# !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
# This file is machine-generated by lib/unicore/mktables from the Unicode
# database, Version 15.0.0.  Any changes made here will be lost!

sub TODO_FAILING_BREAKS { 0 }

use strict;
use warnings;

use feature 'signatures';

no warnings 'experimental::uniprop_wildcards';

# Test qr/\X/ and the \p{} regular expression constructs.  This file is
# constructed by mktables from the tables it generates, so if mktables is
# buggy, this won't necessarily catch those bugs.  Tests are generated for all
# feasible properties; a few aren't currently feasible; see
# is_code_point_usable() in mktables for details.

# Standard test packages are not used because this manipulates SIG_WARN.  It
# exits 0 if every non-skipped test succeeded; -1 if any failed.

my $Tests = 0;
my $Fails = 0;

# loc_tools.pl requires this function to be defined
sub ok($pass, @msg) {
    print "not " unless $pass;
    print "ok ";
    print ++$Tests;
    print " - ", join "", @msg if @msg;
    print "\n";
}

sub Expect($expected, $ord, $regex, $warning_type='') {
    my $line   = (caller)[2];

    # Convert the code point to hex form
    my $string = sprintf "\"\\x{%04X}\"", $ord;

    my @tests = "";

    # The first time through, use all warnings.  If the input should generate
    # a warning, add another time through with them turned off
    push @tests, "no warnings '$warning_type';" if $warning_type;

    foreach my $no_warnings (@tests) {

        # Store any warning messages instead of outputting them
        local $SIG{__WARN__} = $SIG{__WARN__};
        my $warning_message;
        $SIG{__WARN__} = sub { $warning_message = $_[0] };

        $Tests++;

        # A string eval is needed because of the 'no warnings'.
        # Assumes no parentheses in the regular expression
        my $result = eval "$no_warnings
                            my \$RegObj = qr($regex);
                            $string =~ \$RegObj ? 1 : 0";
        if (not defined $result) {
            print "not ok $Tests - couldn't compile /$regex/; line $line: $@\n";
            $Fails++;
        }
        elsif ($result ^ $expected) {
            print "not ok $Tests - expected $expected but got $result for $string =~ qr/$regex/; line $line\n";
            $Fails++;
        }
        elsif ($warning_message) {
            if (! $warning_type || ($warning_type && $no_warnings)) {
                print "not ok $Tests - for qr/$regex/ did not expect warning message '$warning_message'; line $line\n";
                $Fails++;
            }
            else {
                print "ok $Tests - expected and got a warning message for qr/$regex/; line $line\n";
            }
        }
        elsif ($warning_type && ! $no_warnings) {
            print "not ok $Tests - for qr/$regex/ expected a $warning_type warning message, but got none; line $line\n";
            $Fails++;
        }
        else {
            print "ok $Tests - got $result for $string =~ qr/$regex/; line $line\n";
        }
    }
    return;
}

sub Error($regex) {
    $Tests++;
    if (eval { 'x' =~ qr/$regex/; 1 }) {
        $Fails++;
        my $line = (caller)[2];
        print "not ok $Tests - re compiled ok, but expected error for qr/$regex/; line $line: $@\n";
    }
    else {
        my $line = (caller)[2];
        print "ok $Tests - got and expected error for qr/$regex/; line $line\n";
    }
    return;
}

# Break test files (e.g. GCBTest.txt) character that break allowed here
my $breakable_utf8 = my $breakable = chr(utf8::unicode_to_native(0xF7));
utf8::upgrade($breakable_utf8);

# Break test files (e.g. GCBTest.txt) character that indicates can't break
# here
my $nobreak_utf8 = my $nobreak = chr(utf8::unicode_to_native(0xD7));
utf8::upgrade($nobreak_utf8);

my $are_ctype_locales_available;
my $utf8_locale;
chdir 't' if -d 't';
eval { require "./loc_tools.pl" };
if (defined &locales_enabled) {
    $are_ctype_locales_available = locales_enabled('LC_CTYPE');
    if ($are_ctype_locales_available) {
        $utf8_locale = &find_utf8_ctype_locale;
    }
}

# Eval'd so can run on versions earlier than the property is available in
my $WB_Extend_or_Format_re = eval 'qr/[\p{WB=Extend}\p{WB=Format}\p{WB=ZWJ}]/';
if (! defined $WB_Extend_or_Format_re) {
    $WB_Extend_or_Format_re = eval 'qr/[\p{WB=Extend}\p{WB=Format}]/';
}

sub _test_break($template, $break_type) {
    # Test various break property matches.  The 2nd parameter gives the
    # property name.  The input is a line from auxiliary/*Test.txt for the
    # given property.  Each such line is a sequence of Unicode (not native)
    # code points given by their hex numbers, separated by the two characters
    # defined just before this subroutine that indicate that either there can
    # or cannot be a break between the adjacent code points.  All these are
    # tested.
    #
    # For the gcb property extra tests are made.  if there isn't a break, that
    # means the sequence forms an extended grapheme cluster, which means that
    # \X should match the whole thing.  If there is a break, \X should stop
    # there.  This is all converted by this routine into a match: $string =~
    # /(\X)/, Each \X should match the next cluster; and that is what is
    # checked.

    my $line   = (caller 1)[2];   # Line number
    my $comment = "";

    if ($template =~ / ( .*? ) \s* \# (.*) /x) {
        $template = $1;
        $comment = $2;

        # Replace leading spaces with a single one.
        $comment =~ s/ ^ \s* / # /x;
    }

    # The line contains characters above the ASCII range, but in Latin1.  It
    # may or may not be in utf8, and if it is, it may or may not know it.  So,
    # convert these characters to 8 bits.  If knows is in utf8, simply
    # downgrade.
    if (utf8::is_utf8($template)) {
        utf8::downgrade($template);
    } else {

        # Otherwise, if it is in utf8, but doesn't know it, the next lines
        # convert the two problematic characters to their 8-bit equivalents.
        # If it isn't in utf8, they don't harm anything.
        use bytes;
        $template =~ s/$nobreak_utf8/$nobreak/g;
        $template =~ s/$breakable_utf8/$breakable/g;
    }

    # Perl customizes wb.  So change the official tests accordingly
    if ($break_type eq 'wb' && $WB_Extend_or_Format_re) {

        # Split into elements that alternate between code point and
        # break/no-break
        my @line = split / +/, $template;

        # Look at each code point and its following one
        for (my $i = 1; $i <  @line - 1 - 1; $i+=2) {

            # The customization only involves changing some breaks to
            # non-breaks.
            next if $line[$i+1] =~ /$nobreak/;

            my $lhs = chr utf8::unicode_to_native(hex $line[$i]);
            my $rhs = chr utf8::unicode_to_native(hex $line[$i+2]);

            # And it only affects adjacent space characters.
            next if $lhs !~ /\s/u;

            # But, we want to make sure to test spaces followed by a Extend
            # or Format.
            next if $rhs !~ /\s|$WB_Extend_or_Format_re/;

            # To test the customization, add some white-space before this to
            # create a span.  The $lhs white space may or may not be bound to
            # that span, and also with the $rhs.  If the $rhs is a binding
            # character, the $lhs is bound to it and not to the span, unless
            # $lhs is vertical space.  In all other cases, the $lhs is bound
            # to the span.  If the $rhs is white space, it is bound to the
            # $lhs
            my $bound;
            my $span;
            if ($rhs =~ /$WB_Extend_or_Format_re/) {
                if ($lhs =~ /\v/) {
                    $bound = $breakable;
                    $span = $nobreak;
                }
                else {
                    $bound = $nobreak;
                    $span = $breakable;
                }
            }
            else {
                $span = $nobreak;
                $bound = $nobreak;
            }

            splice @line, $i, 0, ( '0020', $nobreak, '0020', $span);
            $i += 4;
            $line[$i+1] = $bound;
        }
        $template = join " ", @line;
    }

    # The input is just the break/no-break symbols and sequences of Unicode
    # code points as hex digits separated by spaces for legibility. e.g.:
    # ÷ 0020 × 0308 ÷ 0020 ÷
    # Convert to native \x format
    $template =~ s/ \s* ( [[:xdigit:]]+ ) \s* /sprintf("\\x{%02X}", utf8::unicode_to_native(hex $1))/gex;
    $template =~ s/ \s* //gx;   # Probably the line above removed all spaces;
                                # but be sure

    # Make a copy of the input with the symbols replaced by \b{} and \B{} as
    # appropriate
    my $break_pattern = $template =~ s/ $breakable /\\b{$break_type}/grx;
    $break_pattern =~ s/ $nobreak /\\B{$break_type}/gx;

    my $display_string = $template =~ s/[$breakable$nobreak]//gr;
    my $string = eval "\"$display_string\"";

    # The remaining massaging of the input is for the \X tests.  Get rid of
    # the leading and trailing breakables
    $template =~ s/^ \s* $breakable \s* //x;
    $template =~ s/ \s* $breakable \s* $ //x;

    # Delete no-breaks
    $template =~ s/ \s* $nobreak \s* //xg;

    # Split the input into segments that are breakable between them.
    my @should_display = split /\s*$breakable\s*/, $template;
    my @should_match = map { eval "\"$_\"" } @should_display;

    # If a string can be represented in both non-ut8 and utf8, test both cases
    my $display_upgrade = "";
    UPGRADE:
    for my $to_upgrade (0 .. 1) {

        if ($to_upgrade) {

            # If already in utf8, would just be a repeat
            next UPGRADE if utf8::is_utf8($string);

            utf8::upgrade($string);
            $display_upgrade = " (utf8-upgraded)";
        }

        my @modifiers = qw(a aa d u i);
        if ($are_ctype_locales_available) {
            push @modifiers, "l$utf8_locale" if defined $utf8_locale;

            # The /l modifier has C after it to indicate the locale to try
            push @modifiers, "lC";
        }

        # Test for each of the regex modifiers.
        for my $modifier (@modifiers) {
            my $display_locale = "";

            # For /l, set the locale to what it says to.
            if ($modifier =~ / ^ l (.*) /x) {
                my $locale = $1;
                $display_locale = "(locale = $locale)";
                POSIX::setlocale(POSIX::LC_CTYPE(), $locale);
                $modifier = 'l';
            }

            no warnings qw(locale regexp surrogate);
            my $pattern = "(?$modifier:$break_pattern)";

            # Actually do the test
            my $matched_text;
            my $matched = $string =~ qr/$pattern/;
            if ($matched) {
                $matched_text = "matched";
            }
            else {
                $matched_text = "failed to match";
                print "not ";

                if (TODO_FAILING_BREAKS) {
                    $comment = " # $comment" unless $comment =~ / ^ \s* \# /x;
                    $comment =~ s/#/# TODO/;
                }
            }
            print "ok ", ++$Tests, " - \"$display_string\" $matched_text /$pattern/$display_upgrade; line $line $display_locale$comment\n";

            # Only print the comment on the first use of this line
            $comment = "";

            # Repeat with the first \B{} in the pattern.  This makes sure the
            # code in regexec.c:find_byclass() for \B gets executed
            if ($pattern =~ / ( .*? : ) .* ( \\B\{ .* ) /x) {
                my $B_pattern = "$1$2";
                $matched = $string =~ qr/$B_pattern/;
                print "not " unless $matched;
                $matched_text = ($matched) ? "matched" : "failed to match";
                print "ok ", ++$Tests, " - \"$display_string\" $matched_text /$B_pattern/$display_upgrade; line $line $display_locale";
                print " # TODO" if TODO_FAILING_BREAKS && ! $matched;
                print "\n";
            }
        }

        next if $break_type ne 'gcb';

        # Finally, do the \X match.
        my @matches = $string =~ /(\X)/g;

        # Look through each matched cluster to verify that it matches what we
        # expect.
        my $min = (@matches < @should_match) ? @matches : @should_match;
        for my $i (0 .. $min - 1) {
            $Tests++;
            if ($matches[$i] eq $should_match[$i]) {
                print "ok $Tests - ";
                if ($i == 0) {
                    print "In \"$display_string\" =~ /(\\X)/g, \\X #1";
                } else {
                    print "And \\X #", $i + 1,
                }
                print " correctly matched $should_display[$i]; line $line\n";
            } else {
                $matches[$i] = join("", map { sprintf "\\x{%04X}", ord $_ }
                                                    split "", $matches[$i]);
                print "not ok $Tests -";
                print " # TODO" if TODO_FAILING_BREAKS;
                print " In \"$display_string\" =~ /(\\X)/g, \\X #",
                    $i + 1,
                    " should have matched $should_display[$i]",
                    " but instead matched $matches[$i]",
                    ".  Abandoning rest of line $line\n";
                next UPGRADE;
            }
        }

        # And the number of matches should equal the number of expected matches.
        $Tests++;
        if (@matches == @should_match) {
            print "ok $Tests - Nothing was left over; line $line\n";
        } else {
            print "not ok $Tests - There were ", scalar @should_match, " \\X matches expected, but got ", scalar @matches, " instead; line $line";
            print " # TODO" if TODO_FAILING_BREAKS;
            print "\n";
        }
    }

    return;
}

sub Test_GCB($t) {
    _test_break($t, 'gcb');
}

sub Test_LB($t) {
    _test_break($t, 'lb');
}

sub Test_SB($t) {
    _test_break($t, 'sb');
}

sub Test_WB($t) {
    _test_break($t, 'wb');
}

sub Finished() {
    print "1..$Tests\n";
    exit($Fails ? -1 : 0);
}

if (!$::TESTCHUNK or $::TESTCHUNK == 1) {
    Error('\p{Script=InGreek}');    # Bug #69018
    Test_GCB("1100 $nobreak 1161");  # Bug #70940
    Expect(0, 0x2028, '\p{Print}', ""); # Bug # 71722
    Expect(0, 0x2029, '\p{Print}', ""); # Bug # 71722
    Expect(1, 0xFF10, '\p{XDigit}', ""); # Bug # 71726
    Error('\p{InKana}');    # 'Kana' is not a block so InKana shouldn't compile
    Expect(1, 0xB6, '\p{In=V1_1}', ""); # Didn't use to work
    Expect(1, 0x3A2,'\p{In=NA}', "");   # Didn't use to work
    
    # Make sure this gets tested; it was not part of the official test suite at
    # the time this was added.  Note that this is as it would appear in the
    # official suite, and gets modified to check for the perl tailoring by
    # Test_WB()
    Test_WB("$breakable 0020 $breakable 0020 $breakable 0308 $breakable");
    Test_LB("$nobreak 200B $nobreak 0020 $nobreak 0020 $breakable 2060 $breakable");
    Expect(1, ord(" "), '\p{gc=:(?aa)s:}', "");     # /aa is valid
    Expect(1, ord(" "), '\p{gc=:(?-s)s:}', "");     # /-s is valid
    ;
    Error('\p{_perllb}');
    Error('\P{_perllb}');
    Error('\p{_perlscx}');
    Error('\P{_perlscx}');
    Error('\p{age}');
    Error('\P{age}');
    Error('\p{Age=_V1_1/a/}');
    Error('\P{Age=_V1_1/a/}');
    Expect(1, 65533, '\p{Age=:\AV1_1\z:}', "");;
    Expect(0, 65536, '\p{Age=:\AV1_1\z:}', "");;
    Expect(1, 65533, '\p{Age=v11}', "");
    Expect(0, 65533, '\p{^Age=v11}', "");
    Expect(0, 65533, '\P{Age=v11}', "");
    Expect(1, 65533, '\P{^Age=v11}', "");
    Expect(0, 65536, '\p{Age=v11}', "");
    Expect(1, 65536, '\p{^Age=v11}', "");
    Expect(1, 65536, '\P{Age=v11}', "");
    Expect(0, 65536, '\P{^Age=v11}', "");
    Expect(1, 65533, '\p{Age=:\Av11\z:}', "");;
    Expect(0, 65536, '\p{Age=:\Av11\z:}', "");;
    Expect(1, 65533, '\p{Age=	v1_1}', "");
    Expect(0, 65533, '\p{^Age=	v1_1}', "");
    Expect(0, 65533, '\P{Age=	v1_1}', "");
    Expect(1, 65533, '\P{^Age=	v1_1}', "");
    Expect(0, 65536, '\p{Age=	v1_1}', "");
    Expect(1, 65536, '\p{^Age=	v1_1}', "");
    Expect(1, 65536, '\P{Age=	v1_1}', "");
    Expect(0, 65536, '\P{^Age=	v1_1}', "");
    Error('\p{Is_Age=:=	 000000001.1}');
    Error('\P{Is_Age=:=	 000000001.1}');
    Expect(1, 65533, '\p{Is_Age=+0_1.1}', "");
    Expect(0, 65533, '\p{^Is_Age=+0_1.1}', "");
    Expect(0, 65533, '\P{Is_Age=+0_1.1}', "");
    Expect(1, 65533, '\P{^Is_Age=+0_1.1}', "");
    Expect(0, 65536, '\p{Is_Age=+0_1.1}', "");
    Expect(1, 65536, '\p{^Is_Age=+0_1.1}', "");
    Expect(1, 65536, '\P{Is_Age=+0_1.1}', "");
    Expect(0, 65536, '\P{^Is_Age=+0_1.1}', "");
    Error('\p{Age=		v10_0:=}');
    Error('\P{Age=		v10_0:=}');
    Expect(1, 191456, '\p{Age=:\AV10_0\z:}', "");;
    Expect(0, 191457, '\p{Age=:\AV10_0\z:}', "");;
    Expect(1, 191456, '\p{Age=v100}', "");
    Expect(0, 191456, '\p{^Age=v100}', "");
    Expect(0, 191456, '\P{Age=v100}', "");
    Expect(1, 191456, '\P{^Age=v100}', "");
    Expect(0, 191457, '\p{Age=v100}', "");
    Expect(1, 191457, '\p{^Age=v100}', "");
    Expect(1, 191457, '\P{Age=v100}', "");
    Expect(0, 191457, '\P{^Age=v100}', "");
    Expect(1, 191456, '\p{Age=:\Av100\z:}', "");;
    Expect(0, 191457, '\p{Age=:\Av100\z:}', "");;
    Expect(1, 191456, '\p{Age=	-V10_0}', "");
    Expect(0, 191456, '\p{^Age=	-V10_0}', "");
    Expect(0, 191456, '\P{Age=	-V10_0}', "");
    Expect(1, 191456, '\P{^Age=	-V10_0}', "");
    Expect(0, 191457, '\p{Age=	-V10_0}', "");
    Expect(1, 191457, '\p{^Age=	-V10_0}', "");
    Expect(1, 191457, '\P{Age=	-V10_0}', "");
    Expect(0, 191457, '\P{^Age=	-V10_0}', "");
    Error('\p{Is_Age:   __0_0_0_0_0_0_0010.0/a/}');
    Error('\P{Is_Age:   __0_0_0_0_0_0_0010.0/a/}');
    Expect(1, 191456, '\p{Is_Age=0000010.0}', "");
    Expect(0, 191456, '\p{^Is_Age=0000010.0}', "");
    Expect(0, 191456, '\P{Is_Age=0000010.0}', "");
    Expect(1, 191456, '\P{^Is_Age=0000010.0}', "");
    Expect(0, 191457, '\p{Is_Age=0000010.0}', "");
    Expect(1, 191457, '\p{^Is_Age=0000010.0}', "");
    Expect(1, 191457, '\P{Is_Age=0000010.0}', "");
    Expect(0, 191457, '\P{^Is_Age=0000010.0}', "");
    Error('\p{Age=/a/V11_0}');
    Error('\P{Age=/a/V11_0}');
    Expect(1, 129645, '\p{Age=:\AV11_0\z:}', "");;
    Expect(0, 129646, '\p{Age=:\AV11_0\z:}', "");;
    Expect(1, 129645, '\p{Age=v110}', "");
    Expect(0, 129645, '\p{^Age=v110}', "");
    Expect(0, 129645, '\P{Age=v110}', "");
    Expect(1, 129645, '\P{^Age=v110}', "");
    Expect(0, 129646, '\p{Age=v110}', "");
    Expect(1, 129646, '\p{^Age=v110}', "");
    Expect(1, 129646, '\P{Age=v110}', "");
    Expect(0, 129646, '\P{^Age=v110}', "");
    Expect(1, 129645, '\p{Age=:\Av110\z:}', "");;
    Expect(0, 129646, '\p{Age=:\Av110\z:}', "");;
    Expect(1, 129645, '\p{Age= _V11_0}', "");
    Expect(0, 129645, '\p{^Age= _V11_0}', "");
    Expect(0, 129645, '\P{Age= _V11_0}', "");
    Expect(1, 129645, '\P{^Age= _V11_0}', "");
    Expect(0, 129646, '\p{Age= _V11_0}', "");
    Expect(1, 129646, '\p{^Age= _V11_0}', "");
    Expect(1, 129646, '\P{Age= _V11_0}', "");
    Expect(0, 129646, '\P{^Age= _V11_0}', "");
    Error('\p{Is_Age=_ +0000011.0:=}');
    Error('\P{Is_Age=_ +0000011.0:=}');
    Expect(1, 129645, '\p{Is_Age=1_1.0}', "");
    Expect(0, 129645, '\p{^Is_Age=1_1.0}', "");
    Expect(0, 129645, '\P{Is_Age=1_1.0}', "");
    Expect(1, 129645, '\P{^Is_Age=1_1.0}', "");
    Expect(0, 129646, '\p{Is_Age=1_1.0}', "");
    Expect(1, 129646, '\p{^Is_Age=1_1.0}', "");
    Expect(1, 129646, '\P{Is_Age=1_1.0}', "");
    Expect(0, 129646, '\P{^Is_Age=1_1.0}', "");
    Error('\p{Age= V12_0:=}');
    Error('\P{Age= V12_0:=}');
    Expect(1, 129685, '\p{Age=:\AV12_0\z:}', "");;
    Expect(0, 129686, '\p{Age=:\AV12_0\z:}', "");;
    Expect(1, 129685, '\p{Age=v120}', "");
    Expect(0, 129685, '\p{^Age=v120}', "");
    Expect(0, 129685, '\P{Age=v120}', "");
    Expect(1, 129685, '\P{^Age=v120}', "");
    Expect(0, 129686, '\p{Age=v120}', "");
    Expect(1, 129686, '\p{^Age=v120}', "");
    Expect(1, 129686, '\P{Age=v120}', "");
    Expect(0, 129686, '\P{^Age=v120}', "");
    Expect(1, 129685, '\p{Age=:\Av120\z:}', "");;
    Expect(0, 129686, '\p{Age=:\Av120\z:}', "");;
    Expect(1, 129685, '\p{Age= _V12_0}', "");
    Expect(0, 129685, '\p{^Age= _V12_0}', "");
    Expect(0, 129685, '\P{Age= _V12_0}', "");
    Expect(1, 129685, '\P{^Age= _V12_0}', "");
    Expect(0, 129686, '\p{Age= _V12_0}', "");
    Expect(1, 129686, '\p{^Age= _V12_0}', "");
    Expect(1, 129686, '\P{Age= _V12_0}', "");
    Expect(0, 129686, '\P{^Age= _V12_0}', "");
    Error('\p{Is_Age=/a/		0000000012.0}');
    Error('\P{Is_Age=/a/		0000000012.0}');
    Expect(1, 129685, '\p{Is_Age=00_00_01_2.0}', "");
    Expect(0, 129685, '\p{^Is_Age=00_00_01_2.0}', "");
    Expect(0, 129685, '\P{Is_Age=00_00_01_2.0}', "");
    Expect(1, 129685, '\P{^Is_Age=00_00_01_2.0}', "");
    Expect(0, 129686, '\p{Is_Age=00_00_01_2.0}', "");
    Expect(1, 129686, '\p{^Is_Age=00_00_01_2.0}', "");
    Expect(1, 129686, '\P{Is_Age=00_00_01_2.0}', "");
    Expect(0, 129686, '\P{^Is_Age=00_00_01_2.0}', "");
    Error('\p{Age=_V12_1/a/}');
    Error('\P{Age=_V12_1/a/}');
    Expect(1, 13055, '\p{Age=:\AV12_1\z:}', "");;
    Expect(0, 13056, '\p{Age=:\AV12_1\z:}', "");;
    Expect(1, 13055, '\p{Age=v121}', "");
    Expect(0, 13055, '\p{^Age=v121}', "");
    Expect(0, 13055, '\P{Age=v121}', "");
    Expect(1, 13055, '\P{^Age=v121}', "");
    Expect(0, 13056, '\p{Age=v121}', "");
    Expect(1, 13056, '\p{^Age=v121}', "");
    Expect(1, 13056, '\P{Age=v121}', "");
    Expect(0, 13056, '\P{^Age=v121}', "");
    Expect(1, 13055, '\p{Age=:\Av121\z:}', "");;
    Expect(0, 13056, '\p{Age=:\Av121\z:}', "");;
    Expect(1, 13055, '\p{Age= 	V12_1}', "");
    Expect(0, 13055, '\p{^Age= 	V12_1}', "");
    Expect(0, 13055, '\P{Age= 	V12_1}', "");
    Expect(1, 13055, '\P{^Age= 	V12_1}', "");
    Expect(0, 13056, '\p{Age= 	V12_1}', "");
    Expect(1, 13056, '\p{^Age= 	V12_1}', "");
    Expect(1, 13056, '\P{Age= 	V12_1}', "");
    Expect(0, 13056, '\P{^Age= 	V12_1}', "");
    Error('\p{Is_Age=:=-+012.1}');
    Error('\P{Is_Age=:=-+012.1}');
    Expect(1, 13055, '\p{Is_Age=000000012.1}', "");
    Expect(0, 13055, '\p{^Is_Age=000000012.1}', "");
    Expect(0, 13055, '\P{Is_Age=000000012.1}', "");
    Expect(1, 13055, '\P{^Is_Age=000000012.1}', "");
    Expect(0, 13056, '\p{Is_Age=000000012.1}', "");
    Expect(1, 13056, '\p{^Is_Age=000000012.1}', "");
    Expect(1, 13056, '\P{Is_Age=000000012.1}', "");
    Expect(0, 13056, '\P{^Is_Age=000000012.1}', "");
    Error('\p{Age=--V13_0/a/}');
    Error('\P{Age=--V13_0/a/}');
    Expect(1, 201546, '\p{Age=:\AV13_0\z:}', "");;
    Expect(0, 201547, '\p{Age=:\AV13_0\z:}', "");;
    Expect(1, 201546, '\p{Age=v130}', "");
    Expect(0, 201546, '\p{^Age=v130}', "");
    Expect(0, 201546, '\P{Age=v130}', "");
    Expect(1, 201546, '\P{^Age=v130}', "");
    Expect(0, 201547, '\p{Age=v130}', "");
    Expect(1, 201547, '\p{^Age=v130}', "");
    Expect(1, 201547, '\P{Age=v130}', "");
    Expect(0, 201547, '\P{^Age=v130}', "");
    Expect(1, 201546, '\p{Age=:\Av130\z:}', "");;
    Expect(0, 201547, '\p{Age=:\Av130\z:}', "");;
    Expect(1, 201546, '\p{Age= V13_0}', "");
    Expect(0, 201546, '\p{^Age= V13_0}', "");
    Expect(0, 201546, '\P{Age= V13_0}', "");
    Expect(1, 201546, '\P{^Age= V13_0}', "");
    Expect(0, 201547, '\p{Age= V13_0}', "");
    Expect(1, 201547, '\p{^Age= V13_0}', "");
    Expect(1, 201547, '\P{Age= V13_0}', "");
    Expect(0, 201547, '\P{^Age= V13_0}', "");
    Error('\p{Is_Age=	01_3.0/a/}');
    Error('\P{Is_Age=	01_3.0/a/}');
    Expect(1, 201546, '\p{Is_Age=+00000013.0}', "");
    Expect(0, 201546, '\p{^Is_Age=+00000013.0}', "");
    Expect(0, 201546, '\P{Is_Age=+00000013.0}', "");
    Expect(1, 201546, '\P{^Is_Age=+00000013.0}', "");
    Expect(0, 201547, '\p{Is_Age=+00000013.0}', "");
    Expect(1, 201547, '\p{^Is_Age=+00000013.0}', "");
    Expect(1, 201547, '\P{Is_Age=+00000013.0}', "");
    Expect(0, 201547, '\P{^Is_Age=+00000013.0}', "");
    Error('\p{Age=	V14_0/a/}');
    Error('\P{Age=	V14_0/a/}');
    Expect(1, 177976, '\p{Age=:\AV14_0\z:}', "");;
    Expect(0, 177977, '\p{Age=:\AV14_0\z:}', "");;
    Expect(1, 177976, '\p{Age=v140}', "");
    Expect(0, 177976, '\p{^Age=v140}', "");
    Expect(0, 177976, '\P{Age=v140}', "");
    Expect(1, 177976, '\P{^Age=v140}', "");
    Expect(0, 177977, '\p{Age=v140}', "");
    Expect(1, 177977, '\p{^Age=v140}', "");
    Expect(1, 177977, '\P{Age=v140}', "");
    Expect(0, 177977, '\P{^Age=v140}', "");
    Expect(1, 177976, '\p{Age=:\Av140\z:}', "");;
    Expect(0, 177977, '\p{Age=:\Av140\z:}', "");;
    Expect(1, 177976, '\p{Age=  V14_0}', "");
    Expect(0, 177976, '\p{^Age=  V14_0}', "");
    Expect(0, 177976, '\P{Age=  V14_0}', "");
    Expect(1, 177976, '\P{^Age=  V14_0}', "");
    Expect(0, 177977, '\p{Age=  V14_0}', "");
    Expect(1, 177977, '\p{^Age=  V14_0}', "");
    Expect(1, 177977, '\P{Age=  V14_0}', "");
    Expect(0, 177977, '\P{^Age=  V14_0}', "");
    Error('\p{Is_Age=:=	-+00000014.0}');
    Error('\P{Is_Age=:=	-+00000014.0}');
    Expect(1, 177976, '\p{Is_Age=0_0_0_0_0014.0}', "");
    Expect(0, 177976, '\p{^Is_Age=0_0_0_0_0014.0}', "");
    Expect(0, 177976, '\P{Is_Age=0_0_0_0_0014.0}', "");
    Expect(1, 177976, '\P{^Is_Age=0_0_0_0_0014.0}', "");
    Expect(0, 177977, '\p{Is_Age=0_0_0_0_0014.0}', "");
    Expect(1, 177977, '\p{^Is_Age=0_0_0_0_0014.0}', "");
    Expect(1, 177977, '\P{Is_Age=0_0_0_0_0014.0}', "");
    Expect(0, 177977, '\P{^Is_Age=0_0_0_0_0014.0}', "");
    Error('\p{Age= :=V15_0}');
    Error('\P{Age= :=V15_0}');
    Expect(1, 205743, '\p{Age=:\AV15_0\z:}', "");;
    Expect(0, 205744, '\p{Age=:\AV15_0\z:}', "");;
    Expect(1, 205743, '\p{Age=v150}', "");
    Expect(0, 205743, '\p{^Age=v150}', "");
    Expect(0, 205743, '\P{Age=v150}', "");
    Expect(1, 205743, '\P{^Age=v150}', "");
    Expect(0, 205744, '\p{Age=v150}', "");
    Expect(1, 205744, '\p{^Age=v150}', "");
    Expect(1, 205744, '\P{Age=v150}', "");
    Expect(0, 205744, '\P{^Age=v150}', "");
    Expect(1, 205743, '\p{Age=:\Av150\z:}', "");;
    Expect(0, 205744, '\p{Age=:\Av150\z:}', "");;
    Expect(1, 205743, '\p{Age=V15_0}', "");
    Expect(0, 205743, '\p{^Age=V15_0}', "");
    Expect(0, 205743, '\P{Age=V15_0}', "");
    Expect(1, 205743, '\P{^Age=V15_0}', "");
    Expect(0, 205744, '\p{Age=V15_0}', "");
    Expect(1, 205744, '\p{^Age=V15_0}', "");
    Expect(1, 205744, '\P{Age=V15_0}', "");
    Expect(0, 205744, '\P{^Age=V15_0}', "");
    Error('\p{Is_Age=/a/ -+00000015.0}');
    Error('\P{Is_Age=/a/ -+00000015.0}');
    Expect(1, 205743, '\p{Is_Age=1_5.0}', "");
    Expect(0, 205743, '\p{^Is_Age=1_5.0}', "");
    Expect(0, 205743, '\P{Is_Age=1_5.0}', "");
    Expect(1, 205743, '\P{^Is_Age=1_5.0}', "");
    Expect(0, 205744, '\p{Is_Age=1_5.0}', "");
    Expect(1, 205744, '\p{^Is_Age=1_5.0}', "");
    Expect(1, 205744, '\P{Is_Age=1_5.0}', "");
    Expect(0, 205744, '\P{^Is_Age=1_5.0}', "");
    Error('\p{Age=-	v2_0:=}');
    Error('\P{Age=-	v2_0:=}');
    Expect(1, 983040, '\p{Age=:\AV2_0\z:}', "");;
    Expect(0, 983037, '\p{Age=:\AV2_0\z:}', "");;
    Expect(1, 983040, '\p{Age=v20}', "");
    Expect(0, 983040, '\p{^Age=v20}', "");
    Expect(0, 983040, '\P{Age=v20}', "");
    Expect(1, 983040, '\P{^Age=v20}', "");
    Expect(0, 983037, '\p{Age=v20}', "");
    Expect(1, 983037, '\p{^Age=v20}', "");
    Expect(1, 983037, '\P{Age=v20}', "");
    Expect(0, 983037, '\P{^Age=v20}', "");
    Expect(1, 983040, '\p{Age=:\Av20\z:}', "");;
    Expect(0, 983037, '\p{Age=:\Av20\z:}', "");;
    Expect(1, 983040, '\p{Age=_	V2_0}', "");
    Expect(0, 983040, '\p{^Age=_	V2_0}', "");
    Expect(0, 983040, '\P{Age=_	V2_0}', "");
    Expect(1, 983040, '\P{^Age=_	V2_0}', "");
    Expect(0, 983037, '\p{Age=_	V2_0}', "");
    Expect(1, 983037, '\p{^Age=_	V2_0}', "");
    Expect(1, 983037, '\P{Age=_	V2_0}', "");
    Expect(0, 983037, '\P{^Age=_	V2_0}', "");
    Error('\p{Is_Age:/a/- +000002.0}');
    Error('\P{Is_Age:/a/- +000002.0}');
    Expect(1, 983040, '\p{Is_Age=+2.0}', "");
    Expect(0, 983040, '\p{^Is_Age=+2.0}', "");
    Expect(0, 983040, '\P{Is_Age=+2.0}', "");
    Expect(1, 983040, '\P{^Is_Age=+2.0}', "");
    Expect(0, 983037, '\p{Is_Age=+2.0}', "");
    Expect(1, 983037, '\p{^Is_Age=+2.0}', "");
    Expect(1, 983037, '\P{Is_Age=+2.0}', "");
    Expect(0, 983037, '\P{^Is_Age=+2.0}', "");
    Error('\p{Age=__V2_1/a/}');
    Error('\P{Age=__V2_1/a/}');
    Expect(1, 65532, '\p{Age=:\AV2_1\z:}', "");;
    Expect(0, 65533, '\p{Age=:\AV2_1\z:}', "");;
    Expect(1, 65532, '\p{Age=v21}', "");
    Expect(0, 65532, '\p{^Age=v21}', "");
    Expect(0, 65532, '\P{Age=v21}', "");
    Expect(1, 65532, '\P{^Age=v21}', "");
    Expect(0, 65533, '\p{Age=v21}', "");
    Expect(1, 65533, '\p{^Age=v21}', "");
    Expect(1, 65533, '\P{Age=v21}', "");
    Expect(0, 65533, '\P{^Age=v21}', "");
    Expect(1, 65532, '\p{Age=:\Av21\z:}', "");;
    Expect(0, 65533, '\p{Age=:\Av21\z:}', "");;
    Expect(1, 65532, '\p{Age=__V2_1}', "");
    Expect(0, 65532, '\p{^Age=__V2_1}', "");
    Expect(0, 65532, '\P{Age=__V2_1}', "");
    Expect(1, 65532, '\P{^Age=__V2_1}', "");
    Expect(0, 65533, '\p{Age=__V2_1}', "");
    Expect(1, 65533, '\p{^Age=__V2_1}', "");
    Expect(1, 65533, '\P{Age=__V2_1}', "");
    Expect(0, 65533, '\P{^Age=__V2_1}', "");
    Error('\p{Is_Age=:=00000002.1}');
    Error('\P{Is_Age=:=00000002.1}');
    Expect(1, 65532, '\p{Is_Age=0_2.1}', "");
    Expect(0, 65532, '\p{^Is_Age=0_2.1}', "");
    Expect(0, 65532, '\P{Is_Age=0_2.1}', "");
    Expect(1, 65532, '\P{^Is_Age=0_2.1}', "");
    Expect(0, 65533, '\p{Is_Age=0_2.1}', "");
    Expect(1, 65533, '\p{^Is_Age=0_2.1}', "");
    Expect(1, 65533, '\P{Is_Age=0_2.1}', "");
    Expect(0, 65533, '\P{^Is_Age=0_2.1}', "");
    Error('\p{Age=/a/  V3_0}');
    Error('\P{Age=/a/  V3_0}');
    Expect(1, 65531, '\p{Age=:\AV3_0\z:}', "");;
    Expect(0, 65532, '\p{Age=:\AV3_0\z:}', "");;
    Expect(1, 65531, '\p{Age=v30}', "");
    Expect(0, 65531, '\p{^Age=v30}', "");
    Expect(0, 65531, '\P{Age=v30}', "");
    Expect(1, 65531, '\P{^Age=v30}', "");
    Expect(0, 65532, '\p{Age=v30}', "");
    Expect(1, 65532, '\p{^Age=v30}', "");
    Expect(1, 65532, '\P{Age=v30}', "");
    Expect(0, 65532, '\P{^Age=v30}', "");
    Expect(1, 65531, '\p{Age=:\Av30\z:}', "");;
    Expect(0, 65532, '\p{Age=:\Av30\z:}', "");;
    Expect(1, 65531, '\p{Age=-_V3_0}', "");
    Expect(0, 65531, '\p{^Age=-_V3_0}', "");
    Expect(0, 65531, '\P{Age=-_V3_0}', "");
    Expect(1, 65531, '\P{^Age=-_V3_0}', "");
    Expect(0, 65532, '\p{Age=-_V3_0}', "");
    Expect(1, 65532, '\p{^Age=-_V3_0}', "");
    Expect(1, 65532, '\P{Age=-_V3_0}', "");
    Expect(0, 65532, '\P{^Age=-_V3_0}', "");
    Error('\p{Is_Age:		:=0000000003.0}');
    Error('\P{Is_Age:		:=0000000003.0}');
    Expect(1, 65531, '\p{Is_Age=0_3.0}', "");
    Expect(0, 65531, '\p{^Is_Age=0_3.0}', "");
    Expect(0, 65531, '\P{Is_Age=0_3.0}', "");
    Expect(1, 65531, '\P{^Is_Age=0_3.0}', "");
    Expect(0, 65532, '\p{Is_Age=0_3.0}', "");
    Expect(1, 65532, '\p{^Is_Age=0_3.0}', "");
    Expect(1, 65532, '\P{Is_Age=0_3.0}', "");
    Expect(0, 65532, '\P{^Is_Age=0_3.0}', "");
    Error('\p{Age=-:=V3_1}');
    Error('\P{Age=-:=V3_1}');
    Expect(1, 917631, '\p{Age=:\AV3_1\z:}', "");;
    Expect(0, 917632, '\p{Age=:\AV3_1\z:}', "");;
    Expect(1, 917631, '\p{Age=v31}', "");
    Expect(0, 917631, '\p{^Age=v31}', "");
    Expect(0, 917631, '\P{Age=v31}', "");
    Expect(1, 917631, '\P{^Age=v31}', "");
    Expect(0, 917632, '\p{Age=v31}', "");
    Expect(1, 917632, '\p{^Age=v31}', "");
    Expect(1, 917632, '\P{Age=v31}', "");
    Expect(0, 917632, '\P{^Age=v31}', "");
    Expect(1, 917631, '\p{Age=:\Av31\z:}', "");;
    Expect(0, 917632, '\p{Age=:\Av31\z:}', "");;
    Expect(1, 917631, '\p{Age=		v3_1}', "");
    Expect(0, 917631, '\p{^Age=		v3_1}', "");
    Expect(0, 917631, '\P{Age=		v3_1}', "");
    Expect(1, 917631, '\P{^Age=		v3_1}', "");
    Expect(0, 917632, '\p{Age=		v3_1}', "");
    Expect(1, 917632, '\p{^Age=		v3_1}', "");
    Expect(1, 917632, '\P{Age=		v3_1}', "");
    Expect(0, 917632, '\P{^Age=		v3_1}', "");
    Error('\p{Is_Age=		0_0_0_0_0_03.1/a/}');
    Error('\P{Is_Age=		0_0_0_0_0_03.1/a/}');
    Expect(1, 917631, '\p{Is_Age=0003.1}', "");
    Expect(0, 917631, '\p{^Is_Age=0003.1}', "");
    Expect(0, 917631, '\P{Is_Age=0003.1}', "");
    Expect(1, 917631, '\P{^Is_Age=0003.1}', "");
    Expect(0, 917632, '\p{Is_Age=0003.1}', "");
    Expect(1, 917632, '\p{^Is_Age=0003.1}', "");
    Expect(1, 917632, '\P{Is_Age=0003.1}', "");
    Expect(0, 917632, '\P{^Is_Age=0003.1}', "");
    Error('\p{Age=:=	V3_2}');
    Error('\P{Age=:=	V3_2}');
    Expect(1, 65376, '\p{Age=:\AV3_2\z:}', "");;
    Expect(0, 65377, '\p{Age=:\AV3_2\z:}', "");;
    Expect(1, 65376, '\p{Age:	v32}', "");
    Expect(0, 65376, '\p{^Age:	v32}', "");
    Expect(0, 65376, '\P{Age:	v32}', "");
    Expect(1, 65376, '\P{^Age:	v32}', "");
    Expect(0, 65377, '\p{Age:	v32}', "");
    Expect(1, 65377, '\p{^Age:	v32}', "");
    Expect(1, 65377, '\P{Age:	v32}', "");
    Expect(0, 65377, '\P{^Age:	v32}', "");
    Expect(1, 65376, '\p{Age=:\Av32\z:}', "");;
    Expect(0, 65377, '\p{Age=:\Av32\z:}', "");;
    Expect(1, 65376, '\p{Age= -v3_2}', "");
    Expect(0, 65376, '\p{^Age= -v3_2}', "");
    Expect(0, 65376, '\P{Age= -v3_2}', "");
    Expect(1, 65376, '\P{^Age= -v3_2}', "");
    Expect(0, 65377, '\p{Age= -v3_2}', "");
    Expect(1, 65377, '\p{^Age= -v3_2}', "");
    Expect(1, 65377, '\P{Age= -v3_2}', "");
    Expect(0, 65377, '\P{^Age= -v3_2}', "");
    Error('\p{Is_Age=_0_3.2:=}');
    Error('\P{Is_Age=_0_3.2:=}');
    Expect(1, 65376, '\p{Is_Age=+00003.2}', "");
    Expect(0, 65376, '\p{^Is_Age=+00003.2}', "");
    Expect(0, 65376, '\P{Is_Age=+00003.2}', "");
    Expect(1, 65376, '\P{^Is_Age=+00003.2}', "");
    Expect(0, 65377, '\p{Is_Age=+00003.2}', "");
    Expect(1, 65377, '\p{^Is_Age=+00003.2}', "");
    Expect(1, 65377, '\P{Is_Age=+00003.2}', "");
    Expect(0, 65377, '\P{^Is_Age=+00003.2}', "");
    Error('\p{Age=:=_V4_0}');
    Error('\P{Age=:=_V4_0}');
    Expect(1, 917999, '\p{Age=:\AV4_0\z:}', "");;
    Expect(0, 918000, '\p{Age=:\AV4_0\z:}', "");;
    Expect(1, 917999, '\p{Age:	v40}', "");
    Expect(0, 917999, '\p{^Age:	v40}', "");
    Expect(0, 917999, '\P{Age:	v40}', "");
    Expect(1, 917999, '\P{^Age:	v40}', "");
    Expect(0, 918000, '\p{Age:	v40}', "");
    Expect(1, 918000, '\p{^Age:	v40}', "");
    Expect(1, 918000, '\P{Age:	v40}', "");
    Expect(0, 918000, '\P{^Age:	v40}', "");
    Expect(1, 917999, '\p{Age=:\Av40\z:}', "");;
    Expect(0, 918000, '\p{Age=:\Av40\z:}', "");;
    Expect(1, 917999, '\p{Age=		v4_0}', "");
    Expect(0, 917999, '\p{^Age=		v4_0}', "");
    Expect(0, 917999, '\P{Age=		v4_0}', "");
    Expect(1, 917999, '\P{^Age=		v4_0}', "");
    Expect(0, 918000, '\p{Age=		v4_0}', "");
    Expect(1, 918000, '\p{^Age=		v4_0}', "");
    Expect(1, 918000, '\P{Age=		v4_0}', "");
    Expect(0, 918000, '\P{^Age=		v4_0}', "");
    Error('\p{Is_Age=:=00_4.0}');
    Error('\P{Is_Age=:=00_4.0}');
    Expect(1, 917999, '\p{Is_Age=00_00_4.0}', "");
    Expect(0, 917999, '\p{^Is_Age=00_00_4.0}', "");
    Expect(0, 917999, '\P{Is_Age=00_00_4.0}', "");
    Expect(1, 917999, '\P{^Is_Age=00_00_4.0}', "");
    Expect(0, 918000, '\p{Is_Age=00_00_4.0}', "");
    Expect(1, 918000, '\p{^Is_Age=00_00_4.0}', "");
    Expect(1, 918000, '\P{Is_Age=00_00_4.0}', "");
    Expect(0, 918000, '\P{^Is_Age=00_00_4.0}', "");
    Error('\p{Age:/a/_V4_1}');
    Error('\P{Age:/a/_V4_1}');
    Expect(1, 120485, '\p{Age=:\AV4_1\z:}', "");;
    Expect(0, 120486, '\p{Age=:\AV4_1\z:}', "");;
    Expect(1, 120485, '\p{Age=v41}', "");
    Expect(0, 120485, '\p{^Age=v41}', "");
    Expect(0, 120485, '\P{Age=v41}', "");
    Expect(1, 120485, '\P{^Age=v41}', "");
    Expect(0, 120486, '\p{Age=v41}', "");
    Expect(1, 120486, '\p{^Age=v41}', "");
    Expect(1, 120486, '\P{Age=v41}', "");
    Expect(0, 120486, '\P{^Age=v41}', "");
    Expect(1, 120485, '\p{Age=:\Av41\z:}', "");;
    Expect(0, 120486, '\p{Age=:\Av41\z:}', "");;
    Expect(1, 120485, '\p{Age=	-V4_1}', "");
    Expect(0, 120485, '\p{^Age=	-V4_1}', "");
    Expect(0, 120485, '\P{Age=	-V4_1}', "");
    Expect(1, 120485, '\P{^Age=	-V4_1}', "");
    Expect(0, 120486, '\p{Age=	-V4_1}', "");
    Expect(1, 120486, '\p{^Age=	-V4_1}', "");
    Expect(1, 120486, '\P{Age=	-V4_1}', "");
    Expect(0, 120486, '\P{^Age=	-V4_1}', "");
    Error('\p{Is_Age=/a/-_+0_4.1}');
    Error('\P{Is_Age=/a/-_+0_4.1}');
    Expect(1, 120485, '\p{Is_Age=+00_00_00_004.1}', "");
    Expect(0, 120485, '\p{^Is_Age=+00_00_00_004.1}', "");
    Expect(0, 120485, '\P{Is_Age=+00_00_00_004.1}', "");
    Expect(1, 120485, '\P{^Is_Age=+00_00_00_004.1}', "");
    Expect(0, 120486, '\p{Is_Age=+00_00_00_004.1}', "");
    Expect(1, 120486, '\p{^Is_Age=+00_00_00_004.1}', "");
    Expect(1, 120486, '\P{Is_Age=+00_00_00_004.1}', "");
    Expect(0, 120486, '\P{^Is_Age=+00_00_00_004.1}', "");
    Error('\p{Age=V5_0:=}');
    Error('\P{Age=V5_0:=}');
    Expect(1, 120779, '\p{Age=:\AV5_0\z:}', "");;
    Expect(0, 120780, '\p{Age=:\AV5_0\z:}', "");;
    Expect(1, 120779, '\p{Age=v50}', "");
    Expect(0, 120779, '\p{^Age=v50}', "");
    Expect(0, 120779, '\P{Age=v50}', "");
    Expect(1, 120779, '\P{^Age=v50}', "");
    Expect(0, 120780, '\p{Age=v50}', "");
    Expect(1, 120780, '\p{^Age=v50}', "");
    Expect(1, 120780, '\P{Age=v50}', "");
    Expect(0, 120780, '\P{^Age=v50}', "");
    Expect(1, 120779, '\p{Age=:\Av50\z:}', "");;
    Expect(0, 120780, '\p{Age=:\Av50\z:}', "");;
    Expect(1, 120779, '\p{Age=	V5_0}', "");
    Expect(0, 120779, '\p{^Age=	V5_0}', "");
    Expect(0, 120779, '\P{Age=	V5_0}', "");
    Expect(1, 120779, '\P{^Age=	V5_0}', "");
    Expect(0, 120780, '\p{Age=	V5_0}', "");
    Expect(1, 120780, '\p{^Age=	V5_0}', "");
    Expect(1, 120780, '\P{Age=	V5_0}', "");
    Expect(0, 120780, '\P{^Age=	V5_0}', "");
    Error('\p{Is_Age=/a/		5.0}');
    Error('\P{Is_Age=/a/		5.0}');
    Expect(1, 120779, '\p{Is_Age=0_0_0_05.0}', "");
    Expect(0, 120779, '\p{^Is_Age=0_0_0_05.0}', "");
    Expect(0, 120779, '\P{Is_Age=0_0_0_05.0}', "");
    Expect(1, 120779, '\P{^Is_Age=0_0_0_05.0}', "");
    Expect(0, 120780, '\p{Is_Age=0_0_0_05.0}', "");
    Expect(1, 120780, '\p{^Is_Age=0_0_0_05.0}', "");
    Expect(1, 120780, '\P{Is_Age=0_0_0_05.0}', "");
    Expect(0, 120780, '\P{^Is_Age=0_0_0_05.0}', "");
    Error('\p{Age=	:=V5_1}');
    Error('\P{Age=	:=V5_1}');
    Expect(1, 127123, '\p{Age=:\AV5_1\z:}', "");;
    Expect(0, 127124, '\p{Age=:\AV5_1\z:}', "");;
    Expect(1, 127123, '\p{Age: v51}', "");
    Expect(0, 127123, '\p{^Age: v51}', "");
    Expect(0, 127123, '\P{Age: v51}', "");
    Expect(1, 127123, '\P{^Age: v51}', "");
    Expect(0, 127124, '\p{Age: v51}', "");
    Expect(1, 127124, '\p{^Age: v51}', "");
    Expect(1, 127124, '\P{Age: v51}', "");
    Expect(0, 127124, '\P{^Age: v51}', "");
    Expect(1, 127123, '\p{Age=:\Av51\z:}', "");;
    Expect(0, 127124, '\p{Age=:\Av51\z:}', "");;
    Expect(1, 127123, '\p{Age= _V5_1}', "");
    Expect(0, 127123, '\p{^Age= _V5_1}', "");
    Expect(0, 127123, '\P{Age= _V5_1}', "");
    Expect(1, 127123, '\P{^Age= _V5_1}', "");
    Expect(0, 127124, '\p{Age= _V5_1}', "");
    Expect(1, 127124, '\p{^Age= _V5_1}', "");
    Expect(1, 127124, '\P{Age= _V5_1}', "");
    Expect(0, 127124, '\P{^Age= _V5_1}', "");
    Error('\p{Is_Age=_+000005.1:=}');
    Error('\P{Is_Age=_+000005.1:=}');
    Expect(1, 127123, '\p{Is_Age=+0000000005.1}', "");
    Expect(0, 127123, '\p{^Is_Age=+0000000005.1}', "");
    Expect(0, 127123, '\P{Is_Age=+0000000005.1}', "");
    Expect(1, 127123, '\P{^Is_Age=+0000000005.1}', "");
    Expect(0, 127124, '\p{Is_Age=+0000000005.1}', "");
    Expect(1, 127124, '\p{^Is_Age=+0000000005.1}', "");
    Expect(1, 127124, '\P{Is_Age=+0000000005.1}', "");
    Expect(0, 127124, '\P{^Is_Age=+0000000005.1}', "");
    Error('\p{Age:		/a/V5_2}');
    Error('\P{Age:		/a/V5_2}');
    Expect(1, 177972, '\p{Age=:\AV5_2\z:}', "");;
    Expect(0, 177973, '\p{Age=:\AV5_2\z:}', "");;
    Expect(1, 177972, '\p{Age=v52}', "");
    Expect(0, 177972, '\p{^Age=v52}', "");
    Expect(0, 177972, '\P{Age=v52}', "");
    Expect(1, 177972, '\P{^Age=v52}', "");
    Expect(0, 177973, '\p{Age=v52}', "");
    Expect(1, 177973, '\p{^Age=v52}', "");
    Expect(1, 177973, '\P{Age=v52}', "");
    Expect(0, 177973, '\P{^Age=v52}', "");
    Expect(1, 177972, '\p{Age=:\Av52\z:}', "");;
    Expect(0, 177973, '\p{Age=:\Av52\z:}', "");;
    Expect(1, 177972, '\p{Age=_ v5_2}', "");
    Expect(0, 177972, '\p{^Age=_ v5_2}', "");
    Expect(0, 177972, '\P{Age=_ v5_2}', "");
    Expect(1, 177972, '\P{^Age=_ v5_2}', "");
    Expect(0, 177973, '\p{Age=_ v5_2}', "");
    Expect(1, 177973, '\p{^Age=_ v5_2}', "");
    Expect(1, 177973, '\P{Age=_ v5_2}', "");
    Expect(0, 177973, '\P{^Age=_ v5_2}', "");
    Error('\p{Is_Age=- +00_5.2:=}');
    Error('\P{Is_Age=- +00_5.2:=}');
    Expect(1, 177972, '\p{Is_Age:	0_5.2}', "");
    Expect(0, 177972, '\p{^Is_Age:	0_5.2}', "");
    Expect(0, 177972, '\P{Is_Age:	0_5.2}', "");
    Expect(1, 177972, '\P{^Is_Age:	0_5.2}', "");
    Expect(0, 177973, '\p{Is_Age:	0_5.2}', "");
    Expect(1, 177973, '\p{^Is_Age:	0_5.2}', "");
    Expect(1, 177973, '\P{Is_Age:	0_5.2}', "");
    Expect(0, 177973, '\P{^Is_Age:	0_5.2}', "");
    Error('\p{Age=/a/V6_0}');
    Error('\P{Age=/a/V6_0}');
    Expect(1, 178205, '\p{Age=:\AV6_0\z:}', "");;
    Expect(0, 178206, '\p{Age=:\AV6_0\z:}', "");;
    Expect(1, 178205, '\p{Age=v60}', "");
    Expect(0, 178205, '\p{^Age=v60}', "");
    Expect(0, 178205, '\P{Age=v60}', "");
    Expect(1, 178205, '\P{^Age=v60}', "");
    Expect(0, 178206, '\p{Age=v60}', "");
    Expect(1, 178206, '\p{^Age=v60}', "");
    Expect(1, 178206, '\P{Age=v60}', "");
    Expect(0, 178206, '\P{^Age=v60}', "");
    Expect(1, 178205, '\p{Age=:\Av60\z:}', "");;
    Expect(0, 178206, '\p{Age=:\Av60\z:}', "");;
    Expect(1, 178205, '\p{Age=_V6_0}', "");
    Expect(0, 178205, '\p{^Age=_V6_0}', "");
    Expect(0, 178205, '\P{Age=_V6_0}', "");
    Expect(1, 178205, '\P{^Age=_V6_0}', "");
    Expect(0, 178206, '\p{Age=_V6_0}', "");
    Expect(1, 178206, '\p{^Age=_V6_0}', "");
    Expect(1, 178206, '\P{Age=_V6_0}', "");
    Expect(0, 178206, '\P{^Age=_V6_0}', "");
    Error('\p{Is_Age= 00000000_6.0:=}');
    Error('\P{Is_Age= 00000000_6.0:=}');
    Expect(1, 178205, '\p{Is_Age=+0_6.0}', "");
    Expect(0, 178205, '\p{^Is_Age=+0_6.0}', "");
    Expect(0, 178205, '\P{Is_Age=+0_6.0}', "");
    Expect(1, 178205, '\P{^Is_Age=+0_6.0}', "");
    Expect(0, 178206, '\p{Is_Age=+0_6.0}', "");
    Expect(1, 178206, '\p{^Is_Age=+0_6.0}', "");
    Expect(1, 178206, '\P{Is_Age=+0_6.0}', "");
    Expect(0, 178206, '\P{^Is_Age=+0_6.0}', "");
    Error('\p{Age=:=_v6_1}');
    Error('\P{Age=:=_v6_1}');
    Expect(1, 128564, '\p{Age=:\AV6_1\z:}', "");;
    Expect(0, 128565, '\p{Age=:\AV6_1\z:}', "");;
    Expect(1, 128564, '\p{Age=v61}', "");
    Expect(0, 128564, '\p{^Age=v61}', "");
    Expect(0, 128564, '\P{Age=v61}', "");
    Expect(1, 128564, '\P{^Age=v61}', "");
    Expect(0, 128565, '\p{Age=v61}', "");
    Expect(1, 128565, '\p{^Age=v61}', "");
    Expect(1, 128565, '\P{Age=v61}', "");
    Expect(0, 128565, '\P{^Age=v61}', "");
    Expect(1, 128564, '\p{Age=:\Av61\z:}', "");;
    Expect(0, 128565, '\p{Age=:\Av61\z:}', "");;
    Expect(1, 128564, '\p{Age=-V6_1}', "");
    Expect(0, 128564, '\p{^Age=-V6_1}', "");
    Expect(0, 128564, '\P{Age=-V6_1}', "");
    Expect(1, 128564, '\P{^Age=-V6_1}', "");
    Expect(0, 128565, '\p{Age=-V6_1}', "");
    Expect(1, 128565, '\p{^Age=-V6_1}', "");
    Expect(1, 128565, '\P{Age=-V6_1}', "");
    Expect(0, 128565, '\P{^Age=-V6_1}', "");
    Error('\p{Is_Age=_	0_6.1/a/}');
    Error('\P{Is_Age=_	0_6.1/a/}');
    Expect(1, 128564, '\p{Is_Age=00_00_00_00_6.1}', "");
    Expect(0, 128564, '\p{^Is_Age=00_00_00_00_6.1}', "");
    Expect(0, 128564, '\P{Is_Age=00_00_00_00_6.1}', "");
    Expect(1, 128564, '\P{^Is_Age=00_00_00_00_6.1}', "");
    Expect(0, 128565, '\p{Is_Age=00_00_00_00_6.1}', "");
    Expect(1, 128565, '\p{^Is_Age=00_00_00_00_6.1}', "");
    Expect(1, 128565, '\P{Is_Age=00_00_00_00_6.1}', "");
    Expect(0, 128565, '\P{^Is_Age=00_00_00_00_6.1}', "");
    Error('\p{Age=-	v6_2/a/}');
    Error('\P{Age=-	v6_2/a/}');
    Expect(1, 8378, '\p{Age=:\AV6_2\z:}', "");;
    Expect(0, 8379, '\p{Age=:\AV6_2\z:}', "");;
    Expect(1, 8378, '\p{Age=v62}', "");
    Expect(0, 8378, '\p{^Age=v62}', "");
    Expect(0, 8378, '\P{Age=v62}', "");
    Expect(1, 8378, '\P{^Age=v62}', "");
    Expect(0, 8379, '\p{Age=v62}', "");
    Expect(1, 8379, '\p{^Age=v62}', "");
    Expect(1, 8379, '\P{Age=v62}', "");
    Expect(0, 8379, '\P{^Age=v62}', "");
    Expect(1, 8378, '\p{Age=:\Av62\z:}', "");;
    Expect(0, 8379, '\p{Age=:\Av62\z:}', "");;
    Expect(1, 8378, '\p{Age=  V6_2}', "");
    Expect(0, 8378, '\p{^Age=  V6_2}', "");
    Expect(0, 8378, '\P{Age=  V6_2}', "");
    Expect(1, 8378, '\P{^Age=  V6_2}', "");
    Expect(0, 8379, '\p{Age=  V6_2}', "");
    Expect(1, 8379, '\p{^Age=  V6_2}', "");
    Expect(1, 8379, '\P{Age=  V6_2}', "");
    Expect(0, 8379, '\P{^Age=  V6_2}', "");
    Error('\p{Is_Age=_/a/006.2}');
    Error('\P{Is_Age=_/a/006.2}');
    Expect(1, 8378, '\p{Is_Age=00000000_6.2}', "");
    Expect(0, 8378, '\p{^Is_Age=00000000_6.2}', "");
    Expect(0, 8378, '\P{Is_Age=00000000_6.2}', "");
    Expect(1, 8378, '\P{^Is_Age=00000000_6.2}', "");
    Expect(0, 8379, '\p{Is_Age=00000000_6.2}', "");
    Expect(1, 8379, '\p{^Is_Age=00000000_6.2}', "");
    Expect(1, 8379, '\P{Is_Age=00000000_6.2}', "");
    Expect(0, 8379, '\P{^Is_Age=00000000_6.2}', "");
    Error('\p{Age=/a/- V6_3}');
    Error('\P{Age=/a/- V6_3}');
    Expect(1, 8297, '\p{Age=:\AV6_3\z:}', "");;
    Expect(0, 8298, '\p{Age=:\AV6_3\z:}', "");;
    Expect(1, 8297, '\p{Age=v63}', "");
    Expect(0, 8297, '\p{^Age=v63}', "");
    Expect(0, 8297, '\P{Age=v63}', "");
    Expect(1, 8297, '\P{^Age=v63}', "");
    Expect(0, 8298, '\p{Age=v63}', "");
    Expect(1, 8298, '\p{^Age=v63}', "");
    Expect(1, 8298, '\P{Age=v63}', "");
    Expect(0, 8298, '\P{^Age=v63}', "");
    Expect(1, 8297, '\p{Age=:\Av63\z:}', "");;
    Expect(0, 8298, '\p{Age=:\Av63\z:}', "");;
    Expect(1, 8297, '\p{Age=_	v6_3}', "");
    Expect(0, 8297, '\p{^Age=_	v6_3}', "");
    Expect(0, 8297, '\P{Age=_	v6_3}', "");
    Expect(1, 8297, '\P{^Age=_	v6_3}', "");
    Expect(0, 8298, '\p{Age=_	v6_3}', "");
    Expect(1, 8298, '\p{^Age=_	v6_3}', "");
    Expect(1, 8298, '\P{Age=_	v6_3}', "");
    Expect(0, 8298, '\P{^Age=_	v6_3}', "");
    Error('\p{Is_Age=:= _0000006.3}');
    Error('\P{Is_Age=:= _0000006.3}');
    Expect(1, 8297, '\p{Is_Age=+0000_0000_06.3}', "");
    Expect(0, 8297, '\p{^Is_Age=+0000_0000_06.3}', "");
    Expect(0, 8297, '\P{Is_Age=+0000_0000_06.3}', "");
    Expect(1, 8297, '\P{^Is_Age=+0000_0000_06.3}', "");
    Expect(0, 8298, '\p{Is_Age=+0000_0000_06.3}', "");
    Expect(1, 8298, '\p{^Is_Age=+0000_0000_06.3}', "");
    Expect(1, 8298, '\P{Is_Age=+0000_0000_06.3}', "");
    Expect(0, 8298, '\P{^Is_Age=+0000_0000_06.3}', "");
    Error('\p{Age= /a/v7_0}');
    Error('\P{Age= /a/v7_0}');
    Expect(1, 129197, '\p{Age=:\AV7_0\z:}', "");;
    Expect(0, 129198, '\p{Age=:\AV7_0\z:}', "");;
    Expect(1, 129197, '\p{Age=v70}', "");
    Expect(0, 129197, '\p{^Age=v70}', "");
    Expect(0, 129197, '\P{Age=v70}', "");
    Expect(1, 129197, '\P{^Age=v70}', "");
    Expect(0, 129198, '\p{Age=v70}', "");
    Expect(1, 129198, '\p{^Age=v70}', "");
    Expect(1, 129198, '\P{Age=v70}', "");
    Expect(0, 129198, '\P{^Age=v70}', "");
    Expect(1, 129197, '\p{Age=:\Av70\z:}', "");;
    Expect(0, 129198, '\p{Age=:\Av70\z:}', "");;
    Expect(1, 129197, '\p{Age=	 V7_0}', "");
    Expect(0, 129197, '\p{^Age=	 V7_0}', "");
    Expect(0, 129197, '\P{Age=	 V7_0}', "");
    Expect(1, 129197, '\P{^Age=	 V7_0}', "");
    Expect(0, 129198, '\p{Age=	 V7_0}', "");
    Expect(1, 129198, '\p{^Age=	 V7_0}', "");
    Expect(1, 129198, '\P{Age=	 V7_0}', "");
    Expect(0, 129198, '\P{^Age=	 V7_0}', "");
    Error('\p{Is_Age= :=0007.0}');
    Error('\P{Is_Age= :=0007.0}');
    Expect(1, 129197, '\p{Is_Age=00000007.0}', "");
    Expect(0, 129197, '\p{^Is_Age=00000007.0}', "");
    Expect(0, 129197, '\P{Is_Age=00000007.0}', "");
    Expect(1, 129197, '\P{^Is_Age=00000007.0}', "");
    Expect(0, 129198, '\p{Is_Age=00000007.0}', "");
    Expect(1, 129198, '\p{^Is_Age=00000007.0}', "");
    Expect(1, 129198, '\P{Is_Age=00000007.0}', "");
    Expect(0, 129198, '\P{^Is_Age=00000007.0}', "");
    Error('\p{Age=	/a/V8_0}');
    Error('\P{Age=	/a/V8_0}');
    Expect(1, 183969, '\p{Age=:\AV8_0\z:}', "");;
    Expect(0, 183970, '\p{Age=:\AV8_0\z:}', "");;
    Expect(1, 183969, '\p{Age=v80}', "");
    Expect(0, 183969, '\p{^Age=v80}', "");
    Expect(0, 183969, '\P{Age=v80}', "");
    Expect(1, 183969, '\P{^Age=v80}', "");
    Expect(0, 183970, '\p{Age=v80}', "");
    Expect(1, 183970, '\p{^Age=v80}', "");
    Expect(1, 183970, '\P{Age=v80}', "");
    Expect(0, 183970, '\P{^Age=v80}', "");
    Expect(1, 183969, '\p{Age=:\Av80\z:}', "");;
    Expect(0, 183970, '\p{Age=:\Av80\z:}', "");;
    Expect(1, 183969, '\p{Age=_v8_0}', "");
    Expect(0, 183969, '\p{^Age=_v8_0}', "");
    Expect(0, 183969, '\P{Age=_v8_0}', "");
    Expect(1, 183969, '\P{^Age=_v8_0}', "");
    Expect(0, 183970, '\p{Age=_v8_0}', "");
    Expect(1, 183970, '\p{^Age=_v8_0}', "");
    Expect(1, 183970, '\P{Age=_v8_0}', "");
    Expect(0, 183970, '\P{^Age=_v8_0}', "");
    Error('\p{Is_Age=:=	_+008.0}');
    Error('\P{Is_Age=:=	_+008.0}');
    Expect(1, 183969, '\p{Is_Age=0_0_0_0_008.0}', "");
    Expect(0, 183969, '\p{^Is_Age=0_0_0_0_008.0}', "");
    Expect(0, 183969, '\P{Is_Age=0_0_0_0_008.0}', "");
    Expect(1, 183969, '\P{^Is_Age=0_0_0_0_008.0}', "");
    Expect(0, 183970, '\p{Is_Age=0_0_0_0_008.0}', "");
    Expect(1, 183970, '\p{^Is_Age=0_0_0_0_008.0}', "");
    Expect(1, 183970, '\P{Is_Age=0_0_0_0_008.0}', "");
    Expect(0, 183970, '\P{^Is_Age=0_0_0_0_008.0}', "");
    Error('\p{Age=-	V9_0:=}');
    Error('\P{Age=-	V9_0:=}');
    Expect(1, 129425, '\p{Age=:\AV9_0\z:}', "");;
    Expect(0, 129426, '\p{Age=:\AV9_0\z:}', "");;
    Expect(1, 129425, '\p{Age=v90}', "");
    Expect(0, 129425, '\p{^Age=v90}', "");
    Expect(0, 129425, '\P{Age=v90}', "");
    Expect(1, 129425, '\P{^Age=v90}', "");
    Expect(0, 129426, '\p{Age=v90}', "");
    Expect(1, 129426, '\p{^Age=v90}', "");
    Expect(1, 129426, '\P{Age=v90}', "");
    Expect(0, 129426, '\P{^Age=v90}', "");
    Expect(1, 129425, '\p{Age=:\Av90\z:}', "");;
    Expect(0, 129426, '\p{Age=:\Av90\z:}', "");;
    Expect(1, 129425, '\p{Age=-V9_0}', "");
    Expect(0, 129425, '\p{^Age=-V9_0}', "");
    Expect(0, 129425, '\P{Age=-V9_0}', "");
    Expect(1, 129425, '\P{^Age=-V9_0}', "");
    Expect(0, 129426, '\p{Age=-V9_0}', "");
    Expect(1, 129426, '\p{^Age=-V9_0}', "");
    Expect(1, 129426, '\P{Age=-V9_0}', "");
    Expect(0, 129426, '\P{^Age=-V9_0}', "");
    Error('\p{Is_Age=/a/00000009.0}');
    Error('\P{Is_Age=/a/00000009.0}');
    Expect(1, 129425, '\p{Is_Age=0_0_0_0_0009.0}', "");
    Expect(0, 129425, '\p{^Is_Age=0_0_0_0_0009.0}', "");
    Expect(0, 129425, '\P{Is_Age=0_0_0_0_0009.0}', "");
    Expect(1, 129425, '\P{^Is_Age=0_0_0_0_0009.0}', "");
    Expect(0, 129426, '\p{Is_Age=0_0_0_0_0009.0}', "");
    Expect(1, 129426, '\p{^Is_Age=0_0_0_0_0009.0}', "");
    Expect(1, 129426, '\P{Is_Age=0_0_0_0_0009.0}', "");
    Expect(0, 129426, '\P{^Is_Age=0_0_0_0_0009.0}', "");
    Error('\p{Age=	:=unassigned}');
    Error('\P{Age=	:=unassigned}');
    Expect(1, 983037, '\p{Age=:\AUnassigned\z:}', "");;
    Expect(0, 983040, '\p{Age=:\AUnassigned\z:}', "");;
    Expect(1, 983037, '\p{Age=unassigned}', "");
    Expect(0, 983037, '\p{^Age=unassigned}', "");
    Expect(0, 983037, '\P{Age=unassigned}', "");
    Expect(1, 983037, '\P{^Age=unassigned}', "");
    Expect(0, 983040, '\p{Age=unassigned}', "");
    Expect(1, 983040, '\p{^Age=unassigned}', "");
    Expect(1, 983040, '\P{Age=unassigned}', "");
    Expect(0, 983040, '\P{^Age=unassigned}', "");
    Expect(1, 983037, '\p{Age=:\Aunassigned\z:}', "");;
    Expect(0, 983040, '\p{Age=:\Aunassigned\z:}', "");;
    Expect(1, 983037, '\p{Age=	UNASSIGNED}', "");
    Expect(0, 983037, '\p{^Age=	UNASSIGNED}', "");
    Expect(0, 983037, '\P{Age=	UNASSIGNED}', "");
    Expect(1, 983037, '\P{^Age=	UNASSIGNED}', "");
    Expect(0, 983040, '\p{Age=	UNASSIGNED}', "");
    Expect(1, 983040, '\p{^Age=	UNASSIGNED}', "");
    Expect(1, 983040, '\P{Age=	UNASSIGNED}', "");
    Expect(0, 983040, '\P{^Age=	UNASSIGNED}', "");
    Error('\p{Is_Age=/a/_ NA}');
    Error('\P{Is_Age=/a/_ NA}');
    Expect(1, 983037, '\p{Is_Age=na}', "");
    Expect(0, 983037, '\p{^Is_Age=na}', "");
    Expect(0, 983037, '\P{Is_Age=na}', "");
    Expect(1, 983037, '\P{^Is_Age=na}', "");
    Expect(0, 983040, '\p{Is_Age=na}', "");
    Expect(1, 983040, '\p{^Is_Age=na}', "");
    Expect(1, 983040, '\P{Is_Age=na}', "");
    Expect(0, 983040, '\P{^Is_Age=na}', "");
    Expect(1, 983037, '\p{Is_Age=_NA}', "");
    Expect(0, 983037, '\p{^Is_Age=_NA}', "");
    Expect(0, 983037, '\P{Is_Age=_NA}', "");
    Expect(1, 983037, '\P{^Is_Age=_NA}', "");
    Expect(0, 983040, '\p{Is_Age=_NA}', "");
    Expect(1, 983040, '\p{^Is_Age=_NA}', "");
    Expect(1, 983040, '\P{Is_Age=_NA}', "");
    Expect(0, 983040, '\P{^Is_Age=_NA}', "");
    Error('\p{ASCII_Hex_Digit=-/a/no}');
    Error('\P{ASCII_Hex_Digit=-/a/no}');
    Expect(1, 103, '\p{ASCII_Hex_Digit=:\ANo\z:}', "");;
    Expect(0, 102, '\p{ASCII_Hex_Digit=:\ANo\z:}', "");;
    Expect(1, 103, '\p{ASCII_Hex_Digit=no}', "");
    Expect(0, 103, '\p{^ASCII_Hex_Digit=no}', "");
    Expect(0, 103, '\P{ASCII_Hex_Digit=no}', "");
    Expect(1, 103, '\P{^ASCII_Hex_Digit=no}', "");
    Expect(0, 102, '\p{ASCII_Hex_Digit=no}', "");
    Expect(1, 102, '\p{^ASCII_Hex_Digit=no}', "");
    Expect(1, 102, '\P{ASCII_Hex_Digit=no}', "");
    Expect(0, 102, '\P{^ASCII_Hex_Digit=no}', "");
    Expect(1, 103, '\p{ASCII_Hex_Digit=:\Ano\z:}', "");;
    Expect(0, 102, '\p{ASCII_Hex_Digit=:\Ano\z:}', "");;
    Expect(1, 103, '\p{ASCII_Hex_Digit=-	No}', "");
    Expect(0, 103, '\p{^ASCII_Hex_Digit=-	No}', "");
    Expect(0, 103, '\P{ASCII_Hex_Digit=-	No}', "");
    Expect(1, 103, '\P{^ASCII_Hex_Digit=-	No}', "");
    Expect(0, 102, '\p{ASCII_Hex_Digit=-	No}', "");
    Expect(1, 102, '\p{^ASCII_Hex_Digit=-	No}', "");
    Expect(1, 102, '\P{ASCII_Hex_Digit=-	No}', "");
    Expect(0, 102, '\P{^ASCII_Hex_Digit=-	No}', "");
    Error('\p{AHex:	__N:=}');
    Error('\P{AHex:	__N:=}');
    Expect(1, 103, '\p{AHex=:\AN\z:}', "");;
    Expect(0, 102, '\p{AHex=:\AN\z:}', "");;
    Expect(1, 103, '\p{AHex:	n}', "");
    Expect(0, 103, '\p{^AHex:	n}', "");
    Expect(0, 103, '\P{AHex:	n}', "");
    Expect(1, 103, '\P{^AHex:	n}', "");
    Expect(0, 102, '\p{AHex:	n}', "");
    Expect(1, 102, '\p{^AHex:	n}', "");
    Expect(1, 102, '\P{AHex:	n}', "");
    Expect(0, 102, '\P{^AHex:	n}', "");
    Expect(1, 103, '\p{AHex=:\An\z:}', "");;
    Expect(0, 102, '\p{AHex=:\An\z:}', "");;
    Expect(1, 103, '\p{AHex=	n}', "");
    Expect(0, 103, '\p{^AHex=	n}', "");
    Expect(0, 103, '\P{AHex=	n}', "");
    Expect(1, 103, '\P{^AHex=	n}', "");
    Expect(0, 102, '\p{AHex=	n}', "");
    Expect(1, 102, '\p{^AHex=	n}', "");
    Expect(1, 102, '\P{AHex=	n}', "");
    Expect(0, 102, '\P{^AHex=	n}', "");
    Error('\p{Is_ASCII_Hex_Digit=	F/a/}');
    Error('\P{Is_ASCII_Hex_Digit=	F/a/}');
    Expect(1, 103, '\p{Is_ASCII_Hex_Digit:   f}', "");
    Expect(0, 103, '\p{^Is_ASCII_Hex_Digit:   f}', "");
    Expect(0, 103, '\P{Is_ASCII_Hex_Digit:   f}', "");
    Expect(1, 103, '\P{^Is_ASCII_Hex_Digit:   f}', "");
    Expect(0, 102, '\p{Is_ASCII_Hex_Digit:   f}', "");
    Expect(1, 102, '\p{^Is_ASCII_Hex_Digit:   f}', "");
    Expect(1, 102, '\P{Is_ASCII_Hex_Digit:   f}', "");
    Expect(0, 102, '\P{^Is_ASCII_Hex_Digit:   f}', "");
    Expect(1, 103, '\p{Is_ASCII_Hex_Digit=_ F}', "");
    Expect(0, 103, '\p{^Is_ASCII_Hex_Digit=_ F}', "");
    Expect(0, 103, '\P{Is_ASCII_Hex_Digit=_ F}', "");
    Expect(1, 103, '\P{^Is_ASCII_Hex_Digit=_ F}', "");
    Expect(0, 102, '\p{Is_ASCII_Hex_Digit=_ F}', "");
    Expect(1, 102, '\p{^Is_ASCII_Hex_Digit=_ F}', "");
    Expect(1, 102, '\P{Is_ASCII_Hex_Digit=_ F}', "");
    Expect(0, 102, '\P{^Is_ASCII_Hex_Digit=_ F}', "");
    Error('\p{Is_AHex=_	False:=}');
    Error('\P{Is_AHex=_	False:=}');
    Expect(1, 103, '\p{Is_AHex=false}', "");
    Expect(0, 103, '\p{^Is_AHex=false}', "");
    Expect(0, 103, '\P{Is_AHex=false}', "");
    Expect(1, 103, '\P{^Is_AHex=false}', "");
    Expect(0, 102, '\p{Is_AHex=false}', "");
    Expect(1, 102, '\p{^Is_AHex=false}', "");
    Expect(1, 102, '\P{Is_AHex=false}', "");
    Expect(0, 102, '\P{^Is_AHex=false}', "");
    Expect(1, 103, '\p{Is_AHex= -false}', "");
    Expect(0, 103, '\p{^Is_AHex= -false}', "");
    Expect(0, 103, '\P{Is_AHex= -false}', "");
    Expect(1, 103, '\P{^Is_AHex= -false}', "");
    Expect(0, 102, '\p{Is_AHex= -false}', "");
    Expect(1, 102, '\p{^Is_AHex= -false}', "");
    Expect(1, 102, '\P{Is_AHex= -false}', "");
    Expect(0, 102, '\P{^Is_AHex= -false}', "");
    Error('\p{ASCII_Hex_Digit=:=__Yes}');
    Error('\P{ASCII_Hex_Digit=:=__Yes}');
    Expect(1, 102, '\p{ASCII_Hex_Digit=:\AYes\z:}', "");;
    Expect(0, 103, '\p{ASCII_Hex_Digit=:\AYes\z:}', "");;
    Expect(1, 102, '\p{ASCII_Hex_Digit=yes}', "");
    Expect(0, 102, '\p{^ASCII_Hex_Digit=yes}', "");
    Expect(0, 102, '\P{ASCII_Hex_Digit=yes}', "");
    Expect(1, 102, '\P{^ASCII_Hex_Digit=yes}', "");
    Expect(0, 103, '\p{ASCII_Hex_Digit=yes}', "");
    Expect(1, 103, '\p{^ASCII_Hex_Digit=yes}', "");
    Expect(1, 103, '\P{ASCII_Hex_Digit=yes}', "");
    Expect(0, 103, '\P{^ASCII_Hex_Digit=yes}', "");
    Expect(1, 102, '\p{ASCII_Hex_Digit=:\Ayes\z:}', "");;
    Expect(0, 103, '\p{ASCII_Hex_Digit=:\Ayes\z:}', "");;
    Expect(1, 102, '\p{ASCII_Hex_Digit=	 YES}', "");
    Expect(0, 102, '\p{^ASCII_Hex_Digit=	 YES}', "");
    Expect(0, 102, '\P{ASCII_Hex_Digit=	 YES}', "");
    Expect(1, 102, '\P{^ASCII_Hex_Digit=	 YES}', "");
    Expect(0, 103, '\p{ASCII_Hex_Digit=	 YES}', "");
    Expect(1, 103, '\p{^ASCII_Hex_Digit=	 YES}', "");
    Expect(1, 103, '\P{ASCII_Hex_Digit=	 YES}', "");
    Expect(0, 103, '\P{^ASCII_Hex_Digit=	 YES}', "");
    Error('\p{AHex=-/a/y}');
    Error('\P{AHex=-/a/y}');
    Expect(1, 102, '\p{AHex=:\AY\z:}', "");;
    Expect(0, 103, '\p{AHex=:\AY\z:}', "");;
    Expect(1, 102, '\p{AHex:	y}', "");
    Expect(0, 102, '\p{^AHex:	y}', "");
    Expect(0, 102, '\P{AHex:	y}', "");
    Expect(1, 102, '\P{^AHex:	y}', "");
    Expect(0, 103, '\p{AHex:	y}', "");
    Expect(1, 103, '\p{^AHex:	y}', "");
    Expect(1, 103, '\P{AHex:	y}', "");
    Expect(0, 103, '\P{^AHex:	y}', "");
    Expect(1, 102, '\p{AHex=:\Ay\z:}', "");;
    Expect(0, 103, '\p{AHex=:\Ay\z:}', "");;
    Expect(1, 102, '\p{AHex=_ Y}', "");
    Expect(0, 102, '\p{^AHex=_ Y}', "");
    Expect(0, 102, '\P{AHex=_ Y}', "");
    Expect(1, 102, '\P{^AHex=_ Y}', "");
    Expect(0, 103, '\p{AHex=_ Y}', "");
    Expect(1, 103, '\p{^AHex=_ Y}', "");
    Expect(1, 103, '\P{AHex=_ Y}', "");
    Expect(0, 103, '\P{^AHex=_ Y}', "");
    Error('\p{Is_ASCII_Hex_Digit=--T:=}');
    Error('\P{Is_ASCII_Hex_Digit=--T:=}');
    Expect(1, 102, '\p{Is_ASCII_Hex_Digit=t}', "");
    Expect(0, 102, '\p{^Is_ASCII_Hex_Digit=t}', "");
    Expect(0, 102, '\P{Is_ASCII_Hex_Digit=t}', "");
    Expect(1, 102, '\P{^Is_ASCII_Hex_Digit=t}', "");
    Expect(0, 103, '\p{Is_ASCII_Hex_Digit=t}', "");
    Expect(1, 103, '\p{^Is_ASCII_Hex_Digit=t}', "");
    Expect(1, 103, '\P{Is_ASCII_Hex_Digit=t}', "");
    Expect(0, 103, '\P{^Is_ASCII_Hex_Digit=t}', "");
    Expect(1, 102, '\p{Is_ASCII_Hex_Digit=		T}', "");
    Expect(0, 102, '\p{^Is_ASCII_Hex_Digit=		T}', "");
    Expect(0, 102, '\P{Is_ASCII_Hex_Digit=		T}', "");
    Expect(1, 102, '\P{^Is_ASCII_Hex_Digit=		T}', "");
    Expect(0, 103, '\p{Is_ASCII_Hex_Digit=		T}', "");
    Expect(1, 103, '\p{^Is_ASCII_Hex_Digit=		T}', "");
    Expect(1, 103, '\P{Is_ASCII_Hex_Digit=		T}', "");
    Expect(0, 103, '\P{^Is_ASCII_Hex_Digit=		T}', "");
    Error('\p{Is_AHex=:=-true}');
    Error('\P{Is_AHex=:=-true}');
    Expect(1, 102, '\p{Is_AHex=true}', "");
    Expect(0, 102, '\p{^Is_AHex=true}', "");
    Expect(0, 102, '\P{Is_AHex=true}', "");
    Expect(1, 102, '\P{^Is_AHex=true}', "");
    Expect(0, 103, '\p{Is_AHex=true}', "");
    Expect(1, 103, '\p{^Is_AHex=true}', "");
    Expect(1, 103, '\P{Is_AHex=true}', "");
    Expect(0, 103, '\P{^Is_AHex=true}', "");
    Expect(1, 102, '\p{Is_AHex=- True}', "");
    Expect(0, 102, '\p{^Is_AHex=- True}', "");
    Expect(0, 102, '\P{Is_AHex=- True}', "");
    Expect(1, 102, '\P{^Is_AHex=- True}', "");
    Expect(0, 103, '\p{Is_AHex=- True}', "");
    Expect(1, 103, '\p{^Is_AHex=- True}', "");
    Expect(1, 103, '\P{Is_AHex=- True}', "");
    Expect(0, 103, '\P{^Is_AHex=- True}', "");
    Error('\p{Alphabetic=:=__no}');
    Error('\P{Alphabetic=:=__no}');
    Expect(1, 205744, '\p{Alphabetic=:\ANo\z:}', "");;
    Expect(0, 205743, '\p{Alphabetic=:\ANo\z:}', "");;
    Expect(1, 205744, '\p{Alphabetic=no}', "");
    Expect(0, 205744, '\p{^Alphabetic=no}', "");
    Expect(0, 205744, '\P{Alphabetic=no}', "");
    Expect(1, 205744, '\P{^Alphabetic=no}', "");
    Expect(0, 205743, '\p{Alphabetic=no}', "");
    Expect(1, 205743, '\p{^Alphabetic=no}', "");
    Expect(1, 205743, '\P{Alphabetic=no}', "");
    Expect(0, 205743, '\P{^Alphabetic=no}', "");
    Expect(1, 205744, '\p{Alphabetic=:\Ano\z:}', "");;
    Expect(0, 205743, '\p{Alphabetic=:\Ano\z:}', "");;
    Expect(1, 205744, '\p{Alphabetic=  No}', "");
    Expect(0, 205744, '\p{^Alphabetic=  No}', "");
    Expect(0, 205744, '\P{Alphabetic=  No}', "");
    Expect(1, 205744, '\P{^Alphabetic=  No}', "");
    Expect(0, 205743, '\p{Alphabetic=  No}', "");
    Expect(1, 205743, '\p{^Alphabetic=  No}', "");
    Expect(1, 205743, '\P{Alphabetic=  No}', "");
    Expect(0, 205743, '\P{^Alphabetic=  No}', "");
    Error('\p{Alpha:	_/a/N}');
    Error('\P{Alpha:	_/a/N}');
    Expect(1, 205744, '\p{Alpha=:\AN\z:}', "");;
    Expect(0, 205743, '\p{Alpha=:\AN\z:}', "");;
    Expect(1, 205744, '\p{Alpha=n}', "");
    Expect(0, 205744, '\p{^Alpha=n}', "");
    Expect(0, 205744, '\P{Alpha=n}', "");
    Expect(1, 205744, '\P{^Alpha=n}', "");
    Expect(0, 205743, '\p{Alpha=n}', "");
    Expect(1, 205743, '\p{^Alpha=n}', "");
    Expect(1, 205743, '\P{Alpha=n}', "");
    Expect(0, 205743, '\P{^Alpha=n}', "");
    Expect(1, 205744, '\p{Alpha=:\An\z:}', "");;
    Expect(0, 205743, '\p{Alpha=:\An\z:}', "");;
    Expect(1, 205744, '\p{Alpha=	_N}', "");
    Expect(0, 205744, '\p{^Alpha=	_N}', "");
    Expect(0, 205744, '\P{Alpha=	_N}', "");
    Expect(1, 205744, '\P{^Alpha=	_N}', "");
    Expect(0, 205743, '\p{Alpha=	_N}', "");
    Expect(1, 205743, '\p{^Alpha=	_N}', "");
    Expect(1, 205743, '\P{Alpha=	_N}', "");
    Expect(0, 205743, '\P{^Alpha=	_N}', "");
    Error('\p{Is_Alphabetic=:=--F}');
    Error('\P{Is_Alphabetic=:=--F}');
    Expect(1, 205744, '\p{Is_Alphabetic=f}', "");
    Expect(0, 205744, '\p{^Is_Alphabetic=f}', "");
    Expect(0, 205744, '\P{Is_Alphabetic=f}', "");
    Expect(1, 205744, '\P{^Is_Alphabetic=f}', "");
    Expect(0, 205743, '\p{Is_Alphabetic=f}', "");
    Expect(1, 205743, '\p{^Is_Alphabetic=f}', "");
    Expect(1, 205743, '\P{Is_Alphabetic=f}', "");
    Expect(0, 205743, '\P{^Is_Alphabetic=f}', "");
    Expect(1, 205744, '\p{Is_Alphabetic:    -F}', "");
    Expect(0, 205744, '\p{^Is_Alphabetic:    -F}', "");
    Expect(0, 205744, '\P{Is_Alphabetic:    -F}', "");
    Expect(1, 205744, '\P{^Is_Alphabetic:    -F}', "");
    Expect(0, 205743, '\p{Is_Alphabetic:    -F}', "");
    Expect(1, 205743, '\p{^Is_Alphabetic:    -F}', "");
    Expect(1, 205743, '\P{Is_Alphabetic:    -F}', "");
    Expect(0, 205743, '\P{^Is_Alphabetic:    -F}', "");
    Error('\p{Is_Alpha=:=-	FALSE}');
    Error('\P{Is_Alpha=:=-	FALSE}');
    Expect(1, 205744, '\p{Is_Alpha=false}', "");
    Expect(0, 205744, '\p{^Is_Alpha=false}', "");
    Expect(0, 205744, '\P{Is_Alpha=false}', "");
    Expect(1, 205744, '\P{^Is_Alpha=false}', "");
    Expect(0, 205743, '\p{Is_Alpha=false}', "");
    Expect(1, 205743, '\p{^Is_Alpha=false}', "");
    Expect(1, 205743, '\P{Is_Alpha=false}', "");
    Expect(0, 205743, '\P{^Is_Alpha=false}', "");
    Expect(1, 205744, '\p{Is_Alpha: 		false}', "");
    Expect(0, 205744, '\p{^Is_Alpha: 		false}', "");
    Expect(0, 205744, '\P{Is_Alpha: 		false}', "");
    Expect(1, 205744, '\P{^Is_Alpha: 		false}', "");
    Expect(0, 205743, '\p{Is_Alpha: 		false}', "");
    Expect(1, 205743, '\p{^Is_Alpha: 		false}', "");
    Expect(1, 205743, '\P{Is_Alpha: 		false}', "");
    Expect(0, 205743, '\P{^Is_Alpha: 		false}', "");
    Error('\p{Alphabetic=-YES/a/}');
    Error('\P{Alphabetic=-YES/a/}');
    Expect(1, 205743, '\p{Alphabetic=:\AYes\z:}', "");;
    Expect(0, 205744, '\p{Alphabetic=:\AYes\z:}', "");;
    Expect(1, 205743, '\p{Alphabetic=yes}', "");
    Expect(0, 205743, '\p{^Alphabetic=yes}', "");
    Expect(0, 205743, '\P{Alphabetic=yes}', "");
    Expect(1, 205743, '\P{^Alphabetic=yes}', "");
    Expect(0, 205744, '\p{Alphabetic=yes}', "");
    Expect(1, 205744, '\p{^Alphabetic=yes}', "");
    Expect(1, 205744, '\P{Alphabetic=yes}', "");
    Expect(0, 205744, '\P{^Alphabetic=yes}', "");
    Expect(1, 205743, '\p{Alphabetic=:\Ayes\z:}', "");;
    Expect(0, 205744, '\p{Alphabetic=:\Ayes\z:}', "");;
    Expect(1, 205743, '\p{Alphabetic=_-YES}', "");
    Expect(0, 205743, '\p{^Alphabetic=_-YES}', "");
    Expect(0, 205743, '\P{Alphabetic=_-YES}', "");
    Expect(1, 205743, '\P{^Alphabetic=_-YES}', "");
    Expect(0, 205744, '\p{Alphabetic=_-YES}', "");
    Expect(1, 205744, '\p{^Alphabetic=_-YES}', "");
    Expect(1, 205744, '\P{Alphabetic=_-YES}', "");
    Expect(0, 205744, '\P{^Alphabetic=_-YES}', "");
    Error('\p{Alpha=_:=Y}');
    Error('\P{Alpha=_:=Y}');
    Expect(1, 205743, '\p{Alpha=:\AY\z:}', "");;
    Expect(0, 205744, '\p{Alpha=:\AY\z:}', "");;
    Expect(1, 205743, '\p{Alpha=y}', "");
    Expect(0, 205743, '\p{^Alpha=y}', "");
    Expect(0, 205743, '\P{Alpha=y}', "");
    Expect(1, 205743, '\P{^Alpha=y}', "");
    Expect(0, 205744, '\p{Alpha=y}', "");
    Expect(1, 205744, '\p{^Alpha=y}', "");
    Expect(1, 205744, '\P{Alpha=y}', "");
    Expect(0, 205744, '\P{^Alpha=y}', "");
    Expect(1, 205743, '\p{Alpha=:\Ay\z:}', "");;
    Expect(0, 205744, '\p{Alpha=:\Ay\z:}', "");;
    Expect(1, 205743, '\p{Alpha= Y}', "");
    Expect(0, 205743, '\p{^Alpha= Y}', "");
    Expect(0, 205743, '\P{Alpha= Y}', "");
    Expect(1, 205743, '\P{^Alpha= Y}', "");
    Expect(0, 205744, '\p{Alpha= Y}', "");
    Expect(1, 205744, '\p{^Alpha= Y}', "");
    Expect(1, 205744, '\P{Alpha= Y}', "");
    Expect(0, 205744, '\P{^Alpha= Y}', "");
    Error('\p{Is_Alphabetic:	:=T}');
    Error('\P{Is_Alphabetic:	:=T}');
    Expect(1, 205743, '\p{Is_Alphabetic=t}', "");
    Expect(0, 205743, '\p{^Is_Alphabetic=t}', "");
    Expect(0, 205743, '\P{Is_Alphabetic=t}', "");
    Expect(1, 205743, '\P{^Is_Alphabetic=t}', "");
    Expect(0, 205744, '\p{Is_Alphabetic=t}', "");
    Expect(1, 205744, '\p{^Is_Alphabetic=t}', "");
    Expect(1, 205744, '\P{Is_Alphabetic=t}', "");
    Expect(0, 205744, '\P{^Is_Alphabetic=t}', "");
    Expect(1, 205743, '\p{Is_Alphabetic=_T}', "");
    Expect(0, 205743, '\p{^Is_Alphabetic=_T}', "");
    Expect(0, 205743, '\P{Is_Alphabetic=_T}', "");
    Expect(1, 205743, '\P{^Is_Alphabetic=_T}', "");
    Expect(0, 205744, '\p{Is_Alphabetic=_T}', "");
    Expect(1, 205744, '\p{^Is_Alphabetic=_T}', "");
    Expect(1, 205744, '\P{Is_Alphabetic=_T}', "");
    Expect(0, 205744, '\P{^Is_Alphabetic=_T}', "");
    Error('\p{Is_Alpha=-/a/true}');
    Error('\P{Is_Alpha=-/a/true}');
    Expect(1, 205743, '\p{Is_Alpha: true}', "");
    Expect(0, 205743, '\p{^Is_Alpha: true}', "");
    Expect(0, 205743, '\P{Is_Alpha: true}', "");
    Expect(1, 205743, '\P{^Is_Alpha: true}', "");
    Expect(0, 205744, '\p{Is_Alpha: true}', "");
    Expect(1, 205744, '\p{^Is_Alpha: true}', "");
    Expect(1, 205744, '\P{Is_Alpha: true}', "");
    Expect(0, 205744, '\P{^Is_Alpha: true}', "");
    Expect(1, 205743, '\p{Is_Alpha=	true}', "");
    Expect(0, 205743, '\p{^Is_Alpha=	true}', "");
    Expect(0, 205743, '\P{Is_Alpha=	true}', "");
    Expect(1, 205743, '\P{^Is_Alpha=	true}', "");
    Expect(0, 205744, '\p{Is_Alpha=	true}', "");
    Expect(1, 205744, '\p{^Is_Alpha=	true}', "");
    Expect(1, 205744, '\P{Is_Alpha=	true}', "");
    Expect(0, 205744, '\P{^Is_Alpha=	true}', "");
    Error('\p{bidiclass}');
    Error('\P{bidiclass}');
    Error('\p{bc}');
    Error('\P{bc}');
    Error('\p{Bidi_Class=	-Arabic_letter:=}');
    Error('\P{Bidi_Class=	-Arabic_letter:=}');
    Expect(1, 126719, '\p{Bidi_Class=:\AArabic_Letter\z:}', "");;
    Expect(0, 126720, '\p{Bidi_Class=:\AArabic_Letter\z:}', "");;
    Expect(1, 126719, '\p{Bidi_Class=arabicletter}', "");
    Expect(0, 126719, '\p{^Bidi_Class=arabicletter}', "");
    Expect(0, 126719, '\P{Bidi_Class=arabicletter}', "");
    Expect(1, 126719, '\P{^Bidi_Class=arabicletter}', "");
    Expect(0, 126720, '\p{Bidi_Class=arabicletter}', "");
    Expect(1, 126720, '\p{^Bidi_Class=arabicletter}', "");
    Expect(1, 126720, '\P{Bidi_Class=arabicletter}', "");
    Expect(0, 126720, '\P{^Bidi_Class=arabicletter}', "");
    Expect(1, 126719, '\p{Bidi_Class=:\Aarabicletter\z:}', "");;
    Expect(0, 126720, '\p{Bidi_Class=:\Aarabicletter\z:}', "");;
    Expect(1, 126719, '\p{Bidi_Class=	-ARABIC_letter}', "");
    Expect(0, 126719, '\p{^Bidi_Class=	-ARABIC_letter}', "");
    Expect(0, 126719, '\P{Bidi_Class=	-ARABIC_letter}', "");
    Expect(1, 126719, '\P{^Bidi_Class=	-ARABIC_letter}', "");
    Expect(0, 126720, '\p{Bidi_Class=	-ARABIC_letter}', "");
    Expect(1, 126720, '\p{^Bidi_Class=	-ARABIC_letter}', "");
    Expect(1, 126720, '\P{Bidi_Class=	-ARABIC_letter}', "");
    Expect(0, 126720, '\P{^Bidi_Class=	-ARABIC_letter}', "");
    Error('\p{Bc=-/a/AL}');
    Error('\P{Bc=-/a/AL}');
    Expect(1, 126719, '\p{Bc=:\AAL\z:}', "");;
    Expect(0, 126720, '\p{Bc=:\AAL\z:}', "");;
    Expect(1, 126719, '\p{Bc=al}', "");
    Expect(0, 126719, '\p{^Bc=al}', "");
    Expect(0, 126719, '\P{Bc=al}', "");
    Expect(1, 126719, '\P{^Bc=al}', "");
    Expect(0, 126720, '\p{Bc=al}', "");
    Expect(1, 126720, '\p{^Bc=al}', "");
    Expect(1, 126720, '\P{Bc=al}', "");
    Expect(0, 126720, '\P{^Bc=al}', "");
    Expect(1, 126719, '\p{Bc=:\Aal\z:}', "");;
    Expect(0, 126720, '\p{Bc=:\Aal\z:}', "");;
    Expect(1, 126719, '\p{Bc=	-AL}', "");
    Expect(0, 126719, '\p{^Bc=	-AL}', "");
    Expect(0, 126719, '\P{Bc=	-AL}', "");
    Expect(1, 126719, '\P{^Bc=	-AL}', "");
    Expect(0, 126720, '\p{Bc=	-AL}', "");
    Expect(1, 126720, '\p{^Bc=	-AL}', "");
    Expect(1, 126720, '\P{Bc=	-AL}', "");
    Expect(0, 126720, '\P{^Bc=	-AL}', "");
    Error('\p{Is_Bidi_Class:   -	Arabic_letter/a/}');
    Error('\P{Is_Bidi_Class:   -	Arabic_letter/a/}');
    Expect(1, 126719, '\p{Is_Bidi_Class=arabicletter}', "");
    Expect(0, 126719, '\p{^Is_Bidi_Class=arabicletter}', "");
    Expect(0, 126719, '\P{Is_Bidi_Class=arabicletter}', "");
    Expect(1, 126719, '\P{^Is_Bidi_Class=arabicletter}', "");
    Expect(0, 126720, '\p{Is_Bidi_Class=arabicletter}', "");
    Expect(1, 126720, '\p{^Is_Bidi_Class=arabicletter}', "");
    Expect(1, 126720, '\P{Is_Bidi_Class=arabicletter}', "");
    Expect(0, 126720, '\P{^Is_Bidi_Class=arabicletter}', "");
    Expect(1, 126719, '\p{Is_Bidi_Class=__Arabic_Letter}', "");
    Expect(0, 126719, '\p{^Is_Bidi_Class=__Arabic_Letter}', "");
    Expect(0, 126719, '\P{Is_Bidi_Class=__Arabic_Letter}', "");
    Expect(1, 126719, '\P{^Is_Bidi_Class=__Arabic_Letter}', "");
    Expect(0, 126720, '\p{Is_Bidi_Class=__Arabic_Letter}', "");
    Expect(1, 126720, '\p{^Is_Bidi_Class=__Arabic_Letter}', "");
    Expect(1, 126720, '\P{Is_Bidi_Class=__Arabic_Letter}', "");
    Expect(0, 126720, '\P{^Is_Bidi_Class=__Arabic_Letter}', "");
    Error('\p{Is_Bc=__AL:=}');
    Error('\P{Is_Bc=__AL:=}');
    Expect(1, 126719, '\p{Is_Bc=al}', "");
    Expect(0, 126719, '\p{^Is_Bc=al}', "");
    Expect(0, 126719, '\P{Is_Bc=al}', "");
    Expect(1, 126719, '\P{^Is_Bc=al}', "");
    Expect(0, 126720, '\p{Is_Bc=al}', "");
    Expect(1, 126720, '\p{^Is_Bc=al}', "");
    Expect(1, 126720, '\P{Is_Bc=al}', "");
    Expect(0, 126720, '\P{^Is_Bc=al}', "");
    Expect(1, 126719, '\p{Is_Bc=_-AL}', "");
    Expect(0, 126719, '\p{^Is_Bc=_-AL}', "");
    Expect(0, 126719, '\P{Is_Bc=_-AL}', "");
    Expect(1, 126719, '\P{^Is_Bc=_-AL}', "");
    Expect(0, 126720, '\p{Is_Bc=_-AL}', "");
    Expect(1, 126720, '\p{^Is_Bc=_-AL}', "");
    Expect(1, 126720, '\P{Is_Bc=_-AL}', "");
    Expect(0, 126720, '\P{^Is_Bc=_-AL}', "");
    Error('\p{Bidi_Class=/a/-_ARABIC_Number}');
    Error('\P{Bidi_Class=/a/-_ARABIC_Number}');
    Expect(1, 69246, '\p{Bidi_Class=:\AArabic_Number\z:}', "");;
    Expect(0, 69247, '\p{Bidi_Class=:\AArabic_Number\z:}', "");;
    Expect(1, 69246, '\p{Bidi_Class=arabicnumber}', "");
    Expect(0, 69246, '\p{^Bidi_Class=arabicnumber}', "");
    Expect(0, 69246, '\P{Bidi_Class=arabicnumber}', "");
    Expect(1, 69246, '\P{^Bidi_Class=arabicnumber}', "");
    Expect(0, 69247, '\p{Bidi_Class=arabicnumber}', "");
    Expect(1, 69247, '\p{^Bidi_Class=arabicnumber}', "");
    Expect(1, 69247, '\P{Bidi_Class=arabicnumber}', "");
    Expect(0, 69247, '\P{^Bidi_Class=arabicnumber}', "");
    Expect(1, 69246, '\p{Bidi_Class=:\Aarabicnumber\z:}', "");;
    Expect(0, 69247, '\p{Bidi_Class=:\Aarabicnumber\z:}', "");;
    Expect(1, 69246, '\p{Bidi_Class=-	Arabic_Number}', "");
    Expect(0, 69246, '\p{^Bidi_Class=-	Arabic_Number}', "");
    Expect(0, 69246, '\P{Bidi_Class=-	Arabic_Number}', "");
    Expect(1, 69246, '\P{^Bidi_Class=-	Arabic_Number}', "");
    Expect(0, 69247, '\p{Bidi_Class=-	Arabic_Number}', "");
    Expect(1, 69247, '\p{^Bidi_Class=-	Arabic_Number}', "");
    Expect(1, 69247, '\P{Bidi_Class=-	Arabic_Number}', "");
    Expect(0, 69247, '\P{^Bidi_Class=-	Arabic_Number}', "");
    Error('\p{Bc: 	an:=}');
    Error('\P{Bc: 	an:=}');
    Expect(1, 69246, '\p{Bc=:\AAN\z:}', "");;
    Expect(0, 69247, '\p{Bc=:\AAN\z:}', "");;
    Expect(1, 69246, '\p{Bc=an}', "");
    Expect(0, 69246, '\p{^Bc=an}', "");
    Expect(0, 69246, '\P{Bc=an}', "");
    Expect(1, 69246, '\P{^Bc=an}', "");
    Expect(0, 69247, '\p{Bc=an}', "");
    Expect(1, 69247, '\p{^Bc=an}', "");
    Expect(1, 69247, '\P{Bc=an}', "");
    Expect(0, 69247, '\P{^Bc=an}', "");
    Expect(1, 69246, '\p{Bc=:\Aan\z:}', "");;
    Expect(0, 69247, '\p{Bc=:\Aan\z:}', "");;
    Expect(1, 69246, '\p{Bc=__AN}', "");
    Expect(0, 69246, '\p{^Bc=__AN}', "");
    Expect(0, 69246, '\P{Bc=__AN}', "");
    Expect(1, 69246, '\P{^Bc=__AN}', "");
    Expect(0, 69247, '\p{Bc=__AN}', "");
    Expect(1, 69247, '\p{^Bc=__AN}', "");
    Expect(1, 69247, '\P{Bc=__AN}', "");
    Expect(0, 69247, '\P{^Bc=__AN}', "");
    Error('\p{Is_Bidi_Class= -ARABIC_Number:=}');
    Error('\P{Is_Bidi_Class= -ARABIC_Number:=}');
    Expect(1, 69246, '\p{Is_Bidi_Class=arabicnumber}', "");
    Expect(0, 69246, '\p{^Is_Bidi_Class=arabicnumber}', "");
    Expect(0, 69246, '\P{Is_Bidi_Class=arabicnumber}', "");
    Expect(1, 69246, '\P{^Is_Bidi_Class=arabicnumber}', "");
    Expect(0, 69247, '\p{Is_Bidi_Class=arabicnumber}', "");
    Expect(1, 69247, '\p{^Is_Bidi_Class=arabicnumber}', "");
    Expect(1, 69247, '\P{Is_Bidi_Class=arabicnumber}', "");
    Expect(0, 69247, '\P{^Is_Bidi_Class=arabicnumber}', "");
    Expect(1, 69246, '\p{Is_Bidi_Class=	 Arabic_Number}', "");
    Expect(0, 69246, '\p{^Is_Bidi_Class=	 Arabic_Number}', "");
    Expect(0, 69246, '\P{Is_Bidi_Class=	 Arabic_Number}', "");
    Expect(1, 69246, '\P{^Is_Bidi_Class=	 Arabic_Number}', "");
    Expect(0, 69247, '\p{Is_Bidi_Class=	 Arabic_Number}', "");
    Expect(1, 69247, '\p{^Is_Bidi_Class=	 Arabic_Number}', "");
    Expect(1, 69247, '\P{Is_Bidi_Class=	 Arabic_Number}', "");
    Expect(0, 69247, '\P{^Is_Bidi_Class=	 Arabic_Number}', "");
    Error('\p{Is_Bc=_AN/a/}');
    Error('\P{Is_Bc=_AN/a/}');
    Expect(1, 69246, '\p{Is_Bc=an}', "");
    Expect(0, 69246, '\p{^Is_Bc=an}', "");
    Expect(0, 69246, '\P{Is_Bc=an}', "");
    Expect(1, 69246, '\P{^Is_Bc=an}', "");
    Expect(0, 69247, '\p{Is_Bc=an}', "");
    Expect(1, 69247, '\p{^Is_Bc=an}', "");
    Expect(1, 69247, '\P{Is_Bc=an}', "");
    Expect(0, 69247, '\P{^Is_Bc=an}', "");
    Expect(1, 69246, '\p{Is_Bc:   	 an}', "");
    Expect(0, 69246, '\p{^Is_Bc:   	 an}', "");
    Expect(0, 69246, '\P{Is_Bc:   	 an}', "");
    Expect(1, 69246, '\P{^Is_Bc:   	 an}', "");
    Expect(0, 69247, '\p{Is_Bc:   	 an}', "");
    Expect(1, 69247, '\p{^Is_Bc:   	 an}', "");
    Expect(1, 69247, '\P{Is_Bc:   	 an}', "");
    Expect(0, 69247, '\P{^Is_Bc:   	 an}', "");
    Error('\p{Bidi_Class=-:=Paragraph_Separator}');
    Error('\P{Bidi_Class=-:=Paragraph_Separator}');
    Expect(1, 8233, '\p{Bidi_Class=:\AParagraph_Separator\z:}', "");;
    Expect(0, 8234, '\p{Bidi_Class=:\AParagraph_Separator\z:}', "");;
    Expect(1, 8233, '\p{Bidi_Class=paragraphseparator}', "");
    Expect(0, 8233, '\p{^Bidi_Class=paragraphseparator}', "");
    Expect(0, 8233, '\P{Bidi_Class=paragraphseparator}', "");
    Expect(1, 8233, '\P{^Bidi_Class=paragraphseparator}', "");
    Expect(0, 8234, '\p{Bidi_Class=paragraphseparator}', "");
    Expect(1, 8234, '\p{^Bidi_Class=paragraphseparator}', "");
    Expect(1, 8234, '\P{Bidi_Class=paragraphseparator}', "");
    Expect(0, 8234, '\P{^Bidi_Class=paragraphseparator}', "");
    Expect(1, 8233, '\p{Bidi_Class=:\Aparagraphseparator\z:}', "");;
    Expect(0, 8234, '\p{Bidi_Class=:\Aparagraphseparator\z:}', "");;
    Expect(1, 8233, '\p{Bidi_Class=_Paragraph_Separator}', "");
    Expect(0, 8233, '\p{^Bidi_Class=_Paragraph_Separator}', "");
    Expect(0, 8233, '\P{Bidi_Class=_Paragraph_Separator}', "");
    Expect(1, 8233, '\P{^Bidi_Class=_Paragraph_Separator}', "");
    Expect(0, 8234, '\p{Bidi_Class=_Paragraph_Separator}', "");
    Expect(1, 8234, '\p{^Bidi_Class=_Paragraph_Separator}', "");
    Expect(1, 8234, '\P{Bidi_Class=_Paragraph_Separator}', "");
    Expect(0, 8234, '\P{^Bidi_Class=_Paragraph_Separator}', "");
    Error('\p{Bc=/a/--b}');
    Error('\P{Bc=/a/--b}');
    Expect(1, 8233, '\p{Bc=:\AB\z:}', "");;
    Expect(0, 8234, '\p{Bc=:\AB\z:}', "");;
    Expect(1, 8233, '\p{Bc=b}', "");
    Expect(0, 8233, '\p{^Bc=b}', "");
    Expect(0, 8233, '\P{Bc=b}', "");
    Expect(1, 8233, '\P{^Bc=b}', "");
    Expect(0, 8234, '\p{Bc=b}', "");
    Expect(1, 8234, '\p{^Bc=b}', "");
    Expect(1, 8234, '\P{Bc=b}', "");
    Expect(0, 8234, '\P{^Bc=b}', "");
    Expect(1, 8233, '\p{Bc=:\Ab\z:}', "");;
    Expect(0, 8234, '\p{Bc=:\Ab\z:}', "");;
    Expect(1, 8233, '\p{Bc=-b}', "");
    Expect(0, 8233, '\p{^Bc=-b}', "");
    Expect(0, 8233, '\P{Bc=-b}', "");
    Expect(1, 8233, '\P{^Bc=-b}', "");
    Expect(0, 8234, '\p{Bc=-b}', "");
    Expect(1, 8234, '\p{^Bc=-b}', "");
    Expect(1, 8234, '\P{Bc=-b}', "");
    Expect(0, 8234, '\P{^Bc=-b}', "");
    Error('\p{Is_Bidi_Class=	:=Paragraph_Separator}');
    Error('\P{Is_Bidi_Class=	:=Paragraph_Separator}');
    Expect(1, 8233, '\p{Is_Bidi_Class=paragraphseparator}', "");
    Expect(0, 8233, '\p{^Is_Bidi_Class=paragraphseparator}', "");
    Expect(0, 8233, '\P{Is_Bidi_Class=paragraphseparator}', "");
    Expect(1, 8233, '\P{^Is_Bidi_Class=paragraphseparator}', "");
    Expect(0, 8234, '\p{Is_Bidi_Class=paragraphseparator}', "");
    Expect(1, 8234, '\p{^Is_Bidi_Class=paragraphseparator}', "");
    Expect(1, 8234, '\P{Is_Bidi_Class=paragraphseparator}', "");
    Expect(0, 8234, '\P{^Is_Bidi_Class=paragraphseparator}', "");
    Expect(1, 8233, '\p{Is_Bidi_Class=	 Paragraph_separator}', "");
    Expect(0, 8233, '\p{^Is_Bidi_Class=	 Paragraph_separator}', "");
    Expect(0, 8233, '\P{Is_Bidi_Class=	 Paragraph_separator}', "");
    Expect(1, 8233, '\P{^Is_Bidi_Class=	 Paragraph_separator}', "");
    Expect(0, 8234, '\p{Is_Bidi_Class=	 Paragraph_separator}', "");
    Expect(1, 8234, '\p{^Is_Bidi_Class=	 Paragraph_separator}', "");
    Expect(1, 8234, '\P{Is_Bidi_Class=	 Paragraph_separator}', "");
    Expect(0, 8234, '\P{^Is_Bidi_Class=	 Paragraph_separator}', "");
    Error('\p{Is_Bc=_/a/B}');
    Error('\P{Is_Bc=_/a/B}');
    Expect(1, 8233, '\p{Is_Bc=b}', "");
    Expect(0, 8233, '\p{^Is_Bc=b}', "");
    Expect(0, 8233, '\P{Is_Bc=b}', "");
    Expect(1, 8233, '\P{^Is_Bc=b}', "");
    Expect(0, 8234, '\p{Is_Bc=b}', "");
    Expect(1, 8234, '\p{^Is_Bc=b}', "");
    Expect(1, 8234, '\P{Is_Bc=b}', "");
    Expect(0, 8234, '\P{^Is_Bc=b}', "");
    Expect(1, 8233, '\p{Is_Bc=		B}', "");
    Expect(0, 8233, '\p{^Is_Bc=		B}', "");
    Expect(0, 8233, '\P{Is_Bc=		B}', "");
    Expect(1, 8233, '\P{^Is_Bc=		B}', "");
    Expect(0, 8234, '\p{Is_Bc=		B}', "");
    Expect(1, 8234, '\p{^Is_Bc=		B}', "");
    Expect(1, 8234, '\P{Is_Bc=		B}', "");
    Expect(0, 8234, '\P{^Is_Bc=		B}', "");
    Error('\p{Bidi_Class=/a/	boundary_Neutral}');
    Error('\P{Bidi_Class=/a/	boundary_Neutral}');
    Expect(1, 921599, '\p{Bidi_Class=:\ABoundary_Neutral\z:}', "");;
    Expect(0, 1114109, '\p{Bidi_Class=:\ABoundary_Neutral\z:}', "");;
    Expect(1, 921599, '\p{Bidi_Class:   boundaryneutral}', "");
    Expect(0, 921599, '\p{^Bidi_Class:   boundaryneutral}', "");
    Expect(0, 921599, '\P{Bidi_Class:   boundaryneutral}', "");
    Expect(1, 921599, '\P{^Bidi_Class:   boundaryneutral}', "");
    Expect(0, 1114109, '\p{Bidi_Class:   boundaryneutral}', "");
    Expect(1, 1114109, '\p{^Bidi_Class:   boundaryneutral}', "");
    Expect(1, 1114109, '\P{Bidi_Class:   boundaryneutral}', "");
    Expect(0, 1114109, '\P{^Bidi_Class:   boundaryneutral}', "");
    Expect(1, 921599, '\p{Bidi_Class=:\Aboundaryneutral\z:}', "");;
    Expect(0, 1114109, '\p{Bidi_Class=:\Aboundaryneutral\z:}', "");;
    Expect(1, 921599, '\p{Bidi_Class=	Boundary_Neutral}', "");
    Expect(0, 921599, '\p{^Bidi_Class=	Boundary_Neutral}', "");
    Expect(0, 921599, '\P{Bidi_Class=	Boundary_Neutral}', "");
    Expect(1, 921599, '\P{^Bidi_Class=	Boundary_Neutral}', "");
    Expect(0, 1114109, '\p{Bidi_Class=	Boundary_Neutral}', "");
    Expect(1, 1114109, '\p{^Bidi_Class=	Boundary_Neutral}', "");
    Expect(1, 1114109, '\P{Bidi_Class=	Boundary_Neutral}', "");
    Expect(0, 1114109, '\P{^Bidi_Class=	Boundary_Neutral}', "");
    Error('\p{Bc=-BN:=}');
    Error('\P{Bc=-BN:=}');
    Expect(1, 921599, '\p{Bc=:\ABN\z:}', "");;
    Expect(0, 1114109, '\p{Bc=:\ABN\z:}', "");;
    Expect(1, 921599, '\p{Bc=bn}', "");
    Expect(0, 921599, '\p{^Bc=bn}', "");
    Expect(0, 921599, '\P{Bc=bn}', "");
    Expect(1, 921599, '\P{^Bc=bn}', "");
    Expect(0, 1114109, '\p{Bc=bn}', "");
    Expect(1, 1114109, '\p{^Bc=bn}', "");
    Expect(1, 1114109, '\P{Bc=bn}', "");
    Expect(0, 1114109, '\P{^Bc=bn}', "");
    Expect(1, 921599, '\p{Bc=:\Abn\z:}', "");;
    Expect(0, 1114109, '\p{Bc=:\Abn\z:}', "");;
    Expect(1, 921599, '\p{Bc= bn}', "");
    Expect(0, 921599, '\p{^Bc= bn}', "");
    Expect(0, 921599, '\P{Bc= bn}', "");
    Expect(1, 921599, '\P{^Bc= bn}', "");
    Expect(0, 1114109, '\p{Bc= bn}', "");
    Expect(1, 1114109, '\p{^Bc= bn}', "");
    Expect(1, 1114109, '\P{Bc= bn}', "");
    Expect(0, 1114109, '\P{^Bc= bn}', "");
    Error('\p{Is_Bidi_Class=-/a/Boundary_neutral}');
    Error('\P{Is_Bidi_Class=-/a/Boundary_neutral}');
    Expect(1, 921599, '\p{Is_Bidi_Class=boundaryneutral}', "");
    Expect(0, 921599, '\p{^Is_Bidi_Class=boundaryneutral}', "");
    Expect(0, 921599, '\P{Is_Bidi_Class=boundaryneutral}', "");
    Expect(1, 921599, '\P{^Is_Bidi_Class=boundaryneutral}', "");
    Expect(0, 1114109, '\p{Is_Bidi_Class=boundaryneutral}', "");
    Expect(1, 1114109, '\p{^Is_Bidi_Class=boundaryneutral}', "");
    Expect(1, 1114109, '\P{Is_Bidi_Class=boundaryneutral}', "");
    Expect(0, 1114109, '\P{^Is_Bidi_Class=boundaryneutral}', "");
    Expect(1, 921599, '\p{Is_Bidi_Class=__boundary_Neutral}', "");
    Expect(0, 921599, '\p{^Is_Bidi_Class=__boundary_Neutral}', "");
    Expect(0, 921599, '\P{Is_Bidi_Class=__boundary_Neutral}', "");
    Expect(1, 921599, '\P{^Is_Bidi_Class=__boundary_Neutral}', "");
    Expect(0, 1114109, '\p{Is_Bidi_Class=__boundary_Neutral}', "");
    Expect(1, 1114109, '\p{^Is_Bidi_Class=__boundary_Neutral}', "");
    Expect(1, 1114109, '\P{Is_Bidi_Class=__boundary_Neutral}', "");
    Expect(0, 1114109, '\P{^Is_Bidi_Class=__boundary_Neutral}', "");
    Error('\p{Is_Bc=/a/bn}');
    Error('\P{Is_Bc=/a/bn}');
    Expect(1, 921599, '\p{Is_Bc=bn}', "");
    Expect(0, 921599, '\p{^Is_Bc=bn}', "");
    Expect(0, 921599, '\P{Is_Bc=bn}', "");
    Expect(1, 921599, '\P{^Is_Bc=bn}', "");
    Expect(0, 1114109, '\p{Is_Bc=bn}', "");
    Expect(1, 1114109, '\p{^Is_Bc=bn}', "");
    Expect(1, 1114109, '\P{Is_Bc=bn}', "");
    Expect(0, 1114109, '\P{^Is_Bc=bn}', "");
    Expect(1, 921599, '\p{Is_Bc=_ BN}', "");
    Expect(0, 921599, '\p{^Is_Bc=_ BN}', "");
    Expect(0, 921599, '\P{Is_Bc=_ BN}', "");
    Expect(1, 921599, '\P{^Is_Bc=_ BN}', "");
    Expect(0, 1114109, '\p{Is_Bc=_ BN}', "");
    Expect(1, 1114109, '\p{^Is_Bc=_ BN}', "");
    Expect(1, 1114109, '\P{Is_Bc=_ BN}', "");
    Expect(0, 1114109, '\P{^Is_Bc=_ BN}', "");
    Error('\p{Bidi_Class=_COMMON_Separator/a/}');
    Error('\P{Bidi_Class=_COMMON_Separator/a/}');
    Expect(1, 65306, '\p{Bidi_Class=:\ACommon_Separator\z:}', "");;
    Expect(0, 65307, '\p{Bidi_Class=:\ACommon_Separator\z:}', "");;
    Expect(1, 65306, '\p{Bidi_Class=commonseparator}', "");
    Expect(0, 65306, '\p{^Bidi_Class=commonseparator}', "");
    Expect(0, 65306, '\P{Bidi_Class=commonseparator}', "");
    Expect(1, 65306, '\P{^Bidi_Class=commonseparator}', "");
    Expect(0, 65307, '\p{Bidi_Class=commonseparator}', "");
    Expect(1, 65307, '\p{^Bidi_Class=commonseparator}', "");
    Expect(1, 65307, '\P{Bidi_Class=commonseparator}', "");
    Expect(0, 65307, '\P{^Bidi_Class=commonseparator}', "");
    Expect(1, 65306, '\p{Bidi_Class=:\Acommonseparator\z:}', "");;
    Expect(0, 65307, '\p{Bidi_Class=:\Acommonseparator\z:}', "");;
    Expect(1, 65306, '\p{Bidi_Class=-	common_Separator}', "");
    Expect(0, 65306, '\p{^Bidi_Class=-	common_Separator}', "");
    Expect(0, 65306, '\P{Bidi_Class=-	common_Separator}', "");
    Expect(1, 65306, '\P{^Bidi_Class=-	common_Separator}', "");
    Expect(0, 65307, '\p{Bidi_Class=-	common_Separator}', "");
    Expect(1, 65307, '\p{^Bidi_Class=-	common_Separator}', "");
    Expect(1, 65307, '\P{Bidi_Class=-	common_Separator}', "");
    Expect(0, 65307, '\P{^Bidi_Class=-	common_Separator}', "");
    Error('\p{Bc=_-cs:=}');
    Error('\P{Bc=_-cs:=}');
    Expect(1, 65306, '\p{Bc=:\ACS\z:}', "");;
    Expect(0, 65307, '\p{Bc=:\ACS\z:}', "");;
    Expect(1, 65306, '\p{Bc=cs}', "");
    Expect(0, 65306, '\p{^Bc=cs}', "");
    Expect(0, 65306, '\P{Bc=cs}', "");
    Expect(1, 65306, '\P{^Bc=cs}', "");
    Expect(0, 65307, '\p{Bc=cs}', "");
    Expect(1, 65307, '\p{^Bc=cs}', "");
    Expect(1, 65307, '\P{Bc=cs}', "");
    Expect(0, 65307, '\P{^Bc=cs}', "");
    Expect(1, 65306, '\p{Bc=:\Acs\z:}', "");;
    Expect(0, 65307, '\p{Bc=:\Acs\z:}', "");;
    Expect(1, 65306, '\p{Bc=		cs}', "");
    Expect(0, 65306, '\p{^Bc=		cs}', "");
    Expect(0, 65306, '\P{Bc=		cs}', "");
    Expect(1, 65306, '\P{^Bc=		cs}', "");
    Expect(0, 65307, '\p{Bc=		cs}', "");
    Expect(1, 65307, '\p{^Bc=		cs}', "");
    Expect(1, 65307, '\P{Bc=		cs}', "");
    Expect(0, 65307, '\P{^Bc=		cs}', "");
    Error('\p{Is_Bidi_Class:-/a/Common_Separator}');
    Error('\P{Is_Bidi_Class:-/a/Common_Separator}');
    Expect(1, 65306, '\p{Is_Bidi_Class=commonseparator}', "");
    Expect(0, 65306, '\p{^Is_Bidi_Class=commonseparator}', "");
    Expect(0, 65306, '\P{Is_Bidi_Class=commonseparator}', "");
    Expect(1, 65306, '\P{^Is_Bidi_Class=commonseparator}', "");
    Expect(0, 65307, '\p{Is_Bidi_Class=commonseparator}', "");
    Expect(1, 65307, '\p{^Is_Bidi_Class=commonseparator}', "");
    Expect(1, 65307, '\P{Is_Bidi_Class=commonseparator}', "");
    Expect(0, 65307, '\P{^Is_Bidi_Class=commonseparator}', "");
    Expect(1, 65306, '\p{Is_Bidi_Class=	-COMMON_Separator}', "");
    Expect(0, 65306, '\p{^Is_Bidi_Class=	-COMMON_Separator}', "");
    Expect(0, 65306, '\P{Is_Bidi_Class=	-COMMON_Separator}', "");
    Expect(1, 65306, '\P{^Is_Bidi_Class=	-COMMON_Separator}', "");
    Expect(0, 65307, '\p{Is_Bidi_Class=	-COMMON_Separator}', "");
    Expect(1, 65307, '\p{^Is_Bidi_Class=	-COMMON_Separator}', "");
    Expect(1, 65307, '\P{Is_Bidi_Class=	-COMMON_Separator}', "");
    Expect(0, 65307, '\P{^Is_Bidi_Class=	-COMMON_Separator}', "");
    Error('\p{Is_Bc:		:=cs}');
    Error('\P{Is_Bc:		:=cs}');
    Expect(1, 65306, '\p{Is_Bc=cs}', "");
    Expect(0, 65306, '\p{^Is_Bc=cs}', "");
    Expect(0, 65306, '\P{Is_Bc=cs}', "");
    Expect(1, 65306, '\P{^Is_Bc=cs}', "");
    Expect(0, 65307, '\p{Is_Bc=cs}', "");
    Expect(1, 65307, '\p{^Is_Bc=cs}', "");
    Expect(1, 65307, '\P{Is_Bc=cs}', "");
    Expect(0, 65307, '\P{^Is_Bc=cs}', "");
    Expect(1, 65306, '\p{Is_Bc=-_CS}', "");
    Expect(0, 65306, '\p{^Is_Bc=-_CS}', "");
    Expect(0, 65306, '\P{Is_Bc=-_CS}', "");
    Expect(1, 65306, '\P{^Is_Bc=-_CS}', "");
    Expect(0, 65307, '\p{Is_Bc=-_CS}', "");
    Expect(1, 65307, '\p{^Is_Bc=-_CS}', "");
    Expect(1, 65307, '\P{Is_Bc=-_CS}', "");
    Expect(0, 65307, '\P{^Is_Bc=-_CS}', "");
    Error('\p{Bidi_Class::=		European_number}');
    Error('\P{Bidi_Class::=		European_number}');
    Expect(1, 130041, '\p{Bidi_Class=:\AEuropean_Number\z:}', "");;
    Expect(0, 130042, '\p{Bidi_Class=:\AEuropean_Number\z:}', "");;
    Expect(1, 130041, '\p{Bidi_Class=europeannumber}', "");
    Expect(0, 130041, '\p{^Bidi_Class=europeannumber}', "");
    Expect(0, 130041, '\P{Bidi_Class=europeannumber}', "");
    Expect(1, 130041, '\P{^Bidi_Class=europeannumber}', "");
    Expect(0, 130042, '\p{Bidi_Class=europeannumber}', "");
    Expect(1, 130042, '\p{^Bidi_Class=europeannumber}', "");
    Expect(1, 130042, '\P{Bidi_Class=europeannumber}', "");
    Expect(0, 130042, '\P{^Bidi_Class=europeannumber}', "");
    Expect(1, 130041, '\p{Bidi_Class=:\Aeuropeannumber\z:}', "");;
    Expect(0, 130042, '\p{Bidi_Class=:\Aeuropeannumber\z:}', "");;
    Expect(1, 130041, '\p{Bidi_Class=- EUROPEAN_NUMBER}', "");
    Expect(0, 130041, '\p{^Bidi_Class=- EUROPEAN_NUMBER}', "");
    Expect(0, 130041, '\P{Bidi_Class=- EUROPEAN_NUMBER}', "");
    Expect(1, 130041, '\P{^Bidi_Class=- EUROPEAN_NUMBER}', "");
    Expect(0, 130042, '\p{Bidi_Class=- EUROPEAN_NUMBER}', "");
    Expect(1, 130042, '\p{^Bidi_Class=- EUROPEAN_NUMBER}', "");
    Expect(1, 130042, '\P{Bidi_Class=- EUROPEAN_NUMBER}', "");
    Expect(0, 130042, '\P{^Bidi_Class=- EUROPEAN_NUMBER}', "");
    Error('\p{Bc=	:=EN}');
    Error('\P{Bc=	:=EN}');
    Expect(1, 130041, '\p{Bc=:\AEN\z:}', "");;
    Expect(0, 130042, '\p{Bc=:\AEN\z:}', "");;
    Expect(1, 130041, '\p{Bc=en}', "");
    Expect(0, 130041, '\p{^Bc=en}', "");
    Expect(0, 130041, '\P{Bc=en}', "");
    Expect(1, 130041, '\P{^Bc=en}', "");
    Expect(0, 130042, '\p{Bc=en}', "");
    Expect(1, 130042, '\p{^Bc=en}', "");
    Expect(1, 130042, '\P{Bc=en}', "");
    Expect(0, 130042, '\P{^Bc=en}', "");
    Expect(1, 130041, '\p{Bc=:\Aen\z:}', "");;
    Expect(0, 130042, '\p{Bc=:\Aen\z:}', "");;
    Expect(1, 130041, '\p{Bc=-EN}', "");
    Expect(0, 130041, '\p{^Bc=-EN}', "");
    Expect(0, 130041, '\P{Bc=-EN}', "");
    Expect(1, 130041, '\P{^Bc=-EN}', "");
    Expect(0, 130042, '\p{Bc=-EN}', "");
    Expect(1, 130042, '\p{^Bc=-EN}', "");
    Expect(1, 130042, '\P{Bc=-EN}', "");
    Expect(0, 130042, '\P{^Bc=-EN}', "");
    Error('\p{Is_Bidi_Class=:= 	european_number}');
    Error('\P{Is_Bidi_Class=:= 	european_number}');
    Expect(1, 130041, '\p{Is_Bidi_Class=europeannumber}', "");
    Expect(0, 130041, '\p{^Is_Bidi_Class=europeannumber}', "");
    Expect(0, 130041, '\P{Is_Bidi_Class=europeannumber}', "");
    Expect(1, 130041, '\P{^Is_Bidi_Class=europeannumber}', "");
    Expect(0, 130042, '\p{Is_Bidi_Class=europeannumber}', "");
    Expect(1, 130042, '\p{^Is_Bidi_Class=europeannumber}', "");
    Expect(1, 130042, '\P{Is_Bidi_Class=europeannumber}', "");
    Expect(0, 130042, '\P{^Is_Bidi_Class=europeannumber}', "");
    Expect(1, 130041, '\p{Is_Bidi_Class=_ european_Number}', "");
    Expect(0, 130041, '\p{^Is_Bidi_Class=_ european_Number}', "");
    Expect(0, 130041, '\P{Is_Bidi_Class=_ european_Number}', "");
    Expect(1, 130041, '\P{^Is_Bidi_Class=_ european_Number}', "");
    Expect(0, 130042, '\p{Is_Bidi_Class=_ european_Number}', "");
    Expect(1, 130042, '\p{^Is_Bidi_Class=_ european_Number}', "");
    Expect(1, 130042, '\P{Is_Bidi_Class=_ european_Number}', "");
    Expect(0, 130042, '\P{^Is_Bidi_Class=_ european_Number}', "");
    Error('\p{Is_Bc=-:=EN}');
    Error('\P{Is_Bc=-:=EN}');
    Expect(1, 130041, '\p{Is_Bc=en}', "");
    Expect(0, 130041, '\p{^Is_Bc=en}', "");
    Expect(0, 130041, '\P{Is_Bc=en}', "");
    Expect(1, 130041, '\P{^Is_Bc=en}', "");
    Expect(0, 130042, '\p{Is_Bc=en}', "");
    Expect(1, 130042, '\p{^Is_Bc=en}', "");
    Expect(1, 130042, '\P{Is_Bc=en}', "");
    Expect(0, 130042, '\P{^Is_Bc=en}', "");
    Expect(1, 130041, '\p{Is_Bc:-EN}', "");
    Expect(0, 130041, '\p{^Is_Bc:-EN}', "");
    Expect(0, 130041, '\P{Is_Bc:-EN}', "");
    Expect(1, 130041, '\P{^Is_Bc:-EN}', "");
    Expect(0, 130042, '\p{Is_Bc:-EN}', "");
    Expect(1, 130042, '\p{^Is_Bc:-EN}', "");
    Expect(1, 130042, '\P{Is_Bc:-EN}', "");
    Expect(0, 130042, '\P{^Is_Bc:-EN}', "");
    Error('\p{Bidi_Class=/a/--European_Separator}');
    Error('\P{Bidi_Class=/a/--European_Separator}');
    Expect(1, 65293, '\p{Bidi_Class=:\AEuropean_Separator\z:}', "");;
    Expect(0, 65294, '\p{Bidi_Class=:\AEuropean_Separator\z:}', "");;
    Expect(1, 65293, '\p{Bidi_Class=europeanseparator}', "");
    Expect(0, 65293, '\p{^Bidi_Class=europeanseparator}', "");
    Expect(0, 65293, '\P{Bidi_Class=europeanseparator}', "");
    Expect(1, 65293, '\P{^Bidi_Class=europeanseparator}', "");
    Expect(0, 65294, '\p{Bidi_Class=europeanseparator}', "");
    Expect(1, 65294, '\p{^Bidi_Class=europeanseparator}', "");
    Expect(1, 65294, '\P{Bidi_Class=europeanseparator}', "");
    Expect(0, 65294, '\P{^Bidi_Class=europeanseparator}', "");
    Expect(1, 65293, '\p{Bidi_Class=:\Aeuropeanseparator\z:}', "");;
    Expect(0, 65294, '\p{Bidi_Class=:\Aeuropeanseparator\z:}', "");;
    Expect(1, 65293, '\p{Bidi_Class=_European_Separator}', "");
    Expect(0, 65293, '\p{^Bidi_Class=_European_Separator}', "");
    Expect(0, 65293, '\P{Bidi_Class=_European_Separator}', "");
    Expect(1, 65293, '\P{^Bidi_Class=_European_Separator}', "");
    Expect(0, 65294, '\p{Bidi_Class=_European_Separator}', "");
    Expect(1, 65294, '\p{^Bidi_Class=_European_Separator}', "");
    Expect(1, 65294, '\P{Bidi_Class=_European_Separator}', "");
    Expect(0, 65294, '\P{^Bidi_Class=_European_Separator}', "");
    Error('\p{Bc= ES/a/}');
    Error('\P{Bc= ES/a/}');
    Expect(1, 65293, '\p{Bc=:\AES\z:}', "");;
    Expect(0, 65294, '\p{Bc=:\AES\z:}', "");;
    Expect(1, 65293, '\p{Bc=es}', "");
    Expect(0, 65293, '\p{^Bc=es}', "");
    Expect(0, 65293, '\P{Bc=es}', "");
    Expect(1, 65293, '\P{^Bc=es}', "");
    Expect(0, 65294, '\p{Bc=es}', "");
    Expect(1, 65294, '\p{^Bc=es}', "");
    Expect(1, 65294, '\P{Bc=es}', "");
    Expect(0, 65294, '\P{^Bc=es}', "");
    Expect(1, 65293, '\p{Bc=:\Aes\z:}', "");;
    Expect(0, 65294, '\p{Bc=:\Aes\z:}', "");;
    Expect(1, 65293, '\p{Bc=_ES}', "");
    Expect(0, 65293, '\p{^Bc=_ES}', "");
    Expect(0, 65293, '\P{Bc=_ES}', "");
    Expect(1, 65293, '\P{^Bc=_ES}', "");
    Expect(0, 65294, '\p{Bc=_ES}', "");
    Expect(1, 65294, '\p{^Bc=_ES}', "");
    Expect(1, 65294, '\P{Bc=_ES}', "");
    Expect(0, 65294, '\P{^Bc=_ES}', "");
    Error('\p{Is_Bidi_Class=- European_Separator/a/}');
    Error('\P{Is_Bidi_Class=- European_Separator/a/}');
    Expect(1, 65293, '\p{Is_Bidi_Class=europeanseparator}', "");
    Expect(0, 65293, '\p{^Is_Bidi_Class=europeanseparator}', "");
    Expect(0, 65293, '\P{Is_Bidi_Class=europeanseparator}', "");
    Expect(1, 65293, '\P{^Is_Bidi_Class=europeanseparator}', "");
    Expect(0, 65294, '\p{Is_Bidi_Class=europeanseparator}', "");
    Expect(1, 65294, '\p{^Is_Bidi_Class=europeanseparator}', "");
    Expect(1, 65294, '\P{Is_Bidi_Class=europeanseparator}', "");
    Expect(0, 65294, '\P{^Is_Bidi_Class=europeanseparator}', "");
    Expect(1, 65293, '\p{Is_Bidi_Class:   	-EUROPEAN_Separator}', "");
    Expect(0, 65293, '\p{^Is_Bidi_Class:   	-EUROPEAN_Separator}', "");
    Expect(0, 65293, '\P{Is_Bidi_Class:   	-EUROPEAN_Separator}', "");
    Expect(1, 65293, '\P{^Is_Bidi_Class:   	-EUROPEAN_Separator}', "");
    Expect(0, 65294, '\p{Is_Bidi_Class:   	-EUROPEAN_Separator}', "");
    Expect(1, 65294, '\p{^Is_Bidi_Class:   	-EUROPEAN_Separator}', "");
    Expect(1, 65294, '\P{Is_Bidi_Class:   	-EUROPEAN_Separator}', "");
    Expect(0, 65294, '\P{^Is_Bidi_Class:   	-EUROPEAN_Separator}', "");
    Error('\p{Is_Bc=-/a/ES}');
    Error('\P{Is_Bc=-/a/ES}');
    Expect(1, 65293, '\p{Is_Bc=es}', "");
    Expect(0, 65293, '\p{^Is_Bc=es}', "");
    Expect(0, 65293, '\P{Is_Bc=es}', "");
    Expect(1, 65293, '\P{^Is_Bc=es}', "");
    Expect(0, 65294, '\p{Is_Bc=es}', "");
    Expect(1, 65294, '\p{^Is_Bc=es}', "");
    Expect(1, 65294, '\P{Is_Bc=es}', "");
    Expect(0, 65294, '\P{^Is_Bc=es}', "");
    Expect(1, 65293, '\p{Is_Bc=- ES}', "");
    Expect(0, 65293, '\p{^Is_Bc=- ES}', "");
    Expect(0, 65293, '\P{Is_Bc=- ES}', "");
    Expect(1, 65293, '\P{^Is_Bc=- ES}', "");
    Expect(0, 65294, '\p{Is_Bc=- ES}', "");
    Expect(1, 65294, '\p{^Is_Bc=- ES}', "");
    Expect(1, 65294, '\P{Is_Bc=- ES}', "");
    Expect(0, 65294, '\P{^Is_Bc=- ES}', "");
    Error('\p{Bidi_Class=_European_TERMINATOR:=}');
    Error('\P{Bidi_Class=_European_TERMINATOR:=}');
    Expect(1, 123647, '\p{Bidi_Class=:\AEuropean_Terminator\z:}', "");;
    Expect(0, 123648, '\p{Bidi_Class=:\AEuropean_Terminator\z:}', "");;
    Expect(1, 123647, '\p{Bidi_Class=europeanterminator}', "");
    Expect(0, 123647, '\p{^Bidi_Class=europeanterminator}', "");
    Expect(0, 123647, '\P{Bidi_Class=europeanterminator}', "");
    Expect(1, 123647, '\P{^Bidi_Class=europeanterminator}', "");
    Expect(0, 123648, '\p{Bidi_Class=europeanterminator}', "");
    Expect(1, 123648, '\p{^Bidi_Class=europeanterminator}', "");
    Expect(1, 123648, '\P{Bidi_Class=europeanterminator}', "");
    Expect(0, 123648, '\P{^Bidi_Class=europeanterminator}', "");
    Expect(1, 123647, '\p{Bidi_Class=:\Aeuropeanterminator\z:}', "");;
    Expect(0, 123648, '\p{Bidi_Class=:\Aeuropeanterminator\z:}', "");;
    Expect(1, 123647, '\p{Bidi_Class:	_	European_Terminator}', "");
    Expect(0, 123647, '\p{^Bidi_Class:	_	European_Terminator}', "");
    Expect(0, 123647, '\P{Bidi_Class:	_	European_Terminator}', "");
    Expect(1, 123647, '\P{^Bidi_Class:	_	European_Terminator}', "");
    Expect(0, 123648, '\p{Bidi_Class:	_	European_Terminator}', "");
    Expect(1, 123648, '\p{^Bidi_Class:	_	European_Terminator}', "");
    Expect(1, 123648, '\P{Bidi_Class:	_	European_Terminator}', "");
    Expect(0, 123648, '\P{^Bidi_Class:	_	European_Terminator}', "");
    Error('\p{Bc=:=__ET}');
    Error('\P{Bc=:=__ET}');
    Expect(1, 123647, '\p{Bc=:\AET\z:}', "");;
    Expect(0, 123648, '\p{Bc=:\AET\z:}', "");;
    Expect(1, 123647, '\p{Bc=et}', "");
    Expect(0, 123647, '\p{^Bc=et}', "");
    Expect(0, 123647, '\P{Bc=et}', "");
    Expect(1, 123647, '\P{^Bc=et}', "");
    Expect(0, 123648, '\p{Bc=et}', "");
    Expect(1, 123648, '\p{^Bc=et}', "");
    Expect(1, 123648, '\P{Bc=et}', "");
    Expect(0, 123648, '\P{^Bc=et}', "");
    Expect(1, 123647, '\p{Bc=:\Aet\z:}', "");;
    Expect(0, 123648, '\p{Bc=:\Aet\z:}', "");;
    Expect(1, 123647, '\p{Bc=-ET}', "");
    Expect(0, 123647, '\p{^Bc=-ET}', "");
    Expect(0, 123647, '\P{Bc=-ET}', "");
    Expect(1, 123647, '\P{^Bc=-ET}', "");
    Expect(0, 123648, '\p{Bc=-ET}', "");
    Expect(1, 123648, '\p{^Bc=-ET}', "");
    Expect(1, 123648, '\P{Bc=-ET}', "");
    Expect(0, 123648, '\P{^Bc=-ET}', "");
    Error('\p{Is_Bidi_Class=_:=European_terminator}');
    Error('\P{Is_Bidi_Class=_:=European_terminator}');
    Expect(1, 123647, '\p{Is_Bidi_Class=europeanterminator}', "");
    Expect(0, 123647, '\p{^Is_Bidi_Class=europeanterminator}', "");
    Expect(0, 123647, '\P{Is_Bidi_Class=europeanterminator}', "");
    Expect(1, 123647, '\P{^Is_Bidi_Class=europeanterminator}', "");
    Expect(0, 123648, '\p{Is_Bidi_Class=europeanterminator}', "");
    Expect(1, 123648, '\p{^Is_Bidi_Class=europeanterminator}', "");
    Expect(1, 123648, '\P{Is_Bidi_Class=europeanterminator}', "");
    Expect(0, 123648, '\P{^Is_Bidi_Class=europeanterminator}', "");
    Expect(1, 123647, '\p{Is_Bidi_Class= European_terminator}', "");
    Expect(0, 123647, '\p{^Is_Bidi_Class= European_terminator}', "");
    Expect(0, 123647, '\P{Is_Bidi_Class= European_terminator}', "");
    Expect(1, 123647, '\P{^Is_Bidi_Class= European_terminator}', "");
    Expect(0, 123648, '\p{Is_Bidi_Class= European_terminator}', "");
    Expect(1, 123648, '\p{^Is_Bidi_Class= European_terminator}', "");
    Expect(1, 123648, '\P{Is_Bidi_Class= European_terminator}', "");
    Expect(0, 123648, '\P{^Is_Bidi_Class= European_terminator}', "");
    Error('\p{Is_Bc=:=ET}');
    Error('\P{Is_Bc=:=ET}');
    Expect(1, 123647, '\p{Is_Bc=et}', "");
    Expect(0, 123647, '\p{^Is_Bc=et}', "");
    Expect(0, 123647, '\P{Is_Bc=et}', "");
    Expect(1, 123647, '\P{^Is_Bc=et}', "");
    Expect(0, 123648, '\p{Is_Bc=et}', "");
    Expect(1, 123648, '\p{^Is_Bc=et}', "");
    Expect(1, 123648, '\P{Is_Bc=et}', "");
    Expect(0, 123648, '\P{^Is_Bc=et}', "");
    Expect(1, 123647, '\p{Is_Bc: _	et}', "");
    Expect(0, 123647, '\p{^Is_Bc: _	et}', "");
    Expect(0, 123647, '\P{Is_Bc: _	et}', "");
    Expect(1, 123647, '\P{^Is_Bc: _	et}', "");
    Expect(0, 123648, '\p{Is_Bc: _	et}', "");
    Expect(1, 123648, '\p{^Is_Bc: _	et}', "");
    Expect(1, 123648, '\P{Is_Bc: _	et}', "");
    Expect(0, 123648, '\P{^Is_Bc: _	et}', "");
    Error('\p{Bidi_Class: _:=First_Strong_Isolate}');
    Error('\P{Bidi_Class: _:=First_Strong_Isolate}');
    Expect(1, 8296, '\p{Bidi_Class=:\AFirst_Strong_Isolate\z:}', "");;
    Expect(0, 8297, '\p{Bidi_Class=:\AFirst_Strong_Isolate\z:}', "");;
    Expect(1, 8296, '\p{Bidi_Class=firststrongisolate}', "");
    Expect(0, 8296, '\p{^Bidi_Class=firststrongisolate}', "");
    Expect(0, 8296, '\P{Bidi_Class=firststrongisolate}', "");
    Expect(1, 8296, '\P{^Bidi_Class=firststrongisolate}', "");
    Expect(0, 8297, '\p{Bidi_Class=firststrongisolate}', "");
    Expect(1, 8297, '\p{^Bidi_Class=firststrongisolate}', "");
    Expect(1, 8297, '\P{Bidi_Class=firststrongisolate}', "");
    Expect(0, 8297, '\P{^Bidi_Class=firststrongisolate}', "");
    Expect(1, 8296, '\p{Bidi_Class=:\Afirststrongisolate\z:}', "");;
    Expect(0, 8297, '\p{Bidi_Class=:\Afirststrongisolate\z:}', "");;
    Expect(1, 8296, '\p{Bidi_Class=_First_strong_Isolate}', "");
    Expect(0, 8296, '\p{^Bidi_Class=_First_strong_Isolate}', "");
    Expect(0, 8296, '\P{Bidi_Class=_First_strong_Isolate}', "");
    Expect(1, 8296, '\P{^Bidi_Class=_First_strong_Isolate}', "");
    Expect(0, 8297, '\p{Bidi_Class=_First_strong_Isolate}', "");
    Expect(1, 8297, '\p{^Bidi_Class=_First_strong_Isolate}', "");
    Expect(1, 8297, '\P{Bidi_Class=_First_strong_Isolate}', "");
    Expect(0, 8297, '\P{^Bidi_Class=_First_strong_Isolate}', "");
    Error('\p{Bc:  -FSI/a/}');
    Error('\P{Bc:  -FSI/a/}');
    Expect(1, 8296, '\p{Bc=:\AFSI\z:}', "");;
    Expect(0, 8297, '\p{Bc=:\AFSI\z:}', "");;
    Expect(1, 8296, '\p{Bc=fsi}', "");
    Expect(0, 8296, '\p{^Bc=fsi}', "");
    Expect(0, 8296, '\P{Bc=fsi}', "");
    Expect(1, 8296, '\P{^Bc=fsi}', "");
    Expect(0, 8297, '\p{Bc=fsi}', "");
    Expect(1, 8297, '\p{^Bc=fsi}', "");
    Expect(1, 8297, '\P{Bc=fsi}', "");
    Expect(0, 8297, '\P{^Bc=fsi}', "");
    Expect(1, 8296, '\p{Bc=:\Afsi\z:}', "");;
    Expect(0, 8297, '\p{Bc=:\Afsi\z:}', "");;
    Expect(1, 8296, '\p{Bc=	 FSI}', "");
    Expect(0, 8296, '\p{^Bc=	 FSI}', "");
    Expect(0, 8296, '\P{Bc=	 FSI}', "");
    Expect(1, 8296, '\P{^Bc=	 FSI}', "");
    Expect(0, 8297, '\p{Bc=	 FSI}', "");
    Expect(1, 8297, '\p{^Bc=	 FSI}', "");
    Expect(1, 8297, '\P{Bc=	 FSI}', "");
    Expect(0, 8297, '\P{^Bc=	 FSI}', "");
    Error('\p{Is_Bidi_Class=-/a/first_Strong_Isolate}');
    Error('\P{Is_Bidi_Class=-/a/first_Strong_Isolate}');
    Expect(1, 8296, '\p{Is_Bidi_Class=firststrongisolate}', "");
    Expect(0, 8296, '\p{^Is_Bidi_Class=firststrongisolate}', "");
    Expect(0, 8296, '\P{Is_Bidi_Class=firststrongisolate}', "");
    Expect(1, 8296, '\P{^Is_Bidi_Class=firststrongisolate}', "");
    Expect(0, 8297, '\p{Is_Bidi_Class=firststrongisolate}', "");
    Expect(1, 8297, '\p{^Is_Bidi_Class=firststrongisolate}', "");
    Expect(1, 8297, '\P{Is_Bidi_Class=firststrongisolate}', "");
    Expect(0, 8297, '\P{^Is_Bidi_Class=firststrongisolate}', "");
    Expect(1, 8296, '\p{Is_Bidi_Class=  First_STRONG_Isolate}', "");
    Expect(0, 8296, '\p{^Is_Bidi_Class=  First_STRONG_Isolate}', "");
    Expect(0, 8296, '\P{Is_Bidi_Class=  First_STRONG_Isolate}', "");
    Expect(1, 8296, '\P{^Is_Bidi_Class=  First_STRONG_Isolate}', "");
    Expect(0, 8297, '\p{Is_Bidi_Class=  First_STRONG_Isolate}', "");
    Expect(1, 8297, '\p{^Is_Bidi_Class=  First_STRONG_Isolate}', "");
    Expect(1, 8297, '\P{Is_Bidi_Class=  First_STRONG_Isolate}', "");
    Expect(0, 8297, '\P{^Is_Bidi_Class=  First_STRONG_Isolate}', "");
    Error('\p{Is_Bc=	/a/FSI}');
    Error('\P{Is_Bc=	/a/FSI}');
    Expect(1, 8296, '\p{Is_Bc=fsi}', "");
    Expect(0, 8296, '\p{^Is_Bc=fsi}', "");
    Expect(0, 8296, '\P{Is_Bc=fsi}', "");
    Expect(1, 8296, '\P{^Is_Bc=fsi}', "");
    Expect(0, 8297, '\p{Is_Bc=fsi}', "");
    Expect(1, 8297, '\p{^Is_Bc=fsi}', "");
    Expect(1, 8297, '\P{Is_Bc=fsi}', "");
    Expect(0, 8297, '\P{^Is_Bc=fsi}', "");
    Expect(1, 8296, '\p{Is_Bc=	FSI}', "");
    Expect(0, 8296, '\p{^Is_Bc=	FSI}', "");
    Expect(0, 8296, '\P{Is_Bc=	FSI}', "");
    Expect(1, 8296, '\P{^Is_Bc=	FSI}', "");
    Expect(0, 8297, '\p{Is_Bc=	FSI}', "");
    Expect(1, 8297, '\p{^Is_Bc=	FSI}', "");
    Expect(1, 8297, '\P{Is_Bc=	FSI}', "");
    Expect(0, 8297, '\P{^Is_Bc=	FSI}', "");
    Error('\p{Bidi_Class=	/a/Left_TO_Right}');
    Error('\P{Bidi_Class=	/a/Left_TO_Right}');
    Expect(1, 1114109, '\p{Bidi_Class=:\ALeft_To_Right\z:}', "");;
    Expect(0, 921599, '\p{Bidi_Class=:\ALeft_To_Right\z:}', "");;
    Expect(1, 1114109, '\p{Bidi_Class=lefttoright}', "");
    Expect(0, 1114109, '\p{^Bidi_Class=lefttoright}', "");
    Expect(0, 1114109, '\P{Bidi_Class=lefttoright}', "");
    Expect(1, 1114109, '\P{^Bidi_Class=lefttoright}', "");
    Expect(0, 921599, '\p{Bidi_Class=lefttoright}', "");
    Expect(1, 921599, '\p{^Bidi_Class=lefttoright}', "");
    Expect(1, 921599, '\P{Bidi_Class=lefttoright}', "");
    Expect(0, 921599, '\P{^Bidi_Class=lefttoright}', "");
    Expect(1, 1114109, '\p{Bidi_Class=:\Alefttoright\z:}', "");;
    Expect(0, 921599, '\p{Bidi_Class=:\Alefttoright\z:}', "");;
    Expect(1, 1114109, '\p{Bidi_Class=_-Left_TO_Right}', "");
    Expect(0, 1114109, '\p{^Bidi_Class=_-Left_TO_Right}', "");
    Expect(0, 1114109, '\P{Bidi_Class=_-Left_TO_Right}', "");
    Expect(1, 1114109, '\P{^Bidi_Class=_-Left_TO_Right}', "");
    Expect(0, 921599, '\p{Bidi_Class=_-Left_TO_Right}', "");
    Expect(1, 921599, '\p{^Bidi_Class=_-Left_TO_Right}', "");
    Expect(1, 921599, '\P{Bidi_Class=_-Left_TO_Right}', "");
    Expect(0, 921599, '\P{^Bidi_Class=_-Left_TO_Right}', "");
    Error('\p{Bc=	/a/l}');
    Error('\P{Bc=	/a/l}');
    Expect(1, 1114109, '\p{Bc=:\AL\z:}', "");;
    Expect(0, 921599, '\p{Bc=:\AL\z:}', "");;
    Expect(1, 1114109, '\p{Bc=l}', "");
    Expect(0, 1114109, '\p{^Bc=l}', "");
    Expect(0, 1114109, '\P{Bc=l}', "");
    Expect(1, 1114109, '\P{^Bc=l}', "");
    Expect(0, 921599, '\p{Bc=l}', "");
    Expect(1, 921599, '\p{^Bc=l}', "");
    Expect(1, 921599, '\P{Bc=l}', "");
    Expect(0, 921599, '\P{^Bc=l}', "");
    Expect(1, 1114109, '\p{Bc=:\Al\z:}', "");;
    Expect(0, 921599, '\p{Bc=:\Al\z:}', "");;
    Expect(1, 1114109, '\p{Bc:   - L}', "");
    Expect(0, 1114109, '\p{^Bc:   - L}', "");
    Expect(0, 1114109, '\P{Bc:   - L}', "");
    Expect(1, 1114109, '\P{^Bc:   - L}', "");
    Expect(0, 921599, '\p{Bc:   - L}', "");
    Expect(1, 921599, '\p{^Bc:   - L}', "");
    Expect(1, 921599, '\P{Bc:   - L}', "");
    Expect(0, 921599, '\P{^Bc:   - L}', "");
    Error('\p{Is_Bidi_Class=	/a/Left_To_right}');
    Error('\P{Is_Bidi_Class=	/a/Left_To_right}');
    Expect(1, 1114109, '\p{Is_Bidi_Class=lefttoright}', "");
    Expect(0, 1114109, '\p{^Is_Bidi_Class=lefttoright}', "");
    Expect(0, 1114109, '\P{Is_Bidi_Class=lefttoright}', "");
    Expect(1, 1114109, '\P{^Is_Bidi_Class=lefttoright}', "");
    Expect(0, 921599, '\p{Is_Bidi_Class=lefttoright}', "");
    Expect(1, 921599, '\p{^Is_Bidi_Class=lefttoright}', "");
    Expect(1, 921599, '\P{Is_Bidi_Class=lefttoright}', "");
    Expect(0, 921599, '\P{^Is_Bidi_Class=lefttoright}', "");
    Expect(1, 1114109, '\p{Is_Bidi_Class=	LEFT_TO_Right}', "");
    Expect(0, 1114109, '\p{^Is_Bidi_Class=	LEFT_TO_Right}', "");
    Expect(0, 1114109, '\P{Is_Bidi_Class=	LEFT_TO_Right}', "");
    Expect(1, 1114109, '\P{^Is_Bidi_Class=	LEFT_TO_Right}', "");
    Expect(0, 921599, '\p{Is_Bidi_Class=	LEFT_TO_Right}', "");
    Expect(1, 921599, '\p{^Is_Bidi_Class=	LEFT_TO_Right}', "");
    Expect(1, 921599, '\P{Is_Bidi_Class=	LEFT_TO_Right}', "");
    Expect(0, 921599, '\P{^Is_Bidi_Class=	LEFT_TO_Right}', "");
    Error('\p{Is_Bc=_/a/L}');
    Error('\P{Is_Bc=_/a/L}');
    Expect(1, 1114109, '\p{Is_Bc=l}', "");
    Expect(0, 1114109, '\p{^Is_Bc=l}', "");
    Expect(0, 1114109, '\P{Is_Bc=l}', "");
    Expect(1, 1114109, '\P{^Is_Bc=l}', "");
    Expect(0, 921599, '\p{Is_Bc=l}', "");
    Expect(1, 921599, '\p{^Is_Bc=l}', "");
    Expect(1, 921599, '\P{Is_Bc=l}', "");
    Expect(0, 921599, '\P{^Is_Bc=l}', "");
    Expect(1, 1114109, '\p{Is_Bc=	L}', "");
    Expect(0, 1114109, '\p{^Is_Bc=	L}', "");
    Expect(0, 1114109, '\P{Is_Bc=	L}', "");
    Expect(1, 1114109, '\P{^Is_Bc=	L}', "");
    Expect(0, 921599, '\p{Is_Bc=	L}', "");
    Expect(1, 921599, '\p{^Is_Bc=	L}', "");
    Expect(1, 921599, '\P{Is_Bc=	L}', "");
    Expect(0, 921599, '\P{^Is_Bc=	L}', "");
    Error('\p{Bidi_Class:   /a/-left_to_Right_Embedding}');
    Error('\P{Bidi_Class:   /a/-left_to_Right_Embedding}');
    Expect(1, 8234, '\p{Bidi_Class=:\ALeft_To_Right_Embedding\z:}', "");;
    Expect(0, 8235, '\p{Bidi_Class=:\ALeft_To_Right_Embedding\z:}', "");;
    Expect(1, 8234, '\p{Bidi_Class=lefttorightembedding}', "");
    Expect(0, 8234, '\p{^Bidi_Class=lefttorightembedding}', "");
    Expect(0, 8234, '\P{Bidi_Class=lefttorightembedding}', "");
    Expect(1, 8234, '\P{^Bidi_Class=lefttorightembedding}', "");
    Expect(0, 8235, '\p{Bidi_Class=lefttorightembedding}', "");
    Expect(1, 8235, '\p{^Bidi_Class=lefttorightembedding}', "");
    Expect(1, 8235, '\P{Bidi_Class=lefttorightembedding}', "");
    Expect(0, 8235, '\P{^Bidi_Class=lefttorightembedding}', "");
    Expect(1, 8234, '\p{Bidi_Class=:\Alefttorightembedding\z:}', "");;
    Expect(0, 8235, '\p{Bidi_Class=:\Alefttorightembedding\z:}', "");;
    Expect(1, 8234, '\p{Bidi_Class= _left_To_RIGHT_EMBEDDING}', "");
    Expect(0, 8234, '\p{^Bidi_Class= _left_To_RIGHT_EMBEDDING}', "");
    Expect(0, 8234, '\P{Bidi_Class= _left_To_RIGHT_EMBEDDING}', "");
    Expect(1, 8234, '\P{^Bidi_Class= _left_To_RIGHT_EMBEDDING}', "");
    Expect(0, 8235, '\p{Bidi_Class= _left_To_RIGHT_EMBEDDING}', "");
    Expect(1, 8235, '\p{^Bidi_Class= _left_To_RIGHT_EMBEDDING}', "");
    Expect(1, 8235, '\P{Bidi_Class= _left_To_RIGHT_EMBEDDING}', "");
    Expect(0, 8235, '\P{^Bidi_Class= _left_To_RIGHT_EMBEDDING}', "");
    Error('\p{Bc= :=LRE}');
    Error('\P{Bc= :=LRE}');
    Expect(1, 8234, '\p{Bc=:\ALRE\z:}', "");;
    Expect(0, 8235, '\p{Bc=:\ALRE\z:}', "");;
    Expect(1, 8234, '\p{Bc=lre}', "");
    Expect(0, 8234, '\p{^Bc=lre}', "");
    Expect(0, 8234, '\P{Bc=lre}', "");
    Expect(1, 8234, '\P{^Bc=lre}', "");
    Expect(0, 8235, '\p{Bc=lre}', "");
    Expect(1, 8235, '\p{^Bc=lre}', "");
    Expect(1, 8235, '\P{Bc=lre}', "");
    Expect(0, 8235, '\P{^Bc=lre}', "");
    Expect(1, 8234, '\p{Bc=:\Alre\z:}', "");;
    Expect(0, 8235, '\p{Bc=:\Alre\z:}', "");;
    Expect(1, 8234, '\p{Bc=_ LRE}', "");
    Expect(0, 8234, '\p{^Bc=_ LRE}', "");
    Expect(0, 8234, '\P{Bc=_ LRE}', "");
    Expect(1, 8234, '\P{^Bc=_ LRE}', "");
    Expect(0, 8235, '\p{Bc=_ LRE}', "");
    Expect(1, 8235, '\p{^Bc=_ LRE}', "");
    Expect(1, 8235, '\P{Bc=_ LRE}', "");
    Expect(0, 8235, '\P{^Bc=_ LRE}', "");
    Error('\p{Is_Bidi_Class=/a/LEFT_To_RIGHT_embedding}');
    Error('\P{Is_Bidi_Class=/a/LEFT_To_RIGHT_embedding}');
    Expect(1, 8234, '\p{Is_Bidi_Class=lefttorightembedding}', "");
    Expect(0, 8234, '\p{^Is_Bidi_Class=lefttorightembedding}', "");
    Expect(0, 8234, '\P{Is_Bidi_Class=lefttorightembedding}', "");
    Expect(1, 8234, '\P{^Is_Bidi_Class=lefttorightembedding}', "");
    Expect(0, 8235, '\p{Is_Bidi_Class=lefttorightembedding}', "");
    Expect(1, 8235, '\p{^Is_Bidi_Class=lefttorightembedding}', "");
    Expect(1, 8235, '\P{Is_Bidi_Class=lefttorightembedding}', "");
    Expect(0, 8235, '\P{^Is_Bidi_Class=lefttorightembedding}', "");
    Expect(1, 8234, '\p{Is_Bidi_Class=_Left_To_Right_Embedding}', "");
    Expect(0, 8234, '\p{^Is_Bidi_Class=_Left_To_Right_Embedding}', "");
    Expect(0, 8234, '\P{Is_Bidi_Class=_Left_To_Right_Embedding}', "");
    Expect(1, 8234, '\P{^Is_Bidi_Class=_Left_To_Right_Embedding}', "");
    Expect(0, 8235, '\p{Is_Bidi_Class=_Left_To_Right_Embedding}', "");
    Expect(1, 8235, '\p{^Is_Bidi_Class=_Left_To_Right_Embedding}', "");
    Expect(1, 8235, '\P{Is_Bidi_Class=_Left_To_Right_Embedding}', "");
    Expect(0, 8235, '\P{^Is_Bidi_Class=_Left_To_Right_Embedding}', "");
    Error('\p{Is_Bc: _:=LRE}');
    Error('\P{Is_Bc: _:=LRE}');
    Expect(1, 8234, '\p{Is_Bc=lre}', "");
    Expect(0, 8234, '\p{^Is_Bc=lre}', "");
    Expect(0, 8234, '\P{Is_Bc=lre}', "");
    Expect(1, 8234, '\P{^Is_Bc=lre}', "");
    Expect(0, 8235, '\p{Is_Bc=lre}', "");
    Expect(1, 8235, '\p{^Is_Bc=lre}', "");
    Expect(1, 8235, '\P{Is_Bc=lre}', "");
    Expect(0, 8235, '\P{^Is_Bc=lre}', "");
    Expect(1, 8234, '\p{Is_Bc= _lre}', "");
    Expect(0, 8234, '\p{^Is_Bc= _lre}', "");
    Expect(0, 8234, '\P{Is_Bc= _lre}', "");
    Expect(1, 8234, '\P{^Is_Bc= _lre}', "");
    Expect(0, 8235, '\p{Is_Bc= _lre}', "");
    Expect(1, 8235, '\p{^Is_Bc= _lre}', "");
    Expect(1, 8235, '\P{Is_Bc= _lre}', "");
    Expect(0, 8235, '\P{^Is_Bc= _lre}', "");
    Error('\p{Bidi_Class=-:=left_To_right_ISOLATE}');
    Error('\P{Bidi_Class=-:=left_To_right_ISOLATE}');
    Expect(1, 8294, '\p{Bidi_Class=:\ALeft_To_Right_Isolate\z:}', "");;
    Expect(0, 8295, '\p{Bidi_Class=:\ALeft_To_Right_Isolate\z:}', "");;
    Expect(1, 8294, '\p{Bidi_Class=lefttorightisolate}', "");
    Expect(0, 8294, '\p{^Bidi_Class=lefttorightisolate}', "");
    Expect(0, 8294, '\P{Bidi_Class=lefttorightisolate}', "");
    Expect(1, 8294, '\P{^Bidi_Class=lefttorightisolate}', "");
    Expect(0, 8295, '\p{Bidi_Class=lefttorightisolate}', "");
    Expect(1, 8295, '\p{^Bidi_Class=lefttorightisolate}', "");
    Expect(1, 8295, '\P{Bidi_Class=lefttorightisolate}', "");
    Expect(0, 8295, '\P{^Bidi_Class=lefttorightisolate}', "");
    Expect(1, 8294, '\p{Bidi_Class=:\Alefttorightisolate\z:}', "");;
    Expect(0, 8295, '\p{Bidi_Class=:\Alefttorightisolate\z:}', "");;
    Expect(1, 8294, '\p{Bidi_Class=_-Left_To_RIGHT_ISOLATE}', "");
    Expect(0, 8294, '\p{^Bidi_Class=_-Left_To_RIGHT_ISOLATE}', "");
    Expect(0, 8294, '\P{Bidi_Class=_-Left_To_RIGHT_ISOLATE}', "");
    Expect(1, 8294, '\P{^Bidi_Class=_-Left_To_RIGHT_ISOLATE}', "");
    Expect(0, 8295, '\p{Bidi_Class=_-Left_To_RIGHT_ISOLATE}', "");
    Expect(1, 8295, '\p{^Bidi_Class=_-Left_To_RIGHT_ISOLATE}', "");
    Expect(1, 8295, '\P{Bidi_Class=_-Left_To_RIGHT_ISOLATE}', "");
    Expect(0, 8295, '\P{^Bidi_Class=_-Left_To_RIGHT_ISOLATE}', "");
    Error('\p{Bc=:= -LRI}');
    Error('\P{Bc=:= -LRI}');
    Expect(1, 8294, '\p{Bc=:\ALRI\z:}', "");;
    Expect(0, 8295, '\p{Bc=:\ALRI\z:}', "");;
    Expect(1, 8294, '\p{Bc=lri}', "");
    Expect(0, 8294, '\p{^Bc=lri}', "");
    Expect(0, 8294, '\P{Bc=lri}', "");
    Expect(1, 8294, '\P{^Bc=lri}', "");
    Expect(0, 8295, '\p{Bc=lri}', "");
    Expect(1, 8295, '\p{^Bc=lri}', "");
    Expect(1, 8295, '\P{Bc=lri}', "");
    Expect(0, 8295, '\P{^Bc=lri}', "");
    Expect(1, 8294, '\p{Bc=:\Alri\z:}', "");;
    Expect(0, 8295, '\p{Bc=:\Alri\z:}', "");;
    Expect(1, 8294, '\p{Bc= _lri}', "");
    Expect(0, 8294, '\p{^Bc= _lri}', "");
    Expect(0, 8294, '\P{Bc= _lri}', "");
    Expect(1, 8294, '\P{^Bc= _lri}', "");
    Expect(0, 8295, '\p{Bc= _lri}', "");
    Expect(1, 8295, '\p{^Bc= _lri}', "");
    Expect(1, 8295, '\P{Bc= _lri}', "");
    Expect(0, 8295, '\P{^Bc= _lri}', "");
    Error('\p{Is_Bidi_Class=-/a/LEFT_TO_right_ISOLATE}');
    Error('\P{Is_Bidi_Class=-/a/LEFT_TO_right_ISOLATE}');
    Expect(1, 8294, '\p{Is_Bidi_Class=lefttorightisolate}', "");
    Expect(0, 8294, '\p{^Is_Bidi_Class=lefttorightisolate}', "");
    Expect(0, 8294, '\P{Is_Bidi_Class=lefttorightisolate}', "");
    Expect(1, 8294, '\P{^Is_Bidi_Class=lefttorightisolate}', "");
    Expect(0, 8295, '\p{Is_Bidi_Class=lefttorightisolate}', "");
    Expect(1, 8295, '\p{^Is_Bidi_Class=lefttorightisolate}', "");
    Expect(1, 8295, '\P{Is_Bidi_Class=lefttorightisolate}', "");
    Expect(0, 8295, '\P{^Is_Bidi_Class=lefttorightisolate}', "");
    Expect(1, 8294, '\p{Is_Bidi_Class=_LEFT_to_Right_Isolate}', "");
    Expect(0, 8294, '\p{^Is_Bidi_Class=_LEFT_to_Right_Isolate}', "");
    Expect(0, 8294, '\P{Is_Bidi_Class=_LEFT_to_Right_Isolate}', "");
    Expect(1, 8294, '\P{^Is_Bidi_Class=_LEFT_to_Right_Isolate}', "");
    Expect(0, 8295, '\p{Is_Bidi_Class=_LEFT_to_Right_Isolate}', "");
    Expect(1, 8295, '\p{^Is_Bidi_Class=_LEFT_to_Right_Isolate}', "");
    Expect(1, 8295, '\P{Is_Bidi_Class=_LEFT_to_Right_Isolate}', "");
    Expect(0, 8295, '\P{^Is_Bidi_Class=_LEFT_to_Right_Isolate}', "");
    Error('\p{Is_Bc=_:=lri}');
    Error('\P{Is_Bc=_:=lri}');
    Expect(1, 8294, '\p{Is_Bc=lri}', "");
    Expect(0, 8294, '\p{^Is_Bc=lri}', "");
    Expect(0, 8294, '\P{Is_Bc=lri}', "");
    Expect(1, 8294, '\P{^Is_Bc=lri}', "");
    Expect(0, 8295, '\p{Is_Bc=lri}', "");
    Expect(1, 8295, '\p{^Is_Bc=lri}', "");
    Expect(1, 8295, '\P{Is_Bc=lri}', "");
    Expect(0, 8295, '\P{^Is_Bc=lri}', "");
    Expect(1, 8294, '\p{Is_Bc= 	LRI}', "");
    Expect(0, 8294, '\p{^Is_Bc= 	LRI}', "");
    Expect(0, 8294, '\P{Is_Bc= 	LRI}', "");
    Expect(1, 8294, '\P{^Is_Bc= 	LRI}', "");
    Expect(0, 8295, '\p{Is_Bc= 	LRI}', "");
    Expect(1, 8295, '\p{^Is_Bc= 	LRI}', "");
    Expect(1, 8295, '\P{Is_Bc= 	LRI}', "");
    Expect(0, 8295, '\P{^Is_Bc= 	LRI}', "");
    Error('\p{Bidi_Class=/a/__Left_TO_RIGHT_Override}');
    Error('\P{Bidi_Class=/a/__Left_TO_RIGHT_Override}');
    Expect(1, 8237, '\p{Bidi_Class=:\ALeft_To_Right_Override\z:}', "");;
    Expect(0, 8238, '\p{Bidi_Class=:\ALeft_To_Right_Override\z:}', "");;
    Expect(1, 8237, '\p{Bidi_Class=lefttorightoverride}', "");
    Expect(0, 8237, '\p{^Bidi_Class=lefttorightoverride}', "");
    Expect(0, 8237, '\P{Bidi_Class=lefttorightoverride}', "");
    Expect(1, 8237, '\P{^Bidi_Class=lefttorightoverride}', "");
    Expect(0, 8238, '\p{Bidi_Class=lefttorightoverride}', "");
    Expect(1, 8238, '\p{^Bidi_Class=lefttorightoverride}', "");
    Expect(1, 8238, '\P{Bidi_Class=lefttorightoverride}', "");
    Expect(0, 8238, '\P{^Bidi_Class=lefttorightoverride}', "");
    Expect(1, 8237, '\p{Bidi_Class=:\Alefttorightoverride\z:}', "");;
    Expect(0, 8238, '\p{Bidi_Class=:\Alefttorightoverride\z:}', "");;
    Expect(1, 8237, '\p{Bidi_Class=	Left_TO_Right_override}', "");
    Expect(0, 8237, '\p{^Bidi_Class=	Left_TO_Right_override}', "");
    Expect(0, 8237, '\P{Bidi_Class=	Left_TO_Right_override}', "");
    Expect(1, 8237, '\P{^Bidi_Class=	Left_TO_Right_override}', "");
    Expect(0, 8238, '\p{Bidi_Class=	Left_TO_Right_override}', "");
    Expect(1, 8238, '\p{^Bidi_Class=	Left_TO_Right_override}', "");
    Expect(1, 8238, '\P{Bidi_Class=	Left_TO_Right_override}', "");
    Expect(0, 8238, '\P{^Bidi_Class=	Left_TO_Right_override}', "");
    Error('\p{Bc=	/a/LRO}');
    Error('\P{Bc=	/a/LRO}');
    Expect(1, 8237, '\p{Bc=:\ALRO\z:}', "");;
    Expect(0, 8238, '\p{Bc=:\ALRO\z:}', "");;
    Expect(1, 8237, '\p{Bc=lro}', "");
    Expect(0, 8237, '\p{^Bc=lro}', "");
    Expect(0, 8237, '\P{Bc=lro}', "");
    Expect(1, 8237, '\P{^Bc=lro}', "");
    Expect(0, 8238, '\p{Bc=lro}', "");
    Expect(1, 8238, '\p{^Bc=lro}', "");
    Expect(1, 8238, '\P{Bc=lro}', "");
    Expect(0, 8238, '\P{^Bc=lro}', "");
    Expect(1, 8237, '\p{Bc=:\Alro\z:}', "");;
    Expect(0, 8238, '\p{Bc=:\Alro\z:}', "");;
    Expect(1, 8237, '\p{Bc= -lro}', "");
    Expect(0, 8237, '\p{^Bc= -lro}', "");
    Expect(0, 8237, '\P{Bc= -lro}', "");
    Expect(1, 8237, '\P{^Bc= -lro}', "");
    Expect(0, 8238, '\p{Bc= -lro}', "");
    Expect(1, 8238, '\p{^Bc= -lro}', "");
    Expect(1, 8238, '\P{Bc= -lro}', "");
    Expect(0, 8238, '\P{^Bc= -lro}', "");
    Error('\p{Is_Bidi_Class=_/a/LEFT_to_Right_Override}');
    Error('\P{Is_Bidi_Class=_/a/LEFT_to_Right_Override}');
    Expect(1, 8237, '\p{Is_Bidi_Class=lefttorightoverride}', "");
    Expect(0, 8237, '\p{^Is_Bidi_Class=lefttorightoverride}', "");
    Expect(0, 8237, '\P{Is_Bidi_Class=lefttorightoverride}', "");
    Expect(1, 8237, '\P{^Is_Bidi_Class=lefttorightoverride}', "");
    Expect(0, 8238, '\p{Is_Bidi_Class=lefttorightoverride}', "");
    Expect(1, 8238, '\p{^Is_Bidi_Class=lefttorightoverride}', "");
    Expect(1, 8238, '\P{Is_Bidi_Class=lefttorightoverride}', "");
    Expect(0, 8238, '\P{^Is_Bidi_Class=lefttorightoverride}', "");
    Expect(1, 8237, '\p{Is_Bidi_Class=LEFT_to_right_OVERRIDE}', "");
    Expect(0, 8237, '\p{^Is_Bidi_Class=LEFT_to_right_OVERRIDE}', "");
    Expect(0, 8237, '\P{Is_Bidi_Class=LEFT_to_right_OVERRIDE}', "");
    Expect(1, 8237, '\P{^Is_Bidi_Class=LEFT_to_right_OVERRIDE}', "");
    Expect(0, 8238, '\p{Is_Bidi_Class=LEFT_to_right_OVERRIDE}', "");
    Expect(1, 8238, '\p{^Is_Bidi_Class=LEFT_to_right_OVERRIDE}', "");
    Expect(1, 8238, '\P{Is_Bidi_Class=LEFT_to_right_OVERRIDE}', "");
    Expect(0, 8238, '\P{^Is_Bidi_Class=LEFT_to_right_OVERRIDE}', "");
    Error('\p{Is_Bc:	/a/lro}');
    Error('\P{Is_Bc:	/a/lro}');
    Expect(1, 8237, '\p{Is_Bc:   lro}', "");
    Expect(0, 8237, '\p{^Is_Bc:   lro}', "");
    Expect(0, 8237, '\P{Is_Bc:   lro}', "");
    Expect(1, 8237, '\P{^Is_Bc:   lro}', "");
    Expect(0, 8238, '\p{Is_Bc:   lro}', "");
    Expect(1, 8238, '\p{^Is_Bc:   lro}', "");
    Expect(1, 8238, '\P{Is_Bc:   lro}', "");
    Expect(0, 8238, '\P{^Is_Bc:   lro}', "");
    Error('\p{Bidi_Class=-NONSPACING_Mark/a/}');
    Error('\P{Bidi_Class=-NONSPACING_Mark/a/}');
    Expect(1, 917999, '\p{Bidi_Class=:\ANonspacing_Mark\z:}', "");;
    Expect(0, 918000, '\p{Bidi_Class=:\ANonspacing_Mark\z:}', "");;
    Expect(1, 917999, '\p{Bidi_Class=nonspacingmark}', "");
    Expect(0, 917999, '\p{^Bidi_Class=nonspacingmark}', "");
    Expect(0, 917999, '\P{Bidi_Class=nonspacingmark}', "");
    Expect(1, 917999, '\P{^Bidi_Class=nonspacingmark}', "");
    Expect(0, 918000, '\p{Bidi_Class=nonspacingmark}', "");
    Expect(1, 918000, '\p{^Bidi_Class=nonspacingmark}', "");
    Expect(1, 918000, '\P{Bidi_Class=nonspacingmark}', "");
    Expect(0, 918000, '\P{^Bidi_Class=nonspacingmark}', "");
    Expect(1, 917999, '\p{Bidi_Class=:\Anonspacingmark\z:}', "");;
    Expect(0, 918000, '\p{Bidi_Class=:\Anonspacingmark\z:}', "");;
    Expect(1, 917999, '\p{Bidi_Class=		nonspacing_mark}', "");
    Expect(0, 917999, '\p{^Bidi_Class=		nonspacing_mark}', "");
    Expect(0, 917999, '\P{Bidi_Class=		nonspacing_mark}', "");
    Expect(1, 917999, '\P{^Bidi_Class=		nonspacing_mark}', "");
    Expect(0, 918000, '\p{Bidi_Class=		nonspacing_mark}', "");
    Expect(1, 918000, '\p{^Bidi_Class=		nonspacing_mark}', "");
    Expect(1, 918000, '\P{Bidi_Class=		nonspacing_mark}', "");
    Expect(0, 918000, '\P{^Bidi_Class=		nonspacing_mark}', "");
    Error('\p{Bc=- nsm:=}');
    Error('\P{Bc=- nsm:=}');
    Expect(1, 917999, '\p{Bc=:\ANSM\z:}', "");;
    Expect(0, 918000, '\p{Bc=:\ANSM\z:}', "");;
    Expect(1, 917999, '\p{Bc=nsm}', "");
    Expect(0, 917999, '\p{^Bc=nsm}', "");
    Expect(0, 917999, '\P{Bc=nsm}', "");
    Expect(1, 917999, '\P{^Bc=nsm}', "");
    Expect(0, 918000, '\p{Bc=nsm}', "");
    Expect(1, 918000, '\p{^Bc=nsm}', "");
    Expect(1, 918000, '\P{Bc=nsm}', "");
    Expect(0, 918000, '\P{^Bc=nsm}', "");
    Expect(1, 917999, '\p{Bc=:\Ansm\z:}', "");;
    Expect(0, 918000, '\p{Bc=:\Ansm\z:}', "");;
    Expect(1, 917999, '\p{Bc=_ NSM}', "");
    Expect(0, 917999, '\p{^Bc=_ NSM}', "");
    Expect(0, 917999, '\P{Bc=_ NSM}', "");
    Expect(1, 917999, '\P{^Bc=_ NSM}', "");
    Expect(0, 918000, '\p{Bc=_ NSM}', "");
    Expect(1, 918000, '\p{^Bc=_ NSM}', "");
    Expect(1, 918000, '\P{Bc=_ NSM}', "");
    Expect(0, 918000, '\P{^Bc=_ NSM}', "");
    Error('\p{Is_Bidi_Class=/a/-nonspacing_Mark}');
    Error('\P{Is_Bidi_Class=/a/-nonspacing_Mark}');
    Expect(1, 917999, '\p{Is_Bidi_Class=nonspacingmark}', "");
    Expect(0, 917999, '\p{^Is_Bidi_Class=nonspacingmark}', "");
    Expect(0, 917999, '\P{Is_Bidi_Class=nonspacingmark}', "");
    Expect(1, 917999, '\P{^Is_Bidi_Class=nonspacingmark}', "");
    Expect(0, 918000, '\p{Is_Bidi_Class=nonspacingmark}', "");
    Expect(1, 918000, '\p{^Is_Bidi_Class=nonspacingmark}', "");
    Expect(1, 918000, '\P{Is_Bidi_Class=nonspacingmark}', "");
    Expect(0, 918000, '\P{^Is_Bidi_Class=nonspacingmark}', "");
    Expect(1, 917999, '\p{Is_Bidi_Class=-Nonspacing_mark}', "");
    Expect(0, 917999, '\p{^Is_Bidi_Class=-Nonspacing_mark}', "");
    Expect(0, 917999, '\P{Is_Bidi_Class=-Nonspacing_mark}', "");
    Expect(1, 917999, '\P{^Is_Bidi_Class=-Nonspacing_mark}', "");
    Expect(0, 918000, '\p{Is_Bidi_Class=-Nonspacing_mark}', "");
    Expect(1, 918000, '\p{^Is_Bidi_Class=-Nonspacing_mark}', "");
    Expect(1, 918000, '\P{Is_Bidi_Class=-Nonspacing_mark}', "");
    Expect(0, 918000, '\P{^Is_Bidi_Class=-Nonspacing_mark}', "");
    Error('\p{Is_Bc= nsm:=}');
    Error('\P{Is_Bc= nsm:=}');
    Expect(1, 917999, '\p{Is_Bc=nsm}', "");
    Expect(0, 917999, '\p{^Is_Bc=nsm}', "");
    Expect(0, 917999, '\P{Is_Bc=nsm}', "");
    Expect(1, 917999, '\P{^Is_Bc=nsm}', "");
    Expect(0, 918000, '\p{Is_Bc=nsm}', "");
    Expect(1, 918000, '\p{^Is_Bc=nsm}', "");
    Expect(1, 918000, '\P{Is_Bc=nsm}', "");
    Expect(0, 918000, '\P{^Is_Bc=nsm}', "");
    Expect(1, 917999, '\p{Is_Bc= NSM}', "");
    Expect(0, 917999, '\p{^Is_Bc= NSM}', "");
    Expect(0, 917999, '\P{Is_Bc= NSM}', "");
    Expect(1, 917999, '\P{^Is_Bc= NSM}', "");
    Expect(0, 918000, '\p{Is_Bc= NSM}', "");
    Expect(1, 918000, '\p{^Is_Bc= NSM}', "");
    Expect(1, 918000, '\P{Is_Bc= NSM}', "");
    Expect(0, 918000, '\P{^Is_Bc= NSM}', "");
    Error('\p{Bidi_Class=:=Other_Neutral}');
    Error('\P{Bidi_Class=:=Other_Neutral}');
    Expect(1, 129994, '\p{Bidi_Class=:\AOther_Neutral\z:}', "");;
    Expect(0, 129995, '\p{Bidi_Class=:\AOther_Neutral\z:}', "");;
    Expect(1, 129994, '\p{Bidi_Class=otherneutral}', "");
    Expect(0, 129994, '\p{^Bidi_Class=otherneutral}', "");
    Expect(0, 129994, '\P{Bidi_Class=otherneutral}', "");
    Expect(1, 129994, '\P{^Bidi_Class=otherneutral}', "");
    Expect(0, 129995, '\p{Bidi_Class=otherneutral}', "");
    Expect(1, 129995, '\p{^Bidi_Class=otherneutral}', "");
    Expect(1, 129995, '\P{Bidi_Class=otherneutral}', "");
    Expect(0, 129995, '\P{^Bidi_Class=otherneutral}', "");
    Expect(1, 129994, '\p{Bidi_Class=:\Aotherneutral\z:}', "");;
    Expect(0, 129995, '\p{Bidi_Class=:\Aotherneutral\z:}', "");;
    Expect(1, 129994, '\p{Bidi_Class=-Other_Neutral}', "");
    Expect(0, 129994, '\p{^Bidi_Class=-Other_Neutral}', "");
    Expect(0, 129994, '\P{Bidi_Class=-Other_Neutral}', "");
    Expect(1, 129994, '\P{^Bidi_Class=-Other_Neutral}', "");
    Expect(0, 129995, '\p{Bidi_Class=-Other_Neutral}', "");
    Expect(1, 129995, '\p{^Bidi_Class=-Other_Neutral}', "");
    Expect(1, 129995, '\P{Bidi_Class=-Other_Neutral}', "");
    Expect(0, 129995, '\P{^Bidi_Class=-Other_Neutral}', "");
    Error('\p{Bc=-ON/a/}');
    Error('\P{Bc=-ON/a/}');
    Expect(1, 129994, '\p{Bc=:\AON\z:}', "");;
    Expect(0, 129995, '\p{Bc=:\AON\z:}', "");;
    Expect(1, 129994, '\p{Bc=on}', "");
    Expect(0, 129994, '\p{^Bc=on}', "");
    Expect(0, 129994, '\P{Bc=on}', "");
    Expect(1, 129994, '\P{^Bc=on}', "");
    Expect(0, 129995, '\p{Bc=on}', "");
    Expect(1, 129995, '\p{^Bc=on}', "");
    Expect(1, 129995, '\P{Bc=on}', "");
    Expect(0, 129995, '\P{^Bc=on}', "");
    Expect(1, 129994, '\p{Bc=:\Aon\z:}', "");;
    Expect(0, 129995, '\p{Bc=:\Aon\z:}', "");;
    Expect(1, 129994, '\p{Bc=_-on}', "");
    Expect(0, 129994, '\p{^Bc=_-on}', "");
    Expect(0, 129994, '\P{Bc=_-on}', "");
    Expect(1, 129994, '\P{^Bc=_-on}', "");
    Expect(0, 129995, '\p{Bc=_-on}', "");
    Expect(1, 129995, '\p{^Bc=_-on}', "");
    Expect(1, 129995, '\P{Bc=_-on}', "");
    Expect(0, 129995, '\P{^Bc=_-on}', "");
    Error('\p{Is_Bidi_Class=:=-	OTHER_Neutral}');
    Error('\P{Is_Bidi_Class=:=-	OTHER_Neutral}');
    Expect(1, 129994, '\p{Is_Bidi_Class=otherneutral}', "");
    Expect(0, 129994, '\p{^Is_Bidi_Class=otherneutral}', "");
    Expect(0, 129994, '\P{Is_Bidi_Class=otherneutral}', "");
    Expect(1, 129994, '\P{^Is_Bidi_Class=otherneutral}', "");
    Expect(0, 129995, '\p{Is_Bidi_Class=otherneutral}', "");
    Expect(1, 129995, '\p{^Is_Bidi_Class=otherneutral}', "");
    Expect(1, 129995, '\P{Is_Bidi_Class=otherneutral}', "");
    Expect(0, 129995, '\P{^Is_Bidi_Class=otherneutral}', "");
    Expect(1, 129994, '\p{Is_Bidi_Class=--Other_Neutral}', "");
    Expect(0, 129994, '\p{^Is_Bidi_Class=--Other_Neutral}', "");
    Expect(0, 129994, '\P{Is_Bidi_Class=--Other_Neutral}', "");
    Expect(1, 129994, '\P{^Is_Bidi_Class=--Other_Neutral}', "");
    Expect(0, 129995, '\p{Is_Bidi_Class=--Other_Neutral}', "");
    Expect(1, 129995, '\p{^Is_Bidi_Class=--Other_Neutral}', "");
    Expect(1, 129995, '\P{Is_Bidi_Class=--Other_Neutral}', "");
    Expect(0, 129995, '\P{^Is_Bidi_Class=--Other_Neutral}', "");
    Error('\p{Is_Bc=:=- ON}');
    Error('\P{Is_Bc=:=- ON}');
    Expect(1, 129994, '\p{Is_Bc=on}', "");
    Expect(0, 129994, '\p{^Is_Bc=on}', "");
    Expect(0, 129994, '\P{Is_Bc=on}', "");
    Expect(1, 129994, '\P{^Is_Bc=on}', "");
    Expect(0, 129995, '\p{Is_Bc=on}', "");
    Expect(1, 129995, '\p{^Is_Bc=on}', "");
    Expect(1, 129995, '\P{Is_Bc=on}', "");
    Expect(0, 129995, '\P{^Is_Bc=on}', "");
    Expect(1, 129994, '\p{Is_Bc:- ON}', "");
    Expect(0, 129994, '\p{^Is_Bc:- ON}', "");
    Expect(0, 129994, '\P{Is_Bc:- ON}', "");
    Expect(1, 129994, '\P{^Is_Bc:- ON}', "");
    Expect(0, 129995, '\p{Is_Bc:- ON}', "");
    Expect(1, 129995, '\p{^Is_Bc:- ON}', "");
    Expect(1, 129995, '\P{Is_Bc:- ON}', "");
    Expect(0, 129995, '\P{^Is_Bc:- ON}', "");
    Error('\p{Bidi_Class=/a/--pop_Directional_Format}');
    Error('\P{Bidi_Class=/a/--pop_Directional_Format}');
    Expect(1, 8236, '\p{Bidi_Class=:\APop_Directional_Format\z:}', "");;
    Expect(0, 8237, '\p{Bidi_Class=:\APop_Directional_Format\z:}', "");;
    Expect(1, 8236, '\p{Bidi_Class=popdirectionalformat}', "");
    Expect(0, 8236, '\p{^Bidi_Class=popdirectionalformat}', "");
    Expect(0, 8236, '\P{Bidi_Class=popdirectionalformat}', "");
    Expect(1, 8236, '\P{^Bidi_Class=popdirectionalformat}', "");
    Expect(0, 8237, '\p{Bidi_Class=popdirectionalformat}', "");
    Expect(1, 8237, '\p{^Bidi_Class=popdirectionalformat}', "");
    Expect(1, 8237, '\P{Bidi_Class=popdirectionalformat}', "");
    Expect(0, 8237, '\P{^Bidi_Class=popdirectionalformat}', "");
    Expect(1, 8236, '\p{Bidi_Class=:\Apopdirectionalformat\z:}', "");;
    Expect(0, 8237, '\p{Bidi_Class=:\Apopdirectionalformat\z:}', "");;
    Expect(1, 8236, '\p{Bidi_Class= pop_Directional_format}', "");
    Expect(0, 8236, '\p{^Bidi_Class= pop_Directional_format}', "");
    Expect(0, 8236, '\P{Bidi_Class= pop_Directional_format}', "");
    Expect(1, 8236, '\P{^Bidi_Class= pop_Directional_format}', "");
    Expect(0, 8237, '\p{Bidi_Class= pop_Directional_format}', "");
    Expect(1, 8237, '\p{^Bidi_Class= pop_Directional_format}', "");
    Expect(1, 8237, '\P{Bidi_Class= pop_Directional_format}', "");
    Expect(0, 8237, '\P{^Bidi_Class= pop_Directional_format}', "");
    Error('\p{Bc=	PDF/a/}');
    Error('\P{Bc=	PDF/a/}');
    Expect(1, 8236, '\p{Bc=:\APDF\z:}', "");;
    Expect(0, 8237, '\p{Bc=:\APDF\z:}', "");;
    Expect(1, 8236, '\p{Bc=pdf}', "");
    Expect(0, 8236, '\p{^Bc=pdf}', "");
    Expect(0, 8236, '\P{Bc=pdf}', "");
    Expect(1, 8236, '\P{^Bc=pdf}', "");
    Expect(0, 8237, '\p{Bc=pdf}', "");
    Expect(1, 8237, '\p{^Bc=pdf}', "");
    Expect(1, 8237, '\P{Bc=pdf}', "");
    Expect(0, 8237, '\P{^Bc=pdf}', "");
    Expect(1, 8236, '\p{Bc=:\Apdf\z:}', "");;
    Expect(0, 8237, '\p{Bc=:\Apdf\z:}', "");;
    Expect(1, 8236, '\p{Bc=		pdf}', "");
    Expect(0, 8236, '\p{^Bc=		pdf}', "");
    Expect(0, 8236, '\P{Bc=		pdf}', "");
    Expect(1, 8236, '\P{^Bc=		pdf}', "");
    Expect(0, 8237, '\p{Bc=		pdf}', "");
    Expect(1, 8237, '\p{^Bc=		pdf}', "");
    Expect(1, 8237, '\P{Bc=		pdf}', "");
    Expect(0, 8237, '\P{^Bc=		pdf}', "");
    Error('\p{Is_Bidi_Class:   :=  POP_Directional_FORMAT}');
    Error('\P{Is_Bidi_Class:   :=  POP_Directional_FORMAT}');
    Expect(1, 8236, '\p{Is_Bidi_Class=popdirectionalformat}', "");
    Expect(0, 8236, '\p{^Is_Bidi_Class=popdirectionalformat}', "");
    Expect(0, 8236, '\P{Is_Bidi_Class=popdirectionalformat}', "");
    Expect(1, 8236, '\P{^Is_Bidi_Class=popdirectionalformat}', "");
    Expect(0, 8237, '\p{Is_Bidi_Class=popdirectionalformat}', "");
    Expect(1, 8237, '\p{^Is_Bidi_Class=popdirectionalformat}', "");
    Expect(1, 8237, '\P{Is_Bidi_Class=popdirectionalformat}', "");
    Expect(0, 8237, '\P{^Is_Bidi_Class=popdirectionalformat}', "");
    Expect(1, 8236, '\p{Is_Bidi_Class= _POP_directional_FORMAT}', "");
    Expect(0, 8236, '\p{^Is_Bidi_Class= _POP_directional_FORMAT}', "");
    Expect(0, 8236, '\P{Is_Bidi_Class= _POP_directional_FORMAT}', "");
    Expect(1, 8236, '\P{^Is_Bidi_Class= _POP_directional_FORMAT}', "");
    Expect(0, 8237, '\p{Is_Bidi_Class= _POP_directional_FORMAT}', "");
    Expect(1, 8237, '\p{^Is_Bidi_Class= _POP_directional_FORMAT}', "");
    Expect(1, 8237, '\P{Is_Bidi_Class= _POP_directional_FORMAT}', "");
    Expect(0, 8237, '\P{^Is_Bidi_Class= _POP_directional_FORMAT}', "");
    Error('\p{Is_Bc=	:=PDF}');
    Error('\P{Is_Bc=	:=PDF}');
    Expect(1, 8236, '\p{Is_Bc=pdf}', "");
    Expect(0, 8236, '\p{^Is_Bc=pdf}', "");
    Expect(0, 8236, '\P{Is_Bc=pdf}', "");
    Expect(1, 8236, '\P{^Is_Bc=pdf}', "");
    Expect(0, 8237, '\p{Is_Bc=pdf}', "");
    Expect(1, 8237, '\p{^Is_Bc=pdf}', "");
    Expect(1, 8237, '\P{Is_Bc=pdf}', "");
    Expect(0, 8237, '\P{^Is_Bc=pdf}', "");
    Expect(1, 8236, '\p{Is_Bc=	-pdf}', "");
    Expect(0, 8236, '\p{^Is_Bc=	-pdf}', "");
    Expect(0, 8236, '\P{Is_Bc=	-pdf}', "");
    Expect(1, 8236, '\P{^Is_Bc=	-pdf}', "");
    Expect(0, 8237, '\p{Is_Bc=	-pdf}', "");
    Expect(1, 8237, '\p{^Is_Bc=	-pdf}', "");
    Expect(1, 8237, '\P{Is_Bc=	-pdf}', "");
    Expect(0, 8237, '\P{^Is_Bc=	-pdf}', "");
    Error('\p{Bidi_Class=:=POP_Directional_Isolate}');
    Error('\P{Bidi_Class=:=POP_Directional_Isolate}');
    Expect(1, 8297, '\p{Bidi_Class=:\APop_Directional_Isolate\z:}', "");;
    Expect(0, 8298, '\p{Bidi_Class=:\APop_Directional_Isolate\z:}', "");;
    Expect(1, 8297, '\p{Bidi_Class=popdirectionalisolate}', "");
    Expect(0, 8297, '\p{^Bidi_Class=popdirectionalisolate}', "");
    Expect(0, 8297, '\P{Bidi_Class=popdirectionalisolate}', "");
    Expect(1, 8297, '\P{^Bidi_Class=popdirectionalisolate}', "");
    Expect(0, 8298, '\p{Bidi_Class=popdirectionalisolate}', "");
    Expect(1, 8298, '\p{^Bidi_Class=popdirectionalisolate}', "");
    Expect(1, 8298, '\P{Bidi_Class=popdirectionalisolate}', "");
    Expect(0, 8298, '\P{^Bidi_Class=popdirectionalisolate}', "");
    Expect(1, 8297, '\p{Bidi_Class=:\Apopdirectionalisolate\z:}', "");;
    Expect(0, 8298, '\p{Bidi_Class=:\Apopdirectionalisolate\z:}', "");;
    Expect(1, 8297, '\p{Bidi_Class=_-pop_directional_Isolate}', "");
    Expect(0, 8297, '\p{^Bidi_Class=_-pop_directional_Isolate}', "");
    Expect(0, 8297, '\P{Bidi_Class=_-pop_directional_Isolate}', "");
    Expect(1, 8297, '\P{^Bidi_Class=_-pop_directional_Isolate}', "");
    Expect(0, 8298, '\p{Bidi_Class=_-pop_directional_Isolate}', "");
    Expect(1, 8298, '\p{^Bidi_Class=_-pop_directional_Isolate}', "");
    Expect(1, 8298, '\P{Bidi_Class=_-pop_directional_Isolate}', "");
    Expect(0, 8298, '\P{^Bidi_Class=_-pop_directional_Isolate}', "");
    Error('\p{Bc=:= pdi}');
    Error('\P{Bc=:= pdi}');
    Expect(1, 8297, '\p{Bc=:\APDI\z:}', "");;
    Expect(0, 8298, '\p{Bc=:\APDI\z:}', "");;
    Expect(1, 8297, '\p{Bc=pdi}', "");
    Expect(0, 8297, '\p{^Bc=pdi}', "");
    Expect(0, 8297, '\P{Bc=pdi}', "");
    Expect(1, 8297, '\P{^Bc=pdi}', "");
    Expect(0, 8298, '\p{Bc=pdi}', "");
    Expect(1, 8298, '\p{^Bc=pdi}', "");
    Expect(1, 8298, '\P{Bc=pdi}', "");
    Expect(0, 8298, '\P{^Bc=pdi}', "");
    Expect(1, 8297, '\p{Bc=:\Apdi\z:}', "");;
    Expect(0, 8298, '\p{Bc=:\Apdi\z:}', "");;
    Expect(1, 8297, '\p{Bc:	 PDI}', "");
    Expect(0, 8297, '\p{^Bc:	 PDI}', "");
    Expect(0, 8297, '\P{Bc:	 PDI}', "");
    Expect(1, 8297, '\P{^Bc:	 PDI}', "");
    Expect(0, 8298, '\p{Bc:	 PDI}', "");
    Expect(1, 8298, '\p{^Bc:	 PDI}', "");
    Expect(1, 8298, '\P{Bc:	 PDI}', "");
    Expect(0, 8298, '\P{^Bc:	 PDI}', "");
    Error('\p{Is_Bidi_Class= _pop_Directional_Isolate/a/}');
    Error('\P{Is_Bidi_Class= _pop_Directional_Isolate/a/}');
    Expect(1, 8297, '\p{Is_Bidi_Class=popdirectionalisolate}', "");
    Expect(0, 8297, '\p{^Is_Bidi_Class=popdirectionalisolate}', "");
    Expect(0, 8297, '\P{Is_Bidi_Class=popdirectionalisolate}', "");
    Expect(1, 8297, '\P{^Is_Bidi_Class=popdirectionalisolate}', "");
    Expect(0, 8298, '\p{Is_Bidi_Class=popdirectionalisolate}', "");
    Expect(1, 8298, '\p{^Is_Bidi_Class=popdirectionalisolate}', "");
    Expect(1, 8298, '\P{Is_Bidi_Class=popdirectionalisolate}', "");
    Expect(0, 8298, '\P{^Is_Bidi_Class=popdirectionalisolate}', "");
    Expect(1, 8297, '\p{Is_Bidi_Class=-POP_DIRECTIONAL_Isolate}', "");
    Expect(0, 8297, '\p{^Is_Bidi_Class=-POP_DIRECTIONAL_Isolate}', "");
    Expect(0, 8297, '\P{Is_Bidi_Class=-POP_DIRECTIONAL_Isolate}', "");
    Expect(1, 8297, '\P{^Is_Bidi_Class=-POP_DIRECTIONAL_Isolate}', "");
    Expect(0, 8298, '\p{Is_Bidi_Class=-POP_DIRECTIONAL_Isolate}', "");
    Expect(1, 8298, '\p{^Is_Bidi_Class=-POP_DIRECTIONAL_Isolate}', "");
    Expect(1, 8298, '\P{Is_Bidi_Class=-POP_DIRECTIONAL_Isolate}', "");
    Expect(0, 8298, '\P{^Is_Bidi_Class=-POP_DIRECTIONAL_Isolate}', "");
    Error('\p{Is_Bc=/a/ PDI}');
    Error('\P{Is_Bc=/a/ PDI}');
    Expect(1, 8297, '\p{Is_Bc=pdi}', "");
    Expect(0, 8297, '\p{^Is_Bc=pdi}', "");
    Expect(0, 8297, '\P{Is_Bc=pdi}', "");
    Expect(1, 8297, '\P{^Is_Bc=pdi}', "");
    Expect(0, 8298, '\p{Is_Bc=pdi}', "");
    Expect(1, 8298, '\p{^Is_Bc=pdi}', "");
    Expect(1, 8298, '\P{Is_Bc=pdi}', "");
    Expect(0, 8298, '\P{^Is_Bc=pdi}', "");
    Expect(1, 8297, '\p{Is_Bc= 	PDI}', "");
    Expect(0, 8297, '\p{^Is_Bc= 	PDI}', "");
    Expect(0, 8297, '\P{Is_Bc= 	PDI}', "");
    Expect(1, 8297, '\P{^Is_Bc= 	PDI}', "");
    Expect(0, 8298, '\p{Is_Bc= 	PDI}', "");
    Expect(1, 8298, '\p{^Is_Bc= 	PDI}', "");
    Expect(1, 8298, '\P{Is_Bc= 	PDI}', "");
    Expect(0, 8298, '\P{^Is_Bc= 	PDI}', "");
    Error('\p{Bidi_Class=  Right_TO_left:=}');
    Error('\P{Bidi_Class=  Right_TO_left:=}');
    Expect(1, 126975, '\p{Bidi_Class=:\ARight_To_Left\z:}', "");;
    Expect(0, 126976, '\p{Bidi_Class=:\ARight_To_Left\z:}', "");;
    Expect(1, 126975, '\p{Bidi_Class=righttoleft}', "");
    Expect(0, 126975, '\p{^Bidi_Class=righttoleft}', "");
    Expect(0, 126975, '\P{Bidi_Class=righttoleft}', "");
    Expect(1, 126975, '\P{^Bidi_Class=righttoleft}', "");
    Expect(0, 126976, '\p{Bidi_Class=righttoleft}', "");
    Expect(1, 126976, '\p{^Bidi_Class=righttoleft}', "");
    Expect(1, 126976, '\P{Bidi_Class=righttoleft}', "");
    Expect(0, 126976, '\P{^Bidi_Class=righttoleft}', "");
    Expect(1, 126975, '\p{Bidi_Class=:\Arighttoleft\z:}', "");;
    Expect(0, 126976, '\p{Bidi_Class=:\Arighttoleft\z:}', "");;
    Expect(1, 126975, '\p{Bidi_Class:     Right_To_left}', "");
    Expect(0, 126975, '\p{^Bidi_Class:     Right_To_left}', "");
    Expect(0, 126975, '\P{Bidi_Class:     Right_To_left}', "");
    Expect(1, 126975, '\P{^Bidi_Class:     Right_To_left}', "");
    Expect(0, 126976, '\p{Bidi_Class:     Right_To_left}', "");
    Expect(1, 126976, '\p{^Bidi_Class:     Right_To_left}', "");
    Expect(1, 126976, '\P{Bidi_Class:     Right_To_left}', "");
    Expect(0, 126976, '\P{^Bidi_Class:     Right_To_left}', "");
    Error('\p{Bc=--r/a/}');
    Error('\P{Bc=--r/a/}');
    Expect(1, 126975, '\p{Bc=:\AR\z:}', "");;
    Expect(0, 126976, '\p{Bc=:\AR\z:}', "");;
    Expect(1, 126975, '\p{Bc=r}', "");
    Expect(0, 126975, '\p{^Bc=r}', "");
    Expect(0, 126975, '\P{Bc=r}', "");
    Expect(1, 126975, '\P{^Bc=r}', "");
    Expect(0, 126976, '\p{Bc=r}', "");
    Expect(1, 126976, '\p{^Bc=r}', "");
    Expect(1, 126976, '\P{Bc=r}', "");
    Expect(0, 126976, '\P{^Bc=r}', "");
    Expect(1, 126975, '\p{Bc=:\Ar\z:}', "");;
    Expect(0, 126976, '\p{Bc=:\Ar\z:}', "");;
    Expect(1, 126975, '\p{Bc=-_R}', "");
    Expect(0, 126975, '\p{^Bc=-_R}', "");
    Expect(0, 126975, '\P{Bc=-_R}', "");
    Expect(1, 126975, '\P{^Bc=-_R}', "");
    Expect(0, 126976, '\p{Bc=-_R}', "");
    Expect(1, 126976, '\p{^Bc=-_R}', "");
    Expect(1, 126976, '\P{Bc=-_R}', "");
    Expect(0, 126976, '\P{^Bc=-_R}', "");
    Error('\p{Is_Bidi_Class:   right_To_left:=}');
    Error('\P{Is_Bidi_Class:   right_To_left:=}');
    Expect(1, 126975, '\p{Is_Bidi_Class=righttoleft}', "");
    Expect(0, 126975, '\p{^Is_Bidi_Class=righttoleft}', "");
    Expect(0, 126975, '\P{Is_Bidi_Class=righttoleft}', "");
    Expect(1, 126975, '\P{^Is_Bidi_Class=righttoleft}', "");
    Expect(0, 126976, '\p{Is_Bidi_Class=righttoleft}', "");
    Expect(1, 126976, '\p{^Is_Bidi_Class=righttoleft}', "");
    Expect(1, 126976, '\P{Is_Bidi_Class=righttoleft}', "");
    Expect(0, 126976, '\P{^Is_Bidi_Class=righttoleft}', "");
    Expect(1, 126975, '\p{Is_Bidi_Class:   -_Right_To_Left}', "");
    Expect(0, 126975, '\p{^Is_Bidi_Class:   -_Right_To_Left}', "");
    Expect(0, 126975, '\P{Is_Bidi_Class:   -_Right_To_Left}', "");
    Expect(1, 126975, '\P{^Is_Bidi_Class:   -_Right_To_Left}', "");
    Expect(0, 126976, '\p{Is_Bidi_Class:   -_Right_To_Left}', "");
    Expect(1, 126976, '\p{^Is_Bidi_Class:   -_Right_To_Left}', "");
    Expect(1, 126976, '\P{Is_Bidi_Class:   -_Right_To_Left}', "");
    Expect(0, 126976, '\P{^Is_Bidi_Class:   -_Right_To_Left}', "");
    Error('\p{Is_Bc=_/a/R}');
    Error('\P{Is_Bc=_/a/R}');
    Expect(1, 126975, '\p{Is_Bc=r}', "");
    Expect(0, 126975, '\p{^Is_Bc=r}', "");
    Expect(0, 126975, '\P{Is_Bc=r}', "");
    Expect(1, 126975, '\P{^Is_Bc=r}', "");
    Expect(0, 126976, '\p{Is_Bc=r}', "");
    Expect(1, 126976, '\p{^Is_Bc=r}', "");
    Expect(1, 126976, '\P{Is_Bc=r}', "");
    Expect(0, 126976, '\P{^Is_Bc=r}', "");
    Expect(1, 126975, '\p{Is_Bc= -R}', "");
    Expect(0, 126975, '\p{^Is_Bc= -R}', "");
    Expect(0, 126975, '\P{Is_Bc= -R}', "");
    Expect(1, 126975, '\P{^Is_Bc= -R}', "");
    Expect(0, 126976, '\p{Is_Bc= -R}', "");
    Expect(1, 126976, '\p{^Is_Bc= -R}', "");
    Expect(1, 126976, '\P{Is_Bc= -R}', "");
    Expect(0, 126976, '\P{^Is_Bc= -R}', "");
    Error('\p{Bidi_Class=__Right_To_Left_Embedding:=}');
    Error('\P{Bidi_Class=__Right_To_Left_Embedding:=}');
    Expect(1, 8235, '\p{Bidi_Class=:\ARight_To_Left_Embedding\z:}', "");;
    Expect(0, 8236, '\p{Bidi_Class=:\ARight_To_Left_Embedding\z:}', "");;
    Expect(1, 8235, '\p{Bidi_Class=righttoleftembedding}', "");
    Expect(0, 8235, '\p{^Bidi_Class=righttoleftembedding}', "");
    Expect(0, 8235, '\P{Bidi_Class=righttoleftembedding}', "");
    Expect(1, 8235, '\P{^Bidi_Class=righttoleftembedding}', "");
    Expect(0, 8236, '\p{Bidi_Class=righttoleftembedding}', "");
    Expect(1, 8236, '\p{^Bidi_Class=righttoleftembedding}', "");
    Expect(1, 8236, '\P{Bidi_Class=righttoleftembedding}', "");
    Expect(0, 8236, '\P{^Bidi_Class=righttoleftembedding}', "");
    Expect(1, 8235, '\p{Bidi_Class=:\Arighttoleftembedding\z:}', "");;
    Expect(0, 8236, '\p{Bidi_Class=:\Arighttoleftembedding\z:}', "");;
    Expect(1, 8235, '\p{Bidi_Class=	_Right_TO_Left_Embedding}', "");
    Expect(0, 8235, '\p{^Bidi_Class=	_Right_TO_Left_Embedding}', "");
    Expect(0, 8235, '\P{Bidi_Class=	_Right_TO_Left_Embedding}', "");
    Expect(1, 8235, '\P{^Bidi_Class=	_Right_TO_Left_Embedding}', "");
    Expect(0, 8236, '\p{Bidi_Class=	_Right_TO_Left_Embedding}', "");
    Expect(1, 8236, '\p{^Bidi_Class=	_Right_TO_Left_Embedding}', "");
    Expect(1, 8236, '\P{Bidi_Class=	_Right_TO_Left_Embedding}', "");
    Expect(0, 8236, '\P{^Bidi_Class=	_Right_TO_Left_Embedding}', "");
    Error('\p{Bc=		RLE/a/}');
    Error('\P{Bc=		RLE/a/}');
    Expect(1, 8235, '\p{Bc=:\ARLE\z:}', "");;
    Expect(0, 8236, '\p{Bc=:\ARLE\z:}', "");;
    Expect(1, 8235, '\p{Bc=rle}', "");
    Expect(0, 8235, '\p{^Bc=rle}', "");
    Expect(0, 8235, '\P{Bc=rle}', "");
    Expect(1, 8235, '\P{^Bc=rle}', "");
    Expect(0, 8236, '\p{Bc=rle}', "");
    Expect(1, 8236, '\p{^Bc=rle}', "");
    Expect(1, 8236, '\P{Bc=rle}', "");
    Expect(0, 8236, '\P{^Bc=rle}', "");
    Expect(1, 8235, '\p{Bc=:\Arle\z:}', "");;
    Expect(0, 8236, '\p{Bc=:\Arle\z:}', "");;
    Expect(1, 8235, '\p{Bc= _rle}', "");
    Expect(0, 8235, '\p{^Bc= _rle}', "");
    Expect(0, 8235, '\P{Bc= _rle}', "");
    Expect(1, 8235, '\P{^Bc= _rle}', "");
    Expect(0, 8236, '\p{Bc= _rle}', "");
    Expect(1, 8236, '\p{^Bc= _rle}', "");
    Expect(1, 8236, '\P{Bc= _rle}', "");
    Expect(0, 8236, '\P{^Bc= _rle}', "");
    Error('\p{Is_Bidi_Class=/a/RIGHT_to_Left_embedding}');
    Error('\P{Is_Bidi_Class=/a/RIGHT_to_Left_embedding}');
    Expect(1, 8235, '\p{Is_Bidi_Class=righttoleftembedding}', "");
    Expect(0, 8235, '\p{^Is_Bidi_Class=righttoleftembedding}', "");
    Expect(0, 8235, '\P{Is_Bidi_Class=righttoleftembedding}', "");
    Expect(1, 8235, '\P{^Is_Bidi_Class=righttoleftembedding}', "");
    Expect(0, 8236, '\p{Is_Bidi_Class=righttoleftembedding}', "");
    Expect(1, 8236, '\p{^Is_Bidi_Class=righttoleftembedding}', "");
    Expect(1, 8236, '\P{Is_Bidi_Class=righttoleftembedding}', "");
    Expect(0, 8236, '\P{^Is_Bidi_Class=righttoleftembedding}', "");
    Expect(1, 8235, '\p{Is_Bidi_Class=	 RIGHT_to_Left_Embedding}', "");
    Expect(0, 8235, '\p{^Is_Bidi_Class=	 RIGHT_to_Left_Embedding}', "");
    Expect(0, 8235, '\P{Is_Bidi_Class=	 RIGHT_to_Left_Embedding}', "");
    Expect(1, 8235, '\P{^Is_Bidi_Class=	 RIGHT_to_Left_Embedding}', "");
    Expect(0, 8236, '\p{Is_Bidi_Class=	 RIGHT_to_Left_Embedding}', "");
    Expect(1, 8236, '\p{^Is_Bidi_Class=	 RIGHT_to_Left_Embedding}', "");
    Expect(1, 8236, '\P{Is_Bidi_Class=	 RIGHT_to_Left_Embedding}', "");
    Expect(0, 8236, '\P{^Is_Bidi_Class=	 RIGHT_to_Left_Embedding}', "");
    Error('\p{Is_Bc=:=_-RLE}');
    Error('\P{Is_Bc=:=_-RLE}');
    Expect(1, 8235, '\p{Is_Bc=rle}', "");
    Expect(0, 8235, '\p{^Is_Bc=rle}', "");
    Expect(0, 8235, '\P{Is_Bc=rle}', "");
    Expect(1, 8235, '\P{^Is_Bc=rle}', "");
    Expect(0, 8236, '\p{Is_Bc=rle}', "");
    Expect(1, 8236, '\p{^Is_Bc=rle}', "");
    Expect(1, 8236, '\P{Is_Bc=rle}', "");
    Expect(0, 8236, '\P{^Is_Bc=rle}', "");
    Expect(1, 8235, '\p{Is_Bc=	RLE}', "");
    Expect(0, 8235, '\p{^Is_Bc=	RLE}', "");
    Expect(0, 8235, '\P{Is_Bc=	RLE}', "");
    Expect(1, 8235, '\P{^Is_Bc=	RLE}', "");
    Expect(0, 8236, '\p{Is_Bc=	RLE}', "");
    Expect(1, 8236, '\p{^Is_Bc=	RLE}', "");
    Expect(1, 8236, '\P{Is_Bc=	RLE}', "");
    Expect(0, 8236, '\P{^Is_Bc=	RLE}', "");
    Error('\p{Bidi_Class=-	Right_To_LEFT_isolate/a/}');
    Error('\P{Bidi_Class=-	Right_To_LEFT_isolate/a/}');
    Expect(1, 8295, '\p{Bidi_Class=:\ARight_To_Left_Isolate\z:}', "");;
    Expect(0, 8296, '\p{Bidi_Class=:\ARight_To_Left_Isolate\z:}', "");;
    Expect(1, 8295, '\p{Bidi_Class=righttoleftisolate}', "");
    Expect(0, 8295, '\p{^Bidi_Class=righttoleftisolate}', "");
    Expect(0, 8295, '\P{Bidi_Class=righttoleftisolate}', "");
    Expect(1, 8295, '\P{^Bidi_Class=righttoleftisolate}', "");
    Expect(0, 8296, '\p{Bidi_Class=righttoleftisolate}', "");
    Expect(1, 8296, '\p{^Bidi_Class=righttoleftisolate}', "");
    Expect(1, 8296, '\P{Bidi_Class=righttoleftisolate}', "");
    Expect(0, 8296, '\P{^Bidi_Class=righttoleftisolate}', "");
    Expect(1, 8295, '\p{Bidi_Class=:\Arighttoleftisolate\z:}', "");;
    Expect(0, 8296, '\p{Bidi_Class=:\Arighttoleftisolate\z:}', "");;
    Expect(1, 8295, '\p{Bidi_Class= Right_TO_Left_Isolate}', "");
    Expect(0, 8295, '\p{^Bidi_Class= Right_TO_Left_Isolate}', "");
    Expect(0, 8295, '\P{Bidi_Class= Right_TO_Left_Isolate}', "");
    Expect(1, 8295, '\P{^Bidi_Class= Right_TO_Left_Isolate}', "");
    Expect(0, 8296, '\p{Bidi_Class= Right_TO_Left_Isolate}', "");
    Expect(1, 8296, '\p{^Bidi_Class= Right_TO_Left_Isolate}', "");
    Expect(1, 8296, '\P{Bidi_Class= Right_TO_Left_Isolate}', "");
    Expect(0, 8296, '\P{^Bidi_Class= Right_TO_Left_Isolate}', "");
    Error('\p{Bc:   /a/	_RLI}');
    Error('\P{Bc:   /a/	_RLI}');
    Expect(1, 8295, '\p{Bc=:\ARLI\z:}', "");;
    Expect(0, 8296, '\p{Bc=:\ARLI\z:}', "");;
    Expect(1, 8295, '\p{Bc=rli}', "");
    Expect(0, 8295, '\p{^Bc=rli}', "");
    Expect(0, 8295, '\P{Bc=rli}', "");
    Expect(1, 8295, '\P{^Bc=rli}', "");
    Expect(0, 8296, '\p{Bc=rli}', "");
    Expect(1, 8296, '\p{^Bc=rli}', "");
    Expect(1, 8296, '\P{Bc=rli}', "");
    Expect(0, 8296, '\P{^Bc=rli}', "");
    Expect(1, 8295, '\p{Bc=:\Arli\z:}', "");;
    Expect(0, 8296, '\p{Bc=:\Arli\z:}', "");;
    Expect(1, 8295, '\p{Bc=-RLI}', "");
    Expect(0, 8295, '\p{^Bc=-RLI}', "");
    Expect(0, 8295, '\P{Bc=-RLI}', "");
    Expect(1, 8295, '\P{^Bc=-RLI}', "");
    Expect(0, 8296, '\p{Bc=-RLI}', "");
    Expect(1, 8296, '\p{^Bc=-RLI}', "");
    Expect(1, 8296, '\P{Bc=-RLI}', "");
    Expect(0, 8296, '\P{^Bc=-RLI}', "");
    Error('\p{Is_Bidi_Class=/a/	 Right_To_Left_ISOLATE}');
    Error('\P{Is_Bidi_Class=/a/	 Right_To_Left_ISOLATE}');
    Expect(1, 8295, '\p{Is_Bidi_Class=righttoleftisolate}', "");
    Expect(0, 8295, '\p{^Is_Bidi_Class=righttoleftisolate}', "");
    Expect(0, 8295, '\P{Is_Bidi_Class=righttoleftisolate}', "");
    Expect(1, 8295, '\P{^Is_Bidi_Class=righttoleftisolate}', "");
    Expect(0, 8296, '\p{Is_Bidi_Class=righttoleftisolate}', "");
    Expect(1, 8296, '\p{^Is_Bidi_Class=righttoleftisolate}', "");
    Expect(1, 8296, '\P{Is_Bidi_Class=righttoleftisolate}', "");
    Expect(0, 8296, '\P{^Is_Bidi_Class=righttoleftisolate}', "");
    Expect(1, 8295, '\p{Is_Bidi_Class= 	Right_TO_Left_ISOLATE}', "");
    Expect(0, 8295, '\p{^Is_Bidi_Class= 	Right_TO_Left_ISOLATE}', "");
    Expect(0, 8295, '\P{Is_Bidi_Class= 	Right_TO_Left_ISOLATE}', "");
    Expect(1, 8295, '\P{^Is_Bidi_Class= 	Right_TO_Left_ISOLATE}', "");
    Expect(0, 8296, '\p{Is_Bidi_Class= 	Right_TO_Left_ISOLATE}', "");
    Expect(1, 8296, '\p{^Is_Bidi_Class= 	Right_TO_Left_ISOLATE}', "");
    Expect(1, 8296, '\P{Is_Bidi_Class= 	Right_TO_Left_ISOLATE}', "");
    Expect(0, 8296, '\P{^Is_Bidi_Class= 	Right_TO_Left_ISOLATE}', "");
    Error('\p{Is_Bc:	/a/-	rli}');
    Error('\P{Is_Bc:	/a/-	rli}');
    Expect(1, 8295, '\p{Is_Bc=rli}', "");
    Expect(0, 8295, '\p{^Is_Bc=rli}', "");
    Expect(0, 8295, '\P{Is_Bc=rli}', "");
    Expect(1, 8295, '\P{^Is_Bc=rli}', "");
    Expect(0, 8296, '\p{Is_Bc=rli}', "");
    Expect(1, 8296, '\p{^Is_Bc=rli}', "");
    Expect(1, 8296, '\P{Is_Bc=rli}', "");
    Expect(0, 8296, '\P{^Is_Bc=rli}', "");
    Expect(1, 8295, '\p{Is_Bc= -rli}', "");
    Expect(0, 8295, '\p{^Is_Bc= -rli}', "");
    Expect(0, 8295, '\P{Is_Bc= -rli}', "");
    Expect(1, 8295, '\P{^Is_Bc= -rli}', "");
    Expect(0, 8296, '\p{Is_Bc= -rli}', "");
    Expect(1, 8296, '\p{^Is_Bc= -rli}', "");
    Expect(1, 8296, '\P{Is_Bc= -rli}', "");
    Expect(0, 8296, '\P{^Is_Bc= -rli}', "");
    Error('\p{Bidi_Class:/a/Right_to_LEFT_OVERRIDE}');
    Error('\P{Bidi_Class:/a/Right_to_LEFT_OVERRIDE}');
    Expect(1, 8238, '\p{Bidi_Class=:\ARight_To_Left_Override\z:}', "");;
    Expect(0, 8239, '\p{Bidi_Class=:\ARight_To_Left_Override\z:}', "");;
    Expect(1, 8238, '\p{Bidi_Class=righttoleftoverride}', "");
    Expect(0, 8238, '\p{^Bidi_Class=righttoleftoverride}', "");
    Expect(0, 8238, '\P{Bidi_Class=righttoleftoverride}', "");
    Expect(1, 8238, '\P{^Bidi_Class=righttoleftoverride}', "");
    Expect(0, 8239, '\p{Bidi_Class=righttoleftoverride}', "");
    Expect(1, 8239, '\p{^Bidi_Class=righttoleftoverride}', "");
    Expect(1, 8239, '\P{Bidi_Class=righttoleftoverride}', "");
    Expect(0, 8239, '\P{^Bidi_Class=righttoleftoverride}', "");
    Expect(1, 8238, '\p{Bidi_Class=:\Arighttoleftoverride\z:}', "");;
    Expect(0, 8239, '\p{Bidi_Class=:\Arighttoleftoverride\z:}', "");;
    Expect(1, 8238, '\p{Bidi_Class:   _ RIGHT_to_Left_Override}', "");
    Expect(0, 8238, '\p{^Bidi_Class:   _ RIGHT_to_Left_Override}', "");
    Expect(0, 8238, '\P{Bidi_Class:   _ RIGHT_to_Left_Override}', "");
    Expect(1, 8238, '\P{^Bidi_Class:   _ RIGHT_to_Left_Override}', "");
    Expect(0, 8239, '\p{Bidi_Class:   _ RIGHT_to_Left_Override}', "");
    Expect(1, 8239, '\p{^Bidi_Class:   _ RIGHT_to_Left_Override}', "");
    Expect(1, 8239, '\P{Bidi_Class:   _ RIGHT_to_Left_Override}', "");
    Expect(0, 8239, '\P{^Bidi_Class:   _ RIGHT_to_Left_Override}', "");
    Error('\p{Bc=/a/	RLO}');
    Error('\P{Bc=/a/	RLO}');
    Expect(1, 8238, '\p{Bc=:\ARLO\z:}', "");;
    Expect(0, 8239, '\p{Bc=:\ARLO\z:}', "");;
    Expect(1, 8238, '\p{Bc=rlo}', "");
    Expect(0, 8238, '\p{^Bc=rlo}', "");
    Expect(0, 8238, '\P{Bc=rlo}', "");
    Expect(1, 8238, '\P{^Bc=rlo}', "");
    Expect(0, 8239, '\p{Bc=rlo}', "");
    Expect(1, 8239, '\p{^Bc=rlo}', "");
    Expect(1, 8239, '\P{Bc=rlo}', "");
    Expect(0, 8239, '\P{^Bc=rlo}', "");
    Expect(1, 8238, '\p{Bc=:\Arlo\z:}', "");;
    Expect(0, 8239, '\p{Bc=:\Arlo\z:}', "");;
    Expect(1, 8238, '\p{Bc=	 rlo}', "");
    Expect(0, 8238, '\p{^Bc=	 rlo}', "");
    Expect(0, 8238, '\P{Bc=	 rlo}', "");
    Expect(1, 8238, '\P{^Bc=	 rlo}', "");
    Expect(0, 8239, '\p{Bc=	 rlo}', "");
    Expect(1, 8239, '\p{^Bc=	 rlo}', "");
    Expect(1, 8239, '\P{Bc=	 rlo}', "");
    Expect(0, 8239, '\P{^Bc=	 rlo}', "");
    Error('\p{Is_Bidi_Class:_-Right_To_Left_override:=}');
    Error('\P{Is_Bidi_Class:_-Right_To_Left_override:=}');
    Expect(1, 8238, '\p{Is_Bidi_Class=righttoleftoverride}', "");
    Expect(0, 8238, '\p{^Is_Bidi_Class=righttoleftoverride}', "");
    Expect(0, 8238, '\P{Is_Bidi_Class=righttoleftoverride}', "");
    Expect(1, 8238, '\P{^Is_Bidi_Class=righttoleftoverride}', "");
    Expect(0, 8239, '\p{Is_Bidi_Class=righttoleftoverride}', "");
    Expect(1, 8239, '\p{^Is_Bidi_Class=righttoleftoverride}', "");
    Expect(1, 8239, '\P{Is_Bidi_Class=righttoleftoverride}', "");
    Expect(0, 8239, '\P{^Is_Bidi_Class=righttoleftoverride}', "");
    Expect(1, 8238, '\p{Is_Bidi_Class= _RIGHT_To_Left_OVERRIDE}', "");
    Expect(0, 8238, '\p{^Is_Bidi_Class= _RIGHT_To_Left_OVERRIDE}', "");
    Expect(0, 8238, '\P{Is_Bidi_Class= _RIGHT_To_Left_OVERRIDE}', "");
    Expect(1, 8238, '\P{^Is_Bidi_Class= _RIGHT_To_Left_OVERRIDE}', "");
    Expect(0, 8239, '\p{Is_Bidi_Class= _RIGHT_To_Left_OVERRIDE}', "");
    Expect(1, 8239, '\p{^Is_Bidi_Class= _RIGHT_To_Left_OVERRIDE}', "");
    Expect(1, 8239, '\P{Is_Bidi_Class= _RIGHT_To_Left_OVERRIDE}', "");
    Expect(0, 8239, '\P{^Is_Bidi_Class= _RIGHT_To_Left_OVERRIDE}', "");
    Error('\p{Is_Bc=:=- RLO}');
    Error('\P{Is_Bc=:=- RLO}');
    Expect(1, 8238, '\p{Is_Bc=rlo}', "");
    Expect(0, 8238, '\p{^Is_Bc=rlo}', "");
    Expect(0, 8238, '\P{Is_Bc=rlo}', "");
    Expect(1, 8238, '\P{^Is_Bc=rlo}', "");
    Expect(0, 8239, '\p{Is_Bc=rlo}', "");
    Expect(1, 8239, '\p{^Is_Bc=rlo}', "");
    Expect(1, 8239, '\P{Is_Bc=rlo}', "");
    Expect(0, 8239, '\P{^Is_Bc=rlo}', "");
    Expect(1, 8238, '\p{Is_Bc=__RLO}', "");
    Expect(0, 8238, '\p{^Is_Bc=__RLO}', "");
    Expect(0, 8238, '\P{Is_Bc=__RLO}', "");
    Expect(1, 8238, '\P{^Is_Bc=__RLO}', "");
    Expect(0, 8239, '\p{Is_Bc=__RLO}', "");
    Expect(1, 8239, '\p{^Is_Bc=__RLO}', "");
    Expect(1, 8239, '\P{Is_Bc=__RLO}', "");
    Expect(0, 8239, '\P{^Is_Bc=__RLO}', "");
    Error('\p{Bidi_Class: :=-segment_SEPARATOR}');
    Error('\P{Bidi_Class: :=-segment_SEPARATOR}');
    Expect(1, 31, '\p{Bidi_Class=:\ASegment_Separator\z:}', "");;
    Expect(0, 32, '\p{Bidi_Class=:\ASegment_Separator\z:}', "");;
    Expect(1, 31, '\p{Bidi_Class=segmentseparator}', "");
    Expect(0, 31, '\p{^Bidi_Class=segmentseparator}', "");
    Expect(0, 31, '\P{Bidi_Class=segmentseparator}', "");
    Expect(1, 31, '\P{^Bidi_Class=segmentseparator}', "");
    Expect(0, 32, '\p{Bidi_Class=segmentseparator}', "");
    Expect(1, 32, '\p{^Bidi_Class=segmentseparator}', "");
    Expect(1, 32, '\P{Bidi_Class=segmentseparator}', "");
    Expect(0, 32, '\P{^Bidi_Class=segmentseparator}', "");
    Expect(1, 31, '\p{Bidi_Class=:\Asegmentseparator\z:}', "");;
    Expect(0, 32, '\p{Bidi_Class=:\Asegmentseparator\z:}', "");;
    Expect(1, 31, '\p{Bidi_Class=	segment_Separator}', "");
    Expect(0, 31, '\p{^Bidi_Class=	segment_Separator}', "");
    Expect(0, 31, '\P{Bidi_Class=	segment_Separator}', "");
    Expect(1, 31, '\P{^Bidi_Class=	segment_Separator}', "");
    Expect(0, 32, '\p{Bidi_Class=	segment_Separator}', "");
    Expect(1, 32, '\p{^Bidi_Class=	segment_Separator}', "");
    Expect(1, 32, '\P{Bidi_Class=	segment_Separator}', "");
    Expect(0, 32, '\P{^Bidi_Class=	segment_Separator}', "");
    Error('\p{Bc=	 S/a/}');
    Error('\P{Bc=	 S/a/}');
    Expect(1, 31, '\p{Bc=:\AS\z:}', "");;
    Expect(0, 32, '\p{Bc=:\AS\z:}', "");;
    Expect(1, 31, '\p{Bc=s}', "");
    Expect(0, 31, '\p{^Bc=s}', "");
    Expect(0, 31, '\P{Bc=s}', "");
    Expect(1, 31, '\P{^Bc=s}', "");
    Expect(0, 32, '\p{Bc=s}', "");
    Expect(1, 32, '\p{^Bc=s}', "");
    Expect(1, 32, '\P{Bc=s}', "");
    Expect(0, 32, '\P{^Bc=s}', "");
    Expect(1, 31, '\p{Bc=:\As\z:}', "");;
    Expect(0, 32, '\p{Bc=:\As\z:}', "");;
    Expect(1, 31, '\p{Bc=S}', "");
    Expect(0, 31, '\p{^Bc=S}', "");
    Expect(0, 31, '\P{Bc=S}', "");
    Expect(1, 31, '\P{^Bc=S}', "");
    Expect(0, 32, '\p{Bc=S}', "");
    Expect(1, 32, '\p{^Bc=S}', "");
    Expect(1, 32, '\P{Bc=S}', "");
    Expect(0, 32, '\P{^Bc=S}', "");
    Error('\p{Is_Bidi_Class=	Segment_Separator:=}');
    Error('\P{Is_Bidi_Class=	Segment_Separator:=}');
    Expect(1, 31, '\p{Is_Bidi_Class:   segmentseparator}', "");
    Expect(0, 31, '\p{^Is_Bidi_Class:   segmentseparator}', "");
    Expect(0, 31, '\P{Is_Bidi_Class:   segmentseparator}', "");
    Expect(1, 31, '\P{^Is_Bidi_Class:   segmentseparator}', "");
    Expect(0, 32, '\p{Is_Bidi_Class:   segmentseparator}', "");
    Expect(1, 32, '\p{^Is_Bidi_Class:   segmentseparator}', "");
    Expect(1, 32, '\P{Is_Bidi_Class:   segmentseparator}', "");
    Expect(0, 32, '\P{^Is_Bidi_Class:   segmentseparator}', "");
    Expect(1, 31, '\p{Is_Bidi_Class=-segment_Separator}', "");
    Expect(0, 31, '\p{^Is_Bidi_Class=-segment_Separator}', "");
    Expect(0, 31, '\P{Is_Bidi_Class=-segment_Separator}', "");
    Expect(1, 31, '\P{^Is_Bidi_Class=-segment_Separator}', "");
    Expect(0, 32, '\p{Is_Bidi_Class=-segment_Separator}', "");
    Expect(1, 32, '\p{^Is_Bidi_Class=-segment_Separator}', "");
    Expect(1, 32, '\P{Is_Bidi_Class=-segment_Separator}', "");
    Expect(0, 32, '\P{^Is_Bidi_Class=-segment_Separator}', "");
    Error('\p{Is_Bc:	 S/a/}');
    Error('\P{Is_Bc:	 S/a/}');
    Expect(1, 31, '\p{Is_Bc=s}', "");
    Expect(0, 31, '\p{^Is_Bc=s}', "");
    Expect(0, 31, '\P{Is_Bc=s}', "");
    Expect(1, 31, '\P{^Is_Bc=s}', "");
    Expect(0, 32, '\p{Is_Bc=s}', "");
    Expect(1, 32, '\p{^Is_Bc=s}', "");
    Expect(1, 32, '\P{Is_Bc=s}', "");
    Expect(0, 32, '\P{^Is_Bc=s}', "");
    Expect(1, 31, '\p{Is_Bc=_-S}', "");
    Expect(0, 31, '\p{^Is_Bc=_-S}', "");
    Expect(0, 31, '\P{Is_Bc=_-S}', "");
    Expect(1, 31, '\P{^Is_Bc=_-S}', "");
    Expect(0, 32, '\p{Is_Bc=_-S}', "");
    Expect(1, 32, '\p{^Is_Bc=_-S}', "");
    Expect(1, 32, '\P{Is_Bc=_-S}', "");
    Expect(0, 32, '\P{^Is_Bc=_-S}', "");
    Error('\p{Bidi_Class= :=White_Space}');
    Error('\P{Bidi_Class= :=White_Space}');
    Expect(1, 12288, '\p{Bidi_Class=:\AWhite_Space\z:}', "");;
    Expect(0, 12289, '\p{Bidi_Class=:\AWhite_Space\z:}', "");;
    Expect(1, 12288, '\p{Bidi_Class=whitespace}', "");
    Expect(0, 12288, '\p{^Bidi_Class=whitespace}', "");
    Expect(0, 12288, '\P{Bidi_Class=whitespace}', "");
    Expect(1, 12288, '\P{^Bidi_Class=whitespace}', "");
    Expect(0, 12289, '\p{Bidi_Class=whitespace}', "");
    Expect(1, 12289, '\p{^Bidi_Class=whitespace}', "");
    Expect(1, 12289, '\P{Bidi_Class=whitespace}', "");
    Expect(0, 12289, '\P{^Bidi_Class=whitespace}', "");
    Expect(1, 12288, '\p{Bidi_Class=:\Awhitespace\z:}', "");;
    Expect(0, 12289, '\p{Bidi_Class=:\Awhitespace\z:}', "");;
    Expect(1, 12288, '\p{Bidi_Class=	 White_space}', "");
    Expect(0, 12288, '\p{^Bidi_Class=	 White_space}', "");
    Expect(0, 12288, '\P{Bidi_Class=	 White_space}', "");
    Expect(1, 12288, '\P{^Bidi_Class=	 White_space}', "");
    Expect(0, 12289, '\p{Bidi_Class=	 White_space}', "");
    Expect(1, 12289, '\p{^Bidi_Class=	 White_space}', "");
    Expect(1, 12289, '\P{Bidi_Class=	 White_space}', "");
    Expect(0, 12289, '\P{^Bidi_Class=	 White_space}', "");
    Error('\p{Bc=-:=WS}');
    Error('\P{Bc=-:=WS}');
    Expect(1, 12288, '\p{Bc=:\AWS\z:}', "");;
    Expect(0, 12289, '\p{Bc=:\AWS\z:}', "");;
    Expect(1, 12288, '\p{Bc=ws}', "");
    Expect(0, 12288, '\p{^Bc=ws}', "");
    Expect(0, 12288, '\P{Bc=ws}', "");
    Expect(1, 12288, '\P{^Bc=ws}', "");
    Expect(0, 12289, '\p{Bc=ws}', "");
    Expect(1, 12289, '\p{^Bc=ws}', "");
    Expect(1, 12289, '\P{Bc=ws}', "");
    Expect(0, 12289, '\P{^Bc=ws}', "");
    Expect(1, 12288, '\p{Bc=:\Aws\z:}', "");;
    Expect(0, 12289, '\p{Bc=:\Aws\z:}', "");;
    Expect(1, 12288, '\p{Bc=WS}', "");
    Expect(0, 12288, '\p{^Bc=WS}', "");
    Expect(0, 12288, '\P{Bc=WS}', "");
    Expect(1, 12288, '\P{^Bc=WS}', "");
    Expect(0, 12289, '\p{Bc=WS}', "");
    Expect(1, 12289, '\p{^Bc=WS}', "");
    Expect(1, 12289, '\P{Bc=WS}', "");
    Expect(0, 12289, '\P{^Bc=WS}', "");
    Error('\p{Is_Bidi_Class=-_WHITE_SPACE:=}');
    Error('\P{Is_Bidi_Class=-_WHITE_SPACE:=}');
    Expect(1, 12288, '\p{Is_Bidi_Class=whitespace}', "");
    Expect(0, 12288, '\p{^Is_Bidi_Class=whitespace}', "");
    Expect(0, 12288, '\P{Is_Bidi_Class=whitespace}', "");
    Expect(1, 12288, '\P{^Is_Bidi_Class=whitespace}', "");
    Expect(0, 12289, '\p{Is_Bidi_Class=whitespace}', "");
    Expect(1, 12289, '\p{^Is_Bidi_Class=whitespace}', "");
    Expect(1, 12289, '\P{Is_Bidi_Class=whitespace}', "");
    Expect(0, 12289, '\P{^Is_Bidi_Class=whitespace}', "");
    Expect(1, 12288, '\p{Is_Bidi_Class= WHITE_SPACE}', "");
    Expect(0, 12288, '\p{^Is_Bidi_Class= WHITE_SPACE}', "");
    Expect(0, 12288, '\P{Is_Bidi_Class= WHITE_SPACE}', "");
    Expect(1, 12288, '\P{^Is_Bidi_Class= WHITE_SPACE}', "");
    Expect(0, 12289, '\p{Is_Bidi_Class= WHITE_SPACE}', "");
    Expect(1, 12289, '\p{^Is_Bidi_Class= WHITE_SPACE}', "");
    Expect(1, 12289, '\P{Is_Bidi_Class= WHITE_SPACE}', "");
    Expect(0, 12289, '\P{^Is_Bidi_Class= WHITE_SPACE}', "");
    Error('\p{Is_Bc=-/a/WS}');
    Error('\P{Is_Bc=-/a/WS}');
    Expect(1, 12288, '\p{Is_Bc:	ws}', "");
    Expect(0, 12288, '\p{^Is_Bc:	ws}', "");
    Expect(0, 12288, '\P{Is_Bc:	ws}', "");
    Expect(1, 12288, '\P{^Is_Bc:	ws}', "");
    Expect(0, 12289, '\p{Is_Bc:	ws}', "");
    Expect(1, 12289, '\p{^Is_Bc:	ws}', "");
    Expect(1, 12289, '\P{Is_Bc:	ws}', "");
    Expect(0, 12289, '\P{^Is_Bc:	ws}', "");
    Expect(1, 12288, '\p{Is_Bc=-_WS}', "");
    Expect(0, 12288, '\p{^Is_Bc=-_WS}', "");
    Expect(0, 12288, '\P{Is_Bc=-_WS}', "");
    Expect(1, 12288, '\P{^Is_Bc=-_WS}', "");
    Expect(0, 12289, '\p{Is_Bc=-_WS}', "");
    Expect(1, 12289, '\p{^Is_Bc=-_WS}', "");
    Expect(1, 12289, '\P{Is_Bc=-_WS}', "");
    Expect(0, 12289, '\P{^Is_Bc=-_WS}', "");
    Error('\p{Bidi_Control: _:=no}');
    Error('\P{Bidi_Control: _:=no}');
    Expect(1, 8298, '\p{Bidi_Control=:\ANo\z:}', "");;
    Expect(0, 8297, '\p{Bidi_Control=:\ANo\z:}', "");;
    Expect(1, 8298, '\p{Bidi_Control=no}', "");
    Expect(0, 8298, '\p{^Bidi_Control=no}', "");
    Expect(0, 8298, '\P{Bidi_Control=no}', "");
    Expect(1, 8298, '\P{^Bidi_Control=no}', "");
    Expect(0, 8297, '\p{Bidi_Control=no}', "");
    Expect(1, 8297, '\p{^Bidi_Control=no}', "");
    Expect(1, 8297, '\P{Bidi_Control=no}', "");
    Expect(0, 8297, '\P{^Bidi_Control=no}', "");
    Expect(1, 8298, '\p{Bidi_Control=:\Ano\z:}', "");;
    Expect(0, 8297, '\p{Bidi_Control=:\Ano\z:}', "");;
    Expect(1, 8298, '\p{Bidi_Control=_no}', "");
    Expect(0, 8298, '\p{^Bidi_Control=_no}', "");
    Expect(0, 8298, '\P{Bidi_Control=_no}', "");
    Expect(1, 8298, '\P{^Bidi_Control=_no}', "");
    Expect(0, 8297, '\p{Bidi_Control=_no}', "");
    Expect(1, 8297, '\p{^Bidi_Control=_no}', "");
    Expect(1, 8297, '\P{Bidi_Control=_no}', "");
    Expect(0, 8297, '\P{^Bidi_Control=_no}', "");
    Error('\p{Bidi_C=_-N/a/}');
    Error('\P{Bidi_C=_-N/a/}');
    Expect(1, 8298, '\p{Bidi_C=:\AN\z:}', "");;
    Expect(0, 8297, '\p{Bidi_C=:\AN\z:}', "");;
    Expect(1, 8298, '\p{Bidi_C=n}', "");
    Expect(0, 8298, '\p{^Bidi_C=n}', "");
    Expect(0, 8298, '\P{Bidi_C=n}', "");
    Expect(1, 8298, '\P{^Bidi_C=n}', "");
    Expect(0, 8297, '\p{Bidi_C=n}', "");
    Expect(1, 8297, '\p{^Bidi_C=n}', "");
    Expect(1, 8297, '\P{Bidi_C=n}', "");
    Expect(0, 8297, '\P{^Bidi_C=n}', "");
    Expect(1, 8298, '\p{Bidi_C=:\An\z:}', "");;
    Expect(0, 8297, '\p{Bidi_C=:\An\z:}', "");;
    Expect(1, 8298, '\p{Bidi_C= 	N}', "");
    Expect(0, 8298, '\p{^Bidi_C= 	N}', "");
    Expect(0, 8298, '\P{Bidi_C= 	N}', "");
    Expect(1, 8298, '\P{^Bidi_C= 	N}', "");
    Expect(0, 8297, '\p{Bidi_C= 	N}', "");
    Expect(1, 8297, '\p{^Bidi_C= 	N}', "");
    Expect(1, 8297, '\P{Bidi_C= 	N}', "");
    Expect(0, 8297, '\P{^Bidi_C= 	N}', "");
    Error('\p{Is_Bidi_Control=:=_F}');
    Error('\P{Is_Bidi_Control=:=_F}');
    Expect(1, 8298, '\p{Is_Bidi_Control: f}', "");
    Expect(0, 8298, '\p{^Is_Bidi_Control: f}', "");
    Expect(0, 8298, '\P{Is_Bidi_Control: f}', "");
    Expect(1, 8298, '\P{^Is_Bidi_Control: f}', "");
    Expect(0, 8297, '\p{Is_Bidi_Control: f}', "");
    Expect(1, 8297, '\p{^Is_Bidi_Control: f}', "");
    Expect(1, 8297, '\P{Is_Bidi_Control: f}', "");
    Expect(0, 8297, '\P{^Is_Bidi_Control: f}', "");
    Expect(1, 8298, '\p{Is_Bidi_Control=	F}', "");
    Expect(0, 8298, '\p{^Is_Bidi_Control=	F}', "");
    Expect(0, 8298, '\P{Is_Bidi_Control=	F}', "");
    Expect(1, 8298, '\P{^Is_Bidi_Control=	F}', "");
    Expect(0, 8297, '\p{Is_Bidi_Control=	F}', "");
    Expect(1, 8297, '\p{^Is_Bidi_Control=	F}', "");
    Expect(1, 8297, '\P{Is_Bidi_Control=	F}', "");
    Expect(0, 8297, '\P{^Is_Bidi_Control=	F}', "");
    Error('\p{Is_Bidi_C=-false:=}');
    Error('\P{Is_Bidi_C=-false:=}');
    Expect(1, 8298, '\p{Is_Bidi_C=false}', "");
    Expect(0, 8298, '\p{^Is_Bidi_C=false}', "");
    Expect(0, 8298, '\P{Is_Bidi_C=false}', "");
    Expect(1, 8298, '\P{^Is_Bidi_C=false}', "");
    Expect(0, 8297, '\p{Is_Bidi_C=false}', "");
    Expect(1, 8297, '\p{^Is_Bidi_C=false}', "");
    Expect(1, 8297, '\P{Is_Bidi_C=false}', "");
    Expect(0, 8297, '\P{^Is_Bidi_C=false}', "");
    Expect(1, 8298, '\p{Is_Bidi_C=-FALSE}', "");
    Expect(0, 8298, '\p{^Is_Bidi_C=-FALSE}', "");
    Expect(0, 8298, '\P{Is_Bidi_C=-FALSE}', "");
    Expect(1, 8298, '\P{^Is_Bidi_C=-FALSE}', "");
    Expect(0, 8297, '\p{Is_Bidi_C=-FALSE}', "");
    Expect(1, 8297, '\p{^Is_Bidi_C=-FALSE}', "");
    Expect(1, 8297, '\P{Is_Bidi_C=-FALSE}', "");
    Expect(0, 8297, '\P{^Is_Bidi_C=-FALSE}', "");
    Error('\p{Bidi_Control=  Yes:=}');
    Error('\P{Bidi_Control=  Yes:=}');
    Expect(1, 8297, '\p{Bidi_Control=:\AYes\z:}', "");;
    Expect(0, 8298, '\p{Bidi_Control=:\AYes\z:}', "");;
    Expect(1, 8297, '\p{Bidi_Control=yes}', "");
    Expect(0, 8297, '\p{^Bidi_Control=yes}', "");
    Expect(0, 8297, '\P{Bidi_Control=yes}', "");
    Expect(1, 8297, '\P{^Bidi_Control=yes}', "");
    Expect(0, 8298, '\p{Bidi_Control=yes}', "");
    Expect(1, 8298, '\p{^Bidi_Control=yes}', "");
    Expect(1, 8298, '\P{Bidi_Control=yes}', "");
    Expect(0, 8298, '\P{^Bidi_Control=yes}', "");
    Expect(1, 8297, '\p{Bidi_Control=:\Ayes\z:}', "");;
    Expect(0, 8298, '\p{Bidi_Control=:\Ayes\z:}', "");;
    Expect(1, 8297, '\p{Bidi_Control=-YES}', "");
    Expect(0, 8297, '\p{^Bidi_Control=-YES}', "");
    Expect(0, 8297, '\P{Bidi_Control=-YES}', "");
    Expect(1, 8297, '\P{^Bidi_Control=-YES}', "");
    Expect(0, 8298, '\p{Bidi_Control=-YES}', "");
    Expect(1, 8298, '\p{^Bidi_Control=-YES}', "");
    Expect(1, 8298, '\P{Bidi_Control=-YES}', "");
    Expect(0, 8298, '\P{^Bidi_Control=-YES}', "");
    Error('\p{Bidi_C=/a/ Y}');
    Error('\P{Bidi_C=/a/ Y}');
    Expect(1, 8297, '\p{Bidi_C=:\AY\z:}', "");;
    Expect(0, 8298, '\p{Bidi_C=:\AY\z:}', "");;
    Expect(1, 8297, '\p{Bidi_C=y}', "");
    Expect(0, 8297, '\p{^Bidi_C=y}', "");
    Expect(0, 8297, '\P{Bidi_C=y}', "");
    Expect(1, 8297, '\P{^Bidi_C=y}', "");
    Expect(0, 8298, '\p{Bidi_C=y}', "");
    Expect(1, 8298, '\p{^Bidi_C=y}', "");
    Expect(1, 8298, '\P{Bidi_C=y}', "");
    Expect(0, 8298, '\P{^Bidi_C=y}', "");
    Expect(1, 8297, '\p{Bidi_C=:\Ay\z:}', "");;
    Expect(0, 8298, '\p{Bidi_C=:\Ay\z:}', "");;
    Expect(1, 8297, '\p{Bidi_C:Y}', "");
    Expect(0, 8297, '\p{^Bidi_C:Y}', "");
    Expect(0, 8297, '\P{Bidi_C:Y}', "");
    Expect(1, 8297, '\P{^Bidi_C:Y}', "");
    Expect(0, 8298, '\p{Bidi_C:Y}', "");
    Expect(1, 8298, '\p{^Bidi_C:Y}', "");
    Expect(1, 8298, '\P{Bidi_C:Y}', "");
    Expect(0, 8298, '\P{^Bidi_C:Y}', "");
    Error('\p{Is_Bidi_Control=/a/_T}');
    Error('\P{Is_Bidi_Control=/a/_T}');
    Expect(1, 8297, '\p{Is_Bidi_Control=t}', "");
    Expect(0, 8297, '\p{^Is_Bidi_Control=t}', "");
    Expect(0, 8297, '\P{Is_Bidi_Control=t}', "");
    Expect(1, 8297, '\P{^Is_Bidi_Control=t}', "");
    Expect(0, 8298, '\p{Is_Bidi_Control=t}', "");
    Expect(1, 8298, '\p{^Is_Bidi_Control=t}', "");
    Expect(1, 8298, '\P{Is_Bidi_Control=t}', "");
    Expect(0, 8298, '\P{^Is_Bidi_Control=t}', "");
    Expect(1, 8297, '\p{Is_Bidi_Control= T}', "");
    Expect(0, 8297, '\p{^Is_Bidi_Control= T}', "");
    Expect(0, 8297, '\P{Is_Bidi_Control= T}', "");
    Expect(1, 8297, '\P{^Is_Bidi_Control= T}', "");
    Expect(0, 8298, '\p{Is_Bidi_Control= T}', "");
    Expect(1, 8298, '\p{^Is_Bidi_Control= T}', "");
    Expect(1, 8298, '\P{Is_Bidi_Control= T}', "");
    Expect(0, 8298, '\P{^Is_Bidi_Control= T}', "");
    Error('\p{Is_Bidi_C=-True:=}');
    Error('\P{Is_Bidi_C=-True:=}');
    Expect(1, 8297, '\p{Is_Bidi_C=true}', "");
    Expect(0, 8297, '\p{^Is_Bidi_C=true}', "");
    Expect(0, 8297, '\P{Is_Bidi_C=true}', "");
    Expect(1, 8297, '\P{^Is_Bidi_C=true}', "");
    Expect(0, 8298, '\p{Is_Bidi_C=true}', "");
    Expect(1, 8298, '\p{^Is_Bidi_C=true}', "");
    Expect(1, 8298, '\P{Is_Bidi_C=true}', "");
    Expect(0, 8298, '\P{^Is_Bidi_C=true}', "");
    Expect(1, 8297, '\p{Is_Bidi_C=	TRUE}', "");
    Expect(0, 8297, '\p{^Is_Bidi_C=	TRUE}', "");
    Expect(0, 8297, '\P{Is_Bidi_C=	TRUE}', "");
    Expect(1, 8297, '\P{^Is_Bidi_C=	TRUE}', "");
    Expect(0, 8298, '\p{Is_Bidi_C=	TRUE}', "");
    Expect(1, 8298, '\p{^Is_Bidi_C=	TRUE}', "");
    Expect(1, 8298, '\P{Is_Bidi_C=	TRUE}', "");
    Expect(0, 8298, '\P{^Is_Bidi_C=	TRUE}', "");
    Error('\p{Bidi_Mirrored=	_No/a/}');
    Error('\P{Bidi_Mirrored=	_No/a/}');
    Expect(1, 120772, '\p{Bidi_Mirrored=:\ANo\z:}', "");;
    Expect(0, 120771, '\p{Bidi_Mirrored=:\ANo\z:}', "");;
    Expect(1, 120772, '\p{Bidi_Mirrored=no}', "");
    Expect(0, 120772, '\p{^Bidi_Mirrored=no}', "");
    Expect(0, 120772, '\P{Bidi_Mirrored=no}', "");
    Expect(1, 120772, '\P{^Bidi_Mirrored=no}', "");
    Expect(0, 120771, '\p{Bidi_Mirrored=no}', "");
    Expect(1, 120771, '\p{^Bidi_Mirrored=no}', "");
    Expect(1, 120771, '\P{Bidi_Mirrored=no}', "");
    Expect(0, 120771, '\P{^Bidi_Mirrored=no}', "");
    Expect(1, 120772, '\p{Bidi_Mirrored=:\Ano\z:}', "");;
    Expect(0, 120771, '\p{Bidi_Mirrored=:\Ano\z:}', "");;
    Expect(1, 120772, '\p{Bidi_Mirrored=  NO}', "");
    Expect(0, 120772, '\p{^Bidi_Mirrored=  NO}', "");
    Expect(0, 120772, '\P{Bidi_Mirrored=  NO}', "");
    Expect(1, 120772, '\P{^Bidi_Mirrored=  NO}', "");
    Expect(0, 120771, '\p{Bidi_Mirrored=  NO}', "");
    Expect(1, 120771, '\p{^Bidi_Mirrored=  NO}', "");
    Expect(1, 120771, '\P{Bidi_Mirrored=  NO}', "");
    Expect(0, 120771, '\P{^Bidi_Mirrored=  NO}', "");
    Error('\p{Bidi_M:	  N:=}');
    Error('\P{Bidi_M:	  N:=}');
    Expect(1, 120772, '\p{Bidi_M=:\AN\z:}', "");;
    Expect(0, 120771, '\p{Bidi_M=:\AN\z:}', "");;
    Expect(1, 120772, '\p{Bidi_M=n}', "");
    Expect(0, 120772, '\p{^Bidi_M=n}', "");
    Expect(0, 120772, '\P{Bidi_M=n}', "");
    Expect(1, 120772, '\P{^Bidi_M=n}', "");
    Expect(0, 120771, '\p{Bidi_M=n}', "");
    Expect(1, 120771, '\p{^Bidi_M=n}', "");
    Expect(1, 120771, '\P{Bidi_M=n}', "");
    Expect(0, 120771, '\P{^Bidi_M=n}', "");
    Expect(1, 120772, '\p{Bidi_M=:\An\z:}', "");;
    Expect(0, 120771, '\p{Bidi_M=:\An\z:}', "");;
    Expect(1, 120772, '\p{Bidi_M=_N}', "");
    Expect(0, 120772, '\p{^Bidi_M=_N}', "");
    Expect(0, 120772, '\P{Bidi_M=_N}', "");
    Expect(1, 120772, '\P{^Bidi_M=_N}', "");
    Expect(0, 120771, '\p{Bidi_M=_N}', "");
    Expect(1, 120771, '\p{^Bidi_M=_N}', "");
    Expect(1, 120771, '\P{Bidi_M=_N}', "");
    Expect(0, 120771, '\P{^Bidi_M=_N}', "");
    Error('\p{Is_Bidi_Mirrored=:=-F}');
    Error('\P{Is_Bidi_Mirrored=:=-F}');
    Expect(1, 120772, '\p{Is_Bidi_Mirrored=f}', "");
    Expect(0, 120772, '\p{^Is_Bidi_Mirrored=f}', "");
    Expect(0, 120772, '\P{Is_Bidi_Mirrored=f}', "");
    Expect(1, 120772, '\P{^Is_Bidi_Mirrored=f}', "");
    Expect(0, 120771, '\p{Is_Bidi_Mirrored=f}', "");
    Expect(1, 120771, '\p{^Is_Bidi_Mirrored=f}', "");
    Expect(1, 120771, '\P{Is_Bidi_Mirrored=f}', "");
    Expect(0, 120771, '\P{^Is_Bidi_Mirrored=f}', "");
    Expect(1, 120772, '\p{Is_Bidi_Mirrored=-	f}', "");
    Expect(0, 120772, '\p{^Is_Bidi_Mirrored=-	f}', "");
    Expect(0, 120772, '\P{Is_Bidi_Mirrored=-	f}', "");
    Expect(1, 120772, '\P{^Is_Bidi_Mirrored=-	f}', "");
    Expect(0, 120771, '\p{Is_Bidi_Mirrored=-	f}', "");
    Expect(1, 120771, '\p{^Is_Bidi_Mirrored=-	f}', "");
    Expect(1, 120771, '\P{Is_Bidi_Mirrored=-	f}', "");
    Expect(0, 120771, '\P{^Is_Bidi_Mirrored=-	f}', "");
    Error('\p{Is_Bidi_M=:=	 false}');
    Error('\P{Is_Bidi_M=:=	 false}');
    Expect(1, 120772, '\p{Is_Bidi_M=false}', "");
    Expect(0, 120772, '\p{^Is_Bidi_M=false}', "");
    Expect(0, 120772, '\P{Is_Bidi_M=false}', "");
    Expect(1, 120772, '\P{^Is_Bidi_M=false}', "");
    Expect(0, 120771, '\p{Is_Bidi_M=false}', "");
    Expect(1, 120771, '\p{^Is_Bidi_M=false}', "");
    Expect(1, 120771, '\P{Is_Bidi_M=false}', "");
    Expect(0, 120771, '\P{^Is_Bidi_M=false}', "");
    Expect(1, 120772, '\p{Is_Bidi_M: -False}', "");
    Expect(0, 120772, '\p{^Is_Bidi_M: -False}', "");
    Expect(0, 120772, '\P{Is_Bidi_M: -False}', "");
    Expect(1, 120772, '\P{^Is_Bidi_M: -False}', "");
    Expect(0, 120771, '\p{Is_Bidi_M: -False}', "");
    Expect(1, 120771, '\p{^Is_Bidi_M: -False}', "");
    Expect(1, 120771, '\P{Is_Bidi_M: -False}', "");
    Expect(0, 120771, '\P{^Is_Bidi_M: -False}', "");
    Error('\p{Bidi_Mirrored=-:=Yes}');
    Error('\P{Bidi_Mirrored=-:=Yes}');
    Expect(1, 120771, '\p{Bidi_Mirrored=:\AYes\z:}', "");;
    Expect(0, 120772, '\p{Bidi_Mirrored=:\AYes\z:}', "");;
    Expect(1, 120771, '\p{Bidi_Mirrored=yes}', "");
    Expect(0, 120771, '\p{^Bidi_Mirrored=yes}', "");
    Expect(0, 120771, '\P{Bidi_Mirrored=yes}', "");
    Expect(1, 120771, '\P{^Bidi_Mirrored=yes}', "");
    Expect(0, 120772, '\p{Bidi_Mirrored=yes}', "");
    Expect(1, 120772, '\p{^Bidi_Mirrored=yes}', "");
    Expect(1, 120772, '\P{Bidi_Mirrored=yes}', "");
    Expect(0, 120772, '\P{^Bidi_Mirrored=yes}', "");
    Expect(1, 120771, '\p{Bidi_Mirrored=:\Ayes\z:}', "");;
    Expect(0, 120772, '\p{Bidi_Mirrored=:\Ayes\z:}', "");;
    Expect(1, 120771, '\p{Bidi_Mirrored=- Yes}', "");
    Expect(0, 120771, '\p{^Bidi_Mirrored=- Yes}', "");
    Expect(0, 120771, '\P{Bidi_Mirrored=- Yes}', "");
    Expect(1, 120771, '\P{^Bidi_Mirrored=- Yes}', "");
    Expect(0, 120772, '\p{Bidi_Mirrored=- Yes}', "");
    Expect(1, 120772, '\p{^Bidi_Mirrored=- Yes}', "");
    Expect(1, 120772, '\P{Bidi_Mirrored=- Yes}', "");
    Expect(0, 120772, '\P{^Bidi_Mirrored=- Yes}', "");
    Error('\p{Bidi_M=__y/a/}');
    Error('\P{Bidi_M=__y/a/}');
    Expect(1, 120771, '\p{Bidi_M=:\AY\z:}', "");;
    Expect(0, 120772, '\p{Bidi_M=:\AY\z:}', "");;
    Expect(1, 120771, '\p{Bidi_M=y}', "");
    Expect(0, 120771, '\p{^Bidi_M=y}', "");
    Expect(0, 120771, '\P{Bidi_M=y}', "");
    Expect(1, 120771, '\P{^Bidi_M=y}', "");
    Expect(0, 120772, '\p{Bidi_M=y}', "");
    Expect(1, 120772, '\p{^Bidi_M=y}', "");
    Expect(1, 120772, '\P{Bidi_M=y}', "");
    Expect(0, 120772, '\P{^Bidi_M=y}', "");
    Expect(1, 120771, '\p{Bidi_M=:\Ay\z:}', "");;
    Expect(0, 120772, '\p{Bidi_M=:\Ay\z:}', "");;
    Expect(1, 120771, '\p{Bidi_M=	y}', "");
    Expect(0, 120771, '\p{^Bidi_M=	y}', "");
    Expect(0, 120771, '\P{Bidi_M=	y}', "");
    Expect(1, 120771, '\P{^Bidi_M=	y}', "");
    Expect(0, 120772, '\p{Bidi_M=	y}', "");
    Expect(1, 120772, '\p{^Bidi_M=	y}', "");
    Expect(1, 120772, '\P{Bidi_M=	y}', "");
    Expect(0, 120772, '\P{^Bidi_M=	y}', "");
    Error('\p{Is_Bidi_Mirrored=:=T}');
    Error('\P{Is_Bidi_Mirrored=:=T}');
    Expect(1, 120771, '\p{Is_Bidi_Mirrored=t}', "");
    Expect(0, 120771, '\p{^Is_Bidi_Mirrored=t}', "");
    Expect(0, 120771, '\P{Is_Bidi_Mirrored=t}', "");
    Expect(1, 120771, '\P{^Is_Bidi_Mirrored=t}', "");
    Expect(0, 120772, '\p{Is_Bidi_Mirrored=t}', "");
    Expect(1, 120772, '\p{^Is_Bidi_Mirrored=t}', "");
    Expect(1, 120772, '\P{Is_Bidi_Mirrored=t}', "");
    Expect(0, 120772, '\P{^Is_Bidi_Mirrored=t}', "");
    Expect(1, 120771, '\p{Is_Bidi_Mirrored=_ T}', "");
    Expect(0, 120771, '\p{^Is_Bidi_Mirrored=_ T}', "");
    Expect(0, 120771, '\P{Is_Bidi_Mirrored=_ T}', "");
    Expect(1, 120771, '\P{^Is_Bidi_Mirrored=_ T}', "");
    Expect(0, 120772, '\p{Is_Bidi_Mirrored=_ T}', "");
    Expect(1, 120772, '\p{^Is_Bidi_Mirrored=_ T}', "");
    Expect(1, 120772, '\P{Is_Bidi_Mirrored=_ T}', "");
    Expect(0, 120772, '\P{^Is_Bidi_Mirrored=_ T}', "");
    Error('\p{Is_Bidi_M=_-true/a/}');
    Error('\P{Is_Bidi_M=_-true/a/}');
    Expect(1, 120771, '\p{Is_Bidi_M=true}', "");
    Expect(0, 120771, '\p{^Is_Bidi_M=true}', "");
    Expect(0, 120771, '\P{Is_Bidi_M=true}', "");
    Expect(1, 120771, '\P{^Is_Bidi_M=true}', "");
    Expect(0, 120772, '\p{Is_Bidi_M=true}', "");
    Expect(1, 120772, '\p{^Is_Bidi_M=true}', "");
    Expect(1, 120772, '\P{Is_Bidi_M=true}', "");
    Expect(0, 120772, '\P{^Is_Bidi_M=true}', "");
    Expect(1, 120771, '\p{Is_Bidi_M= -TRUE}', "");
    Expect(0, 120771, '\p{^Is_Bidi_M= -TRUE}', "");
    Expect(0, 120771, '\P{Is_Bidi_M= -TRUE}', "");
    Expect(1, 120771, '\P{^Is_Bidi_M= -TRUE}', "");
    Expect(0, 120772, '\p{Is_Bidi_M= -TRUE}', "");
    Expect(1, 120772, '\p{^Is_Bidi_M= -TRUE}', "");
    Expect(1, 120772, '\P{Is_Bidi_M= -TRUE}', "");
    Expect(0, 120772, '\P{^Is_Bidi_M= -TRUE}', "");
    Error('\p{block}');
    Error('\P{block}');
    Error('\p{blk}');
    Error('\P{blk}');
    Error('\p{Block=:=	-Adlam}');
    Error('\P{Block=:=	-Adlam}');
    Expect(1, 125279, '\p{Block=:\AAdlam\z:}', "");;
    Expect(0, 125280, '\p{Block=:\AAdlam\z:}', "");;
    Expect(1, 125279, '\p{Block=adlam}', "");
    Expect(0, 125279, '\p{^Block=adlam}', "");
    Expect(0, 125279, '\P{Block=adlam}', "");
    Expect(1, 125279, '\P{^Block=adlam}', "");
    Expect(0, 125280, '\p{Block=adlam}', "");
    Expect(1, 125280, '\p{^Block=adlam}', "");
    Expect(1, 125280, '\P{Block=adlam}', "");
    Expect(0, 125280, '\P{^Block=adlam}', "");
    Expect(1, 125279, '\p{Block=:\Aadlam\z:}', "");;
    Expect(0, 125280, '\p{Block=:\Aadlam\z:}', "");;
    Expect(1, 125279, '\p{Block=	-ADLAM}', "");
    Expect(0, 125279, '\p{^Block=	-ADLAM}', "");
    Expect(0, 125279, '\P{Block=	-ADLAM}', "");
    Expect(1, 125279, '\P{^Block=	-ADLAM}', "");
    Expect(0, 125280, '\p{Block=	-ADLAM}', "");
    Expect(1, 125280, '\p{^Block=	-ADLAM}', "");
    Expect(1, 125280, '\P{Block=	-ADLAM}', "");
    Expect(0, 125280, '\P{^Block=	-ADLAM}', "");
    Error('\p{Blk=:=_	ADLAM}');
    Error('\P{Blk=:=_	ADLAM}');
    Expect(1, 125279, '\p{Blk=:\AAdlam\z:}', "");;
    Expect(0, 125280, '\p{Blk=:\AAdlam\z:}', "");;
    Expect(1, 125279, '\p{Blk=adlam}', "");
    Expect(0, 125279, '\p{^Blk=adlam}', "");
    Expect(0, 125279, '\P{Blk=adlam}', "");
    Expect(1, 125279, '\P{^Blk=adlam}', "");
    Expect(0, 125280, '\p{Blk=adlam}', "");
    Expect(1, 125280, '\p{^Blk=adlam}', "");
    Expect(1, 125280, '\P{Blk=adlam}', "");
    Expect(0, 125280, '\P{^Blk=adlam}', "");
    Expect(1, 125279, '\p{Blk=:\Aadlam\z:}', "");;
    Expect(0, 125280, '\p{Blk=:\Aadlam\z:}', "");;
    Expect(1, 125279, '\p{Blk= 	Adlam}', "");
    Expect(0, 125279, '\p{^Blk= 	Adlam}', "");
    Expect(0, 125279, '\P{Blk= 	Adlam}', "");
    Expect(1, 125279, '\P{^Blk= 	Adlam}', "");
    Expect(0, 125280, '\p{Blk= 	Adlam}', "");
    Expect(1, 125280, '\p{^Blk= 	Adlam}', "");
    Expect(1, 125280, '\P{Blk= 	Adlam}', "");
    Expect(0, 125280, '\P{^Blk= 	Adlam}', "");
    Error('\p{Is_Block:	_-ADLAM/a/}');
    Error('\P{Is_Block:	_-ADLAM/a/}');
    Expect(1, 125279, '\p{Is_Block=adlam}', "");
    Expect(0, 125279, '\p{^Is_Block=adlam}', "");
    Expect(0, 125279, '\P{Is_Block=adlam}', "");
    Expect(1, 125279, '\P{^Is_Block=adlam}', "");
    Expect(0, 125280, '\p{Is_Block=adlam}', "");
    Expect(1, 125280, '\p{^Is_Block=adlam}', "");
    Expect(1, 125280, '\P{Is_Block=adlam}', "");
    Expect(0, 125280, '\P{^Is_Block=adlam}', "");
    Expect(1, 125279, '\p{Is_Block=__Adlam}', "");
    Expect(0, 125279, '\p{^Is_Block=__Adlam}', "");
    Expect(0, 125279, '\P{Is_Block=__Adlam}', "");
    Expect(1, 125279, '\P{^Is_Block=__Adlam}', "");
    Expect(0, 125280, '\p{Is_Block=__Adlam}', "");
    Expect(1, 125280, '\p{^Is_Block=__Adlam}', "");
    Expect(1, 125280, '\P{Is_Block=__Adlam}', "");
    Expect(0, 125280, '\P{^Is_Block=__Adlam}', "");
    Error('\p{Is_Blk=- adlam/a/}');
    Error('\P{Is_Blk=- adlam/a/}');
    Expect(1, 125279, '\p{Is_Blk=adlam}', "");
    Expect(0, 125279, '\p{^Is_Blk=adlam}', "");
    Expect(0, 125279, '\P{Is_Blk=adlam}', "");
    Expect(1, 125279, '\P{^Is_Blk=adlam}', "");
    Expect(0, 125280, '\p{Is_Blk=adlam}', "");
    Expect(1, 125280, '\p{^Is_Blk=adlam}', "");
    Expect(1, 125280, '\P{Is_Blk=adlam}', "");
    Expect(0, 125280, '\P{^Is_Blk=adlam}', "");
    Expect(1, 125279, '\p{Is_Blk=-_ADLAM}', "");
    Expect(0, 125279, '\p{^Is_Blk=-_ADLAM}', "");
    Expect(0, 125279, '\P{Is_Blk=-_ADLAM}', "");
    Expect(1, 125279, '\P{^Is_Blk=-_ADLAM}', "");
    Expect(0, 125280, '\p{Is_Blk=-_ADLAM}', "");
    Expect(1, 125280, '\p{^Is_Blk=-_ADLAM}', "");
    Expect(1, 125280, '\P{Is_Blk=-_ADLAM}', "");
    Expect(0, 125280, '\P{^Is_Blk=-_ADLAM}', "");
    Error('\p{Block=:=Aegean_numbers}');
    Error('\P{Block=:=Aegean_numbers}');
    Expect(1, 65855, '\p{Block=:\AAegean_Numbers\z:}', "");;
    Expect(0, 65856, '\p{Block=:\AAegean_Numbers\z:}', "");;
    Expect(1, 65855, '\p{Block=aegeannumbers}', "");
    Expect(0, 65855, '\p{^Block=aegeannumbers}', "");
    Expect(0, 65855, '\P{Block=aegeannumbers}', "");
    Expect(1, 65855, '\P{^Block=aegeannumbers}', "");
    Expect(0, 65856, '\p{Block=aegeannumbers}', "");
    Expect(1, 65856, '\p{^Block=aegeannumbers}', "");
    Expect(1, 65856, '\P{Block=aegeannumbers}', "");
    Expect(0, 65856, '\P{^Block=aegeannumbers}', "");
    Expect(1, 65855, '\p{Block=:\Aaegeannumbers\z:}', "");;
    Expect(0, 65856, '\p{Block=:\Aaegeannumbers\z:}', "");;
    Expect(1, 65855, '\p{Block=_-Aegean_Numbers}', "");
    Expect(0, 65855, '\p{^Block=_-Aegean_Numbers}', "");
    Expect(0, 65855, '\P{Block=_-Aegean_Numbers}', "");
    Expect(1, 65855, '\P{^Block=_-Aegean_Numbers}', "");
    Expect(0, 65856, '\p{Block=_-Aegean_Numbers}', "");
    Expect(1, 65856, '\p{^Block=_-Aegean_Numbers}', "");
    Expect(1, 65856, '\P{Block=_-Aegean_Numbers}', "");
    Expect(0, 65856, '\P{^Block=_-Aegean_Numbers}', "");
    Error('\p{Blk=/a/AEGEAN_NUMBERS}');
    Error('\P{Blk=/a/AEGEAN_NUMBERS}');
    Expect(1, 65855, '\p{Blk=:\AAegean_Numbers\z:}', "");;
    Expect(0, 65856, '\p{Blk=:\AAegean_Numbers\z:}', "");;
    Expect(1, 65855, '\p{Blk=aegeannumbers}', "");
    Expect(0, 65855, '\p{^Blk=aegeannumbers}', "");
    Expect(0, 65855, '\P{Blk=aegeannumbers}', "");
    Expect(1, 65855, '\P{^Blk=aegeannumbers}', "");
    Expect(0, 65856, '\p{Blk=aegeannumbers}', "");
    Expect(1, 65856, '\p{^Blk=aegeannumbers}', "");
    Expect(1, 65856, '\P{Blk=aegeannumbers}', "");
    Expect(0, 65856, '\P{^Blk=aegeannumbers}', "");
    Expect(1, 65855, '\p{Blk=:\Aaegeannumbers\z:}', "");;
    Expect(0, 65856, '\p{Blk=:\Aaegeannumbers\z:}', "");;
    Expect(1, 65855, '\p{Blk=-	AEGEAN_numbers}', "");
    Expect(0, 65855, '\p{^Blk=-	AEGEAN_numbers}', "");
    Expect(0, 65855, '\P{Blk=-	AEGEAN_numbers}', "");
    Expect(1, 65855, '\P{^Blk=-	AEGEAN_numbers}', "");
    Expect(0, 65856, '\p{Blk=-	AEGEAN_numbers}', "");
    Expect(1, 65856, '\p{^Blk=-	AEGEAN_numbers}', "");
    Expect(1, 65856, '\P{Blk=-	AEGEAN_numbers}', "");
    Expect(0, 65856, '\P{^Blk=-	AEGEAN_numbers}', "");
    Error('\p{Is_Block=/a/	 aegean_numbers}');
    Error('\P{Is_Block=/a/	 aegean_numbers}');
    Expect(1, 65855, '\p{Is_Block=aegeannumbers}', "");
    Expect(0, 65855, '\p{^Is_Block=aegeannumbers}', "");
    Expect(0, 65855, '\P{Is_Block=aegeannumbers}', "");
    Expect(1, 65855, '\P{^Is_Block=aegeannumbers}', "");
    Expect(0, 65856, '\p{Is_Block=aegeannumbers}', "");
    Expect(1, 65856, '\p{^Is_Block=aegeannumbers}', "");
    Expect(1, 65856, '\P{Is_Block=aegeannumbers}', "");
    Expect(0, 65856, '\P{^Is_Block=aegeannumbers}', "");
    Expect(1, 65855, '\p{Is_Block=	 Aegean_Numbers}', "");
    Expect(0, 65855, '\p{^Is_Block=	 Aegean_Numbers}', "");
    Expect(0, 65855, '\P{Is_Block=	 Aegean_Numbers}', "");
    Expect(1, 65855, '\P{^Is_Block=	 Aegean_Numbers}', "");
    Expect(0, 65856, '\p{Is_Block=	 Aegean_Numbers}', "");
    Expect(1, 65856, '\p{^Is_Block=	 Aegean_Numbers}', "");
    Expect(1, 65856, '\P{Is_Block=	 Aegean_Numbers}', "");
    Expect(0, 65856, '\P{^Is_Block=	 Aegean_Numbers}', "");
    Error('\p{Is_Blk=-aegean_Numbers:=}');
    Error('\P{Is_Blk=-aegean_Numbers:=}');
    Expect(1, 65855, '\p{Is_Blk=aegeannumbers}', "");
    Expect(0, 65855, '\p{^Is_Blk=aegeannumbers}', "");
    Expect(0, 65855, '\P{Is_Blk=aegeannumbers}', "");
    Expect(1, 65855, '\P{^Is_Blk=aegeannumbers}', "");
    Expect(0, 65856, '\p{Is_Blk=aegeannumbers}', "");
    Expect(1, 65856, '\p{^Is_Blk=aegeannumbers}', "");
    Expect(1, 65856, '\P{Is_Blk=aegeannumbers}', "");
    Expect(0, 65856, '\P{^Is_Blk=aegeannumbers}', "");
    Expect(1, 65855, '\p{Is_Blk=	_Aegean_numbers}', "");
    Expect(0, 65855, '\p{^Is_Blk=	_Aegean_numbers}', "");
    Expect(0, 65855, '\P{Is_Blk=	_Aegean_numbers}', "");
    Expect(1, 65855, '\P{^Is_Blk=	_Aegean_numbers}', "");
    Expect(0, 65856, '\p{Is_Blk=	_Aegean_numbers}', "");
    Expect(1, 65856, '\p{^Is_Blk=	_Aegean_numbers}', "");
    Expect(1, 65856, '\P{Is_Blk=	_Aegean_numbers}', "");
    Expect(0, 65856, '\P{^Is_Blk=	_Aegean_numbers}', "");
    Error('\p{Block=_/a/ahom}');
    Error('\P{Block=_/a/ahom}');
    Expect(1, 71503, '\p{Block=:\AAhom\z:}', "");;
    Expect(0, 71504, '\p{Block=:\AAhom\z:}', "");;
    Expect(1, 71503, '\p{Block=ahom}', "");
    Expect(0, 71503, '\p{^Block=ahom}', "");
    Expect(0, 71503, '\P{Block=ahom}', "");
    Expect(1, 71503, '\P{^Block=ahom}', "");
    Expect(0, 71504, '\p{Block=ahom}', "");
    Expect(1, 71504, '\p{^Block=ahom}', "");
    Expect(1, 71504, '\P{Block=ahom}', "");
    Expect(0, 71504, '\P{^Block=ahom}', "");
    Expect(1, 71503, '\p{Block=:\Aahom\z:}', "");;
    Expect(0, 71504, '\p{Block=:\Aahom\z:}', "");;
    Expect(1, 71503, '\p{Block=Ahom}', "");
    Expect(0, 71503, '\p{^Block=Ahom}', "");
    Expect(0, 71503, '\P{Block=Ahom}', "");
    Expect(1, 71503, '\P{^Block=Ahom}', "");
    Expect(0, 71504, '\p{Block=Ahom}', "");
    Expect(1, 71504, '\p{^Block=Ahom}', "");
    Expect(1, 71504, '\P{Block=Ahom}', "");
    Expect(0, 71504, '\P{^Block=Ahom}', "");
    Error('\p{Blk:   _/a/ahom}');
    Error('\P{Blk:   _/a/ahom}');
    Expect(1, 71503, '\p{Blk=:\AAhom\z:}', "");;
    Expect(0, 71504, '\p{Blk=:\AAhom\z:}', "");;
    Expect(1, 71503, '\p{Blk=ahom}', "");
    Expect(0, 71503, '\p{^Blk=ahom}', "");
    Expect(0, 71503, '\P{Blk=ahom}', "");
    Expect(1, 71503, '\P{^Blk=ahom}', "");
    Expect(0, 71504, '\p{Blk=ahom}', "");
    Expect(1, 71504, '\p{^Blk=ahom}', "");
    Expect(1, 71504, '\P{Blk=ahom}', "");
    Expect(0, 71504, '\P{^Blk=ahom}', "");
    Expect(1, 71503, '\p{Blk=:\Aahom\z:}', "");;
    Expect(0, 71504, '\p{Blk=:\Aahom\z:}', "");;
    Expect(1, 71503, '\p{Blk= -ahom}', "");
    Expect(0, 71503, '\p{^Blk= -ahom}', "");
    Expect(0, 71503, '\P{Blk= -ahom}', "");
    Expect(1, 71503, '\P{^Blk= -ahom}', "");
    Expect(0, 71504, '\p{Blk= -ahom}', "");
    Expect(1, 71504, '\p{^Blk= -ahom}', "");
    Expect(1, 71504, '\P{Blk= -ahom}', "");
    Expect(0, 71504, '\P{^Blk= -ahom}', "");
    Error('\p{Is_Block=/a/--ahom}');
    Error('\P{Is_Block=/a/--ahom}');
    Expect(1, 71503, '\p{Is_Block=ahom}', "");
    Expect(0, 71503, '\p{^Is_Block=ahom}', "");
    Expect(0, 71503, '\P{Is_Block=ahom}', "");
    Expect(1, 71503, '\P{^Is_Block=ahom}', "");
    Expect(0, 71504, '\p{Is_Block=ahom}', "");
    Expect(1, 71504, '\p{^Is_Block=ahom}', "");
    Expect(1, 71504, '\P{Is_Block=ahom}', "");
    Expect(0, 71504, '\P{^Is_Block=ahom}', "");
    Expect(1, 71503, '\p{Is_Block= ahom}', "");
    Expect(0, 71503, '\p{^Is_Block= ahom}', "");
    Expect(0, 71503, '\P{Is_Block= ahom}', "");
    Expect(1, 71503, '\P{^Is_Block= ahom}', "");
    Expect(0, 71504, '\p{Is_Block= ahom}', "");
    Expect(1, 71504, '\p{^Is_Block= ahom}', "");
    Expect(1, 71504, '\P{Is_Block= ahom}', "");
    Expect(0, 71504, '\P{^Is_Block= ahom}', "");
    Error('\p{Is_Blk:		/a/AHOM}');
    Error('\P{Is_Blk:		/a/AHOM}');
    Expect(1, 71503, '\p{Is_Blk:ahom}', "");
    Expect(0, 71503, '\p{^Is_Blk:ahom}', "");
    Expect(0, 71503, '\P{Is_Blk:ahom}', "");
    Expect(1, 71503, '\P{^Is_Blk:ahom}', "");
    Expect(0, 71504, '\p{Is_Blk:ahom}', "");
    Expect(1, 71504, '\p{^Is_Blk:ahom}', "");
    Expect(1, 71504, '\P{Is_Blk:ahom}', "");
    Expect(0, 71504, '\P{^Is_Blk:ahom}', "");
    Expect(1, 71503, '\p{Is_Blk= ahom}', "");
    Expect(0, 71503, '\p{^Is_Blk= ahom}', "");
    Expect(0, 71503, '\P{Is_Blk= ahom}', "");
    Expect(1, 71503, '\P{^Is_Blk= ahom}', "");
    Expect(0, 71504, '\p{Is_Blk= ahom}', "");
    Expect(1, 71504, '\p{^Is_Blk= ahom}', "");
    Expect(1, 71504, '\P{Is_Blk= ahom}', "");
    Expect(0, 71504, '\P{^Is_Blk= ahom}', "");
    Error('\p{Block:   	:=alchemical_Symbols}');
    Error('\P{Block:   	:=alchemical_Symbols}');
    Expect(1, 128895, '\p{Block=:\AAlchemical_Symbols\z:}', "");;
    Expect(0, 128896, '\p{Block=:\AAlchemical_Symbols\z:}', "");;
    Expect(1, 128895, '\p{Block=alchemicalsymbols}', "");
    Expect(0, 128895, '\p{^Block=alchemicalsymbols}', "");
    Expect(0, 128895, '\P{Block=alchemicalsymbols}', "");
    Expect(1, 128895, '\P{^Block=alchemicalsymbols}', "");
    Expect(0, 128896, '\p{Block=alchemicalsymbols}', "");
    Expect(1, 128896, '\p{^Block=alchemicalsymbols}', "");
    Expect(1, 128896, '\P{Block=alchemicalsymbols}', "");
    Expect(0, 128896, '\P{^Block=alchemicalsymbols}', "");
    Expect(1, 128895, '\p{Block=:\Aalchemicalsymbols\z:}', "");;
    Expect(0, 128896, '\p{Block=:\Aalchemicalsymbols\z:}', "");;
    Expect(1, 128895, '\p{Block=_-ALCHEMICAL_Symbols}', "");
    Expect(0, 128895, '\p{^Block=_-ALCHEMICAL_Symbols}', "");
    Expect(0, 128895, '\P{Block=_-ALCHEMICAL_Symbols}', "");
    Expect(1, 128895, '\P{^Block=_-ALCHEMICAL_Symbols}', "");
    Expect(0, 128896, '\p{Block=_-ALCHEMICAL_Symbols}', "");
    Expect(1, 128896, '\p{^Block=_-ALCHEMICAL_Symbols}', "");
    Expect(1, 128896, '\P{Block=_-ALCHEMICAL_Symbols}', "");
    Expect(0, 128896, '\P{^Block=_-ALCHEMICAL_Symbols}', "");
    Error('\p{Blk=:=ALCHEMICAL}');
    Error('\P{Blk=:=ALCHEMICAL}');
    Expect(1, 128895, '\p{Blk=:\AAlchemical\z:}', "");;
    Expect(0, 128896, '\p{Blk=:\AAlchemical\z:}', "");;
    Expect(1, 128895, '\p{Blk: alchemical}', "");
    Expect(0, 128895, '\p{^Blk: alchemical}', "");
    Expect(0, 128895, '\P{Blk: alchemical}', "");
    Expect(1, 128895, '\P{^Blk: alchemical}', "");
    Expect(0, 128896, '\p{Blk: alchemical}', "");
    Expect(1, 128896, '\p{^Blk: alchemical}', "");
    Expect(1, 128896, '\P{Blk: alchemical}', "");
    Expect(0, 128896, '\P{^Blk: alchemical}', "");
    Expect(1, 128895, '\p{Blk=:\Aalchemical\z:}', "");;
    Expect(0, 128896, '\p{Blk=:\Aalchemical\z:}', "");;
    Expect(1, 128895, '\p{Blk=--Alchemical}', "");
    Expect(0, 128895, '\p{^Blk=--Alchemical}', "");
    Expect(0, 128895, '\P{Blk=--Alchemical}', "");
    Expect(1, 128895, '\P{^Blk=--Alchemical}', "");
    Expect(0, 128896, '\p{Blk=--Alchemical}', "");
    Expect(1, 128896, '\p{^Blk=--Alchemical}', "");
    Expect(1, 128896, '\P{Blk=--Alchemical}', "");
    Expect(0, 128896, '\P{^Blk=--Alchemical}', "");
    Error('\p{Is_Block=		Alchemical_Symbols/a/}');
    Error('\P{Is_Block=		Alchemical_Symbols/a/}');
    Expect(1, 128895, '\p{Is_Block=alchemicalsymbols}', "");
    Expect(0, 128895, '\p{^Is_Block=alchemicalsymbols}', "");
    Expect(0, 128895, '\P{Is_Block=alchemicalsymbols}', "");
    Expect(1, 128895, '\P{^Is_Block=alchemicalsymbols}', "");
    Expect(0, 128896, '\p{Is_Block=alchemicalsymbols}', "");
    Expect(1, 128896, '\p{^Is_Block=alchemicalsymbols}', "");
    Expect(1, 128896, '\P{Is_Block=alchemicalsymbols}', "");
    Expect(0, 128896, '\P{^Is_Block=alchemicalsymbols}', "");
    Expect(1, 128895, '\p{Is_Block=_Alchemical_Symbols}', "");
    Expect(0, 128895, '\p{^Is_Block=_Alchemical_Symbols}', "");
    Expect(0, 128895, '\P{Is_Block=_Alchemical_Symbols}', "");
    Expect(1, 128895, '\P{^Is_Block=_Alchemical_Symbols}', "");
    Expect(0, 128896, '\p{Is_Block=_Alchemical_Symbols}', "");
    Expect(1, 128896, '\p{^Is_Block=_Alchemical_Symbols}', "");
    Expect(1, 128896, '\P{Is_Block=_Alchemical_Symbols}', "");
    Expect(0, 128896, '\P{^Is_Block=_Alchemical_Symbols}', "");
    Error('\p{Is_Blk=--Alchemical/a/}');
    Error('\P{Is_Blk=--Alchemical/a/}');
    Expect(1, 128895, '\p{Is_Blk:alchemical}', "");
    Expect(0, 128895, '\p{^Is_Blk:alchemical}', "");
    Expect(0, 128895, '\P{Is_Blk:alchemical}', "");
    Expect(1, 128895, '\P{^Is_Blk:alchemical}', "");
    Expect(0, 128896, '\p{Is_Blk:alchemical}', "");
    Expect(1, 128896, '\p{^Is_Blk:alchemical}', "");
    Expect(1, 128896, '\P{Is_Blk:alchemical}', "");
    Expect(0, 128896, '\P{^Is_Blk:alchemical}', "");
    Expect(1, 128895, '\p{Is_Blk=	 ALCHEMICAL}', "");
    Expect(0, 128895, '\p{^Is_Blk=	 ALCHEMICAL}', "");
    Expect(0, 128895, '\P{Is_Blk=	 ALCHEMICAL}', "");
    Expect(1, 128895, '\P{^Is_Blk=	 ALCHEMICAL}', "");
    Expect(0, 128896, '\p{Is_Blk=	 ALCHEMICAL}', "");
    Expect(1, 128896, '\p{^Is_Blk=	 ALCHEMICAL}', "");
    Expect(1, 128896, '\P{Is_Blk=	 ALCHEMICAL}', "");
    Expect(0, 128896, '\P{^Is_Blk=	 ALCHEMICAL}', "");
    Error('\p{Block=		Alphabetic_presentation_FORMS:=}');
    Error('\P{Block=		Alphabetic_presentation_FORMS:=}');
    Expect(1, 64335, '\p{Block=:\AAlphabetic_Presentation_Forms\z:}', "");;
    Expect(0, 64336, '\p{Block=:\AAlphabetic_Presentation_Forms\z:}', "");;
    Expect(1, 64335, '\p{Block=alphabeticpresentationforms}', "");
    Expect(0, 64335, '\p{^Block=alphabeticpresentationforms}', "");
    Expect(0, 64335, '\P{Block=alphabeticpresentationforms}', "");
    Expect(1, 64335, '\P{^Block=alphabeticpresentationforms}', "");
    Expect(0, 64336, '\p{Block=alphabeticpresentationforms}', "");
    Expect(1, 64336, '\p{^Block=alphabeticpresentationforms}', "");
    Expect(1, 64336, '\P{Block=alphabeticpresentationforms}', "");
    Expect(0, 64336, '\P{^Block=alphabeticpresentationforms}', "");
    Expect(1, 64335, '\p{Block=:\Aalphabeticpresentationforms\z:}', "");;
    Expect(0, 64336, '\p{Block=:\Aalphabeticpresentationforms\z:}', "");;
    Expect(1, 64335, '\p{Block=-	alphabetic_Presentation_forms}', "");
    Expect(0, 64335, '\p{^Block=-	alphabetic_Presentation_forms}', "");
    Expect(0, 64335, '\P{Block=-	alphabetic_Presentation_forms}', "");
    Expect(1, 64335, '\P{^Block=-	alphabetic_Presentation_forms}', "");
    Expect(0, 64336, '\p{Block=-	alphabetic_Presentation_forms}', "");
    Expect(1, 64336, '\p{^Block=-	alphabetic_Presentation_forms}', "");
    Expect(1, 64336, '\P{Block=-	alphabetic_Presentation_forms}', "");
    Expect(0, 64336, '\P{^Block=-	alphabetic_Presentation_forms}', "");
    Error('\p{Blk=/a/Alphabetic_PF}');
    Error('\P{Blk=/a/Alphabetic_PF}');
    Expect(1, 64335, '\p{Blk=:\AAlphabetic_PF\z:}', "");;
    Expect(0, 64336, '\p{Blk=:\AAlphabetic_PF\z:}', "");;
    Expect(1, 64335, '\p{Blk=alphabeticpf}', "");
    Expect(0, 64335, '\p{^Blk=alphabeticpf}', "");
    Expect(0, 64335, '\P{Blk=alphabeticpf}', "");
    Expect(1, 64335, '\P{^Blk=alphabeticpf}', "");
    Expect(0, 64336, '\p{Blk=alphabeticpf}', "");
    Expect(1, 64336, '\p{^Blk=alphabeticpf}', "");
    Expect(1, 64336, '\P{Blk=alphabeticpf}', "");
    Expect(0, 64336, '\P{^Blk=alphabeticpf}', "");
    Expect(1, 64335, '\p{Blk=:\Aalphabeticpf\z:}', "");;
    Expect(0, 64336, '\p{Blk=:\Aalphabeticpf\z:}', "");;
    Expect(1, 64335, '\p{Blk=	_Alphabetic_PF}', "");
    Expect(0, 64335, '\p{^Blk=	_Alphabetic_PF}', "");
    Expect(0, 64335, '\P{Blk=	_Alphabetic_PF}', "");
    Expect(1, 64335, '\P{^Blk=	_Alphabetic_PF}', "");
    Expect(0, 64336, '\p{Blk=	_Alphabetic_PF}', "");
    Expect(1, 64336, '\p{^Blk=	_Alphabetic_PF}', "");
    Expect(1, 64336, '\P{Blk=	_Alphabetic_PF}', "");
    Expect(0, 64336, '\P{^Blk=	_Alphabetic_PF}', "");
    Error('\p{Is_Block::=	Alphabetic_Presentation_Forms}');
    Error('\P{Is_Block::=	Alphabetic_Presentation_Forms}');
    Expect(1, 64335, '\p{Is_Block=alphabeticpresentationforms}', "");
    Expect(0, 64335, '\p{^Is_Block=alphabeticpresentationforms}', "");
    Expect(0, 64335, '\P{Is_Block=alphabeticpresentationforms}', "");
    Expect(1, 64335, '\P{^Is_Block=alphabeticpresentationforms}', "");
    Expect(0, 64336, '\p{Is_Block=alphabeticpresentationforms}', "");
    Expect(1, 64336, '\p{^Is_Block=alphabeticpresentationforms}', "");
    Expect(1, 64336, '\P{Is_Block=alphabeticpresentationforms}', "");
    Expect(0, 64336, '\P{^Is_Block=alphabeticpresentationforms}', "");
    Expect(1, 64335, '\p{Is_Block=	ALPHABETIC_PRESENTATION_Forms}', "");
    Expect(0, 64335, '\p{^Is_Block=	ALPHABETIC_PRESENTATION_Forms}', "");
    Expect(0, 64335, '\P{Is_Block=	ALPHABETIC_PRESENTATION_Forms}', "");
    Expect(1, 64335, '\P{^Is_Block=	ALPHABETIC_PRESENTATION_Forms}', "");
    Expect(0, 64336, '\p{Is_Block=	ALPHABETIC_PRESENTATION_Forms}', "");
    Expect(1, 64336, '\p{^Is_Block=	ALPHABETIC_PRESENTATION_Forms}', "");
    Expect(1, 64336, '\P{Is_Block=	ALPHABETIC_PRESENTATION_Forms}', "");
    Expect(0, 64336, '\P{^Is_Block=	ALPHABETIC_PRESENTATION_Forms}', "");
    Error('\p{Is_Blk:	:=ALPHABETIC_PF}');
    Error('\P{Is_Blk:	:=ALPHABETIC_PF}');
    Expect(1, 64335, '\p{Is_Blk=alphabeticpf}', "");
    Expect(0, 64335, '\p{^Is_Blk=alphabeticpf}', "");
    Expect(0, 64335, '\P{Is_Blk=alphabeticpf}', "");
    Expect(1, 64335, '\P{^Is_Blk=alphabeticpf}', "");
    Expect(0, 64336, '\p{Is_Blk=alphabeticpf}', "");
    Expect(1, 64336, '\p{^Is_Blk=alphabeticpf}', "");
    Expect(1, 64336, '\P{Is_Blk=alphabeticpf}', "");
    Expect(0, 64336, '\P{^Is_Blk=alphabeticpf}', "");
    Expect(1, 64335, '\p{Is_Blk=	Alphabetic_PF}', "");
    Expect(0, 64335, '\p{^Is_Blk=	Alphabetic_PF}', "");
    Expect(0, 64335, '\P{Is_Blk=	Alphabetic_PF}', "");
    Expect(1, 64335, '\P{^Is_Blk=	Alphabetic_PF}', "");
    Expect(0, 64336, '\p{Is_Blk=	Alphabetic_PF}', "");
    Expect(1, 64336, '\p{^Is_Blk=	Alphabetic_PF}', "");
    Expect(1, 64336, '\P{Is_Blk=	Alphabetic_PF}', "");
    Expect(0, 64336, '\P{^Is_Blk=	Alphabetic_PF}', "");
    Error('\p{Block=	Anatolian_Hieroglyphs:=}');
    Error('\P{Block=	Anatolian_Hieroglyphs:=}');
    Expect(1, 83583, '\p{Block=:\AAnatolian_Hieroglyphs\z:}', "");;
    Expect(0, 83584, '\p{Block=:\AAnatolian_Hieroglyphs\z:}', "");;
    Expect(1, 83583, '\p{Block=anatolianhieroglyphs}', "");
    Expect(0, 83583, '\p{^Block=anatolianhieroglyphs}', "");
    Expect(0, 83583, '\P{Block=anatolianhieroglyphs}', "");
    Expect(1, 83583, '\P{^Block=anatolianhieroglyphs}', "");
    Expect(0, 83584, '\p{Block=anatolianhieroglyphs}', "");
    Expect(1, 83584, '\p{^Block=anatolianhieroglyphs}', "");
    Expect(1, 83584, '\P{Block=anatolianhieroglyphs}', "");
    Expect(0, 83584, '\P{^Block=anatolianhieroglyphs}', "");
    Expect(1, 83583, '\p{Block=:\Aanatolianhieroglyphs\z:}', "");;
    Expect(0, 83584, '\p{Block=:\Aanatolianhieroglyphs\z:}', "");;
    Expect(1, 83583, '\p{Block=		Anatolian_Hieroglyphs}', "");
    Expect(0, 83583, '\p{^Block=		Anatolian_Hieroglyphs}', "");
    Expect(0, 83583, '\P{Block=		Anatolian_Hieroglyphs}', "");
    Expect(1, 83583, '\P{^Block=		Anatolian_Hieroglyphs}', "");
    Expect(0, 83584, '\p{Block=		Anatolian_Hieroglyphs}', "");
    Expect(1, 83584, '\p{^Block=		Anatolian_Hieroglyphs}', "");
    Expect(1, 83584, '\P{Block=		Anatolian_Hieroglyphs}', "");
    Expect(0, 83584, '\P{^Block=		Anatolian_Hieroglyphs}', "");
    Error('\p{Blk=	-ANATOLIAN_Hieroglyphs:=}');
    Error('\P{Blk=	-ANATOLIAN_Hieroglyphs:=}');
    Expect(1, 83583, '\p{Blk=:\AAnatolian_Hieroglyphs\z:}', "");;
    Expect(0, 83584, '\p{Blk=:\AAnatolian_Hieroglyphs\z:}', "");;
    Expect(1, 83583, '\p{Blk=anatolianhieroglyphs}', "");
    Expect(0, 83583, '\p{^Blk=anatolianhieroglyphs}', "");
    Expect(0, 83583, '\P{Blk=anatolianhieroglyphs}', "");
    Expect(1, 83583, '\P{^Blk=anatolianhieroglyphs}', "");
    Expect(0, 83584, '\p{Blk=anatolianhieroglyphs}', "");
    Expect(1, 83584, '\p{^Blk=anatolianhieroglyphs}', "");
    Expect(1, 83584, '\P{Blk=anatolianhieroglyphs}', "");
    Expect(0, 83584, '\P{^Blk=anatolianhieroglyphs}', "");
    Expect(1, 83583, '\p{Blk=:\Aanatolianhieroglyphs\z:}', "");;
    Expect(0, 83584, '\p{Blk=:\Aanatolianhieroglyphs\z:}', "");;
    Expect(1, 83583, '\p{Blk=  ANATOLIAN_Hieroglyphs}', "");
    Expect(0, 83583, '\p{^Blk=  ANATOLIAN_Hieroglyphs}', "");
    Expect(0, 83583, '\P{Blk=  ANATOLIAN_Hieroglyphs}', "");
    Expect(1, 83583, '\P{^Blk=  ANATOLIAN_Hieroglyphs}', "");
    Expect(0, 83584, '\p{Blk=  ANATOLIAN_Hieroglyphs}', "");
    Expect(1, 83584, '\p{^Blk=  ANATOLIAN_Hieroglyphs}', "");
    Expect(1, 83584, '\P{Blk=  ANATOLIAN_Hieroglyphs}', "");
    Expect(0, 83584, '\P{^Blk=  ANATOLIAN_Hieroglyphs}', "");
    Error('\p{Is_Block=	-anatolian_Hieroglyphs/a/}');
    Error('\P{Is_Block=	-anatolian_Hieroglyphs/a/}');
    Expect(1, 83583, '\p{Is_Block:   anatolianhieroglyphs}', "");
    Expect(0, 83583, '\p{^Is_Block:   anatolianhieroglyphs}', "");
    Expect(0, 83583, '\P{Is_Block:   anatolianhieroglyphs}', "");
    Expect(1, 83583, '\P{^Is_Block:   anatolianhieroglyphs}', "");
    Expect(0, 83584, '\p{Is_Block:   anatolianhieroglyphs}', "");
    Expect(1, 83584, '\p{^Is_Block:   anatolianhieroglyphs}', "");
    Expect(1, 83584, '\P{Is_Block:   anatolianhieroglyphs}', "");
    Expect(0, 83584, '\P{^Is_Block:   anatolianhieroglyphs}', "");
    Expect(1, 83583, '\p{Is_Block=_Anatolian_hieroglyphs}', "");
    Expect(0, 83583, '\p{^Is_Block=_Anatolian_hieroglyphs}', "");
    Expect(0, 83583, '\P{Is_Block=_Anatolian_hieroglyphs}', "");
    Expect(1, 83583, '\P{^Is_Block=_Anatolian_hieroglyphs}', "");
    Expect(0, 83584, '\p{Is_Block=_Anatolian_hieroglyphs}', "");
    Expect(1, 83584, '\p{^Is_Block=_Anatolian_hieroglyphs}', "");
    Expect(1, 83584, '\P{Is_Block=_Anatolian_hieroglyphs}', "");
    Expect(0, 83584, '\P{^Is_Block=_Anatolian_hieroglyphs}', "");
    Error('\p{Is_Blk=/a/Anatolian_HIEROGLYPHS}');
    Error('\P{Is_Blk=/a/Anatolian_HIEROGLYPHS}');
    Expect(1, 83583, '\p{Is_Blk=anatolianhieroglyphs}', "");
    Expect(0, 83583, '\p{^Is_Blk=anatolianhieroglyphs}', "");
    Expect(0, 83583, '\P{Is_Blk=anatolianhieroglyphs}', "");
    Expect(1, 83583, '\P{^Is_Blk=anatolianhieroglyphs}', "");
    Expect(0, 83584, '\p{Is_Blk=anatolianhieroglyphs}', "");
    Expect(1, 83584, '\p{^Is_Blk=anatolianhieroglyphs}', "");
    Expect(1, 83584, '\P{Is_Blk=anatolianhieroglyphs}', "");
    Expect(0, 83584, '\P{^Is_Blk=anatolianhieroglyphs}', "");
    Expect(1, 83583, '\p{Is_Blk: --Anatolian_hieroglyphs}', "");
    Expect(0, 83583, '\p{^Is_Blk: --Anatolian_hieroglyphs}', "");
    Expect(0, 83583, '\P{Is_Blk: --Anatolian_hieroglyphs}', "");
    Expect(1, 83583, '\P{^Is_Blk: --Anatolian_hieroglyphs}', "");
    Expect(0, 83584, '\p{Is_Blk: --Anatolian_hieroglyphs}', "");
    Expect(1, 83584, '\p{^Is_Blk: --Anatolian_hieroglyphs}', "");
    Expect(1, 83584, '\P{Is_Blk: --Anatolian_hieroglyphs}', "");
    Expect(0, 83584, '\P{^Is_Blk: --Anatolian_hieroglyphs}', "");
    Error('\p{Block=:=-	Ancient_GREEK_musical_NOTATION}');
    Error('\P{Block=:=-	Ancient_GREEK_musical_NOTATION}');
    Expect(1, 119375, '\p{Block=:\AAncient_Greek_Musical_Notation\z:}', "");;
    Expect(0, 119376, '\p{Block=:\AAncient_Greek_Musical_Notation\z:}', "");;
    Expect(1, 119375, '\p{Block=ancientgreekmusicalnotation}', "");
    Expect(0, 119375, '\p{^Block=ancientgreekmusicalnotation}', "");
    Expect(0, 119375, '\P{Block=ancientgreekmusicalnotation}', "");
    Expect(1, 119375, '\P{^Block=ancientgreekmusicalnotation}', "");
    Expect(0, 119376, '\p{Block=ancientgreekmusicalnotation}', "");
    Expect(1, 119376, '\p{^Block=ancientgreekmusicalnotation}', "");
    Expect(1, 119376, '\P{Block=ancientgreekmusicalnotation}', "");
    Expect(0, 119376, '\P{^Block=ancientgreekmusicalnotation}', "");
    Expect(1, 119375, '\p{Block=:\Aancientgreekmusicalnotation\z:}', "");;
    Expect(0, 119376, '\p{Block=:\Aancientgreekmusicalnotation\z:}', "");;
    Expect(1, 119375, '\p{Block= -ANCIENT_greek_Musical_NOTATION}', "");
    Expect(0, 119375, '\p{^Block= -ANCIENT_greek_Musical_NOTATION}', "");
    Expect(0, 119375, '\P{Block= -ANCIENT_greek_Musical_NOTATION}', "");
    Expect(1, 119375, '\P{^Block= -ANCIENT_greek_Musical_NOTATION}', "");
    Expect(0, 119376, '\p{Block= -ANCIENT_greek_Musical_NOTATION}', "");
    Expect(1, 119376, '\p{^Block= -ANCIENT_greek_Musical_NOTATION}', "");
    Expect(1, 119376, '\P{Block= -ANCIENT_greek_Musical_NOTATION}', "");
    Expect(0, 119376, '\P{^Block= -ANCIENT_greek_Musical_NOTATION}', "");
    Error('\p{Blk=	 Ancient_greek_music:=}');
    Error('\P{Blk=	 Ancient_greek_music:=}');
    Expect(1, 119375, '\p{Blk=:\AAncient_Greek_Music\z:}', "");;
    Expect(0, 119376, '\p{Blk=:\AAncient_Greek_Music\z:}', "");;
    Expect(1, 119375, '\p{Blk=ancientgreekmusic}', "");
    Expect(0, 119375, '\p{^Blk=ancientgreekmusic}', "");
    Expect(0, 119375, '\P{Blk=ancientgreekmusic}', "");
    Expect(1, 119375, '\P{^Blk=ancientgreekmusic}', "");
    Expect(0, 119376, '\p{Blk=ancientgreekmusic}', "");
    Expect(1, 119376, '\p{^Blk=ancientgreekmusic}', "");
    Expect(1, 119376, '\P{Blk=ancientgreekmusic}', "");
    Expect(0, 119376, '\P{^Blk=ancientgreekmusic}', "");
    Expect(1, 119375, '\p{Blk=:\Aancientgreekmusic\z:}', "");;
    Expect(0, 119376, '\p{Blk=:\Aancientgreekmusic\z:}', "");;
    Expect(1, 119375, '\p{Blk=-_Ancient_greek_MUSIC}', "");
    Expect(0, 119375, '\p{^Blk=-_Ancient_greek_MUSIC}', "");
    Expect(0, 119375, '\P{Blk=-_Ancient_greek_MUSIC}', "");
    Expect(1, 119375, '\P{^Blk=-_Ancient_greek_MUSIC}', "");
    Expect(0, 119376, '\p{Blk=-_Ancient_greek_MUSIC}', "");
    Expect(1, 119376, '\p{^Blk=-_Ancient_greek_MUSIC}', "");
    Expect(1, 119376, '\P{Blk=-_Ancient_greek_MUSIC}', "");
    Expect(0, 119376, '\P{^Blk=-_Ancient_greek_MUSIC}', "");
    Error('\p{Is_Block=--Ancient_Greek_musical_Notation:=}');
    Error('\P{Is_Block=--Ancient_Greek_musical_Notation:=}');
    Expect(1, 119375, '\p{Is_Block=ancientgreekmusicalnotation}', "");
    Expect(0, 119375, '\p{^Is_Block=ancientgreekmusicalnotation}', "");
    Expect(0, 119375, '\P{Is_Block=ancientgreekmusicalnotation}', "");
    Expect(1, 119375, '\P{^Is_Block=ancientgreekmusicalnotation}', "");
    Expect(0, 119376, '\p{Is_Block=ancientgreekmusicalnotation}', "");
    Expect(1, 119376, '\p{^Is_Block=ancientgreekmusicalnotation}', "");
    Expect(1, 119376, '\P{Is_Block=ancientgreekmusicalnotation}', "");
    Expect(0, 119376, '\P{^Is_Block=ancientgreekmusicalnotation}', "");
    Expect(1, 119375, '\p{Is_Block:   	_ancient_Greek_Musical_notation}', "");
    Expect(0, 119375, '\p{^Is_Block:   	_ancient_Greek_Musical_notation}', "");
    Expect(0, 119375, '\P{Is_Block:   	_ancient_Greek_Musical_notation}', "");
    Expect(1, 119375, '\P{^Is_Block:   	_ancient_Greek_Musical_notation}', "");
    Expect(0, 119376, '\p{Is_Block:   	_ancient_Greek_Musical_notation}', "");
    Expect(1, 119376, '\p{^Is_Block:   	_ancient_Greek_Musical_notation}', "");
    Expect(1, 119376, '\P{Is_Block:   	_ancient_Greek_Musical_notation}', "");
    Expect(0, 119376, '\P{^Is_Block:   	_ancient_Greek_Musical_notation}', "");
    Error('\p{Is_Blk=/a/ Ancient_Greek_Music}');
    Error('\P{Is_Blk=/a/ Ancient_Greek_Music}');
    Expect(1, 119375, '\p{Is_Blk=ancientgreekmusic}', "");
    Expect(0, 119375, '\p{^Is_Blk=ancientgreekmusic}', "");
    Expect(0, 119375, '\P{Is_Blk=ancientgreekmusic}', "");
    Expect(1, 119375, '\P{^Is_Blk=ancientgreekmusic}', "");
    Expect(0, 119376, '\p{Is_Blk=ancientgreekmusic}', "");
    Expect(1, 119376, '\p{^Is_Blk=ancientgreekmusic}', "");
    Expect(1, 119376, '\P{Is_Blk=ancientgreekmusic}', "");
    Expect(0, 119376, '\P{^Is_Blk=ancientgreekmusic}', "");
    Expect(1, 119375, '\p{Is_Blk=__Ancient_Greek_music}', "");
    Expect(0, 119375, '\p{^Is_Blk=__Ancient_Greek_music}', "");
    Expect(0, 119375, '\P{Is_Blk=__Ancient_Greek_music}', "");
    Expect(1, 119375, '\P{^Is_Blk=__Ancient_Greek_music}', "");
    Expect(0, 119376, '\p{Is_Blk=__Ancient_Greek_music}', "");
    Expect(1, 119376, '\p{^Is_Blk=__Ancient_Greek_music}', "");
    Expect(1, 119376, '\P{Is_Blk=__Ancient_Greek_music}', "");
    Expect(0, 119376, '\P{^Is_Blk=__Ancient_Greek_music}', "");
    Error('\p{Block=_:=ANCIENT_greek_NUMBERS}');
    Error('\P{Block=_:=ANCIENT_greek_NUMBERS}');
    Expect(1, 65935, '\p{Block=:\AAncient_Greek_Numbers\z:}', "");;
    Expect(0, 65936, '\p{Block=:\AAncient_Greek_Numbers\z:}', "");;
    Expect(1, 65935, '\p{Block=ancientgreeknumbers}', "");
    Expect(0, 65935, '\p{^Block=ancientgreeknumbers}', "");
    Expect(0, 65935, '\P{Block=ancientgreeknumbers}', "");
    Expect(1, 65935, '\P{^Block=ancientgreeknumbers}', "");
    Expect(0, 65936, '\p{Block=ancientgreeknumbers}', "");
    Expect(1, 65936, '\p{^Block=ancientgreeknumbers}', "");
    Expect(1, 65936, '\P{Block=ancientgreeknumbers}', "");
    Expect(0, 65936, '\P{^Block=ancientgreeknumbers}', "");
    Expect(1, 65935, '\p{Block=:\Aancientgreeknumbers\z:}', "");;
    Expect(0, 65936, '\p{Block=:\Aancientgreeknumbers\z:}', "");;
    Expect(1, 65935, '\p{Block=	ancient_GREEK_NUMBERS}', "");
    Expect(0, 65935, '\p{^Block=	ancient_GREEK_NUMBERS}', "");
    Expect(0, 65935, '\P{Block=	ancient_GREEK_NUMBERS}', "");
    Expect(1, 65935, '\P{^Block=	ancient_GREEK_NUMBERS}', "");
    Expect(0, 65936, '\p{Block=	ancient_GREEK_NUMBERS}', "");
    Expect(1, 65936, '\p{^Block=	ancient_GREEK_NUMBERS}', "");
    Expect(1, 65936, '\P{Block=	ancient_GREEK_NUMBERS}', "");
    Expect(0, 65936, '\P{^Block=	ancient_GREEK_NUMBERS}', "");
    Error('\p{Blk=_:=Ancient_GREEK_numbers}');
    Error('\P{Blk=_:=Ancient_GREEK_numbers}');
    Expect(1, 65935, '\p{Blk=:\AAncient_Greek_Numbers\z:}', "");;
    Expect(0, 65936, '\p{Blk=:\AAncient_Greek_Numbers\z:}', "");;
    Expect(1, 65935, '\p{Blk=ancientgreeknumbers}', "");
    Expect(0, 65935, '\p{^Blk=ancientgreeknumbers}', "");
    Expect(0, 65935, '\P{Blk=ancientgreeknumbers}', "");
    Expect(1, 65935, '\P{^Blk=ancientgreeknumbers}', "");
    Expect(0, 65936, '\p{Blk=ancientgreeknumbers}', "");
    Expect(1, 65936, '\p{^Blk=ancientgreeknumbers}', "");
    Expect(1, 65936, '\P{Blk=ancientgreeknumbers}', "");
    Expect(0, 65936, '\P{^Blk=ancientgreeknumbers}', "");
    Expect(1, 65935, '\p{Blk=:\Aancientgreeknumbers\z:}', "");;
    Expect(0, 65936, '\p{Blk=:\Aancientgreeknumbers\z:}', "");;
    Expect(1, 65935, '\p{Blk=	_Ancient_Greek_Numbers}', "");
    Expect(0, 65935, '\p{^Blk=	_Ancient_Greek_Numbers}', "");
    Expect(0, 65935, '\P{Blk=	_Ancient_Greek_Numbers}', "");
    Expect(1, 65935, '\P{^Blk=	_Ancient_Greek_Numbers}', "");
    Expect(0, 65936, '\p{Blk=	_Ancient_Greek_Numbers}', "");
    Expect(1, 65936, '\p{^Blk=	_Ancient_Greek_Numbers}', "");
    Expect(1, 65936, '\P{Blk=	_Ancient_Greek_Numbers}', "");
    Expect(0, 65936, '\P{^Blk=	_Ancient_Greek_Numbers}', "");
    Error('\p{Is_Block= /a/ANCIENT_Greek_numbers}');
    Error('\P{Is_Block= /a/ANCIENT_Greek_numbers}');
    Expect(1, 65935, '\p{Is_Block=ancientgreeknumbers}', "");
    Expect(0, 65935, '\p{^Is_Block=ancientgreeknumbers}', "");
    Expect(0, 65935, '\P{Is_Block=ancientgreeknumbers}', "");
    Expect(1, 65935, '\P{^Is_Block=ancientgreeknumbers}', "");
    Expect(0, 65936, '\p{Is_Block=ancientgreeknumbers}', "");
    Expect(1, 65936, '\p{^Is_Block=ancientgreeknumbers}', "");
    Expect(1, 65936, '\P{Is_Block=ancientgreeknumbers}', "");
    Expect(0, 65936, '\P{^Is_Block=ancientgreeknumbers}', "");
    Expect(1, 65935, '\p{Is_Block= Ancient_GREEK_Numbers}', "");
    Expect(0, 65935, '\p{^Is_Block= Ancient_GREEK_Numbers}', "");
    Expect(0, 65935, '\P{Is_Block= Ancient_GREEK_Numbers}', "");
    Expect(1, 65935, '\P{^Is_Block= Ancient_GREEK_Numbers}', "");
    Expect(0, 65936, '\p{Is_Block= Ancient_GREEK_Numbers}', "");
    Expect(1, 65936, '\p{^Is_Block= Ancient_GREEK_Numbers}', "");
    Expect(1, 65936, '\P{Is_Block= Ancient_GREEK_Numbers}', "");
    Expect(0, 65936, '\P{^Is_Block= Ancient_GREEK_Numbers}', "");
    Error('\p{Is_Blk=	 Ancient_Greek_Numbers:=}');
    Error('\P{Is_Blk=	 Ancient_Greek_Numbers:=}');
    Expect(1, 65935, '\p{Is_Blk=ancientgreeknumbers}', "");
    Expect(0, 65935, '\p{^Is_Blk=ancientgreeknumbers}', "");
    Expect(0, 65935, '\P{Is_Blk=ancientgreeknumbers}', "");
    Expect(1, 65935, '\P{^Is_Blk=ancientgreeknumbers}', "");
    Expect(0, 65936, '\p{Is_Blk=ancientgreeknumbers}', "");
    Expect(1, 65936, '\p{^Is_Blk=ancientgreeknumbers}', "");
    Expect(1, 65936, '\P{Is_Blk=ancientgreeknumbers}', "");
    Expect(0, 65936, '\P{^Is_Blk=ancientgreeknumbers}', "");
    Expect(1, 65935, '\p{Is_Blk=	 Ancient_GREEK_Numbers}', "");
    Expect(0, 65935, '\p{^Is_Blk=	 Ancient_GREEK_Numbers}', "");
    Expect(0, 65935, '\P{Is_Blk=	 Ancient_GREEK_Numbers}', "");
    Expect(1, 65935, '\P{^Is_Blk=	 Ancient_GREEK_Numbers}', "");
    Expect(0, 65936, '\p{Is_Blk=	 Ancient_GREEK_Numbers}', "");
    Expect(1, 65936, '\p{^Is_Blk=	 Ancient_GREEK_Numbers}', "");
    Expect(1, 65936, '\P{Is_Blk=	 Ancient_GREEK_Numbers}', "");
    Expect(0, 65936, '\P{^Is_Blk=	 Ancient_GREEK_Numbers}', "");
    Error('\p{Block=_:=Ancient_Symbols}');
    Error('\P{Block=_:=Ancient_Symbols}');
    Expect(1, 65999, '\p{Block=:\AAncient_Symbols\z:}', "");;
    Expect(0, 66000, '\p{Block=:\AAncient_Symbols\z:}', "");;
    Expect(1, 65999, '\p{Block=ancientsymbols}', "");
    Expect(0, 65999, '\p{^Block=ancientsymbols}', "");
    Expect(0, 65999, '\P{Block=ancientsymbols}', "");
    Expect(1, 65999, '\P{^Block=ancientsymbols}', "");
    Expect(0, 66000, '\p{Block=ancientsymbols}', "");
    Expect(1, 66000, '\p{^Block=ancientsymbols}', "");
    Expect(1, 66000, '\P{Block=ancientsymbols}', "");
    Expect(0, 66000, '\P{^Block=ancientsymbols}', "");
    Expect(1, 65999, '\p{Block=:\Aancientsymbols\z:}', "");;
    Expect(0, 66000, '\p{Block=:\Aancientsymbols\z:}', "");;
    Expect(1, 65999, '\p{Block= -Ancient_SYMBOLS}', "");
    Expect(0, 65999, '\p{^Block= -Ancient_SYMBOLS}', "");
    Expect(0, 65999, '\P{Block= -Ancient_SYMBOLS}', "");
    Expect(1, 65999, '\P{^Block= -Ancient_SYMBOLS}', "");
    Expect(0, 66000, '\p{Block= -Ancient_SYMBOLS}', "");
    Expect(1, 66000, '\p{^Block= -Ancient_SYMBOLS}', "");
    Expect(1, 66000, '\P{Block= -Ancient_SYMBOLS}', "");
    Expect(0, 66000, '\P{^Block= -Ancient_SYMBOLS}', "");
    Error('\p{Blk=:=_ ancient_Symbols}');
    Error('\P{Blk=:=_ ancient_Symbols}');
    Expect(1, 65999, '\p{Blk=:\AAncient_Symbols\z:}', "");;
    Expect(0, 66000, '\p{Blk=:\AAncient_Symbols\z:}', "");;
    Expect(1, 65999, '\p{Blk=ancientsymbols}', "");
    Expect(0, 65999, '\p{^Blk=ancientsymbols}', "");
    Expect(0, 65999, '\P{Blk=ancientsymbols}', "");
    Expect(1, 65999, '\P{^Blk=ancientsymbols}', "");
    Expect(0, 66000, '\p{Blk=ancientsymbols}', "");
    Expect(1, 66000, '\p{^Blk=ancientsymbols}', "");
    Expect(1, 66000, '\P{Blk=ancientsymbols}', "");
    Expect(0, 66000, '\P{^Blk=ancientsymbols}', "");
    Expect(1, 65999, '\p{Blk=:\Aancientsymbols\z:}', "");;
    Expect(0, 66000, '\p{Blk=:\Aancientsymbols\z:}', "");;
    Expect(1, 65999, '\p{Blk=	-Ancient_Symbols}', "");
    Expect(0, 65999, '\p{^Blk=	-Ancient_Symbols}', "");
    Expect(0, 65999, '\P{Blk=	-Ancient_Symbols}', "");
    Expect(1, 65999, '\P{^Blk=	-Ancient_Symbols}', "");
    Expect(0, 66000, '\p{Blk=	-Ancient_Symbols}', "");
    Expect(1, 66000, '\p{^Blk=	-Ancient_Symbols}', "");
    Expect(1, 66000, '\P{Blk=	-Ancient_Symbols}', "");
    Expect(0, 66000, '\P{^Blk=	-Ancient_Symbols}', "");
    Error('\p{Is_Block=-/a/Ancient_Symbols}');
    Error('\P{Is_Block=-/a/Ancient_Symbols}');
    Expect(1, 65999, '\p{Is_Block=ancientsymbols}', "");
    Expect(0, 65999, '\p{^Is_Block=ancientsymbols}', "");
    Expect(0, 65999, '\P{Is_Block=ancientsymbols}', "");
    Expect(1, 65999, '\P{^Is_Block=ancientsymbols}', "");
    Expect(0, 66000, '\p{Is_Block=ancientsymbols}', "");
    Expect(1, 66000, '\p{^Is_Block=ancientsymbols}', "");
    Expect(1, 66000, '\P{Is_Block=ancientsymbols}', "");
    Expect(0, 66000, '\P{^Is_Block=ancientsymbols}', "");
    Expect(1, 65999, '\p{Is_Block:	- Ancient_symbols}', "");
    Expect(0, 65999, '\p{^Is_Block:	- Ancient_symbols}', "");
    Expect(0, 65999, '\P{Is_Block:	- Ancient_symbols}', "");
    Expect(1, 65999, '\P{^Is_Block:	- Ancient_symbols}', "");
    Expect(0, 66000, '\p{Is_Block:	- Ancient_symbols}', "");
    Expect(1, 66000, '\p{^Is_Block:	- Ancient_symbols}', "");
    Expect(1, 66000, '\P{Is_Block:	- Ancient_symbols}', "");
    Expect(0, 66000, '\P{^Is_Block:	- Ancient_symbols}', "");
    Error('\p{Is_Blk= :=Ancient_SYMBOLS}');
    Error('\P{Is_Blk= :=Ancient_SYMBOLS}');
    Expect(1, 65999, '\p{Is_Blk=ancientsymbols}', "");
    Expect(0, 65999, '\p{^Is_Blk=ancientsymbols}', "");
    Expect(0, 65999, '\P{Is_Blk=ancientsymbols}', "");
    Expect(1, 65999, '\P{^Is_Blk=ancientsymbols}', "");
    Expect(0, 66000, '\p{Is_Blk=ancientsymbols}', "");
    Expect(1, 66000, '\p{^Is_Blk=ancientsymbols}', "");
    Expect(1, 66000, '\P{Is_Blk=ancientsymbols}', "");
    Expect(0, 66000, '\P{^Is_Blk=ancientsymbols}', "");
    Expect(1, 65999, '\p{Is_Blk= Ancient_symbols}', "");
    Expect(0, 65999, '\p{^Is_Blk= Ancient_symbols}', "");
    Expect(0, 65999, '\P{Is_Blk= Ancient_symbols}', "");
    Expect(1, 65999, '\P{^Is_Blk= Ancient_symbols}', "");
    Expect(0, 66000, '\p{Is_Blk= Ancient_symbols}', "");
    Expect(1, 66000, '\p{^Is_Blk= Ancient_symbols}', "");
    Expect(1, 66000, '\P{Is_Blk= Ancient_symbols}', "");
    Expect(0, 66000, '\P{^Is_Blk= Ancient_symbols}', "");
    Error('\p{Block=:=-_Arabic}');
    Error('\P{Block=:=-_Arabic}');
    Expect(1, 1791, '\p{Block=:\AArabic\z:}', "");;
    Expect(0, 1792, '\p{Block=:\AArabic\z:}', "");;
    Expect(1, 1791, '\p{Block=arabic}', "");
    Expect(0, 1791, '\p{^Block=arabic}', "");
    Expect(0, 1791, '\P{Block=arabic}', "");
    Expect(1, 1791, '\P{^Block=arabic}', "");
    Expect(0, 1792, '\p{Block=arabic}', "");
    Expect(1, 1792, '\p{^Block=arabic}', "");
    Expect(1, 1792, '\P{Block=arabic}', "");
    Expect(0, 1792, '\P{^Block=arabic}', "");
    Expect(1, 1791, '\p{Block=:\Aarabic\z:}', "");;
    Expect(0, 1792, '\p{Block=:\Aarabic\z:}', "");;
    Expect(1, 1791, '\p{Block=_arabic}', "");
    Expect(0, 1791, '\p{^Block=_arabic}', "");
    Expect(0, 1791, '\P{Block=_arabic}', "");
    Expect(1, 1791, '\P{^Block=_arabic}', "");
    Expect(0, 1792, '\p{Block=_arabic}', "");
    Expect(1, 1792, '\p{^Block=_arabic}', "");
    Expect(1, 1792, '\P{Block=_arabic}', "");
    Expect(0, 1792, '\P{^Block=_arabic}', "");
    Error('\p{Blk= 	arabic/a/}');
    Error('\P{Blk= 	arabic/a/}');
    Expect(1, 1791, '\p{Blk=:\AArabic\z:}', "");;
    Expect(0, 1792, '\p{Blk=:\AArabic\z:}', "");;
    Expect(1, 1791, '\p{Blk=arabic}', "");
    Expect(0, 1791, '\p{^Blk=arabic}', "");
    Expect(0, 1791, '\P{Blk=arabic}', "");
    Expect(1, 1791, '\P{^Blk=arabic}', "");
    Expect(0, 1792, '\p{Blk=arabic}', "");
    Expect(1, 1792, '\p{^Blk=arabic}', "");
    Expect(1, 1792, '\P{Blk=arabic}', "");
    Expect(0, 1792, '\P{^Blk=arabic}', "");
    Expect(1, 1791, '\p{Blk=:\Aarabic\z:}', "");;
    Expect(0, 1792, '\p{Blk=:\Aarabic\z:}', "");;
    Expect(1, 1791, '\p{Blk=- arabic}', "");
    Expect(0, 1791, '\p{^Blk=- arabic}', "");
    Expect(0, 1791, '\P{Blk=- arabic}', "");
    Expect(1, 1791, '\P{^Blk=- arabic}', "");
    Expect(0, 1792, '\p{Blk=- arabic}', "");
    Expect(1, 1792, '\p{^Blk=- arabic}', "");
    Expect(1, 1792, '\P{Blk=- arabic}', "");
    Expect(0, 1792, '\P{^Blk=- arabic}', "");
    Error('\p{Is_Block:	/a/ -Arabic}');
    Error('\P{Is_Block:	/a/ -Arabic}');
    Expect(1, 1791, '\p{Is_Block=arabic}', "");
    Expect(0, 1791, '\p{^Is_Block=arabic}', "");
    Expect(0, 1791, '\P{Is_Block=arabic}', "");
    Expect(1, 1791, '\P{^Is_Block=arabic}', "");
    Expect(0, 1792, '\p{Is_Block=arabic}', "");
    Expect(1, 1792, '\p{^Is_Block=arabic}', "");
    Expect(1, 1792, '\P{Is_Block=arabic}', "");
    Expect(0, 1792, '\P{^Is_Block=arabic}', "");
    Expect(1, 1791, '\p{Is_Block=__arabic}', "");
    Expect(0, 1791, '\p{^Is_Block=__arabic}', "");
    Expect(0, 1791, '\P{Is_Block=__arabic}', "");
    Expect(1, 1791, '\P{^Is_Block=__arabic}', "");
    Expect(0, 1792, '\p{Is_Block=__arabic}', "");
    Expect(1, 1792, '\p{^Is_Block=__arabic}', "");
    Expect(1, 1792, '\P{Is_Block=__arabic}', "");
    Expect(0, 1792, '\P{^Is_Block=__arabic}', "");
    Error('\p{Is_Blk=:=Arabic}');
    Error('\P{Is_Blk=:=Arabic}');
    Expect(1, 1791, '\p{Is_Blk=arabic}', "");
    Expect(0, 1791, '\p{^Is_Blk=arabic}', "");
    Expect(0, 1791, '\P{Is_Blk=arabic}', "");
    Expect(1, 1791, '\P{^Is_Blk=arabic}', "");
    Expect(0, 1792, '\p{Is_Blk=arabic}', "");
    Expect(1, 1792, '\p{^Is_Blk=arabic}', "");
    Expect(1, 1792, '\P{Is_Blk=arabic}', "");
    Expect(0, 1792, '\P{^Is_Blk=arabic}', "");
    Expect(1, 1791, '\p{Is_Blk:	ARABIC}', "");
    Expect(0, 1791, '\p{^Is_Blk:	ARABIC}', "");
    Expect(0, 1791, '\P{Is_Blk:	ARABIC}', "");
    Expect(1, 1791, '\P{^Is_Blk:	ARABIC}', "");
    Expect(0, 1792, '\p{Is_Blk:	ARABIC}', "");
    Expect(1, 1792, '\p{^Is_Blk:	ARABIC}', "");
    Expect(1, 1792, '\P{Is_Blk:	ARABIC}', "");
    Expect(0, 1792, '\P{^Is_Blk:	ARABIC}', "");
    Error('\p{Block= _ARABIC_EXTENDED_A:=}');
    Error('\P{Block= _ARABIC_EXTENDED_A:=}');
    Expect(1, 2303, '\p{Block=:\AArabic_Extended_A\z:}', "");;
    Expect(0, 2304, '\p{Block=:\AArabic_Extended_A\z:}', "");;
    Expect(1, 2303, '\p{Block=arabicextendeda}', "");
    Expect(0, 2303, '\p{^Block=arabicextendeda}', "");
    Expect(0, 2303, '\P{Block=arabicextendeda}', "");
    Expect(1, 2303, '\P{^Block=arabicextendeda}', "");
    Expect(0, 2304, '\p{Block=arabicextendeda}', "");
    Expect(1, 2304, '\p{^Block=arabicextendeda}', "");
    Expect(1, 2304, '\P{Block=arabicextendeda}', "");
    Expect(0, 2304, '\P{^Block=arabicextendeda}', "");
    Expect(1, 2303, '\p{Block=:\Aarabicextendeda\z:}', "");;
    Expect(0, 2304, '\p{Block=:\Aarabicextendeda\z:}', "");;
    Expect(1, 2303, '\p{Block=Arabic_Extended_a}', "");
    Expect(0, 2303, '\p{^Block=Arabic_Extended_a}', "");
    Expect(0, 2303, '\P{Block=Arabic_Extended_a}', "");
    Expect(1, 2303, '\P{^Block=Arabic_Extended_a}', "");
    Expect(0, 2304, '\p{Block=Arabic_Extended_a}', "");
    Expect(1, 2304, '\p{^Block=Arabic_Extended_a}', "");
    Expect(1, 2304, '\P{Block=Arabic_Extended_a}', "");
    Expect(0, 2304, '\P{^Block=Arabic_Extended_a}', "");
    Error('\p{Blk=-_Arabic_EXT_a:=}');
    Error('\P{Blk=-_Arabic_EXT_a:=}');
    Expect(1, 2303, '\p{Blk=:\AArabic_Ext_A\z:}', "");;
    Expect(0, 2304, '\p{Blk=:\AArabic_Ext_A\z:}', "");;
    Expect(1, 2303, '\p{Blk=arabicexta}', "");
    Expect(0, 2303, '\p{^Blk=arabicexta}', "");
    Expect(0, 2303, '\P{Blk=arabicexta}', "");
    Expect(1, 2303, '\P{^Blk=arabicexta}', "");
    Expect(0, 2304, '\p{Blk=arabicexta}', "");
    Expect(1, 2304, '\p{^Blk=arabicexta}', "");
    Expect(1, 2304, '\P{Blk=arabicexta}', "");
    Expect(0, 2304, '\P{^Blk=arabicexta}', "");
    Expect(1, 2303, '\p{Blk=:\Aarabicexta\z:}', "");;
    Expect(0, 2304, '\p{Blk=:\Aarabicexta\z:}', "");;
    Expect(1, 2303, '\p{Blk= 	Arabic_EXT_A}', "");
    Expect(0, 2303, '\p{^Blk= 	Arabic_EXT_A}', "");
    Expect(0, 2303, '\P{Blk= 	Arabic_EXT_A}', "");
    Expect(1, 2303, '\P{^Blk= 	Arabic_EXT_A}', "");
    Expect(0, 2304, '\p{Blk= 	Arabic_EXT_A}', "");
    Expect(1, 2304, '\p{^Blk= 	Arabic_EXT_A}', "");
    Expect(1, 2304, '\P{Blk= 	Arabic_EXT_A}', "");
    Expect(0, 2304, '\P{^Blk= 	Arabic_EXT_A}', "");
    Error('\p{Is_Block=- Arabic_Extended_a/a/}');
    Error('\P{Is_Block=- Arabic_Extended_a/a/}');
    Expect(1, 2303, '\p{Is_Block=arabicextendeda}', "");
    Expect(0, 2303, '\p{^Is_Block=arabicextendeda}', "");
    Expect(0, 2303, '\P{Is_Block=arabicextendeda}', "");
    Expect(1, 2303, '\P{^Is_Block=arabicextendeda}', "");
    Expect(0, 2304, '\p{Is_Block=arabicextendeda}', "");
    Expect(1, 2304, '\p{^Is_Block=arabicextendeda}', "");
    Expect(1, 2304, '\P{Is_Block=arabicextendeda}', "");
    Expect(0, 2304, '\P{^Is_Block=arabicextendeda}', "");
    Expect(1, 2303, '\p{Is_Block: __ARABIC_extended_A}', "");
    Expect(0, 2303, '\p{^Is_Block: __ARABIC_extended_A}', "");
    Expect(0, 2303, '\P{Is_Block: __ARABIC_extended_A}', "");
    Expect(1, 2303, '\P{^Is_Block: __ARABIC_extended_A}', "");
    Expect(0, 2304, '\p{Is_Block: __ARABIC_extended_A}', "");
    Expect(1, 2304, '\p{^Is_Block: __ARABIC_extended_A}', "");
    Expect(1, 2304, '\P{Is_Block: __ARABIC_extended_A}', "");
    Expect(0, 2304, '\P{^Is_Block: __ARABIC_extended_A}', "");
    Error('\p{Is_Blk=:=	_Arabic_ext_A}');
    Error('\P{Is_Blk=:=	_Arabic_ext_A}');
    Expect(1, 2303, '\p{Is_Blk=arabicexta}', "");
    Expect(0, 2303, '\p{^Is_Blk=arabicexta}', "");
    Expect(0, 2303, '\P{Is_Blk=arabicexta}', "");
    Expect(1, 2303, '\P{^Is_Blk=arabicexta}', "");
    Expect(0, 2304, '\p{Is_Blk=arabicexta}', "");
    Expect(1, 2304, '\p{^Is_Blk=arabicexta}', "");
    Expect(1, 2304, '\P{Is_Blk=arabicexta}', "");
    Expect(0, 2304, '\P{^Is_Blk=arabicexta}', "");
    Expect(1, 2303, '\p{Is_Blk=- Arabic_Ext_A}', "");
    Expect(0, 2303, '\p{^Is_Blk=- Arabic_Ext_A}', "");
    Expect(0, 2303, '\P{Is_Blk=- Arabic_Ext_A}', "");
    Expect(1, 2303, '\P{^Is_Blk=- Arabic_Ext_A}', "");
    Expect(0, 2304, '\p{Is_Blk=- Arabic_Ext_A}', "");
    Expect(1, 2304, '\p{^Is_Blk=- Arabic_Ext_A}', "");
    Expect(1, 2304, '\P{Is_Blk=- Arabic_Ext_A}', "");
    Expect(0, 2304, '\P{^Is_Blk=- Arabic_Ext_A}', "");
    Error('\p{Block=-:=ARABIC_extended_B}');
    Error('\P{Block=-:=ARABIC_extended_B}');
    Expect(1, 2207, '\p{Block=:\AArabic_Extended_B\z:}', "");;
    Expect(0, 2208, '\p{Block=:\AArabic_Extended_B\z:}', "");;
    Expect(1, 2207, '\p{Block=arabicextendedb}', "");
    Expect(0, 2207, '\p{^Block=arabicextendedb}', "");
    Expect(0, 2207, '\P{Block=arabicextendedb}', "");
    Expect(1, 2207, '\P{^Block=arabicextendedb}', "");
    Expect(0, 2208, '\p{Block=arabicextendedb}', "");
    Expect(1, 2208, '\p{^Block=arabicextendedb}', "");
    Expect(1, 2208, '\P{Block=arabicextendedb}', "");
    Expect(0, 2208, '\P{^Block=arabicextendedb}', "");
    Expect(1, 2207, '\p{Block=:\Aarabicextendedb\z:}', "");;
    Expect(0, 2208, '\p{Block=:\Aarabicextendedb\z:}', "");;
    Expect(1, 2207, '\p{Block=		ARABIC_Extended_B}', "");
    Expect(0, 2207, '\p{^Block=		ARABIC_Extended_B}', "");
    Expect(0, 2207, '\P{Block=		ARABIC_Extended_B}', "");
    Expect(1, 2207, '\P{^Block=		ARABIC_Extended_B}', "");
    Expect(0, 2208, '\p{Block=		ARABIC_Extended_B}', "");
    Expect(1, 2208, '\p{^Block=		ARABIC_Extended_B}', "");
    Expect(1, 2208, '\P{Block=		ARABIC_Extended_B}', "");
    Expect(0, 2208, '\P{^Block=		ARABIC_Extended_B}', "");
    Error('\p{Blk=	-ARABIC_ext_B:=}');
    Error('\P{Blk=	-ARABIC_ext_B:=}');
    Expect(1, 2207, '\p{Blk=:\AArabic_Ext_B\z:}', "");;
    Expect(0, 2208, '\p{Blk=:\AArabic_Ext_B\z:}', "");;
    Expect(1, 2207, '\p{Blk=arabicextb}', "");
    Expect(0, 2207, '\p{^Blk=arabicextb}', "");
    Expect(0, 2207, '\P{Blk=arabicextb}', "");
    Expect(1, 2207, '\P{^Blk=arabicextb}', "");
    Expect(0, 2208, '\p{Blk=arabicextb}', "");
    Expect(1, 2208, '\p{^Blk=arabicextb}', "");
    Expect(1, 2208, '\P{Blk=arabicextb}', "");
    Expect(0, 2208, '\P{^Blk=arabicextb}', "");
    Expect(1, 2207, '\p{Blk=:\Aarabicextb\z:}', "");;
    Expect(0, 2208, '\p{Blk=:\Aarabicextb\z:}', "");;
    Expect(1, 2207, '\p{Blk:	--ARABIC_Ext_b}', "");
    Expect(0, 2207, '\p{^Blk:	--ARABIC_Ext_b}', "");
    Expect(0, 2207, '\P{Blk:	--ARABIC_Ext_b}', "");
    Expect(1, 2207, '\P{^Blk:	--ARABIC_Ext_b}', "");
    Expect(0, 2208, '\p{Blk:	--ARABIC_Ext_b}', "");
    Expect(1, 2208, '\p{^Blk:	--ARABIC_Ext_b}', "");
    Expect(1, 2208, '\P{Blk:	--ARABIC_Ext_b}', "");
    Expect(0, 2208, '\P{^Blk:	--ARABIC_Ext_b}', "");
    Error('\p{Is_Block=/a/  arabic_EXTENDED_B}');
    Error('\P{Is_Block=/a/  arabic_EXTENDED_B}');
    Expect(1, 2207, '\p{Is_Block=arabicextendedb}', "");
    Expect(0, 2207, '\p{^Is_Block=arabicextendedb}', "");
    Expect(0, 2207, '\P{Is_Block=arabicextendedb}', "");
    Expect(1, 2207, '\P{^Is_Block=arabicextendedb}', "");
    Expect(0, 2208, '\p{Is_Block=arabicextendedb}', "");
    Expect(1, 2208, '\p{^Is_Block=arabicextendedb}', "");
    Expect(1, 2208, '\P{Is_Block=arabicextendedb}', "");
    Expect(0, 2208, '\P{^Is_Block=arabicextendedb}', "");
    Expect(1, 2207, '\p{Is_Block=- Arabic_Extended_B}', "");
    Expect(0, 2207, '\p{^Is_Block=- Arabic_Extended_B}', "");
    Expect(0, 2207, '\P{Is_Block=- Arabic_Extended_B}', "");
    Expect(1, 2207, '\P{^Is_Block=- Arabic_Extended_B}', "");
    Expect(0, 2208, '\p{Is_Block=- Arabic_Extended_B}', "");
    Expect(1, 2208, '\p{^Is_Block=- Arabic_Extended_B}', "");
    Expect(1, 2208, '\P{Is_Block=- Arabic_Extended_B}', "");
    Expect(0, 2208, '\P{^Is_Block=- Arabic_Extended_B}', "");
    Error('\p{Is_Blk=/a/ 	arabic_Ext_B}');
    Error('\P{Is_Blk=/a/ 	arabic_Ext_B}');
    Expect(1, 2207, '\p{Is_Blk=arabicextb}', "");
    Expect(0, 2207, '\p{^Is_Blk=arabicextb}', "");
    Expect(0, 2207, '\P{Is_Blk=arabicextb}', "");
    Expect(1, 2207, '\P{^Is_Blk=arabicextb}', "");
    Expect(0, 2208, '\p{Is_Blk=arabicextb}', "");
    Expect(1, 2208, '\p{^Is_Blk=arabicextb}', "");
    Expect(1, 2208, '\P{Is_Blk=arabicextb}', "");
    Expect(0, 2208, '\P{^Is_Blk=arabicextb}', "");
    Expect(1, 2207, '\p{Is_Blk= _ARABIC_Ext_B}', "");
    Expect(0, 2207, '\p{^Is_Blk= _ARABIC_Ext_B}', "");
    Expect(0, 2207, '\P{Is_Blk= _ARABIC_Ext_B}', "");
    Expect(1, 2207, '\P{^Is_Blk= _ARABIC_Ext_B}', "");
    Expect(0, 2208, '\p{Is_Blk= _ARABIC_Ext_B}', "");
    Expect(1, 2208, '\p{^Is_Blk= _ARABIC_Ext_B}', "");
    Expect(1, 2208, '\P{Is_Blk= _ARABIC_Ext_B}', "");
    Expect(0, 2208, '\P{^Is_Blk= _ARABIC_Ext_B}', "");
    Error('\p{Block= _arabic_Extended_C/a/}');
    Error('\P{Block= _arabic_Extended_C/a/}');
    Expect(1, 69375, '\p{Block=:\AArabic_Extended_C\z:}', "");;
    Expect(0, 69376, '\p{Block=:\AArabic_Extended_C\z:}', "");;
    Expect(1, 69375, '\p{Block=arabicextendedc}', "");
    Expect(0, 69375, '\p{^Block=arabicextendedc}', "");
    Expect(0, 69375, '\P{Block=arabicextendedc}', "");
    Expect(1, 69375, '\P{^Block=arabicextendedc}', "");
    Expect(0, 69376, '\p{Block=arabicextendedc}', "");
    Expect(1, 69376, '\p{^Block=arabicextendedc}', "");
    Expect(1, 69376, '\P{Block=arabicextendedc}', "");
    Expect(0, 69376, '\P{^Block=arabicextendedc}', "");
    Expect(1, 69375, '\p{Block=:\Aarabicextendedc\z:}', "");;
    Expect(0, 69376, '\p{Block=:\Aarabicextendedc\z:}', "");;
    Expect(1, 69375, '\p{Block=-arabic_Extended_C}', "");
    Expect(0, 69375, '\p{^Block=-arabic_Extended_C}', "");
    Expect(0, 69375, '\P{Block=-arabic_Extended_C}', "");
    Expect(1, 69375, '\P{^Block=-arabic_Extended_C}', "");
    Expect(0, 69376, '\p{Block=-arabic_Extended_C}', "");
    Expect(1, 69376, '\p{^Block=-arabic_Extended_C}', "");
    Expect(1, 69376, '\P{Block=-arabic_Extended_C}', "");
    Expect(0, 69376, '\P{^Block=-arabic_Extended_C}', "");
    Error('\p{Blk=_:=Arabic_ext_C}');
    Error('\P{Blk=_:=Arabic_ext_C}');
    Expect(1, 69375, '\p{Blk=:\AArabic_Ext_C\z:}', "");;
    Expect(0, 69376, '\p{Blk=:\AArabic_Ext_C\z:}', "");;
    Expect(1, 69375, '\p{Blk=arabicextc}', "");
    Expect(0, 69375, '\p{^Blk=arabicextc}', "");
    Expect(0, 69375, '\P{Blk=arabicextc}', "");
    Expect(1, 69375, '\P{^Blk=arabicextc}', "");
    Expect(0, 69376, '\p{Blk=arabicextc}', "");
    Expect(1, 69376, '\p{^Blk=arabicextc}', "");
    Expect(1, 69376, '\P{Blk=arabicextc}', "");
    Expect(0, 69376, '\P{^Blk=arabicextc}', "");
    Expect(1, 69375, '\p{Blk=:\Aarabicextc\z:}', "");;
    Expect(0, 69376, '\p{Blk=:\Aarabicextc\z:}', "");;
    Expect(1, 69375, '\p{Blk=_arabic_ext_C}', "");
    Expect(0, 69375, '\p{^Blk=_arabic_ext_C}', "");
    Expect(0, 69375, '\P{Blk=_arabic_ext_C}', "");
    Expect(1, 69375, '\P{^Blk=_arabic_ext_C}', "");
    Expect(0, 69376, '\p{Blk=_arabic_ext_C}', "");
    Expect(1, 69376, '\p{^Blk=_arabic_ext_C}', "");
    Expect(1, 69376, '\P{Blk=_arabic_ext_C}', "");
    Expect(0, 69376, '\P{^Blk=_arabic_ext_C}', "");
    Error('\p{Is_Block=	 arabic_Extended_C:=}');
    Error('\P{Is_Block=	 arabic_Extended_C:=}');
    Expect(1, 69375, '\p{Is_Block=arabicextendedc}', "");
    Expect(0, 69375, '\p{^Is_Block=arabicextendedc}', "");
    Expect(0, 69375, '\P{Is_Block=arabicextendedc}', "");
    Expect(1, 69375, '\P{^Is_Block=arabicextendedc}', "");
    Expect(0, 69376, '\p{Is_Block=arabicextendedc}', "");
    Expect(1, 69376, '\p{^Is_Block=arabicextendedc}', "");
    Expect(1, 69376, '\P{Is_Block=arabicextendedc}', "");
    Expect(0, 69376, '\P{^Is_Block=arabicextendedc}', "");
    Expect(1, 69375, '\p{Is_Block=_	ARABIC_Extended_C}', "");
    Expect(0, 69375, '\p{^Is_Block=_	ARABIC_Extended_C}', "");
    Expect(0, 69375, '\P{Is_Block=_	ARABIC_Extended_C}', "");
    Expect(1, 69375, '\P{^Is_Block=_	ARABIC_Extended_C}', "");
    Expect(0, 69376, '\p{Is_Block=_	ARABIC_Extended_C}', "");
    Expect(1, 69376, '\p{^Is_Block=_	ARABIC_Extended_C}', "");
    Expect(1, 69376, '\P{Is_Block=_	ARABIC_Extended_C}', "");
    Expect(0, 69376, '\P{^Is_Block=_	ARABIC_Extended_C}', "");
    Error('\p{Is_Blk=	:=ARABIC_Ext_C}');
    Error('\P{Is_Blk=	:=ARABIC_Ext_C}');
    Expect(1, 69375, '\p{Is_Blk=arabicextc}', "");
    Expect(0, 69375, '\p{^Is_Blk=arabicextc}', "");
    Expect(0, 69375, '\P{Is_Blk=arabicextc}', "");
    Expect(1, 69375, '\P{^Is_Blk=arabicextc}', "");
    Expect(0, 69376, '\p{Is_Blk=arabicextc}', "");
    Expect(1, 69376, '\p{^Is_Blk=arabicextc}', "");
    Expect(1, 69376, '\P{Is_Blk=arabicextc}', "");
    Expect(0, 69376, '\P{^Is_Blk=arabicextc}', "");
    Expect(1, 69375, '\p{Is_Blk= 	arabic_EXT_C}', "");
    Expect(0, 69375, '\p{^Is_Blk= 	arabic_EXT_C}', "");
    Expect(0, 69375, '\P{Is_Blk= 	arabic_EXT_C}', "");
    Expect(1, 69375, '\P{^Is_Blk= 	arabic_EXT_C}', "");
    Expect(0, 69376, '\p{Is_Blk= 	arabic_EXT_C}', "");
    Expect(1, 69376, '\p{^Is_Blk= 	arabic_EXT_C}', "");
    Expect(1, 69376, '\P{Is_Blk= 	arabic_EXT_C}', "");
    Expect(0, 69376, '\P{^Is_Blk= 	arabic_EXT_C}', "");
    Error('\p{Block=/a/ARABIC_Mathematical_Alphabetic_symbols}');
    Error('\P{Block=/a/ARABIC_Mathematical_Alphabetic_symbols}');
    Expect(1, 126719, '\p{Block=:\AArabic_Mathematical_Alphabetic_Symbols\z:}', "");;
    Expect(0, 126720, '\p{Block=:\AArabic_Mathematical_Alphabetic_Symbols\z:}', "");;
    Expect(1, 126719, '\p{Block=arabicmathematicalalphabeticsymbols}', "");
    Expect(0, 126719, '\p{^Block=arabicmathematicalalphabeticsymbols}', "");
    Expect(0, 126719, '\P{Block=arabicmathematicalalphabeticsymbols}', "");
    Expect(1, 126719, '\P{^Block=arabicmathematicalalphabeticsymbols}', "");
    Expect(0, 126720, '\p{Block=arabicmathematicalalphabeticsymbols}', "");
    Expect(1, 126720, '\p{^Block=arabicmathematicalalphabeticsymbols}', "");
    Expect(1, 126720, '\P{Block=arabicmathematicalalphabeticsymbols}', "");
    Expect(0, 126720, '\P{^Block=arabicmathematicalalphabeticsymbols}', "");
    Expect(1, 126719, '\p{Block=:\Aarabicmathematicalalphabeticsymbols\z:}', "");;
    Expect(0, 126720, '\p{Block=:\Aarabicmathematicalalphabeticsymbols\z:}', "");;
    Expect(1, 126719, '\p{Block=-arabic_Mathematical_alphabetic_SYMBOLS}', "");
    Expect(0, 126719, '\p{^Block=-arabic_Mathematical_alphabetic_SYMBOLS}', "");
    Expect(0, 126719, '\P{Block=-arabic_Mathematical_alphabetic_SYMBOLS}', "");
    Expect(1, 126719, '\P{^Block=-arabic_Mathematical_alphabetic_SYMBOLS}', "");
    Expect(0, 126720, '\p{Block=-arabic_Mathematical_alphabetic_SYMBOLS}', "");
    Expect(1, 126720, '\p{^Block=-arabic_Mathematical_alphabetic_SYMBOLS}', "");
    Expect(1, 126720, '\P{Block=-arabic_Mathematical_alphabetic_SYMBOLS}', "");
    Expect(0, 126720, '\P{^Block=-arabic_Mathematical_alphabetic_SYMBOLS}', "");
    Error('\p{Blk=:=__arabic_MATH}');
    Error('\P{Blk=:=__arabic_MATH}');
    Expect(1, 126719, '\p{Blk=:\AArabic_Math\z:}', "");;
    Expect(0, 126720, '\p{Blk=:\AArabic_Math\z:}', "");;
    Expect(1, 126719, '\p{Blk=arabicmath}', "");
    Expect(0, 126719, '\p{^Blk=arabicmath}', "");
    Expect(0, 126719, '\P{Blk=arabicmath}', "");
    Expect(1, 126719, '\P{^Blk=arabicmath}', "");
    Expect(0, 126720, '\p{Blk=arabicmath}', "");
    Expect(1, 126720, '\p{^Blk=arabicmath}', "");
    Expect(1, 126720, '\P{Blk=arabicmath}', "");
    Expect(0, 126720, '\P{^Blk=arabicmath}', "");
    Expect(1, 126719, '\p{Blk=:\Aarabicmath\z:}', "");;
    Expect(0, 126720, '\p{Blk=:\Aarabicmath\z:}', "");;
    Expect(1, 126719, '\p{Blk=-arabic_Math}', "");
    Expect(0, 126719, '\p{^Blk=-arabic_Math}', "");
    Expect(0, 126719, '\P{Blk=-arabic_Math}', "");
    Expect(1, 126719, '\P{^Blk=-arabic_Math}', "");
    Expect(0, 126720, '\p{Blk=-arabic_Math}', "");
    Expect(1, 126720, '\p{^Blk=-arabic_Math}', "");
    Expect(1, 126720, '\P{Blk=-arabic_Math}', "");
    Expect(0, 126720, '\P{^Blk=-arabic_Math}', "");
    Error('\p{Is_Block=__Arabic_Mathematical_alphabetic_symbols:=}');
    Error('\P{Is_Block=__Arabic_Mathematical_alphabetic_symbols:=}');
    Expect(1, 126719, '\p{Is_Block=arabicmathematicalalphabeticsymbols}', "");
    Expect(0, 126719, '\p{^Is_Block=arabicmathematicalalphabeticsymbols}', "");
    Expect(0, 126719, '\P{Is_Block=arabicmathematicalalphabeticsymbols}', "");
    Expect(1, 126719, '\P{^Is_Block=arabicmathematicalalphabeticsymbols}', "");
    Expect(0, 126720, '\p{Is_Block=arabicmathematicalalphabeticsymbols}', "");
    Expect(1, 126720, '\p{^Is_Block=arabicmathematicalalphabeticsymbols}', "");
    Expect(1, 126720, '\P{Is_Block=arabicmathematicalalphabeticsymbols}', "");
    Expect(0, 126720, '\P{^Is_Block=arabicmathematicalalphabeticsymbols}', "");
    Expect(1, 126719, '\p{Is_Block= ARABIC_Mathematical_Alphabetic_Symbols}', "");
    Expect(0, 126719, '\p{^Is_Block= ARABIC_Mathematical_Alphabetic_Symbols}', "");
    Expect(0, 126719, '\P{Is_Block= ARABIC_Mathematical_Alphabetic_Symbols}', "");
    Expect(1, 126719, '\P{^Is_Block= ARABIC_Mathematical_Alphabetic_Symbols}', "");
    Expect(0, 126720, '\p{Is_Block= ARABIC_Mathematical_Alphabetic_Symbols}', "");
    Expect(1, 126720, '\p{^Is_Block= ARABIC_Mathematical_Alphabetic_Symbols}', "");
    Expect(1, 126720, '\P{Is_Block= ARABIC_Mathematical_Alphabetic_Symbols}', "");
    Expect(0, 126720, '\P{^Is_Block= ARABIC_Mathematical_Alphabetic_Symbols}', "");
    Error('\p{Is_Blk:   __arabic_MATH/a/}');
    Error('\P{Is_Blk:   __arabic_MATH/a/}');
    Expect(1, 126719, '\p{Is_Blk=arabicmath}', "");
    Expect(0, 126719, '\p{^Is_Blk=arabicmath}', "");
    Expect(0, 126719, '\P{Is_Blk=arabicmath}', "");
    Expect(1, 126719, '\P{^Is_Blk=arabicmath}', "");
    Expect(0, 126720, '\p{Is_Blk=arabicmath}', "");
    Expect(1, 126720, '\p{^Is_Blk=arabicmath}', "");
    Expect(1, 126720, '\P{Is_Blk=arabicmath}', "");
    Expect(0, 126720, '\P{^Is_Blk=arabicmath}', "");
    Expect(1, 126719, '\p{Is_Blk=__ARABIC_math}', "");
    Expect(0, 126719, '\p{^Is_Blk=__ARABIC_math}', "");
    Expect(0, 126719, '\P{Is_Blk=__ARABIC_math}', "");
    Expect(1, 126719, '\P{^Is_Blk=__ARABIC_math}', "");
    Expect(0, 126720, '\p{Is_Blk=__ARABIC_math}', "");
    Expect(1, 126720, '\p{^Is_Blk=__ARABIC_math}', "");
    Expect(1, 126720, '\P{Is_Blk=__ARABIC_math}', "");
    Expect(0, 126720, '\P{^Is_Blk=__ARABIC_math}', "");
    Error('\p{Block:	/a/ARABIC_PRESENTATION_Forms_A}');
    Error('\P{Block:	/a/ARABIC_PRESENTATION_Forms_A}');
    Expect(1, 65023, '\p{Block=:\AArabic_Presentation_Forms_A\z:}', "");;
    Expect(0, 65024, '\p{Block=:\AArabic_Presentation_Forms_A\z:}', "");;
    Expect(1, 65023, '\p{Block=arabicpresentationformsa}', "");
    Expect(0, 65023, '\p{^Block=arabicpresentationformsa}', "");
    Expect(0, 65023, '\P{Block=arabicpresentationformsa}', "");
    Expect(1, 65023, '\P{^Block=arabicpresentationformsa}', "");
    Expect(0, 65024, '\p{Block=arabicpresentationformsa}', "");
    Expect(1, 65024, '\p{^Block=arabicpresentationformsa}', "");
    Expect(1, 65024, '\P{Block=arabicpresentationformsa}', "");
    Expect(0, 65024, '\P{^Block=arabicpresentationformsa}', "");
    Expect(1, 65023, '\p{Block=:\Aarabicpresentationformsa\z:}', "");;
    Expect(0, 65024, '\p{Block=:\Aarabicpresentationformsa\z:}', "");;
    Expect(1, 65023, '\p{Block=		ARABIC_Presentation_FORMS_A}', "");
    Expect(0, 65023, '\p{^Block=		ARABIC_Presentation_FORMS_A}', "");
    Expect(0, 65023, '\P{Block=		ARABIC_Presentation_FORMS_A}', "");
    Expect(1, 65023, '\P{^Block=		ARABIC_Presentation_FORMS_A}', "");
    Expect(0, 65024, '\p{Block=		ARABIC_Presentation_FORMS_A}', "");
    Expect(1, 65024, '\p{^Block=		ARABIC_Presentation_FORMS_A}', "");
    Expect(1, 65024, '\P{Block=		ARABIC_Presentation_FORMS_A}', "");
    Expect(0, 65024, '\P{^Block=		ARABIC_Presentation_FORMS_A}', "");
    Error('\p{Blk=_arabic_PF_A/a/}');
    Error('\P{Blk=_arabic_PF_A/a/}');
    Expect(1, 65023, '\p{Blk=:\AArabic_PF_A\z:}', "");;
    Expect(0, 65024, '\p{Blk=:\AArabic_PF_A\z:}', "");;
    Expect(1, 65023, '\p{Blk=arabicpfa}', "");
    Expect(0, 65023, '\p{^Blk=arabicpfa}', "");
    Expect(0, 65023, '\P{Blk=arabicpfa}', "");
    Expect(1, 65023, '\P{^Blk=arabicpfa}', "");
    Expect(0, 65024, '\p{Blk=arabicpfa}', "");
    Expect(1, 65024, '\p{^Blk=arabicpfa}', "");
    Expect(1, 65024, '\P{Blk=arabicpfa}', "");
    Expect(0, 65024, '\P{^Blk=arabicpfa}', "");
    Expect(1, 65023, '\p{Blk=:\Aarabicpfa\z:}', "");;
    Expect(0, 65024, '\p{Blk=:\Aarabicpfa\z:}', "");;
    Expect(1, 65023, '\p{Blk=	 Arabic_PF_a}', "");
    Expect(0, 65023, '\p{^Blk=	 Arabic_PF_a}', "");
    Expect(0, 65023, '\P{Blk=	 Arabic_PF_a}', "");
    Expect(1, 65023, '\P{^Blk=	 Arabic_PF_a}', "");
    Expect(0, 65024, '\p{Blk=	 Arabic_PF_a}', "");
    Expect(1, 65024, '\p{^Blk=	 Arabic_PF_a}', "");
    Expect(1, 65024, '\P{Blk=	 Arabic_PF_a}', "");
    Expect(0, 65024, '\P{^Blk=	 Arabic_PF_a}', "");
    Error('\p{Is_Block=:=- Arabic_Presentation_FORMS_A}');
    Error('\P{Is_Block=:=- Arabic_Presentation_FORMS_A}');
    Expect(1, 65023, '\p{Is_Block=arabicpresentationformsa}', "");
    Expect(0, 65023, '\p{^Is_Block=arabicpresentationformsa}', "");
    Expect(0, 65023, '\P{Is_Block=arabicpresentationformsa}', "");
    Expect(1, 65023, '\P{^Is_Block=arabicpresentationformsa}', "");
    Expect(0, 65024, '\p{Is_Block=arabicpresentationformsa}', "");
    Expect(1, 65024, '\p{^Is_Block=arabicpresentationformsa}', "");
    Expect(1, 65024, '\P{Is_Block=arabicpresentationformsa}', "");
    Expect(0, 65024, '\P{^Is_Block=arabicpresentationformsa}', "");
    Expect(1, 65023, '\p{Is_Block=_ ARABIC_Presentation_Forms_A}', "");
    Expect(0, 65023, '\p{^Is_Block=_ ARABIC_Presentation_Forms_A}', "");
    Expect(0, 65023, '\P{Is_Block=_ ARABIC_Presentation_Forms_A}', "");
    Expect(1, 65023, '\P{^Is_Block=_ ARABIC_Presentation_Forms_A}', "");
    Expect(0, 65024, '\p{Is_Block=_ ARABIC_Presentation_Forms_A}', "");
    Expect(1, 65024, '\p{^Is_Block=_ ARABIC_Presentation_Forms_A}', "");
    Expect(1, 65024, '\P{Is_Block=_ ARABIC_Presentation_Forms_A}', "");
    Expect(0, 65024, '\P{^Is_Block=_ ARABIC_Presentation_Forms_A}', "");
    Error('\p{Is_Blk=	_Arabic_PF_A/a/}');
    Error('\P{Is_Blk=	_Arabic_PF_A/a/}');
    Expect(1, 65023, '\p{Is_Blk=arabicpfa}', "");
    Expect(0, 65023, '\p{^Is_Blk=arabicpfa}', "");
    Expect(0, 65023, '\P{Is_Blk=arabicpfa}', "");
    Expect(1, 65023, '\P{^Is_Blk=arabicpfa}', "");
    Expect(0, 65024, '\p{Is_Blk=arabicpfa}', "");
    Expect(1, 65024, '\p{^Is_Blk=arabicpfa}', "");
    Expect(1, 65024, '\P{Is_Blk=arabicpfa}', "");
    Expect(0, 65024, '\P{^Is_Blk=arabicpfa}', "");
    Expect(1, 65023, '\p{Is_Blk= ARABIC_PF_a}', "");
    Expect(0, 65023, '\p{^Is_Blk= ARABIC_PF_a}', "");
    Expect(0, 65023, '\P{Is_Blk= ARABIC_PF_a}', "");
    Expect(1, 65023, '\P{^Is_Blk= ARABIC_PF_a}', "");
    Expect(0, 65024, '\p{Is_Blk= ARABIC_PF_a}', "");
    Expect(1, 65024, '\p{^Is_Blk= ARABIC_PF_a}', "");
    Expect(1, 65024, '\P{Is_Blk= ARABIC_PF_a}', "");
    Expect(0, 65024, '\P{^Is_Blk= ARABIC_PF_a}', "");
    Error('\p{Block=_:=Arabic_Presentation_Forms_b}');
    Error('\P{Block=_:=Arabic_Presentation_Forms_b}');
    Expect(1, 65279, '\p{Block=:\AArabic_Presentation_Forms_B\z:}', "");;
    Expect(0, 65280, '\p{Block=:\AArabic_Presentation_Forms_B\z:}', "");;
    Expect(1, 65279, '\p{Block=arabicpresentationformsb}', "");
    Expect(0, 65279, '\p{^Block=arabicpresentationformsb}', "");
    Expect(0, 65279, '\P{Block=arabicpresentationformsb}', "");
    Expect(1, 65279, '\P{^Block=arabicpresentationformsb}', "");
    Expect(0, 65280, '\p{Block=arabicpresentationformsb}', "");
    Expect(1, 65280, '\p{^Block=arabicpresentationformsb}', "");
    Expect(1, 65280, '\P{Block=arabicpresentationformsb}', "");
    Expect(0, 65280, '\P{^Block=arabicpresentationformsb}', "");
    Expect(1, 65279, '\p{Block=:\Aarabicpresentationformsb\z:}', "");;
    Expect(0, 65280, '\p{Block=:\Aarabicpresentationformsb\z:}', "");;
    Expect(1, 65279, '\p{Block: 	_ARABIC_presentation_FORMS_b}', "");
    Expect(0, 65279, '\p{^Block: 	_ARABIC_presentation_FORMS_b}', "");
    Expect(0, 65279, '\P{Block: 	_ARABIC_presentation_FORMS_b}', "");
    Expect(1, 65279, '\P{^Block: 	_ARABIC_presentation_FORMS_b}', "");
    Expect(0, 65280, '\p{Block: 	_ARABIC_presentation_FORMS_b}', "");
    Expect(1, 65280, '\p{^Block: 	_ARABIC_presentation_FORMS_b}', "");
    Expect(1, 65280, '\P{Block: 	_ARABIC_presentation_FORMS_b}', "");
    Expect(0, 65280, '\P{^Block: 	_ARABIC_presentation_FORMS_b}', "");
    Error('\p{Blk=--Arabic_PF_B/a/}');
    Error('\P{Blk=--Arabic_PF_B/a/}');
    Expect(1, 65279, '\p{Blk=:\AArabic_PF_B\z:}', "");;
    Expect(0, 65280, '\p{Blk=:\AArabic_PF_B\z:}', "");;
    Expect(1, 65279, '\p{Blk=arabicpfb}', "");
    Expect(0, 65279, '\p{^Blk=arabicpfb}', "");
    Expect(0, 65279, '\P{Blk=arabicpfb}', "");
    Expect(1, 65279, '\P{^Blk=arabicpfb}', "");
    Expect(0, 65280, '\p{Blk=arabicpfb}', "");
    Expect(1, 65280, '\p{^Blk=arabicpfb}', "");
    Expect(1, 65280, '\P{Blk=arabicpfb}', "");
    Expect(0, 65280, '\P{^Blk=arabicpfb}', "");
    Expect(1, 65279, '\p{Blk=:\Aarabicpfb\z:}', "");;
    Expect(0, 65280, '\p{Blk=:\Aarabicpfb\z:}', "");;
    Expect(1, 65279, '\p{Blk: _	Arabic_pf_B}', "");
    Expect(0, 65279, '\p{^Blk: _	Arabic_pf_B}', "");
    Expect(0, 65279, '\P{Blk: _	Arabic_pf_B}', "");
    Expect(1, 65279, '\P{^Blk: _	Arabic_pf_B}', "");
    Expect(0, 65280, '\p{Blk: _	Arabic_pf_B}', "");
    Expect(1, 65280, '\p{^Blk: _	Arabic_pf_B}', "");
    Expect(1, 65280, '\P{Blk: _	Arabic_pf_B}', "");
    Expect(0, 65280, '\P{^Blk: _	Arabic_pf_B}', "");
    Error('\p{Is_Block=-Arabic_presentation_Forms_B/a/}');
    Error('\P{Is_Block=-Arabic_presentation_Forms_B/a/}');
    Expect(1, 65279, '\p{Is_Block=arabicpresentationformsb}', "");
    Expect(0, 65279, '\p{^Is_Block=arabicpresentationformsb}', "");
    Expect(0, 65279, '\P{Is_Block=arabicpresentationformsb}', "");
    Expect(1, 65279, '\P{^Is_Block=arabicpresentationformsb}', "");
    Expect(0, 65280, '\p{Is_Block=arabicpresentationformsb}', "");
    Expect(1, 65280, '\p{^Is_Block=arabicpresentationformsb}', "");
    Expect(1, 65280, '\P{Is_Block=arabicpresentationformsb}', "");
    Expect(0, 65280, '\P{^Is_Block=arabicpresentationformsb}', "");
    Expect(1, 65279, '\p{Is_Block=_Arabic_Presentation_Forms_b}', "");
    Expect(0, 65279, '\p{^Is_Block=_Arabic_Presentation_Forms_b}', "");
    Expect(0, 65279, '\P{Is_Block=_Arabic_Presentation_Forms_b}', "");
    Expect(1, 65279, '\P{^Is_Block=_Arabic_Presentation_Forms_b}', "");
    Expect(0, 65280, '\p{Is_Block=_Arabic_Presentation_Forms_b}', "");
    Expect(1, 65280, '\p{^Is_Block=_Arabic_Presentation_Forms_b}', "");
    Expect(1, 65280, '\P{Is_Block=_Arabic_Presentation_Forms_b}', "");
    Expect(0, 65280, '\P{^Is_Block=_Arabic_Presentation_Forms_b}', "");
    Error('\p{Is_Blk=	:=Arabic_PF_B}');
    Error('\P{Is_Blk=	:=Arabic_PF_B}');
    Expect(1, 65279, '\p{Is_Blk=arabicpfb}', "");
    Expect(0, 65279, '\p{^Is_Blk=arabicpfb}', "");
    Expect(0, 65279, '\P{Is_Blk=arabicpfb}', "");
    Expect(1, 65279, '\P{^Is_Blk=arabicpfb}', "");
    Expect(0, 65280, '\p{Is_Blk=arabicpfb}', "");
    Expect(1, 65280, '\p{^Is_Blk=arabicpfb}', "");
    Expect(1, 65280, '\P{Is_Blk=arabicpfb}', "");
    Expect(0, 65280, '\P{^Is_Blk=arabicpfb}', "");
    Expect(1, 65279, '\p{Is_Blk=	_ARABIC_pf_B}', "");
    Expect(0, 65279, '\p{^Is_Blk=	_ARABIC_pf_B}', "");
    Expect(0, 65279, '\P{Is_Blk=	_ARABIC_pf_B}', "");
    Expect(1, 65279, '\P{^Is_Blk=	_ARABIC_pf_B}', "");
    Expect(0, 65280, '\p{Is_Blk=	_ARABIC_pf_B}', "");
    Expect(1, 65280, '\p{^Is_Blk=	_ARABIC_pf_B}', "");
    Expect(1, 65280, '\P{Is_Blk=	_ARABIC_pf_B}', "");
    Expect(0, 65280, '\P{^Is_Blk=	_ARABIC_pf_B}', "");
    Error('\p{Block=/a/_arabic_supplement}');
    Error('\P{Block=/a/_arabic_supplement}');
    Expect(1, 1919, '\p{Block=:\AArabic_Supplement\z:}', "");;
    Expect(0, 1920, '\p{Block=:\AArabic_Supplement\z:}', "");;
    Expect(1, 1919, '\p{Block=arabicsupplement}', "");
    Expect(0, 1919, '\p{^Block=arabicsupplement}', "");
    Expect(0, 1919, '\P{Block=arabicsupplement}', "");
    Expect(1, 1919, '\P{^Block=arabicsupplement}', "");
    Expect(0, 1920, '\p{Block=arabicsupplement}', "");
    Expect(1, 1920, '\p{^Block=arabicsupplement}', "");
    Expect(1, 1920, '\P{Block=arabicsupplement}', "");
    Expect(0, 1920, '\P{^Block=arabicsupplement}', "");
    Expect(1, 1919, '\p{Block=:\Aarabicsupplement\z:}', "");;
    Expect(0, 1920, '\p{Block=:\Aarabicsupplement\z:}', "");;
    Expect(1, 1919, '\p{Block=__Arabic_Supplement}', "");
    Expect(0, 1919, '\p{^Block=__Arabic_Supplement}', "");
    Expect(0, 1919, '\P{Block=__Arabic_Supplement}', "");
    Expect(1, 1919, '\P{^Block=__Arabic_Supplement}', "");
    Expect(0, 1920, '\p{Block=__Arabic_Supplement}', "");
    Expect(1, 1920, '\p{^Block=__Arabic_Supplement}', "");
    Expect(1, 1920, '\P{Block=__Arabic_Supplement}', "");
    Expect(0, 1920, '\P{^Block=__Arabic_Supplement}', "");
    Error('\p{Blk= /a/arabic_Sup}');
    Error('\P{Blk= /a/arabic_Sup}');
    Expect(1, 1919, '\p{Blk=:\AArabic_Sup\z:}', "");;
    Expect(0, 1920, '\p{Blk=:\AArabic_Sup\z:}', "");;
    Expect(1, 1919, '\p{Blk: arabicsup}', "");
    Expect(0, 1919, '\p{^Blk: arabicsup}', "");
    Expect(0, 1919, '\P{Blk: arabicsup}', "");
    Expect(1, 1919, '\P{^Blk: arabicsup}', "");
    Expect(0, 1920, '\p{Blk: arabicsup}', "");
    Expect(1, 1920, '\p{^Blk: arabicsup}', "");
    Expect(1, 1920, '\P{Blk: arabicsup}', "");
    Expect(0, 1920, '\P{^Blk: arabicsup}', "");
    Expect(1, 1919, '\p{Blk=:\Aarabicsup\z:}', "");;
    Expect(0, 1920, '\p{Blk=:\Aarabicsup\z:}', "");;
    Expect(1, 1919, '\p{Blk=_	ARABIC_Sup}', "");
    Expect(0, 1919, '\p{^Blk=_	ARABIC_Sup}', "");
    Expect(0, 1919, '\P{Blk=_	ARABIC_Sup}', "");
    Expect(1, 1919, '\P{^Blk=_	ARABIC_Sup}', "");
    Expect(0, 1920, '\p{Blk=_	ARABIC_Sup}', "");
    Expect(1, 1920, '\p{^Blk=_	ARABIC_Sup}', "");
    Expect(1, 1920, '\P{Blk=_	ARABIC_Sup}', "");
    Expect(0, 1920, '\P{^Blk=_	ARABIC_Sup}', "");
    Error('\p{Is_Block=_:=Arabic_Supplement}');
    Error('\P{Is_Block=_:=Arabic_Supplement}');
    Expect(1, 1919, '\p{Is_Block=arabicsupplement}', "");
    Expect(0, 1919, '\p{^Is_Block=arabicsupplement}', "");
    Expect(0, 1919, '\P{Is_Block=arabicsupplement}', "");
    Expect(1, 1919, '\P{^Is_Block=arabicsupplement}', "");
    Expect(0, 1920, '\p{Is_Block=arabicsupplement}', "");
    Expect(1, 1920, '\p{^Is_Block=arabicsupplement}', "");
    Expect(1, 1920, '\P{Is_Block=arabicsupplement}', "");
    Expect(0, 1920, '\P{^Is_Block=arabicsupplement}', "");
    Expect(1, 1919, '\p{Is_Block:_Arabic_Supplement}', "");
    Expect(0, 1919, '\p{^Is_Block:_Arabic_Supplement}', "");
    Expect(0, 1919, '\P{Is_Block:_Arabic_Supplement}', "");
    Expect(1, 1919, '\P{^Is_Block:_Arabic_Supplement}', "");
    Expect(0, 1920, '\p{Is_Block:_Arabic_Supplement}', "");
    Expect(1, 1920, '\p{^Is_Block:_Arabic_Supplement}', "");
    Expect(1, 1920, '\P{Is_Block:_Arabic_Supplement}', "");
    Expect(0, 1920, '\P{^Is_Block:_Arabic_Supplement}', "");
    Error('\p{Is_Blk=_ ARABIC_Sup:=}');
    Error('\P{Is_Blk=_ ARABIC_Sup:=}');
    Expect(1, 1919, '\p{Is_Blk=arabicsup}', "");
    Expect(0, 1919, '\p{^Is_Blk=arabicsup}', "");
    Expect(0, 1919, '\P{Is_Blk=arabicsup}', "");
    Expect(1, 1919, '\P{^Is_Blk=arabicsup}', "");
    Expect(0, 1920, '\p{Is_Blk=arabicsup}', "");
    Expect(1, 1920, '\p{^Is_Blk=arabicsup}', "");
    Expect(1, 1920, '\P{Is_Blk=arabicsup}', "");
    Expect(0, 1920, '\P{^Is_Blk=arabicsup}', "");
    Expect(1, 1919, '\p{Is_Blk:	Arabic_Sup}', "");
    Expect(0, 1919, '\p{^Is_Blk:	Arabic_Sup}', "");
    Expect(0, 1919, '\P{Is_Blk:	Arabic_Sup}', "");
    Expect(1, 1919, '\P{^Is_Blk:	Arabic_Sup}', "");
    Expect(0, 1920, '\p{Is_Blk:	Arabic_Sup}', "");
    Expect(1, 1920, '\p{^Is_Blk:	Arabic_Sup}', "");
    Expect(1, 1920, '\P{Is_Blk:	Arabic_Sup}', "");
    Expect(0, 1920, '\P{^Is_Blk:	Arabic_Sup}', "");
    Error('\p{Block=_/a/Armenian}');
    Error('\P{Block=_/a/Armenian}');
    Expect(1, 1423, '\p{Block=:\AArmenian\z:}', "");;
    Expect(0, 1424, '\p{Block=:\AArmenian\z:}', "");;
    Expect(1, 1423, '\p{Block=armenian}', "");
    Expect(0, 1423, '\p{^Block=armenian}', "");
    Expect(0, 1423, '\P{Block=armenian}', "");
    Expect(1, 1423, '\P{^Block=armenian}', "");
    Expect(0, 1424, '\p{Block=armenian}', "");
    Expect(1, 1424, '\p{^Block=armenian}', "");
    Expect(1, 1424, '\P{Block=armenian}', "");
    Expect(0, 1424, '\P{^Block=armenian}', "");
    Expect(1, 1423, '\p{Block=:\Aarmenian\z:}', "");;
    Expect(0, 1424, '\p{Block=:\Aarmenian\z:}', "");;
    Expect(1, 1423, '\p{Block=_ARMENIAN}', "");
    Expect(0, 1423, '\p{^Block=_ARMENIAN}', "");
    Expect(0, 1423, '\P{Block=_ARMENIAN}', "");
    Expect(1, 1423, '\P{^Block=_ARMENIAN}', "");
    Expect(0, 1424, '\p{Block=_ARMENIAN}', "");
    Expect(1, 1424, '\p{^Block=_ARMENIAN}', "");
    Expect(1, 1424, '\P{Block=_ARMENIAN}', "");
    Expect(0, 1424, '\P{^Block=_ARMENIAN}', "");
    Error('\p{Blk=-_Armenian/a/}');
    Error('\P{Blk=-_Armenian/a/}');
    Expect(1, 1423, '\p{Blk=:\AArmenian\z:}', "");;
    Expect(0, 1424, '\p{Blk=:\AArmenian\z:}', "");;
    Expect(1, 1423, '\p{Blk=armenian}', "");
    Expect(0, 1423, '\p{^Blk=armenian}', "");
    Expect(0, 1423, '\P{Blk=armenian}', "");
    Expect(1, 1423, '\P{^Blk=armenian}', "");
    Expect(0, 1424, '\p{Blk=armenian}', "");
    Expect(1, 1424, '\p{^Blk=armenian}', "");
    Expect(1, 1424, '\P{Blk=armenian}', "");
    Expect(0, 1424, '\P{^Blk=armenian}', "");
    Expect(1, 1423, '\p{Blk=:\Aarmenian\z:}', "");;
    Expect(0, 1424, '\p{Blk=:\Aarmenian\z:}', "");;
    Expect(1, 1423, '\p{Blk=_-Armenian}', "");
    Expect(0, 1423, '\p{^Blk=_-Armenian}', "");
    Expect(0, 1423, '\P{Blk=_-Armenian}', "");
    Expect(1, 1423, '\P{^Blk=_-Armenian}', "");
    Expect(0, 1424, '\p{Blk=_-Armenian}', "");
    Expect(1, 1424, '\p{^Blk=_-Armenian}', "");
    Expect(1, 1424, '\P{Blk=_-Armenian}', "");
    Expect(0, 1424, '\P{^Blk=_-Armenian}', "");
    Error('\p{Is_Block= ARMENIAN:=}');
    Error('\P{Is_Block= ARMENIAN:=}');
    Expect(1, 1423, '\p{Is_Block=armenian}', "");
    Expect(0, 1423, '\p{^Is_Block=armenian}', "");
    Expect(0, 1423, '\P{Is_Block=armenian}', "");
    Expect(1, 1423, '\P{^Is_Block=armenian}', "");
    Expect(0, 1424, '\p{Is_Block=armenian}', "");
    Expect(1, 1424, '\p{^Is_Block=armenian}', "");
    Expect(1, 1424, '\P{Is_Block=armenian}', "");
    Expect(0, 1424, '\P{^Is_Block=armenian}', "");
    Expect(1, 1423, '\p{Is_Block=		armenian}', "");
    Expect(0, 1423, '\p{^Is_Block=		armenian}', "");
    Expect(0, 1423, '\P{Is_Block=		armenian}', "");
    Expect(1, 1423, '\P{^Is_Block=		armenian}', "");
    Expect(0, 1424, '\p{Is_Block=		armenian}', "");
    Expect(1, 1424, '\p{^Is_Block=		armenian}', "");
    Expect(1, 1424, '\P{Is_Block=		armenian}', "");
    Expect(0, 1424, '\P{^Is_Block=		armenian}', "");
    Error('\p{Is_Blk=:= _armenian}');
    Error('\P{Is_Blk=:= _armenian}');
    Expect(1, 1423, '\p{Is_Blk:   armenian}', "");
    Expect(0, 1423, '\p{^Is_Blk:   armenian}', "");
    Expect(0, 1423, '\P{Is_Blk:   armenian}', "");
    Expect(1, 1423, '\P{^Is_Blk:   armenian}', "");
    Expect(0, 1424, '\p{Is_Blk:   armenian}', "");
    Expect(1, 1424, '\p{^Is_Blk:   armenian}', "");
    Expect(1, 1424, '\P{Is_Blk:   armenian}', "");
    Expect(0, 1424, '\P{^Is_Blk:   armenian}', "");
    Expect(1, 1423, '\p{Is_Blk=-	ARMENIAN}', "");
    Expect(0, 1423, '\p{^Is_Blk=-	ARMENIAN}', "");
    Expect(0, 1423, '\P{Is_Blk=-	ARMENIAN}', "");
    Expect(1, 1423, '\P{^Is_Blk=-	ARMENIAN}', "");
    Expect(0, 1424, '\p{Is_Blk=-	ARMENIAN}', "");
    Expect(1, 1424, '\p{^Is_Blk=-	ARMENIAN}', "");
    Expect(1, 1424, '\P{Is_Blk=-	ARMENIAN}', "");
    Expect(0, 1424, '\P{^Is_Blk=-	ARMENIAN}', "");
    Error('\p{Block=_ Arrows/a/}');
    Error('\P{Block=_ Arrows/a/}');
    Expect(1, 8703, '\p{Block=:\AArrows\z:}', "");;
    Expect(0, 8704, '\p{Block=:\AArrows\z:}', "");;
    Expect(1, 8703, '\p{Block:   arrows}', "");
    Expect(0, 8703, '\p{^Block:   arrows}', "");
    Expect(0, 8703, '\P{Block:   arrows}', "");
    Expect(1, 8703, '\P{^Block:   arrows}', "");
    Expect(0, 8704, '\p{Block:   arrows}', "");
    Expect(1, 8704, '\p{^Block:   arrows}', "");
    Expect(1, 8704, '\P{Block:   arrows}', "");
    Expect(0, 8704, '\P{^Block:   arrows}', "");
    Expect(1, 8703, '\p{Block=:\Aarrows\z:}', "");;
    Expect(0, 8704, '\p{Block=:\Aarrows\z:}', "");;
    Expect(1, 8703, '\p{Block=	ARROWS}', "");
    Expect(0, 8703, '\p{^Block=	ARROWS}', "");
    Expect(0, 8703, '\P{Block=	ARROWS}', "");
    Expect(1, 8703, '\P{^Block=	ARROWS}', "");
    Expect(0, 8704, '\p{Block=	ARROWS}', "");
    Expect(1, 8704, '\p{^Block=	ARROWS}', "");
    Expect(1, 8704, '\P{Block=	ARROWS}', "");
    Expect(0, 8704, '\P{^Block=	ARROWS}', "");
    Error('\p{Blk: _Arrows/a/}');
    Error('\P{Blk: _Arrows/a/}');
    Expect(1, 8703, '\p{Blk=:\AArrows\z:}', "");;
    Expect(0, 8704, '\p{Blk=:\AArrows\z:}', "");;
    Expect(1, 8703, '\p{Blk=arrows}', "");
    Expect(0, 8703, '\p{^Blk=arrows}', "");
    Expect(0, 8703, '\P{Blk=arrows}', "");
    Expect(1, 8703, '\P{^Blk=arrows}', "");
    Expect(0, 8704, '\p{Blk=arrows}', "");
    Expect(1, 8704, '\p{^Blk=arrows}', "");
    Expect(1, 8704, '\P{Blk=arrows}', "");
    Expect(0, 8704, '\P{^Blk=arrows}', "");
    Expect(1, 8703, '\p{Blk=:\Aarrows\z:}', "");;
    Expect(0, 8704, '\p{Blk=:\Aarrows\z:}', "");;
    Expect(1, 8703, '\p{Blk=_arrows}', "");
    Expect(0, 8703, '\p{^Blk=_arrows}', "");
    Expect(0, 8703, '\P{Blk=_arrows}', "");
    Expect(1, 8703, '\P{^Blk=_arrows}', "");
    Expect(0, 8704, '\p{Blk=_arrows}', "");
    Expect(1, 8704, '\p{^Blk=_arrows}', "");
    Expect(1, 8704, '\P{Blk=_arrows}', "");
    Expect(0, 8704, '\P{^Blk=_arrows}', "");
    Error('\p{Is_Block=-	Arrows/a/}');
    Error('\P{Is_Block=-	Arrows/a/}');
    Expect(1, 8703, '\p{Is_Block: arrows}', "");
    Expect(0, 8703, '\p{^Is_Block: arrows}', "");
    Expect(0, 8703, '\P{Is_Block: arrows}', "");
    Expect(1, 8703, '\P{^Is_Block: arrows}', "");
    Expect(0, 8704, '\p{Is_Block: arrows}', "");
    Expect(1, 8704, '\p{^Is_Block: arrows}', "");
    Expect(1, 8704, '\P{Is_Block: arrows}', "");
    Expect(0, 8704, '\P{^Is_Block: arrows}', "");
    Expect(1, 8703, '\p{Is_Block=	_ARROWS}', "");
    Expect(0, 8703, '\p{^Is_Block=	_ARROWS}', "");
    Expect(0, 8703, '\P{Is_Block=	_ARROWS}', "");
    Expect(1, 8703, '\P{^Is_Block=	_ARROWS}', "");
    Expect(0, 8704, '\p{Is_Block=	_ARROWS}', "");
    Expect(1, 8704, '\p{^Is_Block=	_ARROWS}', "");
    Expect(1, 8704, '\P{Is_Block=	_ARROWS}', "");
    Expect(0, 8704, '\P{^Is_Block=	_ARROWS}', "");
    Error('\p{Is_Blk=-_Arrows:=}');
    Error('\P{Is_Blk=-_Arrows:=}');
    Expect(1, 8703, '\p{Is_Blk=arrows}', "");
    Expect(0, 8703, '\p{^Is_Blk=arrows}', "");
    Expect(0, 8703, '\P{Is_Blk=arrows}', "");
    Expect(1, 8703, '\P{^Is_Blk=arrows}', "");
    Expect(0, 8704, '\p{Is_Blk=arrows}', "");
    Expect(1, 8704, '\p{^Is_Blk=arrows}', "");
    Expect(1, 8704, '\P{Is_Blk=arrows}', "");
    Expect(0, 8704, '\P{^Is_Blk=arrows}', "");
    Expect(1, 8703, '\p{Is_Blk=-_ARROWS}', "");
    Expect(0, 8703, '\p{^Is_Blk=-_ARROWS}', "");
    Expect(0, 8703, '\P{Is_Blk=-_ARROWS}', "");
    Expect(1, 8703, '\P{^Is_Blk=-_ARROWS}', "");
    Expect(0, 8704, '\p{Is_Blk=-_ARROWS}', "");
    Expect(1, 8704, '\p{^Is_Blk=-_ARROWS}', "");
    Expect(1, 8704, '\P{Is_Blk=-_ARROWS}', "");
    Expect(0, 8704, '\P{^Is_Blk=-_ARROWS}', "");
    Error('\p{Block:	 Basic_LATIN:=}');
    Error('\P{Block:	 Basic_LATIN:=}');
    Expect(1, 127, '\p{Block=:\ABasic_Latin\z:}', "");;
    Expect(0, 128, '\p{Block=:\ABasic_Latin\z:}', "");;
    Expect(1, 127, '\p{Block=basiclatin}', "");
    Expect(0, 127, '\p{^Block=basiclatin}', "");
    Expect(0, 127, '\P{Block=basiclatin}', "");
    Expect(1, 127, '\P{^Block=basiclatin}', "");
    Expect(0, 128, '\p{Block=basiclatin}', "");
    Expect(1, 128, '\p{^Block=basiclatin}', "");
    Expect(1, 128, '\P{Block=basiclatin}', "");
    Expect(0, 128, '\P{^Block=basiclatin}', "");
    Expect(1, 127, '\p{Block=:\Abasiclatin\z:}', "");;
    Expect(0, 128, '\p{Block=:\Abasiclatin\z:}', "");;
    Expect(1, 127, '\p{Block:	_Basic_Latin}', "");
    Expect(0, 127, '\p{^Block:	_Basic_Latin}', "");
    Expect(0, 127, '\P{Block:	_Basic_Latin}', "");
    Expect(1, 127, '\P{^Block:	_Basic_Latin}', "");
    Expect(0, 128, '\p{Block:	_Basic_Latin}', "");
    Expect(1, 128, '\p{^Block:	_Basic_Latin}', "");
    Expect(1, 128, '\P{Block:	_Basic_Latin}', "");
    Expect(0, 128, '\P{^Block:	_Basic_Latin}', "");
    Error('\p{Blk=__ASCII:=}');
    Error('\P{Blk=__ASCII:=}');
    Expect(1, 127, '\p{Blk=:\AASCII\z:}', "");;
    Expect(0, 128, '\p{Blk=:\AASCII\z:}', "");;
    Expect(1, 127, '\p{Blk=ascii}', "");
    Expect(0, 127, '\p{^Blk=ascii}', "");
    Expect(0, 127, '\P{Blk=ascii}', "");
    Expect(1, 127, '\P{^Blk=ascii}', "");
    Expect(0, 128, '\p{Blk=ascii}', "");
    Expect(1, 128, '\p{^Blk=ascii}', "");
    Expect(1, 128, '\P{Blk=ascii}', "");
    Expect(0, 128, '\P{^Blk=ascii}', "");
    Expect(1, 127, '\p{Blk=:\Aascii\z:}', "");;
    Expect(0, 128, '\p{Blk=:\Aascii\z:}', "");;
    Expect(1, 127, '\p{Blk=_-ASCII}', "");
    Expect(0, 127, '\p{^Blk=_-ASCII}', "");
    Expect(0, 127, '\P{Blk=_-ASCII}', "");
    Expect(1, 127, '\P{^Blk=_-ASCII}', "");
    Expect(0, 128, '\p{Blk=_-ASCII}', "");
    Expect(1, 128, '\p{^Blk=_-ASCII}', "");
    Expect(1, 128, '\P{Blk=_-ASCII}', "");
    Expect(0, 128, '\P{^Blk=_-ASCII}', "");
    Error('\p{Is_Block= /a/Basic_LATIN}');
    Error('\P{Is_Block= /a/Basic_LATIN}');
    Expect(1, 127, '\p{Is_Block=basiclatin}', "");
    Expect(0, 127, '\p{^Is_Block=basiclatin}', "");
    Expect(0, 127, '\P{Is_Block=basiclatin}', "");
    Expect(1, 127, '\P{^Is_Block=basiclatin}', "");
    Expect(0, 128, '\p{Is_Block=basiclatin}', "");
    Expect(1, 128, '\p{^Is_Block=basiclatin}', "");
    Expect(1, 128, '\P{Is_Block=basiclatin}', "");
    Expect(0, 128, '\P{^Is_Block=basiclatin}', "");
    Expect(1, 127, '\p{Is_Block=  Basic_Latin}', "");
    Expect(0, 127, '\p{^Is_Block=  Basic_Latin}', "");
    Expect(0, 127, '\P{Is_Block=  Basic_Latin}', "");
    Expect(1, 127, '\P{^Is_Block=  Basic_Latin}', "");
    Expect(0, 128, '\p{Is_Block=  Basic_Latin}', "");
    Expect(1, 128, '\p{^Is_Block=  Basic_Latin}', "");
    Expect(1, 128, '\P{Is_Block=  Basic_Latin}', "");
    Expect(0, 128, '\P{^Is_Block=  Basic_Latin}', "");
    Error('\p{Is_Blk=-/a/ASCII}');
    Error('\P{Is_Blk=-/a/ASCII}');
    Expect(1, 127, '\p{Is_Blk:   ascii}', "");
    Expect(0, 127, '\p{^Is_Blk:   ascii}', "");
    Expect(0, 127, '\P{Is_Blk:   ascii}', "");
    Expect(1, 127, '\P{^Is_Blk:   ascii}', "");
    Expect(0, 128, '\p{Is_Blk:   ascii}', "");
    Expect(1, 128, '\p{^Is_Blk:   ascii}', "");
    Expect(1, 128, '\P{Is_Blk:   ascii}', "");
    Expect(0, 128, '\P{^Is_Blk:   ascii}', "");
    Expect(1, 127, '\p{Is_Blk= _ASCII}', "");
    Expect(0, 127, '\p{^Is_Blk= _ASCII}', "");
    Expect(0, 127, '\P{Is_Blk= _ASCII}', "");
    Expect(1, 127, '\P{^Is_Blk= _ASCII}', "");
    Expect(0, 128, '\p{Is_Blk= _ASCII}', "");
    Expect(1, 128, '\p{^Is_Blk= _ASCII}', "");
    Expect(1, 128, '\P{Is_Blk= _ASCII}', "");
    Expect(0, 128, '\P{^Is_Blk= _ASCII}', "");
    Error('\p{Block: /a/-	avestan}');
    Error('\P{Block: /a/-	avestan}');
    Expect(1, 68415, '\p{Block=:\AAvestan\z:}', "");;
    Expect(0, 68416, '\p{Block=:\AAvestan\z:}', "");;
    Expect(1, 68415, '\p{Block:avestan}', "");
    Expect(0, 68415, '\p{^Block:avestan}', "");
    Expect(0, 68415, '\P{Block:avestan}', "");
    Expect(1, 68415, '\P{^Block:avestan}', "");
    Expect(0, 68416, '\p{Block:avestan}', "");
    Expect(1, 68416, '\p{^Block:avestan}', "");
    Expect(1, 68416, '\P{Block:avestan}', "");
    Expect(0, 68416, '\P{^Block:avestan}', "");
    Expect(1, 68415, '\p{Block=:\Aavestan\z:}', "");;
    Expect(0, 68416, '\p{Block=:\Aavestan\z:}', "");;
    Expect(1, 68415, '\p{Block= Avestan}', "");
    Expect(0, 68415, '\p{^Block= Avestan}', "");
    Expect(0, 68415, '\P{Block= Avestan}', "");
    Expect(1, 68415, '\P{^Block= Avestan}', "");
    Expect(0, 68416, '\p{Block= Avestan}', "");
    Expect(1, 68416, '\p{^Block= Avestan}', "");
    Expect(1, 68416, '\P{Block= Avestan}', "");
    Expect(0, 68416, '\P{^Block= Avestan}', "");
    Error('\p{Blk=:=_ Avestan}');
    Error('\P{Blk=:=_ Avestan}');
    Expect(1, 68415, '\p{Blk=:\AAvestan\z:}', "");;
    Expect(0, 68416, '\p{Blk=:\AAvestan\z:}', "");;
    Expect(1, 68415, '\p{Blk=avestan}', "");
    Expect(0, 68415, '\p{^Blk=avestan}', "");
    Expect(0, 68415, '\P{Blk=avestan}', "");
    Expect(1, 68415, '\P{^Blk=avestan}', "");
    Expect(0, 68416, '\p{Blk=avestan}', "");
    Expect(1, 68416, '\p{^Blk=avestan}', "");
    Expect(1, 68416, '\P{Blk=avestan}', "");
    Expect(0, 68416, '\P{^Blk=avestan}', "");
    Expect(1, 68415, '\p{Blk=:\Aavestan\z:}', "");;
    Expect(0, 68416, '\p{Blk=:\Aavestan\z:}', "");;
    Expect(1, 68415, '\p{Blk:	Avestan}', "");
    Expect(0, 68415, '\p{^Blk:	Avestan}', "");
    Expect(0, 68415, '\P{Blk:	Avestan}', "");
    Expect(1, 68415, '\P{^Blk:	Avestan}', "");
    Expect(0, 68416, '\p{Blk:	Avestan}', "");
    Expect(1, 68416, '\p{^Blk:	Avestan}', "");
    Expect(1, 68416, '\P{Blk:	Avestan}', "");
    Expect(0, 68416, '\P{^Blk:	Avestan}', "");
    Error('\p{Is_Block=- Avestan:=}');
    Error('\P{Is_Block=- Avestan:=}');
    Expect(1, 68415, '\p{Is_Block=avestan}', "");
    Expect(0, 68415, '\p{^Is_Block=avestan}', "");
    Expect(0, 68415, '\P{Is_Block=avestan}', "");
    Expect(1, 68415, '\P{^Is_Block=avestan}', "");
    Expect(0, 68416, '\p{Is_Block=avestan}', "");
    Expect(1, 68416, '\p{^Is_Block=avestan}', "");
    Expect(1, 68416, '\P{Is_Block=avestan}', "");
    Expect(0, 68416, '\P{^Is_Block=avestan}', "");
    Expect(1, 68415, '\p{Is_Block:   -AVESTAN}', "");
    Expect(0, 68415, '\p{^Is_Block:   -AVESTAN}', "");
    Expect(0, 68415, '\P{Is_Block:   -AVESTAN}', "");
    Expect(1, 68415, '\P{^Is_Block:   -AVESTAN}', "");
    Expect(0, 68416, '\p{Is_Block:   -AVESTAN}', "");
    Expect(1, 68416, '\p{^Is_Block:   -AVESTAN}', "");
    Expect(1, 68416, '\P{Is_Block:   -AVESTAN}', "");
    Expect(0, 68416, '\P{^Is_Block:   -AVESTAN}', "");
    Error('\p{Is_Blk=_:=avestan}');
    Error('\P{Is_Blk=_:=avestan}');
    Expect(1, 68415, '\p{Is_Blk:   avestan}', "");
    Expect(0, 68415, '\p{^Is_Blk:   avestan}', "");
    Expect(0, 68415, '\P{Is_Blk:   avestan}', "");
    Expect(1, 68415, '\P{^Is_Blk:   avestan}', "");
    Expect(0, 68416, '\p{Is_Blk:   avestan}', "");
    Expect(1, 68416, '\p{^Is_Blk:   avestan}', "");
    Expect(1, 68416, '\P{Is_Blk:   avestan}', "");
    Expect(0, 68416, '\P{^Is_Blk:   avestan}', "");
    Expect(1, 68415, '\p{Is_Blk= AVESTAN}', "");
    Expect(0, 68415, '\p{^Is_Blk= AVESTAN}', "");
    Expect(0, 68415, '\P{Is_Blk= AVESTAN}', "");
    Expect(1, 68415, '\P{^Is_Blk= AVESTAN}', "");
    Expect(0, 68416, '\p{Is_Blk= AVESTAN}', "");
    Expect(1, 68416, '\p{^Is_Blk= AVESTAN}', "");
    Expect(1, 68416, '\P{Is_Blk= AVESTAN}', "");
    Expect(0, 68416, '\P{^Is_Blk= AVESTAN}', "");
    Error('\p{Block:   _/a/Balinese}');
    Error('\P{Block:   _/a/Balinese}');
    Expect(1, 7039, '\p{Block=:\ABalinese\z:}', "");;
    Expect(0, 7040, '\p{Block=:\ABalinese\z:}', "");;
    Expect(1, 7039, '\p{Block=balinese}', "");
    Expect(0, 7039, '\p{^Block=balinese}', "");
    Expect(0, 7039, '\P{Block=balinese}', "");
    Expect(1, 7039, '\P{^Block=balinese}', "");
    Expect(0, 7040, '\p{Block=balinese}', "");
    Expect(1, 7040, '\p{^Block=balinese}', "");
    Expect(1, 7040, '\P{Block=balinese}', "");
    Expect(0, 7040, '\P{^Block=balinese}', "");
    Expect(1, 7039, '\p{Block=:\Abalinese\z:}', "");;
    Expect(0, 7040, '\p{Block=:\Abalinese\z:}', "");;
    Expect(1, 7039, '\p{Block=_-Balinese}', "");
    Expect(0, 7039, '\p{^Block=_-Balinese}', "");
    Expect(0, 7039, '\P{Block=_-Balinese}', "");
    Expect(1, 7039, '\P{^Block=_-Balinese}', "");
    Expect(0, 7040, '\p{Block=_-Balinese}', "");
    Expect(1, 7040, '\p{^Block=_-Balinese}', "");
    Expect(1, 7040, '\P{Block=_-Balinese}', "");
    Expect(0, 7040, '\P{^Block=_-Balinese}', "");
    Error('\p{Blk= _Balinese:=}');
    Error('\P{Blk= _Balinese:=}');
    Expect(1, 7039, '\p{Blk=:\ABalinese\z:}', "");;
    Expect(0, 7040, '\p{Blk=:\ABalinese\z:}', "");;
    Expect(1, 7039, '\p{Blk=balinese}', "");
    Expect(0, 7039, '\p{^Blk=balinese}', "");
    Expect(0, 7039, '\P{Blk=balinese}', "");
    Expect(1, 7039, '\P{^Blk=balinese}', "");
    Expect(0, 7040, '\p{Blk=balinese}', "");
    Expect(1, 7040, '\p{^Blk=balinese}', "");
    Expect(1, 7040, '\P{Blk=balinese}', "");
    Expect(0, 7040, '\P{^Blk=balinese}', "");
    Expect(1, 7039, '\p{Blk=:\Abalinese\z:}', "");;
    Expect(0, 7040, '\p{Blk=:\Abalinese\z:}', "");;
    Expect(1, 7039, '\p{Blk=  Balinese}', "");
    Expect(0, 7039, '\p{^Blk=  Balinese}', "");
    Expect(0, 7039, '\P{Blk=  Balinese}', "");
    Expect(1, 7039, '\P{^Blk=  Balinese}', "");
    Expect(0, 7040, '\p{Blk=  Balinese}', "");
    Expect(1, 7040, '\p{^Blk=  Balinese}', "");
    Expect(1, 7040, '\P{Blk=  Balinese}', "");
    Expect(0, 7040, '\P{^Blk=  Balinese}', "");
    Error('\p{Is_Block=_:=BALINESE}');
    Error('\P{Is_Block=_:=BALINESE}');
    Expect(1, 7039, '\p{Is_Block=balinese}', "");
    Expect(0, 7039, '\p{^Is_Block=balinese}', "");
    Expect(0, 7039, '\P{Is_Block=balinese}', "");
    Expect(1, 7039, '\P{^Is_Block=balinese}', "");
    Expect(0, 7040, '\p{Is_Block=balinese}', "");
    Expect(1, 7040, '\p{^Is_Block=balinese}', "");
    Expect(1, 7040, '\P{Is_Block=balinese}', "");
    Expect(0, 7040, '\P{^Is_Block=balinese}', "");
    Expect(1, 7039, '\p{Is_Block=	-balinese}', "");
    Expect(0, 7039, '\p{^Is_Block=	-balinese}', "");
    Expect(0, 7039, '\P{Is_Block=	-balinese}', "");
    Expect(1, 7039, '\P{^Is_Block=	-balinese}', "");
    Expect(0, 7040, '\p{Is_Block=	-balinese}', "");
    Expect(1, 7040, '\p{^Is_Block=	-balinese}', "");
    Expect(1, 7040, '\P{Is_Block=	-balinese}', "");
    Expect(0, 7040, '\P{^Is_Block=	-balinese}', "");
    Error('\p{Is_Blk= Balinese/a/}');
    Error('\P{Is_Blk= Balinese/a/}');
    Expect(1, 7039, '\p{Is_Blk=balinese}', "");
    Expect(0, 7039, '\p{^Is_Blk=balinese}', "");
    Expect(0, 7039, '\P{Is_Blk=balinese}', "");
    Expect(1, 7039, '\P{^Is_Blk=balinese}', "");
    Expect(0, 7040, '\p{Is_Blk=balinese}', "");
    Expect(1, 7040, '\p{^Is_Blk=balinese}', "");
    Expect(1, 7040, '\P{Is_Blk=balinese}', "");
    Expect(0, 7040, '\P{^Is_Blk=balinese}', "");
    Expect(1, 7039, '\p{Is_Blk:	  balinese}', "");
    Expect(0, 7039, '\p{^Is_Blk:	  balinese}', "");
    Expect(0, 7039, '\P{Is_Blk:	  balinese}', "");
    Expect(1, 7039, '\P{^Is_Blk:	  balinese}', "");
    Expect(0, 7040, '\p{Is_Blk:	  balinese}', "");
    Expect(1, 7040, '\p{^Is_Blk:	  balinese}', "");
    Expect(1, 7040, '\P{Is_Blk:	  balinese}', "");
    Expect(0, 7040, '\P{^Is_Blk:	  balinese}', "");
    Error('\p{Block:_	BAMUM/a/}');
    Error('\P{Block:_	BAMUM/a/}');
    Expect(1, 42751, '\p{Block=:\ABamum\z:}', "");;
    Expect(0, 42752, '\p{Block=:\ABamum\z:}', "");;
    Expect(1, 42751, '\p{Block=bamum}', "");
    Expect(0, 42751, '\p{^Block=bamum}', "");
    Expect(0, 42751, '\P{Block=bamum}', "");
    Expect(1, 42751, '\P{^Block=bamum}', "");
    Expect(0, 42752, '\p{Block=bamum}', "");
    Expect(1, 42752, '\p{^Block=bamum}', "");
    Expect(1, 42752, '\P{Block=bamum}', "");
    Expect(0, 42752, '\P{^Block=bamum}', "");
    Expect(1, 42751, '\p{Block=:\Abamum\z:}', "");;
    Expect(0, 42752, '\p{Block=:\Abamum\z:}', "");;
    Expect(1, 42751, '\p{Block=	 Bamum}', "");
    Expect(0, 42751, '\p{^Block=	 Bamum}', "");
    Expect(0, 42751, '\P{Block=	 Bamum}', "");
    Expect(1, 42751, '\P{^Block=	 Bamum}', "");
    Expect(0, 42752, '\p{Block=	 Bamum}', "");
    Expect(1, 42752, '\p{^Block=	 Bamum}', "");
    Expect(1, 42752, '\P{Block=	 Bamum}', "");
    Expect(0, 42752, '\P{^Block=	 Bamum}', "");
    Error('\p{Blk=/a/- BAMUM}');
    Error('\P{Blk=/a/- BAMUM}');
    Expect(1, 42751, '\p{Blk=:\ABamum\z:}', "");;
    Expect(0, 42752, '\p{Blk=:\ABamum\z:}', "");;
    Expect(1, 42751, '\p{Blk=bamum}', "");
    Expect(0, 42751, '\p{^Blk=bamum}', "");
    Expect(0, 42751, '\P{Blk=bamum}', "");
    Expect(1, 42751, '\P{^Blk=bamum}', "");
    Expect(0, 42752, '\p{Blk=bamum}', "");
    Expect(1, 42752, '\p{^Blk=bamum}', "");
    Expect(1, 42752, '\P{Blk=bamum}', "");
    Expect(0, 42752, '\P{^Blk=bamum}', "");
    Expect(1, 42751, '\p{Blk=:\Abamum\z:}', "");;
    Expect(0, 42752, '\p{Blk=:\Abamum\z:}', "");;
    Expect(1, 42751, '\p{Blk=	Bamum}', "");
    Expect(0, 42751, '\p{^Blk=	Bamum}', "");
    Expect(0, 42751, '\P{Blk=	Bamum}', "");
    Expect(1, 42751, '\P{^Blk=	Bamum}', "");
    Expect(0, 42752, '\p{Blk=	Bamum}', "");
    Expect(1, 42752, '\p{^Blk=	Bamum}', "");
    Expect(1, 42752, '\P{Blk=	Bamum}', "");
    Expect(0, 42752, '\P{^Blk=	Bamum}', "");
    Error('\p{Is_Block=	bamum/a/}');
    Error('\P{Is_Block=	bamum/a/}');
    Expect(1, 42751, '\p{Is_Block: bamum}', "");
    Expect(0, 42751, '\p{^Is_Block: bamum}', "");
    Expect(0, 42751, '\P{Is_Block: bamum}', "");
    Expect(1, 42751, '\P{^Is_Block: bamum}', "");
    Expect(0, 42752, '\p{Is_Block: bamum}', "");
    Expect(1, 42752, '\p{^Is_Block: bamum}', "");
    Expect(1, 42752, '\P{Is_Block: bamum}', "");
    Expect(0, 42752, '\P{^Is_Block: bamum}', "");
    Expect(1, 42751, '\p{Is_Block=-Bamum}', "");
    Expect(0, 42751, '\p{^Is_Block=-Bamum}', "");
    Expect(0, 42751, '\P{Is_Block=-Bamum}', "");
    Expect(1, 42751, '\P{^Is_Block=-Bamum}', "");
    Expect(0, 42752, '\p{Is_Block=-Bamum}', "");
    Expect(1, 42752, '\p{^Is_Block=-Bamum}', "");
    Expect(1, 42752, '\P{Is_Block=-Bamum}', "");
    Expect(0, 42752, '\P{^Is_Block=-Bamum}', "");
    Error('\p{Is_Blk:   :=  Bamum}');
    Error('\P{Is_Blk:   :=  Bamum}');
    Expect(1, 42751, '\p{Is_Blk=bamum}', "");
    Expect(0, 42751, '\p{^Is_Blk=bamum}', "");
    Expect(0, 42751, '\P{Is_Blk=bamum}', "");
    Expect(1, 42751, '\P{^Is_Blk=bamum}', "");
    Expect(0, 42752, '\p{Is_Blk=bamum}', "");
    Expect(1, 42752, '\p{^Is_Blk=bamum}', "");
    Expect(1, 42752, '\P{Is_Blk=bamum}', "");
    Expect(0, 42752, '\P{^Is_Blk=bamum}', "");
    Expect(1, 42751, '\p{Is_Blk=	 BAMUM}', "");
    Expect(0, 42751, '\p{^Is_Blk=	 BAMUM}', "");
    Expect(0, 42751, '\P{Is_Blk=	 BAMUM}', "");
    Expect(1, 42751, '\P{^Is_Blk=	 BAMUM}', "");
    Expect(0, 42752, '\p{Is_Blk=	 BAMUM}', "");
    Expect(1, 42752, '\p{^Is_Blk=	 BAMUM}', "");
    Expect(1, 42752, '\P{Is_Blk=	 BAMUM}', "");
    Expect(0, 42752, '\P{^Is_Blk=	 BAMUM}', "");
    Error('\p{Block=/a/		bamum_supplement}');
    Error('\P{Block=/a/		bamum_supplement}');
    Expect(1, 92735, '\p{Block=:\ABamum_Supplement\z:}', "");;
    Expect(0, 92736, '\p{Block=:\ABamum_Supplement\z:}', "");;
    Expect(1, 92735, '\p{Block=bamumsupplement}', "");
    Expect(0, 92735, '\p{^Block=bamumsupplement}', "");
    Expect(0, 92735, '\P{Block=bamumsupplement}', "");
    Expect(1, 92735, '\P{^Block=bamumsupplement}', "");
    Expect(0, 92736, '\p{Block=bamumsupplement}', "");
    Expect(1, 92736, '\p{^Block=bamumsupplement}', "");
    Expect(1, 92736, '\P{Block=bamumsupplement}', "");
    Expect(0, 92736, '\P{^Block=bamumsupplement}', "");
    Expect(1, 92735, '\p{Block=:\Abamumsupplement\z:}', "");;
    Expect(0, 92736, '\p{Block=:\Abamumsupplement\z:}', "");;
    Expect(1, 92735, '\p{Block=_BAMUM_Supplement}', "");
    Expect(0, 92735, '\p{^Block=_BAMUM_Supplement}', "");
    Expect(0, 92735, '\P{Block=_BAMUM_Supplement}', "");
    Expect(1, 92735, '\P{^Block=_BAMUM_Supplement}', "");
    Expect(0, 92736, '\p{Block=_BAMUM_Supplement}', "");
    Expect(1, 92736, '\p{^Block=_BAMUM_Supplement}', "");
    Expect(1, 92736, '\P{Block=_BAMUM_Supplement}', "");
    Expect(0, 92736, '\P{^Block=_BAMUM_Supplement}', "");
    Error('\p{Blk= /a/bamum_Sup}');
    Error('\P{Blk= /a/bamum_Sup}');
    Expect(1, 92735, '\p{Blk=:\ABamum_Sup\z:}', "");;
    Expect(0, 92736, '\p{Blk=:\ABamum_Sup\z:}', "");;
    Expect(1, 92735, '\p{Blk:bamumsup}', "");
    Expect(0, 92735, '\p{^Blk:bamumsup}', "");
    Expect(0, 92735, '\P{Blk:bamumsup}', "");
    Expect(1, 92735, '\P{^Blk:bamumsup}', "");
    Expect(0, 92736, '\p{Blk:bamumsup}', "");
    Expect(1, 92736, '\p{^Blk:bamumsup}', "");
    Expect(1, 92736, '\P{Blk:bamumsup}', "");
    Expect(0, 92736, '\P{^Blk:bamumsup}', "");
    Expect(1, 92735, '\p{Blk=:\Abamumsup\z:}', "");;
    Expect(0, 92736, '\p{Blk=:\Abamumsup\z:}', "");;
    Expect(1, 92735, '\p{Blk= bamum_SUP}', "");
    Expect(0, 92735, '\p{^Blk= bamum_SUP}', "");
    Expect(0, 92735, '\P{Blk= bamum_SUP}', "");
    Expect(1, 92735, '\P{^Blk= bamum_SUP}', "");
    Expect(0, 92736, '\p{Blk= bamum_SUP}', "");
    Expect(1, 92736, '\p{^Blk= bamum_SUP}', "");
    Expect(1, 92736, '\P{Blk= bamum_SUP}', "");
    Expect(0, 92736, '\P{^Blk= bamum_SUP}', "");
    Error('\p{Is_Block=_	bamum_supplement/a/}');
    Error('\P{Is_Block=_	bamum_supplement/a/}');
    Expect(1, 92735, '\p{Is_Block=bamumsupplement}', "");
    Expect(0, 92735, '\p{^Is_Block=bamumsupplement}', "");
    Expect(0, 92735, '\P{Is_Block=bamumsupplement}', "");
    Expect(1, 92735, '\P{^Is_Block=bamumsupplement}', "");
    Expect(0, 92736, '\p{Is_Block=bamumsupplement}', "");
    Expect(1, 92736, '\p{^Is_Block=bamumsupplement}', "");
    Expect(1, 92736, '\P{Is_Block=bamumsupplement}', "");
    Expect(0, 92736, '\P{^Is_Block=bamumsupplement}', "");
    Expect(1, 92735, '\p{Is_Block=-Bamum_supplement}', "");
    Expect(0, 92735, '\p{^Is_Block=-Bamum_supplement}', "");
    Expect(0, 92735, '\P{Is_Block=-Bamum_supplement}', "");
    Expect(1, 92735, '\P{^Is_Block=-Bamum_supplement}', "");
    Expect(0, 92736, '\p{Is_Block=-Bamum_supplement}', "");
    Expect(1, 92736, '\p{^Is_Block=-Bamum_supplement}', "");
    Expect(1, 92736, '\P{Is_Block=-Bamum_supplement}', "");
    Expect(0, 92736, '\P{^Is_Block=-Bamum_supplement}', "");
    Error('\p{Is_Blk=-BAMUM_Sup:=}');
    Error('\P{Is_Blk=-BAMUM_Sup:=}');
    Expect(1, 92735, '\p{Is_Blk=bamumsup}', "");
    Expect(0, 92735, '\p{^Is_Blk=bamumsup}', "");
    Expect(0, 92735, '\P{Is_Blk=bamumsup}', "");
    Expect(1, 92735, '\P{^Is_Blk=bamumsup}', "");
    Expect(0, 92736, '\p{Is_Blk=bamumsup}', "");
    Expect(1, 92736, '\p{^Is_Blk=bamumsup}', "");
    Expect(1, 92736, '\P{Is_Blk=bamumsup}', "");
    Expect(0, 92736, '\P{^Is_Blk=bamumsup}', "");
    Expect(1, 92735, '\p{Is_Blk= -Bamum_sup}', "");
    Expect(0, 92735, '\p{^Is_Blk= -Bamum_sup}', "");
    Expect(0, 92735, '\P{Is_Blk= -Bamum_sup}', "");
    Expect(1, 92735, '\P{^Is_Blk= -Bamum_sup}', "");
    Expect(0, 92736, '\p{Is_Blk= -Bamum_sup}', "");
    Expect(1, 92736, '\p{^Is_Blk= -Bamum_sup}', "");
    Expect(1, 92736, '\P{Is_Blk= -Bamum_sup}', "");
    Expect(0, 92736, '\P{^Is_Blk= -Bamum_sup}', "");
    Error('\p{Block: 	Bassa_vah/a/}');
    Error('\P{Block: 	Bassa_vah/a/}');
    Expect(1, 92927, '\p{Block=:\ABassa_Vah\z:}', "");;
    Expect(0, 92928, '\p{Block=:\ABassa_Vah\z:}', "");;
    Expect(1, 92927, '\p{Block=bassavah}', "");
    Expect(0, 92927, '\p{^Block=bassavah}', "");
    Expect(0, 92927, '\P{Block=bassavah}', "");
    Expect(1, 92927, '\P{^Block=bassavah}', "");
    Expect(0, 92928, '\p{Block=bassavah}', "");
    Expect(1, 92928, '\p{^Block=bassavah}', "");
    Expect(1, 92928, '\P{Block=bassavah}', "");
    Expect(0, 92928, '\P{^Block=bassavah}', "");
    Expect(1, 92927, '\p{Block=:\Abassavah\z:}', "");;
    Expect(0, 92928, '\p{Block=:\Abassavah\z:}', "");;
    Expect(1, 92927, '\p{Block:	_ Bassa_VAH}', "");
    Expect(0, 92927, '\p{^Block:	_ Bassa_VAH}', "");
    Expect(0, 92927, '\P{Block:	_ Bassa_VAH}', "");
    Expect(1, 92927, '\P{^Block:	_ Bassa_VAH}', "");
    Expect(0, 92928, '\p{Block:	_ Bassa_VAH}', "");
    Expect(1, 92928, '\p{^Block:	_ Bassa_VAH}', "");
    Expect(1, 92928, '\P{Block:	_ Bassa_VAH}', "");
    Expect(0, 92928, '\P{^Block:	_ Bassa_VAH}', "");
    Error('\p{Blk=_BASSA_Vah:=}');
    Error('\P{Blk=_BASSA_Vah:=}');
    Expect(1, 92927, '\p{Blk=:\ABassa_Vah\z:}', "");;
    Expect(0, 92928, '\p{Blk=:\ABassa_Vah\z:}', "");;
    Expect(1, 92927, '\p{Blk=bassavah}', "");
    Expect(0, 92927, '\p{^Blk=bassavah}', "");
    Expect(0, 92927, '\P{Blk=bassavah}', "");
    Expect(1, 92927, '\P{^Blk=bassavah}', "");
    Expect(0, 92928, '\p{Blk=bassavah}', "");
    Expect(1, 92928, '\p{^Blk=bassavah}', "");
    Expect(1, 92928, '\P{Blk=bassavah}', "");
    Expect(0, 92928, '\P{^Blk=bassavah}', "");
    Expect(1, 92927, '\p{Blk=:\Abassavah\z:}', "");;
    Expect(0, 92928, '\p{Blk=:\Abassavah\z:}', "");;
    Expect(1, 92927, '\p{Blk=  Bassa_Vah}', "");
    Expect(0, 92927, '\p{^Blk=  Bassa_Vah}', "");
    Expect(0, 92927, '\P{Blk=  Bassa_Vah}', "");
    Expect(1, 92927, '\P{^Blk=  Bassa_Vah}', "");
    Expect(0, 92928, '\p{Blk=  Bassa_Vah}', "");
    Expect(1, 92928, '\p{^Blk=  Bassa_Vah}', "");
    Expect(1, 92928, '\P{Blk=  Bassa_Vah}', "");
    Expect(0, 92928, '\P{^Blk=  Bassa_Vah}', "");
    Error('\p{Is_Block=-BASSA_VAH/a/}');
    Error('\P{Is_Block=-BASSA_VAH/a/}');
    Expect(1, 92927, '\p{Is_Block=bassavah}', "");
    Expect(0, 92927, '\p{^Is_Block=bassavah}', "");
    Expect(0, 92927, '\P{Is_Block=bassavah}', "");
    Expect(1, 92927, '\P{^Is_Block=bassavah}', "");
    Expect(0, 92928, '\p{Is_Block=bassavah}', "");
    Expect(1, 92928, '\p{^Is_Block=bassavah}', "");
    Expect(1, 92928, '\P{Is_Block=bassavah}', "");
    Expect(0, 92928, '\P{^Is_Block=bassavah}', "");
    Expect(1, 92927, '\p{Is_Block=	 Bassa_Vah}', "");
    Expect(0, 92927, '\p{^Is_Block=	 Bassa_Vah}', "");
    Expect(0, 92927, '\P{Is_Block=	 Bassa_Vah}', "");
    Expect(1, 92927, '\P{^Is_Block=	 Bassa_Vah}', "");
    Expect(0, 92928, '\p{Is_Block=	 Bassa_Vah}', "");
    Expect(1, 92928, '\p{^Is_Block=	 Bassa_Vah}', "");
    Expect(1, 92928, '\P{Is_Block=	 Bassa_Vah}', "");
    Expect(0, 92928, '\P{^Is_Block=	 Bassa_Vah}', "");
    Error('\p{Is_Blk=/a/		Bassa_Vah}');
    Error('\P{Is_Blk=/a/		Bassa_Vah}');
    Expect(1, 92927, '\p{Is_Blk=bassavah}', "");
    Expect(0, 92927, '\p{^Is_Blk=bassavah}', "");
    Expect(0, 92927, '\P{Is_Blk=bassavah}', "");
    Expect(1, 92927, '\P{^Is_Blk=bassavah}', "");
    Expect(0, 92928, '\p{Is_Blk=bassavah}', "");
    Expect(1, 92928, '\p{^Is_Blk=bassavah}', "");
    Expect(1, 92928, '\P{Is_Blk=bassavah}', "");
    Expect(0, 92928, '\P{^Is_Blk=bassavah}', "");
    Expect(1, 92927, '\p{Is_Blk=_Bassa_Vah}', "");
    Expect(0, 92927, '\p{^Is_Blk=_Bassa_Vah}', "");
    Expect(0, 92927, '\P{Is_Blk=_Bassa_Vah}', "");
    Expect(1, 92927, '\P{^Is_Blk=_Bassa_Vah}', "");
    Expect(0, 92928, '\p{Is_Blk=_Bassa_Vah}', "");
    Expect(1, 92928, '\p{^Is_Blk=_Bassa_Vah}', "");
    Expect(1, 92928, '\P{Is_Blk=_Bassa_Vah}', "");
    Expect(0, 92928, '\P{^Is_Blk=_Bassa_Vah}', "");
    Error('\p{Block=/a/		BATAK}');
    Error('\P{Block=/a/		BATAK}');
    Expect(1, 7167, '\p{Block=:\ABatak\z:}', "");;
    Expect(0, 7168, '\p{Block=:\ABatak\z:}', "");;
    Expect(1, 7167, '\p{Block=batak}', "");
    Expect(0, 7167, '\p{^Block=batak}', "");
    Expect(0, 7167, '\P{Block=batak}', "");
    Expect(1, 7167, '\P{^Block=batak}', "");
    Expect(0, 7168, '\p{Block=batak}', "");
    Expect(1, 7168, '\p{^Block=batak}', "");
    Expect(1, 7168, '\P{Block=batak}', "");
    Expect(0, 7168, '\P{^Block=batak}', "");
    Expect(1, 7167, '\p{Block=:\Abatak\z:}', "");;
    Expect(0, 7168, '\p{Block=:\Abatak\z:}', "");;
    Expect(1, 7167, '\p{Block:   		BATAK}', "");
    Expect(0, 7167, '\p{^Block:   		BATAK}', "");
    Expect(0, 7167, '\P{Block:   		BATAK}', "");
    Expect(1, 7167, '\P{^Block:   		BATAK}', "");
    Expect(0, 7168, '\p{Block:   		BATAK}', "");
    Expect(1, 7168, '\p{^Block:   		BATAK}', "");
    Expect(1, 7168, '\P{Block:   		BATAK}', "");
    Expect(0, 7168, '\P{^Block:   		BATAK}', "");
    Error('\p{Blk=	Batak:=}');
    Error('\P{Blk=	Batak:=}');
    Expect(1, 7167, '\p{Blk=:\ABatak\z:}', "");;
    Expect(0, 7168, '\p{Blk=:\ABatak\z:}', "");;
    Expect(1, 7167, '\p{Blk=batak}', "");
    Expect(0, 7167, '\p{^Blk=batak}', "");
    Expect(0, 7167, '\P{Blk=batak}', "");
    Expect(1, 7167, '\P{^Blk=batak}', "");
    Expect(0, 7168, '\p{Blk=batak}', "");
    Expect(1, 7168, '\p{^Blk=batak}', "");
    Expect(1, 7168, '\P{Blk=batak}', "");
    Expect(0, 7168, '\P{^Blk=batak}', "");
    Expect(1, 7167, '\p{Blk=:\Abatak\z:}', "");;
    Expect(0, 7168, '\p{Blk=:\Abatak\z:}', "");;
    Expect(1, 7167, '\p{Blk:   -Batak}', "");
    Expect(0, 7167, '\p{^Blk:   -Batak}', "");
    Expect(0, 7167, '\P{Blk:   -Batak}', "");
    Expect(1, 7167, '\P{^Blk:   -Batak}', "");
    Expect(0, 7168, '\p{Blk:   -Batak}', "");
    Expect(1, 7168, '\p{^Blk:   -Batak}', "");
    Expect(1, 7168, '\P{Blk:   -Batak}', "");
    Expect(0, 7168, '\P{^Blk:   -Batak}', "");
    Error('\p{Is_Block:	-_batak:=}');
    Error('\P{Is_Block:	-_batak:=}');
    Expect(1, 7167, '\p{Is_Block=batak}', "");
    Expect(0, 7167, '\p{^Is_Block=batak}', "");
    Expect(0, 7167, '\P{Is_Block=batak}', "");
    Expect(1, 7167, '\P{^Is_Block=batak}', "");
    Expect(0, 7168, '\p{Is_Block=batak}', "");
    Expect(1, 7168, '\p{^Is_Block=batak}', "");
    Expect(1, 7168, '\P{Is_Block=batak}', "");
    Expect(0, 7168, '\P{^Is_Block=batak}', "");
    Expect(1, 7167, '\p{Is_Block=_Batak}', "");
    Expect(0, 7167, '\p{^Is_Block=_Batak}', "");
    Expect(0, 7167, '\P{Is_Block=_Batak}', "");
    Expect(1, 7167, '\P{^Is_Block=_Batak}', "");
    Expect(0, 7168, '\p{Is_Block=_Batak}', "");
    Expect(1, 7168, '\p{^Is_Block=_Batak}', "");
    Expect(1, 7168, '\P{Is_Block=_Batak}', "");
    Expect(0, 7168, '\P{^Is_Block=_Batak}', "");
    Error('\p{Is_Blk:/a/batak}');
    Error('\P{Is_Blk:/a/batak}');
    Expect(1, 7167, '\p{Is_Blk=batak}', "");
    Expect(0, 7167, '\p{^Is_Blk=batak}', "");
    Expect(0, 7167, '\P{Is_Blk=batak}', "");
    Expect(1, 7167, '\P{^Is_Blk=batak}', "");
    Expect(0, 7168, '\p{Is_Blk=batak}', "");
    Expect(1, 7168, '\p{^Is_Blk=batak}', "");
    Expect(1, 7168, '\P{Is_Blk=batak}', "");
    Expect(0, 7168, '\P{^Is_Blk=batak}', "");
    Expect(1, 7167, '\p{Is_Blk=	Batak}', "");
    Expect(0, 7167, '\p{^Is_Blk=	Batak}', "");
    Expect(0, 7167, '\P{Is_Blk=	Batak}', "");
    Expect(1, 7167, '\P{^Is_Blk=	Batak}', "");
    Expect(0, 7168, '\p{Is_Blk=	Batak}', "");
    Expect(1, 7168, '\p{^Is_Blk=	Batak}', "");
    Expect(1, 7168, '\P{Is_Blk=	Batak}', "");
    Expect(0, 7168, '\P{^Is_Blk=	Batak}', "");
    Error('\p{Block:-/a/Bengali}');
    Error('\P{Block:-/a/Bengali}');
    Expect(1, 2559, '\p{Block=:\ABengali\z:}', "");;
    Expect(0, 2560, '\p{Block=:\ABengali\z:}', "");;
    Expect(1, 2559, '\p{Block:   bengali}', "");
    Expect(0, 2559, '\p{^Block:   bengali}', "");
    Expect(0, 2559, '\P{Block:   bengali}', "");
    Expect(1, 2559, '\P{^Block:   bengali}', "");
    Expect(0, 2560, '\p{Block:   bengali}', "");
    Expect(1, 2560, '\p{^Block:   bengali}', "");
    Expect(1, 2560, '\P{Block:   bengali}', "");
    Expect(0, 2560, '\P{^Block:   bengali}', "");
    Expect(1, 2559, '\p{Block=:\Abengali\z:}', "");;
    Expect(0, 2560, '\p{Block=:\Abengali\z:}', "");;
    Expect(1, 2559, '\p{Block=__Bengali}', "");
    Expect(0, 2559, '\p{^Block=__Bengali}', "");
    Expect(0, 2559, '\P{Block=__Bengali}', "");
    Expect(1, 2559, '\P{^Block=__Bengali}', "");
    Expect(0, 2560, '\p{Block=__Bengali}', "");
    Expect(1, 2560, '\p{^Block=__Bengali}', "");
    Expect(1, 2560, '\P{Block=__Bengali}', "");
    Expect(0, 2560, '\P{^Block=__Bengali}', "");
    Error('\p{Blk=	:=bengali}');
    Error('\P{Blk=	:=bengali}');
    Expect(1, 2559, '\p{Blk=:\ABengali\z:}', "");;
    Expect(0, 2560, '\p{Blk=:\ABengali\z:}', "");;
    Expect(1, 2559, '\p{Blk=bengali}', "");
    Expect(0, 2559, '\p{^Blk=bengali}', "");
    Expect(0, 2559, '\P{Blk=bengali}', "");
    Expect(1, 2559, '\P{^Blk=bengali}', "");
    Expect(0, 2560, '\p{Blk=bengali}', "");
    Expect(1, 2560, '\p{^Blk=bengali}', "");
    Expect(1, 2560, '\P{Blk=bengali}', "");
    Expect(0, 2560, '\P{^Blk=bengali}', "");
    Expect(1, 2559, '\p{Blk=:\Abengali\z:}', "");;
    Expect(0, 2560, '\p{Blk=:\Abengali\z:}', "");;
    Expect(1, 2559, '\p{Blk=_-bengali}', "");
    Expect(0, 2559, '\p{^Blk=_-bengali}', "");
    Expect(0, 2559, '\P{Blk=_-bengali}', "");
    Expect(1, 2559, '\P{^Blk=_-bengali}', "");
    Expect(0, 2560, '\p{Blk=_-bengali}', "");
    Expect(1, 2560, '\p{^Blk=_-bengali}', "");
    Expect(1, 2560, '\P{Blk=_-bengali}', "");
    Expect(0, 2560, '\P{^Blk=_-bengali}', "");
    Error('\p{Is_Block=:= -bengali}');
    Error('\P{Is_Block=:= -bengali}');
    Expect(1, 2559, '\p{Is_Block=bengali}', "");
    Expect(0, 2559, '\p{^Is_Block=bengali}', "");
    Expect(0, 2559, '\P{Is_Block=bengali}', "");
    Expect(1, 2559, '\P{^Is_Block=bengali}', "");
    Expect(0, 2560, '\p{Is_Block=bengali}', "");
    Expect(1, 2560, '\p{^Is_Block=bengali}', "");
    Expect(1, 2560, '\P{Is_Block=bengali}', "");
    Expect(0, 2560, '\P{^Is_Block=bengali}', "");
    Expect(1, 2559, '\p{Is_Block:   -bengali}', "");
    Expect(0, 2559, '\p{^Is_Block:   -bengali}', "");
    Expect(0, 2559, '\P{Is_Block:   -bengali}', "");
    Expect(1, 2559, '\P{^Is_Block:   -bengali}', "");
    Expect(0, 2560, '\p{Is_Block:   -bengali}', "");
    Expect(1, 2560, '\p{^Is_Block:   -bengali}', "");
    Expect(1, 2560, '\P{Is_Block:   -bengali}', "");
    Expect(0, 2560, '\P{^Is_Block:   -bengali}', "");
    Error('\p{Is_Blk=:=- Bengali}');
    Error('\P{Is_Blk=:=- Bengali}');
    Expect(1, 2559, '\p{Is_Blk:	bengali}', "");
    Expect(0, 2559, '\p{^Is_Blk:	bengali}', "");
    Expect(0, 2559, '\P{Is_Blk:	bengali}', "");
    Expect(1, 2559, '\P{^Is_Blk:	bengali}', "");
    Expect(0, 2560, '\p{Is_Blk:	bengali}', "");
    Expect(1, 2560, '\p{^Is_Blk:	bengali}', "");
    Expect(1, 2560, '\P{Is_Blk:	bengali}', "");
    Expect(0, 2560, '\P{^Is_Blk:	bengali}', "");
    Expect(1, 2559, '\p{Is_Blk=	Bengali}', "");
    Expect(0, 2559, '\p{^Is_Blk=	Bengali}', "");
    Expect(0, 2559, '\P{Is_Blk=	Bengali}', "");
    Expect(1, 2559, '\P{^Is_Blk=	Bengali}', "");
    Expect(0, 2560, '\p{Is_Blk=	Bengali}', "");
    Expect(1, 2560, '\p{^Is_Blk=	Bengali}', "");
    Expect(1, 2560, '\P{Is_Blk=	Bengali}', "");
    Expect(0, 2560, '\P{^Is_Blk=	Bengali}', "");
    Error('\p{Block=/a/ BHAIKSUKI}');
    Error('\P{Block=/a/ BHAIKSUKI}');
    Expect(1, 72815, '\p{Block=:\ABhaiksuki\z:}', "");;
    Expect(0, 72816, '\p{Block=:\ABhaiksuki\z:}', "");;
    Expect(1, 72815, '\p{Block=bhaiksuki}', "");
    Expect(0, 72815, '\p{^Block=bhaiksuki}', "");
    Expect(0, 72815, '\P{Block=bhaiksuki}', "");
    Expect(1, 72815, '\P{^Block=bhaiksuki}', "");
    Expect(0, 72816, '\p{Block=bhaiksuki}', "");
    Expect(1, 72816, '\p{^Block=bhaiksuki}', "");
    Expect(1, 72816, '\P{Block=bhaiksuki}', "");
    Expect(0, 72816, '\P{^Block=bhaiksuki}', "");
    Expect(1, 72815, '\p{Block=:\Abhaiksuki\z:}', "");;
    Expect(0, 72816, '\p{Block=:\Abhaiksuki\z:}', "");;
    Expect(1, 72815, '\p{Block:			Bhaiksuki}', "");
    Expect(0, 72815, '\p{^Block:			Bhaiksuki}', "");
    Expect(0, 72815, '\P{Block:			Bhaiksuki}', "");
    Expect(1, 72815, '\P{^Block:			Bhaiksuki}', "");
    Expect(0, 72816, '\p{Block:			Bhaiksuki}', "");
    Expect(1, 72816, '\p{^Block:			Bhaiksuki}', "");
    Expect(1, 72816, '\P{Block:			Bhaiksuki}', "");
    Expect(0, 72816, '\P{^Block:			Bhaiksuki}', "");
    Error('\p{Blk=/a/	_BHAIKSUKI}');
    Error('\P{Blk=/a/	_BHAIKSUKI}');
    Expect(1, 72815, '\p{Blk=:\ABhaiksuki\z:}', "");;
    Expect(0, 72816, '\p{Blk=:\ABhaiksuki\z:}', "");;
    Expect(1, 72815, '\p{Blk=bhaiksuki}', "");
    Expect(0, 72815, '\p{^Blk=bhaiksuki}', "");
    Expect(0, 72815, '\P{Blk=bhaiksuki}', "");
    Expect(1, 72815, '\P{^Blk=bhaiksuki}', "");
    Expect(0, 72816, '\p{Blk=bhaiksuki}', "");
    Expect(1, 72816, '\p{^Blk=bhaiksuki}', "");
    Expect(1, 72816, '\P{Blk=bhaiksuki}', "");
    Expect(0, 72816, '\P{^Blk=bhaiksuki}', "");
    Expect(1, 72815, '\p{Blk=:\Abhaiksuki\z:}', "");;
    Expect(0, 72816, '\p{Blk=:\Abhaiksuki\z:}', "");;
    Expect(1, 72815, '\p{Blk=--Bhaiksuki}', "");
    Expect(0, 72815, '\p{^Blk=--Bhaiksuki}', "");
    Expect(0, 72815, '\P{Blk=--Bhaiksuki}', "");
    Expect(1, 72815, '\P{^Blk=--Bhaiksuki}', "");
    Expect(0, 72816, '\p{Blk=--Bhaiksuki}', "");
    Expect(1, 72816, '\p{^Blk=--Bhaiksuki}', "");
    Expect(1, 72816, '\P{Blk=--Bhaiksuki}', "");
    Expect(0, 72816, '\P{^Blk=--Bhaiksuki}', "");
    Error('\p{Is_Block=:=Bhaiksuki}');
    Error('\P{Is_Block=:=Bhaiksuki}');
    Expect(1, 72815, '\p{Is_Block=bhaiksuki}', "");
    Expect(0, 72815, '\p{^Is_Block=bhaiksuki}', "");
    Expect(0, 72815, '\P{Is_Block=bhaiksuki}', "");
    Expect(1, 72815, '\P{^Is_Block=bhaiksuki}', "");
    Expect(0, 72816, '\p{Is_Block=bhaiksuki}', "");
    Expect(1, 72816, '\p{^Is_Block=bhaiksuki}', "");
    Expect(1, 72816, '\P{Is_Block=bhaiksuki}', "");
    Expect(0, 72816, '\P{^Is_Block=bhaiksuki}', "");
    Expect(1, 72815, '\p{Is_Block=_	Bhaiksuki}', "");
    Expect(0, 72815, '\p{^Is_Block=_	Bhaiksuki}', "");
    Expect(0, 72815, '\P{Is_Block=_	Bhaiksuki}', "");
    Expect(1, 72815, '\P{^Is_Block=_	Bhaiksuki}', "");
    Expect(0, 72816, '\p{Is_Block=_	Bhaiksuki}', "");
    Expect(1, 72816, '\p{^Is_Block=_	Bhaiksuki}', "");
    Expect(1, 72816, '\P{Is_Block=_	Bhaiksuki}', "");
    Expect(0, 72816, '\P{^Is_Block=_	Bhaiksuki}', "");
    Error('\p{Is_Blk:/a/  Bhaiksuki}');
    Error('\P{Is_Blk:/a/  Bhaiksuki}');
    Expect(1, 72815, '\p{Is_Blk=bhaiksuki}', "");
    Expect(0, 72815, '\p{^Is_Blk=bhaiksuki}', "");
    Expect(0, 72815, '\P{Is_Blk=bhaiksuki}', "");
    Expect(1, 72815, '\P{^Is_Blk=bhaiksuki}', "");
    Expect(0, 72816, '\p{Is_Blk=bhaiksuki}', "");
    Expect(1, 72816, '\p{^Is_Blk=bhaiksuki}', "");
    Expect(1, 72816, '\P{Is_Blk=bhaiksuki}', "");
    Expect(0, 72816, '\P{^Is_Blk=bhaiksuki}', "");
    Expect(1, 72815, '\p{Is_Blk=	-Bhaiksuki}', "");
    Expect(0, 72815, '\p{^Is_Blk=	-Bhaiksuki}', "");
    Expect(0, 72815, '\P{Is_Blk=	-Bhaiksuki}', "");
    Expect(1, 72815, '\P{^Is_Blk=	-Bhaiksuki}', "");
    Expect(0, 72816, '\p{Is_Blk=	-Bhaiksuki}', "");
    Expect(1, 72816, '\p{^Is_Blk=	-Bhaiksuki}', "");
    Expect(1, 72816, '\P{Is_Blk=	-Bhaiksuki}', "");
    Expect(0, 72816, '\P{^Is_Blk=	-Bhaiksuki}', "");
    Error('\p{Block=:=_	Block_Elements}');
    Error('\P{Block=:=_	Block_Elements}');
    Expect(1, 9631, '\p{Block=:\ABlock_Elements\z:}', "");;
    Expect(0, 9632, '\p{Block=:\ABlock_Elements\z:}', "");;
    Expect(1, 9631, '\p{Block:blockelements}', "");
    Expect(0, 9631, '\p{^Block:blockelements}', "");
    Expect(0, 9631, '\P{Block:blockelements}', "");
    Expect(1, 9631, '\P{^Block:blockelements}', "");
    Expect(0, 9632, '\p{Block:blockelements}', "");
    Expect(1, 9632, '\p{^Block:blockelements}', "");
    Expect(1, 9632, '\P{Block:blockelements}', "");
    Expect(0, 9632, '\P{^Block:blockelements}', "");
    Expect(1, 9631, '\p{Block=:\Ablockelements\z:}', "");;
    Expect(0, 9632, '\p{Block=:\Ablockelements\z:}', "");;
    Expect(1, 9631, '\p{Block:  BLOCK_elements}', "");
    Expect(0, 9631, '\p{^Block:  BLOCK_elements}', "");
    Expect(0, 9631, '\P{Block:  BLOCK_elements}', "");
    Expect(1, 9631, '\P{^Block:  BLOCK_elements}', "");
    Expect(0, 9632, '\p{Block:  BLOCK_elements}', "");
    Expect(1, 9632, '\p{^Block:  BLOCK_elements}', "");
    Expect(1, 9632, '\P{Block:  BLOCK_elements}', "");
    Expect(0, 9632, '\P{^Block:  BLOCK_elements}', "");
    Error('\p{Blk=_:=BLOCK_elements}');
    Error('\P{Blk=_:=BLOCK_elements}');
    Expect(1, 9631, '\p{Blk=:\ABlock_Elements\z:}', "");;
    Expect(0, 9632, '\p{Blk=:\ABlock_Elements\z:}', "");;
    Expect(1, 9631, '\p{Blk:	blockelements}', "");
    Expect(0, 9631, '\p{^Blk:	blockelements}', "");
    Expect(0, 9631, '\P{Blk:	blockelements}', "");
    Expect(1, 9631, '\P{^Blk:	blockelements}', "");
    Expect(0, 9632, '\p{Blk:	blockelements}', "");
    Expect(1, 9632, '\p{^Blk:	blockelements}', "");
    Expect(1, 9632, '\P{Blk:	blockelements}', "");
    Expect(0, 9632, '\P{^Blk:	blockelements}', "");
    Expect(1, 9631, '\p{Blk=:\Ablockelements\z:}', "");;
    Expect(0, 9632, '\p{Blk=:\Ablockelements\z:}', "");;
    Expect(1, 9631, '\p{Blk=	_Block_elements}', "");
    Expect(0, 9631, '\p{^Blk=	_Block_elements}', "");
    Expect(0, 9631, '\P{Blk=	_Block_elements}', "");
    Expect(1, 9631, '\P{^Blk=	_Block_elements}', "");
    Expect(0, 9632, '\p{Blk=	_Block_elements}', "");
    Expect(1, 9632, '\p{^Blk=	_Block_elements}', "");
    Expect(1, 9632, '\P{Blk=	_Block_elements}', "");
    Expect(0, 9632, '\P{^Blk=	_Block_elements}', "");
    Error('\p{Is_Block=	 BLOCK_Elements:=}');
    Error('\P{Is_Block=	 BLOCK_Elements:=}');
    Expect(1, 9631, '\p{Is_Block=blockelements}', "");
    Expect(0, 9631, '\p{^Is_Block=blockelements}', "");
    Expect(0, 9631, '\P{Is_Block=blockelements}', "");
    Expect(1, 9631, '\P{^Is_Block=blockelements}', "");
    Expect(0, 9632, '\p{Is_Block=blockelements}', "");
    Expect(1, 9632, '\p{^Is_Block=blockelements}', "");
    Expect(1, 9632, '\P{Is_Block=blockelements}', "");
    Expect(0, 9632, '\P{^Is_Block=blockelements}', "");
    Expect(1, 9631, '\p{Is_Block=BLOCK_Elements}', "");
    Expect(0, 9631, '\p{^Is_Block=BLOCK_Elements}', "");
    Expect(0, 9631, '\P{Is_Block=BLOCK_Elements}', "");
    Expect(1, 9631, '\P{^Is_Block=BLOCK_Elements}', "");
    Expect(0, 9632, '\p{Is_Block=BLOCK_Elements}', "");
    Expect(1, 9632, '\p{^Is_Block=BLOCK_Elements}', "");
    Expect(1, 9632, '\P{Is_Block=BLOCK_Elements}', "");
    Expect(0, 9632, '\P{^Is_Block=BLOCK_Elements}', "");
    Error('\p{Is_Blk=	:=Block_Elements}');
    Error('\P{Is_Blk=	:=Block_Elements}');
    Expect(1, 9631, '\p{Is_Blk=blockelements}', "");
    Expect(0, 9631, '\p{^Is_Blk=blockelements}', "");
    Expect(0, 9631, '\P{Is_Blk=blockelements}', "");
    Expect(1, 9631, '\P{^Is_Blk=blockelements}', "");
    Expect(0, 9632, '\p{Is_Blk=blockelements}', "");
    Expect(1, 9632, '\p{^Is_Blk=blockelements}', "");
    Expect(1, 9632, '\P{Is_Blk=blockelements}', "");
    Expect(0, 9632, '\P{^Is_Blk=blockelements}', "");
    Expect(1, 9631, '\p{Is_Blk=- Block_Elements}', "");
    Expect(0, 9631, '\p{^Is_Blk=- Block_Elements}', "");
    Expect(0, 9631, '\P{Is_Blk=- Block_Elements}', "");
    Expect(1, 9631, '\P{^Is_Blk=- Block_Elements}', "");
    Expect(0, 9632, '\p{Is_Blk=- Block_Elements}', "");
    Expect(1, 9632, '\p{^Is_Blk=- Block_Elements}', "");
    Expect(1, 9632, '\P{Is_Blk=- Block_Elements}', "");
    Expect(0, 9632, '\P{^Is_Blk=- Block_Elements}', "");
    Error('\p{Block=  Bopomofo:=}');
    Error('\P{Block=  Bopomofo:=}');
    Expect(1, 12591, '\p{Block=:\ABopomofo\z:}', "");;
    Expect(0, 12592, '\p{Block=:\ABopomofo\z:}', "");;
    Expect(1, 12591, '\p{Block:	bopomofo}', "");
    Expect(0, 12591, '\p{^Block:	bopomofo}', "");
    Expect(0, 12591, '\P{Block:	bopomofo}', "");
    Expect(1, 12591, '\P{^Block:	bopomofo}', "");
    Expect(0, 12592, '\p{Block:	bopomofo}', "");
    Expect(1, 12592, '\p{^Block:	bopomofo}', "");
    Expect(1, 12592, '\P{Block:	bopomofo}', "");
    Expect(0, 12592, '\P{^Block:	bopomofo}', "");
    Expect(1, 12591, '\p{Block=:\Abopomofo\z:}', "");;
    Expect(0, 12592, '\p{Block=:\Abopomofo\z:}', "");;
    Expect(1, 12591, '\p{Block=	BOPOMOFO}', "");
    Expect(0, 12591, '\p{^Block=	BOPOMOFO}', "");
    Expect(0, 12591, '\P{Block=	BOPOMOFO}', "");
    Expect(1, 12591, '\P{^Block=	BOPOMOFO}', "");
    Expect(0, 12592, '\p{Block=	BOPOMOFO}', "");
    Expect(1, 12592, '\p{^Block=	BOPOMOFO}', "");
    Expect(1, 12592, '\P{Block=	BOPOMOFO}', "");
    Expect(0, 12592, '\P{^Block=	BOPOMOFO}', "");
    Error('\p{Blk=	-bopomofo:=}');
    Error('\P{Blk=	-bopomofo:=}');
    Expect(1, 12591, '\p{Blk=:\ABopomofo\z:}', "");;
    Expect(0, 12592, '\p{Blk=:\ABopomofo\z:}', "");;
    Expect(1, 12591, '\p{Blk=bopomofo}', "");
    Expect(0, 12591, '\p{^Blk=bopomofo}', "");
    Expect(0, 12591, '\P{Blk=bopomofo}', "");
    Expect(1, 12591, '\P{^Blk=bopomofo}', "");
    Expect(0, 12592, '\p{Blk=bopomofo}', "");
    Expect(1, 12592, '\p{^Blk=bopomofo}', "");
    Expect(1, 12592, '\P{Blk=bopomofo}', "");
    Expect(0, 12592, '\P{^Blk=bopomofo}', "");
    Expect(1, 12591, '\p{Blk=:\Abopomofo\z:}', "");;
    Expect(0, 12592, '\p{Blk=:\Abopomofo\z:}', "");;
    Expect(1, 12591, '\p{Blk=	bopomofo}', "");
    Expect(0, 12591, '\p{^Blk=	bopomofo}', "");
    Expect(0, 12591, '\P{Blk=	bopomofo}', "");
    Expect(1, 12591, '\P{^Blk=	bopomofo}', "");
    Expect(0, 12592, '\p{Blk=	bopomofo}', "");
    Expect(1, 12592, '\p{^Blk=	bopomofo}', "");
    Expect(1, 12592, '\P{Blk=	bopomofo}', "");
    Expect(0, 12592, '\P{^Blk=	bopomofo}', "");
    Error('\p{Is_Block:	/a/Bopomofo}');
    Error('\P{Is_Block:	/a/Bopomofo}');
    Expect(1, 12591, '\p{Is_Block=bopomofo}', "");
    Expect(0, 12591, '\p{^Is_Block=bopomofo}', "");
    Expect(0, 12591, '\P{Is_Block=bopomofo}', "");
    Expect(1, 12591, '\P{^Is_Block=bopomofo}', "");
    Expect(0, 12592, '\p{Is_Block=bopomofo}', "");
    Expect(1, 12592, '\p{^Is_Block=bopomofo}', "");
    Expect(1, 12592, '\P{Is_Block=bopomofo}', "");
    Expect(0, 12592, '\P{^Is_Block=bopomofo}', "");
    Expect(1, 12591, '\p{Is_Block= _bopomofo}', "");
    Expect(0, 12591, '\p{^Is_Block= _bopomofo}', "");
    Expect(0, 12591, '\P{Is_Block= _bopomofo}', "");
    Expect(1, 12591, '\P{^Is_Block= _bopomofo}', "");
    Expect(0, 12592, '\p{Is_Block= _bopomofo}', "");
    Expect(1, 12592, '\p{^Is_Block= _bopomofo}', "");
    Expect(1, 12592, '\P{Is_Block= _bopomofo}', "");
    Expect(0, 12592, '\P{^Is_Block= _bopomofo}', "");
    Error('\p{Is_Blk=:=_-bopomofo}');
    Error('\P{Is_Blk=:=_-bopomofo}');
    Expect(1, 12591, '\p{Is_Blk=bopomofo}', "");
    Expect(0, 12591, '\p{^Is_Blk=bopomofo}', "");
    Expect(0, 12591, '\P{Is_Blk=bopomofo}', "");
    Expect(1, 12591, '\P{^Is_Blk=bopomofo}', "");
    Expect(0, 12592, '\p{Is_Blk=bopomofo}', "");
    Expect(1, 12592, '\p{^Is_Blk=bopomofo}', "");
    Expect(1, 12592, '\P{Is_Blk=bopomofo}', "");
    Expect(0, 12592, '\P{^Is_Blk=bopomofo}', "");
    Expect(1, 12591, '\p{Is_Blk=	_bopomofo}', "");
    Expect(0, 12591, '\p{^Is_Blk=	_bopomofo}', "");
    Expect(0, 12591, '\P{Is_Blk=	_bopomofo}', "");
    Expect(1, 12591, '\P{^Is_Blk=	_bopomofo}', "");
    Expect(0, 12592, '\p{Is_Blk=	_bopomofo}', "");
    Expect(1, 12592, '\p{^Is_Blk=	_bopomofo}', "");
    Expect(1, 12592, '\P{Is_Blk=	_bopomofo}', "");
    Expect(0, 12592, '\P{^Is_Blk=	_bopomofo}', "");
    Error('\p{Block=/a/bopomofo_EXTENDED}');
    Error('\P{Block=/a/bopomofo_EXTENDED}');
    Expect(1, 12735, '\p{Block=:\ABopomofo_Extended\z:}', "");;
    Expect(0, 12736, '\p{Block=:\ABopomofo_Extended\z:}', "");;
    Expect(1, 12735, '\p{Block=bopomofoextended}', "");
    Expect(0, 12735, '\p{^Block=bopomofoextended}', "");
    Expect(0, 12735, '\P{Block=bopomofoextended}', "");
    Expect(1, 12735, '\P{^Block=bopomofoextended}', "");
    Expect(0, 12736, '\p{Block=bopomofoextended}', "");
    Expect(1, 12736, '\p{^Block=bopomofoextended}', "");
    Expect(1, 12736, '\P{Block=bopomofoextended}', "");
    Expect(0, 12736, '\P{^Block=bopomofoextended}', "");
    Expect(1, 12735, '\p{Block=:\Abopomofoextended\z:}', "");;
    Expect(0, 12736, '\p{Block=:\Abopomofoextended\z:}', "");;
    Expect(1, 12735, '\p{Block=-Bopomofo_Extended}', "");
    Expect(0, 12735, '\p{^Block=-Bopomofo_Extended}', "");
    Expect(0, 12735, '\P{Block=-Bopomofo_Extended}', "");
    Expect(1, 12735, '\P{^Block=-Bopomofo_Extended}', "");
    Expect(0, 12736, '\p{Block=-Bopomofo_Extended}', "");
    Expect(1, 12736, '\p{^Block=-Bopomofo_Extended}', "");
    Expect(1, 12736, '\P{Block=-Bopomofo_Extended}', "");
    Expect(0, 12736, '\P{^Block=-Bopomofo_Extended}', "");
    Error('\p{Blk:	_/a/bopomofo_ext}');
    Error('\P{Blk:	_/a/bopomofo_ext}');
    Expect(1, 12735, '\p{Blk=:\ABopomofo_Ext\z:}', "");;
    Expect(0, 12736, '\p{Blk=:\ABopomofo_Ext\z:}', "");;
    Expect(1, 12735, '\p{Blk=bopomofoext}', "");
    Expect(0, 12735, '\p{^Blk=bopomofoext}', "");
    Expect(0, 12735, '\P{Blk=bopomofoext}', "");
    Expect(1, 12735, '\P{^Blk=bopomofoext}', "");
    Expect(0, 12736, '\p{Blk=bopomofoext}', "");
    Expect(1, 12736, '\p{^Blk=bopomofoext}', "");
    Expect(1, 12736, '\P{Blk=bopomofoext}', "");
    Expect(0, 12736, '\P{^Blk=bopomofoext}', "");
    Expect(1, 12735, '\p{Blk=:\Abopomofoext\z:}', "");;
    Expect(0, 12736, '\p{Blk=:\Abopomofoext\z:}', "");;
    Expect(1, 12735, '\p{Blk=_-Bopomofo_Ext}', "");
    Expect(0, 12735, '\p{^Blk=_-Bopomofo_Ext}', "");
    Expect(0, 12735, '\P{Blk=_-Bopomofo_Ext}', "");
    Expect(1, 12735, '\P{^Blk=_-Bopomofo_Ext}', "");
    Expect(0, 12736, '\p{Blk=_-Bopomofo_Ext}', "");
    Expect(1, 12736, '\p{^Blk=_-Bopomofo_Ext}', "");
    Expect(1, 12736, '\P{Blk=_-Bopomofo_Ext}', "");
    Expect(0, 12736, '\P{^Blk=_-Bopomofo_Ext}', "");
    Error('\p{Is_Block=:=Bopomofo_extended}');
    Error('\P{Is_Block=:=Bopomofo_extended}');
    Expect(1, 12735, '\p{Is_Block=bopomofoextended}', "");
    Expect(0, 12735, '\p{^Is_Block=bopomofoextended}', "");
    Expect(0, 12735, '\P{Is_Block=bopomofoextended}', "");
    Expect(1, 12735, '\P{^Is_Block=bopomofoextended}', "");
    Expect(0, 12736, '\p{Is_Block=bopomofoextended}', "");
    Expect(1, 12736, '\p{^Is_Block=bopomofoextended}', "");
    Expect(1, 12736, '\P{Is_Block=bopomofoextended}', "");
    Expect(0, 12736, '\P{^Is_Block=bopomofoextended}', "");
    Expect(1, 12735, '\p{Is_Block=	_bopomofo_EXTENDED}', "");
    Expect(0, 12735, '\p{^Is_Block=	_bopomofo_EXTENDED}', "");
    Expect(0, 12735, '\P{Is_Block=	_bopomofo_EXTENDED}', "");
    Expect(1, 12735, '\P{^Is_Block=	_bopomofo_EXTENDED}', "");
    Expect(0, 12736, '\p{Is_Block=	_bopomofo_EXTENDED}', "");
    Expect(1, 12736, '\p{^Is_Block=	_bopomofo_EXTENDED}', "");
    Expect(1, 12736, '\P{Is_Block=	_bopomofo_EXTENDED}', "");
    Expect(0, 12736, '\P{^Is_Block=	_bopomofo_EXTENDED}', "");
    Error('\p{Is_Blk=/a/-bopomofo_EXT}');
    Error('\P{Is_Blk=/a/-bopomofo_EXT}');
    Expect(1, 12735, '\p{Is_Blk=bopomofoext}', "");
    Expect(0, 12735, '\p{^Is_Blk=bopomofoext}', "");
    Expect(0, 12735, '\P{Is_Blk=bopomofoext}', "");
    Expect(1, 12735, '\P{^Is_Blk=bopomofoext}', "");
    Expect(0, 12736, '\p{Is_Blk=bopomofoext}', "");
    Expect(1, 12736, '\p{^Is_Blk=bopomofoext}', "");
    Expect(1, 12736, '\P{Is_Blk=bopomofoext}', "");
    Expect(0, 12736, '\P{^Is_Blk=bopomofoext}', "");
    Expect(1, 12735, '\p{Is_Blk=-	Bopomofo_Ext}', "");
    Expect(0, 12735, '\p{^Is_Blk=-	Bopomofo_Ext}', "");
    Expect(0, 12735, '\P{Is_Blk=-	Bopomofo_Ext}', "");
    Expect(1, 12735, '\P{^Is_Blk=-	Bopomofo_Ext}', "");
    Expect(0, 12736, '\p{Is_Blk=-	Bopomofo_Ext}', "");
    Expect(1, 12736, '\p{^Is_Blk=-	Bopomofo_Ext}', "");
    Expect(1, 12736, '\P{Is_Blk=-	Bopomofo_Ext}', "");
    Expect(0, 12736, '\P{^Is_Blk=-	Bopomofo_Ext}', "");
    Error('\p{Block=:=-Box_drawing}');
    Error('\P{Block=:=-Box_drawing}');
    Expect(1, 9599, '\p{Block=:\ABox_Drawing\z:}', "");;
    Expect(0, 9600, '\p{Block=:\ABox_Drawing\z:}', "");;
    Expect(1, 9599, '\p{Block=boxdrawing}', "");
    Expect(0, 9599, '\p{^Block=boxdrawing}', "");
    Expect(0, 9599, '\P{Block=boxdrawing}', "");
    Expect(1, 9599, '\P{^Block=boxdrawing}', "");
    Expect(0, 9600, '\p{Block=boxdrawing}', "");
    Expect(1, 9600, '\p{^Block=boxdrawing}', "");
    Expect(1, 9600, '\P{Block=boxdrawing}', "");
    Expect(0, 9600, '\P{^Block=boxdrawing}', "");
    Expect(1, 9599, '\p{Block=:\Aboxdrawing\z:}', "");;
    Expect(0, 9600, '\p{Block=:\Aboxdrawing\z:}', "");;
    Expect(1, 9599, '\p{Block=_-Box_Drawing}', "");
    Expect(0, 9599, '\p{^Block=_-Box_Drawing}', "");
    Expect(0, 9599, '\P{Block=_-Box_Drawing}', "");
    Expect(1, 9599, '\P{^Block=_-Box_Drawing}', "");
    Expect(0, 9600, '\p{Block=_-Box_Drawing}', "");
    Expect(1, 9600, '\p{^Block=_-Box_Drawing}', "");
    Expect(1, 9600, '\P{Block=_-Box_Drawing}', "");
    Expect(0, 9600, '\P{^Block=_-Box_Drawing}', "");
    Error('\p{Blk=:=_	Box_Drawing}');
    Error('\P{Blk=:=_	Box_Drawing}');
    Expect(1, 9599, '\p{Blk=:\ABox_Drawing\z:}', "");;
    Expect(0, 9600, '\p{Blk=:\ABox_Drawing\z:}', "");;
    Expect(1, 9599, '\p{Blk=boxdrawing}', "");
    Expect(0, 9599, '\p{^Blk=boxdrawing}', "");
    Expect(0, 9599, '\P{Blk=boxdrawing}', "");
    Expect(1, 9599, '\P{^Blk=boxdrawing}', "");
    Expect(0, 9600, '\p{Blk=boxdrawing}', "");
    Expect(1, 9600, '\p{^Blk=boxdrawing}', "");
    Expect(1, 9600, '\P{Blk=boxdrawing}', "");
    Expect(0, 9600, '\P{^Blk=boxdrawing}', "");
    Expect(1, 9599, '\p{Blk=:\Aboxdrawing\z:}', "");;
    Expect(0, 9600, '\p{Blk=:\Aboxdrawing\z:}', "");;
    Expect(1, 9599, '\p{Blk=-Box_DRAWING}', "");
    Expect(0, 9599, '\p{^Blk=-Box_DRAWING}', "");
    Expect(0, 9599, '\P{Blk=-Box_DRAWING}', "");
    Expect(1, 9599, '\P{^Blk=-Box_DRAWING}', "");
    Expect(0, 9600, '\p{Blk=-Box_DRAWING}', "");
    Expect(1, 9600, '\p{^Blk=-Box_DRAWING}', "");
    Expect(1, 9600, '\P{Blk=-Box_DRAWING}', "");
    Expect(0, 9600, '\P{^Blk=-Box_DRAWING}', "");
    Error('\p{Is_Block=	:=Box_drawing}');
    Error('\P{Is_Block=	:=Box_drawing}');
    Expect(1, 9599, '\p{Is_Block:   boxdrawing}', "");
    Expect(0, 9599, '\p{^Is_Block:   boxdrawing}', "");
    Expect(0, 9599, '\P{Is_Block:   boxdrawing}', "");
    Expect(1, 9599, '\P{^Is_Block:   boxdrawing}', "");
    Expect(0, 9600, '\p{Is_Block:   boxdrawing}', "");
    Expect(1, 9600, '\p{^Is_Block:   boxdrawing}', "");
    Expect(1, 9600, '\P{Is_Block:   boxdrawing}', "");
    Expect(0, 9600, '\P{^Is_Block:   boxdrawing}', "");
    Expect(1, 9599, '\p{Is_Block:  -box_Drawing}', "");
    Expect(0, 9599, '\p{^Is_Block:  -box_Drawing}', "");
    Expect(0, 9599, '\P{Is_Block:  -box_Drawing}', "");
    Expect(1, 9599, '\P{^Is_Block:  -box_Drawing}', "");
    Expect(0, 9600, '\p{Is_Block:  -box_Drawing}', "");
    Expect(1, 9600, '\p{^Is_Block:  -box_Drawing}', "");
    Expect(1, 9600, '\P{Is_Block:  -box_Drawing}', "");
    Expect(0, 9600, '\P{^Is_Block:  -box_Drawing}', "");
    Error('\p{Is_Blk=_ BOX_drawing:=}');
    Error('\P{Is_Blk=_ BOX_drawing:=}');
    Expect(1, 9599, '\p{Is_Blk=boxdrawing}', "");
    Expect(0, 9599, '\p{^Is_Blk=boxdrawing}', "");
    Expect(0, 9599, '\P{Is_Blk=boxdrawing}', "");
    Expect(1, 9599, '\P{^Is_Blk=boxdrawing}', "");
    Expect(0, 9600, '\p{Is_Blk=boxdrawing}', "");
    Expect(1, 9600, '\p{^Is_Blk=boxdrawing}', "");
    Expect(1, 9600, '\P{Is_Blk=boxdrawing}', "");
    Expect(0, 9600, '\P{^Is_Blk=boxdrawing}', "");
    Expect(1, 9599, '\p{Is_Blk=-_box_DRAWING}', "");
    Expect(0, 9599, '\p{^Is_Blk=-_box_DRAWING}', "");
    Expect(0, 9599, '\P{Is_Blk=-_box_DRAWING}', "");
    Expect(1, 9599, '\P{^Is_Blk=-_box_DRAWING}', "");
    Expect(0, 9600, '\p{Is_Blk=-_box_DRAWING}', "");
    Expect(1, 9600, '\p{^Is_Blk=-_box_DRAWING}', "");
    Expect(1, 9600, '\P{Is_Blk=-_box_DRAWING}', "");
    Expect(0, 9600, '\P{^Is_Blk=-_box_DRAWING}', "");
    Error('\p{Block=_:=BRAHMI}');
    Error('\P{Block=_:=BRAHMI}');
    Expect(1, 69759, '\p{Block=:\ABrahmi\z:}', "");;
    Expect(0, 69760, '\p{Block=:\ABrahmi\z:}', "");;
    Expect(1, 69759, '\p{Block=brahmi}', "");
    Expect(0, 69759, '\p{^Block=brahmi}', "");
    Expect(0, 69759, '\P{Block=brahmi}', "");
    Expect(1, 69759, '\P{^Block=brahmi}', "");
    Expect(0, 69760, '\p{Block=brahmi}', "");
    Expect(1, 69760, '\p{^Block=brahmi}', "");
    Expect(1, 69760, '\P{Block=brahmi}', "");
    Expect(0, 69760, '\P{^Block=brahmi}', "");
    Expect(1, 69759, '\p{Block=:\Abrahmi\z:}', "");;
    Expect(0, 69760, '\p{Block=:\Abrahmi\z:}', "");;
    Expect(1, 69759, '\p{Block=_	brahmi}', "");
    Expect(0, 69759, '\p{^Block=_	brahmi}', "");
    Expect(0, 69759, '\P{Block=_	brahmi}', "");
    Expect(1, 69759, '\P{^Block=_	brahmi}', "");
    Expect(0, 69760, '\p{Block=_	brahmi}', "");
    Expect(1, 69760, '\p{^Block=_	brahmi}', "");
    Expect(1, 69760, '\P{Block=_	brahmi}', "");
    Expect(0, 69760, '\P{^Block=_	brahmi}', "");
    Error('\p{Blk=-:=Brahmi}');
    Error('\P{Blk=-:=Brahmi}');
    Expect(1, 69759, '\p{Blk=:\ABrahmi\z:}', "");;
    Expect(0, 69760, '\p{Blk=:\ABrahmi\z:}', "");;
    Expect(1, 69759, '\p{Blk:brahmi}', "");
    Expect(0, 69759, '\p{^Blk:brahmi}', "");
    Expect(0, 69759, '\P{Blk:brahmi}', "");
    Expect(1, 69759, '\P{^Blk:brahmi}', "");
    Expect(0, 69760, '\p{Blk:brahmi}', "");
    Expect(1, 69760, '\p{^Blk:brahmi}', "");
    Expect(1, 69760, '\P{Blk:brahmi}', "");
    Expect(0, 69760, '\P{^Blk:brahmi}', "");
    Expect(1, 69759, '\p{Blk=:\Abrahmi\z:}', "");;
    Expect(0, 69760, '\p{Blk=:\Abrahmi\z:}', "");;
    Expect(1, 69759, '\p{Blk=--Brahmi}', "");
    Expect(0, 69759, '\p{^Blk=--Brahmi}', "");
    Expect(0, 69759, '\P{Blk=--Brahmi}', "");
    Expect(1, 69759, '\P{^Blk=--Brahmi}', "");
    Expect(0, 69760, '\p{Blk=--Brahmi}', "");
    Expect(1, 69760, '\p{^Blk=--Brahmi}', "");
    Expect(1, 69760, '\P{Blk=--Brahmi}', "");
    Expect(0, 69760, '\P{^Blk=--Brahmi}', "");
    Error('\p{Is_Block=_:=BRAHMI}');
    Error('\P{Is_Block=_:=BRAHMI}');
    Expect(1, 69759, '\p{Is_Block=brahmi}', "");
    Expect(0, 69759, '\p{^Is_Block=brahmi}', "");
    Expect(0, 69759, '\P{Is_Block=brahmi}', "");
    Expect(1, 69759, '\P{^Is_Block=brahmi}', "");
    Expect(0, 69760, '\p{Is_Block=brahmi}', "");
    Expect(1, 69760, '\p{^Is_Block=brahmi}', "");
    Expect(1, 69760, '\P{Is_Block=brahmi}', "");
    Expect(0, 69760, '\P{^Is_Block=brahmi}', "");
    Expect(1, 69759, '\p{Is_Block=_Brahmi}', "");
    Expect(0, 69759, '\p{^Is_Block=_Brahmi}', "");
    Expect(0, 69759, '\P{Is_Block=_Brahmi}', "");
    Expect(1, 69759, '\P{^Is_Block=_Brahmi}', "");
    Expect(0, 69760, '\p{Is_Block=_Brahmi}', "");
    Expect(1, 69760, '\p{^Is_Block=_Brahmi}', "");
    Expect(1, 69760, '\P{Is_Block=_Brahmi}', "");
    Expect(0, 69760, '\P{^Is_Block=_Brahmi}', "");
    Error('\p{Is_Blk=:=Brahmi}');
    Error('\P{Is_Blk=:=Brahmi}');
    Expect(1, 69759, '\p{Is_Blk=brahmi}', "");
    Expect(0, 69759, '\p{^Is_Blk=brahmi}', "");
    Expect(0, 69759, '\P{Is_Blk=brahmi}', "");
    Expect(1, 69759, '\P{^Is_Blk=brahmi}', "");
    Expect(0, 69760, '\p{Is_Blk=brahmi}', "");
    Expect(1, 69760, '\p{^Is_Blk=brahmi}', "");
    Expect(1, 69760, '\P{Is_Blk=brahmi}', "");
    Expect(0, 69760, '\P{^Is_Blk=brahmi}', "");
    Error('\p{Block=-:=braille_Patterns}');
    Error('\P{Block=-:=braille_Patterns}');
    Expect(1, 10495, '\p{Block=:\ABraille_Patterns\z:}', "");;
    Expect(0, 10496, '\p{Block=:\ABraille_Patterns\z:}', "");;
    Expect(1, 10495, '\p{Block=braillepatterns}', "");
    Expect(0, 10495, '\p{^Block=braillepatterns}', "");
    Expect(0, 10495, '\P{Block=braillepatterns}', "");
    Expect(1, 10495, '\P{^Block=braillepatterns}', "");
    Expect(0, 10496, '\p{Block=braillepatterns}', "");
    Expect(1, 10496, '\p{^Block=braillepatterns}', "");
    Expect(1, 10496, '\P{Block=braillepatterns}', "");
    Expect(0, 10496, '\P{^Block=braillepatterns}', "");
    Expect(1, 10495, '\p{Block=:\Abraillepatterns\z:}', "");;
    Expect(0, 10496, '\p{Block=:\Abraillepatterns\z:}', "");;
    Expect(1, 10495, '\p{Block=	Braille_PATTERNS}', "");
    Expect(0, 10495, '\p{^Block=	Braille_PATTERNS}', "");
    Expect(0, 10495, '\P{Block=	Braille_PATTERNS}', "");
    Expect(1, 10495, '\P{^Block=	Braille_PATTERNS}', "");
    Expect(0, 10496, '\p{Block=	Braille_PATTERNS}', "");
    Expect(1, 10496, '\p{^Block=	Braille_PATTERNS}', "");
    Expect(1, 10496, '\P{Block=	Braille_PATTERNS}', "");
    Expect(0, 10496, '\P{^Block=	Braille_PATTERNS}', "");
    Error('\p{Blk=:=		braille}');
    Error('\P{Blk=:=		braille}');
    Expect(1, 10495, '\p{Blk=:\ABraille\z:}', "");;
    Expect(0, 10496, '\p{Blk=:\ABraille\z:}', "");;
    Expect(1, 10495, '\p{Blk=braille}', "");
    Expect(0, 10495, '\p{^Blk=braille}', "");
    Expect(0, 10495, '\P{Blk=braille}', "");
    Expect(1, 10495, '\P{^Blk=braille}', "");
    Expect(0, 10496, '\p{Blk=braille}', "");
    Expect(1, 10496, '\p{^Blk=braille}', "");
    Expect(1, 10496, '\P{Blk=braille}', "");
    Expect(0, 10496, '\P{^Blk=braille}', "");
    Expect(1, 10495, '\p{Blk=:\Abraille\z:}', "");;
    Expect(0, 10496, '\p{Blk=:\Abraille\z:}', "");;
    Expect(1, 10495, '\p{Blk=		BRAILLE}', "");
    Expect(0, 10495, '\p{^Blk=		BRAILLE}', "");
    Expect(0, 10495, '\P{Blk=		BRAILLE}', "");
    Expect(1, 10495, '\P{^Blk=		BRAILLE}', "");
    Expect(0, 10496, '\p{Blk=		BRAILLE}', "");
    Expect(1, 10496, '\p{^Blk=		BRAILLE}', "");
    Expect(1, 10496, '\P{Blk=		BRAILLE}', "");
    Expect(0, 10496, '\P{^Blk=		BRAILLE}', "");
    Error('\p{Is_Block=_	braille_Patterns:=}');
    Error('\P{Is_Block=_	braille_Patterns:=}');
    Expect(1, 10495, '\p{Is_Block=braillepatterns}', "");
    Expect(0, 10495, '\p{^Is_Block=braillepatterns}', "");
    Expect(0, 10495, '\P{Is_Block=braillepatterns}', "");
    Expect(1, 10495, '\P{^Is_Block=braillepatterns}', "");
    Expect(0, 10496, '\p{Is_Block=braillepatterns}', "");
    Expect(1, 10496, '\p{^Is_Block=braillepatterns}', "");
    Expect(1, 10496, '\P{Is_Block=braillepatterns}', "");
    Expect(0, 10496, '\P{^Is_Block=braillepatterns}', "");
    Expect(1, 10495, '\p{Is_Block=braille_PATTERNS}', "");
    Expect(0, 10495, '\p{^Is_Block=braille_PATTERNS}', "");
    Expect(0, 10495, '\P{Is_Block=braille_PATTERNS}', "");
    Expect(1, 10495, '\P{^Is_Block=braille_PATTERNS}', "");
    Expect(0, 10496, '\p{Is_Block=braille_PATTERNS}', "");
    Expect(1, 10496, '\p{^Is_Block=braille_PATTERNS}', "");
    Expect(1, 10496, '\P{Is_Block=braille_PATTERNS}', "");
    Expect(0, 10496, '\P{^Is_Block=braille_PATTERNS}', "");
    Error('\p{Is_Blk=_/a/Braille}');
    Error('\P{Is_Blk=_/a/Braille}');
    Expect(1, 10495, '\p{Is_Blk=braille}', "");
    Expect(0, 10495, '\p{^Is_Blk=braille}', "");
    Expect(0, 10495, '\P{Is_Blk=braille}', "");
    Expect(1, 10495, '\P{^Is_Blk=braille}', "");
    Expect(0, 10496, '\p{Is_Blk=braille}', "");
    Expect(1, 10496, '\p{^Is_Blk=braille}', "");
    Expect(1, 10496, '\P{Is_Blk=braille}', "");
    Expect(0, 10496, '\P{^Is_Blk=braille}', "");
    Expect(1, 10495, '\p{Is_Blk=_-BRAILLE}', "");
    Expect(0, 10495, '\p{^Is_Blk=_-BRAILLE}', "");
    Expect(0, 10495, '\P{Is_Blk=_-BRAILLE}', "");
    Expect(1, 10495, '\P{^Is_Blk=_-BRAILLE}', "");
    Expect(0, 10496, '\p{Is_Blk=_-BRAILLE}', "");
    Expect(1, 10496, '\p{^Is_Blk=_-BRAILLE}', "");
    Expect(1, 10496, '\P{Is_Blk=_-BRAILLE}', "");
    Expect(0, 10496, '\P{^Is_Blk=_-BRAILLE}', "");
    Error('\p{Block=_:=BUGINESE}');
    Error('\P{Block=_:=BUGINESE}');
    Expect(1, 6687, '\p{Block=:\ABuginese\z:}', "");;
    Expect(0, 6688, '\p{Block=:\ABuginese\z:}', "");;
    Expect(1, 6687, '\p{Block=buginese}', "");
    Expect(0, 6687, '\p{^Block=buginese}', "");
    Expect(0, 6687, '\P{Block=buginese}', "");
    Expect(1, 6687, '\P{^Block=buginese}', "");
    Expect(0, 6688, '\p{Block=buginese}', "");
    Expect(1, 6688, '\p{^Block=buginese}', "");
    Expect(1, 6688, '\P{Block=buginese}', "");
    Expect(0, 6688, '\P{^Block=buginese}', "");
    Expect(1, 6687, '\p{Block=:\Abuginese\z:}', "");;
    Expect(0, 6688, '\p{Block=:\Abuginese\z:}', "");;
    Expect(1, 6687, '\p{Block: _	Buginese}', "");
    Expect(0, 6687, '\p{^Block: _	Buginese}', "");
    Expect(0, 6687, '\P{Block: _	Buginese}', "");
    Expect(1, 6687, '\P{^Block: _	Buginese}', "");
    Expect(0, 6688, '\p{Block: _	Buginese}', "");
    Expect(1, 6688, '\p{^Block: _	Buginese}', "");
    Expect(1, 6688, '\P{Block: _	Buginese}', "");
    Expect(0, 6688, '\P{^Block: _	Buginese}', "");
    Error('\p{Blk=-/a/BUGINESE}');
    Error('\P{Blk=-/a/BUGINESE}');
    Expect(1, 6687, '\p{Blk=:\ABuginese\z:}', "");;
    Expect(0, 6688, '\p{Blk=:\ABuginese\z:}', "");;
    Expect(1, 6687, '\p{Blk=buginese}', "");
    Expect(0, 6687, '\p{^Blk=buginese}', "");
    Expect(0, 6687, '\P{Blk=buginese}', "");
    Expect(1, 6687, '\P{^Blk=buginese}', "");
    Expect(0, 6688, '\p{Blk=buginese}', "");
    Expect(1, 6688, '\p{^Blk=buginese}', "");
    Expect(1, 6688, '\P{Blk=buginese}', "");
    Expect(0, 6688, '\P{^Blk=buginese}', "");
    Expect(1, 6687, '\p{Blk=:\Abuginese\z:}', "");;
    Expect(0, 6688, '\p{Blk=:\Abuginese\z:}', "");;
    Expect(1, 6687, '\p{Blk:BUGINESE}', "");
    Expect(0, 6687, '\p{^Blk:BUGINESE}', "");
    Expect(0, 6687, '\P{Blk:BUGINESE}', "");
    Expect(1, 6687, '\P{^Blk:BUGINESE}', "");
    Expect(0, 6688, '\p{Blk:BUGINESE}', "");
    Expect(1, 6688, '\p{^Blk:BUGINESE}', "");
    Expect(1, 6688, '\P{Blk:BUGINESE}', "");
    Expect(0, 6688, '\P{^Blk:BUGINESE}', "");
    Error('\p{Is_Block: Buginese:=}');
    Error('\P{Is_Block: Buginese:=}');
    Expect(1, 6687, '\p{Is_Block=buginese}', "");
    Expect(0, 6687, '\p{^Is_Block=buginese}', "");
    Expect(0, 6687, '\P{Is_Block=buginese}', "");
    Expect(1, 6687, '\P{^Is_Block=buginese}', "");
    Expect(0, 6688, '\p{Is_Block=buginese}', "");
    Expect(1, 6688, '\p{^Is_Block=buginese}', "");
    Expect(1, 6688, '\P{Is_Block=buginese}', "");
    Expect(0, 6688, '\P{^Is_Block=buginese}', "");
    Expect(1, 6687, '\p{Is_Block=_-BUGINESE}', "");
    Expect(0, 6687, '\p{^Is_Block=_-BUGINESE}', "");
    Expect(0, 6687, '\P{Is_Block=_-BUGINESE}', "");
    Expect(1, 6687, '\P{^Is_Block=_-BUGINESE}', "");
    Expect(0, 6688, '\p{Is_Block=_-BUGINESE}', "");
    Expect(1, 6688, '\p{^Is_Block=_-BUGINESE}', "");
    Expect(1, 6688, '\P{Is_Block=_-BUGINESE}', "");
    Expect(0, 6688, '\P{^Is_Block=_-BUGINESE}', "");
    Error('\p{Is_Blk: /a/		Buginese}');
    Error('\P{Is_Blk: /a/		Buginese}');
    Expect(1, 6687, '\p{Is_Blk=buginese}', "");
    Expect(0, 6687, '\p{^Is_Blk=buginese}', "");
    Expect(0, 6687, '\P{Is_Blk=buginese}', "");
    Expect(1, 6687, '\P{^Is_Blk=buginese}', "");
    Expect(0, 6688, '\p{Is_Blk=buginese}', "");
    Expect(1, 6688, '\p{^Is_Blk=buginese}', "");
    Expect(1, 6688, '\P{Is_Blk=buginese}', "");
    Expect(0, 6688, '\P{^Is_Blk=buginese}', "");
    Expect(1, 6687, '\p{Is_Blk= 	buginese}', "");
    Expect(0, 6687, '\p{^Is_Blk= 	buginese}', "");
    Expect(0, 6687, '\P{Is_Blk= 	buginese}', "");
    Expect(1, 6687, '\P{^Is_Blk= 	buginese}', "");
    Expect(0, 6688, '\p{Is_Blk= 	buginese}', "");
    Expect(1, 6688, '\p{^Is_Blk= 	buginese}', "");
    Expect(1, 6688, '\P{Is_Blk= 	buginese}', "");
    Expect(0, 6688, '\P{^Is_Blk= 	buginese}', "");
    Error('\p{Block= buhid:=}');
    Error('\P{Block= buhid:=}');
    Expect(1, 5983, '\p{Block=:\ABuhid\z:}', "");;
    Expect(0, 5984, '\p{Block=:\ABuhid\z:}', "");;
    Expect(1, 5983, '\p{Block=buhid}', "");
    Expect(0, 5983, '\p{^Block=buhid}', "");
    Expect(0, 5983, '\P{Block=buhid}', "");
    Expect(1, 5983, '\P{^Block=buhid}', "");
    Expect(0, 5984, '\p{Block=buhid}', "");
    Expect(1, 5984, '\p{^Block=buhid}', "");
    Expect(1, 5984, '\P{Block=buhid}', "");
    Expect(0, 5984, '\P{^Block=buhid}', "");
    Expect(1, 5983, '\p{Block=:\Abuhid\z:}', "");;
    Expect(0, 5984, '\p{Block=:\Abuhid\z:}', "");;
    Expect(1, 5983, '\p{Block=BUHID}', "");
    Expect(0, 5983, '\p{^Block=BUHID}', "");
    Expect(0, 5983, '\P{Block=BUHID}', "");
    Expect(1, 5983, '\P{^Block=BUHID}', "");
    Expect(0, 5984, '\p{Block=BUHID}', "");
    Expect(1, 5984, '\p{^Block=BUHID}', "");
    Expect(1, 5984, '\P{Block=BUHID}', "");
    Expect(0, 5984, '\P{^Block=BUHID}', "");
    Error('\p{Blk= :=buhid}');
    Error('\P{Blk= :=buhid}');
    Expect(1, 5983, '\p{Blk=:\ABuhid\z:}', "");;
    Expect(0, 5984, '\p{Blk=:\ABuhid\z:}', "");;
    Expect(1, 5983, '\p{Blk=buhid}', "");
    Expect(0, 5983, '\p{^Blk=buhid}', "");
    Expect(0, 5983, '\P{Blk=buhid}', "");
    Expect(1, 5983, '\P{^Blk=buhid}', "");
    Expect(0, 5984, '\p{Blk=buhid}', "");
    Expect(1, 5984, '\p{^Blk=buhid}', "");
    Expect(1, 5984, '\P{Blk=buhid}', "");
    Expect(0, 5984, '\P{^Blk=buhid}', "");
    Expect(1, 5983, '\p{Blk=:\Abuhid\z:}', "");;
    Expect(0, 5984, '\p{Blk=:\Abuhid\z:}', "");;
    Expect(1, 5983, '\p{Blk: _BUHID}', "");
    Expect(0, 5983, '\p{^Blk: _BUHID}', "");
    Expect(0, 5983, '\P{Blk: _BUHID}', "");
    Expect(1, 5983, '\P{^Blk: _BUHID}', "");
    Expect(0, 5984, '\p{Blk: _BUHID}', "");
    Expect(1, 5984, '\p{^Blk: _BUHID}', "");
    Expect(1, 5984, '\P{Blk: _BUHID}', "");
    Expect(0, 5984, '\P{^Blk: _BUHID}', "");
    Error('\p{Is_Block: :=_-buhid}');
    Error('\P{Is_Block: :=_-buhid}');
    Expect(1, 5983, '\p{Is_Block=buhid}', "");
    Expect(0, 5983, '\p{^Is_Block=buhid}', "");
    Expect(0, 5983, '\P{Is_Block=buhid}', "");
    Expect(1, 5983, '\P{^Is_Block=buhid}', "");
    Expect(0, 5984, '\p{Is_Block=buhid}', "");
    Expect(1, 5984, '\p{^Is_Block=buhid}', "");
    Expect(1, 5984, '\P{Is_Block=buhid}', "");
    Expect(0, 5984, '\P{^Is_Block=buhid}', "");
    Expect(1, 5983, '\p{Is_Block=_-Buhid}', "");
    Expect(0, 5983, '\p{^Is_Block=_-Buhid}', "");
    Expect(0, 5983, '\P{Is_Block=_-Buhid}', "");
    Expect(1, 5983, '\P{^Is_Block=_-Buhid}', "");
    Expect(0, 5984, '\p{Is_Block=_-Buhid}', "");
    Expect(1, 5984, '\p{^Is_Block=_-Buhid}', "");
    Expect(1, 5984, '\P{Is_Block=_-Buhid}', "");
    Expect(0, 5984, '\P{^Is_Block=_-Buhid}', "");
    Error('\p{Is_Blk=/a/BUHID}');
    Error('\P{Is_Blk=/a/BUHID}');
    Expect(1, 5983, '\p{Is_Blk=buhid}', "");
    Expect(0, 5983, '\p{^Is_Blk=buhid}', "");
    Expect(0, 5983, '\P{Is_Blk=buhid}', "");
    Expect(1, 5983, '\P{^Is_Blk=buhid}', "");
    Expect(0, 5984, '\p{Is_Blk=buhid}', "");
    Expect(1, 5984, '\p{^Is_Blk=buhid}', "");
    Expect(1, 5984, '\P{Is_Blk=buhid}', "");
    Expect(0, 5984, '\P{^Is_Blk=buhid}', "");
    Expect(1, 5983, '\p{Is_Blk=_BUHID}', "");
    Expect(0, 5983, '\p{^Is_Blk=_BUHID}', "");
    Expect(0, 5983, '\P{Is_Blk=_BUHID}', "");
    Expect(1, 5983, '\P{^Is_Blk=_BUHID}', "");
    Expect(0, 5984, '\p{Is_Blk=_BUHID}', "");
    Expect(1, 5984, '\p{^Is_Blk=_BUHID}', "");
    Expect(1, 5984, '\P{Is_Blk=_BUHID}', "");
    Expect(0, 5984, '\P{^Is_Blk=_BUHID}', "");
    Error('\p{Block=	/a/byzantine_Musical_Symbols}');
    Error('\P{Block=	/a/byzantine_Musical_Symbols}');
    Expect(1, 119039, '\p{Block=:\AByzantine_Musical_Symbols\z:}', "");;
    Expect(0, 119040, '\p{Block=:\AByzantine_Musical_Symbols\z:}', "");;
    Expect(1, 119039, '\p{Block=byzantinemusicalsymbols}', "");
    Expect(0, 119039, '\p{^Block=byzantinemusicalsymbols}', "");
    Expect(0, 119039, '\P{Block=byzantinemusicalsymbols}', "");
    Expect(1, 119039, '\P{^Block=byzantinemusicalsymbols}', "");
    Expect(0, 119040, '\p{Block=byzantinemusicalsymbols}', "");
    Expect(1, 119040, '\p{^Block=byzantinemusicalsymbols}', "");
    Expect(1, 119040, '\P{Block=byzantinemusicalsymbols}', "");
    Expect(0, 119040, '\P{^Block=byzantinemusicalsymbols}', "");
    Expect(1, 119039, '\p{Block=:\Abyzantinemusicalsymbols\z:}', "");;
    Expect(0, 119040, '\p{Block=:\Abyzantinemusicalsymbols\z:}', "");;
    Expect(1, 119039, '\p{Block=byzantine_Musical_Symbols}', "");
    Expect(0, 119039, '\p{^Block=byzantine_Musical_Symbols}', "");
    Expect(0, 119039, '\P{Block=byzantine_Musical_Symbols}', "");
    Expect(1, 119039, '\P{^Block=byzantine_Musical_Symbols}', "");
    Expect(0, 119040, '\p{Block=byzantine_Musical_Symbols}', "");
    Expect(1, 119040, '\p{^Block=byzantine_Musical_Symbols}', "");
    Expect(1, 119040, '\P{Block=byzantine_Musical_Symbols}', "");
    Expect(0, 119040, '\P{^Block=byzantine_Musical_Symbols}', "");
    Error('\p{Blk=-:=Byzantine_music}');
    Error('\P{Blk=-:=Byzantine_music}');
    Expect(1, 119039, '\p{Blk=:\AByzantine_Music\z:}', "");;
    Expect(0, 119040, '\p{Blk=:\AByzantine_Music\z:}', "");;
    Expect(1, 119039, '\p{Blk=byzantinemusic}', "");
    Expect(0, 119039, '\p{^Blk=byzantinemusic}', "");
    Expect(0, 119039, '\P{Blk=byzantinemusic}', "");
    Expect(1, 119039, '\P{^Blk=byzantinemusic}', "");
    Expect(0, 119040, '\p{Blk=byzantinemusic}', "");
    Expect(1, 119040, '\p{^Blk=byzantinemusic}', "");
    Expect(1, 119040, '\P{Blk=byzantinemusic}', "");
    Expect(0, 119040, '\P{^Blk=byzantinemusic}', "");
    Expect(1, 119039, '\p{Blk=:\Abyzantinemusic\z:}', "");;
    Expect(0, 119040, '\p{Blk=:\Abyzantinemusic\z:}', "");;
    Expect(1, 119039, '\p{Blk= Byzantine_Music}', "");
    Expect(0, 119039, '\p{^Blk= Byzantine_Music}', "");
    Expect(0, 119039, '\P{Blk= Byzantine_Music}', "");
    Expect(1, 119039, '\P{^Blk= Byzantine_Music}', "");
    Expect(0, 119040, '\p{Blk= Byzantine_Music}', "");
    Expect(1, 119040, '\p{^Blk= Byzantine_Music}', "");
    Expect(1, 119040, '\P{Blk= Byzantine_Music}', "");
    Expect(0, 119040, '\P{^Blk= Byzantine_Music}', "");
    Error('\p{Is_Block=/a/ BYZANTINE_Musical_Symbols}');
    Error('\P{Is_Block=/a/ BYZANTINE_Musical_Symbols}');
    Expect(1, 119039, '\p{Is_Block=byzantinemusicalsymbols}', "");
    Expect(0, 119039, '\p{^Is_Block=byzantinemusicalsymbols}', "");
    Expect(0, 119039, '\P{Is_Block=byzantinemusicalsymbols}', "");
    Expect(1, 119039, '\P{^Is_Block=byzantinemusicalsymbols}', "");
    Expect(0, 119040, '\p{Is_Block=byzantinemusicalsymbols}', "");
    Expect(1, 119040, '\p{^Is_Block=byzantinemusicalsymbols}', "");
    Expect(1, 119040, '\P{Is_Block=byzantinemusicalsymbols}', "");
    Expect(0, 119040, '\P{^Is_Block=byzantinemusicalsymbols}', "");
    Expect(1, 119039, '\p{Is_Block=-	Byzantine_MUSICAL_Symbols}', "");
    Expect(0, 119039, '\p{^Is_Block=-	Byzantine_MUSICAL_Symbols}', "");
    Expect(0, 119039, '\P{Is_Block=-	Byzantine_MUSICAL_Symbols}', "");
    Expect(1, 119039, '\P{^Is_Block=-	Byzantine_MUSICAL_Symbols}', "");
    Expect(0, 119040, '\p{Is_Block=-	Byzantine_MUSICAL_Symbols}', "");
    Expect(1, 119040, '\p{^Is_Block=-	Byzantine_MUSICAL_Symbols}', "");
    Expect(1, 119040, '\P{Is_Block=-	Byzantine_MUSICAL_Symbols}', "");
    Expect(0, 119040, '\P{^Is_Block=-	Byzantine_MUSICAL_Symbols}', "");
    Error('\p{Is_Blk=_	Byzantine_Music/a/}');
    Error('\P{Is_Blk=_	Byzantine_Music/a/}');
    Expect(1, 119039, '\p{Is_Blk:   byzantinemusic}', "");
    Expect(0, 119039, '\p{^Is_Blk:   byzantinemusic}', "");
    Expect(0, 119039, '\P{Is_Blk:   byzantinemusic}', "");
    Expect(1, 119039, '\P{^Is_Blk:   byzantinemusic}', "");
    Expect(0, 119040, '\p{Is_Blk:   byzantinemusic}', "");
    Expect(1, 119040, '\p{^Is_Blk:   byzantinemusic}', "");
    Expect(1, 119040, '\P{Is_Blk:   byzantinemusic}', "");
    Expect(0, 119040, '\P{^Is_Blk:   byzantinemusic}', "");
    Expect(1, 119039, '\p{Is_Blk=BYZANTINE_MUSIC}', "");
    Expect(0, 119039, '\p{^Is_Blk=BYZANTINE_MUSIC}', "");
    Expect(0, 119039, '\P{Is_Blk=BYZANTINE_MUSIC}', "");
    Expect(1, 119039, '\P{^Is_Blk=BYZANTINE_MUSIC}', "");
    Expect(0, 119040, '\p{Is_Blk=BYZANTINE_MUSIC}', "");
    Expect(1, 119040, '\p{^Is_Blk=BYZANTINE_MUSIC}', "");
    Expect(1, 119040, '\P{Is_Blk=BYZANTINE_MUSIC}', "");
    Expect(0, 119040, '\P{^Is_Blk=BYZANTINE_MUSIC}', "");
    Error('\p{Block=:= CARIAN}');
    Error('\P{Block=:= CARIAN}');
    Expect(1, 66271, '\p{Block=:\ACarian\z:}', "");;
    Expect(0, 66272, '\p{Block=:\ACarian\z:}', "");;
    Expect(1, 66271, '\p{Block=carian}', "");
    Expect(0, 66271, '\p{^Block=carian}', "");
    Expect(0, 66271, '\P{Block=carian}', "");
    Expect(1, 66271, '\P{^Block=carian}', "");
    Expect(0, 66272, '\p{Block=carian}', "");
    Expect(1, 66272, '\p{^Block=carian}', "");
    Expect(1, 66272, '\P{Block=carian}', "");
    Expect(0, 66272, '\P{^Block=carian}', "");
    Expect(1, 66271, '\p{Block=:\Acarian\z:}', "");;
    Expect(0, 66272, '\p{Block=:\Acarian\z:}', "");;
    Expect(1, 66271, '\p{Block:	 	CARIAN}', "");
    Expect(0, 66271, '\p{^Block:	 	CARIAN}', "");
    Expect(0, 66271, '\P{Block:	 	CARIAN}', "");
    Expect(1, 66271, '\P{^Block:	 	CARIAN}', "");
    Expect(0, 66272, '\p{Block:	 	CARIAN}', "");
    Expect(1, 66272, '\p{^Block:	 	CARIAN}', "");
    Expect(1, 66272, '\P{Block:	 	CARIAN}', "");
    Expect(0, 66272, '\P{^Block:	 	CARIAN}', "");
    Error('\p{Blk=	:=Carian}');
    Error('\P{Blk=	:=Carian}');
    Expect(1, 66271, '\p{Blk=:\ACarian\z:}', "");;
    Expect(0, 66272, '\p{Blk=:\ACarian\z:}', "");;
    Expect(1, 66271, '\p{Blk=carian}', "");
    Expect(0, 66271, '\p{^Blk=carian}', "");
    Expect(0, 66271, '\P{Blk=carian}', "");
    Expect(1, 66271, '\P{^Blk=carian}', "");
    Expect(0, 66272, '\p{Blk=carian}', "");
    Expect(1, 66272, '\p{^Blk=carian}', "");
    Expect(1, 66272, '\P{Blk=carian}', "");
    Expect(0, 66272, '\P{^Blk=carian}', "");
    Expect(1, 66271, '\p{Blk=:\Acarian\z:}', "");;
    Expect(0, 66272, '\p{Blk=:\Acarian\z:}', "");;
    Expect(1, 66271, '\p{Blk=--Carian}', "");
    Expect(0, 66271, '\p{^Blk=--Carian}', "");
    Expect(0, 66271, '\P{Blk=--Carian}', "");
    Expect(1, 66271, '\P{^Blk=--Carian}', "");
    Expect(0, 66272, '\p{Blk=--Carian}', "");
    Expect(1, 66272, '\p{^Blk=--Carian}', "");
    Expect(1, 66272, '\P{Blk=--Carian}', "");
    Expect(0, 66272, '\P{^Blk=--Carian}', "");
    Error('\p{Is_Block=-_Carian:=}');
    Error('\P{Is_Block=-_Carian:=}');
    Expect(1, 66271, '\p{Is_Block=carian}', "");
    Expect(0, 66271, '\p{^Is_Block=carian}', "");
    Expect(0, 66271, '\P{Is_Block=carian}', "");
    Expect(1, 66271, '\P{^Is_Block=carian}', "");
    Expect(0, 66272, '\p{Is_Block=carian}', "");
    Expect(1, 66272, '\p{^Is_Block=carian}', "");
    Expect(1, 66272, '\P{Is_Block=carian}', "");
    Expect(0, 66272, '\P{^Is_Block=carian}', "");
    Expect(1, 66271, '\p{Is_Block:  CARIAN}', "");
    Expect(0, 66271, '\p{^Is_Block:  CARIAN}', "");
    Expect(0, 66271, '\P{Is_Block:  CARIAN}', "");
    Expect(1, 66271, '\P{^Is_Block:  CARIAN}', "");
    Expect(0, 66272, '\p{Is_Block:  CARIAN}', "");
    Expect(1, 66272, '\p{^Is_Block:  CARIAN}', "");
    Expect(1, 66272, '\P{Is_Block:  CARIAN}', "");
    Expect(0, 66272, '\P{^Is_Block:  CARIAN}', "");
    Error('\p{Is_Blk=:=_-Carian}');
    Error('\P{Is_Blk=:=_-Carian}');
    Expect(1, 66271, '\p{Is_Blk=carian}', "");
    Expect(0, 66271, '\p{^Is_Blk=carian}', "");
    Expect(0, 66271, '\P{Is_Blk=carian}', "");
    Expect(1, 66271, '\P{^Is_Blk=carian}', "");
    Expect(0, 66272, '\p{Is_Blk=carian}', "");
    Expect(1, 66272, '\p{^Is_Blk=carian}', "");
    Expect(1, 66272, '\P{Is_Blk=carian}', "");
    Expect(0, 66272, '\P{^Is_Blk=carian}', "");
    Expect(1, 66271, '\p{Is_Blk=-	CARIAN}', "");
    Expect(0, 66271, '\p{^Is_Blk=-	CARIAN}', "");
    Expect(0, 66271, '\P{Is_Blk=-	CARIAN}', "");
    Expect(1, 66271, '\P{^Is_Blk=-	CARIAN}', "");
    Expect(0, 66272, '\p{Is_Blk=-	CARIAN}', "");
    Expect(1, 66272, '\p{^Is_Blk=-	CARIAN}', "");
    Expect(1, 66272, '\P{Is_Blk=-	CARIAN}', "");
    Expect(0, 66272, '\P{^Is_Blk=-	CARIAN}', "");
    Error('\p{Block=_Caucasian_Albanian/a/}');
    Error('\P{Block=_Caucasian_Albanian/a/}');
    Expect(1, 66927, '\p{Block=:\ACaucasian_Albanian\z:}', "");;
    Expect(0, 66928, '\p{Block=:\ACaucasian_Albanian\z:}', "");;
    Expect(1, 66927, '\p{Block=caucasianalbanian}', "");
    Expect(0, 66927, '\p{^Block=caucasianalbanian}', "");
    Expect(0, 66927, '\P{Block=caucasianalbanian}', "");
    Expect(1, 66927, '\P{^Block=caucasianalbanian}', "");
    Expect(0, 66928, '\p{Block=caucasianalbanian}', "");
    Expect(1, 66928, '\p{^Block=caucasianalbanian}', "");
    Expect(1, 66928, '\P{Block=caucasianalbanian}', "");
    Expect(0, 66928, '\P{^Block=caucasianalbanian}', "");
    Expect(1, 66927, '\p{Block=:\Acaucasianalbanian\z:}', "");;
    Expect(0, 66928, '\p{Block=:\Acaucasianalbanian\z:}', "");;
    Expect(1, 66927, '\p{Block=-caucasian_albanian}', "");
    Expect(0, 66927, '\p{^Block=-caucasian_albanian}', "");
    Expect(0, 66927, '\P{Block=-caucasian_albanian}', "");
    Expect(1, 66927, '\P{^Block=-caucasian_albanian}', "");
    Expect(0, 66928, '\p{Block=-caucasian_albanian}', "");
    Expect(1, 66928, '\p{^Block=-caucasian_albanian}', "");
    Expect(1, 66928, '\P{Block=-caucasian_albanian}', "");
    Expect(0, 66928, '\P{^Block=-caucasian_albanian}', "");
    Error('\p{Blk: :=_-CAUCASIAN_Albanian}');
    Error('\P{Blk: :=_-CAUCASIAN_Albanian}');
    Expect(1, 66927, '\p{Blk=:\ACaucasian_Albanian\z:}', "");;
    Expect(0, 66928, '\p{Blk=:\ACaucasian_Albanian\z:}', "");;
    Expect(1, 66927, '\p{Blk=caucasianalbanian}', "");
    Expect(0, 66927, '\p{^Blk=caucasianalbanian}', "");
    Expect(0, 66927, '\P{Blk=caucasianalbanian}', "");
    Expect(1, 66927, '\P{^Blk=caucasianalbanian}', "");
    Expect(0, 66928, '\p{Blk=caucasianalbanian}', "");
    Expect(1, 66928, '\p{^Blk=caucasianalbanian}', "");
    Expect(1, 66928, '\P{Blk=caucasianalbanian}', "");
    Expect(0, 66928, '\P{^Blk=caucasianalbanian}', "");
    Expect(1, 66927, '\p{Blk=:\Acaucasianalbanian\z:}', "");;
    Expect(0, 66928, '\p{Blk=:\Acaucasianalbanian\z:}', "");;
    Expect(1, 66927, '\p{Blk= -Caucasian_albanian}', "");
    Expect(0, 66927, '\p{^Blk= -Caucasian_albanian}', "");
    Expect(0, 66927, '\P{Blk= -Caucasian_albanian}', "");
    Expect(1, 66927, '\P{^Blk= -Caucasian_albanian}', "");
    Expect(0, 66928, '\p{Blk= -Caucasian_albanian}', "");
    Expect(1, 66928, '\p{^Blk= -Caucasian_albanian}', "");
    Expect(1, 66928, '\P{Blk= -Caucasian_albanian}', "");
    Expect(0, 66928, '\P{^Blk= -Caucasian_albanian}', "");
    Error('\p{Is_Block=:=_	Caucasian_ALBANIAN}');
    Error('\P{Is_Block=:=_	Caucasian_ALBANIAN}');
    Expect(1, 66927, '\p{Is_Block=caucasianalbanian}', "");
    Expect(0, 66927, '\p{^Is_Block=caucasianalbanian}', "");
    Expect(0, 66927, '\P{Is_Block=caucasianalbanian}', "");
    Expect(1, 66927, '\P{^Is_Block=caucasianalbanian}', "");
    Expect(0, 66928, '\p{Is_Block=caucasianalbanian}', "");
    Expect(1, 66928, '\p{^Is_Block=caucasianalbanian}', "");
    Expect(1, 66928, '\P{Is_Block=caucasianalbanian}', "");
    Expect(0, 66928, '\P{^Is_Block=caucasianalbanian}', "");
    Expect(1, 66927, '\p{Is_Block=- CAUCASIAN_ALBANIAN}', "");
    Expect(0, 66927, '\p{^Is_Block=- CAUCASIAN_ALBANIAN}', "");
    Expect(0, 66927, '\P{Is_Block=- CAUCASIAN_ALBANIAN}', "");
    Expect(1, 66927, '\P{^Is_Block=- CAUCASIAN_ALBANIAN}', "");
    Expect(0, 66928, '\p{Is_Block=- CAUCASIAN_ALBANIAN}', "");
    Expect(1, 66928, '\p{^Is_Block=- CAUCASIAN_ALBANIAN}', "");
    Expect(1, 66928, '\P{Is_Block=- CAUCASIAN_ALBANIAN}', "");
    Expect(0, 66928, '\P{^Is_Block=- CAUCASIAN_ALBANIAN}', "");
    Error('\p{Is_Blk=_/a/Caucasian_Albanian}');
    Error('\P{Is_Blk=_/a/Caucasian_Albanian}');
    Expect(1, 66927, '\p{Is_Blk=caucasianalbanian}', "");
    Expect(0, 66927, '\p{^Is_Blk=caucasianalbanian}', "");
    Expect(0, 66927, '\P{Is_Blk=caucasianalbanian}', "");
    Expect(1, 66927, '\P{^Is_Blk=caucasianalbanian}', "");
    Expect(0, 66928, '\p{Is_Blk=caucasianalbanian}', "");
    Expect(1, 66928, '\p{^Is_Blk=caucasianalbanian}', "");
    Expect(1, 66928, '\P{Is_Blk=caucasianalbanian}', "");
    Expect(0, 66928, '\P{^Is_Blk=caucasianalbanian}', "");
    Expect(1, 66927, '\p{Is_Blk=_CAUCASIAN_ALBANIAN}', "");
    Expect(0, 66927, '\p{^Is_Blk=_CAUCASIAN_ALBANIAN}', "");
    Expect(0, 66927, '\P{Is_Blk=_CAUCASIAN_ALBANIAN}', "");
    Expect(1, 66927, '\P{^Is_Blk=_CAUCASIAN_ALBANIAN}', "");
    Expect(0, 66928, '\p{Is_Blk=_CAUCASIAN_ALBANIAN}', "");
    Expect(1, 66928, '\p{^Is_Blk=_CAUCASIAN_ALBANIAN}', "");
    Expect(1, 66928, '\P{Is_Blk=_CAUCASIAN_ALBANIAN}', "");
    Expect(0, 66928, '\P{^Is_Blk=_CAUCASIAN_ALBANIAN}', "");
    Error('\p{Block=/a/Chakma}');
    Error('\P{Block=/a/Chakma}');
    Expect(1, 69967, '\p{Block=:\AChakma\z:}', "");;
    Expect(0, 69968, '\p{Block=:\AChakma\z:}', "");;
    Expect(1, 69967, '\p{Block=chakma}', "");
    Expect(0, 69967, '\p{^Block=chakma}', "");
    Expect(0, 69967, '\P{Block=chakma}', "");
    Expect(1, 69967, '\P{^Block=chakma}', "");
    Expect(0, 69968, '\p{Block=chakma}', "");
    Expect(1, 69968, '\p{^Block=chakma}', "");
    Expect(1, 69968, '\P{Block=chakma}', "");
    Expect(0, 69968, '\P{^Block=chakma}', "");
    Expect(1, 69967, '\p{Block=:\Achakma\z:}', "");;
    Expect(0, 69968, '\p{Block=:\Achakma\z:}', "");;
    Expect(1, 69967, '\p{Block=	 chakma}', "");
    Expect(0, 69967, '\p{^Block=	 chakma}', "");
    Expect(0, 69967, '\P{Block=	 chakma}', "");
    Expect(1, 69967, '\P{^Block=	 chakma}', "");
    Expect(0, 69968, '\p{Block=	 chakma}', "");
    Expect(1, 69968, '\p{^Block=	 chakma}', "");
    Expect(1, 69968, '\P{Block=	 chakma}', "");
    Expect(0, 69968, '\P{^Block=	 chakma}', "");
    Error('\p{Blk=_Chakma/a/}');
    Error('\P{Blk=_Chakma/a/}');
    Expect(1, 69967, '\p{Blk=:\AChakma\z:}', "");;
    Expect(0, 69968, '\p{Blk=:\AChakma\z:}', "");;
    Expect(1, 69967, '\p{Blk=chakma}', "");
    Expect(0, 69967, '\p{^Blk=chakma}', "");
    Expect(0, 69967, '\P{Blk=chakma}', "");
    Expect(1, 69967, '\P{^Blk=chakma}', "");
    Expect(0, 69968, '\p{Blk=chakma}', "");
    Expect(1, 69968, '\p{^Blk=chakma}', "");
    Expect(1, 69968, '\P{Blk=chakma}', "");
    Expect(0, 69968, '\P{^Blk=chakma}', "");
    Expect(1, 69967, '\p{Blk=:\Achakma\z:}', "");;
    Expect(0, 69968, '\p{Blk=:\Achakma\z:}', "");;
    Expect(1, 69967, '\p{Blk=	_Chakma}', "");
    Expect(0, 69967, '\p{^Blk=	_Chakma}', "");
    Expect(0, 69967, '\P{Blk=	_Chakma}', "");
    Expect(1, 69967, '\P{^Blk=	_Chakma}', "");
    Expect(0, 69968, '\p{Blk=	_Chakma}', "");
    Expect(1, 69968, '\p{^Blk=	_Chakma}', "");
    Expect(1, 69968, '\P{Blk=	_Chakma}', "");
    Expect(0, 69968, '\P{^Blk=	_Chakma}', "");
    Error('\p{Is_Block=:=	-Chakma}');
    Error('\P{Is_Block=:=	-Chakma}');
    Expect(1, 69967, '\p{Is_Block=chakma}', "");
    Expect(0, 69967, '\p{^Is_Block=chakma}', "");
    Expect(0, 69967, '\P{Is_Block=chakma}', "");
    Expect(1, 69967, '\P{^Is_Block=chakma}', "");
    Expect(0, 69968, '\p{Is_Block=chakma}', "");
    Expect(1, 69968, '\p{^Is_Block=chakma}', "");
    Expect(1, 69968, '\P{Is_Block=chakma}', "");
    Expect(0, 69968, '\P{^Is_Block=chakma}', "");
    Expect(1, 69967, '\p{Is_Block= _chakma}', "");
    Expect(0, 69967, '\p{^Is_Block= _chakma}', "");
    Expect(0, 69967, '\P{Is_Block= _chakma}', "");
    Expect(1, 69967, '\P{^Is_Block= _chakma}', "");
    Expect(0, 69968, '\p{Is_Block= _chakma}', "");
    Expect(1, 69968, '\p{^Is_Block= _chakma}', "");
    Expect(1, 69968, '\P{Is_Block= _chakma}', "");
    Expect(0, 69968, '\P{^Is_Block= _chakma}', "");
    Error('\p{Is_Blk=:= -Chakma}');
    Error('\P{Is_Blk=:= -Chakma}');
    Expect(1, 69967, '\p{Is_Blk=chakma}', "");
    Expect(0, 69967, '\p{^Is_Blk=chakma}', "");
    Expect(0, 69967, '\P{Is_Blk=chakma}', "");
    Expect(1, 69967, '\P{^Is_Blk=chakma}', "");
    Expect(0, 69968, '\p{Is_Blk=chakma}', "");
    Expect(1, 69968, '\p{^Is_Blk=chakma}', "");
    Expect(1, 69968, '\P{Is_Blk=chakma}', "");
    Expect(0, 69968, '\P{^Is_Blk=chakma}', "");
    Expect(1, 69967, '\p{Is_Blk=	-Chakma}', "");
    Expect(0, 69967, '\p{^Is_Blk=	-Chakma}', "");
    Expect(0, 69967, '\P{Is_Blk=	-Chakma}', "");
    Expect(1, 69967, '\P{^Is_Blk=	-Chakma}', "");
    Expect(0, 69968, '\p{Is_Blk=	-Chakma}', "");
    Expect(1, 69968, '\p{^Is_Blk=	-Chakma}', "");
    Expect(1, 69968, '\P{Is_Blk=	-Chakma}', "");
    Expect(0, 69968, '\P{^Is_Blk=	-Chakma}', "");
    Error('\p{Block=:=_-CHAM}');
    Error('\P{Block=:=_-CHAM}');
    Expect(1, 43615, '\p{Block=:\ACham\z:}', "");;
    Expect(0, 43616, '\p{Block=:\ACham\z:}', "");;
    Expect(1, 43615, '\p{Block=cham}', "");
    Expect(0, 43615, '\p{^Block=cham}', "");
    Expect(0, 43615, '\P{Block=cham}', "");
    Expect(1, 43615, '\P{^Block=cham}', "");
    Expect(0, 43616, '\p{Block=cham}', "");
    Expect(1, 43616, '\p{^Block=cham}', "");
    Expect(1, 43616, '\P{Block=cham}', "");
    Expect(0, 43616, '\P{^Block=cham}', "");
    Expect(1, 43615, '\p{Block=:\Acham\z:}', "");;
    Expect(0, 43616, '\p{Block=:\Acham\z:}', "");;
    Expect(1, 43615, '\p{Block= 	Cham}', "");
    Expect(0, 43615, '\p{^Block= 	Cham}', "");
    Expect(0, 43615, '\P{Block= 	Cham}', "");
    Expect(1, 43615, '\P{^Block= 	Cham}', "");
    Expect(0, 43616, '\p{Block= 	Cham}', "");
    Expect(1, 43616, '\p{^Block= 	Cham}', "");
    Expect(1, 43616, '\P{Block= 	Cham}', "");
    Expect(0, 43616, '\P{^Block= 	Cham}', "");
    Error('\p{Blk=_:=cham}');
    Error('\P{Blk=_:=cham}');
    Expect(1, 43615, '\p{Blk=:\ACham\z:}', "");;
    Expect(0, 43616, '\p{Blk=:\ACham\z:}', "");;
    Expect(1, 43615, '\p{Blk=cham}', "");
    Expect(0, 43615, '\p{^Blk=cham}', "");
    Expect(0, 43615, '\P{Blk=cham}', "");
    Expect(1, 43615, '\P{^Blk=cham}', "");
    Expect(0, 43616, '\p{Blk=cham}', "");
    Expect(1, 43616, '\p{^Blk=cham}', "");
    Expect(1, 43616, '\P{Blk=cham}', "");
    Expect(0, 43616, '\P{^Blk=cham}', "");
    Expect(1, 43615, '\p{Blk=:\Acham\z:}', "");;
    Expect(0, 43616, '\p{Blk=:\Acham\z:}', "");;
    Expect(1, 43615, '\p{Blk: 	Cham}', "");
    Expect(0, 43615, '\p{^Blk: 	Cham}', "");
    Expect(0, 43615, '\P{Blk: 	Cham}', "");
    Expect(1, 43615, '\P{^Blk: 	Cham}', "");
    Expect(0, 43616, '\p{Blk: 	Cham}', "");
    Expect(1, 43616, '\p{^Blk: 	Cham}', "");
    Expect(1, 43616, '\P{Blk: 	Cham}', "");
    Expect(0, 43616, '\P{^Blk: 	Cham}', "");
    Error('\p{Is_Block=-:=Cham}');
    Error('\P{Is_Block=-:=Cham}');
    Expect(1, 43615, '\p{Is_Block=cham}', "");
    Expect(0, 43615, '\p{^Is_Block=cham}', "");
    Expect(0, 43615, '\P{Is_Block=cham}', "");
    Expect(1, 43615, '\P{^Is_Block=cham}', "");
    Expect(0, 43616, '\p{Is_Block=cham}', "");
    Expect(1, 43616, '\p{^Is_Block=cham}', "");
    Expect(1, 43616, '\P{Is_Block=cham}', "");
    Expect(0, 43616, '\P{^Is_Block=cham}', "");
    Expect(1, 43615, '\p{Is_Block= 	Cham}', "");
    Expect(0, 43615, '\p{^Is_Block= 	Cham}', "");
    Expect(0, 43615, '\P{Is_Block= 	Cham}', "");
    Expect(1, 43615, '\P{^Is_Block= 	Cham}', "");
    Expect(0, 43616, '\p{Is_Block= 	Cham}', "");
    Expect(1, 43616, '\p{^Is_Block= 	Cham}', "");
    Expect(1, 43616, '\P{Is_Block= 	Cham}', "");
    Expect(0, 43616, '\P{^Is_Block= 	Cham}', "");
    Error('\p{Is_Blk=:=	_Cham}');
    Error('\P{Is_Blk=:=	_Cham}');
    Expect(1, 43615, '\p{Is_Blk=cham}', "");
    Expect(0, 43615, '\p{^Is_Blk=cham}', "");
    Expect(0, 43615, '\P{Is_Blk=cham}', "");
    Expect(1, 43615, '\P{^Is_Blk=cham}', "");
    Expect(0, 43616, '\p{Is_Blk=cham}', "");
    Expect(1, 43616, '\p{^Is_Blk=cham}', "");
    Expect(1, 43616, '\P{Is_Blk=cham}', "");
    Expect(0, 43616, '\P{^Is_Blk=cham}', "");
    Expect(1, 43615, '\p{Is_Blk=	 cham}', "");
    Expect(0, 43615, '\p{^Is_Blk=	 cham}', "");
    Expect(0, 43615, '\P{Is_Blk=	 cham}', "");
    Expect(1, 43615, '\P{^Is_Blk=	 cham}', "");
    Expect(0, 43616, '\p{Is_Blk=	 cham}', "");
    Expect(1, 43616, '\p{^Is_Blk=	 cham}', "");
    Expect(1, 43616, '\P{Is_Blk=	 cham}', "");
    Expect(0, 43616, '\P{^Is_Blk=	 cham}', "");
    Error('\p{Block:   	/a/Cherokee}');
    Error('\P{Block:   	/a/Cherokee}');
    Expect(1, 5119, '\p{Block=:\ACherokee\z:}', "");;
    Expect(0, 5120, '\p{Block=:\ACherokee\z:}', "");;
    Expect(1, 5119, '\p{Block=cherokee}', "");
    Expect(0, 5119, '\p{^Block=cherokee}', "");
    Expect(0, 5119, '\P{Block=cherokee}', "");
    Expect(1, 5119, '\P{^Block=cherokee}', "");
    Expect(0, 5120, '\p{Block=cherokee}', "");
    Expect(1, 5120, '\p{^Block=cherokee}', "");
    Expect(1, 5120, '\P{Block=cherokee}', "");
    Expect(0, 5120, '\P{^Block=cherokee}', "");
    Expect(1, 5119, '\p{Block=:\Acherokee\z:}', "");;
    Expect(0, 5120, '\p{Block=:\Acherokee\z:}', "");;
    Expect(1, 5119, '\p{Block=		CHEROKEE}', "");
    Expect(0, 5119, '\p{^Block=		CHEROKEE}', "");
    Expect(0, 5119, '\P{Block=		CHEROKEE}', "");
    Expect(1, 5119, '\P{^Block=		CHEROKEE}', "");
    Expect(0, 5120, '\p{Block=		CHEROKEE}', "");
    Expect(1, 5120, '\p{^Block=		CHEROKEE}', "");
    Expect(1, 5120, '\P{Block=		CHEROKEE}', "");
    Expect(0, 5120, '\P{^Block=		CHEROKEE}', "");
    Error('\p{Blk=:=-	CHEROKEE}');
    Error('\P{Blk=:=-	CHEROKEE}');
    Expect(1, 5119, '\p{Blk=:\ACherokee\z:}', "");;
    Expect(0, 5120, '\p{Blk=:\ACherokee\z:}', "");;
    Expect(1, 5119, '\p{Blk=cherokee}', "");
    Expect(0, 5119, '\p{^Blk=cherokee}', "");
    Expect(0, 5119, '\P{Blk=cherokee}', "");
    Expect(1, 5119, '\P{^Blk=cherokee}', "");
    Expect(0, 5120, '\p{Blk=cherokee}', "");
    Expect(1, 5120, '\p{^Blk=cherokee}', "");
    Expect(1, 5120, '\P{Blk=cherokee}', "");
    Expect(0, 5120, '\P{^Blk=cherokee}', "");
    Expect(1, 5119, '\p{Blk=:\Acherokee\z:}', "");;
    Expect(0, 5120, '\p{Blk=:\Acherokee\z:}', "");;
    Expect(1, 5119, '\p{Blk=-_cherokee}', "");
    Expect(0, 5119, '\p{^Blk=-_cherokee}', "");
    Expect(0, 5119, '\P{Blk=-_cherokee}', "");
    Expect(1, 5119, '\P{^Blk=-_cherokee}', "");
    Expect(0, 5120, '\p{Blk=-_cherokee}', "");
    Expect(1, 5120, '\p{^Blk=-_cherokee}', "");
    Expect(1, 5120, '\P{Blk=-_cherokee}', "");
    Expect(0, 5120, '\P{^Blk=-_cherokee}', "");
    Error('\p{Is_Block=	-cherokee:=}');
    Error('\P{Is_Block=	-cherokee:=}');
    Expect(1, 5119, '\p{Is_Block=cherokee}', "");
    Expect(0, 5119, '\p{^Is_Block=cherokee}', "");
    Expect(0, 5119, '\P{Is_Block=cherokee}', "");
    Expect(1, 5119, '\P{^Is_Block=cherokee}', "");
    Expect(0, 5120, '\p{Is_Block=cherokee}', "");
    Expect(1, 5120, '\p{^Is_Block=cherokee}', "");
    Expect(1, 5120, '\P{Is_Block=cherokee}', "");
    Expect(0, 5120, '\P{^Is_Block=cherokee}', "");
    Expect(1, 5119, '\p{Is_Block=  Cherokee}', "");
    Expect(0, 5119, '\p{^Is_Block=  Cherokee}', "");
    Expect(0, 5119, '\P{Is_Block=  Cherokee}', "");
    Expect(1, 5119, '\P{^Is_Block=  Cherokee}', "");
    Expect(0, 5120, '\p{Is_Block=  Cherokee}', "");
    Expect(1, 5120, '\p{^Is_Block=  Cherokee}', "");
    Expect(1, 5120, '\P{Is_Block=  Cherokee}', "");
    Expect(0, 5120, '\P{^Is_Block=  Cherokee}', "");
    Error('\p{Is_Blk=_	Cherokee/a/}');
    Error('\P{Is_Blk=_	Cherokee/a/}');
    Expect(1, 5119, '\p{Is_Blk=cherokee}', "");
    Expect(0, 5119, '\p{^Is_Blk=cherokee}', "");
    Expect(0, 5119, '\P{Is_Blk=cherokee}', "");
    Expect(1, 5119, '\P{^Is_Blk=cherokee}', "");
    Expect(0, 5120, '\p{Is_Blk=cherokee}', "");
    Expect(1, 5120, '\p{^Is_Blk=cherokee}', "");
    Expect(1, 5120, '\P{Is_Blk=cherokee}', "");
    Expect(0, 5120, '\P{^Is_Blk=cherokee}', "");
    Expect(1, 5119, '\p{Is_Blk=	-CHEROKEE}', "");
    Expect(0, 5119, '\p{^Is_Blk=	-CHEROKEE}', "");
    Expect(0, 5119, '\P{Is_Blk=	-CHEROKEE}', "");
    Expect(1, 5119, '\P{^Is_Blk=	-CHEROKEE}', "");
    Expect(0, 5120, '\p{Is_Blk=	-CHEROKEE}', "");
    Expect(1, 5120, '\p{^Is_Blk=	-CHEROKEE}', "");
    Expect(1, 5120, '\P{Is_Blk=	-CHEROKEE}', "");
    Expect(0, 5120, '\P{^Is_Blk=	-CHEROKEE}', "");
    Error('\p{Block=	:=Cherokee_Supplement}');
    Error('\P{Block=	:=Cherokee_Supplement}');
    Expect(1, 43967, '\p{Block=:\ACherokee_Supplement\z:}', "");;
    Expect(0, 43968, '\p{Block=:\ACherokee_Supplement\z:}', "");;
    Expect(1, 43967, '\p{Block=cherokeesupplement}', "");
    Expect(0, 43967, '\p{^Block=cherokeesupplement}', "");
    Expect(0, 43967, '\P{Block=cherokeesupplement}', "");
    Expect(1, 43967, '\P{^Block=cherokeesupplement}', "");
    Expect(0, 43968, '\p{Block=cherokeesupplement}', "");
    Expect(1, 43968, '\p{^Block=cherokeesupplement}', "");
    Expect(1, 43968, '\P{Block=cherokeesupplement}', "");
    Expect(0, 43968, '\P{^Block=cherokeesupplement}', "");
    Expect(1, 43967, '\p{Block=:\Acherokeesupplement\z:}', "");;
    Expect(0, 43968, '\p{Block=:\Acherokeesupplement\z:}', "");;
    Expect(1, 43967, '\p{Block= CHEROKEE_Supplement}', "");
    Expect(0, 43967, '\p{^Block= CHEROKEE_Supplement}', "");
    Expect(0, 43967, '\P{Block= CHEROKEE_Supplement}', "");
    Expect(1, 43967, '\P{^Block= CHEROKEE_Supplement}', "");
    Expect(0, 43968, '\p{Block= CHEROKEE_Supplement}', "");
    Expect(1, 43968, '\p{^Block= CHEROKEE_Supplement}', "");
    Expect(1, 43968, '\P{Block= CHEROKEE_Supplement}', "");
    Expect(0, 43968, '\P{^Block= CHEROKEE_Supplement}', "");
    Error('\p{Blk=- CHEROKEE_Sup:=}');
    Error('\P{Blk=- CHEROKEE_Sup:=}');
    Expect(1, 43967, '\p{Blk=:\ACherokee_Sup\z:}', "");;
    Expect(0, 43968, '\p{Blk=:\ACherokee_Sup\z:}', "");;
    Expect(1, 43967, '\p{Blk:	cherokeesup}', "");
    Expect(0, 43967, '\p{^Blk:	cherokeesup}', "");
    Expect(0, 43967, '\P{Blk:	cherokeesup}', "");
    Expect(1, 43967, '\P{^Blk:	cherokeesup}', "");
    Expect(0, 43968, '\p{Blk:	cherokeesup}', "");
    Expect(1, 43968, '\p{^Blk:	cherokeesup}', "");
    Expect(1, 43968, '\P{Blk:	cherokeesup}', "");
    Expect(0, 43968, '\P{^Blk:	cherokeesup}', "");
    Expect(1, 43967, '\p{Blk=:\Acherokeesup\z:}', "");;
    Expect(0, 43968, '\p{Blk=:\Acherokeesup\z:}', "");;
    Expect(1, 43967, '\p{Blk= 	Cherokee_Sup}', "");
    Expect(0, 43967, '\p{^Blk= 	Cherokee_Sup}', "");
    Expect(0, 43967, '\P{Blk= 	Cherokee_Sup}', "");
    Expect(1, 43967, '\P{^Blk= 	Cherokee_Sup}', "");
    Expect(0, 43968, '\p{Blk= 	Cherokee_Sup}', "");
    Expect(1, 43968, '\p{^Blk= 	Cherokee_Sup}', "");
    Expect(1, 43968, '\P{Blk= 	Cherokee_Sup}', "");
    Expect(0, 43968, '\P{^Blk= 	Cherokee_Sup}', "");
    Error('\p{Is_Block= :=cherokee_Supplement}');
    Error('\P{Is_Block= :=cherokee_Supplement}');
    Expect(1, 43967, '\p{Is_Block:cherokeesupplement}', "");
    Expect(0, 43967, '\p{^Is_Block:cherokeesupplement}', "");
    Expect(0, 43967, '\P{Is_Block:cherokeesupplement}', "");
    Expect(1, 43967, '\P{^Is_Block:cherokeesupplement}', "");
    Expect(0, 43968, '\p{Is_Block:cherokeesupplement}', "");
    Expect(1, 43968, '\p{^Is_Block:cherokeesupplement}', "");
    Expect(1, 43968, '\P{Is_Block:cherokeesupplement}', "");
    Expect(0, 43968, '\P{^Is_Block:cherokeesupplement}', "");
    Expect(1, 43967, '\p{Is_Block= -cherokee_Supplement}', "");
    Expect(0, 43967, '\p{^Is_Block= -cherokee_Supplement}', "");
    Expect(0, 43967, '\P{Is_Block= -cherokee_Supplement}', "");
    Expect(1, 43967, '\P{^Is_Block= -cherokee_Supplement}', "");
    Expect(0, 43968, '\p{Is_Block= -cherokee_Supplement}', "");
    Expect(1, 43968, '\p{^Is_Block= -cherokee_Supplement}', "");
    Expect(1, 43968, '\P{Is_Block= -cherokee_Supplement}', "");
    Expect(0, 43968, '\P{^Is_Block= -cherokee_Supplement}', "");
    Error('\p{Is_Blk=:= -cherokee_SUP}');
    Error('\P{Is_Blk=:= -cherokee_SUP}');
    Expect(1, 43967, '\p{Is_Blk:cherokeesup}', "");
    Expect(0, 43967, '\p{^Is_Blk:cherokeesup}', "");
    Expect(0, 43967, '\P{Is_Blk:cherokeesup}', "");
    Expect(1, 43967, '\P{^Is_Blk:cherokeesup}', "");
    Expect(0, 43968, '\p{Is_Blk:cherokeesup}', "");
    Expect(1, 43968, '\p{^Is_Blk:cherokeesup}', "");
    Expect(1, 43968, '\P{Is_Blk:cherokeesup}', "");
    Expect(0, 43968, '\P{^Is_Blk:cherokeesup}', "");
    Expect(1, 43967, '\p{Is_Blk=  CHEROKEE_sup}', "");
    Expect(0, 43967, '\p{^Is_Blk=  CHEROKEE_sup}', "");
    Expect(0, 43967, '\P{Is_Blk=  CHEROKEE_sup}', "");
    Expect(1, 43967, '\P{^Is_Blk=  CHEROKEE_sup}', "");
    Expect(0, 43968, '\p{Is_Blk=  CHEROKEE_sup}', "");
    Expect(1, 43968, '\p{^Is_Blk=  CHEROKEE_sup}', "");
    Expect(1, 43968, '\P{Is_Blk=  CHEROKEE_sup}', "");
    Expect(0, 43968, '\P{^Is_Blk=  CHEROKEE_sup}', "");
    Error('\p{Block: _:=CHESS_Symbols}');
    Error('\P{Block: _:=CHESS_Symbols}');
    Expect(1, 129647, '\p{Block=:\AChess_Symbols\z:}', "");;
    Expect(0, 129648, '\p{Block=:\AChess_Symbols\z:}', "");;
    Expect(1, 129647, '\p{Block:   chesssymbols}', "");
    Expect(0, 129647, '\p{^Block:   chesssymbols}', "");
    Expect(0, 129647, '\P{Block:   chesssymbols}', "");
    Expect(1, 129647, '\P{^Block:   chesssymbols}', "");
    Expect(0, 129648, '\p{Block:   chesssymbols}', "");
    Expect(1, 129648, '\p{^Block:   chesssymbols}', "");
    Expect(1, 129648, '\P{Block:   chesssymbols}', "");
    Expect(0, 129648, '\P{^Block:   chesssymbols}', "");
    Expect(1, 129647, '\p{Block=:\Achesssymbols\z:}', "");;
    Expect(0, 129648, '\p{Block=:\Achesssymbols\z:}', "");;
    Expect(1, 129647, '\p{Block= -CHESS_Symbols}', "");
    Expect(0, 129647, '\p{^Block= -CHESS_Symbols}', "");
    Expect(0, 129647, '\P{Block= -CHESS_Symbols}', "");
    Expect(1, 129647, '\P{^Block= -CHESS_Symbols}', "");
    Expect(0, 129648, '\p{Block= -CHESS_Symbols}', "");
    Expect(1, 129648, '\p{^Block= -CHESS_Symbols}', "");
    Expect(1, 129648, '\P{Block= -CHESS_Symbols}', "");
    Expect(0, 129648, '\P{^Block= -CHESS_Symbols}', "");
    Error('\p{Blk:	:=chess_Symbols}');
    Error('\P{Blk:	:=chess_Symbols}');
    Expect(1, 129647, '\p{Blk=:\AChess_Symbols\z:}', "");;
    Expect(0, 129648, '\p{Blk=:\AChess_Symbols\z:}', "");;
    Expect(1, 129647, '\p{Blk=chesssymbols}', "");
    Expect(0, 129647, '\p{^Blk=chesssymbols}', "");
    Expect(0, 129647, '\P{Blk=chesssymbols}', "");
    Expect(1, 129647, '\P{^Blk=chesssymbols}', "");
    Expect(0, 129648, '\p{Blk=chesssymbols}', "");
    Expect(1, 129648, '\p{^Blk=chesssymbols}', "");
    Expect(1, 129648, '\P{Blk=chesssymbols}', "");
    Expect(0, 129648, '\P{^Blk=chesssymbols}', "");
    Expect(1, 129647, '\p{Blk=:\Achesssymbols\z:}', "");;
    Expect(0, 129648, '\p{Blk=:\Achesssymbols\z:}', "");;
    Expect(1, 129647, '\p{Blk=--Chess_Symbols}', "");
    Expect(0, 129647, '\p{^Blk=--Chess_Symbols}', "");
    Expect(0, 129647, '\P{Blk=--Chess_Symbols}', "");
    Expect(1, 129647, '\P{^Blk=--Chess_Symbols}', "");
    Expect(0, 129648, '\p{Blk=--Chess_Symbols}', "");
    Expect(1, 129648, '\p{^Blk=--Chess_Symbols}', "");
    Expect(1, 129648, '\P{Blk=--Chess_Symbols}', "");
    Expect(0, 129648, '\P{^Blk=--Chess_Symbols}', "");
    Error('\p{Is_Block=/a/__chess_SYMBOLS}');
    Error('\P{Is_Block=/a/__chess_SYMBOLS}');
    Expect(1, 129647, '\p{Is_Block=chesssymbols}', "");
    Expect(0, 129647, '\p{^Is_Block=chesssymbols}', "");
    Expect(0, 129647, '\P{Is_Block=chesssymbols}', "");
    Expect(1, 129647, '\P{^Is_Block=chesssymbols}', "");
    Expect(0, 129648, '\p{Is_Block=chesssymbols}', "");
    Expect(1, 129648, '\p{^Is_Block=chesssymbols}', "");
    Expect(1, 129648, '\P{Is_Block=chesssymbols}', "");
    Expect(0, 129648, '\P{^Is_Block=chesssymbols}', "");
    Expect(1, 129647, '\p{Is_Block: Chess_Symbols}', "");
    Expect(0, 129647, '\p{^Is_Block: Chess_Symbols}', "");
    Expect(0, 129647, '\P{Is_Block: Chess_Symbols}', "");
    Expect(1, 129647, '\P{^Is_Block: Chess_Symbols}', "");
    Expect(0, 129648, '\p{Is_Block: Chess_Symbols}', "");
    Expect(1, 129648, '\p{^Is_Block: Chess_Symbols}', "");
    Expect(1, 129648, '\P{Is_Block: Chess_Symbols}', "");
    Expect(0, 129648, '\P{^Is_Block: Chess_Symbols}', "");
    Error('\p{Is_Blk=	/a/CHESS_SYMBOLS}');
    Error('\P{Is_Blk=	/a/CHESS_SYMBOLS}');
    Expect(1, 129647, '\p{Is_Blk=chesssymbols}', "");
    Expect(0, 129647, '\p{^Is_Blk=chesssymbols}', "");
    Expect(0, 129647, '\P{Is_Blk=chesssymbols}', "");
    Expect(1, 129647, '\P{^Is_Blk=chesssymbols}', "");
    Expect(0, 129648, '\p{Is_Blk=chesssymbols}', "");
    Expect(1, 129648, '\p{^Is_Blk=chesssymbols}', "");
    Expect(1, 129648, '\P{Is_Blk=chesssymbols}', "");
    Expect(0, 129648, '\P{^Is_Blk=chesssymbols}', "");
    Expect(1, 129647, '\p{Is_Blk= 	Chess_SYMBOLS}', "");
    Expect(0, 129647, '\p{^Is_Blk= 	Chess_SYMBOLS}', "");
    Expect(0, 129647, '\P{Is_Blk= 	Chess_SYMBOLS}', "");
    Expect(1, 129647, '\P{^Is_Blk= 	Chess_SYMBOLS}', "");
    Expect(0, 129648, '\p{Is_Blk= 	Chess_SYMBOLS}', "");
    Expect(1, 129648, '\p{^Is_Blk= 	Chess_SYMBOLS}', "");
    Expect(1, 129648, '\P{Is_Blk= 	Chess_SYMBOLS}', "");
    Expect(0, 129648, '\P{^Is_Blk= 	Chess_SYMBOLS}', "");
    Error('\p{Block:	 chorasmian:=}');
    Error('\P{Block:	 chorasmian:=}');
    Expect(1, 69599, '\p{Block=:\AChorasmian\z:}', "");;
    Expect(0, 69600, '\p{Block=:\AChorasmian\z:}', "");;
    Expect(1, 69599, '\p{Block=chorasmian}', "");
    Expect(0, 69599, '\p{^Block=chorasmian}', "");
    Expect(0, 69599, '\P{Block=chorasmian}', "");
    Expect(1, 69599, '\P{^Block=chorasmian}', "");
    Expect(0, 69600, '\p{Block=chorasmian}', "");
    Expect(1, 69600, '\p{^Block=chorasmian}', "");
    Expect(1, 69600, '\P{Block=chorasmian}', "");
    Expect(0, 69600, '\P{^Block=chorasmian}', "");
    Expect(1, 69599, '\p{Block=:\Achorasmian\z:}', "");;
    Expect(0, 69600, '\p{Block=:\Achorasmian\z:}', "");;
    Expect(1, 69599, '\p{Block:			Chorasmian}', "");
    Expect(0, 69599, '\p{^Block:			Chorasmian}', "");
    Expect(0, 69599, '\P{Block:			Chorasmian}', "");
    Expect(1, 69599, '\P{^Block:			Chorasmian}', "");
    Expect(0, 69600, '\p{Block:			Chorasmian}', "");
    Expect(1, 69600, '\p{^Block:			Chorasmian}', "");
    Expect(1, 69600, '\P{Block:			Chorasmian}', "");
    Expect(0, 69600, '\P{^Block:			Chorasmian}', "");
    Error('\p{Blk=-Chorasmian:=}');
    Error('\P{Blk=-Chorasmian:=}');
    Expect(1, 69599, '\p{Blk=:\AChorasmian\z:}', "");;
    Expect(0, 69600, '\p{Blk=:\AChorasmian\z:}', "");;
    Expect(1, 69599, '\p{Blk=chorasmian}', "");
    Expect(0, 69599, '\p{^Blk=chorasmian}', "");
    Expect(0, 69599, '\P{Blk=chorasmian}', "");
    Expect(1, 69599, '\P{^Blk=chorasmian}', "");
    Expect(0, 69600, '\p{Blk=chorasmian}', "");
    Expect(1, 69600, '\p{^Blk=chorasmian}', "");
    Expect(1, 69600, '\P{Blk=chorasmian}', "");
    Expect(0, 69600, '\P{^Blk=chorasmian}', "");
    Expect(1, 69599, '\p{Blk=:\Achorasmian\z:}', "");;
    Expect(0, 69600, '\p{Blk=:\Achorasmian\z:}', "");;
    Expect(1, 69599, '\p{Blk=	Chorasmian}', "");
    Expect(0, 69599, '\p{^Blk=	Chorasmian}', "");
    Expect(0, 69599, '\P{Blk=	Chorasmian}', "");
    Expect(1, 69599, '\P{^Blk=	Chorasmian}', "");
    Expect(0, 69600, '\p{Blk=	Chorasmian}', "");
    Expect(1, 69600, '\p{^Blk=	Chorasmian}', "");
    Expect(1, 69600, '\P{Blk=	Chorasmian}', "");
    Expect(0, 69600, '\P{^Blk=	Chorasmian}', "");
    Error('\p{Is_Block=:=  CHORASMIAN}');
    Error('\P{Is_Block=:=  CHORASMIAN}');
    Expect(1, 69599, '\p{Is_Block=chorasmian}', "");
    Expect(0, 69599, '\p{^Is_Block=chorasmian}', "");
    Expect(0, 69599, '\P{Is_Block=chorasmian}', "");
    Expect(1, 69599, '\P{^Is_Block=chorasmian}', "");
    Expect(0, 69600, '\p{Is_Block=chorasmian}', "");
    Expect(1, 69600, '\p{^Is_Block=chorasmian}', "");
    Expect(1, 69600, '\P{Is_Block=chorasmian}', "");
    Expect(0, 69600, '\P{^Is_Block=chorasmian}', "");
    Expect(1, 69599, '\p{Is_Block= _chorasmian}', "");
    Expect(0, 69599, '\p{^Is_Block= _chorasmian}', "");
    Expect(0, 69599, '\P{Is_Block= _chorasmian}', "");
    Expect(1, 69599, '\P{^Is_Block= _chorasmian}', "");
    Expect(0, 69600, '\p{Is_Block= _chorasmian}', "");
    Expect(1, 69600, '\p{^Is_Block= _chorasmian}', "");
    Expect(1, 69600, '\P{Is_Block= _chorasmian}', "");
    Expect(0, 69600, '\P{^Is_Block= _chorasmian}', "");
    Error('\p{Is_Blk=-	Chorasmian/a/}');
    Error('\P{Is_Blk=-	Chorasmian/a/}');
    Expect(1, 69599, '\p{Is_Blk=chorasmian}', "");
    Expect(0, 69599, '\p{^Is_Blk=chorasmian}', "");
    Expect(0, 69599, '\P{Is_Blk=chorasmian}', "");
    Expect(1, 69599, '\P{^Is_Blk=chorasmian}', "");
    Expect(0, 69600, '\p{Is_Blk=chorasmian}', "");
    Expect(1, 69600, '\p{^Is_Blk=chorasmian}', "");
    Expect(1, 69600, '\P{Is_Blk=chorasmian}', "");
    Expect(0, 69600, '\P{^Is_Blk=chorasmian}', "");
    Expect(1, 69599, '\p{Is_Blk=		chorasmian}', "");
    Expect(0, 69599, '\p{^Is_Blk=		chorasmian}', "");
    Expect(0, 69599, '\P{Is_Blk=		chorasmian}', "");
    Expect(1, 69599, '\P{^Is_Blk=		chorasmian}', "");
    Expect(0, 69600, '\p{Is_Blk=		chorasmian}', "");
    Expect(1, 69600, '\p{^Is_Blk=		chorasmian}', "");
    Expect(1, 69600, '\P{Is_Blk=		chorasmian}', "");
    Expect(0, 69600, '\P{^Is_Blk=		chorasmian}', "");
    Error('\p{Block=/a/ -CJK_Unified_ideographs}');
    Error('\P{Block=/a/ -CJK_Unified_ideographs}');
    Expect(1, 40959, '\p{Block=:\ACJK_Unified_Ideographs\z:}', "");;
    Expect(0, 40960, '\p{Block=:\ACJK_Unified_Ideographs\z:}', "");;
    Expect(1, 40959, '\p{Block=cjkunifiedideographs}', "");
    Expect(0, 40959, '\p{^Block=cjkunifiedideographs}', "");
    Expect(0, 40959, '\P{Block=cjkunifiedideographs}', "");
    Expect(1, 40959, '\P{^Block=cjkunifiedideographs}', "");
    Expect(0, 40960, '\p{Block=cjkunifiedideographs}', "");
    Expect(1, 40960, '\p{^Block=cjkunifiedideographs}', "");
    Expect(1, 40960, '\P{Block=cjkunifiedideographs}', "");
    Expect(0, 40960, '\P{^Block=cjkunifiedideographs}', "");
    Expect(1, 40959, '\p{Block=:\Acjkunifiedideographs\z:}', "");;
    Expect(0, 40960, '\p{Block=:\Acjkunifiedideographs\z:}', "");;
    Expect(1, 40959, '\p{Block=--CJK_Unified_Ideographs}', "");
    Expect(0, 40959, '\p{^Block=--CJK_Unified_Ideographs}', "");
    Expect(0, 40959, '\P{Block=--CJK_Unified_Ideographs}', "");
    Expect(1, 40959, '\P{^Block=--CJK_Unified_Ideographs}', "");
    Expect(0, 40960, '\p{Block=--CJK_Unified_Ideographs}', "");
    Expect(1, 40960, '\p{^Block=--CJK_Unified_Ideographs}', "");
    Expect(1, 40960, '\P{Block=--CJK_Unified_Ideographs}', "");
    Expect(0, 40960, '\P{^Block=--CJK_Unified_Ideographs}', "");
    Error('\p{Blk=:=_ CJK}');
    Error('\P{Blk=:=_ CJK}');
    Expect(1, 40959, '\p{Blk=:\ACJK\z:}', "");;
    Expect(0, 40960, '\p{Blk=:\ACJK\z:}', "");;
    Expect(1, 40959, '\p{Blk=cjk}', "");
    Expect(0, 40959, '\p{^Blk=cjk}', "");
    Expect(0, 40959, '\P{Blk=cjk}', "");
    Expect(1, 40959, '\P{^Blk=cjk}', "");
    Expect(0, 40960, '\p{Blk=cjk}', "");
    Expect(1, 40960, '\p{^Blk=cjk}', "");
    Expect(1, 40960, '\P{Blk=cjk}', "");
    Expect(0, 40960, '\P{^Blk=cjk}', "");
    Expect(1, 40959, '\p{Blk=:\Acjk\z:}', "");;
    Expect(0, 40960, '\p{Blk=:\Acjk\z:}', "");;
    Expect(1, 40959, '\p{Blk:		_cjk}', "");
    Expect(0, 40959, '\p{^Blk:		_cjk}', "");
    Expect(0, 40959, '\P{Blk:		_cjk}', "");
    Expect(1, 40959, '\P{^Blk:		_cjk}', "");
    Expect(0, 40960, '\p{Blk:		_cjk}', "");
    Expect(1, 40960, '\p{^Blk:		_cjk}', "");
    Expect(1, 40960, '\P{Blk:		_cjk}', "");
    Expect(0, 40960, '\P{^Blk:		_cjk}', "");
    Error('\p{Is_Block=:=-_cjk_Unified_ideographs}');
    Error('\P{Is_Block=:=-_cjk_Unified_ideographs}');
    Expect(1, 40959, '\p{Is_Block=cjkunifiedideographs}', "");
    Expect(0, 40959, '\p{^Is_Block=cjkunifiedideographs}', "");
    Expect(0, 40959, '\P{Is_Block=cjkunifiedideographs}', "");
    Expect(1, 40959, '\P{^Is_Block=cjkunifiedideographs}', "");
    Expect(0, 40960, '\p{Is_Block=cjkunifiedideographs}', "");
    Expect(1, 40960, '\p{^Is_Block=cjkunifiedideographs}', "");
    Expect(1, 40960, '\P{Is_Block=cjkunifiedideographs}', "");
    Expect(0, 40960, '\P{^Is_Block=cjkunifiedideographs}', "");
    Expect(1, 40959, '\p{Is_Block=_ CJK_Unified_Ideographs}', "");
    Expect(0, 40959, '\p{^Is_Block=_ CJK_Unified_Ideographs}', "");
    Expect(0, 40959, '\P{Is_Block=_ CJK_Unified_Ideographs}', "");
    Expect(1, 40959, '\P{^Is_Block=_ CJK_Unified_Ideographs}', "");
    Expect(0, 40960, '\p{Is_Block=_ CJK_Unified_Ideographs}', "");
    Expect(1, 40960, '\p{^Is_Block=_ CJK_Unified_Ideographs}', "");
    Expect(1, 40960, '\P{Is_Block=_ CJK_Unified_Ideographs}', "");
    Expect(0, 40960, '\P{^Is_Block=_ CJK_Unified_Ideographs}', "");
    Error('\p{Is_Blk=:= cjk}');
    Error('\P{Is_Blk=:= cjk}');
    Expect(1, 40959, '\p{Is_Blk=cjk}', "");
    Expect(0, 40959, '\p{^Is_Blk=cjk}', "");
    Expect(0, 40959, '\P{Is_Blk=cjk}', "");
    Expect(1, 40959, '\P{^Is_Blk=cjk}', "");
    Expect(0, 40960, '\p{Is_Blk=cjk}', "");
    Expect(1, 40960, '\p{^Is_Blk=cjk}', "");
    Expect(1, 40960, '\P{Is_Blk=cjk}', "");
    Expect(0, 40960, '\P{^Is_Blk=cjk}', "");
    Expect(1, 40959, '\p{Is_Blk= 	cjk}', "");
    Expect(0, 40959, '\p{^Is_Blk= 	cjk}', "");
    Expect(0, 40959, '\P{Is_Blk= 	cjk}', "");
    Expect(1, 40959, '\P{^Is_Blk= 	cjk}', "");
    Expect(0, 40960, '\p{Is_Blk= 	cjk}', "");
    Expect(1, 40960, '\p{^Is_Blk= 	cjk}', "");
    Expect(1, 40960, '\P{Is_Blk= 	cjk}', "");
    Expect(0, 40960, '\P{^Is_Blk= 	cjk}', "");
    Error('\p{Block:   		CJK_Compatibility:=}');
    Error('\P{Block:   		CJK_Compatibility:=}');
    Expect(1, 13311, '\p{Block=:\ACJK_Compatibility\z:}', "");;
    Expect(0, 13312, '\p{Block=:\ACJK_Compatibility\z:}', "");;
    Expect(1, 13311, '\p{Block:	cjkcompatibility}', "");
    Expect(0, 13311, '\p{^Block:	cjkcompatibility}', "");
    Expect(0, 13311, '\P{Block:	cjkcompatibility}', "");
    Expect(1, 13311, '\P{^Block:	cjkcompatibility}', "");
    Expect(0, 13312, '\p{Block:	cjkcompatibility}', "");
    Expect(1, 13312, '\p{^Block:	cjkcompatibility}', "");
    Expect(1, 13312, '\P{Block:	cjkcompatibility}', "");
    Expect(0, 13312, '\P{^Block:	cjkcompatibility}', "");
    Expect(1, 13311, '\p{Block=:\Acjkcompatibility\z:}', "");;
    Expect(0, 13312, '\p{Block=:\Acjkcompatibility\z:}', "");;
    Expect(1, 13311, '\p{Block= _CJK_compatibility}', "");
    Expect(0, 13311, '\p{^Block= _CJK_compatibility}', "");
    Expect(0, 13311, '\P{Block= _CJK_compatibility}', "");
    Expect(1, 13311, '\P{^Block= _CJK_compatibility}', "");
    Expect(0, 13312, '\p{Block= _CJK_compatibility}', "");
    Expect(1, 13312, '\p{^Block= _CJK_compatibility}', "");
    Expect(1, 13312, '\P{Block= _CJK_compatibility}', "");
    Expect(0, 13312, '\P{^Block= _CJK_compatibility}', "");
    Error('\p{Blk=-:=cjk_compat}');
    Error('\P{Blk=-:=cjk_compat}');
    Expect(1, 13311, '\p{Blk=:\ACJK_Compat\z:}', "");;
    Expect(0, 13312, '\p{Blk=:\ACJK_Compat\z:}', "");;
    Expect(1, 13311, '\p{Blk=cjkcompat}', "");
    Expect(0, 13311, '\p{^Blk=cjkcompat}', "");
    Expect(0, 13311, '\P{Blk=cjkcompat}', "");
    Expect(1, 13311, '\P{^Blk=cjkcompat}', "");
    Expect(0, 13312, '\p{Blk=cjkcompat}', "");
    Expect(1, 13312, '\p{^Blk=cjkcompat}', "");
    Expect(1, 13312, '\P{Blk=cjkcompat}', "");
    Expect(0, 13312, '\P{^Blk=cjkcompat}', "");
    Expect(1, 13311, '\p{Blk=:\Acjkcompat\z:}', "");;
    Expect(0, 13312, '\p{Blk=:\Acjkcompat\z:}', "");;
    Expect(1, 13311, '\p{Blk=-CJK_Compat}', "");
    Expect(0, 13311, '\p{^Blk=-CJK_Compat}', "");
    Expect(0, 13311, '\P{Blk=-CJK_Compat}', "");
    Expect(1, 13311, '\P{^Blk=-CJK_Compat}', "");
    Expect(0, 13312, '\p{Blk=-CJK_Compat}', "");
    Expect(1, 13312, '\p{^Blk=-CJK_Compat}', "");
    Expect(1, 13312, '\P{Blk=-CJK_Compat}', "");
    Expect(0, 13312, '\P{^Blk=-CJK_Compat}', "");
    Error('\p{Is_Block=_/a/CJK_Compatibility}');
    Error('\P{Is_Block=_/a/CJK_Compatibility}');
    Expect(1, 13311, '\p{Is_Block: cjkcompatibility}', "");
    Expect(0, 13311, '\p{^Is_Block: cjkcompatibility}', "");
    Expect(0, 13311, '\P{Is_Block: cjkcompatibility}', "");
    Expect(1, 13311, '\P{^Is_Block: cjkcompatibility}', "");
    Expect(0, 13312, '\p{Is_Block: cjkcompatibility}', "");
    Expect(1, 13312, '\p{^Is_Block: cjkcompatibility}', "");
    Expect(1, 13312, '\P{Is_Block: cjkcompatibility}', "");
    Expect(0, 13312, '\P{^Is_Block: cjkcompatibility}', "");
    Expect(1, 13311, '\p{Is_Block= CJK_Compatibility}', "");
    Expect(0, 13311, '\p{^Is_Block= CJK_Compatibility}', "");
    Expect(0, 13311, '\P{Is_Block= CJK_Compatibility}', "");
    Expect(1, 13311, '\P{^Is_Block= CJK_Compatibility}', "");
    Expect(0, 13312, '\p{Is_Block= CJK_Compatibility}', "");
    Expect(1, 13312, '\p{^Is_Block= CJK_Compatibility}', "");
    Expect(1, 13312, '\P{Is_Block= CJK_Compatibility}', "");
    Expect(0, 13312, '\P{^Is_Block= CJK_Compatibility}', "");
    Error('\p{Is_Blk=/a/ cjk_Compat}');
    Error('\P{Is_Blk=/a/ cjk_Compat}');
    Expect(1, 13311, '\p{Is_Blk=cjkcompat}', "");
    Expect(0, 13311, '\p{^Is_Blk=cjkcompat}', "");
    Expect(0, 13311, '\P{Is_Blk=cjkcompat}', "");
    Expect(1, 13311, '\P{^Is_Blk=cjkcompat}', "");
    Expect(0, 13312, '\p{Is_Blk=cjkcompat}', "");
    Expect(1, 13312, '\p{^Is_Blk=cjkcompat}', "");
    Expect(1, 13312, '\P{Is_Blk=cjkcompat}', "");
    Expect(0, 13312, '\P{^Is_Blk=cjkcompat}', "");
    Expect(1, 13311, '\p{Is_Blk=		CJK_compat}', "");
    Expect(0, 13311, '\p{^Is_Blk=		CJK_compat}', "");
    Expect(0, 13311, '\P{Is_Blk=		CJK_compat}', "");
    Expect(1, 13311, '\P{^Is_Blk=		CJK_compat}', "");
    Expect(0, 13312, '\p{Is_Blk=		CJK_compat}', "");
    Expect(1, 13312, '\p{^Is_Blk=		CJK_compat}', "");
    Expect(1, 13312, '\P{Is_Blk=		CJK_compat}', "");
    Expect(0, 13312, '\P{^Is_Blk=		CJK_compat}', "");
    Error('\p{Block=:=-CJK_Compatibility_FORMS}');
    Error('\P{Block=:=-CJK_Compatibility_FORMS}');
    Expect(1, 65103, '\p{Block=:\ACJK_Compatibility_Forms\z:}', "");;
    Expect(0, 65104, '\p{Block=:\ACJK_Compatibility_Forms\z:}', "");;
    Expect(1, 65103, '\p{Block=cjkcompatibilityforms}', "");
    Expect(0, 65103, '\p{^Block=cjkcompatibilityforms}', "");
    Expect(0, 65103, '\P{Block=cjkcompatibilityforms}', "");
    Expect(1, 65103, '\P{^Block=cjkcompatibilityforms}', "");
    Expect(0, 65104, '\p{Block=cjkcompatibilityforms}', "");
    Expect(1, 65104, '\p{^Block=cjkcompatibilityforms}', "");
    Expect(1, 65104, '\P{Block=cjkcompatibilityforms}', "");
    Expect(0, 65104, '\P{^Block=cjkcompatibilityforms}', "");
    Expect(1, 65103, '\p{Block=:\Acjkcompatibilityforms\z:}', "");;
    Expect(0, 65104, '\p{Block=:\Acjkcompatibilityforms\z:}', "");;
    Expect(1, 65103, '\p{Block=	_CJK_compatibility_Forms}', "");
    Expect(0, 65103, '\p{^Block=	_CJK_compatibility_Forms}', "");
    Expect(0, 65103, '\P{Block=	_CJK_compatibility_Forms}', "");
    Expect(1, 65103, '\P{^Block=	_CJK_compatibility_Forms}', "");
    Expect(0, 65104, '\p{Block=	_CJK_compatibility_Forms}', "");
    Expect(1, 65104, '\p{^Block=	_CJK_compatibility_Forms}', "");
    Expect(1, 65104, '\P{Block=	_CJK_compatibility_Forms}', "");
    Expect(0, 65104, '\P{^Block=	_CJK_compatibility_Forms}', "");
    Error('\p{Blk=-CJK_compat_Forms/a/}');
    Error('\P{Blk=-CJK_compat_Forms/a/}');
    Expect(1, 65103, '\p{Blk=:\ACJK_Compat_Forms\z:}', "");;
    Expect(0, 65104, '\p{Blk=:\ACJK_Compat_Forms\z:}', "");;
    Expect(1, 65103, '\p{Blk=cjkcompatforms}', "");
    Expect(0, 65103, '\p{^Blk=cjkcompatforms}', "");
    Expect(0, 65103, '\P{Blk=cjkcompatforms}', "");
    Expect(1, 65103, '\P{^Blk=cjkcompatforms}', "");
    Expect(0, 65104, '\p{Blk=cjkcompatforms}', "");
    Expect(1, 65104, '\p{^Blk=cjkcompatforms}', "");
    Expect(1, 65104, '\P{Blk=cjkcompatforms}', "");
    Expect(0, 65104, '\P{^Blk=cjkcompatforms}', "");
    Expect(1, 65103, '\p{Blk=:\Acjkcompatforms\z:}', "");;
    Expect(0, 65104, '\p{Blk=:\Acjkcompatforms\z:}', "");;
    Expect(1, 65103, '\p{Blk= 	cjk_Compat_Forms}', "");
    Expect(0, 65103, '\p{^Blk= 	cjk_Compat_Forms}', "");
    Expect(0, 65103, '\P{Blk= 	cjk_Compat_Forms}', "");
    Expect(1, 65103, '\P{^Blk= 	cjk_Compat_Forms}', "");
    Expect(0, 65104, '\p{Blk= 	cjk_Compat_Forms}', "");
    Expect(1, 65104, '\p{^Blk= 	cjk_Compat_Forms}', "");
    Expect(1, 65104, '\P{Blk= 	cjk_Compat_Forms}', "");
    Expect(0, 65104, '\P{^Blk= 	cjk_Compat_Forms}', "");
    Error('\p{Is_Block: :=-CJK_Compatibility_FORMS}');
    Error('\P{Is_Block: :=-CJK_Compatibility_FORMS}');
    Expect(1, 65103, '\p{Is_Block=cjkcompatibilityforms}', "");
    Expect(0, 65103, '\p{^Is_Block=cjkcompatibilityforms}', "");
    Expect(0, 65103, '\P{Is_Block=cjkcompatibilityforms}', "");
    Expect(1, 65103, '\P{^Is_Block=cjkcompatibilityforms}', "");
    Expect(0, 65104, '\p{Is_Block=cjkcompatibilityforms}', "");
    Expect(1, 65104, '\p{^Is_Block=cjkcompatibilityforms}', "");
    Expect(1, 65104, '\P{Is_Block=cjkcompatibilityforms}', "");
    Expect(0, 65104, '\P{^Is_Block=cjkcompatibilityforms}', "");
    Expect(1, 65103, '\p{Is_Block:    CJK_Compatibility_FORMS}', "");
    Expect(0, 65103, '\p{^Is_Block:    CJK_Compatibility_FORMS}', "");
    Expect(0, 65103, '\P{Is_Block:    CJK_Compatibility_FORMS}', "");
    Expect(1, 65103, '\P{^Is_Block:    CJK_Compatibility_FORMS}', "");
    Expect(0, 65104, '\p{Is_Block:    CJK_Compatibility_FORMS}', "");
    Expect(1, 65104, '\p{^Is_Block:    CJK_Compatibility_FORMS}', "");
    Expect(1, 65104, '\P{Is_Block:    CJK_Compatibility_FORMS}', "");
    Expect(0, 65104, '\P{^Is_Block:    CJK_Compatibility_FORMS}', "");
    Error('\p{Is_Blk=_:=CJK_compat_FORMS}');
    Error('\P{Is_Blk=_:=CJK_compat_FORMS}');
    Expect(1, 65103, '\p{Is_Blk=cjkcompatforms}', "");
    Expect(0, 65103, '\p{^Is_Blk=cjkcompatforms}', "");
    Expect(0, 65103, '\P{Is_Blk=cjkcompatforms}', "");
    Expect(1, 65103, '\P{^Is_Blk=cjkcompatforms}', "");
    Expect(0, 65104, '\p{Is_Blk=cjkcompatforms}', "");
    Expect(1, 65104, '\p{^Is_Blk=cjkcompatforms}', "");
    Expect(1, 65104, '\P{Is_Blk=cjkcompatforms}', "");
    Expect(0, 65104, '\P{^Is_Blk=cjkcompatforms}', "");
    Expect(1, 65103, '\p{Is_Blk= _CJK_Compat_forms}', "");
    Expect(0, 65103, '\p{^Is_Blk= _CJK_Compat_forms}', "");
    Expect(0, 65103, '\P{Is_Blk= _CJK_Compat_forms}', "");
    Expect(1, 65103, '\P{^Is_Blk= _CJK_Compat_forms}', "");
    Expect(0, 65104, '\p{Is_Blk= _CJK_Compat_forms}', "");
    Expect(1, 65104, '\p{^Is_Blk= _CJK_Compat_forms}', "");
    Expect(1, 65104, '\P{Is_Blk= _CJK_Compat_forms}', "");
    Expect(0, 65104, '\P{^Is_Blk= _CJK_Compat_forms}', "");
    Error('\p{Block=/a/- CJK_COMPATIBILITY_IDEOGRAPHS}');
    Error('\P{Block=/a/- CJK_COMPATIBILITY_IDEOGRAPHS}');
    Expect(1, 64255, '\p{Block=:\ACJK_Compatibility_Ideographs\z:}', "");;
    Expect(0, 64256, '\p{Block=:\ACJK_Compatibility_Ideographs\z:}', "");;
    Expect(1, 64255, '\p{Block=cjkcompatibilityideographs}', "");
    Expect(0, 64255, '\p{^Block=cjkcompatibilityideographs}', "");
    Expect(0, 64255, '\P{Block=cjkcompatibilityideographs}', "");
    Expect(1, 64255, '\P{^Block=cjkcompatibilityideographs}', "");
    Expect(0, 64256, '\p{Block=cjkcompatibilityideographs}', "");
    Expect(1, 64256, '\p{^Block=cjkcompatibilityideographs}', "");
    Expect(1, 64256, '\P{Block=cjkcompatibilityideographs}', "");
    Expect(0, 64256, '\P{^Block=cjkcompatibilityideographs}', "");
    Expect(1, 64255, '\p{Block=:\Acjkcompatibilityideographs\z:}', "");;
    Expect(0, 64256, '\p{Block=:\Acjkcompatibilityideographs\z:}', "");;
    Expect(1, 64255, '\p{Block=	_CJK_COMPATIBILITY_IDEOGRAPHS}', "");
    Expect(0, 64255, '\p{^Block=	_CJK_COMPATIBILITY_IDEOGRAPHS}', "");
    Expect(0, 64255, '\P{Block=	_CJK_COMPATIBILITY_IDEOGRAPHS}', "");
    Expect(1, 64255, '\P{^Block=	_CJK_COMPATIBILITY_IDEOGRAPHS}', "");
    Expect(0, 64256, '\p{Block=	_CJK_COMPATIBILITY_IDEOGRAPHS}', "");
    Expect(1, 64256, '\p{^Block=	_CJK_COMPATIBILITY_IDEOGRAPHS}', "");
    Expect(1, 64256, '\P{Block=	_CJK_COMPATIBILITY_IDEOGRAPHS}', "");
    Expect(0, 64256, '\P{^Block=	_CJK_COMPATIBILITY_IDEOGRAPHS}', "");
    Error('\p{Blk=-/a/CJK_compat_IDEOGRAPHS}');
    Error('\P{Blk=-/a/CJK_compat_IDEOGRAPHS}');
    Expect(1, 64255, '\p{Blk=:\ACJK_Compat_Ideographs\z:}', "");;
    Expect(0, 64256, '\p{Blk=:\ACJK_Compat_Ideographs\z:}', "");;
    Expect(1, 64255, '\p{Blk=cjkcompatideographs}', "");
    Expect(0, 64255, '\p{^Blk=cjkcompatideographs}', "");
    Expect(0, 64255, '\P{Blk=cjkcompatideographs}', "");
    Expect(1, 64255, '\P{^Blk=cjkcompatideographs}', "");
    Expect(0, 64256, '\p{Blk=cjkcompatideographs}', "");
    Expect(1, 64256, '\p{^Blk=cjkcompatideographs}', "");
    Expect(1, 64256, '\P{Blk=cjkcompatideographs}', "");
    Expect(0, 64256, '\P{^Blk=cjkcompatideographs}', "");
    Expect(1, 64255, '\p{Blk=:\Acjkcompatideographs\z:}', "");;
    Expect(0, 64256, '\p{Blk=:\Acjkcompatideographs\z:}', "");;
    Expect(1, 64255, '\p{Blk= _cjk_COMPAT_IDEOGRAPHS}', "");
    Expect(0, 64255, '\p{^Blk= _cjk_COMPAT_IDEOGRAPHS}', "");
    Expect(0, 64255, '\P{Blk= _cjk_COMPAT_IDEOGRAPHS}', "");
    Expect(1, 64255, '\P{^Blk= _cjk_COMPAT_IDEOGRAPHS}', "");
    Expect(0, 64256, '\p{Blk= _cjk_COMPAT_IDEOGRAPHS}', "");
    Expect(1, 64256, '\p{^Blk= _cjk_COMPAT_IDEOGRAPHS}', "");
    Expect(1, 64256, '\P{Blk= _cjk_COMPAT_IDEOGRAPHS}', "");
    Expect(0, 64256, '\P{^Blk= _cjk_COMPAT_IDEOGRAPHS}', "");
    Error('\p{Is_Block=-/a/CJK_Compatibility_Ideographs}');
    Error('\P{Is_Block=-/a/CJK_Compatibility_Ideographs}');
    Expect(1, 64255, '\p{Is_Block=cjkcompatibilityideographs}', "");
    Expect(0, 64255, '\p{^Is_Block=cjkcompatibilityideographs}', "");
    Expect(0, 64255, '\P{Is_Block=cjkcompatibilityideographs}', "");
    Expect(1, 64255, '\P{^Is_Block=cjkcompatibilityideographs}', "");
    Expect(0, 64256, '\p{Is_Block=cjkcompatibilityideographs}', "");
    Expect(1, 64256, '\p{^Is_Block=cjkcompatibilityideographs}', "");
    Expect(1, 64256, '\P{Is_Block=cjkcompatibilityideographs}', "");
    Expect(0, 64256, '\P{^Is_Block=cjkcompatibilityideographs}', "");
    Expect(1, 64255, '\p{Is_Block= 	cjk_Compatibility_IDEOGRAPHS}', "");
    Expect(0, 64255, '\p{^Is_Block= 	cjk_Compatibility_IDEOGRAPHS}', "");
    Expect(0, 64255, '\P{Is_Block= 	cjk_Compatibility_IDEOGRAPHS}', "");
    Expect(1, 64255, '\P{^Is_Block= 	cjk_Compatibility_IDEOGRAPHS}', "");
    Expect(0, 64256, '\p{Is_Block= 	cjk_Compatibility_IDEOGRAPHS}', "");
    Expect(1, 64256, '\p{^Is_Block= 	cjk_Compatibility_IDEOGRAPHS}', "");
    Expect(1, 64256, '\P{Is_Block= 	cjk_Compatibility_IDEOGRAPHS}', "");
    Expect(0, 64256, '\P{^Is_Block= 	cjk_Compatibility_IDEOGRAPHS}', "");
    Error('\p{Is_Blk=/a/--cjk_COMPAT_IDEOGRAPHS}');
    Error('\P{Is_Blk=/a/--cjk_COMPAT_IDEOGRAPHS}');
    Expect(1, 64255, '\p{Is_Blk:cjkcompatideographs}', "");
    Expect(0, 64255, '\p{^Is_Blk:cjkcompatideographs}', "");
    Expect(0, 64255, '\P{Is_Blk:cjkcompatideographs}', "");
    Expect(1, 64255, '\P{^Is_Blk:cjkcompatideographs}', "");
    Expect(0, 64256, '\p{Is_Blk:cjkcompatideographs}', "");
    Expect(1, 64256, '\p{^Is_Blk:cjkcompatideographs}', "");
    Expect(1, 64256, '\P{Is_Blk:cjkcompatideographs}', "");
    Expect(0, 64256, '\P{^Is_Blk:cjkcompatideographs}', "");
    Expect(1, 64255, '\p{Is_Blk=- cjk_COMPAT_Ideographs}', "");
    Expect(0, 64255, '\p{^Is_Blk=- cjk_COMPAT_Ideographs}', "");
    Expect(0, 64255, '\P{Is_Blk=- cjk_COMPAT_Ideographs}', "");
    Expect(1, 64255, '\P{^Is_Blk=- cjk_COMPAT_Ideographs}', "");
    Expect(0, 64256, '\p{Is_Blk=- cjk_COMPAT_Ideographs}', "");
    Expect(1, 64256, '\p{^Is_Blk=- cjk_COMPAT_Ideographs}', "");
    Expect(1, 64256, '\P{Is_Blk=- cjk_COMPAT_Ideographs}', "");
    Expect(0, 64256, '\P{^Is_Blk=- cjk_COMPAT_Ideographs}', "");
    Error('\p{Block=:= _cjk_Compatibility_ideographs_Supplement}');
    Error('\P{Block=:= _cjk_Compatibility_ideographs_Supplement}');
    Expect(1, 195103, '\p{Block=:\ACJK_Compatibility_Ideographs_Supplement\z:}', "");;
    Expect(0, 195104, '\p{Block=:\ACJK_Compatibility_Ideographs_Supplement\z:}', "");;
    Expect(1, 195103, '\p{Block=cjkcompatibilityideographssupplement}', "");
    Expect(0, 195103, '\p{^Block=cjkcompatibilityideographssupplement}', "");
    Expect(0, 195103, '\P{Block=cjkcompatibilityideographssupplement}', "");
    Expect(1, 195103, '\P{^Block=cjkcompatibilityideographssupplement}', "");
    Expect(0, 195104, '\p{Block=cjkcompatibilityideographssupplement}', "");
    Expect(1, 195104, '\p{^Block=cjkcompatibilityideographssupplement}', "");
    Expect(1, 195104, '\P{Block=cjkcompatibilityideographssupplement}', "");
    Expect(0, 195104, '\P{^Block=cjkcompatibilityideographssupplement}', "");
    Expect(1, 195103, '\p{Block=:\Acjkcompatibilityideographssupplement\z:}', "");;
    Expect(0, 195104, '\p{Block=:\Acjkcompatibilityideographssupplement\z:}', "");;
    Expect(1, 195103, '\p{Block:_	CJK_COMPATIBILITY_Ideographs_supplement}', "");
    Expect(0, 195103, '\p{^Block:_	CJK_COMPATIBILITY_Ideographs_supplement}', "");
    Expect(0, 195103, '\P{Block:_	CJK_COMPATIBILITY_Ideographs_supplement}', "");
    Expect(1, 195103, '\P{^Block:_	CJK_COMPATIBILITY_Ideographs_supplement}', "");
    Expect(0, 195104, '\p{Block:_	CJK_COMPATIBILITY_Ideographs_supplement}', "");
    Expect(1, 195104, '\p{^Block:_	CJK_COMPATIBILITY_Ideographs_supplement}', "");
    Expect(1, 195104, '\P{Block:_	CJK_COMPATIBILITY_Ideographs_supplement}', "");
    Expect(0, 195104, '\P{^Block:_	CJK_COMPATIBILITY_Ideographs_supplement}', "");
    Error('\p{Blk::=-CJK_Compat_IDEOGRAPHS_Sup}');
    Error('\P{Blk::=-CJK_Compat_IDEOGRAPHS_Sup}');
    Expect(1, 195103, '\p{Blk=:\ACJK_Compat_Ideographs_Sup\z:}', "");;
    Expect(0, 195104, '\p{Blk=:\ACJK_Compat_Ideographs_Sup\z:}', "");;
    Expect(1, 195103, '\p{Blk=cjkcompatideographssup}', "");
    Expect(0, 195103, '\p{^Blk=cjkcompatideographssup}', "");
    Expect(0, 195103, '\P{Blk=cjkcompatideographssup}', "");
    Expect(1, 195103, '\P{^Blk=cjkcompatideographssup}', "");
    Expect(0, 195104, '\p{Blk=cjkcompatideographssup}', "");
    Expect(1, 195104, '\p{^Blk=cjkcompatideographssup}', "");
    Expect(1, 195104, '\P{Blk=cjkcompatideographssup}', "");
    Expect(0, 195104, '\P{^Blk=cjkcompatideographssup}', "");
    Expect(1, 195103, '\p{Blk=:\Acjkcompatideographssup\z:}', "");;
    Expect(0, 195104, '\p{Blk=:\Acjkcompatideographssup\z:}', "");;
    Expect(1, 195103, '\p{Blk:   	 CJK_COMPAT_Ideographs_Sup}', "");
    Expect(0, 195103, '\p{^Blk:   	 CJK_COMPAT_Ideographs_Sup}', "");
    Expect(0, 195103, '\P{Blk:   	 CJK_COMPAT_Ideographs_Sup}', "");
    Expect(1, 195103, '\P{^Blk:   	 CJK_COMPAT_Ideographs_Sup}', "");
    Expect(0, 195104, '\p{Blk:   	 CJK_COMPAT_Ideographs_Sup}', "");
    Expect(1, 195104, '\p{^Blk:   	 CJK_COMPAT_Ideographs_Sup}', "");
    Expect(1, 195104, '\P{Blk:   	 CJK_COMPAT_Ideographs_Sup}', "");
    Expect(0, 195104, '\P{^Blk:   	 CJK_COMPAT_Ideographs_Sup}', "");
    Error('\p{Is_Block:	/a/CJK_Compatibility_IDEOGRAPHS_Supplement}');
    Error('\P{Is_Block:	/a/CJK_Compatibility_IDEOGRAPHS_Supplement}');
    Expect(1, 195103, '\p{Is_Block=cjkcompatibilityideographssupplement}', "");
    Expect(0, 195103, '\p{^Is_Block=cjkcompatibilityideographssupplement}', "");
    Expect(0, 195103, '\P{Is_Block=cjkcompatibilityideographssupplement}', "");
    Expect(1, 195103, '\P{^Is_Block=cjkcompatibilityideographssupplement}', "");
    Expect(0, 195104, '\p{Is_Block=cjkcompatibilityideographssupplement}', "");
    Expect(1, 195104, '\p{^Is_Block=cjkcompatibilityideographssupplement}', "");
    Expect(1, 195104, '\P{Is_Block=cjkcompatibilityideographssupplement}', "");
    Expect(0, 195104, '\P{^Is_Block=cjkcompatibilityideographssupplement}', "");
    Expect(1, 195103, '\p{Is_Block= -cjk_compatibility_Ideographs_SUPPLEMENT}', "");
    Expect(0, 195103, '\p{^Is_Block= -cjk_compatibility_Ideographs_SUPPLEMENT}', "");
    Expect(0, 195103, '\P{Is_Block= -cjk_compatibility_Ideographs_SUPPLEMENT}', "");
    Expect(1, 195103, '\P{^Is_Block= -cjk_compatibility_Ideographs_SUPPLEMENT}', "");
    Expect(0, 195104, '\p{Is_Block= -cjk_compatibility_Ideographs_SUPPLEMENT}', "");
    Expect(1, 195104, '\p{^Is_Block= -cjk_compatibility_Ideographs_SUPPLEMENT}', "");
    Expect(1, 195104, '\P{Is_Block= -cjk_compatibility_Ideographs_SUPPLEMENT}', "");
    Expect(0, 195104, '\P{^Is_Block= -cjk_compatibility_Ideographs_SUPPLEMENT}', "");
    Error('\p{Is_Blk=/a/__CJK_compat_IDEOGRAPHS_SUP}');
    Error('\P{Is_Blk=/a/__CJK_compat_IDEOGRAPHS_SUP}');
    Expect(1, 195103, '\p{Is_Blk=cjkcompatideographssup}', "");
    Expect(0, 195103, '\p{^Is_Blk=cjkcompatideographssup}', "");
    Expect(0, 195103, '\P{Is_Blk=cjkcompatideographssup}', "");
    Expect(1, 195103, '\P{^Is_Blk=cjkcompatideographssup}', "");
    Expect(0, 195104, '\p{Is_Blk=cjkcompatideographssup}', "");
    Expect(1, 195104, '\p{^Is_Blk=cjkcompatideographssup}', "");
    Expect(1, 195104, '\P{Is_Blk=cjkcompatideographssup}', "");
    Expect(0, 195104, '\P{^Is_Blk=cjkcompatideographssup}', "");
    Expect(1, 195103, '\p{Is_Blk= 	CJK_compat_Ideographs_sup}', "");
    Expect(0, 195103, '\p{^Is_Blk= 	CJK_compat_Ideographs_sup}', "");
    Expect(0, 195103, '\P{Is_Blk= 	CJK_compat_Ideographs_sup}', "");
    Expect(1, 195103, '\P{^Is_Blk= 	CJK_compat_Ideographs_sup}', "");
    Expect(0, 195104, '\p{Is_Blk= 	CJK_compat_Ideographs_sup}', "");
    Expect(1, 195104, '\p{^Is_Blk= 	CJK_compat_Ideographs_sup}', "");
    Expect(1, 195104, '\P{Is_Blk= 	CJK_compat_Ideographs_sup}', "");
    Expect(0, 195104, '\P{^Is_Blk= 	CJK_compat_Ideographs_sup}', "");
    Error('\p{Block: _cjk_Unified_Ideographs_Extension_A:=}');
    Error('\P{Block: _cjk_Unified_Ideographs_Extension_A:=}');
    Expect(1, 19903, '\p{Block=:\ACJK_Unified_Ideographs_Extension_A\z:}', "");;
    Expect(0, 19904, '\p{Block=:\ACJK_Unified_Ideographs_Extension_A\z:}', "");;
    Expect(1, 19903, '\p{Block=cjkunifiedideographsextensiona}', "");
    Expect(0, 19903, '\p{^Block=cjkunifiedideographsextensiona}', "");
    Expect(0, 19903, '\P{Block=cjkunifiedideographsextensiona}', "");
    Expect(1, 19903, '\P{^Block=cjkunifiedideographsextensiona}', "");
    Expect(0, 19904, '\p{Block=cjkunifiedideographsextensiona}', "");
    Expect(1, 19904, '\p{^Block=cjkunifiedideographsextensiona}', "");
    Expect(1, 19904, '\P{Block=cjkunifiedideographsextensiona}', "");
    Expect(0, 19904, '\P{^Block=cjkunifiedideographsextensiona}', "");
    Expect(1, 19903, '\p{Block=:\Acjkunifiedideographsextensiona\z:}', "");;
    Expect(0, 19904, '\p{Block=:\Acjkunifiedideographsextensiona\z:}', "");;
    Expect(1, 19903, '\p{Block= -cjk_UNIFIED_IDEOGRAPHS_extension_A}', "");
    Expect(0, 19903, '\p{^Block= -cjk_UNIFIED_IDEOGRAPHS_extension_A}', "");
    Expect(0, 19903, '\P{Block= -cjk_UNIFIED_IDEOGRAPHS_extension_A}', "");
    Expect(1, 19903, '\P{^Block= -cjk_UNIFIED_IDEOGRAPHS_extension_A}', "");
    Expect(0, 19904, '\p{Block= -cjk_UNIFIED_IDEOGRAPHS_extension_A}', "");
    Expect(1, 19904, '\p{^Block= -cjk_UNIFIED_IDEOGRAPHS_extension_A}', "");
    Expect(1, 19904, '\P{Block= -cjk_UNIFIED_IDEOGRAPHS_extension_A}', "");
    Expect(0, 19904, '\P{^Block= -cjk_UNIFIED_IDEOGRAPHS_extension_A}', "");
    Error('\p{Blk=		CJK_Ext_A:=}');
    Error('\P{Blk=		CJK_Ext_A:=}');
    Expect(1, 19903, '\p{Blk=:\ACJK_Ext_A\z:}', "");;
    Expect(0, 19904, '\p{Blk=:\ACJK_Ext_A\z:}', "");;
    Expect(1, 19903, '\p{Blk=cjkexta}', "");
    Expect(0, 19903, '\p{^Blk=cjkexta}', "");
    Expect(0, 19903, '\P{Blk=cjkexta}', "");
    Expect(1, 19903, '\P{^Blk=cjkexta}', "");
    Expect(0, 19904, '\p{Blk=cjkexta}', "");
    Expect(1, 19904, '\p{^Blk=cjkexta}', "");
    Expect(1, 19904, '\P{Blk=cjkexta}', "");
    Expect(0, 19904, '\P{^Blk=cjkexta}', "");
    Expect(1, 19903, '\p{Blk=:\Acjkexta\z:}', "");;
    Expect(0, 19904, '\p{Blk=:\Acjkexta\z:}', "");;
    Expect(1, 19903, '\p{Blk= 	CJK_EXT_A}', "");
    Expect(0, 19903, '\p{^Blk= 	CJK_EXT_A}', "");
    Expect(0, 19903, '\P{Blk= 	CJK_EXT_A}', "");
    Expect(1, 19903, '\P{^Blk= 	CJK_EXT_A}', "");
    Expect(0, 19904, '\p{Blk= 	CJK_EXT_A}', "");
    Expect(1, 19904, '\p{^Blk= 	CJK_EXT_A}', "");
    Expect(1, 19904, '\P{Blk= 	CJK_EXT_A}', "");
    Expect(0, 19904, '\P{^Blk= 	CJK_EXT_A}', "");
    Error('\p{Is_Block=	_cjk_UNIFIED_ideographs_Extension_A:=}');
    Error('\P{Is_Block=	_cjk_UNIFIED_ideographs_Extension_A:=}');
    Expect(1, 19903, '\p{Is_Block=cjkunifiedideographsextensiona}', "");
    Expect(0, 19903, '\p{^Is_Block=cjkunifiedideographsextensiona}', "");
    Expect(0, 19903, '\P{Is_Block=cjkunifiedideographsextensiona}', "");
    Expect(1, 19903, '\P{^Is_Block=cjkunifiedideographsextensiona}', "");
    Expect(0, 19904, '\p{Is_Block=cjkunifiedideographsextensiona}', "");
    Expect(1, 19904, '\p{^Is_Block=cjkunifiedideographsextensiona}', "");
    Expect(1, 19904, '\P{Is_Block=cjkunifiedideographsextensiona}', "");
    Expect(0, 19904, '\P{^Is_Block=cjkunifiedideographsextensiona}', "");
    Expect(1, 19903, '\p{Is_Block= CJK_Unified_Ideographs_extension_A}', "");
    Expect(0, 19903, '\p{^Is_Block= CJK_Unified_Ideographs_extension_A}', "");
    Expect(0, 19903, '\P{Is_Block= CJK_Unified_Ideographs_extension_A}', "");
    Expect(1, 19903, '\P{^Is_Block= CJK_Unified_Ideographs_extension_A}', "");
    Expect(0, 19904, '\p{Is_Block= CJK_Unified_Ideographs_extension_A}', "");
    Expect(1, 19904, '\p{^Is_Block= CJK_Unified_Ideographs_extension_A}', "");
    Expect(1, 19904, '\P{Is_Block= CJK_Unified_Ideographs_extension_A}', "");
    Expect(0, 19904, '\P{^Is_Block= CJK_Unified_Ideographs_extension_A}', "");
    Error('\p{Is_Blk=-/a/CJK_EXT_A}');
    Error('\P{Is_Blk=-/a/CJK_EXT_A}');
    Expect(1, 19903, '\p{Is_Blk=cjkexta}', "");
    Expect(0, 19903, '\p{^Is_Blk=cjkexta}', "");
    Expect(0, 19903, '\P{Is_Blk=cjkexta}', "");
    Expect(1, 19903, '\P{^Is_Blk=cjkexta}', "");
    Expect(0, 19904, '\p{Is_Blk=cjkexta}', "");
    Expect(1, 19904, '\p{^Is_Blk=cjkexta}', "");
    Expect(1, 19904, '\P{Is_Blk=cjkexta}', "");
    Expect(0, 19904, '\P{^Is_Blk=cjkexta}', "");
    Expect(1, 19903, '\p{Is_Blk=-CJK_Ext_A}', "");
    Expect(0, 19903, '\p{^Is_Blk=-CJK_Ext_A}', "");
    Expect(0, 19903, '\P{Is_Blk=-CJK_Ext_A}', "");
    Expect(1, 19903, '\P{^Is_Blk=-CJK_Ext_A}', "");
    Expect(0, 19904, '\p{Is_Blk=-CJK_Ext_A}', "");
    Expect(1, 19904, '\p{^Is_Blk=-CJK_Ext_A}', "");
    Expect(1, 19904, '\P{Is_Blk=-CJK_Ext_A}', "");
    Expect(0, 19904, '\P{^Is_Blk=-CJK_Ext_A}', "");
    Error('\p{Block=/a/cjk_unified_ideographs_Extension_B}');
    Error('\P{Block=/a/cjk_unified_ideographs_Extension_B}');
    Expect(1, 173791, '\p{Block=:\ACJK_Unified_Ideographs_Extension_B\z:}', "");;
    Expect(0, 173792, '\p{Block=:\ACJK_Unified_Ideographs_Extension_B\z:}', "");;
    Expect(1, 173791, '\p{Block: cjkunifiedideographsextensionb}', "");
    Expect(0, 173791, '\p{^Block: cjkunifiedideographsextensionb}', "");
    Expect(0, 173791, '\P{Block: cjkunifiedideographsextensionb}', "");
    Expect(1, 173791, '\P{^Block: cjkunifiedideographsextensionb}', "");
    Expect(0, 173792, '\p{Block: cjkunifiedideographsextensionb}', "");
    Expect(1, 173792, '\p{^Block: cjkunifiedideographsextensionb}', "");
    Expect(1, 173792, '\P{Block: cjkunifiedideographsextensionb}', "");
    Expect(0, 173792, '\P{^Block: cjkunifiedideographsextensionb}', "");
    Expect(1, 173791, '\p{Block=:\Acjkunifiedideographsextensionb\z:}', "");;
    Expect(0, 173792, '\p{Block=:\Acjkunifiedideographsextensionb\z:}', "");;
    Expect(1, 173791, '\p{Block= 	cjk_Unified_Ideographs_extension_B}', "");
    Expect(0, 173791, '\p{^Block= 	cjk_Unified_Ideographs_extension_B}', "");
    Expect(0, 173791, '\P{Block= 	cjk_Unified_Ideographs_extension_B}', "");
    Expect(1, 173791, '\P{^Block= 	cjk_Unified_Ideographs_extension_B}', "");
    Expect(0, 173792, '\p{Block= 	cjk_Unified_Ideographs_extension_B}', "");
    Expect(1, 173792, '\p{^Block= 	cjk_Unified_Ideographs_extension_B}', "");
    Expect(1, 173792, '\P{Block= 	cjk_Unified_Ideographs_extension_B}', "");
    Expect(0, 173792, '\P{^Block= 	cjk_Unified_Ideographs_extension_B}', "");
    Error('\p{Blk=:= CJK_Ext_B}');
    Error('\P{Blk=:= CJK_Ext_B}');
    Expect(1, 173791, '\p{Blk=:\ACJK_Ext_B\z:}', "");;
    Expect(0, 173792, '\p{Blk=:\ACJK_Ext_B\z:}', "");;
    Expect(1, 173791, '\p{Blk=cjkextb}', "");
    Expect(0, 173791, '\p{^Blk=cjkextb}', "");
    Expect(0, 173791, '\P{Blk=cjkextb}', "");
    Expect(1, 173791, '\P{^Blk=cjkextb}', "");
    Expect(0, 173792, '\p{Blk=cjkextb}', "");
    Expect(1, 173792, '\p{^Blk=cjkextb}', "");
    Expect(1, 173792, '\P{Blk=cjkextb}', "");
    Expect(0, 173792, '\P{^Blk=cjkextb}', "");
    Expect(1, 173791, '\p{Blk=:\Acjkextb\z:}', "");;
    Expect(0, 173792, '\p{Blk=:\Acjkextb\z:}', "");;
    Expect(1, 173791, '\p{Blk= 	cjk_EXT_B}', "");
    Expect(0, 173791, '\p{^Blk= 	cjk_EXT_B}', "");
    Expect(0, 173791, '\P{Blk= 	cjk_EXT_B}', "");
    Expect(1, 173791, '\P{^Blk= 	cjk_EXT_B}', "");
    Expect(0, 173792, '\p{Blk= 	cjk_EXT_B}', "");
    Expect(1, 173792, '\p{^Blk= 	cjk_EXT_B}', "");
    Expect(1, 173792, '\P{Blk= 	cjk_EXT_B}', "");
    Expect(0, 173792, '\P{^Blk= 	cjk_EXT_B}', "");
    Error('\p{Is_Block=/a/_ cjk_UNIFIED_Ideographs_Extension_B}');
    Error('\P{Is_Block=/a/_ cjk_UNIFIED_Ideographs_Extension_B}');
    Expect(1, 173791, '\p{Is_Block: cjkunifiedideographsextensionb}', "");
    Expect(0, 173791, '\p{^Is_Block: cjkunifiedideographsextensionb}', "");
    Expect(0, 173791, '\P{Is_Block: cjkunifiedideographsextensionb}', "");
    Expect(1, 173791, '\P{^Is_Block: cjkunifiedideographsextensionb}', "");
    Expect(0, 173792, '\p{Is_Block: cjkunifiedideographsextensionb}', "");
    Expect(1, 173792, '\p{^Is_Block: cjkunifiedideographsextensionb}', "");
    Expect(1, 173792, '\P{Is_Block: cjkunifiedideographsextensionb}', "");
    Expect(0, 173792, '\P{^Is_Block: cjkunifiedideographsextensionb}', "");
    Expect(1, 173791, '\p{Is_Block=_	CJK_Unified_Ideographs_Extension_b}', "");
    Expect(0, 173791, '\p{^Is_Block=_	CJK_Unified_Ideographs_Extension_b}', "");
    Expect(0, 173791, '\P{Is_Block=_	CJK_Unified_Ideographs_Extension_b}', "");
    Expect(1, 173791, '\P{^Is_Block=_	CJK_Unified_Ideographs_Extension_b}', "");
    Expect(0, 173792, '\p{Is_Block=_	CJK_Unified_Ideographs_Extension_b}', "");
    Expect(1, 173792, '\p{^Is_Block=_	CJK_Unified_Ideographs_Extension_b}', "");
    Expect(1, 173792, '\P{Is_Block=_	CJK_Unified_Ideographs_Extension_b}', "");
    Expect(0, 173792, '\P{^Is_Block=_	CJK_Unified_Ideographs_Extension_b}', "");
    Error('\p{Is_Blk:	_-CJK_EXT_b/a/}');
    Error('\P{Is_Blk:	_-CJK_EXT_b/a/}');
    Expect(1, 173791, '\p{Is_Blk:	cjkextb}', "");
    Expect(0, 173791, '\p{^Is_Blk:	cjkextb}', "");
    Expect(0, 173791, '\P{Is_Blk:	cjkextb}', "");
    Expect(1, 173791, '\P{^Is_Blk:	cjkextb}', "");
    Expect(0, 173792, '\p{Is_Blk:	cjkextb}', "");
    Expect(1, 173792, '\p{^Is_Blk:	cjkextb}', "");
    Expect(1, 173792, '\P{Is_Blk:	cjkextb}', "");
    Expect(0, 173792, '\P{^Is_Blk:	cjkextb}', "");
    Expect(1, 173791, '\p{Is_Blk=__CJK_EXT_B}', "");
    Expect(0, 173791, '\p{^Is_Blk=__CJK_EXT_B}', "");
    Expect(0, 173791, '\P{Is_Blk=__CJK_EXT_B}', "");
    Expect(1, 173791, '\P{^Is_Blk=__CJK_EXT_B}', "");
    Expect(0, 173792, '\p{Is_Blk=__CJK_EXT_B}', "");
    Expect(1, 173792, '\p{^Is_Blk=__CJK_EXT_B}', "");
    Expect(1, 173792, '\P{Is_Blk=__CJK_EXT_B}', "");
    Expect(0, 173792, '\P{^Is_Blk=__CJK_EXT_B}', "");
    Error('\p{Block:	/a/  CJK_UNIFIED_IDEOGRAPHS_Extension_C}');
    Error('\P{Block:	/a/  CJK_UNIFIED_IDEOGRAPHS_Extension_C}');
    Expect(1, 177983, '\p{Block=:\ACJK_Unified_Ideographs_Extension_C\z:}', "");;
    Expect(0, 177984, '\p{Block=:\ACJK_Unified_Ideographs_Extension_C\z:}', "");;
    Expect(1, 177983, '\p{Block=cjkunifiedideographsextensionc}', "");
    Expect(0, 177983, '\p{^Block=cjkunifiedideographsextensionc}', "");
    Expect(0, 177983, '\P{Block=cjkunifiedideographsextensionc}', "");
    Expect(1, 177983, '\P{^Block=cjkunifiedideographsextensionc}', "");
    Expect(0, 177984, '\p{Block=cjkunifiedideographsextensionc}', "");
    Expect(1, 177984, '\p{^Block=cjkunifiedideographsextensionc}', "");
    Expect(1, 177984, '\P{Block=cjkunifiedideographsextensionc}', "");
    Expect(0, 177984, '\P{^Block=cjkunifiedideographsextensionc}', "");
    Expect(1, 177983, '\p{Block=:\Acjkunifiedideographsextensionc\z:}', "");;
    Expect(0, 177984, '\p{Block=:\Acjkunifiedideographsextensionc\z:}', "");;
    Expect(1, 177983, '\p{Block=	CJK_UNIFIED_ideographs_Extension_C}', "");
    Expect(0, 177983, '\p{^Block=	CJK_UNIFIED_ideographs_Extension_C}', "");
    Expect(0, 177983, '\P{Block=	CJK_UNIFIED_ideographs_Extension_C}', "");
    Expect(1, 177983, '\P{^Block=	CJK_UNIFIED_ideographs_Extension_C}', "");
    Expect(0, 177984, '\p{Block=	CJK_UNIFIED_ideographs_Extension_C}', "");
    Expect(1, 177984, '\p{^Block=	CJK_UNIFIED_ideographs_Extension_C}', "");
    Expect(1, 177984, '\P{Block=	CJK_UNIFIED_ideographs_Extension_C}', "");
    Expect(0, 177984, '\P{^Block=	CJK_UNIFIED_ideographs_Extension_C}', "");
    Error('\p{Blk: /a/CJK_Ext_C}');
    Error('\P{Blk: /a/CJK_Ext_C}');
    Expect(1, 177983, '\p{Blk=:\ACJK_Ext_C\z:}', "");;
    Expect(0, 177984, '\p{Blk=:\ACJK_Ext_C\z:}', "");;
    Expect(1, 177983, '\p{Blk=cjkextc}', "");
    Expect(0, 177983, '\p{^Blk=cjkextc}', "");
    Expect(0, 177983, '\P{Blk=cjkextc}', "");
    Expect(1, 177983, '\P{^Blk=cjkextc}', "");
    Expect(0, 177984, '\p{Blk=cjkextc}', "");
    Expect(1, 177984, '\p{^Blk=cjkextc}', "");
    Expect(1, 177984, '\P{Blk=cjkextc}', "");
    Expect(0, 177984, '\P{^Blk=cjkextc}', "");
    Expect(1, 177983, '\p{Blk=:\Acjkextc\z:}', "");;
    Expect(0, 177984, '\p{Blk=:\Acjkextc\z:}', "");;
    Expect(1, 177983, '\p{Blk=	 cjk_Ext_C}', "");
    Expect(0, 177983, '\p{^Blk=	 cjk_Ext_C}', "");
    Expect(0, 177983, '\P{Blk=	 cjk_Ext_C}', "");
    Expect(1, 177983, '\P{^Blk=	 cjk_Ext_C}', "");
    Expect(0, 177984, '\p{Blk=	 cjk_Ext_C}', "");
    Expect(1, 177984, '\p{^Blk=	 cjk_Ext_C}', "");
    Expect(1, 177984, '\P{Blk=	 cjk_Ext_C}', "");
    Expect(0, 177984, '\P{^Blk=	 cjk_Ext_C}', "");
    Error('\p{Is_Block:_ CJK_Unified_ideographs_extension_c/a/}');
    Error('\P{Is_Block:_ CJK_Unified_ideographs_extension_c/a/}');
    Expect(1, 177983, '\p{Is_Block=cjkunifiedideographsextensionc}', "");
    Expect(0, 177983, '\p{^Is_Block=cjkunifiedideographsextensionc}', "");
    Expect(0, 177983, '\P{Is_Block=cjkunifiedideographsextensionc}', "");
    Expect(1, 177983, '\P{^Is_Block=cjkunifiedideographsextensionc}', "");
    Expect(0, 177984, '\p{Is_Block=cjkunifiedideographsextensionc}', "");
    Expect(1, 177984, '\p{^Is_Block=cjkunifiedideographsextensionc}', "");
    Expect(1, 177984, '\P{Is_Block=cjkunifiedideographsextensionc}', "");
    Expect(0, 177984, '\P{^Is_Block=cjkunifiedideographsextensionc}', "");
    Expect(1, 177983, '\p{Is_Block= _CJK_unified_Ideographs_extension_c}', "");
    Expect(0, 177983, '\p{^Is_Block= _CJK_unified_Ideographs_extension_c}', "");
    Expect(0, 177983, '\P{Is_Block= _CJK_unified_Ideographs_extension_c}', "");
    Expect(1, 177983, '\P{^Is_Block= _CJK_unified_Ideographs_extension_c}', "");
    Expect(0, 177984, '\p{Is_Block= _CJK_unified_Ideographs_extension_c}', "");
    Expect(1, 177984, '\p{^Is_Block= _CJK_unified_Ideographs_extension_c}', "");
    Expect(1, 177984, '\P{Is_Block= _CJK_unified_Ideographs_extension_c}', "");
    Expect(0, 177984, '\P{^Is_Block= _CJK_unified_Ideographs_extension_c}', "");
    Error('\p{Is_Blk::= -cjk_Ext_C}');
    Error('\P{Is_Blk::= -cjk_Ext_C}');
    Expect(1, 177983, '\p{Is_Blk=cjkextc}', "");
    Expect(0, 177983, '\p{^Is_Blk=cjkextc}', "");
    Expect(0, 177983, '\P{Is_Blk=cjkextc}', "");
    Expect(1, 177983, '\P{^Is_Blk=cjkextc}', "");
    Expect(0, 177984, '\p{Is_Blk=cjkextc}', "");
    Expect(1, 177984, '\p{^Is_Blk=cjkextc}', "");
    Expect(1, 177984, '\P{Is_Blk=cjkextc}', "");
    Expect(0, 177984, '\P{^Is_Blk=cjkextc}', "");
    Expect(1, 177983, '\p{Is_Blk= 	CJK_ext_C}', "");
    Expect(0, 177983, '\p{^Is_Blk= 	CJK_ext_C}', "");
    Expect(0, 177983, '\P{Is_Blk= 	CJK_ext_C}', "");
    Expect(1, 177983, '\P{^Is_Blk= 	CJK_ext_C}', "");
    Expect(0, 177984, '\p{Is_Blk= 	CJK_ext_C}', "");
    Expect(1, 177984, '\p{^Is_Blk= 	CJK_ext_C}', "");
    Expect(1, 177984, '\P{Is_Blk= 	CJK_ext_C}', "");
    Expect(0, 177984, '\P{^Is_Blk= 	CJK_ext_C}', "");
    Error('\p{Block=	CJK_unified_IDEOGRAPHS_EXTENSION_D/a/}');
    Error('\P{Block=	CJK_unified_IDEOGRAPHS_EXTENSION_D/a/}');
    Expect(1, 178207, '\p{Block=:\ACJK_Unified_Ideographs_Extension_D\z:}', "");;
    Expect(0, 178208, '\p{Block=:\ACJK_Unified_Ideographs_Extension_D\z:}', "");;
    Expect(1, 178207, '\p{Block=cjkunifiedideographsextensiond}', "");
    Expect(0, 178207, '\p{^Block=cjkunifiedideographsextensiond}', "");
    Expect(0, 178207, '\P{Block=cjkunifiedideographsextensiond}', "");
    Expect(1, 178207, '\P{^Block=cjkunifiedideographsextensiond}', "");
    Expect(0, 178208, '\p{Block=cjkunifiedideographsextensiond}', "");
    Expect(1, 178208, '\p{^Block=cjkunifiedideographsextensiond}', "");
    Expect(1, 178208, '\P{Block=cjkunifiedideographsextensiond}', "");
    Expect(0, 178208, '\P{^Block=cjkunifiedideographsextensiond}', "");
    Expect(1, 178207, '\p{Block=:\Acjkunifiedideographsextensiond\z:}', "");;
    Expect(0, 178208, '\p{Block=:\Acjkunifiedideographsextensiond\z:}', "");;
    Expect(1, 178207, '\p{Block=	_CJK_UNIFIED_Ideographs_Extension_D}', "");
    Expect(0, 178207, '\p{^Block=	_CJK_UNIFIED_Ideographs_Extension_D}', "");
    Expect(0, 178207, '\P{Block=	_CJK_UNIFIED_Ideographs_Extension_D}', "");
    Expect(1, 178207, '\P{^Block=	_CJK_UNIFIED_Ideographs_Extension_D}', "");
    Expect(0, 178208, '\p{Block=	_CJK_UNIFIED_Ideographs_Extension_D}', "");
    Expect(1, 178208, '\p{^Block=	_CJK_UNIFIED_Ideographs_Extension_D}', "");
    Expect(1, 178208, '\P{Block=	_CJK_UNIFIED_Ideographs_Extension_D}', "");
    Expect(0, 178208, '\P{^Block=	_CJK_UNIFIED_Ideographs_Extension_D}', "");
    Error('\p{Blk: /a/cjk_Ext_D}');
    Error('\P{Blk: /a/cjk_Ext_D}');
    Expect(1, 178207, '\p{Blk=:\ACJK_Ext_D\z:}', "");;
    Expect(0, 178208, '\p{Blk=:\ACJK_Ext_D\z:}', "");;
    Expect(1, 178207, '\p{Blk=cjkextd}', "");
    Expect(0, 178207, '\p{^Blk=cjkextd}', "");
    Expect(0, 178207, '\P{Blk=cjkextd}', "");
    Expect(1, 178207, '\P{^Blk=cjkextd}', "");
    Expect(0, 178208, '\p{Blk=cjkextd}', "");
    Expect(1, 178208, '\p{^Blk=cjkextd}', "");
    Expect(1, 178208, '\P{Blk=cjkextd}', "");
    Expect(0, 178208, '\P{^Blk=cjkextd}', "");
    Expect(1, 178207, '\p{Blk=:\Acjkextd\z:}', "");;
    Expect(0, 178208, '\p{Blk=:\Acjkextd\z:}', "");;
    Expect(1, 178207, '\p{Blk= -CJK_EXT_D}', "");
    Expect(0, 178207, '\p{^Blk= -CJK_EXT_D}', "");
    Expect(0, 178207, '\P{Blk= -CJK_EXT_D}', "");
    Expect(1, 178207, '\P{^Blk= -CJK_EXT_D}', "");
    Expect(0, 178208, '\p{Blk= -CJK_EXT_D}', "");
    Expect(1, 178208, '\p{^Blk= -CJK_EXT_D}', "");
    Expect(1, 178208, '\P{Blk= -CJK_EXT_D}', "");
    Expect(0, 178208, '\P{^Blk= -CJK_EXT_D}', "");
    Error('\p{Is_Block=-CJK_UNIFIED_Ideographs_Extension_D:=}');
    Error('\P{Is_Block=-CJK_UNIFIED_Ideographs_Extension_D:=}');
    Expect(1, 178207, '\p{Is_Block=cjkunifiedideographsextensiond}', "");
    Expect(0, 178207, '\p{^Is_Block=cjkunifiedideographsextensiond}', "");
    Expect(0, 178207, '\P{Is_Block=cjkunifiedideographsextensiond}', "");
    Expect(1, 178207, '\P{^Is_Block=cjkunifiedideographsextensiond}', "");
    Expect(0, 178208, '\p{Is_Block=cjkunifiedideographsextensiond}', "");
    Expect(1, 178208, '\p{^Is_Block=cjkunifiedideographsextensiond}', "");
    Expect(1, 178208, '\P{Is_Block=cjkunifiedideographsextensiond}', "");
    Expect(0, 178208, '\P{^Is_Block=cjkunifiedideographsextensiond}', "");
    Expect(1, 178207, '\p{Is_Block= CJK_Unified_Ideographs_EXTENSION_D}', "");
    Expect(0, 178207, '\p{^Is_Block= CJK_Unified_Ideographs_EXTENSION_D}', "");
    Expect(0, 178207, '\P{Is_Block= CJK_Unified_Ideographs_EXTENSION_D}', "");
    Expect(1, 178207, '\P{^Is_Block= CJK_Unified_Ideographs_EXTENSION_D}', "");
    Expect(0, 178208, '\p{Is_Block= CJK_Unified_Ideographs_EXTENSION_D}', "");
    Expect(1, 178208, '\p{^Is_Block= CJK_Unified_Ideographs_EXTENSION_D}', "");
    Expect(1, 178208, '\P{Is_Block= CJK_Unified_Ideographs_EXTENSION_D}', "");
    Expect(0, 178208, '\P{^Is_Block= CJK_Unified_Ideographs_EXTENSION_D}', "");
    Error('\p{Is_Blk:_ CJK_Ext_d:=}');
    Error('\P{Is_Blk:_ CJK_Ext_d:=}');
    Expect(1, 178207, '\p{Is_Blk:cjkextd}', "");
    Expect(0, 178207, '\p{^Is_Blk:cjkextd}', "");
    Expect(0, 178207, '\P{Is_Blk:cjkextd}', "");
    Expect(1, 178207, '\P{^Is_Blk:cjkextd}', "");
    Expect(0, 178208, '\p{Is_Blk:cjkextd}', "");
    Expect(1, 178208, '\p{^Is_Blk:cjkextd}', "");
    Expect(1, 178208, '\P{Is_Blk:cjkextd}', "");
    Expect(0, 178208, '\P{^Is_Blk:cjkextd}', "");
    Expect(1, 178207, '\p{Is_Blk= -cjk_Ext_D}', "");
    Expect(0, 178207, '\p{^Is_Blk= -cjk_Ext_D}', "");
    Expect(0, 178207, '\P{Is_Blk= -cjk_Ext_D}', "");
    Expect(1, 178207, '\P{^Is_Blk= -cjk_Ext_D}', "");
    Expect(0, 178208, '\p{Is_Blk= -cjk_Ext_D}', "");
    Expect(1, 178208, '\p{^Is_Blk= -cjk_Ext_D}', "");
    Expect(1, 178208, '\P{Is_Blk= -cjk_Ext_D}', "");
    Expect(0, 178208, '\P{^Is_Blk= -cjk_Ext_D}', "");
    Error('\p{Block=-_CJK_UNIFIED_Ideographs_Extension_E:=}');
    Error('\P{Block=-_CJK_UNIFIED_Ideographs_Extension_E:=}');
    Expect(1, 183983, '\p{Block=:\ACJK_Unified_Ideographs_Extension_E\z:}', "");;
    Expect(0, 183984, '\p{Block=:\ACJK_Unified_Ideographs_Extension_E\z:}', "");;
    Expect(1, 183983, '\p{Block=cjkunifiedideographsextensione}', "");
    Expect(0, 183983, '\p{^Block=cjkunifiedideographsextensione}', "");
    Expect(0, 183983, '\P{Block=cjkunifiedideographsextensione}', "");
    Expect(1, 183983, '\P{^Block=cjkunifiedideographsextensione}', "");
    Expect(0, 183984, '\p{Block=cjkunifiedideographsextensione}', "");
    Expect(1, 183984, '\p{^Block=cjkunifiedideographsextensione}', "");
    Expect(1, 183984, '\P{Block=cjkunifiedideographsextensione}', "");
    Expect(0, 183984, '\P{^Block=cjkunifiedideographsextensione}', "");
    Expect(1, 183983, '\p{Block=:\Acjkunifiedideographsextensione\z:}', "");;
    Expect(0, 183984, '\p{Block=:\Acjkunifiedideographsextensione\z:}', "");;
    Expect(1, 183983, '\p{Block=	-cjk_Unified_ideographs_extension_E}', "");
    Expect(0, 183983, '\p{^Block=	-cjk_Unified_ideographs_extension_E}', "");
    Expect(0, 183983, '\P{Block=	-cjk_Unified_ideographs_extension_E}', "");
    Expect(1, 183983, '\P{^Block=	-cjk_Unified_ideographs_extension_E}', "");
    Expect(0, 183984, '\p{Block=	-cjk_Unified_ideographs_extension_E}', "");
    Expect(1, 183984, '\p{^Block=	-cjk_Unified_ideographs_extension_E}', "");
    Expect(1, 183984, '\P{Block=	-cjk_Unified_ideographs_extension_E}', "");
    Expect(0, 183984, '\P{^Block=	-cjk_Unified_ideographs_extension_E}', "");
    Error('\p{Blk=:= CJK_ext_E}');
    Error('\P{Blk=:= CJK_ext_E}');
    Expect(1, 183983, '\p{Blk=:\ACJK_Ext_E\z:}', "");;
    Expect(0, 183984, '\p{Blk=:\ACJK_Ext_E\z:}', "");;
    Expect(1, 183983, '\p{Blk=cjkexte}', "");
    Expect(0, 183983, '\p{^Blk=cjkexte}', "");
    Expect(0, 183983, '\P{Blk=cjkexte}', "");
    Expect(1, 183983, '\P{^Blk=cjkexte}', "");
    Expect(0, 183984, '\p{Blk=cjkexte}', "");
    Expect(1, 183984, '\p{^Blk=cjkexte}', "");
    Expect(1, 183984, '\P{Blk=cjkexte}', "");
    Expect(0, 183984, '\P{^Blk=cjkexte}', "");
    Expect(1, 183983, '\p{Blk=:\Acjkexte\z:}', "");;
    Expect(0, 183984, '\p{Blk=:\Acjkexte\z:}', "");;
    Expect(1, 183983, '\p{Blk=__CJK_EXT_E}', "");
    Expect(0, 183983, '\p{^Blk=__CJK_EXT_E}', "");
    Expect(0, 183983, '\P{Blk=__CJK_EXT_E}', "");
    Expect(1, 183983, '\P{^Blk=__CJK_EXT_E}', "");
    Expect(0, 183984, '\p{Blk=__CJK_EXT_E}', "");
    Expect(1, 183984, '\p{^Blk=__CJK_EXT_E}', "");
    Expect(1, 183984, '\P{Blk=__CJK_EXT_E}', "");
    Expect(0, 183984, '\P{^Blk=__CJK_EXT_E}', "");
    Error('\p{Is_Block=/a/CJK_Unified_ideographs_extension_E}');
    Error('\P{Is_Block=/a/CJK_Unified_ideographs_extension_E}');
    Expect(1, 183983, '\p{Is_Block=cjkunifiedideographsextensione}', "");
    Expect(0, 183983, '\p{^Is_Block=cjkunifiedideographsextensione}', "");
    Expect(0, 183983, '\P{Is_Block=cjkunifiedideographsextensione}', "");
    Expect(1, 183983, '\P{^Is_Block=cjkunifiedideographsextensione}', "");
    Expect(0, 183984, '\p{Is_Block=cjkunifiedideographsextensione}', "");
    Expect(1, 183984, '\p{^Is_Block=cjkunifiedideographsextensione}', "");
    Expect(1, 183984, '\P{Is_Block=cjkunifiedideographsextensione}', "");
    Expect(0, 183984, '\P{^Is_Block=cjkunifiedideographsextensione}', "");
    Expect(1, 183983, '\p{Is_Block=_-CJK_unified_ideographs_extension_E}', "");
    Expect(0, 183983, '\p{^Is_Block=_-CJK_unified_ideographs_extension_E}', "");
    Expect(0, 183983, '\P{Is_Block=_-CJK_unified_ideographs_extension_E}', "");
    Expect(1, 183983, '\P{^Is_Block=_-CJK_unified_ideographs_extension_E}', "");
    Expect(0, 183984, '\p{Is_Block=_-CJK_unified_ideographs_extension_E}', "");
    Expect(1, 183984, '\p{^Is_Block=_-CJK_unified_ideographs_extension_E}', "");
    Expect(1, 183984, '\P{Is_Block=_-CJK_unified_ideographs_extension_E}', "");
    Expect(0, 183984, '\P{^Is_Block=_-CJK_unified_ideographs_extension_E}', "");
    Error('\p{Is_Blk=:=-CJK_Ext_E}');
    Error('\P{Is_Blk=:=-CJK_Ext_E}');
    Expect(1, 183983, '\p{Is_Blk=cjkexte}', "");
    Expect(0, 183983, '\p{^Is_Blk=cjkexte}', "");
    Expect(0, 183983, '\P{Is_Blk=cjkexte}', "");
    Expect(1, 183983, '\P{^Is_Blk=cjkexte}', "");
    Expect(0, 183984, '\p{Is_Blk=cjkexte}', "");
    Expect(1, 183984, '\p{^Is_Blk=cjkexte}', "");
    Expect(1, 183984, '\P{Is_Blk=cjkexte}', "");
    Expect(0, 183984, '\P{^Is_Blk=cjkexte}', "");
    Expect(1, 183983, '\p{Is_Blk=--CJK_Ext_E}', "");
    Expect(0, 183983, '\p{^Is_Blk=--CJK_Ext_E}', "");
    Expect(0, 183983, '\P{Is_Blk=--CJK_Ext_E}', "");
    Expect(1, 183983, '\P{^Is_Blk=--CJK_Ext_E}', "");
    Expect(0, 183984, '\p{Is_Blk=--CJK_Ext_E}', "");
    Expect(1, 183984, '\p{^Is_Blk=--CJK_Ext_E}', "");
    Expect(1, 183984, '\P{Is_Blk=--CJK_Ext_E}', "");
    Expect(0, 183984, '\P{^Is_Blk=--CJK_Ext_E}', "");
    Error('\p{Block= :=CJK_Unified_ideographs_EXTENSION_F}');
    Error('\P{Block= :=CJK_Unified_ideographs_EXTENSION_F}');
    Expect(1, 191471, '\p{Block=:\ACJK_Unified_Ideographs_Extension_F\z:}', "");;
    Expect(0, 191472, '\p{Block=:\ACJK_Unified_Ideographs_Extension_F\z:}', "");;
    Expect(1, 191471, '\p{Block=cjkunifiedideographsextensionf}', "");
    Expect(0, 191471, '\p{^Block=cjkunifiedideographsextensionf}', "");
    Expect(0, 191471, '\P{Block=cjkunifiedideographsextensionf}', "");
    Expect(1, 191471, '\P{^Block=cjkunifiedideographsextensionf}', "");
    Expect(0, 191472, '\p{Block=cjkunifiedideographsextensionf}', "");
    Expect(1, 191472, '\p{^Block=cjkunifiedideographsextensionf}', "");
    Expect(1, 191472, '\P{Block=cjkunifiedideographsextensionf}', "");
    Expect(0, 191472, '\P{^Block=cjkunifiedideographsextensionf}', "");
    Expect(1, 191471, '\p{Block=:\Acjkunifiedideographsextensionf\z:}', "");;
    Expect(0, 191472, '\p{Block=:\Acjkunifiedideographsextensionf\z:}', "");;
    Expect(1, 191471, '\p{Block=	_cjk_Unified_Ideographs_extension_F}', "");
    Expect(0, 191471, '\p{^Block=	_cjk_Unified_Ideographs_extension_F}', "");
    Expect(0, 191471, '\P{Block=	_cjk_Unified_Ideographs_extension_F}', "");
    Expect(1, 191471, '\P{^Block=	_cjk_Unified_Ideographs_extension_F}', "");
    Expect(0, 191472, '\p{Block=	_cjk_Unified_Ideographs_extension_F}', "");
    Expect(1, 191472, '\p{^Block=	_cjk_Unified_Ideographs_extension_F}', "");
    Expect(1, 191472, '\P{Block=	_cjk_Unified_Ideographs_extension_F}', "");
    Expect(0, 191472, '\P{^Block=	_cjk_Unified_Ideographs_extension_F}', "");
    Error('\p{Blk=_/a/CJK_Ext_F}');
    Error('\P{Blk=_/a/CJK_Ext_F}');
    Expect(1, 191471, '\p{Blk=:\ACJK_Ext_F\z:}', "");;
    Expect(0, 191472, '\p{Blk=:\ACJK_Ext_F\z:}', "");;
    Expect(1, 191471, '\p{Blk=cjkextf}', "");
    Expect(0, 191471, '\p{^Blk=cjkextf}', "");
    Expect(0, 191471, '\P{Blk=cjkextf}', "");
    Expect(1, 191471, '\P{^Blk=cjkextf}', "");
    Expect(0, 191472, '\p{Blk=cjkextf}', "");
    Expect(1, 191472, '\p{^Blk=cjkextf}', "");
    Expect(1, 191472, '\P{Blk=cjkextf}', "");
    Expect(0, 191472, '\P{^Blk=cjkextf}', "");
    Expect(1, 191471, '\p{Blk=:\Acjkextf\z:}', "");;
    Expect(0, 191472, '\p{Blk=:\Acjkextf\z:}', "");;
    Expect(1, 191471, '\p{Blk=--CJK_EXT_F}', "");
    Expect(0, 191471, '\p{^Blk=--CJK_EXT_F}', "");
    Expect(0, 191471, '\P{Blk=--CJK_EXT_F}', "");
    Expect(1, 191471, '\P{^Blk=--CJK_EXT_F}', "");
    Expect(0, 191472, '\p{Blk=--CJK_EXT_F}', "");
    Expect(1, 191472, '\p{^Blk=--CJK_EXT_F}', "");
    Expect(1, 191472, '\P{Blk=--CJK_EXT_F}', "");
    Expect(0, 191472, '\P{^Blk=--CJK_EXT_F}', "");
    Error('\p{Is_Block=/a/-cjk_unified_Ideographs_Extension_f}');
    Error('\P{Is_Block=/a/-cjk_unified_Ideographs_Extension_f}');
    Expect(1, 191471, '\p{Is_Block=cjkunifiedideographsextensionf}', "");
    Expect(0, 191471, '\p{^Is_Block=cjkunifiedideographsextensionf}', "");
    Expect(0, 191471, '\P{Is_Block=cjkunifiedideographsextensionf}', "");
    Expect(1, 191471, '\P{^Is_Block=cjkunifiedideographsextensionf}', "");
    Expect(0, 191472, '\p{Is_Block=cjkunifiedideographsextensionf}', "");
    Expect(1, 191472, '\p{^Is_Block=cjkunifiedideographsextensionf}', "");
    Expect(1, 191472, '\P{Is_Block=cjkunifiedideographsextensionf}', "");
    Expect(0, 191472, '\P{^Is_Block=cjkunifiedideographsextensionf}', "");
    Expect(1, 191471, '\p{Is_Block= CJK_Unified_ideographs_Extension_F}', "");
    Expect(0, 191471, '\p{^Is_Block= CJK_Unified_ideographs_Extension_F}', "");
    Expect(0, 191471, '\P{Is_Block= CJK_Unified_ideographs_Extension_F}', "");
    Expect(1, 191471, '\P{^Is_Block= CJK_Unified_ideographs_Extension_F}', "");
    Expect(0, 191472, '\p{Is_Block= CJK_Unified_ideographs_Extension_F}', "");
    Expect(1, 191472, '\p{^Is_Block= CJK_Unified_ideographs_Extension_F}', "");
    Expect(1, 191472, '\P{Is_Block= CJK_Unified_ideographs_Extension_F}', "");
    Expect(0, 191472, '\P{^Is_Block= CJK_Unified_ideographs_Extension_F}', "");
    Error('\p{Is_Blk= CJK_Ext_f/a/}');
    Error('\P{Is_Blk= CJK_Ext_f/a/}');
    Expect(1, 191471, '\p{Is_Blk:	cjkextf}', "");
    Expect(0, 191471, '\p{^Is_Blk:	cjkextf}', "");
    Expect(0, 191471, '\P{Is_Blk:	cjkextf}', "");
    Expect(1, 191471, '\P{^Is_Blk:	cjkextf}', "");
    Expect(0, 191472, '\p{Is_Blk:	cjkextf}', "");
    Expect(1, 191472, '\p{^Is_Blk:	cjkextf}', "");
    Expect(1, 191472, '\P{Is_Blk:	cjkextf}', "");
    Expect(0, 191472, '\P{^Is_Blk:	cjkextf}', "");
    Expect(1, 191471, '\p{Is_Blk=  CJK_Ext_F}', "");
    Expect(0, 191471, '\p{^Is_Blk=  CJK_Ext_F}', "");
    Expect(0, 191471, '\P{Is_Blk=  CJK_Ext_F}', "");
    Expect(1, 191471, '\P{^Is_Blk=  CJK_Ext_F}', "");
    Expect(0, 191472, '\p{Is_Blk=  CJK_Ext_F}', "");
    Expect(1, 191472, '\p{^Is_Blk=  CJK_Ext_F}', "");
    Expect(1, 191472, '\P{Is_Blk=  CJK_Ext_F}', "");
    Expect(0, 191472, '\P{^Is_Blk=  CJK_Ext_F}', "");
    Error('\p{Block=CJK_Unified_ideographs_EXTENSION_G/a/}');
    Error('\P{Block=CJK_Unified_ideographs_EXTENSION_G/a/}');
    Expect(1, 201551, '\p{Block=:\ACJK_Unified_Ideographs_Extension_G\z:}', "");;
    Expect(0, 201552, '\p{Block=:\ACJK_Unified_Ideographs_Extension_G\z:}', "");;
    Expect(1, 201551, '\p{Block=cjkunifiedideographsextensiong}', "");
    Expect(0, 201551, '\p{^Block=cjkunifiedideographsextensiong}', "");
    Expect(0, 201551, '\P{Block=cjkunifiedideographsextensiong}', "");
    Expect(1, 201551, '\P{^Block=cjkunifiedideographsextensiong}', "");
    Expect(0, 201552, '\p{Block=cjkunifiedideographsextensiong}', "");
    Expect(1, 201552, '\p{^Block=cjkunifiedideographsextensiong}', "");
    Expect(1, 201552, '\P{Block=cjkunifiedideographsextensiong}', "");
    Expect(0, 201552, '\P{^Block=cjkunifiedideographsextensiong}', "");
    Expect(1, 201551, '\p{Block=:\Acjkunifiedideographsextensiong\z:}', "");;
    Expect(0, 201552, '\p{Block=:\Acjkunifiedideographsextensiong\z:}', "");;
    Expect(1, 201551, '\p{Block:  CJK_UNIFIED_IDEOGRAPHS_Extension_G}', "");
    Expect(0, 201551, '\p{^Block:  CJK_UNIFIED_IDEOGRAPHS_Extension_G}', "");
    Expect(0, 201551, '\P{Block:  CJK_UNIFIED_IDEOGRAPHS_Extension_G}', "");
    Expect(1, 201551, '\P{^Block:  CJK_UNIFIED_IDEOGRAPHS_Extension_G}', "");
    Expect(0, 201552, '\p{Block:  CJK_UNIFIED_IDEOGRAPHS_Extension_G}', "");
    Expect(1, 201552, '\p{^Block:  CJK_UNIFIED_IDEOGRAPHS_Extension_G}', "");
    Expect(1, 201552, '\P{Block:  CJK_UNIFIED_IDEOGRAPHS_Extension_G}', "");
    Expect(0, 201552, '\P{^Block:  CJK_UNIFIED_IDEOGRAPHS_Extension_G}', "");
    Error('\p{Blk= /a/CJK_Ext_G}');
    Error('\P{Blk= /a/CJK_Ext_G}');
    Expect(1, 201551, '\p{Blk=:\ACJK_Ext_G\z:}', "");;
    Expect(0, 201552, '\p{Blk=:\ACJK_Ext_G\z:}', "");;
    Expect(1, 201551, '\p{Blk=cjkextg}', "");
    Expect(0, 201551, '\p{^Blk=cjkextg}', "");
    Expect(0, 201551, '\P{Blk=cjkextg}', "");
    Expect(1, 201551, '\P{^Blk=cjkextg}', "");
    Expect(0, 201552, '\p{Blk=cjkextg}', "");
    Expect(1, 201552, '\p{^Blk=cjkextg}', "");
    Expect(1, 201552, '\P{Blk=cjkextg}', "");
    Expect(0, 201552, '\P{^Blk=cjkextg}', "");
    Expect(1, 201551, '\p{Blk=:\Acjkextg\z:}', "");;
    Expect(0, 201552, '\p{Blk=:\Acjkextg\z:}', "");;
    Expect(1, 201551, '\p{Blk=	-CJK_Ext_g}', "");
    Expect(0, 201551, '\p{^Blk=	-CJK_Ext_g}', "");
    Expect(0, 201551, '\P{Blk=	-CJK_Ext_g}', "");
    Expect(1, 201551, '\P{^Blk=	-CJK_Ext_g}', "");
    Expect(0, 201552, '\p{Blk=	-CJK_Ext_g}', "");
    Expect(1, 201552, '\p{^Blk=	-CJK_Ext_g}', "");
    Expect(1, 201552, '\P{Blk=	-CJK_Ext_g}', "");
    Expect(0, 201552, '\P{^Blk=	-CJK_Ext_g}', "");
    Error('\p{Is_Block=-cjk_UNIFIED_Ideographs_Extension_G/a/}');
    Error('\P{Is_Block=-cjk_UNIFIED_Ideographs_Extension_G/a/}');
    Expect(1, 201551, '\p{Is_Block=cjkunifiedideographsextensiong}', "");
    Expect(0, 201551, '\p{^Is_Block=cjkunifiedideographsextensiong}', "");
    Expect(0, 201551, '\P{Is_Block=cjkunifiedideographsextensiong}', "");
    Expect(1, 201551, '\P{^Is_Block=cjkunifiedideographsextensiong}', "");
    Expect(0, 201552, '\p{Is_Block=cjkunifiedideographsextensiong}', "");
    Expect(1, 201552, '\p{^Is_Block=cjkunifiedideographsextensiong}', "");
    Expect(1, 201552, '\P{Is_Block=cjkunifiedideographsextensiong}', "");
    Expect(0, 201552, '\P{^Is_Block=cjkunifiedideographsextensiong}', "");
    Expect(1, 201551, '\p{Is_Block=__CJK_unified_Ideographs_Extension_G}', "");
    Expect(0, 201551, '\p{^Is_Block=__CJK_unified_Ideographs_Extension_G}', "");
    Expect(0, 201551, '\P{Is_Block=__CJK_unified_Ideographs_Extension_G}', "");
    Expect(1, 201551, '\P{^Is_Block=__CJK_unified_Ideographs_Extension_G}', "");
    Expect(0, 201552, '\p{Is_Block=__CJK_unified_Ideographs_Extension_G}', "");
    Expect(1, 201552, '\p{^Is_Block=__CJK_unified_Ideographs_Extension_G}', "");
    Expect(1, 201552, '\P{Is_Block=__CJK_unified_Ideographs_Extension_G}', "");
    Expect(0, 201552, '\P{^Is_Block=__CJK_unified_Ideographs_Extension_G}', "");
    Error('\p{Is_Blk= 	CJK_Ext_g/a/}');
    Error('\P{Is_Blk= 	CJK_Ext_g/a/}');
    Expect(1, 201551, '\p{Is_Blk=cjkextg}', "");
    Expect(0, 201551, '\p{^Is_Blk=cjkextg}', "");
    Expect(0, 201551, '\P{Is_Blk=cjkextg}', "");
    Expect(1, 201551, '\P{^Is_Blk=cjkextg}', "");
    Expect(0, 201552, '\p{Is_Blk=cjkextg}', "");
    Expect(1, 201552, '\p{^Is_Blk=cjkextg}', "");
    Expect(1, 201552, '\P{Is_Blk=cjkextg}', "");
    Expect(0, 201552, '\P{^Is_Blk=cjkextg}', "");
    Expect(1, 201551, '\p{Is_Blk=-CJK_Ext_G}', "");
    Expect(0, 201551, '\p{^Is_Blk=-CJK_Ext_G}', "");
    Expect(0, 201551, '\P{Is_Blk=-CJK_Ext_G}', "");
    Expect(1, 201551, '\P{^Is_Blk=-CJK_Ext_G}', "");
    Expect(0, 201552, '\p{Is_Blk=-CJK_Ext_G}', "");
    Expect(1, 201552, '\p{^Is_Blk=-CJK_Ext_G}', "");
    Expect(1, 201552, '\P{Is_Blk=-CJK_Ext_G}', "");
    Expect(0, 201552, '\P{^Is_Blk=-CJK_Ext_G}', "");
    Error('\p{Block=-CJK_UNIFIED_ideographs_EXTENSION_H:=}');
    Error('\P{Block=-CJK_UNIFIED_ideographs_EXTENSION_H:=}');
    Expect(1, 205743, '\p{Block=:\ACJK_Unified_Ideographs_Extension_H\z:}', "");;
    Expect(0, 205744, '\p{Block=:\ACJK_Unified_Ideographs_Extension_H\z:}', "");;
    Expect(1, 205743, '\p{Block=cjkunifiedideographsextensionh}', "");
    Expect(0, 205743, '\p{^Block=cjkunifiedideographsextensionh}', "");
    Expect(0, 205743, '\P{Block=cjkunifiedideographsextensionh}', "");
    Expect(1, 205743, '\P{^Block=cjkunifiedideographsextensionh}', "");
    Expect(0, 205744, '\p{Block=cjkunifiedideographsextensionh}', "");
    Expect(1, 205744, '\p{^Block=cjkunifiedideographsextensionh}', "");
    Expect(1, 205744, '\P{Block=cjkunifiedideographsextensionh}', "");
    Expect(0, 205744, '\P{^Block=cjkunifiedideographsextensionh}', "");
    Expect(1, 205743, '\p{Block=:\Acjkunifiedideographsextensionh\z:}', "");;
    Expect(0, 205744, '\p{Block=:\Acjkunifiedideographsextensionh\z:}', "");;
    Expect(1, 205743, '\p{Block=	-CJK_UNIFIED_Ideographs_Extension_H}', "");
    Expect(0, 205743, '\p{^Block=	-CJK_UNIFIED_Ideographs_Extension_H}', "");
    Expect(0, 205743, '\P{Block=	-CJK_UNIFIED_Ideographs_Extension_H}', "");
    Expect(1, 205743, '\P{^Block=	-CJK_UNIFIED_Ideographs_Extension_H}', "");
    Expect(0, 205744, '\p{Block=	-CJK_UNIFIED_Ideographs_Extension_H}', "");
    Expect(1, 205744, '\p{^Block=	-CJK_UNIFIED_Ideographs_Extension_H}', "");
    Expect(1, 205744, '\P{Block=	-CJK_UNIFIED_Ideographs_Extension_H}', "");
    Expect(0, 205744, '\P{^Block=	-CJK_UNIFIED_Ideographs_Extension_H}', "");
    Error('\p{Blk=-_CJK_ext_H:=}');
    Error('\P{Blk=-_CJK_ext_H:=}');
    Expect(1, 205743, '\p{Blk=:\ACJK_Ext_H\z:}', "");;
    Expect(0, 205744, '\p{Blk=:\ACJK_Ext_H\z:}', "");;
    Expect(1, 205743, '\p{Blk=cjkexth}', "");
    Expect(0, 205743, '\p{^Blk=cjkexth}', "");
    Expect(0, 205743, '\P{Blk=cjkexth}', "");
    Expect(1, 205743, '\P{^Blk=cjkexth}', "");
    Expect(0, 205744, '\p{Blk=cjkexth}', "");
    Expect(1, 205744, '\p{^Blk=cjkexth}', "");
    Expect(1, 205744, '\P{Blk=cjkexth}', "");
    Expect(0, 205744, '\P{^Blk=cjkexth}', "");
    Expect(1, 205743, '\p{Blk=:\Acjkexth\z:}', "");;
    Expect(0, 205744, '\p{Blk=:\Acjkexth\z:}', "");;
    Expect(1, 205743, '\p{Blk=	cjk_Ext_H}', "");
    Expect(0, 205743, '\p{^Blk=	cjk_Ext_H}', "");
    Expect(0, 205743, '\P{Blk=	cjk_Ext_H}', "");
    Expect(1, 205743, '\P{^Blk=	cjk_Ext_H}', "");
    Expect(0, 205744, '\p{Blk=	cjk_Ext_H}', "");
    Expect(1, 205744, '\p{^Blk=	cjk_Ext_H}', "");
    Expect(1, 205744, '\P{Blk=	cjk_Ext_H}', "");
    Expect(0, 205744, '\P{^Blk=	cjk_Ext_H}', "");
    Error('\p{Is_Block=	/a/CJK_unified_ideographs_Extension_h}');
    Error('\P{Is_Block=	/a/CJK_unified_ideographs_Extension_h}');
    Expect(1, 205743, '\p{Is_Block=cjkunifiedideographsextensionh}', "");
    Expect(0, 205743, '\p{^Is_Block=cjkunifiedideographsextensionh}', "");
    Expect(0, 205743, '\P{Is_Block=cjkunifiedideographsextensionh}', "");
    Expect(1, 205743, '\P{^Is_Block=cjkunifiedideographsextensionh}', "");
    Expect(0, 205744, '\p{Is_Block=cjkunifiedideographsextensionh}', "");
    Expect(1, 205744, '\p{^Is_Block=cjkunifiedideographsextensionh}', "");
    Expect(1, 205744, '\P{Is_Block=cjkunifiedideographsextensionh}', "");
    Expect(0, 205744, '\P{^Is_Block=cjkunifiedideographsextensionh}', "");
    Expect(1, 205743, '\p{Is_Block=-	CJK_UNIFIED_IDEOGRAPHS_EXTENSION_H}', "");
    Expect(0, 205743, '\p{^Is_Block=-	CJK_UNIFIED_IDEOGRAPHS_EXTENSION_H}', "");
    Expect(0, 205743, '\P{Is_Block=-	CJK_UNIFIED_IDEOGRAPHS_EXTENSION_H}', "");
    Expect(1, 205743, '\P{^Is_Block=-	CJK_UNIFIED_IDEOGRAPHS_EXTENSION_H}', "");
    Expect(0, 205744, '\p{Is_Block=-	CJK_UNIFIED_IDEOGRAPHS_EXTENSION_H}', "");
    Expect(1, 205744, '\p{^Is_Block=-	CJK_UNIFIED_IDEOGRAPHS_EXTENSION_H}', "");
    Expect(1, 205744, '\P{Is_Block=-	CJK_UNIFIED_IDEOGRAPHS_EXTENSION_H}', "");
    Expect(0, 205744, '\P{^Is_Block=-	CJK_UNIFIED_IDEOGRAPHS_EXTENSION_H}', "");
    Error('\p{Is_Blk=:=	CJK_ext_H}');
    Error('\P{Is_Blk=:=	CJK_ext_H}');
    Expect(1, 205743, '\p{Is_Blk=cjkexth}', "");
    Expect(0, 205743, '\p{^Is_Blk=cjkexth}', "");
    Expect(0, 205743, '\P{Is_Blk=cjkexth}', "");
    Expect(1, 205743, '\P{^Is_Blk=cjkexth}', "");
    Expect(0, 205744, '\p{Is_Blk=cjkexth}', "");
    Expect(1, 205744, '\p{^Is_Blk=cjkexth}', "");
    Expect(1, 205744, '\P{Is_Blk=cjkexth}', "");
    Expect(0, 205744, '\P{^Is_Blk=cjkexth}', "");
    Expect(1, 205743, '\p{Is_Blk=- CJK_Ext_H}', "");
    Expect(0, 205743, '\p{^Is_Blk=- CJK_Ext_H}', "");
    Expect(0, 205743, '\P{Is_Blk=- CJK_Ext_H}', "");
    Expect(1, 205743, '\P{^Is_Blk=- CJK_Ext_H}', "");
    Expect(0, 205744, '\p{Is_Blk=- CJK_Ext_H}', "");
    Expect(1, 205744, '\p{^Is_Blk=- CJK_Ext_H}', "");
    Expect(1, 205744, '\P{Is_Blk=- CJK_Ext_H}', "");
    Expect(0, 205744, '\P{^Is_Blk=- CJK_Ext_H}', "");
    Error('\p{Block=-:=cjk_radicals_SUPPLEMENT}');
    Error('\P{Block=-:=cjk_radicals_SUPPLEMENT}');
    Expect(1, 12031, '\p{Block=:\ACJK_Radicals_Supplement\z:}', "");;
    Expect(0, 12032, '\p{Block=:\ACJK_Radicals_Supplement\z:}', "");;
    Expect(1, 12031, '\p{Block=cjkradicalssupplement}', "");
    Expect(0, 12031, '\p{^Block=cjkradicalssupplement}', "");
    Expect(0, 12031, '\P{Block=cjkradicalssupplement}', "");
    Expect(1, 12031, '\P{^Block=cjkradicalssupplement}', "");
    Expect(0, 12032, '\p{Block=cjkradicalssupplement}', "");
    Expect(1, 12032, '\p{^Block=cjkradicalssupplement}', "");
    Expect(1, 12032, '\P{Block=cjkradicalssupplement}', "");
    Expect(0, 12032, '\P{^Block=cjkradicalssupplement}', "");
    Expect(1, 12031, '\p{Block=:\Acjkradicalssupplement\z:}', "");;
    Expect(0, 12032, '\p{Block=:\Acjkradicalssupplement\z:}', "");;
    Expect(1, 12031, '\p{Block=_	CJK_Radicals_SUPPLEMENT}', "");
    Expect(0, 12031, '\p{^Block=_	CJK_Radicals_SUPPLEMENT}', "");
    Expect(0, 12031, '\P{Block=_	CJK_Radicals_SUPPLEMENT}', "");
    Expect(1, 12031, '\P{^Block=_	CJK_Radicals_SUPPLEMENT}', "");
    Expect(0, 12032, '\p{Block=_	CJK_Radicals_SUPPLEMENT}', "");
    Expect(1, 12032, '\p{^Block=_	CJK_Radicals_SUPPLEMENT}', "");
    Expect(1, 12032, '\P{Block=_	CJK_Radicals_SUPPLEMENT}', "");
    Expect(0, 12032, '\P{^Block=_	CJK_Radicals_SUPPLEMENT}', "");
    Error('\p{Blk=	:=CJK_radicals_Sup}');
    Error('\P{Blk=	:=CJK_radicals_Sup}');
    Expect(1, 12031, '\p{Blk=:\ACJK_Radicals_Sup\z:}', "");;
    Expect(0, 12032, '\p{Blk=:\ACJK_Radicals_Sup\z:}', "");;
    Expect(1, 12031, '\p{Blk=cjkradicalssup}', "");
    Expect(0, 12031, '\p{^Blk=cjkradicalssup}', "");
    Expect(0, 12031, '\P{Blk=cjkradicalssup}', "");
    Expect(1, 12031, '\P{^Blk=cjkradicalssup}', "");
    Expect(0, 12032, '\p{Blk=cjkradicalssup}', "");
    Expect(1, 12032, '\p{^Blk=cjkradicalssup}', "");
    Expect(1, 12032, '\P{Blk=cjkradicalssup}', "");
    Expect(0, 12032, '\P{^Blk=cjkradicalssup}', "");
    Expect(1, 12031, '\p{Blk=:\Acjkradicalssup\z:}', "");;
    Expect(0, 12032, '\p{Blk=:\Acjkradicalssup\z:}', "");;
    Expect(1, 12031, '\p{Blk=_ CJK_RADICALS_Sup}', "");
    Expect(0, 12031, '\p{^Blk=_ CJK_RADICALS_Sup}', "");
    Expect(0, 12031, '\P{Blk=_ CJK_RADICALS_Sup}', "");
    Expect(1, 12031, '\P{^Blk=_ CJK_RADICALS_Sup}', "");
    Expect(0, 12032, '\p{Blk=_ CJK_RADICALS_Sup}', "");
    Expect(1, 12032, '\p{^Blk=_ CJK_RADICALS_Sup}', "");
    Expect(1, 12032, '\P{Blk=_ CJK_RADICALS_Sup}', "");
    Expect(0, 12032, '\P{^Blk=_ CJK_RADICALS_Sup}', "");
    Error('\p{Is_Block=:=CJK_RADICALS_Supplement}');
    Error('\P{Is_Block=:=CJK_RADICALS_Supplement}');
    Expect(1, 12031, '\p{Is_Block=cjkradicalssupplement}', "");
    Expect(0, 12031, '\p{^Is_Block=cjkradicalssupplement}', "");
    Expect(0, 12031, '\P{Is_Block=cjkradicalssupplement}', "");
    Expect(1, 12031, '\P{^Is_Block=cjkradicalssupplement}', "");
    Expect(0, 12032, '\p{Is_Block=cjkradicalssupplement}', "");
    Expect(1, 12032, '\p{^Is_Block=cjkradicalssupplement}', "");
    Expect(1, 12032, '\P{Is_Block=cjkradicalssupplement}', "");
    Expect(0, 12032, '\P{^Is_Block=cjkradicalssupplement}', "");
    Expect(1, 12031, '\p{Is_Block=		cjk_Radicals_supplement}', "");
    Expect(0, 12031, '\p{^Is_Block=		cjk_Radicals_supplement}', "");
    Expect(0, 12031, '\P{Is_Block=		cjk_Radicals_supplement}', "");
    Expect(1, 12031, '\P{^Is_Block=		cjk_Radicals_supplement}', "");
    Expect(0, 12032, '\p{Is_Block=		cjk_Radicals_supplement}', "");
    Expect(1, 12032, '\p{^Is_Block=		cjk_Radicals_supplement}', "");
    Expect(1, 12032, '\P{Is_Block=		cjk_Radicals_supplement}', "");
    Expect(0, 12032, '\P{^Is_Block=		cjk_Radicals_supplement}', "");
    Error('\p{Is_Blk=_CJK_Radicals_Sup:=}');
    Error('\P{Is_Blk=_CJK_Radicals_Sup:=}');
    Expect(1, 12031, '\p{Is_Blk=cjkradicalssup}', "");
    Expect(0, 12031, '\p{^Is_Blk=cjkradicalssup}', "");
    Expect(0, 12031, '\P{Is_Blk=cjkradicalssup}', "");
    Expect(1, 12031, '\P{^Is_Blk=cjkradicalssup}', "");
    Expect(0, 12032, '\p{Is_Blk=cjkradicalssup}', "");
    Expect(1, 12032, '\p{^Is_Blk=cjkradicalssup}', "");
    Expect(1, 12032, '\P{Is_Blk=cjkradicalssup}', "");
    Expect(0, 12032, '\P{^Is_Blk=cjkradicalssup}', "");
    Expect(1, 12031, '\p{Is_Blk=--CJK_Radicals_sup}', "");
    Expect(0, 12031, '\p{^Is_Blk=--CJK_Radicals_sup}', "");
    Expect(0, 12031, '\P{Is_Blk=--CJK_Radicals_sup}', "");
    Expect(1, 12031, '\P{^Is_Blk=--CJK_Radicals_sup}', "");
    Expect(0, 12032, '\p{Is_Blk=--CJK_Radicals_sup}', "");
    Expect(1, 12032, '\p{^Is_Blk=--CJK_Radicals_sup}', "");
    Expect(1, 12032, '\P{Is_Blk=--CJK_Radicals_sup}', "");
    Expect(0, 12032, '\P{^Is_Blk=--CJK_Radicals_sup}', "");
    Error('\p{Block= _CJK_Strokes/a/}');
    Error('\P{Block= _CJK_Strokes/a/}');
    Expect(1, 12783, '\p{Block=:\ACJK_Strokes\z:}', "");;
    Expect(0, 12784, '\p{Block=:\ACJK_Strokes\z:}', "");;
    Expect(1, 12783, '\p{Block=cjkstrokes}', "");
    Expect(0, 12783, '\p{^Block=cjkstrokes}', "");
    Expect(0, 12783, '\P{Block=cjkstrokes}', "");
    Expect(1, 12783, '\P{^Block=cjkstrokes}', "");
    Expect(0, 12784, '\p{Block=cjkstrokes}', "");
    Expect(1, 12784, '\p{^Block=cjkstrokes}', "");
    Expect(1, 12784, '\P{Block=cjkstrokes}', "");
    Expect(0, 12784, '\P{^Block=cjkstrokes}', "");
    Expect(1, 12783, '\p{Block=:\Acjkstrokes\z:}', "");;
    Expect(0, 12784, '\p{Block=:\Acjkstrokes\z:}', "");;
    Expect(1, 12783, '\p{Block= CJK_strokes}', "");
    Expect(0, 12783, '\p{^Block= CJK_strokes}', "");
    Expect(0, 12783, '\P{Block= CJK_strokes}', "");
    Expect(1, 12783, '\P{^Block= CJK_strokes}', "");
    Expect(0, 12784, '\p{Block= CJK_strokes}', "");
    Expect(1, 12784, '\p{^Block= CJK_strokes}', "");
    Expect(1, 12784, '\P{Block= CJK_strokes}', "");
    Expect(0, 12784, '\P{^Block= CJK_strokes}', "");
    Error('\p{Blk=-	cjk_strokes:=}');
    Error('\P{Blk=-	cjk_strokes:=}');
    Expect(1, 12783, '\p{Blk=:\ACJK_Strokes\z:}', "");;
    Expect(0, 12784, '\p{Blk=:\ACJK_Strokes\z:}', "");;
    Expect(1, 12783, '\p{Blk:	cjkstrokes}', "");
    Expect(0, 12783, '\p{^Blk:	cjkstrokes}', "");
    Expect(0, 12783, '\P{Blk:	cjkstrokes}', "");
    Expect(1, 12783, '\P{^Blk:	cjkstrokes}', "");
    Expect(0, 12784, '\p{Blk:	cjkstrokes}', "");
    Expect(1, 12784, '\p{^Blk:	cjkstrokes}', "");
    Expect(1, 12784, '\P{Blk:	cjkstrokes}', "");
    Expect(0, 12784, '\P{^Blk:	cjkstrokes}', "");
    Expect(1, 12783, '\p{Blk=:\Acjkstrokes\z:}', "");;
    Expect(0, 12784, '\p{Blk=:\Acjkstrokes\z:}', "");;
    Expect(1, 12783, '\p{Blk=	 CJK_Strokes}', "");
    Expect(0, 12783, '\p{^Blk=	 CJK_Strokes}', "");
    Expect(0, 12783, '\P{Blk=	 CJK_Strokes}', "");
    Expect(1, 12783, '\P{^Blk=	 CJK_Strokes}', "");
    Expect(0, 12784, '\p{Blk=	 CJK_Strokes}', "");
    Expect(1, 12784, '\p{^Blk=	 CJK_Strokes}', "");
    Expect(1, 12784, '\P{Blk=	 CJK_Strokes}', "");
    Expect(0, 12784, '\P{^Blk=	 CJK_Strokes}', "");
    Error('\p{Is_Block= _CJK_strokes:=}');
    Error('\P{Is_Block= _CJK_strokes:=}');
    Expect(1, 12783, '\p{Is_Block=cjkstrokes}', "");
    Expect(0, 12783, '\p{^Is_Block=cjkstrokes}', "");
    Expect(0, 12783, '\P{Is_Block=cjkstrokes}', "");
    Expect(1, 12783, '\P{^Is_Block=cjkstrokes}', "");
    Expect(0, 12784, '\p{Is_Block=cjkstrokes}', "");
    Expect(1, 12784, '\p{^Is_Block=cjkstrokes}', "");
    Expect(1, 12784, '\P{Is_Block=cjkstrokes}', "");
    Expect(0, 12784, '\P{^Is_Block=cjkstrokes}', "");
    Expect(1, 12783, '\p{Is_Block=-CJK_Strokes}', "");
    Expect(0, 12783, '\p{^Is_Block=-CJK_Strokes}', "");
    Expect(0, 12783, '\P{Is_Block=-CJK_Strokes}', "");
    Expect(1, 12783, '\P{^Is_Block=-CJK_Strokes}', "");
    Expect(0, 12784, '\p{Is_Block=-CJK_Strokes}', "");
    Expect(1, 12784, '\p{^Is_Block=-CJK_Strokes}', "");
    Expect(1, 12784, '\P{Is_Block=-CJK_Strokes}', "");
    Expect(0, 12784, '\P{^Is_Block=-CJK_Strokes}', "");
    Error('\p{Is_Blk=_CJK_STROKES/a/}');
    Error('\P{Is_Blk=_CJK_STROKES/a/}');
    Expect(1, 12783, '\p{Is_Blk: cjkstrokes}', "");
    Expect(0, 12783, '\p{^Is_Blk: cjkstrokes}', "");
    Expect(0, 12783, '\P{Is_Blk: cjkstrokes}', "");
    Expect(1, 12783, '\P{^Is_Blk: cjkstrokes}', "");
    Expect(0, 12784, '\p{Is_Blk: cjkstrokes}', "");
    Expect(1, 12784, '\p{^Is_Blk: cjkstrokes}', "");
    Expect(1, 12784, '\P{Is_Blk: cjkstrokes}', "");
    Expect(0, 12784, '\P{^Is_Blk: cjkstrokes}', "");
    Expect(1, 12783, '\p{Is_Blk: _CJK_Strokes}', "");
    Expect(0, 12783, '\p{^Is_Blk: _CJK_Strokes}', "");
    Expect(0, 12783, '\P{Is_Blk: _CJK_Strokes}', "");
    Expect(1, 12783, '\P{^Is_Blk: _CJK_Strokes}', "");
    Expect(0, 12784, '\p{Is_Blk: _CJK_Strokes}', "");
    Expect(1, 12784, '\p{^Is_Blk: _CJK_Strokes}', "");
    Expect(1, 12784, '\P{Is_Blk: _CJK_Strokes}', "");
    Expect(0, 12784, '\P{^Is_Blk: _CJK_Strokes}', "");
    Error('\p{Block=:=	_CJK_symbols_And_Punctuation}');
    Error('\P{Block=:=	_CJK_symbols_And_Punctuation}');
    Expect(1, 12351, '\p{Block=:\ACJK_Symbols_And_Punctuation\z:}', "");;
    Expect(0, 12352, '\p{Block=:\ACJK_Symbols_And_Punctuation\z:}', "");;
    Expect(1, 12351, '\p{Block:   cjksymbolsandpunctuation}', "");
    Expect(0, 12351, '\p{^Block:   cjksymbolsandpunctuation}', "");
    Expect(0, 12351, '\P{Block:   cjksymbolsandpunctuation}', "");
    Expect(1, 12351, '\P{^Block:   cjksymbolsandpunctuation}', "");
    Expect(0, 12352, '\p{Block:   cjksymbolsandpunctuation}', "");
    Expect(1, 12352, '\p{^Block:   cjksymbolsandpunctuation}', "");
    Expect(1, 12352, '\P{Block:   cjksymbolsandpunctuation}', "");
    Expect(0, 12352, '\P{^Block:   cjksymbolsandpunctuation}', "");
    Expect(1, 12351, '\p{Block=:\Acjksymbolsandpunctuation\z:}', "");;
    Expect(0, 12352, '\p{Block=:\Acjksymbolsandpunctuation\z:}', "");;
    Expect(1, 12351, '\p{Block=- CJK_SYMBOLS_and_punctuation}', "");
    Expect(0, 12351, '\p{^Block=- CJK_SYMBOLS_and_punctuation}', "");
    Expect(0, 12351, '\P{Block=- CJK_SYMBOLS_and_punctuation}', "");
    Expect(1, 12351, '\P{^Block=- CJK_SYMBOLS_and_punctuation}', "");
    Expect(0, 12352, '\p{Block=- CJK_SYMBOLS_and_punctuation}', "");
    Expect(1, 12352, '\p{^Block=- CJK_SYMBOLS_and_punctuation}', "");
    Expect(1, 12352, '\P{Block=- CJK_SYMBOLS_and_punctuation}', "");
    Expect(0, 12352, '\P{^Block=- CJK_SYMBOLS_and_punctuation}', "");
    Error('\p{Blk: --CJK_SYMBOLS:=}');
    Error('\P{Blk: --CJK_SYMBOLS:=}');
    Expect(1, 12351, '\p{Blk=:\ACJK_Symbols\z:}', "");;
    Expect(0, 12352, '\p{Blk=:\ACJK_Symbols\z:}', "");;
    Expect(1, 12351, '\p{Blk=cjksymbols}', "");
    Expect(0, 12351, '\p{^Blk=cjksymbols}', "");
    Expect(0, 12351, '\P{Blk=cjksymbols}', "");
    Expect(1, 12351, '\P{^Blk=cjksymbols}', "");
    Expect(0, 12352, '\p{Blk=cjksymbols}', "");
    Expect(1, 12352, '\p{^Blk=cjksymbols}', "");
    Expect(1, 12352, '\P{Blk=cjksymbols}', "");
    Expect(0, 12352, '\P{^Blk=cjksymbols}', "");
    Expect(1, 12351, '\p{Blk=:\Acjksymbols\z:}', "");;
    Expect(0, 12352, '\p{Blk=:\Acjksymbols\z:}', "");;
    Expect(1, 12351, '\p{Blk=__cjk_Symbols}', "");
    Expect(0, 12351, '\p{^Blk=__cjk_Symbols}', "");
    Expect(0, 12351, '\P{Blk=__cjk_Symbols}', "");
    Expect(1, 12351, '\P{^Blk=__cjk_Symbols}', "");
    Expect(0, 12352, '\p{Blk=__cjk_Symbols}', "");
    Expect(1, 12352, '\p{^Blk=__cjk_Symbols}', "");
    Expect(1, 12352, '\P{Blk=__cjk_Symbols}', "");
    Expect(0, 12352, '\P{^Blk=__cjk_Symbols}', "");
    Error('\p{Is_Block= /a/CJK_symbols_And_punctuation}');
    Error('\P{Is_Block= /a/CJK_symbols_And_punctuation}');
    Expect(1, 12351, '\p{Is_Block=cjksymbolsandpunctuation}', "");
    Expect(0, 12351, '\p{^Is_Block=cjksymbolsandpunctuation}', "");
    Expect(0, 12351, '\P{Is_Block=cjksymbolsandpunctuation}', "");
    Expect(1, 12351, '\P{^Is_Block=cjksymbolsandpunctuation}', "");
    Expect(0, 12352, '\p{Is_Block=cjksymbolsandpunctuation}', "");
    Expect(1, 12352, '\p{^Is_Block=cjksymbolsandpunctuation}', "");
    Expect(1, 12352, '\P{Is_Block=cjksymbolsandpunctuation}', "");
    Expect(0, 12352, '\P{^Is_Block=cjksymbolsandpunctuation}', "");
    Expect(1, 12351, '\p{Is_Block=-cjk_Symbols_and_punctuation}', "");
    Expect(0, 12351, '\p{^Is_Block=-cjk_Symbols_and_punctuation}', "");
    Expect(0, 12351, '\P{Is_Block=-cjk_Symbols_and_punctuation}', "");
    Expect(1, 12351, '\P{^Is_Block=-cjk_Symbols_and_punctuation}', "");
    Expect(0, 12352, '\p{Is_Block=-cjk_Symbols_and_punctuation}', "");
    Expect(1, 12352, '\p{^Is_Block=-cjk_Symbols_and_punctuation}', "");
    Expect(1, 12352, '\P{Is_Block=-cjk_Symbols_and_punctuation}', "");
    Expect(0, 12352, '\P{^Is_Block=-cjk_Symbols_and_punctuation}', "");
    Error('\p{Is_Blk=-CJK_SYMBOLS:=}');
    Error('\P{Is_Blk=-CJK_SYMBOLS:=}');
    Expect(1, 12351, '\p{Is_Blk:	cjksymbols}', "");
    Expect(0, 12351, '\p{^Is_Blk:	cjksymbols}', "");
    Expect(0, 12351, '\P{Is_Blk:	cjksymbols}', "");
    Expect(1, 12351, '\P{^Is_Blk:	cjksymbols}', "");
    Expect(0, 12352, '\p{Is_Blk:	cjksymbols}', "");
    Expect(1, 12352, '\p{^Is_Blk:	cjksymbols}', "");
    Expect(1, 12352, '\P{Is_Blk:	cjksymbols}', "");
    Expect(0, 12352, '\P{^Is_Blk:	cjksymbols}', "");
    Expect(1, 12351, '\p{Is_Blk=	-CJK_SYMBOLS}', "");
    Expect(0, 12351, '\p{^Is_Blk=	-CJK_SYMBOLS}', "");
    Expect(0, 12351, '\P{Is_Blk=	-CJK_SYMBOLS}', "");
    Expect(1, 12351, '\P{^Is_Blk=	-CJK_SYMBOLS}', "");
    Expect(0, 12352, '\p{Is_Blk=	-CJK_SYMBOLS}', "");
    Expect(1, 12352, '\p{^Is_Blk=	-CJK_SYMBOLS}', "");
    Expect(1, 12352, '\P{Is_Blk=	-CJK_SYMBOLS}', "");
    Expect(0, 12352, '\P{^Is_Blk=	-CJK_SYMBOLS}', "");
    Error('\p{Block=/a/--Hangul_Compatibility_JAMO}');
    Error('\P{Block=/a/--Hangul_Compatibility_JAMO}');
    Expect(1, 12687, '\p{Block=:\AHangul_Compatibility_Jamo\z:}', "");;
    Expect(0, 12688, '\p{Block=:\AHangul_Compatibility_Jamo\z:}', "");;
    Expect(1, 12687, '\p{Block=hangulcompatibilityjamo}', "");
    Expect(0, 12687, '\p{^Block=hangulcompatibilityjamo}', "");
    Expect(0, 12687, '\P{Block=hangulcompatibilityjamo}', "");
    Expect(1, 12687, '\P{^Block=hangulcompatibilityjamo}', "");
    Expect(0, 12688, '\p{Block=hangulcompatibilityjamo}', "");
    Expect(1, 12688, '\p{^Block=hangulcompatibilityjamo}', "");
    Expect(1, 12688, '\P{Block=hangulcompatibilityjamo}', "");
    Expect(0, 12688, '\P{^Block=hangulcompatibilityjamo}', "");
    Expect(1, 12687, '\p{Block=:\Ahangulcompatibilityjamo\z:}', "");;
    Expect(0, 12688, '\p{Block=:\Ahangulcompatibilityjamo\z:}', "");;
    Expect(1, 12687, '\p{Block=--HANGUL_Compatibility_JAMO}', "");
    Expect(0, 12687, '\p{^Block=--HANGUL_Compatibility_JAMO}', "");
    Expect(0, 12687, '\P{Block=--HANGUL_Compatibility_JAMO}', "");
    Expect(1, 12687, '\P{^Block=--HANGUL_Compatibility_JAMO}', "");
    Expect(0, 12688, '\p{Block=--HANGUL_Compatibility_JAMO}', "");
    Expect(1, 12688, '\p{^Block=--HANGUL_Compatibility_JAMO}', "");
    Expect(1, 12688, '\P{Block=--HANGUL_Compatibility_JAMO}', "");
    Expect(0, 12688, '\P{^Block=--HANGUL_Compatibility_JAMO}', "");
    Error('\p{Blk=/a/-compat_JAMO}');
    Error('\P{Blk=/a/-compat_JAMO}');
    Expect(1, 12687, '\p{Blk=:\ACompat_Jamo\z:}', "");;
    Expect(0, 12688, '\p{Blk=:\ACompat_Jamo\z:}', "");;
    Expect(1, 12687, '\p{Blk=compatjamo}', "");
    Expect(0, 12687, '\p{^Blk=compatjamo}', "");
    Expect(0, 12687, '\P{Blk=compatjamo}', "");
    Expect(1, 12687, '\P{^Blk=compatjamo}', "");
    Expect(0, 12688, '\p{Blk=compatjamo}', "");
    Expect(1, 12688, '\p{^Blk=compatjamo}', "");
    Expect(1, 12688, '\P{Blk=compatjamo}', "");
    Expect(0, 12688, '\P{^Blk=compatjamo}', "");
    Expect(1, 12687, '\p{Blk=:\Acompatjamo\z:}', "");;
    Expect(0, 12688, '\p{Blk=:\Acompatjamo\z:}', "");;
    Expect(1, 12687, '\p{Blk=	-Compat_jamo}', "");
    Expect(0, 12687, '\p{^Blk=	-Compat_jamo}', "");
    Expect(0, 12687, '\P{Blk=	-Compat_jamo}', "");
    Expect(1, 12687, '\P{^Blk=	-Compat_jamo}', "");
    Expect(0, 12688, '\p{Blk=	-Compat_jamo}', "");
    Expect(1, 12688, '\p{^Blk=	-Compat_jamo}', "");
    Expect(1, 12688, '\P{Blk=	-Compat_jamo}', "");
    Expect(0, 12688, '\P{^Blk=	-Compat_jamo}', "");
    Error('\p{Is_Block=/a/_Hangul_Compatibility_Jamo}');
    Error('\P{Is_Block=/a/_Hangul_Compatibility_Jamo}');
    Expect(1, 12687, '\p{Is_Block=hangulcompatibilityjamo}', "");
    Expect(0, 12687, '\p{^Is_Block=hangulcompatibilityjamo}', "");
    Expect(0, 12687, '\P{Is_Block=hangulcompatibilityjamo}', "");
    Expect(1, 12687, '\P{^Is_Block=hangulcompatibilityjamo}', "");
    Expect(0, 12688, '\p{Is_Block=hangulcompatibilityjamo}', "");
    Expect(1, 12688, '\p{^Is_Block=hangulcompatibilityjamo}', "");
    Expect(1, 12688, '\P{Is_Block=hangulcompatibilityjamo}', "");
    Expect(0, 12688, '\P{^Is_Block=hangulcompatibilityjamo}', "");
    Expect(1, 12687, '\p{Is_Block=_-Hangul_Compatibility_JAMO}', "");
    Expect(0, 12687, '\p{^Is_Block=_-Hangul_Compatibility_JAMO}', "");
    Expect(0, 12687, '\P{Is_Block=_-Hangul_Compatibility_JAMO}', "");
    Expect(1, 12687, '\P{^Is_Block=_-Hangul_Compatibility_JAMO}', "");
    Expect(0, 12688, '\p{Is_Block=_-Hangul_Compatibility_JAMO}', "");
    Expect(1, 12688, '\p{^Is_Block=_-Hangul_Compatibility_JAMO}', "");
    Expect(1, 12688, '\P{Is_Block=_-Hangul_Compatibility_JAMO}', "");
    Expect(0, 12688, '\P{^Is_Block=_-Hangul_Compatibility_JAMO}', "");
    Error('\p{Is_Blk=/a/ Compat_JAMO}');
    Error('\P{Is_Blk=/a/ Compat_JAMO}');
    Expect(1, 12687, '\p{Is_Blk=compatjamo}', "");
    Expect(0, 12687, '\p{^Is_Blk=compatjamo}', "");
    Expect(0, 12687, '\P{Is_Blk=compatjamo}', "");
    Expect(1, 12687, '\P{^Is_Blk=compatjamo}', "");
    Expect(0, 12688, '\p{Is_Blk=compatjamo}', "");
    Expect(1, 12688, '\p{^Is_Blk=compatjamo}', "");
    Expect(1, 12688, '\P{Is_Blk=compatjamo}', "");
    Expect(0, 12688, '\P{^Is_Blk=compatjamo}', "");
    Expect(1, 12687, '\p{Is_Blk=-_Compat_JAMO}', "");
    Expect(0, 12687, '\p{^Is_Blk=-_Compat_JAMO}', "");
    Expect(0, 12687, '\P{Is_Blk=-_Compat_JAMO}', "");
    Expect(1, 12687, '\P{^Is_Blk=-_Compat_JAMO}', "");
    Expect(0, 12688, '\p{Is_Blk=-_Compat_JAMO}', "");
    Expect(1, 12688, '\p{^Is_Blk=-_Compat_JAMO}', "");
    Expect(1, 12688, '\P{Is_Blk=-_Compat_JAMO}', "");
    Expect(0, 12688, '\P{^Is_Blk=-_Compat_JAMO}', "");
    Error('\p{Block=/a/Control_Pictures}');
    Error('\P{Block=/a/Control_Pictures}');
    Expect(1, 9279, '\p{Block=:\AControl_Pictures\z:}', "");;
    Expect(0, 9280, '\p{Block=:\AControl_Pictures\z:}', "");;
    Expect(1, 9279, '\p{Block: controlpictures}', "");
    Expect(0, 9279, '\p{^Block: controlpictures}', "");
    Expect(0, 9279, '\P{Block: controlpictures}', "");
    Expect(1, 9279, '\P{^Block: controlpictures}', "");
    Expect(0, 9280, '\p{Block: controlpictures}', "");
    Expect(1, 9280, '\p{^Block: controlpictures}', "");
    Expect(1, 9280, '\P{Block: controlpictures}', "");
    Expect(0, 9280, '\P{^Block: controlpictures}', "");
    Expect(1, 9279, '\p{Block=:\Acontrolpictures\z:}', "");;
    Expect(0, 9280, '\p{Block=:\Acontrolpictures\z:}', "");;
    Expect(1, 9279, '\p{Block=-_Control_PICTURES}', "");
    Expect(0, 9279, '\p{^Block=-_Control_PICTURES}', "");
    Expect(0, 9279, '\P{Block=-_Control_PICTURES}', "");
    Expect(1, 9279, '\P{^Block=-_Control_PICTURES}', "");
    Expect(0, 9280, '\p{Block=-_Control_PICTURES}', "");
    Expect(1, 9280, '\p{^Block=-_Control_PICTURES}', "");
    Expect(1, 9280, '\P{Block=-_Control_PICTURES}', "");
    Expect(0, 9280, '\P{^Block=-_Control_PICTURES}', "");
    Error('\p{Blk=:=	 Control_PICTURES}');
    Error('\P{Blk=:=	 Control_PICTURES}');
    Expect(1, 9279, '\p{Blk=:\AControl_Pictures\z:}', "");;
    Expect(0, 9280, '\p{Blk=:\AControl_Pictures\z:}', "");;
    Expect(1, 9279, '\p{Blk=controlpictures}', "");
    Expect(0, 9279, '\p{^Blk=controlpictures}', "");
    Expect(0, 9279, '\P{Blk=controlpictures}', "");
    Expect(1, 9279, '\P{^Blk=controlpictures}', "");
    Expect(0, 9280, '\p{Blk=controlpictures}', "");
    Expect(1, 9280, '\p{^Blk=controlpictures}', "");
    Expect(1, 9280, '\P{Blk=controlpictures}', "");
    Expect(0, 9280, '\P{^Blk=controlpictures}', "");
    Expect(1, 9279, '\p{Blk=:\Acontrolpictures\z:}', "");;
    Expect(0, 9280, '\p{Blk=:\Acontrolpictures\z:}', "");;
    Expect(1, 9279, '\p{Blk= 	control_PICTURES}', "");
    Expect(0, 9279, '\p{^Blk= 	control_PICTURES}', "");
    Expect(0, 9279, '\P{Blk= 	control_PICTURES}', "");
    Expect(1, 9279, '\P{^Blk= 	control_PICTURES}', "");
    Expect(0, 9280, '\p{Blk= 	control_PICTURES}', "");
    Expect(1, 9280, '\p{^Blk= 	control_PICTURES}', "");
    Expect(1, 9280, '\P{Blk= 	control_PICTURES}', "");
    Expect(0, 9280, '\P{^Blk= 	control_PICTURES}', "");
    Error('\p{Is_Block=:=	Control_Pictures}');
    Error('\P{Is_Block=:=	Control_Pictures}');
    Expect(1, 9279, '\p{Is_Block=controlpictures}', "");
    Expect(0, 9279, '\p{^Is_Block=controlpictures}', "");
    Expect(0, 9279, '\P{Is_Block=controlpictures}', "");
    Expect(1, 9279, '\P{^Is_Block=controlpictures}', "");
    Expect(0, 9280, '\p{Is_Block=controlpictures}', "");
    Expect(1, 9280, '\p{^Is_Block=controlpictures}', "");
    Expect(1, 9280, '\P{Is_Block=controlpictures}', "");
    Expect(0, 9280, '\P{^Is_Block=controlpictures}', "");
    Expect(1, 9279, '\p{Is_Block=	_Control_pictures}', "");
    Expect(0, 9279, '\p{^Is_Block=	_Control_pictures}', "");
    Expect(0, 9279, '\P{Is_Block=	_Control_pictures}', "");
    Expect(1, 9279, '\P{^Is_Block=	_Control_pictures}', "");
    Expect(0, 9280, '\p{Is_Block=	_Control_pictures}', "");
    Expect(1, 9280, '\p{^Is_Block=	_Control_pictures}', "");
    Expect(1, 9280, '\P{Is_Block=	_Control_pictures}', "");
    Expect(0, 9280, '\P{^Is_Block=	_Control_pictures}', "");
    Error('\p{Is_Blk=:=  CONTROL_Pictures}');
    Error('\P{Is_Blk=:=  CONTROL_Pictures}');
    Expect(1, 9279, '\p{Is_Blk: controlpictures}', "");
    Expect(0, 9279, '\p{^Is_Blk: controlpictures}', "");
    Expect(0, 9279, '\P{Is_Blk: controlpictures}', "");
    Expect(1, 9279, '\P{^Is_Blk: controlpictures}', "");
    Expect(0, 9280, '\p{Is_Blk: controlpictures}', "");
    Expect(1, 9280, '\p{^Is_Blk: controlpictures}', "");
    Expect(1, 9280, '\P{Is_Blk: controlpictures}', "");
    Expect(0, 9280, '\P{^Is_Blk: controlpictures}', "");
    Expect(1, 9279, '\p{Is_Blk=	Control_pictures}', "");
    Expect(0, 9279, '\p{^Is_Blk=	Control_pictures}', "");
    Expect(0, 9279, '\P{Is_Blk=	Control_pictures}', "");
    Expect(1, 9279, '\P{^Is_Blk=	Control_pictures}', "");
    Expect(0, 9280, '\p{Is_Blk=	Control_pictures}', "");
    Expect(1, 9280, '\p{^Is_Blk=	Control_pictures}', "");
    Expect(1, 9280, '\P{Is_Blk=	Control_pictures}', "");
    Expect(0, 9280, '\P{^Is_Blk=	Control_pictures}', "");
    Error('\p{Block=_:=COPTIC}');
    Error('\P{Block=_:=COPTIC}');
    Expect(1, 11519, '\p{Block=:\ACoptic\z:}', "");;
    Expect(0, 11520, '\p{Block=:\ACoptic\z:}', "");;
    Expect(1, 11519, '\p{Block=coptic}', "");
    Expect(0, 11519, '\p{^Block=coptic}', "");
    Expect(0, 11519, '\P{Block=coptic}', "");
    Expect(1, 11519, '\P{^Block=coptic}', "");
    Expect(0, 11520, '\p{Block=coptic}', "");
    Expect(1, 11520, '\p{^Block=coptic}', "");
    Expect(1, 11520, '\P{Block=coptic}', "");
    Expect(0, 11520, '\P{^Block=coptic}', "");
    Expect(1, 11519, '\p{Block=:\Acoptic\z:}', "");;
    Expect(0, 11520, '\p{Block=:\Acoptic\z:}', "");;
    Expect(1, 11519, '\p{Block=	_COPTIC}', "");
    Expect(0, 11519, '\p{^Block=	_COPTIC}', "");
    Expect(0, 11519, '\P{Block=	_COPTIC}', "");
    Expect(1, 11519, '\P{^Block=	_COPTIC}', "");
    Expect(0, 11520, '\p{Block=	_COPTIC}', "");
    Expect(1, 11520, '\p{^Block=	_COPTIC}', "");
    Expect(1, 11520, '\P{Block=	_COPTIC}', "");
    Expect(0, 11520, '\P{^Block=	_COPTIC}', "");
    Error('\p{Blk=	/a/Coptic}');
    Error('\P{Blk=	/a/Coptic}');
    Expect(1, 11519, '\p{Blk=:\ACoptic\z:}', "");;
    Expect(0, 11520, '\p{Blk=:\ACoptic\z:}', "");;
    Expect(1, 11519, '\p{Blk=coptic}', "");
    Expect(0, 11519, '\p{^Blk=coptic}', "");
    Expect(0, 11519, '\P{Blk=coptic}', "");
    Expect(1, 11519, '\P{^Blk=coptic}', "");
    Expect(0, 11520, '\p{Blk=coptic}', "");
    Expect(1, 11520, '\p{^Blk=coptic}', "");
    Expect(1, 11520, '\P{Blk=coptic}', "");
    Expect(0, 11520, '\P{^Blk=coptic}', "");
    Expect(1, 11519, '\p{Blk=:\Acoptic\z:}', "");;
    Expect(0, 11520, '\p{Blk=:\Acoptic\z:}', "");;
    Expect(1, 11519, '\p{Blk=_	coptic}', "");
    Expect(0, 11519, '\p{^Blk=_	coptic}', "");
    Expect(0, 11519, '\P{Blk=_	coptic}', "");
    Expect(1, 11519, '\P{^Blk=_	coptic}', "");
    Expect(0, 11520, '\p{Blk=_	coptic}', "");
    Expect(1, 11520, '\p{^Blk=_	coptic}', "");
    Expect(1, 11520, '\P{Blk=_	coptic}', "");
    Expect(0, 11520, '\P{^Blk=_	coptic}', "");
    Error('\p{Is_Block=	 Coptic/a/}');
    Error('\P{Is_Block=	 Coptic/a/}');
    Expect(1, 11519, '\p{Is_Block=coptic}', "");
    Expect(0, 11519, '\p{^Is_Block=coptic}', "");
    Expect(0, 11519, '\P{Is_Block=coptic}', "");
    Expect(1, 11519, '\P{^Is_Block=coptic}', "");
    Expect(0, 11520, '\p{Is_Block=coptic}', "");
    Expect(1, 11520, '\p{^Is_Block=coptic}', "");
    Expect(1, 11520, '\P{Is_Block=coptic}', "");
    Expect(0, 11520, '\P{^Is_Block=coptic}', "");
    Expect(1, 11519, '\p{Is_Block=-COPTIC}', "");
    Expect(0, 11519, '\p{^Is_Block=-COPTIC}', "");
    Expect(0, 11519, '\P{Is_Block=-COPTIC}', "");
    Expect(1, 11519, '\P{^Is_Block=-COPTIC}', "");
    Expect(0, 11520, '\p{Is_Block=-COPTIC}', "");
    Expect(1, 11520, '\p{^Is_Block=-COPTIC}', "");
    Expect(1, 11520, '\P{Is_Block=-COPTIC}', "");
    Expect(0, 11520, '\P{^Is_Block=-COPTIC}', "");
    Error('\p{Is_Blk=/a/-COPTIC}');
    Error('\P{Is_Blk=/a/-COPTIC}');
    Expect(1, 11519, '\p{Is_Blk=coptic}', "");
    Expect(0, 11519, '\p{^Is_Blk=coptic}', "");
    Expect(0, 11519, '\P{Is_Blk=coptic}', "");
    Expect(1, 11519, '\P{^Is_Blk=coptic}', "");
    Expect(0, 11520, '\p{Is_Blk=coptic}', "");
    Expect(1, 11520, '\p{^Is_Blk=coptic}', "");
    Expect(1, 11520, '\P{Is_Blk=coptic}', "");
    Expect(0, 11520, '\P{^Is_Blk=coptic}', "");
    Expect(1, 11519, '\p{Is_Blk=-_COPTIC}', "");
    Expect(0, 11519, '\p{^Is_Blk=-_COPTIC}', "");
    Expect(0, 11519, '\P{Is_Blk=-_COPTIC}', "");
    Expect(1, 11519, '\P{^Is_Blk=-_COPTIC}', "");
    Expect(0, 11520, '\p{Is_Blk=-_COPTIC}', "");
    Expect(1, 11520, '\p{^Is_Blk=-_COPTIC}', "");
    Expect(1, 11520, '\P{Is_Blk=-_COPTIC}', "");
    Expect(0, 11520, '\P{^Is_Blk=-_COPTIC}', "");
    Error('\p{Block=:=_-Coptic_EPACT_NUMBERS}');
    Error('\P{Block=:=_-Coptic_EPACT_NUMBERS}');
    Expect(1, 66303, '\p{Block=:\ACoptic_Epact_Numbers\z:}', "");;
    Expect(0, 66304, '\p{Block=:\ACoptic_Epact_Numbers\z:}', "");;
    Expect(1, 66303, '\p{Block:copticepactnumbers}', "");
    Expect(0, 66303, '\p{^Block:copticepactnumbers}', "");
    Expect(0, 66303, '\P{Block:copticepactnumbers}', "");
    Expect(1, 66303, '\P{^Block:copticepactnumbers}', "");
    Expect(0, 66304, '\p{Block:copticepactnumbers}', "");
    Expect(1, 66304, '\p{^Block:copticepactnumbers}', "");
    Expect(1, 66304, '\P{Block:copticepactnumbers}', "");
    Expect(0, 66304, '\P{^Block:copticepactnumbers}', "");
    Expect(1, 66303, '\p{Block=:\Acopticepactnumbers\z:}', "");;
    Expect(0, 66304, '\p{Block=:\Acopticepactnumbers\z:}', "");;
    Expect(1, 66303, '\p{Block=	 coptic_EPACT_numbers}', "");
    Expect(0, 66303, '\p{^Block=	 coptic_EPACT_numbers}', "");
    Expect(0, 66303, '\P{Block=	 coptic_EPACT_numbers}', "");
    Expect(1, 66303, '\P{^Block=	 coptic_EPACT_numbers}', "");
    Expect(0, 66304, '\p{Block=	 coptic_EPACT_numbers}', "");
    Expect(1, 66304, '\p{^Block=	 coptic_EPACT_numbers}', "");
    Expect(1, 66304, '\P{Block=	 coptic_EPACT_numbers}', "");
    Expect(0, 66304, '\P{^Block=	 coptic_EPACT_numbers}', "");
    Error('\p{Blk= /a/Coptic_EPACT_NUMBERS}');
    Error('\P{Blk= /a/Coptic_EPACT_NUMBERS}');
    Expect(1, 66303, '\p{Blk=:\ACoptic_Epact_Numbers\z:}', "");;
    Expect(0, 66304, '\p{Blk=:\ACoptic_Epact_Numbers\z:}', "");;
    Expect(1, 66303, '\p{Blk: copticepactnumbers}', "");
    Expect(0, 66303, '\p{^Blk: copticepactnumbers}', "");
    Expect(0, 66303, '\P{Blk: copticepactnumbers}', "");
    Expect(1, 66303, '\P{^Blk: copticepactnumbers}', "");
    Expect(0, 66304, '\p{Blk: copticepactnumbers}', "");
    Expect(1, 66304, '\p{^Blk: copticepactnumbers}', "");
    Expect(1, 66304, '\P{Blk: copticepactnumbers}', "");
    Expect(0, 66304, '\P{^Blk: copticepactnumbers}', "");
    Expect(1, 66303, '\p{Blk=:\Acopticepactnumbers\z:}', "");;
    Expect(0, 66304, '\p{Blk=:\Acopticepactnumbers\z:}', "");;
    Expect(1, 66303, '\p{Blk:   -coptic_Epact_numbers}', "");
    Expect(0, 66303, '\p{^Blk:   -coptic_Epact_numbers}', "");
    Expect(0, 66303, '\P{Blk:   -coptic_Epact_numbers}', "");
    Expect(1, 66303, '\P{^Blk:   -coptic_Epact_numbers}', "");
    Expect(0, 66304, '\p{Blk:   -coptic_Epact_numbers}', "");
    Expect(1, 66304, '\p{^Blk:   -coptic_Epact_numbers}', "");
    Expect(1, 66304, '\P{Blk:   -coptic_Epact_numbers}', "");
    Expect(0, 66304, '\P{^Blk:   -coptic_Epact_numbers}', "");
    Error('\p{Is_Block=-/a/Coptic_Epact_NUMBERS}');
    Error('\P{Is_Block=-/a/Coptic_Epact_NUMBERS}');
    Expect(1, 66303, '\p{Is_Block:	copticepactnumbers}', "");
    Expect(0, 66303, '\p{^Is_Block:	copticepactnumbers}', "");
    Expect(0, 66303, '\P{Is_Block:	copticepactnumbers}', "");
    Expect(1, 66303, '\P{^Is_Block:	copticepactnumbers}', "");
    Expect(0, 66304, '\p{Is_Block:	copticepactnumbers}', "");
    Expect(1, 66304, '\p{^Is_Block:	copticepactnumbers}', "");
    Expect(1, 66304, '\P{Is_Block:	copticepactnumbers}', "");
    Expect(0, 66304, '\P{^Is_Block:	copticepactnumbers}', "");
    Expect(1, 66303, '\p{Is_Block=-_COPTIC_Epact_Numbers}', "");
    Expect(0, 66303, '\p{^Is_Block=-_COPTIC_Epact_Numbers}', "");
    Expect(0, 66303, '\P{Is_Block=-_COPTIC_Epact_Numbers}', "");
    Expect(1, 66303, '\P{^Is_Block=-_COPTIC_Epact_Numbers}', "");
    Expect(0, 66304, '\p{Is_Block=-_COPTIC_Epact_Numbers}', "");
    Expect(1, 66304, '\p{^Is_Block=-_COPTIC_Epact_Numbers}', "");
    Expect(1, 66304, '\P{Is_Block=-_COPTIC_Epact_Numbers}', "");
    Expect(0, 66304, '\P{^Is_Block=-_COPTIC_Epact_Numbers}', "");
    Error('\p{Is_Blk= _Coptic_epact_Numbers/a/}');
    Error('\P{Is_Blk= _Coptic_epact_Numbers/a/}');
    Expect(1, 66303, '\p{Is_Blk:copticepactnumbers}', "");
    Expect(0, 66303, '\p{^Is_Blk:copticepactnumbers}', "");
    Expect(0, 66303, '\P{Is_Blk:copticepactnumbers}', "");
    Expect(1, 66303, '\P{^Is_Blk:copticepactnumbers}', "");
    Expect(0, 66304, '\p{Is_Blk:copticepactnumbers}', "");
    Expect(1, 66304, '\p{^Is_Blk:copticepactnumbers}', "");
    Expect(1, 66304, '\P{Is_Blk:copticepactnumbers}', "");
    Expect(0, 66304, '\P{^Is_Blk:copticepactnumbers}', "");
    Expect(1, 66303, '\p{Is_Blk=	coptic_Epact_Numbers}', "");
    Expect(0, 66303, '\p{^Is_Blk=	coptic_Epact_Numbers}', "");
    Expect(0, 66303, '\P{Is_Blk=	coptic_Epact_Numbers}', "");
    Expect(1, 66303, '\P{^Is_Blk=	coptic_Epact_Numbers}', "");
    Expect(0, 66304, '\p{Is_Blk=	coptic_Epact_Numbers}', "");
    Expect(1, 66304, '\p{^Is_Blk=	coptic_Epact_Numbers}', "");
    Expect(1, 66304, '\P{Is_Blk=	coptic_Epact_Numbers}', "");
    Expect(0, 66304, '\P{^Is_Blk=	coptic_Epact_Numbers}', "");
    Error('\p{Block=  counting_rod_Numerals/a/}');
    Error('\P{Block=  counting_rod_Numerals/a/}');
    Expect(1, 119679, '\p{Block=:\ACounting_Rod_Numerals\z:}', "");;
    Expect(0, 119680, '\p{Block=:\ACounting_Rod_Numerals\z:}', "");;
    Expect(1, 119679, '\p{Block=countingrodnumerals}', "");
    Expect(0, 119679, '\p{^Block=countingrodnumerals}', "");
    Expect(0, 119679, '\P{Block=countingrodnumerals}', "");
    Expect(1, 119679, '\P{^Block=countingrodnumerals}', "");
    Expect(0, 119680, '\p{Block=countingrodnumerals}', "");
    Expect(1, 119680, '\p{^Block=countingrodnumerals}', "");
    Expect(1, 119680, '\P{Block=countingrodnumerals}', "");
    Expect(0, 119680, '\P{^Block=countingrodnumerals}', "");
    Expect(1, 119679, '\p{Block=:\Acountingrodnumerals\z:}', "");;
    Expect(0, 119680, '\p{Block=:\Acountingrodnumerals\z:}', "");;
    Expect(1, 119679, '\p{Block=	-counting_Rod_numerals}', "");
    Expect(0, 119679, '\p{^Block=	-counting_Rod_numerals}', "");
    Expect(0, 119679, '\P{Block=	-counting_Rod_numerals}', "");
    Expect(1, 119679, '\P{^Block=	-counting_Rod_numerals}', "");
    Expect(0, 119680, '\p{Block=	-counting_Rod_numerals}', "");
    Expect(1, 119680, '\p{^Block=	-counting_Rod_numerals}', "");
    Expect(1, 119680, '\P{Block=	-counting_Rod_numerals}', "");
    Expect(0, 119680, '\P{^Block=	-counting_Rod_numerals}', "");
    Error('\p{Blk=/a/_ COUNTING_Rod}');
    Error('\P{Blk=/a/_ COUNTING_Rod}');
    Expect(1, 119679, '\p{Blk=:\ACounting_Rod\z:}', "");;
    Expect(0, 119680, '\p{Blk=:\ACounting_Rod\z:}', "");;
    Expect(1, 119679, '\p{Blk=countingrod}', "");
    Expect(0, 119679, '\p{^Blk=countingrod}', "");
    Expect(0, 119679, '\P{Blk=countingrod}', "");
    Expect(1, 119679, '\P{^Blk=countingrod}', "");
    Expect(0, 119680, '\p{Blk=countingrod}', "");
    Expect(1, 119680, '\p{^Blk=countingrod}', "");
    Expect(1, 119680, '\P{Blk=countingrod}', "");
    Expect(0, 119680, '\P{^Blk=countingrod}', "");
    Expect(1, 119679, '\p{Blk=:\Acountingrod\z:}', "");;
    Expect(0, 119680, '\p{Blk=:\Acountingrod\z:}', "");;
    Expect(1, 119679, '\p{Blk=  Counting_Rod}', "");
    Expect(0, 119679, '\p{^Blk=  Counting_Rod}', "");
    Expect(0, 119679, '\P{Blk=  Counting_Rod}', "");
    Expect(1, 119679, '\P{^Blk=  Counting_Rod}', "");
    Expect(0, 119680, '\p{Blk=  Counting_Rod}', "");
    Expect(1, 119680, '\p{^Blk=  Counting_Rod}', "");
    Expect(1, 119680, '\P{Blk=  Counting_Rod}', "");
    Expect(0, 119680, '\P{^Blk=  Counting_Rod}', "");
    Error('\p{Is_Block=/a/ _counting_ROD_Numerals}');
    Error('\P{Is_Block=/a/ _counting_ROD_Numerals}');
    Expect(1, 119679, '\p{Is_Block=countingrodnumerals}', "");
    Expect(0, 119679, '\p{^Is_Block=countingrodnumerals}', "");
    Expect(0, 119679, '\P{Is_Block=countingrodnumerals}', "");
    Expect(1, 119679, '\P{^Is_Block=countingrodnumerals}', "");
    Expect(0, 119680, '\p{Is_Block=countingrodnumerals}', "");
    Expect(1, 119680, '\p{^Is_Block=countingrodnumerals}', "");
    Expect(1, 119680, '\P{Is_Block=countingrodnumerals}', "");
    Expect(0, 119680, '\P{^Is_Block=countingrodnumerals}', "");
    Expect(1, 119679, '\p{Is_Block=	COUNTING_ROD_NUMERALS}', "");
    Expect(0, 119679, '\p{^Is_Block=	COUNTING_ROD_NUMERALS}', "");
    Expect(0, 119679, '\P{Is_Block=	COUNTING_ROD_NUMERALS}', "");
    Expect(1, 119679, '\P{^Is_Block=	COUNTING_ROD_NUMERALS}', "");
    Expect(0, 119680, '\p{Is_Block=	COUNTING_ROD_NUMERALS}', "");
    Expect(1, 119680, '\p{^Is_Block=	COUNTING_ROD_NUMERALS}', "");
    Expect(1, 119680, '\P{Is_Block=	COUNTING_ROD_NUMERALS}', "");
    Expect(0, 119680, '\P{^Is_Block=	COUNTING_ROD_NUMERALS}', "");
    Error('\p{Is_Blk=/a/_Counting_Rod}');
    Error('\P{Is_Blk=/a/_Counting_Rod}');
    Expect(1, 119679, '\p{Is_Blk=countingrod}', "");
    Expect(0, 119679, '\p{^Is_Blk=countingrod}', "");
    Expect(0, 119679, '\P{Is_Blk=countingrod}', "");
    Expect(1, 119679, '\P{^Is_Blk=countingrod}', "");
    Expect(0, 119680, '\p{Is_Blk=countingrod}', "");
    Expect(1, 119680, '\p{^Is_Blk=countingrod}', "");
    Expect(1, 119680, '\P{Is_Blk=countingrod}', "");
    Expect(0, 119680, '\P{^Is_Blk=countingrod}', "");
    Expect(1, 119679, '\p{Is_Blk=-	counting_Rod}', "");
    Expect(0, 119679, '\p{^Is_Blk=-	counting_Rod}', "");
    Expect(0, 119679, '\P{Is_Blk=-	counting_Rod}', "");
    Expect(1, 119679, '\P{^Is_Blk=-	counting_Rod}', "");
    Expect(0, 119680, '\p{Is_Blk=-	counting_Rod}', "");
    Expect(1, 119680, '\p{^Is_Blk=-	counting_Rod}', "");
    Expect(1, 119680, '\P{Is_Blk=-	counting_Rod}', "");
    Expect(0, 119680, '\P{^Is_Blk=-	counting_Rod}', "");
    Error('\p{Block=/a/_	CUNEIFORM}');
    Error('\P{Block=/a/_	CUNEIFORM}');
    Expect(1, 74751, '\p{Block=:\ACuneiform\z:}', "");;
    Expect(0, 74752, '\p{Block=:\ACuneiform\z:}', "");;
    Expect(1, 74751, '\p{Block=cuneiform}', "");
    Expect(0, 74751, '\p{^Block=cuneiform}', "");
    Expect(0, 74751, '\P{Block=cuneiform}', "");
    Expect(1, 74751, '\P{^Block=cuneiform}', "");
    Expect(0, 74752, '\p{Block=cuneiform}', "");
    Expect(1, 74752, '\p{^Block=cuneiform}', "");
    Expect(1, 74752, '\P{Block=cuneiform}', "");
    Expect(0, 74752, '\P{^Block=cuneiform}', "");
    Expect(1, 74751, '\p{Block=:\Acuneiform\z:}', "");;
    Expect(0, 74752, '\p{Block=:\Acuneiform\z:}', "");;
    Expect(1, 74751, '\p{Block=_	Cuneiform}', "");
    Expect(0, 74751, '\p{^Block=_	Cuneiform}', "");
    Expect(0, 74751, '\P{Block=_	Cuneiform}', "");
    Expect(1, 74751, '\P{^Block=_	Cuneiform}', "");
    Expect(0, 74752, '\p{Block=_	Cuneiform}', "");
    Expect(1, 74752, '\p{^Block=_	Cuneiform}', "");
    Expect(1, 74752, '\P{Block=_	Cuneiform}', "");
    Expect(0, 74752, '\P{^Block=_	Cuneiform}', "");
    Error('\p{Blk=:=	Cuneiform}');
    Error('\P{Blk=:=	Cuneiform}');
    Expect(1, 74751, '\p{Blk=:\ACuneiform\z:}', "");;
    Expect(0, 74752, '\p{Blk=:\ACuneiform\z:}', "");;
    Expect(1, 74751, '\p{Blk=cuneiform}', "");
    Expect(0, 74751, '\p{^Blk=cuneiform}', "");
    Expect(0, 74751, '\P{Blk=cuneiform}', "");
    Expect(1, 74751, '\P{^Blk=cuneiform}', "");
    Expect(0, 74752, '\p{Blk=cuneiform}', "");
    Expect(1, 74752, '\p{^Blk=cuneiform}', "");
    Expect(1, 74752, '\P{Blk=cuneiform}', "");
    Expect(0, 74752, '\P{^Blk=cuneiform}', "");
    Expect(1, 74751, '\p{Blk=:\Acuneiform\z:}', "");;
    Expect(0, 74752, '\p{Blk=:\Acuneiform\z:}', "");;
    Expect(1, 74751, '\p{Blk:		cuneiform}', "");
    Expect(0, 74751, '\p{^Blk:		cuneiform}', "");
    Expect(0, 74751, '\P{Blk:		cuneiform}', "");
    Expect(1, 74751, '\P{^Blk:		cuneiform}', "");
    Expect(0, 74752, '\p{Blk:		cuneiform}', "");
    Expect(1, 74752, '\p{^Blk:		cuneiform}', "");
    Expect(1, 74752, '\P{Blk:		cuneiform}', "");
    Expect(0, 74752, '\P{^Blk:		cuneiform}', "");
    Error('\p{Is_Block=/a/  cuneiform}');
    Error('\P{Is_Block=/a/  cuneiform}');
    Expect(1, 74751, '\p{Is_Block:   cuneiform}', "");
    Expect(0, 74751, '\p{^Is_Block:   cuneiform}', "");
    Expect(0, 74751, '\P{Is_Block:   cuneiform}', "");
    Expect(1, 74751, '\P{^Is_Block:   cuneiform}', "");
    Expect(0, 74752, '\p{Is_Block:   cuneiform}', "");
    Expect(1, 74752, '\p{^Is_Block:   cuneiform}', "");
    Expect(1, 74752, '\P{Is_Block:   cuneiform}', "");
    Expect(0, 74752, '\P{^Is_Block:   cuneiform}', "");
    Expect(1, 74751, '\p{Is_Block=__CUNEIFORM}', "");
    Expect(0, 74751, '\p{^Is_Block=__CUNEIFORM}', "");
    Expect(0, 74751, '\P{Is_Block=__CUNEIFORM}', "");
    Expect(1, 74751, '\P{^Is_Block=__CUNEIFORM}', "");
    Expect(0, 74752, '\p{Is_Block=__CUNEIFORM}', "");
    Expect(1, 74752, '\p{^Is_Block=__CUNEIFORM}', "");
    Expect(1, 74752, '\P{Is_Block=__CUNEIFORM}', "");
    Expect(0, 74752, '\P{^Is_Block=__CUNEIFORM}', "");
    Error('\p{Is_Blk:   	:=cuneiform}');
    Error('\P{Is_Blk:   	:=cuneiform}');
    Expect(1, 74751, '\p{Is_Blk=cuneiform}', "");
    Expect(0, 74751, '\p{^Is_Blk=cuneiform}', "");
    Expect(0, 74751, '\P{Is_Blk=cuneiform}', "");
    Expect(1, 74751, '\P{^Is_Blk=cuneiform}', "");
    Expect(0, 74752, '\p{Is_Blk=cuneiform}', "");
    Expect(1, 74752, '\p{^Is_Blk=cuneiform}', "");
    Expect(1, 74752, '\P{Is_Blk=cuneiform}', "");
    Expect(0, 74752, '\P{^Is_Blk=cuneiform}', "");
    Expect(1, 74751, '\p{Is_Blk=  cuneiform}', "");
    Expect(0, 74751, '\p{^Is_Blk=  cuneiform}', "");
    Expect(0, 74751, '\P{Is_Blk=  cuneiform}', "");
    Expect(1, 74751, '\P{^Is_Blk=  cuneiform}', "");
    Expect(0, 74752, '\p{Is_Blk=  cuneiform}', "");
    Expect(1, 74752, '\p{^Is_Blk=  cuneiform}', "");
    Expect(1, 74752, '\P{Is_Blk=  cuneiform}', "");
    Expect(0, 74752, '\P{^Is_Blk=  cuneiform}', "");
    Error('\p{Block=:=_cuneiform_numbers_And_Punctuation}');
    Error('\P{Block=:=_cuneiform_numbers_And_Punctuation}');
    Expect(1, 74879, '\p{Block=:\ACuneiform_Numbers_And_Punctuation\z:}', "");;
    Expect(0, 74880, '\p{Block=:\ACuneiform_Numbers_And_Punctuation\z:}', "");;
    Expect(1, 74879, '\p{Block=cuneiformnumbersandpunctuation}', "");
    Expect(0, 74879, '\p{^Block=cuneiformnumbersandpunctuation}', "");
    Expect(0, 74879, '\P{Block=cuneiformnumbersandpunctuation}', "");
    Expect(1, 74879, '\P{^Block=cuneiformnumbersandpunctuation}', "");
    Expect(0, 74880, '\p{Block=cuneiformnumbersandpunctuation}', "");
    Expect(1, 74880, '\p{^Block=cuneiformnumbersandpunctuation}', "");
    Expect(1, 74880, '\P{Block=cuneiformnumbersandpunctuation}', "");
    Expect(0, 74880, '\P{^Block=cuneiformnumbersandpunctuation}', "");
    Expect(1, 74879, '\p{Block=:\Acuneiformnumbersandpunctuation\z:}', "");;
    Expect(0, 74880, '\p{Block=:\Acuneiformnumbersandpunctuation\z:}', "");;
    Expect(1, 74879, '\p{Block= 	Cuneiform_numbers_AND_punctuation}', "");
    Expect(0, 74879, '\p{^Block= 	Cuneiform_numbers_AND_punctuation}', "");
    Expect(0, 74879, '\P{Block= 	Cuneiform_numbers_AND_punctuation}', "");
    Expect(1, 74879, '\P{^Block= 	Cuneiform_numbers_AND_punctuation}', "");
    Expect(0, 74880, '\p{Block= 	Cuneiform_numbers_AND_punctuation}', "");
    Expect(1, 74880, '\p{^Block= 	Cuneiform_numbers_AND_punctuation}', "");
    Expect(1, 74880, '\P{Block= 	Cuneiform_numbers_AND_punctuation}', "");
    Expect(0, 74880, '\P{^Block= 	Cuneiform_numbers_AND_punctuation}', "");
    Error('\p{Blk=/a/ 	cuneiform_Numbers}');
    Error('\P{Blk=/a/ 	cuneiform_Numbers}');
    Expect(1, 74879, '\p{Blk=:\ACuneiform_Numbers\z:}', "");;
    Expect(0, 74880, '\p{Blk=:\ACuneiform_Numbers\z:}', "");;
    Expect(1, 74879, '\p{Blk=cuneiformnumbers}', "");
    Expect(0, 74879, '\p{^Blk=cuneiformnumbers}', "");
    Expect(0, 74879, '\P{Blk=cuneiformnumbers}', "");
    Expect(1, 74879, '\P{^Blk=cuneiformnumbers}', "");
    Expect(0, 74880, '\p{Blk=cuneiformnumbers}', "");
    Expect(1, 74880, '\p{^Blk=cuneiformnumbers}', "");
    Expect(1, 74880, '\P{Blk=cuneiformnumbers}', "");
    Expect(0, 74880, '\P{^Blk=cuneiformnumbers}', "");
    Expect(1, 74879, '\p{Blk=:\Acuneiformnumbers\z:}', "");;
    Expect(0, 74880, '\p{Blk=:\Acuneiformnumbers\z:}', "");;
    Expect(1, 74879, '\p{Blk=_cuneiform_numbers}', "");
    Expect(0, 74879, '\p{^Blk=_cuneiform_numbers}', "");
    Expect(0, 74879, '\P{Blk=_cuneiform_numbers}', "");
    Expect(1, 74879, '\P{^Blk=_cuneiform_numbers}', "");
    Expect(0, 74880, '\p{Blk=_cuneiform_numbers}', "");
    Expect(1, 74880, '\p{^Blk=_cuneiform_numbers}', "");
    Expect(1, 74880, '\P{Blk=_cuneiform_numbers}', "");
    Expect(0, 74880, '\P{^Blk=_cuneiform_numbers}', "");
    Error('\p{Is_Block=	:=Cuneiform_Numbers_AND_Punctuation}');
    Error('\P{Is_Block=	:=Cuneiform_Numbers_AND_Punctuation}');
    Expect(1, 74879, '\p{Is_Block=cuneiformnumbersandpunctuation}', "");
    Expect(0, 74879, '\p{^Is_Block=cuneiformnumbersandpunctuation}', "");
    Expect(0, 74879, '\P{Is_Block=cuneiformnumbersandpunctuation}', "");
    Expect(1, 74879, '\P{^Is_Block=cuneiformnumbersandpunctuation}', "");
    Expect(0, 74880, '\p{Is_Block=cuneiformnumbersandpunctuation}', "");
    Expect(1, 74880, '\p{^Is_Block=cuneiformnumbersandpunctuation}', "");
    Expect(1, 74880, '\P{Is_Block=cuneiformnumbersandpunctuation}', "");
    Expect(0, 74880, '\P{^Is_Block=cuneiformnumbersandpunctuation}', "");
    Expect(1, 74879, '\p{Is_Block=_ Cuneiform_NUMBERS_And_Punctuation}', "");
    Expect(0, 74879, '\p{^Is_Block=_ Cuneiform_NUMBERS_And_Punctuation}', "");
    Expect(0, 74879, '\P{Is_Block=_ Cuneiform_NUMBERS_And_Punctuation}', "");
    Expect(1, 74879, '\P{^Is_Block=_ Cuneiform_NUMBERS_And_Punctuation}', "");
    Expect(0, 74880, '\p{Is_Block=_ Cuneiform_NUMBERS_And_Punctuation}', "");
    Expect(1, 74880, '\p{^Is_Block=_ Cuneiform_NUMBERS_And_Punctuation}', "");
    Expect(1, 74880, '\P{Is_Block=_ Cuneiform_NUMBERS_And_Punctuation}', "");
    Expect(0, 74880, '\P{^Is_Block=_ Cuneiform_NUMBERS_And_Punctuation}', "");
    Error('\p{Is_Blk= CUNEIFORM_NUMBERS:=}');
    Error('\P{Is_Blk= CUNEIFORM_NUMBERS:=}');
    Expect(1, 74879, '\p{Is_Blk=cuneiformnumbers}', "");
    Expect(0, 74879, '\p{^Is_Blk=cuneiformnumbers}', "");
    Expect(0, 74879, '\P{Is_Blk=cuneiformnumbers}', "");
    Expect(1, 74879, '\P{^Is_Blk=cuneiformnumbers}', "");
    Expect(0, 74880, '\p{Is_Blk=cuneiformnumbers}', "");
    Expect(1, 74880, '\p{^Is_Blk=cuneiformnumbers}', "");
    Expect(1, 74880, '\P{Is_Blk=cuneiformnumbers}', "");
    Expect(0, 74880, '\P{^Is_Blk=cuneiformnumbers}', "");
    Expect(1, 74879, '\p{Is_Blk=		cuneiform_numbers}', "");
    Expect(0, 74879, '\p{^Is_Blk=		cuneiform_numbers}', "");
    Expect(0, 74879, '\P{Is_Blk=		cuneiform_numbers}', "");
    Expect(1, 74879, '\P{^Is_Blk=		cuneiform_numbers}', "");
    Expect(0, 74880, '\p{Is_Blk=		cuneiform_numbers}', "");
    Expect(1, 74880, '\p{^Is_Blk=		cuneiform_numbers}', "");
    Expect(1, 74880, '\P{Is_Blk=		cuneiform_numbers}', "");
    Expect(0, 74880, '\P{^Is_Blk=		cuneiform_numbers}', "");
    Error('\p{Block=		Currency_Symbols/a/}');
    Error('\P{Block=		Currency_Symbols/a/}');
    Expect(1, 8399, '\p{Block=:\ACurrency_Symbols\z:}', "");;
    Expect(0, 8400, '\p{Block=:\ACurrency_Symbols\z:}', "");;
    Expect(1, 8399, '\p{Block=currencysymbols}', "");
    Expect(0, 8399, '\p{^Block=currencysymbols}', "");
    Expect(0, 8399, '\P{Block=currencysymbols}', "");
    Expect(1, 8399, '\P{^Block=currencysymbols}', "");
    Expect(0, 8400, '\p{Block=currencysymbols}', "");
    Expect(1, 8400, '\p{^Block=currencysymbols}', "");
    Expect(1, 8400, '\P{Block=currencysymbols}', "");
    Expect(0, 8400, '\P{^Block=currencysymbols}', "");
    Expect(1, 8399, '\p{Block=:\Acurrencysymbols\z:}', "");;
    Expect(0, 8400, '\p{Block=:\Acurrencysymbols\z:}', "");;
    Expect(1, 8399, '\p{Block=Currency_Symbols}', "");
    Expect(0, 8399, '\p{^Block=Currency_Symbols}', "");
    Expect(0, 8399, '\P{Block=Currency_Symbols}', "");
    Expect(1, 8399, '\P{^Block=Currency_Symbols}', "");
    Expect(0, 8400, '\p{Block=Currency_Symbols}', "");
    Expect(1, 8400, '\p{^Block=Currency_Symbols}', "");
    Expect(1, 8400, '\P{Block=Currency_Symbols}', "");
    Expect(0, 8400, '\P{^Block=Currency_Symbols}', "");
    Error('\p{Blk=Currency_Symbols/a/}');
    Error('\P{Blk=Currency_Symbols/a/}');
    Expect(1, 8399, '\p{Blk=:\ACurrency_Symbols\z:}', "");;
    Expect(0, 8400, '\p{Blk=:\ACurrency_Symbols\z:}', "");;
    Expect(1, 8399, '\p{Blk=currencysymbols}', "");
    Expect(0, 8399, '\p{^Blk=currencysymbols}', "");
    Expect(0, 8399, '\P{Blk=currencysymbols}', "");
    Expect(1, 8399, '\P{^Blk=currencysymbols}', "");
    Expect(0, 8400, '\p{Blk=currencysymbols}', "");
    Expect(1, 8400, '\p{^Blk=currencysymbols}', "");
    Expect(1, 8400, '\P{Blk=currencysymbols}', "");
    Expect(0, 8400, '\P{^Blk=currencysymbols}', "");
    Expect(1, 8399, '\p{Blk=:\Acurrencysymbols\z:}', "");;
    Expect(0, 8400, '\p{Blk=:\Acurrencysymbols\z:}', "");;
    Expect(1, 8399, '\p{Blk:	- Currency_Symbols}', "");
    Expect(0, 8399, '\p{^Blk:	- Currency_Symbols}', "");
    Expect(0, 8399, '\P{Blk:	- Currency_Symbols}', "");
    Expect(1, 8399, '\P{^Blk:	- Currency_Symbols}', "");
    Expect(0, 8400, '\p{Blk:	- Currency_Symbols}', "");
    Expect(1, 8400, '\p{^Blk:	- Currency_Symbols}', "");
    Expect(1, 8400, '\P{Blk:	- Currency_Symbols}', "");
    Expect(0, 8400, '\P{^Blk:	- Currency_Symbols}', "");
    Error('\p{Is_Block=	_Currency_symbols/a/}');
    Error('\P{Is_Block=	_Currency_symbols/a/}');
    Expect(1, 8399, '\p{Is_Block=currencysymbols}', "");
    Expect(0, 8399, '\p{^Is_Block=currencysymbols}', "");
    Expect(0, 8399, '\P{Is_Block=currencysymbols}', "");
    Expect(1, 8399, '\P{^Is_Block=currencysymbols}', "");
    Expect(0, 8400, '\p{Is_Block=currencysymbols}', "");
    Expect(1, 8400, '\p{^Is_Block=currencysymbols}', "");
    Expect(1, 8400, '\P{Is_Block=currencysymbols}', "");
    Expect(0, 8400, '\P{^Is_Block=currencysymbols}', "");
    Expect(1, 8399, '\p{Is_Block=-	Currency_SYMBOLS}', "");
    Expect(0, 8399, '\p{^Is_Block=-	Currency_SYMBOLS}', "");
    Expect(0, 8399, '\P{Is_Block=-	Currency_SYMBOLS}', "");
    Expect(1, 8399, '\P{^Is_Block=-	Currency_SYMBOLS}', "");
    Expect(0, 8400, '\p{Is_Block=-	Currency_SYMBOLS}', "");
    Expect(1, 8400, '\p{^Is_Block=-	Currency_SYMBOLS}', "");
    Expect(1, 8400, '\P{Is_Block=-	Currency_SYMBOLS}', "");
    Expect(0, 8400, '\P{^Is_Block=-	Currency_SYMBOLS}', "");
    Error('\p{Is_Blk= currency_symbols/a/}');
    Error('\P{Is_Blk= currency_symbols/a/}');
    Expect(1, 8399, '\p{Is_Blk=currencysymbols}', "");
    Expect(0, 8399, '\p{^Is_Blk=currencysymbols}', "");
    Expect(0, 8399, '\P{Is_Blk=currencysymbols}', "");
    Expect(1, 8399, '\P{^Is_Blk=currencysymbols}', "");
    Expect(0, 8400, '\p{Is_Blk=currencysymbols}', "");
    Expect(1, 8400, '\p{^Is_Blk=currencysymbols}', "");
    Expect(1, 8400, '\P{Is_Blk=currencysymbols}', "");
    Expect(0, 8400, '\P{^Is_Blk=currencysymbols}', "");
    Expect(1, 8399, '\p{Is_Blk=	-Currency_Symbols}', "");
    Expect(0, 8399, '\p{^Is_Blk=	-Currency_Symbols}', "");
    Expect(0, 8399, '\P{Is_Blk=	-Currency_Symbols}', "");
    Expect(1, 8399, '\P{^Is_Blk=	-Currency_Symbols}', "");
    Expect(0, 8400, '\p{Is_Blk=	-Currency_Symbols}', "");
    Expect(1, 8400, '\p{^Is_Blk=	-Currency_Symbols}', "");
    Expect(1, 8400, '\P{Is_Blk=	-Currency_Symbols}', "");
    Expect(0, 8400, '\P{^Is_Blk=	-Currency_Symbols}', "");
    Error('\p{Block=  Cypriot_SYLLABARY/a/}');
    Error('\P{Block=  Cypriot_SYLLABARY/a/}');
    Expect(1, 67647, '\p{Block=:\ACypriot_Syllabary\z:}', "");;
    Expect(0, 67648, '\p{Block=:\ACypriot_Syllabary\z:}', "");;
    Expect(1, 67647, '\p{Block=cypriotsyllabary}', "");
    Expect(0, 67647, '\p{^Block=cypriotsyllabary}', "");
    Expect(0, 67647, '\P{Block=cypriotsyllabary}', "");
    Expect(1, 67647, '\P{^Block=cypriotsyllabary}', "");
    Expect(0, 67648, '\p{Block=cypriotsyllabary}', "");
    Expect(1, 67648, '\p{^Block=cypriotsyllabary}', "");
    Expect(1, 67648, '\P{Block=cypriotsyllabary}', "");
    Expect(0, 67648, '\P{^Block=cypriotsyllabary}', "");
    Expect(1, 67647, '\p{Block=:\Acypriotsyllabary\z:}', "");;
    Expect(0, 67648, '\p{Block=:\Acypriotsyllabary\z:}', "");;
    Expect(1, 67647, '\p{Block=	Cypriot_Syllabary}', "");
    Expect(0, 67647, '\p{^Block=	Cypriot_Syllabary}', "");
    Expect(0, 67647, '\P{Block=	Cypriot_Syllabary}', "");
    Expect(1, 67647, '\P{^Block=	Cypriot_Syllabary}', "");
    Expect(0, 67648, '\p{Block=	Cypriot_Syllabary}', "");
    Expect(1, 67648, '\p{^Block=	Cypriot_Syllabary}', "");
    Expect(1, 67648, '\P{Block=	Cypriot_Syllabary}', "");
    Expect(0, 67648, '\P{^Block=	Cypriot_Syllabary}', "");
    Error('\p{Blk=:=cypriot_SYLLABARY}');
    Error('\P{Blk=:=cypriot_SYLLABARY}');
    Expect(1, 67647, '\p{Blk=:\ACypriot_Syllabary\z:}', "");;
    Expect(0, 67648, '\p{Blk=:\ACypriot_Syllabary\z:}', "");;
    Expect(1, 67647, '\p{Blk=cypriotsyllabary}', "");
    Expect(0, 67647, '\p{^Blk=cypriotsyllabary}', "");
    Expect(0, 67647, '\P{Blk=cypriotsyllabary}', "");
    Expect(1, 67647, '\P{^Blk=cypriotsyllabary}', "");
    Expect(0, 67648, '\p{Blk=cypriotsyllabary}', "");
    Expect(1, 67648, '\p{^Blk=cypriotsyllabary}', "");
    Expect(1, 67648, '\P{Blk=cypriotsyllabary}', "");
    Expect(0, 67648, '\P{^Blk=cypriotsyllabary}', "");
    Expect(1, 67647, '\p{Blk=:\Acypriotsyllabary\z:}', "");;
    Expect(0, 67648, '\p{Blk=:\Acypriotsyllabary\z:}', "");;
    Expect(1, 67647, '\p{Blk=		CYPRIOT_syllabary}', "");
    Expect(0, 67647, '\p{^Blk=		CYPRIOT_syllabary}', "");
    Expect(0, 67647, '\P{Blk=		CYPRIOT_syllabary}', "");
    Expect(1, 67647, '\P{^Blk=		CYPRIOT_syllabary}', "");
    Expect(0, 67648, '\p{Blk=		CYPRIOT_syllabary}', "");
    Expect(1, 67648, '\p{^Blk=		CYPRIOT_syllabary}', "");
    Expect(1, 67648, '\P{Blk=		CYPRIOT_syllabary}', "");
    Expect(0, 67648, '\P{^Blk=		CYPRIOT_syllabary}', "");
    Error('\p{Is_Block=:= -Cypriot_Syllabary}');
    Error('\P{Is_Block=:= -Cypriot_Syllabary}');
    Expect(1, 67647, '\p{Is_Block=cypriotsyllabary}', "");
    Expect(0, 67647, '\p{^Is_Block=cypriotsyllabary}', "");
    Expect(0, 67647, '\P{Is_Block=cypriotsyllabary}', "");
    Expect(1, 67647, '\P{^Is_Block=cypriotsyllabary}', "");
    Expect(0, 67648, '\p{Is_Block=cypriotsyllabary}', "");
    Expect(1, 67648, '\p{^Is_Block=cypriotsyllabary}', "");
    Expect(1, 67648, '\P{Is_Block=cypriotsyllabary}', "");
    Expect(0, 67648, '\P{^Is_Block=cypriotsyllabary}', "");
    Expect(1, 67647, '\p{Is_Block=-Cypriot_Syllabary}', "");
    Expect(0, 67647, '\p{^Is_Block=-Cypriot_Syllabary}', "");
    Expect(0, 67647, '\P{Is_Block=-Cypriot_Syllabary}', "");
    Expect(1, 67647, '\P{^Is_Block=-Cypriot_Syllabary}', "");
    Expect(0, 67648, '\p{Is_Block=-Cypriot_Syllabary}', "");
    Expect(1, 67648, '\p{^Is_Block=-Cypriot_Syllabary}', "");
    Expect(1, 67648, '\P{Is_Block=-Cypriot_Syllabary}', "");
    Expect(0, 67648, '\P{^Is_Block=-Cypriot_Syllabary}', "");
    Error('\p{Is_Blk=/a/-cypriot_SYLLABARY}');
    Error('\P{Is_Blk=/a/-cypriot_SYLLABARY}');
    Expect(1, 67647, '\p{Is_Blk=cypriotsyllabary}', "");
    Expect(0, 67647, '\p{^Is_Blk=cypriotsyllabary}', "");
    Expect(0, 67647, '\P{Is_Blk=cypriotsyllabary}', "");
    Expect(1, 67647, '\P{^Is_Blk=cypriotsyllabary}', "");
    Expect(0, 67648, '\p{Is_Blk=cypriotsyllabary}', "");
    Expect(1, 67648, '\p{^Is_Blk=cypriotsyllabary}', "");
    Expect(1, 67648, '\P{Is_Blk=cypriotsyllabary}', "");
    Expect(0, 67648, '\P{^Is_Blk=cypriotsyllabary}', "");
    Expect(1, 67647, '\p{Is_Blk= cypriot_syllabary}', "");
    Expect(0, 67647, '\p{^Is_Blk= cypriot_syllabary}', "");
    Expect(0, 67647, '\P{Is_Blk= cypriot_syllabary}', "");
    Expect(1, 67647, '\P{^Is_Blk= cypriot_syllabary}', "");
    Expect(0, 67648, '\p{Is_Blk= cypriot_syllabary}', "");
    Expect(1, 67648, '\p{^Is_Blk= cypriot_syllabary}', "");
    Expect(1, 67648, '\P{Is_Blk= cypriot_syllabary}', "");
    Expect(0, 67648, '\P{^Is_Blk= cypriot_syllabary}', "");
    Error('\p{Block=- cypro_MINOAN:=}');
    Error('\P{Block=- cypro_MINOAN:=}');
    Expect(1, 77823, '\p{Block=:\ACypro_Minoan\z:}', "");;
    Expect(0, 77824, '\p{Block=:\ACypro_Minoan\z:}', "");;
    Expect(1, 77823, '\p{Block=cyprominoan}', "");
    Expect(0, 77823, '\p{^Block=cyprominoan}', "");
    Expect(0, 77823, '\P{Block=cyprominoan}', "");
    Expect(1, 77823, '\P{^Block=cyprominoan}', "");
    Expect(0, 77824, '\p{Block=cyprominoan}', "");
    Expect(1, 77824, '\p{^Block=cyprominoan}', "");
    Expect(1, 77824, '\P{Block=cyprominoan}', "");
    Expect(0, 77824, '\P{^Block=cyprominoan}', "");
    Expect(1, 77823, '\p{Block=:\Acyprominoan\z:}', "");;
    Expect(0, 77824, '\p{Block=:\Acyprominoan\z:}', "");;
    Expect(1, 77823, '\p{Block=_-Cypro_Minoan}', "");
    Expect(0, 77823, '\p{^Block=_-Cypro_Minoan}', "");
    Expect(0, 77823, '\P{Block=_-Cypro_Minoan}', "");
    Expect(1, 77823, '\P{^Block=_-Cypro_Minoan}', "");
    Expect(0, 77824, '\p{Block=_-Cypro_Minoan}', "");
    Expect(1, 77824, '\p{^Block=_-Cypro_Minoan}', "");
    Expect(1, 77824, '\P{Block=_-Cypro_Minoan}', "");
    Expect(0, 77824, '\P{^Block=_-Cypro_Minoan}', "");
    Error('\p{Blk= -CYPRO_Minoan:=}');
    Error('\P{Blk= -CYPRO_Minoan:=}');
    Expect(1, 77823, '\p{Blk=:\ACypro_Minoan\z:}', "");;
    Expect(0, 77824, '\p{Blk=:\ACypro_Minoan\z:}', "");;
    Expect(1, 77823, '\p{Blk=cyprominoan}', "");
    Expect(0, 77823, '\p{^Blk=cyprominoan}', "");
    Expect(0, 77823, '\P{Blk=cyprominoan}', "");
    Expect(1, 77823, '\P{^Blk=cyprominoan}', "");
    Expect(0, 77824, '\p{Blk=cyprominoan}', "");
    Expect(1, 77824, '\p{^Blk=cyprominoan}', "");
    Expect(1, 77824, '\P{Blk=cyprominoan}', "");
    Expect(0, 77824, '\P{^Blk=cyprominoan}', "");
    Expect(1, 77823, '\p{Blk=:\Acyprominoan\z:}', "");;
    Expect(0, 77824, '\p{Blk=:\Acyprominoan\z:}', "");;
    Expect(1, 77823, '\p{Blk=--Cypro_MINOAN}', "");
    Expect(0, 77823, '\p{^Blk=--Cypro_MINOAN}', "");
    Expect(0, 77823, '\P{Blk=--Cypro_MINOAN}', "");
    Expect(1, 77823, '\P{^Blk=--Cypro_MINOAN}', "");
    Expect(0, 77824, '\p{Blk=--Cypro_MINOAN}', "");
    Expect(1, 77824, '\p{^Blk=--Cypro_MINOAN}', "");
    Expect(1, 77824, '\P{Blk=--Cypro_MINOAN}', "");
    Expect(0, 77824, '\P{^Blk=--Cypro_MINOAN}', "");
    Error('\p{Is_Block=-:=cypro_Minoan}');
    Error('\P{Is_Block=-:=cypro_Minoan}');
    Expect(1, 77823, '\p{Is_Block=cyprominoan}', "");
    Expect(0, 77823, '\p{^Is_Block=cyprominoan}', "");
    Expect(0, 77823, '\P{Is_Block=cyprominoan}', "");
    Expect(1, 77823, '\P{^Is_Block=cyprominoan}', "");
    Expect(0, 77824, '\p{Is_Block=cyprominoan}', "");
    Expect(1, 77824, '\p{^Is_Block=cyprominoan}', "");
    Expect(1, 77824, '\P{Is_Block=cyprominoan}', "");
    Expect(0, 77824, '\P{^Is_Block=cyprominoan}', "");
    Expect(1, 77823, '\p{Is_Block=__cypro_MINOAN}', "");
    Expect(0, 77823, '\p{^Is_Block=__cypro_MINOAN}', "");
    Expect(0, 77823, '\P{Is_Block=__cypro_MINOAN}', "");
    Expect(1, 77823, '\P{^Is_Block=__cypro_MINOAN}', "");
    Expect(0, 77824, '\p{Is_Block=__cypro_MINOAN}', "");
    Expect(1, 77824, '\p{^Is_Block=__cypro_MINOAN}', "");
    Expect(1, 77824, '\P{Is_Block=__cypro_MINOAN}', "");
    Expect(0, 77824, '\P{^Is_Block=__cypro_MINOAN}', "");
    Error('\p{Is_Blk=	/a/Cypro_minoan}');
    Error('\P{Is_Blk=	/a/Cypro_minoan}');
    Expect(1, 77823, '\p{Is_Blk=cyprominoan}', "");
    Expect(0, 77823, '\p{^Is_Blk=cyprominoan}', "");
    Expect(0, 77823, '\P{Is_Blk=cyprominoan}', "");
    Expect(1, 77823, '\P{^Is_Blk=cyprominoan}', "");
    Expect(0, 77824, '\p{Is_Blk=cyprominoan}', "");
    Expect(1, 77824, '\p{^Is_Blk=cyprominoan}', "");
    Expect(1, 77824, '\P{Is_Blk=cyprominoan}', "");
    Expect(0, 77824, '\P{^Is_Blk=cyprominoan}', "");
    Expect(1, 77823, '\p{Is_Blk=	-Cypro_Minoan}', "");
    Expect(0, 77823, '\p{^Is_Blk=	-Cypro_Minoan}', "");
    Expect(0, 77823, '\P{Is_Blk=	-Cypro_Minoan}', "");
    Expect(1, 77823, '\P{^Is_Blk=	-Cypro_Minoan}', "");
    Expect(0, 77824, '\p{Is_Blk=	-Cypro_Minoan}', "");
    Expect(1, 77824, '\p{^Is_Blk=	-Cypro_Minoan}', "");
    Expect(1, 77824, '\P{Is_Blk=	-Cypro_Minoan}', "");
    Expect(0, 77824, '\P{^Is_Blk=	-Cypro_Minoan}', "");
    Error('\p{Block=	-cyrillic:=}');
    Error('\P{Block=	-cyrillic:=}');
    Expect(1, 1279, '\p{Block=:\ACyrillic\z:}', "");;
    Expect(0, 1280, '\p{Block=:\ACyrillic\z:}', "");;
    Expect(1, 1279, '\p{Block=cyrillic}', "");
    Expect(0, 1279, '\p{^Block=cyrillic}', "");
    Expect(0, 1279, '\P{Block=cyrillic}', "");
    Expect(1, 1279, '\P{^Block=cyrillic}', "");
    Expect(0, 1280, '\p{Block=cyrillic}', "");
    Expect(1, 1280, '\p{^Block=cyrillic}', "");
    Expect(1, 1280, '\P{Block=cyrillic}', "");
    Expect(0, 1280, '\P{^Block=cyrillic}', "");
    Expect(1, 1279, '\p{Block=:\Acyrillic\z:}', "");;
    Expect(0, 1280, '\p{Block=:\Acyrillic\z:}', "");;
    Expect(1, 1279, '\p{Block=	CYRILLIC}', "");
    Expect(0, 1279, '\p{^Block=	CYRILLIC}', "");
    Expect(0, 1279, '\P{Block=	CYRILLIC}', "");
    Expect(1, 1279, '\P{^Block=	CYRILLIC}', "");
    Expect(0, 1280, '\p{Block=	CYRILLIC}', "");
    Expect(1, 1280, '\p{^Block=	CYRILLIC}', "");
    Expect(1, 1280, '\P{Block=	CYRILLIC}', "");
    Expect(0, 1280, '\P{^Block=	CYRILLIC}', "");
    Error('\p{Blk=/a/-_cyrillic}');
    Error('\P{Blk=/a/-_cyrillic}');
    Expect(1, 1279, '\p{Blk=:\ACyrillic\z:}', "");;
    Expect(0, 1280, '\p{Blk=:\ACyrillic\z:}', "");;
    Expect(1, 1279, '\p{Blk=cyrillic}', "");
    Expect(0, 1279, '\p{^Blk=cyrillic}', "");
    Expect(0, 1279, '\P{Blk=cyrillic}', "");
    Expect(1, 1279, '\P{^Blk=cyrillic}', "");
    Expect(0, 1280, '\p{Blk=cyrillic}', "");
    Expect(1, 1280, '\p{^Blk=cyrillic}', "");
    Expect(1, 1280, '\P{Blk=cyrillic}', "");
    Expect(0, 1280, '\P{^Blk=cyrillic}', "");
    Expect(1, 1279, '\p{Blk=:\Acyrillic\z:}', "");;
    Expect(0, 1280, '\p{Blk=:\Acyrillic\z:}', "");;
    Expect(1, 1279, '\p{Blk=_ Cyrillic}', "");
    Expect(0, 1279, '\p{^Blk=_ Cyrillic}', "");
    Expect(0, 1279, '\P{Blk=_ Cyrillic}', "");
    Expect(1, 1279, '\P{^Blk=_ Cyrillic}', "");
    Expect(0, 1280, '\p{Blk=_ Cyrillic}', "");
    Expect(1, 1280, '\p{^Blk=_ Cyrillic}', "");
    Expect(1, 1280, '\P{Blk=_ Cyrillic}', "");
    Expect(0, 1280, '\P{^Blk=_ Cyrillic}', "");
    Error('\p{Is_Block:/a/	CYRILLIC}');
    Error('\P{Is_Block:/a/	CYRILLIC}');
    Expect(1, 1279, '\p{Is_Block=cyrillic}', "");
    Expect(0, 1279, '\p{^Is_Block=cyrillic}', "");
    Expect(0, 1279, '\P{Is_Block=cyrillic}', "");
    Expect(1, 1279, '\P{^Is_Block=cyrillic}', "");
    Expect(0, 1280, '\p{Is_Block=cyrillic}', "");
    Expect(1, 1280, '\p{^Is_Block=cyrillic}', "");
    Expect(1, 1280, '\P{Is_Block=cyrillic}', "");
    Expect(0, 1280, '\P{^Is_Block=cyrillic}', "");
    Expect(1, 1279, '\p{Is_Block= -Cyrillic}', "");
    Expect(0, 1279, '\p{^Is_Block= -Cyrillic}', "");
    Expect(0, 1279, '\P{Is_Block= -Cyrillic}', "");
    Expect(1, 1279, '\P{^Is_Block= -Cyrillic}', "");
    Expect(0, 1280, '\p{Is_Block= -Cyrillic}', "");
    Expect(1, 1280, '\p{^Is_Block= -Cyrillic}', "");
    Expect(1, 1280, '\P{Is_Block= -Cyrillic}', "");
    Expect(0, 1280, '\P{^Is_Block= -Cyrillic}', "");
    Error('\p{Is_Blk=_:=CYRILLIC}');
    Error('\P{Is_Blk=_:=CYRILLIC}');
    Expect(1, 1279, '\p{Is_Blk:	cyrillic}', "");
    Expect(0, 1279, '\p{^Is_Blk:	cyrillic}', "");
    Expect(0, 1279, '\P{Is_Blk:	cyrillic}', "");
    Expect(1, 1279, '\P{^Is_Blk:	cyrillic}', "");
    Expect(0, 1280, '\p{Is_Blk:	cyrillic}', "");
    Expect(1, 1280, '\p{^Is_Blk:	cyrillic}', "");
    Expect(1, 1280, '\P{Is_Blk:	cyrillic}', "");
    Expect(0, 1280, '\P{^Is_Blk:	cyrillic}', "");
    Expect(1, 1279, '\p{Is_Blk=-	cyrillic}', "");
    Expect(0, 1279, '\p{^Is_Blk=-	cyrillic}', "");
    Expect(0, 1279, '\P{Is_Blk=-	cyrillic}', "");
    Expect(1, 1279, '\P{^Is_Blk=-	cyrillic}', "");
    Expect(0, 1280, '\p{Is_Blk=-	cyrillic}', "");
    Expect(1, 1280, '\p{^Is_Blk=-	cyrillic}', "");
    Expect(1, 1280, '\P{Is_Blk=-	cyrillic}', "");
    Expect(0, 1280, '\P{^Is_Blk=-	cyrillic}', "");
    Error('\p{Block=_Cyrillic_Extended_A/a/}');
    Error('\P{Block=_Cyrillic_Extended_A/a/}');
    Expect(1, 11775, '\p{Block=:\ACyrillic_Extended_A\z:}', "");;
    Expect(0, 11776, '\p{Block=:\ACyrillic_Extended_A\z:}', "");;
    Expect(1, 11775, '\p{Block=cyrillicextendeda}', "");
    Expect(0, 11775, '\p{^Block=cyrillicextendeda}', "");
    Expect(0, 11775, '\P{Block=cyrillicextendeda}', "");
    Expect(1, 11775, '\P{^Block=cyrillicextendeda}', "");
    Expect(0, 11776, '\p{Block=cyrillicextendeda}', "");
    Expect(1, 11776, '\p{^Block=cyrillicextendeda}', "");
    Expect(1, 11776, '\P{Block=cyrillicextendeda}', "");
    Expect(0, 11776, '\P{^Block=cyrillicextendeda}', "");
    Expect(1, 11775, '\p{Block=:\Acyrillicextendeda\z:}', "");;
    Expect(0, 11776, '\p{Block=:\Acyrillicextendeda\z:}', "");;
    Expect(1, 11775, '\p{Block=-Cyrillic_Extended_A}', "");
    Expect(0, 11775, '\p{^Block=-Cyrillic_Extended_A}', "");
    Expect(0, 11775, '\P{Block=-Cyrillic_Extended_A}', "");
    Expect(1, 11775, '\P{^Block=-Cyrillic_Extended_A}', "");
    Expect(0, 11776, '\p{Block=-Cyrillic_Extended_A}', "");
    Expect(1, 11776, '\p{^Block=-Cyrillic_Extended_A}', "");
    Expect(1, 11776, '\P{Block=-Cyrillic_Extended_A}', "");
    Expect(0, 11776, '\P{^Block=-Cyrillic_Extended_A}', "");
    Error('\p{Blk:   _/a/CYRILLIC_ext_A}');
    Error('\P{Blk:   _/a/CYRILLIC_ext_A}');
    Expect(1, 11775, '\p{Blk=:\ACyrillic_Ext_A\z:}', "");;
    Expect(0, 11776, '\p{Blk=:\ACyrillic_Ext_A\z:}', "");;
    Expect(1, 11775, '\p{Blk=cyrillicexta}', "");
    Expect(0, 11775, '\p{^Blk=cyrillicexta}', "");
    Expect(0, 11775, '\P{Blk=cyrillicexta}', "");
    Expect(1, 11775, '\P{^Blk=cyrillicexta}', "");
    Expect(0, 11776, '\p{Blk=cyrillicexta}', "");
    Expect(1, 11776, '\p{^Blk=cyrillicexta}', "");
    Expect(1, 11776, '\P{Blk=cyrillicexta}', "");
    Expect(0, 11776, '\P{^Blk=cyrillicexta}', "");
    Expect(1, 11775, '\p{Blk=:\Acyrillicexta\z:}', "");;
    Expect(0, 11776, '\p{Blk=:\Acyrillicexta\z:}', "");;
    Expect(1, 11775, '\p{Blk=_CYRILLIC_ext_A}', "");
    Expect(0, 11775, '\p{^Blk=_CYRILLIC_ext_A}', "");
    Expect(0, 11775, '\P{Blk=_CYRILLIC_ext_A}', "");
    Expect(1, 11775, '\P{^Blk=_CYRILLIC_ext_A}', "");
    Expect(0, 11776, '\p{Blk=_CYRILLIC_ext_A}', "");
    Expect(1, 11776, '\p{^Blk=_CYRILLIC_ext_A}', "");
    Expect(1, 11776, '\P{Blk=_CYRILLIC_ext_A}', "");
    Expect(0, 11776, '\P{^Blk=_CYRILLIC_ext_A}', "");
    Error('\p{Is_Block= cyrillic_Extended_A:=}');
    Error('\P{Is_Block= cyrillic_Extended_A:=}');
    Expect(1, 11775, '\p{Is_Block=cyrillicextendeda}', "");
    Expect(0, 11775, '\p{^Is_Block=cyrillicextendeda}', "");
    Expect(0, 11775, '\P{Is_Block=cyrillicextendeda}', "");
    Expect(1, 11775, '\P{^Is_Block=cyrillicextendeda}', "");
    Expect(0, 11776, '\p{Is_Block=cyrillicextendeda}', "");
    Expect(1, 11776, '\p{^Is_Block=cyrillicextendeda}', "");
    Expect(1, 11776, '\P{Is_Block=cyrillicextendeda}', "");
    Expect(0, 11776, '\P{^Is_Block=cyrillicextendeda}', "");
    Expect(1, 11775, '\p{Is_Block=  Cyrillic_Extended_A}', "");
    Expect(0, 11775, '\p{^Is_Block=  Cyrillic_Extended_A}', "");
    Expect(0, 11775, '\P{Is_Block=  Cyrillic_Extended_A}', "");
    Expect(1, 11775, '\P{^Is_Block=  Cyrillic_Extended_A}', "");
    Expect(0, 11776, '\p{Is_Block=  Cyrillic_Extended_A}', "");
    Expect(1, 11776, '\p{^Is_Block=  Cyrillic_Extended_A}', "");
    Expect(1, 11776, '\P{Is_Block=  Cyrillic_Extended_A}', "");
    Expect(0, 11776, '\P{^Is_Block=  Cyrillic_Extended_A}', "");
    Error('\p{Is_Blk=/a/		cyrillic_Ext_A}');
    Error('\P{Is_Blk=/a/		cyrillic_Ext_A}');
    Expect(1, 11775, '\p{Is_Blk=cyrillicexta}', "");
    Expect(0, 11775, '\p{^Is_Blk=cyrillicexta}', "");
    Expect(0, 11775, '\P{Is_Blk=cyrillicexta}', "");
    Expect(1, 11775, '\P{^Is_Blk=cyrillicexta}', "");
    Expect(0, 11776, '\p{Is_Blk=cyrillicexta}', "");
    Expect(1, 11776, '\p{^Is_Blk=cyrillicexta}', "");
    Expect(1, 11776, '\P{Is_Blk=cyrillicexta}', "");
    Expect(0, 11776, '\P{^Is_Blk=cyrillicexta}', "");
    Expect(1, 11775, '\p{Is_Blk=	 CYRILLIC_ext_A}', "");
    Expect(0, 11775, '\p{^Is_Blk=	 CYRILLIC_ext_A}', "");
    Expect(0, 11775, '\P{Is_Blk=	 CYRILLIC_ext_A}', "");
    Expect(1, 11775, '\P{^Is_Blk=	 CYRILLIC_ext_A}', "");
    Expect(0, 11776, '\p{Is_Blk=	 CYRILLIC_ext_A}', "");
    Expect(1, 11776, '\p{^Is_Blk=	 CYRILLIC_ext_A}', "");
    Expect(1, 11776, '\P{Is_Blk=	 CYRILLIC_ext_A}', "");
    Expect(0, 11776, '\P{^Is_Blk=	 CYRILLIC_ext_A}', "");
    Error('\p{Block=_:=cyrillic_extended_B}');
    Error('\P{Block=_:=cyrillic_extended_B}');
    Expect(1, 42655, '\p{Block=:\ACyrillic_Extended_B\z:}', "");;
    Expect(0, 42656, '\p{Block=:\ACyrillic_Extended_B\z:}', "");;
    Expect(1, 42655, '\p{Block:cyrillicextendedb}', "");
    Expect(0, 42655, '\p{^Block:cyrillicextendedb}', "");
    Expect(0, 42655, '\P{Block:cyrillicextendedb}', "");
    Expect(1, 42655, '\P{^Block:cyrillicextendedb}', "");
    Expect(0, 42656, '\p{Block:cyrillicextendedb}', "");
    Expect(1, 42656, '\p{^Block:cyrillicextendedb}', "");
    Expect(1, 42656, '\P{Block:cyrillicextendedb}', "");
    Expect(0, 42656, '\P{^Block:cyrillicextendedb}', "");
    Expect(1, 42655, '\p{Block=:\Acyrillicextendedb\z:}', "");;
    Expect(0, 42656, '\p{Block=:\Acyrillicextendedb\z:}', "");;
    Expect(1, 42655, '\p{Block=	 CYRILLIC_EXTENDED_B}', "");
    Expect(0, 42655, '\p{^Block=	 CYRILLIC_EXTENDED_B}', "");
    Expect(0, 42655, '\P{Block=	 CYRILLIC_EXTENDED_B}', "");
    Expect(1, 42655, '\P{^Block=	 CYRILLIC_EXTENDED_B}', "");
    Expect(0, 42656, '\p{Block=	 CYRILLIC_EXTENDED_B}', "");
    Expect(1, 42656, '\p{^Block=	 CYRILLIC_EXTENDED_B}', "");
    Expect(1, 42656, '\P{Block=	 CYRILLIC_EXTENDED_B}', "");
    Expect(0, 42656, '\P{^Block=	 CYRILLIC_EXTENDED_B}', "");
    Error('\p{Blk=/a/ 	CYRILLIC_EXT_B}');
    Error('\P{Blk=/a/ 	CYRILLIC_EXT_B}');
    Expect(1, 42655, '\p{Blk=:\ACyrillic_Ext_B\z:}', "");;
    Expect(0, 42656, '\p{Blk=:\ACyrillic_Ext_B\z:}', "");;
    Expect(1, 42655, '\p{Blk=cyrillicextb}', "");
    Expect(0, 42655, '\p{^Blk=cyrillicextb}', "");
    Expect(0, 42655, '\P{Blk=cyrillicextb}', "");
    Expect(1, 42655, '\P{^Blk=cyrillicextb}', "");
    Expect(0, 42656, '\p{Blk=cyrillicextb}', "");
    Expect(1, 42656, '\p{^Blk=cyrillicextb}', "");
    Expect(1, 42656, '\P{Blk=cyrillicextb}', "");
    Expect(0, 42656, '\P{^Blk=cyrillicextb}', "");
    Expect(1, 42655, '\p{Blk=:\Acyrillicextb\z:}', "");;
    Expect(0, 42656, '\p{Blk=:\Acyrillicextb\z:}', "");;
    Expect(1, 42655, '\p{Blk= -Cyrillic_EXT_B}', "");
    Expect(0, 42655, '\p{^Blk= -Cyrillic_EXT_B}', "");
    Expect(0, 42655, '\P{Blk= -Cyrillic_EXT_B}', "");
    Expect(1, 42655, '\P{^Blk= -Cyrillic_EXT_B}', "");
    Expect(0, 42656, '\p{Blk= -Cyrillic_EXT_B}', "");
    Expect(1, 42656, '\p{^Blk= -Cyrillic_EXT_B}', "");
    Expect(1, 42656, '\P{Blk= -Cyrillic_EXT_B}', "");
    Expect(0, 42656, '\P{^Blk= -Cyrillic_EXT_B}', "");
    Error('\p{Is_Block=_:=Cyrillic_Extended_b}');
    Error('\P{Is_Block=_:=Cyrillic_Extended_b}');
    Expect(1, 42655, '\p{Is_Block=cyrillicextendedb}', "");
    Expect(0, 42655, '\p{^Is_Block=cyrillicextendedb}', "");
    Expect(0, 42655, '\P{Is_Block=cyrillicextendedb}', "");
    Expect(1, 42655, '\P{^Is_Block=cyrillicextendedb}', "");
    Expect(0, 42656, '\p{Is_Block=cyrillicextendedb}', "");
    Expect(1, 42656, '\p{^Is_Block=cyrillicextendedb}', "");
    Expect(1, 42656, '\P{Is_Block=cyrillicextendedb}', "");
    Expect(0, 42656, '\P{^Is_Block=cyrillicextendedb}', "");
    Expect(1, 42655, '\p{Is_Block=-Cyrillic_Extended_B}', "");
    Expect(0, 42655, '\p{^Is_Block=-Cyrillic_Extended_B}', "");
    Expect(0, 42655, '\P{Is_Block=-Cyrillic_Extended_B}', "");
    Expect(1, 42655, '\P{^Is_Block=-Cyrillic_Extended_B}', "");
    Expect(0, 42656, '\p{Is_Block=-Cyrillic_Extended_B}', "");
    Expect(1, 42656, '\p{^Is_Block=-Cyrillic_Extended_B}', "");
    Expect(1, 42656, '\P{Is_Block=-Cyrillic_Extended_B}', "");
    Expect(0, 42656, '\P{^Is_Block=-Cyrillic_Extended_B}', "");
    Error('\p{Is_Blk=-:=Cyrillic_EXT_b}');
    Error('\P{Is_Blk=-:=Cyrillic_EXT_b}');
    Expect(1, 42655, '\p{Is_Blk=cyrillicextb}', "");
    Expect(0, 42655, '\p{^Is_Blk=cyrillicextb}', "");
    Expect(0, 42655, '\P{Is_Blk=cyrillicextb}', "");
    Expect(1, 42655, '\P{^Is_Blk=cyrillicextb}', "");
    Expect(0, 42656, '\p{Is_Blk=cyrillicextb}', "");
    Expect(1, 42656, '\p{^Is_Blk=cyrillicextb}', "");
    Expect(1, 42656, '\P{Is_Blk=cyrillicextb}', "");
    Expect(0, 42656, '\P{^Is_Blk=cyrillicextb}', "");
    Expect(1, 42655, '\p{Is_Blk=	-CYRILLIC_EXT_B}', "");
    Expect(0, 42655, '\p{^Is_Blk=	-CYRILLIC_EXT_B}', "");
    Expect(0, 42655, '\P{Is_Blk=	-CYRILLIC_EXT_B}', "");
    Expect(1, 42655, '\P{^Is_Blk=	-CYRILLIC_EXT_B}', "");
    Expect(0, 42656, '\p{Is_Blk=	-CYRILLIC_EXT_B}', "");
    Expect(1, 42656, '\p{^Is_Blk=	-CYRILLIC_EXT_B}', "");
    Expect(1, 42656, '\P{Is_Blk=	-CYRILLIC_EXT_B}', "");
    Expect(0, 42656, '\P{^Is_Blk=	-CYRILLIC_EXT_B}', "");
    Error('\p{Block= -cyrillic_Extended_c/a/}');
    Error('\P{Block= -cyrillic_Extended_c/a/}');
    Expect(1, 7311, '\p{Block=:\ACyrillic_Extended_C\z:}', "");;
    Expect(0, 7312, '\p{Block=:\ACyrillic_Extended_C\z:}', "");;
    Expect(1, 7311, '\p{Block=cyrillicextendedc}', "");
    Expect(0, 7311, '\p{^Block=cyrillicextendedc}', "");
    Expect(0, 7311, '\P{Block=cyrillicextendedc}', "");
    Expect(1, 7311, '\P{^Block=cyrillicextendedc}', "");
    Expect(0, 7312, '\p{Block=cyrillicextendedc}', "");
    Expect(1, 7312, '\p{^Block=cyrillicextendedc}', "");
    Expect(1, 7312, '\P{Block=cyrillicextendedc}', "");
    Expect(0, 7312, '\P{^Block=cyrillicextendedc}', "");
    Expect(1, 7311, '\p{Block=:\Acyrillicextendedc\z:}', "");;
    Expect(0, 7312, '\p{Block=:\Acyrillicextendedc\z:}', "");;
    Expect(1, 7311, '\p{Block=__Cyrillic_Extended_C}', "");
    Expect(0, 7311, '\p{^Block=__Cyrillic_Extended_C}', "");
    Expect(0, 7311, '\P{Block=__Cyrillic_Extended_C}', "");
    Expect(1, 7311, '\P{^Block=__Cyrillic_Extended_C}', "");
    Expect(0, 7312, '\p{Block=__Cyrillic_Extended_C}', "");
    Expect(1, 7312, '\p{^Block=__Cyrillic_Extended_C}', "");
    Expect(1, 7312, '\P{Block=__Cyrillic_Extended_C}', "");
    Expect(0, 7312, '\P{^Block=__Cyrillic_Extended_C}', "");
    Error('\p{Blk= 	Cyrillic_EXT_c/a/}');
    Error('\P{Blk= 	Cyrillic_EXT_c/a/}');
    Expect(1, 7311, '\p{Blk=:\ACyrillic_Ext_C\z:}', "");;
    Expect(0, 7312, '\p{Blk=:\ACyrillic_Ext_C\z:}', "");;
    Expect(1, 7311, '\p{Blk=cyrillicextc}', "");
    Expect(0, 7311, '\p{^Blk=cyrillicextc}', "");
    Expect(0, 7311, '\P{Blk=cyrillicextc}', "");
    Expect(1, 7311, '\P{^Blk=cyrillicextc}', "");
    Expect(0, 7312, '\p{Blk=cyrillicextc}', "");
    Expect(1, 7312, '\p{^Blk=cyrillicextc}', "");
    Expect(1, 7312, '\P{Blk=cyrillicextc}', "");
    Expect(0, 7312, '\P{^Blk=cyrillicextc}', "");
    Expect(1, 7311, '\p{Blk=:\Acyrillicextc\z:}', "");;
    Expect(0, 7312, '\p{Blk=:\Acyrillicextc\z:}', "");;
    Expect(1, 7311, '\p{Blk=	-Cyrillic_Ext_C}', "");
    Expect(0, 7311, '\p{^Blk=	-Cyrillic_Ext_C}', "");
    Expect(0, 7311, '\P{Blk=	-Cyrillic_Ext_C}', "");
    Expect(1, 7311, '\P{^Blk=	-Cyrillic_Ext_C}', "");
    Expect(0, 7312, '\p{Blk=	-Cyrillic_Ext_C}', "");
    Expect(1, 7312, '\p{^Blk=	-Cyrillic_Ext_C}', "");
    Expect(1, 7312, '\P{Blk=	-Cyrillic_Ext_C}', "");
    Expect(0, 7312, '\P{^Blk=	-Cyrillic_Ext_C}', "");
    Error('\p{Is_Block=/a/__CYRILLIC_extended_C}');
    Error('\P{Is_Block=/a/__CYRILLIC_extended_C}');
    Expect(1, 7311, '\p{Is_Block=cyrillicextendedc}', "");
    Expect(0, 7311, '\p{^Is_Block=cyrillicextendedc}', "");
    Expect(0, 7311, '\P{Is_Block=cyrillicextendedc}', "");
    Expect(1, 7311, '\P{^Is_Block=cyrillicextendedc}', "");
    Expect(0, 7312, '\p{Is_Block=cyrillicextendedc}', "");
    Expect(1, 7312, '\p{^Is_Block=cyrillicextendedc}', "");
    Expect(1, 7312, '\P{Is_Block=cyrillicextendedc}', "");
    Expect(0, 7312, '\P{^Is_Block=cyrillicextendedc}', "");
    Expect(1, 7311, '\p{Is_Block=-cyrillic_Extended_C}', "");
    Expect(0, 7311, '\p{^Is_Block=-cyrillic_Extended_C}', "");
    Expect(0, 7311, '\P{Is_Block=-cyrillic_Extended_C}', "");
    Expect(1, 7311, '\P{^Is_Block=-cyrillic_Extended_C}', "");
    Expect(0, 7312, '\p{Is_Block=-cyrillic_Extended_C}', "");
    Expect(1, 7312, '\p{^Is_Block=-cyrillic_Extended_C}', "");
    Expect(1, 7312, '\P{Is_Block=-cyrillic_Extended_C}', "");
    Expect(0, 7312, '\P{^Is_Block=-cyrillic_Extended_C}', "");
    Error('\p{Is_Blk= -cyrillic_ext_C/a/}');
    Error('\P{Is_Blk= -cyrillic_ext_C/a/}');
    Expect(1, 7311, '\p{Is_Blk=cyrillicextc}', "");
    Expect(0, 7311, '\p{^Is_Blk=cyrillicextc}', "");
    Expect(0, 7311, '\P{Is_Blk=cyrillicextc}', "");
    Expect(1, 7311, '\P{^Is_Blk=cyrillicextc}', "");
    Expect(0, 7312, '\p{Is_Blk=cyrillicextc}', "");
    Expect(1, 7312, '\p{^Is_Blk=cyrillicextc}', "");
    Expect(1, 7312, '\P{Is_Blk=cyrillicextc}', "");
    Expect(0, 7312, '\P{^Is_Blk=cyrillicextc}', "");
    Expect(1, 7311, '\p{Is_Blk=_-CYRILLIC_Ext_C}', "");
    Expect(0, 7311, '\p{^Is_Blk=_-CYRILLIC_Ext_C}', "");
    Expect(0, 7311, '\P{Is_Blk=_-CYRILLIC_Ext_C}', "");
    Expect(1, 7311, '\P{^Is_Blk=_-CYRILLIC_Ext_C}', "");
    Expect(0, 7312, '\p{Is_Blk=_-CYRILLIC_Ext_C}', "");
    Expect(1, 7312, '\p{^Is_Blk=_-CYRILLIC_Ext_C}', "");
    Expect(1, 7312, '\P{Is_Blk=_-CYRILLIC_Ext_C}', "");
    Expect(0, 7312, '\P{^Is_Blk=_-CYRILLIC_Ext_C}', "");
    Error('\p{Block=:=CYRILLIC_extended_D}');
    Error('\P{Block=:=CYRILLIC_extended_D}');
    Expect(1, 123023, '\p{Block=:\ACyrillic_Extended_D\z:}', "");;
    Expect(0, 123024, '\p{Block=:\ACyrillic_Extended_D\z:}', "");;
    Expect(1, 123023, '\p{Block=cyrillicextendedd}', "");
    Expect(0, 123023, '\p{^Block=cyrillicextendedd}', "");
    Expect(0, 123023, '\P{Block=cyrillicextendedd}', "");
    Expect(1, 123023, '\P{^Block=cyrillicextendedd}', "");
    Expect(0, 123024, '\p{Block=cyrillicextendedd}', "");
    Expect(1, 123024, '\p{^Block=cyrillicextendedd}', "");
    Expect(1, 123024, '\P{Block=cyrillicextendedd}', "");
    Expect(0, 123024, '\P{^Block=cyrillicextendedd}', "");
    Expect(1, 123023, '\p{Block=:\Acyrillicextendedd\z:}', "");;
    Expect(0, 123024, '\p{Block=:\Acyrillicextendedd\z:}', "");;
    Expect(1, 123023, '\p{Block=-Cyrillic_Extended_D}', "");
    Expect(0, 123023, '\p{^Block=-Cyrillic_Extended_D}', "");
    Expect(0, 123023, '\P{Block=-Cyrillic_Extended_D}', "");
    Expect(1, 123023, '\P{^Block=-Cyrillic_Extended_D}', "");
    Expect(0, 123024, '\p{Block=-Cyrillic_Extended_D}', "");
    Expect(1, 123024, '\p{^Block=-Cyrillic_Extended_D}', "");
    Expect(1, 123024, '\P{Block=-Cyrillic_Extended_D}', "");
    Expect(0, 123024, '\P{^Block=-Cyrillic_Extended_D}', "");
    Error('\p{Blk=:=CYRILLIC_ext_D}');
    Error('\P{Blk=:=CYRILLIC_ext_D}');
    Expect(1, 123023, '\p{Blk=:\ACyrillic_Ext_D\z:}', "");;
    Expect(0, 123024, '\p{Blk=:\ACyrillic_Ext_D\z:}', "");;
    Expect(1, 123023, '\p{Blk=cyrillicextd}', "");
    Expect(0, 123023, '\p{^Blk=cyrillicextd}', "");
    Expect(0, 123023, '\P{Blk=cyrillicextd}', "");
    Expect(1, 123023, '\P{^Blk=cyrillicextd}', "");
    Expect(0, 123024, '\p{Blk=cyrillicextd}', "");
    Expect(1, 123024, '\p{^Blk=cyrillicextd}', "");
    Expect(1, 123024, '\P{Blk=cyrillicextd}', "");
    Expect(0, 123024, '\P{^Blk=cyrillicextd}', "");
    Expect(1, 123023, '\p{Blk=:\Acyrillicextd\z:}', "");;
    Expect(0, 123024, '\p{Blk=:\Acyrillicextd\z:}', "");;
    Expect(1, 123023, '\p{Blk=  CYRILLIC_EXT_D}', "");
    Expect(0, 123023, '\p{^Blk=  CYRILLIC_EXT_D}', "");
    Expect(0, 123023, '\P{Blk=  CYRILLIC_EXT_D}', "");
    Expect(1, 123023, '\P{^Blk=  CYRILLIC_EXT_D}', "");
    Expect(0, 123024, '\p{Blk=  CYRILLIC_EXT_D}', "");
    Expect(1, 123024, '\p{^Blk=  CYRILLIC_EXT_D}', "");
    Expect(1, 123024, '\P{Blk=  CYRILLIC_EXT_D}', "");
    Expect(0, 123024, '\P{^Blk=  CYRILLIC_EXT_D}', "");
    Error('\p{Is_Block=_/a/Cyrillic_Extended_D}');
    Error('\P{Is_Block=_/a/Cyrillic_Extended_D}');
    Expect(1, 123023, '\p{Is_Block=cyrillicextendedd}', "");
    Expect(0, 123023, '\p{^Is_Block=cyrillicextendedd}', "");
    Expect(0, 123023, '\P{Is_Block=cyrillicextendedd}', "");
    Expect(1, 123023, '\P{^Is_Block=cyrillicextendedd}', "");
    Expect(0, 123024, '\p{Is_Block=cyrillicextendedd}', "");
    Expect(1, 123024, '\p{^Is_Block=cyrillicextendedd}', "");
    Expect(1, 123024, '\P{Is_Block=cyrillicextendedd}', "");
    Expect(0, 123024, '\P{^Is_Block=cyrillicextendedd}', "");
    Expect(1, 123023, '\p{Is_Block= cyrillic_EXTENDED_D}', "");
    Expect(0, 123023, '\p{^Is_Block= cyrillic_EXTENDED_D}', "");
    Expect(0, 123023, '\P{Is_Block= cyrillic_EXTENDED_D}', "");
    Expect(1, 123023, '\P{^Is_Block= cyrillic_EXTENDED_D}', "");
    Expect(0, 123024, '\p{Is_Block= cyrillic_EXTENDED_D}', "");
    Expect(1, 123024, '\p{^Is_Block= cyrillic_EXTENDED_D}', "");
    Expect(1, 123024, '\P{Is_Block= cyrillic_EXTENDED_D}', "");
    Expect(0, 123024, '\P{^Is_Block= cyrillic_EXTENDED_D}', "");
    Error('\p{Is_Blk= :=CYRILLIC_Ext_d}');
    Error('\P{Is_Blk= :=CYRILLIC_Ext_d}');
    Expect(1, 123023, '\p{Is_Blk=cyrillicextd}', "");
    Expect(0, 123023, '\p{^Is_Blk=cyrillicextd}', "");
    Expect(0, 123023, '\P{Is_Blk=cyrillicextd}', "");
    Expect(1, 123023, '\P{^Is_Blk=cyrillicextd}', "");
    Expect(0, 123024, '\p{Is_Blk=cyrillicextd}', "");
    Expect(1, 123024, '\p{^Is_Blk=cyrillicextd}', "");
    Expect(1, 123024, '\P{Is_Blk=cyrillicextd}', "");
    Expect(0, 123024, '\P{^Is_Blk=cyrillicextd}', "");
    Expect(1, 123023, '\p{Is_Blk=	cyrillic_EXT_D}', "");
    Expect(0, 123023, '\p{^Is_Blk=	cyrillic_EXT_D}', "");
    Expect(0, 123023, '\P{Is_Blk=	cyrillic_EXT_D}', "");
    Expect(1, 123023, '\P{^Is_Blk=	cyrillic_EXT_D}', "");
    Expect(0, 123024, '\p{Is_Blk=	cyrillic_EXT_D}', "");
    Expect(1, 123024, '\p{^Is_Blk=	cyrillic_EXT_D}', "");
    Expect(1, 123024, '\P{Is_Blk=	cyrillic_EXT_D}', "");
    Expect(0, 123024, '\P{^Is_Blk=	cyrillic_EXT_D}', "");
    Error('\p{Block=_ cyrillic_Supplement:=}');
    Error('\P{Block=_ cyrillic_Supplement:=}');
    Expect(1, 1327, '\p{Block=:\ACyrillic_Supplement\z:}', "");;
    Expect(0, 1328, '\p{Block=:\ACyrillic_Supplement\z:}', "");;
    Expect(1, 1327, '\p{Block=cyrillicsupplement}', "");
    Expect(0, 1327, '\p{^Block=cyrillicsupplement}', "");
    Expect(0, 1327, '\P{Block=cyrillicsupplement}', "");
    Expect(1, 1327, '\P{^Block=cyrillicsupplement}', "");
    Expect(0, 1328, '\p{Block=cyrillicsupplement}', "");
    Expect(1, 1328, '\p{^Block=cyrillicsupplement}', "");
    Expect(1, 1328, '\P{Block=cyrillicsupplement}', "");
    Expect(0, 1328, '\P{^Block=cyrillicsupplement}', "");
    Expect(1, 1327, '\p{Block=:\Acyrillicsupplement\z:}', "");;
    Expect(0, 1328, '\p{Block=:\Acyrillicsupplement\z:}', "");;
    Expect(1, 1327, '\p{Block:    Cyrillic_Supplement}', "");
    Expect(0, 1327, '\p{^Block:    Cyrillic_Supplement}', "");
    Expect(0, 1327, '\P{Block:    Cyrillic_Supplement}', "");
    Expect(1, 1327, '\P{^Block:    Cyrillic_Supplement}', "");
    Expect(0, 1328, '\p{Block:    Cyrillic_Supplement}', "");
    Expect(1, 1328, '\p{^Block:    Cyrillic_Supplement}', "");
    Expect(1, 1328, '\P{Block:    Cyrillic_Supplement}', "");
    Expect(0, 1328, '\P{^Block:    Cyrillic_Supplement}', "");
    Error('\p{Blk: /a/cyrillic_sup}');
    Error('\P{Blk: /a/cyrillic_sup}');
    Expect(1, 1327, '\p{Blk=:\ACyrillic_Sup\z:}', "");;
    Expect(0, 1328, '\p{Blk=:\ACyrillic_Sup\z:}', "");;
    Expect(1, 1327, '\p{Blk:   cyrillicsup}', "");
    Expect(0, 1327, '\p{^Blk:   cyrillicsup}', "");
    Expect(0, 1327, '\P{Blk:   cyrillicsup}', "");
    Expect(1, 1327, '\P{^Blk:   cyrillicsup}', "");
    Expect(0, 1328, '\p{Blk:   cyrillicsup}', "");
    Expect(1, 1328, '\p{^Blk:   cyrillicsup}', "");
    Expect(1, 1328, '\P{Blk:   cyrillicsup}', "");
    Expect(0, 1328, '\P{^Blk:   cyrillicsup}', "");
    Expect(1, 1327, '\p{Blk=:\Acyrillicsup\z:}', "");;
    Expect(0, 1328, '\p{Blk=:\Acyrillicsup\z:}', "");;
    Expect(1, 1327, '\p{Blk:-cyrillic_sup}', "");
    Expect(0, 1327, '\p{^Blk:-cyrillic_sup}', "");
    Expect(0, 1327, '\P{Blk:-cyrillic_sup}', "");
    Expect(1, 1327, '\P{^Blk:-cyrillic_sup}', "");
    Expect(0, 1328, '\p{Blk:-cyrillic_sup}', "");
    Expect(1, 1328, '\p{^Blk:-cyrillic_sup}', "");
    Expect(1, 1328, '\P{Blk:-cyrillic_sup}', "");
    Expect(0, 1328, '\P{^Blk:-cyrillic_sup}', "");
    Error('\p{Is_Block=_/a/Cyrillic_Supplementary}');
    Error('\P{Is_Block=_/a/Cyrillic_Supplementary}');
    Expect(1, 1327, '\p{Is_Block=cyrillicsupplementary}', "");
    Expect(0, 1327, '\p{^Is_Block=cyrillicsupplementary}', "");
    Expect(0, 1327, '\P{Is_Block=cyrillicsupplementary}', "");
    Expect(1, 1327, '\P{^Is_Block=cyrillicsupplementary}', "");
    Expect(0, 1328, '\p{Is_Block=cyrillicsupplementary}', "");
    Expect(1, 1328, '\p{^Is_Block=cyrillicsupplementary}', "");
    Expect(1, 1328, '\P{Is_Block=cyrillicsupplementary}', "");
    Expect(0, 1328, '\P{^Is_Block=cyrillicsupplementary}', "");
    Expect(1, 1327, '\p{Is_Block=		Cyrillic_Supplementary}', "");
    Expect(0, 1327, '\p{^Is_Block=		Cyrillic_Supplementary}', "");
    Expect(0, 1327, '\P{Is_Block=		Cyrillic_Supplementary}', "");
    Expect(1, 1327, '\P{^Is_Block=		Cyrillic_Supplementary}', "");
    Expect(0, 1328, '\p{Is_Block=		Cyrillic_Supplementary}', "");
    Expect(1, 1328, '\p{^Is_Block=		Cyrillic_Supplementary}', "");
    Expect(1, 1328, '\P{Is_Block=		Cyrillic_Supplementary}', "");
    Expect(0, 1328, '\P{^Is_Block=		Cyrillic_Supplementary}', "");
    Error('\p{Is_Blk=:= Cyrillic_supplement}');
    Error('\P{Is_Blk=:= Cyrillic_supplement}');
    Expect(1, 1327, '\p{Is_Blk=cyrillicsupplement}', "");
    Expect(0, 1327, '\p{^Is_Blk=cyrillicsupplement}', "");
    Expect(0, 1327, '\P{Is_Blk=cyrillicsupplement}', "");
    Expect(1, 1327, '\P{^Is_Blk=cyrillicsupplement}', "");
    Expect(0, 1328, '\p{Is_Blk=cyrillicsupplement}', "");
    Expect(1, 1328, '\p{^Is_Blk=cyrillicsupplement}', "");
    Expect(1, 1328, '\P{Is_Blk=cyrillicsupplement}', "");
    Expect(0, 1328, '\P{^Is_Blk=cyrillicsupplement}', "");
    Expect(1, 1327, '\p{Is_Blk=	-Cyrillic_Supplement}', "");
    Expect(0, 1327, '\p{^Is_Blk=	-Cyrillic_Supplement}', "");
    Expect(0, 1327, '\P{Is_Blk=	-Cyrillic_Supplement}', "");
    Expect(1, 1327, '\P{^Is_Blk=	-Cyrillic_Supplement}', "");
    Expect(0, 1328, '\p{Is_Blk=	-Cyrillic_Supplement}', "");
    Expect(1, 1328, '\p{^Is_Blk=	-Cyrillic_Supplement}', "");
    Expect(1, 1328, '\P{Is_Blk=	-Cyrillic_Supplement}', "");
    Expect(0, 1328, '\P{^Is_Blk=	-Cyrillic_Supplement}', "");
    Error('\p{Block= /a/Deseret}');
    Error('\P{Block= /a/Deseret}');
    Expect(1, 66639, '\p{Block=:\ADeseret\z:}', "");;
    Expect(0, 66640, '\p{Block=:\ADeseret\z:}', "");;
    Expect(1, 66639, '\p{Block=deseret}', "");
    Expect(0, 66639, '\p{^Block=deseret}', "");
    Expect(0, 66639, '\P{Block=deseret}', "");
    Expect(1, 66639, '\P{^Block=deseret}', "");
    Expect(0, 66640, '\p{Block=deseret}', "");
    Expect(1, 66640, '\p{^Block=deseret}', "");
    Expect(1, 66640, '\P{Block=deseret}', "");
    Expect(0, 66640, '\P{^Block=deseret}', "");
    Expect(1, 66639, '\p{Block=:\Adeseret\z:}', "");;
    Expect(0, 66640, '\p{Block=:\Adeseret\z:}', "");;
    Expect(1, 66639, '\p{Block=  Deseret}', "");
    Expect(0, 66639, '\p{^Block=  Deseret}', "");
    Expect(0, 66639, '\P{Block=  Deseret}', "");
    Expect(1, 66639, '\P{^Block=  Deseret}', "");
    Expect(0, 66640, '\p{Block=  Deseret}', "");
    Expect(1, 66640, '\p{^Block=  Deseret}', "");
    Expect(1, 66640, '\P{Block=  Deseret}', "");
    Expect(0, 66640, '\P{^Block=  Deseret}', "");
    Error('\p{Blk=/a/Deseret}');
    Error('\P{Blk=/a/Deseret}');
    Expect(1, 66639, '\p{Blk=:\ADeseret\z:}', "");;
    Expect(0, 66640, '\p{Blk=:\ADeseret\z:}', "");;
    Expect(1, 66639, '\p{Blk=deseret}', "");
    Expect(0, 66639, '\p{^Blk=deseret}', "");
    Expect(0, 66639, '\P{Blk=deseret}', "");
    Expect(1, 66639, '\P{^Blk=deseret}', "");
    Expect(0, 66640, '\p{Blk=deseret}', "");
    Expect(1, 66640, '\p{^Blk=deseret}', "");
    Expect(1, 66640, '\P{Blk=deseret}', "");
    Expect(0, 66640, '\P{^Blk=deseret}', "");
    Expect(1, 66639, '\p{Blk=:\Adeseret\z:}', "");;
    Expect(0, 66640, '\p{Blk=:\Adeseret\z:}', "");;
    Expect(1, 66639, '\p{Blk=_Deseret}', "");
    Expect(0, 66639, '\p{^Blk=_Deseret}', "");
    Expect(0, 66639, '\P{Blk=_Deseret}', "");
    Expect(1, 66639, '\P{^Blk=_Deseret}', "");
    Expect(0, 66640, '\p{Blk=_Deseret}', "");
    Expect(1, 66640, '\p{^Blk=_Deseret}', "");
    Expect(1, 66640, '\P{Blk=_Deseret}', "");
    Expect(0, 66640, '\P{^Blk=_Deseret}', "");
    Error('\p{Is_Block=/a/-deseret}');
    Error('\P{Is_Block=/a/-deseret}');
    Expect(1, 66639, '\p{Is_Block=deseret}', "");
    Expect(0, 66639, '\p{^Is_Block=deseret}', "");
    Expect(0, 66639, '\P{Is_Block=deseret}', "");
    Expect(1, 66639, '\P{^Is_Block=deseret}', "");
    Expect(0, 66640, '\p{Is_Block=deseret}', "");
    Expect(1, 66640, '\p{^Is_Block=deseret}', "");
    Expect(1, 66640, '\P{Is_Block=deseret}', "");
    Expect(0, 66640, '\P{^Is_Block=deseret}', "");
    Expect(1, 66639, '\p{Is_Block=	 Deseret}', "");
    Expect(0, 66639, '\p{^Is_Block=	 Deseret}', "");
    Expect(0, 66639, '\P{Is_Block=	 Deseret}', "");
    Expect(1, 66639, '\P{^Is_Block=	 Deseret}', "");
    Expect(0, 66640, '\p{Is_Block=	 Deseret}', "");
    Expect(1, 66640, '\p{^Is_Block=	 Deseret}', "");
    Expect(1, 66640, '\P{Is_Block=	 Deseret}', "");
    Expect(0, 66640, '\P{^Is_Block=	 Deseret}', "");
    Error('\p{Is_Blk=-Deseret:=}');
    Error('\P{Is_Blk=-Deseret:=}');
    Expect(1, 66639, '\p{Is_Blk=deseret}', "");
    Expect(0, 66639, '\p{^Is_Blk=deseret}', "");
    Expect(0, 66639, '\P{Is_Blk=deseret}', "");
    Expect(1, 66639, '\P{^Is_Blk=deseret}', "");
    Expect(0, 66640, '\p{Is_Blk=deseret}', "");
    Expect(1, 66640, '\p{^Is_Blk=deseret}', "");
    Expect(1, 66640, '\P{Is_Blk=deseret}', "");
    Expect(0, 66640, '\P{^Is_Blk=deseret}', "");
    Expect(1, 66639, '\p{Is_Blk=	Deseret}', "");
    Expect(0, 66639, '\p{^Is_Blk=	Deseret}', "");
    Expect(0, 66639, '\P{Is_Blk=	Deseret}', "");
    Expect(1, 66639, '\P{^Is_Blk=	Deseret}', "");
    Expect(0, 66640, '\p{Is_Blk=	Deseret}', "");
    Expect(1, 66640, '\p{^Is_Blk=	Deseret}', "");
    Expect(1, 66640, '\P{Is_Blk=	Deseret}', "");
    Expect(0, 66640, '\P{^Is_Blk=	Deseret}', "");
    Error('\p{Block=:=_-Devanagari}');
    Error('\P{Block=:=_-Devanagari}');
    Expect(1, 2431, '\p{Block=:\ADevanagari\z:}', "");;
    Expect(0, 2432, '\p{Block=:\ADevanagari\z:}', "");;
    Expect(1, 2431, '\p{Block: devanagari}', "");
    Expect(0, 2431, '\p{^Block: devanagari}', "");
    Expect(0, 2431, '\P{Block: devanagari}', "");
    Expect(1, 2431, '\P{^Block: devanagari}', "");
    Expect(0, 2432, '\p{Block: devanagari}', "");
    Expect(1, 2432, '\p{^Block: devanagari}', "");
    Expect(1, 2432, '\P{Block: devanagari}', "");
    Expect(0, 2432, '\P{^Block: devanagari}', "");
    Expect(1, 2431, '\p{Block=:\Adevanagari\z:}', "");;
    Expect(0, 2432, '\p{Block=:\Adevanagari\z:}', "");;
    Expect(1, 2431, '\p{Block=  Devanagari}', "");
    Expect(0, 2431, '\p{^Block=  Devanagari}', "");
    Expect(0, 2431, '\P{Block=  Devanagari}', "");
    Expect(1, 2431, '\P{^Block=  Devanagari}', "");
    Expect(0, 2432, '\p{Block=  Devanagari}', "");
    Expect(1, 2432, '\p{^Block=  Devanagari}', "");
    Expect(1, 2432, '\P{Block=  Devanagari}', "");
    Expect(0, 2432, '\P{^Block=  Devanagari}', "");
    Error('\p{Blk=	/a/DEVANAGARI}');
    Error('\P{Blk=	/a/DEVANAGARI}');
    Expect(1, 2431, '\p{Blk=:\ADevanagari\z:}', "");;
    Expect(0, 2432, '\p{Blk=:\ADevanagari\z:}', "");;
    Expect(1, 2431, '\p{Blk: devanagari}', "");
    Expect(0, 2431, '\p{^Blk: devanagari}', "");
    Expect(0, 2431, '\P{Blk: devanagari}', "");
    Expect(1, 2431, '\P{^Blk: devanagari}', "");
    Expect(0, 2432, '\p{Blk: devanagari}', "");
    Expect(1, 2432, '\p{^Blk: devanagari}', "");
    Expect(1, 2432, '\P{Blk: devanagari}', "");
    Expect(0, 2432, '\P{^Blk: devanagari}', "");
    Expect(1, 2431, '\p{Blk=:\Adevanagari\z:}', "");;
    Expect(0, 2432, '\p{Blk=:\Adevanagari\z:}', "");;
    Expect(1, 2431, '\p{Blk=-devanagari}', "");
    Expect(0, 2431, '\p{^Blk=-devanagari}', "");
    Expect(0, 2431, '\P{Blk=-devanagari}', "");
    Expect(1, 2431, '\P{^Blk=-devanagari}', "");
    Expect(0, 2432, '\p{Blk=-devanagari}', "");
    Expect(1, 2432, '\p{^Blk=-devanagari}', "");
    Expect(1, 2432, '\P{Blk=-devanagari}', "");
    Expect(0, 2432, '\P{^Blk=-devanagari}', "");
    Error('\p{Is_Block=:=_devanagari}');
    Error('\P{Is_Block=:=_devanagari}');
    Expect(1, 2431, '\p{Is_Block=devanagari}', "");
    Expect(0, 2431, '\p{^Is_Block=devanagari}', "");
    Expect(0, 2431, '\P{Is_Block=devanagari}', "");
    Expect(1, 2431, '\P{^Is_Block=devanagari}', "");
    Expect(0, 2432, '\p{Is_Block=devanagari}', "");
    Expect(1, 2432, '\p{^Is_Block=devanagari}', "");
    Expect(1, 2432, '\P{Is_Block=devanagari}', "");
    Expect(0, 2432, '\P{^Is_Block=devanagari}', "");
    Expect(1, 2431, '\p{Is_Block=	 Devanagari}', "");
    Expect(0, 2431, '\p{^Is_Block=	 Devanagari}', "");
    Expect(0, 2431, '\P{Is_Block=	 Devanagari}', "");
    Expect(1, 2431, '\P{^Is_Block=	 Devanagari}', "");
    Expect(0, 2432, '\p{Is_Block=	 Devanagari}', "");
    Expect(1, 2432, '\p{^Is_Block=	 Devanagari}', "");
    Expect(1, 2432, '\P{Is_Block=	 Devanagari}', "");
    Expect(0, 2432, '\P{^Is_Block=	 Devanagari}', "");
    Error('\p{Is_Blk=_-Devanagari:=}');
    Error('\P{Is_Blk=_-Devanagari:=}');
    Expect(1, 2431, '\p{Is_Blk=devanagari}', "");
    Expect(0, 2431, '\p{^Is_Blk=devanagari}', "");
    Expect(0, 2431, '\P{Is_Blk=devanagari}', "");
    Expect(1, 2431, '\P{^Is_Blk=devanagari}', "");
    Expect(0, 2432, '\p{Is_Blk=devanagari}', "");
    Expect(1, 2432, '\p{^Is_Blk=devanagari}', "");
    Expect(1, 2432, '\P{Is_Blk=devanagari}', "");
    Expect(0, 2432, '\P{^Is_Blk=devanagari}', "");
    Expect(1, 2431, '\p{Is_Blk=	 Devanagari}', "");
    Expect(0, 2431, '\p{^Is_Blk=	 Devanagari}', "");
    Expect(0, 2431, '\P{Is_Blk=	 Devanagari}', "");
    Expect(1, 2431, '\P{^Is_Blk=	 Devanagari}', "");
    Expect(0, 2432, '\p{Is_Blk=	 Devanagari}', "");
    Expect(1, 2432, '\p{^Is_Blk=	 Devanagari}', "");
    Expect(1, 2432, '\P{Is_Blk=	 Devanagari}', "");
    Expect(0, 2432, '\P{^Is_Blk=	 Devanagari}', "");
    Error('\p{Block= 	DEVANAGARI_extended:=}');
    Error('\P{Block= 	DEVANAGARI_extended:=}');
    Expect(1, 43263, '\p{Block=:\ADevanagari_Extended\z:}', "");;
    Expect(0, 43264, '\p{Block=:\ADevanagari_Extended\z:}', "");;
    Expect(1, 43263, '\p{Block=devanagariextended}', "");
    Expect(0, 43263, '\p{^Block=devanagariextended}', "");
    Expect(0, 43263, '\P{Block=devanagariextended}', "");
    Expect(1, 43263, '\P{^Block=devanagariextended}', "");
    Expect(0, 43264, '\p{Block=devanagariextended}', "");
    Expect(1, 43264, '\p{^Block=devanagariextended}', "");
    Expect(1, 43264, '\P{Block=devanagariextended}', "");
    Expect(0, 43264, '\P{^Block=devanagariextended}', "");
    Expect(1, 43263, '\p{Block=:\Adevanagariextended\z:}', "");;
    Expect(0, 43264, '\p{Block=:\Adevanagariextended\z:}', "");;
    Expect(1, 43263, '\p{Block=DEVANAGARI_Extended}', "");
    Expect(0, 43263, '\p{^Block=DEVANAGARI_Extended}', "");
    Expect(0, 43263, '\P{Block=DEVANAGARI_Extended}', "");
    Expect(1, 43263, '\P{^Block=DEVANAGARI_Extended}', "");
    Expect(0, 43264, '\p{Block=DEVANAGARI_Extended}', "");
    Expect(1, 43264, '\p{^Block=DEVANAGARI_Extended}', "");
    Expect(1, 43264, '\P{Block=DEVANAGARI_Extended}', "");
    Expect(0, 43264, '\P{^Block=DEVANAGARI_Extended}', "");
    Error('\p{Blk=:= _Devanagari_Ext}');
    Error('\P{Blk=:= _Devanagari_Ext}');
    Expect(1, 43263, '\p{Blk=:\ADevanagari_Ext\z:}', "");;
    Expect(0, 43264, '\p{Blk=:\ADevanagari_Ext\z:}', "");;
    Expect(1, 43263, '\p{Blk=devanagariext}', "");
    Expect(0, 43263, '\p{^Blk=devanagariext}', "");
    Expect(0, 43263, '\P{Blk=devanagariext}', "");
    Expect(1, 43263, '\P{^Blk=devanagariext}', "");
    Expect(0, 43264, '\p{Blk=devanagariext}', "");
    Expect(1, 43264, '\p{^Blk=devanagariext}', "");
    Expect(1, 43264, '\P{Blk=devanagariext}', "");
    Expect(0, 43264, '\P{^Blk=devanagariext}', "");
    Expect(1, 43263, '\p{Blk=:\Adevanagariext\z:}', "");;
    Expect(0, 43264, '\p{Blk=:\Adevanagariext\z:}', "");;
    Expect(1, 43263, '\p{Blk=--devanagari_Ext}', "");
    Expect(0, 43263, '\p{^Blk=--devanagari_Ext}', "");
    Expect(0, 43263, '\P{Blk=--devanagari_Ext}', "");
    Expect(1, 43263, '\P{^Blk=--devanagari_Ext}', "");
    Expect(0, 43264, '\p{Blk=--devanagari_Ext}', "");
    Expect(1, 43264, '\p{^Blk=--devanagari_Ext}', "");
    Expect(1, 43264, '\P{Blk=--devanagari_Ext}', "");
    Expect(0, 43264, '\P{^Blk=--devanagari_Ext}', "");
    Error('\p{Is_Block=/a/ -Devanagari_Extended}');
    Error('\P{Is_Block=/a/ -Devanagari_Extended}');
    Expect(1, 43263, '\p{Is_Block=devanagariextended}', "");
    Expect(0, 43263, '\p{^Is_Block=devanagariextended}', "");
    Expect(0, 43263, '\P{Is_Block=devanagariextended}', "");
    Expect(1, 43263, '\P{^Is_Block=devanagariextended}', "");
    Expect(0, 43264, '\p{Is_Block=devanagariextended}', "");
    Expect(1, 43264, '\p{^Is_Block=devanagariextended}', "");
    Expect(1, 43264, '\P{Is_Block=devanagariextended}', "");
    Expect(0, 43264, '\P{^Is_Block=devanagariextended}', "");
    Expect(1, 43263, '\p{Is_Block=Devanagari_EXTENDED}', "");
    Expect(0, 43263, '\p{^Is_Block=Devanagari_EXTENDED}', "");
    Expect(0, 43263, '\P{Is_Block=Devanagari_EXTENDED}', "");
    Expect(1, 43263, '\P{^Is_Block=Devanagari_EXTENDED}', "");
    Expect(0, 43264, '\p{Is_Block=Devanagari_EXTENDED}', "");
    Expect(1, 43264, '\p{^Is_Block=Devanagari_EXTENDED}', "");
    Expect(1, 43264, '\P{Is_Block=Devanagari_EXTENDED}', "");
    Expect(0, 43264, '\P{^Is_Block=Devanagari_EXTENDED}', "");
    Error('\p{Is_Blk=-DEVANAGARI_Ext/a/}');
    Error('\P{Is_Blk=-DEVANAGARI_Ext/a/}');
    Expect(1, 43263, '\p{Is_Blk=devanagariext}', "");
    Expect(0, 43263, '\p{^Is_Blk=devanagariext}', "");
    Expect(0, 43263, '\P{Is_Blk=devanagariext}', "");
    Expect(1, 43263, '\P{^Is_Blk=devanagariext}', "");
    Expect(0, 43264, '\p{Is_Blk=devanagariext}', "");
    Expect(1, 43264, '\p{^Is_Blk=devanagariext}', "");
    Expect(1, 43264, '\P{Is_Blk=devanagariext}', "");
    Expect(0, 43264, '\P{^Is_Blk=devanagariext}', "");
    Expect(1, 43263, '\p{Is_Blk= _Devanagari_Ext}', "");
    Expect(0, 43263, '\p{^Is_Blk= _Devanagari_Ext}', "");
    Expect(0, 43263, '\P{Is_Blk= _Devanagari_Ext}', "");
    Expect(1, 43263, '\P{^Is_Blk= _Devanagari_Ext}', "");
    Expect(0, 43264, '\p{Is_Blk= _Devanagari_Ext}', "");
    Expect(1, 43264, '\p{^Is_Blk= _Devanagari_Ext}', "");
    Expect(1, 43264, '\P{Is_Blk= _Devanagari_Ext}', "");
    Expect(0, 43264, '\P{^Is_Blk= _Devanagari_Ext}', "");
    Error('\p{Block=Devanagari_extended_A/a/}');
    Error('\P{Block=Devanagari_extended_A/a/}');
    Expect(1, 72543, '\p{Block=:\ADevanagari_Extended_A\z:}', "");;
    Expect(0, 72544, '\p{Block=:\ADevanagari_Extended_A\z:}', "");;
    Expect(1, 72543, '\p{Block: devanagariextendeda}', "");
    Expect(0, 72543, '\p{^Block: devanagariextendeda}', "");
    Expect(0, 72543, '\P{Block: devanagariextendeda}', "");
    Expect(1, 72543, '\P{^Block: devanagariextendeda}', "");
    Expect(0, 72544, '\p{Block: devanagariextendeda}', "");
    Expect(1, 72544, '\p{^Block: devanagariextendeda}', "");
    Expect(1, 72544, '\P{Block: devanagariextendeda}', "");
    Expect(0, 72544, '\P{^Block: devanagariextendeda}', "");
    Expect(1, 72543, '\p{Block=:\Adevanagariextendeda\z:}', "");;
    Expect(0, 72544, '\p{Block=:\Adevanagariextendeda\z:}', "");;
    Expect(1, 72543, '\p{Block=	_DEVANAGARI_Extended_A}', "");
    Expect(0, 72543, '\p{^Block=	_DEVANAGARI_Extended_A}', "");
    Expect(0, 72543, '\P{Block=	_DEVANAGARI_Extended_A}', "");
    Expect(1, 72543, '\P{^Block=	_DEVANAGARI_Extended_A}', "");
    Expect(0, 72544, '\p{Block=	_DEVANAGARI_Extended_A}', "");
    Expect(1, 72544, '\p{^Block=	_DEVANAGARI_Extended_A}', "");
    Expect(1, 72544, '\P{Block=	_DEVANAGARI_Extended_A}', "");
    Expect(0, 72544, '\P{^Block=	_DEVANAGARI_Extended_A}', "");
    Error('\p{Blk=	 DEVANAGARI_Ext_A/a/}');
    Error('\P{Blk=	 DEVANAGARI_Ext_A/a/}');
    Expect(1, 72543, '\p{Blk=:\ADevanagari_Ext_A\z:}', "");;
    Expect(0, 72544, '\p{Blk=:\ADevanagari_Ext_A\z:}', "");;
    Expect(1, 72543, '\p{Blk=devanagariexta}', "");
    Expect(0, 72543, '\p{^Blk=devanagariexta}', "");
    Expect(0, 72543, '\P{Blk=devanagariexta}', "");
    Expect(1, 72543, '\P{^Blk=devanagariexta}', "");
    Expect(0, 72544, '\p{Blk=devanagariexta}', "");
    Expect(1, 72544, '\p{^Blk=devanagariexta}', "");
    Expect(1, 72544, '\P{Blk=devanagariexta}', "");
    Expect(0, 72544, '\P{^Blk=devanagariexta}', "");
    Expect(1, 72543, '\p{Blk=:\Adevanagariexta\z:}', "");;
    Expect(0, 72544, '\p{Blk=:\Adevanagariexta\z:}', "");;
    Expect(1, 72543, '\p{Blk=	DEVANAGARI_ext_A}', "");
    Expect(0, 72543, '\p{^Blk=	DEVANAGARI_ext_A}', "");
    Expect(0, 72543, '\P{Blk=	DEVANAGARI_ext_A}', "");
    Expect(1, 72543, '\P{^Blk=	DEVANAGARI_ext_A}', "");
    Expect(0, 72544, '\p{Blk=	DEVANAGARI_ext_A}', "");
    Expect(1, 72544, '\p{^Blk=	DEVANAGARI_ext_A}', "");
    Expect(1, 72544, '\P{Blk=	DEVANAGARI_ext_A}', "");
    Expect(0, 72544, '\P{^Blk=	DEVANAGARI_ext_A}', "");
    Error('\p{Is_Block=	/a/DEVANAGARI_Extended_a}');
    Error('\P{Is_Block=	/a/DEVANAGARI_Extended_a}');
    Expect(1, 72543, '\p{Is_Block:   devanagariextendeda}', "");
    Expect(0, 72543, '\p{^Is_Block:   devanagariextendeda}', "");
    Expect(0, 72543, '\P{Is_Block:   devanagariextendeda}', "");
    Expect(1, 72543, '\P{^Is_Block:   devanagariextendeda}', "");
    Expect(0, 72544, '\p{Is_Block:   devanagariextendeda}', "");
    Expect(1, 72544, '\p{^Is_Block:   devanagariextendeda}', "");
    Expect(1, 72544, '\P{Is_Block:   devanagariextendeda}', "");
    Expect(0, 72544, '\P{^Is_Block:   devanagariextendeda}', "");
    Expect(1, 72543, '\p{Is_Block=-	Devanagari_Extended_A}', "");
    Expect(0, 72543, '\p{^Is_Block=-	Devanagari_Extended_A}', "");
    Expect(0, 72543, '\P{Is_Block=-	Devanagari_Extended_A}', "");
    Expect(1, 72543, '\P{^Is_Block=-	Devanagari_Extended_A}', "");
    Expect(0, 72544, '\p{Is_Block=-	Devanagari_Extended_A}', "");
    Expect(1, 72544, '\p{^Is_Block=-	Devanagari_Extended_A}', "");
    Expect(1, 72544, '\P{Is_Block=-	Devanagari_Extended_A}', "");
    Expect(0, 72544, '\P{^Is_Block=-	Devanagari_Extended_A}', "");
    Error('\p{Is_Blk=_devanagari_EXT_A:=}');
    Error('\P{Is_Blk=_devanagari_EXT_A:=}');
    Expect(1, 72543, '\p{Is_Blk=devanagariexta}', "");
    Expect(0, 72543, '\p{^Is_Blk=devanagariexta}', "");
    Expect(0, 72543, '\P{Is_Blk=devanagariexta}', "");
    Expect(1, 72543, '\P{^Is_Blk=devanagariexta}', "");
    Expect(0, 72544, '\p{Is_Blk=devanagariexta}', "");
    Expect(1, 72544, '\p{^Is_Blk=devanagariexta}', "");
    Expect(1, 72544, '\P{Is_Blk=devanagariexta}', "");
    Expect(0, 72544, '\P{^Is_Blk=devanagariexta}', "");
    Expect(1, 72543, '\p{Is_Blk= 	Devanagari_EXT_A}', "");
    Expect(0, 72543, '\p{^Is_Blk= 	Devanagari_EXT_A}', "");
    Expect(0, 72543, '\P{Is_Blk= 	Devanagari_EXT_A}', "");
    Expect(1, 72543, '\P{^Is_Blk= 	Devanagari_EXT_A}', "");
    Expect(0, 72544, '\p{Is_Blk= 	Devanagari_EXT_A}', "");
    Expect(1, 72544, '\p{^Is_Blk= 	Devanagari_EXT_A}', "");
    Expect(1, 72544, '\P{Is_Blk= 	Devanagari_EXT_A}', "");
    Expect(0, 72544, '\P{^Is_Blk= 	Devanagari_EXT_A}', "");
    Error('\p{Block=_/a/Combining_diacritical_MARKS}');
    Error('\P{Block=_/a/Combining_diacritical_MARKS}');
    Expect(1, 879, '\p{Block=:\ACombining_Diacritical_Marks\z:}', "");;
    Expect(0, 880, '\p{Block=:\ACombining_Diacritical_Marks\z:}', "");;
    Expect(1, 879, '\p{Block=combiningdiacriticalmarks}', "");
    Expect(0, 879, '\p{^Block=combiningdiacriticalmarks}', "");
    Expect(0, 879, '\P{Block=combiningdiacriticalmarks}', "");
    Expect(1, 879, '\P{^Block=combiningdiacriticalmarks}', "");
    Expect(0, 880, '\p{Block=combiningdiacriticalmarks}', "");
    Expect(1, 880, '\p{^Block=combiningdiacriticalmarks}', "");
    Expect(1, 880, '\P{Block=combiningdiacriticalmarks}', "");
    Expect(0, 880, '\P{^Block=combiningdiacriticalmarks}', "");
    Expect(1, 879, '\p{Block=:\Acombiningdiacriticalmarks\z:}', "");;
    Expect(0, 880, '\p{Block=:\Acombiningdiacriticalmarks\z:}', "");;
    Expect(1, 879, '\p{Block=_Combining_Diacritical_marks}', "");
    Expect(0, 879, '\p{^Block=_Combining_Diacritical_marks}', "");
    Expect(0, 879, '\P{Block=_Combining_Diacritical_marks}', "");
    Expect(1, 879, '\P{^Block=_Combining_Diacritical_marks}', "");
    Expect(0, 880, '\p{Block=_Combining_Diacritical_marks}', "");
    Expect(1, 880, '\p{^Block=_Combining_Diacritical_marks}', "");
    Expect(1, 880, '\P{Block=_Combining_Diacritical_marks}', "");
    Expect(0, 880, '\P{^Block=_Combining_Diacritical_marks}', "");
    Error('\p{Blk:    :=diacriticals}');
    Error('\P{Blk:    :=diacriticals}');
    Expect(1, 879, '\p{Blk=:\ADiacriticals\z:}', "");;
    Expect(0, 880, '\p{Blk=:\ADiacriticals\z:}', "");;
    Expect(1, 879, '\p{Blk: diacriticals}', "");
    Expect(0, 879, '\p{^Blk: diacriticals}', "");
    Expect(0, 879, '\P{Blk: diacriticals}', "");
    Expect(1, 879, '\P{^Blk: diacriticals}', "");
    Expect(0, 880, '\p{Blk: diacriticals}', "");
    Expect(1, 880, '\p{^Blk: diacriticals}', "");
    Expect(1, 880, '\P{Blk: diacriticals}', "");
    Expect(0, 880, '\P{^Blk: diacriticals}', "");
    Expect(1, 879, '\p{Blk=:\Adiacriticals\z:}', "");;
    Expect(0, 880, '\p{Blk=:\Adiacriticals\z:}', "");;
    Expect(1, 879, '\p{Blk=	_DIACRITICALS}', "");
    Expect(0, 879, '\p{^Blk=	_DIACRITICALS}', "");
    Expect(0, 879, '\P{Blk=	_DIACRITICALS}', "");
    Expect(1, 879, '\P{^Blk=	_DIACRITICALS}', "");
    Expect(0, 880, '\p{Blk=	_DIACRITICALS}', "");
    Expect(1, 880, '\p{^Blk=	_DIACRITICALS}', "");
    Expect(1, 880, '\P{Blk=	_DIACRITICALS}', "");
    Expect(0, 880, '\P{^Blk=	_DIACRITICALS}', "");
    Error('\p{Is_Block=_/a/combining_Diacritical_marks}');
    Error('\P{Is_Block=_/a/combining_Diacritical_marks}');
    Expect(1, 879, '\p{Is_Block=combiningdiacriticalmarks}', "");
    Expect(0, 879, '\p{^Is_Block=combiningdiacriticalmarks}', "");
    Expect(0, 879, '\P{Is_Block=combiningdiacriticalmarks}', "");
    Expect(1, 879, '\P{^Is_Block=combiningdiacriticalmarks}', "");
    Expect(0, 880, '\p{Is_Block=combiningdiacriticalmarks}', "");
    Expect(1, 880, '\p{^Is_Block=combiningdiacriticalmarks}', "");
    Expect(1, 880, '\P{Is_Block=combiningdiacriticalmarks}', "");
    Expect(0, 880, '\P{^Is_Block=combiningdiacriticalmarks}', "");
    Expect(1, 879, '\p{Is_Block=_-Combining_Diacritical_Marks}', "");
    Expect(0, 879, '\p{^Is_Block=_-Combining_Diacritical_Marks}', "");
    Expect(0, 879, '\P{Is_Block=_-Combining_Diacritical_Marks}', "");
    Expect(1, 879, '\P{^Is_Block=_-Combining_Diacritical_Marks}', "");
    Expect(0, 880, '\p{Is_Block=_-Combining_Diacritical_Marks}', "");
    Expect(1, 880, '\p{^Is_Block=_-Combining_Diacritical_Marks}', "");
    Expect(1, 880, '\P{Is_Block=_-Combining_Diacritical_Marks}', "");
    Expect(0, 880, '\P{^Is_Block=_-Combining_Diacritical_Marks}', "");
    Error('\p{Is_Blk= Diacriticals:=}');
    Error('\P{Is_Blk= Diacriticals:=}');
    Expect(1, 879, '\p{Is_Blk=diacriticals}', "");
    Expect(0, 879, '\p{^Is_Blk=diacriticals}', "");
    Expect(0, 879, '\P{Is_Blk=diacriticals}', "");
    Expect(1, 879, '\P{^Is_Blk=diacriticals}', "");
    Expect(0, 880, '\p{Is_Blk=diacriticals}', "");
    Expect(1, 880, '\p{^Is_Blk=diacriticals}', "");
    Expect(1, 880, '\P{Is_Blk=diacriticals}', "");
    Expect(0, 880, '\P{^Is_Blk=diacriticals}', "");
    Expect(1, 879, '\p{Is_Blk= Diacriticals}', "");
    Expect(0, 879, '\p{^Is_Blk= Diacriticals}', "");
    Expect(0, 879, '\P{Is_Blk= Diacriticals}', "");
    Expect(1, 879, '\P{^Is_Blk= Diacriticals}', "");
    Expect(0, 880, '\p{Is_Blk= Diacriticals}', "");
    Expect(1, 880, '\p{^Is_Blk= Diacriticals}', "");
    Expect(1, 880, '\P{Is_Blk= Diacriticals}', "");
    Expect(0, 880, '\P{^Is_Blk= Diacriticals}', "");
    Error('\p{Block:  /a/combining_Diacritical_Marks_extended}');
    Error('\P{Block:  /a/combining_Diacritical_Marks_extended}');
    Expect(1, 6911, '\p{Block=:\ACombining_Diacritical_Marks_Extended\z:}', "");;
    Expect(0, 6912, '\p{Block=:\ACombining_Diacritical_Marks_Extended\z:}', "");;
    Expect(1, 6911, '\p{Block=combiningdiacriticalmarksextended}', "");
    Expect(0, 6911, '\p{^Block=combiningdiacriticalmarksextended}', "");
    Expect(0, 6911, '\P{Block=combiningdiacriticalmarksextended}', "");
    Expect(1, 6911, '\P{^Block=combiningdiacriticalmarksextended}', "");
    Expect(0, 6912, '\p{Block=combiningdiacriticalmarksextended}', "");
    Expect(1, 6912, '\p{^Block=combiningdiacriticalmarksextended}', "");
    Expect(1, 6912, '\P{Block=combiningdiacriticalmarksextended}', "");
    Expect(0, 6912, '\P{^Block=combiningdiacriticalmarksextended}', "");
    Expect(1, 6911, '\p{Block=:\Acombiningdiacriticalmarksextended\z:}', "");;
    Expect(0, 6912, '\p{Block=:\Acombiningdiacriticalmarksextended\z:}', "");;
    Expect(1, 6911, '\p{Block=-COMBINING_Diacritical_Marks_extended}', "");
    Expect(0, 6911, '\p{^Block=-COMBINING_Diacritical_Marks_extended}', "");
    Expect(0, 6911, '\P{Block=-COMBINING_Diacritical_Marks_extended}', "");
    Expect(1, 6911, '\P{^Block=-COMBINING_Diacritical_Marks_extended}', "");
    Expect(0, 6912, '\p{Block=-COMBINING_Diacritical_Marks_extended}', "");
    Expect(1, 6912, '\p{^Block=-COMBINING_Diacritical_Marks_extended}', "");
    Expect(1, 6912, '\P{Block=-COMBINING_Diacritical_Marks_extended}', "");
    Expect(0, 6912, '\P{^Block=-COMBINING_Diacritical_Marks_extended}', "");
    Error('\p{Blk=	/a/Diacriticals_EXT}');
    Error('\P{Blk=	/a/Diacriticals_EXT}');
    Expect(1, 6911, '\p{Blk=:\ADiacriticals_Ext\z:}', "");;
    Expect(0, 6912, '\p{Blk=:\ADiacriticals_Ext\z:}', "");;
    Expect(1, 6911, '\p{Blk=diacriticalsext}', "");
    Expect(0, 6911, '\p{^Blk=diacriticalsext}', "");
    Expect(0, 6911, '\P{Blk=diacriticalsext}', "");
    Expect(1, 6911, '\P{^Blk=diacriticalsext}', "");
    Expect(0, 6912, '\p{Blk=diacriticalsext}', "");
    Expect(1, 6912, '\p{^Blk=diacriticalsext}', "");
    Expect(1, 6912, '\P{Blk=diacriticalsext}', "");
    Expect(0, 6912, '\P{^Blk=diacriticalsext}', "");
    Expect(1, 6911, '\p{Blk=:\Adiacriticalsext\z:}', "");;
    Expect(0, 6912, '\p{Blk=:\Adiacriticalsext\z:}', "");;
    Expect(1, 6911, '\p{Blk=_-Diacriticals_EXT}', "");
    Expect(0, 6911, '\p{^Blk=_-Diacriticals_EXT}', "");
    Expect(0, 6911, '\P{Blk=_-Diacriticals_EXT}', "");
    Expect(1, 6911, '\P{^Blk=_-Diacriticals_EXT}', "");
    Expect(0, 6912, '\p{Blk=_-Diacriticals_EXT}', "");
    Expect(1, 6912, '\p{^Blk=_-Diacriticals_EXT}', "");
    Expect(1, 6912, '\P{Blk=_-Diacriticals_EXT}', "");
    Expect(0, 6912, '\P{^Blk=_-Diacriticals_EXT}', "");
    Error('\p{Is_Block=--combining_DIACRITICAL_marks_Extended/a/}');
    Error('\P{Is_Block=--combining_DIACRITICAL_marks_Extended/a/}');
    Expect(1, 6911, '\p{Is_Block=combiningdiacriticalmarksextended}', "");
    Expect(0, 6911, '\p{^Is_Block=combiningdiacriticalmarksextended}', "");
    Expect(0, 6911, '\P{Is_Block=combiningdiacriticalmarksextended}', "");
    Expect(1, 6911, '\P{^Is_Block=combiningdiacriticalmarksextended}', "");
    Expect(0, 6912, '\p{Is_Block=combiningdiacriticalmarksextended}', "");
    Expect(1, 6912, '\p{^Is_Block=combiningdiacriticalmarksextended}', "");
    Expect(1, 6912, '\P{Is_Block=combiningdiacriticalmarksextended}', "");
    Expect(0, 6912, '\P{^Is_Block=combiningdiacriticalmarksextended}', "");
    Expect(1, 6911, '\p{Is_Block=  COMBINING_diacritical_Marks_Extended}', "");
    Expect(0, 6911, '\p{^Is_Block=  COMBINING_diacritical_Marks_Extended}', "");
    Expect(0, 6911, '\P{Is_Block=  COMBINING_diacritical_Marks_Extended}', "");
    Expect(1, 6911, '\P{^Is_Block=  COMBINING_diacritical_Marks_Extended}', "");
    Expect(0, 6912, '\p{Is_Block=  COMBINING_diacritical_Marks_Extended}', "");
    Expect(1, 6912, '\p{^Is_Block=  COMBINING_diacritical_Marks_Extended}', "");
    Expect(1, 6912, '\P{Is_Block=  COMBINING_diacritical_Marks_Extended}', "");
    Expect(0, 6912, '\P{^Is_Block=  COMBINING_diacritical_Marks_Extended}', "");
    Error('\p{Is_Blk=-DIACRITICALS_ext/a/}');
    Error('\P{Is_Blk=-DIACRITICALS_ext/a/}');
    Expect(1, 6911, '\p{Is_Blk=diacriticalsext}', "");
    Expect(0, 6911, '\p{^Is_Blk=diacriticalsext}', "");
    Expect(0, 6911, '\P{Is_Blk=diacriticalsext}', "");
    Expect(1, 6911, '\P{^Is_Blk=diacriticalsext}', "");
    Expect(0, 6912, '\p{Is_Blk=diacriticalsext}', "");
    Expect(1, 6912, '\p{^Is_Blk=diacriticalsext}', "");
    Expect(1, 6912, '\P{Is_Blk=diacriticalsext}', "");
    Expect(0, 6912, '\P{^Is_Blk=diacriticalsext}', "");
    Expect(1, 6911, '\p{Is_Blk=-Diacriticals_ext}', "");
    Expect(0, 6911, '\p{^Is_Blk=-Diacriticals_ext}', "");
    Expect(0, 6911, '\P{Is_Blk=-Diacriticals_ext}', "");
    Expect(1, 6911, '\P{^Is_Blk=-Diacriticals_ext}', "");
    Expect(0, 6912, '\p{Is_Blk=-Diacriticals_ext}', "");
    Expect(1, 6912, '\p{^Is_Blk=-Diacriticals_ext}', "");
    Expect(1, 6912, '\P{Is_Blk=-Diacriticals_ext}', "");
    Expect(0, 6912, '\P{^Is_Blk=-Diacriticals_ext}', "");
    Error('\p{Block=		Combining_Diacritical_Marks_For_SYMBOLS:=}');
    Error('\P{Block=		Combining_Diacritical_Marks_For_SYMBOLS:=}');
    Expect(1, 8447, '\p{Block=:\ACombining_Diacritical_Marks_For_Symbols\z:}', "");;
    Expect(0, 8448, '\p{Block=:\ACombining_Diacritical_Marks_For_Symbols\z:}', "");;
    Expect(1, 8447, '\p{Block=combiningdiacriticalmarksforsymbols}', "");
    Expect(0, 8447, '\p{^Block=combiningdiacriticalmarksforsymbols}', "");
    Expect(0, 8447, '\P{Block=combiningdiacriticalmarksforsymbols}', "");
    Expect(1, 8447, '\P{^Block=combiningdiacriticalmarksforsymbols}', "");
    Expect(0, 8448, '\p{Block=combiningdiacriticalmarksforsymbols}', "");
    Expect(1, 8448, '\p{^Block=combiningdiacriticalmarksforsymbols}', "");
    Expect(1, 8448, '\P{Block=combiningdiacriticalmarksforsymbols}', "");
    Expect(0, 8448, '\P{^Block=combiningdiacriticalmarksforsymbols}', "");
    Expect(1, 8447, '\p{Block=:\Acombiningdiacriticalmarksforsymbols\z:}', "");;
    Expect(0, 8448, '\p{Block=:\Acombiningdiacriticalmarksforsymbols\z:}', "");;
    Expect(1, 8447, '\p{Block=_ combining_DIACRITICAL_marks_For_Symbols}', "");
    Expect(0, 8447, '\p{^Block=_ combining_DIACRITICAL_marks_For_Symbols}', "");
    Expect(0, 8447, '\P{Block=_ combining_DIACRITICAL_marks_For_Symbols}', "");
    Expect(1, 8447, '\P{^Block=_ combining_DIACRITICAL_marks_For_Symbols}', "");
    Expect(0, 8448, '\p{Block=_ combining_DIACRITICAL_marks_For_Symbols}', "");
    Expect(1, 8448, '\p{^Block=_ combining_DIACRITICAL_marks_For_Symbols}', "");
    Expect(1, 8448, '\P{Block=_ combining_DIACRITICAL_marks_For_Symbols}', "");
    Expect(0, 8448, '\P{^Block=_ combining_DIACRITICAL_marks_For_Symbols}', "");
    Error('\p{Blk=	Diacriticals_For_SYMBOLS:=}');
    Error('\P{Blk=	Diacriticals_For_SYMBOLS:=}');
    Expect(1, 8447, '\p{Blk=:\ADiacriticals_For_Symbols\z:}', "");;
    Expect(0, 8448, '\p{Blk=:\ADiacriticals_For_Symbols\z:}', "");;
    Expect(1, 8447, '\p{Blk=diacriticalsforsymbols}', "");
    Expect(0, 8447, '\p{^Blk=diacriticalsforsymbols}', "");
    Expect(0, 8447, '\P{Blk=diacriticalsforsymbols}', "");
    Expect(1, 8447, '\P{^Blk=diacriticalsforsymbols}', "");
    Expect(0, 8448, '\p{Blk=diacriticalsforsymbols}', "");
    Expect(1, 8448, '\p{^Blk=diacriticalsforsymbols}', "");
    Expect(1, 8448, '\P{Blk=diacriticalsforsymbols}', "");
    Expect(0, 8448, '\P{^Blk=diacriticalsforsymbols}', "");
    Expect(1, 8447, '\p{Blk=:\Adiacriticalsforsymbols\z:}', "");;
    Expect(0, 8448, '\p{Blk=:\Adiacriticalsforsymbols\z:}', "");;
    Expect(1, 8447, '\p{Blk=_	diacriticals_For_Symbols}', "");
    Expect(0, 8447, '\p{^Blk=_	diacriticals_For_Symbols}', "");
    Expect(0, 8447, '\P{Blk=_	diacriticals_For_Symbols}', "");
    Expect(1, 8447, '\P{^Blk=_	diacriticals_For_Symbols}', "");
    Expect(0, 8448, '\p{Blk=_	diacriticals_For_Symbols}', "");
    Expect(1, 8448, '\p{^Blk=_	diacriticals_For_Symbols}', "");
    Expect(1, 8448, '\P{Blk=_	diacriticals_For_Symbols}', "");
    Expect(0, 8448, '\P{^Blk=_	diacriticals_For_Symbols}', "");
    Error('\p{Is_Block=-Combining_Marks_for_Symbols:=}');
    Error('\P{Is_Block=-Combining_Marks_for_Symbols:=}');
    Expect(1, 8447, '\p{Is_Block: combiningmarksforsymbols}', "");
    Expect(0, 8447, '\p{^Is_Block: combiningmarksforsymbols}', "");
    Expect(0, 8447, '\P{Is_Block: combiningmarksforsymbols}', "");
    Expect(1, 8447, '\P{^Is_Block: combiningmarksforsymbols}', "");
    Expect(0, 8448, '\p{Is_Block: combiningmarksforsymbols}', "");
    Expect(1, 8448, '\p{^Is_Block: combiningmarksforsymbols}', "");
    Expect(1, 8448, '\P{Is_Block: combiningmarksforsymbols}', "");
    Expect(0, 8448, '\P{^Is_Block: combiningmarksforsymbols}', "");
    Expect(1, 8447, '\p{Is_Block=Combining_marks_FOR_Symbols}', "");
    Expect(0, 8447, '\p{^Is_Block=Combining_marks_FOR_Symbols}', "");
    Expect(0, 8447, '\P{Is_Block=Combining_marks_FOR_Symbols}', "");
    Expect(1, 8447, '\P{^Is_Block=Combining_marks_FOR_Symbols}', "");
    Expect(0, 8448, '\p{Is_Block=Combining_marks_FOR_Symbols}', "");
    Expect(1, 8448, '\p{^Is_Block=Combining_marks_FOR_Symbols}', "");
    Expect(1, 8448, '\P{Is_Block=Combining_marks_FOR_Symbols}', "");
    Expect(0, 8448, '\P{^Is_Block=Combining_marks_FOR_Symbols}', "");
    Error('\p{Is_Blk= :=combining_diacritical_MARKS_for_symbols}');
    Error('\P{Is_Blk= :=combining_diacritical_MARKS_for_symbols}');
    Expect(1, 8447, '\p{Is_Blk=combiningdiacriticalmarksforsymbols}', "");
    Expect(0, 8447, '\p{^Is_Blk=combiningdiacriticalmarksforsymbols}', "");
    Expect(0, 8447, '\P{Is_Blk=combiningdiacriticalmarksforsymbols}', "");
    Expect(1, 8447, '\P{^Is_Blk=combiningdiacriticalmarksforsymbols}', "");
    Expect(0, 8448, '\p{Is_Blk=combiningdiacriticalmarksforsymbols}', "");
    Expect(1, 8448, '\p{^Is_Blk=combiningdiacriticalmarksforsymbols}', "");
    Expect(1, 8448, '\P{Is_Blk=combiningdiacriticalmarksforsymbols}', "");
    Expect(0, 8448, '\P{^Is_Blk=combiningdiacriticalmarksforsymbols}', "");
    Expect(1, 8447, '\p{Is_Blk=-combining_Diacritical_Marks_For_symbols}', "");
    Expect(0, 8447, '\p{^Is_Blk=-combining_Diacritical_Marks_For_symbols}', "");
    Expect(0, 8447, '\P{Is_Blk=-combining_Diacritical_Marks_For_symbols}', "");
    Expect(1, 8447, '\P{^Is_Blk=-combining_Diacritical_Marks_For_symbols}', "");
    Expect(0, 8448, '\p{Is_Blk=-combining_Diacritical_Marks_For_symbols}', "");
    Expect(1, 8448, '\p{^Is_Blk=-combining_Diacritical_Marks_For_symbols}', "");
    Expect(1, 8448, '\P{Is_Blk=-combining_Diacritical_Marks_For_symbols}', "");
    Expect(0, 8448, '\P{^Is_Blk=-combining_Diacritical_Marks_For_symbols}', "");
    Error('\p{Block: 	/a/Combining_Diacritical_MARKS_supplement}');
    Error('\P{Block: 	/a/Combining_Diacritical_MARKS_supplement}');
    Expect(1, 7679, '\p{Block=:\ACombining_Diacritical_Marks_Supplement\z:}', "");;
    Expect(0, 7680, '\p{Block=:\ACombining_Diacritical_Marks_Supplement\z:}', "");;
    Expect(1, 7679, '\p{Block=combiningdiacriticalmarkssupplement}', "");
    Expect(0, 7679, '\p{^Block=combiningdiacriticalmarkssupplement}', "");
    Expect(0, 7679, '\P{Block=combiningdiacriticalmarkssupplement}', "");
    Expect(1, 7679, '\P{^Block=combiningdiacriticalmarkssupplement}', "");
    Expect(0, 7680, '\p{Block=combiningdiacriticalmarkssupplement}', "");
    Expect(1, 7680, '\p{^Block=combiningdiacriticalmarkssupplement}', "");
    Expect(1, 7680, '\P{Block=combiningdiacriticalmarkssupplement}', "");
    Expect(0, 7680, '\P{^Block=combiningdiacriticalmarkssupplement}', "");
    Expect(1, 7679, '\p{Block=:\Acombiningdiacriticalmarkssupplement\z:}', "");;
    Expect(0, 7680, '\p{Block=:\Acombiningdiacriticalmarkssupplement\z:}', "");;
    Expect(1, 7679, '\p{Block=--combining_Diacritical_MARKS_Supplement}', "");
    Expect(0, 7679, '\p{^Block=--combining_Diacritical_MARKS_Supplement}', "");
    Expect(0, 7679, '\P{Block=--combining_Diacritical_MARKS_Supplement}', "");
    Expect(1, 7679, '\P{^Block=--combining_Diacritical_MARKS_Supplement}', "");
    Expect(0, 7680, '\p{Block=--combining_Diacritical_MARKS_Supplement}', "");
    Expect(1, 7680, '\p{^Block=--combining_Diacritical_MARKS_Supplement}', "");
    Expect(1, 7680, '\P{Block=--combining_Diacritical_MARKS_Supplement}', "");
    Expect(0, 7680, '\P{^Block=--combining_Diacritical_MARKS_Supplement}', "");
    Error('\p{Blk=_:=Diacriticals_sup}');
    Error('\P{Blk=_:=Diacriticals_sup}');
    Expect(1, 7679, '\p{Blk=:\ADiacriticals_Sup\z:}', "");;
    Expect(0, 7680, '\p{Blk=:\ADiacriticals_Sup\z:}', "");;
    Expect(1, 7679, '\p{Blk=diacriticalssup}', "");
    Expect(0, 7679, '\p{^Blk=diacriticalssup}', "");
    Expect(0, 7679, '\P{Blk=diacriticalssup}', "");
    Expect(1, 7679, '\P{^Blk=diacriticalssup}', "");
    Expect(0, 7680, '\p{Blk=diacriticalssup}', "");
    Expect(1, 7680, '\p{^Blk=diacriticalssup}', "");
    Expect(1, 7680, '\P{Blk=diacriticalssup}', "");
    Expect(0, 7680, '\P{^Blk=diacriticalssup}', "");
    Expect(1, 7679, '\p{Blk=:\Adiacriticalssup\z:}', "");;
    Expect(0, 7680, '\p{Blk=:\Adiacriticalssup\z:}', "");;
    Expect(1, 7679, '\p{Blk: Diacriticals_sup}', "");
    Expect(0, 7679, '\p{^Blk: Diacriticals_sup}', "");
    Expect(0, 7679, '\P{Blk: Diacriticals_sup}', "");
    Expect(1, 7679, '\P{^Blk: Diacriticals_sup}', "");
    Expect(0, 7680, '\p{Blk: Diacriticals_sup}', "");
    Expect(1, 7680, '\p{^Blk: Diacriticals_sup}', "");
    Expect(1, 7680, '\P{Blk: Diacriticals_sup}', "");
    Expect(0, 7680, '\P{^Blk: Diacriticals_sup}', "");
    Error('\p{Is_Block=	combining_diacritical_Marks_Supplement/a/}');
    Error('\P{Is_Block=	combining_diacritical_Marks_Supplement/a/}');
    Expect(1, 7679, '\p{Is_Block=combiningdiacriticalmarkssupplement}', "");
    Expect(0, 7679, '\p{^Is_Block=combiningdiacriticalmarkssupplement}', "");
    Expect(0, 7679, '\P{Is_Block=combiningdiacriticalmarkssupplement}', "");
    Expect(1, 7679, '\P{^Is_Block=combiningdiacriticalmarkssupplement}', "");
    Expect(0, 7680, '\p{Is_Block=combiningdiacriticalmarkssupplement}', "");
    Expect(1, 7680, '\p{^Is_Block=combiningdiacriticalmarkssupplement}', "");
    Expect(1, 7680, '\P{Is_Block=combiningdiacriticalmarkssupplement}', "");
    Expect(0, 7680, '\P{^Is_Block=combiningdiacriticalmarkssupplement}', "");
    Expect(1, 7679, '\p{Is_Block=	_Combining_Diacritical_Marks_Supplement}', "");
    Expect(0, 7679, '\p{^Is_Block=	_Combining_Diacritical_Marks_Supplement}', "");
    Expect(0, 7679, '\P{Is_Block=	_Combining_Diacritical_Marks_Supplement}', "");
    Expect(1, 7679, '\P{^Is_Block=	_Combining_Diacritical_Marks_Supplement}', "");
    Expect(0, 7680, '\p{Is_Block=	_Combining_Diacritical_Marks_Supplement}', "");
    Expect(1, 7680, '\p{^Is_Block=	_Combining_Diacritical_Marks_Supplement}', "");
    Expect(1, 7680, '\P{Is_Block=	_Combining_Diacritical_Marks_Supplement}', "");
    Expect(0, 7680, '\P{^Is_Block=	_Combining_Diacritical_Marks_Supplement}', "");
    Error('\p{Is_Blk=/a/__DIACRITICALS_Sup}');
    Error('\P{Is_Blk=/a/__DIACRITICALS_Sup}');
    Expect(1, 7679, '\p{Is_Blk=diacriticalssup}', "");
    Expect(0, 7679, '\p{^Is_Blk=diacriticalssup}', "");
    Expect(0, 7679, '\P{Is_Blk=diacriticalssup}', "");
    Expect(1, 7679, '\P{^Is_Blk=diacriticalssup}', "");
    Expect(0, 7680, '\p{Is_Blk=diacriticalssup}', "");
    Expect(1, 7680, '\p{^Is_Blk=diacriticalssup}', "");
    Expect(1, 7680, '\P{Is_Blk=diacriticalssup}', "");
    Expect(0, 7680, '\P{^Is_Blk=diacriticalssup}', "");
    Expect(1, 7679, '\p{Is_Blk=-diacriticals_Sup}', "");
    Expect(0, 7679, '\p{^Is_Blk=-diacriticals_Sup}', "");
    Expect(0, 7679, '\P{Is_Blk=-diacriticals_Sup}', "");
    Expect(1, 7679, '\P{^Is_Blk=-diacriticals_Sup}', "");
    Expect(0, 7680, '\p{Is_Blk=-diacriticals_Sup}', "");
    Expect(1, 7680, '\p{^Is_Blk=-diacriticals_Sup}', "");
    Expect(1, 7680, '\P{Is_Blk=-diacriticals_Sup}', "");
    Expect(0, 7680, '\P{^Is_Blk=-diacriticals_Sup}', "");
    Error('\p{Block=:=	-DINGBATS}');
    Error('\P{Block=:=	-DINGBATS}');
    Expect(1, 10175, '\p{Block=:\ADingbats\z:}', "");;
    Expect(0, 10176, '\p{Block=:\ADingbats\z:}', "");;
    Expect(1, 10175, '\p{Block=dingbats}', "");
    Expect(0, 10175, '\p{^Block=dingbats}', "");
    Expect(0, 10175, '\P{Block=dingbats}', "");
    Expect(1, 10175, '\P{^Block=dingbats}', "");
    Expect(0, 10176, '\p{Block=dingbats}', "");
    Expect(1, 10176, '\p{^Block=dingbats}', "");
    Expect(1, 10176, '\P{Block=dingbats}', "");
    Expect(0, 10176, '\P{^Block=dingbats}', "");
    Expect(1, 10175, '\p{Block=:\Adingbats\z:}', "");;
    Expect(0, 10176, '\p{Block=:\Adingbats\z:}', "");;
    Expect(1, 10175, '\p{Block=- Dingbats}', "");
    Expect(0, 10175, '\p{^Block=- Dingbats}', "");
    Expect(0, 10175, '\P{Block=- Dingbats}', "");
    Expect(1, 10175, '\P{^Block=- Dingbats}', "");
    Expect(0, 10176, '\p{Block=- Dingbats}', "");
    Expect(1, 10176, '\p{^Block=- Dingbats}', "");
    Expect(1, 10176, '\P{Block=- Dingbats}', "");
    Expect(0, 10176, '\P{^Block=- Dingbats}', "");
    Error('\p{Blk=-DINGBATS/a/}');
    Error('\P{Blk=-DINGBATS/a/}');
    Expect(1, 10175, '\p{Blk=:\ADingbats\z:}', "");;
    Expect(0, 10176, '\p{Blk=:\ADingbats\z:}', "");;
    Expect(1, 10175, '\p{Blk=dingbats}', "");
    Expect(0, 10175, '\p{^Blk=dingbats}', "");
    Expect(0, 10175, '\P{Blk=dingbats}', "");
    Expect(1, 10175, '\P{^Blk=dingbats}', "");
    Expect(0, 10176, '\p{Blk=dingbats}', "");
    Expect(1, 10176, '\p{^Blk=dingbats}', "");
    Expect(1, 10176, '\P{Blk=dingbats}', "");
    Expect(0, 10176, '\P{^Blk=dingbats}', "");
    Expect(1, 10175, '\p{Blk=:\Adingbats\z:}', "");;
    Expect(0, 10176, '\p{Blk=:\Adingbats\z:}', "");;
    Expect(1, 10175, '\p{Blk= -Dingbats}', "");
    Expect(0, 10175, '\p{^Blk= -Dingbats}', "");
    Expect(0, 10175, '\P{Blk= -Dingbats}', "");
    Expect(1, 10175, '\P{^Blk= -Dingbats}', "");
    Expect(0, 10176, '\p{Blk= -Dingbats}', "");
    Expect(1, 10176, '\p{^Blk= -Dingbats}', "");
    Expect(1, 10176, '\P{Blk= -Dingbats}', "");
    Expect(0, 10176, '\P{^Blk= -Dingbats}', "");
    Error('\p{Is_Block=DINGBATS:=}');
    Error('\P{Is_Block=DINGBATS:=}');
    Expect(1, 10175, '\p{Is_Block=dingbats}', "");
    Expect(0, 10175, '\p{^Is_Block=dingbats}', "");
    Expect(0, 10175, '\P{Is_Block=dingbats}', "");
    Expect(1, 10175, '\P{^Is_Block=dingbats}', "");
    Expect(0, 10176, '\p{Is_Block=dingbats}', "");
    Expect(1, 10176, '\p{^Is_Block=dingbats}', "");
    Expect(1, 10176, '\P{Is_Block=dingbats}', "");
    Expect(0, 10176, '\P{^Is_Block=dingbats}', "");
    Expect(1, 10175, '\p{Is_Block=		dingbats}', "");
    Expect(0, 10175, '\p{^Is_Block=		dingbats}', "");
    Expect(0, 10175, '\P{Is_Block=		dingbats}', "");
    Expect(1, 10175, '\P{^Is_Block=		dingbats}', "");
    Expect(0, 10176, '\p{Is_Block=		dingbats}', "");
    Expect(1, 10176, '\p{^Is_Block=		dingbats}', "");
    Expect(1, 10176, '\P{Is_Block=		dingbats}', "");
    Expect(0, 10176, '\P{^Is_Block=		dingbats}', "");
    Error('\p{Is_Blk=:=dingbats}');
    Error('\P{Is_Blk=:=dingbats}');
    Expect(1, 10175, '\p{Is_Blk=dingbats}', "");
    Expect(0, 10175, '\p{^Is_Blk=dingbats}', "");
    Expect(0, 10175, '\P{Is_Blk=dingbats}', "");
    Expect(1, 10175, '\P{^Is_Blk=dingbats}', "");
    Expect(0, 10176, '\p{Is_Blk=dingbats}', "");
    Expect(1, 10176, '\p{^Is_Blk=dingbats}', "");
    Expect(1, 10176, '\P{Is_Blk=dingbats}', "");
    Expect(0, 10176, '\P{^Is_Blk=dingbats}', "");
    Expect(1, 10175, '\p{Is_Blk=_dingbats}', "");
    Expect(0, 10175, '\p{^Is_Blk=_dingbats}', "");
    Expect(0, 10175, '\P{Is_Blk=_dingbats}', "");
    Expect(1, 10175, '\P{^Is_Blk=_dingbats}', "");
    Expect(0, 10176, '\p{Is_Blk=_dingbats}', "");
    Expect(1, 10176, '\p{^Is_Blk=_dingbats}', "");
    Expect(1, 10176, '\P{Is_Blk=_dingbats}', "");
    Expect(0, 10176, '\P{^Is_Blk=_dingbats}', "");
    Error('\p{Block=/a/-dives_AKURU}');
    Error('\P{Block=/a/-dives_AKURU}');
    Expect(1, 72031, '\p{Block=:\ADives_Akuru\z:}', "");;
    Expect(0, 72032, '\p{Block=:\ADives_Akuru\z:}', "");;
    Expect(1, 72031, '\p{Block=divesakuru}', "");
    Expect(0, 72031, '\p{^Block=divesakuru}', "");
    Expect(0, 72031, '\P{Block=divesakuru}', "");
    Expect(1, 72031, '\P{^Block=divesakuru}', "");
    Expect(0, 72032, '\p{Block=divesakuru}', "");
    Expect(1, 72032, '\p{^Block=divesakuru}', "");
    Expect(1, 72032, '\P{Block=divesakuru}', "");
    Expect(0, 72032, '\P{^Block=divesakuru}', "");
    Expect(1, 72031, '\p{Block=:\Adivesakuru\z:}', "");;
    Expect(0, 72032, '\p{Block=:\Adivesakuru\z:}', "");;
    Expect(1, 72031, '\p{Block:  -Dives_Akuru}', "");
    Expect(0, 72031, '\p{^Block:  -Dives_Akuru}', "");
    Expect(0, 72031, '\P{Block:  -Dives_Akuru}', "");
    Expect(1, 72031, '\P{^Block:  -Dives_Akuru}', "");
    Expect(0, 72032, '\p{Block:  -Dives_Akuru}', "");
    Expect(1, 72032, '\p{^Block:  -Dives_Akuru}', "");
    Expect(1, 72032, '\P{Block:  -Dives_Akuru}', "");
    Expect(0, 72032, '\P{^Block:  -Dives_Akuru}', "");
    Error('\p{Blk=:=--DIVES_AKURU}');
    Error('\P{Blk=:=--DIVES_AKURU}');
    Expect(1, 72031, '\p{Blk=:\ADives_Akuru\z:}', "");;
    Expect(0, 72032, '\p{Blk=:\ADives_Akuru\z:}', "");;
    Expect(1, 72031, '\p{Blk=divesakuru}', "");
    Expect(0, 72031, '\p{^Blk=divesakuru}', "");
    Expect(0, 72031, '\P{Blk=divesakuru}', "");
    Expect(1, 72031, '\P{^Blk=divesakuru}', "");
    Expect(0, 72032, '\p{Blk=divesakuru}', "");
    Expect(1, 72032, '\p{^Blk=divesakuru}', "");
    Expect(1, 72032, '\P{Blk=divesakuru}', "");
    Expect(0, 72032, '\P{^Blk=divesakuru}', "");
    Expect(1, 72031, '\p{Blk=:\Adivesakuru\z:}', "");;
    Expect(0, 72032, '\p{Blk=:\Adivesakuru\z:}', "");;
    Expect(1, 72031, '\p{Blk=_DIVES_Akuru}', "");
    Expect(0, 72031, '\p{^Blk=_DIVES_Akuru}', "");
    Expect(0, 72031, '\P{Blk=_DIVES_Akuru}', "");
    Expect(1, 72031, '\P{^Blk=_DIVES_Akuru}', "");
    Expect(0, 72032, '\p{Blk=_DIVES_Akuru}', "");
    Expect(1, 72032, '\p{^Blk=_DIVES_Akuru}', "");
    Expect(1, 72032, '\P{Blk=_DIVES_Akuru}', "");
    Expect(0, 72032, '\P{^Blk=_DIVES_Akuru}', "");
    Error('\p{Is_Block=/a/--DIVES_Akuru}');
    Error('\P{Is_Block=/a/--DIVES_Akuru}');
    Expect(1, 72031, '\p{Is_Block:   divesakuru}', "");
    Expect(0, 72031, '\p{^Is_Block:   divesakuru}', "");
    Expect(0, 72031, '\P{Is_Block:   divesakuru}', "");
    Expect(1, 72031, '\P{^Is_Block:   divesakuru}', "");
    Expect(0, 72032, '\p{Is_Block:   divesakuru}', "");
    Expect(1, 72032, '\p{^Is_Block:   divesakuru}', "");
    Expect(1, 72032, '\P{Is_Block:   divesakuru}', "");
    Expect(0, 72032, '\P{^Is_Block:   divesakuru}', "");
    Expect(1, 72031, '\p{Is_Block=_Dives_Akuru}', "");
    Expect(0, 72031, '\p{^Is_Block=_Dives_Akuru}', "");
    Expect(0, 72031, '\P{Is_Block=_Dives_Akuru}', "");
    Expect(1, 72031, '\P{^Is_Block=_Dives_Akuru}', "");
    Expect(0, 72032, '\p{Is_Block=_Dives_Akuru}', "");
    Expect(1, 72032, '\p{^Is_Block=_Dives_Akuru}', "");
    Expect(1, 72032, '\P{Is_Block=_Dives_Akuru}', "");
    Expect(0, 72032, '\P{^Is_Block=_Dives_Akuru}', "");
    Error('\p{Is_Blk=__DIVES_Akuru/a/}');
    Error('\P{Is_Blk=__DIVES_Akuru/a/}');
    Expect(1, 72031, '\p{Is_Blk=divesakuru}', "");
    Expect(0, 72031, '\p{^Is_Blk=divesakuru}', "");
    Expect(0, 72031, '\P{Is_Blk=divesakuru}', "");
    Expect(1, 72031, '\P{^Is_Blk=divesakuru}', "");
    Expect(0, 72032, '\p{Is_Blk=divesakuru}', "");
    Expect(1, 72032, '\p{^Is_Blk=divesakuru}', "");
    Expect(1, 72032, '\P{Is_Blk=divesakuru}', "");
    Expect(0, 72032, '\P{^Is_Blk=divesakuru}', "");
    Expect(1, 72031, '\p{Is_Blk=	 Dives_Akuru}', "");
    Expect(0, 72031, '\p{^Is_Blk=	 Dives_Akuru}', "");
    Expect(0, 72031, '\P{Is_Blk=	 Dives_Akuru}', "");
    Expect(1, 72031, '\P{^Is_Blk=	 Dives_Akuru}', "");
    Expect(0, 72032, '\p{Is_Blk=	 Dives_Akuru}', "");
    Expect(1, 72032, '\p{^Is_Blk=	 Dives_Akuru}', "");
    Expect(1, 72032, '\P{Is_Blk=	 Dives_Akuru}', "");
    Expect(0, 72032, '\P{^Is_Blk=	 Dives_Akuru}', "");
    Error('\p{Block=:=	_Dogra}');
    Error('\P{Block=:=	_Dogra}');
    Expect(1, 71759, '\p{Block=:\ADogra\z:}', "");;
    Expect(0, 71760, '\p{Block=:\ADogra\z:}', "");;
    Expect(1, 71759, '\p{Block=dogra}', "");
    Expect(0, 71759, '\p{^Block=dogra}', "");
    Expect(0, 71759, '\P{Block=dogra}', "");
    Expect(1, 71759, '\P{^Block=dogra}', "");
    Expect(0, 71760, '\p{Block=dogra}', "");
    Expect(1, 71760, '\p{^Block=dogra}', "");
    Expect(1, 71760, '\P{Block=dogra}', "");
    Expect(0, 71760, '\P{^Block=dogra}', "");
    Expect(1, 71759, '\p{Block=:\Adogra\z:}', "");;
    Expect(0, 71760, '\p{Block=:\Adogra\z:}', "");;
    Expect(1, 71759, '\p{Block= dogra}', "");
    Expect(0, 71759, '\p{^Block= dogra}', "");
    Expect(0, 71759, '\P{Block= dogra}', "");
    Expect(1, 71759, '\P{^Block= dogra}', "");
    Expect(0, 71760, '\p{Block= dogra}', "");
    Expect(1, 71760, '\p{^Block= dogra}', "");
    Expect(1, 71760, '\P{Block= dogra}', "");
    Expect(0, 71760, '\P{^Block= dogra}', "");
    Error('\p{Blk= 	dogra/a/}');
    Error('\P{Blk= 	dogra/a/}');
    Expect(1, 71759, '\p{Blk=:\ADogra\z:}', "");;
    Expect(0, 71760, '\p{Blk=:\ADogra\z:}', "");;
    Expect(1, 71759, '\p{Blk=dogra}', "");
    Expect(0, 71759, '\p{^Blk=dogra}', "");
    Expect(0, 71759, '\P{Blk=dogra}', "");
    Expect(1, 71759, '\P{^Blk=dogra}', "");
    Expect(0, 71760, '\p{Blk=dogra}', "");
    Expect(1, 71760, '\p{^Blk=dogra}', "");
    Expect(1, 71760, '\P{Blk=dogra}', "");
    Expect(0, 71760, '\P{^Blk=dogra}', "");
    Expect(1, 71759, '\p{Blk=:\Adogra\z:}', "");;
    Expect(0, 71760, '\p{Blk=:\Adogra\z:}', "");;
    Expect(1, 71759, '\p{Blk=__dogra}', "");
    Expect(0, 71759, '\p{^Blk=__dogra}', "");
    Expect(0, 71759, '\P{Blk=__dogra}', "");
    Expect(1, 71759, '\P{^Blk=__dogra}', "");
    Expect(0, 71760, '\p{Blk=__dogra}', "");
    Expect(1, 71760, '\p{^Blk=__dogra}', "");
    Expect(1, 71760, '\P{Blk=__dogra}', "");
    Expect(0, 71760, '\P{^Blk=__dogra}', "");
    Error('\p{Is_Block=_Dogra/a/}');
    Error('\P{Is_Block=_Dogra/a/}');
    Expect(1, 71759, '\p{Is_Block=dogra}', "");
    Expect(0, 71759, '\p{^Is_Block=dogra}', "");
    Expect(0, 71759, '\P{Is_Block=dogra}', "");
    Expect(1, 71759, '\P{^Is_Block=dogra}', "");
    Expect(0, 71760, '\p{Is_Block=dogra}', "");
    Expect(1, 71760, '\p{^Is_Block=dogra}', "");
    Expect(1, 71760, '\P{Is_Block=dogra}', "");
    Expect(0, 71760, '\P{^Is_Block=dogra}', "");
    Expect(1, 71759, '\p{Is_Block= dogra}', "");
    Expect(0, 71759, '\p{^Is_Block= dogra}', "");
    Expect(0, 71759, '\P{Is_Block= dogra}', "");
    Expect(1, 71759, '\P{^Is_Block= dogra}', "");
    Expect(0, 71760, '\p{Is_Block= dogra}', "");
    Expect(1, 71760, '\p{^Is_Block= dogra}', "");
    Expect(1, 71760, '\P{Is_Block= dogra}', "");
    Expect(0, 71760, '\P{^Is_Block= dogra}', "");
    Error('\p{Is_Blk=_/a/Dogra}');
    Error('\P{Is_Blk=_/a/Dogra}');
    Expect(1, 71759, '\p{Is_Blk=dogra}', "");
    Expect(0, 71759, '\p{^Is_Blk=dogra}', "");
    Expect(0, 71759, '\P{Is_Blk=dogra}', "");
    Expect(1, 71759, '\P{^Is_Blk=dogra}', "");
    Expect(0, 71760, '\p{Is_Blk=dogra}', "");
    Expect(1, 71760, '\p{^Is_Blk=dogra}', "");
    Expect(1, 71760, '\P{Is_Blk=dogra}', "");
    Expect(0, 71760, '\P{^Is_Blk=dogra}', "");
    Expect(1, 71759, '\p{Is_Blk=--Dogra}', "");
    Expect(0, 71759, '\p{^Is_Blk=--Dogra}', "");
    Expect(0, 71759, '\P{Is_Blk=--Dogra}', "");
    Expect(1, 71759, '\P{^Is_Blk=--Dogra}', "");
    Expect(0, 71760, '\p{Is_Blk=--Dogra}', "");
    Expect(1, 71760, '\p{^Is_Blk=--Dogra}', "");
    Expect(1, 71760, '\P{Is_Blk=--Dogra}', "");
    Expect(0, 71760, '\P{^Is_Blk=--Dogra}', "");
    Error('\p{Block=		Domino_TILES/a/}');
    Error('\P{Block=		Domino_TILES/a/}');
    Expect(1, 127135, '\p{Block=:\ADomino_Tiles\z:}', "");;
    Expect(0, 127136, '\p{Block=:\ADomino_Tiles\z:}', "");;
    Expect(1, 127135, '\p{Block=dominotiles}', "");
    Expect(0, 127135, '\p{^Block=dominotiles}', "");
    Expect(0, 127135, '\P{Block=dominotiles}', "");
    Expect(1, 127135, '\P{^Block=dominotiles}', "");
    Expect(0, 127136, '\p{Block=dominotiles}', "");
    Expect(1, 127136, '\p{^Block=dominotiles}', "");
    Expect(1, 127136, '\P{Block=dominotiles}', "");
    Expect(0, 127136, '\P{^Block=dominotiles}', "");
    Expect(1, 127135, '\p{Block=:\Adominotiles\z:}', "");;
    Expect(0, 127136, '\p{Block=:\Adominotiles\z:}', "");;
    Expect(1, 127135, '\p{Block=-Domino_Tiles}', "");
    Expect(0, 127135, '\p{^Block=-Domino_Tiles}', "");
    Expect(0, 127135, '\P{Block=-Domino_Tiles}', "");
    Expect(1, 127135, '\P{^Block=-Domino_Tiles}', "");
    Expect(0, 127136, '\p{Block=-Domino_Tiles}', "");
    Expect(1, 127136, '\p{^Block=-Domino_Tiles}', "");
    Expect(1, 127136, '\P{Block=-Domino_Tiles}', "");
    Expect(0, 127136, '\P{^Block=-Domino_Tiles}', "");
    Error('\p{Blk: -/a/Domino}');
    Error('\P{Blk: -/a/Domino}');
    Expect(1, 127135, '\p{Blk=:\ADomino\z:}', "");;
    Expect(0, 127136, '\p{Blk=:\ADomino\z:}', "");;
    Expect(1, 127135, '\p{Blk=domino}', "");
    Expect(0, 127135, '\p{^Blk=domino}', "");
    Expect(0, 127135, '\P{Blk=domino}', "");
    Expect(1, 127135, '\P{^Blk=domino}', "");
    Expect(0, 127136, '\p{Blk=domino}', "");
    Expect(1, 127136, '\p{^Blk=domino}', "");
    Expect(1, 127136, '\P{Blk=domino}', "");
    Expect(0, 127136, '\P{^Blk=domino}', "");
    Expect(1, 127135, '\p{Blk=:\Adomino\z:}', "");;
    Expect(0, 127136, '\p{Blk=:\Adomino\z:}', "");;
    Expect(1, 127135, '\p{Blk=	 DOMINO}', "");
    Expect(0, 127135, '\p{^Blk=	 DOMINO}', "");
    Expect(0, 127135, '\P{Blk=	 DOMINO}', "");
    Expect(1, 127135, '\P{^Blk=	 DOMINO}', "");
    Expect(0, 127136, '\p{Blk=	 DOMINO}', "");
    Expect(1, 127136, '\p{^Blk=	 DOMINO}', "");
    Expect(1, 127136, '\P{Blk=	 DOMINO}', "");
    Expect(0, 127136, '\P{^Blk=	 DOMINO}', "");
    Error('\p{Is_Block=:=_Domino_tiles}');
    Error('\P{Is_Block=:=_Domino_tiles}');
    Expect(1, 127135, '\p{Is_Block=dominotiles}', "");
    Expect(0, 127135, '\p{^Is_Block=dominotiles}', "");
    Expect(0, 127135, '\P{Is_Block=dominotiles}', "");
    Expect(1, 127135, '\P{^Is_Block=dominotiles}', "");
    Expect(0, 127136, '\p{Is_Block=dominotiles}', "");
    Expect(1, 127136, '\p{^Is_Block=dominotiles}', "");
    Expect(1, 127136, '\P{Is_Block=dominotiles}', "");
    Expect(0, 127136, '\P{^Is_Block=dominotiles}', "");
    Expect(1, 127135, '\p{Is_Block=  domino_TILES}', "");
    Expect(0, 127135, '\p{^Is_Block=  domino_TILES}', "");
    Expect(0, 127135, '\P{Is_Block=  domino_TILES}', "");
    Expect(1, 127135, '\P{^Is_Block=  domino_TILES}', "");
    Expect(0, 127136, '\p{Is_Block=  domino_TILES}', "");
    Expect(1, 127136, '\p{^Is_Block=  domino_TILES}', "");
    Expect(1, 127136, '\P{Is_Block=  domino_TILES}', "");
    Expect(0, 127136, '\P{^Is_Block=  domino_TILES}', "");
    Error('\p{Is_Blk=:=	-Domino}');
    Error('\P{Is_Blk=:=	-Domino}');
    Expect(1, 127135, '\p{Is_Blk: domino}', "");
    Expect(0, 127135, '\p{^Is_Blk: domino}', "");
    Expect(0, 127135, '\P{Is_Blk: domino}', "");
    Expect(1, 127135, '\P{^Is_Blk: domino}', "");
    Expect(0, 127136, '\p{Is_Blk: domino}', "");
    Expect(1, 127136, '\p{^Is_Blk: domino}', "");
    Expect(1, 127136, '\P{Is_Blk: domino}', "");
    Expect(0, 127136, '\P{^Is_Blk: domino}', "");
    Expect(1, 127135, '\p{Is_Blk=-	Domino}', "");
    Expect(0, 127135, '\p{^Is_Blk=-	Domino}', "");
    Expect(0, 127135, '\P{Is_Blk=-	Domino}', "");
    Expect(1, 127135, '\P{^Is_Blk=-	Domino}', "");
    Expect(0, 127136, '\p{Is_Blk=-	Domino}', "");
    Expect(1, 127136, '\p{^Is_Blk=-	Domino}', "");
    Expect(1, 127136, '\P{Is_Blk=-	Domino}', "");
    Expect(0, 127136, '\P{^Is_Blk=-	Domino}', "");
    Error('\p{Block=/a/ _DUPLOYAN}');
    Error('\P{Block=/a/ _DUPLOYAN}');
    Expect(1, 113823, '\p{Block=:\ADuployan\z:}', "");;
    Expect(0, 113824, '\p{Block=:\ADuployan\z:}', "");;
    Expect(1, 113823, '\p{Block=duployan}', "");
    Expect(0, 113823, '\p{^Block=duployan}', "");
    Expect(0, 113823, '\P{Block=duployan}', "");
    Expect(1, 113823, '\P{^Block=duployan}', "");
    Expect(0, 113824, '\p{Block=duployan}', "");
    Expect(1, 113824, '\p{^Block=duployan}', "");
    Expect(1, 113824, '\P{Block=duployan}', "");
    Expect(0, 113824, '\P{^Block=duployan}', "");
    Expect(1, 113823, '\p{Block=:\Aduployan\z:}', "");;
    Expect(0, 113824, '\p{Block=:\Aduployan\z:}', "");;
    Expect(1, 113823, '\p{Block:		-DUPLOYAN}', "");
    Expect(0, 113823, '\p{^Block:		-DUPLOYAN}', "");
    Expect(0, 113823, '\P{Block:		-DUPLOYAN}', "");
    Expect(1, 113823, '\P{^Block:		-DUPLOYAN}', "");
    Expect(0, 113824, '\p{Block:		-DUPLOYAN}', "");
    Expect(1, 113824, '\p{^Block:		-DUPLOYAN}', "");
    Expect(1, 113824, '\P{Block:		-DUPLOYAN}', "");
    Expect(0, 113824, '\P{^Block:		-DUPLOYAN}', "");
    Error('\p{Blk=/a/duployan}');
    Error('\P{Blk=/a/duployan}');
    Expect(1, 113823, '\p{Blk=:\ADuployan\z:}', "");;
    Expect(0, 113824, '\p{Blk=:\ADuployan\z:}', "");;
    Expect(1, 113823, '\p{Blk:	duployan}', "");
    Expect(0, 113823, '\p{^Blk:	duployan}', "");
    Expect(0, 113823, '\P{Blk:	duployan}', "");
    Expect(1, 113823, '\P{^Blk:	duployan}', "");
    Expect(0, 113824, '\p{Blk:	duployan}', "");
    Expect(1, 113824, '\p{^Blk:	duployan}', "");
    Expect(1, 113824, '\P{Blk:	duployan}', "");
    Expect(0, 113824, '\P{^Blk:	duployan}', "");
    Expect(1, 113823, '\p{Blk=:\Aduployan\z:}', "");;
    Expect(0, 113824, '\p{Blk=:\Aduployan\z:}', "");;
    Expect(1, 113823, '\p{Blk=  duployan}', "");
    Expect(0, 113823, '\p{^Blk=  duployan}', "");
    Expect(0, 113823, '\P{Blk=  duployan}', "");
    Expect(1, 113823, '\P{^Blk=  duployan}', "");
    Expect(0, 113824, '\p{Blk=  duployan}', "");
    Expect(1, 113824, '\p{^Blk=  duployan}', "");
    Expect(1, 113824, '\P{Blk=  duployan}', "");
    Expect(0, 113824, '\P{^Blk=  duployan}', "");
    Error('\p{Is_Block=_Duployan:=}');
    Error('\P{Is_Block=_Duployan:=}');
    Expect(1, 113823, '\p{Is_Block=duployan}', "");
    Expect(0, 113823, '\p{^Is_Block=duployan}', "");
    Expect(0, 113823, '\P{Is_Block=duployan}', "");
    Expect(1, 113823, '\P{^Is_Block=duployan}', "");
    Expect(0, 113824, '\p{Is_Block=duployan}', "");
    Expect(1, 113824, '\p{^Is_Block=duployan}', "");
    Expect(1, 113824, '\P{Is_Block=duployan}', "");
    Expect(0, 113824, '\P{^Is_Block=duployan}', "");
    Expect(1, 113823, '\p{Is_Block=-	Duployan}', "");
    Expect(0, 113823, '\p{^Is_Block=-	Duployan}', "");
    Expect(0, 113823, '\P{Is_Block=-	Duployan}', "");
    Expect(1, 113823, '\P{^Is_Block=-	Duployan}', "");
    Expect(0, 113824, '\p{Is_Block=-	Duployan}', "");
    Expect(1, 113824, '\p{^Is_Block=-	Duployan}', "");
    Expect(1, 113824, '\P{Is_Block=-	Duployan}', "");
    Expect(0, 113824, '\P{^Is_Block=-	Duployan}', "");
    Error('\p{Is_Blk=:=_-Duployan}');
    Error('\P{Is_Blk=:=_-Duployan}');
    Expect(1, 113823, '\p{Is_Blk:   duployan}', "");
    Expect(0, 113823, '\p{^Is_Blk:   duployan}', "");
    Expect(0, 113823, '\P{Is_Blk:   duployan}', "");
    Expect(1, 113823, '\P{^Is_Blk:   duployan}', "");
    Expect(0, 113824, '\p{Is_Blk:   duployan}', "");
    Expect(1, 113824, '\p{^Is_Blk:   duployan}', "");
    Expect(1, 113824, '\P{Is_Blk:   duployan}', "");
    Expect(0, 113824, '\P{^Is_Blk:   duployan}', "");
    Expect(1, 113823, '\p{Is_Blk= duployan}', "");
    Expect(0, 113823, '\p{^Is_Blk= duployan}', "");
    Expect(0, 113823, '\P{Is_Blk= duployan}', "");
    Expect(1, 113823, '\P{^Is_Blk= duployan}', "");
    Expect(0, 113824, '\p{Is_Blk= duployan}', "");
    Expect(1, 113824, '\p{^Is_Blk= duployan}', "");
    Expect(1, 113824, '\P{Is_Blk= duployan}', "");
    Expect(0, 113824, '\P{^Is_Blk= duployan}', "");
    Error('\p{Block=:=__EARLY_Dynastic_CUNEIFORM}');
    Error('\P{Block=:=__EARLY_Dynastic_CUNEIFORM}');
    Expect(1, 75087, '\p{Block=:\AEarly_Dynastic_Cuneiform\z:}', "");;
    Expect(0, 75088, '\p{Block=:\AEarly_Dynastic_Cuneiform\z:}', "");;
    Expect(1, 75087, '\p{Block=earlydynasticcuneiform}', "");
    Expect(0, 75087, '\p{^Block=earlydynasticcuneiform}', "");
    Expect(0, 75087, '\P{Block=earlydynasticcuneiform}', "");
    Expect(1, 75087, '\P{^Block=earlydynasticcuneiform}', "");
    Expect(0, 75088, '\p{Block=earlydynasticcuneiform}', "");
    Expect(1, 75088, '\p{^Block=earlydynasticcuneiform}', "");
    Expect(1, 75088, '\P{Block=earlydynasticcuneiform}', "");
    Expect(0, 75088, '\P{^Block=earlydynasticcuneiform}', "");
    Expect(1, 75087, '\p{Block=:\Aearlydynasticcuneiform\z:}', "");;
    Expect(0, 75088, '\p{Block=:\Aearlydynasticcuneiform\z:}', "");;
    Expect(1, 75087, '\p{Block:  Early_Dynastic_cuneiform}', "");
    Expect(0, 75087, '\p{^Block:  Early_Dynastic_cuneiform}', "");
    Expect(0, 75087, '\P{Block:  Early_Dynastic_cuneiform}', "");
    Expect(1, 75087, '\P{^Block:  Early_Dynastic_cuneiform}', "");
    Expect(0, 75088, '\p{Block:  Early_Dynastic_cuneiform}', "");
    Expect(1, 75088, '\p{^Block:  Early_Dynastic_cuneiform}', "");
    Expect(1, 75088, '\P{Block:  Early_Dynastic_cuneiform}', "");
    Expect(0, 75088, '\P{^Block:  Early_Dynastic_cuneiform}', "");
    Error('\p{Blk=/a/		early_Dynastic_Cuneiform}');
    Error('\P{Blk=/a/		early_Dynastic_Cuneiform}');
    Expect(1, 75087, '\p{Blk=:\AEarly_Dynastic_Cuneiform\z:}', "");;
    Expect(0, 75088, '\p{Blk=:\AEarly_Dynastic_Cuneiform\z:}', "");;
    Expect(1, 75087, '\p{Blk=earlydynasticcuneiform}', "");
    Expect(0, 75087, '\p{^Blk=earlydynasticcuneiform}', "");
    Expect(0, 75087, '\P{Blk=earlydynasticcuneiform}', "");
    Expect(1, 75087, '\P{^Blk=earlydynasticcuneiform}', "");
    Expect(0, 75088, '\p{Blk=earlydynasticcuneiform}', "");
    Expect(1, 75088, '\p{^Blk=earlydynasticcuneiform}', "");
    Expect(1, 75088, '\P{Blk=earlydynasticcuneiform}', "");
    Expect(0, 75088, '\P{^Blk=earlydynasticcuneiform}', "");
    Expect(1, 75087, '\p{Blk=:\Aearlydynasticcuneiform\z:}', "");;
    Expect(0, 75088, '\p{Blk=:\Aearlydynasticcuneiform\z:}', "");;
    Expect(1, 75087, '\p{Blk=_early_Dynastic_Cuneiform}', "");
    Expect(0, 75087, '\p{^Blk=_early_Dynastic_Cuneiform}', "");
    Expect(0, 75087, '\P{Blk=_early_Dynastic_Cuneiform}', "");
    Expect(1, 75087, '\P{^Blk=_early_Dynastic_Cuneiform}', "");
    Expect(0, 75088, '\p{Blk=_early_Dynastic_Cuneiform}', "");
    Expect(1, 75088, '\p{^Blk=_early_Dynastic_Cuneiform}', "");
    Expect(1, 75088, '\P{Blk=_early_Dynastic_Cuneiform}', "");
    Expect(0, 75088, '\P{^Blk=_early_Dynastic_Cuneiform}', "");
    Error('\p{Is_Block=/a/	 early_DYNASTIC_Cuneiform}');
    Error('\P{Is_Block=/a/	 early_DYNASTIC_Cuneiform}');
    Expect(1, 75087, '\p{Is_Block=earlydynasticcuneiform}', "");
    Expect(0, 75087, '\p{^Is_Block=earlydynasticcuneiform}', "");
    Expect(0, 75087, '\P{Is_Block=earlydynasticcuneiform}', "");
    Expect(1, 75087, '\P{^Is_Block=earlydynasticcuneiform}', "");
    Expect(0, 75088, '\p{Is_Block=earlydynasticcuneiform}', "");
    Expect(1, 75088, '\p{^Is_Block=earlydynasticcuneiform}', "");
    Expect(1, 75088, '\P{Is_Block=earlydynasticcuneiform}', "");
    Expect(0, 75088, '\P{^Is_Block=earlydynasticcuneiform}', "");
    Expect(1, 75087, '\p{Is_Block= 	Early_Dynastic_Cuneiform}', "");
    Expect(0, 75087, '\p{^Is_Block= 	Early_Dynastic_Cuneiform}', "");
    Expect(0, 75087, '\P{Is_Block= 	Early_Dynastic_Cuneiform}', "");
    Expect(1, 75087, '\P{^Is_Block= 	Early_Dynastic_Cuneiform}', "");
    Expect(0, 75088, '\p{Is_Block= 	Early_Dynastic_Cuneiform}', "");
    Expect(1, 75088, '\p{^Is_Block= 	Early_Dynastic_Cuneiform}', "");
    Expect(1, 75088, '\P{Is_Block= 	Early_Dynastic_Cuneiform}', "");
    Expect(0, 75088, '\P{^Is_Block= 	Early_Dynastic_Cuneiform}', "");
    Error('\p{Is_Blk= early_DYNASTIC_Cuneiform:=}');
    Error('\P{Is_Blk= early_DYNASTIC_Cuneiform:=}');
    Expect(1, 75087, '\p{Is_Blk=earlydynasticcuneiform}', "");
    Expect(0, 75087, '\p{^Is_Blk=earlydynasticcuneiform}', "");
    Expect(0, 75087, '\P{Is_Blk=earlydynasticcuneiform}', "");
    Expect(1, 75087, '\P{^Is_Blk=earlydynasticcuneiform}', "");
    Expect(0, 75088, '\p{Is_Blk=earlydynasticcuneiform}', "");
    Expect(1, 75088, '\p{^Is_Blk=earlydynasticcuneiform}', "");
    Expect(1, 75088, '\P{Is_Blk=earlydynasticcuneiform}', "");
    Expect(0, 75088, '\P{^Is_Blk=earlydynasticcuneiform}', "");
    Expect(1, 75087, '\p{Is_Blk= early_DYNASTIC_Cuneiform}', "");
    Expect(0, 75087, '\p{^Is_Blk= early_DYNASTIC_Cuneiform}', "");
    Expect(0, 75087, '\P{Is_Blk= early_DYNASTIC_Cuneiform}', "");
    Expect(1, 75087, '\P{^Is_Blk= early_DYNASTIC_Cuneiform}', "");
    Expect(0, 75088, '\p{Is_Blk= early_DYNASTIC_Cuneiform}', "");
    Expect(1, 75088, '\p{^Is_Blk= early_DYNASTIC_Cuneiform}', "");
    Expect(1, 75088, '\P{Is_Blk= early_DYNASTIC_Cuneiform}', "");
    Expect(0, 75088, '\P{^Is_Blk= early_DYNASTIC_Cuneiform}', "");
    Error('\p{Block=:= -egyptian_HIEROGLYPH_FORMAT_controls}');
    Error('\P{Block=:= -egyptian_HIEROGLYPH_FORMAT_controls}');
    Expect(1, 78943, '\p{Block=:\AEgyptian_Hieroglyph_Format_Controls\z:}', "");;
    Expect(0, 78944, '\p{Block=:\AEgyptian_Hieroglyph_Format_Controls\z:}', "");;
    Expect(1, 78943, '\p{Block=egyptianhieroglyphformatcontrols}', "");
    Expect(0, 78943, '\p{^Block=egyptianhieroglyphformatcontrols}', "");
    Expect(0, 78943, '\P{Block=egyptianhieroglyphformatcontrols}', "");
    Expect(1, 78943, '\P{^Block=egyptianhieroglyphformatcontrols}', "");
    Expect(0, 78944, '\p{Block=egyptianhieroglyphformatcontrols}', "");
    Expect(1, 78944, '\p{^Block=egyptianhieroglyphformatcontrols}', "");
    Expect(1, 78944, '\P{Block=egyptianhieroglyphformatcontrols}', "");
    Expect(0, 78944, '\P{^Block=egyptianhieroglyphformatcontrols}', "");
    Expect(1, 78943, '\p{Block=:\Aegyptianhieroglyphformatcontrols\z:}', "");;
    Expect(0, 78944, '\p{Block=:\Aegyptianhieroglyphformatcontrols\z:}', "");;
    Expect(1, 78943, '\p{Block=_-egyptian_Hieroglyph_Format_controls}', "");
    Expect(0, 78943, '\p{^Block=_-egyptian_Hieroglyph_Format_controls}', "");
    Expect(0, 78943, '\P{Block=_-egyptian_Hieroglyph_Format_controls}', "");
    Expect(1, 78943, '\P{^Block=_-egyptian_Hieroglyph_Format_controls}', "");
    Expect(0, 78944, '\p{Block=_-egyptian_Hieroglyph_Format_controls}', "");
    Expect(1, 78944, '\p{^Block=_-egyptian_Hieroglyph_Format_controls}', "");
    Expect(1, 78944, '\P{Block=_-egyptian_Hieroglyph_Format_controls}', "");
    Expect(0, 78944, '\P{^Block=_-egyptian_Hieroglyph_Format_controls}', "");
    Error('\p{Blk:-Egyptian_HIEROGLYPH_FORMAT_Controls/a/}');
    Error('\P{Blk:-Egyptian_HIEROGLYPH_FORMAT_Controls/a/}');
    Expect(1, 78943, '\p{Blk=:\AEgyptian_Hieroglyph_Format_Controls\z:}', "");;
    Expect(0, 78944, '\p{Blk=:\AEgyptian_Hieroglyph_Format_Controls\z:}', "");;
    Expect(1, 78943, '\p{Blk=egyptianhieroglyphformatcontrols}', "");
    Expect(0, 78943, '\p{^Blk=egyptianhieroglyphformatcontrols}', "");
    Expect(0, 78943, '\P{Blk=egyptianhieroglyphformatcontrols}', "");
    Expect(1, 78943, '\P{^Blk=egyptianhieroglyphformatcontrols}', "");
    Expect(0, 78944, '\p{Blk=egyptianhieroglyphformatcontrols}', "");
    Expect(1, 78944, '\p{^Blk=egyptianhieroglyphformatcontrols}', "");
    Expect(1, 78944, '\P{Blk=egyptianhieroglyphformatcontrols}', "");
    Expect(0, 78944, '\P{^Blk=egyptianhieroglyphformatcontrols}', "");
    Expect(1, 78943, '\p{Blk=:\Aegyptianhieroglyphformatcontrols\z:}', "");;
    Expect(0, 78944, '\p{Blk=:\Aegyptianhieroglyphformatcontrols\z:}', "");;
    Expect(1, 78943, '\p{Blk=__EGYPTIAN_HIEROGLYPH_Format_controls}', "");
    Expect(0, 78943, '\p{^Blk=__EGYPTIAN_HIEROGLYPH_Format_controls}', "");
    Expect(0, 78943, '\P{Blk=__EGYPTIAN_HIEROGLYPH_Format_controls}', "");
    Expect(1, 78943, '\P{^Blk=__EGYPTIAN_HIEROGLYPH_Format_controls}', "");
    Expect(0, 78944, '\p{Blk=__EGYPTIAN_HIEROGLYPH_Format_controls}', "");
    Expect(1, 78944, '\p{^Blk=__EGYPTIAN_HIEROGLYPH_Format_controls}', "");
    Expect(1, 78944, '\P{Blk=__EGYPTIAN_HIEROGLYPH_Format_controls}', "");
    Expect(0, 78944, '\P{^Blk=__EGYPTIAN_HIEROGLYPH_Format_controls}', "");
    Error('\p{Is_Block=:=egyptian_Hieroglyph_format_Controls}');
    Error('\P{Is_Block=:=egyptian_Hieroglyph_format_Controls}');
    Expect(1, 78943, '\p{Is_Block=egyptianhieroglyphformatcontrols}', "");
    Expect(0, 78943, '\p{^Is_Block=egyptianhieroglyphformatcontrols}', "");
    Expect(0, 78943, '\P{Is_Block=egyptianhieroglyphformatcontrols}', "");
    Expect(1, 78943, '\P{^Is_Block=egyptianhieroglyphformatcontrols}', "");
    Expect(0, 78944, '\p{Is_Block=egyptianhieroglyphformatcontrols}', "");
    Expect(1, 78944, '\p{^Is_Block=egyptianhieroglyphformatcontrols}', "");
    Expect(1, 78944, '\P{Is_Block=egyptianhieroglyphformatcontrols}', "");
    Expect(0, 78944, '\P{^Is_Block=egyptianhieroglyphformatcontrols}', "");
    Expect(1, 78943, '\p{Is_Block=Egyptian_hieroglyph_FORMAT_CONTROLS}', "");
    Expect(0, 78943, '\p{^Is_Block=Egyptian_hieroglyph_FORMAT_CONTROLS}', "");
    Expect(0, 78943, '\P{Is_Block=Egyptian_hieroglyph_FORMAT_CONTROLS}', "");
    Expect(1, 78943, '\P{^Is_Block=Egyptian_hieroglyph_FORMAT_CONTROLS}', "");
    Expect(0, 78944, '\p{Is_Block=Egyptian_hieroglyph_FORMAT_CONTROLS}', "");
    Expect(1, 78944, '\p{^Is_Block=Egyptian_hieroglyph_FORMAT_CONTROLS}', "");
    Expect(1, 78944, '\P{Is_Block=Egyptian_hieroglyph_FORMAT_CONTROLS}', "");
    Expect(0, 78944, '\P{^Is_Block=Egyptian_hieroglyph_FORMAT_CONTROLS}', "");
    Error('\p{Is_Blk=:=_egyptian_hieroglyph_Format_Controls}');
    Error('\P{Is_Blk=:=_egyptian_hieroglyph_Format_Controls}');
    Expect(1, 78943, '\p{Is_Blk=egyptianhieroglyphformatcontrols}', "");
    Expect(0, 78943, '\p{^Is_Blk=egyptianhieroglyphformatcontrols}', "");
    Expect(0, 78943, '\P{Is_Blk=egyptianhieroglyphformatcontrols}', "");
    Expect(1, 78943, '\P{^Is_Blk=egyptianhieroglyphformatcontrols}', "");
    Expect(0, 78944, '\p{Is_Blk=egyptianhieroglyphformatcontrols}', "");
    Expect(1, 78944, '\p{^Is_Blk=egyptianhieroglyphformatcontrols}', "");
    Expect(1, 78944, '\P{Is_Blk=egyptianhieroglyphformatcontrols}', "");
    Expect(0, 78944, '\P{^Is_Blk=egyptianhieroglyphformatcontrols}', "");
    Expect(1, 78943, '\p{Is_Blk=	egyptian_HIEROGLYPH_Format_CONTROLS}', "");
    Expect(0, 78943, '\p{^Is_Blk=	egyptian_HIEROGLYPH_Format_CONTROLS}', "");
    Expect(0, 78943, '\P{Is_Blk=	egyptian_HIEROGLYPH_Format_CONTROLS}', "");
    Expect(1, 78943, '\P{^Is_Blk=	egyptian_HIEROGLYPH_Format_CONTROLS}', "");
    Expect(0, 78944, '\p{Is_Blk=	egyptian_HIEROGLYPH_Format_CONTROLS}', "");
    Expect(1, 78944, '\p{^Is_Blk=	egyptian_HIEROGLYPH_Format_CONTROLS}', "");
    Expect(1, 78944, '\P{Is_Blk=	egyptian_HIEROGLYPH_Format_CONTROLS}', "");
    Expect(0, 78944, '\P{^Is_Blk=	egyptian_HIEROGLYPH_Format_CONTROLS}', "");
    Error('\p{Block=/a/Egyptian_hieroglyphs}');
    Error('\P{Block=/a/Egyptian_hieroglyphs}');
    Expect(1, 78895, '\p{Block=:\AEgyptian_Hieroglyphs\z:}', "");;
    Expect(0, 78896, '\p{Block=:\AEgyptian_Hieroglyphs\z:}', "");;
    Expect(1, 78895, '\p{Block=egyptianhieroglyphs}', "");
    Expect(0, 78895, '\p{^Block=egyptianhieroglyphs}', "");
    Expect(0, 78895, '\P{Block=egyptianhieroglyphs}', "");
    Expect(1, 78895, '\P{^Block=egyptianhieroglyphs}', "");
    Expect(0, 78896, '\p{Block=egyptianhieroglyphs}', "");
    Expect(1, 78896, '\p{^Block=egyptianhieroglyphs}', "");
    Expect(1, 78896, '\P{Block=egyptianhieroglyphs}', "");
    Expect(0, 78896, '\P{^Block=egyptianhieroglyphs}', "");
    Expect(1, 78895, '\p{Block=:\Aegyptianhieroglyphs\z:}', "");;
    Expect(0, 78896, '\p{Block=:\Aegyptianhieroglyphs\z:}', "");;
    Expect(1, 78895, '\p{Block=_Egyptian_HIEROGLYPHS}', "");
    Expect(0, 78895, '\p{^Block=_Egyptian_HIEROGLYPHS}', "");
    Expect(0, 78895, '\P{Block=_Egyptian_HIEROGLYPHS}', "");
    Expect(1, 78895, '\P{^Block=_Egyptian_HIEROGLYPHS}', "");
    Expect(0, 78896, '\p{Block=_Egyptian_HIEROGLYPHS}', "");
    Expect(1, 78896, '\p{^Block=_Egyptian_HIEROGLYPHS}', "");
    Expect(1, 78896, '\P{Block=_Egyptian_HIEROGLYPHS}', "");
    Expect(0, 78896, '\P{^Block=_Egyptian_HIEROGLYPHS}', "");
    Error('\p{Blk=/a/		EGYPTIAN_hieroglyphs}');
    Error('\P{Blk=/a/		EGYPTIAN_hieroglyphs}');
    Expect(1, 78895, '\p{Blk=:\AEgyptian_Hieroglyphs\z:}', "");;
    Expect(0, 78896, '\p{Blk=:\AEgyptian_Hieroglyphs\z:}', "");;
    Expect(1, 78895, '\p{Blk=egyptianhieroglyphs}', "");
    Expect(0, 78895, '\p{^Blk=egyptianhieroglyphs}', "");
    Expect(0, 78895, '\P{Blk=egyptianhieroglyphs}', "");
    Expect(1, 78895, '\P{^Blk=egyptianhieroglyphs}', "");
    Expect(0, 78896, '\p{Blk=egyptianhieroglyphs}', "");
    Expect(1, 78896, '\p{^Blk=egyptianhieroglyphs}', "");
    Expect(1, 78896, '\P{Blk=egyptianhieroglyphs}', "");
    Expect(0, 78896, '\P{^Blk=egyptianhieroglyphs}', "");
    Expect(1, 78895, '\p{Blk=:\Aegyptianhieroglyphs\z:}', "");;
    Expect(0, 78896, '\p{Blk=:\Aegyptianhieroglyphs\z:}', "");;
    Expect(1, 78895, '\p{Blk=_	Egyptian_hieroglyphs}', "");
    Expect(0, 78895, '\p{^Blk=_	Egyptian_hieroglyphs}', "");
    Expect(0, 78895, '\P{Blk=_	Egyptian_hieroglyphs}', "");
    Expect(1, 78895, '\P{^Blk=_	Egyptian_hieroglyphs}', "");
    Expect(0, 78896, '\p{Blk=_	Egyptian_hieroglyphs}', "");
    Expect(1, 78896, '\p{^Blk=_	Egyptian_hieroglyphs}', "");
    Expect(1, 78896, '\P{Blk=_	Egyptian_hieroglyphs}', "");
    Expect(0, 78896, '\P{^Blk=_	Egyptian_hieroglyphs}', "");
    Error('\p{Is_Block=-	Egyptian_HIEROGLYPHS:=}');
    Error('\P{Is_Block=-	Egyptian_HIEROGLYPHS:=}');
    Expect(1, 78895, '\p{Is_Block=egyptianhieroglyphs}', "");
    Expect(0, 78895, '\p{^Is_Block=egyptianhieroglyphs}', "");
    Expect(0, 78895, '\P{Is_Block=egyptianhieroglyphs}', "");
    Expect(1, 78895, '\P{^Is_Block=egyptianhieroglyphs}', "");
    Expect(0, 78896, '\p{Is_Block=egyptianhieroglyphs}', "");
    Expect(1, 78896, '\p{^Is_Block=egyptianhieroglyphs}', "");
    Expect(1, 78896, '\P{Is_Block=egyptianhieroglyphs}', "");
    Expect(0, 78896, '\P{^Is_Block=egyptianhieroglyphs}', "");
    Expect(1, 78895, '\p{Is_Block=_	EGYPTIAN_hieroglyphs}', "");
    Expect(0, 78895, '\p{^Is_Block=_	EGYPTIAN_hieroglyphs}', "");
    Expect(0, 78895, '\P{Is_Block=_	EGYPTIAN_hieroglyphs}', "");
    Expect(1, 78895, '\P{^Is_Block=_	EGYPTIAN_hieroglyphs}', "");
    Expect(0, 78896, '\p{Is_Block=_	EGYPTIAN_hieroglyphs}', "");
    Expect(1, 78896, '\p{^Is_Block=_	EGYPTIAN_hieroglyphs}', "");
    Expect(1, 78896, '\P{Is_Block=_	EGYPTIAN_hieroglyphs}', "");
    Expect(0, 78896, '\P{^Is_Block=_	EGYPTIAN_hieroglyphs}', "");
    Error('\p{Is_Blk=-/a/egyptian_Hieroglyphs}');
    Error('\P{Is_Blk=-/a/egyptian_Hieroglyphs}');
    Expect(1, 78895, '\p{Is_Blk=egyptianhieroglyphs}', "");
    Expect(0, 78895, '\p{^Is_Blk=egyptianhieroglyphs}', "");
    Expect(0, 78895, '\P{Is_Blk=egyptianhieroglyphs}', "");
    Expect(1, 78895, '\P{^Is_Blk=egyptianhieroglyphs}', "");
    Expect(0, 78896, '\p{Is_Blk=egyptianhieroglyphs}', "");
    Expect(1, 78896, '\p{^Is_Blk=egyptianhieroglyphs}', "");
    Expect(1, 78896, '\P{Is_Blk=egyptianhieroglyphs}', "");
    Expect(0, 78896, '\P{^Is_Blk=egyptianhieroglyphs}', "");
    Expect(1, 78895, '\p{Is_Blk=--Egyptian_Hieroglyphs}', "");
    Expect(0, 78895, '\p{^Is_Blk=--Egyptian_Hieroglyphs}', "");
    Expect(0, 78895, '\P{Is_Blk=--Egyptian_Hieroglyphs}', "");
    Expect(1, 78895, '\P{^Is_Blk=--Egyptian_Hieroglyphs}', "");
    Expect(0, 78896, '\p{Is_Blk=--Egyptian_Hieroglyphs}', "");
    Expect(1, 78896, '\p{^Is_Blk=--Egyptian_Hieroglyphs}', "");
    Expect(1, 78896, '\P{Is_Blk=--Egyptian_Hieroglyphs}', "");
    Expect(0, 78896, '\P{^Is_Blk=--Egyptian_Hieroglyphs}', "");
    Error('\p{Block=_-elbasan:=}');
    Error('\P{Block=_-elbasan:=}');
    Expect(1, 66863, '\p{Block=:\AElbasan\z:}', "");;
    Expect(0, 66864, '\p{Block=:\AElbasan\z:}', "");;
    Expect(1, 66863, '\p{Block=elbasan}', "");
    Expect(0, 66863, '\p{^Block=elbasan}', "");
    Expect(0, 66863, '\P{Block=elbasan}', "");
    Expect(1, 66863, '\P{^Block=elbasan}', "");
    Expect(0, 66864, '\p{Block=elbasan}', "");
    Expect(1, 66864, '\p{^Block=elbasan}', "");
    Expect(1, 66864, '\P{Block=elbasan}', "");
    Expect(0, 66864, '\P{^Block=elbasan}', "");
    Expect(1, 66863, '\p{Block=:\Aelbasan\z:}', "");;
    Expect(0, 66864, '\p{Block=:\Aelbasan\z:}', "");;
    Expect(1, 66863, '\p{Block=--Elbasan}', "");
    Expect(0, 66863, '\p{^Block=--Elbasan}', "");
    Expect(0, 66863, '\P{Block=--Elbasan}', "");
    Expect(1, 66863, '\P{^Block=--Elbasan}', "");
    Expect(0, 66864, '\p{Block=--Elbasan}', "");
    Expect(1, 66864, '\p{^Block=--Elbasan}', "");
    Expect(1, 66864, '\P{Block=--Elbasan}', "");
    Expect(0, 66864, '\P{^Block=--Elbasan}', "");
    Error('\p{Blk=/a/	 Elbasan}');
    Error('\P{Blk=/a/	 Elbasan}');
    Expect(1, 66863, '\p{Blk=:\AElbasan\z:}', "");;
    Expect(0, 66864, '\p{Blk=:\AElbasan\z:}', "");;
    Expect(1, 66863, '\p{Blk=elbasan}', "");
    Expect(0, 66863, '\p{^Blk=elbasan}', "");
    Expect(0, 66863, '\P{Blk=elbasan}', "");
    Expect(1, 66863, '\P{^Blk=elbasan}', "");
    Expect(0, 66864, '\p{Blk=elbasan}', "");
    Expect(1, 66864, '\p{^Blk=elbasan}', "");
    Expect(1, 66864, '\P{Blk=elbasan}', "");
    Expect(0, 66864, '\P{^Blk=elbasan}', "");
    Expect(1, 66863, '\p{Blk=:\Aelbasan\z:}', "");;
    Expect(0, 66864, '\p{Blk=:\Aelbasan\z:}', "");;
    Expect(1, 66863, '\p{Blk= 	Elbasan}', "");
    Expect(0, 66863, '\p{^Blk= 	Elbasan}', "");
    Expect(0, 66863, '\P{Blk= 	Elbasan}', "");
    Expect(1, 66863, '\P{^Blk= 	Elbasan}', "");
    Expect(0, 66864, '\p{Blk= 	Elbasan}', "");
    Expect(1, 66864, '\p{^Blk= 	Elbasan}', "");
    Expect(1, 66864, '\P{Blk= 	Elbasan}', "");
    Expect(0, 66864, '\P{^Blk= 	Elbasan}', "");
    Error('\p{Is_Block=:=-	elbasan}');
    Error('\P{Is_Block=:=-	elbasan}');
    Expect(1, 66863, '\p{Is_Block=elbasan}', "");
    Expect(0, 66863, '\p{^Is_Block=elbasan}', "");
    Expect(0, 66863, '\P{Is_Block=elbasan}', "");
    Expect(1, 66863, '\P{^Is_Block=elbasan}', "");
    Expect(0, 66864, '\p{Is_Block=elbasan}', "");
    Expect(1, 66864, '\p{^Is_Block=elbasan}', "");
    Expect(1, 66864, '\P{Is_Block=elbasan}', "");
    Expect(0, 66864, '\P{^Is_Block=elbasan}', "");
    Expect(1, 66863, '\p{Is_Block:   -Elbasan}', "");
    Expect(0, 66863, '\p{^Is_Block:   -Elbasan}', "");
    Expect(0, 66863, '\P{Is_Block:   -Elbasan}', "");
    Expect(1, 66863, '\P{^Is_Block:   -Elbasan}', "");
    Expect(0, 66864, '\p{Is_Block:   -Elbasan}', "");
    Expect(1, 66864, '\p{^Is_Block:   -Elbasan}', "");
    Expect(1, 66864, '\P{Is_Block:   -Elbasan}', "");
    Expect(0, 66864, '\P{^Is_Block:   -Elbasan}', "");
    Error('\p{Is_Blk=:= -elbasan}');
    Error('\P{Is_Blk=:= -elbasan}');
    Expect(1, 66863, '\p{Is_Blk=elbasan}', "");
    Expect(0, 66863, '\p{^Is_Blk=elbasan}', "");
    Expect(0, 66863, '\P{Is_Blk=elbasan}', "");
    Expect(1, 66863, '\P{^Is_Blk=elbasan}', "");
    Expect(0, 66864, '\p{Is_Blk=elbasan}', "");
    Expect(1, 66864, '\p{^Is_Blk=elbasan}', "");
    Expect(1, 66864, '\P{Is_Blk=elbasan}', "");
    Expect(0, 66864, '\P{^Is_Blk=elbasan}', "");
    Expect(1, 66863, '\p{Is_Blk:   -elbasan}', "");
    Expect(0, 66863, '\p{^Is_Blk:   -elbasan}', "");
    Expect(0, 66863, '\P{Is_Blk:   -elbasan}', "");
    Expect(1, 66863, '\P{^Is_Blk:   -elbasan}', "");
    Expect(0, 66864, '\p{Is_Blk:   -elbasan}', "");
    Expect(1, 66864, '\p{^Is_Blk:   -elbasan}', "");
    Expect(1, 66864, '\P{Is_Blk:   -elbasan}', "");
    Expect(0, 66864, '\P{^Is_Blk:   -elbasan}', "");
    Error('\p{Block=:= ELYMAIC}');
    Error('\P{Block=:= ELYMAIC}');
    Expect(1, 69631, '\p{Block=:\AElymaic\z:}', "");;
    Expect(0, 69632, '\p{Block=:\AElymaic\z:}', "");;
    Expect(1, 69631, '\p{Block=elymaic}', "");
    Expect(0, 69631, '\p{^Block=elymaic}', "");
    Expect(0, 69631, '\P{Block=elymaic}', "");
    Expect(1, 69631, '\P{^Block=elymaic}', "");
    Expect(0, 69632, '\p{Block=elymaic}', "");
    Expect(1, 69632, '\p{^Block=elymaic}', "");
    Expect(1, 69632, '\P{Block=elymaic}', "");
    Expect(0, 69632, '\P{^Block=elymaic}', "");
    Expect(1, 69631, '\p{Block=:\Aelymaic\z:}', "");;
    Expect(0, 69632, '\p{Block=:\Aelymaic\z:}', "");;
    Expect(1, 69631, '\p{Block: -	Elymaic}', "");
    Expect(0, 69631, '\p{^Block: -	Elymaic}', "");
    Expect(0, 69631, '\P{Block: -	Elymaic}', "");
    Expect(1, 69631, '\P{^Block: -	Elymaic}', "");
    Expect(0, 69632, '\p{Block: -	Elymaic}', "");
    Expect(1, 69632, '\p{^Block: -	Elymaic}', "");
    Expect(1, 69632, '\P{Block: -	Elymaic}', "");
    Expect(0, 69632, '\P{^Block: -	Elymaic}', "");
    Error('\p{Blk= :=elymaic}');
    Error('\P{Blk= :=elymaic}');
    Expect(1, 69631, '\p{Blk=:\AElymaic\z:}', "");;
    Expect(0, 69632, '\p{Blk=:\AElymaic\z:}', "");;
    Expect(1, 69631, '\p{Blk=elymaic}', "");
    Expect(0, 69631, '\p{^Blk=elymaic}', "");
    Expect(0, 69631, '\P{Blk=elymaic}', "");
    Expect(1, 69631, '\P{^Blk=elymaic}', "");
    Expect(0, 69632, '\p{Blk=elymaic}', "");
    Expect(1, 69632, '\p{^Blk=elymaic}', "");
    Expect(1, 69632, '\P{Blk=elymaic}', "");
    Expect(0, 69632, '\P{^Blk=elymaic}', "");
    Expect(1, 69631, '\p{Blk=:\Aelymaic\z:}', "");;
    Expect(0, 69632, '\p{Blk=:\Aelymaic\z:}', "");;
    Expect(1, 69631, '\p{Blk=	Elymaic}', "");
    Expect(0, 69631, '\p{^Blk=	Elymaic}', "");
    Expect(0, 69631, '\P{Blk=	Elymaic}', "");
    Expect(1, 69631, '\P{^Blk=	Elymaic}', "");
    Expect(0, 69632, '\p{Blk=	Elymaic}', "");
    Expect(1, 69632, '\p{^Blk=	Elymaic}', "");
    Expect(1, 69632, '\P{Blk=	Elymaic}', "");
    Expect(0, 69632, '\P{^Blk=	Elymaic}', "");
    Error('\p{Is_Block= Elymaic:=}');
    Error('\P{Is_Block= Elymaic:=}');
    Expect(1, 69631, '\p{Is_Block:elymaic}', "");
    Expect(0, 69631, '\p{^Is_Block:elymaic}', "");
    Expect(0, 69631, '\P{Is_Block:elymaic}', "");
    Expect(1, 69631, '\P{^Is_Block:elymaic}', "");
    Expect(0, 69632, '\p{Is_Block:elymaic}', "");
    Expect(1, 69632, '\p{^Is_Block:elymaic}', "");
    Expect(1, 69632, '\P{Is_Block:elymaic}', "");
    Expect(0, 69632, '\P{^Is_Block:elymaic}', "");
    Expect(1, 69631, '\p{Is_Block=-_ELYMAIC}', "");
    Expect(0, 69631, '\p{^Is_Block=-_ELYMAIC}', "");
    Expect(0, 69631, '\P{Is_Block=-_ELYMAIC}', "");
    Expect(1, 69631, '\P{^Is_Block=-_ELYMAIC}', "");
    Expect(0, 69632, '\p{Is_Block=-_ELYMAIC}', "");
    Expect(1, 69632, '\p{^Is_Block=-_ELYMAIC}', "");
    Expect(1, 69632, '\P{Is_Block=-_ELYMAIC}', "");
    Expect(0, 69632, '\P{^Is_Block=-_ELYMAIC}', "");
    Error('\p{Is_Blk=/a/Elymaic}');
    Error('\P{Is_Blk=/a/Elymaic}');
    Expect(1, 69631, '\p{Is_Blk=elymaic}', "");
    Expect(0, 69631, '\p{^Is_Blk=elymaic}', "");
    Expect(0, 69631, '\P{Is_Blk=elymaic}', "");
    Expect(1, 69631, '\P{^Is_Blk=elymaic}', "");
    Expect(0, 69632, '\p{Is_Blk=elymaic}', "");
    Expect(1, 69632, '\p{^Is_Blk=elymaic}', "");
    Expect(1, 69632, '\P{Is_Blk=elymaic}', "");
    Expect(0, 69632, '\P{^Is_Blk=elymaic}', "");
    Expect(1, 69631, '\p{Is_Blk= -elymaic}', "");
    Expect(0, 69631, '\p{^Is_Blk= -elymaic}', "");
    Expect(0, 69631, '\P{Is_Blk= -elymaic}', "");
    Expect(1, 69631, '\P{^Is_Blk= -elymaic}', "");
    Expect(0, 69632, '\p{Is_Blk= -elymaic}', "");
    Expect(1, 69632, '\p{^Is_Blk= -elymaic}', "");
    Expect(1, 69632, '\P{Is_Blk= -elymaic}', "");
    Expect(0, 69632, '\P{^Is_Blk= -elymaic}', "");
    Error('\p{Block=:=__EMOTICONS}');
    Error('\P{Block=:=__EMOTICONS}');
    Expect(1, 128591, '\p{Block=:\AEmoticons\z:}', "");;
    Expect(0, 128592, '\p{Block=:\AEmoticons\z:}', "");;
    Expect(1, 128591, '\p{Block=emoticons}', "");
    Expect(0, 128591, '\p{^Block=emoticons}', "");
    Expect(0, 128591, '\P{Block=emoticons}', "");
    Expect(1, 128591, '\P{^Block=emoticons}', "");
    Expect(0, 128592, '\p{Block=emoticons}', "");
    Expect(1, 128592, '\p{^Block=emoticons}', "");
    Expect(1, 128592, '\P{Block=emoticons}', "");
    Expect(0, 128592, '\P{^Block=emoticons}', "");
    Expect(1, 128591, '\p{Block=:\Aemoticons\z:}', "");;
    Expect(0, 128592, '\p{Block=:\Aemoticons\z:}', "");;
    Expect(1, 128591, '\p{Block= emoticons}', "");
    Expect(0, 128591, '\p{^Block= emoticons}', "");
    Expect(0, 128591, '\P{Block= emoticons}', "");
    Expect(1, 128591, '\P{^Block= emoticons}', "");
    Expect(0, 128592, '\p{Block= emoticons}', "");
    Expect(1, 128592, '\p{^Block= emoticons}', "");
    Expect(1, 128592, '\P{Block= emoticons}', "");
    Expect(0, 128592, '\P{^Block= emoticons}', "");
    Error('\p{Blk=:=_ emoticons}');
    Error('\P{Blk=:=_ emoticons}');
    Expect(1, 128591, '\p{Blk=:\AEmoticons\z:}', "");;
    Expect(0, 128592, '\p{Blk=:\AEmoticons\z:}', "");;
    Expect(1, 128591, '\p{Blk:emoticons}', "");
    Expect(0, 128591, '\p{^Blk:emoticons}', "");
    Expect(0, 128591, '\P{Blk:emoticons}', "");
    Expect(1, 128591, '\P{^Blk:emoticons}', "");
    Expect(0, 128592, '\p{Blk:emoticons}', "");
    Expect(1, 128592, '\p{^Blk:emoticons}', "");
    Expect(1, 128592, '\P{Blk:emoticons}', "");
    Expect(0, 128592, '\P{^Blk:emoticons}', "");
    Expect(1, 128591, '\p{Blk=:\Aemoticons\z:}', "");;
    Expect(0, 128592, '\p{Blk=:\Aemoticons\z:}', "");;
    Expect(1, 128591, '\p{Blk=	emoticons}', "");
    Expect(0, 128591, '\p{^Blk=	emoticons}', "");
    Expect(0, 128591, '\P{Blk=	emoticons}', "");
    Expect(1, 128591, '\P{^Blk=	emoticons}', "");
    Expect(0, 128592, '\p{Blk=	emoticons}', "");
    Expect(1, 128592, '\p{^Blk=	emoticons}', "");
    Expect(1, 128592, '\P{Blk=	emoticons}', "");
    Expect(0, 128592, '\P{^Blk=	emoticons}', "");
    Error('\p{Is_Block=-/a/Emoticons}');
    Error('\P{Is_Block=-/a/Emoticons}');
    Expect(1, 128591, '\p{Is_Block=emoticons}', "");
    Expect(0, 128591, '\p{^Is_Block=emoticons}', "");
    Expect(0, 128591, '\P{Is_Block=emoticons}', "");
    Expect(1, 128591, '\P{^Is_Block=emoticons}', "");
    Expect(0, 128592, '\p{Is_Block=emoticons}', "");
    Expect(1, 128592, '\p{^Is_Block=emoticons}', "");
    Expect(1, 128592, '\P{Is_Block=emoticons}', "");
    Expect(0, 128592, '\P{^Is_Block=emoticons}', "");
    Expect(1, 128591, '\p{Is_Block=  EMOTICONS}', "");
    Expect(0, 128591, '\p{^Is_Block=  EMOTICONS}', "");
    Expect(0, 128591, '\P{Is_Block=  EMOTICONS}', "");
    Expect(1, 128591, '\P{^Is_Block=  EMOTICONS}', "");
    Expect(0, 128592, '\p{Is_Block=  EMOTICONS}', "");
    Expect(1, 128592, '\p{^Is_Block=  EMOTICONS}', "");
    Expect(1, 128592, '\P{Is_Block=  EMOTICONS}', "");
    Expect(0, 128592, '\P{^Is_Block=  EMOTICONS}', "");
    Error('\p{Is_Blk=	:=Emoticons}');
    Error('\P{Is_Blk=	:=Emoticons}');
    Expect(1, 128591, '\p{Is_Blk=emoticons}', "");
    Expect(0, 128591, '\p{^Is_Blk=emoticons}', "");
    Expect(0, 128591, '\P{Is_Blk=emoticons}', "");
    Expect(1, 128591, '\P{^Is_Blk=emoticons}', "");
    Expect(0, 128592, '\p{Is_Blk=emoticons}', "");
    Expect(1, 128592, '\p{^Is_Blk=emoticons}', "");
    Expect(1, 128592, '\P{Is_Blk=emoticons}', "");
    Expect(0, 128592, '\P{^Is_Blk=emoticons}', "");
    Expect(1, 128591, '\p{Is_Blk=	EMOTICONS}', "");
    Expect(0, 128591, '\p{^Is_Blk=	EMOTICONS}', "");
    Expect(0, 128591, '\P{Is_Blk=	EMOTICONS}', "");
    Expect(1, 128591, '\P{^Is_Blk=	EMOTICONS}', "");
    Expect(0, 128592, '\p{Is_Blk=	EMOTICONS}', "");
    Expect(1, 128592, '\p{^Is_Blk=	EMOTICONS}', "");
    Expect(1, 128592, '\P{Is_Blk=	EMOTICONS}', "");
    Expect(0, 128592, '\P{^Is_Blk=	EMOTICONS}', "");
    Error('\p{Block: /a/ Enclosed_Alphanumerics}');
    Error('\P{Block: /a/ Enclosed_Alphanumerics}');
    Expect(1, 9471, '\p{Block=:\AEnclosed_Alphanumerics\z:}', "");;
    Expect(0, 9472, '\p{Block=:\AEnclosed_Alphanumerics\z:}', "");;
    Expect(1, 9471, '\p{Block=enclosedalphanumerics}', "");
    Expect(0, 9471, '\p{^Block=enclosedalphanumerics}', "");
    Expect(0, 9471, '\P{Block=enclosedalphanumerics}', "");
    Expect(1, 9471, '\P{^Block=enclosedalphanumerics}', "");
    Expect(0, 9472, '\p{Block=enclosedalphanumerics}', "");
    Expect(1, 9472, '\p{^Block=enclosedalphanumerics}', "");
    Expect(1, 9472, '\P{Block=enclosedalphanumerics}', "");
    Expect(0, 9472, '\P{^Block=enclosedalphanumerics}', "");
    Expect(1, 9471, '\p{Block=:\Aenclosedalphanumerics\z:}', "");;
    Expect(0, 9472, '\p{Block=:\Aenclosedalphanumerics\z:}', "");;
    Expect(1, 9471, '\p{Block=- Enclosed_alphanumerics}', "");
    Expect(0, 9471, '\p{^Block=- Enclosed_alphanumerics}', "");
    Expect(0, 9471, '\P{Block=- Enclosed_alphanumerics}', "");
    Expect(1, 9471, '\P{^Block=- Enclosed_alphanumerics}', "");
    Expect(0, 9472, '\p{Block=- Enclosed_alphanumerics}', "");
    Expect(1, 9472, '\p{^Block=- Enclosed_alphanumerics}', "");
    Expect(1, 9472, '\P{Block=- Enclosed_alphanumerics}', "");
    Expect(0, 9472, '\P{^Block=- Enclosed_alphanumerics}', "");
    Error('\p{Blk=:=_ENCLOSED_ALPHANUM}');
    Error('\P{Blk=:=_ENCLOSED_ALPHANUM}');
    Expect(1, 9471, '\p{Blk=:\AEnclosed_Alphanum\z:}', "");;
    Expect(0, 9472, '\p{Blk=:\AEnclosed_Alphanum\z:}', "");;
    Expect(1, 9471, '\p{Blk=enclosedalphanum}', "");
    Expect(0, 9471, '\p{^Blk=enclosedalphanum}', "");
    Expect(0, 9471, '\P{Blk=enclosedalphanum}', "");
    Expect(1, 9471, '\P{^Blk=enclosedalphanum}', "");
    Expect(0, 9472, '\p{Blk=enclosedalphanum}', "");
    Expect(1, 9472, '\p{^Blk=enclosedalphanum}', "");
    Expect(1, 9472, '\P{Blk=enclosedalphanum}', "");
    Expect(0, 9472, '\P{^Blk=enclosedalphanum}', "");
    Expect(1, 9471, '\p{Blk=:\Aenclosedalphanum\z:}', "");;
    Expect(0, 9472, '\p{Blk=:\Aenclosedalphanum\z:}', "");;
    Expect(1, 9471, '\p{Blk=__enclosed_Alphanum}', "");
    Expect(0, 9471, '\p{^Blk=__enclosed_Alphanum}', "");
    Expect(0, 9471, '\P{Blk=__enclosed_Alphanum}', "");
    Expect(1, 9471, '\P{^Blk=__enclosed_Alphanum}', "");
    Expect(0, 9472, '\p{Blk=__enclosed_Alphanum}', "");
    Expect(1, 9472, '\p{^Blk=__enclosed_Alphanum}', "");
    Expect(1, 9472, '\P{Blk=__enclosed_Alphanum}', "");
    Expect(0, 9472, '\P{^Blk=__enclosed_Alphanum}', "");
    Error('\p{Is_Block=:= Enclosed_Alphanumerics}');
    Error('\P{Is_Block=:= Enclosed_Alphanumerics}');
    Expect(1, 9471, '\p{Is_Block=enclosedalphanumerics}', "");
    Expect(0, 9471, '\p{^Is_Block=enclosedalphanumerics}', "");
    Expect(0, 9471, '\P{Is_Block=enclosedalphanumerics}', "");
    Expect(1, 9471, '\P{^Is_Block=enclosedalphanumerics}', "");
    Expect(0, 9472, '\p{Is_Block=enclosedalphanumerics}', "");
    Expect(1, 9472, '\p{^Is_Block=enclosedalphanumerics}', "");
    Expect(1, 9472, '\P{Is_Block=enclosedalphanumerics}', "");
    Expect(0, 9472, '\P{^Is_Block=enclosedalphanumerics}', "");
    Expect(1, 9471, '\p{Is_Block= Enclosed_Alphanumerics}', "");
    Expect(0, 9471, '\p{^Is_Block= Enclosed_Alphanumerics}', "");
    Expect(0, 9471, '\P{Is_Block= Enclosed_Alphanumerics}', "");
    Expect(1, 9471, '\P{^Is_Block= Enclosed_Alphanumerics}', "");
    Expect(0, 9472, '\p{Is_Block= Enclosed_Alphanumerics}', "");
    Expect(1, 9472, '\p{^Is_Block= Enclosed_Alphanumerics}', "");
    Expect(1, 9472, '\P{Is_Block= Enclosed_Alphanumerics}', "");
    Expect(0, 9472, '\P{^Is_Block= Enclosed_Alphanumerics}', "");
    Error('\p{Is_Blk=-/a/enclosed_Alphanum}');
    Error('\P{Is_Blk=-/a/enclosed_Alphanum}');
    Expect(1, 9471, '\p{Is_Blk=enclosedalphanum}', "");
    Expect(0, 9471, '\p{^Is_Blk=enclosedalphanum}', "");
    Expect(0, 9471, '\P{Is_Blk=enclosedalphanum}', "");
    Expect(1, 9471, '\P{^Is_Blk=enclosedalphanum}', "");
    Expect(0, 9472, '\p{Is_Blk=enclosedalphanum}', "");
    Expect(1, 9472, '\p{^Is_Blk=enclosedalphanum}', "");
    Expect(1, 9472, '\P{Is_Blk=enclosedalphanum}', "");
    Expect(0, 9472, '\P{^Is_Blk=enclosedalphanum}', "");
    Expect(1, 9471, '\p{Is_Blk= _Enclosed_ALPHANUM}', "");
    Expect(0, 9471, '\p{^Is_Blk= _Enclosed_ALPHANUM}', "");
    Expect(0, 9471, '\P{Is_Blk= _Enclosed_ALPHANUM}', "");
    Expect(1, 9471, '\P{^Is_Blk= _Enclosed_ALPHANUM}', "");
    Expect(0, 9472, '\p{Is_Blk= _Enclosed_ALPHANUM}', "");
    Expect(1, 9472, '\p{^Is_Blk= _Enclosed_ALPHANUM}', "");
    Expect(1, 9472, '\P{Is_Blk= _Enclosed_ALPHANUM}', "");
    Expect(0, 9472, '\P{^Is_Blk= _Enclosed_ALPHANUM}', "");
    Error('\p{Block=/a/_Enclosed_ALPHANUMERIC_Supplement}');
    Error('\P{Block=/a/_Enclosed_ALPHANUMERIC_Supplement}');
    Expect(1, 127487, '\p{Block=:\AEnclosed_Alphanumeric_Supplement\z:}', "");;
    Expect(0, 127488, '\p{Block=:\AEnclosed_Alphanumeric_Supplement\z:}', "");;
    Expect(1, 127487, '\p{Block=enclosedalphanumericsupplement}', "");
    Expect(0, 127487, '\p{^Block=enclosedalphanumericsupplement}', "");
    Expect(0, 127487, '\P{Block=enclosedalphanumericsupplement}', "");
    Expect(1, 127487, '\P{^Block=enclosedalphanumericsupplement}', "");
    Expect(0, 127488, '\p{Block=enclosedalphanumericsupplement}', "");
    Expect(1, 127488, '\p{^Block=enclosedalphanumericsupplement}', "");
    Expect(1, 127488, '\P{Block=enclosedalphanumericsupplement}', "");
    Expect(0, 127488, '\P{^Block=enclosedalphanumericsupplement}', "");
    Expect(1, 127487, '\p{Block=:\Aenclosedalphanumericsupplement\z:}', "");;
    Expect(0, 127488, '\p{Block=:\Aenclosedalphanumericsupplement\z:}', "");;
    Expect(1, 127487, '\p{Block:		 Enclosed_Alphanumeric_Supplement}', "");
    Expect(0, 127487, '\p{^Block:		 Enclosed_Alphanumeric_Supplement}', "");
    Expect(0, 127487, '\P{Block:		 Enclosed_Alphanumeric_Supplement}', "");
    Expect(1, 127487, '\P{^Block:		 Enclosed_Alphanumeric_Supplement}', "");
    Expect(0, 127488, '\p{Block:		 Enclosed_Alphanumeric_Supplement}', "");
    Expect(1, 127488, '\p{^Block:		 Enclosed_Alphanumeric_Supplement}', "");
    Expect(1, 127488, '\P{Block:		 Enclosed_Alphanumeric_Supplement}', "");
    Expect(0, 127488, '\P{^Block:		 Enclosed_Alphanumeric_Supplement}', "");
    Error('\p{Blk=_ENCLOSED_ALPHANUM_Sup/a/}');
    Error('\P{Blk=_ENCLOSED_ALPHANUM_Sup/a/}');
    Expect(1, 127487, '\p{Blk=:\AEnclosed_Alphanum_Sup\z:}', "");;
    Expect(0, 127488, '\p{Blk=:\AEnclosed_Alphanum_Sup\z:}', "");;
    Expect(1, 127487, '\p{Blk=enclosedalphanumsup}', "");
    Expect(0, 127487, '\p{^Blk=enclosedalphanumsup}', "");
    Expect(0, 127487, '\P{Blk=enclosedalphanumsup}', "");
    Expect(1, 127487, '\P{^Blk=enclosedalphanumsup}', "");
    Expect(0, 127488, '\p{Blk=enclosedalphanumsup}', "");
    Expect(1, 127488, '\p{^Blk=enclosedalphanumsup}', "");
    Expect(1, 127488, '\P{Blk=enclosedalphanumsup}', "");
    Expect(0, 127488, '\P{^Blk=enclosedalphanumsup}', "");
    Expect(1, 127487, '\p{Blk=:\Aenclosedalphanumsup\z:}', "");;
    Expect(0, 127488, '\p{Blk=:\Aenclosedalphanumsup\z:}', "");;
    Expect(1, 127487, '\p{Blk=	 enclosed_Alphanum_Sup}', "");
    Expect(0, 127487, '\p{^Blk=	 enclosed_Alphanum_Sup}', "");
    Expect(0, 127487, '\P{Blk=	 enclosed_Alphanum_Sup}', "");
    Expect(1, 127487, '\P{^Blk=	 enclosed_Alphanum_Sup}', "");
    Expect(0, 127488, '\p{Blk=	 enclosed_Alphanum_Sup}', "");
    Expect(1, 127488, '\p{^Blk=	 enclosed_Alphanum_Sup}', "");
    Expect(1, 127488, '\P{Blk=	 enclosed_Alphanum_Sup}', "");
    Expect(0, 127488, '\P{^Blk=	 enclosed_Alphanum_Sup}', "");
    Error('\p{Is_Block:	/a/-	ENCLOSED_alphanumeric_Supplement}');
    Error('\P{Is_Block:	/a/-	ENCLOSED_alphanumeric_Supplement}');
    Expect(1, 127487, '\p{Is_Block=enclosedalphanumericsupplement}', "");
    Expect(0, 127487, '\p{^Is_Block=enclosedalphanumericsupplement}', "");
    Expect(0, 127487, '\P{Is_Block=enclosedalphanumericsupplement}', "");
    Expect(1, 127487, '\P{^Is_Block=enclosedalphanumericsupplement}', "");
    Expect(0, 127488, '\p{Is_Block=enclosedalphanumericsupplement}', "");
    Expect(1, 127488, '\p{^Is_Block=enclosedalphanumericsupplement}', "");
    Expect(1, 127488, '\P{Is_Block=enclosedalphanumericsupplement}', "");
    Expect(0, 127488, '\P{^Is_Block=enclosedalphanumericsupplement}', "");
    Expect(1, 127487, '\p{Is_Block= -Enclosed_alphanumeric_Supplement}', "");
    Expect(0, 127487, '\p{^Is_Block= -Enclosed_alphanumeric_Supplement}', "");
    Expect(0, 127487, '\P{Is_Block= -Enclosed_alphanumeric_Supplement}', "");
    Expect(1, 127487, '\P{^Is_Block= -Enclosed_alphanumeric_Supplement}', "");
    Expect(0, 127488, '\p{Is_Block= -Enclosed_alphanumeric_Supplement}', "");
    Expect(1, 127488, '\p{^Is_Block= -Enclosed_alphanumeric_Supplement}', "");
    Expect(1, 127488, '\P{Is_Block= -Enclosed_alphanumeric_Supplement}', "");
    Expect(0, 127488, '\P{^Is_Block= -Enclosed_alphanumeric_Supplement}', "");
    Error('\p{Is_Blk=:=  ENCLOSED_Alphanum_SUP}');
    Error('\P{Is_Blk=:=  ENCLOSED_Alphanum_SUP}');
    Expect(1, 127487, '\p{Is_Blk=enclosedalphanumsup}', "");
    Expect(0, 127487, '\p{^Is_Blk=enclosedalphanumsup}', "");
    Expect(0, 127487, '\P{Is_Blk=enclosedalphanumsup}', "");
    Expect(1, 127487, '\P{^Is_Blk=enclosedalphanumsup}', "");
    Expect(0, 127488, '\p{Is_Blk=enclosedalphanumsup}', "");
    Expect(1, 127488, '\p{^Is_Blk=enclosedalphanumsup}', "");
    Expect(1, 127488, '\P{Is_Blk=enclosedalphanumsup}', "");
    Expect(0, 127488, '\P{^Is_Blk=enclosedalphanumsup}', "");
    Expect(1, 127487, '\p{Is_Blk=_ ENCLOSED_alphanum_Sup}', "");
    Expect(0, 127487, '\p{^Is_Blk=_ ENCLOSED_alphanum_Sup}', "");
    Expect(0, 127487, '\P{Is_Blk=_ ENCLOSED_alphanum_Sup}', "");
    Expect(1, 127487, '\P{^Is_Blk=_ ENCLOSED_alphanum_Sup}', "");
    Expect(0, 127488, '\p{Is_Blk=_ ENCLOSED_alphanum_Sup}', "");
    Expect(1, 127488, '\p{^Is_Blk=_ ENCLOSED_alphanum_Sup}', "");
    Expect(1, 127488, '\P{Is_Blk=_ ENCLOSED_alphanum_Sup}', "");
    Expect(0, 127488, '\P{^Is_Blk=_ ENCLOSED_alphanum_Sup}', "");
    Error('\p{Block=	Enclosed_CJK_Letters_And_Months:=}');
    Error('\P{Block=	Enclosed_CJK_Letters_And_Months:=}');
    Expect(1, 13055, '\p{Block=:\AEnclosed_CJK_Letters_And_Months\z:}', "");;
    Expect(0, 13056, '\p{Block=:\AEnclosed_CJK_Letters_And_Months\z:}', "");;
    Expect(1, 13055, '\p{Block=enclosedcjklettersandmonths}', "");
    Expect(0, 13055, '\p{^Block=enclosedcjklettersandmonths}', "");
    Expect(0, 13055, '\P{Block=enclosedcjklettersandmonths}', "");
    Expect(1, 13055, '\P{^Block=enclosedcjklettersandmonths}', "");
    Expect(0, 13056, '\p{Block=enclosedcjklettersandmonths}', "");
    Expect(1, 13056, '\p{^Block=enclosedcjklettersandmonths}', "");
    Expect(1, 13056, '\P{Block=enclosedcjklettersandmonths}', "");
    Expect(0, 13056, '\P{^Block=enclosedcjklettersandmonths}', "");
    Expect(1, 13055, '\p{Block=:\Aenclosedcjklettersandmonths\z:}', "");;
    Expect(0, 13056, '\p{Block=:\Aenclosedcjklettersandmonths\z:}', "");;
    Expect(1, 13055, '\p{Block=  enclosed_CJK_LETTERS_And_Months}', "");
    Expect(0, 13055, '\p{^Block=  enclosed_CJK_LETTERS_And_Months}', "");
    Expect(0, 13055, '\P{Block=  enclosed_CJK_LETTERS_And_Months}', "");
    Expect(1, 13055, '\P{^Block=  enclosed_CJK_LETTERS_And_Months}', "");
    Expect(0, 13056, '\p{Block=  enclosed_CJK_LETTERS_And_Months}', "");
    Expect(1, 13056, '\p{^Block=  enclosed_CJK_LETTERS_And_Months}', "");
    Expect(1, 13056, '\P{Block=  enclosed_CJK_LETTERS_And_Months}', "");
    Expect(0, 13056, '\P{^Block=  enclosed_CJK_LETTERS_And_Months}', "");
    Error('\p{Blk=-_Enclosed_CJK:=}');
    Error('\P{Blk=-_Enclosed_CJK:=}');
    Expect(1, 13055, '\p{Blk=:\AEnclosed_CJK\z:}', "");;
    Expect(0, 13056, '\p{Blk=:\AEnclosed_CJK\z:}', "");;
    Expect(1, 13055, '\p{Blk=enclosedcjk}', "");
    Expect(0, 13055, '\p{^Blk=enclosedcjk}', "");
    Expect(0, 13055, '\P{Blk=enclosedcjk}', "");
    Expect(1, 13055, '\P{^Blk=enclosedcjk}', "");
    Expect(0, 13056, '\p{Blk=enclosedcjk}', "");
    Expect(1, 13056, '\p{^Blk=enclosedcjk}', "");
    Expect(1, 13056, '\P{Blk=enclosedcjk}', "");
    Expect(0, 13056, '\P{^Blk=enclosedcjk}', "");
    Expect(1, 13055, '\p{Blk=:\Aenclosedcjk\z:}', "");;
    Expect(0, 13056, '\p{Blk=:\Aenclosedcjk\z:}', "");;
    Expect(1, 13055, '\p{Blk= -enclosed_cjk}', "");
    Expect(0, 13055, '\p{^Blk= -enclosed_cjk}', "");
    Expect(0, 13055, '\P{Blk= -enclosed_cjk}', "");
    Expect(1, 13055, '\P{^Blk= -enclosed_cjk}', "");
    Expect(0, 13056, '\p{Blk= -enclosed_cjk}', "");
    Expect(1, 13056, '\p{^Blk= -enclosed_cjk}', "");
    Expect(1, 13056, '\P{Blk= -enclosed_cjk}', "");
    Expect(0, 13056, '\P{^Blk= -enclosed_cjk}', "");
    Error('\p{Is_Block=:=-Enclosed_cjk_letters_And_Months}');
    Error('\P{Is_Block=:=-Enclosed_cjk_letters_And_Months}');
    Expect(1, 13055, '\p{Is_Block=enclosedcjklettersandmonths}', "");
    Expect(0, 13055, '\p{^Is_Block=enclosedcjklettersandmonths}', "");
    Expect(0, 13055, '\P{Is_Block=enclosedcjklettersandmonths}', "");
    Expect(1, 13055, '\P{^Is_Block=enclosedcjklettersandmonths}', "");
    Expect(0, 13056, '\p{Is_Block=enclosedcjklettersandmonths}', "");
    Expect(1, 13056, '\p{^Is_Block=enclosedcjklettersandmonths}', "");
    Expect(1, 13056, '\P{Is_Block=enclosedcjklettersandmonths}', "");
    Expect(0, 13056, '\P{^Is_Block=enclosedcjklettersandmonths}', "");
    Expect(1, 13055, '\p{Is_Block=-Enclosed_CJK_LETTERS_And_Months}', "");
    Expect(0, 13055, '\p{^Is_Block=-Enclosed_CJK_LETTERS_And_Months}', "");
    Expect(0, 13055, '\P{Is_Block=-Enclosed_CJK_LETTERS_And_Months}', "");
    Expect(1, 13055, '\P{^Is_Block=-Enclosed_CJK_LETTERS_And_Months}', "");
    Expect(0, 13056, '\p{Is_Block=-Enclosed_CJK_LETTERS_And_Months}', "");
    Expect(1, 13056, '\p{^Is_Block=-Enclosed_CJK_LETTERS_And_Months}', "");
    Expect(1, 13056, '\P{Is_Block=-Enclosed_CJK_LETTERS_And_Months}', "");
    Expect(0, 13056, '\P{^Is_Block=-Enclosed_CJK_LETTERS_And_Months}', "");
    Error('\p{Is_Blk=__Enclosed_CJK/a/}');
    Error('\P{Is_Blk=__Enclosed_CJK/a/}');
    Expect(1, 13055, '\p{Is_Blk=enclosedcjk}', "");
    Expect(0, 13055, '\p{^Is_Blk=enclosedcjk}', "");
    Expect(0, 13055, '\P{Is_Blk=enclosedcjk}', "");
    Expect(1, 13055, '\P{^Is_Blk=enclosedcjk}', "");
    Expect(0, 13056, '\p{Is_Blk=enclosedcjk}', "");
    Expect(1, 13056, '\p{^Is_Blk=enclosedcjk}', "");
    Expect(1, 13056, '\P{Is_Blk=enclosedcjk}', "");
    Expect(0, 13056, '\P{^Is_Blk=enclosedcjk}', "");
    Expect(1, 13055, '\p{Is_Blk=		Enclosed_CJK}', "");
    Expect(0, 13055, '\p{^Is_Blk=		Enclosed_CJK}', "");
    Expect(0, 13055, '\P{Is_Blk=		Enclosed_CJK}', "");
    Expect(1, 13055, '\P{^Is_Blk=		Enclosed_CJK}', "");
    Expect(0, 13056, '\p{Is_Blk=		Enclosed_CJK}', "");
    Expect(1, 13056, '\p{^Is_Blk=		Enclosed_CJK}', "");
    Expect(1, 13056, '\P{Is_Blk=		Enclosed_CJK}', "");
    Expect(0, 13056, '\P{^Is_Blk=		Enclosed_CJK}', "");
    Error('\p{Block=	/a/Enclosed_Ideographic_Supplement}');
    Error('\P{Block=	/a/Enclosed_Ideographic_Supplement}');
    Expect(1, 127743, '\p{Block=:\AEnclosed_Ideographic_Supplement\z:}', "");;
    Expect(0, 127744, '\p{Block=:\AEnclosed_Ideographic_Supplement\z:}', "");;
    Expect(1, 127743, '\p{Block=enclosedideographicsupplement}', "");
    Expect(0, 127743, '\p{^Block=enclosedideographicsupplement}', "");
    Expect(0, 127743, '\P{Block=enclosedideographicsupplement}', "");
    Expect(1, 127743, '\P{^Block=enclosedideographicsupplement}', "");
    Expect(0, 127744, '\p{Block=enclosedideographicsupplement}', "");
    Expect(1, 127744, '\p{^Block=enclosedideographicsupplement}', "");
    Expect(1, 127744, '\P{Block=enclosedideographicsupplement}', "");
    Expect(0, 127744, '\P{^Block=enclosedideographicsupplement}', "");
    Expect(1, 127743, '\p{Block=:\Aenclosedideographicsupplement\z:}', "");;
    Expect(0, 127744, '\p{Block=:\Aenclosedideographicsupplement\z:}', "");;
    Expect(1, 127743, '\p{Block=_Enclosed_IDEOGRAPHIC_Supplement}', "");
    Expect(0, 127743, '\p{^Block=_Enclosed_IDEOGRAPHIC_Supplement}', "");
    Expect(0, 127743, '\P{Block=_Enclosed_IDEOGRAPHIC_Supplement}', "");
    Expect(1, 127743, '\P{^Block=_Enclosed_IDEOGRAPHIC_Supplement}', "");
    Expect(0, 127744, '\p{Block=_Enclosed_IDEOGRAPHIC_Supplement}', "");
    Expect(1, 127744, '\p{^Block=_Enclosed_IDEOGRAPHIC_Supplement}', "");
    Expect(1, 127744, '\P{Block=_Enclosed_IDEOGRAPHIC_Supplement}', "");
    Expect(0, 127744, '\P{^Block=_Enclosed_IDEOGRAPHIC_Supplement}', "");
    Error('\p{Blk=_ENCLOSED_ideographic_Sup/a/}');
    Error('\P{Blk=_ENCLOSED_ideographic_Sup/a/}');
    Expect(1, 127743, '\p{Blk=:\AEnclosed_Ideographic_Sup\z:}', "");;
    Expect(0, 127744, '\p{Blk=:\AEnclosed_Ideographic_Sup\z:}', "");;
    Expect(1, 127743, '\p{Blk:enclosedideographicsup}', "");
    Expect(0, 127743, '\p{^Blk:enclosedideographicsup}', "");
    Expect(0, 127743, '\P{Blk:enclosedideographicsup}', "");
    Expect(1, 127743, '\P{^Blk:enclosedideographicsup}', "");
    Expect(0, 127744, '\p{Blk:enclosedideographicsup}', "");
    Expect(1, 127744, '\p{^Blk:enclosedideographicsup}', "");
    Expect(1, 127744, '\P{Blk:enclosedideographicsup}', "");
    Expect(0, 127744, '\P{^Blk:enclosedideographicsup}', "");
    Expect(1, 127743, '\p{Blk=:\Aenclosedideographicsup\z:}', "");;
    Expect(0, 127744, '\p{Blk=:\Aenclosedideographicsup\z:}', "");;
    Expect(1, 127743, '\p{Blk=- Enclosed_ideographic_SUP}', "");
    Expect(0, 127743, '\p{^Blk=- Enclosed_ideographic_SUP}', "");
    Expect(0, 127743, '\P{Blk=- Enclosed_ideographic_SUP}', "");
    Expect(1, 127743, '\P{^Blk=- Enclosed_ideographic_SUP}', "");
    Expect(0, 127744, '\p{Blk=- Enclosed_ideographic_SUP}', "");
    Expect(1, 127744, '\p{^Blk=- Enclosed_ideographic_SUP}', "");
    Expect(1, 127744, '\P{Blk=- Enclosed_ideographic_SUP}', "");
    Expect(0, 127744, '\P{^Blk=- Enclosed_ideographic_SUP}', "");
    Error('\p{Is_Block=_Enclosed_IDEOGRAPHIC_supplement:=}');
    Error('\P{Is_Block=_Enclosed_IDEOGRAPHIC_supplement:=}');
    Expect(1, 127743, '\p{Is_Block=enclosedideographicsupplement}', "");
    Expect(0, 127743, '\p{^Is_Block=enclosedideographicsupplement}', "");
    Expect(0, 127743, '\P{Is_Block=enclosedideographicsupplement}', "");
    Expect(1, 127743, '\P{^Is_Block=enclosedideographicsupplement}', "");
    Expect(0, 127744, '\p{Is_Block=enclosedideographicsupplement}', "");
    Expect(1, 127744, '\p{^Is_Block=enclosedideographicsupplement}', "");
    Expect(1, 127744, '\P{Is_Block=enclosedideographicsupplement}', "");
    Expect(0, 127744, '\P{^Is_Block=enclosedideographicsupplement}', "");
    Expect(1, 127743, '\p{Is_Block=-ENCLOSED_Ideographic_Supplement}', "");
    Expect(0, 127743, '\p{^Is_Block=-ENCLOSED_Ideographic_Supplement}', "");
    Expect(0, 127743, '\P{Is_Block=-ENCLOSED_Ideographic_Supplement}', "");
    Expect(1, 127743, '\P{^Is_Block=-ENCLOSED_Ideographic_Supplement}', "");
    Expect(0, 127744, '\p{Is_Block=-ENCLOSED_Ideographic_Supplement}', "");
    Expect(1, 127744, '\p{^Is_Block=-ENCLOSED_Ideographic_Supplement}', "");
    Expect(1, 127744, '\P{Is_Block=-ENCLOSED_Ideographic_Supplement}', "");
    Expect(0, 127744, '\P{^Is_Block=-ENCLOSED_Ideographic_Supplement}', "");
    Error('\p{Is_Blk=/a/-enclosed_Ideographic_Sup}');
    Error('\P{Is_Blk=/a/-enclosed_Ideographic_Sup}');
    Expect(1, 127743, '\p{Is_Blk=enclosedideographicsup}', "");
    Expect(0, 127743, '\p{^Is_Blk=enclosedideographicsup}', "");
    Expect(0, 127743, '\P{Is_Blk=enclosedideographicsup}', "");
    Expect(1, 127743, '\P{^Is_Blk=enclosedideographicsup}', "");
    Expect(0, 127744, '\p{Is_Blk=enclosedideographicsup}', "");
    Expect(1, 127744, '\p{^Is_Blk=enclosedideographicsup}', "");
    Expect(1, 127744, '\P{Is_Blk=enclosedideographicsup}', "");
    Expect(0, 127744, '\P{^Is_Blk=enclosedideographicsup}', "");
    Expect(1, 127743, '\p{Is_Blk=_	Enclosed_Ideographic_sup}', "");
    Expect(0, 127743, '\p{^Is_Blk=_	Enclosed_Ideographic_sup}', "");
    Expect(0, 127743, '\P{Is_Blk=_	Enclosed_Ideographic_sup}', "");
    Expect(1, 127743, '\P{^Is_Blk=_	Enclosed_Ideographic_sup}', "");
    Expect(0, 127744, '\p{Is_Blk=_	Enclosed_Ideographic_sup}', "");
    Expect(1, 127744, '\p{^Is_Blk=_	Enclosed_Ideographic_sup}', "");
    Expect(1, 127744, '\P{Is_Blk=_	Enclosed_Ideographic_sup}', "");
    Expect(0, 127744, '\P{^Is_Blk=_	Enclosed_Ideographic_sup}', "");
    Error('\p{Block=-ETHIOPIC/a/}');
    Error('\P{Block=-ETHIOPIC/a/}');
    Expect(1, 4991, '\p{Block=:\AEthiopic\z:}', "");;
    Expect(0, 4992, '\p{Block=:\AEthiopic\z:}', "");;
    Expect(1, 4991, '\p{Block=ethiopic}', "");
    Expect(0, 4991, '\p{^Block=ethiopic}', "");
    Expect(0, 4991, '\P{Block=ethiopic}', "");
    Expect(1, 4991, '\P{^Block=ethiopic}', "");
    Expect(0, 4992, '\p{Block=ethiopic}', "");
    Expect(1, 4992, '\p{^Block=ethiopic}', "");
    Expect(1, 4992, '\P{Block=ethiopic}', "");
    Expect(0, 4992, '\P{^Block=ethiopic}', "");
    Expect(1, 4991, '\p{Block=:\Aethiopic\z:}', "");;
    Expect(0, 4992, '\p{Block=:\Aethiopic\z:}', "");;
    Expect(1, 4991, '\p{Block= Ethiopic}', "");
    Expect(0, 4991, '\p{^Block= Ethiopic}', "");
    Expect(0, 4991, '\P{Block= Ethiopic}', "");
    Expect(1, 4991, '\P{^Block= Ethiopic}', "");
    Expect(0, 4992, '\p{Block= Ethiopic}', "");
    Expect(1, 4992, '\p{^Block= Ethiopic}', "");
    Expect(1, 4992, '\P{Block= Ethiopic}', "");
    Expect(0, 4992, '\P{^Block= Ethiopic}', "");
    Error('\p{Blk=/a/-_Ethiopic}');
    Error('\P{Blk=/a/-_Ethiopic}');
    Expect(1, 4991, '\p{Blk=:\AEthiopic\z:}', "");;
    Expect(0, 4992, '\p{Blk=:\AEthiopic\z:}', "");;
    Expect(1, 4991, '\p{Blk=ethiopic}', "");
    Expect(0, 4991, '\p{^Blk=ethiopic}', "");
    Expect(0, 4991, '\P{Blk=ethiopic}', "");
    Expect(1, 4991, '\P{^Blk=ethiopic}', "");
    Expect(0, 4992, '\p{Blk=ethiopic}', "");
    Expect(1, 4992, '\p{^Blk=ethiopic}', "");
    Expect(1, 4992, '\P{Blk=ethiopic}', "");
    Expect(0, 4992, '\P{^Blk=ethiopic}', "");
    Expect(1, 4991, '\p{Blk=:\Aethiopic\z:}', "");;
    Expect(0, 4992, '\p{Blk=:\Aethiopic\z:}', "");;
    Expect(1, 4991, '\p{Blk=_ Ethiopic}', "");
    Expect(0, 4991, '\p{^Blk=_ Ethiopic}', "");
    Expect(0, 4991, '\P{Blk=_ Ethiopic}', "");
    Expect(1, 4991, '\P{^Blk=_ Ethiopic}', "");
    Expect(0, 4992, '\p{Blk=_ Ethiopic}', "");
    Expect(1, 4992, '\p{^Blk=_ Ethiopic}', "");
    Expect(1, 4992, '\P{Blk=_ Ethiopic}', "");
    Expect(0, 4992, '\P{^Blk=_ Ethiopic}', "");
    Error('\p{Is_Block=_Ethiopic/a/}');
    Error('\P{Is_Block=_Ethiopic/a/}');
    Expect(1, 4991, '\p{Is_Block=ethiopic}', "");
    Expect(0, 4991, '\p{^Is_Block=ethiopic}', "");
    Expect(0, 4991, '\P{Is_Block=ethiopic}', "");
    Expect(1, 4991, '\P{^Is_Block=ethiopic}', "");
    Expect(0, 4992, '\p{Is_Block=ethiopic}', "");
    Expect(1, 4992, '\p{^Is_Block=ethiopic}', "");
    Expect(1, 4992, '\P{Is_Block=ethiopic}', "");
    Expect(0, 4992, '\P{^Is_Block=ethiopic}', "");
    Expect(1, 4991, '\p{Is_Block=-_Ethiopic}', "");
    Expect(0, 4991, '\p{^Is_Block=-_Ethiopic}', "");
    Expect(0, 4991, '\P{Is_Block=-_Ethiopic}', "");
    Expect(1, 4991, '\P{^Is_Block=-_Ethiopic}', "");
    Expect(0, 4992, '\p{Is_Block=-_Ethiopic}', "");
    Expect(1, 4992, '\p{^Is_Block=-_Ethiopic}', "");
    Expect(1, 4992, '\P{Is_Block=-_Ethiopic}', "");
    Expect(0, 4992, '\P{^Is_Block=-_Ethiopic}', "");
    Error('\p{Is_Blk=	/a/Ethiopic}');
    Error('\P{Is_Blk=	/a/Ethiopic}');
    Expect(1, 4991, '\p{Is_Blk:	ethiopic}', "");
    Expect(0, 4991, '\p{^Is_Blk:	ethiopic}', "");
    Expect(0, 4991, '\P{Is_Blk:	ethiopic}', "");
    Expect(1, 4991, '\P{^Is_Blk:	ethiopic}', "");
    Expect(0, 4992, '\p{Is_Blk:	ethiopic}', "");
    Expect(1, 4992, '\p{^Is_Blk:	ethiopic}', "");
    Expect(1, 4992, '\P{Is_Blk:	ethiopic}', "");
    Expect(0, 4992, '\P{^Is_Blk:	ethiopic}', "");
    Expect(1, 4991, '\p{Is_Blk= Ethiopic}', "");
    Expect(0, 4991, '\p{^Is_Blk= Ethiopic}', "");
    Expect(0, 4991, '\P{Is_Blk= Ethiopic}', "");
    Expect(1, 4991, '\P{^Is_Blk= Ethiopic}', "");
    Expect(0, 4992, '\p{Is_Blk= Ethiopic}', "");
    Expect(1, 4992, '\p{^Is_Blk= Ethiopic}', "");
    Expect(1, 4992, '\P{Is_Blk= Ethiopic}', "");
    Expect(0, 4992, '\P{^Is_Blk= Ethiopic}', "");
    Error('\p{Block=  Ethiopic_Extended:=}');
    Error('\P{Block=  Ethiopic_Extended:=}');
    Expect(1, 11743, '\p{Block=:\AEthiopic_Extended\z:}', "");;
    Expect(0, 11744, '\p{Block=:\AEthiopic_Extended\z:}', "");;
    Expect(1, 11743, '\p{Block=ethiopicextended}', "");
    Expect(0, 11743, '\p{^Block=ethiopicextended}', "");
    Expect(0, 11743, '\P{Block=ethiopicextended}', "");
    Expect(1, 11743, '\P{^Block=ethiopicextended}', "");
    Expect(0, 11744, '\p{Block=ethiopicextended}', "");
    Expect(1, 11744, '\p{^Block=ethiopicextended}', "");
    Expect(1, 11744, '\P{Block=ethiopicextended}', "");
    Expect(0, 11744, '\P{^Block=ethiopicextended}', "");
    Expect(1, 11743, '\p{Block=:\Aethiopicextended\z:}', "");;
    Expect(0, 11744, '\p{Block=:\Aethiopicextended\z:}', "");;
    Expect(1, 11743, '\p{Block=_ethiopic_Extended}', "");
    Expect(0, 11743, '\p{^Block=_ethiopic_Extended}', "");
    Expect(0, 11743, '\P{Block=_ethiopic_Extended}', "");
    Expect(1, 11743, '\P{^Block=_ethiopic_Extended}', "");
    Expect(0, 11744, '\p{Block=_ethiopic_Extended}', "");
    Expect(1, 11744, '\p{^Block=_ethiopic_Extended}', "");
    Expect(1, 11744, '\P{Block=_ethiopic_Extended}', "");
    Expect(0, 11744, '\P{^Block=_ethiopic_Extended}', "");
    Error('\p{Blk= /a/ETHIOPIC_Ext}');
    Error('\P{Blk= /a/ETHIOPIC_Ext}');
    Expect(1, 11743, '\p{Blk=:\AEthiopic_Ext\z:}', "");;
    Expect(0, 11744, '\p{Blk=:\AEthiopic_Ext\z:}', "");;
    Expect(1, 11743, '\p{Blk=ethiopicext}', "");
    Expect(0, 11743, '\p{^Blk=ethiopicext}', "");
    Expect(0, 11743, '\P{Blk=ethiopicext}', "");
    Expect(1, 11743, '\P{^Blk=ethiopicext}', "");
    Expect(0, 11744, '\p{Blk=ethiopicext}', "");
    Expect(1, 11744, '\p{^Blk=ethiopicext}', "");
    Expect(1, 11744, '\P{Blk=ethiopicext}', "");
    Expect(0, 11744, '\P{^Blk=ethiopicext}', "");
    Expect(1, 11743, '\p{Blk=:\Aethiopicext\z:}', "");;
    Expect(0, 11744, '\p{Blk=:\Aethiopicext\z:}', "");;
    Expect(1, 11743, '\p{Blk=_ethiopic_Ext}', "");
    Expect(0, 11743, '\p{^Blk=_ethiopic_Ext}', "");
    Expect(0, 11743, '\P{Blk=_ethiopic_Ext}', "");
    Expect(1, 11743, '\P{^Blk=_ethiopic_Ext}', "");
    Expect(0, 11744, '\p{Blk=_ethiopic_Ext}', "");
    Expect(1, 11744, '\p{^Blk=_ethiopic_Ext}', "");
    Expect(1, 11744, '\P{Blk=_ethiopic_Ext}', "");
    Expect(0, 11744, '\P{^Blk=_ethiopic_Ext}', "");
    Error('\p{Is_Block=:=Ethiopic_extended}');
    Error('\P{Is_Block=:=Ethiopic_extended}');
    Expect(1, 11743, '\p{Is_Block=ethiopicextended}', "");
    Expect(0, 11743, '\p{^Is_Block=ethiopicextended}', "");
    Expect(0, 11743, '\P{Is_Block=ethiopicextended}', "");
    Expect(1, 11743, '\P{^Is_Block=ethiopicextended}', "");
    Expect(0, 11744, '\p{Is_Block=ethiopicextended}', "");
    Expect(1, 11744, '\p{^Is_Block=ethiopicextended}', "");
    Expect(1, 11744, '\P{Is_Block=ethiopicextended}', "");
    Expect(0, 11744, '\P{^Is_Block=ethiopicextended}', "");
    Expect(1, 11743, '\p{Is_Block: -ETHIOPIC_Extended}', "");
    Expect(0, 11743, '\p{^Is_Block: -ETHIOPIC_Extended}', "");
    Expect(0, 11743, '\P{Is_Block: -ETHIOPIC_Extended}', "");
    Expect(1, 11743, '\P{^Is_Block: -ETHIOPIC_Extended}', "");
    Expect(0, 11744, '\p{Is_Block: -ETHIOPIC_Extended}', "");
    Expect(1, 11744, '\p{^Is_Block: -ETHIOPIC_Extended}', "");
    Expect(1, 11744, '\P{Is_Block: -ETHIOPIC_Extended}', "");
    Expect(0, 11744, '\P{^Is_Block: -ETHIOPIC_Extended}', "");
    Error('\p{Is_Blk=/a/ 	ETHIOPIC_Ext}');
    Error('\P{Is_Blk=/a/ 	ETHIOPIC_Ext}');
    Expect(1, 11743, '\p{Is_Blk=ethiopicext}', "");
    Expect(0, 11743, '\p{^Is_Blk=ethiopicext}', "");
    Expect(0, 11743, '\P{Is_Blk=ethiopicext}', "");
    Expect(1, 11743, '\P{^Is_Blk=ethiopicext}', "");
    Expect(0, 11744, '\p{Is_Blk=ethiopicext}', "");
    Expect(1, 11744, '\p{^Is_Blk=ethiopicext}', "");
    Expect(1, 11744, '\P{Is_Blk=ethiopicext}', "");
    Expect(0, 11744, '\P{^Is_Blk=ethiopicext}', "");
    Expect(1, 11743, '\p{Is_Blk= -Ethiopic_EXT}', "");
    Expect(0, 11743, '\p{^Is_Blk= -Ethiopic_EXT}', "");
    Expect(0, 11743, '\P{Is_Blk= -Ethiopic_EXT}', "");
    Expect(1, 11743, '\P{^Is_Blk= -Ethiopic_EXT}', "");
    Expect(0, 11744, '\p{Is_Blk= -Ethiopic_EXT}', "");
    Expect(1, 11744, '\p{^Is_Blk= -Ethiopic_EXT}', "");
    Expect(1, 11744, '\P{Is_Blk= -Ethiopic_EXT}', "");
    Expect(0, 11744, '\P{^Is_Blk= -Ethiopic_EXT}', "");
    Error('\p{Block=/a/Ethiopic_Extended_a}');
    Error('\P{Block=/a/Ethiopic_Extended_a}');
    Expect(1, 43823, '\p{Block=:\AEthiopic_Extended_A\z:}', "");;
    Expect(0, 43824, '\p{Block=:\AEthiopic_Extended_A\z:}', "");;
    Expect(1, 43823, '\p{Block:	ethiopicextendeda}', "");
    Expect(0, 43823, '\p{^Block:	ethiopicextendeda}', "");
    Expect(0, 43823, '\P{Block:	ethiopicextendeda}', "");
    Expect(1, 43823, '\P{^Block:	ethiopicextendeda}', "");
    Expect(0, 43824, '\p{Block:	ethiopicextendeda}', "");
    Expect(1, 43824, '\p{^Block:	ethiopicextendeda}', "");
    Expect(1, 43824, '\P{Block:	ethiopicextendeda}', "");
    Expect(0, 43824, '\P{^Block:	ethiopicextendeda}', "");
    Expect(1, 43823, '\p{Block=:\Aethiopicextendeda\z:}', "");;
    Expect(0, 43824, '\p{Block=:\Aethiopicextendeda\z:}', "");;
    Expect(1, 43823, '\p{Block=	-ethiopic_Extended_A}', "");
    Expect(0, 43823, '\p{^Block=	-ethiopic_Extended_A}', "");
    Expect(0, 43823, '\P{Block=	-ethiopic_Extended_A}', "");
    Expect(1, 43823, '\P{^Block=	-ethiopic_Extended_A}', "");
    Expect(0, 43824, '\p{Block=	-ethiopic_Extended_A}', "");
    Expect(1, 43824, '\p{^Block=	-ethiopic_Extended_A}', "");
    Expect(1, 43824, '\P{Block=	-ethiopic_Extended_A}', "");
    Expect(0, 43824, '\P{^Block=	-ethiopic_Extended_A}', "");
    Error('\p{Blk:/a/_ ETHIOPIC_ext_A}');
    Error('\P{Blk:/a/_ ETHIOPIC_ext_A}');
    Expect(1, 43823, '\p{Blk=:\AEthiopic_Ext_A\z:}', "");;
    Expect(0, 43824, '\p{Blk=:\AEthiopic_Ext_A\z:}', "");;
    Expect(1, 43823, '\p{Blk=ethiopicexta}', "");
    Expect(0, 43823, '\p{^Blk=ethiopicexta}', "");
    Expect(0, 43823, '\P{Blk=ethiopicexta}', "");
    Expect(1, 43823, '\P{^Blk=ethiopicexta}', "");
    Expect(0, 43824, '\p{Blk=ethiopicexta}', "");
    Expect(1, 43824, '\p{^Blk=ethiopicexta}', "");
    Expect(1, 43824, '\P{Blk=ethiopicexta}', "");
    Expect(0, 43824, '\P{^Blk=ethiopicexta}', "");
    Expect(1, 43823, '\p{Blk=:\Aethiopicexta\z:}', "");;
    Expect(0, 43824, '\p{Blk=:\Aethiopicexta\z:}', "");;
    Expect(1, 43823, '\p{Blk:    ETHIOPIC_EXT_a}', "");
    Expect(0, 43823, '\p{^Blk:    ETHIOPIC_EXT_a}', "");
    Expect(0, 43823, '\P{Blk:    ETHIOPIC_EXT_a}', "");
    Expect(1, 43823, '\P{^Blk:    ETHIOPIC_EXT_a}', "");
    Expect(0, 43824, '\p{Blk:    ETHIOPIC_EXT_a}', "");
    Expect(1, 43824, '\p{^Blk:    ETHIOPIC_EXT_a}', "");
    Expect(1, 43824, '\P{Blk:    ETHIOPIC_EXT_a}', "");
    Expect(0, 43824, '\P{^Blk:    ETHIOPIC_EXT_a}', "");
    Error('\p{Is_Block:_/a/ETHIOPIC_EXTENDED_a}');
    Error('\P{Is_Block:_/a/ETHIOPIC_EXTENDED_a}');
    Expect(1, 43823, '\p{Is_Block=ethiopicextendeda}', "");
    Expect(0, 43823, '\p{^Is_Block=ethiopicextendeda}', "");
    Expect(0, 43823, '\P{Is_Block=ethiopicextendeda}', "");
    Expect(1, 43823, '\P{^Is_Block=ethiopicextendeda}', "");
    Expect(0, 43824, '\p{Is_Block=ethiopicextendeda}', "");
    Expect(1, 43824, '\p{^Is_Block=ethiopicextendeda}', "");
    Expect(1, 43824, '\P{Is_Block=ethiopicextendeda}', "");
    Expect(0, 43824, '\P{^Is_Block=ethiopicextendeda}', "");
    Expect(1, 43823, '\p{Is_Block=__ethiopic_extended_A}', "");
    Expect(0, 43823, '\p{^Is_Block=__ethiopic_extended_A}', "");
    Expect(0, 43823, '\P{Is_Block=__ethiopic_extended_A}', "");
    Expect(1, 43823, '\P{^Is_Block=__ethiopic_extended_A}', "");
    Expect(0, 43824, '\p{Is_Block=__ethiopic_extended_A}', "");
    Expect(1, 43824, '\p{^Is_Block=__ethiopic_extended_A}', "");
    Expect(1, 43824, '\P{Is_Block=__ethiopic_extended_A}', "");
    Expect(0, 43824, '\P{^Is_Block=__ethiopic_extended_A}', "");
    Error('\p{Is_Blk=	_ETHIOPIC_Ext_A/a/}');
    Error('\P{Is_Blk=	_ETHIOPIC_Ext_A/a/}');
    Expect(1, 43823, '\p{Is_Blk=ethiopicexta}', "");
    Expect(0, 43823, '\p{^Is_Blk=ethiopicexta}', "");
    Expect(0, 43823, '\P{Is_Blk=ethiopicexta}', "");
    Expect(1, 43823, '\P{^Is_Blk=ethiopicexta}', "");
    Expect(0, 43824, '\p{Is_Blk=ethiopicexta}', "");
    Expect(1, 43824, '\p{^Is_Blk=ethiopicexta}', "");
    Expect(1, 43824, '\P{Is_Blk=ethiopicexta}', "");
    Expect(0, 43824, '\P{^Is_Blk=ethiopicexta}', "");
    Expect(1, 43823, '\p{Is_Blk:    -Ethiopic_EXT_A}', "");
    Expect(0, 43823, '\p{^Is_Blk:    -Ethiopic_EXT_A}', "");
    Expect(0, 43823, '\P{Is_Blk:    -Ethiopic_EXT_A}', "");
    Expect(1, 43823, '\P{^Is_Blk:    -Ethiopic_EXT_A}', "");
    Expect(0, 43824, '\p{Is_Blk:    -Ethiopic_EXT_A}', "");
    Expect(1, 43824, '\p{^Is_Blk:    -Ethiopic_EXT_A}', "");
    Expect(1, 43824, '\P{Is_Blk:    -Ethiopic_EXT_A}', "");
    Expect(0, 43824, '\P{^Is_Blk:    -Ethiopic_EXT_A}', "");
    Error('\p{Block= Ethiopic_EXTENDED_b:=}');
    Error('\P{Block= Ethiopic_EXTENDED_b:=}');
    Expect(1, 124927, '\p{Block=:\AEthiopic_Extended_B\z:}', "");;
    Expect(0, 124928, '\p{Block=:\AEthiopic_Extended_B\z:}', "");;
    Expect(1, 124927, '\p{Block=ethiopicextendedb}', "");
    Expect(0, 124927, '\p{^Block=ethiopicextendedb}', "");
    Expect(0, 124927, '\P{Block=ethiopicextendedb}', "");
    Expect(1, 124927, '\P{^Block=ethiopicextendedb}', "");
    Expect(0, 124928, '\p{Block=ethiopicextendedb}', "");
    Expect(1, 124928, '\p{^Block=ethiopicextendedb}', "");
    Expect(1, 124928, '\P{Block=ethiopicextendedb}', "");
    Expect(0, 124928, '\P{^Block=ethiopicextendedb}', "");
    Expect(1, 124927, '\p{Block=:\Aethiopicextendedb\z:}', "");;
    Expect(0, 124928, '\p{Block=:\Aethiopicextendedb\z:}', "");;
    Expect(1, 124927, '\p{Block=Ethiopic_extended_b}', "");
    Expect(0, 124927, '\p{^Block=Ethiopic_extended_b}', "");
    Expect(0, 124927, '\P{Block=Ethiopic_extended_b}', "");
    Expect(1, 124927, '\P{^Block=Ethiopic_extended_b}', "");
    Expect(0, 124928, '\p{Block=Ethiopic_extended_b}', "");
    Expect(1, 124928, '\p{^Block=Ethiopic_extended_b}', "");
    Expect(1, 124928, '\P{Block=Ethiopic_extended_b}', "");
    Expect(0, 124928, '\P{^Block=Ethiopic_extended_b}', "");
    Error('\p{Blk=-:=Ethiopic_Ext_B}');
    Error('\P{Blk=-:=Ethiopic_Ext_B}');
    Expect(1, 124927, '\p{Blk=:\AEthiopic_Ext_B\z:}', "");;
    Expect(0, 124928, '\p{Blk=:\AEthiopic_Ext_B\z:}', "");;
    Expect(1, 124927, '\p{Blk=ethiopicextb}', "");
    Expect(0, 124927, '\p{^Blk=ethiopicextb}', "");
    Expect(0, 124927, '\P{Blk=ethiopicextb}', "");
    Expect(1, 124927, '\P{^Blk=ethiopicextb}', "");
    Expect(0, 124928, '\p{Blk=ethiopicextb}', "");
    Expect(1, 124928, '\p{^Blk=ethiopicextb}', "");
    Expect(1, 124928, '\P{Blk=ethiopicextb}', "");
    Expect(0, 124928, '\P{^Blk=ethiopicextb}', "");
    Expect(1, 124927, '\p{Blk=:\Aethiopicextb\z:}', "");;
    Expect(0, 124928, '\p{Blk=:\Aethiopicextb\z:}', "");;
    Expect(1, 124927, '\p{Blk=-ethiopic_Ext_b}', "");
    Expect(0, 124927, '\p{^Blk=-ethiopic_Ext_b}', "");
    Expect(0, 124927, '\P{Blk=-ethiopic_Ext_b}', "");
    Expect(1, 124927, '\P{^Blk=-ethiopic_Ext_b}', "");
    Expect(0, 124928, '\p{Blk=-ethiopic_Ext_b}', "");
    Expect(1, 124928, '\p{^Blk=-ethiopic_Ext_b}', "");
    Expect(1, 124928, '\P{Blk=-ethiopic_Ext_b}', "");
    Expect(0, 124928, '\P{^Blk=-ethiopic_Ext_b}', "");
    Error('\p{Is_Block=:=		Ethiopic_Extended_B}');
    Error('\P{Is_Block=:=		Ethiopic_Extended_B}');
    Expect(1, 124927, '\p{Is_Block=ethiopicextendedb}', "");
    Expect(0, 124927, '\p{^Is_Block=ethiopicextendedb}', "");
    Expect(0, 124927, '\P{Is_Block=ethiopicextendedb}', "");
    Expect(1, 124927, '\P{^Is_Block=ethiopicextendedb}', "");
    Expect(0, 124928, '\p{Is_Block=ethiopicextendedb}', "");
    Expect(1, 124928, '\p{^Is_Block=ethiopicextendedb}', "");
    Expect(1, 124928, '\P{Is_Block=ethiopicextendedb}', "");
    Expect(0, 124928, '\P{^Is_Block=ethiopicextendedb}', "");
    Expect(1, 124927, '\p{Is_Block=-	ETHIOPIC_Extended_B}', "");
    Expect(0, 124927, '\p{^Is_Block=-	ETHIOPIC_Extended_B}', "");
    Expect(0, 124927, '\P{Is_Block=-	ETHIOPIC_Extended_B}', "");
    Expect(1, 124927, '\P{^Is_Block=-	ETHIOPIC_Extended_B}', "");
    Expect(0, 124928, '\p{Is_Block=-	ETHIOPIC_Extended_B}', "");
    Expect(1, 124928, '\p{^Is_Block=-	ETHIOPIC_Extended_B}', "");
    Expect(1, 124928, '\P{Is_Block=-	ETHIOPIC_Extended_B}', "");
    Expect(0, 124928, '\P{^Is_Block=-	ETHIOPIC_Extended_B}', "");
    Error('\p{Is_Blk=/a/		ethiopic_ext_B}');
    Error('\P{Is_Blk=/a/		ethiopic_ext_B}');
    Expect(1, 124927, '\p{Is_Blk=ethiopicextb}', "");
    Expect(0, 124927, '\p{^Is_Blk=ethiopicextb}', "");
    Expect(0, 124927, '\P{Is_Blk=ethiopicextb}', "");
    Expect(1, 124927, '\P{^Is_Blk=ethiopicextb}', "");
    Expect(0, 124928, '\p{Is_Blk=ethiopicextb}', "");
    Expect(1, 124928, '\p{^Is_Blk=ethiopicextb}', "");
    Expect(1, 124928, '\P{Is_Blk=ethiopicextb}', "");
    Expect(0, 124928, '\P{^Is_Blk=ethiopicextb}', "");
    Expect(1, 124927, '\p{Is_Blk=__ethiopic_Ext_B}', "");
    Expect(0, 124927, '\p{^Is_Blk=__ethiopic_Ext_B}', "");
    Expect(0, 124927, '\P{Is_Blk=__ethiopic_Ext_B}', "");
    Expect(1, 124927, '\P{^Is_Blk=__ethiopic_Ext_B}', "");
    Expect(0, 124928, '\p{Is_Blk=__ethiopic_Ext_B}', "");
    Expect(1, 124928, '\p{^Is_Blk=__ethiopic_Ext_B}', "");
    Expect(1, 124928, '\P{Is_Blk=__ethiopic_Ext_B}', "");
    Expect(0, 124928, '\P{^Is_Blk=__ethiopic_Ext_B}', "");
    Error('\p{Block=_/a/ethiopic_Supplement}');
    Error('\P{Block=_/a/ethiopic_Supplement}');
    Expect(1, 5023, '\p{Block=:\AEthiopic_Supplement\z:}', "");;
    Expect(0, 5024, '\p{Block=:\AEthiopic_Supplement\z:}', "");;
    Expect(1, 5023, '\p{Block=ethiopicsupplement}', "");
    Expect(0, 5023, '\p{^Block=ethiopicsupplement}', "");
    Expect(0, 5023, '\P{Block=ethiopicsupplement}', "");
    Expect(1, 5023, '\P{^Block=ethiopicsupplement}', "");
    Expect(0, 5024, '\p{Block=ethiopicsupplement}', "");
    Expect(1, 5024, '\p{^Block=ethiopicsupplement}', "");
    Expect(1, 5024, '\P{Block=ethiopicsupplement}', "");
    Expect(0, 5024, '\P{^Block=ethiopicsupplement}', "");
    Expect(1, 5023, '\p{Block=:\Aethiopicsupplement\z:}', "");;
    Expect(0, 5024, '\p{Block=:\Aethiopicsupplement\z:}', "");;
    Expect(1, 5023, '\p{Block:   -ethiopic_supplement}', "");
    Expect(0, 5023, '\p{^Block:   -ethiopic_supplement}', "");
    Expect(0, 5023, '\P{Block:   -ethiopic_supplement}', "");
    Expect(1, 5023, '\P{^Block:   -ethiopic_supplement}', "");
    Expect(0, 5024, '\p{Block:   -ethiopic_supplement}', "");
    Expect(1, 5024, '\p{^Block:   -ethiopic_supplement}', "");
    Expect(1, 5024, '\P{Block:   -ethiopic_supplement}', "");
    Expect(0, 5024, '\P{^Block:   -ethiopic_supplement}', "");
    Error('\p{Blk=-Ethiopic_sup/a/}');
    Error('\P{Blk=-Ethiopic_sup/a/}');
    Expect(1, 5023, '\p{Blk=:\AEthiopic_Sup\z:}', "");;
    Expect(0, 5024, '\p{Blk=:\AEthiopic_Sup\z:}', "");;
    Expect(1, 5023, '\p{Blk=ethiopicsup}', "");
    Expect(0, 5023, '\p{^Blk=ethiopicsup}', "");
    Expect(0, 5023, '\P{Blk=ethiopicsup}', "");
    Expect(1, 5023, '\P{^Blk=ethiopicsup}', "");
    Expect(0, 5024, '\p{Blk=ethiopicsup}', "");
    Expect(1, 5024, '\p{^Blk=ethiopicsup}', "");
    Expect(1, 5024, '\P{Blk=ethiopicsup}', "");
    Expect(0, 5024, '\P{^Blk=ethiopicsup}', "");
    Expect(1, 5023, '\p{Blk=:\Aethiopicsup\z:}', "");;
    Expect(0, 5024, '\p{Blk=:\Aethiopicsup\z:}', "");;
    Expect(1, 5023, '\p{Blk=-ETHIOPIC_Sup}', "");
    Expect(0, 5023, '\p{^Blk=-ETHIOPIC_Sup}', "");
    Expect(0, 5023, '\P{Blk=-ETHIOPIC_Sup}', "");
    Expect(1, 5023, '\P{^Blk=-ETHIOPIC_Sup}', "");
    Expect(0, 5024, '\p{Blk=-ETHIOPIC_Sup}', "");
    Expect(1, 5024, '\p{^Blk=-ETHIOPIC_Sup}', "");
    Expect(1, 5024, '\P{Blk=-ETHIOPIC_Sup}', "");
    Expect(0, 5024, '\P{^Blk=-ETHIOPIC_Sup}', "");
    Error('\p{Is_Block=:=_	ETHIOPIC_Supplement}');
    Error('\P{Is_Block=:=_	ETHIOPIC_Supplement}');
    Expect(1, 5023, '\p{Is_Block=ethiopicsupplement}', "");
    Expect(0, 5023, '\p{^Is_Block=ethiopicsupplement}', "");
    Expect(0, 5023, '\P{Is_Block=ethiopicsupplement}', "");
    Expect(1, 5023, '\P{^Is_Block=ethiopicsupplement}', "");
    Expect(0, 5024, '\p{Is_Block=ethiopicsupplement}', "");
    Expect(1, 5024, '\p{^Is_Block=ethiopicsupplement}', "");
    Expect(1, 5024, '\P{Is_Block=ethiopicsupplement}', "");
    Expect(0, 5024, '\P{^Is_Block=ethiopicsupplement}', "");
    Expect(1, 5023, '\p{Is_Block= ethiopic_SUPPLEMENT}', "");
    Expect(0, 5023, '\p{^Is_Block= ethiopic_SUPPLEMENT}', "");
    Expect(0, 5023, '\P{Is_Block= ethiopic_SUPPLEMENT}', "");
    Expect(1, 5023, '\P{^Is_Block= ethiopic_SUPPLEMENT}', "");
    Expect(0, 5024, '\p{Is_Block= ethiopic_SUPPLEMENT}', "");
    Expect(1, 5024, '\p{^Is_Block= ethiopic_SUPPLEMENT}', "");
    Expect(1, 5024, '\P{Is_Block= ethiopic_SUPPLEMENT}', "");
    Expect(0, 5024, '\P{^Is_Block= ethiopic_SUPPLEMENT}', "");
    Error('\p{Is_Blk=/a/ ethiopic_Sup}');
    Error('\P{Is_Blk=/a/ ethiopic_Sup}');
    Expect(1, 5023, '\p{Is_Blk: ethiopicsup}', "");
    Expect(0, 5023, '\p{^Is_Blk: ethiopicsup}', "");
    Expect(0, 5023, '\P{Is_Blk: ethiopicsup}', "");
    Expect(1, 5023, '\P{^Is_Blk: ethiopicsup}', "");
    Expect(0, 5024, '\p{Is_Blk: ethiopicsup}', "");
    Expect(1, 5024, '\p{^Is_Blk: ethiopicsup}', "");
    Expect(1, 5024, '\P{Is_Blk: ethiopicsup}', "");
    Expect(0, 5024, '\P{^Is_Blk: ethiopicsup}', "");
    Expect(1, 5023, '\p{Is_Blk=_ETHIOPIC_Sup}', "");
    Expect(0, 5023, '\p{^Is_Blk=_ETHIOPIC_Sup}', "");
    Expect(0, 5023, '\P{Is_Blk=_ETHIOPIC_Sup}', "");
    Expect(1, 5023, '\P{^Is_Blk=_ETHIOPIC_Sup}', "");
    Expect(0, 5024, '\p{Is_Blk=_ETHIOPIC_Sup}', "");
    Expect(1, 5024, '\p{^Is_Blk=_ETHIOPIC_Sup}', "");
    Expect(1, 5024, '\P{Is_Blk=_ETHIOPIC_Sup}', "");
    Expect(0, 5024, '\P{^Is_Blk=_ETHIOPIC_Sup}', "");
    Error('\p{Block=	geometric_shapes:=}');
    Error('\P{Block=	geometric_shapes:=}');
    Expect(1, 9727, '\p{Block=:\AGeometric_Shapes\z:}', "");;
    Expect(0, 9728, '\p{Block=:\AGeometric_Shapes\z:}', "");;
    Expect(1, 9727, '\p{Block=geometricshapes}', "");
    Expect(0, 9727, '\p{^Block=geometricshapes}', "");
    Expect(0, 9727, '\P{Block=geometricshapes}', "");
    Expect(1, 9727, '\P{^Block=geometricshapes}', "");
    Expect(0, 9728, '\p{Block=geometricshapes}', "");
    Expect(1, 9728, '\p{^Block=geometricshapes}', "");
    Expect(1, 9728, '\P{Block=geometricshapes}', "");
    Expect(0, 9728, '\P{^Block=geometricshapes}', "");
    Expect(1, 9727, '\p{Block=:\Ageometricshapes\z:}', "");;
    Expect(0, 9728, '\p{Block=:\Ageometricshapes\z:}', "");;
    Expect(1, 9727, '\p{Block=- geometric_shapes}', "");
    Expect(0, 9727, '\p{^Block=- geometric_shapes}', "");
    Expect(0, 9727, '\P{Block=- geometric_shapes}', "");
    Expect(1, 9727, '\P{^Block=- geometric_shapes}', "");
    Expect(0, 9728, '\p{Block=- geometric_shapes}', "");
    Expect(1, 9728, '\p{^Block=- geometric_shapes}', "");
    Expect(1, 9728, '\P{Block=- geometric_shapes}', "");
    Expect(0, 9728, '\P{^Block=- geometric_shapes}', "");
    Error('\p{Blk=/a/		Geometric_Shapes}');
    Error('\P{Blk=/a/		Geometric_Shapes}');
    Expect(1, 9727, '\p{Blk=:\AGeometric_Shapes\z:}', "");;
    Expect(0, 9728, '\p{Blk=:\AGeometric_Shapes\z:}', "");;
    Expect(1, 9727, '\p{Blk=geometricshapes}', "");
    Expect(0, 9727, '\p{^Blk=geometricshapes}', "");
    Expect(0, 9727, '\P{Blk=geometricshapes}', "");
    Expect(1, 9727, '\P{^Blk=geometricshapes}', "");
    Expect(0, 9728, '\p{Blk=geometricshapes}', "");
    Expect(1, 9728, '\p{^Blk=geometricshapes}', "");
    Expect(1, 9728, '\P{Blk=geometricshapes}', "");
    Expect(0, 9728, '\P{^Blk=geometricshapes}', "");
    Expect(1, 9727, '\p{Blk=:\Ageometricshapes\z:}', "");;
    Expect(0, 9728, '\p{Blk=:\Ageometricshapes\z:}', "");;
    Expect(1, 9727, '\p{Blk=-_Geometric_Shapes}', "");
    Expect(0, 9727, '\p{^Blk=-_Geometric_Shapes}', "");
    Expect(0, 9727, '\P{Blk=-_Geometric_Shapes}', "");
    Expect(1, 9727, '\P{^Blk=-_Geometric_Shapes}', "");
    Expect(0, 9728, '\p{Blk=-_Geometric_Shapes}', "");
    Expect(1, 9728, '\p{^Blk=-_Geometric_Shapes}', "");
    Expect(1, 9728, '\P{Blk=-_Geometric_Shapes}', "");
    Expect(0, 9728, '\P{^Blk=-_Geometric_Shapes}', "");
    Error('\p{Is_Block=  geometric_Shapes:=}');
    Error('\P{Is_Block=  geometric_Shapes:=}');
    Expect(1, 9727, '\p{Is_Block=geometricshapes}', "");
    Expect(0, 9727, '\p{^Is_Block=geometricshapes}', "");
    Expect(0, 9727, '\P{Is_Block=geometricshapes}', "");
    Expect(1, 9727, '\P{^Is_Block=geometricshapes}', "");
    Expect(0, 9728, '\p{Is_Block=geometricshapes}', "");
    Expect(1, 9728, '\p{^Is_Block=geometricshapes}', "");
    Expect(1, 9728, '\P{Is_Block=geometricshapes}', "");
    Expect(0, 9728, '\P{^Is_Block=geometricshapes}', "");
    Expect(1, 9727, '\p{Is_Block=	Geometric_shapes}', "");
    Expect(0, 9727, '\p{^Is_Block=	Geometric_shapes}', "");
    Expect(0, 9727, '\P{Is_Block=	Geometric_shapes}', "");
    Expect(1, 9727, '\P{^Is_Block=	Geometric_shapes}', "");
    Expect(0, 9728, '\p{Is_Block=	Geometric_shapes}', "");
    Expect(1, 9728, '\p{^Is_Block=	Geometric_shapes}', "");
    Expect(1, 9728, '\P{Is_Block=	Geometric_shapes}', "");
    Expect(0, 9728, '\P{^Is_Block=	Geometric_shapes}', "");
    Error('\p{Is_Blk=	_Geometric_shapes/a/}');
    Error('\P{Is_Blk=	_Geometric_shapes/a/}');
    Expect(1, 9727, '\p{Is_Blk=geometricshapes}', "");
    Expect(0, 9727, '\p{^Is_Blk=geometricshapes}', "");
    Expect(0, 9727, '\P{Is_Blk=geometricshapes}', "");
    Expect(1, 9727, '\P{^Is_Blk=geometricshapes}', "");
    Expect(0, 9728, '\p{Is_Blk=geometricshapes}', "");
    Expect(1, 9728, '\p{^Is_Blk=geometricshapes}', "");
    Expect(1, 9728, '\P{Is_Blk=geometricshapes}', "");
    Expect(0, 9728, '\P{^Is_Blk=geometricshapes}', "");
    Expect(1, 9727, '\p{Is_Blk=_-Geometric_Shapes}', "");
    Expect(0, 9727, '\p{^Is_Blk=_-Geometric_Shapes}', "");
    Expect(0, 9727, '\P{Is_Blk=_-Geometric_Shapes}', "");
    Expect(1, 9727, '\P{^Is_Blk=_-Geometric_Shapes}', "");
    Expect(0, 9728, '\p{Is_Blk=_-Geometric_Shapes}', "");
    Expect(1, 9728, '\p{^Is_Blk=_-Geometric_Shapes}', "");
    Expect(1, 9728, '\P{Is_Blk=_-Geometric_Shapes}', "");
    Expect(0, 9728, '\P{^Is_Blk=_-Geometric_Shapes}', "");
    Error('\p{Block=-geometric_Shapes_Extended/a/}');
    Error('\P{Block=-geometric_Shapes_Extended/a/}');
    Expect(1, 129023, '\p{Block=:\AGeometric_Shapes_Extended\z:}', "");;
    Expect(0, 129024, '\p{Block=:\AGeometric_Shapes_Extended\z:}', "");;
    Expect(1, 129023, '\p{Block=geometricshapesextended}', "");
    Expect(0, 129023, '\p{^Block=geometricshapesextended}', "");
    Expect(0, 129023, '\P{Block=geometricshapesextended}', "");
    Expect(1, 129023, '\P{^Block=geometricshapesextended}', "");
    Expect(0, 129024, '\p{Block=geometricshapesextended}', "");
    Expect(1, 129024, '\p{^Block=geometricshapesextended}', "");
    Expect(1, 129024, '\P{Block=geometricshapesextended}', "");
    Expect(0, 129024, '\P{^Block=geometricshapesextended}', "");
    Expect(1, 129023, '\p{Block=:\Ageometricshapesextended\z:}', "");;
    Expect(0, 129024, '\p{Block=:\Ageometricshapesextended\z:}', "");;
    Expect(1, 129023, '\p{Block:	 geometric_Shapes_EXTENDED}', "");
    Expect(0, 129023, '\p{^Block:	 geometric_Shapes_EXTENDED}', "");
    Expect(0, 129023, '\P{Block:	 geometric_Shapes_EXTENDED}', "");
    Expect(1, 129023, '\P{^Block:	 geometric_Shapes_EXTENDED}', "");
    Expect(0, 129024, '\p{Block:	 geometric_Shapes_EXTENDED}', "");
    Expect(1, 129024, '\p{^Block:	 geometric_Shapes_EXTENDED}', "");
    Expect(1, 129024, '\P{Block:	 geometric_Shapes_EXTENDED}', "");
    Expect(0, 129024, '\P{^Block:	 geometric_Shapes_EXTENDED}', "");
    Error('\p{Blk=	-Geometric_Shapes_ext:=}');
    Error('\P{Blk=	-Geometric_Shapes_ext:=}');
    Expect(1, 129023, '\p{Blk=:\AGeometric_Shapes_Ext\z:}', "");;
    Expect(0, 129024, '\p{Blk=:\AGeometric_Shapes_Ext\z:}', "");;
    Expect(1, 129023, '\p{Blk=geometricshapesext}', "");
    Expect(0, 129023, '\p{^Blk=geometricshapesext}', "");
    Expect(0, 129023, '\P{Blk=geometricshapesext}', "");
    Expect(1, 129023, '\P{^Blk=geometricshapesext}', "");
    Expect(0, 129024, '\p{Blk=geometricshapesext}', "");
    Expect(1, 129024, '\p{^Blk=geometricshapesext}', "");
    Expect(1, 129024, '\P{Blk=geometricshapesext}', "");
    Expect(0, 129024, '\P{^Blk=geometricshapesext}', "");
    Expect(1, 129023, '\p{Blk=:\Ageometricshapesext\z:}', "");;
    Expect(0, 129024, '\p{Blk=:\Ageometricshapesext\z:}', "");;
    Expect(1, 129023, '\p{Blk=__Geometric_SHAPES_EXT}', "");
    Expect(0, 129023, '\p{^Blk=__Geometric_SHAPES_EXT}', "");
    Expect(0, 129023, '\P{Blk=__Geometric_SHAPES_EXT}', "");
    Expect(1, 129023, '\P{^Blk=__Geometric_SHAPES_EXT}', "");
    Expect(0, 129024, '\p{Blk=__Geometric_SHAPES_EXT}', "");
    Expect(1, 129024, '\p{^Blk=__Geometric_SHAPES_EXT}', "");
    Expect(1, 129024, '\P{Blk=__Geometric_SHAPES_EXT}', "");
    Expect(0, 129024, '\P{^Blk=__Geometric_SHAPES_EXT}', "");
    Error('\p{Is_Block=/a/ -Geometric_Shapes_extended}');
    Error('\P{Is_Block=/a/ -Geometric_Shapes_extended}');
    Expect(1, 129023, '\p{Is_Block=geometricshapesextended}', "");
    Expect(0, 129023, '\p{^Is_Block=geometricshapesextended}', "");
    Expect(0, 129023, '\P{Is_Block=geometricshapesextended}', "");
    Expect(1, 129023, '\P{^Is_Block=geometricshapesextended}', "");
    Expect(0, 129024, '\p{Is_Block=geometricshapesextended}', "");
    Expect(1, 129024, '\p{^Is_Block=geometricshapesextended}', "");
    Expect(1, 129024, '\P{Is_Block=geometricshapesextended}', "");
    Expect(0, 129024, '\P{^Is_Block=geometricshapesextended}', "");
    Expect(1, 129023, '\p{Is_Block=	Geometric_Shapes_extended}', "");
    Expect(0, 129023, '\p{^Is_Block=	Geometric_Shapes_extended}', "");
    Expect(0, 129023, '\P{Is_Block=	Geometric_Shapes_extended}', "");
    Expect(1, 129023, '\P{^Is_Block=	Geometric_Shapes_extended}', "");
    Expect(0, 129024, '\p{Is_Block=	Geometric_Shapes_extended}', "");
    Expect(1, 129024, '\p{^Is_Block=	Geometric_Shapes_extended}', "");
    Expect(1, 129024, '\P{Is_Block=	Geometric_Shapes_extended}', "");
    Expect(0, 129024, '\P{^Is_Block=	Geometric_Shapes_extended}', "");
    Error('\p{Is_Blk=	:=GEOMETRIC_Shapes_ext}');
    Error('\P{Is_Blk=	:=GEOMETRIC_Shapes_ext}');
    Expect(1, 129023, '\p{Is_Blk=geometricshapesext}', "");
    Expect(0, 129023, '\p{^Is_Blk=geometricshapesext}', "");
    Expect(0, 129023, '\P{Is_Blk=geometricshapesext}', "");
    Expect(1, 129023, '\P{^Is_Blk=geometricshapesext}', "");
    Expect(0, 129024, '\p{Is_Blk=geometricshapesext}', "");
    Expect(1, 129024, '\p{^Is_Blk=geometricshapesext}', "");
    Expect(1, 129024, '\P{Is_Blk=geometricshapesext}', "");
    Expect(0, 129024, '\P{^Is_Blk=geometricshapesext}', "");
    Expect(1, 129023, '\p{Is_Blk=	 Geometric_Shapes_Ext}', "");
    Expect(0, 129023, '\p{^Is_Blk=	 Geometric_Shapes_Ext}', "");
    Expect(0, 129023, '\P{Is_Blk=	 Geometric_Shapes_Ext}', "");
    Expect(1, 129023, '\P{^Is_Blk=	 Geometric_Shapes_Ext}', "");
    Expect(0, 129024, '\p{Is_Blk=	 Geometric_Shapes_Ext}', "");
    Expect(1, 129024, '\p{^Is_Blk=	 Geometric_Shapes_Ext}', "");
    Expect(1, 129024, '\P{Is_Blk=	 Geometric_Shapes_Ext}', "");
    Expect(0, 129024, '\P{^Is_Blk=	 Geometric_Shapes_Ext}', "");
    Error('\p{Block=:=--Georgian}');
    Error('\P{Block=:=--Georgian}');
    Expect(1, 4351, '\p{Block=:\AGeorgian\z:}', "");;
    Expect(0, 4352, '\p{Block=:\AGeorgian\z:}', "");;
    Expect(1, 4351, '\p{Block=georgian}', "");
    Expect(0, 4351, '\p{^Block=georgian}', "");
    Expect(0, 4351, '\P{Block=georgian}', "");
    Expect(1, 4351, '\P{^Block=georgian}', "");
    Expect(0, 4352, '\p{Block=georgian}', "");
    Expect(1, 4352, '\p{^Block=georgian}', "");
    Expect(1, 4352, '\P{Block=georgian}', "");
    Expect(0, 4352, '\P{^Block=georgian}', "");
    Expect(1, 4351, '\p{Block=:\Ageorgian\z:}', "");;
    Expect(0, 4352, '\p{Block=:\Ageorgian\z:}', "");;
    Expect(1, 4351, '\p{Block=_georgian}', "");
    Expect(0, 4351, '\p{^Block=_georgian}', "");
    Expect(0, 4351, '\P{Block=_georgian}', "");
    Expect(1, 4351, '\P{^Block=_georgian}', "");
    Expect(0, 4352, '\p{Block=_georgian}', "");
    Expect(1, 4352, '\p{^Block=_georgian}', "");
    Expect(1, 4352, '\P{Block=_georgian}', "");
    Expect(0, 4352, '\P{^Block=_georgian}', "");
    Error('\p{Blk=	georgian/a/}');
    Error('\P{Blk=	georgian/a/}');
    Expect(1, 4351, '\p{Blk=:\AGeorgian\z:}', "");;
    Expect(0, 4352, '\p{Blk=:\AGeorgian\z:}', "");;
    Expect(1, 4351, '\p{Blk=georgian}', "");
    Expect(0, 4351, '\p{^Blk=georgian}', "");
    Expect(0, 4351, '\P{Blk=georgian}', "");
    Expect(1, 4351, '\P{^Blk=georgian}', "");
    Expect(0, 4352, '\p{Blk=georgian}', "");
    Expect(1, 4352, '\p{^Blk=georgian}', "");
    Expect(1, 4352, '\P{Blk=georgian}', "");
    Expect(0, 4352, '\P{^Blk=georgian}', "");
    Expect(1, 4351, '\p{Blk=:\Ageorgian\z:}', "");;
    Expect(0, 4352, '\p{Blk=:\Ageorgian\z:}', "");;
    Expect(1, 4351, '\p{Blk=_ GEORGIAN}', "");
    Expect(0, 4351, '\p{^Blk=_ GEORGIAN}', "");
    Expect(0, 4351, '\P{Blk=_ GEORGIAN}', "");
    Expect(1, 4351, '\P{^Blk=_ GEORGIAN}', "");
    Expect(0, 4352, '\p{Blk=_ GEORGIAN}', "");
    Expect(1, 4352, '\p{^Blk=_ GEORGIAN}', "");
    Expect(1, 4352, '\P{Blk=_ GEORGIAN}', "");
    Expect(0, 4352, '\P{^Blk=_ GEORGIAN}', "");
    Error('\p{Is_Block:   _Georgian/a/}');
    Error('\P{Is_Block:   _Georgian/a/}');
    Expect(1, 4351, '\p{Is_Block=georgian}', "");
    Expect(0, 4351, '\p{^Is_Block=georgian}', "");
    Expect(0, 4351, '\P{Is_Block=georgian}', "");
    Expect(1, 4351, '\P{^Is_Block=georgian}', "");
    Expect(0, 4352, '\p{Is_Block=georgian}', "");
    Expect(1, 4352, '\p{^Is_Block=georgian}', "");
    Expect(1, 4352, '\P{Is_Block=georgian}', "");
    Expect(0, 4352, '\P{^Is_Block=georgian}', "");
    Expect(1, 4351, '\p{Is_Block=-georgian}', "");
    Expect(0, 4351, '\p{^Is_Block=-georgian}', "");
    Expect(0, 4351, '\P{Is_Block=-georgian}', "");
    Expect(1, 4351, '\P{^Is_Block=-georgian}', "");
    Expect(0, 4352, '\p{Is_Block=-georgian}', "");
    Expect(1, 4352, '\p{^Is_Block=-georgian}', "");
    Expect(1, 4352, '\P{Is_Block=-georgian}', "");
    Expect(0, 4352, '\P{^Is_Block=-georgian}', "");
    Error('\p{Is_Blk=/a/-_GEORGIAN}');
    Error('\P{Is_Blk=/a/-_GEORGIAN}');
    Expect(1, 4351, '\p{Is_Blk=georgian}', "");
    Expect(0, 4351, '\p{^Is_Blk=georgian}', "");
    Expect(0, 4351, '\P{Is_Blk=georgian}', "");
    Expect(1, 4351, '\P{^Is_Blk=georgian}', "");
    Expect(0, 4352, '\p{Is_Blk=georgian}', "");
    Expect(1, 4352, '\p{^Is_Blk=georgian}', "");
    Expect(1, 4352, '\P{Is_Blk=georgian}', "");
    Expect(0, 4352, '\P{^Is_Blk=georgian}', "");
    Expect(1, 4351, '\p{Is_Blk:  GEORGIAN}', "");
    Expect(0, 4351, '\p{^Is_Blk:  GEORGIAN}', "");
    Expect(0, 4351, '\P{Is_Blk:  GEORGIAN}', "");
    Expect(1, 4351, '\P{^Is_Blk:  GEORGIAN}', "");
    Expect(0, 4352, '\p{Is_Blk:  GEORGIAN}', "");
    Expect(1, 4352, '\p{^Is_Blk:  GEORGIAN}', "");
    Expect(1, 4352, '\P{Is_Blk:  GEORGIAN}', "");
    Expect(0, 4352, '\P{^Is_Blk:  GEORGIAN}', "");
    Error('\p{Block=/a/	_GEORGIAN_EXTENDED}');
    Error('\P{Block=/a/	_GEORGIAN_EXTENDED}');
    Expect(1, 7359, '\p{Block=:\AGeorgian_Extended\z:}', "");;
    Expect(0, 7360, '\p{Block=:\AGeorgian_Extended\z:}', "");;
    Expect(1, 7359, '\p{Block=georgianextended}', "");
    Expect(0, 7359, '\p{^Block=georgianextended}', "");
    Expect(0, 7359, '\P{Block=georgianextended}', "");
    Expect(1, 7359, '\P{^Block=georgianextended}', "");
    Expect(0, 7360, '\p{Block=georgianextended}', "");
    Expect(1, 7360, '\p{^Block=georgianextended}', "");
    Expect(1, 7360, '\P{Block=georgianextended}', "");
    Expect(0, 7360, '\P{^Block=georgianextended}', "");
    Expect(1, 7359, '\p{Block=:\Ageorgianextended\z:}', "");;
    Expect(0, 7360, '\p{Block=:\Ageorgianextended\z:}', "");;
    Expect(1, 7359, '\p{Block=_	Georgian_Extended}', "");
    Expect(0, 7359, '\p{^Block=_	Georgian_Extended}', "");
    Expect(0, 7359, '\P{Block=_	Georgian_Extended}', "");
    Expect(1, 7359, '\P{^Block=_	Georgian_Extended}', "");
    Expect(0, 7360, '\p{Block=_	Georgian_Extended}', "");
    Expect(1, 7360, '\p{^Block=_	Georgian_Extended}', "");
    Expect(1, 7360, '\P{Block=_	Georgian_Extended}', "");
    Expect(0, 7360, '\P{^Block=_	Georgian_Extended}', "");
    Error('\p{Blk=-:=georgian_Ext}');
    Error('\P{Blk=-:=georgian_Ext}');
    Expect(1, 7359, '\p{Blk=:\AGeorgian_Ext\z:}', "");;
    Expect(0, 7360, '\p{Blk=:\AGeorgian_Ext\z:}', "");;
    Expect(1, 7359, '\p{Blk=georgianext}', "");
    Expect(0, 7359, '\p{^Blk=georgianext}', "");
    Expect(0, 7359, '\P{Blk=georgianext}', "");
    Expect(1, 7359, '\P{^Blk=georgianext}', "");
    Expect(0, 7360, '\p{Blk=georgianext}', "");
    Expect(1, 7360, '\p{^Blk=georgianext}', "");
    Expect(1, 7360, '\P{Blk=georgianext}', "");
    Expect(0, 7360, '\P{^Blk=georgianext}', "");
    Expect(1, 7359, '\p{Blk=:\Ageorgianext\z:}', "");;
    Expect(0, 7360, '\p{Blk=:\Ageorgianext\z:}', "");;
    Expect(1, 7359, '\p{Blk=_Georgian_EXT}', "");
    Expect(0, 7359, '\p{^Blk=_Georgian_EXT}', "");
    Expect(0, 7359, '\P{Blk=_Georgian_EXT}', "");
    Expect(1, 7359, '\P{^Blk=_Georgian_EXT}', "");
    Expect(0, 7360, '\p{Blk=_Georgian_EXT}', "");
    Expect(1, 7360, '\p{^Blk=_Georgian_EXT}', "");
    Expect(1, 7360, '\P{Blk=_Georgian_EXT}', "");
    Expect(0, 7360, '\P{^Blk=_Georgian_EXT}', "");
    Error('\p{Is_Block=_georgian_EXTENDED:=}');
    Error('\P{Is_Block=_georgian_EXTENDED:=}');
    Expect(1, 7359, '\p{Is_Block=georgianextended}', "");
    Expect(0, 7359, '\p{^Is_Block=georgianextended}', "");
    Expect(0, 7359, '\P{Is_Block=georgianextended}', "");
    Expect(1, 7359, '\P{^Is_Block=georgianextended}', "");
    Expect(0, 7360, '\p{Is_Block=georgianextended}', "");
    Expect(1, 7360, '\p{^Is_Block=georgianextended}', "");
    Expect(1, 7360, '\P{Is_Block=georgianextended}', "");
    Expect(0, 7360, '\P{^Is_Block=georgianextended}', "");
    Expect(1, 7359, '\p{Is_Block= 	GEORGIAN_Extended}', "");
    Expect(0, 7359, '\p{^Is_Block= 	GEORGIAN_Extended}', "");
    Expect(0, 7359, '\P{Is_Block= 	GEORGIAN_Extended}', "");
    Expect(1, 7359, '\P{^Is_Block= 	GEORGIAN_Extended}', "");
    Expect(0, 7360, '\p{Is_Block= 	GEORGIAN_Extended}', "");
    Expect(1, 7360, '\p{^Is_Block= 	GEORGIAN_Extended}', "");
    Expect(1, 7360, '\P{Is_Block= 	GEORGIAN_Extended}', "");
    Expect(0, 7360, '\P{^Is_Block= 	GEORGIAN_Extended}', "");
    Error('\p{Is_Blk=-:=georgian_Ext}');
    Error('\P{Is_Blk=-:=georgian_Ext}');
    Expect(1, 7359, '\p{Is_Blk:georgianext}', "");
    Expect(0, 7359, '\p{^Is_Blk:georgianext}', "");
    Expect(0, 7359, '\P{Is_Blk:georgianext}', "");
    Expect(1, 7359, '\P{^Is_Blk:georgianext}', "");
    Expect(0, 7360, '\p{Is_Blk:georgianext}', "");
    Expect(1, 7360, '\p{^Is_Blk:georgianext}', "");
    Expect(1, 7360, '\P{Is_Blk:georgianext}', "");
    Expect(0, 7360, '\P{^Is_Blk:georgianext}', "");
    Expect(1, 7359, '\p{Is_Blk=_-GEORGIAN_Ext}', "");
    Expect(0, 7359, '\p{^Is_Blk=_-GEORGIAN_Ext}', "");
    Expect(0, 7359, '\P{Is_Blk=_-GEORGIAN_Ext}', "");
    Expect(1, 7359, '\P{^Is_Blk=_-GEORGIAN_Ext}', "");
    Expect(0, 7360, '\p{Is_Blk=_-GEORGIAN_Ext}', "");
    Expect(1, 7360, '\p{^Is_Blk=_-GEORGIAN_Ext}', "");
    Expect(1, 7360, '\P{Is_Blk=_-GEORGIAN_Ext}', "");
    Expect(0, 7360, '\P{^Is_Blk=_-GEORGIAN_Ext}', "");
    Error('\p{Block=:=_-Georgian_supplement}');
    Error('\P{Block=:=_-Georgian_supplement}');
    Expect(1, 11567, '\p{Block=:\AGeorgian_Supplement\z:}', "");;
    Expect(0, 11568, '\p{Block=:\AGeorgian_Supplement\z:}', "");;
    Expect(1, 11567, '\p{Block=georgiansupplement}', "");
    Expect(0, 11567, '\p{^Block=georgiansupplement}', "");
    Expect(0, 11567, '\P{Block=georgiansupplement}', "");
    Expect(1, 11567, '\P{^Block=georgiansupplement}', "");
    Expect(0, 11568, '\p{Block=georgiansupplement}', "");
    Expect(1, 11568, '\p{^Block=georgiansupplement}', "");
    Expect(1, 11568, '\P{Block=georgiansupplement}', "");
    Expect(0, 11568, '\P{^Block=georgiansupplement}', "");
    Expect(1, 11567, '\p{Block=:\Ageorgiansupplement\z:}', "");;
    Expect(0, 11568, '\p{Block=:\Ageorgiansupplement\z:}', "");;
    Expect(1, 11567, '\p{Block=_-Georgian_Supplement}', "");
    Expect(0, 11567, '\p{^Block=_-Georgian_Supplement}', "");
    Expect(0, 11567, '\P{Block=_-Georgian_Supplement}', "");
    Expect(1, 11567, '\P{^Block=_-Georgian_Supplement}', "");
    Expect(0, 11568, '\p{Block=_-Georgian_Supplement}', "");
    Expect(1, 11568, '\p{^Block=_-Georgian_Supplement}', "");
    Expect(1, 11568, '\P{Block=_-Georgian_Supplement}', "");
    Expect(0, 11568, '\P{^Block=_-Georgian_Supplement}', "");
    Error('\p{Blk=-/a/GEORGIAN_SUP}');
    Error('\P{Blk=-/a/GEORGIAN_SUP}');
    Expect(1, 11567, '\p{Blk=:\AGeorgian_Sup\z:}', "");;
    Expect(0, 11568, '\p{Blk=:\AGeorgian_Sup\z:}', "");;
    Expect(1, 11567, '\p{Blk=georgiansup}', "");
    Expect(0, 11567, '\p{^Blk=georgiansup}', "");
    Expect(0, 11567, '\P{Blk=georgiansup}', "");
    Expect(1, 11567, '\P{^Blk=georgiansup}', "");
    Expect(0, 11568, '\p{Blk=georgiansup}', "");
    Expect(1, 11568, '\p{^Blk=georgiansup}', "");
    Expect(1, 11568, '\P{Blk=georgiansup}', "");
    Expect(0, 11568, '\P{^Blk=georgiansup}', "");
    Expect(1, 11567, '\p{Blk=:\Ageorgiansup\z:}', "");;
    Expect(0, 11568, '\p{Blk=:\Ageorgiansup\z:}', "");;
    Expect(1, 11567, '\p{Blk=	Georgian_sup}', "");
    Expect(0, 11567, '\p{^Blk=	Georgian_sup}', "");
    Expect(0, 11567, '\P{Blk=	Georgian_sup}', "");
    Expect(1, 11567, '\P{^Blk=	Georgian_sup}', "");
    Expect(0, 11568, '\p{Blk=	Georgian_sup}', "");
    Expect(1, 11568, '\p{^Blk=	Georgian_sup}', "");
    Expect(1, 11568, '\P{Blk=	Georgian_sup}', "");
    Expect(0, 11568, '\P{^Blk=	Georgian_sup}', "");
    Error('\p{Is_Block=:=_-georgian_Supplement}');
    Error('\P{Is_Block=:=_-georgian_Supplement}');
    Expect(1, 11567, '\p{Is_Block=georgiansupplement}', "");
    Expect(0, 11567, '\p{^Is_Block=georgiansupplement}', "");
    Expect(0, 11567, '\P{Is_Block=georgiansupplement}', "");
    Expect(1, 11567, '\P{^Is_Block=georgiansupplement}', "");
    Expect(0, 11568, '\p{Is_Block=georgiansupplement}', "");
    Expect(1, 11568, '\p{^Is_Block=georgiansupplement}', "");
    Expect(1, 11568, '\P{Is_Block=georgiansupplement}', "");
    Expect(0, 11568, '\P{^Is_Block=georgiansupplement}', "");
    Expect(1, 11567, '\p{Is_Block= -Georgian_Supplement}', "");
    Expect(0, 11567, '\p{^Is_Block= -Georgian_Supplement}', "");
    Expect(0, 11567, '\P{Is_Block= -Georgian_Supplement}', "");
    Expect(1, 11567, '\P{^Is_Block= -Georgian_Supplement}', "");
    Expect(0, 11568, '\p{Is_Block= -Georgian_Supplement}', "");
    Expect(1, 11568, '\p{^Is_Block= -Georgian_Supplement}', "");
    Expect(1, 11568, '\P{Is_Block= -Georgian_Supplement}', "");
    Expect(0, 11568, '\P{^Is_Block= -Georgian_Supplement}', "");
    Error('\p{Is_Blk=_ georgian_SUP/a/}');
    Error('\P{Is_Blk=_ georgian_SUP/a/}');
    Expect(1, 11567, '\p{Is_Blk:   georgiansup}', "");
    Expect(0, 11567, '\p{^Is_Blk:   georgiansup}', "");
    Expect(0, 11567, '\P{Is_Blk:   georgiansup}', "");
    Expect(1, 11567, '\P{^Is_Blk:   georgiansup}', "");
    Expect(0, 11568, '\p{Is_Blk:   georgiansup}', "");
    Expect(1, 11568, '\p{^Is_Blk:   georgiansup}', "");
    Expect(1, 11568, '\P{Is_Blk:   georgiansup}', "");
    Expect(0, 11568, '\P{^Is_Blk:   georgiansup}', "");
    Expect(1, 11567, '\p{Is_Blk=_Georgian_Sup}', "");
    Expect(0, 11567, '\p{^Is_Blk=_Georgian_Sup}', "");
    Expect(0, 11567, '\P{Is_Blk=_Georgian_Sup}', "");
    Expect(1, 11567, '\P{^Is_Blk=_Georgian_Sup}', "");
    Expect(0, 11568, '\p{Is_Blk=_Georgian_Sup}', "");
    Expect(1, 11568, '\p{^Is_Blk=_Georgian_Sup}', "");
    Expect(1, 11568, '\P{Is_Blk=_Georgian_Sup}', "");
    Expect(0, 11568, '\P{^Is_Blk=_Georgian_Sup}', "");
    Error('\p{Block=/a/- glagolitic}');
    Error('\P{Block=/a/- glagolitic}');
    Expect(1, 11359, '\p{Block=:\AGlagolitic\z:}', "");;
    Expect(0, 11360, '\p{Block=:\AGlagolitic\z:}', "");;
    Expect(1, 11359, '\p{Block=glagolitic}', "");
    Expect(0, 11359, '\p{^Block=glagolitic}', "");
    Expect(0, 11359, '\P{Block=glagolitic}', "");
    Expect(1, 11359, '\P{^Block=glagolitic}', "");
    Expect(0, 11360, '\p{Block=glagolitic}', "");
    Expect(1, 11360, '\p{^Block=glagolitic}', "");
    Expect(1, 11360, '\P{Block=glagolitic}', "");
    Expect(0, 11360, '\P{^Block=glagolitic}', "");
    Expect(1, 11359, '\p{Block=:\Aglagolitic\z:}', "");;
    Expect(0, 11360, '\p{Block=:\Aglagolitic\z:}', "");;
    Expect(1, 11359, '\p{Block=_ glagolitic}', "");
    Expect(0, 11359, '\p{^Block=_ glagolitic}', "");
    Expect(0, 11359, '\P{Block=_ glagolitic}', "");
    Expect(1, 11359, '\P{^Block=_ glagolitic}', "");
    Expect(0, 11360, '\p{Block=_ glagolitic}', "");
    Expect(1, 11360, '\p{^Block=_ glagolitic}', "");
    Expect(1, 11360, '\P{Block=_ glagolitic}', "");
    Expect(0, 11360, '\P{^Block=_ glagolitic}', "");
    Error('\p{Blk=	:=glagolitic}');
    Error('\P{Blk=	:=glagolitic}');
    Expect(1, 11359, '\p{Blk=:\AGlagolitic\z:}', "");;
    Expect(0, 11360, '\p{Blk=:\AGlagolitic\z:}', "");;
    Expect(1, 11359, '\p{Blk=glagolitic}', "");
    Expect(0, 11359, '\p{^Blk=glagolitic}', "");
    Expect(0, 11359, '\P{Blk=glagolitic}', "");
    Expect(1, 11359, '\P{^Blk=glagolitic}', "");
    Expect(0, 11360, '\p{Blk=glagolitic}', "");
    Expect(1, 11360, '\p{^Blk=glagolitic}', "");
    Expect(1, 11360, '\P{Blk=glagolitic}', "");
    Expect(0, 11360, '\P{^Blk=glagolitic}', "");
    Expect(1, 11359, '\p{Blk=:\Aglagolitic\z:}', "");;
    Expect(0, 11360, '\p{Blk=:\Aglagolitic\z:}', "");;
    Expect(1, 11359, '\p{Blk=_Glagolitic}', "");
    Expect(0, 11359, '\p{^Blk=_Glagolitic}', "");
    Expect(0, 11359, '\P{Blk=_Glagolitic}', "");
    Expect(1, 11359, '\P{^Blk=_Glagolitic}', "");
    Expect(0, 11360, '\p{Blk=_Glagolitic}', "");
    Expect(1, 11360, '\p{^Blk=_Glagolitic}', "");
    Expect(1, 11360, '\P{Blk=_Glagolitic}', "");
    Expect(0, 11360, '\P{^Blk=_Glagolitic}', "");
    Error('\p{Is_Block=-	GLAGOLITIC:=}');
    Error('\P{Is_Block=-	GLAGOLITIC:=}');
    Expect(1, 11359, '\p{Is_Block=glagolitic}', "");
    Expect(0, 11359, '\p{^Is_Block=glagolitic}', "");
    Expect(0, 11359, '\P{Is_Block=glagolitic}', "");
    Expect(1, 11359, '\P{^Is_Block=glagolitic}', "");
    Expect(0, 11360, '\p{Is_Block=glagolitic}', "");
    Expect(1, 11360, '\p{^Is_Block=glagolitic}', "");
    Expect(1, 11360, '\P{Is_Block=glagolitic}', "");
    Expect(0, 11360, '\P{^Is_Block=glagolitic}', "");
    Expect(1, 11359, '\p{Is_Block:   	Glagolitic}', "");
    Expect(0, 11359, '\p{^Is_Block:   	Glagolitic}', "");
    Expect(0, 11359, '\P{Is_Block:   	Glagolitic}', "");
    Expect(1, 11359, '\P{^Is_Block:   	Glagolitic}', "");
    Expect(0, 11360, '\p{Is_Block:   	Glagolitic}', "");
    Expect(1, 11360, '\p{^Is_Block:   	Glagolitic}', "");
    Expect(1, 11360, '\P{Is_Block:   	Glagolitic}', "");
    Expect(0, 11360, '\P{^Is_Block:   	Glagolitic}', "");
    Error('\p{Is_Blk=/a/Glagolitic}');
    Error('\P{Is_Blk=/a/Glagolitic}');
    Expect(1, 11359, '\p{Is_Blk=glagolitic}', "");
    Expect(0, 11359, '\p{^Is_Blk=glagolitic}', "");
    Expect(0, 11359, '\P{Is_Blk=glagolitic}', "");
    Expect(1, 11359, '\P{^Is_Blk=glagolitic}', "");
    Expect(0, 11360, '\p{Is_Blk=glagolitic}', "");
    Expect(1, 11360, '\p{^Is_Blk=glagolitic}', "");
    Expect(1, 11360, '\P{Is_Blk=glagolitic}', "");
    Expect(0, 11360, '\P{^Is_Blk=glagolitic}', "");
    Expect(1, 11359, '\p{Is_Blk: Glagolitic}', "");
    Expect(0, 11359, '\p{^Is_Blk: Glagolitic}', "");
    Expect(0, 11359, '\P{Is_Blk: Glagolitic}', "");
    Expect(1, 11359, '\P{^Is_Blk: Glagolitic}', "");
    Expect(0, 11360, '\p{Is_Blk: Glagolitic}', "");
    Expect(1, 11360, '\p{^Is_Blk: Glagolitic}', "");
    Expect(1, 11360, '\P{Is_Blk: Glagolitic}', "");
    Expect(0, 11360, '\P{^Is_Blk: Glagolitic}', "");
    Error('\p{Block=/a/-_Glagolitic_SUPPLEMENT}');
    Error('\P{Block=/a/-_Glagolitic_SUPPLEMENT}');
    Expect(1, 122927, '\p{Block=:\AGlagolitic_Supplement\z:}', "");;
    Expect(0, 122928, '\p{Block=:\AGlagolitic_Supplement\z:}', "");;
    Expect(1, 122927, '\p{Block=glagoliticsupplement}', "");
    Expect(0, 122927, '\p{^Block=glagoliticsupplement}', "");
    Expect(0, 122927, '\P{Block=glagoliticsupplement}', "");
    Expect(1, 122927, '\P{^Block=glagoliticsupplement}', "");
    Expect(0, 122928, '\p{Block=glagoliticsupplement}', "");
    Expect(1, 122928, '\p{^Block=glagoliticsupplement}', "");
    Expect(1, 122928, '\P{Block=glagoliticsupplement}', "");
    Expect(0, 122928, '\P{^Block=glagoliticsupplement}', "");
    Expect(1, 122927, '\p{Block=:\Aglagoliticsupplement\z:}', "");;
    Expect(0, 122928, '\p{Block=:\Aglagoliticsupplement\z:}', "");;
    Expect(1, 122927, '\p{Block= Glagolitic_supplement}', "");
    Expect(0, 122927, '\p{^Block= Glagolitic_supplement}', "");
    Expect(0, 122927, '\P{Block= Glagolitic_supplement}', "");
    Expect(1, 122927, '\P{^Block= Glagolitic_supplement}', "");
    Expect(0, 122928, '\p{Block= Glagolitic_supplement}', "");
    Expect(1, 122928, '\p{^Block= Glagolitic_supplement}', "");
    Expect(1, 122928, '\P{Block= Glagolitic_supplement}', "");
    Expect(0, 122928, '\P{^Block= Glagolitic_supplement}', "");
    Error('\p{Blk=_glagolitic_sup:=}');
    Error('\P{Blk=_glagolitic_sup:=}');
    Expect(1, 122927, '\p{Blk=:\AGlagolitic_Sup\z:}', "");;
    Expect(0, 122928, '\p{Blk=:\AGlagolitic_Sup\z:}', "");;
    Expect(1, 122927, '\p{Blk=glagoliticsup}', "");
    Expect(0, 122927, '\p{^Blk=glagoliticsup}', "");
    Expect(0, 122927, '\P{Blk=glagoliticsup}', "");
    Expect(1, 122927, '\P{^Blk=glagoliticsup}', "");
    Expect(0, 122928, '\p{Blk=glagoliticsup}', "");
    Expect(1, 122928, '\p{^Blk=glagoliticsup}', "");
    Expect(1, 122928, '\P{Blk=glagoliticsup}', "");
    Expect(0, 122928, '\P{^Blk=glagoliticsup}', "");
    Expect(1, 122927, '\p{Blk=:\Aglagoliticsup\z:}', "");;
    Expect(0, 122928, '\p{Blk=:\Aglagoliticsup\z:}', "");;
    Expect(1, 122927, '\p{Blk=  GLAGOLITIC_Sup}', "");
    Expect(0, 122927, '\p{^Blk=  GLAGOLITIC_Sup}', "");
    Expect(0, 122927, '\P{Blk=  GLAGOLITIC_Sup}', "");
    Expect(1, 122927, '\P{^Blk=  GLAGOLITIC_Sup}', "");
    Expect(0, 122928, '\p{Blk=  GLAGOLITIC_Sup}', "");
    Expect(1, 122928, '\p{^Blk=  GLAGOLITIC_Sup}', "");
    Expect(1, 122928, '\P{Blk=  GLAGOLITIC_Sup}', "");
    Expect(0, 122928, '\P{^Blk=  GLAGOLITIC_Sup}', "");
    Error('\p{Is_Block=Glagolitic_supplement:=}');
    Error('\P{Is_Block=Glagolitic_supplement:=}');
    Expect(1, 122927, '\p{Is_Block=glagoliticsupplement}', "");
    Expect(0, 122927, '\p{^Is_Block=glagoliticsupplement}', "");
    Expect(0, 122927, '\P{Is_Block=glagoliticsupplement}', "");
    Expect(1, 122927, '\P{^Is_Block=glagoliticsupplement}', "");
    Expect(0, 122928, '\p{Is_Block=glagoliticsupplement}', "");
    Expect(1, 122928, '\p{^Is_Block=glagoliticsupplement}', "");
    Expect(1, 122928, '\P{Is_Block=glagoliticsupplement}', "");
    Expect(0, 122928, '\P{^Is_Block=glagoliticsupplement}', "");
    Expect(1, 122927, '\p{Is_Block=-glagolitic_supplement}', "");
    Expect(0, 122927, '\p{^Is_Block=-glagolitic_supplement}', "");
    Expect(0, 122927, '\P{Is_Block=-glagolitic_supplement}', "");
    Expect(1, 122927, '\P{^Is_Block=-glagolitic_supplement}', "");
    Expect(0, 122928, '\p{Is_Block=-glagolitic_supplement}', "");
    Expect(1, 122928, '\p{^Is_Block=-glagolitic_supplement}', "");
    Expect(1, 122928, '\P{Is_Block=-glagolitic_supplement}', "");
    Expect(0, 122928, '\P{^Is_Block=-glagolitic_supplement}', "");
    Error('\p{Is_Blk=:=- GLAGOLITIC_SUP}');
    Error('\P{Is_Blk=:=- GLAGOLITIC_SUP}');
    Expect(1, 122927, '\p{Is_Blk=glagoliticsup}', "");
    Expect(0, 122927, '\p{^Is_Blk=glagoliticsup}', "");
    Expect(0, 122927, '\P{Is_Blk=glagoliticsup}', "");
    Expect(1, 122927, '\P{^Is_Blk=glagoliticsup}', "");
    Expect(0, 122928, '\p{Is_Blk=glagoliticsup}', "");
    Expect(1, 122928, '\p{^Is_Blk=glagoliticsup}', "");
    Expect(1, 122928, '\P{Is_Blk=glagoliticsup}', "");
    Expect(0, 122928, '\P{^Is_Blk=glagoliticsup}', "");
    Expect(1, 122927, '\p{Is_Blk=_	GLAGOLITIC_sup}', "");
    Expect(0, 122927, '\p{^Is_Blk=_	GLAGOLITIC_sup}', "");
    Expect(0, 122927, '\P{Is_Blk=_	GLAGOLITIC_sup}', "");
    Expect(1, 122927, '\P{^Is_Blk=_	GLAGOLITIC_sup}', "");
    Expect(0, 122928, '\p{Is_Blk=_	GLAGOLITIC_sup}', "");
    Expect(1, 122928, '\p{^Is_Blk=_	GLAGOLITIC_sup}', "");
    Expect(1, 122928, '\P{Is_Blk=_	GLAGOLITIC_sup}', "");
    Expect(0, 122928, '\P{^Is_Blk=_	GLAGOLITIC_sup}', "");
    Error('\p{Block=:=-Gothic}');
    Error('\P{Block=:=-Gothic}');
    Expect(1, 66383, '\p{Block=:\AGothic\z:}', "");;
    Expect(0, 66384, '\p{Block=:\AGothic\z:}', "");;
    Expect(1, 66383, '\p{Block=gothic}', "");
    Expect(0, 66383, '\p{^Block=gothic}', "");
    Expect(0, 66383, '\P{Block=gothic}', "");
    Expect(1, 66383, '\P{^Block=gothic}', "");
    Expect(0, 66384, '\p{Block=gothic}', "");
    Expect(1, 66384, '\p{^Block=gothic}', "");
    Expect(1, 66384, '\P{Block=gothic}', "");
    Expect(0, 66384, '\P{^Block=gothic}', "");
    Expect(1, 66383, '\p{Block=:\Agothic\z:}', "");;
    Expect(0, 66384, '\p{Block=:\Agothic\z:}', "");;
    Expect(1, 66383, '\p{Block=	gothic}', "");
    Expect(0, 66383, '\p{^Block=	gothic}', "");
    Expect(0, 66383, '\P{Block=	gothic}', "");
    Expect(1, 66383, '\P{^Block=	gothic}', "");
    Expect(0, 66384, '\p{Block=	gothic}', "");
    Expect(1, 66384, '\p{^Block=	gothic}', "");
    Expect(1, 66384, '\P{Block=	gothic}', "");
    Expect(0, 66384, '\P{^Block=	gothic}', "");
    Error('\p{Blk:		Gothic/a/}');
    Error('\P{Blk:		Gothic/a/}');
    Expect(1, 66383, '\p{Blk=:\AGothic\z:}', "");;
    Expect(0, 66384, '\p{Blk=:\AGothic\z:}', "");;
    Expect(1, 66383, '\p{Blk=gothic}', "");
    Expect(0, 66383, '\p{^Blk=gothic}', "");
    Expect(0, 66383, '\P{Blk=gothic}', "");
    Expect(1, 66383, '\P{^Blk=gothic}', "");
    Expect(0, 66384, '\p{Blk=gothic}', "");
    Expect(1, 66384, '\p{^Blk=gothic}', "");
    Expect(1, 66384, '\P{Blk=gothic}', "");
    Expect(0, 66384, '\P{^Blk=gothic}', "");
    Expect(1, 66383, '\p{Blk=:\Agothic\z:}', "");;
    Expect(0, 66384, '\p{Blk=:\Agothic\z:}', "");;
    Expect(1, 66383, '\p{Blk=_	Gothic}', "");
    Expect(0, 66383, '\p{^Blk=_	Gothic}', "");
    Expect(0, 66383, '\P{Blk=_	Gothic}', "");
    Expect(1, 66383, '\P{^Blk=_	Gothic}', "");
    Expect(0, 66384, '\p{Blk=_	Gothic}', "");
    Expect(1, 66384, '\p{^Blk=_	Gothic}', "");
    Expect(1, 66384, '\P{Blk=_	Gothic}', "");
    Expect(0, 66384, '\P{^Blk=_	Gothic}', "");
    Error('\p{Is_Block=	:=gothic}');
    Error('\P{Is_Block=	:=gothic}');
    Expect(1, 66383, '\p{Is_Block=gothic}', "");
    Expect(0, 66383, '\p{^Is_Block=gothic}', "");
    Expect(0, 66383, '\P{Is_Block=gothic}', "");
    Expect(1, 66383, '\P{^Is_Block=gothic}', "");
    Expect(0, 66384, '\p{Is_Block=gothic}', "");
    Expect(1, 66384, '\p{^Is_Block=gothic}', "");
    Expect(1, 66384, '\P{Is_Block=gothic}', "");
    Expect(0, 66384, '\P{^Is_Block=gothic}', "");
    Expect(1, 66383, '\p{Is_Block:   - gothic}', "");
    Expect(0, 66383, '\p{^Is_Block:   - gothic}', "");
    Expect(0, 66383, '\P{Is_Block:   - gothic}', "");
    Expect(1, 66383, '\P{^Is_Block:   - gothic}', "");
    Expect(0, 66384, '\p{Is_Block:   - gothic}', "");
    Expect(1, 66384, '\p{^Is_Block:   - gothic}', "");
    Expect(1, 66384, '\P{Is_Block:   - gothic}', "");
    Expect(0, 66384, '\P{^Is_Block:   - gothic}', "");
    Error('\p{Is_Blk=- Gothic/a/}');
    Error('\P{Is_Blk=- Gothic/a/}');
    Expect(1, 66383, '\p{Is_Blk=gothic}', "");
    Expect(0, 66383, '\p{^Is_Blk=gothic}', "");
    Expect(0, 66383, '\P{Is_Blk=gothic}', "");
    Expect(1, 66383, '\P{^Is_Blk=gothic}', "");
    Expect(0, 66384, '\p{Is_Blk=gothic}', "");
    Expect(1, 66384, '\p{^Is_Blk=gothic}', "");
    Expect(1, 66384, '\P{Is_Blk=gothic}', "");
    Expect(0, 66384, '\P{^Is_Blk=gothic}', "");
    Expect(1, 66383, '\p{Is_Blk=	gothic}', "");
    Expect(0, 66383, '\p{^Is_Blk=	gothic}', "");
    Expect(0, 66383, '\P{Is_Blk=	gothic}', "");
    Expect(1, 66383, '\P{^Is_Blk=	gothic}', "");
    Expect(0, 66384, '\p{Is_Blk=	gothic}', "");
    Expect(1, 66384, '\p{^Is_Blk=	gothic}', "");
    Expect(1, 66384, '\P{Is_Blk=	gothic}', "");
    Expect(0, 66384, '\P{^Is_Blk=	gothic}', "");
    Error('\p{Block=/a/_Grantha}');
    Error('\P{Block=/a/_Grantha}');
    Expect(1, 70527, '\p{Block=:\AGrantha\z:}', "");;
    Expect(0, 70528, '\p{Block=:\AGrantha\z:}', "");;
    Expect(1, 70527, '\p{Block=grantha}', "");
    Expect(0, 70527, '\p{^Block=grantha}', "");
    Expect(0, 70527, '\P{Block=grantha}', "");
    Expect(1, 70527, '\P{^Block=grantha}', "");
    Expect(0, 70528, '\p{Block=grantha}', "");
    Expect(1, 70528, '\p{^Block=grantha}', "");
    Expect(1, 70528, '\P{Block=grantha}', "");
    Expect(0, 70528, '\P{^Block=grantha}', "");
    Expect(1, 70527, '\p{Block=:\Agrantha\z:}', "");;
    Expect(0, 70528, '\p{Block=:\Agrantha\z:}', "");;
    Expect(1, 70527, '\p{Block=_GRANTHA}', "");
    Expect(0, 70527, '\p{^Block=_GRANTHA}', "");
    Expect(0, 70527, '\P{Block=_GRANTHA}', "");
    Expect(1, 70527, '\P{^Block=_GRANTHA}', "");
    Expect(0, 70528, '\p{Block=_GRANTHA}', "");
    Expect(1, 70528, '\p{^Block=_GRANTHA}', "");
    Expect(1, 70528, '\P{Block=_GRANTHA}', "");
    Expect(0, 70528, '\P{^Block=_GRANTHA}', "");
    Error('\p{Blk: 	 GRANTHA/a/}');
    Error('\P{Blk: 	 GRANTHA/a/}');
    Expect(1, 70527, '\p{Blk=:\AGrantha\z:}', "");;
    Expect(0, 70528, '\p{Blk=:\AGrantha\z:}', "");;
    Expect(1, 70527, '\p{Blk=grantha}', "");
    Expect(0, 70527, '\p{^Blk=grantha}', "");
    Expect(0, 70527, '\P{Blk=grantha}', "");
    Expect(1, 70527, '\P{^Blk=grantha}', "");
    Expect(0, 70528, '\p{Blk=grantha}', "");
    Expect(1, 70528, '\p{^Blk=grantha}', "");
    Expect(1, 70528, '\P{Blk=grantha}', "");
    Expect(0, 70528, '\P{^Blk=grantha}', "");
    Expect(1, 70527, '\p{Blk=:\Agrantha\z:}', "");;
    Expect(0, 70528, '\p{Blk=:\Agrantha\z:}', "");;
    Expect(1, 70527, '\p{Blk=-GRANTHA}', "");
    Expect(0, 70527, '\p{^Blk=-GRANTHA}', "");
    Expect(0, 70527, '\P{Blk=-GRANTHA}', "");
    Expect(1, 70527, '\P{^Blk=-GRANTHA}', "");
    Expect(0, 70528, '\p{Blk=-GRANTHA}', "");
    Expect(1, 70528, '\p{^Blk=-GRANTHA}', "");
    Expect(1, 70528, '\P{Blk=-GRANTHA}', "");
    Expect(0, 70528, '\P{^Blk=-GRANTHA}', "");
    Error('\p{Is_Block=:=-grantha}');
    Error('\P{Is_Block=:=-grantha}');
    Expect(1, 70527, '\p{Is_Block=grantha}', "");
    Expect(0, 70527, '\p{^Is_Block=grantha}', "");
    Expect(0, 70527, '\P{Is_Block=grantha}', "");
    Expect(1, 70527, '\P{^Is_Block=grantha}', "");
    Expect(0, 70528, '\p{Is_Block=grantha}', "");
    Expect(1, 70528, '\p{^Is_Block=grantha}', "");
    Expect(1, 70528, '\P{Is_Block=grantha}', "");
    Expect(0, 70528, '\P{^Is_Block=grantha}', "");
    Expect(1, 70527, '\p{Is_Block= -Grantha}', "");
    Expect(0, 70527, '\p{^Is_Block= -Grantha}', "");
    Expect(0, 70527, '\P{Is_Block= -Grantha}', "");
    Expect(1, 70527, '\P{^Is_Block= -Grantha}', "");
    Expect(0, 70528, '\p{Is_Block= -Grantha}', "");
    Expect(1, 70528, '\p{^Is_Block= -Grantha}', "");
    Expect(1, 70528, '\P{Is_Block= -Grantha}', "");
    Expect(0, 70528, '\P{^Is_Block= -Grantha}', "");
    Error('\p{Is_Blk: -_Grantha/a/}');
    Error('\P{Is_Blk: -_Grantha/a/}');
    Expect(1, 70527, '\p{Is_Blk=grantha}', "");
    Expect(0, 70527, '\p{^Is_Blk=grantha}', "");
    Expect(0, 70527, '\P{Is_Blk=grantha}', "");
    Expect(1, 70527, '\P{^Is_Blk=grantha}', "");
    Expect(0, 70528, '\p{Is_Blk=grantha}', "");
    Expect(1, 70528, '\p{^Is_Blk=grantha}', "");
    Expect(1, 70528, '\P{Is_Blk=grantha}', "");
    Expect(0, 70528, '\P{^Is_Blk=grantha}', "");
    Expect(1, 70527, '\p{Is_Blk=_ Grantha}', "");
    Expect(0, 70527, '\p{^Is_Blk=_ Grantha}', "");
    Expect(0, 70527, '\P{Is_Blk=_ Grantha}', "");
    Expect(1, 70527, '\P{^Is_Blk=_ Grantha}', "");
    Expect(0, 70528, '\p{Is_Blk=_ Grantha}', "");
    Expect(1, 70528, '\p{^Is_Blk=_ Grantha}', "");
    Expect(1, 70528, '\P{Is_Blk=_ Grantha}', "");
    Expect(0, 70528, '\P{^Is_Blk=_ Grantha}', "");
    Error('\p{Block=_/a/GREEK_AND_Coptic}');
    Error('\P{Block=_/a/GREEK_AND_Coptic}');
    Expect(1, 1023, '\p{Block=:\AGreek_And_Coptic\z:}', "");;
    Expect(0, 1024, '\p{Block=:\AGreek_And_Coptic\z:}', "");;
    Expect(1, 1023, '\p{Block=greekandcoptic}', "");
    Expect(0, 1023, '\p{^Block=greekandcoptic}', "");
    Expect(0, 1023, '\P{Block=greekandcoptic}', "");
    Expect(1, 1023, '\P{^Block=greekandcoptic}', "");
    Expect(0, 1024, '\p{Block=greekandcoptic}', "");
    Expect(1, 1024, '\p{^Block=greekandcoptic}', "");
    Expect(1, 1024, '\P{Block=greekandcoptic}', "");
    Expect(0, 1024, '\P{^Block=greekandcoptic}', "");
    Expect(1, 1023, '\p{Block=:\Agreekandcoptic\z:}', "");;
    Expect(0, 1024, '\p{Block=:\Agreekandcoptic\z:}', "");;
    Expect(1, 1023, '\p{Block= Greek_And_coptic}', "");
    Expect(0, 1023, '\p{^Block= Greek_And_coptic}', "");
    Expect(0, 1023, '\P{Block= Greek_And_coptic}', "");
    Expect(1, 1023, '\P{^Block= Greek_And_coptic}', "");
    Expect(0, 1024, '\p{Block= Greek_And_coptic}', "");
    Expect(1, 1024, '\p{^Block= Greek_And_coptic}', "");
    Expect(1, 1024, '\P{Block= Greek_And_coptic}', "");
    Expect(0, 1024, '\P{^Block= Greek_And_coptic}', "");
    Error('\p{Blk= /a/greek}');
    Error('\P{Blk= /a/greek}');
    Expect(1, 1023, '\p{Blk=:\AGreek\z:}', "");;
    Expect(0, 1024, '\p{Blk=:\AGreek\z:}', "");;
    Expect(1, 1023, '\p{Blk=greek}', "");
    Expect(0, 1023, '\p{^Blk=greek}', "");
    Expect(0, 1023, '\P{Blk=greek}', "");
    Expect(1, 1023, '\P{^Blk=greek}', "");
    Expect(0, 1024, '\p{Blk=greek}', "");
    Expect(1, 1024, '\p{^Blk=greek}', "");
    Expect(1, 1024, '\P{Blk=greek}', "");
    Expect(0, 1024, '\P{^Blk=greek}', "");
    Expect(1, 1023, '\p{Blk=:\Agreek\z:}', "");;
    Expect(0, 1024, '\p{Blk=:\Agreek\z:}', "");;
    Expect(1, 1023, '\p{Blk=-	greek}', "");
    Expect(0, 1023, '\p{^Blk=-	greek}', "");
    Expect(0, 1023, '\P{Blk=-	greek}', "");
    Expect(1, 1023, '\P{^Blk=-	greek}', "");
    Expect(0, 1024, '\p{Blk=-	greek}', "");
    Expect(1, 1024, '\p{^Blk=-	greek}', "");
    Expect(1, 1024, '\P{Blk=-	greek}', "");
    Expect(0, 1024, '\P{^Blk=-	greek}', "");
    Error('\p{Is_Block=_:=greek_And_Coptic}');
    Error('\P{Is_Block=_:=greek_And_Coptic}');
    Expect(1, 1023, '\p{Is_Block=greekandcoptic}', "");
    Expect(0, 1023, '\p{^Is_Block=greekandcoptic}', "");
    Expect(0, 1023, '\P{Is_Block=greekandcoptic}', "");
    Expect(1, 1023, '\P{^Is_Block=greekandcoptic}', "");
    Expect(0, 1024, '\p{Is_Block=greekandcoptic}', "");
    Expect(1, 1024, '\p{^Is_Block=greekandcoptic}', "");
    Expect(1, 1024, '\P{Is_Block=greekandcoptic}', "");
    Expect(0, 1024, '\P{^Is_Block=greekandcoptic}', "");
    Expect(1, 1023, '\p{Is_Block=_ Greek_AND_COPTIC}', "");
    Expect(0, 1023, '\p{^Is_Block=_ Greek_AND_COPTIC}', "");
    Expect(0, 1023, '\P{Is_Block=_ Greek_AND_COPTIC}', "");
    Expect(1, 1023, '\P{^Is_Block=_ Greek_AND_COPTIC}', "");
    Expect(0, 1024, '\p{Is_Block=_ Greek_AND_COPTIC}', "");
    Expect(1, 1024, '\p{^Is_Block=_ Greek_AND_COPTIC}', "");
    Expect(1, 1024, '\P{Is_Block=_ Greek_AND_COPTIC}', "");
    Expect(0, 1024, '\P{^Is_Block=_ Greek_AND_COPTIC}', "");
    Error('\p{Is_Blk=		Greek:=}');
    Error('\P{Is_Blk=		Greek:=}');
    Expect(1, 1023, '\p{Is_Blk=greek}', "");
    Expect(0, 1023, '\p{^Is_Blk=greek}', "");
    Expect(0, 1023, '\P{Is_Blk=greek}', "");
    Expect(1, 1023, '\P{^Is_Blk=greek}', "");
    Expect(0, 1024, '\p{Is_Blk=greek}', "");
    Expect(1, 1024, '\p{^Is_Blk=greek}', "");
    Expect(1, 1024, '\P{Is_Blk=greek}', "");
    Expect(0, 1024, '\P{^Is_Blk=greek}', "");
    Expect(1, 1023, '\p{Is_Blk=-	Greek}', "");
    Expect(0, 1023, '\p{^Is_Blk=-	Greek}', "");
    Expect(0, 1023, '\P{Is_Blk=-	Greek}', "");
    Expect(1, 1023, '\P{^Is_Blk=-	Greek}', "");
    Expect(0, 1024, '\p{Is_Blk=-	Greek}', "");
    Expect(1, 1024, '\p{^Is_Blk=-	Greek}', "");
    Expect(1, 1024, '\P{Is_Blk=-	Greek}', "");
    Expect(0, 1024, '\P{^Is_Blk=-	Greek}', "");
    Error('\p{Block=Greek_EXTENDED:=}');
    Error('\P{Block=Greek_EXTENDED:=}');
    Expect(1, 8191, '\p{Block=:\AGreek_Extended\z:}', "");;
    Expect(0, 8192, '\p{Block=:\AGreek_Extended\z:}', "");;
    Expect(1, 8191, '\p{Block=greekextended}', "");
    Expect(0, 8191, '\p{^Block=greekextended}', "");
    Expect(0, 8191, '\P{Block=greekextended}', "");
    Expect(1, 8191, '\P{^Block=greekextended}', "");
    Expect(0, 8192, '\p{Block=greekextended}', "");
    Expect(1, 8192, '\p{^Block=greekextended}', "");
    Expect(1, 8192, '\P{Block=greekextended}', "");
    Expect(0, 8192, '\P{^Block=greekextended}', "");
    Expect(1, 8191, '\p{Block=:\Agreekextended\z:}', "");;
    Expect(0, 8192, '\p{Block=:\Agreekextended\z:}', "");;
    Expect(1, 8191, '\p{Block= greek_Extended}', "");
    Expect(0, 8191, '\p{^Block= greek_Extended}', "");
    Expect(0, 8191, '\P{Block= greek_Extended}', "");
    Expect(1, 8191, '\P{^Block= greek_Extended}', "");
    Expect(0, 8192, '\p{Block= greek_Extended}', "");
    Expect(1, 8192, '\p{^Block= greek_Extended}', "");
    Expect(1, 8192, '\P{Block= greek_Extended}', "");
    Expect(0, 8192, '\P{^Block= greek_Extended}', "");
    Error('\p{Blk=	:=greek_EXT}');
    Error('\P{Blk=	:=greek_EXT}');
    Expect(1, 8191, '\p{Blk=:\AGreek_Ext\z:}', "");;
    Expect(0, 8192, '\p{Blk=:\AGreek_Ext\z:}', "");;
    Expect(1, 8191, '\p{Blk=greekext}', "");
    Expect(0, 8191, '\p{^Blk=greekext}', "");
    Expect(0, 8191, '\P{Blk=greekext}', "");
    Expect(1, 8191, '\P{^Blk=greekext}', "");
    Expect(0, 8192, '\p{Blk=greekext}', "");
    Expect(1, 8192, '\p{^Blk=greekext}', "");
    Expect(1, 8192, '\P{Blk=greekext}', "");
    Expect(0, 8192, '\P{^Blk=greekext}', "");
    Expect(1, 8191, '\p{Blk=:\Agreekext\z:}', "");;
    Expect(0, 8192, '\p{Blk=:\Agreekext\z:}', "");;
    Expect(1, 8191, '\p{Blk=__Greek_Ext}', "");
    Expect(0, 8191, '\p{^Blk=__Greek_Ext}', "");
    Expect(0, 8191, '\P{Blk=__Greek_Ext}', "");
    Expect(1, 8191, '\P{^Blk=__Greek_Ext}', "");
    Expect(0, 8192, '\p{Blk=__Greek_Ext}', "");
    Expect(1, 8192, '\p{^Blk=__Greek_Ext}', "");
    Expect(1, 8192, '\P{Blk=__Greek_Ext}', "");
    Expect(0, 8192, '\P{^Blk=__Greek_Ext}', "");
    Error('\p{Is_Block=-greek_extended/a/}');
    Error('\P{Is_Block=-greek_extended/a/}');
    Expect(1, 8191, '\p{Is_Block=greekextended}', "");
    Expect(0, 8191, '\p{^Is_Block=greekextended}', "");
    Expect(0, 8191, '\P{Is_Block=greekextended}', "");
    Expect(1, 8191, '\P{^Is_Block=greekextended}', "");
    Expect(0, 8192, '\p{Is_Block=greekextended}', "");
    Expect(1, 8192, '\p{^Is_Block=greekextended}', "");
    Expect(1, 8192, '\P{Is_Block=greekextended}', "");
    Expect(0, 8192, '\P{^Is_Block=greekextended}', "");
    Expect(1, 8191, '\p{Is_Block=	GREEK_EXTENDED}', "");
    Expect(0, 8191, '\p{^Is_Block=	GREEK_EXTENDED}', "");
    Expect(0, 8191, '\P{Is_Block=	GREEK_EXTENDED}', "");
    Expect(1, 8191, '\P{^Is_Block=	GREEK_EXTENDED}', "");
    Expect(0, 8192, '\p{Is_Block=	GREEK_EXTENDED}', "");
    Expect(1, 8192, '\p{^Is_Block=	GREEK_EXTENDED}', "");
    Expect(1, 8192, '\P{Is_Block=	GREEK_EXTENDED}', "");
    Expect(0, 8192, '\P{^Is_Block=	GREEK_EXTENDED}', "");
    Error('\p{Is_Blk=/a/- greek_Ext}');
    Error('\P{Is_Blk=/a/- greek_Ext}');
    Expect(1, 8191, '\p{Is_Blk:greekext}', "");
    Expect(0, 8191, '\p{^Is_Blk:greekext}', "");
    Expect(0, 8191, '\P{Is_Blk:greekext}', "");
    Expect(1, 8191, '\P{^Is_Blk:greekext}', "");
    Expect(0, 8192, '\p{Is_Blk:greekext}', "");
    Expect(1, 8192, '\p{^Is_Blk:greekext}', "");
    Expect(1, 8192, '\P{Is_Blk:greekext}', "");
    Expect(0, 8192, '\P{^Is_Blk:greekext}', "");
    Expect(1, 8191, '\p{Is_Blk=-_Greek_Ext}', "");
    Expect(0, 8191, '\p{^Is_Blk=-_Greek_Ext}', "");
    Expect(0, 8191, '\P{Is_Blk=-_Greek_Ext}', "");
    Expect(1, 8191, '\P{^Is_Blk=-_Greek_Ext}', "");
    Expect(0, 8192, '\p{Is_Blk=-_Greek_Ext}', "");
    Expect(1, 8192, '\p{^Is_Blk=-_Greek_Ext}', "");
    Expect(1, 8192, '\P{Is_Blk=-_Greek_Ext}', "");
    Expect(0, 8192, '\P{^Is_Blk=-_Greek_Ext}', "");
    Error('\p{Block=:=gujarati}');
    Error('\P{Block=:=gujarati}');
    Expect(1, 2815, '\p{Block=:\AGujarati\z:}', "");;
    Expect(0, 2816, '\p{Block=:\AGujarati\z:}', "");;
    Expect(1, 2815, '\p{Block=gujarati}', "");
    Expect(0, 2815, '\p{^Block=gujarati}', "");
    Expect(0, 2815, '\P{Block=gujarati}', "");
    Expect(1, 2815, '\P{^Block=gujarati}', "");
    Expect(0, 2816, '\p{Block=gujarati}', "");
    Expect(1, 2816, '\p{^Block=gujarati}', "");
    Expect(1, 2816, '\P{Block=gujarati}', "");
    Expect(0, 2816, '\P{^Block=gujarati}', "");
    Expect(1, 2815, '\p{Block=:\Agujarati\z:}', "");;
    Expect(0, 2816, '\p{Block=:\Agujarati\z:}', "");;
    Expect(1, 2815, '\p{Block= -gujarati}', "");
    Expect(0, 2815, '\p{^Block= -gujarati}', "");
    Expect(0, 2815, '\P{Block= -gujarati}', "");
    Expect(1, 2815, '\P{^Block= -gujarati}', "");
    Expect(0, 2816, '\p{Block= -gujarati}', "");
    Expect(1, 2816, '\p{^Block= -gujarati}', "");
    Expect(1, 2816, '\P{Block= -gujarati}', "");
    Expect(0, 2816, '\P{^Block= -gujarati}', "");
    Error('\p{Blk=/a/	-Gujarati}');
    Error('\P{Blk=/a/	-Gujarati}');
    Expect(1, 2815, '\p{Blk=:\AGujarati\z:}', "");;
    Expect(0, 2816, '\p{Blk=:\AGujarati\z:}', "");;
    Expect(1, 2815, '\p{Blk=gujarati}', "");
    Expect(0, 2815, '\p{^Blk=gujarati}', "");
    Expect(0, 2815, '\P{Blk=gujarati}', "");
    Expect(1, 2815, '\P{^Blk=gujarati}', "");
    Expect(0, 2816, '\p{Blk=gujarati}', "");
    Expect(1, 2816, '\p{^Blk=gujarati}', "");
    Expect(1, 2816, '\P{Blk=gujarati}', "");
    Expect(0, 2816, '\P{^Blk=gujarati}', "");
    Expect(1, 2815, '\p{Blk=:\Agujarati\z:}', "");;
    Expect(0, 2816, '\p{Blk=:\Agujarati\z:}', "");;
    Expect(1, 2815, '\p{Blk= gujarati}', "");
    Expect(0, 2815, '\p{^Blk= gujarati}', "");
    Expect(0, 2815, '\P{Blk= gujarati}', "");
    Expect(1, 2815, '\P{^Blk= gujarati}', "");
    Expect(0, 2816, '\p{Blk= gujarati}', "");
    Expect(1, 2816, '\p{^Blk= gujarati}', "");
    Expect(1, 2816, '\P{Blk= gujarati}', "");
    Expect(0, 2816, '\P{^Blk= gujarati}', "");
    Error('\p{Is_Block= GUJARATI:=}');
    Error('\P{Is_Block= GUJARATI:=}');
    Expect(1, 2815, '\p{Is_Block=gujarati}', "");
    Expect(0, 2815, '\p{^Is_Block=gujarati}', "");
    Expect(0, 2815, '\P{Is_Block=gujarati}', "");
    Expect(1, 2815, '\P{^Is_Block=gujarati}', "");
    Expect(0, 2816, '\p{Is_Block=gujarati}', "");
    Expect(1, 2816, '\p{^Is_Block=gujarati}', "");
    Expect(1, 2816, '\P{Is_Block=gujarati}', "");
    Expect(0, 2816, '\P{^Is_Block=gujarati}', "");
    Expect(1, 2815, '\p{Is_Block:-GUJARATI}', "");
    Expect(0, 2815, '\p{^Is_Block:-GUJARATI}', "");
    Expect(0, 2815, '\P{Is_Block:-GUJARATI}', "");
    Expect(1, 2815, '\P{^Is_Block:-GUJARATI}', "");
    Expect(0, 2816, '\p{Is_Block:-GUJARATI}', "");
    Expect(1, 2816, '\p{^Is_Block:-GUJARATI}', "");
    Expect(1, 2816, '\P{Is_Block:-GUJARATI}', "");
    Expect(0, 2816, '\P{^Is_Block:-GUJARATI}', "");
    Error('\p{Is_Blk=:=-Gujarati}');
    Error('\P{Is_Blk=:=-Gujarati}');
    Expect(1, 2815, '\p{Is_Blk=gujarati}', "");
    Expect(0, 2815, '\p{^Is_Blk=gujarati}', "");
    Expect(0, 2815, '\P{Is_Blk=gujarati}', "");
    Expect(1, 2815, '\P{^Is_Blk=gujarati}', "");
    Expect(0, 2816, '\p{Is_Blk=gujarati}', "");
    Expect(1, 2816, '\p{^Is_Blk=gujarati}', "");
    Expect(1, 2816, '\P{Is_Blk=gujarati}', "");
    Expect(0, 2816, '\P{^Is_Blk=gujarati}', "");
    Expect(1, 2815, '\p{Is_Blk=_Gujarati}', "");
    Expect(0, 2815, '\p{^Is_Blk=_Gujarati}', "");
    Expect(0, 2815, '\P{Is_Blk=_Gujarati}', "");
    Expect(1, 2815, '\P{^Is_Blk=_Gujarati}', "");
    Expect(0, 2816, '\p{Is_Blk=_Gujarati}', "");
    Expect(1, 2816, '\p{^Is_Blk=_Gujarati}', "");
    Expect(1, 2816, '\P{Is_Blk=_Gujarati}', "");
    Expect(0, 2816, '\P{^Is_Blk=_Gujarati}', "");
    Error('\p{Block=	:=Gunjala_gondi}');
    Error('\P{Block=	:=Gunjala_gondi}');
    Expect(1, 73135, '\p{Block=:\AGunjala_Gondi\z:}', "");;
    Expect(0, 73136, '\p{Block=:\AGunjala_Gondi\z:}', "");;
    Expect(1, 73135, '\p{Block:gunjalagondi}', "");
    Expect(0, 73135, '\p{^Block:gunjalagondi}', "");
    Expect(0, 73135, '\P{Block:gunjalagondi}', "");
    Expect(1, 73135, '\P{^Block:gunjalagondi}', "");
    Expect(0, 73136, '\p{Block:gunjalagondi}', "");
    Expect(1, 73136, '\p{^Block:gunjalagondi}', "");
    Expect(1, 73136, '\P{Block:gunjalagondi}', "");
    Expect(0, 73136, '\P{^Block:gunjalagondi}', "");
    Expect(1, 73135, '\p{Block=:\Agunjalagondi\z:}', "");;
    Expect(0, 73136, '\p{Block=:\Agunjalagondi\z:}', "");;
    Expect(1, 73135, '\p{Block=-	gunjala_Gondi}', "");
    Expect(0, 73135, '\p{^Block=-	gunjala_Gondi}', "");
    Expect(0, 73135, '\P{Block=-	gunjala_Gondi}', "");
    Expect(1, 73135, '\P{^Block=-	gunjala_Gondi}', "");
    Expect(0, 73136, '\p{Block=-	gunjala_Gondi}', "");
    Expect(1, 73136, '\p{^Block=-	gunjala_Gondi}', "");
    Expect(1, 73136, '\P{Block=-	gunjala_Gondi}', "");
    Expect(0, 73136, '\P{^Block=-	gunjala_Gondi}', "");
    Error('\p{Blk=		GUNJALA_Gondi:=}');
    Error('\P{Blk=		GUNJALA_Gondi:=}');
    Expect(1, 73135, '\p{Blk=:\AGunjala_Gondi\z:}', "");;
    Expect(0, 73136, '\p{Blk=:\AGunjala_Gondi\z:}', "");;
    Expect(1, 73135, '\p{Blk=gunjalagondi}', "");
    Expect(0, 73135, '\p{^Blk=gunjalagondi}', "");
    Expect(0, 73135, '\P{Blk=gunjalagondi}', "");
    Expect(1, 73135, '\P{^Blk=gunjalagondi}', "");
    Expect(0, 73136, '\p{Blk=gunjalagondi}', "");
    Expect(1, 73136, '\p{^Blk=gunjalagondi}', "");
    Expect(1, 73136, '\P{Blk=gunjalagondi}', "");
    Expect(0, 73136, '\P{^Blk=gunjalagondi}', "");
    Expect(1, 73135, '\p{Blk=:\Agunjalagondi\z:}', "");;
    Expect(0, 73136, '\p{Blk=:\Agunjalagondi\z:}', "");;
    Expect(1, 73135, '\p{Blk=--GUNJALA_Gondi}', "");
    Expect(0, 73135, '\p{^Blk=--GUNJALA_Gondi}', "");
    Expect(0, 73135, '\P{Blk=--GUNJALA_Gondi}', "");
    Expect(1, 73135, '\P{^Blk=--GUNJALA_Gondi}', "");
    Expect(0, 73136, '\p{Blk=--GUNJALA_Gondi}', "");
    Expect(1, 73136, '\p{^Blk=--GUNJALA_Gondi}', "");
    Expect(1, 73136, '\P{Blk=--GUNJALA_Gondi}', "");
    Expect(0, 73136, '\P{^Blk=--GUNJALA_Gondi}', "");
    Error('\p{Is_Block=	:=Gunjala_Gondi}');
    Error('\P{Is_Block=	:=Gunjala_Gondi}');
    Expect(1, 73135, '\p{Is_Block=gunjalagondi}', "");
    Expect(0, 73135, '\p{^Is_Block=gunjalagondi}', "");
    Expect(0, 73135, '\P{Is_Block=gunjalagondi}', "");
    Expect(1, 73135, '\P{^Is_Block=gunjalagondi}', "");
    Expect(0, 73136, '\p{Is_Block=gunjalagondi}', "");
    Expect(1, 73136, '\p{^Is_Block=gunjalagondi}', "");
    Expect(1, 73136, '\P{Is_Block=gunjalagondi}', "");
    Expect(0, 73136, '\P{^Is_Block=gunjalagondi}', "");
    Expect(1, 73135, '\p{Is_Block=		gunjala_Gondi}', "");
    Expect(0, 73135, '\p{^Is_Block=		gunjala_Gondi}', "");
    Expect(0, 73135, '\P{Is_Block=		gunjala_Gondi}', "");
    Expect(1, 73135, '\P{^Is_Block=		gunjala_Gondi}', "");
    Expect(0, 73136, '\p{Is_Block=		gunjala_Gondi}', "");
    Expect(1, 73136, '\p{^Is_Block=		gunjala_Gondi}', "");
    Expect(1, 73136, '\P{Is_Block=		gunjala_Gondi}', "");
    Expect(0, 73136, '\P{^Is_Block=		gunjala_Gondi}', "");
    Error('\p{Is_Blk=:=	GUNJALA_Gondi}');
    Error('\P{Is_Blk=:=	GUNJALA_Gondi}');
    Expect(1, 73135, '\p{Is_Blk=gunjalagondi}', "");
    Expect(0, 73135, '\p{^Is_Blk=gunjalagondi}', "");
    Expect(0, 73135, '\P{Is_Blk=gunjalagondi}', "");
    Expect(1, 73135, '\P{^Is_Blk=gunjalagondi}', "");
    Expect(0, 73136, '\p{Is_Blk=gunjalagondi}', "");
    Expect(1, 73136, '\p{^Is_Blk=gunjalagondi}', "");
    Expect(1, 73136, '\P{Is_Blk=gunjalagondi}', "");
    Expect(0, 73136, '\P{^Is_Blk=gunjalagondi}', "");
    Expect(1, 73135, '\p{Is_Blk:    _gunjala_gondi}', "");
    Expect(0, 73135, '\p{^Is_Blk:    _gunjala_gondi}', "");
    Expect(0, 73135, '\P{Is_Blk:    _gunjala_gondi}', "");
    Expect(1, 73135, '\P{^Is_Blk:    _gunjala_gondi}', "");
    Expect(0, 73136, '\p{Is_Blk:    _gunjala_gondi}', "");
    Expect(1, 73136, '\p{^Is_Blk:    _gunjala_gondi}', "");
    Expect(1, 73136, '\P{Is_Blk:    _gunjala_gondi}', "");
    Expect(0, 73136, '\P{^Is_Blk:    _gunjala_gondi}', "");
    Error('\p{Block: _:=Gurmukhi}');
    Error('\P{Block: _:=Gurmukhi}');
    Expect(1, 2687, '\p{Block=:\AGurmukhi\z:}', "");;
    Expect(0, 2688, '\p{Block=:\AGurmukhi\z:}', "");;
    Expect(1, 2687, '\p{Block=gurmukhi}', "");
    Expect(0, 2687, '\p{^Block=gurmukhi}', "");
    Expect(0, 2687, '\P{Block=gurmukhi}', "");
    Expect(1, 2687, '\P{^Block=gurmukhi}', "");
    Expect(0, 2688, '\p{Block=gurmukhi}', "");
    Expect(1, 2688, '\p{^Block=gurmukhi}', "");
    Expect(1, 2688, '\P{Block=gurmukhi}', "");
    Expect(0, 2688, '\P{^Block=gurmukhi}', "");
    Expect(1, 2687, '\p{Block=:\Agurmukhi\z:}', "");;
    Expect(0, 2688, '\p{Block=:\Agurmukhi\z:}', "");;
    Expect(1, 2687, '\p{Block=	gurmukhi}', "");
    Expect(0, 2687, '\p{^Block=	gurmukhi}', "");
    Expect(0, 2687, '\P{Block=	gurmukhi}', "");
    Expect(1, 2687, '\P{^Block=	gurmukhi}', "");
    Expect(0, 2688, '\p{Block=	gurmukhi}', "");
    Expect(1, 2688, '\p{^Block=	gurmukhi}', "");
    Expect(1, 2688, '\P{Block=	gurmukhi}', "");
    Expect(0, 2688, '\P{^Block=	gurmukhi}', "");
    Error('\p{Blk=:=Gurmukhi}');
    Error('\P{Blk=:=Gurmukhi}');
    Expect(1, 2687, '\p{Blk=:\AGurmukhi\z:}', "");;
    Expect(0, 2688, '\p{Blk=:\AGurmukhi\z:}', "");;
    Expect(1, 2687, '\p{Blk=gurmukhi}', "");
    Expect(0, 2687, '\p{^Blk=gurmukhi}', "");
    Expect(0, 2687, '\P{Blk=gurmukhi}', "");
    Expect(1, 2687, '\P{^Blk=gurmukhi}', "");
    Expect(0, 2688, '\p{Blk=gurmukhi}', "");
    Expect(1, 2688, '\p{^Blk=gurmukhi}', "");
    Expect(1, 2688, '\P{Blk=gurmukhi}', "");
    Expect(0, 2688, '\P{^Blk=gurmukhi}', "");
    Expect(1, 2687, '\p{Blk=:\Agurmukhi\z:}', "");;
    Expect(0, 2688, '\p{Blk=:\Agurmukhi\z:}', "");;
    Expect(1, 2687, '\p{Blk=	GURMUKHI}', "");
    Expect(0, 2687, '\p{^Blk=	GURMUKHI}', "");
    Expect(0, 2687, '\P{Blk=	GURMUKHI}', "");
    Expect(1, 2687, '\P{^Blk=	GURMUKHI}', "");
    Expect(0, 2688, '\p{Blk=	GURMUKHI}', "");
    Expect(1, 2688, '\p{^Blk=	GURMUKHI}', "");
    Expect(1, 2688, '\P{Blk=	GURMUKHI}', "");
    Expect(0, 2688, '\P{^Blk=	GURMUKHI}', "");
    Error('\p{Is_Block:   	:=Gurmukhi}');
    Error('\P{Is_Block:   	:=Gurmukhi}');
    Expect(1, 2687, '\p{Is_Block=gurmukhi}', "");
    Expect(0, 2687, '\p{^Is_Block=gurmukhi}', "");
    Expect(0, 2687, '\P{Is_Block=gurmukhi}', "");
    Expect(1, 2687, '\P{^Is_Block=gurmukhi}', "");
    Expect(0, 2688, '\p{Is_Block=gurmukhi}', "");
    Expect(1, 2688, '\p{^Is_Block=gurmukhi}', "");
    Expect(1, 2688, '\P{Is_Block=gurmukhi}', "");
    Expect(0, 2688, '\P{^Is_Block=gurmukhi}', "");
    Expect(1, 2687, '\p{Is_Block:	- Gurmukhi}', "");
    Expect(0, 2687, '\p{^Is_Block:	- Gurmukhi}', "");
    Expect(0, 2687, '\P{Is_Block:	- Gurmukhi}', "");
    Expect(1, 2687, '\P{^Is_Block:	- Gurmukhi}', "");
    Expect(0, 2688, '\p{Is_Block:	- Gurmukhi}', "");
    Expect(1, 2688, '\p{^Is_Block:	- Gurmukhi}', "");
    Expect(1, 2688, '\P{Is_Block:	- Gurmukhi}', "");
    Expect(0, 2688, '\P{^Is_Block:	- Gurmukhi}', "");
    Error('\p{Is_Blk=  gurmukhi:=}');
    Error('\P{Is_Blk=  gurmukhi:=}');
    Expect(1, 2687, '\p{Is_Blk=gurmukhi}', "");
    Expect(0, 2687, '\p{^Is_Blk=gurmukhi}', "");
    Expect(0, 2687, '\P{Is_Blk=gurmukhi}', "");
    Expect(1, 2687, '\P{^Is_Blk=gurmukhi}', "");
    Expect(0, 2688, '\p{Is_Blk=gurmukhi}', "");
    Expect(1, 2688, '\p{^Is_Blk=gurmukhi}', "");
    Expect(1, 2688, '\P{Is_Blk=gurmukhi}', "");
    Expect(0, 2688, '\P{^Is_Blk=gurmukhi}', "");
    Expect(1, 2687, '\p{Is_Blk=_Gurmukhi}', "");
    Expect(0, 2687, '\p{^Is_Blk=_Gurmukhi}', "");
    Expect(0, 2687, '\P{Is_Blk=_Gurmukhi}', "");
    Expect(1, 2687, '\P{^Is_Blk=_Gurmukhi}', "");
    Expect(0, 2688, '\p{Is_Blk=_Gurmukhi}', "");
    Expect(1, 2688, '\p{^Is_Blk=_Gurmukhi}', "");
    Expect(1, 2688, '\P{Is_Blk=_Gurmukhi}', "");
    Expect(0, 2688, '\P{^Is_Blk=_Gurmukhi}', "");
    Error('\p{Block=/a/	HALFWIDTH_And_Fullwidth_FORMS}');
    Error('\P{Block=/a/	HALFWIDTH_And_Fullwidth_FORMS}');
    Expect(1, 65519, '\p{Block=:\AHalfwidth_And_Fullwidth_Forms\z:}', "");;
    Expect(0, 65520, '\p{Block=:\AHalfwidth_And_Fullwidth_Forms\z:}', "");;
    Expect(1, 65519, '\p{Block=halfwidthandfullwidthforms}', "");
    Expect(0, 65519, '\p{^Block=halfwidthandfullwidthforms}', "");
    Expect(0, 65519, '\P{Block=halfwidthandfullwidthforms}', "");
    Expect(1, 65519, '\P{^Block=halfwidthandfullwidthforms}', "");
    Expect(0, 65520, '\p{Block=halfwidthandfullwidthforms}', "");
    Expect(1, 65520, '\p{^Block=halfwidthandfullwidthforms}', "");
    Expect(1, 65520, '\P{Block=halfwidthandfullwidthforms}', "");
    Expect(0, 65520, '\P{^Block=halfwidthandfullwidthforms}', "");
    Expect(1, 65519, '\p{Block=:\Ahalfwidthandfullwidthforms\z:}', "");;
    Expect(0, 65520, '\p{Block=:\Ahalfwidthandfullwidthforms\z:}', "");;
    Expect(1, 65519, '\p{Block=	-HALFWIDTH_AND_Fullwidth_forms}', "");
    Expect(0, 65519, '\p{^Block=	-HALFWIDTH_AND_Fullwidth_forms}', "");
    Expect(0, 65519, '\P{Block=	-HALFWIDTH_AND_Fullwidth_forms}', "");
    Expect(1, 65519, '\P{^Block=	-HALFWIDTH_AND_Fullwidth_forms}', "");
    Expect(0, 65520, '\p{Block=	-HALFWIDTH_AND_Fullwidth_forms}', "");
    Expect(1, 65520, '\p{^Block=	-HALFWIDTH_AND_Fullwidth_forms}', "");
    Expect(1, 65520, '\P{Block=	-HALFWIDTH_AND_Fullwidth_forms}', "");
    Expect(0, 65520, '\P{^Block=	-HALFWIDTH_AND_Fullwidth_forms}', "");
    Error('\p{Blk=-/a/half_And_Full_FORMS}');
    Error('\P{Blk=-/a/half_And_Full_FORMS}');
    Expect(1, 65519, '\p{Blk=:\AHalf_And_Full_Forms\z:}', "");;
    Expect(0, 65520, '\p{Blk=:\AHalf_And_Full_Forms\z:}', "");;
    Expect(1, 65519, '\p{Blk=halfandfullforms}', "");
    Expect(0, 65519, '\p{^Blk=halfandfullforms}', "");
    Expect(0, 65519, '\P{Blk=halfandfullforms}', "");
    Expect(1, 65519, '\P{^Blk=halfandfullforms}', "");
    Expect(0, 65520, '\p{Blk=halfandfullforms}', "");
    Expect(1, 65520, '\p{^Blk=halfandfullforms}', "");
    Expect(1, 65520, '\P{Blk=halfandfullforms}', "");
    Expect(0, 65520, '\P{^Blk=halfandfullforms}', "");
    Expect(1, 65519, '\p{Blk=:\Ahalfandfullforms\z:}', "");;
    Expect(0, 65520, '\p{Blk=:\Ahalfandfullforms\z:}', "");;
    Expect(1, 65519, '\p{Blk=	-Half_And_Full_FORMS}', "");
    Expect(0, 65519, '\p{^Blk=	-Half_And_Full_FORMS}', "");
    Expect(0, 65519, '\P{Blk=	-Half_And_Full_FORMS}', "");
    Expect(1, 65519, '\P{^Blk=	-Half_And_Full_FORMS}', "");
    Expect(0, 65520, '\p{Blk=	-Half_And_Full_FORMS}', "");
    Expect(1, 65520, '\p{^Blk=	-Half_And_Full_FORMS}', "");
    Expect(1, 65520, '\P{Blk=	-Half_And_Full_FORMS}', "");
    Expect(0, 65520, '\P{^Blk=	-Half_And_Full_FORMS}', "");
    Error('\p{Is_Block=  Halfwidth_AND_fullwidth_Forms:=}');
    Error('\P{Is_Block=  Halfwidth_AND_fullwidth_Forms:=}');
    Expect(1, 65519, '\p{Is_Block=halfwidthandfullwidthforms}', "");
    Expect(0, 65519, '\p{^Is_Block=halfwidthandfullwidthforms}', "");
    Expect(0, 65519, '\P{Is_Block=halfwidthandfullwidthforms}', "");
    Expect(1, 65519, '\P{^Is_Block=halfwidthandfullwidthforms}', "");
    Expect(0, 65520, '\p{Is_Block=halfwidthandfullwidthforms}', "");
    Expect(1, 65520, '\p{^Is_Block=halfwidthandfullwidthforms}', "");
    Expect(1, 65520, '\P{Is_Block=halfwidthandfullwidthforms}', "");
    Expect(0, 65520, '\P{^Is_Block=halfwidthandfullwidthforms}', "");
    Expect(1, 65519, '\p{Is_Block=  Halfwidth_And_FULLWIDTH_FORMS}', "");
    Expect(0, 65519, '\p{^Is_Block=  Halfwidth_And_FULLWIDTH_FORMS}', "");
    Expect(0, 65519, '\P{Is_Block=  Halfwidth_And_FULLWIDTH_FORMS}', "");
    Expect(1, 65519, '\P{^Is_Block=  Halfwidth_And_FULLWIDTH_FORMS}', "");
    Expect(0, 65520, '\p{Is_Block=  Halfwidth_And_FULLWIDTH_FORMS}', "");
    Expect(1, 65520, '\p{^Is_Block=  Halfwidth_And_FULLWIDTH_FORMS}', "");
    Expect(1, 65520, '\P{Is_Block=  Halfwidth_And_FULLWIDTH_FORMS}', "");
    Expect(0, 65520, '\P{^Is_Block=  Halfwidth_And_FULLWIDTH_FORMS}', "");
    Error('\p{Is_Blk=	-Half_And_full_Forms:=}');
    Error('\P{Is_Blk=	-Half_And_full_Forms:=}');
    Expect(1, 65519, '\p{Is_Blk=halfandfullforms}', "");
    Expect(0, 65519, '\p{^Is_Blk=halfandfullforms}', "");
    Expect(0, 65519, '\P{Is_Blk=halfandfullforms}', "");
    Expect(1, 65519, '\P{^Is_Blk=halfandfullforms}', "");
    Expect(0, 65520, '\p{Is_Blk=halfandfullforms}', "");
    Expect(1, 65520, '\p{^Is_Blk=halfandfullforms}', "");
    Expect(1, 65520, '\P{Is_Blk=halfandfullforms}', "");
    Expect(0, 65520, '\P{^Is_Blk=halfandfullforms}', "");
    Expect(1, 65519, '\p{Is_Blk:   	Half_and_Full_forms}', "");
    Expect(0, 65519, '\p{^Is_Blk:   	Half_and_Full_forms}', "");
    Expect(0, 65519, '\P{Is_Blk:   	Half_and_Full_forms}', "");
    Expect(1, 65519, '\P{^Is_Blk:   	Half_and_Full_forms}', "");
    Expect(0, 65520, '\p{Is_Blk:   	Half_and_Full_forms}', "");
    Expect(1, 65520, '\p{^Is_Blk:   	Half_and_Full_forms}', "");
    Expect(1, 65520, '\P{Is_Blk:   	Half_and_Full_forms}', "");
    Expect(0, 65520, '\P{^Is_Blk:   	Half_and_Full_forms}', "");
    Error('\p{Block=:=-	Combining_Half_MARKS}');
    Error('\P{Block=:=-	Combining_Half_MARKS}');
    Expect(1, 65071, '\p{Block=:\ACombining_Half_Marks\z:}', "");;
    Expect(0, 65072, '\p{Block=:\ACombining_Half_Marks\z:}', "");;
    Expect(1, 65071, '\p{Block:   combininghalfmarks}', "");
    Expect(0, 65071, '\p{^Block:   combininghalfmarks}', "");
    Expect(0, 65071, '\P{Block:   combininghalfmarks}', "");
    Expect(1, 65071, '\P{^Block:   combininghalfmarks}', "");
    Expect(0, 65072, '\p{Block:   combininghalfmarks}', "");
    Expect(1, 65072, '\p{^Block:   combininghalfmarks}', "");
    Expect(1, 65072, '\P{Block:   combininghalfmarks}', "");
    Expect(0, 65072, '\P{^Block:   combininghalfmarks}', "");
    Expect(1, 65071, '\p{Block=:\Acombininghalfmarks\z:}', "");;
    Expect(0, 65072, '\p{Block=:\Acombininghalfmarks\z:}', "");;
    Expect(1, 65071, '\p{Block=--Combining_Half_Marks}', "");
    Expect(0, 65071, '\p{^Block=--Combining_Half_Marks}', "");
    Expect(0, 65071, '\P{Block=--Combining_Half_Marks}', "");
    Expect(1, 65071, '\P{^Block=--Combining_Half_Marks}', "");
    Expect(0, 65072, '\p{Block=--Combining_Half_Marks}', "");
    Expect(1, 65072, '\p{^Block=--Combining_Half_Marks}', "");
    Expect(1, 65072, '\P{Block=--Combining_Half_Marks}', "");
    Expect(0, 65072, '\P{^Block=--Combining_Half_Marks}', "");
    Error('\p{Blk=:= Half_Marks}');
    Error('\P{Blk=:= Half_Marks}');
    Expect(1, 65071, '\p{Blk=:\AHalf_Marks\z:}', "");;
    Expect(0, 65072, '\p{Blk=:\AHalf_Marks\z:}', "");;
    Expect(1, 65071, '\p{Blk=halfmarks}', "");
    Expect(0, 65071, '\p{^Blk=halfmarks}', "");
    Expect(0, 65071, '\P{Blk=halfmarks}', "");
    Expect(1, 65071, '\P{^Blk=halfmarks}', "");
    Expect(0, 65072, '\p{Blk=halfmarks}', "");
    Expect(1, 65072, '\p{^Blk=halfmarks}', "");
    Expect(1, 65072, '\P{Blk=halfmarks}', "");
    Expect(0, 65072, '\P{^Blk=halfmarks}', "");
    Expect(1, 65071, '\p{Blk=:\Ahalfmarks\z:}', "");;
    Expect(0, 65072, '\p{Blk=:\Ahalfmarks\z:}', "");;
    Expect(1, 65071, '\p{Blk= 	HALF_Marks}', "");
    Expect(0, 65071, '\p{^Blk= 	HALF_Marks}', "");
    Expect(0, 65071, '\P{Blk= 	HALF_Marks}', "");
    Expect(1, 65071, '\P{^Blk= 	HALF_Marks}', "");
    Expect(0, 65072, '\p{Blk= 	HALF_Marks}', "");
    Expect(1, 65072, '\p{^Blk= 	HALF_Marks}', "");
    Expect(1, 65072, '\P{Blk= 	HALF_Marks}', "");
    Expect(0, 65072, '\P{^Blk= 	HALF_Marks}', "");
    Error('\p{Is_Block=/a/-_Combining_half_Marks}');
    Error('\P{Is_Block=/a/-_Combining_half_Marks}');
    Expect(1, 65071, '\p{Is_Block=combininghalfmarks}', "");
    Expect(0, 65071, '\p{^Is_Block=combininghalfmarks}', "");
    Expect(0, 65071, '\P{Is_Block=combininghalfmarks}', "");
    Expect(1, 65071, '\P{^Is_Block=combininghalfmarks}', "");
    Expect(0, 65072, '\p{Is_Block=combininghalfmarks}', "");
    Expect(1, 65072, '\p{^Is_Block=combininghalfmarks}', "");
    Expect(1, 65072, '\P{Is_Block=combininghalfmarks}', "");
    Expect(0, 65072, '\P{^Is_Block=combininghalfmarks}', "");
    Expect(1, 65071, '\p{Is_Block=	 COMBINING_Half_marks}', "");
    Expect(0, 65071, '\p{^Is_Block=	 COMBINING_Half_marks}', "");
    Expect(0, 65071, '\P{Is_Block=	 COMBINING_Half_marks}', "");
    Expect(1, 65071, '\P{^Is_Block=	 COMBINING_Half_marks}', "");
    Expect(0, 65072, '\p{Is_Block=	 COMBINING_Half_marks}', "");
    Expect(1, 65072, '\p{^Is_Block=	 COMBINING_Half_marks}', "");
    Expect(1, 65072, '\P{Is_Block=	 COMBINING_Half_marks}', "");
    Expect(0, 65072, '\P{^Is_Block=	 COMBINING_Half_marks}', "");
    Error('\p{Is_Blk=	-half_Marks/a/}');
    Error('\P{Is_Blk=	-half_Marks/a/}');
    Expect(1, 65071, '\p{Is_Blk:halfmarks}', "");
    Expect(0, 65071, '\p{^Is_Blk:halfmarks}', "");
    Expect(0, 65071, '\P{Is_Blk:halfmarks}', "");
    Expect(1, 65071, '\P{^Is_Blk:halfmarks}', "");
    Expect(0, 65072, '\p{Is_Blk:halfmarks}', "");
    Expect(1, 65072, '\p{^Is_Blk:halfmarks}', "");
    Expect(1, 65072, '\P{Is_Blk:halfmarks}', "");
    Expect(0, 65072, '\P{^Is_Blk:halfmarks}', "");
    Expect(1, 65071, '\p{Is_Blk: 	-Half_marks}', "");
    Expect(0, 65071, '\p{^Is_Blk: 	-Half_marks}', "");
    Expect(0, 65071, '\P{Is_Blk: 	-Half_marks}', "");
    Expect(1, 65071, '\P{^Is_Blk: 	-Half_marks}', "");
    Expect(0, 65072, '\p{Is_Blk: 	-Half_marks}', "");
    Expect(1, 65072, '\p{^Is_Blk: 	-Half_marks}', "");
    Expect(1, 65072, '\P{Is_Blk: 	-Half_marks}', "");
    Expect(0, 65072, '\P{^Is_Blk: 	-Half_marks}', "");
    Error('\p{Block=	/a/hangul_syllables}');
    Error('\P{Block=	/a/hangul_syllables}');
    Expect(1, 55215, '\p{Block=:\AHangul_Syllables\z:}', "");;
    Expect(0, 55216, '\p{Block=:\AHangul_Syllables\z:}', "");;
    Expect(1, 55215, '\p{Block=hangulsyllables}', "");
    Expect(0, 55215, '\p{^Block=hangulsyllables}', "");
    Expect(0, 55215, '\P{Block=hangulsyllables}', "");
    Expect(1, 55215, '\P{^Block=hangulsyllables}', "");
    Expect(0, 55216, '\p{Block=hangulsyllables}', "");
    Expect(1, 55216, '\p{^Block=hangulsyllables}', "");
    Expect(1, 55216, '\P{Block=hangulsyllables}', "");
    Expect(0, 55216, '\P{^Block=hangulsyllables}', "");
    Expect(1, 55215, '\p{Block=:\Ahangulsyllables\z:}', "");;
    Expect(0, 55216, '\p{Block=:\Ahangulsyllables\z:}', "");;
    Expect(1, 55215, '\p{Block=-Hangul_Syllables}', "");
    Expect(0, 55215, '\p{^Block=-Hangul_Syllables}', "");
    Expect(0, 55215, '\P{Block=-Hangul_Syllables}', "");
    Expect(1, 55215, '\P{^Block=-Hangul_Syllables}', "");
    Expect(0, 55216, '\p{Block=-Hangul_Syllables}', "");
    Expect(1, 55216, '\p{^Block=-Hangul_Syllables}', "");
    Expect(1, 55216, '\P{Block=-Hangul_Syllables}', "");
    Expect(0, 55216, '\P{^Block=-Hangul_Syllables}', "");
    Error('\p{Blk=	 HANGUL:=}');
    Error('\P{Blk=	 HANGUL:=}');
    Expect(1, 55215, '\p{Blk=:\AHangul\z:}', "");;
    Expect(0, 55216, '\p{Blk=:\AHangul\z:}', "");;
    Expect(1, 55215, '\p{Blk=hangul}', "");
    Expect(0, 55215, '\p{^Blk=hangul}', "");
    Expect(0, 55215, '\P{Blk=hangul}', "");
    Expect(1, 55215, '\P{^Blk=hangul}', "");
    Expect(0, 55216, '\p{Blk=hangul}', "");
    Expect(1, 55216, '\p{^Blk=hangul}', "");
    Expect(1, 55216, '\P{Blk=hangul}', "");
    Expect(0, 55216, '\P{^Blk=hangul}', "");
    Expect(1, 55215, '\p{Blk=:\Ahangul\z:}', "");;
    Expect(0, 55216, '\p{Blk=:\Ahangul\z:}', "");;
    Expect(1, 55215, '\p{Blk=- Hangul}', "");
    Expect(0, 55215, '\p{^Blk=- Hangul}', "");
    Expect(0, 55215, '\P{Blk=- Hangul}', "");
    Expect(1, 55215, '\P{^Blk=- Hangul}', "");
    Expect(0, 55216, '\p{Blk=- Hangul}', "");
    Expect(1, 55216, '\p{^Blk=- Hangul}', "");
    Expect(1, 55216, '\P{Blk=- Hangul}', "");
    Expect(0, 55216, '\P{^Blk=- Hangul}', "");
    Error('\p{Is_Block=:=Hangul_Syllables}');
    Error('\P{Is_Block=:=Hangul_Syllables}');
    Expect(1, 55215, '\p{Is_Block=hangulsyllables}', "");
    Expect(0, 55215, '\p{^Is_Block=hangulsyllables}', "");
    Expect(0, 55215, '\P{Is_Block=hangulsyllables}', "");
    Expect(1, 55215, '\P{^Is_Block=hangulsyllables}', "");
    Expect(0, 55216, '\p{Is_Block=hangulsyllables}', "");
    Expect(1, 55216, '\p{^Is_Block=hangulsyllables}', "");
    Expect(1, 55216, '\P{Is_Block=hangulsyllables}', "");
    Expect(0, 55216, '\P{^Is_Block=hangulsyllables}', "");
    Expect(1, 55215, '\p{Is_Block=_ HANGUL_Syllables}', "");
    Expect(0, 55215, '\p{^Is_Block=_ HANGUL_Syllables}', "");
    Expect(0, 55215, '\P{Is_Block=_ HANGUL_Syllables}', "");
    Expect(1, 55215, '\P{^Is_Block=_ HANGUL_Syllables}', "");
    Expect(0, 55216, '\p{Is_Block=_ HANGUL_Syllables}', "");
    Expect(1, 55216, '\p{^Is_Block=_ HANGUL_Syllables}', "");
    Expect(1, 55216, '\P{Is_Block=_ HANGUL_Syllables}', "");
    Expect(0, 55216, '\P{^Is_Block=_ HANGUL_Syllables}', "");
    Error('\p{Is_Blk= :=HANGUL}');
    Error('\P{Is_Blk= :=HANGUL}');
    Expect(1, 55215, '\p{Is_Blk=hangul}', "");
    Expect(0, 55215, '\p{^Is_Blk=hangul}', "");
    Expect(0, 55215, '\P{Is_Blk=hangul}', "");
    Expect(1, 55215, '\P{^Is_Blk=hangul}', "");
    Expect(0, 55216, '\p{Is_Blk=hangul}', "");
    Expect(1, 55216, '\p{^Is_Blk=hangul}', "");
    Expect(1, 55216, '\P{Is_Blk=hangul}', "");
    Expect(0, 55216, '\P{^Is_Blk=hangul}', "");
    Expect(1, 55215, '\p{Is_Blk=_HANGUL}', "");
    Expect(0, 55215, '\p{^Is_Blk=_HANGUL}', "");
    Expect(0, 55215, '\P{Is_Blk=_HANGUL}', "");
    Expect(1, 55215, '\P{^Is_Blk=_HANGUL}', "");
    Expect(0, 55216, '\p{Is_Blk=_HANGUL}', "");
    Expect(1, 55216, '\p{^Is_Blk=_HANGUL}', "");
    Expect(1, 55216, '\P{Is_Blk=_HANGUL}', "");
    Expect(0, 55216, '\P{^Is_Blk=_HANGUL}', "");
    Error('\p{Block=/a/Hanifi_ROHINGYA}');
    Error('\P{Block=/a/Hanifi_ROHINGYA}');
    Expect(1, 68927, '\p{Block=:\AHanifi_Rohingya\z:}', "");;
    Expect(0, 68928, '\p{Block=:\AHanifi_Rohingya\z:}', "");;
    Expect(1, 68927, '\p{Block=hanifirohingya}', "");
    Expect(0, 68927, '\p{^Block=hanifirohingya}', "");
    Expect(0, 68927, '\P{Block=hanifirohingya}', "");
    Expect(1, 68927, '\P{^Block=hanifirohingya}', "");
    Expect(0, 68928, '\p{Block=hanifirohingya}', "");
    Expect(1, 68928, '\p{^Block=hanifirohingya}', "");
    Expect(1, 68928, '\P{Block=hanifirohingya}', "");
    Expect(0, 68928, '\P{^Block=hanifirohingya}', "");
    Expect(1, 68927, '\p{Block=:\Ahanifirohingya\z:}', "");;
    Expect(0, 68928, '\p{Block=:\Ahanifirohingya\z:}', "");;
    Expect(1, 68927, '\p{Block=hanifi_Rohingya}', "");
    Expect(0, 68927, '\p{^Block=hanifi_Rohingya}', "");
    Expect(0, 68927, '\P{Block=hanifi_Rohingya}', "");
    Expect(1, 68927, '\P{^Block=hanifi_Rohingya}', "");
    Expect(0, 68928, '\p{Block=hanifi_Rohingya}', "");
    Expect(1, 68928, '\p{^Block=hanifi_Rohingya}', "");
    Expect(1, 68928, '\P{Block=hanifi_Rohingya}', "");
    Expect(0, 68928, '\P{^Block=hanifi_Rohingya}', "");
    Error('\p{Blk=/a/__Hanifi_rohingya}');
    Error('\P{Blk=/a/__Hanifi_rohingya}');
    Expect(1, 68927, '\p{Blk=:\AHanifi_Rohingya\z:}', "");;
    Expect(0, 68928, '\p{Blk=:\AHanifi_Rohingya\z:}', "");;
    Expect(1, 68927, '\p{Blk=hanifirohingya}', "");
    Expect(0, 68927, '\p{^Blk=hanifirohingya}', "");
    Expect(0, 68927, '\P{Blk=hanifirohingya}', "");
    Expect(1, 68927, '\P{^Blk=hanifirohingya}', "");
    Expect(0, 68928, '\p{Blk=hanifirohingya}', "");
    Expect(1, 68928, '\p{^Blk=hanifirohingya}', "");
    Expect(1, 68928, '\P{Blk=hanifirohingya}', "");
    Expect(0, 68928, '\P{^Blk=hanifirohingya}', "");
    Expect(1, 68927, '\p{Blk=:\Ahanifirohingya\z:}', "");;
    Expect(0, 68928, '\p{Blk=:\Ahanifirohingya\z:}', "");;
    Expect(1, 68927, '\p{Blk=_Hanifi_ROHINGYA}', "");
    Expect(0, 68927, '\p{^Blk=_Hanifi_ROHINGYA}', "");
    Expect(0, 68927, '\P{Blk=_Hanifi_ROHINGYA}', "");
    Expect(1, 68927, '\P{^Blk=_Hanifi_ROHINGYA}', "");
    Expect(0, 68928, '\p{Blk=_Hanifi_ROHINGYA}', "");
    Expect(1, 68928, '\p{^Blk=_Hanifi_ROHINGYA}', "");
    Expect(1, 68928, '\P{Blk=_Hanifi_ROHINGYA}', "");
    Expect(0, 68928, '\P{^Blk=_Hanifi_ROHINGYA}', "");
    Error('\p{Is_Block= :=HANIFI_ROHINGYA}');
    Error('\P{Is_Block= :=HANIFI_ROHINGYA}');
    Expect(1, 68927, '\p{Is_Block=hanifirohingya}', "");
    Expect(0, 68927, '\p{^Is_Block=hanifirohingya}', "");
    Expect(0, 68927, '\P{Is_Block=hanifirohingya}', "");
    Expect(1, 68927, '\P{^Is_Block=hanifirohingya}', "");
    Expect(0, 68928, '\p{Is_Block=hanifirohingya}', "");
    Expect(1, 68928, '\p{^Is_Block=hanifirohingya}', "");
    Expect(1, 68928, '\P{Is_Block=hanifirohingya}', "");
    Expect(0, 68928, '\P{^Is_Block=hanifirohingya}', "");
    Expect(1, 68927, '\p{Is_Block= -Hanifi_Rohingya}', "");
    Expect(0, 68927, '\p{^Is_Block= -Hanifi_Rohingya}', "");
    Expect(0, 68927, '\P{Is_Block= -Hanifi_Rohingya}', "");
    Expect(1, 68927, '\P{^Is_Block= -Hanifi_Rohingya}', "");
    Expect(0, 68928, '\p{Is_Block= -Hanifi_Rohingya}', "");
    Expect(1, 68928, '\p{^Is_Block= -Hanifi_Rohingya}', "");
    Expect(1, 68928, '\P{Is_Block= -Hanifi_Rohingya}', "");
    Expect(0, 68928, '\P{^Is_Block= -Hanifi_Rohingya}', "");
    Error('\p{Is_Blk=	:=Hanifi_Rohingya}');
    Error('\P{Is_Blk=	:=Hanifi_Rohingya}');
    Expect(1, 68927, '\p{Is_Blk=hanifirohingya}', "");
    Expect(0, 68927, '\p{^Is_Blk=hanifirohingya}', "");
    Expect(0, 68927, '\P{Is_Blk=hanifirohingya}', "");
    Expect(1, 68927, '\P{^Is_Blk=hanifirohingya}', "");
    Expect(0, 68928, '\p{Is_Blk=hanifirohingya}', "");
    Expect(1, 68928, '\p{^Is_Blk=hanifirohingya}', "");
    Expect(1, 68928, '\P{Is_Blk=hanifirohingya}', "");
    Expect(0, 68928, '\P{^Is_Blk=hanifirohingya}', "");
    Expect(1, 68927, '\p{Is_Blk=		Hanifi_Rohingya}', "");
    Expect(0, 68927, '\p{^Is_Blk=		Hanifi_Rohingya}', "");
    Expect(0, 68927, '\P{Is_Blk=		Hanifi_Rohingya}', "");
    Expect(1, 68927, '\P{^Is_Blk=		Hanifi_Rohingya}', "");
    Expect(0, 68928, '\p{Is_Blk=		Hanifi_Rohingya}', "");
    Expect(1, 68928, '\p{^Is_Blk=		Hanifi_Rohingya}', "");
    Expect(1, 68928, '\P{Is_Blk=		Hanifi_Rohingya}', "");
    Expect(0, 68928, '\P{^Is_Blk=		Hanifi_Rohingya}', "");
    Error('\p{Block=_ HANUNOO:=}');
    Error('\P{Block=_ HANUNOO:=}');
    Expect(1, 5951, '\p{Block=:\AHanunoo\z:}', "");;
    Expect(0, 5952, '\p{Block=:\AHanunoo\z:}', "");;
    Expect(1, 5951, '\p{Block=hanunoo}', "");
    Expect(0, 5951, '\p{^Block=hanunoo}', "");
    Expect(0, 5951, '\P{Block=hanunoo}', "");
    Expect(1, 5951, '\P{^Block=hanunoo}', "");
    Expect(0, 5952, '\p{Block=hanunoo}', "");
    Expect(1, 5952, '\p{^Block=hanunoo}', "");
    Expect(1, 5952, '\P{Block=hanunoo}', "");
    Expect(0, 5952, '\P{^Block=hanunoo}', "");
    Expect(1, 5951, '\p{Block=:\Ahanunoo\z:}', "");;
    Expect(0, 5952, '\p{Block=:\Ahanunoo\z:}', "");;
    Expect(1, 5951, '\p{Block=_Hanunoo}', "");
    Expect(0, 5951, '\p{^Block=_Hanunoo}', "");
    Expect(0, 5951, '\P{Block=_Hanunoo}', "");
    Expect(1, 5951, '\P{^Block=_Hanunoo}', "");
    Expect(0, 5952, '\p{Block=_Hanunoo}', "");
    Expect(1, 5952, '\p{^Block=_Hanunoo}', "");
    Expect(1, 5952, '\P{Block=_Hanunoo}', "");
    Expect(0, 5952, '\P{^Block=_Hanunoo}', "");
    Error('\p{Blk=_ Hanunoo/a/}');
    Error('\P{Blk=_ Hanunoo/a/}');
    Expect(1, 5951, '\p{Blk=:\AHanunoo\z:}', "");;
    Expect(0, 5952, '\p{Blk=:\AHanunoo\z:}', "");;
    Expect(1, 5951, '\p{Blk=hanunoo}', "");
    Expect(0, 5951, '\p{^Blk=hanunoo}', "");
    Expect(0, 5951, '\P{Blk=hanunoo}', "");
    Expect(1, 5951, '\P{^Blk=hanunoo}', "");
    Expect(0, 5952, '\p{Blk=hanunoo}', "");
    Expect(1, 5952, '\p{^Blk=hanunoo}', "");
    Expect(1, 5952, '\P{Blk=hanunoo}', "");
    Expect(0, 5952, '\P{^Blk=hanunoo}', "");
    Expect(1, 5951, '\p{Blk=:\Ahanunoo\z:}', "");;
    Expect(0, 5952, '\p{Blk=:\Ahanunoo\z:}', "");;
    Expect(1, 5951, '\p{Blk=-_Hanunoo}', "");
    Expect(0, 5951, '\p{^Blk=-_Hanunoo}', "");
    Expect(0, 5951, '\P{Blk=-_Hanunoo}', "");
    Expect(1, 5951, '\P{^Blk=-_Hanunoo}', "");
    Expect(0, 5952, '\p{Blk=-_Hanunoo}', "");
    Expect(1, 5952, '\p{^Blk=-_Hanunoo}', "");
    Expect(1, 5952, '\P{Blk=-_Hanunoo}', "");
    Expect(0, 5952, '\P{^Blk=-_Hanunoo}', "");
    Error('\p{Is_Block=-	Hanunoo:=}');
    Error('\P{Is_Block=-	Hanunoo:=}');
    Expect(1, 5951, '\p{Is_Block=hanunoo}', "");
    Expect(0, 5951, '\p{^Is_Block=hanunoo}', "");
    Expect(0, 5951, '\P{Is_Block=hanunoo}', "");
    Expect(1, 5951, '\P{^Is_Block=hanunoo}', "");
    Expect(0, 5952, '\p{Is_Block=hanunoo}', "");
    Expect(1, 5952, '\p{^Is_Block=hanunoo}', "");
    Expect(1, 5952, '\P{Is_Block=hanunoo}', "");
    Expect(0, 5952, '\P{^Is_Block=hanunoo}', "");
    Expect(1, 5951, '\p{Is_Block=  HANUNOO}', "");
    Expect(0, 5951, '\p{^Is_Block=  HANUNOO}', "");
    Expect(0, 5951, '\P{Is_Block=  HANUNOO}', "");
    Expect(1, 5951, '\P{^Is_Block=  HANUNOO}', "");
    Expect(0, 5952, '\p{Is_Block=  HANUNOO}', "");
    Expect(1, 5952, '\p{^Is_Block=  HANUNOO}', "");
    Expect(1, 5952, '\P{Is_Block=  HANUNOO}', "");
    Expect(0, 5952, '\P{^Is_Block=  HANUNOO}', "");
    Error('\p{Is_Blk=_ HANUNOO:=}');
    Error('\P{Is_Blk=_ HANUNOO:=}');
    Expect(1, 5951, '\p{Is_Blk=hanunoo}', "");
    Expect(0, 5951, '\p{^Is_Blk=hanunoo}', "");
    Expect(0, 5951, '\P{Is_Blk=hanunoo}', "");
    Expect(1, 5951, '\P{^Is_Blk=hanunoo}', "");
    Expect(0, 5952, '\p{Is_Blk=hanunoo}', "");
    Expect(1, 5952, '\p{^Is_Blk=hanunoo}', "");
    Expect(1, 5952, '\P{Is_Blk=hanunoo}', "");
    Expect(0, 5952, '\P{^Is_Blk=hanunoo}', "");
    Expect(1, 5951, '\p{Is_Blk=_	HANUNOO}', "");
    Expect(0, 5951, '\p{^Is_Blk=_	HANUNOO}', "");
    Expect(0, 5951, '\P{Is_Blk=_	HANUNOO}', "");
    Expect(1, 5951, '\P{^Is_Blk=_	HANUNOO}', "");
    Expect(0, 5952, '\p{Is_Blk=_	HANUNOO}', "");
    Expect(1, 5952, '\p{^Is_Blk=_	HANUNOO}', "");
    Expect(1, 5952, '\P{Is_Blk=_	HANUNOO}', "");
    Expect(0, 5952, '\P{^Is_Blk=_	HANUNOO}', "");
    Error('\p{Block:   	:=Hatran}');
    Error('\P{Block:   	:=Hatran}');
    Expect(1, 67839, '\p{Block=:\AHatran\z:}', "");;
    Expect(0, 67840, '\p{Block=:\AHatran\z:}', "");;
    Expect(1, 67839, '\p{Block=hatran}', "");
    Expect(0, 67839, '\p{^Block=hatran}', "");
    Expect(0, 67839, '\P{Block=hatran}', "");
    Expect(1, 67839, '\P{^Block=hatran}', "");
    Expect(0, 67840, '\p{Block=hatran}', "");
    Expect(1, 67840, '\p{^Block=hatran}', "");
    Expect(1, 67840, '\P{Block=hatran}', "");
    Expect(0, 67840, '\P{^Block=hatran}', "");
    Expect(1, 67839, '\p{Block=:\Ahatran\z:}', "");;
    Expect(0, 67840, '\p{Block=:\Ahatran\z:}', "");;
    Expect(1, 67839, '\p{Block= Hatran}', "");
    Expect(0, 67839, '\p{^Block= Hatran}', "");
    Expect(0, 67839, '\P{Block= Hatran}', "");
    Expect(1, 67839, '\P{^Block= Hatran}', "");
    Expect(0, 67840, '\p{Block= Hatran}', "");
    Expect(1, 67840, '\p{^Block= Hatran}', "");
    Expect(1, 67840, '\P{Block= Hatran}', "");
    Expect(0, 67840, '\P{^Block= Hatran}', "");
    Error('\p{Blk=/a/Hatran}');
    Error('\P{Blk=/a/Hatran}');
    Expect(1, 67839, '\p{Blk=:\AHatran\z:}', "");;
    Expect(0, 67840, '\p{Blk=:\AHatran\z:}', "");;
    Expect(1, 67839, '\p{Blk=hatran}', "");
    Expect(0, 67839, '\p{^Blk=hatran}', "");
    Expect(0, 67839, '\P{Blk=hatran}', "");
    Expect(1, 67839, '\P{^Blk=hatran}', "");
    Expect(0, 67840, '\p{Blk=hatran}', "");
    Expect(1, 67840, '\p{^Blk=hatran}', "");
    Expect(1, 67840, '\P{Blk=hatran}', "");
    Expect(0, 67840, '\P{^Blk=hatran}', "");
    Expect(1, 67839, '\p{Blk=:\Ahatran\z:}', "");;
    Expect(0, 67840, '\p{Blk=:\Ahatran\z:}', "");;
    Expect(1, 67839, '\p{Blk=_ Hatran}', "");
    Expect(0, 67839, '\p{^Blk=_ Hatran}', "");
    Expect(0, 67839, '\P{Blk=_ Hatran}', "");
    Expect(1, 67839, '\P{^Blk=_ Hatran}', "");
    Expect(0, 67840, '\p{Blk=_ Hatran}', "");
    Expect(1, 67840, '\p{^Blk=_ Hatran}', "");
    Expect(1, 67840, '\P{Blk=_ Hatran}', "");
    Expect(0, 67840, '\P{^Blk=_ Hatran}', "");
    Error('\p{Is_Block=		hatran:=}');
    Error('\P{Is_Block=		hatran:=}');
    Expect(1, 67839, '\p{Is_Block=hatran}', "");
    Expect(0, 67839, '\p{^Is_Block=hatran}', "");
    Expect(0, 67839, '\P{Is_Block=hatran}', "");
    Expect(1, 67839, '\P{^Is_Block=hatran}', "");
    Expect(0, 67840, '\p{Is_Block=hatran}', "");
    Expect(1, 67840, '\p{^Is_Block=hatran}', "");
    Expect(1, 67840, '\P{Is_Block=hatran}', "");
    Expect(0, 67840, '\P{^Is_Block=hatran}', "");
    Expect(1, 67839, '\p{Is_Block= HATRAN}', "");
    Expect(0, 67839, '\p{^Is_Block= HATRAN}', "");
    Expect(0, 67839, '\P{Is_Block= HATRAN}', "");
    Expect(1, 67839, '\P{^Is_Block= HATRAN}', "");
    Expect(0, 67840, '\p{Is_Block= HATRAN}', "");
    Expect(1, 67840, '\p{^Is_Block= HATRAN}', "");
    Expect(1, 67840, '\P{Is_Block= HATRAN}', "");
    Expect(0, 67840, '\P{^Is_Block= HATRAN}', "");
    Error('\p{Is_Blk=-:=Hatran}');
    Error('\P{Is_Blk=-:=Hatran}');
    Expect(1, 67839, '\p{Is_Blk=hatran}', "");
    Expect(0, 67839, '\p{^Is_Blk=hatran}', "");
    Expect(0, 67839, '\P{Is_Blk=hatran}', "");
    Expect(1, 67839, '\P{^Is_Blk=hatran}', "");
    Expect(0, 67840, '\p{Is_Blk=hatran}', "");
    Expect(1, 67840, '\p{^Is_Blk=hatran}', "");
    Expect(1, 67840, '\P{Is_Blk=hatran}', "");
    Expect(0, 67840, '\P{^Is_Blk=hatran}', "");
    Expect(1, 67839, '\p{Is_Blk=_-HATRAN}', "");
    Expect(0, 67839, '\p{^Is_Blk=_-HATRAN}', "");
    Expect(0, 67839, '\P{Is_Blk=_-HATRAN}', "");
    Expect(1, 67839, '\P{^Is_Blk=_-HATRAN}', "");
    Expect(0, 67840, '\p{Is_Blk=_-HATRAN}', "");
    Expect(1, 67840, '\p{^Is_Blk=_-HATRAN}', "");
    Expect(1, 67840, '\P{Is_Blk=_-HATRAN}', "");
    Expect(0, 67840, '\P{^Is_Blk=_-HATRAN}', "");
    Error('\p{Block=/a/	_HEBREW}');
    Error('\P{Block=/a/	_HEBREW}');
    Expect(1, 1535, '\p{Block=:\AHebrew\z:}', "");;
    Expect(0, 1536, '\p{Block=:\AHebrew\z:}', "");;
    Expect(1, 1535, '\p{Block:hebrew}', "");
    Expect(0, 1535, '\p{^Block:hebrew}', "");
    Expect(0, 1535, '\P{Block:hebrew}', "");
    Expect(1, 1535, '\P{^Block:hebrew}', "");
    Expect(0, 1536, '\p{Block:hebrew}', "");
    Expect(1, 1536, '\p{^Block:hebrew}', "");
    Expect(1, 1536, '\P{Block:hebrew}', "");
    Expect(0, 1536, '\P{^Block:hebrew}', "");
    Expect(1, 1535, '\p{Block=:\Ahebrew\z:}', "");;
    Expect(0, 1536, '\p{Block=:\Ahebrew\z:}', "");;
    Expect(1, 1535, '\p{Block= 	Hebrew}', "");
    Expect(0, 1535, '\p{^Block= 	Hebrew}', "");
    Expect(0, 1535, '\P{Block= 	Hebrew}', "");
    Expect(1, 1535, '\P{^Block= 	Hebrew}', "");
    Expect(0, 1536, '\p{Block= 	Hebrew}', "");
    Expect(1, 1536, '\p{^Block= 	Hebrew}', "");
    Expect(1, 1536, '\P{Block= 	Hebrew}', "");
    Expect(0, 1536, '\P{^Block= 	Hebrew}', "");
    Error('\p{Blk=  hebrew:=}');
    Error('\P{Blk=  hebrew:=}');
    Expect(1, 1535, '\p{Blk=:\AHebrew\z:}', "");;
    Expect(0, 1536, '\p{Blk=:\AHebrew\z:}', "");;
    Expect(1, 1535, '\p{Blk=hebrew}', "");
    Expect(0, 1535, '\p{^Blk=hebrew}', "");
    Expect(0, 1535, '\P{Blk=hebrew}', "");
    Expect(1, 1535, '\P{^Blk=hebrew}', "");
    Expect(0, 1536, '\p{Blk=hebrew}', "");
    Expect(1, 1536, '\p{^Blk=hebrew}', "");
    Expect(1, 1536, '\P{Blk=hebrew}', "");
    Expect(0, 1536, '\P{^Blk=hebrew}', "");
    Expect(1, 1535, '\p{Blk=:\Ahebrew\z:}', "");;
    Expect(0, 1536, '\p{Blk=:\Ahebrew\z:}', "");;
    Expect(1, 1535, '\p{Blk=	hebrew}', "");
    Expect(0, 1535, '\p{^Blk=	hebrew}', "");
    Expect(0, 1535, '\P{Blk=	hebrew}', "");
    Expect(1, 1535, '\P{^Blk=	hebrew}', "");
    Expect(0, 1536, '\p{Blk=	hebrew}', "");
    Expect(1, 1536, '\p{^Blk=	hebrew}', "");
    Expect(1, 1536, '\P{Blk=	hebrew}', "");
    Expect(0, 1536, '\P{^Blk=	hebrew}', "");
    Error('\p{Is_Block=__hebrew:=}');
    Error('\P{Is_Block=__hebrew:=}');
    Expect(1, 1535, '\p{Is_Block=hebrew}', "");
    Expect(0, 1535, '\p{^Is_Block=hebrew}', "");
    Expect(0, 1535, '\P{Is_Block=hebrew}', "");
    Expect(1, 1535, '\P{^Is_Block=hebrew}', "");
    Expect(0, 1536, '\p{Is_Block=hebrew}', "");
    Expect(1, 1536, '\p{^Is_Block=hebrew}', "");
    Expect(1, 1536, '\P{Is_Block=hebrew}', "");
    Expect(0, 1536, '\P{^Is_Block=hebrew}', "");
    Expect(1, 1535, '\p{Is_Block=	 Hebrew}', "");
    Expect(0, 1535, '\p{^Is_Block=	 Hebrew}', "");
    Expect(0, 1535, '\P{Is_Block=	 Hebrew}', "");
    Expect(1, 1535, '\P{^Is_Block=	 Hebrew}', "");
    Expect(0, 1536, '\p{Is_Block=	 Hebrew}', "");
    Expect(1, 1536, '\p{^Is_Block=	 Hebrew}', "");
    Expect(1, 1536, '\P{Is_Block=	 Hebrew}', "");
    Expect(0, 1536, '\P{^Is_Block=	 Hebrew}', "");
    Error('\p{Is_Blk=_	hebrew:=}');
    Error('\P{Is_Blk=_	hebrew:=}');
    Expect(1, 1535, '\p{Is_Blk:hebrew}', "");
    Expect(0, 1535, '\p{^Is_Blk:hebrew}', "");
    Expect(0, 1535, '\P{Is_Blk:hebrew}', "");
    Expect(1, 1535, '\P{^Is_Blk:hebrew}', "");
    Expect(0, 1536, '\p{Is_Blk:hebrew}', "");
    Expect(1, 1536, '\p{^Is_Blk:hebrew}', "");
    Expect(1, 1536, '\P{Is_Blk:hebrew}', "");
    Expect(0, 1536, '\P{^Is_Blk:hebrew}', "");
    Expect(1, 1535, '\p{Is_Blk=	_Hebrew}', "");
    Expect(0, 1535, '\p{^Is_Blk=	_Hebrew}', "");
    Expect(0, 1535, '\P{Is_Blk=	_Hebrew}', "");
    Expect(1, 1535, '\P{^Is_Blk=	_Hebrew}', "");
    Expect(0, 1536, '\p{Is_Blk=	_Hebrew}', "");
    Expect(1, 1536, '\p{^Is_Blk=	_Hebrew}', "");
    Expect(1, 1536, '\P{Is_Blk=	_Hebrew}', "");
    Expect(0, 1536, '\P{^Is_Blk=	_Hebrew}', "");
    Error('\p{Block=		High_Private_Use_Surrogates:=}');
    Error('\P{Block=		High_Private_Use_Surrogates:=}');
    Expect(1, 56319, '\p{Block=:\AHigh_Private_Use_Surrogates\z:}', "");;
    Expect(0, 57344, '\p{Block=:\AHigh_Private_Use_Surrogates\z:}', "");;
    Expect(1, 56319, '\p{Block=highprivateusesurrogates}', "");
    Expect(0, 56319, '\p{^Block=highprivateusesurrogates}', "");
    Expect(0, 56319, '\P{Block=highprivateusesurrogates}', "");
    Expect(1, 56319, '\P{^Block=highprivateusesurrogates}', "");
    Expect(0, 57344, '\p{Block=highprivateusesurrogates}', "");
    Expect(1, 57344, '\p{^Block=highprivateusesurrogates}', "");
    Expect(1, 57344, '\P{Block=highprivateusesurrogates}', "");
    Expect(0, 57344, '\P{^Block=highprivateusesurrogates}', "");
    Expect(1, 56319, '\p{Block=:\Ahighprivateusesurrogates\z:}', "");;
    Expect(0, 57344, '\p{Block=:\Ahighprivateusesurrogates\z:}', "");;
    Expect(1, 56319, '\p{Block=	HIGH_Private_USE_SURROGATES}', "");
    Expect(0, 56319, '\p{^Block=	HIGH_Private_USE_SURROGATES}', "");
    Expect(0, 56319, '\P{Block=	HIGH_Private_USE_SURROGATES}', "");
    Expect(1, 56319, '\P{^Block=	HIGH_Private_USE_SURROGATES}', "");
    Expect(0, 57344, '\p{Block=	HIGH_Private_USE_SURROGATES}', "");
    Expect(1, 57344, '\p{^Block=	HIGH_Private_USE_SURROGATES}', "");
    Expect(1, 57344, '\P{Block=	HIGH_Private_USE_SURROGATES}', "");
    Expect(0, 57344, '\P{^Block=	HIGH_Private_USE_SURROGATES}', "");
    Error('\p{Blk=	/a/high_PU_SURROGATES}');
    Error('\P{Blk=	/a/high_PU_SURROGATES}');
    Expect(1, 56319, '\p{Blk=:\AHigh_PU_Surrogates\z:}', "");;
    Expect(0, 57344, '\p{Blk=:\AHigh_PU_Surrogates\z:}', "");;
    Expect(1, 56319, '\p{Blk=highpusurrogates}', "");
    Expect(0, 56319, '\p{^Blk=highpusurrogates}', "");
    Expect(0, 56319, '\P{Blk=highpusurrogates}', "");
    Expect(1, 56319, '\P{^Blk=highpusurrogates}', "");
    Expect(0, 57344, '\p{Blk=highpusurrogates}', "");
    Expect(1, 57344, '\p{^Blk=highpusurrogates}', "");
    Expect(1, 57344, '\P{Blk=highpusurrogates}', "");
    Expect(0, 57344, '\P{^Blk=highpusurrogates}', "");
    Expect(1, 56319, '\p{Blk=:\Ahighpusurrogates\z:}', "");;
    Expect(0, 57344, '\p{Blk=:\Ahighpusurrogates\z:}', "");;
    Expect(1, 56319, '\p{Blk=- HIGH_PU_surrogates}', "");
    Expect(0, 56319, '\p{^Blk=- HIGH_PU_surrogates}', "");
    Expect(0, 56319, '\P{Blk=- HIGH_PU_surrogates}', "");
    Expect(1, 56319, '\P{^Blk=- HIGH_PU_surrogates}', "");
    Expect(0, 57344, '\p{Blk=- HIGH_PU_surrogates}', "");
    Expect(1, 57344, '\p{^Blk=- HIGH_PU_surrogates}', "");
    Expect(1, 57344, '\P{Blk=- HIGH_PU_surrogates}', "");
    Expect(0, 57344, '\P{^Blk=- HIGH_PU_surrogates}', "");
    Error('\p{Is_Block=	High_private_USE_Surrogates:=}');
    Error('\P{Is_Block=	High_private_USE_Surrogates:=}');
    Expect(1, 56319, '\p{Is_Block=highprivateusesurrogates}', "");
    Expect(0, 56319, '\p{^Is_Block=highprivateusesurrogates}', "");
    Expect(0, 56319, '\P{Is_Block=highprivateusesurrogates}', "");
    Expect(1, 56319, '\P{^Is_Block=highprivateusesurrogates}', "");
    Expect(0, 57344, '\p{Is_Block=highprivateusesurrogates}', "");
    Expect(1, 57344, '\p{^Is_Block=highprivateusesurrogates}', "");
    Expect(1, 57344, '\P{Is_Block=highprivateusesurrogates}', "");
    Expect(0, 57344, '\P{^Is_Block=highprivateusesurrogates}', "");
    Expect(1, 56319, '\p{Is_Block=	high_Private_USE_Surrogates}', "");
    Expect(0, 56319, '\p{^Is_Block=	high_Private_USE_Surrogates}', "");
    Expect(0, 56319, '\P{Is_Block=	high_Private_USE_Surrogates}', "");
    Expect(1, 56319, '\P{^Is_Block=	high_Private_USE_Surrogates}', "");
    Expect(0, 57344, '\p{Is_Block=	high_Private_USE_Surrogates}', "");
    Expect(1, 57344, '\p{^Is_Block=	high_Private_USE_Surrogates}', "");
    Expect(1, 57344, '\P{Is_Block=	high_Private_USE_Surrogates}', "");
    Expect(0, 57344, '\P{^Is_Block=	high_Private_USE_Surrogates}', "");
    Error('\p{Is_Blk=/a/- high_pu_surrogates}');
    Error('\P{Is_Blk=/a/- high_pu_surrogates}');
    Expect(1, 56319, '\p{Is_Blk=highpusurrogates}', "");
    Expect(0, 56319, '\p{^Is_Blk=highpusurrogates}', "");
    Expect(0, 56319, '\P{Is_Blk=highpusurrogates}', "");
    Expect(1, 56319, '\P{^Is_Blk=highpusurrogates}', "");
    Expect(0, 57344, '\p{Is_Blk=highpusurrogates}', "");
    Expect(1, 57344, '\p{^Is_Blk=highpusurrogates}', "");
    Expect(1, 57344, '\P{Is_Blk=highpusurrogates}', "");
    Expect(0, 57344, '\P{^Is_Blk=highpusurrogates}', "");
    Expect(1, 56319, '\p{Is_Blk=-_high_PU_surrogates}', "");
    Expect(0, 56319, '\p{^Is_Blk=-_high_PU_surrogates}', "");
    Expect(0, 56319, '\P{Is_Blk=-_high_PU_surrogates}', "");
    Expect(1, 56319, '\P{^Is_Blk=-_high_PU_surrogates}', "");
    Expect(0, 57344, '\p{Is_Blk=-_high_PU_surrogates}', "");
    Expect(1, 57344, '\p{^Is_Blk=-_high_PU_surrogates}', "");
    Expect(1, 57344, '\P{Is_Blk=-_high_PU_surrogates}', "");
    Expect(0, 57344, '\P{^Is_Blk=-_high_PU_surrogates}', "");
    Error('\p{Block=	/a/HIGH_Surrogates}');
    Error('\P{Block=	/a/HIGH_Surrogates}');
    Expect(1, 56191, '\p{Block=:\AHigh_Surrogates\z:}', "");;
    Expect(0, 57344, '\p{Block=:\AHigh_Surrogates\z:}', "");;
    Expect(1, 56191, '\p{Block=highsurrogates}', "");
    Expect(0, 56191, '\p{^Block=highsurrogates}', "");
    Expect(0, 56191, '\P{Block=highsurrogates}', "");
    Expect(1, 56191, '\P{^Block=highsurrogates}', "");
    Expect(0, 57344, '\p{Block=highsurrogates}', "");
    Expect(1, 57344, '\p{^Block=highsurrogates}', "");
    Expect(1, 57344, '\P{Block=highsurrogates}', "");
    Expect(0, 57344, '\P{^Block=highsurrogates}', "");
    Expect(1, 56191, '\p{Block=:\Ahighsurrogates\z:}', "");;
    Expect(0, 57344, '\p{Block=:\Ahighsurrogates\z:}', "");;
    Expect(1, 56191, '\p{Block=	 high_Surrogates}', "");
    Expect(0, 56191, '\p{^Block=	 high_Surrogates}', "");
    Expect(0, 56191, '\P{Block=	 high_Surrogates}', "");
    Expect(1, 56191, '\P{^Block=	 high_Surrogates}', "");
    Expect(0, 57344, '\p{Block=	 high_Surrogates}', "");
    Expect(1, 57344, '\p{^Block=	 high_Surrogates}', "");
    Expect(1, 57344, '\P{Block=	 high_Surrogates}', "");
    Expect(0, 57344, '\P{^Block=	 high_Surrogates}', "");
    Error('\p{Blk=/a/_-HIGH_surrogates}');
    Error('\P{Blk=/a/_-HIGH_surrogates}');
    Expect(1, 56191, '\p{Blk=:\AHigh_Surrogates\z:}', "");;
    Expect(0, 57344, '\p{Blk=:\AHigh_Surrogates\z:}', "");;
    Expect(1, 56191, '\p{Blk=highsurrogates}', "");
    Expect(0, 56191, '\p{^Blk=highsurrogates}', "");
    Expect(0, 56191, '\P{Blk=highsurrogates}', "");
    Expect(1, 56191, '\P{^Blk=highsurrogates}', "");
    Expect(0, 57344, '\p{Blk=highsurrogates}', "");
    Expect(1, 57344, '\p{^Blk=highsurrogates}', "");
    Expect(1, 57344, '\P{Blk=highsurrogates}', "");
    Expect(0, 57344, '\P{^Blk=highsurrogates}', "");
    Expect(1, 56191, '\p{Blk=:\Ahighsurrogates\z:}', "");;
    Expect(0, 57344, '\p{Blk=:\Ahighsurrogates\z:}', "");;
    Expect(1, 56191, '\p{Blk=- HIGH_Surrogates}', "");
    Expect(0, 56191, '\p{^Blk=- HIGH_Surrogates}', "");
    Expect(0, 56191, '\P{Blk=- HIGH_Surrogates}', "");
    Expect(1, 56191, '\P{^Blk=- HIGH_Surrogates}', "");
    Expect(0, 57344, '\p{Blk=- HIGH_Surrogates}', "");
    Expect(1, 57344, '\p{^Blk=- HIGH_Surrogates}', "");
    Expect(1, 57344, '\P{Blk=- HIGH_Surrogates}', "");
    Expect(0, 57344, '\P{^Blk=- HIGH_Surrogates}', "");
    Error('\p{Is_Block=:=	high_Surrogates}');
    Error('\P{Is_Block=:=	high_Surrogates}');
    Expect(1, 56191, '\p{Is_Block=highsurrogates}', "");
    Expect(0, 56191, '\p{^Is_Block=highsurrogates}', "");
    Expect(0, 56191, '\P{Is_Block=highsurrogates}', "");
    Expect(1, 56191, '\P{^Is_Block=highsurrogates}', "");
    Expect(0, 57344, '\p{Is_Block=highsurrogates}', "");
    Expect(1, 57344, '\p{^Is_Block=highsurrogates}', "");
    Expect(1, 57344, '\P{Is_Block=highsurrogates}', "");
    Expect(0, 57344, '\P{^Is_Block=highsurrogates}', "");
    Expect(1, 56191, '\p{Is_Block=- HIGH_Surrogates}', "");
    Expect(0, 56191, '\p{^Is_Block=- HIGH_Surrogates}', "");
    Expect(0, 56191, '\P{Is_Block=- HIGH_Surrogates}', "");
    Expect(1, 56191, '\P{^Is_Block=- HIGH_Surrogates}', "");
    Expect(0, 57344, '\p{Is_Block=- HIGH_Surrogates}', "");
    Expect(1, 57344, '\p{^Is_Block=- HIGH_Surrogates}', "");
    Expect(1, 57344, '\P{Is_Block=- HIGH_Surrogates}', "");
    Expect(0, 57344, '\P{^Is_Block=- HIGH_Surrogates}', "");
    Error('\p{Is_Blk=- High_SURROGATES:=}');
    Error('\P{Is_Blk=- High_SURROGATES:=}');
    Expect(1, 56191, '\p{Is_Blk=highsurrogates}', "");
    Expect(0, 56191, '\p{^Is_Blk=highsurrogates}', "");
    Expect(0, 56191, '\P{Is_Blk=highsurrogates}', "");
    Expect(1, 56191, '\P{^Is_Blk=highsurrogates}', "");
    Expect(0, 57344, '\p{Is_Blk=highsurrogates}', "");
    Expect(1, 57344, '\p{^Is_Blk=highsurrogates}', "");
    Expect(1, 57344, '\P{Is_Blk=highsurrogates}', "");
    Expect(0, 57344, '\P{^Is_Blk=highsurrogates}', "");
    Expect(1, 56191, '\p{Is_Blk=_-High_Surrogates}', "");
    Expect(0, 56191, '\p{^Is_Blk=_-High_Surrogates}', "");
    Expect(0, 56191, '\P{Is_Blk=_-High_Surrogates}', "");
    Expect(1, 56191, '\P{^Is_Blk=_-High_Surrogates}', "");
    Expect(0, 57344, '\p{Is_Blk=_-High_Surrogates}', "");
    Expect(1, 57344, '\p{^Is_Blk=_-High_Surrogates}', "");
    Expect(1, 57344, '\P{Is_Blk=_-High_Surrogates}', "");
    Expect(0, 57344, '\P{^Is_Blk=_-High_Surrogates}', "");
    Error('\p{Block=:=Hiragana}');
    Error('\P{Block=:=Hiragana}');
    Expect(1, 12447, '\p{Block=:\AHiragana\z:}', "");;
    Expect(0, 12448, '\p{Block=:\AHiragana\z:}', "");;
    Expect(1, 12447, '\p{Block=hiragana}', "");
    Expect(0, 12447, '\p{^Block=hiragana}', "");
    Expect(0, 12447, '\P{Block=hiragana}', "");
    Expect(1, 12447, '\P{^Block=hiragana}', "");
    Expect(0, 12448, '\p{Block=hiragana}', "");
    Expect(1, 12448, '\p{^Block=hiragana}', "");
    Expect(1, 12448, '\P{Block=hiragana}', "");
    Expect(0, 12448, '\P{^Block=hiragana}', "");
    Expect(1, 12447, '\p{Block=:\Ahiragana\z:}', "");;
    Expect(0, 12448, '\p{Block=:\Ahiragana\z:}', "");;
    Expect(1, 12447, '\p{Block=_	Hiragana}', "");
    Expect(0, 12447, '\p{^Block=_	Hiragana}', "");
    Expect(0, 12447, '\P{Block=_	Hiragana}', "");
    Expect(1, 12447, '\P{^Block=_	Hiragana}', "");
    Expect(0, 12448, '\p{Block=_	Hiragana}', "");
    Expect(1, 12448, '\p{^Block=_	Hiragana}', "");
    Expect(1, 12448, '\P{Block=_	Hiragana}', "");
    Expect(0, 12448, '\P{^Block=_	Hiragana}', "");
    Error('\p{Blk=_:=Hiragana}');
    Error('\P{Blk=_:=Hiragana}');
    Expect(1, 12447, '\p{Blk=:\AHiragana\z:}', "");;
    Expect(0, 12448, '\p{Blk=:\AHiragana\z:}', "");;
    Expect(1, 12447, '\p{Blk=hiragana}', "");
    Expect(0, 12447, '\p{^Blk=hiragana}', "");
    Expect(0, 12447, '\P{Blk=hiragana}', "");
    Expect(1, 12447, '\P{^Blk=hiragana}', "");
    Expect(0, 12448, '\p{Blk=hiragana}', "");
    Expect(1, 12448, '\p{^Blk=hiragana}', "");
    Expect(1, 12448, '\P{Blk=hiragana}', "");
    Expect(0, 12448, '\P{^Blk=hiragana}', "");
    Expect(1, 12447, '\p{Blk=:\Ahiragana\z:}', "");;
    Expect(0, 12448, '\p{Blk=:\Ahiragana\z:}', "");;
    Expect(1, 12447, '\p{Blk:   --HIRAGANA}', "");
    Expect(0, 12447, '\p{^Blk:   --HIRAGANA}', "");
    Expect(0, 12447, '\P{Blk:   --HIRAGANA}', "");
    Expect(1, 12447, '\P{^Blk:   --HIRAGANA}', "");
    Expect(0, 12448, '\p{Blk:   --HIRAGANA}', "");
    Expect(1, 12448, '\p{^Blk:   --HIRAGANA}', "");
    Expect(1, 12448, '\P{Blk:   --HIRAGANA}', "");
    Expect(0, 12448, '\P{^Blk:   --HIRAGANA}', "");
    Error('\p{Is_Block= Hiragana:=}');
    Error('\P{Is_Block= Hiragana:=}');
    Expect(1, 12447, '\p{Is_Block=hiragana}', "");
    Expect(0, 12447, '\p{^Is_Block=hiragana}', "");
    Expect(0, 12447, '\P{Is_Block=hiragana}', "");
    Expect(1, 12447, '\P{^Is_Block=hiragana}', "");
    Expect(0, 12448, '\p{Is_Block=hiragana}', "");
    Expect(1, 12448, '\p{^Is_Block=hiragana}', "");
    Expect(1, 12448, '\P{Is_Block=hiragana}', "");
    Expect(0, 12448, '\P{^Is_Block=hiragana}', "");
    Expect(1, 12447, '\p{Is_Block=-hiragana}', "");
    Expect(0, 12447, '\p{^Is_Block=-hiragana}', "");
    Expect(0, 12447, '\P{Is_Block=-hiragana}', "");
    Expect(1, 12447, '\P{^Is_Block=-hiragana}', "");
    Expect(0, 12448, '\p{Is_Block=-hiragana}', "");
    Expect(1, 12448, '\p{^Is_Block=-hiragana}', "");
    Expect(1, 12448, '\P{Is_Block=-hiragana}', "");
    Expect(0, 12448, '\P{^Is_Block=-hiragana}', "");
    Error('\p{Is_Blk=/a/- Hiragana}');
    Error('\P{Is_Blk=/a/- Hiragana}');
    Expect(1, 12447, '\p{Is_Blk:hiragana}', "");
    Expect(0, 12447, '\p{^Is_Blk:hiragana}', "");
    Expect(0, 12447, '\P{Is_Blk:hiragana}', "");
    Expect(1, 12447, '\P{^Is_Blk:hiragana}', "");
    Expect(0, 12448, '\p{Is_Blk:hiragana}', "");
    Expect(1, 12448, '\p{^Is_Blk:hiragana}', "");
    Expect(1, 12448, '\P{Is_Blk:hiragana}', "");
    Expect(0, 12448, '\P{^Is_Blk:hiragana}', "");
    Expect(1, 12447, '\p{Is_Blk=-_Hiragana}', "");
    Expect(0, 12447, '\p{^Is_Blk=-_Hiragana}', "");
    Expect(0, 12447, '\P{Is_Blk=-_Hiragana}', "");
    Expect(1, 12447, '\P{^Is_Blk=-_Hiragana}', "");
    Expect(0, 12448, '\p{Is_Blk=-_Hiragana}', "");
    Expect(1, 12448, '\p{^Is_Blk=-_Hiragana}', "");
    Expect(1, 12448, '\P{Is_Blk=-_Hiragana}', "");
    Expect(0, 12448, '\P{^Is_Blk=-_Hiragana}', "");
    Error('\p{Block=--ideographic_description_Characters:=}');
    Error('\P{Block=--ideographic_description_Characters:=}');
    Expect(1, 12287, '\p{Block=:\AIdeographic_Description_Characters\z:}', "");;
    Expect(0, 12288, '\p{Block=:\AIdeographic_Description_Characters\z:}', "");;
    Expect(1, 12287, '\p{Block=ideographicdescriptioncharacters}', "");
    Expect(0, 12287, '\p{^Block=ideographicdescriptioncharacters}', "");
    Expect(0, 12287, '\P{Block=ideographicdescriptioncharacters}', "");
    Expect(1, 12287, '\P{^Block=ideographicdescriptioncharacters}', "");
    Expect(0, 12288, '\p{Block=ideographicdescriptioncharacters}', "");
    Expect(1, 12288, '\p{^Block=ideographicdescriptioncharacters}', "");
    Expect(1, 12288, '\P{Block=ideographicdescriptioncharacters}', "");
    Expect(0, 12288, '\P{^Block=ideographicdescriptioncharacters}', "");
    Expect(1, 12287, '\p{Block=:\Aideographicdescriptioncharacters\z:}', "");;
    Expect(0, 12288, '\p{Block=:\Aideographicdescriptioncharacters\z:}', "");;
    Expect(1, 12287, '\p{Block:   Ideographic_description_Characters}', "");
    Expect(0, 12287, '\p{^Block:   Ideographic_description_Characters}', "");
    Expect(0, 12287, '\P{Block:   Ideographic_description_Characters}', "");
    Expect(1, 12287, '\P{^Block:   Ideographic_description_Characters}', "");
    Expect(0, 12288, '\p{Block:   Ideographic_description_Characters}', "");
    Expect(1, 12288, '\p{^Block:   Ideographic_description_Characters}', "");
    Expect(1, 12288, '\P{Block:   Ideographic_description_Characters}', "");
    Expect(0, 12288, '\P{^Block:   Ideographic_description_Characters}', "");
    Error('\p{Blk=-	IDC/a/}');
    Error('\P{Blk=-	IDC/a/}');
    Expect(1, 12287, '\p{Blk=:\AIDC\z:}', "");;
    Expect(0, 12288, '\p{Blk=:\AIDC\z:}', "");;
    Expect(1, 12287, '\p{Blk=idc}', "");
    Expect(0, 12287, '\p{^Blk=idc}', "");
    Expect(0, 12287, '\P{Blk=idc}', "");
    Expect(1, 12287, '\P{^Blk=idc}', "");
    Expect(0, 12288, '\p{Blk=idc}', "");
    Expect(1, 12288, '\p{^Blk=idc}', "");
    Expect(1, 12288, '\P{Blk=idc}', "");
    Expect(0, 12288, '\P{^Blk=idc}', "");
    Expect(1, 12287, '\p{Blk=:\Aidc\z:}', "");;
    Expect(0, 12288, '\p{Blk=:\Aidc\z:}', "");;
    Expect(1, 12287, '\p{Blk=	idc}', "");
    Expect(0, 12287, '\p{^Blk=	idc}', "");
    Expect(0, 12287, '\P{Blk=	idc}', "");
    Expect(1, 12287, '\P{^Blk=	idc}', "");
    Expect(0, 12288, '\p{Blk=	idc}', "");
    Expect(1, 12288, '\p{^Blk=	idc}', "");
    Expect(1, 12288, '\P{Blk=	idc}', "");
    Expect(0, 12288, '\P{^Blk=	idc}', "");
    Error('\p{Is_Block=_:=IDEOGRAPHIC_Description_characters}');
    Error('\P{Is_Block=_:=IDEOGRAPHIC_Description_characters}');
    Expect(1, 12287, '\p{Is_Block: ideographicdescriptioncharacters}', "");
    Expect(0, 12287, '\p{^Is_Block: ideographicdescriptioncharacters}', "");
    Expect(0, 12287, '\P{Is_Block: ideographicdescriptioncharacters}', "");
    Expect(1, 12287, '\P{^Is_Block: ideographicdescriptioncharacters}', "");
    Expect(0, 12288, '\p{Is_Block: ideographicdescriptioncharacters}', "");
    Expect(1, 12288, '\p{^Is_Block: ideographicdescriptioncharacters}', "");
    Expect(1, 12288, '\P{Is_Block: ideographicdescriptioncharacters}', "");
    Expect(0, 12288, '\P{^Is_Block: ideographicdescriptioncharacters}', "");
    Expect(1, 12287, '\p{Is_Block=		ideographic_Description_Characters}', "");
    Expect(0, 12287, '\p{^Is_Block=		ideographic_Description_Characters}', "");
    Expect(0, 12287, '\P{Is_Block=		ideographic_Description_Characters}', "");
    Expect(1, 12287, '\P{^Is_Block=		ideographic_Description_Characters}', "");
    Expect(0, 12288, '\p{Is_Block=		ideographic_Description_Characters}', "");
    Expect(1, 12288, '\p{^Is_Block=		ideographic_Description_Characters}', "");
    Expect(1, 12288, '\P{Is_Block=		ideographic_Description_Characters}', "");
    Expect(0, 12288, '\P{^Is_Block=		ideographic_Description_Characters}', "");
    Error('\p{Is_Blk=	_idc/a/}');
    Error('\P{Is_Blk=	_idc/a/}');
    Expect(1, 12287, '\p{Is_Blk:	idc}', "");
    Expect(0, 12287, '\p{^Is_Blk:	idc}', "");
    Expect(0, 12287, '\P{Is_Blk:	idc}', "");
    Expect(1, 12287, '\P{^Is_Blk:	idc}', "");
    Expect(0, 12288, '\p{Is_Blk:	idc}', "");
    Expect(1, 12288, '\p{^Is_Blk:	idc}', "");
    Expect(1, 12288, '\P{Is_Blk:	idc}', "");
    Expect(0, 12288, '\P{^Is_Blk:	idc}', "");
    Expect(1, 12287, '\p{Is_Blk= _IDC}', "");
    Expect(0, 12287, '\p{^Is_Blk= _IDC}', "");
    Expect(0, 12287, '\P{Is_Blk= _IDC}', "");
    Expect(1, 12287, '\P{^Is_Blk= _IDC}', "");
    Expect(0, 12288, '\p{Is_Blk= _IDC}', "");
    Expect(1, 12288, '\p{^Is_Blk= _IDC}', "");
    Expect(1, 12288, '\P{Is_Blk= _IDC}', "");
    Expect(0, 12288, '\P{^Is_Blk= _IDC}', "");
    Error('\p{Block=- IDEOGRAPHIC_symbols_And_punctuation:=}');
    Error('\P{Block=- IDEOGRAPHIC_symbols_And_punctuation:=}');
    Expect(1, 94207, '\p{Block=:\AIdeographic_Symbols_And_Punctuation\z:}', "");;
    Expect(0, 94208, '\p{Block=:\AIdeographic_Symbols_And_Punctuation\z:}', "");;
    Expect(1, 94207, '\p{Block=ideographicsymbolsandpunctuation}', "");
    Expect(0, 94207, '\p{^Block=ideographicsymbolsandpunctuation}', "");
    Expect(0, 94207, '\P{Block=ideographicsymbolsandpunctuation}', "");
    Expect(1, 94207, '\P{^Block=ideographicsymbolsandpunctuation}', "");
    Expect(0, 94208, '\p{Block=ideographicsymbolsandpunctuation}', "");
    Expect(1, 94208, '\p{^Block=ideographicsymbolsandpunctuation}', "");
    Expect(1, 94208, '\P{Block=ideographicsymbolsandpunctuation}', "");
    Expect(0, 94208, '\P{^Block=ideographicsymbolsandpunctuation}', "");
    Expect(1, 94207, '\p{Block=:\Aideographicsymbolsandpunctuation\z:}', "");;
    Expect(0, 94208, '\p{Block=:\Aideographicsymbolsandpunctuation\z:}', "");;
    Expect(1, 94207, '\p{Block=-	IDEOGRAPHIC_SYMBOLS_And_PUNCTUATION}', "");
    Expect(0, 94207, '\p{^Block=-	IDEOGRAPHIC_SYMBOLS_And_PUNCTUATION}', "");
    Expect(0, 94207, '\P{Block=-	IDEOGRAPHIC_SYMBOLS_And_PUNCTUATION}', "");
    Expect(1, 94207, '\P{^Block=-	IDEOGRAPHIC_SYMBOLS_And_PUNCTUATION}', "");
    Expect(0, 94208, '\p{Block=-	IDEOGRAPHIC_SYMBOLS_And_PUNCTUATION}', "");
    Expect(1, 94208, '\p{^Block=-	IDEOGRAPHIC_SYMBOLS_And_PUNCTUATION}', "");
    Expect(1, 94208, '\P{Block=-	IDEOGRAPHIC_SYMBOLS_And_PUNCTUATION}', "");
    Expect(0, 94208, '\P{^Block=-	IDEOGRAPHIC_SYMBOLS_And_PUNCTUATION}', "");
    Error('\p{Blk=:=	-Ideographic_Symbols}');
    Error('\P{Blk=:=	-Ideographic_Symbols}');
    Expect(1, 94207, '\p{Blk=:\AIdeographic_Symbols\z:}', "");;
    Expect(0, 94208, '\p{Blk=:\AIdeographic_Symbols\z:}', "");;
    Expect(1, 94207, '\p{Blk=ideographicsymbols}', "");
    Expect(0, 94207, '\p{^Blk=ideographicsymbols}', "");
    Expect(0, 94207, '\P{Blk=ideographicsymbols}', "");
    Expect(1, 94207, '\P{^Blk=ideographicsymbols}', "");
    Expect(0, 94208, '\p{Blk=ideographicsymbols}', "");
    Expect(1, 94208, '\p{^Blk=ideographicsymbols}', "");
    Expect(1, 94208, '\P{Blk=ideographicsymbols}', "");
    Expect(0, 94208, '\P{^Blk=ideographicsymbols}', "");
    Expect(1, 94207, '\p{Blk=:\Aideographicsymbols\z:}', "");;
    Expect(0, 94208, '\p{Blk=:\Aideographicsymbols\z:}', "");;
    Expect(1, 94207, '\p{Blk= -Ideographic_Symbols}', "");
    Expect(0, 94207, '\p{^Blk= -Ideographic_Symbols}', "");
    Expect(0, 94207, '\P{Blk= -Ideographic_Symbols}', "");
    Expect(1, 94207, '\P{^Blk= -Ideographic_Symbols}', "");
    Expect(0, 94208, '\p{Blk= -Ideographic_Symbols}', "");
    Expect(1, 94208, '\p{^Blk= -Ideographic_Symbols}', "");
    Expect(1, 94208, '\P{Blk= -Ideographic_Symbols}', "");
    Expect(0, 94208, '\P{^Blk= -Ideographic_Symbols}', "");
    Error('\p{Is_Block:   -:=ideographic_Symbols_And_Punctuation}');
    Error('\P{Is_Block:   -:=ideographic_Symbols_And_Punctuation}');
    Expect(1, 94207, '\p{Is_Block=ideographicsymbolsandpunctuation}', "");
    Expect(0, 94207, '\p{^Is_Block=ideographicsymbolsandpunctuation}', "");
    Expect(0, 94207, '\P{Is_Block=ideographicsymbolsandpunctuation}', "");
    Expect(1, 94207, '\P{^Is_Block=ideographicsymbolsandpunctuation}', "");
    Expect(0, 94208, '\p{Is_Block=ideographicsymbolsandpunctuation}', "");
    Expect(1, 94208, '\p{^Is_Block=ideographicsymbolsandpunctuation}', "");
    Expect(1, 94208, '\P{Is_Block=ideographicsymbolsandpunctuation}', "");
    Expect(0, 94208, '\P{^Is_Block=ideographicsymbolsandpunctuation}', "");
    Expect(1, 94207, '\p{Is_Block=_	ideographic_Symbols_AND_PUNCTUATION}', "");
    Expect(0, 94207, '\p{^Is_Block=_	ideographic_Symbols_AND_PUNCTUATION}', "");
    Expect(0, 94207, '\P{Is_Block=_	ideographic_Symbols_AND_PUNCTUATION}', "");
    Expect(1, 94207, '\P{^Is_Block=_	ideographic_Symbols_AND_PUNCTUATION}', "");
    Expect(0, 94208, '\p{Is_Block=_	ideographic_Symbols_AND_PUNCTUATION}', "");
    Expect(1, 94208, '\p{^Is_Block=_	ideographic_Symbols_AND_PUNCTUATION}', "");
    Expect(1, 94208, '\P{Is_Block=_	ideographic_Symbols_AND_PUNCTUATION}', "");
    Expect(0, 94208, '\P{^Is_Block=_	ideographic_Symbols_AND_PUNCTUATION}', "");
    Error('\p{Is_Blk= :=Ideographic_Symbols}');
    Error('\P{Is_Blk= :=Ideographic_Symbols}');
    Expect(1, 94207, '\p{Is_Blk=ideographicsymbols}', "");
    Expect(0, 94207, '\p{^Is_Blk=ideographicsymbols}', "");
    Expect(0, 94207, '\P{Is_Blk=ideographicsymbols}', "");
    Expect(1, 94207, '\P{^Is_Blk=ideographicsymbols}', "");
    Expect(0, 94208, '\p{Is_Blk=ideographicsymbols}', "");
    Expect(1, 94208, '\p{^Is_Blk=ideographicsymbols}', "");
    Expect(1, 94208, '\P{Is_Blk=ideographicsymbols}', "");
    Expect(0, 94208, '\P{^Is_Blk=ideographicsymbols}', "");
    Expect(1, 94207, '\p{Is_Blk=_ ideographic_Symbols}', "");
    Expect(0, 94207, '\p{^Is_Blk=_ ideographic_Symbols}', "");
    Expect(0, 94207, '\P{Is_Blk=_ ideographic_Symbols}', "");
    Expect(1, 94207, '\P{^Is_Blk=_ ideographic_Symbols}', "");
    Expect(0, 94208, '\p{Is_Blk=_ ideographic_Symbols}', "");
    Expect(1, 94208, '\p{^Is_Blk=_ ideographic_Symbols}', "");
    Expect(1, 94208, '\P{Is_Blk=_ ideographic_Symbols}', "");
    Expect(0, 94208, '\P{^Is_Blk=_ ideographic_Symbols}', "");
    Error('\p{Block=/a/--Imperial_ARAMAIC}');
    Error('\P{Block=/a/--Imperial_ARAMAIC}');
    Expect(1, 67679, '\p{Block=:\AImperial_Aramaic\z:}', "");;
    Expect(0, 67680, '\p{Block=:\AImperial_Aramaic\z:}', "");;
    Expect(1, 67679, '\p{Block=imperialaramaic}', "");
    Expect(0, 67679, '\p{^Block=imperialaramaic}', "");
    Expect(0, 67679, '\P{Block=imperialaramaic}', "");
    Expect(1, 67679, '\P{^Block=imperialaramaic}', "");
    Expect(0, 67680, '\p{Block=imperialaramaic}', "");
    Expect(1, 67680, '\p{^Block=imperialaramaic}', "");
    Expect(1, 67680, '\P{Block=imperialaramaic}', "");
    Expect(0, 67680, '\P{^Block=imperialaramaic}', "");
    Expect(1, 67679, '\p{Block=:\Aimperialaramaic\z:}', "");;
    Expect(0, 67680, '\p{Block=:\Aimperialaramaic\z:}', "");;
    Expect(1, 67679, '\p{Block:	IMPERIAL_ARAMAIC}', "");
    Expect(0, 67679, '\p{^Block:	IMPERIAL_ARAMAIC}', "");
    Expect(0, 67679, '\P{Block:	IMPERIAL_ARAMAIC}', "");
    Expect(1, 67679, '\P{^Block:	IMPERIAL_ARAMAIC}', "");
    Expect(0, 67680, '\p{Block:	IMPERIAL_ARAMAIC}', "");
    Expect(1, 67680, '\p{^Block:	IMPERIAL_ARAMAIC}', "");
    Expect(1, 67680, '\P{Block:	IMPERIAL_ARAMAIC}', "");
    Expect(0, 67680, '\P{^Block:	IMPERIAL_ARAMAIC}', "");
    Error('\p{Blk=	/a/Imperial_Aramaic}');
    Error('\P{Blk=	/a/Imperial_Aramaic}');
    Expect(1, 67679, '\p{Blk=:\AImperial_Aramaic\z:}', "");;
    Expect(0, 67680, '\p{Blk=:\AImperial_Aramaic\z:}', "");;
    Expect(1, 67679, '\p{Blk=imperialaramaic}', "");
    Expect(0, 67679, '\p{^Blk=imperialaramaic}', "");
    Expect(0, 67679, '\P{Blk=imperialaramaic}', "");
    Expect(1, 67679, '\P{^Blk=imperialaramaic}', "");
    Expect(0, 67680, '\p{Blk=imperialaramaic}', "");
    Expect(1, 67680, '\p{^Blk=imperialaramaic}', "");
    Expect(1, 67680, '\P{Blk=imperialaramaic}', "");
    Expect(0, 67680, '\P{^Blk=imperialaramaic}', "");
    Expect(1, 67679, '\p{Blk=:\Aimperialaramaic\z:}', "");;
    Expect(0, 67680, '\p{Blk=:\Aimperialaramaic\z:}', "");;
    Expect(1, 67679, '\p{Blk:-	Imperial_aramaic}', "");
    Expect(0, 67679, '\p{^Blk:-	Imperial_aramaic}', "");
    Expect(0, 67679, '\P{Blk:-	Imperial_aramaic}', "");
    Expect(1, 67679, '\P{^Blk:-	Imperial_aramaic}', "");
    Expect(0, 67680, '\p{Blk:-	Imperial_aramaic}', "");
    Expect(1, 67680, '\p{^Blk:-	Imperial_aramaic}', "");
    Expect(1, 67680, '\P{Blk:-	Imperial_aramaic}', "");
    Expect(0, 67680, '\P{^Blk:-	Imperial_aramaic}', "");
    Error('\p{Is_Block::=imperial_aramaic}');
    Error('\P{Is_Block::=imperial_aramaic}');
    Expect(1, 67679, '\p{Is_Block=imperialaramaic}', "");
    Expect(0, 67679, '\p{^Is_Block=imperialaramaic}', "");
    Expect(0, 67679, '\P{Is_Block=imperialaramaic}', "");
    Expect(1, 67679, '\P{^Is_Block=imperialaramaic}', "");
    Expect(0, 67680, '\p{Is_Block=imperialaramaic}', "");
    Expect(1, 67680, '\p{^Is_Block=imperialaramaic}', "");
    Expect(1, 67680, '\P{Is_Block=imperialaramaic}', "");
    Expect(0, 67680, '\P{^Is_Block=imperialaramaic}', "");
    Expect(1, 67679, '\p{Is_Block= 	Imperial_Aramaic}', "");
    Expect(0, 67679, '\p{^Is_Block= 	Imperial_Aramaic}', "");
    Expect(0, 67679, '\P{Is_Block= 	Imperial_Aramaic}', "");
    Expect(1, 67679, '\P{^Is_Block= 	Imperial_Aramaic}', "");
    Expect(0, 67680, '\p{Is_Block= 	Imperial_Aramaic}', "");
    Expect(1, 67680, '\p{^Is_Block= 	Imperial_Aramaic}', "");
    Expect(1, 67680, '\P{Is_Block= 	Imperial_Aramaic}', "");
    Expect(0, 67680, '\P{^Is_Block= 	Imperial_Aramaic}', "");
    Error('\p{Is_Blk=- Imperial_ARAMAIC:=}');
    Error('\P{Is_Blk=- Imperial_ARAMAIC:=}');
    Expect(1, 67679, '\p{Is_Blk=imperialaramaic}', "");
    Expect(0, 67679, '\p{^Is_Blk=imperialaramaic}', "");
    Expect(0, 67679, '\P{Is_Blk=imperialaramaic}', "");
    Expect(1, 67679, '\P{^Is_Blk=imperialaramaic}', "");
    Expect(0, 67680, '\p{Is_Blk=imperialaramaic}', "");
    Expect(1, 67680, '\p{^Is_Blk=imperialaramaic}', "");
    Expect(1, 67680, '\P{Is_Blk=imperialaramaic}', "");
    Expect(0, 67680, '\P{^Is_Blk=imperialaramaic}', "");
    Expect(1, 67679, '\p{Is_Blk=_-imperial_ARAMAIC}', "");
    Expect(0, 67679, '\p{^Is_Blk=_-imperial_ARAMAIC}', "");
    Expect(0, 67679, '\P{Is_Blk=_-imperial_ARAMAIC}', "");
    Expect(1, 67679, '\P{^Is_Blk=_-imperial_ARAMAIC}', "");
    Expect(0, 67680, '\p{Is_Blk=_-imperial_ARAMAIC}', "");
    Expect(1, 67680, '\p{^Is_Blk=_-imperial_ARAMAIC}', "");
    Expect(1, 67680, '\P{Is_Blk=_-imperial_ARAMAIC}', "");
    Expect(0, 67680, '\P{^Is_Blk=_-imperial_ARAMAIC}', "");
    Error('\p{Block=/a/ Common_Indic_NUMBER_Forms}');
    Error('\P{Block=/a/ Common_Indic_NUMBER_Forms}');
    Expect(1, 43071, '\p{Block=:\ACommon_Indic_Number_Forms\z:}', "");;
    Expect(0, 43072, '\p{Block=:\ACommon_Indic_Number_Forms\z:}', "");;
    Expect(1, 43071, '\p{Block=commonindicnumberforms}', "");
    Expect(0, 43071, '\p{^Block=commonindicnumberforms}', "");
    Expect(0, 43071, '\P{Block=commonindicnumberforms}', "");
    Expect(1, 43071, '\P{^Block=commonindicnumberforms}', "");
    Expect(0, 43072, '\p{Block=commonindicnumberforms}', "");
    Expect(1, 43072, '\p{^Block=commonindicnumberforms}', "");
    Expect(1, 43072, '\P{Block=commonindicnumberforms}', "");
    Expect(0, 43072, '\P{^Block=commonindicnumberforms}', "");
    Expect(1, 43071, '\p{Block=:\Acommonindicnumberforms\z:}', "");;
    Expect(0, 43072, '\p{Block=:\Acommonindicnumberforms\z:}', "");;
    Expect(1, 43071, '\p{Block=		Common_indic_Number_Forms}', "");
    Expect(0, 43071, '\p{^Block=		Common_indic_Number_Forms}', "");
    Expect(0, 43071, '\P{Block=		Common_indic_Number_Forms}', "");
    Expect(1, 43071, '\P{^Block=		Common_indic_Number_Forms}', "");
    Expect(0, 43072, '\p{Block=		Common_indic_Number_Forms}', "");
    Expect(1, 43072, '\p{^Block=		Common_indic_Number_Forms}', "");
    Expect(1, 43072, '\P{Block=		Common_indic_Number_Forms}', "");
    Expect(0, 43072, '\P{^Block=		Common_indic_Number_Forms}', "");
    Error('\p{Blk=_ Indic_number_Forms:=}');
    Error('\P{Blk=_ Indic_number_Forms:=}');
    Expect(1, 43071, '\p{Blk=:\AIndic_Number_Forms\z:}', "");;
    Expect(0, 43072, '\p{Blk=:\AIndic_Number_Forms\z:}', "");;
    Expect(1, 43071, '\p{Blk=indicnumberforms}', "");
    Expect(0, 43071, '\p{^Blk=indicnumberforms}', "");
    Expect(0, 43071, '\P{Blk=indicnumberforms}', "");
    Expect(1, 43071, '\P{^Blk=indicnumberforms}', "");
    Expect(0, 43072, '\p{Blk=indicnumberforms}', "");
    Expect(1, 43072, '\p{^Blk=indicnumberforms}', "");
    Expect(1, 43072, '\P{Blk=indicnumberforms}', "");
    Expect(0, 43072, '\P{^Blk=indicnumberforms}', "");
    Expect(1, 43071, '\p{Blk=:\Aindicnumberforms\z:}', "");;
    Expect(0, 43072, '\p{Blk=:\Aindicnumberforms\z:}', "");;
    Expect(1, 43071, '\p{Blk=_ INDIC_number_Forms}', "");
    Expect(0, 43071, '\p{^Blk=_ INDIC_number_Forms}', "");
    Expect(0, 43071, '\P{Blk=_ INDIC_number_Forms}', "");
    Expect(1, 43071, '\P{^Blk=_ INDIC_number_Forms}', "");
    Expect(0, 43072, '\p{Blk=_ INDIC_number_Forms}', "");
    Expect(1, 43072, '\p{^Blk=_ INDIC_number_Forms}', "");
    Expect(1, 43072, '\P{Blk=_ INDIC_number_Forms}', "");
    Expect(0, 43072, '\P{^Blk=_ INDIC_number_Forms}', "");
    Error('\p{Is_Block=_/a/Common_indic_NUMBER_Forms}');
    Error('\P{Is_Block=_/a/Common_indic_NUMBER_Forms}');
    Expect(1, 43071, '\p{Is_Block=commonindicnumberforms}', "");
    Expect(0, 43071, '\p{^Is_Block=commonindicnumberforms}', "");
    Expect(0, 43071, '\P{Is_Block=commonindicnumberforms}', "");
    Expect(1, 43071, '\P{^Is_Block=commonindicnumberforms}', "");
    Expect(0, 43072, '\p{Is_Block=commonindicnumberforms}', "");
    Expect(1, 43072, '\p{^Is_Block=commonindicnumberforms}', "");
    Expect(1, 43072, '\P{Is_Block=commonindicnumberforms}', "");
    Expect(0, 43072, '\P{^Is_Block=commonindicnumberforms}', "");
    Expect(1, 43071, '\p{Is_Block=common_INDIC_NUMBER_Forms}', "");
    Expect(0, 43071, '\p{^Is_Block=common_INDIC_NUMBER_Forms}', "");
    Expect(0, 43071, '\P{Is_Block=common_INDIC_NUMBER_Forms}', "");
    Expect(1, 43071, '\P{^Is_Block=common_INDIC_NUMBER_Forms}', "");
    Expect(0, 43072, '\p{Is_Block=common_INDIC_NUMBER_Forms}', "");
    Expect(1, 43072, '\p{^Is_Block=common_INDIC_NUMBER_Forms}', "");
    Expect(1, 43072, '\P{Is_Block=common_INDIC_NUMBER_Forms}', "");
    Expect(0, 43072, '\P{^Is_Block=common_INDIC_NUMBER_Forms}', "");
    Error('\p{Is_Blk=	Indic_number_forms:=}');
    Error('\P{Is_Blk=	Indic_number_forms:=}');
    Expect(1, 43071, '\p{Is_Blk=indicnumberforms}', "");
    Expect(0, 43071, '\p{^Is_Blk=indicnumberforms}', "");
    Expect(0, 43071, '\P{Is_Blk=indicnumberforms}', "");
    Expect(1, 43071, '\P{^Is_Blk=indicnumberforms}', "");
    Expect(0, 43072, '\p{Is_Blk=indicnumberforms}', "");
    Expect(1, 43072, '\p{^Is_Blk=indicnumberforms}', "");
    Expect(1, 43072, '\P{Is_Blk=indicnumberforms}', "");
    Expect(0, 43072, '\P{^Is_Blk=indicnumberforms}', "");
    Expect(1, 43071, '\p{Is_Blk=-INDIC_Number_Forms}', "");
    Expect(0, 43071, '\p{^Is_Blk=-INDIC_Number_Forms}', "");
    Expect(0, 43071, '\P{Is_Blk=-INDIC_Number_Forms}', "");
    Expect(1, 43071, '\P{^Is_Blk=-INDIC_Number_Forms}', "");
    Expect(0, 43072, '\p{Is_Blk=-INDIC_Number_Forms}', "");
    Expect(1, 43072, '\p{^Is_Blk=-INDIC_Number_Forms}', "");
    Expect(1, 43072, '\P{Is_Blk=-INDIC_Number_Forms}', "");
    Expect(0, 43072, '\P{^Is_Blk=-INDIC_Number_Forms}', "");
    Error('\p{Block= -INDIC_siyaq_NUMBERS/a/}');
    Error('\P{Block= -INDIC_siyaq_NUMBERS/a/}');
    Expect(1, 126143, '\p{Block=:\AIndic_Siyaq_Numbers\z:}', "");;
    Expect(0, 126144, '\p{Block=:\AIndic_Siyaq_Numbers\z:}', "");;
    Expect(1, 126143, '\p{Block=indicsiyaqnumbers}', "");
    Expect(0, 126143, '\p{^Block=indicsiyaqnumbers}', "");
    Expect(0, 126143, '\P{Block=indicsiyaqnumbers}', "");
    Expect(1, 126143, '\P{^Block=indicsiyaqnumbers}', "");
    Expect(0, 126144, '\p{Block=indicsiyaqnumbers}', "");
    Expect(1, 126144, '\p{^Block=indicsiyaqnumbers}', "");
    Expect(1, 126144, '\P{Block=indicsiyaqnumbers}', "");
    Expect(0, 126144, '\P{^Block=indicsiyaqnumbers}', "");
    Expect(1, 126143, '\p{Block=:\Aindicsiyaqnumbers\z:}', "");;
    Expect(0, 126144, '\p{Block=:\Aindicsiyaqnumbers\z:}', "");;
    Expect(1, 126143, '\p{Block=	INDIC_Siyaq_NUMBERS}', "");
    Expect(0, 126143, '\p{^Block=	INDIC_Siyaq_NUMBERS}', "");
    Expect(0, 126143, '\P{Block=	INDIC_Siyaq_NUMBERS}', "");
    Expect(1, 126143, '\P{^Block=	INDIC_Siyaq_NUMBERS}', "");
    Expect(0, 126144, '\p{Block=	INDIC_Siyaq_NUMBERS}', "");
    Expect(1, 126144, '\p{^Block=	INDIC_Siyaq_NUMBERS}', "");
    Expect(1, 126144, '\P{Block=	INDIC_Siyaq_NUMBERS}', "");
    Expect(0, 126144, '\P{^Block=	INDIC_Siyaq_NUMBERS}', "");
    Error('\p{Blk=/a/__Indic_Siyaq_numbers}');
    Error('\P{Blk=/a/__Indic_Siyaq_numbers}');
    Expect(1, 126143, '\p{Blk=:\AIndic_Siyaq_Numbers\z:}', "");;
    Expect(0, 126144, '\p{Blk=:\AIndic_Siyaq_Numbers\z:}', "");;
    Expect(1, 126143, '\p{Blk=indicsiyaqnumbers}', "");
    Expect(0, 126143, '\p{^Blk=indicsiyaqnumbers}', "");
    Expect(0, 126143, '\P{Blk=indicsiyaqnumbers}', "");
    Expect(1, 126143, '\P{^Blk=indicsiyaqnumbers}', "");
    Expect(0, 126144, '\p{Blk=indicsiyaqnumbers}', "");
    Expect(1, 126144, '\p{^Blk=indicsiyaqnumbers}', "");
    Expect(1, 126144, '\P{Blk=indicsiyaqnumbers}', "");
    Expect(0, 126144, '\P{^Blk=indicsiyaqnumbers}', "");
    Expect(1, 126143, '\p{Blk=:\Aindicsiyaqnumbers\z:}', "");;
    Expect(0, 126144, '\p{Blk=:\Aindicsiyaqnumbers\z:}', "");;
    Expect(1, 126143, '\p{Blk= -Indic_SIYAQ_Numbers}', "");
    Expect(0, 126143, '\p{^Blk= -Indic_SIYAQ_Numbers}', "");
    Expect(0, 126143, '\P{Blk= -Indic_SIYAQ_Numbers}', "");
    Expect(1, 126143, '\P{^Blk= -Indic_SIYAQ_Numbers}', "");
    Expect(0, 126144, '\p{Blk= -Indic_SIYAQ_Numbers}', "");
    Expect(1, 126144, '\p{^Blk= -Indic_SIYAQ_Numbers}', "");
    Expect(1, 126144, '\P{Blk= -Indic_SIYAQ_Numbers}', "");
    Expect(0, 126144, '\P{^Blk= -Indic_SIYAQ_Numbers}', "");
    Error('\p{Is_Block=_:=Indic_siyaq_Numbers}');
    Error('\P{Is_Block=_:=Indic_siyaq_Numbers}');
    Expect(1, 126143, '\p{Is_Block=indicsiyaqnumbers}', "");
    Expect(0, 126143, '\p{^Is_Block=indicsiyaqnumbers}', "");
    Expect(0, 126143, '\P{Is_Block=indicsiyaqnumbers}', "");
    Expect(1, 126143, '\P{^Is_Block=indicsiyaqnumbers}', "");
    Expect(0, 126144, '\p{Is_Block=indicsiyaqnumbers}', "");
    Expect(1, 126144, '\p{^Is_Block=indicsiyaqnumbers}', "");
    Expect(1, 126144, '\P{Is_Block=indicsiyaqnumbers}', "");
    Expect(0, 126144, '\P{^Is_Block=indicsiyaqnumbers}', "");
    Expect(1, 126143, '\p{Is_Block=-Indic_SIYAQ_Numbers}', "");
    Expect(0, 126143, '\p{^Is_Block=-Indic_SIYAQ_Numbers}', "");
    Expect(0, 126143, '\P{Is_Block=-Indic_SIYAQ_Numbers}', "");
    Expect(1, 126143, '\P{^Is_Block=-Indic_SIYAQ_Numbers}', "");
    Expect(0, 126144, '\p{Is_Block=-Indic_SIYAQ_Numbers}', "");
    Expect(1, 126144, '\p{^Is_Block=-Indic_SIYAQ_Numbers}', "");
    Expect(1, 126144, '\P{Is_Block=-Indic_SIYAQ_Numbers}', "");
    Expect(0, 126144, '\P{^Is_Block=-Indic_SIYAQ_Numbers}', "");
    Error('\p{Is_Blk:		INDIC_SIYAQ_numbers:=}');
    Error('\P{Is_Blk:		INDIC_SIYAQ_numbers:=}');
    Expect(1, 126143, '\p{Is_Blk:	indicsiyaqnumbers}', "");
    Expect(0, 126143, '\p{^Is_Blk:	indicsiyaqnumbers}', "");
    Expect(0, 126143, '\P{Is_Blk:	indicsiyaqnumbers}', "");
    Expect(1, 126143, '\P{^Is_Blk:	indicsiyaqnumbers}', "");
    Expect(0, 126144, '\p{Is_Blk:	indicsiyaqnumbers}', "");
    Expect(1, 126144, '\p{^Is_Blk:	indicsiyaqnumbers}', "");
    Expect(1, 126144, '\P{Is_Blk:	indicsiyaqnumbers}', "");
    Expect(0, 126144, '\P{^Is_Blk:	indicsiyaqnumbers}', "");
    Expect(1, 126143, '\p{Is_Blk=_	indic_SIYAQ_Numbers}', "");
    Expect(0, 126143, '\p{^Is_Blk=_	indic_SIYAQ_Numbers}', "");
    Expect(0, 126143, '\P{Is_Blk=_	indic_SIYAQ_Numbers}', "");
    Expect(1, 126143, '\P{^Is_Blk=_	indic_SIYAQ_Numbers}', "");
    Expect(0, 126144, '\p{Is_Blk=_	indic_SIYAQ_Numbers}', "");
    Expect(1, 126144, '\p{^Is_Blk=_	indic_SIYAQ_Numbers}', "");
    Expect(1, 126144, '\P{Is_Blk=_	indic_SIYAQ_Numbers}', "");
    Expect(0, 126144, '\P{^Is_Blk=_	indic_SIYAQ_Numbers}', "");
    Error('\p{Block=/a/__inscriptional_Pahlavi}');
    Error('\P{Block=/a/__inscriptional_Pahlavi}');
    Expect(1, 68479, '\p{Block=:\AInscriptional_Pahlavi\z:}', "");;
    Expect(0, 68480, '\p{Block=:\AInscriptional_Pahlavi\z:}', "");;
    Expect(1, 68479, '\p{Block=inscriptionalpahlavi}', "");
    Expect(0, 68479, '\p{^Block=inscriptionalpahlavi}', "");
    Expect(0, 68479, '\P{Block=inscriptionalpahlavi}', "");
    Expect(1, 68479, '\P{^Block=inscriptionalpahlavi}', "");
    Expect(0, 68480, '\p{Block=inscriptionalpahlavi}', "");
    Expect(1, 68480, '\p{^Block=inscriptionalpahlavi}', "");
    Expect(1, 68480, '\P{Block=inscriptionalpahlavi}', "");
    Expect(0, 68480, '\P{^Block=inscriptionalpahlavi}', "");
    Expect(1, 68479, '\p{Block=:\Ainscriptionalpahlavi\z:}', "");;
    Expect(0, 68480, '\p{Block=:\Ainscriptionalpahlavi\z:}', "");;
    Expect(1, 68479, '\p{Block=	Inscriptional_pahlavi}', "");
    Expect(0, 68479, '\p{^Block=	Inscriptional_pahlavi}', "");
    Expect(0, 68479, '\P{Block=	Inscriptional_pahlavi}', "");
    Expect(1, 68479, '\P{^Block=	Inscriptional_pahlavi}', "");
    Expect(0, 68480, '\p{Block=	Inscriptional_pahlavi}', "");
    Expect(1, 68480, '\p{^Block=	Inscriptional_pahlavi}', "");
    Expect(1, 68480, '\P{Block=	Inscriptional_pahlavi}', "");
    Expect(0, 68480, '\P{^Block=	Inscriptional_pahlavi}', "");
    Error('\p{Blk=/a/ _INSCRIPTIONAL_Pahlavi}');
    Error('\P{Blk=/a/ _INSCRIPTIONAL_Pahlavi}');
    Expect(1, 68479, '\p{Blk=:\AInscriptional_Pahlavi\z:}', "");;
    Expect(0, 68480, '\p{Blk=:\AInscriptional_Pahlavi\z:}', "");;
    Expect(1, 68479, '\p{Blk=inscriptionalpahlavi}', "");
    Expect(0, 68479, '\p{^Blk=inscriptionalpahlavi}', "");
    Expect(0, 68479, '\P{Blk=inscriptionalpahlavi}', "");
    Expect(1, 68479, '\P{^Blk=inscriptionalpahlavi}', "");
    Expect(0, 68480, '\p{Blk=inscriptionalpahlavi}', "");
    Expect(1, 68480, '\p{^Blk=inscriptionalpahlavi}', "");
    Expect(1, 68480, '\P{Blk=inscriptionalpahlavi}', "");
    Expect(0, 68480, '\P{^Blk=inscriptionalpahlavi}', "");
    Expect(1, 68479, '\p{Blk=:\Ainscriptionalpahlavi\z:}', "");;
    Expect(0, 68480, '\p{Blk=:\Ainscriptionalpahlavi\z:}', "");;
    Expect(1, 68479, '\p{Blk=_	inscriptional_Pahlavi}', "");
    Expect(0, 68479, '\p{^Blk=_	inscriptional_Pahlavi}', "");
    Expect(0, 68479, '\P{Blk=_	inscriptional_Pahlavi}', "");
    Expect(1, 68479, '\P{^Blk=_	inscriptional_Pahlavi}', "");
    Expect(0, 68480, '\p{Blk=_	inscriptional_Pahlavi}', "");
    Expect(1, 68480, '\p{^Blk=_	inscriptional_Pahlavi}', "");
    Expect(1, 68480, '\P{Blk=_	inscriptional_Pahlavi}', "");
    Expect(0, 68480, '\P{^Blk=_	inscriptional_Pahlavi}', "");
    Error('\p{Is_Block= :=inscriptional_pahlavi}');
    Error('\P{Is_Block= :=inscriptional_pahlavi}');
    Expect(1, 68479, '\p{Is_Block=inscriptionalpahlavi}', "");
    Expect(0, 68479, '\p{^Is_Block=inscriptionalpahlavi}', "");
    Expect(0, 68479, '\P{Is_Block=inscriptionalpahlavi}', "");
    Expect(1, 68479, '\P{^Is_Block=inscriptionalpahlavi}', "");
    Expect(0, 68480, '\p{Is_Block=inscriptionalpahlavi}', "");
    Expect(1, 68480, '\p{^Is_Block=inscriptionalpahlavi}', "");
    Expect(1, 68480, '\P{Is_Block=inscriptionalpahlavi}', "");
    Expect(0, 68480, '\P{^Is_Block=inscriptionalpahlavi}', "");
    Expect(1, 68479, '\p{Is_Block=-Inscriptional_PAHLAVI}', "");
    Expect(0, 68479, '\p{^Is_Block=-Inscriptional_PAHLAVI}', "");
    Expect(0, 68479, '\P{Is_Block=-Inscriptional_PAHLAVI}', "");
    Expect(1, 68479, '\P{^Is_Block=-Inscriptional_PAHLAVI}', "");
    Expect(0, 68480, '\p{Is_Block=-Inscriptional_PAHLAVI}', "");
    Expect(1, 68480, '\p{^Is_Block=-Inscriptional_PAHLAVI}', "");
    Expect(1, 68480, '\P{Is_Block=-Inscriptional_PAHLAVI}', "");
    Expect(0, 68480, '\P{^Is_Block=-Inscriptional_PAHLAVI}', "");
    Error('\p{Is_Blk=_:=INSCRIPTIONAL_Pahlavi}');
    Error('\P{Is_Blk=_:=INSCRIPTIONAL_Pahlavi}');
    Expect(1, 68479, '\p{Is_Blk=inscriptionalpahlavi}', "");
    Expect(0, 68479, '\p{^Is_Blk=inscriptionalpahlavi}', "");
    Expect(0, 68479, '\P{Is_Blk=inscriptionalpahlavi}', "");
    Expect(1, 68479, '\P{^Is_Blk=inscriptionalpahlavi}', "");
    Expect(0, 68480, '\p{Is_Blk=inscriptionalpahlavi}', "");
    Expect(1, 68480, '\p{^Is_Blk=inscriptionalpahlavi}', "");
    Expect(1, 68480, '\P{Is_Blk=inscriptionalpahlavi}', "");
    Expect(0, 68480, '\P{^Is_Blk=inscriptionalpahlavi}', "");
    Expect(1, 68479, '\p{Is_Blk=--Inscriptional_PAHLAVI}', "");
    Expect(0, 68479, '\p{^Is_Blk=--Inscriptional_PAHLAVI}', "");
    Expect(0, 68479, '\P{Is_Blk=--Inscriptional_PAHLAVI}', "");
    Expect(1, 68479, '\P{^Is_Blk=--Inscriptional_PAHLAVI}', "");
    Expect(0, 68480, '\p{Is_Blk=--Inscriptional_PAHLAVI}', "");
    Expect(1, 68480, '\p{^Is_Blk=--Inscriptional_PAHLAVI}', "");
    Expect(1, 68480, '\P{Is_Blk=--Inscriptional_PAHLAVI}', "");
    Expect(0, 68480, '\P{^Is_Blk=--Inscriptional_PAHLAVI}', "");
    Error('\p{Block=	:=Inscriptional_parthian}');
    Error('\P{Block=	:=Inscriptional_parthian}');
    Expect(1, 68447, '\p{Block=:\AInscriptional_Parthian\z:}', "");;
    Expect(0, 68448, '\p{Block=:\AInscriptional_Parthian\z:}', "");;
    Expect(1, 68447, '\p{Block=inscriptionalparthian}', "");
    Expect(0, 68447, '\p{^Block=inscriptionalparthian}', "");
    Expect(0, 68447, '\P{Block=inscriptionalparthian}', "");
    Expect(1, 68447, '\P{^Block=inscriptionalparthian}', "");
    Expect(0, 68448, '\p{Block=inscriptionalparthian}', "");
    Expect(1, 68448, '\p{^Block=inscriptionalparthian}', "");
    Expect(1, 68448, '\P{Block=inscriptionalparthian}', "");
    Expect(0, 68448, '\P{^Block=inscriptionalparthian}', "");
    Expect(1, 68447, '\p{Block=:\Ainscriptionalparthian\z:}', "");;
    Expect(0, 68448, '\p{Block=:\Ainscriptionalparthian\z:}', "");;
    Expect(1, 68447, '\p{Block=_Inscriptional_PARTHIAN}', "");
    Expect(0, 68447, '\p{^Block=_Inscriptional_PARTHIAN}', "");
    Expect(0, 68447, '\P{Block=_Inscriptional_PARTHIAN}', "");
    Expect(1, 68447, '\P{^Block=_Inscriptional_PARTHIAN}', "");
    Expect(0, 68448, '\p{Block=_Inscriptional_PARTHIAN}', "");
    Expect(1, 68448, '\p{^Block=_Inscriptional_PARTHIAN}', "");
    Expect(1, 68448, '\P{Block=_Inscriptional_PARTHIAN}', "");
    Expect(0, 68448, '\P{^Block=_Inscriptional_PARTHIAN}', "");
    Error('\p{Blk= -Inscriptional_Parthian/a/}');
    Error('\P{Blk= -Inscriptional_Parthian/a/}');
    Expect(1, 68447, '\p{Blk=:\AInscriptional_Parthian\z:}', "");;
    Expect(0, 68448, '\p{Blk=:\AInscriptional_Parthian\z:}', "");;
    Expect(1, 68447, '\p{Blk=inscriptionalparthian}', "");
    Expect(0, 68447, '\p{^Blk=inscriptionalparthian}', "");
    Expect(0, 68447, '\P{Blk=inscriptionalparthian}', "");
    Expect(1, 68447, '\P{^Blk=inscriptionalparthian}', "");
    Expect(0, 68448, '\p{Blk=inscriptionalparthian}', "");
    Expect(1, 68448, '\p{^Blk=inscriptionalparthian}', "");
    Expect(1, 68448, '\P{Blk=inscriptionalparthian}', "");
    Expect(0, 68448, '\P{^Blk=inscriptionalparthian}', "");
    Expect(1, 68447, '\p{Blk=:\Ainscriptionalparthian\z:}', "");;
    Expect(0, 68448, '\p{Blk=:\Ainscriptionalparthian\z:}', "");;
    Expect(1, 68447, '\p{Blk= Inscriptional_parthian}', "");
    Expect(0, 68447, '\p{^Blk= Inscriptional_parthian}', "");
    Expect(0, 68447, '\P{Blk= Inscriptional_parthian}', "");
    Expect(1, 68447, '\P{^Blk= Inscriptional_parthian}', "");
    Expect(0, 68448, '\p{Blk= Inscriptional_parthian}', "");
    Expect(1, 68448, '\p{^Blk= Inscriptional_parthian}', "");
    Expect(1, 68448, '\P{Blk= Inscriptional_parthian}', "");
    Expect(0, 68448, '\P{^Blk= Inscriptional_parthian}', "");
    Error('\p{Is_Block=:= 	inscriptional_PARTHIAN}');
    Error('\P{Is_Block=:= 	inscriptional_PARTHIAN}');
    Expect(1, 68447, '\p{Is_Block=inscriptionalparthian}', "");
    Expect(0, 68447, '\p{^Is_Block=inscriptionalparthian}', "");
    Expect(0, 68447, '\P{Is_Block=inscriptionalparthian}', "");
    Expect(1, 68447, '\P{^Is_Block=inscriptionalparthian}', "");
    Expect(0, 68448, '\p{Is_Block=inscriptionalparthian}', "");
    Expect(1, 68448, '\p{^Is_Block=inscriptionalparthian}', "");
    Expect(1, 68448, '\P{Is_Block=inscriptionalparthian}', "");
    Expect(0, 68448, '\P{^Is_Block=inscriptionalparthian}', "");
    Expect(1, 68447, '\p{Is_Block=_Inscriptional_Parthian}', "");
    Expect(0, 68447, '\p{^Is_Block=_Inscriptional_Parthian}', "");
    Expect(0, 68447, '\P{Is_Block=_Inscriptional_Parthian}', "");
    Expect(1, 68447, '\P{^Is_Block=_Inscriptional_Parthian}', "");
    Expect(0, 68448, '\p{Is_Block=_Inscriptional_Parthian}', "");
    Expect(1, 68448, '\p{^Is_Block=_Inscriptional_Parthian}', "");
    Expect(1, 68448, '\P{Is_Block=_Inscriptional_Parthian}', "");
    Expect(0, 68448, '\P{^Is_Block=_Inscriptional_Parthian}', "");
    Error('\p{Is_Blk=/a/ -INSCRIPTIONAL_Parthian}');
    Error('\P{Is_Blk=/a/ -INSCRIPTIONAL_Parthian}');
    Expect(1, 68447, '\p{Is_Blk=inscriptionalparthian}', "");
    Expect(0, 68447, '\p{^Is_Blk=inscriptionalparthian}', "");
    Expect(0, 68447, '\P{Is_Blk=inscriptionalparthian}', "");
    Expect(1, 68447, '\P{^Is_Blk=inscriptionalparthian}', "");
    Expect(0, 68448, '\p{Is_Blk=inscriptionalparthian}', "");
    Expect(1, 68448, '\p{^Is_Blk=inscriptionalparthian}', "");
    Expect(1, 68448, '\P{Is_Blk=inscriptionalparthian}', "");
    Expect(0, 68448, '\P{^Is_Blk=inscriptionalparthian}', "");
    Expect(1, 68447, '\p{Is_Blk=	Inscriptional_Parthian}', "");
    Expect(0, 68447, '\p{^Is_Blk=	Inscriptional_Parthian}', "");
    Expect(0, 68447, '\P{Is_Blk=	Inscriptional_Parthian}', "");
    Expect(1, 68447, '\P{^Is_Blk=	Inscriptional_Parthian}', "");
    Expect(0, 68448, '\p{Is_Blk=	Inscriptional_Parthian}', "");
    Expect(1, 68448, '\p{^Is_Blk=	Inscriptional_Parthian}', "");
    Expect(1, 68448, '\P{Is_Blk=	Inscriptional_Parthian}', "");
    Expect(0, 68448, '\P{^Is_Blk=	Inscriptional_Parthian}', "");
    Error('\p{Block=-/a/IPA_EXTENSIONS}');
    Error('\P{Block=-/a/IPA_EXTENSIONS}');
    Expect(1, 687, '\p{Block=:\AIPA_Extensions\z:}', "");;
    Expect(0, 688, '\p{Block=:\AIPA_Extensions\z:}', "");;
    Expect(1, 687, '\p{Block: ipaextensions}', "");
    Expect(0, 687, '\p{^Block: ipaextensions}', "");
    Expect(0, 687, '\P{Block: ipaextensions}', "");
    Expect(1, 687, '\P{^Block: ipaextensions}', "");
    Expect(0, 688, '\p{Block: ipaextensions}', "");
    Expect(1, 688, '\p{^Block: ipaextensions}', "");
    Expect(1, 688, '\P{Block: ipaextensions}', "");
    Expect(0, 688, '\P{^Block: ipaextensions}', "");
    Expect(1, 687, '\p{Block=:\Aipaextensions\z:}', "");;
    Expect(0, 688, '\p{Block=:\Aipaextensions\z:}', "");;
    Expect(1, 687, '\p{Block=-IPA_EXTENSIONS}', "");
    Expect(0, 687, '\p{^Block=-IPA_EXTENSIONS}', "");
    Expect(0, 687, '\P{Block=-IPA_EXTENSIONS}', "");
    Expect(1, 687, '\P{^Block=-IPA_EXTENSIONS}', "");
    Expect(0, 688, '\p{Block=-IPA_EXTENSIONS}', "");
    Expect(1, 688, '\p{^Block=-IPA_EXTENSIONS}', "");
    Expect(1, 688, '\P{Block=-IPA_EXTENSIONS}', "");
    Expect(0, 688, '\P{^Block=-IPA_EXTENSIONS}', "");
    Error('\p{Blk=/a/		IPA_Ext}');
    Error('\P{Blk=/a/		IPA_Ext}');
    Expect(1, 687, '\p{Blk=:\AIPA_Ext\z:}', "");;
    Expect(0, 688, '\p{Blk=:\AIPA_Ext\z:}', "");;
    Expect(1, 687, '\p{Blk:	ipaext}', "");
    Expect(0, 687, '\p{^Blk:	ipaext}', "");
    Expect(0, 687, '\P{Blk:	ipaext}', "");
    Expect(1, 687, '\P{^Blk:	ipaext}', "");
    Expect(0, 688, '\p{Blk:	ipaext}', "");
    Expect(1, 688, '\p{^Blk:	ipaext}', "");
    Expect(1, 688, '\P{Blk:	ipaext}', "");
    Expect(0, 688, '\P{^Blk:	ipaext}', "");
    Expect(1, 687, '\p{Blk=:\Aipaext\z:}', "");;
    Expect(0, 688, '\p{Blk=:\Aipaext\z:}', "");;
    Expect(1, 687, '\p{Blk=ipa_ext}', "");
    Expect(0, 687, '\p{^Blk=ipa_ext}', "");
    Expect(0, 687, '\P{Blk=ipa_ext}', "");
    Expect(1, 687, '\P{^Blk=ipa_ext}', "");
    Expect(0, 688, '\p{Blk=ipa_ext}', "");
    Expect(1, 688, '\p{^Blk=ipa_ext}', "");
    Expect(1, 688, '\P{Blk=ipa_ext}', "");
    Expect(0, 688, '\P{^Blk=ipa_ext}', "");
    Error('\p{Is_Block=-/a/ipa_Extensions}');
    Error('\P{Is_Block=-/a/ipa_Extensions}');
    Expect(1, 687, '\p{Is_Block=ipaextensions}', "");
    Expect(0, 687, '\p{^Is_Block=ipaextensions}', "");
    Expect(0, 687, '\P{Is_Block=ipaextensions}', "");
    Expect(1, 687, '\P{^Is_Block=ipaextensions}', "");
    Expect(0, 688, '\p{Is_Block=ipaextensions}', "");
    Expect(1, 688, '\p{^Is_Block=ipaextensions}', "");
    Expect(1, 688, '\P{Is_Block=ipaextensions}', "");
    Expect(0, 688, '\P{^Is_Block=ipaextensions}', "");
    Expect(1, 687, '\p{Is_Block= _IPA_Extensions}', "");
    Expect(0, 687, '\p{^Is_Block= _IPA_Extensions}', "");
    Expect(0, 687, '\P{Is_Block= _IPA_Extensions}', "");
    Expect(1, 687, '\P{^Is_Block= _IPA_Extensions}', "");
    Expect(0, 688, '\p{Is_Block= _IPA_Extensions}', "");
    Expect(1, 688, '\p{^Is_Block= _IPA_Extensions}', "");
    Expect(1, 688, '\P{Is_Block= _IPA_Extensions}', "");
    Expect(0, 688, '\P{^Is_Block= _IPA_Extensions}', "");
    Error('\p{Is_Blk=/a/IPA_Ext}');
    Error('\P{Is_Blk=/a/IPA_Ext}');
    Expect(1, 687, '\p{Is_Blk=ipaext}', "");
    Expect(0, 687, '\p{^Is_Blk=ipaext}', "");
    Expect(0, 687, '\P{Is_Blk=ipaext}', "");
    Expect(1, 687, '\P{^Is_Blk=ipaext}', "");
    Expect(0, 688, '\p{Is_Blk=ipaext}', "");
    Expect(1, 688, '\p{^Is_Blk=ipaext}', "");
    Expect(1, 688, '\P{Is_Blk=ipaext}', "");
    Expect(0, 688, '\P{^Is_Blk=ipaext}', "");
    Expect(1, 687, '\p{Is_Blk=	IPA_EXT}', "");
    Expect(0, 687, '\p{^Is_Blk=	IPA_EXT}', "");
    Expect(0, 687, '\P{Is_Blk=	IPA_EXT}', "");
    Expect(1, 687, '\P{^Is_Blk=	IPA_EXT}', "");
    Expect(0, 688, '\p{Is_Blk=	IPA_EXT}', "");
    Expect(1, 688, '\p{^Is_Blk=	IPA_EXT}', "");
    Expect(1, 688, '\P{Is_Blk=	IPA_EXT}', "");
    Expect(0, 688, '\P{^Is_Blk=	IPA_EXT}', "");
    Error('\p{Block=:=-	Hangul_Jamo}');
    Error('\P{Block=:=-	Hangul_Jamo}');
    Expect(1, 4607, '\p{Block=:\AHangul_Jamo\z:}', "");;
    Expect(0, 4608, '\p{Block=:\AHangul_Jamo\z:}', "");;
    Expect(1, 4607, '\p{Block=hanguljamo}', "");
    Expect(0, 4607, '\p{^Block=hanguljamo}', "");
    Expect(0, 4607, '\P{Block=hanguljamo}', "");
    Expect(1, 4607, '\P{^Block=hanguljamo}', "");
    Expect(0, 4608, '\p{Block=hanguljamo}', "");
    Expect(1, 4608, '\p{^Block=hanguljamo}', "");
    Expect(1, 4608, '\P{Block=hanguljamo}', "");
    Expect(0, 4608, '\P{^Block=hanguljamo}', "");
    Expect(1, 4607, '\p{Block=:\Ahanguljamo\z:}', "");;
    Expect(0, 4608, '\p{Block=:\Ahanguljamo\z:}', "");;
    Expect(1, 4607, '\p{Block=-_Hangul_jamo}', "");
    Expect(0, 4607, '\p{^Block=-_Hangul_jamo}', "");
    Expect(0, 4607, '\P{Block=-_Hangul_jamo}', "");
    Expect(1, 4607, '\P{^Block=-_Hangul_jamo}', "");
    Expect(0, 4608, '\p{Block=-_Hangul_jamo}', "");
    Expect(1, 4608, '\p{^Block=-_Hangul_jamo}', "");
    Expect(1, 4608, '\P{Block=-_Hangul_jamo}', "");
    Expect(0, 4608, '\P{^Block=-_Hangul_jamo}', "");
    Error('\p{Blk=:=	jamo}');
    Error('\P{Blk=:=	jamo}');
    Expect(1, 4607, '\p{Blk=:\AJamo\z:}', "");;
    Expect(0, 4608, '\p{Blk=:\AJamo\z:}', "");;
    Expect(1, 4607, '\p{Blk=jamo}', "");
    Expect(0, 4607, '\p{^Blk=jamo}', "");
    Expect(0, 4607, '\P{Blk=jamo}', "");
    Expect(1, 4607, '\P{^Blk=jamo}', "");
    Expect(0, 4608, '\p{Blk=jamo}', "");
    Expect(1, 4608, '\p{^Blk=jamo}', "");
    Expect(1, 4608, '\P{Blk=jamo}', "");
    Expect(0, 4608, '\P{^Blk=jamo}', "");
    Expect(1, 4607, '\p{Blk=:\Ajamo\z:}', "");;
    Expect(0, 4608, '\p{Blk=:\Ajamo\z:}', "");;
    Expect(1, 4607, '\p{Blk=--JAMO}', "");
    Expect(0, 4607, '\p{^Blk=--JAMO}', "");
    Expect(0, 4607, '\P{Blk=--JAMO}', "");
    Expect(1, 4607, '\P{^Blk=--JAMO}', "");
    Expect(0, 4608, '\p{Blk=--JAMO}', "");
    Expect(1, 4608, '\p{^Blk=--JAMO}', "");
    Expect(1, 4608, '\P{Blk=--JAMO}', "");
    Expect(0, 4608, '\P{^Blk=--JAMO}', "");
    Error('\p{Is_Block=-:=HANGUL_Jamo}');
    Error('\P{Is_Block=-:=HANGUL_Jamo}');
    Expect(1, 4607, '\p{Is_Block=hanguljamo}', "");
    Expect(0, 4607, '\p{^Is_Block=hanguljamo}', "");
    Expect(0, 4607, '\P{Is_Block=hanguljamo}', "");
    Expect(1, 4607, '\P{^Is_Block=hanguljamo}', "");
    Expect(0, 4608, '\p{Is_Block=hanguljamo}', "");
    Expect(1, 4608, '\p{^Is_Block=hanguljamo}', "");
    Expect(1, 4608, '\P{Is_Block=hanguljamo}', "");
    Expect(0, 4608, '\P{^Is_Block=hanguljamo}', "");
    Expect(1, 4607, '\p{Is_Block=	 Hangul_JAMO}', "");
    Expect(0, 4607, '\p{^Is_Block=	 Hangul_JAMO}', "");
    Expect(0, 4607, '\P{Is_Block=	 Hangul_JAMO}', "");
    Expect(1, 4607, '\P{^Is_Block=	 Hangul_JAMO}', "");
    Expect(0, 4608, '\p{Is_Block=	 Hangul_JAMO}', "");
    Expect(1, 4608, '\p{^Is_Block=	 Hangul_JAMO}', "");
    Expect(1, 4608, '\P{Is_Block=	 Hangul_JAMO}', "");
    Expect(0, 4608, '\P{^Is_Block=	 Hangul_JAMO}', "");
    Error('\p{Is_Blk=_/a/jamo}');
    Error('\P{Is_Blk=_/a/jamo}');
    Expect(1, 4607, '\p{Is_Blk:   jamo}', "");
    Expect(0, 4607, '\p{^Is_Blk:   jamo}', "");
    Expect(0, 4607, '\P{Is_Blk:   jamo}', "");
    Expect(1, 4607, '\P{^Is_Blk:   jamo}', "");
    Expect(0, 4608, '\p{Is_Blk:   jamo}', "");
    Expect(1, 4608, '\p{^Is_Blk:   jamo}', "");
    Expect(1, 4608, '\P{Is_Blk:   jamo}', "");
    Expect(0, 4608, '\P{^Is_Blk:   jamo}', "");
    Expect(1, 4607, '\p{Is_Blk=-JAMO}', "");
    Expect(0, 4607, '\p{^Is_Blk=-JAMO}', "");
    Expect(0, 4607, '\P{Is_Blk=-JAMO}', "");
    Expect(1, 4607, '\P{^Is_Blk=-JAMO}', "");
    Expect(0, 4608, '\p{Is_Blk=-JAMO}', "");
    Expect(1, 4608, '\p{^Is_Blk=-JAMO}', "");
    Expect(1, 4608, '\P{Is_Blk=-JAMO}', "");
    Expect(0, 4608, '\P{^Is_Blk=-JAMO}', "");
    Error('\p{Block=:=Hangul_JAMO_extended_A}');
    Error('\P{Block=:=Hangul_JAMO_extended_A}');
    Expect(1, 43391, '\p{Block=:\AHangul_Jamo_Extended_A\z:}', "");;
    Expect(0, 43392, '\p{Block=:\AHangul_Jamo_Extended_A\z:}', "");;
    Expect(1, 43391, '\p{Block:	hanguljamoextendeda}', "");
    Expect(0, 43391, '\p{^Block:	hanguljamoextendeda}', "");
    Expect(0, 43391, '\P{Block:	hanguljamoextendeda}', "");
    Expect(1, 43391, '\P{^Block:	hanguljamoextendeda}', "");
    Expect(0, 43392, '\p{Block:	hanguljamoextendeda}', "");
    Expect(1, 43392, '\p{^Block:	hanguljamoextendeda}', "");
    Expect(1, 43392, '\P{Block:	hanguljamoextendeda}', "");
    Expect(0, 43392, '\P{^Block:	hanguljamoextendeda}', "");
    Expect(1, 43391, '\p{Block=:\Ahanguljamoextendeda\z:}', "");;
    Expect(0, 43392, '\p{Block=:\Ahanguljamoextendeda\z:}', "");;
    Expect(1, 43391, '\p{Block= _Hangul_Jamo_Extended_A}', "");
    Expect(0, 43391, '\p{^Block= _Hangul_Jamo_Extended_A}', "");
    Expect(0, 43391, '\P{Block= _Hangul_Jamo_Extended_A}', "");
    Expect(1, 43391, '\P{^Block= _Hangul_Jamo_Extended_A}', "");
    Expect(0, 43392, '\p{Block= _Hangul_Jamo_Extended_A}', "");
    Expect(1, 43392, '\p{^Block= _Hangul_Jamo_Extended_A}', "");
    Expect(1, 43392, '\P{Block= _Hangul_Jamo_Extended_A}', "");
    Expect(0, 43392, '\P{^Block= _Hangul_Jamo_Extended_A}', "");
    Error('\p{Blk= /a/Jamo_Ext_a}');
    Error('\P{Blk= /a/Jamo_Ext_a}');
    Expect(1, 43391, '\p{Blk=:\AJamo_Ext_A\z:}', "");;
    Expect(0, 43392, '\p{Blk=:\AJamo_Ext_A\z:}', "");;
    Expect(1, 43391, '\p{Blk=jamoexta}', "");
    Expect(0, 43391, '\p{^Blk=jamoexta}', "");
    Expect(0, 43391, '\P{Blk=jamoexta}', "");
    Expect(1, 43391, '\P{^Blk=jamoexta}', "");
    Expect(0, 43392, '\p{Blk=jamoexta}', "");
    Expect(1, 43392, '\p{^Blk=jamoexta}', "");
    Expect(1, 43392, '\P{Blk=jamoexta}', "");
    Expect(0, 43392, '\P{^Blk=jamoexta}', "");
    Expect(1, 43391, '\p{Blk=:\Ajamoexta\z:}', "");;
    Expect(0, 43392, '\p{Blk=:\Ajamoexta\z:}', "");;
    Expect(1, 43391, '\p{Blk=	_JAMO_EXT_A}', "");
    Expect(0, 43391, '\p{^Blk=	_JAMO_EXT_A}', "");
    Expect(0, 43391, '\P{Blk=	_JAMO_EXT_A}', "");
    Expect(1, 43391, '\P{^Blk=	_JAMO_EXT_A}', "");
    Expect(0, 43392, '\p{Blk=	_JAMO_EXT_A}', "");
    Expect(1, 43392, '\p{^Blk=	_JAMO_EXT_A}', "");
    Expect(1, 43392, '\P{Blk=	_JAMO_EXT_A}', "");
    Expect(0, 43392, '\P{^Blk=	_JAMO_EXT_A}', "");
    Error('\p{Is_Block=  Hangul_jamo_Extended_A/a/}');
    Error('\P{Is_Block=  Hangul_jamo_Extended_A/a/}');
    Expect(1, 43391, '\p{Is_Block=hanguljamoextendeda}', "");
    Expect(0, 43391, '\p{^Is_Block=hanguljamoextendeda}', "");
    Expect(0, 43391, '\P{Is_Block=hanguljamoextendeda}', "");
    Expect(1, 43391, '\P{^Is_Block=hanguljamoextendeda}', "");
    Expect(0, 43392, '\p{Is_Block=hanguljamoextendeda}', "");
    Expect(1, 43392, '\p{^Is_Block=hanguljamoextendeda}', "");
    Expect(1, 43392, '\P{Is_Block=hanguljamoextendeda}', "");
    Expect(0, 43392, '\P{^Is_Block=hanguljamoextendeda}', "");
    Expect(1, 43391, '\p{Is_Block= -HANGUL_JAMO_Extended_a}', "");
    Expect(0, 43391, '\p{^Is_Block= -HANGUL_JAMO_Extended_a}', "");
    Expect(0, 43391, '\P{Is_Block= -HANGUL_JAMO_Extended_a}', "");
    Expect(1, 43391, '\P{^Is_Block= -HANGUL_JAMO_Extended_a}', "");
    Expect(0, 43392, '\p{Is_Block= -HANGUL_JAMO_Extended_a}', "");
    Expect(1, 43392, '\p{^Is_Block= -HANGUL_JAMO_Extended_a}', "");
    Expect(1, 43392, '\P{Is_Block= -HANGUL_JAMO_Extended_a}', "");
    Expect(0, 43392, '\P{^Is_Block= -HANGUL_JAMO_Extended_a}', "");
    Error('\p{Is_Blk=-_Jamo_ext_A:=}');
    Error('\P{Is_Blk=-_Jamo_ext_A:=}');
    Expect(1, 43391, '\p{Is_Blk:	jamoexta}', "");
    Expect(0, 43391, '\p{^Is_Blk:	jamoexta}', "");
    Expect(0, 43391, '\P{Is_Blk:	jamoexta}', "");
    Expect(1, 43391, '\P{^Is_Blk:	jamoexta}', "");
    Expect(0, 43392, '\p{Is_Blk:	jamoexta}', "");
    Expect(1, 43392, '\p{^Is_Blk:	jamoexta}', "");
    Expect(1, 43392, '\P{Is_Blk:	jamoexta}', "");
    Expect(0, 43392, '\P{^Is_Blk:	jamoexta}', "");
    Expect(1, 43391, '\p{Is_Blk= -Jamo_Ext_a}', "");
    Expect(0, 43391, '\p{^Is_Blk= -Jamo_Ext_a}', "");
    Expect(0, 43391, '\P{Is_Blk= -Jamo_Ext_a}', "");
    Expect(1, 43391, '\P{^Is_Blk= -Jamo_Ext_a}', "");
    Expect(0, 43392, '\p{Is_Blk= -Jamo_Ext_a}', "");
    Expect(1, 43392, '\p{^Is_Blk= -Jamo_Ext_a}', "");
    Expect(1, 43392, '\P{Is_Blk= -Jamo_Ext_a}', "");
    Expect(0, 43392, '\P{^Is_Blk= -Jamo_Ext_a}', "");
    Error('\p{Block=_-Hangul_jamo_extended_b:=}');
    Error('\P{Block=_-Hangul_jamo_extended_b:=}');
    Expect(1, 55295, '\p{Block=:\AHangul_Jamo_Extended_B\z:}', "");;
    Expect(0, 57344, '\p{Block=:\AHangul_Jamo_Extended_B\z:}', "");;
    Expect(1, 55295, '\p{Block=hanguljamoextendedb}', "");
    Expect(0, 55295, '\p{^Block=hanguljamoextendedb}', "");
    Expect(0, 55295, '\P{Block=hanguljamoextendedb}', "");
    Expect(1, 55295, '\P{^Block=hanguljamoextendedb}', "");
    Expect(0, 57344, '\p{Block=hanguljamoextendedb}', "");
    Expect(1, 57344, '\p{^Block=hanguljamoextendedb}', "");
    Expect(1, 57344, '\P{Block=hanguljamoextendedb}', "");
    Expect(0, 57344, '\P{^Block=hanguljamoextendedb}', "");
    Expect(1, 55295, '\p{Block=:\Ahanguljamoextendedb\z:}', "");;
    Expect(0, 57344, '\p{Block=:\Ahanguljamoextendedb\z:}', "");;
    Expect(1, 55295, '\p{Block=	-HANGUL_Jamo_Extended_B}', "");
    Expect(0, 55295, '\p{^Block=	-HANGUL_Jamo_Extended_B}', "");
    Expect(0, 55295, '\P{Block=	-HANGUL_Jamo_Extended_B}', "");
    Expect(1, 55295, '\P{^Block=	-HANGUL_Jamo_Extended_B}', "");
    Expect(0, 57344, '\p{Block=	-HANGUL_Jamo_Extended_B}', "");
    Expect(1, 57344, '\p{^Block=	-HANGUL_Jamo_Extended_B}', "");
    Expect(1, 57344, '\P{Block=	-HANGUL_Jamo_Extended_B}', "");
    Expect(0, 57344, '\P{^Block=	-HANGUL_Jamo_Extended_B}', "");
    Error('\p{Blk= _Jamo_EXT_B/a/}');
    Error('\P{Blk= _Jamo_EXT_B/a/}');
    Expect(1, 55295, '\p{Blk=:\AJamo_Ext_B\z:}', "");;
    Expect(0, 57344, '\p{Blk=:\AJamo_Ext_B\z:}', "");;
    Expect(1, 55295, '\p{Blk=jamoextb}', "");
    Expect(0, 55295, '\p{^Blk=jamoextb}', "");
    Expect(0, 55295, '\P{Blk=jamoextb}', "");
    Expect(1, 55295, '\P{^Blk=jamoextb}', "");
    Expect(0, 57344, '\p{Blk=jamoextb}', "");
    Expect(1, 57344, '\p{^Blk=jamoextb}', "");
    Expect(1, 57344, '\P{Blk=jamoextb}', "");
    Expect(0, 57344, '\P{^Blk=jamoextb}', "");
    Expect(1, 55295, '\p{Blk=:\Ajamoextb\z:}', "");;
    Expect(0, 57344, '\p{Blk=:\Ajamoextb\z:}', "");;
    Expect(1, 55295, '\p{Blk=-_Jamo_EXT_B}', "");
    Expect(0, 55295, '\p{^Blk=-_Jamo_EXT_B}', "");
    Expect(0, 55295, '\P{Blk=-_Jamo_EXT_B}', "");
    Expect(1, 55295, '\P{^Blk=-_Jamo_EXT_B}', "");
    Expect(0, 57344, '\p{Blk=-_Jamo_EXT_B}', "");
    Expect(1, 57344, '\p{^Blk=-_Jamo_EXT_B}', "");
    Expect(1, 57344, '\P{Blk=-_Jamo_EXT_B}', "");
    Expect(0, 57344, '\P{^Blk=-_Jamo_EXT_B}', "");
    Error('\p{Is_Block=_-HANGUL_JAMO_extended_B/a/}');
    Error('\P{Is_Block=_-HANGUL_JAMO_extended_B/a/}');
    Expect(1, 55295, '\p{Is_Block: hanguljamoextendedb}', "");
    Expect(0, 55295, '\p{^Is_Block: hanguljamoextendedb}', "");
    Expect(0, 55295, '\P{Is_Block: hanguljamoextendedb}', "");
    Expect(1, 55295, '\P{^Is_Block: hanguljamoextendedb}', "");
    Expect(0, 57344, '\p{Is_Block: hanguljamoextendedb}', "");
    Expect(1, 57344, '\p{^Is_Block: hanguljamoextendedb}', "");
    Expect(1, 57344, '\P{Is_Block: hanguljamoextendedb}', "");
    Expect(0, 57344, '\P{^Is_Block: hanguljamoextendedb}', "");
    Expect(1, 55295, '\p{Is_Block=hangul_Jamo_Extended_B}', "");
    Expect(0, 55295, '\p{^Is_Block=hangul_Jamo_Extended_B}', "");
    Expect(0, 55295, '\P{Is_Block=hangul_Jamo_Extended_B}', "");
    Expect(1, 55295, '\P{^Is_Block=hangul_Jamo_Extended_B}', "");
    Expect(0, 57344, '\p{Is_Block=hangul_Jamo_Extended_B}', "");
    Expect(1, 57344, '\p{^Is_Block=hangul_Jamo_Extended_B}', "");
    Expect(1, 57344, '\P{Is_Block=hangul_Jamo_Extended_B}', "");
    Expect(0, 57344, '\P{^Is_Block=hangul_Jamo_Extended_B}', "");
    Error('\p{Is_Blk=_Jamo_Ext_B/a/}');
    Error('\P{Is_Blk=_Jamo_Ext_B/a/}');
    Expect(1, 55295, '\p{Is_Blk=jamoextb}', "");
    Expect(0, 55295, '\p{^Is_Blk=jamoextb}', "");
    Expect(0, 55295, '\P{Is_Blk=jamoextb}', "");
    Expect(1, 55295, '\P{^Is_Blk=jamoextb}', "");
    Expect(0, 57344, '\p{Is_Blk=jamoextb}', "");
    Expect(1, 57344, '\p{^Is_Blk=jamoextb}', "");
    Expect(1, 57344, '\P{Is_Blk=jamoextb}', "");
    Expect(0, 57344, '\P{^Is_Blk=jamoextb}', "");
    Expect(1, 55295, '\p{Is_Blk= JAMO_Ext_b}', "");
    Expect(0, 55295, '\p{^Is_Blk= JAMO_Ext_b}', "");
    Expect(0, 55295, '\P{Is_Blk= JAMO_Ext_b}', "");
    Expect(1, 55295, '\P{^Is_Blk= JAMO_Ext_b}', "");
    Expect(0, 57344, '\p{Is_Blk= JAMO_Ext_b}', "");
    Expect(1, 57344, '\p{^Is_Blk= JAMO_Ext_b}', "");
    Expect(1, 57344, '\P{Is_Blk= JAMO_Ext_b}', "");
    Expect(0, 57344, '\P{^Is_Blk= JAMO_Ext_b}', "");
    Error('\p{Block=/a/-Javanese}');
    Error('\P{Block=/a/-Javanese}');
    Expect(1, 43487, '\p{Block=:\AJavanese\z:}', "");;
    Expect(0, 43488, '\p{Block=:\AJavanese\z:}', "");;
    Expect(1, 43487, '\p{Block=javanese}', "");
    Expect(0, 43487, '\p{^Block=javanese}', "");
    Expect(0, 43487, '\P{Block=javanese}', "");
    Expect(1, 43487, '\P{^Block=javanese}', "");
    Expect(0, 43488, '\p{Block=javanese}', "");
    Expect(1, 43488, '\p{^Block=javanese}', "");
    Expect(1, 43488, '\P{Block=javanese}', "");
    Expect(0, 43488, '\P{^Block=javanese}', "");
    Expect(1, 43487, '\p{Block=:\Ajavanese\z:}', "");;
    Expect(0, 43488, '\p{Block=:\Ajavanese\z:}', "");;
    Expect(1, 43487, '\p{Block:		_Javanese}', "");
    Expect(0, 43487, '\p{^Block:		_Javanese}', "");
    Expect(0, 43487, '\P{Block:		_Javanese}', "");
    Expect(1, 43487, '\P{^Block:		_Javanese}', "");
    Expect(0, 43488, '\p{Block:		_Javanese}', "");
    Expect(1, 43488, '\p{^Block:		_Javanese}', "");
    Expect(1, 43488, '\P{Block:		_Javanese}', "");
    Expect(0, 43488, '\P{^Block:		_Javanese}', "");
    Error('\p{Blk=_/a/Javanese}');
    Error('\P{Blk=_/a/Javanese}');
    Expect(1, 43487, '\p{Blk=:\AJavanese\z:}', "");;
    Expect(0, 43488, '\p{Blk=:\AJavanese\z:}', "");;
    Expect(1, 43487, '\p{Blk=javanese}', "");
    Expect(0, 43487, '\p{^Blk=javanese}', "");
    Expect(0, 43487, '\P{Blk=javanese}', "");
    Expect(1, 43487, '\P{^Blk=javanese}', "");
    Expect(0, 43488, '\p{Blk=javanese}', "");
    Expect(1, 43488, '\p{^Blk=javanese}', "");
    Expect(1, 43488, '\P{Blk=javanese}', "");
    Expect(0, 43488, '\P{^Blk=javanese}', "");
    Expect(1, 43487, '\p{Blk=:\Ajavanese\z:}', "");;
    Expect(0, 43488, '\p{Blk=:\Ajavanese\z:}', "");;
    Expect(1, 43487, '\p{Blk=	Javanese}', "");
    Expect(0, 43487, '\p{^Blk=	Javanese}', "");
    Expect(0, 43487, '\P{Blk=	Javanese}', "");
    Expect(1, 43487, '\P{^Blk=	Javanese}', "");
    Expect(0, 43488, '\p{Blk=	Javanese}', "");
    Expect(1, 43488, '\p{^Blk=	Javanese}', "");
    Expect(1, 43488, '\P{Blk=	Javanese}', "");
    Expect(0, 43488, '\P{^Blk=	Javanese}', "");
    Error('\p{Is_Block=_	Javanese/a/}');
    Error('\P{Is_Block=_	Javanese/a/}');
    Expect(1, 43487, '\p{Is_Block=javanese}', "");
    Expect(0, 43487, '\p{^Is_Block=javanese}', "");
    Expect(0, 43487, '\P{Is_Block=javanese}', "");
    Expect(1, 43487, '\P{^Is_Block=javanese}', "");
    Expect(0, 43488, '\p{Is_Block=javanese}', "");
    Expect(1, 43488, '\p{^Is_Block=javanese}', "");
    Expect(1, 43488, '\P{Is_Block=javanese}', "");
    Expect(0, 43488, '\P{^Is_Block=javanese}', "");
    Expect(1, 43487, '\p{Is_Block: _JAVANESE}', "");
    Expect(0, 43487, '\p{^Is_Block: _JAVANESE}', "");
    Expect(0, 43487, '\P{Is_Block: _JAVANESE}', "");
    Expect(1, 43487, '\P{^Is_Block: _JAVANESE}', "");
    Expect(0, 43488, '\p{Is_Block: _JAVANESE}', "");
    Expect(1, 43488, '\p{^Is_Block: _JAVANESE}', "");
    Expect(1, 43488, '\P{Is_Block: _JAVANESE}', "");
    Expect(0, 43488, '\P{^Is_Block: _JAVANESE}', "");
    Error('\p{Is_Blk= 	Javanese/a/}');
    Error('\P{Is_Blk= 	Javanese/a/}');
    Expect(1, 43487, '\p{Is_Blk=javanese}', "");
    Expect(0, 43487, '\p{^Is_Blk=javanese}', "");
    Expect(0, 43487, '\P{Is_Blk=javanese}', "");
    Expect(1, 43487, '\P{^Is_Blk=javanese}', "");
    Expect(0, 43488, '\p{Is_Blk=javanese}', "");
    Expect(1, 43488, '\p{^Is_Blk=javanese}', "");
    Expect(1, 43488, '\P{Is_Blk=javanese}', "");
    Expect(0, 43488, '\P{^Is_Blk=javanese}', "");
    Expect(1, 43487, '\p{Is_Blk=  JAVANESE}', "");
    Expect(0, 43487, '\p{^Is_Blk=  JAVANESE}', "");
    Expect(0, 43487, '\P{Is_Blk=  JAVANESE}', "");
    Expect(1, 43487, '\P{^Is_Blk=  JAVANESE}', "");
    Expect(0, 43488, '\p{Is_Blk=  JAVANESE}', "");
    Expect(1, 43488, '\p{^Is_Blk=  JAVANESE}', "");
    Expect(1, 43488, '\P{Is_Blk=  JAVANESE}', "");
    Expect(0, 43488, '\P{^Is_Blk=  JAVANESE}', "");
    Error('\p{Block=/a/_Kaithi}');
    Error('\P{Block=/a/_Kaithi}');
    Expect(1, 69839, '\p{Block=:\AKaithi\z:}', "");;
    Expect(0, 69840, '\p{Block=:\AKaithi\z:}', "");;
    Expect(1, 69839, '\p{Block=kaithi}', "");
    Expect(0, 69839, '\p{^Block=kaithi}', "");
    Expect(0, 69839, '\P{Block=kaithi}', "");
    Expect(1, 69839, '\P{^Block=kaithi}', "");
    Expect(0, 69840, '\p{Block=kaithi}', "");
    Expect(1, 69840, '\p{^Block=kaithi}', "");
    Expect(1, 69840, '\P{Block=kaithi}', "");
    Expect(0, 69840, '\P{^Block=kaithi}', "");
    Expect(1, 69839, '\p{Block=:\Akaithi\z:}', "");;
    Expect(0, 69840, '\p{Block=:\Akaithi\z:}', "");;
    Expect(1, 69839, '\p{Block=_ Kaithi}', "");
    Expect(0, 69839, '\p{^Block=_ Kaithi}', "");
    Expect(0, 69839, '\P{Block=_ Kaithi}', "");
    Expect(1, 69839, '\P{^Block=_ Kaithi}', "");
    Expect(0, 69840, '\p{Block=_ Kaithi}', "");
    Expect(1, 69840, '\p{^Block=_ Kaithi}', "");
    Expect(1, 69840, '\P{Block=_ Kaithi}', "");
    Expect(0, 69840, '\P{^Block=_ Kaithi}', "");
    Error('\p{Blk=:=_	kaithi}');
    Error('\P{Blk=:=_	kaithi}');
    Expect(1, 69839, '\p{Blk=:\AKaithi\z:}', "");;
    Expect(0, 69840, '\p{Blk=:\AKaithi\z:}', "");;
    Expect(1, 69839, '\p{Blk=kaithi}', "");
    Expect(0, 69839, '\p{^Blk=kaithi}', "");
    Expect(0, 69839, '\P{Blk=kaithi}', "");
    Expect(1, 69839, '\P{^Blk=kaithi}', "");
    Expect(0, 69840, '\p{Blk=kaithi}', "");
    Expect(1, 69840, '\p{^Blk=kaithi}', "");
    Expect(1, 69840, '\P{Blk=kaithi}', "");
    Expect(0, 69840, '\P{^Blk=kaithi}', "");
    Expect(1, 69839, '\p{Blk=:\Akaithi\z:}', "");;
    Expect(0, 69840, '\p{Blk=:\Akaithi\z:}', "");;
    Expect(1, 69839, '\p{Blk=-kaithi}', "");
    Expect(0, 69839, '\p{^Blk=-kaithi}', "");
    Expect(0, 69839, '\P{Blk=-kaithi}', "");
    Expect(1, 69839, '\P{^Blk=-kaithi}', "");
    Expect(0, 69840, '\p{Blk=-kaithi}', "");
    Expect(1, 69840, '\p{^Blk=-kaithi}', "");
    Expect(1, 69840, '\P{Blk=-kaithi}', "");
    Expect(0, 69840, '\P{^Blk=-kaithi}', "");
    Error('\p{Is_Block=/a/KAITHI}');
    Error('\P{Is_Block=/a/KAITHI}');
    Expect(1, 69839, '\p{Is_Block=kaithi}', "");
    Expect(0, 69839, '\p{^Is_Block=kaithi}', "");
    Expect(0, 69839, '\P{Is_Block=kaithi}', "");
    Expect(1, 69839, '\P{^Is_Block=kaithi}', "");
    Expect(0, 69840, '\p{Is_Block=kaithi}', "");
    Expect(1, 69840, '\p{^Is_Block=kaithi}', "");
    Expect(1, 69840, '\P{Is_Block=kaithi}', "");
    Expect(0, 69840, '\P{^Is_Block=kaithi}', "");
    Expect(1, 69839, '\p{Is_Block=	-Kaithi}', "");
    Expect(0, 69839, '\p{^Is_Block=	-Kaithi}', "");
    Expect(0, 69839, '\P{Is_Block=	-Kaithi}', "");
    Expect(1, 69839, '\P{^Is_Block=	-Kaithi}', "");
    Expect(0, 69840, '\p{Is_Block=	-Kaithi}', "");
    Expect(1, 69840, '\p{^Is_Block=	-Kaithi}', "");
    Expect(1, 69840, '\P{Is_Block=	-Kaithi}', "");
    Expect(0, 69840, '\P{^Is_Block=	-Kaithi}', "");
    Error('\p{Is_Blk=:=--Kaithi}');
    Error('\P{Is_Blk=:=--Kaithi}');
    Expect(1, 69839, '\p{Is_Blk=kaithi}', "");
    Expect(0, 69839, '\p{^Is_Blk=kaithi}', "");
    Expect(0, 69839, '\P{Is_Blk=kaithi}', "");
    Expect(1, 69839, '\P{^Is_Blk=kaithi}', "");
    Expect(0, 69840, '\p{Is_Blk=kaithi}', "");
    Expect(1, 69840, '\p{^Is_Blk=kaithi}', "");
    Expect(1, 69840, '\P{Is_Blk=kaithi}', "");
    Expect(0, 69840, '\P{^Is_Blk=kaithi}', "");
    Expect(1, 69839, '\p{Is_Blk=- KAITHI}', "");
    Expect(0, 69839, '\p{^Is_Blk=- KAITHI}', "");
    Expect(0, 69839, '\P{Is_Blk=- KAITHI}', "");
    Expect(1, 69839, '\P{^Is_Blk=- KAITHI}', "");
    Expect(0, 69840, '\p{Is_Blk=- KAITHI}', "");
    Expect(1, 69840, '\p{^Is_Blk=- KAITHI}', "");
    Expect(1, 69840, '\P{Is_Blk=- KAITHI}', "");
    Expect(0, 69840, '\P{^Is_Blk=- KAITHI}', "");
    Error('\p{Block=_Kaktovik_Numerals/a/}');
    Error('\P{Block=_Kaktovik_Numerals/a/}');
    Expect(1, 119519, '\p{Block=:\AKaktovik_Numerals\z:}', "");;
    Expect(0, 119520, '\p{Block=:\AKaktovik_Numerals\z:}', "");;
    Expect(1, 119519, '\p{Block=kaktoviknumerals}', "");
    Expect(0, 119519, '\p{^Block=kaktoviknumerals}', "");
    Expect(0, 119519, '\P{Block=kaktoviknumerals}', "");
    Expect(1, 119519, '\P{^Block=kaktoviknumerals}', "");
    Expect(0, 119520, '\p{Block=kaktoviknumerals}', "");
    Expect(1, 119520, '\p{^Block=kaktoviknumerals}', "");
    Expect(1, 119520, '\P{Block=kaktoviknumerals}', "");
    Expect(0, 119520, '\P{^Block=kaktoviknumerals}', "");
    Expect(1, 119519, '\p{Block=:\Akaktoviknumerals\z:}', "");;
    Expect(0, 119520, '\p{Block=:\Akaktoviknumerals\z:}', "");;
    Expect(1, 119519, '\p{Block=_-kaktovik_Numerals}', "");
    Expect(0, 119519, '\p{^Block=_-kaktovik_Numerals}', "");
    Expect(0, 119519, '\P{Block=_-kaktovik_Numerals}', "");
    Expect(1, 119519, '\P{^Block=_-kaktovik_Numerals}', "");
    Expect(0, 119520, '\p{Block=_-kaktovik_Numerals}', "");
    Expect(1, 119520, '\p{^Block=_-kaktovik_Numerals}', "");
    Expect(1, 119520, '\P{Block=_-kaktovik_Numerals}', "");
    Expect(0, 119520, '\P{^Block=_-kaktovik_Numerals}', "");
    Error('\p{Blk=/a/KAKTOVIK_NUMERALS}');
    Error('\P{Blk=/a/KAKTOVIK_NUMERALS}');
    Expect(1, 119519, '\p{Blk=:\AKaktovik_Numerals\z:}', "");;
    Expect(0, 119520, '\p{Blk=:\AKaktovik_Numerals\z:}', "");;
    Expect(1, 119519, '\p{Blk=kaktoviknumerals}', "");
    Expect(0, 119519, '\p{^Blk=kaktoviknumerals}', "");
    Expect(0, 119519, '\P{Blk=kaktoviknumerals}', "");
    Expect(1, 119519, '\P{^Blk=kaktoviknumerals}', "");
    Expect(0, 119520, '\p{Blk=kaktoviknumerals}', "");
    Expect(1, 119520, '\p{^Blk=kaktoviknumerals}', "");
    Expect(1, 119520, '\P{Blk=kaktoviknumerals}', "");
    Expect(0, 119520, '\P{^Blk=kaktoviknumerals}', "");
    Expect(1, 119519, '\p{Blk=:\Akaktoviknumerals\z:}', "");;
    Expect(0, 119520, '\p{Blk=:\Akaktoviknumerals\z:}', "");;
    Expect(1, 119519, '\p{Blk=_	kaktovik_Numerals}', "");
    Expect(0, 119519, '\p{^Blk=_	kaktovik_Numerals}', "");
    Expect(0, 119519, '\P{Blk=_	kaktovik_Numerals}', "");
    Expect(1, 119519, '\P{^Blk=_	kaktovik_Numerals}', "");
    Expect(0, 119520, '\p{Blk=_	kaktovik_Numerals}', "");
    Expect(1, 119520, '\p{^Blk=_	kaktovik_Numerals}', "");
    Expect(1, 119520, '\P{Blk=_	kaktovik_Numerals}', "");
    Expect(0, 119520, '\P{^Blk=_	kaktovik_Numerals}', "");
    Error('\p{Is_Block=  kaktovik_Numerals:=}');
    Error('\P{Is_Block=  kaktovik_Numerals:=}');
    Expect(1, 119519, '\p{Is_Block=kaktoviknumerals}', "");
    Expect(0, 119519, '\p{^Is_Block=kaktoviknumerals}', "");
    Expect(0, 119519, '\P{Is_Block=kaktoviknumerals}', "");
    Expect(1, 119519, '\P{^Is_Block=kaktoviknumerals}', "");
    Expect(0, 119520, '\p{Is_Block=kaktoviknumerals}', "");
    Expect(1, 119520, '\p{^Is_Block=kaktoviknumerals}', "");
    Expect(1, 119520, '\P{Is_Block=kaktoviknumerals}', "");
    Expect(0, 119520, '\P{^Is_Block=kaktoviknumerals}', "");
    Expect(1, 119519, '\p{Is_Block=		kaktovik_NUMERALS}', "");
    Expect(0, 119519, '\p{^Is_Block=		kaktovik_NUMERALS}', "");
    Expect(0, 119519, '\P{Is_Block=		kaktovik_NUMERALS}', "");
    Expect(1, 119519, '\P{^Is_Block=		kaktovik_NUMERALS}', "");
    Expect(0, 119520, '\p{Is_Block=		kaktovik_NUMERALS}', "");
    Expect(1, 119520, '\p{^Is_Block=		kaktovik_NUMERALS}', "");
    Expect(1, 119520, '\P{Is_Block=		kaktovik_NUMERALS}', "");
    Expect(0, 119520, '\P{^Is_Block=		kaktovik_NUMERALS}', "");
    Error('\p{Is_Blk=-Kaktovik_Numerals:=}');
    Error('\P{Is_Blk=-Kaktovik_Numerals:=}');
    Expect(1, 119519, '\p{Is_Blk=kaktoviknumerals}', "");
    Expect(0, 119519, '\p{^Is_Blk=kaktoviknumerals}', "");
    Expect(0, 119519, '\P{Is_Blk=kaktoviknumerals}', "");
    Expect(1, 119519, '\P{^Is_Blk=kaktoviknumerals}', "");
    Expect(0, 119520, '\p{Is_Blk=kaktoviknumerals}', "");
    Expect(1, 119520, '\p{^Is_Blk=kaktoviknumerals}', "");
    Expect(1, 119520, '\P{Is_Blk=kaktoviknumerals}', "");
    Expect(0, 119520, '\P{^Is_Blk=kaktoviknumerals}', "");
    Expect(1, 119519, '\p{Is_Blk=__Kaktovik_Numerals}', "");
    Expect(0, 119519, '\p{^Is_Blk=__Kaktovik_Numerals}', "");
    Expect(0, 119519, '\P{Is_Blk=__Kaktovik_Numerals}', "");
    Expect(1, 119519, '\P{^Is_Blk=__Kaktovik_Numerals}', "");
    Expect(0, 119520, '\p{Is_Blk=__Kaktovik_Numerals}', "");
    Expect(1, 119520, '\p{^Is_Blk=__Kaktovik_Numerals}', "");
    Expect(1, 119520, '\P{Is_Blk=__Kaktovik_Numerals}', "");
    Expect(0, 119520, '\P{^Is_Blk=__Kaktovik_Numerals}', "");
    Error('\p{Block= _kana_EXTENDED_A:=}');
    Error('\P{Block= _kana_EXTENDED_A:=}');
    Expect(1, 110895, '\p{Block=:\AKana_Extended_A\z:}', "");;
    Expect(0, 110896, '\p{Block=:\AKana_Extended_A\z:}', "");;
    Expect(1, 110895, '\p{Block=kanaextendeda}', "");
    Expect(0, 110895, '\p{^Block=kanaextendeda}', "");
    Expect(0, 110895, '\P{Block=kanaextendeda}', "");
    Expect(1, 110895, '\P{^Block=kanaextendeda}', "");
    Expect(0, 110896, '\p{Block=kanaextendeda}', "");
    Expect(1, 110896, '\p{^Block=kanaextendeda}', "");
    Expect(1, 110896, '\P{Block=kanaextendeda}', "");
    Expect(0, 110896, '\P{^Block=kanaextendeda}', "");
    Expect(1, 110895, '\p{Block=:\Akanaextendeda\z:}', "");;
    Expect(0, 110896, '\p{Block=:\Akanaextendeda\z:}', "");;
    Expect(1, 110895, '\p{Block= 	Kana_EXTENDED_A}', "");
    Expect(0, 110895, '\p{^Block= 	Kana_EXTENDED_A}', "");
    Expect(0, 110895, '\P{Block= 	Kana_EXTENDED_A}', "");
    Expect(1, 110895, '\P{^Block= 	Kana_EXTENDED_A}', "");
    Expect(0, 110896, '\p{Block= 	Kana_EXTENDED_A}', "");
    Expect(1, 110896, '\p{^Block= 	Kana_EXTENDED_A}', "");
    Expect(1, 110896, '\P{Block= 	Kana_EXTENDED_A}', "");
    Expect(0, 110896, '\P{^Block= 	Kana_EXTENDED_A}', "");
    Error('\p{Blk=	:=kana_Ext_A}');
    Error('\P{Blk=	:=kana_Ext_A}');
    Expect(1, 110895, '\p{Blk=:\AKana_Ext_A\z:}', "");;
    Expect(0, 110896, '\p{Blk=:\AKana_Ext_A\z:}', "");;
    Expect(1, 110895, '\p{Blk=kanaexta}', "");
    Expect(0, 110895, '\p{^Blk=kanaexta}', "");
    Expect(0, 110895, '\P{Blk=kanaexta}', "");
    Expect(1, 110895, '\P{^Blk=kanaexta}', "");
    Expect(0, 110896, '\p{Blk=kanaexta}', "");
    Expect(1, 110896, '\p{^Blk=kanaexta}', "");
    Expect(1, 110896, '\P{Blk=kanaexta}', "");
    Expect(0, 110896, '\P{^Blk=kanaexta}', "");
    Expect(1, 110895, '\p{Blk=:\Akanaexta\z:}', "");;
    Expect(0, 110896, '\p{Blk=:\Akanaexta\z:}', "");;
    Expect(1, 110895, '\p{Blk: __Kana_Ext_A}', "");
    Expect(0, 110895, '\p{^Blk: __Kana_Ext_A}', "");
    Expect(0, 110895, '\P{Blk: __Kana_Ext_A}', "");
    Expect(1, 110895, '\P{^Blk: __Kana_Ext_A}', "");
    Expect(0, 110896, '\p{Blk: __Kana_Ext_A}', "");
    Expect(1, 110896, '\p{^Blk: __Kana_Ext_A}', "");
    Expect(1, 110896, '\P{Blk: __Kana_Ext_A}', "");
    Expect(0, 110896, '\P{^Blk: __Kana_Ext_A}', "");
    Error('\p{Is_Block=--KANA_Extended_A/a/}');
    Error('\P{Is_Block=--KANA_Extended_A/a/}');
    Expect(1, 110895, '\p{Is_Block=kanaextendeda}', "");
    Expect(0, 110895, '\p{^Is_Block=kanaextendeda}', "");
    Expect(0, 110895, '\P{Is_Block=kanaextendeda}', "");
    Expect(1, 110895, '\P{^Is_Block=kanaextendeda}', "");
    Expect(0, 110896, '\p{Is_Block=kanaextendeda}', "");
    Expect(1, 110896, '\p{^Is_Block=kanaextendeda}', "");
    Expect(1, 110896, '\P{Is_Block=kanaextendeda}', "");
    Expect(0, 110896, '\P{^Is_Block=kanaextendeda}', "");
    Expect(1, 110895, '\p{Is_Block=_ kana_EXTENDED_a}', "");
    Expect(0, 110895, '\p{^Is_Block=_ kana_EXTENDED_a}', "");
    Expect(0, 110895, '\P{Is_Block=_ kana_EXTENDED_a}', "");
    Expect(1, 110895, '\P{^Is_Block=_ kana_EXTENDED_a}', "");
    Expect(0, 110896, '\p{Is_Block=_ kana_EXTENDED_a}', "");
    Expect(1, 110896, '\p{^Is_Block=_ kana_EXTENDED_a}', "");
    Expect(1, 110896, '\P{Is_Block=_ kana_EXTENDED_a}', "");
    Expect(0, 110896, '\P{^Is_Block=_ kana_EXTENDED_a}', "");
    Error('\p{Is_Blk=/a/Kana_ext_a}');
    Error('\P{Is_Blk=/a/Kana_ext_a}');
    Expect(1, 110895, '\p{Is_Blk=kanaexta}', "");
    Expect(0, 110895, '\p{^Is_Blk=kanaexta}', "");
    Expect(0, 110895, '\P{Is_Blk=kanaexta}', "");
    Expect(1, 110895, '\P{^Is_Blk=kanaexta}', "");
    Expect(0, 110896, '\p{Is_Blk=kanaexta}', "");
    Expect(1, 110896, '\p{^Is_Blk=kanaexta}', "");
    Expect(1, 110896, '\P{Is_Blk=kanaexta}', "");
    Expect(0, 110896, '\P{^Is_Blk=kanaexta}', "");
    Expect(1, 110895, '\p{Is_Blk= 	kana_Ext_A}', "");
    Expect(0, 110895, '\p{^Is_Blk= 	kana_Ext_A}', "");
    Expect(0, 110895, '\P{Is_Blk= 	kana_Ext_A}', "");
    Expect(1, 110895, '\P{^Is_Blk= 	kana_Ext_A}', "");
    Expect(0, 110896, '\p{Is_Blk= 	kana_Ext_A}', "");
    Expect(1, 110896, '\p{^Is_Blk= 	kana_Ext_A}', "");
    Expect(1, 110896, '\P{Is_Blk= 	kana_Ext_A}', "");
    Expect(0, 110896, '\P{^Is_Blk= 	kana_Ext_A}', "");
    Error('\p{Block:   - Kana_Extended_b:=}');
    Error('\P{Block:   - Kana_Extended_b:=}');
    Expect(1, 110591, '\p{Block=:\AKana_Extended_B\z:}', "");;
    Expect(0, 110592, '\p{Block=:\AKana_Extended_B\z:}', "");;
    Expect(1, 110591, '\p{Block:	kanaextendedb}', "");
    Expect(0, 110591, '\p{^Block:	kanaextendedb}', "");
    Expect(0, 110591, '\P{Block:	kanaextendedb}', "");
    Expect(1, 110591, '\P{^Block:	kanaextendedb}', "");
    Expect(0, 110592, '\p{Block:	kanaextendedb}', "");
    Expect(1, 110592, '\p{^Block:	kanaextendedb}', "");
    Expect(1, 110592, '\P{Block:	kanaextendedb}', "");
    Expect(0, 110592, '\P{^Block:	kanaextendedb}', "");
    Expect(1, 110591, '\p{Block=:\Akanaextendedb\z:}', "");;
    Expect(0, 110592, '\p{Block=:\Akanaextendedb\z:}', "");;
    Expect(1, 110591, '\p{Block=__KANA_Extended_B}', "");
    Expect(0, 110591, '\p{^Block=__KANA_Extended_B}', "");
    Expect(0, 110591, '\P{Block=__KANA_Extended_B}', "");
    Expect(1, 110591, '\P{^Block=__KANA_Extended_B}', "");
    Expect(0, 110592, '\p{Block=__KANA_Extended_B}', "");
    Expect(1, 110592, '\p{^Block=__KANA_Extended_B}', "");
    Expect(1, 110592, '\P{Block=__KANA_Extended_B}', "");
    Expect(0, 110592, '\P{^Block=__KANA_Extended_B}', "");
    Error('\p{Blk=/a/Kana_Ext_b}');
    Error('\P{Blk=/a/Kana_Ext_b}');
    Expect(1, 110591, '\p{Blk=:\AKana_Ext_B\z:}', "");;
    Expect(0, 110592, '\p{Blk=:\AKana_Ext_B\z:}', "");;
    Expect(1, 110591, '\p{Blk=kanaextb}', "");
    Expect(0, 110591, '\p{^Blk=kanaextb}', "");
    Expect(0, 110591, '\P{Blk=kanaextb}', "");
    Expect(1, 110591, '\P{^Blk=kanaextb}', "");
    Expect(0, 110592, '\p{Blk=kanaextb}', "");
    Expect(1, 110592, '\p{^Blk=kanaextb}', "");
    Expect(1, 110592, '\P{Blk=kanaextb}', "");
    Expect(0, 110592, '\P{^Blk=kanaextb}', "");
    Expect(1, 110591, '\p{Blk=:\Akanaextb\z:}', "");;
    Expect(0, 110592, '\p{Blk=:\Akanaextb\z:}', "");;
    Expect(1, 110591, '\p{Blk= KANA_EXT_b}', "");
    Expect(0, 110591, '\p{^Blk= KANA_EXT_b}', "");
    Expect(0, 110591, '\P{Blk= KANA_EXT_b}', "");
    Expect(1, 110591, '\P{^Blk= KANA_EXT_b}', "");
    Expect(0, 110592, '\p{Blk= KANA_EXT_b}', "");
    Expect(1, 110592, '\p{^Blk= KANA_EXT_b}', "");
    Expect(1, 110592, '\P{Blk= KANA_EXT_b}', "");
    Expect(0, 110592, '\P{^Blk= KANA_EXT_b}', "");
    Error('\p{Is_Block=:=		Kana_extended_B}');
    Error('\P{Is_Block=:=		Kana_extended_B}');
    Expect(1, 110591, '\p{Is_Block:kanaextendedb}', "");
    Expect(0, 110591, '\p{^Is_Block:kanaextendedb}', "");
    Expect(0, 110591, '\P{Is_Block:kanaextendedb}', "");
    Expect(1, 110591, '\P{^Is_Block:kanaextendedb}', "");
    Expect(0, 110592, '\p{Is_Block:kanaextendedb}', "");
    Expect(1, 110592, '\p{^Is_Block:kanaextendedb}', "");
    Expect(1, 110592, '\P{Is_Block:kanaextendedb}', "");
    Expect(0, 110592, '\P{^Is_Block:kanaextendedb}', "");
    Expect(1, 110591, '\p{Is_Block:   -_kana_EXTENDED_B}', "");
    Expect(0, 110591, '\p{^Is_Block:   -_kana_EXTENDED_B}', "");
    Expect(0, 110591, '\P{Is_Block:   -_kana_EXTENDED_B}', "");
    Expect(1, 110591, '\P{^Is_Block:   -_kana_EXTENDED_B}', "");
    Expect(0, 110592, '\p{Is_Block:   -_kana_EXTENDED_B}', "");
    Expect(1, 110592, '\p{^Is_Block:   -_kana_EXTENDED_B}', "");
    Expect(1, 110592, '\P{Is_Block:   -_kana_EXTENDED_B}', "");
    Expect(0, 110592, '\P{^Is_Block:   -_kana_EXTENDED_B}', "");
    Error('\p{Is_Blk=-	KANA_EXT_B:=}');
    Error('\P{Is_Blk=-	KANA_EXT_B:=}');
    Expect(1, 110591, '\p{Is_Blk=kanaextb}', "");
    Expect(0, 110591, '\p{^Is_Blk=kanaextb}', "");
    Expect(0, 110591, '\P{Is_Blk=kanaextb}', "");
    Expect(1, 110591, '\P{^Is_Blk=kanaextb}', "");
    Expect(0, 110592, '\p{Is_Blk=kanaextb}', "");
    Expect(1, 110592, '\p{^Is_Blk=kanaextb}', "");
    Expect(1, 110592, '\P{Is_Blk=kanaextb}', "");
    Expect(0, 110592, '\P{^Is_Blk=kanaextb}', "");
    Expect(1, 110591, '\p{Is_Blk=	Kana_Ext_B}', "");
    Expect(0, 110591, '\p{^Is_Blk=	Kana_Ext_B}', "");
    Expect(0, 110591, '\P{Is_Blk=	Kana_Ext_B}', "");
    Expect(1, 110591, '\P{^Is_Blk=	Kana_Ext_B}', "");
    Expect(0, 110592, '\p{Is_Blk=	Kana_Ext_B}', "");
    Expect(1, 110592, '\p{^Is_Blk=	Kana_Ext_B}', "");
    Expect(1, 110592, '\P{Is_Blk=	Kana_Ext_B}', "");
    Expect(0, 110592, '\P{^Is_Blk=	Kana_Ext_B}', "");
    Error('\p{Block=  Kana_Supplement/a/}');
    Error('\P{Block=  Kana_Supplement/a/}');
    Expect(1, 110847, '\p{Block=:\AKana_Supplement\z:}', "");;
    Expect(0, 110848, '\p{Block=:\AKana_Supplement\z:}', "");;
    Expect(1, 110847, '\p{Block=kanasupplement}', "");
    Expect(0, 110847, '\p{^Block=kanasupplement}', "");
    Expect(0, 110847, '\P{Block=kanasupplement}', "");
    Expect(1, 110847, '\P{^Block=kanasupplement}', "");
    Expect(0, 110848, '\p{Block=kanasupplement}', "");
    Expect(1, 110848, '\p{^Block=kanasupplement}', "");
    Expect(1, 110848, '\P{Block=kanasupplement}', "");
    Expect(0, 110848, '\P{^Block=kanasupplement}', "");
    Expect(1, 110847, '\p{Block=:\Akanasupplement\z:}', "");;
    Expect(0, 110848, '\p{Block=:\Akanasupplement\z:}', "");;
    Expect(1, 110847, '\p{Block=	_kana_SUPPLEMENT}', "");
    Expect(0, 110847, '\p{^Block=	_kana_SUPPLEMENT}', "");
    Expect(0, 110847, '\P{Block=	_kana_SUPPLEMENT}', "");
    Expect(1, 110847, '\P{^Block=	_kana_SUPPLEMENT}', "");
    Expect(0, 110848, '\p{Block=	_kana_SUPPLEMENT}', "");
    Expect(1, 110848, '\p{^Block=	_kana_SUPPLEMENT}', "");
    Expect(1, 110848, '\P{Block=	_kana_SUPPLEMENT}', "");
    Expect(0, 110848, '\P{^Block=	_kana_SUPPLEMENT}', "");
    Error('\p{Blk=/a/-KANA_SUP}');
    Error('\P{Blk=/a/-KANA_SUP}');
    Expect(1, 110847, '\p{Blk=:\AKana_Sup\z:}', "");;
    Expect(0, 110848, '\p{Blk=:\AKana_Sup\z:}', "");;
    Expect(1, 110847, '\p{Blk=kanasup}', "");
    Expect(0, 110847, '\p{^Blk=kanasup}', "");
    Expect(0, 110847, '\P{Blk=kanasup}', "");
    Expect(1, 110847, '\P{^Blk=kanasup}', "");
    Expect(0, 110848, '\p{Blk=kanasup}', "");
    Expect(1, 110848, '\p{^Blk=kanasup}', "");
    Expect(1, 110848, '\P{Blk=kanasup}', "");
    Expect(0, 110848, '\P{^Blk=kanasup}', "");
    Expect(1, 110847, '\p{Blk=:\Akanasup\z:}', "");;
    Expect(0, 110848, '\p{Blk=:\Akanasup\z:}', "");;
    Expect(1, 110847, '\p{Blk=-_Kana_sup}', "");
    Expect(0, 110847, '\p{^Blk=-_Kana_sup}', "");
    Expect(0, 110847, '\P{Blk=-_Kana_sup}', "");
    Expect(1, 110847, '\P{^Blk=-_Kana_sup}', "");
    Expect(0, 110848, '\p{Blk=-_Kana_sup}', "");
    Expect(1, 110848, '\p{^Blk=-_Kana_sup}', "");
    Expect(1, 110848, '\P{Blk=-_Kana_sup}', "");
    Expect(0, 110848, '\P{^Blk=-_Kana_sup}', "");
    Error('\p{Is_Block=	-kana_Supplement/a/}');
    Error('\P{Is_Block=	-kana_Supplement/a/}');
    Expect(1, 110847, '\p{Is_Block=kanasupplement}', "");
    Expect(0, 110847, '\p{^Is_Block=kanasupplement}', "");
    Expect(0, 110847, '\P{Is_Block=kanasupplement}', "");
    Expect(1, 110847, '\P{^Is_Block=kanasupplement}', "");
    Expect(0, 110848, '\p{Is_Block=kanasupplement}', "");
    Expect(1, 110848, '\p{^Is_Block=kanasupplement}', "");
    Expect(1, 110848, '\P{Is_Block=kanasupplement}', "");
    Expect(0, 110848, '\P{^Is_Block=kanasupplement}', "");
    Expect(1, 110847, '\p{Is_Block=-	Kana_SUPPLEMENT}', "");
    Expect(0, 110847, '\p{^Is_Block=-	Kana_SUPPLEMENT}', "");
    Expect(0, 110847, '\P{Is_Block=-	Kana_SUPPLEMENT}', "");
    Expect(1, 110847, '\P{^Is_Block=-	Kana_SUPPLEMENT}', "");
    Expect(0, 110848, '\p{Is_Block=-	Kana_SUPPLEMENT}', "");
    Expect(1, 110848, '\p{^Is_Block=-	Kana_SUPPLEMENT}', "");
    Expect(1, 110848, '\P{Is_Block=-	Kana_SUPPLEMENT}', "");
    Expect(0, 110848, '\P{^Is_Block=-	Kana_SUPPLEMENT}', "");
    Error('\p{Is_Blk= Kana_sup/a/}');
    Error('\P{Is_Blk= Kana_sup/a/}');
    Expect(1, 110847, '\p{Is_Blk=kanasup}', "");
    Expect(0, 110847, '\p{^Is_Blk=kanasup}', "");
    Expect(0, 110847, '\P{Is_Blk=kanasup}', "");
    Expect(1, 110847, '\P{^Is_Blk=kanasup}', "");
    Expect(0, 110848, '\p{Is_Blk=kanasup}', "");
    Expect(1, 110848, '\p{^Is_Blk=kanasup}', "");
    Expect(1, 110848, '\P{Is_Blk=kanasup}', "");
    Expect(0, 110848, '\P{^Is_Blk=kanasup}', "");
    Expect(1, 110847, '\p{Is_Blk= -Kana_Sup}', "");
    Expect(0, 110847, '\p{^Is_Blk= -Kana_Sup}', "");
    Expect(0, 110847, '\P{Is_Blk= -Kana_Sup}', "");
    Expect(1, 110847, '\P{^Is_Blk= -Kana_Sup}', "");
    Expect(0, 110848, '\p{Is_Blk= -Kana_Sup}', "");
    Expect(1, 110848, '\p{^Is_Blk= -Kana_Sup}', "");
    Expect(1, 110848, '\P{Is_Blk= -Kana_Sup}', "");
    Expect(0, 110848, '\P{^Is_Blk= -Kana_Sup}', "");
    Error('\p{Block:			kanbun/a/}');
    Error('\P{Block:			kanbun/a/}');
    Expect(1, 12703, '\p{Block=:\AKanbun\z:}', "");;
    Expect(0, 12704, '\p{Block=:\AKanbun\z:}', "");;
    Expect(1, 12703, '\p{Block=kanbun}', "");
    Expect(0, 12703, '\p{^Block=kanbun}', "");
    Expect(0, 12703, '\P{Block=kanbun}', "");
    Expect(1, 12703, '\P{^Block=kanbun}', "");
    Expect(0, 12704, '\p{Block=kanbun}', "");
    Expect(1, 12704, '\p{^Block=kanbun}', "");
    Expect(1, 12704, '\P{Block=kanbun}', "");
    Expect(0, 12704, '\P{^Block=kanbun}', "");
    Expect(1, 12703, '\p{Block=:\Akanbun\z:}', "");;
    Expect(0, 12704, '\p{Block=:\Akanbun\z:}', "");;
    Expect(1, 12703, '\p{Block= -Kanbun}', "");
    Expect(0, 12703, '\p{^Block= -Kanbun}', "");
    Expect(0, 12703, '\P{Block= -Kanbun}', "");
    Expect(1, 12703, '\P{^Block= -Kanbun}', "");
    Expect(0, 12704, '\p{Block= -Kanbun}', "");
    Expect(1, 12704, '\p{^Block= -Kanbun}', "");
    Expect(1, 12704, '\P{Block= -Kanbun}', "");
    Expect(0, 12704, '\P{^Block= -Kanbun}', "");
    Error('\p{Blk=/a/_KANBUN}');
    Error('\P{Blk=/a/_KANBUN}');
    Expect(1, 12703, '\p{Blk=:\AKanbun\z:}', "");;
    Expect(0, 12704, '\p{Blk=:\AKanbun\z:}', "");;
    Expect(1, 12703, '\p{Blk=kanbun}', "");
    Expect(0, 12703, '\p{^Blk=kanbun}', "");
    Expect(0, 12703, '\P{Blk=kanbun}', "");
    Expect(1, 12703, '\P{^Blk=kanbun}', "");
    Expect(0, 12704, '\p{Blk=kanbun}', "");
    Expect(1, 12704, '\p{^Blk=kanbun}', "");
    Expect(1, 12704, '\P{Blk=kanbun}', "");
    Expect(0, 12704, '\P{^Blk=kanbun}', "");
    Expect(1, 12703, '\p{Blk=:\Akanbun\z:}', "");;
    Expect(0, 12704, '\p{Blk=:\Akanbun\z:}', "");;
    Expect(1, 12703, '\p{Blk=-_KANBUN}', "");
    Expect(0, 12703, '\p{^Blk=-_KANBUN}', "");
    Expect(0, 12703, '\P{Blk=-_KANBUN}', "");
    Expect(1, 12703, '\P{^Blk=-_KANBUN}', "");
    Expect(0, 12704, '\p{Blk=-_KANBUN}', "");
    Expect(1, 12704, '\p{^Blk=-_KANBUN}', "");
    Expect(1, 12704, '\P{Blk=-_KANBUN}', "");
    Expect(0, 12704, '\P{^Blk=-_KANBUN}', "");
    Error('\p{Is_Block=	/a/KANBUN}');
    Error('\P{Is_Block=	/a/KANBUN}');
    Expect(1, 12703, '\p{Is_Block: kanbun}', "");
    Expect(0, 12703, '\p{^Is_Block: kanbun}', "");
    Expect(0, 12703, '\P{Is_Block: kanbun}', "");
    Expect(1, 12703, '\P{^Is_Block: kanbun}', "");
    Expect(0, 12704, '\p{Is_Block: kanbun}', "");
    Expect(1, 12704, '\p{^Is_Block: kanbun}', "");
    Expect(1, 12704, '\P{Is_Block: kanbun}', "");
    Expect(0, 12704, '\P{^Is_Block: kanbun}', "");
    Expect(1, 12703, '\p{Is_Block=	_Kanbun}', "");
    Expect(0, 12703, '\p{^Is_Block=	_Kanbun}', "");
    Expect(0, 12703, '\P{Is_Block=	_Kanbun}', "");
    Expect(1, 12703, '\P{^Is_Block=	_Kanbun}', "");
    Expect(0, 12704, '\p{Is_Block=	_Kanbun}', "");
    Expect(1, 12704, '\p{^Is_Block=	_Kanbun}', "");
    Expect(1, 12704, '\P{Is_Block=	_Kanbun}', "");
    Expect(0, 12704, '\P{^Is_Block=	_Kanbun}', "");
    Error('\p{Is_Blk:	_kanbun/a/}');
    Error('\P{Is_Blk:	_kanbun/a/}');
    Expect(1, 12703, '\p{Is_Blk=kanbun}', "");
    Expect(0, 12703, '\p{^Is_Blk=kanbun}', "");
    Expect(0, 12703, '\P{Is_Blk=kanbun}', "");
    Expect(1, 12703, '\P{^Is_Blk=kanbun}', "");
    Expect(0, 12704, '\p{Is_Blk=kanbun}', "");
    Expect(1, 12704, '\p{^Is_Blk=kanbun}', "");
    Expect(1, 12704, '\P{Is_Blk=kanbun}', "");
    Expect(0, 12704, '\P{^Is_Blk=kanbun}', "");
    Expect(1, 12703, '\p{Is_Blk=--KANBUN}', "");
    Expect(0, 12703, '\p{^Is_Blk=--KANBUN}', "");
    Expect(0, 12703, '\P{Is_Blk=--KANBUN}', "");
    Expect(1, 12703, '\P{^Is_Blk=--KANBUN}', "");
    Expect(0, 12704, '\p{Is_Blk=--KANBUN}', "");
    Expect(1, 12704, '\p{^Is_Blk=--KANBUN}', "");
    Expect(1, 12704, '\P{Is_Blk=--KANBUN}', "");
    Expect(0, 12704, '\P{^Is_Blk=--KANBUN}', "");
    Error('\p{Block=	/a/Kangxi_radicals}');
    Error('\P{Block=	/a/Kangxi_radicals}');
    Expect(1, 12255, '\p{Block=:\AKangxi_Radicals\z:}', "");;
    Expect(0, 12256, '\p{Block=:\AKangxi_Radicals\z:}', "");;
    Expect(1, 12255, '\p{Block=kangxiradicals}', "");
    Expect(0, 12255, '\p{^Block=kangxiradicals}', "");
    Expect(0, 12255, '\P{Block=kangxiradicals}', "");
    Expect(1, 12255, '\P{^Block=kangxiradicals}', "");
    Expect(0, 12256, '\p{Block=kangxiradicals}', "");
    Expect(1, 12256, '\p{^Block=kangxiradicals}', "");
    Expect(1, 12256, '\P{Block=kangxiradicals}', "");
    Expect(0, 12256, '\P{^Block=kangxiradicals}', "");
    Expect(1, 12255, '\p{Block=:\Akangxiradicals\z:}', "");;
    Expect(0, 12256, '\p{Block=:\Akangxiradicals\z:}', "");;
    Expect(1, 12255, '\p{Block= -Kangxi_radicals}', "");
    Expect(0, 12255, '\p{^Block= -Kangxi_radicals}', "");
    Expect(0, 12255, '\P{Block= -Kangxi_radicals}', "");
    Expect(1, 12255, '\P{^Block= -Kangxi_radicals}', "");
    Expect(0, 12256, '\p{Block= -Kangxi_radicals}', "");
    Expect(1, 12256, '\p{^Block= -Kangxi_radicals}', "");
    Expect(1, 12256, '\P{Block= -Kangxi_radicals}', "");
    Expect(0, 12256, '\P{^Block= -Kangxi_radicals}', "");
    Error('\p{Blk=/a/Kangxi}');
    Error('\P{Blk=/a/Kangxi}');
    Expect(1, 12255, '\p{Blk=:\AKangxi\z:}', "");;
    Expect(0, 12256, '\p{Blk=:\AKangxi\z:}', "");;
    Expect(1, 12255, '\p{Blk=kangxi}', "");
    Expect(0, 12255, '\p{^Blk=kangxi}', "");
    Expect(0, 12255, '\P{Blk=kangxi}', "");
    Expect(1, 12255, '\P{^Blk=kangxi}', "");
    Expect(0, 12256, '\p{Blk=kangxi}', "");
    Expect(1, 12256, '\p{^Blk=kangxi}', "");
    Expect(1, 12256, '\P{Blk=kangxi}', "");
    Expect(0, 12256, '\P{^Blk=kangxi}', "");
    Expect(1, 12255, '\p{Blk=:\Akangxi\z:}', "");;
    Expect(0, 12256, '\p{Blk=:\Akangxi\z:}', "");;
    Expect(1, 12255, '\p{Blk=--Kangxi}', "");
    Expect(0, 12255, '\p{^Blk=--Kangxi}', "");
    Expect(0, 12255, '\P{Blk=--Kangxi}', "");
    Expect(1, 12255, '\P{^Blk=--Kangxi}', "");
    Expect(0, 12256, '\p{Blk=--Kangxi}', "");
    Expect(1, 12256, '\p{^Blk=--Kangxi}', "");
    Expect(1, 12256, '\P{Blk=--Kangxi}', "");
    Expect(0, 12256, '\P{^Blk=--Kangxi}', "");
    Error('\p{Is_Block=:=	_kangxi_Radicals}');
    Error('\P{Is_Block=:=	_kangxi_Radicals}');
    Expect(1, 12255, '\p{Is_Block=kangxiradicals}', "");
    Expect(0, 12255, '\p{^Is_Block=kangxiradicals}', "");
    Expect(0, 12255, '\P{Is_Block=kangxiradicals}', "");
    Expect(1, 12255, '\P{^Is_Block=kangxiradicals}', "");
    Expect(0, 12256, '\p{Is_Block=kangxiradicals}', "");
    Expect(1, 12256, '\p{^Is_Block=kangxiradicals}', "");
    Expect(1, 12256, '\P{Is_Block=kangxiradicals}', "");
    Expect(0, 12256, '\P{^Is_Block=kangxiradicals}', "");
    Expect(1, 12255, '\p{Is_Block=-	kangxi_RADICALS}', "");
    Expect(0, 12255, '\p{^Is_Block=-	kangxi_RADICALS}', "");
    Expect(0, 12255, '\P{Is_Block=-	kangxi_RADICALS}', "");
    Expect(1, 12255, '\P{^Is_Block=-	kangxi_RADICALS}', "");
    Expect(0, 12256, '\p{Is_Block=-	kangxi_RADICALS}', "");
    Expect(1, 12256, '\p{^Is_Block=-	kangxi_RADICALS}', "");
    Expect(1, 12256, '\P{Is_Block=-	kangxi_RADICALS}', "");
    Expect(0, 12256, '\P{^Is_Block=-	kangxi_RADICALS}', "");
    Error('\p{Is_Blk= :=kangxi}');
    Error('\P{Is_Blk= :=kangxi}');
    Expect(1, 12255, '\p{Is_Blk=kangxi}', "");
    Expect(0, 12255, '\p{^Is_Blk=kangxi}', "");
    Expect(0, 12255, '\P{Is_Blk=kangxi}', "");
    Expect(1, 12255, '\P{^Is_Blk=kangxi}', "");
    Expect(0, 12256, '\p{Is_Blk=kangxi}', "");
    Expect(1, 12256, '\p{^Is_Blk=kangxi}', "");
    Expect(1, 12256, '\P{Is_Blk=kangxi}', "");
    Expect(0, 12256, '\P{^Is_Blk=kangxi}', "");
    Expect(1, 12255, '\p{Is_Blk= 	Kangxi}', "");
    Expect(0, 12255, '\p{^Is_Blk= 	Kangxi}', "");
    Expect(0, 12255, '\P{Is_Blk= 	Kangxi}', "");
    Expect(1, 12255, '\P{^Is_Blk= 	Kangxi}', "");
    Expect(0, 12256, '\p{Is_Blk= 	Kangxi}', "");
    Expect(1, 12256, '\p{^Is_Blk= 	Kangxi}', "");
    Expect(1, 12256, '\P{Is_Blk= 	Kangxi}', "");
    Expect(0, 12256, '\P{^Is_Blk= 	Kangxi}', "");
    Error('\p{Block=/a/ kannada}');
    Error('\P{Block=/a/ kannada}');
    Expect(1, 3327, '\p{Block=:\AKannada\z:}', "");;
    Expect(0, 3328, '\p{Block=:\AKannada\z:}', "");;
    Expect(1, 3327, '\p{Block=kannada}', "");
    Expect(0, 3327, '\p{^Block=kannada}', "");
    Expect(0, 3327, '\P{Block=kannada}', "");
    Expect(1, 3327, '\P{^Block=kannada}', "");
    Expect(0, 3328, '\p{Block=kannada}', "");
    Expect(1, 3328, '\p{^Block=kannada}', "");
    Expect(1, 3328, '\P{Block=kannada}', "");
    Expect(0, 3328, '\P{^Block=kannada}', "");
    Expect(1, 3327, '\p{Block=:\Akannada\z:}', "");;
    Expect(0, 3328, '\p{Block=:\Akannada\z:}', "");;
    Expect(1, 3327, '\p{Block=  KANNADA}', "");
    Expect(0, 3327, '\p{^Block=  KANNADA}', "");
    Expect(0, 3327, '\P{Block=  KANNADA}', "");
    Expect(1, 3327, '\P{^Block=  KANNADA}', "");
    Expect(0, 3328, '\p{Block=  KANNADA}', "");
    Expect(1, 3328, '\p{^Block=  KANNADA}', "");
    Expect(1, 3328, '\P{Block=  KANNADA}', "");
    Expect(0, 3328, '\P{^Block=  KANNADA}', "");
    Error('\p{Blk:	 :=KANNADA}');
    Error('\P{Blk:	 :=KANNADA}');
    Expect(1, 3327, '\p{Blk=:\AKannada\z:}', "");;
    Expect(0, 3328, '\p{Blk=:\AKannada\z:}', "");;
    Expect(1, 3327, '\p{Blk=kannada}', "");
    Expect(0, 3327, '\p{^Blk=kannada}', "");
    Expect(0, 3327, '\P{Blk=kannada}', "");
    Expect(1, 3327, '\P{^Blk=kannada}', "");
    Expect(0, 3328, '\p{Blk=kannada}', "");
    Expect(1, 3328, '\p{^Blk=kannada}', "");
    Expect(1, 3328, '\P{Blk=kannada}', "");
    Expect(0, 3328, '\P{^Blk=kannada}', "");
    Expect(1, 3327, '\p{Blk=:\Akannada\z:}', "");;
    Expect(0, 3328, '\p{Blk=:\Akannada\z:}', "");;
    Expect(1, 3327, '\p{Blk=--Kannada}', "");
    Expect(0, 3327, '\p{^Blk=--Kannada}', "");
    Expect(0, 3327, '\P{Blk=--Kannada}', "");
    Expect(1, 3327, '\P{^Blk=--Kannada}', "");
    Expect(0, 3328, '\p{Blk=--Kannada}', "");
    Expect(1, 3328, '\p{^Blk=--Kannada}', "");
    Expect(1, 3328, '\P{Blk=--Kannada}', "");
    Expect(0, 3328, '\P{^Blk=--Kannada}', "");
    Error('\p{Is_Block=_/a/KANNADA}');
    Error('\P{Is_Block=_/a/KANNADA}');
    Expect(1, 3327, '\p{Is_Block=kannada}', "");
    Expect(0, 3327, '\p{^Is_Block=kannada}', "");
    Expect(0, 3327, '\P{Is_Block=kannada}', "");
    Expect(1, 3327, '\P{^Is_Block=kannada}', "");
    Expect(0, 3328, '\p{Is_Block=kannada}', "");
    Expect(1, 3328, '\p{^Is_Block=kannada}', "");
    Expect(1, 3328, '\P{Is_Block=kannada}', "");
    Expect(0, 3328, '\P{^Is_Block=kannada}', "");
    Expect(1, 3327, '\p{Is_Block:	-_KANNADA}', "");
    Expect(0, 3327, '\p{^Is_Block:	-_KANNADA}', "");
    Expect(0, 3327, '\P{Is_Block:	-_KANNADA}', "");
    Expect(1, 3327, '\P{^Is_Block:	-_KANNADA}', "");
    Expect(0, 3328, '\p{Is_Block:	-_KANNADA}', "");
    Expect(1, 3328, '\p{^Is_Block:	-_KANNADA}', "");
    Expect(1, 3328, '\P{Is_Block:	-_KANNADA}', "");
    Expect(0, 3328, '\P{^Is_Block:	-_KANNADA}', "");
    Error('\p{Is_Blk= -Kannada:=}');
    Error('\P{Is_Blk= -Kannada:=}');
    Expect(1, 3327, '\p{Is_Blk=kannada}', "");
    Expect(0, 3327, '\p{^Is_Blk=kannada}', "");
    Expect(0, 3327, '\P{Is_Blk=kannada}', "");
    Expect(1, 3327, '\P{^Is_Blk=kannada}', "");
    Expect(0, 3328, '\p{Is_Blk=kannada}', "");
    Expect(1, 3328, '\p{^Is_Blk=kannada}', "");
    Expect(1, 3328, '\P{Is_Blk=kannada}', "");
    Expect(0, 3328, '\P{^Is_Blk=kannada}', "");
    Expect(1, 3327, '\p{Is_Blk=__Kannada}', "");
    Expect(0, 3327, '\p{^Is_Blk=__Kannada}', "");
    Expect(0, 3327, '\P{Is_Blk=__Kannada}', "");
    Expect(1, 3327, '\P{^Is_Blk=__Kannada}', "");
    Expect(0, 3328, '\p{Is_Blk=__Kannada}', "");
    Expect(1, 3328, '\p{^Is_Blk=__Kannada}', "");
    Expect(1, 3328, '\P{Is_Blk=__Kannada}', "");
    Expect(0, 3328, '\P{^Is_Blk=__Kannada}', "");
    Error('\p{Block= 	Katakana:=}');
    Error('\P{Block= 	Katakana:=}');
    Expect(1, 12543, '\p{Block=:\AKatakana\z:}', "");;
    Expect(0, 12544, '\p{Block=:\AKatakana\z:}', "");;
    Expect(1, 12543, '\p{Block=katakana}', "");
    Expect(0, 12543, '\p{^Block=katakana}', "");
    Expect(0, 12543, '\P{Block=katakana}', "");
    Expect(1, 12543, '\P{^Block=katakana}', "");
    Expect(0, 12544, '\p{Block=katakana}', "");
    Expect(1, 12544, '\p{^Block=katakana}', "");
    Expect(1, 12544, '\P{Block=katakana}', "");
    Expect(0, 12544, '\P{^Block=katakana}', "");
    Expect(1, 12543, '\p{Block=:\Akatakana\z:}', "");;
    Expect(0, 12544, '\p{Block=:\Akatakana\z:}', "");;
    Expect(1, 12543, '\p{Block=	KATAKANA}', "");
    Expect(0, 12543, '\p{^Block=	KATAKANA}', "");
    Expect(0, 12543, '\P{Block=	KATAKANA}', "");
    Expect(1, 12543, '\P{^Block=	KATAKANA}', "");
    Expect(0, 12544, '\p{Block=	KATAKANA}', "");
    Expect(1, 12544, '\p{^Block=	KATAKANA}', "");
    Expect(1, 12544, '\P{Block=	KATAKANA}', "");
    Expect(0, 12544, '\P{^Block=	KATAKANA}', "");
    Error('\p{Blk:-/a/Katakana}');
    Error('\P{Blk:-/a/Katakana}');
    Expect(1, 12543, '\p{Blk=:\AKatakana\z:}', "");;
    Expect(0, 12544, '\p{Blk=:\AKatakana\z:}', "");;
    Expect(1, 12543, '\p{Blk=katakana}', "");
    Expect(0, 12543, '\p{^Blk=katakana}', "");
    Expect(0, 12543, '\P{Blk=katakana}', "");
    Expect(1, 12543, '\P{^Blk=katakana}', "");
    Expect(0, 12544, '\p{Blk=katakana}', "");
    Expect(1, 12544, '\p{^Blk=katakana}', "");
    Expect(1, 12544, '\P{Blk=katakana}', "");
    Expect(0, 12544, '\P{^Blk=katakana}', "");
    Expect(1, 12543, '\p{Blk=:\Akatakana\z:}', "");;
    Expect(0, 12544, '\p{Blk=:\Akatakana\z:}', "");;
    Expect(1, 12543, '\p{Blk= KATAKANA}', "");
    Expect(0, 12543, '\p{^Blk= KATAKANA}', "");
    Expect(0, 12543, '\P{Blk= KATAKANA}', "");
    Expect(1, 12543, '\P{^Blk= KATAKANA}', "");
    Expect(0, 12544, '\p{Blk= KATAKANA}', "");
    Expect(1, 12544, '\p{^Blk= KATAKANA}', "");
    Expect(1, 12544, '\P{Blk= KATAKANA}', "");
    Expect(0, 12544, '\P{^Blk= KATAKANA}', "");
    Error('\p{Is_Block= _Katakana/a/}');
    Error('\P{Is_Block= _Katakana/a/}');
    Expect(1, 12543, '\p{Is_Block=katakana}', "");
    Expect(0, 12543, '\p{^Is_Block=katakana}', "");
    Expect(0, 12543, '\P{Is_Block=katakana}', "");
    Expect(1, 12543, '\P{^Is_Block=katakana}', "");
    Expect(0, 12544, '\p{Is_Block=katakana}', "");
    Expect(1, 12544, '\p{^Is_Block=katakana}', "");
    Expect(1, 12544, '\P{Is_Block=katakana}', "");
    Expect(0, 12544, '\P{^Is_Block=katakana}', "");
    Expect(1, 12543, '\p{Is_Block: _ Katakana}', "");
    Expect(0, 12543, '\p{^Is_Block: _ Katakana}', "");
    Expect(0, 12543, '\P{Is_Block: _ Katakana}', "");
    Expect(1, 12543, '\P{^Is_Block: _ Katakana}', "");
    Expect(0, 12544, '\p{Is_Block: _ Katakana}', "");
    Expect(1, 12544, '\p{^Is_Block: _ Katakana}', "");
    Expect(1, 12544, '\P{Is_Block: _ Katakana}', "");
    Expect(0, 12544, '\P{^Is_Block: _ Katakana}', "");
    Error('\p{Is_Blk=:=Katakana}');
    Error('\P{Is_Blk=:=Katakana}');
    Expect(1, 12543, '\p{Is_Blk=katakana}', "");
    Expect(0, 12543, '\p{^Is_Blk=katakana}', "");
    Expect(0, 12543, '\P{Is_Blk=katakana}', "");
    Expect(1, 12543, '\P{^Is_Blk=katakana}', "");
    Expect(0, 12544, '\p{Is_Blk=katakana}', "");
    Expect(1, 12544, '\p{^Is_Blk=katakana}', "");
    Expect(1, 12544, '\P{Is_Blk=katakana}', "");
    Expect(0, 12544, '\P{^Is_Blk=katakana}', "");
    Expect(1, 12543, '\p{Is_Blk=- Katakana}', "");
    Expect(0, 12543, '\p{^Is_Blk=- Katakana}', "");
    Expect(0, 12543, '\P{Is_Blk=- Katakana}', "");
    Expect(1, 12543, '\P{^Is_Blk=- Katakana}', "");
    Expect(0, 12544, '\p{Is_Blk=- Katakana}', "");
    Expect(1, 12544, '\p{^Is_Blk=- Katakana}', "");
    Expect(1, 12544, '\P{Is_Blk=- Katakana}', "");
    Expect(0, 12544, '\P{^Is_Blk=- Katakana}', "");
    Error('\p{Block=Katakana_phonetic_EXTENSIONS/a/}');
    Error('\P{Block=Katakana_phonetic_EXTENSIONS/a/}');
    Expect(1, 12799, '\p{Block=:\AKatakana_Phonetic_Extensions\z:}', "");;
    Expect(0, 12800, '\p{Block=:\AKatakana_Phonetic_Extensions\z:}', "");;
    Expect(1, 12799, '\p{Block=katakanaphoneticextensions}', "");
    Expect(0, 12799, '\p{^Block=katakanaphoneticextensions}', "");
    Expect(0, 12799, '\P{Block=katakanaphoneticextensions}', "");
    Expect(1, 12799, '\P{^Block=katakanaphoneticextensions}', "");
    Expect(0, 12800, '\p{Block=katakanaphoneticextensions}', "");
    Expect(1, 12800, '\p{^Block=katakanaphoneticextensions}', "");
    Expect(1, 12800, '\P{Block=katakanaphoneticextensions}', "");
    Expect(0, 12800, '\P{^Block=katakanaphoneticextensions}', "");
    Expect(1, 12799, '\p{Block=:\Akatakanaphoneticextensions\z:}', "");;
    Expect(0, 12800, '\p{Block=:\Akatakanaphoneticextensions\z:}', "");;
    Expect(1, 12799, '\p{Block=	_katakana_phonetic_Extensions}', "");
    Expect(0, 12799, '\p{^Block=	_katakana_phonetic_Extensions}', "");
    Expect(0, 12799, '\P{Block=	_katakana_phonetic_Extensions}', "");
    Expect(1, 12799, '\P{^Block=	_katakana_phonetic_Extensions}', "");
    Expect(0, 12800, '\p{Block=	_katakana_phonetic_Extensions}', "");
    Expect(1, 12800, '\p{^Block=	_katakana_phonetic_Extensions}', "");
    Expect(1, 12800, '\P{Block=	_katakana_phonetic_Extensions}', "");
    Expect(0, 12800, '\P{^Block=	_katakana_phonetic_Extensions}', "");
    Error('\p{Blk=:=	 katakana_Ext}');
    Error('\P{Blk=:=	 katakana_Ext}');
    Expect(1, 12799, '\p{Blk=:\AKatakana_Ext\z:}', "");;
    Expect(0, 12800, '\p{Blk=:\AKatakana_Ext\z:}', "");;
    Expect(1, 12799, '\p{Blk=katakanaext}', "");
    Expect(0, 12799, '\p{^Blk=katakanaext}', "");
    Expect(0, 12799, '\P{Blk=katakanaext}', "");
    Expect(1, 12799, '\P{^Blk=katakanaext}', "");
    Expect(0, 12800, '\p{Blk=katakanaext}', "");
    Expect(1, 12800, '\p{^Blk=katakanaext}', "");
    Expect(1, 12800, '\P{Blk=katakanaext}', "");
    Expect(0, 12800, '\P{^Blk=katakanaext}', "");
    Expect(1, 12799, '\p{Blk=:\Akatakanaext\z:}', "");;
    Expect(0, 12800, '\p{Blk=:\Akatakanaext\z:}', "");;
    Expect(1, 12799, '\p{Blk= 	Katakana_EXT}', "");
    Expect(0, 12799, '\p{^Blk= 	Katakana_EXT}', "");
    Expect(0, 12799, '\P{Blk= 	Katakana_EXT}', "");
    Expect(1, 12799, '\P{^Blk= 	Katakana_EXT}', "");
    Expect(0, 12800, '\p{Blk= 	Katakana_EXT}', "");
    Expect(1, 12800, '\p{^Blk= 	Katakana_EXT}', "");
    Expect(1, 12800, '\P{Blk= 	Katakana_EXT}', "");
    Expect(0, 12800, '\P{^Blk= 	Katakana_EXT}', "");
    Error('\p{Is_Block=_/a/KATAKANA_phonetic_Extensions}');
    Error('\P{Is_Block=_/a/KATAKANA_phonetic_Extensions}');
    Expect(1, 12799, '\p{Is_Block=katakanaphoneticextensions}', "");
    Expect(0, 12799, '\p{^Is_Block=katakanaphoneticextensions}', "");
    Expect(0, 12799, '\P{Is_Block=katakanaphoneticextensions}', "");
    Expect(1, 12799, '\P{^Is_Block=katakanaphoneticextensions}', "");
    Expect(0, 12800, '\p{Is_Block=katakanaphoneticextensions}', "");
    Expect(1, 12800, '\p{^Is_Block=katakanaphoneticextensions}', "");
    Expect(1, 12800, '\P{Is_Block=katakanaphoneticextensions}', "");
    Expect(0, 12800, '\P{^Is_Block=katakanaphoneticextensions}', "");
    Expect(1, 12799, '\p{Is_Block= -KATAKANA_Phonetic_Extensions}', "");
    Expect(0, 12799, '\p{^Is_Block= -KATAKANA_Phonetic_Extensions}', "");
    Expect(0, 12799, '\P{Is_Block= -KATAKANA_Phonetic_Extensions}', "");
    Expect(1, 12799, '\P{^Is_Block= -KATAKANA_Phonetic_Extensions}', "");
    Expect(0, 12800, '\p{Is_Block= -KATAKANA_Phonetic_Extensions}', "");
    Expect(1, 12800, '\p{^Is_Block= -KATAKANA_Phonetic_Extensions}', "");
    Expect(1, 12800, '\P{Is_Block= -KATAKANA_Phonetic_Extensions}', "");
    Expect(0, 12800, '\P{^Is_Block= -KATAKANA_Phonetic_Extensions}', "");
    Error('\p{Is_Blk=KATAKANA_Ext/a/}');
    Error('\P{Is_Blk=KATAKANA_Ext/a/}');
    Expect(1, 12799, '\p{Is_Blk=katakanaext}', "");
    Expect(0, 12799, '\p{^Is_Blk=katakanaext}', "");
    Expect(0, 12799, '\P{Is_Blk=katakanaext}', "");
    Expect(1, 12799, '\P{^Is_Blk=katakanaext}', "");
    Expect(0, 12800, '\p{Is_Blk=katakanaext}', "");
    Expect(1, 12800, '\p{^Is_Blk=katakanaext}', "");
    Expect(1, 12800, '\P{Is_Blk=katakanaext}', "");
    Expect(0, 12800, '\P{^Is_Blk=katakanaext}', "");
    Expect(1, 12799, '\p{Is_Blk=_Katakana_EXT}', "");
    Expect(0, 12799, '\p{^Is_Blk=_Katakana_EXT}', "");
    Expect(0, 12799, '\P{Is_Blk=_Katakana_EXT}', "");
    Expect(1, 12799, '\P{^Is_Blk=_Katakana_EXT}', "");
    Expect(0, 12800, '\p{Is_Blk=_Katakana_EXT}', "");
    Expect(1, 12800, '\p{^Is_Blk=_Katakana_EXT}', "");
    Expect(1, 12800, '\P{Is_Blk=_Katakana_EXT}', "");
    Expect(0, 12800, '\P{^Is_Blk=_Katakana_EXT}', "");
    Error('\p{Block=/a/_	KAWI}');
    Error('\P{Block=/a/_	KAWI}');
    Expect(1, 73567, '\p{Block=:\AKawi\z:}', "");;
    Expect(0, 73568, '\p{Block=:\AKawi\z:}', "");;
    Expect(1, 73567, '\p{Block=kawi}', "");
    Expect(0, 73567, '\p{^Block=kawi}', "");
    Expect(0, 73567, '\P{Block=kawi}', "");
    Expect(1, 73567, '\P{^Block=kawi}', "");
    Expect(0, 73568, '\p{Block=kawi}', "");
    Expect(1, 73568, '\p{^Block=kawi}', "");
    Expect(1, 73568, '\P{Block=kawi}', "");
    Expect(0, 73568, '\P{^Block=kawi}', "");
    Expect(1, 73567, '\p{Block=:\Akawi\z:}', "");;
    Expect(0, 73568, '\p{Block=:\Akawi\z:}', "");;
    Expect(1, 73567, '\p{Block:		-KAWI}', "");
    Expect(0, 73567, '\p{^Block:		-KAWI}', "");
    Expect(0, 73567, '\P{Block:		-KAWI}', "");
    Expect(1, 73567, '\P{^Block:		-KAWI}', "");
    Expect(0, 73568, '\p{Block:		-KAWI}', "");
    Expect(1, 73568, '\p{^Block:		-KAWI}', "");
    Expect(1, 73568, '\P{Block:		-KAWI}', "");
    Expect(0, 73568, '\P{^Block:		-KAWI}', "");
    Error('\p{Blk=-_Kawi/a/}');
    Error('\P{Blk=-_Kawi/a/}');
    Expect(1, 73567, '\p{Blk=:\AKawi\z:}', "");;
    Expect(0, 73568, '\p{Blk=:\AKawi\z:}', "");;
    Expect(1, 73567, '\p{Blk=kawi}', "");
    Expect(0, 73567, '\p{^Blk=kawi}', "");
    Expect(0, 73567, '\P{Blk=kawi}', "");
    Expect(1, 73567, '\P{^Blk=kawi}', "");
    Expect(0, 73568, '\p{Blk=kawi}', "");
    Expect(1, 73568, '\p{^Blk=kawi}', "");
    Expect(1, 73568, '\P{Blk=kawi}', "");
    Expect(0, 73568, '\P{^Blk=kawi}', "");
    Expect(1, 73567, '\p{Blk=:\Akawi\z:}', "");;
    Expect(0, 73568, '\p{Blk=:\Akawi\z:}', "");;
    Expect(1, 73567, '\p{Blk=	-Kawi}', "");
    Expect(0, 73567, '\p{^Blk=	-Kawi}', "");
    Expect(0, 73567, '\P{Blk=	-Kawi}', "");
    Expect(1, 73567, '\P{^Blk=	-Kawi}', "");
    Expect(0, 73568, '\p{Blk=	-Kawi}', "");
    Expect(1, 73568, '\p{^Blk=	-Kawi}', "");
    Expect(1, 73568, '\P{Blk=	-Kawi}', "");
    Expect(0, 73568, '\P{^Blk=	-Kawi}', "");
    Error('\p{Is_Block=:=  Kawi}');
    Error('\P{Is_Block=:=  Kawi}');
    Expect(1, 73567, '\p{Is_Block=kawi}', "");
    Expect(0, 73567, '\p{^Is_Block=kawi}', "");
    Expect(0, 73567, '\P{Is_Block=kawi}', "");
    Expect(1, 73567, '\P{^Is_Block=kawi}', "");
    Expect(0, 73568, '\p{Is_Block=kawi}', "");
    Expect(1, 73568, '\p{^Is_Block=kawi}', "");
    Expect(1, 73568, '\P{Is_Block=kawi}', "");
    Expect(0, 73568, '\P{^Is_Block=kawi}', "");
    Expect(1, 73567, '\p{Is_Block=_	Kawi}', "");
    Expect(0, 73567, '\p{^Is_Block=_	Kawi}', "");
    Expect(0, 73567, '\P{Is_Block=_	Kawi}', "");
    Expect(1, 73567, '\P{^Is_Block=_	Kawi}', "");
    Expect(0, 73568, '\p{Is_Block=_	Kawi}', "");
    Expect(1, 73568, '\p{^Is_Block=_	Kawi}', "");
    Expect(1, 73568, '\P{Is_Block=_	Kawi}', "");
    Expect(0, 73568, '\P{^Is_Block=_	Kawi}', "");
    Error('\p{Is_Blk=/a/	 kawi}');
    Error('\P{Is_Blk=/a/	 kawi}');
    Expect(1, 73567, '\p{Is_Blk=kawi}', "");
    Expect(0, 73567, '\p{^Is_Blk=kawi}', "");
    Expect(0, 73567, '\P{Is_Blk=kawi}', "");
    Expect(1, 73567, '\P{^Is_Blk=kawi}', "");
    Expect(0, 73568, '\p{Is_Blk=kawi}', "");
    Expect(1, 73568, '\p{^Is_Blk=kawi}', "");
    Expect(1, 73568, '\P{Is_Blk=kawi}', "");
    Expect(0, 73568, '\P{^Is_Blk=kawi}', "");
    Expect(1, 73567, '\p{Is_Blk:	-_Kawi}', "");
    Expect(0, 73567, '\p{^Is_Blk:	-_Kawi}', "");
    Expect(0, 73567, '\P{Is_Blk:	-_Kawi}', "");
    Expect(1, 73567, '\P{^Is_Blk:	-_Kawi}', "");
    Expect(0, 73568, '\p{Is_Blk:	-_Kawi}', "");
    Expect(1, 73568, '\p{^Is_Blk:	-_Kawi}', "");
    Expect(1, 73568, '\P{Is_Blk:	-_Kawi}', "");
    Expect(0, 73568, '\P{^Is_Blk:	-_Kawi}', "");
    Error('\p{Block=_ kayah_Li/a/}');
    Error('\P{Block=_ kayah_Li/a/}');
    Expect(1, 43311, '\p{Block=:\AKayah_Li\z:}', "");;
    Expect(0, 43312, '\p{Block=:\AKayah_Li\z:}', "");;
    Expect(1, 43311, '\p{Block:	kayahli}', "");
    Expect(0, 43311, '\p{^Block:	kayahli}', "");
    Expect(0, 43311, '\P{Block:	kayahli}', "");
    Expect(1, 43311, '\P{^Block:	kayahli}', "");
    Expect(0, 43312, '\p{Block:	kayahli}', "");
    Expect(1, 43312, '\p{^Block:	kayahli}', "");
    Expect(1, 43312, '\P{Block:	kayahli}', "");
    Expect(0, 43312, '\P{^Block:	kayahli}', "");
    Expect(1, 43311, '\p{Block=:\Akayahli\z:}', "");;
    Expect(0, 43312, '\p{Block=:\Akayahli\z:}', "");;
    Expect(1, 43311, '\p{Block=Kayah_LI}', "");
    Expect(0, 43311, '\p{^Block=Kayah_LI}', "");
    Expect(0, 43311, '\P{Block=Kayah_LI}', "");
    Expect(1, 43311, '\P{^Block=Kayah_LI}', "");
    Expect(0, 43312, '\p{Block=Kayah_LI}', "");
    Expect(1, 43312, '\p{^Block=Kayah_LI}', "");
    Expect(1, 43312, '\P{Block=Kayah_LI}', "");
    Expect(0, 43312, '\P{^Block=Kayah_LI}', "");
    Error('\p{Blk=:=--KAYAH_li}');
    Error('\P{Blk=:=--KAYAH_li}');
    Expect(1, 43311, '\p{Blk=:\AKayah_Li\z:}', "");;
    Expect(0, 43312, '\p{Blk=:\AKayah_Li\z:}', "");;
    Expect(1, 43311, '\p{Blk=kayahli}', "");
    Expect(0, 43311, '\p{^Blk=kayahli}', "");
    Expect(0, 43311, '\P{Blk=kayahli}', "");
    Expect(1, 43311, '\P{^Blk=kayahli}', "");
    Expect(0, 43312, '\p{Blk=kayahli}', "");
    Expect(1, 43312, '\p{^Blk=kayahli}', "");
    Expect(1, 43312, '\P{Blk=kayahli}', "");
    Expect(0, 43312, '\P{^Blk=kayahli}', "");
    Expect(1, 43311, '\p{Blk=:\Akayahli\z:}', "");;
    Expect(0, 43312, '\p{Blk=:\Akayahli\z:}', "");;
    Expect(1, 43311, '\p{Blk=- KAYAH_li}', "");
    Expect(0, 43311, '\p{^Blk=- KAYAH_li}', "");
    Expect(0, 43311, '\P{Blk=- KAYAH_li}', "");
    Expect(1, 43311, '\P{^Blk=- KAYAH_li}', "");
    Expect(0, 43312, '\p{Blk=- KAYAH_li}', "");
    Expect(1, 43312, '\p{^Blk=- KAYAH_li}', "");
    Expect(1, 43312, '\P{Blk=- KAYAH_li}', "");
    Expect(0, 43312, '\P{^Blk=- KAYAH_li}', "");
    Error('\p{Is_Block=_KAYAH_Li:=}');
    Error('\P{Is_Block=_KAYAH_Li:=}');
    Expect(1, 43311, '\p{Is_Block:	kayahli}', "");
    Expect(0, 43311, '\p{^Is_Block:	kayahli}', "");
    Expect(0, 43311, '\P{Is_Block:	kayahli}', "");
    Expect(1, 43311, '\P{^Is_Block:	kayahli}', "");
    Expect(0, 43312, '\p{Is_Block:	kayahli}', "");
    Expect(1, 43312, '\p{^Is_Block:	kayahli}', "");
    Expect(1, 43312, '\P{Is_Block:	kayahli}', "");
    Expect(0, 43312, '\P{^Is_Block:	kayahli}', "");
    Expect(1, 43311, '\p{Is_Block=	 Kayah_Li}', "");
    Expect(0, 43311, '\p{^Is_Block=	 Kayah_Li}', "");
    Expect(0, 43311, '\P{Is_Block=	 Kayah_Li}', "");
    Expect(1, 43311, '\P{^Is_Block=	 Kayah_Li}', "");
    Expect(0, 43312, '\p{Is_Block=	 Kayah_Li}', "");
    Expect(1, 43312, '\p{^Is_Block=	 Kayah_Li}', "");
    Expect(1, 43312, '\P{Is_Block=	 Kayah_Li}', "");
    Expect(0, 43312, '\P{^Is_Block=	 Kayah_Li}', "");
    Error('\p{Is_Blk=/a/_	Kayah_li}');
    Error('\P{Is_Blk=/a/_	Kayah_li}');
    Expect(1, 43311, '\p{Is_Blk=kayahli}', "");
    Expect(0, 43311, '\p{^Is_Blk=kayahli}', "");
    Expect(0, 43311, '\P{Is_Blk=kayahli}', "");
    Expect(1, 43311, '\P{^Is_Blk=kayahli}', "");
    Expect(0, 43312, '\p{Is_Blk=kayahli}', "");
    Expect(1, 43312, '\p{^Is_Blk=kayahli}', "");
    Expect(1, 43312, '\P{Is_Blk=kayahli}', "");
    Expect(0, 43312, '\P{^Is_Blk=kayahli}', "");
    Expect(1, 43311, '\p{Is_Blk=	Kayah_Li}', "");
    Expect(0, 43311, '\p{^Is_Blk=	Kayah_Li}', "");
    Expect(0, 43311, '\P{Is_Blk=	Kayah_Li}', "");
    Expect(1, 43311, '\P{^Is_Blk=	Kayah_Li}', "");
    Expect(0, 43312, '\p{Is_Blk=	Kayah_Li}', "");
    Expect(1, 43312, '\p{^Is_Blk=	Kayah_Li}', "");
    Expect(1, 43312, '\P{Is_Blk=	Kayah_Li}', "");
    Expect(0, 43312, '\P{^Is_Blk=	Kayah_Li}', "");
    Error('\p{Block:/a/_KHAROSHTHI}');
    Error('\P{Block:/a/_KHAROSHTHI}');
    Expect(1, 68191, '\p{Block=:\AKharoshthi\z:}', "");;
    Expect(0, 68192, '\p{Block=:\AKharoshthi\z:}', "");;
    Expect(1, 68191, '\p{Block=kharoshthi}', "");
    Expect(0, 68191, '\p{^Block=kharoshthi}', "");
    Expect(0, 68191, '\P{Block=kharoshthi}', "");
    Expect(1, 68191, '\P{^Block=kharoshthi}', "");
    Expect(0, 68192, '\p{Block=kharoshthi}', "");
    Expect(1, 68192, '\p{^Block=kharoshthi}', "");
    Expect(1, 68192, '\P{Block=kharoshthi}', "");
    Expect(0, 68192, '\P{^Block=kharoshthi}', "");
    Expect(1, 68191, '\p{Block=:\Akharoshthi\z:}', "");;
    Expect(0, 68192, '\p{Block=:\Akharoshthi\z:}', "");;
    Expect(1, 68191, '\p{Block=-_Kharoshthi}', "");
    Expect(0, 68191, '\p{^Block=-_Kharoshthi}', "");
    Expect(0, 68191, '\P{Block=-_Kharoshthi}', "");
    Expect(1, 68191, '\P{^Block=-_Kharoshthi}', "");
    Expect(0, 68192, '\p{Block=-_Kharoshthi}', "");
    Expect(1, 68192, '\p{^Block=-_Kharoshthi}', "");
    Expect(1, 68192, '\P{Block=-_Kharoshthi}', "");
    Expect(0, 68192, '\P{^Block=-_Kharoshthi}', "");
    Error('\p{Blk=/a/	-KHAROSHTHI}');
    Error('\P{Blk=/a/	-KHAROSHTHI}');
    Expect(1, 68191, '\p{Blk=:\AKharoshthi\z:}', "");;
    Expect(0, 68192, '\p{Blk=:\AKharoshthi\z:}', "");;
    Expect(1, 68191, '\p{Blk:	kharoshthi}', "");
    Expect(0, 68191, '\p{^Blk:	kharoshthi}', "");
    Expect(0, 68191, '\P{Blk:	kharoshthi}', "");
    Expect(1, 68191, '\P{^Blk:	kharoshthi}', "");
    Expect(0, 68192, '\p{Blk:	kharoshthi}', "");
    Expect(1, 68192, '\p{^Blk:	kharoshthi}', "");
    Expect(1, 68192, '\P{Blk:	kharoshthi}', "");
    Expect(0, 68192, '\P{^Blk:	kharoshthi}', "");
    Expect(1, 68191, '\p{Blk=:\Akharoshthi\z:}', "");;
    Expect(0, 68192, '\p{Blk=:\Akharoshthi\z:}', "");;
    Expect(1, 68191, '\p{Blk= 	kharoshthi}', "");
    Expect(0, 68191, '\p{^Blk= 	kharoshthi}', "");
    Expect(0, 68191, '\P{Blk= 	kharoshthi}', "");
    Expect(1, 68191, '\P{^Blk= 	kharoshthi}', "");
    Expect(0, 68192, '\p{Blk= 	kharoshthi}', "");
    Expect(1, 68192, '\p{^Blk= 	kharoshthi}', "");
    Expect(1, 68192, '\P{Blk= 	kharoshthi}', "");
    Expect(0, 68192, '\P{^Blk= 	kharoshthi}', "");
    Error('\p{Is_Block= 	Kharoshthi:=}');
    Error('\P{Is_Block= 	Kharoshthi:=}');
    Expect(1, 68191, '\p{Is_Block=kharoshthi}', "");
    Expect(0, 68191, '\p{^Is_Block=kharoshthi}', "");
    Expect(0, 68191, '\P{Is_Block=kharoshthi}', "");
    Expect(1, 68191, '\P{^Is_Block=kharoshthi}', "");
    Expect(0, 68192, '\p{Is_Block=kharoshthi}', "");
    Expect(1, 68192, '\p{^Is_Block=kharoshthi}', "");
    Expect(1, 68192, '\P{Is_Block=kharoshthi}', "");
    Expect(0, 68192, '\P{^Is_Block=kharoshthi}', "");
    Expect(1, 68191, '\p{Is_Block=_kharoshthi}', "");
    Expect(0, 68191, '\p{^Is_Block=_kharoshthi}', "");
    Expect(0, 68191, '\P{Is_Block=_kharoshthi}', "");
    Expect(1, 68191, '\P{^Is_Block=_kharoshthi}', "");
    Expect(0, 68192, '\p{Is_Block=_kharoshthi}', "");
    Expect(1, 68192, '\p{^Is_Block=_kharoshthi}', "");
    Expect(1, 68192, '\P{Is_Block=_kharoshthi}', "");
    Expect(0, 68192, '\P{^Is_Block=_kharoshthi}', "");
    Error('\p{Is_Blk=  Kharoshthi:=}');
    Error('\P{Is_Blk=  Kharoshthi:=}');
    Expect(1, 68191, '\p{Is_Blk:	kharoshthi}', "");
    Expect(0, 68191, '\p{^Is_Blk:	kharoshthi}', "");
    Expect(0, 68191, '\P{Is_Blk:	kharoshthi}', "");
    Expect(1, 68191, '\P{^Is_Blk:	kharoshthi}', "");
    Expect(0, 68192, '\p{Is_Blk:	kharoshthi}', "");
    Expect(1, 68192, '\p{^Is_Blk:	kharoshthi}', "");
    Expect(1, 68192, '\P{Is_Blk:	kharoshthi}', "");
    Expect(0, 68192, '\P{^Is_Blk:	kharoshthi}', "");
    Expect(1, 68191, '\p{Is_Blk= Kharoshthi}', "");
    Expect(0, 68191, '\p{^Is_Blk= Kharoshthi}', "");
    Expect(0, 68191, '\P{Is_Blk= Kharoshthi}', "");
    Expect(1, 68191, '\P{^Is_Blk= Kharoshthi}', "");
    Expect(0, 68192, '\p{Is_Blk= Kharoshthi}', "");
    Expect(1, 68192, '\p{^Is_Blk= Kharoshthi}', "");
    Expect(1, 68192, '\P{Is_Blk= Kharoshthi}', "");
    Expect(0, 68192, '\P{^Is_Blk= Kharoshthi}', "");
    Error('\p{Block=-	Khitan_small_Script/a/}');
    Error('\P{Block=-	Khitan_small_Script/a/}');
    Expect(1, 101631, '\p{Block=:\AKhitan_Small_Script\z:}', "");;
    Expect(0, 101632, '\p{Block=:\AKhitan_Small_Script\z:}', "");;
    Expect(1, 101631, '\p{Block=khitansmallscript}', "");
    Expect(0, 101631, '\p{^Block=khitansmallscript}', "");
    Expect(0, 101631, '\P{Block=khitansmallscript}', "");
    Expect(1, 101631, '\P{^Block=khitansmallscript}', "");
    Expect(0, 101632, '\p{Block=khitansmallscript}', "");
    Expect(1, 101632, '\p{^Block=khitansmallscript}', "");
    Expect(1, 101632, '\P{Block=khitansmallscript}', "");
    Expect(0, 101632, '\P{^Block=khitansmallscript}', "");
    Expect(1, 101631, '\p{Block=:\Akhitansmallscript\z:}', "");;
    Expect(0, 101632, '\p{Block=:\Akhitansmallscript\z:}', "");;
    Expect(1, 101631, '\p{Block=_khitan_Small_Script}', "");
    Expect(0, 101631, '\p{^Block=_khitan_Small_Script}', "");
    Expect(0, 101631, '\P{Block=_khitan_Small_Script}', "");
    Expect(1, 101631, '\P{^Block=_khitan_Small_Script}', "");
    Expect(0, 101632, '\p{Block=_khitan_Small_Script}', "");
    Expect(1, 101632, '\p{^Block=_khitan_Small_Script}', "");
    Expect(1, 101632, '\P{Block=_khitan_Small_Script}', "");
    Expect(0, 101632, '\P{^Block=_khitan_Small_Script}', "");
    Error('\p{Blk=-:=Khitan_Small_Script}');
    Error('\P{Blk=-:=Khitan_Small_Script}');
    Expect(1, 101631, '\p{Blk=:\AKhitan_Small_Script\z:}', "");;
    Expect(0, 101632, '\p{Blk=:\AKhitan_Small_Script\z:}', "");;
    Expect(1, 101631, '\p{Blk=khitansmallscript}', "");
    Expect(0, 101631, '\p{^Blk=khitansmallscript}', "");
    Expect(0, 101631, '\P{Blk=khitansmallscript}', "");
    Expect(1, 101631, '\P{^Blk=khitansmallscript}', "");
    Expect(0, 101632, '\p{Blk=khitansmallscript}', "");
    Expect(1, 101632, '\p{^Blk=khitansmallscript}', "");
    Expect(1, 101632, '\P{Blk=khitansmallscript}', "");
    Expect(0, 101632, '\P{^Blk=khitansmallscript}', "");
    Expect(1, 101631, '\p{Blk=:\Akhitansmallscript\z:}', "");;
    Expect(0, 101632, '\p{Blk=:\Akhitansmallscript\z:}', "");;
    Expect(1, 101631, '\p{Blk= Khitan_small_SCRIPT}', "");
    Expect(0, 101631, '\p{^Blk= Khitan_small_SCRIPT}', "");
    Expect(0, 101631, '\P{Blk= Khitan_small_SCRIPT}', "");
    Expect(1, 101631, '\P{^Blk= Khitan_small_SCRIPT}', "");
    Expect(0, 101632, '\p{Blk= Khitan_small_SCRIPT}', "");
    Expect(1, 101632, '\p{^Blk= Khitan_small_SCRIPT}', "");
    Expect(1, 101632, '\P{Blk= Khitan_small_SCRIPT}', "");
    Expect(0, 101632, '\P{^Blk= Khitan_small_SCRIPT}', "");
    Error('\p{Is_Block=:=_KHITAN_SMALL_Script}');
    Error('\P{Is_Block=:=_KHITAN_SMALL_Script}');
    Expect(1, 101631, '\p{Is_Block=khitansmallscript}', "");
    Expect(0, 101631, '\p{^Is_Block=khitansmallscript}', "");
    Expect(0, 101631, '\P{Is_Block=khitansmallscript}', "");
    Expect(1, 101631, '\P{^Is_Block=khitansmallscript}', "");
    Expect(0, 101632, '\p{Is_Block=khitansmallscript}', "");
    Expect(1, 101632, '\p{^Is_Block=khitansmallscript}', "");
    Expect(1, 101632, '\P{Is_Block=khitansmallscript}', "");
    Expect(0, 101632, '\P{^Is_Block=khitansmallscript}', "");
    Expect(1, 101631, '\p{Is_Block:	_khitan_Small_script}', "");
    Expect(0, 101631, '\p{^Is_Block:	_khitan_Small_script}', "");
    Expect(0, 101631, '\P{Is_Block:	_khitan_Small_script}', "");
    Expect(1, 101631, '\P{^Is_Block:	_khitan_Small_script}', "");
    Expect(0, 101632, '\p{Is_Block:	_khitan_Small_script}', "");
    Expect(1, 101632, '\p{^Is_Block:	_khitan_Small_script}', "");
    Expect(1, 101632, '\P{Is_Block:	_khitan_Small_script}', "");
    Expect(0, 101632, '\P{^Is_Block:	_khitan_Small_script}', "");
    Error('\p{Is_Blk=:= 	Khitan_small_Script}');
    Error('\P{Is_Blk=:= 	Khitan_small_Script}');
    Expect(1, 101631, '\p{Is_Blk=khitansmallscript}', "");
    Expect(0, 101631, '\p{^Is_Blk=khitansmallscript}', "");
    Expect(0, 101631, '\P{Is_Blk=khitansmallscript}', "");
    Expect(1, 101631, '\P{^Is_Blk=khitansmallscript}', "");
    Expect(0, 101632, '\p{Is_Blk=khitansmallscript}', "");
    Expect(1, 101632, '\p{^Is_Blk=khitansmallscript}', "");
    Expect(1, 101632, '\P{Is_Blk=khitansmallscript}', "");
    Expect(0, 101632, '\P{^Is_Blk=khitansmallscript}', "");
    Expect(1, 101631, '\p{Is_Blk=	_KHITAN_Small_script}', "");
    Expect(0, 101631, '\p{^Is_Blk=	_KHITAN_Small_script}', "");
    Expect(0, 101631, '\P{Is_Blk=	_KHITAN_Small_script}', "");
    Expect(1, 101631, '\P{^Is_Blk=	_KHITAN_Small_script}', "");
    Expect(0, 101632, '\p{Is_Blk=	_KHITAN_Small_script}', "");
    Expect(1, 101632, '\p{^Is_Blk=	_KHITAN_Small_script}', "");
    Expect(1, 101632, '\P{Is_Blk=	_KHITAN_Small_script}', "");
    Expect(0, 101632, '\P{^Is_Blk=	_KHITAN_Small_script}', "");
    Error('\p{Block=_:=khmer}');
    Error('\P{Block=_:=khmer}');
    Expect(1, 6143, '\p{Block=:\AKhmer\z:}', "");;
    Expect(0, 6144, '\p{Block=:\AKhmer\z:}', "");;
    Expect(1, 6143, '\p{Block=khmer}', "");
    Expect(0, 6143, '\p{^Block=khmer}', "");
    Expect(0, 6143, '\P{Block=khmer}', "");
    Expect(1, 6143, '\P{^Block=khmer}', "");
    Expect(0, 6144, '\p{Block=khmer}', "");
    Expect(1, 6144, '\p{^Block=khmer}', "");
    Expect(1, 6144, '\P{Block=khmer}', "");
    Expect(0, 6144, '\P{^Block=khmer}', "");
    Expect(1, 6143, '\p{Block=:\Akhmer\z:}', "");;
    Expect(0, 6144, '\p{Block=:\Akhmer\z:}', "");;
    Expect(1, 6143, '\p{Block=- Khmer}', "");
    Expect(0, 6143, '\p{^Block=- Khmer}', "");
    Expect(0, 6143, '\P{Block=- Khmer}', "");
    Expect(1, 6143, '\P{^Block=- Khmer}', "");
    Expect(0, 6144, '\p{Block=- Khmer}', "");
    Expect(1, 6144, '\p{^Block=- Khmer}', "");
    Expect(1, 6144, '\P{Block=- Khmer}', "");
    Expect(0, 6144, '\P{^Block=- Khmer}', "");
    Error('\p{Blk= /a/khmer}');
    Error('\P{Blk= /a/khmer}');
    Expect(1, 6143, '\p{Blk=:\AKhmer\z:}', "");;
    Expect(0, 6144, '\p{Blk=:\AKhmer\z:}', "");;
    Expect(1, 6143, '\p{Blk=khmer}', "");
    Expect(0, 6143, '\p{^Blk=khmer}', "");
    Expect(0, 6143, '\P{Blk=khmer}', "");
    Expect(1, 6143, '\P{^Blk=khmer}', "");
    Expect(0, 6144, '\p{Blk=khmer}', "");
    Expect(1, 6144, '\p{^Blk=khmer}', "");
    Expect(1, 6144, '\P{Blk=khmer}', "");
    Expect(0, 6144, '\P{^Blk=khmer}', "");
    Expect(1, 6143, '\p{Blk=:\Akhmer\z:}', "");;
    Expect(0, 6144, '\p{Blk=:\Akhmer\z:}', "");;
    Expect(1, 6143, '\p{Blk=-khmer}', "");
    Expect(0, 6143, '\p{^Blk=-khmer}', "");
    Expect(0, 6143, '\P{Blk=-khmer}', "");
    Expect(1, 6143, '\P{^Blk=-khmer}', "");
    Expect(0, 6144, '\p{Blk=-khmer}', "");
    Expect(1, 6144, '\p{^Blk=-khmer}', "");
    Expect(1, 6144, '\P{Blk=-khmer}', "");
    Expect(0, 6144, '\P{^Blk=-khmer}', "");
    Error('\p{Is_Block=	/a/khmer}');
    Error('\P{Is_Block=	/a/khmer}');
    Expect(1, 6143, '\p{Is_Block=khmer}', "");
    Expect(0, 6143, '\p{^Is_Block=khmer}', "");
    Expect(0, 6143, '\P{Is_Block=khmer}', "");
    Expect(1, 6143, '\P{^Is_Block=khmer}', "");
    Expect(0, 6144, '\p{Is_Block=khmer}', "");
    Expect(1, 6144, '\p{^Is_Block=khmer}', "");
    Expect(1, 6144, '\P{Is_Block=khmer}', "");
    Expect(0, 6144, '\P{^Is_Block=khmer}', "");
    Expect(1, 6143, '\p{Is_Block=--Khmer}', "");
    Expect(0, 6143, '\p{^Is_Block=--Khmer}', "");
    Expect(0, 6143, '\P{Is_Block=--Khmer}', "");
    Expect(1, 6143, '\P{^Is_Block=--Khmer}', "");
    Expect(0, 6144, '\p{Is_Block=--Khmer}', "");
    Expect(1, 6144, '\p{^Is_Block=--Khmer}', "");
    Expect(1, 6144, '\P{Is_Block=--Khmer}', "");
    Expect(0, 6144, '\P{^Is_Block=--Khmer}', "");
    Error('\p{Is_Blk=--Khmer/a/}');
    Error('\P{Is_Blk=--Khmer/a/}');
    Expect(1, 6143, '\p{Is_Blk=khmer}', "");
    Expect(0, 6143, '\p{^Is_Blk=khmer}', "");
    Expect(0, 6143, '\P{Is_Blk=khmer}', "");
    Expect(1, 6143, '\P{^Is_Blk=khmer}', "");
    Expect(0, 6144, '\p{Is_Blk=khmer}', "");
    Expect(1, 6144, '\p{^Is_Blk=khmer}', "");
    Expect(1, 6144, '\P{Is_Blk=khmer}', "");
    Expect(0, 6144, '\P{^Is_Blk=khmer}', "");
    Expect(1, 6143, '\p{Is_Blk=-Khmer}', "");
    Expect(0, 6143, '\p{^Is_Blk=-Khmer}', "");
    Expect(0, 6143, '\P{Is_Blk=-Khmer}', "");
    Expect(1, 6143, '\P{^Is_Blk=-Khmer}', "");
    Expect(0, 6144, '\p{Is_Blk=-Khmer}', "");
    Expect(1, 6144, '\p{^Is_Blk=-Khmer}', "");
    Expect(1, 6144, '\P{Is_Blk=-Khmer}', "");
    Expect(0, 6144, '\P{^Is_Blk=-Khmer}', "");
    Error('\p{Block=_:=Khmer_Symbols}');
    Error('\P{Block=_:=Khmer_Symbols}');
    Expect(1, 6655, '\p{Block=:\AKhmer_Symbols\z:}', "");;
    Expect(0, 6656, '\p{Block=:\AKhmer_Symbols\z:}', "");;
    Expect(1, 6655, '\p{Block=khmersymbols}', "");
    Expect(0, 6655, '\p{^Block=khmersymbols}', "");
    Expect(0, 6655, '\P{Block=khmersymbols}', "");
    Expect(1, 6655, '\P{^Block=khmersymbols}', "");
    Expect(0, 6656, '\p{Block=khmersymbols}', "");
    Expect(1, 6656, '\p{^Block=khmersymbols}', "");
    Expect(1, 6656, '\P{Block=khmersymbols}', "");
    Expect(0, 6656, '\P{^Block=khmersymbols}', "");
    Expect(1, 6655, '\p{Block=:\Akhmersymbols\z:}', "");;
    Expect(0, 6656, '\p{Block=:\Akhmersymbols\z:}', "");;
    Expect(1, 6655, '\p{Block=_Khmer_SYMBOLS}', "");
    Expect(0, 6655, '\p{^Block=_Khmer_SYMBOLS}', "");
    Expect(0, 6655, '\P{Block=_Khmer_SYMBOLS}', "");
    Expect(1, 6655, '\P{^Block=_Khmer_SYMBOLS}', "");
    Expect(0, 6656, '\p{Block=_Khmer_SYMBOLS}', "");
    Expect(1, 6656, '\p{^Block=_Khmer_SYMBOLS}', "");
    Expect(1, 6656, '\P{Block=_Khmer_SYMBOLS}', "");
    Expect(0, 6656, '\P{^Block=_Khmer_SYMBOLS}', "");
    Error('\p{Blk=:=_ KHMER_SYMBOLS}');
    Error('\P{Blk=:=_ KHMER_SYMBOLS}');
    Expect(1, 6655, '\p{Blk=:\AKhmer_Symbols\z:}', "");;
    Expect(0, 6656, '\p{Blk=:\AKhmer_Symbols\z:}', "");;
    Expect(1, 6655, '\p{Blk=khmersymbols}', "");
    Expect(0, 6655, '\p{^Blk=khmersymbols}', "");
    Expect(0, 6655, '\P{Blk=khmersymbols}', "");
    Expect(1, 6655, '\P{^Blk=khmersymbols}', "");
    Expect(0, 6656, '\p{Blk=khmersymbols}', "");
    Expect(1, 6656, '\p{^Blk=khmersymbols}', "");
    Expect(1, 6656, '\P{Blk=khmersymbols}', "");
    Expect(0, 6656, '\P{^Blk=khmersymbols}', "");
    Expect(1, 6655, '\p{Blk=:\Akhmersymbols\z:}', "");;
    Expect(0, 6656, '\p{Blk=:\Akhmersymbols\z:}', "");;
    Expect(1, 6655, '\p{Blk:_Khmer_Symbols}', "");
    Expect(0, 6655, '\p{^Blk:_Khmer_Symbols}', "");
    Expect(0, 6655, '\P{Blk:_Khmer_Symbols}', "");
    Expect(1, 6655, '\P{^Blk:_Khmer_Symbols}', "");
    Expect(0, 6656, '\p{Blk:_Khmer_Symbols}', "");
    Expect(1, 6656, '\p{^Blk:_Khmer_Symbols}', "");
    Expect(1, 6656, '\P{Blk:_Khmer_Symbols}', "");
    Expect(0, 6656, '\P{^Blk:_Khmer_Symbols}', "");
    Error('\p{Is_Block=-:=Khmer_Symbols}');
    Error('\P{Is_Block=-:=Khmer_Symbols}');
    Expect(1, 6655, '\p{Is_Block: khmersymbols}', "");
    Expect(0, 6655, '\p{^Is_Block: khmersymbols}', "");
    Expect(0, 6655, '\P{Is_Block: khmersymbols}', "");
    Expect(1, 6655, '\P{^Is_Block: khmersymbols}', "");
    Expect(0, 6656, '\p{Is_Block: khmersymbols}', "");
    Expect(1, 6656, '\p{^Is_Block: khmersymbols}', "");
    Expect(1, 6656, '\P{Is_Block: khmersymbols}', "");
    Expect(0, 6656, '\P{^Is_Block: khmersymbols}', "");
    Expect(1, 6655, '\p{Is_Block=_khmer_symbols}', "");
    Expect(0, 6655, '\p{^Is_Block=_khmer_symbols}', "");
    Expect(0, 6655, '\P{Is_Block=_khmer_symbols}', "");
    Expect(1, 6655, '\P{^Is_Block=_khmer_symbols}', "");
    Expect(0, 6656, '\p{Is_Block=_khmer_symbols}', "");
    Expect(1, 6656, '\p{^Is_Block=_khmer_symbols}', "");
    Expect(1, 6656, '\P{Is_Block=_khmer_symbols}', "");
    Expect(0, 6656, '\P{^Is_Block=_khmer_symbols}', "");
    Error('\p{Is_Blk:   /a/ -KHMER_SYMBOLS}');
    Error('\P{Is_Blk:   /a/ -KHMER_SYMBOLS}');
    Expect(1, 6655, '\p{Is_Blk:khmersymbols}', "");
    Expect(0, 6655, '\p{^Is_Blk:khmersymbols}', "");
    Expect(0, 6655, '\P{Is_Blk:khmersymbols}', "");
    Expect(1, 6655, '\P{^Is_Blk:khmersymbols}', "");
    Expect(0, 6656, '\p{Is_Blk:khmersymbols}', "");
    Expect(1, 6656, '\p{^Is_Blk:khmersymbols}', "");
    Expect(1, 6656, '\P{Is_Blk:khmersymbols}', "");
    Expect(0, 6656, '\P{^Is_Blk:khmersymbols}', "");
    Expect(1, 6655, '\p{Is_Blk:	 Khmer_Symbols}', "");
    Expect(0, 6655, '\p{^Is_Blk:	 Khmer_Symbols}', "");
    Expect(0, 6655, '\P{Is_Blk:	 Khmer_Symbols}', "");
    Expect(1, 6655, '\P{^Is_Blk:	 Khmer_Symbols}', "");
    Expect(0, 6656, '\p{Is_Blk:	 Khmer_Symbols}', "");
    Expect(1, 6656, '\p{^Is_Blk:	 Khmer_Symbols}', "");
    Expect(1, 6656, '\P{Is_Blk:	 Khmer_Symbols}', "");
    Expect(0, 6656, '\P{^Is_Blk:	 Khmer_Symbols}', "");
    Error('\p{Block=-_khojki:=}');
    Error('\P{Block=-_khojki:=}');
    Expect(1, 70223, '\p{Block=:\AKhojki\z:}', "");;
    Expect(0, 70224, '\p{Block=:\AKhojki\z:}', "");;
    Expect(1, 70223, '\p{Block=khojki}', "");
    Expect(0, 70223, '\p{^Block=khojki}', "");
    Expect(0, 70223, '\P{Block=khojki}', "");
    Expect(1, 70223, '\P{^Block=khojki}', "");
    Expect(0, 70224, '\p{Block=khojki}', "");
    Expect(1, 70224, '\p{^Block=khojki}', "");
    Expect(1, 70224, '\P{Block=khojki}', "");
    Expect(0, 70224, '\P{^Block=khojki}', "");
    Expect(1, 70223, '\p{Block=:\Akhojki\z:}', "");;
    Expect(0, 70224, '\p{Block=:\Akhojki\z:}', "");;
    Expect(1, 70223, '\p{Block=- Khojki}', "");
    Expect(0, 70223, '\p{^Block=- Khojki}', "");
    Expect(0, 70223, '\P{Block=- Khojki}', "");
    Expect(1, 70223, '\P{^Block=- Khojki}', "");
    Expect(0, 70224, '\p{Block=- Khojki}', "");
    Expect(1, 70224, '\p{^Block=- Khojki}', "");
    Expect(1, 70224, '\P{Block=- Khojki}', "");
    Expect(0, 70224, '\P{^Block=- Khojki}', "");
    Error('\p{Blk=	 khojki:=}');
    Error('\P{Blk=	 khojki:=}');
    Expect(1, 70223, '\p{Blk=:\AKhojki\z:}', "");;
    Expect(0, 70224, '\p{Blk=:\AKhojki\z:}', "");;
    Expect(1, 70223, '\p{Blk=khojki}', "");
    Expect(0, 70223, '\p{^Blk=khojki}', "");
    Expect(0, 70223, '\P{Blk=khojki}', "");
    Expect(1, 70223, '\P{^Blk=khojki}', "");
    Expect(0, 70224, '\p{Blk=khojki}', "");
    Expect(1, 70224, '\p{^Blk=khojki}', "");
    Expect(1, 70224, '\P{Blk=khojki}', "");
    Expect(0, 70224, '\P{^Blk=khojki}', "");
    Expect(1, 70223, '\p{Blk=:\Akhojki\z:}', "");;
    Expect(0, 70224, '\p{Blk=:\Akhojki\z:}', "");;
    Expect(1, 70223, '\p{Blk=-Khojki}', "");
    Expect(0, 70223, '\p{^Blk=-Khojki}', "");
    Expect(0, 70223, '\P{Blk=-Khojki}', "");
    Expect(1, 70223, '\P{^Blk=-Khojki}', "");
    Expect(0, 70224, '\p{Blk=-Khojki}', "");
    Expect(1, 70224, '\p{^Blk=-Khojki}', "");
    Expect(1, 70224, '\P{Blk=-Khojki}', "");
    Expect(0, 70224, '\P{^Blk=-Khojki}', "");
    Error('\p{Is_Block=:=- Khojki}');
    Error('\P{Is_Block=:=- Khojki}');
    Expect(1, 70223, '\p{Is_Block=khojki}', "");
    Expect(0, 70223, '\p{^Is_Block=khojki}', "");
    Expect(0, 70223, '\P{Is_Block=khojki}', "");
    Expect(1, 70223, '\P{^Is_Block=khojki}', "");
    Expect(0, 70224, '\p{Is_Block=khojki}', "");
    Expect(1, 70224, '\p{^Is_Block=khojki}', "");
    Expect(1, 70224, '\P{Is_Block=khojki}', "");
    Expect(0, 70224, '\P{^Is_Block=khojki}', "");
    Expect(1, 70223, '\p{Is_Block=  Khojki}', "");
    Expect(0, 70223, '\p{^Is_Block=  Khojki}', "");
    Expect(0, 70223, '\P{Is_Block=  Khojki}', "");
    Expect(1, 70223, '\P{^Is_Block=  Khojki}', "");
    Expect(0, 70224, '\p{Is_Block=  Khojki}', "");
    Expect(1, 70224, '\p{^Is_Block=  Khojki}', "");
    Expect(1, 70224, '\P{Is_Block=  Khojki}', "");
    Expect(0, 70224, '\P{^Is_Block=  Khojki}', "");
    Error('\p{Is_Blk:	-_Khojki:=}');
    Error('\P{Is_Blk:	-_Khojki:=}');
    Expect(1, 70223, '\p{Is_Blk=khojki}', "");
    Expect(0, 70223, '\p{^Is_Blk=khojki}', "");
    Expect(0, 70223, '\P{Is_Blk=khojki}', "");
    Expect(1, 70223, '\P{^Is_Blk=khojki}', "");
    Expect(0, 70224, '\p{Is_Blk=khojki}', "");
    Expect(1, 70224, '\p{^Is_Blk=khojki}', "");
    Expect(1, 70224, '\P{Is_Blk=khojki}', "");
    Expect(0, 70224, '\P{^Is_Blk=khojki}', "");
    Expect(1, 70223, '\p{Is_Blk=	Khojki}', "");
    Expect(0, 70223, '\p{^Is_Blk=	Khojki}', "");
    Expect(0, 70223, '\P{Is_Blk=	Khojki}', "");
    Expect(1, 70223, '\P{^Is_Blk=	Khojki}', "");
    Expect(0, 70224, '\p{Is_Blk=	Khojki}', "");
    Expect(1, 70224, '\p{^Is_Blk=	Khojki}', "");
    Expect(1, 70224, '\P{Is_Blk=	Khojki}', "");
    Expect(0, 70224, '\P{^Is_Blk=	Khojki}', "");
    Error('\p{Block=-_khudawadi/a/}');
    Error('\P{Block=-_khudawadi/a/}');
    Expect(1, 70399, '\p{Block=:\AKhudawadi\z:}', "");;
    Expect(0, 70400, '\p{Block=:\AKhudawadi\z:}', "");;
    Expect(1, 70399, '\p{Block: khudawadi}', "");
    Expect(0, 70399, '\p{^Block: khudawadi}', "");
    Expect(0, 70399, '\P{Block: khudawadi}', "");
    Expect(1, 70399, '\P{^Block: khudawadi}', "");
    Expect(0, 70400, '\p{Block: khudawadi}', "");
    Expect(1, 70400, '\p{^Block: khudawadi}', "");
    Expect(1, 70400, '\P{Block: khudawadi}', "");
    Expect(0, 70400, '\P{^Block: khudawadi}', "");
    Expect(1, 70399, '\p{Block=:\Akhudawadi\z:}', "");;
    Expect(0, 70400, '\p{Block=:\Akhudawadi\z:}', "");;
    Expect(1, 70399, '\p{Block=_ khudawadi}', "");
    Expect(0, 70399, '\p{^Block=_ khudawadi}', "");
    Expect(0, 70399, '\P{Block=_ khudawadi}', "");
    Expect(1, 70399, '\P{^Block=_ khudawadi}', "");
    Expect(0, 70400, '\p{Block=_ khudawadi}', "");
    Expect(1, 70400, '\p{^Block=_ khudawadi}', "");
    Expect(1, 70400, '\P{Block=_ khudawadi}', "");
    Expect(0, 70400, '\P{^Block=_ khudawadi}', "");
    Error('\p{Blk:   _ khudawadi/a/}');
    Error('\P{Blk:   _ khudawadi/a/}');
    Expect(1, 70399, '\p{Blk=:\AKhudawadi\z:}', "");;
    Expect(0, 70400, '\p{Blk=:\AKhudawadi\z:}', "");;
    Expect(1, 70399, '\p{Blk=khudawadi}', "");
    Expect(0, 70399, '\p{^Blk=khudawadi}', "");
    Expect(0, 70399, '\P{Blk=khudawadi}', "");
    Expect(1, 70399, '\P{^Blk=khudawadi}', "");
    Expect(0, 70400, '\p{Blk=khudawadi}', "");
    Expect(1, 70400, '\p{^Blk=khudawadi}', "");
    Expect(1, 70400, '\P{Blk=khudawadi}', "");
    Expect(0, 70400, '\P{^Blk=khudawadi}', "");
    Expect(1, 70399, '\p{Blk=:\Akhudawadi\z:}', "");;
    Expect(0, 70400, '\p{Blk=:\Akhudawadi\z:}', "");;
    Expect(1, 70399, '\p{Blk= khudawadi}', "");
    Expect(0, 70399, '\p{^Blk= khudawadi}', "");
    Expect(0, 70399, '\P{Blk= khudawadi}', "");
    Expect(1, 70399, '\P{^Blk= khudawadi}', "");
    Expect(0, 70400, '\p{Blk= khudawadi}', "");
    Expect(1, 70400, '\p{^Blk= khudawadi}', "");
    Expect(1, 70400, '\P{Blk= khudawadi}', "");
    Expect(0, 70400, '\P{^Blk= khudawadi}', "");
    Error('\p{Is_Block=_khudawadi/a/}');
    Error('\P{Is_Block=_khudawadi/a/}');
    Expect(1, 70399, '\p{Is_Block=khudawadi}', "");
    Expect(0, 70399, '\p{^Is_Block=khudawadi}', "");
    Expect(0, 70399, '\P{Is_Block=khudawadi}', "");
    Expect(1, 70399, '\P{^Is_Block=khudawadi}', "");
    Expect(0, 70400, '\p{Is_Block=khudawadi}', "");
    Expect(1, 70400, '\p{^Is_Block=khudawadi}', "");
    Expect(1, 70400, '\P{Is_Block=khudawadi}', "");
    Expect(0, 70400, '\P{^Is_Block=khudawadi}', "");
    Expect(1, 70399, '\p{Is_Block=_KHUDAWADI}', "");
    Expect(0, 70399, '\p{^Is_Block=_KHUDAWADI}', "");
    Expect(0, 70399, '\P{Is_Block=_KHUDAWADI}', "");
    Expect(1, 70399, '\P{^Is_Block=_KHUDAWADI}', "");
    Expect(0, 70400, '\p{Is_Block=_KHUDAWADI}', "");
    Expect(1, 70400, '\p{^Is_Block=_KHUDAWADI}', "");
    Expect(1, 70400, '\P{Is_Block=_KHUDAWADI}', "");
    Expect(0, 70400, '\P{^Is_Block=_KHUDAWADI}', "");
    Error('\p{Is_Blk=:=KHUDAWADI}');
    Error('\P{Is_Blk=:=KHUDAWADI}');
    Expect(1, 70399, '\p{Is_Blk=khudawadi}', "");
    Expect(0, 70399, '\p{^Is_Blk=khudawadi}', "");
    Expect(0, 70399, '\P{Is_Blk=khudawadi}', "");
    Expect(1, 70399, '\P{^Is_Blk=khudawadi}', "");
    Expect(0, 70400, '\p{Is_Blk=khudawadi}', "");
    Expect(1, 70400, '\p{^Is_Blk=khudawadi}', "");
    Expect(1, 70400, '\P{Is_Blk=khudawadi}', "");
    Expect(0, 70400, '\P{^Is_Blk=khudawadi}', "");
    Expect(1, 70399, '\p{Is_Blk=  khudawadi}', "");
    Expect(0, 70399, '\p{^Is_Blk=  khudawadi}', "");
    Expect(0, 70399, '\P{Is_Blk=  khudawadi}', "");
    Expect(1, 70399, '\P{^Is_Blk=  khudawadi}', "");
    Expect(0, 70400, '\p{Is_Blk=  khudawadi}', "");
    Expect(1, 70400, '\p{^Is_Blk=  khudawadi}', "");
    Expect(1, 70400, '\P{Is_Blk=  khudawadi}', "");
    Expect(0, 70400, '\P{^Is_Blk=  khudawadi}', "");
    Error('\p{Block=	_lao/a/}');
    Error('\P{Block=	_lao/a/}');
    Expect(1, 3839, '\p{Block=:\ALao\z:}', "");;
    Expect(0, 3840, '\p{Block=:\ALao\z:}', "");;
    Expect(1, 3839, '\p{Block=lao}', "");
    Expect(0, 3839, '\p{^Block=lao}', "");
    Expect(0, 3839, '\P{Block=lao}', "");
    Expect(1, 3839, '\P{^Block=lao}', "");
    Expect(0, 3840, '\p{Block=lao}', "");
    Expect(1, 3840, '\p{^Block=lao}', "");
    Expect(1, 3840, '\P{Block=lao}', "");
    Expect(0, 3840, '\P{^Block=lao}', "");
    Expect(1, 3839, '\p{Block=:\Alao\z:}', "");;
    Expect(0, 3840, '\p{Block=:\Alao\z:}', "");;
    Expect(1, 3839, '\p{Block=  LAO}', "");
    Expect(0, 3839, '\p{^Block=  LAO}', "");
    Expect(0, 3839, '\P{Block=  LAO}', "");
    Expect(1, 3839, '\P{^Block=  LAO}', "");
    Expect(0, 3840, '\p{Block=  LAO}', "");
    Expect(1, 3840, '\p{^Block=  LAO}', "");
    Expect(1, 3840, '\P{Block=  LAO}', "");
    Expect(0, 3840, '\P{^Block=  LAO}', "");
    Error('\p{Blk=--Lao:=}');
    Error('\P{Blk=--Lao:=}');
    Expect(1, 3839, '\p{Blk=:\ALao\z:}', "");;
    Expect(0, 3840, '\p{Blk=:\ALao\z:}', "");;
    Expect(1, 3839, '\p{Blk=lao}', "");
    Expect(0, 3839, '\p{^Blk=lao}', "");
    Expect(0, 3839, '\P{Blk=lao}', "");
    Expect(1, 3839, '\P{^Blk=lao}', "");
    Expect(0, 3840, '\p{Blk=lao}', "");
    Expect(1, 3840, '\p{^Blk=lao}', "");
    Expect(1, 3840, '\P{Blk=lao}', "");
    Expect(0, 3840, '\P{^Blk=lao}', "");
    Expect(1, 3839, '\p{Blk=:\Alao\z:}', "");;
    Expect(0, 3840, '\p{Blk=:\Alao\z:}', "");;
    Expect(1, 3839, '\p{Blk=-Lao}', "");
    Expect(0, 3839, '\p{^Blk=-Lao}', "");
    Expect(0, 3839, '\P{Blk=-Lao}', "");
    Expect(1, 3839, '\P{^Blk=-Lao}', "");
    Expect(0, 3840, '\p{Blk=-Lao}', "");
    Expect(1, 3840, '\p{^Blk=-Lao}', "");
    Expect(1, 3840, '\P{Blk=-Lao}', "");
    Expect(0, 3840, '\P{^Blk=-Lao}', "");
    Error('\p{Is_Block=-	lao/a/}');
    Error('\P{Is_Block=-	lao/a/}');
    Expect(1, 3839, '\p{Is_Block=lao}', "");
    Expect(0, 3839, '\p{^Is_Block=lao}', "");
    Expect(0, 3839, '\P{Is_Block=lao}', "");
    Expect(1, 3839, '\P{^Is_Block=lao}', "");
    Expect(0, 3840, '\p{Is_Block=lao}', "");
    Expect(1, 3840, '\p{^Is_Block=lao}', "");
    Expect(1, 3840, '\P{Is_Block=lao}', "");
    Expect(0, 3840, '\P{^Is_Block=lao}', "");
    Expect(1, 3839, '\p{Is_Block: 	Lao}', "");
    Expect(0, 3839, '\p{^Is_Block: 	Lao}', "");
    Expect(0, 3839, '\P{Is_Block: 	Lao}', "");
    Expect(1, 3839, '\P{^Is_Block: 	Lao}', "");
    Expect(0, 3840, '\p{Is_Block: 	Lao}', "");
    Expect(1, 3840, '\p{^Is_Block: 	Lao}', "");
    Expect(1, 3840, '\P{Is_Block: 	Lao}', "");
    Expect(0, 3840, '\P{^Is_Block: 	Lao}', "");
    Error('\p{Is_Blk=-/a/lao}');
    Error('\P{Is_Blk=-/a/lao}');
    Expect(1, 3839, '\p{Is_Blk=lao}', "");
    Expect(0, 3839, '\p{^Is_Blk=lao}', "");
    Expect(0, 3839, '\P{Is_Blk=lao}', "");
    Expect(1, 3839, '\P{^Is_Blk=lao}', "");
    Expect(0, 3840, '\p{Is_Blk=lao}', "");
    Expect(1, 3840, '\p{^Is_Blk=lao}', "");
    Expect(1, 3840, '\P{Is_Blk=lao}', "");
    Expect(0, 3840, '\P{^Is_Blk=lao}', "");
    Expect(1, 3839, '\p{Is_Blk: 		lao}', "");
    Expect(0, 3839, '\p{^Is_Blk: 		lao}', "");
    Expect(0, 3839, '\P{Is_Blk: 		lao}', "");
    Expect(1, 3839, '\P{^Is_Blk: 		lao}', "");
    Expect(0, 3840, '\p{Is_Blk: 		lao}', "");
    Expect(1, 3840, '\p{^Is_Blk: 		lao}', "");
    Expect(1, 3840, '\P{Is_Blk: 		lao}', "");
    Expect(0, 3840, '\P{^Is_Blk: 		lao}', "");
    Error('\p{Block=:=latin_1_Supplement}');
    Error('\P{Block=:=latin_1_Supplement}');
    Expect(1, 255, '\p{Block=:\ALatin_1_Supplement\z:}', "");;
    Expect(0, 256, '\p{Block=:\ALatin_1_Supplement\z:}', "");;
    Expect(1, 255, '\p{Block=latin1supplement}', "");
    Expect(0, 255, '\p{^Block=latin1supplement}', "");
    Expect(0, 255, '\P{Block=latin1supplement}', "");
    Expect(1, 255, '\P{^Block=latin1supplement}', "");
    Expect(0, 256, '\p{Block=latin1supplement}', "");
    Expect(1, 256, '\p{^Block=latin1supplement}', "");
    Expect(1, 256, '\P{Block=latin1supplement}', "");
    Expect(0, 256, '\P{^Block=latin1supplement}', "");
    Expect(1, 255, '\p{Block=:\Alatin1supplement\z:}', "");;
    Expect(0, 256, '\p{Block=:\Alatin1supplement\z:}', "");;
    Expect(1, 255, '\p{Block= LATIN_1_SUPPLEMENT}', "");
    Expect(0, 255, '\p{^Block= LATIN_1_SUPPLEMENT}', "");
    Expect(0, 255, '\P{Block= LATIN_1_SUPPLEMENT}', "");
    Expect(1, 255, '\P{^Block= LATIN_1_SUPPLEMENT}', "");
    Expect(0, 256, '\p{Block= LATIN_1_SUPPLEMENT}', "");
    Expect(1, 256, '\p{^Block= LATIN_1_SUPPLEMENT}', "");
    Expect(1, 256, '\P{Block= LATIN_1_SUPPLEMENT}', "");
    Expect(0, 256, '\P{^Block= LATIN_1_SUPPLEMENT}', "");
    Error('\p{Blk=/a/_ latin_1_sup}');
    Error('\P{Blk=/a/_ latin_1_sup}');
    Expect(1, 255, '\p{Blk=:\ALatin_1_Sup\z:}', "");;
    Expect(0, 256, '\p{Blk=:\ALatin_1_Sup\z:}', "");;
    Expect(1, 255, '\p{Blk=latin1sup}', "");
    Expect(0, 255, '\p{^Blk=latin1sup}', "");
    Expect(0, 255, '\P{Blk=latin1sup}', "");
    Expect(1, 255, '\P{^Blk=latin1sup}', "");
    Expect(0, 256, '\p{Blk=latin1sup}', "");
    Expect(1, 256, '\p{^Blk=latin1sup}', "");
    Expect(1, 256, '\P{Blk=latin1sup}', "");
    Expect(0, 256, '\P{^Blk=latin1sup}', "");
    Expect(1, 255, '\p{Blk=:\Alatin1sup\z:}', "");;
    Expect(0, 256, '\p{Blk=:\Alatin1sup\z:}', "");;
    Expect(1, 255, '\p{Blk=latin_1_Sup}', "");
    Expect(0, 255, '\p{^Blk=latin_1_Sup}', "");
    Expect(0, 255, '\P{Blk=latin_1_Sup}', "");
    Expect(1, 255, '\P{^Blk=latin_1_Sup}', "");
    Expect(0, 256, '\p{Blk=latin_1_Sup}', "");
    Expect(1, 256, '\p{^Blk=latin_1_Sup}', "");
    Expect(1, 256, '\P{Blk=latin_1_Sup}', "");
    Expect(0, 256, '\P{^Blk=latin_1_Sup}', "");
    Error('\p{Is_Block=_-LATIN_1:=}');
    Error('\P{Is_Block=_-LATIN_1:=}');
    Expect(1, 255, '\p{Is_Block=latin1}', "");
    Expect(0, 255, '\p{^Is_Block=latin1}', "");
    Expect(0, 255, '\P{Is_Block=latin1}', "");
    Expect(1, 255, '\P{^Is_Block=latin1}', "");
    Expect(0, 256, '\p{Is_Block=latin1}', "");
    Expect(1, 256, '\p{^Is_Block=latin1}', "");
    Expect(1, 256, '\P{Is_Block=latin1}', "");
    Expect(0, 256, '\P{^Is_Block=latin1}', "");
    Expect(1, 255, '\p{Is_Block=Latin_1}', "");
    Expect(0, 255, '\p{^Is_Block=Latin_1}', "");
    Expect(0, 255, '\P{Is_Block=Latin_1}', "");
    Expect(1, 255, '\P{^Is_Block=Latin_1}', "");
    Expect(0, 256, '\p{Is_Block=Latin_1}', "");
    Expect(1, 256, '\p{^Is_Block=Latin_1}', "");
    Expect(1, 256, '\P{Is_Block=Latin_1}', "");
    Expect(0, 256, '\P{^Is_Block=Latin_1}', "");
    Error('\p{Is_Blk=:=latin_1_Supplement}');
    Error('\P{Is_Blk=:=latin_1_Supplement}');
    Expect(1, 255, '\p{Is_Blk=latin1supplement}', "");
    Expect(0, 255, '\p{^Is_Blk=latin1supplement}', "");
    Expect(0, 255, '\P{Is_Blk=latin1supplement}', "");
    Expect(1, 255, '\P{^Is_Blk=latin1supplement}', "");
    Expect(0, 256, '\p{Is_Blk=latin1supplement}', "");
    Expect(1, 256, '\p{^Is_Blk=latin1supplement}', "");
    Expect(1, 256, '\P{Is_Blk=latin1supplement}', "");
    Expect(0, 256, '\P{^Is_Blk=latin1supplement}', "");
    Expect(1, 255, '\p{Is_Blk= 	LATIN_1_Supplement}', "");
    Expect(0, 255, '\p{^Is_Blk= 	LATIN_1_Supplement}', "");
    Expect(0, 255, '\P{Is_Blk= 	LATIN_1_Supplement}', "");
    Expect(1, 255, '\P{^Is_Blk= 	LATIN_1_Supplement}', "");
    Expect(0, 256, '\p{Is_Blk= 	LATIN_1_Supplement}', "");
    Expect(1, 256, '\p{^Is_Blk= 	LATIN_1_Supplement}', "");
    Expect(1, 256, '\P{Is_Blk= 	LATIN_1_Supplement}', "");
    Expect(0, 256, '\P{^Is_Blk= 	LATIN_1_Supplement}', "");
    Error('\p{Block=	/a/Latin_Extended_A}');
    Error('\P{Block=	/a/Latin_Extended_A}');
    Expect(1, 383, '\p{Block=:\ALatin_Extended_A\z:}', "");;
    Expect(0, 384, '\p{Block=:\ALatin_Extended_A\z:}', "");;
    Expect(1, 383, '\p{Block:	latinextendeda}', "");
    Expect(0, 383, '\p{^Block:	latinextendeda}', "");
    Expect(0, 383, '\P{Block:	latinextendeda}', "");
    Expect(1, 383, '\P{^Block:	latinextendeda}', "");
    Expect(0, 384, '\p{Block:	latinextendeda}', "");
    Expect(1, 384, '\p{^Block:	latinextendeda}', "");
    Expect(1, 384, '\P{Block:	latinextendeda}', "");
    Expect(0, 384, '\P{^Block:	latinextendeda}', "");
    Expect(1, 383, '\p{Block=:\Alatinextendeda\z:}', "");;
    Expect(0, 384, '\p{Block=:\Alatinextendeda\z:}', "");;
    Expect(1, 383, '\p{Block= 	Latin_Extended_A}', "");
    Expect(0, 383, '\p{^Block= 	Latin_Extended_A}', "");
    Expect(0, 383, '\P{Block= 	Latin_Extended_A}', "");
    Expect(1, 383, '\P{^Block= 	Latin_Extended_A}', "");
    Expect(0, 384, '\p{Block= 	Latin_Extended_A}', "");
    Expect(1, 384, '\p{^Block= 	Latin_Extended_A}', "");
    Expect(1, 384, '\P{Block= 	Latin_Extended_A}', "");
    Expect(0, 384, '\P{^Block= 	Latin_Extended_A}', "");
    Error('\p{Blk=_:=latin_EXT_a}');
    Error('\P{Blk=_:=latin_EXT_a}');
    Expect(1, 383, '\p{Blk=:\ALatin_Ext_A\z:}', "");;
    Expect(0, 384, '\p{Blk=:\ALatin_Ext_A\z:}', "");;
    Expect(1, 383, '\p{Blk=latinexta}', "");
    Expect(0, 383, '\p{^Blk=latinexta}', "");
    Expect(0, 383, '\P{Blk=latinexta}', "");
    Expect(1, 383, '\P{^Blk=latinexta}', "");
    Expect(0, 384, '\p{Blk=latinexta}', "");
    Expect(1, 384, '\p{^Blk=latinexta}', "");
    Expect(1, 384, '\P{Blk=latinexta}', "");
    Expect(0, 384, '\P{^Blk=latinexta}', "");
    Expect(1, 383, '\p{Blk=:\Alatinexta\z:}', "");;
    Expect(0, 384, '\p{Blk=:\Alatinexta\z:}', "");;
    Expect(1, 383, '\p{Blk=- LATIN_EXT_A}', "");
    Expect(0, 383, '\p{^Blk=- LATIN_EXT_A}', "");
    Expect(0, 383, '\P{Blk=- LATIN_EXT_A}', "");
    Expect(1, 383, '\P{^Blk=- LATIN_EXT_A}', "");
    Expect(0, 384, '\p{Blk=- LATIN_EXT_A}', "");
    Expect(1, 384, '\p{^Blk=- LATIN_EXT_A}', "");
    Expect(1, 384, '\P{Blk=- LATIN_EXT_A}', "");
    Expect(0, 384, '\P{^Blk=- LATIN_EXT_A}', "");
    Error('\p{Is_Block=_Latin_extended_a:=}');
    Error('\P{Is_Block=_Latin_extended_a:=}');
    Expect(1, 383, '\p{Is_Block=latinextendeda}', "");
    Expect(0, 383, '\p{^Is_Block=latinextendeda}', "");
    Expect(0, 383, '\P{Is_Block=latinextendeda}', "");
    Expect(1, 383, '\P{^Is_Block=latinextendeda}', "");
    Expect(0, 384, '\p{Is_Block=latinextendeda}', "");
    Expect(1, 384, '\p{^Is_Block=latinextendeda}', "");
    Expect(1, 384, '\P{Is_Block=latinextendeda}', "");
    Expect(0, 384, '\P{^Is_Block=latinextendeda}', "");
    Expect(1, 383, '\p{Is_Block=_Latin_Extended_A}', "");
    Expect(0, 383, '\p{^Is_Block=_Latin_Extended_A}', "");
    Expect(0, 383, '\P{Is_Block=_Latin_Extended_A}', "");
    Expect(1, 383, '\P{^Is_Block=_Latin_Extended_A}', "");
    Expect(0, 384, '\p{Is_Block=_Latin_Extended_A}', "");
    Expect(1, 384, '\p{^Is_Block=_Latin_Extended_A}', "");
    Expect(1, 384, '\P{Is_Block=_Latin_Extended_A}', "");
    Expect(0, 384, '\P{^Is_Block=_Latin_Extended_A}', "");
    Error('\p{Is_Blk=/a/_	Latin_ext_A}');
    Error('\P{Is_Blk=/a/_	Latin_ext_A}');
    Expect(1, 383, '\p{Is_Blk=latinexta}', "");
    Expect(0, 383, '\p{^Is_Blk=latinexta}', "");
    Expect(0, 383, '\P{Is_Blk=latinexta}', "");
    Expect(1, 383, '\P{^Is_Blk=latinexta}', "");
    Expect(0, 384, '\p{Is_Blk=latinexta}', "");
    Expect(1, 384, '\p{^Is_Blk=latinexta}', "");
    Expect(1, 384, '\P{Is_Blk=latinexta}', "");
    Expect(0, 384, '\P{^Is_Blk=latinexta}', "");
    Expect(1, 383, '\p{Is_Blk= _Latin_Ext_A}', "");
    Expect(0, 383, '\p{^Is_Blk= _Latin_Ext_A}', "");
    Expect(0, 383, '\P{Is_Blk= _Latin_Ext_A}', "");
    Expect(1, 383, '\P{^Is_Blk= _Latin_Ext_A}', "");
    Expect(0, 384, '\p{Is_Blk= _Latin_Ext_A}', "");
    Expect(1, 384, '\p{^Is_Blk= _Latin_Ext_A}', "");
    Expect(1, 384, '\P{Is_Blk= _Latin_Ext_A}', "");
    Expect(0, 384, '\P{^Is_Blk= _Latin_Ext_A}', "");
    Error('\p{Block=	/a/Latin_Extended_Additional}');
    Error('\P{Block=	/a/Latin_Extended_Additional}');
    Expect(1, 7935, '\p{Block=:\ALatin_Extended_Additional\z:}', "");;
    Expect(0, 7936, '\p{Block=:\ALatin_Extended_Additional\z:}', "");;
    Expect(1, 7935, '\p{Block=latinextendedadditional}', "");
    Expect(0, 7935, '\p{^Block=latinextendedadditional}', "");
    Expect(0, 7935, '\P{Block=latinextendedadditional}', "");
    Expect(1, 7935, '\P{^Block=latinextendedadditional}', "");
    Expect(0, 7936, '\p{Block=latinextendedadditional}', "");
    Expect(1, 7936, '\p{^Block=latinextendedadditional}', "");
    Expect(1, 7936, '\P{Block=latinextendedadditional}', "");
    Expect(0, 7936, '\P{^Block=latinextendedadditional}', "");
    Expect(1, 7935, '\p{Block=:\Alatinextendedadditional\z:}', "");;
    Expect(0, 7936, '\p{Block=:\Alatinextendedadditional\z:}', "");;
    Expect(1, 7935, '\p{Block=-latin_EXTENDED_ADDITIONAL}', "");
    Expect(0, 7935, '\p{^Block=-latin_EXTENDED_ADDITIONAL}', "");
    Expect(0, 7935, '\P{Block=-latin_EXTENDED_ADDITIONAL}', "");
    Expect(1, 7935, '\P{^Block=-latin_EXTENDED_ADDITIONAL}', "");
    Expect(0, 7936, '\p{Block=-latin_EXTENDED_ADDITIONAL}', "");
    Expect(1, 7936, '\p{^Block=-latin_EXTENDED_ADDITIONAL}', "");
    Expect(1, 7936, '\P{Block=-latin_EXTENDED_ADDITIONAL}', "");
    Expect(0, 7936, '\P{^Block=-latin_EXTENDED_ADDITIONAL}', "");
    Error('\p{Blk:-	latin_ext_additional:=}');
    Error('\P{Blk:-	latin_ext_additional:=}');
    Expect(1, 7935, '\p{Blk=:\ALatin_Ext_Additional\z:}', "");;
    Expect(0, 7936, '\p{Blk=:\ALatin_Ext_Additional\z:}', "");;
    Expect(1, 7935, '\p{Blk=latinextadditional}', "");
    Expect(0, 7935, '\p{^Blk=latinextadditional}', "");
    Expect(0, 7935, '\P{Blk=latinextadditional}', "");
    Expect(1, 7935, '\P{^Blk=latinextadditional}', "");
    Expect(0, 7936, '\p{Blk=latinextadditional}', "");
    Expect(1, 7936, '\p{^Blk=latinextadditional}', "");
    Expect(1, 7936, '\P{Blk=latinextadditional}', "");
    Expect(0, 7936, '\P{^Blk=latinextadditional}', "");
    Expect(1, 7935, '\p{Blk=:\Alatinextadditional\z:}', "");;
    Expect(0, 7936, '\p{Blk=:\Alatinextadditional\z:}', "");;
    Expect(1, 7935, '\p{Blk=_	Latin_Ext_Additional}', "");
    Expect(0, 7935, '\p{^Blk=_	Latin_Ext_Additional}', "");
    Expect(0, 7935, '\P{Blk=_	Latin_Ext_Additional}', "");
    Expect(1, 7935, '\P{^Blk=_	Latin_Ext_Additional}', "");
    Expect(0, 7936, '\p{Blk=_	Latin_Ext_Additional}', "");
    Expect(1, 7936, '\p{^Blk=_	Latin_Ext_Additional}', "");
    Expect(1, 7936, '\P{Blk=_	Latin_Ext_Additional}', "");
    Expect(0, 7936, '\P{^Blk=_	Latin_Ext_Additional}', "");
    Error('\p{Is_Block=_:=LATIN_EXTENDED_additional}');
    Error('\P{Is_Block=_:=LATIN_EXTENDED_additional}');
    Expect(1, 7935, '\p{Is_Block=latinextendedadditional}', "");
    Expect(0, 7935, '\p{^Is_Block=latinextendedadditional}', "");
    Expect(0, 7935, '\P{Is_Block=latinextendedadditional}', "");
    Expect(1, 7935, '\P{^Is_Block=latinextendedadditional}', "");
    Expect(0, 7936, '\p{Is_Block=latinextendedadditional}', "");
    Expect(1, 7936, '\p{^Is_Block=latinextendedadditional}', "");
    Expect(1, 7936, '\P{Is_Block=latinextendedadditional}', "");
    Expect(0, 7936, '\P{^Is_Block=latinextendedadditional}', "");
    Expect(1, 7935, '\p{Is_Block=- LATIN_EXTENDED_additional}', "");
    Expect(0, 7935, '\p{^Is_Block=- LATIN_EXTENDED_additional}', "");
    Expect(0, 7935, '\P{Is_Block=- LATIN_EXTENDED_additional}', "");
    Expect(1, 7935, '\P{^Is_Block=- LATIN_EXTENDED_additional}', "");
    Expect(0, 7936, '\p{Is_Block=- LATIN_EXTENDED_additional}', "");
    Expect(1, 7936, '\p{^Is_Block=- LATIN_EXTENDED_additional}', "");
    Expect(1, 7936, '\P{Is_Block=- LATIN_EXTENDED_additional}', "");
    Expect(0, 7936, '\P{^Is_Block=- LATIN_EXTENDED_additional}', "");
    Error('\p{Is_Blk:   	/a/latin_ext_Additional}');
    Error('\P{Is_Blk:   	/a/latin_ext_Additional}');
    Expect(1, 7935, '\p{Is_Blk=latinextadditional}', "");
    Expect(0, 7935, '\p{^Is_Blk=latinextadditional}', "");
    Expect(0, 7935, '\P{Is_Blk=latinextadditional}', "");
    Expect(1, 7935, '\P{^Is_Blk=latinextadditional}', "");
    Expect(0, 7936, '\p{Is_Blk=latinextadditional}', "");
    Expect(1, 7936, '\p{^Is_Blk=latinextadditional}', "");
    Expect(1, 7936, '\P{Is_Blk=latinextadditional}', "");
    Expect(0, 7936, '\P{^Is_Blk=latinextadditional}', "");
    Expect(1, 7935, '\p{Is_Blk= -Latin_EXT_ADDITIONAL}', "");
    Expect(0, 7935, '\p{^Is_Blk= -Latin_EXT_ADDITIONAL}', "");
    Expect(0, 7935, '\P{Is_Blk= -Latin_EXT_ADDITIONAL}', "");
    Expect(1, 7935, '\P{^Is_Blk= -Latin_EXT_ADDITIONAL}', "");
    Expect(0, 7936, '\p{Is_Blk= -Latin_EXT_ADDITIONAL}', "");
    Expect(1, 7936, '\p{^Is_Blk= -Latin_EXT_ADDITIONAL}', "");
    Expect(1, 7936, '\P{Is_Blk= -Latin_EXT_ADDITIONAL}', "");
    Expect(0, 7936, '\P{^Is_Blk= -Latin_EXT_ADDITIONAL}', "");
    Error('\p{Block=__Latin_Extended_B:=}');
    Error('\P{Block=__Latin_Extended_B:=}');
    Expect(1, 591, '\p{Block=:\ALatin_Extended_B\z:}', "");;
    Expect(0, 592, '\p{Block=:\ALatin_Extended_B\z:}', "");;
    Expect(1, 591, '\p{Block=latinextendedb}', "");
    Expect(0, 591, '\p{^Block=latinextendedb}', "");
    Expect(0, 591, '\P{Block=latinextendedb}', "");
    Expect(1, 591, '\P{^Block=latinextendedb}', "");
    Expect(0, 592, '\p{Block=latinextendedb}', "");
    Expect(1, 592, '\p{^Block=latinextendedb}', "");
    Expect(1, 592, '\P{Block=latinextendedb}', "");
    Expect(0, 592, '\P{^Block=latinextendedb}', "");
    Expect(1, 591, '\p{Block=:\Alatinextendedb\z:}', "");;
    Expect(0, 592, '\p{Block=:\Alatinextendedb\z:}', "");;
    Expect(1, 591, '\p{Block=_-latin_Extended_b}', "");
    Expect(0, 591, '\p{^Block=_-latin_Extended_b}', "");
    Expect(0, 591, '\P{Block=_-latin_Extended_b}', "");
    Expect(1, 591, '\P{^Block=_-latin_Extended_b}', "");
    Expect(0, 592, '\p{Block=_-latin_Extended_b}', "");
    Expect(1, 592, '\p{^Block=_-latin_Extended_b}', "");
    Expect(1, 592, '\P{Block=_-latin_Extended_b}', "");
    Expect(0, 592, '\P{^Block=_-latin_Extended_b}', "");
    Error('\p{Blk=_	latin_EXT_b:=}');
    Error('\P{Blk=_	latin_EXT_b:=}');
    Expect(1, 591, '\p{Blk=:\ALatin_Ext_B\z:}', "");;
    Expect(0, 592, '\p{Blk=:\ALatin_Ext_B\z:}', "");;
    Expect(1, 591, '\p{Blk=latinextb}', "");
    Expect(0, 591, '\p{^Blk=latinextb}', "");
    Expect(0, 591, '\P{Blk=latinextb}', "");
    Expect(1, 591, '\P{^Blk=latinextb}', "");
    Expect(0, 592, '\p{Blk=latinextb}', "");
    Expect(1, 592, '\p{^Blk=latinextb}', "");
    Expect(1, 592, '\P{Blk=latinextb}', "");
    Expect(0, 592, '\P{^Blk=latinextb}', "");
    Expect(1, 591, '\p{Blk=:\Alatinextb\z:}', "");;
    Expect(0, 592, '\p{Blk=:\Alatinextb\z:}', "");;
    Expect(1, 591, '\p{Blk=	_Latin_Ext_B}', "");
    Expect(0, 591, '\p{^Blk=	_Latin_Ext_B}', "");
    Expect(0, 591, '\P{Blk=	_Latin_Ext_B}', "");
    Expect(1, 591, '\P{^Blk=	_Latin_Ext_B}', "");
    Expect(0, 592, '\p{Blk=	_Latin_Ext_B}', "");
    Expect(1, 592, '\p{^Blk=	_Latin_Ext_B}', "");
    Expect(1, 592, '\P{Blk=	_Latin_Ext_B}', "");
    Expect(0, 592, '\P{^Blk=	_Latin_Ext_B}', "");
    Error('\p{Is_Block=/a/ 	Latin_Extended_B}');
    Error('\P{Is_Block=/a/ 	Latin_Extended_B}');
    Expect(1, 591, '\p{Is_Block=latinextendedb}', "");
    Expect(0, 591, '\p{^Is_Block=latinextendedb}', "");
    Expect(0, 591, '\P{Is_Block=latinextendedb}', "");
    Expect(1, 591, '\P{^Is_Block=latinextendedb}', "");
    Expect(0, 592, '\p{Is_Block=latinextendedb}', "");
    Expect(1, 592, '\p{^Is_Block=latinextendedb}', "");
    Expect(1, 592, '\P{Is_Block=latinextendedb}', "");
    Expect(0, 592, '\P{^Is_Block=latinextendedb}', "");
    Expect(1, 591, '\p{Is_Block=-_LATIN_Extended_B}', "");
    Expect(0, 591, '\p{^Is_Block=-_LATIN_Extended_B}', "");
    Expect(0, 591, '\P{Is_Block=-_LATIN_Extended_B}', "");
    Expect(1, 591, '\P{^Is_Block=-_LATIN_Extended_B}', "");
    Expect(0, 592, '\p{Is_Block=-_LATIN_Extended_B}', "");
    Expect(1, 592, '\p{^Is_Block=-_LATIN_Extended_B}', "");
    Expect(1, 592, '\P{Is_Block=-_LATIN_Extended_B}', "");
    Expect(0, 592, '\P{^Is_Block=-_LATIN_Extended_B}', "");
    Error('\p{Is_Blk:	_:=latin_Ext_B}');
    Error('\P{Is_Blk:	_:=latin_Ext_B}');
    Expect(1, 591, '\p{Is_Blk=latinextb}', "");
    Expect(0, 591, '\p{^Is_Blk=latinextb}', "");
    Expect(0, 591, '\P{Is_Blk=latinextb}', "");
    Expect(1, 591, '\P{^Is_Blk=latinextb}', "");
    Expect(0, 592, '\p{Is_Blk=latinextb}', "");
    Expect(1, 592, '\p{^Is_Blk=latinextb}', "");
    Expect(1, 592, '\P{Is_Blk=latinextb}', "");
    Expect(0, 592, '\P{^Is_Blk=latinextb}', "");
    Expect(1, 591, '\p{Is_Blk= 	Latin_ext_b}', "");
    Expect(0, 591, '\p{^Is_Blk= 	Latin_ext_b}', "");
    Expect(0, 591, '\P{Is_Blk= 	Latin_ext_b}', "");
    Expect(1, 591, '\P{^Is_Blk= 	Latin_ext_b}', "");
    Expect(0, 592, '\p{Is_Blk= 	Latin_ext_b}', "");
    Expect(1, 592, '\p{^Is_Blk= 	Latin_ext_b}', "");
    Expect(1, 592, '\P{Is_Blk= 	Latin_ext_b}', "");
    Expect(0, 592, '\P{^Is_Blk= 	Latin_ext_b}', "");
    Error('\p{Block=/a/latin_EXTENDED_C}');
    Error('\P{Block=/a/latin_EXTENDED_C}');
    Expect(1, 11391, '\p{Block=:\ALatin_Extended_C\z:}', "");;
    Expect(0, 11392, '\p{Block=:\ALatin_Extended_C\z:}', "");;
    Expect(1, 11391, '\p{Block=latinextendedc}', "");
    Expect(0, 11391, '\p{^Block=latinextendedc}', "");
    Expect(0, 11391, '\P{Block=latinextendedc}', "");
    Expect(1, 11391, '\P{^Block=latinextendedc}', "");
    Expect(0, 11392, '\p{Block=latinextendedc}', "");
    Expect(1, 11392, '\p{^Block=latinextendedc}', "");
    Expect(1, 11392, '\P{Block=latinextendedc}', "");
    Expect(0, 11392, '\P{^Block=latinextendedc}', "");
    Expect(1, 11391, '\p{Block=:\Alatinextendedc\z:}', "");;
    Expect(0, 11392, '\p{Block=:\Alatinextendedc\z:}', "");;
    Expect(1, 11391, '\p{Block=	_LATIN_Extended_C}', "");
    Expect(0, 11391, '\p{^Block=	_LATIN_Extended_C}', "");
    Expect(0, 11391, '\P{Block=	_LATIN_Extended_C}', "");
    Expect(1, 11391, '\P{^Block=	_LATIN_Extended_C}', "");
    Expect(0, 11392, '\p{Block=	_LATIN_Extended_C}', "");
    Expect(1, 11392, '\p{^Block=	_LATIN_Extended_C}', "");
    Expect(1, 11392, '\P{Block=	_LATIN_Extended_C}', "");
    Expect(0, 11392, '\P{^Block=	_LATIN_Extended_C}', "");
    Error('\p{Blk=_ latin_Ext_C:=}');
    Error('\P{Blk=_ latin_Ext_C:=}');
    Expect(1, 11391, '\p{Blk=:\ALatin_Ext_C\z:}', "");;
    Expect(0, 11392, '\p{Blk=:\ALatin_Ext_C\z:}', "");;
    Expect(1, 11391, '\p{Blk:   latinextc}', "");
    Expect(0, 11391, '\p{^Blk:   latinextc}', "");
    Expect(0, 11391, '\P{Blk:   latinextc}', "");
    Expect(1, 11391, '\P{^Blk:   latinextc}', "");
    Expect(0, 11392, '\p{Blk:   latinextc}', "");
    Expect(1, 11392, '\p{^Blk:   latinextc}', "");
    Expect(1, 11392, '\P{Blk:   latinextc}', "");
    Expect(0, 11392, '\P{^Blk:   latinextc}', "");
    Expect(1, 11391, '\p{Blk=:\Alatinextc\z:}', "");;
    Expect(0, 11392, '\p{Blk=:\Alatinextc\z:}', "");;
    Expect(1, 11391, '\p{Blk=_ Latin_EXT_C}', "");
    Expect(0, 11391, '\p{^Blk=_ Latin_EXT_C}', "");
    Expect(0, 11391, '\P{Blk=_ Latin_EXT_C}', "");
    Expect(1, 11391, '\P{^Blk=_ Latin_EXT_C}', "");
    Expect(0, 11392, '\p{Blk=_ Latin_EXT_C}', "");
    Expect(1, 11392, '\p{^Blk=_ Latin_EXT_C}', "");
    Expect(1, 11392, '\P{Blk=_ Latin_EXT_C}', "");
    Expect(0, 11392, '\P{^Blk=_ Latin_EXT_C}', "");
    Error('\p{Is_Block:   :=Latin_extended_C}');
    Error('\P{Is_Block:   :=Latin_extended_C}');
    Expect(1, 11391, '\p{Is_Block=latinextendedc}', "");
    Expect(0, 11391, '\p{^Is_Block=latinextendedc}', "");
    Expect(0, 11391, '\P{Is_Block=latinextendedc}', "");
    Expect(1, 11391, '\P{^Is_Block=latinextendedc}', "");
    Expect(0, 11392, '\p{Is_Block=latinextendedc}', "");
    Expect(1, 11392, '\p{^Is_Block=latinextendedc}', "");
    Expect(1, 11392, '\P{Is_Block=latinextendedc}', "");
    Expect(0, 11392, '\P{^Is_Block=latinextendedc}', "");
    Expect(1, 11391, '\p{Is_Block=	-Latin_extended_C}', "");
    Expect(0, 11391, '\p{^Is_Block=	-Latin_extended_C}', "");
    Expect(0, 11391, '\P{Is_Block=	-Latin_extended_C}', "");
    Expect(1, 11391, '\P{^Is_Block=	-Latin_extended_C}', "");
    Expect(0, 11392, '\p{Is_Block=	-Latin_extended_C}', "");
    Expect(1, 11392, '\p{^Is_Block=	-Latin_extended_C}', "");
    Expect(1, 11392, '\P{Is_Block=	-Latin_extended_C}', "");
    Expect(0, 11392, '\P{^Is_Block=	-Latin_extended_C}', "");
    Error('\p{Is_Blk=_/a/latin_Ext_C}');
    Error('\P{Is_Blk=_/a/latin_Ext_C}');
    Expect(1, 11391, '\p{Is_Blk=latinextc}', "");
    Expect(0, 11391, '\p{^Is_Blk=latinextc}', "");
    Expect(0, 11391, '\P{Is_Blk=latinextc}', "");
    Expect(1, 11391, '\P{^Is_Blk=latinextc}', "");
    Expect(0, 11392, '\p{Is_Blk=latinextc}', "");
    Expect(1, 11392, '\p{^Is_Blk=latinextc}', "");
    Expect(1, 11392, '\P{Is_Blk=latinextc}', "");
    Expect(0, 11392, '\P{^Is_Blk=latinextc}', "");
    Expect(1, 11391, '\p{Is_Blk=-_Latin_ext_c}', "");
    Expect(0, 11391, '\p{^Is_Blk=-_Latin_ext_c}', "");
    Expect(0, 11391, '\P{Is_Blk=-_Latin_ext_c}', "");
    Expect(1, 11391, '\P{^Is_Blk=-_Latin_ext_c}', "");
    Expect(0, 11392, '\p{Is_Blk=-_Latin_ext_c}', "");
    Expect(1, 11392, '\p{^Is_Blk=-_Latin_ext_c}', "");
    Expect(1, 11392, '\P{Is_Blk=-_Latin_ext_c}', "");
    Expect(0, 11392, '\P{^Is_Blk=-_Latin_ext_c}', "");
    Error('\p{Block=:=		Latin_Extended_d}');
    Error('\P{Block=:=		Latin_Extended_d}');
    Expect(1, 43007, '\p{Block=:\ALatin_Extended_D\z:}', "");;
    Expect(0, 43008, '\p{Block=:\ALatin_Extended_D\z:}', "");;
    Expect(1, 43007, '\p{Block=latinextendedd}', "");
    Expect(0, 43007, '\p{^Block=latinextendedd}', "");
    Expect(0, 43007, '\P{Block=latinextendedd}', "");
    Expect(1, 43007, '\P{^Block=latinextendedd}', "");
    Expect(0, 43008, '\p{Block=latinextendedd}', "");
    Expect(1, 43008, '\p{^Block=latinextendedd}', "");
    Expect(1, 43008, '\P{Block=latinextendedd}', "");
    Expect(0, 43008, '\P{^Block=latinextendedd}', "");
    Expect(1, 43007, '\p{Block=:\Alatinextendedd\z:}', "");;
    Expect(0, 43008, '\p{Block=:\Alatinextendedd\z:}', "");;
    Expect(1, 43007, '\p{Block=_ latin_Extended_D}', "");
    Expect(0, 43007, '\p{^Block=_ latin_Extended_D}', "");
    Expect(0, 43007, '\P{Block=_ latin_Extended_D}', "");
    Expect(1, 43007, '\P{^Block=_ latin_Extended_D}', "");
    Expect(0, 43008, '\p{Block=_ latin_Extended_D}', "");
    Expect(1, 43008, '\p{^Block=_ latin_Extended_D}', "");
    Expect(1, 43008, '\P{Block=_ latin_Extended_D}', "");
    Expect(0, 43008, '\P{^Block=_ latin_Extended_D}', "");
    Error('\p{Blk:/a/ -LATIN_EXT_D}');
    Error('\P{Blk:/a/ -LATIN_EXT_D}');
    Expect(1, 43007, '\p{Blk=:\ALatin_Ext_D\z:}', "");;
    Expect(0, 43008, '\p{Blk=:\ALatin_Ext_D\z:}', "");;
    Expect(1, 43007, '\p{Blk=latinextd}', "");
    Expect(0, 43007, '\p{^Blk=latinextd}', "");
    Expect(0, 43007, '\P{Blk=latinextd}', "");
    Expect(1, 43007, '\P{^Blk=latinextd}', "");
    Expect(0, 43008, '\p{Blk=latinextd}', "");
    Expect(1, 43008, '\p{^Blk=latinextd}', "");
    Expect(1, 43008, '\P{Blk=latinextd}', "");
    Expect(0, 43008, '\P{^Blk=latinextd}', "");
    Expect(1, 43007, '\p{Blk=:\Alatinextd\z:}', "");;
    Expect(0, 43008, '\p{Blk=:\Alatinextd\z:}', "");;
    Expect(1, 43007, '\p{Blk= Latin_ext_D}', "");
    Expect(0, 43007, '\p{^Blk= Latin_ext_D}', "");
    Expect(0, 43007, '\P{Blk= Latin_ext_D}', "");
    Expect(1, 43007, '\P{^Blk= Latin_ext_D}', "");
    Expect(0, 43008, '\p{Blk= Latin_ext_D}', "");
    Expect(1, 43008, '\p{^Blk= Latin_ext_D}', "");
    Expect(1, 43008, '\P{Blk= Latin_ext_D}', "");
    Expect(0, 43008, '\P{^Blk= Latin_ext_D}', "");
    Error('\p{Is_Block=Latin_extended_D/a/}');
    Error('\P{Is_Block=Latin_extended_D/a/}');
    Expect(1, 43007, '\p{Is_Block=latinextendedd}', "");
    Expect(0, 43007, '\p{^Is_Block=latinextendedd}', "");
    Expect(0, 43007, '\P{Is_Block=latinextendedd}', "");
    Expect(1, 43007, '\P{^Is_Block=latinextendedd}', "");
    Expect(0, 43008, '\p{Is_Block=latinextendedd}', "");
    Expect(1, 43008, '\p{^Is_Block=latinextendedd}', "");
    Expect(1, 43008, '\P{Is_Block=latinextendedd}', "");
    Expect(0, 43008, '\P{^Is_Block=latinextendedd}', "");
    Expect(1, 43007, '\p{Is_Block=_LATIN_extended_D}', "");
    Expect(0, 43007, '\p{^Is_Block=_LATIN_extended_D}', "");
    Expect(0, 43007, '\P{Is_Block=_LATIN_extended_D}', "");
    Expect(1, 43007, '\P{^Is_Block=_LATIN_extended_D}', "");
    Expect(0, 43008, '\p{Is_Block=_LATIN_extended_D}', "");
    Expect(1, 43008, '\p{^Is_Block=_LATIN_extended_D}', "");
    Expect(1, 43008, '\P{Is_Block=_LATIN_extended_D}', "");
    Expect(0, 43008, '\P{^Is_Block=_LATIN_extended_D}', "");
    Error('\p{Is_Blk=  Latin_EXT_D:=}');
    Error('\P{Is_Blk=  Latin_EXT_D:=}');
    Expect(1, 43007, '\p{Is_Blk=latinextd}', "");
    Expect(0, 43007, '\p{^Is_Blk=latinextd}', "");
    Expect(0, 43007, '\P{Is_Blk=latinextd}', "");
    Expect(1, 43007, '\P{^Is_Blk=latinextd}', "");
    Expect(0, 43008, '\p{Is_Blk=latinextd}', "");
    Expect(1, 43008, '\p{^Is_Blk=latinextd}', "");
    Expect(1, 43008, '\P{Is_Blk=latinextd}', "");
    Expect(0, 43008, '\P{^Is_Blk=latinextd}', "");
    Expect(1, 43007, '\p{Is_Blk=-	LATIN_ext_d}', "");
    Expect(0, 43007, '\p{^Is_Blk=-	LATIN_ext_d}', "");
    Expect(0, 43007, '\P{Is_Blk=-	LATIN_ext_d}', "");
    Expect(1, 43007, '\P{^Is_Blk=-	LATIN_ext_d}', "");
    Expect(0, 43008, '\p{Is_Blk=-	LATIN_ext_d}', "");
    Expect(1, 43008, '\p{^Is_Blk=-	LATIN_ext_d}', "");
    Expect(1, 43008, '\P{Is_Blk=-	LATIN_ext_d}', "");
    Expect(0, 43008, '\P{^Is_Blk=-	LATIN_ext_d}', "");
    Error('\p{Block=:= 	LATIN_EXTENDED_E}');
    Error('\P{Block=:= 	LATIN_EXTENDED_E}');
    Expect(1, 43887, '\p{Block=:\ALatin_Extended_E\z:}', "");;
    Expect(0, 43888, '\p{Block=:\ALatin_Extended_E\z:}', "");;
    Expect(1, 43887, '\p{Block=latinextendede}', "");
    Expect(0, 43887, '\p{^Block=latinextendede}', "");
    Expect(0, 43887, '\P{Block=latinextendede}', "");
    Expect(1, 43887, '\P{^Block=latinextendede}', "");
    Expect(0, 43888, '\p{Block=latinextendede}', "");
    Expect(1, 43888, '\p{^Block=latinextendede}', "");
    Expect(1, 43888, '\P{Block=latinextendede}', "");
    Expect(0, 43888, '\P{^Block=latinextendede}', "");
    Expect(1, 43887, '\p{Block=:\Alatinextendede\z:}', "");;
    Expect(0, 43888, '\p{Block=:\Alatinextendede\z:}', "");;
    Expect(1, 43887, '\p{Block=-Latin_Extended_E}', "");
    Expect(0, 43887, '\p{^Block=-Latin_Extended_E}', "");
    Expect(0, 43887, '\P{Block=-Latin_Extended_E}', "");
    Expect(1, 43887, '\P{^Block=-Latin_Extended_E}', "");
    Expect(0, 43888, '\p{Block=-Latin_Extended_E}', "");
    Expect(1, 43888, '\p{^Block=-Latin_Extended_E}', "");
    Expect(1, 43888, '\P{Block=-Latin_Extended_E}', "");
    Expect(0, 43888, '\P{^Block=-Latin_Extended_E}', "");
    Error('\p{Blk=/a/_LATIN_EXT_e}');
    Error('\P{Blk=/a/_LATIN_EXT_e}');
    Expect(1, 43887, '\p{Blk=:\ALatin_Ext_E\z:}', "");;
    Expect(0, 43888, '\p{Blk=:\ALatin_Ext_E\z:}', "");;
    Expect(1, 43887, '\p{Blk=latinexte}', "");
    Expect(0, 43887, '\p{^Blk=latinexte}', "");
    Expect(0, 43887, '\P{Blk=latinexte}', "");
    Expect(1, 43887, '\P{^Blk=latinexte}', "");
    Expect(0, 43888, '\p{Blk=latinexte}', "");
    Expect(1, 43888, '\p{^Blk=latinexte}', "");
    Expect(1, 43888, '\P{Blk=latinexte}', "");
    Expect(0, 43888, '\P{^Blk=latinexte}', "");
    Expect(1, 43887, '\p{Blk=:\Alatinexte\z:}', "");;
    Expect(0, 43888, '\p{Blk=:\Alatinexte\z:}', "");;
    Expect(1, 43887, '\p{Blk=_LATIN_EXT_E}', "");
    Expect(0, 43887, '\p{^Blk=_LATIN_EXT_E}', "");
    Expect(0, 43887, '\P{Blk=_LATIN_EXT_E}', "");
    Expect(1, 43887, '\P{^Blk=_LATIN_EXT_E}', "");
    Expect(0, 43888, '\p{Blk=_LATIN_EXT_E}', "");
    Expect(1, 43888, '\p{^Blk=_LATIN_EXT_E}', "");
    Expect(1, 43888, '\P{Blk=_LATIN_EXT_E}', "");
    Expect(0, 43888, '\P{^Blk=_LATIN_EXT_E}', "");
    Error('\p{Is_Block=/a/		LATIN_extended_E}');
    Error('\P{Is_Block=/a/		LATIN_extended_E}');
    Expect(1, 43887, '\p{Is_Block=latinextendede}', "");
    Expect(0, 43887, '\p{^Is_Block=latinextendede}', "");
    Expect(0, 43887, '\P{Is_Block=latinextendede}', "");
    Expect(1, 43887, '\P{^Is_Block=latinextendede}', "");
    Expect(0, 43888, '\p{Is_Block=latinextendede}', "");
    Expect(1, 43888, '\p{^Is_Block=latinextendede}', "");
    Expect(1, 43888, '\P{Is_Block=latinextendede}', "");
    Expect(0, 43888, '\P{^Is_Block=latinextendede}', "");
    Expect(1, 43887, '\p{Is_Block=_ latin_extended_E}', "");
    Expect(0, 43887, '\p{^Is_Block=_ latin_extended_E}', "");
    Expect(0, 43887, '\P{Is_Block=_ latin_extended_E}', "");
    Expect(1, 43887, '\P{^Is_Block=_ latin_extended_E}', "");
    Expect(0, 43888, '\p{Is_Block=_ latin_extended_E}', "");
    Expect(1, 43888, '\p{^Is_Block=_ latin_extended_E}', "");
    Expect(1, 43888, '\P{Is_Block=_ latin_extended_E}', "");
    Expect(0, 43888, '\P{^Is_Block=_ latin_extended_E}', "");
    Error('\p{Is_Blk=/a/-Latin_ext_E}');
    Error('\P{Is_Blk=/a/-Latin_ext_E}');
    Expect(1, 43887, '\p{Is_Blk=latinexte}', "");
    Expect(0, 43887, '\p{^Is_Blk=latinexte}', "");
    Expect(0, 43887, '\P{Is_Blk=latinexte}', "");
    Expect(1, 43887, '\P{^Is_Blk=latinexte}', "");
    Expect(0, 43888, '\p{Is_Blk=latinexte}', "");
    Expect(1, 43888, '\p{^Is_Blk=latinexte}', "");
    Expect(1, 43888, '\P{Is_Blk=latinexte}', "");
    Expect(0, 43888, '\P{^Is_Blk=latinexte}', "");
    Expect(1, 43887, '\p{Is_Blk=Latin_EXT_E}', "");
    Expect(0, 43887, '\p{^Is_Blk=Latin_EXT_E}', "");
    Expect(0, 43887, '\P{Is_Blk=Latin_EXT_E}', "");
    Expect(1, 43887, '\P{^Is_Blk=Latin_EXT_E}', "");
    Expect(0, 43888, '\p{Is_Blk=Latin_EXT_E}', "");
    Expect(1, 43888, '\p{^Is_Blk=Latin_EXT_E}', "");
    Expect(1, 43888, '\P{Is_Blk=Latin_EXT_E}', "");
    Expect(0, 43888, '\P{^Is_Blk=Latin_EXT_E}', "");
    Error('\p{Block=/a/-	LATIN_extended_F}');
    Error('\P{Block=/a/-	LATIN_extended_F}');
    Expect(1, 67519, '\p{Block=:\ALatin_Extended_F\z:}', "");;
    Expect(0, 67520, '\p{Block=:\ALatin_Extended_F\z:}', "");;
    Expect(1, 67519, '\p{Block=latinextendedf}', "");
    Expect(0, 67519, '\p{^Block=latinextendedf}', "");
    Expect(0, 67519, '\P{Block=latinextendedf}', "");
    Expect(1, 67519, '\P{^Block=latinextendedf}', "");
    Expect(0, 67520, '\p{Block=latinextendedf}', "");
    Expect(1, 67520, '\p{^Block=latinextendedf}', "");
    Expect(1, 67520, '\P{Block=latinextendedf}', "");
    Expect(0, 67520, '\P{^Block=latinextendedf}', "");
    Expect(1, 67519, '\p{Block=:\Alatinextendedf\z:}', "");;
    Expect(0, 67520, '\p{Block=:\Alatinextendedf\z:}', "");;
    Expect(1, 67519, '\p{Block= _Latin_Extended_f}', "");
    Expect(0, 67519, '\p{^Block= _Latin_Extended_f}', "");
    Expect(0, 67519, '\P{Block= _Latin_Extended_f}', "");
    Expect(1, 67519, '\P{^Block= _Latin_Extended_f}', "");
    Expect(0, 67520, '\p{Block= _Latin_Extended_f}', "");
    Expect(1, 67520, '\p{^Block= _Latin_Extended_f}', "");
    Expect(1, 67520, '\P{Block= _Latin_Extended_f}', "");
    Expect(0, 67520, '\P{^Block= _Latin_Extended_f}', "");
    Error('\p{Blk=	_Latin_ext_f:=}');
    Error('\P{Blk=	_Latin_ext_f:=}');
    Expect(1, 67519, '\p{Blk=:\ALatin_Ext_F\z:}', "");;
    Expect(0, 67520, '\p{Blk=:\ALatin_Ext_F\z:}', "");;
    Expect(1, 67519, '\p{Blk:   latinextf}', "");
    Expect(0, 67519, '\p{^Blk:   latinextf}', "");
    Expect(0, 67519, '\P{Blk:   latinextf}', "");
    Expect(1, 67519, '\P{^Blk:   latinextf}', "");
    Expect(0, 67520, '\p{Blk:   latinextf}', "");
    Expect(1, 67520, '\p{^Blk:   latinextf}', "");
    Expect(1, 67520, '\P{Blk:   latinextf}', "");
    Expect(0, 67520, '\P{^Blk:   latinextf}', "");
    Expect(1, 67519, '\p{Blk=:\Alatinextf\z:}', "");;
    Expect(0, 67520, '\p{Blk=:\Alatinextf\z:}', "");;
    Expect(1, 67519, '\p{Blk= 	latin_Ext_F}', "");
    Expect(0, 67519, '\p{^Blk= 	latin_Ext_F}', "");
    Expect(0, 67519, '\P{Blk= 	latin_Ext_F}', "");
    Expect(1, 67519, '\P{^Blk= 	latin_Ext_F}', "");
    Expect(0, 67520, '\p{Blk= 	latin_Ext_F}', "");
    Expect(1, 67520, '\p{^Blk= 	latin_Ext_F}', "");
    Expect(1, 67520, '\P{Blk= 	latin_Ext_F}', "");
    Expect(0, 67520, '\P{^Blk= 	latin_Ext_F}', "");
    Error('\p{Is_Block: --LATIN_Extended_F:=}');
    Error('\P{Is_Block: --LATIN_Extended_F:=}');
    Expect(1, 67519, '\p{Is_Block=latinextendedf}', "");
    Expect(0, 67519, '\p{^Is_Block=latinextendedf}', "");
    Expect(0, 67519, '\P{Is_Block=latinextendedf}', "");
    Expect(1, 67519, '\P{^Is_Block=latinextendedf}', "");
    Expect(0, 67520, '\p{Is_Block=latinextendedf}', "");
    Expect(1, 67520, '\p{^Is_Block=latinextendedf}', "");
    Expect(1, 67520, '\P{Is_Block=latinextendedf}', "");
    Expect(0, 67520, '\P{^Is_Block=latinextendedf}', "");
    Expect(1, 67519, '\p{Is_Block= 	Latin_Extended_F}', "");
    Expect(0, 67519, '\p{^Is_Block= 	Latin_Extended_F}', "");
    Expect(0, 67519, '\P{Is_Block= 	Latin_Extended_F}', "");
    Expect(1, 67519, '\P{^Is_Block= 	Latin_Extended_F}', "");
    Expect(0, 67520, '\p{Is_Block= 	Latin_Extended_F}', "");
    Expect(1, 67520, '\p{^Is_Block= 	Latin_Extended_F}', "");
    Expect(1, 67520, '\P{Is_Block= 	Latin_Extended_F}', "");
    Expect(0, 67520, '\P{^Is_Block= 	Latin_Extended_F}', "");
    Error('\p{Is_Blk= Latin_Ext_F:=}');
    Error('\P{Is_Blk= Latin_Ext_F:=}');
    Expect(1, 67519, '\p{Is_Blk=latinextf}', "");
    Expect(0, 67519, '\p{^Is_Blk=latinextf}', "");
    Expect(0, 67519, '\P{Is_Blk=latinextf}', "");
    Expect(1, 67519, '\P{^Is_Blk=latinextf}', "");
    Expect(0, 67520, '\p{Is_Blk=latinextf}', "");
    Expect(1, 67520, '\p{^Is_Blk=latinextf}', "");
    Expect(1, 67520, '\P{Is_Blk=latinextf}', "");
    Expect(0, 67520, '\P{^Is_Blk=latinextf}', "");
    Expect(1, 67519, '\p{Is_Blk=_	Latin_EXT_F}', "");
    Expect(0, 67519, '\p{^Is_Blk=_	Latin_EXT_F}', "");
    Expect(0, 67519, '\P{Is_Blk=_	Latin_EXT_F}', "");
    Expect(1, 67519, '\P{^Is_Blk=_	Latin_EXT_F}', "");
    Expect(0, 67520, '\p{Is_Blk=_	Latin_EXT_F}', "");
    Expect(1, 67520, '\p{^Is_Blk=_	Latin_EXT_F}', "");
    Expect(1, 67520, '\P{Is_Blk=_	Latin_EXT_F}', "");
    Expect(0, 67520, '\P{^Is_Blk=_	Latin_EXT_F}', "");
    Error('\p{Block= -LATIN_EXTENDED_G:=}');
    Error('\P{Block= -LATIN_EXTENDED_G:=}');
    Expect(1, 122879, '\p{Block=:\ALatin_Extended_G\z:}', "");;
    Expect(0, 122880, '\p{Block=:\ALatin_Extended_G\z:}', "");;
    Expect(1, 122879, '\p{Block=latinextendedg}', "");
    Expect(0, 122879, '\p{^Block=latinextendedg}', "");
    Expect(0, 122879, '\P{Block=latinextendedg}', "");
    Expect(1, 122879, '\P{^Block=latinextendedg}', "");
    Expect(0, 122880, '\p{Block=latinextendedg}', "");
    Expect(1, 122880, '\p{^Block=latinextendedg}', "");
    Expect(1, 122880, '\P{Block=latinextendedg}', "");
    Expect(0, 122880, '\P{^Block=latinextendedg}', "");
    Expect(1, 122879, '\p{Block=:\Alatinextendedg\z:}', "");;
    Expect(0, 122880, '\p{Block=:\Alatinextendedg\z:}', "");;
    Expect(1, 122879, '\p{Block=-LATIN_Extended_G}', "");
    Expect(0, 122879, '\p{^Block=-LATIN_Extended_G}', "");
    Expect(0, 122879, '\P{Block=-LATIN_Extended_G}', "");
    Expect(1, 122879, '\P{^Block=-LATIN_Extended_G}', "");
    Expect(0, 122880, '\p{Block=-LATIN_Extended_G}', "");
    Expect(1, 122880, '\p{^Block=-LATIN_Extended_G}', "");
    Expect(1, 122880, '\P{Block=-LATIN_Extended_G}', "");
    Expect(0, 122880, '\P{^Block=-LATIN_Extended_G}', "");
    Error('\p{Blk:   latin_Ext_G/a/}');
    Error('\P{Blk:   latin_Ext_G/a/}');
    Expect(1, 122879, '\p{Blk=:\ALatin_Ext_G\z:}', "");;
    Expect(0, 122880, '\p{Blk=:\ALatin_Ext_G\z:}', "");;
    Expect(1, 122879, '\p{Blk=latinextg}', "");
    Expect(0, 122879, '\p{^Blk=latinextg}', "");
    Expect(0, 122879, '\P{Blk=latinextg}', "");
    Expect(1, 122879, '\P{^Blk=latinextg}', "");
    Expect(0, 122880, '\p{Blk=latinextg}', "");
    Expect(1, 122880, '\p{^Blk=latinextg}', "");
    Expect(1, 122880, '\P{Blk=latinextg}', "");
    Expect(0, 122880, '\P{^Blk=latinextg}', "");
    Expect(1, 122879, '\p{Blk=:\Alatinextg\z:}', "");;
    Expect(0, 122880, '\p{Blk=:\Alatinextg\z:}', "");;
    Expect(1, 122879, '\p{Blk=--LATIN_Ext_G}', "");
    Expect(0, 122879, '\p{^Blk=--LATIN_Ext_G}', "");
    Expect(0, 122879, '\P{Blk=--LATIN_Ext_G}', "");
    Expect(1, 122879, '\P{^Blk=--LATIN_Ext_G}', "");
    Expect(0, 122880, '\p{Blk=--LATIN_Ext_G}', "");
    Expect(1, 122880, '\p{^Blk=--LATIN_Ext_G}', "");
    Expect(1, 122880, '\P{Blk=--LATIN_Ext_G}', "");
    Expect(0, 122880, '\P{^Blk=--LATIN_Ext_G}', "");
    Error('\p{Is_Block=-	LATIN_EXTENDED_G:=}');
    Error('\P{Is_Block=-	LATIN_EXTENDED_G:=}');
    Expect(1, 122879, '\p{Is_Block=latinextendedg}', "");
    Expect(0, 122879, '\p{^Is_Block=latinextendedg}', "");
    Expect(0, 122879, '\P{Is_Block=latinextendedg}', "");
    Expect(1, 122879, '\P{^Is_Block=latinextendedg}', "");
    Expect(0, 122880, '\p{Is_Block=latinextendedg}', "");
    Expect(1, 122880, '\p{^Is_Block=latinextendedg}', "");
    Expect(1, 122880, '\P{Is_Block=latinextendedg}', "");
    Expect(0, 122880, '\P{^Is_Block=latinextendedg}', "");
    Expect(1, 122879, '\p{Is_Block= 	Latin_EXTENDED_G}', "");
    Expect(0, 122879, '\p{^Is_Block= 	Latin_EXTENDED_G}', "");
    Expect(0, 122879, '\P{Is_Block= 	Latin_EXTENDED_G}', "");
    Expect(1, 122879, '\P{^Is_Block= 	Latin_EXTENDED_G}', "");
    Expect(0, 122880, '\p{Is_Block= 	Latin_EXTENDED_G}', "");
    Expect(1, 122880, '\p{^Is_Block= 	Latin_EXTENDED_G}', "");
    Expect(1, 122880, '\P{Is_Block= 	Latin_EXTENDED_G}', "");
    Expect(0, 122880, '\P{^Is_Block= 	Latin_EXTENDED_G}', "");
    Error('\p{Is_Blk=	_LATIN_ext_G/a/}');
    Error('\P{Is_Blk=	_LATIN_ext_G/a/}');
    Expect(1, 122879, '\p{Is_Blk=latinextg}', "");
    Expect(0, 122879, '\p{^Is_Blk=latinextg}', "");
    Expect(0, 122879, '\P{Is_Blk=latinextg}', "");
    Expect(1, 122879, '\P{^Is_Blk=latinextg}', "");
    Expect(0, 122880, '\p{Is_Blk=latinextg}', "");
    Expect(1, 122880, '\p{^Is_Blk=latinextg}', "");
    Expect(1, 122880, '\P{Is_Blk=latinextg}', "");
    Expect(0, 122880, '\P{^Is_Blk=latinextg}', "");
    Expect(1, 122879, '\p{Is_Blk=_	Latin_EXT_G}', "");
    Expect(0, 122879, '\p{^Is_Blk=_	Latin_EXT_G}', "");
    Expect(0, 122879, '\P{Is_Blk=_	Latin_EXT_G}', "");
    Expect(1, 122879, '\P{^Is_Blk=_	Latin_EXT_G}', "");
    Expect(0, 122880, '\p{Is_Blk=_	Latin_EXT_G}', "");
    Expect(1, 122880, '\p{^Is_Blk=_	Latin_EXT_G}', "");
    Expect(1, 122880, '\P{Is_Blk=_	Latin_EXT_G}', "");
    Expect(0, 122880, '\P{^Is_Blk=_	Latin_EXT_G}', "");
    Error('\p{Block=/a/LEPCHA}');
    Error('\P{Block=/a/LEPCHA}');
    Expect(1, 7247, '\p{Block=:\ALepcha\z:}', "");;
    Expect(0, 7248, '\p{Block=:\ALepcha\z:}', "");;
    Expect(1, 7247, '\p{Block=lepcha}', "");
    Expect(0, 7247, '\p{^Block=lepcha}', "");
    Expect(0, 7247, '\P{Block=lepcha}', "");
    Expect(1, 7247, '\P{^Block=lepcha}', "");
    Expect(0, 7248, '\p{Block=lepcha}', "");
    Expect(1, 7248, '\p{^Block=lepcha}', "");
    Expect(1, 7248, '\P{Block=lepcha}', "");
    Expect(0, 7248, '\P{^Block=lepcha}', "");
    Expect(1, 7247, '\p{Block=:\Alepcha\z:}', "");;
    Expect(0, 7248, '\p{Block=:\Alepcha\z:}', "");;
    Expect(1, 7247, '\p{Block=  Lepcha}', "");
    Expect(0, 7247, '\p{^Block=  Lepcha}', "");
    Expect(0, 7247, '\P{Block=  Lepcha}', "");
    Expect(1, 7247, '\P{^Block=  Lepcha}', "");
    Expect(0, 7248, '\p{Block=  Lepcha}', "");
    Expect(1, 7248, '\p{^Block=  Lepcha}', "");
    Expect(1, 7248, '\P{Block=  Lepcha}', "");
    Expect(0, 7248, '\P{^Block=  Lepcha}', "");
    Error('\p{Blk=/a/ Lepcha}');
    Error('\P{Blk=/a/ Lepcha}');
    Expect(1, 7247, '\p{Blk=:\ALepcha\z:}', "");;
    Expect(0, 7248, '\p{Blk=:\ALepcha\z:}', "");;
    Expect(1, 7247, '\p{Blk:   lepcha}', "");
    Expect(0, 7247, '\p{^Blk:   lepcha}', "");
    Expect(0, 7247, '\P{Blk:   lepcha}', "");
    Expect(1, 7247, '\P{^Blk:   lepcha}', "");
    Expect(0, 7248, '\p{Blk:   lepcha}', "");
    Expect(1, 7248, '\p{^Blk:   lepcha}', "");
    Expect(1, 7248, '\P{Blk:   lepcha}', "");
    Expect(0, 7248, '\P{^Blk:   lepcha}', "");
    Expect(1, 7247, '\p{Blk=:\Alepcha\z:}', "");;
    Expect(0, 7248, '\p{Blk=:\Alepcha\z:}', "");;
    Expect(1, 7247, '\p{Blk=_lepcha}', "");
    Expect(0, 7247, '\p{^Blk=_lepcha}', "");
    Expect(0, 7247, '\P{Blk=_lepcha}', "");
    Expect(1, 7247, '\P{^Blk=_lepcha}', "");
    Expect(0, 7248, '\p{Blk=_lepcha}', "");
    Expect(1, 7248, '\p{^Blk=_lepcha}', "");
    Expect(1, 7248, '\P{Blk=_lepcha}', "");
    Expect(0, 7248, '\P{^Blk=_lepcha}', "");
    Error('\p{Is_Block= _LEPCHA:=}');
    Error('\P{Is_Block= _LEPCHA:=}');
    Expect(1, 7247, '\p{Is_Block=lepcha}', "");
    Expect(0, 7247, '\p{^Is_Block=lepcha}', "");
    Expect(0, 7247, '\P{Is_Block=lepcha}', "");
    Expect(1, 7247, '\P{^Is_Block=lepcha}', "");
    Expect(0, 7248, '\p{Is_Block=lepcha}', "");
    Expect(1, 7248, '\p{^Is_Block=lepcha}', "");
    Expect(1, 7248, '\P{Is_Block=lepcha}', "");
    Expect(0, 7248, '\P{^Is_Block=lepcha}', "");
    Expect(1, 7247, '\p{Is_Block=LEPCHA}', "");
    Expect(0, 7247, '\p{^Is_Block=LEPCHA}', "");
    Expect(0, 7247, '\P{Is_Block=LEPCHA}', "");
    Expect(1, 7247, '\P{^Is_Block=LEPCHA}', "");
    Expect(0, 7248, '\p{Is_Block=LEPCHA}', "");
    Expect(1, 7248, '\p{^Is_Block=LEPCHA}', "");
    Expect(1, 7248, '\P{Is_Block=LEPCHA}', "");
    Expect(0, 7248, '\P{^Is_Block=LEPCHA}', "");
    Error('\p{Is_Blk=  Lepcha:=}');
    Error('\P{Is_Blk=  Lepcha:=}');
    Expect(1, 7247, '\p{Is_Blk=lepcha}', "");
    Expect(0, 7247, '\p{^Is_Blk=lepcha}', "");
    Expect(0, 7247, '\P{Is_Blk=lepcha}', "");
    Expect(1, 7247, '\P{^Is_Blk=lepcha}', "");
    Expect(0, 7248, '\p{Is_Blk=lepcha}', "");
    Expect(1, 7248, '\p{^Is_Blk=lepcha}', "");
    Expect(1, 7248, '\P{Is_Blk=lepcha}', "");
    Expect(0, 7248, '\P{^Is_Blk=lepcha}', "");
    Expect(1, 7247, '\p{Is_Blk=_-Lepcha}', "");
    Expect(0, 7247, '\p{^Is_Blk=_-Lepcha}', "");
    Expect(0, 7247, '\P{Is_Blk=_-Lepcha}', "");
    Expect(1, 7247, '\P{^Is_Blk=_-Lepcha}', "");
    Expect(0, 7248, '\p{Is_Blk=_-Lepcha}', "");
    Expect(1, 7248, '\p{^Is_Blk=_-Lepcha}', "");
    Expect(1, 7248, '\P{Is_Blk=_-Lepcha}', "");
    Expect(0, 7248, '\P{^Is_Blk=_-Lepcha}', "");
    Error('\p{Block=:= -Letterlike_SYMBOLS}');
    Error('\P{Block=:= -Letterlike_SYMBOLS}');
    Expect(1, 8527, '\p{Block=:\ALetterlike_Symbols\z:}', "");;
    Expect(0, 8528, '\p{Block=:\ALetterlike_Symbols\z:}', "");;
    Expect(1, 8527, '\p{Block=letterlikesymbols}', "");
    Expect(0, 8527, '\p{^Block=letterlikesymbols}', "");
    Expect(0, 8527, '\P{Block=letterlikesymbols}', "");
    Expect(1, 8527, '\P{^Block=letterlikesymbols}', "");
    Expect(0, 8528, '\p{Block=letterlikesymbols}', "");
    Expect(1, 8528, '\p{^Block=letterlikesymbols}', "");
    Expect(1, 8528, '\P{Block=letterlikesymbols}', "");
    Expect(0, 8528, '\P{^Block=letterlikesymbols}', "");
    Expect(1, 8527, '\p{Block=:\Aletterlikesymbols\z:}', "");;
    Expect(0, 8528, '\p{Block=:\Aletterlikesymbols\z:}', "");;
    Expect(1, 8527, '\p{Block=__Letterlike_Symbols}', "");
    Expect(0, 8527, '\p{^Block=__Letterlike_Symbols}', "");
    Expect(0, 8527, '\P{Block=__Letterlike_Symbols}', "");
    Expect(1, 8527, '\P{^Block=__Letterlike_Symbols}', "");
    Expect(0, 8528, '\p{Block=__Letterlike_Symbols}', "");
    Expect(1, 8528, '\p{^Block=__Letterlike_Symbols}', "");
    Expect(1, 8528, '\P{Block=__Letterlike_Symbols}', "");
    Expect(0, 8528, '\P{^Block=__Letterlike_Symbols}', "");
    Error('\p{Blk=	:=letterlike_SYMBOLS}');
    Error('\P{Blk=	:=letterlike_SYMBOLS}');
    Expect(1, 8527, '\p{Blk=:\ALetterlike_Symbols\z:}', "");;
    Expect(0, 8528, '\p{Blk=:\ALetterlike_Symbols\z:}', "");;
    Expect(1, 8527, '\p{Blk: letterlikesymbols}', "");
    Expect(0, 8527, '\p{^Blk: letterlikesymbols}', "");
    Expect(0, 8527, '\P{Blk: letterlikesymbols}', "");
    Expect(1, 8527, '\P{^Blk: letterlikesymbols}', "");
    Expect(0, 8528, '\p{Blk: letterlikesymbols}', "");
    Expect(1, 8528, '\p{^Blk: letterlikesymbols}', "");
    Expect(1, 8528, '\P{Blk: letterlikesymbols}', "");
    Expect(0, 8528, '\P{^Blk: letterlikesymbols}', "");
    Expect(1, 8527, '\p{Blk=:\Aletterlikesymbols\z:}', "");;
    Expect(0, 8528, '\p{Blk=:\Aletterlikesymbols\z:}', "");;
    Expect(1, 8527, '\p{Blk=	Letterlike_Symbols}', "");
    Expect(0, 8527, '\p{^Blk=	Letterlike_Symbols}', "");
    Expect(0, 8527, '\P{Blk=	Letterlike_Symbols}', "");
    Expect(1, 8527, '\P{^Blk=	Letterlike_Symbols}', "");
    Expect(0, 8528, '\p{Blk=	Letterlike_Symbols}', "");
    Expect(1, 8528, '\p{^Blk=	Letterlike_Symbols}', "");
    Expect(1, 8528, '\P{Blk=	Letterlike_Symbols}', "");
    Expect(0, 8528, '\P{^Blk=	Letterlike_Symbols}', "");
    Error('\p{Is_Block: _ Letterlike_Symbols/a/}');
    Error('\P{Is_Block: _ Letterlike_Symbols/a/}');
    Expect(1, 8527, '\p{Is_Block=letterlikesymbols}', "");
    Expect(0, 8527, '\p{^Is_Block=letterlikesymbols}', "");
    Expect(0, 8527, '\P{Is_Block=letterlikesymbols}', "");
    Expect(1, 8527, '\P{^Is_Block=letterlikesymbols}', "");
    Expect(0, 8528, '\p{Is_Block=letterlikesymbols}', "");
    Expect(1, 8528, '\p{^Is_Block=letterlikesymbols}', "");
    Expect(1, 8528, '\P{Is_Block=letterlikesymbols}', "");
    Expect(0, 8528, '\P{^Is_Block=letterlikesymbols}', "");
    Expect(1, 8527, '\p{Is_Block= 	Letterlike_Symbols}', "");
    Expect(0, 8527, '\p{^Is_Block= 	Letterlike_Symbols}', "");
    Expect(0, 8527, '\P{Is_Block= 	Letterlike_Symbols}', "");
    Expect(1, 8527, '\P{^Is_Block= 	Letterlike_Symbols}', "");
    Expect(0, 8528, '\p{Is_Block= 	Letterlike_Symbols}', "");
    Expect(1, 8528, '\p{^Is_Block= 	Letterlike_Symbols}', "");
    Expect(1, 8528, '\P{Is_Block= 	Letterlike_Symbols}', "");
    Expect(0, 8528, '\P{^Is_Block= 	Letterlike_Symbols}', "");
    Error('\p{Is_Blk=/a/-_LETTERLIKE_symbols}');
    Error('\P{Is_Blk=/a/-_LETTERLIKE_symbols}');
    Expect(1, 8527, '\p{Is_Blk=letterlikesymbols}', "");
    Expect(0, 8527, '\p{^Is_Blk=letterlikesymbols}', "");
    Expect(0, 8527, '\P{Is_Blk=letterlikesymbols}', "");
    Expect(1, 8527, '\P{^Is_Blk=letterlikesymbols}', "");
    Expect(0, 8528, '\p{Is_Blk=letterlikesymbols}', "");
    Expect(1, 8528, '\p{^Is_Blk=letterlikesymbols}', "");
    Expect(1, 8528, '\P{Is_Blk=letterlikesymbols}', "");
    Expect(0, 8528, '\P{^Is_Blk=letterlikesymbols}', "");
    Expect(1, 8527, '\p{Is_Blk=Letterlike_symbols}', "");
    Expect(0, 8527, '\p{^Is_Blk=Letterlike_symbols}', "");
    Expect(0, 8527, '\P{Is_Blk=Letterlike_symbols}', "");
    Expect(1, 8527, '\P{^Is_Blk=Letterlike_symbols}', "");
    Expect(0, 8528, '\p{Is_Blk=Letterlike_symbols}', "");
    Expect(1, 8528, '\p{^Is_Blk=Letterlike_symbols}', "");
    Expect(1, 8528, '\P{Is_Blk=Letterlike_symbols}', "");
    Expect(0, 8528, '\P{^Is_Blk=Letterlike_symbols}', "");
    Error('\p{Block=:=	 LIMBU}');
    Error('\P{Block=:=	 LIMBU}');
    Expect(1, 6479, '\p{Block=:\ALimbu\z:}', "");;
    Expect(0, 6480, '\p{Block=:\ALimbu\z:}', "");;
    Expect(1, 6479, '\p{Block=limbu}', "");
    Expect(0, 6479, '\p{^Block=limbu}', "");
    Expect(0, 6479, '\P{Block=limbu}', "");
    Expect(1, 6479, '\P{^Block=limbu}', "");
    Expect(0, 6480, '\p{Block=limbu}', "");
    Expect(1, 6480, '\p{^Block=limbu}', "");
    Expect(1, 6480, '\P{Block=limbu}', "");
    Expect(0, 6480, '\P{^Block=limbu}', "");
    Expect(1, 6479, '\p{Block=:\Alimbu\z:}', "");;
    Expect(0, 6480, '\p{Block=:\Alimbu\z:}', "");;
    Expect(1, 6479, '\p{Block=	limbu}', "");
    Expect(0, 6479, '\p{^Block=	limbu}', "");
    Expect(0, 6479, '\P{Block=	limbu}', "");
    Expect(1, 6479, '\P{^Block=	limbu}', "");
    Expect(0, 6480, '\p{Block=	limbu}', "");
    Expect(1, 6480, '\p{^Block=	limbu}', "");
    Expect(1, 6480, '\P{Block=	limbu}', "");
    Expect(0, 6480, '\P{^Block=	limbu}', "");
    Error('\p{Blk=-:=Limbu}');
    Error('\P{Blk=-:=Limbu}');
    Expect(1, 6479, '\p{Blk=:\ALimbu\z:}', "");;
    Expect(0, 6480, '\p{Blk=:\ALimbu\z:}', "");;
    Expect(1, 6479, '\p{Blk=limbu}', "");
    Expect(0, 6479, '\p{^Blk=limbu}', "");
    Expect(0, 6479, '\P{Blk=limbu}', "");
    Expect(1, 6479, '\P{^Blk=limbu}', "");
    Expect(0, 6480, '\p{Blk=limbu}', "");
    Expect(1, 6480, '\p{^Blk=limbu}', "");
    Expect(1, 6480, '\P{Blk=limbu}', "");
    Expect(0, 6480, '\P{^Blk=limbu}', "");
    Expect(1, 6479, '\p{Blk=:\Alimbu\z:}', "");;
    Expect(0, 6480, '\p{Blk=:\Alimbu\z:}', "");;
    Expect(1, 6479, '\p{Blk:	-_limbu}', "");
    Expect(0, 6479, '\p{^Blk:	-_limbu}', "");
    Expect(0, 6479, '\P{Blk:	-_limbu}', "");
    Expect(1, 6479, '\P{^Blk:	-_limbu}', "");
    Expect(0, 6480, '\p{Blk:	-_limbu}', "");
    Expect(1, 6480, '\p{^Blk:	-_limbu}', "");
    Expect(1, 6480, '\P{Blk:	-_limbu}', "");
    Expect(0, 6480, '\P{^Blk:	-_limbu}', "");
    Error('\p{Is_Block= Limbu/a/}');
    Error('\P{Is_Block= Limbu/a/}');
    Expect(1, 6479, '\p{Is_Block=limbu}', "");
    Expect(0, 6479, '\p{^Is_Block=limbu}', "");
    Expect(0, 6479, '\P{Is_Block=limbu}', "");
    Expect(1, 6479, '\P{^Is_Block=limbu}', "");
    Expect(0, 6480, '\p{Is_Block=limbu}', "");
    Expect(1, 6480, '\p{^Is_Block=limbu}', "");
    Expect(1, 6480, '\P{Is_Block=limbu}', "");
    Expect(0, 6480, '\P{^Is_Block=limbu}', "");
    Expect(1, 6479, '\p{Is_Block=_ limbu}', "");
    Expect(0, 6479, '\p{^Is_Block=_ limbu}', "");
    Expect(0, 6479, '\P{Is_Block=_ limbu}', "");
    Expect(1, 6479, '\P{^Is_Block=_ limbu}', "");
    Expect(0, 6480, '\p{Is_Block=_ limbu}', "");
    Expect(1, 6480, '\p{^Is_Block=_ limbu}', "");
    Expect(1, 6480, '\P{Is_Block=_ limbu}', "");
    Expect(0, 6480, '\P{^Is_Block=_ limbu}', "");
    Error('\p{Is_Blk=/a/	-Limbu}');
    Error('\P{Is_Blk=/a/	-Limbu}');
    Expect(1, 6479, '\p{Is_Blk=limbu}', "");
    Expect(0, 6479, '\p{^Is_Blk=limbu}', "");
    Expect(0, 6479, '\P{Is_Blk=limbu}', "");
    Expect(1, 6479, '\P{^Is_Blk=limbu}', "");
    Expect(0, 6480, '\p{Is_Blk=limbu}', "");
    Expect(1, 6480, '\p{^Is_Blk=limbu}', "");
    Expect(1, 6480, '\P{Is_Blk=limbu}', "");
    Expect(0, 6480, '\P{^Is_Blk=limbu}', "");
    Expect(1, 6479, '\p{Is_Blk=	-LIMBU}', "");
    Expect(0, 6479, '\p{^Is_Blk=	-LIMBU}', "");
    Expect(0, 6479, '\P{Is_Blk=	-LIMBU}', "");
    Expect(1, 6479, '\P{^Is_Blk=	-LIMBU}', "");
    Expect(0, 6480, '\p{Is_Blk=	-LIMBU}', "");
    Expect(1, 6480, '\p{^Is_Blk=	-LIMBU}', "");
    Expect(1, 6480, '\P{Is_Blk=	-LIMBU}', "");
    Expect(0, 6480, '\P{^Is_Blk=	-LIMBU}', "");
    Error('\p{Block=/a/_	Linear_A}');
    Error('\P{Block=/a/_	Linear_A}');
    Expect(1, 67455, '\p{Block=:\ALinear_A\z:}', "");;
    Expect(0, 67456, '\p{Block=:\ALinear_A\z:}', "");;
    Expect(1, 67455, '\p{Block:	lineara}', "");
    Expect(0, 67455, '\p{^Block:	lineara}', "");
    Expect(0, 67455, '\P{Block:	lineara}', "");
    Expect(1, 67455, '\P{^Block:	lineara}', "");
    Expect(0, 67456, '\p{Block:	lineara}', "");
    Expect(1, 67456, '\p{^Block:	lineara}', "");
    Expect(1, 67456, '\P{Block:	lineara}', "");
    Expect(0, 67456, '\P{^Block:	lineara}', "");
    Expect(1, 67455, '\p{Block=:\Alineara\z:}', "");;
    Expect(0, 67456, '\p{Block=:\Alineara\z:}', "");;
    Expect(1, 67455, '\p{Block=__Linear_A}', "");
    Expect(0, 67455, '\p{^Block=__Linear_A}', "");
    Expect(0, 67455, '\P{Block=__Linear_A}', "");
    Expect(1, 67455, '\P{^Block=__Linear_A}', "");
    Expect(0, 67456, '\p{Block=__Linear_A}', "");
    Expect(1, 67456, '\p{^Block=__Linear_A}', "");
    Expect(1, 67456, '\P{Block=__Linear_A}', "");
    Expect(0, 67456, '\P{^Block=__Linear_A}', "");
    Error('\p{Blk=	/a/linear_A}');
    Error('\P{Blk=	/a/linear_A}');
    Expect(1, 67455, '\p{Blk=:\ALinear_A\z:}', "");;
    Expect(0, 67456, '\p{Blk=:\ALinear_A\z:}', "");;
    Expect(1, 67455, '\p{Blk=lineara}', "");
    Expect(0, 67455, '\p{^Blk=lineara}', "");
    Expect(0, 67455, '\P{Blk=lineara}', "");
    Expect(1, 67455, '\P{^Blk=lineara}', "");
    Expect(0, 67456, '\p{Blk=lineara}', "");
    Expect(1, 67456, '\p{^Blk=lineara}', "");
    Expect(1, 67456, '\P{Blk=lineara}', "");
    Expect(0, 67456, '\P{^Blk=lineara}', "");
    Expect(1, 67455, '\p{Blk=:\Alineara\z:}', "");;
    Expect(0, 67456, '\p{Blk=:\Alineara\z:}', "");;
    Expect(1, 67455, '\p{Blk=	Linear_A}', "");
    Expect(0, 67455, '\p{^Blk=	Linear_A}', "");
    Expect(0, 67455, '\P{Blk=	Linear_A}', "");
    Expect(1, 67455, '\P{^Blk=	Linear_A}', "");
    Expect(0, 67456, '\p{Blk=	Linear_A}', "");
    Expect(1, 67456, '\p{^Blk=	Linear_A}', "");
    Expect(1, 67456, '\P{Blk=	Linear_A}', "");
    Expect(0, 67456, '\P{^Blk=	Linear_A}', "");
    Error('\p{Is_Block:   _:=linear_a}');
    Error('\P{Is_Block:   _:=linear_a}');
    Expect(1, 67455, '\p{Is_Block=lineara}', "");
    Expect(0, 67455, '\p{^Is_Block=lineara}', "");
    Expect(0, 67455, '\P{Is_Block=lineara}', "");
    Expect(1, 67455, '\P{^Is_Block=lineara}', "");
    Expect(0, 67456, '\p{Is_Block=lineara}', "");
    Expect(1, 67456, '\p{^Is_Block=lineara}', "");
    Expect(1, 67456, '\P{Is_Block=lineara}', "");
    Expect(0, 67456, '\P{^Is_Block=lineara}', "");
    Expect(1, 67455, '\p{Is_Block= _Linear_A}', "");
    Expect(0, 67455, '\p{^Is_Block= _Linear_A}', "");
    Expect(0, 67455, '\P{Is_Block= _Linear_A}', "");
    Expect(1, 67455, '\P{^Is_Block= _Linear_A}', "");
    Expect(0, 67456, '\p{Is_Block= _Linear_A}', "");
    Expect(1, 67456, '\p{^Is_Block= _Linear_A}', "");
    Expect(1, 67456, '\P{Is_Block= _Linear_A}', "");
    Expect(0, 67456, '\P{^Is_Block= _Linear_A}', "");
    Error('\p{Is_Blk=:=	linear_a}');
    Error('\P{Is_Blk=:=	linear_a}');
    Expect(1, 67455, '\p{Is_Blk=lineara}', "");
    Expect(0, 67455, '\p{^Is_Blk=lineara}', "");
    Expect(0, 67455, '\P{Is_Blk=lineara}', "");
    Expect(1, 67455, '\P{^Is_Blk=lineara}', "");
    Expect(0, 67456, '\p{Is_Blk=lineara}', "");
    Expect(1, 67456, '\p{^Is_Blk=lineara}', "");
    Expect(1, 67456, '\P{Is_Blk=lineara}', "");
    Expect(0, 67456, '\P{^Is_Blk=lineara}', "");
    Expect(1, 67455, '\p{Is_Blk=__LINEAR_A}', "");
    Expect(0, 67455, '\p{^Is_Blk=__LINEAR_A}', "");
    Expect(0, 67455, '\P{Is_Blk=__LINEAR_A}', "");
    Expect(1, 67455, '\P{^Is_Blk=__LINEAR_A}', "");
    Expect(0, 67456, '\p{Is_Blk=__LINEAR_A}', "");
    Expect(1, 67456, '\p{^Is_Blk=__LINEAR_A}', "");
    Expect(1, 67456, '\P{Is_Blk=__LINEAR_A}', "");
    Expect(0, 67456, '\P{^Is_Blk=__LINEAR_A}', "");
    Error('\p{Block=_ LINEAR_B_IDEOGRAMS/a/}');
    Error('\P{Block=_ LINEAR_B_IDEOGRAMS/a/}');
    Expect(1, 65791, '\p{Block=:\ALinear_B_Ideograms\z:}', "");;
    Expect(0, 65792, '\p{Block=:\ALinear_B_Ideograms\z:}', "");;
    Expect(1, 65791, '\p{Block=linearbideograms}', "");
    Expect(0, 65791, '\p{^Block=linearbideograms}', "");
    Expect(0, 65791, '\P{Block=linearbideograms}', "");
    Expect(1, 65791, '\P{^Block=linearbideograms}', "");
    Expect(0, 65792, '\p{Block=linearbideograms}', "");
    Expect(1, 65792, '\p{^Block=linearbideograms}', "");
    Expect(1, 65792, '\P{Block=linearbideograms}', "");
    Expect(0, 65792, '\P{^Block=linearbideograms}', "");
    Expect(1, 65791, '\p{Block=:\Alinearbideograms\z:}', "");;
    Expect(0, 65792, '\p{Block=:\Alinearbideograms\z:}', "");;
    Expect(1, 65791, '\p{Block: -LINEAR_b_Ideograms}', "");
    Expect(0, 65791, '\p{^Block: -LINEAR_b_Ideograms}', "");
    Expect(0, 65791, '\P{Block: -LINEAR_b_Ideograms}', "");
    Expect(1, 65791, '\P{^Block: -LINEAR_b_Ideograms}', "");
    Expect(0, 65792, '\p{Block: -LINEAR_b_Ideograms}', "");
    Expect(1, 65792, '\p{^Block: -LINEAR_b_Ideograms}', "");
    Expect(1, 65792, '\P{Block: -LINEAR_b_Ideograms}', "");
    Expect(0, 65792, '\P{^Block: -LINEAR_b_Ideograms}', "");
    Error('\p{Blk=	:=Linear_B_ideograms}');
    Error('\P{Blk=	:=Linear_B_ideograms}');
    Expect(1, 65791, '\p{Blk=:\ALinear_B_Ideograms\z:}', "");;
    Expect(0, 65792, '\p{Blk=:\ALinear_B_Ideograms\z:}', "");;
    Expect(1, 65791, '\p{Blk=linearbideograms}', "");
    Expect(0, 65791, '\p{^Blk=linearbideograms}', "");
    Expect(0, 65791, '\P{Blk=linearbideograms}', "");
    Expect(1, 65791, '\P{^Blk=linearbideograms}', "");
    Expect(0, 65792, '\p{Blk=linearbideograms}', "");
    Expect(1, 65792, '\p{^Blk=linearbideograms}', "");
    Expect(1, 65792, '\P{Blk=linearbideograms}', "");
    Expect(0, 65792, '\P{^Blk=linearbideograms}', "");
    Expect(1, 65791, '\p{Blk=:\Alinearbideograms\z:}', "");;
    Expect(0, 65792, '\p{Blk=:\Alinearbideograms\z:}', "");;
    Expect(1, 65791, '\p{Blk=_ linear_B_ideograms}', "");
    Expect(0, 65791, '\p{^Blk=_ linear_B_ideograms}', "");
    Expect(0, 65791, '\P{Blk=_ linear_B_ideograms}', "");
    Expect(1, 65791, '\P{^Blk=_ linear_B_ideograms}', "");
    Expect(0, 65792, '\p{Blk=_ linear_B_ideograms}', "");
    Expect(1, 65792, '\p{^Blk=_ linear_B_ideograms}', "");
    Expect(1, 65792, '\P{Blk=_ linear_B_ideograms}', "");
    Expect(0, 65792, '\P{^Blk=_ linear_B_ideograms}', "");
    Error('\p{Is_Block= 	Linear_b_Ideograms:=}');
    Error('\P{Is_Block= 	Linear_b_Ideograms:=}');
    Expect(1, 65791, '\p{Is_Block=linearbideograms}', "");
    Expect(0, 65791, '\p{^Is_Block=linearbideograms}', "");
    Expect(0, 65791, '\P{Is_Block=linearbideograms}', "");
    Expect(1, 65791, '\P{^Is_Block=linearbideograms}', "");
    Expect(0, 65792, '\p{Is_Block=linearbideograms}', "");
    Expect(1, 65792, '\p{^Is_Block=linearbideograms}', "");
    Expect(1, 65792, '\P{Is_Block=linearbideograms}', "");
    Expect(0, 65792, '\P{^Is_Block=linearbideograms}', "");
    Expect(1, 65791, '\p{Is_Block=	-linear_B_ideograms}', "");
    Expect(0, 65791, '\p{^Is_Block=	-linear_B_ideograms}', "");
    Expect(0, 65791, '\P{Is_Block=	-linear_B_ideograms}', "");
    Expect(1, 65791, '\P{^Is_Block=	-linear_B_ideograms}', "");
    Expect(0, 65792, '\p{Is_Block=	-linear_B_ideograms}', "");
    Expect(1, 65792, '\p{^Is_Block=	-linear_B_ideograms}', "");
    Expect(1, 65792, '\P{Is_Block=	-linear_B_ideograms}', "");
    Expect(0, 65792, '\P{^Is_Block=	-linear_B_ideograms}', "");
    Error('\p{Is_Blk=-_linear_B_ideograms:=}');
    Error('\P{Is_Blk=-_linear_B_ideograms:=}');
    Expect(1, 65791, '\p{Is_Blk=linearbideograms}', "");
    Expect(0, 65791, '\p{^Is_Blk=linearbideograms}', "");
    Expect(0, 65791, '\P{Is_Blk=linearbideograms}', "");
    Expect(1, 65791, '\P{^Is_Blk=linearbideograms}', "");
    Expect(0, 65792, '\p{Is_Blk=linearbideograms}', "");
    Expect(1, 65792, '\p{^Is_Blk=linearbideograms}', "");
    Expect(1, 65792, '\P{Is_Blk=linearbideograms}', "");
    Expect(0, 65792, '\P{^Is_Blk=linearbideograms}', "");
    Expect(1, 65791, '\p{Is_Blk:	_ linear_B_IDEOGRAMS}', "");
    Expect(0, 65791, '\p{^Is_Blk:	_ linear_B_IDEOGRAMS}', "");
    Expect(0, 65791, '\P{Is_Blk:	_ linear_B_IDEOGRAMS}', "");
    Expect(1, 65791, '\P{^Is_Blk:	_ linear_B_IDEOGRAMS}', "");
    Expect(0, 65792, '\p{Is_Blk:	_ linear_B_IDEOGRAMS}', "");
    Expect(1, 65792, '\p{^Is_Blk:	_ linear_B_IDEOGRAMS}', "");
    Expect(1, 65792, '\P{Is_Blk:	_ linear_B_IDEOGRAMS}', "");
    Expect(0, 65792, '\P{^Is_Blk:	_ linear_B_IDEOGRAMS}', "");
    Error('\p{Block=- linear_b_Syllabary/a/}');
    Error('\P{Block=- linear_b_Syllabary/a/}');
    Expect(1, 65663, '\p{Block=:\ALinear_B_Syllabary\z:}', "");;
    Expect(0, 65664, '\p{Block=:\ALinear_B_Syllabary\z:}', "");;
    Expect(1, 65663, '\p{Block=linearbsyllabary}', "");
    Expect(0, 65663, '\p{^Block=linearbsyllabary}', "");
    Expect(0, 65663, '\P{Block=linearbsyllabary}', "");
    Expect(1, 65663, '\P{^Block=linearbsyllabary}', "");
    Expect(0, 65664, '\p{Block=linearbsyllabary}', "");
    Expect(1, 65664, '\p{^Block=linearbsyllabary}', "");
    Expect(1, 65664, '\P{Block=linearbsyllabary}', "");
    Expect(0, 65664, '\P{^Block=linearbsyllabary}', "");
    Expect(1, 65663, '\p{Block=:\Alinearbsyllabary\z:}', "");;
    Expect(0, 65664, '\p{Block=:\Alinearbsyllabary\z:}', "");;
    Expect(1, 65663, '\p{Block= -LINEAR_B_syllabary}', "");
    Expect(0, 65663, '\p{^Block= -LINEAR_B_syllabary}', "");
    Expect(0, 65663, '\P{Block= -LINEAR_B_syllabary}', "");
    Expect(1, 65663, '\P{^Block= -LINEAR_B_syllabary}', "");
    Expect(0, 65664, '\p{Block= -LINEAR_B_syllabary}', "");
    Expect(1, 65664, '\p{^Block= -LINEAR_B_syllabary}', "");
    Expect(1, 65664, '\P{Block= -LINEAR_B_syllabary}', "");
    Expect(0, 65664, '\P{^Block= -LINEAR_B_syllabary}', "");
    Error('\p{Blk=-/a/Linear_B_syllabary}');
    Error('\P{Blk=-/a/Linear_B_syllabary}');
    Expect(1, 65663, '\p{Blk=:\ALinear_B_Syllabary\z:}', "");;
    Expect(0, 65664, '\p{Blk=:\ALinear_B_Syllabary\z:}', "");;
    Expect(1, 65663, '\p{Blk=linearbsyllabary}', "");
    Expect(0, 65663, '\p{^Blk=linearbsyllabary}', "");
    Expect(0, 65663, '\P{Blk=linearbsyllabary}', "");
    Expect(1, 65663, '\P{^Blk=linearbsyllabary}', "");
    Expect(0, 65664, '\p{Blk=linearbsyllabary}', "");
    Expect(1, 65664, '\p{^Blk=linearbsyllabary}', "");
    Expect(1, 65664, '\P{Blk=linearbsyllabary}', "");
    Expect(0, 65664, '\P{^Blk=linearbsyllabary}', "");
    Expect(1, 65663, '\p{Blk=:\Alinearbsyllabary\z:}', "");;
    Expect(0, 65664, '\p{Blk=:\Alinearbsyllabary\z:}', "");;
    Expect(1, 65663, '\p{Blk=  Linear_B_SYLLABARY}', "");
    Expect(0, 65663, '\p{^Blk=  Linear_B_SYLLABARY}', "");
    Expect(0, 65663, '\P{Blk=  Linear_B_SYLLABARY}', "");
    Expect(1, 65663, '\P{^Blk=  Linear_B_SYLLABARY}', "");
    Expect(0, 65664, '\p{Blk=  Linear_B_SYLLABARY}', "");
    Expect(1, 65664, '\p{^Blk=  Linear_B_SYLLABARY}', "");
    Expect(1, 65664, '\P{Blk=  Linear_B_SYLLABARY}', "");
    Expect(0, 65664, '\P{^Blk=  Linear_B_SYLLABARY}', "");
    Error('\p{Is_Block=:= LINEAR_B_SYLLABARY}');
    Error('\P{Is_Block=:= LINEAR_B_SYLLABARY}');
    Expect(1, 65663, '\p{Is_Block=linearbsyllabary}', "");
    Expect(0, 65663, '\p{^Is_Block=linearbsyllabary}', "");
    Expect(0, 65663, '\P{Is_Block=linearbsyllabary}', "");
    Expect(1, 65663, '\P{^Is_Block=linearbsyllabary}', "");
    Expect(0, 65664, '\p{Is_Block=linearbsyllabary}', "");
    Expect(1, 65664, '\p{^Is_Block=linearbsyllabary}', "");
    Expect(1, 65664, '\P{Is_Block=linearbsyllabary}', "");
    Expect(0, 65664, '\P{^Is_Block=linearbsyllabary}', "");
    Expect(1, 65663, '\p{Is_Block=_ Linear_B_Syllabary}', "");
    Expect(0, 65663, '\p{^Is_Block=_ Linear_B_Syllabary}', "");
    Expect(0, 65663, '\P{Is_Block=_ Linear_B_Syllabary}', "");
    Expect(1, 65663, '\P{^Is_Block=_ Linear_B_Syllabary}', "");
    Expect(0, 65664, '\p{Is_Block=_ Linear_B_Syllabary}', "");
    Expect(1, 65664, '\p{^Is_Block=_ Linear_B_Syllabary}', "");
    Expect(1, 65664, '\P{Is_Block=_ Linear_B_Syllabary}', "");
    Expect(0, 65664, '\P{^Is_Block=_ Linear_B_Syllabary}', "");
    Error('\p{Is_Blk:   	:=linear_b_SYLLABARY}');
    Error('\P{Is_Blk:   	:=linear_b_SYLLABARY}');
    Expect(1, 65663, '\p{Is_Blk=linearbsyllabary}', "");
    Expect(0, 65663, '\p{^Is_Blk=linearbsyllabary}', "");
    Expect(0, 65663, '\P{Is_Blk=linearbsyllabary}', "");
    Expect(1, 65663, '\P{^Is_Blk=linearbsyllabary}', "");
    Expect(0, 65664, '\p{Is_Blk=linearbsyllabary}', "");
    Expect(1, 65664, '\p{^Is_Blk=linearbsyllabary}', "");
    Expect(1, 65664, '\P{Is_Blk=linearbsyllabary}', "");
    Expect(0, 65664, '\P{^Is_Blk=linearbsyllabary}', "");
    Expect(1, 65663, '\p{Is_Blk=__Linear_B_Syllabary}', "");
    Expect(0, 65663, '\p{^Is_Blk=__Linear_B_Syllabary}', "");
    Expect(0, 65663, '\P{Is_Blk=__Linear_B_Syllabary}', "");
    Expect(1, 65663, '\P{^Is_Blk=__Linear_B_Syllabary}', "");
    Expect(0, 65664, '\p{Is_Blk=__Linear_B_Syllabary}', "");
    Expect(1, 65664, '\p{^Is_Blk=__Linear_B_Syllabary}', "");
    Expect(1, 65664, '\P{Is_Blk=__Linear_B_Syllabary}', "");
    Expect(0, 65664, '\P{^Is_Blk=__Linear_B_Syllabary}', "");
    Error('\p{Block=:=__Lisu}');
    Error('\P{Block=:=__Lisu}');
    Expect(1, 42239, '\p{Block=:\ALisu\z:}', "");;
    Expect(0, 42240, '\p{Block=:\ALisu\z:}', "");;
    Expect(1, 42239, '\p{Block=lisu}', "");
    Expect(0, 42239, '\p{^Block=lisu}', "");
    Expect(0, 42239, '\P{Block=lisu}', "");
    Expect(1, 42239, '\P{^Block=lisu}', "");
    Expect(0, 42240, '\p{Block=lisu}', "");
    Expect(1, 42240, '\p{^Block=lisu}', "");
    Expect(1, 42240, '\P{Block=lisu}', "");
    Expect(0, 42240, '\P{^Block=lisu}', "");
    Expect(1, 42239, '\p{Block=:\Alisu\z:}', "");;
    Expect(0, 42240, '\p{Block=:\Alisu\z:}', "");;
    Expect(1, 42239, '\p{Block=	-Lisu}', "");
    Expect(0, 42239, '\p{^Block=	-Lisu}', "");
    Expect(0, 42239, '\P{Block=	-Lisu}', "");
    Expect(1, 42239, '\P{^Block=	-Lisu}', "");
    Expect(0, 42240, '\p{Block=	-Lisu}', "");
    Expect(1, 42240, '\p{^Block=	-Lisu}', "");
    Expect(1, 42240, '\P{Block=	-Lisu}', "");
    Expect(0, 42240, '\P{^Block=	-Lisu}', "");
    Error('\p{Blk= :=Lisu}');
    Error('\P{Blk= :=Lisu}');
    Expect(1, 42239, '\p{Blk=:\ALisu\z:}', "");;
    Expect(0, 42240, '\p{Blk=:\ALisu\z:}', "");;
    Expect(1, 42239, '\p{Blk=lisu}', "");
    Expect(0, 42239, '\p{^Blk=lisu}', "");
    Expect(0, 42239, '\P{Blk=lisu}', "");
    Expect(1, 42239, '\P{^Blk=lisu}', "");
    Expect(0, 42240, '\p{Blk=lisu}', "");
    Expect(1, 42240, '\p{^Blk=lisu}', "");
    Expect(1, 42240, '\P{Blk=lisu}', "");
    Expect(0, 42240, '\P{^Blk=lisu}', "");
    Expect(1, 42239, '\p{Blk=:\Alisu\z:}', "");;
    Expect(0, 42240, '\p{Blk=:\Alisu\z:}', "");;
    Expect(1, 42239, '\p{Blk=--Lisu}', "");
    Expect(0, 42239, '\p{^Blk=--Lisu}', "");
    Expect(0, 42239, '\P{Blk=--Lisu}', "");
    Expect(1, 42239, '\P{^Blk=--Lisu}', "");
    Expect(0, 42240, '\p{Blk=--Lisu}', "");
    Expect(1, 42240, '\p{^Blk=--Lisu}', "");
    Expect(1, 42240, '\P{Blk=--Lisu}', "");
    Expect(0, 42240, '\P{^Blk=--Lisu}', "");
    Error('\p{Is_Block=:=_	Lisu}');
    Error('\P{Is_Block=:=_	Lisu}');
    Expect(1, 42239, '\p{Is_Block=lisu}', "");
    Expect(0, 42239, '\p{^Is_Block=lisu}', "");
    Expect(0, 42239, '\P{Is_Block=lisu}', "");
    Expect(1, 42239, '\P{^Is_Block=lisu}', "");
    Expect(0, 42240, '\p{Is_Block=lisu}', "");
    Expect(1, 42240, '\p{^Is_Block=lisu}', "");
    Expect(1, 42240, '\P{Is_Block=lisu}', "");
    Expect(0, 42240, '\P{^Is_Block=lisu}', "");
    Expect(1, 42239, '\p{Is_Block=_Lisu}', "");
    Expect(0, 42239, '\p{^Is_Block=_Lisu}', "");
    Expect(0, 42239, '\P{Is_Block=_Lisu}', "");
    Expect(1, 42239, '\P{^Is_Block=_Lisu}', "");
    Expect(0, 42240, '\p{Is_Block=_Lisu}', "");
    Expect(1, 42240, '\p{^Is_Block=_Lisu}', "");
    Expect(1, 42240, '\P{Is_Block=_Lisu}', "");
    Expect(0, 42240, '\P{^Is_Block=_Lisu}', "");
    Error('\p{Is_Blk=:=Lisu}');
    Error('\P{Is_Blk=:=Lisu}');
    Expect(1, 42239, '\p{Is_Blk=lisu}', "");
    Expect(0, 42239, '\p{^Is_Blk=lisu}', "");
    Expect(0, 42239, '\P{Is_Blk=lisu}', "");
    Expect(1, 42239, '\P{^Is_Blk=lisu}', "");
    Expect(0, 42240, '\p{Is_Blk=lisu}', "");
    Expect(1, 42240, '\p{^Is_Blk=lisu}', "");
    Expect(1, 42240, '\P{Is_Blk=lisu}', "");
    Expect(0, 42240, '\P{^Is_Blk=lisu}', "");
    Expect(1, 42239, '\p{Is_Blk=	Lisu}', "");
    Expect(0, 42239, '\p{^Is_Blk=	Lisu}', "");
    Expect(0, 42239, '\P{Is_Blk=	Lisu}', "");
    Expect(1, 42239, '\P{^Is_Blk=	Lisu}', "");
    Expect(0, 42240, '\p{Is_Blk=	Lisu}', "");
    Expect(1, 42240, '\p{^Is_Blk=	Lisu}', "");
    Expect(1, 42240, '\P{Is_Blk=	Lisu}', "");
    Expect(0, 42240, '\P{^Is_Blk=	Lisu}', "");
    Error('\p{Block:	/a/lisu_Supplement}');
    Error('\P{Block:	/a/lisu_Supplement}');
    Expect(1, 73663, '\p{Block=:\ALisu_Supplement\z:}', "");;
    Expect(0, 73664, '\p{Block=:\ALisu_Supplement\z:}', "");;
    Expect(1, 73663, '\p{Block=lisusupplement}', "");
    Expect(0, 73663, '\p{^Block=lisusupplement}', "");
    Expect(0, 73663, '\P{Block=lisusupplement}', "");
    Expect(1, 73663, '\P{^Block=lisusupplement}', "");
    Expect(0, 73664, '\p{Block=lisusupplement}', "");
    Expect(1, 73664, '\p{^Block=lisusupplement}', "");
    Expect(1, 73664, '\P{Block=lisusupplement}', "");
    Expect(0, 73664, '\P{^Block=lisusupplement}', "");
    Expect(1, 73663, '\p{Block=:\Alisusupplement\z:}', "");;
    Expect(0, 73664, '\p{Block=:\Alisusupplement\z:}', "");;
    Expect(1, 73663, '\p{Block= Lisu_Supplement}', "");
    Expect(0, 73663, '\p{^Block= Lisu_Supplement}', "");
    Expect(0, 73663, '\P{Block= Lisu_Supplement}', "");
    Expect(1, 73663, '\P{^Block= Lisu_Supplement}', "");
    Expect(0, 73664, '\p{Block= Lisu_Supplement}', "");
    Expect(1, 73664, '\p{^Block= Lisu_Supplement}', "");
    Expect(1, 73664, '\P{Block= Lisu_Supplement}', "");
    Expect(0, 73664, '\P{^Block= Lisu_Supplement}', "");
    Error('\p{Blk=/a/	 Lisu_sup}');
    Error('\P{Blk=/a/	 Lisu_sup}');
    Expect(1, 73663, '\p{Blk=:\ALisu_Sup\z:}', "");;
    Expect(0, 73664, '\p{Blk=:\ALisu_Sup\z:}', "");;
    Expect(1, 73663, '\p{Blk=lisusup}', "");
    Expect(0, 73663, '\p{^Blk=lisusup}', "");
    Expect(0, 73663, '\P{Blk=lisusup}', "");
    Expect(1, 73663, '\P{^Blk=lisusup}', "");
    Expect(0, 73664, '\p{Blk=lisusup}', "");
    Expect(1, 73664, '\p{^Blk=lisusup}', "");
    Expect(1, 73664, '\P{Blk=lisusup}', "");
    Expect(0, 73664, '\P{^Blk=lisusup}', "");
    Expect(1, 73663, '\p{Blk=:\Alisusup\z:}', "");;
    Expect(0, 73664, '\p{Blk=:\Alisusup\z:}', "");;
    Expect(1, 73663, '\p{Blk=_	LISU_SUP}', "");
    Expect(0, 73663, '\p{^Blk=_	LISU_SUP}', "");
    Expect(0, 73663, '\P{Blk=_	LISU_SUP}', "");
    Expect(1, 73663, '\P{^Blk=_	LISU_SUP}', "");
    Expect(0, 73664, '\p{Blk=_	LISU_SUP}', "");
    Expect(1, 73664, '\p{^Blk=_	LISU_SUP}', "");
    Expect(1, 73664, '\P{Blk=_	LISU_SUP}', "");
    Expect(0, 73664, '\P{^Blk=_	LISU_SUP}', "");
    Error('\p{Is_Block=_Lisu_Supplement/a/}');
    Error('\P{Is_Block=_Lisu_Supplement/a/}');
    Expect(1, 73663, '\p{Is_Block=lisusupplement}', "");
    Expect(0, 73663, '\p{^Is_Block=lisusupplement}', "");
    Expect(0, 73663, '\P{Is_Block=lisusupplement}', "");
    Expect(1, 73663, '\P{^Is_Block=lisusupplement}', "");
    Expect(0, 73664, '\p{Is_Block=lisusupplement}', "");
    Expect(1, 73664, '\p{^Is_Block=lisusupplement}', "");
    Expect(1, 73664, '\P{Is_Block=lisusupplement}', "");
    Expect(0, 73664, '\P{^Is_Block=lisusupplement}', "");
    Expect(1, 73663, '\p{Is_Block=- LISU_SUPPLEMENT}', "");
    Expect(0, 73663, '\p{^Is_Block=- LISU_SUPPLEMENT}', "");
    Expect(0, 73663, '\P{Is_Block=- LISU_SUPPLEMENT}', "");
    Expect(1, 73663, '\P{^Is_Block=- LISU_SUPPLEMENT}', "");
    Expect(0, 73664, '\p{Is_Block=- LISU_SUPPLEMENT}', "");
    Expect(1, 73664, '\p{^Is_Block=- LISU_SUPPLEMENT}', "");
    Expect(1, 73664, '\P{Is_Block=- LISU_SUPPLEMENT}', "");
    Expect(0, 73664, '\P{^Is_Block=- LISU_SUPPLEMENT}', "");
    Error('\p{Is_Blk=:=	Lisu_Sup}');
    Error('\P{Is_Blk=:=	Lisu_Sup}');
    Expect(1, 73663, '\p{Is_Blk=lisusup}', "");
    Expect(0, 73663, '\p{^Is_Blk=lisusup}', "");
    Expect(0, 73663, '\P{Is_Blk=lisusup}', "");
    Expect(1, 73663, '\P{^Is_Blk=lisusup}', "");
    Expect(0, 73664, '\p{Is_Blk=lisusup}', "");
    Expect(1, 73664, '\p{^Is_Blk=lisusup}', "");
    Expect(1, 73664, '\P{Is_Blk=lisusup}', "");
    Expect(0, 73664, '\P{^Is_Blk=lisusup}', "");
    Expect(1, 73663, '\p{Is_Blk= Lisu_SUP}', "");
    Expect(0, 73663, '\p{^Is_Blk= Lisu_SUP}', "");
    Expect(0, 73663, '\P{Is_Blk= Lisu_SUP}', "");
    Expect(1, 73663, '\P{^Is_Blk= Lisu_SUP}', "");
    Expect(0, 73664, '\p{Is_Blk= Lisu_SUP}', "");
    Expect(1, 73664, '\p{^Is_Blk= Lisu_SUP}', "");
    Expect(1, 73664, '\P{Is_Blk= Lisu_SUP}', "");
    Expect(0, 73664, '\P{^Is_Blk= Lisu_SUP}', "");
    Error('\p{Block= Low_SURROGATES/a/}');
    Error('\P{Block= Low_SURROGATES/a/}');
    Expect(1, 57343, '\p{Block=:\ALow_Surrogates\z:}', "");;
    Expect(0, 57344, '\p{Block=:\ALow_Surrogates\z:}', "");;
    Expect(1, 57343, '\p{Block=lowsurrogates}', "");
    Expect(0, 57343, '\p{^Block=lowsurrogates}', "");
    Expect(0, 57343, '\P{Block=lowsurrogates}', "");
    Expect(1, 57343, '\P{^Block=lowsurrogates}', "");
    Expect(0, 57344, '\p{Block=lowsurrogates}', "");
    Expect(1, 57344, '\p{^Block=lowsurrogates}', "");
    Expect(1, 57344, '\P{Block=lowsurrogates}', "");
    Expect(0, 57344, '\P{^Block=lowsurrogates}', "");
    Expect(1, 57343, '\p{Block=:\Alowsurrogates\z:}', "");;
    Expect(0, 57344, '\p{Block=:\Alowsurrogates\z:}', "");;
    Expect(1, 57343, '\p{Block=__Low_Surrogates}', "");
    Expect(0, 57343, '\p{^Block=__Low_Surrogates}', "");
    Expect(0, 57343, '\P{Block=__Low_Surrogates}', "");
    Expect(1, 57343, '\P{^Block=__Low_Surrogates}', "");
    Expect(0, 57344, '\p{Block=__Low_Surrogates}', "");
    Expect(1, 57344, '\p{^Block=__Low_Surrogates}', "");
    Expect(1, 57344, '\P{Block=__Low_Surrogates}', "");
    Expect(0, 57344, '\P{^Block=__Low_Surrogates}', "");
    Error('\p{Blk=	 low_Surrogates:=}');
    Error('\P{Blk=	 low_Surrogates:=}');
    Expect(1, 57343, '\p{Blk=:\ALow_Surrogates\z:}', "");;
    Expect(0, 57344, '\p{Blk=:\ALow_Surrogates\z:}', "");;
    Expect(1, 57343, '\p{Blk=lowsurrogates}', "");
    Expect(0, 57343, '\p{^Blk=lowsurrogates}', "");
    Expect(0, 57343, '\P{Blk=lowsurrogates}', "");
    Expect(1, 57343, '\P{^Blk=lowsurrogates}', "");
    Expect(0, 57344, '\p{Blk=lowsurrogates}', "");
    Expect(1, 57344, '\p{^Blk=lowsurrogates}', "");
    Expect(1, 57344, '\P{Blk=lowsurrogates}', "");
    Expect(0, 57344, '\P{^Blk=lowsurrogates}', "");
    Expect(1, 57343, '\p{Blk=:\Alowsurrogates\z:}', "");;
    Expect(0, 57344, '\p{Blk=:\Alowsurrogates\z:}', "");;
    Expect(1, 57343, '\p{Blk= -Low_Surrogates}', "");
    Expect(0, 57343, '\p{^Blk= -Low_Surrogates}', "");
    Expect(0, 57343, '\P{Blk= -Low_Surrogates}', "");
    Expect(1, 57343, '\P{^Blk= -Low_Surrogates}', "");
    Expect(0, 57344, '\p{Blk= -Low_Surrogates}', "");
    Expect(1, 57344, '\p{^Blk= -Low_Surrogates}', "");
    Expect(1, 57344, '\P{Blk= -Low_Surrogates}', "");
    Expect(0, 57344, '\P{^Blk= -Low_Surrogates}', "");
    Error('\p{Is_Block:   _	Low_Surrogates:=}');
    Error('\P{Is_Block:   _	Low_Surrogates:=}');
    Expect(1, 57343, '\p{Is_Block=lowsurrogates}', "");
    Expect(0, 57343, '\p{^Is_Block=lowsurrogates}', "");
    Expect(0, 57343, '\P{Is_Block=lowsurrogates}', "");
    Expect(1, 57343, '\P{^Is_Block=lowsurrogates}', "");
    Expect(0, 57344, '\p{Is_Block=lowsurrogates}', "");
    Expect(1, 57344, '\p{^Is_Block=lowsurrogates}', "");
    Expect(1, 57344, '\P{Is_Block=lowsurrogates}', "");
    Expect(0, 57344, '\P{^Is_Block=lowsurrogates}', "");
    Expect(1, 57343, '\p{Is_Block= _Low_SURROGATES}', "");
    Expect(0, 57343, '\p{^Is_Block= _Low_SURROGATES}', "");
    Expect(0, 57343, '\P{Is_Block= _Low_SURROGATES}', "");
    Expect(1, 57343, '\P{^Is_Block= _Low_SURROGATES}', "");
    Expect(0, 57344, '\p{Is_Block= _Low_SURROGATES}', "");
    Expect(1, 57344, '\p{^Is_Block= _Low_SURROGATES}', "");
    Expect(1, 57344, '\P{Is_Block= _Low_SURROGATES}', "");
    Expect(0, 57344, '\P{^Is_Block= _Low_SURROGATES}', "");
    Error('\p{Is_Blk=_ Low_Surrogates:=}');
    Error('\P{Is_Blk=_ Low_Surrogates:=}');
    Expect(1, 57343, '\p{Is_Blk=lowsurrogates}', "");
    Expect(0, 57343, '\p{^Is_Blk=lowsurrogates}', "");
    Expect(0, 57343, '\P{Is_Blk=lowsurrogates}', "");
    Expect(1, 57343, '\P{^Is_Blk=lowsurrogates}', "");
    Expect(0, 57344, '\p{Is_Blk=lowsurrogates}', "");
    Expect(1, 57344, '\p{^Is_Blk=lowsurrogates}', "");
    Expect(1, 57344, '\P{Is_Blk=lowsurrogates}', "");
    Expect(0, 57344, '\P{^Is_Blk=lowsurrogates}', "");
    Expect(1, 57343, '\p{Is_Blk= _Low_Surrogates}', "");
    Expect(0, 57343, '\p{^Is_Blk= _Low_Surrogates}', "");
    Expect(0, 57343, '\P{Is_Blk= _Low_Surrogates}', "");
    Expect(1, 57343, '\P{^Is_Blk= _Low_Surrogates}', "");
    Expect(0, 57344, '\p{Is_Blk= _Low_Surrogates}', "");
    Expect(1, 57344, '\p{^Is_Blk= _Low_Surrogates}', "");
    Expect(1, 57344, '\P{Is_Blk= _Low_Surrogates}', "");
    Expect(0, 57344, '\P{^Is_Blk= _Low_Surrogates}', "");
    Error('\p{Block=	LYCIAN/a/}');
    Error('\P{Block=	LYCIAN/a/}');
    Expect(1, 66207, '\p{Block=:\ALycian\z:}', "");;
    Expect(0, 66208, '\p{Block=:\ALycian\z:}', "");;
    Expect(1, 66207, '\p{Block=lycian}', "");
    Expect(0, 66207, '\p{^Block=lycian}', "");
    Expect(0, 66207, '\P{Block=lycian}', "");
    Expect(1, 66207, '\P{^Block=lycian}', "");
    Expect(0, 66208, '\p{Block=lycian}', "");
    Expect(1, 66208, '\p{^Block=lycian}', "");
    Expect(1, 66208, '\P{Block=lycian}', "");
    Expect(0, 66208, '\P{^Block=lycian}', "");
    Expect(1, 66207, '\p{Block=:\Alycian\z:}', "");;
    Expect(0, 66208, '\p{Block=:\Alycian\z:}', "");;
    Expect(1, 66207, '\p{Block=	 LYCIAN}', "");
    Expect(0, 66207, '\p{^Block=	 LYCIAN}', "");
    Expect(0, 66207, '\P{Block=	 LYCIAN}', "");
    Expect(1, 66207, '\P{^Block=	 LYCIAN}', "");
    Expect(0, 66208, '\p{Block=	 LYCIAN}', "");
    Expect(1, 66208, '\p{^Block=	 LYCIAN}', "");
    Expect(1, 66208, '\P{Block=	 LYCIAN}', "");
    Expect(0, 66208, '\P{^Block=	 LYCIAN}', "");
    Error('\p{Blk=/a/Lycian}');
    Error('\P{Blk=/a/Lycian}');
    Expect(1, 66207, '\p{Blk=:\ALycian\z:}', "");;
    Expect(0, 66208, '\p{Blk=:\ALycian\z:}', "");;
    Expect(1, 66207, '\p{Blk=lycian}', "");
    Expect(0, 66207, '\p{^Blk=lycian}', "");
    Expect(0, 66207, '\P{Blk=lycian}', "");
    Expect(1, 66207, '\P{^Blk=lycian}', "");
    Expect(0, 66208, '\p{Blk=lycian}', "");
    Expect(1, 66208, '\p{^Blk=lycian}', "");
    Expect(1, 66208, '\P{Blk=lycian}', "");
    Expect(0, 66208, '\P{^Blk=lycian}', "");
    Expect(1, 66207, '\p{Blk=:\Alycian\z:}', "");;
    Expect(0, 66208, '\p{Blk=:\Alycian\z:}', "");;
    Expect(1, 66207, '\p{Blk=__lycian}', "");
    Expect(0, 66207, '\p{^Blk=__lycian}', "");
    Expect(0, 66207, '\P{Blk=__lycian}', "");
    Expect(1, 66207, '\P{^Blk=__lycian}', "");
    Expect(0, 66208, '\p{Blk=__lycian}', "");
    Expect(1, 66208, '\p{^Blk=__lycian}', "");
    Expect(1, 66208, '\P{Blk=__lycian}', "");
    Expect(0, 66208, '\P{^Blk=__lycian}', "");
    Error('\p{Is_Block=/a/LYCIAN}');
    Error('\P{Is_Block=/a/LYCIAN}');
    Expect(1, 66207, '\p{Is_Block:   lycian}', "");
    Expect(0, 66207, '\p{^Is_Block:   lycian}', "");
    Expect(0, 66207, '\P{Is_Block:   lycian}', "");
    Expect(1, 66207, '\P{^Is_Block:   lycian}', "");
    Expect(0, 66208, '\p{Is_Block:   lycian}', "");
    Expect(1, 66208, '\p{^Is_Block:   lycian}', "");
    Expect(1, 66208, '\P{Is_Block:   lycian}', "");
    Expect(0, 66208, '\P{^Is_Block:   lycian}', "");
    Expect(1, 66207, '\p{Is_Block=_ LYCIAN}', "");
    Expect(0, 66207, '\p{^Is_Block=_ LYCIAN}', "");
    Expect(0, 66207, '\P{Is_Block=_ LYCIAN}', "");
    Expect(1, 66207, '\P{^Is_Block=_ LYCIAN}', "");
    Expect(0, 66208, '\p{Is_Block=_ LYCIAN}', "");
    Expect(1, 66208, '\p{^Is_Block=_ LYCIAN}', "");
    Expect(1, 66208, '\P{Is_Block=_ LYCIAN}', "");
    Expect(0, 66208, '\P{^Is_Block=_ LYCIAN}', "");
    Error('\p{Is_Blk=/a/ Lycian}');
    Error('\P{Is_Blk=/a/ Lycian}');
    Expect(1, 66207, '\p{Is_Blk=lycian}', "");
    Expect(0, 66207, '\p{^Is_Blk=lycian}', "");
    Expect(0, 66207, '\P{Is_Blk=lycian}', "");
    Expect(1, 66207, '\P{^Is_Blk=lycian}', "");
    Expect(0, 66208, '\p{Is_Blk=lycian}', "");
    Expect(1, 66208, '\p{^Is_Blk=lycian}', "");
    Expect(1, 66208, '\P{Is_Blk=lycian}', "");
    Expect(0, 66208, '\P{^Is_Blk=lycian}', "");
    Expect(1, 66207, '\p{Is_Blk=-LYCIAN}', "");
    Expect(0, 66207, '\p{^Is_Blk=-LYCIAN}', "");
    Expect(0, 66207, '\P{Is_Blk=-LYCIAN}', "");
    Expect(1, 66207, '\P{^Is_Blk=-LYCIAN}', "");
    Expect(0, 66208, '\p{Is_Blk=-LYCIAN}', "");
    Expect(1, 66208, '\p{^Is_Blk=-LYCIAN}', "");
    Expect(1, 66208, '\P{Is_Blk=-LYCIAN}', "");
    Expect(0, 66208, '\P{^Is_Blk=-LYCIAN}', "");
    Error('\p{Block=/a/Lydian}');
    Error('\P{Block=/a/Lydian}');
    Expect(1, 67903, '\p{Block=:\ALydian\z:}', "");;
    Expect(0, 67904, '\p{Block=:\ALydian\z:}', "");;
    Expect(1, 67903, '\p{Block=lydian}', "");
    Expect(0, 67903, '\p{^Block=lydian}', "");
    Expect(0, 67903, '\P{Block=lydian}', "");
    Expect(1, 67903, '\P{^Block=lydian}', "");
    Expect(0, 67904, '\p{Block=lydian}', "");
    Expect(1, 67904, '\p{^Block=lydian}', "");
    Expect(1, 67904, '\P{Block=lydian}', "");
    Expect(0, 67904, '\P{^Block=lydian}', "");
    Expect(1, 67903, '\p{Block=:\Alydian\z:}', "");;
    Expect(0, 67904, '\p{Block=:\Alydian\z:}', "");;
    Expect(1, 67903, '\p{Block:		Lydian}', "");
    Expect(0, 67903, '\p{^Block:		Lydian}', "");
    Expect(0, 67903, '\P{Block:		Lydian}', "");
    Expect(1, 67903, '\P{^Block:		Lydian}', "");
    Expect(0, 67904, '\p{Block:		Lydian}', "");
    Expect(1, 67904, '\p{^Block:		Lydian}', "");
    Expect(1, 67904, '\P{Block:		Lydian}', "");
    Expect(0, 67904, '\P{^Block:		Lydian}', "");
    Error('\p{Blk=:=Lydian}');
    Error('\P{Blk=:=Lydian}');
    Expect(1, 67903, '\p{Blk=:\ALydian\z:}', "");;
    Expect(0, 67904, '\p{Blk=:\ALydian\z:}', "");;
    Expect(1, 67903, '\p{Blk=lydian}', "");
    Expect(0, 67903, '\p{^Blk=lydian}', "");
    Expect(0, 67903, '\P{Blk=lydian}', "");
    Expect(1, 67903, '\P{^Blk=lydian}', "");
    Expect(0, 67904, '\p{Blk=lydian}', "");
    Expect(1, 67904, '\p{^Blk=lydian}', "");
    Expect(1, 67904, '\P{Blk=lydian}', "");
    Expect(0, 67904, '\P{^Blk=lydian}', "");
    Expect(1, 67903, '\p{Blk=:\Alydian\z:}', "");;
    Expect(0, 67904, '\p{Blk=:\Alydian\z:}', "");;
    Expect(1, 67903, '\p{Blk=		Lydian}', "");
    Expect(0, 67903, '\p{^Blk=		Lydian}', "");
    Expect(0, 67903, '\P{Blk=		Lydian}', "");
    Expect(1, 67903, '\P{^Blk=		Lydian}', "");
    Expect(0, 67904, '\p{Blk=		Lydian}', "");
    Expect(1, 67904, '\p{^Blk=		Lydian}', "");
    Expect(1, 67904, '\P{Blk=		Lydian}', "");
    Expect(0, 67904, '\P{^Blk=		Lydian}', "");
    Error('\p{Is_Block=/a/__Lydian}');
    Error('\P{Is_Block=/a/__Lydian}');
    Expect(1, 67903, '\p{Is_Block=lydian}', "");
    Expect(0, 67903, '\p{^Is_Block=lydian}', "");
    Expect(0, 67903, '\P{Is_Block=lydian}', "");
    Expect(1, 67903, '\P{^Is_Block=lydian}', "");
    Expect(0, 67904, '\p{Is_Block=lydian}', "");
    Expect(1, 67904, '\p{^Is_Block=lydian}', "");
    Expect(1, 67904, '\P{Is_Block=lydian}', "");
    Expect(0, 67904, '\P{^Is_Block=lydian}', "");
    Expect(1, 67903, '\p{Is_Block=	Lydian}', "");
    Expect(0, 67903, '\p{^Is_Block=	Lydian}', "");
    Expect(0, 67903, '\P{Is_Block=	Lydian}', "");
    Expect(1, 67903, '\P{^Is_Block=	Lydian}', "");
    Expect(0, 67904, '\p{Is_Block=	Lydian}', "");
    Expect(1, 67904, '\p{^Is_Block=	Lydian}', "");
    Expect(1, 67904, '\P{Is_Block=	Lydian}', "");
    Expect(0, 67904, '\P{^Is_Block=	Lydian}', "");
    Error('\p{Is_Blk:	-:=lydian}');
    Error('\P{Is_Blk:	-:=lydian}');
    Expect(1, 67903, '\p{Is_Blk=lydian}', "");
    Expect(0, 67903, '\p{^Is_Blk=lydian}', "");
    Expect(0, 67903, '\P{Is_Blk=lydian}', "");
    Expect(1, 67903, '\P{^Is_Blk=lydian}', "");
    Expect(0, 67904, '\p{Is_Blk=lydian}', "");
    Expect(1, 67904, '\p{^Is_Blk=lydian}', "");
    Expect(1, 67904, '\P{Is_Blk=lydian}', "");
    Expect(0, 67904, '\P{^Is_Blk=lydian}', "");
    Expect(1, 67903, '\p{Is_Blk=-Lydian}', "");
    Expect(0, 67903, '\p{^Is_Blk=-Lydian}', "");
    Expect(0, 67903, '\P{Is_Blk=-Lydian}', "");
    Expect(1, 67903, '\P{^Is_Blk=-Lydian}', "");
    Expect(0, 67904, '\p{Is_Blk=-Lydian}', "");
    Expect(1, 67904, '\p{^Is_Blk=-Lydian}', "");
    Expect(1, 67904, '\P{Is_Blk=-Lydian}', "");
    Expect(0, 67904, '\P{^Is_Blk=-Lydian}', "");
    Error('\p{Block=:= -MAHAJANI}');
    Error('\P{Block=:= -MAHAJANI}');
    Expect(1, 70015, '\p{Block=:\AMahajani\z:}', "");;
    Expect(0, 70016, '\p{Block=:\AMahajani\z:}', "");;
    Expect(1, 70015, '\p{Block=mahajani}', "");
    Expect(0, 70015, '\p{^Block=mahajani}', "");
    Expect(0, 70015, '\P{Block=mahajani}', "");
    Expect(1, 70015, '\P{^Block=mahajani}', "");
    Expect(0, 70016, '\p{Block=mahajani}', "");
    Expect(1, 70016, '\p{^Block=mahajani}', "");
    Expect(1, 70016, '\P{Block=mahajani}', "");
    Expect(0, 70016, '\P{^Block=mahajani}', "");
    Expect(1, 70015, '\p{Block=:\Amahajani\z:}', "");;
    Expect(0, 70016, '\p{Block=:\Amahajani\z:}', "");;
    Expect(1, 70015, '\p{Block=  Mahajani}', "");
    Expect(0, 70015, '\p{^Block=  Mahajani}', "");
    Expect(0, 70015, '\P{Block=  Mahajani}', "");
    Expect(1, 70015, '\P{^Block=  Mahajani}', "");
    Expect(0, 70016, '\p{Block=  Mahajani}', "");
    Expect(1, 70016, '\p{^Block=  Mahajani}', "");
    Expect(1, 70016, '\P{Block=  Mahajani}', "");
    Expect(0, 70016, '\P{^Block=  Mahajani}', "");
    Error('\p{Blk=:=__MAHAJANI}');
    Error('\P{Blk=:=__MAHAJANI}');
    Expect(1, 70015, '\p{Blk=:\AMahajani\z:}', "");;
    Expect(0, 70016, '\p{Blk=:\AMahajani\z:}', "");;
    Expect(1, 70015, '\p{Blk=mahajani}', "");
    Expect(0, 70015, '\p{^Blk=mahajani}', "");
    Expect(0, 70015, '\P{Blk=mahajani}', "");
    Expect(1, 70015, '\P{^Blk=mahajani}', "");
    Expect(0, 70016, '\p{Blk=mahajani}', "");
    Expect(1, 70016, '\p{^Blk=mahajani}', "");
    Expect(1, 70016, '\P{Blk=mahajani}', "");
    Expect(0, 70016, '\P{^Blk=mahajani}', "");
    Expect(1, 70015, '\p{Blk=:\Amahajani\z:}', "");;
    Expect(0, 70016, '\p{Blk=:\Amahajani\z:}', "");;
    Expect(1, 70015, '\p{Blk=	 Mahajani}', "");
    Expect(0, 70015, '\p{^Blk=	 Mahajani}', "");
    Expect(0, 70015, '\P{Blk=	 Mahajani}', "");
    Expect(1, 70015, '\P{^Blk=	 Mahajani}', "");
    Expect(0, 70016, '\p{Blk=	 Mahajani}', "");
    Expect(1, 70016, '\p{^Blk=	 Mahajani}', "");
    Expect(1, 70016, '\P{Blk=	 Mahajani}', "");
    Expect(0, 70016, '\P{^Blk=	 Mahajani}', "");
    Error('\p{Is_Block=/a/  mahajani}');
    Error('\P{Is_Block=/a/  mahajani}');
    Expect(1, 70015, '\p{Is_Block=mahajani}', "");
    Expect(0, 70015, '\p{^Is_Block=mahajani}', "");
    Expect(0, 70015, '\P{Is_Block=mahajani}', "");
    Expect(1, 70015, '\P{^Is_Block=mahajani}', "");
    Expect(0, 70016, '\p{Is_Block=mahajani}', "");
    Expect(1, 70016, '\p{^Is_Block=mahajani}', "");
    Expect(1, 70016, '\P{Is_Block=mahajani}', "");
    Expect(0, 70016, '\P{^Is_Block=mahajani}', "");
    Expect(1, 70015, '\p{Is_Block=_mahajani}', "");
    Expect(0, 70015, '\p{^Is_Block=_mahajani}', "");
    Expect(0, 70015, '\P{Is_Block=_mahajani}', "");
    Expect(1, 70015, '\P{^Is_Block=_mahajani}', "");
    Expect(0, 70016, '\p{Is_Block=_mahajani}', "");
    Expect(1, 70016, '\p{^Is_Block=_mahajani}', "");
    Expect(1, 70016, '\P{Is_Block=_mahajani}', "");
    Expect(0, 70016, '\P{^Is_Block=_mahajani}', "");
    Error('\p{Is_Blk= /a/Mahajani}');
    Error('\P{Is_Blk= /a/Mahajani}');
    Expect(1, 70015, '\p{Is_Blk=mahajani}', "");
    Expect(0, 70015, '\p{^Is_Blk=mahajani}', "");
    Expect(0, 70015, '\P{Is_Blk=mahajani}', "");
    Expect(1, 70015, '\P{^Is_Blk=mahajani}', "");
    Expect(0, 70016, '\p{Is_Blk=mahajani}', "");
    Expect(1, 70016, '\p{^Is_Blk=mahajani}', "");
    Expect(1, 70016, '\P{Is_Blk=mahajani}', "");
    Expect(0, 70016, '\P{^Is_Blk=mahajani}', "");
    Expect(1, 70015, '\p{Is_Blk=_	Mahajani}', "");
    Expect(0, 70015, '\p{^Is_Blk=_	Mahajani}', "");
    Expect(0, 70015, '\P{Is_Blk=_	Mahajani}', "");
    Expect(1, 70015, '\P{^Is_Blk=_	Mahajani}', "");
    Expect(0, 70016, '\p{Is_Blk=_	Mahajani}', "");
    Expect(1, 70016, '\p{^Is_Blk=_	Mahajani}', "");
    Expect(1, 70016, '\P{Is_Blk=_	Mahajani}', "");
    Expect(0, 70016, '\P{^Is_Blk=_	Mahajani}', "");
    Error('\p{Block=:=_	Mahjong_TILES}');
    Error('\P{Block=:=_	Mahjong_TILES}');
    Expect(1, 127023, '\p{Block=:\AMahjong_Tiles\z:}', "");;
    Expect(0, 127024, '\p{Block=:\AMahjong_Tiles\z:}', "");;
    Expect(1, 127023, '\p{Block=mahjongtiles}', "");
    Expect(0, 127023, '\p{^Block=mahjongtiles}', "");
    Expect(0, 127023, '\P{Block=mahjongtiles}', "");
    Expect(1, 127023, '\P{^Block=mahjongtiles}', "");
    Expect(0, 127024, '\p{Block=mahjongtiles}', "");
    Expect(1, 127024, '\p{^Block=mahjongtiles}', "");
    Expect(1, 127024, '\P{Block=mahjongtiles}', "");
    Expect(0, 127024, '\P{^Block=mahjongtiles}', "");
    Expect(1, 127023, '\p{Block=:\Amahjongtiles\z:}', "");;
    Expect(0, 127024, '\p{Block=:\Amahjongtiles\z:}', "");;
    Expect(1, 127023, '\p{Block= -mahjong_tiles}', "");
    Expect(0, 127023, '\p{^Block= -mahjong_tiles}', "");
    Expect(0, 127023, '\P{Block= -mahjong_tiles}', "");
    Expect(1, 127023, '\P{^Block= -mahjong_tiles}', "");
    Expect(0, 127024, '\p{Block= -mahjong_tiles}', "");
    Expect(1, 127024, '\p{^Block= -mahjong_tiles}', "");
    Expect(1, 127024, '\P{Block= -mahjong_tiles}', "");
    Expect(0, 127024, '\P{^Block= -mahjong_tiles}', "");
    Error('\p{Blk=_:=Mahjong}');
    Error('\P{Blk=_:=Mahjong}');
    Expect(1, 127023, '\p{Blk=:\AMahjong\z:}', "");;
    Expect(0, 127024, '\p{Blk=:\AMahjong\z:}', "");;
    Expect(1, 127023, '\p{Blk=mahjong}', "");
    Expect(0, 127023, '\p{^Blk=mahjong}', "");
    Expect(0, 127023, '\P{Blk=mahjong}', "");
    Expect(1, 127023, '\P{^Blk=mahjong}', "");
    Expect(0, 127024, '\p{Blk=mahjong}', "");
    Expect(1, 127024, '\p{^Blk=mahjong}', "");
    Expect(1, 127024, '\P{Blk=mahjong}', "");
    Expect(0, 127024, '\P{^Blk=mahjong}', "");
    Expect(1, 127023, '\p{Blk=:\Amahjong\z:}', "");;
    Expect(0, 127024, '\p{Blk=:\Amahjong\z:}', "");;
    Error('\p{Is_Block= 	Mahjong_Tiles:=}');
    Error('\P{Is_Block= 	Mahjong_Tiles:=}');
    Expect(1, 127023, '\p{Is_Block=mahjongtiles}', "");
    Expect(0, 127023, '\p{^Is_Block=mahjongtiles}', "");
    Expect(0, 127023, '\P{Is_Block=mahjongtiles}', "");
    Expect(1, 127023, '\P{^Is_Block=mahjongtiles}', "");
    Expect(0, 127024, '\p{Is_Block=mahjongtiles}', "");
    Expect(1, 127024, '\p{^Is_Block=mahjongtiles}', "");
    Expect(1, 127024, '\P{Is_Block=mahjongtiles}', "");
    Expect(0, 127024, '\P{^Is_Block=mahjongtiles}', "");
    Expect(1, 127023, '\p{Is_Block=-	Mahjong_Tiles}', "");
    Expect(0, 127023, '\p{^Is_Block=-	Mahjong_Tiles}', "");
    Expect(0, 127023, '\P{Is_Block=-	Mahjong_Tiles}', "");
    Expect(1, 127023, '\P{^Is_Block=-	Mahjong_Tiles}', "");
    Expect(0, 127024, '\p{Is_Block=-	Mahjong_Tiles}', "");
    Expect(1, 127024, '\p{^Is_Block=-	Mahjong_Tiles}', "");
    Expect(1, 127024, '\P{Is_Block=-	Mahjong_Tiles}', "");
    Expect(0, 127024, '\P{^Is_Block=-	Mahjong_Tiles}', "");
    Error('\p{Is_Blk=-mahjong:=}');
    Error('\P{Is_Blk=-mahjong:=}');
    Expect(1, 127023, '\p{Is_Blk:   mahjong}', "");
    Expect(0, 127023, '\p{^Is_Blk:   mahjong}', "");
    Expect(0, 127023, '\P{Is_Blk:   mahjong}', "");
    Expect(1, 127023, '\P{^Is_Blk:   mahjong}', "");
    Expect(0, 127024, '\p{Is_Blk:   mahjong}', "");
    Expect(1, 127024, '\p{^Is_Blk:   mahjong}', "");
    Expect(1, 127024, '\P{Is_Blk:   mahjong}', "");
    Expect(0, 127024, '\P{^Is_Blk:   mahjong}', "");
    Expect(1, 127023, '\p{Is_Blk=	MAHJONG}', "");
    Expect(0, 127023, '\p{^Is_Blk=	MAHJONG}', "");
    Expect(0, 127023, '\P{Is_Blk=	MAHJONG}', "");
    Expect(1, 127023, '\P{^Is_Blk=	MAHJONG}', "");
    Expect(0, 127024, '\p{Is_Blk=	MAHJONG}', "");
    Expect(1, 127024, '\p{^Is_Blk=	MAHJONG}', "");
    Expect(1, 127024, '\P{Is_Blk=	MAHJONG}', "");
    Expect(0, 127024, '\P{^Is_Blk=	MAHJONG}', "");
    Error('\p{Block=		Makasar/a/}');
    Error('\P{Block=		Makasar/a/}');
    Expect(1, 73471, '\p{Block=:\AMakasar\z:}', "");;
    Expect(0, 73472, '\p{Block=:\AMakasar\z:}', "");;
    Expect(1, 73471, '\p{Block=makasar}', "");
    Expect(0, 73471, '\p{^Block=makasar}', "");
    Expect(0, 73471, '\P{Block=makasar}', "");
    Expect(1, 73471, '\P{^Block=makasar}', "");
    Expect(0, 73472, '\p{Block=makasar}', "");
    Expect(1, 73472, '\p{^Block=makasar}', "");
    Expect(1, 73472, '\P{Block=makasar}', "");
    Expect(0, 73472, '\P{^Block=makasar}', "");
    Expect(1, 73471, '\p{Block=:\Amakasar\z:}', "");;
    Expect(0, 73472, '\p{Block=:\Amakasar\z:}', "");;
    Expect(1, 73471, '\p{Block=-makasar}', "");
    Expect(0, 73471, '\p{^Block=-makasar}', "");
    Expect(0, 73471, '\P{Block=-makasar}', "");
    Expect(1, 73471, '\P{^Block=-makasar}', "");
    Expect(0, 73472, '\p{Block=-makasar}', "");
    Expect(1, 73472, '\p{^Block=-makasar}', "");
    Expect(1, 73472, '\P{Block=-makasar}', "");
    Expect(0, 73472, '\P{^Block=-makasar}', "");
    Error('\p{Blk= MAKASAR/a/}');
    Error('\P{Blk= MAKASAR/a/}');
    Expect(1, 73471, '\p{Blk=:\AMakasar\z:}', "");;
    Expect(0, 73472, '\p{Blk=:\AMakasar\z:}', "");;
    Expect(1, 73471, '\p{Blk=makasar}', "");
    Expect(0, 73471, '\p{^Blk=makasar}', "");
    Expect(0, 73471, '\P{Blk=makasar}', "");
    Expect(1, 73471, '\P{^Blk=makasar}', "");
    Expect(0, 73472, '\p{Blk=makasar}', "");
    Expect(1, 73472, '\p{^Blk=makasar}', "");
    Expect(1, 73472, '\P{Blk=makasar}', "");
    Expect(0, 73472, '\P{^Blk=makasar}', "");
    Expect(1, 73471, '\p{Blk=:\Amakasar\z:}', "");;
    Expect(0, 73472, '\p{Blk=:\Amakasar\z:}', "");;
    Expect(1, 73471, '\p{Blk=-Makasar}', "");
    Expect(0, 73471, '\p{^Blk=-Makasar}', "");
    Expect(0, 73471, '\P{Blk=-Makasar}', "");
    Expect(1, 73471, '\P{^Blk=-Makasar}', "");
    Expect(0, 73472, '\p{Blk=-Makasar}', "");
    Expect(1, 73472, '\p{^Blk=-Makasar}', "");
    Expect(1, 73472, '\P{Blk=-Makasar}', "");
    Expect(0, 73472, '\P{^Blk=-Makasar}', "");
    Error('\p{Is_Block= Makasar:=}');
    Error('\P{Is_Block= Makasar:=}');
    Expect(1, 73471, '\p{Is_Block=makasar}', "");
    Expect(0, 73471, '\p{^Is_Block=makasar}', "");
    Expect(0, 73471, '\P{Is_Block=makasar}', "");
    Expect(1, 73471, '\P{^Is_Block=makasar}', "");
    Expect(0, 73472, '\p{Is_Block=makasar}', "");
    Expect(1, 73472, '\p{^Is_Block=makasar}', "");
    Expect(1, 73472, '\P{Is_Block=makasar}', "");
    Expect(0, 73472, '\P{^Is_Block=makasar}', "");
    Expect(1, 73471, '\p{Is_Block:  makasar}', "");
    Expect(0, 73471, '\p{^Is_Block:  makasar}', "");
    Expect(0, 73471, '\P{Is_Block:  makasar}', "");
    Expect(1, 73471, '\P{^Is_Block:  makasar}', "");
    Expect(0, 73472, '\p{Is_Block:  makasar}', "");
    Expect(1, 73472, '\p{^Is_Block:  makasar}', "");
    Expect(1, 73472, '\P{Is_Block:  makasar}', "");
    Expect(0, 73472, '\P{^Is_Block:  makasar}', "");
    Error('\p{Is_Blk=-	MAKASAR/a/}');
    Error('\P{Is_Blk=-	MAKASAR/a/}');
    Expect(1, 73471, '\p{Is_Blk:makasar}', "");
    Expect(0, 73471, '\p{^Is_Blk:makasar}', "");
    Expect(0, 73471, '\P{Is_Blk:makasar}', "");
    Expect(1, 73471, '\P{^Is_Blk:makasar}', "");
    Expect(0, 73472, '\p{Is_Blk:makasar}', "");
    Expect(1, 73472, '\p{^Is_Blk:makasar}', "");
    Expect(1, 73472, '\P{Is_Blk:makasar}', "");
    Expect(0, 73472, '\P{^Is_Blk:makasar}', "");
    Expect(1, 73471, '\p{Is_Blk=	Makasar}', "");
    Expect(0, 73471, '\p{^Is_Blk=	Makasar}', "");
    Expect(0, 73471, '\P{Is_Blk=	Makasar}', "");
    Expect(1, 73471, '\P{^Is_Blk=	Makasar}', "");
    Expect(0, 73472, '\p{Is_Blk=	Makasar}', "");
    Expect(1, 73472, '\p{^Is_Blk=	Makasar}', "");
    Expect(1, 73472, '\P{Is_Blk=	Makasar}', "");
    Expect(0, 73472, '\P{^Is_Blk=	Makasar}', "");
    Error('\p{Block=/a/	MALAYALAM}');
    Error('\P{Block=/a/	MALAYALAM}');
    Expect(1, 3455, '\p{Block=:\AMalayalam\z:}', "");;
    Expect(0, 3456, '\p{Block=:\AMalayalam\z:}', "");;
    Expect(1, 3455, '\p{Block=malayalam}', "");
    Expect(0, 3455, '\p{^Block=malayalam}', "");
    Expect(0, 3455, '\P{Block=malayalam}', "");
    Expect(1, 3455, '\P{^Block=malayalam}', "");
    Expect(0, 3456, '\p{Block=malayalam}', "");
    Expect(1, 3456, '\p{^Block=malayalam}', "");
    Expect(1, 3456, '\P{Block=malayalam}', "");
    Expect(0, 3456, '\P{^Block=malayalam}', "");
    Expect(1, 3455, '\p{Block=:\Amalayalam\z:}', "");;
    Expect(0, 3456, '\p{Block=:\Amalayalam\z:}', "");;
    Expect(1, 3455, '\p{Block= Malayalam}', "");
    Expect(0, 3455, '\p{^Block= Malayalam}', "");
    Expect(0, 3455, '\P{Block= Malayalam}', "");
    Expect(1, 3455, '\P{^Block= Malayalam}', "");
    Expect(0, 3456, '\p{Block= Malayalam}', "");
    Expect(1, 3456, '\p{^Block= Malayalam}', "");
    Expect(1, 3456, '\P{Block= Malayalam}', "");
    Expect(0, 3456, '\P{^Block= Malayalam}', "");
    Error('\p{Blk=_ Malayalam:=}');
    Error('\P{Blk=_ Malayalam:=}');
    Expect(1, 3455, '\p{Blk=:\AMalayalam\z:}', "");;
    Expect(0, 3456, '\p{Blk=:\AMalayalam\z:}', "");;
    Expect(1, 3455, '\p{Blk=malayalam}', "");
    Expect(0, 3455, '\p{^Blk=malayalam}', "");
    Expect(0, 3455, '\P{Blk=malayalam}', "");
    Expect(1, 3455, '\P{^Blk=malayalam}', "");
    Expect(0, 3456, '\p{Blk=malayalam}', "");
    Expect(1, 3456, '\p{^Blk=malayalam}', "");
    Expect(1, 3456, '\P{Blk=malayalam}', "");
    Expect(0, 3456, '\P{^Blk=malayalam}', "");
    Expect(1, 3455, '\p{Blk=:\Amalayalam\z:}', "");;
    Expect(0, 3456, '\p{Blk=:\Amalayalam\z:}', "");;
    Expect(1, 3455, '\p{Blk=	Malayalam}', "");
    Expect(0, 3455, '\p{^Blk=	Malayalam}', "");
    Expect(0, 3455, '\P{Blk=	Malayalam}', "");
    Expect(1, 3455, '\P{^Blk=	Malayalam}', "");
    Expect(0, 3456, '\p{Blk=	Malayalam}', "");
    Expect(1, 3456, '\p{^Blk=	Malayalam}', "");
    Expect(1, 3456, '\P{Blk=	Malayalam}', "");
    Expect(0, 3456, '\P{^Blk=	Malayalam}', "");
    Error('\p{Is_Block=/a/malayalam}');
    Error('\P{Is_Block=/a/malayalam}');
    Expect(1, 3455, '\p{Is_Block:malayalam}', "");
    Expect(0, 3455, '\p{^Is_Block:malayalam}', "");
    Expect(0, 3455, '\P{Is_Block:malayalam}', "");
    Expect(1, 3455, '\P{^Is_Block:malayalam}', "");
    Expect(0, 3456, '\p{Is_Block:malayalam}', "");
    Expect(1, 3456, '\p{^Is_Block:malayalam}', "");
    Expect(1, 3456, '\P{Is_Block:malayalam}', "");
    Expect(0, 3456, '\P{^Is_Block:malayalam}', "");
    Expect(1, 3455, '\p{Is_Block=	Malayalam}', "");
    Expect(0, 3455, '\p{^Is_Block=	Malayalam}', "");
    Expect(0, 3455, '\P{Is_Block=	Malayalam}', "");
    Expect(1, 3455, '\P{^Is_Block=	Malayalam}', "");
    Expect(0, 3456, '\p{Is_Block=	Malayalam}', "");
    Expect(1, 3456, '\p{^Is_Block=	Malayalam}', "");
    Expect(1, 3456, '\P{Is_Block=	Malayalam}', "");
    Expect(0, 3456, '\P{^Is_Block=	Malayalam}', "");
    Error('\p{Is_Blk=:=MALAYALAM}');
    Error('\P{Is_Blk=:=MALAYALAM}');
    Expect(1, 3455, '\p{Is_Blk=malayalam}', "");
    Expect(0, 3455, '\p{^Is_Blk=malayalam}', "");
    Expect(0, 3455, '\P{Is_Blk=malayalam}', "");
    Expect(1, 3455, '\P{^Is_Blk=malayalam}', "");
    Expect(0, 3456, '\p{Is_Blk=malayalam}', "");
    Expect(1, 3456, '\p{^Is_Blk=malayalam}', "");
    Expect(1, 3456, '\P{Is_Blk=malayalam}', "");
    Expect(0, 3456, '\P{^Is_Blk=malayalam}', "");
    Expect(1, 3455, '\p{Is_Blk=-_malayalam}', "");
    Expect(0, 3455, '\p{^Is_Blk=-_malayalam}', "");
    Expect(0, 3455, '\P{Is_Blk=-_malayalam}', "");
    Expect(1, 3455, '\P{^Is_Blk=-_malayalam}', "");
    Expect(0, 3456, '\p{Is_Blk=-_malayalam}', "");
    Expect(1, 3456, '\p{^Is_Blk=-_malayalam}', "");
    Expect(1, 3456, '\P{Is_Blk=-_malayalam}', "");
    Expect(0, 3456, '\P{^Is_Blk=-_malayalam}', "");
    Error('\p{Block= /a/Mandaic}');
    Error('\P{Block= /a/Mandaic}');
    Expect(1, 2143, '\p{Block=:\AMandaic\z:}', "");;
    Expect(0, 2144, '\p{Block=:\AMandaic\z:}', "");;
    Expect(1, 2143, '\p{Block:	mandaic}', "");
    Expect(0, 2143, '\p{^Block:	mandaic}', "");
    Expect(0, 2143, '\P{Block:	mandaic}', "");
    Expect(1, 2143, '\P{^Block:	mandaic}', "");
    Expect(0, 2144, '\p{Block:	mandaic}', "");
    Expect(1, 2144, '\p{^Block:	mandaic}', "");
    Expect(1, 2144, '\P{Block:	mandaic}', "");
    Expect(0, 2144, '\P{^Block:	mandaic}', "");
    Expect(1, 2143, '\p{Block=:\Amandaic\z:}', "");;
    Expect(0, 2144, '\p{Block=:\Amandaic\z:}', "");;
    Expect(1, 2143, '\p{Block=		MANDAIC}', "");
    Expect(0, 2143, '\p{^Block=		MANDAIC}', "");
    Expect(0, 2143, '\P{Block=		MANDAIC}', "");
    Expect(1, 2143, '\P{^Block=		MANDAIC}', "");
    Expect(0, 2144, '\p{Block=		MANDAIC}', "");
    Expect(1, 2144, '\p{^Block=		MANDAIC}', "");
    Expect(1, 2144, '\P{Block=		MANDAIC}', "");
    Expect(0, 2144, '\P{^Block=		MANDAIC}', "");
    Error('\p{Blk= /a/Mandaic}');
    Error('\P{Blk= /a/Mandaic}');
    Expect(1, 2143, '\p{Blk=:\AMandaic\z:}', "");;
    Expect(0, 2144, '\p{Blk=:\AMandaic\z:}', "");;
    Expect(1, 2143, '\p{Blk: mandaic}', "");
    Expect(0, 2143, '\p{^Blk: mandaic}', "");
    Expect(0, 2143, '\P{Blk: mandaic}', "");
    Expect(1, 2143, '\P{^Blk: mandaic}', "");
    Expect(0, 2144, '\p{Blk: mandaic}', "");
    Expect(1, 2144, '\p{^Blk: mandaic}', "");
    Expect(1, 2144, '\P{Blk: mandaic}', "");
    Expect(0, 2144, '\P{^Blk: mandaic}', "");
    Expect(1, 2143, '\p{Blk=:\Amandaic\z:}', "");;
    Expect(0, 2144, '\p{Blk=:\Amandaic\z:}', "");;
    Expect(1, 2143, '\p{Blk=		Mandaic}', "");
    Expect(0, 2143, '\p{^Blk=		Mandaic}', "");
    Expect(0, 2143, '\P{Blk=		Mandaic}', "");
    Expect(1, 2143, '\P{^Blk=		Mandaic}', "");
    Expect(0, 2144, '\p{Blk=		Mandaic}', "");
    Expect(1, 2144, '\p{^Blk=		Mandaic}', "");
    Expect(1, 2144, '\P{Blk=		Mandaic}', "");
    Expect(0, 2144, '\P{^Blk=		Mandaic}', "");
    Error('\p{Is_Block=/a/Mandaic}');
    Error('\P{Is_Block=/a/Mandaic}');
    Expect(1, 2143, '\p{Is_Block:   mandaic}', "");
    Expect(0, 2143, '\p{^Is_Block:   mandaic}', "");
    Expect(0, 2143, '\P{Is_Block:   mandaic}', "");
    Expect(1, 2143, '\P{^Is_Block:   mandaic}', "");
    Expect(0, 2144, '\p{Is_Block:   mandaic}', "");
    Expect(1, 2144, '\p{^Is_Block:   mandaic}', "");
    Expect(1, 2144, '\P{Is_Block:   mandaic}', "");
    Expect(0, 2144, '\P{^Is_Block:   mandaic}', "");
    Expect(1, 2143, '\p{Is_Block=Mandaic}', "");
    Expect(0, 2143, '\p{^Is_Block=Mandaic}', "");
    Expect(0, 2143, '\P{Is_Block=Mandaic}', "");
    Expect(1, 2143, '\P{^Is_Block=Mandaic}', "");
    Expect(0, 2144, '\p{Is_Block=Mandaic}', "");
    Expect(1, 2144, '\p{^Is_Block=Mandaic}', "");
    Expect(1, 2144, '\P{Is_Block=Mandaic}', "");
    Expect(0, 2144, '\P{^Is_Block=Mandaic}', "");
    Error('\p{Is_Blk=	_mandaic/a/}');
    Error('\P{Is_Blk=	_mandaic/a/}');
    Expect(1, 2143, '\p{Is_Blk=mandaic}', "");
    Expect(0, 2143, '\p{^Is_Blk=mandaic}', "");
    Expect(0, 2143, '\P{Is_Blk=mandaic}', "");
    Expect(1, 2143, '\P{^Is_Blk=mandaic}', "");
    Expect(0, 2144, '\p{Is_Blk=mandaic}', "");
    Expect(1, 2144, '\p{^Is_Blk=mandaic}', "");
    Expect(1, 2144, '\P{Is_Blk=mandaic}', "");
    Expect(0, 2144, '\P{^Is_Blk=mandaic}', "");
    Expect(1, 2143, '\p{Is_Blk=_-Mandaic}', "");
    Expect(0, 2143, '\p{^Is_Blk=_-Mandaic}', "");
    Expect(0, 2143, '\P{Is_Blk=_-Mandaic}', "");
    Expect(1, 2143, '\P{^Is_Blk=_-Mandaic}', "");
    Expect(0, 2144, '\p{Is_Blk=_-Mandaic}', "");
    Expect(1, 2144, '\p{^Is_Blk=_-Mandaic}', "");
    Expect(1, 2144, '\P{Is_Blk=_-Mandaic}', "");
    Expect(0, 2144, '\P{^Is_Blk=_-Mandaic}', "");
    Error('\p{Block=/a/Manichaean}');
    Error('\P{Block=/a/Manichaean}');
    Expect(1, 68351, '\p{Block=:\AManichaean\z:}', "");;
    Expect(0, 68352, '\p{Block=:\AManichaean\z:}', "");;
    Expect(1, 68351, '\p{Block=manichaean}', "");
    Expect(0, 68351, '\p{^Block=manichaean}', "");
    Expect(0, 68351, '\P{Block=manichaean}', "");
    Expect(1, 68351, '\P{^Block=manichaean}', "");
    Expect(0, 68352, '\p{Block=manichaean}', "");
    Expect(1, 68352, '\p{^Block=manichaean}', "");
    Expect(1, 68352, '\P{Block=manichaean}', "");
    Expect(0, 68352, '\P{^Block=manichaean}', "");
    Expect(1, 68351, '\p{Block=:\Amanichaean\z:}', "");;
    Expect(0, 68352, '\p{Block=:\Amanichaean\z:}', "");;
    Expect(1, 68351, '\p{Block=	_manichaean}', "");
    Expect(0, 68351, '\p{^Block=	_manichaean}', "");
    Expect(0, 68351, '\P{Block=	_manichaean}', "");
    Expect(1, 68351, '\P{^Block=	_manichaean}', "");
    Expect(0, 68352, '\p{Block=	_manichaean}', "");
    Expect(1, 68352, '\p{^Block=	_manichaean}', "");
    Expect(1, 68352, '\P{Block=	_manichaean}', "");
    Expect(0, 68352, '\P{^Block=	_manichaean}', "");
    Error('\p{Blk:/a/ -manichaean}');
    Error('\P{Blk:/a/ -manichaean}');
    Expect(1, 68351, '\p{Blk=:\AManichaean\z:}', "");;
    Expect(0, 68352, '\p{Blk=:\AManichaean\z:}', "");;
    Expect(1, 68351, '\p{Blk=manichaean}', "");
    Expect(0, 68351, '\p{^Blk=manichaean}', "");
    Expect(0, 68351, '\P{Blk=manichaean}', "");
    Expect(1, 68351, '\P{^Blk=manichaean}', "");
    Expect(0, 68352, '\p{Blk=manichaean}', "");
    Expect(1, 68352, '\p{^Blk=manichaean}', "");
    Expect(1, 68352, '\P{Blk=manichaean}', "");
    Expect(0, 68352, '\P{^Blk=manichaean}', "");
    Expect(1, 68351, '\p{Blk=:\Amanichaean\z:}', "");;
    Expect(0, 68352, '\p{Blk=:\Amanichaean\z:}', "");;
    Expect(1, 68351, '\p{Blk=--manichaean}', "");
    Expect(0, 68351, '\p{^Blk=--manichaean}', "");
    Expect(0, 68351, '\P{Blk=--manichaean}', "");
    Expect(1, 68351, '\P{^Blk=--manichaean}', "");
    Expect(0, 68352, '\p{Blk=--manichaean}', "");
    Expect(1, 68352, '\p{^Blk=--manichaean}', "");
    Expect(1, 68352, '\P{Blk=--manichaean}', "");
    Expect(0, 68352, '\P{^Blk=--manichaean}', "");
    Error('\p{Is_Block=_/a/MANICHAEAN}');
    Error('\P{Is_Block=_/a/MANICHAEAN}');
    Expect(1, 68351, '\p{Is_Block=manichaean}', "");
    Expect(0, 68351, '\p{^Is_Block=manichaean}', "");
    Expect(0, 68351, '\P{Is_Block=manichaean}', "");
    Expect(1, 68351, '\P{^Is_Block=manichaean}', "");
    Expect(0, 68352, '\p{Is_Block=manichaean}', "");
    Expect(1, 68352, '\p{^Is_Block=manichaean}', "");
    Expect(1, 68352, '\P{Is_Block=manichaean}', "");
    Expect(0, 68352, '\P{^Is_Block=manichaean}', "");
    Expect(1, 68351, '\p{Is_Block=-_manichaean}', "");
    Expect(0, 68351, '\p{^Is_Block=-_manichaean}', "");
    Expect(0, 68351, '\P{Is_Block=-_manichaean}', "");
    Expect(1, 68351, '\P{^Is_Block=-_manichaean}', "");
    Expect(0, 68352, '\p{Is_Block=-_manichaean}', "");
    Expect(1, 68352, '\p{^Is_Block=-_manichaean}', "");
    Expect(1, 68352, '\P{Is_Block=-_manichaean}', "");
    Expect(0, 68352, '\P{^Is_Block=-_manichaean}', "");
    Error('\p{Is_Blk=_/a/manichaean}');
    Error('\P{Is_Blk=_/a/manichaean}');
    Expect(1, 68351, '\p{Is_Blk=manichaean}', "");
    Expect(0, 68351, '\p{^Is_Blk=manichaean}', "");
    Expect(0, 68351, '\P{Is_Blk=manichaean}', "");
    Expect(1, 68351, '\P{^Is_Blk=manichaean}', "");
    Expect(0, 68352, '\p{Is_Blk=manichaean}', "");
    Expect(1, 68352, '\p{^Is_Blk=manichaean}', "");
    Expect(1, 68352, '\P{Is_Blk=manichaean}', "");
    Expect(0, 68352, '\P{^Is_Blk=manichaean}', "");
    Expect(1, 68351, '\p{Is_Blk=	Manichaean}', "");
    Expect(0, 68351, '\p{^Is_Blk=	Manichaean}', "");
    Expect(0, 68351, '\P{Is_Blk=	Manichaean}', "");
    Expect(1, 68351, '\P{^Is_Blk=	Manichaean}', "");
    Expect(0, 68352, '\p{Is_Blk=	Manichaean}', "");
    Expect(1, 68352, '\p{^Is_Blk=	Manichaean}', "");
    Expect(1, 68352, '\P{Is_Blk=	Manichaean}', "");
    Expect(0, 68352, '\P{^Is_Blk=	Manichaean}', "");
    Error('\p{Block=_:=marchen}');
    Error('\P{Block=_:=marchen}');
    Expect(1, 72895, '\p{Block=:\AMarchen\z:}', "");;
    Expect(0, 72896, '\p{Block=:\AMarchen\z:}', "");;
    Expect(1, 72895, '\p{Block=marchen}', "");
    Expect(0, 72895, '\p{^Block=marchen}', "");
    Expect(0, 72895, '\P{Block=marchen}', "");
    Expect(1, 72895, '\P{^Block=marchen}', "");
    Expect(0, 72896, '\p{Block=marchen}', "");
    Expect(1, 72896, '\p{^Block=marchen}', "");
    Expect(1, 72896, '\P{Block=marchen}', "");
    Expect(0, 72896, '\P{^Block=marchen}', "");
    Expect(1, 72895, '\p{Block=:\Amarchen\z:}', "");;
    Expect(0, 72896, '\p{Block=:\Amarchen\z:}', "");;
    Expect(1, 72895, '\p{Block= _MARCHEN}', "");
    Expect(0, 72895, '\p{^Block= _MARCHEN}', "");
    Expect(0, 72895, '\P{Block= _MARCHEN}', "");
    Expect(1, 72895, '\P{^Block= _MARCHEN}', "");
    Expect(0, 72896, '\p{Block= _MARCHEN}', "");
    Expect(1, 72896, '\p{^Block= _MARCHEN}', "");
    Expect(1, 72896, '\P{Block= _MARCHEN}', "");
    Expect(0, 72896, '\P{^Block= _MARCHEN}', "");
    Error('\p{Blk=	/a/Marchen}');
    Error('\P{Blk=	/a/Marchen}');
    Expect(1, 72895, '\p{Blk=:\AMarchen\z:}', "");;
    Expect(0, 72896, '\p{Blk=:\AMarchen\z:}', "");;
    Expect(1, 72895, '\p{Blk=marchen}', "");
    Expect(0, 72895, '\p{^Blk=marchen}', "");
    Expect(0, 72895, '\P{Blk=marchen}', "");
    Expect(1, 72895, '\P{^Blk=marchen}', "");
    Expect(0, 72896, '\p{Blk=marchen}', "");
    Expect(1, 72896, '\p{^Blk=marchen}', "");
    Expect(1, 72896, '\P{Blk=marchen}', "");
    Expect(0, 72896, '\P{^Blk=marchen}', "");
    Expect(1, 72895, '\p{Blk=:\Amarchen\z:}', "");;
    Expect(0, 72896, '\p{Blk=:\Amarchen\z:}', "");;
    Error('\p{Is_Block: -:=marchen}');
    Error('\P{Is_Block: -:=marchen}');
    Expect(1, 72895, '\p{Is_Block=marchen}', "");
    Expect(0, 72895, '\p{^Is_Block=marchen}', "");
    Expect(0, 72895, '\P{Is_Block=marchen}', "");
    Expect(1, 72895, '\P{^Is_Block=marchen}', "");
    Expect(0, 72896, '\p{Is_Block=marchen}', "");
    Expect(1, 72896, '\p{^Is_Block=marchen}', "");
    Expect(1, 72896, '\P{Is_Block=marchen}', "");
    Expect(0, 72896, '\P{^Is_Block=marchen}', "");
    Expect(1, 72895, '\p{Is_Block=--marchen}', "");
    Expect(0, 72895, '\p{^Is_Block=--marchen}', "");
    Expect(0, 72895, '\P{Is_Block=--marchen}', "");
    Expect(1, 72895, '\P{^Is_Block=--marchen}', "");
    Expect(0, 72896, '\p{Is_Block=--marchen}', "");
    Expect(1, 72896, '\p{^Is_Block=--marchen}', "");
    Expect(1, 72896, '\P{Is_Block=--marchen}', "");
    Expect(0, 72896, '\P{^Is_Block=--marchen}', "");
    Error('\p{Is_Blk=:=--Marchen}');
    Error('\P{Is_Blk=:=--Marchen}');
    Expect(1, 72895, '\p{Is_Blk=marchen}', "");
    Expect(0, 72895, '\p{^Is_Blk=marchen}', "");
    Expect(0, 72895, '\P{Is_Blk=marchen}', "");
    Expect(1, 72895, '\P{^Is_Blk=marchen}', "");
    Expect(0, 72896, '\p{Is_Blk=marchen}', "");
    Expect(1, 72896, '\p{^Is_Blk=marchen}', "");
    Expect(1, 72896, '\P{Is_Blk=marchen}', "");
    Expect(0, 72896, '\P{^Is_Blk=marchen}', "");
    Expect(1, 72895, '\p{Is_Blk=_Marchen}', "");
    Expect(0, 72895, '\p{^Is_Blk=_Marchen}', "");
    Expect(0, 72895, '\P{Is_Blk=_Marchen}', "");
    Expect(1, 72895, '\P{^Is_Blk=_Marchen}', "");
    Expect(0, 72896, '\p{Is_Blk=_Marchen}', "");
    Expect(1, 72896, '\p{^Is_Blk=_Marchen}', "");
    Expect(1, 72896, '\P{Is_Blk=_Marchen}', "");
    Expect(0, 72896, '\P{^Is_Blk=_Marchen}', "");
    Error('\p{Block=/a/Masaram_Gondi}');
    Error('\P{Block=/a/Masaram_Gondi}');
    Expect(1, 73055, '\p{Block=:\AMasaram_Gondi\z:}', "");;
    Expect(0, 73056, '\p{Block=:\AMasaram_Gondi\z:}', "");;
    Expect(1, 73055, '\p{Block=masaramgondi}', "");
    Expect(0, 73055, '\p{^Block=masaramgondi}', "");
    Expect(0, 73055, '\P{Block=masaramgondi}', "");
    Expect(1, 73055, '\P{^Block=masaramgondi}', "");
    Expect(0, 73056, '\p{Block=masaramgondi}', "");
    Expect(1, 73056, '\p{^Block=masaramgondi}', "");
    Expect(1, 73056, '\P{Block=masaramgondi}', "");
    Expect(0, 73056, '\P{^Block=masaramgondi}', "");
    Expect(1, 73055, '\p{Block=:\Amasaramgondi\z:}', "");;
    Expect(0, 73056, '\p{Block=:\Amasaramgondi\z:}', "");;
    Expect(1, 73055, '\p{Block=__MASARAM_Gondi}', "");
    Expect(0, 73055, '\p{^Block=__MASARAM_Gondi}', "");
    Expect(0, 73055, '\P{Block=__MASARAM_Gondi}', "");
    Expect(1, 73055, '\P{^Block=__MASARAM_Gondi}', "");
    Expect(0, 73056, '\p{Block=__MASARAM_Gondi}', "");
    Expect(1, 73056, '\p{^Block=__MASARAM_Gondi}', "");
    Expect(1, 73056, '\P{Block=__MASARAM_Gondi}', "");
    Expect(0, 73056, '\P{^Block=__MASARAM_Gondi}', "");
    Error('\p{Blk=-/a/Masaram_GONDI}');
    Error('\P{Blk=-/a/Masaram_GONDI}');
    Expect(1, 73055, '\p{Blk=:\AMasaram_Gondi\z:}', "");;
    Expect(0, 73056, '\p{Blk=:\AMasaram_Gondi\z:}', "");;
    Expect(1, 73055, '\p{Blk=masaramgondi}', "");
    Expect(0, 73055, '\p{^Blk=masaramgondi}', "");
    Expect(0, 73055, '\P{Blk=masaramgondi}', "");
    Expect(1, 73055, '\P{^Blk=masaramgondi}', "");
    Expect(0, 73056, '\p{Blk=masaramgondi}', "");
    Expect(1, 73056, '\p{^Blk=masaramgondi}', "");
    Expect(1, 73056, '\P{Blk=masaramgondi}', "");
    Expect(0, 73056, '\P{^Blk=masaramgondi}', "");
    Expect(1, 73055, '\p{Blk=:\Amasaramgondi\z:}', "");;
    Expect(0, 73056, '\p{Blk=:\Amasaramgondi\z:}', "");;
    Expect(1, 73055, '\p{Blk=- Masaram_GONDI}', "");
    Expect(0, 73055, '\p{^Blk=- Masaram_GONDI}', "");
    Expect(0, 73055, '\P{Blk=- Masaram_GONDI}', "");
    Expect(1, 73055, '\P{^Blk=- Masaram_GONDI}', "");
    Expect(0, 73056, '\p{Blk=- Masaram_GONDI}', "");
    Expect(1, 73056, '\p{^Blk=- Masaram_GONDI}', "");
    Expect(1, 73056, '\P{Blk=- Masaram_GONDI}', "");
    Expect(0, 73056, '\P{^Blk=- Masaram_GONDI}', "");
    Error('\p{Is_Block: /a/_masaram_Gondi}');
    Error('\P{Is_Block: /a/_masaram_Gondi}');
    Expect(1, 73055, '\p{Is_Block: masaramgondi}', "");
    Expect(0, 73055, '\p{^Is_Block: masaramgondi}', "");
    Expect(0, 73055, '\P{Is_Block: masaramgondi}', "");
    Expect(1, 73055, '\P{^Is_Block: masaramgondi}', "");
    Expect(0, 73056, '\p{Is_Block: masaramgondi}', "");
    Expect(1, 73056, '\p{^Is_Block: masaramgondi}', "");
    Expect(1, 73056, '\P{Is_Block: masaramgondi}', "");
    Expect(0, 73056, '\P{^Is_Block: masaramgondi}', "");
    Expect(1, 73055, '\p{Is_Block=_ masaram_Gondi}', "");
    Expect(0, 73055, '\p{^Is_Block=_ masaram_Gondi}', "");
    Expect(0, 73055, '\P{Is_Block=_ masaram_Gondi}', "");
    Expect(1, 73055, '\P{^Is_Block=_ masaram_Gondi}', "");
    Expect(0, 73056, '\p{Is_Block=_ masaram_Gondi}', "");
    Expect(1, 73056, '\p{^Is_Block=_ masaram_Gondi}', "");
    Expect(1, 73056, '\P{Is_Block=_ masaram_Gondi}', "");
    Expect(0, 73056, '\P{^Is_Block=_ masaram_Gondi}', "");
    Error('\p{Is_Blk=_:=masaram_Gondi}');
    Error('\P{Is_Blk=_:=masaram_Gondi}');
    Expect(1, 73055, '\p{Is_Blk=masaramgondi}', "");
    Expect(0, 73055, '\p{^Is_Blk=masaramgondi}', "");
    Expect(0, 73055, '\P{Is_Blk=masaramgondi}', "");
    Expect(1, 73055, '\P{^Is_Blk=masaramgondi}', "");
    Expect(0, 73056, '\p{Is_Blk=masaramgondi}', "");
    Expect(1, 73056, '\p{^Is_Blk=masaramgondi}', "");
    Expect(1, 73056, '\P{Is_Blk=masaramgondi}', "");
    Expect(0, 73056, '\P{^Is_Blk=masaramgondi}', "");
    Expect(1, 73055, '\p{Is_Blk:    masaram_Gondi}', "");
    Expect(0, 73055, '\p{^Is_Blk:    masaram_Gondi}', "");
    Expect(0, 73055, '\P{Is_Blk:    masaram_Gondi}', "");
    Expect(1, 73055, '\P{^Is_Blk:    masaram_Gondi}', "");
    Expect(0, 73056, '\p{Is_Blk:    masaram_Gondi}', "");
    Expect(1, 73056, '\p{^Is_Blk:    masaram_Gondi}', "");
    Expect(1, 73056, '\P{Is_Blk:    masaram_Gondi}', "");
    Expect(0, 73056, '\P{^Is_Blk:    masaram_Gondi}', "");
    Error('\p{Block=:=mathematical_alphanumeric_symbols}');
    Error('\P{Block=:=mathematical_alphanumeric_symbols}');
    Expect(1, 120831, '\p{Block=:\AMathematical_Alphanumeric_Symbols\z:}', "");;
    Expect(0, 120832, '\p{Block=:\AMathematical_Alphanumeric_Symbols\z:}', "");;
    Expect(1, 120831, '\p{Block=mathematicalalphanumericsymbols}', "");
    Expect(0, 120831, '\p{^Block=mathematicalalphanumericsymbols}', "");
    Expect(0, 120831, '\P{Block=mathematicalalphanumericsymbols}', "");
    Expect(1, 120831, '\P{^Block=mathematicalalphanumericsymbols}', "");
    Expect(0, 120832, '\p{Block=mathematicalalphanumericsymbols}', "");
    Expect(1, 120832, '\p{^Block=mathematicalalphanumericsymbols}', "");
    Expect(1, 120832, '\P{Block=mathematicalalphanumericsymbols}', "");
    Expect(0, 120832, '\P{^Block=mathematicalalphanumericsymbols}', "");
    Expect(1, 120831, '\p{Block=:\Amathematicalalphanumericsymbols\z:}', "");;
    Expect(0, 120832, '\p{Block=:\Amathematicalalphanumericsymbols\z:}', "");;
    Expect(1, 120831, '\p{Block=_Mathematical_alphanumeric_Symbols}', "");
    Expect(0, 120831, '\p{^Block=_Mathematical_alphanumeric_Symbols}', "");
    Expect(0, 120831, '\P{Block=_Mathematical_alphanumeric_Symbols}', "");
    Expect(1, 120831, '\P{^Block=_Mathematical_alphanumeric_Symbols}', "");
    Expect(0, 120832, '\p{Block=_Mathematical_alphanumeric_Symbols}', "");
    Expect(1, 120832, '\p{^Block=_Mathematical_alphanumeric_Symbols}', "");
    Expect(1, 120832, '\P{Block=_Mathematical_alphanumeric_Symbols}', "");
    Expect(0, 120832, '\P{^Block=_Mathematical_alphanumeric_Symbols}', "");
    Error('\p{Blk=  Math_ALPHANUM:=}');
    Error('\P{Blk=  Math_ALPHANUM:=}');
    Expect(1, 120831, '\p{Blk=:\AMath_Alphanum\z:}', "");;
    Expect(0, 120832, '\p{Blk=:\AMath_Alphanum\z:}', "");;
    Expect(1, 120831, '\p{Blk=mathalphanum}', "");
    Expect(0, 120831, '\p{^Blk=mathalphanum}', "");
    Expect(0, 120831, '\P{Blk=mathalphanum}', "");
    Expect(1, 120831, '\P{^Blk=mathalphanum}', "");
    Expect(0, 120832, '\p{Blk=mathalphanum}', "");
    Expect(1, 120832, '\p{^Blk=mathalphanum}', "");
    Expect(1, 120832, '\P{Blk=mathalphanum}', "");
    Expect(0, 120832, '\P{^Blk=mathalphanum}', "");
    Expect(1, 120831, '\p{Blk=:\Amathalphanum\z:}', "");;
    Expect(0, 120832, '\p{Blk=:\Amathalphanum\z:}', "");;
    Expect(1, 120831, '\p{Blk= 	math_Alphanum}', "");
    Expect(0, 120831, '\p{^Blk= 	math_Alphanum}', "");
    Expect(0, 120831, '\P{Blk= 	math_Alphanum}', "");
    Expect(1, 120831, '\P{^Blk= 	math_Alphanum}', "");
    Expect(0, 120832, '\p{Blk= 	math_Alphanum}', "");
    Expect(1, 120832, '\p{^Blk= 	math_Alphanum}', "");
    Expect(1, 120832, '\P{Blk= 	math_Alphanum}', "");
    Expect(0, 120832, '\P{^Blk= 	math_Alphanum}', "");
    Error('\p{Is_Block:   -:=Mathematical_ALPHANUMERIC_Symbols}');
    Error('\P{Is_Block:   -:=Mathematical_ALPHANUMERIC_Symbols}');
    Expect(1, 120831, '\p{Is_Block=mathematicalalphanumericsymbols}', "");
    Expect(0, 120831, '\p{^Is_Block=mathematicalalphanumericsymbols}', "");
    Expect(0, 120831, '\P{Is_Block=mathematicalalphanumericsymbols}', "");
    Expect(1, 120831, '\P{^Is_Block=mathematicalalphanumericsymbols}', "");
    Expect(0, 120832, '\p{Is_Block=mathematicalalphanumericsymbols}', "");
    Expect(1, 120832, '\p{^Is_Block=mathematicalalphanumericsymbols}', "");
    Expect(1, 120832, '\P{Is_Block=mathematicalalphanumericsymbols}', "");
    Expect(0, 120832, '\P{^Is_Block=mathematicalalphanumericsymbols}', "");
    Expect(1, 120831, '\p{Is_Block:-_Mathematical_Alphanumeric_Symbols}', "");
    Expect(0, 120831, '\p{^Is_Block:-_Mathematical_Alphanumeric_Symbols}', "");
    Expect(0, 120831, '\P{Is_Block:-_Mathematical_Alphanumeric_Symbols}', "");
    Expect(1, 120831, '\P{^Is_Block:-_Mathematical_Alphanumeric_Symbols}', "");
    Expect(0, 120832, '\p{Is_Block:-_Mathematical_Alphanumeric_Symbols}', "");
    Expect(1, 120832, '\p{^Is_Block:-_Mathematical_Alphanumeric_Symbols}', "");
    Expect(1, 120832, '\P{Is_Block:-_Mathematical_Alphanumeric_Symbols}', "");
    Expect(0, 120832, '\P{^Is_Block:-_Mathematical_Alphanumeric_Symbols}', "");
    Error('\p{Is_Blk=:=-Math_ALPHANUM}');
    Error('\P{Is_Blk=:=-Math_ALPHANUM}');
    Expect(1, 120831, '\p{Is_Blk=mathalphanum}', "");
    Expect(0, 120831, '\p{^Is_Blk=mathalphanum}', "");
    Expect(0, 120831, '\P{Is_Blk=mathalphanum}', "");
    Expect(1, 120831, '\P{^Is_Blk=mathalphanum}', "");
    Expect(0, 120832, '\p{Is_Blk=mathalphanum}', "");
    Expect(1, 120832, '\p{^Is_Blk=mathalphanum}', "");
    Expect(1, 120832, '\P{Is_Blk=mathalphanum}', "");
    Expect(0, 120832, '\P{^Is_Blk=mathalphanum}', "");
    Expect(1, 120831, '\p{Is_Blk=	MATH_alphanum}', "");
    Expect(0, 120831, '\p{^Is_Blk=	MATH_alphanum}', "");
    Expect(0, 120831, '\P{Is_Blk=	MATH_alphanum}', "");
    Expect(1, 120831, '\P{^Is_Blk=	MATH_alphanum}', "");
    Expect(0, 120832, '\p{Is_Blk=	MATH_alphanum}', "");
    Expect(1, 120832, '\p{^Is_Blk=	MATH_alphanum}', "");
    Expect(1, 120832, '\P{Is_Blk=	MATH_alphanum}', "");
    Expect(0, 120832, '\P{^Is_Blk=	MATH_alphanum}', "");
    Error('\p{Block=-mathematical_Operators:=}');
    Error('\P{Block=-mathematical_Operators:=}');
    Expect(1, 8959, '\p{Block=:\AMathematical_Operators\z:}', "");;
    Expect(0, 8960, '\p{Block=:\AMathematical_Operators\z:}', "");;
    Expect(1, 8959, '\p{Block=mathematicaloperators}', "");
    Expect(0, 8959, '\p{^Block=mathematicaloperators}', "");
    Expect(0, 8959, '\P{Block=mathematicaloperators}', "");
    Expect(1, 8959, '\P{^Block=mathematicaloperators}', "");
    Expect(0, 8960, '\p{Block=mathematicaloperators}', "");
    Expect(1, 8960, '\p{^Block=mathematicaloperators}', "");
    Expect(1, 8960, '\P{Block=mathematicaloperators}', "");
    Expect(0, 8960, '\P{^Block=mathematicaloperators}', "");
    Expect(1, 8959, '\p{Block=:\Amathematicaloperators\z:}', "");;
    Expect(0, 8960, '\p{Block=:\Amathematicaloperators\z:}', "");;
    Expect(1, 8959, '\p{Block:		Mathematical_OPERATORS}', "");
    Expect(0, 8959, '\p{^Block:		Mathematical_OPERATORS}', "");
    Expect(0, 8959, '\P{Block:		Mathematical_OPERATORS}', "");
    Expect(1, 8959, '\P{^Block:		Mathematical_OPERATORS}', "");
    Expect(0, 8960, '\p{Block:		Mathematical_OPERATORS}', "");
    Expect(1, 8960, '\p{^Block:		Mathematical_OPERATORS}', "");
    Expect(1, 8960, '\P{Block:		Mathematical_OPERATORS}', "");
    Expect(0, 8960, '\P{^Block:		Mathematical_OPERATORS}', "");
    Error('\p{Blk=__Math_operators/a/}');
    Error('\P{Blk=__Math_operators/a/}');
    Expect(1, 8959, '\p{Blk=:\AMath_Operators\z:}', "");;
    Expect(0, 8960, '\p{Blk=:\AMath_Operators\z:}', "");;
    Expect(1, 8959, '\p{Blk=mathoperators}', "");
    Expect(0, 8959, '\p{^Blk=mathoperators}', "");
    Expect(0, 8959, '\P{Blk=mathoperators}', "");
    Expect(1, 8959, '\P{^Blk=mathoperators}', "");
    Expect(0, 8960, '\p{Blk=mathoperators}', "");
    Expect(1, 8960, '\p{^Blk=mathoperators}', "");
    Expect(1, 8960, '\P{Blk=mathoperators}', "");
    Expect(0, 8960, '\P{^Blk=mathoperators}', "");
    Expect(1, 8959, '\p{Blk=:\Amathoperators\z:}', "");;
    Expect(0, 8960, '\p{Blk=:\Amathoperators\z:}', "");;
    Expect(1, 8959, '\p{Blk=-MATH_OPERATORS}', "");
    Expect(0, 8959, '\p{^Blk=-MATH_OPERATORS}', "");
    Expect(0, 8959, '\P{Blk=-MATH_OPERATORS}', "");
    Expect(1, 8959, '\P{^Blk=-MATH_OPERATORS}', "");
    Expect(0, 8960, '\p{Blk=-MATH_OPERATORS}', "");
    Expect(1, 8960, '\p{^Blk=-MATH_OPERATORS}', "");
    Expect(1, 8960, '\P{Blk=-MATH_OPERATORS}', "");
    Expect(0, 8960, '\P{^Blk=-MATH_OPERATORS}', "");
    Error('\p{Is_Block=-_Mathematical_Operators:=}');
    Error('\P{Is_Block=-_Mathematical_Operators:=}');
    Expect(1, 8959, '\p{Is_Block=mathematicaloperators}', "");
    Expect(0, 8959, '\p{^Is_Block=mathematicaloperators}', "");
    Expect(0, 8959, '\P{Is_Block=mathematicaloperators}', "");
    Expect(1, 8959, '\P{^Is_Block=mathematicaloperators}', "");
    Expect(0, 8960, '\p{Is_Block=mathematicaloperators}', "");
    Expect(1, 8960, '\p{^Is_Block=mathematicaloperators}', "");
    Expect(1, 8960, '\P{Is_Block=mathematicaloperators}', "");
    Expect(0, 8960, '\P{^Is_Block=mathematicaloperators}', "");
    Expect(1, 8959, '\p{Is_Block= Mathematical_Operators}', "");
    Expect(0, 8959, '\p{^Is_Block= Mathematical_Operators}', "");
    Expect(0, 8959, '\P{Is_Block= Mathematical_Operators}', "");
    Expect(1, 8959, '\P{^Is_Block= Mathematical_Operators}', "");
    Expect(0, 8960, '\p{Is_Block= Mathematical_Operators}', "");
    Expect(1, 8960, '\p{^Is_Block= Mathematical_Operators}', "");
    Expect(1, 8960, '\P{Is_Block= Mathematical_Operators}', "");
    Expect(0, 8960, '\P{^Is_Block= Mathematical_Operators}', "");
    Error('\p{Is_Blk=-_MATH_Operators:=}');
    Error('\P{Is_Blk=-_MATH_Operators:=}');
    Expect(1, 8959, '\p{Is_Blk=mathoperators}', "");
    Expect(0, 8959, '\p{^Is_Blk=mathoperators}', "");
    Expect(0, 8959, '\P{Is_Blk=mathoperators}', "");
    Expect(1, 8959, '\P{^Is_Blk=mathoperators}', "");
    Expect(0, 8960, '\p{Is_Blk=mathoperators}', "");
    Expect(1, 8960, '\p{^Is_Blk=mathoperators}', "");
    Expect(1, 8960, '\P{Is_Blk=mathoperators}', "");
    Expect(0, 8960, '\P{^Is_Blk=mathoperators}', "");
    Expect(1, 8959, '\p{Is_Blk=__MATH_operators}', "");
    Expect(0, 8959, '\p{^Is_Blk=__MATH_operators}', "");
    Expect(0, 8959, '\P{Is_Blk=__MATH_operators}', "");
    Expect(1, 8959, '\P{^Is_Blk=__MATH_operators}', "");
    Expect(0, 8960, '\p{Is_Blk=__MATH_operators}', "");
    Expect(1, 8960, '\p{^Is_Blk=__MATH_operators}', "");
    Expect(1, 8960, '\P{Is_Blk=__MATH_operators}', "");
    Expect(0, 8960, '\P{^Is_Blk=__MATH_operators}', "");
    Error('\p{Block: /a/--MAYAN_NUMERALS}');
    Error('\P{Block: /a/--MAYAN_NUMERALS}');
    Expect(1, 119551, '\p{Block=:\AMayan_Numerals\z:}', "");;
    Expect(0, 119552, '\p{Block=:\AMayan_Numerals\z:}', "");;
    Expect(1, 119551, '\p{Block=mayannumerals}', "");
    Expect(0, 119551, '\p{^Block=mayannumerals}', "");
    Expect(0, 119551, '\P{Block=mayannumerals}', "");
    Expect(1, 119551, '\P{^Block=mayannumerals}', "");
    Expect(0, 119552, '\p{Block=mayannumerals}', "");
    Expect(1, 119552, '\p{^Block=mayannumerals}', "");
    Expect(1, 119552, '\P{Block=mayannumerals}', "");
    Expect(0, 119552, '\P{^Block=mayannumerals}', "");
    Expect(1, 119551, '\p{Block=:\Amayannumerals\z:}', "");;
    Expect(0, 119552, '\p{Block=:\Amayannumerals\z:}', "");;
    Expect(1, 119551, '\p{Block=-	Mayan_Numerals}', "");
    Expect(0, 119551, '\p{^Block=-	Mayan_Numerals}', "");
    Expect(0, 119551, '\P{Block=-	Mayan_Numerals}', "");
    Expect(1, 119551, '\P{^Block=-	Mayan_Numerals}', "");
    Expect(0, 119552, '\p{Block=-	Mayan_Numerals}', "");
    Expect(1, 119552, '\p{^Block=-	Mayan_Numerals}', "");
    Expect(1, 119552, '\P{Block=-	Mayan_Numerals}', "");
    Expect(0, 119552, '\P{^Block=-	Mayan_Numerals}', "");
    Error('\p{Blk=	_Mayan_numerals:=}');
    Error('\P{Blk=	_Mayan_numerals:=}');
    Expect(1, 119551, '\p{Blk=:\AMayan_Numerals\z:}', "");;
    Expect(0, 119552, '\p{Blk=:\AMayan_Numerals\z:}', "");;
    Expect(1, 119551, '\p{Blk=mayannumerals}', "");
    Expect(0, 119551, '\p{^Blk=mayannumerals}', "");
    Expect(0, 119551, '\P{Blk=mayannumerals}', "");
    Expect(1, 119551, '\P{^Blk=mayannumerals}', "");
    Expect(0, 119552, '\p{Blk=mayannumerals}', "");
    Expect(1, 119552, '\p{^Blk=mayannumerals}', "");
    Expect(1, 119552, '\P{Blk=mayannumerals}', "");
    Expect(0, 119552, '\P{^Blk=mayannumerals}', "");
    Expect(1, 119551, '\p{Blk=:\Amayannumerals\z:}', "");;
    Expect(0, 119552, '\p{Blk=:\Amayannumerals\z:}', "");;
    Expect(1, 119551, '\p{Blk=--mayan_numerals}', "");
    Expect(0, 119551, '\p{^Blk=--mayan_numerals}', "");
    Expect(0, 119551, '\P{Blk=--mayan_numerals}', "");
    Expect(1, 119551, '\P{^Blk=--mayan_numerals}', "");
    Expect(0, 119552, '\p{Blk=--mayan_numerals}', "");
    Expect(1, 119552, '\p{^Blk=--mayan_numerals}', "");
    Expect(1, 119552, '\P{Blk=--mayan_numerals}', "");
    Expect(0, 119552, '\P{^Blk=--mayan_numerals}', "");
    Error('\p{Is_Block=-Mayan_Numerals/a/}');
    Error('\P{Is_Block=-Mayan_Numerals/a/}');
    Expect(1, 119551, '\p{Is_Block=mayannumerals}', "");
    Expect(0, 119551, '\p{^Is_Block=mayannumerals}', "");
    Expect(0, 119551, '\P{Is_Block=mayannumerals}', "");
    Expect(1, 119551, '\P{^Is_Block=mayannumerals}', "");
    Expect(0, 119552, '\p{Is_Block=mayannumerals}', "");
    Expect(1, 119552, '\p{^Is_Block=mayannumerals}', "");
    Expect(1, 119552, '\P{Is_Block=mayannumerals}', "");
    Expect(0, 119552, '\P{^Is_Block=mayannumerals}', "");
    Expect(1, 119551, '\p{Is_Block=_ mayan_Numerals}', "");
    Expect(0, 119551, '\p{^Is_Block=_ mayan_Numerals}', "");
    Expect(0, 119551, '\P{Is_Block=_ mayan_Numerals}', "");
    Expect(1, 119551, '\P{^Is_Block=_ mayan_Numerals}', "");
    Expect(0, 119552, '\p{Is_Block=_ mayan_Numerals}', "");
    Expect(1, 119552, '\p{^Is_Block=_ mayan_Numerals}', "");
    Expect(1, 119552, '\P{Is_Block=_ mayan_Numerals}', "");
    Expect(0, 119552, '\P{^Is_Block=_ mayan_Numerals}', "");
    Error('\p{Is_Blk= -MAYAN_Numerals/a/}');
    Error('\P{Is_Blk= -MAYAN_Numerals/a/}');
    Expect(1, 119551, '\p{Is_Blk=mayannumerals}', "");
    Expect(0, 119551, '\p{^Is_Blk=mayannumerals}', "");
    Expect(0, 119551, '\P{Is_Blk=mayannumerals}', "");
    Expect(1, 119551, '\P{^Is_Blk=mayannumerals}', "");
    Expect(0, 119552, '\p{Is_Blk=mayannumerals}', "");
    Expect(1, 119552, '\p{^Is_Blk=mayannumerals}', "");
    Expect(1, 119552, '\P{Is_Blk=mayannumerals}', "");
    Expect(0, 119552, '\P{^Is_Blk=mayannumerals}', "");
    Expect(1, 119551, '\p{Is_Blk=	 Mayan_NUMERALS}', "");
    Expect(0, 119551, '\p{^Is_Blk=	 Mayan_NUMERALS}', "");
    Expect(0, 119551, '\P{Is_Blk=	 Mayan_NUMERALS}', "");
    Expect(1, 119551, '\P{^Is_Blk=	 Mayan_NUMERALS}', "");
    Expect(0, 119552, '\p{Is_Blk=	 Mayan_NUMERALS}', "");
    Expect(1, 119552, '\p{^Is_Blk=	 Mayan_NUMERALS}', "");
    Expect(1, 119552, '\P{Is_Blk=	 Mayan_NUMERALS}', "");
    Expect(0, 119552, '\P{^Is_Blk=	 Mayan_NUMERALS}', "");
    Error('\p{Block=	Medefaidrin:=}');
    Error('\P{Block=	Medefaidrin:=}');
    Expect(1, 93855, '\p{Block=:\AMedefaidrin\z:}', "");;
    Expect(0, 93856, '\p{Block=:\AMedefaidrin\z:}', "");;
    Expect(1, 93855, '\p{Block: medefaidrin}', "");
    Expect(0, 93855, '\p{^Block: medefaidrin}', "");
    Expect(0, 93855, '\P{Block: medefaidrin}', "");
    Expect(1, 93855, '\P{^Block: medefaidrin}', "");
    Expect(0, 93856, '\p{Block: medefaidrin}', "");
    Expect(1, 93856, '\p{^Block: medefaidrin}', "");
    Expect(1, 93856, '\P{Block: medefaidrin}', "");
    Expect(0, 93856, '\P{^Block: medefaidrin}', "");
    Expect(1, 93855, '\p{Block=:\Amedefaidrin\z:}', "");;
    Expect(0, 93856, '\p{Block=:\Amedefaidrin\z:}', "");;
    Expect(1, 93855, '\p{Block=- Medefaidrin}', "");
    Expect(0, 93855, '\p{^Block=- Medefaidrin}', "");
    Expect(0, 93855, '\P{Block=- Medefaidrin}', "");
    Expect(1, 93855, '\P{^Block=- Medefaidrin}', "");
    Expect(0, 93856, '\p{Block=- Medefaidrin}', "");
    Expect(1, 93856, '\p{^Block=- Medefaidrin}', "");
    Expect(1, 93856, '\P{Block=- Medefaidrin}', "");
    Expect(0, 93856, '\P{^Block=- Medefaidrin}', "");
    Error('\p{Blk=:=-Medefaidrin}');
    Error('\P{Blk=:=-Medefaidrin}');
    Expect(1, 93855, '\p{Blk=:\AMedefaidrin\z:}', "");;
    Expect(0, 93856, '\p{Blk=:\AMedefaidrin\z:}', "");;
    Expect(1, 93855, '\p{Blk:medefaidrin}', "");
    Expect(0, 93855, '\p{^Blk:medefaidrin}', "");
    Expect(0, 93855, '\P{Blk:medefaidrin}', "");
    Expect(1, 93855, '\P{^Blk:medefaidrin}', "");
    Expect(0, 93856, '\p{Blk:medefaidrin}', "");
    Expect(1, 93856, '\p{^Blk:medefaidrin}', "");
    Expect(1, 93856, '\P{Blk:medefaidrin}', "");
    Expect(0, 93856, '\P{^Blk:medefaidrin}', "");
    Expect(1, 93855, '\p{Blk=:\Amedefaidrin\z:}', "");;
    Expect(0, 93856, '\p{Blk=:\Amedefaidrin\z:}', "");;
    Expect(1, 93855, '\p{Blk= 	Medefaidrin}', "");
    Expect(0, 93855, '\p{^Blk= 	Medefaidrin}', "");
    Expect(0, 93855, '\P{Blk= 	Medefaidrin}', "");
    Expect(1, 93855, '\P{^Blk= 	Medefaidrin}', "");
    Expect(0, 93856, '\p{Blk= 	Medefaidrin}', "");
    Expect(1, 93856, '\p{^Blk= 	Medefaidrin}', "");
    Expect(1, 93856, '\P{Blk= 	Medefaidrin}', "");
    Expect(0, 93856, '\P{^Blk= 	Medefaidrin}', "");
    Error('\p{Is_Block:	-_MEDEFAIDRIN/a/}');
    Error('\P{Is_Block:	-_MEDEFAIDRIN/a/}');
    Expect(1, 93855, '\p{Is_Block=medefaidrin}', "");
    Expect(0, 93855, '\p{^Is_Block=medefaidrin}', "");
    Expect(0, 93855, '\P{Is_Block=medefaidrin}', "");
    Expect(1, 93855, '\P{^Is_Block=medefaidrin}', "");
    Expect(0, 93856, '\p{Is_Block=medefaidrin}', "");
    Expect(1, 93856, '\p{^Is_Block=medefaidrin}', "");
    Expect(1, 93856, '\P{Is_Block=medefaidrin}', "");
    Expect(0, 93856, '\P{^Is_Block=medefaidrin}', "");
    Expect(1, 93855, '\p{Is_Block:	 	Medefaidrin}', "");
    Expect(0, 93855, '\p{^Is_Block:	 	Medefaidrin}', "");
    Expect(0, 93855, '\P{Is_Block:	 	Medefaidrin}', "");
    Expect(1, 93855, '\P{^Is_Block:	 	Medefaidrin}', "");
    Expect(0, 93856, '\p{Is_Block:	 	Medefaidrin}', "");
    Expect(1, 93856, '\p{^Is_Block:	 	Medefaidrin}', "");
    Expect(1, 93856, '\P{Is_Block:	 	Medefaidrin}', "");
    Expect(0, 93856, '\P{^Is_Block:	 	Medefaidrin}', "");
    Error('\p{Is_Blk=	Medefaidrin:=}');
    Error('\P{Is_Blk=	Medefaidrin:=}');
    Expect(1, 93855, '\p{Is_Blk=medefaidrin}', "");
    Expect(0, 93855, '\p{^Is_Blk=medefaidrin}', "");
    Expect(0, 93855, '\P{Is_Blk=medefaidrin}', "");
    Expect(1, 93855, '\P{^Is_Blk=medefaidrin}', "");
    Expect(0, 93856, '\p{Is_Blk=medefaidrin}', "");
    Expect(1, 93856, '\p{^Is_Blk=medefaidrin}', "");
    Expect(1, 93856, '\P{Is_Blk=medefaidrin}', "");
    Expect(0, 93856, '\P{^Is_Blk=medefaidrin}', "");
    Expect(1, 93855, '\p{Is_Blk=	-Medefaidrin}', "");
    Expect(0, 93855, '\p{^Is_Blk=	-Medefaidrin}', "");
    Expect(0, 93855, '\P{Is_Blk=	-Medefaidrin}', "");
    Expect(1, 93855, '\P{^Is_Blk=	-Medefaidrin}', "");
    Expect(0, 93856, '\p{Is_Blk=	-Medefaidrin}', "");
    Expect(1, 93856, '\p{^Is_Blk=	-Medefaidrin}', "");
    Expect(1, 93856, '\P{Is_Blk=	-Medefaidrin}', "");
    Expect(0, 93856, '\P{^Is_Blk=	-Medefaidrin}', "");
    Error('\p{Block=	-MEETEI_Mayek/a/}');
    Error('\P{Block=	-MEETEI_Mayek/a/}');
    Expect(1, 44031, '\p{Block=:\AMeetei_Mayek\z:}', "");;
    Expect(0, 44032, '\p{Block=:\AMeetei_Mayek\z:}', "");;
    Expect(1, 44031, '\p{Block:meeteimayek}', "");
    Expect(0, 44031, '\p{^Block:meeteimayek}', "");
    Expect(0, 44031, '\P{Block:meeteimayek}', "");
    Expect(1, 44031, '\P{^Block:meeteimayek}', "");
    Expect(0, 44032, '\p{Block:meeteimayek}', "");
    Expect(1, 44032, '\p{^Block:meeteimayek}', "");
    Expect(1, 44032, '\P{Block:meeteimayek}', "");
    Expect(0, 44032, '\P{^Block:meeteimayek}', "");
    Expect(1, 44031, '\p{Block=:\Ameeteimayek\z:}', "");;
    Expect(0, 44032, '\p{Block=:\Ameeteimayek\z:}', "");;
    Expect(1, 44031, '\p{Block=  meetei_Mayek}', "");
    Expect(0, 44031, '\p{^Block=  meetei_Mayek}', "");
    Expect(0, 44031, '\P{Block=  meetei_Mayek}', "");
    Expect(1, 44031, '\P{^Block=  meetei_Mayek}', "");
    Expect(0, 44032, '\p{Block=  meetei_Mayek}', "");
    Expect(1, 44032, '\p{^Block=  meetei_Mayek}', "");
    Expect(1, 44032, '\P{Block=  meetei_Mayek}', "");
    Expect(0, 44032, '\P{^Block=  meetei_Mayek}', "");
    Error('\p{Blk=_	meetei_mayek/a/}');
    Error('\P{Blk=_	meetei_mayek/a/}');
    Expect(1, 44031, '\p{Blk=:\AMeetei_Mayek\z:}', "");;
    Expect(0, 44032, '\p{Blk=:\AMeetei_Mayek\z:}', "");;
    Expect(1, 44031, '\p{Blk: meeteimayek}', "");
    Expect(0, 44031, '\p{^Blk: meeteimayek}', "");
    Expect(0, 44031, '\P{Blk: meeteimayek}', "");
    Expect(1, 44031, '\P{^Blk: meeteimayek}', "");
    Expect(0, 44032, '\p{Blk: meeteimayek}', "");
    Expect(1, 44032, '\p{^Blk: meeteimayek}', "");
    Expect(1, 44032, '\P{Blk: meeteimayek}', "");
    Expect(0, 44032, '\P{^Blk: meeteimayek}', "");
    Expect(1, 44031, '\p{Blk=:\Ameeteimayek\z:}', "");;
    Expect(0, 44032, '\p{Blk=:\Ameeteimayek\z:}', "");;
    Expect(1, 44031, '\p{Blk=__meetei_MAYEK}', "");
    Expect(0, 44031, '\p{^Blk=__meetei_MAYEK}', "");
    Expect(0, 44031, '\P{Blk=__meetei_MAYEK}', "");
    Expect(1, 44031, '\P{^Blk=__meetei_MAYEK}', "");
    Expect(0, 44032, '\p{Blk=__meetei_MAYEK}', "");
    Expect(1, 44032, '\p{^Blk=__meetei_MAYEK}', "");
    Expect(1, 44032, '\P{Blk=__meetei_MAYEK}', "");
    Expect(0, 44032, '\P{^Blk=__meetei_MAYEK}', "");
    Error('\p{Is_Block=_/a/Meetei_MAYEK}');
    Error('\P{Is_Block=_/a/Meetei_MAYEK}');
    Expect(1, 44031, '\p{Is_Block=meeteimayek}', "");
    Expect(0, 44031, '\p{^Is_Block=meeteimayek}', "");
    Expect(0, 44031, '\P{Is_Block=meeteimayek}', "");
    Expect(1, 44031, '\P{^Is_Block=meeteimayek}', "");
    Expect(0, 44032, '\p{Is_Block=meeteimayek}', "");
    Expect(1, 44032, '\p{^Is_Block=meeteimayek}', "");
    Expect(1, 44032, '\P{Is_Block=meeteimayek}', "");
    Expect(0, 44032, '\P{^Is_Block=meeteimayek}', "");
    Expect(1, 44031, '\p{Is_Block=-	meetei_Mayek}', "");
    Expect(0, 44031, '\p{^Is_Block=-	meetei_Mayek}', "");
    Expect(0, 44031, '\P{Is_Block=-	meetei_Mayek}', "");
    Expect(1, 44031, '\P{^Is_Block=-	meetei_Mayek}', "");
    Expect(0, 44032, '\p{Is_Block=-	meetei_Mayek}', "");
    Expect(1, 44032, '\p{^Is_Block=-	meetei_Mayek}', "");
    Expect(1, 44032, '\P{Is_Block=-	meetei_Mayek}', "");
    Expect(0, 44032, '\P{^Is_Block=-	meetei_Mayek}', "");
    Error('\p{Is_Blk=-:=Meetei_MAYEK}');
    Error('\P{Is_Blk=-:=Meetei_MAYEK}');
    Expect(1, 44031, '\p{Is_Blk=meeteimayek}', "");
    Expect(0, 44031, '\p{^Is_Blk=meeteimayek}', "");
    Expect(0, 44031, '\P{Is_Blk=meeteimayek}', "");
    Expect(1, 44031, '\P{^Is_Blk=meeteimayek}', "");
    Expect(0, 44032, '\p{Is_Blk=meeteimayek}', "");
    Expect(1, 44032, '\p{^Is_Blk=meeteimayek}', "");
    Expect(1, 44032, '\P{Is_Blk=meeteimayek}', "");
    Expect(0, 44032, '\P{^Is_Blk=meeteimayek}', "");
    Expect(1, 44031, '\p{Is_Blk=-Meetei_Mayek}', "");
    Expect(0, 44031, '\p{^Is_Blk=-Meetei_Mayek}', "");
    Expect(0, 44031, '\P{Is_Blk=-Meetei_Mayek}', "");
    Expect(1, 44031, '\P{^Is_Blk=-Meetei_Mayek}', "");
    Expect(0, 44032, '\p{Is_Blk=-Meetei_Mayek}', "");
    Expect(1, 44032, '\p{^Is_Blk=-Meetei_Mayek}', "");
    Expect(1, 44032, '\P{Is_Blk=-Meetei_Mayek}', "");
    Expect(0, 44032, '\P{^Is_Blk=-Meetei_Mayek}', "");
    Error('\p{Block:   -:=Meetei_Mayek_Extensions}');
    Error('\P{Block:   -:=Meetei_Mayek_Extensions}');
    Expect(1, 43775, '\p{Block=:\AMeetei_Mayek_Extensions\z:}', "");;
    Expect(0, 43776, '\p{Block=:\AMeetei_Mayek_Extensions\z:}', "");;
    Expect(1, 43775, '\p{Block=meeteimayekextensions}', "");
    Expect(0, 43775, '\p{^Block=meeteimayekextensions}', "");
    Expect(0, 43775, '\P{Block=meeteimayekextensions}', "");
    Expect(1, 43775, '\P{^Block=meeteimayekextensions}', "");
    Expect(0, 43776, '\p{Block=meeteimayekextensions}', "");
    Expect(1, 43776, '\p{^Block=meeteimayekextensions}', "");
    Expect(1, 43776, '\P{Block=meeteimayekextensions}', "");
    Expect(0, 43776, '\P{^Block=meeteimayekextensions}', "");
    Expect(1, 43775, '\p{Block=:\Ameeteimayekextensions\z:}', "");;
    Expect(0, 43776, '\p{Block=:\Ameeteimayekextensions\z:}', "");;
    Expect(1, 43775, '\p{Block=-_Meetei_Mayek_Extensions}', "");
    Expect(0, 43775, '\p{^Block=-_Meetei_Mayek_Extensions}', "");
    Expect(0, 43775, '\P{Block=-_Meetei_Mayek_Extensions}', "");
    Expect(1, 43775, '\P{^Block=-_Meetei_Mayek_Extensions}', "");
    Expect(0, 43776, '\p{Block=-_Meetei_Mayek_Extensions}', "");
    Expect(1, 43776, '\p{^Block=-_Meetei_Mayek_Extensions}', "");
    Expect(1, 43776, '\P{Block=-_Meetei_Mayek_Extensions}', "");
    Expect(0, 43776, '\P{^Block=-_Meetei_Mayek_Extensions}', "");
    Error('\p{Blk= /a/Meetei_mayek_ext}');
    Error('\P{Blk= /a/Meetei_mayek_ext}');
    Expect(1, 43775, '\p{Blk=:\AMeetei_Mayek_Ext\z:}', "");;
    Expect(0, 43776, '\p{Blk=:\AMeetei_Mayek_Ext\z:}', "");;
    Expect(1, 43775, '\p{Blk=meeteimayekext}', "");
    Expect(0, 43775, '\p{^Blk=meeteimayekext}', "");
    Expect(0, 43775, '\P{Blk=meeteimayekext}', "");
    Expect(1, 43775, '\P{^Blk=meeteimayekext}', "");
    Expect(0, 43776, '\p{Blk=meeteimayekext}', "");
    Expect(1, 43776, '\p{^Blk=meeteimayekext}', "");
    Expect(1, 43776, '\P{Blk=meeteimayekext}', "");
    Expect(0, 43776, '\P{^Blk=meeteimayekext}', "");
    Expect(1, 43775, '\p{Blk=:\Ameeteimayekext\z:}', "");;
    Expect(0, 43776, '\p{Blk=:\Ameeteimayekext\z:}', "");;
    Expect(1, 43775, '\p{Blk=_ Meetei_MAYEK_ext}', "");
    Expect(0, 43775, '\p{^Blk=_ Meetei_MAYEK_ext}', "");
    Expect(0, 43775, '\P{Blk=_ Meetei_MAYEK_ext}', "");
    Expect(1, 43775, '\P{^Blk=_ Meetei_MAYEK_ext}', "");
    Expect(0, 43776, '\p{Blk=_ Meetei_MAYEK_ext}', "");
    Expect(1, 43776, '\p{^Blk=_ Meetei_MAYEK_ext}', "");
    Expect(1, 43776, '\P{Blk=_ Meetei_MAYEK_ext}', "");
    Expect(0, 43776, '\P{^Blk=_ Meetei_MAYEK_ext}', "");
    Error('\p{Is_Block=_/a/Meetei_mayek_EXTENSIONS}');
    Error('\P{Is_Block=_/a/Meetei_mayek_EXTENSIONS}');
    Expect(1, 43775, '\p{Is_Block=meeteimayekextensions}', "");
    Expect(0, 43775, '\p{^Is_Block=meeteimayekextensions}', "");
    Expect(0, 43775, '\P{Is_Block=meeteimayekextensions}', "");
    Expect(1, 43775, '\P{^Is_Block=meeteimayekextensions}', "");
    Expect(0, 43776, '\p{Is_Block=meeteimayekextensions}', "");
    Expect(1, 43776, '\p{^Is_Block=meeteimayekextensions}', "");
    Expect(1, 43776, '\P{Is_Block=meeteimayekextensions}', "");
    Expect(0, 43776, '\P{^Is_Block=meeteimayekextensions}', "");
    Expect(1, 43775, '\p{Is_Block=_-MEETEI_Mayek_extensions}', "");
    Expect(0, 43775, '\p{^Is_Block=_-MEETEI_Mayek_extensions}', "");
    Expect(0, 43775, '\P{Is_Block=_-MEETEI_Mayek_extensions}', "");
    Expect(1, 43775, '\P{^Is_Block=_-MEETEI_Mayek_extensions}', "");
    Expect(0, 43776, '\p{Is_Block=_-MEETEI_Mayek_extensions}', "");
    Expect(1, 43776, '\p{^Is_Block=_-MEETEI_Mayek_extensions}', "");
    Expect(1, 43776, '\P{Is_Block=_-MEETEI_Mayek_extensions}', "");
    Expect(0, 43776, '\P{^Is_Block=_-MEETEI_Mayek_extensions}', "");
    Error('\p{Is_Blk=:=meetei_mayek_Ext}');
    Error('\P{Is_Blk=:=meetei_mayek_Ext}');
    Expect(1, 43775, '\p{Is_Blk:	meeteimayekext}', "");
    Expect(0, 43775, '\p{^Is_Blk:	meeteimayekext}', "");
    Expect(0, 43775, '\P{Is_Blk:	meeteimayekext}', "");
    Expect(1, 43775, '\P{^Is_Blk:	meeteimayekext}', "");
    Expect(0, 43776, '\p{Is_Blk:	meeteimayekext}', "");
    Expect(1, 43776, '\p{^Is_Blk:	meeteimayekext}', "");
    Expect(1, 43776, '\P{Is_Blk:	meeteimayekext}', "");
    Expect(0, 43776, '\P{^Is_Blk:	meeteimayekext}', "");
    Expect(1, 43775, '\p{Is_Blk:	 Meetei_Mayek_Ext}', "");
    Expect(0, 43775, '\p{^Is_Blk:	 Meetei_Mayek_Ext}', "");
    Expect(0, 43775, '\P{Is_Blk:	 Meetei_Mayek_Ext}', "");
    Expect(1, 43775, '\P{^Is_Blk:	 Meetei_Mayek_Ext}', "");
    Expect(0, 43776, '\p{Is_Blk:	 Meetei_Mayek_Ext}', "");
    Expect(1, 43776, '\p{^Is_Blk:	 Meetei_Mayek_Ext}', "");
    Expect(1, 43776, '\P{Is_Blk:	 Meetei_Mayek_Ext}', "");
    Expect(0, 43776, '\P{^Is_Blk:	 Meetei_Mayek_Ext}', "");
    Error('\p{Block=/a/_ Mende_Kikakui}');
    Error('\P{Block=/a/_ Mende_Kikakui}');
    Expect(1, 125151, '\p{Block=:\AMende_Kikakui\z:}', "");;
    Expect(0, 125152, '\p{Block=:\AMende_Kikakui\z:}', "");;
    Expect(1, 125151, '\p{Block: mendekikakui}', "");
    Expect(0, 125151, '\p{^Block: mendekikakui}', "");
    Expect(0, 125151, '\P{Block: mendekikakui}', "");
    Expect(1, 125151, '\P{^Block: mendekikakui}', "");
    Expect(0, 125152, '\p{Block: mendekikakui}', "");
    Expect(1, 125152, '\p{^Block: mendekikakui}', "");
    Expect(1, 125152, '\P{Block: mendekikakui}', "");
    Expect(0, 125152, '\P{^Block: mendekikakui}', "");
    Expect(1, 125151, '\p{Block=:\Amendekikakui\z:}', "");;
    Expect(0, 125152, '\p{Block=:\Amendekikakui\z:}', "");;
    Expect(1, 125151, '\p{Block=_	Mende_KIKAKUI}', "");
    Expect(0, 125151, '\p{^Block=_	Mende_KIKAKUI}', "");
    Expect(0, 125151, '\P{Block=_	Mende_KIKAKUI}', "");
    Expect(1, 125151, '\P{^Block=_	Mende_KIKAKUI}', "");
    Expect(0, 125152, '\p{Block=_	Mende_KIKAKUI}', "");
    Expect(1, 125152, '\p{^Block=_	Mende_KIKAKUI}', "");
    Expect(1, 125152, '\P{Block=_	Mende_KIKAKUI}', "");
    Expect(0, 125152, '\P{^Block=_	Mende_KIKAKUI}', "");
    Error('\p{Blk=	-MENDE_kikakui/a/}');
    Error('\P{Blk=	-MENDE_kikakui/a/}');
    Expect(1, 125151, '\p{Blk=:\AMende_Kikakui\z:}', "");;
    Expect(0, 125152, '\p{Blk=:\AMende_Kikakui\z:}', "");;
    Expect(1, 125151, '\p{Blk=mendekikakui}', "");
    Expect(0, 125151, '\p{^Blk=mendekikakui}', "");
    Expect(0, 125151, '\P{Blk=mendekikakui}', "");
    Expect(1, 125151, '\P{^Blk=mendekikakui}', "");
    Expect(0, 125152, '\p{Blk=mendekikakui}', "");
    Expect(1, 125152, '\p{^Blk=mendekikakui}', "");
    Expect(1, 125152, '\P{Blk=mendekikakui}', "");
    Expect(0, 125152, '\P{^Blk=mendekikakui}', "");
    Expect(1, 125151, '\p{Blk=:\Amendekikakui\z:}', "");;
    Expect(0, 125152, '\p{Blk=:\Amendekikakui\z:}', "");;
    Expect(1, 125151, '\p{Blk= _Mende_Kikakui}', "");
    Expect(0, 125151, '\p{^Blk= _Mende_Kikakui}', "");
    Expect(0, 125151, '\P{Blk= _Mende_Kikakui}', "");
    Expect(1, 125151, '\P{^Blk= _Mende_Kikakui}', "");
    Expect(0, 125152, '\p{Blk= _Mende_Kikakui}', "");
    Expect(1, 125152, '\p{^Blk= _Mende_Kikakui}', "");
    Expect(1, 125152, '\P{Blk= _Mende_Kikakui}', "");
    Expect(0, 125152, '\P{^Blk= _Mende_Kikakui}', "");
    Error('\p{Is_Block=	_Mende_Kikakui:=}');
    Error('\P{Is_Block=	_Mende_Kikakui:=}');
    Expect(1, 125151, '\p{Is_Block=mendekikakui}', "");
    Expect(0, 125151, '\p{^Is_Block=mendekikakui}', "");
    Expect(0, 125151, '\P{Is_Block=mendekikakui}', "");
    Expect(1, 125151, '\P{^Is_Block=mendekikakui}', "");
    Expect(0, 125152, '\p{Is_Block=mendekikakui}', "");
    Expect(1, 125152, '\p{^Is_Block=mendekikakui}', "");
    Expect(1, 125152, '\P{Is_Block=mendekikakui}', "");
    Expect(0, 125152, '\P{^Is_Block=mendekikakui}', "");
    Expect(1, 125151, '\p{Is_Block=	mende_KIKAKUI}', "");
    Expect(0, 125151, '\p{^Is_Block=	mende_KIKAKUI}', "");
    Expect(0, 125151, '\P{Is_Block=	mende_KIKAKUI}', "");
    Expect(1, 125151, '\P{^Is_Block=	mende_KIKAKUI}', "");
    Expect(0, 125152, '\p{Is_Block=	mende_KIKAKUI}', "");
    Expect(1, 125152, '\p{^Is_Block=	mende_KIKAKUI}', "");
    Expect(1, 125152, '\P{Is_Block=	mende_KIKAKUI}', "");
    Expect(0, 125152, '\P{^Is_Block=	mende_KIKAKUI}', "");
    Error('\p{Is_Blk=:= -mende_KIKAKUI}');
    Error('\P{Is_Blk=:= -mende_KIKAKUI}');
    Expect(1, 125151, '\p{Is_Blk=mendekikakui}', "");
    Expect(0, 125151, '\p{^Is_Blk=mendekikakui}', "");
    Expect(0, 125151, '\P{Is_Blk=mendekikakui}', "");
    Expect(1, 125151, '\P{^Is_Blk=mendekikakui}', "");
    Expect(0, 125152, '\p{Is_Blk=mendekikakui}', "");
    Expect(1, 125152, '\p{^Is_Blk=mendekikakui}', "");
    Expect(1, 125152, '\P{Is_Blk=mendekikakui}', "");
    Expect(0, 125152, '\P{^Is_Blk=mendekikakui}', "");
    Expect(1, 125151, '\p{Is_Blk=  Mende_kikakui}', "");
    Expect(0, 125151, '\p{^Is_Blk=  Mende_kikakui}', "");
    Expect(0, 125151, '\P{Is_Blk=  Mende_kikakui}', "");
    Expect(1, 125151, '\P{^Is_Blk=  Mende_kikakui}', "");
    Expect(0, 125152, '\p{Is_Blk=  Mende_kikakui}', "");
    Expect(1, 125152, '\p{^Is_Blk=  Mende_kikakui}', "");
    Expect(1, 125152, '\P{Is_Blk=  Mende_kikakui}', "");
    Expect(0, 125152, '\P{^Is_Blk=  Mende_kikakui}', "");
    Error('\p{Block= /a/MEROITIC_cursive}');
    Error('\P{Block= /a/MEROITIC_cursive}');
    Expect(1, 68095, '\p{Block=:\AMeroitic_Cursive\z:}', "");;
    Expect(0, 68096, '\p{Block=:\AMeroitic_Cursive\z:}', "");;
    Expect(1, 68095, '\p{Block=meroiticcursive}', "");
    Expect(0, 68095, '\p{^Block=meroiticcursive}', "");
    Expect(0, 68095, '\P{Block=meroiticcursive}', "");
    Expect(1, 68095, '\P{^Block=meroiticcursive}', "");
    Expect(0, 68096, '\p{Block=meroiticcursive}', "");
    Expect(1, 68096, '\p{^Block=meroiticcursive}', "");
    Expect(1, 68096, '\P{Block=meroiticcursive}', "");
    Expect(0, 68096, '\P{^Block=meroiticcursive}', "");
    Expect(1, 68095, '\p{Block=:\Ameroiticcursive\z:}', "");;
    Expect(0, 68096, '\p{Block=:\Ameroiticcursive\z:}', "");;
    Expect(1, 68095, '\p{Block=--Meroitic_cursive}', "");
    Expect(0, 68095, '\p{^Block=--Meroitic_cursive}', "");
    Expect(0, 68095, '\P{Block=--Meroitic_cursive}', "");
    Expect(1, 68095, '\P{^Block=--Meroitic_cursive}', "");
    Expect(0, 68096, '\p{Block=--Meroitic_cursive}', "");
    Expect(1, 68096, '\p{^Block=--Meroitic_cursive}', "");
    Expect(1, 68096, '\P{Block=--Meroitic_cursive}', "");
    Expect(0, 68096, '\P{^Block=--Meroitic_cursive}', "");
    Error('\p{Blk=_/a/MEROITIC_CURSIVE}');
    Error('\P{Blk=_/a/MEROITIC_CURSIVE}');
    Expect(1, 68095, '\p{Blk=:\AMeroitic_Cursive\z:}', "");;
    Expect(0, 68096, '\p{Blk=:\AMeroitic_Cursive\z:}', "");;
    Expect(1, 68095, '\p{Blk=meroiticcursive}', "");
    Expect(0, 68095, '\p{^Blk=meroiticcursive}', "");
    Expect(0, 68095, '\P{Blk=meroiticcursive}', "");
    Expect(1, 68095, '\P{^Blk=meroiticcursive}', "");
    Expect(0, 68096, '\p{Blk=meroiticcursive}', "");
    Expect(1, 68096, '\p{^Blk=meroiticcursive}', "");
    Expect(1, 68096, '\P{Blk=meroiticcursive}', "");
    Expect(0, 68096, '\P{^Blk=meroiticcursive}', "");
    Expect(1, 68095, '\p{Blk=:\Ameroiticcursive\z:}', "");;
    Expect(0, 68096, '\p{Blk=:\Ameroiticcursive\z:}', "");;
    Expect(1, 68095, '\p{Blk=	_Meroitic_CURSIVE}', "");
    Expect(0, 68095, '\p{^Blk=	_Meroitic_CURSIVE}', "");
    Expect(0, 68095, '\P{Blk=	_Meroitic_CURSIVE}', "");
    Expect(1, 68095, '\P{^Blk=	_Meroitic_CURSIVE}', "");
    Expect(0, 68096, '\p{Blk=	_Meroitic_CURSIVE}', "");
    Expect(1, 68096, '\p{^Blk=	_Meroitic_CURSIVE}', "");
    Expect(1, 68096, '\P{Blk=	_Meroitic_CURSIVE}', "");
    Expect(0, 68096, '\P{^Blk=	_Meroitic_CURSIVE}', "");
    Error('\p{Is_Block=Meroitic_CURSIVE/a/}');
    Error('\P{Is_Block=Meroitic_CURSIVE/a/}');
    Expect(1, 68095, '\p{Is_Block=meroiticcursive}', "");
    Expect(0, 68095, '\p{^Is_Block=meroiticcursive}', "");
    Expect(0, 68095, '\P{Is_Block=meroiticcursive}', "");
    Expect(1, 68095, '\P{^Is_Block=meroiticcursive}', "");
    Expect(0, 68096, '\p{Is_Block=meroiticcursive}', "");
    Expect(1, 68096, '\p{^Is_Block=meroiticcursive}', "");
    Expect(1, 68096, '\P{Is_Block=meroiticcursive}', "");
    Expect(0, 68096, '\P{^Is_Block=meroiticcursive}', "");
    Expect(1, 68095, '\p{Is_Block=-Meroitic_CURSIVE}', "");
    Expect(0, 68095, '\p{^Is_Block=-Meroitic_CURSIVE}', "");
    Expect(0, 68095, '\P{Is_Block=-Meroitic_CURSIVE}', "");
    Expect(1, 68095, '\P{^Is_Block=-Meroitic_CURSIVE}', "");
    Expect(0, 68096, '\p{Is_Block=-Meroitic_CURSIVE}', "");
    Expect(1, 68096, '\p{^Is_Block=-Meroitic_CURSIVE}', "");
    Expect(1, 68096, '\P{Is_Block=-Meroitic_CURSIVE}', "");
    Expect(0, 68096, '\P{^Is_Block=-Meroitic_CURSIVE}', "");
    Error('\p{Is_Blk=	/a/Meroitic_cursive}');
    Error('\P{Is_Blk=	/a/Meroitic_cursive}');
    Expect(1, 68095, '\p{Is_Blk=meroiticcursive}', "");
    Expect(0, 68095, '\p{^Is_Blk=meroiticcursive}', "");
    Expect(0, 68095, '\P{Is_Blk=meroiticcursive}', "");
    Expect(1, 68095, '\P{^Is_Blk=meroiticcursive}', "");
    Expect(0, 68096, '\p{Is_Blk=meroiticcursive}', "");
    Expect(1, 68096, '\p{^Is_Blk=meroiticcursive}', "");
    Expect(1, 68096, '\P{Is_Blk=meroiticcursive}', "");
    Expect(0, 68096, '\P{^Is_Blk=meroiticcursive}', "");
    Expect(1, 68095, '\p{Is_Blk:	_MEROITIC_cursive}', "");
    Expect(0, 68095, '\p{^Is_Blk:	_MEROITIC_cursive}', "");
    Expect(0, 68095, '\P{Is_Blk:	_MEROITIC_cursive}', "");
    Expect(1, 68095, '\P{^Is_Blk:	_MEROITIC_cursive}', "");
    Expect(0, 68096, '\p{Is_Blk:	_MEROITIC_cursive}', "");
    Expect(1, 68096, '\p{^Is_Blk:	_MEROITIC_cursive}', "");
    Expect(1, 68096, '\P{Is_Blk:	_MEROITIC_cursive}', "");
    Expect(0, 68096, '\P{^Is_Blk:	_MEROITIC_cursive}', "");
    Error('\p{Block=-	meroitic_hieroglyphs/a/}');
    Error('\P{Block=-	meroitic_hieroglyphs/a/}');
    Expect(1, 67999, '\p{Block=:\AMeroitic_Hieroglyphs\z:}', "");;
    Expect(0, 68000, '\p{Block=:\AMeroitic_Hieroglyphs\z:}', "");;
    Expect(1, 67999, '\p{Block=meroitichieroglyphs}', "");
    Expect(0, 67999, '\p{^Block=meroitichieroglyphs}', "");
    Expect(0, 67999, '\P{Block=meroitichieroglyphs}', "");
    Expect(1, 67999, '\P{^Block=meroitichieroglyphs}', "");
    Expect(0, 68000, '\p{Block=meroitichieroglyphs}', "");
    Expect(1, 68000, '\p{^Block=meroitichieroglyphs}', "");
    Expect(1, 68000, '\P{Block=meroitichieroglyphs}', "");
    Expect(0, 68000, '\P{^Block=meroitichieroglyphs}', "");
    Expect(1, 67999, '\p{Block=:\Ameroitichieroglyphs\z:}', "");;
    Expect(0, 68000, '\p{Block=:\Ameroitichieroglyphs\z:}', "");;
    Expect(1, 67999, '\p{Block=MEROITIC_Hieroglyphs}', "");
    Expect(0, 67999, '\p{^Block=MEROITIC_Hieroglyphs}', "");
    Expect(0, 67999, '\P{Block=MEROITIC_Hieroglyphs}', "");
    Expect(1, 67999, '\P{^Block=MEROITIC_Hieroglyphs}', "");
    Expect(0, 68000, '\p{Block=MEROITIC_Hieroglyphs}', "");
    Expect(1, 68000, '\p{^Block=MEROITIC_Hieroglyphs}', "");
    Expect(1, 68000, '\P{Block=MEROITIC_Hieroglyphs}', "");
    Expect(0, 68000, '\P{^Block=MEROITIC_Hieroglyphs}', "");
    Error('\p{Blk=_/a/Meroitic_Hieroglyphs}');
    Error('\P{Blk=_/a/Meroitic_Hieroglyphs}');
    Expect(1, 67999, '\p{Blk=:\AMeroitic_Hieroglyphs\z:}', "");;
    Expect(0, 68000, '\p{Blk=:\AMeroitic_Hieroglyphs\z:}', "");;
    Expect(1, 67999, '\p{Blk: meroitichieroglyphs}', "");
    Expect(0, 67999, '\p{^Blk: meroitichieroglyphs}', "");
    Expect(0, 67999, '\P{Blk: meroitichieroglyphs}', "");
    Expect(1, 67999, '\P{^Blk: meroitichieroglyphs}', "");
    Expect(0, 68000, '\p{Blk: meroitichieroglyphs}', "");
    Expect(1, 68000, '\p{^Blk: meroitichieroglyphs}', "");
    Expect(1, 68000, '\P{Blk: meroitichieroglyphs}', "");
    Expect(0, 68000, '\P{^Blk: meroitichieroglyphs}', "");
    Expect(1, 67999, '\p{Blk=:\Ameroitichieroglyphs\z:}', "");;
    Expect(0, 68000, '\p{Blk=:\Ameroitichieroglyphs\z:}', "");;
    Expect(1, 67999, '\p{Blk=_	Meroitic_Hieroglyphs}', "");
    Expect(0, 67999, '\p{^Blk=_	Meroitic_Hieroglyphs}', "");
    Expect(0, 67999, '\P{Blk=_	Meroitic_Hieroglyphs}', "");
    Expect(1, 67999, '\P{^Blk=_	Meroitic_Hieroglyphs}', "");
    Expect(0, 68000, '\p{Blk=_	Meroitic_Hieroglyphs}', "");
    Expect(1, 68000, '\p{^Blk=_	Meroitic_Hieroglyphs}', "");
    Expect(1, 68000, '\P{Blk=_	Meroitic_Hieroglyphs}', "");
    Expect(0, 68000, '\P{^Blk=_	Meroitic_Hieroglyphs}', "");
    Error('\p{Is_Block:	 MEROITIC_HIEROGLYPHS/a/}');
    Error('\P{Is_Block:	 MEROITIC_HIEROGLYPHS/a/}');
    Expect(1, 67999, '\p{Is_Block=meroitichieroglyphs}', "");
    Expect(0, 67999, '\p{^Is_Block=meroitichieroglyphs}', "");
    Expect(0, 67999, '\P{Is_Block=meroitichieroglyphs}', "");
    Expect(1, 67999, '\P{^Is_Block=meroitichieroglyphs}', "");
    Expect(0, 68000, '\p{Is_Block=meroitichieroglyphs}', "");
    Expect(1, 68000, '\p{^Is_Block=meroitichieroglyphs}', "");
    Expect(1, 68000, '\P{Is_Block=meroitichieroglyphs}', "");
    Expect(0, 68000, '\P{^Is_Block=meroitichieroglyphs}', "");
    Expect(1, 67999, '\p{Is_Block=	 Meroitic_HIEROGLYPHS}', "");
    Expect(0, 67999, '\p{^Is_Block=	 Meroitic_HIEROGLYPHS}', "");
    Expect(0, 67999, '\P{Is_Block=	 Meroitic_HIEROGLYPHS}', "");
    Expect(1, 67999, '\P{^Is_Block=	 Meroitic_HIEROGLYPHS}', "");
    Expect(0, 68000, '\p{Is_Block=	 Meroitic_HIEROGLYPHS}', "");
    Expect(1, 68000, '\p{^Is_Block=	 Meroitic_HIEROGLYPHS}', "");
    Expect(1, 68000, '\P{Is_Block=	 Meroitic_HIEROGLYPHS}', "");
    Expect(0, 68000, '\P{^Is_Block=	 Meroitic_HIEROGLYPHS}', "");
    Error('\p{Is_Blk=/a/__Meroitic_HIEROGLYPHS}');
    Error('\P{Is_Blk=/a/__Meroitic_HIEROGLYPHS}');
    Expect(1, 67999, '\p{Is_Blk=meroitichieroglyphs}', "");
    Expect(0, 67999, '\p{^Is_Blk=meroitichieroglyphs}', "");
    Expect(0, 67999, '\P{Is_Blk=meroitichieroglyphs}', "");
    Expect(1, 67999, '\P{^Is_Blk=meroitichieroglyphs}', "");
    Expect(0, 68000, '\p{Is_Blk=meroitichieroglyphs}', "");
    Expect(1, 68000, '\p{^Is_Blk=meroitichieroglyphs}', "");
    Expect(1, 68000, '\P{Is_Blk=meroitichieroglyphs}', "");
    Expect(0, 68000, '\P{^Is_Blk=meroitichieroglyphs}', "");
    Expect(1, 67999, '\p{Is_Blk:   	 Meroitic_hieroglyphs}', "");
    Expect(0, 67999, '\p{^Is_Blk:   	 Meroitic_hieroglyphs}', "");
    Expect(0, 67999, '\P{Is_Blk:   	 Meroitic_hieroglyphs}', "");
    Expect(1, 67999, '\P{^Is_Blk:   	 Meroitic_hieroglyphs}', "");
    Expect(0, 68000, '\p{Is_Blk:   	 Meroitic_hieroglyphs}', "");
    Expect(1, 68000, '\p{^Is_Blk:   	 Meroitic_hieroglyphs}', "");
    Expect(1, 68000, '\P{Is_Blk:   	 Meroitic_hieroglyphs}', "");
    Expect(0, 68000, '\P{^Is_Blk:   	 Meroitic_hieroglyphs}', "");
    Error('\p{Block=/a/--Miao}');
    Error('\P{Block=/a/--Miao}');
    Expect(1, 94111, '\p{Block=:\AMiao\z:}', "");;
    Expect(0, 94112, '\p{Block=:\AMiao\z:}', "");;
    Expect(1, 94111, '\p{Block=miao}', "");
    Expect(0, 94111, '\p{^Block=miao}', "");
    Expect(0, 94111, '\P{Block=miao}', "");
    Expect(1, 94111, '\P{^Block=miao}', "");
    Expect(0, 94112, '\p{Block=miao}', "");
    Expect(1, 94112, '\p{^Block=miao}', "");
    Expect(1, 94112, '\P{Block=miao}', "");
    Expect(0, 94112, '\P{^Block=miao}', "");
    Expect(1, 94111, '\p{Block=:\Amiao\z:}', "");;
    Expect(0, 94112, '\p{Block=:\Amiao\z:}', "");;
    Expect(1, 94111, '\p{Block=	_Miao}', "");
    Expect(0, 94111, '\p{^Block=	_Miao}', "");
    Expect(0, 94111, '\P{Block=	_Miao}', "");
    Expect(1, 94111, '\P{^Block=	_Miao}', "");
    Expect(0, 94112, '\p{Block=	_Miao}', "");
    Expect(1, 94112, '\p{^Block=	_Miao}', "");
    Expect(1, 94112, '\P{Block=	_Miao}', "");
    Expect(0, 94112, '\P{^Block=	_Miao}', "");
    Error('\p{Blk=  Miao/a/}');
    Error('\P{Blk=  Miao/a/}');
    Expect(1, 94111, '\p{Blk=:\AMiao\z:}', "");;
    Expect(0, 94112, '\p{Blk=:\AMiao\z:}', "");;
    Expect(1, 94111, '\p{Blk=miao}', "");
    Expect(0, 94111, '\p{^Blk=miao}', "");
    Expect(0, 94111, '\P{Blk=miao}', "");
    Expect(1, 94111, '\P{^Blk=miao}', "");
    Expect(0, 94112, '\p{Blk=miao}', "");
    Expect(1, 94112, '\p{^Blk=miao}', "");
    Expect(1, 94112, '\P{Blk=miao}', "");
    Expect(0, 94112, '\P{^Blk=miao}', "");
    Expect(1, 94111, '\p{Blk=:\Amiao\z:}', "");;
    Expect(0, 94112, '\p{Blk=:\Amiao\z:}', "");;
    Expect(1, 94111, '\p{Blk=	-Miao}', "");
    Expect(0, 94111, '\p{^Blk=	-Miao}', "");
    Expect(0, 94111, '\P{Blk=	-Miao}', "");
    Expect(1, 94111, '\P{^Blk=	-Miao}', "");
    Expect(0, 94112, '\p{Blk=	-Miao}', "");
    Expect(1, 94112, '\p{^Blk=	-Miao}', "");
    Expect(1, 94112, '\P{Blk=	-Miao}', "");
    Expect(0, 94112, '\P{^Blk=	-Miao}', "");
    Error('\p{Is_Block=/a/_	Miao}');
    Error('\P{Is_Block=/a/_	Miao}');
    Expect(1, 94111, '\p{Is_Block=miao}', "");
    Expect(0, 94111, '\p{^Is_Block=miao}', "");
    Expect(0, 94111, '\P{Is_Block=miao}', "");
    Expect(1, 94111, '\P{^Is_Block=miao}', "");
    Expect(0, 94112, '\p{Is_Block=miao}', "");
    Expect(1, 94112, '\p{^Is_Block=miao}', "");
    Expect(1, 94112, '\P{Is_Block=miao}', "");
    Expect(0, 94112, '\P{^Is_Block=miao}', "");
    Expect(1, 94111, '\p{Is_Block=	MIAO}', "");
    Expect(0, 94111, '\p{^Is_Block=	MIAO}', "");
    Expect(0, 94111, '\P{Is_Block=	MIAO}', "");
    Expect(1, 94111, '\P{^Is_Block=	MIAO}', "");
    Expect(0, 94112, '\p{Is_Block=	MIAO}', "");
    Expect(1, 94112, '\p{^Is_Block=	MIAO}', "");
    Expect(1, 94112, '\P{Is_Block=	MIAO}', "");
    Expect(0, 94112, '\P{^Is_Block=	MIAO}', "");
    Error('\p{Is_Blk=/a/ _MIAO}');
    Error('\P{Is_Blk=/a/ _MIAO}');
    Expect(1, 94111, '\p{Is_Blk:   miao}', "");
    Expect(0, 94111, '\p{^Is_Blk:   miao}', "");
    Expect(0, 94111, '\P{Is_Blk:   miao}', "");
    Expect(1, 94111, '\P{^Is_Blk:   miao}', "");
    Expect(0, 94112, '\p{Is_Blk:   miao}', "");
    Expect(1, 94112, '\p{^Is_Blk:   miao}', "");
    Expect(1, 94112, '\P{Is_Blk:   miao}', "");
    Expect(0, 94112, '\P{^Is_Blk:   miao}', "");
    Expect(1, 94111, '\p{Is_Blk=_ Miao}', "");
    Expect(0, 94111, '\p{^Is_Blk=_ Miao}', "");
    Expect(0, 94111, '\P{Is_Blk=_ Miao}', "");
    Expect(1, 94111, '\P{^Is_Blk=_ Miao}', "");
    Expect(0, 94112, '\p{Is_Blk=_ Miao}', "");
    Expect(1, 94112, '\p{^Is_Blk=_ Miao}', "");
    Expect(1, 94112, '\P{Is_Blk=_ Miao}', "");
    Expect(0, 94112, '\P{^Is_Blk=_ Miao}', "");
    Error('\p{Block::=_MISCELLANEOUS_Symbols_and_Arrows}');
    Error('\P{Block::=_MISCELLANEOUS_Symbols_and_Arrows}');
    Expect(1, 11263, '\p{Block=:\AMiscellaneous_Symbols_And_Arrows\z:}', "");;
    Expect(0, 11264, '\p{Block=:\AMiscellaneous_Symbols_And_Arrows\z:}', "");;
    Expect(1, 11263, '\p{Block=miscellaneoussymbolsandarrows}', "");
    Expect(0, 11263, '\p{^Block=miscellaneoussymbolsandarrows}', "");
    Expect(0, 11263, '\P{Block=miscellaneoussymbolsandarrows}', "");
    Expect(1, 11263, '\P{^Block=miscellaneoussymbolsandarrows}', "");
    Expect(0, 11264, '\p{Block=miscellaneoussymbolsandarrows}', "");
    Expect(1, 11264, '\p{^Block=miscellaneoussymbolsandarrows}', "");
    Expect(1, 11264, '\P{Block=miscellaneoussymbolsandarrows}', "");
    Expect(0, 11264, '\P{^Block=miscellaneoussymbolsandarrows}', "");
    Expect(1, 11263, '\p{Block=:\Amiscellaneoussymbolsandarrows\z:}', "");;
    Expect(0, 11264, '\p{Block=:\Amiscellaneoussymbolsandarrows\z:}', "");;
    Expect(1, 11263, '\p{Block:	MISCELLANEOUS_Symbols_AND_arrows}', "");
    Expect(0, 11263, '\p{^Block:	MISCELLANEOUS_Symbols_AND_arrows}', "");
    Expect(0, 11263, '\P{Block:	MISCELLANEOUS_Symbols_AND_arrows}', "");
    Expect(1, 11263, '\P{^Block:	MISCELLANEOUS_Symbols_AND_arrows}', "");
    Expect(0, 11264, '\p{Block:	MISCELLANEOUS_Symbols_AND_arrows}', "");
    Expect(1, 11264, '\p{^Block:	MISCELLANEOUS_Symbols_AND_arrows}', "");
    Expect(1, 11264, '\P{Block:	MISCELLANEOUS_Symbols_AND_arrows}', "");
    Expect(0, 11264, '\P{^Block:	MISCELLANEOUS_Symbols_AND_arrows}', "");
    Error('\p{Blk=_ MISC_arrows:=}');
    Error('\P{Blk=_ MISC_arrows:=}');
    Expect(1, 11263, '\p{Blk=:\AMisc_Arrows\z:}', "");;
    Expect(0, 11264, '\p{Blk=:\AMisc_Arrows\z:}', "");;
    Expect(1, 11263, '\p{Blk=miscarrows}', "");
    Expect(0, 11263, '\p{^Blk=miscarrows}', "");
    Expect(0, 11263, '\P{Blk=miscarrows}', "");
    Expect(1, 11263, '\P{^Blk=miscarrows}', "");
    Expect(0, 11264, '\p{Blk=miscarrows}', "");
    Expect(1, 11264, '\p{^Blk=miscarrows}', "");
    Expect(1, 11264, '\P{Blk=miscarrows}', "");
    Expect(0, 11264, '\P{^Blk=miscarrows}', "");
    Expect(1, 11263, '\p{Blk=:\Amiscarrows\z:}', "");;
    Expect(0, 11264, '\p{Blk=:\Amiscarrows\z:}', "");;
    Expect(1, 11263, '\p{Blk=	misc_Arrows}', "");
    Expect(0, 11263, '\p{^Blk=	misc_Arrows}', "");
    Expect(0, 11263, '\P{Blk=	misc_Arrows}', "");
    Expect(1, 11263, '\P{^Blk=	misc_Arrows}', "");
    Expect(0, 11264, '\p{Blk=	misc_Arrows}', "");
    Expect(1, 11264, '\p{^Blk=	misc_Arrows}', "");
    Expect(1, 11264, '\P{Blk=	misc_Arrows}', "");
    Expect(0, 11264, '\P{^Blk=	misc_Arrows}', "");
    Error('\p{Is_Block=__MISCELLANEOUS_symbols_and_ARROWS:=}');
    Error('\P{Is_Block=__MISCELLANEOUS_symbols_and_ARROWS:=}');
    Expect(1, 11263, '\p{Is_Block=miscellaneoussymbolsandarrows}', "");
    Expect(0, 11263, '\p{^Is_Block=miscellaneoussymbolsandarrows}', "");
    Expect(0, 11263, '\P{Is_Block=miscellaneoussymbolsandarrows}', "");
    Expect(1, 11263, '\P{^Is_Block=miscellaneoussymbolsandarrows}', "");
    Expect(0, 11264, '\p{Is_Block=miscellaneoussymbolsandarrows}', "");
    Expect(1, 11264, '\p{^Is_Block=miscellaneoussymbolsandarrows}', "");
    Expect(1, 11264, '\P{Is_Block=miscellaneoussymbolsandarrows}', "");
    Expect(0, 11264, '\P{^Is_Block=miscellaneoussymbolsandarrows}', "");
    Expect(1, 11263, '\p{Is_Block=_ Miscellaneous_symbols_And_Arrows}', "");
    Expect(0, 11263, '\p{^Is_Block=_ Miscellaneous_symbols_And_Arrows}', "");
    Expect(0, 11263, '\P{Is_Block=_ Miscellaneous_symbols_And_Arrows}', "");
    Expect(1, 11263, '\P{^Is_Block=_ Miscellaneous_symbols_And_Arrows}', "");
    Expect(0, 11264, '\p{Is_Block=_ Miscellaneous_symbols_And_Arrows}', "");
    Expect(1, 11264, '\p{^Is_Block=_ Miscellaneous_symbols_And_Arrows}', "");
    Expect(1, 11264, '\P{Is_Block=_ Miscellaneous_symbols_And_Arrows}', "");
    Expect(0, 11264, '\P{^Is_Block=_ Miscellaneous_symbols_And_Arrows}', "");
    Error('\p{Is_Blk=- Misc_Arrows/a/}');
    Error('\P{Is_Blk=- Misc_Arrows/a/}');
    Expect(1, 11263, '\p{Is_Blk=miscarrows}', "");
    Expect(0, 11263, '\p{^Is_Blk=miscarrows}', "");
    Expect(0, 11263, '\P{Is_Blk=miscarrows}', "");
    Expect(1, 11263, '\P{^Is_Blk=miscarrows}', "");
    Expect(0, 11264, '\p{Is_Blk=miscarrows}', "");
    Expect(1, 11264, '\p{^Is_Blk=miscarrows}', "");
    Expect(1, 11264, '\P{Is_Blk=miscarrows}', "");
    Expect(0, 11264, '\P{^Is_Blk=miscarrows}', "");
    Expect(1, 11263, '\p{Is_Blk:   -misc_arrows}', "");
    Expect(0, 11263, '\p{^Is_Blk:   -misc_arrows}', "");
    Expect(0, 11263, '\P{Is_Blk:   -misc_arrows}', "");
    Expect(1, 11263, '\P{^Is_Blk:   -misc_arrows}', "");
    Expect(0, 11264, '\p{Is_Blk:   -misc_arrows}', "");
    Expect(1, 11264, '\p{^Is_Blk:   -misc_arrows}', "");
    Expect(1, 11264, '\P{Is_Blk:   -misc_arrows}', "");
    Expect(0, 11264, '\P{^Is_Blk:   -misc_arrows}', "");
    Error('\p{Block=:=  MISCELLANEOUS_Mathematical_SYMBOLS_a}');
    Error('\P{Block=:=  MISCELLANEOUS_Mathematical_SYMBOLS_a}');
    Expect(1, 10223, '\p{Block=:\AMiscellaneous_Mathematical_Symbols_A\z:}', "");;
    Expect(0, 10224, '\p{Block=:\AMiscellaneous_Mathematical_Symbols_A\z:}', "");;
    Expect(1, 10223, '\p{Block=miscellaneousmathematicalsymbolsa}', "");
    Expect(0, 10223, '\p{^Block=miscellaneousmathematicalsymbolsa}', "");
    Expect(0, 10223, '\P{Block=miscellaneousmathematicalsymbolsa}', "");
    Expect(1, 10223, '\P{^Block=miscellaneousmathematicalsymbolsa}', "");
    Expect(0, 10224, '\p{Block=miscellaneousmathematicalsymbolsa}', "");
    Expect(1, 10224, '\p{^Block=miscellaneousmathematicalsymbolsa}', "");
    Expect(1, 10224, '\P{Block=miscellaneousmathematicalsymbolsa}', "");
    Expect(0, 10224, '\P{^Block=miscellaneousmathematicalsymbolsa}', "");
    Expect(1, 10223, '\p{Block=:\Amiscellaneousmathematicalsymbolsa\z:}', "");;
    Expect(0, 10224, '\p{Block=:\Amiscellaneousmathematicalsymbolsa\z:}', "");;
    Expect(1, 10223, '\p{Block=	-Miscellaneous_mathematical_SYMBOLS_a}', "");
    Expect(0, 10223, '\p{^Block=	-Miscellaneous_mathematical_SYMBOLS_a}', "");
    Expect(0, 10223, '\P{Block=	-Miscellaneous_mathematical_SYMBOLS_a}', "");
    Expect(1, 10223, '\P{^Block=	-Miscellaneous_mathematical_SYMBOLS_a}', "");
    Expect(0, 10224, '\p{Block=	-Miscellaneous_mathematical_SYMBOLS_a}', "");
    Expect(1, 10224, '\p{^Block=	-Miscellaneous_mathematical_SYMBOLS_a}', "");
    Expect(1, 10224, '\P{Block=	-Miscellaneous_mathematical_SYMBOLS_a}', "");
    Expect(0, 10224, '\P{^Block=	-Miscellaneous_mathematical_SYMBOLS_a}', "");
    Error('\p{Blk:	  Misc_Math_symbols_A:=}');
    Error('\P{Blk:	  Misc_Math_symbols_A:=}');
    Expect(1, 10223, '\p{Blk=:\AMisc_Math_Symbols_A\z:}', "");;
    Expect(0, 10224, '\p{Blk=:\AMisc_Math_Symbols_A\z:}', "");;
    Expect(1, 10223, '\p{Blk=miscmathsymbolsa}', "");
    Expect(0, 10223, '\p{^Blk=miscmathsymbolsa}', "");
    Expect(0, 10223, '\P{Blk=miscmathsymbolsa}', "");
    Expect(1, 10223, '\P{^Blk=miscmathsymbolsa}', "");
    Expect(0, 10224, '\p{Blk=miscmathsymbolsa}', "");
    Expect(1, 10224, '\p{^Blk=miscmathsymbolsa}', "");
    Expect(1, 10224, '\P{Blk=miscmathsymbolsa}', "");
    Expect(0, 10224, '\P{^Blk=miscmathsymbolsa}', "");
    Expect(1, 10223, '\p{Blk=:\Amiscmathsymbolsa\z:}', "");;
    Expect(0, 10224, '\p{Blk=:\Amiscmathsymbolsa\z:}', "");;
    Expect(1, 10223, '\p{Blk=	misc_math_SYMBOLS_A}', "");
    Expect(0, 10223, '\p{^Blk=	misc_math_SYMBOLS_A}', "");
    Expect(0, 10223, '\P{Blk=	misc_math_SYMBOLS_A}', "");
    Expect(1, 10223, '\P{^Blk=	misc_math_SYMBOLS_A}', "");
    Expect(0, 10224, '\p{Blk=	misc_math_SYMBOLS_A}', "");
    Expect(1, 10224, '\p{^Blk=	misc_math_SYMBOLS_A}', "");
    Expect(1, 10224, '\P{Blk=	misc_math_SYMBOLS_A}', "");
    Expect(0, 10224, '\P{^Blk=	misc_math_SYMBOLS_A}', "");
    Error('\p{Is_Block=-	Miscellaneous_Mathematical_Symbols_A:=}');
    Error('\P{Is_Block=-	Miscellaneous_Mathematical_Symbols_A:=}');
    Expect(1, 10223, '\p{Is_Block=miscellaneousmathematicalsymbolsa}', "");
    Expect(0, 10223, '\p{^Is_Block=miscellaneousmathematicalsymbolsa}', "");
    Expect(0, 10223, '\P{Is_Block=miscellaneousmathematicalsymbolsa}', "");
    Expect(1, 10223, '\P{^Is_Block=miscellaneousmathematicalsymbolsa}', "");
    Expect(0, 10224, '\p{Is_Block=miscellaneousmathematicalsymbolsa}', "");
    Expect(1, 10224, '\p{^Is_Block=miscellaneousmathematicalsymbolsa}', "");
    Expect(1, 10224, '\P{Is_Block=miscellaneousmathematicalsymbolsa}', "");
    Expect(0, 10224, '\P{^Is_Block=miscellaneousmathematicalsymbolsa}', "");
    Expect(1, 10223, '\p{Is_Block= Miscellaneous_mathematical_SYMBOLS_a}', "");
    Expect(0, 10223, '\p{^Is_Block= Miscellaneous_mathematical_SYMBOLS_a}', "");
    Expect(0, 10223, '\P{Is_Block= Miscellaneous_mathematical_SYMBOLS_a}', "");
    Expect(1, 10223, '\P{^Is_Block= Miscellaneous_mathematical_SYMBOLS_a}', "");
    Expect(0, 10224, '\p{Is_Block= Miscellaneous_mathematical_SYMBOLS_a}', "");
    Expect(1, 10224, '\p{^Is_Block= Miscellaneous_mathematical_SYMBOLS_a}', "");
    Expect(1, 10224, '\P{Is_Block= Miscellaneous_mathematical_SYMBOLS_a}', "");
    Expect(0, 10224, '\P{^Is_Block= Miscellaneous_mathematical_SYMBOLS_a}', "");
    Error('\p{Is_Blk=/a/		misc_Math_SYMBOLS_A}');
    Error('\P{Is_Blk=/a/		misc_Math_SYMBOLS_A}');
    Expect(1, 10223, '\p{Is_Blk=miscmathsymbolsa}', "");
    Expect(0, 10223, '\p{^Is_Blk=miscmathsymbolsa}', "");
    Expect(0, 10223, '\P{Is_Blk=miscmathsymbolsa}', "");
    Expect(1, 10223, '\P{^Is_Blk=miscmathsymbolsa}', "");
    Expect(0, 10224, '\p{Is_Blk=miscmathsymbolsa}', "");
    Expect(1, 10224, '\p{^Is_Blk=miscmathsymbolsa}', "");
    Expect(1, 10224, '\P{Is_Blk=miscmathsymbolsa}', "");
    Expect(0, 10224, '\P{^Is_Blk=miscmathsymbolsa}', "");
    Expect(1, 10223, '\p{Is_Blk=		Misc_math_symbols_A}', "");
    Expect(0, 10223, '\p{^Is_Blk=		Misc_math_symbols_A}', "");
    Expect(0, 10223, '\P{Is_Blk=		Misc_math_symbols_A}', "");
    Expect(1, 10223, '\P{^Is_Blk=		Misc_math_symbols_A}', "");
    Expect(0, 10224, '\p{Is_Blk=		Misc_math_symbols_A}', "");
    Expect(1, 10224, '\p{^Is_Blk=		Misc_math_symbols_A}', "");
    Expect(1, 10224, '\P{Is_Blk=		Misc_math_symbols_A}', "");
    Expect(0, 10224, '\P{^Is_Blk=		Misc_math_symbols_A}', "");
    Error('\p{Block=		Miscellaneous_MATHEMATICAL_symbols_B/a/}');
    Error('\P{Block=		Miscellaneous_MATHEMATICAL_symbols_B/a/}');
    Expect(1, 10751, '\p{Block=:\AMiscellaneous_Mathematical_Symbols_B\z:}', "");;
    Expect(0, 10752, '\p{Block=:\AMiscellaneous_Mathematical_Symbols_B\z:}', "");;
    Expect(1, 10751, '\p{Block:   miscellaneousmathematicalsymbolsb}', "");
    Expect(0, 10751, '\p{^Block:   miscellaneousmathematicalsymbolsb}', "");
    Expect(0, 10751, '\P{Block:   miscellaneousmathematicalsymbolsb}', "");
    Expect(1, 10751, '\P{^Block:   miscellaneousmathematicalsymbolsb}', "");
    Expect(0, 10752, '\p{Block:   miscellaneousmathematicalsymbolsb}', "");
    Expect(1, 10752, '\p{^Block:   miscellaneousmathematicalsymbolsb}', "");
    Expect(1, 10752, '\P{Block:   miscellaneousmathematicalsymbolsb}', "");
    Expect(0, 10752, '\P{^Block:   miscellaneousmathematicalsymbolsb}', "");
    Expect(1, 10751, '\p{Block=:\Amiscellaneousmathematicalsymbolsb\z:}', "");;
    Expect(0, 10752, '\p{Block=:\Amiscellaneousmathematicalsymbolsb\z:}', "");;
    Expect(1, 10751, '\p{Block:   -Miscellaneous_Mathematical_Symbols_B}', "");
    Expect(0, 10751, '\p{^Block:   -Miscellaneous_Mathematical_Symbols_B}', "");
    Expect(0, 10751, '\P{Block:   -Miscellaneous_Mathematical_Symbols_B}', "");
    Expect(1, 10751, '\P{^Block:   -Miscellaneous_Mathematical_Symbols_B}', "");
    Expect(0, 10752, '\p{Block:   -Miscellaneous_Mathematical_Symbols_B}', "");
    Expect(1, 10752, '\p{^Block:   -Miscellaneous_Mathematical_Symbols_B}', "");
    Expect(1, 10752, '\P{Block:   -Miscellaneous_Mathematical_Symbols_B}', "");
    Expect(0, 10752, '\P{^Block:   -Miscellaneous_Mathematical_Symbols_B}', "");
    Error('\p{Blk=	/a/misc_Math_Symbols_B}');
    Error('\P{Blk=	/a/misc_Math_Symbols_B}');
    Expect(1, 10751, '\p{Blk=:\AMisc_Math_Symbols_B\z:}', "");;
    Expect(0, 10752, '\p{Blk=:\AMisc_Math_Symbols_B\z:}', "");;
    Expect(1, 10751, '\p{Blk=miscmathsymbolsb}', "");
    Expect(0, 10751, '\p{^Blk=miscmathsymbolsb}', "");
    Expect(0, 10751, '\P{Blk=miscmathsymbolsb}', "");
    Expect(1, 10751, '\P{^Blk=miscmathsymbolsb}', "");
    Expect(0, 10752, '\p{Blk=miscmathsymbolsb}', "");
    Expect(1, 10752, '\p{^Blk=miscmathsymbolsb}', "");
    Expect(1, 10752, '\P{Blk=miscmathsymbolsb}', "");
    Expect(0, 10752, '\P{^Blk=miscmathsymbolsb}', "");
    Expect(1, 10751, '\p{Blk=:\Amiscmathsymbolsb\z:}', "");;
    Expect(0, 10752, '\p{Blk=:\Amiscmathsymbolsb\z:}', "");;
    Expect(1, 10751, '\p{Blk=_	misc_math_symbols_B}', "");
    Expect(0, 10751, '\p{^Blk=_	misc_math_symbols_B}', "");
    Expect(0, 10751, '\P{Blk=_	misc_math_symbols_B}', "");
    Expect(1, 10751, '\P{^Blk=_	misc_math_symbols_B}', "");
    Expect(0, 10752, '\p{Blk=_	misc_math_symbols_B}', "");
    Expect(1, 10752, '\p{^Blk=_	misc_math_symbols_B}', "");
    Expect(1, 10752, '\P{Blk=_	misc_math_symbols_B}', "");
    Expect(0, 10752, '\P{^Blk=_	misc_math_symbols_B}', "");
    Error('\p{Is_Block=miscellaneous_Mathematical_symbols_B:=}');
    Error('\P{Is_Block=miscellaneous_Mathematical_symbols_B:=}');
    Expect(1, 10751, '\p{Is_Block=miscellaneousmathematicalsymbolsb}', "");
    Expect(0, 10751, '\p{^Is_Block=miscellaneousmathematicalsymbolsb}', "");
    Expect(0, 10751, '\P{Is_Block=miscellaneousmathematicalsymbolsb}', "");
    Expect(1, 10751, '\P{^Is_Block=miscellaneousmathematicalsymbolsb}', "");
    Expect(0, 10752, '\p{Is_Block=miscellaneousmathematicalsymbolsb}', "");
    Expect(1, 10752, '\p{^Is_Block=miscellaneousmathematicalsymbolsb}', "");
    Expect(1, 10752, '\P{Is_Block=miscellaneousmathematicalsymbolsb}', "");
    Expect(0, 10752, '\P{^Is_Block=miscellaneousmathematicalsymbolsb}', "");
    Expect(1, 10751, '\p{Is_Block=	-Miscellaneous_mathematical_symbols_b}', "");
    Expect(0, 10751, '\p{^Is_Block=	-Miscellaneous_mathematical_symbols_b}', "");
    Expect(0, 10751, '\P{Is_Block=	-Miscellaneous_mathematical_symbols_b}', "");
    Expect(1, 10751, '\P{^Is_Block=	-Miscellaneous_mathematical_symbols_b}', "");
    Expect(0, 10752, '\p{Is_Block=	-Miscellaneous_mathematical_symbols_b}', "");
    Expect(1, 10752, '\p{^Is_Block=	-Miscellaneous_mathematical_symbols_b}', "");
    Expect(1, 10752, '\P{Is_Block=	-Miscellaneous_mathematical_symbols_b}', "");
    Expect(0, 10752, '\P{^Is_Block=	-Miscellaneous_mathematical_symbols_b}', "");
    Error('\p{Is_Blk=:=misc_MATH_Symbols_B}');
    Error('\P{Is_Blk=:=misc_MATH_Symbols_B}');
    Expect(1, 10751, '\p{Is_Blk=miscmathsymbolsb}', "");
    Expect(0, 10751, '\p{^Is_Blk=miscmathsymbolsb}', "");
    Expect(0, 10751, '\P{Is_Blk=miscmathsymbolsb}', "");
    Expect(1, 10751, '\P{^Is_Blk=miscmathsymbolsb}', "");
    Expect(0, 10752, '\p{Is_Blk=miscmathsymbolsb}', "");
    Expect(1, 10752, '\p{^Is_Blk=miscmathsymbolsb}', "");
    Expect(1, 10752, '\P{Is_Blk=miscmathsymbolsb}', "");
    Expect(0, 10752, '\P{^Is_Blk=miscmathsymbolsb}', "");
    Expect(1, 10751, '\p{Is_Blk=-_MISC_Math_Symbols_B}', "");
    Expect(0, 10751, '\p{^Is_Blk=-_MISC_Math_Symbols_B}', "");
    Expect(0, 10751, '\P{Is_Blk=-_MISC_Math_Symbols_B}', "");
    Expect(1, 10751, '\P{^Is_Blk=-_MISC_Math_Symbols_B}', "");
    Expect(0, 10752, '\p{Is_Blk=-_MISC_Math_Symbols_B}', "");
    Expect(1, 10752, '\p{^Is_Blk=-_MISC_Math_Symbols_B}', "");
    Expect(1, 10752, '\P{Is_Blk=-_MISC_Math_Symbols_B}', "");
    Expect(0, 10752, '\P{^Is_Blk=-_MISC_Math_Symbols_B}', "");
    Error('\p{Block=/a/Miscellaneous_Symbols_And_Pictographs}');
    Error('\P{Block=/a/Miscellaneous_Symbols_And_Pictographs}');
    Expect(1, 128511, '\p{Block=:\AMiscellaneous_Symbols_And_Pictographs\z:}', "");;
    Expect(0, 128512, '\p{Block=:\AMiscellaneous_Symbols_And_Pictographs\z:}', "");;
    Expect(1, 128511, '\p{Block=miscellaneoussymbolsandpictographs}', "");
    Expect(0, 128511, '\p{^Block=miscellaneoussymbolsandpictographs}', "");
    Expect(0, 128511, '\P{Block=miscellaneoussymbolsandpictographs}', "");
    Expect(1, 128511, '\P{^Block=miscellaneoussymbolsandpictographs}', "");
    Expect(0, 128512, '\p{Block=miscellaneoussymbolsandpictographs}', "");
    Expect(1, 128512, '\p{^Block=miscellaneoussymbolsandpictographs}', "");
    Expect(1, 128512, '\P{Block=miscellaneoussymbolsandpictographs}', "");
    Expect(0, 128512, '\P{^Block=miscellaneoussymbolsandpictographs}', "");
    Expect(1, 128511, '\p{Block=:\Amiscellaneoussymbolsandpictographs\z:}', "");;
    Expect(0, 128512, '\p{Block=:\Amiscellaneoussymbolsandpictographs\z:}', "");;
    Expect(1, 128511, '\p{Block=-Miscellaneous_Symbols_AND_PICTOGRAPHS}', "");
    Expect(0, 128511, '\p{^Block=-Miscellaneous_Symbols_AND_PICTOGRAPHS}', "");
    Expect(0, 128511, '\P{Block=-Miscellaneous_Symbols_AND_PICTOGRAPHS}', "");
    Expect(1, 128511, '\P{^Block=-Miscellaneous_Symbols_AND_PICTOGRAPHS}', "");
    Expect(0, 128512, '\p{Block=-Miscellaneous_Symbols_AND_PICTOGRAPHS}', "");
    Expect(1, 128512, '\p{^Block=-Miscellaneous_Symbols_AND_PICTOGRAPHS}', "");
    Expect(1, 128512, '\P{Block=-Miscellaneous_Symbols_AND_PICTOGRAPHS}', "");
    Expect(0, 128512, '\P{^Block=-Miscellaneous_Symbols_AND_PICTOGRAPHS}', "");
    Error('\p{Blk:   /a/	MISC_PICTOGRAPHS}');
    Error('\P{Blk:   /a/	MISC_PICTOGRAPHS}');
    Expect(1, 128511, '\p{Blk=:\AMisc_Pictographs\z:}', "");;
    Expect(0, 128512, '\p{Blk=:\AMisc_Pictographs\z:}', "");;
    Expect(1, 128511, '\p{Blk=miscpictographs}', "");
    Expect(0, 128511, '\p{^Blk=miscpictographs}', "");
    Expect(0, 128511, '\P{Blk=miscpictographs}', "");
    Expect(1, 128511, '\P{^Blk=miscpictographs}', "");
    Expect(0, 128512, '\p{Blk=miscpictographs}', "");
    Expect(1, 128512, '\p{^Blk=miscpictographs}', "");
    Expect(1, 128512, '\P{Blk=miscpictographs}', "");
    Expect(0, 128512, '\P{^Blk=miscpictographs}', "");
    Expect(1, 128511, '\p{Blk=:\Amiscpictographs\z:}', "");;
    Expect(0, 128512, '\p{Blk=:\Amiscpictographs\z:}', "");;
    Expect(1, 128511, '\p{Blk=_	misc_pictographs}', "");
    Expect(0, 128511, '\p{^Blk=_	misc_pictographs}', "");
    Expect(0, 128511, '\P{Blk=_	misc_pictographs}', "");
    Expect(1, 128511, '\P{^Blk=_	misc_pictographs}', "");
    Expect(0, 128512, '\p{Blk=_	misc_pictographs}', "");
    Expect(1, 128512, '\p{^Blk=_	misc_pictographs}', "");
    Expect(1, 128512, '\P{Blk=_	misc_pictographs}', "");
    Expect(0, 128512, '\P{^Blk=_	misc_pictographs}', "");
    Error('\p{Is_Block=:=	 Miscellaneous_symbols_And_Pictographs}');
    Error('\P{Is_Block=:=	 Miscellaneous_symbols_And_Pictographs}');
    Expect(1, 128511, '\p{Is_Block=miscellaneoussymbolsandpictographs}', "");
    Expect(0, 128511, '\p{^Is_Block=miscellaneoussymbolsandpictographs}', "");
    Expect(0, 128511, '\P{Is_Block=miscellaneoussymbolsandpictographs}', "");
    Expect(1, 128511, '\P{^Is_Block=miscellaneoussymbolsandpictographs}', "");
    Expect(0, 128512, '\p{Is_Block=miscellaneoussymbolsandpictographs}', "");
    Expect(1, 128512, '\p{^Is_Block=miscellaneoussymbolsandpictographs}', "");
    Expect(1, 128512, '\P{Is_Block=miscellaneoussymbolsandpictographs}', "");
    Expect(0, 128512, '\P{^Is_Block=miscellaneoussymbolsandpictographs}', "");
    Expect(1, 128511, '\p{Is_Block=_ Miscellaneous_Symbols_And_Pictographs}', "");
    Expect(0, 128511, '\p{^Is_Block=_ Miscellaneous_Symbols_And_Pictographs}', "");
    Expect(0, 128511, '\P{Is_Block=_ Miscellaneous_Symbols_And_Pictographs}', "");
    Expect(1, 128511, '\P{^Is_Block=_ Miscellaneous_Symbols_And_Pictographs}', "");
    Expect(0, 128512, '\p{Is_Block=_ Miscellaneous_Symbols_And_Pictographs}', "");
    Expect(1, 128512, '\p{^Is_Block=_ Miscellaneous_Symbols_And_Pictographs}', "");
    Expect(1, 128512, '\P{Is_Block=_ Miscellaneous_Symbols_And_Pictographs}', "");
    Expect(0, 128512, '\P{^Is_Block=_ Miscellaneous_Symbols_And_Pictographs}', "");
    Error('\p{Is_Blk: __Misc_Pictographs/a/}');
    Error('\P{Is_Blk: __Misc_Pictographs/a/}');
    Expect(1, 128511, '\p{Is_Blk:	miscpictographs}', "");
    Expect(0, 128511, '\p{^Is_Blk:	miscpictographs}', "");
    Expect(0, 128511, '\P{Is_Blk:	miscpictographs}', "");
    Expect(1, 128511, '\P{^Is_Blk:	miscpictographs}', "");
    Expect(0, 128512, '\p{Is_Blk:	miscpictographs}', "");
    Expect(1, 128512, '\p{^Is_Blk:	miscpictographs}', "");
    Expect(1, 128512, '\P{Is_Blk:	miscpictographs}', "");
    Expect(0, 128512, '\P{^Is_Blk:	miscpictographs}', "");
    Expect(1, 128511, '\p{Is_Blk=__misc_Pictographs}', "");
    Expect(0, 128511, '\p{^Is_Blk=__misc_Pictographs}', "");
    Expect(0, 128511, '\P{Is_Blk=__misc_Pictographs}', "");
    Expect(1, 128511, '\P{^Is_Blk=__misc_Pictographs}', "");
    Expect(0, 128512, '\p{Is_Blk=__misc_Pictographs}', "");
    Expect(1, 128512, '\p{^Is_Blk=__misc_Pictographs}', "");
    Expect(1, 128512, '\P{Is_Blk=__misc_Pictographs}', "");
    Expect(0, 128512, '\P{^Is_Blk=__misc_Pictographs}', "");
    Error('\p{Block: /a/-	MISCELLANEOUS_Symbols}');
    Error('\P{Block: /a/-	MISCELLANEOUS_Symbols}');
    Expect(1, 9983, '\p{Block=:\AMiscellaneous_Symbols\z:}', "");;
    Expect(0, 9984, '\p{Block=:\AMiscellaneous_Symbols\z:}', "");;
    Expect(1, 9983, '\p{Block=miscellaneoussymbols}', "");
    Expect(0, 9983, '\p{^Block=miscellaneoussymbols}', "");
    Expect(0, 9983, '\P{Block=miscellaneoussymbols}', "");
    Expect(1, 9983, '\P{^Block=miscellaneoussymbols}', "");
    Expect(0, 9984, '\p{Block=miscellaneoussymbols}', "");
    Expect(1, 9984, '\p{^Block=miscellaneoussymbols}', "");
    Expect(1, 9984, '\P{Block=miscellaneoussymbols}', "");
    Expect(0, 9984, '\P{^Block=miscellaneoussymbols}', "");
    Expect(1, 9983, '\p{Block=:\Amiscellaneoussymbols\z:}', "");;
    Expect(0, 9984, '\p{Block=:\Amiscellaneoussymbols\z:}', "");;
    Expect(1, 9983, '\p{Block=_Miscellaneous_Symbols}', "");
    Expect(0, 9983, '\p{^Block=_Miscellaneous_Symbols}', "");
    Expect(0, 9983, '\P{Block=_Miscellaneous_Symbols}', "");
    Expect(1, 9983, '\P{^Block=_Miscellaneous_Symbols}', "");
    Expect(0, 9984, '\p{Block=_Miscellaneous_Symbols}', "");
    Expect(1, 9984, '\p{^Block=_Miscellaneous_Symbols}', "");
    Expect(1, 9984, '\P{Block=_Miscellaneous_Symbols}', "");
    Expect(0, 9984, '\P{^Block=_Miscellaneous_Symbols}', "");
    Error('\p{Blk:_/a/MISC_Symbols}');
    Error('\P{Blk:_/a/MISC_Symbols}');
    Expect(1, 9983, '\p{Blk=:\AMisc_Symbols\z:}', "");;
    Expect(0, 9984, '\p{Blk=:\AMisc_Symbols\z:}', "");;
    Expect(1, 9983, '\p{Blk=miscsymbols}', "");
    Expect(0, 9983, '\p{^Blk=miscsymbols}', "");
    Expect(0, 9983, '\P{Blk=miscsymbols}', "");
    Expect(1, 9983, '\P{^Blk=miscsymbols}', "");
    Expect(0, 9984, '\p{Blk=miscsymbols}', "");
    Expect(1, 9984, '\p{^Blk=miscsymbols}', "");
    Expect(1, 9984, '\P{Blk=miscsymbols}', "");
    Expect(0, 9984, '\P{^Blk=miscsymbols}', "");
    Expect(1, 9983, '\p{Blk=:\Amiscsymbols\z:}', "");;
    Expect(0, 9984, '\p{Blk=:\Amiscsymbols\z:}', "");;
    Expect(1, 9983, '\p{Blk=- misc_Symbols}', "");
    Expect(0, 9983, '\p{^Blk=- misc_Symbols}', "");
    Expect(0, 9983, '\P{Blk=- misc_Symbols}', "");
    Expect(1, 9983, '\P{^Blk=- misc_Symbols}', "");
    Expect(0, 9984, '\p{Blk=- misc_Symbols}', "");
    Expect(1, 9984, '\p{^Blk=- misc_Symbols}', "");
    Expect(1, 9984, '\P{Blk=- misc_Symbols}', "");
    Expect(0, 9984, '\P{^Blk=- misc_Symbols}', "");
    Error('\p{Is_Block:		/a/Miscellaneous_Symbols}');
    Error('\P{Is_Block:		/a/Miscellaneous_Symbols}');
    Expect(1, 9983, '\p{Is_Block: miscellaneoussymbols}', "");
    Expect(0, 9983, '\p{^Is_Block: miscellaneoussymbols}', "");
    Expect(0, 9983, '\P{Is_Block: miscellaneoussymbols}', "");
    Expect(1, 9983, '\P{^Is_Block: miscellaneoussymbols}', "");
    Expect(0, 9984, '\p{Is_Block: miscellaneoussymbols}', "");
    Expect(1, 9984, '\p{^Is_Block: miscellaneoussymbols}', "");
    Expect(1, 9984, '\P{Is_Block: miscellaneoussymbols}', "");
    Expect(0, 9984, '\P{^Is_Block: miscellaneoussymbols}', "");
    Expect(1, 9983, '\p{Is_Block=_miscellaneous_Symbols}', "");
    Expect(0, 9983, '\p{^Is_Block=_miscellaneous_Symbols}', "");
    Expect(0, 9983, '\P{Is_Block=_miscellaneous_Symbols}', "");
    Expect(1, 9983, '\P{^Is_Block=_miscellaneous_Symbols}', "");
    Expect(0, 9984, '\p{Is_Block=_miscellaneous_Symbols}', "");
    Expect(1, 9984, '\p{^Is_Block=_miscellaneous_Symbols}', "");
    Expect(1, 9984, '\P{Is_Block=_miscellaneous_Symbols}', "");
    Expect(0, 9984, '\P{^Is_Block=_miscellaneous_Symbols}', "");
    Error('\p{Is_Blk:	-Misc_symbols:=}');
    Error('\P{Is_Blk:	-Misc_symbols:=}');
    Expect(1, 9983, '\p{Is_Blk=miscsymbols}', "");
    Expect(0, 9983, '\p{^Is_Blk=miscsymbols}', "");
    Expect(0, 9983, '\P{Is_Blk=miscsymbols}', "");
    Expect(1, 9983, '\P{^Is_Blk=miscsymbols}', "");
    Expect(0, 9984, '\p{Is_Blk=miscsymbols}', "");
    Expect(1, 9984, '\p{^Is_Blk=miscsymbols}', "");
    Expect(1, 9984, '\P{Is_Blk=miscsymbols}', "");
    Expect(0, 9984, '\P{^Is_Blk=miscsymbols}', "");
    Expect(1, 9983, '\p{Is_Blk=-	MISC_SYMBOLS}', "");
    Expect(0, 9983, '\p{^Is_Blk=-	MISC_SYMBOLS}', "");
    Expect(0, 9983, '\P{Is_Blk=-	MISC_SYMBOLS}', "");
    Expect(1, 9983, '\P{^Is_Blk=-	MISC_SYMBOLS}', "");
    Expect(0, 9984, '\p{Is_Blk=-	MISC_SYMBOLS}', "");
    Expect(1, 9984, '\p{^Is_Blk=-	MISC_SYMBOLS}', "");
    Expect(1, 9984, '\P{Is_Blk=-	MISC_SYMBOLS}', "");
    Expect(0, 9984, '\P{^Is_Blk=-	MISC_SYMBOLS}', "");
    Error('\p{Block=:=- miscellaneous_technical}');
    Error('\P{Block=:=- miscellaneous_technical}');
    Expect(1, 9215, '\p{Block=:\AMiscellaneous_Technical\z:}', "");;
    Expect(0, 9216, '\p{Block=:\AMiscellaneous_Technical\z:}', "");;
    Expect(1, 9215, '\p{Block=miscellaneoustechnical}', "");
    Expect(0, 9215, '\p{^Block=miscellaneoustechnical}', "");
    Expect(0, 9215, '\P{Block=miscellaneoustechnical}', "");
    Expect(1, 9215, '\P{^Block=miscellaneoustechnical}', "");
    Expect(0, 9216, '\p{Block=miscellaneoustechnical}', "");
    Expect(1, 9216, '\p{^Block=miscellaneoustechnical}', "");
    Expect(1, 9216, '\P{Block=miscellaneoustechnical}', "");
    Expect(0, 9216, '\P{^Block=miscellaneoustechnical}', "");
    Expect(1, 9215, '\p{Block=:\Amiscellaneoustechnical\z:}', "");;
    Expect(0, 9216, '\p{Block=:\Amiscellaneoustechnical\z:}', "");;
    Expect(1, 9215, '\p{Block=miscellaneous_TECHNICAL}', "");
    Expect(0, 9215, '\p{^Block=miscellaneous_TECHNICAL}', "");
    Expect(0, 9215, '\P{Block=miscellaneous_TECHNICAL}', "");
    Expect(1, 9215, '\P{^Block=miscellaneous_TECHNICAL}', "");
    Expect(0, 9216, '\p{Block=miscellaneous_TECHNICAL}', "");
    Expect(1, 9216, '\p{^Block=miscellaneous_TECHNICAL}', "");
    Expect(1, 9216, '\P{Block=miscellaneous_TECHNICAL}', "");
    Expect(0, 9216, '\P{^Block=miscellaneous_TECHNICAL}', "");
    Error('\p{Blk: /a/Misc_Technical}');
    Error('\P{Blk: /a/Misc_Technical}');
    Expect(1, 9215, '\p{Blk=:\AMisc_Technical\z:}', "");;
    Expect(0, 9216, '\p{Blk=:\AMisc_Technical\z:}', "");;
    Expect(1, 9215, '\p{Blk=misctechnical}', "");
    Expect(0, 9215, '\p{^Blk=misctechnical}', "");
    Expect(0, 9215, '\P{Blk=misctechnical}', "");
    Expect(1, 9215, '\P{^Blk=misctechnical}', "");
    Expect(0, 9216, '\p{Blk=misctechnical}', "");
    Expect(1, 9216, '\p{^Blk=misctechnical}', "");
    Expect(1, 9216, '\P{Blk=misctechnical}', "");
    Expect(0, 9216, '\P{^Blk=misctechnical}', "");
    Expect(1, 9215, '\p{Blk=:\Amisctechnical\z:}', "");;
    Expect(0, 9216, '\p{Blk=:\Amisctechnical\z:}', "");;
    Expect(1, 9215, '\p{Blk:  -MISC_technical}', "");
    Expect(0, 9215, '\p{^Blk:  -MISC_technical}', "");
    Expect(0, 9215, '\P{Blk:  -MISC_technical}', "");
    Expect(1, 9215, '\P{^Blk:  -MISC_technical}', "");
    Expect(0, 9216, '\p{Blk:  -MISC_technical}', "");
    Expect(1, 9216, '\p{^Blk:  -MISC_technical}', "");
    Expect(1, 9216, '\P{Blk:  -MISC_technical}', "");
    Expect(0, 9216, '\P{^Blk:  -MISC_technical}', "");
    Error('\p{Is_Block=-miscellaneous_technical:=}');
    Error('\P{Is_Block=-miscellaneous_technical:=}');
    Expect(1, 9215, '\p{Is_Block=miscellaneoustechnical}', "");
    Expect(0, 9215, '\p{^Is_Block=miscellaneoustechnical}', "");
    Expect(0, 9215, '\P{Is_Block=miscellaneoustechnical}', "");
    Expect(1, 9215, '\P{^Is_Block=miscellaneoustechnical}', "");
    Expect(0, 9216, '\p{Is_Block=miscellaneoustechnical}', "");
    Expect(1, 9216, '\p{^Is_Block=miscellaneoustechnical}', "");
    Expect(1, 9216, '\P{Is_Block=miscellaneoustechnical}', "");
    Expect(0, 9216, '\P{^Is_Block=miscellaneoustechnical}', "");
    Expect(1, 9215, '\p{Is_Block=-miscellaneous_TECHNICAL}', "");
    Expect(0, 9215, '\p{^Is_Block=-miscellaneous_TECHNICAL}', "");
    Expect(0, 9215, '\P{Is_Block=-miscellaneous_TECHNICAL}', "");
    Expect(1, 9215, '\P{^Is_Block=-miscellaneous_TECHNICAL}', "");
    Expect(0, 9216, '\p{Is_Block=-miscellaneous_TECHNICAL}', "");
    Expect(1, 9216, '\p{^Is_Block=-miscellaneous_TECHNICAL}', "");
    Expect(1, 9216, '\P{Is_Block=-miscellaneous_TECHNICAL}', "");
    Expect(0, 9216, '\P{^Is_Block=-miscellaneous_TECHNICAL}', "");
    Error('\p{Is_Blk=_:=MISC_Technical}');
    Error('\P{Is_Blk=_:=MISC_Technical}');
    Expect(1, 9215, '\p{Is_Blk=misctechnical}', "");
    Expect(0, 9215, '\p{^Is_Blk=misctechnical}', "");
    Expect(0, 9215, '\P{Is_Blk=misctechnical}', "");
    Expect(1, 9215, '\P{^Is_Blk=misctechnical}', "");
    Expect(0, 9216, '\p{Is_Blk=misctechnical}', "");
    Expect(1, 9216, '\p{^Is_Blk=misctechnical}', "");
    Expect(1, 9216, '\P{Is_Blk=misctechnical}', "");
    Expect(0, 9216, '\P{^Is_Blk=misctechnical}', "");
    Expect(1, 9215, '\p{Is_Blk= 	Misc_TECHNICAL}', "");
    Expect(0, 9215, '\p{^Is_Blk= 	Misc_TECHNICAL}', "");
    Expect(0, 9215, '\P{Is_Blk= 	Misc_TECHNICAL}', "");
    Expect(1, 9215, '\P{^Is_Blk= 	Misc_TECHNICAL}', "");
    Expect(0, 9216, '\p{Is_Blk= 	Misc_TECHNICAL}', "");
    Expect(1, 9216, '\p{^Is_Blk= 	Misc_TECHNICAL}', "");
    Expect(1, 9216, '\P{Is_Blk= 	Misc_TECHNICAL}', "");
    Expect(0, 9216, '\P{^Is_Blk= 	Misc_TECHNICAL}', "");
    Error('\p{Block: _ Modi/a/}');
    Error('\P{Block: _ Modi/a/}');
    Expect(1, 71263, '\p{Block=:\AModi\z:}', "");;
    Expect(0, 71264, '\p{Block=:\AModi\z:}', "");;
    Expect(1, 71263, '\p{Block=modi}', "");
    Expect(0, 71263, '\p{^Block=modi}', "");
    Expect(0, 71263, '\P{Block=modi}', "");
    Expect(1, 71263, '\P{^Block=modi}', "");
    Expect(0, 71264, '\p{Block=modi}', "");
    Expect(1, 71264, '\p{^Block=modi}', "");
    Expect(1, 71264, '\P{Block=modi}', "");
    Expect(0, 71264, '\P{^Block=modi}', "");
    Expect(1, 71263, '\p{Block=:\Amodi\z:}', "");;
    Expect(0, 71264, '\p{Block=:\Amodi\z:}', "");;
    Expect(1, 71263, '\p{Block=		MODI}', "");
    Expect(0, 71263, '\p{^Block=		MODI}', "");
    Expect(0, 71263, '\P{Block=		MODI}', "");
    Expect(1, 71263, '\P{^Block=		MODI}', "");
    Expect(0, 71264, '\p{Block=		MODI}', "");
    Expect(1, 71264, '\p{^Block=		MODI}', "");
    Expect(1, 71264, '\P{Block=		MODI}', "");
    Expect(0, 71264, '\P{^Block=		MODI}', "");
    Error('\p{Blk= Modi/a/}');
    Error('\P{Blk= Modi/a/}');
    Expect(1, 71263, '\p{Blk=:\AModi\z:}', "");;
    Expect(0, 71264, '\p{Blk=:\AModi\z:}', "");;
    Expect(1, 71263, '\p{Blk=modi}', "");
    Expect(0, 71263, '\p{^Blk=modi}', "");
    Expect(0, 71263, '\P{Blk=modi}', "");
    Expect(1, 71263, '\P{^Blk=modi}', "");
    Expect(0, 71264, '\p{Blk=modi}', "");
    Expect(1, 71264, '\p{^Blk=modi}', "");
    Expect(1, 71264, '\P{Blk=modi}', "");
    Expect(0, 71264, '\P{^Blk=modi}', "");
    Expect(1, 71263, '\p{Blk=:\Amodi\z:}', "");;
    Expect(0, 71264, '\p{Blk=:\Amodi\z:}', "");;
    Expect(1, 71263, '\p{Blk= Modi}', "");
    Expect(0, 71263, '\p{^Blk= Modi}', "");
    Expect(0, 71263, '\P{Blk= Modi}', "");
    Expect(1, 71263, '\P{^Blk= Modi}', "");
    Expect(0, 71264, '\p{Blk= Modi}', "");
    Expect(1, 71264, '\p{^Blk= Modi}', "");
    Expect(1, 71264, '\P{Blk= Modi}', "");
    Expect(0, 71264, '\P{^Blk= Modi}', "");
    Error('\p{Is_Block=	/a/Modi}');
    Error('\P{Is_Block=	/a/Modi}');
    Expect(1, 71263, '\p{Is_Block=modi}', "");
    Expect(0, 71263, '\p{^Is_Block=modi}', "");
    Expect(0, 71263, '\P{Is_Block=modi}', "");
    Expect(1, 71263, '\P{^Is_Block=modi}', "");
    Expect(0, 71264, '\p{Is_Block=modi}', "");
    Expect(1, 71264, '\p{^Is_Block=modi}', "");
    Expect(1, 71264, '\P{Is_Block=modi}', "");
    Expect(0, 71264, '\P{^Is_Block=modi}', "");
    Expect(1, 71263, '\p{Is_Block=		Modi}', "");
    Expect(0, 71263, '\p{^Is_Block=		Modi}', "");
    Expect(0, 71263, '\P{Is_Block=		Modi}', "");
    Expect(1, 71263, '\P{^Is_Block=		Modi}', "");
    Expect(0, 71264, '\p{Is_Block=		Modi}', "");
    Expect(1, 71264, '\p{^Is_Block=		Modi}', "");
    Expect(1, 71264, '\P{Is_Block=		Modi}', "");
    Expect(0, 71264, '\P{^Is_Block=		Modi}', "");
    Error('\p{Is_Blk=:=__Modi}');
    Error('\P{Is_Blk=:=__Modi}');
    Expect(1, 71263, '\p{Is_Blk=modi}', "");
    Expect(0, 71263, '\p{^Is_Blk=modi}', "");
    Expect(0, 71263, '\P{Is_Blk=modi}', "");
    Expect(1, 71263, '\P{^Is_Blk=modi}', "");
    Expect(0, 71264, '\p{Is_Blk=modi}', "");
    Expect(1, 71264, '\p{^Is_Blk=modi}', "");
    Expect(1, 71264, '\P{Is_Blk=modi}', "");
    Expect(0, 71264, '\P{^Is_Blk=modi}', "");
    Expect(1, 71263, '\p{Is_Blk=		Modi}', "");
    Expect(0, 71263, '\p{^Is_Blk=		Modi}', "");
    Expect(0, 71263, '\P{Is_Blk=		Modi}', "");
    Expect(1, 71263, '\P{^Is_Blk=		Modi}', "");
    Expect(0, 71264, '\p{Is_Blk=		Modi}', "");
    Expect(1, 71264, '\p{^Is_Blk=		Modi}', "");
    Expect(1, 71264, '\P{Is_Blk=		Modi}', "");
    Expect(0, 71264, '\P{^Is_Blk=		Modi}', "");
    Error('\p{Block=_:=Spacing_Modifier_letters}');
    Error('\P{Block=_:=Spacing_Modifier_letters}');
    Expect(1, 767, '\p{Block=:\ASpacing_Modifier_Letters\z:}', "");;
    Expect(0, 768, '\p{Block=:\ASpacing_Modifier_Letters\z:}', "");;
    Expect(1, 767, '\p{Block=spacingmodifierletters}', "");
    Expect(0, 767, '\p{^Block=spacingmodifierletters}', "");
    Expect(0, 767, '\P{Block=spacingmodifierletters}', "");
    Expect(1, 767, '\P{^Block=spacingmodifierletters}', "");
    Expect(0, 768, '\p{Block=spacingmodifierletters}', "");
    Expect(1, 768, '\p{^Block=spacingmodifierletters}', "");
    Expect(1, 768, '\P{Block=spacingmodifierletters}', "");
    Expect(0, 768, '\P{^Block=spacingmodifierletters}', "");
    Expect(1, 767, '\p{Block=:\Aspacingmodifierletters\z:}', "");;
    Expect(0, 768, '\p{Block=:\Aspacingmodifierletters\z:}', "");;
    Expect(1, 767, '\p{Block=-Spacing_modifier_Letters}', "");
    Expect(0, 767, '\p{^Block=-Spacing_modifier_Letters}', "");
    Expect(0, 767, '\P{Block=-Spacing_modifier_Letters}', "");
    Expect(1, 767, '\P{^Block=-Spacing_modifier_Letters}', "");
    Expect(0, 768, '\p{Block=-Spacing_modifier_Letters}', "");
    Expect(1, 768, '\p{^Block=-Spacing_modifier_Letters}', "");
    Expect(1, 768, '\P{Block=-Spacing_modifier_Letters}', "");
    Expect(0, 768, '\P{^Block=-Spacing_modifier_Letters}', "");
    Error('\p{Blk=_/a/Modifier_Letters}');
    Error('\P{Blk=_/a/Modifier_Letters}');
    Expect(1, 767, '\p{Blk=:\AModifier_Letters\z:}', "");;
    Expect(0, 768, '\p{Blk=:\AModifier_Letters\z:}', "");;
    Expect(1, 767, '\p{Blk=modifierletters}', "");
    Expect(0, 767, '\p{^Blk=modifierletters}', "");
    Expect(0, 767, '\P{Blk=modifierletters}', "");
    Expect(1, 767, '\P{^Blk=modifierletters}', "");
    Expect(0, 768, '\p{Blk=modifierletters}', "");
    Expect(1, 768, '\p{^Blk=modifierletters}', "");
    Expect(1, 768, '\P{Blk=modifierletters}', "");
    Expect(0, 768, '\P{^Blk=modifierletters}', "");
    Expect(1, 767, '\p{Blk=:\Amodifierletters\z:}', "");;
    Expect(0, 768, '\p{Blk=:\Amodifierletters\z:}', "");;
    Expect(1, 767, '\p{Blk=_ modifier_letters}', "");
    Expect(0, 767, '\p{^Blk=_ modifier_letters}', "");
    Expect(0, 767, '\P{Blk=_ modifier_letters}', "");
    Expect(1, 767, '\P{^Blk=_ modifier_letters}', "");
    Expect(0, 768, '\p{Blk=_ modifier_letters}', "");
    Expect(1, 768, '\p{^Blk=_ modifier_letters}', "");
    Expect(1, 768, '\P{Blk=_ modifier_letters}', "");
    Expect(0, 768, '\P{^Blk=_ modifier_letters}', "");
    Error('\p{Is_Block:  /a/Spacing_Modifier_LETTERS}');
    Error('\P{Is_Block:  /a/Spacing_Modifier_LETTERS}');
    Expect(1, 767, '\p{Is_Block=spacingmodifierletters}', "");
    Expect(0, 767, '\p{^Is_Block=spacingmodifierletters}', "");
    Expect(0, 767, '\P{Is_Block=spacingmodifierletters}', "");
    Expect(1, 767, '\P{^Is_Block=spacingmodifierletters}', "");
    Expect(0, 768, '\p{Is_Block=spacingmodifierletters}', "");
    Expect(1, 768, '\p{^Is_Block=spacingmodifierletters}', "");
    Expect(1, 768, '\P{Is_Block=spacingmodifierletters}', "");
    Expect(0, 768, '\P{^Is_Block=spacingmodifierletters}', "");
    Expect(1, 767, '\p{Is_Block=		spacing_modifier_LETTERS}', "");
    Expect(0, 767, '\p{^Is_Block=		spacing_modifier_LETTERS}', "");
    Expect(0, 767, '\P{Is_Block=		spacing_modifier_LETTERS}', "");
    Expect(1, 767, '\P{^Is_Block=		spacing_modifier_LETTERS}', "");
    Expect(0, 768, '\p{Is_Block=		spacing_modifier_LETTERS}', "");
    Expect(1, 768, '\p{^Is_Block=		spacing_modifier_LETTERS}', "");
    Expect(1, 768, '\P{Is_Block=		spacing_modifier_LETTERS}', "");
    Expect(0, 768, '\P{^Is_Block=		spacing_modifier_LETTERS}', "");
    Error('\p{Is_Blk=	:=modifier_LETTERS}');
    Error('\P{Is_Blk=	:=modifier_LETTERS}');
    Expect(1, 767, '\p{Is_Blk=modifierletters}', "");
    Expect(0, 767, '\p{^Is_Blk=modifierletters}', "");
    Expect(0, 767, '\P{Is_Blk=modifierletters}', "");
    Expect(1, 767, '\P{^Is_Blk=modifierletters}', "");
    Expect(0, 768, '\p{Is_Blk=modifierletters}', "");
    Expect(1, 768, '\p{^Is_Blk=modifierletters}', "");
    Expect(1, 768, '\P{Is_Blk=modifierletters}', "");
    Expect(0, 768, '\P{^Is_Blk=modifierletters}', "");
    Expect(1, 767, '\p{Is_Blk=_modifier_Letters}', "");
    Expect(0, 767, '\p{^Is_Blk=_modifier_Letters}', "");
    Expect(0, 767, '\P{Is_Blk=_modifier_Letters}', "");
    Expect(1, 767, '\P{^Is_Blk=_modifier_Letters}', "");
    Expect(0, 768, '\p{Is_Blk=_modifier_Letters}', "");
    Expect(1, 768, '\p{^Is_Blk=_modifier_Letters}', "");
    Expect(1, 768, '\P{Is_Blk=_modifier_Letters}', "");
    Expect(0, 768, '\P{^Is_Blk=_modifier_Letters}', "");
    Error('\p{Block:/a/ MODIFIER_tone_letters}');
    Error('\P{Block:/a/ MODIFIER_tone_letters}');
    Expect(1, 42783, '\p{Block=:\AModifier_Tone_Letters\z:}', "");;
    Expect(0, 42784, '\p{Block=:\AModifier_Tone_Letters\z:}', "");;
    Expect(1, 42783, '\p{Block=modifiertoneletters}', "");
    Expect(0, 42783, '\p{^Block=modifiertoneletters}', "");
    Expect(0, 42783, '\P{Block=modifiertoneletters}', "");
    Expect(1, 42783, '\P{^Block=modifiertoneletters}', "");
    Expect(0, 42784, '\p{Block=modifiertoneletters}', "");
    Expect(1, 42784, '\p{^Block=modifiertoneletters}', "");
    Expect(1, 42784, '\P{Block=modifiertoneletters}', "");
    Expect(0, 42784, '\P{^Block=modifiertoneletters}', "");
    Expect(1, 42783, '\p{Block=:\Amodifiertoneletters\z:}', "");;
    Expect(0, 42784, '\p{Block=:\Amodifiertoneletters\z:}', "");;
    Expect(1, 42783, '\p{Block= Modifier_Tone_letters}', "");
    Expect(0, 42783, '\p{^Block= Modifier_Tone_letters}', "");
    Expect(0, 42783, '\P{Block= Modifier_Tone_letters}', "");
    Expect(1, 42783, '\P{^Block= Modifier_Tone_letters}', "");
    Expect(0, 42784, '\p{Block= Modifier_Tone_letters}', "");
    Expect(1, 42784, '\p{^Block= Modifier_Tone_letters}', "");
    Expect(1, 42784, '\P{Block= Modifier_Tone_letters}', "");
    Expect(0, 42784, '\P{^Block= Modifier_Tone_letters}', "");
    Error('\p{Blk=:=_ Modifier_Tone_Letters}');
    Error('\P{Blk=:=_ Modifier_Tone_Letters}');
    Expect(1, 42783, '\p{Blk=:\AModifier_Tone_Letters\z:}', "");;
    Expect(0, 42784, '\p{Blk=:\AModifier_Tone_Letters\z:}', "");;
    Expect(1, 42783, '\p{Blk=modifiertoneletters}', "");
    Expect(0, 42783, '\p{^Blk=modifiertoneletters}', "");
    Expect(0, 42783, '\P{Blk=modifiertoneletters}', "");
    Expect(1, 42783, '\P{^Blk=modifiertoneletters}', "");
    Expect(0, 42784, '\p{Blk=modifiertoneletters}', "");
    Expect(1, 42784, '\p{^Blk=modifiertoneletters}', "");
    Expect(1, 42784, '\P{Blk=modifiertoneletters}', "");
    Expect(0, 42784, '\P{^Blk=modifiertoneletters}', "");
    Expect(1, 42783, '\p{Blk=:\Amodifiertoneletters\z:}', "");;
    Expect(0, 42784, '\p{Blk=:\Amodifiertoneletters\z:}', "");;
    Expect(1, 42783, '\p{Blk= _modifier_Tone_letters}', "");
    Expect(0, 42783, '\p{^Blk= _modifier_Tone_letters}', "");
    Expect(0, 42783, '\P{Blk= _modifier_Tone_letters}', "");
    Expect(1, 42783, '\P{^Blk= _modifier_Tone_letters}', "");
    Expect(0, 42784, '\p{Blk= _modifier_Tone_letters}', "");
    Expect(1, 42784, '\p{^Blk= _modifier_Tone_letters}', "");
    Expect(1, 42784, '\P{Blk= _modifier_Tone_letters}', "");
    Expect(0, 42784, '\P{^Blk= _modifier_Tone_letters}', "");
    Error('\p{Is_Block=_	modifier_Tone_letters:=}');
    Error('\P{Is_Block=_	modifier_Tone_letters:=}');
    Expect(1, 42783, '\p{Is_Block=modifiertoneletters}', "");
    Expect(0, 42783, '\p{^Is_Block=modifiertoneletters}', "");
    Expect(0, 42783, '\P{Is_Block=modifiertoneletters}', "");
    Expect(1, 42783, '\P{^Is_Block=modifiertoneletters}', "");
    Expect(0, 42784, '\p{Is_Block=modifiertoneletters}', "");
    Expect(1, 42784, '\p{^Is_Block=modifiertoneletters}', "");
    Expect(1, 42784, '\P{Is_Block=modifiertoneletters}', "");
    Expect(0, 42784, '\P{^Is_Block=modifiertoneletters}', "");
    Expect(1, 42783, '\p{Is_Block:		_Modifier_tone_LETTERS}', "");
    Expect(0, 42783, '\p{^Is_Block:		_Modifier_tone_LETTERS}', "");
    Expect(0, 42783, '\P{Is_Block:		_Modifier_tone_LETTERS}', "");
    Expect(1, 42783, '\P{^Is_Block:		_Modifier_tone_LETTERS}', "");
    Expect(0, 42784, '\p{Is_Block:		_Modifier_tone_LETTERS}', "");
    Expect(1, 42784, '\p{^Is_Block:		_Modifier_tone_LETTERS}', "");
    Expect(1, 42784, '\P{Is_Block:		_Modifier_tone_LETTERS}', "");
    Expect(0, 42784, '\P{^Is_Block:		_Modifier_tone_LETTERS}', "");
    Error('\p{Is_Blk=	 Modifier_Tone_Letters:=}');
    Error('\P{Is_Blk=	 Modifier_Tone_Letters:=}');
    Expect(1, 42783, '\p{Is_Blk=modifiertoneletters}', "");
    Expect(0, 42783, '\p{^Is_Blk=modifiertoneletters}', "");
    Expect(0, 42783, '\P{Is_Blk=modifiertoneletters}', "");
    Expect(1, 42783, '\P{^Is_Blk=modifiertoneletters}', "");
    Expect(0, 42784, '\p{Is_Blk=modifiertoneletters}', "");
    Expect(1, 42784, '\p{^Is_Blk=modifiertoneletters}', "");
    Expect(1, 42784, '\P{Is_Blk=modifiertoneletters}', "");
    Expect(0, 42784, '\P{^Is_Blk=modifiertoneletters}', "");
    Expect(1, 42783, '\p{Is_Blk:   -MODIFIER_Tone_letters}', "");
    Expect(0, 42783, '\p{^Is_Blk:   -MODIFIER_Tone_letters}', "");
    Expect(0, 42783, '\P{Is_Blk:   -MODIFIER_Tone_letters}', "");
    Expect(1, 42783, '\P{^Is_Blk:   -MODIFIER_Tone_letters}', "");
    Expect(0, 42784, '\p{Is_Blk:   -MODIFIER_Tone_letters}', "");
    Expect(1, 42784, '\p{^Is_Blk:   -MODIFIER_Tone_letters}', "");
    Expect(1, 42784, '\P{Is_Blk:   -MODIFIER_Tone_letters}', "");
    Expect(0, 42784, '\P{^Is_Blk:   -MODIFIER_Tone_letters}', "");
    Error('\p{Block=:=	_Mongolian}');
    Error('\P{Block=:=	_Mongolian}');
    Expect(1, 6319, '\p{Block=:\AMongolian\z:}', "");;
    Expect(0, 6320, '\p{Block=:\AMongolian\z:}', "");;
    Expect(1, 6319, '\p{Block=mongolian}', "");
    Expect(0, 6319, '\p{^Block=mongolian}', "");
    Expect(0, 6319, '\P{Block=mongolian}', "");
    Expect(1, 6319, '\P{^Block=mongolian}', "");
    Expect(0, 6320, '\p{Block=mongolian}', "");
    Expect(1, 6320, '\p{^Block=mongolian}', "");
    Expect(1, 6320, '\P{Block=mongolian}', "");
    Expect(0, 6320, '\P{^Block=mongolian}', "");
    Expect(1, 6319, '\p{Block=:\Amongolian\z:}', "");;
    Expect(0, 6320, '\p{Block=:\Amongolian\z:}', "");;
    Expect(1, 6319, '\p{Block=		MONGOLIAN}', "");
    Expect(0, 6319, '\p{^Block=		MONGOLIAN}', "");
    Expect(0, 6319, '\P{Block=		MONGOLIAN}', "");
    Expect(1, 6319, '\P{^Block=		MONGOLIAN}', "");
    Expect(0, 6320, '\p{Block=		MONGOLIAN}', "");
    Expect(1, 6320, '\p{^Block=		MONGOLIAN}', "");
    Expect(1, 6320, '\P{Block=		MONGOLIAN}', "");
    Expect(0, 6320, '\P{^Block=		MONGOLIAN}', "");
    Error('\p{Blk=	:=mongolian}');
    Error('\P{Blk=	:=mongolian}');
    Expect(1, 6319, '\p{Blk=:\AMongolian\z:}', "");;
    Expect(0, 6320, '\p{Blk=:\AMongolian\z:}', "");;
    Expect(1, 6319, '\p{Blk=mongolian}', "");
    Expect(0, 6319, '\p{^Blk=mongolian}', "");
    Expect(0, 6319, '\P{Blk=mongolian}', "");
    Expect(1, 6319, '\P{^Blk=mongolian}', "");
    Expect(0, 6320, '\p{Blk=mongolian}', "");
    Expect(1, 6320, '\p{^Blk=mongolian}', "");
    Expect(1, 6320, '\P{Blk=mongolian}', "");
    Expect(0, 6320, '\P{^Blk=mongolian}', "");
    Expect(1, 6319, '\p{Blk=:\Amongolian\z:}', "");;
    Expect(0, 6320, '\p{Blk=:\Amongolian\z:}', "");;
    Expect(1, 6319, '\p{Blk=_MONGOLIAN}', "");
    Expect(0, 6319, '\p{^Blk=_MONGOLIAN}', "");
    Expect(0, 6319, '\P{Blk=_MONGOLIAN}', "");
    Expect(1, 6319, '\P{^Blk=_MONGOLIAN}', "");
    Expect(0, 6320, '\p{Blk=_MONGOLIAN}', "");
    Expect(1, 6320, '\p{^Blk=_MONGOLIAN}', "");
    Expect(1, 6320, '\P{Blk=_MONGOLIAN}', "");
    Expect(0, 6320, '\P{^Blk=_MONGOLIAN}', "");
    Error('\p{Is_Block=-	mongolian/a/}');
    Error('\P{Is_Block=-	mongolian/a/}');
    Expect(1, 6319, '\p{Is_Block=mongolian}', "");
    Expect(0, 6319, '\p{^Is_Block=mongolian}', "");
    Expect(0, 6319, '\P{Is_Block=mongolian}', "");
    Expect(1, 6319, '\P{^Is_Block=mongolian}', "");
    Expect(0, 6320, '\p{Is_Block=mongolian}', "");
    Expect(1, 6320, '\p{^Is_Block=mongolian}', "");
    Expect(1, 6320, '\P{Is_Block=mongolian}', "");
    Expect(0, 6320, '\P{^Is_Block=mongolian}', "");
    Expect(1, 6319, '\p{Is_Block=	Mongolian}', "");
    Expect(0, 6319, '\p{^Is_Block=	Mongolian}', "");
    Expect(0, 6319, '\P{Is_Block=	Mongolian}', "");
    Expect(1, 6319, '\P{^Is_Block=	Mongolian}', "");
    Expect(0, 6320, '\p{Is_Block=	Mongolian}', "");
    Expect(1, 6320, '\p{^Is_Block=	Mongolian}', "");
    Expect(1, 6320, '\P{Is_Block=	Mongolian}', "");
    Expect(0, 6320, '\P{^Is_Block=	Mongolian}', "");
    Error('\p{Is_Blk=__Mongolian:=}');
    Error('\P{Is_Blk=__Mongolian:=}');
    Expect(1, 6319, '\p{Is_Blk=mongolian}', "");
    Expect(0, 6319, '\p{^Is_Blk=mongolian}', "");
    Expect(0, 6319, '\P{Is_Blk=mongolian}', "");
    Expect(1, 6319, '\P{^Is_Blk=mongolian}', "");
    Expect(0, 6320, '\p{Is_Blk=mongolian}', "");
    Expect(1, 6320, '\p{^Is_Blk=mongolian}', "");
    Expect(1, 6320, '\P{Is_Blk=mongolian}', "");
    Expect(0, 6320, '\P{^Is_Blk=mongolian}', "");
    Expect(1, 6319, '\p{Is_Blk:   	Mongolian}', "");
    Expect(0, 6319, '\p{^Is_Blk:   	Mongolian}', "");
    Expect(0, 6319, '\P{Is_Blk:   	Mongolian}', "");
    Expect(1, 6319, '\P{^Is_Blk:   	Mongolian}', "");
    Expect(0, 6320, '\p{Is_Blk:   	Mongolian}', "");
    Expect(1, 6320, '\p{^Is_Blk:   	Mongolian}', "");
    Expect(1, 6320, '\P{Is_Blk:   	Mongolian}', "");
    Expect(0, 6320, '\P{^Is_Blk:   	Mongolian}', "");
    Error('\p{Block:	:=Mongolian_supplement}');
    Error('\P{Block:	:=Mongolian_supplement}');
    Expect(1, 71295, '\p{Block=:\AMongolian_Supplement\z:}', "");;
    Expect(0, 71296, '\p{Block=:\AMongolian_Supplement\z:}', "");;
    Expect(1, 71295, '\p{Block=mongoliansupplement}', "");
    Expect(0, 71295, '\p{^Block=mongoliansupplement}', "");
    Expect(0, 71295, '\P{Block=mongoliansupplement}', "");
    Expect(1, 71295, '\P{^Block=mongoliansupplement}', "");
    Expect(0, 71296, '\p{Block=mongoliansupplement}', "");
    Expect(1, 71296, '\p{^Block=mongoliansupplement}', "");
    Expect(1, 71296, '\P{Block=mongoliansupplement}', "");
    Expect(0, 71296, '\P{^Block=mongoliansupplement}', "");
    Expect(1, 71295, '\p{Block=:\Amongoliansupplement\z:}', "");;
    Expect(0, 71296, '\p{Block=:\Amongoliansupplement\z:}', "");;
    Expect(1, 71295, '\p{Block: mongolian_SUPPLEMENT}', "");
    Expect(0, 71295, '\p{^Block: mongolian_SUPPLEMENT}', "");
    Expect(0, 71295, '\P{Block: mongolian_SUPPLEMENT}', "");
    Expect(1, 71295, '\P{^Block: mongolian_SUPPLEMENT}', "");
    Expect(0, 71296, '\p{Block: mongolian_SUPPLEMENT}', "");
    Expect(1, 71296, '\p{^Block: mongolian_SUPPLEMENT}', "");
    Expect(1, 71296, '\P{Block: mongolian_SUPPLEMENT}', "");
    Expect(0, 71296, '\P{^Block: mongolian_SUPPLEMENT}', "");
    Error('\p{Blk=	 mongolian_Sup/a/}');
    Error('\P{Blk=	 mongolian_Sup/a/}');
    Expect(1, 71295, '\p{Blk=:\AMongolian_Sup\z:}', "");;
    Expect(0, 71296, '\p{Blk=:\AMongolian_Sup\z:}', "");;
    Expect(1, 71295, '\p{Blk=mongoliansup}', "");
    Expect(0, 71295, '\p{^Blk=mongoliansup}', "");
    Expect(0, 71295, '\P{Blk=mongoliansup}', "");
    Expect(1, 71295, '\P{^Blk=mongoliansup}', "");
    Expect(0, 71296, '\p{Blk=mongoliansup}', "");
    Expect(1, 71296, '\p{^Blk=mongoliansup}', "");
    Expect(1, 71296, '\P{Blk=mongoliansup}', "");
    Expect(0, 71296, '\P{^Blk=mongoliansup}', "");
    Expect(1, 71295, '\p{Blk=:\Amongoliansup\z:}', "");;
    Expect(0, 71296, '\p{Blk=:\Amongoliansup\z:}', "");;
    Expect(1, 71295, '\p{Blk= MONGOLIAN_sup}', "");
    Expect(0, 71295, '\p{^Blk= MONGOLIAN_sup}', "");
    Expect(0, 71295, '\P{Blk= MONGOLIAN_sup}', "");
    Expect(1, 71295, '\P{^Blk= MONGOLIAN_sup}', "");
    Expect(0, 71296, '\p{Blk= MONGOLIAN_sup}', "");
    Expect(1, 71296, '\p{^Blk= MONGOLIAN_sup}', "");
    Expect(1, 71296, '\P{Blk= MONGOLIAN_sup}', "");
    Expect(0, 71296, '\P{^Blk= MONGOLIAN_sup}', "");
    Error('\p{Is_Block= /a/mongolian_SUPPLEMENT}');
    Error('\P{Is_Block= /a/mongolian_SUPPLEMENT}');
    Expect(1, 71295, '\p{Is_Block=mongoliansupplement}', "");
    Expect(0, 71295, '\p{^Is_Block=mongoliansupplement}', "");
    Expect(0, 71295, '\P{Is_Block=mongoliansupplement}', "");
    Expect(1, 71295, '\P{^Is_Block=mongoliansupplement}', "");
    Expect(0, 71296, '\p{Is_Block=mongoliansupplement}', "");
    Expect(1, 71296, '\p{^Is_Block=mongoliansupplement}', "");
    Expect(1, 71296, '\P{Is_Block=mongoliansupplement}', "");
    Expect(0, 71296, '\P{^Is_Block=mongoliansupplement}', "");
    Expect(1, 71295, '\p{Is_Block=  mongolian_SUPPLEMENT}', "");
    Expect(0, 71295, '\p{^Is_Block=  mongolian_SUPPLEMENT}', "");
    Expect(0, 71295, '\P{Is_Block=  mongolian_SUPPLEMENT}', "");
    Expect(1, 71295, '\P{^Is_Block=  mongolian_SUPPLEMENT}', "");
    Expect(0, 71296, '\p{Is_Block=  mongolian_SUPPLEMENT}', "");
    Expect(1, 71296, '\p{^Is_Block=  mongolian_SUPPLEMENT}', "");
    Expect(1, 71296, '\P{Is_Block=  mongolian_SUPPLEMENT}', "");
    Expect(0, 71296, '\P{^Is_Block=  mongolian_SUPPLEMENT}', "");
    Error('\p{Is_Blk=/a/ -MONGOLIAN_Sup}');
    Error('\P{Is_Blk=/a/ -MONGOLIAN_Sup}');
    Expect(1, 71295, '\p{Is_Blk=mongoliansup}', "");
    Expect(0, 71295, '\p{^Is_Blk=mongoliansup}', "");
    Expect(0, 71295, '\P{Is_Blk=mongoliansup}', "");
    Expect(1, 71295, '\P{^Is_Blk=mongoliansup}', "");
    Expect(0, 71296, '\p{Is_Blk=mongoliansup}', "");
    Expect(1, 71296, '\p{^Is_Blk=mongoliansup}', "");
    Expect(1, 71296, '\P{Is_Blk=mongoliansup}', "");
    Expect(0, 71296, '\P{^Is_Blk=mongoliansup}', "");
    Expect(1, 71295, '\p{Is_Blk=-Mongolian_Sup}', "");
    Expect(0, 71295, '\p{^Is_Blk=-Mongolian_Sup}', "");
    Expect(0, 71295, '\P{Is_Blk=-Mongolian_Sup}', "");
    Expect(1, 71295, '\P{^Is_Blk=-Mongolian_Sup}', "");
    Expect(0, 71296, '\p{Is_Blk=-Mongolian_Sup}', "");
    Expect(1, 71296, '\p{^Is_Blk=-Mongolian_Sup}', "");
    Expect(1, 71296, '\P{Is_Blk=-Mongolian_Sup}', "");
    Expect(0, 71296, '\P{^Is_Blk=-Mongolian_Sup}', "");
    Error('\p{Block= 	Mro/a/}');
    Error('\P{Block= 	Mro/a/}');
    Expect(1, 92783, '\p{Block=:\AMro\z:}', "");;
    Expect(0, 92784, '\p{Block=:\AMro\z:}', "");;
    Expect(1, 92783, '\p{Block=mro}', "");
    Expect(0, 92783, '\p{^Block=mro}', "");
    Expect(0, 92783, '\P{Block=mro}', "");
    Expect(1, 92783, '\P{^Block=mro}', "");
    Expect(0, 92784, '\p{Block=mro}', "");
    Expect(1, 92784, '\p{^Block=mro}', "");
    Expect(1, 92784, '\P{Block=mro}', "");
    Expect(0, 92784, '\P{^Block=mro}', "");
    Expect(1, 92783, '\p{Block=:\Amro\z:}', "");;
    Expect(0, 92784, '\p{Block=:\Amro\z:}', "");;
    Expect(1, 92783, '\p{Block= -mro}', "");
    Expect(0, 92783, '\p{^Block= -mro}', "");
    Expect(0, 92783, '\P{Block= -mro}', "");
    Expect(1, 92783, '\P{^Block= -mro}', "");
    Expect(0, 92784, '\p{Block= -mro}', "");
    Expect(1, 92784, '\p{^Block= -mro}', "");
    Expect(1, 92784, '\P{Block= -mro}', "");
    Expect(0, 92784, '\P{^Block= -mro}', "");
    Error('\p{Blk=:=	_mro}');
    Error('\P{Blk=:=	_mro}');
    Expect(1, 92783, '\p{Blk=:\AMro\z:}', "");;
    Expect(0, 92784, '\p{Blk=:\AMro\z:}', "");;
    Expect(1, 92783, '\p{Blk=mro}', "");
    Expect(0, 92783, '\p{^Blk=mro}', "");
    Expect(0, 92783, '\P{Blk=mro}', "");
    Expect(1, 92783, '\P{^Blk=mro}', "");
    Expect(0, 92784, '\p{Blk=mro}', "");
    Expect(1, 92784, '\p{^Blk=mro}', "");
    Expect(1, 92784, '\P{Blk=mro}', "");
    Expect(0, 92784, '\P{^Blk=mro}', "");
    Expect(1, 92783, '\p{Blk=:\Amro\z:}', "");;
    Expect(0, 92784, '\p{Blk=:\Amro\z:}', "");;
    Expect(1, 92783, '\p{Blk=	 mro}', "");
    Expect(0, 92783, '\p{^Blk=	 mro}', "");
    Expect(0, 92783, '\P{Blk=	 mro}', "");
    Expect(1, 92783, '\P{^Blk=	 mro}', "");
    Expect(0, 92784, '\p{Blk=	 mro}', "");
    Expect(1, 92784, '\p{^Blk=	 mro}', "");
    Expect(1, 92784, '\P{Blk=	 mro}', "");
    Expect(0, 92784, '\P{^Blk=	 mro}', "");
    Error('\p{Is_Block=	_MRO:=}');
    Error('\P{Is_Block=	_MRO:=}');
    Expect(1, 92783, '\p{Is_Block=mro}', "");
    Expect(0, 92783, '\p{^Is_Block=mro}', "");
    Expect(0, 92783, '\P{Is_Block=mro}', "");
    Expect(1, 92783, '\P{^Is_Block=mro}', "");
    Expect(0, 92784, '\p{Is_Block=mro}', "");
    Expect(1, 92784, '\p{^Is_Block=mro}', "");
    Expect(1, 92784, '\P{Is_Block=mro}', "");
    Expect(0, 92784, '\P{^Is_Block=mro}', "");
    Expect(1, 92783, '\p{Is_Block=_Mro}', "");
    Expect(0, 92783, '\p{^Is_Block=_Mro}', "");
    Expect(0, 92783, '\P{Is_Block=_Mro}', "");
    Expect(1, 92783, '\P{^Is_Block=_Mro}', "");
    Expect(0, 92784, '\p{Is_Block=_Mro}', "");
    Expect(1, 92784, '\p{^Is_Block=_Mro}', "");
    Expect(1, 92784, '\P{Is_Block=_Mro}', "");
    Expect(0, 92784, '\P{^Is_Block=_Mro}', "");
    Error('\p{Is_Blk=:= 	Mro}');
    Error('\P{Is_Blk=:= 	Mro}');
    Expect(1, 92783, '\p{Is_Blk=mro}', "");
    Expect(0, 92783, '\p{^Is_Blk=mro}', "");
    Expect(0, 92783, '\P{Is_Blk=mro}', "");
    Expect(1, 92783, '\P{^Is_Blk=mro}', "");
    Expect(0, 92784, '\p{Is_Blk=mro}', "");
    Expect(1, 92784, '\p{^Is_Blk=mro}', "");
    Expect(1, 92784, '\P{Is_Blk=mro}', "");
    Expect(0, 92784, '\P{^Is_Blk=mro}', "");
    Expect(1, 92783, '\p{Is_Blk= Mro}', "");
    Expect(0, 92783, '\p{^Is_Blk= Mro}', "");
    Expect(0, 92783, '\P{Is_Blk= Mro}', "");
    Expect(1, 92783, '\P{^Is_Blk= Mro}', "");
    Expect(0, 92784, '\p{Is_Blk= Mro}', "");
    Expect(1, 92784, '\p{^Is_Blk= Mro}', "");
    Expect(1, 92784, '\P{Is_Blk= Mro}', "");
    Expect(0, 92784, '\P{^Is_Blk= Mro}', "");
    Error('\p{Block=:=	_multani}');
    Error('\P{Block=:=	_multani}');
    Expect(1, 70319, '\p{Block=:\AMultani\z:}', "");;
    Expect(0, 70320, '\p{Block=:\AMultani\z:}', "");;
    Expect(1, 70319, '\p{Block=multani}', "");
    Expect(0, 70319, '\p{^Block=multani}', "");
    Expect(0, 70319, '\P{Block=multani}', "");
    Expect(1, 70319, '\P{^Block=multani}', "");
    Expect(0, 70320, '\p{Block=multani}', "");
    Expect(1, 70320, '\p{^Block=multani}', "");
    Expect(1, 70320, '\P{Block=multani}', "");
    Expect(0, 70320, '\P{^Block=multani}', "");
    Expect(1, 70319, '\p{Block=:\Amultani\z:}', "");;
    Expect(0, 70320, '\p{Block=:\Amultani\z:}', "");;
    Expect(1, 70319, '\p{Block=-	multani}', "");
    Expect(0, 70319, '\p{^Block=-	multani}', "");
    Expect(0, 70319, '\P{Block=-	multani}', "");
    Expect(1, 70319, '\P{^Block=-	multani}', "");
    Expect(0, 70320, '\p{Block=-	multani}', "");
    Expect(1, 70320, '\p{^Block=-	multani}', "");
    Expect(1, 70320, '\P{Block=-	multani}', "");
    Expect(0, 70320, '\P{^Block=-	multani}', "");
    Error('\p{Blk=/a/Multani}');
    Error('\P{Blk=/a/Multani}');
    Expect(1, 70319, '\p{Blk=:\AMultani\z:}', "");;
    Expect(0, 70320, '\p{Blk=:\AMultani\z:}', "");;
    Expect(1, 70319, '\p{Blk=multani}', "");
    Expect(0, 70319, '\p{^Blk=multani}', "");
    Expect(0, 70319, '\P{Blk=multani}', "");
    Expect(1, 70319, '\P{^Blk=multani}', "");
    Expect(0, 70320, '\p{Blk=multani}', "");
    Expect(1, 70320, '\p{^Blk=multani}', "");
    Expect(1, 70320, '\P{Blk=multani}', "");
    Expect(0, 70320, '\P{^Blk=multani}', "");
    Expect(1, 70319, '\p{Blk=:\Amultani\z:}', "");;
    Expect(0, 70320, '\p{Blk=:\Amultani\z:}', "");;
    Expect(1, 70319, '\p{Blk=_	Multani}', "");
    Expect(0, 70319, '\p{^Blk=_	Multani}', "");
    Expect(0, 70319, '\P{Blk=_	Multani}', "");
    Expect(1, 70319, '\P{^Blk=_	Multani}', "");
    Expect(0, 70320, '\p{Blk=_	Multani}', "");
    Expect(1, 70320, '\p{^Blk=_	Multani}', "");
    Expect(1, 70320, '\P{Blk=_	Multani}', "");
    Expect(0, 70320, '\P{^Blk=_	Multani}', "");
    Error('\p{Is_Block=	:=Multani}');
    Error('\P{Is_Block=	:=Multani}');
    Expect(1, 70319, '\p{Is_Block=multani}', "");
    Expect(0, 70319, '\p{^Is_Block=multani}', "");
    Expect(0, 70319, '\P{Is_Block=multani}', "");
    Expect(1, 70319, '\P{^Is_Block=multani}', "");
    Expect(0, 70320, '\p{Is_Block=multani}', "");
    Expect(1, 70320, '\p{^Is_Block=multani}', "");
    Expect(1, 70320, '\P{Is_Block=multani}', "");
    Expect(0, 70320, '\P{^Is_Block=multani}', "");
    Expect(1, 70319, '\p{Is_Block=		Multani}', "");
    Expect(0, 70319, '\p{^Is_Block=		Multani}', "");
    Expect(0, 70319, '\P{Is_Block=		Multani}', "");
    Expect(1, 70319, '\P{^Is_Block=		Multani}', "");
    Expect(0, 70320, '\p{Is_Block=		Multani}', "");
    Expect(1, 70320, '\p{^Is_Block=		Multani}', "");
    Expect(1, 70320, '\P{Is_Block=		Multani}', "");
    Expect(0, 70320, '\P{^Is_Block=		Multani}', "");
    Error('\p{Is_Blk=_:=MULTANI}');
    Error('\P{Is_Blk=_:=MULTANI}');
    Expect(1, 70319, '\p{Is_Blk:	multani}', "");
    Expect(0, 70319, '\p{^Is_Blk:	multani}', "");
    Expect(0, 70319, '\P{Is_Blk:	multani}', "");
    Expect(1, 70319, '\P{^Is_Blk:	multani}', "");
    Expect(0, 70320, '\p{Is_Blk:	multani}', "");
    Expect(1, 70320, '\p{^Is_Blk:	multani}', "");
    Expect(1, 70320, '\P{Is_Blk:	multani}', "");
    Expect(0, 70320, '\P{^Is_Blk:	multani}', "");
    Expect(1, 70319, '\p{Is_Blk:	_ MULTANI}', "");
    Expect(0, 70319, '\p{^Is_Blk:	_ MULTANI}', "");
    Expect(0, 70319, '\P{Is_Blk:	_ MULTANI}', "");
    Expect(1, 70319, '\P{^Is_Blk:	_ MULTANI}', "");
    Expect(0, 70320, '\p{Is_Blk:	_ MULTANI}', "");
    Expect(1, 70320, '\p{^Is_Blk:	_ MULTANI}', "");
    Expect(1, 70320, '\P{Is_Blk:	_ MULTANI}', "");
    Expect(0, 70320, '\P{^Is_Blk:	_ MULTANI}', "");
    Error('\p{Block=/a/ musical_Symbols}');
    Error('\P{Block=/a/ musical_Symbols}');
    Expect(1, 119295, '\p{Block=:\AMusical_Symbols\z:}', "");;
    Expect(0, 119296, '\p{Block=:\AMusical_Symbols\z:}', "");;
    Expect(1, 119295, '\p{Block=musicalsymbols}', "");
    Expect(0, 119295, '\p{^Block=musicalsymbols}', "");
    Expect(0, 119295, '\P{Block=musicalsymbols}', "");
    Expect(1, 119295, '\P{^Block=musicalsymbols}', "");
    Expect(0, 119296, '\p{Block=musicalsymbols}', "");
    Expect(1, 119296, '\p{^Block=musicalsymbols}', "");
    Expect(1, 119296, '\P{Block=musicalsymbols}', "");
    Expect(0, 119296, '\P{^Block=musicalsymbols}', "");
    Expect(1, 119295, '\p{Block=:\Amusicalsymbols\z:}', "");;
    Expect(0, 119296, '\p{Block=:\Amusicalsymbols\z:}', "");;
    Expect(1, 119295, '\p{Block=-_Musical_SYMBOLS}', "");
    Expect(0, 119295, '\p{^Block=-_Musical_SYMBOLS}', "");
    Expect(0, 119295, '\P{Block=-_Musical_SYMBOLS}', "");
    Expect(1, 119295, '\P{^Block=-_Musical_SYMBOLS}', "");
    Expect(0, 119296, '\p{Block=-_Musical_SYMBOLS}', "");
    Expect(1, 119296, '\p{^Block=-_Musical_SYMBOLS}', "");
    Expect(1, 119296, '\P{Block=-_Musical_SYMBOLS}', "");
    Expect(0, 119296, '\P{^Block=-_Musical_SYMBOLS}', "");
    Error('\p{Blk=:=music}');
    Error('\P{Blk=:=music}');
    Expect(1, 119295, '\p{Blk=:\AMusic\z:}', "");;
    Expect(0, 119296, '\p{Blk=:\AMusic\z:}', "");;
    Expect(1, 119295, '\p{Blk=music}', "");
    Expect(0, 119295, '\p{^Blk=music}', "");
    Expect(0, 119295, '\P{Blk=music}', "");
    Expect(1, 119295, '\P{^Blk=music}', "");
    Expect(0, 119296, '\p{Blk=music}', "");
    Expect(1, 119296, '\p{^Blk=music}', "");
    Expect(1, 119296, '\P{Blk=music}', "");
    Expect(0, 119296, '\P{^Blk=music}', "");
    Expect(1, 119295, '\p{Blk=:\Amusic\z:}', "");;
    Expect(0, 119296, '\p{Blk=:\Amusic\z:}', "");;
    Expect(1, 119295, '\p{Blk:    music}', "");
    Expect(0, 119295, '\p{^Blk:    music}', "");
    Expect(0, 119295, '\P{Blk:    music}', "");
    Expect(1, 119295, '\P{^Blk:    music}', "");
    Expect(0, 119296, '\p{Blk:    music}', "");
    Expect(1, 119296, '\p{^Blk:    music}', "");
    Expect(1, 119296, '\P{Blk:    music}', "");
    Expect(0, 119296, '\P{^Blk:    music}', "");
    Error('\p{Is_Block=/a/  Musical_Symbols}');
    Error('\P{Is_Block=/a/  Musical_Symbols}');
    Expect(1, 119295, '\p{Is_Block=musicalsymbols}', "");
    Expect(0, 119295, '\p{^Is_Block=musicalsymbols}', "");
    Expect(0, 119295, '\P{Is_Block=musicalsymbols}', "");
    Expect(1, 119295, '\P{^Is_Block=musicalsymbols}', "");
    Expect(0, 119296, '\p{Is_Block=musicalsymbols}', "");
    Expect(1, 119296, '\p{^Is_Block=musicalsymbols}', "");
    Expect(1, 119296, '\P{Is_Block=musicalsymbols}', "");
    Expect(0, 119296, '\P{^Is_Block=musicalsymbols}', "");
    Expect(1, 119295, '\p{Is_Block=--musical_Symbols}', "");
    Expect(0, 119295, '\p{^Is_Block=--musical_Symbols}', "");
    Expect(0, 119295, '\P{Is_Block=--musical_Symbols}', "");
    Expect(1, 119295, '\P{^Is_Block=--musical_Symbols}', "");
    Expect(0, 119296, '\p{Is_Block=--musical_Symbols}', "");
    Expect(1, 119296, '\p{^Is_Block=--musical_Symbols}', "");
    Expect(1, 119296, '\P{Is_Block=--musical_Symbols}', "");
    Expect(0, 119296, '\P{^Is_Block=--musical_Symbols}', "");
    Error('\p{Is_Blk= _music:=}');
    Error('\P{Is_Blk= _music:=}');
    Expect(1, 119295, '\p{Is_Blk=music}', "");
    Expect(0, 119295, '\p{^Is_Blk=music}', "");
    Expect(0, 119295, '\P{Is_Blk=music}', "");
    Expect(1, 119295, '\P{^Is_Blk=music}', "");
    Expect(0, 119296, '\p{Is_Blk=music}', "");
    Expect(1, 119296, '\p{^Is_Blk=music}', "");
    Expect(1, 119296, '\P{Is_Blk=music}', "");
    Expect(0, 119296, '\P{^Is_Blk=music}', "");
    Expect(1, 119295, '\p{Is_Blk=_Music}', "");
    Expect(0, 119295, '\p{^Is_Blk=_Music}', "");
    Expect(0, 119295, '\P{Is_Blk=_Music}', "");
    Expect(1, 119295, '\P{^Is_Blk=_Music}', "");
    Expect(0, 119296, '\p{Is_Blk=_Music}', "");
    Expect(1, 119296, '\p{^Is_Blk=_Music}', "");
    Expect(1, 119296, '\P{Is_Blk=_Music}', "");
    Expect(0, 119296, '\P{^Is_Blk=_Music}', "");
    Error('\p{Block=_-myanmar:=}');
    Error('\P{Block=_-myanmar:=}');
    Expect(1, 4255, '\p{Block=:\AMyanmar\z:}', "");;
    Expect(0, 4256, '\p{Block=:\AMyanmar\z:}', "");;
    Expect(1, 4255, '\p{Block=myanmar}', "");
    Expect(0, 4255, '\p{^Block=myanmar}', "");
    Expect(0, 4255, '\P{Block=myanmar}', "");
    Expect(1, 4255, '\P{^Block=myanmar}', "");
    Expect(0, 4256, '\p{Block=myanmar}', "");
    Expect(1, 4256, '\p{^Block=myanmar}', "");
    Expect(1, 4256, '\P{Block=myanmar}', "");
    Expect(0, 4256, '\P{^Block=myanmar}', "");
    Expect(1, 4255, '\p{Block=:\Amyanmar\z:}', "");;
    Expect(0, 4256, '\p{Block=:\Amyanmar\z:}', "");;
    Expect(1, 4255, '\p{Block=-Myanmar}', "");
    Expect(0, 4255, '\p{^Block=-Myanmar}', "");
    Expect(0, 4255, '\P{Block=-Myanmar}', "");
    Expect(1, 4255, '\P{^Block=-Myanmar}', "");
    Expect(0, 4256, '\p{Block=-Myanmar}', "");
    Expect(1, 4256, '\p{^Block=-Myanmar}', "");
    Expect(1, 4256, '\P{Block=-Myanmar}', "");
    Expect(0, 4256, '\P{^Block=-Myanmar}', "");
    Error('\p{Blk=/a/	-MYANMAR}');
    Error('\P{Blk=/a/	-MYANMAR}');
    Expect(1, 4255, '\p{Blk=:\AMyanmar\z:}', "");;
    Expect(0, 4256, '\p{Blk=:\AMyanmar\z:}', "");;
    Expect(1, 4255, '\p{Blk=myanmar}', "");
    Expect(0, 4255, '\p{^Blk=myanmar}', "");
    Expect(0, 4255, '\P{Blk=myanmar}', "");
    Expect(1, 4255, '\P{^Blk=myanmar}', "");
    Expect(0, 4256, '\p{Blk=myanmar}', "");
    Expect(1, 4256, '\p{^Blk=myanmar}', "");
    Expect(1, 4256, '\P{Blk=myanmar}', "");
    Expect(0, 4256, '\P{^Blk=myanmar}', "");
    Expect(1, 4255, '\p{Blk=:\Amyanmar\z:}', "");;
    Expect(0, 4256, '\p{Blk=:\Amyanmar\z:}', "");;
    Expect(1, 4255, '\p{Blk=_Myanmar}', "");
    Expect(0, 4255, '\p{^Blk=_Myanmar}', "");
    Expect(0, 4255, '\P{Blk=_Myanmar}', "");
    Expect(1, 4255, '\P{^Blk=_Myanmar}', "");
    Expect(0, 4256, '\p{Blk=_Myanmar}', "");
    Expect(1, 4256, '\p{^Blk=_Myanmar}', "");
    Expect(1, 4256, '\P{Blk=_Myanmar}', "");
    Expect(0, 4256, '\P{^Blk=_Myanmar}', "");
    Error('\p{Is_Block=_/a/MYANMAR}');
    Error('\P{Is_Block=_/a/MYANMAR}');
    Expect(1, 4255, '\p{Is_Block=myanmar}', "");
    Expect(0, 4255, '\p{^Is_Block=myanmar}', "");
    Expect(0, 4255, '\P{Is_Block=myanmar}', "");
    Expect(1, 4255, '\P{^Is_Block=myanmar}', "");
    Expect(0, 4256, '\p{Is_Block=myanmar}', "");
    Expect(1, 4256, '\p{^Is_Block=myanmar}', "");
    Expect(1, 4256, '\P{Is_Block=myanmar}', "");
    Expect(0, 4256, '\P{^Is_Block=myanmar}', "");
    Expect(1, 4255, '\p{Is_Block=__Myanmar}', "");
    Expect(0, 4255, '\p{^Is_Block=__Myanmar}', "");
    Expect(0, 4255, '\P{Is_Block=__Myanmar}', "");
    Expect(1, 4255, '\P{^Is_Block=__Myanmar}', "");
    Expect(0, 4256, '\p{Is_Block=__Myanmar}', "");
    Expect(1, 4256, '\p{^Is_Block=__Myanmar}', "");
    Expect(1, 4256, '\P{Is_Block=__Myanmar}', "");
    Expect(0, 4256, '\P{^Is_Block=__Myanmar}', "");
    Error('\p{Is_Blk=:=myanmar}');
    Error('\P{Is_Blk=:=myanmar}');
    Expect(1, 4255, '\p{Is_Blk=myanmar}', "");
    Expect(0, 4255, '\p{^Is_Blk=myanmar}', "");
    Expect(0, 4255, '\P{Is_Blk=myanmar}', "");
    Expect(1, 4255, '\P{^Is_Blk=myanmar}', "");
    Expect(0, 4256, '\p{Is_Blk=myanmar}', "");
    Expect(1, 4256, '\p{^Is_Blk=myanmar}', "");
    Expect(1, 4256, '\P{Is_Blk=myanmar}', "");
    Expect(0, 4256, '\P{^Is_Blk=myanmar}', "");
    Expect(1, 4255, '\p{Is_Blk= -myanmar}', "");
    Expect(0, 4255, '\p{^Is_Blk= -myanmar}', "");
    Expect(0, 4255, '\P{Is_Blk= -myanmar}', "");
    Expect(1, 4255, '\P{^Is_Blk= -myanmar}', "");
    Expect(0, 4256, '\p{Is_Blk= -myanmar}', "");
    Expect(1, 4256, '\p{^Is_Blk= -myanmar}', "");
    Expect(1, 4256, '\P{Is_Blk= -myanmar}', "");
    Expect(0, 4256, '\P{^Is_Blk= -myanmar}', "");
    Error('\p{Block= /a/Myanmar_EXTENDED_A}');
    Error('\P{Block= /a/Myanmar_EXTENDED_A}');
    Expect(1, 43647, '\p{Block=:\AMyanmar_Extended_A\z:}', "");;
    Expect(0, 43648, '\p{Block=:\AMyanmar_Extended_A\z:}', "");;
    Expect(1, 43647, '\p{Block=myanmarextendeda}', "");
    Expect(0, 43647, '\p{^Block=myanmarextendeda}', "");
    Expect(0, 43647, '\P{Block=myanmarextendeda}', "");
    Expect(1, 43647, '\P{^Block=myanmarextendeda}', "");
    Expect(0, 43648, '\p{Block=myanmarextendeda}', "");
    Expect(1, 43648, '\p{^Block=myanmarextendeda}', "");
    Expect(1, 43648, '\P{Block=myanmarextendeda}', "");
    Expect(0, 43648, '\P{^Block=myanmarextendeda}', "");
    Expect(1, 43647, '\p{Block=:\Amyanmarextendeda\z:}', "");;
    Expect(0, 43648, '\p{Block=:\Amyanmarextendeda\z:}', "");;
    Expect(1, 43647, '\p{Block=_-Myanmar_extended_A}', "");
    Expect(0, 43647, '\p{^Block=_-Myanmar_extended_A}', "");
    Expect(0, 43647, '\P{Block=_-Myanmar_extended_A}', "");
    Expect(1, 43647, '\P{^Block=_-Myanmar_extended_A}', "");
    Expect(0, 43648, '\p{Block=_-Myanmar_extended_A}', "");
    Expect(1, 43648, '\p{^Block=_-Myanmar_extended_A}', "");
    Expect(1, 43648, '\P{Block=_-Myanmar_extended_A}', "");
    Expect(0, 43648, '\P{^Block=_-Myanmar_extended_A}', "");
    Error('\p{Blk=	Myanmar_Ext_A/a/}');
    Error('\P{Blk=	Myanmar_Ext_A/a/}');
    Expect(1, 43647, '\p{Blk=:\AMyanmar_Ext_A\z:}', "");;
    Expect(0, 43648, '\p{Blk=:\AMyanmar_Ext_A\z:}', "");;
    Expect(1, 43647, '\p{Blk=myanmarexta}', "");
    Expect(0, 43647, '\p{^Blk=myanmarexta}', "");
    Expect(0, 43647, '\P{Blk=myanmarexta}', "");
    Expect(1, 43647, '\P{^Blk=myanmarexta}', "");
    Expect(0, 43648, '\p{Blk=myanmarexta}', "");
    Expect(1, 43648, '\p{^Blk=myanmarexta}', "");
    Expect(1, 43648, '\P{Blk=myanmarexta}', "");
    Expect(0, 43648, '\P{^Blk=myanmarexta}', "");
    Expect(1, 43647, '\p{Blk=:\Amyanmarexta\z:}', "");;
    Expect(0, 43648, '\p{Blk=:\Amyanmarexta\z:}', "");;
    Expect(1, 43647, '\p{Blk=	_Myanmar_Ext_a}', "");
    Expect(0, 43647, '\p{^Blk=	_Myanmar_Ext_a}', "");
    Expect(0, 43647, '\P{Blk=	_Myanmar_Ext_a}', "");
    Expect(1, 43647, '\P{^Blk=	_Myanmar_Ext_a}', "");
    Expect(0, 43648, '\p{Blk=	_Myanmar_Ext_a}', "");
    Expect(1, 43648, '\p{^Blk=	_Myanmar_Ext_a}', "");
    Expect(1, 43648, '\P{Blk=	_Myanmar_Ext_a}', "");
    Expect(0, 43648, '\P{^Blk=	_Myanmar_Ext_a}', "");
    Error('\p{Is_Block= :=Myanmar_Extended_A}');
    Error('\P{Is_Block= :=Myanmar_Extended_A}');
    Expect(1, 43647, '\p{Is_Block=myanmarextendeda}', "");
    Expect(0, 43647, '\p{^Is_Block=myanmarextendeda}', "");
    Expect(0, 43647, '\P{Is_Block=myanmarextendeda}', "");
    Expect(1, 43647, '\P{^Is_Block=myanmarextendeda}', "");
    Expect(0, 43648, '\p{Is_Block=myanmarextendeda}', "");
    Expect(1, 43648, '\p{^Is_Block=myanmarextendeda}', "");
    Expect(1, 43648, '\P{Is_Block=myanmarextendeda}', "");
    Expect(0, 43648, '\P{^Is_Block=myanmarextendeda}', "");
    Expect(1, 43647, '\p{Is_Block=	 Myanmar_EXTENDED_A}', "");
    Expect(0, 43647, '\p{^Is_Block=	 Myanmar_EXTENDED_A}', "");
    Expect(0, 43647, '\P{Is_Block=	 Myanmar_EXTENDED_A}', "");
    Expect(1, 43647, '\P{^Is_Block=	 Myanmar_EXTENDED_A}', "");
    Expect(0, 43648, '\p{Is_Block=	 Myanmar_EXTENDED_A}', "");
    Expect(1, 43648, '\p{^Is_Block=	 Myanmar_EXTENDED_A}', "");
    Expect(1, 43648, '\P{Is_Block=	 Myanmar_EXTENDED_A}', "");
    Expect(0, 43648, '\P{^Is_Block=	 Myanmar_EXTENDED_A}', "");
    Error('\p{Is_Blk=/a/-_Myanmar_EXT_A}');
    Error('\P{Is_Blk=/a/-_Myanmar_EXT_A}');
    Expect(1, 43647, '\p{Is_Blk=myanmarexta}', "");
    Expect(0, 43647, '\p{^Is_Blk=myanmarexta}', "");
    Expect(0, 43647, '\P{Is_Blk=myanmarexta}', "");
    Expect(1, 43647, '\P{^Is_Blk=myanmarexta}', "");
    Expect(0, 43648, '\p{Is_Blk=myanmarexta}', "");
    Expect(1, 43648, '\p{^Is_Blk=myanmarexta}', "");
    Expect(1, 43648, '\P{Is_Blk=myanmarexta}', "");
    Expect(0, 43648, '\P{^Is_Blk=myanmarexta}', "");
    Expect(1, 43647, '\p{Is_Blk=--Myanmar_ext_A}', "");
    Expect(0, 43647, '\p{^Is_Blk=--Myanmar_ext_A}', "");
    Expect(0, 43647, '\P{Is_Blk=--Myanmar_ext_A}', "");
    Expect(1, 43647, '\P{^Is_Blk=--Myanmar_ext_A}', "");
    Expect(0, 43648, '\p{Is_Blk=--Myanmar_ext_A}', "");
    Expect(1, 43648, '\p{^Is_Blk=--Myanmar_ext_A}', "");
    Expect(1, 43648, '\P{Is_Blk=--Myanmar_ext_A}', "");
    Expect(0, 43648, '\P{^Is_Blk=--Myanmar_ext_A}', "");
    Error('\p{Block=/a/ MYANMAR_extended_B}');
    Error('\P{Block=/a/ MYANMAR_extended_B}');
    Expect(1, 43519, '\p{Block=:\AMyanmar_Extended_B\z:}', "");;
    Expect(0, 43520, '\p{Block=:\AMyanmar_Extended_B\z:}', "");;
    Expect(1, 43519, '\p{Block=myanmarextendedb}', "");
    Expect(0, 43519, '\p{^Block=myanmarextendedb}', "");
    Expect(0, 43519, '\P{Block=myanmarextendedb}', "");
    Expect(1, 43519, '\P{^Block=myanmarextendedb}', "");
    Expect(0, 43520, '\p{Block=myanmarextendedb}', "");
    Expect(1, 43520, '\p{^Block=myanmarextendedb}', "");
    Expect(1, 43520, '\P{Block=myanmarextendedb}', "");
    Expect(0, 43520, '\P{^Block=myanmarextendedb}', "");
    Expect(1, 43519, '\p{Block=:\Amyanmarextendedb\z:}', "");;
    Expect(0, 43520, '\p{Block=:\Amyanmarextendedb\z:}', "");;
    Expect(1, 43519, '\p{Block:-Myanmar_extended_b}', "");
    Expect(0, 43519, '\p{^Block:-Myanmar_extended_b}', "");
    Expect(0, 43519, '\P{Block:-Myanmar_extended_b}', "");
    Expect(1, 43519, '\P{^Block:-Myanmar_extended_b}', "");
    Expect(0, 43520, '\p{Block:-Myanmar_extended_b}', "");
    Expect(1, 43520, '\p{^Block:-Myanmar_extended_b}', "");
    Expect(1, 43520, '\P{Block:-Myanmar_extended_b}', "");
    Expect(0, 43520, '\P{^Block:-Myanmar_extended_b}', "");
    Error('\p{Blk::=-Myanmar_Ext_b}');
    Error('\P{Blk::=-Myanmar_Ext_b}');
    Expect(1, 43519, '\p{Blk=:\AMyanmar_Ext_B\z:}', "");;
    Expect(0, 43520, '\p{Blk=:\AMyanmar_Ext_B\z:}', "");;
    Expect(1, 43519, '\p{Blk=myanmarextb}', "");
    Expect(0, 43519, '\p{^Blk=myanmarextb}', "");
    Expect(0, 43519, '\P{Blk=myanmarextb}', "");
    Expect(1, 43519, '\P{^Blk=myanmarextb}', "");
    Expect(0, 43520, '\p{Blk=myanmarextb}', "");
    Expect(1, 43520, '\p{^Blk=myanmarextb}', "");
    Expect(1, 43520, '\P{Blk=myanmarextb}', "");
    Expect(0, 43520, '\P{^Blk=myanmarextb}', "");
    Expect(1, 43519, '\p{Blk=:\Amyanmarextb\z:}', "");;
    Expect(0, 43520, '\p{Blk=:\Amyanmarextb\z:}', "");;
    Expect(1, 43519, '\p{Blk=_Myanmar_ext_B}', "");
    Expect(0, 43519, '\p{^Blk=_Myanmar_ext_B}', "");
    Expect(0, 43519, '\P{Blk=_Myanmar_ext_B}', "");
    Expect(1, 43519, '\P{^Blk=_Myanmar_ext_B}', "");
    Expect(0, 43520, '\p{Blk=_Myanmar_ext_B}', "");
    Expect(1, 43520, '\p{^Blk=_Myanmar_ext_B}', "");
    Expect(1, 43520, '\P{Blk=_Myanmar_ext_B}', "");
    Expect(0, 43520, '\P{^Blk=_Myanmar_ext_B}', "");
    Error('\p{Is_Block=- MYANMAR_Extended_b:=}');
    Error('\P{Is_Block=- MYANMAR_Extended_b:=}');
    Expect(1, 43519, '\p{Is_Block=myanmarextendedb}', "");
    Expect(0, 43519, '\p{^Is_Block=myanmarextendedb}', "");
    Expect(0, 43519, '\P{Is_Block=myanmarextendedb}', "");
    Expect(1, 43519, '\P{^Is_Block=myanmarextendedb}', "");
    Expect(0, 43520, '\p{Is_Block=myanmarextendedb}', "");
    Expect(1, 43520, '\p{^Is_Block=myanmarextendedb}', "");
    Expect(1, 43520, '\P{Is_Block=myanmarextendedb}', "");
    Expect(0, 43520, '\P{^Is_Block=myanmarextendedb}', "");
    Expect(1, 43519, '\p{Is_Block=-myanmar_EXTENDED_B}', "");
    Expect(0, 43519, '\p{^Is_Block=-myanmar_EXTENDED_B}', "");
    Expect(0, 43519, '\P{Is_Block=-myanmar_EXTENDED_B}', "");
    Expect(1, 43519, '\P{^Is_Block=-myanmar_EXTENDED_B}', "");
    Expect(0, 43520, '\p{Is_Block=-myanmar_EXTENDED_B}', "");
    Expect(1, 43520, '\p{^Is_Block=-myanmar_EXTENDED_B}', "");
    Expect(1, 43520, '\P{Is_Block=-myanmar_EXTENDED_B}', "");
    Expect(0, 43520, '\P{^Is_Block=-myanmar_EXTENDED_B}', "");
    Error('\p{Is_Blk=:=	_Myanmar_Ext_B}');
    Error('\P{Is_Blk=:=	_Myanmar_Ext_B}');
    Expect(1, 43519, '\p{Is_Blk=myanmarextb}', "");
    Expect(0, 43519, '\p{^Is_Blk=myanmarextb}', "");
    Expect(0, 43519, '\P{Is_Blk=myanmarextb}', "");
    Expect(1, 43519, '\P{^Is_Blk=myanmarextb}', "");
    Expect(0, 43520, '\p{Is_Blk=myanmarextb}', "");
    Expect(1, 43520, '\p{^Is_Blk=myanmarextb}', "");
    Expect(1, 43520, '\P{Is_Blk=myanmarextb}', "");
    Expect(0, 43520, '\P{^Is_Blk=myanmarextb}', "");
    Expect(1, 43519, '\p{Is_Blk=		MYANMAR_Ext_B}', "");
    Expect(0, 43519, '\p{^Is_Blk=		MYANMAR_Ext_B}', "");
    Expect(0, 43519, '\P{Is_Blk=		MYANMAR_Ext_B}', "");
    Expect(1, 43519, '\P{^Is_Blk=		MYANMAR_Ext_B}', "");
    Expect(0, 43520, '\p{Is_Blk=		MYANMAR_Ext_B}', "");
    Expect(1, 43520, '\p{^Is_Blk=		MYANMAR_Ext_B}', "");
    Expect(1, 43520, '\P{Is_Blk=		MYANMAR_Ext_B}', "");
    Expect(0, 43520, '\P{^Is_Blk=		MYANMAR_Ext_B}', "");
    Error('\p{Block:	-_nabataean/a/}');
    Error('\P{Block:	-_nabataean/a/}');
    Expect(1, 67759, '\p{Block=:\ANabataean\z:}', "");;
    Expect(0, 67760, '\p{Block=:\ANabataean\z:}', "");;
    Expect(1, 67759, '\p{Block=nabataean}', "");
    Expect(0, 67759, '\p{^Block=nabataean}', "");
    Expect(0, 67759, '\P{Block=nabataean}', "");
    Expect(1, 67759, '\P{^Block=nabataean}', "");
    Expect(0, 67760, '\p{Block=nabataean}', "");
    Expect(1, 67760, '\p{^Block=nabataean}', "");
    Expect(1, 67760, '\P{Block=nabataean}', "");
    Expect(0, 67760, '\P{^Block=nabataean}', "");
    Expect(1, 67759, '\p{Block=:\Anabataean\z:}', "");;
    Expect(0, 67760, '\p{Block=:\Anabataean\z:}', "");;
    Expect(1, 67759, '\p{Block=	Nabataean}', "");
    Expect(0, 67759, '\p{^Block=	Nabataean}', "");
    Expect(0, 67759, '\P{Block=	Nabataean}', "");
    Expect(1, 67759, '\P{^Block=	Nabataean}', "");
    Expect(0, 67760, '\p{Block=	Nabataean}', "");
    Expect(1, 67760, '\p{^Block=	Nabataean}', "");
    Expect(1, 67760, '\P{Block=	Nabataean}', "");
    Expect(0, 67760, '\P{^Block=	Nabataean}', "");
    Error('\p{Blk=	/a/nabataean}');
    Error('\P{Blk=	/a/nabataean}');
    Expect(1, 67759, '\p{Blk=:\ANabataean\z:}', "");;
    Expect(0, 67760, '\p{Blk=:\ANabataean\z:}', "");;
    Expect(1, 67759, '\p{Blk=nabataean}', "");
    Expect(0, 67759, '\p{^Blk=nabataean}', "");
    Expect(0, 67759, '\P{Blk=nabataean}', "");
    Expect(1, 67759, '\P{^Blk=nabataean}', "");
    Expect(0, 67760, '\p{Blk=nabataean}', "");
    Expect(1, 67760, '\p{^Blk=nabataean}', "");
    Expect(1, 67760, '\P{Blk=nabataean}', "");
    Expect(0, 67760, '\P{^Blk=nabataean}', "");
    Expect(1, 67759, '\p{Blk=:\Anabataean\z:}', "");;
    Expect(0, 67760, '\p{Blk=:\Anabataean\z:}', "");;
    Expect(1, 67759, '\p{Blk=		Nabataean}', "");
    Expect(0, 67759, '\p{^Blk=		Nabataean}', "");
    Expect(0, 67759, '\P{Blk=		Nabataean}', "");
    Expect(1, 67759, '\P{^Blk=		Nabataean}', "");
    Expect(0, 67760, '\p{Blk=		Nabataean}', "");
    Expect(1, 67760, '\p{^Blk=		Nabataean}', "");
    Expect(1, 67760, '\P{Blk=		Nabataean}', "");
    Expect(0, 67760, '\P{^Blk=		Nabataean}', "");
    Error('\p{Is_Block=-:=nabataean}');
    Error('\P{Is_Block=-:=nabataean}');
    Expect(1, 67759, '\p{Is_Block=nabataean}', "");
    Expect(0, 67759, '\p{^Is_Block=nabataean}', "");
    Expect(0, 67759, '\P{Is_Block=nabataean}', "");
    Expect(1, 67759, '\P{^Is_Block=nabataean}', "");
    Expect(0, 67760, '\p{Is_Block=nabataean}', "");
    Expect(1, 67760, '\p{^Is_Block=nabataean}', "");
    Expect(1, 67760, '\P{Is_Block=nabataean}', "");
    Expect(0, 67760, '\P{^Is_Block=nabataean}', "");
    Expect(1, 67759, '\p{Is_Block=-Nabataean}', "");
    Expect(0, 67759, '\p{^Is_Block=-Nabataean}', "");
    Expect(0, 67759, '\P{Is_Block=-Nabataean}', "");
    Expect(1, 67759, '\P{^Is_Block=-Nabataean}', "");
    Expect(0, 67760, '\p{Is_Block=-Nabataean}', "");
    Expect(1, 67760, '\p{^Is_Block=-Nabataean}', "");
    Expect(1, 67760, '\P{Is_Block=-Nabataean}', "");
    Expect(0, 67760, '\P{^Is_Block=-Nabataean}', "");
    Error('\p{Is_Blk:	_Nabataean:=}');
    Error('\P{Is_Blk:	_Nabataean:=}');
    Expect(1, 67759, '\p{Is_Blk=nabataean}', "");
    Expect(0, 67759, '\p{^Is_Blk=nabataean}', "");
    Expect(0, 67759, '\P{Is_Blk=nabataean}', "");
    Expect(1, 67759, '\P{^Is_Blk=nabataean}', "");
    Expect(0, 67760, '\p{Is_Blk=nabataean}', "");
    Expect(1, 67760, '\p{^Is_Blk=nabataean}', "");
    Expect(1, 67760, '\P{Is_Blk=nabataean}', "");
    Expect(0, 67760, '\P{^Is_Blk=nabataean}', "");
    Expect(1, 67759, '\p{Is_Blk=-Nabataean}', "");
    Expect(0, 67759, '\p{^Is_Blk=-Nabataean}', "");
    Expect(0, 67759, '\P{Is_Blk=-Nabataean}', "");
    Expect(1, 67759, '\P{^Is_Blk=-Nabataean}', "");
    Expect(0, 67760, '\p{Is_Blk=-Nabataean}', "");
    Expect(1, 67760, '\p{^Is_Blk=-Nabataean}', "");
    Expect(1, 67760, '\P{Is_Blk=-Nabataean}', "");
    Expect(0, 67760, '\P{^Is_Blk=-Nabataean}', "");
    Error('\p{Block:	/a/ NAG_Mundari}');
    Error('\P{Block:	/a/ NAG_Mundari}');
    Expect(1, 124159, '\p{Block=:\ANag_Mundari\z:}', "");;
    Expect(0, 124160, '\p{Block=:\ANag_Mundari\z:}', "");;
    Expect(1, 124159, '\p{Block=nagmundari}', "");
    Expect(0, 124159, '\p{^Block=nagmundari}', "");
    Expect(0, 124159, '\P{Block=nagmundari}', "");
    Expect(1, 124159, '\P{^Block=nagmundari}', "");
    Expect(0, 124160, '\p{Block=nagmundari}', "");
    Expect(1, 124160, '\p{^Block=nagmundari}', "");
    Expect(1, 124160, '\P{Block=nagmundari}', "");
    Expect(0, 124160, '\P{^Block=nagmundari}', "");
    Expect(1, 124159, '\p{Block=:\Anagmundari\z:}', "");;
    Expect(0, 124160, '\p{Block=:\Anagmundari\z:}', "");;
    Expect(1, 124159, '\p{Block= NAG_MUNDARI}', "");
    Expect(0, 124159, '\p{^Block= NAG_MUNDARI}', "");
    Expect(0, 124159, '\P{Block= NAG_MUNDARI}', "");
    Expect(1, 124159, '\P{^Block= NAG_MUNDARI}', "");
    Expect(0, 124160, '\p{Block= NAG_MUNDARI}', "");
    Expect(1, 124160, '\p{^Block= NAG_MUNDARI}', "");
    Expect(1, 124160, '\P{Block= NAG_MUNDARI}', "");
    Expect(0, 124160, '\P{^Block= NAG_MUNDARI}', "");
    Error('\p{Blk=_:=Nag_mundari}');
    Error('\P{Blk=_:=Nag_mundari}');
    Expect(1, 124159, '\p{Blk=:\ANag_Mundari\z:}', "");;
    Expect(0, 124160, '\p{Blk=:\ANag_Mundari\z:}', "");;
    Expect(1, 124159, '\p{Blk=nagmundari}', "");
    Expect(0, 124159, '\p{^Blk=nagmundari}', "");
    Expect(0, 124159, '\P{Blk=nagmundari}', "");
    Expect(1, 124159, '\P{^Blk=nagmundari}', "");
    Expect(0, 124160, '\p{Blk=nagmundari}', "");
    Expect(1, 124160, '\p{^Blk=nagmundari}', "");
    Expect(1, 124160, '\P{Blk=nagmundari}', "");
    Expect(0, 124160, '\P{^Blk=nagmundari}', "");
    Expect(1, 124159, '\p{Blk=:\Anagmundari\z:}', "");;
    Expect(0, 124160, '\p{Blk=:\Anagmundari\z:}', "");;
    Expect(1, 124159, '\p{Blk:	_nag_Mundari}', "");
    Expect(0, 124159, '\p{^Blk:	_nag_Mundari}', "");
    Expect(0, 124159, '\P{Blk:	_nag_Mundari}', "");
    Expect(1, 124159, '\P{^Blk:	_nag_Mundari}', "");
    Expect(0, 124160, '\p{Blk:	_nag_Mundari}', "");
    Expect(1, 124160, '\p{^Blk:	_nag_Mundari}', "");
    Expect(1, 124160, '\P{Blk:	_nag_Mundari}', "");
    Expect(0, 124160, '\P{^Blk:	_nag_Mundari}', "");
    Error('\p{Is_Block:- nag_mundari:=}');
    Error('\P{Is_Block:- nag_mundari:=}');
    Expect(1, 124159, '\p{Is_Block=nagmundari}', "");
    Expect(0, 124159, '\p{^Is_Block=nagmundari}', "");
    Expect(0, 124159, '\P{Is_Block=nagmundari}', "");
    Expect(1, 124159, '\P{^Is_Block=nagmundari}', "");
    Expect(0, 124160, '\p{Is_Block=nagmundari}', "");
    Expect(1, 124160, '\p{^Is_Block=nagmundari}', "");
    Expect(1, 124160, '\P{Is_Block=nagmundari}', "");
    Expect(0, 124160, '\P{^Is_Block=nagmundari}', "");
    Expect(1, 124159, '\p{Is_Block=--NAG_MUNDARI}', "");
    Expect(0, 124159, '\p{^Is_Block=--NAG_MUNDARI}', "");
    Expect(0, 124159, '\P{Is_Block=--NAG_MUNDARI}', "");
    Expect(1, 124159, '\P{^Is_Block=--NAG_MUNDARI}', "");
    Expect(0, 124160, '\p{Is_Block=--NAG_MUNDARI}', "");
    Expect(1, 124160, '\p{^Is_Block=--NAG_MUNDARI}', "");
    Expect(1, 124160, '\P{Is_Block=--NAG_MUNDARI}', "");
    Expect(0, 124160, '\P{^Is_Block=--NAG_MUNDARI}', "");
    Error('\p{Is_Blk=/a/	NAG_MUNDARI}');
    Error('\P{Is_Blk=/a/	NAG_MUNDARI}');
    Expect(1, 124159, '\p{Is_Blk:	nagmundari}', "");
    Expect(0, 124159, '\p{^Is_Blk:	nagmundari}', "");
    Expect(0, 124159, '\P{Is_Blk:	nagmundari}', "");
    Expect(1, 124159, '\P{^Is_Blk:	nagmundari}', "");
    Expect(0, 124160, '\p{Is_Blk:	nagmundari}', "");
    Expect(1, 124160, '\p{^Is_Blk:	nagmundari}', "");
    Expect(1, 124160, '\P{Is_Blk:	nagmundari}', "");
    Expect(0, 124160, '\P{^Is_Blk:	nagmundari}', "");
    Expect(1, 124159, '\p{Is_Blk=	Nag_Mundari}', "");
    Expect(0, 124159, '\p{^Is_Blk=	Nag_Mundari}', "");
    Expect(0, 124159, '\P{Is_Blk=	Nag_Mundari}', "");
    Expect(1, 124159, '\P{^Is_Blk=	Nag_Mundari}', "");
    Expect(0, 124160, '\p{Is_Blk=	Nag_Mundari}', "");
    Expect(1, 124160, '\p{^Is_Blk=	Nag_Mundari}', "");
    Expect(1, 124160, '\P{Is_Blk=	Nag_Mundari}', "");
    Expect(0, 124160, '\P{^Is_Blk=	Nag_Mundari}', "");
    Error('\p{Block=	nandinagari/a/}');
    Error('\P{Block=	nandinagari/a/}');
    Expect(1, 72191, '\p{Block=:\ANandinagari\z:}', "");;
    Expect(0, 72192, '\p{Block=:\ANandinagari\z:}', "");;
    Expect(1, 72191, '\p{Block:nandinagari}', "");
    Expect(0, 72191, '\p{^Block:nandinagari}', "");
    Expect(0, 72191, '\P{Block:nandinagari}', "");
    Expect(1, 72191, '\P{^Block:nandinagari}', "");
    Expect(0, 72192, '\p{Block:nandinagari}', "");
    Expect(1, 72192, '\p{^Block:nandinagari}', "");
    Expect(1, 72192, '\P{Block:nandinagari}', "");
    Expect(0, 72192, '\P{^Block:nandinagari}', "");
    Expect(1, 72191, '\p{Block=:\Anandinagari\z:}', "");;
    Expect(0, 72192, '\p{Block=:\Anandinagari\z:}', "");;
    Expect(1, 72191, '\p{Block= _NANDINAGARI}', "");
    Expect(0, 72191, '\p{^Block= _NANDINAGARI}', "");
    Expect(0, 72191, '\P{Block= _NANDINAGARI}', "");
    Expect(1, 72191, '\P{^Block= _NANDINAGARI}', "");
    Expect(0, 72192, '\p{Block= _NANDINAGARI}', "");
    Expect(1, 72192, '\p{^Block= _NANDINAGARI}', "");
    Expect(1, 72192, '\P{Block= _NANDINAGARI}', "");
    Expect(0, 72192, '\P{^Block= _NANDINAGARI}', "");
    Error('\p{Blk= 	nandinagari:=}');
    Error('\P{Blk= 	nandinagari:=}');
    Expect(1, 72191, '\p{Blk=:\ANandinagari\z:}', "");;
    Expect(0, 72192, '\p{Blk=:\ANandinagari\z:}', "");;
    Expect(1, 72191, '\p{Blk=nandinagari}', "");
    Expect(0, 72191, '\p{^Blk=nandinagari}', "");
    Expect(0, 72191, '\P{Blk=nandinagari}', "");
    Expect(1, 72191, '\P{^Blk=nandinagari}', "");
    Expect(0, 72192, '\p{Blk=nandinagari}', "");
    Expect(1, 72192, '\p{^Blk=nandinagari}', "");
    Expect(1, 72192, '\P{Blk=nandinagari}', "");
    Expect(0, 72192, '\P{^Blk=nandinagari}', "");
    Expect(1, 72191, '\p{Blk=:\Anandinagari\z:}', "");;
    Expect(0, 72192, '\p{Blk=:\Anandinagari\z:}', "");;
    Expect(1, 72191, '\p{Blk=- Nandinagari}', "");
    Expect(0, 72191, '\p{^Blk=- Nandinagari}', "");
    Expect(0, 72191, '\P{Blk=- Nandinagari}', "");
    Expect(1, 72191, '\P{^Blk=- Nandinagari}', "");
    Expect(0, 72192, '\p{Blk=- Nandinagari}', "");
    Expect(1, 72192, '\p{^Blk=- Nandinagari}', "");
    Expect(1, 72192, '\P{Blk=- Nandinagari}', "");
    Expect(0, 72192, '\P{^Blk=- Nandinagari}', "");
    Error('\p{Is_Block:   _/a/nandinagari}');
    Error('\P{Is_Block:   _/a/nandinagari}');
    Expect(1, 72191, '\p{Is_Block=nandinagari}', "");
    Expect(0, 72191, '\p{^Is_Block=nandinagari}', "");
    Expect(0, 72191, '\P{Is_Block=nandinagari}', "");
    Expect(1, 72191, '\P{^Is_Block=nandinagari}', "");
    Expect(0, 72192, '\p{Is_Block=nandinagari}', "");
    Expect(1, 72192, '\p{^Is_Block=nandinagari}', "");
    Expect(1, 72192, '\P{Is_Block=nandinagari}', "");
    Expect(0, 72192, '\P{^Is_Block=nandinagari}', "");
    Expect(1, 72191, '\p{Is_Block=	_Nandinagari}', "");
    Expect(0, 72191, '\p{^Is_Block=	_Nandinagari}', "");
    Expect(0, 72191, '\P{Is_Block=	_Nandinagari}', "");
    Expect(1, 72191, '\P{^Is_Block=	_Nandinagari}', "");
    Expect(0, 72192, '\p{Is_Block=	_Nandinagari}', "");
    Expect(1, 72192, '\p{^Is_Block=	_Nandinagari}', "");
    Expect(1, 72192, '\P{Is_Block=	_Nandinagari}', "");
    Expect(0, 72192, '\P{^Is_Block=	_Nandinagari}', "");
    Error('\p{Is_Blk=_	Nandinagari:=}');
    Error('\P{Is_Blk=_	Nandinagari:=}');
    Expect(1, 72191, '\p{Is_Blk=nandinagari}', "");
    Expect(0, 72191, '\p{^Is_Blk=nandinagari}', "");
    Expect(0, 72191, '\P{Is_Blk=nandinagari}', "");
    Expect(1, 72191, '\P{^Is_Blk=nandinagari}', "");
    Expect(0, 72192, '\p{Is_Blk=nandinagari}', "");
    Expect(1, 72192, '\p{^Is_Blk=nandinagari}', "");
    Expect(1, 72192, '\P{Is_Blk=nandinagari}', "");
    Expect(0, 72192, '\P{^Is_Blk=nandinagari}', "");
    Expect(1, 72191, '\p{Is_Blk=__Nandinagari}', "");
    Expect(0, 72191, '\p{^Is_Blk=__Nandinagari}', "");
    Expect(0, 72191, '\P{Is_Blk=__Nandinagari}', "");
    Expect(1, 72191, '\P{^Is_Blk=__Nandinagari}', "");
    Expect(0, 72192, '\p{Is_Blk=__Nandinagari}', "");
    Expect(1, 72192, '\p{^Is_Blk=__Nandinagari}', "");
    Expect(1, 72192, '\P{Is_Blk=__Nandinagari}', "");
    Expect(0, 72192, '\P{^Is_Blk=__Nandinagari}', "");
    Error('\p{Block=  NO_block:=}');
    Error('\P{Block=  NO_block:=}');
    Expect(1, 918000, '\p{Block=:\ANo_Block\z:}', "");;
    Expect(0, 983040, '\p{Block=:\ANo_Block\z:}', "");;
    Expect(1, 918000, '\p{Block=noblock}', "");
    Expect(0, 918000, '\p{^Block=noblock}', "");
    Expect(0, 918000, '\P{Block=noblock}', "");
    Expect(1, 918000, '\P{^Block=noblock}', "");
    Expect(0, 983040, '\p{Block=noblock}', "");
    Expect(1, 983040, '\p{^Block=noblock}', "");
    Expect(1, 983040, '\P{Block=noblock}', "");
    Expect(0, 983040, '\P{^Block=noblock}', "");
    Expect(1, 918000, '\p{Block=:\Anoblock\z:}', "");;
    Expect(0, 983040, '\p{Block=:\Anoblock\z:}', "");;
    Expect(1, 918000, '\p{Block:	__No_Block}', "");
    Expect(0, 918000, '\p{^Block:	__No_Block}', "");
    Expect(0, 918000, '\P{Block:	__No_Block}', "");
    Expect(1, 918000, '\P{^Block:	__No_Block}', "");
    Expect(0, 983040, '\p{Block:	__No_Block}', "");
    Expect(1, 983040, '\p{^Block:	__No_Block}', "");
    Expect(1, 983040, '\P{Block:	__No_Block}', "");
    Expect(0, 983040, '\P{^Block:	__No_Block}', "");
    Error('\p{Blk=/a/--NB}');
    Error('\P{Blk=/a/--NB}');
    Expect(1, 918000, '\p{Blk=:\ANB\z:}', "");;
    Expect(0, 983040, '\p{Blk=:\ANB\z:}', "");;
    Expect(1, 918000, '\p{Blk=nb}', "");
    Expect(0, 918000, '\p{^Blk=nb}', "");
    Expect(0, 918000, '\P{Blk=nb}', "");
    Expect(1, 918000, '\P{^Blk=nb}', "");
    Expect(0, 983040, '\p{Blk=nb}', "");
    Expect(1, 983040, '\p{^Blk=nb}', "");
    Expect(1, 983040, '\P{Blk=nb}', "");
    Expect(0, 983040, '\P{^Blk=nb}', "");
    Expect(1, 918000, '\p{Blk=:\Anb\z:}', "");;
    Expect(0, 983040, '\p{Blk=:\Anb\z:}', "");;
    Expect(1, 918000, '\p{Blk=_	NB}', "");
    Expect(0, 918000, '\p{^Blk=_	NB}', "");
    Expect(0, 918000, '\P{Blk=_	NB}', "");
    Expect(1, 918000, '\P{^Blk=_	NB}', "");
    Expect(0, 983040, '\p{Blk=_	NB}', "");
    Expect(1, 983040, '\p{^Blk=_	NB}', "");
    Expect(1, 983040, '\P{Blk=_	NB}', "");
    Expect(0, 983040, '\P{^Blk=_	NB}', "");
    Error('\p{Is_Block=/a/_-no_Block}');
    Error('\P{Is_Block=/a/_-no_Block}');
    Expect(1, 918000, '\p{Is_Block=noblock}', "");
    Expect(0, 918000, '\p{^Is_Block=noblock}', "");
    Expect(0, 918000, '\P{Is_Block=noblock}', "");
    Expect(1, 918000, '\P{^Is_Block=noblock}', "");
    Expect(0, 983040, '\p{Is_Block=noblock}', "");
    Expect(1, 983040, '\p{^Is_Block=noblock}', "");
    Expect(1, 983040, '\P{Is_Block=noblock}', "");
    Expect(0, 983040, '\P{^Is_Block=noblock}', "");
    Expect(1, 918000, '\p{Is_Block:   _	No_Block}', "");
    Expect(0, 918000, '\p{^Is_Block:   _	No_Block}', "");
    Expect(0, 918000, '\P{Is_Block:   _	No_Block}', "");
    Expect(1, 918000, '\P{^Is_Block:   _	No_Block}', "");
    Expect(0, 983040, '\p{Is_Block:   _	No_Block}', "");
    Expect(1, 983040, '\p{^Is_Block:   _	No_Block}', "");
    Expect(1, 983040, '\P{Is_Block:   _	No_Block}', "");
    Expect(0, 983040, '\P{^Is_Block:   _	No_Block}', "");
    Error('\p{Is_Blk=:=_NB}');
    Error('\P{Is_Blk=:=_NB}');
    Expect(1, 918000, '\p{Is_Blk=nb}', "");
    Expect(0, 918000, '\p{^Is_Blk=nb}', "");
    Expect(0, 918000, '\P{Is_Blk=nb}', "");
    Expect(1, 918000, '\P{^Is_Blk=nb}', "");
    Expect(0, 983040, '\p{Is_Blk=nb}', "");
    Expect(1, 983040, '\p{^Is_Blk=nb}', "");
    Expect(1, 983040, '\P{Is_Blk=nb}', "");
    Expect(0, 983040, '\P{^Is_Blk=nb}', "");
    Expect(1, 918000, '\p{Is_Blk=	nb}', "");
    Expect(0, 918000, '\p{^Is_Blk=	nb}', "");
    Expect(0, 918000, '\P{Is_Blk=	nb}', "");
    Expect(1, 918000, '\P{^Is_Blk=	nb}', "");
    Expect(0, 983040, '\p{Is_Blk=	nb}', "");
    Expect(1, 983040, '\p{^Is_Blk=	nb}', "");
    Expect(1, 983040, '\P{Is_Blk=	nb}', "");
    Expect(0, 983040, '\P{^Is_Blk=	nb}', "");
    Error('\p{Block=	New_Tai_Lue:=}');
    Error('\P{Block=	New_Tai_Lue:=}');
    Expect(1, 6623, '\p{Block=:\ANew_Tai_Lue\z:}', "");;
    Expect(0, 6624, '\p{Block=:\ANew_Tai_Lue\z:}', "");;
    Expect(1, 6623, '\p{Block=newtailue}', "");
    Expect(0, 6623, '\p{^Block=newtailue}', "");
    Expect(0, 6623, '\P{Block=newtailue}', "");
    Expect(1, 6623, '\P{^Block=newtailue}', "");
    Expect(0, 6624, '\p{Block=newtailue}', "");
    Expect(1, 6624, '\p{^Block=newtailue}', "");
    Expect(1, 6624, '\P{Block=newtailue}', "");
    Expect(0, 6624, '\P{^Block=newtailue}', "");
    Expect(1, 6623, '\p{Block=:\Anewtailue\z:}', "");;
    Expect(0, 6624, '\p{Block=:\Anewtailue\z:}', "");;
    Expect(1, 6623, '\p{Block= _New_tai_LUE}', "");
    Expect(0, 6623, '\p{^Block= _New_tai_LUE}', "");
    Expect(0, 6623, '\P{Block= _New_tai_LUE}', "");
    Expect(1, 6623, '\P{^Block= _New_tai_LUE}', "");
    Expect(0, 6624, '\p{Block= _New_tai_LUE}', "");
    Expect(1, 6624, '\p{^Block= _New_tai_LUE}', "");
    Expect(1, 6624, '\P{Block= _New_tai_LUE}', "");
    Expect(0, 6624, '\P{^Block= _New_tai_LUE}', "");
    Error('\p{Blk=-new_tai_lue/a/}');
    Error('\P{Blk=-new_tai_lue/a/}');
    Expect(1, 6623, '\p{Blk=:\ANew_Tai_Lue\z:}', "");;
    Expect(0, 6624, '\p{Blk=:\ANew_Tai_Lue\z:}', "");;
    Expect(1, 6623, '\p{Blk=newtailue}', "");
    Expect(0, 6623, '\p{^Blk=newtailue}', "");
    Expect(0, 6623, '\P{Blk=newtailue}', "");
    Expect(1, 6623, '\P{^Blk=newtailue}', "");
    Expect(0, 6624, '\p{Blk=newtailue}', "");
    Expect(1, 6624, '\p{^Blk=newtailue}', "");
    Expect(1, 6624, '\P{Blk=newtailue}', "");
    Expect(0, 6624, '\P{^Blk=newtailue}', "");
    Expect(1, 6623, '\p{Blk=:\Anewtailue\z:}', "");;
    Expect(0, 6624, '\p{Blk=:\Anewtailue\z:}', "");;
    Expect(1, 6623, '\p{Blk=_-new_tai_Lue}', "");
    Expect(0, 6623, '\p{^Blk=_-new_tai_Lue}', "");
    Expect(0, 6623, '\P{Blk=_-new_tai_Lue}', "");
    Expect(1, 6623, '\P{^Blk=_-new_tai_Lue}', "");
    Expect(0, 6624, '\p{Blk=_-new_tai_Lue}', "");
    Expect(1, 6624, '\p{^Blk=_-new_tai_Lue}', "");
    Expect(1, 6624, '\P{Blk=_-new_tai_Lue}', "");
    Expect(0, 6624, '\P{^Blk=_-new_tai_Lue}', "");
    Error('\p{Is_Block=-:=new_tai_Lue}');
    Error('\P{Is_Block=-:=new_tai_Lue}');
    Expect(1, 6623, '\p{Is_Block=newtailue}', "");
    Expect(0, 6623, '\p{^Is_Block=newtailue}', "");
    Expect(0, 6623, '\P{Is_Block=newtailue}', "");
    Expect(1, 6623, '\P{^Is_Block=newtailue}', "");
    Expect(0, 6624, '\p{Is_Block=newtailue}', "");
    Expect(1, 6624, '\p{^Is_Block=newtailue}', "");
    Expect(1, 6624, '\P{Is_Block=newtailue}', "");
    Expect(0, 6624, '\P{^Is_Block=newtailue}', "");
    Expect(1, 6623, '\p{Is_Block: 	New_Tai_LUE}', "");
    Expect(0, 6623, '\p{^Is_Block: 	New_Tai_LUE}', "");
    Expect(0, 6623, '\P{Is_Block: 	New_Tai_LUE}', "");
    Expect(1, 6623, '\P{^Is_Block: 	New_Tai_LUE}', "");
    Expect(0, 6624, '\p{Is_Block: 	New_Tai_LUE}', "");
    Expect(1, 6624, '\p{^Is_Block: 	New_Tai_LUE}', "");
    Expect(1, 6624, '\P{Is_Block: 	New_Tai_LUE}', "");
    Expect(0, 6624, '\P{^Is_Block: 	New_Tai_LUE}', "");
    Error('\p{Is_Blk=/a/_New_TAI_LUE}');
    Error('\P{Is_Blk=/a/_New_TAI_LUE}');
    Expect(1, 6623, '\p{Is_Blk: newtailue}', "");
    Expect(0, 6623, '\p{^Is_Blk: newtailue}', "");
    Expect(0, 6623, '\P{Is_Blk: newtailue}', "");
    Expect(1, 6623, '\P{^Is_Blk: newtailue}', "");
    Expect(0, 6624, '\p{Is_Blk: newtailue}', "");
    Expect(1, 6624, '\p{^Is_Blk: newtailue}', "");
    Expect(1, 6624, '\P{Is_Blk: newtailue}', "");
    Expect(0, 6624, '\P{^Is_Blk: newtailue}', "");
    Expect(1, 6623, '\p{Is_Blk= new_Tai_LUE}', "");
    Expect(0, 6623, '\p{^Is_Blk= new_Tai_LUE}', "");
    Expect(0, 6623, '\P{Is_Blk= new_Tai_LUE}', "");
    Expect(1, 6623, '\P{^Is_Blk= new_Tai_LUE}', "");
    Expect(0, 6624, '\p{Is_Blk= new_Tai_LUE}', "");
    Expect(1, 6624, '\p{^Is_Blk= new_Tai_LUE}', "");
    Expect(1, 6624, '\P{Is_Blk= new_Tai_LUE}', "");
    Expect(0, 6624, '\P{^Is_Blk= new_Tai_LUE}', "");
    Error('\p{Block:   :=  NEWA}');
    Error('\P{Block:   :=  NEWA}');
    Expect(1, 70783, '\p{Block=:\ANewa\z:}', "");;
    Expect(0, 70784, '\p{Block=:\ANewa\z:}', "");;
    Expect(1, 70783, '\p{Block=newa}', "");
    Expect(0, 70783, '\p{^Block=newa}', "");
    Expect(0, 70783, '\P{Block=newa}', "");
    Expect(1, 70783, '\P{^Block=newa}', "");
    Expect(0, 70784, '\p{Block=newa}', "");
    Expect(1, 70784, '\p{^Block=newa}', "");
    Expect(1, 70784, '\P{Block=newa}', "");
    Expect(0, 70784, '\P{^Block=newa}', "");
    Expect(1, 70783, '\p{Block=:\Anewa\z:}', "");;
    Expect(0, 70784, '\p{Block=:\Anewa\z:}', "");;
    Error('\p{Blk=_NEWA:=}');
    Error('\P{Blk=_NEWA:=}');
    Expect(1, 70783, '\p{Blk=:\ANewa\z:}', "");;
    Expect(0, 70784, '\p{Blk=:\ANewa\z:}', "");;
    Expect(1, 70783, '\p{Blk=newa}', "");
    Expect(0, 70783, '\p{^Blk=newa}', "");
    Expect(0, 70783, '\P{Blk=newa}', "");
    Expect(1, 70783, '\P{^Blk=newa}', "");
    Expect(0, 70784, '\p{Blk=newa}', "");
    Expect(1, 70784, '\p{^Blk=newa}', "");
    Expect(1, 70784, '\P{Blk=newa}', "");
    Expect(0, 70784, '\P{^Blk=newa}', "");
    Expect(1, 70783, '\p{Blk=:\Anewa\z:}', "");;
    Expect(0, 70784, '\p{Blk=:\Anewa\z:}', "");;
    Expect(1, 70783, '\p{Blk=_	Newa}', "");
    Expect(0, 70783, '\p{^Blk=_	Newa}', "");
    Expect(0, 70783, '\P{Blk=_	Newa}', "");
    Expect(1, 70783, '\P{^Blk=_	Newa}', "");
    Expect(0, 70784, '\p{Blk=_	Newa}', "");
    Expect(1, 70784, '\p{^Blk=_	Newa}', "");
    Expect(1, 70784, '\P{Blk=_	Newa}', "");
    Expect(0, 70784, '\P{^Blk=_	Newa}', "");
    Error('\p{Is_Block=/a/	Newa}');
    Error('\P{Is_Block=/a/	Newa}');
    Expect(1, 70783, '\p{Is_Block=newa}', "");
    Expect(0, 70783, '\p{^Is_Block=newa}', "");
    Expect(0, 70783, '\P{Is_Block=newa}', "");
    Expect(1, 70783, '\P{^Is_Block=newa}', "");
    Expect(0, 70784, '\p{Is_Block=newa}', "");
    Expect(1, 70784, '\p{^Is_Block=newa}', "");
    Expect(1, 70784, '\P{Is_Block=newa}', "");
    Expect(0, 70784, '\P{^Is_Block=newa}', "");
    Error('\p{Is_Blk= Newa/a/}');
    Error('\P{Is_Blk= Newa/a/}');
    Expect(1, 70783, '\p{Is_Blk=newa}', "");
    Expect(0, 70783, '\p{^Is_Blk=newa}', "");
    Expect(0, 70783, '\P{Is_Blk=newa}', "");
    Expect(1, 70783, '\P{^Is_Blk=newa}', "");
    Expect(0, 70784, '\p{Is_Blk=newa}', "");
    Expect(1, 70784, '\p{^Is_Blk=newa}', "");
    Expect(1, 70784, '\P{Is_Blk=newa}', "");
    Expect(0, 70784, '\P{^Is_Blk=newa}', "");
    Expect(1, 70783, '\p{Is_Blk=	Newa}', "");
    Expect(0, 70783, '\p{^Is_Blk=	Newa}', "");
    Expect(0, 70783, '\P{Is_Blk=	Newa}', "");
    Expect(1, 70783, '\P{^Is_Blk=	Newa}', "");
    Expect(0, 70784, '\p{Is_Blk=	Newa}', "");
    Expect(1, 70784, '\p{^Is_Blk=	Newa}', "");
    Expect(1, 70784, '\P{Is_Blk=	Newa}', "");
    Expect(0, 70784, '\P{^Is_Blk=	Newa}', "");
    Error('\p{Block=:=--NKo}');
    Error('\P{Block=:=--NKo}');
    Expect(1, 2047, '\p{Block=:\ANKo\z:}', "");;
    Expect(0, 2048, '\p{Block=:\ANKo\z:}', "");;
    Expect(1, 2047, '\p{Block:nko}', "");
    Expect(0, 2047, '\p{^Block:nko}', "");
    Expect(0, 2047, '\P{Block:nko}', "");
    Expect(1, 2047, '\P{^Block:nko}', "");
    Expect(0, 2048, '\p{Block:nko}', "");
    Expect(1, 2048, '\p{^Block:nko}', "");
    Expect(1, 2048, '\P{Block:nko}', "");
    Expect(0, 2048, '\P{^Block:nko}', "");
    Expect(1, 2047, '\p{Block=:\Anko\z:}', "");;
    Expect(0, 2048, '\p{Block=:\Anko\z:}', "");;
    Expect(1, 2047, '\p{Block: _-nko}', "");
    Expect(0, 2047, '\p{^Block: _-nko}', "");
    Expect(0, 2047, '\P{Block: _-nko}', "");
    Expect(1, 2047, '\P{^Block: _-nko}', "");
    Expect(0, 2048, '\p{Block: _-nko}', "");
    Expect(1, 2048, '\p{^Block: _-nko}', "");
    Expect(1, 2048, '\P{Block: _-nko}', "");
    Expect(0, 2048, '\P{^Block: _-nko}', "");
    Error('\p{Blk:	-/a/NKo}');
    Error('\P{Blk:	-/a/NKo}');
    Expect(1, 2047, '\p{Blk=:\ANKo\z:}', "");;
    Expect(0, 2048, '\p{Blk=:\ANKo\z:}', "");;
    Expect(1, 2047, '\p{Blk=nko}', "");
    Expect(0, 2047, '\p{^Blk=nko}', "");
    Expect(0, 2047, '\P{Blk=nko}', "");
    Expect(1, 2047, '\P{^Blk=nko}', "");
    Expect(0, 2048, '\p{Blk=nko}', "");
    Expect(1, 2048, '\p{^Blk=nko}', "");
    Expect(1, 2048, '\P{Blk=nko}', "");
    Expect(0, 2048, '\P{^Blk=nko}', "");
    Expect(1, 2047, '\p{Blk=:\Anko\z:}', "");;
    Expect(0, 2048, '\p{Blk=:\Anko\z:}', "");;
    Expect(1, 2047, '\p{Blk= -NKo}', "");
    Expect(0, 2047, '\p{^Blk= -NKo}', "");
    Expect(0, 2047, '\P{Blk= -NKo}', "");
    Expect(1, 2047, '\P{^Blk= -NKo}', "");
    Expect(0, 2048, '\p{Blk= -NKo}', "");
    Expect(1, 2048, '\p{^Blk= -NKo}', "");
    Expect(1, 2048, '\P{Blk= -NKo}', "");
    Expect(0, 2048, '\P{^Blk= -NKo}', "");
    Error('\p{Is_Block=_	NKo/a/}');
    Error('\P{Is_Block=_	NKo/a/}');
    Expect(1, 2047, '\p{Is_Block:nko}', "");
    Expect(0, 2047, '\p{^Is_Block:nko}', "");
    Expect(0, 2047, '\P{Is_Block:nko}', "");
    Expect(1, 2047, '\P{^Is_Block:nko}', "");
    Expect(0, 2048, '\p{Is_Block:nko}', "");
    Expect(1, 2048, '\p{^Is_Block:nko}', "");
    Expect(1, 2048, '\P{Is_Block:nko}', "");
    Expect(0, 2048, '\P{^Is_Block:nko}', "");
    Expect(1, 2047, '\p{Is_Block=	NKO}', "");
    Expect(0, 2047, '\p{^Is_Block=	NKO}', "");
    Expect(0, 2047, '\P{Is_Block=	NKO}', "");
    Expect(1, 2047, '\P{^Is_Block=	NKO}', "");
    Expect(0, 2048, '\p{Is_Block=	NKO}', "");
    Expect(1, 2048, '\p{^Is_Block=	NKO}', "");
    Expect(1, 2048, '\P{Is_Block=	NKO}', "");
    Expect(0, 2048, '\P{^Is_Block=	NKO}', "");
    Error('\p{Is_Blk=-NKO/a/}');
    Error('\P{Is_Blk=-NKO/a/}');
    Expect(1, 2047, '\p{Is_Blk=nko}', "");
    Expect(0, 2047, '\p{^Is_Blk=nko}', "");
    Expect(0, 2047, '\P{Is_Blk=nko}', "");
    Expect(1, 2047, '\P{^Is_Blk=nko}', "");
    Expect(0, 2048, '\p{Is_Blk=nko}', "");
    Expect(1, 2048, '\p{^Is_Blk=nko}', "");
    Expect(1, 2048, '\P{Is_Blk=nko}', "");
    Expect(0, 2048, '\P{^Is_Blk=nko}', "");
    Expect(1, 2047, '\p{Is_Blk=-NKo}', "");
    Expect(0, 2047, '\p{^Is_Blk=-NKo}', "");
    Expect(0, 2047, '\P{Is_Blk=-NKo}', "");
    Expect(1, 2047, '\P{^Is_Blk=-NKo}', "");
    Expect(0, 2048, '\p{Is_Blk=-NKo}', "");
    Expect(1, 2048, '\p{^Is_Blk=-NKo}', "");
    Expect(1, 2048, '\P{Is_Blk=-NKo}', "");
    Expect(0, 2048, '\P{^Is_Blk=-NKo}', "");
    Error('\p{Block=-:=Number_forms}');
    Error('\P{Block=-:=Number_forms}');
    Expect(1, 8591, '\p{Block=:\ANumber_Forms\z:}', "");;
    Expect(0, 8592, '\p{Block=:\ANumber_Forms\z:}', "");;
    Expect(1, 8591, '\p{Block=numberforms}', "");
    Expect(0, 8591, '\p{^Block=numberforms}', "");
    Expect(0, 8591, '\P{Block=numberforms}', "");
    Expect(1, 8591, '\P{^Block=numberforms}', "");
    Expect(0, 8592, '\p{Block=numberforms}', "");
    Expect(1, 8592, '\p{^Block=numberforms}', "");
    Expect(1, 8592, '\P{Block=numberforms}', "");
    Expect(0, 8592, '\P{^Block=numberforms}', "");
    Expect(1, 8591, '\p{Block=:\Anumberforms\z:}', "");;
    Expect(0, 8592, '\p{Block=:\Anumberforms\z:}', "");;
    Expect(1, 8591, '\p{Block=_-Number_FORMS}', "");
    Expect(0, 8591, '\p{^Block=_-Number_FORMS}', "");
    Expect(0, 8591, '\P{Block=_-Number_FORMS}', "");
    Expect(1, 8591, '\P{^Block=_-Number_FORMS}', "");
    Expect(0, 8592, '\p{Block=_-Number_FORMS}', "");
    Expect(1, 8592, '\p{^Block=_-Number_FORMS}', "");
    Expect(1, 8592, '\P{Block=_-Number_FORMS}', "");
    Expect(0, 8592, '\P{^Block=_-Number_FORMS}', "");
    Error('\p{Blk= /a/Number_forms}');
    Error('\P{Blk= /a/Number_forms}');
    Expect(1, 8591, '\p{Blk=:\ANumber_Forms\z:}', "");;
    Expect(0, 8592, '\p{Blk=:\ANumber_Forms\z:}', "");;
    Expect(1, 8591, '\p{Blk=numberforms}', "");
    Expect(0, 8591, '\p{^Blk=numberforms}', "");
    Expect(0, 8591, '\P{Blk=numberforms}', "");
    Expect(1, 8591, '\P{^Blk=numberforms}', "");
    Expect(0, 8592, '\p{Blk=numberforms}', "");
    Expect(1, 8592, '\p{^Blk=numberforms}', "");
    Expect(1, 8592, '\P{Blk=numberforms}', "");
    Expect(0, 8592, '\P{^Blk=numberforms}', "");
    Expect(1, 8591, '\p{Blk=:\Anumberforms\z:}', "");;
    Expect(0, 8592, '\p{Blk=:\Anumberforms\z:}', "");;
    Expect(1, 8591, '\p{Blk: 		number_Forms}', "");
    Expect(0, 8591, '\p{^Blk: 		number_Forms}', "");
    Expect(0, 8591, '\P{Blk: 		number_Forms}', "");
    Expect(1, 8591, '\P{^Blk: 		number_Forms}', "");
    Expect(0, 8592, '\p{Blk: 		number_Forms}', "");
    Expect(1, 8592, '\p{^Blk: 		number_Forms}', "");
    Expect(1, 8592, '\P{Blk: 		number_Forms}', "");
    Expect(0, 8592, '\P{^Blk: 		number_Forms}', "");
    Error('\p{Is_Block=_/a/number_Forms}');
    Error('\P{Is_Block=_/a/number_Forms}');
    Expect(1, 8591, '\p{Is_Block=numberforms}', "");
    Expect(0, 8591, '\p{^Is_Block=numberforms}', "");
    Expect(0, 8591, '\P{Is_Block=numberforms}', "");
    Expect(1, 8591, '\P{^Is_Block=numberforms}', "");
    Expect(0, 8592, '\p{Is_Block=numberforms}', "");
    Expect(1, 8592, '\p{^Is_Block=numberforms}', "");
    Expect(1, 8592, '\P{Is_Block=numberforms}', "");
    Expect(0, 8592, '\P{^Is_Block=numberforms}', "");
    Expect(1, 8591, '\p{Is_Block=- Number_forms}', "");
    Expect(0, 8591, '\p{^Is_Block=- Number_forms}', "");
    Expect(0, 8591, '\P{Is_Block=- Number_forms}', "");
    Expect(1, 8591, '\P{^Is_Block=- Number_forms}', "");
    Expect(0, 8592, '\p{Is_Block=- Number_forms}', "");
    Expect(1, 8592, '\p{^Is_Block=- Number_forms}', "");
    Expect(1, 8592, '\P{Is_Block=- Number_forms}', "");
    Expect(0, 8592, '\P{^Is_Block=- Number_forms}', "");
    Error('\p{Is_Blk=/a/_	number_FORMS}');
    Error('\P{Is_Blk=/a/_	number_FORMS}');
    Expect(1, 8591, '\p{Is_Blk=numberforms}', "");
    Expect(0, 8591, '\p{^Is_Blk=numberforms}', "");
    Expect(0, 8591, '\P{Is_Blk=numberforms}', "");
    Expect(1, 8591, '\P{^Is_Blk=numberforms}', "");
    Expect(0, 8592, '\p{Is_Blk=numberforms}', "");
    Expect(1, 8592, '\p{^Is_Blk=numberforms}', "");
    Expect(1, 8592, '\P{Is_Blk=numberforms}', "");
    Expect(0, 8592, '\P{^Is_Blk=numberforms}', "");
    Expect(1, 8591, '\p{Is_Blk=-Number_Forms}', "");
    Expect(0, 8591, '\p{^Is_Blk=-Number_Forms}', "");
    Expect(0, 8591, '\P{Is_Blk=-Number_Forms}', "");
    Expect(1, 8591, '\P{^Is_Blk=-Number_Forms}', "");
    Expect(0, 8592, '\p{Is_Blk=-Number_Forms}', "");
    Expect(1, 8592, '\p{^Is_Blk=-Number_Forms}', "");
    Expect(1, 8592, '\P{Is_Blk=-Number_Forms}', "");
    Expect(0, 8592, '\P{^Is_Blk=-Number_Forms}', "");
    Error('\p{Block=/a/		NUSHU}');
    Error('\P{Block=/a/		NUSHU}');
    Expect(1, 111359, '\p{Block=:\ANushu\z:}', "");;
    Expect(0, 111360, '\p{Block=:\ANushu\z:}', "");;
    Expect(1, 111359, '\p{Block=nushu}', "");
    Expect(0, 111359, '\p{^Block=nushu}', "");
    Expect(0, 111359, '\P{Block=nushu}', "");
    Expect(1, 111359, '\P{^Block=nushu}', "");
    Expect(0, 111360, '\p{Block=nushu}', "");
    Expect(1, 111360, '\p{^Block=nushu}', "");
    Expect(1, 111360, '\P{Block=nushu}', "");
    Expect(0, 111360, '\P{^Block=nushu}', "");
    Expect(1, 111359, '\p{Block=:\Anushu\z:}', "");;
    Expect(0, 111360, '\p{Block=:\Anushu\z:}', "");;
    Expect(1, 111359, '\p{Block=	-nushu}', "");
    Expect(0, 111359, '\p{^Block=	-nushu}', "");
    Expect(0, 111359, '\P{Block=	-nushu}', "");
    Expect(1, 111359, '\P{^Block=	-nushu}', "");
    Expect(0, 111360, '\p{Block=	-nushu}', "");
    Expect(1, 111360, '\p{^Block=	-nushu}', "");
    Expect(1, 111360, '\P{Block=	-nushu}', "");
    Expect(0, 111360, '\P{^Block=	-nushu}', "");
    Error('\p{Blk=	 Nushu/a/}');
    Error('\P{Blk=	 Nushu/a/}');
    Expect(1, 111359, '\p{Blk=:\ANushu\z:}', "");;
    Expect(0, 111360, '\p{Blk=:\ANushu\z:}', "");;
    Expect(1, 111359, '\p{Blk:   nushu}', "");
    Expect(0, 111359, '\p{^Blk:   nushu}', "");
    Expect(0, 111359, '\P{Blk:   nushu}', "");
    Expect(1, 111359, '\P{^Blk:   nushu}', "");
    Expect(0, 111360, '\p{Blk:   nushu}', "");
    Expect(1, 111360, '\p{^Blk:   nushu}', "");
    Expect(1, 111360, '\P{Blk:   nushu}', "");
    Expect(0, 111360, '\P{^Blk:   nushu}', "");
    Expect(1, 111359, '\p{Blk=:\Anushu\z:}', "");;
    Expect(0, 111360, '\p{Blk=:\Anushu\z:}', "");;
    Expect(1, 111359, '\p{Blk=	NUSHU}', "");
    Expect(0, 111359, '\p{^Blk=	NUSHU}', "");
    Expect(0, 111359, '\P{Blk=	NUSHU}', "");
    Expect(1, 111359, '\P{^Blk=	NUSHU}', "");
    Expect(0, 111360, '\p{Blk=	NUSHU}', "");
    Expect(1, 111360, '\p{^Blk=	NUSHU}', "");
    Expect(1, 111360, '\P{Blk=	NUSHU}', "");
    Expect(0, 111360, '\P{^Blk=	NUSHU}', "");
    Error('\p{Is_Block=	-nushu:=}');
    Error('\P{Is_Block=	-nushu:=}');
    Expect(1, 111359, '\p{Is_Block=nushu}', "");
    Expect(0, 111359, '\p{^Is_Block=nushu}', "");
    Expect(0, 111359, '\P{Is_Block=nushu}', "");
    Expect(1, 111359, '\P{^Is_Block=nushu}', "");
    Expect(0, 111360, '\p{Is_Block=nushu}', "");
    Expect(1, 111360, '\p{^Is_Block=nushu}', "");
    Expect(1, 111360, '\P{Is_Block=nushu}', "");
    Expect(0, 111360, '\P{^Is_Block=nushu}', "");
    Expect(1, 111359, '\p{Is_Block:	-Nushu}', "");
    Expect(0, 111359, '\p{^Is_Block:	-Nushu}', "");
    Expect(0, 111359, '\P{Is_Block:	-Nushu}', "");
    Expect(1, 111359, '\P{^Is_Block:	-Nushu}', "");
    Expect(0, 111360, '\p{Is_Block:	-Nushu}', "");
    Expect(1, 111360, '\p{^Is_Block:	-Nushu}', "");
    Expect(1, 111360, '\P{Is_Block:	-Nushu}', "");
    Expect(0, 111360, '\P{^Is_Block:	-Nushu}', "");
    Error('\p{Is_Blk:	 /a/NUSHU}');
    Error('\P{Is_Blk:	 /a/NUSHU}');
    Expect(1, 111359, '\p{Is_Blk=nushu}', "");
    Expect(0, 111359, '\p{^Is_Blk=nushu}', "");
    Expect(0, 111359, '\P{Is_Blk=nushu}', "");
    Expect(1, 111359, '\P{^Is_Blk=nushu}', "");
    Expect(0, 111360, '\p{Is_Blk=nushu}', "");
    Expect(1, 111360, '\p{^Is_Blk=nushu}', "");
    Expect(1, 111360, '\P{Is_Blk=nushu}', "");
    Expect(0, 111360, '\P{^Is_Blk=nushu}', "");
    Expect(1, 111359, '\p{Is_Blk=_-NUSHU}', "");
    Expect(0, 111359, '\p{^Is_Blk=_-NUSHU}', "");
    Expect(0, 111359, '\P{Is_Blk=_-NUSHU}', "");
    Expect(1, 111359, '\P{^Is_Blk=_-NUSHU}', "");
    Expect(0, 111360, '\p{Is_Blk=_-NUSHU}', "");
    Expect(1, 111360, '\p{^Is_Blk=_-NUSHU}', "");
    Expect(1, 111360, '\P{Is_Blk=_-NUSHU}', "");
    Expect(0, 111360, '\P{^Is_Blk=_-NUSHU}', "");
    Error('\p{Block=	/a/NYIAKENG_Puachue_Hmong}');
    Error('\P{Block=	/a/NYIAKENG_Puachue_Hmong}');
    Expect(1, 123215, '\p{Block=:\ANyiakeng_Puachue_Hmong\z:}', "");;
    Expect(0, 123216, '\p{Block=:\ANyiakeng_Puachue_Hmong\z:}', "");;
    Expect(1, 123215, '\p{Block=nyiakengpuachuehmong}', "");
    Expect(0, 123215, '\p{^Block=nyiakengpuachuehmong}', "");
    Expect(0, 123215, '\P{Block=nyiakengpuachuehmong}', "");
    Expect(1, 123215, '\P{^Block=nyiakengpuachuehmong}', "");
    Expect(0, 123216, '\p{Block=nyiakengpuachuehmong}', "");
    Expect(1, 123216, '\p{^Block=nyiakengpuachuehmong}', "");
    Expect(1, 123216, '\P{Block=nyiakengpuachuehmong}', "");
    Expect(0, 123216, '\P{^Block=nyiakengpuachuehmong}', "");
    Expect(1, 123215, '\p{Block=:\Anyiakengpuachuehmong\z:}', "");;
    Expect(0, 123216, '\p{Block=:\Anyiakengpuachuehmong\z:}', "");;
    Expect(1, 123215, '\p{Block=- Nyiakeng_Puachue_hmong}', "");
    Expect(0, 123215, '\p{^Block=- Nyiakeng_Puachue_hmong}', "");
    Expect(0, 123215, '\P{Block=- Nyiakeng_Puachue_hmong}', "");
    Expect(1, 123215, '\P{^Block=- Nyiakeng_Puachue_hmong}', "");
    Expect(0, 123216, '\p{Block=- Nyiakeng_Puachue_hmong}', "");
    Expect(1, 123216, '\p{^Block=- Nyiakeng_Puachue_hmong}', "");
    Expect(1, 123216, '\P{Block=- Nyiakeng_Puachue_hmong}', "");
    Expect(0, 123216, '\P{^Block=- Nyiakeng_Puachue_hmong}', "");
    Error('\p{Blk=	-Nyiakeng_PUACHUE_Hmong:=}');
    Error('\P{Blk=	-Nyiakeng_PUACHUE_Hmong:=}');
    Expect(1, 123215, '\p{Blk=:\ANyiakeng_Puachue_Hmong\z:}', "");;
    Expect(0, 123216, '\p{Blk=:\ANyiakeng_Puachue_Hmong\z:}', "");;
    Expect(1, 123215, '\p{Blk:	nyiakengpuachuehmong}', "");
    Expect(0, 123215, '\p{^Blk:	nyiakengpuachuehmong}', "");
    Expect(0, 123215, '\P{Blk:	nyiakengpuachuehmong}', "");
    Expect(1, 123215, '\P{^Blk:	nyiakengpuachuehmong}', "");
    Expect(0, 123216, '\p{Blk:	nyiakengpuachuehmong}', "");
    Expect(1, 123216, '\p{^Blk:	nyiakengpuachuehmong}', "");
    Expect(1, 123216, '\P{Blk:	nyiakengpuachuehmong}', "");
    Expect(0, 123216, '\P{^Blk:	nyiakengpuachuehmong}', "");
    Expect(1, 123215, '\p{Blk=:\Anyiakengpuachuehmong\z:}', "");;
    Expect(0, 123216, '\p{Blk=:\Anyiakengpuachuehmong\z:}', "");;
    Expect(1, 123215, '\p{Blk=	Nyiakeng_Puachue_Hmong}', "");
    Expect(0, 123215, '\p{^Blk=	Nyiakeng_Puachue_Hmong}', "");
    Expect(0, 123215, '\P{Blk=	Nyiakeng_Puachue_Hmong}', "");
    Expect(1, 123215, '\P{^Blk=	Nyiakeng_Puachue_Hmong}', "");
    Expect(0, 123216, '\p{Blk=	Nyiakeng_Puachue_Hmong}', "");
    Expect(1, 123216, '\p{^Blk=	Nyiakeng_Puachue_Hmong}', "");
    Expect(1, 123216, '\P{Blk=	Nyiakeng_Puachue_Hmong}', "");
    Expect(0, 123216, '\P{^Blk=	Nyiakeng_Puachue_Hmong}', "");
    Error('\p{Is_Block=:=-nyiakeng_Puachue_Hmong}');
    Error('\P{Is_Block=:=-nyiakeng_Puachue_Hmong}');
    Expect(1, 123215, '\p{Is_Block: nyiakengpuachuehmong}', "");
    Expect(0, 123215, '\p{^Is_Block: nyiakengpuachuehmong}', "");
    Expect(0, 123215, '\P{Is_Block: nyiakengpuachuehmong}', "");
    Expect(1, 123215, '\P{^Is_Block: nyiakengpuachuehmong}', "");
    Expect(0, 123216, '\p{Is_Block: nyiakengpuachuehmong}', "");
    Expect(1, 123216, '\p{^Is_Block: nyiakengpuachuehmong}', "");
    Expect(1, 123216, '\P{Is_Block: nyiakengpuachuehmong}', "");
    Expect(0, 123216, '\P{^Is_Block: nyiakengpuachuehmong}', "");
    Expect(1, 123215, '\p{Is_Block=-Nyiakeng_Puachue_Hmong}', "");
    Expect(0, 123215, '\p{^Is_Block=-Nyiakeng_Puachue_Hmong}', "");
    Expect(0, 123215, '\P{Is_Block=-Nyiakeng_Puachue_Hmong}', "");
    Expect(1, 123215, '\P{^Is_Block=-Nyiakeng_Puachue_Hmong}', "");
    Expect(0, 123216, '\p{Is_Block=-Nyiakeng_Puachue_Hmong}', "");
    Expect(1, 123216, '\p{^Is_Block=-Nyiakeng_Puachue_Hmong}', "");
    Expect(1, 123216, '\P{Is_Block=-Nyiakeng_Puachue_Hmong}', "");
    Expect(0, 123216, '\P{^Is_Block=-Nyiakeng_Puachue_Hmong}', "");
    Error('\p{Is_Blk=	Nyiakeng_puachue_HMONG/a/}');
    Error('\P{Is_Blk=	Nyiakeng_puachue_HMONG/a/}');
    Expect(1, 123215, '\p{Is_Blk=nyiakengpuachuehmong}', "");
    Expect(0, 123215, '\p{^Is_Blk=nyiakengpuachuehmong}', "");
    Expect(0, 123215, '\P{Is_Blk=nyiakengpuachuehmong}', "");
    Expect(1, 123215, '\P{^Is_Blk=nyiakengpuachuehmong}', "");
    Expect(0, 123216, '\p{Is_Blk=nyiakengpuachuehmong}', "");
    Expect(1, 123216, '\p{^Is_Blk=nyiakengpuachuehmong}', "");
    Expect(1, 123216, '\P{Is_Blk=nyiakengpuachuehmong}', "");
    Expect(0, 123216, '\P{^Is_Blk=nyiakengpuachuehmong}', "");
    Expect(1, 123215, '\p{Is_Blk=  Nyiakeng_Puachue_hmong}', "");
    Expect(0, 123215, '\p{^Is_Blk=  Nyiakeng_Puachue_hmong}', "");
    Expect(0, 123215, '\P{Is_Blk=  Nyiakeng_Puachue_hmong}', "");
    Expect(1, 123215, '\P{^Is_Blk=  Nyiakeng_Puachue_hmong}', "");
    Expect(0, 123216, '\p{Is_Blk=  Nyiakeng_Puachue_hmong}', "");
    Expect(1, 123216, '\p{^Is_Blk=  Nyiakeng_Puachue_hmong}', "");
    Expect(1, 123216, '\P{Is_Blk=  Nyiakeng_Puachue_hmong}', "");
    Expect(0, 123216, '\P{^Is_Blk=  Nyiakeng_Puachue_hmong}', "");
    Error('\p{Block=:=-_OPTICAL_CHARACTER_Recognition}');
    Error('\P{Block=:=-_OPTICAL_CHARACTER_Recognition}');
    Expect(1, 9311, '\p{Block=:\AOptical_Character_Recognition\z:}', "");;
    Expect(0, 9312, '\p{Block=:\AOptical_Character_Recognition\z:}', "");;
    Expect(1, 9311, '\p{Block=opticalcharacterrecognition}', "");
    Expect(0, 9311, '\p{^Block=opticalcharacterrecognition}', "");
    Expect(0, 9311, '\P{Block=opticalcharacterrecognition}', "");
    Expect(1, 9311, '\P{^Block=opticalcharacterrecognition}', "");
    Expect(0, 9312, '\p{Block=opticalcharacterrecognition}', "");
    Expect(1, 9312, '\p{^Block=opticalcharacterrecognition}', "");
    Expect(1, 9312, '\P{Block=opticalcharacterrecognition}', "");
    Expect(0, 9312, '\P{^Block=opticalcharacterrecognition}', "");
    Expect(1, 9311, '\p{Block=:\Aopticalcharacterrecognition\z:}', "");;
    Expect(0, 9312, '\p{Block=:\Aopticalcharacterrecognition\z:}', "");;
    Expect(1, 9311, '\p{Block= Optical_Character_recognition}', "");
    Expect(0, 9311, '\p{^Block= Optical_Character_recognition}', "");
    Expect(0, 9311, '\P{Block= Optical_Character_recognition}', "");
    Expect(1, 9311, '\P{^Block= Optical_Character_recognition}', "");
    Expect(0, 9312, '\p{Block= Optical_Character_recognition}', "");
    Expect(1, 9312, '\p{^Block= Optical_Character_recognition}', "");
    Expect(1, 9312, '\P{Block= Optical_Character_recognition}', "");
    Expect(0, 9312, '\P{^Block= Optical_Character_recognition}', "");
    Error('\p{Blk=:=_OCR}');
    Error('\P{Blk=:=_OCR}');
    Expect(1, 9311, '\p{Blk=:\AOCR\z:}', "");;
    Expect(0, 9312, '\p{Blk=:\AOCR\z:}', "");;
    Expect(1, 9311, '\p{Blk=ocr}', "");
    Expect(0, 9311, '\p{^Blk=ocr}', "");
    Expect(0, 9311, '\P{Blk=ocr}', "");
    Expect(1, 9311, '\P{^Blk=ocr}', "");
    Expect(0, 9312, '\p{Blk=ocr}', "");
    Expect(1, 9312, '\p{^Blk=ocr}', "");
    Expect(1, 9312, '\P{Blk=ocr}', "");
    Expect(0, 9312, '\P{^Blk=ocr}', "");
    Expect(1, 9311, '\p{Blk=:\Aocr\z:}', "");;
    Expect(0, 9312, '\p{Blk=:\Aocr\z:}', "");;
    Expect(1, 9311, '\p{Blk: --OCR}', "");
    Expect(0, 9311, '\p{^Blk: --OCR}', "");
    Expect(0, 9311, '\P{Blk: --OCR}', "");
    Expect(1, 9311, '\P{^Blk: --OCR}', "");
    Expect(0, 9312, '\p{Blk: --OCR}', "");
    Expect(1, 9312, '\p{^Blk: --OCR}', "");
    Expect(1, 9312, '\P{Blk: --OCR}', "");
    Expect(0, 9312, '\P{^Blk: --OCR}', "");
    Error('\p{Is_Block=:=		optical_CHARACTER_RECOGNITION}');
    Error('\P{Is_Block=:=		optical_CHARACTER_RECOGNITION}');
    Expect(1, 9311, '\p{Is_Block=opticalcharacterrecognition}', "");
    Expect(0, 9311, '\p{^Is_Block=opticalcharacterrecognition}', "");
    Expect(0, 9311, '\P{Is_Block=opticalcharacterrecognition}', "");
    Expect(1, 9311, '\P{^Is_Block=opticalcharacterrecognition}', "");
    Expect(0, 9312, '\p{Is_Block=opticalcharacterrecognition}', "");
    Expect(1, 9312, '\p{^Is_Block=opticalcharacterrecognition}', "");
    Expect(1, 9312, '\P{Is_Block=opticalcharacterrecognition}', "");
    Expect(0, 9312, '\P{^Is_Block=opticalcharacterrecognition}', "");
    Expect(1, 9311, '\p{Is_Block=_Optical_CHARACTER_RECOGNITION}', "");
    Expect(0, 9311, '\p{^Is_Block=_Optical_CHARACTER_RECOGNITION}', "");
    Expect(0, 9311, '\P{Is_Block=_Optical_CHARACTER_RECOGNITION}', "");
    Expect(1, 9311, '\P{^Is_Block=_Optical_CHARACTER_RECOGNITION}', "");
    Expect(0, 9312, '\p{Is_Block=_Optical_CHARACTER_RECOGNITION}', "");
    Expect(1, 9312, '\p{^Is_Block=_Optical_CHARACTER_RECOGNITION}', "");
    Expect(1, 9312, '\P{Is_Block=_Optical_CHARACTER_RECOGNITION}', "");
    Expect(0, 9312, '\P{^Is_Block=_Optical_CHARACTER_RECOGNITION}', "");
    Error('\p{Is_Blk= -OCR/a/}');
    Error('\P{Is_Blk= -OCR/a/}');
    Expect(1, 9311, '\p{Is_Blk=ocr}', "");
    Expect(0, 9311, '\p{^Is_Blk=ocr}', "");
    Expect(0, 9311, '\P{Is_Blk=ocr}', "");
    Expect(1, 9311, '\P{^Is_Blk=ocr}', "");
    Expect(0, 9312, '\p{Is_Blk=ocr}', "");
    Expect(1, 9312, '\p{^Is_Blk=ocr}', "");
    Expect(1, 9312, '\P{Is_Blk=ocr}', "");
    Expect(0, 9312, '\P{^Is_Blk=ocr}', "");
    Expect(1, 9311, '\p{Is_Blk=--OCR}', "");
    Expect(0, 9311, '\p{^Is_Blk=--OCR}', "");
    Expect(0, 9311, '\P{Is_Blk=--OCR}', "");
    Expect(1, 9311, '\P{^Is_Blk=--OCR}', "");
    Expect(0, 9312, '\p{Is_Blk=--OCR}', "");
    Expect(1, 9312, '\p{^Is_Blk=--OCR}', "");
    Expect(1, 9312, '\P{Is_Blk=--OCR}', "");
    Expect(0, 9312, '\P{^Is_Blk=--OCR}', "");
    Error('\p{Block=/a/Ogham}');
    Error('\P{Block=/a/Ogham}');
    Expect(1, 5791, '\p{Block=:\AOgham\z:}', "");;
    Expect(0, 5792, '\p{Block=:\AOgham\z:}', "");;
    Expect(1, 5791, '\p{Block=ogham}', "");
    Expect(0, 5791, '\p{^Block=ogham}', "");
    Expect(0, 5791, '\P{Block=ogham}', "");
    Expect(1, 5791, '\P{^Block=ogham}', "");
    Expect(0, 5792, '\p{Block=ogham}', "");
    Expect(1, 5792, '\p{^Block=ogham}', "");
    Expect(1, 5792, '\P{Block=ogham}', "");
    Expect(0, 5792, '\P{^Block=ogham}', "");
    Expect(1, 5791, '\p{Block=:\Aogham\z:}', "");;
    Expect(0, 5792, '\p{Block=:\Aogham\z:}', "");;
    Expect(1, 5791, '\p{Block=_-OGHAM}', "");
    Expect(0, 5791, '\p{^Block=_-OGHAM}', "");
    Expect(0, 5791, '\P{Block=_-OGHAM}', "");
    Expect(1, 5791, '\P{^Block=_-OGHAM}', "");
    Expect(0, 5792, '\p{Block=_-OGHAM}', "");
    Expect(1, 5792, '\p{^Block=_-OGHAM}', "");
    Expect(1, 5792, '\P{Block=_-OGHAM}', "");
    Expect(0, 5792, '\P{^Block=_-OGHAM}', "");
    Error('\p{Blk=/a/	_OGHAM}');
    Error('\P{Blk=/a/	_OGHAM}');
    Expect(1, 5791, '\p{Blk=:\AOgham\z:}', "");;
    Expect(0, 5792, '\p{Blk=:\AOgham\z:}', "");;
    Expect(1, 5791, '\p{Blk: ogham}', "");
    Expect(0, 5791, '\p{^Blk: ogham}', "");
    Expect(0, 5791, '\P{Blk: ogham}', "");
    Expect(1, 5791, '\P{^Blk: ogham}', "");
    Expect(0, 5792, '\p{Blk: ogham}', "");
    Expect(1, 5792, '\p{^Blk: ogham}', "");
    Expect(1, 5792, '\P{Blk: ogham}', "");
    Expect(0, 5792, '\P{^Blk: ogham}', "");
    Expect(1, 5791, '\p{Blk=:\Aogham\z:}', "");;
    Expect(0, 5792, '\p{Blk=:\Aogham\z:}', "");;
    Expect(1, 5791, '\p{Blk=__Ogham}', "");
    Expect(0, 5791, '\p{^Blk=__Ogham}', "");
    Expect(0, 5791, '\P{Blk=__Ogham}', "");
    Expect(1, 5791, '\P{^Blk=__Ogham}', "");
    Expect(0, 5792, '\p{Blk=__Ogham}', "");
    Expect(1, 5792, '\p{^Blk=__Ogham}', "");
    Expect(1, 5792, '\P{Blk=__Ogham}', "");
    Expect(0, 5792, '\P{^Blk=__Ogham}', "");
    Error('\p{Is_Block=-	Ogham:=}');
    Error('\P{Is_Block=-	Ogham:=}');
    Expect(1, 5791, '\p{Is_Block=ogham}', "");
    Expect(0, 5791, '\p{^Is_Block=ogham}', "");
    Expect(0, 5791, '\P{Is_Block=ogham}', "");
    Expect(1, 5791, '\P{^Is_Block=ogham}', "");
    Expect(0, 5792, '\p{Is_Block=ogham}', "");
    Expect(1, 5792, '\p{^Is_Block=ogham}', "");
    Expect(1, 5792, '\P{Is_Block=ogham}', "");
    Expect(0, 5792, '\P{^Is_Block=ogham}', "");
    Expect(1, 5791, '\p{Is_Block=		Ogham}', "");
    Expect(0, 5791, '\p{^Is_Block=		Ogham}', "");
    Expect(0, 5791, '\P{Is_Block=		Ogham}', "");
    Expect(1, 5791, '\P{^Is_Block=		Ogham}', "");
    Expect(0, 5792, '\p{Is_Block=		Ogham}', "");
    Expect(1, 5792, '\p{^Is_Block=		Ogham}', "");
    Expect(1, 5792, '\P{Is_Block=		Ogham}', "");
    Expect(0, 5792, '\P{^Is_Block=		Ogham}', "");
    Error('\p{Is_Blk= Ogham/a/}');
    Error('\P{Is_Blk= Ogham/a/}');
    Expect(1, 5791, '\p{Is_Blk=ogham}', "");
    Expect(0, 5791, '\p{^Is_Blk=ogham}', "");
    Expect(0, 5791, '\P{Is_Blk=ogham}', "");
    Expect(1, 5791, '\P{^Is_Blk=ogham}', "");
    Expect(0, 5792, '\p{Is_Blk=ogham}', "");
    Expect(1, 5792, '\p{^Is_Blk=ogham}', "");
    Expect(1, 5792, '\P{Is_Blk=ogham}', "");
    Expect(0, 5792, '\P{^Is_Blk=ogham}', "");
    Expect(1, 5791, '\p{Is_Blk: -Ogham}', "");
    Expect(0, 5791, '\p{^Is_Blk: -Ogham}', "");
    Expect(0, 5791, '\P{Is_Blk: -Ogham}', "");
    Expect(1, 5791, '\P{^Is_Blk: -Ogham}', "");
    Expect(0, 5792, '\p{Is_Blk: -Ogham}', "");
    Expect(1, 5792, '\p{^Is_Blk: -Ogham}', "");
    Expect(1, 5792, '\P{Is_Blk: -Ogham}', "");
    Expect(0, 5792, '\P{^Is_Blk: -Ogham}', "");
    Error('\p{Block:	:=	OL_Chiki}');
    Error('\P{Block:	:=	OL_Chiki}');
    Expect(1, 7295, '\p{Block=:\AOl_Chiki\z:}', "");;
    Expect(0, 7296, '\p{Block=:\AOl_Chiki\z:}', "");;
    Expect(1, 7295, '\p{Block=olchiki}', "");
    Expect(0, 7295, '\p{^Block=olchiki}', "");
    Expect(0, 7295, '\P{Block=olchiki}', "");
    Expect(1, 7295, '\P{^Block=olchiki}', "");
    Expect(0, 7296, '\p{Block=olchiki}', "");
    Expect(1, 7296, '\p{^Block=olchiki}', "");
    Expect(1, 7296, '\P{Block=olchiki}', "");
    Expect(0, 7296, '\P{^Block=olchiki}', "");
    Expect(1, 7295, '\p{Block=:\Aolchiki\z:}', "");;
    Expect(0, 7296, '\p{Block=:\Aolchiki\z:}', "");;
    Expect(1, 7295, '\p{Block=	 Ol_chiki}', "");
    Expect(0, 7295, '\p{^Block=	 Ol_chiki}', "");
    Expect(0, 7295, '\P{Block=	 Ol_chiki}', "");
    Expect(1, 7295, '\P{^Block=	 Ol_chiki}', "");
    Expect(0, 7296, '\p{Block=	 Ol_chiki}', "");
    Expect(1, 7296, '\p{^Block=	 Ol_chiki}', "");
    Expect(1, 7296, '\P{Block=	 Ol_chiki}', "");
    Expect(0, 7296, '\P{^Block=	 Ol_chiki}', "");
    Error('\p{Blk=:=ol_Chiki}');
    Error('\P{Blk=:=ol_Chiki}');
    Expect(1, 7295, '\p{Blk=:\AOl_Chiki\z:}', "");;
    Expect(0, 7296, '\p{Blk=:\AOl_Chiki\z:}', "");;
    Expect(1, 7295, '\p{Blk=olchiki}', "");
    Expect(0, 7295, '\p{^Blk=olchiki}', "");
    Expect(0, 7295, '\P{Blk=olchiki}', "");
    Expect(1, 7295, '\P{^Blk=olchiki}', "");
    Expect(0, 7296, '\p{Blk=olchiki}', "");
    Expect(1, 7296, '\p{^Blk=olchiki}', "");
    Expect(1, 7296, '\P{Blk=olchiki}', "");
    Expect(0, 7296, '\P{^Blk=olchiki}', "");
    Expect(1, 7295, '\p{Blk=:\Aolchiki\z:}', "");;
    Expect(0, 7296, '\p{Blk=:\Aolchiki\z:}', "");;
    Expect(1, 7295, '\p{Blk:_-OL_chiki}', "");
    Expect(0, 7295, '\p{^Blk:_-OL_chiki}', "");
    Expect(0, 7295, '\P{Blk:_-OL_chiki}', "");
    Expect(1, 7295, '\P{^Blk:_-OL_chiki}', "");
    Expect(0, 7296, '\p{Blk:_-OL_chiki}', "");
    Expect(1, 7296, '\p{^Blk:_-OL_chiki}', "");
    Expect(1, 7296, '\P{Blk:_-OL_chiki}', "");
    Expect(0, 7296, '\P{^Blk:_-OL_chiki}', "");
    Error('\p{Is_Block=:=_-Ol_chiki}');
    Error('\P{Is_Block=:=_-Ol_chiki}');
    Expect(1, 7295, '\p{Is_Block=olchiki}', "");
    Expect(0, 7295, '\p{^Is_Block=olchiki}', "");
    Expect(0, 7295, '\P{Is_Block=olchiki}', "");
    Expect(1, 7295, '\P{^Is_Block=olchiki}', "");
    Expect(0, 7296, '\p{Is_Block=olchiki}', "");
    Expect(1, 7296, '\p{^Is_Block=olchiki}', "");
    Expect(1, 7296, '\P{Is_Block=olchiki}', "");
    Expect(0, 7296, '\P{^Is_Block=olchiki}', "");
    Expect(1, 7295, '\p{Is_Block= -ol_CHIKI}', "");
    Expect(0, 7295, '\p{^Is_Block= -ol_CHIKI}', "");
    Expect(0, 7295, '\P{Is_Block= -ol_CHIKI}', "");
    Expect(1, 7295, '\P{^Is_Block= -ol_CHIKI}', "");
    Expect(0, 7296, '\p{Is_Block= -ol_CHIKI}', "");
    Expect(1, 7296, '\p{^Is_Block= -ol_CHIKI}', "");
    Expect(1, 7296, '\P{Is_Block= -ol_CHIKI}', "");
    Expect(0, 7296, '\P{^Is_Block= -ol_CHIKI}', "");
    Error('\p{Is_Blk=-/a/Ol_chiki}');
    Error('\P{Is_Blk=-/a/Ol_chiki}');
    Expect(1, 7295, '\p{Is_Blk=olchiki}', "");
    Expect(0, 7295, '\p{^Is_Blk=olchiki}', "");
    Expect(0, 7295, '\P{Is_Blk=olchiki}', "");
    Expect(1, 7295, '\P{^Is_Blk=olchiki}', "");
    Expect(0, 7296, '\p{Is_Blk=olchiki}', "");
    Expect(1, 7296, '\p{^Is_Blk=olchiki}', "");
    Expect(1, 7296, '\P{Is_Blk=olchiki}', "");
    Expect(0, 7296, '\P{^Is_Blk=olchiki}', "");
    Expect(1, 7295, '\p{Is_Blk=_Ol_CHIKI}', "");
    Expect(0, 7295, '\p{^Is_Blk=_Ol_CHIKI}', "");
    Expect(0, 7295, '\P{Is_Blk=_Ol_CHIKI}', "");
    Expect(1, 7295, '\P{^Is_Blk=_Ol_CHIKI}', "");
    Expect(0, 7296, '\p{Is_Blk=_Ol_CHIKI}', "");
    Expect(1, 7296, '\p{^Is_Blk=_Ol_CHIKI}', "");
    Expect(1, 7296, '\P{Is_Blk=_Ol_CHIKI}', "");
    Expect(0, 7296, '\P{^Is_Blk=_Ol_CHIKI}', "");
    Error('\p{Block=/a/_-old_Hungarian}');
    Error('\P{Block=/a/_-old_Hungarian}');
    Expect(1, 68863, '\p{Block=:\AOld_Hungarian\z:}', "");;
    Expect(0, 68864, '\p{Block=:\AOld_Hungarian\z:}', "");;
    Expect(1, 68863, '\p{Block=oldhungarian}', "");
    Expect(0, 68863, '\p{^Block=oldhungarian}', "");
    Expect(0, 68863, '\P{Block=oldhungarian}', "");
    Expect(1, 68863, '\P{^Block=oldhungarian}', "");
    Expect(0, 68864, '\p{Block=oldhungarian}', "");
    Expect(1, 68864, '\p{^Block=oldhungarian}', "");
    Expect(1, 68864, '\P{Block=oldhungarian}', "");
    Expect(0, 68864, '\P{^Block=oldhungarian}', "");
    Expect(1, 68863, '\p{Block=:\Aoldhungarian\z:}', "");;
    Expect(0, 68864, '\p{Block=:\Aoldhungarian\z:}', "");;
    Expect(1, 68863, '\p{Block=_Old_Hungarian}', "");
    Expect(0, 68863, '\p{^Block=_Old_Hungarian}', "");
    Expect(0, 68863, '\P{Block=_Old_Hungarian}', "");
    Expect(1, 68863, '\P{^Block=_Old_Hungarian}', "");
    Expect(0, 68864, '\p{Block=_Old_Hungarian}', "");
    Expect(1, 68864, '\p{^Block=_Old_Hungarian}', "");
    Expect(1, 68864, '\P{Block=_Old_Hungarian}', "");
    Expect(0, 68864, '\P{^Block=_Old_Hungarian}', "");
    Error('\p{Blk=/a/_ old_hungarian}');
    Error('\P{Blk=/a/_ old_hungarian}');
    Expect(1, 68863, '\p{Blk=:\AOld_Hungarian\z:}', "");;
    Expect(0, 68864, '\p{Blk=:\AOld_Hungarian\z:}', "");;
    Expect(1, 68863, '\p{Blk=oldhungarian}', "");
    Expect(0, 68863, '\p{^Blk=oldhungarian}', "");
    Expect(0, 68863, '\P{Blk=oldhungarian}', "");
    Expect(1, 68863, '\P{^Blk=oldhungarian}', "");
    Expect(0, 68864, '\p{Blk=oldhungarian}', "");
    Expect(1, 68864, '\p{^Blk=oldhungarian}', "");
    Expect(1, 68864, '\P{Blk=oldhungarian}', "");
    Expect(0, 68864, '\P{^Blk=oldhungarian}', "");
    Expect(1, 68863, '\p{Blk=:\Aoldhungarian\z:}', "");;
    Expect(0, 68864, '\p{Blk=:\Aoldhungarian\z:}', "");;
    Expect(1, 68863, '\p{Blk=	Old_Hungarian}', "");
    Expect(0, 68863, '\p{^Blk=	Old_Hungarian}', "");
    Expect(0, 68863, '\P{Blk=	Old_Hungarian}', "");
    Expect(1, 68863, '\P{^Blk=	Old_Hungarian}', "");
    Expect(0, 68864, '\p{Blk=	Old_Hungarian}', "");
    Expect(1, 68864, '\p{^Blk=	Old_Hungarian}', "");
    Expect(1, 68864, '\P{Blk=	Old_Hungarian}', "");
    Expect(0, 68864, '\P{^Blk=	Old_Hungarian}', "");
    Error('\p{Is_Block=/a/	old_Hungarian}');
    Error('\P{Is_Block=/a/	old_Hungarian}');
    Expect(1, 68863, '\p{Is_Block=oldhungarian}', "");
    Expect(0, 68863, '\p{^Is_Block=oldhungarian}', "");
    Expect(0, 68863, '\P{Is_Block=oldhungarian}', "");
    Expect(1, 68863, '\P{^Is_Block=oldhungarian}', "");
    Expect(0, 68864, '\p{Is_Block=oldhungarian}', "");
    Expect(1, 68864, '\p{^Is_Block=oldhungarian}', "");
    Expect(1, 68864, '\P{Is_Block=oldhungarian}', "");
    Expect(0, 68864, '\P{^Is_Block=oldhungarian}', "");
    Expect(1, 68863, '\p{Is_Block=_OLD_hungarian}', "");
    Expect(0, 68863, '\p{^Is_Block=_OLD_hungarian}', "");
    Expect(0, 68863, '\P{Is_Block=_OLD_hungarian}', "");
    Expect(1, 68863, '\P{^Is_Block=_OLD_hungarian}', "");
    Expect(0, 68864, '\p{Is_Block=_OLD_hungarian}', "");
    Expect(1, 68864, '\p{^Is_Block=_OLD_hungarian}', "");
    Expect(1, 68864, '\P{Is_Block=_OLD_hungarian}', "");
    Expect(0, 68864, '\P{^Is_Block=_OLD_hungarian}', "");
    Error('\p{Is_Blk:	/a/- OLD_hungarian}');
    Error('\P{Is_Blk:	/a/- OLD_hungarian}');
    Expect(1, 68863, '\p{Is_Blk=oldhungarian}', "");
    Expect(0, 68863, '\p{^Is_Blk=oldhungarian}', "");
    Expect(0, 68863, '\P{Is_Blk=oldhungarian}', "");
    Expect(1, 68863, '\P{^Is_Blk=oldhungarian}', "");
    Expect(0, 68864, '\p{Is_Blk=oldhungarian}', "");
    Expect(1, 68864, '\p{^Is_Blk=oldhungarian}', "");
    Expect(1, 68864, '\P{Is_Blk=oldhungarian}', "");
    Expect(0, 68864, '\P{^Is_Blk=oldhungarian}', "");
    Expect(1, 68863, '\p{Is_Blk=-_Old_Hungarian}', "");
    Expect(0, 68863, '\p{^Is_Blk=-_Old_Hungarian}', "");
    Expect(0, 68863, '\P{Is_Blk=-_Old_Hungarian}', "");
    Expect(1, 68863, '\P{^Is_Blk=-_Old_Hungarian}', "");
    Expect(0, 68864, '\p{Is_Blk=-_Old_Hungarian}', "");
    Expect(1, 68864, '\p{^Is_Blk=-_Old_Hungarian}', "");
    Expect(1, 68864, '\P{Is_Blk=-_Old_Hungarian}', "");
    Expect(0, 68864, '\P{^Is_Blk=-_Old_Hungarian}', "");
    Error('\p{Block=:=		old_ITALIC}');
    Error('\P{Block=:=		old_ITALIC}');
    Expect(1, 66351, '\p{Block=:\AOld_Italic\z:}', "");;
    Expect(0, 66352, '\p{Block=:\AOld_Italic\z:}', "");;
    Expect(1, 66351, '\p{Block=olditalic}', "");
    Expect(0, 66351, '\p{^Block=olditalic}', "");
    Expect(0, 66351, '\P{Block=olditalic}', "");
    Expect(1, 66351, '\P{^Block=olditalic}', "");
    Expect(0, 66352, '\p{Block=olditalic}', "");
    Expect(1, 66352, '\p{^Block=olditalic}', "");
    Expect(1, 66352, '\P{Block=olditalic}', "");
    Expect(0, 66352, '\P{^Block=olditalic}', "");
    Expect(1, 66351, '\p{Block=:\Aolditalic\z:}', "");;
    Expect(0, 66352, '\p{Block=:\Aolditalic\z:}', "");;
    Expect(1, 66351, '\p{Block=_ Old_Italic}', "");
    Expect(0, 66351, '\p{^Block=_ Old_Italic}', "");
    Expect(0, 66351, '\P{Block=_ Old_Italic}', "");
    Expect(1, 66351, '\P{^Block=_ Old_Italic}', "");
    Expect(0, 66352, '\p{Block=_ Old_Italic}', "");
    Expect(1, 66352, '\p{^Block=_ Old_Italic}', "");
    Expect(1, 66352, '\P{Block=_ Old_Italic}', "");
    Expect(0, 66352, '\P{^Block=_ Old_Italic}', "");
    Error('\p{Blk= :=OLD_Italic}');
    Error('\P{Blk= :=OLD_Italic}');
    Expect(1, 66351, '\p{Blk=:\AOld_Italic\z:}', "");;
    Expect(0, 66352, '\p{Blk=:\AOld_Italic\z:}', "");;
    Expect(1, 66351, '\p{Blk=olditalic}', "");
    Expect(0, 66351, '\p{^Blk=olditalic}', "");
    Expect(0, 66351, '\P{Blk=olditalic}', "");
    Expect(1, 66351, '\P{^Blk=olditalic}', "");
    Expect(0, 66352, '\p{Blk=olditalic}', "");
    Expect(1, 66352, '\p{^Blk=olditalic}', "");
    Expect(1, 66352, '\P{Blk=olditalic}', "");
    Expect(0, 66352, '\P{^Blk=olditalic}', "");
    Expect(1, 66351, '\p{Blk=:\Aolditalic\z:}', "");;
    Expect(0, 66352, '\p{Blk=:\Aolditalic\z:}', "");;
    Expect(1, 66351, '\p{Blk=--Old_Italic}', "");
    Expect(0, 66351, '\p{^Blk=--Old_Italic}', "");
    Expect(0, 66351, '\P{Blk=--Old_Italic}', "");
    Expect(1, 66351, '\P{^Blk=--Old_Italic}', "");
    Expect(0, 66352, '\p{Blk=--Old_Italic}', "");
    Expect(1, 66352, '\p{^Blk=--Old_Italic}', "");
    Expect(1, 66352, '\P{Blk=--Old_Italic}', "");
    Expect(0, 66352, '\P{^Blk=--Old_Italic}', "");
    Error('\p{Is_Block=	/a/Old_italic}');
    Error('\P{Is_Block=	/a/Old_italic}');
    Expect(1, 66351, '\p{Is_Block=olditalic}', "");
    Expect(0, 66351, '\p{^Is_Block=olditalic}', "");
    Expect(0, 66351, '\P{Is_Block=olditalic}', "");
    Expect(1, 66351, '\P{^Is_Block=olditalic}', "");
    Expect(0, 66352, '\p{Is_Block=olditalic}', "");
    Expect(1, 66352, '\p{^Is_Block=olditalic}', "");
    Expect(1, 66352, '\P{Is_Block=olditalic}', "");
    Expect(0, 66352, '\P{^Is_Block=olditalic}', "");
    Expect(1, 66351, '\p{Is_Block=-Old_Italic}', "");
    Expect(0, 66351, '\p{^Is_Block=-Old_Italic}', "");
    Expect(0, 66351, '\P{Is_Block=-Old_Italic}', "");
    Expect(1, 66351, '\P{^Is_Block=-Old_Italic}', "");
    Expect(0, 66352, '\p{Is_Block=-Old_Italic}', "");
    Expect(1, 66352, '\p{^Is_Block=-Old_Italic}', "");
    Expect(1, 66352, '\P{Is_Block=-Old_Italic}', "");
    Expect(0, 66352, '\P{^Is_Block=-Old_Italic}', "");
    Error('\p{Is_Blk=--Old_Italic/a/}');
    Error('\P{Is_Blk=--Old_Italic/a/}');
    Expect(1, 66351, '\p{Is_Blk=olditalic}', "");
    Expect(0, 66351, '\p{^Is_Blk=olditalic}', "");
    Expect(0, 66351, '\P{Is_Blk=olditalic}', "");
    Expect(1, 66351, '\P{^Is_Blk=olditalic}', "");
    Expect(0, 66352, '\p{Is_Blk=olditalic}', "");
    Expect(1, 66352, '\p{^Is_Blk=olditalic}', "");
    Expect(1, 66352, '\P{Is_Blk=olditalic}', "");
    Expect(0, 66352, '\P{^Is_Blk=olditalic}', "");
    Expect(1, 66351, '\p{Is_Blk=	Old_Italic}', "");
    Expect(0, 66351, '\p{^Is_Blk=	Old_Italic}', "");
    Expect(0, 66351, '\P{Is_Blk=	Old_Italic}', "");
    Expect(1, 66351, '\P{^Is_Blk=	Old_Italic}', "");
    Expect(0, 66352, '\p{Is_Blk=	Old_Italic}', "");
    Expect(1, 66352, '\p{^Is_Blk=	Old_Italic}', "");
    Expect(1, 66352, '\P{Is_Blk=	Old_Italic}', "");
    Expect(0, 66352, '\P{^Is_Blk=	Old_Italic}', "");
    Error('\p{Block=:=	OLD_North_arabian}');
    Error('\P{Block=:=	OLD_North_arabian}');
    Expect(1, 68255, '\p{Block=:\AOld_North_Arabian\z:}', "");;
    Expect(0, 68256, '\p{Block=:\AOld_North_Arabian\z:}', "");;
    Expect(1, 68255, '\p{Block=oldnortharabian}', "");
    Expect(0, 68255, '\p{^Block=oldnortharabian}', "");
    Expect(0, 68255, '\P{Block=oldnortharabian}', "");
    Expect(1, 68255, '\P{^Block=oldnortharabian}', "");
    Expect(0, 68256, '\p{Block=oldnortharabian}', "");
    Expect(1, 68256, '\p{^Block=oldnortharabian}', "");
    Expect(1, 68256, '\P{Block=oldnortharabian}', "");
    Expect(0, 68256, '\P{^Block=oldnortharabian}', "");
    Expect(1, 68255, '\p{Block=:\Aoldnortharabian\z:}', "");;
    Expect(0, 68256, '\p{Block=:\Aoldnortharabian\z:}', "");;
    Expect(1, 68255, '\p{Block=	 old_North_Arabian}', "");
    Expect(0, 68255, '\p{^Block=	 old_North_Arabian}', "");
    Expect(0, 68255, '\P{Block=	 old_North_Arabian}', "");
    Expect(1, 68255, '\P{^Block=	 old_North_Arabian}', "");
    Expect(0, 68256, '\p{Block=	 old_North_Arabian}', "");
    Expect(1, 68256, '\p{^Block=	 old_North_Arabian}', "");
    Expect(1, 68256, '\P{Block=	 old_North_Arabian}', "");
    Expect(0, 68256, '\P{^Block=	 old_North_Arabian}', "");
    Error('\p{Blk=_old_North_Arabian/a/}');
    Error('\P{Blk=_old_North_Arabian/a/}');
    Expect(1, 68255, '\p{Blk=:\AOld_North_Arabian\z:}', "");;
    Expect(0, 68256, '\p{Blk=:\AOld_North_Arabian\z:}', "");;
    Expect(1, 68255, '\p{Blk=oldnortharabian}', "");
    Expect(0, 68255, '\p{^Blk=oldnortharabian}', "");
    Expect(0, 68255, '\P{Blk=oldnortharabian}', "");
    Expect(1, 68255, '\P{^Blk=oldnortharabian}', "");
    Expect(0, 68256, '\p{Blk=oldnortharabian}', "");
    Expect(1, 68256, '\p{^Blk=oldnortharabian}', "");
    Expect(1, 68256, '\P{Blk=oldnortharabian}', "");
    Expect(0, 68256, '\P{^Blk=oldnortharabian}', "");
    Expect(1, 68255, '\p{Blk=:\Aoldnortharabian\z:}', "");;
    Expect(0, 68256, '\p{Blk=:\Aoldnortharabian\z:}', "");;
    Expect(1, 68255, '\p{Blk=_	Old_NORTH_Arabian}', "");
    Expect(0, 68255, '\p{^Blk=_	Old_NORTH_Arabian}', "");
    Expect(0, 68255, '\P{Blk=_	Old_NORTH_Arabian}', "");
    Expect(1, 68255, '\P{^Blk=_	Old_NORTH_Arabian}', "");
    Expect(0, 68256, '\p{Blk=_	Old_NORTH_Arabian}', "");
    Expect(1, 68256, '\p{^Blk=_	Old_NORTH_Arabian}', "");
    Expect(1, 68256, '\P{Blk=_	Old_NORTH_Arabian}', "");
    Expect(0, 68256, '\P{^Blk=_	Old_NORTH_Arabian}', "");
    Error('\p{Is_Block=_ Old_North_Arabian:=}');
    Error('\P{Is_Block=_ Old_North_Arabian:=}');
    Expect(1, 68255, '\p{Is_Block:	oldnortharabian}', "");
    Expect(0, 68255, '\p{^Is_Block:	oldnortharabian}', "");
    Expect(0, 68255, '\P{Is_Block:	oldnortharabian}', "");
    Expect(1, 68255, '\P{^Is_Block:	oldnortharabian}', "");
    Expect(0, 68256, '\p{Is_Block:	oldnortharabian}', "");
    Expect(1, 68256, '\p{^Is_Block:	oldnortharabian}', "");
    Expect(1, 68256, '\P{Is_Block:	oldnortharabian}', "");
    Expect(0, 68256, '\P{^Is_Block:	oldnortharabian}', "");
    Expect(1, 68255, '\p{Is_Block= 	Old_North_Arabian}', "");
    Expect(0, 68255, '\p{^Is_Block= 	Old_North_Arabian}', "");
    Expect(0, 68255, '\P{Is_Block= 	Old_North_Arabian}', "");
    Expect(1, 68255, '\P{^Is_Block= 	Old_North_Arabian}', "");
    Expect(0, 68256, '\p{Is_Block= 	Old_North_Arabian}', "");
    Expect(1, 68256, '\p{^Is_Block= 	Old_North_Arabian}', "");
    Expect(1, 68256, '\P{Is_Block= 	Old_North_Arabian}', "");
    Expect(0, 68256, '\P{^Is_Block= 	Old_North_Arabian}', "");
    Error('\p{Is_Blk=:=_-old_north_Arabian}');
    Error('\P{Is_Blk=:=_-old_north_Arabian}');
    Expect(1, 68255, '\p{Is_Blk=oldnortharabian}', "");
    Expect(0, 68255, '\p{^Is_Blk=oldnortharabian}', "");
    Expect(0, 68255, '\P{Is_Blk=oldnortharabian}', "");
    Expect(1, 68255, '\P{^Is_Blk=oldnortharabian}', "");
    Expect(0, 68256, '\p{Is_Blk=oldnortharabian}', "");
    Expect(1, 68256, '\p{^Is_Blk=oldnortharabian}', "");
    Expect(1, 68256, '\P{Is_Blk=oldnortharabian}', "");
    Expect(0, 68256, '\P{^Is_Blk=oldnortharabian}', "");
    Expect(1, 68255, '\p{Is_Blk:    -Old_north_Arabian}', "");
    Expect(0, 68255, '\p{^Is_Blk:    -Old_north_Arabian}', "");
    Expect(0, 68255, '\P{Is_Blk:    -Old_north_Arabian}', "");
    Expect(1, 68255, '\P{^Is_Blk:    -Old_north_Arabian}', "");
    Expect(0, 68256, '\p{Is_Blk:    -Old_north_Arabian}', "");
    Expect(1, 68256, '\p{^Is_Blk:    -Old_north_Arabian}', "");
    Expect(1, 68256, '\P{Is_Blk:    -Old_north_Arabian}', "");
    Expect(0, 68256, '\P{^Is_Blk:    -Old_north_Arabian}', "");
    Error('\p{Block=	-OLD_Permic:=}');
    Error('\P{Block=	-OLD_Permic:=}');
    Expect(1, 66431, '\p{Block=:\AOld_Permic\z:}', "");;
    Expect(0, 66432, '\p{Block=:\AOld_Permic\z:}', "");;
    Expect(1, 66431, '\p{Block:   oldpermic}', "");
    Expect(0, 66431, '\p{^Block:   oldpermic}', "");
    Expect(0, 66431, '\P{Block:   oldpermic}', "");
    Expect(1, 66431, '\P{^Block:   oldpermic}', "");
    Expect(0, 66432, '\p{Block:   oldpermic}', "");
    Expect(1, 66432, '\p{^Block:   oldpermic}', "");
    Expect(1, 66432, '\P{Block:   oldpermic}', "");
    Expect(0, 66432, '\P{^Block:   oldpermic}', "");
    Expect(1, 66431, '\p{Block=:\Aoldpermic\z:}', "");;
    Expect(0, 66432, '\p{Block=:\Aoldpermic\z:}', "");;
    Expect(1, 66431, '\p{Block=	-OLD_Permic}', "");
    Expect(0, 66431, '\p{^Block=	-OLD_Permic}', "");
    Expect(0, 66431, '\P{Block=	-OLD_Permic}', "");
    Expect(1, 66431, '\P{^Block=	-OLD_Permic}', "");
    Expect(0, 66432, '\p{Block=	-OLD_Permic}', "");
    Expect(1, 66432, '\p{^Block=	-OLD_Permic}', "");
    Expect(1, 66432, '\P{Block=	-OLD_Permic}', "");
    Expect(0, 66432, '\P{^Block=	-OLD_Permic}', "");
    Error('\p{Blk=/a/_	Old_PERMIC}');
    Error('\P{Blk=/a/_	Old_PERMIC}');
    Expect(1, 66431, '\p{Blk=:\AOld_Permic\z:}', "");;
    Expect(0, 66432, '\p{Blk=:\AOld_Permic\z:}', "");;
    Expect(1, 66431, '\p{Blk=oldpermic}', "");
    Expect(0, 66431, '\p{^Blk=oldpermic}', "");
    Expect(0, 66431, '\P{Blk=oldpermic}', "");
    Expect(1, 66431, '\P{^Blk=oldpermic}', "");
    Expect(0, 66432, '\p{Blk=oldpermic}', "");
    Expect(1, 66432, '\p{^Blk=oldpermic}', "");
    Expect(1, 66432, '\P{Blk=oldpermic}', "");
    Expect(0, 66432, '\P{^Blk=oldpermic}', "");
    Expect(1, 66431, '\p{Blk=:\Aoldpermic\z:}', "");;
    Expect(0, 66432, '\p{Blk=:\Aoldpermic\z:}', "");;
    Expect(1, 66431, '\p{Blk=	_Old_Permic}', "");
    Expect(0, 66431, '\p{^Blk=	_Old_Permic}', "");
    Expect(0, 66431, '\P{Blk=	_Old_Permic}', "");
    Expect(1, 66431, '\P{^Blk=	_Old_Permic}', "");
    Expect(0, 66432, '\p{Blk=	_Old_Permic}', "");
    Expect(1, 66432, '\p{^Blk=	_Old_Permic}', "");
    Expect(1, 66432, '\P{Blk=	_Old_Permic}', "");
    Expect(0, 66432, '\P{^Blk=	_Old_Permic}', "");
    Error('\p{Is_Block=	 OLD_Permic/a/}');
    Error('\P{Is_Block=	 OLD_Permic/a/}');
    Expect(1, 66431, '\p{Is_Block=oldpermic}', "");
    Expect(0, 66431, '\p{^Is_Block=oldpermic}', "");
    Expect(0, 66431, '\P{Is_Block=oldpermic}', "");
    Expect(1, 66431, '\P{^Is_Block=oldpermic}', "");
    Expect(0, 66432, '\p{Is_Block=oldpermic}', "");
    Expect(1, 66432, '\p{^Is_Block=oldpermic}', "");
    Expect(1, 66432, '\P{Is_Block=oldpermic}', "");
    Expect(0, 66432, '\P{^Is_Block=oldpermic}', "");
    Expect(1, 66431, '\p{Is_Block=--Old_PERMIC}', "");
    Expect(0, 66431, '\p{^Is_Block=--Old_PERMIC}', "");
    Expect(0, 66431, '\P{Is_Block=--Old_PERMIC}', "");
    Expect(1, 66431, '\P{^Is_Block=--Old_PERMIC}', "");
    Expect(0, 66432, '\p{Is_Block=--Old_PERMIC}', "");
    Expect(1, 66432, '\p{^Is_Block=--Old_PERMIC}', "");
    Expect(1, 66432, '\P{Is_Block=--Old_PERMIC}', "");
    Expect(0, 66432, '\P{^Is_Block=--Old_PERMIC}', "");
    Error('\p{Is_Blk=-:=old_PERMIC}');
    Error('\P{Is_Blk=-:=old_PERMIC}');
    Expect(1, 66431, '\p{Is_Blk=oldpermic}', "");
    Expect(0, 66431, '\p{^Is_Blk=oldpermic}', "");
    Expect(0, 66431, '\P{Is_Blk=oldpermic}', "");
    Expect(1, 66431, '\P{^Is_Blk=oldpermic}', "");
    Expect(0, 66432, '\p{Is_Blk=oldpermic}', "");
    Expect(1, 66432, '\p{^Is_Blk=oldpermic}', "");
    Expect(1, 66432, '\P{Is_Blk=oldpermic}', "");
    Expect(0, 66432, '\P{^Is_Blk=oldpermic}', "");
    Expect(1, 66431, '\p{Is_Blk:   _old_Permic}', "");
    Expect(0, 66431, '\p{^Is_Blk:   _old_Permic}', "");
    Expect(0, 66431, '\P{Is_Blk:   _old_Permic}', "");
    Expect(1, 66431, '\P{^Is_Blk:   _old_Permic}', "");
    Expect(0, 66432, '\p{Is_Blk:   _old_Permic}', "");
    Expect(1, 66432, '\p{^Is_Blk:   _old_Permic}', "");
    Expect(1, 66432, '\P{Is_Blk:   _old_Permic}', "");
    Expect(0, 66432, '\P{^Is_Blk:   _old_Permic}', "");
    Error('\p{Block=	/a/old_Persian}');
    Error('\P{Block=	/a/old_Persian}');
    Expect(1, 66527, '\p{Block=:\AOld_Persian\z:}', "");;
    Expect(0, 66528, '\p{Block=:\AOld_Persian\z:}', "");;
    Expect(1, 66527, '\p{Block=oldpersian}', "");
    Expect(0, 66527, '\p{^Block=oldpersian}', "");
    Expect(0, 66527, '\P{Block=oldpersian}', "");
    Expect(1, 66527, '\P{^Block=oldpersian}', "");
    Expect(0, 66528, '\p{Block=oldpersian}', "");
    Expect(1, 66528, '\p{^Block=oldpersian}', "");
    Expect(1, 66528, '\P{Block=oldpersian}', "");
    Expect(0, 66528, '\P{^Block=oldpersian}', "");
    Expect(1, 66527, '\p{Block=:\Aoldpersian\z:}', "");;
    Expect(0, 66528, '\p{Block=:\Aoldpersian\z:}', "");;
    Expect(1, 66527, '\p{Block=_Old_PERSIAN}', "");
    Expect(0, 66527, '\p{^Block=_Old_PERSIAN}', "");
    Expect(0, 66527, '\P{Block=_Old_PERSIAN}', "");
    Expect(1, 66527, '\P{^Block=_Old_PERSIAN}', "");
    Expect(0, 66528, '\p{Block=_Old_PERSIAN}', "");
    Expect(1, 66528, '\p{^Block=_Old_PERSIAN}', "");
    Expect(1, 66528, '\P{Block=_Old_PERSIAN}', "");
    Expect(0, 66528, '\P{^Block=_Old_PERSIAN}', "");
    Error('\p{Blk=-:=Old_Persian}');
    Error('\P{Blk=-:=Old_Persian}');
    Expect(1, 66527, '\p{Blk=:\AOld_Persian\z:}', "");;
    Expect(0, 66528, '\p{Blk=:\AOld_Persian\z:}', "");;
    Expect(1, 66527, '\p{Blk=oldpersian}', "");
    Expect(0, 66527, '\p{^Blk=oldpersian}', "");
    Expect(0, 66527, '\P{Blk=oldpersian}', "");
    Expect(1, 66527, '\P{^Blk=oldpersian}', "");
    Expect(0, 66528, '\p{Blk=oldpersian}', "");
    Expect(1, 66528, '\p{^Blk=oldpersian}', "");
    Expect(1, 66528, '\P{Blk=oldpersian}', "");
    Expect(0, 66528, '\P{^Blk=oldpersian}', "");
    Expect(1, 66527, '\p{Blk=:\Aoldpersian\z:}', "");;
    Expect(0, 66528, '\p{Blk=:\Aoldpersian\z:}', "");;
    Expect(1, 66527, '\p{Blk=Old_Persian}', "");
    Expect(0, 66527, '\p{^Blk=Old_Persian}', "");
    Expect(0, 66527, '\P{Blk=Old_Persian}', "");
    Expect(1, 66527, '\P{^Blk=Old_Persian}', "");
    Expect(0, 66528, '\p{Blk=Old_Persian}', "");
    Expect(1, 66528, '\p{^Blk=Old_Persian}', "");
    Expect(1, 66528, '\P{Blk=Old_Persian}', "");
    Expect(0, 66528, '\P{^Blk=Old_Persian}', "");
    Error('\p{Is_Block=:=-_OLD_Persian}');
    Error('\P{Is_Block=:=-_OLD_Persian}');
    Expect(1, 66527, '\p{Is_Block=oldpersian}', "");
    Expect(0, 66527, '\p{^Is_Block=oldpersian}', "");
    Expect(0, 66527, '\P{Is_Block=oldpersian}', "");
    Expect(1, 66527, '\P{^Is_Block=oldpersian}', "");
    Expect(0, 66528, '\p{Is_Block=oldpersian}', "");
    Expect(1, 66528, '\p{^Is_Block=oldpersian}', "");
    Expect(1, 66528, '\P{Is_Block=oldpersian}', "");
    Expect(0, 66528, '\P{^Is_Block=oldpersian}', "");
    Expect(1, 66527, '\p{Is_Block=- old_PERSIAN}', "");
    Expect(0, 66527, '\p{^Is_Block=- old_PERSIAN}', "");
    Expect(0, 66527, '\P{Is_Block=- old_PERSIAN}', "");
    Expect(1, 66527, '\P{^Is_Block=- old_PERSIAN}', "");
    Expect(0, 66528, '\p{Is_Block=- old_PERSIAN}', "");
    Expect(1, 66528, '\p{^Is_Block=- old_PERSIAN}', "");
    Expect(1, 66528, '\P{Is_Block=- old_PERSIAN}', "");
    Expect(0, 66528, '\P{^Is_Block=- old_PERSIAN}', "");
    Error('\p{Is_Blk=:= 	Old_Persian}');
    Error('\P{Is_Blk=:= 	Old_Persian}');
    Expect(1, 66527, '\p{Is_Blk=oldpersian}', "");
    Expect(0, 66527, '\p{^Is_Blk=oldpersian}', "");
    Expect(0, 66527, '\P{Is_Blk=oldpersian}', "");
    Expect(1, 66527, '\P{^Is_Blk=oldpersian}', "");
    Expect(0, 66528, '\p{Is_Blk=oldpersian}', "");
    Expect(1, 66528, '\p{^Is_Blk=oldpersian}', "");
    Expect(1, 66528, '\P{Is_Blk=oldpersian}', "");
    Expect(0, 66528, '\P{^Is_Blk=oldpersian}', "");
    Expect(1, 66527, '\p{Is_Blk=_old_Persian}', "");
    Expect(0, 66527, '\p{^Is_Blk=_old_Persian}', "");
    Expect(0, 66527, '\P{Is_Blk=_old_Persian}', "");
    Expect(1, 66527, '\P{^Is_Blk=_old_Persian}', "");
    Expect(0, 66528, '\p{Is_Blk=_old_Persian}', "");
    Expect(1, 66528, '\p{^Is_Blk=_old_Persian}', "");
    Expect(1, 66528, '\P{Is_Blk=_old_Persian}', "");
    Expect(0, 66528, '\P{^Is_Blk=_old_Persian}', "");
    Error('\p{Block=/a/ _old_sogdian}');
    Error('\P{Block=/a/ _old_sogdian}');
    Expect(1, 69423, '\p{Block=:\AOld_Sogdian\z:}', "");;
    Expect(0, 69424, '\p{Block=:\AOld_Sogdian\z:}', "");;
    Expect(1, 69423, '\p{Block=oldsogdian}', "");
    Expect(0, 69423, '\p{^Block=oldsogdian}', "");
    Expect(0, 69423, '\P{Block=oldsogdian}', "");
    Expect(1, 69423, '\P{^Block=oldsogdian}', "");
    Expect(0, 69424, '\p{Block=oldsogdian}', "");
    Expect(1, 69424, '\p{^Block=oldsogdian}', "");
    Expect(1, 69424, '\P{Block=oldsogdian}', "");
    Expect(0, 69424, '\P{^Block=oldsogdian}', "");
    Expect(1, 69423, '\p{Block=:\Aoldsogdian\z:}', "");;
    Expect(0, 69424, '\p{Block=:\Aoldsogdian\z:}', "");;
    Expect(1, 69423, '\p{Block=	_OLD_SOGDIAN}', "");
    Expect(0, 69423, '\p{^Block=	_OLD_SOGDIAN}', "");
    Expect(0, 69423, '\P{Block=	_OLD_SOGDIAN}', "");
    Expect(1, 69423, '\P{^Block=	_OLD_SOGDIAN}', "");
    Expect(0, 69424, '\p{Block=	_OLD_SOGDIAN}', "");
    Expect(1, 69424, '\p{^Block=	_OLD_SOGDIAN}', "");
    Expect(1, 69424, '\P{Block=	_OLD_SOGDIAN}', "");
    Expect(0, 69424, '\P{^Block=	_OLD_SOGDIAN}', "");
    Error('\p{Blk=_/a/Old_Sogdian}');
    Error('\P{Blk=_/a/Old_Sogdian}');
    Expect(1, 69423, '\p{Blk=:\AOld_Sogdian\z:}', "");;
    Expect(0, 69424, '\p{Blk=:\AOld_Sogdian\z:}', "");;
    Expect(1, 69423, '\p{Blk=oldsogdian}', "");
    Expect(0, 69423, '\p{^Blk=oldsogdian}', "");
    Expect(0, 69423, '\P{Blk=oldsogdian}', "");
    Expect(1, 69423, '\P{^Blk=oldsogdian}', "");
    Expect(0, 69424, '\p{Blk=oldsogdian}', "");
    Expect(1, 69424, '\p{^Blk=oldsogdian}', "");
    Expect(1, 69424, '\P{Blk=oldsogdian}', "");
    Expect(0, 69424, '\P{^Blk=oldsogdian}', "");
    Expect(1, 69423, '\p{Blk=:\Aoldsogdian\z:}', "");;
    Expect(0, 69424, '\p{Blk=:\Aoldsogdian\z:}', "");;
    Expect(1, 69423, '\p{Blk=old_sogdian}', "");
    Expect(0, 69423, '\p{^Blk=old_sogdian}', "");
    Expect(0, 69423, '\P{Blk=old_sogdian}', "");
    Expect(1, 69423, '\P{^Blk=old_sogdian}', "");
    Expect(0, 69424, '\p{Blk=old_sogdian}', "");
    Expect(1, 69424, '\p{^Blk=old_sogdian}', "");
    Expect(1, 69424, '\P{Blk=old_sogdian}', "");
    Expect(0, 69424, '\P{^Blk=old_sogdian}', "");
    Error('\p{Is_Block= :=Old_sogdian}');
    Error('\P{Is_Block= :=Old_sogdian}');
    Expect(1, 69423, '\p{Is_Block=oldsogdian}', "");
    Expect(0, 69423, '\p{^Is_Block=oldsogdian}', "");
    Expect(0, 69423, '\P{Is_Block=oldsogdian}', "");
    Expect(1, 69423, '\P{^Is_Block=oldsogdian}', "");
    Expect(0, 69424, '\p{Is_Block=oldsogdian}', "");
    Expect(1, 69424, '\p{^Is_Block=oldsogdian}', "");
    Expect(1, 69424, '\P{Is_Block=oldsogdian}', "");
    Expect(0, 69424, '\P{^Is_Block=oldsogdian}', "");
    Expect(1, 69423, '\p{Is_Block=	_Old_sogdian}', "");
    Expect(0, 69423, '\p{^Is_Block=	_Old_sogdian}', "");
    Expect(0, 69423, '\P{Is_Block=	_Old_sogdian}', "");
    Expect(1, 69423, '\P{^Is_Block=	_Old_sogdian}', "");
    Expect(0, 69424, '\p{Is_Block=	_Old_sogdian}', "");
    Expect(1, 69424, '\p{^Is_Block=	_Old_sogdian}', "");
    Expect(1, 69424, '\P{Is_Block=	_Old_sogdian}', "");
    Expect(0, 69424, '\P{^Is_Block=	_Old_sogdian}', "");
    Error('\p{Is_Blk=_ OLD_sogdian:=}');
    Error('\P{Is_Blk=_ OLD_sogdian:=}');
    Expect(1, 69423, '\p{Is_Blk=oldsogdian}', "");
    Expect(0, 69423, '\p{^Is_Blk=oldsogdian}', "");
    Expect(0, 69423, '\P{Is_Blk=oldsogdian}', "");
    Expect(1, 69423, '\P{^Is_Blk=oldsogdian}', "");
    Expect(0, 69424, '\p{Is_Blk=oldsogdian}', "");
    Expect(1, 69424, '\p{^Is_Blk=oldsogdian}', "");
    Expect(1, 69424, '\P{Is_Blk=oldsogdian}', "");
    Expect(0, 69424, '\P{^Is_Blk=oldsogdian}', "");
    Expect(1, 69423, '\p{Is_Blk=-_Old_SOGDIAN}', "");
    Expect(0, 69423, '\p{^Is_Blk=-_Old_SOGDIAN}', "");
    Expect(0, 69423, '\P{Is_Blk=-_Old_SOGDIAN}', "");
    Expect(1, 69423, '\P{^Is_Blk=-_Old_SOGDIAN}', "");
    Expect(0, 69424, '\p{Is_Blk=-_Old_SOGDIAN}', "");
    Expect(1, 69424, '\p{^Is_Blk=-_Old_SOGDIAN}', "");
    Expect(1, 69424, '\P{Is_Blk=-_Old_SOGDIAN}', "");
    Expect(0, 69424, '\P{^Is_Blk=-_Old_SOGDIAN}', "");
    Error('\p{Block=-Old_South_Arabian:=}');
    Error('\P{Block=-Old_South_Arabian:=}');
    Expect(1, 68223, '\p{Block=:\AOld_South_Arabian\z:}', "");;
    Expect(0, 68224, '\p{Block=:\AOld_South_Arabian\z:}', "");;
    Expect(1, 68223, '\p{Block=oldsoutharabian}', "");
    Expect(0, 68223, '\p{^Block=oldsoutharabian}', "");
    Expect(0, 68223, '\P{Block=oldsoutharabian}', "");
    Expect(1, 68223, '\P{^Block=oldsoutharabian}', "");
    Expect(0, 68224, '\p{Block=oldsoutharabian}', "");
    Expect(1, 68224, '\p{^Block=oldsoutharabian}', "");
    Expect(1, 68224, '\P{Block=oldsoutharabian}', "");
    Expect(0, 68224, '\P{^Block=oldsoutharabian}', "");
    Expect(1, 68223, '\p{Block=:\Aoldsoutharabian\z:}', "");;
    Expect(0, 68224, '\p{Block=:\Aoldsoutharabian\z:}', "");;
    Expect(1, 68223, '\p{Block=		Old_South_Arabian}', "");
    Expect(0, 68223, '\p{^Block=		Old_South_Arabian}', "");
    Expect(0, 68223, '\P{Block=		Old_South_Arabian}', "");
    Expect(1, 68223, '\P{^Block=		Old_South_Arabian}', "");
    Expect(0, 68224, '\p{Block=		Old_South_Arabian}', "");
    Expect(1, 68224, '\p{^Block=		Old_South_Arabian}', "");
    Expect(1, 68224, '\P{Block=		Old_South_Arabian}', "");
    Expect(0, 68224, '\P{^Block=		Old_South_Arabian}', "");
    Error('\p{Blk=	/a/OLD_South_Arabian}');
    Error('\P{Blk=	/a/OLD_South_Arabian}');
    Expect(1, 68223, '\p{Blk=:\AOld_South_Arabian\z:}', "");;
    Expect(0, 68224, '\p{Blk=:\AOld_South_Arabian\z:}', "");;
    Expect(1, 68223, '\p{Blk:   oldsoutharabian}', "");
    Expect(0, 68223, '\p{^Blk:   oldsoutharabian}', "");
    Expect(0, 68223, '\P{Blk:   oldsoutharabian}', "");
    Expect(1, 68223, '\P{^Blk:   oldsoutharabian}', "");
    Expect(0, 68224, '\p{Blk:   oldsoutharabian}', "");
    Expect(1, 68224, '\p{^Blk:   oldsoutharabian}', "");
    Expect(1, 68224, '\P{Blk:   oldsoutharabian}', "");
    Expect(0, 68224, '\P{^Blk:   oldsoutharabian}', "");
    Expect(1, 68223, '\p{Blk=:\Aoldsoutharabian\z:}', "");;
    Expect(0, 68224, '\p{Blk=:\Aoldsoutharabian\z:}', "");;
    Expect(1, 68223, '\p{Blk=_Old_South_arabian}', "");
    Expect(0, 68223, '\p{^Blk=_Old_South_arabian}', "");
    Expect(0, 68223, '\P{Blk=_Old_South_arabian}', "");
    Expect(1, 68223, '\P{^Blk=_Old_South_arabian}', "");
    Expect(0, 68224, '\p{Blk=_Old_South_arabian}', "");
    Expect(1, 68224, '\p{^Blk=_Old_South_arabian}', "");
    Expect(1, 68224, '\P{Blk=_Old_South_arabian}', "");
    Expect(0, 68224, '\P{^Blk=_Old_South_arabian}', "");
    Error('\p{Is_Block= 	Old_South_ARABIAN/a/}');
    Error('\P{Is_Block= 	Old_South_ARABIAN/a/}');
    Expect(1, 68223, '\p{Is_Block=oldsoutharabian}', "");
    Expect(0, 68223, '\p{^Is_Block=oldsoutharabian}', "");
    Expect(0, 68223, '\P{Is_Block=oldsoutharabian}', "");
    Expect(1, 68223, '\P{^Is_Block=oldsoutharabian}', "");
    Expect(0, 68224, '\p{Is_Block=oldsoutharabian}', "");
    Expect(1, 68224, '\p{^Is_Block=oldsoutharabian}', "");
    Expect(1, 68224, '\P{Is_Block=oldsoutharabian}', "");
    Expect(0, 68224, '\P{^Is_Block=oldsoutharabian}', "");
    Expect(1, 68223, '\p{Is_Block=  Old_South_Arabian}', "");
    Expect(0, 68223, '\p{^Is_Block=  Old_South_Arabian}', "");
    Expect(0, 68223, '\P{Is_Block=  Old_South_Arabian}', "");
    Expect(1, 68223, '\P{^Is_Block=  Old_South_Arabian}', "");
    Expect(0, 68224, '\p{Is_Block=  Old_South_Arabian}', "");
    Expect(1, 68224, '\p{^Is_Block=  Old_South_Arabian}', "");
    Expect(1, 68224, '\P{Is_Block=  Old_South_Arabian}', "");
    Expect(0, 68224, '\P{^Is_Block=  Old_South_Arabian}', "");
    Error('\p{Is_Blk=:=  OLD_South_ARABIAN}');
    Error('\P{Is_Blk=:=  OLD_South_ARABIAN}');
    Expect(1, 68223, '\p{Is_Blk=oldsoutharabian}', "");
    Expect(0, 68223, '\p{^Is_Blk=oldsoutharabian}', "");
    Expect(0, 68223, '\P{Is_Blk=oldsoutharabian}', "");
    Expect(1, 68223, '\P{^Is_Blk=oldsoutharabian}', "");
    Expect(0, 68224, '\p{Is_Blk=oldsoutharabian}', "");
    Expect(1, 68224, '\p{^Is_Blk=oldsoutharabian}', "");
    Expect(1, 68224, '\P{Is_Blk=oldsoutharabian}', "");
    Expect(0, 68224, '\P{^Is_Blk=oldsoutharabian}', "");
    Expect(1, 68223, '\p{Is_Blk=_OLD_SOUTH_arabian}', "");
    Expect(0, 68223, '\p{^Is_Blk=_OLD_SOUTH_arabian}', "");
    Expect(0, 68223, '\P{Is_Blk=_OLD_SOUTH_arabian}', "");
    Expect(1, 68223, '\P{^Is_Blk=_OLD_SOUTH_arabian}', "");
    Expect(0, 68224, '\p{Is_Blk=_OLD_SOUTH_arabian}', "");
    Expect(1, 68224, '\p{^Is_Blk=_OLD_SOUTH_arabian}', "");
    Expect(1, 68224, '\P{Is_Blk=_OLD_SOUTH_arabian}', "");
    Expect(0, 68224, '\P{^Is_Blk=_OLD_SOUTH_arabian}', "");
    Error('\p{Block= _Old_Turkic:=}');
    Error('\P{Block= _Old_Turkic:=}');
    Expect(1, 68687, '\p{Block=:\AOld_Turkic\z:}', "");;
    Expect(0, 68688, '\p{Block=:\AOld_Turkic\z:}', "");;
    Expect(1, 68687, '\p{Block=oldturkic}', "");
    Expect(0, 68687, '\p{^Block=oldturkic}', "");
    Expect(0, 68687, '\P{Block=oldturkic}', "");
    Expect(1, 68687, '\P{^Block=oldturkic}', "");
    Expect(0, 68688, '\p{Block=oldturkic}', "");
    Expect(1, 68688, '\p{^Block=oldturkic}', "");
    Expect(1, 68688, '\P{Block=oldturkic}', "");
    Expect(0, 68688, '\P{^Block=oldturkic}', "");
    Expect(1, 68687, '\p{Block=:\Aoldturkic\z:}', "");;
    Expect(0, 68688, '\p{Block=:\Aoldturkic\z:}', "");;
    Expect(1, 68687, '\p{Block=Old_TURKIC}', "");
    Expect(0, 68687, '\p{^Block=Old_TURKIC}', "");
    Expect(0, 68687, '\P{Block=Old_TURKIC}', "");
    Expect(1, 68687, '\P{^Block=Old_TURKIC}', "");
    Expect(0, 68688, '\p{Block=Old_TURKIC}', "");
    Expect(1, 68688, '\p{^Block=Old_TURKIC}', "");
    Expect(1, 68688, '\P{Block=Old_TURKIC}', "");
    Expect(0, 68688, '\P{^Block=Old_TURKIC}', "");
    Error('\p{Blk=-/a/old_Turkic}');
    Error('\P{Blk=-/a/old_Turkic}');
    Expect(1, 68687, '\p{Blk=:\AOld_Turkic\z:}', "");;
    Expect(0, 68688, '\p{Blk=:\AOld_Turkic\z:}', "");;
    Expect(1, 68687, '\p{Blk: oldturkic}', "");
    Expect(0, 68687, '\p{^Blk: oldturkic}', "");
    Expect(0, 68687, '\P{Blk: oldturkic}', "");
    Expect(1, 68687, '\P{^Blk: oldturkic}', "");
    Expect(0, 68688, '\p{Blk: oldturkic}', "");
    Expect(1, 68688, '\p{^Blk: oldturkic}', "");
    Expect(1, 68688, '\P{Blk: oldturkic}', "");
    Expect(0, 68688, '\P{^Blk: oldturkic}', "");
    Expect(1, 68687, '\p{Blk=:\Aoldturkic\z:}', "");;
    Expect(0, 68688, '\p{Blk=:\Aoldturkic\z:}', "");;
    Expect(1, 68687, '\p{Blk=	-old_Turkic}', "");
    Expect(0, 68687, '\p{^Blk=	-old_Turkic}', "");
    Expect(0, 68687, '\P{Blk=	-old_Turkic}', "");
    Expect(1, 68687, '\P{^Blk=	-old_Turkic}', "");
    Expect(0, 68688, '\p{Blk=	-old_Turkic}', "");
    Expect(1, 68688, '\p{^Blk=	-old_Turkic}', "");
    Expect(1, 68688, '\P{Blk=	-old_Turkic}', "");
    Expect(0, 68688, '\P{^Blk=	-old_Turkic}', "");
    Error('\p{Is_Block=--OLD_Turkic:=}');
    Error('\P{Is_Block=--OLD_Turkic:=}');
    Expect(1, 68687, '\p{Is_Block=oldturkic}', "");
    Expect(0, 68687, '\p{^Is_Block=oldturkic}', "");
    Expect(0, 68687, '\P{Is_Block=oldturkic}', "");
    Expect(1, 68687, '\P{^Is_Block=oldturkic}', "");
    Expect(0, 68688, '\p{Is_Block=oldturkic}', "");
    Expect(1, 68688, '\p{^Is_Block=oldturkic}', "");
    Expect(1, 68688, '\P{Is_Block=oldturkic}', "");
    Expect(0, 68688, '\P{^Is_Block=oldturkic}', "");
    Expect(1, 68687, '\p{Is_Block=_	OLD_TURKIC}', "");
    Expect(0, 68687, '\p{^Is_Block=_	OLD_TURKIC}', "");
    Expect(0, 68687, '\P{Is_Block=_	OLD_TURKIC}', "");
    Expect(1, 68687, '\P{^Is_Block=_	OLD_TURKIC}', "");
    Expect(0, 68688, '\p{Is_Block=_	OLD_TURKIC}', "");
    Expect(1, 68688, '\p{^Is_Block=_	OLD_TURKIC}', "");
    Expect(1, 68688, '\P{Is_Block=_	OLD_TURKIC}', "");
    Expect(0, 68688, '\P{^Is_Block=_	OLD_TURKIC}', "");
    Error('\p{Is_Blk=-	Old_Turkic/a/}');
    Error('\P{Is_Blk=-	Old_Turkic/a/}');
    Expect(1, 68687, '\p{Is_Blk=oldturkic}', "");
    Expect(0, 68687, '\p{^Is_Blk=oldturkic}', "");
    Expect(0, 68687, '\P{Is_Blk=oldturkic}', "");
    Expect(1, 68687, '\P{^Is_Blk=oldturkic}', "");
    Expect(0, 68688, '\p{Is_Blk=oldturkic}', "");
    Expect(1, 68688, '\p{^Is_Blk=oldturkic}', "");
    Expect(1, 68688, '\P{Is_Blk=oldturkic}', "");
    Expect(0, 68688, '\P{^Is_Blk=oldturkic}', "");
    Expect(1, 68687, '\p{Is_Blk=-_Old_turkic}', "");
    Expect(0, 68687, '\p{^Is_Blk=-_Old_turkic}', "");
    Expect(0, 68687, '\P{Is_Blk=-_Old_turkic}', "");
    Expect(1, 68687, '\P{^Is_Blk=-_Old_turkic}', "");
    Expect(0, 68688, '\p{Is_Blk=-_Old_turkic}', "");
    Expect(1, 68688, '\p{^Is_Blk=-_Old_turkic}', "");
    Expect(1, 68688, '\P{Is_Blk=-_Old_turkic}', "");
    Expect(0, 68688, '\P{^Is_Blk=-_Old_turkic}', "");
    Error('\p{Block=-:=OLD_UYGHUR}');
    Error('\P{Block=-:=OLD_UYGHUR}');
    Expect(1, 69551, '\p{Block=:\AOld_Uyghur\z:}', "");;
    Expect(0, 69552, '\p{Block=:\AOld_Uyghur\z:}', "");;
    Expect(1, 69551, '\p{Block=olduyghur}', "");
    Expect(0, 69551, '\p{^Block=olduyghur}', "");
    Expect(0, 69551, '\P{Block=olduyghur}', "");
    Expect(1, 69551, '\P{^Block=olduyghur}', "");
    Expect(0, 69552, '\p{Block=olduyghur}', "");
    Expect(1, 69552, '\p{^Block=olduyghur}', "");
    Expect(1, 69552, '\P{Block=olduyghur}', "");
    Expect(0, 69552, '\P{^Block=olduyghur}', "");
    Expect(1, 69551, '\p{Block=:\Aolduyghur\z:}', "");;
    Expect(0, 69552, '\p{Block=:\Aolduyghur\z:}', "");;
    Expect(1, 69551, '\p{Block=--Old_Uyghur}', "");
    Expect(0, 69551, '\p{^Block=--Old_Uyghur}', "");
    Expect(0, 69551, '\P{Block=--Old_Uyghur}', "");
    Expect(1, 69551, '\P{^Block=--Old_Uyghur}', "");
    Expect(0, 69552, '\p{Block=--Old_Uyghur}', "");
    Expect(1, 69552, '\p{^Block=--Old_Uyghur}', "");
    Expect(1, 69552, '\P{Block=--Old_Uyghur}', "");
    Expect(0, 69552, '\P{^Block=--Old_Uyghur}', "");
    Error('\p{Blk=_:=Old_Uyghur}');
    Error('\P{Blk=_:=Old_Uyghur}');
    Expect(1, 69551, '\p{Blk=:\AOld_Uyghur\z:}', "");;
    Expect(0, 69552, '\p{Blk=:\AOld_Uyghur\z:}', "");;
    Expect(1, 69551, '\p{Blk=olduyghur}', "");
    Expect(0, 69551, '\p{^Blk=olduyghur}', "");
    Expect(0, 69551, '\P{Blk=olduyghur}', "");
    Expect(1, 69551, '\P{^Blk=olduyghur}', "");
    Expect(0, 69552, '\p{Blk=olduyghur}', "");
    Expect(1, 69552, '\p{^Blk=olduyghur}', "");
    Expect(1, 69552, '\P{Blk=olduyghur}', "");
    Expect(0, 69552, '\P{^Blk=olduyghur}', "");
    Expect(1, 69551, '\p{Blk=:\Aolduyghur\z:}', "");;
    Expect(0, 69552, '\p{Blk=:\Aolduyghur\z:}', "");;
    Expect(1, 69551, '\p{Blk=- Old_uyghur}', "");
    Expect(0, 69551, '\p{^Blk=- Old_uyghur}', "");
    Expect(0, 69551, '\P{Blk=- Old_uyghur}', "");
    Expect(1, 69551, '\P{^Blk=- Old_uyghur}', "");
    Expect(0, 69552, '\p{Blk=- Old_uyghur}', "");
    Expect(1, 69552, '\p{^Blk=- Old_uyghur}', "");
    Expect(1, 69552, '\P{Blk=- Old_uyghur}', "");
    Expect(0, 69552, '\P{^Blk=- Old_uyghur}', "");
    Error('\p{Is_Block=:=__Old_Uyghur}');
    Error('\P{Is_Block=:=__Old_Uyghur}');
    Expect(1, 69551, '\p{Is_Block=olduyghur}', "");
    Expect(0, 69551, '\p{^Is_Block=olduyghur}', "");
    Expect(0, 69551, '\P{Is_Block=olduyghur}', "");
    Expect(1, 69551, '\P{^Is_Block=olduyghur}', "");
    Expect(0, 69552, '\p{Is_Block=olduyghur}', "");
    Expect(1, 69552, '\p{^Is_Block=olduyghur}', "");
    Expect(1, 69552, '\P{Is_Block=olduyghur}', "");
    Expect(0, 69552, '\P{^Is_Block=olduyghur}', "");
    Expect(1, 69551, '\p{Is_Block=	Old_uyghur}', "");
    Expect(0, 69551, '\p{^Is_Block=	Old_uyghur}', "");
    Expect(0, 69551, '\P{Is_Block=	Old_uyghur}', "");
    Expect(1, 69551, '\P{^Is_Block=	Old_uyghur}', "");
    Expect(0, 69552, '\p{Is_Block=	Old_uyghur}', "");
    Expect(1, 69552, '\p{^Is_Block=	Old_uyghur}', "");
    Expect(1, 69552, '\P{Is_Block=	Old_uyghur}', "");
    Expect(0, 69552, '\P{^Is_Block=	Old_uyghur}', "");
    Error('\p{Is_Blk=/a/ _old_Uyghur}');
    Error('\P{Is_Blk=/a/ _old_Uyghur}');
    Expect(1, 69551, '\p{Is_Blk=olduyghur}', "");
    Expect(0, 69551, '\p{^Is_Blk=olduyghur}', "");
    Expect(0, 69551, '\P{Is_Blk=olduyghur}', "");
    Expect(1, 69551, '\P{^Is_Blk=olduyghur}', "");
    Expect(0, 69552, '\p{Is_Blk=olduyghur}', "");
    Expect(1, 69552, '\p{^Is_Blk=olduyghur}', "");
    Expect(1, 69552, '\P{Is_Blk=olduyghur}', "");
    Expect(0, 69552, '\P{^Is_Blk=olduyghur}', "");
    Expect(1, 69551, '\p{Is_Blk=_ Old_Uyghur}', "");
    Expect(0, 69551, '\p{^Is_Blk=_ Old_Uyghur}', "");
    Expect(0, 69551, '\P{Is_Blk=_ Old_Uyghur}', "");
    Expect(1, 69551, '\P{^Is_Blk=_ Old_Uyghur}', "");
    Expect(0, 69552, '\p{Is_Blk=_ Old_Uyghur}', "");
    Expect(1, 69552, '\p{^Is_Blk=_ Old_Uyghur}', "");
    Expect(1, 69552, '\P{Is_Blk=_ Old_Uyghur}', "");
    Expect(0, 69552, '\P{^Is_Blk=_ Old_Uyghur}', "");
    Error('\p{Block=oriya:=}');
    Error('\P{Block=oriya:=}');
    Expect(1, 2943, '\p{Block=:\AOriya\z:}', "");;
    Expect(0, 2944, '\p{Block=:\AOriya\z:}', "");;
    Expect(1, 2943, '\p{Block=oriya}', "");
    Expect(0, 2943, '\p{^Block=oriya}', "");
    Expect(0, 2943, '\P{Block=oriya}', "");
    Expect(1, 2943, '\P{^Block=oriya}', "");
    Expect(0, 2944, '\p{Block=oriya}', "");
    Expect(1, 2944, '\p{^Block=oriya}', "");
    Expect(1, 2944, '\P{Block=oriya}', "");
    Expect(0, 2944, '\P{^Block=oriya}', "");
    Expect(1, 2943, '\p{Block=:\Aoriya\z:}', "");;
    Expect(0, 2944, '\p{Block=:\Aoriya\z:}', "");;
    Expect(1, 2943, '\p{Block=-ORIYA}', "");
    Expect(0, 2943, '\p{^Block=-ORIYA}', "");
    Expect(0, 2943, '\P{Block=-ORIYA}', "");
    Expect(1, 2943, '\P{^Block=-ORIYA}', "");
    Expect(0, 2944, '\p{Block=-ORIYA}', "");
    Expect(1, 2944, '\p{^Block=-ORIYA}', "");
    Expect(1, 2944, '\P{Block=-ORIYA}', "");
    Expect(0, 2944, '\P{^Block=-ORIYA}', "");
    Error('\p{Blk=/a/	Oriya}');
    Error('\P{Blk=/a/	Oriya}');
    Expect(1, 2943, '\p{Blk=:\AOriya\z:}', "");;
    Expect(0, 2944, '\p{Blk=:\AOriya\z:}', "");;
    Expect(1, 2943, '\p{Blk=oriya}', "");
    Expect(0, 2943, '\p{^Blk=oriya}', "");
    Expect(0, 2943, '\P{Blk=oriya}', "");
    Expect(1, 2943, '\P{^Blk=oriya}', "");
    Expect(0, 2944, '\p{Blk=oriya}', "");
    Expect(1, 2944, '\p{^Blk=oriya}', "");
    Expect(1, 2944, '\P{Blk=oriya}', "");
    Expect(0, 2944, '\P{^Blk=oriya}', "");
    Expect(1, 2943, '\p{Blk=:\Aoriya\z:}', "");;
    Expect(0, 2944, '\p{Blk=:\Aoriya\z:}', "");;
    Expect(1, 2943, '\p{Blk:   	 Oriya}', "");
    Expect(0, 2943, '\p{^Blk:   	 Oriya}', "");
    Expect(0, 2943, '\P{Blk:   	 Oriya}', "");
    Expect(1, 2943, '\P{^Blk:   	 Oriya}', "");
    Expect(0, 2944, '\p{Blk:   	 Oriya}', "");
    Expect(1, 2944, '\p{^Blk:   	 Oriya}', "");
    Expect(1, 2944, '\P{Blk:   	 Oriya}', "");
    Expect(0, 2944, '\P{^Blk:   	 Oriya}', "");
    Error('\p{Is_Block=:=_	Oriya}');
    Error('\P{Is_Block=:=_	Oriya}');
    Expect(1, 2943, '\p{Is_Block=oriya}', "");
    Expect(0, 2943, '\p{^Is_Block=oriya}', "");
    Expect(0, 2943, '\P{Is_Block=oriya}', "");
    Expect(1, 2943, '\P{^Is_Block=oriya}', "");
    Expect(0, 2944, '\p{Is_Block=oriya}', "");
    Expect(1, 2944, '\p{^Is_Block=oriya}', "");
    Expect(1, 2944, '\P{Is_Block=oriya}', "");
    Expect(0, 2944, '\P{^Is_Block=oriya}', "");
    Expect(1, 2943, '\p{Is_Block=		Oriya}', "");
    Expect(0, 2943, '\p{^Is_Block=		Oriya}', "");
    Expect(0, 2943, '\P{Is_Block=		Oriya}', "");
    Expect(1, 2943, '\P{^Is_Block=		Oriya}', "");
    Expect(0, 2944, '\p{Is_Block=		Oriya}', "");
    Expect(1, 2944, '\p{^Is_Block=		Oriya}', "");
    Expect(1, 2944, '\P{Is_Block=		Oriya}', "");
    Expect(0, 2944, '\P{^Is_Block=		Oriya}', "");
    Error('\p{Is_Blk:	-Oriya:=}');
    Error('\P{Is_Blk:	-Oriya:=}');
    Expect(1, 2943, '\p{Is_Blk=oriya}', "");
    Expect(0, 2943, '\p{^Is_Blk=oriya}', "");
    Expect(0, 2943, '\P{Is_Blk=oriya}', "");
    Expect(1, 2943, '\P{^Is_Blk=oriya}', "");
    Expect(0, 2944, '\p{Is_Blk=oriya}', "");
    Expect(1, 2944, '\p{^Is_Blk=oriya}', "");
    Expect(1, 2944, '\P{Is_Blk=oriya}', "");
    Expect(0, 2944, '\P{^Is_Blk=oriya}', "");
    Expect(1, 2943, '\p{Is_Blk=-_oriya}', "");
    Expect(0, 2943, '\p{^Is_Blk=-_oriya}', "");
    Expect(0, 2943, '\P{Is_Blk=-_oriya}', "");
    Expect(1, 2943, '\P{^Is_Blk=-_oriya}', "");
    Expect(0, 2944, '\p{Is_Blk=-_oriya}', "");
    Expect(1, 2944, '\p{^Is_Blk=-_oriya}', "");
    Expect(1, 2944, '\P{Is_Blk=-_oriya}', "");
    Expect(0, 2944, '\P{^Is_Blk=-_oriya}', "");
    Error('\p{Block=/a/_Ornamental_dingbats}');
    Error('\P{Block=/a/_Ornamental_dingbats}');
    Expect(1, 128639, '\p{Block=:\AOrnamental_Dingbats\z:}', "");;
    Expect(0, 128640, '\p{Block=:\AOrnamental_Dingbats\z:}', "");;
    Expect(1, 128639, '\p{Block=ornamentaldingbats}', "");
    Expect(0, 128639, '\p{^Block=ornamentaldingbats}', "");
    Expect(0, 128639, '\P{Block=ornamentaldingbats}', "");
    Expect(1, 128639, '\P{^Block=ornamentaldingbats}', "");
    Expect(0, 128640, '\p{Block=ornamentaldingbats}', "");
    Expect(1, 128640, '\p{^Block=ornamentaldingbats}', "");
    Expect(1, 128640, '\P{Block=ornamentaldingbats}', "");
    Expect(0, 128640, '\P{^Block=ornamentaldingbats}', "");
    Expect(1, 128639, '\p{Block=:\Aornamentaldingbats\z:}', "");;
    Expect(0, 128640, '\p{Block=:\Aornamentaldingbats\z:}', "");;
    Expect(1, 128639, '\p{Block=		ornamental_dingbats}', "");
    Expect(0, 128639, '\p{^Block=		ornamental_dingbats}', "");
    Expect(0, 128639, '\P{Block=		ornamental_dingbats}', "");
    Expect(1, 128639, '\P{^Block=		ornamental_dingbats}', "");
    Expect(0, 128640, '\p{Block=		ornamental_dingbats}', "");
    Expect(1, 128640, '\p{^Block=		ornamental_dingbats}', "");
    Expect(1, 128640, '\P{Block=		ornamental_dingbats}', "");
    Expect(0, 128640, '\P{^Block=		ornamental_dingbats}', "");
    Error('\p{Blk=	ORNAMENTAL_Dingbats:=}');
    Error('\P{Blk=	ORNAMENTAL_Dingbats:=}');
    Expect(1, 128639, '\p{Blk=:\AOrnamental_Dingbats\z:}', "");;
    Expect(0, 128640, '\p{Blk=:\AOrnamental_Dingbats\z:}', "");;
    Expect(1, 128639, '\p{Blk=ornamentaldingbats}', "");
    Expect(0, 128639, '\p{^Blk=ornamentaldingbats}', "");
    Expect(0, 128639, '\P{Blk=ornamentaldingbats}', "");
    Expect(1, 128639, '\P{^Blk=ornamentaldingbats}', "");
    Expect(0, 128640, '\p{Blk=ornamentaldingbats}', "");
    Expect(1, 128640, '\p{^Blk=ornamentaldingbats}', "");
    Expect(1, 128640, '\P{Blk=ornamentaldingbats}', "");
    Expect(0, 128640, '\P{^Blk=ornamentaldingbats}', "");
    Expect(1, 128639, '\p{Blk=:\Aornamentaldingbats\z:}', "");;
    Expect(0, 128640, '\p{Blk=:\Aornamentaldingbats\z:}', "");;
    Expect(1, 128639, '\p{Blk=-Ornamental_dingbats}', "");
    Expect(0, 128639, '\p{^Blk=-Ornamental_dingbats}', "");
    Expect(0, 128639, '\P{Blk=-Ornamental_dingbats}', "");
    Expect(1, 128639, '\P{^Blk=-Ornamental_dingbats}', "");
    Expect(0, 128640, '\p{Blk=-Ornamental_dingbats}', "");
    Expect(1, 128640, '\p{^Blk=-Ornamental_dingbats}', "");
    Expect(1, 128640, '\P{Blk=-Ornamental_dingbats}', "");
    Expect(0, 128640, '\P{^Blk=-Ornamental_dingbats}', "");
    Error('\p{Is_Block=-/a/ORNAMENTAL_DINGBATS}');
    Error('\P{Is_Block=-/a/ORNAMENTAL_DINGBATS}');
    Expect(1, 128639, '\p{Is_Block=ornamentaldingbats}', "");
    Expect(0, 128639, '\p{^Is_Block=ornamentaldingbats}', "");
    Expect(0, 128639, '\P{Is_Block=ornamentaldingbats}', "");
    Expect(1, 128639, '\P{^Is_Block=ornamentaldingbats}', "");
    Expect(0, 128640, '\p{Is_Block=ornamentaldingbats}', "");
    Expect(1, 128640, '\p{^Is_Block=ornamentaldingbats}', "");
    Expect(1, 128640, '\P{Is_Block=ornamentaldingbats}', "");
    Expect(0, 128640, '\P{^Is_Block=ornamentaldingbats}', "");
    Expect(1, 128639, '\p{Is_Block=		ORNAMENTAL_Dingbats}', "");
    Expect(0, 128639, '\p{^Is_Block=		ORNAMENTAL_Dingbats}', "");
    Expect(0, 128639, '\P{Is_Block=		ORNAMENTAL_Dingbats}', "");
    Expect(1, 128639, '\P{^Is_Block=		ORNAMENTAL_Dingbats}', "");
    Expect(0, 128640, '\p{Is_Block=		ORNAMENTAL_Dingbats}', "");
    Expect(1, 128640, '\p{^Is_Block=		ORNAMENTAL_Dingbats}', "");
    Expect(1, 128640, '\P{Is_Block=		ORNAMENTAL_Dingbats}', "");
    Expect(0, 128640, '\P{^Is_Block=		ORNAMENTAL_Dingbats}', "");
    Error('\p{Is_Blk=-Ornamental_DINGBATS:=}');
    Error('\P{Is_Blk=-Ornamental_DINGBATS:=}');
    Expect(1, 128639, '\p{Is_Blk=ornamentaldingbats}', "");
    Expect(0, 128639, '\p{^Is_Blk=ornamentaldingbats}', "");
    Expect(0, 128639, '\P{Is_Blk=ornamentaldingbats}', "");
    Expect(1, 128639, '\P{^Is_Blk=ornamentaldingbats}', "");
    Expect(0, 128640, '\p{Is_Blk=ornamentaldingbats}', "");
    Expect(1, 128640, '\p{^Is_Blk=ornamentaldingbats}', "");
    Expect(1, 128640, '\P{Is_Blk=ornamentaldingbats}', "");
    Expect(0, 128640, '\P{^Is_Blk=ornamentaldingbats}', "");
    Expect(1, 128639, '\p{Is_Blk=__ornamental_DINGBATS}', "");
    Expect(0, 128639, '\p{^Is_Blk=__ornamental_DINGBATS}', "");
    Expect(0, 128639, '\P{Is_Blk=__ornamental_DINGBATS}', "");
    Expect(1, 128639, '\P{^Is_Blk=__ornamental_DINGBATS}', "");
    Expect(0, 128640, '\p{Is_Blk=__ornamental_DINGBATS}', "");
    Expect(1, 128640, '\p{^Is_Blk=__ornamental_DINGBATS}', "");
    Expect(1, 128640, '\P{Is_Blk=__ornamental_DINGBATS}', "");
    Expect(0, 128640, '\P{^Is_Blk=__ornamental_DINGBATS}', "");
    Error('\p{Block=:=	_Osage}');
    Error('\P{Block=:=	_Osage}');
    Expect(1, 66815, '\p{Block=:\AOsage\z:}', "");;
    Expect(0, 66816, '\p{Block=:\AOsage\z:}', "");;
    Expect(1, 66815, '\p{Block=osage}', "");
    Expect(0, 66815, '\p{^Block=osage}', "");
    Expect(0, 66815, '\P{Block=osage}', "");
    Expect(1, 66815, '\P{^Block=osage}', "");
    Expect(0, 66816, '\p{Block=osage}', "");
    Expect(1, 66816, '\p{^Block=osage}', "");
    Expect(1, 66816, '\P{Block=osage}', "");
    Expect(0, 66816, '\P{^Block=osage}', "");
    Expect(1, 66815, '\p{Block=:\Aosage\z:}', "");;
    Expect(0, 66816, '\p{Block=:\Aosage\z:}', "");;
    Expect(1, 66815, '\p{Block=_Osage}', "");
    Expect(0, 66815, '\p{^Block=_Osage}', "");
    Expect(0, 66815, '\P{Block=_Osage}', "");
    Expect(1, 66815, '\P{^Block=_Osage}', "");
    Expect(0, 66816, '\p{Block=_Osage}', "");
    Expect(1, 66816, '\p{^Block=_Osage}', "");
    Expect(1, 66816, '\P{Block=_Osage}', "");
    Expect(0, 66816, '\P{^Block=_Osage}', "");
    Error('\p{Blk=	 OSAGE:=}');
    Error('\P{Blk=	 OSAGE:=}');
    Expect(1, 66815, '\p{Blk=:\AOsage\z:}', "");;
    Expect(0, 66816, '\p{Blk=:\AOsage\z:}', "");;
    Expect(1, 66815, '\p{Blk=osage}', "");
    Expect(0, 66815, '\p{^Blk=osage}', "");
    Expect(0, 66815, '\P{Blk=osage}', "");
    Expect(1, 66815, '\P{^Blk=osage}', "");
    Expect(0, 66816, '\p{Blk=osage}', "");
    Expect(1, 66816, '\p{^Blk=osage}', "");
    Expect(1, 66816, '\P{Blk=osage}', "");
    Expect(0, 66816, '\P{^Blk=osage}', "");
    Expect(1, 66815, '\p{Blk=:\Aosage\z:}', "");;
    Expect(0, 66816, '\p{Blk=:\Aosage\z:}', "");;
    Expect(1, 66815, '\p{Blk=_-OSAGE}', "");
    Expect(0, 66815, '\p{^Blk=_-OSAGE}', "");
    Expect(0, 66815, '\P{Blk=_-OSAGE}', "");
    Expect(1, 66815, '\P{^Blk=_-OSAGE}', "");
    Expect(0, 66816, '\p{Blk=_-OSAGE}', "");
    Expect(1, 66816, '\p{^Blk=_-OSAGE}', "");
    Expect(1, 66816, '\P{Blk=_-OSAGE}', "");
    Expect(0, 66816, '\P{^Blk=_-OSAGE}', "");
    Error('\p{Is_Block=_/a/Osage}');
    Error('\P{Is_Block=_/a/Osage}');
    Expect(1, 66815, '\p{Is_Block=osage}', "");
    Expect(0, 66815, '\p{^Is_Block=osage}', "");
    Expect(0, 66815, '\P{Is_Block=osage}', "");
    Expect(1, 66815, '\P{^Is_Block=osage}', "");
    Expect(0, 66816, '\p{Is_Block=osage}', "");
    Expect(1, 66816, '\p{^Is_Block=osage}', "");
    Expect(1, 66816, '\P{Is_Block=osage}', "");
    Expect(0, 66816, '\P{^Is_Block=osage}', "");
    Expect(1, 66815, '\p{Is_Block= -osage}', "");
    Expect(0, 66815, '\p{^Is_Block= -osage}', "");
    Expect(0, 66815, '\P{Is_Block= -osage}', "");
    Expect(1, 66815, '\P{^Is_Block= -osage}', "");
    Expect(0, 66816, '\p{Is_Block= -osage}', "");
    Expect(1, 66816, '\p{^Is_Block= -osage}', "");
    Expect(1, 66816, '\P{Is_Block= -osage}', "");
    Expect(0, 66816, '\P{^Is_Block= -osage}', "");
    Error('\p{Is_Blk:		 Osage/a/}');
    Error('\P{Is_Blk:		 Osage/a/}');
    Expect(1, 66815, '\p{Is_Blk=osage}', "");
    Expect(0, 66815, '\p{^Is_Blk=osage}', "");
    Expect(0, 66815, '\P{Is_Blk=osage}', "");
    Expect(1, 66815, '\P{^Is_Blk=osage}', "");
    Expect(0, 66816, '\p{Is_Blk=osage}', "");
    Expect(1, 66816, '\p{^Is_Blk=osage}', "");
    Expect(1, 66816, '\P{Is_Blk=osage}', "");
    Expect(0, 66816, '\P{^Is_Blk=osage}', "");
    Expect(1, 66815, '\p{Is_Blk: 	OSAGE}', "");
    Expect(0, 66815, '\p{^Is_Blk: 	OSAGE}', "");
    Expect(0, 66815, '\P{Is_Blk: 	OSAGE}', "");
    Expect(1, 66815, '\P{^Is_Blk: 	OSAGE}', "");
    Expect(0, 66816, '\p{Is_Blk: 	OSAGE}', "");
    Expect(1, 66816, '\p{^Is_Blk: 	OSAGE}', "");
    Expect(1, 66816, '\P{Is_Blk: 	OSAGE}', "");
    Expect(0, 66816, '\P{^Is_Blk: 	OSAGE}', "");
    Error('\p{Block= :=OSMANYA}');
    Error('\P{Block= :=OSMANYA}');
    Expect(1, 66735, '\p{Block=:\AOsmanya\z:}', "");;
    Expect(0, 66736, '\p{Block=:\AOsmanya\z:}', "");;
    Expect(1, 66735, '\p{Block=osmanya}', "");
    Expect(0, 66735, '\p{^Block=osmanya}', "");
    Expect(0, 66735, '\P{Block=osmanya}', "");
    Expect(1, 66735, '\P{^Block=osmanya}', "");
    Expect(0, 66736, '\p{Block=osmanya}', "");
    Expect(1, 66736, '\p{^Block=osmanya}', "");
    Expect(1, 66736, '\P{Block=osmanya}', "");
    Expect(0, 66736, '\P{^Block=osmanya}', "");
    Expect(1, 66735, '\p{Block=:\Aosmanya\z:}', "");;
    Expect(0, 66736, '\p{Block=:\Aosmanya\z:}', "");;
    Expect(1, 66735, '\p{Block=- Osmanya}', "");
    Expect(0, 66735, '\p{^Block=- Osmanya}', "");
    Expect(0, 66735, '\P{Block=- Osmanya}', "");
    Expect(1, 66735, '\P{^Block=- Osmanya}', "");
    Expect(0, 66736, '\p{Block=- Osmanya}', "");
    Expect(1, 66736, '\p{^Block=- Osmanya}', "");
    Expect(1, 66736, '\P{Block=- Osmanya}', "");
    Expect(0, 66736, '\P{^Block=- Osmanya}', "");
    Error('\p{Blk=/a/	-Osmanya}');
    Error('\P{Blk=/a/	-Osmanya}');
    Expect(1, 66735, '\p{Blk=:\AOsmanya\z:}', "");;
    Expect(0, 66736, '\p{Blk=:\AOsmanya\z:}', "");;
    Expect(1, 66735, '\p{Blk=osmanya}', "");
    Expect(0, 66735, '\p{^Blk=osmanya}', "");
    Expect(0, 66735, '\P{Blk=osmanya}', "");
    Expect(1, 66735, '\P{^Blk=osmanya}', "");
    Expect(0, 66736, '\p{Blk=osmanya}', "");
    Expect(1, 66736, '\p{^Blk=osmanya}', "");
    Expect(1, 66736, '\P{Blk=osmanya}', "");
    Expect(0, 66736, '\P{^Blk=osmanya}', "");
    Expect(1, 66735, '\p{Blk=:\Aosmanya\z:}', "");;
    Expect(0, 66736, '\p{Blk=:\Aosmanya\z:}', "");;
    Expect(1, 66735, '\p{Blk:	  OSMANYA}', "");
    Expect(0, 66735, '\p{^Blk:	  OSMANYA}', "");
    Expect(0, 66735, '\P{Blk:	  OSMANYA}', "");
    Expect(1, 66735, '\P{^Blk:	  OSMANYA}', "");
    Expect(0, 66736, '\p{Blk:	  OSMANYA}', "");
    Expect(1, 66736, '\p{^Blk:	  OSMANYA}', "");
    Expect(1, 66736, '\P{Blk:	  OSMANYA}', "");
    Expect(0, 66736, '\P{^Blk:	  OSMANYA}', "");
    Error('\p{Is_Block=_/a/OSMANYA}');
    Error('\P{Is_Block=_/a/OSMANYA}');
    Expect(1, 66735, '\p{Is_Block=osmanya}', "");
    Expect(0, 66735, '\p{^Is_Block=osmanya}', "");
    Expect(0, 66735, '\P{Is_Block=osmanya}', "");
    Expect(1, 66735, '\P{^Is_Block=osmanya}', "");
    Expect(0, 66736, '\p{Is_Block=osmanya}', "");
    Expect(1, 66736, '\p{^Is_Block=osmanya}', "");
    Expect(1, 66736, '\P{Is_Block=osmanya}', "");
    Expect(0, 66736, '\P{^Is_Block=osmanya}', "");
    Expect(1, 66735, '\p{Is_Block=Osmanya}', "");
    Expect(0, 66735, '\p{^Is_Block=Osmanya}', "");
    Expect(0, 66735, '\P{Is_Block=Osmanya}', "");
    Expect(1, 66735, '\P{^Is_Block=Osmanya}', "");
    Expect(0, 66736, '\p{Is_Block=Osmanya}', "");
    Expect(1, 66736, '\p{^Is_Block=Osmanya}', "");
    Expect(1, 66736, '\P{Is_Block=Osmanya}', "");
    Expect(0, 66736, '\P{^Is_Block=Osmanya}', "");
    Error('\p{Is_Blk=_osmanya:=}');
    Error('\P{Is_Blk=_osmanya:=}');
    Expect(1, 66735, '\p{Is_Blk=osmanya}', "");
    Expect(0, 66735, '\p{^Is_Blk=osmanya}', "");
    Expect(0, 66735, '\P{Is_Blk=osmanya}', "");
    Expect(1, 66735, '\P{^Is_Blk=osmanya}', "");
    Expect(0, 66736, '\p{Is_Blk=osmanya}', "");
    Expect(1, 66736, '\p{^Is_Blk=osmanya}', "");
    Expect(1, 66736, '\P{Is_Blk=osmanya}', "");
    Expect(0, 66736, '\P{^Is_Blk=osmanya}', "");
    Expect(1, 66735, '\p{Is_Blk=		Osmanya}', "");
    Expect(0, 66735, '\p{^Is_Blk=		Osmanya}', "");
    Expect(0, 66735, '\P{Is_Blk=		Osmanya}', "");
    Expect(1, 66735, '\P{^Is_Blk=		Osmanya}', "");
    Expect(0, 66736, '\p{Is_Blk=		Osmanya}', "");
    Expect(1, 66736, '\p{^Is_Blk=		Osmanya}', "");
    Expect(1, 66736, '\P{Is_Blk=		Osmanya}', "");
    Expect(0, 66736, '\P{^Is_Blk=		Osmanya}', "");
    Error('\p{Block:/a/	Ottoman_Siyaq_Numbers}');
    Error('\P{Block:/a/	Ottoman_Siyaq_Numbers}');
    Expect(1, 126287, '\p{Block=:\AOttoman_Siyaq_Numbers\z:}', "");;
    Expect(0, 126288, '\p{Block=:\AOttoman_Siyaq_Numbers\z:}', "");;
    Expect(1, 126287, '\p{Block: ottomansiyaqnumbers}', "");
    Expect(0, 126287, '\p{^Block: ottomansiyaqnumbers}', "");
    Expect(0, 126287, '\P{Block: ottomansiyaqnumbers}', "");
    Expect(1, 126287, '\P{^Block: ottomansiyaqnumbers}', "");
    Expect(0, 126288, '\p{Block: ottomansiyaqnumbers}', "");
    Expect(1, 126288, '\p{^Block: ottomansiyaqnumbers}', "");
    Expect(1, 126288, '\P{Block: ottomansiyaqnumbers}', "");
    Expect(0, 126288, '\P{^Block: ottomansiyaqnumbers}', "");
    Expect(1, 126287, '\p{Block=:\Aottomansiyaqnumbers\z:}', "");;
    Expect(0, 126288, '\p{Block=:\Aottomansiyaqnumbers\z:}', "");;
    Expect(1, 126287, '\p{Block=_OTTOMAN_Siyaq_Numbers}', "");
    Expect(0, 126287, '\p{^Block=_OTTOMAN_Siyaq_Numbers}', "");
    Expect(0, 126287, '\P{Block=_OTTOMAN_Siyaq_Numbers}', "");
    Expect(1, 126287, '\P{^Block=_OTTOMAN_Siyaq_Numbers}', "");
    Expect(0, 126288, '\p{Block=_OTTOMAN_Siyaq_Numbers}', "");
    Expect(1, 126288, '\p{^Block=_OTTOMAN_Siyaq_Numbers}', "");
    Expect(1, 126288, '\P{Block=_OTTOMAN_Siyaq_Numbers}', "");
    Expect(0, 126288, '\P{^Block=_OTTOMAN_Siyaq_Numbers}', "");
    Error('\p{Blk=/a/	_Ottoman_Siyaq_NUMBERS}');
    Error('\P{Blk=/a/	_Ottoman_Siyaq_NUMBERS}');
    Expect(1, 126287, '\p{Blk=:\AOttoman_Siyaq_Numbers\z:}', "");;
    Expect(0, 126288, '\p{Blk=:\AOttoman_Siyaq_Numbers\z:}', "");;
    Expect(1, 126287, '\p{Blk=ottomansiyaqnumbers}', "");
    Expect(0, 126287, '\p{^Blk=ottomansiyaqnumbers}', "");
    Expect(0, 126287, '\P{Blk=ottomansiyaqnumbers}', "");
    Expect(1, 126287, '\P{^Blk=ottomansiyaqnumbers}', "");
    Expect(0, 126288, '\p{Blk=ottomansiyaqnumbers}', "");
    Expect(1, 126288, '\p{^Blk=ottomansiyaqnumbers}', "");
    Expect(1, 126288, '\P{Blk=ottomansiyaqnumbers}', "");
    Expect(0, 126288, '\P{^Blk=ottomansiyaqnumbers}', "");
    Expect(1, 126287, '\p{Blk=:\Aottomansiyaqnumbers\z:}', "");;
    Expect(0, 126288, '\p{Blk=:\Aottomansiyaqnumbers\z:}', "");;
    Expect(1, 126287, '\p{Blk= Ottoman_Siyaq_NUMBERS}', "");
    Expect(0, 126287, '\p{^Blk= Ottoman_Siyaq_NUMBERS}', "");
    Expect(0, 126287, '\P{Blk= Ottoman_Siyaq_NUMBERS}', "");
    Expect(1, 126287, '\P{^Blk= Ottoman_Siyaq_NUMBERS}', "");
    Expect(0, 126288, '\p{Blk= Ottoman_Siyaq_NUMBERS}', "");
    Expect(1, 126288, '\p{^Blk= Ottoman_Siyaq_NUMBERS}', "");
    Expect(1, 126288, '\P{Blk= Ottoman_Siyaq_NUMBERS}', "");
    Expect(0, 126288, '\P{^Blk= Ottoman_Siyaq_NUMBERS}', "");
    Error('\p{Is_Block=:=-	ottoman_Siyaq_Numbers}');
    Error('\P{Is_Block=:=-	ottoman_Siyaq_Numbers}');
    Expect(1, 126287, '\p{Is_Block=ottomansiyaqnumbers}', "");
    Expect(0, 126287, '\p{^Is_Block=ottomansiyaqnumbers}', "");
    Expect(0, 126287, '\P{Is_Block=ottomansiyaqnumbers}', "");
    Expect(1, 126287, '\P{^Is_Block=ottomansiyaqnumbers}', "");
    Expect(0, 126288, '\p{Is_Block=ottomansiyaqnumbers}', "");
    Expect(1, 126288, '\p{^Is_Block=ottomansiyaqnumbers}', "");
    Expect(1, 126288, '\P{Is_Block=ottomansiyaqnumbers}', "");
    Expect(0, 126288, '\P{^Is_Block=ottomansiyaqnumbers}', "");
    Expect(1, 126287, '\p{Is_Block=_ Ottoman_Siyaq_Numbers}', "");
    Expect(0, 126287, '\p{^Is_Block=_ Ottoman_Siyaq_Numbers}', "");
    Expect(0, 126287, '\P{Is_Block=_ Ottoman_Siyaq_Numbers}', "");
    Expect(1, 126287, '\P{^Is_Block=_ Ottoman_Siyaq_Numbers}', "");
    Expect(0, 126288, '\p{Is_Block=_ Ottoman_Siyaq_Numbers}', "");
    Expect(1, 126288, '\p{^Is_Block=_ Ottoman_Siyaq_Numbers}', "");
    Expect(1, 126288, '\P{Is_Block=_ Ottoman_Siyaq_Numbers}', "");
    Expect(0, 126288, '\P{^Is_Block=_ Ottoman_Siyaq_Numbers}', "");
    Error('\p{Is_Blk=:=-Ottoman_siyaq_Numbers}');
    Error('\P{Is_Blk=:=-Ottoman_siyaq_Numbers}');
    Expect(1, 126287, '\p{Is_Blk=ottomansiyaqnumbers}', "");
    Expect(0, 126287, '\p{^Is_Blk=ottomansiyaqnumbers}', "");
    Expect(0, 126287, '\P{Is_Blk=ottomansiyaqnumbers}', "");
    Expect(1, 126287, '\P{^Is_Blk=ottomansiyaqnumbers}', "");
    Expect(0, 126288, '\p{Is_Blk=ottomansiyaqnumbers}', "");
    Expect(1, 126288, '\p{^Is_Blk=ottomansiyaqnumbers}', "");
    Expect(1, 126288, '\P{Is_Blk=ottomansiyaqnumbers}', "");
    Expect(0, 126288, '\P{^Is_Blk=ottomansiyaqnumbers}', "");
    Expect(1, 126287, '\p{Is_Blk=_Ottoman_Siyaq_Numbers}', "");
    Expect(0, 126287, '\p{^Is_Blk=_Ottoman_Siyaq_Numbers}', "");
    Expect(0, 126287, '\P{Is_Blk=_Ottoman_Siyaq_Numbers}', "");
    Expect(1, 126287, '\P{^Is_Blk=_Ottoman_Siyaq_Numbers}', "");
    Expect(0, 126288, '\p{Is_Blk=_Ottoman_Siyaq_Numbers}', "");
    Expect(1, 126288, '\p{^Is_Blk=_Ottoman_Siyaq_Numbers}', "");
    Expect(1, 126288, '\P{Is_Blk=_Ottoman_Siyaq_Numbers}', "");
    Expect(0, 126288, '\P{^Is_Blk=_Ottoman_Siyaq_Numbers}', "");
    Error('\p{Block= /a/PAHAWH_Hmong}');
    Error('\P{Block= /a/PAHAWH_Hmong}');
    Expect(1, 93071, '\p{Block=:\APahawh_Hmong\z:}', "");;
    Expect(0, 93072, '\p{Block=:\APahawh_Hmong\z:}', "");;
    Expect(1, 93071, '\p{Block=pahawhhmong}', "");
    Expect(0, 93071, '\p{^Block=pahawhhmong}', "");
    Expect(0, 93071, '\P{Block=pahawhhmong}', "");
    Expect(1, 93071, '\P{^Block=pahawhhmong}', "");
    Expect(0, 93072, '\p{Block=pahawhhmong}', "");
    Expect(1, 93072, '\p{^Block=pahawhhmong}', "");
    Expect(1, 93072, '\P{Block=pahawhhmong}', "");
    Expect(0, 93072, '\P{^Block=pahawhhmong}', "");
    Expect(1, 93071, '\p{Block=:\Apahawhhmong\z:}', "");;
    Expect(0, 93072, '\p{Block=:\Apahawhhmong\z:}', "");;
    Expect(1, 93071, '\p{Block=	_pahawh_hmong}', "");
    Expect(0, 93071, '\p{^Block=	_pahawh_hmong}', "");
    Expect(0, 93071, '\P{Block=	_pahawh_hmong}', "");
    Expect(1, 93071, '\P{^Block=	_pahawh_hmong}', "");
    Expect(0, 93072, '\p{Block=	_pahawh_hmong}', "");
    Expect(1, 93072, '\p{^Block=	_pahawh_hmong}', "");
    Expect(1, 93072, '\P{Block=	_pahawh_hmong}', "");
    Expect(0, 93072, '\P{^Block=	_pahawh_hmong}', "");
    Error('\p{Blk:   :=	 pahawh_hmong}');
    Error('\P{Blk:   :=	 pahawh_hmong}');
    Expect(1, 93071, '\p{Blk=:\APahawh_Hmong\z:}', "");;
    Expect(0, 93072, '\p{Blk=:\APahawh_Hmong\z:}', "");;
    Expect(1, 93071, '\p{Blk=pahawhhmong}', "");
    Expect(0, 93071, '\p{^Blk=pahawhhmong}', "");
    Expect(0, 93071, '\P{Blk=pahawhhmong}', "");
    Expect(1, 93071, '\P{^Blk=pahawhhmong}', "");
    Expect(0, 93072, '\p{Blk=pahawhhmong}', "");
    Expect(1, 93072, '\p{^Blk=pahawhhmong}', "");
    Expect(1, 93072, '\P{Blk=pahawhhmong}', "");
    Expect(0, 93072, '\P{^Blk=pahawhhmong}', "");
    Expect(1, 93071, '\p{Blk=:\Apahawhhmong\z:}', "");;
    Expect(0, 93072, '\p{Blk=:\Apahawhhmong\z:}', "");;
    Expect(1, 93071, '\p{Blk= Pahawh_hmong}', "");
    Expect(0, 93071, '\p{^Blk= Pahawh_hmong}', "");
    Expect(0, 93071, '\P{Blk= Pahawh_hmong}', "");
    Expect(1, 93071, '\P{^Blk= Pahawh_hmong}', "");
    Expect(0, 93072, '\p{Blk= Pahawh_hmong}', "");
    Expect(1, 93072, '\p{^Blk= Pahawh_hmong}', "");
    Expect(1, 93072, '\P{Blk= Pahawh_hmong}', "");
    Expect(0, 93072, '\P{^Blk= Pahawh_hmong}', "");
    Error('\p{Is_Block=_/a/pahawh_HMONG}');
    Error('\P{Is_Block=_/a/pahawh_HMONG}');
    Expect(1, 93071, '\p{Is_Block=pahawhhmong}', "");
    Expect(0, 93071, '\p{^Is_Block=pahawhhmong}', "");
    Expect(0, 93071, '\P{Is_Block=pahawhhmong}', "");
    Expect(1, 93071, '\P{^Is_Block=pahawhhmong}', "");
    Expect(0, 93072, '\p{Is_Block=pahawhhmong}', "");
    Expect(1, 93072, '\p{^Is_Block=pahawhhmong}', "");
    Expect(1, 93072, '\P{Is_Block=pahawhhmong}', "");
    Expect(0, 93072, '\P{^Is_Block=pahawhhmong}', "");
    Expect(1, 93071, '\p{Is_Block= -Pahawh_hmong}', "");
    Expect(0, 93071, '\p{^Is_Block= -Pahawh_hmong}', "");
    Expect(0, 93071, '\P{Is_Block= -Pahawh_hmong}', "");
    Expect(1, 93071, '\P{^Is_Block= -Pahawh_hmong}', "");
    Expect(0, 93072, '\p{Is_Block= -Pahawh_hmong}', "");
    Expect(1, 93072, '\p{^Is_Block= -Pahawh_hmong}', "");
    Expect(1, 93072, '\P{Is_Block= -Pahawh_hmong}', "");
    Expect(0, 93072, '\P{^Is_Block= -Pahawh_hmong}', "");
    Error('\p{Is_Blk=:=PAHAWH_Hmong}');
    Error('\P{Is_Blk=:=PAHAWH_Hmong}');
    Expect(1, 93071, '\p{Is_Blk=pahawhhmong}', "");
    Expect(0, 93071, '\p{^Is_Blk=pahawhhmong}', "");
    Expect(0, 93071, '\P{Is_Blk=pahawhhmong}', "");
    Expect(1, 93071, '\P{^Is_Blk=pahawhhmong}', "");
    Expect(0, 93072, '\p{Is_Blk=pahawhhmong}', "");
    Expect(1, 93072, '\p{^Is_Blk=pahawhhmong}', "");
    Expect(1, 93072, '\P{Is_Blk=pahawhhmong}', "");
    Expect(0, 93072, '\P{^Is_Blk=pahawhhmong}', "");
    Expect(1, 93071, '\p{Is_Blk=-_Pahawh_Hmong}', "");
    Expect(0, 93071, '\p{^Is_Blk=-_Pahawh_Hmong}', "");
    Expect(0, 93071, '\P{Is_Blk=-_Pahawh_Hmong}', "");
    Expect(1, 93071, '\P{^Is_Blk=-_Pahawh_Hmong}', "");
    Expect(0, 93072, '\p{Is_Blk=-_Pahawh_Hmong}', "");
    Expect(1, 93072, '\p{^Is_Blk=-_Pahawh_Hmong}', "");
    Expect(1, 93072, '\P{Is_Blk=-_Pahawh_Hmong}', "");
    Expect(0, 93072, '\P{^Is_Blk=-_Pahawh_Hmong}', "");
    Error('\p{Block=_PALMYRENE:=}');
    Error('\P{Block=_PALMYRENE:=}');
    Expect(1, 67711, '\p{Block=:\APalmyrene\z:}', "");;
    Expect(0, 67712, '\p{Block=:\APalmyrene\z:}', "");;
    Expect(1, 67711, '\p{Block=palmyrene}', "");
    Expect(0, 67711, '\p{^Block=palmyrene}', "");
    Expect(0, 67711, '\P{Block=palmyrene}', "");
    Expect(1, 67711, '\P{^Block=palmyrene}', "");
    Expect(0, 67712, '\p{Block=palmyrene}', "");
    Expect(1, 67712, '\p{^Block=palmyrene}', "");
    Expect(1, 67712, '\P{Block=palmyrene}', "");
    Expect(0, 67712, '\P{^Block=palmyrene}', "");
    Expect(1, 67711, '\p{Block=:\Apalmyrene\z:}', "");;
    Expect(0, 67712, '\p{Block=:\Apalmyrene\z:}', "");;
    Expect(1, 67711, '\p{Block=	-Palmyrene}', "");
    Expect(0, 67711, '\p{^Block=	-Palmyrene}', "");
    Expect(0, 67711, '\P{Block=	-Palmyrene}', "");
    Expect(1, 67711, '\P{^Block=	-Palmyrene}', "");
    Expect(0, 67712, '\p{Block=	-Palmyrene}', "");
    Expect(1, 67712, '\p{^Block=	-Palmyrene}', "");
    Expect(1, 67712, '\P{Block=	-Palmyrene}', "");
    Expect(0, 67712, '\P{^Block=	-Palmyrene}', "");
    Error('\p{Blk:	:=  palmyrene}');
    Error('\P{Blk:	:=  palmyrene}');
    Expect(1, 67711, '\p{Blk=:\APalmyrene\z:}', "");;
    Expect(0, 67712, '\p{Blk=:\APalmyrene\z:}', "");;
    Expect(1, 67711, '\p{Blk=palmyrene}', "");
    Expect(0, 67711, '\p{^Blk=palmyrene}', "");
    Expect(0, 67711, '\P{Blk=palmyrene}', "");
    Expect(1, 67711, '\P{^Blk=palmyrene}', "");
    Expect(0, 67712, '\p{Blk=palmyrene}', "");
    Expect(1, 67712, '\p{^Blk=palmyrene}', "");
    Expect(1, 67712, '\P{Blk=palmyrene}', "");
    Expect(0, 67712, '\P{^Blk=palmyrene}', "");
    Expect(1, 67711, '\p{Blk=:\Apalmyrene\z:}', "");;
    Expect(0, 67712, '\p{Blk=:\Apalmyrene\z:}', "");;
    Expect(1, 67711, '\p{Blk=_ Palmyrene}', "");
    Expect(0, 67711, '\p{^Blk=_ Palmyrene}', "");
    Expect(0, 67711, '\P{Blk=_ Palmyrene}', "");
    Expect(1, 67711, '\P{^Blk=_ Palmyrene}', "");
    Expect(0, 67712, '\p{Blk=_ Palmyrene}', "");
    Expect(1, 67712, '\p{^Blk=_ Palmyrene}', "");
    Expect(1, 67712, '\P{Blk=_ Palmyrene}', "");
    Expect(0, 67712, '\P{^Blk=_ Palmyrene}', "");
    Error('\p{Is_Block=_ palmyrene/a/}');
    Error('\P{Is_Block=_ palmyrene/a/}');
    Expect(1, 67711, '\p{Is_Block=palmyrene}', "");
    Expect(0, 67711, '\p{^Is_Block=palmyrene}', "");
    Expect(0, 67711, '\P{Is_Block=palmyrene}', "");
    Expect(1, 67711, '\P{^Is_Block=palmyrene}', "");
    Expect(0, 67712, '\p{Is_Block=palmyrene}', "");
    Expect(1, 67712, '\p{^Is_Block=palmyrene}', "");
    Expect(1, 67712, '\P{Is_Block=palmyrene}', "");
    Expect(0, 67712, '\P{^Is_Block=palmyrene}', "");
    Expect(1, 67711, '\p{Is_Block=_Palmyrene}', "");
    Expect(0, 67711, '\p{^Is_Block=_Palmyrene}', "");
    Expect(0, 67711, '\P{Is_Block=_Palmyrene}', "");
    Expect(1, 67711, '\P{^Is_Block=_Palmyrene}', "");
    Expect(0, 67712, '\p{Is_Block=_Palmyrene}', "");
    Expect(1, 67712, '\p{^Is_Block=_Palmyrene}', "");
    Expect(1, 67712, '\P{Is_Block=_Palmyrene}', "");
    Expect(0, 67712, '\P{^Is_Block=_Palmyrene}', "");
    Error('\p{Is_Blk= /a/Palmyrene}');
    Error('\P{Is_Blk= /a/Palmyrene}');
    Expect(1, 67711, '\p{Is_Blk=palmyrene}', "");
    Expect(0, 67711, '\p{^Is_Blk=palmyrene}', "");
    Expect(0, 67711, '\P{Is_Blk=palmyrene}', "");
    Expect(1, 67711, '\P{^Is_Blk=palmyrene}', "");
    Expect(0, 67712, '\p{Is_Blk=palmyrene}', "");
    Expect(1, 67712, '\p{^Is_Blk=palmyrene}', "");
    Expect(1, 67712, '\P{Is_Blk=palmyrene}', "");
    Expect(0, 67712, '\P{^Is_Blk=palmyrene}', "");
    Expect(1, 67711, '\p{Is_Blk=	 palmyrene}', "");
    Expect(0, 67711, '\p{^Is_Blk=	 palmyrene}', "");
    Expect(0, 67711, '\P{Is_Blk=	 palmyrene}', "");
    Expect(1, 67711, '\P{^Is_Blk=	 palmyrene}', "");
    Expect(0, 67712, '\p{Is_Blk=	 palmyrene}', "");
    Expect(1, 67712, '\p{^Is_Blk=	 palmyrene}', "");
    Expect(1, 67712, '\P{Is_Blk=	 palmyrene}', "");
    Expect(0, 67712, '\P{^Is_Blk=	 palmyrene}', "");
    Error('\p{Block=/a/  Pau_cin_Hau}');
    Error('\P{Block=/a/  Pau_cin_Hau}');
    Expect(1, 72447, '\p{Block=:\APau_Cin_Hau\z:}', "");;
    Expect(0, 72448, '\p{Block=:\APau_Cin_Hau\z:}', "");;
    Expect(1, 72447, '\p{Block=paucinhau}', "");
    Expect(0, 72447, '\p{^Block=paucinhau}', "");
    Expect(0, 72447, '\P{Block=paucinhau}', "");
    Expect(1, 72447, '\P{^Block=paucinhau}', "");
    Expect(0, 72448, '\p{Block=paucinhau}', "");
    Expect(1, 72448, '\p{^Block=paucinhau}', "");
    Expect(1, 72448, '\P{Block=paucinhau}', "");
    Expect(0, 72448, '\P{^Block=paucinhau}', "");
    Expect(1, 72447, '\p{Block=:\Apaucinhau\z:}', "");;
    Expect(0, 72448, '\p{Block=:\Apaucinhau\z:}', "");;
    Expect(1, 72447, '\p{Block=- Pau_Cin_Hau}', "");
    Expect(0, 72447, '\p{^Block=- Pau_Cin_Hau}', "");
    Expect(0, 72447, '\P{Block=- Pau_Cin_Hau}', "");
    Expect(1, 72447, '\P{^Block=- Pau_Cin_Hau}', "");
    Expect(0, 72448, '\p{Block=- Pau_Cin_Hau}', "");
    Expect(1, 72448, '\p{^Block=- Pau_Cin_Hau}', "");
    Expect(1, 72448, '\P{Block=- Pau_Cin_Hau}', "");
    Expect(0, 72448, '\P{^Block=- Pau_Cin_Hau}', "");
    Error('\p{Blk= 	Pau_Cin_Hau:=}');
    Error('\P{Blk= 	Pau_Cin_Hau:=}');
    Expect(1, 72447, '\p{Blk=:\APau_Cin_Hau\z:}', "");;
    Expect(0, 72448, '\p{Blk=:\APau_Cin_Hau\z:}', "");;
    Expect(1, 72447, '\p{Blk=paucinhau}', "");
    Expect(0, 72447, '\p{^Blk=paucinhau}', "");
    Expect(0, 72447, '\P{Blk=paucinhau}', "");
    Expect(1, 72447, '\P{^Blk=paucinhau}', "");
    Expect(0, 72448, '\p{Blk=paucinhau}', "");
    Expect(1, 72448, '\p{^Blk=paucinhau}', "");
    Expect(1, 72448, '\P{Blk=paucinhau}', "");
    Expect(0, 72448, '\P{^Blk=paucinhau}', "");
    Expect(1, 72447, '\p{Blk=:\Apaucinhau\z:}', "");;
    Expect(0, 72448, '\p{Blk=:\Apaucinhau\z:}', "");;
    Expect(1, 72447, '\p{Blk:	-pau_cin_Hau}', "");
    Expect(0, 72447, '\p{^Blk:	-pau_cin_Hau}', "");
    Expect(0, 72447, '\P{Blk:	-pau_cin_Hau}', "");
    Expect(1, 72447, '\P{^Blk:	-pau_cin_Hau}', "");
    Expect(0, 72448, '\p{Blk:	-pau_cin_Hau}', "");
    Expect(1, 72448, '\p{^Blk:	-pau_cin_Hau}', "");
    Expect(1, 72448, '\P{Blk:	-pau_cin_Hau}', "");
    Expect(0, 72448, '\P{^Blk:	-pau_cin_Hau}', "");
    Error('\p{Is_Block=	-pau_CIN_Hau:=}');
    Error('\P{Is_Block=	-pau_CIN_Hau:=}');
    Expect(1, 72447, '\p{Is_Block=paucinhau}', "");
    Expect(0, 72447, '\p{^Is_Block=paucinhau}', "");
    Expect(0, 72447, '\P{Is_Block=paucinhau}', "");
    Expect(1, 72447, '\P{^Is_Block=paucinhau}', "");
    Expect(0, 72448, '\p{Is_Block=paucinhau}', "");
    Expect(1, 72448, '\p{^Is_Block=paucinhau}', "");
    Expect(1, 72448, '\P{Is_Block=paucinhau}', "");
    Expect(0, 72448, '\P{^Is_Block=paucinhau}', "");
    Expect(1, 72447, '\p{Is_Block= -pau_CIN_HAU}', "");
    Expect(0, 72447, '\p{^Is_Block= -pau_CIN_HAU}', "");
    Expect(0, 72447, '\P{Is_Block= -pau_CIN_HAU}', "");
    Expect(1, 72447, '\P{^Is_Block= -pau_CIN_HAU}', "");
    Expect(0, 72448, '\p{Is_Block= -pau_CIN_HAU}', "");
    Expect(1, 72448, '\p{^Is_Block= -pau_CIN_HAU}', "");
    Expect(1, 72448, '\P{Is_Block= -pau_CIN_HAU}', "");
    Expect(0, 72448, '\P{^Is_Block= -pau_CIN_HAU}', "");
    Error('\p{Is_Blk: PAU_CIN_hau/a/}');
    Error('\P{Is_Blk: PAU_CIN_hau/a/}');
    Expect(1, 72447, '\p{Is_Blk=paucinhau}', "");
    Expect(0, 72447, '\p{^Is_Blk=paucinhau}', "");
    Expect(0, 72447, '\P{Is_Blk=paucinhau}', "");
    Expect(1, 72447, '\P{^Is_Blk=paucinhau}', "");
    Expect(0, 72448, '\p{Is_Blk=paucinhau}', "");
    Expect(1, 72448, '\p{^Is_Blk=paucinhau}', "");
    Expect(1, 72448, '\P{Is_Blk=paucinhau}', "");
    Expect(0, 72448, '\P{^Is_Blk=paucinhau}', "");
    Expect(1, 72447, '\p{Is_Blk= -Pau_cin_HAU}', "");
    Expect(0, 72447, '\p{^Is_Blk= -Pau_cin_HAU}', "");
    Expect(0, 72447, '\P{Is_Blk= -Pau_cin_HAU}', "");
    Expect(1, 72447, '\P{^Is_Blk= -Pau_cin_HAU}', "");
    Expect(0, 72448, '\p{Is_Blk= -Pau_cin_HAU}', "");
    Expect(1, 72448, '\p{^Is_Blk= -Pau_cin_HAU}', "");
    Expect(1, 72448, '\P{Is_Blk= -Pau_cin_HAU}', "");
    Expect(0, 72448, '\P{^Is_Blk= -Pau_cin_HAU}', "");
    Error('\p{Block=/a/ Phags_pa}');
    Error('\P{Block=/a/ Phags_pa}');
    Expect(1, 43135, '\p{Block=:\APhags_Pa\z:}', "");;
    Expect(0, 43136, '\p{Block=:\APhags_Pa\z:}', "");;
    Expect(1, 43135, '\p{Block=phagspa}', "");
    Expect(0, 43135, '\p{^Block=phagspa}', "");
    Expect(0, 43135, '\P{Block=phagspa}', "");
    Expect(1, 43135, '\P{^Block=phagspa}', "");
    Expect(0, 43136, '\p{Block=phagspa}', "");
    Expect(1, 43136, '\p{^Block=phagspa}', "");
    Expect(1, 43136, '\P{Block=phagspa}', "");
    Expect(0, 43136, '\P{^Block=phagspa}', "");
    Expect(1, 43135, '\p{Block=:\Aphagspa\z:}', "");;
    Expect(0, 43136, '\p{Block=:\Aphagspa\z:}', "");;
    Expect(1, 43135, '\p{Block=__PHAGS_Pa}', "");
    Expect(0, 43135, '\p{^Block=__PHAGS_Pa}', "");
    Expect(0, 43135, '\P{Block=__PHAGS_Pa}', "");
    Expect(1, 43135, '\P{^Block=__PHAGS_Pa}', "");
    Expect(0, 43136, '\p{Block=__PHAGS_Pa}', "");
    Expect(1, 43136, '\p{^Block=__PHAGS_Pa}', "");
    Expect(1, 43136, '\P{Block=__PHAGS_Pa}', "");
    Expect(0, 43136, '\P{^Block=__PHAGS_Pa}', "");
    Error('\p{Blk=:=Phags_PA}');
    Error('\P{Blk=:=Phags_PA}');
    Expect(1, 43135, '\p{Blk=:\APhags_Pa\z:}', "");;
    Expect(0, 43136, '\p{Blk=:\APhags_Pa\z:}', "");;
    Expect(1, 43135, '\p{Blk=phagspa}', "");
    Expect(0, 43135, '\p{^Blk=phagspa}', "");
    Expect(0, 43135, '\P{Blk=phagspa}', "");
    Expect(1, 43135, '\P{^Blk=phagspa}', "");
    Expect(0, 43136, '\p{Blk=phagspa}', "");
    Expect(1, 43136, '\p{^Blk=phagspa}', "");
    Expect(1, 43136, '\P{Blk=phagspa}', "");
    Expect(0, 43136, '\P{^Blk=phagspa}', "");
    Expect(1, 43135, '\p{Blk=:\Aphagspa\z:}', "");;
    Expect(0, 43136, '\p{Blk=:\Aphagspa\z:}', "");;
    Expect(1, 43135, '\p{Blk=-	Phags_Pa}', "");
    Expect(0, 43135, '\p{^Blk=-	Phags_Pa}', "");
    Expect(0, 43135, '\P{Blk=-	Phags_Pa}', "");
    Expect(1, 43135, '\P{^Blk=-	Phags_Pa}', "");
    Expect(0, 43136, '\p{Blk=-	Phags_Pa}', "");
    Expect(1, 43136, '\p{^Blk=-	Phags_Pa}', "");
    Expect(1, 43136, '\P{Blk=-	Phags_Pa}', "");
    Expect(0, 43136, '\P{^Blk=-	Phags_Pa}', "");
    Error('\p{Is_Block=	 PHAGS_pa/a/}');
    Error('\P{Is_Block=	 PHAGS_pa/a/}');
    Expect(1, 43135, '\p{Is_Block=phagspa}', "");
    Expect(0, 43135, '\p{^Is_Block=phagspa}', "");
    Expect(0, 43135, '\P{Is_Block=phagspa}', "");
    Expect(1, 43135, '\P{^Is_Block=phagspa}', "");
    Expect(0, 43136, '\p{Is_Block=phagspa}', "");
    Expect(1, 43136, '\p{^Is_Block=phagspa}', "");
    Expect(1, 43136, '\P{Is_Block=phagspa}', "");
    Expect(0, 43136, '\P{^Is_Block=phagspa}', "");
    Expect(1, 43135, '\p{Is_Block=	phags_Pa}', "");
    Expect(0, 43135, '\p{^Is_Block=	phags_Pa}', "");
    Expect(0, 43135, '\P{Is_Block=	phags_Pa}', "");
    Expect(1, 43135, '\P{^Is_Block=	phags_Pa}', "");
    Expect(0, 43136, '\p{Is_Block=	phags_Pa}', "");
    Expect(1, 43136, '\p{^Is_Block=	phags_Pa}', "");
    Expect(1, 43136, '\P{Is_Block=	phags_Pa}', "");
    Expect(0, 43136, '\P{^Is_Block=	phags_Pa}', "");
    Error('\p{Is_Blk=/a/Phags_pa}');
    Error('\P{Is_Blk=/a/Phags_pa}');
    Expect(1, 43135, '\p{Is_Blk=phagspa}', "");
    Expect(0, 43135, '\p{^Is_Blk=phagspa}', "");
    Expect(0, 43135, '\P{Is_Blk=phagspa}', "");
    Expect(1, 43135, '\P{^Is_Blk=phagspa}', "");
    Expect(0, 43136, '\p{Is_Blk=phagspa}', "");
    Expect(1, 43136, '\p{^Is_Blk=phagspa}', "");
    Expect(1, 43136, '\P{Is_Blk=phagspa}', "");
    Expect(0, 43136, '\P{^Is_Blk=phagspa}', "");
    Expect(1, 43135, '\p{Is_Blk=_-Phags_pa}', "");
    Expect(0, 43135, '\p{^Is_Blk=_-Phags_pa}', "");
    Expect(0, 43135, '\P{Is_Blk=_-Phags_pa}', "");
    Expect(1, 43135, '\P{^Is_Blk=_-Phags_pa}', "");
    Expect(0, 43136, '\p{Is_Blk=_-Phags_pa}', "");
    Expect(1, 43136, '\p{^Is_Blk=_-Phags_pa}', "");
    Expect(1, 43136, '\P{Is_Blk=_-Phags_pa}', "");
    Expect(0, 43136, '\P{^Is_Blk=_-Phags_pa}', "");
    Error('\p{Block=  phaistos_Disc:=}');
    Error('\P{Block=  phaistos_Disc:=}');
    Expect(1, 66047, '\p{Block=:\APhaistos_Disc\z:}', "");;
    Expect(0, 66048, '\p{Block=:\APhaistos_Disc\z:}', "");;
    Expect(1, 66047, '\p{Block=phaistosdisc}', "");
    Expect(0, 66047, '\p{^Block=phaistosdisc}', "");
    Expect(0, 66047, '\P{Block=phaistosdisc}', "");
    Expect(1, 66047, '\P{^Block=phaistosdisc}', "");
    Expect(0, 66048, '\p{Block=phaistosdisc}', "");
    Expect(1, 66048, '\p{^Block=phaistosdisc}', "");
    Expect(1, 66048, '\P{Block=phaistosdisc}', "");
    Expect(0, 66048, '\P{^Block=phaistosdisc}', "");
    Expect(1, 66047, '\p{Block=:\Aphaistosdisc\z:}', "");;
    Expect(0, 66048, '\p{Block=:\Aphaistosdisc\z:}', "");;
    Expect(1, 66047, '\p{Block=	_PHAISTOS_Disc}', "");
    Expect(0, 66047, '\p{^Block=	_PHAISTOS_Disc}', "");
    Expect(0, 66047, '\P{Block=	_PHAISTOS_Disc}', "");
    Expect(1, 66047, '\P{^Block=	_PHAISTOS_Disc}', "");
    Expect(0, 66048, '\p{Block=	_PHAISTOS_Disc}', "");
    Expect(1, 66048, '\p{^Block=	_PHAISTOS_Disc}', "");
    Expect(1, 66048, '\P{Block=	_PHAISTOS_Disc}', "");
    Expect(0, 66048, '\P{^Block=	_PHAISTOS_Disc}', "");
    Error('\p{Blk= 	PHAISTOS:=}');
    Error('\P{Blk= 	PHAISTOS:=}');
    Expect(1, 66047, '\p{Blk=:\APhaistos\z:}', "");;
    Expect(0, 66048, '\p{Blk=:\APhaistos\z:}', "");;
    Expect(1, 66047, '\p{Blk=phaistos}', "");
    Expect(0, 66047, '\p{^Blk=phaistos}', "");
    Expect(0, 66047, '\P{Blk=phaistos}', "");
    Expect(1, 66047, '\P{^Blk=phaistos}', "");
    Expect(0, 66048, '\p{Blk=phaistos}', "");
    Expect(1, 66048, '\p{^Blk=phaistos}', "");
    Expect(1, 66048, '\P{Blk=phaistos}', "");
    Expect(0, 66048, '\P{^Blk=phaistos}', "");
    Expect(1, 66047, '\p{Blk=:\Aphaistos\z:}', "");;
    Expect(0, 66048, '\p{Blk=:\Aphaistos\z:}', "");;
    Expect(1, 66047, '\p{Blk=	PHAISTOS}', "");
    Expect(0, 66047, '\p{^Blk=	PHAISTOS}', "");
    Expect(0, 66047, '\P{Blk=	PHAISTOS}', "");
    Expect(1, 66047, '\P{^Blk=	PHAISTOS}', "");
    Expect(0, 66048, '\p{Blk=	PHAISTOS}', "");
    Expect(1, 66048, '\p{^Blk=	PHAISTOS}', "");
    Expect(1, 66048, '\P{Blk=	PHAISTOS}', "");
    Expect(0, 66048, '\P{^Blk=	PHAISTOS}', "");
    Error('\p{Is_Block= /a/phaistos_disc}');
    Error('\P{Is_Block= /a/phaistos_disc}');
    Expect(1, 66047, '\p{Is_Block=phaistosdisc}', "");
    Expect(0, 66047, '\p{^Is_Block=phaistosdisc}', "");
    Expect(0, 66047, '\P{Is_Block=phaistosdisc}', "");
    Expect(1, 66047, '\P{^Is_Block=phaistosdisc}', "");
    Expect(0, 66048, '\p{Is_Block=phaistosdisc}', "");
    Expect(1, 66048, '\p{^Is_Block=phaistosdisc}', "");
    Expect(1, 66048, '\P{Is_Block=phaistosdisc}', "");
    Expect(0, 66048, '\P{^Is_Block=phaistosdisc}', "");
    Expect(1, 66047, '\p{Is_Block=_-phaistos_disc}', "");
    Expect(0, 66047, '\p{^Is_Block=_-phaistos_disc}', "");
    Expect(0, 66047, '\P{Is_Block=_-phaistos_disc}', "");
    Expect(1, 66047, '\P{^Is_Block=_-phaistos_disc}', "");
    Expect(0, 66048, '\p{Is_Block=_-phaistos_disc}', "");
    Expect(1, 66048, '\p{^Is_Block=_-phaistos_disc}', "");
    Expect(1, 66048, '\P{Is_Block=_-phaistos_disc}', "");
    Expect(0, 66048, '\P{^Is_Block=_-phaistos_disc}', "");
    Error('\p{Is_Blk=/a/	Phaistos}');
    Error('\P{Is_Blk=/a/	Phaistos}');
    Expect(1, 66047, '\p{Is_Blk=phaistos}', "");
    Expect(0, 66047, '\p{^Is_Blk=phaistos}', "");
    Expect(0, 66047, '\P{Is_Blk=phaistos}', "");
    Expect(1, 66047, '\P{^Is_Blk=phaistos}', "");
    Expect(0, 66048, '\p{Is_Blk=phaistos}', "");
    Expect(1, 66048, '\p{^Is_Blk=phaistos}', "");
    Expect(1, 66048, '\P{Is_Blk=phaistos}', "");
    Expect(0, 66048, '\P{^Is_Blk=phaistos}', "");
    Expect(1, 66047, '\p{Is_Blk=	_phaistos}', "");
    Expect(0, 66047, '\p{^Is_Blk=	_phaistos}', "");
    Expect(0, 66047, '\P{Is_Blk=	_phaistos}', "");
    Expect(1, 66047, '\P{^Is_Blk=	_phaistos}', "");
    Expect(0, 66048, '\p{Is_Blk=	_phaistos}', "");
    Expect(1, 66048, '\p{^Is_Blk=	_phaistos}', "");
    Expect(1, 66048, '\P{Is_Blk=	_phaistos}', "");
    Expect(0, 66048, '\P{^Is_Blk=	_phaistos}', "");
    Error('\p{Block=- phoenician:=}');
    Error('\P{Block=- phoenician:=}');
    Expect(1, 67871, '\p{Block=:\APhoenician\z:}', "");;
    Expect(0, 67872, '\p{Block=:\APhoenician\z:}', "");;
    Expect(1, 67871, '\p{Block=phoenician}', "");
    Expect(0, 67871, '\p{^Block=phoenician}', "");
    Expect(0, 67871, '\P{Block=phoenician}', "");
    Expect(1, 67871, '\P{^Block=phoenician}', "");
    Expect(0, 67872, '\p{Block=phoenician}', "");
    Expect(1, 67872, '\p{^Block=phoenician}', "");
    Expect(1, 67872, '\P{Block=phoenician}', "");
    Expect(0, 67872, '\P{^Block=phoenician}', "");
    Expect(1, 67871, '\p{Block=:\Aphoenician\z:}', "");;
    Expect(0, 67872, '\p{Block=:\Aphoenician\z:}', "");;
    Expect(1, 67871, '\p{Block=- Phoenician}', "");
    Expect(0, 67871, '\p{^Block=- Phoenician}', "");
    Expect(0, 67871, '\P{Block=- Phoenician}', "");
    Expect(1, 67871, '\P{^Block=- Phoenician}', "");
    Expect(0, 67872, '\p{Block=- Phoenician}', "");
    Expect(1, 67872, '\p{^Block=- Phoenician}', "");
    Expect(1, 67872, '\P{Block=- Phoenician}', "");
    Expect(0, 67872, '\P{^Block=- Phoenician}', "");
    Error('\p{Blk=	 Phoenician:=}');
    Error('\P{Blk=	 Phoenician:=}');
    Expect(1, 67871, '\p{Blk=:\APhoenician\z:}', "");;
    Expect(0, 67872, '\p{Blk=:\APhoenician\z:}', "");;
    Expect(1, 67871, '\p{Blk=phoenician}', "");
    Expect(0, 67871, '\p{^Blk=phoenician}', "");
    Expect(0, 67871, '\P{Blk=phoenician}', "");
    Expect(1, 67871, '\P{^Blk=phoenician}', "");
    Expect(0, 67872, '\p{Blk=phoenician}', "");
    Expect(1, 67872, '\p{^Blk=phoenician}', "");
    Expect(1, 67872, '\P{Blk=phoenician}', "");
    Expect(0, 67872, '\P{^Blk=phoenician}', "");
    Expect(1, 67871, '\p{Blk=:\Aphoenician\z:}', "");;
    Expect(0, 67872, '\p{Blk=:\Aphoenician\z:}', "");;
    Expect(1, 67871, '\p{Blk=_ PHOENICIAN}', "");
    Expect(0, 67871, '\p{^Blk=_ PHOENICIAN}', "");
    Expect(0, 67871, '\P{Blk=_ PHOENICIAN}', "");
    Expect(1, 67871, '\P{^Blk=_ PHOENICIAN}', "");
    Expect(0, 67872, '\p{Blk=_ PHOENICIAN}', "");
    Expect(1, 67872, '\p{^Blk=_ PHOENICIAN}', "");
    Expect(1, 67872, '\P{Blk=_ PHOENICIAN}', "");
    Expect(0, 67872, '\P{^Blk=_ PHOENICIAN}', "");
    Error('\p{Is_Block=-_Phoenician:=}');
    Error('\P{Is_Block=-_Phoenician:=}');
    Expect(1, 67871, '\p{Is_Block=phoenician}', "");
    Expect(0, 67871, '\p{^Is_Block=phoenician}', "");
    Expect(0, 67871, '\P{Is_Block=phoenician}', "");
    Expect(1, 67871, '\P{^Is_Block=phoenician}', "");
    Expect(0, 67872, '\p{Is_Block=phoenician}', "");
    Expect(1, 67872, '\p{^Is_Block=phoenician}', "");
    Expect(1, 67872, '\P{Is_Block=phoenician}', "");
    Expect(0, 67872, '\P{^Is_Block=phoenician}', "");
    Expect(1, 67871, '\p{Is_Block=	_Phoenician}', "");
    Expect(0, 67871, '\p{^Is_Block=	_Phoenician}', "");
    Expect(0, 67871, '\P{Is_Block=	_Phoenician}', "");
    Expect(1, 67871, '\P{^Is_Block=	_Phoenician}', "");
    Expect(0, 67872, '\p{Is_Block=	_Phoenician}', "");
    Expect(1, 67872, '\p{^Is_Block=	_Phoenician}', "");
    Expect(1, 67872, '\P{Is_Block=	_Phoenician}', "");
    Expect(0, 67872, '\P{^Is_Block=	_Phoenician}', "");
    Error('\p{Is_Blk=	/a/Phoenician}');
    Error('\P{Is_Blk=	/a/Phoenician}');
    Expect(1, 67871, '\p{Is_Blk=phoenician}', "");
    Expect(0, 67871, '\p{^Is_Blk=phoenician}', "");
    Expect(0, 67871, '\P{Is_Blk=phoenician}', "");
    Expect(1, 67871, '\P{^Is_Blk=phoenician}', "");
    Expect(0, 67872, '\p{Is_Blk=phoenician}', "");
    Expect(1, 67872, '\p{^Is_Blk=phoenician}', "");
    Expect(1, 67872, '\P{Is_Blk=phoenician}', "");
    Expect(0, 67872, '\P{^Is_Blk=phoenician}', "");
    Expect(1, 67871, '\p{Is_Blk= phoenician}', "");
    Expect(0, 67871, '\p{^Is_Blk= phoenician}', "");
    Expect(0, 67871, '\P{Is_Blk= phoenician}', "");
    Expect(1, 67871, '\P{^Is_Blk= phoenician}', "");
    Expect(0, 67872, '\p{Is_Blk= phoenician}', "");
    Expect(1, 67872, '\p{^Is_Blk= phoenician}', "");
    Expect(1, 67872, '\P{Is_Blk= phoenician}', "");
    Expect(0, 67872, '\P{^Is_Blk= phoenician}', "");
    Error('\p{Block=/a/	Phonetic_extensions}');
    Error('\P{Block=/a/	Phonetic_extensions}');
    Expect(1, 7551, '\p{Block=:\APhonetic_Extensions\z:}', "");;
    Expect(0, 7552, '\p{Block=:\APhonetic_Extensions\z:}', "");;
    Expect(1, 7551, '\p{Block=phoneticextensions}', "");
    Expect(0, 7551, '\p{^Block=phoneticextensions}', "");
    Expect(0, 7551, '\P{Block=phoneticextensions}', "");
    Expect(1, 7551, '\P{^Block=phoneticextensions}', "");
    Expect(0, 7552, '\p{Block=phoneticextensions}', "");
    Expect(1, 7552, '\p{^Block=phoneticextensions}', "");
    Expect(1, 7552, '\P{Block=phoneticextensions}', "");
    Expect(0, 7552, '\P{^Block=phoneticextensions}', "");
    Expect(1, 7551, '\p{Block=:\Aphoneticextensions\z:}', "");;
    Expect(0, 7552, '\p{Block=:\Aphoneticextensions\z:}', "");;
    Expect(1, 7551, '\p{Block= 	Phonetic_extensions}', "");
    Expect(0, 7551, '\p{^Block= 	Phonetic_extensions}', "");
    Expect(0, 7551, '\P{Block= 	Phonetic_extensions}', "");
    Expect(1, 7551, '\P{^Block= 	Phonetic_extensions}', "");
    Expect(0, 7552, '\p{Block= 	Phonetic_extensions}', "");
    Expect(1, 7552, '\p{^Block= 	Phonetic_extensions}', "");
    Expect(1, 7552, '\P{Block= 	Phonetic_extensions}', "");
    Expect(0, 7552, '\P{^Block= 	Phonetic_extensions}', "");
    Error('\p{Blk:   -/a/PHONETIC_Ext}');
    Error('\P{Blk:   -/a/PHONETIC_Ext}');
    Expect(1, 7551, '\p{Blk=:\APhonetic_Ext\z:}', "");;
    Expect(0, 7552, '\p{Blk=:\APhonetic_Ext\z:}', "");;
    Expect(1, 7551, '\p{Blk=phoneticext}', "");
    Expect(0, 7551, '\p{^Blk=phoneticext}', "");
    Expect(0, 7551, '\P{Blk=phoneticext}', "");
    Expect(1, 7551, '\P{^Blk=phoneticext}', "");
    Expect(0, 7552, '\p{Blk=phoneticext}', "");
    Expect(1, 7552, '\p{^Blk=phoneticext}', "");
    Expect(1, 7552, '\P{Blk=phoneticext}', "");
    Expect(0, 7552, '\P{^Blk=phoneticext}', "");
    Expect(1, 7551, '\p{Blk=:\Aphoneticext\z:}', "");;
    Expect(0, 7552, '\p{Blk=:\Aphoneticext\z:}', "");;
    Expect(1, 7551, '\p{Blk:_	Phonetic_Ext}', "");
    Expect(0, 7551, '\p{^Blk:_	Phonetic_Ext}', "");
    Expect(0, 7551, '\P{Blk:_	Phonetic_Ext}', "");
    Expect(1, 7551, '\P{^Blk:_	Phonetic_Ext}', "");
    Expect(0, 7552, '\p{Blk:_	Phonetic_Ext}', "");
    Expect(1, 7552, '\p{^Blk:_	Phonetic_Ext}', "");
    Expect(1, 7552, '\P{Blk:_	Phonetic_Ext}', "");
    Expect(0, 7552, '\P{^Blk:_	Phonetic_Ext}', "");
    Error('\p{Is_Block=/a/-Phonetic_extensions}');
    Error('\P{Is_Block=/a/-Phonetic_extensions}');
    Expect(1, 7551, '\p{Is_Block=phoneticextensions}', "");
    Expect(0, 7551, '\p{^Is_Block=phoneticextensions}', "");
    Expect(0, 7551, '\P{Is_Block=phoneticextensions}', "");
    Expect(1, 7551, '\P{^Is_Block=phoneticextensions}', "");
    Expect(0, 7552, '\p{Is_Block=phoneticextensions}', "");
    Expect(1, 7552, '\p{^Is_Block=phoneticextensions}', "");
    Expect(1, 7552, '\P{Is_Block=phoneticextensions}', "");
    Expect(0, 7552, '\P{^Is_Block=phoneticextensions}', "");
    Expect(1, 7551, '\p{Is_Block=- Phonetic_EXTENSIONS}', "");
    Expect(0, 7551, '\p{^Is_Block=- Phonetic_EXTENSIONS}', "");
    Expect(0, 7551, '\P{Is_Block=- Phonetic_EXTENSIONS}', "");
    Expect(1, 7551, '\P{^Is_Block=- Phonetic_EXTENSIONS}', "");
    Expect(0, 7552, '\p{Is_Block=- Phonetic_EXTENSIONS}', "");
    Expect(1, 7552, '\p{^Is_Block=- Phonetic_EXTENSIONS}', "");
    Expect(1, 7552, '\P{Is_Block=- Phonetic_EXTENSIONS}', "");
    Expect(0, 7552, '\P{^Is_Block=- Phonetic_EXTENSIONS}', "");
    Error('\p{Is_Blk=/a/phonetic_EXT}');
    Error('\P{Is_Blk=/a/phonetic_EXT}');
    Expect(1, 7551, '\p{Is_Blk=phoneticext}', "");
    Expect(0, 7551, '\p{^Is_Blk=phoneticext}', "");
    Expect(0, 7551, '\P{Is_Blk=phoneticext}', "");
    Expect(1, 7551, '\P{^Is_Blk=phoneticext}', "");
    Expect(0, 7552, '\p{Is_Blk=phoneticext}', "");
    Expect(1, 7552, '\p{^Is_Blk=phoneticext}', "");
    Expect(1, 7552, '\P{Is_Blk=phoneticext}', "");
    Expect(0, 7552, '\P{^Is_Blk=phoneticext}', "");
    Expect(1, 7551, '\p{Is_Blk:	 phonetic_ext}', "");
    Expect(0, 7551, '\p{^Is_Blk:	 phonetic_ext}', "");
    Expect(0, 7551, '\P{Is_Blk:	 phonetic_ext}', "");
    Expect(1, 7551, '\P{^Is_Blk:	 phonetic_ext}', "");
    Expect(0, 7552, '\p{Is_Blk:	 phonetic_ext}', "");
    Expect(1, 7552, '\p{^Is_Blk:	 phonetic_ext}', "");
    Expect(1, 7552, '\P{Is_Blk:	 phonetic_ext}', "");
    Expect(0, 7552, '\P{^Is_Blk:	 phonetic_ext}', "");
    Error('\p{Block=		phonetic_EXTENSIONS_supplement:=}');
    Error('\P{Block=		phonetic_EXTENSIONS_supplement:=}');
    Expect(1, 7615, '\p{Block=:\APhonetic_Extensions_Supplement\z:}', "");;
    Expect(0, 7616, '\p{Block=:\APhonetic_Extensions_Supplement\z:}', "");;
    Expect(1, 7615, '\p{Block=phoneticextensionssupplement}', "");
    Expect(0, 7615, '\p{^Block=phoneticextensionssupplement}', "");
    Expect(0, 7615, '\P{Block=phoneticextensionssupplement}', "");
    Expect(1, 7615, '\P{^Block=phoneticextensionssupplement}', "");
    Expect(0, 7616, '\p{Block=phoneticextensionssupplement}', "");
    Expect(1, 7616, '\p{^Block=phoneticextensionssupplement}', "");
    Expect(1, 7616, '\P{Block=phoneticextensionssupplement}', "");
    Expect(0, 7616, '\P{^Block=phoneticextensionssupplement}', "");
    Expect(1, 7615, '\p{Block=:\Aphoneticextensionssupplement\z:}', "");;
    Expect(0, 7616, '\p{Block=:\Aphoneticextensionssupplement\z:}', "");;
    Expect(1, 7615, '\p{Block:			PHONETIC_EXTENSIONS_supplement}', "");
    Expect(0, 7615, '\p{^Block:			PHONETIC_EXTENSIONS_supplement}', "");
    Expect(0, 7615, '\P{Block:			PHONETIC_EXTENSIONS_supplement}', "");
    Expect(1, 7615, '\P{^Block:			PHONETIC_EXTENSIONS_supplement}', "");
    Expect(0, 7616, '\p{Block:			PHONETIC_EXTENSIONS_supplement}', "");
    Expect(1, 7616, '\p{^Block:			PHONETIC_EXTENSIONS_supplement}', "");
    Expect(1, 7616, '\P{Block:			PHONETIC_EXTENSIONS_supplement}', "");
    Expect(0, 7616, '\P{^Block:			PHONETIC_EXTENSIONS_supplement}', "");
    Error('\p{Blk:	:=- Phonetic_EXT_Sup}');
    Error('\P{Blk:	:=- Phonetic_EXT_Sup}');
    Expect(1, 7615, '\p{Blk=:\APhonetic_Ext_Sup\z:}', "");;
    Expect(0, 7616, '\p{Blk=:\APhonetic_Ext_Sup\z:}', "");;
    Expect(1, 7615, '\p{Blk=phoneticextsup}', "");
    Expect(0, 7615, '\p{^Blk=phoneticextsup}', "");
    Expect(0, 7615, '\P{Blk=phoneticextsup}', "");
    Expect(1, 7615, '\P{^Blk=phoneticextsup}', "");
    Expect(0, 7616, '\p{Blk=phoneticextsup}', "");
    Expect(1, 7616, '\p{^Blk=phoneticextsup}', "");
    Expect(1, 7616, '\P{Blk=phoneticextsup}', "");
    Expect(0, 7616, '\P{^Blk=phoneticextsup}', "");
    Expect(1, 7615, '\p{Blk=:\Aphoneticextsup\z:}', "");;
    Expect(0, 7616, '\p{Blk=:\Aphoneticextsup\z:}', "");;
    Expect(1, 7615, '\p{Blk=_ Phonetic_ext_SUP}', "");
    Expect(0, 7615, '\p{^Blk=_ Phonetic_ext_SUP}', "");
    Expect(0, 7615, '\P{Blk=_ Phonetic_ext_SUP}', "");
    Expect(1, 7615, '\P{^Blk=_ Phonetic_ext_SUP}', "");
    Expect(0, 7616, '\p{Blk=_ Phonetic_ext_SUP}', "");
    Expect(1, 7616, '\p{^Blk=_ Phonetic_ext_SUP}', "");
    Expect(1, 7616, '\P{Blk=_ Phonetic_ext_SUP}', "");
    Expect(0, 7616, '\P{^Blk=_ Phonetic_ext_SUP}', "");
    Error('\p{Is_Block=:=_PHONETIC_Extensions_supplement}');
    Error('\P{Is_Block=:=_PHONETIC_Extensions_supplement}');
    Expect(1, 7615, '\p{Is_Block=phoneticextensionssupplement}', "");
    Expect(0, 7615, '\p{^Is_Block=phoneticextensionssupplement}', "");
    Expect(0, 7615, '\P{Is_Block=phoneticextensionssupplement}', "");
    Expect(1, 7615, '\P{^Is_Block=phoneticextensionssupplement}', "");
    Expect(0, 7616, '\p{Is_Block=phoneticextensionssupplement}', "");
    Expect(1, 7616, '\p{^Is_Block=phoneticextensionssupplement}', "");
    Expect(1, 7616, '\P{Is_Block=phoneticextensionssupplement}', "");
    Expect(0, 7616, '\P{^Is_Block=phoneticextensionssupplement}', "");
    Expect(1, 7615, '\p{Is_Block= 	Phonetic_Extensions_supplement}', "");
    Expect(0, 7615, '\p{^Is_Block= 	Phonetic_Extensions_supplement}', "");
    Expect(0, 7615, '\P{Is_Block= 	Phonetic_Extensions_supplement}', "");
    Expect(1, 7615, '\P{^Is_Block= 	Phonetic_Extensions_supplement}', "");
    Expect(0, 7616, '\p{Is_Block= 	Phonetic_Extensions_supplement}', "");
    Expect(1, 7616, '\p{^Is_Block= 	Phonetic_Extensions_supplement}', "");
    Expect(1, 7616, '\P{Is_Block= 	Phonetic_Extensions_supplement}', "");
    Expect(0, 7616, '\P{^Is_Block= 	Phonetic_Extensions_supplement}', "");
    Error('\p{Is_Blk=:=_	PHONETIC_EXT_SUP}');
    Error('\P{Is_Blk=:=_	PHONETIC_EXT_SUP}');
    Expect(1, 7615, '\p{Is_Blk=phoneticextsup}', "");
    Expect(0, 7615, '\p{^Is_Blk=phoneticextsup}', "");
    Expect(0, 7615, '\P{Is_Blk=phoneticextsup}', "");
    Expect(1, 7615, '\P{^Is_Blk=phoneticextsup}', "");
    Expect(0, 7616, '\p{Is_Blk=phoneticextsup}', "");
    Expect(1, 7616, '\p{^Is_Blk=phoneticextsup}', "");
    Expect(1, 7616, '\P{Is_Blk=phoneticextsup}', "");
    Expect(0, 7616, '\P{^Is_Blk=phoneticextsup}', "");
    Expect(1, 7615, '\p{Is_Blk=	 phonetic_EXT_Sup}', "");
    Expect(0, 7615, '\p{^Is_Blk=	 phonetic_EXT_Sup}', "");
    Expect(0, 7615, '\P{Is_Blk=	 phonetic_EXT_Sup}', "");
    Expect(1, 7615, '\P{^Is_Blk=	 phonetic_EXT_Sup}', "");
    Expect(0, 7616, '\p{Is_Blk=	 phonetic_EXT_Sup}', "");
    Expect(1, 7616, '\p{^Is_Blk=	 phonetic_EXT_Sup}', "");
    Expect(1, 7616, '\P{Is_Blk=	 phonetic_EXT_Sup}', "");
    Expect(0, 7616, '\P{^Is_Blk=	 phonetic_EXT_Sup}', "");
    Error('\p{Block=Playing_Cards:=}');
    Error('\P{Block=Playing_Cards:=}');
    Expect(1, 127231, '\p{Block=:\APlaying_Cards\z:}', "");;
    Expect(0, 127232, '\p{Block=:\APlaying_Cards\z:}', "");;
    Expect(1, 127231, '\p{Block=playingcards}', "");
    Expect(0, 127231, '\p{^Block=playingcards}', "");
    Expect(0, 127231, '\P{Block=playingcards}', "");
    Expect(1, 127231, '\P{^Block=playingcards}', "");
    Expect(0, 127232, '\p{Block=playingcards}', "");
    Expect(1, 127232, '\p{^Block=playingcards}', "");
    Expect(1, 127232, '\P{Block=playingcards}', "");
    Expect(0, 127232, '\P{^Block=playingcards}', "");
    Expect(1, 127231, '\p{Block=:\Aplayingcards\z:}', "");;
    Expect(0, 127232, '\p{Block=:\Aplayingcards\z:}', "");;
    Expect(1, 127231, '\p{Block=- PLAYING_CARDS}', "");
    Expect(0, 127231, '\p{^Block=- PLAYING_CARDS}', "");
    Expect(0, 127231, '\P{Block=- PLAYING_CARDS}', "");
    Expect(1, 127231, '\P{^Block=- PLAYING_CARDS}', "");
    Expect(0, 127232, '\p{Block=- PLAYING_CARDS}', "");
    Expect(1, 127232, '\p{^Block=- PLAYING_CARDS}', "");
    Expect(1, 127232, '\P{Block=- PLAYING_CARDS}', "");
    Expect(0, 127232, '\P{^Block=- PLAYING_CARDS}', "");
    Error('\p{Blk=/a/-Playing_cards}');
    Error('\P{Blk=/a/-Playing_cards}');
    Expect(1, 127231, '\p{Blk=:\APlaying_Cards\z:}', "");;
    Expect(0, 127232, '\p{Blk=:\APlaying_Cards\z:}', "");;
    Expect(1, 127231, '\p{Blk=playingcards}', "");
    Expect(0, 127231, '\p{^Blk=playingcards}', "");
    Expect(0, 127231, '\P{Blk=playingcards}', "");
    Expect(1, 127231, '\P{^Blk=playingcards}', "");
    Expect(0, 127232, '\p{Blk=playingcards}', "");
    Expect(1, 127232, '\p{^Blk=playingcards}', "");
    Expect(1, 127232, '\P{Blk=playingcards}', "");
    Expect(0, 127232, '\P{^Blk=playingcards}', "");
    Expect(1, 127231, '\p{Blk=:\Aplayingcards\z:}', "");;
    Expect(0, 127232, '\p{Blk=:\Aplayingcards\z:}', "");;
    Expect(1, 127231, '\p{Blk=--playing_Cards}', "");
    Expect(0, 127231, '\p{^Blk=--playing_Cards}', "");
    Expect(0, 127231, '\P{Blk=--playing_Cards}', "");
    Expect(1, 127231, '\P{^Blk=--playing_Cards}', "");
    Expect(0, 127232, '\p{Blk=--playing_Cards}', "");
    Expect(1, 127232, '\p{^Blk=--playing_Cards}', "");
    Expect(1, 127232, '\P{Blk=--playing_Cards}', "");
    Expect(0, 127232, '\P{^Blk=--playing_Cards}', "");
    Error('\p{Is_Block=/a/PLAYING_CARDS}');
    Error('\P{Is_Block=/a/PLAYING_CARDS}');
    Expect(1, 127231, '\p{Is_Block=playingcards}', "");
    Expect(0, 127231, '\p{^Is_Block=playingcards}', "");
    Expect(0, 127231, '\P{Is_Block=playingcards}', "");
    Expect(1, 127231, '\P{^Is_Block=playingcards}', "");
    Expect(0, 127232, '\p{Is_Block=playingcards}', "");
    Expect(1, 127232, '\p{^Is_Block=playingcards}', "");
    Expect(1, 127232, '\P{Is_Block=playingcards}', "");
    Expect(0, 127232, '\P{^Is_Block=playingcards}', "");
    Expect(1, 127231, '\p{Is_Block= _playing_Cards}', "");
    Expect(0, 127231, '\p{^Is_Block= _playing_Cards}', "");
    Expect(0, 127231, '\P{Is_Block= _playing_Cards}', "");
    Expect(1, 127231, '\P{^Is_Block= _playing_Cards}', "");
    Expect(0, 127232, '\p{Is_Block= _playing_Cards}', "");
    Expect(1, 127232, '\p{^Is_Block= _playing_Cards}', "");
    Expect(1, 127232, '\P{Is_Block= _playing_Cards}', "");
    Expect(0, 127232, '\P{^Is_Block= _playing_Cards}', "");
    Error('\p{Is_Blk=	/a/Playing_cards}');
    Error('\P{Is_Blk=	/a/Playing_cards}');
    Expect(1, 127231, '\p{Is_Blk: playingcards}', "");
    Expect(0, 127231, '\p{^Is_Blk: playingcards}', "");
    Expect(0, 127231, '\P{Is_Blk: playingcards}', "");
    Expect(1, 127231, '\P{^Is_Blk: playingcards}', "");
    Expect(0, 127232, '\p{Is_Blk: playingcards}', "");
    Expect(1, 127232, '\p{^Is_Blk: playingcards}', "");
    Expect(1, 127232, '\P{Is_Blk: playingcards}', "");
    Expect(0, 127232, '\P{^Is_Blk: playingcards}', "");
    Expect(1, 127231, '\p{Is_Blk=_Playing_CARDS}', "");
    Expect(0, 127231, '\p{^Is_Blk=_Playing_CARDS}', "");
    Expect(0, 127231, '\P{Is_Blk=_Playing_CARDS}', "");
    Expect(1, 127231, '\P{^Is_Blk=_Playing_CARDS}', "");
    Expect(0, 127232, '\p{Is_Blk=_Playing_CARDS}', "");
    Expect(1, 127232, '\p{^Is_Blk=_Playing_CARDS}', "");
    Expect(1, 127232, '\P{Is_Blk=_Playing_CARDS}', "");
    Expect(0, 127232, '\P{^Is_Blk=_Playing_CARDS}', "");
    Error('\p{Block= 	psalter_Pahlavi/a/}');
    Error('\P{Block= 	psalter_Pahlavi/a/}');
    Expect(1, 68527, '\p{Block=:\APsalter_Pahlavi\z:}', "");;
    Expect(0, 68528, '\p{Block=:\APsalter_Pahlavi\z:}', "");;
    Expect(1, 68527, '\p{Block=psalterpahlavi}', "");
    Expect(0, 68527, '\p{^Block=psalterpahlavi}', "");
    Expect(0, 68527, '\P{Block=psalterpahlavi}', "");
    Expect(1, 68527, '\P{^Block=psalterpahlavi}', "");
    Expect(0, 68528, '\p{Block=psalterpahlavi}', "");
    Expect(1, 68528, '\p{^Block=psalterpahlavi}', "");
    Expect(1, 68528, '\P{Block=psalterpahlavi}', "");
    Expect(0, 68528, '\P{^Block=psalterpahlavi}', "");
    Expect(1, 68527, '\p{Block=:\Apsalterpahlavi\z:}', "");;
    Expect(0, 68528, '\p{Block=:\Apsalterpahlavi\z:}', "");;
    Expect(1, 68527, '\p{Block=  psalter_Pahlavi}', "");
    Expect(0, 68527, '\p{^Block=  psalter_Pahlavi}', "");
    Expect(0, 68527, '\P{Block=  psalter_Pahlavi}', "");
    Expect(1, 68527, '\P{^Block=  psalter_Pahlavi}', "");
    Expect(0, 68528, '\p{Block=  psalter_Pahlavi}', "");
    Expect(1, 68528, '\p{^Block=  psalter_Pahlavi}', "");
    Expect(1, 68528, '\P{Block=  psalter_Pahlavi}', "");
    Expect(0, 68528, '\P{^Block=  psalter_Pahlavi}', "");
    Error('\p{Blk:   /a/-PSALTER_pahlavi}');
    Error('\P{Blk:   /a/-PSALTER_pahlavi}');
    Expect(1, 68527, '\p{Blk=:\APsalter_Pahlavi\z:}', "");;
    Expect(0, 68528, '\p{Blk=:\APsalter_Pahlavi\z:}', "");;
    Expect(1, 68527, '\p{Blk=psalterpahlavi}', "");
    Expect(0, 68527, '\p{^Blk=psalterpahlavi}', "");
    Expect(0, 68527, '\P{Blk=psalterpahlavi}', "");
    Expect(1, 68527, '\P{^Blk=psalterpahlavi}', "");
    Expect(0, 68528, '\p{Blk=psalterpahlavi}', "");
    Expect(1, 68528, '\p{^Blk=psalterpahlavi}', "");
    Expect(1, 68528, '\P{Blk=psalterpahlavi}', "");
    Expect(0, 68528, '\P{^Blk=psalterpahlavi}', "");
    Expect(1, 68527, '\p{Blk=:\Apsalterpahlavi\z:}', "");;
    Expect(0, 68528, '\p{Blk=:\Apsalterpahlavi\z:}', "");;
    Expect(1, 68527, '\p{Blk=		psalter_PAHLAVI}', "");
    Expect(0, 68527, '\p{^Blk=		psalter_PAHLAVI}', "");
    Expect(0, 68527, '\P{Blk=		psalter_PAHLAVI}', "");
    Expect(1, 68527, '\P{^Blk=		psalter_PAHLAVI}', "");
    Expect(0, 68528, '\p{Blk=		psalter_PAHLAVI}', "");
    Expect(1, 68528, '\p{^Blk=		psalter_PAHLAVI}', "");
    Expect(1, 68528, '\P{Blk=		psalter_PAHLAVI}', "");
    Expect(0, 68528, '\P{^Blk=		psalter_PAHLAVI}', "");
    Error('\p{Is_Block=:=_ PSALTER_Pahlavi}');
    Error('\P{Is_Block=:=_ PSALTER_Pahlavi}');
    Expect(1, 68527, '\p{Is_Block=psalterpahlavi}', "");
    Expect(0, 68527, '\p{^Is_Block=psalterpahlavi}', "");
    Expect(0, 68527, '\P{Is_Block=psalterpahlavi}', "");
    Expect(1, 68527, '\P{^Is_Block=psalterpahlavi}', "");
    Expect(0, 68528, '\p{Is_Block=psalterpahlavi}', "");
    Expect(1, 68528, '\p{^Is_Block=psalterpahlavi}', "");
    Expect(1, 68528, '\P{Is_Block=psalterpahlavi}', "");
    Expect(0, 68528, '\P{^Is_Block=psalterpahlavi}', "");
    Expect(1, 68527, '\p{Is_Block=_Psalter_pahlavi}', "");
    Expect(0, 68527, '\p{^Is_Block=_Psalter_pahlavi}', "");
    Expect(0, 68527, '\P{Is_Block=_Psalter_pahlavi}', "");
    Expect(1, 68527, '\P{^Is_Block=_Psalter_pahlavi}', "");
    Expect(0, 68528, '\p{Is_Block=_Psalter_pahlavi}', "");
    Expect(1, 68528, '\p{^Is_Block=_Psalter_pahlavi}', "");
    Expect(1, 68528, '\P{Is_Block=_Psalter_pahlavi}', "");
    Expect(0, 68528, '\P{^Is_Block=_Psalter_pahlavi}', "");
    Error('\p{Is_Blk=_-PSALTER_pahlavi/a/}');
    Error('\P{Is_Blk=_-PSALTER_pahlavi/a/}');
    Expect(1, 68527, '\p{Is_Blk=psalterpahlavi}', "");
    Expect(0, 68527, '\p{^Is_Blk=psalterpahlavi}', "");
    Expect(0, 68527, '\P{Is_Blk=psalterpahlavi}', "");
    Expect(1, 68527, '\P{^Is_Blk=psalterpahlavi}', "");
    Expect(0, 68528, '\p{Is_Blk=psalterpahlavi}', "");
    Expect(1, 68528, '\p{^Is_Blk=psalterpahlavi}', "");
    Expect(1, 68528, '\P{Is_Blk=psalterpahlavi}', "");
    Expect(0, 68528, '\P{^Is_Blk=psalterpahlavi}', "");
    Expect(1, 68527, '\p{Is_Blk=__Psalter_PAHLAVI}', "");
    Expect(0, 68527, '\p{^Is_Blk=__Psalter_PAHLAVI}', "");
    Expect(0, 68527, '\P{Is_Blk=__Psalter_PAHLAVI}', "");
    Expect(1, 68527, '\P{^Is_Blk=__Psalter_PAHLAVI}', "");
    Expect(0, 68528, '\p{Is_Blk=__Psalter_PAHLAVI}', "");
    Expect(1, 68528, '\p{^Is_Blk=__Psalter_PAHLAVI}', "");
    Expect(1, 68528, '\P{Is_Blk=__Psalter_PAHLAVI}', "");
    Expect(0, 68528, '\P{^Is_Blk=__Psalter_PAHLAVI}', "");
    Error('\p{Block:	:=-_private_Use_AREA}');
    Error('\P{Block:	:=-_private_Use_AREA}');
    Expect(1, 63743, '\p{Block=:\APrivate_Use_Area\z:}', "");;
    Expect(0, 63744, '\p{Block=:\APrivate_Use_Area\z:}', "");;
    Expect(1, 63743, '\p{Block=privateusearea}', "");
    Expect(0, 63743, '\p{^Block=privateusearea}', "");
    Expect(0, 63743, '\P{Block=privateusearea}', "");
    Expect(1, 63743, '\P{^Block=privateusearea}', "");
    Expect(0, 63744, '\p{Block=privateusearea}', "");
    Expect(1, 63744, '\p{^Block=privateusearea}', "");
    Expect(1, 63744, '\P{Block=privateusearea}', "");
    Expect(0, 63744, '\P{^Block=privateusearea}', "");
    Expect(1, 63743, '\p{Block=:\Aprivateusearea\z:}', "");;
    Expect(0, 63744, '\p{Block=:\Aprivateusearea\z:}', "");;
    Expect(1, 63743, '\p{Block=_Private_Use_Area}', "");
    Expect(0, 63743, '\p{^Block=_Private_Use_Area}', "");
    Expect(0, 63743, '\P{Block=_Private_Use_Area}', "");
    Expect(1, 63743, '\P{^Block=_Private_Use_Area}', "");
    Expect(0, 63744, '\p{Block=_Private_Use_Area}', "");
    Expect(1, 63744, '\p{^Block=_Private_Use_Area}', "");
    Expect(1, 63744, '\P{Block=_Private_Use_Area}', "");
    Expect(0, 63744, '\P{^Block=_Private_Use_Area}', "");
    Error('\p{Blk=:=	_PUA}');
    Error('\P{Blk=:=	_PUA}');
    Expect(1, 63743, '\p{Blk=:\APUA\z:}', "");;
    Expect(0, 63744, '\p{Blk=:\APUA\z:}', "");;
    Expect(1, 63743, '\p{Blk=pua}', "");
    Expect(0, 63743, '\p{^Blk=pua}', "");
    Expect(0, 63743, '\P{Blk=pua}', "");
    Expect(1, 63743, '\P{^Blk=pua}', "");
    Expect(0, 63744, '\p{Blk=pua}', "");
    Expect(1, 63744, '\p{^Blk=pua}', "");
    Expect(1, 63744, '\P{Blk=pua}', "");
    Expect(0, 63744, '\P{^Blk=pua}', "");
    Expect(1, 63743, '\p{Blk=:\Apua\z:}', "");;
    Expect(0, 63744, '\p{Blk=:\Apua\z:}', "");;
    Expect(1, 63743, '\p{Blk= _pua}', "");
    Expect(0, 63743, '\p{^Blk= _pua}', "");
    Expect(0, 63743, '\P{Blk= _pua}', "");
    Expect(1, 63743, '\P{^Blk= _pua}', "");
    Expect(0, 63744, '\p{Blk= _pua}', "");
    Expect(1, 63744, '\p{^Blk= _pua}', "");
    Expect(1, 63744, '\P{Blk= _pua}', "");
    Expect(0, 63744, '\P{^Blk= _pua}', "");
    Error('\p{Is_Block= -PRIVATE_use:=}');
    Error('\P{Is_Block= -PRIVATE_use:=}');
    Expect(1, 63743, '\p{Is_Block=privateuse}', "");
    Expect(0, 63743, '\p{^Is_Block=privateuse}', "");
    Expect(0, 63743, '\P{Is_Block=privateuse}', "");
    Expect(1, 63743, '\P{^Is_Block=privateuse}', "");
    Expect(0, 63744, '\p{Is_Block=privateuse}', "");
    Expect(1, 63744, '\p{^Is_Block=privateuse}', "");
    Expect(1, 63744, '\P{Is_Block=privateuse}', "");
    Expect(0, 63744, '\P{^Is_Block=privateuse}', "");
    Expect(1, 63743, '\p{Is_Block=-	PRIVATE_Use}', "");
    Expect(0, 63743, '\p{^Is_Block=-	PRIVATE_Use}', "");
    Expect(0, 63743, '\P{Is_Block=-	PRIVATE_Use}', "");
    Expect(1, 63743, '\P{^Is_Block=-	PRIVATE_Use}', "");
    Expect(0, 63744, '\p{Is_Block=-	PRIVATE_Use}', "");
    Expect(1, 63744, '\p{^Is_Block=-	PRIVATE_Use}', "");
    Expect(1, 63744, '\P{Is_Block=-	PRIVATE_Use}', "");
    Expect(0, 63744, '\P{^Is_Block=-	PRIVATE_Use}', "");
    Error('\p{Is_Blk=/a/private_use_Area}');
    Error('\P{Is_Blk=/a/private_use_Area}');
    Expect(1, 63743, '\p{Is_Blk=privateusearea}', "");
    Expect(0, 63743, '\p{^Is_Blk=privateusearea}', "");
    Expect(0, 63743, '\P{Is_Blk=privateusearea}', "");
    Expect(1, 63743, '\P{^Is_Blk=privateusearea}', "");
    Expect(0, 63744, '\p{Is_Blk=privateusearea}', "");
    Expect(1, 63744, '\p{^Is_Blk=privateusearea}', "");
    Expect(1, 63744, '\P{Is_Blk=privateusearea}', "");
    Expect(0, 63744, '\P{^Is_Blk=privateusearea}', "");
    Expect(1, 63743, '\p{Is_Blk= PRIVATE_Use_Area}', "");
    Expect(0, 63743, '\p{^Is_Blk= PRIVATE_Use_Area}', "");
    Expect(0, 63743, '\P{Is_Blk= PRIVATE_Use_Area}', "");
    Expect(1, 63743, '\P{^Is_Blk= PRIVATE_Use_Area}', "");
    Expect(0, 63744, '\p{Is_Blk= PRIVATE_Use_Area}', "");
    Expect(1, 63744, '\p{^Is_Blk= PRIVATE_Use_Area}', "");
    Expect(1, 63744, '\P{Is_Blk= PRIVATE_Use_Area}', "");
    Expect(0, 63744, '\P{^Is_Blk= PRIVATE_Use_Area}', "");
    Error('\p{Block=:= general_punctuation}');
    Error('\P{Block=:= general_punctuation}');
    Expect(1, 8303, '\p{Block=:\AGeneral_Punctuation\z:}', "");;
    Expect(0, 8304, '\p{Block=:\AGeneral_Punctuation\z:}', "");;
    Expect(1, 8303, '\p{Block=generalpunctuation}', "");
    Expect(0, 8303, '\p{^Block=generalpunctuation}', "");
    Expect(0, 8303, '\P{Block=generalpunctuation}', "");
    Expect(1, 8303, '\P{^Block=generalpunctuation}', "");
    Expect(0, 8304, '\p{Block=generalpunctuation}', "");
    Expect(1, 8304, '\p{^Block=generalpunctuation}', "");
    Expect(1, 8304, '\P{Block=generalpunctuation}', "");
    Expect(0, 8304, '\P{^Block=generalpunctuation}', "");
    Expect(1, 8303, '\p{Block=:\Ageneralpunctuation\z:}', "");;
    Expect(0, 8304, '\p{Block=:\Ageneralpunctuation\z:}', "");;
    Expect(1, 8303, '\p{Block=-General_Punctuation}', "");
    Expect(0, 8303, '\p{^Block=-General_Punctuation}', "");
    Expect(0, 8303, '\P{Block=-General_Punctuation}', "");
    Expect(1, 8303, '\P{^Block=-General_Punctuation}', "");
    Expect(0, 8304, '\p{Block=-General_Punctuation}', "");
    Expect(1, 8304, '\p{^Block=-General_Punctuation}', "");
    Expect(1, 8304, '\P{Block=-General_Punctuation}', "");
    Expect(0, 8304, '\P{^Block=-General_Punctuation}', "");
    Error('\p{Blk=-Punctuation/a/}');
    Error('\P{Blk=-Punctuation/a/}');
    Expect(1, 8303, '\p{Blk=:\APunctuation\z:}', "");;
    Expect(0, 8304, '\p{Blk=:\APunctuation\z:}', "");;
    Expect(1, 8303, '\p{Blk=punctuation}', "");
    Expect(0, 8303, '\p{^Blk=punctuation}', "");
    Expect(0, 8303, '\P{Blk=punctuation}', "");
    Expect(1, 8303, '\P{^Blk=punctuation}', "");
    Expect(0, 8304, '\p{Blk=punctuation}', "");
    Expect(1, 8304, '\p{^Blk=punctuation}', "");
    Expect(1, 8304, '\P{Blk=punctuation}', "");
    Expect(0, 8304, '\P{^Blk=punctuation}', "");
    Expect(1, 8303, '\p{Blk=:\Apunctuation\z:}', "");;
    Expect(0, 8304, '\p{Blk=:\Apunctuation\z:}', "");;
    Expect(1, 8303, '\p{Blk=-	Punctuation}', "");
    Expect(0, 8303, '\p{^Blk=-	Punctuation}', "");
    Expect(0, 8303, '\P{Blk=-	Punctuation}', "");
    Expect(1, 8303, '\P{^Blk=-	Punctuation}', "");
    Expect(0, 8304, '\p{Blk=-	Punctuation}', "");
    Expect(1, 8304, '\p{^Blk=-	Punctuation}', "");
    Expect(1, 8304, '\P{Blk=-	Punctuation}', "");
    Expect(0, 8304, '\P{^Blk=-	Punctuation}', "");
    Error('\p{Is_Block=_:=General_Punctuation}');
    Error('\P{Is_Block=_:=General_Punctuation}');
    Expect(1, 8303, '\p{Is_Block=generalpunctuation}', "");
    Expect(0, 8303, '\p{^Is_Block=generalpunctuation}', "");
    Expect(0, 8303, '\P{Is_Block=generalpunctuation}', "");
    Expect(1, 8303, '\P{^Is_Block=generalpunctuation}', "");
    Expect(0, 8304, '\p{Is_Block=generalpunctuation}', "");
    Expect(1, 8304, '\p{^Is_Block=generalpunctuation}', "");
    Expect(1, 8304, '\P{Is_Block=generalpunctuation}', "");
    Expect(0, 8304, '\P{^Is_Block=generalpunctuation}', "");
    Expect(1, 8303, '\p{Is_Block=-GENERAL_PUNCTUATION}', "");
    Expect(0, 8303, '\p{^Is_Block=-GENERAL_PUNCTUATION}', "");
    Expect(0, 8303, '\P{Is_Block=-GENERAL_PUNCTUATION}', "");
    Expect(1, 8303, '\P{^Is_Block=-GENERAL_PUNCTUATION}', "");
    Expect(0, 8304, '\p{Is_Block=-GENERAL_PUNCTUATION}', "");
    Expect(1, 8304, '\p{^Is_Block=-GENERAL_PUNCTUATION}', "");
    Expect(1, 8304, '\P{Is_Block=-GENERAL_PUNCTUATION}', "");
    Expect(0, 8304, '\P{^Is_Block=-GENERAL_PUNCTUATION}', "");
    Error('\p{Is_Blk=_ PUNCTUATION:=}');
    Error('\P{Is_Blk=_ PUNCTUATION:=}');
    Expect(1, 8303, '\p{Is_Blk=punctuation}', "");
    Expect(0, 8303, '\p{^Is_Blk=punctuation}', "");
    Expect(0, 8303, '\P{Is_Blk=punctuation}', "");
    Expect(1, 8303, '\P{^Is_Blk=punctuation}', "");
    Expect(0, 8304, '\p{Is_Blk=punctuation}', "");
    Expect(1, 8304, '\p{^Is_Blk=punctuation}', "");
    Expect(1, 8304, '\P{Is_Blk=punctuation}', "");
    Expect(0, 8304, '\P{^Is_Blk=punctuation}', "");
    Expect(1, 8303, '\p{Is_Blk: 	PUNCTUATION}', "");
    Expect(0, 8303, '\p{^Is_Blk: 	PUNCTUATION}', "");
    Expect(0, 8303, '\P{Is_Blk: 	PUNCTUATION}', "");
    Expect(1, 8303, '\P{^Is_Blk: 	PUNCTUATION}', "");
    Expect(0, 8304, '\p{Is_Blk: 	PUNCTUATION}', "");
    Expect(1, 8304, '\p{^Is_Blk: 	PUNCTUATION}', "");
    Expect(1, 8304, '\P{Is_Blk: 	PUNCTUATION}', "");
    Expect(0, 8304, '\P{^Is_Blk: 	PUNCTUATION}', "");
    Error('\p{Block=/a/_Rejang}');
    Error('\P{Block=/a/_Rejang}');
    Expect(1, 43359, '\p{Block=:\ARejang\z:}', "");;
    Expect(0, 43360, '\p{Block=:\ARejang\z:}', "");;
    Expect(1, 43359, '\p{Block=rejang}', "");
    Expect(0, 43359, '\p{^Block=rejang}', "");
    Expect(0, 43359, '\P{Block=rejang}', "");
    Expect(1, 43359, '\P{^Block=rejang}', "");
    Expect(0, 43360, '\p{Block=rejang}', "");
    Expect(1, 43360, '\p{^Block=rejang}', "");
    Expect(1, 43360, '\P{Block=rejang}', "");
    Expect(0, 43360, '\P{^Block=rejang}', "");
    Expect(1, 43359, '\p{Block=:\Arejang\z:}', "");;
    Expect(0, 43360, '\p{Block=:\Arejang\z:}', "");;
    Expect(1, 43359, '\p{Block=_Rejang}', "");
    Expect(0, 43359, '\p{^Block=_Rejang}', "");
    Expect(0, 43359, '\P{Block=_Rejang}', "");
    Expect(1, 43359, '\P{^Block=_Rejang}', "");
    Expect(0, 43360, '\p{Block=_Rejang}', "");
    Expect(1, 43360, '\p{^Block=_Rejang}', "");
    Expect(1, 43360, '\P{Block=_Rejang}', "");
    Expect(0, 43360, '\P{^Block=_Rejang}', "");
    Error('\p{Blk=/a/ -Rejang}');
    Error('\P{Blk=/a/ -Rejang}');
    Expect(1, 43359, '\p{Blk=:\ARejang\z:}', "");;
    Expect(0, 43360, '\p{Blk=:\ARejang\z:}', "");;
    Expect(1, 43359, '\p{Blk=rejang}', "");
    Expect(0, 43359, '\p{^Blk=rejang}', "");
    Expect(0, 43359, '\P{Blk=rejang}', "");
    Expect(1, 43359, '\P{^Blk=rejang}', "");
    Expect(0, 43360, '\p{Blk=rejang}', "");
    Expect(1, 43360, '\p{^Blk=rejang}', "");
    Expect(1, 43360, '\P{Blk=rejang}', "");
    Expect(0, 43360, '\P{^Blk=rejang}', "");
    Expect(1, 43359, '\p{Blk=:\Arejang\z:}', "");;
    Expect(0, 43360, '\p{Blk=:\Arejang\z:}', "");;
    Expect(1, 43359, '\p{Blk=  rejang}', "");
    Expect(0, 43359, '\p{^Blk=  rejang}', "");
    Expect(0, 43359, '\P{Blk=  rejang}', "");
    Expect(1, 43359, '\P{^Blk=  rejang}', "");
    Expect(0, 43360, '\p{Blk=  rejang}', "");
    Expect(1, 43360, '\p{^Blk=  rejang}', "");
    Expect(1, 43360, '\P{Blk=  rejang}', "");
    Expect(0, 43360, '\P{^Blk=  rejang}', "");
    Error('\p{Is_Block:   -/a/rejang}');
    Error('\P{Is_Block:   -/a/rejang}');
    Expect(1, 43359, '\p{Is_Block=rejang}', "");
    Expect(0, 43359, '\p{^Is_Block=rejang}', "");
    Expect(0, 43359, '\P{Is_Block=rejang}', "");
    Expect(1, 43359, '\P{^Is_Block=rejang}', "");
    Expect(0, 43360, '\p{Is_Block=rejang}', "");
    Expect(1, 43360, '\p{^Is_Block=rejang}', "");
    Expect(1, 43360, '\P{Is_Block=rejang}', "");
    Expect(0, 43360, '\P{^Is_Block=rejang}', "");
    Expect(1, 43359, '\p{Is_Block:	REJANG}', "");
    Expect(0, 43359, '\p{^Is_Block:	REJANG}', "");
    Expect(0, 43359, '\P{Is_Block:	REJANG}', "");
    Expect(1, 43359, '\P{^Is_Block:	REJANG}', "");
    Expect(0, 43360, '\p{Is_Block:	REJANG}', "");
    Expect(1, 43360, '\p{^Is_Block:	REJANG}', "");
    Expect(1, 43360, '\P{Is_Block:	REJANG}', "");
    Expect(0, 43360, '\P{^Is_Block:	REJANG}', "");
    Error('\p{Is_Blk=_:=REJANG}');
    Error('\P{Is_Blk=_:=REJANG}');
    Expect(1, 43359, '\p{Is_Blk=rejang}', "");
    Expect(0, 43359, '\p{^Is_Blk=rejang}', "");
    Expect(0, 43359, '\P{Is_Blk=rejang}', "");
    Expect(1, 43359, '\P{^Is_Blk=rejang}', "");
    Expect(0, 43360, '\p{Is_Blk=rejang}', "");
    Expect(1, 43360, '\p{^Is_Blk=rejang}', "");
    Expect(1, 43360, '\P{Is_Blk=rejang}', "");
    Expect(0, 43360, '\P{^Is_Blk=rejang}', "");
    Expect(1, 43359, '\p{Is_Blk=--REJANG}', "");
    Expect(0, 43359, '\p{^Is_Blk=--REJANG}', "");
    Expect(0, 43359, '\P{Is_Blk=--REJANG}', "");
    Expect(1, 43359, '\P{^Is_Blk=--REJANG}', "");
    Expect(0, 43360, '\p{Is_Blk=--REJANG}', "");
    Expect(1, 43360, '\p{^Is_Blk=--REJANG}', "");
    Expect(1, 43360, '\P{Is_Blk=--REJANG}', "");
    Expect(0, 43360, '\P{^Is_Blk=--REJANG}', "");
    Error('\p{Block=/a/	 rumi_Numeral_symbols}');
    Error('\P{Block=/a/	 rumi_Numeral_symbols}');
    Expect(1, 69247, '\p{Block=:\ARumi_Numeral_Symbols\z:}', "");;
    Expect(0, 69248, '\p{Block=:\ARumi_Numeral_Symbols\z:}', "");;
    Expect(1, 69247, '\p{Block:ruminumeralsymbols}', "");
    Expect(0, 69247, '\p{^Block:ruminumeralsymbols}', "");
    Expect(0, 69247, '\P{Block:ruminumeralsymbols}', "");
    Expect(1, 69247, '\P{^Block:ruminumeralsymbols}', "");
    Expect(0, 69248, '\p{Block:ruminumeralsymbols}', "");
    Expect(1, 69248, '\p{^Block:ruminumeralsymbols}', "");
    Expect(1, 69248, '\P{Block:ruminumeralsymbols}', "");
    Expect(0, 69248, '\P{^Block:ruminumeralsymbols}', "");
    Expect(1, 69247, '\p{Block=:\Aruminumeralsymbols\z:}', "");;
    Expect(0, 69248, '\p{Block=:\Aruminumeralsymbols\z:}', "");;
    Expect(1, 69247, '\p{Block=_ Rumi_numeral_SYMBOLS}', "");
    Expect(0, 69247, '\p{^Block=_ Rumi_numeral_SYMBOLS}', "");
    Expect(0, 69247, '\P{Block=_ Rumi_numeral_SYMBOLS}', "");
    Expect(1, 69247, '\P{^Block=_ Rumi_numeral_SYMBOLS}', "");
    Expect(0, 69248, '\p{Block=_ Rumi_numeral_SYMBOLS}', "");
    Expect(1, 69248, '\p{^Block=_ Rumi_numeral_SYMBOLS}', "");
    Expect(1, 69248, '\P{Block=_ Rumi_numeral_SYMBOLS}', "");
    Expect(0, 69248, '\P{^Block=_ Rumi_numeral_SYMBOLS}', "");
    Error('\p{Blk=-:=rumi}');
    Error('\P{Blk=-:=rumi}');
    Expect(1, 69247, '\p{Blk=:\ARumi\z:}', "");;
    Expect(0, 69248, '\p{Blk=:\ARumi\z:}', "");;
    Expect(1, 69247, '\p{Blk=rumi}', "");
    Expect(0, 69247, '\p{^Blk=rumi}', "");
    Expect(0, 69247, '\P{Blk=rumi}', "");
    Expect(1, 69247, '\P{^Blk=rumi}', "");
    Expect(0, 69248, '\p{Blk=rumi}', "");
    Expect(1, 69248, '\p{^Blk=rumi}', "");
    Expect(1, 69248, '\P{Blk=rumi}', "");
    Expect(0, 69248, '\P{^Blk=rumi}', "");
    Expect(1, 69247, '\p{Blk=:\Arumi\z:}', "");;
    Expect(0, 69248, '\p{Blk=:\Arumi\z:}', "");;
    Expect(1, 69247, '\p{Blk=	Rumi}', "");
    Expect(0, 69247, '\p{^Blk=	Rumi}', "");
    Expect(0, 69247, '\P{Blk=	Rumi}', "");
    Expect(1, 69247, '\P{^Blk=	Rumi}', "");
    Expect(0, 69248, '\p{Blk=	Rumi}', "");
    Expect(1, 69248, '\p{^Blk=	Rumi}', "");
    Expect(1, 69248, '\P{Blk=	Rumi}', "");
    Expect(0, 69248, '\P{^Blk=	Rumi}', "");
    Error('\p{Is_Block= /a/rumi_NUMERAL_SYMBOLS}');
    Error('\P{Is_Block= /a/rumi_NUMERAL_SYMBOLS}');
    Expect(1, 69247, '\p{Is_Block=ruminumeralsymbols}', "");
    Expect(0, 69247, '\p{^Is_Block=ruminumeralsymbols}', "");
    Expect(0, 69247, '\P{Is_Block=ruminumeralsymbols}', "");
    Expect(1, 69247, '\P{^Is_Block=ruminumeralsymbols}', "");
    Expect(0, 69248, '\p{Is_Block=ruminumeralsymbols}', "");
    Expect(1, 69248, '\p{^Is_Block=ruminumeralsymbols}', "");
    Expect(1, 69248, '\P{Is_Block=ruminumeralsymbols}', "");
    Expect(0, 69248, '\P{^Is_Block=ruminumeralsymbols}', "");
    Expect(1, 69247, '\p{Is_Block=  rumi_NUMERAL_SYMBOLS}', "");
    Expect(0, 69247, '\p{^Is_Block=  rumi_NUMERAL_SYMBOLS}', "");
    Expect(0, 69247, '\P{Is_Block=  rumi_NUMERAL_SYMBOLS}', "");
    Expect(1, 69247, '\P{^Is_Block=  rumi_NUMERAL_SYMBOLS}', "");
    Expect(0, 69248, '\p{Is_Block=  rumi_NUMERAL_SYMBOLS}', "");
    Expect(1, 69248, '\p{^Is_Block=  rumi_NUMERAL_SYMBOLS}', "");
    Expect(1, 69248, '\P{Is_Block=  rumi_NUMERAL_SYMBOLS}', "");
    Expect(0, 69248, '\P{^Is_Block=  rumi_NUMERAL_SYMBOLS}', "");
    Error('\p{Is_Blk=	-Rumi:=}');
    Error('\P{Is_Blk=	-Rumi:=}');
    Expect(1, 69247, '\p{Is_Blk=rumi}', "");
    Expect(0, 69247, '\p{^Is_Blk=rumi}', "");
    Expect(0, 69247, '\P{Is_Blk=rumi}', "");
    Expect(1, 69247, '\P{^Is_Blk=rumi}', "");
    Expect(0, 69248, '\p{Is_Blk=rumi}', "");
    Expect(1, 69248, '\p{^Is_Blk=rumi}', "");
    Expect(1, 69248, '\P{Is_Blk=rumi}', "");
    Expect(0, 69248, '\P{^Is_Blk=rumi}', "");
    Expect(1, 69247, '\p{Is_Blk=	_rumi}', "");
    Expect(0, 69247, '\p{^Is_Blk=	_rumi}', "");
    Expect(0, 69247, '\P{Is_Blk=	_rumi}', "");
    Expect(1, 69247, '\P{^Is_Blk=	_rumi}', "");
    Expect(0, 69248, '\p{Is_Blk=	_rumi}', "");
    Expect(1, 69248, '\p{^Is_Blk=	_rumi}', "");
    Expect(1, 69248, '\P{Is_Blk=	_rumi}', "");
    Expect(0, 69248, '\P{^Is_Blk=	_rumi}', "");
    Error('\p{Block=_Runic/a/}');
    Error('\P{Block=_Runic/a/}');
    Expect(1, 5887, '\p{Block=:\ARunic\z:}', "");;
    Expect(0, 5888, '\p{Block=:\ARunic\z:}', "");;
    Expect(1, 5887, '\p{Block=runic}', "");
    Expect(0, 5887, '\p{^Block=runic}', "");
    Expect(0, 5887, '\P{Block=runic}', "");
    Expect(1, 5887, '\P{^Block=runic}', "");
    Expect(0, 5888, '\p{Block=runic}', "");
    Expect(1, 5888, '\p{^Block=runic}', "");
    Expect(1, 5888, '\P{Block=runic}', "");
    Expect(0, 5888, '\P{^Block=runic}', "");
    Expect(1, 5887, '\p{Block=:\Arunic\z:}', "");;
    Expect(0, 5888, '\p{Block=:\Arunic\z:}', "");;
    Expect(1, 5887, '\p{Block= -Runic}', "");
    Expect(0, 5887, '\p{^Block= -Runic}', "");
    Expect(0, 5887, '\P{Block= -Runic}', "");
    Expect(1, 5887, '\P{^Block= -Runic}', "");
    Expect(0, 5888, '\p{Block= -Runic}', "");
    Expect(1, 5888, '\p{^Block= -Runic}', "");
    Expect(1, 5888, '\P{Block= -Runic}', "");
    Expect(0, 5888, '\P{^Block= -Runic}', "");
    Error('\p{Blk=-	runic:=}');
    Error('\P{Blk=-	runic:=}');
    Expect(1, 5887, '\p{Blk=:\ARunic\z:}', "");;
    Expect(0, 5888, '\p{Blk=:\ARunic\z:}', "");;
    Expect(1, 5887, '\p{Blk=runic}', "");
    Expect(0, 5887, '\p{^Blk=runic}', "");
    Expect(0, 5887, '\P{Blk=runic}', "");
    Expect(1, 5887, '\P{^Blk=runic}', "");
    Expect(0, 5888, '\p{Blk=runic}', "");
    Expect(1, 5888, '\p{^Blk=runic}', "");
    Expect(1, 5888, '\P{Blk=runic}', "");
    Expect(0, 5888, '\P{^Blk=runic}', "");
    Expect(1, 5887, '\p{Blk=:\Arunic\z:}', "");;
    Expect(0, 5888, '\p{Blk=:\Arunic\z:}', "");;
    Expect(1, 5887, '\p{Blk:  runic}', "");
    Expect(0, 5887, '\p{^Blk:  runic}', "");
    Expect(0, 5887, '\P{Blk:  runic}', "");
    Expect(1, 5887, '\P{^Blk:  runic}', "");
    Expect(0, 5888, '\p{Blk:  runic}', "");
    Expect(1, 5888, '\p{^Blk:  runic}', "");
    Expect(1, 5888, '\P{Blk:  runic}', "");
    Expect(0, 5888, '\P{^Blk:  runic}', "");
    Error('\p{Is_Block=  RUNIC/a/}');
    Error('\P{Is_Block=  RUNIC/a/}');
    Expect(1, 5887, '\p{Is_Block: runic}', "");
    Expect(0, 5887, '\p{^Is_Block: runic}', "");
    Expect(0, 5887, '\P{Is_Block: runic}', "");
    Expect(1, 5887, '\P{^Is_Block: runic}', "");
    Expect(0, 5888, '\p{Is_Block: runic}', "");
    Expect(1, 5888, '\p{^Is_Block: runic}', "");
    Expect(1, 5888, '\P{Is_Block: runic}', "");
    Expect(0, 5888, '\P{^Is_Block: runic}', "");
    Expect(1, 5887, '\p{Is_Block=_	runic}', "");
    Expect(0, 5887, '\p{^Is_Block=_	runic}', "");
    Expect(0, 5887, '\P{Is_Block=_	runic}', "");
    Expect(1, 5887, '\P{^Is_Block=_	runic}', "");
    Expect(0, 5888, '\p{Is_Block=_	runic}', "");
    Expect(1, 5888, '\p{^Is_Block=_	runic}', "");
    Expect(1, 5888, '\P{Is_Block=_	runic}', "");
    Expect(0, 5888, '\P{^Is_Block=_	runic}', "");
    Error('\p{Is_Blk= Runic/a/}');
    Error('\P{Is_Blk= Runic/a/}');
    Expect(1, 5887, '\p{Is_Blk:runic}', "");
    Expect(0, 5887, '\p{^Is_Blk:runic}', "");
    Expect(0, 5887, '\P{Is_Blk:runic}', "");
    Expect(1, 5887, '\P{^Is_Blk:runic}', "");
    Expect(0, 5888, '\p{Is_Blk:runic}', "");
    Expect(1, 5888, '\p{^Is_Blk:runic}', "");
    Expect(1, 5888, '\P{Is_Blk:runic}', "");
    Expect(0, 5888, '\P{^Is_Blk:runic}', "");
    Expect(1, 5887, '\p{Is_Blk= 	RUNIC}', "");
    Expect(0, 5887, '\p{^Is_Blk= 	RUNIC}', "");
    Expect(0, 5887, '\P{Is_Blk= 	RUNIC}', "");
    Expect(1, 5887, '\P{^Is_Blk= 	RUNIC}', "");
    Expect(0, 5888, '\p{Is_Blk= 	RUNIC}', "");
    Expect(1, 5888, '\p{^Is_Blk= 	RUNIC}', "");
    Expect(1, 5888, '\P{Is_Blk= 	RUNIC}', "");
    Expect(0, 5888, '\P{^Is_Blk= 	RUNIC}', "");
    Error('\p{Block=		Samaritan/a/}');
    Error('\P{Block=		Samaritan/a/}');
    Expect(1, 2111, '\p{Block=:\ASamaritan\z:}', "");;
    Expect(0, 2112, '\p{Block=:\ASamaritan\z:}', "");;
    Expect(1, 2111, '\p{Block=samaritan}', "");
    Expect(0, 2111, '\p{^Block=samaritan}', "");
    Expect(0, 2111, '\P{Block=samaritan}', "");
    Expect(1, 2111, '\P{^Block=samaritan}', "");
    Expect(0, 2112, '\p{Block=samaritan}', "");
    Expect(1, 2112, '\p{^Block=samaritan}', "");
    Expect(1, 2112, '\P{Block=samaritan}', "");
    Expect(0, 2112, '\P{^Block=samaritan}', "");
    Expect(1, 2111, '\p{Block=:\Asamaritan\z:}', "");;
    Expect(0, 2112, '\p{Block=:\Asamaritan\z:}', "");;
    Expect(1, 2111, '\p{Block=	 Samaritan}', "");
    Expect(0, 2111, '\p{^Block=	 Samaritan}', "");
    Expect(0, 2111, '\P{Block=	 Samaritan}', "");
    Expect(1, 2111, '\P{^Block=	 Samaritan}', "");
    Expect(0, 2112, '\p{Block=	 Samaritan}', "");
    Expect(1, 2112, '\p{^Block=	 Samaritan}', "");
    Expect(1, 2112, '\P{Block=	 Samaritan}', "");
    Expect(0, 2112, '\P{^Block=	 Samaritan}', "");
    Error('\p{Blk=-	SAMARITAN/a/}');
    Error('\P{Blk=-	SAMARITAN/a/}');
    Expect(1, 2111, '\p{Blk=:\ASamaritan\z:}', "");;
    Expect(0, 2112, '\p{Blk=:\ASamaritan\z:}', "");;
    Expect(1, 2111, '\p{Blk=samaritan}', "");
    Expect(0, 2111, '\p{^Blk=samaritan}', "");
    Expect(0, 2111, '\P{Blk=samaritan}', "");
    Expect(1, 2111, '\P{^Blk=samaritan}', "");
    Expect(0, 2112, '\p{Blk=samaritan}', "");
    Expect(1, 2112, '\p{^Blk=samaritan}', "");
    Expect(1, 2112, '\P{Blk=samaritan}', "");
    Expect(0, 2112, '\P{^Blk=samaritan}', "");
    Expect(1, 2111, '\p{Blk=:\Asamaritan\z:}', "");;
    Expect(0, 2112, '\p{Blk=:\Asamaritan\z:}', "");;
    Expect(1, 2111, '\p{Blk=	 Samaritan}', "");
    Expect(0, 2111, '\p{^Blk=	 Samaritan}', "");
    Expect(0, 2111, '\P{Blk=	 Samaritan}', "");
    Expect(1, 2111, '\P{^Blk=	 Samaritan}', "");
    Expect(0, 2112, '\p{Blk=	 Samaritan}', "");
    Expect(1, 2112, '\p{^Blk=	 Samaritan}', "");
    Expect(1, 2112, '\P{Blk=	 Samaritan}', "");
    Expect(0, 2112, '\P{^Blk=	 Samaritan}', "");
    Error('\p{Is_Block=/a/-_Samaritan}');
    Error('\P{Is_Block=/a/-_Samaritan}');
    Expect(1, 2111, '\p{Is_Block=samaritan}', "");
    Expect(0, 2111, '\p{^Is_Block=samaritan}', "");
    Expect(0, 2111, '\P{Is_Block=samaritan}', "");
    Expect(1, 2111, '\P{^Is_Block=samaritan}', "");
    Expect(0, 2112, '\p{Is_Block=samaritan}', "");
    Expect(1, 2112, '\p{^Is_Block=samaritan}', "");
    Expect(1, 2112, '\P{Is_Block=samaritan}', "");
    Expect(0, 2112, '\P{^Is_Block=samaritan}', "");
    Expect(1, 2111, '\p{Is_Block=- samaritan}', "");
    Expect(0, 2111, '\p{^Is_Block=- samaritan}', "");
    Expect(0, 2111, '\P{Is_Block=- samaritan}', "");
    Expect(1, 2111, '\P{^Is_Block=- samaritan}', "");
    Expect(0, 2112, '\p{Is_Block=- samaritan}', "");
    Expect(1, 2112, '\p{^Is_Block=- samaritan}', "");
    Expect(1, 2112, '\P{Is_Block=- samaritan}', "");
    Expect(0, 2112, '\P{^Is_Block=- samaritan}', "");
    Error('\p{Is_Blk=:=-Samaritan}');
    Error('\P{Is_Blk=:=-Samaritan}');
    Expect(1, 2111, '\p{Is_Blk:samaritan}', "");
    Expect(0, 2111, '\p{^Is_Blk:samaritan}', "");
    Expect(0, 2111, '\P{Is_Blk:samaritan}', "");
    Expect(1, 2111, '\P{^Is_Blk:samaritan}', "");
    Expect(0, 2112, '\p{Is_Blk:samaritan}', "");
    Expect(1, 2112, '\p{^Is_Blk:samaritan}', "");
    Expect(1, 2112, '\P{Is_Blk:samaritan}', "");
    Expect(0, 2112, '\P{^Is_Blk:samaritan}', "");
    Expect(1, 2111, '\p{Is_Blk: -_SAMARITAN}', "");
    Expect(0, 2111, '\p{^Is_Blk: -_SAMARITAN}', "");
    Expect(0, 2111, '\P{Is_Blk: -_SAMARITAN}', "");
    Expect(1, 2111, '\P{^Is_Blk: -_SAMARITAN}', "");
    Expect(0, 2112, '\p{Is_Blk: -_SAMARITAN}', "");
    Expect(1, 2112, '\p{^Is_Blk: -_SAMARITAN}', "");
    Expect(1, 2112, '\P{Is_Blk: -_SAMARITAN}', "");
    Expect(0, 2112, '\P{^Is_Blk: -_SAMARITAN}', "");
    Error('\p{Block=:=	 SAURASHTRA}');
    Error('\P{Block=:=	 SAURASHTRA}');
    Expect(1, 43231, '\p{Block=:\ASaurashtra\z:}', "");;
    Expect(0, 43232, '\p{Block=:\ASaurashtra\z:}', "");;
    Expect(1, 43231, '\p{Block=saurashtra}', "");
    Expect(0, 43231, '\p{^Block=saurashtra}', "");
    Expect(0, 43231, '\P{Block=saurashtra}', "");
    Expect(1, 43231, '\P{^Block=saurashtra}', "");
    Expect(0, 43232, '\p{Block=saurashtra}', "");
    Expect(1, 43232, '\p{^Block=saurashtra}', "");
    Expect(1, 43232, '\P{Block=saurashtra}', "");
    Expect(0, 43232, '\P{^Block=saurashtra}', "");
    Expect(1, 43231, '\p{Block=:\Asaurashtra\z:}', "");;
    Expect(0, 43232, '\p{Block=:\Asaurashtra\z:}', "");;
    Expect(1, 43231, '\p{Block=-	SAURASHTRA}', "");
    Expect(0, 43231, '\p{^Block=-	SAURASHTRA}', "");
    Expect(0, 43231, '\P{Block=-	SAURASHTRA}', "");
    Expect(1, 43231, '\P{^Block=-	SAURASHTRA}', "");
    Expect(0, 43232, '\p{Block=-	SAURASHTRA}', "");
    Expect(1, 43232, '\p{^Block=-	SAURASHTRA}', "");
    Expect(1, 43232, '\P{Block=-	SAURASHTRA}', "");
    Expect(0, 43232, '\P{^Block=-	SAURASHTRA}', "");
    Error('\p{Blk= /a/saurashtra}');
    Error('\P{Blk= /a/saurashtra}');
    Expect(1, 43231, '\p{Blk=:\ASaurashtra\z:}', "");;
    Expect(0, 43232, '\p{Blk=:\ASaurashtra\z:}', "");;
    Expect(1, 43231, '\p{Blk=saurashtra}', "");
    Expect(0, 43231, '\p{^Blk=saurashtra}', "");
    Expect(0, 43231, '\P{Blk=saurashtra}', "");
    Expect(1, 43231, '\P{^Blk=saurashtra}', "");
    Expect(0, 43232, '\p{Blk=saurashtra}', "");
    Expect(1, 43232, '\p{^Blk=saurashtra}', "");
    Expect(1, 43232, '\P{Blk=saurashtra}', "");
    Expect(0, 43232, '\P{^Blk=saurashtra}', "");
    Expect(1, 43231, '\p{Blk=:\Asaurashtra\z:}', "");;
    Expect(0, 43232, '\p{Blk=:\Asaurashtra\z:}', "");;
    Expect(1, 43231, '\p{Blk=		Saurashtra}', "");
    Expect(0, 43231, '\p{^Blk=		Saurashtra}', "");
    Expect(0, 43231, '\P{Blk=		Saurashtra}', "");
    Expect(1, 43231, '\P{^Blk=		Saurashtra}', "");
    Expect(0, 43232, '\p{Blk=		Saurashtra}', "");
    Expect(1, 43232, '\p{^Blk=		Saurashtra}', "");
    Expect(1, 43232, '\P{Blk=		Saurashtra}', "");
    Expect(0, 43232, '\P{^Blk=		Saurashtra}', "");
    Error('\p{Is_Block= :=Saurashtra}');
    Error('\P{Is_Block= :=Saurashtra}');
    Expect(1, 43231, '\p{Is_Block=saurashtra}', "");
    Expect(0, 43231, '\p{^Is_Block=saurashtra}', "");
    Expect(0, 43231, '\P{Is_Block=saurashtra}', "");
    Expect(1, 43231, '\P{^Is_Block=saurashtra}', "");
    Expect(0, 43232, '\p{Is_Block=saurashtra}', "");
    Expect(1, 43232, '\p{^Is_Block=saurashtra}', "");
    Expect(1, 43232, '\P{Is_Block=saurashtra}', "");
    Expect(0, 43232, '\P{^Is_Block=saurashtra}', "");
    Expect(1, 43231, '\p{Is_Block=- Saurashtra}', "");
    Expect(0, 43231, '\p{^Is_Block=- Saurashtra}', "");
    Expect(0, 43231, '\P{Is_Block=- Saurashtra}', "");
    Expect(1, 43231, '\P{^Is_Block=- Saurashtra}', "");
    Expect(0, 43232, '\p{Is_Block=- Saurashtra}', "");
    Expect(1, 43232, '\p{^Is_Block=- Saurashtra}', "");
    Expect(1, 43232, '\P{Is_Block=- Saurashtra}', "");
    Expect(0, 43232, '\P{^Is_Block=- Saurashtra}', "");
    Error('\p{Is_Blk= /a/saurashtra}');
    Error('\P{Is_Blk= /a/saurashtra}');
    Expect(1, 43231, '\p{Is_Blk=saurashtra}', "");
    Expect(0, 43231, '\p{^Is_Blk=saurashtra}', "");
    Expect(0, 43231, '\P{Is_Blk=saurashtra}', "");
    Expect(1, 43231, '\P{^Is_Blk=saurashtra}', "");
    Expect(0, 43232, '\p{Is_Blk=saurashtra}', "");
    Expect(1, 43232, '\p{^Is_Blk=saurashtra}', "");
    Expect(1, 43232, '\P{Is_Blk=saurashtra}', "");
    Expect(0, 43232, '\P{^Is_Blk=saurashtra}', "");
    Expect(1, 43231, '\p{Is_Blk=-	Saurashtra}', "");
    Expect(0, 43231, '\p{^Is_Blk=-	Saurashtra}', "");
    Expect(0, 43231, '\P{Is_Blk=-	Saurashtra}', "");
    Expect(1, 43231, '\P{^Is_Blk=-	Saurashtra}', "");
    Expect(0, 43232, '\p{Is_Blk=-	Saurashtra}', "");
    Expect(1, 43232, '\p{^Is_Blk=-	Saurashtra}', "");
    Expect(1, 43232, '\P{Is_Blk=-	Saurashtra}', "");
    Expect(0, 43232, '\P{^Is_Blk=-	Saurashtra}', "");
    Error('\p{Block=-	Sharada/a/}');
    Error('\P{Block=-	Sharada/a/}');
    Expect(1, 70111, '\p{Block=:\ASharada\z:}', "");;
    Expect(0, 70112, '\p{Block=:\ASharada\z:}', "");;
    Expect(1, 70111, '\p{Block:sharada}', "");
    Expect(0, 70111, '\p{^Block:sharada}', "");
    Expect(0, 70111, '\P{Block:sharada}', "");
    Expect(1, 70111, '\P{^Block:sharada}', "");
    Expect(0, 70112, '\p{Block:sharada}', "");
    Expect(1, 70112, '\p{^Block:sharada}', "");
    Expect(1, 70112, '\P{Block:sharada}', "");
    Expect(0, 70112, '\P{^Block:sharada}', "");
    Expect(1, 70111, '\p{Block=:\Asharada\z:}', "");;
    Expect(0, 70112, '\p{Block=:\Asharada\z:}', "");;
    Expect(1, 70111, '\p{Block=	_sharada}', "");
    Expect(0, 70111, '\p{^Block=	_sharada}', "");
    Expect(0, 70111, '\P{Block=	_sharada}', "");
    Expect(1, 70111, '\P{^Block=	_sharada}', "");
    Expect(0, 70112, '\p{Block=	_sharada}', "");
    Expect(1, 70112, '\p{^Block=	_sharada}', "");
    Expect(1, 70112, '\P{Block=	_sharada}', "");
    Expect(0, 70112, '\P{^Block=	_sharada}', "");
    Error('\p{Blk=--Sharada:=}');
    Error('\P{Blk=--Sharada:=}');
    Expect(1, 70111, '\p{Blk=:\ASharada\z:}', "");;
    Expect(0, 70112, '\p{Blk=:\ASharada\z:}', "");;
    Expect(1, 70111, '\p{Blk=sharada}', "");
    Expect(0, 70111, '\p{^Blk=sharada}', "");
    Expect(0, 70111, '\P{Blk=sharada}', "");
    Expect(1, 70111, '\P{^Blk=sharada}', "");
    Expect(0, 70112, '\p{Blk=sharada}', "");
    Expect(1, 70112, '\p{^Blk=sharada}', "");
    Expect(1, 70112, '\P{Blk=sharada}', "");
    Expect(0, 70112, '\P{^Blk=sharada}', "");
    Expect(1, 70111, '\p{Blk=:\Asharada\z:}', "");;
    Expect(0, 70112, '\p{Blk=:\Asharada\z:}', "");;
    Expect(1, 70111, '\p{Blk= Sharada}', "");
    Expect(0, 70111, '\p{^Blk= Sharada}', "");
    Expect(0, 70111, '\P{Blk= Sharada}', "");
    Expect(1, 70111, '\P{^Blk= Sharada}', "");
    Expect(0, 70112, '\p{Blk= Sharada}', "");
    Expect(1, 70112, '\p{^Blk= Sharada}', "");
    Expect(1, 70112, '\P{Blk= Sharada}', "");
    Expect(0, 70112, '\P{^Blk= Sharada}', "");
    Error('\p{Is_Block=/a/ Sharada}');
    Error('\P{Is_Block=/a/ Sharada}');
    Expect(1, 70111, '\p{Is_Block=sharada}', "");
    Expect(0, 70111, '\p{^Is_Block=sharada}', "");
    Expect(0, 70111, '\P{Is_Block=sharada}', "");
    Expect(1, 70111, '\P{^Is_Block=sharada}', "");
    Expect(0, 70112, '\p{Is_Block=sharada}', "");
    Expect(1, 70112, '\p{^Is_Block=sharada}', "");
    Expect(1, 70112, '\P{Is_Block=sharada}', "");
    Expect(0, 70112, '\P{^Is_Block=sharada}', "");
    Expect(1, 70111, '\p{Is_Block= Sharada}', "");
    Expect(0, 70111, '\p{^Is_Block= Sharada}', "");
    Expect(0, 70111, '\P{Is_Block= Sharada}', "");
    Expect(1, 70111, '\P{^Is_Block= Sharada}', "");
    Expect(0, 70112, '\p{Is_Block= Sharada}', "");
    Expect(1, 70112, '\p{^Is_Block= Sharada}', "");
    Expect(1, 70112, '\P{Is_Block= Sharada}', "");
    Expect(0, 70112, '\P{^Is_Block= Sharada}', "");
    Error('\p{Is_Blk=_Sharada:=}');
    Error('\P{Is_Blk=_Sharada:=}');
    Expect(1, 70111, '\p{Is_Blk=sharada}', "");
    Expect(0, 70111, '\p{^Is_Blk=sharada}', "");
    Expect(0, 70111, '\P{Is_Blk=sharada}', "");
    Expect(1, 70111, '\P{^Is_Blk=sharada}', "");
    Expect(0, 70112, '\p{Is_Blk=sharada}', "");
    Expect(1, 70112, '\p{^Is_Blk=sharada}', "");
    Expect(1, 70112, '\P{Is_Blk=sharada}', "");
    Expect(0, 70112, '\P{^Is_Blk=sharada}', "");
    Expect(1, 70111, '\p{Is_Blk=	 SHARADA}', "");
    Expect(0, 70111, '\p{^Is_Blk=	 SHARADA}', "");
    Expect(0, 70111, '\P{Is_Blk=	 SHARADA}', "");
    Expect(1, 70111, '\P{^Is_Blk=	 SHARADA}', "");
    Expect(0, 70112, '\p{Is_Blk=	 SHARADA}', "");
    Expect(1, 70112, '\p{^Is_Blk=	 SHARADA}', "");
    Expect(1, 70112, '\P{Is_Blk=	 SHARADA}', "");
    Expect(0, 70112, '\P{^Is_Blk=	 SHARADA}', "");
    Error('\p{Block=:=		Shavian}');
    Error('\P{Block=:=		Shavian}');
    Expect(1, 66687, '\p{Block=:\AShavian\z:}', "");;
    Expect(0, 66688, '\p{Block=:\AShavian\z:}', "");;
    Expect(1, 66687, '\p{Block=shavian}', "");
    Expect(0, 66687, '\p{^Block=shavian}', "");
    Expect(0, 66687, '\P{Block=shavian}', "");
    Expect(1, 66687, '\P{^Block=shavian}', "");
    Expect(0, 66688, '\p{Block=shavian}', "");
    Expect(1, 66688, '\p{^Block=shavian}', "");
    Expect(1, 66688, '\P{Block=shavian}', "");
    Expect(0, 66688, '\P{^Block=shavian}', "");
    Expect(1, 66687, '\p{Block=:\Ashavian\z:}', "");;
    Expect(0, 66688, '\p{Block=:\Ashavian\z:}', "");;
    Expect(1, 66687, '\p{Block=	 SHAVIAN}', "");
    Expect(0, 66687, '\p{^Block=	 SHAVIAN}', "");
    Expect(0, 66687, '\P{Block=	 SHAVIAN}', "");
    Expect(1, 66687, '\P{^Block=	 SHAVIAN}', "");
    Expect(0, 66688, '\p{Block=	 SHAVIAN}', "");
    Expect(1, 66688, '\p{^Block=	 SHAVIAN}', "");
    Expect(1, 66688, '\P{Block=	 SHAVIAN}', "");
    Expect(0, 66688, '\P{^Block=	 SHAVIAN}', "");
    Error('\p{Blk=:=--SHAVIAN}');
    Error('\P{Blk=:=--SHAVIAN}');
    Expect(1, 66687, '\p{Blk=:\AShavian\z:}', "");;
    Expect(0, 66688, '\p{Blk=:\AShavian\z:}', "");;
    Expect(1, 66687, '\p{Blk=shavian}', "");
    Expect(0, 66687, '\p{^Blk=shavian}', "");
    Expect(0, 66687, '\P{Blk=shavian}', "");
    Expect(1, 66687, '\P{^Blk=shavian}', "");
    Expect(0, 66688, '\p{Blk=shavian}', "");
    Expect(1, 66688, '\p{^Blk=shavian}', "");
    Expect(1, 66688, '\P{Blk=shavian}', "");
    Expect(0, 66688, '\P{^Blk=shavian}', "");
    Expect(1, 66687, '\p{Blk=:\Ashavian\z:}', "");;
    Expect(0, 66688, '\p{Blk=:\Ashavian\z:}', "");;
    Expect(1, 66687, '\p{Blk=		Shavian}', "");
    Expect(0, 66687, '\p{^Blk=		Shavian}', "");
    Expect(0, 66687, '\P{Blk=		Shavian}', "");
    Expect(1, 66687, '\P{^Blk=		Shavian}', "");
    Expect(0, 66688, '\p{Blk=		Shavian}', "");
    Expect(1, 66688, '\p{^Blk=		Shavian}', "");
    Expect(1, 66688, '\P{Blk=		Shavian}', "");
    Expect(0, 66688, '\P{^Blk=		Shavian}', "");
    Error('\p{Is_Block=:=-	shavian}');
    Error('\P{Is_Block=:=-	shavian}');
    Expect(1, 66687, '\p{Is_Block=shavian}', "");
    Expect(0, 66687, '\p{^Is_Block=shavian}', "");
    Expect(0, 66687, '\P{Is_Block=shavian}', "");
    Expect(1, 66687, '\P{^Is_Block=shavian}', "");
    Expect(0, 66688, '\p{Is_Block=shavian}', "");
    Expect(1, 66688, '\p{^Is_Block=shavian}', "");
    Expect(1, 66688, '\P{Is_Block=shavian}', "");
    Expect(0, 66688, '\P{^Is_Block=shavian}', "");
    Expect(1, 66687, '\p{Is_Block=__Shavian}', "");
    Expect(0, 66687, '\p{^Is_Block=__Shavian}', "");
    Expect(0, 66687, '\P{Is_Block=__Shavian}', "");
    Expect(1, 66687, '\P{^Is_Block=__Shavian}', "");
    Expect(0, 66688, '\p{Is_Block=__Shavian}', "");
    Expect(1, 66688, '\p{^Is_Block=__Shavian}', "");
    Expect(1, 66688, '\P{Is_Block=__Shavian}', "");
    Expect(0, 66688, '\P{^Is_Block=__Shavian}', "");
    Error('\p{Is_Blk=-SHAVIAN/a/}');
    Error('\P{Is_Blk=-SHAVIAN/a/}');
    Expect(1, 66687, '\p{Is_Blk=shavian}', "");
    Expect(0, 66687, '\p{^Is_Blk=shavian}', "");
    Expect(0, 66687, '\P{Is_Blk=shavian}', "");
    Expect(1, 66687, '\P{^Is_Blk=shavian}', "");
    Expect(0, 66688, '\p{Is_Blk=shavian}', "");
    Expect(1, 66688, '\p{^Is_Blk=shavian}', "");
    Expect(1, 66688, '\P{Is_Blk=shavian}', "");
    Expect(0, 66688, '\P{^Is_Blk=shavian}', "");
    Expect(1, 66687, '\p{Is_Blk=-_SHAVIAN}', "");
    Expect(0, 66687, '\p{^Is_Blk=-_SHAVIAN}', "");
    Expect(0, 66687, '\P{Is_Blk=-_SHAVIAN}', "");
    Expect(1, 66687, '\P{^Is_Blk=-_SHAVIAN}', "");
    Expect(0, 66688, '\p{Is_Blk=-_SHAVIAN}', "");
    Expect(1, 66688, '\p{^Is_Blk=-_SHAVIAN}', "");
    Expect(1, 66688, '\P{Is_Blk=-_SHAVIAN}', "");
    Expect(0, 66688, '\P{^Is_Blk=-_SHAVIAN}', "");
    Error('\p{Block=_/a/Shorthand_Format_Controls}');
    Error('\P{Block=_/a/Shorthand_Format_Controls}');
    Expect(1, 113839, '\p{Block=:\AShorthand_Format_Controls\z:}', "");;
    Expect(0, 113840, '\p{Block=:\AShorthand_Format_Controls\z:}', "");;
    Expect(1, 113839, '\p{Block=shorthandformatcontrols}', "");
    Expect(0, 113839, '\p{^Block=shorthandformatcontrols}', "");
    Expect(0, 113839, '\P{Block=shorthandformatcontrols}', "");
    Expect(1, 113839, '\P{^Block=shorthandformatcontrols}', "");
    Expect(0, 113840, '\p{Block=shorthandformatcontrols}', "");
    Expect(1, 113840, '\p{^Block=shorthandformatcontrols}', "");
    Expect(1, 113840, '\P{Block=shorthandformatcontrols}', "");
    Expect(0, 113840, '\P{^Block=shorthandformatcontrols}', "");
    Expect(1, 113839, '\p{Block=:\Ashorthandformatcontrols\z:}', "");;
    Expect(0, 113840, '\p{Block=:\Ashorthandformatcontrols\z:}', "");;
    Expect(1, 113839, '\p{Block=--Shorthand_Format_controls}', "");
    Expect(0, 113839, '\p{^Block=--Shorthand_Format_controls}', "");
    Expect(0, 113839, '\P{Block=--Shorthand_Format_controls}', "");
    Expect(1, 113839, '\P{^Block=--Shorthand_Format_controls}', "");
    Expect(0, 113840, '\p{Block=--Shorthand_Format_controls}', "");
    Expect(1, 113840, '\p{^Block=--Shorthand_Format_controls}', "");
    Expect(1, 113840, '\P{Block=--Shorthand_Format_controls}', "");
    Expect(0, 113840, '\P{^Block=--Shorthand_Format_controls}', "");
    Error('\p{Blk= 	shorthand_FORMAT_Controls/a/}');
    Error('\P{Blk= 	shorthand_FORMAT_Controls/a/}');
    Expect(1, 113839, '\p{Blk=:\AShorthand_Format_Controls\z:}', "");;
    Expect(0, 113840, '\p{Blk=:\AShorthand_Format_Controls\z:}', "");;
    Expect(1, 113839, '\p{Blk=shorthandformatcontrols}', "");
    Expect(0, 113839, '\p{^Blk=shorthandformatcontrols}', "");
    Expect(0, 113839, '\P{Blk=shorthandformatcontrols}', "");
    Expect(1, 113839, '\P{^Blk=shorthandformatcontrols}', "");
    Expect(0, 113840, '\p{Blk=shorthandformatcontrols}', "");
    Expect(1, 113840, '\p{^Blk=shorthandformatcontrols}', "");
    Expect(1, 113840, '\P{Blk=shorthandformatcontrols}', "");
    Expect(0, 113840, '\P{^Blk=shorthandformatcontrols}', "");
    Expect(1, 113839, '\p{Blk=:\Ashorthandformatcontrols\z:}', "");;
    Expect(0, 113840, '\p{Blk=:\Ashorthandformatcontrols\z:}', "");;
    Expect(1, 113839, '\p{Blk=-	Shorthand_format_CONTROLS}', "");
    Expect(0, 113839, '\p{^Blk=-	Shorthand_format_CONTROLS}', "");
    Expect(0, 113839, '\P{Blk=-	Shorthand_format_CONTROLS}', "");
    Expect(1, 113839, '\P{^Blk=-	Shorthand_format_CONTROLS}', "");
    Expect(0, 113840, '\p{Blk=-	Shorthand_format_CONTROLS}', "");
    Expect(1, 113840, '\p{^Blk=-	Shorthand_format_CONTROLS}', "");
    Expect(1, 113840, '\P{Blk=-	Shorthand_format_CONTROLS}', "");
    Expect(0, 113840, '\P{^Blk=-	Shorthand_format_CONTROLS}', "");
    Error('\p{Is_Block:	/a/_SHORTHAND_Format_Controls}');
    Error('\P{Is_Block:	/a/_SHORTHAND_Format_Controls}');
    Expect(1, 113839, '\p{Is_Block=shorthandformatcontrols}', "");
    Expect(0, 113839, '\p{^Is_Block=shorthandformatcontrols}', "");
    Expect(0, 113839, '\P{Is_Block=shorthandformatcontrols}', "");
    Expect(1, 113839, '\P{^Is_Block=shorthandformatcontrols}', "");
    Expect(0, 113840, '\p{Is_Block=shorthandformatcontrols}', "");
    Expect(1, 113840, '\p{^Is_Block=shorthandformatcontrols}', "");
    Expect(1, 113840, '\P{Is_Block=shorthandformatcontrols}', "");
    Expect(0, 113840, '\P{^Is_Block=shorthandformatcontrols}', "");
    Expect(1, 113839, '\p{Is_Block=	 SHORTHAND_format_Controls}', "");
    Expect(0, 113839, '\p{^Is_Block=	 SHORTHAND_format_Controls}', "");
    Expect(0, 113839, '\P{Is_Block=	 SHORTHAND_format_Controls}', "");
    Expect(1, 113839, '\P{^Is_Block=	 SHORTHAND_format_Controls}', "");
    Expect(0, 113840, '\p{Is_Block=	 SHORTHAND_format_Controls}', "");
    Expect(1, 113840, '\p{^Is_Block=	 SHORTHAND_format_Controls}', "");
    Expect(1, 113840, '\P{Is_Block=	 SHORTHAND_format_Controls}', "");
    Expect(0, 113840, '\P{^Is_Block=	 SHORTHAND_format_Controls}', "");
    Error('\p{Is_Blk:   	/a/Shorthand_Format_CONTROLS}');
    Error('\P{Is_Blk:   	/a/Shorthand_Format_CONTROLS}');
    Expect(1, 113839, '\p{Is_Blk=shorthandformatcontrols}', "");
    Expect(0, 113839, '\p{^Is_Blk=shorthandformatcontrols}', "");
    Expect(0, 113839, '\P{Is_Blk=shorthandformatcontrols}', "");
    Expect(1, 113839, '\P{^Is_Blk=shorthandformatcontrols}', "");
    Expect(0, 113840, '\p{Is_Blk=shorthandformatcontrols}', "");
    Expect(1, 113840, '\p{^Is_Blk=shorthandformatcontrols}', "");
    Expect(1, 113840, '\P{Is_Blk=shorthandformatcontrols}', "");
    Expect(0, 113840, '\P{^Is_Blk=shorthandformatcontrols}', "");
    Expect(1, 113839, '\p{Is_Blk=--Shorthand_Format_Controls}', "");
    Expect(0, 113839, '\p{^Is_Blk=--Shorthand_Format_Controls}', "");
    Expect(0, 113839, '\P{Is_Blk=--Shorthand_Format_Controls}', "");
    Expect(1, 113839, '\P{^Is_Blk=--Shorthand_Format_Controls}', "");
    Expect(0, 113840, '\p{Is_Blk=--Shorthand_Format_Controls}', "");
    Expect(1, 113840, '\p{^Is_Blk=--Shorthand_Format_Controls}', "");
    Expect(1, 113840, '\P{Is_Blk=--Shorthand_Format_Controls}', "");
    Expect(0, 113840, '\P{^Is_Blk=--Shorthand_Format_Controls}', "");
    Error('\p{Block= /a/Siddham}');
    Error('\P{Block= /a/Siddham}');
    Expect(1, 71167, '\p{Block=:\ASiddham\z:}', "");;
    Expect(0, 71168, '\p{Block=:\ASiddham\z:}', "");;
    Expect(1, 71167, '\p{Block=siddham}', "");
    Expect(0, 71167, '\p{^Block=siddham}', "");
    Expect(0, 71167, '\P{Block=siddham}', "");
    Expect(1, 71167, '\P{^Block=siddham}', "");
    Expect(0, 71168, '\p{Block=siddham}', "");
    Expect(1, 71168, '\p{^Block=siddham}', "");
    Expect(1, 71168, '\P{Block=siddham}', "");
    Expect(0, 71168, '\P{^Block=siddham}', "");
    Expect(1, 71167, '\p{Block=:\Asiddham\z:}', "");;
    Expect(0, 71168, '\p{Block=:\Asiddham\z:}', "");;
    Expect(1, 71167, '\p{Block:   Siddham}', "");
    Expect(0, 71167, '\p{^Block:   Siddham}', "");
    Expect(0, 71167, '\P{Block:   Siddham}', "");
    Expect(1, 71167, '\P{^Block:   Siddham}', "");
    Expect(0, 71168, '\p{Block:   Siddham}', "");
    Expect(1, 71168, '\p{^Block:   Siddham}', "");
    Expect(1, 71168, '\P{Block:   Siddham}', "");
    Expect(0, 71168, '\P{^Block:   Siddham}', "");
    Error('\p{Blk=_	Siddham:=}');
    Error('\P{Blk=_	Siddham:=}');
    Expect(1, 71167, '\p{Blk=:\ASiddham\z:}', "");;
    Expect(0, 71168, '\p{Blk=:\ASiddham\z:}', "");;
    Expect(1, 71167, '\p{Blk=siddham}', "");
    Expect(0, 71167, '\p{^Blk=siddham}', "");
    Expect(0, 71167, '\P{Blk=siddham}', "");
    Expect(1, 71167, '\P{^Blk=siddham}', "");
    Expect(0, 71168, '\p{Blk=siddham}', "");
    Expect(1, 71168, '\p{^Blk=siddham}', "");
    Expect(1, 71168, '\P{Blk=siddham}', "");
    Expect(0, 71168, '\P{^Blk=siddham}', "");
    Expect(1, 71167, '\p{Blk=:\Asiddham\z:}', "");;
    Expect(0, 71168, '\p{Blk=:\Asiddham\z:}', "");;
    Expect(1, 71167, '\p{Blk=	_siddham}', "");
    Expect(0, 71167, '\p{^Blk=	_siddham}', "");
    Expect(0, 71167, '\P{Blk=	_siddham}', "");
    Expect(1, 71167, '\P{^Blk=	_siddham}', "");
    Expect(0, 71168, '\p{Blk=	_siddham}', "");
    Expect(1, 71168, '\p{^Blk=	_siddham}', "");
    Expect(1, 71168, '\P{Blk=	_siddham}', "");
    Expect(0, 71168, '\P{^Blk=	_siddham}', "");
    Error('\p{Is_Block=/a/ SIDDHAM}');
    Error('\P{Is_Block=/a/ SIDDHAM}');
    Expect(1, 71167, '\p{Is_Block=siddham}', "");
    Expect(0, 71167, '\p{^Is_Block=siddham}', "");
    Expect(0, 71167, '\P{Is_Block=siddham}', "");
    Expect(1, 71167, '\P{^Is_Block=siddham}', "");
    Expect(0, 71168, '\p{Is_Block=siddham}', "");
    Expect(1, 71168, '\p{^Is_Block=siddham}', "");
    Expect(1, 71168, '\P{Is_Block=siddham}', "");
    Expect(0, 71168, '\P{^Is_Block=siddham}', "");
    Expect(1, 71167, '\p{Is_Block=  Siddham}', "");
    Expect(0, 71167, '\p{^Is_Block=  Siddham}', "");
    Expect(0, 71167, '\P{Is_Block=  Siddham}', "");
    Expect(1, 71167, '\P{^Is_Block=  Siddham}', "");
    Expect(0, 71168, '\p{Is_Block=  Siddham}', "");
    Expect(1, 71168, '\p{^Is_Block=  Siddham}', "");
    Expect(1, 71168, '\P{Is_Block=  Siddham}', "");
    Expect(0, 71168, '\P{^Is_Block=  Siddham}', "");
    Error('\p{Is_Blk=--Siddham/a/}');
    Error('\P{Is_Blk=--Siddham/a/}');
    Expect(1, 71167, '\p{Is_Blk=siddham}', "");
    Expect(0, 71167, '\p{^Is_Blk=siddham}', "");
    Expect(0, 71167, '\P{Is_Blk=siddham}', "");
    Expect(1, 71167, '\P{^Is_Blk=siddham}', "");
    Expect(0, 71168, '\p{Is_Blk=siddham}', "");
    Expect(1, 71168, '\p{^Is_Blk=siddham}', "");
    Expect(1, 71168, '\P{Is_Blk=siddham}', "");
    Expect(0, 71168, '\P{^Is_Blk=siddham}', "");
    Expect(1, 71167, '\p{Is_Blk=-Siddham}', "");
    Expect(0, 71167, '\p{^Is_Blk=-Siddham}', "");
    Expect(0, 71167, '\P{Is_Blk=-Siddham}', "");
    Expect(1, 71167, '\P{^Is_Blk=-Siddham}', "");
    Expect(0, 71168, '\p{Is_Blk=-Siddham}', "");
    Expect(1, 71168, '\p{^Is_Blk=-Siddham}', "");
    Expect(1, 71168, '\P{Is_Blk=-Siddham}', "");
    Expect(0, 71168, '\P{^Is_Blk=-Siddham}', "");
    Error('\p{Block= :=Sinhala}');
    Error('\P{Block= :=Sinhala}');
    Expect(1, 3583, '\p{Block=:\ASinhala\z:}', "");;
    Expect(0, 3584, '\p{Block=:\ASinhala\z:}', "");;
    Expect(1, 3583, '\p{Block=sinhala}', "");
    Expect(0, 3583, '\p{^Block=sinhala}', "");
    Expect(0, 3583, '\P{Block=sinhala}', "");
    Expect(1, 3583, '\P{^Block=sinhala}', "");
    Expect(0, 3584, '\p{Block=sinhala}', "");
    Expect(1, 3584, '\p{^Block=sinhala}', "");
    Expect(1, 3584, '\P{Block=sinhala}', "");
    Expect(0, 3584, '\P{^Block=sinhala}', "");
    Expect(1, 3583, '\p{Block=:\Asinhala\z:}', "");;
    Expect(0, 3584, '\p{Block=:\Asinhala\z:}', "");;
    Expect(1, 3583, '\p{Block= 	Sinhala}', "");
    Expect(0, 3583, '\p{^Block= 	Sinhala}', "");
    Expect(0, 3583, '\P{Block= 	Sinhala}', "");
    Expect(1, 3583, '\P{^Block= 	Sinhala}', "");
    Expect(0, 3584, '\p{Block= 	Sinhala}', "");
    Expect(1, 3584, '\p{^Block= 	Sinhala}', "");
    Expect(1, 3584, '\P{Block= 	Sinhala}', "");
    Expect(0, 3584, '\P{^Block= 	Sinhala}', "");
    Error('\p{Blk=	 sinhala:=}');
    Error('\P{Blk=	 sinhala:=}');
    Expect(1, 3583, '\p{Blk=:\ASinhala\z:}', "");;
    Expect(0, 3584, '\p{Blk=:\ASinhala\z:}', "");;
    Expect(1, 3583, '\p{Blk=sinhala}', "");
    Expect(0, 3583, '\p{^Blk=sinhala}', "");
    Expect(0, 3583, '\P{Blk=sinhala}', "");
    Expect(1, 3583, '\P{^Blk=sinhala}', "");
    Expect(0, 3584, '\p{Blk=sinhala}', "");
    Expect(1, 3584, '\p{^Blk=sinhala}', "");
    Expect(1, 3584, '\P{Blk=sinhala}', "");
    Expect(0, 3584, '\P{^Blk=sinhala}', "");
    Expect(1, 3583, '\p{Blk=:\Asinhala\z:}', "");;
    Expect(0, 3584, '\p{Blk=:\Asinhala\z:}', "");;
    Expect(1, 3583, '\p{Blk=-_Sinhala}', "");
    Expect(0, 3583, '\p{^Blk=-_Sinhala}', "");
    Expect(0, 3583, '\P{Blk=-_Sinhala}', "");
    Expect(1, 3583, '\P{^Blk=-_Sinhala}', "");
    Expect(0, 3584, '\p{Blk=-_Sinhala}', "");
    Expect(1, 3584, '\p{^Blk=-_Sinhala}', "");
    Expect(1, 3584, '\P{Blk=-_Sinhala}', "");
    Expect(0, 3584, '\P{^Blk=-_Sinhala}', "");
    Error('\p{Is_Block=:=- SINHALA}');
    Error('\P{Is_Block=:=- SINHALA}');
    Expect(1, 3583, '\p{Is_Block=sinhala}', "");
    Expect(0, 3583, '\p{^Is_Block=sinhala}', "");
    Expect(0, 3583, '\P{Is_Block=sinhala}', "");
    Expect(1, 3583, '\P{^Is_Block=sinhala}', "");
    Expect(0, 3584, '\p{Is_Block=sinhala}', "");
    Expect(1, 3584, '\p{^Is_Block=sinhala}', "");
    Expect(1, 3584, '\P{Is_Block=sinhala}', "");
    Expect(0, 3584, '\P{^Is_Block=sinhala}', "");
    Expect(1, 3583, '\p{Is_Block=_SINHALA}', "");
    Expect(0, 3583, '\p{^Is_Block=_SINHALA}', "");
    Expect(0, 3583, '\P{Is_Block=_SINHALA}', "");
    Expect(1, 3583, '\P{^Is_Block=_SINHALA}', "");
    Expect(0, 3584, '\p{Is_Block=_SINHALA}', "");
    Expect(1, 3584, '\p{^Is_Block=_SINHALA}', "");
    Expect(1, 3584, '\P{Is_Block=_SINHALA}', "");
    Expect(0, 3584, '\P{^Is_Block=_SINHALA}', "");
    Error('\p{Is_Blk=/a/ SINHALA}');
    Error('\P{Is_Blk=/a/ SINHALA}');
    Expect(1, 3583, '\p{Is_Blk=sinhala}', "");
    Expect(0, 3583, '\p{^Is_Blk=sinhala}', "");
    Expect(0, 3583, '\P{Is_Blk=sinhala}', "");
    Expect(1, 3583, '\P{^Is_Blk=sinhala}', "");
    Expect(0, 3584, '\p{Is_Blk=sinhala}', "");
    Expect(1, 3584, '\p{^Is_Blk=sinhala}', "");
    Expect(1, 3584, '\P{Is_Blk=sinhala}', "");
    Expect(0, 3584, '\P{^Is_Blk=sinhala}', "");
    Expect(1, 3583, '\p{Is_Blk= _Sinhala}', "");
    Expect(0, 3583, '\p{^Is_Blk= _Sinhala}', "");
    Expect(0, 3583, '\P{Is_Blk= _Sinhala}', "");
    Expect(1, 3583, '\P{^Is_Blk= _Sinhala}', "");
    Expect(0, 3584, '\p{Is_Blk= _Sinhala}', "");
    Expect(1, 3584, '\p{^Is_Blk= _Sinhala}', "");
    Expect(1, 3584, '\P{Is_Blk= _Sinhala}', "");
    Expect(0, 3584, '\P{^Is_Blk= _Sinhala}', "");
    Error('\p{Block=:=Sinhala_archaic_NUMBERS}');
    Error('\P{Block=:=Sinhala_archaic_NUMBERS}');
    Expect(1, 70143, '\p{Block=:\ASinhala_Archaic_Numbers\z:}', "");;
    Expect(0, 70144, '\p{Block=:\ASinhala_Archaic_Numbers\z:}', "");;
    Expect(1, 70143, '\p{Block=sinhalaarchaicnumbers}', "");
    Expect(0, 70143, '\p{^Block=sinhalaarchaicnumbers}', "");
    Expect(0, 70143, '\P{Block=sinhalaarchaicnumbers}', "");
    Expect(1, 70143, '\P{^Block=sinhalaarchaicnumbers}', "");
    Expect(0, 70144, '\p{Block=sinhalaarchaicnumbers}', "");
    Expect(1, 70144, '\p{^Block=sinhalaarchaicnumbers}', "");
    Expect(1, 70144, '\P{Block=sinhalaarchaicnumbers}', "");
    Expect(0, 70144, '\P{^Block=sinhalaarchaicnumbers}', "");
    Expect(1, 70143, '\p{Block=:\Asinhalaarchaicnumbers\z:}', "");;
    Expect(0, 70144, '\p{Block=:\Asinhalaarchaicnumbers\z:}', "");;
    Expect(1, 70143, '\p{Block=_ Sinhala_archaic_NUMBERS}', "");
    Expect(0, 70143, '\p{^Block=_ Sinhala_archaic_NUMBERS}', "");
    Expect(0, 70143, '\P{Block=_ Sinhala_archaic_NUMBERS}', "");
    Expect(1, 70143, '\P{^Block=_ Sinhala_archaic_NUMBERS}', "");
    Expect(0, 70144, '\p{Block=_ Sinhala_archaic_NUMBERS}', "");
    Expect(1, 70144, '\p{^Block=_ Sinhala_archaic_NUMBERS}', "");
    Expect(1, 70144, '\P{Block=_ Sinhala_archaic_NUMBERS}', "");
    Expect(0, 70144, '\P{^Block=_ Sinhala_archaic_NUMBERS}', "");
    Error('\p{Blk=-	sinhala_archaic_Numbers/a/}');
    Error('\P{Blk=-	sinhala_archaic_Numbers/a/}');
    Expect(1, 70143, '\p{Blk=:\ASinhala_Archaic_Numbers\z:}', "");;
    Expect(0, 70144, '\p{Blk=:\ASinhala_Archaic_Numbers\z:}', "");;
    Expect(1, 70143, '\p{Blk=sinhalaarchaicnumbers}', "");
    Expect(0, 70143, '\p{^Blk=sinhalaarchaicnumbers}', "");
    Expect(0, 70143, '\P{Blk=sinhalaarchaicnumbers}', "");
    Expect(1, 70143, '\P{^Blk=sinhalaarchaicnumbers}', "");
    Expect(0, 70144, '\p{Blk=sinhalaarchaicnumbers}', "");
    Expect(1, 70144, '\p{^Blk=sinhalaarchaicnumbers}', "");
    Expect(1, 70144, '\P{Blk=sinhalaarchaicnumbers}', "");
    Expect(0, 70144, '\P{^Blk=sinhalaarchaicnumbers}', "");
    Expect(1, 70143, '\p{Blk=:\Asinhalaarchaicnumbers\z:}', "");;
    Expect(0, 70144, '\p{Blk=:\Asinhalaarchaicnumbers\z:}', "");;
    Expect(1, 70143, '\p{Blk= 	Sinhala_ARCHAIC_numbers}', "");
    Expect(0, 70143, '\p{^Blk= 	Sinhala_ARCHAIC_numbers}', "");
    Expect(0, 70143, '\P{Blk= 	Sinhala_ARCHAIC_numbers}', "");
    Expect(1, 70143, '\P{^Blk= 	Sinhala_ARCHAIC_numbers}', "");
    Expect(0, 70144, '\p{Blk= 	Sinhala_ARCHAIC_numbers}', "");
    Expect(1, 70144, '\p{^Blk= 	Sinhala_ARCHAIC_numbers}', "");
    Expect(1, 70144, '\P{Blk= 	Sinhala_ARCHAIC_numbers}', "");
    Expect(0, 70144, '\P{^Blk= 	Sinhala_ARCHAIC_numbers}', "");
    Error('\p{Is_Block:    :=Sinhala_Archaic_NUMBERS}');
    Error('\P{Is_Block:    :=Sinhala_Archaic_NUMBERS}');
    Expect(1, 70143, '\p{Is_Block=sinhalaarchaicnumbers}', "");
    Expect(0, 70143, '\p{^Is_Block=sinhalaarchaicnumbers}', "");
    Expect(0, 70143, '\P{Is_Block=sinhalaarchaicnumbers}', "");
    Expect(1, 70143, '\P{^Is_Block=sinhalaarchaicnumbers}', "");
    Expect(0, 70144, '\p{Is_Block=sinhalaarchaicnumbers}', "");
    Expect(1, 70144, '\p{^Is_Block=sinhalaarchaicnumbers}', "");
    Expect(1, 70144, '\P{Is_Block=sinhalaarchaicnumbers}', "");
    Expect(0, 70144, '\P{^Is_Block=sinhalaarchaicnumbers}', "");
    Expect(1, 70143, '\p{Is_Block=--Sinhala_Archaic_Numbers}', "");
    Expect(0, 70143, '\p{^Is_Block=--Sinhala_Archaic_Numbers}', "");
    Expect(0, 70143, '\P{Is_Block=--Sinhala_Archaic_Numbers}', "");
    Expect(1, 70143, '\P{^Is_Block=--Sinhala_Archaic_Numbers}', "");
    Expect(0, 70144, '\p{Is_Block=--Sinhala_Archaic_Numbers}', "");
    Expect(1, 70144, '\p{^Is_Block=--Sinhala_Archaic_Numbers}', "");
    Expect(1, 70144, '\P{Is_Block=--Sinhala_Archaic_Numbers}', "");
    Expect(0, 70144, '\P{^Is_Block=--Sinhala_Archaic_Numbers}', "");
    Error('\p{Is_Blk=/a/--SINHALA_ARCHAIC_Numbers}');
    Error('\P{Is_Blk=/a/--SINHALA_ARCHAIC_Numbers}');
    Expect(1, 70143, '\p{Is_Blk=sinhalaarchaicnumbers}', "");
    Expect(0, 70143, '\p{^Is_Blk=sinhalaarchaicnumbers}', "");
    Expect(0, 70143, '\P{Is_Blk=sinhalaarchaicnumbers}', "");
    Expect(1, 70143, '\P{^Is_Blk=sinhalaarchaicnumbers}', "");
    Expect(0, 70144, '\p{Is_Blk=sinhalaarchaicnumbers}', "");
    Expect(1, 70144, '\p{^Is_Blk=sinhalaarchaicnumbers}', "");
    Expect(1, 70144, '\P{Is_Blk=sinhalaarchaicnumbers}', "");
    Expect(0, 70144, '\P{^Is_Blk=sinhalaarchaicnumbers}', "");
    Expect(1, 70143, '\p{Is_Blk=-_sinhala_ARCHAIC_Numbers}', "");
    Expect(0, 70143, '\p{^Is_Blk=-_sinhala_ARCHAIC_Numbers}', "");
    Expect(0, 70143, '\P{Is_Blk=-_sinhala_ARCHAIC_Numbers}', "");
    Expect(1, 70143, '\P{^Is_Blk=-_sinhala_ARCHAIC_Numbers}', "");
    Expect(0, 70144, '\p{Is_Blk=-_sinhala_ARCHAIC_Numbers}', "");
    Expect(1, 70144, '\p{^Is_Blk=-_sinhala_ARCHAIC_Numbers}', "");
    Expect(1, 70144, '\P{Is_Blk=-_sinhala_ARCHAIC_Numbers}', "");
    Expect(0, 70144, '\P{^Is_Blk=-_sinhala_ARCHAIC_Numbers}', "");
    Error('\p{Block= _Small_Form_variants/a/}');
    Error('\P{Block= _Small_Form_variants/a/}');
    Expect(1, 65135, '\p{Block=:\ASmall_Form_Variants\z:}', "");;
    Expect(0, 65136, '\p{Block=:\ASmall_Form_Variants\z:}', "");;
    Expect(1, 65135, '\p{Block=smallformvariants}', "");
    Expect(0, 65135, '\p{^Block=smallformvariants}', "");
    Expect(0, 65135, '\P{Block=smallformvariants}', "");
    Expect(1, 65135, '\P{^Block=smallformvariants}', "");
    Expect(0, 65136, '\p{Block=smallformvariants}', "");
    Expect(1, 65136, '\p{^Block=smallformvariants}', "");
    Expect(1, 65136, '\P{Block=smallformvariants}', "");
    Expect(0, 65136, '\P{^Block=smallformvariants}', "");
    Expect(1, 65135, '\p{Block=:\Asmallformvariants\z:}', "");;
    Expect(0, 65136, '\p{Block=:\Asmallformvariants\z:}', "");;
    Expect(1, 65135, '\p{Block=_-Small_Form_Variants}', "");
    Expect(0, 65135, '\p{^Block=_-Small_Form_Variants}', "");
    Expect(0, 65135, '\P{Block=_-Small_Form_Variants}', "");
    Expect(1, 65135, '\P{^Block=_-Small_Form_Variants}', "");
    Expect(0, 65136, '\p{Block=_-Small_Form_Variants}', "");
    Expect(1, 65136, '\p{^Block=_-Small_Form_Variants}', "");
    Expect(1, 65136, '\P{Block=_-Small_Form_Variants}', "");
    Expect(0, 65136, '\P{^Block=_-Small_Form_Variants}', "");
    Error('\p{Blk=/a/Small_Forms}');
    Error('\P{Blk=/a/Small_Forms}');
    Expect(1, 65135, '\p{Blk=:\ASmall_Forms\z:}', "");;
    Expect(0, 65136, '\p{Blk=:\ASmall_Forms\z:}', "");;
    Expect(1, 65135, '\p{Blk:smallforms}', "");
    Expect(0, 65135, '\p{^Blk:smallforms}', "");
    Expect(0, 65135, '\P{Blk:smallforms}', "");
    Expect(1, 65135, '\P{^Blk:smallforms}', "");
    Expect(0, 65136, '\p{Blk:smallforms}', "");
    Expect(1, 65136, '\p{^Blk:smallforms}', "");
    Expect(1, 65136, '\P{Blk:smallforms}', "");
    Expect(0, 65136, '\P{^Blk:smallforms}', "");
    Expect(1, 65135, '\p{Blk=:\Asmallforms\z:}', "");;
    Expect(0, 65136, '\p{Blk=:\Asmallforms\z:}', "");;
    Expect(1, 65135, '\p{Blk=-_SMALL_FORMS}', "");
    Expect(0, 65135, '\p{^Blk=-_SMALL_FORMS}', "");
    Expect(0, 65135, '\P{Blk=-_SMALL_FORMS}', "");
    Expect(1, 65135, '\P{^Blk=-_SMALL_FORMS}', "");
    Expect(0, 65136, '\p{Blk=-_SMALL_FORMS}', "");
    Expect(1, 65136, '\p{^Blk=-_SMALL_FORMS}', "");
    Expect(1, 65136, '\P{Blk=-_SMALL_FORMS}', "");
    Expect(0, 65136, '\P{^Blk=-_SMALL_FORMS}', "");
    Error('\p{Is_Block::=	 small_FORM_Variants}');
    Error('\P{Is_Block::=	 small_FORM_Variants}');
    Expect(1, 65135, '\p{Is_Block=smallformvariants}', "");
    Expect(0, 65135, '\p{^Is_Block=smallformvariants}', "");
    Expect(0, 65135, '\P{Is_Block=smallformvariants}', "");
    Expect(1, 65135, '\P{^Is_Block=smallformvariants}', "");
    Expect(0, 65136, '\p{Is_Block=smallformvariants}', "");
    Expect(1, 65136, '\p{^Is_Block=smallformvariants}', "");
    Expect(1, 65136, '\P{Is_Block=smallformvariants}', "");
    Expect(0, 65136, '\P{^Is_Block=smallformvariants}', "");
    Expect(1, 65135, '\p{Is_Block=_Small_Form_VARIANTS}', "");
    Expect(0, 65135, '\p{^Is_Block=_Small_Form_VARIANTS}', "");
    Expect(0, 65135, '\P{Is_Block=_Small_Form_VARIANTS}', "");
    Expect(1, 65135, '\P{^Is_Block=_Small_Form_VARIANTS}', "");
    Expect(0, 65136, '\p{Is_Block=_Small_Form_VARIANTS}', "");
    Expect(1, 65136, '\p{^Is_Block=_Small_Form_VARIANTS}', "");
    Expect(1, 65136, '\P{Is_Block=_Small_Form_VARIANTS}', "");
    Expect(0, 65136, '\P{^Is_Block=_Small_Form_VARIANTS}', "");
    Error('\p{Is_Blk=-/a/SMALL_Forms}');
    Error('\P{Is_Blk=-/a/SMALL_Forms}');
    Expect(1, 65135, '\p{Is_Blk:   smallforms}', "");
    Expect(0, 65135, '\p{^Is_Blk:   smallforms}', "");
    Expect(0, 65135, '\P{Is_Blk:   smallforms}', "");
    Expect(1, 65135, '\P{^Is_Blk:   smallforms}', "");
    Expect(0, 65136, '\p{Is_Blk:   smallforms}', "");
    Expect(1, 65136, '\p{^Is_Blk:   smallforms}', "");
    Expect(1, 65136, '\P{Is_Blk:   smallforms}', "");
    Expect(0, 65136, '\P{^Is_Blk:   smallforms}', "");
    Expect(1, 65135, '\p{Is_Blk= small_FORMS}', "");
    Expect(0, 65135, '\p{^Is_Blk= small_FORMS}', "");
    Expect(0, 65135, '\P{Is_Blk= small_FORMS}', "");
    Expect(1, 65135, '\P{^Is_Blk= small_FORMS}', "");
    Expect(0, 65136, '\p{Is_Blk= small_FORMS}', "");
    Expect(1, 65136, '\p{^Is_Blk= small_FORMS}', "");
    Expect(1, 65136, '\P{Is_Blk= small_FORMS}', "");
    Expect(0, 65136, '\P{^Is_Blk= small_FORMS}', "");
    Error('\p{Block=:=-_Small_KANA_EXTENSION}');
    Error('\P{Block=:=-_Small_KANA_EXTENSION}');
    Expect(1, 110959, '\p{Block=:\ASmall_Kana_Extension\z:}', "");;
    Expect(0, 110960, '\p{Block=:\ASmall_Kana_Extension\z:}', "");;
    Expect(1, 110959, '\p{Block=smallkanaextension}', "");
    Expect(0, 110959, '\p{^Block=smallkanaextension}', "");
    Expect(0, 110959, '\P{Block=smallkanaextension}', "");
    Expect(1, 110959, '\P{^Block=smallkanaextension}', "");
    Expect(0, 110960, '\p{Block=smallkanaextension}', "");
    Expect(1, 110960, '\p{^Block=smallkanaextension}', "");
    Expect(1, 110960, '\P{Block=smallkanaextension}', "");
    Expect(0, 110960, '\P{^Block=smallkanaextension}', "");
    Expect(1, 110959, '\p{Block=:\Asmallkanaextension\z:}', "");;
    Expect(0, 110960, '\p{Block=:\Asmallkanaextension\z:}', "");;
    Expect(1, 110959, '\p{Block=  Small_kana_Extension}', "");
    Expect(0, 110959, '\p{^Block=  Small_kana_Extension}', "");
    Expect(0, 110959, '\P{Block=  Small_kana_Extension}', "");
    Expect(1, 110959, '\P{^Block=  Small_kana_Extension}', "");
    Expect(0, 110960, '\p{Block=  Small_kana_Extension}', "");
    Expect(1, 110960, '\p{^Block=  Small_kana_Extension}', "");
    Expect(1, 110960, '\P{Block=  Small_kana_Extension}', "");
    Expect(0, 110960, '\P{^Block=  Small_kana_Extension}', "");
    Error('\p{Blk:   /a/-	Small_KANA_Ext}');
    Error('\P{Blk:   /a/-	Small_KANA_Ext}');
    Expect(1, 110959, '\p{Blk=:\ASmall_Kana_Ext\z:}', "");;
    Expect(0, 110960, '\p{Blk=:\ASmall_Kana_Ext\z:}', "");;
    Expect(1, 110959, '\p{Blk=smallkanaext}', "");
    Expect(0, 110959, '\p{^Blk=smallkanaext}', "");
    Expect(0, 110959, '\P{Blk=smallkanaext}', "");
    Expect(1, 110959, '\P{^Blk=smallkanaext}', "");
    Expect(0, 110960, '\p{Blk=smallkanaext}', "");
    Expect(1, 110960, '\p{^Blk=smallkanaext}', "");
    Expect(1, 110960, '\P{Blk=smallkanaext}', "");
    Expect(0, 110960, '\P{^Blk=smallkanaext}', "");
    Expect(1, 110959, '\p{Blk=:\Asmallkanaext\z:}', "");;
    Expect(0, 110960, '\p{Blk=:\Asmallkanaext\z:}', "");;
    Expect(1, 110959, '\p{Blk=__Small_kana_ext}', "");
    Expect(0, 110959, '\p{^Blk=__Small_kana_ext}', "");
    Expect(0, 110959, '\P{Blk=__Small_kana_ext}', "");
    Expect(1, 110959, '\P{^Blk=__Small_kana_ext}', "");
    Expect(0, 110960, '\p{Blk=__Small_kana_ext}', "");
    Expect(1, 110960, '\p{^Blk=__Small_kana_ext}', "");
    Expect(1, 110960, '\P{Blk=__Small_kana_ext}', "");
    Expect(0, 110960, '\P{^Blk=__Small_kana_ext}', "");
    Error('\p{Is_Block=/a/Small_Kana_extension}');
    Error('\P{Is_Block=/a/Small_Kana_extension}');
    Expect(1, 110959, '\p{Is_Block=smallkanaextension}', "");
    Expect(0, 110959, '\p{^Is_Block=smallkanaextension}', "");
    Expect(0, 110959, '\P{Is_Block=smallkanaextension}', "");
    Expect(1, 110959, '\P{^Is_Block=smallkanaextension}', "");
    Expect(0, 110960, '\p{Is_Block=smallkanaextension}', "");
    Expect(1, 110960, '\p{^Is_Block=smallkanaextension}', "");
    Expect(1, 110960, '\P{Is_Block=smallkanaextension}', "");
    Expect(0, 110960, '\P{^Is_Block=smallkanaextension}', "");
    Expect(1, 110959, '\p{Is_Block=small_KANA_Extension}', "");
    Expect(0, 110959, '\p{^Is_Block=small_KANA_Extension}', "");
    Expect(0, 110959, '\P{Is_Block=small_KANA_Extension}', "");
    Expect(1, 110959, '\P{^Is_Block=small_KANA_Extension}', "");
    Expect(0, 110960, '\p{Is_Block=small_KANA_Extension}', "");
    Expect(1, 110960, '\p{^Is_Block=small_KANA_Extension}', "");
    Expect(1, 110960, '\P{Is_Block=small_KANA_Extension}', "");
    Expect(0, 110960, '\P{^Is_Block=small_KANA_Extension}', "");
    Error('\p{Is_Blk=/a/ small_KANA_EXT}');
    Error('\P{Is_Blk=/a/ small_KANA_EXT}');
    Expect(1, 110959, '\p{Is_Blk=smallkanaext}', "");
    Expect(0, 110959, '\p{^Is_Blk=smallkanaext}', "");
    Expect(0, 110959, '\P{Is_Blk=smallkanaext}', "");
    Expect(1, 110959, '\P{^Is_Blk=smallkanaext}', "");
    Expect(0, 110960, '\p{Is_Blk=smallkanaext}', "");
    Expect(1, 110960, '\p{^Is_Blk=smallkanaext}', "");
    Expect(1, 110960, '\P{Is_Blk=smallkanaext}', "");
    Expect(0, 110960, '\P{^Is_Blk=smallkanaext}', "");
    Expect(1, 110959, '\p{Is_Blk=	_small_kana_ext}', "");
    Expect(0, 110959, '\p{^Is_Blk=	_small_kana_ext}', "");
    Expect(0, 110959, '\P{Is_Blk=	_small_kana_ext}', "");
    Expect(1, 110959, '\P{^Is_Blk=	_small_kana_ext}', "");
    Expect(0, 110960, '\p{Is_Blk=	_small_kana_ext}', "");
    Expect(1, 110960, '\p{^Is_Blk=	_small_kana_ext}', "");
    Expect(1, 110960, '\P{Is_Blk=	_small_kana_ext}', "");
    Expect(0, 110960, '\P{^Is_Blk=	_small_kana_ext}', "");
    Error('\p{Block=:=  Sogdian}');
    Error('\P{Block=:=  Sogdian}');
    Expect(1, 69487, '\p{Block=:\ASogdian\z:}', "");;
    Expect(0, 69488, '\p{Block=:\ASogdian\z:}', "");;
    Expect(1, 69487, '\p{Block=sogdian}', "");
    Expect(0, 69487, '\p{^Block=sogdian}', "");
    Expect(0, 69487, '\P{Block=sogdian}', "");
    Expect(1, 69487, '\P{^Block=sogdian}', "");
    Expect(0, 69488, '\p{Block=sogdian}', "");
    Expect(1, 69488, '\p{^Block=sogdian}', "");
    Expect(1, 69488, '\P{Block=sogdian}', "");
    Expect(0, 69488, '\P{^Block=sogdian}', "");
    Expect(1, 69487, '\p{Block=:\Asogdian\z:}', "");;
    Expect(0, 69488, '\p{Block=:\Asogdian\z:}', "");;
    Expect(1, 69487, '\p{Block=		Sogdian}', "");
    Expect(0, 69487, '\p{^Block=		Sogdian}', "");
    Expect(0, 69487, '\P{Block=		Sogdian}', "");
    Expect(1, 69487, '\P{^Block=		Sogdian}', "");
    Expect(0, 69488, '\p{Block=		Sogdian}', "");
    Expect(1, 69488, '\p{^Block=		Sogdian}', "");
    Expect(1, 69488, '\P{Block=		Sogdian}', "");
    Expect(0, 69488, '\P{^Block=		Sogdian}', "");
    Error('\p{Blk= 	sogdian:=}');
    Error('\P{Blk= 	sogdian:=}');
    Expect(1, 69487, '\p{Blk=:\ASogdian\z:}', "");;
    Expect(0, 69488, '\p{Blk=:\ASogdian\z:}', "");;
    Expect(1, 69487, '\p{Blk=sogdian}', "");
    Expect(0, 69487, '\p{^Blk=sogdian}', "");
    Expect(0, 69487, '\P{Blk=sogdian}', "");
    Expect(1, 69487, '\P{^Blk=sogdian}', "");
    Expect(0, 69488, '\p{Blk=sogdian}', "");
    Expect(1, 69488, '\p{^Blk=sogdian}', "");
    Expect(1, 69488, '\P{Blk=sogdian}', "");
    Expect(0, 69488, '\P{^Blk=sogdian}', "");
    Expect(1, 69487, '\p{Blk=:\Asogdian\z:}', "");;
    Expect(0, 69488, '\p{Blk=:\Asogdian\z:}', "");;
    Expect(1, 69487, '\p{Blk=_	sogdian}', "");
    Expect(0, 69487, '\p{^Blk=_	sogdian}', "");
    Expect(0, 69487, '\P{Blk=_	sogdian}', "");
    Expect(1, 69487, '\P{^Blk=_	sogdian}', "");
    Expect(0, 69488, '\p{Blk=_	sogdian}', "");
    Expect(1, 69488, '\p{^Blk=_	sogdian}', "");
    Expect(1, 69488, '\P{Blk=_	sogdian}', "");
    Expect(0, 69488, '\P{^Blk=_	sogdian}', "");
    Error('\p{Is_Block=-_SOGDIAN:=}');
    Error('\P{Is_Block=-_SOGDIAN:=}');
    Expect(1, 69487, '\p{Is_Block=sogdian}', "");
    Expect(0, 69487, '\p{^Is_Block=sogdian}', "");
    Expect(0, 69487, '\P{Is_Block=sogdian}', "");
    Expect(1, 69487, '\P{^Is_Block=sogdian}', "");
    Expect(0, 69488, '\p{Is_Block=sogdian}', "");
    Expect(1, 69488, '\p{^Is_Block=sogdian}', "");
    Expect(1, 69488, '\P{Is_Block=sogdian}', "");
    Expect(0, 69488, '\P{^Is_Block=sogdian}', "");
    Expect(1, 69487, '\p{Is_Block=_-Sogdian}', "");
    Expect(0, 69487, '\p{^Is_Block=_-Sogdian}', "");
    Expect(0, 69487, '\P{Is_Block=_-Sogdian}', "");
    Expect(1, 69487, '\P{^Is_Block=_-Sogdian}', "");
    Expect(0, 69488, '\p{Is_Block=_-Sogdian}', "");
    Expect(1, 69488, '\p{^Is_Block=_-Sogdian}', "");
    Expect(1, 69488, '\P{Is_Block=_-Sogdian}', "");
    Expect(0, 69488, '\P{^Is_Block=_-Sogdian}', "");
    Error('\p{Is_Blk=-:=Sogdian}');
    Error('\P{Is_Blk=-:=Sogdian}');
    Expect(1, 69487, '\p{Is_Blk=sogdian}', "");
    Expect(0, 69487, '\p{^Is_Blk=sogdian}', "");
    Expect(0, 69487, '\P{Is_Blk=sogdian}', "");
    Expect(1, 69487, '\P{^Is_Blk=sogdian}', "");
    Expect(0, 69488, '\p{Is_Blk=sogdian}', "");
    Expect(1, 69488, '\p{^Is_Blk=sogdian}', "");
    Expect(1, 69488, '\P{Is_Blk=sogdian}', "");
    Expect(0, 69488, '\P{^Is_Blk=sogdian}', "");
    Expect(1, 69487, '\p{Is_Blk=	 Sogdian}', "");
    Expect(0, 69487, '\p{^Is_Blk=	 Sogdian}', "");
    Expect(0, 69487, '\P{Is_Blk=	 Sogdian}', "");
    Expect(1, 69487, '\P{^Is_Blk=	 Sogdian}', "");
    Expect(0, 69488, '\p{Is_Blk=	 Sogdian}', "");
    Expect(1, 69488, '\p{^Is_Blk=	 Sogdian}', "");
    Expect(1, 69488, '\P{Is_Blk=	 Sogdian}', "");
    Expect(0, 69488, '\P{^Is_Blk=	 Sogdian}', "");
    Error('\p{Block= :=Sora_sompeng}');
    Error('\P{Block= :=Sora_sompeng}');
    Expect(1, 69887, '\p{Block=:\ASora_Sompeng\z:}', "");;
    Expect(0, 69888, '\p{Block=:\ASora_Sompeng\z:}', "");;
    Expect(1, 69887, '\p{Block:	sorasompeng}', "");
    Expect(0, 69887, '\p{^Block:	sorasompeng}', "");
    Expect(0, 69887, '\P{Block:	sorasompeng}', "");
    Expect(1, 69887, '\P{^Block:	sorasompeng}', "");
    Expect(0, 69888, '\p{Block:	sorasompeng}', "");
    Expect(1, 69888, '\p{^Block:	sorasompeng}', "");
    Expect(1, 69888, '\P{Block:	sorasompeng}', "");
    Expect(0, 69888, '\P{^Block:	sorasompeng}', "");
    Expect(1, 69887, '\p{Block=:\Asorasompeng\z:}', "");;
    Expect(0, 69888, '\p{Block=:\Asorasompeng\z:}', "");;
    Expect(1, 69887, '\p{Block:	 SORA_SOMPENG}', "");
    Expect(0, 69887, '\p{^Block:	 SORA_SOMPENG}', "");
    Expect(0, 69887, '\P{Block:	 SORA_SOMPENG}', "");
    Expect(1, 69887, '\P{^Block:	 SORA_SOMPENG}', "");
    Expect(0, 69888, '\p{Block:	 SORA_SOMPENG}', "");
    Expect(1, 69888, '\p{^Block:	 SORA_SOMPENG}', "");
    Expect(1, 69888, '\P{Block:	 SORA_SOMPENG}', "");
    Expect(0, 69888, '\P{^Block:	 SORA_SOMPENG}', "");
    Error('\p{Blk=_:=Sora_Sompeng}');
    Error('\P{Blk=_:=Sora_Sompeng}');
    Expect(1, 69887, '\p{Blk=:\ASora_Sompeng\z:}', "");;
    Expect(0, 69888, '\p{Blk=:\ASora_Sompeng\z:}', "");;
    Expect(1, 69887, '\p{Blk=sorasompeng}', "");
    Expect(0, 69887, '\p{^Blk=sorasompeng}', "");
    Expect(0, 69887, '\P{Blk=sorasompeng}', "");
    Expect(1, 69887, '\P{^Blk=sorasompeng}', "");
    Expect(0, 69888, '\p{Blk=sorasompeng}', "");
    Expect(1, 69888, '\p{^Blk=sorasompeng}', "");
    Expect(1, 69888, '\P{Blk=sorasompeng}', "");
    Expect(0, 69888, '\P{^Blk=sorasompeng}', "");
    Expect(1, 69887, '\p{Blk=:\Asorasompeng\z:}', "");;
    Expect(0, 69888, '\p{Blk=:\Asorasompeng\z:}', "");;
    Expect(1, 69887, '\p{Blk=__SORA_Sompeng}', "");
    Expect(0, 69887, '\p{^Blk=__SORA_Sompeng}', "");
    Expect(0, 69887, '\P{Blk=__SORA_Sompeng}', "");
    Expect(1, 69887, '\P{^Blk=__SORA_Sompeng}', "");
    Expect(0, 69888, '\p{Blk=__SORA_Sompeng}', "");
    Expect(1, 69888, '\p{^Blk=__SORA_Sompeng}', "");
    Expect(1, 69888, '\P{Blk=__SORA_Sompeng}', "");
    Expect(0, 69888, '\P{^Blk=__SORA_Sompeng}', "");
    Error('\p{Is_Block= 	SORA_SOMPENG:=}');
    Error('\P{Is_Block= 	SORA_SOMPENG:=}');
    Expect(1, 69887, '\p{Is_Block=sorasompeng}', "");
    Expect(0, 69887, '\p{^Is_Block=sorasompeng}', "");
    Expect(0, 69887, '\P{Is_Block=sorasompeng}', "");
    Expect(1, 69887, '\P{^Is_Block=sorasompeng}', "");
    Expect(0, 69888, '\p{Is_Block=sorasompeng}', "");
    Expect(1, 69888, '\p{^Is_Block=sorasompeng}', "");
    Expect(1, 69888, '\P{Is_Block=sorasompeng}', "");
    Expect(0, 69888, '\P{^Is_Block=sorasompeng}', "");
    Expect(1, 69887, '\p{Is_Block=_	SORA_Sompeng}', "");
    Expect(0, 69887, '\p{^Is_Block=_	SORA_Sompeng}', "");
    Expect(0, 69887, '\P{Is_Block=_	SORA_Sompeng}', "");
    Expect(1, 69887, '\P{^Is_Block=_	SORA_Sompeng}', "");
    Expect(0, 69888, '\p{Is_Block=_	SORA_Sompeng}', "");
    Expect(1, 69888, '\p{^Is_Block=_	SORA_Sompeng}', "");
    Expect(1, 69888, '\P{Is_Block=_	SORA_Sompeng}', "");
    Expect(0, 69888, '\P{^Is_Block=_	SORA_Sompeng}', "");
    Error('\p{Is_Blk=-/a/Sora_Sompeng}');
    Error('\P{Is_Blk=-/a/Sora_Sompeng}');
    Expect(1, 69887, '\p{Is_Blk=sorasompeng}', "");
    Expect(0, 69887, '\p{^Is_Blk=sorasompeng}', "");
    Expect(0, 69887, '\P{Is_Blk=sorasompeng}', "");
    Expect(1, 69887, '\P{^Is_Blk=sorasompeng}', "");
    Expect(0, 69888, '\p{Is_Blk=sorasompeng}', "");
    Expect(1, 69888, '\p{^Is_Blk=sorasompeng}', "");
    Expect(1, 69888, '\P{Is_Blk=sorasompeng}', "");
    Expect(0, 69888, '\P{^Is_Blk=sorasompeng}', "");
    Expect(1, 69887, '\p{Is_Blk=__SORA_sompeng}', "");
    Expect(0, 69887, '\p{^Is_Blk=__SORA_sompeng}', "");
    Expect(0, 69887, '\P{Is_Blk=__SORA_sompeng}', "");
    Expect(1, 69887, '\P{^Is_Blk=__SORA_sompeng}', "");
    Expect(0, 69888, '\p{Is_Blk=__SORA_sompeng}', "");
    Expect(1, 69888, '\p{^Is_Blk=__SORA_sompeng}', "");
    Expect(1, 69888, '\P{Is_Blk=__SORA_sompeng}', "");
    Expect(0, 69888, '\P{^Is_Blk=__SORA_sompeng}', "");
    Error('\p{Block:	:=		SOYOMBO}');
    Error('\P{Block:	:=		SOYOMBO}');
    Expect(1, 72367, '\p{Block=:\ASoyombo\z:}', "");;
    Expect(0, 72368, '\p{Block=:\ASoyombo\z:}', "");;
    Expect(1, 72367, '\p{Block:	soyombo}', "");
    Expect(0, 72367, '\p{^Block:	soyombo}', "");
    Expect(0, 72367, '\P{Block:	soyombo}', "");
    Expect(1, 72367, '\P{^Block:	soyombo}', "");
    Expect(0, 72368, '\p{Block:	soyombo}', "");
    Expect(1, 72368, '\p{^Block:	soyombo}', "");
    Expect(1, 72368, '\P{Block:	soyombo}', "");
    Expect(0, 72368, '\P{^Block:	soyombo}', "");
    Expect(1, 72367, '\p{Block=:\Asoyombo\z:}', "");;
    Expect(0, 72368, '\p{Block=:\Asoyombo\z:}', "");;
    Expect(1, 72367, '\p{Block=_soyombo}', "");
    Expect(0, 72367, '\p{^Block=_soyombo}', "");
    Expect(0, 72367, '\P{Block=_soyombo}', "");
    Expect(1, 72367, '\P{^Block=_soyombo}', "");
    Expect(0, 72368, '\p{Block=_soyombo}', "");
    Expect(1, 72368, '\p{^Block=_soyombo}', "");
    Expect(1, 72368, '\P{Block=_soyombo}', "");
    Expect(0, 72368, '\P{^Block=_soyombo}', "");
    Error('\p{Blk=:=_	Soyombo}');
    Error('\P{Blk=:=_	Soyombo}');
    Expect(1, 72367, '\p{Blk=:\ASoyombo\z:}', "");;
    Expect(0, 72368, '\p{Blk=:\ASoyombo\z:}', "");;
    Expect(1, 72367, '\p{Blk=soyombo}', "");
    Expect(0, 72367, '\p{^Blk=soyombo}', "");
    Expect(0, 72367, '\P{Blk=soyombo}', "");
    Expect(1, 72367, '\P{^Blk=soyombo}', "");
    Expect(0, 72368, '\p{Blk=soyombo}', "");
    Expect(1, 72368, '\p{^Blk=soyombo}', "");
    Expect(1, 72368, '\P{Blk=soyombo}', "");
    Expect(0, 72368, '\P{^Blk=soyombo}', "");
    Expect(1, 72367, '\p{Blk=:\Asoyombo\z:}', "");;
    Expect(0, 72368, '\p{Blk=:\Asoyombo\z:}', "");;
    Expect(1, 72367, '\p{Blk=		SOYOMBO}', "");
    Expect(0, 72367, '\p{^Blk=		SOYOMBO}', "");
    Expect(0, 72367, '\P{Blk=		SOYOMBO}', "");
    Expect(1, 72367, '\P{^Blk=		SOYOMBO}', "");
    Expect(0, 72368, '\p{Blk=		SOYOMBO}', "");
    Expect(1, 72368, '\p{^Blk=		SOYOMBO}', "");
    Expect(1, 72368, '\P{Blk=		SOYOMBO}', "");
    Expect(0, 72368, '\P{^Blk=		SOYOMBO}', "");
    Error('\p{Is_Block= :=soyombo}');
    Error('\P{Is_Block= :=soyombo}');
    Expect(1, 72367, '\p{Is_Block=soyombo}', "");
    Expect(0, 72367, '\p{^Is_Block=soyombo}', "");
    Expect(0, 72367, '\P{Is_Block=soyombo}', "");
    Expect(1, 72367, '\P{^Is_Block=soyombo}', "");
    Expect(0, 72368, '\p{Is_Block=soyombo}', "");
    Expect(1, 72368, '\p{^Is_Block=soyombo}', "");
    Expect(1, 72368, '\P{Is_Block=soyombo}', "");
    Expect(0, 72368, '\P{^Is_Block=soyombo}', "");
    Expect(1, 72367, '\p{Is_Block=	soyombo}', "");
    Expect(0, 72367, '\p{^Is_Block=	soyombo}', "");
    Expect(0, 72367, '\P{Is_Block=	soyombo}', "");
    Expect(1, 72367, '\P{^Is_Block=	soyombo}', "");
    Expect(0, 72368, '\p{Is_Block=	soyombo}', "");
    Expect(1, 72368, '\p{^Is_Block=	soyombo}', "");
    Expect(1, 72368, '\P{Is_Block=	soyombo}', "");
    Expect(0, 72368, '\P{^Is_Block=	soyombo}', "");
    Error('\p{Is_Blk=--Soyombo:=}');
    Error('\P{Is_Blk=--Soyombo:=}');
    Expect(1, 72367, '\p{Is_Blk=soyombo}', "");
    Expect(0, 72367, '\p{^Is_Blk=soyombo}', "");
    Expect(0, 72367, '\P{Is_Blk=soyombo}', "");
    Expect(1, 72367, '\P{^Is_Blk=soyombo}', "");
    Expect(0, 72368, '\p{Is_Blk=soyombo}', "");
    Expect(1, 72368, '\p{^Is_Blk=soyombo}', "");
    Expect(1, 72368, '\P{Is_Blk=soyombo}', "");
    Expect(0, 72368, '\P{^Is_Blk=soyombo}', "");
    Expect(1, 72367, '\p{Is_Blk=_-Soyombo}', "");
    Expect(0, 72367, '\p{^Is_Blk=_-Soyombo}', "");
    Expect(0, 72367, '\P{Is_Blk=_-Soyombo}', "");
    Expect(1, 72367, '\P{^Is_Blk=_-Soyombo}', "");
    Expect(0, 72368, '\p{Is_Blk=_-Soyombo}', "");
    Expect(1, 72368, '\p{^Is_Blk=_-Soyombo}', "");
    Expect(1, 72368, '\P{Is_Blk=_-Soyombo}', "");
    Expect(0, 72368, '\P{^Is_Blk=_-Soyombo}', "");
    Error('\p{Block=-/a/Specials}');
    Error('\P{Block=-/a/Specials}');
    Expect(1, 65520, '\p{Block=:\ASpecials\z:}', "");;
    Expect(0, 65536, '\p{Block=:\ASpecials\z:}', "");;
    Expect(1, 65520, '\p{Block=specials}', "");
    Expect(0, 65520, '\p{^Block=specials}', "");
    Expect(0, 65520, '\P{Block=specials}', "");
    Expect(1, 65520, '\P{^Block=specials}', "");
    Expect(0, 65536, '\p{Block=specials}', "");
    Expect(1, 65536, '\p{^Block=specials}', "");
    Expect(1, 65536, '\P{Block=specials}', "");
    Expect(0, 65536, '\P{^Block=specials}', "");
    Expect(1, 65520, '\p{Block=:\Aspecials\z:}', "");;
    Expect(0, 65536, '\p{Block=:\Aspecials\z:}', "");;
    Expect(1, 65520, '\p{Block=__SPECIALS}', "");
    Expect(0, 65520, '\p{^Block=__SPECIALS}', "");
    Expect(0, 65520, '\P{Block=__SPECIALS}', "");
    Expect(1, 65520, '\P{^Block=__SPECIALS}', "");
    Expect(0, 65536, '\p{Block=__SPECIALS}', "");
    Expect(1, 65536, '\p{^Block=__SPECIALS}', "");
    Expect(1, 65536, '\P{Block=__SPECIALS}', "");
    Expect(0, 65536, '\P{^Block=__SPECIALS}', "");
    Error('\p{Blk=--specials/a/}');
    Error('\P{Blk=--specials/a/}');
    Expect(1, 65520, '\p{Blk=:\ASpecials\z:}', "");;
    Expect(0, 65536, '\p{Blk=:\ASpecials\z:}', "");;
    Expect(1, 65520, '\p{Blk=specials}', "");
    Expect(0, 65520, '\p{^Blk=specials}', "");
    Expect(0, 65520, '\P{Blk=specials}', "");
    Expect(1, 65520, '\P{^Blk=specials}', "");
    Expect(0, 65536, '\p{Blk=specials}', "");
    Expect(1, 65536, '\p{^Blk=specials}', "");
    Expect(1, 65536, '\P{Blk=specials}', "");
    Expect(0, 65536, '\P{^Blk=specials}', "");
    Expect(1, 65520, '\p{Blk=:\Aspecials\z:}', "");;
    Expect(0, 65536, '\p{Blk=:\Aspecials\z:}', "");;
    Expect(1, 65520, '\p{Blk=-SPECIALS}', "");
    Expect(0, 65520, '\p{^Blk=-SPECIALS}', "");
    Expect(0, 65520, '\P{Blk=-SPECIALS}', "");
    Expect(1, 65520, '\P{^Blk=-SPECIALS}', "");
    Expect(0, 65536, '\p{Blk=-SPECIALS}', "");
    Expect(1, 65536, '\p{^Blk=-SPECIALS}', "");
    Expect(1, 65536, '\P{Blk=-SPECIALS}', "");
    Expect(0, 65536, '\P{^Blk=-SPECIALS}', "");
    Error('\p{Is_Block=/a/-	specials}');
    Error('\P{Is_Block=/a/-	specials}');
    Expect(1, 65520, '\p{Is_Block=specials}', "");
    Expect(0, 65520, '\p{^Is_Block=specials}', "");
    Expect(0, 65520, '\P{Is_Block=specials}', "");
    Expect(1, 65520, '\P{^Is_Block=specials}', "");
    Expect(0, 65536, '\p{Is_Block=specials}', "");
    Expect(1, 65536, '\p{^Is_Block=specials}', "");
    Expect(1, 65536, '\P{Is_Block=specials}', "");
    Expect(0, 65536, '\P{^Is_Block=specials}', "");
    Expect(1, 65520, '\p{Is_Block=	SPECIALS}', "");
    Expect(0, 65520, '\p{^Is_Block=	SPECIALS}', "");
    Expect(0, 65520, '\P{Is_Block=	SPECIALS}', "");
    Expect(1, 65520, '\P{^Is_Block=	SPECIALS}', "");
    Expect(0, 65536, '\p{Is_Block=	SPECIALS}', "");
    Expect(1, 65536, '\p{^Is_Block=	SPECIALS}', "");
    Expect(1, 65536, '\P{Is_Block=	SPECIALS}', "");
    Expect(0, 65536, '\P{^Is_Block=	SPECIALS}', "");
    Error('\p{Is_Blk=/a/- SPECIALS}');
    Error('\P{Is_Blk=/a/- SPECIALS}');
    Expect(1, 65520, '\p{Is_Blk=specials}', "");
    Expect(0, 65520, '\p{^Is_Blk=specials}', "");
    Expect(0, 65520, '\P{Is_Blk=specials}', "");
    Expect(1, 65520, '\P{^Is_Blk=specials}', "");
    Expect(0, 65536, '\p{Is_Blk=specials}', "");
    Expect(1, 65536, '\p{^Is_Blk=specials}', "");
    Expect(1, 65536, '\P{Is_Blk=specials}', "");
    Expect(0, 65536, '\P{^Is_Blk=specials}', "");
    Expect(1, 65520, '\p{Is_Blk=	 specials}', "");
    Expect(0, 65520, '\p{^Is_Blk=	 specials}', "");
    Expect(0, 65520, '\P{Is_Blk=	 specials}', "");
    Expect(1, 65520, '\P{^Is_Blk=	 specials}', "");
    Expect(0, 65536, '\p{Is_Blk=	 specials}', "");
    Expect(1, 65536, '\p{^Is_Blk=	 specials}', "");
    Expect(1, 65536, '\P{Is_Blk=	 specials}', "");
    Expect(0, 65536, '\P{^Is_Blk=	 specials}', "");
    Error('\p{Block=:= Sundanese}');
    Error('\P{Block=:= Sundanese}');
    Expect(1, 7103, '\p{Block=:\ASundanese\z:}', "");;
    Expect(0, 7104, '\p{Block=:\ASundanese\z:}', "");;
    Expect(1, 7103, '\p{Block=sundanese}', "");
    Expect(0, 7103, '\p{^Block=sundanese}', "");
    Expect(0, 7103, '\P{Block=sundanese}', "");
    Expect(1, 7103, '\P{^Block=sundanese}', "");
    Expect(0, 7104, '\p{Block=sundanese}', "");
    Expect(1, 7104, '\p{^Block=sundanese}', "");
    Expect(1, 7104, '\P{Block=sundanese}', "");
    Expect(0, 7104, '\P{^Block=sundanese}', "");
    Expect(1, 7103, '\p{Block=:\Asundanese\z:}', "");;
    Expect(0, 7104, '\p{Block=:\Asundanese\z:}', "");;
    Expect(1, 7103, '\p{Block=_sundanese}', "");
    Expect(0, 7103, '\p{^Block=_sundanese}', "");
    Expect(0, 7103, '\P{Block=_sundanese}', "");
    Expect(1, 7103, '\P{^Block=_sundanese}', "");
    Expect(0, 7104, '\p{Block=_sundanese}', "");
    Expect(1, 7104, '\p{^Block=_sundanese}', "");
    Expect(1, 7104, '\P{Block=_sundanese}', "");
    Expect(0, 7104, '\P{^Block=_sundanese}', "");
    Error('\p{Blk=_/a/Sundanese}');
    Error('\P{Blk=_/a/Sundanese}');
    Expect(1, 7103, '\p{Blk=:\ASundanese\z:}', "");;
    Expect(0, 7104, '\p{Blk=:\ASundanese\z:}', "");;
    Expect(1, 7103, '\p{Blk=sundanese}', "");
    Expect(0, 7103, '\p{^Blk=sundanese}', "");
    Expect(0, 7103, '\P{Blk=sundanese}', "");
    Expect(1, 7103, '\P{^Blk=sundanese}', "");
    Expect(0, 7104, '\p{Blk=sundanese}', "");
    Expect(1, 7104, '\p{^Blk=sundanese}', "");
    Expect(1, 7104, '\P{Blk=sundanese}', "");
    Expect(0, 7104, '\P{^Blk=sundanese}', "");
    Expect(1, 7103, '\p{Blk=:\Asundanese\z:}', "");;
    Expect(0, 7104, '\p{Blk=:\Asundanese\z:}', "");;
    Expect(1, 7103, '\p{Blk=_Sundanese}', "");
    Expect(0, 7103, '\p{^Blk=_Sundanese}', "");
    Expect(0, 7103, '\P{Blk=_Sundanese}', "");
    Expect(1, 7103, '\P{^Blk=_Sundanese}', "");
    Expect(0, 7104, '\p{Blk=_Sundanese}', "");
    Expect(1, 7104, '\p{^Blk=_Sundanese}', "");
    Expect(1, 7104, '\P{Blk=_Sundanese}', "");
    Expect(0, 7104, '\P{^Blk=_Sundanese}', "");
    Error('\p{Is_Block=	SUNDANESE/a/}');
    Error('\P{Is_Block=	SUNDANESE/a/}');
    Expect(1, 7103, '\p{Is_Block=sundanese}', "");
    Expect(0, 7103, '\p{^Is_Block=sundanese}', "");
    Expect(0, 7103, '\P{Is_Block=sundanese}', "");
    Expect(1, 7103, '\P{^Is_Block=sundanese}', "");
    Expect(0, 7104, '\p{Is_Block=sundanese}', "");
    Expect(1, 7104, '\p{^Is_Block=sundanese}', "");
    Expect(1, 7104, '\P{Is_Block=sundanese}', "");
    Expect(0, 7104, '\P{^Is_Block=sundanese}', "");
    Expect(1, 7103, '\p{Is_Block=-_Sundanese}', "");
    Expect(0, 7103, '\p{^Is_Block=-_Sundanese}', "");
    Expect(0, 7103, '\P{Is_Block=-_Sundanese}', "");
    Expect(1, 7103, '\P{^Is_Block=-_Sundanese}', "");
    Expect(0, 7104, '\p{Is_Block=-_Sundanese}', "");
    Expect(1, 7104, '\p{^Is_Block=-_Sundanese}', "");
    Expect(1, 7104, '\P{Is_Block=-_Sundanese}', "");
    Expect(0, 7104, '\P{^Is_Block=-_Sundanese}', "");
    Error('\p{Is_Blk=_	Sundanese:=}');
    Error('\P{Is_Blk=_	Sundanese:=}');
    Expect(1, 7103, '\p{Is_Blk=sundanese}', "");
    Expect(0, 7103, '\p{^Is_Blk=sundanese}', "");
    Expect(0, 7103, '\P{Is_Blk=sundanese}', "");
    Expect(1, 7103, '\P{^Is_Blk=sundanese}', "");
    Expect(0, 7104, '\p{Is_Blk=sundanese}', "");
    Expect(1, 7104, '\p{^Is_Blk=sundanese}', "");
    Expect(1, 7104, '\P{Is_Blk=sundanese}', "");
    Expect(0, 7104, '\P{^Is_Blk=sundanese}', "");
    Expect(1, 7103, '\p{Is_Blk=	_Sundanese}', "");
    Expect(0, 7103, '\p{^Is_Blk=	_Sundanese}', "");
    Expect(0, 7103, '\P{Is_Blk=	_Sundanese}', "");
    Expect(1, 7103, '\P{^Is_Blk=	_Sundanese}', "");
    Expect(0, 7104, '\p{Is_Blk=	_Sundanese}', "");
    Expect(1, 7104, '\p{^Is_Blk=	_Sundanese}', "");
    Expect(1, 7104, '\P{Is_Blk=	_Sundanese}', "");
    Expect(0, 7104, '\P{^Is_Blk=	_Sundanese}', "");
    Error('\p{Block=:=SUNDANESE_supplement}');
    Error('\P{Block=:=SUNDANESE_supplement}');
    Expect(1, 7375, '\p{Block=:\ASundanese_Supplement\z:}', "");;
    Expect(0, 7376, '\p{Block=:\ASundanese_Supplement\z:}', "");;
    Expect(1, 7375, '\p{Block=sundanesesupplement}', "");
    Expect(0, 7375, '\p{^Block=sundanesesupplement}', "");
    Expect(0, 7375, '\P{Block=sundanesesupplement}', "");
    Expect(1, 7375, '\P{^Block=sundanesesupplement}', "");
    Expect(0, 7376, '\p{Block=sundanesesupplement}', "");
    Expect(1, 7376, '\p{^Block=sundanesesupplement}', "");
    Expect(1, 7376, '\P{Block=sundanesesupplement}', "");
    Expect(0, 7376, '\P{^Block=sundanesesupplement}', "");
    Expect(1, 7375, '\p{Block=:\Asundanesesupplement\z:}', "");;
    Expect(0, 7376, '\p{Block=:\Asundanesesupplement\z:}', "");;
    Expect(1, 7375, '\p{Block=	 sundanese_Supplement}', "");
    Expect(0, 7375, '\p{^Block=	 sundanese_Supplement}', "");
    Expect(0, 7375, '\P{Block=	 sundanese_Supplement}', "");
    Expect(1, 7375, '\P{^Block=	 sundanese_Supplement}', "");
    Expect(0, 7376, '\p{Block=	 sundanese_Supplement}', "");
    Expect(1, 7376, '\p{^Block=	 sundanese_Supplement}', "");
    Expect(1, 7376, '\P{Block=	 sundanese_Supplement}', "");
    Expect(0, 7376, '\P{^Block=	 sundanese_Supplement}', "");
    Error('\p{Blk=/a/	Sundanese_Sup}');
    Error('\P{Blk=/a/	Sundanese_Sup}');
    Expect(1, 7375, '\p{Blk=:\ASundanese_Sup\z:}', "");;
    Expect(0, 7376, '\p{Blk=:\ASundanese_Sup\z:}', "");;
    Expect(1, 7375, '\p{Blk=sundanesesup}', "");
    Expect(0, 7375, '\p{^Blk=sundanesesup}', "");
    Expect(0, 7375, '\P{Blk=sundanesesup}', "");
    Expect(1, 7375, '\P{^Blk=sundanesesup}', "");
    Expect(0, 7376, '\p{Blk=sundanesesup}', "");
    Expect(1, 7376, '\p{^Blk=sundanesesup}', "");
    Expect(1, 7376, '\P{Blk=sundanesesup}', "");
    Expect(0, 7376, '\P{^Blk=sundanesesup}', "");
    Expect(1, 7375, '\p{Blk=:\Asundanesesup\z:}', "");;
    Expect(0, 7376, '\p{Blk=:\Asundanesesup\z:}', "");;
    Expect(1, 7375, '\p{Blk=__sundanese_Sup}', "");
    Expect(0, 7375, '\p{^Blk=__sundanese_Sup}', "");
    Expect(0, 7375, '\P{Blk=__sundanese_Sup}', "");
    Expect(1, 7375, '\P{^Blk=__sundanese_Sup}', "");
    Expect(0, 7376, '\p{Blk=__sundanese_Sup}', "");
    Expect(1, 7376, '\p{^Blk=__sundanese_Sup}', "");
    Expect(1, 7376, '\P{Blk=__sundanese_Sup}', "");
    Expect(0, 7376, '\P{^Blk=__sundanese_Sup}', "");
    Error('\p{Is_Block=	:=Sundanese_supplement}');
    Error('\P{Is_Block=	:=Sundanese_supplement}');
    Expect(1, 7375, '\p{Is_Block=sundanesesupplement}', "");
    Expect(0, 7375, '\p{^Is_Block=sundanesesupplement}', "");
    Expect(0, 7375, '\P{Is_Block=sundanesesupplement}', "");
    Expect(1, 7375, '\P{^Is_Block=sundanesesupplement}', "");
    Expect(0, 7376, '\p{Is_Block=sundanesesupplement}', "");
    Expect(1, 7376, '\p{^Is_Block=sundanesesupplement}', "");
    Expect(1, 7376, '\P{Is_Block=sundanesesupplement}', "");
    Expect(0, 7376, '\P{^Is_Block=sundanesesupplement}', "");
    Expect(1, 7375, '\p{Is_Block=	SUNDANESE_Supplement}', "");
    Expect(0, 7375, '\p{^Is_Block=	SUNDANESE_Supplement}', "");
    Expect(0, 7375, '\P{Is_Block=	SUNDANESE_Supplement}', "");
    Expect(1, 7375, '\P{^Is_Block=	SUNDANESE_Supplement}', "");
    Expect(0, 7376, '\p{Is_Block=	SUNDANESE_Supplement}', "");
    Expect(1, 7376, '\p{^Is_Block=	SUNDANESE_Supplement}', "");
    Expect(1, 7376, '\P{Is_Block=	SUNDANESE_Supplement}', "");
    Expect(0, 7376, '\P{^Is_Block=	SUNDANESE_Supplement}', "");
    Error('\p{Is_Blk= Sundanese_Sup/a/}');
    Error('\P{Is_Blk= Sundanese_Sup/a/}');
    Expect(1, 7375, '\p{Is_Blk=sundanesesup}', "");
    Expect(0, 7375, '\p{^Is_Blk=sundanesesup}', "");
    Expect(0, 7375, '\P{Is_Blk=sundanesesup}', "");
    Expect(1, 7375, '\P{^Is_Blk=sundanesesup}', "");
    Expect(0, 7376, '\p{Is_Blk=sundanesesup}', "");
    Expect(1, 7376, '\p{^Is_Blk=sundanesesup}', "");
    Expect(1, 7376, '\P{Is_Blk=sundanesesup}', "");
    Expect(0, 7376, '\P{^Is_Blk=sundanesesup}', "");
    Expect(1, 7375, '\p{Is_Blk=_ sundanese_sup}', "");
    Expect(0, 7375, '\p{^Is_Blk=_ sundanese_sup}', "");
    Expect(0, 7375, '\P{Is_Blk=_ sundanese_sup}', "");
    Expect(1, 7375, '\P{^Is_Blk=_ sundanese_sup}', "");
    Expect(0, 7376, '\p{Is_Blk=_ sundanese_sup}', "");
    Expect(1, 7376, '\p{^Is_Blk=_ sundanese_sup}', "");
    Expect(1, 7376, '\P{Is_Blk=_ sundanese_sup}', "");
    Expect(0, 7376, '\P{^Is_Blk=_ sundanese_sup}', "");
    Error('\p{Block:	/a/ 	SUPPLEMENTAL_ARROWS_A}');
    Error('\P{Block:	/a/ 	SUPPLEMENTAL_ARROWS_A}');
    Expect(1, 10239, '\p{Block=:\ASupplemental_Arrows_A\z:}', "");;
    Expect(0, 10240, '\p{Block=:\ASupplemental_Arrows_A\z:}', "");;
    Expect(1, 10239, '\p{Block=supplementalarrowsa}', "");
    Expect(0, 10239, '\p{^Block=supplementalarrowsa}', "");
    Expect(0, 10239, '\P{Block=supplementalarrowsa}', "");
    Expect(1, 10239, '\P{^Block=supplementalarrowsa}', "");
    Expect(0, 10240, '\p{Block=supplementalarrowsa}', "");
    Expect(1, 10240, '\p{^Block=supplementalarrowsa}', "");
    Expect(1, 10240, '\P{Block=supplementalarrowsa}', "");
    Expect(0, 10240, '\P{^Block=supplementalarrowsa}', "");
    Expect(1, 10239, '\p{Block=:\Asupplementalarrowsa\z:}', "");;
    Expect(0, 10240, '\p{Block=:\Asupplementalarrowsa\z:}', "");;
    Expect(1, 10239, '\p{Block=_SUPPLEMENTAL_ARROWS_a}', "");
    Expect(0, 10239, '\p{^Block=_SUPPLEMENTAL_ARROWS_a}', "");
    Expect(0, 10239, '\P{Block=_SUPPLEMENTAL_ARROWS_a}', "");
    Expect(1, 10239, '\P{^Block=_SUPPLEMENTAL_ARROWS_a}', "");
    Expect(0, 10240, '\p{Block=_SUPPLEMENTAL_ARROWS_a}', "");
    Expect(1, 10240, '\p{^Block=_SUPPLEMENTAL_ARROWS_a}', "");
    Expect(1, 10240, '\P{Block=_SUPPLEMENTAL_ARROWS_a}', "");
    Expect(0, 10240, '\P{^Block=_SUPPLEMENTAL_ARROWS_a}', "");
    Error('\p{Blk: :=-	Sup_Arrows_A}');
    Error('\P{Blk: :=-	Sup_Arrows_A}');
    Expect(1, 10239, '\p{Blk=:\ASup_Arrows_A\z:}', "");;
    Expect(0, 10240, '\p{Blk=:\ASup_Arrows_A\z:}', "");;
    Expect(1, 10239, '\p{Blk:suparrowsa}', "");
    Expect(0, 10239, '\p{^Blk:suparrowsa}', "");
    Expect(0, 10239, '\P{Blk:suparrowsa}', "");
    Expect(1, 10239, '\P{^Blk:suparrowsa}', "");
    Expect(0, 10240, '\p{Blk:suparrowsa}', "");
    Expect(1, 10240, '\p{^Blk:suparrowsa}', "");
    Expect(1, 10240, '\P{Blk:suparrowsa}', "");
    Expect(0, 10240, '\P{^Blk:suparrowsa}', "");
    Expect(1, 10239, '\p{Blk=:\Asuparrowsa\z:}', "");;
    Expect(0, 10240, '\p{Blk=:\Asuparrowsa\z:}', "");;
    Expect(1, 10239, '\p{Blk= 	sup_ARROWS_A}', "");
    Expect(0, 10239, '\p{^Blk= 	sup_ARROWS_A}', "");
    Expect(0, 10239, '\P{Blk= 	sup_ARROWS_A}', "");
    Expect(1, 10239, '\P{^Blk= 	sup_ARROWS_A}', "");
    Expect(0, 10240, '\p{Blk= 	sup_ARROWS_A}', "");
    Expect(1, 10240, '\p{^Blk= 	sup_ARROWS_A}', "");
    Expect(1, 10240, '\P{Blk= 	sup_ARROWS_A}', "");
    Expect(0, 10240, '\P{^Blk= 	sup_ARROWS_A}', "");
    Error('\p{Is_Block=:=--SUPPLEMENTAL_ARROWS_A}');
    Error('\P{Is_Block=:=--SUPPLEMENTAL_ARROWS_A}');
    Expect(1, 10239, '\p{Is_Block=supplementalarrowsa}', "");
    Expect(0, 10239, '\p{^Is_Block=supplementalarrowsa}', "");
    Expect(0, 10239, '\P{Is_Block=supplementalarrowsa}', "");
    Expect(1, 10239, '\P{^Is_Block=supplementalarrowsa}', "");
    Expect(0, 10240, '\p{Is_Block=supplementalarrowsa}', "");
    Expect(1, 10240, '\p{^Is_Block=supplementalarrowsa}', "");
    Expect(1, 10240, '\P{Is_Block=supplementalarrowsa}', "");
    Expect(0, 10240, '\P{^Is_Block=supplementalarrowsa}', "");
    Expect(1, 10239, '\p{Is_Block: _Supplemental_arrows_a}', "");
    Expect(0, 10239, '\p{^Is_Block: _Supplemental_arrows_a}', "");
    Expect(0, 10239, '\P{Is_Block: _Supplemental_arrows_a}', "");
    Expect(1, 10239, '\P{^Is_Block: _Supplemental_arrows_a}', "");
    Expect(0, 10240, '\p{Is_Block: _Supplemental_arrows_a}', "");
    Expect(1, 10240, '\p{^Is_Block: _Supplemental_arrows_a}', "");
    Expect(1, 10240, '\P{Is_Block: _Supplemental_arrows_a}', "");
    Expect(0, 10240, '\P{^Is_Block: _Supplemental_arrows_a}', "");
    Error('\p{Is_Blk=-	SUP_ARROWS_A/a/}');
    Error('\P{Is_Blk=-	SUP_ARROWS_A/a/}');
    Expect(1, 10239, '\p{Is_Blk: suparrowsa}', "");
    Expect(0, 10239, '\p{^Is_Blk: suparrowsa}', "");
    Expect(0, 10239, '\P{Is_Blk: suparrowsa}', "");
    Expect(1, 10239, '\P{^Is_Blk: suparrowsa}', "");
    Expect(0, 10240, '\p{Is_Blk: suparrowsa}', "");
    Expect(1, 10240, '\p{^Is_Blk: suparrowsa}', "");
    Expect(1, 10240, '\P{Is_Blk: suparrowsa}', "");
    Expect(0, 10240, '\P{^Is_Blk: suparrowsa}', "");
    Expect(1, 10239, '\p{Is_Blk:    sup_ARROWS_A}', "");
    Expect(0, 10239, '\p{^Is_Blk:    sup_ARROWS_A}', "");
    Expect(0, 10239, '\P{Is_Blk:    sup_ARROWS_A}', "");
    Expect(1, 10239, '\P{^Is_Blk:    sup_ARROWS_A}', "");
    Expect(0, 10240, '\p{Is_Blk:    sup_ARROWS_A}', "");
    Expect(1, 10240, '\p{^Is_Blk:    sup_ARROWS_A}', "");
    Expect(1, 10240, '\P{Is_Blk:    sup_ARROWS_A}', "");
    Expect(0, 10240, '\P{^Is_Blk:    sup_ARROWS_A}', "");
    Error('\p{Block=/a/supplemental_Arrows_B}');
    Error('\P{Block=/a/supplemental_Arrows_B}');
    Expect(1, 10623, '\p{Block=:\ASupplemental_Arrows_B\z:}', "");;
    Expect(0, 10624, '\p{Block=:\ASupplemental_Arrows_B\z:}', "");;
    Expect(1, 10623, '\p{Block=supplementalarrowsb}', "");
    Expect(0, 10623, '\p{^Block=supplementalarrowsb}', "");
    Expect(0, 10623, '\P{Block=supplementalarrowsb}', "");
    Expect(1, 10623, '\P{^Block=supplementalarrowsb}', "");
    Expect(0, 10624, '\p{Block=supplementalarrowsb}', "");
    Expect(1, 10624, '\p{^Block=supplementalarrowsb}', "");
    Expect(1, 10624, '\P{Block=supplementalarrowsb}', "");
    Expect(0, 10624, '\P{^Block=supplementalarrowsb}', "");
    Expect(1, 10623, '\p{Block=:\Asupplementalarrowsb\z:}', "");;
    Expect(0, 10624, '\p{Block=:\Asupplementalarrowsb\z:}', "");;
    Expect(1, 10623, '\p{Block=_Supplemental_ARROWS_B}', "");
    Expect(0, 10623, '\p{^Block=_Supplemental_ARROWS_B}', "");
    Expect(0, 10623, '\P{Block=_Supplemental_ARROWS_B}', "");
    Expect(1, 10623, '\P{^Block=_Supplemental_ARROWS_B}', "");
    Expect(0, 10624, '\p{Block=_Supplemental_ARROWS_B}', "");
    Expect(1, 10624, '\p{^Block=_Supplemental_ARROWS_B}', "");
    Expect(1, 10624, '\P{Block=_Supplemental_ARROWS_B}', "");
    Expect(0, 10624, '\P{^Block=_Supplemental_ARROWS_B}', "");
    Error('\p{Blk=	-SUP_arrows_B/a/}');
    Error('\P{Blk=	-SUP_arrows_B/a/}');
    Expect(1, 10623, '\p{Blk=:\ASup_Arrows_B\z:}', "");;
    Expect(0, 10624, '\p{Blk=:\ASup_Arrows_B\z:}', "");;
    Expect(1, 10623, '\p{Blk=suparrowsb}', "");
    Expect(0, 10623, '\p{^Blk=suparrowsb}', "");
    Expect(0, 10623, '\P{Blk=suparrowsb}', "");
    Expect(1, 10623, '\P{^Blk=suparrowsb}', "");
    Expect(0, 10624, '\p{Blk=suparrowsb}', "");
    Expect(1, 10624, '\p{^Blk=suparrowsb}', "");
    Expect(1, 10624, '\P{Blk=suparrowsb}', "");
    Expect(0, 10624, '\P{^Blk=suparrowsb}', "");
    Expect(1, 10623, '\p{Blk=:\Asuparrowsb\z:}', "");;
    Expect(0, 10624, '\p{Blk=:\Asuparrowsb\z:}', "");;
    Expect(1, 10623, '\p{Blk: _sup_Arrows_B}', "");
    Expect(0, 10623, '\p{^Blk: _sup_Arrows_B}', "");
    Expect(0, 10623, '\P{Blk: _sup_Arrows_B}', "");
    Expect(1, 10623, '\P{^Blk: _sup_Arrows_B}', "");
    Expect(0, 10624, '\p{Blk: _sup_Arrows_B}', "");
    Expect(1, 10624, '\p{^Blk: _sup_Arrows_B}', "");
    Expect(1, 10624, '\P{Blk: _sup_Arrows_B}', "");
    Expect(0, 10624, '\P{^Blk: _sup_Arrows_B}', "");
    Error('\p{Is_Block=:= -Supplemental_Arrows_B}');
    Error('\P{Is_Block=:= -Supplemental_Arrows_B}');
    Expect(1, 10623, '\p{Is_Block=supplementalarrowsb}', "");
    Expect(0, 10623, '\p{^Is_Block=supplementalarrowsb}', "");
    Expect(0, 10623, '\P{Is_Block=supplementalarrowsb}', "");
    Expect(1, 10623, '\P{^Is_Block=supplementalarrowsb}', "");
    Expect(0, 10624, '\p{Is_Block=supplementalarrowsb}', "");
    Expect(1, 10624, '\p{^Is_Block=supplementalarrowsb}', "");
    Expect(1, 10624, '\P{Is_Block=supplementalarrowsb}', "");
    Expect(0, 10624, '\P{^Is_Block=supplementalarrowsb}', "");
    Expect(1, 10623, '\p{Is_Block= supplemental_ARROWS_B}', "");
    Expect(0, 10623, '\p{^Is_Block= supplemental_ARROWS_B}', "");
    Expect(0, 10623, '\P{Is_Block= supplemental_ARROWS_B}', "");
    Expect(1, 10623, '\P{^Is_Block= supplemental_ARROWS_B}', "");
    Expect(0, 10624, '\p{Is_Block= supplemental_ARROWS_B}', "");
    Expect(1, 10624, '\p{^Is_Block= supplemental_ARROWS_B}', "");
    Expect(1, 10624, '\P{Is_Block= supplemental_ARROWS_B}', "");
    Expect(0, 10624, '\P{^Is_Block= supplemental_ARROWS_B}', "");
    Error('\p{Is_Blk=/a/ 	Sup_arrows_B}');
    Error('\P{Is_Blk=/a/ 	Sup_arrows_B}');
    Expect(1, 10623, '\p{Is_Blk=suparrowsb}', "");
    Expect(0, 10623, '\p{^Is_Blk=suparrowsb}', "");
    Expect(0, 10623, '\P{Is_Blk=suparrowsb}', "");
    Expect(1, 10623, '\P{^Is_Blk=suparrowsb}', "");
    Expect(0, 10624, '\p{Is_Blk=suparrowsb}', "");
    Expect(1, 10624, '\p{^Is_Blk=suparrowsb}', "");
    Expect(1, 10624, '\P{Is_Blk=suparrowsb}', "");
    Expect(0, 10624, '\P{^Is_Blk=suparrowsb}', "");
    Expect(1, 10623, '\p{Is_Blk= SUP_Arrows_B}', "");
    Expect(0, 10623, '\p{^Is_Blk= SUP_Arrows_B}', "");
    Expect(0, 10623, '\P{Is_Blk= SUP_Arrows_B}', "");
    Expect(1, 10623, '\P{^Is_Blk= SUP_Arrows_B}', "");
    Expect(0, 10624, '\p{Is_Blk= SUP_Arrows_B}', "");
    Expect(1, 10624, '\p{^Is_Blk= SUP_Arrows_B}', "");
    Expect(1, 10624, '\P{Is_Blk= SUP_Arrows_B}', "");
    Expect(0, 10624, '\P{^Is_Blk= SUP_Arrows_B}', "");
    Error('\p{Block= /a/Supplemental_Arrows_C}');
    Error('\P{Block= /a/Supplemental_Arrows_C}');
    Expect(1, 129279, '\p{Block=:\ASupplemental_Arrows_C\z:}', "");;
    Expect(0, 129280, '\p{Block=:\ASupplemental_Arrows_C\z:}', "");;
    Expect(1, 129279, '\p{Block=supplementalarrowsc}', "");
    Expect(0, 129279, '\p{^Block=supplementalarrowsc}', "");
    Expect(0, 129279, '\P{Block=supplementalarrowsc}', "");
    Expect(1, 129279, '\P{^Block=supplementalarrowsc}', "");
    Expect(0, 129280, '\p{Block=supplementalarrowsc}', "");
    Expect(1, 129280, '\p{^Block=supplementalarrowsc}', "");
    Expect(1, 129280, '\P{Block=supplementalarrowsc}', "");
    Expect(0, 129280, '\P{^Block=supplementalarrowsc}', "");
    Expect(1, 129279, '\p{Block=:\Asupplementalarrowsc\z:}', "");;
    Expect(0, 129280, '\p{Block=:\Asupplementalarrowsc\z:}', "");;
    Expect(1, 129279, '\p{Block=_-SUPPLEMENTAL_ARROWS_C}', "");
    Expect(0, 129279, '\p{^Block=_-SUPPLEMENTAL_ARROWS_C}', "");
    Expect(0, 129279, '\P{Block=_-SUPPLEMENTAL_ARROWS_C}', "");
    Expect(1, 129279, '\P{^Block=_-SUPPLEMENTAL_ARROWS_C}', "");
    Expect(0, 129280, '\p{Block=_-SUPPLEMENTAL_ARROWS_C}', "");
    Expect(1, 129280, '\p{^Block=_-SUPPLEMENTAL_ARROWS_C}', "");
    Expect(1, 129280, '\P{Block=_-SUPPLEMENTAL_ARROWS_C}', "");
    Expect(0, 129280, '\P{^Block=_-SUPPLEMENTAL_ARROWS_C}', "");
    Error('\p{Blk= _SUP_Arrows_c/a/}');
    Error('\P{Blk= _SUP_Arrows_c/a/}');
    Expect(1, 129279, '\p{Blk=:\ASup_Arrows_C\z:}', "");;
    Expect(0, 129280, '\p{Blk=:\ASup_Arrows_C\z:}', "");;
    Expect(1, 129279, '\p{Blk=suparrowsc}', "");
    Expect(0, 129279, '\p{^Blk=suparrowsc}', "");
    Expect(0, 129279, '\P{Blk=suparrowsc}', "");
    Expect(1, 129279, '\P{^Blk=suparrowsc}', "");
    Expect(0, 129280, '\p{Blk=suparrowsc}', "");
    Expect(1, 129280, '\p{^Blk=suparrowsc}', "");
    Expect(1, 129280, '\P{Blk=suparrowsc}', "");
    Expect(0, 129280, '\P{^Blk=suparrowsc}', "");
    Expect(1, 129279, '\p{Blk=:\Asuparrowsc\z:}', "");;
    Expect(0, 129280, '\p{Blk=:\Asuparrowsc\z:}', "");;
    Expect(1, 129279, '\p{Blk=_-Sup_Arrows_C}', "");
    Expect(0, 129279, '\p{^Blk=_-Sup_Arrows_C}', "");
    Expect(0, 129279, '\P{Blk=_-Sup_Arrows_C}', "");
    Expect(1, 129279, '\P{^Blk=_-Sup_Arrows_C}', "");
    Expect(0, 129280, '\p{Blk=_-Sup_Arrows_C}', "");
    Expect(1, 129280, '\p{^Blk=_-Sup_Arrows_C}', "");
    Expect(1, 129280, '\P{Blk=_-Sup_Arrows_C}', "");
    Expect(0, 129280, '\P{^Blk=_-Sup_Arrows_C}', "");
    Error('\p{Is_Block=/a/		SUPPLEMENTAL_Arrows_c}');
    Error('\P{Is_Block=/a/		SUPPLEMENTAL_Arrows_c}');
    Expect(1, 129279, '\p{Is_Block=supplementalarrowsc}', "");
    Expect(0, 129279, '\p{^Is_Block=supplementalarrowsc}', "");
    Expect(0, 129279, '\P{Is_Block=supplementalarrowsc}', "");
    Expect(1, 129279, '\P{^Is_Block=supplementalarrowsc}', "");
    Expect(0, 129280, '\p{Is_Block=supplementalarrowsc}', "");
    Expect(1, 129280, '\p{^Is_Block=supplementalarrowsc}', "");
    Expect(1, 129280, '\P{Is_Block=supplementalarrowsc}', "");
    Expect(0, 129280, '\P{^Is_Block=supplementalarrowsc}', "");
    Expect(1, 129279, '\p{Is_Block=SUPPLEMENTAL_ARROWS_c}', "");
    Expect(0, 129279, '\p{^Is_Block=SUPPLEMENTAL_ARROWS_c}', "");
    Expect(0, 129279, '\P{Is_Block=SUPPLEMENTAL_ARROWS_c}', "");
    Expect(1, 129279, '\P{^Is_Block=SUPPLEMENTAL_ARROWS_c}', "");
    Expect(0, 129280, '\p{Is_Block=SUPPLEMENTAL_ARROWS_c}', "");
    Expect(1, 129280, '\p{^Is_Block=SUPPLEMENTAL_ARROWS_c}', "");
    Expect(1, 129280, '\P{Is_Block=SUPPLEMENTAL_ARROWS_c}', "");
    Expect(0, 129280, '\P{^Is_Block=SUPPLEMENTAL_ARROWS_c}', "");
    Error('\p{Is_Blk=-/a/Sup_ARROWS_C}');
    Error('\P{Is_Blk=-/a/Sup_ARROWS_C}');
    Expect(1, 129279, '\p{Is_Blk=suparrowsc}', "");
    Expect(0, 129279, '\p{^Is_Blk=suparrowsc}', "");
    Expect(0, 129279, '\P{Is_Blk=suparrowsc}', "");
    Expect(1, 129279, '\P{^Is_Blk=suparrowsc}', "");
    Expect(0, 129280, '\p{Is_Blk=suparrowsc}', "");
    Expect(1, 129280, '\p{^Is_Blk=suparrowsc}', "");
    Expect(1, 129280, '\P{Is_Blk=suparrowsc}', "");
    Expect(0, 129280, '\P{^Is_Blk=suparrowsc}', "");
    Expect(1, 129279, '\p{Is_Blk=	_SUP_Arrows_C}', "");
    Expect(0, 129279, '\p{^Is_Blk=	_SUP_Arrows_C}', "");
    Expect(0, 129279, '\P{Is_Blk=	_SUP_Arrows_C}', "");
    Expect(1, 129279, '\P{^Is_Blk=	_SUP_Arrows_C}', "");
    Expect(0, 129280, '\p{Is_Blk=	_SUP_Arrows_C}', "");
    Expect(1, 129280, '\p{^Is_Blk=	_SUP_Arrows_C}', "");
    Expect(1, 129280, '\P{Is_Blk=	_SUP_Arrows_C}', "");
    Expect(0, 129280, '\P{^Is_Blk=	_SUP_Arrows_C}', "");
    Error('\p{Block=/a/	-Supplemental_Mathematical_Operators}');
    Error('\P{Block=/a/	-Supplemental_Mathematical_Operators}');
    Expect(1, 11007, '\p{Block=:\ASupplemental_Mathematical_Operators\z:}', "");;
    Expect(0, 11008, '\p{Block=:\ASupplemental_Mathematical_Operators\z:}', "");;
    Expect(1, 11007, '\p{Block=supplementalmathematicaloperators}', "");
    Expect(0, 11007, '\p{^Block=supplementalmathematicaloperators}', "");
    Expect(0, 11007, '\P{Block=supplementalmathematicaloperators}', "");
    Expect(1, 11007, '\P{^Block=supplementalmathematicaloperators}', "");
    Expect(0, 11008, '\p{Block=supplementalmathematicaloperators}', "");
    Expect(1, 11008, '\p{^Block=supplementalmathematicaloperators}', "");
    Expect(1, 11008, '\P{Block=supplementalmathematicaloperators}', "");
    Expect(0, 11008, '\P{^Block=supplementalmathematicaloperators}', "");
    Expect(1, 11007, '\p{Block=:\Asupplementalmathematicaloperators\z:}', "");;
    Expect(0, 11008, '\p{Block=:\Asupplementalmathematicaloperators\z:}', "");;
    Expect(1, 11007, '\p{Block=_-SUPPLEMENTAL_mathematical_operators}', "");
    Expect(0, 11007, '\p{^Block=_-SUPPLEMENTAL_mathematical_operators}', "");
    Expect(0, 11007, '\P{Block=_-SUPPLEMENTAL_mathematical_operators}', "");
    Expect(1, 11007, '\P{^Block=_-SUPPLEMENTAL_mathematical_operators}', "");
    Expect(0, 11008, '\p{Block=_-SUPPLEMENTAL_mathematical_operators}', "");
    Expect(1, 11008, '\p{^Block=_-SUPPLEMENTAL_mathematical_operators}', "");
    Expect(1, 11008, '\P{Block=_-SUPPLEMENTAL_mathematical_operators}', "");
    Expect(0, 11008, '\P{^Block=_-SUPPLEMENTAL_mathematical_operators}', "");
    Error('\p{Blk=/a/ -Sup_MATH_operators}');
    Error('\P{Blk=/a/ -Sup_MATH_operators}');
    Expect(1, 11007, '\p{Blk=:\ASup_Math_Operators\z:}', "");;
    Expect(0, 11008, '\p{Blk=:\ASup_Math_Operators\z:}', "");;
    Expect(1, 11007, '\p{Blk=supmathoperators}', "");
    Expect(0, 11007, '\p{^Blk=supmathoperators}', "");
    Expect(0, 11007, '\P{Blk=supmathoperators}', "");
    Expect(1, 11007, '\P{^Blk=supmathoperators}', "");
    Expect(0, 11008, '\p{Blk=supmathoperators}', "");
    Expect(1, 11008, '\p{^Blk=supmathoperators}', "");
    Expect(1, 11008, '\P{Blk=supmathoperators}', "");
    Expect(0, 11008, '\P{^Blk=supmathoperators}', "");
    Expect(1, 11007, '\p{Blk=:\Asupmathoperators\z:}', "");;
    Expect(0, 11008, '\p{Blk=:\Asupmathoperators\z:}', "");;
    Expect(1, 11007, '\p{Blk= Sup_Math_Operators}', "");
    Expect(0, 11007, '\p{^Blk= Sup_Math_Operators}', "");
    Expect(0, 11007, '\P{Blk= Sup_Math_Operators}', "");
    Expect(1, 11007, '\P{^Blk= Sup_Math_Operators}', "");
    Expect(0, 11008, '\p{Blk= Sup_Math_Operators}', "");
    Expect(1, 11008, '\p{^Blk= Sup_Math_Operators}', "");
    Expect(1, 11008, '\P{Blk= Sup_Math_Operators}', "");
    Expect(0, 11008, '\P{^Blk= Sup_Math_Operators}', "");
    Error('\p{Is_Block=	:=Supplemental_MATHEMATICAL_operators}');
    Error('\P{Is_Block=	:=Supplemental_MATHEMATICAL_operators}');
    Expect(1, 11007, '\p{Is_Block=supplementalmathematicaloperators}', "");
    Expect(0, 11007, '\p{^Is_Block=supplementalmathematicaloperators}', "");
    Expect(0, 11007, '\P{Is_Block=supplementalmathematicaloperators}', "");
    Expect(1, 11007, '\P{^Is_Block=supplementalmathematicaloperators}', "");
    Expect(0, 11008, '\p{Is_Block=supplementalmathematicaloperators}', "");
    Expect(1, 11008, '\p{^Is_Block=supplementalmathematicaloperators}', "");
    Expect(1, 11008, '\P{Is_Block=supplementalmathematicaloperators}', "");
    Expect(0, 11008, '\P{^Is_Block=supplementalmathematicaloperators}', "");
    Expect(1, 11007, '\p{Is_Block:		_Supplemental_Mathematical_OPERATORS}', "");
    Expect(0, 11007, '\p{^Is_Block:		_Supplemental_Mathematical_OPERATORS}', "");
    Expect(0, 11007, '\P{Is_Block:		_Supplemental_Mathematical_OPERATORS}', "");
    Expect(1, 11007, '\P{^Is_Block:		_Supplemental_Mathematical_OPERATORS}', "");
    Expect(0, 11008, '\p{Is_Block:		_Supplemental_Mathematical_OPERATORS}', "");
    Expect(1, 11008, '\p{^Is_Block:		_Supplemental_Mathematical_OPERATORS}', "");
    Expect(1, 11008, '\P{Is_Block:		_Supplemental_Mathematical_OPERATORS}', "");
    Expect(0, 11008, '\P{^Is_Block:		_Supplemental_Mathematical_OPERATORS}', "");
    Error('\p{Is_Blk=_ SUP_Math_Operators/a/}');
    Error('\P{Is_Blk=_ SUP_Math_Operators/a/}');
    Expect(1, 11007, '\p{Is_Blk=supmathoperators}', "");
    Expect(0, 11007, '\p{^Is_Blk=supmathoperators}', "");
    Expect(0, 11007, '\P{Is_Blk=supmathoperators}', "");
    Expect(1, 11007, '\P{^Is_Blk=supmathoperators}', "");
    Expect(0, 11008, '\p{Is_Blk=supmathoperators}', "");
    Expect(1, 11008, '\p{^Is_Blk=supmathoperators}', "");
    Expect(1, 11008, '\P{Is_Blk=supmathoperators}', "");
    Expect(0, 11008, '\P{^Is_Blk=supmathoperators}', "");
    Expect(1, 11007, '\p{Is_Blk=__sup_Math_Operators}', "");
    Expect(0, 11007, '\p{^Is_Blk=__sup_Math_Operators}', "");
    Expect(0, 11007, '\P{Is_Blk=__sup_Math_Operators}', "");
    Expect(1, 11007, '\P{^Is_Blk=__sup_Math_Operators}', "");
    Expect(0, 11008, '\p{Is_Blk=__sup_Math_Operators}', "");
    Expect(1, 11008, '\p{^Is_Blk=__sup_Math_Operators}', "");
    Expect(1, 11008, '\P{Is_Blk=__sup_Math_Operators}', "");
    Expect(0, 11008, '\P{^Is_Blk=__sup_Math_Operators}', "");
    Error('\p{Block=_-Supplementary_Private_Use_Area_a:=}');
    Error('\P{Block=_-Supplementary_Private_Use_Area_a:=}');
    Expect(1, 983040, '\p{Block=:\ASupplementary_Private_Use_Area_A\z:}', "");;
    Expect(0, 1048576, '\p{Block=:\ASupplementary_Private_Use_Area_A\z:}', "");;
    Expect(1, 983040, '\p{Block=supplementaryprivateuseareaa}', "");
    Expect(0, 983040, '\p{^Block=supplementaryprivateuseareaa}', "");
    Expect(0, 983040, '\P{Block=supplementaryprivateuseareaa}', "");
    Expect(1, 983040, '\P{^Block=supplementaryprivateuseareaa}', "");
    Expect(0, 1048576, '\p{Block=supplementaryprivateuseareaa}', "");
    Expect(1, 1048576, '\p{^Block=supplementaryprivateuseareaa}', "");
    Expect(1, 1048576, '\P{Block=supplementaryprivateuseareaa}', "");
    Expect(0, 1048576, '\P{^Block=supplementaryprivateuseareaa}', "");
    Expect(1, 983040, '\p{Block=:\Asupplementaryprivateuseareaa\z:}', "");;
    Expect(0, 1048576, '\p{Block=:\Asupplementaryprivateuseareaa\z:}', "");;
    Expect(1, 983040, '\p{Block=-Supplementary_private_USE_AREA_A}', "");
    Expect(0, 983040, '\p{^Block=-Supplementary_private_USE_AREA_A}', "");
    Expect(0, 983040, '\P{Block=-Supplementary_private_USE_AREA_A}', "");
    Expect(1, 983040, '\P{^Block=-Supplementary_private_USE_AREA_A}', "");
    Expect(0, 1048576, '\p{Block=-Supplementary_private_USE_AREA_A}', "");
    Expect(1, 1048576, '\p{^Block=-Supplementary_private_USE_AREA_A}', "");
    Expect(1, 1048576, '\P{Block=-Supplementary_private_USE_AREA_A}', "");
    Expect(0, 1048576, '\P{^Block=-Supplementary_private_USE_AREA_A}', "");
    Error('\p{Blk=/a/	_Sup_PUA_A}');
    Error('\P{Blk=/a/	_Sup_PUA_A}');
    Expect(1, 983040, '\p{Blk=:\ASup_PUA_A\z:}', "");;
    Expect(0, 1048576, '\p{Blk=:\ASup_PUA_A\z:}', "");;
    Expect(1, 983040, '\p{Blk:	suppuaa}', "");
    Expect(0, 983040, '\p{^Blk:	suppuaa}', "");
    Expect(0, 983040, '\P{Blk:	suppuaa}', "");
    Expect(1, 983040, '\P{^Blk:	suppuaa}', "");
    Expect(0, 1048576, '\p{Blk:	suppuaa}', "");
    Expect(1, 1048576, '\p{^Blk:	suppuaa}', "");
    Expect(1, 1048576, '\P{Blk:	suppuaa}', "");
    Expect(0, 1048576, '\P{^Blk:	suppuaa}', "");
    Expect(1, 983040, '\p{Blk=:\Asuppuaa\z:}', "");;
    Expect(0, 1048576, '\p{Blk=:\Asuppuaa\z:}', "");;
    Expect(1, 983040, '\p{Blk=-Sup_pua_A}', "");
    Expect(0, 983040, '\p{^Blk=-Sup_pua_A}', "");
    Expect(0, 983040, '\P{Blk=-Sup_pua_A}', "");
    Expect(1, 983040, '\P{^Blk=-Sup_pua_A}', "");
    Expect(0, 1048576, '\p{Blk=-Sup_pua_A}', "");
    Expect(1, 1048576, '\p{^Blk=-Sup_pua_A}', "");
    Expect(1, 1048576, '\P{Blk=-Sup_pua_A}', "");
    Expect(0, 1048576, '\P{^Blk=-Sup_pua_A}', "");
    Error('\p{Is_Block= /a/SUPPLEMENTARY_private_Use_Area_a}');
    Error('\P{Is_Block= /a/SUPPLEMENTARY_private_Use_Area_a}');
    Expect(1, 983040, '\p{Is_Block=supplementaryprivateuseareaa}', "");
    Expect(0, 983040, '\p{^Is_Block=supplementaryprivateuseareaa}', "");
    Expect(0, 983040, '\P{Is_Block=supplementaryprivateuseareaa}', "");
    Expect(1, 983040, '\P{^Is_Block=supplementaryprivateuseareaa}', "");
    Expect(0, 1048576, '\p{Is_Block=supplementaryprivateuseareaa}', "");
    Expect(1, 1048576, '\p{^Is_Block=supplementaryprivateuseareaa}', "");
    Expect(1, 1048576, '\P{Is_Block=supplementaryprivateuseareaa}', "");
    Expect(0, 1048576, '\P{^Is_Block=supplementaryprivateuseareaa}', "");
    Expect(1, 983040, '\p{Is_Block= supplementary_private_Use_Area_a}', "");
    Expect(0, 983040, '\p{^Is_Block= supplementary_private_Use_Area_a}', "");
    Expect(0, 983040, '\P{Is_Block= supplementary_private_Use_Area_a}', "");
    Expect(1, 983040, '\P{^Is_Block= supplementary_private_Use_Area_a}', "");
    Expect(0, 1048576, '\p{Is_Block= supplementary_private_Use_Area_a}', "");
    Expect(1, 1048576, '\p{^Is_Block= supplementary_private_Use_Area_a}', "");
    Expect(1, 1048576, '\P{Is_Block= supplementary_private_Use_Area_a}', "");
    Expect(0, 1048576, '\P{^Is_Block= supplementary_private_Use_Area_a}', "");
    Error('\p{Is_Blk= :=Sup_PUA_A}');
    Error('\P{Is_Blk= :=Sup_PUA_A}');
    Expect(1, 983040, '\p{Is_Blk=suppuaa}', "");
    Expect(0, 983040, '\p{^Is_Blk=suppuaa}', "");
    Expect(0, 983040, '\P{Is_Blk=suppuaa}', "");
    Expect(1, 983040, '\P{^Is_Blk=suppuaa}', "");
    Expect(0, 1048576, '\p{Is_Blk=suppuaa}', "");
    Expect(1, 1048576, '\p{^Is_Blk=suppuaa}', "");
    Expect(1, 1048576, '\P{Is_Blk=suppuaa}', "");
    Expect(0, 1048576, '\P{^Is_Blk=suppuaa}', "");
    Expect(1, 983040, '\p{Is_Blk: _sup_pua_A}', "");
    Expect(0, 983040, '\p{^Is_Blk: _sup_pua_A}', "");
    Expect(0, 983040, '\P{Is_Blk: _sup_pua_A}', "");
    Expect(1, 983040, '\P{^Is_Blk: _sup_pua_A}', "");
    Expect(0, 1048576, '\p{Is_Blk: _sup_pua_A}', "");
    Expect(1, 1048576, '\p{^Is_Blk: _sup_pua_A}', "");
    Expect(1, 1048576, '\P{Is_Blk: _sup_pua_A}', "");
    Expect(0, 1048576, '\P{^Is_Blk: _sup_pua_A}', "");
    Error('\p{Block= /a/Supplementary_Private_Use_area_b}');
    Error('\P{Block= /a/Supplementary_Private_Use_area_b}');
    Expect(1, 1048576, '\p{Block=:\ASupplementary_Private_Use_Area_B\z:}', "");;
    Expect(0, 1, '\p{Block=:\ASupplementary_Private_Use_Area_B\z:}', "");;
    Expect(1, 1048576, '\p{Block=supplementaryprivateuseareab}', "");
    Expect(0, 1048576, '\p{^Block=supplementaryprivateuseareab}', "");
    Expect(0, 1048576, '\P{Block=supplementaryprivateuseareab}', "");
    Expect(1, 1048576, '\P{^Block=supplementaryprivateuseareab}', "");
    Expect(0, 1, '\p{Block=supplementaryprivateuseareab}', "");
    Expect(1, 1, '\p{^Block=supplementaryprivateuseareab}', "");
    Expect(1, 1, '\P{Block=supplementaryprivateuseareab}', "");
    Expect(0, 1, '\P{^Block=supplementaryprivateuseareab}', "");
    Expect(1, 1048576, '\p{Block=:\Asupplementaryprivateuseareab\z:}', "");;
    Expect(0, 1, '\p{Block=:\Asupplementaryprivateuseareab\z:}', "");;
    Expect(1, 1048576, '\p{Block=-	Supplementary_Private_Use_Area_B}', "");
    Expect(0, 1048576, '\p{^Block=-	Supplementary_Private_Use_Area_B}', "");
    Expect(0, 1048576, '\P{Block=-	Supplementary_Private_Use_Area_B}', "");
    Expect(1, 1048576, '\P{^Block=-	Supplementary_Private_Use_Area_B}', "");
    Expect(0, 1, '\p{Block=-	Supplementary_Private_Use_Area_B}', "");
    Expect(1, 1, '\p{^Block=-	Supplementary_Private_Use_Area_B}', "");
    Expect(1, 1, '\P{Block=-	Supplementary_Private_Use_Area_B}', "");
    Expect(0, 1, '\P{^Block=-	Supplementary_Private_Use_Area_B}', "");
    Error('\p{Blk=-Sup_PUA_b:=}');
    Error('\P{Blk=-Sup_PUA_b:=}');
    Expect(1, 1048576, '\p{Blk=:\ASup_PUA_B\z:}', "");;
    Expect(0, 1, '\p{Blk=:\ASup_PUA_B\z:}', "");;
    Expect(1, 1048576, '\p{Blk:	suppuab}', "");
    Expect(0, 1048576, '\p{^Blk:	suppuab}', "");
    Expect(0, 1048576, '\P{Blk:	suppuab}', "");
    Expect(1, 1048576, '\P{^Blk:	suppuab}', "");
    Expect(0, 1, '\p{Blk:	suppuab}', "");
    Expect(1, 1, '\p{^Blk:	suppuab}', "");
    Expect(1, 1, '\P{Blk:	suppuab}', "");
    Expect(0, 1, '\P{^Blk:	suppuab}', "");
    Expect(1, 1048576, '\p{Blk=:\Asuppuab\z:}', "");;
    Expect(0, 1, '\p{Blk=:\Asuppuab\z:}', "");;
    Expect(1, 1048576, '\p{Blk=	-sup_pua_B}', "");
    Expect(0, 1048576, '\p{^Blk=	-sup_pua_B}', "");
    Expect(0, 1048576, '\P{Blk=	-sup_pua_B}', "");
    Expect(1, 1048576, '\P{^Blk=	-sup_pua_B}', "");
    Expect(0, 1, '\p{Blk=	-sup_pua_B}', "");
    Expect(1, 1, '\p{^Blk=	-sup_pua_B}', "");
    Expect(1, 1, '\P{Blk=	-sup_pua_B}', "");
    Expect(0, 1, '\P{^Blk=	-sup_pua_B}', "");
    Error('\p{Is_Block= /a/Supplementary_PRIVATE_Use_AREA_B}');
    Error('\P{Is_Block= /a/Supplementary_PRIVATE_Use_AREA_B}');
    Expect(1, 1048576, '\p{Is_Block=supplementaryprivateuseareab}', "");
    Expect(0, 1048576, '\p{^Is_Block=supplementaryprivateuseareab}', "");
    Expect(0, 1048576, '\P{Is_Block=supplementaryprivateuseareab}', "");
    Expect(1, 1048576, '\P{^Is_Block=supplementaryprivateuseareab}', "");
    Expect(0, 1, '\p{Is_Block=supplementaryprivateuseareab}', "");
    Expect(1, 1, '\p{^Is_Block=supplementaryprivateuseareab}', "");
    Expect(1, 1, '\P{Is_Block=supplementaryprivateuseareab}', "");
    Expect(0, 1, '\P{^Is_Block=supplementaryprivateuseareab}', "");
    Expect(1, 1048576, '\p{Is_Block=		supplementary_Private_Use_Area_b}', "");
    Expect(0, 1048576, '\p{^Is_Block=		supplementary_Private_Use_Area_b}', "");
    Expect(0, 1048576, '\P{Is_Block=		supplementary_Private_Use_Area_b}', "");
    Expect(1, 1048576, '\P{^Is_Block=		supplementary_Private_Use_Area_b}', "");
    Expect(0, 1, '\p{Is_Block=		supplementary_Private_Use_Area_b}', "");
    Expect(1, 1, '\p{^Is_Block=		supplementary_Private_Use_Area_b}', "");
    Expect(1, 1, '\P{Is_Block=		supplementary_Private_Use_Area_b}', "");
    Expect(0, 1, '\P{^Is_Block=		supplementary_Private_Use_Area_b}', "");
    Error('\p{Is_Blk=/a/-	sup_PUA_B}');
    Error('\P{Is_Blk=/a/-	sup_PUA_B}');
    Expect(1, 1048576, '\p{Is_Blk=suppuab}', "");
    Expect(0, 1048576, '\p{^Is_Blk=suppuab}', "");
    Expect(0, 1048576, '\P{Is_Blk=suppuab}', "");
    Expect(1, 1048576, '\P{^Is_Blk=suppuab}', "");
    Expect(0, 1, '\p{Is_Blk=suppuab}', "");
    Expect(1, 1, '\p{^Is_Blk=suppuab}', "");
    Expect(1, 1, '\P{Is_Blk=suppuab}', "");
    Expect(0, 1, '\P{^Is_Blk=suppuab}', "");
    Expect(1, 1048576, '\p{Is_Blk=-Sup_PUA_B}', "");
    Expect(0, 1048576, '\p{^Is_Blk=-Sup_PUA_B}', "");
    Expect(0, 1048576, '\P{Is_Blk=-Sup_PUA_B}', "");
    Expect(1, 1048576, '\P{^Is_Blk=-Sup_PUA_B}', "");
    Expect(0, 1, '\p{Is_Blk=-Sup_PUA_B}', "");
    Expect(1, 1, '\p{^Is_Blk=-Sup_PUA_B}', "");
    Expect(1, 1, '\P{Is_Blk=-Sup_PUA_B}', "");
    Expect(0, 1, '\P{^Is_Blk=-Sup_PUA_B}', "");
    Error('\p{Block= Supplemental_PUNCTUATION:=}');
    Error('\P{Block= Supplemental_PUNCTUATION:=}');
    Expect(1, 11903, '\p{Block=:\ASupplemental_Punctuation\z:}', "");;
    Expect(0, 11904, '\p{Block=:\ASupplemental_Punctuation\z:}', "");;
    Expect(1, 11903, '\p{Block=supplementalpunctuation}', "");
    Expect(0, 11903, '\p{^Block=supplementalpunctuation}', "");
    Expect(0, 11903, '\P{Block=supplementalpunctuation}', "");
    Expect(1, 11903, '\P{^Block=supplementalpunctuation}', "");
    Expect(0, 11904, '\p{Block=supplementalpunctuation}', "");
    Expect(1, 11904, '\p{^Block=supplementalpunctuation}', "");
    Expect(1, 11904, '\P{Block=supplementalpunctuation}', "");
    Expect(0, 11904, '\P{^Block=supplementalpunctuation}', "");
    Expect(1, 11903, '\p{Block=:\Asupplementalpunctuation\z:}', "");;
    Expect(0, 11904, '\p{Block=:\Asupplementalpunctuation\z:}', "");;
    Expect(1, 11903, '\p{Block: -supplemental_Punctuation}', "");
    Expect(0, 11903, '\p{^Block: -supplemental_Punctuation}', "");
    Expect(0, 11903, '\P{Block: -supplemental_Punctuation}', "");
    Expect(1, 11903, '\P{^Block: -supplemental_Punctuation}', "");
    Expect(0, 11904, '\p{Block: -supplemental_Punctuation}', "");
    Expect(1, 11904, '\p{^Block: -supplemental_Punctuation}', "");
    Expect(1, 11904, '\P{Block: -supplemental_Punctuation}', "");
    Expect(0, 11904, '\P{^Block: -supplemental_Punctuation}', "");
    Error('\p{Blk=/a/SUP_punctuation}');
    Error('\P{Blk=/a/SUP_punctuation}');
    Expect(1, 11903, '\p{Blk=:\ASup_Punctuation\z:}', "");;
    Expect(0, 11904, '\p{Blk=:\ASup_Punctuation\z:}', "");;
    Expect(1, 11903, '\p{Blk:   suppunctuation}', "");
    Expect(0, 11903, '\p{^Blk:   suppunctuation}', "");
    Expect(0, 11903, '\P{Blk:   suppunctuation}', "");
    Expect(1, 11903, '\P{^Blk:   suppunctuation}', "");
    Expect(0, 11904, '\p{Blk:   suppunctuation}', "");
    Expect(1, 11904, '\p{^Blk:   suppunctuation}', "");
    Expect(1, 11904, '\P{Blk:   suppunctuation}', "");
    Expect(0, 11904, '\P{^Blk:   suppunctuation}', "");
    Expect(1, 11903, '\p{Blk=:\Asuppunctuation\z:}', "");;
    Expect(0, 11904, '\p{Blk=:\Asuppunctuation\z:}', "");;
    Expect(1, 11903, '\p{Blk=-Sup_PUNCTUATION}', "");
    Expect(0, 11903, '\p{^Blk=-Sup_PUNCTUATION}', "");
    Expect(0, 11903, '\P{Blk=-Sup_PUNCTUATION}', "");
    Expect(1, 11903, '\P{^Blk=-Sup_PUNCTUATION}', "");
    Expect(0, 11904, '\p{Blk=-Sup_PUNCTUATION}', "");
    Expect(1, 11904, '\p{^Blk=-Sup_PUNCTUATION}', "");
    Expect(1, 11904, '\P{Blk=-Sup_PUNCTUATION}', "");
    Expect(0, 11904, '\P{^Blk=-Sup_PUNCTUATION}', "");
    Error('\p{Is_Block=/a/ supplemental_PUNCTUATION}');
    Error('\P{Is_Block=/a/ supplemental_PUNCTUATION}');
    Expect(1, 11903, '\p{Is_Block=supplementalpunctuation}', "");
    Expect(0, 11903, '\p{^Is_Block=supplementalpunctuation}', "");
    Expect(0, 11903, '\P{Is_Block=supplementalpunctuation}', "");
    Expect(1, 11903, '\P{^Is_Block=supplementalpunctuation}', "");
    Expect(0, 11904, '\p{Is_Block=supplementalpunctuation}', "");
    Expect(1, 11904, '\p{^Is_Block=supplementalpunctuation}', "");
    Expect(1, 11904, '\P{Is_Block=supplementalpunctuation}', "");
    Expect(0, 11904, '\P{^Is_Block=supplementalpunctuation}', "");
    Expect(1, 11903, '\p{Is_Block= Supplemental_Punctuation}', "");
    Expect(0, 11903, '\p{^Is_Block= Supplemental_Punctuation}', "");
    Expect(0, 11903, '\P{Is_Block= Supplemental_Punctuation}', "");
    Expect(1, 11903, '\P{^Is_Block= Supplemental_Punctuation}', "");
    Expect(0, 11904, '\p{Is_Block= Supplemental_Punctuation}', "");
    Expect(1, 11904, '\p{^Is_Block= Supplemental_Punctuation}', "");
    Expect(1, 11904, '\P{Is_Block= Supplemental_Punctuation}', "");
    Expect(0, 11904, '\P{^Is_Block= Supplemental_Punctuation}', "");
    Error('\p{Is_Blk=		sup_punctuation/a/}');
    Error('\P{Is_Blk=		sup_punctuation/a/}');
    Expect(1, 11903, '\p{Is_Blk=suppunctuation}', "");
    Expect(0, 11903, '\p{^Is_Blk=suppunctuation}', "");
    Expect(0, 11903, '\P{Is_Blk=suppunctuation}', "");
    Expect(1, 11903, '\P{^Is_Blk=suppunctuation}', "");
    Expect(0, 11904, '\p{Is_Blk=suppunctuation}', "");
    Expect(1, 11904, '\p{^Is_Blk=suppunctuation}', "");
    Expect(1, 11904, '\P{Is_Blk=suppunctuation}', "");
    Expect(0, 11904, '\P{^Is_Blk=suppunctuation}', "");
    Expect(1, 11903, '\p{Is_Blk: -	Sup_punctuation}', "");
    Expect(0, 11903, '\p{^Is_Blk: -	Sup_punctuation}', "");
    Expect(0, 11903, '\P{Is_Blk: -	Sup_punctuation}', "");
    Expect(1, 11903, '\P{^Is_Blk: -	Sup_punctuation}', "");
    Expect(0, 11904, '\p{Is_Blk: -	Sup_punctuation}', "");
    Expect(1, 11904, '\p{^Is_Blk: -	Sup_punctuation}', "");
    Expect(1, 11904, '\P{Is_Blk: -	Sup_punctuation}', "");
    Expect(0, 11904, '\P{^Is_Blk: -	Sup_punctuation}', "");
    Error('\p{Block=_:=SUPPLEMENTAL_symbols_And_pictographs}');
    Error('\P{Block=_:=SUPPLEMENTAL_symbols_And_pictographs}');
    Expect(1, 129535, '\p{Block=:\ASupplemental_Symbols_And_Pictographs\z:}', "");;
    Expect(0, 129536, '\p{Block=:\ASupplemental_Symbols_And_Pictographs\z:}', "");;
    Expect(1, 129535, '\p{Block=supplementalsymbolsandpictographs}', "");
    Expect(0, 129535, '\p{^Block=supplementalsymbolsandpictographs}', "");
    Expect(0, 129535, '\P{Block=supplementalsymbolsandpictographs}', "");
    Expect(1, 129535, '\P{^Block=supplementalsymbolsandpictographs}', "");
    Expect(0, 129536, '\p{Block=supplementalsymbolsandpictographs}', "");
    Expect(1, 129536, '\p{^Block=supplementalsymbolsandpictographs}', "");
    Expect(1, 129536, '\P{Block=supplementalsymbolsandpictographs}', "");
    Expect(0, 129536, '\P{^Block=supplementalsymbolsandpictographs}', "");
    Expect(1, 129535, '\p{Block=:\Asupplementalsymbolsandpictographs\z:}', "");;
    Expect(0, 129536, '\p{Block=:\Asupplementalsymbolsandpictographs\z:}', "");;
    Expect(1, 129535, '\p{Block=	Supplemental_Symbols_and_pictographs}', "");
    Expect(0, 129535, '\p{^Block=	Supplemental_Symbols_and_pictographs}', "");
    Expect(0, 129535, '\P{Block=	Supplemental_Symbols_and_pictographs}', "");
    Expect(1, 129535, '\P{^Block=	Supplemental_Symbols_and_pictographs}', "");
    Expect(0, 129536, '\p{Block=	Supplemental_Symbols_and_pictographs}', "");
    Expect(1, 129536, '\p{^Block=	Supplemental_Symbols_and_pictographs}', "");
    Expect(1, 129536, '\P{Block=	Supplemental_Symbols_and_pictographs}', "");
    Expect(0, 129536, '\P{^Block=	Supplemental_Symbols_and_pictographs}', "");
    Error('\p{Blk=	:=Sup_SYMBOLS_and_Pictographs}');
    Error('\P{Blk=	:=Sup_SYMBOLS_and_Pictographs}');
    Expect(1, 129535, '\p{Blk=:\ASup_Symbols_And_Pictographs\z:}', "");;
    Expect(0, 129536, '\p{Blk=:\ASup_Symbols_And_Pictographs\z:}', "");;
    Expect(1, 129535, '\p{Blk=supsymbolsandpictographs}', "");
    Expect(0, 129535, '\p{^Blk=supsymbolsandpictographs}', "");
    Expect(0, 129535, '\P{Blk=supsymbolsandpictographs}', "");
    Expect(1, 129535, '\P{^Blk=supsymbolsandpictographs}', "");
    Expect(0, 129536, '\p{Blk=supsymbolsandpictographs}', "");
    Expect(1, 129536, '\p{^Blk=supsymbolsandpictographs}', "");
    Expect(1, 129536, '\P{Blk=supsymbolsandpictographs}', "");
    Expect(0, 129536, '\P{^Blk=supsymbolsandpictographs}', "");
    Expect(1, 129535, '\p{Blk=:\Asupsymbolsandpictographs\z:}', "");;
    Expect(0, 129536, '\p{Blk=:\Asupsymbolsandpictographs\z:}', "");;
    Expect(1, 129535, '\p{Blk=_ SUP_SYMBOLS_AND_Pictographs}', "");
    Expect(0, 129535, '\p{^Blk=_ SUP_SYMBOLS_AND_Pictographs}', "");
    Expect(0, 129535, '\P{Blk=_ SUP_SYMBOLS_AND_Pictographs}', "");
    Expect(1, 129535, '\P{^Blk=_ SUP_SYMBOLS_AND_Pictographs}', "");
    Expect(0, 129536, '\p{Blk=_ SUP_SYMBOLS_AND_Pictographs}', "");
    Expect(1, 129536, '\p{^Blk=_ SUP_SYMBOLS_AND_Pictographs}', "");
    Expect(1, 129536, '\P{Blk=_ SUP_SYMBOLS_AND_Pictographs}', "");
    Expect(0, 129536, '\P{^Blk=_ SUP_SYMBOLS_AND_Pictographs}', "");
    Error('\p{Is_Block=_:=SUPPLEMENTAL_symbols_AND_pictographs}');
    Error('\P{Is_Block=_:=SUPPLEMENTAL_symbols_AND_pictographs}');
    Expect(1, 129535, '\p{Is_Block:	supplementalsymbolsandpictographs}', "");
    Expect(0, 129535, '\p{^Is_Block:	supplementalsymbolsandpictographs}', "");
    Expect(0, 129535, '\P{Is_Block:	supplementalsymbolsandpictographs}', "");
    Expect(1, 129535, '\P{^Is_Block:	supplementalsymbolsandpictographs}', "");
    Expect(0, 129536, '\p{Is_Block:	supplementalsymbolsandpictographs}', "");
    Expect(1, 129536, '\p{^Is_Block:	supplementalsymbolsandpictographs}', "");
    Expect(1, 129536, '\P{Is_Block:	supplementalsymbolsandpictographs}', "");
    Expect(0, 129536, '\P{^Is_Block:	supplementalsymbolsandpictographs}', "");
    Expect(1, 129535, '\p{Is_Block=--Supplemental_symbols_And_Pictographs}', "");
    Expect(0, 129535, '\p{^Is_Block=--Supplemental_symbols_And_Pictographs}', "");
    Expect(0, 129535, '\P{Is_Block=--Supplemental_symbols_And_Pictographs}', "");
    Expect(1, 129535, '\P{^Is_Block=--Supplemental_symbols_And_Pictographs}', "");
    Expect(0, 129536, '\p{Is_Block=--Supplemental_symbols_And_Pictographs}', "");
    Expect(1, 129536, '\p{^Is_Block=--Supplemental_symbols_And_Pictographs}', "");
    Expect(1, 129536, '\P{Is_Block=--Supplemental_symbols_And_Pictographs}', "");
    Expect(0, 129536, '\P{^Is_Block=--Supplemental_symbols_And_Pictographs}', "");
    Error('\p{Is_Blk=:= sup_symbols_And_Pictographs}');
    Error('\P{Is_Blk=:= sup_symbols_And_Pictographs}');
    Expect(1, 129535, '\p{Is_Blk=supsymbolsandpictographs}', "");
    Expect(0, 129535, '\p{^Is_Blk=supsymbolsandpictographs}', "");
    Expect(0, 129535, '\P{Is_Blk=supsymbolsandpictographs}', "");
    Expect(1, 129535, '\P{^Is_Blk=supsymbolsandpictographs}', "");
    Expect(0, 129536, '\p{Is_Blk=supsymbolsandpictographs}', "");
    Expect(1, 129536, '\p{^Is_Blk=supsymbolsandpictographs}', "");
    Expect(1, 129536, '\P{Is_Blk=supsymbolsandpictographs}', "");
    Expect(0, 129536, '\P{^Is_Blk=supsymbolsandpictographs}', "");
    Expect(1, 129535, '\p{Is_Blk=	-Sup_SYMBOLS_AND_pictographs}', "");
    Expect(0, 129535, '\p{^Is_Blk=	-Sup_SYMBOLS_AND_pictographs}', "");
    Expect(0, 129535, '\P{Is_Blk=	-Sup_SYMBOLS_AND_pictographs}', "");
    Expect(1, 129535, '\P{^Is_Blk=	-Sup_SYMBOLS_AND_pictographs}', "");
    Expect(0, 129536, '\p{Is_Blk=	-Sup_SYMBOLS_AND_pictographs}', "");
    Expect(1, 129536, '\p{^Is_Blk=	-Sup_SYMBOLS_AND_pictographs}', "");
    Expect(1, 129536, '\P{Is_Blk=	-Sup_SYMBOLS_AND_pictographs}', "");
    Expect(0, 129536, '\P{^Is_Blk=	-Sup_SYMBOLS_AND_pictographs}', "");
    Error('\p{Block=-/a/SUPERSCRIPTS_And_subscripts}');
    Error('\P{Block=-/a/SUPERSCRIPTS_And_subscripts}');
    Expect(1, 8351, '\p{Block=:\ASuperscripts_And_Subscripts\z:}', "");;
    Expect(0, 8352, '\p{Block=:\ASuperscripts_And_Subscripts\z:}', "");;
    Expect(1, 8351, '\p{Block=superscriptsandsubscripts}', "");
    Expect(0, 8351, '\p{^Block=superscriptsandsubscripts}', "");
    Expect(0, 8351, '\P{Block=superscriptsandsubscripts}', "");
    Expect(1, 8351, '\P{^Block=superscriptsandsubscripts}', "");
    Expect(0, 8352, '\p{Block=superscriptsandsubscripts}', "");
    Expect(1, 8352, '\p{^Block=superscriptsandsubscripts}', "");
    Expect(1, 8352, '\P{Block=superscriptsandsubscripts}', "");
    Expect(0, 8352, '\P{^Block=superscriptsandsubscripts}', "");
    Expect(1, 8351, '\p{Block=:\Asuperscriptsandsubscripts\z:}', "");;
    Expect(0, 8352, '\p{Block=:\Asuperscriptsandsubscripts\z:}', "");;
    Expect(1, 8351, '\p{Block:   -Superscripts_AND_Subscripts}', "");
    Expect(0, 8351, '\p{^Block:   -Superscripts_AND_Subscripts}', "");
    Expect(0, 8351, '\P{Block:   -Superscripts_AND_Subscripts}', "");
    Expect(1, 8351, '\P{^Block:   -Superscripts_AND_Subscripts}', "");
    Expect(0, 8352, '\p{Block:   -Superscripts_AND_Subscripts}', "");
    Expect(1, 8352, '\p{^Block:   -Superscripts_AND_Subscripts}', "");
    Expect(1, 8352, '\P{Block:   -Superscripts_AND_Subscripts}', "");
    Expect(0, 8352, '\P{^Block:   -Superscripts_AND_Subscripts}', "");
    Error('\p{Blk=/a/ Super_AND_sub}');
    Error('\P{Blk=/a/ Super_AND_sub}');
    Expect(1, 8351, '\p{Blk=:\ASuper_And_Sub\z:}', "");;
    Expect(0, 8352, '\p{Blk=:\ASuper_And_Sub\z:}', "");;
    Expect(1, 8351, '\p{Blk=superandsub}', "");
    Expect(0, 8351, '\p{^Blk=superandsub}', "");
    Expect(0, 8351, '\P{Blk=superandsub}', "");
    Expect(1, 8351, '\P{^Blk=superandsub}', "");
    Expect(0, 8352, '\p{Blk=superandsub}', "");
    Expect(1, 8352, '\p{^Blk=superandsub}', "");
    Expect(1, 8352, '\P{Blk=superandsub}', "");
    Expect(0, 8352, '\P{^Blk=superandsub}', "");
    Expect(1, 8351, '\p{Blk=:\Asuperandsub\z:}', "");;
    Expect(0, 8352, '\p{Blk=:\Asuperandsub\z:}', "");;
    Expect(1, 8351, '\p{Blk= Super_and_sub}', "");
    Expect(0, 8351, '\p{^Blk= Super_and_sub}', "");
    Expect(0, 8351, '\P{Blk= Super_and_sub}', "");
    Expect(1, 8351, '\P{^Blk= Super_and_sub}', "");
    Expect(0, 8352, '\p{Blk= Super_and_sub}', "");
    Expect(1, 8352, '\p{^Blk= Super_and_sub}', "");
    Expect(1, 8352, '\P{Blk= Super_and_sub}', "");
    Expect(0, 8352, '\P{^Blk= Super_and_sub}', "");
    Error('\p{Is_Block=-:=SUPERSCRIPTS_and_Subscripts}');
    Error('\P{Is_Block=-:=SUPERSCRIPTS_and_Subscripts}');
    Expect(1, 8351, '\p{Is_Block=superscriptsandsubscripts}', "");
    Expect(0, 8351, '\p{^Is_Block=superscriptsandsubscripts}', "");
    Expect(0, 8351, '\P{Is_Block=superscriptsandsubscripts}', "");
    Expect(1, 8351, '\P{^Is_Block=superscriptsandsubscripts}', "");
    Expect(0, 8352, '\p{Is_Block=superscriptsandsubscripts}', "");
    Expect(1, 8352, '\p{^Is_Block=superscriptsandsubscripts}', "");
    Expect(1, 8352, '\P{Is_Block=superscriptsandsubscripts}', "");
    Expect(0, 8352, '\P{^Is_Block=superscriptsandsubscripts}', "");
    Expect(1, 8351, '\p{Is_Block=	 Superscripts_AND_Subscripts}', "");
    Expect(0, 8351, '\p{^Is_Block=	 Superscripts_AND_Subscripts}', "");
    Expect(0, 8351, '\P{Is_Block=	 Superscripts_AND_Subscripts}', "");
    Expect(1, 8351, '\P{^Is_Block=	 Superscripts_AND_Subscripts}', "");
    Expect(0, 8352, '\p{Is_Block=	 Superscripts_AND_Subscripts}', "");
    Expect(1, 8352, '\p{^Is_Block=	 Superscripts_AND_Subscripts}', "");
    Expect(1, 8352, '\P{Is_Block=	 Superscripts_AND_Subscripts}', "");
    Expect(0, 8352, '\P{^Is_Block=	 Superscripts_AND_Subscripts}', "");
    Error('\p{Is_Blk:		Super_And_SUB:=}');
    Error('\P{Is_Blk:		Super_And_SUB:=}');
    Expect(1, 8351, '\p{Is_Blk=superandsub}', "");
    Expect(0, 8351, '\p{^Is_Blk=superandsub}', "");
    Expect(0, 8351, '\P{Is_Blk=superandsub}', "");
    Expect(1, 8351, '\P{^Is_Blk=superandsub}', "");
    Expect(0, 8352, '\p{Is_Blk=superandsub}', "");
    Expect(1, 8352, '\p{^Is_Blk=superandsub}', "");
    Expect(1, 8352, '\P{Is_Blk=superandsub}', "");
    Expect(0, 8352, '\P{^Is_Blk=superandsub}', "");
    Expect(1, 8351, '\p{Is_Blk= Super_And_SUB}', "");
    Expect(0, 8351, '\p{^Is_Blk= Super_And_SUB}', "");
    Expect(0, 8351, '\P{Is_Blk= Super_And_SUB}', "");
    Expect(1, 8351, '\P{^Is_Blk= Super_And_SUB}', "");
    Expect(0, 8352, '\p{Is_Blk= Super_And_SUB}', "");
    Expect(1, 8352, '\p{^Is_Blk= Super_And_SUB}', "");
    Expect(1, 8352, '\P{Is_Blk= Super_And_SUB}', "");
    Expect(0, 8352, '\P{^Is_Blk= Super_And_SUB}', "");
    Error('\p{Block= _Sutton_SignWriting/a/}');
    Error('\P{Block= _Sutton_SignWriting/a/}');
    Expect(1, 121519, '\p{Block=:\ASutton_SignWriting\z:}', "");;
    Expect(0, 121520, '\p{Block=:\ASutton_SignWriting\z:}', "");;
    Expect(1, 121519, '\p{Block=suttonsignwriting}', "");
    Expect(0, 121519, '\p{^Block=suttonsignwriting}', "");
    Expect(0, 121519, '\P{Block=suttonsignwriting}', "");
    Expect(1, 121519, '\P{^Block=suttonsignwriting}', "");
    Expect(0, 121520, '\p{Block=suttonsignwriting}', "");
    Expect(1, 121520, '\p{^Block=suttonsignwriting}', "");
    Expect(1, 121520, '\P{Block=suttonsignwriting}', "");
    Expect(0, 121520, '\P{^Block=suttonsignwriting}', "");
    Expect(1, 121519, '\p{Block=:\Asuttonsignwriting\z:}', "");;
    Expect(0, 121520, '\p{Block=:\Asuttonsignwriting\z:}', "");;
    Expect(1, 121519, '\p{Block=	Sutton_SignWriting}', "");
    Expect(0, 121519, '\p{^Block=	Sutton_SignWriting}', "");
    Expect(0, 121519, '\P{Block=	Sutton_SignWriting}', "");
    Expect(1, 121519, '\P{^Block=	Sutton_SignWriting}', "");
    Expect(0, 121520, '\p{Block=	Sutton_SignWriting}', "");
    Expect(1, 121520, '\p{^Block=	Sutton_SignWriting}', "");
    Expect(1, 121520, '\P{Block=	Sutton_SignWriting}', "");
    Expect(0, 121520, '\P{^Block=	Sutton_SignWriting}', "");
    Error('\p{Blk=/a/-	SUTTON_SignWriting}');
    Error('\P{Blk=/a/-	SUTTON_SignWriting}');
    Expect(1, 121519, '\p{Blk=:\ASutton_SignWriting\z:}', "");;
    Expect(0, 121520, '\p{Blk=:\ASutton_SignWriting\z:}', "");;
    Expect(1, 121519, '\p{Blk:suttonsignwriting}', "");
    Expect(0, 121519, '\p{^Blk:suttonsignwriting}', "");
    Expect(0, 121519, '\P{Blk:suttonsignwriting}', "");
    Expect(1, 121519, '\P{^Blk:suttonsignwriting}', "");
    Expect(0, 121520, '\p{Blk:suttonsignwriting}', "");
    Expect(1, 121520, '\p{^Blk:suttonsignwriting}', "");
    Expect(1, 121520, '\P{Blk:suttonsignwriting}', "");
    Expect(0, 121520, '\P{^Blk:suttonsignwriting}', "");
    Expect(1, 121519, '\p{Blk=:\Asuttonsignwriting\z:}', "");;
    Expect(0, 121520, '\p{Blk=:\Asuttonsignwriting\z:}', "");;
    Expect(1, 121519, '\p{Blk=	sutton_SignWriting}', "");
    Expect(0, 121519, '\p{^Blk=	sutton_SignWriting}', "");
    Expect(0, 121519, '\P{Blk=	sutton_SignWriting}', "");
    Expect(1, 121519, '\P{^Blk=	sutton_SignWriting}', "");
    Expect(0, 121520, '\p{Blk=	sutton_SignWriting}', "");
    Expect(1, 121520, '\p{^Blk=	sutton_SignWriting}', "");
    Expect(1, 121520, '\P{Blk=	sutton_SignWriting}', "");
    Expect(0, 121520, '\P{^Blk=	sutton_SignWriting}', "");
    Error('\p{Is_Block=_Sutton_SignWriting/a/}');
    Error('\P{Is_Block=_Sutton_SignWriting/a/}');
    Expect(1, 121519, '\p{Is_Block=suttonsignwriting}', "");
    Expect(0, 121519, '\p{^Is_Block=suttonsignwriting}', "");
    Expect(0, 121519, '\P{Is_Block=suttonsignwriting}', "");
    Expect(1, 121519, '\P{^Is_Block=suttonsignwriting}', "");
    Expect(0, 121520, '\p{Is_Block=suttonsignwriting}', "");
    Expect(1, 121520, '\p{^Is_Block=suttonsignwriting}', "");
    Expect(1, 121520, '\P{Is_Block=suttonsignwriting}', "");
    Expect(0, 121520, '\P{^Is_Block=suttonsignwriting}', "");
    Expect(1, 121519, '\p{Is_Block=- Sutton_SIGNWRITING}', "");
    Expect(0, 121519, '\p{^Is_Block=- Sutton_SIGNWRITING}', "");
    Expect(0, 121519, '\P{Is_Block=- Sutton_SIGNWRITING}', "");
    Expect(1, 121519, '\P{^Is_Block=- Sutton_SIGNWRITING}', "");
    Expect(0, 121520, '\p{Is_Block=- Sutton_SIGNWRITING}', "");
    Expect(1, 121520, '\p{^Is_Block=- Sutton_SIGNWRITING}', "");
    Expect(1, 121520, '\P{Is_Block=- Sutton_SIGNWRITING}', "");
    Expect(0, 121520, '\P{^Is_Block=- Sutton_SIGNWRITING}', "");
    Error('\p{Is_Blk=-/a/Sutton_signwriting}');
    Error('\P{Is_Blk=-/a/Sutton_signwriting}');
    Expect(1, 121519, '\p{Is_Blk=suttonsignwriting}', "");
    Expect(0, 121519, '\p{^Is_Blk=suttonsignwriting}', "");
    Expect(0, 121519, '\P{Is_Blk=suttonsignwriting}', "");
    Expect(1, 121519, '\P{^Is_Blk=suttonsignwriting}', "");
    Expect(0, 121520, '\p{Is_Blk=suttonsignwriting}', "");
    Expect(1, 121520, '\p{^Is_Blk=suttonsignwriting}', "");
    Expect(1, 121520, '\P{Is_Blk=suttonsignwriting}', "");
    Expect(0, 121520, '\P{^Is_Blk=suttonsignwriting}', "");
    Expect(1, 121519, '\p{Is_Blk=	_sutton_SignWriting}', "");
    Expect(0, 121519, '\p{^Is_Blk=	_sutton_SignWriting}', "");
    Expect(0, 121519, '\P{Is_Blk=	_sutton_SignWriting}', "");
    Expect(1, 121519, '\P{^Is_Blk=	_sutton_SignWriting}', "");
    Expect(0, 121520, '\p{Is_Blk=	_sutton_SignWriting}', "");
    Expect(1, 121520, '\p{^Is_Blk=	_sutton_SignWriting}', "");
    Expect(1, 121520, '\P{Is_Blk=	_sutton_SignWriting}', "");
    Expect(0, 121520, '\P{^Is_Blk=	_sutton_SignWriting}', "");
    Error('\p{Block=-:=SYLOTI_Nagri}');
    Error('\P{Block=-:=SYLOTI_Nagri}');
    Expect(1, 43055, '\p{Block=:\ASyloti_Nagri\z:}', "");;
    Expect(0, 43056, '\p{Block=:\ASyloti_Nagri\z:}', "");;
    Expect(1, 43055, '\p{Block=sylotinagri}', "");
    Expect(0, 43055, '\p{^Block=sylotinagri}', "");
    Expect(0, 43055, '\P{Block=sylotinagri}', "");
    Expect(1, 43055, '\P{^Block=sylotinagri}', "");
    Expect(0, 43056, '\p{Block=sylotinagri}', "");
    Expect(1, 43056, '\p{^Block=sylotinagri}', "");
    Expect(1, 43056, '\P{Block=sylotinagri}', "");
    Expect(0, 43056, '\P{^Block=sylotinagri}', "");
    Expect(1, 43055, '\p{Block=:\Asylotinagri\z:}', "");;
    Expect(0, 43056, '\p{Block=:\Asylotinagri\z:}', "");;
    Expect(1, 43055, '\p{Block=  SYLOTI_Nagri}', "");
    Expect(0, 43055, '\p{^Block=  SYLOTI_Nagri}', "");
    Expect(0, 43055, '\P{Block=  SYLOTI_Nagri}', "");
    Expect(1, 43055, '\P{^Block=  SYLOTI_Nagri}', "");
    Expect(0, 43056, '\p{Block=  SYLOTI_Nagri}', "");
    Expect(1, 43056, '\p{^Block=  SYLOTI_Nagri}', "");
    Expect(1, 43056, '\P{Block=  SYLOTI_Nagri}', "");
    Expect(0, 43056, '\P{^Block=  SYLOTI_Nagri}', "");
    Error('\p{Blk= /a/syloti_Nagri}');
    Error('\P{Blk= /a/syloti_Nagri}');
    Expect(1, 43055, '\p{Blk=:\ASyloti_Nagri\z:}', "");;
    Expect(0, 43056, '\p{Blk=:\ASyloti_Nagri\z:}', "");;
    Expect(1, 43055, '\p{Blk=sylotinagri}', "");
    Expect(0, 43055, '\p{^Blk=sylotinagri}', "");
    Expect(0, 43055, '\P{Blk=sylotinagri}', "");
    Expect(1, 43055, '\P{^Blk=sylotinagri}', "");
    Expect(0, 43056, '\p{Blk=sylotinagri}', "");
    Expect(1, 43056, '\p{^Blk=sylotinagri}', "");
    Expect(1, 43056, '\P{Blk=sylotinagri}', "");
    Expect(0, 43056, '\P{^Blk=sylotinagri}', "");
    Expect(1, 43055, '\p{Blk=:\Asylotinagri\z:}', "");;
    Expect(0, 43056, '\p{Blk=:\Asylotinagri\z:}', "");;
    Expect(1, 43055, '\p{Blk=-	syloti_nagri}', "");
    Expect(0, 43055, '\p{^Blk=-	syloti_nagri}', "");
    Expect(0, 43055, '\P{Blk=-	syloti_nagri}', "");
    Expect(1, 43055, '\P{^Blk=-	syloti_nagri}', "");
    Expect(0, 43056, '\p{Blk=-	syloti_nagri}', "");
    Expect(1, 43056, '\p{^Blk=-	syloti_nagri}', "");
    Expect(1, 43056, '\P{Blk=-	syloti_nagri}', "");
    Expect(0, 43056, '\P{^Blk=-	syloti_nagri}', "");
    Error('\p{Is_Block=/a/	Syloti_Nagri}');
    Error('\P{Is_Block=/a/	Syloti_Nagri}');
    Expect(1, 43055, '\p{Is_Block=sylotinagri}', "");
    Expect(0, 43055, '\p{^Is_Block=sylotinagri}', "");
    Expect(0, 43055, '\P{Is_Block=sylotinagri}', "");
    Expect(1, 43055, '\P{^Is_Block=sylotinagri}', "");
    Expect(0, 43056, '\p{Is_Block=sylotinagri}', "");
    Expect(1, 43056, '\p{^Is_Block=sylotinagri}', "");
    Expect(1, 43056, '\P{Is_Block=sylotinagri}', "");
    Expect(0, 43056, '\P{^Is_Block=sylotinagri}', "");
    Expect(1, 43055, '\p{Is_Block=		syloti_Nagri}', "");
    Expect(0, 43055, '\p{^Is_Block=		syloti_Nagri}', "");
    Expect(0, 43055, '\P{Is_Block=		syloti_Nagri}', "");
    Expect(1, 43055, '\P{^Is_Block=		syloti_Nagri}', "");
    Expect(0, 43056, '\p{Is_Block=		syloti_Nagri}', "");
    Expect(1, 43056, '\p{^Is_Block=		syloti_Nagri}', "");
    Expect(1, 43056, '\P{Is_Block=		syloti_Nagri}', "");
    Expect(0, 43056, '\P{^Is_Block=		syloti_Nagri}', "");
    Error('\p{Is_Blk:	 /a/Syloti_NAGRI}');
    Error('\P{Is_Blk:	 /a/Syloti_NAGRI}');
    Expect(1, 43055, '\p{Is_Blk=sylotinagri}', "");
    Expect(0, 43055, '\p{^Is_Blk=sylotinagri}', "");
    Expect(0, 43055, '\P{Is_Blk=sylotinagri}', "");
    Expect(1, 43055, '\P{^Is_Blk=sylotinagri}', "");
    Expect(0, 43056, '\p{Is_Blk=sylotinagri}', "");
    Expect(1, 43056, '\p{^Is_Blk=sylotinagri}', "");
    Expect(1, 43056, '\P{Is_Blk=sylotinagri}', "");
    Expect(0, 43056, '\P{^Is_Blk=sylotinagri}', "");
    Expect(1, 43055, '\p{Is_Blk= -syloti_Nagri}', "");
    Expect(0, 43055, '\p{^Is_Blk= -syloti_Nagri}', "");
    Expect(0, 43055, '\P{Is_Blk= -syloti_Nagri}', "");
    Expect(1, 43055, '\P{^Is_Blk= -syloti_Nagri}', "");
    Expect(0, 43056, '\p{Is_Blk= -syloti_Nagri}', "");
    Expect(1, 43056, '\p{^Is_Blk= -syloti_Nagri}', "");
    Expect(1, 43056, '\P{Is_Blk= -syloti_Nagri}', "");
    Expect(0, 43056, '\P{^Is_Blk= -syloti_Nagri}', "");
    Error('\p{Block= _SYMBOLS_And_pictographs_Extended_A:=}');
    Error('\P{Block= _SYMBOLS_And_pictographs_Extended_A:=}');
    Expect(1, 129791, '\p{Block=:\ASymbols_And_Pictographs_Extended_A\z:}', "");;
    Expect(0, 129792, '\p{Block=:\ASymbols_And_Pictographs_Extended_A\z:}', "");;
    Expect(1, 129791, '\p{Block=symbolsandpictographsextendeda}', "");
    Expect(0, 129791, '\p{^Block=symbolsandpictographsextendeda}', "");
    Expect(0, 129791, '\P{Block=symbolsandpictographsextendeda}', "");
    Expect(1, 129791, '\P{^Block=symbolsandpictographsextendeda}', "");
    Expect(0, 129792, '\p{Block=symbolsandpictographsextendeda}', "");
    Expect(1, 129792, '\p{^Block=symbolsandpictographsextendeda}', "");
    Expect(1, 129792, '\P{Block=symbolsandpictographsextendeda}', "");
    Expect(0, 129792, '\P{^Block=symbolsandpictographsextendeda}', "");
    Expect(1, 129791, '\p{Block=:\Asymbolsandpictographsextendeda\z:}', "");;
    Expect(0, 129792, '\p{Block=:\Asymbolsandpictographsextendeda\z:}', "");;
    Expect(1, 129791, '\p{Block=_ Symbols_And_pictographs_extended_a}', "");
    Expect(0, 129791, '\p{^Block=_ Symbols_And_pictographs_extended_a}', "");
    Expect(0, 129791, '\P{Block=_ Symbols_And_pictographs_extended_a}', "");
    Expect(1, 129791, '\P{^Block=_ Symbols_And_pictographs_extended_a}', "");
    Expect(0, 129792, '\p{Block=_ Symbols_And_pictographs_extended_a}', "");
    Expect(1, 129792, '\p{^Block=_ Symbols_And_pictographs_extended_a}', "");
    Expect(1, 129792, '\P{Block=_ Symbols_And_pictographs_extended_a}', "");
    Expect(0, 129792, '\P{^Block=_ Symbols_And_pictographs_extended_a}', "");
    Error('\p{Blk=__Symbols_And_PICTOGRAPHS_EXT_A:=}');
    Error('\P{Blk=__Symbols_And_PICTOGRAPHS_EXT_A:=}');
    Expect(1, 129791, '\p{Blk=:\ASymbols_And_Pictographs_Ext_A\z:}', "");;
    Expect(0, 129792, '\p{Blk=:\ASymbols_And_Pictographs_Ext_A\z:}', "");;
    Expect(1, 129791, '\p{Blk: symbolsandpictographsexta}', "");
    Expect(0, 129791, '\p{^Blk: symbolsandpictographsexta}', "");
    Expect(0, 129791, '\P{Blk: symbolsandpictographsexta}', "");
    Expect(1, 129791, '\P{^Blk: symbolsandpictographsexta}', "");
    Expect(0, 129792, '\p{Blk: symbolsandpictographsexta}', "");
    Expect(1, 129792, '\p{^Blk: symbolsandpictographsexta}', "");
    Expect(1, 129792, '\P{Blk: symbolsandpictographsexta}', "");
    Expect(0, 129792, '\P{^Blk: symbolsandpictographsexta}', "");
    Expect(1, 129791, '\p{Blk=:\Asymbolsandpictographsexta\z:}', "");;
    Expect(0, 129792, '\p{Blk=:\Asymbolsandpictographsexta\z:}', "");;
    Expect(1, 129791, '\p{Blk= SYMBOLS_AND_PICTOGRAPHS_ext_A}', "");
    Expect(0, 129791, '\p{^Blk= SYMBOLS_AND_PICTOGRAPHS_ext_A}', "");
    Expect(0, 129791, '\P{Blk= SYMBOLS_AND_PICTOGRAPHS_ext_A}', "");
    Expect(1, 129791, '\P{^Blk= SYMBOLS_AND_PICTOGRAPHS_ext_A}', "");
    Expect(0, 129792, '\p{Blk= SYMBOLS_AND_PICTOGRAPHS_ext_A}', "");
    Expect(1, 129792, '\p{^Blk= SYMBOLS_AND_PICTOGRAPHS_ext_A}', "");
    Expect(1, 129792, '\P{Blk= SYMBOLS_AND_PICTOGRAPHS_ext_A}', "");
    Expect(0, 129792, '\P{^Blk= SYMBOLS_AND_PICTOGRAPHS_ext_A}', "");
    Error('\p{Is_Block= 	Symbols_And_pictographs_EXTENDED_A:=}');
    Error('\P{Is_Block= 	Symbols_And_pictographs_EXTENDED_A:=}');
    Expect(1, 129791, '\p{Is_Block=symbolsandpictographsextendeda}', "");
    Expect(0, 129791, '\p{^Is_Block=symbolsandpictographsextendeda}', "");
    Expect(0, 129791, '\P{Is_Block=symbolsandpictographsextendeda}', "");
    Expect(1, 129791, '\P{^Is_Block=symbolsandpictographsextendeda}', "");
    Expect(0, 129792, '\p{Is_Block=symbolsandpictographsextendeda}', "");
    Expect(1, 129792, '\p{^Is_Block=symbolsandpictographsextendeda}', "");
    Expect(1, 129792, '\P{Is_Block=symbolsandpictographsextendeda}', "");
    Expect(0, 129792, '\P{^Is_Block=symbolsandpictographsextendeda}', "");
    Expect(1, 129791, '\p{Is_Block=_-Symbols_And_Pictographs_Extended_A}', "");
    Expect(0, 129791, '\p{^Is_Block=_-Symbols_And_Pictographs_Extended_A}', "");
    Expect(0, 129791, '\P{Is_Block=_-Symbols_And_Pictographs_Extended_A}', "");
    Expect(1, 129791, '\P{^Is_Block=_-Symbols_And_Pictographs_Extended_A}', "");
    Expect(0, 129792, '\p{Is_Block=_-Symbols_And_Pictographs_Extended_A}', "");
    Expect(1, 129792, '\p{^Is_Block=_-Symbols_And_Pictographs_Extended_A}', "");
    Expect(1, 129792, '\P{Is_Block=_-Symbols_And_Pictographs_Extended_A}', "");
    Expect(0, 129792, '\P{^Is_Block=_-Symbols_And_Pictographs_Extended_A}', "");
    Error('\p{Is_Blk: /a/symbols_AND_pictographs_Ext_A}');
    Error('\P{Is_Blk: /a/symbols_AND_pictographs_Ext_A}');
    Expect(1, 129791, '\p{Is_Blk=symbolsandpictographsexta}', "");
    Expect(0, 129791, '\p{^Is_Blk=symbolsandpictographsexta}', "");
    Expect(0, 129791, '\P{Is_Blk=symbolsandpictographsexta}', "");
    Expect(1, 129791, '\P{^Is_Blk=symbolsandpictographsexta}', "");
    Expect(0, 129792, '\p{Is_Blk=symbolsandpictographsexta}', "");
    Expect(1, 129792, '\p{^Is_Blk=symbolsandpictographsexta}', "");
    Expect(1, 129792, '\P{Is_Blk=symbolsandpictographsexta}', "");
    Expect(0, 129792, '\P{^Is_Blk=symbolsandpictographsexta}', "");
    Expect(1, 129791, '\p{Is_Blk=Symbols_AND_pictographs_EXT_a}', "");
    Expect(0, 129791, '\p{^Is_Blk=Symbols_AND_pictographs_EXT_a}', "");
    Expect(0, 129791, '\P{Is_Blk=Symbols_AND_pictographs_EXT_a}', "");
    Expect(1, 129791, '\P{^Is_Blk=Symbols_AND_pictographs_EXT_a}', "");
    Expect(0, 129792, '\p{Is_Blk=Symbols_AND_pictographs_EXT_a}', "");
    Expect(1, 129792, '\p{^Is_Blk=Symbols_AND_pictographs_EXT_a}', "");
    Expect(1, 129792, '\P{Is_Blk=Symbols_AND_pictographs_EXT_a}', "");
    Expect(0, 129792, '\P{^Is_Blk=Symbols_AND_pictographs_EXT_a}', "");
    Error('\p{Block=:=	 SYMBOLS_For_legacy_Computing}');
    Error('\P{Block=:=	 SYMBOLS_For_legacy_Computing}');
    Expect(1, 130047, '\p{Block=:\ASymbols_For_Legacy_Computing\z:}', "");;
    Expect(0, 130048, '\p{Block=:\ASymbols_For_Legacy_Computing\z:}', "");;
    Expect(1, 130047, '\p{Block=symbolsforlegacycomputing}', "");
    Expect(0, 130047, '\p{^Block=symbolsforlegacycomputing}', "");
    Expect(0, 130047, '\P{Block=symbolsforlegacycomputing}', "");
    Expect(1, 130047, '\P{^Block=symbolsforlegacycomputing}', "");
    Expect(0, 130048, '\p{Block=symbolsforlegacycomputing}', "");
    Expect(1, 130048, '\p{^Block=symbolsforlegacycomputing}', "");
    Expect(1, 130048, '\P{Block=symbolsforlegacycomputing}', "");
    Expect(0, 130048, '\P{^Block=symbolsforlegacycomputing}', "");
    Expect(1, 130047, '\p{Block=:\Asymbolsforlegacycomputing\z:}', "");;
    Expect(0, 130048, '\p{Block=:\Asymbolsforlegacycomputing\z:}', "");;
    Expect(1, 130047, '\p{Block=__Symbols_for_Legacy_Computing}', "");
    Expect(0, 130047, '\p{^Block=__Symbols_for_Legacy_Computing}', "");
    Expect(0, 130047, '\P{Block=__Symbols_for_Legacy_Computing}', "");
    Expect(1, 130047, '\P{^Block=__Symbols_for_Legacy_Computing}', "");
    Expect(0, 130048, '\p{Block=__Symbols_for_Legacy_Computing}', "");
    Expect(1, 130048, '\p{^Block=__Symbols_for_Legacy_Computing}', "");
    Expect(1, 130048, '\P{Block=__Symbols_for_Legacy_Computing}', "");
    Expect(0, 130048, '\P{^Block=__Symbols_for_Legacy_Computing}', "");
    Error('\p{Blk=/a/	-Symbols_FOR_Legacy_computing}');
    Error('\P{Blk=/a/	-Symbols_FOR_Legacy_computing}');
    Expect(1, 130047, '\p{Blk=:\ASymbols_For_Legacy_Computing\z:}', "");;
    Expect(0, 130048, '\p{Blk=:\ASymbols_For_Legacy_Computing\z:}', "");;
    Expect(1, 130047, '\p{Blk=symbolsforlegacycomputing}', "");
    Expect(0, 130047, '\p{^Blk=symbolsforlegacycomputing}', "");
    Expect(0, 130047, '\P{Blk=symbolsforlegacycomputing}', "");
    Expect(1, 130047, '\P{^Blk=symbolsforlegacycomputing}', "");
    Expect(0, 130048, '\p{Blk=symbolsforlegacycomputing}', "");
    Expect(1, 130048, '\p{^Blk=symbolsforlegacycomputing}', "");
    Expect(1, 130048, '\P{Blk=symbolsforlegacycomputing}', "");
    Expect(0, 130048, '\P{^Blk=symbolsforlegacycomputing}', "");
    Expect(1, 130047, '\p{Blk=:\Asymbolsforlegacycomputing\z:}', "");;
    Expect(0, 130048, '\p{Blk=:\Asymbolsforlegacycomputing\z:}', "");;
    Expect(1, 130047, '\p{Blk=	-SYMBOLS_For_Legacy_Computing}', "");
    Expect(0, 130047, '\p{^Blk=	-SYMBOLS_For_Legacy_Computing}', "");
    Expect(0, 130047, '\P{Blk=	-SYMBOLS_For_Legacy_Computing}', "");
    Expect(1, 130047, '\P{^Blk=	-SYMBOLS_For_Legacy_Computing}', "");
    Expect(0, 130048, '\p{Blk=	-SYMBOLS_For_Legacy_Computing}', "");
    Expect(1, 130048, '\p{^Blk=	-SYMBOLS_For_Legacy_Computing}', "");
    Expect(1, 130048, '\P{Blk=	-SYMBOLS_For_Legacy_Computing}', "");
    Expect(0, 130048, '\P{^Blk=	-SYMBOLS_For_Legacy_Computing}', "");
    Error('\p{Is_Block=/a/--symbols_For_legacy_Computing}');
    Error('\P{Is_Block=/a/--symbols_For_legacy_Computing}');
    Expect(1, 130047, '\p{Is_Block=symbolsforlegacycomputing}', "");
    Expect(0, 130047, '\p{^Is_Block=symbolsforlegacycomputing}', "");
    Expect(0, 130047, '\P{Is_Block=symbolsforlegacycomputing}', "");
    Expect(1, 130047, '\P{^Is_Block=symbolsforlegacycomputing}', "");
    Expect(0, 130048, '\p{Is_Block=symbolsforlegacycomputing}', "");
    Expect(1, 130048, '\p{^Is_Block=symbolsforlegacycomputing}', "");
    Expect(1, 130048, '\P{Is_Block=symbolsforlegacycomputing}', "");
    Expect(0, 130048, '\P{^Is_Block=symbolsforlegacycomputing}', "");
    Expect(1, 130047, '\p{Is_Block=	Symbols_for_Legacy_COMPUTING}', "");
    Expect(0, 130047, '\p{^Is_Block=	Symbols_for_Legacy_COMPUTING}', "");
    Expect(0, 130047, '\P{Is_Block=	Symbols_for_Legacy_COMPUTING}', "");
    Expect(1, 130047, '\P{^Is_Block=	Symbols_for_Legacy_COMPUTING}', "");
    Expect(0, 130048, '\p{Is_Block=	Symbols_for_Legacy_COMPUTING}', "");
    Expect(1, 130048, '\p{^Is_Block=	Symbols_for_Legacy_COMPUTING}', "");
    Expect(1, 130048, '\P{Is_Block=	Symbols_for_Legacy_COMPUTING}', "");
    Expect(0, 130048, '\P{^Is_Block=	Symbols_for_Legacy_COMPUTING}', "");
    Error('\p{Is_Blk=:= -symbols_For_LEGACY_computing}');
    Error('\P{Is_Blk=:= -symbols_For_LEGACY_computing}');
    Expect(1, 130047, '\p{Is_Blk=symbolsforlegacycomputing}', "");
    Expect(0, 130047, '\p{^Is_Blk=symbolsforlegacycomputing}', "");
    Expect(0, 130047, '\P{Is_Blk=symbolsforlegacycomputing}', "");
    Expect(1, 130047, '\P{^Is_Blk=symbolsforlegacycomputing}', "");
    Expect(0, 130048, '\p{Is_Blk=symbolsforlegacycomputing}', "");
    Expect(1, 130048, '\p{^Is_Blk=symbolsforlegacycomputing}', "");
    Expect(1, 130048, '\P{Is_Blk=symbolsforlegacycomputing}', "");
    Expect(0, 130048, '\P{^Is_Blk=symbolsforlegacycomputing}', "");
    Expect(1, 130047, '\p{Is_Blk=-	Symbols_FOR_legacy_computing}', "");
    Expect(0, 130047, '\p{^Is_Blk=-	Symbols_FOR_legacy_computing}', "");
    Expect(0, 130047, '\P{Is_Blk=-	Symbols_FOR_legacy_computing}', "");
    Expect(1, 130047, '\P{^Is_Blk=-	Symbols_FOR_legacy_computing}', "");
    Expect(0, 130048, '\p{Is_Blk=-	Symbols_FOR_legacy_computing}', "");
    Expect(1, 130048, '\p{^Is_Blk=-	Symbols_FOR_legacy_computing}', "");
    Expect(1, 130048, '\P{Is_Blk=-	Symbols_FOR_legacy_computing}', "");
    Expect(0, 130048, '\P{^Is_Blk=-	Symbols_FOR_legacy_computing}', "");
    Error('\p{Block=	-syriac/a/}');
    Error('\P{Block=	-syriac/a/}');
    Expect(1, 1871, '\p{Block=:\ASyriac\z:}', "");;
    Expect(0, 1872, '\p{Block=:\ASyriac\z:}', "");;
    Expect(1, 1871, '\p{Block=syriac}', "");
    Expect(0, 1871, '\p{^Block=syriac}', "");
    Expect(0, 1871, '\P{Block=syriac}', "");
    Expect(1, 1871, '\P{^Block=syriac}', "");
    Expect(0, 1872, '\p{Block=syriac}', "");
    Expect(1, 1872, '\p{^Block=syriac}', "");
    Expect(1, 1872, '\P{Block=syriac}', "");
    Expect(0, 1872, '\P{^Block=syriac}', "");
    Expect(1, 1871, '\p{Block=:\Asyriac\z:}', "");;
    Expect(0, 1872, '\p{Block=:\Asyriac\z:}', "");;
    Expect(1, 1871, '\p{Block=Syriac}', "");
    Expect(0, 1871, '\p{^Block=Syriac}', "");
    Expect(0, 1871, '\P{Block=Syriac}', "");
    Expect(1, 1871, '\P{^Block=Syriac}', "");
    Expect(0, 1872, '\p{Block=Syriac}', "");
    Expect(1, 1872, '\p{^Block=Syriac}', "");
    Expect(1, 1872, '\P{Block=Syriac}', "");
    Expect(0, 1872, '\P{^Block=Syriac}', "");
    Error('\p{Blk=:= -SYRIAC}');
    Error('\P{Blk=:= -SYRIAC}');
    Expect(1, 1871, '\p{Blk=:\ASyriac\z:}', "");;
    Expect(0, 1872, '\p{Blk=:\ASyriac\z:}', "");;
    Expect(1, 1871, '\p{Blk=syriac}', "");
    Expect(0, 1871, '\p{^Blk=syriac}', "");
    Expect(0, 1871, '\P{Blk=syriac}', "");
    Expect(1, 1871, '\P{^Blk=syriac}', "");
    Expect(0, 1872, '\p{Blk=syriac}', "");
    Expect(1, 1872, '\p{^Blk=syriac}', "");
    Expect(1, 1872, '\P{Blk=syriac}', "");
    Expect(0, 1872, '\P{^Blk=syriac}', "");
    Expect(1, 1871, '\p{Blk=:\Asyriac\z:}', "");;
    Expect(0, 1872, '\p{Blk=:\Asyriac\z:}', "");;
    Expect(1, 1871, '\p{Blk=_Syriac}', "");
    Expect(0, 1871, '\p{^Blk=_Syriac}', "");
    Expect(0, 1871, '\P{Blk=_Syriac}', "");
    Expect(1, 1871, '\P{^Blk=_Syriac}', "");
    Expect(0, 1872, '\p{Blk=_Syriac}', "");
    Expect(1, 1872, '\p{^Blk=_Syriac}', "");
    Expect(1, 1872, '\P{Blk=_Syriac}', "");
    Expect(0, 1872, '\P{^Blk=_Syriac}', "");
    Error('\p{Is_Block=	:=Syriac}');
    Error('\P{Is_Block=	:=Syriac}');
    Expect(1, 1871, '\p{Is_Block=syriac}', "");
    Expect(0, 1871, '\p{^Is_Block=syriac}', "");
    Expect(0, 1871, '\P{Is_Block=syriac}', "");
    Expect(1, 1871, '\P{^Is_Block=syriac}', "");
    Expect(0, 1872, '\p{Is_Block=syriac}', "");
    Expect(1, 1872, '\p{^Is_Block=syriac}', "");
    Expect(1, 1872, '\P{Is_Block=syriac}', "");
    Expect(0, 1872, '\P{^Is_Block=syriac}', "");
    Error('\p{Is_Blk=_/a/Syriac}');
    Error('\P{Is_Blk=_/a/Syriac}');
    Expect(1, 1871, '\p{Is_Blk=syriac}', "");
    Expect(0, 1871, '\p{^Is_Blk=syriac}', "");
    Expect(0, 1871, '\P{Is_Blk=syriac}', "");
    Expect(1, 1871, '\P{^Is_Blk=syriac}', "");
    Expect(0, 1872, '\p{Is_Blk=syriac}', "");
    Expect(1, 1872, '\p{^Is_Blk=syriac}', "");
    Expect(1, 1872, '\P{Is_Blk=syriac}', "");
    Expect(0, 1872, '\P{^Is_Blk=syriac}', "");
    Expect(1, 1871, '\p{Is_Blk=		syriac}', "");
    Expect(0, 1871, '\p{^Is_Blk=		syriac}', "");
    Expect(0, 1871, '\P{Is_Blk=		syriac}', "");
    Expect(1, 1871, '\P{^Is_Blk=		syriac}', "");
    Expect(0, 1872, '\p{Is_Blk=		syriac}', "");
    Expect(1, 1872, '\p{^Is_Blk=		syriac}', "");
    Expect(1, 1872, '\P{Is_Blk=		syriac}', "");
    Expect(0, 1872, '\P{^Is_Blk=		syriac}', "");
    Error('\p{Block=/a/SYRIAC_Supplement}');
    Error('\P{Block=/a/SYRIAC_Supplement}');
    Expect(1, 2159, '\p{Block=:\ASyriac_Supplement\z:}', "");;
    Expect(0, 2160, '\p{Block=:\ASyriac_Supplement\z:}', "");;
    Expect(1, 2159, '\p{Block=syriacsupplement}', "");
    Expect(0, 2159, '\p{^Block=syriacsupplement}', "");
    Expect(0, 2159, '\P{Block=syriacsupplement}', "");
    Expect(1, 2159, '\P{^Block=syriacsupplement}', "");
    Expect(0, 2160, '\p{Block=syriacsupplement}', "");
    Expect(1, 2160, '\p{^Block=syriacsupplement}', "");
    Expect(1, 2160, '\P{Block=syriacsupplement}', "");
    Expect(0, 2160, '\P{^Block=syriacsupplement}', "");
    Expect(1, 2159, '\p{Block=:\Asyriacsupplement\z:}', "");;
    Expect(0, 2160, '\p{Block=:\Asyriacsupplement\z:}', "");;
    Expect(1, 2159, '\p{Block:   --Syriac_Supplement}', "");
    Expect(0, 2159, '\p{^Block:   --Syriac_Supplement}', "");
    Expect(0, 2159, '\P{Block:   --Syriac_Supplement}', "");
    Expect(1, 2159, '\P{^Block:   --Syriac_Supplement}', "");
    Expect(0, 2160, '\p{Block:   --Syriac_Supplement}', "");
    Expect(1, 2160, '\p{^Block:   --Syriac_Supplement}', "");
    Expect(1, 2160, '\P{Block:   --Syriac_Supplement}', "");
    Expect(0, 2160, '\P{^Block:   --Syriac_Supplement}', "");
    Error('\p{Blk: -Syriac_sup:=}');
    Error('\P{Blk: -Syriac_sup:=}');
    Expect(1, 2159, '\p{Blk=:\ASyriac_Sup\z:}', "");;
    Expect(0, 2160, '\p{Blk=:\ASyriac_Sup\z:}', "");;
    Expect(1, 2159, '\p{Blk=syriacsup}', "");
    Expect(0, 2159, '\p{^Blk=syriacsup}', "");
    Expect(0, 2159, '\P{Blk=syriacsup}', "");
    Expect(1, 2159, '\P{^Blk=syriacsup}', "");
    Expect(0, 2160, '\p{Blk=syriacsup}', "");
    Expect(1, 2160, '\p{^Blk=syriacsup}', "");
    Expect(1, 2160, '\P{Blk=syriacsup}', "");
    Expect(0, 2160, '\P{^Blk=syriacsup}', "");
    Expect(1, 2159, '\p{Blk=:\Asyriacsup\z:}', "");;
    Expect(0, 2160, '\p{Blk=:\Asyriacsup\z:}', "");;
    Expect(1, 2159, '\p{Blk=syriac_Sup}', "");
    Expect(0, 2159, '\p{^Blk=syriac_Sup}', "");
    Expect(0, 2159, '\P{Blk=syriac_Sup}', "");
    Expect(1, 2159, '\P{^Blk=syriac_Sup}', "");
    Expect(0, 2160, '\p{Blk=syriac_Sup}', "");
    Expect(1, 2160, '\p{^Blk=syriac_Sup}', "");
    Expect(1, 2160, '\P{Blk=syriac_Sup}', "");
    Expect(0, 2160, '\P{^Blk=syriac_Sup}', "");
    Error('\p{Is_Block=:= _Syriac_Supplement}');
    Error('\P{Is_Block=:= _Syriac_Supplement}');
    Expect(1, 2159, '\p{Is_Block=syriacsupplement}', "");
    Expect(0, 2159, '\p{^Is_Block=syriacsupplement}', "");
    Expect(0, 2159, '\P{Is_Block=syriacsupplement}', "");
    Expect(1, 2159, '\P{^Is_Block=syriacsupplement}', "");
    Expect(0, 2160, '\p{Is_Block=syriacsupplement}', "");
    Expect(1, 2160, '\p{^Is_Block=syriacsupplement}', "");
    Expect(1, 2160, '\P{Is_Block=syriacsupplement}', "");
    Expect(0, 2160, '\P{^Is_Block=syriacsupplement}', "");
    Expect(1, 2159, '\p{Is_Block=		Syriac_SUPPLEMENT}', "");
    Expect(0, 2159, '\p{^Is_Block=		Syriac_SUPPLEMENT}', "");
    Expect(0, 2159, '\P{Is_Block=		Syriac_SUPPLEMENT}', "");
    Expect(1, 2159, '\P{^Is_Block=		Syriac_SUPPLEMENT}', "");
    Expect(0, 2160, '\p{Is_Block=		Syriac_SUPPLEMENT}', "");
    Expect(1, 2160, '\p{^Is_Block=		Syriac_SUPPLEMENT}', "");
    Expect(1, 2160, '\P{Is_Block=		Syriac_SUPPLEMENT}', "");
    Expect(0, 2160, '\P{^Is_Block=		Syriac_SUPPLEMENT}', "");
    Error('\p{Is_Blk=:= -SYRIAC_SUP}');
    Error('\P{Is_Blk=:= -SYRIAC_SUP}');
    Expect(1, 2159, '\p{Is_Blk=syriacsup}', "");
    Expect(0, 2159, '\p{^Is_Blk=syriacsup}', "");
    Expect(0, 2159, '\P{Is_Blk=syriacsup}', "");
    Expect(1, 2159, '\P{^Is_Blk=syriacsup}', "");
    Expect(0, 2160, '\p{Is_Blk=syriacsup}', "");
    Expect(1, 2160, '\p{^Is_Blk=syriacsup}', "");
    Expect(1, 2160, '\P{Is_Blk=syriacsup}', "");
    Expect(0, 2160, '\P{^Is_Blk=syriacsup}', "");
    Expect(1, 2159, '\p{Is_Blk=	syriac_sup}', "");
    Expect(0, 2159, '\p{^Is_Blk=	syriac_sup}', "");
    Expect(0, 2159, '\P{Is_Blk=	syriac_sup}', "");
    Expect(1, 2159, '\P{^Is_Blk=	syriac_sup}', "");
    Expect(0, 2160, '\p{Is_Blk=	syriac_sup}', "");
    Expect(1, 2160, '\p{^Is_Blk=	syriac_sup}', "");
    Expect(1, 2160, '\P{Is_Blk=	syriac_sup}', "");
    Expect(0, 2160, '\P{^Is_Blk=	syriac_sup}', "");
    Error('\p{Block=/a/-_Tagalog}');
    Error('\P{Block=/a/-_Tagalog}');
    Expect(1, 5919, '\p{Block=:\ATagalog\z:}', "");;
    Expect(0, 5920, '\p{Block=:\ATagalog\z:}', "");;
    Expect(1, 5919, '\p{Block=tagalog}', "");
    Expect(0, 5919, '\p{^Block=tagalog}', "");
    Expect(0, 5919, '\P{Block=tagalog}', "");
    Expect(1, 5919, '\P{^Block=tagalog}', "");
    Expect(0, 5920, '\p{Block=tagalog}', "");
    Expect(1, 5920, '\p{^Block=tagalog}', "");
    Expect(1, 5920, '\P{Block=tagalog}', "");
    Expect(0, 5920, '\P{^Block=tagalog}', "");
    Expect(1, 5919, '\p{Block=:\Atagalog\z:}', "");;
    Expect(0, 5920, '\p{Block=:\Atagalog\z:}', "");;
    Expect(1, 5919, '\p{Block=		Tagalog}', "");
    Expect(0, 5919, '\p{^Block=		Tagalog}', "");
    Expect(0, 5919, '\P{Block=		Tagalog}', "");
    Expect(1, 5919, '\P{^Block=		Tagalog}', "");
    Expect(0, 5920, '\p{Block=		Tagalog}', "");
    Expect(1, 5920, '\p{^Block=		Tagalog}', "");
    Expect(1, 5920, '\P{Block=		Tagalog}', "");
    Expect(0, 5920, '\P{^Block=		Tagalog}', "");
    Error('\p{Blk=-Tagalog:=}');
    Error('\P{Blk=-Tagalog:=}');
    Expect(1, 5919, '\p{Blk=:\ATagalog\z:}', "");;
    Expect(0, 5920, '\p{Blk=:\ATagalog\z:}', "");;
    Expect(1, 5919, '\p{Blk=tagalog}', "");
    Expect(0, 5919, '\p{^Blk=tagalog}', "");
    Expect(0, 5919, '\P{Blk=tagalog}', "");
    Expect(1, 5919, '\P{^Blk=tagalog}', "");
    Expect(0, 5920, '\p{Blk=tagalog}', "");
    Expect(1, 5920, '\p{^Blk=tagalog}', "");
    Expect(1, 5920, '\P{Blk=tagalog}', "");
    Expect(0, 5920, '\P{^Blk=tagalog}', "");
    Expect(1, 5919, '\p{Blk=:\Atagalog\z:}', "");;
    Expect(0, 5920, '\p{Blk=:\Atagalog\z:}', "");;
    Expect(1, 5919, '\p{Blk= -TAGALOG}', "");
    Expect(0, 5919, '\p{^Blk= -TAGALOG}', "");
    Expect(0, 5919, '\P{Blk= -TAGALOG}', "");
    Expect(1, 5919, '\P{^Blk= -TAGALOG}', "");
    Expect(0, 5920, '\p{Blk= -TAGALOG}', "");
    Expect(1, 5920, '\p{^Blk= -TAGALOG}', "");
    Expect(1, 5920, '\P{Blk= -TAGALOG}', "");
    Expect(0, 5920, '\P{^Blk= -TAGALOG}', "");
    Error('\p{Is_Block=/a/	-Tagalog}');
    Error('\P{Is_Block=/a/	-Tagalog}');
    Expect(1, 5919, '\p{Is_Block=tagalog}', "");
    Expect(0, 5919, '\p{^Is_Block=tagalog}', "");
    Expect(0, 5919, '\P{Is_Block=tagalog}', "");
    Expect(1, 5919, '\P{^Is_Block=tagalog}', "");
    Expect(0, 5920, '\p{Is_Block=tagalog}', "");
    Expect(1, 5920, '\p{^Is_Block=tagalog}', "");
    Expect(1, 5920, '\P{Is_Block=tagalog}', "");
    Expect(0, 5920, '\P{^Is_Block=tagalog}', "");
    Expect(1, 5919, '\p{Is_Block=  tagalog}', "");
    Expect(0, 5919, '\p{^Is_Block=  tagalog}', "");
    Expect(0, 5919, '\P{Is_Block=  tagalog}', "");
    Expect(1, 5919, '\P{^Is_Block=  tagalog}', "");
    Expect(0, 5920, '\p{Is_Block=  tagalog}', "");
    Expect(1, 5920, '\p{^Is_Block=  tagalog}', "");
    Expect(1, 5920, '\P{Is_Block=  tagalog}', "");
    Expect(0, 5920, '\P{^Is_Block=  tagalog}', "");
    Error('\p{Is_Blk=:=_	Tagalog}');
    Error('\P{Is_Blk=:=_	Tagalog}');
    Expect(1, 5919, '\p{Is_Blk=tagalog}', "");
    Expect(0, 5919, '\p{^Is_Blk=tagalog}', "");
    Expect(0, 5919, '\P{Is_Blk=tagalog}', "");
    Expect(1, 5919, '\P{^Is_Blk=tagalog}', "");
    Expect(0, 5920, '\p{Is_Blk=tagalog}', "");
    Expect(1, 5920, '\p{^Is_Blk=tagalog}', "");
    Expect(1, 5920, '\P{Is_Blk=tagalog}', "");
    Expect(0, 5920, '\P{^Is_Blk=tagalog}', "");
    Expect(1, 5919, '\p{Is_Blk=__tagalog}', "");
    Expect(0, 5919, '\p{^Is_Blk=__tagalog}', "");
    Expect(0, 5919, '\P{Is_Blk=__tagalog}', "");
    Expect(1, 5919, '\P{^Is_Blk=__tagalog}', "");
    Expect(0, 5920, '\p{Is_Blk=__tagalog}', "");
    Expect(1, 5920, '\p{^Is_Blk=__tagalog}', "");
    Expect(1, 5920, '\P{Is_Blk=__tagalog}', "");
    Expect(0, 5920, '\P{^Is_Blk=__tagalog}', "");
    Error('\p{Block=_TAGBANWA:=}');
    Error('\P{Block=_TAGBANWA:=}');
    Expect(1, 6015, '\p{Block=:\ATagbanwa\z:}', "");;
    Expect(0, 6016, '\p{Block=:\ATagbanwa\z:}', "");;
    Expect(1, 6015, '\p{Block=tagbanwa}', "");
    Expect(0, 6015, '\p{^Block=tagbanwa}', "");
    Expect(0, 6015, '\P{Block=tagbanwa}', "");
    Expect(1, 6015, '\P{^Block=tagbanwa}', "");
    Expect(0, 6016, '\p{Block=tagbanwa}', "");
    Expect(1, 6016, '\p{^Block=tagbanwa}', "");
    Expect(1, 6016, '\P{Block=tagbanwa}', "");
    Expect(0, 6016, '\P{^Block=tagbanwa}', "");
    Expect(1, 6015, '\p{Block=:\Atagbanwa\z:}', "");;
    Expect(0, 6016, '\p{Block=:\Atagbanwa\z:}', "");;
    Expect(1, 6015, '\p{Block=	 TAGBANWA}', "");
    Expect(0, 6015, '\p{^Block=	 TAGBANWA}', "");
    Expect(0, 6015, '\P{Block=	 TAGBANWA}', "");
    Expect(1, 6015, '\P{^Block=	 TAGBANWA}', "");
    Expect(0, 6016, '\p{Block=	 TAGBANWA}', "");
    Expect(1, 6016, '\p{^Block=	 TAGBANWA}', "");
    Expect(1, 6016, '\P{Block=	 TAGBANWA}', "");
    Expect(0, 6016, '\P{^Block=	 TAGBANWA}', "");
    Error('\p{Blk:-:=TAGBANWA}');
    Error('\P{Blk:-:=TAGBANWA}');
    Expect(1, 6015, '\p{Blk=:\ATagbanwa\z:}', "");;
    Expect(0, 6016, '\p{Blk=:\ATagbanwa\z:}', "");;
    Expect(1, 6015, '\p{Blk=tagbanwa}', "");
    Expect(0, 6015, '\p{^Blk=tagbanwa}', "");
    Expect(0, 6015, '\P{Blk=tagbanwa}', "");
    Expect(1, 6015, '\P{^Blk=tagbanwa}', "");
    Expect(0, 6016, '\p{Blk=tagbanwa}', "");
    Expect(1, 6016, '\p{^Blk=tagbanwa}', "");
    Expect(1, 6016, '\P{Blk=tagbanwa}', "");
    Expect(0, 6016, '\P{^Blk=tagbanwa}', "");
    Expect(1, 6015, '\p{Blk=:\Atagbanwa\z:}', "");;
    Expect(0, 6016, '\p{Blk=:\Atagbanwa\z:}', "");;
    Expect(1, 6015, '\p{Blk=_ TAGBANWA}', "");
    Expect(0, 6015, '\p{^Blk=_ TAGBANWA}', "");
    Expect(0, 6015, '\P{Blk=_ TAGBANWA}', "");
    Expect(1, 6015, '\P{^Blk=_ TAGBANWA}', "");
    Expect(0, 6016, '\p{Blk=_ TAGBANWA}', "");
    Expect(1, 6016, '\p{^Blk=_ TAGBANWA}', "");
    Expect(1, 6016, '\P{Blk=_ TAGBANWA}', "");
    Expect(0, 6016, '\P{^Blk=_ TAGBANWA}', "");
    Error('\p{Is_Block=-/a/tagbanwa}');
    Error('\P{Is_Block=-/a/tagbanwa}');
    Expect(1, 6015, '\p{Is_Block: tagbanwa}', "");
    Expect(0, 6015, '\p{^Is_Block: tagbanwa}', "");
    Expect(0, 6015, '\P{Is_Block: tagbanwa}', "");
    Expect(1, 6015, '\P{^Is_Block: tagbanwa}', "");
    Expect(0, 6016, '\p{Is_Block: tagbanwa}', "");
    Expect(1, 6016, '\p{^Is_Block: tagbanwa}', "");
    Expect(1, 6016, '\P{Is_Block: tagbanwa}', "");
    Expect(0, 6016, '\P{^Is_Block: tagbanwa}', "");
    Expect(1, 6015, '\p{Is_Block=		TAGBANWA}', "");
    Expect(0, 6015, '\p{^Is_Block=		TAGBANWA}', "");
    Expect(0, 6015, '\P{Is_Block=		TAGBANWA}', "");
    Expect(1, 6015, '\P{^Is_Block=		TAGBANWA}', "");
    Expect(0, 6016, '\p{Is_Block=		TAGBANWA}', "");
    Expect(1, 6016, '\p{^Is_Block=		TAGBANWA}', "");
    Expect(1, 6016, '\P{Is_Block=		TAGBANWA}', "");
    Expect(0, 6016, '\P{^Is_Block=		TAGBANWA}', "");
    Error('\p{Is_Blk=:=	TAGBANWA}');
    Error('\P{Is_Blk=:=	TAGBANWA}');
    Expect(1, 6015, '\p{Is_Blk=tagbanwa}', "");
    Expect(0, 6015, '\p{^Is_Blk=tagbanwa}', "");
    Expect(0, 6015, '\P{Is_Blk=tagbanwa}', "");
    Expect(1, 6015, '\P{^Is_Blk=tagbanwa}', "");
    Expect(0, 6016, '\p{Is_Blk=tagbanwa}', "");
    Expect(1, 6016, '\p{^Is_Blk=tagbanwa}', "");
    Expect(1, 6016, '\P{Is_Blk=tagbanwa}', "");
    Expect(0, 6016, '\P{^Is_Blk=tagbanwa}', "");
    Expect(1, 6015, '\p{Is_Blk= -Tagbanwa}', "");
    Expect(0, 6015, '\p{^Is_Blk= -Tagbanwa}', "");
    Expect(0, 6015, '\P{Is_Blk= -Tagbanwa}', "");
    Expect(1, 6015, '\P{^Is_Blk= -Tagbanwa}', "");
    Expect(0, 6016, '\p{Is_Blk= -Tagbanwa}', "");
    Expect(1, 6016, '\p{^Is_Blk= -Tagbanwa}', "");
    Expect(1, 6016, '\P{Is_Blk= -Tagbanwa}', "");
    Expect(0, 6016, '\P{^Is_Blk= -Tagbanwa}', "");
    Error('\p{Block=  tags/a/}');
    Error('\P{Block=  tags/a/}');
    Expect(1, 917631, '\p{Block=:\ATags\z:}', "");;
    Expect(0, 917632, '\p{Block=:\ATags\z:}', "");;
    Expect(1, 917631, '\p{Block=tags}', "");
    Expect(0, 917631, '\p{^Block=tags}', "");
    Expect(0, 917631, '\P{Block=tags}', "");
    Expect(1, 917631, '\P{^Block=tags}', "");
    Expect(0, 917632, '\p{Block=tags}', "");
    Expect(1, 917632, '\p{^Block=tags}', "");
    Expect(1, 917632, '\P{Block=tags}', "");
    Expect(0, 917632, '\P{^Block=tags}', "");
    Expect(1, 917631, '\p{Block=:\Atags\z:}', "");;
    Expect(0, 917632, '\p{Block=:\Atags\z:}', "");;
    Expect(1, 917631, '\p{Block=	-Tags}', "");
    Expect(0, 917631, '\p{^Block=	-Tags}', "");
    Expect(0, 917631, '\P{Block=	-Tags}', "");
    Expect(1, 917631, '\P{^Block=	-Tags}', "");
    Expect(0, 917632, '\p{Block=	-Tags}', "");
    Expect(1, 917632, '\p{^Block=	-Tags}', "");
    Expect(1, 917632, '\P{Block=	-Tags}', "");
    Expect(0, 917632, '\P{^Block=	-Tags}', "");
    Error('\p{Blk=:=	TAGS}');
    Error('\P{Blk=:=	TAGS}');
    Expect(1, 917631, '\p{Blk=:\ATags\z:}', "");;
    Expect(0, 917632, '\p{Blk=:\ATags\z:}', "");;
    Expect(1, 917631, '\p{Blk=tags}', "");
    Expect(0, 917631, '\p{^Blk=tags}', "");
    Expect(0, 917631, '\P{Blk=tags}', "");
    Expect(1, 917631, '\P{^Blk=tags}', "");
    Expect(0, 917632, '\p{Blk=tags}', "");
    Expect(1, 917632, '\p{^Blk=tags}', "");
    Expect(1, 917632, '\P{Blk=tags}', "");
    Expect(0, 917632, '\P{^Blk=tags}', "");
    Expect(1, 917631, '\p{Blk=:\Atags\z:}', "");;
    Expect(0, 917632, '\p{Blk=:\Atags\z:}', "");;
    Expect(1, 917631, '\p{Blk=-Tags}', "");
    Expect(0, 917631, '\p{^Blk=-Tags}', "");
    Expect(0, 917631, '\P{Blk=-Tags}', "");
    Expect(1, 917631, '\P{^Blk=-Tags}', "");
    Expect(0, 917632, '\p{Blk=-Tags}', "");
    Expect(1, 917632, '\p{^Blk=-Tags}', "");
    Expect(1, 917632, '\P{Blk=-Tags}', "");
    Expect(0, 917632, '\P{^Blk=-Tags}', "");
    Error('\p{Is_Block=-:=tags}');
    Error('\P{Is_Block=-:=tags}');
    Expect(1, 917631, '\p{Is_Block:tags}', "");
    Expect(0, 917631, '\p{^Is_Block:tags}', "");
    Expect(0, 917631, '\P{Is_Block:tags}', "");
    Expect(1, 917631, '\P{^Is_Block:tags}', "");
    Expect(0, 917632, '\p{Is_Block:tags}', "");
    Expect(1, 917632, '\p{^Is_Block:tags}', "");
    Expect(1, 917632, '\P{Is_Block:tags}', "");
    Expect(0, 917632, '\P{^Is_Block:tags}', "");
    Expect(1, 917631, '\p{Is_Block= Tags}', "");
    Expect(0, 917631, '\p{^Is_Block= Tags}', "");
    Expect(0, 917631, '\P{Is_Block= Tags}', "");
    Expect(1, 917631, '\P{^Is_Block= Tags}', "");
    Expect(0, 917632, '\p{Is_Block= Tags}', "");
    Expect(1, 917632, '\p{^Is_Block= Tags}', "");
    Expect(1, 917632, '\P{Is_Block= Tags}', "");
    Expect(0, 917632, '\P{^Is_Block= Tags}', "");
    Error('\p{Is_Blk=/a/	Tags}');
    Error('\P{Is_Blk=/a/	Tags}');
    Expect(1, 917631, '\p{Is_Blk=tags}', "");
    Expect(0, 917631, '\p{^Is_Blk=tags}', "");
    Expect(0, 917631, '\P{Is_Blk=tags}', "");
    Expect(1, 917631, '\P{^Is_Blk=tags}', "");
    Expect(0, 917632, '\p{Is_Blk=tags}', "");
    Expect(1, 917632, '\p{^Is_Blk=tags}', "");
    Expect(1, 917632, '\P{Is_Blk=tags}', "");
    Expect(0, 917632, '\P{^Is_Blk=tags}', "");
    Expect(1, 917631, '\p{Is_Blk= 	TAGS}', "");
    Expect(0, 917631, '\p{^Is_Blk= 	TAGS}', "");
    Expect(0, 917631, '\P{Is_Blk= 	TAGS}', "");
    Expect(1, 917631, '\P{^Is_Blk= 	TAGS}', "");
    Expect(0, 917632, '\p{Is_Blk= 	TAGS}', "");
    Expect(1, 917632, '\p{^Is_Blk= 	TAGS}', "");
    Expect(1, 917632, '\P{Is_Blk= 	TAGS}', "");
    Expect(0, 917632, '\P{^Is_Blk= 	TAGS}', "");
    Error('\p{Block=:=  Tai_Le}');
    Error('\P{Block=:=  Tai_Le}');
    Expect(1, 6527, '\p{Block=:\ATai_Le\z:}', "");;
    Expect(0, 6528, '\p{Block=:\ATai_Le\z:}', "");;
    Expect(1, 6527, '\p{Block=taile}', "");
    Expect(0, 6527, '\p{^Block=taile}', "");
    Expect(0, 6527, '\P{Block=taile}', "");
    Expect(1, 6527, '\P{^Block=taile}', "");
    Expect(0, 6528, '\p{Block=taile}', "");
    Expect(1, 6528, '\p{^Block=taile}', "");
    Expect(1, 6528, '\P{Block=taile}', "");
    Expect(0, 6528, '\P{^Block=taile}', "");
    Expect(1, 6527, '\p{Block=:\Ataile\z:}', "");;
    Expect(0, 6528, '\p{Block=:\Ataile\z:}', "");;
    Expect(1, 6527, '\p{Block=-	Tai_Le}', "");
    Expect(0, 6527, '\p{^Block=-	Tai_Le}', "");
    Expect(0, 6527, '\P{Block=-	Tai_Le}', "");
    Expect(1, 6527, '\P{^Block=-	Tai_Le}', "");
    Expect(0, 6528, '\p{Block=-	Tai_Le}', "");
    Expect(1, 6528, '\p{^Block=-	Tai_Le}', "");
    Expect(1, 6528, '\P{Block=-	Tai_Le}', "");
    Expect(0, 6528, '\P{^Block=-	Tai_Le}', "");
    Error('\p{Blk=_-TAI_Le/a/}');
    Error('\P{Blk=_-TAI_Le/a/}');
    Expect(1, 6527, '\p{Blk=:\ATai_Le\z:}', "");;
    Expect(0, 6528, '\p{Blk=:\ATai_Le\z:}', "");;
    Expect(1, 6527, '\p{Blk=taile}', "");
    Expect(0, 6527, '\p{^Blk=taile}', "");
    Expect(0, 6527, '\P{Blk=taile}', "");
    Expect(1, 6527, '\P{^Blk=taile}', "");
    Expect(0, 6528, '\p{Blk=taile}', "");
    Expect(1, 6528, '\p{^Blk=taile}', "");
    Expect(1, 6528, '\P{Blk=taile}', "");
    Expect(0, 6528, '\P{^Blk=taile}', "");
    Expect(1, 6527, '\p{Blk=:\Ataile\z:}', "");;
    Expect(0, 6528, '\p{Blk=:\Ataile\z:}', "");;
    Expect(1, 6527, '\p{Blk=_ Tai_le}', "");
    Expect(0, 6527, '\p{^Blk=_ Tai_le}', "");
    Expect(0, 6527, '\P{Blk=_ Tai_le}', "");
    Expect(1, 6527, '\P{^Blk=_ Tai_le}', "");
    Expect(0, 6528, '\p{Blk=_ Tai_le}', "");
    Expect(1, 6528, '\p{^Blk=_ Tai_le}', "");
    Expect(1, 6528, '\P{Blk=_ Tai_le}', "");
    Expect(0, 6528, '\P{^Blk=_ Tai_le}', "");
    Error('\p{Is_Block=_-tai_Le/a/}');
    Error('\P{Is_Block=_-tai_Le/a/}');
    Expect(1, 6527, '\p{Is_Block=taile}', "");
    Expect(0, 6527, '\p{^Is_Block=taile}', "");
    Expect(0, 6527, '\P{Is_Block=taile}', "");
    Expect(1, 6527, '\P{^Is_Block=taile}', "");
    Expect(0, 6528, '\p{Is_Block=taile}', "");
    Expect(1, 6528, '\p{^Is_Block=taile}', "");
    Expect(1, 6528, '\P{Is_Block=taile}', "");
    Expect(0, 6528, '\P{^Is_Block=taile}', "");
    Expect(1, 6527, '\p{Is_Block=_ Tai_LE}', "");
    Expect(0, 6527, '\p{^Is_Block=_ Tai_LE}', "");
    Expect(0, 6527, '\P{Is_Block=_ Tai_LE}', "");
    Expect(1, 6527, '\P{^Is_Block=_ Tai_LE}', "");
    Expect(0, 6528, '\p{Is_Block=_ Tai_LE}', "");
    Expect(1, 6528, '\p{^Is_Block=_ Tai_LE}', "");
    Expect(1, 6528, '\P{Is_Block=_ Tai_LE}', "");
    Expect(0, 6528, '\P{^Is_Block=_ Tai_LE}', "");
    Error('\p{Is_Blk=--TAI_LE/a/}');
    Error('\P{Is_Blk=--TAI_LE/a/}');
    Expect(1, 6527, '\p{Is_Blk=taile}', "");
    Expect(0, 6527, '\p{^Is_Blk=taile}', "");
    Expect(0, 6527, '\P{Is_Blk=taile}', "");
    Expect(1, 6527, '\P{^Is_Blk=taile}', "");
    Expect(0, 6528, '\p{Is_Blk=taile}', "");
    Expect(1, 6528, '\p{^Is_Blk=taile}', "");
    Expect(1, 6528, '\P{Is_Blk=taile}', "");
    Expect(0, 6528, '\P{^Is_Blk=taile}', "");
    Expect(1, 6527, '\p{Is_Blk=Tai_Le}', "");
    Expect(0, 6527, '\p{^Is_Blk=Tai_Le}', "");
    Expect(0, 6527, '\P{Is_Blk=Tai_Le}', "");
    Expect(1, 6527, '\P{^Is_Blk=Tai_Le}', "");
    Expect(0, 6528, '\p{Is_Blk=Tai_Le}', "");
    Expect(1, 6528, '\p{^Is_Blk=Tai_Le}', "");
    Expect(1, 6528, '\P{Is_Blk=Tai_Le}', "");
    Expect(0, 6528, '\P{^Is_Blk=Tai_Le}', "");
    Error('\p{Block=:=-Tai_Tham}');
    Error('\P{Block=:=-Tai_Tham}');
    Expect(1, 6831, '\p{Block=:\ATai_Tham\z:}', "");;
    Expect(0, 6832, '\p{Block=:\ATai_Tham\z:}', "");;
    Expect(1, 6831, '\p{Block=taitham}', "");
    Expect(0, 6831, '\p{^Block=taitham}', "");
    Expect(0, 6831, '\P{Block=taitham}', "");
    Expect(1, 6831, '\P{^Block=taitham}', "");
    Expect(0, 6832, '\p{Block=taitham}', "");
    Expect(1, 6832, '\p{^Block=taitham}', "");
    Expect(1, 6832, '\P{Block=taitham}', "");
    Expect(0, 6832, '\P{^Block=taitham}', "");
    Expect(1, 6831, '\p{Block=:\Ataitham\z:}', "");;
    Expect(0, 6832, '\p{Block=:\Ataitham\z:}', "");;
    Expect(1, 6831, '\p{Block=_ Tai_Tham}', "");
    Expect(0, 6831, '\p{^Block=_ Tai_Tham}', "");
    Expect(0, 6831, '\P{Block=_ Tai_Tham}', "");
    Expect(1, 6831, '\P{^Block=_ Tai_Tham}', "");
    Expect(0, 6832, '\p{Block=_ Tai_Tham}', "");
    Expect(1, 6832, '\p{^Block=_ Tai_Tham}', "");
    Expect(1, 6832, '\P{Block=_ Tai_Tham}', "");
    Expect(0, 6832, '\P{^Block=_ Tai_Tham}', "");
    Error('\p{Blk=/a/ _TAI_Tham}');
    Error('\P{Blk=/a/ _TAI_Tham}');
    Expect(1, 6831, '\p{Blk=:\ATai_Tham\z:}', "");;
    Expect(0, 6832, '\p{Blk=:\ATai_Tham\z:}', "");;
    Expect(1, 6831, '\p{Blk=taitham}', "");
    Expect(0, 6831, '\p{^Blk=taitham}', "");
    Expect(0, 6831, '\P{Blk=taitham}', "");
    Expect(1, 6831, '\P{^Blk=taitham}', "");
    Expect(0, 6832, '\p{Blk=taitham}', "");
    Expect(1, 6832, '\p{^Blk=taitham}', "");
    Expect(1, 6832, '\P{Blk=taitham}', "");
    Expect(0, 6832, '\P{^Blk=taitham}', "");
    Expect(1, 6831, '\p{Blk=:\Ataitham\z:}', "");;
    Expect(0, 6832, '\p{Blk=:\Ataitham\z:}', "");;
    Expect(1, 6831, '\p{Blk=_tai_Tham}', "");
    Expect(0, 6831, '\p{^Blk=_tai_Tham}', "");
    Expect(0, 6831, '\P{Blk=_tai_Tham}', "");
    Expect(1, 6831, '\P{^Blk=_tai_Tham}', "");
    Expect(0, 6832, '\p{Blk=_tai_Tham}', "");
    Expect(1, 6832, '\p{^Blk=_tai_Tham}', "");
    Expect(1, 6832, '\P{Blk=_tai_Tham}', "");
    Expect(0, 6832, '\P{^Blk=_tai_Tham}', "");
    Error('\p{Is_Block=/a/_TAI_Tham}');
    Error('\P{Is_Block=/a/_TAI_Tham}');
    Expect(1, 6831, '\p{Is_Block=taitham}', "");
    Expect(0, 6831, '\p{^Is_Block=taitham}', "");
    Expect(0, 6831, '\P{Is_Block=taitham}', "");
    Expect(1, 6831, '\P{^Is_Block=taitham}', "");
    Expect(0, 6832, '\p{Is_Block=taitham}', "");
    Expect(1, 6832, '\p{^Is_Block=taitham}', "");
    Expect(1, 6832, '\P{Is_Block=taitham}', "");
    Expect(0, 6832, '\P{^Is_Block=taitham}', "");
    Expect(1, 6831, '\p{Is_Block:		Tai_THAM}', "");
    Expect(0, 6831, '\p{^Is_Block:		Tai_THAM}', "");
    Expect(0, 6831, '\P{Is_Block:		Tai_THAM}', "");
    Expect(1, 6831, '\P{^Is_Block:		Tai_THAM}', "");
    Expect(0, 6832, '\p{Is_Block:		Tai_THAM}', "");
    Expect(1, 6832, '\p{^Is_Block:		Tai_THAM}', "");
    Expect(1, 6832, '\P{Is_Block:		Tai_THAM}', "");
    Expect(0, 6832, '\P{^Is_Block:		Tai_THAM}', "");
    Error('\p{Is_Blk=/a/tai_THAM}');
    Error('\P{Is_Blk=/a/tai_THAM}');
    Expect(1, 6831, '\p{Is_Blk=taitham}', "");
    Expect(0, 6831, '\p{^Is_Blk=taitham}', "");
    Expect(0, 6831, '\P{Is_Blk=taitham}', "");
    Expect(1, 6831, '\P{^Is_Blk=taitham}', "");
    Expect(0, 6832, '\p{Is_Blk=taitham}', "");
    Expect(1, 6832, '\p{^Is_Blk=taitham}', "");
    Expect(1, 6832, '\P{Is_Blk=taitham}', "");
    Expect(0, 6832, '\P{^Is_Blk=taitham}', "");
    Expect(1, 6831, '\p{Is_Blk=_-Tai_THAM}', "");
    Expect(0, 6831, '\p{^Is_Blk=_-Tai_THAM}', "");
    Expect(0, 6831, '\P{Is_Blk=_-Tai_THAM}', "");
    Expect(1, 6831, '\P{^Is_Blk=_-Tai_THAM}', "");
    Expect(0, 6832, '\p{Is_Blk=_-Tai_THAM}', "");
    Expect(1, 6832, '\p{^Is_Blk=_-Tai_THAM}', "");
    Expect(1, 6832, '\P{Is_Blk=_-Tai_THAM}', "");
    Expect(0, 6832, '\P{^Is_Blk=_-Tai_THAM}', "");
    Error('\p{Block=-/a/TAI_Viet}');
    Error('\P{Block=-/a/TAI_Viet}');
    Expect(1, 43743, '\p{Block=:\ATai_Viet\z:}', "");;
    Expect(0, 43744, '\p{Block=:\ATai_Viet\z:}', "");;
    Expect(1, 43743, '\p{Block=taiviet}', "");
    Expect(0, 43743, '\p{^Block=taiviet}', "");
    Expect(0, 43743, '\P{Block=taiviet}', "");
    Expect(1, 43743, '\P{^Block=taiviet}', "");
    Expect(0, 43744, '\p{Block=taiviet}', "");
    Expect(1, 43744, '\p{^Block=taiviet}', "");
    Expect(1, 43744, '\P{Block=taiviet}', "");
    Expect(0, 43744, '\P{^Block=taiviet}', "");
    Expect(1, 43743, '\p{Block=:\Ataiviet\z:}', "");;
    Expect(0, 43744, '\p{Block=:\Ataiviet\z:}', "");;
    Expect(1, 43743, '\p{Block=	_Tai_Viet}', "");
    Expect(0, 43743, '\p{^Block=	_Tai_Viet}', "");
    Expect(0, 43743, '\P{Block=	_Tai_Viet}', "");
    Expect(1, 43743, '\P{^Block=	_Tai_Viet}', "");
    Expect(0, 43744, '\p{Block=	_Tai_Viet}', "");
    Expect(1, 43744, '\p{^Block=	_Tai_Viet}', "");
    Expect(1, 43744, '\P{Block=	_Tai_Viet}', "");
    Expect(0, 43744, '\P{^Block=	_Tai_Viet}', "");
    Error('\p{Blk=tai_viet/a/}');
    Error('\P{Blk=tai_viet/a/}');
    Expect(1, 43743, '\p{Blk=:\ATai_Viet\z:}', "");;
    Expect(0, 43744, '\p{Blk=:\ATai_Viet\z:}', "");;
    Expect(1, 43743, '\p{Blk=taiviet}', "");
    Expect(0, 43743, '\p{^Blk=taiviet}', "");
    Expect(0, 43743, '\P{Blk=taiviet}', "");
    Expect(1, 43743, '\P{^Blk=taiviet}', "");
    Expect(0, 43744, '\p{Blk=taiviet}', "");
    Expect(1, 43744, '\p{^Blk=taiviet}', "");
    Expect(1, 43744, '\P{Blk=taiviet}', "");
    Expect(0, 43744, '\P{^Blk=taiviet}', "");
    Expect(1, 43743, '\p{Blk=:\Ataiviet\z:}', "");;
    Expect(0, 43744, '\p{Blk=:\Ataiviet\z:}', "");;
    Expect(1, 43743, '\p{Blk= 	TAI_Viet}', "");
    Expect(0, 43743, '\p{^Blk= 	TAI_Viet}', "");
    Expect(0, 43743, '\P{Blk= 	TAI_Viet}', "");
    Expect(1, 43743, '\P{^Blk= 	TAI_Viet}', "");
    Expect(0, 43744, '\p{Blk= 	TAI_Viet}', "");
    Expect(1, 43744, '\p{^Blk= 	TAI_Viet}', "");
    Expect(1, 43744, '\P{Blk= 	TAI_Viet}', "");
    Expect(0, 43744, '\P{^Blk= 	TAI_Viet}', "");
    Error('\p{Is_Block=:=_ Tai_Viet}');
    Error('\P{Is_Block=:=_ Tai_Viet}');
    Expect(1, 43743, '\p{Is_Block=taiviet}', "");
    Expect(0, 43743, '\p{^Is_Block=taiviet}', "");
    Expect(0, 43743, '\P{Is_Block=taiviet}', "");
    Expect(1, 43743, '\P{^Is_Block=taiviet}', "");
    Expect(0, 43744, '\p{Is_Block=taiviet}', "");
    Expect(1, 43744, '\p{^Is_Block=taiviet}', "");
    Expect(1, 43744, '\P{Is_Block=taiviet}', "");
    Expect(0, 43744, '\P{^Is_Block=taiviet}', "");
    Expect(1, 43743, '\p{Is_Block=_-TAI_VIET}', "");
    Expect(0, 43743, '\p{^Is_Block=_-TAI_VIET}', "");
    Expect(0, 43743, '\P{Is_Block=_-TAI_VIET}', "");
    Expect(1, 43743, '\P{^Is_Block=_-TAI_VIET}', "");
    Expect(0, 43744, '\p{Is_Block=_-TAI_VIET}', "");
    Expect(1, 43744, '\p{^Is_Block=_-TAI_VIET}', "");
    Expect(1, 43744, '\P{Is_Block=_-TAI_VIET}', "");
    Expect(0, 43744, '\P{^Is_Block=_-TAI_VIET}', "");
    Error('\p{Is_Blk=_-Tai_VIET/a/}');
    Error('\P{Is_Blk=_-Tai_VIET/a/}');
    Expect(1, 43743, '\p{Is_Blk=taiviet}', "");
    Expect(0, 43743, '\p{^Is_Blk=taiviet}', "");
    Expect(0, 43743, '\P{Is_Blk=taiviet}', "");
    Expect(1, 43743, '\P{^Is_Blk=taiviet}', "");
    Expect(0, 43744, '\p{Is_Blk=taiviet}', "");
    Expect(1, 43744, '\p{^Is_Blk=taiviet}', "");
    Expect(1, 43744, '\P{Is_Blk=taiviet}', "");
    Expect(0, 43744, '\P{^Is_Blk=taiviet}', "");
    Expect(1, 43743, '\p{Is_Blk=_	Tai_Viet}', "");
    Expect(0, 43743, '\p{^Is_Blk=_	Tai_Viet}', "");
    Expect(0, 43743, '\P{Is_Blk=_	Tai_Viet}', "");
    Expect(1, 43743, '\P{^Is_Blk=_	Tai_Viet}', "");
    Expect(0, 43744, '\p{Is_Blk=_	Tai_Viet}', "");
    Expect(1, 43744, '\p{^Is_Blk=_	Tai_Viet}', "");
    Expect(1, 43744, '\P{Is_Blk=_	Tai_Viet}', "");
    Expect(0, 43744, '\P{^Is_Blk=_	Tai_Viet}', "");
    Error('\p{Block= tai_Xuan_Jing_symbols:=}');
    Error('\P{Block= tai_Xuan_Jing_symbols:=}');
    Expect(1, 119647, '\p{Block=:\ATai_Xuan_Jing_Symbols\z:}', "");;
    Expect(0, 119648, '\p{Block=:\ATai_Xuan_Jing_Symbols\z:}', "");;
    Expect(1, 119647, '\p{Block=taixuanjingsymbols}', "");
    Expect(0, 119647, '\p{^Block=taixuanjingsymbols}', "");
    Expect(0, 119647, '\P{Block=taixuanjingsymbols}', "");
    Expect(1, 119647, '\P{^Block=taixuanjingsymbols}', "");
    Expect(0, 119648, '\p{Block=taixuanjingsymbols}', "");
    Expect(1, 119648, '\p{^Block=taixuanjingsymbols}', "");
    Expect(1, 119648, '\P{Block=taixuanjingsymbols}', "");
    Expect(0, 119648, '\P{^Block=taixuanjingsymbols}', "");
    Expect(1, 119647, '\p{Block=:\Ataixuanjingsymbols\z:}', "");;
    Expect(0, 119648, '\p{Block=:\Ataixuanjingsymbols\z:}', "");;
    Expect(1, 119647, '\p{Block:   _Tai_XUAN_Jing_Symbols}', "");
    Expect(0, 119647, '\p{^Block:   _Tai_XUAN_Jing_Symbols}', "");
    Expect(0, 119647, '\P{Block:   _Tai_XUAN_Jing_Symbols}', "");
    Expect(1, 119647, '\P{^Block:   _Tai_XUAN_Jing_Symbols}', "");
    Expect(0, 119648, '\p{Block:   _Tai_XUAN_Jing_Symbols}', "");
    Expect(1, 119648, '\p{^Block:   _Tai_XUAN_Jing_Symbols}', "");
    Expect(1, 119648, '\P{Block:   _Tai_XUAN_Jing_Symbols}', "");
    Expect(0, 119648, '\P{^Block:   _Tai_XUAN_Jing_Symbols}', "");
    Error('\p{Blk=/a/Tai_xuan_JING}');
    Error('\P{Blk=/a/Tai_xuan_JING}');
    Expect(1, 119647, '\p{Blk=:\ATai_Xuan_Jing\z:}', "");;
    Expect(0, 119648, '\p{Blk=:\ATai_Xuan_Jing\z:}', "");;
    Expect(1, 119647, '\p{Blk=taixuanjing}', "");
    Expect(0, 119647, '\p{^Blk=taixuanjing}', "");
    Expect(0, 119647, '\P{Blk=taixuanjing}', "");
    Expect(1, 119647, '\P{^Blk=taixuanjing}', "");
    Expect(0, 119648, '\p{Blk=taixuanjing}', "");
    Expect(1, 119648, '\p{^Blk=taixuanjing}', "");
    Expect(1, 119648, '\P{Blk=taixuanjing}', "");
    Expect(0, 119648, '\P{^Blk=taixuanjing}', "");
    Expect(1, 119647, '\p{Blk=:\Ataixuanjing\z:}', "");;
    Expect(0, 119648, '\p{Blk=:\Ataixuanjing\z:}', "");;
    Expect(1, 119647, '\p{Blk=-TAI_Xuan_jing}', "");
    Expect(0, 119647, '\p{^Blk=-TAI_Xuan_jing}', "");
    Expect(0, 119647, '\P{Blk=-TAI_Xuan_jing}', "");
    Expect(1, 119647, '\P{^Blk=-TAI_Xuan_jing}', "");
    Expect(0, 119648, '\p{Blk=-TAI_Xuan_jing}', "");
    Expect(1, 119648, '\p{^Blk=-TAI_Xuan_jing}', "");
    Expect(1, 119648, '\P{Blk=-TAI_Xuan_jing}', "");
    Expect(0, 119648, '\P{^Blk=-TAI_Xuan_jing}', "");
    Error('\p{Is_Block=	/a/Tai_Xuan_JING_Symbols}');
    Error('\P{Is_Block=	/a/Tai_Xuan_JING_Symbols}');
    Expect(1, 119647, '\p{Is_Block=taixuanjingsymbols}', "");
    Expect(0, 119647, '\p{^Is_Block=taixuanjingsymbols}', "");
    Expect(0, 119647, '\P{Is_Block=taixuanjingsymbols}', "");
    Expect(1, 119647, '\P{^Is_Block=taixuanjingsymbols}', "");
    Expect(0, 119648, '\p{Is_Block=taixuanjingsymbols}', "");
    Expect(1, 119648, '\p{^Is_Block=taixuanjingsymbols}', "");
    Expect(1, 119648, '\P{Is_Block=taixuanjingsymbols}', "");
    Expect(0, 119648, '\P{^Is_Block=taixuanjingsymbols}', "");
    Expect(1, 119647, '\p{Is_Block=-_Tai_Xuan_Jing_Symbols}', "");
    Expect(0, 119647, '\p{^Is_Block=-_Tai_Xuan_Jing_Symbols}', "");
    Expect(0, 119647, '\P{Is_Block=-_Tai_Xuan_Jing_Symbols}', "");
    Expect(1, 119647, '\P{^Is_Block=-_Tai_Xuan_Jing_Symbols}', "");
    Expect(0, 119648, '\p{Is_Block=-_Tai_Xuan_Jing_Symbols}', "");
    Expect(1, 119648, '\p{^Is_Block=-_Tai_Xuan_Jing_Symbols}', "");
    Expect(1, 119648, '\P{Is_Block=-_Tai_Xuan_Jing_Symbols}', "");
    Expect(0, 119648, '\P{^Is_Block=-_Tai_Xuan_Jing_Symbols}', "");
    Error('\p{Is_Blk=:=	 Tai_XUAN_Jing}');
    Error('\P{Is_Blk=:=	 Tai_XUAN_Jing}');
    Expect(1, 119647, '\p{Is_Blk=taixuanjing}', "");
    Expect(0, 119647, '\p{^Is_Blk=taixuanjing}', "");
    Expect(0, 119647, '\P{Is_Blk=taixuanjing}', "");
    Expect(1, 119647, '\P{^Is_Blk=taixuanjing}', "");
    Expect(0, 119648, '\p{Is_Blk=taixuanjing}', "");
    Expect(1, 119648, '\p{^Is_Blk=taixuanjing}', "");
    Expect(1, 119648, '\P{Is_Blk=taixuanjing}', "");
    Expect(0, 119648, '\P{^Is_Blk=taixuanjing}', "");
    Expect(1, 119647, '\p{Is_Blk=	 Tai_XUAN_jing}', "");
    Expect(0, 119647, '\p{^Is_Blk=	 Tai_XUAN_jing}', "");
    Expect(0, 119647, '\P{Is_Blk=	 Tai_XUAN_jing}', "");
    Expect(1, 119647, '\P{^Is_Blk=	 Tai_XUAN_jing}', "");
    Expect(0, 119648, '\p{Is_Blk=	 Tai_XUAN_jing}', "");
    Expect(1, 119648, '\p{^Is_Blk=	 Tai_XUAN_jing}', "");
    Expect(1, 119648, '\P{Is_Blk=	 Tai_XUAN_jing}', "");
    Expect(0, 119648, '\P{^Is_Blk=	 Tai_XUAN_jing}', "");
    Error('\p{Block=Takri/a/}');
    Error('\P{Block=Takri/a/}');
    Expect(1, 71375, '\p{Block=:\ATakri\z:}', "");;
    Expect(0, 71376, '\p{Block=:\ATakri\z:}', "");;
    Expect(1, 71375, '\p{Block:takri}', "");
    Expect(0, 71375, '\p{^Block:takri}', "");
    Expect(0, 71375, '\P{Block:takri}', "");
    Expect(1, 71375, '\P{^Block:takri}', "");
    Expect(0, 71376, '\p{Block:takri}', "");
    Expect(1, 71376, '\p{^Block:takri}', "");
    Expect(1, 71376, '\P{Block:takri}', "");
    Expect(0, 71376, '\P{^Block:takri}', "");
    Expect(1, 71375, '\p{Block=:\Atakri\z:}', "");;
    Expect(0, 71376, '\p{Block=:\Atakri\z:}', "");;
    Expect(1, 71375, '\p{Block=_takri}', "");
    Expect(0, 71375, '\p{^Block=_takri}', "");
    Expect(0, 71375, '\P{Block=_takri}', "");
    Expect(1, 71375, '\P{^Block=_takri}', "");
    Expect(0, 71376, '\p{Block=_takri}', "");
    Expect(1, 71376, '\p{^Block=_takri}', "");
    Expect(1, 71376, '\P{Block=_takri}', "");
    Expect(0, 71376, '\P{^Block=_takri}', "");
    Error('\p{Blk=	 Takri:=}');
    Error('\P{Blk=	 Takri:=}');
    Expect(1, 71375, '\p{Blk=:\ATakri\z:}', "");;
    Expect(0, 71376, '\p{Blk=:\ATakri\z:}', "");;
    Expect(1, 71375, '\p{Blk=takri}', "");
    Expect(0, 71375, '\p{^Blk=takri}', "");
    Expect(0, 71375, '\P{Blk=takri}', "");
    Expect(1, 71375, '\P{^Blk=takri}', "");
    Expect(0, 71376, '\p{Blk=takri}', "");
    Expect(1, 71376, '\p{^Blk=takri}', "");
    Expect(1, 71376, '\P{Blk=takri}', "");
    Expect(0, 71376, '\P{^Blk=takri}', "");
    Expect(1, 71375, '\p{Blk=:\Atakri\z:}', "");;
    Expect(0, 71376, '\p{Blk=:\Atakri\z:}', "");;
    Expect(1, 71375, '\p{Blk=-_TAKRI}', "");
    Expect(0, 71375, '\p{^Blk=-_TAKRI}', "");
    Expect(0, 71375, '\P{Blk=-_TAKRI}', "");
    Expect(1, 71375, '\P{^Blk=-_TAKRI}', "");
    Expect(0, 71376, '\p{Blk=-_TAKRI}', "");
    Expect(1, 71376, '\p{^Blk=-_TAKRI}', "");
    Expect(1, 71376, '\P{Blk=-_TAKRI}', "");
    Expect(0, 71376, '\P{^Blk=-_TAKRI}', "");
    Error('\p{Is_Block= :=Takri}');
    Error('\P{Is_Block= :=Takri}');
    Expect(1, 71375, '\p{Is_Block=takri}', "");
    Expect(0, 71375, '\p{^Is_Block=takri}', "");
    Expect(0, 71375, '\P{Is_Block=takri}', "");
    Expect(1, 71375, '\P{^Is_Block=takri}', "");
    Expect(0, 71376, '\p{Is_Block=takri}', "");
    Expect(1, 71376, '\p{^Is_Block=takri}', "");
    Expect(1, 71376, '\P{Is_Block=takri}', "");
    Expect(0, 71376, '\P{^Is_Block=takri}', "");
    Expect(1, 71375, '\p{Is_Block:	-_Takri}', "");
    Expect(0, 71375, '\p{^Is_Block:	-_Takri}', "");
    Expect(0, 71375, '\P{Is_Block:	-_Takri}', "");
    Expect(1, 71375, '\P{^Is_Block:	-_Takri}', "");
    Expect(0, 71376, '\p{Is_Block:	-_Takri}', "");
    Expect(1, 71376, '\p{^Is_Block:	-_Takri}', "");
    Expect(1, 71376, '\P{Is_Block:	-_Takri}', "");
    Expect(0, 71376, '\P{^Is_Block:	-_Takri}', "");
    Error('\p{Is_Blk= :=TAKRI}');
    Error('\P{Is_Blk= :=TAKRI}');
    Expect(1, 71375, '\p{Is_Blk=takri}', "");
    Expect(0, 71375, '\p{^Is_Blk=takri}', "");
    Expect(0, 71375, '\P{Is_Blk=takri}', "");
    Expect(1, 71375, '\P{^Is_Blk=takri}', "");
    Expect(0, 71376, '\p{Is_Blk=takri}', "");
    Expect(1, 71376, '\p{^Is_Blk=takri}', "");
    Expect(1, 71376, '\P{Is_Blk=takri}', "");
    Expect(0, 71376, '\P{^Is_Blk=takri}', "");
    Expect(1, 71375, '\p{Is_Blk=	-Takri}', "");
    Expect(0, 71375, '\p{^Is_Blk=	-Takri}', "");
    Expect(0, 71375, '\P{Is_Blk=	-Takri}', "");
    Expect(1, 71375, '\P{^Is_Blk=	-Takri}', "");
    Expect(0, 71376, '\p{Is_Blk=	-Takri}', "");
    Expect(1, 71376, '\p{^Is_Blk=	-Takri}', "");
    Expect(1, 71376, '\P{Is_Blk=	-Takri}', "");
    Expect(0, 71376, '\P{^Is_Blk=	-Takri}', "");
    Error('\p{Block=:= -Tamil}');
    Error('\P{Block=:= -Tamil}');
    Expect(1, 3071, '\p{Block=:\ATamil\z:}', "");;
    Expect(0, 3072, '\p{Block=:\ATamil\z:}', "");;
    Expect(1, 3071, '\p{Block=tamil}', "");
    Expect(0, 3071, '\p{^Block=tamil}', "");
    Expect(0, 3071, '\P{Block=tamil}', "");
    Expect(1, 3071, '\P{^Block=tamil}', "");
    Expect(0, 3072, '\p{Block=tamil}', "");
    Expect(1, 3072, '\p{^Block=tamil}', "");
    Expect(1, 3072, '\P{Block=tamil}', "");
    Expect(0, 3072, '\P{^Block=tamil}', "");
    Expect(1, 3071, '\p{Block=:\Atamil\z:}', "");;
    Expect(0, 3072, '\p{Block=:\Atamil\z:}', "");;
    Expect(1, 3071, '\p{Block=Tamil}', "");
    Expect(0, 3071, '\p{^Block=Tamil}', "");
    Expect(0, 3071, '\P{Block=Tamil}', "");
    Expect(1, 3071, '\P{^Block=Tamil}', "");
    Expect(0, 3072, '\p{Block=Tamil}', "");
    Expect(1, 3072, '\p{^Block=Tamil}', "");
    Expect(1, 3072, '\P{Block=Tamil}', "");
    Expect(0, 3072, '\P{^Block=Tamil}', "");
    Error('\p{Blk=:=TAMIL}');
    Error('\P{Blk=:=TAMIL}');
    Expect(1, 3071, '\p{Blk=:\ATamil\z:}', "");;
    Expect(0, 3072, '\p{Blk=:\ATamil\z:}', "");;
    Expect(1, 3071, '\p{Blk=tamil}', "");
    Expect(0, 3071, '\p{^Blk=tamil}', "");
    Expect(0, 3071, '\P{Blk=tamil}', "");
    Expect(1, 3071, '\P{^Blk=tamil}', "");
    Expect(0, 3072, '\p{Blk=tamil}', "");
    Expect(1, 3072, '\p{^Blk=tamil}', "");
    Expect(1, 3072, '\P{Blk=tamil}', "");
    Expect(0, 3072, '\P{^Blk=tamil}', "");
    Expect(1, 3071, '\p{Blk=:\Atamil\z:}', "");;
    Expect(0, 3072, '\p{Blk=:\Atamil\z:}', "");;
    Expect(1, 3071, '\p{Blk=--tamil}', "");
    Expect(0, 3071, '\p{^Blk=--tamil}', "");
    Expect(0, 3071, '\P{Blk=--tamil}', "");
    Expect(1, 3071, '\P{^Blk=--tamil}', "");
    Expect(0, 3072, '\p{Blk=--tamil}', "");
    Expect(1, 3072, '\p{^Blk=--tamil}', "");
    Expect(1, 3072, '\P{Blk=--tamil}', "");
    Expect(0, 3072, '\P{^Blk=--tamil}', "");
    Error('\p{Is_Block=-Tamil:=}');
    Error('\P{Is_Block=-Tamil:=}');
    Expect(1, 3071, '\p{Is_Block=tamil}', "");
    Expect(0, 3071, '\p{^Is_Block=tamil}', "");
    Expect(0, 3071, '\P{Is_Block=tamil}', "");
    Expect(1, 3071, '\P{^Is_Block=tamil}', "");
    Expect(0, 3072, '\p{Is_Block=tamil}', "");
    Expect(1, 3072, '\p{^Is_Block=tamil}', "");
    Expect(1, 3072, '\P{Is_Block=tamil}', "");
    Expect(0, 3072, '\P{^Is_Block=tamil}', "");
    Expect(1, 3071, '\p{Is_Block=- Tamil}', "");
    Expect(0, 3071, '\p{^Is_Block=- Tamil}', "");
    Expect(0, 3071, '\P{Is_Block=- Tamil}', "");
    Expect(1, 3071, '\P{^Is_Block=- Tamil}', "");
    Expect(0, 3072, '\p{Is_Block=- Tamil}', "");
    Expect(1, 3072, '\p{^Is_Block=- Tamil}', "");
    Expect(1, 3072, '\P{Is_Block=- Tamil}', "");
    Expect(0, 3072, '\P{^Is_Block=- Tamil}', "");
    Error('\p{Is_Blk=--tamil:=}');
    Error('\P{Is_Blk=--tamil:=}');
    Expect(1, 3071, '\p{Is_Blk=tamil}', "");
    Expect(0, 3071, '\p{^Is_Blk=tamil}', "");
    Expect(0, 3071, '\P{Is_Blk=tamil}', "");
    Expect(1, 3071, '\P{^Is_Blk=tamil}', "");
    Expect(0, 3072, '\p{Is_Blk=tamil}', "");
    Expect(1, 3072, '\p{^Is_Blk=tamil}', "");
    Expect(1, 3072, '\P{Is_Blk=tamil}', "");
    Expect(0, 3072, '\P{^Is_Blk=tamil}', "");
    Expect(1, 3071, '\p{Is_Blk=-TAMIL}', "");
    Expect(0, 3071, '\p{^Is_Blk=-TAMIL}', "");
    Expect(0, 3071, '\P{Is_Blk=-TAMIL}', "");
    Expect(1, 3071, '\P{^Is_Blk=-TAMIL}', "");
    Expect(0, 3072, '\p{Is_Blk=-TAMIL}', "");
    Expect(1, 3072, '\p{^Is_Blk=-TAMIL}', "");
    Expect(1, 3072, '\P{Is_Blk=-TAMIL}', "");
    Expect(0, 3072, '\P{^Is_Blk=-TAMIL}', "");
    Error('\p{Block=	/a/Tamil_Supplement}');
    Error('\P{Block=	/a/Tamil_Supplement}');
    Expect(1, 73727, '\p{Block=:\ATamil_Supplement\z:}', "");;
    Expect(0, 73728, '\p{Block=:\ATamil_Supplement\z:}', "");;
    Expect(1, 73727, '\p{Block=tamilsupplement}', "");
    Expect(0, 73727, '\p{^Block=tamilsupplement}', "");
    Expect(0, 73727, '\P{Block=tamilsupplement}', "");
    Expect(1, 73727, '\P{^Block=tamilsupplement}', "");
    Expect(0, 73728, '\p{Block=tamilsupplement}', "");
    Expect(1, 73728, '\p{^Block=tamilsupplement}', "");
    Expect(1, 73728, '\P{Block=tamilsupplement}', "");
    Expect(0, 73728, '\P{^Block=tamilsupplement}', "");
    Expect(1, 73727, '\p{Block=:\Atamilsupplement\z:}', "");;
    Expect(0, 73728, '\p{Block=:\Atamilsupplement\z:}', "");;
    Expect(1, 73727, '\p{Block=	tamil_Supplement}', "");
    Expect(0, 73727, '\p{^Block=	tamil_Supplement}', "");
    Expect(0, 73727, '\P{Block=	tamil_Supplement}', "");
    Expect(1, 73727, '\P{^Block=	tamil_Supplement}', "");
    Expect(0, 73728, '\p{Block=	tamil_Supplement}', "");
    Expect(1, 73728, '\p{^Block=	tamil_Supplement}', "");
    Expect(1, 73728, '\P{Block=	tamil_Supplement}', "");
    Expect(0, 73728, '\P{^Block=	tamil_Supplement}', "");
    Error('\p{Blk=:=tamil_SUP}');
    Error('\P{Blk=:=tamil_SUP}');
    Expect(1, 73727, '\p{Blk=:\ATamil_Sup\z:}', "");;
    Expect(0, 73728, '\p{Blk=:\ATamil_Sup\z:}', "");;
    Expect(1, 73727, '\p{Blk=tamilsup}', "");
    Expect(0, 73727, '\p{^Blk=tamilsup}', "");
    Expect(0, 73727, '\P{Blk=tamilsup}', "");
    Expect(1, 73727, '\P{^Blk=tamilsup}', "");
    Expect(0, 73728, '\p{Blk=tamilsup}', "");
    Expect(1, 73728, '\p{^Blk=tamilsup}', "");
    Expect(1, 73728, '\P{Blk=tamilsup}', "");
    Expect(0, 73728, '\P{^Blk=tamilsup}', "");
    Expect(1, 73727, '\p{Blk=:\Atamilsup\z:}', "");;
    Expect(0, 73728, '\p{Blk=:\Atamilsup\z:}', "");;
    Expect(1, 73727, '\p{Blk: _-Tamil_Sup}', "");
    Expect(0, 73727, '\p{^Blk: _-Tamil_Sup}', "");
    Expect(0, 73727, '\P{Blk: _-Tamil_Sup}', "");
    Expect(1, 73727, '\P{^Blk: _-Tamil_Sup}', "");
    Expect(0, 73728, '\p{Blk: _-Tamil_Sup}', "");
    Expect(1, 73728, '\p{^Blk: _-Tamil_Sup}', "");
    Expect(1, 73728, '\P{Blk: _-Tamil_Sup}', "");
    Expect(0, 73728, '\P{^Blk: _-Tamil_Sup}', "");
    Error('\p{Is_Block=	:=tamil_Supplement}');
    Error('\P{Is_Block=	:=tamil_Supplement}');
    Expect(1, 73727, '\p{Is_Block=tamilsupplement}', "");
    Expect(0, 73727, '\p{^Is_Block=tamilsupplement}', "");
    Expect(0, 73727, '\P{Is_Block=tamilsupplement}', "");
    Expect(1, 73727, '\P{^Is_Block=tamilsupplement}', "");
    Expect(0, 73728, '\p{Is_Block=tamilsupplement}', "");
    Expect(1, 73728, '\p{^Is_Block=tamilsupplement}', "");
    Expect(1, 73728, '\P{Is_Block=tamilsupplement}', "");
    Expect(0, 73728, '\P{^Is_Block=tamilsupplement}', "");
    Expect(1, 73727, '\p{Is_Block=-_tamil_supplement}', "");
    Expect(0, 73727, '\p{^Is_Block=-_tamil_supplement}', "");
    Expect(0, 73727, '\P{Is_Block=-_tamil_supplement}', "");
    Expect(1, 73727, '\P{^Is_Block=-_tamil_supplement}', "");
    Expect(0, 73728, '\p{Is_Block=-_tamil_supplement}', "");
    Expect(1, 73728, '\p{^Is_Block=-_tamil_supplement}', "");
    Expect(1, 73728, '\P{Is_Block=-_tamil_supplement}', "");
    Expect(0, 73728, '\P{^Is_Block=-_tamil_supplement}', "");
    Error('\p{Is_Blk=- Tamil_sup/a/}');
    Error('\P{Is_Blk=- Tamil_sup/a/}');
    Expect(1, 73727, '\p{Is_Blk=tamilsup}', "");
    Expect(0, 73727, '\p{^Is_Blk=tamilsup}', "");
    Expect(0, 73727, '\P{Is_Blk=tamilsup}', "");
    Expect(1, 73727, '\P{^Is_Blk=tamilsup}', "");
    Expect(0, 73728, '\p{Is_Blk=tamilsup}', "");
    Expect(1, 73728, '\p{^Is_Blk=tamilsup}', "");
    Expect(1, 73728, '\P{Is_Blk=tamilsup}', "");
    Expect(0, 73728, '\P{^Is_Blk=tamilsup}', "");
    Expect(1, 73727, '\p{Is_Blk=_-Tamil_Sup}', "");
    Expect(0, 73727, '\p{^Is_Blk=_-Tamil_Sup}', "");
    Expect(0, 73727, '\P{Is_Blk=_-Tamil_Sup}', "");
    Expect(1, 73727, '\P{^Is_Blk=_-Tamil_Sup}', "");
    Expect(0, 73728, '\p{Is_Blk=_-Tamil_Sup}', "");
    Expect(1, 73728, '\p{^Is_Blk=_-Tamil_Sup}', "");
    Expect(1, 73728, '\P{Is_Blk=_-Tamil_Sup}', "");
    Expect(0, 73728, '\P{^Is_Blk=_-Tamil_Sup}', "");
    Error('\p{Block= 	TANGSA:=}');
    Error('\P{Block= 	TANGSA:=}');
    Expect(1, 92879, '\p{Block=:\ATangsa\z:}', "");;
    Expect(0, 92880, '\p{Block=:\ATangsa\z:}', "");;
    Expect(1, 92879, '\p{Block=tangsa}', "");
    Expect(0, 92879, '\p{^Block=tangsa}', "");
    Expect(0, 92879, '\P{Block=tangsa}', "");
    Expect(1, 92879, '\P{^Block=tangsa}', "");
    Expect(0, 92880, '\p{Block=tangsa}', "");
    Expect(1, 92880, '\p{^Block=tangsa}', "");
    Expect(1, 92880, '\P{Block=tangsa}', "");
    Expect(0, 92880, '\P{^Block=tangsa}', "");
    Expect(1, 92879, '\p{Block=:\Atangsa\z:}', "");;
    Expect(0, 92880, '\p{Block=:\Atangsa\z:}', "");;
    Expect(1, 92879, '\p{Block:		 Tangsa}', "");
    Expect(0, 92879, '\p{^Block:		 Tangsa}', "");
    Expect(0, 92879, '\P{Block:		 Tangsa}', "");
    Expect(1, 92879, '\P{^Block:		 Tangsa}', "");
    Expect(0, 92880, '\p{Block:		 Tangsa}', "");
    Expect(1, 92880, '\p{^Block:		 Tangsa}', "");
    Expect(1, 92880, '\P{Block:		 Tangsa}', "");
    Expect(0, 92880, '\P{^Block:		 Tangsa}', "");
    Error('\p{Blk=-_TANGSA:=}');
    Error('\P{Blk=-_TANGSA:=}');
    Expect(1, 92879, '\p{Blk=:\ATangsa\z:}', "");;
    Expect(0, 92880, '\p{Blk=:\ATangsa\z:}', "");;
    Expect(1, 92879, '\p{Blk=tangsa}', "");
    Expect(0, 92879, '\p{^Blk=tangsa}', "");
    Expect(0, 92879, '\P{Blk=tangsa}', "");
    Expect(1, 92879, '\P{^Blk=tangsa}', "");
    Expect(0, 92880, '\p{Blk=tangsa}', "");
    Expect(1, 92880, '\p{^Blk=tangsa}', "");
    Expect(1, 92880, '\P{Blk=tangsa}', "");
    Expect(0, 92880, '\P{^Blk=tangsa}', "");
    Expect(1, 92879, '\p{Blk=:\Atangsa\z:}', "");;
    Expect(0, 92880, '\p{Blk=:\Atangsa\z:}', "");;
    Expect(1, 92879, '\p{Blk:	-_Tangsa}', "");
    Expect(0, 92879, '\p{^Blk:	-_Tangsa}', "");
    Expect(0, 92879, '\P{Blk:	-_Tangsa}', "");
    Expect(1, 92879, '\P{^Blk:	-_Tangsa}', "");
    Expect(0, 92880, '\p{Blk:	-_Tangsa}', "");
    Expect(1, 92880, '\p{^Blk:	-_Tangsa}', "");
    Expect(1, 92880, '\P{Blk:	-_Tangsa}', "");
    Expect(0, 92880, '\P{^Blk:	-_Tangsa}', "");
    Error('\p{Is_Block: /a/ 	Tangsa}');
    Error('\P{Is_Block: /a/ 	Tangsa}');
    Expect(1, 92879, '\p{Is_Block=tangsa}', "");
    Expect(0, 92879, '\p{^Is_Block=tangsa}', "");
    Expect(0, 92879, '\P{Is_Block=tangsa}', "");
    Expect(1, 92879, '\P{^Is_Block=tangsa}', "");
    Expect(0, 92880, '\p{Is_Block=tangsa}', "");
    Expect(1, 92880, '\p{^Is_Block=tangsa}', "");
    Expect(1, 92880, '\P{Is_Block=tangsa}', "");
    Expect(0, 92880, '\P{^Is_Block=tangsa}', "");
    Expect(1, 92879, '\p{Is_Block=	-Tangsa}', "");
    Expect(0, 92879, '\p{^Is_Block=	-Tangsa}', "");
    Expect(0, 92879, '\P{Is_Block=	-Tangsa}', "");
    Expect(1, 92879, '\P{^Is_Block=	-Tangsa}', "");
    Expect(0, 92880, '\p{Is_Block=	-Tangsa}', "");
    Expect(1, 92880, '\p{^Is_Block=	-Tangsa}', "");
    Expect(1, 92880, '\P{Is_Block=	-Tangsa}', "");
    Expect(0, 92880, '\P{^Is_Block=	-Tangsa}', "");
    Error('\p{Is_Blk=	-TANGSA/a/}');
    Error('\P{Is_Blk=	-TANGSA/a/}');
    Expect(1, 92879, '\p{Is_Blk=tangsa}', "");
    Expect(0, 92879, '\p{^Is_Blk=tangsa}', "");
    Expect(0, 92879, '\P{Is_Blk=tangsa}', "");
    Expect(1, 92879, '\P{^Is_Blk=tangsa}', "");
    Expect(0, 92880, '\p{Is_Blk=tangsa}', "");
    Expect(1, 92880, '\p{^Is_Blk=tangsa}', "");
    Expect(1, 92880, '\P{Is_Blk=tangsa}', "");
    Expect(0, 92880, '\P{^Is_Blk=tangsa}', "");
    Expect(1, 92879, '\p{Is_Blk=-Tangsa}', "");
    Expect(0, 92879, '\p{^Is_Blk=-Tangsa}', "");
    Expect(0, 92879, '\P{Is_Blk=-Tangsa}', "");
    Expect(1, 92879, '\P{^Is_Blk=-Tangsa}', "");
    Expect(0, 92880, '\p{Is_Blk=-Tangsa}', "");
    Expect(1, 92880, '\p{^Is_Blk=-Tangsa}', "");
    Expect(1, 92880, '\P{Is_Blk=-Tangsa}', "");
    Expect(0, 92880, '\P{^Is_Blk=-Tangsa}', "");
    Error('\p{Block=-/a/TANGUT}');
    Error('\P{Block=-/a/TANGUT}');
    Expect(1, 100351, '\p{Block=:\ATangut\z:}', "");;
    Expect(0, 100352, '\p{Block=:\ATangut\z:}', "");;
    Expect(1, 100351, '\p{Block=tangut}', "");
    Expect(0, 100351, '\p{^Block=tangut}', "");
    Expect(0, 100351, '\P{Block=tangut}', "");
    Expect(1, 100351, '\P{^Block=tangut}', "");
    Expect(0, 100352, '\p{Block=tangut}', "");
    Expect(1, 100352, '\p{^Block=tangut}', "");
    Expect(1, 100352, '\P{Block=tangut}', "");
    Expect(0, 100352, '\P{^Block=tangut}', "");
    Expect(1, 100351, '\p{Block=:\Atangut\z:}', "");;
    Expect(0, 100352, '\p{Block=:\Atangut\z:}', "");;
    Expect(1, 100351, '\p{Block:   _-tangut}', "");
    Expect(0, 100351, '\p{^Block:   _-tangut}', "");
    Expect(0, 100351, '\P{Block:   _-tangut}', "");
    Expect(1, 100351, '\P{^Block:   _-tangut}', "");
    Expect(0, 100352, '\p{Block:   _-tangut}', "");
    Expect(1, 100352, '\p{^Block:   _-tangut}', "");
    Expect(1, 100352, '\P{Block:   _-tangut}', "");
    Expect(0, 100352, '\P{^Block:   _-tangut}', "");
    Error('\p{Blk:	 :=TANGUT}');
    Error('\P{Blk:	 :=TANGUT}');
    Expect(1, 100351, '\p{Blk=:\ATangut\z:}', "");;
    Expect(0, 100352, '\p{Blk=:\ATangut\z:}', "");;
    Expect(1, 100351, '\p{Blk=tangut}', "");
    Expect(0, 100351, '\p{^Blk=tangut}', "");
    Expect(0, 100351, '\P{Blk=tangut}', "");
    Expect(1, 100351, '\P{^Blk=tangut}', "");
    Expect(0, 100352, '\p{Blk=tangut}', "");
    Expect(1, 100352, '\p{^Blk=tangut}', "");
    Expect(1, 100352, '\P{Blk=tangut}', "");
    Expect(0, 100352, '\P{^Blk=tangut}', "");
    Expect(1, 100351, '\p{Blk=:\Atangut\z:}', "");;
    Expect(0, 100352, '\p{Blk=:\Atangut\z:}', "");;
    Expect(1, 100351, '\p{Blk=-Tangut}', "");
    Expect(0, 100351, '\p{^Blk=-Tangut}', "");
    Expect(0, 100351, '\P{Blk=-Tangut}', "");
    Expect(1, 100351, '\P{^Blk=-Tangut}', "");
    Expect(0, 100352, '\p{Blk=-Tangut}', "");
    Expect(1, 100352, '\p{^Blk=-Tangut}', "");
    Expect(1, 100352, '\P{Blk=-Tangut}', "");
    Expect(0, 100352, '\P{^Blk=-Tangut}', "");
    Error('\p{Is_Block:		_tangut/a/}');
    Error('\P{Is_Block:		_tangut/a/}');
    Expect(1, 100351, '\p{Is_Block=tangut}', "");
    Expect(0, 100351, '\p{^Is_Block=tangut}', "");
    Expect(0, 100351, '\P{Is_Block=tangut}', "");
    Expect(1, 100351, '\P{^Is_Block=tangut}', "");
    Expect(0, 100352, '\p{Is_Block=tangut}', "");
    Expect(1, 100352, '\p{^Is_Block=tangut}', "");
    Expect(1, 100352, '\P{Is_Block=tangut}', "");
    Expect(0, 100352, '\P{^Is_Block=tangut}', "");
    Expect(1, 100351, '\p{Is_Block: Tangut}', "");
    Expect(0, 100351, '\p{^Is_Block: Tangut}', "");
    Expect(0, 100351, '\P{Is_Block: Tangut}', "");
    Expect(1, 100351, '\P{^Is_Block: Tangut}', "");
    Expect(0, 100352, '\p{Is_Block: Tangut}', "");
    Expect(1, 100352, '\p{^Is_Block: Tangut}', "");
    Expect(1, 100352, '\P{Is_Block: Tangut}', "");
    Expect(0, 100352, '\P{^Is_Block: Tangut}', "");
    Error('\p{Is_Blk:	:= 	TANGUT}');
    Error('\P{Is_Blk:	:= 	TANGUT}');
    Expect(1, 100351, '\p{Is_Blk=tangut}', "");
    Expect(0, 100351, '\p{^Is_Blk=tangut}', "");
    Expect(0, 100351, '\P{Is_Blk=tangut}', "");
    Expect(1, 100351, '\P{^Is_Blk=tangut}', "");
    Expect(0, 100352, '\p{Is_Blk=tangut}', "");
    Expect(1, 100352, '\p{^Is_Blk=tangut}', "");
    Expect(1, 100352, '\P{Is_Blk=tangut}', "");
    Expect(0, 100352, '\P{^Is_Blk=tangut}', "");
    Error('\p{Block=-:=TANGUT_Components}');
    Error('\P{Block=-:=TANGUT_Components}');
    Expect(1, 101119, '\p{Block=:\ATangut_Components\z:}', "");;
    Expect(0, 101120, '\p{Block=:\ATangut_Components\z:}', "");;
    Expect(1, 101119, '\p{Block=tangutcomponents}', "");
    Expect(0, 101119, '\p{^Block=tangutcomponents}', "");
    Expect(0, 101119, '\P{Block=tangutcomponents}', "");
    Expect(1, 101119, '\P{^Block=tangutcomponents}', "");
    Expect(0, 101120, '\p{Block=tangutcomponents}', "");
    Expect(1, 101120, '\p{^Block=tangutcomponents}', "");
    Expect(1, 101120, '\P{Block=tangutcomponents}', "");
    Expect(0, 101120, '\P{^Block=tangutcomponents}', "");
    Expect(1, 101119, '\p{Block=:\Atangutcomponents\z:}', "");;
    Expect(0, 101120, '\p{Block=:\Atangutcomponents\z:}', "");;
    Expect(1, 101119, '\p{Block=		Tangut_components}', "");
    Expect(0, 101119, '\p{^Block=		Tangut_components}', "");
    Expect(0, 101119, '\P{Block=		Tangut_components}', "");
    Expect(1, 101119, '\P{^Block=		Tangut_components}', "");
    Expect(0, 101120, '\p{Block=		Tangut_components}', "");
    Expect(1, 101120, '\p{^Block=		Tangut_components}', "");
    Expect(1, 101120, '\P{Block=		Tangut_components}', "");
    Expect(0, 101120, '\P{^Block=		Tangut_components}', "");
    Error('\p{Blk=--tangut_Components/a/}');
    Error('\P{Blk=--tangut_Components/a/}');
    Expect(1, 101119, '\p{Blk=:\ATangut_Components\z:}', "");;
    Expect(0, 101120, '\p{Blk=:\ATangut_Components\z:}', "");;
    Expect(1, 101119, '\p{Blk=tangutcomponents}', "");
    Expect(0, 101119, '\p{^Blk=tangutcomponents}', "");
    Expect(0, 101119, '\P{Blk=tangutcomponents}', "");
    Expect(1, 101119, '\P{^Blk=tangutcomponents}', "");
    Expect(0, 101120, '\p{Blk=tangutcomponents}', "");
    Expect(1, 101120, '\p{^Blk=tangutcomponents}', "");
    Expect(1, 101120, '\P{Blk=tangutcomponents}', "");
    Expect(0, 101120, '\P{^Blk=tangutcomponents}', "");
    Expect(1, 101119, '\p{Blk=:\Atangutcomponents\z:}', "");;
    Expect(0, 101120, '\p{Blk=:\Atangutcomponents\z:}', "");;
    Expect(1, 101119, '\p{Blk=_ TANGUT_components}', "");
    Expect(0, 101119, '\p{^Blk=_ TANGUT_components}', "");
    Expect(0, 101119, '\P{Blk=_ TANGUT_components}', "");
    Expect(1, 101119, '\P{^Blk=_ TANGUT_components}', "");
    Expect(0, 101120, '\p{Blk=_ TANGUT_components}', "");
    Expect(1, 101120, '\p{^Blk=_ TANGUT_components}', "");
    Expect(1, 101120, '\P{Blk=_ TANGUT_components}', "");
    Expect(0, 101120, '\P{^Blk=_ TANGUT_components}', "");
    Error('\p{Is_Block=_:=Tangut_components}');
    Error('\P{Is_Block=_:=Tangut_components}');
    Expect(1, 101119, '\p{Is_Block=tangutcomponents}', "");
    Expect(0, 101119, '\p{^Is_Block=tangutcomponents}', "");
    Expect(0, 101119, '\P{Is_Block=tangutcomponents}', "");
    Expect(1, 101119, '\P{^Is_Block=tangutcomponents}', "");
    Expect(0, 101120, '\p{Is_Block=tangutcomponents}', "");
    Expect(1, 101120, '\p{^Is_Block=tangutcomponents}', "");
    Expect(1, 101120, '\P{Is_Block=tangutcomponents}', "");
    Expect(0, 101120, '\P{^Is_Block=tangutcomponents}', "");
    Expect(1, 101119, '\p{Is_Block:__Tangut_components}', "");
    Expect(0, 101119, '\p{^Is_Block:__Tangut_components}', "");
    Expect(0, 101119, '\P{Is_Block:__Tangut_components}', "");
    Expect(1, 101119, '\P{^Is_Block:__Tangut_components}', "");
    Expect(0, 101120, '\p{Is_Block:__Tangut_components}', "");
    Expect(1, 101120, '\p{^Is_Block:__Tangut_components}', "");
    Expect(1, 101120, '\P{Is_Block:__Tangut_components}', "");
    Expect(0, 101120, '\P{^Is_Block:__Tangut_components}', "");
    Error('\p{Is_Blk=/a/	 Tangut_Components}');
    Error('\P{Is_Blk=/a/	 Tangut_Components}');
    Expect(1, 101119, '\p{Is_Blk=tangutcomponents}', "");
    Expect(0, 101119, '\p{^Is_Blk=tangutcomponents}', "");
    Expect(0, 101119, '\P{Is_Blk=tangutcomponents}', "");
    Expect(1, 101119, '\P{^Is_Blk=tangutcomponents}', "");
    Expect(0, 101120, '\p{Is_Blk=tangutcomponents}', "");
    Expect(1, 101120, '\p{^Is_Blk=tangutcomponents}', "");
    Expect(1, 101120, '\P{Is_Blk=tangutcomponents}', "");
    Expect(0, 101120, '\P{^Is_Blk=tangutcomponents}', "");
    Expect(1, 101119, '\p{Is_Blk=_-tangut_Components}', "");
    Expect(0, 101119, '\p{^Is_Blk=_-tangut_Components}', "");
    Expect(0, 101119, '\P{Is_Blk=_-tangut_Components}', "");
    Expect(1, 101119, '\P{^Is_Blk=_-tangut_Components}', "");
    Expect(0, 101120, '\p{Is_Blk=_-tangut_Components}', "");
    Expect(1, 101120, '\p{^Is_Blk=_-tangut_Components}', "");
    Expect(1, 101120, '\P{Is_Blk=_-tangut_Components}', "");
    Expect(0, 101120, '\P{^Is_Blk=_-tangut_Components}', "");
    Error('\p{Block=--Tangut_SUPPLEMENT/a/}');
    Error('\P{Block=--Tangut_SUPPLEMENT/a/}');
    Expect(1, 101759, '\p{Block=:\ATangut_Supplement\z:}', "");;
    Expect(0, 101760, '\p{Block=:\ATangut_Supplement\z:}', "");;
    Expect(1, 101759, '\p{Block=tangutsupplement}', "");
    Expect(0, 101759, '\p{^Block=tangutsupplement}', "");
    Expect(0, 101759, '\P{Block=tangutsupplement}', "");
    Expect(1, 101759, '\P{^Block=tangutsupplement}', "");
    Expect(0, 101760, '\p{Block=tangutsupplement}', "");
    Expect(1, 101760, '\p{^Block=tangutsupplement}', "");
    Expect(1, 101760, '\P{Block=tangutsupplement}', "");
    Expect(0, 101760, '\P{^Block=tangutsupplement}', "");
    Expect(1, 101759, '\p{Block=:\Atangutsupplement\z:}', "");;
    Expect(0, 101760, '\p{Block=:\Atangutsupplement\z:}', "");;
    Expect(1, 101759, '\p{Block=_	TANGUT_supplement}', "");
    Expect(0, 101759, '\p{^Block=_	TANGUT_supplement}', "");
    Expect(0, 101759, '\P{Block=_	TANGUT_supplement}', "");
    Expect(1, 101759, '\P{^Block=_	TANGUT_supplement}', "");
    Expect(0, 101760, '\p{Block=_	TANGUT_supplement}', "");
    Expect(1, 101760, '\p{^Block=_	TANGUT_supplement}', "");
    Expect(1, 101760, '\P{Block=_	TANGUT_supplement}', "");
    Expect(0, 101760, '\P{^Block=_	TANGUT_supplement}', "");
    Error('\p{Blk=:=-_Tangut_sup}');
    Error('\P{Blk=:=-_Tangut_sup}');
    Expect(1, 101759, '\p{Blk=:\ATangut_Sup\z:}', "");;
    Expect(0, 101760, '\p{Blk=:\ATangut_Sup\z:}', "");;
    Expect(1, 101759, '\p{Blk=tangutsup}', "");
    Expect(0, 101759, '\p{^Blk=tangutsup}', "");
    Expect(0, 101759, '\P{Blk=tangutsup}', "");
    Expect(1, 101759, '\P{^Blk=tangutsup}', "");
    Expect(0, 101760, '\p{Blk=tangutsup}', "");
    Expect(1, 101760, '\p{^Blk=tangutsup}', "");
    Expect(1, 101760, '\P{Blk=tangutsup}', "");
    Expect(0, 101760, '\P{^Blk=tangutsup}', "");
    Expect(1, 101759, '\p{Blk=:\Atangutsup\z:}', "");;
    Expect(0, 101760, '\p{Blk=:\Atangutsup\z:}', "");;
    Expect(1, 101759, '\p{Blk:    _tangut_Sup}', "");
    Expect(0, 101759, '\p{^Blk:    _tangut_Sup}', "");
    Expect(0, 101759, '\P{Blk:    _tangut_Sup}', "");
    Expect(1, 101759, '\P{^Blk:    _tangut_Sup}', "");
    Expect(0, 101760, '\p{Blk:    _tangut_Sup}', "");
    Expect(1, 101760, '\p{^Blk:    _tangut_Sup}', "");
    Expect(1, 101760, '\P{Blk:    _tangut_Sup}', "");
    Expect(0, 101760, '\P{^Blk:    _tangut_Sup}', "");
    Error('\p{Is_Block=/a/	-Tangut_Supplement}');
    Error('\P{Is_Block=/a/	-Tangut_Supplement}');
    Expect(1, 101759, '\p{Is_Block=tangutsupplement}', "");
    Expect(0, 101759, '\p{^Is_Block=tangutsupplement}', "");
    Expect(0, 101759, '\P{Is_Block=tangutsupplement}', "");
    Expect(1, 101759, '\P{^Is_Block=tangutsupplement}', "");
    Expect(0, 101760, '\p{Is_Block=tangutsupplement}', "");
    Expect(1, 101760, '\p{^Is_Block=tangutsupplement}', "");
    Expect(1, 101760, '\P{Is_Block=tangutsupplement}', "");
    Expect(0, 101760, '\P{^Is_Block=tangutsupplement}', "");
    Expect(1, 101759, '\p{Is_Block=	Tangut_supplement}', "");
    Expect(0, 101759, '\p{^Is_Block=	Tangut_supplement}', "");
    Expect(0, 101759, '\P{Is_Block=	Tangut_supplement}', "");
    Expect(1, 101759, '\P{^Is_Block=	Tangut_supplement}', "");
    Expect(0, 101760, '\p{Is_Block=	Tangut_supplement}', "");
    Expect(1, 101760, '\p{^Is_Block=	Tangut_supplement}', "");
    Expect(1, 101760, '\P{Is_Block=	Tangut_supplement}', "");
    Expect(0, 101760, '\P{^Is_Block=	Tangut_supplement}', "");
    Error('\p{Is_Blk:	tangut_Sup/a/}');
    Error('\P{Is_Blk:	tangut_Sup/a/}');
    Expect(1, 101759, '\p{Is_Blk=tangutsup}', "");
    Expect(0, 101759, '\p{^Is_Blk=tangutsup}', "");
    Expect(0, 101759, '\P{Is_Blk=tangutsup}', "");
    Expect(1, 101759, '\P{^Is_Blk=tangutsup}', "");
    Expect(0, 101760, '\p{Is_Blk=tangutsup}', "");
    Expect(1, 101760, '\p{^Is_Blk=tangutsup}', "");
    Expect(1, 101760, '\P{Is_Blk=tangutsup}', "");
    Expect(0, 101760, '\P{^Is_Blk=tangutsup}', "");
    Expect(1, 101759, '\p{Is_Blk=-TANGUT_SUP}', "");
    Expect(0, 101759, '\p{^Is_Blk=-TANGUT_SUP}', "");
    Expect(0, 101759, '\P{Is_Blk=-TANGUT_SUP}', "");
    Expect(1, 101759, '\P{^Is_Blk=-TANGUT_SUP}', "");
    Expect(0, 101760, '\p{Is_Blk=-TANGUT_SUP}', "");
    Expect(1, 101760, '\p{^Is_Blk=-TANGUT_SUP}', "");
    Expect(1, 101760, '\P{Is_Blk=-TANGUT_SUP}', "");
    Expect(0, 101760, '\P{^Is_Blk=-TANGUT_SUP}', "");
    Error('\p{Block=:=	TELUGU}');
    Error('\P{Block=:=	TELUGU}');
    Expect(1, 3199, '\p{Block=:\ATelugu\z:}', "");;
    Expect(0, 3200, '\p{Block=:\ATelugu\z:}', "");;
    Expect(1, 3199, '\p{Block=telugu}', "");
    Expect(0, 3199, '\p{^Block=telugu}', "");
    Expect(0, 3199, '\P{Block=telugu}', "");
    Expect(1, 3199, '\P{^Block=telugu}', "");
    Expect(0, 3200, '\p{Block=telugu}', "");
    Expect(1, 3200, '\p{^Block=telugu}', "");
    Expect(1, 3200, '\P{Block=telugu}', "");
    Expect(0, 3200, '\P{^Block=telugu}', "");
    Expect(1, 3199, '\p{Block=:\Atelugu\z:}', "");;
    Expect(0, 3200, '\p{Block=:\Atelugu\z:}', "");;
    Expect(1, 3199, '\p{Block=  telugu}', "");
    Expect(0, 3199, '\p{^Block=  telugu}', "");
    Expect(0, 3199, '\P{Block=  telugu}', "");
    Expect(1, 3199, '\P{^Block=  telugu}', "");
    Expect(0, 3200, '\p{Block=  telugu}', "");
    Expect(1, 3200, '\p{^Block=  telugu}', "");
    Expect(1, 3200, '\P{Block=  telugu}', "");
    Expect(0, 3200, '\P{^Block=  telugu}', "");
    Error('\p{Blk=	:=TELUGU}');
    Error('\P{Blk=	:=TELUGU}');
    Expect(1, 3199, '\p{Blk=:\ATelugu\z:}', "");;
    Expect(0, 3200, '\p{Blk=:\ATelugu\z:}', "");;
    Expect(1, 3199, '\p{Blk: telugu}', "");
    Expect(0, 3199, '\p{^Blk: telugu}', "");
    Expect(0, 3199, '\P{Blk: telugu}', "");
    Expect(1, 3199, '\P{^Blk: telugu}', "");
    Expect(0, 3200, '\p{Blk: telugu}', "");
    Expect(1, 3200, '\p{^Blk: telugu}', "");
    Expect(1, 3200, '\P{Blk: telugu}', "");
    Expect(0, 3200, '\P{^Blk: telugu}', "");
    Expect(1, 3199, '\p{Blk=:\Atelugu\z:}', "");;
    Expect(0, 3200, '\p{Blk=:\Atelugu\z:}', "");;
    Expect(1, 3199, '\p{Blk= Telugu}', "");
    Expect(0, 3199, '\p{^Blk= Telugu}', "");
    Expect(0, 3199, '\P{Blk= Telugu}', "");
    Expect(1, 3199, '\P{^Blk= Telugu}', "");
    Expect(0, 3200, '\p{Blk= Telugu}', "");
    Expect(1, 3200, '\p{^Blk= Telugu}', "");
    Expect(1, 3200, '\P{Blk= Telugu}', "");
    Expect(0, 3200, '\P{^Blk= Telugu}', "");
    Error('\p{Is_Block=:=	-TELUGU}');
    Error('\P{Is_Block=:=	-TELUGU}');
    Expect(1, 3199, '\p{Is_Block=telugu}', "");
    Expect(0, 3199, '\p{^Is_Block=telugu}', "");
    Expect(0, 3199, '\P{Is_Block=telugu}', "");
    Expect(1, 3199, '\P{^Is_Block=telugu}', "");
    Expect(0, 3200, '\p{Is_Block=telugu}', "");
    Expect(1, 3200, '\p{^Is_Block=telugu}', "");
    Expect(1, 3200, '\P{Is_Block=telugu}', "");
    Expect(0, 3200, '\P{^Is_Block=telugu}', "");
    Expect(1, 3199, '\p{Is_Block:	 Telugu}', "");
    Expect(0, 3199, '\p{^Is_Block:	 Telugu}', "");
    Expect(0, 3199, '\P{Is_Block:	 Telugu}', "");
    Expect(1, 3199, '\P{^Is_Block:	 Telugu}', "");
    Expect(0, 3200, '\p{Is_Block:	 Telugu}', "");
    Expect(1, 3200, '\p{^Is_Block:	 Telugu}', "");
    Expect(1, 3200, '\P{Is_Block:	 Telugu}', "");
    Expect(0, 3200, '\P{^Is_Block:	 Telugu}', "");
    Error('\p{Is_Blk=:=	_TELUGU}');
    Error('\P{Is_Blk=:=	_TELUGU}');
    Expect(1, 3199, '\p{Is_Blk=telugu}', "");
    Expect(0, 3199, '\p{^Is_Blk=telugu}', "");
    Expect(0, 3199, '\P{Is_Blk=telugu}', "");
    Expect(1, 3199, '\P{^Is_Blk=telugu}', "");
    Expect(0, 3200, '\p{Is_Blk=telugu}', "");
    Expect(1, 3200, '\p{^Is_Blk=telugu}', "");
    Expect(1, 3200, '\P{Is_Blk=telugu}', "");
    Expect(0, 3200, '\P{^Is_Blk=telugu}', "");
    Expect(1, 3199, '\p{Is_Blk= TELUGU}', "");
    Expect(0, 3199, '\p{^Is_Blk= TELUGU}', "");
    Expect(0, 3199, '\P{Is_Blk= TELUGU}', "");
    Expect(1, 3199, '\P{^Is_Blk= TELUGU}', "");
    Expect(0, 3200, '\p{Is_Blk= TELUGU}', "");
    Expect(1, 3200, '\p{^Is_Blk= TELUGU}', "");
    Expect(1, 3200, '\P{Is_Blk= TELUGU}', "");
    Expect(0, 3200, '\P{^Is_Blk= TELUGU}', "");
    Error('\p{Block=:= -Thaana}');
    Error('\P{Block=:= -Thaana}');
    Expect(1, 1983, '\p{Block=:\AThaana\z:}', "");;
    Expect(0, 1984, '\p{Block=:\AThaana\z:}', "");;
    Expect(1, 1983, '\p{Block=thaana}', "");
    Expect(0, 1983, '\p{^Block=thaana}', "");
    Expect(0, 1983, '\P{Block=thaana}', "");
    Expect(1, 1983, '\P{^Block=thaana}', "");
    Expect(0, 1984, '\p{Block=thaana}', "");
    Expect(1, 1984, '\p{^Block=thaana}', "");
    Expect(1, 1984, '\P{Block=thaana}', "");
    Expect(0, 1984, '\P{^Block=thaana}', "");
    Expect(1, 1983, '\p{Block=:\Athaana\z:}', "");;
    Expect(0, 1984, '\p{Block=:\Athaana\z:}', "");;
    Expect(1, 1983, '\p{Block=-	Thaana}', "");
    Expect(0, 1983, '\p{^Block=-	Thaana}', "");
    Expect(0, 1983, '\P{Block=-	Thaana}', "");
    Expect(1, 1983, '\P{^Block=-	Thaana}', "");
    Expect(0, 1984, '\p{Block=-	Thaana}', "");
    Expect(1, 1984, '\p{^Block=-	Thaana}', "");
    Expect(1, 1984, '\P{Block=-	Thaana}', "");
    Expect(0, 1984, '\P{^Block=-	Thaana}', "");
    Error('\p{Blk=/a/	-thaana}');
    Error('\P{Blk=/a/	-thaana}');
    Expect(1, 1983, '\p{Blk=:\AThaana\z:}', "");;
    Expect(0, 1984, '\p{Blk=:\AThaana\z:}', "");;
    Expect(1, 1983, '\p{Blk=thaana}', "");
    Expect(0, 1983, '\p{^Blk=thaana}', "");
    Expect(0, 1983, '\P{Blk=thaana}', "");
    Expect(1, 1983, '\P{^Blk=thaana}', "");
    Expect(0, 1984, '\p{Blk=thaana}', "");
    Expect(1, 1984, '\p{^Blk=thaana}', "");
    Expect(1, 1984, '\P{Blk=thaana}', "");
    Expect(0, 1984, '\P{^Blk=thaana}', "");
    Expect(1, 1983, '\p{Blk=:\Athaana\z:}', "");;
    Expect(0, 1984, '\p{Blk=:\Athaana\z:}', "");;
    Expect(1, 1983, '\p{Blk=-Thaana}', "");
    Expect(0, 1983, '\p{^Blk=-Thaana}', "");
    Expect(0, 1983, '\P{Blk=-Thaana}', "");
    Expect(1, 1983, '\P{^Blk=-Thaana}', "");
    Expect(0, 1984, '\p{Blk=-Thaana}', "");
    Expect(1, 1984, '\p{^Blk=-Thaana}', "");
    Expect(1, 1984, '\P{Blk=-Thaana}', "");
    Expect(0, 1984, '\P{^Blk=-Thaana}', "");
    Error('\p{Is_Block=/a/THAANA}');
    Error('\P{Is_Block=/a/THAANA}');
    Expect(1, 1983, '\p{Is_Block=thaana}', "");
    Expect(0, 1983, '\p{^Is_Block=thaana}', "");
    Expect(0, 1983, '\P{Is_Block=thaana}', "");
    Expect(1, 1983, '\P{^Is_Block=thaana}', "");
    Expect(0, 1984, '\p{Is_Block=thaana}', "");
    Expect(1, 1984, '\p{^Is_Block=thaana}', "");
    Expect(1, 1984, '\P{Is_Block=thaana}', "");
    Expect(0, 1984, '\P{^Is_Block=thaana}', "");
    Expect(1, 1983, '\p{Is_Block=-	Thaana}', "");
    Expect(0, 1983, '\p{^Is_Block=-	Thaana}', "");
    Expect(0, 1983, '\P{Is_Block=-	Thaana}', "");
    Expect(1, 1983, '\P{^Is_Block=-	Thaana}', "");
    Expect(0, 1984, '\p{Is_Block=-	Thaana}', "");
    Expect(1, 1984, '\p{^Is_Block=-	Thaana}', "");
    Expect(1, 1984, '\P{Is_Block=-	Thaana}', "");
    Expect(0, 1984, '\P{^Is_Block=-	Thaana}', "");
    Error('\p{Is_Blk=_ Thaana/a/}');
    Error('\P{Is_Blk=_ Thaana/a/}');
    Expect(1, 1983, '\p{Is_Blk=thaana}', "");
    Expect(0, 1983, '\p{^Is_Blk=thaana}', "");
    Expect(0, 1983, '\P{Is_Blk=thaana}', "");
    Expect(1, 1983, '\P{^Is_Blk=thaana}', "");
    Expect(0, 1984, '\p{Is_Blk=thaana}', "");
    Expect(1, 1984, '\p{^Is_Blk=thaana}', "");
    Expect(1, 1984, '\P{Is_Blk=thaana}', "");
    Expect(0, 1984, '\P{^Is_Blk=thaana}', "");
    Expect(1, 1983, '\p{Is_Blk=	THAANA}', "");
    Expect(0, 1983, '\p{^Is_Blk=	THAANA}', "");
    Expect(0, 1983, '\P{Is_Blk=	THAANA}', "");
    Expect(1, 1983, '\P{^Is_Blk=	THAANA}', "");
    Expect(0, 1984, '\p{Is_Blk=	THAANA}', "");
    Expect(1, 1984, '\p{^Is_Blk=	THAANA}', "");
    Expect(1, 1984, '\P{Is_Blk=	THAANA}', "");
    Expect(0, 1984, '\P{^Is_Blk=	THAANA}', "");
    Error('\p{Block= /a/Thai}');
    Error('\P{Block= /a/Thai}');
    Expect(1, 3711, '\p{Block=:\AThai\z:}', "");;
    Expect(0, 3712, '\p{Block=:\AThai\z:}', "");;
    Expect(1, 3711, '\p{Block=thai}', "");
    Expect(0, 3711, '\p{^Block=thai}', "");
    Expect(0, 3711, '\P{Block=thai}', "");
    Expect(1, 3711, '\P{^Block=thai}', "");
    Expect(0, 3712, '\p{Block=thai}', "");
    Expect(1, 3712, '\p{^Block=thai}', "");
    Expect(1, 3712, '\P{Block=thai}', "");
    Expect(0, 3712, '\P{^Block=thai}', "");
    Expect(1, 3711, '\p{Block=:\Athai\z:}', "");;
    Expect(0, 3712, '\p{Block=:\Athai\z:}', "");;
    Expect(1, 3711, '\p{Block=_-thai}', "");
    Expect(0, 3711, '\p{^Block=_-thai}', "");
    Expect(0, 3711, '\P{Block=_-thai}', "");
    Expect(1, 3711, '\P{^Block=_-thai}', "");
    Expect(0, 3712, '\p{Block=_-thai}', "");
    Expect(1, 3712, '\p{^Block=_-thai}', "");
    Expect(1, 3712, '\P{Block=_-thai}', "");
    Expect(0, 3712, '\P{^Block=_-thai}', "");
    Error('\p{Blk=_ Thai:=}');
    Error('\P{Blk=_ Thai:=}');
    Expect(1, 3711, '\p{Blk=:\AThai\z:}', "");;
    Expect(0, 3712, '\p{Blk=:\AThai\z:}', "");;
    Expect(1, 3711, '\p{Blk=thai}', "");
    Expect(0, 3711, '\p{^Blk=thai}', "");
    Expect(0, 3711, '\P{Blk=thai}', "");
    Expect(1, 3711, '\P{^Blk=thai}', "");
    Expect(0, 3712, '\p{Blk=thai}', "");
    Expect(1, 3712, '\p{^Blk=thai}', "");
    Expect(1, 3712, '\P{Blk=thai}', "");
    Expect(0, 3712, '\P{^Blk=thai}', "");
    Expect(1, 3711, '\p{Blk=:\Athai\z:}', "");;
    Expect(0, 3712, '\p{Blk=:\Athai\z:}', "");;
    Expect(1, 3711, '\p{Blk=	-Thai}', "");
    Expect(0, 3711, '\p{^Blk=	-Thai}', "");
    Expect(0, 3711, '\P{Blk=	-Thai}', "");
    Expect(1, 3711, '\P{^Blk=	-Thai}', "");
    Expect(0, 3712, '\p{Blk=	-Thai}', "");
    Expect(1, 3712, '\p{^Blk=	-Thai}', "");
    Expect(1, 3712, '\P{Blk=	-Thai}', "");
    Expect(0, 3712, '\P{^Blk=	-Thai}', "");
    Error('\p{Is_Block=/a/thai}');
    Error('\P{Is_Block=/a/thai}');
    Expect(1, 3711, '\p{Is_Block=thai}', "");
    Expect(0, 3711, '\p{^Is_Block=thai}', "");
    Expect(0, 3711, '\P{Is_Block=thai}', "");
    Expect(1, 3711, '\P{^Is_Block=thai}', "");
    Expect(0, 3712, '\p{Is_Block=thai}', "");
    Expect(1, 3712, '\p{^Is_Block=thai}', "");
    Expect(1, 3712, '\P{Is_Block=thai}', "");
    Expect(0, 3712, '\P{^Is_Block=thai}', "");
    Expect(1, 3711, '\p{Is_Block=	thai}', "");
    Expect(0, 3711, '\p{^Is_Block=	thai}', "");
    Expect(0, 3711, '\P{Is_Block=	thai}', "");
    Expect(1, 3711, '\P{^Is_Block=	thai}', "");
    Expect(0, 3712, '\p{Is_Block=	thai}', "");
    Expect(1, 3712, '\p{^Is_Block=	thai}', "");
    Expect(1, 3712, '\P{Is_Block=	thai}', "");
    Expect(0, 3712, '\P{^Is_Block=	thai}', "");
    Error('\p{Is_Blk=-/a/Thai}');
    Error('\P{Is_Blk=-/a/Thai}');
    Expect(1, 3711, '\p{Is_Blk=thai}', "");
    Expect(0, 3711, '\p{^Is_Blk=thai}', "");
    Expect(0, 3711, '\P{Is_Blk=thai}', "");
    Expect(1, 3711, '\P{^Is_Blk=thai}', "");
    Expect(0, 3712, '\p{Is_Blk=thai}', "");
    Expect(1, 3712, '\p{^Is_Blk=thai}', "");
    Expect(1, 3712, '\P{Is_Blk=thai}', "");
    Expect(0, 3712, '\P{^Is_Blk=thai}', "");
    Expect(1, 3711, '\p{Is_Blk=-thai}', "");
    Expect(0, 3711, '\p{^Is_Blk=-thai}', "");
    Expect(0, 3711, '\P{Is_Blk=-thai}', "");
    Expect(1, 3711, '\P{^Is_Blk=-thai}', "");
    Expect(0, 3712, '\p{Is_Blk=-thai}', "");
    Expect(1, 3712, '\p{^Is_Blk=-thai}', "");
    Expect(1, 3712, '\P{Is_Blk=-thai}', "");
    Expect(0, 3712, '\P{^Is_Blk=-thai}', "");
    Error('\p{Block=_Tibetan/a/}');
    Error('\P{Block=_Tibetan/a/}');
    Expect(1, 4095, '\p{Block=:\ATibetan\z:}', "");;
    Expect(0, 4096, '\p{Block=:\ATibetan\z:}', "");;
    Expect(1, 4095, '\p{Block=tibetan}', "");
    Expect(0, 4095, '\p{^Block=tibetan}', "");
    Expect(0, 4095, '\P{Block=tibetan}', "");
    Expect(1, 4095, '\P{^Block=tibetan}', "");
    Expect(0, 4096, '\p{Block=tibetan}', "");
    Expect(1, 4096, '\p{^Block=tibetan}', "");
    Expect(1, 4096, '\P{Block=tibetan}', "");
    Expect(0, 4096, '\P{^Block=tibetan}', "");
    Expect(1, 4095, '\p{Block=:\Atibetan\z:}', "");;
    Expect(0, 4096, '\p{Block=:\Atibetan\z:}', "");;
    Expect(1, 4095, '\p{Block= tibetan}', "");
    Expect(0, 4095, '\p{^Block= tibetan}', "");
    Expect(0, 4095, '\P{Block= tibetan}', "");
    Expect(1, 4095, '\P{^Block= tibetan}', "");
    Expect(0, 4096, '\p{Block= tibetan}', "");
    Expect(1, 4096, '\p{^Block= tibetan}', "");
    Expect(1, 4096, '\P{Block= tibetan}', "");
    Expect(0, 4096, '\P{^Block= tibetan}', "");
    Error('\p{Blk=	-TIBETAN/a/}');
    Error('\P{Blk=	-TIBETAN/a/}');
    Expect(1, 4095, '\p{Blk=:\ATibetan\z:}', "");;
    Expect(0, 4096, '\p{Blk=:\ATibetan\z:}', "");;
    Expect(1, 4095, '\p{Blk=tibetan}', "");
    Expect(0, 4095, '\p{^Blk=tibetan}', "");
    Expect(0, 4095, '\P{Blk=tibetan}', "");
    Expect(1, 4095, '\P{^Blk=tibetan}', "");
    Expect(0, 4096, '\p{Blk=tibetan}', "");
    Expect(1, 4096, '\p{^Blk=tibetan}', "");
    Expect(1, 4096, '\P{Blk=tibetan}', "");
    Expect(0, 4096, '\P{^Blk=tibetan}', "");
    Expect(1, 4095, '\p{Blk=:\Atibetan\z:}', "");;
    Expect(0, 4096, '\p{Blk=:\Atibetan\z:}', "");;
    Expect(1, 4095, '\p{Blk=	 Tibetan}', "");
    Expect(0, 4095, '\p{^Blk=	 Tibetan}', "");
    Expect(0, 4095, '\P{Blk=	 Tibetan}', "");
    Expect(1, 4095, '\P{^Blk=	 Tibetan}', "");
    Expect(0, 4096, '\p{Blk=	 Tibetan}', "");
    Expect(1, 4096, '\p{^Blk=	 Tibetan}', "");
    Expect(1, 4096, '\P{Blk=	 Tibetan}', "");
    Expect(0, 4096, '\P{^Blk=	 Tibetan}', "");
    Error('\p{Is_Block=/a/tibetan}');
    Error('\P{Is_Block=/a/tibetan}');
    Expect(1, 4095, '\p{Is_Block=tibetan}', "");
    Expect(0, 4095, '\p{^Is_Block=tibetan}', "");
    Expect(0, 4095, '\P{Is_Block=tibetan}', "");
    Expect(1, 4095, '\P{^Is_Block=tibetan}', "");
    Expect(0, 4096, '\p{Is_Block=tibetan}', "");
    Expect(1, 4096, '\p{^Is_Block=tibetan}', "");
    Expect(1, 4096, '\P{Is_Block=tibetan}', "");
    Expect(0, 4096, '\P{^Is_Block=tibetan}', "");
    Expect(1, 4095, '\p{Is_Block=_	tibetan}', "");
    Expect(0, 4095, '\p{^Is_Block=_	tibetan}', "");
    Expect(0, 4095, '\P{Is_Block=_	tibetan}', "");
    Expect(1, 4095, '\P{^Is_Block=_	tibetan}', "");
    Expect(0, 4096, '\p{Is_Block=_	tibetan}', "");
    Expect(1, 4096, '\p{^Is_Block=_	tibetan}', "");
    Expect(1, 4096, '\P{Is_Block=_	tibetan}', "");
    Expect(0, 4096, '\P{^Is_Block=_	tibetan}', "");
    Error('\p{Is_Blk=-	Tibetan/a/}');
    Error('\P{Is_Blk=-	Tibetan/a/}');
    Expect(1, 4095, '\p{Is_Blk=tibetan}', "");
    Expect(0, 4095, '\p{^Is_Blk=tibetan}', "");
    Expect(0, 4095, '\P{Is_Blk=tibetan}', "");
    Expect(1, 4095, '\P{^Is_Blk=tibetan}', "");
    Expect(0, 4096, '\p{Is_Blk=tibetan}', "");
    Expect(1, 4096, '\p{^Is_Blk=tibetan}', "");
    Expect(1, 4096, '\P{Is_Blk=tibetan}', "");
    Expect(0, 4096, '\P{^Is_Blk=tibetan}', "");
    Expect(1, 4095, '\p{Is_Blk= Tibetan}', "");
    Expect(0, 4095, '\p{^Is_Blk= Tibetan}', "");
    Expect(0, 4095, '\P{Is_Blk= Tibetan}', "");
    Expect(1, 4095, '\P{^Is_Blk= Tibetan}', "");
    Expect(0, 4096, '\p{Is_Blk= Tibetan}', "");
    Expect(1, 4096, '\p{^Is_Blk= Tibetan}', "");
    Expect(1, 4096, '\P{Is_Blk= Tibetan}', "");
    Expect(0, 4096, '\P{^Is_Blk= Tibetan}', "");
    Error('\p{Block=__TIFINAGH:=}');
    Error('\P{Block=__TIFINAGH:=}');
    Expect(1, 11647, '\p{Block=:\ATifinagh\z:}', "");;
    Expect(0, 11648, '\p{Block=:\ATifinagh\z:}', "");;
    Expect(1, 11647, '\p{Block=tifinagh}', "");
    Expect(0, 11647, '\p{^Block=tifinagh}', "");
    Expect(0, 11647, '\P{Block=tifinagh}', "");
    Expect(1, 11647, '\P{^Block=tifinagh}', "");
    Expect(0, 11648, '\p{Block=tifinagh}', "");
    Expect(1, 11648, '\p{^Block=tifinagh}', "");
    Expect(1, 11648, '\P{Block=tifinagh}', "");
    Expect(0, 11648, '\P{^Block=tifinagh}', "");
    Expect(1, 11647, '\p{Block=:\Atifinagh\z:}', "");;
    Expect(0, 11648, '\p{Block=:\Atifinagh\z:}', "");;
    Expect(1, 11647, '\p{Block=-Tifinagh}', "");
    Expect(0, 11647, '\p{^Block=-Tifinagh}', "");
    Expect(0, 11647, '\P{Block=-Tifinagh}', "");
    Expect(1, 11647, '\P{^Block=-Tifinagh}', "");
    Expect(0, 11648, '\p{Block=-Tifinagh}', "");
    Expect(1, 11648, '\p{^Block=-Tifinagh}', "");
    Expect(1, 11648, '\P{Block=-Tifinagh}', "");
    Expect(0, 11648, '\P{^Block=-Tifinagh}', "");
    Error('\p{Blk: :=-tifinagh}');
    Error('\P{Blk: :=-tifinagh}');
    Expect(1, 11647, '\p{Blk=:\ATifinagh\z:}', "");;
    Expect(0, 11648, '\p{Blk=:\ATifinagh\z:}', "");;
    Expect(1, 11647, '\p{Blk:   tifinagh}', "");
    Expect(0, 11647, '\p{^Blk:   tifinagh}', "");
    Expect(0, 11647, '\P{Blk:   tifinagh}', "");
    Expect(1, 11647, '\P{^Blk:   tifinagh}', "");
    Expect(0, 11648, '\p{Blk:   tifinagh}', "");
    Expect(1, 11648, '\p{^Blk:   tifinagh}', "");
    Expect(1, 11648, '\P{Blk:   tifinagh}', "");
    Expect(0, 11648, '\P{^Blk:   tifinagh}', "");
    Expect(1, 11647, '\p{Blk=:\Atifinagh\z:}', "");;
    Expect(0, 11648, '\p{Blk=:\Atifinagh\z:}', "");;
    Expect(1, 11647, '\p{Blk=--tifinagh}', "");
    Expect(0, 11647, '\p{^Blk=--tifinagh}', "");
    Expect(0, 11647, '\P{Blk=--tifinagh}', "");
    Expect(1, 11647, '\P{^Blk=--tifinagh}', "");
    Expect(0, 11648, '\p{Blk=--tifinagh}', "");
    Expect(1, 11648, '\p{^Blk=--tifinagh}', "");
    Expect(1, 11648, '\P{Blk=--tifinagh}', "");
    Expect(0, 11648, '\P{^Blk=--tifinagh}', "");
    Error('\p{Is_Block= /a/Tifinagh}');
    Error('\P{Is_Block= /a/Tifinagh}');
    Expect(1, 11647, '\p{Is_Block=tifinagh}', "");
    Expect(0, 11647, '\p{^Is_Block=tifinagh}', "");
    Expect(0, 11647, '\P{Is_Block=tifinagh}', "");
    Expect(1, 11647, '\P{^Is_Block=tifinagh}', "");
    Expect(0, 11648, '\p{Is_Block=tifinagh}', "");
    Expect(1, 11648, '\p{^Is_Block=tifinagh}', "");
    Expect(1, 11648, '\P{Is_Block=tifinagh}', "");
    Expect(0, 11648, '\P{^Is_Block=tifinagh}', "");
    Error('\p{Is_Blk= Tifinagh:=}');
    Error('\P{Is_Blk= Tifinagh:=}');
    Expect(1, 11647, '\p{Is_Blk=tifinagh}', "");
    Expect(0, 11647, '\p{^Is_Blk=tifinagh}', "");
    Expect(0, 11647, '\P{Is_Blk=tifinagh}', "");
    Expect(1, 11647, '\P{^Is_Blk=tifinagh}', "");
    Expect(0, 11648, '\p{Is_Blk=tifinagh}', "");
    Expect(1, 11648, '\p{^Is_Blk=tifinagh}', "");
    Expect(1, 11648, '\P{Is_Blk=tifinagh}', "");
    Expect(0, 11648, '\P{^Is_Blk=tifinagh}', "");
    Expect(1, 11647, '\p{Is_Blk:   _-TIFINAGH}', "");
    Expect(0, 11647, '\p{^Is_Blk:   _-TIFINAGH}', "");
    Expect(0, 11647, '\P{Is_Blk:   _-TIFINAGH}', "");
    Expect(1, 11647, '\P{^Is_Blk:   _-TIFINAGH}', "");
    Expect(0, 11648, '\p{Is_Blk:   _-TIFINAGH}', "");
    Expect(1, 11648, '\p{^Is_Blk:   _-TIFINAGH}', "");
    Expect(1, 11648, '\P{Is_Blk:   _-TIFINAGH}', "");
    Expect(0, 11648, '\P{^Is_Blk:   _-TIFINAGH}', "");
    Error('\p{Block=/a/_tirhuta}');
    Error('\P{Block=/a/_tirhuta}');
    Expect(1, 70879, '\p{Block=:\ATirhuta\z:}', "");;
    Expect(0, 70880, '\p{Block=:\ATirhuta\z:}', "");;
    Expect(1, 70879, '\p{Block=tirhuta}', "");
    Expect(0, 70879, '\p{^Block=tirhuta}', "");
    Expect(0, 70879, '\P{Block=tirhuta}', "");
    Expect(1, 70879, '\P{^Block=tirhuta}', "");
    Expect(0, 70880, '\p{Block=tirhuta}', "");
    Expect(1, 70880, '\p{^Block=tirhuta}', "");
    Expect(1, 70880, '\P{Block=tirhuta}', "");
    Expect(0, 70880, '\P{^Block=tirhuta}', "");
    Expect(1, 70879, '\p{Block=:\Atirhuta\z:}', "");;
    Expect(0, 70880, '\p{Block=:\Atirhuta\z:}', "");;
    Expect(1, 70879, '\p{Block=_Tirhuta}', "");
    Expect(0, 70879, '\p{^Block=_Tirhuta}', "");
    Expect(0, 70879, '\P{Block=_Tirhuta}', "");
    Expect(1, 70879, '\P{^Block=_Tirhuta}', "");
    Expect(0, 70880, '\p{Block=_Tirhuta}', "");
    Expect(1, 70880, '\p{^Block=_Tirhuta}', "");
    Expect(1, 70880, '\P{Block=_Tirhuta}', "");
    Expect(0, 70880, '\P{^Block=_Tirhuta}', "");
    Error('\p{Blk: -Tirhuta:=}');
    Error('\P{Blk: -Tirhuta:=}');
    Expect(1, 70879, '\p{Blk=:\ATirhuta\z:}', "");;
    Expect(0, 70880, '\p{Blk=:\ATirhuta\z:}', "");;
    Expect(1, 70879, '\p{Blk=tirhuta}', "");
    Expect(0, 70879, '\p{^Blk=tirhuta}', "");
    Expect(0, 70879, '\P{Blk=tirhuta}', "");
    Expect(1, 70879, '\P{^Blk=tirhuta}', "");
    Expect(0, 70880, '\p{Blk=tirhuta}', "");
    Expect(1, 70880, '\p{^Blk=tirhuta}', "");
    Expect(1, 70880, '\P{Blk=tirhuta}', "");
    Expect(0, 70880, '\P{^Blk=tirhuta}', "");
    Expect(1, 70879, '\p{Blk=:\Atirhuta\z:}', "");;
    Expect(0, 70880, '\p{Blk=:\Atirhuta\z:}', "");;
    Expect(1, 70879, '\p{Blk=_-TIRHUTA}', "");
    Expect(0, 70879, '\p{^Blk=_-TIRHUTA}', "");
    Expect(0, 70879, '\P{Blk=_-TIRHUTA}', "");
    Expect(1, 70879, '\P{^Blk=_-TIRHUTA}', "");
    Expect(0, 70880, '\p{Blk=_-TIRHUTA}', "");
    Expect(1, 70880, '\p{^Blk=_-TIRHUTA}', "");
    Expect(1, 70880, '\P{Blk=_-TIRHUTA}', "");
    Expect(0, 70880, '\P{^Blk=_-TIRHUTA}', "");
    Error('\p{Is_Block:		/a/Tirhuta}');
    Error('\P{Is_Block:		/a/Tirhuta}');
    Expect(1, 70879, '\p{Is_Block=tirhuta}', "");
    Expect(0, 70879, '\p{^Is_Block=tirhuta}', "");
    Expect(0, 70879, '\P{Is_Block=tirhuta}', "");
    Expect(1, 70879, '\P{^Is_Block=tirhuta}', "");
    Expect(0, 70880, '\p{Is_Block=tirhuta}', "");
    Expect(1, 70880, '\p{^Is_Block=tirhuta}', "");
    Expect(1, 70880, '\P{Is_Block=tirhuta}', "");
    Expect(0, 70880, '\P{^Is_Block=tirhuta}', "");
    Expect(1, 70879, '\p{Is_Block=-Tirhuta}', "");
    Expect(0, 70879, '\p{^Is_Block=-Tirhuta}', "");
    Expect(0, 70879, '\P{Is_Block=-Tirhuta}', "");
    Expect(1, 70879, '\P{^Is_Block=-Tirhuta}', "");
    Expect(0, 70880, '\p{Is_Block=-Tirhuta}', "");
    Expect(1, 70880, '\p{^Is_Block=-Tirhuta}', "");
    Expect(1, 70880, '\P{Is_Block=-Tirhuta}', "");
    Expect(0, 70880, '\P{^Is_Block=-Tirhuta}', "");
    Error('\p{Is_Blk= /a/tirhuta}');
    Error('\P{Is_Blk= /a/tirhuta}');
    Expect(1, 70879, '\p{Is_Blk=tirhuta}', "");
    Expect(0, 70879, '\p{^Is_Blk=tirhuta}', "");
    Expect(0, 70879, '\P{Is_Blk=tirhuta}', "");
    Expect(1, 70879, '\P{^Is_Blk=tirhuta}', "");
    Expect(0, 70880, '\p{Is_Blk=tirhuta}', "");
    Expect(1, 70880, '\p{^Is_Blk=tirhuta}', "");
    Expect(1, 70880, '\P{Is_Blk=tirhuta}', "");
    Expect(0, 70880, '\P{^Is_Blk=tirhuta}', "");
    Expect(1, 70879, '\p{Is_Blk=	 Tirhuta}', "");
    Expect(0, 70879, '\p{^Is_Blk=	 Tirhuta}', "");
    Expect(0, 70879, '\P{Is_Blk=	 Tirhuta}', "");
    Expect(1, 70879, '\P{^Is_Blk=	 Tirhuta}', "");
    Expect(0, 70880, '\p{Is_Blk=	 Tirhuta}', "");
    Expect(1, 70880, '\p{^Is_Blk=	 Tirhuta}', "");
    Expect(1, 70880, '\P{Is_Blk=	 Tirhuta}', "");
    Expect(0, 70880, '\P{^Is_Blk=	 Tirhuta}', "");
    Error('\p{Block:   -_TOTO/a/}');
    Error('\P{Block:   -_TOTO/a/}');
    Expect(1, 123583, '\p{Block=:\AToto\z:}', "");;
    Expect(0, 123584, '\p{Block=:\AToto\z:}', "");;
    Expect(1, 123583, '\p{Block=toto}', "");
    Expect(0, 123583, '\p{^Block=toto}', "");
    Expect(0, 123583, '\P{Block=toto}', "");
    Expect(1, 123583, '\P{^Block=toto}', "");
    Expect(0, 123584, '\p{Block=toto}', "");
    Expect(1, 123584, '\p{^Block=toto}', "");
    Expect(1, 123584, '\P{Block=toto}', "");
    Expect(0, 123584, '\P{^Block=toto}', "");
    Expect(1, 123583, '\p{Block=:\Atoto\z:}', "");;
    Expect(0, 123584, '\p{Block=:\Atoto\z:}', "");;
    Expect(1, 123583, '\p{Block:	-Toto}', "");
    Expect(0, 123583, '\p{^Block:	-Toto}', "");
    Expect(0, 123583, '\P{Block:	-Toto}', "");
    Expect(1, 123583, '\P{^Block:	-Toto}', "");
    Expect(0, 123584, '\p{Block:	-Toto}', "");
    Expect(1, 123584, '\p{^Block:	-Toto}', "");
    Expect(1, 123584, '\P{Block:	-Toto}', "");
    Expect(0, 123584, '\P{^Block:	-Toto}', "");
    Error('\p{Blk=_/a/Toto}');
    Error('\P{Blk=_/a/Toto}');
    Expect(1, 123583, '\p{Blk=:\AToto\z:}', "");;
    Expect(0, 123584, '\p{Blk=:\AToto\z:}', "");;
    Expect(1, 123583, '\p{Blk=toto}', "");
    Expect(0, 123583, '\p{^Blk=toto}', "");
    Expect(0, 123583, '\P{Blk=toto}', "");
    Expect(1, 123583, '\P{^Blk=toto}', "");
    Expect(0, 123584, '\p{Blk=toto}', "");
    Expect(1, 123584, '\p{^Blk=toto}', "");
    Expect(1, 123584, '\P{Blk=toto}', "");
    Expect(0, 123584, '\P{^Blk=toto}', "");
    Expect(1, 123583, '\p{Blk=:\Atoto\z:}', "");;
    Expect(0, 123584, '\p{Blk=:\Atoto\z:}', "");;
    Expect(1, 123583, '\p{Blk:_-toto}', "");
    Expect(0, 123583, '\p{^Blk:_-toto}', "");
    Expect(0, 123583, '\P{Blk:_-toto}', "");
    Expect(1, 123583, '\P{^Blk:_-toto}', "");
    Expect(0, 123584, '\p{Blk:_-toto}', "");
    Expect(1, 123584, '\p{^Blk:_-toto}', "");
    Expect(1, 123584, '\P{Blk:_-toto}', "");
    Expect(0, 123584, '\P{^Blk:_-toto}', "");
    Error('\p{Is_Block=	 TOTO/a/}');
    Error('\P{Is_Block=	 TOTO/a/}');
    Expect(1, 123583, '\p{Is_Block=toto}', "");
    Expect(0, 123583, '\p{^Is_Block=toto}', "");
    Expect(0, 123583, '\P{Is_Block=toto}', "");
    Expect(1, 123583, '\P{^Is_Block=toto}', "");
    Expect(0, 123584, '\p{Is_Block=toto}', "");
    Expect(1, 123584, '\p{^Is_Block=toto}', "");
    Expect(1, 123584, '\P{Is_Block=toto}', "");
    Expect(0, 123584, '\P{^Is_Block=toto}', "");
    Expect(1, 123583, '\p{Is_Block=_Toto}', "");
    Expect(0, 123583, '\p{^Is_Block=_Toto}', "");
    Expect(0, 123583, '\P{Is_Block=_Toto}', "");
    Expect(1, 123583, '\P{^Is_Block=_Toto}', "");
    Expect(0, 123584, '\p{Is_Block=_Toto}', "");
    Expect(1, 123584, '\p{^Is_Block=_Toto}', "");
    Expect(1, 123584, '\P{Is_Block=_Toto}', "");
    Expect(0, 123584, '\P{^Is_Block=_Toto}', "");
    Error('\p{Is_Blk=/a/_-toto}');
    Error('\P{Is_Blk=/a/_-toto}');
    Expect(1, 123583, '\p{Is_Blk=toto}', "");
    Expect(0, 123583, '\p{^Is_Blk=toto}', "");
    Expect(0, 123583, '\P{Is_Blk=toto}', "");
    Expect(1, 123583, '\P{^Is_Blk=toto}', "");
    Expect(0, 123584, '\p{Is_Blk=toto}', "");
    Expect(1, 123584, '\p{^Is_Blk=toto}', "");
    Expect(1, 123584, '\P{Is_Blk=toto}', "");
    Expect(0, 123584, '\P{^Is_Blk=toto}', "");
    Expect(1, 123583, '\p{Is_Blk=_toto}', "");
    Expect(0, 123583, '\p{^Is_Blk=_toto}', "");
    Expect(0, 123583, '\P{Is_Blk=_toto}', "");
    Expect(1, 123583, '\P{^Is_Blk=_toto}', "");
    Expect(0, 123584, '\p{Is_Blk=_toto}', "");
    Expect(1, 123584, '\p{^Is_Blk=_toto}', "");
    Expect(1, 123584, '\P{Is_Blk=_toto}', "");
    Expect(0, 123584, '\P{^Is_Blk=_toto}', "");
    Error('\p{Block=_:=Transport_And_map_symbols}');
    Error('\P{Block=_:=Transport_And_map_symbols}');
    Expect(1, 128767, '\p{Block=:\ATransport_And_Map_Symbols\z:}', "");;
    Expect(0, 128768, '\p{Block=:\ATransport_And_Map_Symbols\z:}', "");;
    Expect(1, 128767, '\p{Block=transportandmapsymbols}', "");
    Expect(0, 128767, '\p{^Block=transportandmapsymbols}', "");
    Expect(0, 128767, '\P{Block=transportandmapsymbols}', "");
    Expect(1, 128767, '\P{^Block=transportandmapsymbols}', "");
    Expect(0, 128768, '\p{Block=transportandmapsymbols}', "");
    Expect(1, 128768, '\p{^Block=transportandmapsymbols}', "");
    Expect(1, 128768, '\P{Block=transportandmapsymbols}', "");
    Expect(0, 128768, '\P{^Block=transportandmapsymbols}', "");
    Expect(1, 128767, '\p{Block=:\Atransportandmapsymbols\z:}', "");;
    Expect(0, 128768, '\p{Block=:\Atransportandmapsymbols\z:}', "");;
    Expect(1, 128767, '\p{Block= 	Transport_And_map_symbols}', "");
    Expect(0, 128767, '\p{^Block= 	Transport_And_map_symbols}', "");
    Expect(0, 128767, '\P{Block= 	Transport_And_map_symbols}', "");
    Expect(1, 128767, '\P{^Block= 	Transport_And_map_symbols}', "");
    Expect(0, 128768, '\p{Block= 	Transport_And_map_symbols}', "");
    Expect(1, 128768, '\p{^Block= 	Transport_And_map_symbols}', "");
    Expect(1, 128768, '\P{Block= 	Transport_And_map_symbols}', "");
    Expect(0, 128768, '\P{^Block= 	Transport_And_map_symbols}', "");
    Error('\p{Blk=:=--transport_AND_Map}');
    Error('\P{Blk=:=--transport_AND_Map}');
    Expect(1, 128767, '\p{Blk=:\ATransport_And_Map\z:}', "");;
    Expect(0, 128768, '\p{Blk=:\ATransport_And_Map\z:}', "");;
    Expect(1, 128767, '\p{Blk=transportandmap}', "");
    Expect(0, 128767, '\p{^Blk=transportandmap}', "");
    Expect(0, 128767, '\P{Blk=transportandmap}', "");
    Expect(1, 128767, '\P{^Blk=transportandmap}', "");
    Expect(0, 128768, '\p{Blk=transportandmap}', "");
    Expect(1, 128768, '\p{^Blk=transportandmap}', "");
    Expect(1, 128768, '\P{Blk=transportandmap}', "");
    Expect(0, 128768, '\P{^Blk=transportandmap}', "");
    Expect(1, 128767, '\p{Blk=:\Atransportandmap\z:}', "");;
    Expect(0, 128768, '\p{Blk=:\Atransportandmap\z:}', "");;
    Expect(1, 128767, '\p{Blk=_	Transport_AND_Map}', "");
    Expect(0, 128767, '\p{^Blk=_	Transport_AND_Map}', "");
    Expect(0, 128767, '\P{Blk=_	Transport_AND_Map}', "");
    Expect(1, 128767, '\P{^Blk=_	Transport_AND_Map}', "");
    Expect(0, 128768, '\p{Blk=_	Transport_AND_Map}', "");
    Expect(1, 128768, '\p{^Blk=_	Transport_AND_Map}', "");
    Expect(1, 128768, '\P{Blk=_	Transport_AND_Map}', "");
    Expect(0, 128768, '\P{^Blk=_	Transport_AND_Map}', "");
    Error('\p{Is_Block=/a/ _Transport_and_Map_SYMBOLS}');
    Error('\P{Is_Block=/a/ _Transport_and_Map_SYMBOLS}');
    Expect(1, 128767, '\p{Is_Block=transportandmapsymbols}', "");
    Expect(0, 128767, '\p{^Is_Block=transportandmapsymbols}', "");
    Expect(0, 128767, '\P{Is_Block=transportandmapsymbols}', "");
    Expect(1, 128767, '\P{^Is_Block=transportandmapsymbols}', "");
    Expect(0, 128768, '\p{Is_Block=transportandmapsymbols}', "");
    Expect(1, 128768, '\p{^Is_Block=transportandmapsymbols}', "");
    Expect(1, 128768, '\P{Is_Block=transportandmapsymbols}', "");
    Expect(0, 128768, '\P{^Is_Block=transportandmapsymbols}', "");
    Expect(1, 128767, '\p{Is_Block= transport_AND_Map_Symbols}', "");
    Expect(0, 128767, '\p{^Is_Block= transport_AND_Map_Symbols}', "");
    Expect(0, 128767, '\P{Is_Block= transport_AND_Map_Symbols}', "");
    Expect(1, 128767, '\P{^Is_Block= transport_AND_Map_Symbols}', "");
    Expect(0, 128768, '\p{Is_Block= transport_AND_Map_Symbols}', "");
    Expect(1, 128768, '\p{^Is_Block= transport_AND_Map_Symbols}', "");
    Expect(1, 128768, '\P{Is_Block= transport_AND_Map_Symbols}', "");
    Expect(0, 128768, '\P{^Is_Block= transport_AND_Map_Symbols}', "");
    Error('\p{Is_Blk=:=Transport_And_Map}');
    Error('\P{Is_Blk=:=Transport_And_Map}');
    Expect(1, 128767, '\p{Is_Blk=transportandmap}', "");
    Expect(0, 128767, '\p{^Is_Blk=transportandmap}', "");
    Expect(0, 128767, '\P{Is_Blk=transportandmap}', "");
    Expect(1, 128767, '\P{^Is_Blk=transportandmap}', "");
    Expect(0, 128768, '\p{Is_Blk=transportandmap}', "");
    Expect(1, 128768, '\p{^Is_Blk=transportandmap}', "");
    Expect(1, 128768, '\P{Is_Blk=transportandmap}', "");
    Expect(0, 128768, '\P{^Is_Blk=transportandmap}', "");
    Expect(1, 128767, '\p{Is_Blk=__Transport_and_MAP}', "");
    Expect(0, 128767, '\p{^Is_Blk=__Transport_and_MAP}', "");
    Expect(0, 128767, '\P{Is_Blk=__Transport_and_MAP}', "");
    Expect(1, 128767, '\P{^Is_Blk=__Transport_and_MAP}', "");
    Expect(0, 128768, '\p{Is_Blk=__Transport_and_MAP}', "");
    Expect(1, 128768, '\p{^Is_Blk=__Transport_and_MAP}', "");
    Expect(1, 128768, '\P{Is_Blk=__Transport_and_MAP}', "");
    Expect(0, 128768, '\P{^Is_Blk=__Transport_and_MAP}', "");
    Error('\p{Block=_/a/Unified_Canadian_Aboriginal_syllabics}');
    Error('\P{Block=_/a/Unified_Canadian_Aboriginal_syllabics}');
    Expect(1, 5759, '\p{Block=:\AUnified_Canadian_Aboriginal_Syllabics\z:}', "");;
    Expect(0, 5760, '\p{Block=:\AUnified_Canadian_Aboriginal_Syllabics\z:}', "");;
    Expect(1, 5759, '\p{Block=unifiedcanadianaboriginalsyllabics}', "");
    Expect(0, 5759, '\p{^Block=unifiedcanadianaboriginalsyllabics}', "");
    Expect(0, 5759, '\P{Block=unifiedcanadianaboriginalsyllabics}', "");
    Expect(1, 5759, '\P{^Block=unifiedcanadianaboriginalsyllabics}', "");
    Expect(0, 5760, '\p{Block=unifiedcanadianaboriginalsyllabics}', "");
    Expect(1, 5760, '\p{^Block=unifiedcanadianaboriginalsyllabics}', "");
    Expect(1, 5760, '\P{Block=unifiedcanadianaboriginalsyllabics}', "");
    Expect(0, 5760, '\P{^Block=unifiedcanadianaboriginalsyllabics}', "");
    Expect(1, 5759, '\p{Block=:\Aunifiedcanadianaboriginalsyllabics\z:}', "");;
    Expect(0, 5760, '\p{Block=:\Aunifiedcanadianaboriginalsyllabics\z:}', "");;
    Expect(1, 5759, '\p{Block=  UNIFIED_CANADIAN_ABORIGINAL_Syllabics}', "");
    Expect(0, 5759, '\p{^Block=  UNIFIED_CANADIAN_ABORIGINAL_Syllabics}', "");
    Expect(0, 5759, '\P{Block=  UNIFIED_CANADIAN_ABORIGINAL_Syllabics}', "");
    Expect(1, 5759, '\P{^Block=  UNIFIED_CANADIAN_ABORIGINAL_Syllabics}', "");
    Expect(0, 5760, '\p{Block=  UNIFIED_CANADIAN_ABORIGINAL_Syllabics}', "");
    Expect(1, 5760, '\p{^Block=  UNIFIED_CANADIAN_ABORIGINAL_Syllabics}', "");
    Expect(1, 5760, '\P{Block=  UNIFIED_CANADIAN_ABORIGINAL_Syllabics}', "");
    Expect(0, 5760, '\P{^Block=  UNIFIED_CANADIAN_ABORIGINAL_Syllabics}', "");
    Error('\p{Blk=:= ucas}');
    Error('\P{Blk=:= ucas}');
    Expect(1, 5759, '\p{Blk=:\AUCAS\z:}', "");;
    Expect(0, 5760, '\p{Blk=:\AUCAS\z:}', "");;
    Expect(1, 5759, '\p{Blk=ucas}', "");
    Expect(0, 5759, '\p{^Blk=ucas}', "");
    Expect(0, 5759, '\P{Blk=ucas}', "");
    Expect(1, 5759, '\P{^Blk=ucas}', "");
    Expect(0, 5760, '\p{Blk=ucas}', "");
    Expect(1, 5760, '\p{^Blk=ucas}', "");
    Expect(1, 5760, '\P{Blk=ucas}', "");
    Expect(0, 5760, '\P{^Blk=ucas}', "");
    Expect(1, 5759, '\p{Blk=:\Aucas\z:}', "");;
    Expect(0, 5760, '\p{Blk=:\Aucas\z:}', "");;
    Expect(1, 5759, '\p{Blk=	_ucas}', "");
    Expect(0, 5759, '\p{^Blk=	_ucas}', "");
    Expect(0, 5759, '\P{Blk=	_ucas}', "");
    Expect(1, 5759, '\P{^Blk=	_ucas}', "");
    Expect(0, 5760, '\p{Blk=	_ucas}', "");
    Expect(1, 5760, '\p{^Blk=	_ucas}', "");
    Expect(1, 5760, '\P{Blk=	_ucas}', "");
    Expect(0, 5760, '\P{^Blk=	_ucas}', "");
    Error('\p{Is_Block:   :=-_Canadian_Syllabics}');
    Error('\P{Is_Block:   :=-_Canadian_Syllabics}');
    Expect(1, 5759, '\p{Is_Block=canadiansyllabics}', "");
    Expect(0, 5759, '\p{^Is_Block=canadiansyllabics}', "");
    Expect(0, 5759, '\P{Is_Block=canadiansyllabics}', "");
    Expect(1, 5759, '\P{^Is_Block=canadiansyllabics}', "");
    Expect(0, 5760, '\p{Is_Block=canadiansyllabics}', "");
    Expect(1, 5760, '\p{^Is_Block=canadiansyllabics}', "");
    Expect(1, 5760, '\P{Is_Block=canadiansyllabics}', "");
    Expect(0, 5760, '\P{^Is_Block=canadiansyllabics}', "");
    Expect(1, 5759, '\p{Is_Block=- Canadian_syllabics}', "");
    Expect(0, 5759, '\p{^Is_Block=- Canadian_syllabics}', "");
    Expect(0, 5759, '\P{Is_Block=- Canadian_syllabics}', "");
    Expect(1, 5759, '\P{^Is_Block=- Canadian_syllabics}', "");
    Expect(0, 5760, '\p{Is_Block=- Canadian_syllabics}', "");
    Expect(1, 5760, '\p{^Is_Block=- Canadian_syllabics}', "");
    Expect(1, 5760, '\P{Is_Block=- Canadian_syllabics}', "");
    Expect(0, 5760, '\P{^Is_Block=- Canadian_syllabics}', "");
    Error('\p{Is_Blk=unified_Canadian_Aboriginal_Syllabics/a/}');
    Error('\P{Is_Blk=unified_Canadian_Aboriginal_Syllabics/a/}');
    Expect(1, 5759, '\p{Is_Blk=unifiedcanadianaboriginalsyllabics}', "");
    Expect(0, 5759, '\p{^Is_Blk=unifiedcanadianaboriginalsyllabics}', "");
    Expect(0, 5759, '\P{Is_Blk=unifiedcanadianaboriginalsyllabics}', "");
    Expect(1, 5759, '\P{^Is_Blk=unifiedcanadianaboriginalsyllabics}', "");
    Expect(0, 5760, '\p{Is_Blk=unifiedcanadianaboriginalsyllabics}', "");
    Expect(1, 5760, '\p{^Is_Blk=unifiedcanadianaboriginalsyllabics}', "");
    Expect(1, 5760, '\P{Is_Blk=unifiedcanadianaboriginalsyllabics}', "");
    Expect(0, 5760, '\P{^Is_Blk=unifiedcanadianaboriginalsyllabics}', "");
    Expect(1, 5759, '\p{Is_Blk=_ unified_canadian_aboriginal_Syllabics}', "");
    Expect(0, 5759, '\p{^Is_Blk=_ unified_canadian_aboriginal_Syllabics}', "");
    Expect(0, 5759, '\P{Is_Blk=_ unified_canadian_aboriginal_Syllabics}', "");
    Expect(1, 5759, '\P{^Is_Blk=_ unified_canadian_aboriginal_Syllabics}', "");
    Expect(0, 5760, '\p{Is_Blk=_ unified_canadian_aboriginal_Syllabics}', "");
    Expect(1, 5760, '\p{^Is_Blk=_ unified_canadian_aboriginal_Syllabics}', "");
    Expect(1, 5760, '\P{Is_Blk=_ unified_canadian_aboriginal_Syllabics}', "");
    Expect(0, 5760, '\P{^Is_Blk=_ unified_canadian_aboriginal_Syllabics}', "");
    Error('\p{Block: /a/_ Unified_canadian_aboriginal_SYLLABICS_Extended}');
    Error('\P{Block: /a/_ Unified_canadian_aboriginal_SYLLABICS_Extended}');
    Expect(1, 6399, '\p{Block=:\AUnified_Canadian_Aboriginal_Syllabics_Extended\z:}', "");;
    Expect(0, 6400, '\p{Block=:\AUnified_Canadian_Aboriginal_Syllabics_Extended\z:}', "");;
    Expect(1, 6399, '\p{Block=unifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(0, 6399, '\p{^Block=unifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(0, 6399, '\P{Block=unifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(1, 6399, '\P{^Block=unifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(0, 6400, '\p{Block=unifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(1, 6400, '\p{^Block=unifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(1, 6400, '\P{Block=unifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(0, 6400, '\P{^Block=unifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(1, 6399, '\p{Block=:\Aunifiedcanadianaboriginalsyllabicsextended\z:}', "");;
    Expect(0, 6400, '\p{Block=:\Aunifiedcanadianaboriginalsyllabicsextended\z:}', "");;
    Expect(1, 6399, '\p{Block:	_ Unified_canadian_Aboriginal_syllabics_Extended}', "");
    Expect(0, 6399, '\p{^Block:	_ Unified_canadian_Aboriginal_syllabics_Extended}', "");
    Expect(0, 6399, '\P{Block:	_ Unified_canadian_Aboriginal_syllabics_Extended}', "");
    Expect(1, 6399, '\P{^Block:	_ Unified_canadian_Aboriginal_syllabics_Extended}', "");
    Expect(0, 6400, '\p{Block:	_ Unified_canadian_Aboriginal_syllabics_Extended}', "");
    Expect(1, 6400, '\p{^Block:	_ Unified_canadian_Aboriginal_syllabics_Extended}', "");
    Expect(1, 6400, '\P{Block:	_ Unified_canadian_Aboriginal_syllabics_Extended}', "");
    Expect(0, 6400, '\P{^Block:	_ Unified_canadian_Aboriginal_syllabics_Extended}', "");
    Error('\p{Blk:  /a/UCAS_EXT}');
    Error('\P{Blk:  /a/UCAS_EXT}');
    Expect(1, 6399, '\p{Blk=:\AUCAS_Ext\z:}', "");;
    Expect(0, 6400, '\p{Blk=:\AUCAS_Ext\z:}', "");;
    Expect(1, 6399, '\p{Blk=ucasext}', "");
    Expect(0, 6399, '\p{^Blk=ucasext}', "");
    Expect(0, 6399, '\P{Blk=ucasext}', "");
    Expect(1, 6399, '\P{^Blk=ucasext}', "");
    Expect(0, 6400, '\p{Blk=ucasext}', "");
    Expect(1, 6400, '\p{^Blk=ucasext}', "");
    Expect(1, 6400, '\P{Blk=ucasext}', "");
    Expect(0, 6400, '\P{^Blk=ucasext}', "");
    Expect(1, 6399, '\p{Blk=:\Aucasext\z:}', "");;
    Expect(0, 6400, '\p{Blk=:\Aucasext\z:}', "");;
    Expect(1, 6399, '\p{Blk=-	UCAS_EXT}', "");
    Expect(0, 6399, '\p{^Blk=-	UCAS_EXT}', "");
    Expect(0, 6399, '\P{Blk=-	UCAS_EXT}', "");
    Expect(1, 6399, '\P{^Blk=-	UCAS_EXT}', "");
    Expect(0, 6400, '\p{Blk=-	UCAS_EXT}', "");
    Expect(1, 6400, '\p{^Blk=-	UCAS_EXT}', "");
    Expect(1, 6400, '\P{Blk=-	UCAS_EXT}', "");
    Expect(0, 6400, '\P{^Blk=-	UCAS_EXT}', "");
    Error('\p{Is_Block=-	unified_CANADIAN_Aboriginal_Syllabics_extended/a/}');
    Error('\P{Is_Block=-	unified_CANADIAN_Aboriginal_Syllabics_extended/a/}');
    Expect(1, 6399, '\p{Is_Block:unifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(0, 6399, '\p{^Is_Block:unifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(0, 6399, '\P{Is_Block:unifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(1, 6399, '\P{^Is_Block:unifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(0, 6400, '\p{Is_Block:unifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(1, 6400, '\p{^Is_Block:unifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(1, 6400, '\P{Is_Block:unifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(0, 6400, '\P{^Is_Block:unifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(1, 6399, '\p{Is_Block=-_UNIFIED_Canadian_Aboriginal_syllabics_Extended}', "");
    Expect(0, 6399, '\p{^Is_Block=-_UNIFIED_Canadian_Aboriginal_syllabics_Extended}', "");
    Expect(0, 6399, '\P{Is_Block=-_UNIFIED_Canadian_Aboriginal_syllabics_Extended}', "");
    Expect(1, 6399, '\P{^Is_Block=-_UNIFIED_Canadian_Aboriginal_syllabics_Extended}', "");
    Expect(0, 6400, '\p{Is_Block=-_UNIFIED_Canadian_Aboriginal_syllabics_Extended}', "");
    Expect(1, 6400, '\p{^Is_Block=-_UNIFIED_Canadian_Aboriginal_syllabics_Extended}', "");
    Expect(1, 6400, '\P{Is_Block=-_UNIFIED_Canadian_Aboriginal_syllabics_Extended}', "");
    Expect(0, 6400, '\P{^Is_Block=-_UNIFIED_Canadian_Aboriginal_syllabics_Extended}', "");
    Error('\p{Is_Blk=		UCAS_Ext/a/}');
    Error('\P{Is_Blk=		UCAS_Ext/a/}');
    Expect(1, 6399, '\p{Is_Blk=ucasext}', "");
    Expect(0, 6399, '\p{^Is_Blk=ucasext}', "");
    Expect(0, 6399, '\P{Is_Blk=ucasext}', "");
    Expect(1, 6399, '\P{^Is_Blk=ucasext}', "");
    Expect(0, 6400, '\p{Is_Blk=ucasext}', "");
    Expect(1, 6400, '\p{^Is_Blk=ucasext}', "");
    Expect(1, 6400, '\P{Is_Blk=ucasext}', "");
    Expect(0, 6400, '\P{^Is_Blk=ucasext}', "");
    Expect(1, 6399, '\p{Is_Blk=ucas_Ext}', "");
    Expect(0, 6399, '\p{^Is_Blk=ucas_Ext}', "");
    Expect(0, 6399, '\P{Is_Blk=ucas_Ext}', "");
    Expect(1, 6399, '\P{^Is_Blk=ucas_Ext}', "");
    Expect(0, 6400, '\p{Is_Blk=ucas_Ext}', "");
    Expect(1, 6400, '\p{^Is_Blk=ucas_Ext}', "");
    Expect(1, 6400, '\P{Is_Blk=ucas_Ext}', "");
    Expect(0, 6400, '\P{^Is_Blk=ucas_Ext}', "");
    Error('\p{Block=/a/UNIFIED_CANADIAN_aboriginal_Syllabics_Extended_a}');
    Error('\P{Block=/a/UNIFIED_CANADIAN_aboriginal_Syllabics_Extended_a}');
    Expect(1, 72383, '\p{Block=:\AUnified_Canadian_Aboriginal_Syllabics_Extended_A\z:}', "");;
    Expect(0, 72384, '\p{Block=:\AUnified_Canadian_Aboriginal_Syllabics_Extended_A\z:}', "");;
    Expect(1, 72383, '\p{Block=unifiedcanadianaboriginalsyllabicsextendeda}', "");
    Expect(0, 72383, '\p{^Block=unifiedcanadianaboriginalsyllabicsextendeda}', "");
    Expect(0, 72383, '\P{Block=unifiedcanadianaboriginalsyllabicsextendeda}', "");
    Expect(1, 72383, '\P{^Block=unifiedcanadianaboriginalsyllabicsextendeda}', "");
    Expect(0, 72384, '\p{Block=unifiedcanadianaboriginalsyllabicsextendeda}', "");
    Expect(1, 72384, '\p{^Block=unifiedcanadianaboriginalsyllabicsextendeda}', "");
    Expect(1, 72384, '\P{Block=unifiedcanadianaboriginalsyllabicsextendeda}', "");
    Expect(0, 72384, '\P{^Block=unifiedcanadianaboriginalsyllabicsextendeda}', "");
    Expect(1, 72383, '\p{Block=:\Aunifiedcanadianaboriginalsyllabicsextendeda\z:}', "");;
    Expect(0, 72384, '\p{Block=:\Aunifiedcanadianaboriginalsyllabicsextendeda\z:}', "");;
    Expect(1, 72383, '\p{Block=- Unified_Canadian_ABORIGINAL_Syllabics_extended_a}', "");
    Expect(0, 72383, '\p{^Block=- Unified_Canadian_ABORIGINAL_Syllabics_extended_a}', "");
    Expect(0, 72383, '\P{Block=- Unified_Canadian_ABORIGINAL_Syllabics_extended_a}', "");
    Expect(1, 72383, '\P{^Block=- Unified_Canadian_ABORIGINAL_Syllabics_extended_a}', "");
    Expect(0, 72384, '\p{Block=- Unified_Canadian_ABORIGINAL_Syllabics_extended_a}', "");
    Expect(1, 72384, '\p{^Block=- Unified_Canadian_ABORIGINAL_Syllabics_extended_a}', "");
    Expect(1, 72384, '\P{Block=- Unified_Canadian_ABORIGINAL_Syllabics_extended_a}', "");
    Expect(0, 72384, '\P{^Block=- Unified_Canadian_ABORIGINAL_Syllabics_extended_a}', "");
    Error('\p{Blk=-UCAS_EXT_a:=}');
    Error('\P{Blk=-UCAS_EXT_a:=}');
    Expect(1, 72383, '\p{Blk=:\AUCAS_Ext_A\z:}', "");;
    Expect(0, 72384, '\p{Blk=:\AUCAS_Ext_A\z:}', "");;
    Expect(1, 72383, '\p{Blk=ucasexta}', "");
    Expect(0, 72383, '\p{^Blk=ucasexta}', "");
    Expect(0, 72383, '\P{Blk=ucasexta}', "");
    Expect(1, 72383, '\P{^Blk=ucasexta}', "");
    Expect(0, 72384, '\p{Blk=ucasexta}', "");
    Expect(1, 72384, '\p{^Blk=ucasexta}', "");
    Expect(1, 72384, '\P{Blk=ucasexta}', "");
    Expect(0, 72384, '\P{^Blk=ucasexta}', "");
    Expect(1, 72383, '\p{Blk=:\Aucasexta\z:}', "");;
    Expect(0, 72384, '\p{Blk=:\Aucasexta\z:}', "");;
    Expect(1, 72383, '\p{Blk:	_UCAS_Ext_A}', "");
    Expect(0, 72383, '\p{^Blk:	_UCAS_Ext_A}', "");
    Expect(0, 72383, '\P{Blk:	_UCAS_Ext_A}', "");
    Expect(1, 72383, '\P{^Blk:	_UCAS_Ext_A}', "");
    Expect(0, 72384, '\p{Blk:	_UCAS_Ext_A}', "");
    Expect(1, 72384, '\p{^Blk:	_UCAS_Ext_A}', "");
    Expect(1, 72384, '\P{Blk:	_UCAS_Ext_A}', "");
    Expect(0, 72384, '\P{^Blk:	_UCAS_Ext_A}', "");
    Error('\p{Is_Block=/a/-Unified_CANADIAN_ABORIGINAL_SYLLABICS_EXTENDED_a}');
    Error('\P{Is_Block=/a/-Unified_CANADIAN_ABORIGINAL_SYLLABICS_EXTENDED_a}');
    Expect(1, 72383, '\p{Is_Block=unifiedcanadianaboriginalsyllabicsextendeda}', "");
    Expect(0, 72383, '\p{^Is_Block=unifiedcanadianaboriginalsyllabicsextendeda}', "");
    Expect(0, 72383, '\P{Is_Block=unifiedcanadianaboriginalsyllabicsextendeda}', "");
    Expect(1, 72383, '\P{^Is_Block=unifiedcanadianaboriginalsyllabicsextendeda}', "");
    Expect(0, 72384, '\p{Is_Block=unifiedcanadianaboriginalsyllabicsextendeda}', "");
    Expect(1, 72384, '\p{^Is_Block=unifiedcanadianaboriginalsyllabicsextendeda}', "");
    Expect(1, 72384, '\P{Is_Block=unifiedcanadianaboriginalsyllabicsextendeda}', "");
    Expect(0, 72384, '\P{^Is_Block=unifiedcanadianaboriginalsyllabicsextendeda}', "");
    Expect(1, 72383, '\p{Is_Block= UNIFIED_canadian_Aboriginal_SYLLABICS_Extended_A}', "");
    Expect(0, 72383, '\p{^Is_Block= UNIFIED_canadian_Aboriginal_SYLLABICS_Extended_A}', "");
    Expect(0, 72383, '\P{Is_Block= UNIFIED_canadian_Aboriginal_SYLLABICS_Extended_A}', "");
    Expect(1, 72383, '\P{^Is_Block= UNIFIED_canadian_Aboriginal_SYLLABICS_Extended_A}', "");
    Expect(0, 72384, '\p{Is_Block= UNIFIED_canadian_Aboriginal_SYLLABICS_Extended_A}', "");
    Expect(1, 72384, '\p{^Is_Block= UNIFIED_canadian_Aboriginal_SYLLABICS_Extended_A}', "");
    Expect(1, 72384, '\P{Is_Block= UNIFIED_canadian_Aboriginal_SYLLABICS_Extended_A}', "");
    Expect(0, 72384, '\P{^Is_Block= UNIFIED_canadian_Aboriginal_SYLLABICS_Extended_A}', "");
    Error('\p{Is_Blk=	:=ucas_ext_A}');
    Error('\P{Is_Blk=	:=ucas_ext_A}');
    Expect(1, 72383, '\p{Is_Blk=ucasexta}', "");
    Expect(0, 72383, '\p{^Is_Blk=ucasexta}', "");
    Expect(0, 72383, '\P{Is_Blk=ucasexta}', "");
    Expect(1, 72383, '\P{^Is_Blk=ucasexta}', "");
    Expect(0, 72384, '\p{Is_Blk=ucasexta}', "");
    Expect(1, 72384, '\p{^Is_Blk=ucasexta}', "");
    Expect(1, 72384, '\P{Is_Blk=ucasexta}', "");
    Expect(0, 72384, '\P{^Is_Blk=ucasexta}', "");
    Expect(1, 72383, '\p{Is_Blk= 	UCAS_Ext_a}', "");
    Expect(0, 72383, '\p{^Is_Blk= 	UCAS_Ext_a}', "");
    Expect(0, 72383, '\P{Is_Blk= 	UCAS_Ext_a}', "");
    Expect(1, 72383, '\P{^Is_Blk= 	UCAS_Ext_a}', "");
    Expect(0, 72384, '\p{Is_Blk= 	UCAS_Ext_a}', "");
    Expect(1, 72384, '\p{^Is_Blk= 	UCAS_Ext_a}', "");
    Expect(1, 72384, '\P{Is_Blk= 	UCAS_Ext_a}', "");
    Expect(0, 72384, '\P{^Is_Blk= 	UCAS_Ext_a}', "");
    Error('\p{Block=:=	Ugaritic}');
    Error('\P{Block=:=	Ugaritic}');
    Expect(1, 66463, '\p{Block=:\AUgaritic\z:}', "");;
    Expect(0, 66464, '\p{Block=:\AUgaritic\z:}', "");;
    Expect(1, 66463, '\p{Block=ugaritic}', "");
    Expect(0, 66463, '\p{^Block=ugaritic}', "");
    Expect(0, 66463, '\P{Block=ugaritic}', "");
    Expect(1, 66463, '\P{^Block=ugaritic}', "");
    Expect(0, 66464, '\p{Block=ugaritic}', "");
    Expect(1, 66464, '\p{^Block=ugaritic}', "");
    Expect(1, 66464, '\P{Block=ugaritic}', "");
    Expect(0, 66464, '\P{^Block=ugaritic}', "");
    Expect(1, 66463, '\p{Block=:\Augaritic\z:}', "");;
    Expect(0, 66464, '\p{Block=:\Augaritic\z:}', "");;
    Expect(1, 66463, '\p{Block= UGARITIC}', "");
    Expect(0, 66463, '\p{^Block= UGARITIC}', "");
    Expect(0, 66463, '\P{Block= UGARITIC}', "");
    Expect(1, 66463, '\P{^Block= UGARITIC}', "");
    Expect(0, 66464, '\p{Block= UGARITIC}', "");
    Expect(1, 66464, '\p{^Block= UGARITIC}', "");
    Expect(1, 66464, '\P{Block= UGARITIC}', "");
    Expect(0, 66464, '\P{^Block= UGARITIC}', "");
    Error('\p{Blk=-Ugaritic/a/}');
    Error('\P{Blk=-Ugaritic/a/}');
    Expect(1, 66463, '\p{Blk=:\AUgaritic\z:}', "");;
    Expect(0, 66464, '\p{Blk=:\AUgaritic\z:}', "");;
    Expect(1, 66463, '\p{Blk=ugaritic}', "");
    Expect(0, 66463, '\p{^Blk=ugaritic}', "");
    Expect(0, 66463, '\P{Blk=ugaritic}', "");
    Expect(1, 66463, '\P{^Blk=ugaritic}', "");
    Expect(0, 66464, '\p{Blk=ugaritic}', "");
    Expect(1, 66464, '\p{^Blk=ugaritic}', "");
    Expect(1, 66464, '\P{Blk=ugaritic}', "");
    Expect(0, 66464, '\P{^Blk=ugaritic}', "");
    Expect(1, 66463, '\p{Blk=:\Augaritic\z:}', "");;
    Expect(0, 66464, '\p{Blk=:\Augaritic\z:}', "");;
    Expect(1, 66463, '\p{Blk=_	Ugaritic}', "");
    Expect(0, 66463, '\p{^Blk=_	Ugaritic}', "");
    Expect(0, 66463, '\P{Blk=_	Ugaritic}', "");
    Expect(1, 66463, '\P{^Blk=_	Ugaritic}', "");
    Expect(0, 66464, '\p{Blk=_	Ugaritic}', "");
    Expect(1, 66464, '\p{^Blk=_	Ugaritic}', "");
    Expect(1, 66464, '\P{Blk=_	Ugaritic}', "");
    Expect(0, 66464, '\P{^Blk=_	Ugaritic}', "");
    Error('\p{Is_Block:	ugaritic:=}');
    Error('\P{Is_Block:	ugaritic:=}');
    Expect(1, 66463, '\p{Is_Block=ugaritic}', "");
    Expect(0, 66463, '\p{^Is_Block=ugaritic}', "");
    Expect(0, 66463, '\P{Is_Block=ugaritic}', "");
    Expect(1, 66463, '\P{^Is_Block=ugaritic}', "");
    Expect(0, 66464, '\p{Is_Block=ugaritic}', "");
    Expect(1, 66464, '\p{^Is_Block=ugaritic}', "");
    Expect(1, 66464, '\P{Is_Block=ugaritic}', "");
    Expect(0, 66464, '\P{^Is_Block=ugaritic}', "");
    Expect(1, 66463, '\p{Is_Block=	_Ugaritic}', "");
    Expect(0, 66463, '\p{^Is_Block=	_Ugaritic}', "");
    Expect(0, 66463, '\P{Is_Block=	_Ugaritic}', "");
    Expect(1, 66463, '\P{^Is_Block=	_Ugaritic}', "");
    Expect(0, 66464, '\p{Is_Block=	_Ugaritic}', "");
    Expect(1, 66464, '\p{^Is_Block=	_Ugaritic}', "");
    Expect(1, 66464, '\P{Is_Block=	_Ugaritic}', "");
    Expect(0, 66464, '\P{^Is_Block=	_Ugaritic}', "");
    Error('\p{Is_Blk=:=_	UGARITIC}');
    Error('\P{Is_Blk=:=_	UGARITIC}');
    Expect(1, 66463, '\p{Is_Blk=ugaritic}', "");
    Expect(0, 66463, '\p{^Is_Blk=ugaritic}', "");
    Expect(0, 66463, '\P{Is_Blk=ugaritic}', "");
    Expect(1, 66463, '\P{^Is_Blk=ugaritic}', "");
    Expect(0, 66464, '\p{Is_Blk=ugaritic}', "");
    Expect(1, 66464, '\p{^Is_Blk=ugaritic}', "");
    Expect(1, 66464, '\P{Is_Blk=ugaritic}', "");
    Expect(0, 66464, '\P{^Is_Blk=ugaritic}', "");
    Expect(1, 66463, '\p{Is_Blk=- UGARITIC}', "");
    Expect(0, 66463, '\p{^Is_Blk=- UGARITIC}', "");
    Expect(0, 66463, '\P{Is_Blk=- UGARITIC}', "");
    Expect(1, 66463, '\P{^Is_Blk=- UGARITIC}', "");
    Expect(0, 66464, '\p{Is_Blk=- UGARITIC}', "");
    Expect(1, 66464, '\p{^Is_Blk=- UGARITIC}', "");
    Expect(1, 66464, '\P{Is_Blk=- UGARITIC}', "");
    Expect(0, 66464, '\P{^Is_Blk=- UGARITIC}', "");
    Error('\p{Block= _vai/a/}');
    Error('\P{Block= _vai/a/}');
    Expect(1, 42559, '\p{Block=:\AVai\z:}', "");;
    Expect(0, 42560, '\p{Block=:\AVai\z:}', "");;
    Expect(1, 42559, '\p{Block=vai}', "");
    Expect(0, 42559, '\p{^Block=vai}', "");
    Expect(0, 42559, '\P{Block=vai}', "");
    Expect(1, 42559, '\P{^Block=vai}', "");
    Expect(0, 42560, '\p{Block=vai}', "");
    Expect(1, 42560, '\p{^Block=vai}', "");
    Expect(1, 42560, '\P{Block=vai}', "");
    Expect(0, 42560, '\P{^Block=vai}', "");
    Expect(1, 42559, '\p{Block=:\Avai\z:}', "");;
    Expect(0, 42560, '\p{Block=:\Avai\z:}', "");;
    Expect(1, 42559, '\p{Block=		Vai}', "");
    Expect(0, 42559, '\p{^Block=		Vai}', "");
    Expect(0, 42559, '\P{Block=		Vai}', "");
    Expect(1, 42559, '\P{^Block=		Vai}', "");
    Expect(0, 42560, '\p{Block=		Vai}', "");
    Expect(1, 42560, '\p{^Block=		Vai}', "");
    Expect(1, 42560, '\P{Block=		Vai}', "");
    Expect(0, 42560, '\P{^Block=		Vai}', "");
    Error('\p{Blk=/a/Vai}');
    Error('\P{Blk=/a/Vai}');
    Expect(1, 42559, '\p{Blk=:\AVai\z:}', "");;
    Expect(0, 42560, '\p{Blk=:\AVai\z:}', "");;
    Expect(1, 42559, '\p{Blk=vai}', "");
    Expect(0, 42559, '\p{^Blk=vai}', "");
    Expect(0, 42559, '\P{Blk=vai}', "");
    Expect(1, 42559, '\P{^Blk=vai}', "");
    Expect(0, 42560, '\p{Blk=vai}', "");
    Expect(1, 42560, '\p{^Blk=vai}', "");
    Expect(1, 42560, '\P{Blk=vai}', "");
    Expect(0, 42560, '\P{^Blk=vai}', "");
    Expect(1, 42559, '\p{Blk=:\Avai\z:}', "");;
    Expect(0, 42560, '\p{Blk=:\Avai\z:}', "");;
    Expect(1, 42559, '\p{Blk=		Vai}', "");
    Expect(0, 42559, '\p{^Blk=		Vai}', "");
    Expect(0, 42559, '\P{Blk=		Vai}', "");
    Expect(1, 42559, '\P{^Blk=		Vai}', "");
    Expect(0, 42560, '\p{Blk=		Vai}', "");
    Expect(1, 42560, '\p{^Blk=		Vai}', "");
    Expect(1, 42560, '\P{Blk=		Vai}', "");
    Expect(0, 42560, '\P{^Blk=		Vai}', "");
    Error('\p{Is_Block::=_-Vai}');
    Error('\P{Is_Block::=_-Vai}');
    Expect(1, 42559, '\p{Is_Block=vai}', "");
    Expect(0, 42559, '\p{^Is_Block=vai}', "");
    Expect(0, 42559, '\P{Is_Block=vai}', "");
    Expect(1, 42559, '\P{^Is_Block=vai}', "");
    Expect(0, 42560, '\p{Is_Block=vai}', "");
    Expect(1, 42560, '\p{^Is_Block=vai}', "");
    Expect(1, 42560, '\P{Is_Block=vai}', "");
    Expect(0, 42560, '\P{^Is_Block=vai}', "");
    Expect(1, 42559, '\p{Is_Block=- VAI}', "");
    Expect(0, 42559, '\p{^Is_Block=- VAI}', "");
    Expect(0, 42559, '\P{Is_Block=- VAI}', "");
    Expect(1, 42559, '\P{^Is_Block=- VAI}', "");
    Expect(0, 42560, '\p{Is_Block=- VAI}', "");
    Expect(1, 42560, '\p{^Is_Block=- VAI}', "");
    Expect(1, 42560, '\P{Is_Block=- VAI}', "");
    Expect(0, 42560, '\P{^Is_Block=- VAI}', "");
    Error('\p{Is_Blk=/a/_ VAI}');
    Error('\P{Is_Blk=/a/_ VAI}');
    Expect(1, 42559, '\p{Is_Blk:vai}', "");
    Expect(0, 42559, '\p{^Is_Blk:vai}', "");
    Expect(0, 42559, '\P{Is_Blk:vai}', "");
    Expect(1, 42559, '\P{^Is_Blk:vai}', "");
    Expect(0, 42560, '\p{Is_Blk:vai}', "");
    Expect(1, 42560, '\p{^Is_Blk:vai}', "");
    Expect(1, 42560, '\P{Is_Blk:vai}', "");
    Expect(0, 42560, '\P{^Is_Blk:vai}', "");
    Expect(1, 42559, '\p{Is_Blk=	-vai}', "");
    Expect(0, 42559, '\p{^Is_Blk=	-vai}', "");
    Expect(0, 42559, '\P{Is_Blk=	-vai}', "");
    Expect(1, 42559, '\P{^Is_Blk=	-vai}', "");
    Expect(0, 42560, '\p{Is_Blk=	-vai}', "");
    Expect(1, 42560, '\p{^Is_Blk=	-vai}', "");
    Expect(1, 42560, '\P{Is_Blk=	-vai}', "");
    Expect(0, 42560, '\P{^Is_Blk=	-vai}', "");
    Error('\p{Block=:=-vedic_extensions}');
    Error('\P{Block=:=-vedic_extensions}');
    Expect(1, 7423, '\p{Block=:\AVedic_Extensions\z:}', "");;
    Expect(0, 7424, '\p{Block=:\AVedic_Extensions\z:}', "");;
    Expect(1, 7423, '\p{Block=vedicextensions}', "");
    Expect(0, 7423, '\p{^Block=vedicextensions}', "");
    Expect(0, 7423, '\P{Block=vedicextensions}', "");
    Expect(1, 7423, '\P{^Block=vedicextensions}', "");
    Expect(0, 7424, '\p{Block=vedicextensions}', "");
    Expect(1, 7424, '\p{^Block=vedicextensions}', "");
    Expect(1, 7424, '\P{Block=vedicextensions}', "");
    Expect(0, 7424, '\P{^Block=vedicextensions}', "");
    Expect(1, 7423, '\p{Block=:\Avedicextensions\z:}', "");;
    Expect(0, 7424, '\p{Block=:\Avedicextensions\z:}', "");;
    Expect(1, 7423, '\p{Block=-vedic_EXTENSIONS}', "");
    Expect(0, 7423, '\p{^Block=-vedic_EXTENSIONS}', "");
    Expect(0, 7423, '\P{Block=-vedic_EXTENSIONS}', "");
    Expect(1, 7423, '\P{^Block=-vedic_EXTENSIONS}', "");
    Expect(0, 7424, '\p{Block=-vedic_EXTENSIONS}', "");
    Expect(1, 7424, '\p{^Block=-vedic_EXTENSIONS}', "");
    Expect(1, 7424, '\P{Block=-vedic_EXTENSIONS}', "");
    Expect(0, 7424, '\P{^Block=-vedic_EXTENSIONS}', "");
    Error('\p{Blk=-/a/VEDIC_ext}');
    Error('\P{Blk=-/a/VEDIC_ext}');
    Expect(1, 7423, '\p{Blk=:\AVedic_Ext\z:}', "");;
    Expect(0, 7424, '\p{Blk=:\AVedic_Ext\z:}', "");;
    Expect(1, 7423, '\p{Blk=vedicext}', "");
    Expect(0, 7423, '\p{^Blk=vedicext}', "");
    Expect(0, 7423, '\P{Blk=vedicext}', "");
    Expect(1, 7423, '\P{^Blk=vedicext}', "");
    Expect(0, 7424, '\p{Blk=vedicext}', "");
    Expect(1, 7424, '\p{^Blk=vedicext}', "");
    Expect(1, 7424, '\P{Blk=vedicext}', "");
    Expect(0, 7424, '\P{^Blk=vedicext}', "");
    Expect(1, 7423, '\p{Blk=:\Avedicext\z:}', "");;
    Expect(0, 7424, '\p{Blk=:\Avedicext\z:}', "");;
    Expect(1, 7423, '\p{Blk=_Vedic_Ext}', "");
    Expect(0, 7423, '\p{^Blk=_Vedic_Ext}', "");
    Expect(0, 7423, '\P{Blk=_Vedic_Ext}', "");
    Expect(1, 7423, '\P{^Blk=_Vedic_Ext}', "");
    Expect(0, 7424, '\p{Blk=_Vedic_Ext}', "");
    Expect(1, 7424, '\p{^Blk=_Vedic_Ext}', "");
    Expect(1, 7424, '\P{Blk=_Vedic_Ext}', "");
    Expect(0, 7424, '\P{^Blk=_Vedic_Ext}', "");
    Error('\p{Is_Block= :=VEDIC_Extensions}');
    Error('\P{Is_Block= :=VEDIC_Extensions}');
    Expect(1, 7423, '\p{Is_Block=vedicextensions}', "");
    Expect(0, 7423, '\p{^Is_Block=vedicextensions}', "");
    Expect(0, 7423, '\P{Is_Block=vedicextensions}', "");
    Expect(1, 7423, '\P{^Is_Block=vedicextensions}', "");
    Expect(0, 7424, '\p{Is_Block=vedicextensions}', "");
    Expect(1, 7424, '\p{^Is_Block=vedicextensions}', "");
    Expect(1, 7424, '\P{Is_Block=vedicextensions}', "");
    Expect(0, 7424, '\P{^Is_Block=vedicextensions}', "");
    Expect(1, 7423, '\p{Is_Block= 	Vedic_Extensions}', "");
    Expect(0, 7423, '\p{^Is_Block= 	Vedic_Extensions}', "");
    Expect(0, 7423, '\P{Is_Block= 	Vedic_Extensions}', "");
    Expect(1, 7423, '\P{^Is_Block= 	Vedic_Extensions}', "");
    Expect(0, 7424, '\p{Is_Block= 	Vedic_Extensions}', "");
    Expect(1, 7424, '\p{^Is_Block= 	Vedic_Extensions}', "");
    Expect(1, 7424, '\P{Is_Block= 	Vedic_Extensions}', "");
    Expect(0, 7424, '\P{^Is_Block= 	Vedic_Extensions}', "");
    Error('\p{Is_Blk=	-vedic_EXT/a/}');
    Error('\P{Is_Blk=	-vedic_EXT/a/}');
    Expect(1, 7423, '\p{Is_Blk=vedicext}', "");
    Expect(0, 7423, '\p{^Is_Blk=vedicext}', "");
    Expect(0, 7423, '\P{Is_Blk=vedicext}', "");
    Expect(1, 7423, '\P{^Is_Blk=vedicext}', "");
    Expect(0, 7424, '\p{Is_Blk=vedicext}', "");
    Expect(1, 7424, '\p{^Is_Blk=vedicext}', "");
    Expect(1, 7424, '\P{Is_Blk=vedicext}', "");
    Expect(0, 7424, '\P{^Is_Blk=vedicext}', "");
    Expect(1, 7423, '\p{Is_Blk= _VEDIC_ext}', "");
    Expect(0, 7423, '\p{^Is_Blk= _VEDIC_ext}', "");
    Expect(0, 7423, '\P{Is_Blk= _VEDIC_ext}', "");
    Expect(1, 7423, '\P{^Is_Blk= _VEDIC_ext}', "");
    Expect(0, 7424, '\p{Is_Blk= _VEDIC_ext}', "");
    Expect(1, 7424, '\p{^Is_Blk= _VEDIC_ext}', "");
    Expect(1, 7424, '\P{Is_Blk= _VEDIC_ext}', "");
    Expect(0, 7424, '\P{^Is_Blk= _VEDIC_ext}', "");
    Error('\p{Block=	vertical_Forms/a/}');
    Error('\P{Block=	vertical_Forms/a/}');
    Expect(1, 65055, '\p{Block=:\AVertical_Forms\z:}', "");;
    Expect(0, 65056, '\p{Block=:\AVertical_Forms\z:}', "");;
    Expect(1, 65055, '\p{Block=verticalforms}', "");
    Expect(0, 65055, '\p{^Block=verticalforms}', "");
    Expect(0, 65055, '\P{Block=verticalforms}', "");
    Expect(1, 65055, '\P{^Block=verticalforms}', "");
    Expect(0, 65056, '\p{Block=verticalforms}', "");
    Expect(1, 65056, '\p{^Block=verticalforms}', "");
    Expect(1, 65056, '\P{Block=verticalforms}', "");
    Expect(0, 65056, '\P{^Block=verticalforms}', "");
    Expect(1, 65055, '\p{Block=:\Averticalforms\z:}', "");;
    Expect(0, 65056, '\p{Block=:\Averticalforms\z:}', "");;
    Expect(1, 65055, '\p{Block:		vertical_forms}', "");
    Expect(0, 65055, '\p{^Block:		vertical_forms}', "");
    Expect(0, 65055, '\P{Block:		vertical_forms}', "");
    Expect(1, 65055, '\P{^Block:		vertical_forms}', "");
    Expect(0, 65056, '\p{Block:		vertical_forms}', "");
    Expect(1, 65056, '\p{^Block:		vertical_forms}', "");
    Expect(1, 65056, '\P{Block:		vertical_forms}', "");
    Expect(0, 65056, '\P{^Block:		vertical_forms}', "");
    Error('\p{Blk=	Vertical_FORMS/a/}');
    Error('\P{Blk=	Vertical_FORMS/a/}');
    Expect(1, 65055, '\p{Blk=:\AVertical_Forms\z:}', "");;
    Expect(0, 65056, '\p{Blk=:\AVertical_Forms\z:}', "");;
    Expect(1, 65055, '\p{Blk=verticalforms}', "");
    Expect(0, 65055, '\p{^Blk=verticalforms}', "");
    Expect(0, 65055, '\P{Blk=verticalforms}', "");
    Expect(1, 65055, '\P{^Blk=verticalforms}', "");
    Expect(0, 65056, '\p{Blk=verticalforms}', "");
    Expect(1, 65056, '\p{^Blk=verticalforms}', "");
    Expect(1, 65056, '\P{Blk=verticalforms}', "");
    Expect(0, 65056, '\P{^Blk=verticalforms}', "");
    Expect(1, 65055, '\p{Blk=:\Averticalforms\z:}', "");;
    Expect(0, 65056, '\p{Blk=:\Averticalforms\z:}', "");;
    Expect(1, 65055, '\p{Blk:	 _vertical_Forms}', "");
    Expect(0, 65055, '\p{^Blk:	 _vertical_Forms}', "");
    Expect(0, 65055, '\P{Blk:	 _vertical_Forms}', "");
    Expect(1, 65055, '\P{^Blk:	 _vertical_Forms}', "");
    Expect(0, 65056, '\p{Blk:	 _vertical_Forms}', "");
    Expect(1, 65056, '\p{^Blk:	 _vertical_Forms}', "");
    Expect(1, 65056, '\P{Blk:	 _vertical_Forms}', "");
    Expect(0, 65056, '\P{^Blk:	 _vertical_Forms}', "");
    Error('\p{Is_Block:	 -Vertical_Forms:=}');
    Error('\P{Is_Block:	 -Vertical_Forms:=}');
    Expect(1, 65055, '\p{Is_Block=verticalforms}', "");
    Expect(0, 65055, '\p{^Is_Block=verticalforms}', "");
    Expect(0, 65055, '\P{Is_Block=verticalforms}', "");
    Expect(1, 65055, '\P{^Is_Block=verticalforms}', "");
    Expect(0, 65056, '\p{Is_Block=verticalforms}', "");
    Expect(1, 65056, '\p{^Is_Block=verticalforms}', "");
    Expect(1, 65056, '\P{Is_Block=verticalforms}', "");
    Expect(0, 65056, '\P{^Is_Block=verticalforms}', "");
    Expect(1, 65055, '\p{Is_Block:	 Vertical_Forms}', "");
    Expect(0, 65055, '\p{^Is_Block:	 Vertical_Forms}', "");
    Expect(0, 65055, '\P{Is_Block:	 Vertical_Forms}', "");
    Expect(1, 65055, '\P{^Is_Block:	 Vertical_Forms}', "");
    Expect(0, 65056, '\p{Is_Block:	 Vertical_Forms}', "");
    Expect(1, 65056, '\p{^Is_Block:	 Vertical_Forms}', "");
    Expect(1, 65056, '\P{Is_Block:	 Vertical_Forms}', "");
    Expect(0, 65056, '\P{^Is_Block:	 Vertical_Forms}', "");
    Error('\p{Is_Blk=/a/VERTICAL_forms}');
    Error('\P{Is_Blk=/a/VERTICAL_forms}');
    Expect(1, 65055, '\p{Is_Blk=verticalforms}', "");
    Expect(0, 65055, '\p{^Is_Blk=verticalforms}', "");
    Expect(0, 65055, '\P{Is_Blk=verticalforms}', "");
    Expect(1, 65055, '\P{^Is_Blk=verticalforms}', "");
    Expect(0, 65056, '\p{Is_Blk=verticalforms}', "");
    Expect(1, 65056, '\p{^Is_Blk=verticalforms}', "");
    Expect(1, 65056, '\P{Is_Blk=verticalforms}', "");
    Expect(0, 65056, '\P{^Is_Blk=verticalforms}', "");
    Expect(1, 65055, '\p{Is_Blk=vertical_Forms}', "");
    Expect(0, 65055, '\p{^Is_Blk=vertical_Forms}', "");
    Expect(0, 65055, '\P{Is_Blk=vertical_Forms}', "");
    Expect(1, 65055, '\P{^Is_Blk=vertical_Forms}', "");
    Expect(0, 65056, '\p{Is_Blk=vertical_Forms}', "");
    Expect(1, 65056, '\p{^Is_Blk=vertical_Forms}', "");
    Expect(1, 65056, '\P{Is_Blk=vertical_Forms}', "");
    Expect(0, 65056, '\P{^Is_Blk=vertical_Forms}', "");
    Error('\p{Block=	VITHKUQI:=}');
    Error('\P{Block=	VITHKUQI:=}');
    Expect(1, 67007, '\p{Block=:\AVithkuqi\z:}', "");;
    Expect(0, 67008, '\p{Block=:\AVithkuqi\z:}', "");;
    Expect(1, 67007, '\p{Block=vithkuqi}', "");
    Expect(0, 67007, '\p{^Block=vithkuqi}', "");
    Expect(0, 67007, '\P{Block=vithkuqi}', "");
    Expect(1, 67007, '\P{^Block=vithkuqi}', "");
    Expect(0, 67008, '\p{Block=vithkuqi}', "");
    Expect(1, 67008, '\p{^Block=vithkuqi}', "");
    Expect(1, 67008, '\P{Block=vithkuqi}', "");
    Expect(0, 67008, '\P{^Block=vithkuqi}', "");
    Expect(1, 67007, '\p{Block=:\Avithkuqi\z:}', "");;
    Expect(0, 67008, '\p{Block=:\Avithkuqi\z:}', "");;
    Expect(1, 67007, '\p{Block:__VITHKUQI}', "");
    Expect(0, 67007, '\p{^Block:__VITHKUQI}', "");
    Expect(0, 67007, '\P{Block:__VITHKUQI}', "");
    Expect(1, 67007, '\P{^Block:__VITHKUQI}', "");
    Expect(0, 67008, '\p{Block:__VITHKUQI}', "");
    Expect(1, 67008, '\p{^Block:__VITHKUQI}', "");
    Expect(1, 67008, '\P{Block:__VITHKUQI}', "");
    Expect(0, 67008, '\P{^Block:__VITHKUQI}', "");
    Error('\p{Blk:-Vithkuqi/a/}');
    Error('\P{Blk:-Vithkuqi/a/}');
    Expect(1, 67007, '\p{Blk=:\AVithkuqi\z:}', "");;
    Expect(0, 67008, '\p{Blk=:\AVithkuqi\z:}', "");;
    Expect(1, 67007, '\p{Blk=vithkuqi}', "");
    Expect(0, 67007, '\p{^Blk=vithkuqi}', "");
    Expect(0, 67007, '\P{Blk=vithkuqi}', "");
    Expect(1, 67007, '\P{^Blk=vithkuqi}', "");
    Expect(0, 67008, '\p{Blk=vithkuqi}', "");
    Expect(1, 67008, '\p{^Blk=vithkuqi}', "");
    Expect(1, 67008, '\P{Blk=vithkuqi}', "");
    Expect(0, 67008, '\P{^Blk=vithkuqi}', "");
    Expect(1, 67007, '\p{Blk=:\Avithkuqi\z:}', "");;
    Expect(0, 67008, '\p{Blk=:\Avithkuqi\z:}', "");;
    Expect(1, 67007, '\p{Blk=- Vithkuqi}', "");
    Expect(0, 67007, '\p{^Blk=- Vithkuqi}', "");
    Expect(0, 67007, '\P{Blk=- Vithkuqi}', "");
    Expect(1, 67007, '\P{^Blk=- Vithkuqi}', "");
    Expect(0, 67008, '\p{Blk=- Vithkuqi}', "");
    Expect(1, 67008, '\p{^Blk=- Vithkuqi}', "");
    Expect(1, 67008, '\P{Blk=- Vithkuqi}', "");
    Expect(0, 67008, '\P{^Blk=- Vithkuqi}', "");
    Error('\p{Is_Block=	Vithkuqi/a/}');
    Error('\P{Is_Block=	Vithkuqi/a/}');
    Expect(1, 67007, '\p{Is_Block=vithkuqi}', "");
    Expect(0, 67007, '\p{^Is_Block=vithkuqi}', "");
    Expect(0, 67007, '\P{Is_Block=vithkuqi}', "");
    Expect(1, 67007, '\P{^Is_Block=vithkuqi}', "");
    Expect(0, 67008, '\p{Is_Block=vithkuqi}', "");
    Expect(1, 67008, '\p{^Is_Block=vithkuqi}', "");
    Expect(1, 67008, '\P{Is_Block=vithkuqi}', "");
    Expect(0, 67008, '\P{^Is_Block=vithkuqi}', "");
    Expect(1, 67007, '\p{Is_Block= 	vithkuqi}', "");
    Expect(0, 67007, '\p{^Is_Block= 	vithkuqi}', "");
    Expect(0, 67007, '\P{Is_Block= 	vithkuqi}', "");
    Expect(1, 67007, '\P{^Is_Block= 	vithkuqi}', "");
    Expect(0, 67008, '\p{Is_Block= 	vithkuqi}', "");
    Expect(1, 67008, '\p{^Is_Block= 	vithkuqi}', "");
    Expect(1, 67008, '\P{Is_Block= 	vithkuqi}', "");
    Expect(0, 67008, '\P{^Is_Block= 	vithkuqi}', "");
    Error('\p{Is_Blk= _VITHKUQI/a/}');
    Error('\P{Is_Blk= _VITHKUQI/a/}');
    Expect(1, 67007, '\p{Is_Blk=vithkuqi}', "");
    Expect(0, 67007, '\p{^Is_Blk=vithkuqi}', "");
    Expect(0, 67007, '\P{Is_Blk=vithkuqi}', "");
    Expect(1, 67007, '\P{^Is_Blk=vithkuqi}', "");
    Expect(0, 67008, '\p{Is_Blk=vithkuqi}', "");
    Expect(1, 67008, '\p{^Is_Blk=vithkuqi}', "");
    Expect(1, 67008, '\P{Is_Blk=vithkuqi}', "");
    Expect(0, 67008, '\P{^Is_Blk=vithkuqi}', "");
    Expect(1, 67007, '\p{Is_Blk: -	VITHKUQI}', "");
    Expect(0, 67007, '\p{^Is_Blk: -	VITHKUQI}', "");
    Expect(0, 67007, '\P{Is_Blk: -	VITHKUQI}', "");
    Expect(1, 67007, '\P{^Is_Blk: -	VITHKUQI}', "");
    Expect(0, 67008, '\p{Is_Blk: -	VITHKUQI}', "");
    Expect(1, 67008, '\p{^Is_Blk: -	VITHKUQI}', "");
    Expect(1, 67008, '\P{Is_Blk: -	VITHKUQI}', "");
    Expect(0, 67008, '\P{^Is_Blk: -	VITHKUQI}', "");
    Error('\p{Block: 	variation_selectors/a/}');
    Error('\P{Block: 	variation_selectors/a/}');
    Expect(1, 65039, '\p{Block=:\AVariation_Selectors\z:}', "");;
    Expect(0, 65040, '\p{Block=:\AVariation_Selectors\z:}', "");;
    Expect(1, 65039, '\p{Block: variationselectors}', "");
    Expect(0, 65039, '\p{^Block: variationselectors}', "");
    Expect(0, 65039, '\P{Block: variationselectors}', "");
    Expect(1, 65039, '\P{^Block: variationselectors}', "");
    Expect(0, 65040, '\p{Block: variationselectors}', "");
    Expect(1, 65040, '\p{^Block: variationselectors}', "");
    Expect(1, 65040, '\P{Block: variationselectors}', "");
    Expect(0, 65040, '\P{^Block: variationselectors}', "");
    Expect(1, 65039, '\p{Block=:\Avariationselectors\z:}', "");;
    Expect(0, 65040, '\p{Block=:\Avariationselectors\z:}', "");;
    Expect(1, 65039, '\p{Block=-_variation_selectors}', "");
    Expect(0, 65039, '\p{^Block=-_variation_selectors}', "");
    Expect(0, 65039, '\P{Block=-_variation_selectors}', "");
    Expect(1, 65039, '\P{^Block=-_variation_selectors}', "");
    Expect(0, 65040, '\p{Block=-_variation_selectors}', "");
    Expect(1, 65040, '\p{^Block=-_variation_selectors}', "");
    Expect(1, 65040, '\P{Block=-_variation_selectors}', "");
    Expect(0, 65040, '\P{^Block=-_variation_selectors}', "");
    Error('\p{Blk= :=vs}');
    Error('\P{Blk= :=vs}');
    Expect(1, 65039, '\p{Blk=:\AVS\z:}', "");;
    Expect(0, 65040, '\p{Blk=:\AVS\z:}', "");;
    Expect(1, 65039, '\p{Blk=vs}', "");
    Expect(0, 65039, '\p{^Blk=vs}', "");
    Expect(0, 65039, '\P{Blk=vs}', "");
    Expect(1, 65039, '\P{^Blk=vs}', "");
    Expect(0, 65040, '\p{Blk=vs}', "");
    Expect(1, 65040, '\p{^Blk=vs}', "");
    Expect(1, 65040, '\P{Blk=vs}', "");
    Expect(0, 65040, '\P{^Blk=vs}', "");
    Expect(1, 65039, '\p{Blk=:\Avs\z:}', "");;
    Expect(0, 65040, '\p{Blk=:\Avs\z:}', "");;
    Expect(1, 65039, '\p{Blk=	 VS}', "");
    Expect(0, 65039, '\p{^Blk=	 VS}', "");
    Expect(0, 65039, '\P{Blk=	 VS}', "");
    Expect(1, 65039, '\P{^Blk=	 VS}', "");
    Expect(0, 65040, '\p{Blk=	 VS}', "");
    Expect(1, 65040, '\p{^Blk=	 VS}', "");
    Expect(1, 65040, '\P{Blk=	 VS}', "");
    Expect(0, 65040, '\P{^Blk=	 VS}', "");
    Error('\p{Is_Block=_:=Variation_Selectors}');
    Error('\P{Is_Block=_:=Variation_Selectors}');
    Expect(1, 65039, '\p{Is_Block=variationselectors}', "");
    Expect(0, 65039, '\p{^Is_Block=variationselectors}', "");
    Expect(0, 65039, '\P{Is_Block=variationselectors}', "");
    Expect(1, 65039, '\P{^Is_Block=variationselectors}', "");
    Expect(0, 65040, '\p{Is_Block=variationselectors}', "");
    Expect(1, 65040, '\p{^Is_Block=variationselectors}', "");
    Expect(1, 65040, '\P{Is_Block=variationselectors}', "");
    Expect(0, 65040, '\P{^Is_Block=variationselectors}', "");
    Expect(1, 65039, '\p{Is_Block:   	 Variation_Selectors}', "");
    Expect(0, 65039, '\p{^Is_Block:   	 Variation_Selectors}', "");
    Expect(0, 65039, '\P{Is_Block:   	 Variation_Selectors}', "");
    Expect(1, 65039, '\P{^Is_Block:   	 Variation_Selectors}', "");
    Expect(0, 65040, '\p{Is_Block:   	 Variation_Selectors}', "");
    Expect(1, 65040, '\p{^Is_Block:   	 Variation_Selectors}', "");
    Expect(1, 65040, '\P{Is_Block:   	 Variation_Selectors}', "");
    Expect(0, 65040, '\P{^Is_Block:   	 Variation_Selectors}', "");
    Error('\p{Is_Blk=- VS/a/}');
    Error('\P{Is_Blk=- VS/a/}');
    Expect(1, 65039, '\p{Is_Blk:vs}', "");
    Expect(0, 65039, '\p{^Is_Blk:vs}', "");
    Expect(0, 65039, '\P{Is_Blk:vs}', "");
    Expect(1, 65039, '\P{^Is_Blk:vs}', "");
    Expect(0, 65040, '\p{Is_Blk:vs}', "");
    Expect(1, 65040, '\p{^Is_Blk:vs}', "");
    Expect(1, 65040, '\P{Is_Blk:vs}', "");
    Expect(0, 65040, '\P{^Is_Blk:vs}', "");
    Expect(1, 65039, '\p{Is_Blk= VS}', "");
    Expect(0, 65039, '\p{^Is_Blk= VS}', "");
    Expect(0, 65039, '\P{Is_Blk= VS}', "");
    Expect(1, 65039, '\P{^Is_Blk= VS}', "");
    Expect(0, 65040, '\p{Is_Blk= VS}', "");
    Expect(1, 65040, '\p{^Is_Blk= VS}', "");
    Expect(1, 65040, '\P{Is_Blk= VS}', "");
    Expect(0, 65040, '\P{^Is_Blk= VS}', "");
    Error('\p{Block=/a/VARIATION_selectors_Supplement}');
    Error('\P{Block=/a/VARIATION_selectors_Supplement}');
    Expect(1, 917999, '\p{Block=:\AVariation_Selectors_Supplement\z:}', "");;
    Expect(0, 918000, '\p{Block=:\AVariation_Selectors_Supplement\z:}', "");;
    Expect(1, 917999, '\p{Block=variationselectorssupplement}', "");
    Expect(0, 917999, '\p{^Block=variationselectorssupplement}', "");
    Expect(0, 917999, '\P{Block=variationselectorssupplement}', "");
    Expect(1, 917999, '\P{^Block=variationselectorssupplement}', "");
    Expect(0, 918000, '\p{Block=variationselectorssupplement}', "");
    Expect(1, 918000, '\p{^Block=variationselectorssupplement}', "");
    Expect(1, 918000, '\P{Block=variationselectorssupplement}', "");
    Expect(0, 918000, '\P{^Block=variationselectorssupplement}', "");
    Expect(1, 917999, '\p{Block=:\Avariationselectorssupplement\z:}', "");;
    Expect(0, 918000, '\p{Block=:\Avariationselectorssupplement\z:}', "");;
    Expect(1, 917999, '\p{Block=	-VARIATION_Selectors_Supplement}', "");
    Expect(0, 917999, '\p{^Block=	-VARIATION_Selectors_Supplement}', "");
    Expect(0, 917999, '\P{Block=	-VARIATION_Selectors_Supplement}', "");
    Expect(1, 917999, '\P{^Block=	-VARIATION_Selectors_Supplement}', "");
    Expect(0, 918000, '\p{Block=	-VARIATION_Selectors_Supplement}', "");
    Expect(1, 918000, '\p{^Block=	-VARIATION_Selectors_Supplement}', "");
    Expect(1, 918000, '\P{Block=	-VARIATION_Selectors_Supplement}', "");
    Expect(0, 918000, '\P{^Block=	-VARIATION_Selectors_Supplement}', "");
    Error('\p{Blk=:=	_VS_Sup}');
    Error('\P{Blk=:=	_VS_Sup}');
    Expect(1, 917999, '\p{Blk=:\AVS_Sup\z:}', "");;
    Expect(0, 918000, '\p{Blk=:\AVS_Sup\z:}', "");;
    Expect(1, 917999, '\p{Blk=vssup}', "");
    Expect(0, 917999, '\p{^Blk=vssup}', "");
    Expect(0, 917999, '\P{Blk=vssup}', "");
    Expect(1, 917999, '\P{^Blk=vssup}', "");
    Expect(0, 918000, '\p{Blk=vssup}', "");
    Expect(1, 918000, '\p{^Blk=vssup}', "");
    Expect(1, 918000, '\P{Blk=vssup}', "");
    Expect(0, 918000, '\P{^Blk=vssup}', "");
    Expect(1, 917999, '\p{Blk=:\Avssup\z:}', "");;
    Expect(0, 918000, '\p{Blk=:\Avssup\z:}', "");;
    Expect(1, 917999, '\p{Blk=	_vs_Sup}', "");
    Expect(0, 917999, '\p{^Blk=	_vs_Sup}', "");
    Expect(0, 917999, '\P{Blk=	_vs_Sup}', "");
    Expect(1, 917999, '\P{^Blk=	_vs_Sup}', "");
    Expect(0, 918000, '\p{Blk=	_vs_Sup}', "");
    Expect(1, 918000, '\p{^Blk=	_vs_Sup}', "");
    Expect(1, 918000, '\P{Blk=	_vs_Sup}', "");
    Expect(0, 918000, '\P{^Blk=	_vs_Sup}', "");
    Error('\p{Is_Block= /a/VARIATION_Selectors_Supplement}');
    Error('\P{Is_Block= /a/VARIATION_Selectors_Supplement}');
    Expect(1, 917999, '\p{Is_Block=variationselectorssupplement}', "");
    Expect(0, 917999, '\p{^Is_Block=variationselectorssupplement}', "");
    Expect(0, 917999, '\P{Is_Block=variationselectorssupplement}', "");
    Expect(1, 917999, '\P{^Is_Block=variationselectorssupplement}', "");
    Expect(0, 918000, '\p{Is_Block=variationselectorssupplement}', "");
    Expect(1, 918000, '\p{^Is_Block=variationselectorssupplement}', "");
    Expect(1, 918000, '\P{Is_Block=variationselectorssupplement}', "");
    Expect(0, 918000, '\P{^Is_Block=variationselectorssupplement}', "");
    Expect(1, 917999, '\p{Is_Block=Variation_Selectors_supplement}', "");
    Expect(0, 917999, '\p{^Is_Block=Variation_Selectors_supplement}', "");
    Expect(0, 917999, '\P{Is_Block=Variation_Selectors_supplement}', "");
    Expect(1, 917999, '\P{^Is_Block=Variation_Selectors_supplement}', "");
    Expect(0, 918000, '\p{Is_Block=Variation_Selectors_supplement}', "");
    Expect(1, 918000, '\p{^Is_Block=Variation_Selectors_supplement}', "");
    Expect(1, 918000, '\P{Is_Block=Variation_Selectors_supplement}', "");
    Expect(0, 918000, '\P{^Is_Block=Variation_Selectors_supplement}', "");
    Error('\p{Is_Blk=__VS_Sup/a/}');
    Error('\P{Is_Blk=__VS_Sup/a/}');
    Expect(1, 917999, '\p{Is_Blk=vssup}', "");
    Expect(0, 917999, '\p{^Is_Blk=vssup}', "");
    Expect(0, 917999, '\P{Is_Blk=vssup}', "");
    Expect(1, 917999, '\P{^Is_Blk=vssup}', "");
    Expect(0, 918000, '\p{Is_Blk=vssup}', "");
    Expect(1, 918000, '\p{^Is_Blk=vssup}', "");
    Expect(1, 918000, '\P{Is_Blk=vssup}', "");
    Expect(0, 918000, '\P{^Is_Blk=vssup}', "");
    Expect(1, 917999, '\p{Is_Blk= 	VS_sup}', "");
    Expect(0, 917999, '\p{^Is_Blk= 	VS_sup}', "");
    Expect(0, 917999, '\P{Is_Blk= 	VS_sup}', "");
    Expect(1, 917999, '\P{^Is_Blk= 	VS_sup}', "");
    Expect(0, 918000, '\p{Is_Blk= 	VS_sup}', "");
    Expect(1, 918000, '\p{^Is_Blk= 	VS_sup}', "");
    Expect(1, 918000, '\P{Is_Blk= 	VS_sup}', "");
    Expect(0, 918000, '\P{^Is_Blk= 	VS_sup}', "");
    Error('\p{Block:	/a/- Wancho}');
    Error('\P{Block:	/a/- Wancho}');
    Expect(1, 123647, '\p{Block=:\AWancho\z:}', "");;
    Expect(0, 123648, '\p{Block=:\AWancho\z:}', "");;
    Expect(1, 123647, '\p{Block=wancho}', "");
    Expect(0, 123647, '\p{^Block=wancho}', "");
    Expect(0, 123647, '\P{Block=wancho}', "");
    Expect(1, 123647, '\P{^Block=wancho}', "");
    Expect(0, 123648, '\p{Block=wancho}', "");
    Expect(1, 123648, '\p{^Block=wancho}', "");
    Expect(1, 123648, '\P{Block=wancho}', "");
    Expect(0, 123648, '\P{^Block=wancho}', "");
    Expect(1, 123647, '\p{Block=:\Awancho\z:}', "");;
    Expect(0, 123648, '\p{Block=:\Awancho\z:}', "");;
    Expect(1, 123647, '\p{Block=-wancho}', "");
    Expect(0, 123647, '\p{^Block=-wancho}', "");
    Expect(0, 123647, '\P{Block=-wancho}', "");
    Expect(1, 123647, '\P{^Block=-wancho}', "");
    Expect(0, 123648, '\p{Block=-wancho}', "");
    Expect(1, 123648, '\p{^Block=-wancho}', "");
    Expect(1, 123648, '\P{Block=-wancho}', "");
    Expect(0, 123648, '\P{^Block=-wancho}', "");
    Error('\p{Blk=:= Wancho}');
    Error('\P{Blk=:= Wancho}');
    Expect(1, 123647, '\p{Blk=:\AWancho\z:}', "");;
    Expect(0, 123648, '\p{Blk=:\AWancho\z:}', "");;
    Expect(1, 123647, '\p{Blk=wancho}', "");
    Expect(0, 123647, '\p{^Blk=wancho}', "");
    Expect(0, 123647, '\P{Blk=wancho}', "");
    Expect(1, 123647, '\P{^Blk=wancho}', "");
    Expect(0, 123648, '\p{Blk=wancho}', "");
    Expect(1, 123648, '\p{^Blk=wancho}', "");
    Expect(1, 123648, '\P{Blk=wancho}', "");
    Expect(0, 123648, '\P{^Blk=wancho}', "");
    Expect(1, 123647, '\p{Blk=:\Awancho\z:}', "");;
    Expect(0, 123648, '\p{Blk=:\Awancho\z:}', "");;
    Expect(1, 123647, '\p{Blk:  wancho}', "");
    Expect(0, 123647, '\p{^Blk:  wancho}', "");
    Expect(0, 123647, '\P{Blk:  wancho}', "");
    Expect(1, 123647, '\P{^Blk:  wancho}', "");
    Expect(0, 123648, '\p{Blk:  wancho}', "");
    Expect(1, 123648, '\p{^Blk:  wancho}', "");
    Expect(1, 123648, '\P{Blk:  wancho}', "");
    Expect(0, 123648, '\P{^Blk:  wancho}', "");
    Error('\p{Is_Block=/a/ _WANCHO}');
    Error('\P{Is_Block=/a/ _WANCHO}');
    Expect(1, 123647, '\p{Is_Block=wancho}', "");
    Expect(0, 123647, '\p{^Is_Block=wancho}', "");
    Expect(0, 123647, '\P{Is_Block=wancho}', "");
    Expect(1, 123647, '\P{^Is_Block=wancho}', "");
    Expect(0, 123648, '\p{Is_Block=wancho}', "");
    Expect(1, 123648, '\p{^Is_Block=wancho}', "");
    Expect(1, 123648, '\P{Is_Block=wancho}', "");
    Expect(0, 123648, '\P{^Is_Block=wancho}', "");
    Expect(1, 123647, '\p{Is_Block=	-Wancho}', "");
    Expect(0, 123647, '\p{^Is_Block=	-Wancho}', "");
    Expect(0, 123647, '\P{Is_Block=	-Wancho}', "");
    Expect(1, 123647, '\P{^Is_Block=	-Wancho}', "");
    Expect(0, 123648, '\p{Is_Block=	-Wancho}', "");
    Expect(1, 123648, '\p{^Is_Block=	-Wancho}', "");
    Expect(1, 123648, '\P{Is_Block=	-Wancho}', "");
    Expect(0, 123648, '\P{^Is_Block=	-Wancho}', "");
    Error('\p{Is_Blk=/a/ -wancho}');
    Error('\P{Is_Blk=/a/ -wancho}');
    Expect(1, 123647, '\p{Is_Blk=wancho}', "");
    Expect(0, 123647, '\p{^Is_Blk=wancho}', "");
    Expect(0, 123647, '\P{Is_Blk=wancho}', "");
    Expect(1, 123647, '\P{^Is_Blk=wancho}', "");
    Expect(0, 123648, '\p{Is_Blk=wancho}', "");
    Expect(1, 123648, '\p{^Is_Blk=wancho}', "");
    Expect(1, 123648, '\P{Is_Blk=wancho}', "");
    Expect(0, 123648, '\P{^Is_Blk=wancho}', "");
    Expect(1, 123647, '\p{Is_Blk=_Wancho}', "");
    Expect(0, 123647, '\p{^Is_Blk=_Wancho}', "");
    Expect(0, 123647, '\P{Is_Blk=_Wancho}', "");
    Expect(1, 123647, '\P{^Is_Blk=_Wancho}', "");
    Expect(0, 123648, '\p{Is_Blk=_Wancho}', "");
    Expect(1, 123648, '\p{^Is_Blk=_Wancho}', "");
    Expect(1, 123648, '\P{Is_Blk=_Wancho}', "");
    Expect(0, 123648, '\P{^Is_Blk=_Wancho}', "");
    Error('\p{Block=:=_Warang_Citi}');
    Error('\P{Block=:=_Warang_Citi}');
    Expect(1, 71935, '\p{Block=:\AWarang_Citi\z:}', "");;
    Expect(0, 71936, '\p{Block=:\AWarang_Citi\z:}', "");;
    Expect(1, 71935, '\p{Block=warangciti}', "");
    Expect(0, 71935, '\p{^Block=warangciti}', "");
    Expect(0, 71935, '\P{Block=warangciti}', "");
    Expect(1, 71935, '\P{^Block=warangciti}', "");
    Expect(0, 71936, '\p{Block=warangciti}', "");
    Expect(1, 71936, '\p{^Block=warangciti}', "");
    Expect(1, 71936, '\P{Block=warangciti}', "");
    Expect(0, 71936, '\P{^Block=warangciti}', "");
    Expect(1, 71935, '\p{Block=:\Awarangciti\z:}', "");;
    Expect(0, 71936, '\p{Block=:\Awarangciti\z:}', "");;
    Expect(1, 71935, '\p{Block=_Warang_Citi}', "");
    Expect(0, 71935, '\p{^Block=_Warang_Citi}', "");
    Expect(0, 71935, '\P{Block=_Warang_Citi}', "");
    Expect(1, 71935, '\P{^Block=_Warang_Citi}', "");
    Expect(0, 71936, '\p{Block=_Warang_Citi}', "");
    Expect(1, 71936, '\p{^Block=_Warang_Citi}', "");
    Expect(1, 71936, '\P{Block=_Warang_Citi}', "");
    Expect(0, 71936, '\P{^Block=_Warang_Citi}', "");
    Error('\p{Blk=	/a/Warang_Citi}');
    Error('\P{Blk=	/a/Warang_Citi}');
    Expect(1, 71935, '\p{Blk=:\AWarang_Citi\z:}', "");;
    Expect(0, 71936, '\p{Blk=:\AWarang_Citi\z:}', "");;
    Expect(1, 71935, '\p{Blk:	warangciti}', "");
    Expect(0, 71935, '\p{^Blk:	warangciti}', "");
    Expect(0, 71935, '\P{Blk:	warangciti}', "");
    Expect(1, 71935, '\P{^Blk:	warangciti}', "");
    Expect(0, 71936, '\p{Blk:	warangciti}', "");
    Expect(1, 71936, '\p{^Blk:	warangciti}', "");
    Expect(1, 71936, '\P{Blk:	warangciti}', "");
    Expect(0, 71936, '\P{^Blk:	warangciti}', "");
    Expect(1, 71935, '\p{Blk=:\Awarangciti\z:}', "");;
    Expect(0, 71936, '\p{Blk=:\Awarangciti\z:}', "");;
    Expect(1, 71935, '\p{Blk=WARANG_Citi}', "");
    Expect(0, 71935, '\p{^Blk=WARANG_Citi}', "");
    Expect(0, 71935, '\P{Blk=WARANG_Citi}', "");
    Expect(1, 71935, '\P{^Blk=WARANG_Citi}', "");
    Expect(0, 71936, '\p{Blk=WARANG_Citi}', "");
    Expect(1, 71936, '\p{^Blk=WARANG_Citi}', "");
    Expect(1, 71936, '\P{Blk=WARANG_Citi}', "");
    Expect(0, 71936, '\P{^Blk=WARANG_Citi}', "");
    Error('\p{Is_Block=/a/	WARANG_Citi}');
    Error('\P{Is_Block=/a/	WARANG_Citi}');
    Expect(1, 71935, '\p{Is_Block=warangciti}', "");
    Expect(0, 71935, '\p{^Is_Block=warangciti}', "");
    Expect(0, 71935, '\P{Is_Block=warangciti}', "");
    Expect(1, 71935, '\P{^Is_Block=warangciti}', "");
    Expect(0, 71936, '\p{Is_Block=warangciti}', "");
    Expect(1, 71936, '\p{^Is_Block=warangciti}', "");
    Expect(1, 71936, '\P{Is_Block=warangciti}', "");
    Expect(0, 71936, '\P{^Is_Block=warangciti}', "");
    Expect(1, 71935, '\p{Is_Block:	_	WARANG_citi}', "");
    Expect(0, 71935, '\p{^Is_Block:	_	WARANG_citi}', "");
    Expect(0, 71935, '\P{Is_Block:	_	WARANG_citi}', "");
    Expect(1, 71935, '\P{^Is_Block:	_	WARANG_citi}', "");
    Expect(0, 71936, '\p{Is_Block:	_	WARANG_citi}', "");
    Expect(1, 71936, '\p{^Is_Block:	_	WARANG_citi}', "");
    Expect(1, 71936, '\P{Is_Block:	_	WARANG_citi}', "");
    Expect(0, 71936, '\P{^Is_Block:	_	WARANG_citi}', "");
    Error('\p{Is_Blk=-_Warang_Citi/a/}');
    Error('\P{Is_Blk=-_Warang_Citi/a/}');
    Expect(1, 71935, '\p{Is_Blk=warangciti}', "");
    Expect(0, 71935, '\p{^Is_Blk=warangciti}', "");
    Expect(0, 71935, '\P{Is_Blk=warangciti}', "");
    Expect(1, 71935, '\P{^Is_Blk=warangciti}', "");
    Expect(0, 71936, '\p{Is_Blk=warangciti}', "");
    Expect(1, 71936, '\p{^Is_Blk=warangciti}', "");
    Expect(1, 71936, '\P{Is_Blk=warangciti}', "");
    Expect(0, 71936, '\P{^Is_Blk=warangciti}', "");
    Expect(1, 71935, '\p{Is_Blk= -warang_Citi}', "");
    Expect(0, 71935, '\p{^Is_Blk= -warang_Citi}', "");
    Expect(0, 71935, '\P{Is_Blk= -warang_Citi}', "");
    Expect(1, 71935, '\P{^Is_Blk= -warang_Citi}', "");
    Expect(0, 71936, '\p{Is_Blk= -warang_Citi}', "");
    Expect(1, 71936, '\p{^Is_Blk= -warang_Citi}', "");
    Expect(1, 71936, '\P{Is_Blk= -warang_Citi}', "");
    Expect(0, 71936, '\P{^Is_Blk= -warang_Citi}', "");
    Error('\p{Block=:=	_YEZIDI}');
    Error('\P{Block=:=	_YEZIDI}');
    Expect(1, 69311, '\p{Block=:\AYezidi\z:}', "");;
    Expect(0, 69312, '\p{Block=:\AYezidi\z:}', "");;
    Expect(1, 69311, '\p{Block=yezidi}', "");
    Expect(0, 69311, '\p{^Block=yezidi}', "");
    Expect(0, 69311, '\P{Block=yezidi}', "");
    Expect(1, 69311, '\P{^Block=yezidi}', "");
    Expect(0, 69312, '\p{Block=yezidi}', "");
    Expect(1, 69312, '\p{^Block=yezidi}', "");
    Expect(1, 69312, '\P{Block=yezidi}', "");
    Expect(0, 69312, '\P{^Block=yezidi}', "");
    Expect(1, 69311, '\p{Block=:\Ayezidi\z:}', "");;
    Expect(0, 69312, '\p{Block=:\Ayezidi\z:}', "");;
    Expect(1, 69311, '\p{Block=_	YEZIDI}', "");
    Expect(0, 69311, '\p{^Block=_	YEZIDI}', "");
    Expect(0, 69311, '\P{Block=_	YEZIDI}', "");
    Expect(1, 69311, '\P{^Block=_	YEZIDI}', "");
    Expect(0, 69312, '\p{Block=_	YEZIDI}', "");
    Expect(1, 69312, '\p{^Block=_	YEZIDI}', "");
    Expect(1, 69312, '\P{Block=_	YEZIDI}', "");
    Expect(0, 69312, '\P{^Block=_	YEZIDI}', "");
    Error('\p{Blk=:=yezidi}');
    Error('\P{Blk=:=yezidi}');
    Expect(1, 69311, '\p{Blk=:\AYezidi\z:}', "");;
    Expect(0, 69312, '\p{Blk=:\AYezidi\z:}', "");;
    Expect(1, 69311, '\p{Blk:	yezidi}', "");
    Expect(0, 69311, '\p{^Blk:	yezidi}', "");
    Expect(0, 69311, '\P{Blk:	yezidi}', "");
    Expect(1, 69311, '\P{^Blk:	yezidi}', "");
    Expect(0, 69312, '\p{Blk:	yezidi}', "");
    Expect(1, 69312, '\p{^Blk:	yezidi}', "");
    Expect(1, 69312, '\P{Blk:	yezidi}', "");
    Expect(0, 69312, '\P{^Blk:	yezidi}', "");
    Expect(1, 69311, '\p{Blk=:\Ayezidi\z:}', "");;
    Expect(0, 69312, '\p{Blk=:\Ayezidi\z:}', "");;
    Expect(1, 69311, '\p{Blk:   	Yezidi}', "");
    Expect(0, 69311, '\p{^Blk:   	Yezidi}', "");
    Expect(0, 69311, '\P{Blk:   	Yezidi}', "");
    Expect(1, 69311, '\P{^Blk:   	Yezidi}', "");
    Expect(0, 69312, '\p{Blk:   	Yezidi}', "");
    Expect(1, 69312, '\p{^Blk:   	Yezidi}', "");
    Expect(1, 69312, '\P{Blk:   	Yezidi}', "");
    Expect(0, 69312, '\P{^Blk:   	Yezidi}', "");
    Error('\p{Is_Block=	-Yezidi/a/}');
    Error('\P{Is_Block=	-Yezidi/a/}');
    Expect(1, 69311, '\p{Is_Block=yezidi}', "");
    Expect(0, 69311, '\p{^Is_Block=yezidi}', "");
    Expect(0, 69311, '\P{Is_Block=yezidi}', "");
    Expect(1, 69311, '\P{^Is_Block=yezidi}', "");
    Expect(0, 69312, '\p{Is_Block=yezidi}', "");
    Expect(1, 69312, '\p{^Is_Block=yezidi}', "");
    Expect(1, 69312, '\P{Is_Block=yezidi}', "");
    Expect(0, 69312, '\P{^Is_Block=yezidi}', "");
    Expect(1, 69311, '\p{Is_Block=_	Yezidi}', "");
    Expect(0, 69311, '\p{^Is_Block=_	Yezidi}', "");
    Expect(0, 69311, '\P{Is_Block=_	Yezidi}', "");
    Expect(1, 69311, '\P{^Is_Block=_	Yezidi}', "");
    Expect(0, 69312, '\p{Is_Block=_	Yezidi}', "");
    Expect(1, 69312, '\p{^Is_Block=_	Yezidi}', "");
    Expect(1, 69312, '\P{Is_Block=_	Yezidi}', "");
    Expect(0, 69312, '\P{^Is_Block=_	Yezidi}', "");
    Error('\p{Is_Blk=_/a/Yezidi}');
    Error('\P{Is_Blk=_/a/Yezidi}');
    Expect(1, 69311, '\p{Is_Blk=yezidi}', "");
    Expect(0, 69311, '\p{^Is_Blk=yezidi}', "");
    Expect(0, 69311, '\P{Is_Blk=yezidi}', "");
    Expect(1, 69311, '\P{^Is_Blk=yezidi}', "");
    Expect(0, 69312, '\p{Is_Blk=yezidi}', "");
    Expect(1, 69312, '\p{^Is_Blk=yezidi}', "");
    Expect(1, 69312, '\P{Is_Blk=yezidi}', "");
    Expect(0, 69312, '\P{^Is_Blk=yezidi}', "");
    Expect(1, 69311, '\p{Is_Blk=_Yezidi}', "");
    Expect(0, 69311, '\p{^Is_Blk=_Yezidi}', "");
    Expect(0, 69311, '\P{Is_Blk=_Yezidi}', "");
    Expect(1, 69311, '\P{^Is_Blk=_Yezidi}', "");
    Expect(0, 69312, '\p{Is_Blk=_Yezidi}', "");
    Expect(1, 69312, '\p{^Is_Blk=_Yezidi}', "");
    Expect(1, 69312, '\P{Is_Blk=_Yezidi}', "");
    Expect(0, 69312, '\P{^Is_Blk=_Yezidi}', "");
    Error('\p{Block= :=Yi_RADICALS}');
    Error('\P{Block= :=Yi_RADICALS}');
    Expect(1, 42191, '\p{Block=:\AYi_Radicals\z:}', "");;
    Expect(0, 42192, '\p{Block=:\AYi_Radicals\z:}', "");;
    Expect(1, 42191, '\p{Block=yiradicals}', "");
    Expect(0, 42191, '\p{^Block=yiradicals}', "");
    Expect(0, 42191, '\P{Block=yiradicals}', "");
    Expect(1, 42191, '\P{^Block=yiradicals}', "");
    Expect(0, 42192, '\p{Block=yiradicals}', "");
    Expect(1, 42192, '\p{^Block=yiradicals}', "");
    Expect(1, 42192, '\P{Block=yiradicals}', "");
    Expect(0, 42192, '\P{^Block=yiradicals}', "");
    Expect(1, 42191, '\p{Block=:\Ayiradicals\z:}', "");;
    Expect(0, 42192, '\p{Block=:\Ayiradicals\z:}', "");;
    Expect(1, 42191, '\p{Block=- YI_RADICALS}', "");
    Expect(0, 42191, '\p{^Block=- YI_RADICALS}', "");
    Expect(0, 42191, '\P{Block=- YI_RADICALS}', "");
    Expect(1, 42191, '\P{^Block=- YI_RADICALS}', "");
    Expect(0, 42192, '\p{Block=- YI_RADICALS}', "");
    Expect(1, 42192, '\p{^Block=- YI_RADICALS}', "");
    Expect(1, 42192, '\P{Block=- YI_RADICALS}', "");
    Expect(0, 42192, '\P{^Block=- YI_RADICALS}', "");
    Error('\p{Blk=/a/ Yi_RADICALS}');
    Error('\P{Blk=/a/ Yi_RADICALS}');
    Expect(1, 42191, '\p{Blk=:\AYi_Radicals\z:}', "");;
    Expect(0, 42192, '\p{Blk=:\AYi_Radicals\z:}', "");;
    Expect(1, 42191, '\p{Blk=yiradicals}', "");
    Expect(0, 42191, '\p{^Blk=yiradicals}', "");
    Expect(0, 42191, '\P{Blk=yiradicals}', "");
    Expect(1, 42191, '\P{^Blk=yiradicals}', "");
    Expect(0, 42192, '\p{Blk=yiradicals}', "");
    Expect(1, 42192, '\p{^Blk=yiradicals}', "");
    Expect(1, 42192, '\P{Blk=yiradicals}', "");
    Expect(0, 42192, '\P{^Blk=yiradicals}', "");
    Expect(1, 42191, '\p{Blk=:\Ayiradicals\z:}', "");;
    Expect(0, 42192, '\p{Blk=:\Ayiradicals\z:}', "");;
    Expect(1, 42191, '\p{Blk=_Yi_Radicals}', "");
    Expect(0, 42191, '\p{^Blk=_Yi_Radicals}', "");
    Expect(0, 42191, '\P{Blk=_Yi_Radicals}', "");
    Expect(1, 42191, '\P{^Blk=_Yi_Radicals}', "");
    Expect(0, 42192, '\p{Blk=_Yi_Radicals}', "");
    Expect(1, 42192, '\p{^Blk=_Yi_Radicals}', "");
    Expect(1, 42192, '\P{Blk=_Yi_Radicals}', "");
    Expect(0, 42192, '\P{^Blk=_Yi_Radicals}', "");
    Error('\p{Is_Block=_:=YI_Radicals}');
    Error('\P{Is_Block=_:=YI_Radicals}');
    Expect(1, 42191, '\p{Is_Block=yiradicals}', "");
    Expect(0, 42191, '\p{^Is_Block=yiradicals}', "");
    Expect(0, 42191, '\P{Is_Block=yiradicals}', "");
    Expect(1, 42191, '\P{^Is_Block=yiradicals}', "");
    Expect(0, 42192, '\p{Is_Block=yiradicals}', "");
    Expect(1, 42192, '\p{^Is_Block=yiradicals}', "");
    Expect(1, 42192, '\P{Is_Block=yiradicals}', "");
    Expect(0, 42192, '\P{^Is_Block=yiradicals}', "");
    Expect(1, 42191, '\p{Is_Block= YI_Radicals}', "");
    Expect(0, 42191, '\p{^Is_Block= YI_Radicals}', "");
    Expect(0, 42191, '\P{Is_Block= YI_Radicals}', "");
    Expect(1, 42191, '\P{^Is_Block= YI_Radicals}', "");
    Expect(0, 42192, '\p{Is_Block= YI_Radicals}', "");
    Expect(1, 42192, '\p{^Is_Block= YI_Radicals}', "");
    Expect(1, 42192, '\P{Is_Block= YI_Radicals}', "");
    Expect(0, 42192, '\P{^Is_Block= YI_Radicals}', "");
    Error('\p{Is_Blk=/a/ yi_RADICALS}');
    Error('\P{Is_Blk=/a/ yi_RADICALS}');
    Expect(1, 42191, '\p{Is_Blk:yiradicals}', "");
    Expect(0, 42191, '\p{^Is_Blk:yiradicals}', "");
    Expect(0, 42191, '\P{Is_Blk:yiradicals}', "");
    Expect(1, 42191, '\P{^Is_Blk:yiradicals}', "");
    Expect(0, 42192, '\p{Is_Blk:yiradicals}', "");
    Expect(1, 42192, '\p{^Is_Blk:yiradicals}', "");
    Expect(1, 42192, '\P{Is_Blk:yiradicals}', "");
    Expect(0, 42192, '\P{^Is_Blk:yiradicals}', "");
    Expect(1, 42191, '\p{Is_Blk=-	yi_RADICALS}', "");
    Expect(0, 42191, '\p{^Is_Blk=-	yi_RADICALS}', "");
    Expect(0, 42191, '\P{Is_Blk=-	yi_RADICALS}', "");
    Expect(1, 42191, '\P{^Is_Blk=-	yi_RADICALS}', "");
    Expect(0, 42192, '\p{Is_Blk=-	yi_RADICALS}', "");
    Expect(1, 42192, '\p{^Is_Blk=-	yi_RADICALS}', "");
    Expect(1, 42192, '\P{Is_Blk=-	yi_RADICALS}', "");
    Expect(0, 42192, '\P{^Is_Blk=-	yi_RADICALS}', "");
    Error('\p{Block=:=YI_syllables}');
    Error('\P{Block=:=YI_syllables}');
    Expect(1, 42127, '\p{Block=:\AYi_Syllables\z:}', "");;
    Expect(0, 42128, '\p{Block=:\AYi_Syllables\z:}', "");;
    Expect(1, 42127, '\p{Block=yisyllables}', "");
    Expect(0, 42127, '\p{^Block=yisyllables}', "");
    Expect(0, 42127, '\P{Block=yisyllables}', "");
    Expect(1, 42127, '\P{^Block=yisyllables}', "");
    Expect(0, 42128, '\p{Block=yisyllables}', "");
    Expect(1, 42128, '\p{^Block=yisyllables}', "");
    Expect(1, 42128, '\P{Block=yisyllables}', "");
    Expect(0, 42128, '\P{^Block=yisyllables}', "");
    Expect(1, 42127, '\p{Block=:\Ayisyllables\z:}', "");;
    Expect(0, 42128, '\p{Block=:\Ayisyllables\z:}', "");;
    Expect(1, 42127, '\p{Block=	yi_Syllables}', "");
    Expect(0, 42127, '\p{^Block=	yi_Syllables}', "");
    Expect(0, 42127, '\P{Block=	yi_Syllables}', "");
    Expect(1, 42127, '\P{^Block=	yi_Syllables}', "");
    Expect(0, 42128, '\p{Block=	yi_Syllables}', "");
    Expect(1, 42128, '\p{^Block=	yi_Syllables}', "");
    Expect(1, 42128, '\P{Block=	yi_Syllables}', "");
    Expect(0, 42128, '\P{^Block=	yi_Syllables}', "");
    Error('\p{Blk=	/a/YI_Syllables}');
    Error('\P{Blk=	/a/YI_Syllables}');
    Expect(1, 42127, '\p{Blk=:\AYi_Syllables\z:}', "");;
    Expect(0, 42128, '\p{Blk=:\AYi_Syllables\z:}', "");;
    Expect(1, 42127, '\p{Blk=yisyllables}', "");
    Expect(0, 42127, '\p{^Blk=yisyllables}', "");
    Expect(0, 42127, '\P{Blk=yisyllables}', "");
    Expect(1, 42127, '\P{^Blk=yisyllables}', "");
    Expect(0, 42128, '\p{Blk=yisyllables}', "");
    Expect(1, 42128, '\p{^Blk=yisyllables}', "");
    Expect(1, 42128, '\P{Blk=yisyllables}', "");
    Expect(0, 42128, '\P{^Blk=yisyllables}', "");
    Expect(1, 42127, '\p{Blk=:\Ayisyllables\z:}', "");;
    Expect(0, 42128, '\p{Blk=:\Ayisyllables\z:}', "");;
    Expect(1, 42127, '\p{Blk= YI_Syllables}', "");
    Expect(0, 42127, '\p{^Blk= YI_Syllables}', "");
    Expect(0, 42127, '\P{Blk= YI_Syllables}', "");
    Expect(1, 42127, '\P{^Blk= YI_Syllables}', "");
    Expect(0, 42128, '\p{Blk= YI_Syllables}', "");
    Expect(1, 42128, '\p{^Blk= YI_Syllables}', "");
    Expect(1, 42128, '\P{Blk= YI_Syllables}', "");
    Expect(0, 42128, '\P{^Blk= YI_Syllables}', "");
    Error('\p{Is_Block= :=YI_SYLLABLES}');
    Error('\P{Is_Block= :=YI_SYLLABLES}');
    Expect(1, 42127, '\p{Is_Block=yisyllables}', "");
    Expect(0, 42127, '\p{^Is_Block=yisyllables}', "");
    Expect(0, 42127, '\P{Is_Block=yisyllables}', "");
    Expect(1, 42127, '\P{^Is_Block=yisyllables}', "");
    Expect(0, 42128, '\p{Is_Block=yisyllables}', "");
    Expect(1, 42128, '\p{^Is_Block=yisyllables}', "");
    Expect(1, 42128, '\P{Is_Block=yisyllables}', "");
    Expect(0, 42128, '\P{^Is_Block=yisyllables}', "");
    Expect(1, 42127, '\p{Is_Block: -YI_Syllables}', "");
    Expect(0, 42127, '\p{^Is_Block: -YI_Syllables}', "");
    Expect(0, 42127, '\P{Is_Block: -YI_Syllables}', "");
    Expect(1, 42127, '\P{^Is_Block: -YI_Syllables}', "");
    Expect(0, 42128, '\p{Is_Block: -YI_Syllables}', "");
    Expect(1, 42128, '\p{^Is_Block: -YI_Syllables}', "");
    Expect(1, 42128, '\P{Is_Block: -YI_Syllables}', "");
    Expect(0, 42128, '\P{^Is_Block: -YI_Syllables}', "");
    Error('\p{Is_Blk=_Yi_Syllables/a/}');
    Error('\P{Is_Blk=_Yi_Syllables/a/}');
    Expect(1, 42127, '\p{Is_Blk=yisyllables}', "");
    Expect(0, 42127, '\p{^Is_Blk=yisyllables}', "");
    Expect(0, 42127, '\P{Is_Blk=yisyllables}', "");
    Expect(1, 42127, '\P{^Is_Blk=yisyllables}', "");
    Expect(0, 42128, '\p{Is_Blk=yisyllables}', "");
    Expect(1, 42128, '\p{^Is_Blk=yisyllables}', "");
    Expect(1, 42128, '\P{Is_Blk=yisyllables}', "");
    Expect(0, 42128, '\P{^Is_Blk=yisyllables}', "");
    Expect(1, 42127, '\p{Is_Blk=--Yi_Syllables}', "");
    Expect(0, 42127, '\p{^Is_Blk=--Yi_Syllables}', "");
    Expect(0, 42127, '\P{Is_Blk=--Yi_Syllables}', "");
    Expect(1, 42127, '\P{^Is_Blk=--Yi_Syllables}', "");
    Expect(0, 42128, '\p{Is_Blk=--Yi_Syllables}', "");
    Expect(1, 42128, '\p{^Is_Blk=--Yi_Syllables}', "");
    Expect(1, 42128, '\P{Is_Blk=--Yi_Syllables}', "");
    Expect(0, 42128, '\P{^Is_Blk=--Yi_Syllables}', "");
    Error('\p{Block=:=_YIJING_HEXAGRAM_symbols}');
    Error('\P{Block=:=_YIJING_HEXAGRAM_symbols}');
    Expect(1, 19967, '\p{Block=:\AYijing_Hexagram_Symbols\z:}', "");;
    Expect(0, 19968, '\p{Block=:\AYijing_Hexagram_Symbols\z:}', "");;
    Expect(1, 19967, '\p{Block=yijinghexagramsymbols}', "");
    Expect(0, 19967, '\p{^Block=yijinghexagramsymbols}', "");
    Expect(0, 19967, '\P{Block=yijinghexagramsymbols}', "");
    Expect(1, 19967, '\P{^Block=yijinghexagramsymbols}', "");
    Expect(0, 19968, '\p{Block=yijinghexagramsymbols}', "");
    Expect(1, 19968, '\p{^Block=yijinghexagramsymbols}', "");
    Expect(1, 19968, '\P{Block=yijinghexagramsymbols}', "");
    Expect(0, 19968, '\P{^Block=yijinghexagramsymbols}', "");
    Expect(1, 19967, '\p{Block=:\Ayijinghexagramsymbols\z:}', "");;
    Expect(0, 19968, '\p{Block=:\Ayijinghexagramsymbols\z:}', "");;
    Expect(1, 19967, '\p{Block=-	Yijing_Hexagram_symbols}', "");
    Expect(0, 19967, '\p{^Block=-	Yijing_Hexagram_symbols}', "");
    Expect(0, 19967, '\P{Block=-	Yijing_Hexagram_symbols}', "");
    Expect(1, 19967, '\P{^Block=-	Yijing_Hexagram_symbols}', "");
    Expect(0, 19968, '\p{Block=-	Yijing_Hexagram_symbols}', "");
    Expect(1, 19968, '\p{^Block=-	Yijing_Hexagram_symbols}', "");
    Expect(1, 19968, '\P{Block=-	Yijing_Hexagram_symbols}', "");
    Expect(0, 19968, '\P{^Block=-	Yijing_Hexagram_symbols}', "");
    Error('\p{Blk=-/a/Yijing}');
    Error('\P{Blk=-/a/Yijing}');
    Expect(1, 19967, '\p{Blk=:\AYijing\z:}', "");;
    Expect(0, 19968, '\p{Blk=:\AYijing\z:}', "");;
    Expect(1, 19967, '\p{Blk=yijing}', "");
    Expect(0, 19967, '\p{^Blk=yijing}', "");
    Expect(0, 19967, '\P{Blk=yijing}', "");
    Expect(1, 19967, '\P{^Blk=yijing}', "");
    Expect(0, 19968, '\p{Blk=yijing}', "");
    Expect(1, 19968, '\p{^Blk=yijing}', "");
    Expect(1, 19968, '\P{Blk=yijing}', "");
    Expect(0, 19968, '\P{^Blk=yijing}', "");
    Expect(1, 19967, '\p{Blk=:\Ayijing\z:}', "");;
    Expect(0, 19968, '\p{Blk=:\Ayijing\z:}', "");;
    Expect(1, 19967, '\p{Blk=_Yijing}', "");
    Expect(0, 19967, '\p{^Blk=_Yijing}', "");
    Expect(0, 19967, '\P{Blk=_Yijing}', "");
    Expect(1, 19967, '\P{^Blk=_Yijing}', "");
    Expect(0, 19968, '\p{Blk=_Yijing}', "");
    Expect(1, 19968, '\p{^Blk=_Yijing}', "");
    Expect(1, 19968, '\P{Blk=_Yijing}', "");
    Expect(0, 19968, '\P{^Blk=_Yijing}', "");
    Error('\p{Is_Block=/a/_ Yijing_hexagram_Symbols}');
    Error('\P{Is_Block=/a/_ Yijing_hexagram_Symbols}');
    Expect(1, 19967, '\p{Is_Block=yijinghexagramsymbols}', "");
    Expect(0, 19967, '\p{^Is_Block=yijinghexagramsymbols}', "");
    Expect(0, 19967, '\P{Is_Block=yijinghexagramsymbols}', "");
    Expect(1, 19967, '\P{^Is_Block=yijinghexagramsymbols}', "");
    Expect(0, 19968, '\p{Is_Block=yijinghexagramsymbols}', "");
    Expect(1, 19968, '\p{^Is_Block=yijinghexagramsymbols}', "");
    Expect(1, 19968, '\P{Is_Block=yijinghexagramsymbols}', "");
    Expect(0, 19968, '\P{^Is_Block=yijinghexagramsymbols}', "");
    Expect(1, 19967, '\p{Is_Block=		Yijing_Hexagram_symbols}', "");
    Expect(0, 19967, '\p{^Is_Block=		Yijing_Hexagram_symbols}', "");
    Expect(0, 19967, '\P{Is_Block=		Yijing_Hexagram_symbols}', "");
    Expect(1, 19967, '\P{^Is_Block=		Yijing_Hexagram_symbols}', "");
    Expect(0, 19968, '\p{Is_Block=		Yijing_Hexagram_symbols}', "");
    Expect(1, 19968, '\p{^Is_Block=		Yijing_Hexagram_symbols}', "");
    Expect(1, 19968, '\P{Is_Block=		Yijing_Hexagram_symbols}', "");
    Expect(0, 19968, '\P{^Is_Block=		Yijing_Hexagram_symbols}', "");
    Error('\p{Is_Blk=/a/-Yijing}');
    Error('\P{Is_Blk=/a/-Yijing}');
    Expect(1, 19967, '\p{Is_Blk=yijing}', "");
    Expect(0, 19967, '\p{^Is_Blk=yijing}', "");
    Expect(0, 19967, '\P{Is_Blk=yijing}', "");
    Expect(1, 19967, '\P{^Is_Blk=yijing}', "");
    Expect(0, 19968, '\p{Is_Blk=yijing}', "");
    Expect(1, 19968, '\p{^Is_Blk=yijing}', "");
    Expect(1, 19968, '\P{Is_Blk=yijing}', "");
    Expect(0, 19968, '\P{^Is_Blk=yijing}', "");
    Expect(1, 19967, '\p{Is_Blk=-Yijing}', "");
    Expect(0, 19967, '\p{^Is_Blk=-Yijing}', "");
    Expect(0, 19967, '\P{Is_Blk=-Yijing}', "");
    Expect(1, 19967, '\P{^Is_Blk=-Yijing}', "");
    Expect(0, 19968, '\p{Is_Blk=-Yijing}', "");
    Expect(1, 19968, '\p{^Is_Blk=-Yijing}', "");
    Expect(1, 19968, '\P{Is_Blk=-Yijing}', "");
    Expect(0, 19968, '\P{^Is_Blk=-Yijing}', "");
    Error('\p{Block=	/a/ZANABAZAR_Square}');
    Error('\P{Block=	/a/ZANABAZAR_Square}');
    Expect(1, 72271, '\p{Block=:\AZanabazar_Square\z:}', "");;
    Expect(0, 72272, '\p{Block=:\AZanabazar_Square\z:}', "");;
    Expect(1, 72271, '\p{Block=zanabazarsquare}', "");
    Expect(0, 72271, '\p{^Block=zanabazarsquare}', "");
    Expect(0, 72271, '\P{Block=zanabazarsquare}', "");
    Expect(1, 72271, '\P{^Block=zanabazarsquare}', "");
    Expect(0, 72272, '\p{Block=zanabazarsquare}', "");
    Expect(1, 72272, '\p{^Block=zanabazarsquare}', "");
    Expect(1, 72272, '\P{Block=zanabazarsquare}', "");
    Expect(0, 72272, '\P{^Block=zanabazarsquare}', "");
    Expect(1, 72271, '\p{Block=:\Azanabazarsquare\z:}', "");;
    Expect(0, 72272, '\p{Block=:\Azanabazarsquare\z:}', "");;
    Expect(1, 72271, '\p{Block=--zanabazar_Square}', "");
    Expect(0, 72271, '\p{^Block=--zanabazar_Square}', "");
    Expect(0, 72271, '\P{Block=--zanabazar_Square}', "");
    Expect(1, 72271, '\P{^Block=--zanabazar_Square}', "");
    Expect(0, 72272, '\p{Block=--zanabazar_Square}', "");
    Expect(1, 72272, '\p{^Block=--zanabazar_Square}', "");
    Expect(1, 72272, '\P{Block=--zanabazar_Square}', "");
    Expect(0, 72272, '\P{^Block=--zanabazar_Square}', "");
    Error('\p{Blk=	_ZANABAZAR_square:=}');
    Error('\P{Blk=	_ZANABAZAR_square:=}');
    Expect(1, 72271, '\p{Blk=:\AZanabazar_Square\z:}', "");;
    Expect(0, 72272, '\p{Blk=:\AZanabazar_Square\z:}', "");;
    Expect(1, 72271, '\p{Blk=zanabazarsquare}', "");
    Expect(0, 72271, '\p{^Blk=zanabazarsquare}', "");
    Expect(0, 72271, '\P{Blk=zanabazarsquare}', "");
    Expect(1, 72271, '\P{^Blk=zanabazarsquare}', "");
    Expect(0, 72272, '\p{Blk=zanabazarsquare}', "");
    Expect(1, 72272, '\p{^Blk=zanabazarsquare}', "");
    Expect(1, 72272, '\P{Blk=zanabazarsquare}', "");
    Expect(0, 72272, '\P{^Blk=zanabazarsquare}', "");
    Expect(1, 72271, '\p{Blk=:\Azanabazarsquare\z:}', "");;
    Expect(0, 72272, '\p{Blk=:\Azanabazarsquare\z:}', "");;
    Expect(1, 72271, '\p{Blk=-Zanabazar_square}', "");
    Expect(0, 72271, '\p{^Blk=-Zanabazar_square}', "");
    Expect(0, 72271, '\P{Blk=-Zanabazar_square}', "");
    Expect(1, 72271, '\P{^Blk=-Zanabazar_square}', "");
    Expect(0, 72272, '\p{Blk=-Zanabazar_square}', "");
    Expect(1, 72272, '\p{^Blk=-Zanabazar_square}', "");
    Expect(1, 72272, '\P{Blk=-Zanabazar_square}', "");
    Expect(0, 72272, '\P{^Blk=-Zanabazar_square}', "");
    Error('\p{Is_Block: /a/	zanabazar_SQUARE}');
    Error('\P{Is_Block: /a/	zanabazar_SQUARE}');
    Expect(1, 72271, '\p{Is_Block=zanabazarsquare}', "");
    Expect(0, 72271, '\p{^Is_Block=zanabazarsquare}', "");
    Expect(0, 72271, '\P{Is_Block=zanabazarsquare}', "");
    Expect(1, 72271, '\P{^Is_Block=zanabazarsquare}', "");
    Expect(0, 72272, '\p{Is_Block=zanabazarsquare}', "");
    Expect(1, 72272, '\p{^Is_Block=zanabazarsquare}', "");
    Expect(1, 72272, '\P{Is_Block=zanabazarsquare}', "");
    Expect(0, 72272, '\P{^Is_Block=zanabazarsquare}', "");
    Expect(1, 72271, '\p{Is_Block= -zanabazar_square}', "");
    Expect(0, 72271, '\p{^Is_Block= -zanabazar_square}', "");
    Expect(0, 72271, '\P{Is_Block= -zanabazar_square}', "");
    Expect(1, 72271, '\P{^Is_Block= -zanabazar_square}', "");
    Expect(0, 72272, '\p{Is_Block= -zanabazar_square}', "");
    Expect(1, 72272, '\p{^Is_Block= -zanabazar_square}', "");
    Expect(1, 72272, '\P{Is_Block= -zanabazar_square}', "");
    Expect(0, 72272, '\P{^Is_Block= -zanabazar_square}', "");
    Error('\p{Is_Blk=/a/_ZANABAZAR_square}');
    Error('\P{Is_Blk=/a/_ZANABAZAR_square}');
    Expect(1, 72271, '\p{Is_Blk=zanabazarsquare}', "");
    Expect(0, 72271, '\p{^Is_Blk=zanabazarsquare}', "");
    Expect(0, 72271, '\P{Is_Blk=zanabazarsquare}', "");
    Expect(1, 72271, '\P{^Is_Blk=zanabazarsquare}', "");
    Expect(0, 72272, '\p{Is_Blk=zanabazarsquare}', "");
    Expect(1, 72272, '\p{^Is_Blk=zanabazarsquare}', "");
    Expect(1, 72272, '\P{Is_Blk=zanabazarsquare}', "");
    Expect(0, 72272, '\P{^Is_Blk=zanabazarsquare}', "");
    Expect(1, 72271, '\p{Is_Blk= _zanabazar_square}', "");
    Expect(0, 72271, '\p{^Is_Blk= _zanabazar_square}', "");
    Expect(0, 72271, '\P{Is_Blk= _zanabazar_square}', "");
    Expect(1, 72271, '\P{^Is_Blk= _zanabazar_square}', "");
    Expect(0, 72272, '\p{Is_Blk= _zanabazar_square}', "");
    Expect(1, 72272, '\p{^Is_Blk= _zanabazar_square}', "");
    Expect(1, 72272, '\P{Is_Blk= _zanabazar_square}', "");
    Expect(0, 72272, '\P{^Is_Blk= _zanabazar_square}', "");
    Error('\p{Block= /a/znamenny_Musical_notation}');
    Error('\P{Block= /a/znamenny_Musical_notation}');
    Expect(1, 118735, '\p{Block=:\AZnamenny_Musical_Notation\z:}', "");;
    Expect(0, 118736, '\p{Block=:\AZnamenny_Musical_Notation\z:}', "");;
    Expect(1, 118735, '\p{Block=znamennymusicalnotation}', "");
    Expect(0, 118735, '\p{^Block=znamennymusicalnotation}', "");
    Expect(0, 118735, '\P{Block=znamennymusicalnotation}', "");
    Expect(1, 118735, '\P{^Block=znamennymusicalnotation}', "");
    Expect(0, 118736, '\p{Block=znamennymusicalnotation}', "");
    Expect(1, 118736, '\p{^Block=znamennymusicalnotation}', "");
    Expect(1, 118736, '\P{Block=znamennymusicalnotation}', "");
    Expect(0, 118736, '\P{^Block=znamennymusicalnotation}', "");
    Expect(1, 118735, '\p{Block=:\Aznamennymusicalnotation\z:}', "");;
    Expect(0, 118736, '\p{Block=:\Aznamennymusicalnotation\z:}', "");;
    Expect(1, 118735, '\p{Block:	 -Znamenny_musical_Notation}', "");
    Expect(0, 118735, '\p{^Block:	 -Znamenny_musical_Notation}', "");
    Expect(0, 118735, '\P{Block:	 -Znamenny_musical_Notation}', "");
    Expect(1, 118735, '\P{^Block:	 -Znamenny_musical_Notation}', "");
    Expect(0, 118736, '\p{Block:	 -Znamenny_musical_Notation}', "");
    Expect(1, 118736, '\p{^Block:	 -Znamenny_musical_Notation}', "");
    Expect(1, 118736, '\P{Block:	 -Znamenny_musical_Notation}', "");
    Expect(0, 118736, '\P{^Block:	 -Znamenny_musical_Notation}', "");
    Error('\p{Blk= Znamenny_Music/a/}');
    Error('\P{Blk= Znamenny_Music/a/}');
    Expect(1, 118735, '\p{Blk=:\AZnamenny_Music\z:}', "");;
    Expect(0, 118736, '\p{Blk=:\AZnamenny_Music\z:}', "");;
    Expect(1, 118735, '\p{Blk=znamennymusic}', "");
    Expect(0, 118735, '\p{^Blk=znamennymusic}', "");
    Expect(0, 118735, '\P{Blk=znamennymusic}', "");
    Expect(1, 118735, '\P{^Blk=znamennymusic}', "");
    Expect(0, 118736, '\p{Blk=znamennymusic}', "");
    Expect(1, 118736, '\p{^Blk=znamennymusic}', "");
    Expect(1, 118736, '\P{Blk=znamennymusic}', "");
    Expect(0, 118736, '\P{^Blk=znamennymusic}', "");
    Expect(1, 118735, '\p{Blk=:\Aznamennymusic\z:}', "");;
    Expect(0, 118736, '\p{Blk=:\Aznamennymusic\z:}', "");;
    Expect(1, 118735, '\p{Blk= Znamenny_Music}', "");
    Expect(0, 118735, '\p{^Blk= Znamenny_Music}', "");
    Expect(0, 118735, '\P{Blk= Znamenny_Music}', "");
    Expect(1, 118735, '\P{^Blk= Znamenny_Music}', "");
    Expect(0, 118736, '\p{Blk= Znamenny_Music}', "");
    Expect(1, 118736, '\p{^Blk= Znamenny_Music}', "");
    Expect(1, 118736, '\P{Blk= Znamenny_Music}', "");
    Expect(0, 118736, '\P{^Blk= Znamenny_Music}', "");
    Error('\p{Is_Block=	_Znamenny_Musical_NOTATION:=}');
    Error('\P{Is_Block=	_Znamenny_Musical_NOTATION:=}');
    Expect(1, 118735, '\p{Is_Block=znamennymusicalnotation}', "");
    Expect(0, 118735, '\p{^Is_Block=znamennymusicalnotation}', "");
    Expect(0, 118735, '\P{Is_Block=znamennymusicalnotation}', "");
    Expect(1, 118735, '\P{^Is_Block=znamennymusicalnotation}', "");
    Expect(0, 118736, '\p{Is_Block=znamennymusicalnotation}', "");
    Expect(1, 118736, '\p{^Is_Block=znamennymusicalnotation}', "");
    Expect(1, 118736, '\P{Is_Block=znamennymusicalnotation}', "");
    Expect(0, 118736, '\P{^Is_Block=znamennymusicalnotation}', "");
    Expect(1, 118735, '\p{Is_Block=--znamenny_musical_Notation}', "");
    Expect(0, 118735, '\p{^Is_Block=--znamenny_musical_Notation}', "");
    Expect(0, 118735, '\P{Is_Block=--znamenny_musical_Notation}', "");
    Expect(1, 118735, '\P{^Is_Block=--znamenny_musical_Notation}', "");
    Expect(0, 118736, '\p{Is_Block=--znamenny_musical_Notation}', "");
    Expect(1, 118736, '\p{^Is_Block=--znamenny_musical_Notation}', "");
    Expect(1, 118736, '\P{Is_Block=--znamenny_musical_Notation}', "");
    Expect(0, 118736, '\P{^Is_Block=--znamenny_musical_Notation}', "");
    Error('\p{Is_Blk=_ Znamenny_Music/a/}');
    Error('\P{Is_Blk=_ Znamenny_Music/a/}');
    Expect(1, 118735, '\p{Is_Blk=znamennymusic}', "");
    Expect(0, 118735, '\p{^Is_Blk=znamennymusic}', "");
    Expect(0, 118735, '\P{Is_Blk=znamennymusic}', "");
    Expect(1, 118735, '\P{^Is_Blk=znamennymusic}', "");
    Expect(0, 118736, '\p{Is_Blk=znamennymusic}', "");
    Expect(1, 118736, '\p{^Is_Blk=znamennymusic}', "");
    Expect(1, 118736, '\P{Is_Blk=znamennymusic}', "");
    Expect(0, 118736, '\P{^Is_Blk=znamennymusic}', "");
    Expect(1, 118735, '\p{Is_Blk=	-Znamenny_MUSIC}', "");
    Expect(0, 118735, '\p{^Is_Blk=	-Znamenny_MUSIC}', "");
    Expect(0, 118735, '\P{Is_Blk=	-Znamenny_MUSIC}', "");
    Expect(1, 118735, '\P{^Is_Blk=	-Znamenny_MUSIC}', "");
    Expect(0, 118736, '\p{Is_Blk=	-Znamenny_MUSIC}', "");
    Expect(1, 118736, '\p{^Is_Blk=	-Znamenny_MUSIC}', "");
    Expect(1, 118736, '\P{Is_Blk=	-Znamenny_MUSIC}', "");
    Expect(0, 118736, '\P{^Is_Blk=	-Znamenny_MUSIC}', "");
    Error('\p{bidimirroringglyph}');
    Error('\P{bidimirroringglyph}');
    Error('\p{bmg}');
    Error('\P{bmg}');
    Error('\p{bidipairedbracket}');
    Error('\P{bidipairedbracket}');
    Error('\p{bpb}');
    Error('\P{bpb}');
    Error('\p{bidipairedbrackettype}');
    Error('\P{bidipairedbrackettype}');
    Error('\p{bpt}');
    Error('\P{bpt}');
    Error('\p{Bidi_Paired_Bracket_Type=-:=Close}');
    Error('\P{Bidi_Paired_Bracket_Type=-:=Close}');
    Expect(1, 65379, '\p{Bidi_Paired_Bracket_Type=:\AClose\z:}', "");;
    Expect(0, 65380, '\p{Bidi_Paired_Bracket_Type=:\AClose\z:}', "");;
    Expect(1, 65379, '\p{Bidi_Paired_Bracket_Type:	close}', "");
    Expect(0, 65379, '\p{^Bidi_Paired_Bracket_Type:	close}', "");
    Expect(0, 65379, '\P{Bidi_Paired_Bracket_Type:	close}', "");
    Expect(1, 65379, '\P{^Bidi_Paired_Bracket_Type:	close}', "");
    Expect(0, 65380, '\p{Bidi_Paired_Bracket_Type:	close}', "");
    Expect(1, 65380, '\p{^Bidi_Paired_Bracket_Type:	close}', "");
    Expect(1, 65380, '\P{Bidi_Paired_Bracket_Type:	close}', "");
    Expect(0, 65380, '\P{^Bidi_Paired_Bracket_Type:	close}', "");
    Expect(1, 65379, '\p{Bidi_Paired_Bracket_Type=:\Aclose\z:}', "");;
    Expect(0, 65380, '\p{Bidi_Paired_Bracket_Type=:\Aclose\z:}', "");;
    Expect(1, 65379, '\p{Bidi_Paired_Bracket_Type:   -Close}', "");
    Expect(0, 65379, '\p{^Bidi_Paired_Bracket_Type:   -Close}', "");
    Expect(0, 65379, '\P{Bidi_Paired_Bracket_Type:   -Close}', "");
    Expect(1, 65379, '\P{^Bidi_Paired_Bracket_Type:   -Close}', "");
    Expect(0, 65380, '\p{Bidi_Paired_Bracket_Type:   -Close}', "");
    Expect(1, 65380, '\p{^Bidi_Paired_Bracket_Type:   -Close}', "");
    Expect(1, 65380, '\P{Bidi_Paired_Bracket_Type:   -Close}', "");
    Expect(0, 65380, '\P{^Bidi_Paired_Bracket_Type:   -Close}', "");
    Error('\p{Bpt=-:=c}');
    Error('\P{Bpt=-:=c}');
    Expect(1, 65379, '\p{Bpt=:\AC\z:}', "");;
    Expect(0, 65380, '\p{Bpt=:\AC\z:}', "");;
    Expect(1, 65379, '\p{Bpt=c}', "");
    Expect(0, 65379, '\p{^Bpt=c}', "");
    Expect(0, 65379, '\P{Bpt=c}', "");
    Expect(1, 65379, '\P{^Bpt=c}', "");
    Expect(0, 65380, '\p{Bpt=c}', "");
    Expect(1, 65380, '\p{^Bpt=c}', "");
    Expect(1, 65380, '\P{Bpt=c}', "");
    Expect(0, 65380, '\P{^Bpt=c}', "");
    Expect(1, 65379, '\p{Bpt=:\Ac\z:}', "");;
    Expect(0, 65380, '\p{Bpt=:\Ac\z:}', "");;
    Expect(1, 65379, '\p{Bpt= _C}', "");
    Expect(0, 65379, '\p{^Bpt= _C}', "");
    Expect(0, 65379, '\P{Bpt= _C}', "");
    Expect(1, 65379, '\P{^Bpt= _C}', "");
    Expect(0, 65380, '\p{Bpt= _C}', "");
    Expect(1, 65380, '\p{^Bpt= _C}', "");
    Expect(1, 65380, '\P{Bpt= _C}', "");
    Expect(0, 65380, '\P{^Bpt= _C}', "");
    Error('\p{Is_Bidi_Paired_Bracket_Type=	:=Close}');
    Error('\P{Is_Bidi_Paired_Bracket_Type=	:=Close}');
    Expect(1, 65379, '\p{Is_Bidi_Paired_Bracket_Type:   close}', "");
    Expect(0, 65379, '\p{^Is_Bidi_Paired_Bracket_Type:   close}', "");
    Expect(0, 65379, '\P{Is_Bidi_Paired_Bracket_Type:   close}', "");
    Expect(1, 65379, '\P{^Is_Bidi_Paired_Bracket_Type:   close}', "");
    Expect(0, 65380, '\p{Is_Bidi_Paired_Bracket_Type:   close}', "");
    Expect(1, 65380, '\p{^Is_Bidi_Paired_Bracket_Type:   close}', "");
    Expect(1, 65380, '\P{Is_Bidi_Paired_Bracket_Type:   close}', "");
    Expect(0, 65380, '\P{^Is_Bidi_Paired_Bracket_Type:   close}', "");
    Expect(1, 65379, '\p{Is_Bidi_Paired_Bracket_Type=--close}', "");
    Expect(0, 65379, '\p{^Is_Bidi_Paired_Bracket_Type=--close}', "");
    Expect(0, 65379, '\P{Is_Bidi_Paired_Bracket_Type=--close}', "");
    Expect(1, 65379, '\P{^Is_Bidi_Paired_Bracket_Type=--close}', "");
    Expect(0, 65380, '\p{Is_Bidi_Paired_Bracket_Type=--close}', "");
    Expect(1, 65380, '\p{^Is_Bidi_Paired_Bracket_Type=--close}', "");
    Expect(1, 65380, '\P{Is_Bidi_Paired_Bracket_Type=--close}', "");
    Expect(0, 65380, '\P{^Is_Bidi_Paired_Bracket_Type=--close}', "");
    Error('\p{Is_Bpt=_/a/C}');
    Error('\P{Is_Bpt=_/a/C}');
    Expect(1, 65379, '\p{Is_Bpt:	c}', "");
    Expect(0, 65379, '\p{^Is_Bpt:	c}', "");
    Expect(0, 65379, '\P{Is_Bpt:	c}', "");
    Expect(1, 65379, '\P{^Is_Bpt:	c}', "");
    Expect(0, 65380, '\p{Is_Bpt:	c}', "");
    Expect(1, 65380, '\p{^Is_Bpt:	c}', "");
    Expect(1, 65380, '\P{Is_Bpt:	c}', "");
    Expect(0, 65380, '\P{^Is_Bpt:	c}', "");
    Expect(1, 65379, '\p{Is_Bpt:		C}', "");
    Expect(0, 65379, '\p{^Is_Bpt:		C}', "");
    Expect(0, 65379, '\P{Is_Bpt:		C}', "");
    Expect(1, 65379, '\P{^Is_Bpt:		C}', "");
    Expect(0, 65380, '\p{Is_Bpt:		C}', "");
    Expect(1, 65380, '\p{^Is_Bpt:		C}', "");
    Expect(1, 65380, '\P{Is_Bpt:		C}', "");
    Expect(0, 65380, '\P{^Is_Bpt:		C}', "");
    Error('\p{Bidi_Paired_Bracket_Type= -None/a/}');
    Error('\P{Bidi_Paired_Bracket_Type= -None/a/}');
    Expect(1, 65380, '\p{Bidi_Paired_Bracket_Type=:\ANone\z:}', "");;
    Expect(0, 65379, '\p{Bidi_Paired_Bracket_Type=:\ANone\z:}', "");;
    Expect(1, 65380, '\p{Bidi_Paired_Bracket_Type=none}', "");
    Expect(0, 65380, '\p{^Bidi_Paired_Bracket_Type=none}', "");
    Expect(0, 65380, '\P{Bidi_Paired_Bracket_Type=none}', "");
    Expect(1, 65380, '\P{^Bidi_Paired_Bracket_Type=none}', "");
    Expect(0, 65379, '\p{Bidi_Paired_Bracket_Type=none}', "");
    Expect(1, 65379, '\p{^Bidi_Paired_Bracket_Type=none}', "");
    Expect(1, 65379, '\P{Bidi_Paired_Bracket_Type=none}', "");
    Expect(0, 65379, '\P{^Bidi_Paired_Bracket_Type=none}', "");
    Expect(1, 65380, '\p{Bidi_Paired_Bracket_Type=:\Anone\z:}', "");;
    Expect(0, 65379, '\p{Bidi_Paired_Bracket_Type=:\Anone\z:}', "");;
    Expect(1, 65380, '\p{Bidi_Paired_Bracket_Type= 	None}', "");
    Expect(0, 65380, '\p{^Bidi_Paired_Bracket_Type= 	None}', "");
    Expect(0, 65380, '\P{Bidi_Paired_Bracket_Type= 	None}', "");
    Expect(1, 65380, '\P{^Bidi_Paired_Bracket_Type= 	None}', "");
    Expect(0, 65379, '\p{Bidi_Paired_Bracket_Type= 	None}', "");
    Expect(1, 65379, '\p{^Bidi_Paired_Bracket_Type= 	None}', "");
    Expect(1, 65379, '\P{Bidi_Paired_Bracket_Type= 	None}', "");
    Expect(0, 65379, '\P{^Bidi_Paired_Bracket_Type= 	None}', "");
    Error('\p{Bpt=/a/N}');
    Error('\P{Bpt=/a/N}');
    Expect(1, 65380, '\p{Bpt=:\AN\z:}', "");;
    Expect(0, 65379, '\p{Bpt=:\AN\z:}', "");;
    Expect(1, 65380, '\p{Bpt=n}', "");
    Expect(0, 65380, '\p{^Bpt=n}', "");
    Expect(0, 65380, '\P{Bpt=n}', "");
    Expect(1, 65380, '\P{^Bpt=n}', "");
    Expect(0, 65379, '\p{Bpt=n}', "");
    Expect(1, 65379, '\p{^Bpt=n}', "");
    Expect(1, 65379, '\P{Bpt=n}', "");
    Expect(0, 65379, '\P{^Bpt=n}', "");
    Expect(1, 65380, '\p{Bpt=:\An\z:}', "");;
    Expect(0, 65379, '\p{Bpt=:\An\z:}', "");;
    Expect(1, 65380, '\p{Bpt=	N}', "");
    Expect(0, 65380, '\p{^Bpt=	N}', "");
    Expect(0, 65380, '\P{Bpt=	N}', "");
    Expect(1, 65380, '\P{^Bpt=	N}', "");
    Expect(0, 65379, '\p{Bpt=	N}', "");
    Expect(1, 65379, '\p{^Bpt=	N}', "");
    Expect(1, 65379, '\P{Bpt=	N}', "");
    Expect(0, 65379, '\P{^Bpt=	N}', "");
    Error('\p{Is_Bidi_Paired_Bracket_Type:/a/ none}');
    Error('\P{Is_Bidi_Paired_Bracket_Type:/a/ none}');
    Expect(1, 65380, '\p{Is_Bidi_Paired_Bracket_Type=none}', "");
    Expect(0, 65380, '\p{^Is_Bidi_Paired_Bracket_Type=none}', "");
    Expect(0, 65380, '\P{Is_Bidi_Paired_Bracket_Type=none}', "");
    Expect(1, 65380, '\P{^Is_Bidi_Paired_Bracket_Type=none}', "");
    Expect(0, 65379, '\p{Is_Bidi_Paired_Bracket_Type=none}', "");
    Expect(1, 65379, '\p{^Is_Bidi_Paired_Bracket_Type=none}', "");
    Expect(1, 65379, '\P{Is_Bidi_Paired_Bracket_Type=none}', "");
    Expect(0, 65379, '\P{^Is_Bidi_Paired_Bracket_Type=none}', "");
    Expect(1, 65380, '\p{Is_Bidi_Paired_Bracket_Type=- NONE}', "");
    Expect(0, 65380, '\p{^Is_Bidi_Paired_Bracket_Type=- NONE}', "");
    Expect(0, 65380, '\P{Is_Bidi_Paired_Bracket_Type=- NONE}', "");
    Expect(1, 65380, '\P{^Is_Bidi_Paired_Bracket_Type=- NONE}', "");
    Expect(0, 65379, '\p{Is_Bidi_Paired_Bracket_Type=- NONE}', "");
    Expect(1, 65379, '\p{^Is_Bidi_Paired_Bracket_Type=- NONE}', "");
    Expect(1, 65379, '\P{Is_Bidi_Paired_Bracket_Type=- NONE}', "");
    Expect(0, 65379, '\P{^Is_Bidi_Paired_Bracket_Type=- NONE}', "");
    Error('\p{Is_Bpt=/a/-_N}');
    Error('\P{Is_Bpt=/a/-_N}');
    Expect(1, 65380, '\p{Is_Bpt=n}', "");
    Expect(0, 65380, '\p{^Is_Bpt=n}', "");
    Expect(0, 65380, '\P{Is_Bpt=n}', "");
    Expect(1, 65380, '\P{^Is_Bpt=n}', "");
    Expect(0, 65379, '\p{Is_Bpt=n}', "");
    Expect(1, 65379, '\p{^Is_Bpt=n}', "");
    Expect(1, 65379, '\P{Is_Bpt=n}', "");
    Expect(0, 65379, '\P{^Is_Bpt=n}', "");
    Expect(1, 65380, '\p{Is_Bpt=	N}', "");
    Expect(0, 65380, '\p{^Is_Bpt=	N}', "");
    Expect(0, 65380, '\P{Is_Bpt=	N}', "");
    Expect(1, 65380, '\P{^Is_Bpt=	N}', "");
    Expect(0, 65379, '\p{Is_Bpt=	N}', "");
    Expect(1, 65379, '\p{^Is_Bpt=	N}', "");
    Expect(1, 65379, '\P{Is_Bpt=	N}', "");
    Expect(0, 65379, '\P{^Is_Bpt=	N}', "");
    Error('\p{Bidi_Paired_Bracket_Type=_/a/Open}');
    Error('\P{Bidi_Paired_Bracket_Type=_/a/Open}');
    Expect(1, 65378, '\p{Bidi_Paired_Bracket_Type=:\AOpen\z:}', "");;
    Expect(0, 65379, '\p{Bidi_Paired_Bracket_Type=:\AOpen\z:}', "");;
    Expect(1, 65378, '\p{Bidi_Paired_Bracket_Type=open}', "");
    Expect(0, 65378, '\p{^Bidi_Paired_Bracket_Type=open}', "");
    Expect(0, 65378, '\P{Bidi_Paired_Bracket_Type=open}', "");
    Expect(1, 65378, '\P{^Bidi_Paired_Bracket_Type=open}', "");
    Expect(0, 65379, '\p{Bidi_Paired_Bracket_Type=open}', "");
    Expect(1, 65379, '\p{^Bidi_Paired_Bracket_Type=open}', "");
    Expect(1, 65379, '\P{Bidi_Paired_Bracket_Type=open}', "");
    Expect(0, 65379, '\P{^Bidi_Paired_Bracket_Type=open}', "");
    Expect(1, 65378, '\p{Bidi_Paired_Bracket_Type=:\Aopen\z:}', "");;
    Expect(0, 65379, '\p{Bidi_Paired_Bracket_Type=:\Aopen\z:}', "");;
    Expect(1, 65378, '\p{Bidi_Paired_Bracket_Type:   - Open}', "");
    Expect(0, 65378, '\p{^Bidi_Paired_Bracket_Type:   - Open}', "");
    Expect(0, 65378, '\P{Bidi_Paired_Bracket_Type:   - Open}', "");
    Expect(1, 65378, '\P{^Bidi_Paired_Bracket_Type:   - Open}', "");
    Expect(0, 65379, '\p{Bidi_Paired_Bracket_Type:   - Open}', "");
    Expect(1, 65379, '\p{^Bidi_Paired_Bracket_Type:   - Open}', "");
    Expect(1, 65379, '\P{Bidi_Paired_Bracket_Type:   - Open}', "");
    Expect(0, 65379, '\P{^Bidi_Paired_Bracket_Type:   - Open}', "");
    Error('\p{Bpt=/a/O}');
    Error('\P{Bpt=/a/O}');
    Expect(1, 65378, '\p{Bpt=:\AO\z:}', "");;
    Expect(0, 65379, '\p{Bpt=:\AO\z:}', "");;
    Expect(1, 65378, '\p{Bpt=o}', "");
    Expect(0, 65378, '\p{^Bpt=o}', "");
    Expect(0, 65378, '\P{Bpt=o}', "");
    Expect(1, 65378, '\P{^Bpt=o}', "");
    Expect(0, 65379, '\p{Bpt=o}', "");
    Expect(1, 65379, '\p{^Bpt=o}', "");
    Expect(1, 65379, '\P{Bpt=o}', "");
    Expect(0, 65379, '\P{^Bpt=o}', "");
    Expect(1, 65378, '\p{Bpt=:\Ao\z:}', "");;
    Expect(0, 65379, '\p{Bpt=:\Ao\z:}', "");;
    Expect(1, 65378, '\p{Bpt= -O}', "");
    Expect(0, 65378, '\p{^Bpt= -O}', "");
    Expect(0, 65378, '\P{Bpt= -O}', "");
    Expect(1, 65378, '\P{^Bpt= -O}', "");
    Expect(0, 65379, '\p{Bpt= -O}', "");
    Expect(1, 65379, '\p{^Bpt= -O}', "");
    Expect(1, 65379, '\P{Bpt= -O}', "");
    Expect(0, 65379, '\P{^Bpt= -O}', "");
    Error('\p{Is_Bidi_Paired_Bracket_Type=:=	 Open}');
    Error('\P{Is_Bidi_Paired_Bracket_Type=:=	 Open}');
    Expect(1, 65378, '\p{Is_Bidi_Paired_Bracket_Type: open}', "");
    Expect(0, 65378, '\p{^Is_Bidi_Paired_Bracket_Type: open}', "");
    Expect(0, 65378, '\P{Is_Bidi_Paired_Bracket_Type: open}', "");
    Expect(1, 65378, '\P{^Is_Bidi_Paired_Bracket_Type: open}', "");
    Expect(0, 65379, '\p{Is_Bidi_Paired_Bracket_Type: open}', "");
    Expect(1, 65379, '\p{^Is_Bidi_Paired_Bracket_Type: open}', "");
    Expect(1, 65379, '\P{Is_Bidi_Paired_Bracket_Type: open}', "");
    Expect(0, 65379, '\P{^Is_Bidi_Paired_Bracket_Type: open}', "");
    Expect(1, 65378, '\p{Is_Bidi_Paired_Bracket_Type=-_Open}', "");
    Expect(0, 65378, '\p{^Is_Bidi_Paired_Bracket_Type=-_Open}', "");
    Expect(0, 65378, '\P{Is_Bidi_Paired_Bracket_Type=-_Open}', "");
    Expect(1, 65378, '\P{^Is_Bidi_Paired_Bracket_Type=-_Open}', "");
    Expect(0, 65379, '\p{Is_Bidi_Paired_Bracket_Type=-_Open}', "");
    Expect(1, 65379, '\p{^Is_Bidi_Paired_Bracket_Type=-_Open}', "");
    Expect(1, 65379, '\P{Is_Bidi_Paired_Bracket_Type=-_Open}', "");
    Expect(0, 65379, '\P{^Is_Bidi_Paired_Bracket_Type=-_Open}', "");
    Error('\p{Is_Bpt=:=	-O}');
    Error('\P{Is_Bpt=:=	-O}');
    Expect(1, 65378, '\p{Is_Bpt=o}', "");
    Expect(0, 65378, '\p{^Is_Bpt=o}', "");
    Expect(0, 65378, '\P{Is_Bpt=o}', "");
    Expect(1, 65378, '\P{^Is_Bpt=o}', "");
    Expect(0, 65379, '\p{Is_Bpt=o}', "");
    Expect(1, 65379, '\p{^Is_Bpt=o}', "");
    Expect(1, 65379, '\P{Is_Bpt=o}', "");
    Expect(0, 65379, '\P{^Is_Bpt=o}', "");
    Expect(1, 65378, '\p{Is_Bpt=-	o}', "");
    Expect(0, 65378, '\p{^Is_Bpt=-	o}', "");
    Expect(0, 65378, '\P{Is_Bpt=-	o}', "");
    Expect(1, 65378, '\P{^Is_Bpt=-	o}', "");
    Expect(0, 65379, '\p{Is_Bpt=-	o}', "");
    Expect(1, 65379, '\p{^Is_Bpt=-	o}', "");
    Expect(1, 65379, '\P{Is_Bpt=-	o}', "");
    Expect(0, 65379, '\P{^Is_Bpt=-	o}', "");
    Error('\p{Cased=	/a/No}');
    Error('\P{Cased=	/a/No}');
    Expect(1, 127370, '\p{Cased=:\ANo\z:}', "");;
    Expect(0, 127369, '\p{Cased=:\ANo\z:}', "");;
    Expect(1, 127370, '\p{Cased=no}', "");
    Expect(0, 127370, '\p{^Cased=no}', "");
    Expect(0, 127370, '\P{Cased=no}', "");
    Expect(1, 127370, '\P{^Cased=no}', "");
    Expect(0, 127369, '\p{Cased=no}', "");
    Expect(1, 127369, '\p{^Cased=no}', "");
    Expect(1, 127369, '\P{Cased=no}', "");
    Expect(0, 127369, '\P{^Cased=no}', "");
    Expect(1, 127370, '\p{Cased=:\Ano\z:}', "");;
    Expect(0, 127369, '\p{Cased=:\Ano\z:}', "");;
    Expect(1, 127370, '\p{Cased=		no}', "");
    Expect(0, 127370, '\p{^Cased=		no}', "");
    Expect(0, 127370, '\P{Cased=		no}', "");
    Expect(1, 127370, '\P{^Cased=		no}', "");
    Expect(0, 127369, '\p{Cased=		no}', "");
    Expect(1, 127369, '\p{^Cased=		no}', "");
    Expect(1, 127369, '\P{Cased=		no}', "");
    Expect(0, 127369, '\P{^Cased=		no}', "");
    Error('\p{Is_Cased=_	n:=}');
    Error('\P{Is_Cased=_	n:=}');
    Expect(1, 127370, '\p{Is_Cased=n}', "");
    Expect(0, 127370, '\p{^Is_Cased=n}', "");
    Expect(0, 127370, '\P{Is_Cased=n}', "");
    Expect(1, 127370, '\P{^Is_Cased=n}', "");
    Expect(0, 127369, '\p{Is_Cased=n}', "");
    Expect(1, 127369, '\p{^Is_Cased=n}', "");
    Expect(1, 127369, '\P{Is_Cased=n}', "");
    Expect(0, 127369, '\P{^Is_Cased=n}', "");
    Expect(1, 127370, '\p{Is_Cased:	 N}', "");
    Expect(0, 127370, '\p{^Is_Cased:	 N}', "");
    Expect(0, 127370, '\P{Is_Cased:	 N}', "");
    Expect(1, 127370, '\P{^Is_Cased:	 N}', "");
    Expect(0, 127369, '\p{Is_Cased:	 N}', "");
    Expect(1, 127369, '\p{^Is_Cased:	 N}', "");
    Expect(1, 127369, '\P{Is_Cased:	 N}', "");
    Expect(0, 127369, '\P{^Is_Cased:	 N}', "");
    Error('\p{Cased=__f:=}');
    Error('\P{Cased=__f:=}');
    Expect(1, 127370, '\p{Cased=:\AF\z:}', "");;
    Expect(0, 127369, '\p{Cased=:\AF\z:}', "");;
    Expect(1, 127370, '\p{Cased=f}', "");
    Expect(0, 127370, '\p{^Cased=f}', "");
    Expect(0, 127370, '\P{Cased=f}', "");
    Expect(1, 127370, '\P{^Cased=f}', "");
    Expect(0, 127369, '\p{Cased=f}', "");
    Expect(1, 127369, '\p{^Cased=f}', "");
    Expect(1, 127369, '\P{Cased=f}', "");
    Expect(0, 127369, '\P{^Cased=f}', "");
    Expect(1, 127370, '\p{Cased=:\Af\z:}', "");;
    Expect(0, 127369, '\p{Cased=:\Af\z:}', "");;
    Expect(1, 127370, '\p{Cased=__f}', "");
    Expect(0, 127370, '\p{^Cased=__f}', "");
    Expect(0, 127370, '\P{Cased=__f}', "");
    Expect(1, 127370, '\P{^Cased=__f}', "");
    Expect(0, 127369, '\p{Cased=__f}', "");
    Expect(1, 127369, '\p{^Cased=__f}', "");
    Expect(1, 127369, '\P{Cased=__f}', "");
    Expect(0, 127369, '\P{^Cased=__f}', "");
    Error('\p{Is_Cased:  false/a/}');
    Error('\P{Is_Cased:  false/a/}');
    Expect(1, 127370, '\p{Is_Cased=false}', "");
    Expect(0, 127370, '\p{^Is_Cased=false}', "");
    Expect(0, 127370, '\P{Is_Cased=false}', "");
    Expect(1, 127370, '\P{^Is_Cased=false}', "");
    Expect(0, 127369, '\p{Is_Cased=false}', "");
    Expect(1, 127369, '\p{^Is_Cased=false}', "");
    Expect(1, 127369, '\P{Is_Cased=false}', "");
    Expect(0, 127369, '\P{^Is_Cased=false}', "");
    Expect(1, 127370, '\p{Is_Cased=		False}', "");
    Expect(0, 127370, '\p{^Is_Cased=		False}', "");
    Expect(0, 127370, '\P{Is_Cased=		False}', "");
    Expect(1, 127370, '\P{^Is_Cased=		False}', "");
    Expect(0, 127369, '\p{Is_Cased=		False}', "");
    Expect(1, 127369, '\p{^Is_Cased=		False}', "");
    Expect(1, 127369, '\P{Is_Cased=		False}', "");
    Expect(0, 127369, '\P{^Is_Cased=		False}', "");
    Error('\p{Cased= :=Yes}');
    Error('\P{Cased= :=Yes}');
    Expect(1, 127369, '\p{Cased=:\AYes\z:}', "");;
    Expect(0, 127370, '\p{Cased=:\AYes\z:}', "");;
    Expect(1, 127369, '\p{Cased=yes}', "");
    Expect(0, 127369, '\p{^Cased=yes}', "");
    Expect(0, 127369, '\P{Cased=yes}', "");
    Expect(1, 127369, '\P{^Cased=yes}', "");
    Expect(0, 127370, '\p{Cased=yes}', "");
    Expect(1, 127370, '\p{^Cased=yes}', "");
    Expect(1, 127370, '\P{Cased=yes}', "");
    Expect(0, 127370, '\P{^Cased=yes}', "");
    Expect(1, 127369, '\p{Cased=:\Ayes\z:}', "");;
    Expect(0, 127370, '\p{Cased=:\Ayes\z:}', "");;
    Expect(1, 127369, '\p{Cased=_Yes}', "");
    Expect(0, 127369, '\p{^Cased=_Yes}', "");
    Expect(0, 127369, '\P{Cased=_Yes}', "");
    Expect(1, 127369, '\P{^Cased=_Yes}', "");
    Expect(0, 127370, '\p{Cased=_Yes}', "");
    Expect(1, 127370, '\p{^Cased=_Yes}', "");
    Expect(1, 127370, '\P{Cased=_Yes}', "");
    Expect(0, 127370, '\P{^Cased=_Yes}', "");
    Error('\p{Is_Cased= Y:=}');
    Error('\P{Is_Cased= Y:=}');
    Expect(1, 127369, '\p{Is_Cased=y}', "");
    Expect(0, 127369, '\p{^Is_Cased=y}', "");
    Expect(0, 127369, '\P{Is_Cased=y}', "");
    Expect(1, 127369, '\P{^Is_Cased=y}', "");
    Expect(0, 127370, '\p{Is_Cased=y}', "");
    Expect(1, 127370, '\p{^Is_Cased=y}', "");
    Expect(1, 127370, '\P{Is_Cased=y}', "");
    Expect(0, 127370, '\P{^Is_Cased=y}', "");
    Expect(1, 127369, '\p{Is_Cased=		Y}', "");
    Expect(0, 127369, '\p{^Is_Cased=		Y}', "");
    Expect(0, 127369, '\P{Is_Cased=		Y}', "");
    Expect(1, 127369, '\P{^Is_Cased=		Y}', "");
    Expect(0, 127370, '\p{Is_Cased=		Y}', "");
    Expect(1, 127370, '\p{^Is_Cased=		Y}', "");
    Expect(1, 127370, '\P{Is_Cased=		Y}', "");
    Expect(0, 127370, '\P{^Is_Cased=		Y}', "");
    Error('\p{Cased=_	t:=}');
    Error('\P{Cased=_	t:=}');
    Expect(1, 127369, '\p{Cased=:\AT\z:}', "");;
    Expect(0, 127370, '\p{Cased=:\AT\z:}', "");;
    Expect(1, 127369, '\p{Cased=t}', "");
    Expect(0, 127369, '\p{^Cased=t}', "");
    Expect(0, 127369, '\P{Cased=t}', "");
    Expect(1, 127369, '\P{^Cased=t}', "");
    Expect(0, 127370, '\p{Cased=t}', "");
    Expect(1, 127370, '\p{^Cased=t}', "");
    Expect(1, 127370, '\P{Cased=t}', "");
    Expect(0, 127370, '\P{^Cased=t}', "");
    Expect(1, 127369, '\p{Cased=:\At\z:}', "");;
    Expect(0, 127370, '\p{Cased=:\At\z:}', "");;
    Expect(1, 127369, '\p{Cased:    	T}', "");
    Expect(0, 127369, '\p{^Cased:    	T}', "");
    Expect(0, 127369, '\P{Cased:    	T}', "");
    Expect(1, 127369, '\P{^Cased:    	T}', "");
    Expect(0, 127370, '\p{Cased:    	T}', "");
    Expect(1, 127370, '\p{^Cased:    	T}', "");
    Expect(1, 127370, '\P{Cased:    	T}', "");
    Expect(0, 127370, '\P{^Cased:    	T}', "");
    Error('\p{Is_Cased=	-TRUE/a/}');
    Error('\P{Is_Cased=	-TRUE/a/}');
    Expect(1, 127369, '\p{Is_Cased=true}', "");
    Expect(0, 127369, '\p{^Is_Cased=true}', "");
    Expect(0, 127369, '\P{Is_Cased=true}', "");
    Expect(1, 127369, '\P{^Is_Cased=true}', "");
    Expect(0, 127370, '\p{Is_Cased=true}', "");
    Expect(1, 127370, '\p{^Is_Cased=true}', "");
    Expect(1, 127370, '\P{Is_Cased=true}', "");
    Expect(0, 127370, '\P{^Is_Cased=true}', "");
    Expect(1, 127369, '\p{Is_Cased=-_TRUE}', "");
    Expect(0, 127369, '\p{^Is_Cased=-_TRUE}', "");
    Expect(0, 127369, '\P{Is_Cased=-_TRUE}', "");
    Expect(1, 127369, '\P{^Is_Cased=-_TRUE}', "");
    Expect(0, 127370, '\p{Is_Cased=-_TRUE}', "");
    Expect(1, 127370, '\p{^Is_Cased=-_TRUE}', "");
    Expect(1, 127370, '\P{Is_Cased=-_TRUE}', "");
    Expect(0, 127370, '\P{^Is_Cased=-_TRUE}', "");
    Error('\p{canonicalcombiningclass}');
    Error('\P{canonicalcombiningclass}');
    Error('\p{ccc}');
    Error('\P{ccc}');
    Error('\p{Canonical_Combining_Class=/a/ -ABOVE}');
    Error('\P{Canonical_Combining_Class=/a/ -ABOVE}');
    Expect(1, 125257, '\p{Canonical_Combining_Class=:\AAbove\z:}', "");;
    Expect(0, 125258, '\p{Canonical_Combining_Class=:\AAbove\z:}', "");;
    Expect(1, 125257, '\p{Canonical_Combining_Class:above}', "");
    Expect(0, 125257, '\p{^Canonical_Combining_Class:above}', "");
    Expect(0, 125257, '\P{Canonical_Combining_Class:above}', "");
    Expect(1, 125257, '\P{^Canonical_Combining_Class:above}', "");
    Expect(0, 125258, '\p{Canonical_Combining_Class:above}', "");
    Expect(1, 125258, '\p{^Canonical_Combining_Class:above}', "");
    Expect(1, 125258, '\P{Canonical_Combining_Class:above}', "");
    Expect(0, 125258, '\P{^Canonical_Combining_Class:above}', "");
    Expect(1, 125257, '\p{Canonical_Combining_Class=:\Aabove\z:}', "");;
    Expect(0, 125258, '\p{Canonical_Combining_Class=:\Aabove\z:}', "");;
    Expect(1, 125257, '\p{Canonical_Combining_Class=_above}', "");
    Expect(0, 125257, '\p{^Canonical_Combining_Class=_above}', "");
    Expect(0, 125257, '\P{Canonical_Combining_Class=_above}', "");
    Expect(1, 125257, '\P{^Canonical_Combining_Class=_above}', "");
    Expect(0, 125258, '\p{Canonical_Combining_Class=_above}', "");
    Expect(1, 125258, '\p{^Canonical_Combining_Class=_above}', "");
    Expect(1, 125258, '\P{Canonical_Combining_Class=_above}', "");
    Expect(0, 125258, '\P{^Canonical_Combining_Class=_above}', "");
    Error('\p{Ccc=/a/A}');
    Error('\P{Ccc=/a/A}');
    Expect(1, 125257, '\p{Ccc=:\AA\z:}', "");;
    Expect(0, 125258, '\p{Ccc=:\AA\z:}', "");;
    Expect(1, 125257, '\p{Ccc:   a}', "");
    Expect(0, 125257, '\p{^Ccc:   a}', "");
    Expect(0, 125257, '\P{Ccc:   a}', "");
    Expect(1, 125257, '\P{^Ccc:   a}', "");
    Expect(0, 125258, '\p{Ccc:   a}', "");
    Expect(1, 125258, '\p{^Ccc:   a}', "");
    Expect(1, 125258, '\P{Ccc:   a}', "");
    Expect(0, 125258, '\P{^Ccc:   a}', "");
    Expect(1, 125257, '\p{Ccc=:\Aa\z:}', "");;
    Expect(0, 125258, '\p{Ccc=:\Aa\z:}', "");;
    Expect(1, 125257, '\p{Ccc=	A}', "");
    Expect(0, 125257, '\p{^Ccc=	A}', "");
    Expect(0, 125257, '\P{Ccc=	A}', "");
    Expect(1, 125257, '\P{^Ccc=	A}', "");
    Expect(0, 125258, '\p{Ccc=	A}', "");
    Expect(1, 125258, '\p{^Ccc=	A}', "");
    Expect(1, 125258, '\P{Ccc=	A}', "");
    Expect(0, 125258, '\P{^Ccc=	A}', "");
    Error('\p{Is_Canonical_Combining_Class=:=	-00000000230}');
    Error('\P{Is_Canonical_Combining_Class=:=	-00000000230}');
    Expect(1, 125257, '\p{Is_Canonical_Combining_Class=+0230}', "");
    Expect(0, 125257, '\p{^Is_Canonical_Combining_Class=+0230}', "");
    Expect(0, 125257, '\P{Is_Canonical_Combining_Class=+0230}', "");
    Expect(1, 125257, '\P{^Is_Canonical_Combining_Class=+0230}', "");
    Expect(0, 125258, '\p{Is_Canonical_Combining_Class=+0230}', "");
    Expect(1, 125258, '\p{^Is_Canonical_Combining_Class=+0230}', "");
    Expect(1, 125258, '\P{Is_Canonical_Combining_Class=+0230}', "");
    Expect(0, 125258, '\P{^Is_Canonical_Combining_Class=+0230}', "");
    Error('\p{Is_Ccc=:=-	Above}');
    Error('\P{Is_Ccc=:=-	Above}');
    Expect(1, 125257, '\p{Is_Ccc=above}', "");
    Expect(0, 125257, '\p{^Is_Ccc=above}', "");
    Expect(0, 125257, '\P{Is_Ccc=above}', "");
    Expect(1, 125257, '\P{^Is_Ccc=above}', "");
    Expect(0, 125258, '\p{Is_Ccc=above}', "");
    Expect(1, 125258, '\p{^Is_Ccc=above}', "");
    Expect(1, 125258, '\P{Is_Ccc=above}', "");
    Expect(0, 125258, '\P{^Is_Ccc=above}', "");
    Expect(1, 125257, '\p{Is_Ccc= Above}', "");
    Expect(0, 125257, '\p{^Is_Ccc= Above}', "");
    Expect(0, 125257, '\P{Is_Ccc= Above}', "");
    Expect(1, 125257, '\P{^Is_Ccc= Above}', "");
    Expect(0, 125258, '\p{Is_Ccc= Above}', "");
    Expect(1, 125258, '\p{^Is_Ccc= Above}', "");
    Expect(1, 125258, '\P{Is_Ccc= Above}', "");
    Expect(0, 125258, '\P{^Is_Ccc= Above}', "");
    Error('\p{Canonical_Combining_Class=:= 	Above_left}');
    Error('\P{Canonical_Combining_Class=:= 	Above_left}');
    Expect(1, 12331, '\p{Canonical_Combining_Class=:\AAbove_Left\z:}', "");;
    Expect(0, 12332, '\p{Canonical_Combining_Class=:\AAbove_Left\z:}', "");;
    Expect(1, 12331, '\p{Canonical_Combining_Class=aboveleft}', "");
    Expect(0, 12331, '\p{^Canonical_Combining_Class=aboveleft}', "");
    Expect(0, 12331, '\P{Canonical_Combining_Class=aboveleft}', "");
    Expect(1, 12331, '\P{^Canonical_Combining_Class=aboveleft}', "");
    Expect(0, 12332, '\p{Canonical_Combining_Class=aboveleft}', "");
    Expect(1, 12332, '\p{^Canonical_Combining_Class=aboveleft}', "");
    Expect(1, 12332, '\P{Canonical_Combining_Class=aboveleft}', "");
    Expect(0, 12332, '\P{^Canonical_Combining_Class=aboveleft}', "");
    Expect(1, 12331, '\p{Canonical_Combining_Class=:\Aaboveleft\z:}', "");;
    Expect(0, 12332, '\p{Canonical_Combining_Class=:\Aaboveleft\z:}', "");;
    Expect(1, 12331, '\p{Canonical_Combining_Class:	_-ABOVE_Left}', "");
    Expect(0, 12331, '\p{^Canonical_Combining_Class:	_-ABOVE_Left}', "");
    Expect(0, 12331, '\P{Canonical_Combining_Class:	_-ABOVE_Left}', "");
    Expect(1, 12331, '\P{^Canonical_Combining_Class:	_-ABOVE_Left}', "");
    Expect(0, 12332, '\p{Canonical_Combining_Class:	_-ABOVE_Left}', "");
    Expect(1, 12332, '\p{^Canonical_Combining_Class:	_-ABOVE_Left}', "");
    Expect(1, 12332, '\P{Canonical_Combining_Class:	_-ABOVE_Left}', "");
    Expect(0, 12332, '\P{^Canonical_Combining_Class:	_-ABOVE_Left}', "");
    Error('\p{Ccc=/a/-AL}');
    Error('\P{Ccc=/a/-AL}');
    Expect(1, 12331, '\p{Ccc=:\AAL\z:}', "");;
    Expect(0, 12332, '\p{Ccc=:\AAL\z:}', "");;
    Expect(1, 12331, '\p{Ccc=al}', "");
    Expect(0, 12331, '\p{^Ccc=al}', "");
    Expect(0, 12331, '\P{Ccc=al}', "");
    Expect(1, 12331, '\P{^Ccc=al}', "");
    Expect(0, 12332, '\p{Ccc=al}', "");
    Expect(1, 12332, '\p{^Ccc=al}', "");
    Expect(1, 12332, '\P{Ccc=al}', "");
    Expect(0, 12332, '\P{^Ccc=al}', "");
    Expect(1, 12331, '\p{Ccc=:\Aal\z:}', "");;
    Expect(0, 12332, '\p{Ccc=:\Aal\z:}', "");;
    Expect(1, 12331, '\p{Ccc=		al}', "");
    Expect(0, 12331, '\p{^Ccc=		al}', "");
    Expect(0, 12331, '\P{Ccc=		al}', "");
    Expect(1, 12331, '\P{^Ccc=		al}', "");
    Expect(0, 12332, '\p{Ccc=		al}', "");
    Expect(1, 12332, '\p{^Ccc=		al}', "");
    Expect(1, 12332, '\P{Ccc=		al}', "");
    Expect(0, 12332, '\P{^Ccc=		al}', "");
    Error('\p{Is_Canonical_Combining_Class=:=-	+0000000228}');
    Error('\P{Is_Canonical_Combining_Class=:=-	+0000000228}');
    Expect(1, 12331, '\p{Is_Canonical_Combining_Class:	+0_0_0_0_0_0_0_2_28}', "");
    Expect(0, 12331, '\p{^Is_Canonical_Combining_Class:	+0_0_0_0_0_0_0_2_28}', "");
    Expect(0, 12331, '\P{Is_Canonical_Combining_Class:	+0_0_0_0_0_0_0_2_28}', "");
    Expect(1, 12331, '\P{^Is_Canonical_Combining_Class:	+0_0_0_0_0_0_0_2_28}', "");
    Expect(0, 12332, '\p{Is_Canonical_Combining_Class:	+0_0_0_0_0_0_0_2_28}', "");
    Expect(1, 12332, '\p{^Is_Canonical_Combining_Class:	+0_0_0_0_0_0_0_2_28}', "");
    Expect(1, 12332, '\P{Is_Canonical_Combining_Class:	+0_0_0_0_0_0_0_2_28}', "");
    Expect(0, 12332, '\P{^Is_Canonical_Combining_Class:	+0_0_0_0_0_0_0_2_28}', "");
    Error('\p{Is_Ccc=/a/	Above_Left}');
    Error('\P{Is_Ccc=/a/	Above_Left}');
    Expect(1, 12331, '\p{Is_Ccc:	aboveleft}', "");
    Expect(0, 12331, '\p{^Is_Ccc:	aboveleft}', "");
    Expect(0, 12331, '\P{Is_Ccc:	aboveleft}', "");
    Expect(1, 12331, '\P{^Is_Ccc:	aboveleft}', "");
    Expect(0, 12332, '\p{Is_Ccc:	aboveleft}', "");
    Expect(1, 12332, '\p{^Is_Ccc:	aboveleft}', "");
    Expect(1, 12332, '\P{Is_Ccc:	aboveleft}', "");
    Expect(0, 12332, '\P{^Is_Ccc:	aboveleft}', "");
    Expect(1, 12331, '\p{Is_Ccc=_	above_LEFT}', "");
    Expect(0, 12331, '\p{^Is_Ccc=_	above_LEFT}', "");
    Expect(0, 12331, '\P{Is_Ccc=_	above_LEFT}', "");
    Expect(1, 12331, '\P{^Is_Ccc=_	above_LEFT}', "");
    Expect(0, 12332, '\p{Is_Ccc=_	above_LEFT}', "");
    Expect(1, 12332, '\p{^Is_Ccc=_	above_LEFT}', "");
    Expect(1, 12332, '\P{Is_Ccc=_	above_LEFT}', "");
    Expect(0, 12332, '\P{^Is_Ccc=_	above_LEFT}', "");
    Error('\p{Canonical_Combining_Class=_ Above_Right:=}');
    Error('\P{Canonical_Combining_Class=_ Above_Right:=}');
    Expect(1, 124141, '\p{Canonical_Combining_Class=:\AAbove_Right\z:}', "");;
    Expect(0, 124142, '\p{Canonical_Combining_Class=:\AAbove_Right\z:}', "");;
    Expect(1, 124141, '\p{Canonical_Combining_Class=aboveright}', "");
    Expect(0, 124141, '\p{^Canonical_Combining_Class=aboveright}', "");
    Expect(0, 124141, '\P{Canonical_Combining_Class=aboveright}', "");
    Expect(1, 124141, '\P{^Canonical_Combining_Class=aboveright}', "");
    Expect(0, 124142, '\p{Canonical_Combining_Class=aboveright}', "");
    Expect(1, 124142, '\p{^Canonical_Combining_Class=aboveright}', "");
    Expect(1, 124142, '\P{Canonical_Combining_Class=aboveright}', "");
    Expect(0, 124142, '\P{^Canonical_Combining_Class=aboveright}', "");
    Expect(1, 124141, '\p{Canonical_Combining_Class=:\Aaboveright\z:}', "");;
    Expect(0, 124142, '\p{Canonical_Combining_Class=:\Aaboveright\z:}', "");;
    Expect(1, 124141, '\p{Canonical_Combining_Class=-	ABOVE_Right}', "");
    Expect(0, 124141, '\p{^Canonical_Combining_Class=-	ABOVE_Right}', "");
    Expect(0, 124141, '\P{Canonical_Combining_Class=-	ABOVE_Right}', "");
    Expect(1, 124141, '\P{^Canonical_Combining_Class=-	ABOVE_Right}', "");
    Expect(0, 124142, '\p{Canonical_Combining_Class=-	ABOVE_Right}', "");
    Expect(1, 124142, '\p{^Canonical_Combining_Class=-	ABOVE_Right}', "");
    Expect(1, 124142, '\P{Canonical_Combining_Class=-	ABOVE_Right}', "");
    Expect(0, 124142, '\P{^Canonical_Combining_Class=-	ABOVE_Right}', "");
    Error('\p{Ccc:	:=AR}');
    Error('\P{Ccc:	:=AR}');
    Expect(1, 124141, '\p{Ccc=:\AAR\z:}', "");;
    Expect(0, 124142, '\p{Ccc=:\AAR\z:}', "");;
    Expect(1, 124141, '\p{Ccc=ar}', "");
    Expect(0, 124141, '\p{^Ccc=ar}', "");
    Expect(0, 124141, '\P{Ccc=ar}', "");
    Expect(1, 124141, '\P{^Ccc=ar}', "");
    Expect(0, 124142, '\p{Ccc=ar}', "");
    Expect(1, 124142, '\p{^Ccc=ar}', "");
    Expect(1, 124142, '\P{Ccc=ar}', "");
    Expect(0, 124142, '\P{^Ccc=ar}', "");
    Expect(1, 124141, '\p{Ccc=:\Aar\z:}', "");;
    Expect(0, 124142, '\p{Ccc=:\Aar\z:}', "");;
    Expect(1, 124141, '\p{Ccc=	_AR}', "");
    Expect(0, 124141, '\p{^Ccc=	_AR}', "");
    Expect(0, 124141, '\P{Ccc=	_AR}', "");
    Expect(1, 124141, '\P{^Ccc=	_AR}', "");
    Expect(0, 124142, '\p{Ccc=	_AR}', "");
    Expect(1, 124142, '\p{^Ccc=	_AR}', "");
    Expect(1, 124142, '\P{Ccc=	_AR}', "");
    Expect(0, 124142, '\P{^Ccc=	_AR}', "");
    Error('\p{Is_Canonical_Combining_Class: 	+0_0_0_0_0_0_000232:=}');
    Error('\P{Is_Canonical_Combining_Class: 	+0_0_0_0_0_0_000232:=}');
    Expect(1, 124141, '\p{Is_Canonical_Combining_Class=00000_00023_2}', "");
    Expect(0, 124141, '\p{^Is_Canonical_Combining_Class=00000_00023_2}', "");
    Expect(0, 124141, '\P{Is_Canonical_Combining_Class=00000_00023_2}', "");
    Expect(1, 124141, '\P{^Is_Canonical_Combining_Class=00000_00023_2}', "");
    Expect(0, 124142, '\p{Is_Canonical_Combining_Class=00000_00023_2}', "");
    Expect(1, 124142, '\p{^Is_Canonical_Combining_Class=00000_00023_2}', "");
    Expect(1, 124142, '\P{Is_Canonical_Combining_Class=00000_00023_2}', "");
    Expect(0, 124142, '\P{^Is_Canonical_Combining_Class=00000_00023_2}', "");
    Error('\p{Is_Ccc=:=	Above_right}');
    Error('\P{Is_Ccc=:=	Above_right}');
    Expect(1, 124141, '\p{Is_Ccc=aboveright}', "");
    Expect(0, 124141, '\p{^Is_Ccc=aboveright}', "");
    Expect(0, 124141, '\P{Is_Ccc=aboveright}', "");
    Expect(1, 124141, '\P{^Is_Ccc=aboveright}', "");
    Expect(0, 124142, '\p{Is_Ccc=aboveright}', "");
    Expect(1, 124142, '\p{^Is_Ccc=aboveright}', "");
    Expect(1, 124142, '\P{Is_Ccc=aboveright}', "");
    Expect(0, 124142, '\P{^Is_Ccc=aboveright}', "");
    Expect(1, 124141, '\p{Is_Ccc=	_Above_Right}', "");
    Expect(0, 124141, '\p{^Is_Ccc=	_Above_Right}', "");
    Expect(0, 124141, '\P{Is_Ccc=	_Above_Right}', "");
    Expect(1, 124141, '\P{^Is_Ccc=	_Above_Right}', "");
    Expect(0, 124142, '\p{Is_Ccc=	_Above_Right}', "");
    Expect(1, 124142, '\p{^Is_Ccc=	_Above_Right}', "");
    Expect(1, 124142, '\P{Is_Ccc=	_Above_Right}', "");
    Expect(0, 124142, '\P{^Is_Ccc=	_Above_Right}', "");
    Error('\p{Canonical_Combining_Class=/a/Attached_ABOVE}');
    Error('\P{Canonical_Combining_Class=/a/Attached_ABOVE}');
    Expect(1, 7630, '\p{Canonical_Combining_Class=:\AAttached_Above\z:}', "");;
    Expect(0, 7631, '\p{Canonical_Combining_Class=:\AAttached_Above\z:}', "");;
    Expect(1, 7630, '\p{Canonical_Combining_Class=attachedabove}', "");
    Expect(0, 7630, '\p{^Canonical_Combining_Class=attachedabove}', "");
    Expect(0, 7630, '\P{Canonical_Combining_Class=attachedabove}', "");
    Expect(1, 7630, '\P{^Canonical_Combining_Class=attachedabove}', "");
    Expect(0, 7631, '\p{Canonical_Combining_Class=attachedabove}', "");
    Expect(1, 7631, '\p{^Canonical_Combining_Class=attachedabove}', "");
    Expect(1, 7631, '\P{Canonical_Combining_Class=attachedabove}', "");
    Expect(0, 7631, '\P{^Canonical_Combining_Class=attachedabove}', "");
    Expect(1, 7630, '\p{Canonical_Combining_Class=:\Aattachedabove\z:}', "");;
    Expect(0, 7631, '\p{Canonical_Combining_Class=:\Aattachedabove\z:}', "");;
    Expect(1, 7630, '\p{Canonical_Combining_Class=_-attached_above}', "");
    Expect(0, 7630, '\p{^Canonical_Combining_Class=_-attached_above}', "");
    Expect(0, 7630, '\P{Canonical_Combining_Class=_-attached_above}', "");
    Expect(1, 7630, '\P{^Canonical_Combining_Class=_-attached_above}', "");
    Expect(0, 7631, '\p{Canonical_Combining_Class=_-attached_above}', "");
    Expect(1, 7631, '\p{^Canonical_Combining_Class=_-attached_above}', "");
    Expect(1, 7631, '\P{Canonical_Combining_Class=_-attached_above}', "");
    Expect(0, 7631, '\P{^Canonical_Combining_Class=_-attached_above}', "");
    Error('\p{Ccc=/a/_ATA}');
    Error('\P{Ccc=/a/_ATA}');
    Expect(1, 7630, '\p{Ccc=:\AATA\z:}', "");;
    Expect(0, 7631, '\p{Ccc=:\AATA\z:}', "");;
    Expect(1, 7630, '\p{Ccc=ata}', "");
    Expect(0, 7630, '\p{^Ccc=ata}', "");
    Expect(0, 7630, '\P{Ccc=ata}', "");
    Expect(1, 7630, '\P{^Ccc=ata}', "");
    Expect(0, 7631, '\p{Ccc=ata}', "");
    Expect(1, 7631, '\p{^Ccc=ata}', "");
    Expect(1, 7631, '\P{Ccc=ata}', "");
    Expect(0, 7631, '\P{^Ccc=ata}', "");
    Expect(1, 7630, '\p{Ccc=:\Aata\z:}', "");;
    Expect(0, 7631, '\p{Ccc=:\Aata\z:}', "");;
    Expect(1, 7630, '\p{Ccc=__ATA}', "");
    Expect(0, 7630, '\p{^Ccc=__ATA}', "");
    Expect(0, 7630, '\P{Ccc=__ATA}', "");
    Expect(1, 7630, '\P{^Ccc=__ATA}', "");
    Expect(0, 7631, '\p{Ccc=__ATA}', "");
    Expect(1, 7631, '\p{^Ccc=__ATA}', "");
    Expect(1, 7631, '\P{Ccc=__ATA}', "");
    Expect(0, 7631, '\P{^Ccc=__ATA}', "");
    Error('\p{Is_Canonical_Combining_Class:   _ +00_00_00_00_0214/a/}');
    Error('\P{Is_Canonical_Combining_Class:   _ +00_00_00_00_0214/a/}');
    Expect(1, 7630, '\p{Is_Canonical_Combining_Class: 00214}', "");
    Expect(0, 7630, '\p{^Is_Canonical_Combining_Class: 00214}', "");
    Expect(0, 7630, '\P{Is_Canonical_Combining_Class: 00214}', "");
    Expect(1, 7630, '\P{^Is_Canonical_Combining_Class: 00214}', "");
    Expect(0, 7631, '\p{Is_Canonical_Combining_Class: 00214}', "");
    Expect(1, 7631, '\p{^Is_Canonical_Combining_Class: 00214}', "");
    Expect(1, 7631, '\P{Is_Canonical_Combining_Class: 00214}', "");
    Expect(0, 7631, '\P{^Is_Canonical_Combining_Class: 00214}', "");
    Error('\p{Is_Ccc=_:=Attached_above}');
    Error('\P{Is_Ccc=_:=Attached_above}');
    Expect(1, 7630, '\p{Is_Ccc=attachedabove}', "");
    Expect(0, 7630, '\p{^Is_Ccc=attachedabove}', "");
    Expect(0, 7630, '\P{Is_Ccc=attachedabove}', "");
    Expect(1, 7630, '\P{^Is_Ccc=attachedabove}', "");
    Expect(0, 7631, '\p{Is_Ccc=attachedabove}', "");
    Expect(1, 7631, '\p{^Is_Ccc=attachedabove}', "");
    Expect(1, 7631, '\P{Is_Ccc=attachedabove}', "");
    Expect(0, 7631, '\P{^Is_Ccc=attachedabove}', "");
    Expect(1, 7630, '\p{Is_Ccc=-Attached_Above}', "");
    Expect(0, 7630, '\p{^Is_Ccc=-Attached_Above}', "");
    Expect(0, 7630, '\P{Is_Ccc=-Attached_Above}', "");
    Expect(1, 7630, '\P{^Is_Ccc=-Attached_Above}', "");
    Expect(0, 7631, '\p{Is_Ccc=-Attached_Above}', "");
    Expect(1, 7631, '\p{^Is_Ccc=-Attached_Above}', "");
    Expect(1, 7631, '\P{Is_Ccc=-Attached_Above}', "");
    Expect(0, 7631, '\P{^Is_Ccc=-Attached_Above}', "");
    Error('\p{Canonical_Combining_Class: /a/-	ATTACHED_ABOVE_Right}');
    Error('\P{Canonical_Combining_Class: /a/-	ATTACHED_ABOVE_Right}');
    Expect(1, 119154, '\p{Canonical_Combining_Class=:\AAttached_Above_Right\z:}', "");;
    Expect(0, 119155, '\p{Canonical_Combining_Class=:\AAttached_Above_Right\z:}', "");;
    Expect(1, 119154, '\p{Canonical_Combining_Class=attachedaboveright}', "");
    Expect(0, 119154, '\p{^Canonical_Combining_Class=attachedaboveright}', "");
    Expect(0, 119154, '\P{Canonical_Combining_Class=attachedaboveright}', "");
    Expect(1, 119154, '\P{^Canonical_Combining_Class=attachedaboveright}', "");
    Expect(0, 119155, '\p{Canonical_Combining_Class=attachedaboveright}', "");
    Expect(1, 119155, '\p{^Canonical_Combining_Class=attachedaboveright}', "");
    Expect(1, 119155, '\P{Canonical_Combining_Class=attachedaboveright}', "");
    Expect(0, 119155, '\P{^Canonical_Combining_Class=attachedaboveright}', "");
    Expect(1, 119154, '\p{Canonical_Combining_Class=:\Aattachedaboveright\z:}', "");;
    Expect(0, 119155, '\p{Canonical_Combining_Class=:\Aattachedaboveright\z:}', "");;
    Expect(1, 119154, '\p{Canonical_Combining_Class=	-ATTACHED_Above_Right}', "");
    Expect(0, 119154, '\p{^Canonical_Combining_Class=	-ATTACHED_Above_Right}', "");
    Expect(0, 119154, '\P{Canonical_Combining_Class=	-ATTACHED_Above_Right}', "");
    Expect(1, 119154, '\P{^Canonical_Combining_Class=	-ATTACHED_Above_Right}', "");
    Expect(0, 119155, '\p{Canonical_Combining_Class=	-ATTACHED_Above_Right}', "");
    Expect(1, 119155, '\p{^Canonical_Combining_Class=	-ATTACHED_Above_Right}', "");
    Expect(1, 119155, '\P{Canonical_Combining_Class=	-ATTACHED_Above_Right}', "");
    Expect(0, 119155, '\P{^Canonical_Combining_Class=	-ATTACHED_Above_Right}', "");
    Error('\p{Ccc=_/a/ATAR}');
    Error('\P{Ccc=_/a/ATAR}');
    Expect(1, 119154, '\p{Ccc=:\AATAR\z:}', "");;
    Expect(0, 119155, '\p{Ccc=:\AATAR\z:}', "");;
    Expect(1, 119154, '\p{Ccc=atar}', "");
    Expect(0, 119154, '\p{^Ccc=atar}', "");
    Expect(0, 119154, '\P{Ccc=atar}', "");
    Expect(1, 119154, '\P{^Ccc=atar}', "");
    Expect(0, 119155, '\p{Ccc=atar}', "");
    Expect(1, 119155, '\p{^Ccc=atar}', "");
    Expect(1, 119155, '\P{Ccc=atar}', "");
    Expect(0, 119155, '\P{^Ccc=atar}', "");
    Expect(1, 119154, '\p{Ccc=:\Aatar\z:}', "");;
    Expect(0, 119155, '\p{Ccc=:\Aatar\z:}', "");;
    Expect(1, 119154, '\p{Ccc=		atar}', "");
    Expect(0, 119154, '\p{^Ccc=		atar}', "");
    Expect(0, 119154, '\P{Ccc=		atar}', "");
    Expect(1, 119154, '\P{^Ccc=		atar}', "");
    Expect(0, 119155, '\p{Ccc=		atar}', "");
    Expect(1, 119155, '\p{^Ccc=		atar}', "");
    Expect(1, 119155, '\P{Ccc=		atar}', "");
    Expect(0, 119155, '\P{^Ccc=		atar}', "");
    Error('\p{Is_Canonical_Combining_Class=	 0216/a/}');
    Error('\P{Is_Canonical_Combining_Class=	 0216/a/}');
    Expect(1, 119154, '\p{Is_Canonical_Combining_Class=+00_02_16}', "");
    Expect(0, 119154, '\p{^Is_Canonical_Combining_Class=+00_02_16}', "");
    Expect(0, 119154, '\P{Is_Canonical_Combining_Class=+00_02_16}', "");
    Expect(1, 119154, '\P{^Is_Canonical_Combining_Class=+00_02_16}', "");
    Expect(0, 119155, '\p{Is_Canonical_Combining_Class=+00_02_16}', "");
    Expect(1, 119155, '\p{^Is_Canonical_Combining_Class=+00_02_16}', "");
    Expect(1, 119155, '\P{Is_Canonical_Combining_Class=+00_02_16}', "");
    Expect(0, 119155, '\P{^Is_Canonical_Combining_Class=+00_02_16}', "");
    Error('\p{Is_Ccc=/a/	_ATTACHED_Above_Right}');
    Error('\P{Is_Ccc=/a/	_ATTACHED_Above_Right}');
    Expect(1, 119154, '\p{Is_Ccc: attachedaboveright}', "");
    Expect(0, 119154, '\p{^Is_Ccc: attachedaboveright}', "");
    Expect(0, 119154, '\P{Is_Ccc: attachedaboveright}', "");
    Expect(1, 119154, '\P{^Is_Ccc: attachedaboveright}', "");
    Expect(0, 119155, '\p{Is_Ccc: attachedaboveright}', "");
    Expect(1, 119155, '\p{^Is_Ccc: attachedaboveright}', "");
    Expect(1, 119155, '\P{Is_Ccc: attachedaboveright}', "");
    Expect(0, 119155, '\P{^Is_Ccc: attachedaboveright}', "");
    Expect(1, 119154, '\p{Is_Ccc=_ATTACHED_Above_Right}', "");
    Expect(0, 119154, '\p{^Is_Ccc=_ATTACHED_Above_Right}', "");
    Expect(0, 119154, '\P{Is_Ccc=_ATTACHED_Above_Right}', "");
    Expect(1, 119154, '\P{^Is_Ccc=_ATTACHED_Above_Right}', "");
    Expect(0, 119155, '\p{Is_Ccc=_ATTACHED_Above_Right}', "");
    Expect(1, 119155, '\p{^Is_Ccc=_ATTACHED_Above_Right}', "");
    Expect(1, 119155, '\P{Is_Ccc=_ATTACHED_Above_Right}', "");
    Expect(0, 119155, '\P{^Is_Ccc=_ATTACHED_Above_Right}', "");
    Error('\p{Canonical_Combining_Class=:=	Attached_Below}');
    Error('\P{Canonical_Combining_Class=:=	Attached_Below}');
    Expect(1, 7632, '\p{Canonical_Combining_Class=:\AAttached_Below\z:}', "");;
    Expect(0, 7633, '\p{Canonical_Combining_Class=:\AAttached_Below\z:}', "");;
    Expect(1, 7632, '\p{Canonical_Combining_Class=attachedbelow}', "");
    Expect(0, 7632, '\p{^Canonical_Combining_Class=attachedbelow}', "");
    Expect(0, 7632, '\P{Canonical_Combining_Class=attachedbelow}', "");
    Expect(1, 7632, '\P{^Canonical_Combining_Class=attachedbelow}', "");
    Expect(0, 7633, '\p{Canonical_Combining_Class=attachedbelow}', "");
    Expect(1, 7633, '\p{^Canonical_Combining_Class=attachedbelow}', "");
    Expect(1, 7633, '\P{Canonical_Combining_Class=attachedbelow}', "");
    Expect(0, 7633, '\P{^Canonical_Combining_Class=attachedbelow}', "");
    Expect(1, 7632, '\p{Canonical_Combining_Class=:\Aattachedbelow\z:}', "");;
    Expect(0, 7633, '\p{Canonical_Combining_Class=:\Aattachedbelow\z:}', "");;
    Expect(1, 7632, '\p{Canonical_Combining_Class=_ ATTACHED_Below}', "");
    Expect(0, 7632, '\p{^Canonical_Combining_Class=_ ATTACHED_Below}', "");
    Expect(0, 7632, '\P{Canonical_Combining_Class=_ ATTACHED_Below}', "");
    Expect(1, 7632, '\P{^Canonical_Combining_Class=_ ATTACHED_Below}', "");
    Expect(0, 7633, '\p{Canonical_Combining_Class=_ ATTACHED_Below}', "");
    Expect(1, 7633, '\p{^Canonical_Combining_Class=_ ATTACHED_Below}', "");
    Expect(1, 7633, '\P{Canonical_Combining_Class=_ ATTACHED_Below}', "");
    Expect(0, 7633, '\P{^Canonical_Combining_Class=_ ATTACHED_Below}', "");
    Error('\p{Ccc=_ATB:=}');
    Error('\P{Ccc=_ATB:=}');
    Expect(1, 7632, '\p{Ccc=:\AATB\z:}', "");;
    Expect(0, 7633, '\p{Ccc=:\AATB\z:}', "");;
    Expect(1, 7632, '\p{Ccc=atb}', "");
    Expect(0, 7632, '\p{^Ccc=atb}', "");
    Expect(0, 7632, '\P{Ccc=atb}', "");
    Expect(1, 7632, '\P{^Ccc=atb}', "");
    Expect(0, 7633, '\p{Ccc=atb}', "");
    Expect(1, 7633, '\p{^Ccc=atb}', "");
    Expect(1, 7633, '\P{Ccc=atb}', "");
    Expect(0, 7633, '\P{^Ccc=atb}', "");
    Expect(1, 7632, '\p{Ccc=:\Aatb\z:}', "");;
    Expect(0, 7633, '\p{Ccc=:\Aatb\z:}', "");;
    Expect(1, 7632, '\p{Ccc=_-ATB}', "");
    Expect(0, 7632, '\p{^Ccc=_-ATB}', "");
    Expect(0, 7632, '\P{Ccc=_-ATB}', "");
    Expect(1, 7632, '\P{^Ccc=_-ATB}', "");
    Expect(0, 7633, '\p{Ccc=_-ATB}', "");
    Expect(1, 7633, '\p{^Ccc=_-ATB}', "");
    Expect(1, 7633, '\P{Ccc=_-ATB}', "");
    Expect(0, 7633, '\P{^Ccc=_-ATB}', "");
    Error('\p{Is_Canonical_Combining_Class:	 /a/0000000202}');
    Error('\P{Is_Canonical_Combining_Class:	 /a/0000000202}');
    Expect(1, 7632, '\p{Is_Canonical_Combining_Class=0_0_0_2_02}', "");
    Expect(0, 7632, '\p{^Is_Canonical_Combining_Class=0_0_0_2_02}', "");
    Expect(0, 7632, '\P{Is_Canonical_Combining_Class=0_0_0_2_02}', "");
    Expect(1, 7632, '\P{^Is_Canonical_Combining_Class=0_0_0_2_02}', "");
    Expect(0, 7633, '\p{Is_Canonical_Combining_Class=0_0_0_2_02}', "");
    Expect(1, 7633, '\p{^Is_Canonical_Combining_Class=0_0_0_2_02}', "");
    Expect(1, 7633, '\P{Is_Canonical_Combining_Class=0_0_0_2_02}', "");
    Expect(0, 7633, '\P{^Is_Canonical_Combining_Class=0_0_0_2_02}', "");
    Error('\p{Is_Ccc=_:=Attached_below}');
    Error('\P{Is_Ccc=_:=Attached_below}');
    Expect(1, 7632, '\p{Is_Ccc: attachedbelow}', "");
    Expect(0, 7632, '\p{^Is_Ccc: attachedbelow}', "");
    Expect(0, 7632, '\P{Is_Ccc: attachedbelow}', "");
    Expect(1, 7632, '\P{^Is_Ccc: attachedbelow}', "");
    Expect(0, 7633, '\p{Is_Ccc: attachedbelow}', "");
    Expect(1, 7633, '\p{^Is_Ccc: attachedbelow}', "");
    Expect(1, 7633, '\P{Is_Ccc: attachedbelow}', "");
    Expect(0, 7633, '\P{^Is_Ccc: attachedbelow}', "");
    Expect(1, 7632, '\p{Is_Ccc=	 attached_below}', "");
    Expect(0, 7632, '\p{^Is_Ccc=	 attached_below}', "");
    Expect(0, 7632, '\P{Is_Ccc=	 attached_below}', "");
    Expect(1, 7632, '\P{^Is_Ccc=	 attached_below}', "");
    Expect(0, 7633, '\p{Is_Ccc=	 attached_below}', "");
    Expect(1, 7633, '\p{^Is_Ccc=	 attached_below}', "");
    Expect(1, 7633, '\P{Is_Ccc=	 attached_below}', "");
    Expect(0, 7633, '\P{^Is_Ccc=	 attached_below}', "");
    Error('\p{Canonical_Combining_Class=  Attached_Below_Left:=}');
    Error('\P{Canonical_Combining_Class=  Attached_Below_Left:=}');
    Expect(0, 1, '\p{Canonical_Combining_Class=:\AAttached_Below_Left\z:}', "");;
    Expect(0, 1, '\p{Canonical_Combining_Class=attachedbelowleft}', "");
    Expect(1, 1, '\p{^Canonical_Combining_Class=attachedbelowleft}', "");
    Expect(1, 1, '\P{Canonical_Combining_Class=attachedbelowleft}', "");
    Expect(0, 1, '\P{^Canonical_Combining_Class=attachedbelowleft}', "");
    Expect(0, 1, '\p{Canonical_Combining_Class=:\Aattachedbelowleft\z:}', "");;
    Expect(0, 1, '\p{Canonical_Combining_Class=		Attached_Below_left}', "");
    Expect(1, 1, '\p{^Canonical_Combining_Class=		Attached_Below_left}', "");
    Expect(1, 1, '\P{Canonical_Combining_Class=		Attached_Below_left}', "");
    Expect(0, 1, '\P{^Canonical_Combining_Class=		Attached_Below_left}', "");
    Error('\p{Ccc= ATBL:=}');
    Error('\P{Ccc= ATBL:=}');
    Expect(0, 1, '\p{Ccc=:\AATBL\z:}', "");;
    Expect(0, 1, '\p{Ccc=atbl}', "");
    Expect(1, 1, '\p{^Ccc=atbl}', "");
    Expect(1, 1, '\P{Ccc=atbl}', "");
    Expect(0, 1, '\P{^Ccc=atbl}', "");
    Expect(0, 1, '\p{Ccc=:\Aatbl\z:}', "");;
    Expect(0, 1, '\p{Ccc= _ATBL}', "");
    Expect(1, 1, '\p{^Ccc= _ATBL}', "");
    Expect(1, 1, '\P{Ccc= _ATBL}', "");
    Expect(0, 1, '\P{^Ccc= _ATBL}', "");
    Error('\p{Is_Canonical_Combining_Class:	 00_00_00_200/a/}');
    Error('\P{Is_Canonical_Combining_Class:	 00_00_00_200/a/}');
    Expect(0, 1, '\p{Is_Canonical_Combining_Class=0200}', "");
    Expect(1, 1, '\p{^Is_Canonical_Combining_Class=0200}', "");
    Expect(1, 1, '\P{Is_Canonical_Combining_Class=0200}', "");
    Expect(0, 1, '\P{^Is_Canonical_Combining_Class=0200}', "");
    Error('\p{Is_Ccc=	:=ATTACHED_below_Left}');
    Error('\P{Is_Ccc=	:=ATTACHED_below_Left}');
    Expect(0, 1, '\p{Is_Ccc=attachedbelowleft}', "");
    Expect(1, 1, '\p{^Is_Ccc=attachedbelowleft}', "");
    Expect(1, 1, '\P{Is_Ccc=attachedbelowleft}', "");
    Expect(0, 1, '\P{^Is_Ccc=attachedbelowleft}', "");
    Expect(0, 1, '\p{Is_Ccc=attached_below_LEFT}', "");
    Expect(1, 1, '\p{^Is_Ccc=attached_below_LEFT}', "");
    Expect(1, 1, '\P{Is_Ccc=attached_below_LEFT}', "");
    Expect(0, 1, '\P{^Is_Ccc=attached_below_LEFT}', "");
    Error('\p{Canonical_Combining_Class=__below/a/}');
    Error('\P{Canonical_Combining_Class=__below/a/}');
    Expect(1, 125142, '\p{Canonical_Combining_Class=:\ABelow\z:}', "");;
    Expect(0, 125143, '\p{Canonical_Combining_Class=:\ABelow\z:}', "");;
    Expect(1, 125142, '\p{Canonical_Combining_Class:   below}', "");
    Expect(0, 125142, '\p{^Canonical_Combining_Class:   below}', "");
    Expect(0, 125142, '\P{Canonical_Combining_Class:   below}', "");
    Expect(1, 125142, '\P{^Canonical_Combining_Class:   below}', "");
    Expect(0, 125143, '\p{Canonical_Combining_Class:   below}', "");
    Expect(1, 125143, '\p{^Canonical_Combining_Class:   below}', "");
    Expect(1, 125143, '\P{Canonical_Combining_Class:   below}', "");
    Expect(0, 125143, '\P{^Canonical_Combining_Class:   below}', "");
    Expect(1, 125142, '\p{Canonical_Combining_Class=:\Abelow\z:}', "");;
    Expect(0, 125143, '\p{Canonical_Combining_Class=:\Abelow\z:}', "");;
    Expect(1, 125142, '\p{Canonical_Combining_Class: 	_Below}', "");
    Expect(0, 125142, '\p{^Canonical_Combining_Class: 	_Below}', "");
    Expect(0, 125142, '\P{Canonical_Combining_Class: 	_Below}', "");
    Expect(1, 125142, '\P{^Canonical_Combining_Class: 	_Below}', "");
    Expect(0, 125143, '\p{Canonical_Combining_Class: 	_Below}', "");
    Expect(1, 125143, '\p{^Canonical_Combining_Class: 	_Below}', "");
    Expect(1, 125143, '\P{Canonical_Combining_Class: 	_Below}', "");
    Expect(0, 125143, '\P{^Canonical_Combining_Class: 	_Below}', "");
    Error('\p{Ccc=/a/_ B}');
    Error('\P{Ccc=/a/_ B}');
    Expect(1, 125142, '\p{Ccc=:\AB\z:}', "");;
    Expect(0, 125143, '\p{Ccc=:\AB\z:}', "");;
    Expect(1, 125142, '\p{Ccc=b}', "");
    Expect(0, 125142, '\p{^Ccc=b}', "");
    Expect(0, 125142, '\P{Ccc=b}', "");
    Expect(1, 125142, '\P{^Ccc=b}', "");
    Expect(0, 125143, '\p{Ccc=b}', "");
    Expect(1, 125143, '\p{^Ccc=b}', "");
    Expect(1, 125143, '\P{Ccc=b}', "");
    Expect(0, 125143, '\P{^Ccc=b}', "");
    Expect(1, 125142, '\p{Ccc=:\Ab\z:}', "");;
    Expect(0, 125143, '\p{Ccc=:\Ab\z:}', "");;
    Expect(1, 125142, '\p{Ccc: -_B}', "");
    Expect(0, 125142, '\p{^Ccc: -_B}', "");
    Expect(0, 125142, '\P{Ccc: -_B}', "");
    Expect(1, 125142, '\P{^Ccc: -_B}', "");
    Expect(0, 125143, '\p{Ccc: -_B}', "");
    Expect(1, 125143, '\p{^Ccc: -_B}', "");
    Expect(1, 125143, '\P{Ccc: -_B}', "");
    Expect(0, 125143, '\P{^Ccc: -_B}', "");
    Error('\p{Is_Canonical_Combining_Class=/a/ +000220}');
    Error('\P{Is_Canonical_Combining_Class=/a/ +000220}');
    Expect(1, 125142, '\p{Is_Canonical_Combining_Class: 0_0_0_0_0_0_000220}', "");
    Expect(0, 125142, '\p{^Is_Canonical_Combining_Class: 0_0_0_0_0_0_000220}', "");
    Expect(0, 125142, '\P{Is_Canonical_Combining_Class: 0_0_0_0_0_0_000220}', "");
    Expect(1, 125142, '\P{^Is_Canonical_Combining_Class: 0_0_0_0_0_0_000220}', "");
    Expect(0, 125143, '\p{Is_Canonical_Combining_Class: 0_0_0_0_0_0_000220}', "");
    Expect(1, 125143, '\p{^Is_Canonical_Combining_Class: 0_0_0_0_0_0_000220}', "");
    Expect(1, 125143, '\P{Is_Canonical_Combining_Class: 0_0_0_0_0_0_000220}', "");
    Expect(0, 125143, '\P{^Is_Canonical_Combining_Class: 0_0_0_0_0_0_000220}', "");
    Error('\p{Is_Ccc=_	below:=}');
    Error('\P{Is_Ccc=_	below:=}');
    Expect(1, 125142, '\p{Is_Ccc=below}', "");
    Expect(0, 125142, '\p{^Is_Ccc=below}', "");
    Expect(0, 125142, '\P{Is_Ccc=below}', "");
    Expect(1, 125142, '\P{^Is_Ccc=below}', "");
    Expect(0, 125143, '\p{Is_Ccc=below}', "");
    Expect(1, 125143, '\p{^Is_Ccc=below}', "");
    Expect(1, 125143, '\P{Is_Ccc=below}', "");
    Expect(0, 125143, '\P{^Is_Ccc=below}', "");
    Expect(1, 125142, '\p{Is_Ccc=	Below}', "");
    Expect(0, 125142, '\p{^Is_Ccc=	Below}', "");
    Expect(0, 125142, '\P{Is_Ccc=	Below}', "");
    Expect(1, 125142, '\P{^Is_Ccc=	Below}', "");
    Expect(0, 125143, '\p{Is_Ccc=	Below}', "");
    Expect(1, 125143, '\p{^Is_Ccc=	Below}', "");
    Expect(1, 125143, '\P{Is_Ccc=	Below}', "");
    Expect(0, 125143, '\P{^Is_Ccc=	Below}', "");
    Error('\p{Canonical_Combining_Class=:= -below_Left}');
    Error('\P{Canonical_Combining_Class=:= -below_Left}');
    Expect(1, 12330, '\p{Canonical_Combining_Class=:\ABelow_Left\z:}', "");;
    Expect(0, 12331, '\p{Canonical_Combining_Class=:\ABelow_Left\z:}', "");;
    Expect(1, 12330, '\p{Canonical_Combining_Class=belowleft}', "");
    Expect(0, 12330, '\p{^Canonical_Combining_Class=belowleft}', "");
    Expect(0, 12330, '\P{Canonical_Combining_Class=belowleft}', "");
    Expect(1, 12330, '\P{^Canonical_Combining_Class=belowleft}', "");
    Expect(0, 12331, '\p{Canonical_Combining_Class=belowleft}', "");
    Expect(1, 12331, '\p{^Canonical_Combining_Class=belowleft}', "");
    Expect(1, 12331, '\P{Canonical_Combining_Class=belowleft}', "");
    Expect(0, 12331, '\P{^Canonical_Combining_Class=belowleft}', "");
    Expect(1, 12330, '\p{Canonical_Combining_Class=:\Abelowleft\z:}', "");;
    Expect(0, 12331, '\p{Canonical_Combining_Class=:\Abelowleft\z:}', "");;
    Expect(1, 12330, '\p{Canonical_Combining_Class=_Below_left}', "");
    Expect(0, 12330, '\p{^Canonical_Combining_Class=_Below_left}', "");
    Expect(0, 12330, '\P{Canonical_Combining_Class=_Below_left}', "");
    Expect(1, 12330, '\P{^Canonical_Combining_Class=_Below_left}', "");
    Expect(0, 12331, '\p{Canonical_Combining_Class=_Below_left}', "");
    Expect(1, 12331, '\p{^Canonical_Combining_Class=_Below_left}', "");
    Expect(1, 12331, '\P{Canonical_Combining_Class=_Below_left}', "");
    Expect(0, 12331, '\P{^Canonical_Combining_Class=_Below_left}', "");
    Error('\p{Ccc=-	BL/a/}');
    Error('\P{Ccc=-	BL/a/}');
    Expect(1, 12330, '\p{Ccc=:\ABL\z:}', "");;
    Expect(0, 12331, '\p{Ccc=:\ABL\z:}', "");;
    Expect(1, 12330, '\p{Ccc=bl}', "");
    Expect(0, 12330, '\p{^Ccc=bl}', "");
    Expect(0, 12330, '\P{Ccc=bl}', "");
    Expect(1, 12330, '\P{^Ccc=bl}', "");
    Expect(0, 12331, '\p{Ccc=bl}', "");
    Expect(1, 12331, '\p{^Ccc=bl}', "");
    Expect(1, 12331, '\P{Ccc=bl}', "");
    Expect(0, 12331, '\P{^Ccc=bl}', "");
    Expect(1, 12330, '\p{Ccc=:\Abl\z:}', "");;
    Expect(0, 12331, '\p{Ccc=:\Abl\z:}', "");;
    Expect(1, 12330, '\p{Ccc= _BL}', "");
    Expect(0, 12330, '\p{^Ccc= _BL}', "");
    Expect(0, 12330, '\P{Ccc= _BL}', "");
    Expect(1, 12330, '\P{^Ccc= _BL}', "");
    Expect(0, 12331, '\p{Ccc= _BL}', "");
    Expect(1, 12331, '\p{^Ccc= _BL}', "");
    Expect(1, 12331, '\P{Ccc= _BL}', "");
    Expect(0, 12331, '\P{^Ccc= _BL}', "");
    Error('\p{Is_Canonical_Combining_Class=_:=+0000218}');
    Error('\P{Is_Canonical_Combining_Class=_:=+0000218}');
    Expect(1, 12330, '\p{Is_Canonical_Combining_Class=0000000218}', "");
    Expect(0, 12330, '\p{^Is_Canonical_Combining_Class=0000000218}', "");
    Expect(0, 12330, '\P{Is_Canonical_Combining_Class=0000000218}', "");
    Expect(1, 12330, '\P{^Is_Canonical_Combining_Class=0000000218}', "");
    Expect(0, 12331, '\p{Is_Canonical_Combining_Class=0000000218}', "");
    Expect(1, 12331, '\p{^Is_Canonical_Combining_Class=0000000218}', "");
    Expect(1, 12331, '\P{Is_Canonical_Combining_Class=0000000218}', "");
    Expect(0, 12331, '\P{^Is_Canonical_Combining_Class=0000000218}', "");
    Error('\p{Is_Ccc=:=BELOW_Left}');
    Error('\P{Is_Ccc=:=BELOW_Left}');
    Expect(1, 12330, '\p{Is_Ccc=belowleft}', "");
    Expect(0, 12330, '\p{^Is_Ccc=belowleft}', "");
    Expect(0, 12330, '\P{Is_Ccc=belowleft}', "");
    Expect(1, 12330, '\P{^Is_Ccc=belowleft}', "");
    Expect(0, 12331, '\p{Is_Ccc=belowleft}', "");
    Expect(1, 12331, '\p{^Is_Ccc=belowleft}', "");
    Expect(1, 12331, '\P{Is_Ccc=belowleft}', "");
    Expect(0, 12331, '\P{^Is_Ccc=belowleft}', "");
    Expect(1, 12330, '\p{Is_Ccc:		Below_Left}', "");
    Expect(0, 12330, '\p{^Is_Ccc:		Below_Left}', "");
    Expect(0, 12330, '\P{Is_Ccc:		Below_Left}', "");
    Expect(1, 12330, '\P{^Is_Ccc:		Below_Left}', "");
    Expect(0, 12331, '\p{Is_Ccc:		Below_Left}', "");
    Expect(1, 12331, '\p{^Is_Ccc:		Below_Left}', "");
    Expect(1, 12331, '\P{Is_Ccc:		Below_Left}', "");
    Expect(0, 12331, '\P{^Is_Ccc:		Below_Left}', "");
    Error('\p{Canonical_Combining_Class=/a/Below_Right}');
    Error('\P{Canonical_Combining_Class=/a/Below_Right}');
    Expect(1, 12333, '\p{Canonical_Combining_Class=:\ABelow_Right\z:}', "");;
    Expect(0, 12334, '\p{Canonical_Combining_Class=:\ABelow_Right\z:}', "");;
    Expect(1, 12333, '\p{Canonical_Combining_Class=belowright}', "");
    Expect(0, 12333, '\p{^Canonical_Combining_Class=belowright}', "");
    Expect(0, 12333, '\P{Canonical_Combining_Class=belowright}', "");
    Expect(1, 12333, '\P{^Canonical_Combining_Class=belowright}', "");
    Expect(0, 12334, '\p{Canonical_Combining_Class=belowright}', "");
    Expect(1, 12334, '\p{^Canonical_Combining_Class=belowright}', "");
    Expect(1, 12334, '\P{Canonical_Combining_Class=belowright}', "");
    Expect(0, 12334, '\P{^Canonical_Combining_Class=belowright}', "");
    Expect(1, 12333, '\p{Canonical_Combining_Class=:\Abelowright\z:}', "");;
    Expect(0, 12334, '\p{Canonical_Combining_Class=:\Abelowright\z:}', "");;
    Expect(1, 12333, '\p{Canonical_Combining_Class= _Below_Right}', "");
    Expect(0, 12333, '\p{^Canonical_Combining_Class= _Below_Right}', "");
    Expect(0, 12333, '\P{Canonical_Combining_Class= _Below_Right}', "");
    Expect(1, 12333, '\P{^Canonical_Combining_Class= _Below_Right}', "");
    Expect(0, 12334, '\p{Canonical_Combining_Class= _Below_Right}', "");
    Expect(1, 12334, '\p{^Canonical_Combining_Class= _Below_Right}', "");
    Expect(1, 12334, '\P{Canonical_Combining_Class= _Below_Right}', "");
    Expect(0, 12334, '\P{^Canonical_Combining_Class= _Below_Right}', "");
    Error('\p{Ccc=/a/- BR}');
    Error('\P{Ccc=/a/- BR}');
    Expect(1, 12333, '\p{Ccc=:\ABR\z:}', "");;
    Expect(0, 12334, '\p{Ccc=:\ABR\z:}', "");;
    Expect(1, 12333, '\p{Ccc: br}', "");
    Expect(0, 12333, '\p{^Ccc: br}', "");
    Expect(0, 12333, '\P{Ccc: br}', "");
    Expect(1, 12333, '\P{^Ccc: br}', "");
    Expect(0, 12334, '\p{Ccc: br}', "");
    Expect(1, 12334, '\p{^Ccc: br}', "");
    Expect(1, 12334, '\P{Ccc: br}', "");
    Expect(0, 12334, '\P{^Ccc: br}', "");
    Expect(1, 12333, '\p{Ccc=:\Abr\z:}', "");;
    Expect(0, 12334, '\p{Ccc=:\Abr\z:}', "");;
    Expect(1, 12333, '\p{Ccc=-br}', "");
    Expect(0, 12333, '\p{^Ccc=-br}', "");
    Expect(0, 12333, '\P{Ccc=-br}', "");
    Expect(1, 12333, '\P{^Ccc=-br}', "");
    Expect(0, 12334, '\p{Ccc=-br}', "");
    Expect(1, 12334, '\p{^Ccc=-br}', "");
    Expect(1, 12334, '\P{Ccc=-br}', "");
    Expect(0, 12334, '\P{^Ccc=-br}', "");
    Error('\p{Is_Canonical_Combining_Class=:=	_+222}');
    Error('\P{Is_Canonical_Combining_Class=:=	_+222}');
    Expect(1, 12333, '\p{Is_Canonical_Combining_Class=0_0_2_22}', "");
    Expect(0, 12333, '\p{^Is_Canonical_Combining_Class=0_0_2_22}', "");
    Expect(0, 12333, '\P{Is_Canonical_Combining_Class=0_0_2_22}', "");
    Expect(1, 12333, '\P{^Is_Canonical_Combining_Class=0_0_2_22}', "");
    Expect(0, 12334, '\p{Is_Canonical_Combining_Class=0_0_2_22}', "");
    Expect(1, 12334, '\p{^Is_Canonical_Combining_Class=0_0_2_22}', "");
    Expect(1, 12334, '\P{Is_Canonical_Combining_Class=0_0_2_22}', "");
    Expect(0, 12334, '\P{^Is_Canonical_Combining_Class=0_0_2_22}', "");
    Error('\p{Is_Ccc=-Below_RIGHT:=}');
    Error('\P{Is_Ccc=-Below_RIGHT:=}');
    Expect(1, 12333, '\p{Is_Ccc:belowright}', "");
    Expect(0, 12333, '\p{^Is_Ccc:belowright}', "");
    Expect(0, 12333, '\P{Is_Ccc:belowright}', "");
    Expect(1, 12333, '\P{^Is_Ccc:belowright}', "");
    Expect(0, 12334, '\p{Is_Ccc:belowright}', "");
    Expect(1, 12334, '\p{^Is_Ccc:belowright}', "");
    Expect(1, 12334, '\P{Is_Ccc:belowright}', "");
    Expect(0, 12334, '\P{^Is_Ccc:belowright}', "");
    Expect(1, 12333, '\p{Is_Ccc=__Below_Right}', "");
    Expect(0, 12333, '\p{^Is_Ccc=__Below_Right}', "");
    Expect(0, 12333, '\P{Is_Ccc=__Below_Right}', "");
    Expect(1, 12333, '\P{^Is_Ccc=__Below_Right}', "");
    Expect(0, 12334, '\p{Is_Ccc=__Below_Right}', "");
    Expect(1, 12334, '\p{^Is_Ccc=__Below_Right}', "");
    Expect(1, 12334, '\P{Is_Ccc=__Below_Right}', "");
    Expect(0, 12334, '\P{^Is_Ccc=__Below_Right}', "");
    Error('\p{Canonical_Combining_Class=/a/CCC10}');
    Error('\P{Canonical_Combining_Class=/a/CCC10}');
    Expect(1, 1456, '\p{Canonical_Combining_Class=:\ACCC10\z:}', "");;
    Expect(0, 1457, '\p{Canonical_Combining_Class=:\ACCC10\z:}', "");;
    Expect(1, 1456, '\p{Canonical_Combining_Class=ccc10}', "");
    Expect(0, 1456, '\p{^Canonical_Combining_Class=ccc10}', "");
    Expect(0, 1456, '\P{Canonical_Combining_Class=ccc10}', "");
    Expect(1, 1456, '\P{^Canonical_Combining_Class=ccc10}', "");
    Expect(0, 1457, '\p{Canonical_Combining_Class=ccc10}', "");
    Expect(1, 1457, '\p{^Canonical_Combining_Class=ccc10}', "");
    Expect(1, 1457, '\P{Canonical_Combining_Class=ccc10}', "");
    Expect(0, 1457, '\P{^Canonical_Combining_Class=ccc10}', "");
    Expect(1, 1456, '\p{Canonical_Combining_Class=:\Accc10\z:}', "");;
    Expect(0, 1457, '\p{Canonical_Combining_Class=:\Accc10\z:}', "");;
    Expect(1, 1456, '\p{Canonical_Combining_Class=- CCC10}', "");
    Expect(0, 1456, '\p{^Canonical_Combining_Class=- CCC10}', "");
    Expect(0, 1456, '\P{Canonical_Combining_Class=- CCC10}', "");
    Expect(1, 1456, '\P{^Canonical_Combining_Class=- CCC10}', "");
    Expect(0, 1457, '\p{Canonical_Combining_Class=- CCC10}', "");
    Expect(1, 1457, '\p{^Canonical_Combining_Class=- CCC10}', "");
    Expect(1, 1457, '\P{Canonical_Combining_Class=- CCC10}', "");
    Expect(0, 1457, '\P{^Canonical_Combining_Class=- CCC10}', "");
    Error('\p{Ccc=/a/	_0_0_0_0_0010}');
    Error('\P{Ccc=/a/	_0_0_0_0_0010}');
    Expect(1, 1456, '\p{Ccc=:\A10\z:}', "");;
    Expect(0, 1457, '\p{Ccc=:\A10\z:}', "");;
    Expect(1, 1456, '\p{Ccc=010}', "");
    Expect(0, 1456, '\p{^Ccc=010}', "");
    Expect(0, 1456, '\P{Ccc=010}', "");
    Expect(1, 1456, '\P{^Ccc=010}', "");
    Expect(0, 1457, '\p{Ccc=010}', "");
    Expect(1, 1457, '\p{^Ccc=010}', "");
    Expect(1, 1457, '\P{Ccc=010}', "");
    Expect(0, 1457, '\P{^Ccc=010}', "");
    Error('\p{Is_Canonical_Combining_Class=/a/__CCC10}');
    Error('\P{Is_Canonical_Combining_Class=/a/__CCC10}');
    Expect(1, 1456, '\p{Is_Canonical_Combining_Class=ccc10}', "");
    Expect(0, 1456, '\p{^Is_Canonical_Combining_Class=ccc10}', "");
    Expect(0, 1456, '\P{Is_Canonical_Combining_Class=ccc10}', "");
    Expect(1, 1456, '\P{^Is_Canonical_Combining_Class=ccc10}', "");
    Expect(0, 1457, '\p{Is_Canonical_Combining_Class=ccc10}', "");
    Expect(1, 1457, '\p{^Is_Canonical_Combining_Class=ccc10}', "");
    Expect(1, 1457, '\P{Is_Canonical_Combining_Class=ccc10}', "");
    Expect(0, 1457, '\P{^Is_Canonical_Combining_Class=ccc10}', "");
    Expect(1, 1456, '\p{Is_Canonical_Combining_Class:   -CCC10}', "");
    Expect(0, 1456, '\p{^Is_Canonical_Combining_Class:   -CCC10}', "");
    Expect(0, 1456, '\P{Is_Canonical_Combining_Class:   -CCC10}', "");
    Expect(1, 1456, '\P{^Is_Canonical_Combining_Class:   -CCC10}', "");
    Expect(0, 1457, '\p{Is_Canonical_Combining_Class:   -CCC10}', "");
    Expect(1, 1457, '\p{^Is_Canonical_Combining_Class:   -CCC10}', "");
    Expect(1, 1457, '\P{Is_Canonical_Combining_Class:   -CCC10}', "");
    Expect(0, 1457, '\P{^Is_Canonical_Combining_Class:   -CCC10}', "");
    Error('\p{Is_Ccc=/a/_ 0000001_0}');
    Error('\P{Is_Ccc=/a/_ 0000001_0}');
    Expect(1, 1456, '\p{Is_Ccc=+00000010}', "");
    Expect(0, 1456, '\p{^Is_Ccc=+00000010}', "");
    Expect(0, 1456, '\P{Is_Ccc=+00000010}', "");
    Expect(1, 1456, '\P{^Is_Ccc=+00000010}', "");
    Expect(0, 1457, '\p{Is_Ccc=+00000010}', "");
    Expect(1, 1457, '\p{^Is_Ccc=+00000010}', "");
    Expect(1, 1457, '\P{Is_Ccc=+00000010}', "");
    Expect(0, 1457, '\P{^Is_Ccc=+00000010}', "");
    Error('\p{Canonical_Combining_Class=:=ccc103}');
    Error('\P{Canonical_Combining_Class=:=ccc103}');
    Expect(1, 3641, '\p{Canonical_Combining_Class=:\ACCC103\z:}', "");;
    Expect(0, 3642, '\p{Canonical_Combining_Class=:\ACCC103\z:}', "");;
    Expect(1, 3641, '\p{Canonical_Combining_Class:   ccc103}', "");
    Expect(0, 3641, '\p{^Canonical_Combining_Class:   ccc103}', "");
    Expect(0, 3641, '\P{Canonical_Combining_Class:   ccc103}', "");
    Expect(1, 3641, '\P{^Canonical_Combining_Class:   ccc103}', "");
    Expect(0, 3642, '\p{Canonical_Combining_Class:   ccc103}', "");
    Expect(1, 3642, '\p{^Canonical_Combining_Class:   ccc103}', "");
    Expect(1, 3642, '\P{Canonical_Combining_Class:   ccc103}', "");
    Expect(0, 3642, '\P{^Canonical_Combining_Class:   ccc103}', "");
    Expect(1, 3641, '\p{Canonical_Combining_Class=:\Accc103\z:}', "");;
    Expect(0, 3642, '\p{Canonical_Combining_Class=:\Accc103\z:}', "");;
    Expect(1, 3641, '\p{Canonical_Combining_Class=__CCC103}', "");
    Expect(0, 3641, '\p{^Canonical_Combining_Class=__CCC103}', "");
    Expect(0, 3641, '\P{Canonical_Combining_Class=__CCC103}', "");
    Expect(1, 3641, '\P{^Canonical_Combining_Class=__CCC103}', "");
    Expect(0, 3642, '\p{Canonical_Combining_Class=__CCC103}', "");
    Expect(1, 3642, '\p{^Canonical_Combining_Class=__CCC103}', "");
    Expect(1, 3642, '\P{Canonical_Combining_Class=__CCC103}', "");
    Expect(0, 3642, '\P{^Canonical_Combining_Class=__CCC103}', "");
    Error('\p{Ccc=		0010_3:=}');
    Error('\P{Ccc=		0010_3:=}');
    Expect(1, 3641, '\p{Ccc=:\A103\z:}', "");;
    Expect(0, 3642, '\p{Ccc=:\A103\z:}', "");;
    Expect(1, 3641, '\p{Ccc=000000103}', "");
    Expect(0, 3641, '\p{^Ccc=000000103}', "");
    Expect(0, 3641, '\P{Ccc=000000103}', "");
    Expect(1, 3641, '\P{^Ccc=000000103}', "");
    Expect(0, 3642, '\p{Ccc=000000103}', "");
    Expect(1, 3642, '\p{^Ccc=000000103}', "");
    Expect(1, 3642, '\P{Ccc=000000103}', "");
    Expect(0, 3642, '\P{^Ccc=000000103}', "");
    Error('\p{Is_Canonical_Combining_Class=	/a/CCC103}');
    Error('\P{Is_Canonical_Combining_Class=	/a/CCC103}');
    Expect(1, 3641, '\p{Is_Canonical_Combining_Class=ccc103}', "");
    Expect(0, 3641, '\p{^Is_Canonical_Combining_Class=ccc103}', "");
    Expect(0, 3641, '\P{Is_Canonical_Combining_Class=ccc103}', "");
    Expect(1, 3641, '\P{^Is_Canonical_Combining_Class=ccc103}', "");
    Expect(0, 3642, '\p{Is_Canonical_Combining_Class=ccc103}', "");
    Expect(1, 3642, '\p{^Is_Canonical_Combining_Class=ccc103}', "");
    Expect(1, 3642, '\P{Is_Canonical_Combining_Class=ccc103}', "");
    Expect(0, 3642, '\P{^Is_Canonical_Combining_Class=ccc103}', "");
    Expect(1, 3641, '\p{Is_Canonical_Combining_Class= -CCC103}', "");
    Expect(0, 3641, '\p{^Is_Canonical_Combining_Class= -CCC103}', "");
    Expect(0, 3641, '\P{Is_Canonical_Combining_Class= -CCC103}', "");
    Expect(1, 3641, '\P{^Is_Canonical_Combining_Class= -CCC103}', "");
    Expect(0, 3642, '\p{Is_Canonical_Combining_Class= -CCC103}', "");
    Expect(1, 3642, '\p{^Is_Canonical_Combining_Class= -CCC103}', "");
    Expect(1, 3642, '\P{Is_Canonical_Combining_Class= -CCC103}', "");
    Expect(0, 3642, '\P{^Is_Canonical_Combining_Class= -CCC103}', "");
    Error('\p{Is_Ccc=:=	0010_3}');
    Error('\P{Is_Ccc=:=	0010_3}');
    Expect(1, 3641, '\p{Is_Ccc=000000000103}', "");
    Expect(0, 3641, '\p{^Is_Ccc=000000000103}', "");
    Expect(0, 3641, '\P{Is_Ccc=000000000103}', "");
    Expect(1, 3641, '\P{^Is_Ccc=000000000103}', "");
    Expect(0, 3642, '\p{Is_Ccc=000000000103}', "");
    Expect(1, 3642, '\p{^Is_Ccc=000000000103}', "");
    Expect(1, 3642, '\P{Is_Ccc=000000000103}', "");
    Expect(0, 3642, '\P{^Is_Ccc=000000000103}', "");
    Error('\p{Canonical_Combining_Class=_:=ccc107}');
    Error('\P{Canonical_Combining_Class=_:=ccc107}');
    Expect(1, 3659, '\p{Canonical_Combining_Class=:\ACCC107\z:}', "");;
    Expect(0, 3660, '\p{Canonical_Combining_Class=:\ACCC107\z:}', "");;
    Expect(1, 3659, '\p{Canonical_Combining_Class=ccc107}', "");
    Expect(0, 3659, '\p{^Canonical_Combining_Class=ccc107}', "");
    Expect(0, 3659, '\P{Canonical_Combining_Class=ccc107}', "");
    Expect(1, 3659, '\P{^Canonical_Combining_Class=ccc107}', "");
    Expect(0, 3660, '\p{Canonical_Combining_Class=ccc107}', "");
    Expect(1, 3660, '\p{^Canonical_Combining_Class=ccc107}', "");
    Expect(1, 3660, '\P{Canonical_Combining_Class=ccc107}', "");
    Expect(0, 3660, '\P{^Canonical_Combining_Class=ccc107}', "");
    Expect(1, 3659, '\p{Canonical_Combining_Class=:\Accc107\z:}', "");;
    Expect(0, 3660, '\p{Canonical_Combining_Class=:\Accc107\z:}', "");;
    Expect(1, 3659, '\p{Canonical_Combining_Class=	 CCC107}', "");
    Expect(0, 3659, '\p{^Canonical_Combining_Class=	 CCC107}', "");
    Expect(0, 3659, '\P{Canonical_Combining_Class=	 CCC107}', "");
    Expect(1, 3659, '\P{^Canonical_Combining_Class=	 CCC107}', "");
    Expect(0, 3660, '\p{Canonical_Combining_Class=	 CCC107}', "");
    Expect(1, 3660, '\p{^Canonical_Combining_Class=	 CCC107}', "");
    Expect(1, 3660, '\P{Canonical_Combining_Class=	 CCC107}', "");
    Expect(0, 3660, '\P{^Canonical_Combining_Class=	 CCC107}', "");
    Error('\p{Ccc=/a/_+0_0_0_0_1_07}');
    Error('\P{Ccc=/a/_+0_0_0_0_1_07}');
    Expect(1, 3659, '\p{Ccc=:\A107\z:}', "");;
    Expect(0, 3660, '\p{Ccc=:\A107\z:}', "");;
    Expect(1, 3659, '\p{Ccc: 0000000107}', "");
    Expect(0, 3659, '\p{^Ccc: 0000000107}', "");
    Expect(0, 3659, '\P{Ccc: 0000000107}', "");
    Expect(1, 3659, '\P{^Ccc: 0000000107}', "");
    Expect(0, 3660, '\p{Ccc: 0000000107}', "");
    Expect(1, 3660, '\p{^Ccc: 0000000107}', "");
    Expect(1, 3660, '\P{Ccc: 0000000107}', "");
    Expect(0, 3660, '\P{^Ccc: 0000000107}', "");
    Error('\p{Is_Canonical_Combining_Class=__CCC107/a/}');
    Error('\P{Is_Canonical_Combining_Class=__CCC107/a/}');
    Expect(1, 3659, '\p{Is_Canonical_Combining_Class=ccc107}', "");
    Expect(0, 3659, '\p{^Is_Canonical_Combining_Class=ccc107}', "");
    Expect(0, 3659, '\P{Is_Canonical_Combining_Class=ccc107}', "");
    Expect(1, 3659, '\P{^Is_Canonical_Combining_Class=ccc107}', "");
    Expect(0, 3660, '\p{Is_Canonical_Combining_Class=ccc107}', "");
    Expect(1, 3660, '\p{^Is_Canonical_Combining_Class=ccc107}', "");
    Expect(1, 3660, '\P{Is_Canonical_Combining_Class=ccc107}', "");
    Expect(0, 3660, '\P{^Is_Canonical_Combining_Class=ccc107}', "");
    Expect(1, 3659, '\p{Is_Canonical_Combining_Class=- CCC107}', "");
    Expect(0, 3659, '\p{^Is_Canonical_Combining_Class=- CCC107}', "");
    Expect(0, 3659, '\P{Is_Canonical_Combining_Class=- CCC107}', "");
    Expect(1, 3659, '\P{^Is_Canonical_Combining_Class=- CCC107}', "");
    Expect(0, 3660, '\p{Is_Canonical_Combining_Class=- CCC107}', "");
    Expect(1, 3660, '\p{^Is_Canonical_Combining_Class=- CCC107}', "");
    Expect(1, 3660, '\P{Is_Canonical_Combining_Class=- CCC107}', "");
    Expect(0, 3660, '\P{^Is_Canonical_Combining_Class=- CCC107}', "");
    Error('\p{Is_Ccc=/a/+0107}');
    Error('\P{Is_Ccc=/a/+0107}');
    Expect(1, 3659, '\p{Is_Ccc=0_0_0_0_0107}', "");
    Expect(0, 3659, '\p{^Is_Ccc=0_0_0_0_0107}', "");
    Expect(0, 3659, '\P{Is_Ccc=0_0_0_0_0107}', "");
    Expect(1, 3659, '\P{^Is_Ccc=0_0_0_0_0107}', "");
    Expect(0, 3660, '\p{Is_Ccc=0_0_0_0_0107}', "");
    Expect(1, 3660, '\p{^Is_Ccc=0_0_0_0_0107}', "");
    Expect(1, 3660, '\P{Is_Ccc=0_0_0_0_0107}', "");
    Expect(0, 3660, '\P{^Is_Ccc=0_0_0_0_0107}', "");
    Error('\p{Canonical_Combining_Class=/a/-CCC11}');
    Error('\P{Canonical_Combining_Class=/a/-CCC11}');
    Expect(1, 1457, '\p{Canonical_Combining_Class=:\ACCC11\z:}', "");;
    Expect(0, 1458, '\p{Canonical_Combining_Class=:\ACCC11\z:}', "");;
    Expect(1, 1457, '\p{Canonical_Combining_Class=ccc11}', "");
    Expect(0, 1457, '\p{^Canonical_Combining_Class=ccc11}', "");
    Expect(0, 1457, '\P{Canonical_Combining_Class=ccc11}', "");
    Expect(1, 1457, '\P{^Canonical_Combining_Class=ccc11}', "");
    Expect(0, 1458, '\p{Canonical_Combining_Class=ccc11}', "");
    Expect(1, 1458, '\p{^Canonical_Combining_Class=ccc11}', "");
    Expect(1, 1458, '\P{Canonical_Combining_Class=ccc11}', "");
    Expect(0, 1458, '\P{^Canonical_Combining_Class=ccc11}', "");
    Expect(1, 1457, '\p{Canonical_Combining_Class=:\Accc11\z:}', "");;
    Expect(0, 1458, '\p{Canonical_Combining_Class=:\Accc11\z:}', "");;
    Expect(1, 1457, '\p{Canonical_Combining_Class:	-CCC11}', "");
    Expect(0, 1457, '\p{^Canonical_Combining_Class:	-CCC11}', "");
    Expect(0, 1457, '\P{Canonical_Combining_Class:	-CCC11}', "");
    Expect(1, 1457, '\P{^Canonical_Combining_Class:	-CCC11}', "");
    Expect(0, 1458, '\p{Canonical_Combining_Class:	-CCC11}', "");
    Expect(1, 1458, '\p{^Canonical_Combining_Class:	-CCC11}', "");
    Expect(1, 1458, '\P{Canonical_Combining_Class:	-CCC11}', "");
    Expect(0, 1458, '\P{^Canonical_Combining_Class:	-CCC11}', "");
    Error('\p{Ccc=-/a/00_00_00_00_01_1}');
    Error('\P{Ccc=-/a/00_00_00_00_01_1}');
    Expect(1, 1457, '\p{Ccc=:\A11\z:}', "");;
    Expect(0, 1458, '\p{Ccc=:\A11\z:}', "");;
    Expect(1, 1457, '\p{Ccc=011}', "");
    Expect(0, 1457, '\p{^Ccc=011}', "");
    Expect(0, 1457, '\P{Ccc=011}', "");
    Expect(1, 1457, '\P{^Ccc=011}', "");
    Expect(0, 1458, '\p{Ccc=011}', "");
    Expect(1, 1458, '\p{^Ccc=011}', "");
    Expect(1, 1458, '\P{Ccc=011}', "");
    Expect(0, 1458, '\P{^Ccc=011}', "");
    Error('\p{Is_Canonical_Combining_Class=/a/-CCC11}');
    Error('\P{Is_Canonical_Combining_Class=/a/-CCC11}');
    Expect(1, 1457, '\p{Is_Canonical_Combining_Class=ccc11}', "");
    Expect(0, 1457, '\p{^Is_Canonical_Combining_Class=ccc11}', "");
    Expect(0, 1457, '\P{Is_Canonical_Combining_Class=ccc11}', "");
    Expect(1, 1457, '\P{^Is_Canonical_Combining_Class=ccc11}', "");
    Expect(0, 1458, '\p{Is_Canonical_Combining_Class=ccc11}', "");
    Expect(1, 1458, '\p{^Is_Canonical_Combining_Class=ccc11}', "");
    Expect(1, 1458, '\P{Is_Canonical_Combining_Class=ccc11}', "");
    Expect(0, 1458, '\P{^Is_Canonical_Combining_Class=ccc11}', "");
    Expect(1, 1457, '\p{Is_Canonical_Combining_Class=--CCC11}', "");
    Expect(0, 1457, '\p{^Is_Canonical_Combining_Class=--CCC11}', "");
    Expect(0, 1457, '\P{Is_Canonical_Combining_Class=--CCC11}', "");
    Expect(1, 1457, '\P{^Is_Canonical_Combining_Class=--CCC11}', "");
    Expect(0, 1458, '\p{Is_Canonical_Combining_Class=--CCC11}', "");
    Expect(1, 1458, '\p{^Is_Canonical_Combining_Class=--CCC11}', "");
    Expect(1, 1458, '\P{Is_Canonical_Combining_Class=--CCC11}', "");
    Expect(0, 1458, '\P{^Is_Canonical_Combining_Class=--CCC11}', "");
    Error('\p{Is_Ccc=	/a/1_1}');
    Error('\P{Is_Ccc=	/a/1_1}');
    Expect(1, 1457, '\p{Is_Ccc=000011}', "");
    Expect(0, 1457, '\p{^Is_Ccc=000011}', "");
    Expect(0, 1457, '\P{Is_Ccc=000011}', "");
    Expect(1, 1457, '\P{^Is_Ccc=000011}', "");
    Expect(0, 1458, '\p{Is_Ccc=000011}', "");
    Expect(1, 1458, '\p{^Is_Ccc=000011}', "");
    Expect(1, 1458, '\P{Is_Ccc=000011}', "");
    Expect(0, 1458, '\P{^Is_Ccc=000011}', "");
    Error('\p{Canonical_Combining_Class= -ccc118:=}');
    Error('\P{Canonical_Combining_Class= -ccc118:=}');
    Expect(1, 3769, '\p{Canonical_Combining_Class=:\ACCC118\z:}', "");;
    Expect(0, 3770, '\p{Canonical_Combining_Class=:\ACCC118\z:}', "");;
    Expect(1, 3769, '\p{Canonical_Combining_Class=ccc118}', "");
    Expect(0, 3769, '\p{^Canonical_Combining_Class=ccc118}', "");
    Expect(0, 3769, '\P{Canonical_Combining_Class=ccc118}', "");
    Expect(1, 3769, '\P{^Canonical_Combining_Class=ccc118}', "");
    Expect(0, 3770, '\p{Canonical_Combining_Class=ccc118}', "");
    Expect(1, 3770, '\p{^Canonical_Combining_Class=ccc118}', "");
    Expect(1, 3770, '\P{Canonical_Combining_Class=ccc118}', "");
    Expect(0, 3770, '\P{^Canonical_Combining_Class=ccc118}', "");
    Expect(1, 3769, '\p{Canonical_Combining_Class=:\Accc118\z:}', "");;
    Expect(0, 3770, '\p{Canonical_Combining_Class=:\Accc118\z:}', "");;
    Expect(1, 3769, '\p{Canonical_Combining_Class=-ccc118}', "");
    Expect(0, 3769, '\p{^Canonical_Combining_Class=-ccc118}', "");
    Expect(0, 3769, '\P{Canonical_Combining_Class=-ccc118}', "");
    Expect(1, 3769, '\P{^Canonical_Combining_Class=-ccc118}', "");
    Expect(0, 3770, '\p{Canonical_Combining_Class=-ccc118}', "");
    Expect(1, 3770, '\p{^Canonical_Combining_Class=-ccc118}', "");
    Expect(1, 3770, '\P{Canonical_Combining_Class=-ccc118}', "");
    Expect(0, 3770, '\P{^Canonical_Combining_Class=-ccc118}', "");
    Error('\p{Ccc=:= _+0000000118}');
    Error('\P{Ccc=:= _+0000000118}');
    Expect(1, 3769, '\p{Ccc=:\A118\z:}', "");;
    Expect(0, 3770, '\p{Ccc=:\A118\z:}', "");;
    Expect(1, 3769, '\p{Ccc:+118}', "");
    Expect(0, 3769, '\p{^Ccc:+118}', "");
    Expect(0, 3769, '\P{Ccc:+118}', "");
    Expect(1, 3769, '\P{^Ccc:+118}', "");
    Expect(0, 3770, '\p{Ccc:+118}', "");
    Expect(1, 3770, '\p{^Ccc:+118}', "");
    Expect(1, 3770, '\P{Ccc:+118}', "");
    Expect(0, 3770, '\P{^Ccc:+118}', "");
    Error('\p{Is_Canonical_Combining_Class= :=CCC118}');
    Error('\P{Is_Canonical_Combining_Class= :=CCC118}');
    Expect(1, 3769, '\p{Is_Canonical_Combining_Class=ccc118}', "");
    Expect(0, 3769, '\p{^Is_Canonical_Combining_Class=ccc118}', "");
    Expect(0, 3769, '\P{Is_Canonical_Combining_Class=ccc118}', "");
    Expect(1, 3769, '\P{^Is_Canonical_Combining_Class=ccc118}', "");
    Expect(0, 3770, '\p{Is_Canonical_Combining_Class=ccc118}', "");
    Expect(1, 3770, '\p{^Is_Canonical_Combining_Class=ccc118}', "");
    Expect(1, 3770, '\P{Is_Canonical_Combining_Class=ccc118}', "");
    Expect(0, 3770, '\P{^Is_Canonical_Combining_Class=ccc118}', "");
    Expect(1, 3769, '\p{Is_Canonical_Combining_Class=-	CCC118}', "");
    Expect(0, 3769, '\p{^Is_Canonical_Combining_Class=-	CCC118}', "");
    Expect(0, 3769, '\P{Is_Canonical_Combining_Class=-	CCC118}', "");
    Expect(1, 3769, '\P{^Is_Canonical_Combining_Class=-	CCC118}', "");
    Expect(0, 3770, '\p{Is_Canonical_Combining_Class=-	CCC118}', "");
    Expect(1, 3770, '\p{^Is_Canonical_Combining_Class=-	CCC118}', "");
    Expect(1, 3770, '\P{Is_Canonical_Combining_Class=-	CCC118}', "");
    Expect(0, 3770, '\P{^Is_Canonical_Combining_Class=-	CCC118}', "");
    Error('\p{Is_Ccc=/a/_	011_8}');
    Error('\P{Is_Ccc=/a/_	011_8}');
    Expect(1, 3769, '\p{Is_Ccc=00000000118}', "");
    Expect(0, 3769, '\p{^Is_Ccc=00000000118}', "");
    Expect(0, 3769, '\P{Is_Ccc=00000000118}', "");
    Expect(1, 3769, '\P{^Is_Ccc=00000000118}', "");
    Expect(0, 3770, '\p{Is_Ccc=00000000118}', "");
    Expect(1, 3770, '\p{^Is_Ccc=00000000118}', "");
    Expect(1, 3770, '\P{Is_Ccc=00000000118}', "");
    Expect(0, 3770, '\P{^Is_Ccc=00000000118}', "");
    Error('\p{Canonical_Combining_Class= ccc12:=}');
    Error('\P{Canonical_Combining_Class= ccc12:=}');
    Expect(1, 1458, '\p{Canonical_Combining_Class=:\ACCC12\z:}', "");;
    Expect(0, 1459, '\p{Canonical_Combining_Class=:\ACCC12\z:}', "");;
    Expect(1, 1458, '\p{Canonical_Combining_Class=ccc12}', "");
    Expect(0, 1458, '\p{^Canonical_Combining_Class=ccc12}', "");
    Expect(0, 1458, '\P{Canonical_Combining_Class=ccc12}', "");
    Expect(1, 1458, '\P{^Canonical_Combining_Class=ccc12}', "");
    Expect(0, 1459, '\p{Canonical_Combining_Class=ccc12}', "");
    Expect(1, 1459, '\p{^Canonical_Combining_Class=ccc12}', "");
    Expect(1, 1459, '\P{Canonical_Combining_Class=ccc12}', "");
    Expect(0, 1459, '\P{^Canonical_Combining_Class=ccc12}', "");
    Expect(1, 1458, '\p{Canonical_Combining_Class=:\Accc12\z:}', "");;
    Expect(0, 1459, '\p{Canonical_Combining_Class=:\Accc12\z:}', "");;
    Expect(1, 1458, '\p{Canonical_Combining_Class=	CCC12}', "");
    Expect(0, 1458, '\p{^Canonical_Combining_Class=	CCC12}', "");
    Expect(0, 1458, '\P{Canonical_Combining_Class=	CCC12}', "");
    Expect(1, 1458, '\P{^Canonical_Combining_Class=	CCC12}', "");
    Expect(0, 1459, '\p{Canonical_Combining_Class=	CCC12}', "");
    Expect(1, 1459, '\p{^Canonical_Combining_Class=	CCC12}', "");
    Expect(1, 1459, '\P{Canonical_Combining_Class=	CCC12}', "");
    Expect(0, 1459, '\P{^Canonical_Combining_Class=	CCC12}', "");
    Error('\p{Ccc=/a/ +01_2}');
    Error('\P{Ccc=/a/ +01_2}');
    Expect(1, 1458, '\p{Ccc=:\A12\z:}', "");;
    Expect(0, 1459, '\p{Ccc=:\A12\z:}', "");;
    Expect(1, 1458, '\p{Ccc=012}', "");
    Expect(0, 1458, '\p{^Ccc=012}', "");
    Expect(0, 1458, '\P{Ccc=012}', "");
    Expect(1, 1458, '\P{^Ccc=012}', "");
    Expect(0, 1459, '\p{Ccc=012}', "");
    Expect(1, 1459, '\p{^Ccc=012}', "");
    Expect(1, 1459, '\P{Ccc=012}', "");
    Expect(0, 1459, '\P{^Ccc=012}', "");
    Error('\p{Is_Canonical_Combining_Class=	/a/CCC12}');
    Error('\P{Is_Canonical_Combining_Class=	/a/CCC12}');
    Expect(1, 1458, '\p{Is_Canonical_Combining_Class=ccc12}', "");
    Expect(0, 1458, '\p{^Is_Canonical_Combining_Class=ccc12}', "");
    Expect(0, 1458, '\P{Is_Canonical_Combining_Class=ccc12}', "");
    Expect(1, 1458, '\P{^Is_Canonical_Combining_Class=ccc12}', "");
    Expect(0, 1459, '\p{Is_Canonical_Combining_Class=ccc12}', "");
    Expect(1, 1459, '\p{^Is_Canonical_Combining_Class=ccc12}', "");
    Expect(1, 1459, '\P{Is_Canonical_Combining_Class=ccc12}', "");
    Expect(0, 1459, '\P{^Is_Canonical_Combining_Class=ccc12}', "");
    Expect(1, 1458, '\p{Is_Canonical_Combining_Class=-CCC12}', "");
    Expect(0, 1458, '\p{^Is_Canonical_Combining_Class=-CCC12}', "");
    Expect(0, 1458, '\P{Is_Canonical_Combining_Class=-CCC12}', "");
    Expect(1, 1458, '\P{^Is_Canonical_Combining_Class=-CCC12}', "");
    Expect(0, 1459, '\p{Is_Canonical_Combining_Class=-CCC12}', "");
    Expect(1, 1459, '\p{^Is_Canonical_Combining_Class=-CCC12}', "");
    Expect(1, 1459, '\P{Is_Canonical_Combining_Class=-CCC12}', "");
    Expect(0, 1459, '\P{^Is_Canonical_Combining_Class=-CCC12}', "");
    Error('\p{Is_Ccc:	_/a/000012}');
    Error('\P{Is_Ccc:	_/a/000012}');
    Expect(1, 1458, '\p{Is_Ccc=+00000012}', "");
    Expect(0, 1458, '\p{^Is_Ccc=+00000012}', "");
    Expect(0, 1458, '\P{Is_Ccc=+00000012}', "");
    Expect(1, 1458, '\P{^Is_Ccc=+00000012}', "");
    Expect(0, 1459, '\p{Is_Ccc=+00000012}', "");
    Expect(1, 1459, '\p{^Is_Ccc=+00000012}', "");
    Expect(1, 1459, '\P{Is_Ccc=+00000012}', "");
    Expect(0, 1459, '\P{^Is_Ccc=+00000012}', "");
    Error('\p{Canonical_Combining_Class=/a/__CCC122}');
    Error('\P{Canonical_Combining_Class=/a/__CCC122}');
    Expect(1, 3787, '\p{Canonical_Combining_Class=:\ACCC122\z:}', "");;
    Expect(0, 3788, '\p{Canonical_Combining_Class=:\ACCC122\z:}', "");;
    Expect(1, 3787, '\p{Canonical_Combining_Class=ccc122}', "");
    Expect(0, 3787, '\p{^Canonical_Combining_Class=ccc122}', "");
    Expect(0, 3787, '\P{Canonical_Combining_Class=ccc122}', "");
    Expect(1, 3787, '\P{^Canonical_Combining_Class=ccc122}', "");
    Expect(0, 3788, '\p{Canonical_Combining_Class=ccc122}', "");
    Expect(1, 3788, '\p{^Canonical_Combining_Class=ccc122}', "");
    Expect(1, 3788, '\P{Canonical_Combining_Class=ccc122}', "");
    Expect(0, 3788, '\P{^Canonical_Combining_Class=ccc122}', "");
    Expect(1, 3787, '\p{Canonical_Combining_Class=:\Accc122\z:}', "");;
    Expect(0, 3788, '\p{Canonical_Combining_Class=:\Accc122\z:}', "");;
    Expect(1, 3787, '\p{Canonical_Combining_Class:    -CCC122}', "");
    Expect(0, 3787, '\p{^Canonical_Combining_Class:    -CCC122}', "");
    Expect(0, 3787, '\P{Canonical_Combining_Class:    -CCC122}', "");
    Expect(1, 3787, '\P{^Canonical_Combining_Class:    -CCC122}', "");
    Expect(0, 3788, '\p{Canonical_Combining_Class:    -CCC122}', "");
    Expect(1, 3788, '\p{^Canonical_Combining_Class:    -CCC122}', "");
    Expect(1, 3788, '\P{Canonical_Combining_Class:    -CCC122}', "");
    Expect(0, 3788, '\P{^Canonical_Combining_Class:    -CCC122}', "");
    Error('\p{Ccc=-/a/0122}');
    Error('\P{Ccc=-/a/0122}');
    Expect(1, 3787, '\p{Ccc=:\A122\z:}', "");;
    Expect(0, 3788, '\p{Ccc=:\A122\z:}', "");;
    Expect(1, 3787, '\p{Ccc=+0_0_0_0_0_0_1_22}', "");
    Expect(0, 3787, '\p{^Ccc=+0_0_0_0_0_0_1_22}', "");
    Expect(0, 3787, '\P{Ccc=+0_0_0_0_0_0_1_22}', "");
    Expect(1, 3787, '\P{^Ccc=+0_0_0_0_0_0_1_22}', "");
    Expect(0, 3788, '\p{Ccc=+0_0_0_0_0_0_1_22}', "");
    Expect(1, 3788, '\p{^Ccc=+0_0_0_0_0_0_1_22}', "");
    Expect(1, 3788, '\P{Ccc=+0_0_0_0_0_0_1_22}', "");
    Expect(0, 3788, '\P{^Ccc=+0_0_0_0_0_0_1_22}', "");
    Error('\p{Is_Canonical_Combining_Class=:=	-CCC122}');
    Error('\P{Is_Canonical_Combining_Class=:=	-CCC122}');
    Expect(1, 3787, '\p{Is_Canonical_Combining_Class=ccc122}', "");
    Expect(0, 3787, '\p{^Is_Canonical_Combining_Class=ccc122}', "");
    Expect(0, 3787, '\P{Is_Canonical_Combining_Class=ccc122}', "");
    Expect(1, 3787, '\P{^Is_Canonical_Combining_Class=ccc122}', "");
    Expect(0, 3788, '\p{Is_Canonical_Combining_Class=ccc122}', "");
    Expect(1, 3788, '\p{^Is_Canonical_Combining_Class=ccc122}', "");
    Expect(1, 3788, '\P{Is_Canonical_Combining_Class=ccc122}', "");
    Expect(0, 3788, '\P{^Is_Canonical_Combining_Class=ccc122}', "");
    Expect(1, 3787, '\p{Is_Canonical_Combining_Class=  CCC122}', "");
    Expect(0, 3787, '\p{^Is_Canonical_Combining_Class=  CCC122}', "");
    Expect(0, 3787, '\P{Is_Canonical_Combining_Class=  CCC122}', "");
    Expect(1, 3787, '\P{^Is_Canonical_Combining_Class=  CCC122}', "");
    Expect(0, 3788, '\p{Is_Canonical_Combining_Class=  CCC122}', "");
    Expect(1, 3788, '\p{^Is_Canonical_Combining_Class=  CCC122}', "");
    Expect(1, 3788, '\P{Is_Canonical_Combining_Class=  CCC122}', "");
    Expect(0, 3788, '\P{^Is_Canonical_Combining_Class=  CCC122}', "");
    Error('\p{Is_Ccc=_/a/0_0_1_22}');
    Error('\P{Is_Ccc=_/a/0_0_1_22}');
    Expect(1, 3787, '\p{Is_Ccc=+0000122}', "");
    Expect(0, 3787, '\p{^Is_Ccc=+0000122}', "");
    Expect(0, 3787, '\P{Is_Ccc=+0000122}', "");
    Expect(1, 3787, '\P{^Is_Ccc=+0000122}', "");
    Expect(0, 3788, '\p{Is_Ccc=+0000122}', "");
    Expect(1, 3788, '\p{^Is_Ccc=+0000122}', "");
    Expect(1, 3788, '\P{Is_Ccc=+0000122}', "");
    Expect(0, 3788, '\P{^Is_Ccc=+0000122}', "");
    Error('\p{Canonical_Combining_Class=_/a/CCC129}');
    Error('\P{Canonical_Combining_Class=_/a/CCC129}');
    Expect(1, 3953, '\p{Canonical_Combining_Class=:\ACCC129\z:}', "");;
    Expect(0, 3954, '\p{Canonical_Combining_Class=:\ACCC129\z:}', "");;
    Expect(1, 3953, '\p{Canonical_Combining_Class=ccc129}', "");
    Expect(0, 3953, '\p{^Canonical_Combining_Class=ccc129}', "");
    Expect(0, 3953, '\P{Canonical_Combining_Class=ccc129}', "");
    Expect(1, 3953, '\P{^Canonical_Combining_Class=ccc129}', "");
    Expect(0, 3954, '\p{Canonical_Combining_Class=ccc129}', "");
    Expect(1, 3954, '\p{^Canonical_Combining_Class=ccc129}', "");
    Expect(1, 3954, '\P{Canonical_Combining_Class=ccc129}', "");
    Expect(0, 3954, '\P{^Canonical_Combining_Class=ccc129}', "");
    Expect(1, 3953, '\p{Canonical_Combining_Class=:\Accc129\z:}', "");;
    Expect(0, 3954, '\p{Canonical_Combining_Class=:\Accc129\z:}', "");;
    Expect(1, 3953, '\p{Canonical_Combining_Class= CCC129}', "");
    Expect(0, 3953, '\p{^Canonical_Combining_Class= CCC129}', "");
    Expect(0, 3953, '\P{Canonical_Combining_Class= CCC129}', "");
    Expect(1, 3953, '\P{^Canonical_Combining_Class= CCC129}', "");
    Expect(0, 3954, '\p{Canonical_Combining_Class= CCC129}', "");
    Expect(1, 3954, '\p{^Canonical_Combining_Class= CCC129}', "");
    Expect(1, 3954, '\P{Canonical_Combining_Class= CCC129}', "");
    Expect(0, 3954, '\P{^Canonical_Combining_Class= CCC129}', "");
    Error('\p{Ccc=--000000000129:=}');
    Error('\P{Ccc=--000000000129:=}');
    Expect(1, 3953, '\p{Ccc=:\A129\z:}', "");;
    Expect(0, 3954, '\p{Ccc=:\A129\z:}', "");;
    Expect(1, 3953, '\p{Ccc=00000000129}', "");
    Expect(0, 3953, '\p{^Ccc=00000000129}', "");
    Expect(0, 3953, '\P{Ccc=00000000129}', "");
    Expect(1, 3953, '\P{^Ccc=00000000129}', "");
    Expect(0, 3954, '\p{Ccc=00000000129}', "");
    Expect(1, 3954, '\p{^Ccc=00000000129}', "");
    Expect(1, 3954, '\P{Ccc=00000000129}', "");
    Expect(0, 3954, '\P{^Ccc=00000000129}', "");
    Error('\p{Is_Canonical_Combining_Class: /a/	_ccc129}');
    Error('\P{Is_Canonical_Combining_Class: /a/	_ccc129}');
    Expect(1, 3953, '\p{Is_Canonical_Combining_Class: ccc129}', "");
    Expect(0, 3953, '\p{^Is_Canonical_Combining_Class: ccc129}', "");
    Expect(0, 3953, '\P{Is_Canonical_Combining_Class: ccc129}', "");
    Expect(1, 3953, '\P{^Is_Canonical_Combining_Class: ccc129}', "");
    Expect(0, 3954, '\p{Is_Canonical_Combining_Class: ccc129}', "");
    Expect(1, 3954, '\p{^Is_Canonical_Combining_Class: ccc129}', "");
    Expect(1, 3954, '\P{Is_Canonical_Combining_Class: ccc129}', "");
    Expect(0, 3954, '\P{^Is_Canonical_Combining_Class: ccc129}', "");
    Expect(1, 3953, '\p{Is_Canonical_Combining_Class= 	CCC129}', "");
    Expect(0, 3953, '\p{^Is_Canonical_Combining_Class= 	CCC129}', "");
    Expect(0, 3953, '\P{Is_Canonical_Combining_Class= 	CCC129}', "");
    Expect(1, 3953, '\P{^Is_Canonical_Combining_Class= 	CCC129}', "");
    Expect(0, 3954, '\p{Is_Canonical_Combining_Class= 	CCC129}', "");
    Expect(1, 3954, '\p{^Is_Canonical_Combining_Class= 	CCC129}', "");
    Expect(1, 3954, '\P{Is_Canonical_Combining_Class= 	CCC129}', "");
    Expect(0, 3954, '\P{^Is_Canonical_Combining_Class= 	CCC129}', "");
    Error('\p{Is_Ccc=:=_-0129}');
    Error('\P{Is_Ccc=:=_-0129}');
    Expect(1, 3953, '\p{Is_Ccc=+00000000129}', "");
    Expect(0, 3953, '\p{^Is_Ccc=+00000000129}', "");
    Expect(0, 3953, '\P{Is_Ccc=+00000000129}', "");
    Expect(1, 3953, '\P{^Is_Ccc=+00000000129}', "");
    Expect(0, 3954, '\p{Is_Ccc=+00000000129}', "");
    Expect(1, 3954, '\p{^Is_Ccc=+00000000129}', "");
    Expect(1, 3954, '\P{Is_Ccc=+00000000129}', "");
    Expect(0, 3954, '\P{^Is_Ccc=+00000000129}', "");
    Error('\p{Canonical_Combining_Class=:= -CCC13}');
    Error('\P{Canonical_Combining_Class=:= -CCC13}');
    Expect(1, 1459, '\p{Canonical_Combining_Class=:\ACCC13\z:}', "");;
    Expect(0, 1460, '\p{Canonical_Combining_Class=:\ACCC13\z:}', "");;
    Expect(1, 1459, '\p{Canonical_Combining_Class=ccc13}', "");
    Expect(0, 1459, '\p{^Canonical_Combining_Class=ccc13}', "");
    Expect(0, 1459, '\P{Canonical_Combining_Class=ccc13}', "");
    Expect(1, 1459, '\P{^Canonical_Combining_Class=ccc13}', "");
    Expect(0, 1460, '\p{Canonical_Combining_Class=ccc13}', "");
    Expect(1, 1460, '\p{^Canonical_Combining_Class=ccc13}', "");
    Expect(1, 1460, '\P{Canonical_Combining_Class=ccc13}', "");
    Expect(0, 1460, '\P{^Canonical_Combining_Class=ccc13}', "");
    Expect(1, 1459, '\p{Canonical_Combining_Class=:\Accc13\z:}', "");;
    Expect(0, 1460, '\p{Canonical_Combining_Class=:\Accc13\z:}', "");;
    Expect(1, 1459, '\p{Canonical_Combining_Class=-_CCC13}', "");
    Expect(0, 1459, '\p{^Canonical_Combining_Class=-_CCC13}', "");
    Expect(0, 1459, '\P{Canonical_Combining_Class=-_CCC13}', "");
    Expect(1, 1459, '\P{^Canonical_Combining_Class=-_CCC13}', "");
    Expect(0, 1460, '\p{Canonical_Combining_Class=-_CCC13}', "");
    Expect(1, 1460, '\p{^Canonical_Combining_Class=-_CCC13}', "");
    Expect(1, 1460, '\P{Canonical_Combining_Class=-_CCC13}', "");
    Expect(0, 1460, '\P{^Canonical_Combining_Class=-_CCC13}', "");
    Error('\p{Ccc=-/a/00_00_00_13}');
    Error('\P{Ccc=-/a/00_00_00_13}');
    Expect(1, 1459, '\p{Ccc=:\A13\z:}', "");;
    Expect(0, 1460, '\p{Ccc=:\A13\z:}', "");;
    Expect(1, 1459, '\p{Ccc=+0_0_0_0_0_0_0_13}', "");
    Expect(0, 1459, '\p{^Ccc=+0_0_0_0_0_0_0_13}', "");
    Expect(0, 1459, '\P{Ccc=+0_0_0_0_0_0_0_13}', "");
    Expect(1, 1459, '\P{^Ccc=+0_0_0_0_0_0_0_13}', "");
    Expect(0, 1460, '\p{Ccc=+0_0_0_0_0_0_0_13}', "");
    Expect(1, 1460, '\p{^Ccc=+0_0_0_0_0_0_0_13}', "");
    Expect(1, 1460, '\P{Ccc=+0_0_0_0_0_0_0_13}', "");
    Expect(0, 1460, '\P{^Ccc=+0_0_0_0_0_0_0_13}', "");
    Error('\p{Is_Canonical_Combining_Class= _CCC13/a/}');
    Error('\P{Is_Canonical_Combining_Class= _CCC13/a/}');
    Expect(1, 1459, '\p{Is_Canonical_Combining_Class=ccc13}', "");
    Expect(0, 1459, '\p{^Is_Canonical_Combining_Class=ccc13}', "");
    Expect(0, 1459, '\P{Is_Canonical_Combining_Class=ccc13}', "");
    Expect(1, 1459, '\P{^Is_Canonical_Combining_Class=ccc13}', "");
    Expect(0, 1460, '\p{Is_Canonical_Combining_Class=ccc13}', "");
    Expect(1, 1460, '\p{^Is_Canonical_Combining_Class=ccc13}', "");
    Expect(1, 1460, '\P{Is_Canonical_Combining_Class=ccc13}', "");
    Expect(0, 1460, '\P{^Is_Canonical_Combining_Class=ccc13}', "");
    Expect(1, 1459, '\p{Is_Canonical_Combining_Class:- CCC13}', "");
    Expect(0, 1459, '\p{^Is_Canonical_Combining_Class:- CCC13}', "");
    Expect(0, 1459, '\P{Is_Canonical_Combining_Class:- CCC13}', "");
    Expect(1, 1459, '\P{^Is_Canonical_Combining_Class:- CCC13}', "");
    Expect(0, 1460, '\p{Is_Canonical_Combining_Class:- CCC13}', "");
    Expect(1, 1460, '\p{^Is_Canonical_Combining_Class:- CCC13}', "");
    Expect(1, 1460, '\P{Is_Canonical_Combining_Class:- CCC13}', "");
    Expect(0, 1460, '\P{^Is_Canonical_Combining_Class:- CCC13}', "");
    Error('\p{Is_Ccc=	_00000013/a/}');
    Error('\P{Is_Ccc=	_00000013/a/}');
    Expect(1, 1459, '\p{Is_Ccc=0_0_0_0_13}', "");
    Expect(0, 1459, '\p{^Is_Ccc=0_0_0_0_13}', "");
    Expect(0, 1459, '\P{Is_Ccc=0_0_0_0_13}', "");
    Expect(1, 1459, '\P{^Is_Ccc=0_0_0_0_13}', "");
    Expect(0, 1460, '\p{Is_Ccc=0_0_0_0_13}', "");
    Expect(1, 1460, '\p{^Is_Ccc=0_0_0_0_13}', "");
    Expect(1, 1460, '\P{Is_Ccc=0_0_0_0_13}', "");
    Expect(0, 1460, '\P{^Is_Ccc=0_0_0_0_13}', "");
    Error('\p{Canonical_Combining_Class= 	ccc130:=}');
    Error('\P{Canonical_Combining_Class= 	ccc130:=}');
    Expect(1, 3968, '\p{Canonical_Combining_Class=:\ACCC130\z:}', "");;
    Expect(0, 3969, '\p{Canonical_Combining_Class=:\ACCC130\z:}', "");;
    Expect(1, 3968, '\p{Canonical_Combining_Class=ccc130}', "");
    Expect(0, 3968, '\p{^Canonical_Combining_Class=ccc130}', "");
    Expect(0, 3968, '\P{Canonical_Combining_Class=ccc130}', "");
    Expect(1, 3968, '\P{^Canonical_Combining_Class=ccc130}', "");
    Expect(0, 3969, '\p{Canonical_Combining_Class=ccc130}', "");
    Expect(1, 3969, '\p{^Canonical_Combining_Class=ccc130}', "");
    Expect(1, 3969, '\P{Canonical_Combining_Class=ccc130}', "");
    Expect(0, 3969, '\P{^Canonical_Combining_Class=ccc130}', "");
    Expect(1, 3968, '\p{Canonical_Combining_Class=:\Accc130\z:}', "");;
    Expect(0, 3969, '\p{Canonical_Combining_Class=:\Accc130\z:}', "");;
    Expect(1, 3968, '\p{Canonical_Combining_Class:   	ccc130}', "");
    Expect(0, 3968, '\p{^Canonical_Combining_Class:   	ccc130}', "");
    Expect(0, 3968, '\P{Canonical_Combining_Class:   	ccc130}', "");
    Expect(1, 3968, '\P{^Canonical_Combining_Class:   	ccc130}', "");
    Expect(0, 3969, '\p{Canonical_Combining_Class:   	ccc130}', "");
    Expect(1, 3969, '\p{^Canonical_Combining_Class:   	ccc130}', "");
    Expect(1, 3969, '\P{Canonical_Combining_Class:   	ccc130}', "");
    Expect(0, 3969, '\P{^Canonical_Combining_Class:   	ccc130}', "");
    Error('\p{Ccc=-_0_0_0_0_0_130/a/}');
    Error('\P{Ccc=-_0_0_0_0_0_130/a/}');
    Expect(1, 3968, '\p{Ccc=:\A130\z:}', "");;
    Expect(0, 3969, '\p{Ccc=:\A130\z:}', "");;
    Expect(1, 3968, '\p{Ccc=130}', "");
    Expect(0, 3968, '\p{^Ccc=130}', "");
    Expect(0, 3968, '\P{Ccc=130}', "");
    Expect(1, 3968, '\P{^Ccc=130}', "");
    Expect(0, 3969, '\p{Ccc=130}', "");
    Expect(1, 3969, '\p{^Ccc=130}', "");
    Expect(1, 3969, '\P{Ccc=130}', "");
    Expect(0, 3969, '\P{^Ccc=130}', "");
    Error('\p{Is_Canonical_Combining_Class:    	CCC130:=}');
    Error('\P{Is_Canonical_Combining_Class:    	CCC130:=}');
    Expect(1, 3968, '\p{Is_Canonical_Combining_Class=ccc130}', "");
    Expect(0, 3968, '\p{^Is_Canonical_Combining_Class=ccc130}', "");
    Expect(0, 3968, '\P{Is_Canonical_Combining_Class=ccc130}', "");
    Expect(1, 3968, '\P{^Is_Canonical_Combining_Class=ccc130}', "");
    Expect(0, 3969, '\p{Is_Canonical_Combining_Class=ccc130}', "");
    Expect(1, 3969, '\p{^Is_Canonical_Combining_Class=ccc130}', "");
    Expect(1, 3969, '\P{Is_Canonical_Combining_Class=ccc130}', "");
    Expect(0, 3969, '\P{^Is_Canonical_Combining_Class=ccc130}', "");
    Expect(1, 3968, '\p{Is_Canonical_Combining_Class=	-CCC130}', "");
    Expect(0, 3968, '\p{^Is_Canonical_Combining_Class=	-CCC130}', "");
    Expect(0, 3968, '\P{Is_Canonical_Combining_Class=	-CCC130}', "");
    Expect(1, 3968, '\P{^Is_Canonical_Combining_Class=	-CCC130}', "");
    Expect(0, 3969, '\p{Is_Canonical_Combining_Class=	-CCC130}', "");
    Expect(1, 3969, '\p{^Is_Canonical_Combining_Class=	-CCC130}', "");
    Expect(1, 3969, '\P{Is_Canonical_Combining_Class=	-CCC130}', "");
    Expect(0, 3969, '\P{^Is_Canonical_Combining_Class=	-CCC130}', "");
    Error('\p{Is_Ccc=:=	-000130}');
    Error('\P{Is_Ccc=:=	-000130}');
    Expect(1, 3968, '\p{Is_Ccc=+0130}', "");
    Expect(0, 3968, '\p{^Is_Ccc=+0130}', "");
    Expect(0, 3968, '\P{Is_Ccc=+0130}', "");
    Expect(1, 3968, '\P{^Is_Ccc=+0130}', "");
    Expect(0, 3969, '\p{Is_Ccc=+0130}', "");
    Expect(1, 3969, '\p{^Is_Ccc=+0130}', "");
    Expect(1, 3969, '\P{Is_Ccc=+0130}', "");
    Expect(0, 3969, '\P{^Is_Ccc=+0130}', "");
    Error('\p{Canonical_Combining_Class=/a/	 CCC132}');
    Error('\P{Canonical_Combining_Class=/a/	 CCC132}');
    Expect(1, 3956, '\p{Canonical_Combining_Class=:\ACCC132\z:}', "");;
    Expect(0, 3957, '\p{Canonical_Combining_Class=:\ACCC132\z:}', "");;
    Expect(1, 3956, '\p{Canonical_Combining_Class=ccc132}', "");
    Expect(0, 3956, '\p{^Canonical_Combining_Class=ccc132}', "");
    Expect(0, 3956, '\P{Canonical_Combining_Class=ccc132}', "");
    Expect(1, 3956, '\P{^Canonical_Combining_Class=ccc132}', "");
    Expect(0, 3957, '\p{Canonical_Combining_Class=ccc132}', "");
    Expect(1, 3957, '\p{^Canonical_Combining_Class=ccc132}', "");
    Expect(1, 3957, '\P{Canonical_Combining_Class=ccc132}', "");
    Expect(0, 3957, '\P{^Canonical_Combining_Class=ccc132}', "");
    Expect(1, 3956, '\p{Canonical_Combining_Class=:\Accc132\z:}', "");;
    Expect(0, 3957, '\p{Canonical_Combining_Class=:\Accc132\z:}', "");;
    Expect(1, 3956, '\p{Canonical_Combining_Class:   _	CCC132}', "");
    Expect(0, 3956, '\p{^Canonical_Combining_Class:   _	CCC132}', "");
    Expect(0, 3956, '\P{Canonical_Combining_Class:   _	CCC132}', "");
    Expect(1, 3956, '\P{^Canonical_Combining_Class:   _	CCC132}', "");
    Expect(0, 3957, '\p{Canonical_Combining_Class:   _	CCC132}', "");
    Expect(1, 3957, '\p{^Canonical_Combining_Class:   _	CCC132}', "");
    Expect(1, 3957, '\P{Canonical_Combining_Class:   _	CCC132}', "");
    Expect(0, 3957, '\P{^Canonical_Combining_Class:   _	CCC132}', "");
    Error('\p{Ccc:/a/+0_0_1_32}');
    Error('\P{Ccc:/a/+0_0_1_32}');
    Expect(1, 3956, '\p{Ccc=:\A132\z:}', "");;
    Expect(0, 3957, '\p{Ccc=:\A132\z:}', "");;
    Expect(1, 3956, '\p{Ccc=00000000013_2}', "");
    Expect(0, 3956, '\p{^Ccc=00000000013_2}', "");
    Expect(0, 3956, '\P{Ccc=00000000013_2}', "");
    Expect(1, 3956, '\P{^Ccc=00000000013_2}', "");
    Expect(0, 3957, '\p{Ccc=00000000013_2}', "");
    Expect(1, 3957, '\p{^Ccc=00000000013_2}', "");
    Expect(1, 3957, '\P{Ccc=00000000013_2}', "");
    Expect(0, 3957, '\P{^Ccc=00000000013_2}', "");
    Error('\p{Is_Canonical_Combining_Class=	 ccc132/a/}');
    Error('\P{Is_Canonical_Combining_Class=	 ccc132/a/}');
    Expect(1, 3956, '\p{Is_Canonical_Combining_Class:   ccc132}', "");
    Expect(0, 3956, '\p{^Is_Canonical_Combining_Class:   ccc132}', "");
    Expect(0, 3956, '\P{Is_Canonical_Combining_Class:   ccc132}', "");
    Expect(1, 3956, '\P{^Is_Canonical_Combining_Class:   ccc132}', "");
    Expect(0, 3957, '\p{Is_Canonical_Combining_Class:   ccc132}', "");
    Expect(1, 3957, '\p{^Is_Canonical_Combining_Class:   ccc132}', "");
    Expect(1, 3957, '\P{Is_Canonical_Combining_Class:   ccc132}', "");
    Expect(0, 3957, '\P{^Is_Canonical_Combining_Class:   ccc132}', "");
    Expect(1, 3956, '\p{Is_Canonical_Combining_Class=  ccc132}', "");
    Expect(0, 3956, '\p{^Is_Canonical_Combining_Class=  ccc132}', "");
    Expect(0, 3956, '\P{Is_Canonical_Combining_Class=  ccc132}', "");
    Expect(1, 3956, '\P{^Is_Canonical_Combining_Class=  ccc132}', "");
    Expect(0, 3957, '\p{Is_Canonical_Combining_Class=  ccc132}', "");
    Expect(1, 3957, '\p{^Is_Canonical_Combining_Class=  ccc132}', "");
    Expect(1, 3957, '\P{Is_Canonical_Combining_Class=  ccc132}', "");
    Expect(0, 3957, '\P{^Is_Canonical_Combining_Class=  ccc132}', "");
    Error('\p{Is_Ccc=:= 00000000132}');
    Error('\P{Is_Ccc=:= 00000000132}');
    Expect(1, 3956, '\p{Is_Ccc=00_00_00_00_0132}', "");
    Expect(0, 3956, '\p{^Is_Ccc=00_00_00_00_0132}', "");
    Expect(0, 3956, '\P{Is_Ccc=00_00_00_00_0132}', "");
    Expect(1, 3956, '\P{^Is_Ccc=00_00_00_00_0132}', "");
    Expect(0, 3957, '\p{Is_Ccc=00_00_00_00_0132}', "");
    Expect(1, 3957, '\p{^Is_Ccc=00_00_00_00_0132}', "");
    Expect(1, 3957, '\P{Is_Ccc=00_00_00_00_0132}', "");
    Expect(0, 3957, '\P{^Is_Ccc=00_00_00_00_0132}', "");
    Error('\p{Canonical_Combining_Class=:= CCC133}');
    Error('\P{Canonical_Combining_Class=:= CCC133}');
    Expect(0, 1, '\p{Canonical_Combining_Class=:\ACCC133\z:}', "");;
    Expect(0, 1, '\p{Canonical_Combining_Class:	ccc133}', "");
    Expect(1, 1, '\p{^Canonical_Combining_Class:	ccc133}', "");
    Expect(1, 1, '\P{Canonical_Combining_Class:	ccc133}', "");
    Expect(0, 1, '\P{^Canonical_Combining_Class:	ccc133}', "");
    Expect(0, 1, '\p{Canonical_Combining_Class=:\Accc133\z:}', "");;
    Expect(0, 1, '\p{Canonical_Combining_Class=_ ccc133}', "");
    Expect(1, 1, '\p{^Canonical_Combining_Class=_ ccc133}', "");
    Expect(1, 1, '\P{Canonical_Combining_Class=_ ccc133}', "");
    Expect(0, 1, '\P{^Canonical_Combining_Class=_ ccc133}', "");
    Error('\p{Ccc= 000000000133:=}');
    Error('\P{Ccc= 000000000133:=}');
    Expect(0, 1, '\p{Ccc=:\A133\z:}', "");;
    Expect(0, 1, '\p{Ccc=00000133}', "");
    Expect(1, 1, '\p{^Ccc=00000133}', "");
    Expect(1, 1, '\P{Ccc=00000133}', "");
    Expect(0, 1, '\P{^Ccc=00000133}', "");
    Error('\p{Is_Canonical_Combining_Class=-:=CCC133}');
    Error('\P{Is_Canonical_Combining_Class=-:=CCC133}');
    Expect(0, 1, '\p{Is_Canonical_Combining_Class=ccc133}', "");
    Expect(1, 1, '\p{^Is_Canonical_Combining_Class=ccc133}', "");
    Expect(1, 1, '\P{Is_Canonical_Combining_Class=ccc133}', "");
    Expect(0, 1, '\P{^Is_Canonical_Combining_Class=ccc133}', "");
    Expect(0, 1, '\p{Is_Canonical_Combining_Class=_ CCC133}', "");
    Expect(1, 1, '\p{^Is_Canonical_Combining_Class=_ CCC133}', "");
    Expect(1, 1, '\P{Is_Canonical_Combining_Class=_ CCC133}', "");
    Expect(0, 1, '\P{^Is_Canonical_Combining_Class=_ CCC133}', "");
    Error('\p{Is_Ccc=:=-	00133}');
    Error('\P{Is_Ccc=:=-	00133}');
    Expect(0, 1, '\p{Is_Ccc=0000133}', "");
    Expect(1, 1, '\p{^Is_Ccc=0000133}', "");
    Expect(1, 1, '\P{Is_Ccc=0000133}', "");
    Expect(0, 1, '\P{^Is_Ccc=0000133}', "");
    Error('\p{Canonical_Combining_Class: _/a/CCC14}');
    Error('\P{Canonical_Combining_Class: _/a/CCC14}');
    Expect(1, 1460, '\p{Canonical_Combining_Class=:\ACCC14\z:}', "");;
    Expect(0, 1461, '\p{Canonical_Combining_Class=:\ACCC14\z:}', "");;
    Expect(1, 1460, '\p{Canonical_Combining_Class=ccc14}', "");
    Expect(0, 1460, '\p{^Canonical_Combining_Class=ccc14}', "");
    Expect(0, 1460, '\P{Canonical_Combining_Class=ccc14}', "");
    Expect(1, 1460, '\P{^Canonical_Combining_Class=ccc14}', "");
    Expect(0, 1461, '\p{Canonical_Combining_Class=ccc14}', "");
    Expect(1, 1461, '\p{^Canonical_Combining_Class=ccc14}', "");
    Expect(1, 1461, '\P{Canonical_Combining_Class=ccc14}', "");
    Expect(0, 1461, '\P{^Canonical_Combining_Class=ccc14}', "");
    Expect(1, 1460, '\p{Canonical_Combining_Class=:\Accc14\z:}', "");;
    Expect(0, 1461, '\p{Canonical_Combining_Class=:\Accc14\z:}', "");;
    Expect(1, 1460, '\p{Canonical_Combining_Class= 	CCC14}', "");
    Expect(0, 1460, '\p{^Canonical_Combining_Class= 	CCC14}', "");
    Expect(0, 1460, '\P{Canonical_Combining_Class= 	CCC14}', "");
    Expect(1, 1460, '\P{^Canonical_Combining_Class= 	CCC14}', "");
    Expect(0, 1461, '\p{Canonical_Combining_Class= 	CCC14}', "");
    Expect(1, 1461, '\p{^Canonical_Combining_Class= 	CCC14}', "");
    Expect(1, 1461, '\P{Canonical_Combining_Class= 	CCC14}', "");
    Expect(0, 1461, '\P{^Canonical_Combining_Class= 	CCC14}', "");
    Error('\p{Ccc=_	00000014/a/}');
    Error('\P{Ccc=_	00000014/a/}');
    Expect(1, 1460, '\p{Ccc=:\A14\z:}', "");;
    Expect(0, 1461, '\p{Ccc=:\A14\z:}', "");;
    Expect(1, 1460, '\p{Ccc=0000000014}', "");
    Expect(0, 1460, '\p{^Ccc=0000000014}', "");
    Expect(0, 1460, '\P{Ccc=0000000014}', "");
    Expect(1, 1460, '\P{^Ccc=0000000014}', "");
    Expect(0, 1461, '\p{Ccc=0000000014}', "");
    Expect(1, 1461, '\p{^Ccc=0000000014}', "");
    Expect(1, 1461, '\P{Ccc=0000000014}', "");
    Expect(0, 1461, '\P{^Ccc=0000000014}', "");
    Error('\p{Is_Canonical_Combining_Class=_ccc14:=}');
    Error('\P{Is_Canonical_Combining_Class=_ccc14:=}');
    Expect(1, 1460, '\p{Is_Canonical_Combining_Class=ccc14}', "");
    Expect(0, 1460, '\p{^Is_Canonical_Combining_Class=ccc14}', "");
    Expect(0, 1460, '\P{Is_Canonical_Combining_Class=ccc14}', "");
    Expect(1, 1460, '\P{^Is_Canonical_Combining_Class=ccc14}', "");
    Expect(0, 1461, '\p{Is_Canonical_Combining_Class=ccc14}', "");
    Expect(1, 1461, '\p{^Is_Canonical_Combining_Class=ccc14}', "");
    Expect(1, 1461, '\P{Is_Canonical_Combining_Class=ccc14}', "");
    Expect(0, 1461, '\P{^Is_Canonical_Combining_Class=ccc14}', "");
    Expect(1, 1460, '\p{Is_Canonical_Combining_Class=__ccc14}', "");
    Expect(0, 1460, '\p{^Is_Canonical_Combining_Class=__ccc14}', "");
    Expect(0, 1460, '\P{Is_Canonical_Combining_Class=__ccc14}', "");
    Expect(1, 1460, '\P{^Is_Canonical_Combining_Class=__ccc14}', "");
    Expect(0, 1461, '\p{Is_Canonical_Combining_Class=__ccc14}', "");
    Expect(1, 1461, '\p{^Is_Canonical_Combining_Class=__ccc14}', "");
    Expect(1, 1461, '\P{Is_Canonical_Combining_Class=__ccc14}', "");
    Expect(0, 1461, '\P{^Is_Canonical_Combining_Class=__ccc14}', "");
    Error('\p{Is_Ccc:   	_0000014:=}');
    Error('\P{Is_Ccc:   	_0000014:=}');
    Expect(1, 1460, '\p{Is_Ccc: 0_0_0_0_0_0_0_014}', "");
    Expect(0, 1460, '\p{^Is_Ccc: 0_0_0_0_0_0_0_014}', "");
    Expect(0, 1460, '\P{Is_Ccc: 0_0_0_0_0_0_0_014}', "");
    Expect(1, 1460, '\P{^Is_Ccc: 0_0_0_0_0_0_0_014}', "");
    Expect(0, 1461, '\p{Is_Ccc: 0_0_0_0_0_0_0_014}', "");
    Expect(1, 1461, '\p{^Is_Ccc: 0_0_0_0_0_0_0_014}', "");
    Expect(1, 1461, '\P{Is_Ccc: 0_0_0_0_0_0_0_014}', "");
    Expect(0, 1461, '\P{^Is_Ccc: 0_0_0_0_0_0_0_014}', "");
    Error('\p{Canonical_Combining_Class=_:=CCC15}');
    Error('\P{Canonical_Combining_Class=_:=CCC15}');
    Expect(1, 1461, '\p{Canonical_Combining_Class=:\ACCC15\z:}', "");;
    Expect(0, 1462, '\p{Canonical_Combining_Class=:\ACCC15\z:}', "");;
    Expect(1, 1461, '\p{Canonical_Combining_Class=ccc15}', "");
    Expect(0, 1461, '\p{^Canonical_Combining_Class=ccc15}', "");
    Expect(0, 1461, '\P{Canonical_Combining_Class=ccc15}', "");
    Expect(1, 1461, '\P{^Canonical_Combining_Class=ccc15}', "");
    Expect(0, 1462, '\p{Canonical_Combining_Class=ccc15}', "");
    Expect(1, 1462, '\p{^Canonical_Combining_Class=ccc15}', "");
    Expect(1, 1462, '\P{Canonical_Combining_Class=ccc15}', "");
    Expect(0, 1462, '\P{^Canonical_Combining_Class=ccc15}', "");
    Expect(1, 1461, '\p{Canonical_Combining_Class=:\Accc15\z:}', "");;
    Expect(0, 1462, '\p{Canonical_Combining_Class=:\Accc15\z:}', "");;
    Expect(1, 1461, '\p{Canonical_Combining_Class=-_CCC15}', "");
    Expect(0, 1461, '\p{^Canonical_Combining_Class=-_CCC15}', "");
    Expect(0, 1461, '\P{Canonical_Combining_Class=-_CCC15}', "");
    Expect(1, 1461, '\P{^Canonical_Combining_Class=-_CCC15}', "");
    Expect(0, 1462, '\p{Canonical_Combining_Class=-_CCC15}', "");
    Expect(1, 1462, '\p{^Canonical_Combining_Class=-_CCC15}', "");
    Expect(1, 1462, '\P{Canonical_Combining_Class=-_CCC15}', "");
    Expect(0, 1462, '\P{^Canonical_Combining_Class=-_CCC15}', "");
    Error('\p{Ccc=-/a/0000000015}');
    Error('\P{Ccc=-/a/0000000015}');
    Expect(1, 1461, '\p{Ccc=:\A15\z:}', "");;
    Expect(0, 1462, '\p{Ccc=:\A15\z:}', "");;
    Expect(1, 1461, '\p{Ccc=001_5}', "");
    Expect(0, 1461, '\p{^Ccc=001_5}', "");
    Expect(0, 1461, '\P{Ccc=001_5}', "");
    Expect(1, 1461, '\P{^Ccc=001_5}', "");
    Expect(0, 1462, '\p{Ccc=001_5}', "");
    Expect(1, 1462, '\p{^Ccc=001_5}', "");
    Expect(1, 1462, '\P{Ccc=001_5}', "");
    Expect(0, 1462, '\P{^Ccc=001_5}', "");
    Error('\p{Is_Canonical_Combining_Class=_:=CCC15}');
    Error('\P{Is_Canonical_Combining_Class=_:=CCC15}');
    Expect(1, 1461, '\p{Is_Canonical_Combining_Class=ccc15}', "");
    Expect(0, 1461, '\p{^Is_Canonical_Combining_Class=ccc15}', "");
    Expect(0, 1461, '\P{Is_Canonical_Combining_Class=ccc15}', "");
    Expect(1, 1461, '\P{^Is_Canonical_Combining_Class=ccc15}', "");
    Expect(0, 1462, '\p{Is_Canonical_Combining_Class=ccc15}', "");
    Expect(1, 1462, '\p{^Is_Canonical_Combining_Class=ccc15}', "");
    Expect(1, 1462, '\P{Is_Canonical_Combining_Class=ccc15}', "");
    Expect(0, 1462, '\P{^Is_Canonical_Combining_Class=ccc15}', "");
    Expect(1, 1461, '\p{Is_Canonical_Combining_Class= _CCC15}', "");
    Expect(0, 1461, '\p{^Is_Canonical_Combining_Class= _CCC15}', "");
    Expect(0, 1461, '\P{Is_Canonical_Combining_Class= _CCC15}', "");
    Expect(1, 1461, '\P{^Is_Canonical_Combining_Class= _CCC15}', "");
    Expect(0, 1462, '\p{Is_Canonical_Combining_Class= _CCC15}', "");
    Expect(1, 1462, '\p{^Is_Canonical_Combining_Class= _CCC15}', "");
    Expect(1, 1462, '\P{Is_Canonical_Combining_Class= _CCC15}', "");
    Expect(0, 1462, '\P{^Is_Canonical_Combining_Class= _CCC15}', "");
    Error('\p{Is_Ccc=	+15:=}');
    Error('\P{Is_Ccc=	+15:=}');
    Expect(1, 1461, '\p{Is_Ccc=0000015}', "");
    Expect(0, 1461, '\p{^Is_Ccc=0000015}', "");
    Expect(0, 1461, '\P{Is_Ccc=0000015}', "");
    Expect(1, 1461, '\P{^Is_Ccc=0000015}', "");
    Expect(0, 1462, '\p{Is_Ccc=0000015}', "");
    Expect(1, 1462, '\p{^Is_Ccc=0000015}', "");
    Expect(1, 1462, '\P{Is_Ccc=0000015}', "");
    Expect(0, 1462, '\P{^Is_Ccc=0000015}', "");
    Error('\p{Canonical_Combining_Class= CCC16/a/}');
    Error('\P{Canonical_Combining_Class= CCC16/a/}');
    Expect(1, 1462, '\p{Canonical_Combining_Class=:\ACCC16\z:}', "");;
    Expect(0, 1463, '\p{Canonical_Combining_Class=:\ACCC16\z:}', "");;
    Expect(1, 1462, '\p{Canonical_Combining_Class: ccc16}', "");
    Expect(0, 1462, '\p{^Canonical_Combining_Class: ccc16}', "");
    Expect(0, 1462, '\P{Canonical_Combining_Class: ccc16}', "");
    Expect(1, 1462, '\P{^Canonical_Combining_Class: ccc16}', "");
    Expect(0, 1463, '\p{Canonical_Combining_Class: ccc16}', "");
    Expect(1, 1463, '\p{^Canonical_Combining_Class: ccc16}', "");
    Expect(1, 1463, '\P{Canonical_Combining_Class: ccc16}', "");
    Expect(0, 1463, '\P{^Canonical_Combining_Class: ccc16}', "");
    Expect(1, 1462, '\p{Canonical_Combining_Class=:\Accc16\z:}', "");;
    Expect(0, 1463, '\p{Canonical_Combining_Class=:\Accc16\z:}', "");;
    Expect(1, 1462, '\p{Canonical_Combining_Class=_-CCC16}', "");
    Expect(0, 1462, '\p{^Canonical_Combining_Class=_-CCC16}', "");
    Expect(0, 1462, '\P{Canonical_Combining_Class=_-CCC16}', "");
    Expect(1, 1462, '\P{^Canonical_Combining_Class=_-CCC16}', "");
    Expect(0, 1463, '\p{Canonical_Combining_Class=_-CCC16}', "");
    Expect(1, 1463, '\p{^Canonical_Combining_Class=_-CCC16}', "");
    Expect(1, 1463, '\P{Canonical_Combining_Class=_-CCC16}', "");
    Expect(0, 1463, '\P{^Canonical_Combining_Class=_-CCC16}', "");
    Error('\p{Ccc=/a/_	+0016}');
    Error('\P{Ccc=/a/_	+0016}');
    Expect(1, 1462, '\p{Ccc=:\A16\z:}', "");;
    Expect(0, 1463, '\p{Ccc=:\A16\z:}', "");;
    Expect(1, 1462, '\p{Ccc=+0016}', "");
    Expect(0, 1462, '\p{^Ccc=+0016}', "");
    Expect(0, 1462, '\P{Ccc=+0016}', "");
    Expect(1, 1462, '\P{^Ccc=+0016}', "");
    Expect(0, 1463, '\p{Ccc=+0016}', "");
    Expect(1, 1463, '\p{^Ccc=+0016}', "");
    Expect(1, 1463, '\P{Ccc=+0016}', "");
    Expect(0, 1463, '\P{^Ccc=+0016}', "");
    Error('\p{Is_Canonical_Combining_Class=:=  CCC16}');
    Error('\P{Is_Canonical_Combining_Class=:=  CCC16}');
    Expect(1, 1462, '\p{Is_Canonical_Combining_Class=ccc16}', "");
    Expect(0, 1462, '\p{^Is_Canonical_Combining_Class=ccc16}', "");
    Expect(0, 1462, '\P{Is_Canonical_Combining_Class=ccc16}', "");
    Expect(1, 1462, '\P{^Is_Canonical_Combining_Class=ccc16}', "");
    Expect(0, 1463, '\p{Is_Canonical_Combining_Class=ccc16}', "");
    Expect(1, 1463, '\p{^Is_Canonical_Combining_Class=ccc16}', "");
    Expect(1, 1463, '\P{Is_Canonical_Combining_Class=ccc16}', "");
    Expect(0, 1463, '\P{^Is_Canonical_Combining_Class=ccc16}', "");
    Expect(1, 1462, '\p{Is_Canonical_Combining_Class= 	CCC16}', "");
    Expect(0, 1462, '\p{^Is_Canonical_Combining_Class= 	CCC16}', "");
    Expect(0, 1462, '\P{Is_Canonical_Combining_Class= 	CCC16}', "");
    Expect(1, 1462, '\P{^Is_Canonical_Combining_Class= 	CCC16}', "");
    Expect(0, 1463, '\p{Is_Canonical_Combining_Class= 	CCC16}', "");
    Expect(1, 1463, '\p{^Is_Canonical_Combining_Class= 	CCC16}', "");
    Expect(1, 1463, '\P{Is_Canonical_Combining_Class= 	CCC16}', "");
    Expect(0, 1463, '\P{^Is_Canonical_Combining_Class= 	CCC16}', "");
    Error('\p{Is_Ccc=-	+0000016/a/}');
    Error('\P{Is_Ccc=-	+0000016/a/}');
    Expect(1, 1462, '\p{Is_Ccc=00000016}', "");
    Expect(0, 1462, '\p{^Is_Ccc=00000016}', "");
    Expect(0, 1462, '\P{Is_Ccc=00000016}', "");
    Expect(1, 1462, '\P{^Is_Ccc=00000016}', "");
    Expect(0, 1463, '\p{Is_Ccc=00000016}', "");
    Expect(1, 1463, '\p{^Is_Ccc=00000016}', "");
    Expect(1, 1463, '\P{Is_Ccc=00000016}', "");
    Expect(0, 1463, '\P{^Is_Ccc=00000016}', "");
    Error('\p{Canonical_Combining_Class=_CCC17/a/}');
    Error('\P{Canonical_Combining_Class=_CCC17/a/}');
    Expect(1, 1463, '\p{Canonical_Combining_Class=:\ACCC17\z:}', "");;
    Expect(0, 1464, '\p{Canonical_Combining_Class=:\ACCC17\z:}', "");;
    Expect(1, 1463, '\p{Canonical_Combining_Class=ccc17}', "");
    Expect(0, 1463, '\p{^Canonical_Combining_Class=ccc17}', "");
    Expect(0, 1463, '\P{Canonical_Combining_Class=ccc17}', "");
    Expect(1, 1463, '\P{^Canonical_Combining_Class=ccc17}', "");
    Expect(0, 1464, '\p{Canonical_Combining_Class=ccc17}', "");
    Expect(1, 1464, '\p{^Canonical_Combining_Class=ccc17}', "");
    Expect(1, 1464, '\P{Canonical_Combining_Class=ccc17}', "");
    Expect(0, 1464, '\P{^Canonical_Combining_Class=ccc17}', "");
    Expect(1, 1463, '\p{Canonical_Combining_Class=:\Accc17\z:}', "");;
    Expect(0, 1464, '\p{Canonical_Combining_Class=:\Accc17\z:}', "");;
    Expect(1, 1463, '\p{Canonical_Combining_Class:    _CCC17}', "");
    Expect(0, 1463, '\p{^Canonical_Combining_Class:    _CCC17}', "");
    Expect(0, 1463, '\P{Canonical_Combining_Class:    _CCC17}', "");
    Expect(1, 1463, '\P{^Canonical_Combining_Class:    _CCC17}', "");
    Expect(0, 1464, '\p{Canonical_Combining_Class:    _CCC17}', "");
    Expect(1, 1464, '\p{^Canonical_Combining_Class:    _CCC17}', "");
    Expect(1, 1464, '\P{Canonical_Combining_Class:    _CCC17}', "");
    Expect(0, 1464, '\P{^Canonical_Combining_Class:    _CCC17}', "");
    Error('\p{Ccc= :=000000017}');
    Error('\P{Ccc= :=000000017}');
    Expect(1, 1463, '\p{Ccc=:\A17\z:}', "");;
    Expect(0, 1464, '\p{Ccc=:\A17\z:}', "");;
    Expect(1, 1463, '\p{Ccc=000_001_7}', "");
    Expect(0, 1463, '\p{^Ccc=000_001_7}', "");
    Expect(0, 1463, '\P{Ccc=000_001_7}', "");
    Expect(1, 1463, '\P{^Ccc=000_001_7}', "");
    Expect(0, 1464, '\p{Ccc=000_001_7}', "");
    Expect(1, 1464, '\p{^Ccc=000_001_7}', "");
    Expect(1, 1464, '\P{Ccc=000_001_7}', "");
    Expect(0, 1464, '\P{^Ccc=000_001_7}', "");
    Error('\p{Is_Canonical_Combining_Class=/a/- CCC17}');
    Error('\P{Is_Canonical_Combining_Class=/a/- CCC17}');
    Expect(1, 1463, '\p{Is_Canonical_Combining_Class:	ccc17}', "");
    Expect(0, 1463, '\p{^Is_Canonical_Combining_Class:	ccc17}', "");
    Expect(0, 1463, '\P{Is_Canonical_Combining_Class:	ccc17}', "");
    Expect(1, 1463, '\P{^Is_Canonical_Combining_Class:	ccc17}', "");
    Expect(0, 1464, '\p{Is_Canonical_Combining_Class:	ccc17}', "");
    Expect(1, 1464, '\p{^Is_Canonical_Combining_Class:	ccc17}', "");
    Expect(1, 1464, '\P{Is_Canonical_Combining_Class:	ccc17}', "");
    Expect(0, 1464, '\P{^Is_Canonical_Combining_Class:	ccc17}', "");
    Expect(1, 1463, '\p{Is_Canonical_Combining_Class=_-ccc17}', "");
    Expect(0, 1463, '\p{^Is_Canonical_Combining_Class=_-ccc17}', "");
    Expect(0, 1463, '\P{Is_Canonical_Combining_Class=_-ccc17}', "");
    Expect(1, 1463, '\P{^Is_Canonical_Combining_Class=_-ccc17}', "");
    Expect(0, 1464, '\p{Is_Canonical_Combining_Class=_-ccc17}', "");
    Expect(1, 1464, '\p{^Is_Canonical_Combining_Class=_-ccc17}', "");
    Expect(1, 1464, '\P{Is_Canonical_Combining_Class=_-ccc17}', "");
    Expect(0, 1464, '\P{^Is_Canonical_Combining_Class=_-ccc17}', "");
    Error('\p{Is_Ccc=- 00_00_00_00_01_7:=}');
    Error('\P{Is_Ccc=- 00_00_00_00_01_7:=}');
    Expect(1, 1463, '\p{Is_Ccc=000017}', "");
    Expect(0, 1463, '\p{^Is_Ccc=000017}', "");
    Expect(0, 1463, '\P{Is_Ccc=000017}', "");
    Expect(1, 1463, '\P{^Is_Ccc=000017}', "");
    Expect(0, 1464, '\p{Is_Ccc=000017}', "");
    Expect(1, 1464, '\p{^Is_Ccc=000017}', "");
    Expect(1, 1464, '\P{Is_Ccc=000017}', "");
    Expect(0, 1464, '\P{^Is_Ccc=000017}', "");
    Error('\p{Canonical_Combining_Class=  CCC18/a/}');
    Error('\P{Canonical_Combining_Class=  CCC18/a/}');
    Expect(1, 1479, '\p{Canonical_Combining_Class=:\ACCC18\z:}', "");;
    Expect(0, 1480, '\p{Canonical_Combining_Class=:\ACCC18\z:}', "");;
    Expect(1, 1479, '\p{Canonical_Combining_Class=ccc18}', "");
    Expect(0, 1479, '\p{^Canonical_Combining_Class=ccc18}', "");
    Expect(0, 1479, '\P{Canonical_Combining_Class=ccc18}', "");
    Expect(1, 1479, '\P{^Canonical_Combining_Class=ccc18}', "");
    Expect(0, 1480, '\p{Canonical_Combining_Class=ccc18}', "");
    Expect(1, 1480, '\p{^Canonical_Combining_Class=ccc18}', "");
    Expect(1, 1480, '\P{Canonical_Combining_Class=ccc18}', "");
    Expect(0, 1480, '\P{^Canonical_Combining_Class=ccc18}', "");
    Expect(1, 1479, '\p{Canonical_Combining_Class=:\Accc18\z:}', "");;
    Expect(0, 1480, '\p{Canonical_Combining_Class=:\Accc18\z:}', "");;
    Expect(1, 1479, '\p{Canonical_Combining_Class=	 CCC18}', "");
    Expect(0, 1479, '\p{^Canonical_Combining_Class=	 CCC18}', "");
    Expect(0, 1479, '\P{Canonical_Combining_Class=	 CCC18}', "");
    Expect(1, 1479, '\P{^Canonical_Combining_Class=	 CCC18}', "");
    Expect(0, 1480, '\p{Canonical_Combining_Class=	 CCC18}', "");
    Expect(1, 1480, '\p{^Canonical_Combining_Class=	 CCC18}', "");
    Expect(1, 1480, '\P{Canonical_Combining_Class=	 CCC18}', "");
    Expect(0, 1480, '\P{^Canonical_Combining_Class=	 CCC18}', "");
    Error('\p{Ccc:	__+00000001_8:=}');
    Error('\P{Ccc:	__+00000001_8:=}');
    Expect(1, 1479, '\p{Ccc=:\A18\z:}', "");;
    Expect(0, 1480, '\p{Ccc=:\A18\z:}', "");;
    Expect(1, 1479, '\p{Ccc=18}', "");
    Expect(0, 1479, '\p{^Ccc=18}', "");
    Expect(0, 1479, '\P{Ccc=18}', "");
    Expect(1, 1479, '\P{^Ccc=18}', "");
    Expect(0, 1480, '\p{Ccc=18}', "");
    Expect(1, 1480, '\p{^Ccc=18}', "");
    Expect(1, 1480, '\P{Ccc=18}', "");
    Expect(0, 1480, '\P{^Ccc=18}', "");
    Error('\p{Is_Canonical_Combining_Class=--ccc18:=}');
    Error('\P{Is_Canonical_Combining_Class=--ccc18:=}');
    Expect(1, 1479, '\p{Is_Canonical_Combining_Class=ccc18}', "");
    Expect(0, 1479, '\p{^Is_Canonical_Combining_Class=ccc18}', "");
    Expect(0, 1479, '\P{Is_Canonical_Combining_Class=ccc18}', "");
    Expect(1, 1479, '\P{^Is_Canonical_Combining_Class=ccc18}', "");
    Expect(0, 1480, '\p{Is_Canonical_Combining_Class=ccc18}', "");
    Expect(1, 1480, '\p{^Is_Canonical_Combining_Class=ccc18}', "");
    Expect(1, 1480, '\P{Is_Canonical_Combining_Class=ccc18}', "");
    Expect(0, 1480, '\P{^Is_Canonical_Combining_Class=ccc18}', "");
    Expect(1, 1479, '\p{Is_Canonical_Combining_Class=	ccc18}', "");
    Expect(0, 1479, '\p{^Is_Canonical_Combining_Class=	ccc18}', "");
    Expect(0, 1479, '\P{Is_Canonical_Combining_Class=	ccc18}', "");
    Expect(1, 1479, '\P{^Is_Canonical_Combining_Class=	ccc18}', "");
    Expect(0, 1480, '\p{Is_Canonical_Combining_Class=	ccc18}', "");
    Expect(1, 1480, '\p{^Is_Canonical_Combining_Class=	ccc18}', "");
    Expect(1, 1480, '\P{Is_Canonical_Combining_Class=	ccc18}', "");
    Expect(0, 1480, '\P{^Is_Canonical_Combining_Class=	ccc18}', "");
    Error('\p{Is_Ccc=_-0_0_0_0_0_0_00018:=}');
    Error('\P{Is_Ccc=_-0_0_0_0_0_0_00018:=}');
    Expect(1, 1479, '\p{Is_Ccc:1_8}', "");
    Expect(0, 1479, '\p{^Is_Ccc:1_8}', "");
    Expect(0, 1479, '\P{Is_Ccc:1_8}', "");
    Expect(1, 1479, '\P{^Is_Ccc:1_8}', "");
    Expect(0, 1480, '\p{Is_Ccc:1_8}', "");
    Expect(1, 1480, '\p{^Is_Ccc:1_8}', "");
    Expect(1, 1480, '\P{Is_Ccc:1_8}', "");
    Expect(0, 1480, '\P{^Is_Ccc:1_8}', "");
    Error('\p{Canonical_Combining_Class=	/a/CCC19}');
    Error('\P{Canonical_Combining_Class=	/a/CCC19}');
    Expect(1, 1466, '\p{Canonical_Combining_Class=:\ACCC19\z:}', "");;
    Expect(0, 1467, '\p{Canonical_Combining_Class=:\ACCC19\z:}', "");;
    Expect(1, 1466, '\p{Canonical_Combining_Class=ccc19}', "");
    Expect(0, 1466, '\p{^Canonical_Combining_Class=ccc19}', "");
    Expect(0, 1466, '\P{Canonical_Combining_Class=ccc19}', "");
    Expect(1, 1466, '\P{^Canonical_Combining_Class=ccc19}', "");
    Expect(0, 1467, '\p{Canonical_Combining_Class=ccc19}', "");
    Expect(1, 1467, '\p{^Canonical_Combining_Class=ccc19}', "");
    Expect(1, 1467, '\P{Canonical_Combining_Class=ccc19}', "");
    Expect(0, 1467, '\P{^Canonical_Combining_Class=ccc19}', "");
    Expect(1, 1466, '\p{Canonical_Combining_Class=:\Accc19\z:}', "");;
    Expect(0, 1467, '\p{Canonical_Combining_Class=:\Accc19\z:}', "");;
    Expect(1, 1466, '\p{Canonical_Combining_Class:    CCC19}', "");
    Expect(0, 1466, '\p{^Canonical_Combining_Class:    CCC19}', "");
    Expect(0, 1466, '\P{Canonical_Combining_Class:    CCC19}', "");
    Expect(1, 1466, '\P{^Canonical_Combining_Class:    CCC19}', "");
    Expect(0, 1467, '\p{Canonical_Combining_Class:    CCC19}', "");
    Expect(1, 1467, '\p{^Canonical_Combining_Class:    CCC19}', "");
    Expect(1, 1467, '\P{Canonical_Combining_Class:    CCC19}', "");
    Expect(0, 1467, '\P{^Canonical_Combining_Class:    CCC19}', "");
    Error('\p{Ccc= -0_0_19/a/}');
    Error('\P{Ccc= -0_0_19/a/}');
    Expect(1, 1466, '\p{Ccc=:\A19\z:}', "");;
    Expect(0, 1467, '\p{Ccc=:\A19\z:}', "");;
    Expect(1, 1466, '\p{Ccc=00_00_00_00_01_9}', "");
    Expect(0, 1466, '\p{^Ccc=00_00_00_00_01_9}', "");
    Expect(0, 1466, '\P{Ccc=00_00_00_00_01_9}', "");
    Expect(1, 1466, '\P{^Ccc=00_00_00_00_01_9}', "");
    Expect(0, 1467, '\p{Ccc=00_00_00_00_01_9}', "");
    Expect(1, 1467, '\p{^Ccc=00_00_00_00_01_9}', "");
    Expect(1, 1467, '\P{Ccc=00_00_00_00_01_9}', "");
    Expect(0, 1467, '\P{^Ccc=00_00_00_00_01_9}', "");
    Error('\p{Is_Canonical_Combining_Class=/a/-CCC19}');
    Error('\P{Is_Canonical_Combining_Class=/a/-CCC19}');
    Expect(1, 1466, '\p{Is_Canonical_Combining_Class=ccc19}', "");
    Expect(0, 1466, '\p{^Is_Canonical_Combining_Class=ccc19}', "");
    Expect(0, 1466, '\P{Is_Canonical_Combining_Class=ccc19}', "");
    Expect(1, 1466, '\P{^Is_Canonical_Combining_Class=ccc19}', "");
    Expect(0, 1467, '\p{Is_Canonical_Combining_Class=ccc19}', "");
    Expect(1, 1467, '\p{^Is_Canonical_Combining_Class=ccc19}', "");
    Expect(1, 1467, '\P{Is_Canonical_Combining_Class=ccc19}', "");
    Expect(0, 1467, '\P{^Is_Canonical_Combining_Class=ccc19}', "");
    Expect(1, 1466, '\p{Is_Canonical_Combining_Class=	_CCC19}', "");
    Expect(0, 1466, '\p{^Is_Canonical_Combining_Class=	_CCC19}', "");
    Expect(0, 1466, '\P{Is_Canonical_Combining_Class=	_CCC19}', "");
    Expect(1, 1466, '\P{^Is_Canonical_Combining_Class=	_CCC19}', "");
    Expect(0, 1467, '\p{Is_Canonical_Combining_Class=	_CCC19}', "");
    Expect(1, 1467, '\p{^Is_Canonical_Combining_Class=	_CCC19}', "");
    Expect(1, 1467, '\P{Is_Canonical_Combining_Class=	_CCC19}', "");
    Expect(0, 1467, '\P{^Is_Canonical_Combining_Class=	_CCC19}', "");
    Error('\p{Is_Ccc=_ 00019/a/}');
    Error('\P{Is_Ccc=_ 00019/a/}');
    Expect(1, 1466, '\p{Is_Ccc=+0000019}', "");
    Expect(0, 1466, '\p{^Is_Ccc=+0000019}', "");
    Expect(0, 1466, '\P{Is_Ccc=+0000019}', "");
    Expect(1, 1466, '\P{^Is_Ccc=+0000019}', "");
    Expect(0, 1467, '\p{Is_Ccc=+0000019}', "");
    Expect(1, 1467, '\p{^Is_Ccc=+0000019}', "");
    Expect(1, 1467, '\P{Is_Ccc=+0000019}', "");
    Expect(0, 1467, '\P{^Is_Ccc=+0000019}', "");
    Error('\p{Canonical_Combining_Class=/a/- CCC20}');
    Error('\P{Canonical_Combining_Class=/a/- CCC20}');
    Expect(1, 1467, '\p{Canonical_Combining_Class=:\ACCC20\z:}', "");;
    Expect(0, 1468, '\p{Canonical_Combining_Class=:\ACCC20\z:}', "");;
    Expect(1, 1467, '\p{Canonical_Combining_Class=ccc20}', "");
    Expect(0, 1467, '\p{^Canonical_Combining_Class=ccc20}', "");
    Expect(0, 1467, '\P{Canonical_Combining_Class=ccc20}', "");
    Expect(1, 1467, '\P{^Canonical_Combining_Class=ccc20}', "");
    Expect(0, 1468, '\p{Canonical_Combining_Class=ccc20}', "");
    Expect(1, 1468, '\p{^Canonical_Combining_Class=ccc20}', "");
    Expect(1, 1468, '\P{Canonical_Combining_Class=ccc20}', "");
    Expect(0, 1468, '\P{^Canonical_Combining_Class=ccc20}', "");
    Expect(1, 1467, '\p{Canonical_Combining_Class=:\Accc20\z:}', "");;
    Expect(0, 1468, '\p{Canonical_Combining_Class=:\Accc20\z:}', "");;
    Expect(1, 1467, '\p{Canonical_Combining_Class=	CCC20}', "");
    Expect(0, 1467, '\p{^Canonical_Combining_Class=	CCC20}', "");
    Expect(0, 1467, '\P{Canonical_Combining_Class=	CCC20}', "");
    Expect(1, 1467, '\P{^Canonical_Combining_Class=	CCC20}', "");
    Expect(0, 1468, '\p{Canonical_Combining_Class=	CCC20}', "");
    Expect(1, 1468, '\p{^Canonical_Combining_Class=	CCC20}', "");
    Expect(1, 1468, '\P{Canonical_Combining_Class=	CCC20}', "");
    Expect(0, 1468, '\P{^Canonical_Combining_Class=	CCC20}', "");
    Error('\p{Ccc=	:=20}');
    Error('\P{Ccc=	:=20}');
    Expect(1, 1467, '\p{Ccc=:\A20\z:}', "");;
    Expect(0, 1468, '\p{Ccc=:\A20\z:}', "");;
    Expect(1, 1467, '\p{Ccc=+0000000020}', "");
    Expect(0, 1467, '\p{^Ccc=+0000000020}', "");
    Expect(0, 1467, '\P{Ccc=+0000000020}', "");
    Expect(1, 1467, '\P{^Ccc=+0000000020}', "");
    Expect(0, 1468, '\p{Ccc=+0000000020}', "");
    Expect(1, 1468, '\p{^Ccc=+0000000020}', "");
    Expect(1, 1468, '\P{Ccc=+0000000020}', "");
    Expect(0, 1468, '\P{^Ccc=+0000000020}', "");
    Error('\p{Is_Canonical_Combining_Class=_/a/CCC20}');
    Error('\P{Is_Canonical_Combining_Class=_/a/CCC20}');
    Expect(1, 1467, '\p{Is_Canonical_Combining_Class=ccc20}', "");
    Expect(0, 1467, '\p{^Is_Canonical_Combining_Class=ccc20}', "");
    Expect(0, 1467, '\P{Is_Canonical_Combining_Class=ccc20}', "");
    Expect(1, 1467, '\P{^Is_Canonical_Combining_Class=ccc20}', "");
    Expect(0, 1468, '\p{Is_Canonical_Combining_Class=ccc20}', "");
    Expect(1, 1468, '\p{^Is_Canonical_Combining_Class=ccc20}', "");
    Expect(1, 1468, '\P{Is_Canonical_Combining_Class=ccc20}', "");
    Expect(0, 1468, '\P{^Is_Canonical_Combining_Class=ccc20}', "");
    Expect(1, 1467, '\p{Is_Canonical_Combining_Class: _CCC20}', "");
    Expect(0, 1467, '\p{^Is_Canonical_Combining_Class: _CCC20}', "");
    Expect(0, 1467, '\P{Is_Canonical_Combining_Class: _CCC20}', "");
    Expect(1, 1467, '\P{^Is_Canonical_Combining_Class: _CCC20}', "");
    Expect(0, 1468, '\p{Is_Canonical_Combining_Class: _CCC20}', "");
    Expect(1, 1468, '\p{^Is_Canonical_Combining_Class: _CCC20}', "");
    Expect(1, 1468, '\P{Is_Canonical_Combining_Class: _CCC20}', "");
    Expect(0, 1468, '\P{^Is_Canonical_Combining_Class: _CCC20}', "");
    Error('\p{Is_Ccc=/a/		000_000_20}');
    Error('\P{Is_Ccc=/a/		000_000_20}');
    Expect(1, 1467, '\p{Is_Ccc=+2_0}', "");
    Expect(0, 1467, '\p{^Is_Ccc=+2_0}', "");
    Expect(0, 1467, '\P{Is_Ccc=+2_0}', "");
    Expect(1, 1467, '\P{^Is_Ccc=+2_0}', "");
    Expect(0, 1468, '\p{Is_Ccc=+2_0}', "");
    Expect(1, 1468, '\p{^Is_Ccc=+2_0}', "");
    Expect(1, 1468, '\P{Is_Ccc=+2_0}', "");
    Expect(0, 1468, '\P{^Is_Ccc=+2_0}', "");
    Error('\p{Canonical_Combining_Class=_:=ccc21}');
    Error('\P{Canonical_Combining_Class=_:=ccc21}');
    Expect(1, 1468, '\p{Canonical_Combining_Class=:\ACCC21\z:}', "");;
    Expect(0, 1469, '\p{Canonical_Combining_Class=:\ACCC21\z:}', "");;
    Expect(1, 1468, '\p{Canonical_Combining_Class=ccc21}', "");
    Expect(0, 1468, '\p{^Canonical_Combining_Class=ccc21}', "");
    Expect(0, 1468, '\P{Canonical_Combining_Class=ccc21}', "");
    Expect(1, 1468, '\P{^Canonical_Combining_Class=ccc21}', "");
    Expect(0, 1469, '\p{Canonical_Combining_Class=ccc21}', "");
    Expect(1, 1469, '\p{^Canonical_Combining_Class=ccc21}', "");
    Expect(1, 1469, '\P{Canonical_Combining_Class=ccc21}', "");
    Expect(0, 1469, '\P{^Canonical_Combining_Class=ccc21}', "");
    Expect(1, 1468, '\p{Canonical_Combining_Class=:\Accc21\z:}', "");;
    Expect(0, 1469, '\p{Canonical_Combining_Class=:\Accc21\z:}', "");;
    Expect(1, 1468, '\p{Canonical_Combining_Class=_-CCC21}', "");
    Expect(0, 1468, '\p{^Canonical_Combining_Class=_-CCC21}', "");
    Expect(0, 1468, '\P{Canonical_Combining_Class=_-CCC21}', "");
    Expect(1, 1468, '\P{^Canonical_Combining_Class=_-CCC21}', "");
    Expect(0, 1469, '\p{Canonical_Combining_Class=_-CCC21}', "");
    Expect(1, 1469, '\p{^Canonical_Combining_Class=_-CCC21}', "");
    Expect(1, 1469, '\P{Canonical_Combining_Class=_-CCC21}', "");
    Expect(0, 1469, '\P{^Canonical_Combining_Class=_-CCC21}', "");
    Error('\p{Ccc=:=_02_1}');
    Error('\P{Ccc=:=_02_1}');
    Expect(1, 1468, '\p{Ccc=:\A21\z:}', "");;
    Expect(0, 1469, '\p{Ccc=:\A21\z:}', "");;
    Expect(1, 1468, '\p{Ccc=+0000000021}', "");
    Expect(0, 1468, '\p{^Ccc=+0000000021}', "");
    Expect(0, 1468, '\P{Ccc=+0000000021}', "");
    Expect(1, 1468, '\P{^Ccc=+0000000021}', "");
    Expect(0, 1469, '\p{Ccc=+0000000021}', "");
    Expect(1, 1469, '\p{^Ccc=+0000000021}', "");
    Expect(1, 1469, '\P{Ccc=+0000000021}', "");
    Expect(0, 1469, '\P{^Ccc=+0000000021}', "");
    Error('\p{Is_Canonical_Combining_Class=_CCC21/a/}');
    Error('\P{Is_Canonical_Combining_Class=_CCC21/a/}');
    Expect(1, 1468, '\p{Is_Canonical_Combining_Class=ccc21}', "");
    Expect(0, 1468, '\p{^Is_Canonical_Combining_Class=ccc21}', "");
    Expect(0, 1468, '\P{Is_Canonical_Combining_Class=ccc21}', "");
    Expect(1, 1468, '\P{^Is_Canonical_Combining_Class=ccc21}', "");
    Expect(0, 1469, '\p{Is_Canonical_Combining_Class=ccc21}', "");
    Expect(1, 1469, '\p{^Is_Canonical_Combining_Class=ccc21}', "");
    Expect(1, 1469, '\P{Is_Canonical_Combining_Class=ccc21}', "");
    Expect(0, 1469, '\P{^Is_Canonical_Combining_Class=ccc21}', "");
    Expect(1, 1468, '\p{Is_Canonical_Combining_Class=-ccc21}', "");
    Expect(0, 1468, '\p{^Is_Canonical_Combining_Class=-ccc21}', "");
    Expect(0, 1468, '\P{Is_Canonical_Combining_Class=-ccc21}', "");
    Expect(1, 1468, '\P{^Is_Canonical_Combining_Class=-ccc21}', "");
    Expect(0, 1469, '\p{Is_Canonical_Combining_Class=-ccc21}', "");
    Expect(1, 1469, '\p{^Is_Canonical_Combining_Class=-ccc21}', "");
    Expect(1, 1469, '\P{Is_Canonical_Combining_Class=-ccc21}', "");
    Expect(0, 1469, '\P{^Is_Canonical_Combining_Class=-ccc21}', "");
    Error('\p{Is_Ccc=:= 0000021}');
    Error('\P{Is_Ccc=:= 0000021}');
    Expect(1, 1468, '\p{Is_Ccc=0021}', "");
    Expect(0, 1468, '\p{^Is_Ccc=0021}', "");
    Expect(0, 1468, '\P{Is_Ccc=0021}', "");
    Expect(1, 1468, '\P{^Is_Ccc=0021}', "");
    Expect(0, 1469, '\p{Is_Ccc=0021}', "");
    Expect(1, 1469, '\p{^Is_Ccc=0021}', "");
    Expect(1, 1469, '\P{Is_Ccc=0021}', "");
    Expect(0, 1469, '\P{^Is_Ccc=0021}', "");
    Error('\p{Canonical_Combining_Class=_:=CCC22}');
    Error('\P{Canonical_Combining_Class=_:=CCC22}');
    Expect(1, 1469, '\p{Canonical_Combining_Class=:\ACCC22\z:}', "");;
    Expect(0, 1470, '\p{Canonical_Combining_Class=:\ACCC22\z:}', "");;
    Expect(1, 1469, '\p{Canonical_Combining_Class=ccc22}', "");
    Expect(0, 1469, '\p{^Canonical_Combining_Class=ccc22}', "");
    Expect(0, 1469, '\P{Canonical_Combining_Class=ccc22}', "");
    Expect(1, 1469, '\P{^Canonical_Combining_Class=ccc22}', "");
    Expect(0, 1470, '\p{Canonical_Combining_Class=ccc22}', "");
    Expect(1, 1470, '\p{^Canonical_Combining_Class=ccc22}', "");
    Expect(1, 1470, '\P{Canonical_Combining_Class=ccc22}', "");
    Expect(0, 1470, '\P{^Canonical_Combining_Class=ccc22}', "");
    Expect(1, 1469, '\p{Canonical_Combining_Class=:\Accc22\z:}', "");;
    Expect(0, 1470, '\p{Canonical_Combining_Class=:\Accc22\z:}', "");;
    Expect(1, 1469, '\p{Canonical_Combining_Class=-	CCC22}', "");
    Expect(0, 1469, '\p{^Canonical_Combining_Class=-	CCC22}', "");
    Expect(0, 1469, '\P{Canonical_Combining_Class=-	CCC22}', "");
    Expect(1, 1469, '\P{^Canonical_Combining_Class=-	CCC22}', "");
    Expect(0, 1470, '\p{Canonical_Combining_Class=-	CCC22}', "");
    Expect(1, 1470, '\p{^Canonical_Combining_Class=-	CCC22}', "");
    Expect(1, 1470, '\P{Canonical_Combining_Class=-	CCC22}', "");
    Expect(0, 1470, '\P{^Canonical_Combining_Class=-	CCC22}', "");
    Error('\p{Ccc=	-00000000022/a/}');
    Error('\P{Ccc=	-00000000022/a/}');
    Expect(1, 1469, '\p{Ccc=:\A22\z:}', "");;
    Expect(0, 1470, '\p{Ccc=:\A22\z:}', "");;
    Expect(1, 1469, '\p{Ccc=00000000022}', "");
    Expect(0, 1469, '\p{^Ccc=00000000022}', "");
    Expect(0, 1469, '\P{Ccc=00000000022}', "");
    Expect(1, 1469, '\P{^Ccc=00000000022}', "");
    Expect(0, 1470, '\p{Ccc=00000000022}', "");
    Expect(1, 1470, '\p{^Ccc=00000000022}', "");
    Expect(1, 1470, '\P{Ccc=00000000022}', "");
    Expect(0, 1470, '\P{^Ccc=00000000022}', "");
    Error('\p{Is_Canonical_Combining_Class=_ CCC22/a/}');
    Error('\P{Is_Canonical_Combining_Class=_ CCC22/a/}');
    Expect(1, 1469, '\p{Is_Canonical_Combining_Class=ccc22}', "");
    Expect(0, 1469, '\p{^Is_Canonical_Combining_Class=ccc22}', "");
    Expect(0, 1469, '\P{Is_Canonical_Combining_Class=ccc22}', "");
    Expect(1, 1469, '\P{^Is_Canonical_Combining_Class=ccc22}', "");
    Expect(0, 1470, '\p{Is_Canonical_Combining_Class=ccc22}', "");
    Expect(1, 1470, '\p{^Is_Canonical_Combining_Class=ccc22}', "");
    Expect(1, 1470, '\P{Is_Canonical_Combining_Class=ccc22}', "");
    Expect(0, 1470, '\P{^Is_Canonical_Combining_Class=ccc22}', "");
    Expect(1, 1469, '\p{Is_Canonical_Combining_Class= -CCC22}', "");
    Expect(0, 1469, '\p{^Is_Canonical_Combining_Class= -CCC22}', "");
    Expect(0, 1469, '\P{Is_Canonical_Combining_Class= -CCC22}', "");
    Expect(1, 1469, '\P{^Is_Canonical_Combining_Class= -CCC22}', "");
    Expect(0, 1470, '\p{Is_Canonical_Combining_Class= -CCC22}', "");
    Expect(1, 1470, '\p{^Is_Canonical_Combining_Class= -CCC22}', "");
    Expect(1, 1470, '\P{Is_Canonical_Combining_Class= -CCC22}', "");
    Expect(0, 1470, '\P{^Is_Canonical_Combining_Class= -CCC22}', "");
    Error('\p{Is_Ccc=-0_0_0_22:=}');
    Error('\P{Is_Ccc=-0_0_0_22:=}');
    Expect(1, 1469, '\p{Is_Ccc=22}', "");
    Expect(0, 1469, '\p{^Is_Ccc=22}', "");
    Expect(0, 1469, '\P{Is_Ccc=22}', "");
    Expect(1, 1469, '\P{^Is_Ccc=22}', "");
    Expect(0, 1470, '\p{Is_Ccc=22}', "");
    Expect(1, 1470, '\p{^Is_Ccc=22}', "");
    Expect(1, 1470, '\P{Is_Ccc=22}', "");
    Expect(0, 1470, '\P{^Is_Ccc=22}', "");
    Error('\p{Canonical_Combining_Class=:=_-CCC23}');
    Error('\P{Canonical_Combining_Class=:=_-CCC23}');
    Expect(1, 1471, '\p{Canonical_Combining_Class=:\ACCC23\z:}', "");;
    Expect(0, 1472, '\p{Canonical_Combining_Class=:\ACCC23\z:}', "");;
    Expect(1, 1471, '\p{Canonical_Combining_Class=ccc23}', "");
    Expect(0, 1471, '\p{^Canonical_Combining_Class=ccc23}', "");
    Expect(0, 1471, '\P{Canonical_Combining_Class=ccc23}', "");
    Expect(1, 1471, '\P{^Canonical_Combining_Class=ccc23}', "");
    Expect(0, 1472, '\p{Canonical_Combining_Class=ccc23}', "");
    Expect(1, 1472, '\p{^Canonical_Combining_Class=ccc23}', "");
    Expect(1, 1472, '\P{Canonical_Combining_Class=ccc23}', "");
    Expect(0, 1472, '\P{^Canonical_Combining_Class=ccc23}', "");
    Expect(1, 1471, '\p{Canonical_Combining_Class=:\Accc23\z:}', "");;
    Expect(0, 1472, '\p{Canonical_Combining_Class=:\Accc23\z:}', "");;
    Expect(1, 1471, '\p{Canonical_Combining_Class=--CCC23}', "");
    Expect(0, 1471, '\p{^Canonical_Combining_Class=--CCC23}', "");
    Expect(0, 1471, '\P{Canonical_Combining_Class=--CCC23}', "");
    Expect(1, 1471, '\P{^Canonical_Combining_Class=--CCC23}', "");
    Expect(0, 1472, '\p{Canonical_Combining_Class=--CCC23}', "");
    Expect(1, 1472, '\p{^Canonical_Combining_Class=--CCC23}', "");
    Expect(1, 1472, '\P{Canonical_Combining_Class=--CCC23}', "");
    Expect(0, 1472, '\P{^Canonical_Combining_Class=--CCC23}', "");
    Error('\p{Ccc: /a/	+00_02_3}');
    Error('\P{Ccc: /a/	+00_02_3}');
    Expect(1, 1471, '\p{Ccc=:\A23\z:}', "");;
    Expect(0, 1472, '\p{Ccc=:\A23\z:}', "");;
    Expect(1, 1471, '\p{Ccc=+00_00_23}', "");
    Expect(0, 1471, '\p{^Ccc=+00_00_23}', "");
    Expect(0, 1471, '\P{Ccc=+00_00_23}', "");
    Expect(1, 1471, '\P{^Ccc=+00_00_23}', "");
    Expect(0, 1472, '\p{Ccc=+00_00_23}', "");
    Expect(1, 1472, '\p{^Ccc=+00_00_23}', "");
    Expect(1, 1472, '\P{Ccc=+00_00_23}', "");
    Expect(0, 1472, '\P{^Ccc=+00_00_23}', "");
    Error('\p{Is_Canonical_Combining_Class=:=_ CCC23}');
    Error('\P{Is_Canonical_Combining_Class=:=_ CCC23}');
    Expect(1, 1471, '\p{Is_Canonical_Combining_Class=ccc23}', "");
    Expect(0, 1471, '\p{^Is_Canonical_Combining_Class=ccc23}', "");
    Expect(0, 1471, '\P{Is_Canonical_Combining_Class=ccc23}', "");
    Expect(1, 1471, '\P{^Is_Canonical_Combining_Class=ccc23}', "");
    Expect(0, 1472, '\p{Is_Canonical_Combining_Class=ccc23}', "");
    Expect(1, 1472, '\p{^Is_Canonical_Combining_Class=ccc23}', "");
    Expect(1, 1472, '\P{Is_Canonical_Combining_Class=ccc23}', "");
    Expect(0, 1472, '\P{^Is_Canonical_Combining_Class=ccc23}', "");
    Expect(1, 1471, '\p{Is_Canonical_Combining_Class:	 CCC23}', "");
    Expect(0, 1471, '\p{^Is_Canonical_Combining_Class:	 CCC23}', "");
    Expect(0, 1471, '\P{Is_Canonical_Combining_Class:	 CCC23}', "");
    Expect(1, 1471, '\P{^Is_Canonical_Combining_Class:	 CCC23}', "");
    Expect(0, 1472, '\p{Is_Canonical_Combining_Class:	 CCC23}', "");
    Expect(1, 1472, '\p{^Is_Canonical_Combining_Class:	 CCC23}', "");
    Expect(1, 1472, '\P{Is_Canonical_Combining_Class:	 CCC23}', "");
    Expect(0, 1472, '\P{^Is_Canonical_Combining_Class:	 CCC23}', "");
    Error('\p{Is_Ccc=/a/00_02_3}');
    Error('\P{Is_Ccc=/a/00_02_3}');
    Expect(1, 1471, '\p{Is_Ccc=+00023}', "");
    Expect(0, 1471, '\p{^Is_Ccc=+00023}', "");
    Expect(0, 1471, '\P{Is_Ccc=+00023}', "");
    Expect(1, 1471, '\P{^Is_Ccc=+00023}', "");
    Expect(0, 1472, '\p{Is_Ccc=+00023}', "");
    Expect(1, 1472, '\p{^Is_Ccc=+00023}', "");
    Expect(1, 1472, '\P{Is_Ccc=+00023}', "");
    Expect(0, 1472, '\P{^Is_Ccc=+00023}', "");
    Error('\p{Canonical_Combining_Class= :=ccc24}');
    Error('\P{Canonical_Combining_Class= :=ccc24}');
    Expect(1, 1473, '\p{Canonical_Combining_Class=:\ACCC24\z:}', "");;
    Expect(0, 1474, '\p{Canonical_Combining_Class=:\ACCC24\z:}', "");;
    Expect(1, 1473, '\p{Canonical_Combining_Class=ccc24}', "");
    Expect(0, 1473, '\p{^Canonical_Combining_Class=ccc24}', "");
    Expect(0, 1473, '\P{Canonical_Combining_Class=ccc24}', "");
    Expect(1, 1473, '\P{^Canonical_Combining_Class=ccc24}', "");
    Expect(0, 1474, '\p{Canonical_Combining_Class=ccc24}', "");
    Expect(1, 1474, '\p{^Canonical_Combining_Class=ccc24}', "");
    Expect(1, 1474, '\P{Canonical_Combining_Class=ccc24}', "");
    Expect(0, 1474, '\P{^Canonical_Combining_Class=ccc24}', "");
    Expect(1, 1473, '\p{Canonical_Combining_Class=:\Accc24\z:}', "");;
    Expect(0, 1474, '\p{Canonical_Combining_Class=:\Accc24\z:}', "");;
    Expect(1, 1473, '\p{Canonical_Combining_Class=	CCC24}', "");
    Expect(0, 1473, '\p{^Canonical_Combining_Class=	CCC24}', "");
    Expect(0, 1473, '\P{Canonical_Combining_Class=	CCC24}', "");
    Expect(1, 1473, '\P{^Canonical_Combining_Class=	CCC24}', "");
    Expect(0, 1474, '\p{Canonical_Combining_Class=	CCC24}', "");
    Expect(1, 1474, '\p{^Canonical_Combining_Class=	CCC24}', "");
    Expect(1, 1474, '\P{Canonical_Combining_Class=	CCC24}', "");
    Expect(0, 1474, '\P{^Canonical_Combining_Class=	CCC24}', "");
    Error('\p{Ccc=_24/a/}');
    Error('\P{Ccc=_24/a/}');
    Expect(1, 1473, '\p{Ccc=:\A24\z:}', "");;
    Expect(0, 1474, '\p{Ccc=:\A24\z:}', "");;
    Expect(1, 1473, '\p{Ccc=+0000024}', "");
    Expect(0, 1473, '\p{^Ccc=+0000024}', "");
    Expect(0, 1473, '\P{Ccc=+0000024}', "");
    Expect(1, 1473, '\P{^Ccc=+0000024}', "");
    Expect(0, 1474, '\p{Ccc=+0000024}', "");
    Expect(1, 1474, '\p{^Ccc=+0000024}', "");
    Expect(1, 1474, '\P{Ccc=+0000024}', "");
    Expect(0, 1474, '\P{^Ccc=+0000024}', "");
    Error('\p{Is_Canonical_Combining_Class=_ccc24/a/}');
    Error('\P{Is_Canonical_Combining_Class=_ccc24/a/}');
    Expect(1, 1473, '\p{Is_Canonical_Combining_Class=ccc24}', "");
    Expect(0, 1473, '\p{^Is_Canonical_Combining_Class=ccc24}', "");
    Expect(0, 1473, '\P{Is_Canonical_Combining_Class=ccc24}', "");
    Expect(1, 1473, '\P{^Is_Canonical_Combining_Class=ccc24}', "");
    Expect(0, 1474, '\p{Is_Canonical_Combining_Class=ccc24}', "");
    Expect(1, 1474, '\p{^Is_Canonical_Combining_Class=ccc24}', "");
    Expect(1, 1474, '\P{Is_Canonical_Combining_Class=ccc24}', "");
    Expect(0, 1474, '\P{^Is_Canonical_Combining_Class=ccc24}', "");
    Expect(1, 1473, '\p{Is_Canonical_Combining_Class=CCC24}', "");
    Expect(0, 1473, '\p{^Is_Canonical_Combining_Class=CCC24}', "");
    Expect(0, 1473, '\P{Is_Canonical_Combining_Class=CCC24}', "");
    Expect(1, 1473, '\P{^Is_Canonical_Combining_Class=CCC24}', "");
    Expect(0, 1474, '\p{Is_Canonical_Combining_Class=CCC24}', "");
    Expect(1, 1474, '\p{^Is_Canonical_Combining_Class=CCC24}', "");
    Expect(1, 1474, '\P{Is_Canonical_Combining_Class=CCC24}', "");
    Expect(0, 1474, '\P{^Is_Canonical_Combining_Class=CCC24}', "");
    Error('\p{Is_Ccc=:=0_0_0_0_0_0_0024}');
    Error('\P{Is_Ccc=:=0_0_0_0_0_0_0024}');
    Expect(1, 1473, '\p{Is_Ccc=00002_4}', "");
    Expect(0, 1473, '\p{^Is_Ccc=00002_4}', "");
    Expect(0, 1473, '\P{Is_Ccc=00002_4}', "");
    Expect(1, 1473, '\P{^Is_Ccc=00002_4}', "");
    Expect(0, 1474, '\p{Is_Ccc=00002_4}', "");
    Expect(1, 1474, '\p{^Is_Ccc=00002_4}', "");
    Expect(1, 1474, '\P{Is_Ccc=00002_4}', "");
    Expect(0, 1474, '\P{^Is_Ccc=00002_4}', "");
    Error('\p{Canonical_Combining_Class=	_CCC25/a/}');
    Error('\P{Canonical_Combining_Class=	_CCC25/a/}');
    Expect(1, 1474, '\p{Canonical_Combining_Class=:\ACCC25\z:}', "");;
    Expect(0, 1475, '\p{Canonical_Combining_Class=:\ACCC25\z:}', "");;
    Expect(1, 1474, '\p{Canonical_Combining_Class:	ccc25}', "");
    Expect(0, 1474, '\p{^Canonical_Combining_Class:	ccc25}', "");
    Expect(0, 1474, '\P{Canonical_Combining_Class:	ccc25}', "");
    Expect(1, 1474, '\P{^Canonical_Combining_Class:	ccc25}', "");
    Expect(0, 1475, '\p{Canonical_Combining_Class:	ccc25}', "");
    Expect(1, 1475, '\p{^Canonical_Combining_Class:	ccc25}', "");
    Expect(1, 1475, '\P{Canonical_Combining_Class:	ccc25}', "");
    Expect(0, 1475, '\P{^Canonical_Combining_Class:	ccc25}', "");
    Expect(1, 1474, '\p{Canonical_Combining_Class=:\Accc25\z:}', "");;
    Expect(0, 1475, '\p{Canonical_Combining_Class=:\Accc25\z:}', "");;
    Expect(1, 1474, '\p{Canonical_Combining_Class=		CCC25}', "");
    Expect(0, 1474, '\p{^Canonical_Combining_Class=		CCC25}', "");
    Expect(0, 1474, '\P{Canonical_Combining_Class=		CCC25}', "");
    Expect(1, 1474, '\P{^Canonical_Combining_Class=		CCC25}', "");
    Expect(0, 1475, '\p{Canonical_Combining_Class=		CCC25}', "");
    Expect(1, 1475, '\p{^Canonical_Combining_Class=		CCC25}', "");
    Expect(1, 1475, '\P{Canonical_Combining_Class=		CCC25}', "");
    Expect(0, 1475, '\P{^Canonical_Combining_Class=		CCC25}', "");
    Error('\p{Ccc: --0_0_0_0_025:=}');
    Error('\P{Ccc: --0_0_0_0_025:=}');
    Expect(1, 1474, '\p{Ccc=:\A25\z:}', "");;
    Expect(0, 1475, '\p{Ccc=:\A25\z:}', "");;
    Expect(1, 1474, '\p{Ccc=+00_02_5}', "");
    Expect(0, 1474, '\p{^Ccc=+00_02_5}', "");
    Expect(0, 1474, '\P{Ccc=+00_02_5}', "");
    Expect(1, 1474, '\P{^Ccc=+00_02_5}', "");
    Expect(0, 1475, '\p{Ccc=+00_02_5}', "");
    Expect(1, 1475, '\p{^Ccc=+00_02_5}', "");
    Expect(1, 1475, '\P{Ccc=+00_02_5}', "");
    Expect(0, 1475, '\P{^Ccc=+00_02_5}', "");
    Error('\p{Is_Canonical_Combining_Class=/a/CCC25}');
    Error('\P{Is_Canonical_Combining_Class=/a/CCC25}');
    Expect(1, 1474, '\p{Is_Canonical_Combining_Class=ccc25}', "");
    Expect(0, 1474, '\p{^Is_Canonical_Combining_Class=ccc25}', "");
    Expect(0, 1474, '\P{Is_Canonical_Combining_Class=ccc25}', "");
    Expect(1, 1474, '\P{^Is_Canonical_Combining_Class=ccc25}', "");
    Expect(0, 1475, '\p{Is_Canonical_Combining_Class=ccc25}', "");
    Expect(1, 1475, '\p{^Is_Canonical_Combining_Class=ccc25}', "");
    Expect(1, 1475, '\P{Is_Canonical_Combining_Class=ccc25}', "");
    Expect(0, 1475, '\P{^Is_Canonical_Combining_Class=ccc25}', "");
    Expect(1, 1474, '\p{Is_Canonical_Combining_Class=CCC25}', "");
    Expect(0, 1474, '\p{^Is_Canonical_Combining_Class=CCC25}', "");
    Expect(0, 1474, '\P{Is_Canonical_Combining_Class=CCC25}', "");
    Expect(1, 1474, '\P{^Is_Canonical_Combining_Class=CCC25}', "");
    Expect(0, 1475, '\p{Is_Canonical_Combining_Class=CCC25}', "");
    Expect(1, 1475, '\p{^Is_Canonical_Combining_Class=CCC25}', "");
    Expect(1, 1475, '\P{Is_Canonical_Combining_Class=CCC25}', "");
    Expect(0, 1475, '\P{^Is_Canonical_Combining_Class=CCC25}', "");
    Error('\p{Is_Ccc=/a/  25}');
    Error('\P{Is_Ccc=/a/  25}');
    Expect(1, 1474, '\p{Is_Ccc=00000025}', "");
    Expect(0, 1474, '\p{^Is_Ccc=00000025}', "");
    Expect(0, 1474, '\P{Is_Ccc=00000025}', "");
    Expect(1, 1474, '\P{^Is_Ccc=00000025}', "");
    Expect(0, 1475, '\p{Is_Ccc=00000025}', "");
    Expect(1, 1475, '\p{^Is_Ccc=00000025}', "");
    Expect(1, 1475, '\P{Is_Ccc=00000025}', "");
    Expect(0, 1475, '\P{^Is_Ccc=00000025}', "");
    Error('\p{Canonical_Combining_Class=/a/ -ccc26}');
    Error('\P{Canonical_Combining_Class=/a/ -ccc26}');
    Expect(1, 64286, '\p{Canonical_Combining_Class=:\ACCC26\z:}', "");;
    Expect(0, 64287, '\p{Canonical_Combining_Class=:\ACCC26\z:}', "");;
    Expect(1, 64286, '\p{Canonical_Combining_Class=ccc26}', "");
    Expect(0, 64286, '\p{^Canonical_Combining_Class=ccc26}', "");
    Expect(0, 64286, '\P{Canonical_Combining_Class=ccc26}', "");
    Expect(1, 64286, '\P{^Canonical_Combining_Class=ccc26}', "");
    Expect(0, 64287, '\p{Canonical_Combining_Class=ccc26}', "");
    Expect(1, 64287, '\p{^Canonical_Combining_Class=ccc26}', "");
    Expect(1, 64287, '\P{Canonical_Combining_Class=ccc26}', "");
    Expect(0, 64287, '\P{^Canonical_Combining_Class=ccc26}', "");
    Expect(1, 64286, '\p{Canonical_Combining_Class=:\Accc26\z:}', "");;
    Expect(0, 64287, '\p{Canonical_Combining_Class=:\Accc26\z:}', "");;
    Expect(1, 64286, '\p{Canonical_Combining_Class=-CCC26}', "");
    Expect(0, 64286, '\p{^Canonical_Combining_Class=-CCC26}', "");
    Expect(0, 64286, '\P{Canonical_Combining_Class=-CCC26}', "");
    Expect(1, 64286, '\P{^Canonical_Combining_Class=-CCC26}', "");
    Expect(0, 64287, '\p{Canonical_Combining_Class=-CCC26}', "");
    Expect(1, 64287, '\p{^Canonical_Combining_Class=-CCC26}', "");
    Expect(1, 64287, '\P{Canonical_Combining_Class=-CCC26}', "");
    Expect(0, 64287, '\P{^Canonical_Combining_Class=-CCC26}', "");
    Error('\p{Ccc=	0_0_0_0_0_26/a/}');
    Error('\P{Ccc=	0_0_0_0_0_26/a/}');
    Expect(1, 64286, '\p{Ccc=:\A26\z:}', "");;
    Expect(0, 64287, '\p{Ccc=:\A26\z:}', "");;
    Expect(1, 64286, '\p{Ccc=000000026}', "");
    Expect(0, 64286, '\p{^Ccc=000000026}', "");
    Expect(0, 64286, '\P{Ccc=000000026}', "");
    Expect(1, 64286, '\P{^Ccc=000000026}', "");
    Expect(0, 64287, '\p{Ccc=000000026}', "");
    Expect(1, 64287, '\p{^Ccc=000000026}', "");
    Expect(1, 64287, '\P{Ccc=000000026}', "");
    Expect(0, 64287, '\P{^Ccc=000000026}', "");
    Error('\p{Is_Canonical_Combining_Class=:= _CCC26}');
    Error('\P{Is_Canonical_Combining_Class=:= _CCC26}');
    Expect(1, 64286, '\p{Is_Canonical_Combining_Class=ccc26}', "");
    Expect(0, 64286, '\p{^Is_Canonical_Combining_Class=ccc26}', "");
    Expect(0, 64286, '\P{Is_Canonical_Combining_Class=ccc26}', "");
    Expect(1, 64286, '\P{^Is_Canonical_Combining_Class=ccc26}', "");
    Expect(0, 64287, '\p{Is_Canonical_Combining_Class=ccc26}', "");
    Expect(1, 64287, '\p{^Is_Canonical_Combining_Class=ccc26}', "");
    Expect(1, 64287, '\P{Is_Canonical_Combining_Class=ccc26}', "");
    Expect(0, 64287, '\P{^Is_Canonical_Combining_Class=ccc26}', "");
    Expect(1, 64286, '\p{Is_Canonical_Combining_Class=_ ccc26}', "");
    Expect(0, 64286, '\p{^Is_Canonical_Combining_Class=_ ccc26}', "");
    Expect(0, 64286, '\P{Is_Canonical_Combining_Class=_ ccc26}', "");
    Expect(1, 64286, '\P{^Is_Canonical_Combining_Class=_ ccc26}', "");
    Expect(0, 64287, '\p{Is_Canonical_Combining_Class=_ ccc26}', "");
    Expect(1, 64287, '\p{^Is_Canonical_Combining_Class=_ ccc26}', "");
    Expect(1, 64287, '\P{Is_Canonical_Combining_Class=_ ccc26}', "");
    Expect(0, 64287, '\P{^Is_Canonical_Combining_Class=_ ccc26}', "");
    Error('\p{Is_Ccc:	:= 	26}');
    Error('\P{Is_Ccc:	:= 	26}');
    Expect(1, 64286, '\p{Is_Ccc=0_0_0_0_0_0_0_26}', "");
    Expect(0, 64286, '\p{^Is_Ccc=0_0_0_0_0_0_0_26}', "");
    Expect(0, 64286, '\P{Is_Ccc=0_0_0_0_0_0_0_26}', "");
    Expect(1, 64286, '\P{^Is_Ccc=0_0_0_0_0_0_0_26}', "");
    Expect(0, 64287, '\p{Is_Ccc=0_0_0_0_0_0_0_26}', "");
    Expect(1, 64287, '\p{^Is_Ccc=0_0_0_0_0_0_0_26}', "");
    Expect(1, 64287, '\P{Is_Ccc=0_0_0_0_0_0_0_26}', "");
    Expect(0, 64287, '\P{^Is_Ccc=0_0_0_0_0_0_0_26}', "");
    Error('\p{Canonical_Combining_Class=:=_ccc27}');
    Error('\P{Canonical_Combining_Class=:=_ccc27}');
    Expect(1, 2288, '\p{Canonical_Combining_Class=:\ACCC27\z:}', "");;
    Expect(0, 2289, '\p{Canonical_Combining_Class=:\ACCC27\z:}', "");;
    Expect(1, 2288, '\p{Canonical_Combining_Class=ccc27}', "");
    Expect(0, 2288, '\p{^Canonical_Combining_Class=ccc27}', "");
    Expect(0, 2288, '\P{Canonical_Combining_Class=ccc27}', "");
    Expect(1, 2288, '\P{^Canonical_Combining_Class=ccc27}', "");
    Expect(0, 2289, '\p{Canonical_Combining_Class=ccc27}', "");
    Expect(1, 2289, '\p{^Canonical_Combining_Class=ccc27}', "");
    Expect(1, 2289, '\P{Canonical_Combining_Class=ccc27}', "");
    Expect(0, 2289, '\P{^Canonical_Combining_Class=ccc27}', "");
    Expect(1, 2288, '\p{Canonical_Combining_Class=:\Accc27\z:}', "");;
    Expect(0, 2289, '\p{Canonical_Combining_Class=:\Accc27\z:}', "");;
    Expect(1, 2288, '\p{Canonical_Combining_Class=_CCC27}', "");
    Expect(0, 2288, '\p{^Canonical_Combining_Class=_CCC27}', "");
    Expect(0, 2288, '\P{Canonical_Combining_Class=_CCC27}', "");
    Expect(1, 2288, '\P{^Canonical_Combining_Class=_CCC27}', "");
    Expect(0, 2289, '\p{Canonical_Combining_Class=_CCC27}', "");
    Expect(1, 2289, '\p{^Canonical_Combining_Class=_CCC27}', "");
    Expect(1, 2289, '\P{Canonical_Combining_Class=_CCC27}', "");
    Expect(0, 2289, '\P{^Canonical_Combining_Class=_CCC27}', "");
    Error('\p{Ccc=/a/_-00027}');
    Error('\P{Ccc=/a/_-00027}');
    Expect(1, 2288, '\p{Ccc=:\A27\z:}', "");;
    Expect(0, 2289, '\p{Ccc=:\A27\z:}', "");;
    Expect(1, 2288, '\p{Ccc=00000000027}', "");
    Expect(0, 2288, '\p{^Ccc=00000000027}', "");
    Expect(0, 2288, '\P{Ccc=00000000027}', "");
    Expect(1, 2288, '\P{^Ccc=00000000027}', "");
    Expect(0, 2289, '\p{Ccc=00000000027}', "");
    Expect(1, 2289, '\p{^Ccc=00000000027}', "");
    Expect(1, 2289, '\P{Ccc=00000000027}', "");
    Expect(0, 2289, '\P{^Ccc=00000000027}', "");
    Error('\p{Is_Canonical_Combining_Class=	/a/CCC27}');
    Error('\P{Is_Canonical_Combining_Class=	/a/CCC27}');
    Expect(1, 2288, '\p{Is_Canonical_Combining_Class=ccc27}', "");
    Expect(0, 2288, '\p{^Is_Canonical_Combining_Class=ccc27}', "");
    Expect(0, 2288, '\P{Is_Canonical_Combining_Class=ccc27}', "");
    Expect(1, 2288, '\P{^Is_Canonical_Combining_Class=ccc27}', "");
    Expect(0, 2289, '\p{Is_Canonical_Combining_Class=ccc27}', "");
    Expect(1, 2289, '\p{^Is_Canonical_Combining_Class=ccc27}', "");
    Expect(1, 2289, '\P{Is_Canonical_Combining_Class=ccc27}', "");
    Expect(0, 2289, '\P{^Is_Canonical_Combining_Class=ccc27}', "");
    Expect(1, 2288, '\p{Is_Canonical_Combining_Class=_ccc27}', "");
    Expect(0, 2288, '\p{^Is_Canonical_Combining_Class=_ccc27}', "");
    Expect(0, 2288, '\P{Is_Canonical_Combining_Class=_ccc27}', "");
    Expect(1, 2288, '\P{^Is_Canonical_Combining_Class=_ccc27}', "");
    Expect(0, 2289, '\p{Is_Canonical_Combining_Class=_ccc27}', "");
    Expect(1, 2289, '\p{^Is_Canonical_Combining_Class=_ccc27}', "");
    Expect(1, 2289, '\P{Is_Canonical_Combining_Class=_ccc27}', "");
    Expect(0, 2289, '\P{^Is_Canonical_Combining_Class=_ccc27}', "");
    Error('\p{Is_Ccc=-/a/+0027}');
    Error('\P{Is_Ccc=-/a/+0027}');
    Expect(1, 2288, '\p{Is_Ccc=00_00_00_00_02_7}', "");
    Expect(0, 2288, '\p{^Is_Ccc=00_00_00_00_02_7}', "");
    Expect(0, 2288, '\P{Is_Ccc=00_00_00_00_02_7}', "");
    Expect(1, 2288, '\P{^Is_Ccc=00_00_00_00_02_7}', "");
    Expect(0, 2289, '\p{Is_Ccc=00_00_00_00_02_7}', "");
    Expect(1, 2289, '\p{^Is_Ccc=00_00_00_00_02_7}', "");
    Expect(1, 2289, '\P{Is_Ccc=00_00_00_00_02_7}', "");
    Expect(0, 2289, '\P{^Is_Ccc=00_00_00_00_02_7}', "");
    Error('\p{Canonical_Combining_Class= -CCC28:=}');
    Error('\P{Canonical_Combining_Class= -CCC28:=}');
    Expect(1, 2289, '\p{Canonical_Combining_Class=:\ACCC28\z:}', "");;
    Expect(0, 2290, '\p{Canonical_Combining_Class=:\ACCC28\z:}', "");;
    Expect(1, 2289, '\p{Canonical_Combining_Class=ccc28}', "");
    Expect(0, 2289, '\p{^Canonical_Combining_Class=ccc28}', "");
    Expect(0, 2289, '\P{Canonical_Combining_Class=ccc28}', "");
    Expect(1, 2289, '\P{^Canonical_Combining_Class=ccc28}', "");
    Expect(0, 2290, '\p{Canonical_Combining_Class=ccc28}', "");
    Expect(1, 2290, '\p{^Canonical_Combining_Class=ccc28}', "");
    Expect(1, 2290, '\P{Canonical_Combining_Class=ccc28}', "");
    Expect(0, 2290, '\P{^Canonical_Combining_Class=ccc28}', "");
    Expect(1, 2289, '\p{Canonical_Combining_Class=:\Accc28\z:}', "");;
    Expect(0, 2290, '\p{Canonical_Combining_Class=:\Accc28\z:}', "");;
    Error('\p{Ccc:		:=00000028}');
    Error('\P{Ccc:		:=00000028}');
    Expect(1, 2289, '\p{Ccc=:\A28\z:}', "");;
    Expect(0, 2290, '\p{Ccc=:\A28\z:}', "");;
    Expect(1, 2289, '\p{Ccc=0_0_0_0_0_00028}', "");
    Expect(0, 2289, '\p{^Ccc=0_0_0_0_0_00028}', "");
    Expect(0, 2289, '\P{Ccc=0_0_0_0_0_00028}', "");
    Expect(1, 2289, '\P{^Ccc=0_0_0_0_0_00028}', "");
    Expect(0, 2290, '\p{Ccc=0_0_0_0_0_00028}', "");
    Expect(1, 2290, '\p{^Ccc=0_0_0_0_0_00028}', "");
    Expect(1, 2290, '\P{Ccc=0_0_0_0_0_00028}', "");
    Expect(0, 2290, '\P{^Ccc=0_0_0_0_0_00028}', "");
    Error('\p{Is_Canonical_Combining_Class=--CCC28/a/}');
    Error('\P{Is_Canonical_Combining_Class=--CCC28/a/}');
    Expect(1, 2289, '\p{Is_Canonical_Combining_Class:	ccc28}', "");
    Expect(0, 2289, '\p{^Is_Canonical_Combining_Class:	ccc28}', "");
    Expect(0, 2289, '\P{Is_Canonical_Combining_Class:	ccc28}', "");
    Expect(1, 2289, '\P{^Is_Canonical_Combining_Class:	ccc28}', "");
    Expect(0, 2290, '\p{Is_Canonical_Combining_Class:	ccc28}', "");
    Expect(1, 2290, '\p{^Is_Canonical_Combining_Class:	ccc28}', "");
    Expect(1, 2290, '\P{Is_Canonical_Combining_Class:	ccc28}', "");
    Expect(0, 2290, '\P{^Is_Canonical_Combining_Class:	ccc28}', "");
    Expect(1, 2289, '\p{Is_Canonical_Combining_Class= 	CCC28}', "");
    Expect(0, 2289, '\p{^Is_Canonical_Combining_Class= 	CCC28}', "");
    Expect(0, 2289, '\P{Is_Canonical_Combining_Class= 	CCC28}', "");
    Expect(1, 2289, '\P{^Is_Canonical_Combining_Class= 	CCC28}', "");
    Expect(0, 2290, '\p{Is_Canonical_Combining_Class= 	CCC28}', "");
    Expect(1, 2290, '\p{^Is_Canonical_Combining_Class= 	CCC28}', "");
    Expect(1, 2290, '\P{Is_Canonical_Combining_Class= 	CCC28}', "");
    Expect(0, 2290, '\P{^Is_Canonical_Combining_Class= 	CCC28}', "");
    Error('\p{Is_Ccc=/a/	_00_00_00_00_28}');
    Error('\P{Is_Ccc=/a/	_00_00_00_00_28}');
    Expect(1, 2289, '\p{Is_Ccc:2_8}', "");
    Expect(0, 2289, '\p{^Is_Ccc:2_8}', "");
    Expect(0, 2289, '\P{Is_Ccc:2_8}', "");
    Expect(1, 2289, '\P{^Is_Ccc:2_8}', "");
    Expect(0, 2290, '\p{Is_Ccc:2_8}', "");
    Expect(1, 2290, '\p{^Is_Ccc:2_8}', "");
    Expect(1, 2290, '\P{Is_Ccc:2_8}', "");
    Expect(0, 2290, '\P{^Is_Ccc:2_8}', "");
    Error('\p{Canonical_Combining_Class= /a/CCC29}');
    Error('\P{Canonical_Combining_Class= /a/CCC29}');
    Expect(1, 2290, '\p{Canonical_Combining_Class=:\ACCC29\z:}', "");;
    Expect(0, 2291, '\p{Canonical_Combining_Class=:\ACCC29\z:}', "");;
    Expect(1, 2290, '\p{Canonical_Combining_Class=ccc29}', "");
    Expect(0, 2290, '\p{^Canonical_Combining_Class=ccc29}', "");
    Expect(0, 2290, '\P{Canonical_Combining_Class=ccc29}', "");
    Expect(1, 2290, '\P{^Canonical_Combining_Class=ccc29}', "");
    Expect(0, 2291, '\p{Canonical_Combining_Class=ccc29}', "");
    Expect(1, 2291, '\p{^Canonical_Combining_Class=ccc29}', "");
    Expect(1, 2291, '\P{Canonical_Combining_Class=ccc29}', "");
    Expect(0, 2291, '\P{^Canonical_Combining_Class=ccc29}', "");
    Expect(1, 2290, '\p{Canonical_Combining_Class=:\Accc29\z:}', "");;
    Expect(0, 2291, '\p{Canonical_Combining_Class=:\Accc29\z:}', "");;
    Expect(1, 2290, '\p{Canonical_Combining_Class=_ccc29}', "");
    Expect(0, 2290, '\p{^Canonical_Combining_Class=_ccc29}', "");
    Expect(0, 2290, '\P{Canonical_Combining_Class=_ccc29}', "");
    Expect(1, 2290, '\P{^Canonical_Combining_Class=_ccc29}', "");
    Expect(0, 2291, '\p{Canonical_Combining_Class=_ccc29}', "");
    Expect(1, 2291, '\p{^Canonical_Combining_Class=_ccc29}', "");
    Expect(1, 2291, '\P{Canonical_Combining_Class=_ccc29}', "");
    Expect(0, 2291, '\P{^Canonical_Combining_Class=_ccc29}', "");
    Error('\p{Ccc=	:=+00000000029}');
    Error('\P{Ccc=	:=+00000000029}');
    Expect(1, 2290, '\p{Ccc=:\A29\z:}', "");;
    Expect(0, 2291, '\p{Ccc=:\A29\z:}', "");;
    Expect(1, 2290, '\p{Ccc:   +0_0_0_029}', "");
    Expect(0, 2290, '\p{^Ccc:   +0_0_0_029}', "");
    Expect(0, 2290, '\P{Ccc:   +0_0_0_029}', "");
    Expect(1, 2290, '\P{^Ccc:   +0_0_0_029}', "");
    Expect(0, 2291, '\p{Ccc:   +0_0_0_029}', "");
    Expect(1, 2291, '\p{^Ccc:   +0_0_0_029}', "");
    Expect(1, 2291, '\P{Ccc:   +0_0_0_029}', "");
    Expect(0, 2291, '\P{^Ccc:   +0_0_0_029}', "");
    Error('\p{Is_Canonical_Combining_Class=:=-	CCC29}');
    Error('\P{Is_Canonical_Combining_Class=:=-	CCC29}');
    Expect(1, 2290, '\p{Is_Canonical_Combining_Class=ccc29}', "");
    Expect(0, 2290, '\p{^Is_Canonical_Combining_Class=ccc29}', "");
    Expect(0, 2290, '\P{Is_Canonical_Combining_Class=ccc29}', "");
    Expect(1, 2290, '\P{^Is_Canonical_Combining_Class=ccc29}', "");
    Expect(0, 2291, '\p{Is_Canonical_Combining_Class=ccc29}', "");
    Expect(1, 2291, '\p{^Is_Canonical_Combining_Class=ccc29}', "");
    Expect(1, 2291, '\P{Is_Canonical_Combining_Class=ccc29}', "");
    Expect(0, 2291, '\P{^Is_Canonical_Combining_Class=ccc29}', "");
    Expect(1, 2290, '\p{Is_Canonical_Combining_Class=_ CCC29}', "");
    Expect(0, 2290, '\p{^Is_Canonical_Combining_Class=_ CCC29}', "");
    Expect(0, 2290, '\P{Is_Canonical_Combining_Class=_ CCC29}', "");
    Expect(1, 2290, '\P{^Is_Canonical_Combining_Class=_ CCC29}', "");
    Expect(0, 2291, '\p{Is_Canonical_Combining_Class=_ CCC29}', "");
    Expect(1, 2291, '\p{^Is_Canonical_Combining_Class=_ CCC29}', "");
    Expect(1, 2291, '\P{Is_Canonical_Combining_Class=_ CCC29}', "");
    Expect(0, 2291, '\P{^Is_Canonical_Combining_Class=_ CCC29}', "");
    Error('\p{Is_Ccc=--0000029/a/}');
    Error('\P{Is_Ccc=--0000029/a/}');
    Expect(1, 2290, '\p{Is_Ccc:	00_00_00_00_29}', "");
    Expect(0, 2290, '\p{^Is_Ccc:	00_00_00_00_29}', "");
    Expect(0, 2290, '\P{Is_Ccc:	00_00_00_00_29}', "");
    Expect(1, 2290, '\P{^Is_Ccc:	00_00_00_00_29}', "");
    Expect(0, 2291, '\p{Is_Ccc:	00_00_00_00_29}', "");
    Expect(1, 2291, '\p{^Is_Ccc:	00_00_00_00_29}', "");
    Expect(1, 2291, '\P{Is_Ccc:	00_00_00_00_29}', "");
    Expect(0, 2291, '\P{^Is_Ccc:	00_00_00_00_29}', "");
    Error('\p{Canonical_Combining_Class=	:=ccc30}');
    Error('\P{Canonical_Combining_Class=	:=ccc30}');
    Expect(1, 1614, '\p{Canonical_Combining_Class=:\ACCC30\z:}', "");;
    Expect(0, 1615, '\p{Canonical_Combining_Class=:\ACCC30\z:}', "");;
    Expect(1, 1614, '\p{Canonical_Combining_Class=ccc30}', "");
    Expect(0, 1614, '\p{^Canonical_Combining_Class=ccc30}', "");
    Expect(0, 1614, '\P{Canonical_Combining_Class=ccc30}', "");
    Expect(1, 1614, '\P{^Canonical_Combining_Class=ccc30}', "");
    Expect(0, 1615, '\p{Canonical_Combining_Class=ccc30}', "");
    Expect(1, 1615, '\p{^Canonical_Combining_Class=ccc30}', "");
    Expect(1, 1615, '\P{Canonical_Combining_Class=ccc30}', "");
    Expect(0, 1615, '\P{^Canonical_Combining_Class=ccc30}', "");
    Expect(1, 1614, '\p{Canonical_Combining_Class=:\Accc30\z:}', "");;
    Expect(0, 1615, '\p{Canonical_Combining_Class=:\Accc30\z:}', "");;
    Expect(1, 1614, '\p{Canonical_Combining_Class=- CCC30}', "");
    Expect(0, 1614, '\p{^Canonical_Combining_Class=- CCC30}', "");
    Expect(0, 1614, '\P{Canonical_Combining_Class=- CCC30}', "");
    Expect(1, 1614, '\P{^Canonical_Combining_Class=- CCC30}', "");
    Expect(0, 1615, '\p{Canonical_Combining_Class=- CCC30}', "");
    Expect(1, 1615, '\p{^Canonical_Combining_Class=- CCC30}', "");
    Expect(1, 1615, '\P{Canonical_Combining_Class=- CCC30}', "");
    Expect(0, 1615, '\P{^Canonical_Combining_Class=- CCC30}', "");
    Error('\p{Ccc=-:=30}');
    Error('\P{Ccc=-:=30}');
    Expect(1, 1614, '\p{Ccc=:\A30\z:}', "");;
    Expect(0, 1615, '\p{Ccc=:\A30\z:}', "");;
    Expect(1, 1614, '\p{Ccc=00_00_00_03_0}', "");
    Expect(0, 1614, '\p{^Ccc=00_00_00_03_0}', "");
    Expect(0, 1614, '\P{Ccc=00_00_00_03_0}', "");
    Expect(1, 1614, '\P{^Ccc=00_00_00_03_0}', "");
    Expect(0, 1615, '\p{Ccc=00_00_00_03_0}', "");
    Expect(1, 1615, '\p{^Ccc=00_00_00_03_0}', "");
    Expect(1, 1615, '\P{Ccc=00_00_00_03_0}', "");
    Expect(0, 1615, '\P{^Ccc=00_00_00_03_0}', "");
    Error('\p{Is_Canonical_Combining_Class=	/a/ccc30}');
    Error('\P{Is_Canonical_Combining_Class=	/a/ccc30}');
    Expect(1, 1614, '\p{Is_Canonical_Combining_Class=ccc30}', "");
    Expect(0, 1614, '\p{^Is_Canonical_Combining_Class=ccc30}', "");
    Expect(0, 1614, '\P{Is_Canonical_Combining_Class=ccc30}', "");
    Expect(1, 1614, '\P{^Is_Canonical_Combining_Class=ccc30}', "");
    Expect(0, 1615, '\p{Is_Canonical_Combining_Class=ccc30}', "");
    Expect(1, 1615, '\p{^Is_Canonical_Combining_Class=ccc30}', "");
    Expect(1, 1615, '\P{Is_Canonical_Combining_Class=ccc30}', "");
    Expect(0, 1615, '\P{^Is_Canonical_Combining_Class=ccc30}', "");
    Expect(1, 1614, '\p{Is_Canonical_Combining_Class=-CCC30}', "");
    Expect(0, 1614, '\p{^Is_Canonical_Combining_Class=-CCC30}', "");
    Expect(0, 1614, '\P{Is_Canonical_Combining_Class=-CCC30}', "");
    Expect(1, 1614, '\P{^Is_Canonical_Combining_Class=-CCC30}', "");
    Expect(0, 1615, '\p{Is_Canonical_Combining_Class=-CCC30}', "");
    Expect(1, 1615, '\p{^Is_Canonical_Combining_Class=-CCC30}', "");
    Expect(1, 1615, '\P{Is_Canonical_Combining_Class=-CCC30}', "");
    Expect(0, 1615, '\P{^Is_Canonical_Combining_Class=-CCC30}', "");
    Error('\p{Is_Ccc=-/a/0003_0}');
    Error('\P{Is_Ccc=-/a/0003_0}');
    Expect(1, 1614, '\p{Is_Ccc=003_0}', "");
    Expect(0, 1614, '\p{^Is_Ccc=003_0}', "");
    Expect(0, 1614, '\P{Is_Ccc=003_0}', "");
    Expect(1, 1614, '\P{^Is_Ccc=003_0}', "");
    Expect(0, 1615, '\p{Is_Ccc=003_0}', "");
    Expect(1, 1615, '\p{^Is_Ccc=003_0}', "");
    Expect(1, 1615, '\P{Is_Ccc=003_0}', "");
    Expect(0, 1615, '\P{^Is_Ccc=003_0}', "");
    Error('\p{Canonical_Combining_Class=/a/_	CCC31}');
    Error('\P{Canonical_Combining_Class=/a/_	CCC31}');
    Expect(1, 1615, '\p{Canonical_Combining_Class=:\ACCC31\z:}', "");;
    Expect(0, 1616, '\p{Canonical_Combining_Class=:\ACCC31\z:}', "");;
    Expect(1, 1615, '\p{Canonical_Combining_Class=ccc31}', "");
    Expect(0, 1615, '\p{^Canonical_Combining_Class=ccc31}', "");
    Expect(0, 1615, '\P{Canonical_Combining_Class=ccc31}', "");
    Expect(1, 1615, '\P{^Canonical_Combining_Class=ccc31}', "");
    Expect(0, 1616, '\p{Canonical_Combining_Class=ccc31}', "");
    Expect(1, 1616, '\p{^Canonical_Combining_Class=ccc31}', "");
    Expect(1, 1616, '\P{Canonical_Combining_Class=ccc31}', "");
    Expect(0, 1616, '\P{^Canonical_Combining_Class=ccc31}', "");
    Expect(1, 1615, '\p{Canonical_Combining_Class=:\Accc31\z:}', "");;
    Expect(0, 1616, '\p{Canonical_Combining_Class=:\Accc31\z:}', "");;
    Expect(1, 1615, '\p{Canonical_Combining_Class=_-ccc31}', "");
    Expect(0, 1615, '\p{^Canonical_Combining_Class=_-ccc31}', "");
    Expect(0, 1615, '\P{Canonical_Combining_Class=_-ccc31}', "");
    Expect(1, 1615, '\P{^Canonical_Combining_Class=_-ccc31}', "");
    Expect(0, 1616, '\p{Canonical_Combining_Class=_-ccc31}', "");
    Expect(1, 1616, '\p{^Canonical_Combining_Class=_-ccc31}', "");
    Expect(1, 1616, '\P{Canonical_Combining_Class=_-ccc31}', "");
    Expect(0, 1616, '\P{^Canonical_Combining_Class=_-ccc31}', "");
    Error('\p{Ccc=_0003_1/a/}');
    Error('\P{Ccc=_0003_1/a/}');
    Expect(1, 1615, '\p{Ccc=:\A31\z:}', "");;
    Expect(0, 1616, '\p{Ccc=:\A31\z:}', "");;
    Expect(1, 1615, '\p{Ccc:   00000000031}', "");
    Expect(0, 1615, '\p{^Ccc:   00000000031}', "");
    Expect(0, 1615, '\P{Ccc:   00000000031}', "");
    Expect(1, 1615, '\P{^Ccc:   00000000031}', "");
    Expect(0, 1616, '\p{Ccc:   00000000031}', "");
    Expect(1, 1616, '\p{^Ccc:   00000000031}', "");
    Expect(1, 1616, '\P{Ccc:   00000000031}', "");
    Expect(0, 1616, '\P{^Ccc:   00000000031}', "");
    Error('\p{Is_Canonical_Combining_Class=_ccc31:=}');
    Error('\P{Is_Canonical_Combining_Class=_ccc31:=}');
    Expect(1, 1615, '\p{Is_Canonical_Combining_Class=ccc31}', "");
    Expect(0, 1615, '\p{^Is_Canonical_Combining_Class=ccc31}', "");
    Expect(0, 1615, '\P{Is_Canonical_Combining_Class=ccc31}', "");
    Expect(1, 1615, '\P{^Is_Canonical_Combining_Class=ccc31}', "");
    Expect(0, 1616, '\p{Is_Canonical_Combining_Class=ccc31}', "");
    Expect(1, 1616, '\p{^Is_Canonical_Combining_Class=ccc31}', "");
    Expect(1, 1616, '\P{Is_Canonical_Combining_Class=ccc31}', "");
    Expect(0, 1616, '\P{^Is_Canonical_Combining_Class=ccc31}', "");
    Expect(1, 1615, '\p{Is_Canonical_Combining_Class=_	ccc31}', "");
    Expect(0, 1615, '\p{^Is_Canonical_Combining_Class=_	ccc31}', "");
    Expect(0, 1615, '\P{Is_Canonical_Combining_Class=_	ccc31}', "");
    Expect(1, 1615, '\P{^Is_Canonical_Combining_Class=_	ccc31}', "");
    Expect(0, 1616, '\p{Is_Canonical_Combining_Class=_	ccc31}', "");
    Expect(1, 1616, '\p{^Is_Canonical_Combining_Class=_	ccc31}', "");
    Expect(1, 1616, '\P{Is_Canonical_Combining_Class=_	ccc31}', "");
    Expect(0, 1616, '\P{^Is_Canonical_Combining_Class=_	ccc31}', "");
    Error('\p{Is_Ccc= -31:=}');
    Error('\P{Is_Ccc= -31:=}');
    Expect(1, 1615, '\p{Is_Ccc=000003_1}', "");
    Expect(0, 1615, '\p{^Is_Ccc=000003_1}', "");
    Expect(0, 1615, '\P{Is_Ccc=000003_1}', "");
    Expect(1, 1615, '\P{^Is_Ccc=000003_1}', "");
    Expect(0, 1616, '\p{Is_Ccc=000003_1}', "");
    Expect(1, 1616, '\p{^Is_Ccc=000003_1}', "");
    Expect(1, 1616, '\P{Is_Ccc=000003_1}', "");
    Expect(0, 1616, '\P{^Is_Ccc=000003_1}', "");
    Error('\p{Canonical_Combining_Class=:= 	CCC32}');
    Error('\P{Canonical_Combining_Class=:= 	CCC32}');
    Expect(1, 1616, '\p{Canonical_Combining_Class=:\ACCC32\z:}', "");;
    Expect(0, 1617, '\p{Canonical_Combining_Class=:\ACCC32\z:}', "");;
    Expect(1, 1616, '\p{Canonical_Combining_Class=ccc32}', "");
    Expect(0, 1616, '\p{^Canonical_Combining_Class=ccc32}', "");
    Expect(0, 1616, '\P{Canonical_Combining_Class=ccc32}', "");
    Expect(1, 1616, '\P{^Canonical_Combining_Class=ccc32}', "");
    Expect(0, 1617, '\p{Canonical_Combining_Class=ccc32}', "");
    Expect(1, 1617, '\p{^Canonical_Combining_Class=ccc32}', "");
    Expect(1, 1617, '\P{Canonical_Combining_Class=ccc32}', "");
    Expect(0, 1617, '\P{^Canonical_Combining_Class=ccc32}', "");
    Expect(1, 1616, '\p{Canonical_Combining_Class=:\Accc32\z:}', "");;
    Expect(0, 1617, '\p{Canonical_Combining_Class=:\Accc32\z:}', "");;
    Expect(1, 1616, '\p{Canonical_Combining_Class=-CCC32}', "");
    Expect(0, 1616, '\p{^Canonical_Combining_Class=-CCC32}', "");
    Expect(0, 1616, '\P{Canonical_Combining_Class=-CCC32}', "");
    Expect(1, 1616, '\P{^Canonical_Combining_Class=-CCC32}', "");
    Expect(0, 1617, '\p{Canonical_Combining_Class=-CCC32}', "");
    Expect(1, 1617, '\p{^Canonical_Combining_Class=-CCC32}', "");
    Expect(1, 1617, '\P{Canonical_Combining_Class=-CCC32}', "");
    Expect(0, 1617, '\P{^Canonical_Combining_Class=-CCC32}', "");
    Error('\p{Ccc= _0000032:=}');
    Error('\P{Ccc= _0000032:=}');
    Expect(1, 1616, '\p{Ccc=:\A32\z:}', "");;
    Expect(0, 1617, '\p{Ccc=:\A32\z:}', "");;
    Expect(1, 1616, '\p{Ccc=+00000_00003_2}', "");
    Expect(0, 1616, '\p{^Ccc=+00000_00003_2}', "");
    Expect(0, 1616, '\P{Ccc=+00000_00003_2}', "");
    Expect(1, 1616, '\P{^Ccc=+00000_00003_2}', "");
    Expect(0, 1617, '\p{Ccc=+00000_00003_2}', "");
    Expect(1, 1617, '\p{^Ccc=+00000_00003_2}', "");
    Expect(1, 1617, '\P{Ccc=+00000_00003_2}', "");
    Expect(0, 1617, '\P{^Ccc=+00000_00003_2}', "");
    Error('\p{Is_Canonical_Combining_Class:/a/CCC32}');
    Error('\P{Is_Canonical_Combining_Class:/a/CCC32}');
    Expect(1, 1616, '\p{Is_Canonical_Combining_Class: ccc32}', "");
    Expect(0, 1616, '\p{^Is_Canonical_Combining_Class: ccc32}', "");
    Expect(0, 1616, '\P{Is_Canonical_Combining_Class: ccc32}', "");
    Expect(1, 1616, '\P{^Is_Canonical_Combining_Class: ccc32}', "");
    Expect(0, 1617, '\p{Is_Canonical_Combining_Class: ccc32}', "");
    Expect(1, 1617, '\p{^Is_Canonical_Combining_Class: ccc32}', "");
    Expect(1, 1617, '\P{Is_Canonical_Combining_Class: ccc32}', "");
    Expect(0, 1617, '\P{^Is_Canonical_Combining_Class: ccc32}', "");
    Expect(1, 1616, '\p{Is_Canonical_Combining_Class: _ CCC32}', "");
    Expect(0, 1616, '\p{^Is_Canonical_Combining_Class: _ CCC32}', "");
    Expect(0, 1616, '\P{Is_Canonical_Combining_Class: _ CCC32}', "");
    Expect(1, 1616, '\P{^Is_Canonical_Combining_Class: _ CCC32}', "");
    Expect(0, 1617, '\p{Is_Canonical_Combining_Class: _ CCC32}', "");
    Expect(1, 1617, '\p{^Is_Canonical_Combining_Class: _ CCC32}', "");
    Expect(1, 1617, '\P{Is_Canonical_Combining_Class: _ CCC32}', "");
    Expect(0, 1617, '\P{^Is_Canonical_Combining_Class: _ CCC32}', "");
    Error('\p{Is_Ccc=-:=032}');
    Error('\P{Is_Ccc=-:=032}');
    Expect(1, 1616, '\p{Is_Ccc:	00000000032}', "");
    Expect(0, 1616, '\p{^Is_Ccc:	00000000032}', "");
    Expect(0, 1616, '\P{Is_Ccc:	00000000032}', "");
    Expect(1, 1616, '\P{^Is_Ccc:	00000000032}', "");
    Expect(0, 1617, '\p{Is_Ccc:	00000000032}', "");
    Expect(1, 1617, '\p{^Is_Ccc:	00000000032}', "");
    Expect(1, 1617, '\P{Is_Ccc:	00000000032}', "");
    Expect(0, 1617, '\P{^Is_Ccc:	00000000032}', "");
    Error('\p{Canonical_Combining_Class=/a/-_CCC33}');
    Error('\P{Canonical_Combining_Class=/a/-_CCC33}');
    Expect(1, 1617, '\p{Canonical_Combining_Class=:\ACCC33\z:}', "");;
    Expect(0, 1618, '\p{Canonical_Combining_Class=:\ACCC33\z:}', "");;
    Expect(1, 1617, '\p{Canonical_Combining_Class=ccc33}', "");
    Expect(0, 1617, '\p{^Canonical_Combining_Class=ccc33}', "");
    Expect(0, 1617, '\P{Canonical_Combining_Class=ccc33}', "");
    Expect(1, 1617, '\P{^Canonical_Combining_Class=ccc33}', "");
    Expect(0, 1618, '\p{Canonical_Combining_Class=ccc33}', "");
    Expect(1, 1618, '\p{^Canonical_Combining_Class=ccc33}', "");
    Expect(1, 1618, '\P{Canonical_Combining_Class=ccc33}', "");
    Expect(0, 1618, '\P{^Canonical_Combining_Class=ccc33}', "");
    Expect(1, 1617, '\p{Canonical_Combining_Class=:\Accc33\z:}', "");;
    Expect(0, 1618, '\p{Canonical_Combining_Class=:\Accc33\z:}', "");;
    Expect(1, 1617, '\p{Canonical_Combining_Class=_-ccc33}', "");
    Expect(0, 1617, '\p{^Canonical_Combining_Class=_-ccc33}', "");
    Expect(0, 1617, '\P{Canonical_Combining_Class=_-ccc33}', "");
    Expect(1, 1617, '\P{^Canonical_Combining_Class=_-ccc33}', "");
    Expect(0, 1618, '\p{Canonical_Combining_Class=_-ccc33}', "");
    Expect(1, 1618, '\p{^Canonical_Combining_Class=_-ccc33}', "");
    Expect(1, 1618, '\P{Canonical_Combining_Class=_-ccc33}', "");
    Expect(0, 1618, '\P{^Canonical_Combining_Class=_-ccc33}', "");
    Error('\p{Ccc=:=	000_000_003_3}');
    Error('\P{Ccc=:=	000_000_003_3}');
    Expect(1, 1617, '\p{Ccc=:\A33\z:}', "");;
    Expect(0, 1618, '\p{Ccc=:\A33\z:}', "");;
    Expect(1, 1617, '\p{Ccc=+0000033}', "");
    Expect(0, 1617, '\p{^Ccc=+0000033}', "");
    Expect(0, 1617, '\P{Ccc=+0000033}', "");
    Expect(1, 1617, '\P{^Ccc=+0000033}', "");
    Expect(0, 1618, '\p{Ccc=+0000033}', "");
    Expect(1, 1618, '\p{^Ccc=+0000033}', "");
    Expect(1, 1618, '\P{Ccc=+0000033}', "");
    Expect(0, 1618, '\P{^Ccc=+0000033}', "");
    Error('\p{Is_Canonical_Combining_Class=/a/  CCC33}');
    Error('\P{Is_Canonical_Combining_Class=/a/  CCC33}');
    Expect(1, 1617, '\p{Is_Canonical_Combining_Class=ccc33}', "");
    Expect(0, 1617, '\p{^Is_Canonical_Combining_Class=ccc33}', "");
    Expect(0, 1617, '\P{Is_Canonical_Combining_Class=ccc33}', "");
    Expect(1, 1617, '\P{^Is_Canonical_Combining_Class=ccc33}', "");
    Expect(0, 1618, '\p{Is_Canonical_Combining_Class=ccc33}', "");
    Expect(1, 1618, '\p{^Is_Canonical_Combining_Class=ccc33}', "");
    Expect(1, 1618, '\P{Is_Canonical_Combining_Class=ccc33}', "");
    Expect(0, 1618, '\P{^Is_Canonical_Combining_Class=ccc33}', "");
    Expect(1, 1617, '\p{Is_Canonical_Combining_Class=	-CCC33}', "");
    Expect(0, 1617, '\p{^Is_Canonical_Combining_Class=	-CCC33}', "");
    Expect(0, 1617, '\P{Is_Canonical_Combining_Class=	-CCC33}', "");
    Expect(1, 1617, '\P{^Is_Canonical_Combining_Class=	-CCC33}', "");
    Expect(0, 1618, '\p{Is_Canonical_Combining_Class=	-CCC33}', "");
    Expect(1, 1618, '\p{^Is_Canonical_Combining_Class=	-CCC33}', "");
    Expect(1, 1618, '\P{Is_Canonical_Combining_Class=	-CCC33}', "");
    Expect(0, 1618, '\P{^Is_Canonical_Combining_Class=	-CCC33}', "");
    Error('\p{Is_Ccc= _033:=}');
    Error('\P{Is_Ccc= _033:=}');
    Expect(1, 1617, '\p{Is_Ccc=+003_3}', "");
    Expect(0, 1617, '\p{^Is_Ccc=+003_3}', "");
    Expect(0, 1617, '\P{Is_Ccc=+003_3}', "");
    Expect(1, 1617, '\P{^Is_Ccc=+003_3}', "");
    Expect(0, 1618, '\p{Is_Ccc=+003_3}', "");
    Expect(1, 1618, '\p{^Is_Ccc=+003_3}', "");
    Expect(1, 1618, '\P{Is_Ccc=+003_3}', "");
    Expect(0, 1618, '\P{^Is_Ccc=+003_3}', "");
    Error('\p{Canonical_Combining_Class=:=__ccc34}');
    Error('\P{Canonical_Combining_Class=:=__ccc34}');
    Expect(1, 1618, '\p{Canonical_Combining_Class=:\ACCC34\z:}', "");;
    Expect(0, 1619, '\p{Canonical_Combining_Class=:\ACCC34\z:}', "");;
    Expect(1, 1618, '\p{Canonical_Combining_Class=ccc34}', "");
    Expect(0, 1618, '\p{^Canonical_Combining_Class=ccc34}', "");
    Expect(0, 1618, '\P{Canonical_Combining_Class=ccc34}', "");
    Expect(1, 1618, '\P{^Canonical_Combining_Class=ccc34}', "");
    Expect(0, 1619, '\p{Canonical_Combining_Class=ccc34}', "");
    Expect(1, 1619, '\p{^Canonical_Combining_Class=ccc34}', "");
    Expect(1, 1619, '\P{Canonical_Combining_Class=ccc34}', "");
    Expect(0, 1619, '\P{^Canonical_Combining_Class=ccc34}', "");
    Expect(1, 1618, '\p{Canonical_Combining_Class=:\Accc34\z:}', "");;
    Expect(0, 1619, '\p{Canonical_Combining_Class=:\Accc34\z:}', "");;
    Expect(1, 1618, '\p{Canonical_Combining_Class=	 CCC34}', "");
    Expect(0, 1618, '\p{^Canonical_Combining_Class=	 CCC34}', "");
    Expect(0, 1618, '\P{Canonical_Combining_Class=	 CCC34}', "");
    Expect(1, 1618, '\P{^Canonical_Combining_Class=	 CCC34}', "");
    Expect(0, 1619, '\p{Canonical_Combining_Class=	 CCC34}', "");
    Expect(1, 1619, '\p{^Canonical_Combining_Class=	 CCC34}', "");
    Expect(1, 1619, '\P{Canonical_Combining_Class=	 CCC34}', "");
    Expect(0, 1619, '\P{^Canonical_Combining_Class=	 CCC34}', "");
    Error('\p{Ccc=	-003_4/a/}');
    Error('\P{Ccc=	-003_4/a/}');
    Expect(1, 1618, '\p{Ccc=:\A34\z:}', "");;
    Expect(0, 1619, '\p{Ccc=:\A34\z:}', "");;
    Expect(1, 1618, '\p{Ccc=+0003_4}', "");
    Expect(0, 1618, '\p{^Ccc=+0003_4}', "");
    Expect(0, 1618, '\P{Ccc=+0003_4}', "");
    Expect(1, 1618, '\P{^Ccc=+0003_4}', "");
    Expect(0, 1619, '\p{Ccc=+0003_4}', "");
    Expect(1, 1619, '\p{^Ccc=+0003_4}', "");
    Expect(1, 1619, '\P{Ccc=+0003_4}', "");
    Expect(0, 1619, '\P{^Ccc=+0003_4}', "");
    Error('\p{Is_Canonical_Combining_Class=_ CCC34/a/}');
    Error('\P{Is_Canonical_Combining_Class=_ CCC34/a/}');
    Expect(1, 1618, '\p{Is_Canonical_Combining_Class=ccc34}', "");
    Expect(0, 1618, '\p{^Is_Canonical_Combining_Class=ccc34}', "");
    Expect(0, 1618, '\P{Is_Canonical_Combining_Class=ccc34}', "");
    Expect(1, 1618, '\P{^Is_Canonical_Combining_Class=ccc34}', "");
    Expect(0, 1619, '\p{Is_Canonical_Combining_Class=ccc34}', "");
    Expect(1, 1619, '\p{^Is_Canonical_Combining_Class=ccc34}', "");
    Expect(1, 1619, '\P{Is_Canonical_Combining_Class=ccc34}', "");
    Expect(0, 1619, '\P{^Is_Canonical_Combining_Class=ccc34}', "");
    Expect(1, 1618, '\p{Is_Canonical_Combining_Class=	 CCC34}', "");
    Expect(0, 1618, '\p{^Is_Canonical_Combining_Class=	 CCC34}', "");
    Expect(0, 1618, '\P{Is_Canonical_Combining_Class=	 CCC34}', "");
    Expect(1, 1618, '\P{^Is_Canonical_Combining_Class=	 CCC34}', "");
    Expect(0, 1619, '\p{Is_Canonical_Combining_Class=	 CCC34}', "");
    Expect(1, 1619, '\p{^Is_Canonical_Combining_Class=	 CCC34}', "");
    Expect(1, 1619, '\P{Is_Canonical_Combining_Class=	 CCC34}', "");
    Expect(0, 1619, '\P{^Is_Canonical_Combining_Class=	 CCC34}', "");
    Error('\p{Is_Ccc:		_003_4/a/}');
    Error('\P{Is_Ccc:		_003_4/a/}');
    Expect(1, 1618, '\p{Is_Ccc=0_0_0_0_0_00034}', "");
    Expect(0, 1618, '\p{^Is_Ccc=0_0_0_0_0_00034}', "");
    Expect(0, 1618, '\P{Is_Ccc=0_0_0_0_0_00034}', "");
    Expect(1, 1618, '\P{^Is_Ccc=0_0_0_0_0_00034}', "");
    Expect(0, 1619, '\p{Is_Ccc=0_0_0_0_0_00034}', "");
    Expect(1, 1619, '\p{^Is_Ccc=0_0_0_0_0_00034}', "");
    Expect(1, 1619, '\P{Is_Ccc=0_0_0_0_0_00034}', "");
    Expect(0, 1619, '\P{^Is_Ccc=0_0_0_0_0_00034}', "");
    Error('\p{Canonical_Combining_Class=_ CCC35/a/}');
    Error('\P{Canonical_Combining_Class=_ CCC35/a/}');
    Expect(1, 1648, '\p{Canonical_Combining_Class=:\ACCC35\z:}', "");;
    Expect(0, 1649, '\p{Canonical_Combining_Class=:\ACCC35\z:}', "");;
    Expect(1, 1648, '\p{Canonical_Combining_Class=ccc35}', "");
    Expect(0, 1648, '\p{^Canonical_Combining_Class=ccc35}', "");
    Expect(0, 1648, '\P{Canonical_Combining_Class=ccc35}', "");
    Expect(1, 1648, '\P{^Canonical_Combining_Class=ccc35}', "");
    Expect(0, 1649, '\p{Canonical_Combining_Class=ccc35}', "");
    Expect(1, 1649, '\p{^Canonical_Combining_Class=ccc35}', "");
    Expect(1, 1649, '\P{Canonical_Combining_Class=ccc35}', "");
    Expect(0, 1649, '\P{^Canonical_Combining_Class=ccc35}', "");
    Expect(1, 1648, '\p{Canonical_Combining_Class=:\Accc35\z:}', "");;
    Expect(0, 1649, '\p{Canonical_Combining_Class=:\Accc35\z:}', "");;
    Expect(1, 1648, '\p{Canonical_Combining_Class=_	ccc35}', "");
    Expect(0, 1648, '\p{^Canonical_Combining_Class=_	ccc35}', "");
    Expect(0, 1648, '\P{Canonical_Combining_Class=_	ccc35}', "");
    Expect(1, 1648, '\P{^Canonical_Combining_Class=_	ccc35}', "");
    Expect(0, 1649, '\p{Canonical_Combining_Class=_	ccc35}', "");
    Expect(1, 1649, '\p{^Canonical_Combining_Class=_	ccc35}', "");
    Expect(1, 1649, '\P{Canonical_Combining_Class=_	ccc35}', "");
    Expect(0, 1649, '\P{^Canonical_Combining_Class=_	ccc35}', "");
    Error('\p{Ccc=	 00_00_35:=}');
    Error('\P{Ccc=	 00_00_35:=}');
    Expect(1, 1648, '\p{Ccc=:\A35\z:}', "");;
    Expect(0, 1649, '\p{Ccc=:\A35\z:}', "");;
    Expect(1, 1648, '\p{Ccc=03_5}', "");
    Expect(0, 1648, '\p{^Ccc=03_5}', "");
    Expect(0, 1648, '\P{Ccc=03_5}', "");
    Expect(1, 1648, '\P{^Ccc=03_5}', "");
    Expect(0, 1649, '\p{Ccc=03_5}', "");
    Expect(1, 1649, '\p{^Ccc=03_5}', "");
    Expect(1, 1649, '\P{Ccc=03_5}', "");
    Expect(0, 1649, '\P{^Ccc=03_5}', "");
    Error('\p{Is_Canonical_Combining_Class= /a/CCC35}');
    Error('\P{Is_Canonical_Combining_Class= /a/CCC35}');
    Expect(1, 1648, '\p{Is_Canonical_Combining_Class:	ccc35}', "");
    Expect(0, 1648, '\p{^Is_Canonical_Combining_Class:	ccc35}', "");
    Expect(0, 1648, '\P{Is_Canonical_Combining_Class:	ccc35}', "");
    Expect(1, 1648, '\P{^Is_Canonical_Combining_Class:	ccc35}', "");
    Expect(0, 1649, '\p{Is_Canonical_Combining_Class:	ccc35}', "");
    Expect(1, 1649, '\p{^Is_Canonical_Combining_Class:	ccc35}', "");
    Expect(1, 1649, '\P{Is_Canonical_Combining_Class:	ccc35}', "");
    Expect(0, 1649, '\P{^Is_Canonical_Combining_Class:	ccc35}', "");
    Expect(1, 1648, '\p{Is_Canonical_Combining_Class= CCC35}', "");
    Expect(0, 1648, '\p{^Is_Canonical_Combining_Class= CCC35}', "");
    Expect(0, 1648, '\P{Is_Canonical_Combining_Class= CCC35}', "");
    Expect(1, 1648, '\P{^Is_Canonical_Combining_Class= CCC35}', "");
    Expect(0, 1649, '\p{Is_Canonical_Combining_Class= CCC35}', "");
    Expect(1, 1649, '\p{^Is_Canonical_Combining_Class= CCC35}', "");
    Expect(1, 1649, '\P{Is_Canonical_Combining_Class= CCC35}', "");
    Expect(0, 1649, '\P{^Is_Canonical_Combining_Class= CCC35}', "");
    Error('\p{Is_Ccc=_/a/0000000035}');
    Error('\P{Is_Ccc=_/a/0000000035}');
    Expect(1, 1648, '\p{Is_Ccc=+003_5}', "");
    Expect(0, 1648, '\p{^Is_Ccc=+003_5}', "");
    Expect(0, 1648, '\P{Is_Ccc=+003_5}', "");
    Expect(1, 1648, '\P{^Is_Ccc=+003_5}', "");
    Expect(0, 1649, '\p{Is_Ccc=+003_5}', "");
    Expect(1, 1649, '\p{^Is_Ccc=+003_5}', "");
    Expect(1, 1649, '\P{Is_Ccc=+003_5}', "");
    Expect(0, 1649, '\P{^Is_Ccc=+003_5}', "");
    Error('\p{Canonical_Combining_Class:   _/a/CCC36}');
    Error('\P{Canonical_Combining_Class:   _/a/CCC36}');
    Expect(1, 1809, '\p{Canonical_Combining_Class=:\ACCC36\z:}', "");;
    Expect(0, 1810, '\p{Canonical_Combining_Class=:\ACCC36\z:}', "");;
    Expect(1, 1809, '\p{Canonical_Combining_Class:   ccc36}', "");
    Expect(0, 1809, '\p{^Canonical_Combining_Class:   ccc36}', "");
    Expect(0, 1809, '\P{Canonical_Combining_Class:   ccc36}', "");
    Expect(1, 1809, '\P{^Canonical_Combining_Class:   ccc36}', "");
    Expect(0, 1810, '\p{Canonical_Combining_Class:   ccc36}', "");
    Expect(1, 1810, '\p{^Canonical_Combining_Class:   ccc36}', "");
    Expect(1, 1810, '\P{Canonical_Combining_Class:   ccc36}', "");
    Expect(0, 1810, '\P{^Canonical_Combining_Class:   ccc36}', "");
    Expect(1, 1809, '\p{Canonical_Combining_Class=:\Accc36\z:}', "");;
    Expect(0, 1810, '\p{Canonical_Combining_Class=:\Accc36\z:}', "");;
    Expect(1, 1809, '\p{Canonical_Combining_Class=- CCC36}', "");
    Expect(0, 1809, '\p{^Canonical_Combining_Class=- CCC36}', "");
    Expect(0, 1809, '\P{Canonical_Combining_Class=- CCC36}', "");
    Expect(1, 1809, '\P{^Canonical_Combining_Class=- CCC36}', "");
    Expect(0, 1810, '\p{Canonical_Combining_Class=- CCC36}', "");
    Expect(1, 1810, '\p{^Canonical_Combining_Class=- CCC36}', "");
    Expect(1, 1810, '\P{Canonical_Combining_Class=- CCC36}', "");
    Expect(0, 1810, '\P{^Canonical_Combining_Class=- CCC36}', "");
    Error('\p{Ccc=:= 	+0000000003_6}');
    Error('\P{Ccc=:= 	+0000000003_6}');
    Expect(1, 1809, '\p{Ccc=:\A36\z:}', "");;
    Expect(0, 1810, '\p{Ccc=:\A36\z:}', "");;
    Expect(1, 1809, '\p{Ccc=36}', "");
    Expect(0, 1809, '\p{^Ccc=36}', "");
    Expect(0, 1809, '\P{Ccc=36}', "");
    Expect(1, 1809, '\P{^Ccc=36}', "");
    Expect(0, 1810, '\p{Ccc=36}', "");
    Expect(1, 1810, '\p{^Ccc=36}', "");
    Expect(1, 1810, '\P{Ccc=36}', "");
    Expect(0, 1810, '\P{^Ccc=36}', "");
    Error('\p{Is_Canonical_Combining_Class:		:=CCC36}');
    Error('\P{Is_Canonical_Combining_Class:		:=CCC36}');
    Expect(1, 1809, '\p{Is_Canonical_Combining_Class=ccc36}', "");
    Expect(0, 1809, '\p{^Is_Canonical_Combining_Class=ccc36}', "");
    Expect(0, 1809, '\P{Is_Canonical_Combining_Class=ccc36}', "");
    Expect(1, 1809, '\P{^Is_Canonical_Combining_Class=ccc36}', "");
    Expect(0, 1810, '\p{Is_Canonical_Combining_Class=ccc36}', "");
    Expect(1, 1810, '\p{^Is_Canonical_Combining_Class=ccc36}', "");
    Expect(1, 1810, '\P{Is_Canonical_Combining_Class=ccc36}', "");
    Expect(0, 1810, '\P{^Is_Canonical_Combining_Class=ccc36}', "");
    Expect(1, 1809, '\p{Is_Canonical_Combining_Class=_ CCC36}', "");
    Expect(0, 1809, '\p{^Is_Canonical_Combining_Class=_ CCC36}', "");
    Expect(0, 1809, '\P{Is_Canonical_Combining_Class=_ CCC36}', "");
    Expect(1, 1809, '\P{^Is_Canonical_Combining_Class=_ CCC36}', "");
    Expect(0, 1810, '\p{Is_Canonical_Combining_Class=_ CCC36}', "");
    Expect(1, 1810, '\p{^Is_Canonical_Combining_Class=_ CCC36}', "");
    Expect(1, 1810, '\P{Is_Canonical_Combining_Class=_ CCC36}', "");
    Expect(0, 1810, '\P{^Is_Canonical_Combining_Class=_ CCC36}', "");
    Error('\p{Is_Ccc= /a/000000036}');
    Error('\P{Is_Ccc= /a/000000036}');
    Expect(1, 1809, '\p{Is_Ccc=0000000036}', "");
    Expect(0, 1809, '\p{^Is_Ccc=0000000036}', "");
    Expect(0, 1809, '\P{Is_Ccc=0000000036}', "");
    Expect(1, 1809, '\P{^Is_Ccc=0000000036}', "");
    Expect(0, 1810, '\p{Is_Ccc=0000000036}', "");
    Expect(1, 1810, '\p{^Is_Ccc=0000000036}', "");
    Expect(1, 1810, '\P{Is_Ccc=0000000036}', "");
    Expect(0, 1810, '\P{^Is_Ccc=0000000036}', "");
    Error('\p{Canonical_Combining_Class=/a/__CCC84}');
    Error('\P{Canonical_Combining_Class=/a/__CCC84}');
    Expect(1, 3157, '\p{Canonical_Combining_Class=:\ACCC84\z:}', "");;
    Expect(0, 3158, '\p{Canonical_Combining_Class=:\ACCC84\z:}', "");;
    Expect(1, 3157, '\p{Canonical_Combining_Class=ccc84}', "");
    Expect(0, 3157, '\p{^Canonical_Combining_Class=ccc84}', "");
    Expect(0, 3157, '\P{Canonical_Combining_Class=ccc84}', "");
    Expect(1, 3157, '\P{^Canonical_Combining_Class=ccc84}', "");
    Expect(0, 3158, '\p{Canonical_Combining_Class=ccc84}', "");
    Expect(1, 3158, '\p{^Canonical_Combining_Class=ccc84}', "");
    Expect(1, 3158, '\P{Canonical_Combining_Class=ccc84}', "");
    Expect(0, 3158, '\P{^Canonical_Combining_Class=ccc84}', "");
    Expect(1, 3157, '\p{Canonical_Combining_Class=:\Accc84\z:}', "");;
    Expect(0, 3158, '\p{Canonical_Combining_Class=:\Accc84\z:}', "");;
    Expect(1, 3157, '\p{Canonical_Combining_Class= -ccc84}', "");
    Expect(0, 3157, '\p{^Canonical_Combining_Class= -ccc84}', "");
    Expect(0, 3157, '\P{Canonical_Combining_Class= -ccc84}', "");
    Expect(1, 3157, '\P{^Canonical_Combining_Class= -ccc84}', "");
    Expect(0, 3158, '\p{Canonical_Combining_Class= -ccc84}', "");
    Expect(1, 3158, '\p{^Canonical_Combining_Class= -ccc84}', "");
    Expect(1, 3158, '\P{Canonical_Combining_Class= -ccc84}', "");
    Expect(0, 3158, '\P{^Canonical_Combining_Class= -ccc84}', "");
    Error('\p{Ccc=	+0_0_0_0_084/a/}');
    Error('\P{Ccc=	+0_0_0_0_084/a/}');
    Expect(1, 3157, '\p{Ccc=:\A84\z:}', "");;
    Expect(0, 3158, '\p{Ccc=:\A84\z:}', "");;
    Expect(1, 3157, '\p{Ccc=+0_0_84}', "");
    Expect(0, 3157, '\p{^Ccc=+0_0_84}', "");
    Expect(0, 3157, '\P{Ccc=+0_0_84}', "");
    Expect(1, 3157, '\P{^Ccc=+0_0_84}', "");
    Expect(0, 3158, '\p{Ccc=+0_0_84}', "");
    Expect(1, 3158, '\p{^Ccc=+0_0_84}', "");
    Expect(1, 3158, '\P{Ccc=+0_0_84}', "");
    Expect(0, 3158, '\P{^Ccc=+0_0_84}', "");
    Error('\p{Is_Canonical_Combining_Class= /a/CCC84}');
    Error('\P{Is_Canonical_Combining_Class= /a/CCC84}');
    Expect(1, 3157, '\p{Is_Canonical_Combining_Class:   ccc84}', "");
    Expect(0, 3157, '\p{^Is_Canonical_Combining_Class:   ccc84}', "");
    Expect(0, 3157, '\P{Is_Canonical_Combining_Class:   ccc84}', "");
    Expect(1, 3157, '\P{^Is_Canonical_Combining_Class:   ccc84}', "");
    Expect(0, 3158, '\p{Is_Canonical_Combining_Class:   ccc84}', "");
    Expect(1, 3158, '\p{^Is_Canonical_Combining_Class:   ccc84}', "");
    Expect(1, 3158, '\P{Is_Canonical_Combining_Class:   ccc84}', "");
    Expect(0, 3158, '\P{^Is_Canonical_Combining_Class:   ccc84}', "");
    Expect(1, 3157, '\p{Is_Canonical_Combining_Class:		_CCC84}', "");
    Expect(0, 3157, '\p{^Is_Canonical_Combining_Class:		_CCC84}', "");
    Expect(0, 3157, '\P{Is_Canonical_Combining_Class:		_CCC84}', "");
    Expect(1, 3157, '\P{^Is_Canonical_Combining_Class:		_CCC84}', "");
    Expect(0, 3158, '\p{Is_Canonical_Combining_Class:		_CCC84}', "");
    Expect(1, 3158, '\p{^Is_Canonical_Combining_Class:		_CCC84}', "");
    Expect(1, 3158, '\P{Is_Canonical_Combining_Class:		_CCC84}', "");
    Expect(0, 3158, '\P{^Is_Canonical_Combining_Class:		_CCC84}', "");
    Error('\p{Is_Ccc=/a/ -084}');
    Error('\P{Is_Ccc=/a/ -084}');
    Expect(1, 3157, '\p{Is_Ccc=0000084}', "");
    Expect(0, 3157, '\p{^Is_Ccc=0000084}', "");
    Expect(0, 3157, '\P{Is_Ccc=0000084}', "");
    Expect(1, 3157, '\P{^Is_Ccc=0000084}', "");
    Expect(0, 3158, '\p{Is_Ccc=0000084}', "");
    Expect(1, 3158, '\p{^Is_Ccc=0000084}', "");
    Expect(1, 3158, '\P{Is_Ccc=0000084}', "");
    Expect(0, 3158, '\P{^Is_Ccc=0000084}', "");
    Error('\p{Canonical_Combining_Class=--CCC91:=}');
    Error('\P{Canonical_Combining_Class=--CCC91:=}');
    Expect(1, 3158, '\p{Canonical_Combining_Class=:\ACCC91\z:}', "");;
    Expect(0, 3159, '\p{Canonical_Combining_Class=:\ACCC91\z:}', "");;
    Expect(1, 3158, '\p{Canonical_Combining_Class:   ccc91}', "");
    Expect(0, 3158, '\p{^Canonical_Combining_Class:   ccc91}', "");
    Expect(0, 3158, '\P{Canonical_Combining_Class:   ccc91}', "");
    Expect(1, 3158, '\P{^Canonical_Combining_Class:   ccc91}', "");
    Expect(0, 3159, '\p{Canonical_Combining_Class:   ccc91}', "");
    Expect(1, 3159, '\p{^Canonical_Combining_Class:   ccc91}', "");
    Expect(1, 3159, '\P{Canonical_Combining_Class:   ccc91}', "");
    Expect(0, 3159, '\P{^Canonical_Combining_Class:   ccc91}', "");
    Expect(1, 3158, '\p{Canonical_Combining_Class=:\Accc91\z:}', "");;
    Expect(0, 3159, '\p{Canonical_Combining_Class=:\Accc91\z:}', "");;
    Expect(1, 3158, '\p{Canonical_Combining_Class:	 _CCC91}', "");
    Expect(0, 3158, '\p{^Canonical_Combining_Class:	 _CCC91}', "");
    Expect(0, 3158, '\P{Canonical_Combining_Class:	 _CCC91}', "");
    Expect(1, 3158, '\P{^Canonical_Combining_Class:	 _CCC91}', "");
    Expect(0, 3159, '\p{Canonical_Combining_Class:	 _CCC91}', "");
    Expect(1, 3159, '\p{^Canonical_Combining_Class:	 _CCC91}', "");
    Expect(1, 3159, '\P{Canonical_Combining_Class:	 _CCC91}', "");
    Expect(0, 3159, '\P{^Canonical_Combining_Class:	 _CCC91}', "");
    Error('\p{Ccc=/a/	0000000091}');
    Error('\P{Ccc=/a/	0000000091}');
    Expect(1, 3158, '\p{Ccc=:\A91\z:}', "");;
    Expect(0, 3159, '\p{Ccc=:\A91\z:}', "");;
    Expect(1, 3158, '\p{Ccc=9_1}', "");
    Expect(0, 3158, '\p{^Ccc=9_1}', "");
    Expect(0, 3158, '\P{Ccc=9_1}', "");
    Expect(1, 3158, '\P{^Ccc=9_1}', "");
    Expect(0, 3159, '\p{Ccc=9_1}', "");
    Expect(1, 3159, '\p{^Ccc=9_1}', "");
    Expect(1, 3159, '\P{Ccc=9_1}', "");
    Expect(0, 3159, '\P{^Ccc=9_1}', "");
    Error('\p{Is_Canonical_Combining_Class=_:=CCC91}');
    Error('\P{Is_Canonical_Combining_Class=_:=CCC91}');
    Expect(1, 3158, '\p{Is_Canonical_Combining_Class:   ccc91}', "");
    Expect(0, 3158, '\p{^Is_Canonical_Combining_Class:   ccc91}', "");
    Expect(0, 3158, '\P{Is_Canonical_Combining_Class:   ccc91}', "");
    Expect(1, 3158, '\P{^Is_Canonical_Combining_Class:   ccc91}', "");
    Expect(0, 3159, '\p{Is_Canonical_Combining_Class:   ccc91}', "");
    Expect(1, 3159, '\p{^Is_Canonical_Combining_Class:   ccc91}', "");
    Expect(1, 3159, '\P{Is_Canonical_Combining_Class:   ccc91}', "");
    Expect(0, 3159, '\P{^Is_Canonical_Combining_Class:   ccc91}', "");
    Expect(1, 3158, '\p{Is_Canonical_Combining_Class=	_CCC91}', "");
    Expect(0, 3158, '\p{^Is_Canonical_Combining_Class=	_CCC91}', "");
    Expect(0, 3158, '\P{Is_Canonical_Combining_Class=	_CCC91}', "");
    Expect(1, 3158, '\P{^Is_Canonical_Combining_Class=	_CCC91}', "");
    Expect(0, 3159, '\p{Is_Canonical_Combining_Class=	_CCC91}', "");
    Expect(1, 3159, '\p{^Is_Canonical_Combining_Class=	_CCC91}', "");
    Expect(1, 3159, '\P{Is_Canonical_Combining_Class=	_CCC91}', "");
    Expect(0, 3159, '\P{^Is_Canonical_Combining_Class=	_CCC91}', "");
    Error('\p{Is_Ccc= +0_0_0_91/a/}');
    Error('\P{Is_Ccc= +0_0_0_91/a/}');
    Expect(1, 3158, '\p{Is_Ccc=00_00_00_00_09_1}', "");
    Expect(0, 3158, '\p{^Is_Ccc=00_00_00_00_09_1}', "");
    Expect(0, 3158, '\P{Is_Ccc=00_00_00_00_09_1}', "");
    Expect(1, 3158, '\P{^Is_Ccc=00_00_00_00_09_1}', "");
    Expect(0, 3159, '\p{Is_Ccc=00_00_00_00_09_1}', "");
    Expect(1, 3159, '\p{^Is_Ccc=00_00_00_00_09_1}', "");
    Expect(1, 3159, '\P{Is_Ccc=00_00_00_00_09_1}', "");
    Expect(0, 3159, '\P{^Is_Ccc=00_00_00_00_09_1}', "");
    Error('\p{Canonical_Combining_Class=-	Double_ABOVE:=}');
    Error('\P{Canonical_Combining_Class=-	Double_ABOVE:=}');
    Expect(1, 7629, '\p{Canonical_Combining_Class=:\ADouble_Above\z:}', "");;
    Expect(0, 7630, '\p{Canonical_Combining_Class=:\ADouble_Above\z:}', "");;
    Expect(1, 7629, '\p{Canonical_Combining_Class=doubleabove}', "");
    Expect(0, 7629, '\p{^Canonical_Combining_Class=doubleabove}', "");
    Expect(0, 7629, '\P{Canonical_Combining_Class=doubleabove}', "");
    Expect(1, 7629, '\P{^Canonical_Combining_Class=doubleabove}', "");
    Expect(0, 7630, '\p{Canonical_Combining_Class=doubleabove}', "");
    Expect(1, 7630, '\p{^Canonical_Combining_Class=doubleabove}', "");
    Expect(1, 7630, '\P{Canonical_Combining_Class=doubleabove}', "");
    Expect(0, 7630, '\P{^Canonical_Combining_Class=doubleabove}', "");
    Expect(1, 7629, '\p{Canonical_Combining_Class=:\Adoubleabove\z:}', "");;
    Expect(0, 7630, '\p{Canonical_Combining_Class=:\Adoubleabove\z:}', "");;
    Expect(1, 7629, '\p{Canonical_Combining_Class=  Double_Above}', "");
    Expect(0, 7629, '\p{^Canonical_Combining_Class=  Double_Above}', "");
    Expect(0, 7629, '\P{Canonical_Combining_Class=  Double_Above}', "");
    Expect(1, 7629, '\P{^Canonical_Combining_Class=  Double_Above}', "");
    Expect(0, 7630, '\p{Canonical_Combining_Class=  Double_Above}', "");
    Expect(1, 7630, '\p{^Canonical_Combining_Class=  Double_Above}', "");
    Expect(1, 7630, '\P{Canonical_Combining_Class=  Double_Above}', "");
    Expect(0, 7630, '\P{^Canonical_Combining_Class=  Double_Above}', "");
    Error('\p{Ccc=:= 	DA}');
    Error('\P{Ccc=:= 	DA}');
    Expect(1, 7629, '\p{Ccc=:\ADA\z:}', "");;
    Expect(0, 7630, '\p{Ccc=:\ADA\z:}', "");;
    Expect(1, 7629, '\p{Ccc=da}', "");
    Expect(0, 7629, '\p{^Ccc=da}', "");
    Expect(0, 7629, '\P{Ccc=da}', "");
    Expect(1, 7629, '\P{^Ccc=da}', "");
    Expect(0, 7630, '\p{Ccc=da}', "");
    Expect(1, 7630, '\p{^Ccc=da}', "");
    Expect(1, 7630, '\P{Ccc=da}', "");
    Expect(0, 7630, '\P{^Ccc=da}', "");
    Expect(1, 7629, '\p{Ccc=:\Ada\z:}', "");;
    Expect(0, 7630, '\p{Ccc=:\Ada\z:}', "");;
    Expect(1, 7629, '\p{Ccc= 	DA}', "");
    Expect(0, 7629, '\p{^Ccc= 	DA}', "");
    Expect(0, 7629, '\P{Ccc= 	DA}', "");
    Expect(1, 7629, '\P{^Ccc= 	DA}', "");
    Expect(0, 7630, '\p{Ccc= 	DA}', "");
    Expect(1, 7630, '\p{^Ccc= 	DA}', "");
    Expect(1, 7630, '\P{Ccc= 	DA}', "");
    Expect(0, 7630, '\P{^Ccc= 	DA}', "");
    Error('\p{Is_Canonical_Combining_Class= /a/0234}');
    Error('\P{Is_Canonical_Combining_Class= /a/0234}');
    Expect(1, 7629, '\p{Is_Canonical_Combining_Class:	0_0_0_2_34}', "");
    Expect(0, 7629, '\p{^Is_Canonical_Combining_Class:	0_0_0_2_34}', "");
    Expect(0, 7629, '\P{Is_Canonical_Combining_Class:	0_0_0_2_34}', "");
    Expect(1, 7629, '\P{^Is_Canonical_Combining_Class:	0_0_0_2_34}', "");
    Expect(0, 7630, '\p{Is_Canonical_Combining_Class:	0_0_0_2_34}', "");
    Expect(1, 7630, '\p{^Is_Canonical_Combining_Class:	0_0_0_2_34}', "");
    Expect(1, 7630, '\P{Is_Canonical_Combining_Class:	0_0_0_2_34}', "");
    Expect(0, 7630, '\P{^Is_Canonical_Combining_Class:	0_0_0_2_34}', "");
    Error('\p{Is_Ccc=-	double_ABOVE/a/}');
    Error('\P{Is_Ccc=-	double_ABOVE/a/}');
    Expect(1, 7629, '\p{Is_Ccc=doubleabove}', "");
    Expect(0, 7629, '\p{^Is_Ccc=doubleabove}', "");
    Expect(0, 7629, '\P{Is_Ccc=doubleabove}', "");
    Expect(1, 7629, '\P{^Is_Ccc=doubleabove}', "");
    Expect(0, 7630, '\p{Is_Ccc=doubleabove}', "");
    Expect(1, 7630, '\p{^Is_Ccc=doubleabove}', "");
    Expect(1, 7630, '\P{Is_Ccc=doubleabove}', "");
    Expect(0, 7630, '\P{^Is_Ccc=doubleabove}', "");
    Expect(1, 7629, '\p{Is_Ccc=	Double_ABOVE}', "");
    Expect(0, 7629, '\p{^Is_Ccc=	Double_ABOVE}', "");
    Expect(0, 7629, '\P{Is_Ccc=	Double_ABOVE}', "");
    Expect(1, 7629, '\P{^Is_Ccc=	Double_ABOVE}', "");
    Expect(0, 7630, '\p{Is_Ccc=	Double_ABOVE}', "");
    Expect(1, 7630, '\p{^Is_Ccc=	Double_ABOVE}', "");
    Expect(1, 7630, '\P{Is_Ccc=	Double_ABOVE}', "");
    Expect(0, 7630, '\P{^Is_Ccc=	Double_ABOVE}', "");
    Error('\p{Canonical_Combining_Class=:=	-Double_BELOW}');
    Error('\P{Canonical_Combining_Class=:=	-Double_BELOW}');
    Expect(1, 7676, '\p{Canonical_Combining_Class=:\ADouble_Below\z:}', "");;
    Expect(0, 7677, '\p{Canonical_Combining_Class=:\ADouble_Below\z:}', "");;
    Expect(1, 7676, '\p{Canonical_Combining_Class=doublebelow}', "");
    Expect(0, 7676, '\p{^Canonical_Combining_Class=doublebelow}', "");
    Expect(0, 7676, '\P{Canonical_Combining_Class=doublebelow}', "");
    Expect(1, 7676, '\P{^Canonical_Combining_Class=doublebelow}', "");
    Expect(0, 7677, '\p{Canonical_Combining_Class=doublebelow}', "");
    Expect(1, 7677, '\p{^Canonical_Combining_Class=doublebelow}', "");
    Expect(1, 7677, '\P{Canonical_Combining_Class=doublebelow}', "");
    Expect(0, 7677, '\P{^Canonical_Combining_Class=doublebelow}', "");
    Expect(1, 7676, '\p{Canonical_Combining_Class=:\Adoublebelow\z:}', "");;
    Expect(0, 7677, '\p{Canonical_Combining_Class=:\Adoublebelow\z:}', "");;
    Expect(1, 7676, '\p{Canonical_Combining_Class=- DOUBLE_BELOW}', "");
    Expect(0, 7676, '\p{^Canonical_Combining_Class=- DOUBLE_BELOW}', "");
    Expect(0, 7676, '\P{Canonical_Combining_Class=- DOUBLE_BELOW}', "");
    Expect(1, 7676, '\P{^Canonical_Combining_Class=- DOUBLE_BELOW}', "");
    Expect(0, 7677, '\p{Canonical_Combining_Class=- DOUBLE_BELOW}', "");
    Expect(1, 7677, '\p{^Canonical_Combining_Class=- DOUBLE_BELOW}', "");
    Expect(1, 7677, '\P{Canonical_Combining_Class=- DOUBLE_BELOW}', "");
    Expect(0, 7677, '\P{^Canonical_Combining_Class=- DOUBLE_BELOW}', "");
    Error('\p{Ccc=	/a/db}');
    Error('\P{Ccc=	/a/db}');
    Expect(1, 7676, '\p{Ccc=:\ADB\z:}', "");;
    Expect(0, 7677, '\p{Ccc=:\ADB\z:}', "");;
    Expect(1, 7676, '\p{Ccc=db}', "");
    Expect(0, 7676, '\p{^Ccc=db}', "");
    Expect(0, 7676, '\P{Ccc=db}', "");
    Expect(1, 7676, '\P{^Ccc=db}', "");
    Expect(0, 7677, '\p{Ccc=db}', "");
    Expect(1, 7677, '\p{^Ccc=db}', "");
    Expect(1, 7677, '\P{Ccc=db}', "");
    Expect(0, 7677, '\P{^Ccc=db}', "");
    Expect(1, 7676, '\p{Ccc=:\Adb\z:}', "");;
    Expect(0, 7677, '\p{Ccc=:\Adb\z:}', "");;
    Expect(1, 7676, '\p{Ccc=_DB}', "");
    Expect(0, 7676, '\p{^Ccc=_DB}', "");
    Expect(0, 7676, '\P{Ccc=_DB}', "");
    Expect(1, 7676, '\P{^Ccc=_DB}', "");
    Expect(0, 7677, '\p{Ccc=_DB}', "");
    Expect(1, 7677, '\p{^Ccc=_DB}', "");
    Expect(1, 7677, '\P{Ccc=_DB}', "");
    Expect(0, 7677, '\P{^Ccc=_DB}', "");
    Error('\p{Is_Canonical_Combining_Class=-:=+00023_3}');
    Error('\P{Is_Canonical_Combining_Class=-:=+00023_3}');
    Expect(1, 7676, '\p{Is_Canonical_Combining_Class:00_00_00_00_23_3}', "");
    Expect(0, 7676, '\p{^Is_Canonical_Combining_Class:00_00_00_00_23_3}', "");
    Expect(0, 7676, '\P{Is_Canonical_Combining_Class:00_00_00_00_23_3}', "");
    Expect(1, 7676, '\P{^Is_Canonical_Combining_Class:00_00_00_00_23_3}', "");
    Expect(0, 7677, '\p{Is_Canonical_Combining_Class:00_00_00_00_23_3}', "");
    Expect(1, 7677, '\p{^Is_Canonical_Combining_Class:00_00_00_00_23_3}', "");
    Expect(1, 7677, '\P{Is_Canonical_Combining_Class:00_00_00_00_23_3}', "");
    Expect(0, 7677, '\P{^Is_Canonical_Combining_Class:00_00_00_00_23_3}', "");
    Error('\p{Is_Ccc=:=_-double_Below}');
    Error('\P{Is_Ccc=:=_-double_Below}');
    Expect(1, 7676, '\p{Is_Ccc=doublebelow}', "");
    Expect(0, 7676, '\p{^Is_Ccc=doublebelow}', "");
    Expect(0, 7676, '\P{Is_Ccc=doublebelow}', "");
    Expect(1, 7676, '\P{^Is_Ccc=doublebelow}', "");
    Expect(0, 7677, '\p{Is_Ccc=doublebelow}', "");
    Expect(1, 7677, '\p{^Is_Ccc=doublebelow}', "");
    Expect(1, 7677, '\P{Is_Ccc=doublebelow}', "");
    Expect(0, 7677, '\P{^Is_Ccc=doublebelow}', "");
    Expect(1, 7676, '\p{Is_Ccc=-	DOUBLE_Below}', "");
    Expect(0, 7676, '\p{^Is_Ccc=-	DOUBLE_Below}', "");
    Expect(0, 7676, '\P{Is_Ccc=-	DOUBLE_Below}', "");
    Expect(1, 7676, '\P{^Is_Ccc=-	DOUBLE_Below}', "");
    Expect(0, 7677, '\p{Is_Ccc=-	DOUBLE_Below}', "");
    Expect(1, 7677, '\p{^Is_Ccc=-	DOUBLE_Below}', "");
    Expect(1, 7677, '\P{Is_Ccc=-	DOUBLE_Below}', "");
    Expect(0, 7677, '\P{^Is_Ccc=-	DOUBLE_Below}', "");
    Error('\p{Canonical_Combining_Class::=HAN_Reading}');
    Error('\P{Canonical_Combining_Class::=HAN_Reading}');
    Expect(1, 94193, '\p{Canonical_Combining_Class=:\AHan_Reading\z:}', "");;
    Expect(0, 94194, '\p{Canonical_Combining_Class=:\AHan_Reading\z:}', "");;
    Expect(1, 94193, '\p{Canonical_Combining_Class=hanreading}', "");
    Expect(0, 94193, '\p{^Canonical_Combining_Class=hanreading}', "");
    Expect(0, 94193, '\P{Canonical_Combining_Class=hanreading}', "");
    Expect(1, 94193, '\P{^Canonical_Combining_Class=hanreading}', "");
    Expect(0, 94194, '\p{Canonical_Combining_Class=hanreading}', "");
    Expect(1, 94194, '\p{^Canonical_Combining_Class=hanreading}', "");
    Expect(1, 94194, '\P{Canonical_Combining_Class=hanreading}', "");
    Expect(0, 94194, '\P{^Canonical_Combining_Class=hanreading}', "");
    Expect(1, 94193, '\p{Canonical_Combining_Class=:\Ahanreading\z:}', "");;
    Expect(0, 94194, '\p{Canonical_Combining_Class=:\Ahanreading\z:}', "");;
    Expect(1, 94193, '\p{Canonical_Combining_Class:   		HAN_Reading}', "");
    Expect(0, 94193, '\p{^Canonical_Combining_Class:   		HAN_Reading}', "");
    Expect(0, 94193, '\P{Canonical_Combining_Class:   		HAN_Reading}', "");
    Expect(1, 94193, '\P{^Canonical_Combining_Class:   		HAN_Reading}', "");
    Expect(0, 94194, '\p{Canonical_Combining_Class:   		HAN_Reading}', "");
    Expect(1, 94194, '\p{^Canonical_Combining_Class:   		HAN_Reading}', "");
    Expect(1, 94194, '\P{Canonical_Combining_Class:   		HAN_Reading}', "");
    Expect(0, 94194, '\P{^Canonical_Combining_Class:   		HAN_Reading}', "");
    Error('\p{Ccc=/a/HANR}');
    Error('\P{Ccc=/a/HANR}');
    Expect(1, 94193, '\p{Ccc=:\AHANR\z:}', "");;
    Expect(0, 94194, '\p{Ccc=:\AHANR\z:}', "");;
    Expect(1, 94193, '\p{Ccc: hanr}', "");
    Expect(0, 94193, '\p{^Ccc: hanr}', "");
    Expect(0, 94193, '\P{Ccc: hanr}', "");
    Expect(1, 94193, '\P{^Ccc: hanr}', "");
    Expect(0, 94194, '\p{Ccc: hanr}', "");
    Expect(1, 94194, '\p{^Ccc: hanr}', "");
    Expect(1, 94194, '\P{Ccc: hanr}', "");
    Expect(0, 94194, '\P{^Ccc: hanr}', "");
    Expect(1, 94193, '\p{Ccc=:\Ahanr\z:}', "");;
    Expect(0, 94194, '\p{Ccc=:\Ahanr\z:}', "");;
    Expect(1, 94193, '\p{Ccc=	-hanr}', "");
    Expect(0, 94193, '\p{^Ccc=	-hanr}', "");
    Expect(0, 94193, '\P{Ccc=	-hanr}', "");
    Expect(1, 94193, '\P{^Ccc=	-hanr}', "");
    Expect(0, 94194, '\p{Ccc=	-hanr}', "");
    Expect(1, 94194, '\p{^Ccc=	-hanr}', "");
    Expect(1, 94194, '\P{Ccc=	-hanr}', "");
    Expect(0, 94194, '\P{^Ccc=	-hanr}', "");
    Error('\p{Is_Canonical_Combining_Class=_	6:=}');
    Error('\P{Is_Canonical_Combining_Class=_	6:=}');
    Expect(1, 94193, '\p{Is_Canonical_Combining_Class:	+00_6}', "");
    Expect(0, 94193, '\p{^Is_Canonical_Combining_Class:	+00_6}', "");
    Expect(0, 94193, '\P{Is_Canonical_Combining_Class:	+00_6}', "");
    Expect(1, 94193, '\P{^Is_Canonical_Combining_Class:	+00_6}', "");
    Expect(0, 94194, '\p{Is_Canonical_Combining_Class:	+00_6}', "");
    Expect(1, 94194, '\p{^Is_Canonical_Combining_Class:	+00_6}', "");
    Expect(1, 94194, '\P{Is_Canonical_Combining_Class:	+00_6}', "");
    Expect(0, 94194, '\P{^Is_Canonical_Combining_Class:	+00_6}', "");
    Error('\p{Is_Ccc=	/a/Han_Reading}');
    Error('\P{Is_Ccc=	/a/Han_Reading}');
    Expect(1, 94193, '\p{Is_Ccc=hanreading}', "");
    Expect(0, 94193, '\p{^Is_Ccc=hanreading}', "");
    Expect(0, 94193, '\P{Is_Ccc=hanreading}', "");
    Expect(1, 94193, '\P{^Is_Ccc=hanreading}', "");
    Expect(0, 94194, '\p{Is_Ccc=hanreading}', "");
    Expect(1, 94194, '\p{^Is_Ccc=hanreading}', "");
    Expect(1, 94194, '\P{Is_Ccc=hanreading}', "");
    Expect(0, 94194, '\P{^Is_Ccc=hanreading}', "");
    Expect(1, 94193, '\p{Is_Ccc=- Han_Reading}', "");
    Expect(0, 94193, '\p{^Is_Ccc=- Han_Reading}', "");
    Expect(0, 94193, '\P{Is_Ccc=- Han_Reading}', "");
    Expect(1, 94193, '\P{^Is_Ccc=- Han_Reading}', "");
    Expect(0, 94194, '\p{Is_Ccc=- Han_Reading}', "");
    Expect(1, 94194, '\p{^Is_Ccc=- Han_Reading}', "");
    Expect(1, 94194, '\P{Is_Ccc=- Han_Reading}', "");
    Expect(0, 94194, '\P{^Is_Ccc=- Han_Reading}', "");
    Error('\p{Canonical_Combining_Class=:=- IOTA_Subscript}');
    Error('\P{Canonical_Combining_Class=:=- IOTA_Subscript}');
    Expect(1, 837, '\p{Canonical_Combining_Class=:\AIota_Subscript\z:}', "");;
    Expect(0, 838, '\p{Canonical_Combining_Class=:\AIota_Subscript\z:}', "");;
    Expect(1, 837, '\p{Canonical_Combining_Class=iotasubscript}', "");
    Expect(0, 837, '\p{^Canonical_Combining_Class=iotasubscript}', "");
    Expect(0, 837, '\P{Canonical_Combining_Class=iotasubscript}', "");
    Expect(1, 837, '\P{^Canonical_Combining_Class=iotasubscript}', "");
    Expect(0, 838, '\p{Canonical_Combining_Class=iotasubscript}', "");
    Expect(1, 838, '\p{^Canonical_Combining_Class=iotasubscript}', "");
    Expect(1, 838, '\P{Canonical_Combining_Class=iotasubscript}', "");
    Expect(0, 838, '\P{^Canonical_Combining_Class=iotasubscript}', "");
    Expect(1, 837, '\p{Canonical_Combining_Class=:\Aiotasubscript\z:}', "");;
    Expect(0, 838, '\p{Canonical_Combining_Class=:\Aiotasubscript\z:}', "");;
    Expect(1, 837, '\p{Canonical_Combining_Class=-	Iota_SUBSCRIPT}', "");
    Expect(0, 837, '\p{^Canonical_Combining_Class=-	Iota_SUBSCRIPT}', "");
    Expect(0, 837, '\P{Canonical_Combining_Class=-	Iota_SUBSCRIPT}', "");
    Expect(1, 837, '\P{^Canonical_Combining_Class=-	Iota_SUBSCRIPT}', "");
    Expect(0, 838, '\p{Canonical_Combining_Class=-	Iota_SUBSCRIPT}', "");
    Expect(1, 838, '\p{^Canonical_Combining_Class=-	Iota_SUBSCRIPT}', "");
    Expect(1, 838, '\P{Canonical_Combining_Class=-	Iota_SUBSCRIPT}', "");
    Expect(0, 838, '\P{^Canonical_Combining_Class=-	Iota_SUBSCRIPT}', "");
    Error('\p{Ccc=:=-_IS}');
    Error('\P{Ccc=:=-_IS}');
    Expect(1, 837, '\p{Ccc=:\AIS\z:}', "");;
    Expect(0, 838, '\p{Ccc=:\AIS\z:}', "");;
    Expect(1, 837, '\p{Ccc=is}', "");
    Expect(0, 837, '\p{^Ccc=is}', "");
    Expect(0, 837, '\P{Ccc=is}', "");
    Expect(1, 837, '\P{^Ccc=is}', "");
    Expect(0, 838, '\p{Ccc=is}', "");
    Expect(1, 838, '\p{^Ccc=is}', "");
    Expect(1, 838, '\P{Ccc=is}', "");
    Expect(0, 838, '\P{^Ccc=is}', "");
    Expect(1, 837, '\p{Ccc=:\Ais\z:}', "");;
    Expect(0, 838, '\p{Ccc=:\Ais\z:}', "");;
    Expect(1, 837, '\p{Ccc=_IS}', "");
    Expect(0, 837, '\p{^Ccc=_IS}', "");
    Expect(0, 837, '\P{Ccc=_IS}', "");
    Expect(1, 837, '\P{^Ccc=_IS}', "");
    Expect(0, 838, '\p{Ccc=_IS}', "");
    Expect(1, 838, '\p{^Ccc=_IS}', "");
    Expect(1, 838, '\P{Ccc=_IS}', "");
    Expect(0, 838, '\P{^Ccc=_IS}', "");
    Error('\p{Is_Canonical_Combining_Class= :=00240}');
    Error('\P{Is_Canonical_Combining_Class= :=00240}');
    Expect(1, 837, '\p{Is_Canonical_Combining_Class=00_02_40}', "");
    Expect(0, 837, '\p{^Is_Canonical_Combining_Class=00_02_40}', "");
    Expect(0, 837, '\P{Is_Canonical_Combining_Class=00_02_40}', "");
    Expect(1, 837, '\P{^Is_Canonical_Combining_Class=00_02_40}', "");
    Expect(0, 838, '\p{Is_Canonical_Combining_Class=00_02_40}', "");
    Expect(1, 838, '\p{^Is_Canonical_Combining_Class=00_02_40}', "");
    Expect(1, 838, '\P{Is_Canonical_Combining_Class=00_02_40}', "");
    Expect(0, 838, '\P{^Is_Canonical_Combining_Class=00_02_40}', "");
    Error('\p{Is_Ccc=	/a/iota_SUBSCRIPT}');
    Error('\P{Is_Ccc=	/a/iota_SUBSCRIPT}');
    Expect(1, 837, '\p{Is_Ccc=iotasubscript}', "");
    Expect(0, 837, '\p{^Is_Ccc=iotasubscript}', "");
    Expect(0, 837, '\P{Is_Ccc=iotasubscript}', "");
    Expect(1, 837, '\P{^Is_Ccc=iotasubscript}', "");
    Expect(0, 838, '\p{Is_Ccc=iotasubscript}', "");
    Expect(1, 838, '\p{^Is_Ccc=iotasubscript}', "");
    Expect(1, 838, '\P{Is_Ccc=iotasubscript}', "");
    Expect(0, 838, '\P{^Is_Ccc=iotasubscript}', "");
    Expect(1, 837, '\p{Is_Ccc=- Iota_Subscript}', "");
    Expect(0, 837, '\p{^Is_Ccc=- Iota_Subscript}', "");
    Expect(0, 837, '\P{Is_Ccc=- Iota_Subscript}', "");
    Expect(1, 837, '\P{^Is_Ccc=- Iota_Subscript}', "");
    Expect(0, 838, '\p{Is_Ccc=- Iota_Subscript}', "");
    Expect(1, 838, '\p{^Is_Ccc=- Iota_Subscript}', "");
    Expect(1, 838, '\P{Is_Ccc=- Iota_Subscript}', "");
    Expect(0, 838, '\P{^Is_Ccc=- Iota_Subscript}', "");
    Error('\p{Canonical_Combining_Class=:=_ kana_Voicing}');
    Error('\P{Canonical_Combining_Class=:=_ kana_Voicing}');
    Expect(1, 12442, '\p{Canonical_Combining_Class=:\AKana_Voicing\z:}', "");;
    Expect(0, 12443, '\p{Canonical_Combining_Class=:\AKana_Voicing\z:}', "");;
    Expect(1, 12442, '\p{Canonical_Combining_Class:	kanavoicing}', "");
    Expect(0, 12442, '\p{^Canonical_Combining_Class:	kanavoicing}', "");
    Expect(0, 12442, '\P{Canonical_Combining_Class:	kanavoicing}', "");
    Expect(1, 12442, '\P{^Canonical_Combining_Class:	kanavoicing}', "");
    Expect(0, 12443, '\p{Canonical_Combining_Class:	kanavoicing}', "");
    Expect(1, 12443, '\p{^Canonical_Combining_Class:	kanavoicing}', "");
    Expect(1, 12443, '\P{Canonical_Combining_Class:	kanavoicing}', "");
    Expect(0, 12443, '\P{^Canonical_Combining_Class:	kanavoicing}', "");
    Expect(1, 12442, '\p{Canonical_Combining_Class=:\Akanavoicing\z:}', "");;
    Expect(0, 12443, '\p{Canonical_Combining_Class=:\Akanavoicing\z:}', "");;
    Expect(1, 12442, '\p{Canonical_Combining_Class=-	kana_Voicing}', "");
    Expect(0, 12442, '\p{^Canonical_Combining_Class=-	kana_Voicing}', "");
    Expect(0, 12442, '\P{Canonical_Combining_Class=-	kana_Voicing}', "");
    Expect(1, 12442, '\P{^Canonical_Combining_Class=-	kana_Voicing}', "");
    Expect(0, 12443, '\p{Canonical_Combining_Class=-	kana_Voicing}', "");
    Expect(1, 12443, '\p{^Canonical_Combining_Class=-	kana_Voicing}', "");
    Expect(1, 12443, '\P{Canonical_Combining_Class=-	kana_Voicing}', "");
    Expect(0, 12443, '\P{^Canonical_Combining_Class=-	kana_Voicing}', "");
    Error('\p{Ccc:   :=-kv}');
    Error('\P{Ccc:   :=-kv}');
    Expect(1, 12442, '\p{Ccc=:\AKV\z:}', "");;
    Expect(0, 12443, '\p{Ccc=:\AKV\z:}', "");;
    Expect(1, 12442, '\p{Ccc=kv}', "");
    Expect(0, 12442, '\p{^Ccc=kv}', "");
    Expect(0, 12442, '\P{Ccc=kv}', "");
    Expect(1, 12442, '\P{^Ccc=kv}', "");
    Expect(0, 12443, '\p{Ccc=kv}', "");
    Expect(1, 12443, '\p{^Ccc=kv}', "");
    Expect(1, 12443, '\P{Ccc=kv}', "");
    Expect(0, 12443, '\P{^Ccc=kv}', "");
    Expect(1, 12442, '\p{Ccc=:\Akv\z:}', "");;
    Expect(0, 12443, '\p{Ccc=:\Akv\z:}', "");;
    Expect(1, 12442, '\p{Ccc:   	-KV}', "");
    Expect(0, 12442, '\p{^Ccc:   	-KV}', "");
    Expect(0, 12442, '\P{Ccc:   	-KV}', "");
    Expect(1, 12442, '\P{^Ccc:   	-KV}', "");
    Expect(0, 12443, '\p{Ccc:   	-KV}', "");
    Expect(1, 12443, '\p{^Ccc:   	-KV}', "");
    Expect(1, 12443, '\P{Ccc:   	-KV}', "");
    Expect(0, 12443, '\P{^Ccc:   	-KV}', "");
    Error('\p{Is_Canonical_Combining_Class= 0000000008/a/}');
    Error('\P{Is_Canonical_Combining_Class= 0000000008/a/}');
    Expect(1, 12442, '\p{Is_Canonical_Combining_Class=+00000_8}', "");
    Expect(0, 12442, '\p{^Is_Canonical_Combining_Class=+00000_8}', "");
    Expect(0, 12442, '\P{Is_Canonical_Combining_Class=+00000_8}', "");
    Expect(1, 12442, '\P{^Is_Canonical_Combining_Class=+00000_8}', "");
    Expect(0, 12443, '\p{Is_Canonical_Combining_Class=+00000_8}', "");
    Expect(1, 12443, '\p{^Is_Canonical_Combining_Class=+00000_8}', "");
    Expect(1, 12443, '\P{Is_Canonical_Combining_Class=+00000_8}', "");
    Expect(0, 12443, '\P{^Is_Canonical_Combining_Class=+00000_8}', "");
    Error('\p{Is_Ccc=	-Kana_Voicing:=}');
    Error('\P{Is_Ccc=	-Kana_Voicing:=}');
    Expect(1, 12442, '\p{Is_Ccc=kanavoicing}', "");
    Expect(0, 12442, '\p{^Is_Ccc=kanavoicing}', "");
    Expect(0, 12442, '\P{Is_Ccc=kanavoicing}', "");
    Expect(1, 12442, '\P{^Is_Ccc=kanavoicing}', "");
    Expect(0, 12443, '\p{Is_Ccc=kanavoicing}', "");
    Expect(1, 12443, '\p{^Is_Ccc=kanavoicing}', "");
    Expect(1, 12443, '\P{Is_Ccc=kanavoicing}', "");
    Expect(0, 12443, '\P{^Is_Ccc=kanavoicing}', "");
    Expect(1, 12442, '\p{Is_Ccc= KANA_Voicing}', "");
    Expect(0, 12442, '\p{^Is_Ccc= KANA_Voicing}', "");
    Expect(0, 12442, '\P{Is_Ccc= KANA_Voicing}', "");
    Expect(1, 12442, '\P{^Is_Ccc= KANA_Voicing}', "");
    Expect(0, 12443, '\p{Is_Ccc= KANA_Voicing}', "");
    Expect(1, 12443, '\p{^Is_Ccc= KANA_Voicing}', "");
    Expect(1, 12443, '\P{Is_Ccc= KANA_Voicing}', "");
    Expect(0, 12443, '\P{^Is_Ccc= KANA_Voicing}', "");
    Error('\p{Canonical_Combining_Class= /a/Left}');
    Error('\P{Canonical_Combining_Class= /a/Left}');
    Expect(1, 12335, '\p{Canonical_Combining_Class=:\ALeft\z:}', "");;
    Expect(0, 12336, '\p{Canonical_Combining_Class=:\ALeft\z:}', "");;
    Expect(1, 12335, '\p{Canonical_Combining_Class=left}', "");
    Expect(0, 12335, '\p{^Canonical_Combining_Class=left}', "");
    Expect(0, 12335, '\P{Canonical_Combining_Class=left}', "");
    Expect(1, 12335, '\P{^Canonical_Combining_Class=left}', "");
    Expect(0, 12336, '\p{Canonical_Combining_Class=left}', "");
    Expect(1, 12336, '\p{^Canonical_Combining_Class=left}', "");
    Expect(1, 12336, '\P{Canonical_Combining_Class=left}', "");
    Expect(0, 12336, '\P{^Canonical_Combining_Class=left}', "");
    Expect(1, 12335, '\p{Canonical_Combining_Class=:\Aleft\z:}', "");;
    Expect(0, 12336, '\p{Canonical_Combining_Class=:\Aleft\z:}', "");;
    Expect(1, 12335, '\p{Canonical_Combining_Class=_	left}', "");
    Expect(0, 12335, '\p{^Canonical_Combining_Class=_	left}', "");
    Expect(0, 12335, '\P{Canonical_Combining_Class=_	left}', "");
    Expect(1, 12335, '\P{^Canonical_Combining_Class=_	left}', "");
    Expect(0, 12336, '\p{Canonical_Combining_Class=_	left}', "");
    Expect(1, 12336, '\p{^Canonical_Combining_Class=_	left}', "");
    Expect(1, 12336, '\P{Canonical_Combining_Class=_	left}', "");
    Expect(0, 12336, '\P{^Canonical_Combining_Class=_	left}', "");
    Error('\p{Ccc=-_L:=}');
    Error('\P{Ccc=-_L:=}');
    Expect(1, 12335, '\p{Ccc=:\AL\z:}', "");;
    Expect(0, 12336, '\p{Ccc=:\AL\z:}', "");;
    Expect(1, 12335, '\p{Ccc=l}', "");
    Expect(0, 12335, '\p{^Ccc=l}', "");
    Expect(0, 12335, '\P{Ccc=l}', "");
    Expect(1, 12335, '\P{^Ccc=l}', "");
    Expect(0, 12336, '\p{Ccc=l}', "");
    Expect(1, 12336, '\p{^Ccc=l}', "");
    Expect(1, 12336, '\P{Ccc=l}', "");
    Expect(0, 12336, '\P{^Ccc=l}', "");
    Expect(1, 12335, '\p{Ccc=:\Al\z:}', "");;
    Expect(0, 12336, '\p{Ccc=:\Al\z:}', "");;
    Expect(1, 12335, '\p{Ccc=	l}', "");
    Expect(0, 12335, '\p{^Ccc=	l}', "");
    Expect(0, 12335, '\P{Ccc=	l}', "");
    Expect(1, 12335, '\P{^Ccc=	l}', "");
    Expect(0, 12336, '\p{Ccc=	l}', "");
    Expect(1, 12336, '\p{^Ccc=	l}', "");
    Expect(1, 12336, '\P{Ccc=	l}', "");
    Expect(0, 12336, '\P{^Ccc=	l}', "");
    Error('\p{Is_Canonical_Combining_Class=/a/		00_22_4}');
    Error('\P{Is_Canonical_Combining_Class=/a/		00_22_4}');
    Expect(1, 12335, '\p{Is_Canonical_Combining_Class=+00000_00022_4}', "");
    Expect(0, 12335, '\p{^Is_Canonical_Combining_Class=+00000_00022_4}', "");
    Expect(0, 12335, '\P{Is_Canonical_Combining_Class=+00000_00022_4}', "");
    Expect(1, 12335, '\P{^Is_Canonical_Combining_Class=+00000_00022_4}', "");
    Expect(0, 12336, '\p{Is_Canonical_Combining_Class=+00000_00022_4}', "");
    Expect(1, 12336, '\p{^Is_Canonical_Combining_Class=+00000_00022_4}', "");
    Expect(1, 12336, '\P{Is_Canonical_Combining_Class=+00000_00022_4}', "");
    Expect(0, 12336, '\P{^Is_Canonical_Combining_Class=+00000_00022_4}', "");
    Error('\p{Is_Ccc=_:=LEFT}');
    Error('\P{Is_Ccc=_:=LEFT}');
    Expect(1, 12335, '\p{Is_Ccc=left}', "");
    Expect(0, 12335, '\p{^Is_Ccc=left}', "");
    Expect(0, 12335, '\P{Is_Ccc=left}', "");
    Expect(1, 12335, '\P{^Is_Ccc=left}', "");
    Expect(0, 12336, '\p{Is_Ccc=left}', "");
    Expect(1, 12336, '\p{^Is_Ccc=left}', "");
    Expect(1, 12336, '\P{Is_Ccc=left}', "");
    Expect(0, 12336, '\P{^Is_Ccc=left}', "");
    Expect(1, 12335, '\p{Is_Ccc=__Left}', "");
    Expect(0, 12335, '\p{^Is_Ccc=__Left}', "");
    Expect(0, 12335, '\P{Is_Ccc=__Left}', "");
    Expect(1, 12335, '\P{^Is_Ccc=__Left}', "");
    Expect(0, 12336, '\p{Is_Ccc=__Left}', "");
    Expect(1, 12336, '\p{^Is_Ccc=__Left}', "");
    Expect(1, 12336, '\P{Is_Ccc=__Left}', "");
    Expect(0, 12336, '\P{^Is_Ccc=__Left}', "");
    Error('\p{Canonical_Combining_Class= -NUKTA:=}');
    Error('\P{Canonical_Combining_Class= -NUKTA:=}');
    Expect(1, 125258, '\p{Canonical_Combining_Class=:\ANukta\z:}', "");;
    Expect(0, 125259, '\p{Canonical_Combining_Class=:\ANukta\z:}', "");;
    Expect(1, 125258, '\p{Canonical_Combining_Class=nukta}', "");
    Expect(0, 125258, '\p{^Canonical_Combining_Class=nukta}', "");
    Expect(0, 125258, '\P{Canonical_Combining_Class=nukta}', "");
    Expect(1, 125258, '\P{^Canonical_Combining_Class=nukta}', "");
    Expect(0, 125259, '\p{Canonical_Combining_Class=nukta}', "");
    Expect(1, 125259, '\p{^Canonical_Combining_Class=nukta}', "");
    Expect(1, 125259, '\P{Canonical_Combining_Class=nukta}', "");
    Expect(0, 125259, '\P{^Canonical_Combining_Class=nukta}', "");
    Expect(1, 125258, '\p{Canonical_Combining_Class=:\Anukta\z:}', "");;
    Expect(0, 125259, '\p{Canonical_Combining_Class=:\Anukta\z:}', "");;
    Expect(1, 125258, '\p{Canonical_Combining_Class=_	Nukta}', "");
    Expect(0, 125258, '\p{^Canonical_Combining_Class=_	Nukta}', "");
    Expect(0, 125258, '\P{Canonical_Combining_Class=_	Nukta}', "");
    Expect(1, 125258, '\P{^Canonical_Combining_Class=_	Nukta}', "");
    Expect(0, 125259, '\p{Canonical_Combining_Class=_	Nukta}', "");
    Expect(1, 125259, '\p{^Canonical_Combining_Class=_	Nukta}', "");
    Expect(1, 125259, '\P{Canonical_Combining_Class=_	Nukta}', "");
    Expect(0, 125259, '\P{^Canonical_Combining_Class=_	Nukta}', "");
    Error('\p{Ccc=:= nk}');
    Error('\P{Ccc=:= nk}');
    Expect(1, 125258, '\p{Ccc=:\ANK\z:}', "");;
    Expect(0, 125259, '\p{Ccc=:\ANK\z:}', "");;
    Expect(1, 125258, '\p{Ccc=nk}', "");
    Expect(0, 125258, '\p{^Ccc=nk}', "");
    Expect(0, 125258, '\P{Ccc=nk}', "");
    Expect(1, 125258, '\P{^Ccc=nk}', "");
    Expect(0, 125259, '\p{Ccc=nk}', "");
    Expect(1, 125259, '\p{^Ccc=nk}', "");
    Expect(1, 125259, '\P{Ccc=nk}', "");
    Expect(0, 125259, '\P{^Ccc=nk}', "");
    Expect(1, 125258, '\p{Ccc=:\Ank\z:}', "");;
    Expect(0, 125259, '\p{Ccc=:\Ank\z:}', "");;
    Expect(1, 125258, '\p{Ccc=	 nk}', "");
    Expect(0, 125258, '\p{^Ccc=	 nk}', "");
    Expect(0, 125258, '\P{Ccc=	 nk}', "");
    Expect(1, 125258, '\P{^Ccc=	 nk}', "");
    Expect(0, 125259, '\p{Ccc=	 nk}', "");
    Expect(1, 125259, '\p{^Ccc=	 nk}', "");
    Expect(1, 125259, '\P{Ccc=	 nk}', "");
    Expect(0, 125259, '\P{^Ccc=	 nk}', "");
    Error('\p{Is_Canonical_Combining_Class=-	0_0_0_0_0_0_0_07:=}');
    Error('\P{Is_Canonical_Combining_Class=-	0_0_0_0_0_0_0_07:=}');
    Expect(1, 125258, '\p{Is_Canonical_Combining_Class=0_0_0_0_0007}', "");
    Expect(0, 125258, '\p{^Is_Canonical_Combining_Class=0_0_0_0_0007}', "");
    Expect(0, 125258, '\P{Is_Canonical_Combining_Class=0_0_0_0_0007}', "");
    Expect(1, 125258, '\P{^Is_Canonical_Combining_Class=0_0_0_0_0007}', "");
    Expect(0, 125259, '\p{Is_Canonical_Combining_Class=0_0_0_0_0007}', "");
    Expect(1, 125259, '\p{^Is_Canonical_Combining_Class=0_0_0_0_0007}', "");
    Expect(1, 125259, '\P{Is_Canonical_Combining_Class=0_0_0_0_0007}', "");
    Expect(0, 125259, '\P{^Is_Canonical_Combining_Class=0_0_0_0_0007}', "");
    Error('\p{Is_Ccc=/a/ _Nukta}');
    Error('\P{Is_Ccc=/a/ _Nukta}');
    Expect(1, 125258, '\p{Is_Ccc=nukta}', "");
    Expect(0, 125258, '\p{^Is_Ccc=nukta}', "");
    Expect(0, 125258, '\P{Is_Ccc=nukta}', "");
    Expect(1, 125258, '\P{^Is_Ccc=nukta}', "");
    Expect(0, 125259, '\p{Is_Ccc=nukta}', "");
    Expect(1, 125259, '\p{^Is_Ccc=nukta}', "");
    Expect(1, 125259, '\P{Is_Ccc=nukta}', "");
    Expect(0, 125259, '\P{^Is_Ccc=nukta}', "");
    Expect(1, 125258, '\p{Is_Ccc=-nukta}', "");
    Expect(0, 125258, '\p{^Is_Ccc=-nukta}', "");
    Expect(0, 125258, '\P{Is_Ccc=-nukta}', "");
    Expect(1, 125258, '\P{^Is_Ccc=-nukta}', "");
    Expect(0, 125259, '\p{Is_Ccc=-nukta}', "");
    Expect(1, 125259, '\p{^Is_Ccc=-nukta}', "");
    Expect(1, 125259, '\P{Is_Ccc=-nukta}', "");
    Expect(0, 125259, '\P{^Is_Ccc=-nukta}', "");
    Error('\p{Canonical_Combining_Class=:=not_Reordered}');
    Error('\P{Canonical_Combining_Class=:=not_Reordered}');
    Expect(1, 125259, '\p{Canonical_Combining_Class=:\ANot_Reordered\z:}', "");;
    Expect(0, 125258, '\p{Canonical_Combining_Class=:\ANot_Reordered\z:}', "");;
    Expect(1, 125259, '\p{Canonical_Combining_Class=notreordered}', "");
    Expect(0, 125259, '\p{^Canonical_Combining_Class=notreordered}', "");
    Expect(0, 125259, '\P{Canonical_Combining_Class=notreordered}', "");
    Expect(1, 125259, '\P{^Canonical_Combining_Class=notreordered}', "");
    Expect(0, 125258, '\p{Canonical_Combining_Class=notreordered}', "");
    Expect(1, 125258, '\p{^Canonical_Combining_Class=notreordered}', "");
    Expect(1, 125258, '\P{Canonical_Combining_Class=notreordered}', "");
    Expect(0, 125258, '\P{^Canonical_Combining_Class=notreordered}', "");
    Expect(1, 125259, '\p{Canonical_Combining_Class=:\Anotreordered\z:}', "");;
    Expect(0, 125258, '\p{Canonical_Combining_Class=:\Anotreordered\z:}', "");;
    Expect(1, 125259, '\p{Canonical_Combining_Class=__Not_Reordered}', "");
    Expect(0, 125259, '\p{^Canonical_Combining_Class=__Not_Reordered}', "");
    Expect(0, 125259, '\P{Canonical_Combining_Class=__Not_Reordered}', "");
    Expect(1, 125259, '\P{^Canonical_Combining_Class=__Not_Reordered}', "");
    Expect(0, 125258, '\p{Canonical_Combining_Class=__Not_Reordered}', "");
    Expect(1, 125258, '\p{^Canonical_Combining_Class=__Not_Reordered}', "");
    Expect(1, 125258, '\P{Canonical_Combining_Class=__Not_Reordered}', "");
    Expect(0, 125258, '\P{^Canonical_Combining_Class=__Not_Reordered}', "");
    Error('\p{Ccc=_nr:=}');
    Error('\P{Ccc=_nr:=}');
    Expect(1, 125259, '\p{Ccc=:\ANR\z:}', "");;
    Expect(0, 125258, '\p{Ccc=:\ANR\z:}', "");;
    Expect(1, 125259, '\p{Ccc=nr}', "");
    Expect(0, 125259, '\p{^Ccc=nr}', "");
    Expect(0, 125259, '\P{Ccc=nr}', "");
    Expect(1, 125259, '\P{^Ccc=nr}', "");
    Expect(0, 125258, '\p{Ccc=nr}', "");
    Expect(1, 125258, '\p{^Ccc=nr}', "");
    Expect(1, 125258, '\P{Ccc=nr}', "");
    Expect(0, 125258, '\P{^Ccc=nr}', "");
    Expect(1, 125259, '\p{Ccc=:\Anr\z:}', "");;
    Expect(0, 125258, '\p{Ccc=:\Anr\z:}', "");;
    Expect(1, 125259, '\p{Ccc=_	NR}', "");
    Expect(0, 125259, '\p{^Ccc=_	NR}', "");
    Expect(0, 125259, '\P{Ccc=_	NR}', "");
    Expect(1, 125259, '\P{^Ccc=_	NR}', "");
    Expect(0, 125258, '\p{Ccc=_	NR}', "");
    Expect(1, 125258, '\p{^Ccc=_	NR}', "");
    Expect(1, 125258, '\P{Ccc=_	NR}', "");
    Expect(0, 125258, '\P{^Ccc=_	NR}', "");
    Error('\p{Is_Canonical_Combining_Class=-	00_00_00_00_0:=}');
    Error('\P{Is_Canonical_Combining_Class=-	00_00_00_00_0:=}');
    Expect(1, 125259, '\p{Is_Canonical_Combining_Class=0_0_0_0_0_0_0_000}', "");
    Expect(0, 125259, '\p{^Is_Canonical_Combining_Class=0_0_0_0_0_0_0_000}', "");
    Expect(0, 125259, '\P{Is_Canonical_Combining_Class=0_0_0_0_0_0_0_000}', "");
    Expect(1, 125259, '\P{^Is_Canonical_Combining_Class=0_0_0_0_0_0_0_000}', "");
    Expect(0, 125258, '\p{Is_Canonical_Combining_Class=0_0_0_0_0_0_0_000}', "");
    Expect(1, 125258, '\p{^Is_Canonical_Combining_Class=0_0_0_0_0_0_0_000}', "");
    Expect(1, 125258, '\P{Is_Canonical_Combining_Class=0_0_0_0_0_0_0_000}', "");
    Expect(0, 125258, '\P{^Is_Canonical_Combining_Class=0_0_0_0_0_0_0_000}', "");
    Error('\p{Is_Ccc=__NOT_reordered:=}');
    Error('\P{Is_Ccc=__NOT_reordered:=}');
    Expect(1, 125259, '\p{Is_Ccc=notreordered}', "");
    Expect(0, 125259, '\p{^Is_Ccc=notreordered}', "");
    Expect(0, 125259, '\P{Is_Ccc=notreordered}', "");
    Expect(1, 125259, '\P{^Is_Ccc=notreordered}', "");
    Expect(0, 125258, '\p{Is_Ccc=notreordered}', "");
    Expect(1, 125258, '\p{^Is_Ccc=notreordered}', "");
    Expect(1, 125258, '\P{Is_Ccc=notreordered}', "");
    Expect(0, 125258, '\P{^Is_Ccc=notreordered}', "");
    Expect(1, 125259, '\p{Is_Ccc=	NOT_Reordered}', "");
    Expect(0, 125259, '\p{^Is_Ccc=	NOT_Reordered}', "");
    Expect(0, 125259, '\P{Is_Ccc=	NOT_Reordered}', "");
    Expect(1, 125259, '\P{^Is_Ccc=	NOT_Reordered}', "");
    Expect(0, 125258, '\p{Is_Ccc=	NOT_Reordered}', "");
    Expect(1, 125258, '\p{^Is_Ccc=	NOT_Reordered}', "");
    Expect(1, 125258, '\P{Is_Ccc=	NOT_Reordered}', "");
    Expect(0, 125258, '\P{^Is_Ccc=	NOT_Reordered}', "");
    Error('\p{Canonical_Combining_Class=/a/	Overlay}');
    Error('\P{Canonical_Combining_Class=/a/	Overlay}');
    Expect(1, 119145, '\p{Canonical_Combining_Class=:\AOverlay\z:}', "");;
    Expect(0, 119146, '\p{Canonical_Combining_Class=:\AOverlay\z:}', "");;
    Expect(1, 119145, '\p{Canonical_Combining_Class=overlay}', "");
    Expect(0, 119145, '\p{^Canonical_Combining_Class=overlay}', "");
    Expect(0, 119145, '\P{Canonical_Combining_Class=overlay}', "");
    Expect(1, 119145, '\P{^Canonical_Combining_Class=overlay}', "");
    Expect(0, 119146, '\p{Canonical_Combining_Class=overlay}', "");
    Expect(1, 119146, '\p{^Canonical_Combining_Class=overlay}', "");
    Expect(1, 119146, '\P{Canonical_Combining_Class=overlay}', "");
    Expect(0, 119146, '\P{^Canonical_Combining_Class=overlay}', "");
    Expect(1, 119145, '\p{Canonical_Combining_Class=:\Aoverlay\z:}', "");;
    Expect(0, 119146, '\p{Canonical_Combining_Class=:\Aoverlay\z:}', "");;
    Expect(1, 119145, '\p{Canonical_Combining_Class=_	Overlay}', "");
    Expect(0, 119145, '\p{^Canonical_Combining_Class=_	Overlay}', "");
    Expect(0, 119145, '\P{Canonical_Combining_Class=_	Overlay}', "");
    Expect(1, 119145, '\P{^Canonical_Combining_Class=_	Overlay}', "");
    Expect(0, 119146, '\p{Canonical_Combining_Class=_	Overlay}', "");
    Expect(1, 119146, '\p{^Canonical_Combining_Class=_	Overlay}', "");
    Expect(1, 119146, '\P{Canonical_Combining_Class=_	Overlay}', "");
    Expect(0, 119146, '\P{^Canonical_Combining_Class=_	Overlay}', "");
    Error('\p{Ccc=:=-	OV}');
    Error('\P{Ccc=:=-	OV}');
    Expect(1, 119145, '\p{Ccc=:\AOV\z:}', "");;
    Expect(0, 119146, '\p{Ccc=:\AOV\z:}', "");;
    Expect(1, 119145, '\p{Ccc=ov}', "");
    Expect(0, 119145, '\p{^Ccc=ov}', "");
    Expect(0, 119145, '\P{Ccc=ov}', "");
    Expect(1, 119145, '\P{^Ccc=ov}', "");
    Expect(0, 119146, '\p{Ccc=ov}', "");
    Expect(1, 119146, '\p{^Ccc=ov}', "");
    Expect(1, 119146, '\P{Ccc=ov}', "");
    Expect(0, 119146, '\P{^Ccc=ov}', "");
    Expect(1, 119145, '\p{Ccc=:\Aov\z:}', "");;
    Expect(0, 119146, '\p{Ccc=:\Aov\z:}', "");;
    Expect(1, 119145, '\p{Ccc:   	OV}', "");
    Expect(0, 119145, '\p{^Ccc:   	OV}', "");
    Expect(0, 119145, '\P{Ccc:   	OV}', "");
    Expect(1, 119145, '\P{^Ccc:   	OV}', "");
    Expect(0, 119146, '\p{Ccc:   	OV}', "");
    Expect(1, 119146, '\p{^Ccc:   	OV}', "");
    Expect(1, 119146, '\P{Ccc:   	OV}', "");
    Expect(0, 119146, '\P{^Ccc:   	OV}', "");
    Error('\p{Is_Canonical_Combining_Class=	/a/000_1}');
    Error('\P{Is_Canonical_Combining_Class=	/a/000_1}');
    Expect(1, 119145, '\p{Is_Canonical_Combining_Class=0001}', "");
    Expect(0, 119145, '\p{^Is_Canonical_Combining_Class=0001}', "");
    Expect(0, 119145, '\P{Is_Canonical_Combining_Class=0001}', "");
    Expect(1, 119145, '\P{^Is_Canonical_Combining_Class=0001}', "");
    Expect(0, 119146, '\p{Is_Canonical_Combining_Class=0001}', "");
    Expect(1, 119146, '\p{^Is_Canonical_Combining_Class=0001}', "");
    Expect(1, 119146, '\P{Is_Canonical_Combining_Class=0001}', "");
    Expect(0, 119146, '\P{^Is_Canonical_Combining_Class=0001}', "");
    Error('\p{Is_Ccc=:=__Overlay}');
    Error('\P{Is_Ccc=:=__Overlay}');
    Expect(1, 119145, '\p{Is_Ccc=overlay}', "");
    Expect(0, 119145, '\p{^Is_Ccc=overlay}', "");
    Expect(0, 119145, '\P{Is_Ccc=overlay}', "");
    Expect(1, 119145, '\P{^Is_Ccc=overlay}', "");
    Expect(0, 119146, '\p{Is_Ccc=overlay}', "");
    Expect(1, 119146, '\p{^Is_Ccc=overlay}', "");
    Expect(1, 119146, '\P{Is_Ccc=overlay}', "");
    Expect(0, 119146, '\P{^Is_Ccc=overlay}', "");
    Expect(1, 119145, '\p{Is_Ccc=		Overlay}', "");
    Expect(0, 119145, '\p{^Is_Ccc=		Overlay}', "");
    Expect(0, 119145, '\P{Is_Ccc=		Overlay}', "");
    Expect(1, 119145, '\P{^Is_Ccc=		Overlay}', "");
    Expect(0, 119146, '\p{Is_Ccc=		Overlay}', "");
    Expect(1, 119146, '\p{^Is_Ccc=		Overlay}', "");
    Expect(1, 119146, '\P{Is_Ccc=		Overlay}', "");
    Expect(0, 119146, '\P{^Is_Ccc=		Overlay}', "");
    Error('\p{Canonical_Combining_Class=__Right/a/}');
    Error('\P{Canonical_Combining_Class=__Right/a/}');
    Expect(1, 119149, '\p{Canonical_Combining_Class=:\ARight\z:}', "");;
    Expect(0, 119150, '\p{Canonical_Combining_Class=:\ARight\z:}', "");;
    Expect(1, 119149, '\p{Canonical_Combining_Class=right}', "");
    Expect(0, 119149, '\p{^Canonical_Combining_Class=right}', "");
    Expect(0, 119149, '\P{Canonical_Combining_Class=right}', "");
    Expect(1, 119149, '\P{^Canonical_Combining_Class=right}', "");
    Expect(0, 119150, '\p{Canonical_Combining_Class=right}', "");
    Expect(1, 119150, '\p{^Canonical_Combining_Class=right}', "");
    Expect(1, 119150, '\P{Canonical_Combining_Class=right}', "");
    Expect(0, 119150, '\P{^Canonical_Combining_Class=right}', "");
    Expect(1, 119149, '\p{Canonical_Combining_Class=:\Aright\z:}', "");;
    Expect(0, 119150, '\p{Canonical_Combining_Class=:\Aright\z:}', "");;
    Expect(1, 119149, '\p{Canonical_Combining_Class=-_RIGHT}', "");
    Expect(0, 119149, '\p{^Canonical_Combining_Class=-_RIGHT}', "");
    Expect(0, 119149, '\P{Canonical_Combining_Class=-_RIGHT}', "");
    Expect(1, 119149, '\P{^Canonical_Combining_Class=-_RIGHT}', "");
    Expect(0, 119150, '\p{Canonical_Combining_Class=-_RIGHT}', "");
    Expect(1, 119150, '\p{^Canonical_Combining_Class=-_RIGHT}', "");
    Expect(1, 119150, '\P{Canonical_Combining_Class=-_RIGHT}', "");
    Expect(0, 119150, '\P{^Canonical_Combining_Class=-_RIGHT}', "");
    Error('\p{Ccc=	/a/r}');
    Error('\P{Ccc=	/a/r}');
    Expect(1, 119149, '\p{Ccc=:\AR\z:}', "");;
    Expect(0, 119150, '\p{Ccc=:\AR\z:}', "");;
    Expect(1, 119149, '\p{Ccc=r}', "");
    Expect(0, 119149, '\p{^Ccc=r}', "");
    Expect(0, 119149, '\P{Ccc=r}', "");
    Expect(1, 119149, '\P{^Ccc=r}', "");
    Expect(0, 119150, '\p{Ccc=r}', "");
    Expect(1, 119150, '\p{^Ccc=r}', "");
    Expect(1, 119150, '\P{Ccc=r}', "");
    Expect(0, 119150, '\P{^Ccc=r}', "");
    Expect(1, 119149, '\p{Ccc=:\Ar\z:}', "");;
    Expect(0, 119150, '\p{Ccc=:\Ar\z:}', "");;
    Expect(1, 119149, '\p{Ccc=- R}', "");
    Expect(0, 119149, '\p{^Ccc=- R}', "");
    Expect(0, 119149, '\P{Ccc=- R}', "");
    Expect(1, 119149, '\P{^Ccc=- R}', "");
    Expect(0, 119150, '\p{Ccc=- R}', "");
    Expect(1, 119150, '\p{^Ccc=- R}', "");
    Expect(1, 119150, '\P{Ccc=- R}', "");
    Expect(0, 119150, '\P{^Ccc=- R}', "");
    Error('\p{Is_Canonical_Combining_Class= -00022_6:=}');
    Error('\P{Is_Canonical_Combining_Class= -00022_6:=}');
    Expect(1, 119149, '\p{Is_Canonical_Combining_Class=+0226}', "");
    Expect(0, 119149, '\p{^Is_Canonical_Combining_Class=+0226}', "");
    Expect(0, 119149, '\P{Is_Canonical_Combining_Class=+0226}', "");
    Expect(1, 119149, '\P{^Is_Canonical_Combining_Class=+0226}', "");
    Expect(0, 119150, '\p{Is_Canonical_Combining_Class=+0226}', "");
    Expect(1, 119150, '\p{^Is_Canonical_Combining_Class=+0226}', "");
    Expect(1, 119150, '\P{Is_Canonical_Combining_Class=+0226}', "");
    Expect(0, 119150, '\P{^Is_Canonical_Combining_Class=+0226}', "");
    Error('\p{Is_Ccc=/a/	-RIGHT}');
    Error('\P{Is_Ccc=/a/	-RIGHT}');
    Expect(1, 119149, '\p{Is_Ccc=right}', "");
    Expect(0, 119149, '\p{^Is_Ccc=right}', "");
    Expect(0, 119149, '\P{Is_Ccc=right}', "");
    Expect(1, 119149, '\P{^Is_Ccc=right}', "");
    Expect(0, 119150, '\p{Is_Ccc=right}', "");
    Expect(1, 119150, '\p{^Is_Ccc=right}', "");
    Expect(1, 119150, '\P{Is_Ccc=right}', "");
    Expect(0, 119150, '\P{^Is_Ccc=right}', "");
    Expect(1, 119149, '\p{Is_Ccc=-	RIGHT}', "");
    Expect(0, 119149, '\p{^Is_Ccc=-	RIGHT}', "");
    Expect(0, 119149, '\P{Is_Ccc=-	RIGHT}', "");
    Expect(1, 119149, '\P{^Is_Ccc=-	RIGHT}', "");
    Expect(0, 119150, '\p{Is_Ccc=-	RIGHT}', "");
    Expect(1, 119150, '\p{^Is_Ccc=-	RIGHT}', "");
    Expect(1, 119150, '\P{Is_Ccc=-	RIGHT}', "");
    Expect(0, 119150, '\P{^Is_Ccc=-	RIGHT}', "");
    Error('\p{Canonical_Combining_Class=_:=VIRAMA}');
    Error('\P{Canonical_Combining_Class=_:=VIRAMA}');
    Expect(1, 73538, '\p{Canonical_Combining_Class=:\AVirama\z:}', "");;
    Expect(0, 73539, '\p{Canonical_Combining_Class=:\AVirama\z:}', "");;
    Expect(1, 73538, '\p{Canonical_Combining_Class=virama}', "");
    Expect(0, 73538, '\p{^Canonical_Combining_Class=virama}', "");
    Expect(0, 73538, '\P{Canonical_Combining_Class=virama}', "");
    Expect(1, 73538, '\P{^Canonical_Combining_Class=virama}', "");
    Expect(0, 73539, '\p{Canonical_Combining_Class=virama}', "");
    Expect(1, 73539, '\p{^Canonical_Combining_Class=virama}', "");
    Expect(1, 73539, '\P{Canonical_Combining_Class=virama}', "");
    Expect(0, 73539, '\P{^Canonical_Combining_Class=virama}', "");
    Expect(1, 73538, '\p{Canonical_Combining_Class=:\Avirama\z:}', "");;
    Expect(0, 73539, '\p{Canonical_Combining_Class=:\Avirama\z:}', "");;
    Expect(1, 73538, '\p{Canonical_Combining_Class= 	virama}', "");
    Expect(0, 73538, '\p{^Canonical_Combining_Class= 	virama}', "");
    Expect(0, 73538, '\P{Canonical_Combining_Class= 	virama}', "");
    Expect(1, 73538, '\P{^Canonical_Combining_Class= 	virama}', "");
    Expect(0, 73539, '\p{Canonical_Combining_Class= 	virama}', "");
    Expect(1, 73539, '\p{^Canonical_Combining_Class= 	virama}', "");
    Expect(1, 73539, '\P{Canonical_Combining_Class= 	virama}', "");
    Expect(0, 73539, '\P{^Canonical_Combining_Class= 	virama}', "");
    Error('\p{Ccc=/a/ VR}');
    Error('\P{Ccc=/a/ VR}');
    Expect(1, 73538, '\p{Ccc=:\AVR\z:}', "");;
    Expect(0, 73539, '\p{Ccc=:\AVR\z:}', "");;
    Expect(1, 73538, '\p{Ccc=vr}', "");
    Expect(0, 73538, '\p{^Ccc=vr}', "");
    Expect(0, 73538, '\P{Ccc=vr}', "");
    Expect(1, 73538, '\P{^Ccc=vr}', "");
    Expect(0, 73539, '\p{Ccc=vr}', "");
    Expect(1, 73539, '\p{^Ccc=vr}', "");
    Expect(1, 73539, '\P{Ccc=vr}', "");
    Expect(0, 73539, '\P{^Ccc=vr}', "");
    Expect(1, 73538, '\p{Ccc=:\Avr\z:}', "");;
    Expect(0, 73539, '\p{Ccc=:\Avr\z:}', "");;
    Expect(1, 73538, '\p{Ccc=	 VR}', "");
    Expect(0, 73538, '\p{^Ccc=	 VR}', "");
    Expect(0, 73538, '\P{Ccc=	 VR}', "");
    Expect(1, 73538, '\P{^Ccc=	 VR}', "");
    Expect(0, 73539, '\p{Ccc=	 VR}', "");
    Expect(1, 73539, '\p{^Ccc=	 VR}', "");
    Expect(1, 73539, '\P{Ccc=	 VR}', "");
    Expect(0, 73539, '\P{^Ccc=	 VR}', "");
    Error('\p{Is_Canonical_Combining_Class=-/a/0_0_0_0_09}');
    Error('\P{Is_Canonical_Combining_Class=-/a/0_0_0_0_09}');
    Expect(1, 73538, '\p{Is_Canonical_Combining_Class=0_0_0_0_0_09}', "");
    Expect(0, 73538, '\p{^Is_Canonical_Combining_Class=0_0_0_0_0_09}', "");
    Expect(0, 73538, '\P{Is_Canonical_Combining_Class=0_0_0_0_0_09}', "");
    Expect(1, 73538, '\P{^Is_Canonical_Combining_Class=0_0_0_0_0_09}', "");
    Expect(0, 73539, '\p{Is_Canonical_Combining_Class=0_0_0_0_0_09}', "");
    Expect(1, 73539, '\p{^Is_Canonical_Combining_Class=0_0_0_0_0_09}', "");
    Expect(1, 73539, '\P{Is_Canonical_Combining_Class=0_0_0_0_0_09}', "");
    Expect(0, 73539, '\P{^Is_Canonical_Combining_Class=0_0_0_0_0_09}', "");
    Error('\p{Is_Ccc=_-VIRAMA:=}');
    Error('\P{Is_Ccc=_-VIRAMA:=}');
    Expect(1, 73538, '\p{Is_Ccc:	virama}', "");
    Expect(0, 73538, '\p{^Is_Ccc:	virama}', "");
    Expect(0, 73538, '\P{Is_Ccc:	virama}', "");
    Expect(1, 73538, '\P{^Is_Ccc:	virama}', "");
    Expect(0, 73539, '\p{Is_Ccc:	virama}', "");
    Expect(1, 73539, '\p{^Is_Ccc:	virama}', "");
    Expect(1, 73539, '\P{Is_Ccc:	virama}', "");
    Expect(0, 73539, '\P{^Is_Ccc:	virama}', "");
    Expect(1, 73538, '\p{Is_Ccc= virama}', "");
    Expect(0, 73538, '\p{^Is_Ccc= virama}', "");
    Expect(0, 73538, '\P{Is_Ccc= virama}', "");
    Expect(1, 73538, '\P{^Is_Ccc= virama}', "");
    Expect(0, 73539, '\p{Is_Ccc= virama}', "");
    Expect(1, 73539, '\p{^Is_Ccc= virama}', "");
    Expect(1, 73539, '\P{Is_Ccc= virama}', "");
    Expect(0, 73539, '\P{^Is_Ccc= virama}', "");
    Error('\p{Composition_Exclusion=/a/		no}');
    Error('\P{Composition_Exclusion=/a/		no}');
    Expect(1, 119233, '\p{Composition_Exclusion=:\ANo\z:}', "");;
    Expect(0, 119232, '\p{Composition_Exclusion=:\ANo\z:}', "");;
    Expect(1, 119233, '\p{Composition_Exclusion=no}', "");
    Expect(0, 119233, '\p{^Composition_Exclusion=no}', "");
    Expect(0, 119233, '\P{Composition_Exclusion=no}', "");
    Expect(1, 119233, '\P{^Composition_Exclusion=no}', "");
    Expect(0, 119232, '\p{Composition_Exclusion=no}', "");
    Expect(1, 119232, '\p{^Composition_Exclusion=no}', "");
    Expect(1, 119232, '\P{Composition_Exclusion=no}', "");
    Expect(0, 119232, '\P{^Composition_Exclusion=no}', "");
    Expect(1, 119233, '\p{Composition_Exclusion=:\Ano\z:}', "");;
    Expect(0, 119232, '\p{Composition_Exclusion=:\Ano\z:}', "");;
    Expect(1, 119233, '\p{Composition_Exclusion= No}', "");
    Expect(0, 119233, '\p{^Composition_Exclusion= No}', "");
    Expect(0, 119233, '\P{Composition_Exclusion= No}', "");
    Expect(1, 119233, '\P{^Composition_Exclusion= No}', "");
    Expect(0, 119232, '\p{Composition_Exclusion= No}', "");
    Expect(1, 119232, '\p{^Composition_Exclusion= No}', "");
    Expect(1, 119232, '\P{Composition_Exclusion= No}', "");
    Expect(0, 119232, '\P{^Composition_Exclusion= No}', "");
    Error('\p{CE=__N:=}');
    Error('\P{CE=__N:=}');
    Expect(1, 119233, '\p{CE=:\AN\z:}', "");;
    Expect(0, 119232, '\p{CE=:\AN\z:}', "");;
    Expect(1, 119233, '\p{CE=n}', "");
    Expect(0, 119233, '\p{^CE=n}', "");
    Expect(0, 119233, '\P{CE=n}', "");
    Expect(1, 119233, '\P{^CE=n}', "");
    Expect(0, 119232, '\p{CE=n}', "");
    Expect(1, 119232, '\p{^CE=n}', "");
    Expect(1, 119232, '\P{CE=n}', "");
    Expect(0, 119232, '\P{^CE=n}', "");
    Expect(1, 119233, '\p{CE=:\An\z:}', "");;
    Expect(0, 119232, '\p{CE=:\An\z:}', "");;
    Expect(1, 119233, '\p{CE=_-N}', "");
    Expect(0, 119233, '\p{^CE=_-N}', "");
    Expect(0, 119233, '\P{CE=_-N}', "");
    Expect(1, 119233, '\P{^CE=_-N}', "");
    Expect(0, 119232, '\p{CE=_-N}', "");
    Expect(1, 119232, '\p{^CE=_-N}', "");
    Expect(1, 119232, '\P{CE=_-N}', "");
    Expect(0, 119232, '\P{^CE=_-N}', "");
    Error('\p{Is_Composition_Exclusion=	/a/F}');
    Error('\P{Is_Composition_Exclusion=	/a/F}');
    Expect(1, 119233, '\p{Is_Composition_Exclusion=f}', "");
    Expect(0, 119233, '\p{^Is_Composition_Exclusion=f}', "");
    Expect(0, 119233, '\P{Is_Composition_Exclusion=f}', "");
    Expect(1, 119233, '\P{^Is_Composition_Exclusion=f}', "");
    Expect(0, 119232, '\p{Is_Composition_Exclusion=f}', "");
    Expect(1, 119232, '\p{^Is_Composition_Exclusion=f}', "");
    Expect(1, 119232, '\P{Is_Composition_Exclusion=f}', "");
    Expect(0, 119232, '\P{^Is_Composition_Exclusion=f}', "");
    Expect(1, 119233, '\p{Is_Composition_Exclusion=__F}', "");
    Expect(0, 119233, '\p{^Is_Composition_Exclusion=__F}', "");
    Expect(0, 119233, '\P{Is_Composition_Exclusion=__F}', "");
    Expect(1, 119233, '\P{^Is_Composition_Exclusion=__F}', "");
    Expect(0, 119232, '\p{Is_Composition_Exclusion=__F}', "");
    Expect(1, 119232, '\p{^Is_Composition_Exclusion=__F}', "");
    Expect(1, 119232, '\P{Is_Composition_Exclusion=__F}', "");
    Expect(0, 119232, '\P{^Is_Composition_Exclusion=__F}', "");
    Error('\p{Is_CE=-false:=}');
    Error('\P{Is_CE=-false:=}');
    Expect(1, 119233, '\p{Is_CE=false}', "");
    Expect(0, 119233, '\p{^Is_CE=false}', "");
    Expect(0, 119233, '\P{Is_CE=false}', "");
    Expect(1, 119233, '\P{^Is_CE=false}', "");
    Expect(0, 119232, '\p{Is_CE=false}', "");
    Expect(1, 119232, '\p{^Is_CE=false}', "");
    Expect(1, 119232, '\P{Is_CE=false}', "");
    Expect(0, 119232, '\P{^Is_CE=false}', "");
    Expect(1, 119233, '\p{Is_CE=	 false}', "");
    Expect(0, 119233, '\p{^Is_CE=	 false}', "");
    Expect(0, 119233, '\P{Is_CE=	 false}', "");
    Expect(1, 119233, '\P{^Is_CE=	 false}', "");
    Expect(0, 119232, '\p{Is_CE=	 false}', "");
    Expect(1, 119232, '\p{^Is_CE=	 false}', "");
    Expect(1, 119232, '\P{Is_CE=	 false}', "");
    Expect(0, 119232, '\P{^Is_CE=	 false}', "");
    Error('\p{Composition_Exclusion=/a/ _Yes}');
    Error('\P{Composition_Exclusion=/a/ _Yes}');
    Expect(1, 119232, '\p{Composition_Exclusion=:\AYes\z:}', "");;
    Expect(0, 119233, '\p{Composition_Exclusion=:\AYes\z:}', "");;
    Expect(1, 119232, '\p{Composition_Exclusion=yes}', "");
    Expect(0, 119232, '\p{^Composition_Exclusion=yes}', "");
    Expect(0, 119232, '\P{Composition_Exclusion=yes}', "");
    Expect(1, 119232, '\P{^Composition_Exclusion=yes}', "");
    Expect(0, 119233, '\p{Composition_Exclusion=yes}', "");
    Expect(1, 119233, '\p{^Composition_Exclusion=yes}', "");
    Expect(1, 119233, '\P{Composition_Exclusion=yes}', "");
    Expect(0, 119233, '\P{^Composition_Exclusion=yes}', "");
    Expect(1, 119232, '\p{Composition_Exclusion=:\Ayes\z:}', "");;
    Expect(0, 119233, '\p{Composition_Exclusion=:\Ayes\z:}', "");;
    Expect(1, 119232, '\p{Composition_Exclusion=-Yes}', "");
    Expect(0, 119232, '\p{^Composition_Exclusion=-Yes}', "");
    Expect(0, 119232, '\P{Composition_Exclusion=-Yes}', "");
    Expect(1, 119232, '\P{^Composition_Exclusion=-Yes}', "");
    Expect(0, 119233, '\p{Composition_Exclusion=-Yes}', "");
    Expect(1, 119233, '\p{^Composition_Exclusion=-Yes}', "");
    Expect(1, 119233, '\P{Composition_Exclusion=-Yes}', "");
    Expect(0, 119233, '\P{^Composition_Exclusion=-Yes}', "");
    Error('\p{CE=	Y:=}');
    Error('\P{CE=	Y:=}');
    Expect(1, 119232, '\p{CE=:\AY\z:}', "");;
    Expect(0, 119233, '\p{CE=:\AY\z:}', "");;
    Expect(1, 119232, '\p{CE=y}', "");
    Expect(0, 119232, '\p{^CE=y}', "");
    Expect(0, 119232, '\P{CE=y}', "");
    Expect(1, 119232, '\P{^CE=y}', "");
    Expect(0, 119233, '\p{CE=y}', "");
    Expect(1, 119233, '\p{^CE=y}', "");
    Expect(1, 119233, '\P{CE=y}', "");
    Expect(0, 119233, '\P{^CE=y}', "");
    Expect(1, 119232, '\p{CE=:\Ay\z:}', "");;
    Expect(0, 119233, '\p{CE=:\Ay\z:}', "");;
    Expect(1, 119232, '\p{CE=_y}', "");
    Expect(0, 119232, '\p{^CE=_y}', "");
    Expect(0, 119232, '\P{CE=_y}', "");
    Expect(1, 119232, '\P{^CE=_y}', "");
    Expect(0, 119233, '\p{CE=_y}', "");
    Expect(1, 119233, '\p{^CE=_y}', "");
    Expect(1, 119233, '\P{CE=_y}', "");
    Expect(0, 119233, '\P{^CE=_y}', "");
    Error('\p{Is_Composition_Exclusion=_T:=}');
    Error('\P{Is_Composition_Exclusion=_T:=}');
    Expect(1, 119232, '\p{Is_Composition_Exclusion=t}', "");
    Expect(0, 119232, '\p{^Is_Composition_Exclusion=t}', "");
    Expect(0, 119232, '\P{Is_Composition_Exclusion=t}', "");
    Expect(1, 119232, '\P{^Is_Composition_Exclusion=t}', "");
    Expect(0, 119233, '\p{Is_Composition_Exclusion=t}', "");
    Expect(1, 119233, '\p{^Is_Composition_Exclusion=t}', "");
    Expect(1, 119233, '\P{Is_Composition_Exclusion=t}', "");
    Expect(0, 119233, '\P{^Is_Composition_Exclusion=t}', "");
    Expect(1, 119232, '\p{Is_Composition_Exclusion=  T}', "");
    Expect(0, 119232, '\p{^Is_Composition_Exclusion=  T}', "");
    Expect(0, 119232, '\P{Is_Composition_Exclusion=  T}', "");
    Expect(1, 119232, '\P{^Is_Composition_Exclusion=  T}', "");
    Expect(0, 119233, '\p{Is_Composition_Exclusion=  T}', "");
    Expect(1, 119233, '\p{^Is_Composition_Exclusion=  T}', "");
    Expect(1, 119233, '\P{Is_Composition_Exclusion=  T}', "");
    Expect(0, 119233, '\P{^Is_Composition_Exclusion=  T}', "");
    Error('\p{Is_CE=- TRUE:=}');
    Error('\P{Is_CE=- TRUE:=}');
    Expect(1, 119232, '\p{Is_CE=true}', "");
    Expect(0, 119232, '\p{^Is_CE=true}', "");
    Expect(0, 119232, '\P{Is_CE=true}', "");
    Expect(1, 119232, '\P{^Is_CE=true}', "");
    Expect(0, 119233, '\p{Is_CE=true}', "");
    Expect(1, 119233, '\p{^Is_CE=true}', "");
    Expect(1, 119233, '\P{Is_CE=true}', "");
    Expect(0, 119233, '\P{^Is_CE=true}', "");
    Expect(1, 119232, '\p{Is_CE=-	true}', "");
    Expect(0, 119232, '\p{^Is_CE=-	true}', "");
    Expect(0, 119232, '\P{Is_CE=-	true}', "");
    Expect(1, 119232, '\P{^Is_CE=-	true}', "");
    Expect(0, 119233, '\p{Is_CE=-	true}', "");
    Expect(1, 119233, '\p{^Is_CE=-	true}', "");
    Expect(1, 119233, '\P{Is_CE=-	true}', "");
    Expect(0, 119233, '\P{^Is_CE=-	true}', "");
    Error('\p{casefolding}');
    Error('\P{casefolding}');
    Error('\p{Case_Ignorable= /a/NO}');
    Error('\P{Case_Ignorable= /a/NO}');
    Expect(1, 918000, '\p{Case_Ignorable=:\ANo\z:}', "");;
    Expect(0, 917999, '\p{Case_Ignorable=:\ANo\z:}', "");;
    Expect(1, 918000, '\p{Case_Ignorable=no}', "");
    Expect(0, 918000, '\p{^Case_Ignorable=no}', "");
    Expect(0, 918000, '\P{Case_Ignorable=no}', "");
    Expect(1, 918000, '\P{^Case_Ignorable=no}', "");
    Expect(0, 917999, '\p{Case_Ignorable=no}', "");
    Expect(1, 917999, '\p{^Case_Ignorable=no}', "");
    Expect(1, 917999, '\P{Case_Ignorable=no}', "");
    Expect(0, 917999, '\P{^Case_Ignorable=no}', "");
    Expect(1, 918000, '\p{Case_Ignorable=:\Ano\z:}', "");;
    Expect(0, 917999, '\p{Case_Ignorable=:\Ano\z:}', "");;
    Expect(1, 918000, '\p{Case_Ignorable=_no}', "");
    Expect(0, 918000, '\p{^Case_Ignorable=_no}', "");
    Expect(0, 918000, '\P{Case_Ignorable=_no}', "");
    Expect(1, 918000, '\P{^Case_Ignorable=_no}', "");
    Expect(0, 917999, '\p{Case_Ignorable=_no}', "");
    Expect(1, 917999, '\p{^Case_Ignorable=_no}', "");
    Expect(1, 917999, '\P{Case_Ignorable=_no}', "");
    Expect(0, 917999, '\P{^Case_Ignorable=_no}', "");
    Error('\p{CI=/a/- N}');
    Error('\P{CI=/a/- N}');
    Expect(1, 918000, '\p{CI=:\AN\z:}', "");;
    Expect(0, 917999, '\p{CI=:\AN\z:}', "");;
    Expect(1, 918000, '\p{CI=n}', "");
    Expect(0, 918000, '\p{^CI=n}', "");
    Expect(0, 918000, '\P{CI=n}', "");
    Expect(1, 918000, '\P{^CI=n}', "");
    Expect(0, 917999, '\p{CI=n}', "");
    Expect(1, 917999, '\p{^CI=n}', "");
    Expect(1, 917999, '\P{CI=n}', "");
    Expect(0, 917999, '\P{^CI=n}', "");
    Expect(1, 918000, '\p{CI=:\An\z:}', "");;
    Expect(0, 917999, '\p{CI=:\An\z:}', "");;
    Expect(1, 918000, '\p{CI=	N}', "");
    Expect(0, 918000, '\p{^CI=	N}', "");
    Expect(0, 918000, '\P{CI=	N}', "");
    Expect(1, 918000, '\P{^CI=	N}', "");
    Expect(0, 917999, '\p{CI=	N}', "");
    Expect(1, 917999, '\p{^CI=	N}', "");
    Expect(1, 917999, '\P{CI=	N}', "");
    Expect(0, 917999, '\P{^CI=	N}', "");
    Error('\p{Is_Case_Ignorable=	_F/a/}');
    Error('\P{Is_Case_Ignorable=	_F/a/}');
    Expect(1, 918000, '\p{Is_Case_Ignorable:f}', "");
    Expect(0, 918000, '\p{^Is_Case_Ignorable:f}', "");
    Expect(0, 918000, '\P{Is_Case_Ignorable:f}', "");
    Expect(1, 918000, '\P{^Is_Case_Ignorable:f}', "");
    Expect(0, 917999, '\p{Is_Case_Ignorable:f}', "");
    Expect(1, 917999, '\p{^Is_Case_Ignorable:f}', "");
    Expect(1, 917999, '\P{Is_Case_Ignorable:f}', "");
    Expect(0, 917999, '\P{^Is_Case_Ignorable:f}', "");
    Expect(1, 918000, '\p{Is_Case_Ignorable= _F}', "");
    Expect(0, 918000, '\p{^Is_Case_Ignorable= _F}', "");
    Expect(0, 918000, '\P{Is_Case_Ignorable= _F}', "");
    Expect(1, 918000, '\P{^Is_Case_Ignorable= _F}', "");
    Expect(0, 917999, '\p{Is_Case_Ignorable= _F}', "");
    Expect(1, 917999, '\p{^Is_Case_Ignorable= _F}', "");
    Expect(1, 917999, '\P{Is_Case_Ignorable= _F}', "");
    Expect(0, 917999, '\P{^Is_Case_Ignorable= _F}', "");
    Error('\p{Is_CI=	_False:=}');
    Error('\P{Is_CI=	_False:=}');
    Expect(1, 918000, '\p{Is_CI=false}', "");
    Expect(0, 918000, '\p{^Is_CI=false}', "");
    Expect(0, 918000, '\P{Is_CI=false}', "");
    Expect(1, 918000, '\P{^Is_CI=false}', "");
    Expect(0, 917999, '\p{Is_CI=false}', "");
    Expect(1, 917999, '\p{^Is_CI=false}', "");
    Expect(1, 917999, '\P{Is_CI=false}', "");
    Expect(0, 917999, '\P{^Is_CI=false}', "");
    Expect(1, 918000, '\p{Is_CI=	False}', "");
    Expect(0, 918000, '\p{^Is_CI=	False}', "");
    Expect(0, 918000, '\P{Is_CI=	False}', "");
    Expect(1, 918000, '\P{^Is_CI=	False}', "");
    Expect(0, 917999, '\p{Is_CI=	False}', "");
    Expect(1, 917999, '\p{^Is_CI=	False}', "");
    Expect(1, 917999, '\P{Is_CI=	False}', "");
    Expect(0, 917999, '\P{^Is_CI=	False}', "");
    Error('\p{Case_Ignorable=/a/		YES}');
    Error('\P{Case_Ignorable=/a/		YES}');
    Expect(1, 917999, '\p{Case_Ignorable=:\AYes\z:}', "");;
    Expect(0, 918000, '\p{Case_Ignorable=:\AYes\z:}', "");;
    Expect(1, 917999, '\p{Case_Ignorable=yes}', "");
    Expect(0, 917999, '\p{^Case_Ignorable=yes}', "");
    Expect(0, 917999, '\P{Case_Ignorable=yes}', "");
    Expect(1, 917999, '\P{^Case_Ignorable=yes}', "");
    Expect(0, 918000, '\p{Case_Ignorable=yes}', "");
    Expect(1, 918000, '\p{^Case_Ignorable=yes}', "");
    Expect(1, 918000, '\P{Case_Ignorable=yes}', "");
    Expect(0, 918000, '\P{^Case_Ignorable=yes}', "");
    Expect(1, 917999, '\p{Case_Ignorable=:\Ayes\z:}', "");;
    Expect(0, 918000, '\p{Case_Ignorable=:\Ayes\z:}', "");;
    Expect(1, 917999, '\p{Case_Ignorable=	Yes}', "");
    Expect(0, 917999, '\p{^Case_Ignorable=	Yes}', "");
    Expect(0, 917999, '\P{Case_Ignorable=	Yes}', "");
    Expect(1, 917999, '\P{^Case_Ignorable=	Yes}', "");
    Expect(0, 918000, '\p{Case_Ignorable=	Yes}', "");
    Expect(1, 918000, '\p{^Case_Ignorable=	Yes}', "");
    Expect(1, 918000, '\P{Case_Ignorable=	Yes}', "");
    Expect(0, 918000, '\P{^Case_Ignorable=	Yes}', "");
    Error('\p{CI=/a/y}');
    Error('\P{CI=/a/y}');
    Expect(1, 917999, '\p{CI=:\AY\z:}', "");;
    Expect(0, 918000, '\p{CI=:\AY\z:}', "");;
    Expect(1, 917999, '\p{CI=y}', "");
    Expect(0, 917999, '\p{^CI=y}', "");
    Expect(0, 917999, '\P{CI=y}', "");
    Expect(1, 917999, '\P{^CI=y}', "");
    Expect(0, 918000, '\p{CI=y}', "");
    Expect(1, 918000, '\p{^CI=y}', "");
    Expect(1, 918000, '\P{CI=y}', "");
    Expect(0, 918000, '\P{^CI=y}', "");
    Expect(1, 917999, '\p{CI=:\Ay\z:}', "");;
    Expect(0, 918000, '\p{CI=:\Ay\z:}', "");;
    Expect(1, 917999, '\p{CI=	 Y}', "");
    Expect(0, 917999, '\p{^CI=	 Y}', "");
    Expect(0, 917999, '\P{CI=	 Y}', "");
    Expect(1, 917999, '\P{^CI=	 Y}', "");
    Expect(0, 918000, '\p{CI=	 Y}', "");
    Expect(1, 918000, '\p{^CI=	 Y}', "");
    Expect(1, 918000, '\P{CI=	 Y}', "");
    Expect(0, 918000, '\P{^CI=	 Y}', "");
    Error('\p{Is_Case_Ignorable=-t/a/}');
    Error('\P{Is_Case_Ignorable=-t/a/}');
    Expect(1, 917999, '\p{Is_Case_Ignorable=t}', "");
    Expect(0, 917999, '\p{^Is_Case_Ignorable=t}', "");
    Expect(0, 917999, '\P{Is_Case_Ignorable=t}', "");
    Expect(1, 917999, '\P{^Is_Case_Ignorable=t}', "");
    Expect(0, 918000, '\p{Is_Case_Ignorable=t}', "");
    Expect(1, 918000, '\p{^Is_Case_Ignorable=t}', "");
    Expect(1, 918000, '\P{Is_Case_Ignorable=t}', "");
    Expect(0, 918000, '\P{^Is_Case_Ignorable=t}', "");
    Expect(1, 917999, '\p{Is_Case_Ignorable=__T}', "");
    Expect(0, 917999, '\p{^Is_Case_Ignorable=__T}', "");
    Expect(0, 917999, '\P{Is_Case_Ignorable=__T}', "");
    Expect(1, 917999, '\P{^Is_Case_Ignorable=__T}', "");
    Expect(0, 918000, '\p{Is_Case_Ignorable=__T}', "");
    Expect(1, 918000, '\p{^Is_Case_Ignorable=__T}', "");
    Expect(1, 918000, '\P{Is_Case_Ignorable=__T}', "");
    Expect(0, 918000, '\P{^Is_Case_Ignorable=__T}', "");
    Error('\p{Is_CI= /a/True}');
    Error('\P{Is_CI= /a/True}');
    Expect(1, 917999, '\p{Is_CI=true}', "");
    Expect(0, 917999, '\p{^Is_CI=true}', "");
    Expect(0, 917999, '\P{Is_CI=true}', "");
    Expect(1, 917999, '\P{^Is_CI=true}', "");
    Expect(0, 918000, '\p{Is_CI=true}', "");
    Expect(1, 918000, '\p{^Is_CI=true}', "");
    Expect(1, 918000, '\P{Is_CI=true}', "");
    Expect(0, 918000, '\P{^Is_CI=true}', "");
    Expect(1, 917999, '\p{Is_CI=	 true}', "");
    Expect(0, 917999, '\p{^Is_CI=	 true}', "");
    Expect(0, 917999, '\P{Is_CI=	 true}', "");
    Expect(1, 917999, '\P{^Is_CI=	 true}', "");
    Expect(0, 918000, '\p{Is_CI=	 true}', "");
    Expect(1, 918000, '\p{^Is_CI=	 true}', "");
    Expect(1, 918000, '\P{Is_CI=	 true}', "");
    Expect(0, 918000, '\P{^Is_CI=	 true}', "");
    Error('\p{kaccountingnumeric}');
    Error('\P{kaccountingnumeric}');
    Error('\p{cjkaccountingnumeric}');
    Error('\P{cjkaccountingnumeric}');
    Error('\p{kcompatibilityvariant}');
    Error('\P{kcompatibilityvariant}');
    Error('\p{cjkcompatibilityvariant}');
    Error('\P{cjkcompatibilityvariant}');
    Error('\p{kiicore}');
    Error('\P{kiicore}');
    Error('\p{cjkiicore}');
    Error('\P{cjkiicore}');
    Error('\p{kirggsource}');
    Error('\P{kirggsource}');
    Error('\p{cjkirggsource}');
    Error('\P{cjkirggsource}');
    Error('\p{kirghsource}');
    Error('\P{kirghsource}');
    Error('\p{cjkirghsource}');
    Error('\P{cjkirghsource}');
    Error('\p{kirgjsource}');
    Error('\P{kirgjsource}');
    Error('\p{cjkirgjsource}');
    Error('\P{cjkirgjsource}');
    Error('\p{kirgkpsource}');
    Error('\P{kirgkpsource}');
    Error('\p{cjkirgkpsource}');
    Error('\P{cjkirgkpsource}');
    Error('\p{kirgksource}');
    Error('\P{kirgksource}');
    Error('\p{cjkirgksource}');
    Error('\P{cjkirgksource}');
    Error('\p{kirgmsource}');
    Error('\P{kirgmsource}');
    Error('\p{cjkirgmsource}');
    Error('\P{cjkirgmsource}');
    Error('\p{kirgssource}');
    Error('\P{kirgssource}');
    Error('\p{cjkirgssource}');
    Error('\P{cjkirgssource}');
    Error('\p{kirgtsource}');
    Error('\P{kirgtsource}');
    Error('\p{cjkirgtsource}');
    Error('\P{cjkirgtsource}');
    Error('\p{kirguksource}');
    Error('\P{kirguksource}');
    Error('\p{cjkirguksource}');
    Error('\P{cjkirguksource}');
    Error('\p{kirgusource}');
    Error('\P{kirgusource}');
    Error('\p{cjkirgusource}');
    Error('\P{cjkirgusource}');
    Error('\p{kirgvsource}');
    Error('\P{kirgvsource}');
    Error('\p{cjkirgvsource}');
    Error('\P{cjkirgvsource}');
    Error('\p{kothernumeric}');
    Error('\P{kothernumeric}');
    Error('\p{cjkothernumeric}');
    Error('\P{cjkothernumeric}');
    Error('\p{kprimarynumeric}');
    Error('\P{kprimarynumeric}');
    Error('\p{cjkprimarynumeric}');
    Error('\P{cjkprimarynumeric}');
    Error('\p{krsunicode}');
    Error('\P{krsunicode}');
    Error('\p{cjkrsunicode}');
    Error('\P{cjkrsunicode}');
    Error('\p{unicoderadicalstroke}');
    Error('\P{unicoderadicalstroke}');
    Error('\p{urs}');
    Error('\P{urs}');
    Error('\p{Full_Composition_Exclusion=--No/a/}');
    Error('\P{Full_Composition_Exclusion=--No/a/}');
    Expect(1, 195102, '\p{Full_Composition_Exclusion=:\ANo\z:}', "");;
    Expect(0, 195101, '\p{Full_Composition_Exclusion=:\ANo\z:}', "");;
    Expect(1, 195102, '\p{Full_Composition_Exclusion=no}', "");
    Expect(0, 195102, '\p{^Full_Composition_Exclusion=no}', "");
    Expect(0, 195102, '\P{Full_Composition_Exclusion=no}', "");
    Expect(1, 195102, '\P{^Full_Composition_Exclusion=no}', "");
    Expect(0, 195101, '\p{Full_Composition_Exclusion=no}', "");
    Expect(1, 195101, '\p{^Full_Composition_Exclusion=no}', "");
    Expect(1, 195101, '\P{Full_Composition_Exclusion=no}', "");
    Expect(0, 195101, '\P{^Full_Composition_Exclusion=no}', "");
    Expect(1, 195102, '\p{Full_Composition_Exclusion=:\Ano\z:}', "");;
    Expect(0, 195101, '\p{Full_Composition_Exclusion=:\Ano\z:}', "");;
    Expect(1, 195102, '\p{Full_Composition_Exclusion=		no}', "");
    Expect(0, 195102, '\p{^Full_Composition_Exclusion=		no}', "");
    Expect(0, 195102, '\P{Full_Composition_Exclusion=		no}', "");
    Expect(1, 195102, '\P{^Full_Composition_Exclusion=		no}', "");
    Expect(0, 195101, '\p{Full_Composition_Exclusion=		no}', "");
    Expect(1, 195101, '\p{^Full_Composition_Exclusion=		no}', "");
    Expect(1, 195101, '\P{Full_Composition_Exclusion=		no}', "");
    Expect(0, 195101, '\P{^Full_Composition_Exclusion=		no}', "");
    Error('\p{Comp_Ex:	/a/_	n}');
    Error('\P{Comp_Ex:	/a/_	n}');
    Expect(1, 195102, '\p{Comp_Ex=:\AN\z:}', "");;
    Expect(0, 195101, '\p{Comp_Ex=:\AN\z:}', "");;
    Expect(1, 195102, '\p{Comp_Ex:   n}', "");
    Expect(0, 195102, '\p{^Comp_Ex:   n}', "");
    Expect(0, 195102, '\P{Comp_Ex:   n}', "");
    Expect(1, 195102, '\P{^Comp_Ex:   n}', "");
    Expect(0, 195101, '\p{Comp_Ex:   n}', "");
    Expect(1, 195101, '\p{^Comp_Ex:   n}', "");
    Expect(1, 195101, '\P{Comp_Ex:   n}', "");
    Expect(0, 195101, '\P{^Comp_Ex:   n}', "");
    Expect(1, 195102, '\p{Comp_Ex=:\An\z:}', "");;
    Expect(0, 195101, '\p{Comp_Ex=:\An\z:}', "");;
    Expect(1, 195102, '\p{Comp_Ex=- N}', "");
    Expect(0, 195102, '\p{^Comp_Ex=- N}', "");
    Expect(0, 195102, '\P{Comp_Ex=- N}', "");
    Expect(1, 195102, '\P{^Comp_Ex=- N}', "");
    Expect(0, 195101, '\p{Comp_Ex=- N}', "");
    Expect(1, 195101, '\p{^Comp_Ex=- N}', "");
    Expect(1, 195101, '\P{Comp_Ex=- N}', "");
    Expect(0, 195101, '\P{^Comp_Ex=- N}', "");
    Error('\p{Is_Full_Composition_Exclusion=:=		F}');
    Error('\P{Is_Full_Composition_Exclusion=:=		F}');
    Expect(1, 195102, '\p{Is_Full_Composition_Exclusion=f}', "");
    Expect(0, 195102, '\p{^Is_Full_Composition_Exclusion=f}', "");
    Expect(0, 195102, '\P{Is_Full_Composition_Exclusion=f}', "");
    Expect(1, 195102, '\P{^Is_Full_Composition_Exclusion=f}', "");
    Expect(0, 195101, '\p{Is_Full_Composition_Exclusion=f}', "");
    Expect(1, 195101, '\p{^Is_Full_Composition_Exclusion=f}', "");
    Expect(1, 195101, '\P{Is_Full_Composition_Exclusion=f}', "");
    Expect(0, 195101, '\P{^Is_Full_Composition_Exclusion=f}', "");
    Expect(1, 195102, '\p{Is_Full_Composition_Exclusion= F}', "");
    Expect(0, 195102, '\p{^Is_Full_Composition_Exclusion= F}', "");
    Expect(0, 195102, '\P{Is_Full_Composition_Exclusion= F}', "");
    Expect(1, 195102, '\P{^Is_Full_Composition_Exclusion= F}', "");
    Expect(0, 195101, '\p{Is_Full_Composition_Exclusion= F}', "");
    Expect(1, 195101, '\p{^Is_Full_Composition_Exclusion= F}', "");
    Expect(1, 195101, '\P{Is_Full_Composition_Exclusion= F}', "");
    Expect(0, 195101, '\P{^Is_Full_Composition_Exclusion= F}', "");
    Error('\p{Is_Comp_Ex=_/a/False}');
    Error('\P{Is_Comp_Ex=_/a/False}');
    Expect(1, 195102, '\p{Is_Comp_Ex: false}', "");
    Expect(0, 195102, '\p{^Is_Comp_Ex: false}', "");
    Expect(0, 195102, '\P{Is_Comp_Ex: false}', "");
    Expect(1, 195102, '\P{^Is_Comp_Ex: false}', "");
    Expect(0, 195101, '\p{Is_Comp_Ex: false}', "");
    Expect(1, 195101, '\p{^Is_Comp_Ex: false}', "");
    Expect(1, 195101, '\P{Is_Comp_Ex: false}', "");
    Expect(0, 195101, '\P{^Is_Comp_Ex: false}', "");
    Expect(1, 195102, '\p{Is_Comp_Ex=	False}', "");
    Expect(0, 195102, '\p{^Is_Comp_Ex=	False}', "");
    Expect(0, 195102, '\P{Is_Comp_Ex=	False}', "");
    Expect(1, 195102, '\P{^Is_Comp_Ex=	False}', "");
    Expect(0, 195101, '\p{Is_Comp_Ex=	False}', "");
    Expect(1, 195101, '\p{^Is_Comp_Ex=	False}', "");
    Expect(1, 195101, '\P{Is_Comp_Ex=	False}', "");
    Expect(0, 195101, '\P{^Is_Comp_Ex=	False}', "");
    Error('\p{Full_Composition_Exclusion= Yes/a/}');
    Error('\P{Full_Composition_Exclusion= Yes/a/}');
    Expect(1, 195101, '\p{Full_Composition_Exclusion=:\AYes\z:}', "");;
    Expect(0, 195102, '\p{Full_Composition_Exclusion=:\AYes\z:}', "");;
    Expect(1, 195101, '\p{Full_Composition_Exclusion=yes}', "");
    Expect(0, 195101, '\p{^Full_Composition_Exclusion=yes}', "");
    Expect(0, 195101, '\P{Full_Composition_Exclusion=yes}', "");
    Expect(1, 195101, '\P{^Full_Composition_Exclusion=yes}', "");
    Expect(0, 195102, '\p{Full_Composition_Exclusion=yes}', "");
    Expect(1, 195102, '\p{^Full_Composition_Exclusion=yes}', "");
    Expect(1, 195102, '\P{Full_Composition_Exclusion=yes}', "");
    Expect(0, 195102, '\P{^Full_Composition_Exclusion=yes}', "");
    Expect(1, 195101, '\p{Full_Composition_Exclusion=:\Ayes\z:}', "");;
    Expect(0, 195102, '\p{Full_Composition_Exclusion=:\Ayes\z:}', "");;
    Expect(1, 195101, '\p{Full_Composition_Exclusion:		 Yes}', "");
    Expect(0, 195101, '\p{^Full_Composition_Exclusion:		 Yes}', "");
    Expect(0, 195101, '\P{Full_Composition_Exclusion:		 Yes}', "");
    Expect(1, 195101, '\P{^Full_Composition_Exclusion:		 Yes}', "");
    Expect(0, 195102, '\p{Full_Composition_Exclusion:		 Yes}', "");
    Expect(1, 195102, '\p{^Full_Composition_Exclusion:		 Yes}', "");
    Expect(1, 195102, '\P{Full_Composition_Exclusion:		 Yes}', "");
    Expect(0, 195102, '\P{^Full_Composition_Exclusion:		 Yes}', "");
    Error('\p{Comp_Ex::= 	Y}');
    Error('\P{Comp_Ex::= 	Y}');
    Expect(1, 195101, '\p{Comp_Ex=:\AY\z:}', "");;
    Expect(0, 195102, '\p{Comp_Ex=:\AY\z:}', "");;
    Expect(1, 195101, '\p{Comp_Ex=y}', "");
    Expect(0, 195101, '\p{^Comp_Ex=y}', "");
    Expect(0, 195101, '\P{Comp_Ex=y}', "");
    Expect(1, 195101, '\P{^Comp_Ex=y}', "");
    Expect(0, 195102, '\p{Comp_Ex=y}', "");
    Expect(1, 195102, '\p{^Comp_Ex=y}', "");
    Expect(1, 195102, '\P{Comp_Ex=y}', "");
    Expect(0, 195102, '\P{^Comp_Ex=y}', "");
    Expect(1, 195101, '\p{Comp_Ex=:\Ay\z:}', "");;
    Expect(0, 195102, '\p{Comp_Ex=:\Ay\z:}', "");;
    Expect(1, 195101, '\p{Comp_Ex=-	y}', "");
    Expect(0, 195101, '\p{^Comp_Ex=-	y}', "");
    Expect(0, 195101, '\P{Comp_Ex=-	y}', "");
    Expect(1, 195101, '\P{^Comp_Ex=-	y}', "");
    Expect(0, 195102, '\p{Comp_Ex=-	y}', "");
    Expect(1, 195102, '\p{^Comp_Ex=-	y}', "");
    Expect(1, 195102, '\P{Comp_Ex=-	y}', "");
    Expect(0, 195102, '\P{^Comp_Ex=-	y}', "");
    Error('\p{Is_Full_Composition_Exclusion=:=  T}');
    Error('\P{Is_Full_Composition_Exclusion=:=  T}');
    Expect(1, 195101, '\p{Is_Full_Composition_Exclusion=t}', "");
    Expect(0, 195101, '\p{^Is_Full_Composition_Exclusion=t}', "");
    Expect(0, 195101, '\P{Is_Full_Composition_Exclusion=t}', "");
    Expect(1, 195101, '\P{^Is_Full_Composition_Exclusion=t}', "");
    Expect(0, 195102, '\p{Is_Full_Composition_Exclusion=t}', "");
    Expect(1, 195102, '\p{^Is_Full_Composition_Exclusion=t}', "");
    Expect(1, 195102, '\P{Is_Full_Composition_Exclusion=t}', "");
    Expect(0, 195102, '\P{^Is_Full_Composition_Exclusion=t}', "");
    Expect(1, 195101, '\p{Is_Full_Composition_Exclusion=-_t}', "");
    Expect(0, 195101, '\p{^Is_Full_Composition_Exclusion=-_t}', "");
    Expect(0, 195101, '\P{Is_Full_Composition_Exclusion=-_t}', "");
    Expect(1, 195101, '\P{^Is_Full_Composition_Exclusion=-_t}', "");
    Expect(0, 195102, '\p{Is_Full_Composition_Exclusion=-_t}', "");
    Expect(1, 195102, '\p{^Is_Full_Composition_Exclusion=-_t}', "");
    Expect(1, 195102, '\P{Is_Full_Composition_Exclusion=-_t}', "");
    Expect(0, 195102, '\P{^Is_Full_Composition_Exclusion=-_t}', "");
    Error('\p{Is_Comp_Ex= /a/True}');
    Error('\P{Is_Comp_Ex= /a/True}');
    Expect(1, 195101, '\p{Is_Comp_Ex=true}', "");
    Expect(0, 195101, '\p{^Is_Comp_Ex=true}', "");
    Expect(0, 195101, '\P{Is_Comp_Ex=true}', "");
    Expect(1, 195101, '\P{^Is_Comp_Ex=true}', "");
    Expect(0, 195102, '\p{Is_Comp_Ex=true}', "");
    Expect(1, 195102, '\p{^Is_Comp_Ex=true}', "");
    Expect(1, 195102, '\P{Is_Comp_Ex=true}', "");
    Expect(0, 195102, '\P{^Is_Comp_Ex=true}', "");
    Expect(1, 195101, '\p{Is_Comp_Ex=_True}', "");
    Expect(0, 195101, '\p{^Is_Comp_Ex=_True}', "");
    Expect(0, 195101, '\P{Is_Comp_Ex=_True}', "");
    Expect(1, 195101, '\P{^Is_Comp_Ex=_True}', "");
    Expect(0, 195102, '\p{Is_Comp_Ex=_True}', "");
    Expect(1, 195102, '\p{^Is_Comp_Ex=_True}', "");
    Expect(1, 195102, '\P{Is_Comp_Ex=_True}', "");
    Expect(0, 195102, '\P{^Is_Comp_Ex=_True}', "");
    Error('\p{Changes_When_Casefolded=	-No/a/}');
    Error('\P{Changes_When_Casefolded=	-No/a/}');
    Expect(1, 125218, '\p{Changes_When_Casefolded=:\ANo\z:}', "");;
    Expect(0, 125217, '\p{Changes_When_Casefolded=:\ANo\z:}', "");;
    Expect(1, 125218, '\p{Changes_When_Casefolded=no}', "");
    Expect(0, 125218, '\p{^Changes_When_Casefolded=no}', "");
    Expect(0, 125218, '\P{Changes_When_Casefolded=no}', "");
    Expect(1, 125218, '\P{^Changes_When_Casefolded=no}', "");
    Expect(0, 125217, '\p{Changes_When_Casefolded=no}', "");
    Expect(1, 125217, '\p{^Changes_When_Casefolded=no}', "");
    Expect(1, 125217, '\P{Changes_When_Casefolded=no}', "");
    Expect(0, 125217, '\P{^Changes_When_Casefolded=no}', "");
    Expect(1, 125218, '\p{Changes_When_Casefolded=:\Ano\z:}', "");;
    Expect(0, 125217, '\p{Changes_When_Casefolded=:\Ano\z:}', "");;
    Expect(1, 125218, '\p{Changes_When_Casefolded=	_NO}', "");
    Expect(0, 125218, '\p{^Changes_When_Casefolded=	_NO}', "");
    Expect(0, 125218, '\P{Changes_When_Casefolded=	_NO}', "");
    Expect(1, 125218, '\P{^Changes_When_Casefolded=	_NO}', "");
    Expect(0, 125217, '\p{Changes_When_Casefolded=	_NO}', "");
    Expect(1, 125217, '\p{^Changes_When_Casefolded=	_NO}', "");
    Expect(1, 125217, '\P{Changes_When_Casefolded=	_NO}', "");
    Expect(0, 125217, '\P{^Changes_When_Casefolded=	_NO}', "");
    Error('\p{CWCF:	 N:=}');
    Error('\P{CWCF:	 N:=}');
    Expect(1, 125218, '\p{CWCF=:\AN\z:}', "");;
    Expect(0, 125217, '\p{CWCF=:\AN\z:}', "");;
    Expect(1, 125218, '\p{CWCF=n}', "");
    Expect(0, 125218, '\p{^CWCF=n}', "");
    Expect(0, 125218, '\P{CWCF=n}', "");
    Expect(1, 125218, '\P{^CWCF=n}', "");
    Expect(0, 125217, '\p{CWCF=n}', "");
    Expect(1, 125217, '\p{^CWCF=n}', "");
    Expect(1, 125217, '\P{CWCF=n}', "");
    Expect(0, 125217, '\P{^CWCF=n}', "");
    Expect(1, 125218, '\p{CWCF=:\An\z:}', "");;
    Expect(0, 125217, '\p{CWCF=:\An\z:}', "");;
    Expect(1, 125218, '\p{CWCF=	-N}', "");
    Expect(0, 125218, '\p{^CWCF=	-N}', "");
    Expect(0, 125218, '\P{CWCF=	-N}', "");
    Expect(1, 125218, '\P{^CWCF=	-N}', "");
    Expect(0, 125217, '\p{CWCF=	-N}', "");
    Expect(1, 125217, '\p{^CWCF=	-N}', "");
    Expect(1, 125217, '\P{CWCF=	-N}', "");
    Expect(0, 125217, '\P{^CWCF=	-N}', "");
    Error('\p{Is_Changes_When_Casefolded= -F/a/}');
    Error('\P{Is_Changes_When_Casefolded= -F/a/}');
    Expect(1, 125218, '\p{Is_Changes_When_Casefolded=f}', "");
    Expect(0, 125218, '\p{^Is_Changes_When_Casefolded=f}', "");
    Expect(0, 125218, '\P{Is_Changes_When_Casefolded=f}', "");
    Expect(1, 125218, '\P{^Is_Changes_When_Casefolded=f}', "");
    Expect(0, 125217, '\p{Is_Changes_When_Casefolded=f}', "");
    Expect(1, 125217, '\p{^Is_Changes_When_Casefolded=f}', "");
    Expect(1, 125217, '\P{Is_Changes_When_Casefolded=f}', "");
    Expect(0, 125217, '\P{^Is_Changes_When_Casefolded=f}', "");
    Expect(1, 125218, '\p{Is_Changes_When_Casefolded=_f}', "");
    Expect(0, 125218, '\p{^Is_Changes_When_Casefolded=_f}', "");
    Expect(0, 125218, '\P{Is_Changes_When_Casefolded=_f}', "");
    Expect(1, 125218, '\P{^Is_Changes_When_Casefolded=_f}', "");
    Expect(0, 125217, '\p{Is_Changes_When_Casefolded=_f}', "");
    Expect(1, 125217, '\p{^Is_Changes_When_Casefolded=_f}', "");
    Expect(1, 125217, '\P{Is_Changes_When_Casefolded=_f}', "");
    Expect(0, 125217, '\P{^Is_Changes_When_Casefolded=_f}', "");
    Error('\p{Is_CWCF=	false:=}');
    Error('\P{Is_CWCF=	false:=}');
    Expect(1, 125218, '\p{Is_CWCF=false}', "");
    Expect(0, 125218, '\p{^Is_CWCF=false}', "");
    Expect(0, 125218, '\P{Is_CWCF=false}', "");
    Expect(1, 125218, '\P{^Is_CWCF=false}', "");
    Expect(0, 125217, '\p{Is_CWCF=false}', "");
    Expect(1, 125217, '\p{^Is_CWCF=false}', "");
    Expect(1, 125217, '\P{Is_CWCF=false}', "");
    Expect(0, 125217, '\P{^Is_CWCF=false}', "");
    Expect(1, 125218, '\p{Is_CWCF= _false}', "");
    Expect(0, 125218, '\p{^Is_CWCF= _false}', "");
    Expect(0, 125218, '\P{Is_CWCF= _false}', "");
    Expect(1, 125218, '\P{^Is_CWCF= _false}', "");
    Expect(0, 125217, '\p{Is_CWCF= _false}', "");
    Expect(1, 125217, '\p{^Is_CWCF= _false}', "");
    Expect(1, 125217, '\P{Is_CWCF= _false}', "");
    Expect(0, 125217, '\P{^Is_CWCF= _false}', "");
    Error('\p{Changes_When_Casefolded= YES/a/}');
    Error('\P{Changes_When_Casefolded= YES/a/}');
    Expect(1, 125217, '\p{Changes_When_Casefolded=:\AYes\z:}', "");;
    Expect(0, 125218, '\p{Changes_When_Casefolded=:\AYes\z:}', "");;
    Expect(1, 125217, '\p{Changes_When_Casefolded=yes}', "");
    Expect(0, 125217, '\p{^Changes_When_Casefolded=yes}', "");
    Expect(0, 125217, '\P{Changes_When_Casefolded=yes}', "");
    Expect(1, 125217, '\P{^Changes_When_Casefolded=yes}', "");
    Expect(0, 125218, '\p{Changes_When_Casefolded=yes}', "");
    Expect(1, 125218, '\p{^Changes_When_Casefolded=yes}', "");
    Expect(1, 125218, '\P{Changes_When_Casefolded=yes}', "");
    Expect(0, 125218, '\P{^Changes_When_Casefolded=yes}', "");
    Expect(1, 125217, '\p{Changes_When_Casefolded=:\Ayes\z:}', "");;
    Expect(0, 125218, '\p{Changes_When_Casefolded=:\Ayes\z:}', "");;
    Expect(1, 125217, '\p{Changes_When_Casefolded=Yes}', "");
    Expect(0, 125217, '\p{^Changes_When_Casefolded=Yes}', "");
    Expect(0, 125217, '\P{Changes_When_Casefolded=Yes}', "");
    Expect(1, 125217, '\P{^Changes_When_Casefolded=Yes}', "");
    Expect(0, 125218, '\p{Changes_When_Casefolded=Yes}', "");
    Expect(1, 125218, '\p{^Changes_When_Casefolded=Yes}', "");
    Expect(1, 125218, '\P{Changes_When_Casefolded=Yes}', "");
    Expect(0, 125218, '\P{^Changes_When_Casefolded=Yes}', "");
    Error('\p{CWCF=_Y/a/}');
    Error('\P{CWCF=_Y/a/}');
    Expect(1, 125217, '\p{CWCF=:\AY\z:}', "");;
    Expect(0, 125218, '\p{CWCF=:\AY\z:}', "");;
    Expect(1, 125217, '\p{CWCF=y}', "");
    Expect(0, 125217, '\p{^CWCF=y}', "");
    Expect(0, 125217, '\P{CWCF=y}', "");
    Expect(1, 125217, '\P{^CWCF=y}', "");
    Expect(0, 125218, '\p{CWCF=y}', "");
    Expect(1, 125218, '\p{^CWCF=y}', "");
    Expect(1, 125218, '\P{CWCF=y}', "");
    Expect(0, 125218, '\P{^CWCF=y}', "");
    Expect(1, 125217, '\p{CWCF=:\Ay\z:}', "");;
    Expect(0, 125218, '\p{CWCF=:\Ay\z:}', "");;
    Expect(1, 125217, '\p{CWCF=_Y}', "");
    Expect(0, 125217, '\p{^CWCF=_Y}', "");
    Expect(0, 125217, '\P{CWCF=_Y}', "");
    Expect(1, 125217, '\P{^CWCF=_Y}', "");
    Expect(0, 125218, '\p{CWCF=_Y}', "");
    Expect(1, 125218, '\p{^CWCF=_Y}', "");
    Expect(1, 125218, '\P{CWCF=_Y}', "");
    Expect(0, 125218, '\P{^CWCF=_Y}', "");
    Error('\p{Is_Changes_When_Casefolded= _T/a/}');
    Error('\P{Is_Changes_When_Casefolded= _T/a/}');
    Expect(1, 125217, '\p{Is_Changes_When_Casefolded=t}', "");
    Expect(0, 125217, '\p{^Is_Changes_When_Casefolded=t}', "");
    Expect(0, 125217, '\P{Is_Changes_When_Casefolded=t}', "");
    Expect(1, 125217, '\P{^Is_Changes_When_Casefolded=t}', "");
    Expect(0, 125218, '\p{Is_Changes_When_Casefolded=t}', "");
    Expect(1, 125218, '\p{^Is_Changes_When_Casefolded=t}', "");
    Expect(1, 125218, '\P{Is_Changes_When_Casefolded=t}', "");
    Expect(0, 125218, '\P{^Is_Changes_When_Casefolded=t}', "");
    Expect(1, 125217, '\p{Is_Changes_When_Casefolded: T}', "");
    Expect(0, 125217, '\p{^Is_Changes_When_Casefolded: T}', "");
    Expect(0, 125217, '\P{Is_Changes_When_Casefolded: T}', "");
    Expect(1, 125217, '\P{^Is_Changes_When_Casefolded: T}', "");
    Expect(0, 125218, '\p{Is_Changes_When_Casefolded: T}', "");
    Expect(1, 125218, '\p{^Is_Changes_When_Casefolded: T}', "");
    Expect(1, 125218, '\P{Is_Changes_When_Casefolded: T}', "");
    Expect(0, 125218, '\P{^Is_Changes_When_Casefolded: T}', "");
    Error('\p{Is_CWCF=:= -True}');
    Error('\P{Is_CWCF=:= -True}');
    Expect(1, 125217, '\p{Is_CWCF=true}', "");
    Expect(0, 125217, '\p{^Is_CWCF=true}', "");
    Expect(0, 125217, '\P{Is_CWCF=true}', "");
    Expect(1, 125217, '\P{^Is_CWCF=true}', "");
    Expect(0, 125218, '\p{Is_CWCF=true}', "");
    Expect(1, 125218, '\p{^Is_CWCF=true}', "");
    Expect(1, 125218, '\P{Is_CWCF=true}', "");
    Expect(0, 125218, '\P{^Is_CWCF=true}', "");
    Expect(1, 125217, '\p{Is_CWCF=-true}', "");
    Expect(0, 125217, '\p{^Is_CWCF=-true}', "");
    Expect(0, 125217, '\P{Is_CWCF=-true}', "");
    Expect(1, 125217, '\P{^Is_CWCF=-true}', "");
    Expect(0, 125218, '\p{Is_CWCF=-true}', "");
    Expect(1, 125218, '\p{^Is_CWCF=-true}', "");
    Expect(1, 125218, '\P{Is_CWCF=-true}', "");
    Expect(0, 125218, '\P{^Is_CWCF=-true}', "");
    Error('\p{Changes_When_Casemapped=_	No:=}');
    Error('\P{Changes_When_Casemapped=_	No:=}');
    Expect(1, 125252, '\p{Changes_When_Casemapped=:\ANo\z:}', "");;
    Expect(0, 125251, '\p{Changes_When_Casemapped=:\ANo\z:}', "");;
    Expect(1, 125252, '\p{Changes_When_Casemapped=no}', "");
    Expect(0, 125252, '\p{^Changes_When_Casemapped=no}', "");
    Expect(0, 125252, '\P{Changes_When_Casemapped=no}', "");
    Expect(1, 125252, '\P{^Changes_When_Casemapped=no}', "");
    Expect(0, 125251, '\p{Changes_When_Casemapped=no}', "");
    Expect(1, 125251, '\p{^Changes_When_Casemapped=no}', "");
    Expect(1, 125251, '\P{Changes_When_Casemapped=no}', "");
    Expect(0, 125251, '\P{^Changes_When_Casemapped=no}', "");
    Expect(1, 125252, '\p{Changes_When_Casemapped=:\Ano\z:}', "");;
    Expect(0, 125251, '\p{Changes_When_Casemapped=:\Ano\z:}', "");;
    Expect(1, 125252, '\p{Changes_When_Casemapped=-	No}', "");
    Expect(0, 125252, '\p{^Changes_When_Casemapped=-	No}', "");
    Expect(0, 125252, '\P{Changes_When_Casemapped=-	No}', "");
    Expect(1, 125252, '\P{^Changes_When_Casemapped=-	No}', "");
    Expect(0, 125251, '\p{Changes_When_Casemapped=-	No}', "");
    Expect(1, 125251, '\p{^Changes_When_Casemapped=-	No}', "");
    Expect(1, 125251, '\P{Changes_When_Casemapped=-	No}', "");
    Expect(0, 125251, '\P{^Changes_When_Casemapped=-	No}', "");
    Error('\p{CWCM=/a/ -n}');
    Error('\P{CWCM=/a/ -n}');
    Expect(1, 125252, '\p{CWCM=:\AN\z:}', "");;
    Expect(0, 125251, '\p{CWCM=:\AN\z:}', "");;
    Expect(1, 125252, '\p{CWCM=n}', "");
    Expect(0, 125252, '\p{^CWCM=n}', "");
    Expect(0, 125252, '\P{CWCM=n}', "");
    Expect(1, 125252, '\P{^CWCM=n}', "");
    Expect(0, 125251, '\p{CWCM=n}', "");
    Expect(1, 125251, '\p{^CWCM=n}', "");
    Expect(1, 125251, '\P{CWCM=n}', "");
    Expect(0, 125251, '\P{^CWCM=n}', "");
    Expect(1, 125252, '\p{CWCM=:\An\z:}', "");;
    Expect(0, 125251, '\p{CWCM=:\An\z:}', "");;
    Expect(1, 125252, '\p{CWCM=__N}', "");
    Expect(0, 125252, '\p{^CWCM=__N}', "");
    Expect(0, 125252, '\P{CWCM=__N}', "");
    Expect(1, 125252, '\P{^CWCM=__N}', "");
    Expect(0, 125251, '\p{CWCM=__N}', "");
    Expect(1, 125251, '\p{^CWCM=__N}', "");
    Expect(1, 125251, '\P{CWCM=__N}', "");
    Expect(0, 125251, '\P{^CWCM=__N}', "");
    Error('\p{Is_Changes_When_Casemapped=_-f:=}');
    Error('\P{Is_Changes_When_Casemapped=_-f:=}');
    Expect(1, 125252, '\p{Is_Changes_When_Casemapped=f}', "");
    Expect(0, 125252, '\p{^Is_Changes_When_Casemapped=f}', "");
    Expect(0, 125252, '\P{Is_Changes_When_Casemapped=f}', "");
    Expect(1, 125252, '\P{^Is_Changes_When_Casemapped=f}', "");
    Expect(0, 125251, '\p{Is_Changes_When_Casemapped=f}', "");
    Expect(1, 125251, '\p{^Is_Changes_When_Casemapped=f}', "");
    Expect(1, 125251, '\P{Is_Changes_When_Casemapped=f}', "");
    Expect(0, 125251, '\P{^Is_Changes_When_Casemapped=f}', "");
    Expect(1, 125252, '\p{Is_Changes_When_Casemapped=-F}', "");
    Expect(0, 125252, '\p{^Is_Changes_When_Casemapped=-F}', "");
    Expect(0, 125252, '\P{Is_Changes_When_Casemapped=-F}', "");
    Expect(1, 125252, '\P{^Is_Changes_When_Casemapped=-F}', "");
    Expect(0, 125251, '\p{Is_Changes_When_Casemapped=-F}', "");
    Expect(1, 125251, '\p{^Is_Changes_When_Casemapped=-F}', "");
    Expect(1, 125251, '\P{Is_Changes_When_Casemapped=-F}', "");
    Expect(0, 125251, '\P{^Is_Changes_When_Casemapped=-F}', "");
    Error('\p{Is_CWCM=- False:=}');
    Error('\P{Is_CWCM=- False:=}');
    Expect(1, 125252, '\p{Is_CWCM:   false}', "");
    Expect(0, 125252, '\p{^Is_CWCM:   false}', "");
    Expect(0, 125252, '\P{Is_CWCM:   false}', "");
    Expect(1, 125252, '\P{^Is_CWCM:   false}', "");
    Expect(0, 125251, '\p{Is_CWCM:   false}', "");
    Expect(1, 125251, '\p{^Is_CWCM:   false}', "");
    Expect(1, 125251, '\P{Is_CWCM:   false}', "");
    Expect(0, 125251, '\P{^Is_CWCM:   false}', "");
    Expect(1, 125252, '\p{Is_CWCM=	 False}', "");
    Expect(0, 125252, '\p{^Is_CWCM=	 False}', "");
    Expect(0, 125252, '\P{Is_CWCM=	 False}', "");
    Expect(1, 125252, '\P{^Is_CWCM=	 False}', "");
    Expect(0, 125251, '\p{Is_CWCM=	 False}', "");
    Expect(1, 125251, '\p{^Is_CWCM=	 False}', "");
    Expect(1, 125251, '\P{Is_CWCM=	 False}', "");
    Expect(0, 125251, '\P{^Is_CWCM=	 False}', "");
    Error('\p{Changes_When_Casemapped=/a/-_Yes}');
    Error('\P{Changes_When_Casemapped=/a/-_Yes}');
    Expect(1, 125251, '\p{Changes_When_Casemapped=:\AYes\z:}', "");;
    Expect(0, 125252, '\p{Changes_When_Casemapped=:\AYes\z:}', "");;
    Expect(1, 125251, '\p{Changes_When_Casemapped=yes}', "");
    Expect(0, 125251, '\p{^Changes_When_Casemapped=yes}', "");
    Expect(0, 125251, '\P{Changes_When_Casemapped=yes}', "");
    Expect(1, 125251, '\P{^Changes_When_Casemapped=yes}', "");
    Expect(0, 125252, '\p{Changes_When_Casemapped=yes}', "");
    Expect(1, 125252, '\p{^Changes_When_Casemapped=yes}', "");
    Expect(1, 125252, '\P{Changes_When_Casemapped=yes}', "");
    Expect(0, 125252, '\P{^Changes_When_Casemapped=yes}', "");
    Expect(1, 125251, '\p{Changes_When_Casemapped=:\Ayes\z:}', "");;
    Expect(0, 125252, '\p{Changes_When_Casemapped=:\Ayes\z:}', "");;
    Expect(1, 125251, '\p{Changes_When_Casemapped=-Yes}', "");
    Expect(0, 125251, '\p{^Changes_When_Casemapped=-Yes}', "");
    Expect(0, 125251, '\P{Changes_When_Casemapped=-Yes}', "");
    Expect(1, 125251, '\P{^Changes_When_Casemapped=-Yes}', "");
    Expect(0, 125252, '\p{Changes_When_Casemapped=-Yes}', "");
    Expect(1, 125252, '\p{^Changes_When_Casemapped=-Yes}', "");
    Expect(1, 125252, '\P{Changes_When_Casemapped=-Yes}', "");
    Expect(0, 125252, '\P{^Changes_When_Casemapped=-Yes}', "");
    Error('\p{CWCM:    /a/y}');
    Error('\P{CWCM:    /a/y}');
    Expect(1, 125251, '\p{CWCM=:\AY\z:}', "");;
    Expect(0, 125252, '\p{CWCM=:\AY\z:}', "");;
    Expect(1, 125251, '\p{CWCM=y}', "");
    Expect(0, 125251, '\p{^CWCM=y}', "");
    Expect(0, 125251, '\P{CWCM=y}', "");
    Expect(1, 125251, '\P{^CWCM=y}', "");
    Expect(0, 125252, '\p{CWCM=y}', "");
    Expect(1, 125252, '\p{^CWCM=y}', "");
    Expect(1, 125252, '\P{CWCM=y}', "");
    Expect(0, 125252, '\P{^CWCM=y}', "");
    Expect(1, 125251, '\p{CWCM=:\Ay\z:}', "");;
    Expect(0, 125252, '\p{CWCM=:\Ay\z:}', "");;
    Expect(1, 125251, '\p{CWCM=-Y}', "");
    Expect(0, 125251, '\p{^CWCM=-Y}', "");
    Expect(0, 125251, '\P{CWCM=-Y}', "");
    Expect(1, 125251, '\P{^CWCM=-Y}', "");
    Expect(0, 125252, '\p{CWCM=-Y}', "");
    Expect(1, 125252, '\p{^CWCM=-Y}', "");
    Expect(1, 125252, '\P{CWCM=-Y}', "");
    Expect(0, 125252, '\P{^CWCM=-Y}', "");
    Error('\p{Is_Changes_When_Casemapped=		T/a/}');
    Error('\P{Is_Changes_When_Casemapped=		T/a/}');
    Expect(1, 125251, '\p{Is_Changes_When_Casemapped=t}', "");
    Expect(0, 125251, '\p{^Is_Changes_When_Casemapped=t}', "");
    Expect(0, 125251, '\P{Is_Changes_When_Casemapped=t}', "");
    Expect(1, 125251, '\P{^Is_Changes_When_Casemapped=t}', "");
    Expect(0, 125252, '\p{Is_Changes_When_Casemapped=t}', "");
    Expect(1, 125252, '\p{^Is_Changes_When_Casemapped=t}', "");
    Expect(1, 125252, '\P{Is_Changes_When_Casemapped=t}', "");
    Expect(0, 125252, '\P{^Is_Changes_When_Casemapped=t}', "");
    Expect(1, 125251, '\p{Is_Changes_When_Casemapped=  T}', "");
    Expect(0, 125251, '\p{^Is_Changes_When_Casemapped=  T}', "");
    Expect(0, 125251, '\P{Is_Changes_When_Casemapped=  T}', "");
    Expect(1, 125251, '\P{^Is_Changes_When_Casemapped=  T}', "");
    Expect(0, 125252, '\p{Is_Changes_When_Casemapped=  T}', "");
    Expect(1, 125252, '\p{^Is_Changes_When_Casemapped=  T}', "");
    Expect(1, 125252, '\P{Is_Changes_When_Casemapped=  T}', "");
    Expect(0, 125252, '\P{^Is_Changes_When_Casemapped=  T}', "");
    Error('\p{Is_CWCM=		True:=}');
    Error('\P{Is_CWCM=		True:=}');
    Expect(1, 125251, '\p{Is_CWCM=true}', "");
    Expect(0, 125251, '\p{^Is_CWCM=true}', "");
    Expect(0, 125251, '\P{Is_CWCM=true}', "");
    Expect(1, 125251, '\P{^Is_CWCM=true}', "");
    Expect(0, 125252, '\p{Is_CWCM=true}', "");
    Expect(1, 125252, '\p{^Is_CWCM=true}', "");
    Expect(1, 125252, '\P{Is_CWCM=true}', "");
    Expect(0, 125252, '\P{^Is_CWCM=true}', "");
    Expect(1, 125251, '\p{Is_CWCM=True}', "");
    Expect(0, 125251, '\p{^Is_CWCM=True}', "");
    Expect(0, 125251, '\P{Is_CWCM=True}', "");
    Expect(1, 125251, '\P{^Is_CWCM=True}', "");
    Expect(0, 125252, '\p{Is_CWCM=True}', "");
    Expect(1, 125252, '\p{^Is_CWCM=True}', "");
    Expect(1, 125252, '\P{Is_CWCM=True}', "");
    Expect(0, 125252, '\P{^Is_CWCM=True}', "");
    Error('\p{Changes_When_NFKC_Casefolded= _No:=}');
    Error('\P{Changes_When_NFKC_Casefolded= _No:=}');
    Expect(1, 921600, '\p{Changes_When_NFKC_Casefolded=:\ANo\z:}', "");;
    Expect(0, 921599, '\p{Changes_When_NFKC_Casefolded=:\ANo\z:}', "");;
    Expect(1, 921600, '\p{Changes_When_NFKC_Casefolded=no}', "");
    Expect(0, 921600, '\p{^Changes_When_NFKC_Casefolded=no}', "");
    Expect(0, 921600, '\P{Changes_When_NFKC_Casefolded=no}', "");
    Expect(1, 921600, '\P{^Changes_When_NFKC_Casefolded=no}', "");
    Expect(0, 921599, '\p{Changes_When_NFKC_Casefolded=no}', "");
    Expect(1, 921599, '\p{^Changes_When_NFKC_Casefolded=no}', "");
    Expect(1, 921599, '\P{Changes_When_NFKC_Casefolded=no}', "");
    Expect(0, 921599, '\P{^Changes_When_NFKC_Casefolded=no}', "");
    Expect(1, 921600, '\p{Changes_When_NFKC_Casefolded=:\Ano\z:}', "");;
    Expect(0, 921599, '\p{Changes_When_NFKC_Casefolded=:\Ano\z:}', "");;
    Expect(1, 921600, '\p{Changes_When_NFKC_Casefolded= No}', "");
    Expect(0, 921600, '\p{^Changes_When_NFKC_Casefolded= No}', "");
    Expect(0, 921600, '\P{Changes_When_NFKC_Casefolded= No}', "");
    Expect(1, 921600, '\P{^Changes_When_NFKC_Casefolded= No}', "");
    Expect(0, 921599, '\p{Changes_When_NFKC_Casefolded= No}', "");
    Expect(1, 921599, '\p{^Changes_When_NFKC_Casefolded= No}', "");
    Expect(1, 921599, '\P{Changes_When_NFKC_Casefolded= No}', "");
    Expect(0, 921599, '\P{^Changes_When_NFKC_Casefolded= No}', "");
    Error('\p{CWKCF=	_N/a/}');
    Error('\P{CWKCF=	_N/a/}');
    Expect(1, 921600, '\p{CWKCF=:\AN\z:}', "");;
    Expect(0, 921599, '\p{CWKCF=:\AN\z:}', "");;
    Expect(1, 921600, '\p{CWKCF=n}', "");
    Expect(0, 921600, '\p{^CWKCF=n}', "");
    Expect(0, 921600, '\P{CWKCF=n}', "");
    Expect(1, 921600, '\P{^CWKCF=n}', "");
    Expect(0, 921599, '\p{CWKCF=n}', "");
    Expect(1, 921599, '\p{^CWKCF=n}', "");
    Expect(1, 921599, '\P{CWKCF=n}', "");
    Expect(0, 921599, '\P{^CWKCF=n}', "");
    Expect(1, 921600, '\p{CWKCF=:\An\z:}', "");;
    Expect(0, 921599, '\p{CWKCF=:\An\z:}', "");;
    Expect(1, 921600, '\p{CWKCF=-	N}', "");
    Expect(0, 921600, '\p{^CWKCF=-	N}', "");
    Expect(0, 921600, '\P{CWKCF=-	N}', "");
    Expect(1, 921600, '\P{^CWKCF=-	N}', "");
    Expect(0, 921599, '\p{CWKCF=-	N}', "");
    Expect(1, 921599, '\p{^CWKCF=-	N}', "");
    Expect(1, 921599, '\P{CWKCF=-	N}', "");
    Expect(0, 921599, '\P{^CWKCF=-	N}', "");
    Error('\p{Is_Changes_When_NFKC_Casefolded= _F/a/}');
    Error('\P{Is_Changes_When_NFKC_Casefolded= _F/a/}');
    Expect(1, 921600, '\p{Is_Changes_When_NFKC_Casefolded=f}', "");
    Expect(0, 921600, '\p{^Is_Changes_When_NFKC_Casefolded=f}', "");
    Expect(0, 921600, '\P{Is_Changes_When_NFKC_Casefolded=f}', "");
    Expect(1, 921600, '\P{^Is_Changes_When_NFKC_Casefolded=f}', "");
    Expect(0, 921599, '\p{Is_Changes_When_NFKC_Casefolded=f}', "");
    Expect(1, 921599, '\p{^Is_Changes_When_NFKC_Casefolded=f}', "");
    Expect(1, 921599, '\P{Is_Changes_When_NFKC_Casefolded=f}', "");
    Expect(0, 921599, '\P{^Is_Changes_When_NFKC_Casefolded=f}', "");
    Expect(1, 921600, '\p{Is_Changes_When_NFKC_Casefolded=	F}', "");
    Expect(0, 921600, '\p{^Is_Changes_When_NFKC_Casefolded=	F}', "");
    Expect(0, 921600, '\P{Is_Changes_When_NFKC_Casefolded=	F}', "");
    Expect(1, 921600, '\P{^Is_Changes_When_NFKC_Casefolded=	F}', "");
    Expect(0, 921599, '\p{Is_Changes_When_NFKC_Casefolded=	F}', "");
    Expect(1, 921599, '\p{^Is_Changes_When_NFKC_Casefolded=	F}', "");
    Expect(1, 921599, '\P{Is_Changes_When_NFKC_Casefolded=	F}', "");
    Expect(0, 921599, '\P{^Is_Changes_When_NFKC_Casefolded=	F}', "");
    Error('\p{Is_CWKCF=_:=false}');
    Error('\P{Is_CWKCF=_:=false}');
    Expect(1, 921600, '\p{Is_CWKCF:false}', "");
    Expect(0, 921600, '\p{^Is_CWKCF:false}', "");
    Expect(0, 921600, '\P{Is_CWKCF:false}', "");
    Expect(1, 921600, '\P{^Is_CWKCF:false}', "");
    Expect(0, 921599, '\p{Is_CWKCF:false}', "");
    Expect(1, 921599, '\p{^Is_CWKCF:false}', "");
    Expect(1, 921599, '\P{Is_CWKCF:false}', "");
    Expect(0, 921599, '\P{^Is_CWKCF:false}', "");
    Expect(1, 921600, '\p{Is_CWKCF=-False}', "");
    Expect(0, 921600, '\p{^Is_CWKCF=-False}', "");
    Expect(0, 921600, '\P{Is_CWKCF=-False}', "");
    Expect(1, 921600, '\P{^Is_CWKCF=-False}', "");
    Expect(0, 921599, '\p{Is_CWKCF=-False}', "");
    Expect(1, 921599, '\p{^Is_CWKCF=-False}', "");
    Expect(1, 921599, '\P{Is_CWKCF=-False}', "");
    Expect(0, 921599, '\P{^Is_CWKCF=-False}', "");
    Error('\p{Changes_When_NFKC_Casefolded=:=	-YES}');
    Error('\P{Changes_When_NFKC_Casefolded=:=	-YES}');
    Expect(1, 921599, '\p{Changes_When_NFKC_Casefolded=:\AYes\z:}', "");;
    Expect(0, 921600, '\p{Changes_When_NFKC_Casefolded=:\AYes\z:}', "");;
    Expect(1, 921599, '\p{Changes_When_NFKC_Casefolded:yes}', "");
    Expect(0, 921599, '\p{^Changes_When_NFKC_Casefolded:yes}', "");
    Expect(0, 921599, '\P{Changes_When_NFKC_Casefolded:yes}', "");
    Expect(1, 921599, '\P{^Changes_When_NFKC_Casefolded:yes}', "");
    Expect(0, 921600, '\p{Changes_When_NFKC_Casefolded:yes}', "");
    Expect(1, 921600, '\p{^Changes_When_NFKC_Casefolded:yes}', "");
    Expect(1, 921600, '\P{Changes_When_NFKC_Casefolded:yes}', "");
    Expect(0, 921600, '\P{^Changes_When_NFKC_Casefolded:yes}', "");
    Expect(1, 921599, '\p{Changes_When_NFKC_Casefolded=:\Ayes\z:}', "");;
    Expect(0, 921600, '\p{Changes_When_NFKC_Casefolded=:\Ayes\z:}', "");;
    Expect(1, 921599, '\p{Changes_When_NFKC_Casefolded=_YES}', "");
    Expect(0, 921599, '\p{^Changes_When_NFKC_Casefolded=_YES}', "");
    Expect(0, 921599, '\P{Changes_When_NFKC_Casefolded=_YES}', "");
    Expect(1, 921599, '\P{^Changes_When_NFKC_Casefolded=_YES}', "");
    Expect(0, 921600, '\p{Changes_When_NFKC_Casefolded=_YES}', "");
    Expect(1, 921600, '\p{^Changes_When_NFKC_Casefolded=_YES}', "");
    Expect(1, 921600, '\P{Changes_When_NFKC_Casefolded=_YES}', "");
    Expect(0, 921600, '\P{^Changes_When_NFKC_Casefolded=_YES}', "");
    Error('\p{CWKCF:		y/a/}');
    Error('\P{CWKCF:		y/a/}');
    Expect(1, 921599, '\p{CWKCF=:\AY\z:}', "");;
    Expect(0, 921600, '\p{CWKCF=:\AY\z:}', "");;
    Expect(1, 921599, '\p{CWKCF:   y}', "");
    Expect(0, 921599, '\p{^CWKCF:   y}', "");
    Expect(0, 921599, '\P{CWKCF:   y}', "");
    Expect(1, 921599, '\P{^CWKCF:   y}', "");
    Expect(0, 921600, '\p{CWKCF:   y}', "");
    Expect(1, 921600, '\p{^CWKCF:   y}', "");
    Expect(1, 921600, '\P{CWKCF:   y}', "");
    Expect(0, 921600, '\P{^CWKCF:   y}', "");
    Expect(1, 921599, '\p{CWKCF=:\Ay\z:}', "");;
    Expect(0, 921600, '\p{CWKCF=:\Ay\z:}', "");;
    Expect(1, 921599, '\p{CWKCF=-Y}', "");
    Expect(0, 921599, '\p{^CWKCF=-Y}', "");
    Expect(0, 921599, '\P{CWKCF=-Y}', "");
    Expect(1, 921599, '\P{^CWKCF=-Y}', "");
    Expect(0, 921600, '\p{CWKCF=-Y}', "");
    Expect(1, 921600, '\p{^CWKCF=-Y}', "");
    Expect(1, 921600, '\P{CWKCF=-Y}', "");
    Expect(0, 921600, '\P{^CWKCF=-Y}', "");
    Error('\p{Is_Changes_When_NFKC_Casefolded=_T/a/}');
    Error('\P{Is_Changes_When_NFKC_Casefolded=_T/a/}');
    Expect(1, 921599, '\p{Is_Changes_When_NFKC_Casefolded=t}', "");
    Expect(0, 921599, '\p{^Is_Changes_When_NFKC_Casefolded=t}', "");
    Expect(0, 921599, '\P{Is_Changes_When_NFKC_Casefolded=t}', "");
    Expect(1, 921599, '\P{^Is_Changes_When_NFKC_Casefolded=t}', "");
    Expect(0, 921600, '\p{Is_Changes_When_NFKC_Casefolded=t}', "");
    Expect(1, 921600, '\p{^Is_Changes_When_NFKC_Casefolded=t}', "");
    Expect(1, 921600, '\P{Is_Changes_When_NFKC_Casefolded=t}', "");
    Expect(0, 921600, '\P{^Is_Changes_When_NFKC_Casefolded=t}', "");
    Expect(1, 921599, '\p{Is_Changes_When_NFKC_Casefolded=_ T}', "");
    Expect(0, 921599, '\p{^Is_Changes_When_NFKC_Casefolded=_ T}', "");
    Expect(0, 921599, '\P{Is_Changes_When_NFKC_Casefolded=_ T}', "");
    Expect(1, 921599, '\P{^Is_Changes_When_NFKC_Casefolded=_ T}', "");
    Expect(0, 921600, '\p{Is_Changes_When_NFKC_Casefolded=_ T}', "");
    Expect(1, 921600, '\p{^Is_Changes_When_NFKC_Casefolded=_ T}', "");
    Expect(1, 921600, '\P{Is_Changes_When_NFKC_Casefolded=_ T}', "");
    Expect(0, 921600, '\P{^Is_Changes_When_NFKC_Casefolded=_ T}', "");
    Error('\p{Is_CWKCF=/a/true}');
    Error('\P{Is_CWKCF=/a/true}');
    Expect(1, 921599, '\p{Is_CWKCF=true}', "");
    Expect(0, 921599, '\p{^Is_CWKCF=true}', "");
    Expect(0, 921599, '\P{Is_CWKCF=true}', "");
    Expect(1, 921599, '\P{^Is_CWKCF=true}', "");
    Expect(0, 921600, '\p{Is_CWKCF=true}', "");
    Expect(1, 921600, '\p{^Is_CWKCF=true}', "");
    Expect(1, 921600, '\P{Is_CWKCF=true}', "");
    Expect(0, 921600, '\P{^Is_CWKCF=true}', "");
    Expect(1, 921599, '\p{Is_CWKCF=-True}', "");
    Expect(0, 921599, '\p{^Is_CWKCF=-True}', "");
    Expect(0, 921599, '\P{Is_CWKCF=-True}', "");
    Expect(1, 921599, '\P{^Is_CWKCF=-True}', "");
    Expect(0, 921600, '\p{Is_CWKCF=-True}', "");
    Expect(1, 921600, '\p{^Is_CWKCF=-True}', "");
    Expect(1, 921600, '\P{Is_CWKCF=-True}', "");
    Expect(0, 921600, '\P{^Is_CWKCF=-True}', "");
    Error('\p{Changes_When_Lowercased=_NO/a/}');
    Error('\P{Changes_When_Lowercased=_NO/a/}');
    Expect(1, 125218, '\p{Changes_When_Lowercased=:\ANo\z:}', "");;
    Expect(0, 125217, '\p{Changes_When_Lowercased=:\ANo\z:}', "");;
    Expect(1, 125218, '\p{Changes_When_Lowercased=no}', "");
    Expect(0, 125218, '\p{^Changes_When_Lowercased=no}', "");
    Expect(0, 125218, '\P{Changes_When_Lowercased=no}', "");
    Expect(1, 125218, '\P{^Changes_When_Lowercased=no}', "");
    Expect(0, 125217, '\p{Changes_When_Lowercased=no}', "");
    Expect(1, 125217, '\p{^Changes_When_Lowercased=no}', "");
    Expect(1, 125217, '\P{Changes_When_Lowercased=no}', "");
    Expect(0, 125217, '\P{^Changes_When_Lowercased=no}', "");
    Expect(1, 125218, '\p{Changes_When_Lowercased=:\Ano\z:}', "");;
    Expect(0, 125217, '\p{Changes_When_Lowercased=:\Ano\z:}', "");;
    Expect(1, 125218, '\p{Changes_When_Lowercased= No}', "");
    Expect(0, 125218, '\p{^Changes_When_Lowercased= No}', "");
    Expect(0, 125218, '\P{Changes_When_Lowercased= No}', "");
    Expect(1, 125218, '\P{^Changes_When_Lowercased= No}', "");
    Expect(0, 125217, '\p{Changes_When_Lowercased= No}', "");
    Expect(1, 125217, '\p{^Changes_When_Lowercased= No}', "");
    Expect(1, 125217, '\P{Changes_When_Lowercased= No}', "");
    Expect(0, 125217, '\P{^Changes_When_Lowercased= No}', "");
    Error('\p{CWL:	/a/ N}');
    Error('\P{CWL:	/a/ N}');
    Expect(1, 125218, '\p{CWL=:\AN\z:}', "");;
    Expect(0, 125217, '\p{CWL=:\AN\z:}', "");;
    Expect(1, 125218, '\p{CWL=n}', "");
    Expect(0, 125218, '\p{^CWL=n}', "");
    Expect(0, 125218, '\P{CWL=n}', "");
    Expect(1, 125218, '\P{^CWL=n}', "");
    Expect(0, 125217, '\p{CWL=n}', "");
    Expect(1, 125217, '\p{^CWL=n}', "");
    Expect(1, 125217, '\P{CWL=n}', "");
    Expect(0, 125217, '\P{^CWL=n}', "");
    Expect(1, 125218, '\p{CWL=:\An\z:}', "");;
    Expect(0, 125217, '\p{CWL=:\An\z:}', "");;
    Expect(1, 125218, '\p{CWL= _N}', "");
    Expect(0, 125218, '\p{^CWL= _N}', "");
    Expect(0, 125218, '\P{CWL= _N}', "");
    Expect(1, 125218, '\P{^CWL= _N}', "");
    Expect(0, 125217, '\p{CWL= _N}', "");
    Expect(1, 125217, '\p{^CWL= _N}', "");
    Expect(1, 125217, '\P{CWL= _N}', "");
    Expect(0, 125217, '\P{^CWL= _N}', "");
    Error('\p{Is_Changes_When_Lowercased=	:=F}');
    Error('\P{Is_Changes_When_Lowercased=	:=F}');
    Expect(1, 125218, '\p{Is_Changes_When_Lowercased=f}', "");
    Expect(0, 125218, '\p{^Is_Changes_When_Lowercased=f}', "");
    Expect(0, 125218, '\P{Is_Changes_When_Lowercased=f}', "");
    Expect(1, 125218, '\P{^Is_Changes_When_Lowercased=f}', "");
    Expect(0, 125217, '\p{Is_Changes_When_Lowercased=f}', "");
    Expect(1, 125217, '\p{^Is_Changes_When_Lowercased=f}', "");
    Expect(1, 125217, '\P{Is_Changes_When_Lowercased=f}', "");
    Expect(0, 125217, '\P{^Is_Changes_When_Lowercased=f}', "");
    Expect(1, 125218, '\p{Is_Changes_When_Lowercased=--F}', "");
    Expect(0, 125218, '\p{^Is_Changes_When_Lowercased=--F}', "");
    Expect(0, 125218, '\P{Is_Changes_When_Lowercased=--F}', "");
    Expect(1, 125218, '\P{^Is_Changes_When_Lowercased=--F}', "");
    Expect(0, 125217, '\p{Is_Changes_When_Lowercased=--F}', "");
    Expect(1, 125217, '\p{^Is_Changes_When_Lowercased=--F}', "");
    Expect(1, 125217, '\P{Is_Changes_When_Lowercased=--F}', "");
    Expect(0, 125217, '\P{^Is_Changes_When_Lowercased=--F}', "");
    Error('\p{Is_CWL=/a/False}');
    Error('\P{Is_CWL=/a/False}');
    Expect(1, 125218, '\p{Is_CWL=false}', "");
    Expect(0, 125218, '\p{^Is_CWL=false}', "");
    Expect(0, 125218, '\P{Is_CWL=false}', "");
    Expect(1, 125218, '\P{^Is_CWL=false}', "");
    Expect(0, 125217, '\p{Is_CWL=false}', "");
    Expect(1, 125217, '\p{^Is_CWL=false}', "");
    Expect(1, 125217, '\P{Is_CWL=false}', "");
    Expect(0, 125217, '\P{^Is_CWL=false}', "");
    Expect(1, 125218, '\p{Is_CWL=-	False}', "");
    Expect(0, 125218, '\p{^Is_CWL=-	False}', "");
    Expect(0, 125218, '\P{Is_CWL=-	False}', "");
    Expect(1, 125218, '\P{^Is_CWL=-	False}', "");
    Expect(0, 125217, '\p{Is_CWL=-	False}', "");
    Expect(1, 125217, '\p{^Is_CWL=-	False}', "");
    Expect(1, 125217, '\P{Is_CWL=-	False}', "");
    Expect(0, 125217, '\P{^Is_CWL=-	False}', "");
    Error('\p{Changes_When_Lowercased=_Yes:=}');
    Error('\P{Changes_When_Lowercased=_Yes:=}');
    Expect(1, 125217, '\p{Changes_When_Lowercased=:\AYes\z:}', "");;
    Expect(0, 125218, '\p{Changes_When_Lowercased=:\AYes\z:}', "");;
    Expect(1, 125217, '\p{Changes_When_Lowercased=yes}', "");
    Expect(0, 125217, '\p{^Changes_When_Lowercased=yes}', "");
    Expect(0, 125217, '\P{Changes_When_Lowercased=yes}', "");
    Expect(1, 125217, '\P{^Changes_When_Lowercased=yes}', "");
    Expect(0, 125218, '\p{Changes_When_Lowercased=yes}', "");
    Expect(1, 125218, '\p{^Changes_When_Lowercased=yes}', "");
    Expect(1, 125218, '\P{Changes_When_Lowercased=yes}', "");
    Expect(0, 125218, '\P{^Changes_When_Lowercased=yes}', "");
    Expect(1, 125217, '\p{Changes_When_Lowercased=:\Ayes\z:}', "");;
    Expect(0, 125218, '\p{Changes_When_Lowercased=:\Ayes\z:}', "");;
    Expect(1, 125217, '\p{Changes_When_Lowercased:	_ yes}', "");
    Expect(0, 125217, '\p{^Changes_When_Lowercased:	_ yes}', "");
    Expect(0, 125217, '\P{Changes_When_Lowercased:	_ yes}', "");
    Expect(1, 125217, '\P{^Changes_When_Lowercased:	_ yes}', "");
    Expect(0, 125218, '\p{Changes_When_Lowercased:	_ yes}', "");
    Expect(1, 125218, '\p{^Changes_When_Lowercased:	_ yes}', "");
    Expect(1, 125218, '\P{Changes_When_Lowercased:	_ yes}', "");
    Expect(0, 125218, '\P{^Changes_When_Lowercased:	_ yes}', "");
    Error('\p{CWL:   :=	_y}');
    Error('\P{CWL:   :=	_y}');
    Expect(1, 125217, '\p{CWL=:\AY\z:}', "");;
    Expect(0, 125218, '\p{CWL=:\AY\z:}', "");;
    Expect(1, 125217, '\p{CWL=y}', "");
    Expect(0, 125217, '\p{^CWL=y}', "");
    Expect(0, 125217, '\P{CWL=y}', "");
    Expect(1, 125217, '\P{^CWL=y}', "");
    Expect(0, 125218, '\p{CWL=y}', "");
    Expect(1, 125218, '\p{^CWL=y}', "");
    Expect(1, 125218, '\P{CWL=y}', "");
    Expect(0, 125218, '\P{^CWL=y}', "");
    Expect(1, 125217, '\p{CWL=:\Ay\z:}', "");;
    Expect(0, 125218, '\p{CWL=:\Ay\z:}', "");;
    Expect(1, 125217, '\p{CWL= Y}', "");
    Expect(0, 125217, '\p{^CWL= Y}', "");
    Expect(0, 125217, '\P{CWL= Y}', "");
    Expect(1, 125217, '\P{^CWL= Y}', "");
    Expect(0, 125218, '\p{CWL= Y}', "");
    Expect(1, 125218, '\p{^CWL= Y}', "");
    Expect(1, 125218, '\P{CWL= Y}', "");
    Expect(0, 125218, '\P{^CWL= Y}', "");
    Error('\p{Is_Changes_When_Lowercased=_	T:=}');
    Error('\P{Is_Changes_When_Lowercased=_	T:=}');
    Expect(1, 125217, '\p{Is_Changes_When_Lowercased=t}', "");
    Expect(0, 125217, '\p{^Is_Changes_When_Lowercased=t}', "");
    Expect(0, 125217, '\P{Is_Changes_When_Lowercased=t}', "");
    Expect(1, 125217, '\P{^Is_Changes_When_Lowercased=t}', "");
    Expect(0, 125218, '\p{Is_Changes_When_Lowercased=t}', "");
    Expect(1, 125218, '\p{^Is_Changes_When_Lowercased=t}', "");
    Expect(1, 125218, '\P{Is_Changes_When_Lowercased=t}', "");
    Expect(0, 125218, '\P{^Is_Changes_When_Lowercased=t}', "");
    Expect(1, 125217, '\p{Is_Changes_When_Lowercased:	 -T}', "");
    Expect(0, 125217, '\p{^Is_Changes_When_Lowercased:	 -T}', "");
    Expect(0, 125217, '\P{Is_Changes_When_Lowercased:	 -T}', "");
    Expect(1, 125217, '\P{^Is_Changes_When_Lowercased:	 -T}', "");
    Expect(0, 125218, '\p{Is_Changes_When_Lowercased:	 -T}', "");
    Expect(1, 125218, '\p{^Is_Changes_When_Lowercased:	 -T}', "");
    Expect(1, 125218, '\P{Is_Changes_When_Lowercased:	 -T}', "");
    Expect(0, 125218, '\P{^Is_Changes_When_Lowercased:	 -T}', "");
    Error('\p{Is_CWL=_ True/a/}');
    Error('\P{Is_CWL=_ True/a/}');
    Expect(1, 125217, '\p{Is_CWL:true}', "");
    Expect(0, 125217, '\p{^Is_CWL:true}', "");
    Expect(0, 125217, '\P{Is_CWL:true}', "");
    Expect(1, 125217, '\P{^Is_CWL:true}', "");
    Expect(0, 125218, '\p{Is_CWL:true}', "");
    Expect(1, 125218, '\p{^Is_CWL:true}', "");
    Expect(1, 125218, '\P{Is_CWL:true}', "");
    Expect(0, 125218, '\P{^Is_CWL:true}', "");
    Expect(1, 125217, '\p{Is_CWL=-True}', "");
    Expect(0, 125217, '\p{^Is_CWL=-True}', "");
    Expect(0, 125217, '\P{Is_CWL=-True}', "");
    Expect(1, 125217, '\P{^Is_CWL=-True}', "");
    Expect(0, 125218, '\p{Is_CWL=-True}', "");
    Expect(1, 125218, '\p{^Is_CWL=-True}', "");
    Expect(1, 125218, '\P{Is_CWL=-True}', "");
    Expect(0, 125218, '\P{^Is_CWL=-True}', "");
    Error('\p{Changes_When_Titlecased=-/a/no}');
    Error('\P{Changes_When_Titlecased=-/a/no}');
    Expect(1, 125252, '\p{Changes_When_Titlecased=:\ANo\z:}', "");;
    Expect(0, 125251, '\p{Changes_When_Titlecased=:\ANo\z:}', "");;
    Expect(1, 125252, '\p{Changes_When_Titlecased=no}', "");
    Expect(0, 125252, '\p{^Changes_When_Titlecased=no}', "");
    Expect(0, 125252, '\P{Changes_When_Titlecased=no}', "");
    Expect(1, 125252, '\P{^Changes_When_Titlecased=no}', "");
    Expect(0, 125251, '\p{Changes_When_Titlecased=no}', "");
    Expect(1, 125251, '\p{^Changes_When_Titlecased=no}', "");
    Expect(1, 125251, '\P{Changes_When_Titlecased=no}', "");
    Expect(0, 125251, '\P{^Changes_When_Titlecased=no}', "");
    Expect(1, 125252, '\p{Changes_When_Titlecased=:\Ano\z:}', "");;
    Expect(0, 125251, '\p{Changes_When_Titlecased=:\Ano\z:}', "");;
    Expect(1, 125252, '\p{Changes_When_Titlecased=	No}', "");
    Expect(0, 125252, '\p{^Changes_When_Titlecased=	No}', "");
    Expect(0, 125252, '\P{Changes_When_Titlecased=	No}', "");
    Expect(1, 125252, '\P{^Changes_When_Titlecased=	No}', "");
    Expect(0, 125251, '\p{Changes_When_Titlecased=	No}', "");
    Expect(1, 125251, '\p{^Changes_When_Titlecased=	No}', "");
    Expect(1, 125251, '\P{Changes_When_Titlecased=	No}', "");
    Expect(0, 125251, '\P{^Changes_When_Titlecased=	No}', "");
    Error('\p{CWT= 	N/a/}');
    Error('\P{CWT= 	N/a/}');
    Expect(1, 125252, '\p{CWT=:\AN\z:}', "");;
    Expect(0, 125251, '\p{CWT=:\AN\z:}', "");;
    Expect(1, 125252, '\p{CWT: n}', "");
    Expect(0, 125252, '\p{^CWT: n}', "");
    Expect(0, 125252, '\P{CWT: n}', "");
    Expect(1, 125252, '\P{^CWT: n}', "");
    Expect(0, 125251, '\p{CWT: n}', "");
    Expect(1, 125251, '\p{^CWT: n}', "");
    Expect(1, 125251, '\P{CWT: n}', "");
    Expect(0, 125251, '\P{^CWT: n}', "");
    Expect(1, 125252, '\p{CWT=:\An\z:}', "");;
    Expect(0, 125251, '\p{CWT=:\An\z:}', "");;
    Expect(1, 125252, '\p{CWT=- N}', "");
    Expect(0, 125252, '\p{^CWT=- N}', "");
    Expect(0, 125252, '\P{CWT=- N}', "");
    Expect(1, 125252, '\P{^CWT=- N}', "");
    Expect(0, 125251, '\p{CWT=- N}', "");
    Expect(1, 125251, '\p{^CWT=- N}', "");
    Expect(1, 125251, '\P{CWT=- N}', "");
    Expect(0, 125251, '\P{^CWT=- N}', "");
    Error('\p{Is_Changes_When_Titlecased=	_f/a/}');
    Error('\P{Is_Changes_When_Titlecased=	_f/a/}');
    Expect(1, 125252, '\p{Is_Changes_When_Titlecased=f}', "");
    Expect(0, 125252, '\p{^Is_Changes_When_Titlecased=f}', "");
    Expect(0, 125252, '\P{Is_Changes_When_Titlecased=f}', "");
    Expect(1, 125252, '\P{^Is_Changes_When_Titlecased=f}', "");
    Expect(0, 125251, '\p{Is_Changes_When_Titlecased=f}', "");
    Expect(1, 125251, '\p{^Is_Changes_When_Titlecased=f}', "");
    Expect(1, 125251, '\P{Is_Changes_When_Titlecased=f}', "");
    Expect(0, 125251, '\P{^Is_Changes_When_Titlecased=f}', "");
    Expect(1, 125252, '\p{Is_Changes_When_Titlecased=__F}', "");
    Expect(0, 125252, '\p{^Is_Changes_When_Titlecased=__F}', "");
    Expect(0, 125252, '\P{Is_Changes_When_Titlecased=__F}', "");
    Expect(1, 125252, '\P{^Is_Changes_When_Titlecased=__F}', "");
    Expect(0, 125251, '\p{Is_Changes_When_Titlecased=__F}', "");
    Expect(1, 125251, '\p{^Is_Changes_When_Titlecased=__F}', "");
    Expect(1, 125251, '\P{Is_Changes_When_Titlecased=__F}', "");
    Expect(0, 125251, '\P{^Is_Changes_When_Titlecased=__F}', "");
    Error('\p{Is_CWT:   	/a/FALSE}');
    Error('\P{Is_CWT:   	/a/FALSE}');
    Expect(1, 125252, '\p{Is_CWT=false}', "");
    Expect(0, 125252, '\p{^Is_CWT=false}', "");
    Expect(0, 125252, '\P{Is_CWT=false}', "");
    Expect(1, 125252, '\P{^Is_CWT=false}', "");
    Expect(0, 125251, '\p{Is_CWT=false}', "");
    Expect(1, 125251, '\p{^Is_CWT=false}', "");
    Expect(1, 125251, '\P{Is_CWT=false}', "");
    Expect(0, 125251, '\P{^Is_CWT=false}', "");
    Expect(1, 125252, '\p{Is_CWT:    False}', "");
    Expect(0, 125252, '\p{^Is_CWT:    False}', "");
    Expect(0, 125252, '\P{Is_CWT:    False}', "");
    Expect(1, 125252, '\P{^Is_CWT:    False}', "");
    Expect(0, 125251, '\p{Is_CWT:    False}', "");
    Expect(1, 125251, '\p{^Is_CWT:    False}', "");
    Expect(1, 125251, '\P{Is_CWT:    False}', "");
    Expect(0, 125251, '\P{^Is_CWT:    False}', "");
    Error('\p{Changes_When_Titlecased=:=YES}');
    Error('\P{Changes_When_Titlecased=:=YES}');
    Expect(1, 125251, '\p{Changes_When_Titlecased=:\AYes\z:}', "");;
    Expect(0, 125252, '\p{Changes_When_Titlecased=:\AYes\z:}', "");;
    Expect(1, 125251, '\p{Changes_When_Titlecased=yes}', "");
    Expect(0, 125251, '\p{^Changes_When_Titlecased=yes}', "");
    Expect(0, 125251, '\P{Changes_When_Titlecased=yes}', "");
    Expect(1, 125251, '\P{^Changes_When_Titlecased=yes}', "");
    Expect(0, 125252, '\p{Changes_When_Titlecased=yes}', "");
    Expect(1, 125252, '\p{^Changes_When_Titlecased=yes}', "");
    Expect(1, 125252, '\P{Changes_When_Titlecased=yes}', "");
    Expect(0, 125252, '\P{^Changes_When_Titlecased=yes}', "");
    Expect(1, 125251, '\p{Changes_When_Titlecased=:\Ayes\z:}', "");;
    Expect(0, 125252, '\p{Changes_When_Titlecased=:\Ayes\z:}', "");;
    Expect(1, 125251, '\p{Changes_When_Titlecased:   -Yes}', "");
    Expect(0, 125251, '\p{^Changes_When_Titlecased:   -Yes}', "");
    Expect(0, 125251, '\P{Changes_When_Titlecased:   -Yes}', "");
    Expect(1, 125251, '\P{^Changes_When_Titlecased:   -Yes}', "");
    Expect(0, 125252, '\p{Changes_When_Titlecased:   -Yes}', "");
    Expect(1, 125252, '\p{^Changes_When_Titlecased:   -Yes}', "");
    Expect(1, 125252, '\P{Changes_When_Titlecased:   -Yes}', "");
    Expect(0, 125252, '\P{^Changes_When_Titlecased:   -Yes}', "");
    Error('\p{CWT=	-y/a/}');
    Error('\P{CWT=	-y/a/}');
    Expect(1, 125251, '\p{CWT=:\AY\z:}', "");;
    Expect(0, 125252, '\p{CWT=:\AY\z:}', "");;
    Expect(1, 125251, '\p{CWT=y}', "");
    Expect(0, 125251, '\p{^CWT=y}', "");
    Expect(0, 125251, '\P{CWT=y}', "");
    Expect(1, 125251, '\P{^CWT=y}', "");
    Expect(0, 125252, '\p{CWT=y}', "");
    Expect(1, 125252, '\p{^CWT=y}', "");
    Expect(1, 125252, '\P{CWT=y}', "");
    Expect(0, 125252, '\P{^CWT=y}', "");
    Expect(1, 125251, '\p{CWT=:\Ay\z:}', "");;
    Expect(0, 125252, '\p{CWT=:\Ay\z:}', "");;
    Expect(1, 125251, '\p{CWT=	y}', "");
    Expect(0, 125251, '\p{^CWT=	y}', "");
    Expect(0, 125251, '\P{CWT=	y}', "");
    Expect(1, 125251, '\P{^CWT=	y}', "");
    Expect(0, 125252, '\p{CWT=	y}', "");
    Expect(1, 125252, '\p{^CWT=	y}', "");
    Expect(1, 125252, '\P{CWT=	y}', "");
    Expect(0, 125252, '\P{^CWT=	y}', "");
    Error('\p{Is_Changes_When_Titlecased: 	:=T}');
    Error('\P{Is_Changes_When_Titlecased: 	:=T}');
    Expect(1, 125251, '\p{Is_Changes_When_Titlecased=t}', "");
    Expect(0, 125251, '\p{^Is_Changes_When_Titlecased=t}', "");
    Expect(0, 125251, '\P{Is_Changes_When_Titlecased=t}', "");
    Expect(1, 125251, '\P{^Is_Changes_When_Titlecased=t}', "");
    Expect(0, 125252, '\p{Is_Changes_When_Titlecased=t}', "");
    Expect(1, 125252, '\p{^Is_Changes_When_Titlecased=t}', "");
    Expect(1, 125252, '\P{Is_Changes_When_Titlecased=t}', "");
    Expect(0, 125252, '\P{^Is_Changes_When_Titlecased=t}', "");
    Expect(1, 125251, '\p{Is_Changes_When_Titlecased=- T}', "");
    Expect(0, 125251, '\p{^Is_Changes_When_Titlecased=- T}', "");
    Expect(0, 125251, '\P{Is_Changes_When_Titlecased=- T}', "");
    Expect(1, 125251, '\P{^Is_Changes_When_Titlecased=- T}', "");
    Expect(0, 125252, '\p{Is_Changes_When_Titlecased=- T}', "");
    Expect(1, 125252, '\p{^Is_Changes_When_Titlecased=- T}', "");
    Expect(1, 125252, '\P{Is_Changes_When_Titlecased=- T}', "");
    Expect(0, 125252, '\P{^Is_Changes_When_Titlecased=- T}', "");
    Error('\p{Is_CWT=_ true:=}');
    Error('\P{Is_CWT=_ true:=}');
    Expect(1, 125251, '\p{Is_CWT=true}', "");
    Expect(0, 125251, '\p{^Is_CWT=true}', "");
    Expect(0, 125251, '\P{Is_CWT=true}', "");
    Expect(1, 125251, '\P{^Is_CWT=true}', "");
    Expect(0, 125252, '\p{Is_CWT=true}', "");
    Expect(1, 125252, '\p{^Is_CWT=true}', "");
    Expect(1, 125252, '\P{Is_CWT=true}', "");
    Expect(0, 125252, '\P{^Is_CWT=true}', "");
    Expect(1, 125251, '\p{Is_CWT: 	true}', "");
    Expect(0, 125251, '\p{^Is_CWT: 	true}', "");
    Expect(0, 125251, '\P{Is_CWT: 	true}', "");
    Expect(1, 125251, '\P{^Is_CWT: 	true}', "");
    Expect(0, 125252, '\p{Is_CWT: 	true}', "");
    Expect(1, 125252, '\p{^Is_CWT: 	true}', "");
    Expect(1, 125252, '\P{Is_CWT: 	true}', "");
    Expect(0, 125252, '\P{^Is_CWT: 	true}', "");
    Error('\p{Changes_When_Uppercased=--No/a/}');
    Error('\P{Changes_When_Uppercased=--No/a/}');
    Expect(1, 125252, '\p{Changes_When_Uppercased=:\ANo\z:}', "");;
    Expect(0, 125251, '\p{Changes_When_Uppercased=:\ANo\z:}', "");;
    Expect(1, 125252, '\p{Changes_When_Uppercased=no}', "");
    Expect(0, 125252, '\p{^Changes_When_Uppercased=no}', "");
    Expect(0, 125252, '\P{Changes_When_Uppercased=no}', "");
    Expect(1, 125252, '\P{^Changes_When_Uppercased=no}', "");
    Expect(0, 125251, '\p{Changes_When_Uppercased=no}', "");
    Expect(1, 125251, '\p{^Changes_When_Uppercased=no}', "");
    Expect(1, 125251, '\P{Changes_When_Uppercased=no}', "");
    Expect(0, 125251, '\P{^Changes_When_Uppercased=no}', "");
    Expect(1, 125252, '\p{Changes_When_Uppercased=:\Ano\z:}', "");;
    Expect(0, 125251, '\p{Changes_When_Uppercased=:\Ano\z:}', "");;
    Expect(1, 125252, '\p{Changes_When_Uppercased=_no}', "");
    Expect(0, 125252, '\p{^Changes_When_Uppercased=_no}', "");
    Expect(0, 125252, '\P{Changes_When_Uppercased=_no}', "");
    Expect(1, 125252, '\P{^Changes_When_Uppercased=_no}', "");
    Expect(0, 125251, '\p{Changes_When_Uppercased=_no}', "");
    Expect(1, 125251, '\p{^Changes_When_Uppercased=_no}', "");
    Expect(1, 125251, '\P{Changes_When_Uppercased=_no}', "");
    Expect(0, 125251, '\P{^Changes_When_Uppercased=_no}', "");
    Error('\p{CWU=_N:=}');
    Error('\P{CWU=_N:=}');
    Expect(1, 125252, '\p{CWU=:\AN\z:}', "");;
    Expect(0, 125251, '\p{CWU=:\AN\z:}', "");;
    Expect(1, 125252, '\p{CWU=n}', "");
    Expect(0, 125252, '\p{^CWU=n}', "");
    Expect(0, 125252, '\P{CWU=n}', "");
    Expect(1, 125252, '\P{^CWU=n}', "");
    Expect(0, 125251, '\p{CWU=n}', "");
    Expect(1, 125251, '\p{^CWU=n}', "");
    Expect(1, 125251, '\P{CWU=n}', "");
    Expect(0, 125251, '\P{^CWU=n}', "");
    Expect(1, 125252, '\p{CWU=:\An\z:}', "");;
    Expect(0, 125251, '\p{CWU=:\An\z:}', "");;
    Expect(1, 125252, '\p{CWU=--N}', "");
    Expect(0, 125252, '\p{^CWU=--N}', "");
    Expect(0, 125252, '\P{CWU=--N}', "");
    Expect(1, 125252, '\P{^CWU=--N}', "");
    Expect(0, 125251, '\p{CWU=--N}', "");
    Expect(1, 125251, '\p{^CWU=--N}', "");
    Expect(1, 125251, '\P{CWU=--N}', "");
    Expect(0, 125251, '\P{^CWU=--N}', "");
    Error('\p{Is_Changes_When_Uppercased=-_F/a/}');
    Error('\P{Is_Changes_When_Uppercased=-_F/a/}');
    Expect(1, 125252, '\p{Is_Changes_When_Uppercased=f}', "");
    Expect(0, 125252, '\p{^Is_Changes_When_Uppercased=f}', "");
    Expect(0, 125252, '\P{Is_Changes_When_Uppercased=f}', "");
    Expect(1, 125252, '\P{^Is_Changes_When_Uppercased=f}', "");
    Expect(0, 125251, '\p{Is_Changes_When_Uppercased=f}', "");
    Expect(1, 125251, '\p{^Is_Changes_When_Uppercased=f}', "");
    Expect(1, 125251, '\P{Is_Changes_When_Uppercased=f}', "");
    Expect(0, 125251, '\P{^Is_Changes_When_Uppercased=f}', "");
    Expect(1, 125252, '\p{Is_Changes_When_Uppercased=	_F}', "");
    Expect(0, 125252, '\p{^Is_Changes_When_Uppercased=	_F}', "");
    Expect(0, 125252, '\P{Is_Changes_When_Uppercased=	_F}', "");
    Expect(1, 125252, '\P{^Is_Changes_When_Uppercased=	_F}', "");
    Expect(0, 125251, '\p{Is_Changes_When_Uppercased=	_F}', "");
    Expect(1, 125251, '\p{^Is_Changes_When_Uppercased=	_F}', "");
    Expect(1, 125251, '\P{Is_Changes_When_Uppercased=	_F}', "");
    Expect(0, 125251, '\P{^Is_Changes_When_Uppercased=	_F}', "");
    Error('\p{Is_CWU=_ False:=}');
    Error('\P{Is_CWU=_ False:=}');
    Expect(1, 125252, '\p{Is_CWU=false}', "");
    Expect(0, 125252, '\p{^Is_CWU=false}', "");
    Expect(0, 125252, '\P{Is_CWU=false}', "");
    Expect(1, 125252, '\P{^Is_CWU=false}', "");
    Expect(0, 125251, '\p{Is_CWU=false}', "");
    Expect(1, 125251, '\p{^Is_CWU=false}', "");
    Expect(1, 125251, '\P{Is_CWU=false}', "");
    Expect(0, 125251, '\P{^Is_CWU=false}', "");
    Expect(1, 125252, '\p{Is_CWU=-	False}', "");
    Expect(0, 125252, '\p{^Is_CWU=-	False}', "");
    Expect(0, 125252, '\P{Is_CWU=-	False}', "");
    Expect(1, 125252, '\P{^Is_CWU=-	False}', "");
    Expect(0, 125251, '\p{Is_CWU=-	False}', "");
    Expect(1, 125251, '\p{^Is_CWU=-	False}', "");
    Expect(1, 125251, '\P{Is_CWU=-	False}', "");
    Expect(0, 125251, '\P{^Is_CWU=-	False}', "");
    Error('\p{Changes_When_Uppercased=YES/a/}');
    Error('\P{Changes_When_Uppercased=YES/a/}');
    Expect(1, 125251, '\p{Changes_When_Uppercased=:\AYes\z:}', "");;
    Expect(0, 125252, '\p{Changes_When_Uppercased=:\AYes\z:}', "");;
    Expect(1, 125251, '\p{Changes_When_Uppercased=yes}', "");
    Expect(0, 125251, '\p{^Changes_When_Uppercased=yes}', "");
    Expect(0, 125251, '\P{Changes_When_Uppercased=yes}', "");
    Expect(1, 125251, '\P{^Changes_When_Uppercased=yes}', "");
    Expect(0, 125252, '\p{Changes_When_Uppercased=yes}', "");
    Expect(1, 125252, '\p{^Changes_When_Uppercased=yes}', "");
    Expect(1, 125252, '\P{Changes_When_Uppercased=yes}', "");
    Expect(0, 125252, '\P{^Changes_When_Uppercased=yes}', "");
    Expect(1, 125251, '\p{Changes_When_Uppercased=:\Ayes\z:}', "");;
    Expect(0, 125252, '\p{Changes_When_Uppercased=:\Ayes\z:}', "");;
    Expect(1, 125251, '\p{Changes_When_Uppercased=  Yes}', "");
    Expect(0, 125251, '\p{^Changes_When_Uppercased=  Yes}', "");
    Expect(0, 125251, '\P{Changes_When_Uppercased=  Yes}', "");
    Expect(1, 125251, '\P{^Changes_When_Uppercased=  Yes}', "");
    Expect(0, 125252, '\p{Changes_When_Uppercased=  Yes}', "");
    Expect(1, 125252, '\p{^Changes_When_Uppercased=  Yes}', "");
    Expect(1, 125252, '\P{Changes_When_Uppercased=  Yes}', "");
    Expect(0, 125252, '\P{^Changes_When_Uppercased=  Yes}', "");
    Error('\p{CWU=/a/_Y}');
    Error('\P{CWU=/a/_Y}');
    Expect(1, 125251, '\p{CWU=:\AY\z:}', "");;
    Expect(0, 125252, '\p{CWU=:\AY\z:}', "");;
    Expect(1, 125251, '\p{CWU: y}', "");
    Expect(0, 125251, '\p{^CWU: y}', "");
    Expect(0, 125251, '\P{CWU: y}', "");
    Expect(1, 125251, '\P{^CWU: y}', "");
    Expect(0, 125252, '\p{CWU: y}', "");
    Expect(1, 125252, '\p{^CWU: y}', "");
    Expect(1, 125252, '\P{CWU: y}', "");
    Expect(0, 125252, '\P{^CWU: y}', "");
    Expect(1, 125251, '\p{CWU=:\Ay\z:}', "");;
    Expect(0, 125252, '\p{CWU=:\Ay\z:}', "");;
    Expect(1, 125251, '\p{CWU= _y}', "");
    Expect(0, 125251, '\p{^CWU= _y}', "");
    Expect(0, 125251, '\P{CWU= _y}', "");
    Expect(1, 125251, '\P{^CWU= _y}', "");
    Expect(0, 125252, '\p{CWU= _y}', "");
    Expect(1, 125252, '\p{^CWU= _y}', "");
    Expect(1, 125252, '\P{CWU= _y}', "");
    Expect(0, 125252, '\P{^CWU= _y}', "");
    Error('\p{Is_Changes_When_Uppercased=/a/ _T}');
    Error('\P{Is_Changes_When_Uppercased=/a/ _T}');
    Expect(1, 125251, '\p{Is_Changes_When_Uppercased=t}', "");
    Expect(0, 125251, '\p{^Is_Changes_When_Uppercased=t}', "");
    Expect(0, 125251, '\P{Is_Changes_When_Uppercased=t}', "");
    Expect(1, 125251, '\P{^Is_Changes_When_Uppercased=t}', "");
    Expect(0, 125252, '\p{Is_Changes_When_Uppercased=t}', "");
    Expect(1, 125252, '\p{^Is_Changes_When_Uppercased=t}', "");
    Expect(1, 125252, '\P{Is_Changes_When_Uppercased=t}', "");
    Expect(0, 125252, '\P{^Is_Changes_When_Uppercased=t}', "");
    Expect(1, 125251, '\p{Is_Changes_When_Uppercased= T}', "");
    Expect(0, 125251, '\p{^Is_Changes_When_Uppercased= T}', "");
    Expect(0, 125251, '\P{Is_Changes_When_Uppercased= T}', "");
    Expect(1, 125251, '\P{^Is_Changes_When_Uppercased= T}', "");
    Expect(0, 125252, '\p{Is_Changes_When_Uppercased= T}', "");
    Expect(1, 125252, '\p{^Is_Changes_When_Uppercased= T}', "");
    Expect(1, 125252, '\P{Is_Changes_When_Uppercased= T}', "");
    Expect(0, 125252, '\P{^Is_Changes_When_Uppercased= T}', "");
    Error('\p{Is_CWU:   /a/true}');
    Error('\P{Is_CWU:   /a/true}');
    Expect(1, 125251, '\p{Is_CWU=true}', "");
    Expect(0, 125251, '\p{^Is_CWU=true}', "");
    Expect(0, 125251, '\P{Is_CWU=true}', "");
    Expect(1, 125251, '\P{^Is_CWU=true}', "");
    Expect(0, 125252, '\p{Is_CWU=true}', "");
    Expect(1, 125252, '\p{^Is_CWU=true}', "");
    Expect(1, 125252, '\P{Is_CWU=true}', "");
    Expect(0, 125252, '\P{^Is_CWU=true}', "");
    Expect(1, 125251, '\p{Is_CWU= _true}', "");
    Expect(0, 125251, '\p{^Is_CWU= _true}', "");
    Expect(0, 125251, '\P{Is_CWU= _true}', "");
    Expect(1, 125251, '\P{^Is_CWU= _true}', "");
    Expect(0, 125252, '\p{Is_CWU= _true}', "");
    Expect(1, 125252, '\p{^Is_CWU= _true}', "");
    Expect(1, 125252, '\P{Is_CWU= _true}', "");
    Expect(0, 125252, '\P{^Is_CWU= _true}', "");
    Error('\p{Dash=_no:=}');
    Error('\P{Dash=_no:=}');
    Expect(1, 69294, '\p{Dash=:\ANo\z:}', "");;
    Expect(0, 69293, '\p{Dash=:\ANo\z:}', "");;
    Expect(1, 69294, '\p{Dash=no}', "");
    Expect(0, 69294, '\p{^Dash=no}', "");
    Expect(0, 69294, '\P{Dash=no}', "");
    Expect(1, 69294, '\P{^Dash=no}', "");
    Expect(0, 69293, '\p{Dash=no}', "");
    Expect(1, 69293, '\p{^Dash=no}', "");
    Expect(1, 69293, '\P{Dash=no}', "");
    Expect(0, 69293, '\P{^Dash=no}', "");
    Expect(1, 69294, '\p{Dash=:\Ano\z:}', "");;
    Expect(0, 69293, '\p{Dash=:\Ano\z:}', "");;
    Expect(1, 69294, '\p{Dash= No}', "");
    Expect(0, 69294, '\p{^Dash= No}', "");
    Expect(0, 69294, '\P{Dash= No}', "");
    Expect(1, 69294, '\P{^Dash= No}', "");
    Expect(0, 69293, '\p{Dash= No}', "");
    Expect(1, 69293, '\p{^Dash= No}', "");
    Expect(1, 69293, '\P{Dash= No}', "");
    Expect(0, 69293, '\P{^Dash= No}', "");
    Error('\p{Is_Dash=:=-_n}');
    Error('\P{Is_Dash=:=-_n}');
    Expect(1, 69294, '\p{Is_Dash=n}', "");
    Expect(0, 69294, '\p{^Is_Dash=n}', "");
    Expect(0, 69294, '\P{Is_Dash=n}', "");
    Expect(1, 69294, '\P{^Is_Dash=n}', "");
    Expect(0, 69293, '\p{Is_Dash=n}', "");
    Expect(1, 69293, '\p{^Is_Dash=n}', "");
    Expect(1, 69293, '\P{Is_Dash=n}', "");
    Expect(0, 69293, '\P{^Is_Dash=n}', "");
    Expect(1, 69294, '\p{Is_Dash= 	N}', "");
    Expect(0, 69294, '\p{^Is_Dash= 	N}', "");
    Expect(0, 69294, '\P{Is_Dash= 	N}', "");
    Expect(1, 69294, '\P{^Is_Dash= 	N}', "");
    Expect(0, 69293, '\p{Is_Dash= 	N}', "");
    Expect(1, 69293, '\p{^Is_Dash= 	N}', "");
    Expect(1, 69293, '\P{Is_Dash= 	N}', "");
    Expect(0, 69293, '\P{^Is_Dash= 	N}', "");
    Error('\p{Dash=-_F:=}');
    Error('\P{Dash=-_F:=}');
    Expect(1, 69294, '\p{Dash=:\AF\z:}', "");;
    Expect(0, 69293, '\p{Dash=:\AF\z:}', "");;
    Expect(1, 69294, '\p{Dash=f}', "");
    Expect(0, 69294, '\p{^Dash=f}', "");
    Expect(0, 69294, '\P{Dash=f}', "");
    Expect(1, 69294, '\P{^Dash=f}', "");
    Expect(0, 69293, '\p{Dash=f}', "");
    Expect(1, 69293, '\p{^Dash=f}', "");
    Expect(1, 69293, '\P{Dash=f}', "");
    Expect(0, 69293, '\P{^Dash=f}', "");
    Expect(1, 69294, '\p{Dash=:\Af\z:}', "");;
    Expect(0, 69293, '\p{Dash=:\Af\z:}', "");;
    Expect(1, 69294, '\p{Dash=_	F}', "");
    Expect(0, 69294, '\p{^Dash=_	F}', "");
    Expect(0, 69294, '\P{Dash=_	F}', "");
    Expect(1, 69294, '\P{^Dash=_	F}', "");
    Expect(0, 69293, '\p{Dash=_	F}', "");
    Expect(1, 69293, '\p{^Dash=_	F}', "");
    Expect(1, 69293, '\P{Dash=_	F}', "");
    Expect(0, 69293, '\P{^Dash=_	F}', "");
    Error('\p{Is_Dash=	/a/False}');
    Error('\P{Is_Dash=	/a/False}');
    Expect(1, 69294, '\p{Is_Dash=false}', "");
    Expect(0, 69294, '\p{^Is_Dash=false}', "");
    Expect(0, 69294, '\P{Is_Dash=false}', "");
    Expect(1, 69294, '\P{^Is_Dash=false}', "");
    Expect(0, 69293, '\p{Is_Dash=false}', "");
    Expect(1, 69293, '\p{^Is_Dash=false}', "");
    Expect(1, 69293, '\P{Is_Dash=false}', "");
    Expect(0, 69293, '\P{^Is_Dash=false}', "");
    Expect(1, 69294, '\p{Is_Dash: 	 False}', "");
    Expect(0, 69294, '\p{^Is_Dash: 	 False}', "");
    Expect(0, 69294, '\P{Is_Dash: 	 False}', "");
    Expect(1, 69294, '\P{^Is_Dash: 	 False}', "");
    Expect(0, 69293, '\p{Is_Dash: 	 False}', "");
    Expect(1, 69293, '\p{^Is_Dash: 	 False}', "");
    Expect(1, 69293, '\P{Is_Dash: 	 False}', "");
    Expect(0, 69293, '\P{^Is_Dash: 	 False}', "");
    Error('\p{Dash=:=-_yes}');
    Error('\P{Dash=:=-_yes}');
    Expect(1, 69293, '\p{Dash=:\AYes\z:}', "");;
    Expect(0, 69294, '\p{Dash=:\AYes\z:}', "");;
    Expect(1, 69293, '\p{Dash:	yes}', "");
    Expect(0, 69293, '\p{^Dash:	yes}', "");
    Expect(0, 69293, '\P{Dash:	yes}', "");
    Expect(1, 69293, '\P{^Dash:	yes}', "");
    Expect(0, 69294, '\p{Dash:	yes}', "");
    Expect(1, 69294, '\p{^Dash:	yes}', "");
    Expect(1, 69294, '\P{Dash:	yes}', "");
    Expect(0, 69294, '\P{^Dash:	yes}', "");
    Expect(1, 69293, '\p{Dash=:\Ayes\z:}', "");;
    Expect(0, 69294, '\p{Dash=:\Ayes\z:}', "");;
    Expect(1, 69293, '\p{Dash= 	yes}', "");
    Expect(0, 69293, '\p{^Dash= 	yes}', "");
    Expect(0, 69293, '\P{Dash= 	yes}', "");
    Expect(1, 69293, '\P{^Dash= 	yes}', "");
    Expect(0, 69294, '\p{Dash= 	yes}', "");
    Expect(1, 69294, '\p{^Dash= 	yes}', "");
    Expect(1, 69294, '\P{Dash= 	yes}', "");
    Expect(0, 69294, '\P{^Dash= 	yes}', "");
    Error('\p{Is_Dash:	 Y/a/}');
    Error('\P{Is_Dash:	 Y/a/}');
    Expect(1, 69293, '\p{Is_Dash=y}', "");
    Expect(0, 69293, '\p{^Is_Dash=y}', "");
    Expect(0, 69293, '\P{Is_Dash=y}', "");
    Expect(1, 69293, '\P{^Is_Dash=y}', "");
    Expect(0, 69294, '\p{Is_Dash=y}', "");
    Expect(1, 69294, '\p{^Is_Dash=y}', "");
    Expect(1, 69294, '\P{Is_Dash=y}', "");
    Expect(0, 69294, '\P{^Is_Dash=y}', "");
    Expect(1, 69293, '\p{Is_Dash=_Y}', "");
    Expect(0, 69293, '\p{^Is_Dash=_Y}', "");
    Expect(0, 69293, '\P{Is_Dash=_Y}', "");
    Expect(1, 69293, '\P{^Is_Dash=_Y}', "");
    Expect(0, 69294, '\p{Is_Dash=_Y}', "");
    Expect(1, 69294, '\p{^Is_Dash=_Y}', "");
    Expect(1, 69294, '\P{Is_Dash=_Y}', "");
    Expect(0, 69294, '\P{^Is_Dash=_Y}', "");
    Error('\p{Dash=/a/T}');
    Error('\P{Dash=/a/T}');
    Expect(1, 69293, '\p{Dash=:\AT\z:}', "");;
    Expect(0, 69294, '\p{Dash=:\AT\z:}', "");;
    Expect(1, 69293, '\p{Dash=t}', "");
    Expect(0, 69293, '\p{^Dash=t}', "");
    Expect(0, 69293, '\P{Dash=t}', "");
    Expect(1, 69293, '\P{^Dash=t}', "");
    Expect(0, 69294, '\p{Dash=t}', "");
    Expect(1, 69294, '\p{^Dash=t}', "");
    Expect(1, 69294, '\P{Dash=t}', "");
    Expect(0, 69294, '\P{^Dash=t}', "");
    Expect(1, 69293, '\p{Dash=:\At\z:}', "");;
    Expect(0, 69294, '\p{Dash=:\At\z:}', "");;
    Expect(1, 69293, '\p{Dash=	 t}', "");
    Expect(0, 69293, '\p{^Dash=	 t}', "");
    Expect(0, 69293, '\P{Dash=	 t}', "");
    Expect(1, 69293, '\P{^Dash=	 t}', "");
    Expect(0, 69294, '\p{Dash=	 t}', "");
    Expect(1, 69294, '\p{^Dash=	 t}', "");
    Expect(1, 69294, '\P{Dash=	 t}', "");
    Expect(0, 69294, '\P{^Dash=	 t}', "");
    Error('\p{Is_Dash=_/a/True}');
    Error('\P{Is_Dash=_/a/True}');
    Expect(1, 69293, '\p{Is_Dash:   true}', "");
    Expect(0, 69293, '\p{^Is_Dash:   true}', "");
    Expect(0, 69293, '\P{Is_Dash:   true}', "");
    Expect(1, 69293, '\P{^Is_Dash:   true}', "");
    Expect(0, 69294, '\p{Is_Dash:   true}', "");
    Expect(1, 69294, '\p{^Is_Dash:   true}', "");
    Expect(1, 69294, '\P{Is_Dash:   true}', "");
    Expect(0, 69294, '\P{^Is_Dash:   true}', "");
    Expect(1, 69293, '\p{Is_Dash=-_TRUE}', "");
    Expect(0, 69293, '\p{^Is_Dash=-_TRUE}', "");
    Expect(0, 69293, '\P{Is_Dash=-_TRUE}', "");
    Expect(1, 69293, '\P{^Is_Dash=-_TRUE}', "");
    Expect(0, 69294, '\p{Is_Dash=-_TRUE}', "");
    Expect(1, 69294, '\p{^Is_Dash=-_TRUE}', "");
    Expect(1, 69294, '\P{Is_Dash=-_TRUE}', "");
    Expect(0, 69294, '\P{^Is_Dash=-_TRUE}', "");
    Error('\p{Deprecated=/a/__NO}');
    Error('\P{Deprecated=/a/__NO}');
    Expect(1, 917506, '\p{Deprecated=:\ANo\z:}', "");;
    Expect(0, 917505, '\p{Deprecated=:\ANo\z:}', "");;
    Expect(1, 917506, '\p{Deprecated:	no}', "");
    Expect(0, 917506, '\p{^Deprecated:	no}', "");
    Expect(0, 917506, '\P{Deprecated:	no}', "");
    Expect(1, 917506, '\P{^Deprecated:	no}', "");
    Expect(0, 917505, '\p{Deprecated:	no}', "");
    Expect(1, 917505, '\p{^Deprecated:	no}', "");
    Expect(1, 917505, '\P{Deprecated:	no}', "");
    Expect(0, 917505, '\P{^Deprecated:	no}', "");
    Expect(1, 917506, '\p{Deprecated=:\Ano\z:}', "");;
    Expect(0, 917505, '\p{Deprecated=:\Ano\z:}', "");;
    Expect(1, 917506, '\p{Deprecated=  no}', "");
    Expect(0, 917506, '\p{^Deprecated=  no}', "");
    Expect(0, 917506, '\P{Deprecated=  no}', "");
    Expect(1, 917506, '\P{^Deprecated=  no}', "");
    Expect(0, 917505, '\p{Deprecated=  no}', "");
    Expect(1, 917505, '\p{^Deprecated=  no}', "");
    Expect(1, 917505, '\P{Deprecated=  no}', "");
    Expect(0, 917505, '\P{^Deprecated=  no}', "");
    Error('\p{Dep=:=-N}');
    Error('\P{Dep=:=-N}');
    Expect(1, 917506, '\p{Dep=:\AN\z:}', "");;
    Expect(0, 917505, '\p{Dep=:\AN\z:}', "");;
    Expect(1, 917506, '\p{Dep=n}', "");
    Expect(0, 917506, '\p{^Dep=n}', "");
    Expect(0, 917506, '\P{Dep=n}', "");
    Expect(1, 917506, '\P{^Dep=n}', "");
    Expect(0, 917505, '\p{Dep=n}', "");
    Expect(1, 917505, '\p{^Dep=n}', "");
    Expect(1, 917505, '\P{Dep=n}', "");
    Expect(0, 917505, '\P{^Dep=n}', "");
    Expect(1, 917506, '\p{Dep=:\An\z:}', "");;
    Expect(0, 917505, '\p{Dep=:\An\z:}', "");;
    Expect(1, 917506, '\p{Dep:	  N}', "");
    Expect(0, 917506, '\p{^Dep:	  N}', "");
    Expect(0, 917506, '\P{Dep:	  N}', "");
    Expect(1, 917506, '\P{^Dep:	  N}', "");
    Expect(0, 917505, '\p{Dep:	  N}', "");
    Expect(1, 917505, '\p{^Dep:	  N}', "");
    Expect(1, 917505, '\P{Dep:	  N}', "");
    Expect(0, 917505, '\P{^Dep:	  N}', "");
    Error('\p{Is_Deprecated=--f:=}');
    Error('\P{Is_Deprecated=--f:=}');
    Expect(1, 917506, '\p{Is_Deprecated=f}', "");
    Expect(0, 917506, '\p{^Is_Deprecated=f}', "");
    Expect(0, 917506, '\P{Is_Deprecated=f}', "");
    Expect(1, 917506, '\P{^Is_Deprecated=f}', "");
    Expect(0, 917505, '\p{Is_Deprecated=f}', "");
    Expect(1, 917505, '\p{^Is_Deprecated=f}', "");
    Expect(1, 917505, '\P{Is_Deprecated=f}', "");
    Expect(0, 917505, '\P{^Is_Deprecated=f}', "");
    Expect(1, 917506, '\p{Is_Deprecated=--f}', "");
    Expect(0, 917506, '\p{^Is_Deprecated=--f}', "");
    Expect(0, 917506, '\P{Is_Deprecated=--f}', "");
    Expect(1, 917506, '\P{^Is_Deprecated=--f}', "");
    Expect(0, 917505, '\p{Is_Deprecated=--f}', "");
    Expect(1, 917505, '\p{^Is_Deprecated=--f}', "");
    Expect(1, 917505, '\P{Is_Deprecated=--f}', "");
    Expect(0, 917505, '\P{^Is_Deprecated=--f}', "");
    Error('\p{Is_Dep=	False/a/}');
    Error('\P{Is_Dep=	False/a/}');
    Expect(1, 917506, '\p{Is_Dep=false}', "");
    Expect(0, 917506, '\p{^Is_Dep=false}', "");
    Expect(0, 917506, '\P{Is_Dep=false}', "");
    Expect(1, 917506, '\P{^Is_Dep=false}', "");
    Expect(0, 917505, '\p{Is_Dep=false}', "");
    Expect(1, 917505, '\p{^Is_Dep=false}', "");
    Expect(1, 917505, '\P{Is_Dep=false}', "");
    Expect(0, 917505, '\P{^Is_Dep=false}', "");
    Expect(1, 917506, '\p{Is_Dep=	False}', "");
    Expect(0, 917506, '\p{^Is_Dep=	False}', "");
    Expect(0, 917506, '\P{Is_Dep=	False}', "");
    Expect(1, 917506, '\P{^Is_Dep=	False}', "");
    Expect(0, 917505, '\p{Is_Dep=	False}', "");
    Expect(1, 917505, '\p{^Is_Dep=	False}', "");
    Expect(1, 917505, '\P{Is_Dep=	False}', "");
    Expect(0, 917505, '\P{^Is_Dep=	False}', "");
    Error('\p{Deprecated= -Yes/a/}');
    Error('\P{Deprecated= -Yes/a/}');
    Expect(1, 917505, '\p{Deprecated=:\AYes\z:}', "");;
    Expect(0, 917506, '\p{Deprecated=:\AYes\z:}', "");;
    Expect(1, 917505, '\p{Deprecated=yes}', "");
    Expect(0, 917505, '\p{^Deprecated=yes}', "");
    Expect(0, 917505, '\P{Deprecated=yes}', "");
    Expect(1, 917505, '\P{^Deprecated=yes}', "");
    Expect(0, 917506, '\p{Deprecated=yes}', "");
    Expect(1, 917506, '\p{^Deprecated=yes}', "");
    Expect(1, 917506, '\P{Deprecated=yes}', "");
    Expect(0, 917506, '\P{^Deprecated=yes}', "");
    Expect(1, 917505, '\p{Deprecated=:\Ayes\z:}', "");;
    Expect(0, 917506, '\p{Deprecated=:\Ayes\z:}', "");;
    Expect(1, 917505, '\p{Deprecated=	yes}', "");
    Expect(0, 917505, '\p{^Deprecated=	yes}', "");
    Expect(0, 917505, '\P{Deprecated=	yes}', "");
    Expect(1, 917505, '\P{^Deprecated=	yes}', "");
    Expect(0, 917506, '\p{Deprecated=	yes}', "");
    Expect(1, 917506, '\p{^Deprecated=	yes}', "");
    Expect(1, 917506, '\P{Deprecated=	yes}', "");
    Expect(0, 917506, '\P{^Deprecated=	yes}', "");
    Error('\p{Dep:	:=  y}');
    Error('\P{Dep:	:=  y}');
    Expect(1, 917505, '\p{Dep=:\AY\z:}', "");;
    Expect(0, 917506, '\p{Dep=:\AY\z:}', "");;
    Expect(1, 917505, '\p{Dep=y}', "");
    Expect(0, 917505, '\p{^Dep=y}', "");
    Expect(0, 917505, '\P{Dep=y}', "");
    Expect(1, 917505, '\P{^Dep=y}', "");
    Expect(0, 917506, '\p{Dep=y}', "");
    Expect(1, 917506, '\p{^Dep=y}', "");
    Expect(1, 917506, '\P{Dep=y}', "");
    Expect(0, 917506, '\P{^Dep=y}', "");
    Expect(1, 917505, '\p{Dep=:\Ay\z:}', "");;
    Expect(0, 917506, '\p{Dep=:\Ay\z:}', "");;
    Expect(1, 917505, '\p{Dep=-_y}', "");
    Expect(0, 917505, '\p{^Dep=-_y}', "");
    Expect(0, 917505, '\P{Dep=-_y}', "");
    Expect(1, 917505, '\P{^Dep=-_y}', "");
    Expect(0, 917506, '\p{Dep=-_y}', "");
    Expect(1, 917506, '\p{^Dep=-_y}', "");
    Expect(1, 917506, '\P{Dep=-_y}', "");
    Expect(0, 917506, '\P{^Dep=-_y}', "");
    Error('\p{Is_Deprecated=/a/_T}');
    Error('\P{Is_Deprecated=/a/_T}');
    Expect(1, 917505, '\p{Is_Deprecated=t}', "");
    Expect(0, 917505, '\p{^Is_Deprecated=t}', "");
    Expect(0, 917505, '\P{Is_Deprecated=t}', "");
    Expect(1, 917505, '\P{^Is_Deprecated=t}', "");
    Expect(0, 917506, '\p{Is_Deprecated=t}', "");
    Expect(1, 917506, '\p{^Is_Deprecated=t}', "");
    Expect(1, 917506, '\P{Is_Deprecated=t}', "");
    Expect(0, 917506, '\P{^Is_Deprecated=t}', "");
    Expect(1, 917505, '\p{Is_Deprecated=		T}', "");
    Expect(0, 917505, '\p{^Is_Deprecated=		T}', "");
    Expect(0, 917505, '\P{Is_Deprecated=		T}', "");
    Expect(1, 917505, '\P{^Is_Deprecated=		T}', "");
    Expect(0, 917506, '\p{Is_Deprecated=		T}', "");
    Expect(1, 917506, '\p{^Is_Deprecated=		T}', "");
    Expect(1, 917506, '\P{Is_Deprecated=		T}', "");
    Expect(0, 917506, '\P{^Is_Deprecated=		T}', "");
    Error('\p{Is_Dep=/a/_True}');
    Error('\P{Is_Dep=/a/_True}');
    Expect(1, 917505, '\p{Is_Dep=true}', "");
    Expect(0, 917505, '\p{^Is_Dep=true}', "");
    Expect(0, 917505, '\P{Is_Dep=true}', "");
    Expect(1, 917505, '\P{^Is_Dep=true}', "");
    Expect(0, 917506, '\p{Is_Dep=true}', "");
    Expect(1, 917506, '\p{^Is_Dep=true}', "");
    Expect(1, 917506, '\P{Is_Dep=true}', "");
    Expect(0, 917506, '\P{^Is_Dep=true}', "");
    Expect(1, 917505, '\p{Is_Dep: -True}', "");
    Expect(0, 917505, '\p{^Is_Dep: -True}', "");
    Expect(0, 917505, '\P{Is_Dep: -True}', "");
    Expect(1, 917505, '\P{^Is_Dep: -True}', "");
    Expect(0, 917506, '\p{Is_Dep: -True}', "");
    Expect(1, 917506, '\p{^Is_Dep: -True}', "");
    Expect(1, 917506, '\P{Is_Dep: -True}', "");
    Expect(0, 917506, '\P{^Is_Dep: -True}', "");
    Error('\p{Default_Ignorable_Code_Point=_	no:=}');
    Error('\P{Default_Ignorable_Code_Point=_	no:=}');
    Expect(1, 921600, '\p{Default_Ignorable_Code_Point=:\ANo\z:}', "");;
    Expect(0, 921599, '\p{Default_Ignorable_Code_Point=:\ANo\z:}', "");;
    Expect(1, 921600, '\p{Default_Ignorable_Code_Point=no}', "");
    Expect(0, 921600, '\p{^Default_Ignorable_Code_Point=no}', "");
    Expect(0, 921600, '\P{Default_Ignorable_Code_Point=no}', "");
    Expect(1, 921600, '\P{^Default_Ignorable_Code_Point=no}', "");
    Expect(0, 921599, '\p{Default_Ignorable_Code_Point=no}', "");
    Expect(1, 921599, '\p{^Default_Ignorable_Code_Point=no}', "");
    Expect(1, 921599, '\P{Default_Ignorable_Code_Point=no}', "");
    Expect(0, 921599, '\P{^Default_Ignorable_Code_Point=no}', "");
    Expect(1, 921600, '\p{Default_Ignorable_Code_Point=:\Ano\z:}', "");;
    Expect(0, 921599, '\p{Default_Ignorable_Code_Point=:\Ano\z:}', "");;
    Expect(1, 921600, '\p{Default_Ignorable_Code_Point:   _no}', "");
    Expect(0, 921600, '\p{^Default_Ignorable_Code_Point:   _no}', "");
    Expect(0, 921600, '\P{Default_Ignorable_Code_Point:   _no}', "");
    Expect(1, 921600, '\P{^Default_Ignorable_Code_Point:   _no}', "");
    Expect(0, 921599, '\p{Default_Ignorable_Code_Point:   _no}', "");
    Expect(1, 921599, '\p{^Default_Ignorable_Code_Point:   _no}', "");
    Expect(1, 921599, '\P{Default_Ignorable_Code_Point:   _no}', "");
    Expect(0, 921599, '\P{^Default_Ignorable_Code_Point:   _no}', "");
    Error('\p{DI=:= 	N}');
    Error('\P{DI=:= 	N}');
    Expect(1, 921600, '\p{DI=:\AN\z:}', "");;
    Expect(0, 921599, '\p{DI=:\AN\z:}', "");;
    Expect(1, 921600, '\p{DI=n}', "");
    Expect(0, 921600, '\p{^DI=n}', "");
    Expect(0, 921600, '\P{DI=n}', "");
    Expect(1, 921600, '\P{^DI=n}', "");
    Expect(0, 921599, '\p{DI=n}', "");
    Expect(1, 921599, '\p{^DI=n}', "");
    Expect(1, 921599, '\P{DI=n}', "");
    Expect(0, 921599, '\P{^DI=n}', "");
    Expect(1, 921600, '\p{DI=:\An\z:}', "");;
    Expect(0, 921599, '\p{DI=:\An\z:}', "");;
    Expect(1, 921600, '\p{DI:   - n}', "");
    Expect(0, 921600, '\p{^DI:   - n}', "");
    Expect(0, 921600, '\P{DI:   - n}', "");
    Expect(1, 921600, '\P{^DI:   - n}', "");
    Expect(0, 921599, '\p{DI:   - n}', "");
    Expect(1, 921599, '\p{^DI:   - n}', "");
    Expect(1, 921599, '\P{DI:   - n}', "");
    Expect(0, 921599, '\P{^DI:   - n}', "");
    Error('\p{Is_Default_Ignorable_Code_Point=/a/-_f}');
    Error('\P{Is_Default_Ignorable_Code_Point=/a/-_f}');
    Expect(1, 921600, '\p{Is_Default_Ignorable_Code_Point=f}', "");
    Expect(0, 921600, '\p{^Is_Default_Ignorable_Code_Point=f}', "");
    Expect(0, 921600, '\P{Is_Default_Ignorable_Code_Point=f}', "");
    Expect(1, 921600, '\P{^Is_Default_Ignorable_Code_Point=f}', "");
    Expect(0, 921599, '\p{Is_Default_Ignorable_Code_Point=f}', "");
    Expect(1, 921599, '\p{^Is_Default_Ignorable_Code_Point=f}', "");
    Expect(1, 921599, '\P{Is_Default_Ignorable_Code_Point=f}', "");
    Expect(0, 921599, '\P{^Is_Default_Ignorable_Code_Point=f}', "");
    Expect(1, 921600, '\p{Is_Default_Ignorable_Code_Point=  F}', "");
    Expect(0, 921600, '\p{^Is_Default_Ignorable_Code_Point=  F}', "");
    Expect(0, 921600, '\P{Is_Default_Ignorable_Code_Point=  F}', "");
    Expect(1, 921600, '\P{^Is_Default_Ignorable_Code_Point=  F}', "");
    Expect(0, 921599, '\p{Is_Default_Ignorable_Code_Point=  F}', "");
    Expect(1, 921599, '\p{^Is_Default_Ignorable_Code_Point=  F}', "");
    Expect(1, 921599, '\P{Is_Default_Ignorable_Code_Point=  F}', "");
    Expect(0, 921599, '\P{^Is_Default_Ignorable_Code_Point=  F}', "");
    Error('\p{Is_DI=--False:=}');
    Error('\P{Is_DI=--False:=}');
    Expect(1, 921600, '\p{Is_DI:   false}', "");
    Expect(0, 921600, '\p{^Is_DI:   false}', "");
    Expect(0, 921600, '\P{Is_DI:   false}', "");
    Expect(1, 921600, '\P{^Is_DI:   false}', "");
    Expect(0, 921599, '\p{Is_DI:   false}', "");
    Expect(1, 921599, '\p{^Is_DI:   false}', "");
    Expect(1, 921599, '\P{Is_DI:   false}', "");
    Expect(0, 921599, '\P{^Is_DI:   false}', "");
    Expect(1, 921600, '\p{Is_DI=	False}', "");
    Expect(0, 921600, '\p{^Is_DI=	False}', "");
    Expect(0, 921600, '\P{Is_DI=	False}', "");
    Expect(1, 921600, '\P{^Is_DI=	False}', "");
    Expect(0, 921599, '\p{Is_DI=	False}', "");
    Expect(1, 921599, '\p{^Is_DI=	False}', "");
    Expect(1, 921599, '\P{Is_DI=	False}', "");
    Expect(0, 921599, '\P{^Is_DI=	False}', "");
    Error('\p{Default_Ignorable_Code_Point=/a/ yes}');
    Error('\P{Default_Ignorable_Code_Point=/a/ yes}');
    Expect(1, 921599, '\p{Default_Ignorable_Code_Point=:\AYes\z:}', "");;
    Expect(0, 921600, '\p{Default_Ignorable_Code_Point=:\AYes\z:}', "");;
    Expect(1, 921599, '\p{Default_Ignorable_Code_Point=yes}', "");
    Expect(0, 921599, '\p{^Default_Ignorable_Code_Point=yes}', "");
    Expect(0, 921599, '\P{Default_Ignorable_Code_Point=yes}', "");
    Expect(1, 921599, '\P{^Default_Ignorable_Code_Point=yes}', "");
    Expect(0, 921600, '\p{Default_Ignorable_Code_Point=yes}', "");
    Expect(1, 921600, '\p{^Default_Ignorable_Code_Point=yes}', "");
    Expect(1, 921600, '\P{Default_Ignorable_Code_Point=yes}', "");
    Expect(0, 921600, '\P{^Default_Ignorable_Code_Point=yes}', "");
    Expect(1, 921599, '\p{Default_Ignorable_Code_Point=:\Ayes\z:}', "");;
    Expect(0, 921600, '\p{Default_Ignorable_Code_Point=:\Ayes\z:}', "");;
    Expect(1, 921599, '\p{Default_Ignorable_Code_Point=	-Yes}', "");
    Expect(0, 921599, '\p{^Default_Ignorable_Code_Point=	-Yes}', "");
    Expect(0, 921599, '\P{Default_Ignorable_Code_Point=	-Yes}', "");
    Expect(1, 921599, '\P{^Default_Ignorable_Code_Point=	-Yes}', "");
    Expect(0, 921600, '\p{Default_Ignorable_Code_Point=	-Yes}', "");
    Expect(1, 921600, '\p{^Default_Ignorable_Code_Point=	-Yes}', "");
    Expect(1, 921600, '\P{Default_Ignorable_Code_Point=	-Yes}', "");
    Expect(0, 921600, '\P{^Default_Ignorable_Code_Point=	-Yes}', "");
    Error('\p{DI:   := 	Y}');
    Error('\P{DI:   := 	Y}');
    Expect(1, 921599, '\p{DI=:\AY\z:}', "");;
    Expect(0, 921600, '\p{DI=:\AY\z:}', "");;
    Expect(1, 921599, '\p{DI=y}', "");
    Expect(0, 921599, '\p{^DI=y}', "");
    Expect(0, 921599, '\P{DI=y}', "");
    Expect(1, 921599, '\P{^DI=y}', "");
    Expect(0, 921600, '\p{DI=y}', "");
    Expect(1, 921600, '\p{^DI=y}', "");
    Expect(1, 921600, '\P{DI=y}', "");
    Expect(0, 921600, '\P{^DI=y}', "");
    Expect(1, 921599, '\p{DI=:\Ay\z:}', "");;
    Expect(0, 921600, '\p{DI=:\Ay\z:}', "");;
    Expect(1, 921599, '\p{DI=-	Y}', "");
    Expect(0, 921599, '\p{^DI=-	Y}', "");
    Expect(0, 921599, '\P{DI=-	Y}', "");
    Expect(1, 921599, '\P{^DI=-	Y}', "");
    Expect(0, 921600, '\p{DI=-	Y}', "");
    Expect(1, 921600, '\p{^DI=-	Y}', "");
    Expect(1, 921600, '\P{DI=-	Y}', "");
    Expect(0, 921600, '\P{^DI=-	Y}', "");
    Error('\p{Is_Default_Ignorable_Code_Point=-/a/T}');
    Error('\P{Is_Default_Ignorable_Code_Point=-/a/T}');
    Expect(1, 921599, '\p{Is_Default_Ignorable_Code_Point=t}', "");
    Expect(0, 921599, '\p{^Is_Default_Ignorable_Code_Point=t}', "");
    Expect(0, 921599, '\P{Is_Default_Ignorable_Code_Point=t}', "");
    Expect(1, 921599, '\P{^Is_Default_Ignorable_Code_Point=t}', "");
    Expect(0, 921600, '\p{Is_Default_Ignorable_Code_Point=t}', "");
    Expect(1, 921600, '\p{^Is_Default_Ignorable_Code_Point=t}', "");
    Expect(1, 921600, '\P{Is_Default_Ignorable_Code_Point=t}', "");
    Expect(0, 921600, '\P{^Is_Default_Ignorable_Code_Point=t}', "");
    Expect(1, 921599, '\p{Is_Default_Ignorable_Code_Point=- t}', "");
    Expect(0, 921599, '\p{^Is_Default_Ignorable_Code_Point=- t}', "");
    Expect(0, 921599, '\P{Is_Default_Ignorable_Code_Point=- t}', "");
    Expect(1, 921599, '\P{^Is_Default_Ignorable_Code_Point=- t}', "");
    Expect(0, 921600, '\p{Is_Default_Ignorable_Code_Point=- t}', "");
    Expect(1, 921600, '\p{^Is_Default_Ignorable_Code_Point=- t}', "");
    Expect(1, 921600, '\P{Is_Default_Ignorable_Code_Point=- t}', "");
    Expect(0, 921600, '\P{^Is_Default_Ignorable_Code_Point=- t}', "");
    Error('\p{Is_DI:	_-True:=}');
    Error('\P{Is_DI:	_-True:=}');
    Expect(1, 921599, '\p{Is_DI=true}', "");
    Expect(0, 921599, '\p{^Is_DI=true}', "");
    Expect(0, 921599, '\P{Is_DI=true}', "");
    Expect(1, 921599, '\P{^Is_DI=true}', "");
    Expect(0, 921600, '\p{Is_DI=true}', "");
    Expect(1, 921600, '\p{^Is_DI=true}', "");
    Expect(1, 921600, '\P{Is_DI=true}', "");
    Expect(0, 921600, '\P{^Is_DI=true}', "");
    Expect(1, 921599, '\p{Is_DI:	_True}', "");
    Expect(0, 921599, '\p{^Is_DI:	_True}', "");
    Expect(0, 921599, '\P{Is_DI:	_True}', "");
    Expect(1, 921599, '\P{^Is_DI:	_True}', "");
    Expect(0, 921600, '\p{Is_DI:	_True}', "");
    Expect(1, 921600, '\p{^Is_DI:	_True}', "");
    Expect(1, 921600, '\P{Is_DI:	_True}', "");
    Expect(0, 921600, '\P{^Is_DI:	_True}', "");
    Error('\p{Diacritic: 	No/a/}');
    Error('\P{Diacritic: 	No/a/}');
    Expect(1, 125259, '\p{Diacritic=:\ANo\z:}', "");;
    Expect(0, 125258, '\p{Diacritic=:\ANo\z:}', "");;
    Expect(1, 125259, '\p{Diacritic:no}', "");
    Expect(0, 125259, '\p{^Diacritic:no}', "");
    Expect(0, 125259, '\P{Diacritic:no}', "");
    Expect(1, 125259, '\P{^Diacritic:no}', "");
    Expect(0, 125258, '\p{Diacritic:no}', "");
    Expect(1, 125258, '\p{^Diacritic:no}', "");
    Expect(1, 125258, '\P{Diacritic:no}', "");
    Expect(0, 125258, '\P{^Diacritic:no}', "");
    Expect(1, 125259, '\p{Diacritic=:\Ano\z:}', "");;
    Expect(0, 125258, '\p{Diacritic=:\Ano\z:}', "");;
    Expect(1, 125259, '\p{Diacritic=	no}', "");
    Expect(0, 125259, '\p{^Diacritic=	no}', "");
    Expect(0, 125259, '\P{Diacritic=	no}', "");
    Expect(1, 125259, '\P{^Diacritic=	no}', "");
    Expect(0, 125258, '\p{Diacritic=	no}', "");
    Expect(1, 125258, '\p{^Diacritic=	no}', "");
    Expect(1, 125258, '\P{Diacritic=	no}', "");
    Expect(0, 125258, '\P{^Diacritic=	no}', "");
    Error('\p{Dia:	:=	N}');
    Error('\P{Dia:	:=	N}');
    Expect(1, 125259, '\p{Dia=:\AN\z:}', "");;
    Expect(0, 125258, '\p{Dia=:\AN\z:}', "");;
    Expect(1, 125259, '\p{Dia: n}', "");
    Expect(0, 125259, '\p{^Dia: n}', "");
    Expect(0, 125259, '\P{Dia: n}', "");
    Expect(1, 125259, '\P{^Dia: n}', "");
    Expect(0, 125258, '\p{Dia: n}', "");
    Expect(1, 125258, '\p{^Dia: n}', "");
    Expect(1, 125258, '\P{Dia: n}', "");
    Expect(0, 125258, '\P{^Dia: n}', "");
    Expect(1, 125259, '\p{Dia=:\An\z:}', "");;
    Expect(0, 125258, '\p{Dia=:\An\z:}', "");;
    Expect(1, 125259, '\p{Dia=_	N}', "");
    Expect(0, 125259, '\p{^Dia=_	N}', "");
    Expect(0, 125259, '\P{Dia=_	N}', "");
    Expect(1, 125259, '\P{^Dia=_	N}', "");
    Expect(0, 125258, '\p{Dia=_	N}', "");
    Expect(1, 125258, '\p{^Dia=_	N}', "");
    Expect(1, 125258, '\P{Dia=_	N}', "");
    Expect(0, 125258, '\P{^Dia=_	N}', "");
    Error('\p{Is_Diacritic:		f/a/}');
    Error('\P{Is_Diacritic:		f/a/}');
    Expect(1, 125259, '\p{Is_Diacritic: f}', "");
    Expect(0, 125259, '\p{^Is_Diacritic: f}', "");
    Expect(0, 125259, '\P{Is_Diacritic: f}', "");
    Expect(1, 125259, '\P{^Is_Diacritic: f}', "");
    Expect(0, 125258, '\p{Is_Diacritic: f}', "");
    Expect(1, 125258, '\p{^Is_Diacritic: f}', "");
    Expect(1, 125258, '\P{Is_Diacritic: f}', "");
    Expect(0, 125258, '\P{^Is_Diacritic: f}', "");
    Expect(1, 125259, '\p{Is_Diacritic= F}', "");
    Expect(0, 125259, '\p{^Is_Diacritic= F}', "");
    Expect(0, 125259, '\P{Is_Diacritic= F}', "");
    Expect(1, 125259, '\P{^Is_Diacritic= F}', "");
    Expect(0, 125258, '\p{Is_Diacritic= F}', "");
    Expect(1, 125258, '\p{^Is_Diacritic= F}', "");
    Expect(1, 125258, '\P{Is_Diacritic= F}', "");
    Expect(0, 125258, '\P{^Is_Diacritic= F}', "");
    Error('\p{Is_Dia=:=	False}');
    Error('\P{Is_Dia=:=	False}');
    Expect(1, 125259, '\p{Is_Dia=false}', "");
    Expect(0, 125259, '\p{^Is_Dia=false}', "");
    Expect(0, 125259, '\P{Is_Dia=false}', "");
    Expect(1, 125259, '\P{^Is_Dia=false}', "");
    Expect(0, 125258, '\p{Is_Dia=false}', "");
    Expect(1, 125258, '\p{^Is_Dia=false}', "");
    Expect(1, 125258, '\P{Is_Dia=false}', "");
    Expect(0, 125258, '\P{^Is_Dia=false}', "");
    Expect(1, 125259, '\p{Is_Dia=-FALSE}', "");
    Expect(0, 125259, '\p{^Is_Dia=-FALSE}', "");
    Expect(0, 125259, '\P{Is_Dia=-FALSE}', "");
    Expect(1, 125259, '\P{^Is_Dia=-FALSE}', "");
    Expect(0, 125258, '\p{Is_Dia=-FALSE}', "");
    Expect(1, 125258, '\p{^Is_Dia=-FALSE}', "");
    Expect(1, 125258, '\P{Is_Dia=-FALSE}', "");
    Expect(0, 125258, '\P{^Is_Dia=-FALSE}', "");
    Error('\p{Diacritic=/a/-Yes}');
    Error('\P{Diacritic=/a/-Yes}');
    Expect(1, 125258, '\p{Diacritic=:\AYes\z:}', "");;
    Expect(0, 125259, '\p{Diacritic=:\AYes\z:}', "");;
    Expect(1, 125258, '\p{Diacritic=yes}', "");
    Expect(0, 125258, '\p{^Diacritic=yes}', "");
    Expect(0, 125258, '\P{Diacritic=yes}', "");
    Expect(1, 125258, '\P{^Diacritic=yes}', "");
    Expect(0, 125259, '\p{Diacritic=yes}', "");
    Expect(1, 125259, '\p{^Diacritic=yes}', "");
    Expect(1, 125259, '\P{Diacritic=yes}', "");
    Expect(0, 125259, '\P{^Diacritic=yes}', "");
    Expect(1, 125258, '\p{Diacritic=:\Ayes\z:}', "");;
    Expect(0, 125259, '\p{Diacritic=:\Ayes\z:}', "");;
    Expect(1, 125258, '\p{Diacritic:    _Yes}', "");
    Expect(0, 125258, '\p{^Diacritic:    _Yes}', "");
    Expect(0, 125258, '\P{Diacritic:    _Yes}', "");
    Expect(1, 125258, '\P{^Diacritic:    _Yes}', "");
    Expect(0, 125259, '\p{Diacritic:    _Yes}', "");
    Expect(1, 125259, '\p{^Diacritic:    _Yes}', "");
    Expect(1, 125259, '\P{Diacritic:    _Yes}', "");
    Expect(0, 125259, '\P{^Diacritic:    _Yes}', "");
    Error('\p{Dia= :=Y}');
    Error('\P{Dia= :=Y}');
    Expect(1, 125258, '\p{Dia=:\AY\z:}', "");;
    Expect(0, 125259, '\p{Dia=:\AY\z:}', "");;
    Expect(1, 125258, '\p{Dia=y}', "");
    Expect(0, 125258, '\p{^Dia=y}', "");
    Expect(0, 125258, '\P{Dia=y}', "");
    Expect(1, 125258, '\P{^Dia=y}', "");
    Expect(0, 125259, '\p{Dia=y}', "");
    Expect(1, 125259, '\p{^Dia=y}', "");
    Expect(1, 125259, '\P{Dia=y}', "");
    Expect(0, 125259, '\P{^Dia=y}', "");
    Expect(1, 125258, '\p{Dia=:\Ay\z:}', "");;
    Expect(0, 125259, '\p{Dia=:\Ay\z:}', "");;
    Expect(1, 125258, '\p{Dia=	Y}', "");
    Expect(0, 125258, '\p{^Dia=	Y}', "");
    Expect(0, 125258, '\P{Dia=	Y}', "");
    Expect(1, 125258, '\P{^Dia=	Y}', "");
    Expect(0, 125259, '\p{Dia=	Y}', "");
    Expect(1, 125259, '\p{^Dia=	Y}', "");
    Expect(1, 125259, '\P{Dia=	Y}', "");
    Expect(0, 125259, '\P{^Dia=	Y}', "");
    Error('\p{Is_Diacritic=_ t:=}');
    Error('\P{Is_Diacritic=_ t:=}');
    Expect(1, 125258, '\p{Is_Diacritic=t}', "");
    Expect(0, 125258, '\p{^Is_Diacritic=t}', "");
    Expect(0, 125258, '\P{Is_Diacritic=t}', "");
    Expect(1, 125258, '\P{^Is_Diacritic=t}', "");
    Expect(0, 125259, '\p{Is_Diacritic=t}', "");
    Expect(1, 125259, '\p{^Is_Diacritic=t}', "");
    Expect(1, 125259, '\P{Is_Diacritic=t}', "");
    Expect(0, 125259, '\P{^Is_Diacritic=t}', "");
    Expect(1, 125258, '\p{Is_Diacritic= t}', "");
    Expect(0, 125258, '\p{^Is_Diacritic= t}', "");
    Expect(0, 125258, '\P{Is_Diacritic= t}', "");
    Expect(1, 125258, '\P{^Is_Diacritic= t}', "");
    Expect(0, 125259, '\p{Is_Diacritic= t}', "");
    Expect(1, 125259, '\p{^Is_Diacritic= t}', "");
    Expect(1, 125259, '\P{Is_Diacritic= t}', "");
    Expect(0, 125259, '\P{^Is_Diacritic= t}', "");
    Error('\p{Is_Dia=	 True/a/}');
    Error('\P{Is_Dia=	 True/a/}');
    Expect(1, 125258, '\p{Is_Dia=true}', "");
    Expect(0, 125258, '\p{^Is_Dia=true}', "");
    Expect(0, 125258, '\P{Is_Dia=true}', "");
    Expect(1, 125258, '\P{^Is_Dia=true}', "");
    Expect(0, 125259, '\p{Is_Dia=true}', "");
    Expect(1, 125259, '\p{^Is_Dia=true}', "");
    Expect(1, 125259, '\P{Is_Dia=true}', "");
    Expect(0, 125259, '\P{^Is_Dia=true}', "");
    Expect(1, 125258, '\p{Is_Dia=_ TRUE}', "");
    Expect(0, 125258, '\p{^Is_Dia=_ TRUE}', "");
    Expect(0, 125258, '\P{Is_Dia=_ TRUE}', "");
    Expect(1, 125258, '\P{^Is_Dia=_ TRUE}', "");
    Expect(0, 125259, '\p{Is_Dia=_ TRUE}', "");
    Expect(1, 125259, '\p{^Is_Dia=_ TRUE}', "");
    Expect(1, 125259, '\P{Is_Dia=_ TRUE}', "");
    Expect(0, 125259, '\P{^Is_Dia=_ TRUE}', "");
    Error('\p{decompositionmapping}');
    Error('\P{decompositionmapping}');
    Error('\p{dm}');
    Error('\P{dm}');
    Error('\p{decompositiontype}');
    Error('\P{decompositiontype}');
    Error('\p{dt}');
    Error('\P{dt}');
    Error('\p{Decomposition_Type= Canonical:=}');
    Error('\P{Decomposition_Type= Canonical:=}');
    Expect(1, 195101, '\p{Decomposition_Type=:\ACanonical\z:}', "");;
    Expect(0, 195102, '\p{Decomposition_Type=:\ACanonical\z:}', "");;
    Expect(1, 195101, '\p{Decomposition_Type: canonical}', "");
    Expect(0, 195101, '\p{^Decomposition_Type: canonical}', "");
    Expect(0, 195101, '\P{Decomposition_Type: canonical}', "");
    Expect(1, 195101, '\P{^Decomposition_Type: canonical}', "");
    Expect(0, 195102, '\p{Decomposition_Type: canonical}', "");
    Expect(1, 195102, '\p{^Decomposition_Type: canonical}', "");
    Expect(1, 195102, '\P{Decomposition_Type: canonical}', "");
    Expect(0, 195102, '\P{^Decomposition_Type: canonical}', "");
    Expect(1, 195101, '\p{Decomposition_Type=:\Acanonical\z:}', "");;
    Expect(0, 195102, '\p{Decomposition_Type=:\Acanonical\z:}', "");;
    Expect(1, 195101, '\p{Decomposition_Type=__Canonical}', "");
    Expect(0, 195101, '\p{^Decomposition_Type=__Canonical}', "");
    Expect(0, 195101, '\P{Decomposition_Type=__Canonical}', "");
    Expect(1, 195101, '\P{^Decomposition_Type=__Canonical}', "");
    Expect(0, 195102, '\p{Decomposition_Type=__Canonical}', "");
    Expect(1, 195102, '\p{^Decomposition_Type=__Canonical}', "");
    Expect(1, 195102, '\P{Decomposition_Type=__Canonical}', "");
    Expect(0, 195102, '\P{^Decomposition_Type=__Canonical}', "");
    Error('\p{Dt=:=  Can}');
    Error('\P{Dt=:=  Can}');
    Expect(1, 195101, '\p{Dt=:\ACan\z:}', "");;
    Expect(0, 195102, '\p{Dt=:\ACan\z:}', "");;
    Expect(1, 195101, '\p{Dt=can}', "");
    Expect(0, 195101, '\p{^Dt=can}', "");
    Expect(0, 195101, '\P{Dt=can}', "");
    Expect(1, 195101, '\P{^Dt=can}', "");
    Expect(0, 195102, '\p{Dt=can}', "");
    Expect(1, 195102, '\p{^Dt=can}', "");
    Expect(1, 195102, '\P{Dt=can}', "");
    Expect(0, 195102, '\P{^Dt=can}', "");
    Expect(1, 195101, '\p{Dt=:\Acan\z:}', "");;
    Expect(0, 195102, '\p{Dt=:\Acan\z:}', "");;
    Expect(1, 195101, '\p{Dt=Can}', "");
    Expect(0, 195101, '\p{^Dt=Can}', "");
    Expect(0, 195101, '\P{Dt=Can}', "");
    Expect(1, 195101, '\P{^Dt=Can}', "");
    Expect(0, 195102, '\p{Dt=Can}', "");
    Expect(1, 195102, '\p{^Dt=Can}', "");
    Expect(1, 195102, '\P{Dt=Can}', "");
    Expect(0, 195102, '\P{^Dt=Can}', "");
    Error('\p{Is_Decomposition_Type:	:=canonical}');
    Error('\P{Is_Decomposition_Type:	:=canonical}');
    Expect(1, 195101, '\p{Is_Decomposition_Type=canonical}', "");
    Expect(0, 195101, '\p{^Is_Decomposition_Type=canonical}', "");
    Expect(0, 195101, '\P{Is_Decomposition_Type=canonical}', "");
    Expect(1, 195101, '\P{^Is_Decomposition_Type=canonical}', "");
    Expect(0, 195102, '\p{Is_Decomposition_Type=canonical}', "");
    Expect(1, 195102, '\p{^Is_Decomposition_Type=canonical}', "");
    Expect(1, 195102, '\P{Is_Decomposition_Type=canonical}', "");
    Expect(0, 195102, '\P{^Is_Decomposition_Type=canonical}', "");
    Expect(1, 195101, '\p{Is_Decomposition_Type=_Canonical}', "");
    Expect(0, 195101, '\p{^Is_Decomposition_Type=_Canonical}', "");
    Expect(0, 195101, '\P{Is_Decomposition_Type=_Canonical}', "");
    Expect(1, 195101, '\P{^Is_Decomposition_Type=_Canonical}', "");
    Expect(0, 195102, '\p{Is_Decomposition_Type=_Canonical}', "");
    Expect(1, 195102, '\p{^Is_Decomposition_Type=_Canonical}', "");
    Expect(1, 195102, '\P{Is_Decomposition_Type=_Canonical}', "");
    Expect(0, 195102, '\P{^Is_Decomposition_Type=_Canonical}', "");
    Error('\p{Is_Dt=	_Can/a/}');
    Error('\P{Is_Dt=	_Can/a/}');
    Expect(1, 195101, '\p{Is_Dt=can}', "");
    Expect(0, 195101, '\p{^Is_Dt=can}', "");
    Expect(0, 195101, '\P{Is_Dt=can}', "");
    Expect(1, 195101, '\P{^Is_Dt=can}', "");
    Expect(0, 195102, '\p{Is_Dt=can}', "");
    Expect(1, 195102, '\p{^Is_Dt=can}', "");
    Expect(1, 195102, '\P{Is_Dt=can}', "");
    Expect(0, 195102, '\P{^Is_Dt=can}', "");
    Expect(1, 195101, '\p{Is_Dt= CAN}', "");
    Expect(0, 195101, '\p{^Is_Dt= CAN}', "");
    Expect(0, 195101, '\P{Is_Dt= CAN}', "");
    Expect(1, 195101, '\P{^Is_Dt= CAN}', "");
    Expect(0, 195102, '\p{Is_Dt= CAN}', "");
    Expect(1, 195102, '\p{^Is_Dt= CAN}', "");
    Expect(1, 195102, '\P{Is_Dt= CAN}', "");
    Expect(0, 195102, '\P{^Is_Dt= CAN}', "");
    Error('\p{Decomposition_Type:   /a/		Compat}');
    Error('\P{Decomposition_Type:   /a/		Compat}');
    Expect(1, 127560, '\p{Decomposition_Type=:\ACompat\z:}', "");;
    Expect(0, 127561, '\p{Decomposition_Type=:\ACompat\z:}', "");;
    Expect(1, 127560, '\p{Decomposition_Type=compat}', "");
    Expect(0, 127560, '\p{^Decomposition_Type=compat}', "");
    Expect(0, 127560, '\P{Decomposition_Type=compat}', "");
    Expect(1, 127560, '\P{^Decomposition_Type=compat}', "");
    Expect(0, 127561, '\p{Decomposition_Type=compat}', "");
    Expect(1, 127561, '\p{^Decomposition_Type=compat}', "");
    Expect(1, 127561, '\P{Decomposition_Type=compat}', "");
    Expect(0, 127561, '\P{^Decomposition_Type=compat}', "");
    Expect(1, 127560, '\p{Decomposition_Type=:\Acompat\z:}', "");;
    Expect(0, 127561, '\p{Decomposition_Type=:\Acompat\z:}', "");;
    Expect(1, 127560, '\p{Decomposition_Type= _COMPAT}', "");
    Expect(0, 127560, '\p{^Decomposition_Type= _COMPAT}', "");
    Expect(0, 127560, '\P{Decomposition_Type= _COMPAT}', "");
    Expect(1, 127560, '\P{^Decomposition_Type= _COMPAT}', "");
    Expect(0, 127561, '\p{Decomposition_Type= _COMPAT}', "");
    Expect(1, 127561, '\p{^Decomposition_Type= _COMPAT}', "");
    Expect(1, 127561, '\P{Decomposition_Type= _COMPAT}', "");
    Expect(0, 127561, '\P{^Decomposition_Type= _COMPAT}', "");
    Error('\p{Dt=	_COM:=}');
    Error('\P{Dt=	_COM:=}');
    Expect(1, 127560, '\p{Dt=:\ACom\z:}', "");;
    Expect(0, 127561, '\p{Dt=:\ACom\z:}', "");;
    Expect(1, 127560, '\p{Dt:	com}', "");
    Expect(0, 127560, '\p{^Dt:	com}', "");
    Expect(0, 127560, '\P{Dt:	com}', "");
    Expect(1, 127560, '\P{^Dt:	com}', "");
    Expect(0, 127561, '\p{Dt:	com}', "");
    Expect(1, 127561, '\p{^Dt:	com}', "");
    Expect(1, 127561, '\P{Dt:	com}', "");
    Expect(0, 127561, '\P{^Dt:	com}', "");
    Expect(1, 127560, '\p{Dt=:\Acom\z:}', "");;
    Expect(0, 127561, '\p{Dt=:\Acom\z:}', "");;
    Expect(1, 127560, '\p{Dt= 	COM}', "");
    Expect(0, 127560, '\p{^Dt= 	COM}', "");
    Expect(0, 127560, '\P{Dt= 	COM}', "");
    Expect(1, 127560, '\P{^Dt= 	COM}', "");
    Expect(0, 127561, '\p{Dt= 	COM}', "");
    Expect(1, 127561, '\p{^Dt= 	COM}', "");
    Expect(1, 127561, '\P{Dt= 	COM}', "");
    Expect(0, 127561, '\P{^Dt= 	COM}', "");
    Error('\p{Is_Decomposition_Type=/a/--compat}');
    Error('\P{Is_Decomposition_Type=/a/--compat}');
    Expect(1, 127560, '\p{Is_Decomposition_Type=compat}', "");
    Expect(0, 127560, '\p{^Is_Decomposition_Type=compat}', "");
    Expect(0, 127560, '\P{Is_Decomposition_Type=compat}', "");
    Expect(1, 127560, '\P{^Is_Decomposition_Type=compat}', "");
    Expect(0, 127561, '\p{Is_Decomposition_Type=compat}', "");
    Expect(1, 127561, '\p{^Is_Decomposition_Type=compat}', "");
    Expect(1, 127561, '\P{Is_Decomposition_Type=compat}', "");
    Expect(0, 127561, '\P{^Is_Decomposition_Type=compat}', "");
    Expect(1, 127560, '\p{Is_Decomposition_Type:  	compat}', "");
    Expect(0, 127560, '\p{^Is_Decomposition_Type:  	compat}', "");
    Expect(0, 127560, '\P{Is_Decomposition_Type:  	compat}', "");
    Expect(1, 127560, '\P{^Is_Decomposition_Type:  	compat}', "");
    Expect(0, 127561, '\p{Is_Decomposition_Type:  	compat}', "");
    Expect(1, 127561, '\p{^Is_Decomposition_Type:  	compat}', "");
    Expect(1, 127561, '\P{Is_Decomposition_Type:  	compat}', "");
    Expect(0, 127561, '\P{^Is_Decomposition_Type:  	compat}', "");
    Error('\p{Is_Dt=-/a/Com}');
    Error('\P{Is_Dt=-/a/Com}');
    Expect(1, 127560, '\p{Is_Dt:com}', "");
    Expect(0, 127560, '\p{^Is_Dt:com}', "");
    Expect(0, 127560, '\P{Is_Dt:com}', "");
    Expect(1, 127560, '\P{^Is_Dt:com}', "");
    Expect(0, 127561, '\p{Is_Dt:com}', "");
    Expect(1, 127561, '\p{^Is_Dt:com}', "");
    Expect(1, 127561, '\P{Is_Dt:com}', "");
    Expect(0, 127561, '\P{^Is_Dt:com}', "");
    Expect(1, 127560, '\p{Is_Dt=_ com}', "");
    Expect(0, 127560, '\p{^Is_Dt=_ com}', "");
    Expect(0, 127560, '\P{Is_Dt=_ com}', "");
    Expect(1, 127560, '\P{^Is_Dt=_ com}', "");
    Expect(0, 127561, '\p{Is_Dt=_ com}', "");
    Expect(1, 127561, '\p{^Is_Dt=_ com}', "");
    Expect(1, 127561, '\P{Is_Dt=_ com}', "");
    Expect(0, 127561, '\P{^Is_Dt=_ com}', "");
    Error('\p{Decomposition_Type=/a/__Circle}');
    Error('\P{Decomposition_Type=/a/__Circle}');
    Expect(1, 127569, '\p{Decomposition_Type=:\ACircle\z:}', "");;
    Expect(0, 127570, '\p{Decomposition_Type=:\ACircle\z:}', "");;
    Expect(1, 127569, '\p{Decomposition_Type=circle}', "");
    Expect(0, 127569, '\p{^Decomposition_Type=circle}', "");
    Expect(0, 127569, '\P{Decomposition_Type=circle}', "");
    Expect(1, 127569, '\P{^Decomposition_Type=circle}', "");
    Expect(0, 127570, '\p{Decomposition_Type=circle}', "");
    Expect(1, 127570, '\p{^Decomposition_Type=circle}', "");
    Expect(1, 127570, '\P{Decomposition_Type=circle}', "");
    Expect(0, 127570, '\P{^Decomposition_Type=circle}', "");
    Expect(1, 127569, '\p{Decomposition_Type=:\Acircle\z:}', "");;
    Expect(0, 127570, '\p{Decomposition_Type=:\Acircle\z:}', "");;
    Expect(1, 127569, '\p{Decomposition_Type= -Circle}', "");
    Expect(0, 127569, '\p{^Decomposition_Type= -Circle}', "");
    Expect(0, 127569, '\P{Decomposition_Type= -Circle}', "");
    Expect(1, 127569, '\P{^Decomposition_Type= -Circle}', "");
    Expect(0, 127570, '\p{Decomposition_Type= -Circle}', "");
    Expect(1, 127570, '\p{^Decomposition_Type= -Circle}', "");
    Expect(1, 127570, '\P{Decomposition_Type= -Circle}', "");
    Expect(0, 127570, '\P{^Decomposition_Type= -Circle}', "");
    Error('\p{Dt=-_Enc:=}');
    Error('\P{Dt=-_Enc:=}');
    Expect(1, 127569, '\p{Dt=:\AEnc\z:}', "");;
    Expect(0, 127570, '\p{Dt=:\AEnc\z:}', "");;
    Expect(1, 127569, '\p{Dt=enc}', "");
    Expect(0, 127569, '\p{^Dt=enc}', "");
    Expect(0, 127569, '\P{Dt=enc}', "");
    Expect(1, 127569, '\P{^Dt=enc}', "");
    Expect(0, 127570, '\p{Dt=enc}', "");
    Expect(1, 127570, '\p{^Dt=enc}', "");
    Expect(1, 127570, '\P{Dt=enc}', "");
    Expect(0, 127570, '\P{^Dt=enc}', "");
    Expect(1, 127569, '\p{Dt=:\Aenc\z:}', "");;
    Expect(0, 127570, '\p{Dt=:\Aenc\z:}', "");;
    Expect(1, 127569, '\p{Dt= _Enc}', "");
    Expect(0, 127569, '\p{^Dt= _Enc}', "");
    Expect(0, 127569, '\P{Dt= _Enc}', "");
    Expect(1, 127569, '\P{^Dt= _Enc}', "");
    Expect(0, 127570, '\p{Dt= _Enc}', "");
    Expect(1, 127570, '\p{^Dt= _Enc}', "");
    Expect(1, 127570, '\P{Dt= _Enc}', "");
    Expect(0, 127570, '\P{^Dt= _Enc}', "");
    Error('\p{Is_Decomposition_Type=_CIRCLE:=}');
    Error('\P{Is_Decomposition_Type=_CIRCLE:=}');
    Expect(1, 127569, '\p{Is_Decomposition_Type=circle}', "");
    Expect(0, 127569, '\p{^Is_Decomposition_Type=circle}', "");
    Expect(0, 127569, '\P{Is_Decomposition_Type=circle}', "");
    Expect(1, 127569, '\P{^Is_Decomposition_Type=circle}', "");
    Expect(0, 127570, '\p{Is_Decomposition_Type=circle}', "");
    Expect(1, 127570, '\p{^Is_Decomposition_Type=circle}', "");
    Expect(1, 127570, '\P{Is_Decomposition_Type=circle}', "");
    Expect(0, 127570, '\P{^Is_Decomposition_Type=circle}', "");
    Expect(1, 127569, '\p{Is_Decomposition_Type= Circle}', "");
    Expect(0, 127569, '\p{^Is_Decomposition_Type= Circle}', "");
    Expect(0, 127569, '\P{Is_Decomposition_Type= Circle}', "");
    Expect(1, 127569, '\P{^Is_Decomposition_Type= Circle}', "");
    Expect(0, 127570, '\p{Is_Decomposition_Type= Circle}', "");
    Expect(1, 127570, '\p{^Is_Decomposition_Type= Circle}', "");
    Expect(1, 127570, '\P{Is_Decomposition_Type= Circle}', "");
    Expect(0, 127570, '\P{^Is_Decomposition_Type= Circle}', "");
    Error('\p{Is_Dt=/a/_	Enc}');
    Error('\P{Is_Dt=/a/_	Enc}');
    Expect(1, 127569, '\p{Is_Dt=enc}', "");
    Expect(0, 127569, '\p{^Is_Dt=enc}', "");
    Expect(0, 127569, '\P{Is_Dt=enc}', "");
    Expect(1, 127569, '\P{^Is_Dt=enc}', "");
    Expect(0, 127570, '\p{Is_Dt=enc}', "");
    Expect(1, 127570, '\p{^Is_Dt=enc}', "");
    Expect(1, 127570, '\P{Is_Dt=enc}', "");
    Expect(0, 127570, '\P{^Is_Dt=enc}', "");
    Expect(1, 127569, '\p{Is_Dt=		ENC}', "");
    Expect(0, 127569, '\p{^Is_Dt=		ENC}', "");
    Expect(0, 127569, '\P{Is_Dt=		ENC}', "");
    Expect(1, 127569, '\P{^Is_Dt=		ENC}', "");
    Expect(0, 127570, '\p{Is_Dt=		ENC}', "");
    Expect(1, 127570, '\p{^Is_Dt=		ENC}', "");
    Expect(1, 127570, '\P{Is_Dt=		ENC}', "");
    Expect(0, 127570, '\P{^Is_Dt=		ENC}', "");
    Error('\p{Decomposition_Type=_:=Final}');
    Error('\P{Decomposition_Type=_:=Final}');
    Expect(1, 65276, '\p{Decomposition_Type=:\AFinal\z:}', "");;
    Expect(0, 65277, '\p{Decomposition_Type=:\AFinal\z:}', "");;
    Expect(1, 65276, '\p{Decomposition_Type=final}', "");
    Expect(0, 65276, '\p{^Decomposition_Type=final}', "");
    Expect(0, 65276, '\P{Decomposition_Type=final}', "");
    Expect(1, 65276, '\P{^Decomposition_Type=final}', "");
    Expect(0, 65277, '\p{Decomposition_Type=final}', "");
    Expect(1, 65277, '\p{^Decomposition_Type=final}', "");
    Expect(1, 65277, '\P{Decomposition_Type=final}', "");
    Expect(0, 65277, '\P{^Decomposition_Type=final}', "");
    Expect(1, 65276, '\p{Decomposition_Type=:\Afinal\z:}', "");;
    Expect(0, 65277, '\p{Decomposition_Type=:\Afinal\z:}', "");;
    Expect(1, 65276, '\p{Decomposition_Type= FINAL}', "");
    Expect(0, 65276, '\p{^Decomposition_Type= FINAL}', "");
    Expect(0, 65276, '\P{Decomposition_Type= FINAL}', "");
    Expect(1, 65276, '\P{^Decomposition_Type= FINAL}', "");
    Expect(0, 65277, '\p{Decomposition_Type= FINAL}', "");
    Expect(1, 65277, '\p{^Decomposition_Type= FINAL}', "");
    Expect(1, 65277, '\P{Decomposition_Type= FINAL}', "");
    Expect(0, 65277, '\P{^Decomposition_Type= FINAL}', "");
    Error('\p{Dt=_ fin/a/}');
    Error('\P{Dt=_ fin/a/}');
    Expect(1, 65276, '\p{Dt=:\AFin\z:}', "");;
    Expect(0, 65277, '\p{Dt=:\AFin\z:}', "");;
    Expect(1, 65276, '\p{Dt=fin}', "");
    Expect(0, 65276, '\p{^Dt=fin}', "");
    Expect(0, 65276, '\P{Dt=fin}', "");
    Expect(1, 65276, '\P{^Dt=fin}', "");
    Expect(0, 65277, '\p{Dt=fin}', "");
    Expect(1, 65277, '\p{^Dt=fin}', "");
    Expect(1, 65277, '\P{Dt=fin}', "");
    Expect(0, 65277, '\P{^Dt=fin}', "");
    Expect(1, 65276, '\p{Dt=:\Afin\z:}', "");;
    Expect(0, 65277, '\p{Dt=:\Afin\z:}', "");;
    Expect(1, 65276, '\p{Dt=--fin}', "");
    Expect(0, 65276, '\p{^Dt=--fin}', "");
    Expect(0, 65276, '\P{Dt=--fin}', "");
    Expect(1, 65276, '\P{^Dt=--fin}', "");
    Expect(0, 65277, '\p{Dt=--fin}', "");
    Expect(1, 65277, '\p{^Dt=--fin}', "");
    Expect(1, 65277, '\P{Dt=--fin}', "");
    Expect(0, 65277, '\P{^Dt=--fin}', "");
    Error('\p{Is_Decomposition_Type=/a/-FINAL}');
    Error('\P{Is_Decomposition_Type=/a/-FINAL}');
    Expect(1, 65276, '\p{Is_Decomposition_Type=final}', "");
    Expect(0, 65276, '\p{^Is_Decomposition_Type=final}', "");
    Expect(0, 65276, '\P{Is_Decomposition_Type=final}', "");
    Expect(1, 65276, '\P{^Is_Decomposition_Type=final}', "");
    Expect(0, 65277, '\p{Is_Decomposition_Type=final}', "");
    Expect(1, 65277, '\p{^Is_Decomposition_Type=final}', "");
    Expect(1, 65277, '\P{Is_Decomposition_Type=final}', "");
    Expect(0, 65277, '\P{^Is_Decomposition_Type=final}', "");
    Expect(1, 65276, '\p{Is_Decomposition_Type: FINAL}', "");
    Expect(0, 65276, '\p{^Is_Decomposition_Type: FINAL}', "");
    Expect(0, 65276, '\P{Is_Decomposition_Type: FINAL}', "");
    Expect(1, 65276, '\P{^Is_Decomposition_Type: FINAL}', "");
    Expect(0, 65277, '\p{Is_Decomposition_Type: FINAL}', "");
    Expect(1, 65277, '\p{^Is_Decomposition_Type: FINAL}', "");
    Expect(1, 65277, '\P{Is_Decomposition_Type: FINAL}', "");
    Expect(0, 65277, '\P{^Is_Decomposition_Type: FINAL}', "");
    Error('\p{Is_Dt=:= _Fin}');
    Error('\P{Is_Dt=:= _Fin}');
    Expect(1, 65276, '\p{Is_Dt=fin}', "");
    Expect(0, 65276, '\p{^Is_Dt=fin}', "");
    Expect(0, 65276, '\P{Is_Dt=fin}', "");
    Expect(1, 65276, '\P{^Is_Dt=fin}', "");
    Expect(0, 65277, '\p{Is_Dt=fin}', "");
    Expect(1, 65277, '\p{^Is_Dt=fin}', "");
    Expect(1, 65277, '\P{Is_Dt=fin}', "");
    Expect(0, 65277, '\P{^Is_Dt=fin}', "");
    Expect(1, 65276, '\p{Is_Dt=	-Fin}', "");
    Expect(0, 65276, '\p{^Is_Dt=	-Fin}', "");
    Expect(0, 65276, '\P{Is_Dt=	-Fin}', "");
    Expect(1, 65276, '\P{^Is_Dt=	-Fin}', "");
    Expect(0, 65277, '\p{Is_Dt=	-Fin}', "");
    Expect(1, 65277, '\p{^Is_Dt=	-Fin}', "");
    Expect(1, 65277, '\P{Is_Dt=	-Fin}', "");
    Expect(0, 65277, '\P{^Is_Dt=	-Fin}', "");
    Error('\p{Decomposition_Type=_/a/font}');
    Error('\P{Decomposition_Type=_/a/font}');
    Expect(1, 130041, '\p{Decomposition_Type=:\AFont\z:}', "");;
    Expect(0, 130042, '\p{Decomposition_Type=:\AFont\z:}', "");;
    Expect(1, 130041, '\p{Decomposition_Type=font}', "");
    Expect(0, 130041, '\p{^Decomposition_Type=font}', "");
    Expect(0, 130041, '\P{Decomposition_Type=font}', "");
    Expect(1, 130041, '\P{^Decomposition_Type=font}', "");
    Expect(0, 130042, '\p{Decomposition_Type=font}', "");
    Expect(1, 130042, '\p{^Decomposition_Type=font}', "");
    Expect(1, 130042, '\P{Decomposition_Type=font}', "");
    Expect(0, 130042, '\P{^Decomposition_Type=font}', "");
    Expect(1, 130041, '\p{Decomposition_Type=:\Afont\z:}', "");;
    Expect(0, 130042, '\p{Decomposition_Type=:\Afont\z:}', "");;
    Expect(1, 130041, '\p{Decomposition_Type=	 Font}', "");
    Expect(0, 130041, '\p{^Decomposition_Type=	 Font}', "");
    Expect(0, 130041, '\P{Decomposition_Type=	 Font}', "");
    Expect(1, 130041, '\P{^Decomposition_Type=	 Font}', "");
    Expect(0, 130042, '\p{Decomposition_Type=	 Font}', "");
    Expect(1, 130042, '\p{^Decomposition_Type=	 Font}', "");
    Expect(1, 130042, '\P{Decomposition_Type=	 Font}', "");
    Expect(0, 130042, '\P{^Decomposition_Type=	 Font}', "");
    Error('\p{Dt=	font:=}');
    Error('\P{Dt=	font:=}');
    Expect(1, 130041, '\p{Dt=:\AFont\z:}', "");;
    Expect(0, 130042, '\p{Dt=:\AFont\z:}', "");;
    Expect(1, 130041, '\p{Dt=font}', "");
    Expect(0, 130041, '\p{^Dt=font}', "");
    Expect(0, 130041, '\P{Dt=font}', "");
    Expect(1, 130041, '\P{^Dt=font}', "");
    Expect(0, 130042, '\p{Dt=font}', "");
    Expect(1, 130042, '\p{^Dt=font}', "");
    Expect(1, 130042, '\P{Dt=font}', "");
    Expect(0, 130042, '\P{^Dt=font}', "");
    Expect(1, 130041, '\p{Dt=:\Afont\z:}', "");;
    Expect(0, 130042, '\p{Dt=:\Afont\z:}', "");;
    Expect(1, 130041, '\p{Dt:    -Font}', "");
    Expect(0, 130041, '\p{^Dt:    -Font}', "");
    Expect(0, 130041, '\P{Dt:    -Font}', "");
    Expect(1, 130041, '\P{^Dt:    -Font}', "");
    Expect(0, 130042, '\p{Dt:    -Font}', "");
    Expect(1, 130042, '\p{^Dt:    -Font}', "");
    Expect(1, 130042, '\P{Dt:    -Font}', "");
    Expect(0, 130042, '\P{^Dt:    -Font}', "");
    Error('\p{Is_Decomposition_Type= _font:=}');
    Error('\P{Is_Decomposition_Type= _font:=}');
    Expect(1, 130041, '\p{Is_Decomposition_Type=font}', "");
    Expect(0, 130041, '\p{^Is_Decomposition_Type=font}', "");
    Expect(0, 130041, '\P{Is_Decomposition_Type=font}', "");
    Expect(1, 130041, '\P{^Is_Decomposition_Type=font}', "");
    Expect(0, 130042, '\p{Is_Decomposition_Type=font}', "");
    Expect(1, 130042, '\p{^Is_Decomposition_Type=font}', "");
    Expect(1, 130042, '\P{Is_Decomposition_Type=font}', "");
    Expect(0, 130042, '\P{^Is_Decomposition_Type=font}', "");
    Expect(1, 130041, '\p{Is_Decomposition_Type=_Font}', "");
    Expect(0, 130041, '\p{^Is_Decomposition_Type=_Font}', "");
    Expect(0, 130041, '\P{Is_Decomposition_Type=_Font}', "");
    Expect(1, 130041, '\P{^Is_Decomposition_Type=_Font}', "");
    Expect(0, 130042, '\p{Is_Decomposition_Type=_Font}', "");
    Expect(1, 130042, '\p{^Is_Decomposition_Type=_Font}', "");
    Expect(1, 130042, '\P{Is_Decomposition_Type=_Font}', "");
    Expect(0, 130042, '\P{^Is_Decomposition_Type=_Font}', "");
    Error('\p{Is_Dt=-:=Font}');
    Error('\P{Is_Dt=-:=Font}');
    Expect(1, 130041, '\p{Is_Dt=font}', "");
    Expect(0, 130041, '\p{^Is_Dt=font}', "");
    Expect(0, 130041, '\P{Is_Dt=font}', "");
    Expect(1, 130041, '\P{^Is_Dt=font}', "");
    Expect(0, 130042, '\p{Is_Dt=font}', "");
    Expect(1, 130042, '\p{^Is_Dt=font}', "");
    Expect(1, 130042, '\P{Is_Dt=font}', "");
    Expect(0, 130042, '\P{^Is_Dt=font}', "");
    Expect(1, 130041, '\p{Is_Dt=_ Font}', "");
    Expect(0, 130041, '\p{^Is_Dt=_ Font}', "");
    Expect(0, 130041, '\P{Is_Dt=_ Font}', "");
    Expect(1, 130041, '\P{^Is_Dt=_ Font}', "");
    Expect(0, 130042, '\p{Is_Dt=_ Font}', "");
    Expect(1, 130042, '\p{^Is_Dt=_ Font}', "");
    Expect(1, 130042, '\P{Is_Dt=_ Font}', "");
    Expect(0, 130042, '\P{^Is_Dt=_ Font}', "");
    Error('\p{Decomposition_Type=/a/-_fraction}');
    Error('\P{Decomposition_Type=/a/-_fraction}');
    Expect(1, 8585, '\p{Decomposition_Type=:\AFraction\z:}', "");;
    Expect(0, 8586, '\p{Decomposition_Type=:\AFraction\z:}', "");;
    Expect(1, 8585, '\p{Decomposition_Type=fraction}', "");
    Expect(0, 8585, '\p{^Decomposition_Type=fraction}', "");
    Expect(0, 8585, '\P{Decomposition_Type=fraction}', "");
    Expect(1, 8585, '\P{^Decomposition_Type=fraction}', "");
    Expect(0, 8586, '\p{Decomposition_Type=fraction}', "");
    Expect(1, 8586, '\p{^Decomposition_Type=fraction}', "");
    Expect(1, 8586, '\P{Decomposition_Type=fraction}', "");
    Expect(0, 8586, '\P{^Decomposition_Type=fraction}', "");
    Expect(1, 8585, '\p{Decomposition_Type=:\Afraction\z:}', "");;
    Expect(0, 8586, '\p{Decomposition_Type=:\Afraction\z:}', "");;
    Expect(1, 8585, '\p{Decomposition_Type= Fraction}', "");
    Expect(0, 8585, '\p{^Decomposition_Type= Fraction}', "");
    Expect(0, 8585, '\P{Decomposition_Type= Fraction}', "");
    Expect(1, 8585, '\P{^Decomposition_Type= Fraction}', "");
    Expect(0, 8586, '\p{Decomposition_Type= Fraction}', "");
    Expect(1, 8586, '\p{^Decomposition_Type= Fraction}', "");
    Expect(1, 8586, '\P{Decomposition_Type= Fraction}', "");
    Expect(0, 8586, '\P{^Decomposition_Type= Fraction}', "");
    Error('\p{Dt=/a/_fra}');
    Error('\P{Dt=/a/_fra}');
    Expect(1, 8585, '\p{Dt=:\AFra\z:}', "");;
    Expect(0, 8586, '\p{Dt=:\AFra\z:}', "");;
    Expect(1, 8585, '\p{Dt=fra}', "");
    Expect(0, 8585, '\p{^Dt=fra}', "");
    Expect(0, 8585, '\P{Dt=fra}', "");
    Expect(1, 8585, '\P{^Dt=fra}', "");
    Expect(0, 8586, '\p{Dt=fra}', "");
    Expect(1, 8586, '\p{^Dt=fra}', "");
    Expect(1, 8586, '\P{Dt=fra}', "");
    Expect(0, 8586, '\P{^Dt=fra}', "");
    Expect(1, 8585, '\p{Dt=:\Afra\z:}', "");;
    Expect(0, 8586, '\p{Dt=:\Afra\z:}', "");;
    Expect(1, 8585, '\p{Dt=	Fra}', "");
    Expect(0, 8585, '\p{^Dt=	Fra}', "");
    Expect(0, 8585, '\P{Dt=	Fra}', "");
    Expect(1, 8585, '\P{^Dt=	Fra}', "");
    Expect(0, 8586, '\p{Dt=	Fra}', "");
    Expect(1, 8586, '\p{^Dt=	Fra}', "");
    Expect(1, 8586, '\P{Dt=	Fra}', "");
    Expect(0, 8586, '\P{^Dt=	Fra}', "");
    Error('\p{Is_Decomposition_Type=:=	_Fraction}');
    Error('\P{Is_Decomposition_Type=:=	_Fraction}');
    Expect(1, 8585, '\p{Is_Decomposition_Type=fraction}', "");
    Expect(0, 8585, '\p{^Is_Decomposition_Type=fraction}', "");
    Expect(0, 8585, '\P{Is_Decomposition_Type=fraction}', "");
    Expect(1, 8585, '\P{^Is_Decomposition_Type=fraction}', "");
    Expect(0, 8586, '\p{Is_Decomposition_Type=fraction}', "");
    Expect(1, 8586, '\p{^Is_Decomposition_Type=fraction}', "");
    Expect(1, 8586, '\P{Is_Decomposition_Type=fraction}', "");
    Expect(0, 8586, '\P{^Is_Decomposition_Type=fraction}', "");
    Expect(1, 8585, '\p{Is_Decomposition_Type:		 fraction}', "");
    Expect(0, 8585, '\p{^Is_Decomposition_Type:		 fraction}', "");
    Expect(0, 8585, '\P{Is_Decomposition_Type:		 fraction}', "");
    Expect(1, 8585, '\P{^Is_Decomposition_Type:		 fraction}', "");
    Expect(0, 8586, '\p{Is_Decomposition_Type:		 fraction}', "");
    Expect(1, 8586, '\p{^Is_Decomposition_Type:		 fraction}', "");
    Expect(1, 8586, '\P{Is_Decomposition_Type:		 fraction}', "");
    Expect(0, 8586, '\P{^Is_Decomposition_Type:		 fraction}', "");
    Error('\p{Is_Dt=/a/	fra}');
    Error('\P{Is_Dt=/a/	fra}');
    Expect(1, 8585, '\p{Is_Dt=fra}', "");
    Expect(0, 8585, '\p{^Is_Dt=fra}', "");
    Expect(0, 8585, '\P{Is_Dt=fra}', "");
    Expect(1, 8585, '\P{^Is_Dt=fra}', "");
    Expect(0, 8586, '\p{Is_Dt=fra}', "");
    Expect(1, 8586, '\p{^Is_Dt=fra}', "");
    Expect(1, 8586, '\P{Is_Dt=fra}', "");
    Expect(0, 8586, '\P{^Is_Dt=fra}', "");
    Expect(1, 8585, '\p{Is_Dt=_FRA}', "");
    Expect(0, 8585, '\p{^Is_Dt=_FRA}', "");
    Expect(0, 8585, '\P{Is_Dt=_FRA}', "");
    Expect(1, 8585, '\P{^Is_Dt=_FRA}', "");
    Expect(0, 8586, '\p{Is_Dt=_FRA}', "");
    Expect(1, 8586, '\p{^Is_Dt=_FRA}', "");
    Expect(1, 8586, '\P{Is_Dt=_FRA}', "");
    Expect(0, 8586, '\P{^Is_Dt=_FRA}', "");
    Error('\p{Decomposition_Type=/a/ INITIAL}');
    Error('\P{Decomposition_Type=/a/ INITIAL}');
    Expect(1, 65267, '\p{Decomposition_Type=:\AInitial\z:}', "");;
    Expect(0, 65268, '\p{Decomposition_Type=:\AInitial\z:}', "");;
    Expect(1, 65267, '\p{Decomposition_Type=initial}', "");
    Expect(0, 65267, '\p{^Decomposition_Type=initial}', "");
    Expect(0, 65267, '\P{Decomposition_Type=initial}', "");
    Expect(1, 65267, '\P{^Decomposition_Type=initial}', "");
    Expect(0, 65268, '\p{Decomposition_Type=initial}', "");
    Expect(1, 65268, '\p{^Decomposition_Type=initial}', "");
    Expect(1, 65268, '\P{Decomposition_Type=initial}', "");
    Expect(0, 65268, '\P{^Decomposition_Type=initial}', "");
    Expect(1, 65267, '\p{Decomposition_Type=:\Ainitial\z:}', "");;
    Expect(0, 65268, '\p{Decomposition_Type=:\Ainitial\z:}', "");;
    Expect(1, 65267, '\p{Decomposition_Type=	-INITIAL}', "");
    Expect(0, 65267, '\p{^Decomposition_Type=	-INITIAL}', "");
    Expect(0, 65267, '\P{Decomposition_Type=	-INITIAL}', "");
    Expect(1, 65267, '\P{^Decomposition_Type=	-INITIAL}', "");
    Expect(0, 65268, '\p{Decomposition_Type=	-INITIAL}', "");
    Expect(1, 65268, '\p{^Decomposition_Type=	-INITIAL}', "");
    Expect(1, 65268, '\P{Decomposition_Type=	-INITIAL}', "");
    Expect(0, 65268, '\P{^Decomposition_Type=	-INITIAL}', "");
    Error('\p{Dt= Init:=}');
    Error('\P{Dt= Init:=}');
    Expect(1, 65267, '\p{Dt=:\AInit\z:}', "");;
    Expect(0, 65268, '\p{Dt=:\AInit\z:}', "");;
    Expect(1, 65267, '\p{Dt=init}', "");
    Expect(0, 65267, '\p{^Dt=init}', "");
    Expect(0, 65267, '\P{Dt=init}', "");
    Expect(1, 65267, '\P{^Dt=init}', "");
    Expect(0, 65268, '\p{Dt=init}', "");
    Expect(1, 65268, '\p{^Dt=init}', "");
    Expect(1, 65268, '\P{Dt=init}', "");
    Expect(0, 65268, '\P{^Dt=init}', "");
    Expect(1, 65267, '\p{Dt=:\Ainit\z:}', "");;
    Expect(0, 65268, '\p{Dt=:\Ainit\z:}', "");;
    Expect(1, 65267, '\p{Dt= -Init}', "");
    Expect(0, 65267, '\p{^Dt= -Init}', "");
    Expect(0, 65267, '\P{Dt= -Init}', "");
    Expect(1, 65267, '\P{^Dt= -Init}', "");
    Expect(0, 65268, '\p{Dt= -Init}', "");
    Expect(1, 65268, '\p{^Dt= -Init}', "");
    Expect(1, 65268, '\P{Dt= -Init}', "");
    Expect(0, 65268, '\P{^Dt= -Init}', "");
    Error('\p{Is_Decomposition_Type=/a/		Initial}');
    Error('\P{Is_Decomposition_Type=/a/		Initial}');
    Expect(1, 65267, '\p{Is_Decomposition_Type=initial}', "");
    Expect(0, 65267, '\p{^Is_Decomposition_Type=initial}', "");
    Expect(0, 65267, '\P{Is_Decomposition_Type=initial}', "");
    Expect(1, 65267, '\P{^Is_Decomposition_Type=initial}', "");
    Expect(0, 65268, '\p{Is_Decomposition_Type=initial}', "");
    Expect(1, 65268, '\p{^Is_Decomposition_Type=initial}', "");
    Expect(1, 65268, '\P{Is_Decomposition_Type=initial}', "");
    Expect(0, 65268, '\P{^Is_Decomposition_Type=initial}', "");
    Expect(1, 65267, '\p{Is_Decomposition_Type=--Initial}', "");
    Expect(0, 65267, '\p{^Is_Decomposition_Type=--Initial}', "");
    Expect(0, 65267, '\P{Is_Decomposition_Type=--Initial}', "");
    Expect(1, 65267, '\P{^Is_Decomposition_Type=--Initial}', "");
    Expect(0, 65268, '\p{Is_Decomposition_Type=--Initial}', "");
    Expect(1, 65268, '\p{^Is_Decomposition_Type=--Initial}', "");
    Expect(1, 65268, '\P{Is_Decomposition_Type=--Initial}', "");
    Expect(0, 65268, '\P{^Is_Decomposition_Type=--Initial}', "");
    Error('\p{Is_Dt=/a/  INIT}');
    Error('\P{Is_Dt=/a/  INIT}');
    Expect(1, 65267, '\p{Is_Dt=init}', "");
    Expect(0, 65267, '\p{^Is_Dt=init}', "");
    Expect(0, 65267, '\P{Is_Dt=init}', "");
    Expect(1, 65267, '\P{^Is_Dt=init}', "");
    Expect(0, 65268, '\p{Is_Dt=init}', "");
    Expect(1, 65268, '\p{^Is_Dt=init}', "");
    Expect(1, 65268, '\P{Is_Dt=init}', "");
    Expect(0, 65268, '\P{^Is_Dt=init}', "");
    Expect(1, 65267, '\p{Is_Dt=	-init}', "");
    Expect(0, 65267, '\p{^Is_Dt=	-init}', "");
    Expect(0, 65267, '\P{Is_Dt=	-init}', "");
    Expect(1, 65267, '\P{^Is_Dt=	-init}', "");
    Expect(0, 65268, '\p{Is_Dt=	-init}', "");
    Expect(1, 65268, '\p{^Is_Dt=	-init}', "");
    Expect(1, 65268, '\P{Is_Dt=	-init}', "");
    Expect(0, 65268, '\P{^Is_Dt=	-init}', "");
    Error('\p{Decomposition_Type=ISOLATED:=}');
    Error('\P{Decomposition_Type=ISOLATED:=}');
    Expect(1, 65275, '\p{Decomposition_Type=:\AIsolated\z:}', "");;
    Expect(0, 65276, '\p{Decomposition_Type=:\AIsolated\z:}', "");;
    Expect(1, 65275, '\p{Decomposition_Type:	isolated}', "");
    Expect(0, 65275, '\p{^Decomposition_Type:	isolated}', "");
    Expect(0, 65275, '\P{Decomposition_Type:	isolated}', "");
    Expect(1, 65275, '\P{^Decomposition_Type:	isolated}', "");
    Expect(0, 65276, '\p{Decomposition_Type:	isolated}', "");
    Expect(1, 65276, '\p{^Decomposition_Type:	isolated}', "");
    Expect(1, 65276, '\P{Decomposition_Type:	isolated}', "");
    Expect(0, 65276, '\P{^Decomposition_Type:	isolated}', "");
    Expect(1, 65275, '\p{Decomposition_Type=:\Aisolated\z:}', "");;
    Expect(0, 65276, '\p{Decomposition_Type=:\Aisolated\z:}', "");;
    Expect(1, 65275, '\p{Decomposition_Type=	Isolated}', "");
    Expect(0, 65275, '\p{^Decomposition_Type=	Isolated}', "");
    Expect(0, 65275, '\P{Decomposition_Type=	Isolated}', "");
    Expect(1, 65275, '\P{^Decomposition_Type=	Isolated}', "");
    Expect(0, 65276, '\p{Decomposition_Type=	Isolated}', "");
    Expect(1, 65276, '\p{^Decomposition_Type=	Isolated}', "");
    Expect(1, 65276, '\P{Decomposition_Type=	Isolated}', "");
    Expect(0, 65276, '\P{^Decomposition_Type=	Isolated}', "");
    Error('\p{Dt=/a/_iso}');
    Error('\P{Dt=/a/_iso}');
    Expect(1, 65275, '\p{Dt=:\AIso\z:}', "");;
    Expect(0, 65276, '\p{Dt=:\AIso\z:}', "");;
    Expect(1, 65275, '\p{Dt=iso}', "");
    Expect(0, 65275, '\p{^Dt=iso}', "");
    Expect(0, 65275, '\P{Dt=iso}', "");
    Expect(1, 65275, '\P{^Dt=iso}', "");
    Expect(0, 65276, '\p{Dt=iso}', "");
    Expect(1, 65276, '\p{^Dt=iso}', "");
    Expect(1, 65276, '\P{Dt=iso}', "");
    Expect(0, 65276, '\P{^Dt=iso}', "");
    Expect(1, 65275, '\p{Dt=:\Aiso\z:}', "");;
    Expect(0, 65276, '\p{Dt=:\Aiso\z:}', "");;
    Expect(1, 65275, '\p{Dt=--Iso}', "");
    Expect(0, 65275, '\p{^Dt=--Iso}', "");
    Expect(0, 65275, '\P{Dt=--Iso}', "");
    Expect(1, 65275, '\P{^Dt=--Iso}', "");
    Expect(0, 65276, '\p{Dt=--Iso}', "");
    Expect(1, 65276, '\p{^Dt=--Iso}', "");
    Expect(1, 65276, '\P{Dt=--Iso}', "");
    Expect(0, 65276, '\P{^Dt=--Iso}', "");
    Error('\p{Is_Decomposition_Type:   	-Isolated:=}');
    Error('\P{Is_Decomposition_Type:   	-Isolated:=}');
    Expect(1, 65275, '\p{Is_Decomposition_Type=isolated}', "");
    Expect(0, 65275, '\p{^Is_Decomposition_Type=isolated}', "");
    Expect(0, 65275, '\P{Is_Decomposition_Type=isolated}', "");
    Expect(1, 65275, '\P{^Is_Decomposition_Type=isolated}', "");
    Expect(0, 65276, '\p{Is_Decomposition_Type=isolated}', "");
    Expect(1, 65276, '\p{^Is_Decomposition_Type=isolated}', "");
    Expect(1, 65276, '\P{Is_Decomposition_Type=isolated}', "");
    Expect(0, 65276, '\P{^Is_Decomposition_Type=isolated}', "");
    Expect(1, 65275, '\p{Is_Decomposition_Type= isolated}', "");
    Expect(0, 65275, '\p{^Is_Decomposition_Type= isolated}', "");
    Expect(0, 65275, '\P{Is_Decomposition_Type= isolated}', "");
    Expect(1, 65275, '\P{^Is_Decomposition_Type= isolated}', "");
    Expect(0, 65276, '\p{Is_Decomposition_Type= isolated}', "");
    Expect(1, 65276, '\p{^Is_Decomposition_Type= isolated}', "");
    Expect(1, 65276, '\P{Is_Decomposition_Type= isolated}', "");
    Expect(0, 65276, '\P{^Is_Decomposition_Type= isolated}', "");
    Error('\p{Is_Dt:   -:=iso}');
    Error('\P{Is_Dt:   -:=iso}');
    Expect(1, 65275, '\p{Is_Dt=iso}', "");
    Expect(0, 65275, '\p{^Is_Dt=iso}', "");
    Expect(0, 65275, '\P{Is_Dt=iso}', "");
    Expect(1, 65275, '\P{^Is_Dt=iso}', "");
    Expect(0, 65276, '\p{Is_Dt=iso}', "");
    Expect(1, 65276, '\p{^Is_Dt=iso}', "");
    Expect(1, 65276, '\P{Is_Dt=iso}', "");
    Expect(0, 65276, '\P{^Is_Dt=iso}', "");
    Expect(1, 65275, '\p{Is_Dt=_ISO}', "");
    Expect(0, 65275, '\p{^Is_Dt=_ISO}', "");
    Expect(0, 65275, '\P{Is_Dt=_ISO}', "");
    Expect(1, 65275, '\P{^Is_Dt=_ISO}', "");
    Expect(0, 65276, '\p{Is_Dt=_ISO}', "");
    Expect(1, 65276, '\p{^Is_Dt=_ISO}', "");
    Expect(1, 65276, '\P{Is_Dt=_ISO}', "");
    Expect(0, 65276, '\P{^Is_Dt=_ISO}', "");
    Error('\p{Decomposition_Type= :=Medial}');
    Error('\P{Decomposition_Type= :=Medial}');
    Expect(1, 65268, '\p{Decomposition_Type=:\AMedial\z:}', "");;
    Expect(0, 65269, '\p{Decomposition_Type=:\AMedial\z:}', "");;
    Expect(1, 65268, '\p{Decomposition_Type=medial}', "");
    Expect(0, 65268, '\p{^Decomposition_Type=medial}', "");
    Expect(0, 65268, '\P{Decomposition_Type=medial}', "");
    Expect(1, 65268, '\P{^Decomposition_Type=medial}', "");
    Expect(0, 65269, '\p{Decomposition_Type=medial}', "");
    Expect(1, 65269, '\p{^Decomposition_Type=medial}', "");
    Expect(1, 65269, '\P{Decomposition_Type=medial}', "");
    Expect(0, 65269, '\P{^Decomposition_Type=medial}', "");
    Expect(1, 65268, '\p{Decomposition_Type=:\Amedial\z:}', "");;
    Expect(0, 65269, '\p{Decomposition_Type=:\Amedial\z:}', "");;
    Expect(1, 65268, '\p{Decomposition_Type=	-Medial}', "");
    Expect(0, 65268, '\p{^Decomposition_Type=	-Medial}', "");
    Expect(0, 65268, '\P{Decomposition_Type=	-Medial}', "");
    Expect(1, 65268, '\P{^Decomposition_Type=	-Medial}', "");
    Expect(0, 65269, '\p{Decomposition_Type=	-Medial}', "");
    Expect(1, 65269, '\p{^Decomposition_Type=	-Medial}', "");
    Expect(1, 65269, '\P{Decomposition_Type=	-Medial}', "");
    Expect(0, 65269, '\P{^Decomposition_Type=	-Medial}', "");
    Error('\p{Dt=/a/_ med}');
    Error('\P{Dt=/a/_ med}');
    Expect(1, 65268, '\p{Dt=:\AMed\z:}', "");;
    Expect(0, 65269, '\p{Dt=:\AMed\z:}', "");;
    Expect(1, 65268, '\p{Dt=med}', "");
    Expect(0, 65268, '\p{^Dt=med}', "");
    Expect(0, 65268, '\P{Dt=med}', "");
    Expect(1, 65268, '\P{^Dt=med}', "");
    Expect(0, 65269, '\p{Dt=med}', "");
    Expect(1, 65269, '\p{^Dt=med}', "");
    Expect(1, 65269, '\P{Dt=med}', "");
    Expect(0, 65269, '\P{^Dt=med}', "");
    Expect(1, 65268, '\p{Dt=:\Amed\z:}', "");;
    Expect(0, 65269, '\p{Dt=:\Amed\z:}', "");;
    Expect(1, 65268, '\p{Dt=_Med}', "");
    Expect(0, 65268, '\p{^Dt=_Med}', "");
    Expect(0, 65268, '\P{Dt=_Med}', "");
    Expect(1, 65268, '\P{^Dt=_Med}', "");
    Expect(0, 65269, '\p{Dt=_Med}', "");
    Expect(1, 65269, '\p{^Dt=_Med}', "");
    Expect(1, 65269, '\P{Dt=_Med}', "");
    Expect(0, 65269, '\P{^Dt=_Med}', "");
    Error('\p{Is_Decomposition_Type=	/a/medial}');
    Error('\P{Is_Decomposition_Type=	/a/medial}');
    Expect(1, 65268, '\p{Is_Decomposition_Type=medial}', "");
    Expect(0, 65268, '\p{^Is_Decomposition_Type=medial}', "");
    Expect(0, 65268, '\P{Is_Decomposition_Type=medial}', "");
    Expect(1, 65268, '\P{^Is_Decomposition_Type=medial}', "");
    Expect(0, 65269, '\p{Is_Decomposition_Type=medial}', "");
    Expect(1, 65269, '\p{^Is_Decomposition_Type=medial}', "");
    Expect(1, 65269, '\P{Is_Decomposition_Type=medial}', "");
    Expect(0, 65269, '\P{^Is_Decomposition_Type=medial}', "");
    Expect(1, 65268, '\p{Is_Decomposition_Type=  Medial}', "");
    Expect(0, 65268, '\p{^Is_Decomposition_Type=  Medial}', "");
    Expect(0, 65268, '\P{Is_Decomposition_Type=  Medial}', "");
    Expect(1, 65268, '\P{^Is_Decomposition_Type=  Medial}', "");
    Expect(0, 65269, '\p{Is_Decomposition_Type=  Medial}', "");
    Expect(1, 65269, '\p{^Is_Decomposition_Type=  Medial}', "");
    Expect(1, 65269, '\P{Is_Decomposition_Type=  Medial}', "");
    Expect(0, 65269, '\P{^Is_Decomposition_Type=  Medial}', "");
    Error('\p{Is_Dt=:=__Med}');
    Error('\P{Is_Dt=:=__Med}');
    Expect(1, 65268, '\p{Is_Dt=med}', "");
    Expect(0, 65268, '\p{^Is_Dt=med}', "");
    Expect(0, 65268, '\P{Is_Dt=med}', "");
    Expect(1, 65268, '\P{^Is_Dt=med}', "");
    Expect(0, 65269, '\p{Is_Dt=med}', "");
    Expect(1, 65269, '\p{^Is_Dt=med}', "");
    Expect(1, 65269, '\P{Is_Dt=med}', "");
    Expect(0, 65269, '\P{^Is_Dt=med}', "");
    Expect(1, 65268, '\p{Is_Dt:	 Med}', "");
    Expect(0, 65268, '\p{^Is_Dt:	 Med}', "");
    Expect(0, 65268, '\P{Is_Dt:	 Med}', "");
    Expect(1, 65268, '\P{^Is_Dt:	 Med}', "");
    Expect(0, 65269, '\p{Is_Dt:	 Med}', "");
    Expect(1, 65269, '\p{^Is_Dt:	 Med}', "");
    Expect(1, 65269, '\P{Is_Dt:	 Med}', "");
    Expect(0, 65269, '\P{^Is_Dt:	 Med}', "");
    Error('\p{Decomposition_Type=/a/-	Narrow}');
    Error('\P{Decomposition_Type=/a/-	Narrow}');
    Expect(1, 65518, '\p{Decomposition_Type=:\ANarrow\z:}', "");;
    Expect(0, 65519, '\p{Decomposition_Type=:\ANarrow\z:}', "");;
    Expect(1, 65518, '\p{Decomposition_Type=narrow}', "");
    Expect(0, 65518, '\p{^Decomposition_Type=narrow}', "");
    Expect(0, 65518, '\P{Decomposition_Type=narrow}', "");
    Expect(1, 65518, '\P{^Decomposition_Type=narrow}', "");
    Expect(0, 65519, '\p{Decomposition_Type=narrow}', "");
    Expect(1, 65519, '\p{^Decomposition_Type=narrow}', "");
    Expect(1, 65519, '\P{Decomposition_Type=narrow}', "");
    Expect(0, 65519, '\P{^Decomposition_Type=narrow}', "");
    Expect(1, 65518, '\p{Decomposition_Type=:\Anarrow\z:}', "");;
    Expect(0, 65519, '\p{Decomposition_Type=:\Anarrow\z:}', "");;
    Expect(1, 65518, '\p{Decomposition_Type=	narrow}', "");
    Expect(0, 65518, '\p{^Decomposition_Type=	narrow}', "");
    Expect(0, 65518, '\P{Decomposition_Type=	narrow}', "");
    Expect(1, 65518, '\P{^Decomposition_Type=	narrow}', "");
    Expect(0, 65519, '\p{Decomposition_Type=	narrow}', "");
    Expect(1, 65519, '\p{^Decomposition_Type=	narrow}', "");
    Expect(1, 65519, '\P{Decomposition_Type=	narrow}', "");
    Expect(0, 65519, '\P{^Decomposition_Type=	narrow}', "");
    Error('\p{Dt=:=Nar}');
    Error('\P{Dt=:=Nar}');
    Expect(1, 65518, '\p{Dt=:\ANar\z:}', "");;
    Expect(0, 65519, '\p{Dt=:\ANar\z:}', "");;
    Expect(1, 65518, '\p{Dt=nar}', "");
    Expect(0, 65518, '\p{^Dt=nar}', "");
    Expect(0, 65518, '\P{Dt=nar}', "");
    Expect(1, 65518, '\P{^Dt=nar}', "");
    Expect(0, 65519, '\p{Dt=nar}', "");
    Expect(1, 65519, '\p{^Dt=nar}', "");
    Expect(1, 65519, '\P{Dt=nar}', "");
    Expect(0, 65519, '\P{^Dt=nar}', "");
    Expect(1, 65518, '\p{Dt=:\Anar\z:}', "");;
    Expect(0, 65519, '\p{Dt=:\Anar\z:}', "");;
    Expect(1, 65518, '\p{Dt= nar}', "");
    Expect(0, 65518, '\p{^Dt= nar}', "");
    Expect(0, 65518, '\P{Dt= nar}', "");
    Expect(1, 65518, '\P{^Dt= nar}', "");
    Expect(0, 65519, '\p{Dt= nar}', "");
    Expect(1, 65519, '\p{^Dt= nar}', "");
    Expect(1, 65519, '\P{Dt= nar}', "");
    Expect(0, 65519, '\P{^Dt= nar}', "");
    Error('\p{Is_Decomposition_Type=:=__Narrow}');
    Error('\P{Is_Decomposition_Type=:=__Narrow}');
    Expect(1, 65518, '\p{Is_Decomposition_Type=narrow}', "");
    Expect(0, 65518, '\p{^Is_Decomposition_Type=narrow}', "");
    Expect(0, 65518, '\P{Is_Decomposition_Type=narrow}', "");
    Expect(1, 65518, '\P{^Is_Decomposition_Type=narrow}', "");
    Expect(0, 65519, '\p{Is_Decomposition_Type=narrow}', "");
    Expect(1, 65519, '\p{^Is_Decomposition_Type=narrow}', "");
    Expect(1, 65519, '\P{Is_Decomposition_Type=narrow}', "");
    Expect(0, 65519, '\P{^Is_Decomposition_Type=narrow}', "");
    Expect(1, 65518, '\p{Is_Decomposition_Type:	_narrow}', "");
    Expect(0, 65518, '\p{^Is_Decomposition_Type:	_narrow}', "");
    Expect(0, 65518, '\P{Is_Decomposition_Type:	_narrow}', "");
    Expect(1, 65518, '\P{^Is_Decomposition_Type:	_narrow}', "");
    Expect(0, 65519, '\p{Is_Decomposition_Type:	_narrow}', "");
    Expect(1, 65519, '\p{^Is_Decomposition_Type:	_narrow}', "");
    Expect(1, 65519, '\P{Is_Decomposition_Type:	_narrow}', "");
    Expect(0, 65519, '\P{^Is_Decomposition_Type:	_narrow}', "");
    Error('\p{Is_Dt=/a/nar}');
    Error('\P{Is_Dt=/a/nar}');
    Expect(1, 65518, '\p{Is_Dt=nar}', "");
    Expect(0, 65518, '\p{^Is_Dt=nar}', "");
    Expect(0, 65518, '\P{Is_Dt=nar}', "");
    Expect(1, 65518, '\P{^Is_Dt=nar}', "");
    Expect(0, 65519, '\p{Is_Dt=nar}', "");
    Expect(1, 65519, '\p{^Is_Dt=nar}', "");
    Expect(1, 65519, '\P{Is_Dt=nar}', "");
    Expect(0, 65519, '\P{^Is_Dt=nar}', "");
    Expect(1, 65518, '\p{Is_Dt=	NAR}', "");
    Expect(0, 65518, '\p{^Is_Dt=	NAR}', "");
    Expect(0, 65518, '\P{Is_Dt=	NAR}', "");
    Expect(1, 65518, '\P{^Is_Dt=	NAR}', "");
    Expect(0, 65519, '\p{Is_Dt=	NAR}', "");
    Expect(1, 65519, '\p{^Is_Dt=	NAR}', "");
    Expect(1, 65519, '\P{Is_Dt=	NAR}', "");
    Expect(0, 65519, '\P{^Is_Dt=	NAR}', "");
    Error('\p{Decomposition_Type= Nobreak:=}');
    Error('\P{Decomposition_Type= Nobreak:=}');
    Expect(1, 8239, '\p{Decomposition_Type=:\ANobreak\z:}', "");;
    Expect(0, 8240, '\p{Decomposition_Type=:\ANobreak\z:}', "");;
    Expect(1, 8239, '\p{Decomposition_Type=nobreak}', "");
    Expect(0, 8239, '\p{^Decomposition_Type=nobreak}', "");
    Expect(0, 8239, '\P{Decomposition_Type=nobreak}', "");
    Expect(1, 8239, '\P{^Decomposition_Type=nobreak}', "");
    Expect(0, 8240, '\p{Decomposition_Type=nobreak}', "");
    Expect(1, 8240, '\p{^Decomposition_Type=nobreak}', "");
    Expect(1, 8240, '\P{Decomposition_Type=nobreak}', "");
    Expect(0, 8240, '\P{^Decomposition_Type=nobreak}', "");
    Expect(1, 8239, '\p{Decomposition_Type=:\Anobreak\z:}', "");;
    Expect(0, 8240, '\p{Decomposition_Type=:\Anobreak\z:}', "");;
    Expect(1, 8239, '\p{Decomposition_Type:   _nobreak}', "");
    Expect(0, 8239, '\p{^Decomposition_Type:   _nobreak}', "");
    Expect(0, 8239, '\P{Decomposition_Type:   _nobreak}', "");
    Expect(1, 8239, '\P{^Decomposition_Type:   _nobreak}', "");
    Expect(0, 8240, '\p{Decomposition_Type:   _nobreak}', "");
    Expect(1, 8240, '\p{^Decomposition_Type:   _nobreak}', "");
    Expect(1, 8240, '\P{Decomposition_Type:   _nobreak}', "");
    Expect(0, 8240, '\P{^Decomposition_Type:   _nobreak}', "");
    Error('\p{Dt=	-Nb:=}');
    Error('\P{Dt=	-Nb:=}');
    Expect(1, 8239, '\p{Dt=:\ANb\z:}', "");;
    Expect(0, 8240, '\p{Dt=:\ANb\z:}', "");;
    Expect(1, 8239, '\p{Dt=nb}', "");
    Expect(0, 8239, '\p{^Dt=nb}', "");
    Expect(0, 8239, '\P{Dt=nb}', "");
    Expect(1, 8239, '\P{^Dt=nb}', "");
    Expect(0, 8240, '\p{Dt=nb}', "");
    Expect(1, 8240, '\p{^Dt=nb}', "");
    Expect(1, 8240, '\P{Dt=nb}', "");
    Expect(0, 8240, '\P{^Dt=nb}', "");
    Expect(1, 8239, '\p{Dt=:\Anb\z:}', "");;
    Expect(0, 8240, '\p{Dt=:\Anb\z:}', "");;
    Expect(1, 8239, '\p{Dt=_	Nb}', "");
    Expect(0, 8239, '\p{^Dt=_	Nb}', "");
    Expect(0, 8239, '\P{Dt=_	Nb}', "");
    Expect(1, 8239, '\P{^Dt=_	Nb}', "");
    Expect(0, 8240, '\p{Dt=_	Nb}', "");
    Expect(1, 8240, '\p{^Dt=_	Nb}', "");
    Expect(1, 8240, '\P{Dt=_	Nb}', "");
    Expect(0, 8240, '\P{^Dt=_	Nb}', "");
    Error('\p{Is_Decomposition_Type=-/a/nobreak}');
    Error('\P{Is_Decomposition_Type=-/a/nobreak}');
    Expect(1, 8239, '\p{Is_Decomposition_Type=nobreak}', "");
    Expect(0, 8239, '\p{^Is_Decomposition_Type=nobreak}', "");
    Expect(0, 8239, '\P{Is_Decomposition_Type=nobreak}', "");
    Expect(1, 8239, '\P{^Is_Decomposition_Type=nobreak}', "");
    Expect(0, 8240, '\p{Is_Decomposition_Type=nobreak}', "");
    Expect(1, 8240, '\p{^Is_Decomposition_Type=nobreak}', "");
    Expect(1, 8240, '\P{Is_Decomposition_Type=nobreak}', "");
    Expect(0, 8240, '\P{^Is_Decomposition_Type=nobreak}', "");
    Expect(1, 8239, '\p{Is_Decomposition_Type:_ Nobreak}', "");
    Expect(0, 8239, '\p{^Is_Decomposition_Type:_ Nobreak}', "");
    Expect(0, 8239, '\P{Is_Decomposition_Type:_ Nobreak}', "");
    Expect(1, 8239, '\P{^Is_Decomposition_Type:_ Nobreak}', "");
    Expect(0, 8240, '\p{Is_Decomposition_Type:_ Nobreak}', "");
    Expect(1, 8240, '\p{^Is_Decomposition_Type:_ Nobreak}', "");
    Expect(1, 8240, '\P{Is_Decomposition_Type:_ Nobreak}', "");
    Expect(0, 8240, '\P{^Is_Decomposition_Type:_ Nobreak}', "");
    Error('\p{Is_Dt=_/a/nb}');
    Error('\P{Is_Dt=_/a/nb}');
    Expect(1, 8239, '\p{Is_Dt=nb}', "");
    Expect(0, 8239, '\p{^Is_Dt=nb}', "");
    Expect(0, 8239, '\P{Is_Dt=nb}', "");
    Expect(1, 8239, '\P{^Is_Dt=nb}', "");
    Expect(0, 8240, '\p{Is_Dt=nb}', "");
    Expect(1, 8240, '\p{^Is_Dt=nb}', "");
    Expect(1, 8240, '\P{Is_Dt=nb}', "");
    Expect(0, 8240, '\P{^Is_Dt=nb}', "");
    Expect(1, 8239, '\p{Is_Dt:	-Nb}', "");
    Expect(0, 8239, '\p{^Is_Dt:	-Nb}', "");
    Expect(0, 8239, '\P{Is_Dt:	-Nb}', "");
    Expect(1, 8239, '\P{^Is_Dt:	-Nb}', "");
    Expect(0, 8240, '\p{Is_Dt:	-Nb}', "");
    Expect(1, 8240, '\p{^Is_Dt:	-Nb}', "");
    Expect(1, 8240, '\P{Is_Dt:	-Nb}', "");
    Expect(0, 8240, '\P{^Is_Dt:	-Nb}', "");
    Error('\p{Decomposition_Type=- Non_Canonical:=}');
    Error('\P{Decomposition_Type=- Non_Canonical:=}');
    Expect(1, 130041, '\p{Decomposition_Type=:\ANon_Canonical\z:}', "");;
    Expect(0, 130042, '\p{Decomposition_Type=:\ANon_Canonical\z:}', "");;
    Expect(1, 130041, '\p{Decomposition_Type:noncanonical}', "");
    Expect(0, 130041, '\p{^Decomposition_Type:noncanonical}', "");
    Expect(0, 130041, '\P{Decomposition_Type:noncanonical}', "");
    Expect(1, 130041, '\P{^Decomposition_Type:noncanonical}', "");
    Expect(0, 130042, '\p{Decomposition_Type:noncanonical}', "");
    Expect(1, 130042, '\p{^Decomposition_Type:noncanonical}', "");
    Expect(1, 130042, '\P{Decomposition_Type:noncanonical}', "");
    Expect(0, 130042, '\P{^Decomposition_Type:noncanonical}', "");
    Expect(1, 130041, '\p{Decomposition_Type=:\Anoncanonical\z:}', "");;
    Expect(0, 130042, '\p{Decomposition_Type=:\Anoncanonical\z:}', "");;
    Expect(1, 130041, '\p{Decomposition_Type=_-Non_Canonical}', "");
    Expect(0, 130041, '\p{^Decomposition_Type=_-Non_Canonical}', "");
    Expect(0, 130041, '\P{Decomposition_Type=_-Non_Canonical}', "");
    Expect(1, 130041, '\P{^Decomposition_Type=_-Non_Canonical}', "");
    Expect(0, 130042, '\p{Decomposition_Type=_-Non_Canonical}', "");
    Expect(1, 130042, '\p{^Decomposition_Type=_-Non_Canonical}', "");
    Expect(1, 130042, '\P{Decomposition_Type=_-Non_Canonical}', "");
    Expect(0, 130042, '\P{^Decomposition_Type=_-Non_Canonical}', "");
    Error('\p{Dt:   _	Non_canon:=}');
    Error('\P{Dt:   _	Non_canon:=}');
    Expect(1, 130041, '\p{Dt=:\ANon_Canon\z:}', "");;
    Expect(0, 130042, '\p{Dt=:\ANon_Canon\z:}', "");;
    Expect(1, 130041, '\p{Dt=noncanon}', "");
    Expect(0, 130041, '\p{^Dt=noncanon}', "");
    Expect(0, 130041, '\P{Dt=noncanon}', "");
    Expect(1, 130041, '\P{^Dt=noncanon}', "");
    Expect(0, 130042, '\p{Dt=noncanon}', "");
    Expect(1, 130042, '\p{^Dt=noncanon}', "");
    Expect(1, 130042, '\P{Dt=noncanon}', "");
    Expect(0, 130042, '\P{^Dt=noncanon}', "");
    Expect(1, 130041, '\p{Dt=:\Anoncanon\z:}', "");;
    Expect(0, 130042, '\p{Dt=:\Anoncanon\z:}', "");;
    Expect(1, 130041, '\p{Dt: --NON_Canon}', "");
    Expect(0, 130041, '\p{^Dt: --NON_Canon}', "");
    Expect(0, 130041, '\P{Dt: --NON_Canon}', "");
    Expect(1, 130041, '\P{^Dt: --NON_Canon}', "");
    Expect(0, 130042, '\p{Dt: --NON_Canon}', "");
    Expect(1, 130042, '\p{^Dt: --NON_Canon}', "");
    Expect(1, 130042, '\P{Dt: --NON_Canon}', "");
    Expect(0, 130042, '\P{^Dt: --NON_Canon}', "");
    Error('\p{Is_Decomposition_Type= :=NON_Canonical}');
    Error('\P{Is_Decomposition_Type= :=NON_Canonical}');
    Expect(1, 130041, '\p{Is_Decomposition_Type=noncanonical}', "");
    Expect(0, 130041, '\p{^Is_Decomposition_Type=noncanonical}', "");
    Expect(0, 130041, '\P{Is_Decomposition_Type=noncanonical}', "");
    Expect(1, 130041, '\P{^Is_Decomposition_Type=noncanonical}', "");
    Expect(0, 130042, '\p{Is_Decomposition_Type=noncanonical}', "");
    Expect(1, 130042, '\p{^Is_Decomposition_Type=noncanonical}', "");
    Expect(1, 130042, '\P{Is_Decomposition_Type=noncanonical}', "");
    Expect(0, 130042, '\P{^Is_Decomposition_Type=noncanonical}', "");
    Expect(1, 130041, '\p{Is_Decomposition_Type=	Non_canonical}', "");
    Expect(0, 130041, '\p{^Is_Decomposition_Type=	Non_canonical}', "");
    Expect(0, 130041, '\P{Is_Decomposition_Type=	Non_canonical}', "");
    Expect(1, 130041, '\P{^Is_Decomposition_Type=	Non_canonical}', "");
    Expect(0, 130042, '\p{Is_Decomposition_Type=	Non_canonical}', "");
    Expect(1, 130042, '\p{^Is_Decomposition_Type=	Non_canonical}', "");
    Expect(1, 130042, '\P{Is_Decomposition_Type=	Non_canonical}', "");
    Expect(0, 130042, '\P{^Is_Decomposition_Type=	Non_canonical}', "");
    Error('\p{Is_Dt=_:=Non_Canon}');
    Error('\P{Is_Dt=_:=Non_Canon}');
    Expect(1, 130041, '\p{Is_Dt=noncanon}', "");
    Expect(0, 130041, '\p{^Is_Dt=noncanon}', "");
    Expect(0, 130041, '\P{Is_Dt=noncanon}', "");
    Expect(1, 130041, '\P{^Is_Dt=noncanon}', "");
    Expect(0, 130042, '\p{Is_Dt=noncanon}', "");
    Expect(1, 130042, '\p{^Is_Dt=noncanon}', "");
    Expect(1, 130042, '\P{Is_Dt=noncanon}', "");
    Expect(0, 130042, '\P{^Is_Dt=noncanon}', "");
    Expect(1, 130041, '\p{Is_Dt=	_non_CANON}', "");
    Expect(0, 130041, '\p{^Is_Dt=	_non_CANON}', "");
    Expect(0, 130041, '\P{Is_Dt=	_non_CANON}', "");
    Expect(1, 130041, '\P{^Is_Dt=	_non_CANON}', "");
    Expect(0, 130042, '\p{Is_Dt=	_non_CANON}', "");
    Expect(1, 130042, '\p{^Is_Dt=	_non_CANON}', "");
    Expect(1, 130042, '\P{Is_Dt=	_non_CANON}', "");
    Expect(0, 130042, '\P{^Is_Dt=	_non_CANON}', "");
    Error('\p{Decomposition_Type=:= _NONE}');
    Error('\P{Decomposition_Type=:= _NONE}');
    Expect(1, 195102, '\p{Decomposition_Type=:\ANone\z:}', "");;
    Expect(0, 195101, '\p{Decomposition_Type=:\ANone\z:}', "");;
    Expect(1, 195102, '\p{Decomposition_Type=none}', "");
    Expect(0, 195102, '\p{^Decomposition_Type=none}', "");
    Expect(0, 195102, '\P{Decomposition_Type=none}', "");
    Expect(1, 195102, '\P{^Decomposition_Type=none}', "");
    Expect(0, 195101, '\p{Decomposition_Type=none}', "");
    Expect(1, 195101, '\p{^Decomposition_Type=none}', "");
    Expect(1, 195101, '\P{Decomposition_Type=none}', "");
    Expect(0, 195101, '\P{^Decomposition_Type=none}', "");
    Expect(1, 195102, '\p{Decomposition_Type=:\Anone\z:}', "");;
    Expect(0, 195101, '\p{Decomposition_Type=:\Anone\z:}', "");;
    Expect(1, 195102, '\p{Decomposition_Type=	None}', "");
    Expect(0, 195102, '\p{^Decomposition_Type=	None}', "");
    Expect(0, 195102, '\P{Decomposition_Type=	None}', "");
    Expect(1, 195102, '\P{^Decomposition_Type=	None}', "");
    Expect(0, 195101, '\p{Decomposition_Type=	None}', "");
    Expect(1, 195101, '\p{^Decomposition_Type=	None}', "");
    Expect(1, 195101, '\P{Decomposition_Type=	None}', "");
    Expect(0, 195101, '\P{^Decomposition_Type=	None}', "");
    Error('\p{Dt=-_none/a/}');
    Error('\P{Dt=-_none/a/}');
    Expect(1, 195102, '\p{Dt=:\ANone\z:}', "");;
    Expect(0, 195101, '\p{Dt=:\ANone\z:}', "");;
    Expect(1, 195102, '\p{Dt=none}', "");
    Expect(0, 195102, '\p{^Dt=none}', "");
    Expect(0, 195102, '\P{Dt=none}', "");
    Expect(1, 195102, '\P{^Dt=none}', "");
    Expect(0, 195101, '\p{Dt=none}', "");
    Expect(1, 195101, '\p{^Dt=none}', "");
    Expect(1, 195101, '\P{Dt=none}', "");
    Expect(0, 195101, '\P{^Dt=none}', "");
    Expect(1, 195102, '\p{Dt=:\Anone\z:}', "");;
    Expect(0, 195101, '\p{Dt=:\Anone\z:}', "");;
    Expect(1, 195102, '\p{Dt=_NONE}', "");
    Expect(0, 195102, '\p{^Dt=_NONE}', "");
    Expect(0, 195102, '\P{Dt=_NONE}', "");
    Expect(1, 195102, '\P{^Dt=_NONE}', "");
    Expect(0, 195101, '\p{Dt=_NONE}', "");
    Expect(1, 195101, '\p{^Dt=_NONE}', "");
    Expect(1, 195101, '\P{Dt=_NONE}', "");
    Expect(0, 195101, '\P{^Dt=_NONE}', "");
    Error('\p{Is_Decomposition_Type=_:=NONE}');
    Error('\P{Is_Decomposition_Type=_:=NONE}');
    Expect(1, 195102, '\p{Is_Decomposition_Type=none}', "");
    Expect(0, 195102, '\p{^Is_Decomposition_Type=none}', "");
    Expect(0, 195102, '\P{Is_Decomposition_Type=none}', "");
    Expect(1, 195102, '\P{^Is_Decomposition_Type=none}', "");
    Expect(0, 195101, '\p{Is_Decomposition_Type=none}', "");
    Expect(1, 195101, '\p{^Is_Decomposition_Type=none}', "");
    Expect(1, 195101, '\P{Is_Decomposition_Type=none}', "");
    Expect(0, 195101, '\P{^Is_Decomposition_Type=none}', "");
    Expect(1, 195102, '\p{Is_Decomposition_Type=- NONE}', "");
    Expect(0, 195102, '\p{^Is_Decomposition_Type=- NONE}', "");
    Expect(0, 195102, '\P{Is_Decomposition_Type=- NONE}', "");
    Expect(1, 195102, '\P{^Is_Decomposition_Type=- NONE}', "");
    Expect(0, 195101, '\p{Is_Decomposition_Type=- NONE}', "");
    Expect(1, 195101, '\p{^Is_Decomposition_Type=- NONE}', "");
    Expect(1, 195101, '\P{Is_Decomposition_Type=- NONE}', "");
    Expect(0, 195101, '\P{^Is_Decomposition_Type=- NONE}', "");
    Error('\p{Is_Dt=-None/a/}');
    Error('\P{Is_Dt=-None/a/}');
    Expect(1, 195102, '\p{Is_Dt=none}', "");
    Expect(0, 195102, '\p{^Is_Dt=none}', "");
    Expect(0, 195102, '\P{Is_Dt=none}', "");
    Expect(1, 195102, '\P{^Is_Dt=none}', "");
    Expect(0, 195101, '\p{Is_Dt=none}', "");
    Expect(1, 195101, '\p{^Is_Dt=none}', "");
    Expect(1, 195101, '\P{Is_Dt=none}', "");
    Expect(0, 195101, '\P{^Is_Dt=none}', "");
    Expect(1, 195102, '\p{Is_Dt=	-None}', "");
    Expect(0, 195102, '\p{^Is_Dt=	-None}', "");
    Expect(0, 195102, '\P{Is_Dt=	-None}', "");
    Expect(1, 195102, '\P{^Is_Dt=	-None}', "");
    Expect(0, 195101, '\p{Is_Dt=	-None}', "");
    Expect(1, 195101, '\p{^Is_Dt=	-None}', "");
    Expect(1, 195101, '\P{Is_Dt=	-None}', "");
    Expect(0, 195101, '\P{^Is_Dt=	-None}', "");
    Error('\p{Decomposition_Type:    	SMALL/a/}');
    Error('\P{Decomposition_Type:    	SMALL/a/}');
    Expect(1, 65131, '\p{Decomposition_Type=:\ASmall\z:}', "");;
    Expect(0, 65132, '\p{Decomposition_Type=:\ASmall\z:}', "");;
    Expect(1, 65131, '\p{Decomposition_Type=small}', "");
    Expect(0, 65131, '\p{^Decomposition_Type=small}', "");
    Expect(0, 65131, '\P{Decomposition_Type=small}', "");
    Expect(1, 65131, '\P{^Decomposition_Type=small}', "");
    Expect(0, 65132, '\p{Decomposition_Type=small}', "");
    Expect(1, 65132, '\p{^Decomposition_Type=small}', "");
    Expect(1, 65132, '\P{Decomposition_Type=small}', "");
    Expect(0, 65132, '\P{^Decomposition_Type=small}', "");
    Expect(1, 65131, '\p{Decomposition_Type=:\Asmall\z:}', "");;
    Expect(0, 65132, '\p{Decomposition_Type=:\Asmall\z:}', "");;
    Expect(1, 65131, '\p{Decomposition_Type=	_SMALL}', "");
    Expect(0, 65131, '\p{^Decomposition_Type=	_SMALL}', "");
    Expect(0, 65131, '\P{Decomposition_Type=	_SMALL}', "");
    Expect(1, 65131, '\P{^Decomposition_Type=	_SMALL}', "");
    Expect(0, 65132, '\p{Decomposition_Type=	_SMALL}', "");
    Expect(1, 65132, '\p{^Decomposition_Type=	_SMALL}', "");
    Expect(1, 65132, '\P{Decomposition_Type=	_SMALL}', "");
    Expect(0, 65132, '\P{^Decomposition_Type=	_SMALL}', "");
    Error('\p{Dt= Sml/a/}');
    Error('\P{Dt= Sml/a/}');
    Expect(1, 65131, '\p{Dt=:\ASml\z:}', "");;
    Expect(0, 65132, '\p{Dt=:\ASml\z:}', "");;
    Expect(1, 65131, '\p{Dt=sml}', "");
    Expect(0, 65131, '\p{^Dt=sml}', "");
    Expect(0, 65131, '\P{Dt=sml}', "");
    Expect(1, 65131, '\P{^Dt=sml}', "");
    Expect(0, 65132, '\p{Dt=sml}', "");
    Expect(1, 65132, '\p{^Dt=sml}', "");
    Expect(1, 65132, '\P{Dt=sml}', "");
    Expect(0, 65132, '\P{^Dt=sml}', "");
    Expect(1, 65131, '\p{Dt=:\Asml\z:}', "");;
    Expect(0, 65132, '\p{Dt=:\Asml\z:}', "");;
    Error('\p{Is_Decomposition_Type=	SMALL/a/}');
    Error('\P{Is_Decomposition_Type=	SMALL/a/}');
    Expect(1, 65131, '\p{Is_Decomposition_Type=small}', "");
    Expect(0, 65131, '\p{^Is_Decomposition_Type=small}', "");
    Expect(0, 65131, '\P{Is_Decomposition_Type=small}', "");
    Expect(1, 65131, '\P{^Is_Decomposition_Type=small}', "");
    Expect(0, 65132, '\p{Is_Decomposition_Type=small}', "");
    Expect(1, 65132, '\p{^Is_Decomposition_Type=small}', "");
    Expect(1, 65132, '\P{Is_Decomposition_Type=small}', "");
    Expect(0, 65132, '\P{^Is_Decomposition_Type=small}', "");
    Expect(1, 65131, '\p{Is_Decomposition_Type=_small}', "");
    Expect(0, 65131, '\p{^Is_Decomposition_Type=_small}', "");
    Expect(0, 65131, '\P{Is_Decomposition_Type=_small}', "");
    Expect(1, 65131, '\P{^Is_Decomposition_Type=_small}', "");
    Expect(0, 65132, '\p{Is_Decomposition_Type=_small}', "");
    Expect(1, 65132, '\p{^Is_Decomposition_Type=_small}', "");
    Expect(1, 65132, '\P{Is_Decomposition_Type=_small}', "");
    Expect(0, 65132, '\P{^Is_Decomposition_Type=_small}', "");
    Error('\p{Is_Dt=/a/_-sml}');
    Error('\P{Is_Dt=/a/_-sml}');
    Expect(1, 65131, '\p{Is_Dt:sml}', "");
    Expect(0, 65131, '\p{^Is_Dt:sml}', "");
    Expect(0, 65131, '\P{Is_Dt:sml}', "");
    Expect(1, 65131, '\P{^Is_Dt:sml}', "");
    Expect(0, 65132, '\p{Is_Dt:sml}', "");
    Expect(1, 65132, '\p{^Is_Dt:sml}', "");
    Expect(1, 65132, '\P{Is_Dt:sml}', "");
    Expect(0, 65132, '\P{^Is_Dt:sml}', "");
    Expect(1, 65131, '\p{Is_Dt= -Sml}', "");
    Expect(0, 65131, '\p{^Is_Dt= -Sml}', "");
    Expect(0, 65131, '\P{Is_Dt= -Sml}', "");
    Expect(1, 65131, '\P{^Is_Dt= -Sml}', "");
    Expect(0, 65132, '\p{Is_Dt= -Sml}', "");
    Expect(1, 65132, '\p{^Is_Dt= -Sml}', "");
    Expect(1, 65132, '\P{Is_Dt= -Sml}', "");
    Expect(0, 65132, '\P{^Is_Dt= -Sml}', "");
    Error('\p{Decomposition_Type=-_Square/a/}');
    Error('\P{Decomposition_Type=-_Square/a/}');
    Expect(1, 127547, '\p{Decomposition_Type=:\ASquare\z:}', "");;
    Expect(0, 127548, '\p{Decomposition_Type=:\ASquare\z:}', "");;
    Expect(1, 127547, '\p{Decomposition_Type=square}', "");
    Expect(0, 127547, '\p{^Decomposition_Type=square}', "");
    Expect(0, 127547, '\P{Decomposition_Type=square}', "");
    Expect(1, 127547, '\P{^Decomposition_Type=square}', "");
    Expect(0, 127548, '\p{Decomposition_Type=square}', "");
    Expect(1, 127548, '\p{^Decomposition_Type=square}', "");
    Expect(1, 127548, '\P{Decomposition_Type=square}', "");
    Expect(0, 127548, '\P{^Decomposition_Type=square}', "");
    Expect(1, 127547, '\p{Decomposition_Type=:\Asquare\z:}', "");;
    Expect(0, 127548, '\p{Decomposition_Type=:\Asquare\z:}', "");;
    Expect(1, 127547, '\p{Decomposition_Type= 	Square}', "");
    Expect(0, 127547, '\p{^Decomposition_Type= 	Square}', "");
    Expect(0, 127547, '\P{Decomposition_Type= 	Square}', "");
    Expect(1, 127547, '\P{^Decomposition_Type= 	Square}', "");
    Expect(0, 127548, '\p{Decomposition_Type= 	Square}', "");
    Expect(1, 127548, '\p{^Decomposition_Type= 	Square}', "");
    Expect(1, 127548, '\P{Decomposition_Type= 	Square}', "");
    Expect(0, 127548, '\P{^Decomposition_Type= 	Square}', "");
    Error('\p{Dt=/a/-Sqr}');
    Error('\P{Dt=/a/-Sqr}');
    Expect(1, 127547, '\p{Dt=:\ASqr\z:}', "");;
    Expect(0, 127548, '\p{Dt=:\ASqr\z:}', "");;
    Expect(1, 127547, '\p{Dt=sqr}', "");
    Expect(0, 127547, '\p{^Dt=sqr}', "");
    Expect(0, 127547, '\P{Dt=sqr}', "");
    Expect(1, 127547, '\P{^Dt=sqr}', "");
    Expect(0, 127548, '\p{Dt=sqr}', "");
    Expect(1, 127548, '\p{^Dt=sqr}', "");
    Expect(1, 127548, '\P{Dt=sqr}', "");
    Expect(0, 127548, '\P{^Dt=sqr}', "");
    Expect(1, 127547, '\p{Dt=:\Asqr\z:}', "");;
    Expect(0, 127548, '\p{Dt=:\Asqr\z:}', "");;
    Expect(1, 127547, '\p{Dt=	Sqr}', "");
    Expect(0, 127547, '\p{^Dt=	Sqr}', "");
    Expect(0, 127547, '\P{Dt=	Sqr}', "");
    Expect(1, 127547, '\P{^Dt=	Sqr}', "");
    Expect(0, 127548, '\p{Dt=	Sqr}', "");
    Expect(1, 127548, '\p{^Dt=	Sqr}', "");
    Expect(1, 127548, '\P{Dt=	Sqr}', "");
    Expect(0, 127548, '\P{^Dt=	Sqr}', "");
    Error('\p{Is_Decomposition_Type:   /a/ 	SQUARE}');
    Error('\P{Is_Decomposition_Type:   /a/ 	SQUARE}');
    Expect(1, 127547, '\p{Is_Decomposition_Type=square}', "");
    Expect(0, 127547, '\p{^Is_Decomposition_Type=square}', "");
    Expect(0, 127547, '\P{Is_Decomposition_Type=square}', "");
    Expect(1, 127547, '\P{^Is_Decomposition_Type=square}', "");
    Expect(0, 127548, '\p{Is_Decomposition_Type=square}', "");
    Expect(1, 127548, '\p{^Is_Decomposition_Type=square}', "");
    Expect(1, 127548, '\P{Is_Decomposition_Type=square}', "");
    Expect(0, 127548, '\P{^Is_Decomposition_Type=square}', "");
    Expect(1, 127547, '\p{Is_Decomposition_Type= square}', "");
    Expect(0, 127547, '\p{^Is_Decomposition_Type= square}', "");
    Expect(0, 127547, '\P{Is_Decomposition_Type= square}', "");
    Expect(1, 127547, '\P{^Is_Decomposition_Type= square}', "");
    Expect(0, 127548, '\p{Is_Decomposition_Type= square}', "");
    Expect(1, 127548, '\p{^Is_Decomposition_Type= square}', "");
    Expect(1, 127548, '\P{Is_Decomposition_Type= square}', "");
    Expect(0, 127548, '\P{^Is_Decomposition_Type= square}', "");
    Error('\p{Is_Dt=:= SQR}');
    Error('\P{Is_Dt=:= SQR}');
    Expect(1, 127547, '\p{Is_Dt=sqr}', "");
    Expect(0, 127547, '\p{^Is_Dt=sqr}', "");
    Expect(0, 127547, '\P{Is_Dt=sqr}', "");
    Expect(1, 127547, '\P{^Is_Dt=sqr}', "");
    Expect(0, 127548, '\p{Is_Dt=sqr}', "");
    Expect(1, 127548, '\p{^Is_Dt=sqr}', "");
    Expect(1, 127548, '\P{Is_Dt=sqr}', "");
    Expect(0, 127548, '\P{^Is_Dt=sqr}', "");
    Expect(1, 127547, '\p{Is_Dt=	-SQR}', "");
    Expect(0, 127547, '\p{^Is_Dt=	-SQR}', "");
    Expect(0, 127547, '\P{Is_Dt=	-SQR}', "");
    Expect(1, 127547, '\P{^Is_Dt=	-SQR}', "");
    Expect(0, 127548, '\p{Is_Dt=	-SQR}', "");
    Expect(1, 127548, '\p{^Is_Dt=	-SQR}', "");
    Expect(1, 127548, '\P{Is_Dt=	-SQR}', "");
    Expect(0, 127548, '\P{^Is_Dt=	-SQR}', "");
    Error('\p{Decomposition_Type=/a/ SUB}');
    Error('\P{Decomposition_Type=/a/ SUB}');
    Expect(1, 122986, '\p{Decomposition_Type=:\ASub\z:}', "");;
    Expect(0, 122987, '\p{Decomposition_Type=:\ASub\z:}', "");;
    Expect(1, 122986, '\p{Decomposition_Type=sub}', "");
    Expect(0, 122986, '\p{^Decomposition_Type=sub}', "");
    Expect(0, 122986, '\P{Decomposition_Type=sub}', "");
    Expect(1, 122986, '\P{^Decomposition_Type=sub}', "");
    Expect(0, 122987, '\p{Decomposition_Type=sub}', "");
    Expect(1, 122987, '\p{^Decomposition_Type=sub}', "");
    Expect(1, 122987, '\P{Decomposition_Type=sub}', "");
    Expect(0, 122987, '\P{^Decomposition_Type=sub}', "");
    Expect(1, 122986, '\p{Decomposition_Type=:\Asub\z:}', "");;
    Expect(0, 122987, '\p{Decomposition_Type=:\Asub\z:}', "");;
    Expect(1, 122986, '\p{Decomposition_Type=-Sub}', "");
    Expect(0, 122986, '\p{^Decomposition_Type=-Sub}', "");
    Expect(0, 122986, '\P{Decomposition_Type=-Sub}', "");
    Expect(1, 122986, '\P{^Decomposition_Type=-Sub}', "");
    Expect(0, 122987, '\p{Decomposition_Type=-Sub}', "");
    Expect(1, 122987, '\p{^Decomposition_Type=-Sub}', "");
    Expect(1, 122987, '\P{Decomposition_Type=-Sub}', "");
    Expect(0, 122987, '\P{^Decomposition_Type=-Sub}', "");
    Error('\p{Dt: 	Sub/a/}');
    Error('\P{Dt: 	Sub/a/}');
    Expect(1, 122986, '\p{Dt=:\ASub\z:}', "");;
    Expect(0, 122987, '\p{Dt=:\ASub\z:}', "");;
    Expect(1, 122986, '\p{Dt=sub}', "");
    Expect(0, 122986, '\p{^Dt=sub}', "");
    Expect(0, 122986, '\P{Dt=sub}', "");
    Expect(1, 122986, '\P{^Dt=sub}', "");
    Expect(0, 122987, '\p{Dt=sub}', "");
    Expect(1, 122987, '\p{^Dt=sub}', "");
    Expect(1, 122987, '\P{Dt=sub}', "");
    Expect(0, 122987, '\P{^Dt=sub}', "");
    Expect(1, 122986, '\p{Dt=:\Asub\z:}', "");;
    Expect(0, 122987, '\p{Dt=:\Asub\z:}', "");;
    Expect(1, 122986, '\p{Dt:	sub}', "");
    Expect(0, 122986, '\p{^Dt:	sub}', "");
    Expect(0, 122986, '\P{Dt:	sub}', "");
    Expect(1, 122986, '\P{^Dt:	sub}', "");
    Expect(0, 122987, '\p{Dt:	sub}', "");
    Expect(1, 122987, '\p{^Dt:	sub}', "");
    Expect(1, 122987, '\P{Dt:	sub}', "");
    Expect(0, 122987, '\P{^Dt:	sub}', "");
    Error('\p{Is_Decomposition_Type=_/a/SUB}');
    Error('\P{Is_Decomposition_Type=_/a/SUB}');
    Expect(1, 122986, '\p{Is_Decomposition_Type=sub}', "");
    Expect(0, 122986, '\p{^Is_Decomposition_Type=sub}', "");
    Expect(0, 122986, '\P{Is_Decomposition_Type=sub}', "");
    Expect(1, 122986, '\P{^Is_Decomposition_Type=sub}', "");
    Expect(0, 122987, '\p{Is_Decomposition_Type=sub}', "");
    Expect(1, 122987, '\p{^Is_Decomposition_Type=sub}', "");
    Expect(1, 122987, '\P{Is_Decomposition_Type=sub}', "");
    Expect(0, 122987, '\P{^Is_Decomposition_Type=sub}', "");
    Expect(1, 122986, '\p{Is_Decomposition_Type=-Sub}', "");
    Expect(0, 122986, '\p{^Is_Decomposition_Type=-Sub}', "");
    Expect(0, 122986, '\P{Is_Decomposition_Type=-Sub}', "");
    Expect(1, 122986, '\P{^Is_Decomposition_Type=-Sub}', "");
    Expect(0, 122987, '\p{Is_Decomposition_Type=-Sub}', "");
    Expect(1, 122987, '\p{^Is_Decomposition_Type=-Sub}', "");
    Expect(1, 122987, '\P{Is_Decomposition_Type=-Sub}', "");
    Expect(0, 122987, '\P{^Is_Decomposition_Type=-Sub}', "");
    Error('\p{Is_Dt=/a/_Sub}');
    Error('\P{Is_Dt=/a/_Sub}');
    Expect(1, 122986, '\p{Is_Dt=sub}', "");
    Expect(0, 122986, '\p{^Is_Dt=sub}', "");
    Expect(0, 122986, '\P{Is_Dt=sub}', "");
    Expect(1, 122986, '\P{^Is_Dt=sub}', "");
    Expect(0, 122987, '\p{Is_Dt=sub}', "");
    Expect(1, 122987, '\p{^Is_Dt=sub}', "");
    Expect(1, 122987, '\P{Is_Dt=sub}', "");
    Expect(0, 122987, '\P{^Is_Dt=sub}', "");
    Expect(1, 122986, '\p{Is_Dt=		Sub}', "");
    Expect(0, 122986, '\p{^Is_Dt=		Sub}', "");
    Expect(0, 122986, '\P{Is_Dt=		Sub}', "");
    Expect(1, 122986, '\P{^Is_Dt=		Sub}', "");
    Expect(0, 122987, '\p{Is_Dt=		Sub}', "");
    Expect(1, 122987, '\p{^Is_Dt=		Sub}', "");
    Expect(1, 122987, '\P{Is_Dt=		Sub}', "");
    Expect(0, 122987, '\P{^Is_Dt=		Sub}', "");
    Error('\p{Decomposition_Type=-	super:=}');
    Error('\P{Decomposition_Type=-	super:=}');
    Expect(1, 127340, '\p{Decomposition_Type=:\ASuper\z:}', "");;
    Expect(0, 127341, '\p{Decomposition_Type=:\ASuper\z:}', "");;
    Expect(1, 127340, '\p{Decomposition_Type=super}', "");
    Expect(0, 127340, '\p{^Decomposition_Type=super}', "");
    Expect(0, 127340, '\P{Decomposition_Type=super}', "");
    Expect(1, 127340, '\P{^Decomposition_Type=super}', "");
    Expect(0, 127341, '\p{Decomposition_Type=super}', "");
    Expect(1, 127341, '\p{^Decomposition_Type=super}', "");
    Expect(1, 127341, '\P{Decomposition_Type=super}', "");
    Expect(0, 127341, '\P{^Decomposition_Type=super}', "");
    Expect(1, 127340, '\p{Decomposition_Type=:\Asuper\z:}', "");;
    Expect(0, 127341, '\p{Decomposition_Type=:\Asuper\z:}', "");;
    Expect(1, 127340, '\p{Decomposition_Type=__SUPER}', "");
    Expect(0, 127340, '\p{^Decomposition_Type=__SUPER}', "");
    Expect(0, 127340, '\P{Decomposition_Type=__SUPER}', "");
    Expect(1, 127340, '\P{^Decomposition_Type=__SUPER}', "");
    Expect(0, 127341, '\p{Decomposition_Type=__SUPER}', "");
    Expect(1, 127341, '\p{^Decomposition_Type=__SUPER}', "");
    Expect(1, 127341, '\P{Decomposition_Type=__SUPER}', "");
    Expect(0, 127341, '\P{^Decomposition_Type=__SUPER}', "");
    Error('\p{Dt=	sup/a/}');
    Error('\P{Dt=	sup/a/}');
    Expect(1, 127340, '\p{Dt=:\ASup\z:}', "");;
    Expect(0, 127341, '\p{Dt=:\ASup\z:}', "");;
    Expect(1, 127340, '\p{Dt=sup}', "");
    Expect(0, 127340, '\p{^Dt=sup}', "");
    Expect(0, 127340, '\P{Dt=sup}', "");
    Expect(1, 127340, '\P{^Dt=sup}', "");
    Expect(0, 127341, '\p{Dt=sup}', "");
    Expect(1, 127341, '\p{^Dt=sup}', "");
    Expect(1, 127341, '\P{Dt=sup}', "");
    Expect(0, 127341, '\P{^Dt=sup}', "");
    Expect(1, 127340, '\p{Dt=:\Asup\z:}', "");;
    Expect(0, 127341, '\p{Dt=:\Asup\z:}', "");;
    Expect(1, 127340, '\p{Dt=	_SUP}', "");
    Expect(0, 127340, '\p{^Dt=	_SUP}', "");
    Expect(0, 127340, '\P{Dt=	_SUP}', "");
    Expect(1, 127340, '\P{^Dt=	_SUP}', "");
    Expect(0, 127341, '\p{Dt=	_SUP}', "");
    Expect(1, 127341, '\p{^Dt=	_SUP}', "");
    Expect(1, 127341, '\P{Dt=	_SUP}', "");
    Expect(0, 127341, '\P{^Dt=	_SUP}', "");
    Error('\p{Is_Decomposition_Type=/a/-Super}');
    Error('\P{Is_Decomposition_Type=/a/-Super}');
    Expect(1, 127340, '\p{Is_Decomposition_Type=super}', "");
    Expect(0, 127340, '\p{^Is_Decomposition_Type=super}', "");
    Expect(0, 127340, '\P{Is_Decomposition_Type=super}', "");
    Expect(1, 127340, '\P{^Is_Decomposition_Type=super}', "");
    Expect(0, 127341, '\p{Is_Decomposition_Type=super}', "");
    Expect(1, 127341, '\p{^Is_Decomposition_Type=super}', "");
    Expect(1, 127341, '\P{Is_Decomposition_Type=super}', "");
    Expect(0, 127341, '\P{^Is_Decomposition_Type=super}', "");
    Expect(1, 127340, '\p{Is_Decomposition_Type=	_SUPER}', "");
    Expect(0, 127340, '\p{^Is_Decomposition_Type=	_SUPER}', "");
    Expect(0, 127340, '\P{Is_Decomposition_Type=	_SUPER}', "");
    Expect(1, 127340, '\P{^Is_Decomposition_Type=	_SUPER}', "");
    Expect(0, 127341, '\p{Is_Decomposition_Type=	_SUPER}', "");
    Expect(1, 127341, '\p{^Is_Decomposition_Type=	_SUPER}', "");
    Expect(1, 127341, '\P{Is_Decomposition_Type=	_SUPER}', "");
    Expect(0, 127341, '\P{^Is_Decomposition_Type=	_SUPER}', "");
    Error('\p{Is_Dt=	_sup:=}');
    Error('\P{Is_Dt=	_sup:=}');
    Expect(1, 127340, '\p{Is_Dt=sup}', "");
    Expect(0, 127340, '\p{^Is_Dt=sup}', "");
    Expect(0, 127340, '\P{Is_Dt=sup}', "");
    Expect(1, 127340, '\P{^Is_Dt=sup}', "");
    Expect(0, 127341, '\p{Is_Dt=sup}', "");
    Expect(1, 127341, '\p{^Is_Dt=sup}', "");
    Expect(1, 127341, '\P{Is_Dt=sup}', "");
    Expect(0, 127341, '\P{^Is_Dt=sup}', "");
    Expect(1, 127340, '\p{Is_Dt: 		Sup}', "");
    Expect(0, 127340, '\p{^Is_Dt: 		Sup}', "");
    Expect(0, 127340, '\P{Is_Dt: 		Sup}', "");
    Expect(1, 127340, '\P{^Is_Dt: 		Sup}', "");
    Expect(0, 127341, '\p{Is_Dt: 		Sup}', "");
    Expect(1, 127341, '\p{^Is_Dt: 		Sup}', "");
    Expect(1, 127341, '\P{Is_Dt: 		Sup}', "");
    Expect(0, 127341, '\P{^Is_Dt: 		Sup}', "");
    Error('\p{Decomposition_Type=	:=vertical}');
    Error('\P{Decomposition_Type=	:=vertical}');
    Expect(1, 65096, '\p{Decomposition_Type=:\AVertical\z:}', "");;
    Expect(0, 65097, '\p{Decomposition_Type=:\AVertical\z:}', "");;
    Expect(1, 65096, '\p{Decomposition_Type=vertical}', "");
    Expect(0, 65096, '\p{^Decomposition_Type=vertical}', "");
    Expect(0, 65096, '\P{Decomposition_Type=vertical}', "");
    Expect(1, 65096, '\P{^Decomposition_Type=vertical}', "");
    Expect(0, 65097, '\p{Decomposition_Type=vertical}', "");
    Expect(1, 65097, '\p{^Decomposition_Type=vertical}', "");
    Expect(1, 65097, '\P{Decomposition_Type=vertical}', "");
    Expect(0, 65097, '\P{^Decomposition_Type=vertical}', "");
    Expect(1, 65096, '\p{Decomposition_Type=:\Avertical\z:}', "");;
    Expect(0, 65097, '\p{Decomposition_Type=:\Avertical\z:}', "");;
    Expect(1, 65096, '\p{Decomposition_Type=	_vertical}', "");
    Expect(0, 65096, '\p{^Decomposition_Type=	_vertical}', "");
    Expect(0, 65096, '\P{Decomposition_Type=	_vertical}', "");
    Expect(1, 65096, '\P{^Decomposition_Type=	_vertical}', "");
    Expect(0, 65097, '\p{Decomposition_Type=	_vertical}', "");
    Expect(1, 65097, '\p{^Decomposition_Type=	_vertical}', "");
    Expect(1, 65097, '\P{Decomposition_Type=	_vertical}', "");
    Expect(0, 65097, '\P{^Decomposition_Type=	_vertical}', "");
    Error('\p{Dt=_/a/Vert}');
    Error('\P{Dt=_/a/Vert}');
    Expect(1, 65096, '\p{Dt=:\AVert\z:}', "");;
    Expect(0, 65097, '\p{Dt=:\AVert\z:}', "");;
    Expect(1, 65096, '\p{Dt=vert}', "");
    Expect(0, 65096, '\p{^Dt=vert}', "");
    Expect(0, 65096, '\P{Dt=vert}', "");
    Expect(1, 65096, '\P{^Dt=vert}', "");
    Expect(0, 65097, '\p{Dt=vert}', "");
    Expect(1, 65097, '\p{^Dt=vert}', "");
    Expect(1, 65097, '\P{Dt=vert}', "");
    Expect(0, 65097, '\P{^Dt=vert}', "");
    Expect(1, 65096, '\p{Dt=:\Avert\z:}', "");;
    Expect(0, 65097, '\p{Dt=:\Avert\z:}', "");;
    Expect(1, 65096, '\p{Dt=	vert}', "");
    Expect(0, 65096, '\p{^Dt=	vert}', "");
    Expect(0, 65096, '\P{Dt=	vert}', "");
    Expect(1, 65096, '\P{^Dt=	vert}', "");
    Expect(0, 65097, '\p{Dt=	vert}', "");
    Expect(1, 65097, '\p{^Dt=	vert}', "");
    Expect(1, 65097, '\P{Dt=	vert}', "");
    Expect(0, 65097, '\P{^Dt=	vert}', "");
    Error('\p{Is_Decomposition_Type=_/a/vertical}');
    Error('\P{Is_Decomposition_Type=_/a/vertical}');
    Expect(1, 65096, '\p{Is_Decomposition_Type:	vertical}', "");
    Expect(0, 65096, '\p{^Is_Decomposition_Type:	vertical}', "");
    Expect(0, 65096, '\P{Is_Decomposition_Type:	vertical}', "");
    Expect(1, 65096, '\P{^Is_Decomposition_Type:	vertical}', "");
    Expect(0, 65097, '\p{Is_Decomposition_Type:	vertical}', "");
    Expect(1, 65097, '\p{^Is_Decomposition_Type:	vertical}', "");
    Expect(1, 65097, '\P{Is_Decomposition_Type:	vertical}', "");
    Expect(0, 65097, '\P{^Is_Decomposition_Type:	vertical}', "");
    Expect(1, 65096, '\p{Is_Decomposition_Type=-_VERTICAL}', "");
    Expect(0, 65096, '\p{^Is_Decomposition_Type=-_VERTICAL}', "");
    Expect(0, 65096, '\P{Is_Decomposition_Type=-_VERTICAL}', "");
    Expect(1, 65096, '\P{^Is_Decomposition_Type=-_VERTICAL}', "");
    Expect(0, 65097, '\p{Is_Decomposition_Type=-_VERTICAL}', "");
    Expect(1, 65097, '\p{^Is_Decomposition_Type=-_VERTICAL}', "");
    Expect(1, 65097, '\P{Is_Decomposition_Type=-_VERTICAL}', "");
    Expect(0, 65097, '\P{^Is_Decomposition_Type=-_VERTICAL}', "");
    Error('\p{Is_Dt=:=	_VERT}');
    Error('\P{Is_Dt=:=	_VERT}');
    Expect(1, 65096, '\p{Is_Dt=vert}', "");
    Expect(0, 65096, '\p{^Is_Dt=vert}', "");
    Expect(0, 65096, '\P{Is_Dt=vert}', "");
    Expect(1, 65096, '\P{^Is_Dt=vert}', "");
    Expect(0, 65097, '\p{Is_Dt=vert}', "");
    Expect(1, 65097, '\p{^Is_Dt=vert}', "");
    Expect(1, 65097, '\P{Is_Dt=vert}', "");
    Expect(0, 65097, '\P{^Is_Dt=vert}', "");
    Expect(1, 65096, '\p{Is_Dt=_Vert}', "");
    Expect(0, 65096, '\p{^Is_Dt=_Vert}', "");
    Expect(0, 65096, '\P{Is_Dt=_Vert}', "");
    Expect(1, 65096, '\P{^Is_Dt=_Vert}', "");
    Expect(0, 65097, '\p{Is_Dt=_Vert}', "");
    Expect(1, 65097, '\p{^Is_Dt=_Vert}', "");
    Expect(1, 65097, '\P{Is_Dt=_Vert}', "");
    Expect(0, 65097, '\P{^Is_Dt=_Vert}', "");
    Error('\p{Decomposition_Type=:=  WIDE}');
    Error('\P{Decomposition_Type=:=  WIDE}');
    Expect(1, 65510, '\p{Decomposition_Type=:\AWide\z:}', "");;
    Expect(0, 65511, '\p{Decomposition_Type=:\AWide\z:}', "");;
    Expect(1, 65510, '\p{Decomposition_Type=wide}', "");
    Expect(0, 65510, '\p{^Decomposition_Type=wide}', "");
    Expect(0, 65510, '\P{Decomposition_Type=wide}', "");
    Expect(1, 65510, '\P{^Decomposition_Type=wide}', "");
    Expect(0, 65511, '\p{Decomposition_Type=wide}', "");
    Expect(1, 65511, '\p{^Decomposition_Type=wide}', "");
    Expect(1, 65511, '\P{Decomposition_Type=wide}', "");
    Expect(0, 65511, '\P{^Decomposition_Type=wide}', "");
    Expect(1, 65510, '\p{Decomposition_Type=:\Awide\z:}', "");;
    Expect(0, 65511, '\p{Decomposition_Type=:\Awide\z:}', "");;
    Expect(1, 65510, '\p{Decomposition_Type= -WIDE}', "");
    Expect(0, 65510, '\p{^Decomposition_Type= -WIDE}', "");
    Expect(0, 65510, '\P{Decomposition_Type= -WIDE}', "");
    Expect(1, 65510, '\P{^Decomposition_Type= -WIDE}', "");
    Expect(0, 65511, '\p{Decomposition_Type= -WIDE}', "");
    Expect(1, 65511, '\p{^Decomposition_Type= -WIDE}', "");
    Expect(1, 65511, '\P{Decomposition_Type= -WIDE}', "");
    Expect(0, 65511, '\P{^Decomposition_Type= -WIDE}', "");
    Error('\p{Dt=/a/	wide}');
    Error('\P{Dt=/a/	wide}');
    Expect(1, 65510, '\p{Dt=:\AWide\z:}', "");;
    Expect(0, 65511, '\p{Dt=:\AWide\z:}', "");;
    Expect(1, 65510, '\p{Dt=wide}', "");
    Expect(0, 65510, '\p{^Dt=wide}', "");
    Expect(0, 65510, '\P{Dt=wide}', "");
    Expect(1, 65510, '\P{^Dt=wide}', "");
    Expect(0, 65511, '\p{Dt=wide}', "");
    Expect(1, 65511, '\p{^Dt=wide}', "");
    Expect(1, 65511, '\P{Dt=wide}', "");
    Expect(0, 65511, '\P{^Dt=wide}', "");
    Expect(1, 65510, '\p{Dt=:\Awide\z:}', "");;
    Expect(0, 65511, '\p{Dt=:\Awide\z:}', "");;
    Expect(1, 65510, '\p{Dt= WIDE}', "");
    Expect(0, 65510, '\p{^Dt= WIDE}', "");
    Expect(0, 65510, '\P{Dt= WIDE}', "");
    Expect(1, 65510, '\P{^Dt= WIDE}', "");
    Expect(0, 65511, '\p{Dt= WIDE}', "");
    Expect(1, 65511, '\p{^Dt= WIDE}', "");
    Expect(1, 65511, '\P{Dt= WIDE}', "");
    Expect(0, 65511, '\P{^Dt= WIDE}', "");
    Error('\p{Is_Decomposition_Type=/a/_wide}');
    Error('\P{Is_Decomposition_Type=/a/_wide}');
    Expect(1, 65510, '\p{Is_Decomposition_Type=wide}', "");
    Expect(0, 65510, '\p{^Is_Decomposition_Type=wide}', "");
    Expect(0, 65510, '\P{Is_Decomposition_Type=wide}', "");
    Expect(1, 65510, '\P{^Is_Decomposition_Type=wide}', "");
    Expect(0, 65511, '\p{Is_Decomposition_Type=wide}', "");
    Expect(1, 65511, '\p{^Is_Decomposition_Type=wide}', "");
    Expect(1, 65511, '\P{Is_Decomposition_Type=wide}', "");
    Expect(0, 65511, '\P{^Is_Decomposition_Type=wide}', "");
    Expect(1, 65510, '\p{Is_Decomposition_Type= WIDE}', "");
    Expect(0, 65510, '\p{^Is_Decomposition_Type= WIDE}', "");
    Expect(0, 65510, '\P{Is_Decomposition_Type= WIDE}', "");
    Expect(1, 65510, '\P{^Is_Decomposition_Type= WIDE}', "");
    Expect(0, 65511, '\p{Is_Decomposition_Type= WIDE}', "");
    Expect(1, 65511, '\p{^Is_Decomposition_Type= WIDE}', "");
    Expect(1, 65511, '\P{Is_Decomposition_Type= WIDE}', "");
    Expect(0, 65511, '\P{^Is_Decomposition_Type= WIDE}', "");
    Error('\p{Is_Dt=:= Wide}');
    Error('\P{Is_Dt=:= Wide}');
    Expect(1, 65510, '\p{Is_Dt=wide}', "");
    Expect(0, 65510, '\p{^Is_Dt=wide}', "");
    Expect(0, 65510, '\P{Is_Dt=wide}', "");
    Expect(1, 65510, '\P{^Is_Dt=wide}', "");
    Expect(0, 65511, '\p{Is_Dt=wide}', "");
    Expect(1, 65511, '\p{^Is_Dt=wide}', "");
    Expect(1, 65511, '\P{Is_Dt=wide}', "");
    Expect(0, 65511, '\P{^Is_Dt=wide}', "");
    Expect(1, 65510, '\p{Is_Dt=_-Wide}', "");
    Expect(0, 65510, '\p{^Is_Dt=_-Wide}', "");
    Expect(0, 65510, '\P{Is_Dt=_-Wide}', "");
    Expect(1, 65510, '\P{^Is_Dt=_-Wide}', "");
    Expect(0, 65511, '\p{Is_Dt=_-Wide}', "");
    Expect(1, 65511, '\p{^Is_Dt=_-Wide}', "");
    Expect(1, 65511, '\P{Is_Dt=_-Wide}', "");
    Expect(0, 65511, '\P{^Is_Dt=_-Wide}', "");
    Error('\p{eastasianwidth}');
    Error('\P{eastasianwidth}');
    Error('\p{ea}');
    Error('\P{ea}');
    Error('\p{East_Asian_Width=_-ambiguous:=}');
    Error('\P{East_Asian_Width=_-ambiguous:=}');
    Expect(1, 1114109, '\p{East_Asian_Width=:\AAmbiguous\z:}', "");;
    Expect(0, 918000, '\p{East_Asian_Width=:\AAmbiguous\z:}', "");;
    Expect(1, 1114109, '\p{East_Asian_Width=ambiguous}', "");
    Expect(0, 1114109, '\p{^East_Asian_Width=ambiguous}', "");
    Expect(0, 1114109, '\P{East_Asian_Width=ambiguous}', "");
    Expect(1, 1114109, '\P{^East_Asian_Width=ambiguous}', "");
    Expect(0, 918000, '\p{East_Asian_Width=ambiguous}', "");
    Expect(1, 918000, '\p{^East_Asian_Width=ambiguous}', "");
    Expect(1, 918000, '\P{East_Asian_Width=ambiguous}', "");
    Expect(0, 918000, '\P{^East_Asian_Width=ambiguous}', "");
    Expect(1, 1114109, '\p{East_Asian_Width=:\Aambiguous\z:}', "");;
    Expect(0, 918000, '\p{East_Asian_Width=:\Aambiguous\z:}', "");;
    Expect(1, 1114109, '\p{East_Asian_Width:	__AMBIGUOUS}', "");
    Expect(0, 1114109, '\p{^East_Asian_Width:	__AMBIGUOUS}', "");
    Expect(0, 1114109, '\P{East_Asian_Width:	__AMBIGUOUS}', "");
    Expect(1, 1114109, '\P{^East_Asian_Width:	__AMBIGUOUS}', "");
    Expect(0, 918000, '\p{East_Asian_Width:	__AMBIGUOUS}', "");
    Expect(1, 918000, '\p{^East_Asian_Width:	__AMBIGUOUS}', "");
    Expect(1, 918000, '\P{East_Asian_Width:	__AMBIGUOUS}', "");
    Expect(0, 918000, '\P{^East_Asian_Width:	__AMBIGUOUS}', "");
    Error('\p{Ea=_/a/A}');
    Error('\P{Ea=_/a/A}');
    Expect(1, 1114109, '\p{Ea=:\AA\z:}', "");;
    Expect(0, 918000, '\p{Ea=:\AA\z:}', "");;
    Expect(1, 1114109, '\p{Ea=a}', "");
    Expect(0, 1114109, '\p{^Ea=a}', "");
    Expect(0, 1114109, '\P{Ea=a}', "");
    Expect(1, 1114109, '\P{^Ea=a}', "");
    Expect(0, 918000, '\p{Ea=a}', "");
    Expect(1, 918000, '\p{^Ea=a}', "");
    Expect(1, 918000, '\P{Ea=a}', "");
    Expect(0, 918000, '\P{^Ea=a}', "");
    Expect(1, 1114109, '\p{Ea=:\Aa\z:}', "");;
    Expect(0, 918000, '\p{Ea=:\Aa\z:}', "");;
    Expect(1, 1114109, '\p{Ea: 	a}', "");
    Expect(0, 1114109, '\p{^Ea: 	a}', "");
    Expect(0, 1114109, '\P{Ea: 	a}', "");
    Expect(1, 1114109, '\P{^Ea: 	a}', "");
    Expect(0, 918000, '\p{Ea: 	a}', "");
    Expect(1, 918000, '\p{^Ea: 	a}', "");
    Expect(1, 918000, '\P{Ea: 	a}', "");
    Expect(0, 918000, '\P{^Ea: 	a}', "");
    Error('\p{Is_East_Asian_Width=/a/_Ambiguous}');
    Error('\P{Is_East_Asian_Width=/a/_Ambiguous}');
    Expect(1, 1114109, '\p{Is_East_Asian_Width=ambiguous}', "");
    Expect(0, 1114109, '\p{^Is_East_Asian_Width=ambiguous}', "");
    Expect(0, 1114109, '\P{Is_East_Asian_Width=ambiguous}', "");
    Expect(1, 1114109, '\P{^Is_East_Asian_Width=ambiguous}', "");
    Expect(0, 918000, '\p{Is_East_Asian_Width=ambiguous}', "");
    Expect(1, 918000, '\p{^Is_East_Asian_Width=ambiguous}', "");
    Expect(1, 918000, '\P{Is_East_Asian_Width=ambiguous}', "");
    Expect(0, 918000, '\P{^Is_East_Asian_Width=ambiguous}', "");
    Expect(1, 1114109, '\p{Is_East_Asian_Width=--Ambiguous}', "");
    Expect(0, 1114109, '\p{^Is_East_Asian_Width=--Ambiguous}', "");
    Expect(0, 1114109, '\P{Is_East_Asian_Width=--Ambiguous}', "");
    Expect(1, 1114109, '\P{^Is_East_Asian_Width=--Ambiguous}', "");
    Expect(0, 918000, '\p{Is_East_Asian_Width=--Ambiguous}', "");
    Expect(1, 918000, '\p{^Is_East_Asian_Width=--Ambiguous}', "");
    Expect(1, 918000, '\P{Is_East_Asian_Width=--Ambiguous}', "");
    Expect(0, 918000, '\P{^Is_East_Asian_Width=--Ambiguous}', "");
    Error('\p{Is_Ea=:=--A}');
    Error('\P{Is_Ea=:=--A}');
    Expect(1, 1114109, '\p{Is_Ea=a}', "");
    Expect(0, 1114109, '\p{^Is_Ea=a}', "");
    Expect(0, 1114109, '\P{Is_Ea=a}', "");
    Expect(1, 1114109, '\P{^Is_Ea=a}', "");
    Expect(0, 918000, '\p{Is_Ea=a}', "");
    Expect(1, 918000, '\p{^Is_Ea=a}', "");
    Expect(1, 918000, '\P{Is_Ea=a}', "");
    Expect(0, 918000, '\P{^Is_Ea=a}', "");
    Expect(1, 1114109, '\p{Is_Ea=_ A}', "");
    Expect(0, 1114109, '\p{^Is_Ea=_ A}', "");
    Expect(0, 1114109, '\P{Is_Ea=_ A}', "");
    Expect(1, 1114109, '\P{^Is_Ea=_ A}', "");
    Expect(0, 918000, '\p{Is_Ea=_ A}', "");
    Expect(1, 918000, '\p{^Is_Ea=_ A}', "");
    Expect(1, 918000, '\P{Is_Ea=_ A}', "");
    Expect(0, 918000, '\P{^Is_Ea=_ A}', "");
    Error('\p{East_Asian_Width=:= 	Fullwidth}');
    Error('\P{East_Asian_Width=:= 	Fullwidth}');
    Expect(1, 65510, '\p{East_Asian_Width=:\AFullwidth\z:}', "");;
    Expect(0, 65511, '\p{East_Asian_Width=:\AFullwidth\z:}', "");;
    Expect(1, 65510, '\p{East_Asian_Width=fullwidth}', "");
    Expect(0, 65510, '\p{^East_Asian_Width=fullwidth}', "");
    Expect(0, 65510, '\P{East_Asian_Width=fullwidth}', "");
    Expect(1, 65510, '\P{^East_Asian_Width=fullwidth}', "");
    Expect(0, 65511, '\p{East_Asian_Width=fullwidth}', "");
    Expect(1, 65511, '\p{^East_Asian_Width=fullwidth}', "");
    Expect(1, 65511, '\P{East_Asian_Width=fullwidth}', "");
    Expect(0, 65511, '\P{^East_Asian_Width=fullwidth}', "");
    Expect(1, 65510, '\p{East_Asian_Width=:\Afullwidth\z:}', "");;
    Expect(0, 65511, '\p{East_Asian_Width=:\Afullwidth\z:}', "");;
    Expect(1, 65510, '\p{East_Asian_Width=_ FULLWIDTH}', "");
    Expect(0, 65510, '\p{^East_Asian_Width=_ FULLWIDTH}', "");
    Expect(0, 65510, '\P{East_Asian_Width=_ FULLWIDTH}', "");
    Expect(1, 65510, '\P{^East_Asian_Width=_ FULLWIDTH}', "");
    Expect(0, 65511, '\p{East_Asian_Width=_ FULLWIDTH}', "");
    Expect(1, 65511, '\p{^East_Asian_Width=_ FULLWIDTH}', "");
    Expect(1, 65511, '\P{East_Asian_Width=_ FULLWIDTH}', "");
    Expect(0, 65511, '\P{^East_Asian_Width=_ FULLWIDTH}', "");
    Error('\p{Ea=/a/-F}');
    Error('\P{Ea=/a/-F}');
    Expect(1, 65510, '\p{Ea=:\AF\z:}', "");;
    Expect(0, 65511, '\p{Ea=:\AF\z:}', "");;
    Expect(1, 65510, '\p{Ea:f}', "");
    Expect(0, 65510, '\p{^Ea:f}', "");
    Expect(0, 65510, '\P{Ea:f}', "");
    Expect(1, 65510, '\P{^Ea:f}', "");
    Expect(0, 65511, '\p{Ea:f}', "");
    Expect(1, 65511, '\p{^Ea:f}', "");
    Expect(1, 65511, '\P{Ea:f}', "");
    Expect(0, 65511, '\P{^Ea:f}', "");
    Expect(1, 65510, '\p{Ea=:\Af\z:}', "");;
    Expect(0, 65511, '\p{Ea=:\Af\z:}', "");;
    Expect(1, 65510, '\p{Ea=	 f}', "");
    Expect(0, 65510, '\p{^Ea=	 f}', "");
    Expect(0, 65510, '\P{Ea=	 f}', "");
    Expect(1, 65510, '\P{^Ea=	 f}', "");
    Expect(0, 65511, '\p{Ea=	 f}', "");
    Expect(1, 65511, '\p{^Ea=	 f}', "");
    Expect(1, 65511, '\P{Ea=	 f}', "");
    Expect(0, 65511, '\P{^Ea=	 f}', "");
    Error('\p{Is_East_Asian_Width:_-FULLWIDTH:=}');
    Error('\P{Is_East_Asian_Width:_-FULLWIDTH:=}');
    Expect(1, 65510, '\p{Is_East_Asian_Width=fullwidth}', "");
    Expect(0, 65510, '\p{^Is_East_Asian_Width=fullwidth}', "");
    Expect(0, 65510, '\P{Is_East_Asian_Width=fullwidth}', "");
    Expect(1, 65510, '\P{^Is_East_Asian_Width=fullwidth}', "");
    Expect(0, 65511, '\p{Is_East_Asian_Width=fullwidth}', "");
    Expect(1, 65511, '\p{^Is_East_Asian_Width=fullwidth}', "");
    Expect(1, 65511, '\P{Is_East_Asian_Width=fullwidth}', "");
    Expect(0, 65511, '\P{^Is_East_Asian_Width=fullwidth}', "");
    Expect(1, 65510, '\p{Is_East_Asian_Width=_Fullwidth}', "");
    Expect(0, 65510, '\p{^Is_East_Asian_Width=_Fullwidth}', "");
    Expect(0, 65510, '\P{Is_East_Asian_Width=_Fullwidth}', "");
    Expect(1, 65510, '\P{^Is_East_Asian_Width=_Fullwidth}', "");
    Expect(0, 65511, '\p{Is_East_Asian_Width=_Fullwidth}', "");
    Expect(1, 65511, '\p{^Is_East_Asian_Width=_Fullwidth}', "");
    Expect(1, 65511, '\P{Is_East_Asian_Width=_Fullwidth}', "");
    Expect(0, 65511, '\P{^Is_East_Asian_Width=_Fullwidth}', "");
    Error('\p{Is_Ea=-F:=}');
    Error('\P{Is_Ea=-F:=}');
    Expect(1, 65510, '\p{Is_Ea=f}', "");
    Expect(0, 65510, '\p{^Is_Ea=f}', "");
    Expect(0, 65510, '\P{Is_Ea=f}', "");
    Expect(1, 65510, '\P{^Is_Ea=f}', "");
    Expect(0, 65511, '\p{Is_Ea=f}', "");
    Expect(1, 65511, '\p{^Is_Ea=f}', "");
    Expect(1, 65511, '\P{Is_Ea=f}', "");
    Expect(0, 65511, '\P{^Is_Ea=f}', "");
    Expect(1, 65510, '\p{Is_Ea=-_F}', "");
    Expect(0, 65510, '\p{^Is_Ea=-_F}', "");
    Expect(0, 65510, '\P{Is_Ea=-_F}', "");
    Expect(1, 65510, '\P{^Is_Ea=-_F}', "");
    Expect(0, 65511, '\p{Is_Ea=-_F}', "");
    Expect(1, 65511, '\p{^Is_Ea=-_F}', "");
    Expect(1, 65511, '\P{Is_Ea=-_F}', "");
    Expect(0, 65511, '\P{^Is_Ea=-_F}', "");
    Error('\p{East_Asian_Width=:= _Halfwidth}');
    Error('\P{East_Asian_Width=:= _Halfwidth}');
    Expect(1, 65518, '\p{East_Asian_Width=:\AHalfwidth\z:}', "");;
    Expect(0, 65519, '\p{East_Asian_Width=:\AHalfwidth\z:}', "");;
    Expect(1, 65518, '\p{East_Asian_Width=halfwidth}', "");
    Expect(0, 65518, '\p{^East_Asian_Width=halfwidth}', "");
    Expect(0, 65518, '\P{East_Asian_Width=halfwidth}', "");
    Expect(1, 65518, '\P{^East_Asian_Width=halfwidth}', "");
    Expect(0, 65519, '\p{East_Asian_Width=halfwidth}', "");
    Expect(1, 65519, '\p{^East_Asian_Width=halfwidth}', "");
    Expect(1, 65519, '\P{East_Asian_Width=halfwidth}', "");
    Expect(0, 65519, '\P{^East_Asian_Width=halfwidth}', "");
    Expect(1, 65518, '\p{East_Asian_Width=:\Ahalfwidth\z:}', "");;
    Expect(0, 65519, '\p{East_Asian_Width=:\Ahalfwidth\z:}', "");;
    Expect(1, 65518, '\p{East_Asian_Width=--Halfwidth}', "");
    Expect(0, 65518, '\p{^East_Asian_Width=--Halfwidth}', "");
    Expect(0, 65518, '\P{East_Asian_Width=--Halfwidth}', "");
    Expect(1, 65518, '\P{^East_Asian_Width=--Halfwidth}', "");
    Expect(0, 65519, '\p{East_Asian_Width=--Halfwidth}', "");
    Expect(1, 65519, '\p{^East_Asian_Width=--Halfwidth}', "");
    Expect(1, 65519, '\P{East_Asian_Width=--Halfwidth}', "");
    Expect(0, 65519, '\P{^East_Asian_Width=--Halfwidth}', "");
    Error('\p{Ea=/a/ -h}');
    Error('\P{Ea=/a/ -h}');
    Expect(1, 65518, '\p{Ea=:\AH\z:}', "");;
    Expect(0, 65519, '\p{Ea=:\AH\z:}', "");;
    Expect(1, 65518, '\p{Ea=h}', "");
    Expect(0, 65518, '\p{^Ea=h}', "");
    Expect(0, 65518, '\P{Ea=h}', "");
    Expect(1, 65518, '\P{^Ea=h}', "");
    Expect(0, 65519, '\p{Ea=h}', "");
    Expect(1, 65519, '\p{^Ea=h}', "");
    Expect(1, 65519, '\P{Ea=h}', "");
    Expect(0, 65519, '\P{^Ea=h}', "");
    Expect(1, 65518, '\p{Ea=:\Ah\z:}', "");;
    Expect(0, 65519, '\p{Ea=:\Ah\z:}', "");;
    Expect(1, 65518, '\p{Ea=_	H}', "");
    Expect(0, 65518, '\p{^Ea=_	H}', "");
    Expect(0, 65518, '\P{Ea=_	H}', "");
    Expect(1, 65518, '\P{^Ea=_	H}', "");
    Expect(0, 65519, '\p{Ea=_	H}', "");
    Expect(1, 65519, '\p{^Ea=_	H}', "");
    Expect(1, 65519, '\P{Ea=_	H}', "");
    Expect(0, 65519, '\P{^Ea=_	H}', "");
    Error('\p{Is_East_Asian_Width=:=Halfwidth}');
    Error('\P{Is_East_Asian_Width=:=Halfwidth}');
    Expect(1, 65518, '\p{Is_East_Asian_Width=halfwidth}', "");
    Expect(0, 65518, '\p{^Is_East_Asian_Width=halfwidth}', "");
    Expect(0, 65518, '\P{Is_East_Asian_Width=halfwidth}', "");
    Expect(1, 65518, '\P{^Is_East_Asian_Width=halfwidth}', "");
    Expect(0, 65519, '\p{Is_East_Asian_Width=halfwidth}', "");
    Expect(1, 65519, '\p{^Is_East_Asian_Width=halfwidth}', "");
    Expect(1, 65519, '\P{Is_East_Asian_Width=halfwidth}', "");
    Expect(0, 65519, '\P{^Is_East_Asian_Width=halfwidth}', "");
    Expect(1, 65518, '\p{Is_East_Asian_Width= halfwidth}', "");
    Expect(0, 65518, '\p{^Is_East_Asian_Width= halfwidth}', "");
    Expect(0, 65518, '\P{Is_East_Asian_Width= halfwidth}', "");
    Expect(1, 65518, '\P{^Is_East_Asian_Width= halfwidth}', "");
    Expect(0, 65519, '\p{Is_East_Asian_Width= halfwidth}', "");
    Expect(1, 65519, '\p{^Is_East_Asian_Width= halfwidth}', "");
    Expect(1, 65519, '\P{Is_East_Asian_Width= halfwidth}', "");
    Expect(0, 65519, '\P{^Is_East_Asian_Width= halfwidth}', "");
    Error('\p{Is_Ea= h/a/}');
    Error('\P{Is_Ea= h/a/}');
    Expect(1, 65518, '\p{Is_Ea:h}', "");
    Expect(0, 65518, '\p{^Is_Ea:h}', "");
    Expect(0, 65518, '\P{Is_Ea:h}', "");
    Expect(1, 65518, '\P{^Is_Ea:h}', "");
    Expect(0, 65519, '\p{Is_Ea:h}', "");
    Expect(1, 65519, '\p{^Is_Ea:h}', "");
    Expect(1, 65519, '\P{Is_Ea:h}', "");
    Expect(0, 65519, '\P{^Is_Ea:h}', "");
    Expect(1, 65518, '\p{Is_Ea=_	H}', "");
    Expect(0, 65518, '\p{^Is_Ea=_	H}', "");
    Expect(0, 65518, '\P{Is_Ea=_	H}', "");
    Expect(1, 65518, '\P{^Is_Ea=_	H}', "");
    Expect(0, 65519, '\p{Is_Ea=_	H}', "");
    Expect(1, 65519, '\p{^Is_Ea=_	H}', "");
    Expect(1, 65519, '\P{Is_Ea=_	H}', "");
    Expect(0, 65519, '\P{^Is_Ea=_	H}', "");
    Error('\p{East_Asian_Width=-_neutral/a/}');
    Error('\P{East_Asian_Width=-_neutral/a/}');
    Expect(1, 918000, '\p{East_Asian_Width=:\ANeutral\z:}', "");;
    Expect(0, 1114109, '\p{East_Asian_Width=:\ANeutral\z:}', "");;
    Expect(1, 918000, '\p{East_Asian_Width=neutral}', "");
    Expect(0, 918000, '\p{^East_Asian_Width=neutral}', "");
    Expect(0, 918000, '\P{East_Asian_Width=neutral}', "");
    Expect(1, 918000, '\P{^East_Asian_Width=neutral}', "");
    Expect(0, 1114109, '\p{East_Asian_Width=neutral}', "");
    Expect(1, 1114109, '\p{^East_Asian_Width=neutral}', "");
    Expect(1, 1114109, '\P{East_Asian_Width=neutral}', "");
    Expect(0, 1114109, '\P{^East_Asian_Width=neutral}', "");
    Expect(1, 918000, '\p{East_Asian_Width=:\Aneutral\z:}', "");;
    Expect(0, 1114109, '\p{East_Asian_Width=:\Aneutral\z:}', "");;
    Expect(1, 918000, '\p{East_Asian_Width=	-Neutral}', "");
    Expect(0, 918000, '\p{^East_Asian_Width=	-Neutral}', "");
    Expect(0, 918000, '\P{East_Asian_Width=	-Neutral}', "");
    Expect(1, 918000, '\P{^East_Asian_Width=	-Neutral}', "");
    Expect(0, 1114109, '\p{East_Asian_Width=	-Neutral}', "");
    Expect(1, 1114109, '\p{^East_Asian_Width=	-Neutral}', "");
    Expect(1, 1114109, '\P{East_Asian_Width=	-Neutral}', "");
    Expect(0, 1114109, '\P{^East_Asian_Width=	-Neutral}', "");
    Error('\p{Ea=  n/a/}');
    Error('\P{Ea=  n/a/}');
    Expect(1, 918000, '\p{Ea=:\AN\z:}', "");;
    Expect(0, 1114109, '\p{Ea=:\AN\z:}', "");;
    Expect(1, 918000, '\p{Ea=n}', "");
    Expect(0, 918000, '\p{^Ea=n}', "");
    Expect(0, 918000, '\P{Ea=n}', "");
    Expect(1, 918000, '\P{^Ea=n}', "");
    Expect(0, 1114109, '\p{Ea=n}', "");
    Expect(1, 1114109, '\p{^Ea=n}', "");
    Expect(1, 1114109, '\P{Ea=n}', "");
    Expect(0, 1114109, '\P{^Ea=n}', "");
    Expect(1, 918000, '\p{Ea=:\An\z:}', "");;
    Expect(0, 1114109, '\p{Ea=:\An\z:}', "");;
    Expect(1, 918000, '\p{Ea=	_n}', "");
    Expect(0, 918000, '\p{^Ea=	_n}', "");
    Expect(0, 918000, '\P{Ea=	_n}', "");
    Expect(1, 918000, '\P{^Ea=	_n}', "");
    Expect(0, 1114109, '\p{Ea=	_n}', "");
    Expect(1, 1114109, '\p{^Ea=	_n}', "");
    Expect(1, 1114109, '\P{Ea=	_n}', "");
    Expect(0, 1114109, '\P{^Ea=	_n}', "");
    Error('\p{Is_East_Asian_Width=:= -NEUTRAL}');
    Error('\P{Is_East_Asian_Width=:= -NEUTRAL}');
    Expect(1, 918000, '\p{Is_East_Asian_Width=neutral}', "");
    Expect(0, 918000, '\p{^Is_East_Asian_Width=neutral}', "");
    Expect(0, 918000, '\P{Is_East_Asian_Width=neutral}', "");
    Expect(1, 918000, '\P{^Is_East_Asian_Width=neutral}', "");
    Expect(0, 1114109, '\p{Is_East_Asian_Width=neutral}', "");
    Expect(1, 1114109, '\p{^Is_East_Asian_Width=neutral}', "");
    Expect(1, 1114109, '\P{Is_East_Asian_Width=neutral}', "");
    Expect(0, 1114109, '\P{^Is_East_Asian_Width=neutral}', "");
    Expect(1, 918000, '\p{Is_East_Asian_Width=  Neutral}', "");
    Expect(0, 918000, '\p{^Is_East_Asian_Width=  Neutral}', "");
    Expect(0, 918000, '\P{Is_East_Asian_Width=  Neutral}', "");
    Expect(1, 918000, '\P{^Is_East_Asian_Width=  Neutral}', "");
    Expect(0, 1114109, '\p{Is_East_Asian_Width=  Neutral}', "");
    Expect(1, 1114109, '\p{^Is_East_Asian_Width=  Neutral}', "");
    Expect(1, 1114109, '\P{Is_East_Asian_Width=  Neutral}', "");
    Expect(0, 1114109, '\P{^Is_East_Asian_Width=  Neutral}', "");
    Error('\p{Is_Ea=/a/ -N}');
    Error('\P{Is_Ea=/a/ -N}');
    Expect(1, 918000, '\p{Is_Ea=n}', "");
    Expect(0, 918000, '\p{^Is_Ea=n}', "");
    Expect(0, 918000, '\P{Is_Ea=n}', "");
    Expect(1, 918000, '\P{^Is_Ea=n}', "");
    Expect(0, 1114109, '\p{Is_Ea=n}', "");
    Expect(1, 1114109, '\p{^Is_Ea=n}', "");
    Expect(1, 1114109, '\P{Is_Ea=n}', "");
    Expect(0, 1114109, '\P{^Is_Ea=n}', "");
    Expect(1, 918000, '\p{Is_Ea=_n}', "");
    Expect(0, 918000, '\p{^Is_Ea=_n}', "");
    Expect(0, 918000, '\P{Is_Ea=_n}', "");
    Expect(1, 918000, '\P{^Is_Ea=_n}', "");
    Expect(0, 1114109, '\p{Is_Ea=_n}', "");
    Expect(1, 1114109, '\p{^Is_Ea=_n}', "");
    Expect(1, 1114109, '\P{Is_Ea=_n}', "");
    Expect(0, 1114109, '\P{^Is_Ea=_n}', "");
    Error('\p{East_Asian_Width=	narrow:=}');
    Error('\P{East_Asian_Width=	narrow:=}');
    Expect(1, 10630, '\p{East_Asian_Width=:\ANarrow\z:}', "");;
    Expect(0, 10631, '\p{East_Asian_Width=:\ANarrow\z:}', "");;
    Expect(1, 10630, '\p{East_Asian_Width=narrow}', "");
    Expect(0, 10630, '\p{^East_Asian_Width=narrow}', "");
    Expect(0, 10630, '\P{East_Asian_Width=narrow}', "");
    Expect(1, 10630, '\P{^East_Asian_Width=narrow}', "");
    Expect(0, 10631, '\p{East_Asian_Width=narrow}', "");
    Expect(1, 10631, '\p{^East_Asian_Width=narrow}', "");
    Expect(1, 10631, '\P{East_Asian_Width=narrow}', "");
    Expect(0, 10631, '\P{^East_Asian_Width=narrow}', "");
    Expect(1, 10630, '\p{East_Asian_Width=:\Anarrow\z:}', "");;
    Expect(0, 10631, '\p{East_Asian_Width=:\Anarrow\z:}', "");;
    Expect(1, 10630, '\p{East_Asian_Width=--Narrow}', "");
    Expect(0, 10630, '\p{^East_Asian_Width=--Narrow}', "");
    Expect(0, 10630, '\P{East_Asian_Width=--Narrow}', "");
    Expect(1, 10630, '\P{^East_Asian_Width=--Narrow}', "");
    Expect(0, 10631, '\p{East_Asian_Width=--Narrow}', "");
    Expect(1, 10631, '\p{^East_Asian_Width=--Narrow}', "");
    Expect(1, 10631, '\P{East_Asian_Width=--Narrow}', "");
    Expect(0, 10631, '\P{^East_Asian_Width=--Narrow}', "");
    Error('\p{Ea= :=Na}');
    Error('\P{Ea= :=Na}');
    Expect(1, 10630, '\p{Ea=:\ANa\z:}', "");;
    Expect(0, 10631, '\p{Ea=:\ANa\z:}', "");;
    Expect(1, 10630, '\p{Ea=na}', "");
    Expect(0, 10630, '\p{^Ea=na}', "");
    Expect(0, 10630, '\P{Ea=na}', "");
    Expect(1, 10630, '\P{^Ea=na}', "");
    Expect(0, 10631, '\p{Ea=na}', "");
    Expect(1, 10631, '\p{^Ea=na}', "");
    Expect(1, 10631, '\P{Ea=na}', "");
    Expect(0, 10631, '\P{^Ea=na}', "");
    Expect(1, 10630, '\p{Ea=:\Ana\z:}', "");;
    Expect(0, 10631, '\p{Ea=:\Ana\z:}', "");;
    Expect(1, 10630, '\p{Ea=__Na}', "");
    Expect(0, 10630, '\p{^Ea=__Na}', "");
    Expect(0, 10630, '\P{Ea=__Na}', "");
    Expect(1, 10630, '\P{^Ea=__Na}', "");
    Expect(0, 10631, '\p{Ea=__Na}', "");
    Expect(1, 10631, '\p{^Ea=__Na}', "");
    Expect(1, 10631, '\P{Ea=__Na}', "");
    Expect(0, 10631, '\P{^Ea=__Na}', "");
    Error('\p{Is_East_Asian_Width=_	narrow/a/}');
    Error('\P{Is_East_Asian_Width=_	narrow/a/}');
    Expect(1, 10630, '\p{Is_East_Asian_Width=narrow}', "");
    Expect(0, 10630, '\p{^Is_East_Asian_Width=narrow}', "");
    Expect(0, 10630, '\P{Is_East_Asian_Width=narrow}', "");
    Expect(1, 10630, '\P{^Is_East_Asian_Width=narrow}', "");
    Expect(0, 10631, '\p{Is_East_Asian_Width=narrow}', "");
    Expect(1, 10631, '\p{^Is_East_Asian_Width=narrow}', "");
    Expect(1, 10631, '\P{Is_East_Asian_Width=narrow}', "");
    Expect(0, 10631, '\P{^Is_East_Asian_Width=narrow}', "");
    Expect(1, 10630, '\p{Is_East_Asian_Width=_ NARROW}', "");
    Expect(0, 10630, '\p{^Is_East_Asian_Width=_ NARROW}', "");
    Expect(0, 10630, '\P{Is_East_Asian_Width=_ NARROW}', "");
    Expect(1, 10630, '\P{^Is_East_Asian_Width=_ NARROW}', "");
    Expect(0, 10631, '\p{Is_East_Asian_Width=_ NARROW}', "");
    Expect(1, 10631, '\p{^Is_East_Asian_Width=_ NARROW}', "");
    Expect(1, 10631, '\P{Is_East_Asian_Width=_ NARROW}', "");
    Expect(0, 10631, '\P{^Is_East_Asian_Width=_ NARROW}', "");
    Error('\p{Is_Ea= :=Na}');
    Error('\P{Is_Ea= :=Na}');
    Expect(1, 10630, '\p{Is_Ea=na}', "");
    Expect(0, 10630, '\p{^Is_Ea=na}', "");
    Expect(0, 10630, '\P{Is_Ea=na}', "");
    Expect(1, 10630, '\P{^Is_Ea=na}', "");
    Expect(0, 10631, '\p{Is_Ea=na}', "");
    Expect(1, 10631, '\p{^Is_Ea=na}', "");
    Expect(1, 10631, '\P{Is_Ea=na}', "");
    Expect(0, 10631, '\P{^Is_Ea=na}', "");
    Expect(1, 10630, '\p{Is_Ea=_	NA}', "");
    Expect(0, 10630, '\p{^Is_Ea=_	NA}', "");
    Expect(0, 10630, '\P{Is_Ea=_	NA}', "");
    Expect(1, 10630, '\P{^Is_Ea=_	NA}', "");
    Expect(0, 10631, '\p{Is_Ea=_	NA}', "");
    Expect(1, 10631, '\p{^Is_Ea=_	NA}', "");
    Expect(1, 10631, '\P{Is_Ea=_	NA}', "");
    Expect(0, 10631, '\P{^Is_Ea=_	NA}', "");
    Error('\p{East_Asian_Width=:=	_wide}');
    Error('\P{East_Asian_Width=:=	_wide}');
    Expect(1, 262141, '\p{East_Asian_Width=:\AWide\z:}', "");;
    Expect(0, 262144, '\p{East_Asian_Width=:\AWide\z:}', "");;
    Expect(1, 262141, '\p{East_Asian_Width=wide}', "");
    Expect(0, 262141, '\p{^East_Asian_Width=wide}', "");
    Expect(0, 262141, '\P{East_Asian_Width=wide}', "");
    Expect(1, 262141, '\P{^East_Asian_Width=wide}', "");
    Expect(0, 262144, '\p{East_Asian_Width=wide}', "");
    Expect(1, 262144, '\p{^East_Asian_Width=wide}', "");
    Expect(1, 262144, '\P{East_Asian_Width=wide}', "");
    Expect(0, 262144, '\P{^East_Asian_Width=wide}', "");
    Expect(1, 262141, '\p{East_Asian_Width=:\Awide\z:}', "");;
    Expect(0, 262144, '\p{East_Asian_Width=:\Awide\z:}', "");;
    Expect(1, 262141, '\p{East_Asian_Width=_Wide}', "");
    Expect(0, 262141, '\p{^East_Asian_Width=_Wide}', "");
    Expect(0, 262141, '\P{East_Asian_Width=_Wide}', "");
    Expect(1, 262141, '\P{^East_Asian_Width=_Wide}', "");
    Expect(0, 262144, '\p{East_Asian_Width=_Wide}', "");
    Expect(1, 262144, '\p{^East_Asian_Width=_Wide}', "");
    Expect(1, 262144, '\P{East_Asian_Width=_Wide}', "");
    Expect(0, 262144, '\P{^East_Asian_Width=_Wide}', "");
    Error('\p{Ea=_-w/a/}');
    Error('\P{Ea=_-w/a/}');
    Expect(1, 262141, '\p{Ea=:\AW\z:}', "");;
    Expect(0, 262144, '\p{Ea=:\AW\z:}', "");;
    Expect(1, 262141, '\p{Ea=w}', "");
    Expect(0, 262141, '\p{^Ea=w}', "");
    Expect(0, 262141, '\P{Ea=w}', "");
    Expect(1, 262141, '\P{^Ea=w}', "");
    Expect(0, 262144, '\p{Ea=w}', "");
    Expect(1, 262144, '\p{^Ea=w}', "");
    Expect(1, 262144, '\P{Ea=w}', "");
    Expect(0, 262144, '\P{^Ea=w}', "");
    Expect(1, 262141, '\p{Ea=:\Aw\z:}', "");;
    Expect(0, 262144, '\p{Ea=:\Aw\z:}', "");;
    Expect(1, 262141, '\p{Ea=	_w}', "");
    Expect(0, 262141, '\p{^Ea=	_w}', "");
    Expect(0, 262141, '\P{Ea=	_w}', "");
    Expect(1, 262141, '\P{^Ea=	_w}', "");
    Expect(0, 262144, '\p{Ea=	_w}', "");
    Expect(1, 262144, '\p{^Ea=	_w}', "");
    Expect(1, 262144, '\P{Ea=	_w}', "");
    Expect(0, 262144, '\P{^Ea=	_w}', "");
    Error('\p{Is_East_Asian_Width= /a/Wide}');
    Error('\P{Is_East_Asian_Width= /a/Wide}');
    Expect(1, 262141, '\p{Is_East_Asian_Width=wide}', "");
    Expect(0, 262141, '\p{^Is_East_Asian_Width=wide}', "");
    Expect(0, 262141, '\P{Is_East_Asian_Width=wide}', "");
    Expect(1, 262141, '\P{^Is_East_Asian_Width=wide}', "");
    Expect(0, 262144, '\p{Is_East_Asian_Width=wide}', "");
    Expect(1, 262144, '\p{^Is_East_Asian_Width=wide}', "");
    Expect(1, 262144, '\P{Is_East_Asian_Width=wide}', "");
    Expect(0, 262144, '\P{^Is_East_Asian_Width=wide}', "");
    Expect(1, 262141, '\p{Is_East_Asian_Width=_Wide}', "");
    Expect(0, 262141, '\p{^Is_East_Asian_Width=_Wide}', "");
    Expect(0, 262141, '\P{Is_East_Asian_Width=_Wide}', "");
    Expect(1, 262141, '\P{^Is_East_Asian_Width=_Wide}', "");
    Expect(0, 262144, '\p{Is_East_Asian_Width=_Wide}', "");
    Expect(1, 262144, '\p{^Is_East_Asian_Width=_Wide}', "");
    Expect(1, 262144, '\P{Is_East_Asian_Width=_Wide}', "");
    Expect(0, 262144, '\P{^Is_East_Asian_Width=_Wide}', "");
    Error('\p{Is_Ea=/a/	_W}');
    Error('\P{Is_Ea=/a/	_W}');
    Expect(1, 262141, '\p{Is_Ea=w}', "");
    Expect(0, 262141, '\p{^Is_Ea=w}', "");
    Expect(0, 262141, '\P{Is_Ea=w}', "");
    Expect(1, 262141, '\P{^Is_Ea=w}', "");
    Expect(0, 262144, '\p{Is_Ea=w}', "");
    Expect(1, 262144, '\p{^Is_Ea=w}', "");
    Expect(1, 262144, '\P{Is_Ea=w}', "");
    Expect(0, 262144, '\P{^Is_Ea=w}', "");
    Expect(1, 262141, '\p{Is_Ea= 	W}', "");
    Expect(0, 262141, '\p{^Is_Ea= 	W}', "");
    Expect(0, 262141, '\P{Is_Ea= 	W}', "");
    Expect(1, 262141, '\P{^Is_Ea= 	W}', "");
    Expect(0, 262144, '\p{Is_Ea= 	W}', "");
    Expect(1, 262144, '\p{^Is_Ea= 	W}', "");
    Expect(1, 262144, '\P{Is_Ea= 	W}', "");
    Expect(0, 262144, '\P{^Is_Ea= 	W}', "");
    Error('\p{Emoji_Modifier_Base=:=-No}');
    Error('\P{Emoji_Modifier_Base=:=-No}');
    Expect(1, 129785, '\p{Emoji_Modifier_Base=:\ANo\z:}', "");;
    Expect(0, 129784, '\p{Emoji_Modifier_Base=:\ANo\z:}', "");;
    Expect(1, 129785, '\p{Emoji_Modifier_Base=no}', "");
    Expect(0, 129785, '\p{^Emoji_Modifier_Base=no}', "");
    Expect(0, 129785, '\P{Emoji_Modifier_Base=no}', "");
    Expect(1, 129785, '\P{^Emoji_Modifier_Base=no}', "");
    Expect(0, 129784, '\p{Emoji_Modifier_Base=no}', "");
    Expect(1, 129784, '\p{^Emoji_Modifier_Base=no}', "");
    Expect(1, 129784, '\P{Emoji_Modifier_Base=no}', "");
    Expect(0, 129784, '\P{^Emoji_Modifier_Base=no}', "");
    Expect(1, 129785, '\p{Emoji_Modifier_Base=:\Ano\z:}', "");;
    Expect(0, 129784, '\p{Emoji_Modifier_Base=:\Ano\z:}', "");;
    Expect(1, 129785, '\p{Emoji_Modifier_Base=--no}', "");
    Expect(0, 129785, '\p{^Emoji_Modifier_Base=--no}', "");
    Expect(0, 129785, '\P{Emoji_Modifier_Base=--no}', "");
    Expect(1, 129785, '\P{^Emoji_Modifier_Base=--no}', "");
    Expect(0, 129784, '\p{Emoji_Modifier_Base=--no}', "");
    Expect(1, 129784, '\p{^Emoji_Modifier_Base=--no}', "");
    Expect(1, 129784, '\P{Emoji_Modifier_Base=--no}', "");
    Expect(0, 129784, '\P{^Emoji_Modifier_Base=--no}', "");
    Error('\p{EBase= /a/N}');
    Error('\P{EBase= /a/N}');
    Expect(1, 129785, '\p{EBase=:\AN\z:}', "");;
    Expect(0, 129784, '\p{EBase=:\AN\z:}', "");;
    Expect(1, 129785, '\p{EBase=n}', "");
    Expect(0, 129785, '\p{^EBase=n}', "");
    Expect(0, 129785, '\P{EBase=n}', "");
    Expect(1, 129785, '\P{^EBase=n}', "");
    Expect(0, 129784, '\p{EBase=n}', "");
    Expect(1, 129784, '\p{^EBase=n}', "");
    Expect(1, 129784, '\P{EBase=n}', "");
    Expect(0, 129784, '\P{^EBase=n}', "");
    Expect(1, 129785, '\p{EBase=:\An\z:}', "");;
    Expect(0, 129784, '\p{EBase=:\An\z:}', "");;
    Expect(1, 129785, '\p{EBase=_	n}', "");
    Expect(0, 129785, '\p{^EBase=_	n}', "");
    Expect(0, 129785, '\P{EBase=_	n}', "");
    Expect(1, 129785, '\P{^EBase=_	n}', "");
    Expect(0, 129784, '\p{EBase=_	n}', "");
    Expect(1, 129784, '\p{^EBase=_	n}', "");
    Expect(1, 129784, '\P{EBase=_	n}', "");
    Expect(0, 129784, '\P{^EBase=_	n}', "");
    Error('\p{Is_Emoji_Modifier_Base= :=f}');
    Error('\P{Is_Emoji_Modifier_Base= :=f}');
    Expect(1, 129785, '\p{Is_Emoji_Modifier_Base: f}', "");
    Expect(0, 129785, '\p{^Is_Emoji_Modifier_Base: f}', "");
    Expect(0, 129785, '\P{Is_Emoji_Modifier_Base: f}', "");
    Expect(1, 129785, '\P{^Is_Emoji_Modifier_Base: f}', "");
    Expect(0, 129784, '\p{Is_Emoji_Modifier_Base: f}', "");
    Expect(1, 129784, '\p{^Is_Emoji_Modifier_Base: f}', "");
    Expect(1, 129784, '\P{Is_Emoji_Modifier_Base: f}', "");
    Expect(0, 129784, '\P{^Is_Emoji_Modifier_Base: f}', "");
    Expect(1, 129785, '\p{Is_Emoji_Modifier_Base=-_F}', "");
    Expect(0, 129785, '\p{^Is_Emoji_Modifier_Base=-_F}', "");
    Expect(0, 129785, '\P{Is_Emoji_Modifier_Base=-_F}', "");
    Expect(1, 129785, '\P{^Is_Emoji_Modifier_Base=-_F}', "");
    Expect(0, 129784, '\p{Is_Emoji_Modifier_Base=-_F}', "");
    Expect(1, 129784, '\p{^Is_Emoji_Modifier_Base=-_F}', "");
    Expect(1, 129784, '\P{Is_Emoji_Modifier_Base=-_F}', "");
    Expect(0, 129784, '\P{^Is_Emoji_Modifier_Base=-_F}', "");
    Error('\p{Is_EBase=-:=false}');
    Error('\P{Is_EBase=-:=false}');
    Expect(1, 129785, '\p{Is_EBase=false}', "");
    Expect(0, 129785, '\p{^Is_EBase=false}', "");
    Expect(0, 129785, '\P{Is_EBase=false}', "");
    Expect(1, 129785, '\P{^Is_EBase=false}', "");
    Expect(0, 129784, '\p{Is_EBase=false}', "");
    Expect(1, 129784, '\p{^Is_EBase=false}', "");
    Expect(1, 129784, '\P{Is_EBase=false}', "");
    Expect(0, 129784, '\P{^Is_EBase=false}', "");
    Expect(1, 129785, '\p{Is_EBase=-False}', "");
    Expect(0, 129785, '\p{^Is_EBase=-False}', "");
    Expect(0, 129785, '\P{Is_EBase=-False}', "");
    Expect(1, 129785, '\P{^Is_EBase=-False}', "");
    Expect(0, 129784, '\p{Is_EBase=-False}', "");
    Expect(1, 129784, '\p{^Is_EBase=-False}', "");
    Expect(1, 129784, '\P{Is_EBase=-False}', "");
    Expect(0, 129784, '\P{^Is_EBase=-False}', "");
    Error('\p{Emoji_Modifier_Base=/a/__Yes}');
    Error('\P{Emoji_Modifier_Base=/a/__Yes}');
    Expect(1, 129784, '\p{Emoji_Modifier_Base=:\AYes\z:}', "");;
    Expect(0, 129785, '\p{Emoji_Modifier_Base=:\AYes\z:}', "");;
    Expect(1, 129784, '\p{Emoji_Modifier_Base:   yes}', "");
    Expect(0, 129784, '\p{^Emoji_Modifier_Base:   yes}', "");
    Expect(0, 129784, '\P{Emoji_Modifier_Base:   yes}', "");
    Expect(1, 129784, '\P{^Emoji_Modifier_Base:   yes}', "");
    Expect(0, 129785, '\p{Emoji_Modifier_Base:   yes}', "");
    Expect(1, 129785, '\p{^Emoji_Modifier_Base:   yes}', "");
    Expect(1, 129785, '\P{Emoji_Modifier_Base:   yes}', "");
    Expect(0, 129785, '\P{^Emoji_Modifier_Base:   yes}', "");
    Expect(1, 129784, '\p{Emoji_Modifier_Base=:\Ayes\z:}', "");;
    Expect(0, 129785, '\p{Emoji_Modifier_Base=:\Ayes\z:}', "");;
    Expect(1, 129784, '\p{Emoji_Modifier_Base=		Yes}', "");
    Expect(0, 129784, '\p{^Emoji_Modifier_Base=		Yes}', "");
    Expect(0, 129784, '\P{Emoji_Modifier_Base=		Yes}', "");
    Expect(1, 129784, '\P{^Emoji_Modifier_Base=		Yes}', "");
    Expect(0, 129785, '\p{Emoji_Modifier_Base=		Yes}', "");
    Expect(1, 129785, '\p{^Emoji_Modifier_Base=		Yes}', "");
    Expect(1, 129785, '\P{Emoji_Modifier_Base=		Yes}', "");
    Expect(0, 129785, '\P{^Emoji_Modifier_Base=		Yes}', "");
    Error('\p{EBase=/a/	Y}');
    Error('\P{EBase=/a/	Y}');
    Expect(1, 129784, '\p{EBase=:\AY\z:}', "");;
    Expect(0, 129785, '\p{EBase=:\AY\z:}', "");;
    Expect(1, 129784, '\p{EBase=y}', "");
    Expect(0, 129784, '\p{^EBase=y}', "");
    Expect(0, 129784, '\P{EBase=y}', "");
    Expect(1, 129784, '\P{^EBase=y}', "");
    Expect(0, 129785, '\p{EBase=y}', "");
    Expect(1, 129785, '\p{^EBase=y}', "");
    Expect(1, 129785, '\P{EBase=y}', "");
    Expect(0, 129785, '\P{^EBase=y}', "");
    Expect(1, 129784, '\p{EBase=:\Ay\z:}', "");;
    Expect(0, 129785, '\p{EBase=:\Ay\z:}', "");;
    Expect(1, 129784, '\p{EBase= _y}', "");
    Expect(0, 129784, '\p{^EBase= _y}', "");
    Expect(0, 129784, '\P{EBase= _y}', "");
    Expect(1, 129784, '\P{^EBase= _y}', "");
    Expect(0, 129785, '\p{EBase= _y}', "");
    Expect(1, 129785, '\p{^EBase= _y}', "");
    Expect(1, 129785, '\P{EBase= _y}', "");
    Expect(0, 129785, '\P{^EBase= _y}', "");
    Error('\p{Is_Emoji_Modifier_Base=	:=T}');
    Error('\P{Is_Emoji_Modifier_Base=	:=T}');
    Expect(1, 129784, '\p{Is_Emoji_Modifier_Base=t}', "");
    Expect(0, 129784, '\p{^Is_Emoji_Modifier_Base=t}', "");
    Expect(0, 129784, '\P{Is_Emoji_Modifier_Base=t}', "");
    Expect(1, 129784, '\P{^Is_Emoji_Modifier_Base=t}', "");
    Expect(0, 129785, '\p{Is_Emoji_Modifier_Base=t}', "");
    Expect(1, 129785, '\p{^Is_Emoji_Modifier_Base=t}', "");
    Expect(1, 129785, '\P{Is_Emoji_Modifier_Base=t}', "");
    Expect(0, 129785, '\P{^Is_Emoji_Modifier_Base=t}', "");
    Expect(1, 129784, '\p{Is_Emoji_Modifier_Base=--T}', "");
    Expect(0, 129784, '\p{^Is_Emoji_Modifier_Base=--T}', "");
    Expect(0, 129784, '\P{Is_Emoji_Modifier_Base=--T}', "");
    Expect(1, 129784, '\P{^Is_Emoji_Modifier_Base=--T}', "");
    Expect(0, 129785, '\p{Is_Emoji_Modifier_Base=--T}', "");
    Expect(1, 129785, '\p{^Is_Emoji_Modifier_Base=--T}', "");
    Expect(1, 129785, '\P{Is_Emoji_Modifier_Base=--T}', "");
    Expect(0, 129785, '\P{^Is_Emoji_Modifier_Base=--T}', "");
    Error('\p{Is_EBase=		TRUE/a/}');
    Error('\P{Is_EBase=		TRUE/a/}');
    Expect(1, 129784, '\p{Is_EBase:   true}', "");
    Expect(0, 129784, '\p{^Is_EBase:   true}', "");
    Expect(0, 129784, '\P{Is_EBase:   true}', "");
    Expect(1, 129784, '\P{^Is_EBase:   true}', "");
    Expect(0, 129785, '\p{Is_EBase:   true}', "");
    Expect(1, 129785, '\p{^Is_EBase:   true}', "");
    Expect(1, 129785, '\P{Is_EBase:   true}', "");
    Expect(0, 129785, '\P{^Is_EBase:   true}', "");
    Expect(1, 129784, '\p{Is_EBase: 	TRUE}', "");
    Expect(0, 129784, '\p{^Is_EBase: 	TRUE}', "");
    Expect(0, 129784, '\P{Is_EBase: 	TRUE}', "");
    Expect(1, 129784, '\P{^Is_EBase: 	TRUE}', "");
    Expect(0, 129785, '\p{Is_EBase: 	TRUE}', "");
    Expect(1, 129785, '\p{^Is_EBase: 	TRUE}', "");
    Expect(1, 129785, '\P{Is_EBase: 	TRUE}', "");
    Expect(0, 129785, '\P{^Is_EBase: 	TRUE}', "");
    Error('\p{Emoji_Component:	-:=no}');
    Error('\P{Emoji_Component:	-:=no}');
    Expect(1, 917632, '\p{Emoji_Component=:\ANo\z:}', "");;
    Expect(0, 917631, '\p{Emoji_Component=:\ANo\z:}', "");;
    Expect(1, 917632, '\p{Emoji_Component=no}', "");
    Expect(0, 917632, '\p{^Emoji_Component=no}', "");
    Expect(0, 917632, '\P{Emoji_Component=no}', "");
    Expect(1, 917632, '\P{^Emoji_Component=no}', "");
    Expect(0, 917631, '\p{Emoji_Component=no}', "");
    Expect(1, 917631, '\p{^Emoji_Component=no}', "");
    Expect(1, 917631, '\P{Emoji_Component=no}', "");
    Expect(0, 917631, '\P{^Emoji_Component=no}', "");
    Expect(1, 917632, '\p{Emoji_Component=:\Ano\z:}', "");;
    Expect(0, 917631, '\p{Emoji_Component=:\Ano\z:}', "");;
    Expect(1, 917632, '\p{Emoji_Component=-no}', "");
    Expect(0, 917632, '\p{^Emoji_Component=-no}', "");
    Expect(0, 917632, '\P{Emoji_Component=-no}', "");
    Expect(1, 917632, '\P{^Emoji_Component=-no}', "");
    Expect(0, 917631, '\p{Emoji_Component=-no}', "");
    Expect(1, 917631, '\p{^Emoji_Component=-no}', "");
    Expect(1, 917631, '\P{Emoji_Component=-no}', "");
    Expect(0, 917631, '\P{^Emoji_Component=-no}', "");
    Error('\p{EComp=_-N:=}');
    Error('\P{EComp=_-N:=}');
    Expect(1, 917632, '\p{EComp=:\AN\z:}', "");;
    Expect(0, 917631, '\p{EComp=:\AN\z:}', "");;
    Expect(1, 917632, '\p{EComp=n}', "");
    Expect(0, 917632, '\p{^EComp=n}', "");
    Expect(0, 917632, '\P{EComp=n}', "");
    Expect(1, 917632, '\P{^EComp=n}', "");
    Expect(0, 917631, '\p{EComp=n}', "");
    Expect(1, 917631, '\p{^EComp=n}', "");
    Expect(1, 917631, '\P{EComp=n}', "");
    Expect(0, 917631, '\P{^EComp=n}', "");
    Expect(1, 917632, '\p{EComp=:\An\z:}', "");;
    Expect(0, 917631, '\p{EComp=:\An\z:}', "");;
    Expect(1, 917632, '\p{EComp=	N}', "");
    Expect(0, 917632, '\p{^EComp=	N}', "");
    Expect(0, 917632, '\P{EComp=	N}', "");
    Expect(1, 917632, '\P{^EComp=	N}', "");
    Expect(0, 917631, '\p{EComp=	N}', "");
    Expect(1, 917631, '\p{^EComp=	N}', "");
    Expect(1, 917631, '\P{EComp=	N}', "");
    Expect(0, 917631, '\P{^EComp=	N}', "");
    Error('\p{Is_Emoji_Component=_/a/F}');
    Error('\P{Is_Emoji_Component=_/a/F}');
    Expect(1, 917632, '\p{Is_Emoji_Component=f}', "");
    Expect(0, 917632, '\p{^Is_Emoji_Component=f}', "");
    Expect(0, 917632, '\P{Is_Emoji_Component=f}', "");
    Expect(1, 917632, '\P{^Is_Emoji_Component=f}', "");
    Expect(0, 917631, '\p{Is_Emoji_Component=f}', "");
    Expect(1, 917631, '\p{^Is_Emoji_Component=f}', "");
    Expect(1, 917631, '\P{Is_Emoji_Component=f}', "");
    Expect(0, 917631, '\P{^Is_Emoji_Component=f}', "");
    Expect(1, 917632, '\p{Is_Emoji_Component=_	F}', "");
    Expect(0, 917632, '\p{^Is_Emoji_Component=_	F}', "");
    Expect(0, 917632, '\P{Is_Emoji_Component=_	F}', "");
    Expect(1, 917632, '\P{^Is_Emoji_Component=_	F}', "");
    Expect(0, 917631, '\p{Is_Emoji_Component=_	F}', "");
    Expect(1, 917631, '\p{^Is_Emoji_Component=_	F}', "");
    Expect(1, 917631, '\P{Is_Emoji_Component=_	F}', "");
    Expect(0, 917631, '\P{^Is_Emoji_Component=_	F}', "");
    Error('\p{Is_EComp:-:=false}');
    Error('\P{Is_EComp:-:=false}');
    Expect(1, 917632, '\p{Is_EComp=false}', "");
    Expect(0, 917632, '\p{^Is_EComp=false}', "");
    Expect(0, 917632, '\P{Is_EComp=false}', "");
    Expect(1, 917632, '\P{^Is_EComp=false}', "");
    Expect(0, 917631, '\p{Is_EComp=false}', "");
    Expect(1, 917631, '\p{^Is_EComp=false}', "");
    Expect(1, 917631, '\P{Is_EComp=false}', "");
    Expect(0, 917631, '\P{^Is_EComp=false}', "");
    Expect(1, 917632, '\p{Is_EComp= 	FALSE}', "");
    Expect(0, 917632, '\p{^Is_EComp= 	FALSE}', "");
    Expect(0, 917632, '\P{Is_EComp= 	FALSE}', "");
    Expect(1, 917632, '\P{^Is_EComp= 	FALSE}', "");
    Expect(0, 917631, '\p{Is_EComp= 	FALSE}', "");
    Expect(1, 917631, '\p{^Is_EComp= 	FALSE}', "");
    Expect(1, 917631, '\P{Is_EComp= 	FALSE}', "");
    Expect(0, 917631, '\P{^Is_EComp= 	FALSE}', "");
    Error('\p{Emoji_Component=_:=Yes}');
    Error('\P{Emoji_Component=_:=Yes}');
    Expect(1, 917631, '\p{Emoji_Component=:\AYes\z:}', "");;
    Expect(0, 917632, '\p{Emoji_Component=:\AYes\z:}', "");;
    Expect(1, 917631, '\p{Emoji_Component=yes}', "");
    Expect(0, 917631, '\p{^Emoji_Component=yes}', "");
    Expect(0, 917631, '\P{Emoji_Component=yes}', "");
    Expect(1, 917631, '\P{^Emoji_Component=yes}', "");
    Expect(0, 917632, '\p{Emoji_Component=yes}', "");
    Expect(1, 917632, '\p{^Emoji_Component=yes}', "");
    Expect(1, 917632, '\P{Emoji_Component=yes}', "");
    Expect(0, 917632, '\P{^Emoji_Component=yes}', "");
    Expect(1, 917631, '\p{Emoji_Component=:\Ayes\z:}', "");;
    Expect(0, 917632, '\p{Emoji_Component=:\Ayes\z:}', "");;
    Expect(1, 917631, '\p{Emoji_Component=__Yes}', "");
    Expect(0, 917631, '\p{^Emoji_Component=__Yes}', "");
    Expect(0, 917631, '\P{Emoji_Component=__Yes}', "");
    Expect(1, 917631, '\P{^Emoji_Component=__Yes}', "");
    Expect(0, 917632, '\p{Emoji_Component=__Yes}', "");
    Expect(1, 917632, '\p{^Emoji_Component=__Yes}', "");
    Expect(1, 917632, '\P{Emoji_Component=__Yes}', "");
    Expect(0, 917632, '\P{^Emoji_Component=__Yes}', "");
    Error('\p{EComp=:= 	Y}');
    Error('\P{EComp=:= 	Y}');
    Expect(1, 917631, '\p{EComp=:\AY\z:}', "");;
    Expect(0, 917632, '\p{EComp=:\AY\z:}', "");;
    Expect(1, 917631, '\p{EComp=y}', "");
    Expect(0, 917631, '\p{^EComp=y}', "");
    Expect(0, 917631, '\P{EComp=y}', "");
    Expect(1, 917631, '\P{^EComp=y}', "");
    Expect(0, 917632, '\p{EComp=y}', "");
    Expect(1, 917632, '\p{^EComp=y}', "");
    Expect(1, 917632, '\P{EComp=y}', "");
    Expect(0, 917632, '\P{^EComp=y}', "");
    Expect(1, 917631, '\p{EComp=:\Ay\z:}', "");;
    Expect(0, 917632, '\p{EComp=:\Ay\z:}', "");;
    Expect(1, 917631, '\p{EComp= Y}', "");
    Expect(0, 917631, '\p{^EComp= Y}', "");
    Expect(0, 917631, '\P{EComp= Y}', "");
    Expect(1, 917631, '\P{^EComp= Y}', "");
    Expect(0, 917632, '\p{EComp= Y}', "");
    Expect(1, 917632, '\p{^EComp= Y}', "");
    Expect(1, 917632, '\P{EComp= Y}', "");
    Expect(0, 917632, '\P{^EComp= Y}', "");
    Error('\p{Is_Emoji_Component=/a/_-t}');
    Error('\P{Is_Emoji_Component=/a/_-t}');
    Expect(1, 917631, '\p{Is_Emoji_Component=t}', "");
    Expect(0, 917631, '\p{^Is_Emoji_Component=t}', "");
    Expect(0, 917631, '\P{Is_Emoji_Component=t}', "");
    Expect(1, 917631, '\P{^Is_Emoji_Component=t}', "");
    Expect(0, 917632, '\p{Is_Emoji_Component=t}', "");
    Expect(1, 917632, '\p{^Is_Emoji_Component=t}', "");
    Expect(1, 917632, '\P{Is_Emoji_Component=t}', "");
    Expect(0, 917632, '\P{^Is_Emoji_Component=t}', "");
    Expect(1, 917631, '\p{Is_Emoji_Component=-_t}', "");
    Expect(0, 917631, '\p{^Is_Emoji_Component=-_t}', "");
    Expect(0, 917631, '\P{Is_Emoji_Component=-_t}', "");
    Expect(1, 917631, '\P{^Is_Emoji_Component=-_t}', "");
    Expect(0, 917632, '\p{Is_Emoji_Component=-_t}', "");
    Expect(1, 917632, '\p{^Is_Emoji_Component=-_t}', "");
    Expect(1, 917632, '\P{Is_Emoji_Component=-_t}', "");
    Expect(0, 917632, '\P{^Is_Emoji_Component=-_t}', "");
    Error('\p{Is_EComp:   :=_	True}');
    Error('\P{Is_EComp:   :=_	True}');
    Expect(1, 917631, '\p{Is_EComp=true}', "");
    Expect(0, 917631, '\p{^Is_EComp=true}', "");
    Expect(0, 917631, '\P{Is_EComp=true}', "");
    Expect(1, 917631, '\P{^Is_EComp=true}', "");
    Expect(0, 917632, '\p{Is_EComp=true}', "");
    Expect(1, 917632, '\p{^Is_EComp=true}', "");
    Expect(1, 917632, '\P{Is_EComp=true}', "");
    Expect(0, 917632, '\P{^Is_EComp=true}', "");
    Expect(1, 917631, '\p{Is_EComp= _True}', "");
    Expect(0, 917631, '\p{^Is_EComp= _True}', "");
    Expect(0, 917631, '\P{Is_EComp= _True}', "");
    Expect(1, 917631, '\P{^Is_EComp= _True}', "");
    Expect(0, 917632, '\p{Is_EComp= _True}', "");
    Expect(1, 917632, '\p{^Is_EComp= _True}', "");
    Expect(1, 917632, '\P{Is_EComp= _True}', "");
    Expect(0, 917632, '\P{^Is_EComp= _True}', "");
    Error('\p{Emoji_Modifier=-:=no}');
    Error('\P{Emoji_Modifier=-:=no}');
    Expect(1, 128000, '\p{Emoji_Modifier=:\ANo\z:}', "");;
    Expect(0, 127999, '\p{Emoji_Modifier=:\ANo\z:}', "");;
    Expect(1, 128000, '\p{Emoji_Modifier=no}', "");
    Expect(0, 128000, '\p{^Emoji_Modifier=no}', "");
    Expect(0, 128000, '\P{Emoji_Modifier=no}', "");
    Expect(1, 128000, '\P{^Emoji_Modifier=no}', "");
    Expect(0, 127999, '\p{Emoji_Modifier=no}', "");
    Expect(1, 127999, '\p{^Emoji_Modifier=no}', "");
    Expect(1, 127999, '\P{Emoji_Modifier=no}', "");
    Expect(0, 127999, '\P{^Emoji_Modifier=no}', "");
    Expect(1, 128000, '\p{Emoji_Modifier=:\Ano\z:}', "");;
    Expect(0, 127999, '\p{Emoji_Modifier=:\Ano\z:}', "");;
    Expect(1, 128000, '\p{Emoji_Modifier=	_no}', "");
    Expect(0, 128000, '\p{^Emoji_Modifier=	_no}', "");
    Expect(0, 128000, '\P{Emoji_Modifier=	_no}', "");
    Expect(1, 128000, '\P{^Emoji_Modifier=	_no}', "");
    Expect(0, 127999, '\p{Emoji_Modifier=	_no}', "");
    Expect(1, 127999, '\p{^Emoji_Modifier=	_no}', "");
    Expect(1, 127999, '\P{Emoji_Modifier=	_no}', "");
    Expect(0, 127999, '\P{^Emoji_Modifier=	_no}', "");
    Error('\p{EMod: 	_n:=}');
    Error('\P{EMod: 	_n:=}');
    Expect(1, 128000, '\p{EMod=:\AN\z:}', "");;
    Expect(0, 127999, '\p{EMod=:\AN\z:}', "");;
    Expect(1, 128000, '\p{EMod=n}', "");
    Expect(0, 128000, '\p{^EMod=n}', "");
    Expect(0, 128000, '\P{EMod=n}', "");
    Expect(1, 128000, '\P{^EMod=n}', "");
    Expect(0, 127999, '\p{EMod=n}', "");
    Expect(1, 127999, '\p{^EMod=n}', "");
    Expect(1, 127999, '\P{EMod=n}', "");
    Expect(0, 127999, '\P{^EMod=n}', "");
    Expect(1, 128000, '\p{EMod=:\An\z:}', "");;
    Expect(0, 127999, '\p{EMod=:\An\z:}', "");;
    Expect(1, 128000, '\p{EMod=-_n}', "");
    Expect(0, 128000, '\p{^EMod=-_n}', "");
    Expect(0, 128000, '\P{EMod=-_n}', "");
    Expect(1, 128000, '\P{^EMod=-_n}', "");
    Expect(0, 127999, '\p{EMod=-_n}', "");
    Expect(1, 127999, '\p{^EMod=-_n}', "");
    Expect(1, 127999, '\P{EMod=-_n}', "");
    Expect(0, 127999, '\P{^EMod=-_n}', "");
    Error('\p{Is_Emoji_Modifier=	:=F}');
    Error('\P{Is_Emoji_Modifier=	:=F}');
    Expect(1, 128000, '\p{Is_Emoji_Modifier=f}', "");
    Expect(0, 128000, '\p{^Is_Emoji_Modifier=f}', "");
    Expect(0, 128000, '\P{Is_Emoji_Modifier=f}', "");
    Expect(1, 128000, '\P{^Is_Emoji_Modifier=f}', "");
    Expect(0, 127999, '\p{Is_Emoji_Modifier=f}', "");
    Expect(1, 127999, '\p{^Is_Emoji_Modifier=f}', "");
    Expect(1, 127999, '\P{Is_Emoji_Modifier=f}', "");
    Expect(0, 127999, '\P{^Is_Emoji_Modifier=f}', "");
    Expect(1, 128000, '\p{Is_Emoji_Modifier=-F}', "");
    Expect(0, 128000, '\p{^Is_Emoji_Modifier=-F}', "");
    Expect(0, 128000, '\P{Is_Emoji_Modifier=-F}', "");
    Expect(1, 128000, '\P{^Is_Emoji_Modifier=-F}', "");
    Expect(0, 127999, '\p{Is_Emoji_Modifier=-F}', "");
    Expect(1, 127999, '\p{^Is_Emoji_Modifier=-F}', "");
    Expect(1, 127999, '\P{Is_Emoji_Modifier=-F}', "");
    Expect(0, 127999, '\P{^Is_Emoji_Modifier=-F}', "");
    Error('\p{Is_EMod= false:=}');
    Error('\P{Is_EMod= false:=}');
    Expect(1, 128000, '\p{Is_EMod=false}', "");
    Expect(0, 128000, '\p{^Is_EMod=false}', "");
    Expect(0, 128000, '\P{Is_EMod=false}', "");
    Expect(1, 128000, '\P{^Is_EMod=false}', "");
    Expect(0, 127999, '\p{Is_EMod=false}', "");
    Expect(1, 127999, '\p{^Is_EMod=false}', "");
    Expect(1, 127999, '\P{Is_EMod=false}', "");
    Expect(0, 127999, '\P{^Is_EMod=false}', "");
    Expect(1, 128000, '\p{Is_EMod=		false}', "");
    Expect(0, 128000, '\p{^Is_EMod=		false}', "");
    Expect(0, 128000, '\P{Is_EMod=		false}', "");
    Expect(1, 128000, '\P{^Is_EMod=		false}', "");
    Expect(0, 127999, '\p{Is_EMod=		false}', "");
    Expect(1, 127999, '\p{^Is_EMod=		false}', "");
    Expect(1, 127999, '\P{Is_EMod=		false}', "");
    Expect(0, 127999, '\P{^Is_EMod=		false}', "");
    Error('\p{Emoji_Modifier=_:=Yes}');
    Error('\P{Emoji_Modifier=_:=Yes}');
    Expect(1, 127999, '\p{Emoji_Modifier=:\AYes\z:}', "");;
    Expect(0, 128000, '\p{Emoji_Modifier=:\AYes\z:}', "");;
    Expect(1, 127999, '\p{Emoji_Modifier:	yes}', "");
    Expect(0, 127999, '\p{^Emoji_Modifier:	yes}', "");
    Expect(0, 127999, '\P{Emoji_Modifier:	yes}', "");
    Expect(1, 127999, '\P{^Emoji_Modifier:	yes}', "");
    Expect(0, 128000, '\p{Emoji_Modifier:	yes}', "");
    Expect(1, 128000, '\p{^Emoji_Modifier:	yes}', "");
    Expect(1, 128000, '\P{Emoji_Modifier:	yes}', "");
    Expect(0, 128000, '\P{^Emoji_Modifier:	yes}', "");
    Expect(1, 127999, '\p{Emoji_Modifier=:\Ayes\z:}', "");;
    Expect(0, 128000, '\p{Emoji_Modifier=:\Ayes\z:}', "");;
    Expect(1, 127999, '\p{Emoji_Modifier=-_yes}', "");
    Expect(0, 127999, '\p{^Emoji_Modifier=-_yes}', "");
    Expect(0, 127999, '\P{Emoji_Modifier=-_yes}', "");
    Expect(1, 127999, '\P{^Emoji_Modifier=-_yes}', "");
    Expect(0, 128000, '\p{Emoji_Modifier=-_yes}', "");
    Expect(1, 128000, '\p{^Emoji_Modifier=-_yes}', "");
    Expect(1, 128000, '\P{Emoji_Modifier=-_yes}', "");
    Expect(0, 128000, '\P{^Emoji_Modifier=-_yes}', "");
    Error('\p{EMod=- y:=}');
    Error('\P{EMod=- y:=}');
    Expect(1, 127999, '\p{EMod=:\AY\z:}', "");;
    Expect(0, 128000, '\p{EMod=:\AY\z:}', "");;
    Expect(1, 127999, '\p{EMod=y}', "");
    Expect(0, 127999, '\p{^EMod=y}', "");
    Expect(0, 127999, '\P{EMod=y}', "");
    Expect(1, 127999, '\P{^EMod=y}', "");
    Expect(0, 128000, '\p{EMod=y}', "");
    Expect(1, 128000, '\p{^EMod=y}', "");
    Expect(1, 128000, '\P{EMod=y}', "");
    Expect(0, 128000, '\P{^EMod=y}', "");
    Expect(1, 127999, '\p{EMod=:\Ay\z:}', "");;
    Expect(0, 128000, '\p{EMod=:\Ay\z:}', "");;
    Expect(1, 127999, '\p{EMod=--y}', "");
    Expect(0, 127999, '\p{^EMod=--y}', "");
    Expect(0, 127999, '\P{EMod=--y}', "");
    Expect(1, 127999, '\P{^EMod=--y}', "");
    Expect(0, 128000, '\p{EMod=--y}', "");
    Expect(1, 128000, '\p{^EMod=--y}', "");
    Expect(1, 128000, '\P{EMod=--y}', "");
    Expect(0, 128000, '\P{^EMod=--y}', "");
    Error('\p{Is_Emoji_Modifier=-T:=}');
    Error('\P{Is_Emoji_Modifier=-T:=}');
    Expect(1, 127999, '\p{Is_Emoji_Modifier=t}', "");
    Expect(0, 127999, '\p{^Is_Emoji_Modifier=t}', "");
    Expect(0, 127999, '\P{Is_Emoji_Modifier=t}', "");
    Expect(1, 127999, '\P{^Is_Emoji_Modifier=t}', "");
    Expect(0, 128000, '\p{Is_Emoji_Modifier=t}', "");
    Expect(1, 128000, '\p{^Is_Emoji_Modifier=t}', "");
    Expect(1, 128000, '\P{Is_Emoji_Modifier=t}', "");
    Expect(0, 128000, '\P{^Is_Emoji_Modifier=t}', "");
    Expect(1, 127999, '\p{Is_Emoji_Modifier= 	T}', "");
    Expect(0, 127999, '\p{^Is_Emoji_Modifier= 	T}', "");
    Expect(0, 127999, '\P{Is_Emoji_Modifier= 	T}', "");
    Expect(1, 127999, '\P{^Is_Emoji_Modifier= 	T}', "");
    Expect(0, 128000, '\p{Is_Emoji_Modifier= 	T}', "");
    Expect(1, 128000, '\p{^Is_Emoji_Modifier= 	T}', "");
    Expect(1, 128000, '\P{Is_Emoji_Modifier= 	T}', "");
    Expect(0, 128000, '\P{^Is_Emoji_Modifier= 	T}', "");
    Error('\p{Is_EMod=	/a/True}');
    Error('\P{Is_EMod=	/a/True}');
    Expect(1, 127999, '\p{Is_EMod=true}', "");
    Expect(0, 127999, '\p{^Is_EMod=true}', "");
    Expect(0, 127999, '\P{Is_EMod=true}', "");
    Expect(1, 127999, '\P{^Is_EMod=true}', "");
    Expect(0, 128000, '\p{Is_EMod=true}', "");
    Expect(1, 128000, '\p{^Is_EMod=true}', "");
    Expect(1, 128000, '\P{Is_EMod=true}', "");
    Expect(0, 128000, '\P{^Is_EMod=true}', "");
    Expect(1, 127999, '\p{Is_EMod=	 True}', "");
    Expect(0, 127999, '\p{^Is_EMod=	 True}', "");
    Expect(0, 127999, '\P{Is_EMod=	 True}', "");
    Expect(1, 127999, '\P{^Is_EMod=	 True}', "");
    Expect(0, 128000, '\p{Is_EMod=	 True}', "");
    Expect(1, 128000, '\p{^Is_EMod=	 True}', "");
    Expect(1, 128000, '\P{Is_EMod=	 True}', "");
    Expect(0, 128000, '\P{^Is_EMod=	 True}', "");
    Error('\p{Emoji=	/a/NO}');
    Error('\P{Emoji=	/a/NO}');
    Expect(1, 129785, '\p{Emoji=:\ANo\z:}', "");;
    Expect(0, 129784, '\p{Emoji=:\ANo\z:}', "");;
    Expect(1, 129785, '\p{Emoji:	no}', "");
    Expect(0, 129785, '\p{^Emoji:	no}', "");
    Expect(0, 129785, '\P{Emoji:	no}', "");
    Expect(1, 129785, '\P{^Emoji:	no}', "");
    Expect(0, 129784, '\p{Emoji:	no}', "");
    Expect(1, 129784, '\p{^Emoji:	no}', "");
    Expect(1, 129784, '\P{Emoji:	no}', "");
    Expect(0, 129784, '\P{^Emoji:	no}', "");
    Expect(1, 129785, '\p{Emoji=:\Ano\z:}', "");;
    Expect(0, 129784, '\p{Emoji=:\Ano\z:}', "");;
    Expect(1, 129785, '\p{Emoji=-	No}', "");
    Expect(0, 129785, '\p{^Emoji=-	No}', "");
    Expect(0, 129785, '\P{Emoji=-	No}', "");
    Expect(1, 129785, '\P{^Emoji=-	No}', "");
    Expect(0, 129784, '\p{Emoji=-	No}', "");
    Expect(1, 129784, '\p{^Emoji=-	No}', "");
    Expect(1, 129784, '\P{Emoji=-	No}', "");
    Expect(0, 129784, '\P{^Emoji=-	No}', "");
    Error('\p{Is_Emoji:/a/	-N}');
    Error('\P{Is_Emoji:/a/	-N}');
    Expect(1, 129785, '\p{Is_Emoji=n}', "");
    Expect(0, 129785, '\p{^Is_Emoji=n}', "");
    Expect(0, 129785, '\P{Is_Emoji=n}', "");
    Expect(1, 129785, '\P{^Is_Emoji=n}', "");
    Expect(0, 129784, '\p{Is_Emoji=n}', "");
    Expect(1, 129784, '\p{^Is_Emoji=n}', "");
    Expect(1, 129784, '\P{Is_Emoji=n}', "");
    Expect(0, 129784, '\P{^Is_Emoji=n}', "");
    Expect(1, 129785, '\p{Is_Emoji:_ N}', "");
    Expect(0, 129785, '\p{^Is_Emoji:_ N}', "");
    Expect(0, 129785, '\P{Is_Emoji:_ N}', "");
    Expect(1, 129785, '\P{^Is_Emoji:_ N}', "");
    Expect(0, 129784, '\p{Is_Emoji:_ N}', "");
    Expect(1, 129784, '\p{^Is_Emoji:_ N}', "");
    Expect(1, 129784, '\P{Is_Emoji:_ N}', "");
    Expect(0, 129784, '\P{^Is_Emoji:_ N}', "");
    Error('\p{Emoji:    /a/f}');
    Error('\P{Emoji:    /a/f}');
    Expect(1, 129785, '\p{Emoji=:\AF\z:}', "");;
    Expect(0, 129784, '\p{Emoji=:\AF\z:}', "");;
    Expect(1, 129785, '\p{Emoji=f}', "");
    Expect(0, 129785, '\p{^Emoji=f}', "");
    Expect(0, 129785, '\P{Emoji=f}', "");
    Expect(1, 129785, '\P{^Emoji=f}', "");
    Expect(0, 129784, '\p{Emoji=f}', "");
    Expect(1, 129784, '\p{^Emoji=f}', "");
    Expect(1, 129784, '\P{Emoji=f}', "");
    Expect(0, 129784, '\P{^Emoji=f}', "");
    Expect(1, 129785, '\p{Emoji=:\Af\z:}', "");;
    Expect(0, 129784, '\p{Emoji=:\Af\z:}', "");;
    Expect(1, 129785, '\p{Emoji= -F}', "");
    Expect(0, 129785, '\p{^Emoji= -F}', "");
    Expect(0, 129785, '\P{Emoji= -F}', "");
    Expect(1, 129785, '\P{^Emoji= -F}', "");
    Expect(0, 129784, '\p{Emoji= -F}', "");
    Expect(1, 129784, '\p{^Emoji= -F}', "");
    Expect(1, 129784, '\P{Emoji= -F}', "");
    Expect(0, 129784, '\P{^Emoji= -F}', "");
    Error('\p{Is_Emoji: -:=False}');
    Error('\P{Is_Emoji: -:=False}');
    Expect(1, 129785, '\p{Is_Emoji=false}', "");
    Expect(0, 129785, '\p{^Is_Emoji=false}', "");
    Expect(0, 129785, '\P{Is_Emoji=false}', "");
    Expect(1, 129785, '\P{^Is_Emoji=false}', "");
    Expect(0, 129784, '\p{Is_Emoji=false}', "");
    Expect(1, 129784, '\p{^Is_Emoji=false}', "");
    Expect(1, 129784, '\P{Is_Emoji=false}', "");
    Expect(0, 129784, '\P{^Is_Emoji=false}', "");
    Expect(1, 129785, '\p{Is_Emoji=	 FALSE}', "");
    Expect(0, 129785, '\p{^Is_Emoji=	 FALSE}', "");
    Expect(0, 129785, '\P{Is_Emoji=	 FALSE}', "");
    Expect(1, 129785, '\P{^Is_Emoji=	 FALSE}', "");
    Expect(0, 129784, '\p{Is_Emoji=	 FALSE}', "");
    Expect(1, 129784, '\p{^Is_Emoji=	 FALSE}', "");
    Expect(1, 129784, '\P{Is_Emoji=	 FALSE}', "");
    Expect(0, 129784, '\P{^Is_Emoji=	 FALSE}', "");
    Error('\p{Emoji=_/a/yes}');
    Error('\P{Emoji=_/a/yes}');
    Expect(1, 129784, '\p{Emoji=:\AYes\z:}', "");;
    Expect(0, 129785, '\p{Emoji=:\AYes\z:}', "");;
    Expect(1, 129784, '\p{Emoji=yes}', "");
    Expect(0, 129784, '\p{^Emoji=yes}', "");
    Expect(0, 129784, '\P{Emoji=yes}', "");
    Expect(1, 129784, '\P{^Emoji=yes}', "");
    Expect(0, 129785, '\p{Emoji=yes}', "");
    Expect(1, 129785, '\p{^Emoji=yes}', "");
    Expect(1, 129785, '\P{Emoji=yes}', "");
    Expect(0, 129785, '\P{^Emoji=yes}', "");
    Expect(1, 129784, '\p{Emoji=:\Ayes\z:}', "");;
    Expect(0, 129785, '\p{Emoji=:\Ayes\z:}', "");;
    Expect(1, 129784, '\p{Emoji=_-Yes}', "");
    Expect(0, 129784, '\p{^Emoji=_-Yes}', "");
    Expect(0, 129784, '\P{Emoji=_-Yes}', "");
    Expect(1, 129784, '\P{^Emoji=_-Yes}', "");
    Expect(0, 129785, '\p{Emoji=_-Yes}', "");
    Expect(1, 129785, '\p{^Emoji=_-Yes}', "");
    Expect(1, 129785, '\P{Emoji=_-Yes}', "");
    Expect(0, 129785, '\P{^Emoji=_-Yes}', "");
    Error('\p{Is_Emoji=_/a/Y}');
    Error('\P{Is_Emoji=_/a/Y}');
    Expect(1, 129784, '\p{Is_Emoji=y}', "");
    Expect(0, 129784, '\p{^Is_Emoji=y}', "");
    Expect(0, 129784, '\P{Is_Emoji=y}', "");
    Expect(1, 129784, '\P{^Is_Emoji=y}', "");
    Expect(0, 129785, '\p{Is_Emoji=y}', "");
    Expect(1, 129785, '\p{^Is_Emoji=y}', "");
    Expect(1, 129785, '\P{Is_Emoji=y}', "");
    Expect(0, 129785, '\P{^Is_Emoji=y}', "");
    Expect(1, 129784, '\p{Is_Emoji=-_Y}', "");
    Expect(0, 129784, '\p{^Is_Emoji=-_Y}', "");
    Expect(0, 129784, '\P{Is_Emoji=-_Y}', "");
    Expect(1, 129784, '\P{^Is_Emoji=-_Y}', "");
    Expect(0, 129785, '\p{Is_Emoji=-_Y}', "");
    Expect(1, 129785, '\p{^Is_Emoji=-_Y}', "");
    Expect(1, 129785, '\P{Is_Emoji=-_Y}', "");
    Expect(0, 129785, '\P{^Is_Emoji=-_Y}', "");
    Error('\p{Emoji=_T:=}');
    Error('\P{Emoji=_T:=}');
    Expect(1, 129784, '\p{Emoji=:\AT\z:}', "");;
    Expect(0, 129785, '\p{Emoji=:\AT\z:}', "");;
    Expect(1, 129784, '\p{Emoji=t}', "");
    Expect(0, 129784, '\p{^Emoji=t}', "");
    Expect(0, 129784, '\P{Emoji=t}', "");
    Expect(1, 129784, '\P{^Emoji=t}', "");
    Expect(0, 129785, '\p{Emoji=t}', "");
    Expect(1, 129785, '\p{^Emoji=t}', "");
    Expect(1, 129785, '\P{Emoji=t}', "");
    Expect(0, 129785, '\P{^Emoji=t}', "");
    Expect(1, 129784, '\p{Emoji=:\At\z:}', "");;
    Expect(0, 129785, '\p{Emoji=:\At\z:}', "");;
    Expect(1, 129784, '\p{Emoji= T}', "");
    Expect(0, 129784, '\p{^Emoji= T}', "");
    Expect(0, 129784, '\P{Emoji= T}', "");
    Expect(1, 129784, '\P{^Emoji= T}', "");
    Expect(0, 129785, '\p{Emoji= T}', "");
    Expect(1, 129785, '\p{^Emoji= T}', "");
    Expect(1, 129785, '\P{Emoji= T}', "");
    Expect(0, 129785, '\P{^Emoji= T}', "");
    Error('\p{Is_Emoji=-:=True}');
    Error('\P{Is_Emoji=-:=True}');
    Expect(1, 129784, '\p{Is_Emoji=true}', "");
    Expect(0, 129784, '\p{^Is_Emoji=true}', "");
    Expect(0, 129784, '\P{Is_Emoji=true}', "");
    Expect(1, 129784, '\P{^Is_Emoji=true}', "");
    Expect(0, 129785, '\p{Is_Emoji=true}', "");
    Expect(1, 129785, '\p{^Is_Emoji=true}', "");
    Expect(1, 129785, '\P{Is_Emoji=true}', "");
    Expect(0, 129785, '\P{^Is_Emoji=true}', "");
    Expect(1, 129784, '\p{Is_Emoji:	- TRUE}', "");
    Expect(0, 129784, '\p{^Is_Emoji:	- TRUE}', "");
    Expect(0, 129784, '\P{Is_Emoji:	- TRUE}', "");
    Expect(1, 129784, '\P{^Is_Emoji:	- TRUE}', "");
    Expect(0, 129785, '\p{Is_Emoji:	- TRUE}', "");
    Expect(1, 129785, '\p{^Is_Emoji:	- TRUE}', "");
    Expect(1, 129785, '\P{Is_Emoji:	- TRUE}', "");
    Expect(0, 129785, '\P{^Is_Emoji:	- TRUE}', "");
    Error('\p{Emoji_Presentation=/a/NO}');
    Error('\P{Emoji_Presentation=/a/NO}');
    Expect(1, 129785, '\p{Emoji_Presentation=:\ANo\z:}', "");;
    Expect(0, 129784, '\p{Emoji_Presentation=:\ANo\z:}', "");;
    Expect(1, 129785, '\p{Emoji_Presentation=no}', "");
    Expect(0, 129785, '\p{^Emoji_Presentation=no}', "");
    Expect(0, 129785, '\P{Emoji_Presentation=no}', "");
    Expect(1, 129785, '\P{^Emoji_Presentation=no}', "");
    Expect(0, 129784, '\p{Emoji_Presentation=no}', "");
    Expect(1, 129784, '\p{^Emoji_Presentation=no}', "");
    Expect(1, 129784, '\P{Emoji_Presentation=no}', "");
    Expect(0, 129784, '\P{^Emoji_Presentation=no}', "");
    Expect(1, 129785, '\p{Emoji_Presentation=:\Ano\z:}', "");;
    Expect(0, 129784, '\p{Emoji_Presentation=:\Ano\z:}', "");;
    Expect(1, 129785, '\p{Emoji_Presentation=_no}', "");
    Expect(0, 129785, '\p{^Emoji_Presentation=_no}', "");
    Expect(0, 129785, '\P{Emoji_Presentation=_no}', "");
    Expect(1, 129785, '\P{^Emoji_Presentation=_no}', "");
    Expect(0, 129784, '\p{Emoji_Presentation=_no}', "");
    Expect(1, 129784, '\p{^Emoji_Presentation=_no}', "");
    Expect(1, 129784, '\P{Emoji_Presentation=_no}', "");
    Expect(0, 129784, '\P{^Emoji_Presentation=_no}', "");
    Error('\p{EPres= :=N}');
    Error('\P{EPres= :=N}');
    Expect(1, 129785, '\p{EPres=:\AN\z:}', "");;
    Expect(0, 129784, '\p{EPres=:\AN\z:}', "");;
    Expect(1, 129785, '\p{EPres=n}', "");
    Expect(0, 129785, '\p{^EPres=n}', "");
    Expect(0, 129785, '\P{EPres=n}', "");
    Expect(1, 129785, '\P{^EPres=n}', "");
    Expect(0, 129784, '\p{EPres=n}', "");
    Expect(1, 129784, '\p{^EPres=n}', "");
    Expect(1, 129784, '\P{EPres=n}', "");
    Expect(0, 129784, '\P{^EPres=n}', "");
    Expect(1, 129785, '\p{EPres=:\An\z:}', "");;
    Expect(0, 129784, '\p{EPres=:\An\z:}', "");;
    Expect(1, 129785, '\p{EPres= _n}', "");
    Expect(0, 129785, '\p{^EPres= _n}', "");
    Expect(0, 129785, '\P{EPres= _n}', "");
    Expect(1, 129785, '\P{^EPres= _n}', "");
    Expect(0, 129784, '\p{EPres= _n}', "");
    Expect(1, 129784, '\p{^EPres= _n}', "");
    Expect(1, 129784, '\P{EPres= _n}', "");
    Expect(0, 129784, '\P{^EPres= _n}', "");
    Error('\p{Is_Emoji_Presentation=:=	-F}');
    Error('\P{Is_Emoji_Presentation=:=	-F}');
    Expect(1, 129785, '\p{Is_Emoji_Presentation=f}', "");
    Expect(0, 129785, '\p{^Is_Emoji_Presentation=f}', "");
    Expect(0, 129785, '\P{Is_Emoji_Presentation=f}', "");
    Expect(1, 129785, '\P{^Is_Emoji_Presentation=f}', "");
    Expect(0, 129784, '\p{Is_Emoji_Presentation=f}', "");
    Expect(1, 129784, '\p{^Is_Emoji_Presentation=f}', "");
    Expect(1, 129784, '\P{Is_Emoji_Presentation=f}', "");
    Expect(0, 129784, '\P{^Is_Emoji_Presentation=f}', "");
    Expect(1, 129785, '\p{Is_Emoji_Presentation=	F}', "");
    Expect(0, 129785, '\p{^Is_Emoji_Presentation=	F}', "");
    Expect(0, 129785, '\P{Is_Emoji_Presentation=	F}', "");
    Expect(1, 129785, '\P{^Is_Emoji_Presentation=	F}', "");
    Expect(0, 129784, '\p{Is_Emoji_Presentation=	F}', "");
    Expect(1, 129784, '\p{^Is_Emoji_Presentation=	F}', "");
    Expect(1, 129784, '\P{Is_Emoji_Presentation=	F}', "");
    Expect(0, 129784, '\P{^Is_Emoji_Presentation=	F}', "");
    Error('\p{Is_EPres: :=	_false}');
    Error('\P{Is_EPres: :=	_false}');
    Expect(1, 129785, '\p{Is_EPres=false}', "");
    Expect(0, 129785, '\p{^Is_EPres=false}', "");
    Expect(0, 129785, '\P{Is_EPres=false}', "");
    Expect(1, 129785, '\P{^Is_EPres=false}', "");
    Expect(0, 129784, '\p{Is_EPres=false}', "");
    Expect(1, 129784, '\p{^Is_EPres=false}', "");
    Expect(1, 129784, '\P{Is_EPres=false}', "");
    Expect(0, 129784, '\P{^Is_EPres=false}', "");
    Expect(1, 129785, '\p{Is_EPres:   -False}', "");
    Expect(0, 129785, '\p{^Is_EPres:   -False}', "");
    Expect(0, 129785, '\P{Is_EPres:   -False}', "");
    Expect(1, 129785, '\P{^Is_EPres:   -False}', "");
    Expect(0, 129784, '\p{Is_EPres:   -False}', "");
    Expect(1, 129784, '\p{^Is_EPres:   -False}', "");
    Expect(1, 129784, '\P{Is_EPres:   -False}', "");
    Expect(0, 129784, '\P{^Is_EPres:   -False}', "");
    Error('\p{Emoji_Presentation=:=_yes}');
    Error('\P{Emoji_Presentation=:=_yes}');
    Expect(1, 129784, '\p{Emoji_Presentation=:\AYes\z:}', "");;
    Expect(0, 129785, '\p{Emoji_Presentation=:\AYes\z:}', "");;
    Expect(1, 129784, '\p{Emoji_Presentation=yes}', "");
    Expect(0, 129784, '\p{^Emoji_Presentation=yes}', "");
    Expect(0, 129784, '\P{Emoji_Presentation=yes}', "");
    Expect(1, 129784, '\P{^Emoji_Presentation=yes}', "");
    Expect(0, 129785, '\p{Emoji_Presentation=yes}', "");
    Expect(1, 129785, '\p{^Emoji_Presentation=yes}', "");
    Expect(1, 129785, '\P{Emoji_Presentation=yes}', "");
    Expect(0, 129785, '\P{^Emoji_Presentation=yes}', "");
    Expect(1, 129784, '\p{Emoji_Presentation=:\Ayes\z:}', "");;
    Expect(0, 129785, '\p{Emoji_Presentation=:\Ayes\z:}', "");;
    Expect(1, 129784, '\p{Emoji_Presentation=- Yes}', "");
    Expect(0, 129784, '\p{^Emoji_Presentation=- Yes}', "");
    Expect(0, 129784, '\P{Emoji_Presentation=- Yes}', "");
    Expect(1, 129784, '\P{^Emoji_Presentation=- Yes}', "");
    Expect(0, 129785, '\p{Emoji_Presentation=- Yes}', "");
    Expect(1, 129785, '\p{^Emoji_Presentation=- Yes}', "");
    Expect(1, 129785, '\P{Emoji_Presentation=- Yes}', "");
    Expect(0, 129785, '\P{^Emoji_Presentation=- Yes}', "");
    Error('\p{EPres=	_y/a/}');
    Error('\P{EPres=	_y/a/}');
    Expect(1, 129784, '\p{EPres=:\AY\z:}', "");;
    Expect(0, 129785, '\p{EPres=:\AY\z:}', "");;
    Expect(1, 129784, '\p{EPres=y}', "");
    Expect(0, 129784, '\p{^EPres=y}', "");
    Expect(0, 129784, '\P{EPres=y}', "");
    Expect(1, 129784, '\P{^EPres=y}', "");
    Expect(0, 129785, '\p{EPres=y}', "");
    Expect(1, 129785, '\p{^EPres=y}', "");
    Expect(1, 129785, '\P{EPres=y}', "");
    Expect(0, 129785, '\P{^EPres=y}', "");
    Expect(1, 129784, '\p{EPres=:\Ay\z:}', "");;
    Expect(0, 129785, '\p{EPres=:\Ay\z:}', "");;
    Expect(1, 129784, '\p{EPres= -y}', "");
    Expect(0, 129784, '\p{^EPres= -y}', "");
    Expect(0, 129784, '\P{EPres= -y}', "");
    Expect(1, 129784, '\P{^EPres= -y}', "");
    Expect(0, 129785, '\p{EPres= -y}', "");
    Expect(1, 129785, '\p{^EPres= -y}', "");
    Expect(1, 129785, '\P{EPres= -y}', "");
    Expect(0, 129785, '\P{^EPres= -y}', "");
    Error('\p{Is_Emoji_Presentation=:= 	T}');
    Error('\P{Is_Emoji_Presentation=:= 	T}');
    Expect(1, 129784, '\p{Is_Emoji_Presentation=t}', "");
    Expect(0, 129784, '\p{^Is_Emoji_Presentation=t}', "");
    Expect(0, 129784, '\P{Is_Emoji_Presentation=t}', "");
    Expect(1, 129784, '\P{^Is_Emoji_Presentation=t}', "");
    Expect(0, 129785, '\p{Is_Emoji_Presentation=t}', "");
    Expect(1, 129785, '\p{^Is_Emoji_Presentation=t}', "");
    Expect(1, 129785, '\P{Is_Emoji_Presentation=t}', "");
    Expect(0, 129785, '\P{^Is_Emoji_Presentation=t}', "");
    Expect(1, 129784, '\p{Is_Emoji_Presentation=--T}', "");
    Expect(0, 129784, '\p{^Is_Emoji_Presentation=--T}', "");
    Expect(0, 129784, '\P{Is_Emoji_Presentation=--T}', "");
    Expect(1, 129784, '\P{^Is_Emoji_Presentation=--T}', "");
    Expect(0, 129785, '\p{Is_Emoji_Presentation=--T}', "");
    Expect(1, 129785, '\p{^Is_Emoji_Presentation=--T}', "");
    Expect(1, 129785, '\P{Is_Emoji_Presentation=--T}', "");
    Expect(0, 129785, '\P{^Is_Emoji_Presentation=--T}', "");
    Error('\p{Is_EPres=/a/  TRUE}');
    Error('\P{Is_EPres=/a/  TRUE}');
    Expect(1, 129784, '\p{Is_EPres:   true}', "");
    Expect(0, 129784, '\p{^Is_EPres:   true}', "");
    Expect(0, 129784, '\P{Is_EPres:   true}', "");
    Expect(1, 129784, '\P{^Is_EPres:   true}', "");
    Expect(0, 129785, '\p{Is_EPres:   true}', "");
    Expect(1, 129785, '\p{^Is_EPres:   true}', "");
    Expect(1, 129785, '\P{Is_EPres:   true}', "");
    Expect(0, 129785, '\P{^Is_EPres:   true}', "");
    Expect(1, 129784, '\p{Is_EPres=_-true}', "");
    Expect(0, 129784, '\p{^Is_EPres=_-true}', "");
    Expect(0, 129784, '\P{Is_EPres=_-true}', "");
    Expect(1, 129784, '\P{^Is_EPres=_-true}', "");
    Expect(0, 129785, '\p{Is_EPres=_-true}', "");
    Expect(1, 129785, '\p{^Is_EPres=_-true}', "");
    Expect(1, 129785, '\P{Is_EPres=_-true}', "");
    Expect(0, 129785, '\P{^Is_EPres=_-true}', "");
    Error('\p{equivalentunifiedideograph}');
    Error('\P{equivalentunifiedideograph}');
    Error('\p{equideo}');
    Error('\P{equideo}');
    Error('\p{Extender=:=- NO}');
    Error('\P{Extender=:=- NO}');
    Expect(1, 125255, '\p{Extender=:\ANo\z:}', "");;
    Expect(0, 125254, '\p{Extender=:\ANo\z:}', "");;
    Expect(1, 125255, '\p{Extender:no}', "");
    Expect(0, 125255, '\p{^Extender:no}', "");
    Expect(0, 125255, '\P{Extender:no}', "");
    Expect(1, 125255, '\P{^Extender:no}', "");
    Expect(0, 125254, '\p{Extender:no}', "");
    Expect(1, 125254, '\p{^Extender:no}', "");
    Expect(1, 125254, '\P{Extender:no}', "");
    Expect(0, 125254, '\P{^Extender:no}', "");
    Expect(1, 125255, '\p{Extender=:\Ano\z:}', "");;
    Expect(0, 125254, '\p{Extender=:\Ano\z:}', "");;
    Expect(1, 125255, '\p{Extender=_	no}', "");
    Expect(0, 125255, '\p{^Extender=_	no}', "");
    Expect(0, 125255, '\P{Extender=_	no}', "");
    Expect(1, 125255, '\P{^Extender=_	no}', "");
    Expect(0, 125254, '\p{Extender=_	no}', "");
    Expect(1, 125254, '\p{^Extender=_	no}', "");
    Expect(1, 125254, '\P{Extender=_	no}', "");
    Expect(0, 125254, '\P{^Extender=_	no}', "");
    Error('\p{Ext=_n/a/}');
    Error('\P{Ext=_n/a/}');
    Expect(1, 125255, '\p{Ext=:\AN\z:}', "");;
    Expect(0, 125254, '\p{Ext=:\AN\z:}', "");;
    Expect(1, 125255, '\p{Ext=n}', "");
    Expect(0, 125255, '\p{^Ext=n}', "");
    Expect(0, 125255, '\P{Ext=n}', "");
    Expect(1, 125255, '\P{^Ext=n}', "");
    Expect(0, 125254, '\p{Ext=n}', "");
    Expect(1, 125254, '\p{^Ext=n}', "");
    Expect(1, 125254, '\P{Ext=n}', "");
    Expect(0, 125254, '\P{^Ext=n}', "");
    Expect(1, 125255, '\p{Ext=:\An\z:}', "");;
    Expect(0, 125254, '\p{Ext=:\An\z:}', "");;
    Expect(1, 125255, '\p{Ext=-n}', "");
    Expect(0, 125255, '\p{^Ext=-n}', "");
    Expect(0, 125255, '\P{Ext=-n}', "");
    Expect(1, 125255, '\P{^Ext=-n}', "");
    Expect(0, 125254, '\p{Ext=-n}', "");
    Expect(1, 125254, '\p{^Ext=-n}', "");
    Expect(1, 125254, '\P{Ext=-n}', "");
    Expect(0, 125254, '\P{^Ext=-n}', "");
    Error('\p{Is_Extender=  F:=}');
    Error('\P{Is_Extender=  F:=}');
    Expect(1, 125255, '\p{Is_Extender=f}', "");
    Expect(0, 125255, '\p{^Is_Extender=f}', "");
    Expect(0, 125255, '\P{Is_Extender=f}', "");
    Expect(1, 125255, '\P{^Is_Extender=f}', "");
    Expect(0, 125254, '\p{Is_Extender=f}', "");
    Expect(1, 125254, '\p{^Is_Extender=f}', "");
    Expect(1, 125254, '\P{Is_Extender=f}', "");
    Expect(0, 125254, '\P{^Is_Extender=f}', "");
    Expect(1, 125255, '\p{Is_Extender=- F}', "");
    Expect(0, 125255, '\p{^Is_Extender=- F}', "");
    Expect(0, 125255, '\P{Is_Extender=- F}', "");
    Expect(1, 125255, '\P{^Is_Extender=- F}', "");
    Expect(0, 125254, '\p{Is_Extender=- F}', "");
    Expect(1, 125254, '\p{^Is_Extender=- F}', "");
    Expect(1, 125254, '\P{Is_Extender=- F}', "");
    Expect(0, 125254, '\P{^Is_Extender=- F}', "");
    Error('\p{Is_Ext:   :=-_FALSE}');
    Error('\P{Is_Ext:   :=-_FALSE}');
    Expect(1, 125255, '\p{Is_Ext=false}', "");
    Expect(0, 125255, '\p{^Is_Ext=false}', "");
    Expect(0, 125255, '\P{Is_Ext=false}', "");
    Expect(1, 125255, '\P{^Is_Ext=false}', "");
    Expect(0, 125254, '\p{Is_Ext=false}', "");
    Expect(1, 125254, '\p{^Is_Ext=false}', "");
    Expect(1, 125254, '\P{Is_Ext=false}', "");
    Expect(0, 125254, '\P{^Is_Ext=false}', "");
    Expect(1, 125255, '\p{Is_Ext=_FALSE}', "");
    Expect(0, 125255, '\p{^Is_Ext=_FALSE}', "");
    Expect(0, 125255, '\P{Is_Ext=_FALSE}', "");
    Expect(1, 125255, '\P{^Is_Ext=_FALSE}', "");
    Expect(0, 125254, '\p{Is_Ext=_FALSE}', "");
    Expect(1, 125254, '\p{^Is_Ext=_FALSE}', "");
    Expect(1, 125254, '\P{Is_Ext=_FALSE}', "");
    Expect(0, 125254, '\P{^Is_Ext=_FALSE}', "");
    Error('\p{Extender=_	YES/a/}');
    Error('\P{Extender=_	YES/a/}');
    Expect(1, 125254, '\p{Extender=:\AYes\z:}', "");;
    Expect(0, 125255, '\p{Extender=:\AYes\z:}', "");;
    Expect(1, 125254, '\p{Extender=yes}', "");
    Expect(0, 125254, '\p{^Extender=yes}', "");
    Expect(0, 125254, '\P{Extender=yes}', "");
    Expect(1, 125254, '\P{^Extender=yes}', "");
    Expect(0, 125255, '\p{Extender=yes}', "");
    Expect(1, 125255, '\p{^Extender=yes}', "");
    Expect(1, 125255, '\P{Extender=yes}', "");
    Expect(0, 125255, '\P{^Extender=yes}', "");
    Expect(1, 125254, '\p{Extender=:\Ayes\z:}', "");;
    Expect(0, 125255, '\p{Extender=:\Ayes\z:}', "");;
    Expect(1, 125254, '\p{Extender:   -YES}', "");
    Expect(0, 125254, '\p{^Extender:   -YES}', "");
    Expect(0, 125254, '\P{Extender:   -YES}', "");
    Expect(1, 125254, '\P{^Extender:   -YES}', "");
    Expect(0, 125255, '\p{Extender:   -YES}', "");
    Expect(1, 125255, '\p{^Extender:   -YES}', "");
    Expect(1, 125255, '\P{Extender:   -YES}', "");
    Expect(0, 125255, '\P{^Extender:   -YES}', "");
    Error('\p{Ext=_Y/a/}');
    Error('\P{Ext=_Y/a/}');
    Expect(1, 125254, '\p{Ext=:\AY\z:}', "");;
    Expect(0, 125255, '\p{Ext=:\AY\z:}', "");;
    Expect(1, 125254, '\p{Ext=y}', "");
    Expect(0, 125254, '\p{^Ext=y}', "");
    Expect(0, 125254, '\P{Ext=y}', "");
    Expect(1, 125254, '\P{^Ext=y}', "");
    Expect(0, 125255, '\p{Ext=y}', "");
    Expect(1, 125255, '\p{^Ext=y}', "");
    Expect(1, 125255, '\P{Ext=y}', "");
    Expect(0, 125255, '\P{^Ext=y}', "");
    Expect(1, 125254, '\p{Ext=:\Ay\z:}', "");;
    Expect(0, 125255, '\p{Ext=:\Ay\z:}', "");;
    Expect(1, 125254, '\p{Ext=	_Y}', "");
    Expect(0, 125254, '\p{^Ext=	_Y}', "");
    Expect(0, 125254, '\P{Ext=	_Y}', "");
    Expect(1, 125254, '\P{^Ext=	_Y}', "");
    Expect(0, 125255, '\p{Ext=	_Y}', "");
    Expect(1, 125255, '\p{^Ext=	_Y}', "");
    Expect(1, 125255, '\P{Ext=	_Y}', "");
    Expect(0, 125255, '\P{^Ext=	_Y}', "");
    Error('\p{Is_Extender:  T/a/}');
    Error('\P{Is_Extender:  T/a/}');
    Expect(1, 125254, '\p{Is_Extender=t}', "");
    Expect(0, 125254, '\p{^Is_Extender=t}', "");
    Expect(0, 125254, '\P{Is_Extender=t}', "");
    Expect(1, 125254, '\P{^Is_Extender=t}', "");
    Expect(0, 125255, '\p{Is_Extender=t}', "");
    Expect(1, 125255, '\p{^Is_Extender=t}', "");
    Expect(1, 125255, '\P{Is_Extender=t}', "");
    Expect(0, 125255, '\P{^Is_Extender=t}', "");
    Expect(1, 125254, '\p{Is_Extender=  t}', "");
    Expect(0, 125254, '\p{^Is_Extender=  t}', "");
    Expect(0, 125254, '\P{Is_Extender=  t}', "");
    Expect(1, 125254, '\P{^Is_Extender=  t}', "");
    Expect(0, 125255, '\p{Is_Extender=  t}', "");
    Expect(1, 125255, '\p{^Is_Extender=  t}', "");
    Expect(1, 125255, '\P{Is_Extender=  t}', "");
    Expect(0, 125255, '\P{^Is_Extender=  t}', "");
    Error('\p{Is_Ext=- True:=}');
    Error('\P{Is_Ext=- True:=}');
    Expect(1, 125254, '\p{Is_Ext=true}', "");
    Expect(0, 125254, '\p{^Is_Ext=true}', "");
    Expect(0, 125254, '\P{Is_Ext=true}', "");
    Expect(1, 125254, '\P{^Is_Ext=true}', "");
    Expect(0, 125255, '\p{Is_Ext=true}', "");
    Expect(1, 125255, '\p{^Is_Ext=true}', "");
    Expect(1, 125255, '\P{Is_Ext=true}', "");
    Expect(0, 125255, '\P{^Is_Ext=true}', "");
    Expect(1, 125254, '\p{Is_Ext=	True}', "");
    Expect(0, 125254, '\p{^Is_Ext=	True}', "");
    Expect(0, 125254, '\P{Is_Ext=	True}', "");
    Expect(1, 125254, '\P{^Is_Ext=	True}', "");
    Expect(0, 125255, '\p{Is_Ext=	True}', "");
    Expect(1, 125255, '\p{^Is_Ext=	True}', "");
    Expect(1, 125255, '\P{Is_Ext=	True}', "");
    Expect(0, 125255, '\P{^Is_Ext=	True}', "");
    Error('\p{Extended_Pictographic=		NO:=}');
    Error('\P{Extended_Pictographic=		NO:=}');
    Expect(1, 131072, '\p{Extended_Pictographic=:\ANo\z:}', "");;
    Expect(0, 131069, '\p{Extended_Pictographic=:\ANo\z:}', "");;
    Expect(1, 131072, '\p{Extended_Pictographic=no}', "");
    Expect(0, 131072, '\p{^Extended_Pictographic=no}', "");
    Expect(0, 131072, '\P{Extended_Pictographic=no}', "");
    Expect(1, 131072, '\P{^Extended_Pictographic=no}', "");
    Expect(0, 131069, '\p{Extended_Pictographic=no}', "");
    Expect(1, 131069, '\p{^Extended_Pictographic=no}', "");
    Expect(1, 131069, '\P{Extended_Pictographic=no}', "");
    Expect(0, 131069, '\P{^Extended_Pictographic=no}', "");
    Expect(1, 131072, '\p{Extended_Pictographic=:\Ano\z:}', "");;
    Expect(0, 131069, '\p{Extended_Pictographic=:\Ano\z:}', "");;
    Expect(1, 131072, '\p{Extended_Pictographic=_	NO}', "");
    Expect(0, 131072, '\p{^Extended_Pictographic=_	NO}', "");
    Expect(0, 131072, '\P{Extended_Pictographic=_	NO}', "");
    Expect(1, 131072, '\P{^Extended_Pictographic=_	NO}', "");
    Expect(0, 131069, '\p{Extended_Pictographic=_	NO}', "");
    Expect(1, 131069, '\p{^Extended_Pictographic=_	NO}', "");
    Expect(1, 131069, '\P{Extended_Pictographic=_	NO}', "");
    Expect(0, 131069, '\P{^Extended_Pictographic=_	NO}', "");
    Error('\p{ExtPict=/a/	N}');
    Error('\P{ExtPict=/a/	N}');
    Expect(1, 131072, '\p{ExtPict=:\AN\z:}', "");;
    Expect(0, 131069, '\p{ExtPict=:\AN\z:}', "");;
    Expect(1, 131072, '\p{ExtPict=n}', "");
    Expect(0, 131072, '\p{^ExtPict=n}', "");
    Expect(0, 131072, '\P{ExtPict=n}', "");
    Expect(1, 131072, '\P{^ExtPict=n}', "");
    Expect(0, 131069, '\p{ExtPict=n}', "");
    Expect(1, 131069, '\p{^ExtPict=n}', "");
    Expect(1, 131069, '\P{ExtPict=n}', "");
    Expect(0, 131069, '\P{^ExtPict=n}', "");
    Expect(1, 131072, '\p{ExtPict=:\An\z:}', "");;
    Expect(0, 131069, '\p{ExtPict=:\An\z:}', "");;
    Expect(1, 131072, '\p{ExtPict=__N}', "");
    Expect(0, 131072, '\p{^ExtPict=__N}', "");
    Expect(0, 131072, '\P{ExtPict=__N}', "");
    Expect(1, 131072, '\P{^ExtPict=__N}', "");
    Expect(0, 131069, '\p{ExtPict=__N}', "");
    Expect(1, 131069, '\p{^ExtPict=__N}', "");
    Expect(1, 131069, '\P{ExtPict=__N}', "");
    Expect(0, 131069, '\P{^ExtPict=__N}', "");
    Error('\p{Is_Extended_Pictographic=_f/a/}');
    Error('\P{Is_Extended_Pictographic=_f/a/}');
    Expect(1, 131072, '\p{Is_Extended_Pictographic=f}', "");
    Expect(0, 131072, '\p{^Is_Extended_Pictographic=f}', "");
    Expect(0, 131072, '\P{Is_Extended_Pictographic=f}', "");
    Expect(1, 131072, '\P{^Is_Extended_Pictographic=f}', "");
    Expect(0, 131069, '\p{Is_Extended_Pictographic=f}', "");
    Expect(1, 131069, '\p{^Is_Extended_Pictographic=f}', "");
    Expect(1, 131069, '\P{Is_Extended_Pictographic=f}', "");
    Expect(0, 131069, '\P{^Is_Extended_Pictographic=f}', "");
    Expect(1, 131072, '\p{Is_Extended_Pictographic= 	F}', "");
    Expect(0, 131072, '\p{^Is_Extended_Pictographic= 	F}', "");
    Expect(0, 131072, '\P{Is_Extended_Pictographic= 	F}', "");
    Expect(1, 131072, '\P{^Is_Extended_Pictographic= 	F}', "");
    Expect(0, 131069, '\p{Is_Extended_Pictographic= 	F}', "");
    Expect(1, 131069, '\p{^Is_Extended_Pictographic= 	F}', "");
    Expect(1, 131069, '\P{Is_Extended_Pictographic= 	F}', "");
    Expect(0, 131069, '\P{^Is_Extended_Pictographic= 	F}', "");
    Error('\p{Is_ExtPict= /a/False}');
    Error('\P{Is_ExtPict= /a/False}');
    Expect(1, 131072, '\p{Is_ExtPict=false}', "");
    Expect(0, 131072, '\p{^Is_ExtPict=false}', "");
    Expect(0, 131072, '\P{Is_ExtPict=false}', "");
    Expect(1, 131072, '\P{^Is_ExtPict=false}', "");
    Expect(0, 131069, '\p{Is_ExtPict=false}', "");
    Expect(1, 131069, '\p{^Is_ExtPict=false}', "");
    Expect(1, 131069, '\P{Is_ExtPict=false}', "");
    Expect(0, 131069, '\P{^Is_ExtPict=false}', "");
    Expect(1, 131072, '\p{Is_ExtPict=_False}', "");
    Expect(0, 131072, '\p{^Is_ExtPict=_False}', "");
    Expect(0, 131072, '\P{Is_ExtPict=_False}', "");
    Expect(1, 131072, '\P{^Is_ExtPict=_False}', "");
    Expect(0, 131069, '\p{Is_ExtPict=_False}', "");
    Expect(1, 131069, '\p{^Is_ExtPict=_False}', "");
    Expect(1, 131069, '\P{Is_ExtPict=_False}', "");
    Expect(0, 131069, '\P{^Is_ExtPict=_False}', "");
    Error('\p{Extended_Pictographic= _yes:=}');
    Error('\P{Extended_Pictographic= _yes:=}');
    Expect(1, 131069, '\p{Extended_Pictographic=:\AYes\z:}', "");;
    Expect(0, 131072, '\p{Extended_Pictographic=:\AYes\z:}', "");;
    Expect(1, 131069, '\p{Extended_Pictographic=yes}', "");
    Expect(0, 131069, '\p{^Extended_Pictographic=yes}', "");
    Expect(0, 131069, '\P{Extended_Pictographic=yes}', "");
    Expect(1, 131069, '\P{^Extended_Pictographic=yes}', "");
    Expect(0, 131072, '\p{Extended_Pictographic=yes}', "");
    Expect(1, 131072, '\p{^Extended_Pictographic=yes}', "");
    Expect(1, 131072, '\P{Extended_Pictographic=yes}', "");
    Expect(0, 131072, '\P{^Extended_Pictographic=yes}', "");
    Expect(1, 131069, '\p{Extended_Pictographic=:\Ayes\z:}', "");;
    Expect(0, 131072, '\p{Extended_Pictographic=:\Ayes\z:}', "");;
    Error('\p{ExtPict=- Y/a/}');
    Error('\P{ExtPict=- Y/a/}');
    Expect(1, 131069, '\p{ExtPict=:\AY\z:}', "");;
    Expect(0, 131072, '\p{ExtPict=:\AY\z:}', "");;
    Expect(1, 131069, '\p{ExtPict:y}', "");
    Expect(0, 131069, '\p{^ExtPict:y}', "");
    Expect(0, 131069, '\P{ExtPict:y}', "");
    Expect(1, 131069, '\P{^ExtPict:y}', "");
    Expect(0, 131072, '\p{ExtPict:y}', "");
    Expect(1, 131072, '\p{^ExtPict:y}', "");
    Expect(1, 131072, '\P{ExtPict:y}', "");
    Expect(0, 131072, '\P{^ExtPict:y}', "");
    Expect(1, 131069, '\p{ExtPict=:\Ay\z:}', "");;
    Expect(0, 131072, '\p{ExtPict=:\Ay\z:}', "");;
    Expect(1, 131069, '\p{ExtPict= _Y}', "");
    Expect(0, 131069, '\p{^ExtPict= _Y}', "");
    Expect(0, 131069, '\P{ExtPict= _Y}', "");
    Expect(1, 131069, '\P{^ExtPict= _Y}', "");
    Expect(0, 131072, '\p{ExtPict= _Y}', "");
    Expect(1, 131072, '\p{^ExtPict= _Y}', "");
    Expect(1, 131072, '\P{ExtPict= _Y}', "");
    Expect(0, 131072, '\P{^ExtPict= _Y}', "");
    Error('\p{Is_Extended_Pictographic=	T/a/}');
    Error('\P{Is_Extended_Pictographic=	T/a/}');
    Expect(1, 131069, '\p{Is_Extended_Pictographic=t}', "");
    Expect(0, 131069, '\p{^Is_Extended_Pictographic=t}', "");
    Expect(0, 131069, '\P{Is_Extended_Pictographic=t}', "");
    Expect(1, 131069, '\P{^Is_Extended_Pictographic=t}', "");
    Expect(0, 131072, '\p{Is_Extended_Pictographic=t}', "");
    Expect(1, 131072, '\p{^Is_Extended_Pictographic=t}', "");
    Expect(1, 131072, '\P{Is_Extended_Pictographic=t}', "");
    Expect(0, 131072, '\P{^Is_Extended_Pictographic=t}', "");
    Expect(1, 131069, '\p{Is_Extended_Pictographic=  t}', "");
    Expect(0, 131069, '\p{^Is_Extended_Pictographic=  t}', "");
    Expect(0, 131069, '\P{Is_Extended_Pictographic=  t}', "");
    Expect(1, 131069, '\P{^Is_Extended_Pictographic=  t}', "");
    Expect(0, 131072, '\p{Is_Extended_Pictographic=  t}', "");
    Expect(1, 131072, '\p{^Is_Extended_Pictographic=  t}', "");
    Expect(1, 131072, '\P{Is_Extended_Pictographic=  t}', "");
    Expect(0, 131072, '\P{^Is_Extended_Pictographic=  t}', "");
    Error('\p{Is_ExtPict: _ True/a/}');
    Error('\P{Is_ExtPict: _ True/a/}');
    Expect(1, 131069, '\p{Is_ExtPict=true}', "");
    Expect(0, 131069, '\p{^Is_ExtPict=true}', "");
    Expect(0, 131069, '\P{Is_ExtPict=true}', "");
    Expect(1, 131069, '\P{^Is_ExtPict=true}', "");
    Expect(0, 131072, '\p{Is_ExtPict=true}', "");
    Expect(1, 131072, '\p{^Is_ExtPict=true}', "");
    Expect(1, 131072, '\P{Is_ExtPict=true}', "");
    Expect(0, 131072, '\P{^Is_ExtPict=true}', "");
    Expect(1, 131069, '\p{Is_ExtPict=	 True}', "");
    Expect(0, 131069, '\p{^Is_ExtPict=	 True}', "");
    Expect(0, 131069, '\P{Is_ExtPict=	 True}', "");
    Expect(1, 131069, '\P{^Is_ExtPict=	 True}', "");
    Expect(0, 131072, '\p{Is_ExtPict=	 True}', "");
    Expect(1, 131072, '\p{^Is_ExtPict=	 True}', "");
    Expect(1, 131072, '\P{Is_ExtPict=	 True}', "");
    Expect(0, 131072, '\P{^Is_ExtPict=	 True}', "");
    Error('\p{fcnfkcclosure}');
    Error('\P{fcnfkcclosure}');
    Error('\p{fcnfkc}');
    Error('\P{fcnfkc}');
    Error('\p{generalcategory}');
    Error('\P{generalcategory}');
    Error('\p{gc}');
    Error('\P{gc}');
    Error('\p{category}');
    Error('\P{category}');
    Error('\p{General_Category=	-Other:=}');
    Error('\P{General_Category=	-Other:=}');
    Expect(1, 918000, '\p{General_Category=:\AOther\z:}', "");;
    Expect(0, 917999, '\p{General_Category=:\AOther\z:}', "");;
    Expect(1, 918000, '\p{General_Category:other}', "");
    Expect(0, 918000, '\p{^General_Category:other}', "");
    Expect(0, 918000, '\P{General_Category:other}', "");
    Expect(1, 918000, '\P{^General_Category:other}', "");
    Expect(0, 917999, '\p{General_Category:other}', "");
    Expect(1, 917999, '\p{^General_Category:other}', "");
    Expect(1, 917999, '\P{General_Category:other}', "");
    Expect(0, 917999, '\P{^General_Category:other}', "");
    Expect(1, 918000, '\p{General_Category=:\Aother\z:}', "");;
    Expect(0, 917999, '\p{General_Category=:\Aother\z:}', "");;
    Expect(1, 918000, '\p{General_Category=	 OTHER}', "");
    Expect(0, 918000, '\p{^General_Category=	 OTHER}', "");
    Expect(0, 918000, '\P{General_Category=	 OTHER}', "");
    Expect(1, 918000, '\P{^General_Category=	 OTHER}', "");
    Expect(0, 917999, '\p{General_Category=	 OTHER}', "");
    Expect(1, 917999, '\p{^General_Category=	 OTHER}', "");
    Expect(1, 917999, '\P{General_Category=	 OTHER}', "");
    Expect(0, 917999, '\P{^General_Category=	 OTHER}', "");
    Error('\p{Gc=-/a/C}');
    Error('\P{Gc=-/a/C}');
    Expect(1, 918000, '\p{Gc=:\AC\z:}', "");;
    Expect(0, 917999, '\p{Gc=:\AC\z:}', "");;
    Expect(1, 918000, '\p{Gc=c}', "");
    Expect(0, 918000, '\p{^Gc=c}', "");
    Expect(0, 918000, '\P{Gc=c}', "");
    Expect(1, 918000, '\P{^Gc=c}', "");
    Expect(0, 917999, '\p{Gc=c}', "");
    Expect(1, 917999, '\p{^Gc=c}', "");
    Expect(1, 917999, '\P{Gc=c}', "");
    Expect(0, 917999, '\P{^Gc=c}', "");
    Expect(1, 918000, '\p{Gc=:\Ac\z:}', "");;
    Expect(0, 917999, '\p{Gc=:\Ac\z:}', "");;
    Expect(1, 918000, '\p{Gc=-	c}', "");
    Expect(0, 918000, '\p{^Gc=-	c}', "");
    Expect(0, 918000, '\P{Gc=-	c}', "");
    Expect(1, 918000, '\P{^Gc=-	c}', "");
    Expect(0, 917999, '\p{Gc=-	c}', "");
    Expect(1, 917999, '\p{^Gc=-	c}', "");
    Expect(1, 917999, '\P{Gc=-	c}', "");
    Expect(0, 917999, '\P{^Gc=-	c}', "");
    Error('\p{Category=:= 	Other}');
    Error('\P{Category=:= 	Other}');
    Expect(1, 918000, '\p{Category=:\AOther\z:}', "");;
    Expect(0, 917999, '\p{Category=:\AOther\z:}', "");;
    Expect(1, 918000, '\p{Category=other}', "");
    Expect(0, 918000, '\p{^Category=other}', "");
    Expect(0, 918000, '\P{Category=other}', "");
    Expect(1, 918000, '\P{^Category=other}', "");
    Expect(0, 917999, '\p{Category=other}', "");
    Expect(1, 917999, '\p{^Category=other}', "");
    Expect(1, 917999, '\P{Category=other}', "");
    Expect(0, 917999, '\P{^Category=other}', "");
    Expect(1, 918000, '\p{Category=:\Aother\z:}', "");;
    Expect(0, 917999, '\p{Category=:\Aother\z:}', "");;
    Expect(1, 918000, '\p{Category=	 other}', "");
    Expect(0, 918000, '\p{^Category=	 other}', "");
    Expect(0, 918000, '\P{Category=	 other}', "");
    Expect(1, 918000, '\P{^Category=	 other}', "");
    Expect(0, 917999, '\p{Category=	 other}', "");
    Expect(1, 917999, '\p{^Category=	 other}', "");
    Expect(1, 917999, '\P{Category=	 other}', "");
    Expect(0, 917999, '\P{^Category=	 other}', "");
    Error('\p{Is_General_Category=:=--C}');
    Error('\P{Is_General_Category=:=--C}');
    Expect(1, 918000, '\p{Is_General_Category=c}', "");
    Expect(0, 918000, '\p{^Is_General_Category=c}', "");
    Expect(0, 918000, '\P{Is_General_Category=c}', "");
    Expect(1, 918000, '\P{^Is_General_Category=c}', "");
    Expect(0, 917999, '\p{Is_General_Category=c}', "");
    Expect(1, 917999, '\p{^Is_General_Category=c}', "");
    Expect(1, 917999, '\P{Is_General_Category=c}', "");
    Expect(0, 917999, '\P{^Is_General_Category=c}', "");
    Expect(1, 918000, '\p{Is_General_Category:	-_c}', "");
    Expect(0, 918000, '\p{^Is_General_Category:	-_c}', "");
    Expect(0, 918000, '\P{Is_General_Category:	-_c}', "");
    Expect(1, 918000, '\P{^Is_General_Category:	-_c}', "");
    Expect(0, 917999, '\p{Is_General_Category:	-_c}', "");
    Expect(1, 917999, '\p{^Is_General_Category:	-_c}', "");
    Expect(1, 917999, '\P{Is_General_Category:	-_c}', "");
    Expect(0, 917999, '\P{^Is_General_Category:	-_c}', "");
    Error('\p{Is_Gc=:=OTHER}');
    Error('\P{Is_Gc=:=OTHER}');
    Expect(1, 918000, '\p{Is_Gc=other}', "");
    Expect(0, 918000, '\p{^Is_Gc=other}', "");
    Expect(0, 918000, '\P{Is_Gc=other}', "");
    Expect(1, 918000, '\P{^Is_Gc=other}', "");
    Expect(0, 917999, '\p{Is_Gc=other}', "");
    Expect(1, 917999, '\p{^Is_Gc=other}', "");
    Expect(1, 917999, '\P{Is_Gc=other}', "");
    Expect(0, 917999, '\P{^Is_Gc=other}', "");
    Expect(1, 918000, '\p{Is_Gc= other}', "");
    Expect(0, 918000, '\p{^Is_Gc= other}', "");
    Expect(0, 918000, '\P{Is_Gc= other}', "");
    Expect(1, 918000, '\P{^Is_Gc= other}', "");
    Expect(0, 917999, '\p{Is_Gc= other}', "");
    Expect(1, 917999, '\p{^Is_Gc= other}', "");
    Expect(1, 917999, '\P{Is_Gc= other}', "");
    Expect(0, 917999, '\P{^Is_Gc= other}', "");
    Error('\p{Is_Category=_:=C}');
    Error('\P{Is_Category=_:=C}');
    Expect(1, 918000, '\p{Is_Category=c}', "");
    Expect(0, 918000, '\p{^Is_Category=c}', "");
    Expect(0, 918000, '\P{Is_Category=c}', "");
    Expect(1, 918000, '\P{^Is_Category=c}', "");
    Expect(0, 917999, '\p{Is_Category=c}', "");
    Expect(1, 917999, '\p{^Is_Category=c}', "");
    Expect(1, 917999, '\P{Is_Category=c}', "");
    Expect(0, 917999, '\P{^Is_Category=c}', "");
    Expect(1, 918000, '\p{Is_Category=	C}', "");
    Expect(0, 918000, '\p{^Is_Category=	C}', "");
    Expect(0, 918000, '\P{Is_Category=	C}', "");
    Expect(1, 918000, '\P{^Is_Category=	C}', "");
    Expect(0, 917999, '\p{Is_Category=	C}', "");
    Expect(1, 917999, '\p{^Is_Category=	C}', "");
    Expect(1, 917999, '\P{Is_Category=	C}', "");
    Expect(0, 917999, '\P{^Is_Category=	C}', "");
    Error('\p{General_Category=	/a/Control}');
    Error('\P{General_Category=	/a/Control}');
    Expect(1, 159, '\p{General_Category=:\AControl\z:}', "");;
    Expect(0, 160, '\p{General_Category=:\AControl\z:}', "");;
    Expect(1, 159, '\p{General_Category=control}', "");
    Expect(0, 159, '\p{^General_Category=control}', "");
    Expect(0, 159, '\P{General_Category=control}', "");
    Expect(1, 159, '\P{^General_Category=control}', "");
    Expect(0, 160, '\p{General_Category=control}', "");
    Expect(1, 160, '\p{^General_Category=control}', "");
    Expect(1, 160, '\P{General_Category=control}', "");
    Expect(0, 160, '\P{^General_Category=control}', "");
    Expect(1, 159, '\p{General_Category=:\Acontrol\z:}', "");;
    Expect(0, 160, '\p{General_Category=:\Acontrol\z:}', "");;
    Expect(1, 159, '\p{General_Category=-	Control}', "");
    Expect(0, 159, '\p{^General_Category=-	Control}', "");
    Expect(0, 159, '\P{General_Category=-	Control}', "");
    Expect(1, 159, '\P{^General_Category=-	Control}', "");
    Expect(0, 160, '\p{General_Category=-	Control}', "");
    Expect(1, 160, '\p{^General_Category=-	Control}', "");
    Expect(1, 160, '\P{General_Category=-	Control}', "");
    Expect(0, 160, '\P{^General_Category=-	Control}', "");
    Error('\p{Gc= 	cc/a/}');
    Error('\P{Gc= 	cc/a/}');
    Expect(1, 159, '\p{Gc=:\ACc\z:}', "");;
    Expect(0, 160, '\p{Gc=:\ACc\z:}', "");;
    Expect(1, 159, '\p{Gc=cc}', "");
    Expect(0, 159, '\p{^Gc=cc}', "");
    Expect(0, 159, '\P{Gc=cc}', "");
    Expect(1, 159, '\P{^Gc=cc}', "");
    Expect(0, 160, '\p{Gc=cc}', "");
    Expect(1, 160, '\p{^Gc=cc}', "");
    Expect(1, 160, '\P{Gc=cc}', "");
    Expect(0, 160, '\P{^Gc=cc}', "");
    Expect(1, 159, '\p{Gc=:\Acc\z:}', "");;
    Expect(0, 160, '\p{Gc=:\Acc\z:}', "");;
    Expect(1, 159, '\p{Gc: 	cc}', "");
    Expect(0, 159, '\p{^Gc: 	cc}', "");
    Expect(0, 159, '\P{Gc: 	cc}', "");
    Expect(1, 159, '\P{^Gc: 	cc}', "");
    Expect(0, 160, '\p{Gc: 	cc}', "");
    Expect(1, 160, '\p{^Gc: 	cc}', "");
    Expect(1, 160, '\P{Gc: 	cc}', "");
    Expect(0, 160, '\P{^Gc: 	cc}', "");
    Error('\p{Category=:=-Cntrl}');
    Error('\P{Category=:=-Cntrl}');
    Expect(1, 159, '\p{Category=:\ACntrl\z:}', "");;
    Expect(0, 160, '\p{Category=:\ACntrl\z:}', "");;
    Expect(1, 159, '\p{Category=cntrl}', "");
    Expect(0, 159, '\p{^Category=cntrl}', "");
    Expect(0, 159, '\P{Category=cntrl}', "");
    Expect(1, 159, '\P{^Category=cntrl}', "");
    Expect(0, 160, '\p{Category=cntrl}', "");
    Expect(1, 160, '\p{^Category=cntrl}', "");
    Expect(1, 160, '\P{Category=cntrl}', "");
    Expect(0, 160, '\P{^Category=cntrl}', "");
    Expect(1, 159, '\p{Category=:\Acntrl\z:}', "");;
    Expect(0, 160, '\p{Category=:\Acntrl\z:}', "");;
    Expect(1, 159, '\p{Category=		cntrl}', "");
    Expect(0, 159, '\p{^Category=		cntrl}', "");
    Expect(0, 159, '\P{Category=		cntrl}', "");
    Expect(1, 159, '\P{^Category=		cntrl}', "");
    Expect(0, 160, '\p{Category=		cntrl}', "");
    Expect(1, 160, '\p{^Category=		cntrl}', "");
    Expect(1, 160, '\P{Category=		cntrl}', "");
    Expect(0, 160, '\P{^Category=		cntrl}', "");
    Error('\p{Is_General_Category=/a/	 Control}');
    Error('\P{Is_General_Category=/a/	 Control}');
    Expect(1, 159, '\p{Is_General_Category=control}', "");
    Expect(0, 159, '\p{^Is_General_Category=control}', "");
    Expect(0, 159, '\P{Is_General_Category=control}', "");
    Expect(1, 159, '\P{^Is_General_Category=control}', "");
    Expect(0, 160, '\p{Is_General_Category=control}', "");
    Expect(1, 160, '\p{^Is_General_Category=control}', "");
    Expect(1, 160, '\P{Is_General_Category=control}', "");
    Expect(0, 160, '\P{^Is_General_Category=control}', "");
    Expect(1, 159, '\p{Is_General_Category:   --Control}', "");
    Expect(0, 159, '\p{^Is_General_Category:   --Control}', "");
    Expect(0, 159, '\P{Is_General_Category:   --Control}', "");
    Expect(1, 159, '\P{^Is_General_Category:   --Control}', "");
    Expect(0, 160, '\p{Is_General_Category:   --Control}', "");
    Expect(1, 160, '\p{^Is_General_Category:   --Control}', "");
    Expect(1, 160, '\P{Is_General_Category:   --Control}', "");
    Expect(0, 160, '\P{^Is_General_Category:   --Control}', "");
    Error('\p{Is_Gc= Cc:=}');
    Error('\P{Is_Gc= Cc:=}');
    Expect(1, 159, '\p{Is_Gc=cc}', "");
    Expect(0, 159, '\p{^Is_Gc=cc}', "");
    Expect(0, 159, '\P{Is_Gc=cc}', "");
    Expect(1, 159, '\P{^Is_Gc=cc}', "");
    Expect(0, 160, '\p{Is_Gc=cc}', "");
    Expect(1, 160, '\p{^Is_Gc=cc}', "");
    Expect(1, 160, '\P{Is_Gc=cc}', "");
    Expect(0, 160, '\P{^Is_Gc=cc}', "");
    Expect(1, 159, '\p{Is_Gc= 	Cc}', "");
    Expect(0, 159, '\p{^Is_Gc= 	Cc}', "");
    Expect(0, 159, '\P{Is_Gc= 	Cc}', "");
    Expect(1, 159, '\P{^Is_Gc= 	Cc}', "");
    Expect(0, 160, '\p{Is_Gc= 	Cc}', "");
    Expect(1, 160, '\p{^Is_Gc= 	Cc}', "");
    Expect(1, 160, '\P{Is_Gc= 	Cc}', "");
    Expect(0, 160, '\P{^Is_Gc= 	Cc}', "");
    Error('\p{Is_Category= /a/Cntrl}');
    Error('\P{Is_Category= /a/Cntrl}');
    Expect(1, 159, '\p{Is_Category=cntrl}', "");
    Expect(0, 159, '\p{^Is_Category=cntrl}', "");
    Expect(0, 159, '\P{Is_Category=cntrl}', "");
    Expect(1, 159, '\P{^Is_Category=cntrl}', "");
    Expect(0, 160, '\p{Is_Category=cntrl}', "");
    Expect(1, 160, '\p{^Is_Category=cntrl}', "");
    Expect(1, 160, '\P{Is_Category=cntrl}', "");
    Expect(0, 160, '\P{^Is_Category=cntrl}', "");
    Expect(1, 159, '\p{Is_Category:	__cntrl}', "");
    Expect(0, 159, '\p{^Is_Category:	__cntrl}', "");
    Expect(0, 159, '\P{Is_Category:	__cntrl}', "");
    Expect(1, 159, '\P{^Is_Category:	__cntrl}', "");
    Expect(0, 160, '\p{Is_Category:	__cntrl}', "");
    Expect(1, 160, '\p{^Is_Category:	__cntrl}', "");
    Expect(1, 160, '\P{Is_Category:	__cntrl}', "");
    Expect(0, 160, '\P{^Is_Category:	__cntrl}', "");
    Error('\p{General_Category=--Format:=}');
    Error('\P{General_Category=--Format:=}');
    Expect(1, 917631, '\p{General_Category=:\AFormat\z:}', "");;
    Expect(0, 917632, '\p{General_Category=:\AFormat\z:}', "");;
    Expect(1, 917631, '\p{General_Category=format}', "");
    Expect(0, 917631, '\p{^General_Category=format}', "");
    Expect(0, 917631, '\P{General_Category=format}', "");
    Expect(1, 917631, '\P{^General_Category=format}', "");
    Expect(0, 917632, '\p{General_Category=format}', "");
    Expect(1, 917632, '\p{^General_Category=format}', "");
    Expect(1, 917632, '\P{General_Category=format}', "");
    Expect(0, 917632, '\P{^General_Category=format}', "");
    Expect(1, 917631, '\p{General_Category=:\Aformat\z:}', "");;
    Expect(0, 917632, '\p{General_Category=:\Aformat\z:}', "");;
    Expect(1, 917631, '\p{General_Category=		format}', "");
    Expect(0, 917631, '\p{^General_Category=		format}', "");
    Expect(0, 917631, '\P{General_Category=		format}', "");
    Expect(1, 917631, '\P{^General_Category=		format}', "");
    Expect(0, 917632, '\p{General_Category=		format}', "");
    Expect(1, 917632, '\p{^General_Category=		format}', "");
    Expect(1, 917632, '\P{General_Category=		format}', "");
    Expect(0, 917632, '\P{^General_Category=		format}', "");
    Error('\p{Gc=_:=Cf}');
    Error('\P{Gc=_:=Cf}');
    Expect(1, 917631, '\p{Gc=:\ACf\z:}', "");;
    Expect(0, 917632, '\p{Gc=:\ACf\z:}', "");;
    Expect(1, 917631, '\p{Gc=cf}', "");
    Expect(0, 917631, '\p{^Gc=cf}', "");
    Expect(0, 917631, '\P{Gc=cf}', "");
    Expect(1, 917631, '\P{^Gc=cf}', "");
    Expect(0, 917632, '\p{Gc=cf}', "");
    Expect(1, 917632, '\p{^Gc=cf}', "");
    Expect(1, 917632, '\P{Gc=cf}', "");
    Expect(0, 917632, '\P{^Gc=cf}', "");
    Expect(1, 917631, '\p{Gc=:\Acf\z:}', "");;
    Expect(0, 917632, '\p{Gc=:\Acf\z:}', "");;
    Expect(1, 917631, '\p{Gc=	Cf}', "");
    Expect(0, 917631, '\p{^Gc=	Cf}', "");
    Expect(0, 917631, '\P{Gc=	Cf}', "");
    Expect(1, 917631, '\P{^Gc=	Cf}', "");
    Expect(0, 917632, '\p{Gc=	Cf}', "");
    Expect(1, 917632, '\p{^Gc=	Cf}', "");
    Expect(1, 917632, '\P{Gc=	Cf}', "");
    Expect(0, 917632, '\P{^Gc=	Cf}', "");
    Error('\p{Category=	/a/format}');
    Error('\P{Category=	/a/format}');
    Expect(1, 917631, '\p{Category=:\AFormat\z:}', "");;
    Expect(0, 917632, '\p{Category=:\AFormat\z:}', "");;
    Expect(1, 917631, '\p{Category:format}', "");
    Expect(0, 917631, '\p{^Category:format}', "");
    Expect(0, 917631, '\P{Category:format}', "");
    Expect(1, 917631, '\P{^Category:format}', "");
    Expect(0, 917632, '\p{Category:format}', "");
    Expect(1, 917632, '\p{^Category:format}', "");
    Expect(1, 917632, '\P{Category:format}', "");
    Expect(0, 917632, '\P{^Category:format}', "");
    Expect(1, 917631, '\p{Category=:\Aformat\z:}', "");;
    Expect(0, 917632, '\p{Category=:\Aformat\z:}', "");;
    Expect(1, 917631, '\p{Category=_Format}', "");
    Expect(0, 917631, '\p{^Category=_Format}', "");
    Expect(0, 917631, '\P{Category=_Format}', "");
    Expect(1, 917631, '\P{^Category=_Format}', "");
    Expect(0, 917632, '\p{Category=_Format}', "");
    Expect(1, 917632, '\p{^Category=_Format}', "");
    Expect(1, 917632, '\P{Category=_Format}', "");
    Expect(0, 917632, '\P{^Category=_Format}', "");
    Error('\p{Is_General_Category= _Cf/a/}');
    Error('\P{Is_General_Category= _Cf/a/}');
    Expect(1, 917631, '\p{Is_General_Category=cf}', "");
    Expect(0, 917631, '\p{^Is_General_Category=cf}', "");
    Expect(0, 917631, '\P{Is_General_Category=cf}', "");
    Expect(1, 917631, '\P{^Is_General_Category=cf}', "");
    Expect(0, 917632, '\p{Is_General_Category=cf}', "");
    Expect(1, 917632, '\p{^Is_General_Category=cf}', "");
    Expect(1, 917632, '\P{Is_General_Category=cf}', "");
    Expect(0, 917632, '\P{^Is_General_Category=cf}', "");
    Expect(1, 917631, '\p{Is_General_Category=-	Cf}', "");
    Expect(0, 917631, '\p{^Is_General_Category=-	Cf}', "");
    Expect(0, 917631, '\P{Is_General_Category=-	Cf}', "");
    Expect(1, 917631, '\P{^Is_General_Category=-	Cf}', "");
    Expect(0, 917632, '\p{Is_General_Category=-	Cf}', "");
    Expect(1, 917632, '\p{^Is_General_Category=-	Cf}', "");
    Expect(1, 917632, '\P{Is_General_Category=-	Cf}', "");
    Expect(0, 917632, '\P{^Is_General_Category=-	Cf}', "");
    Error('\p{Is_Gc=:=Format}');
    Error('\P{Is_Gc=:=Format}');
    Expect(1, 917631, '\p{Is_Gc=format}', "");
    Expect(0, 917631, '\p{^Is_Gc=format}', "");
    Expect(0, 917631, '\P{Is_Gc=format}', "");
    Expect(1, 917631, '\P{^Is_Gc=format}', "");
    Expect(0, 917632, '\p{Is_Gc=format}', "");
    Expect(1, 917632, '\p{^Is_Gc=format}', "");
    Expect(1, 917632, '\P{Is_Gc=format}', "");
    Expect(0, 917632, '\P{^Is_Gc=format}', "");
    Expect(1, 917631, '\p{Is_Gc= FORMAT}', "");
    Expect(0, 917631, '\p{^Is_Gc= FORMAT}', "");
    Expect(0, 917631, '\P{Is_Gc= FORMAT}', "");
    Expect(1, 917631, '\P{^Is_Gc= FORMAT}', "");
    Expect(0, 917632, '\p{Is_Gc= FORMAT}', "");
    Expect(1, 917632, '\p{^Is_Gc= FORMAT}', "");
    Expect(1, 917632, '\P{Is_Gc= FORMAT}', "");
    Expect(0, 917632, '\P{^Is_Gc= FORMAT}', "");
    Error('\p{Is_Category=:=- Cf}');
    Error('\P{Is_Category=:=- Cf}');
    Expect(1, 917631, '\p{Is_Category=cf}', "");
    Expect(0, 917631, '\p{^Is_Category=cf}', "");
    Expect(0, 917631, '\P{Is_Category=cf}', "");
    Expect(1, 917631, '\P{^Is_Category=cf}', "");
    Expect(0, 917632, '\p{Is_Category=cf}', "");
    Expect(1, 917632, '\p{^Is_Category=cf}', "");
    Expect(1, 917632, '\P{Is_Category=cf}', "");
    Expect(0, 917632, '\P{^Is_Category=cf}', "");
    Expect(1, 917631, '\p{Is_Category=	 Cf}', "");
    Expect(0, 917631, '\p{^Is_Category=	 Cf}', "");
    Expect(0, 917631, '\P{Is_Category=	 Cf}', "");
    Expect(1, 917631, '\P{^Is_Category=	 Cf}', "");
    Expect(0, 917632, '\p{Is_Category=	 Cf}', "");
    Expect(1, 917632, '\p{^Is_Category=	 Cf}', "");
    Expect(1, 917632, '\P{Is_Category=	 Cf}', "");
    Expect(0, 917632, '\P{^Is_Category=	 Cf}', "");
    Error('\p{General_Category=	:=Unassigned}');
    Error('\P{General_Category=	:=Unassigned}');
    Expect(1, 918000, '\p{General_Category=:\AUnassigned\z:}', "");;
    Expect(0, 1114109, '\p{General_Category=:\AUnassigned\z:}', "");;
    Expect(1, 918000, '\p{General_Category=unassigned}', "");
    Expect(0, 918000, '\p{^General_Category=unassigned}', "");
    Expect(0, 918000, '\P{General_Category=unassigned}', "");
    Expect(1, 918000, '\P{^General_Category=unassigned}', "");
    Expect(0, 1114109, '\p{General_Category=unassigned}', "");
    Expect(1, 1114109, '\p{^General_Category=unassigned}', "");
    Expect(1, 1114109, '\P{General_Category=unassigned}', "");
    Expect(0, 1114109, '\P{^General_Category=unassigned}', "");
    Expect(1, 918000, '\p{General_Category=:\Aunassigned\z:}', "");;
    Expect(0, 1114109, '\p{General_Category=:\Aunassigned\z:}', "");;
    Expect(1, 918000, '\p{General_Category: Unassigned}', "");
    Expect(0, 918000, '\p{^General_Category: Unassigned}', "");
    Expect(0, 918000, '\P{General_Category: Unassigned}', "");
    Expect(1, 918000, '\P{^General_Category: Unassigned}', "");
    Expect(0, 1114109, '\p{General_Category: Unassigned}', "");
    Expect(1, 1114109, '\p{^General_Category: Unassigned}', "");
    Expect(1, 1114109, '\P{General_Category: Unassigned}', "");
    Expect(0, 1114109, '\P{^General_Category: Unassigned}', "");
    Error('\p{Gc=:=_	Cn}');
    Error('\P{Gc=:=_	Cn}');
    Expect(1, 918000, '\p{Gc=:\ACn\z:}', "");;
    Expect(0, 1114109, '\p{Gc=:\ACn\z:}', "");;
    Expect(1, 918000, '\p{Gc=cn}', "");
    Expect(0, 918000, '\p{^Gc=cn}', "");
    Expect(0, 918000, '\P{Gc=cn}', "");
    Expect(1, 918000, '\P{^Gc=cn}', "");
    Expect(0, 1114109, '\p{Gc=cn}', "");
    Expect(1, 1114109, '\p{^Gc=cn}', "");
    Expect(1, 1114109, '\P{Gc=cn}', "");
    Expect(0, 1114109, '\P{^Gc=cn}', "");
    Expect(1, 918000, '\p{Gc=:\Acn\z:}', "");;
    Expect(0, 1114109, '\p{Gc=:\Acn\z:}', "");;
    Expect(1, 918000, '\p{Gc=	 Cn}', "");
    Expect(0, 918000, '\p{^Gc=	 Cn}', "");
    Expect(0, 918000, '\P{Gc=	 Cn}', "");
    Expect(1, 918000, '\P{^Gc=	 Cn}', "");
    Expect(0, 1114109, '\p{Gc=	 Cn}', "");
    Expect(1, 1114109, '\p{^Gc=	 Cn}', "");
    Expect(1, 1114109, '\P{Gc=	 Cn}', "");
    Expect(0, 1114109, '\P{^Gc=	 Cn}', "");
    Error('\p{Category=_unassigned/a/}');
    Error('\P{Category=_unassigned/a/}');
    Expect(1, 918000, '\p{Category=:\AUnassigned\z:}', "");;
    Expect(0, 1114109, '\p{Category=:\AUnassigned\z:}', "");;
    Expect(1, 918000, '\p{Category=unassigned}', "");
    Expect(0, 918000, '\p{^Category=unassigned}', "");
    Expect(0, 918000, '\P{Category=unassigned}', "");
    Expect(1, 918000, '\P{^Category=unassigned}', "");
    Expect(0, 1114109, '\p{Category=unassigned}', "");
    Expect(1, 1114109, '\p{^Category=unassigned}', "");
    Expect(1, 1114109, '\P{Category=unassigned}', "");
    Expect(0, 1114109, '\P{^Category=unassigned}', "");
    Expect(1, 918000, '\p{Category=:\Aunassigned\z:}', "");;
    Expect(0, 1114109, '\p{Category=:\Aunassigned\z:}', "");;
    Expect(1, 918000, '\p{Category:   -Unassigned}', "");
    Expect(0, 918000, '\p{^Category:   -Unassigned}', "");
    Expect(0, 918000, '\P{Category:   -Unassigned}', "");
    Expect(1, 918000, '\P{^Category:   -Unassigned}', "");
    Expect(0, 1114109, '\p{Category:   -Unassigned}', "");
    Expect(1, 1114109, '\p{^Category:   -Unassigned}', "");
    Expect(1, 1114109, '\P{Category:   -Unassigned}', "");
    Expect(0, 1114109, '\P{^Category:   -Unassigned}', "");
    Error('\p{Is_General_Category:/a/--Cn}');
    Error('\P{Is_General_Category:/a/--Cn}');
    Expect(1, 918000, '\p{Is_General_Category=cn}', "");
    Expect(0, 918000, '\p{^Is_General_Category=cn}', "");
    Expect(0, 918000, '\P{Is_General_Category=cn}', "");
    Expect(1, 918000, '\P{^Is_General_Category=cn}', "");
    Expect(0, 1114109, '\p{Is_General_Category=cn}', "");
    Expect(1, 1114109, '\p{^Is_General_Category=cn}', "");
    Expect(1, 1114109, '\P{Is_General_Category=cn}', "");
    Expect(0, 1114109, '\P{^Is_General_Category=cn}', "");
    Expect(1, 918000, '\p{Is_General_Category=_	Cn}', "");
    Expect(0, 918000, '\p{^Is_General_Category=_	Cn}', "");
    Expect(0, 918000, '\P{Is_General_Category=_	Cn}', "");
    Expect(1, 918000, '\P{^Is_General_Category=_	Cn}', "");
    Expect(0, 1114109, '\p{Is_General_Category=_	Cn}', "");
    Expect(1, 1114109, '\p{^Is_General_Category=_	Cn}', "");
    Expect(1, 1114109, '\P{Is_General_Category=_	Cn}', "");
    Expect(0, 1114109, '\P{^Is_General_Category=_	Cn}', "");
    Error('\p{Is_Gc=_:=Unassigned}');
    Error('\P{Is_Gc=_:=Unassigned}');
    Expect(1, 918000, '\p{Is_Gc=unassigned}', "");
    Expect(0, 918000, '\p{^Is_Gc=unassigned}', "");
    Expect(0, 918000, '\P{Is_Gc=unassigned}', "");
    Expect(1, 918000, '\P{^Is_Gc=unassigned}', "");
    Expect(0, 1114109, '\p{Is_Gc=unassigned}', "");
    Expect(1, 1114109, '\p{^Is_Gc=unassigned}', "");
    Expect(1, 1114109, '\P{Is_Gc=unassigned}', "");
    Expect(0, 1114109, '\P{^Is_Gc=unassigned}', "");
    Expect(1, 918000, '\p{Is_Gc=Unassigned}', "");
    Expect(0, 918000, '\p{^Is_Gc=Unassigned}', "");
    Expect(0, 918000, '\P{Is_Gc=Unassigned}', "");
    Expect(1, 918000, '\P{^Is_Gc=Unassigned}', "");
    Expect(0, 1114109, '\p{Is_Gc=Unassigned}', "");
    Expect(1, 1114109, '\p{^Is_Gc=Unassigned}', "");
    Expect(1, 1114109, '\P{Is_Gc=Unassigned}', "");
    Expect(0, 1114109, '\P{^Is_Gc=Unassigned}', "");
    Error('\p{Is_Category= CN/a/}');
    Error('\P{Is_Category= CN/a/}');
    Expect(1, 918000, '\p{Is_Category=cn}', "");
    Expect(0, 918000, '\p{^Is_Category=cn}', "");
    Expect(0, 918000, '\P{Is_Category=cn}', "");
    Expect(1, 918000, '\P{^Is_Category=cn}', "");
    Expect(0, 1114109, '\p{Is_Category=cn}', "");
    Expect(1, 1114109, '\p{^Is_Category=cn}', "");
    Expect(1, 1114109, '\P{Is_Category=cn}', "");
    Expect(0, 1114109, '\P{^Is_Category=cn}', "");
    Expect(1, 918000, '\p{Is_Category=	_Cn}', "");
    Expect(0, 918000, '\p{^Is_Category=	_Cn}', "");
    Expect(0, 918000, '\P{Is_Category=	_Cn}', "");
    Expect(1, 918000, '\P{^Is_Category=	_Cn}', "");
    Expect(0, 1114109, '\p{Is_Category=	_Cn}', "");
    Expect(1, 1114109, '\p{^Is_Category=	_Cn}', "");
    Expect(1, 1114109, '\P{Is_Category=	_Cn}', "");
    Expect(0, 1114109, '\P{^Is_Category=	_Cn}', "");
    Error('\p{General_Category=/a/Private_USE}');
    Error('\P{General_Category=/a/Private_USE}');
    Expect(1, 1114109, '\p{General_Category=:\APrivate_Use\z:}', "");;
    Expect(0, 63744, '\p{General_Category=:\APrivate_Use\z:}', "");;
    Expect(1, 1114109, '\p{General_Category=privateuse}', "");
    Expect(0, 1114109, '\p{^General_Category=privateuse}', "");
    Expect(0, 1114109, '\P{General_Category=privateuse}', "");
    Expect(1, 1114109, '\P{^General_Category=privateuse}', "");
    Expect(0, 63744, '\p{General_Category=privateuse}', "");
    Expect(1, 63744, '\p{^General_Category=privateuse}', "");
    Expect(1, 63744, '\P{General_Category=privateuse}', "");
    Expect(0, 63744, '\P{^General_Category=privateuse}', "");
    Expect(1, 1114109, '\p{General_Category=:\Aprivateuse\z:}', "");;
    Expect(0, 63744, '\p{General_Category=:\Aprivateuse\z:}', "");;
    Expect(1, 1114109, '\p{General_Category=_	Private_USE}', "");
    Expect(0, 1114109, '\p{^General_Category=_	Private_USE}', "");
    Expect(0, 1114109, '\P{General_Category=_	Private_USE}', "");
    Expect(1, 1114109, '\P{^General_Category=_	Private_USE}', "");
    Expect(0, 63744, '\p{General_Category=_	Private_USE}', "");
    Expect(1, 63744, '\p{^General_Category=_	Private_USE}', "");
    Expect(1, 63744, '\P{General_Category=_	Private_USE}', "");
    Expect(0, 63744, '\P{^General_Category=_	Private_USE}', "");
    Error('\p{Gc=:=	 Co}');
    Error('\P{Gc=:=	 Co}');
    Expect(1, 1114109, '\p{Gc=:\ACo\z:}', "");;
    Expect(0, 63744, '\p{Gc=:\ACo\z:}', "");;
    Expect(1, 1114109, '\p{Gc=co}', "");
    Expect(0, 1114109, '\p{^Gc=co}', "");
    Expect(0, 1114109, '\P{Gc=co}', "");
    Expect(1, 1114109, '\P{^Gc=co}', "");
    Expect(0, 63744, '\p{Gc=co}', "");
    Expect(1, 63744, '\p{^Gc=co}', "");
    Expect(1, 63744, '\P{Gc=co}', "");
    Expect(0, 63744, '\P{^Gc=co}', "");
    Expect(1, 1114109, '\p{Gc=:\Aco\z:}', "");;
    Expect(0, 63744, '\p{Gc=:\Aco\z:}', "");;
    Expect(1, 1114109, '\p{Gc=_CO}', "");
    Expect(0, 1114109, '\p{^Gc=_CO}', "");
    Expect(0, 1114109, '\P{Gc=_CO}', "");
    Expect(1, 1114109, '\P{^Gc=_CO}', "");
    Expect(0, 63744, '\p{Gc=_CO}', "");
    Expect(1, 63744, '\p{^Gc=_CO}', "");
    Expect(1, 63744, '\P{Gc=_CO}', "");
    Expect(0, 63744, '\P{^Gc=_CO}', "");
    Error('\p{Category=-:=private_Use}');
    Error('\P{Category=-:=private_Use}');
    Expect(1, 1114109, '\p{Category=:\APrivate_Use\z:}', "");;
    Expect(0, 63744, '\p{Category=:\APrivate_Use\z:}', "");;
    Expect(1, 1114109, '\p{Category=privateuse}', "");
    Expect(0, 1114109, '\p{^Category=privateuse}', "");
    Expect(0, 1114109, '\P{Category=privateuse}', "");
    Expect(1, 1114109, '\P{^Category=privateuse}', "");
    Expect(0, 63744, '\p{Category=privateuse}', "");
    Expect(1, 63744, '\p{^Category=privateuse}', "");
    Expect(1, 63744, '\P{Category=privateuse}', "");
    Expect(0, 63744, '\P{^Category=privateuse}', "");
    Expect(1, 1114109, '\p{Category=:\Aprivateuse\z:}', "");;
    Expect(0, 63744, '\p{Category=:\Aprivateuse\z:}', "");;
    Expect(1, 1114109, '\p{Category=	Private_Use}', "");
    Expect(0, 1114109, '\p{^Category=	Private_Use}', "");
    Expect(0, 1114109, '\P{Category=	Private_Use}', "");
    Expect(1, 1114109, '\P{^Category=	Private_Use}', "");
    Expect(0, 63744, '\p{Category=	Private_Use}', "");
    Expect(1, 63744, '\p{^Category=	Private_Use}', "");
    Expect(1, 63744, '\P{Category=	Private_Use}', "");
    Expect(0, 63744, '\P{^Category=	Private_Use}', "");
    Error('\p{Is_General_Category: /a/ CO}');
    Error('\P{Is_General_Category: /a/ CO}');
    Expect(1, 1114109, '\p{Is_General_Category=co}', "");
    Expect(0, 1114109, '\p{^Is_General_Category=co}', "");
    Expect(0, 1114109, '\P{Is_General_Category=co}', "");
    Expect(1, 1114109, '\P{^Is_General_Category=co}', "");
    Expect(0, 63744, '\p{Is_General_Category=co}', "");
    Expect(1, 63744, '\p{^Is_General_Category=co}', "");
    Expect(1, 63744, '\P{Is_General_Category=co}', "");
    Expect(0, 63744, '\P{^Is_General_Category=co}', "");
    Expect(1, 1114109, '\p{Is_General_Category=	 co}', "");
    Expect(0, 1114109, '\p{^Is_General_Category=	 co}', "");
    Expect(0, 1114109, '\P{Is_General_Category=	 co}', "");
    Expect(1, 1114109, '\P{^Is_General_Category=	 co}', "");
    Expect(0, 63744, '\p{Is_General_Category=	 co}', "");
    Expect(1, 63744, '\p{^Is_General_Category=	 co}', "");
    Expect(1, 63744, '\P{Is_General_Category=	 co}', "");
    Expect(0, 63744, '\P{^Is_General_Category=	 co}', "");
    Error('\p{Is_Gc=	:=Private_Use}');
    Error('\P{Is_Gc=	:=Private_Use}');
    Expect(1, 1114109, '\p{Is_Gc=privateuse}', "");
    Expect(0, 1114109, '\p{^Is_Gc=privateuse}', "");
    Expect(0, 1114109, '\P{Is_Gc=privateuse}', "");
    Expect(1, 1114109, '\P{^Is_Gc=privateuse}', "");
    Expect(0, 63744, '\p{Is_Gc=privateuse}', "");
    Expect(1, 63744, '\p{^Is_Gc=privateuse}', "");
    Expect(1, 63744, '\P{Is_Gc=privateuse}', "");
    Expect(0, 63744, '\P{^Is_Gc=privateuse}', "");
    Expect(1, 1114109, '\p{Is_Gc=-_Private_Use}', "");
    Expect(0, 1114109, '\p{^Is_Gc=-_Private_Use}', "");
    Expect(0, 1114109, '\P{Is_Gc=-_Private_Use}', "");
    Expect(1, 1114109, '\P{^Is_Gc=-_Private_Use}', "");
    Expect(0, 63744, '\p{Is_Gc=-_Private_Use}', "");
    Expect(1, 63744, '\p{^Is_Gc=-_Private_Use}', "");
    Expect(1, 63744, '\P{Is_Gc=-_Private_Use}', "");
    Expect(0, 63744, '\P{^Is_Gc=-_Private_Use}', "");
    Error('\p{Is_Category=:=_-Co}');
    Error('\P{Is_Category=:=_-Co}');
    Expect(1, 1114109, '\p{Is_Category=co}', "");
    Expect(0, 1114109, '\p{^Is_Category=co}', "");
    Expect(0, 1114109, '\P{Is_Category=co}', "");
    Expect(1, 1114109, '\P{^Is_Category=co}', "");
    Expect(0, 63744, '\p{Is_Category=co}', "");
    Expect(1, 63744, '\p{^Is_Category=co}', "");
    Expect(1, 63744, '\P{Is_Category=co}', "");
    Expect(0, 63744, '\P{^Is_Category=co}', "");
    Expect(1, 1114109, '\p{Is_Category=--Co}', "");
    Expect(0, 1114109, '\p{^Is_Category=--Co}', "");
    Expect(0, 1114109, '\P{Is_Category=--Co}', "");
    Expect(1, 1114109, '\P{^Is_Category=--Co}', "");
    Expect(0, 63744, '\p{Is_Category=--Co}', "");
    Expect(1, 63744, '\p{^Is_Category=--Co}', "");
    Expect(1, 63744, '\P{Is_Category=--Co}', "");
    Expect(0, 63744, '\P{^Is_Category=--Co}', "");
    Error('\p{General_Category=/a/	SURROGATE}');
    Error('\P{General_Category=/a/	SURROGATE}');
    Expect(1, 57343, '\p{General_Category=:\ASurrogate\z:}', "");;
    Expect(0, 57344, '\p{General_Category=:\ASurrogate\z:}', "");;
    Expect(1, 57343, '\p{General_Category=surrogate}', "");
    Expect(0, 57343, '\p{^General_Category=surrogate}', "");
    Expect(0, 57343, '\P{General_Category=surrogate}', "");
    Expect(1, 57343, '\P{^General_Category=surrogate}', "");
    Expect(0, 57344, '\p{General_Category=surrogate}', "");
    Expect(1, 57344, '\p{^General_Category=surrogate}', "");
    Expect(1, 57344, '\P{General_Category=surrogate}', "");
    Expect(0, 57344, '\P{^General_Category=surrogate}', "");
    Expect(1, 57343, '\p{General_Category=:\Asurrogate\z:}', "");;
    Expect(0, 57344, '\p{General_Category=:\Asurrogate\z:}', "");;
    Expect(1, 57343, '\p{General_Category=- Surrogate}', "");
    Expect(0, 57343, '\p{^General_Category=- Surrogate}', "");
    Expect(0, 57343, '\P{General_Category=- Surrogate}', "");
    Expect(1, 57343, '\P{^General_Category=- Surrogate}', "");
    Expect(0, 57344, '\p{General_Category=- Surrogate}', "");
    Expect(1, 57344, '\p{^General_Category=- Surrogate}', "");
    Expect(1, 57344, '\P{General_Category=- Surrogate}', "");
    Expect(0, 57344, '\P{^General_Category=- Surrogate}', "");
    Error('\p{Gc= 	CS/a/}');
    Error('\P{Gc= 	CS/a/}');
    Expect(1, 57343, '\p{Gc=:\ACs\z:}', "");;
    Expect(0, 57344, '\p{Gc=:\ACs\z:}', "");;
    Expect(1, 57343, '\p{Gc=cs}', "");
    Expect(0, 57343, '\p{^Gc=cs}', "");
    Expect(0, 57343, '\P{Gc=cs}', "");
    Expect(1, 57343, '\P{^Gc=cs}', "");
    Expect(0, 57344, '\p{Gc=cs}', "");
    Expect(1, 57344, '\p{^Gc=cs}', "");
    Expect(1, 57344, '\P{Gc=cs}', "");
    Expect(0, 57344, '\P{^Gc=cs}', "");
    Expect(1, 57343, '\p{Gc=:\Acs\z:}', "");;
    Expect(0, 57344, '\p{Gc=:\Acs\z:}', "");;
    Expect(1, 57343, '\p{Gc=_ CS}', "");
    Expect(0, 57343, '\p{^Gc=_ CS}', "");
    Expect(0, 57343, '\P{Gc=_ CS}', "");
    Expect(1, 57343, '\P{^Gc=_ CS}', "");
    Expect(0, 57344, '\p{Gc=_ CS}', "");
    Expect(1, 57344, '\p{^Gc=_ CS}', "");
    Expect(1, 57344, '\P{Gc=_ CS}', "");
    Expect(0, 57344, '\P{^Gc=_ CS}', "");
    Error('\p{Category=:=		surrogate}');
    Error('\P{Category=:=		surrogate}');
    Expect(1, 57343, '\p{Category=:\ASurrogate\z:}', "");;
    Expect(0, 57344, '\p{Category=:\ASurrogate\z:}', "");;
    Expect(1, 57343, '\p{Category=surrogate}', "");
    Expect(0, 57343, '\p{^Category=surrogate}', "");
    Expect(0, 57343, '\P{Category=surrogate}', "");
    Expect(1, 57343, '\P{^Category=surrogate}', "");
    Expect(0, 57344, '\p{Category=surrogate}', "");
    Expect(1, 57344, '\p{^Category=surrogate}', "");
    Expect(1, 57344, '\P{Category=surrogate}', "");
    Expect(0, 57344, '\P{^Category=surrogate}', "");
    Expect(1, 57343, '\p{Category=:\Asurrogate\z:}', "");;
    Expect(0, 57344, '\p{Category=:\Asurrogate\z:}', "");;
    Expect(1, 57343, '\p{Category=--Surrogate}', "");
    Expect(0, 57343, '\p{^Category=--Surrogate}', "");
    Expect(0, 57343, '\P{Category=--Surrogate}', "");
    Expect(1, 57343, '\P{^Category=--Surrogate}', "");
    Expect(0, 57344, '\p{Category=--Surrogate}', "");
    Expect(1, 57344, '\p{^Category=--Surrogate}', "");
    Expect(1, 57344, '\P{Category=--Surrogate}', "");
    Expect(0, 57344, '\P{^Category=--Surrogate}', "");
    Error('\p{Is_General_Category=	 Cs/a/}');
    Error('\P{Is_General_Category=	 Cs/a/}');
    Expect(1, 57343, '\p{Is_General_Category=cs}', "");
    Expect(0, 57343, '\p{^Is_General_Category=cs}', "");
    Expect(0, 57343, '\P{Is_General_Category=cs}', "");
    Expect(1, 57343, '\P{^Is_General_Category=cs}', "");
    Expect(0, 57344, '\p{Is_General_Category=cs}', "");
    Expect(1, 57344, '\p{^Is_General_Category=cs}', "");
    Expect(1, 57344, '\P{Is_General_Category=cs}', "");
    Expect(0, 57344, '\P{^Is_General_Category=cs}', "");
    Expect(1, 57343, '\p{Is_General_Category=-_CS}', "");
    Expect(0, 57343, '\p{^Is_General_Category=-_CS}', "");
    Expect(0, 57343, '\P{Is_General_Category=-_CS}', "");
    Expect(1, 57343, '\P{^Is_General_Category=-_CS}', "");
    Expect(0, 57344, '\p{Is_General_Category=-_CS}', "");
    Expect(1, 57344, '\p{^Is_General_Category=-_CS}', "");
    Expect(1, 57344, '\P{Is_General_Category=-_CS}', "");
    Expect(0, 57344, '\P{^Is_General_Category=-_CS}', "");
    Error('\p{Is_Gc=:=Surrogate}');
    Error('\P{Is_Gc=:=Surrogate}');
    Expect(1, 57343, '\p{Is_Gc=surrogate}', "");
    Expect(0, 57343, '\p{^Is_Gc=surrogate}', "");
    Expect(0, 57343, '\P{Is_Gc=surrogate}', "");
    Expect(1, 57343, '\P{^Is_Gc=surrogate}', "");
    Expect(0, 57344, '\p{Is_Gc=surrogate}', "");
    Expect(1, 57344, '\p{^Is_Gc=surrogate}', "");
    Expect(1, 57344, '\P{Is_Gc=surrogate}', "");
    Expect(0, 57344, '\P{^Is_Gc=surrogate}', "");
    Expect(1, 57343, '\p{Is_Gc=-surrogate}', "");
    Expect(0, 57343, '\p{^Is_Gc=-surrogate}', "");
    Expect(0, 57343, '\P{Is_Gc=-surrogate}', "");
    Expect(1, 57343, '\P{^Is_Gc=-surrogate}', "");
    Expect(0, 57344, '\p{Is_Gc=-surrogate}', "");
    Expect(1, 57344, '\p{^Is_Gc=-surrogate}', "");
    Expect(1, 57344, '\P{Is_Gc=-surrogate}', "");
    Expect(0, 57344, '\P{^Is_Gc=-surrogate}', "");
    Error('\p{Is_Category=		Cs/a/}');
    Error('\P{Is_Category=		Cs/a/}');
    Expect(1, 57343, '\p{Is_Category=cs}', "");
    Expect(0, 57343, '\p{^Is_Category=cs}', "");
    Expect(0, 57343, '\P{Is_Category=cs}', "");
    Expect(1, 57343, '\P{^Is_Category=cs}', "");
    Expect(0, 57344, '\p{Is_Category=cs}', "");
    Expect(1, 57344, '\p{^Is_Category=cs}', "");
    Expect(1, 57344, '\P{Is_Category=cs}', "");
    Expect(0, 57344, '\P{^Is_Category=cs}', "");
    Expect(1, 57343, '\p{Is_Category=__CS}', "");
    Expect(0, 57343, '\p{^Is_Category=__CS}', "");
    Expect(0, 57343, '\P{Is_Category=__CS}', "");
    Expect(1, 57343, '\P{^Is_Category=__CS}', "");
    Expect(0, 57344, '\p{Is_Category=__CS}', "");
    Expect(1, 57344, '\p{^Is_Category=__CS}', "");
    Expect(1, 57344, '\P{Is_Category=__CS}', "");
    Expect(0, 57344, '\P{^Is_Category=__CS}', "");
    Error('\p{General_Category=_/a/letter}');
    Error('\P{General_Category=_/a/letter}');
    Expect(1, 205743, '\p{General_Category=:\ALetter\z:}', "");;
    Expect(0, 205744, '\p{General_Category=:\ALetter\z:}', "");;
    Expect(1, 205743, '\p{General_Category=letter}', "");
    Expect(0, 205743, '\p{^General_Category=letter}', "");
    Expect(0, 205743, '\P{General_Category=letter}', "");
    Expect(1, 205743, '\P{^General_Category=letter}', "");
    Expect(0, 205744, '\p{General_Category=letter}', "");
    Expect(1, 205744, '\p{^General_Category=letter}', "");
    Expect(1, 205744, '\P{General_Category=letter}', "");
    Expect(0, 205744, '\P{^General_Category=letter}', "");
    Expect(1, 205743, '\p{General_Category=:\Aletter\z:}', "");;
    Expect(0, 205744, '\p{General_Category=:\Aletter\z:}', "");;
    Expect(1, 205743, '\p{General_Category= -Letter}', "");
    Expect(0, 205743, '\p{^General_Category= -Letter}', "");
    Expect(0, 205743, '\P{General_Category= -Letter}', "");
    Expect(1, 205743, '\P{^General_Category= -Letter}', "");
    Expect(0, 205744, '\p{General_Category= -Letter}', "");
    Expect(1, 205744, '\p{^General_Category= -Letter}', "");
    Expect(1, 205744, '\P{General_Category= -Letter}', "");
    Expect(0, 205744, '\P{^General_Category= -Letter}', "");
    Error('\p{Gc=:=_L}');
    Error('\P{Gc=:=_L}');
    Expect(1, 205743, '\p{Gc=:\AL\z:}', "");;
    Expect(0, 205744, '\p{Gc=:\AL\z:}', "");;
    Expect(1, 205743, '\p{Gc=l}', "");
    Expect(0, 205743, '\p{^Gc=l}', "");
    Expect(0, 205743, '\P{Gc=l}', "");
    Expect(1, 205743, '\P{^Gc=l}', "");
    Expect(0, 205744, '\p{Gc=l}', "");
    Expect(1, 205744, '\p{^Gc=l}', "");
    Expect(1, 205744, '\P{Gc=l}', "");
    Expect(0, 205744, '\P{^Gc=l}', "");
    Expect(1, 205743, '\p{Gc=:\Al\z:}', "");;
    Expect(0, 205744, '\p{Gc=:\Al\z:}', "");;
    Expect(1, 205743, '\p{Gc=--L}', "");
    Expect(0, 205743, '\p{^Gc=--L}', "");
    Expect(0, 205743, '\P{Gc=--L}', "");
    Expect(1, 205743, '\P{^Gc=--L}', "");
    Expect(0, 205744, '\p{Gc=--L}', "");
    Expect(1, 205744, '\p{^Gc=--L}', "");
    Expect(1, 205744, '\P{Gc=--L}', "");
    Expect(0, 205744, '\P{^Gc=--L}', "");
    Error('\p{Category=	:=LETTER}');
    Error('\P{Category=	:=LETTER}');
    Expect(1, 205743, '\p{Category=:\ALetter\z:}', "");;
    Expect(0, 205744, '\p{Category=:\ALetter\z:}', "");;
    Expect(1, 205743, '\p{Category=letter}', "");
    Expect(0, 205743, '\p{^Category=letter}', "");
    Expect(0, 205743, '\P{Category=letter}', "");
    Expect(1, 205743, '\P{^Category=letter}', "");
    Expect(0, 205744, '\p{Category=letter}', "");
    Expect(1, 205744, '\p{^Category=letter}', "");
    Expect(1, 205744, '\P{Category=letter}', "");
    Expect(0, 205744, '\P{^Category=letter}', "");
    Expect(1, 205743, '\p{Category=:\Aletter\z:}', "");;
    Expect(0, 205744, '\p{Category=:\Aletter\z:}', "");;
    Expect(1, 205743, '\p{Category=-Letter}', "");
    Expect(0, 205743, '\p{^Category=-Letter}', "");
    Expect(0, 205743, '\P{Category=-Letter}', "");
    Expect(1, 205743, '\P{^Category=-Letter}', "");
    Expect(0, 205744, '\p{Category=-Letter}', "");
    Expect(1, 205744, '\p{^Category=-Letter}', "");
    Expect(1, 205744, '\P{Category=-Letter}', "");
    Expect(0, 205744, '\P{^Category=-Letter}', "");
    Error('\p{Is_General_Category= _L/a/}');
    Error('\P{Is_General_Category= _L/a/}');
    Expect(1, 205743, '\p{Is_General_Category=l}', "");
    Expect(0, 205743, '\p{^Is_General_Category=l}', "");
    Expect(0, 205743, '\P{Is_General_Category=l}', "");
    Expect(1, 205743, '\P{^Is_General_Category=l}', "");
    Expect(0, 205744, '\p{Is_General_Category=l}', "");
    Expect(1, 205744, '\p{^Is_General_Category=l}', "");
    Expect(1, 205744, '\P{Is_General_Category=l}', "");
    Expect(0, 205744, '\P{^Is_General_Category=l}', "");
    Expect(1, 205743, '\p{Is_General_Category=  L}', "");
    Expect(0, 205743, '\p{^Is_General_Category=  L}', "");
    Expect(0, 205743, '\P{Is_General_Category=  L}', "");
    Expect(1, 205743, '\P{^Is_General_Category=  L}', "");
    Expect(0, 205744, '\p{Is_General_Category=  L}', "");
    Expect(1, 205744, '\p{^Is_General_Category=  L}', "");
    Expect(1, 205744, '\P{Is_General_Category=  L}', "");
    Expect(0, 205744, '\P{^Is_General_Category=  L}', "");
    Error('\p{Is_Gc= letter:=}');
    Error('\P{Is_Gc= letter:=}');
    Expect(1, 205743, '\p{Is_Gc=letter}', "");
    Expect(0, 205743, '\p{^Is_Gc=letter}', "");
    Expect(0, 205743, '\P{Is_Gc=letter}', "");
    Expect(1, 205743, '\P{^Is_Gc=letter}', "");
    Expect(0, 205744, '\p{Is_Gc=letter}', "");
    Expect(1, 205744, '\p{^Is_Gc=letter}', "");
    Expect(1, 205744, '\P{Is_Gc=letter}', "");
    Expect(0, 205744, '\P{^Is_Gc=letter}', "");
    Expect(1, 205743, '\p{Is_Gc= _letter}', "");
    Expect(0, 205743, '\p{^Is_Gc= _letter}', "");
    Expect(0, 205743, '\P{Is_Gc= _letter}', "");
}
if (!$::TESTCHUNK or $::TESTCHUNK == 2) {
    Expect(1, 205743, '\P{^Is_Gc= _letter}', "");
    Expect(0, 205744, '\p{Is_Gc= _letter}', "");
    Expect(1, 205744, '\p{^Is_Gc= _letter}', "");
    Expect(1, 205744, '\P{Is_Gc= _letter}', "");
    Expect(0, 205744, '\P{^Is_Gc= _letter}', "");
    Error('\p{Is_Category= l:=}');
    Error('\P{Is_Category= l:=}');
    Expect(1, 205743, '\p{Is_Category=l}', "");
    Expect(0, 205743, '\p{^Is_Category=l}', "");
    Expect(0, 205743, '\P{Is_Category=l}', "");
    Expect(1, 205743, '\P{^Is_Category=l}', "");
    Expect(0, 205744, '\p{Is_Category=l}', "");
    Expect(1, 205744, '\p{^Is_Category=l}', "");
    Expect(1, 205744, '\P{Is_Category=l}', "");
    Expect(0, 205744, '\P{^Is_Category=l}', "");
    Expect(1, 205743, '\p{Is_Category=-_l}', "");
    Expect(0, 205743, '\p{^Is_Category=-_l}', "");
    Expect(0, 205743, '\P{Is_Category=-_l}', "");
    Expect(1, 205743, '\P{^Is_Category=-_l}', "");
    Expect(0, 205744, '\p{Is_Category=-_l}', "");
    Expect(1, 205744, '\p{^Is_Category=-_l}', "");
    Expect(1, 205744, '\P{Is_Category=-_l}', "");
    Expect(0, 205744, '\P{^Is_Category=-_l}', "");
    Error('\p{General_Category=:=_-cased_Letter}');
    Error('\P{General_Category=:=_-cased_Letter}');
    Expect(1, 125251, '\p{General_Category=:\ACased_Letter\z:}', "");;
    Expect(0, 125252, '\p{General_Category=:\ACased_Letter\z:}', "");;
    Expect(1, 125251, '\p{General_Category=casedletter}', "");
    Expect(0, 125251, '\p{^General_Category=casedletter}', "");
    Expect(0, 125251, '\P{General_Category=casedletter}', "");
    Expect(1, 125251, '\P{^General_Category=casedletter}', "");
    Expect(0, 125252, '\p{General_Category=casedletter}', "");
    Expect(1, 125252, '\p{^General_Category=casedletter}', "");
    Expect(1, 125252, '\P{General_Category=casedletter}', "");
    Expect(0, 125252, '\P{^General_Category=casedletter}', "");
    Expect(1, 125251, '\p{General_Category=:\Acasedletter\z:}', "");;
    Expect(0, 125252, '\p{General_Category=:\Acasedletter\z:}', "");;
    Expect(1, 125251, '\p{General_Category=-Cased_Letter}', "");
    Expect(0, 125251, '\p{^General_Category=-Cased_Letter}', "");
    Expect(0, 125251, '\P{General_Category=-Cased_Letter}', "");
    Expect(1, 125251, '\P{^General_Category=-Cased_Letter}', "");
    Expect(0, 125252, '\p{General_Category=-Cased_Letter}', "");
    Expect(1, 125252, '\p{^General_Category=-Cased_Letter}', "");
    Expect(1, 125252, '\P{General_Category=-Cased_Letter}', "");
    Expect(0, 125252, '\P{^General_Category=-Cased_Letter}', "");
    Error('\p{Gc=_LC:=}');
    Error('\P{Gc=_LC:=}');
    Expect(1, 125251, '\p{Gc=:\ALC\z:}', "");;
    Expect(0, 125252, '\p{Gc=:\ALC\z:}', "");;
    Expect(1, 125251, '\p{Gc:	lc}', "");
    Expect(0, 125251, '\p{^Gc:	lc}', "");
    Expect(0, 125251, '\P{Gc:	lc}', "");
    Expect(1, 125251, '\P{^Gc:	lc}', "");
    Expect(0, 125252, '\p{Gc:	lc}', "");
    Expect(1, 125252, '\p{^Gc:	lc}', "");
    Expect(1, 125252, '\P{Gc:	lc}', "");
    Expect(0, 125252, '\P{^Gc:	lc}', "");
    Expect(1, 125251, '\p{Gc=:\Alc\z:}', "");;
    Expect(0, 125252, '\p{Gc=:\Alc\z:}', "");;
    Expect(1, 125251, '\p{Gc= -LC}', "");
    Expect(0, 125251, '\p{^Gc= -LC}', "");
    Expect(0, 125251, '\P{Gc= -LC}', "");
    Expect(1, 125251, '\P{^Gc= -LC}', "");
    Expect(0, 125252, '\p{Gc= -LC}', "");
    Expect(1, 125252, '\p{^Gc= -LC}', "");
    Expect(1, 125252, '\P{Gc= -LC}', "");
    Expect(0, 125252, '\P{^Gc= -LC}', "");
    Error('\p{Category=	-l_:=}');
    Error('\P{Category=	-l_:=}');
    Expect(1, 125251, '\p{Category=l_}', "");
    Expect(0, 125251, '\p{^Category=l_}', "");
    Expect(0, 125251, '\P{Category=l_}', "");
    Expect(1, 125251, '\P{^Category=l_}', "");
    Expect(0, 125252, '\p{Category=l_}', "");
    Expect(1, 125252, '\p{^Category=l_}', "");
    Expect(1, 125252, '\P{Category=l_}', "");
    Expect(0, 125252, '\P{^Category=l_}', "");
    Expect(1, 125251, '\p{Category= L_}', "");
    Expect(0, 125251, '\p{^Category= L_}', "");
    Expect(0, 125251, '\P{Category= L_}', "");
    Expect(1, 125251, '\P{^Category= L_}', "");
    Expect(0, 125252, '\p{Category= L_}', "");
    Expect(1, 125252, '\p{^Category= L_}', "");
    Expect(1, 125252, '\P{Category= L_}', "");
    Expect(0, 125252, '\P{^Category= L_}', "");
    Error('\p{Is_General_Category=_/a/L&}');
    Error('\P{Is_General_Category=_/a/L&}');
    Expect(1, 125251, '\p{Is_General_Category=l&}', "");
    Expect(0, 125251, '\p{^Is_General_Category=l&}', "");
    Expect(0, 125251, '\P{Is_General_Category=l&}', "");
    Expect(1, 125251, '\P{^Is_General_Category=l&}', "");
    Expect(0, 125252, '\p{Is_General_Category=l&}', "");
    Expect(1, 125252, '\p{^Is_General_Category=l&}', "");
    Expect(1, 125252, '\P{Is_General_Category=l&}', "");
    Expect(0, 125252, '\P{^Is_General_Category=l&}', "");
    Expect(1, 125251, '\p{Is_General_Category=	-L&}', "");
    Expect(0, 125251, '\p{^Is_General_Category=	-L&}', "");
    Expect(0, 125251, '\P{Is_General_Category=	-L&}', "");
    Expect(1, 125251, '\P{^Is_General_Category=	-L&}', "");
    Expect(0, 125252, '\p{Is_General_Category=	-L&}', "");
    Expect(1, 125252, '\p{^Is_General_Category=	-L&}', "");
    Expect(1, 125252, '\P{Is_General_Category=	-L&}', "");
    Expect(0, 125252, '\P{^Is_General_Category=	-L&}', "");
    Error('\p{Is_Gc:_/a/Cased_Letter}');
    Error('\P{Is_Gc:_/a/Cased_Letter}');
    Expect(1, 125251, '\p{Is_Gc=casedletter}', "");
    Expect(0, 125251, '\p{^Is_Gc=casedletter}', "");
    Expect(0, 125251, '\P{Is_Gc=casedletter}', "");
    Expect(1, 125251, '\P{^Is_Gc=casedletter}', "");
    Expect(0, 125252, '\p{Is_Gc=casedletter}', "");
    Expect(1, 125252, '\p{^Is_Gc=casedletter}', "");
    Expect(1, 125252, '\P{Is_Gc=casedletter}', "");
    Expect(0, 125252, '\P{^Is_Gc=casedletter}', "");
    Expect(1, 125251, '\p{Is_Gc= 	Cased_letter}', "");
    Expect(0, 125251, '\p{^Is_Gc= 	Cased_letter}', "");
    Expect(0, 125251, '\P{Is_Gc= 	Cased_letter}', "");
    Expect(1, 125251, '\P{^Is_Gc= 	Cased_letter}', "");
    Expect(0, 125252, '\p{Is_Gc= 	Cased_letter}', "");
    Expect(1, 125252, '\p{^Is_Gc= 	Cased_letter}', "");
    Expect(1, 125252, '\P{Is_Gc= 	Cased_letter}', "");
    Expect(0, 125252, '\P{^Is_Gc= 	Cased_letter}', "");
    Error('\p{Is_Category=_-LC:=}');
    Error('\P{Is_Category=_-LC:=}');
    Expect(1, 125251, '\p{Is_Category=lc}', "");
    Expect(0, 125251, '\p{^Is_Category=lc}', "");
    Expect(0, 125251, '\P{Is_Category=lc}', "");
    Expect(1, 125251, '\P{^Is_Category=lc}', "");
    Expect(0, 125252, '\p{Is_Category=lc}', "");
    Expect(1, 125252, '\p{^Is_Category=lc}', "");
    Expect(1, 125252, '\P{Is_Category=lc}', "");
    Expect(0, 125252, '\P{^Is_Category=lc}', "");
    Expect(1, 125251, '\p{Is_Category=_-lc}', "");
    Expect(0, 125251, '\p{^Is_Category=_-lc}', "");
    Expect(0, 125251, '\P{Is_Category=_-lc}', "");
    Expect(1, 125251, '\P{^Is_Category=_-lc}', "");
    Expect(0, 125252, '\p{Is_Category=_-lc}', "");
    Expect(1, 125252, '\p{^Is_Category=_-lc}', "");
    Expect(1, 125252, '\P{Is_Category=_-lc}', "");
    Expect(0, 125252, '\P{^Is_Category=_-lc}', "");
    Error('\p{General_Category=/a/		Lowercase_Letter}');
    Error('\P{General_Category=/a/		Lowercase_Letter}');
    Expect(1, 125251, '\p{General_Category=:\ALowercase_Letter\z:}', "");;
    Expect(0, 125252, '\p{General_Category=:\ALowercase_Letter\z:}', "");;
    Expect(1, 125251, '\p{General_Category=lowercaseletter}', "");
    Expect(0, 125251, '\p{^General_Category=lowercaseletter}', "");
    Expect(0, 125251, '\P{General_Category=lowercaseletter}', "");
    Expect(1, 125251, '\P{^General_Category=lowercaseletter}', "");
    Expect(0, 125252, '\p{General_Category=lowercaseletter}', "");
    Expect(1, 125252, '\p{^General_Category=lowercaseletter}', "");
    Expect(1, 125252, '\P{General_Category=lowercaseletter}', "");
    Expect(0, 125252, '\P{^General_Category=lowercaseletter}', "");
    Expect(1, 125251, '\p{General_Category=:\Alowercaseletter\z:}', "");;
    Expect(0, 125252, '\p{General_Category=:\Alowercaseletter\z:}', "");;
    Expect(1, 125251, '\p{General_Category=		lowercase_LETTER}', "");
    Expect(0, 125251, '\p{^General_Category=		lowercase_LETTER}', "");
    Expect(0, 125251, '\P{General_Category=		lowercase_LETTER}', "");
    Expect(1, 125251, '\P{^General_Category=		lowercase_LETTER}', "");
    Expect(0, 125252, '\p{General_Category=		lowercase_LETTER}', "");
    Expect(1, 125252, '\p{^General_Category=		lowercase_LETTER}', "");
    Expect(1, 125252, '\P{General_Category=		lowercase_LETTER}', "");
    Expect(0, 125252, '\P{^General_Category=		lowercase_LETTER}', "");
    Error('\p{Gc=/a/_Ll}');
    Error('\P{Gc=/a/_Ll}');
    Expect(1, 125251, '\p{Gc=:\ALl\z:}', "");;
    Expect(0, 125252, '\p{Gc=:\ALl\z:}', "");;
    Expect(1, 125251, '\p{Gc=ll}', "");
    Expect(0, 125251, '\p{^Gc=ll}', "");
    Expect(0, 125251, '\P{Gc=ll}', "");
    Expect(1, 125251, '\P{^Gc=ll}', "");
    Expect(0, 125252, '\p{Gc=ll}', "");
    Expect(1, 125252, '\p{^Gc=ll}', "");
    Expect(1, 125252, '\P{Gc=ll}', "");
    Expect(0, 125252, '\P{^Gc=ll}', "");
    Expect(1, 125251, '\p{Gc=:\All\z:}', "");;
    Expect(0, 125252, '\p{Gc=:\All\z:}', "");;
    Expect(1, 125251, '\p{Gc= Ll}', "");
    Expect(0, 125251, '\p{^Gc= Ll}', "");
    Expect(0, 125251, '\P{Gc= Ll}', "");
    Expect(1, 125251, '\P{^Gc= Ll}', "");
    Expect(0, 125252, '\p{Gc= Ll}', "");
    Expect(1, 125252, '\p{^Gc= Ll}', "");
    Expect(1, 125252, '\P{Gc= Ll}', "");
    Expect(0, 125252, '\P{^Gc= Ll}', "");
    Error('\p{Category:	__LOWERCASE_LETTER/a/}');
    Error('\P{Category:	__LOWERCASE_LETTER/a/}');
    Expect(1, 125251, '\p{Category=:\ALowercase_Letter\z:}', "");;
    Expect(0, 125252, '\p{Category=:\ALowercase_Letter\z:}', "");;
    Expect(1, 125251, '\p{Category=lowercaseletter}', "");
    Expect(0, 125251, '\p{^Category=lowercaseletter}', "");
    Expect(0, 125251, '\P{Category=lowercaseletter}', "");
    Expect(1, 125251, '\P{^Category=lowercaseletter}', "");
    Expect(0, 125252, '\p{Category=lowercaseletter}', "");
    Expect(1, 125252, '\p{^Category=lowercaseletter}', "");
    Expect(1, 125252, '\P{Category=lowercaseletter}', "");
    Expect(0, 125252, '\P{^Category=lowercaseletter}', "");
    Expect(1, 125251, '\p{Category=:\Alowercaseletter\z:}', "");;
    Expect(0, 125252, '\p{Category=:\Alowercaseletter\z:}', "");;
    Expect(1, 125251, '\p{Category=-Lowercase_LETTER}', "");
    Expect(0, 125251, '\p{^Category=-Lowercase_LETTER}', "");
    Expect(0, 125251, '\P{Category=-Lowercase_LETTER}', "");
    Expect(1, 125251, '\P{^Category=-Lowercase_LETTER}', "");
    Expect(0, 125252, '\p{Category=-Lowercase_LETTER}', "");
    Expect(1, 125252, '\p{^Category=-Lowercase_LETTER}', "");
    Expect(1, 125252, '\P{Category=-Lowercase_LETTER}', "");
    Expect(0, 125252, '\P{^Category=-Lowercase_LETTER}', "");
    Error('\p{Is_General_Category=	Ll/a/}');
    Error('\P{Is_General_Category=	Ll/a/}');
    Expect(1, 125251, '\p{Is_General_Category=ll}', "");
    Expect(0, 125251, '\p{^Is_General_Category=ll}', "");
    Expect(0, 125251, '\P{Is_General_Category=ll}', "");
    Expect(1, 125251, '\P{^Is_General_Category=ll}', "");
    Expect(0, 125252, '\p{Is_General_Category=ll}', "");
    Expect(1, 125252, '\p{^Is_General_Category=ll}', "");
    Expect(1, 125252, '\P{Is_General_Category=ll}', "");
    Expect(0, 125252, '\P{^Is_General_Category=ll}', "");
    Expect(1, 125251, '\p{Is_General_Category=-_Ll}', "");
    Expect(0, 125251, '\p{^Is_General_Category=-_Ll}', "");
    Expect(0, 125251, '\P{Is_General_Category=-_Ll}', "");
    Expect(1, 125251, '\P{^Is_General_Category=-_Ll}', "");
    Expect(0, 125252, '\p{Is_General_Category=-_Ll}', "");
    Expect(1, 125252, '\p{^Is_General_Category=-_Ll}', "");
    Expect(1, 125252, '\P{Is_General_Category=-_Ll}', "");
    Expect(0, 125252, '\P{^Is_General_Category=-_Ll}', "");
    Error('\p{Is_Gc= _lowercase_Letter/a/}');
    Error('\P{Is_Gc= _lowercase_Letter/a/}');
    Expect(1, 125251, '\p{Is_Gc=lowercaseletter}', "");
    Expect(0, 125251, '\p{^Is_Gc=lowercaseletter}', "");
    Expect(0, 125251, '\P{Is_Gc=lowercaseletter}', "");
    Expect(1, 125251, '\P{^Is_Gc=lowercaseletter}', "");
    Expect(0, 125252, '\p{Is_Gc=lowercaseletter}', "");
    Expect(1, 125252, '\p{^Is_Gc=lowercaseletter}', "");
    Expect(1, 125252, '\P{Is_Gc=lowercaseletter}', "");
    Expect(0, 125252, '\P{^Is_Gc=lowercaseletter}', "");
    Expect(1, 125251, '\p{Is_Gc=_ lowercase_LETTER}', "");
    Expect(0, 125251, '\p{^Is_Gc=_ lowercase_LETTER}', "");
    Expect(0, 125251, '\P{Is_Gc=_ lowercase_LETTER}', "");
    Expect(1, 125251, '\P{^Is_Gc=_ lowercase_LETTER}', "");
    Expect(0, 125252, '\p{Is_Gc=_ lowercase_LETTER}', "");
    Expect(1, 125252, '\p{^Is_Gc=_ lowercase_LETTER}', "");
    Expect(1, 125252, '\P{Is_Gc=_ lowercase_LETTER}', "");
    Expect(0, 125252, '\P{^Is_Gc=_ lowercase_LETTER}', "");
    Error('\p{Is_Category=- Ll/a/}');
    Error('\P{Is_Category=- Ll/a/}');
    Expect(1, 125251, '\p{Is_Category=ll}', "");
    Expect(0, 125251, '\p{^Is_Category=ll}', "");
    Expect(0, 125251, '\P{Is_Category=ll}', "");
    Expect(1, 125251, '\P{^Is_Category=ll}', "");
    Expect(0, 125252, '\p{Is_Category=ll}', "");
    Expect(1, 125252, '\p{^Is_Category=ll}', "");
    Expect(1, 125252, '\P{Is_Category=ll}', "");
    Expect(0, 125252, '\P{^Is_Category=ll}', "");
    Expect(1, 125251, '\p{Is_Category: __LL}', "");
    Expect(0, 125251, '\p{^Is_Category: __LL}', "");
    Expect(0, 125251, '\P{Is_Category: __LL}', "");
    Expect(1, 125251, '\P{^Is_Category: __LL}', "");
    Expect(0, 125252, '\p{Is_Category: __LL}', "");
    Expect(1, 125252, '\p{^Is_Category: __LL}', "");
    Expect(1, 125252, '\P{Is_Category: __LL}', "");
    Expect(0, 125252, '\P{^Is_Category: __LL}', "");
    Error('\p{General_Category= -modifier_Letter:=}');
    Error('\P{General_Category= -modifier_Letter:=}');
    Expect(1, 125259, '\p{General_Category=:\AModifier_Letter\z:}', "");;
    Expect(0, 125260, '\p{General_Category=:\AModifier_Letter\z:}', "");;
    Expect(1, 125259, '\p{General_Category=modifierletter}', "");
    Expect(0, 125259, '\p{^General_Category=modifierletter}', "");
    Expect(0, 125259, '\P{General_Category=modifierletter}', "");
    Expect(1, 125259, '\P{^General_Category=modifierletter}', "");
    Expect(0, 125260, '\p{General_Category=modifierletter}', "");
    Expect(1, 125260, '\p{^General_Category=modifierletter}', "");
    Expect(1, 125260, '\P{General_Category=modifierletter}', "");
    Expect(0, 125260, '\P{^General_Category=modifierletter}', "");
    Expect(1, 125259, '\p{General_Category=:\Amodifierletter\z:}', "");;
    Expect(0, 125260, '\p{General_Category=:\Amodifierletter\z:}', "");;
    Expect(1, 125259, '\p{General_Category=_ Modifier_LETTER}', "");
    Expect(0, 125259, '\p{^General_Category=_ Modifier_LETTER}', "");
    Expect(0, 125259, '\P{General_Category=_ Modifier_LETTER}', "");
    Expect(1, 125259, '\P{^General_Category=_ Modifier_LETTER}', "");
    Expect(0, 125260, '\p{General_Category=_ Modifier_LETTER}', "");
    Expect(1, 125260, '\p{^General_Category=_ Modifier_LETTER}', "");
    Expect(1, 125260, '\P{General_Category=_ Modifier_LETTER}', "");
    Expect(0, 125260, '\P{^General_Category=_ Modifier_LETTER}', "");
    Error('\p{Gc=:=	_LM}');
    Error('\P{Gc=:=	_LM}');
    Expect(1, 125259, '\p{Gc=:\ALm\z:}', "");;
    Expect(0, 125260, '\p{Gc=:\ALm\z:}', "");;
    Expect(1, 125259, '\p{Gc=lm}', "");
    Expect(0, 125259, '\p{^Gc=lm}', "");
    Expect(0, 125259, '\P{Gc=lm}', "");
    Expect(1, 125259, '\P{^Gc=lm}', "");
    Expect(0, 125260, '\p{Gc=lm}', "");
    Expect(1, 125260, '\p{^Gc=lm}', "");
    Expect(1, 125260, '\P{Gc=lm}', "");
    Expect(0, 125260, '\P{^Gc=lm}', "");
    Expect(1, 125259, '\p{Gc=:\Alm\z:}', "");;
    Expect(0, 125260, '\p{Gc=:\Alm\z:}', "");;
    Expect(1, 125259, '\p{Gc=- LM}', "");
    Expect(0, 125259, '\p{^Gc=- LM}', "");
    Expect(0, 125259, '\P{Gc=- LM}', "");
    Expect(1, 125259, '\P{^Gc=- LM}', "");
    Expect(0, 125260, '\p{Gc=- LM}', "");
    Expect(1, 125260, '\p{^Gc=- LM}', "");
    Expect(1, 125260, '\P{Gc=- LM}', "");
    Expect(0, 125260, '\P{^Gc=- LM}', "");
    Error('\p{Category=/a/-Modifier_Letter}');
    Error('\P{Category=/a/-Modifier_Letter}');
    Expect(1, 125259, '\p{Category=:\AModifier_Letter\z:}', "");;
    Expect(0, 125260, '\p{Category=:\AModifier_Letter\z:}', "");;
    Expect(1, 125259, '\p{Category=modifierletter}', "");
    Expect(0, 125259, '\p{^Category=modifierletter}', "");
    Expect(0, 125259, '\P{Category=modifierletter}', "");
    Expect(1, 125259, '\P{^Category=modifierletter}', "");
    Expect(0, 125260, '\p{Category=modifierletter}', "");
    Expect(1, 125260, '\p{^Category=modifierletter}', "");
    Expect(1, 125260, '\P{Category=modifierletter}', "");
    Expect(0, 125260, '\P{^Category=modifierletter}', "");
    Expect(1, 125259, '\p{Category=:\Amodifierletter\z:}', "");;
    Expect(0, 125260, '\p{Category=:\Amodifierletter\z:}', "");;
    Expect(1, 125259, '\p{Category=-	MODIFIER_Letter}', "");
    Expect(0, 125259, '\p{^Category=-	MODIFIER_Letter}', "");
    Expect(0, 125259, '\P{Category=-	MODIFIER_Letter}', "");
    Expect(1, 125259, '\P{^Category=-	MODIFIER_Letter}', "");
    Expect(0, 125260, '\p{Category=-	MODIFIER_Letter}', "");
    Expect(1, 125260, '\p{^Category=-	MODIFIER_Letter}', "");
    Expect(1, 125260, '\P{Category=-	MODIFIER_Letter}', "");
    Expect(0, 125260, '\P{^Category=-	MODIFIER_Letter}', "");
    Error('\p{Is_General_Category=/a/_-Lm}');
    Error('\P{Is_General_Category=/a/_-Lm}');
    Expect(1, 125259, '\p{Is_General_Category=lm}', "");
    Expect(0, 125259, '\p{^Is_General_Category=lm}', "");
    Expect(0, 125259, '\P{Is_General_Category=lm}', "");
    Expect(1, 125259, '\P{^Is_General_Category=lm}', "");
    Expect(0, 125260, '\p{Is_General_Category=lm}', "");
    Expect(1, 125260, '\p{^Is_General_Category=lm}', "");
    Expect(1, 125260, '\P{Is_General_Category=lm}', "");
    Expect(0, 125260, '\P{^Is_General_Category=lm}', "");
    Expect(1, 125259, '\p{Is_General_Category=_ lm}', "");
    Expect(0, 125259, '\p{^Is_General_Category=_ lm}', "");
    Expect(0, 125259, '\P{Is_General_Category=_ lm}', "");
    Expect(1, 125259, '\P{^Is_General_Category=_ lm}', "");
    Expect(0, 125260, '\p{Is_General_Category=_ lm}', "");
    Expect(1, 125260, '\p{^Is_General_Category=_ lm}', "");
    Expect(1, 125260, '\P{Is_General_Category=_ lm}', "");
    Expect(0, 125260, '\P{^Is_General_Category=_ lm}', "");
    Error('\p{Is_Gc=/a/	MODIFIER_LETTER}');
    Error('\P{Is_Gc=/a/	MODIFIER_LETTER}');
    Expect(1, 125259, '\p{Is_Gc=modifierletter}', "");
    Expect(0, 125259, '\p{^Is_Gc=modifierletter}', "");
    Expect(0, 125259, '\P{Is_Gc=modifierletter}', "");
    Expect(1, 125259, '\P{^Is_Gc=modifierletter}', "");
    Expect(0, 125260, '\p{Is_Gc=modifierletter}', "");
    Expect(1, 125260, '\p{^Is_Gc=modifierletter}', "");
    Expect(1, 125260, '\P{Is_Gc=modifierletter}', "");
    Expect(0, 125260, '\P{^Is_Gc=modifierletter}', "");
    Expect(1, 125259, '\p{Is_Gc= _MODIFIER_Letter}', "");
    Expect(0, 125259, '\p{^Is_Gc= _MODIFIER_Letter}', "");
    Expect(0, 125259, '\P{Is_Gc= _MODIFIER_Letter}', "");
    Expect(1, 125259, '\P{^Is_Gc= _MODIFIER_Letter}', "");
    Expect(0, 125260, '\p{Is_Gc= _MODIFIER_Letter}', "");
    Expect(1, 125260, '\p{^Is_Gc= _MODIFIER_Letter}', "");
    Expect(1, 125260, '\P{Is_Gc= _MODIFIER_Letter}', "");
    Expect(0, 125260, '\P{^Is_Gc= _MODIFIER_Letter}', "");
    Error('\p{Is_Category=/a/  Lm}');
    Error('\P{Is_Category=/a/  Lm}');
    Expect(1, 125259, '\p{Is_Category=lm}', "");
    Expect(0, 125259, '\p{^Is_Category=lm}', "");
    Expect(0, 125259, '\P{Is_Category=lm}', "");
    Expect(1, 125259, '\P{^Is_Category=lm}', "");
    Expect(0, 125260, '\p{Is_Category=lm}', "");
    Expect(1, 125260, '\p{^Is_Category=lm}', "");
    Expect(1, 125260, '\P{Is_Category=lm}', "");
    Expect(0, 125260, '\P{^Is_Category=lm}', "");
    Expect(1, 125259, '\p{Is_Category= Lm}', "");
    Expect(0, 125259, '\p{^Is_Category= Lm}', "");
    Expect(0, 125259, '\P{Is_Category= Lm}', "");
    Expect(1, 125259, '\P{^Is_Category= Lm}', "");
    Expect(0, 125260, '\p{Is_Category= Lm}', "");
    Expect(1, 125260, '\p{^Is_Category= Lm}', "");
    Expect(1, 125260, '\P{Is_Category= Lm}', "");
    Expect(0, 125260, '\P{^Is_Category= Lm}', "");
    Error('\p{General_Category=-other_LETTER:=}');
    Error('\P{General_Category=-other_LETTER:=}');
    Expect(1, 205743, '\p{General_Category=:\AOther_Letter\z:}', "");;
    Expect(0, 205744, '\p{General_Category=:\AOther_Letter\z:}', "");;
    Expect(1, 205743, '\p{General_Category=otherletter}', "");
    Expect(0, 205743, '\p{^General_Category=otherletter}', "");
    Expect(0, 205743, '\P{General_Category=otherletter}', "");
    Expect(1, 205743, '\P{^General_Category=otherletter}', "");
    Expect(0, 205744, '\p{General_Category=otherletter}', "");
    Expect(1, 205744, '\p{^General_Category=otherletter}', "");
    Expect(1, 205744, '\P{General_Category=otherletter}', "");
    Expect(0, 205744, '\P{^General_Category=otherletter}', "");
    Expect(1, 205743, '\p{General_Category=:\Aotherletter\z:}', "");;
    Expect(0, 205744, '\p{General_Category=:\Aotherletter\z:}', "");;
    Expect(1, 205743, '\p{General_Category=	 Other_Letter}', "");
    Expect(0, 205743, '\p{^General_Category=	 Other_Letter}', "");
    Expect(0, 205743, '\P{General_Category=	 Other_Letter}', "");
    Expect(1, 205743, '\P{^General_Category=	 Other_Letter}', "");
    Expect(0, 205744, '\p{General_Category=	 Other_Letter}', "");
    Expect(1, 205744, '\p{^General_Category=	 Other_Letter}', "");
    Expect(1, 205744, '\P{General_Category=	 Other_Letter}', "");
    Expect(0, 205744, '\P{^General_Category=	 Other_Letter}', "");
    Error('\p{Gc=:=		Lo}');
    Error('\P{Gc=:=		Lo}');
    Expect(1, 205743, '\p{Gc=:\ALo\z:}', "");;
    Expect(0, 205744, '\p{Gc=:\ALo\z:}', "");;
    Expect(1, 205743, '\p{Gc=lo}', "");
    Expect(0, 205743, '\p{^Gc=lo}', "");
    Expect(0, 205743, '\P{Gc=lo}', "");
    Expect(1, 205743, '\P{^Gc=lo}', "");
    Expect(0, 205744, '\p{Gc=lo}', "");
    Expect(1, 205744, '\p{^Gc=lo}', "");
    Expect(1, 205744, '\P{Gc=lo}', "");
    Expect(0, 205744, '\P{^Gc=lo}', "");
    Expect(1, 205743, '\p{Gc=:\Alo\z:}', "");;
    Expect(0, 205744, '\p{Gc=:\Alo\z:}', "");;
    Expect(1, 205743, '\p{Gc=--LO}', "");
    Expect(0, 205743, '\p{^Gc=--LO}', "");
    Expect(0, 205743, '\P{Gc=--LO}', "");
    Expect(1, 205743, '\P{^Gc=--LO}', "");
    Expect(0, 205744, '\p{Gc=--LO}', "");
    Expect(1, 205744, '\p{^Gc=--LO}', "");
    Expect(1, 205744, '\P{Gc=--LO}', "");
    Expect(0, 205744, '\P{^Gc=--LO}', "");
    Error('\p{Category:	-:=other_Letter}');
    Error('\P{Category:	-:=other_Letter}');
    Expect(1, 205743, '\p{Category=:\AOther_Letter\z:}', "");;
    Expect(0, 205744, '\p{Category=:\AOther_Letter\z:}', "");;
    Expect(1, 205743, '\p{Category=otherletter}', "");
    Expect(0, 205743, '\p{^Category=otherletter}', "");
    Expect(0, 205743, '\P{Category=otherletter}', "");
    Expect(1, 205743, '\P{^Category=otherletter}', "");
    Expect(0, 205744, '\p{Category=otherletter}', "");
    Expect(1, 205744, '\p{^Category=otherletter}', "");
    Expect(1, 205744, '\P{Category=otherletter}', "");
    Expect(0, 205744, '\P{^Category=otherletter}', "");
    Expect(1, 205743, '\p{Category=:\Aotherletter\z:}', "");;
    Expect(0, 205744, '\p{Category=:\Aotherletter\z:}', "");;
    Expect(1, 205743, '\p{Category:_	other_letter}', "");
    Expect(0, 205743, '\p{^Category:_	other_letter}', "");
    Expect(0, 205743, '\P{Category:_	other_letter}', "");
    Expect(1, 205743, '\P{^Category:_	other_letter}', "");
    Expect(0, 205744, '\p{Category:_	other_letter}', "");
    Expect(1, 205744, '\p{^Category:_	other_letter}', "");
    Expect(1, 205744, '\P{Category:_	other_letter}', "");
    Expect(0, 205744, '\P{^Category:_	other_letter}', "");
    Error('\p{Is_General_Category:	/a/ -lo}');
    Error('\P{Is_General_Category:	/a/ -lo}');
    Expect(1, 205743, '\p{Is_General_Category=lo}', "");
    Expect(0, 205743, '\p{^Is_General_Category=lo}', "");
    Expect(0, 205743, '\P{Is_General_Category=lo}', "");
    Expect(1, 205743, '\P{^Is_General_Category=lo}', "");
    Expect(0, 205744, '\p{Is_General_Category=lo}', "");
    Expect(1, 205744, '\p{^Is_General_Category=lo}', "");
    Expect(1, 205744, '\P{Is_General_Category=lo}', "");
    Expect(0, 205744, '\P{^Is_General_Category=lo}', "");
    Expect(1, 205743, '\p{Is_General_Category=	lo}', "");
    Expect(0, 205743, '\p{^Is_General_Category=	lo}', "");
    Expect(0, 205743, '\P{Is_General_Category=	lo}', "");
    Expect(1, 205743, '\P{^Is_General_Category=	lo}', "");
    Expect(0, 205744, '\p{Is_General_Category=	lo}', "");
    Expect(1, 205744, '\p{^Is_General_Category=	lo}', "");
    Expect(1, 205744, '\P{Is_General_Category=	lo}', "");
    Expect(0, 205744, '\P{^Is_General_Category=	lo}', "");
    Error('\p{Is_Gc: _/a/Other_Letter}');
    Error('\P{Is_Gc: _/a/Other_Letter}');
    Expect(1, 205743, '\p{Is_Gc=otherletter}', "");
    Expect(0, 205743, '\p{^Is_Gc=otherletter}', "");
    Expect(0, 205743, '\P{Is_Gc=otherletter}', "");
    Expect(1, 205743, '\P{^Is_Gc=otherletter}', "");
    Expect(0, 205744, '\p{Is_Gc=otherletter}', "");
    Expect(1, 205744, '\p{^Is_Gc=otherletter}', "");
    Expect(1, 205744, '\P{Is_Gc=otherletter}', "");
    Expect(0, 205744, '\P{^Is_Gc=otherletter}', "");
    Expect(1, 205743, '\p{Is_Gc=-Other_letter}', "");
    Expect(0, 205743, '\p{^Is_Gc=-Other_letter}', "");
    Expect(0, 205743, '\P{Is_Gc=-Other_letter}', "");
    Expect(1, 205743, '\P{^Is_Gc=-Other_letter}', "");
    Expect(0, 205744, '\p{Is_Gc=-Other_letter}', "");
    Expect(1, 205744, '\p{^Is_Gc=-Other_letter}', "");
    Expect(1, 205744, '\P{Is_Gc=-Other_letter}', "");
    Expect(0, 205744, '\P{^Is_Gc=-Other_letter}', "");
    Error('\p{Is_Category=	/a/Lo}');
    Error('\P{Is_Category=	/a/Lo}');
    Expect(1, 205743, '\p{Is_Category=lo}', "");
    Expect(0, 205743, '\p{^Is_Category=lo}', "");
    Expect(0, 205743, '\P{Is_Category=lo}', "");
    Expect(1, 205743, '\P{^Is_Category=lo}', "");
    Expect(0, 205744, '\p{Is_Category=lo}', "");
    Expect(1, 205744, '\p{^Is_Category=lo}', "");
    Expect(1, 205744, '\P{Is_Category=lo}', "");
    Expect(0, 205744, '\P{^Is_Category=lo}', "");
    Expect(1, 205743, '\p{Is_Category=	Lo}', "");
    Expect(0, 205743, '\p{^Is_Category=	Lo}', "");
    Expect(0, 205743, '\P{Is_Category=	Lo}', "");
    Expect(1, 205743, '\P{^Is_Category=	Lo}', "");
    Expect(0, 205744, '\p{Is_Category=	Lo}', "");
    Expect(1, 205744, '\p{^Is_Category=	Lo}', "");
    Expect(1, 205744, '\P{Is_Category=	Lo}', "");
    Expect(0, 205744, '\P{^Is_Category=	Lo}', "");
    Error('\p{General_Category: 	/a/Titlecase_Letter}');
    Error('\P{General_Category: 	/a/Titlecase_Letter}');
    Expect(1, 8188, '\p{General_Category=:\ATitlecase_Letter\z:}', "");;
    Expect(0, 8189, '\p{General_Category=:\ATitlecase_Letter\z:}', "");;
    Expect(1, 8188, '\p{General_Category: titlecaseletter}', "");
    Expect(0, 8188, '\p{^General_Category: titlecaseletter}', "");
    Expect(0, 8188, '\P{General_Category: titlecaseletter}', "");
    Expect(1, 8188, '\P{^General_Category: titlecaseletter}', "");
    Expect(0, 8189, '\p{General_Category: titlecaseletter}', "");
    Expect(1, 8189, '\p{^General_Category: titlecaseletter}', "");
    Expect(1, 8189, '\P{General_Category: titlecaseletter}', "");
    Expect(0, 8189, '\P{^General_Category: titlecaseletter}', "");
    Expect(1, 8188, '\p{General_Category=:\Atitlecaseletter\z:}', "");;
    Expect(0, 8189, '\p{General_Category=:\Atitlecaseletter\z:}', "");;
    Expect(1, 8188, '\p{General_Category:	_titlecase_Letter}', "");
    Expect(0, 8188, '\p{^General_Category:	_titlecase_Letter}', "");
    Expect(0, 8188, '\P{General_Category:	_titlecase_Letter}', "");
    Expect(1, 8188, '\P{^General_Category:	_titlecase_Letter}', "");
    Expect(0, 8189, '\p{General_Category:	_titlecase_Letter}', "");
    Expect(1, 8189, '\p{^General_Category:	_titlecase_Letter}', "");
    Expect(1, 8189, '\P{General_Category:	_titlecase_Letter}', "");
    Expect(0, 8189, '\P{^General_Category:	_titlecase_Letter}', "");
    Error('\p{Gc=-LT/a/}');
    Error('\P{Gc=-LT/a/}');
    Expect(1, 8188, '\p{Gc=:\ALt\z:}', "");;
    Expect(0, 8189, '\p{Gc=:\ALt\z:}', "");;
    Expect(1, 8188, '\p{Gc=lt}', "");
    Expect(0, 8188, '\p{^Gc=lt}', "");
    Expect(0, 8188, '\P{Gc=lt}', "");
    Expect(1, 8188, '\P{^Gc=lt}', "");
    Expect(0, 8189, '\p{Gc=lt}', "");
    Expect(1, 8189, '\p{^Gc=lt}', "");
    Expect(1, 8189, '\P{Gc=lt}', "");
    Expect(0, 8189, '\P{^Gc=lt}', "");
    Expect(1, 8188, '\p{Gc=:\Alt\z:}', "");;
    Expect(0, 8189, '\p{Gc=:\Alt\z:}', "");;
    Expect(1, 8188, '\p{Gc: -LT}', "");
    Expect(0, 8188, '\p{^Gc: -LT}', "");
    Expect(0, 8188, '\P{Gc: -LT}', "");
    Expect(1, 8188, '\P{^Gc: -LT}', "");
    Expect(0, 8189, '\p{Gc: -LT}', "");
    Expect(1, 8189, '\p{^Gc: -LT}', "");
    Expect(1, 8189, '\P{Gc: -LT}', "");
    Expect(0, 8189, '\P{^Gc: -LT}', "");
    Error('\p{Category=_Titlecase_Letter/a/}');
    Error('\P{Category=_Titlecase_Letter/a/}');
    Expect(1, 8188, '\p{Category=:\ATitlecase_Letter\z:}', "");;
    Expect(0, 8189, '\p{Category=:\ATitlecase_Letter\z:}', "");;
    Expect(1, 8188, '\p{Category=titlecaseletter}', "");
    Expect(0, 8188, '\p{^Category=titlecaseletter}', "");
    Expect(0, 8188, '\P{Category=titlecaseletter}', "");
    Expect(1, 8188, '\P{^Category=titlecaseletter}', "");
    Expect(0, 8189, '\p{Category=titlecaseletter}', "");
    Expect(1, 8189, '\p{^Category=titlecaseletter}', "");
    Expect(1, 8189, '\P{Category=titlecaseletter}', "");
    Expect(0, 8189, '\P{^Category=titlecaseletter}', "");
    Expect(1, 8188, '\p{Category=:\Atitlecaseletter\z:}', "");;
    Expect(0, 8189, '\p{Category=:\Atitlecaseletter\z:}', "");;
    Expect(1, 8188, '\p{Category=	 Titlecase_Letter}', "");
    Expect(0, 8188, '\p{^Category=	 Titlecase_Letter}', "");
    Expect(0, 8188, '\P{Category=	 Titlecase_Letter}', "");
    Expect(1, 8188, '\P{^Category=	 Titlecase_Letter}', "");
    Expect(0, 8189, '\p{Category=	 Titlecase_Letter}', "");
    Expect(1, 8189, '\p{^Category=	 Titlecase_Letter}', "");
    Expect(1, 8189, '\P{Category=	 Titlecase_Letter}', "");
    Expect(0, 8189, '\P{^Category=	 Titlecase_Letter}', "");
    Error('\p{Is_General_Category=-_lt/a/}');
    Error('\P{Is_General_Category=-_lt/a/}');
    Expect(1, 8188, '\p{Is_General_Category=lt}', "");
    Expect(0, 8188, '\p{^Is_General_Category=lt}', "");
    Expect(0, 8188, '\P{Is_General_Category=lt}', "");
    Expect(1, 8188, '\P{^Is_General_Category=lt}', "");
    Expect(0, 8189, '\p{Is_General_Category=lt}', "");
    Expect(1, 8189, '\p{^Is_General_Category=lt}', "");
    Expect(1, 8189, '\P{Is_General_Category=lt}', "");
    Expect(0, 8189, '\P{^Is_General_Category=lt}', "");
    Expect(1, 8188, '\p{Is_General_Category=	LT}', "");
    Expect(0, 8188, '\p{^Is_General_Category=	LT}', "");
    Expect(0, 8188, '\P{Is_General_Category=	LT}', "");
    Expect(1, 8188, '\P{^Is_General_Category=	LT}', "");
    Expect(0, 8189, '\p{Is_General_Category=	LT}', "");
    Expect(1, 8189, '\p{^Is_General_Category=	LT}', "");
    Expect(1, 8189, '\P{Is_General_Category=	LT}', "");
    Expect(0, 8189, '\P{^Is_General_Category=	LT}', "");
    Error('\p{Is_Gc=/a/-TITLECASE_LETTER}');
    Error('\P{Is_Gc=/a/-TITLECASE_LETTER}');
    Expect(1, 8188, '\p{Is_Gc=titlecaseletter}', "");
    Expect(0, 8188, '\p{^Is_Gc=titlecaseletter}', "");
    Expect(0, 8188, '\P{Is_Gc=titlecaseletter}', "");
    Expect(1, 8188, '\P{^Is_Gc=titlecaseletter}', "");
    Expect(0, 8189, '\p{Is_Gc=titlecaseletter}', "");
    Expect(1, 8189, '\p{^Is_Gc=titlecaseletter}', "");
    Expect(1, 8189, '\P{Is_Gc=titlecaseletter}', "");
    Expect(0, 8189, '\P{^Is_Gc=titlecaseletter}', "");
    Expect(1, 8188, '\p{Is_Gc= -TITLECASE_letter}', "");
    Expect(0, 8188, '\p{^Is_Gc= -TITLECASE_letter}', "");
    Expect(0, 8188, '\P{Is_Gc= -TITLECASE_letter}', "");
    Expect(1, 8188, '\P{^Is_Gc= -TITLECASE_letter}', "");
    Expect(0, 8189, '\p{Is_Gc= -TITLECASE_letter}', "");
    Expect(1, 8189, '\p{^Is_Gc= -TITLECASE_letter}', "");
    Expect(1, 8189, '\P{Is_Gc= -TITLECASE_letter}', "");
    Expect(0, 8189, '\P{^Is_Gc= -TITLECASE_letter}', "");
    Error('\p{Is_Category=__lt:=}');
    Error('\P{Is_Category=__lt:=}');
    Expect(1, 8188, '\p{Is_Category=lt}', "");
    Expect(0, 8188, '\p{^Is_Category=lt}', "");
    Expect(0, 8188, '\P{Is_Category=lt}', "");
    Expect(1, 8188, '\P{^Is_Category=lt}', "");
    Expect(0, 8189, '\p{Is_Category=lt}', "");
    Expect(1, 8189, '\p{^Is_Category=lt}', "");
    Expect(1, 8189, '\P{Is_Category=lt}', "");
    Expect(0, 8189, '\P{^Is_Category=lt}', "");
    Expect(1, 8188, '\p{Is_Category= -lt}', "");
    Expect(0, 8188, '\p{^Is_Category= -lt}', "");
    Expect(0, 8188, '\P{Is_Category= -lt}', "");
    Expect(1, 8188, '\P{^Is_Category= -lt}', "");
    Expect(0, 8189, '\p{Is_Category= -lt}', "");
    Expect(1, 8189, '\p{^Is_Category= -lt}', "");
    Expect(1, 8189, '\P{Is_Category= -lt}', "");
    Expect(0, 8189, '\P{^Is_Category= -lt}', "");
    Error('\p{General_Category=  UPPERCASE_Letter:=}');
    Error('\P{General_Category=  UPPERCASE_Letter:=}');
    Expect(1, 125217, '\p{General_Category=:\AUppercase_Letter\z:}', "");;
    Expect(0, 125218, '\p{General_Category=:\AUppercase_Letter\z:}', "");;
    Expect(1, 125217, '\p{General_Category=uppercaseletter}', "");
    Expect(0, 125217, '\p{^General_Category=uppercaseletter}', "");
    Expect(0, 125217, '\P{General_Category=uppercaseletter}', "");
    Expect(1, 125217, '\P{^General_Category=uppercaseletter}', "");
    Expect(0, 125218, '\p{General_Category=uppercaseletter}', "");
    Expect(1, 125218, '\p{^General_Category=uppercaseletter}', "");
    Expect(1, 125218, '\P{General_Category=uppercaseletter}', "");
    Expect(0, 125218, '\P{^General_Category=uppercaseletter}', "");
    Expect(1, 125217, '\p{General_Category=:\Auppercaseletter\z:}', "");;
    Expect(0, 125218, '\p{General_Category=:\Auppercaseletter\z:}', "");;
    Expect(1, 125217, '\p{General_Category=	 UPPERCASE_Letter}', "");
    Expect(0, 125217, '\p{^General_Category=	 UPPERCASE_Letter}', "");
    Expect(0, 125217, '\P{General_Category=	 UPPERCASE_Letter}', "");
    Expect(1, 125217, '\P{^General_Category=	 UPPERCASE_Letter}', "");
    Expect(0, 125218, '\p{General_Category=	 UPPERCASE_Letter}', "");
    Expect(1, 125218, '\p{^General_Category=	 UPPERCASE_Letter}', "");
    Expect(1, 125218, '\P{General_Category=	 UPPERCASE_Letter}', "");
    Expect(0, 125218, '\P{^General_Category=	 UPPERCASE_Letter}', "");
    Error('\p{Gc=	:=Lu}');
    Error('\P{Gc=	:=Lu}');
    Expect(1, 125217, '\p{Gc=:\ALu\z:}', "");;
    Expect(0, 125218, '\p{Gc=:\ALu\z:}', "");;
    Expect(1, 125217, '\p{Gc=lu}', "");
    Expect(0, 125217, '\p{^Gc=lu}', "");
    Expect(0, 125217, '\P{Gc=lu}', "");
    Expect(1, 125217, '\P{^Gc=lu}', "");
    Expect(0, 125218, '\p{Gc=lu}', "");
    Expect(1, 125218, '\p{^Gc=lu}', "");
    Expect(1, 125218, '\P{Gc=lu}', "");
    Expect(0, 125218, '\P{^Gc=lu}', "");
    Expect(1, 125217, '\p{Gc=:\Alu\z:}', "");;
    Expect(0, 125218, '\p{Gc=:\Alu\z:}', "");;
    Expect(1, 125217, '\p{Gc= LU}', "");
    Expect(0, 125217, '\p{^Gc= LU}', "");
    Expect(0, 125217, '\P{Gc= LU}', "");
    Expect(1, 125217, '\P{^Gc= LU}', "");
    Expect(0, 125218, '\p{Gc= LU}', "");
    Expect(1, 125218, '\p{^Gc= LU}', "");
    Expect(1, 125218, '\P{Gc= LU}', "");
    Expect(0, 125218, '\P{^Gc= LU}', "");
    Error('\p{Category:/a/-_Uppercase_Letter}');
    Error('\P{Category:/a/-_Uppercase_Letter}');
    Expect(1, 125217, '\p{Category=:\AUppercase_Letter\z:}', "");;
    Expect(0, 125218, '\p{Category=:\AUppercase_Letter\z:}', "");;
    Expect(1, 125217, '\p{Category=uppercaseletter}', "");
    Expect(0, 125217, '\p{^Category=uppercaseletter}', "");
    Expect(0, 125217, '\P{Category=uppercaseletter}', "");
    Expect(1, 125217, '\P{^Category=uppercaseletter}', "");
    Expect(0, 125218, '\p{Category=uppercaseletter}', "");
    Expect(1, 125218, '\p{^Category=uppercaseletter}', "");
    Expect(1, 125218, '\P{Category=uppercaseletter}', "");
    Expect(0, 125218, '\P{^Category=uppercaseletter}', "");
    Expect(1, 125217, '\p{Category=:\Auppercaseletter\z:}', "");;
    Expect(0, 125218, '\p{Category=:\Auppercaseletter\z:}', "");;
    Expect(1, 125217, '\p{Category= -UPPERCASE_Letter}', "");
    Expect(0, 125217, '\p{^Category= -UPPERCASE_Letter}', "");
    Expect(0, 125217, '\P{Category= -UPPERCASE_Letter}', "");
    Expect(1, 125217, '\P{^Category= -UPPERCASE_Letter}', "");
    Expect(0, 125218, '\p{Category= -UPPERCASE_Letter}', "");
    Expect(1, 125218, '\p{^Category= -UPPERCASE_Letter}', "");
    Expect(1, 125218, '\P{Category= -UPPERCASE_Letter}', "");
    Expect(0, 125218, '\P{^Category= -UPPERCASE_Letter}', "");
    Error('\p{Is_General_Category=Lu/a/}');
    Error('\P{Is_General_Category=Lu/a/}');
    Expect(1, 125217, '\p{Is_General_Category=lu}', "");
    Expect(0, 125217, '\p{^Is_General_Category=lu}', "");
    Expect(0, 125217, '\P{Is_General_Category=lu}', "");
    Expect(1, 125217, '\P{^Is_General_Category=lu}', "");
    Expect(0, 125218, '\p{Is_General_Category=lu}', "");
    Expect(1, 125218, '\p{^Is_General_Category=lu}', "");
    Expect(1, 125218, '\P{Is_General_Category=lu}', "");
    Expect(0, 125218, '\P{^Is_General_Category=lu}', "");
    Expect(1, 125217, '\p{Is_General_Category=	LU}', "");
    Expect(0, 125217, '\p{^Is_General_Category=	LU}', "");
    Expect(0, 125217, '\P{Is_General_Category=	LU}', "");
    Expect(1, 125217, '\P{^Is_General_Category=	LU}', "");
    Expect(0, 125218, '\p{Is_General_Category=	LU}', "");
    Expect(1, 125218, '\p{^Is_General_Category=	LU}', "");
    Expect(1, 125218, '\P{Is_General_Category=	LU}', "");
    Expect(0, 125218, '\P{^Is_General_Category=	LU}', "");
    Error('\p{Is_Gc=__uppercase_letter:=}');
    Error('\P{Is_Gc=__uppercase_letter:=}');
    Expect(1, 125217, '\p{Is_Gc=uppercaseletter}', "");
    Expect(0, 125217, '\p{^Is_Gc=uppercaseletter}', "");
    Expect(0, 125217, '\P{Is_Gc=uppercaseletter}', "");
    Expect(1, 125217, '\P{^Is_Gc=uppercaseletter}', "");
    Expect(0, 125218, '\p{Is_Gc=uppercaseletter}', "");
    Expect(1, 125218, '\p{^Is_Gc=uppercaseletter}', "");
    Expect(1, 125218, '\P{Is_Gc=uppercaseletter}', "");
    Expect(0, 125218, '\P{^Is_Gc=uppercaseletter}', "");
    Expect(1, 125217, '\p{Is_Gc=-_Uppercase_Letter}', "");
    Expect(0, 125217, '\p{^Is_Gc=-_Uppercase_Letter}', "");
    Expect(0, 125217, '\P{Is_Gc=-_Uppercase_Letter}', "");
    Expect(1, 125217, '\P{^Is_Gc=-_Uppercase_Letter}', "");
    Expect(0, 125218, '\p{Is_Gc=-_Uppercase_Letter}', "");
    Expect(1, 125218, '\p{^Is_Gc=-_Uppercase_Letter}', "");
    Expect(1, 125218, '\P{Is_Gc=-_Uppercase_Letter}', "");
    Expect(0, 125218, '\P{^Is_Gc=-_Uppercase_Letter}', "");
    Error('\p{Is_Category=:=	lu}');
    Error('\P{Is_Category=:=	lu}');
    Expect(1, 125217, '\p{Is_Category=lu}', "");
    Expect(0, 125217, '\p{^Is_Category=lu}', "");
    Expect(0, 125217, '\P{Is_Category=lu}', "");
    Expect(1, 125217, '\P{^Is_Category=lu}', "");
    Expect(0, 125218, '\p{Is_Category=lu}', "");
    Expect(1, 125218, '\p{^Is_Category=lu}', "");
    Expect(1, 125218, '\P{Is_Category=lu}', "");
    Expect(0, 125218, '\P{^Is_Category=lu}', "");
    Expect(1, 125217, '\p{Is_Category=_LU}', "");
    Expect(0, 125217, '\p{^Is_Category=_LU}', "");
    Expect(0, 125217, '\P{Is_Category=_LU}', "");
    Expect(1, 125217, '\P{^Is_Category=_LU}', "");
    Expect(0, 125218, '\p{Is_Category=_LU}', "");
    Expect(1, 125218, '\p{^Is_Category=_LU}', "");
    Expect(1, 125218, '\P{Is_Category=_LU}', "");
    Expect(0, 125218, '\P{^Is_Category=_LU}', "");
    Error('\p{General_Category= :=mark}');
    Error('\P{General_Category= :=mark}');
    Expect(1, 917999, '\p{General_Category=:\AMark\z:}', "");;
    Expect(0, 918000, '\p{General_Category=:\AMark\z:}', "");;
    Expect(1, 917999, '\p{General_Category=mark}', "");
    Expect(0, 917999, '\p{^General_Category=mark}', "");
    Expect(0, 917999, '\P{General_Category=mark}', "");
    Expect(1, 917999, '\P{^General_Category=mark}', "");
    Expect(0, 918000, '\p{General_Category=mark}', "");
    Expect(1, 918000, '\p{^General_Category=mark}', "");
    Expect(1, 918000, '\P{General_Category=mark}', "");
    Expect(0, 918000, '\P{^General_Category=mark}', "");
    Expect(1, 917999, '\p{General_Category=:\Amark\z:}', "");;
    Expect(0, 918000, '\p{General_Category=:\Amark\z:}', "");;
    Expect(1, 917999, '\p{General_Category= 	Mark}', "");
    Expect(0, 917999, '\p{^General_Category= 	Mark}', "");
    Expect(0, 917999, '\P{General_Category= 	Mark}', "");
    Expect(1, 917999, '\P{^General_Category= 	Mark}', "");
    Expect(0, 918000, '\p{General_Category= 	Mark}', "");
    Expect(1, 918000, '\p{^General_Category= 	Mark}', "");
    Expect(1, 918000, '\P{General_Category= 	Mark}', "");
    Expect(0, 918000, '\P{^General_Category= 	Mark}', "");
    Error('\p{Gc=_/a/m}');
    Error('\P{Gc=_/a/m}');
    Expect(1, 917999, '\p{Gc=:\AM\z:}', "");;
    Expect(0, 918000, '\p{Gc=:\AM\z:}', "");;
    Expect(1, 917999, '\p{Gc=m}', "");
    Expect(0, 917999, '\p{^Gc=m}', "");
    Expect(0, 917999, '\P{Gc=m}', "");
    Expect(1, 917999, '\P{^Gc=m}', "");
    Expect(0, 918000, '\p{Gc=m}', "");
    Expect(1, 918000, '\p{^Gc=m}', "");
    Expect(1, 918000, '\P{Gc=m}', "");
    Expect(0, 918000, '\P{^Gc=m}', "");
    Expect(1, 917999, '\p{Gc=:\Am\z:}', "");;
    Expect(0, 918000, '\p{Gc=:\Am\z:}', "");;
    Expect(1, 917999, '\p{Gc=--M}', "");
    Expect(0, 917999, '\p{^Gc=--M}', "");
    Expect(0, 917999, '\P{Gc=--M}', "");
    Expect(1, 917999, '\P{^Gc=--M}', "");
    Expect(0, 918000, '\p{Gc=--M}', "");
    Expect(1, 918000, '\p{^Gc=--M}', "");
    Expect(1, 918000, '\P{Gc=--M}', "");
    Expect(0, 918000, '\P{^Gc=--M}', "");
    Error('\p{Category=/a/Combining_Mark}');
    Error('\P{Category=/a/Combining_Mark}');
    Expect(1, 917999, '\p{Category=:\ACombining_Mark\z:}', "");;
    Expect(0, 918000, '\p{Category=:\ACombining_Mark\z:}', "");;
    Expect(1, 917999, '\p{Category=combiningmark}', "");
    Expect(0, 917999, '\p{^Category=combiningmark}', "");
    Expect(0, 917999, '\P{Category=combiningmark}', "");
    Expect(1, 917999, '\P{^Category=combiningmark}', "");
    Expect(0, 918000, '\p{Category=combiningmark}', "");
    Expect(1, 918000, '\p{^Category=combiningmark}', "");
    Expect(1, 918000, '\P{Category=combiningmark}', "");
    Expect(0, 918000, '\P{^Category=combiningmark}', "");
    Expect(1, 917999, '\p{Category=:\Acombiningmark\z:}', "");;
    Expect(0, 918000, '\p{Category=:\Acombiningmark\z:}', "");;
    Expect(1, 917999, '\p{Category= _COMBINING_MARK}', "");
    Expect(0, 917999, '\p{^Category= _COMBINING_MARK}', "");
    Expect(0, 917999, '\P{Category= _COMBINING_MARK}', "");
    Expect(1, 917999, '\P{^Category= _COMBINING_MARK}', "");
    Expect(0, 918000, '\p{Category= _COMBINING_MARK}', "");
    Expect(1, 918000, '\p{^Category= _COMBINING_MARK}', "");
    Expect(1, 918000, '\P{Category= _COMBINING_MARK}', "");
    Expect(0, 918000, '\P{^Category= _COMBINING_MARK}', "");
    Error('\p{Is_General_Category= Mark:=}');
    Error('\P{Is_General_Category= Mark:=}');
    Expect(1, 917999, '\p{Is_General_Category=mark}', "");
    Expect(0, 917999, '\p{^Is_General_Category=mark}', "");
    Expect(0, 917999, '\P{Is_General_Category=mark}', "");
    Expect(1, 917999, '\P{^Is_General_Category=mark}', "");
    Expect(0, 918000, '\p{Is_General_Category=mark}', "");
    Expect(1, 918000, '\p{^Is_General_Category=mark}', "");
    Expect(1, 918000, '\P{Is_General_Category=mark}', "");
    Expect(0, 918000, '\P{^Is_General_Category=mark}', "");
    Expect(1, 917999, '\p{Is_General_Category=-MARK}', "");
    Expect(0, 917999, '\p{^Is_General_Category=-MARK}', "");
    Expect(0, 917999, '\P{Is_General_Category=-MARK}', "");
    Expect(1, 917999, '\P{^Is_General_Category=-MARK}', "");
    Expect(0, 918000, '\p{Is_General_Category=-MARK}', "");
    Expect(1, 918000, '\p{^Is_General_Category=-MARK}', "");
    Expect(1, 918000, '\P{Is_General_Category=-MARK}', "");
    Expect(0, 918000, '\P{^Is_General_Category=-MARK}', "");
    Error('\p{Is_Gc=/a/	_M}');
    Error('\P{Is_Gc=/a/	_M}');
    Expect(1, 917999, '\p{Is_Gc:m}', "");
    Expect(0, 917999, '\p{^Is_Gc:m}', "");
    Expect(0, 917999, '\P{Is_Gc:m}', "");
    Expect(1, 917999, '\P{^Is_Gc:m}', "");
    Expect(0, 918000, '\p{Is_Gc:m}', "");
    Expect(1, 918000, '\p{^Is_Gc:m}', "");
    Expect(1, 918000, '\P{Is_Gc:m}', "");
    Expect(0, 918000, '\P{^Is_Gc:m}', "");
    Expect(1, 917999, '\p{Is_Gc=M}', "");
    Expect(0, 917999, '\p{^Is_Gc=M}', "");
    Expect(0, 917999, '\P{Is_Gc=M}', "");
    Expect(1, 917999, '\P{^Is_Gc=M}', "");
    Expect(0, 918000, '\p{Is_Gc=M}', "");
    Expect(1, 918000, '\p{^Is_Gc=M}', "");
    Expect(1, 918000, '\P{Is_Gc=M}', "");
    Expect(0, 918000, '\P{^Is_Gc=M}', "");
    Error('\p{Is_Category=:=-	COMBINING_Mark}');
    Error('\P{Is_Category=:=-	COMBINING_Mark}');
    Expect(1, 917999, '\p{Is_Category=combiningmark}', "");
    Expect(0, 917999, '\p{^Is_Category=combiningmark}', "");
    Expect(0, 917999, '\P{Is_Category=combiningmark}', "");
    Expect(1, 917999, '\P{^Is_Category=combiningmark}', "");
    Expect(0, 918000, '\p{Is_Category=combiningmark}', "");
    Expect(1, 918000, '\p{^Is_Category=combiningmark}', "");
    Expect(1, 918000, '\P{Is_Category=combiningmark}', "");
    Expect(0, 918000, '\P{^Is_Category=combiningmark}', "");
    Expect(1, 917999, '\p{Is_Category=_-combining_Mark}', "");
    Expect(0, 917999, '\p{^Is_Category=_-combining_Mark}', "");
    Expect(0, 917999, '\P{Is_Category=_-combining_Mark}', "");
    Expect(1, 917999, '\P{^Is_Category=_-combining_Mark}', "");
    Expect(0, 918000, '\p{Is_Category=_-combining_Mark}', "");
    Expect(1, 918000, '\p{^Is_Category=_-combining_Mark}', "");
    Expect(1, 918000, '\P{Is_Category=_-combining_Mark}', "");
    Expect(0, 918000, '\P{^Is_Category=_-combining_Mark}', "");
    Error('\p{General_Category=__Spacing_Mark:=}');
    Error('\P{General_Category=__Spacing_Mark:=}');
    Expect(1, 119154, '\p{General_Category=:\ASpacing_Mark\z:}', "");;
    Expect(0, 119155, '\p{General_Category=:\ASpacing_Mark\z:}', "");;
    Expect(1, 119154, '\p{General_Category=spacingmark}', "");
    Expect(0, 119154, '\p{^General_Category=spacingmark}', "");
    Expect(0, 119154, '\P{General_Category=spacingmark}', "");
    Expect(1, 119154, '\P{^General_Category=spacingmark}', "");
    Expect(0, 119155, '\p{General_Category=spacingmark}', "");
    Expect(1, 119155, '\p{^General_Category=spacingmark}', "");
    Expect(1, 119155, '\P{General_Category=spacingmark}', "");
    Expect(0, 119155, '\P{^General_Category=spacingmark}', "");
    Expect(1, 119154, '\p{General_Category=:\Aspacingmark\z:}', "");;
    Expect(0, 119155, '\p{General_Category=:\Aspacingmark\z:}', "");;
    Expect(1, 119154, '\p{General_Category=-_Spacing_MARK}', "");
    Expect(0, 119154, '\p{^General_Category=-_Spacing_MARK}', "");
    Expect(0, 119154, '\P{General_Category=-_Spacing_MARK}', "");
    Expect(1, 119154, '\P{^General_Category=-_Spacing_MARK}', "");
    Expect(0, 119155, '\p{General_Category=-_Spacing_MARK}', "");
    Expect(1, 119155, '\p{^General_Category=-_Spacing_MARK}', "");
    Expect(1, 119155, '\P{General_Category=-_Spacing_MARK}', "");
    Expect(0, 119155, '\P{^General_Category=-_Spacing_MARK}', "");
    Error('\p{Gc= _MC:=}');
    Error('\P{Gc= _MC:=}');
    Expect(1, 119154, '\p{Gc=:\AMc\z:}', "");;
    Expect(0, 119155, '\p{Gc=:\AMc\z:}', "");;
    Expect(1, 119154, '\p{Gc=mc}', "");
    Expect(0, 119154, '\p{^Gc=mc}', "");
    Expect(0, 119154, '\P{Gc=mc}', "");
    Expect(1, 119154, '\P{^Gc=mc}', "");
    Expect(0, 119155, '\p{Gc=mc}', "");
    Expect(1, 119155, '\p{^Gc=mc}', "");
    Expect(1, 119155, '\P{Gc=mc}', "");
    Expect(0, 119155, '\P{^Gc=mc}', "");
    Expect(1, 119154, '\p{Gc=:\Amc\z:}', "");;
    Expect(0, 119155, '\p{Gc=:\Amc\z:}', "");;
    Expect(1, 119154, '\p{Gc=_mc}', "");
    Expect(0, 119154, '\p{^Gc=_mc}', "");
    Expect(0, 119154, '\P{Gc=_mc}', "");
    Expect(1, 119154, '\P{^Gc=_mc}', "");
    Expect(0, 119155, '\p{Gc=_mc}', "");
    Expect(1, 119155, '\p{^Gc=_mc}', "");
    Expect(1, 119155, '\P{Gc=_mc}', "");
    Expect(0, 119155, '\P{^Gc=_mc}', "");
    Error('\p{Category=/a/	-Spacing_MARK}');
    Error('\P{Category=/a/	-Spacing_MARK}');
    Expect(1, 119154, '\p{Category=:\ASpacing_Mark\z:}', "");;
    Expect(0, 119155, '\p{Category=:\ASpacing_Mark\z:}', "");;
    Expect(1, 119154, '\p{Category=spacingmark}', "");
    Expect(0, 119154, '\p{^Category=spacingmark}', "");
    Expect(0, 119154, '\P{Category=spacingmark}', "");
    Expect(1, 119154, '\P{^Category=spacingmark}', "");
    Expect(0, 119155, '\p{Category=spacingmark}', "");
    Expect(1, 119155, '\p{^Category=spacingmark}', "");
    Expect(1, 119155, '\P{Category=spacingmark}', "");
    Expect(0, 119155, '\P{^Category=spacingmark}', "");
    Expect(1, 119154, '\p{Category=:\Aspacingmark\z:}', "");;
    Expect(0, 119155, '\p{Category=:\Aspacingmark\z:}', "");;
    Expect(1, 119154, '\p{Category= spacing_Mark}', "");
    Expect(0, 119154, '\p{^Category= spacing_Mark}', "");
    Expect(0, 119154, '\P{Category= spacing_Mark}', "");
    Expect(1, 119154, '\P{^Category= spacing_Mark}', "");
    Expect(0, 119155, '\p{Category= spacing_Mark}', "");
    Expect(1, 119155, '\p{^Category= spacing_Mark}', "");
    Expect(1, 119155, '\P{Category= spacing_Mark}', "");
    Expect(0, 119155, '\P{^Category= spacing_Mark}', "");
    Error('\p{Is_General_Category=	mc/a/}');
    Error('\P{Is_General_Category=	mc/a/}');
    Expect(1, 119154, '\p{Is_General_Category=mc}', "");
    Expect(0, 119154, '\p{^Is_General_Category=mc}', "");
    Expect(0, 119154, '\P{Is_General_Category=mc}', "");
    Expect(1, 119154, '\P{^Is_General_Category=mc}', "");
    Expect(0, 119155, '\p{Is_General_Category=mc}', "");
    Expect(1, 119155, '\p{^Is_General_Category=mc}', "");
    Expect(1, 119155, '\P{Is_General_Category=mc}', "");
    Expect(0, 119155, '\P{^Is_General_Category=mc}', "");
    Expect(1, 119154, '\p{Is_General_Category=		mc}', "");
    Expect(0, 119154, '\p{^Is_General_Category=		mc}', "");
    Expect(0, 119154, '\P{Is_General_Category=		mc}', "");
    Expect(1, 119154, '\P{^Is_General_Category=		mc}', "");
    Expect(0, 119155, '\p{Is_General_Category=		mc}', "");
    Expect(1, 119155, '\p{^Is_General_Category=		mc}', "");
    Expect(1, 119155, '\P{Is_General_Category=		mc}', "");
    Expect(0, 119155, '\P{^Is_General_Category=		mc}', "");
    Error('\p{Is_Gc=:=-SPACING_MARK}');
    Error('\P{Is_Gc=:=-SPACING_MARK}');
    Expect(1, 119154, '\p{Is_Gc=spacingmark}', "");
    Expect(0, 119154, '\p{^Is_Gc=spacingmark}', "");
    Expect(0, 119154, '\P{Is_Gc=spacingmark}', "");
    Expect(1, 119154, '\P{^Is_Gc=spacingmark}', "");
    Expect(0, 119155, '\p{Is_Gc=spacingmark}', "");
    Expect(1, 119155, '\p{^Is_Gc=spacingmark}', "");
    Expect(1, 119155, '\P{Is_Gc=spacingmark}', "");
    Expect(0, 119155, '\P{^Is_Gc=spacingmark}', "");
    Expect(1, 119154, '\p{Is_Gc= -Spacing_mark}', "");
    Expect(0, 119154, '\p{^Is_Gc= -Spacing_mark}', "");
    Expect(0, 119154, '\P{Is_Gc= -Spacing_mark}', "");
    Expect(1, 119154, '\P{^Is_Gc= -Spacing_mark}', "");
    Expect(0, 119155, '\p{Is_Gc= -Spacing_mark}', "");
    Expect(1, 119155, '\p{^Is_Gc= -Spacing_mark}', "");
    Expect(1, 119155, '\P{Is_Gc= -Spacing_mark}', "");
    Expect(0, 119155, '\P{^Is_Gc= -Spacing_mark}', "");
    Error('\p{Is_Category:	-mc:=}');
    Error('\P{Is_Category:	-mc:=}');
    Expect(1, 119154, '\p{Is_Category=mc}', "");
    Expect(0, 119154, '\p{^Is_Category=mc}', "");
    Expect(0, 119154, '\P{Is_Category=mc}', "");
    Expect(1, 119154, '\P{^Is_Category=mc}', "");
    Expect(0, 119155, '\p{Is_Category=mc}', "");
    Expect(1, 119155, '\p{^Is_Category=mc}', "");
    Expect(1, 119155, '\P{Is_Category=mc}', "");
    Expect(0, 119155, '\P{^Is_Category=mc}', "");
    Expect(1, 119154, '\p{Is_Category= 	mc}', "");
    Expect(0, 119154, '\p{^Is_Category= 	mc}', "");
    Expect(0, 119154, '\P{Is_Category= 	mc}', "");
    Expect(1, 119154, '\P{^Is_Category= 	mc}', "");
    Expect(0, 119155, '\p{Is_Category= 	mc}', "");
    Expect(1, 119155, '\p{^Is_Category= 	mc}', "");
    Expect(1, 119155, '\P{Is_Category= 	mc}', "");
    Expect(0, 119155, '\P{^Is_Category= 	mc}', "");
    Error('\p{General_Category=	Enclosing_MARK/a/}');
    Error('\P{General_Category=	Enclosing_MARK/a/}');
    Expect(1, 42610, '\p{General_Category=:\AEnclosing_Mark\z:}', "");;
    Expect(0, 42611, '\p{General_Category=:\AEnclosing_Mark\z:}', "");;
    Expect(1, 42610, '\p{General_Category=enclosingmark}', "");
    Expect(0, 42610, '\p{^General_Category=enclosingmark}', "");
    Expect(0, 42610, '\P{General_Category=enclosingmark}', "");
    Expect(1, 42610, '\P{^General_Category=enclosingmark}', "");
    Expect(0, 42611, '\p{General_Category=enclosingmark}', "");
    Expect(1, 42611, '\p{^General_Category=enclosingmark}', "");
    Expect(1, 42611, '\P{General_Category=enclosingmark}', "");
    Expect(0, 42611, '\P{^General_Category=enclosingmark}', "");
    Expect(1, 42610, '\p{General_Category=:\Aenclosingmark\z:}', "");;
    Expect(0, 42611, '\p{General_Category=:\Aenclosingmark\z:}', "");;
    Expect(1, 42610, '\p{General_Category=	enclosing_Mark}', "");
    Expect(0, 42610, '\p{^General_Category=	enclosing_Mark}', "");
    Expect(0, 42610, '\P{General_Category=	enclosing_Mark}', "");
    Expect(1, 42610, '\P{^General_Category=	enclosing_Mark}', "");
    Expect(0, 42611, '\p{General_Category=	enclosing_Mark}', "");
    Expect(1, 42611, '\p{^General_Category=	enclosing_Mark}', "");
    Expect(1, 42611, '\P{General_Category=	enclosing_Mark}', "");
    Expect(0, 42611, '\P{^General_Category=	enclosing_Mark}', "");
    Error('\p{Gc=:=	 Me}');
    Error('\P{Gc=:=	 Me}');
    Expect(1, 42610, '\p{Gc=:\AMe\z:}', "");;
    Expect(0, 42611, '\p{Gc=:\AMe\z:}', "");;
    Expect(1, 42610, '\p{Gc=me}', "");
    Expect(0, 42610, '\p{^Gc=me}', "");
    Expect(0, 42610, '\P{Gc=me}', "");
    Expect(1, 42610, '\P{^Gc=me}', "");
    Expect(0, 42611, '\p{Gc=me}', "");
    Expect(1, 42611, '\p{^Gc=me}', "");
    Expect(1, 42611, '\P{Gc=me}', "");
    Expect(0, 42611, '\P{^Gc=me}', "");
    Expect(1, 42610, '\p{Gc=:\Ame\z:}', "");;
    Expect(0, 42611, '\p{Gc=:\Ame\z:}', "");;
    Expect(1, 42610, '\p{Gc=- me}', "");
    Expect(0, 42610, '\p{^Gc=- me}', "");
    Expect(0, 42610, '\P{Gc=- me}', "");
    Expect(1, 42610, '\P{^Gc=- me}', "");
    Expect(0, 42611, '\p{Gc=- me}', "");
    Expect(1, 42611, '\p{^Gc=- me}', "");
    Expect(1, 42611, '\P{Gc=- me}', "");
    Expect(0, 42611, '\P{^Gc=- me}', "");
    Error('\p{Category: _Enclosing_Mark/a/}');
    Error('\P{Category: _Enclosing_Mark/a/}');
    Expect(1, 42610, '\p{Category=:\AEnclosing_Mark\z:}', "");;
    Expect(0, 42611, '\p{Category=:\AEnclosing_Mark\z:}', "");;
    Expect(1, 42610, '\p{Category=enclosingmark}', "");
    Expect(0, 42610, '\p{^Category=enclosingmark}', "");
    Expect(0, 42610, '\P{Category=enclosingmark}', "");
    Expect(1, 42610, '\P{^Category=enclosingmark}', "");
    Expect(0, 42611, '\p{Category=enclosingmark}', "");
    Expect(1, 42611, '\p{^Category=enclosingmark}', "");
    Expect(1, 42611, '\P{Category=enclosingmark}', "");
    Expect(0, 42611, '\P{^Category=enclosingmark}', "");
    Expect(1, 42610, '\p{Category=:\Aenclosingmark\z:}', "");;
    Expect(0, 42611, '\p{Category=:\Aenclosingmark\z:}', "");;
    Expect(1, 42610, '\p{Category=-	ENCLOSING_MARK}', "");
    Expect(0, 42610, '\p{^Category=-	ENCLOSING_MARK}', "");
    Expect(0, 42610, '\P{Category=-	ENCLOSING_MARK}', "");
    Expect(1, 42610, '\P{^Category=-	ENCLOSING_MARK}', "");
    Expect(0, 42611, '\p{Category=-	ENCLOSING_MARK}', "");
    Expect(1, 42611, '\p{^Category=-	ENCLOSING_MARK}', "");
    Expect(1, 42611, '\P{Category=-	ENCLOSING_MARK}', "");
    Expect(0, 42611, '\P{^Category=-	ENCLOSING_MARK}', "");
    Error('\p{Is_General_Category= /a/me}');
    Error('\P{Is_General_Category= /a/me}');
    Expect(1, 42610, '\p{Is_General_Category=me}', "");
    Expect(0, 42610, '\p{^Is_General_Category=me}', "");
    Expect(0, 42610, '\P{Is_General_Category=me}', "");
    Expect(1, 42610, '\P{^Is_General_Category=me}', "");
    Expect(0, 42611, '\p{Is_General_Category=me}', "");
    Expect(1, 42611, '\p{^Is_General_Category=me}', "");
    Expect(1, 42611, '\P{Is_General_Category=me}', "");
    Expect(0, 42611, '\P{^Is_General_Category=me}', "");
    Expect(1, 42610, '\p{Is_General_Category=--Me}', "");
    Expect(0, 42610, '\p{^Is_General_Category=--Me}', "");
    Expect(0, 42610, '\P{Is_General_Category=--Me}', "");
    Expect(1, 42610, '\P{^Is_General_Category=--Me}', "");
    Expect(0, 42611, '\p{Is_General_Category=--Me}', "");
    Expect(1, 42611, '\p{^Is_General_Category=--Me}', "");
    Expect(1, 42611, '\P{Is_General_Category=--Me}', "");
    Expect(0, 42611, '\P{^Is_General_Category=--Me}', "");
    Error('\p{Is_Gc=  ENCLOSING_MARK:=}');
    Error('\P{Is_Gc=  ENCLOSING_MARK:=}');
    Expect(1, 42610, '\p{Is_Gc=enclosingmark}', "");
    Expect(0, 42610, '\p{^Is_Gc=enclosingmark}', "");
    Expect(0, 42610, '\P{Is_Gc=enclosingmark}', "");
    Expect(1, 42610, '\P{^Is_Gc=enclosingmark}', "");
    Expect(0, 42611, '\p{Is_Gc=enclosingmark}', "");
    Expect(1, 42611, '\p{^Is_Gc=enclosingmark}', "");
    Expect(1, 42611, '\P{Is_Gc=enclosingmark}', "");
    Expect(0, 42611, '\P{^Is_Gc=enclosingmark}', "");
    Expect(1, 42610, '\p{Is_Gc: -_Enclosing_Mark}', "");
    Expect(0, 42610, '\p{^Is_Gc: -_Enclosing_Mark}', "");
    Expect(0, 42610, '\P{Is_Gc: -_Enclosing_Mark}', "");
    Expect(1, 42610, '\P{^Is_Gc: -_Enclosing_Mark}', "");
    Expect(0, 42611, '\p{Is_Gc: -_Enclosing_Mark}', "");
    Expect(1, 42611, '\p{^Is_Gc: -_Enclosing_Mark}', "");
    Expect(1, 42611, '\P{Is_Gc: -_Enclosing_Mark}', "");
    Expect(0, 42611, '\P{^Is_Gc: -_Enclosing_Mark}', "");
    Error('\p{Is_Category=:=_	ME}');
    Error('\P{Is_Category=:=_	ME}');
    Expect(1, 42610, '\p{Is_Category=me}', "");
    Expect(0, 42610, '\p{^Is_Category=me}', "");
    Expect(0, 42610, '\P{Is_Category=me}', "");
    Expect(1, 42610, '\P{^Is_Category=me}', "");
    Expect(0, 42611, '\p{Is_Category=me}', "");
    Expect(1, 42611, '\p{^Is_Category=me}', "");
    Expect(1, 42611, '\P{Is_Category=me}', "");
    Expect(0, 42611, '\P{^Is_Category=me}', "");
    Expect(1, 42610, '\p{Is_Category=_ME}', "");
    Expect(0, 42610, '\p{^Is_Category=_ME}', "");
    Expect(0, 42610, '\P{Is_Category=_ME}', "");
    Expect(1, 42610, '\P{^Is_Category=_ME}', "");
    Expect(0, 42611, '\p{Is_Category=_ME}', "");
    Expect(1, 42611, '\p{^Is_Category=_ME}', "");
    Expect(1, 42611, '\P{Is_Category=_ME}', "");
    Expect(0, 42611, '\P{^Is_Category=_ME}', "");
    Error('\p{General_Category=-nonspacing_Mark:=}');
    Error('\P{General_Category=-nonspacing_Mark:=}');
    Expect(1, 917999, '\p{General_Category=:\ANonspacing_Mark\z:}', "");;
    Expect(0, 918000, '\p{General_Category=:\ANonspacing_Mark\z:}', "");;
    Expect(1, 917999, '\p{General_Category=nonspacingmark}', "");
    Expect(0, 917999, '\p{^General_Category=nonspacingmark}', "");
    Expect(0, 917999, '\P{General_Category=nonspacingmark}', "");
    Expect(1, 917999, '\P{^General_Category=nonspacingmark}', "");
    Expect(0, 918000, '\p{General_Category=nonspacingmark}', "");
    Expect(1, 918000, '\p{^General_Category=nonspacingmark}', "");
    Expect(1, 918000, '\P{General_Category=nonspacingmark}', "");
    Expect(0, 918000, '\P{^General_Category=nonspacingmark}', "");
    Expect(1, 917999, '\p{General_Category=:\Anonspacingmark\z:}', "");;
    Expect(0, 918000, '\p{General_Category=:\Anonspacingmark\z:}', "");;
    Expect(1, 917999, '\p{General_Category=		Nonspacing_mark}', "");
    Expect(0, 917999, '\p{^General_Category=		Nonspacing_mark}', "");
    Expect(0, 917999, '\P{General_Category=		Nonspacing_mark}', "");
    Expect(1, 917999, '\P{^General_Category=		Nonspacing_mark}', "");
    Expect(0, 918000, '\p{General_Category=		Nonspacing_mark}', "");
    Expect(1, 918000, '\p{^General_Category=		Nonspacing_mark}', "");
    Expect(1, 918000, '\P{General_Category=		Nonspacing_mark}', "");
    Expect(0, 918000, '\P{^General_Category=		Nonspacing_mark}', "");
    Error('\p{Gc=_	mn:=}');
    Error('\P{Gc=_	mn:=}');
    Expect(1, 917999, '\p{Gc=:\AMn\z:}', "");;
    Expect(0, 918000, '\p{Gc=:\AMn\z:}', "");;
    Expect(1, 917999, '\p{Gc=mn}', "");
    Expect(0, 917999, '\p{^Gc=mn}', "");
    Expect(0, 917999, '\P{Gc=mn}', "");
    Expect(1, 917999, '\P{^Gc=mn}', "");
    Expect(0, 918000, '\p{Gc=mn}', "");
    Expect(1, 918000, '\p{^Gc=mn}', "");
    Expect(1, 918000, '\P{Gc=mn}', "");
    Expect(0, 918000, '\P{^Gc=mn}', "");
    Expect(1, 917999, '\p{Gc=:\Amn\z:}', "");;
    Expect(0, 918000, '\p{Gc=:\Amn\z:}', "");;
    Expect(1, 917999, '\p{Gc= mn}', "");
    Expect(0, 917999, '\p{^Gc= mn}', "");
    Expect(0, 917999, '\P{Gc= mn}', "");
    Expect(1, 917999, '\P{^Gc= mn}', "");
    Expect(0, 918000, '\p{Gc= mn}', "");
    Expect(1, 918000, '\p{^Gc= mn}', "");
    Expect(1, 918000, '\P{Gc= mn}', "");
    Expect(0, 918000, '\P{^Gc= mn}', "");
    Error('\p{Category=:= 	Nonspacing_mark}');
    Error('\P{Category=:= 	Nonspacing_mark}');
    Expect(1, 917999, '\p{Category=:\ANonspacing_Mark\z:}', "");;
    Expect(0, 918000, '\p{Category=:\ANonspacing_Mark\z:}', "");;
    Expect(1, 917999, '\p{Category=nonspacingmark}', "");
    Expect(0, 917999, '\p{^Category=nonspacingmark}', "");
    Expect(0, 917999, '\P{Category=nonspacingmark}', "");
    Expect(1, 917999, '\P{^Category=nonspacingmark}', "");
    Expect(0, 918000, '\p{Category=nonspacingmark}', "");
    Expect(1, 918000, '\p{^Category=nonspacingmark}', "");
    Expect(1, 918000, '\P{Category=nonspacingmark}', "");
    Expect(0, 918000, '\P{^Category=nonspacingmark}', "");
    Expect(1, 917999, '\p{Category=:\Anonspacingmark\z:}', "");;
    Expect(0, 918000, '\p{Category=:\Anonspacingmark\z:}', "");;
    Expect(1, 917999, '\p{Category= nonspacing_Mark}', "");
    Expect(0, 917999, '\p{^Category= nonspacing_Mark}', "");
    Expect(0, 917999, '\P{Category= nonspacing_Mark}', "");
    Expect(1, 917999, '\P{^Category= nonspacing_Mark}', "");
    Expect(0, 918000, '\p{Category= nonspacing_Mark}', "");
    Expect(1, 918000, '\p{^Category= nonspacing_Mark}', "");
    Expect(1, 918000, '\P{Category= nonspacing_Mark}', "");
    Expect(0, 918000, '\P{^Category= nonspacing_Mark}', "");
    Error('\p{Is_General_Category= MN/a/}');
    Error('\P{Is_General_Category= MN/a/}');
    Expect(1, 917999, '\p{Is_General_Category=mn}', "");
    Expect(0, 917999, '\p{^Is_General_Category=mn}', "");
    Expect(0, 917999, '\P{Is_General_Category=mn}', "");
    Expect(1, 917999, '\P{^Is_General_Category=mn}', "");
    Expect(0, 918000, '\p{Is_General_Category=mn}', "");
    Expect(1, 918000, '\p{^Is_General_Category=mn}', "");
    Expect(1, 918000, '\P{Is_General_Category=mn}', "");
    Expect(0, 918000, '\P{^Is_General_Category=mn}', "");
    Expect(1, 917999, '\p{Is_General_Category=__Mn}', "");
    Expect(0, 917999, '\p{^Is_General_Category=__Mn}', "");
    Expect(0, 917999, '\P{Is_General_Category=__Mn}', "");
    Expect(1, 917999, '\P{^Is_General_Category=__Mn}', "");
    Expect(0, 918000, '\p{Is_General_Category=__Mn}', "");
    Expect(1, 918000, '\p{^Is_General_Category=__Mn}', "");
    Expect(1, 918000, '\P{Is_General_Category=__Mn}', "");
    Expect(0, 918000, '\P{^Is_General_Category=__Mn}', "");
    Error('\p{Is_Gc=_/a/Nonspacing_Mark}');
    Error('\P{Is_Gc=_/a/Nonspacing_Mark}');
    Expect(1, 917999, '\p{Is_Gc=nonspacingmark}', "");
    Expect(0, 917999, '\p{^Is_Gc=nonspacingmark}', "");
    Expect(0, 917999, '\P{Is_Gc=nonspacingmark}', "");
    Expect(1, 917999, '\P{^Is_Gc=nonspacingmark}', "");
    Expect(0, 918000, '\p{Is_Gc=nonspacingmark}', "");
    Expect(1, 918000, '\p{^Is_Gc=nonspacingmark}', "");
    Expect(1, 918000, '\P{Is_Gc=nonspacingmark}', "");
    Expect(0, 918000, '\P{^Is_Gc=nonspacingmark}', "");
    Expect(1, 917999, '\p{Is_Gc=_NONSPACING_MARK}', "");
    Expect(0, 917999, '\p{^Is_Gc=_NONSPACING_MARK}', "");
    Expect(0, 917999, '\P{Is_Gc=_NONSPACING_MARK}', "");
    Expect(1, 917999, '\P{^Is_Gc=_NONSPACING_MARK}', "");
    Expect(0, 918000, '\p{Is_Gc=_NONSPACING_MARK}', "");
    Expect(1, 918000, '\p{^Is_Gc=_NONSPACING_MARK}', "");
    Expect(1, 918000, '\P{Is_Gc=_NONSPACING_MARK}', "");
    Expect(0, 918000, '\P{^Is_Gc=_NONSPACING_MARK}', "");
    Error('\p{Is_Category=	Mn:=}');
    Error('\P{Is_Category=	Mn:=}');
    Expect(1, 917999, '\p{Is_Category=mn}', "");
    Expect(0, 917999, '\p{^Is_Category=mn}', "");
    Expect(0, 917999, '\P{Is_Category=mn}', "");
    Expect(1, 917999, '\P{^Is_Category=mn}', "");
    Expect(0, 918000, '\p{Is_Category=mn}', "");
    Expect(1, 918000, '\p{^Is_Category=mn}', "");
    Expect(1, 918000, '\P{Is_Category=mn}', "");
    Expect(0, 918000, '\P{^Is_Category=mn}', "");
    Expect(1, 917999, '\p{Is_Category=	 mn}', "");
    Expect(0, 917999, '\p{^Is_Category=	 mn}', "");
    Expect(0, 917999, '\P{Is_Category=	 mn}', "");
    Expect(1, 917999, '\P{^Is_Category=	 mn}', "");
    Expect(0, 918000, '\p{Is_Category=	 mn}', "");
    Expect(1, 918000, '\p{^Is_Category=	 mn}', "");
    Expect(1, 918000, '\P{Is_Category=	 mn}', "");
    Expect(0, 918000, '\P{^Is_Category=	 mn}', "");
    Error('\p{General_Category=:= -Number}');
    Error('\P{General_Category=:= -Number}');
    Expect(1, 130041, '\p{General_Category=:\ANumber\z:}', "");;
    Expect(0, 130042, '\p{General_Category=:\ANumber\z:}', "");;
    Expect(1, 130041, '\p{General_Category=number}', "");
    Expect(0, 130041, '\p{^General_Category=number}', "");
    Expect(0, 130041, '\P{General_Category=number}', "");
    Expect(1, 130041, '\P{^General_Category=number}', "");
    Expect(0, 130042, '\p{General_Category=number}', "");
    Expect(1, 130042, '\p{^General_Category=number}', "");
    Expect(1, 130042, '\P{General_Category=number}', "");
    Expect(0, 130042, '\P{^General_Category=number}', "");
    Expect(1, 130041, '\p{General_Category=:\Anumber\z:}', "");;
    Expect(0, 130042, '\p{General_Category=:\Anumber\z:}', "");;
    Expect(1, 130041, '\p{General_Category=--number}', "");
    Expect(0, 130041, '\p{^General_Category=--number}', "");
    Expect(0, 130041, '\P{General_Category=--number}', "");
    Expect(1, 130041, '\P{^General_Category=--number}', "");
    Expect(0, 130042, '\p{General_Category=--number}', "");
    Expect(1, 130042, '\p{^General_Category=--number}', "");
    Expect(1, 130042, '\P{General_Category=--number}', "");
    Expect(0, 130042, '\P{^General_Category=--number}', "");
    Error('\p{Gc=:=		N}');
    Error('\P{Gc=:=		N}');
    Expect(1, 130041, '\p{Gc=:\AN\z:}', "");;
    Expect(0, 130042, '\p{Gc=:\AN\z:}', "");;
    Expect(1, 130041, '\p{Gc=n}', "");
    Expect(0, 130041, '\p{^Gc=n}', "");
    Expect(0, 130041, '\P{Gc=n}', "");
    Expect(1, 130041, '\P{^Gc=n}', "");
    Expect(0, 130042, '\p{Gc=n}', "");
    Expect(1, 130042, '\p{^Gc=n}', "");
    Expect(1, 130042, '\P{Gc=n}', "");
    Expect(0, 130042, '\P{^Gc=n}', "");
    Expect(1, 130041, '\p{Gc=:\An\z:}', "");;
    Expect(0, 130042, '\p{Gc=:\An\z:}', "");;
    Expect(1, 130041, '\p{Gc= _N}', "");
    Expect(0, 130041, '\p{^Gc= _N}', "");
    Expect(0, 130041, '\P{Gc= _N}', "");
    Expect(1, 130041, '\P{^Gc= _N}', "");
    Expect(0, 130042, '\p{Gc= _N}', "");
    Expect(1, 130042, '\p{^Gc= _N}', "");
    Expect(1, 130042, '\P{Gc= _N}', "");
    Expect(0, 130042, '\P{^Gc= _N}', "");
    Error('\p{Category=:= NUMBER}');
    Error('\P{Category=:= NUMBER}');
    Expect(1, 130041, '\p{Category=:\ANumber\z:}', "");;
    Expect(0, 130042, '\p{Category=:\ANumber\z:}', "");;
    Expect(1, 130041, '\p{Category=number}', "");
    Expect(0, 130041, '\p{^Category=number}', "");
    Expect(0, 130041, '\P{Category=number}', "");
    Expect(1, 130041, '\P{^Category=number}', "");
    Expect(0, 130042, '\p{Category=number}', "");
    Expect(1, 130042, '\p{^Category=number}', "");
    Expect(1, 130042, '\P{Category=number}', "");
    Expect(0, 130042, '\P{^Category=number}', "");
    Expect(1, 130041, '\p{Category=:\Anumber\z:}', "");;
    Expect(0, 130042, '\p{Category=:\Anumber\z:}', "");;
    Expect(1, 130041, '\p{Category:--number}', "");
    Expect(0, 130041, '\p{^Category:--number}', "");
    Expect(0, 130041, '\P{Category:--number}', "");
    Expect(1, 130041, '\P{^Category:--number}', "");
    Expect(0, 130042, '\p{Category:--number}', "");
    Expect(1, 130042, '\p{^Category:--number}', "");
    Expect(1, 130042, '\P{Category:--number}', "");
    Expect(0, 130042, '\P{^Category:--number}', "");
    Error('\p{Is_General_Category=:=	 n}');
    Error('\P{Is_General_Category=:=	 n}');
    Expect(1, 130041, '\p{Is_General_Category=n}', "");
    Expect(0, 130041, '\p{^Is_General_Category=n}', "");
    Expect(0, 130041, '\P{Is_General_Category=n}', "");
    Expect(1, 130041, '\P{^Is_General_Category=n}', "");
    Expect(0, 130042, '\p{Is_General_Category=n}', "");
    Expect(1, 130042, '\p{^Is_General_Category=n}', "");
    Expect(1, 130042, '\P{Is_General_Category=n}', "");
    Expect(0, 130042, '\P{^Is_General_Category=n}', "");
    Expect(1, 130041, '\p{Is_General_Category=	 N}', "");
    Expect(0, 130041, '\p{^Is_General_Category=	 N}', "");
    Expect(0, 130041, '\P{Is_General_Category=	 N}', "");
    Expect(1, 130041, '\P{^Is_General_Category=	 N}', "");
    Expect(0, 130042, '\p{Is_General_Category=	 N}', "");
    Expect(1, 130042, '\p{^Is_General_Category=	 N}', "");
    Expect(1, 130042, '\P{Is_General_Category=	 N}', "");
    Expect(0, 130042, '\P{^Is_General_Category=	 N}', "");
    Error('\p{Is_Gc=/a/	_NUMBER}');
    Error('\P{Is_Gc=/a/	_NUMBER}');
    Expect(1, 130041, '\p{Is_Gc=number}', "");
    Expect(0, 130041, '\p{^Is_Gc=number}', "");
    Expect(0, 130041, '\P{Is_Gc=number}', "");
    Expect(1, 130041, '\P{^Is_Gc=number}', "");
    Expect(0, 130042, '\p{Is_Gc=number}', "");
    Expect(1, 130042, '\p{^Is_Gc=number}', "");
    Expect(1, 130042, '\P{Is_Gc=number}', "");
    Expect(0, 130042, '\P{^Is_Gc=number}', "");
    Expect(1, 130041, '\p{Is_Gc=		NUMBER}', "");
    Expect(0, 130041, '\p{^Is_Gc=		NUMBER}', "");
    Expect(0, 130041, '\P{Is_Gc=		NUMBER}', "");
    Expect(1, 130041, '\P{^Is_Gc=		NUMBER}', "");
    Expect(0, 130042, '\p{Is_Gc=		NUMBER}', "");
    Expect(1, 130042, '\p{^Is_Gc=		NUMBER}', "");
    Expect(1, 130042, '\P{Is_Gc=		NUMBER}', "");
    Expect(0, 130042, '\P{^Is_Gc=		NUMBER}', "");
    Error('\p{Is_Category=	/a/n}');
    Error('\P{Is_Category=	/a/n}');
    Expect(1, 130041, '\p{Is_Category:n}', "");
    Expect(0, 130041, '\p{^Is_Category:n}', "");
    Expect(0, 130041, '\P{Is_Category:n}', "");
    Expect(1, 130041, '\P{^Is_Category:n}', "");
    Expect(0, 130042, '\p{Is_Category:n}', "");
    Expect(1, 130042, '\p{^Is_Category:n}', "");
    Expect(1, 130042, '\P{Is_Category:n}', "");
    Expect(0, 130042, '\P{^Is_Category:n}', "");
    Expect(1, 130041, '\p{Is_Category= n}', "");
    Expect(0, 130041, '\p{^Is_Category= n}', "");
    Expect(0, 130041, '\P{Is_Category= n}', "");
    Expect(1, 130041, '\P{^Is_Category= n}', "");
    Expect(0, 130042, '\p{Is_Category= n}', "");
    Expect(1, 130042, '\p{^Is_Category= n}', "");
    Expect(1, 130042, '\P{Is_Category= n}', "");
    Expect(0, 130042, '\P{^Is_Category= n}', "");
    Error('\p{General_Category=/a/-_Decimal_number}');
    Error('\P{General_Category=/a/-_Decimal_number}');
    Expect(1, 130041, '\p{General_Category=:\ADecimal_Number\z:}', "");;
    Expect(0, 130042, '\p{General_Category=:\ADecimal_Number\z:}', "");;
    Expect(1, 130041, '\p{General_Category=decimalnumber}', "");
    Expect(0, 130041, '\p{^General_Category=decimalnumber}', "");
    Expect(0, 130041, '\P{General_Category=decimalnumber}', "");
    Expect(1, 130041, '\P{^General_Category=decimalnumber}', "");
    Expect(0, 130042, '\p{General_Category=decimalnumber}', "");
    Expect(1, 130042, '\p{^General_Category=decimalnumber}', "");
    Expect(1, 130042, '\P{General_Category=decimalnumber}', "");
    Expect(0, 130042, '\P{^General_Category=decimalnumber}', "");
    Expect(1, 130041, '\p{General_Category=:\Adecimalnumber\z:}', "");;
    Expect(0, 130042, '\p{General_Category=:\Adecimalnumber\z:}', "");;
    Expect(1, 130041, '\p{General_Category=--decimal_Number}', "");
    Expect(0, 130041, '\p{^General_Category=--decimal_Number}', "");
    Expect(0, 130041, '\P{General_Category=--decimal_Number}', "");
    Expect(1, 130041, '\P{^General_Category=--decimal_Number}', "");
    Expect(0, 130042, '\p{General_Category=--decimal_Number}', "");
    Expect(1, 130042, '\p{^General_Category=--decimal_Number}', "");
    Expect(1, 130042, '\P{General_Category=--decimal_Number}', "");
    Expect(0, 130042, '\P{^General_Category=--decimal_Number}', "");
    Error('\p{Gc=/a/- ND}');
    Error('\P{Gc=/a/- ND}');
    Expect(1, 130041, '\p{Gc=:\ANd\z:}', "");;
    Expect(0, 130042, '\p{Gc=:\ANd\z:}', "");;
    Expect(1, 130041, '\p{Gc:   nd}', "");
    Expect(0, 130041, '\p{^Gc:   nd}', "");
    Expect(0, 130041, '\P{Gc:   nd}', "");
    Expect(1, 130041, '\P{^Gc:   nd}', "");
    Expect(0, 130042, '\p{Gc:   nd}', "");
    Expect(1, 130042, '\p{^Gc:   nd}', "");
    Expect(1, 130042, '\P{Gc:   nd}', "");
    Expect(0, 130042, '\P{^Gc:   nd}', "");
    Expect(1, 130041, '\p{Gc=:\And\z:}', "");;
    Expect(0, 130042, '\p{Gc=:\And\z:}', "");;
    Expect(1, 130041, '\p{Gc:  	Nd}', "");
    Expect(0, 130041, '\p{^Gc:  	Nd}', "");
    Expect(0, 130041, '\P{Gc:  	Nd}', "");
    Expect(1, 130041, '\P{^Gc:  	Nd}', "");
    Expect(0, 130042, '\p{Gc:  	Nd}', "");
    Expect(1, 130042, '\p{^Gc:  	Nd}', "");
    Expect(1, 130042, '\P{Gc:  	Nd}', "");
    Expect(0, 130042, '\P{^Gc:  	Nd}', "");
    Error('\p{Category: /a/-DIGIT}');
    Error('\P{Category: /a/-DIGIT}');
    Expect(1, 130041, '\p{Category=:\ADigit\z:}', "");;
    Expect(0, 130042, '\p{Category=:\ADigit\z:}', "");;
    Expect(1, 130041, '\p{Category=digit}', "");
    Expect(0, 130041, '\p{^Category=digit}', "");
    Expect(0, 130041, '\P{Category=digit}', "");
    Expect(1, 130041, '\P{^Category=digit}', "");
    Expect(0, 130042, '\p{Category=digit}', "");
    Expect(1, 130042, '\p{^Category=digit}', "");
    Expect(1, 130042, '\P{Category=digit}', "");
    Expect(0, 130042, '\P{^Category=digit}', "");
    Expect(1, 130041, '\p{Category=:\Adigit\z:}', "");;
    Expect(0, 130042, '\p{Category=:\Adigit\z:}', "");;
    Expect(1, 130041, '\p{Category= Digit}', "");
    Expect(0, 130041, '\p{^Category= Digit}', "");
    Expect(0, 130041, '\P{Category= Digit}', "");
    Expect(1, 130041, '\P{^Category= Digit}', "");
    Expect(0, 130042, '\p{Category= Digit}', "");
    Expect(1, 130042, '\p{^Category= Digit}', "");
    Expect(1, 130042, '\P{Category= Digit}', "");
    Expect(0, 130042, '\P{^Category= Digit}', "");
    Error('\p{Is_General_Category=-:=Decimal_Number}');
    Error('\P{Is_General_Category=-:=Decimal_Number}');
    Expect(1, 130041, '\p{Is_General_Category=decimalnumber}', "");
    Expect(0, 130041, '\p{^Is_General_Category=decimalnumber}', "");
    Expect(0, 130041, '\P{Is_General_Category=decimalnumber}', "");
    Expect(1, 130041, '\P{^Is_General_Category=decimalnumber}', "");
    Expect(0, 130042, '\p{Is_General_Category=decimalnumber}', "");
    Expect(1, 130042, '\p{^Is_General_Category=decimalnumber}', "");
    Expect(1, 130042, '\P{Is_General_Category=decimalnumber}', "");
    Expect(0, 130042, '\P{^Is_General_Category=decimalnumber}', "");
    Expect(1, 130041, '\p{Is_General_Category=-	decimal_number}', "");
    Expect(0, 130041, '\p{^Is_General_Category=-	decimal_number}', "");
    Expect(0, 130041, '\P{Is_General_Category=-	decimal_number}', "");
    Expect(1, 130041, '\P{^Is_General_Category=-	decimal_number}', "");
    Expect(0, 130042, '\p{Is_General_Category=-	decimal_number}', "");
    Expect(1, 130042, '\p{^Is_General_Category=-	decimal_number}', "");
    Expect(1, 130042, '\P{Is_General_Category=-	decimal_number}', "");
    Expect(0, 130042, '\P{^Is_General_Category=-	decimal_number}', "");
    Error('\p{Is_Gc=	-Nd:=}');
    Error('\P{Is_Gc=	-Nd:=}');
    Expect(1, 130041, '\p{Is_Gc=nd}', "");
    Expect(0, 130041, '\p{^Is_Gc=nd}', "");
    Expect(0, 130041, '\P{Is_Gc=nd}', "");
    Expect(1, 130041, '\P{^Is_Gc=nd}', "");
    Expect(0, 130042, '\p{Is_Gc=nd}', "");
    Expect(1, 130042, '\p{^Is_Gc=nd}', "");
    Expect(1, 130042, '\P{Is_Gc=nd}', "");
    Expect(0, 130042, '\P{^Is_Gc=nd}', "");
    Expect(1, 130041, '\p{Is_Gc=	_nd}', "");
    Expect(0, 130041, '\p{^Is_Gc=	_nd}', "");
    Expect(0, 130041, '\P{Is_Gc=	_nd}', "");
    Expect(1, 130041, '\P{^Is_Gc=	_nd}', "");
    Expect(0, 130042, '\p{Is_Gc=	_nd}', "");
    Expect(1, 130042, '\p{^Is_Gc=	_nd}', "");
    Expect(1, 130042, '\P{Is_Gc=	_nd}', "");
    Expect(0, 130042, '\P{^Is_Gc=	_nd}', "");
    Error('\p{Is_Category=- Digit/a/}');
    Error('\P{Is_Category=- Digit/a/}');
    Expect(1, 130041, '\p{Is_Category:digit}', "");
    Expect(0, 130041, '\p{^Is_Category:digit}', "");
    Expect(0, 130041, '\P{Is_Category:digit}', "");
    Expect(1, 130041, '\P{^Is_Category:digit}', "");
    Expect(0, 130042, '\p{Is_Category:digit}', "");
    Expect(1, 130042, '\p{^Is_Category:digit}', "");
    Expect(1, 130042, '\P{Is_Category:digit}', "");
    Expect(0, 130042, '\P{^Is_Category:digit}', "");
    Expect(1, 130041, '\p{Is_Category=-Digit}', "");
    Expect(0, 130041, '\p{^Is_Category=-Digit}', "");
    Expect(0, 130041, '\P{Is_Category=-Digit}', "");
    Expect(1, 130041, '\P{^Is_Category=-Digit}', "");
    Expect(0, 130042, '\p{Is_Category=-Digit}', "");
    Expect(1, 130042, '\p{^Is_Category=-Digit}', "");
    Expect(1, 130042, '\P{Is_Category=-Digit}', "");
    Expect(0, 130042, '\P{^Is_Category=-Digit}', "");
    Error('\p{General_Category=--Letter_Number/a/}');
    Error('\P{General_Category=--Letter_Number/a/}');
    Expect(1, 74862, '\p{General_Category=:\ALetter_Number\z:}', "");;
    Expect(0, 74863, '\p{General_Category=:\ALetter_Number\z:}', "");;
    Expect(1, 74862, '\p{General_Category=letternumber}', "");
    Expect(0, 74862, '\p{^General_Category=letternumber}', "");
    Expect(0, 74862, '\P{General_Category=letternumber}', "");
    Expect(1, 74862, '\P{^General_Category=letternumber}', "");
    Expect(0, 74863, '\p{General_Category=letternumber}', "");
    Expect(1, 74863, '\p{^General_Category=letternumber}', "");
    Expect(1, 74863, '\P{General_Category=letternumber}', "");
    Expect(0, 74863, '\P{^General_Category=letternumber}', "");
    Expect(1, 74862, '\p{General_Category=:\Aletternumber\z:}', "");;
    Expect(0, 74863, '\p{General_Category=:\Aletternumber\z:}', "");;
    Expect(1, 74862, '\p{General_Category= LETTER_Number}', "");
    Expect(0, 74862, '\p{^General_Category= LETTER_Number}', "");
    Expect(0, 74862, '\P{General_Category= LETTER_Number}', "");
    Expect(1, 74862, '\P{^General_Category= LETTER_Number}', "");
    Expect(0, 74863, '\p{General_Category= LETTER_Number}', "");
    Expect(1, 74863, '\p{^General_Category= LETTER_Number}', "");
    Expect(1, 74863, '\P{General_Category= LETTER_Number}', "");
    Expect(0, 74863, '\P{^General_Category= LETTER_Number}', "");
    Error('\p{Gc=:= Nl}');
    Error('\P{Gc=:= Nl}');
    Expect(1, 74862, '\p{Gc=:\ANl\z:}', "");;
    Expect(0, 74863, '\p{Gc=:\ANl\z:}', "");;
    Expect(1, 74862, '\p{Gc=nl}', "");
    Expect(0, 74862, '\p{^Gc=nl}', "");
    Expect(0, 74862, '\P{Gc=nl}', "");
    Expect(1, 74862, '\P{^Gc=nl}', "");
    Expect(0, 74863, '\p{Gc=nl}', "");
    Expect(1, 74863, '\p{^Gc=nl}', "");
    Expect(1, 74863, '\P{Gc=nl}', "");
    Expect(0, 74863, '\P{^Gc=nl}', "");
    Expect(1, 74862, '\p{Gc=:\Anl\z:}', "");;
    Expect(0, 74863, '\p{Gc=:\Anl\z:}', "");;
    Expect(1, 74862, '\p{Gc= _nl}', "");
    Expect(0, 74862, '\p{^Gc= _nl}', "");
    Expect(0, 74862, '\P{Gc= _nl}', "");
    Expect(1, 74862, '\P{^Gc= _nl}', "");
    Expect(0, 74863, '\p{Gc= _nl}', "");
    Expect(1, 74863, '\p{^Gc= _nl}', "");
    Expect(1, 74863, '\P{Gc= _nl}', "");
    Expect(0, 74863, '\P{^Gc= _nl}', "");
    Error('\p{Category=:=Letter_Number}');
    Error('\P{Category=:=Letter_Number}');
    Expect(1, 74862, '\p{Category=:\ALetter_Number\z:}', "");;
    Expect(0, 74863, '\p{Category=:\ALetter_Number\z:}', "");;
    Expect(1, 74862, '\p{Category=letternumber}', "");
    Expect(0, 74862, '\p{^Category=letternumber}', "");
    Expect(0, 74862, '\P{Category=letternumber}', "");
    Expect(1, 74862, '\P{^Category=letternumber}', "");
    Expect(0, 74863, '\p{Category=letternumber}', "");
    Expect(1, 74863, '\p{^Category=letternumber}', "");
    Expect(1, 74863, '\P{Category=letternumber}', "");
    Expect(0, 74863, '\P{^Category=letternumber}', "");
    Expect(1, 74862, '\p{Category=:\Aletternumber\z:}', "");;
    Expect(0, 74863, '\p{Category=:\Aletternumber\z:}', "");;
    Expect(1, 74862, '\p{Category=_LETTER_Number}', "");
    Expect(0, 74862, '\p{^Category=_LETTER_Number}', "");
    Expect(0, 74862, '\P{Category=_LETTER_Number}', "");
    Expect(1, 74862, '\P{^Category=_LETTER_Number}', "");
    Expect(0, 74863, '\p{Category=_LETTER_Number}', "");
    Expect(1, 74863, '\p{^Category=_LETTER_Number}', "");
    Expect(1, 74863, '\P{Category=_LETTER_Number}', "");
    Expect(0, 74863, '\P{^Category=_LETTER_Number}', "");
    Error('\p{Is_General_Category=/a/NL}');
    Error('\P{Is_General_Category=/a/NL}');
    Expect(1, 74862, '\p{Is_General_Category=nl}', "");
    Expect(0, 74862, '\p{^Is_General_Category=nl}', "");
    Expect(0, 74862, '\P{Is_General_Category=nl}', "");
    Expect(1, 74862, '\P{^Is_General_Category=nl}', "");
    Expect(0, 74863, '\p{Is_General_Category=nl}', "");
    Expect(1, 74863, '\p{^Is_General_Category=nl}', "");
    Expect(1, 74863, '\P{Is_General_Category=nl}', "");
    Expect(0, 74863, '\P{^Is_General_Category=nl}', "");
    Expect(1, 74862, '\p{Is_General_Category=  Nl}', "");
    Expect(0, 74862, '\p{^Is_General_Category=  Nl}', "");
    Expect(0, 74862, '\P{Is_General_Category=  Nl}', "");
    Expect(1, 74862, '\P{^Is_General_Category=  Nl}', "");
    Expect(0, 74863, '\p{Is_General_Category=  Nl}', "");
    Expect(1, 74863, '\p{^Is_General_Category=  Nl}', "");
    Expect(1, 74863, '\P{Is_General_Category=  Nl}', "");
    Expect(0, 74863, '\P{^Is_General_Category=  Nl}', "");
    Error('\p{Is_Gc=	Letter_Number/a/}');
    Error('\P{Is_Gc=	Letter_Number/a/}');
    Expect(1, 74862, '\p{Is_Gc=letternumber}', "");
    Expect(0, 74862, '\p{^Is_Gc=letternumber}', "");
    Expect(0, 74862, '\P{Is_Gc=letternumber}', "");
    Expect(1, 74862, '\P{^Is_Gc=letternumber}', "");
    Expect(0, 74863, '\p{Is_Gc=letternumber}', "");
    Expect(1, 74863, '\p{^Is_Gc=letternumber}', "");
    Expect(1, 74863, '\P{Is_Gc=letternumber}', "");
    Expect(0, 74863, '\P{^Is_Gc=letternumber}', "");
    Expect(1, 74862, '\p{Is_Gc:	--Letter_number}', "");
    Expect(0, 74862, '\p{^Is_Gc:	--Letter_number}', "");
    Expect(0, 74862, '\P{Is_Gc:	--Letter_number}', "");
    Expect(1, 74862, '\P{^Is_Gc:	--Letter_number}', "");
    Expect(0, 74863, '\p{Is_Gc:	--Letter_number}', "");
    Expect(1, 74863, '\p{^Is_Gc:	--Letter_number}', "");
    Expect(1, 74863, '\P{Is_Gc:	--Letter_number}', "");
    Expect(0, 74863, '\P{^Is_Gc:	--Letter_number}', "");
    Error('\p{Is_Category=/a/		nl}');
    Error('\P{Is_Category=/a/		nl}');
    Expect(1, 74862, '\p{Is_Category=nl}', "");
    Expect(0, 74862, '\p{^Is_Category=nl}', "");
    Expect(0, 74862, '\P{Is_Category=nl}', "");
    Expect(1, 74862, '\P{^Is_Category=nl}', "");
    Expect(0, 74863, '\p{Is_Category=nl}', "");
    Expect(1, 74863, '\p{^Is_Category=nl}', "");
    Expect(1, 74863, '\P{Is_Category=nl}', "");
    Expect(0, 74863, '\P{^Is_Category=nl}', "");
    Expect(1, 74862, '\p{Is_Category=  NL}', "");
    Expect(0, 74862, '\p{^Is_Category=  NL}', "");
    Expect(0, 74862, '\P{Is_Category=  NL}', "");
    Expect(1, 74862, '\P{^Is_Category=  NL}', "");
    Expect(0, 74863, '\p{Is_Category=  NL}', "");
    Expect(1, 74863, '\p{^Is_Category=  NL}', "");
    Expect(1, 74863, '\P{Is_Category=  NL}', "");
    Expect(0, 74863, '\P{^Is_Category=  NL}', "");
    Error('\p{General_Category= Other_Number:=}');
    Error('\P{General_Category= Other_Number:=}');
    Expect(1, 127244, '\p{General_Category=:\AOther_Number\z:}', "");;
    Expect(0, 127245, '\p{General_Category=:\AOther_Number\z:}', "");;
    Expect(1, 127244, '\p{General_Category:   othernumber}', "");
    Expect(0, 127244, '\p{^General_Category:   othernumber}', "");
    Expect(0, 127244, '\P{General_Category:   othernumber}', "");
    Expect(1, 127244, '\P{^General_Category:   othernumber}', "");
    Expect(0, 127245, '\p{General_Category:   othernumber}', "");
    Expect(1, 127245, '\p{^General_Category:   othernumber}', "");
    Expect(1, 127245, '\P{General_Category:   othernumber}', "");
    Expect(0, 127245, '\P{^General_Category:   othernumber}', "");
    Expect(1, 127244, '\p{General_Category=:\Aothernumber\z:}', "");;
    Expect(0, 127245, '\p{General_Category=:\Aothernumber\z:}', "");;
    Expect(1, 127244, '\p{General_Category=  Other_number}', "");
    Expect(0, 127244, '\p{^General_Category=  Other_number}', "");
    Expect(0, 127244, '\P{General_Category=  Other_number}', "");
    Expect(1, 127244, '\P{^General_Category=  Other_number}', "");
    Expect(0, 127245, '\p{General_Category=  Other_number}', "");
    Expect(1, 127245, '\p{^General_Category=  Other_number}', "");
    Expect(1, 127245, '\P{General_Category=  Other_number}', "");
    Expect(0, 127245, '\P{^General_Category=  Other_number}', "");
    Error('\p{Gc=:=	 No}');
    Error('\P{Gc=:=	 No}');
    Expect(1, 127244, '\p{Gc=:\ANo\z:}', "");;
    Expect(0, 127245, '\p{Gc=:\ANo\z:}', "");;
    Expect(1, 127244, '\p{Gc: no}', "");
    Expect(0, 127244, '\p{^Gc: no}', "");
    Expect(0, 127244, '\P{Gc: no}', "");
    Expect(1, 127244, '\P{^Gc: no}', "");
    Expect(0, 127245, '\p{Gc: no}', "");
    Expect(1, 127245, '\p{^Gc: no}', "");
    Expect(1, 127245, '\P{Gc: no}', "");
    Expect(0, 127245, '\P{^Gc: no}', "");
    Expect(1, 127244, '\p{Gc=:\Ano\z:}', "");;
    Expect(0, 127245, '\p{Gc=:\Ano\z:}', "");;
    Expect(1, 127244, '\p{Gc=-NO}', "");
    Expect(0, 127244, '\p{^Gc=-NO}', "");
    Expect(0, 127244, '\P{Gc=-NO}', "");
    Expect(1, 127244, '\P{^Gc=-NO}', "");
    Expect(0, 127245, '\p{Gc=-NO}', "");
    Expect(1, 127245, '\p{^Gc=-NO}', "");
    Expect(1, 127245, '\P{Gc=-NO}', "");
    Expect(0, 127245, '\P{^Gc=-NO}', "");
    Error('\p{Category=:=- other_Number}');
    Error('\P{Category=:=- other_Number}');
    Expect(1, 127244, '\p{Category=:\AOther_Number\z:}', "");;
    Expect(0, 127245, '\p{Category=:\AOther_Number\z:}', "");;
    Expect(1, 127244, '\p{Category:othernumber}', "");
    Expect(0, 127244, '\p{^Category:othernumber}', "");
    Expect(0, 127244, '\P{Category:othernumber}', "");
    Expect(1, 127244, '\P{^Category:othernumber}', "");
    Expect(0, 127245, '\p{Category:othernumber}', "");
    Expect(1, 127245, '\p{^Category:othernumber}', "");
    Expect(1, 127245, '\P{Category:othernumber}', "");
    Expect(0, 127245, '\P{^Category:othernumber}', "");
    Expect(1, 127244, '\p{Category=:\Aothernumber\z:}', "");;
    Expect(0, 127245, '\p{Category=:\Aothernumber\z:}', "");;
    Expect(1, 127244, '\p{Category:	Other_number}', "");
    Expect(0, 127244, '\p{^Category:	Other_number}', "");
    Expect(0, 127244, '\P{Category:	Other_number}', "");
    Expect(1, 127244, '\P{^Category:	Other_number}', "");
    Expect(0, 127245, '\p{Category:	Other_number}', "");
    Expect(1, 127245, '\p{^Category:	Other_number}', "");
    Expect(1, 127245, '\P{Category:	Other_number}', "");
    Expect(0, 127245, '\P{^Category:	Other_number}', "");
    Error('\p{Is_General_Category=	-No/a/}');
    Error('\P{Is_General_Category=	-No/a/}');
    Expect(1, 127244, '\p{Is_General_Category=no}', "");
    Expect(0, 127244, '\p{^Is_General_Category=no}', "");
    Expect(0, 127244, '\P{Is_General_Category=no}', "");
    Expect(1, 127244, '\P{^Is_General_Category=no}', "");
    Expect(0, 127245, '\p{Is_General_Category=no}', "");
    Expect(1, 127245, '\p{^Is_General_Category=no}', "");
    Expect(1, 127245, '\P{Is_General_Category=no}', "");
    Expect(0, 127245, '\P{^Is_General_Category=no}', "");
    Expect(1, 127244, '\p{Is_General_Category=-	no}', "");
    Expect(0, 127244, '\p{^Is_General_Category=-	no}', "");
    Expect(0, 127244, '\P{Is_General_Category=-	no}', "");
    Expect(1, 127244, '\P{^Is_General_Category=-	no}', "");
    Expect(0, 127245, '\p{Is_General_Category=-	no}', "");
    Expect(1, 127245, '\p{^Is_General_Category=-	no}', "");
    Expect(1, 127245, '\P{Is_General_Category=-	no}', "");
    Expect(0, 127245, '\P{^Is_General_Category=-	no}', "");
    Error('\p{Is_Gc=_	OTHER_Number:=}');
    Error('\P{Is_Gc=_	OTHER_Number:=}');
    Expect(1, 127244, '\p{Is_Gc=othernumber}', "");
    Expect(0, 127244, '\p{^Is_Gc=othernumber}', "");
    Expect(0, 127244, '\P{Is_Gc=othernumber}', "");
    Expect(1, 127244, '\P{^Is_Gc=othernumber}', "");
    Expect(0, 127245, '\p{Is_Gc=othernumber}', "");
    Expect(1, 127245, '\p{^Is_Gc=othernumber}', "");
    Expect(1, 127245, '\P{Is_Gc=othernumber}', "");
    Expect(0, 127245, '\P{^Is_Gc=othernumber}', "");
    Expect(1, 127244, '\p{Is_Gc=  OTHER_Number}', "");
    Expect(0, 127244, '\p{^Is_Gc=  OTHER_Number}', "");
    Expect(0, 127244, '\P{Is_Gc=  OTHER_Number}', "");
    Expect(1, 127244, '\P{^Is_Gc=  OTHER_Number}', "");
    Expect(0, 127245, '\p{Is_Gc=  OTHER_Number}', "");
    Expect(1, 127245, '\p{^Is_Gc=  OTHER_Number}', "");
    Expect(1, 127245, '\P{Is_Gc=  OTHER_Number}', "");
    Expect(0, 127245, '\P{^Is_Gc=  OTHER_Number}', "");
    Error('\p{Is_Category=:=	no}');
    Error('\P{Is_Category=:=	no}');
    Expect(1, 127244, '\p{Is_Category:	no}', "");
    Expect(0, 127244, '\p{^Is_Category:	no}', "");
    Expect(0, 127244, '\P{Is_Category:	no}', "");
    Expect(1, 127244, '\P{^Is_Category:	no}', "");
    Expect(0, 127245, '\p{Is_Category:	no}', "");
    Expect(1, 127245, '\p{^Is_Category:	no}', "");
    Expect(1, 127245, '\P{Is_Category:	no}', "");
    Expect(0, 127245, '\P{^Is_Category:	no}', "");
    Expect(1, 127244, '\p{Is_Category=_no}', "");
    Expect(0, 127244, '\p{^Is_Category=_no}', "");
    Expect(0, 127244, '\P{Is_Category=_no}', "");
    Expect(1, 127244, '\P{^Is_Category=_no}', "");
    Expect(0, 127245, '\p{Is_Category=_no}', "");
    Expect(1, 127245, '\p{^Is_Category=_no}', "");
    Expect(1, 127245, '\P{Is_Category=_no}', "");
    Expect(0, 127245, '\P{^Is_Category=_no}', "");
    Error('\p{General_Category=-/a/Punctuation}');
    Error('\P{General_Category=-/a/Punctuation}');
    Expect(1, 125279, '\p{General_Category=:\APunctuation\z:}', "");;
    Expect(0, 125280, '\p{General_Category=:\APunctuation\z:}', "");;
    Expect(1, 125279, '\p{General_Category=punctuation}', "");
    Expect(0, 125279, '\p{^General_Category=punctuation}', "");
    Expect(0, 125279, '\P{General_Category=punctuation}', "");
    Expect(1, 125279, '\P{^General_Category=punctuation}', "");
    Expect(0, 125280, '\p{General_Category=punctuation}', "");
    Expect(1, 125280, '\p{^General_Category=punctuation}', "");
    Expect(1, 125280, '\P{General_Category=punctuation}', "");
    Expect(0, 125280, '\P{^General_Category=punctuation}', "");
    Expect(1, 125279, '\p{General_Category=:\Apunctuation\z:}', "");;
    Expect(0, 125280, '\p{General_Category=:\Apunctuation\z:}', "");;
    Expect(1, 125279, '\p{General_Category=-Punctuation}', "");
    Expect(0, 125279, '\p{^General_Category=-Punctuation}', "");
    Expect(0, 125279, '\P{General_Category=-Punctuation}', "");
    Expect(1, 125279, '\P{^General_Category=-Punctuation}', "");
    Expect(0, 125280, '\p{General_Category=-Punctuation}', "");
    Expect(1, 125280, '\p{^General_Category=-Punctuation}', "");
    Expect(1, 125280, '\P{General_Category=-Punctuation}', "");
    Expect(0, 125280, '\P{^General_Category=-Punctuation}', "");
    Error('\p{Gc=:=_-P}');
    Error('\P{Gc=:=_-P}');
    Expect(1, 125279, '\p{Gc=:\AP\z:}', "");;
    Expect(0, 125280, '\p{Gc=:\AP\z:}', "");;
    Expect(1, 125279, '\p{Gc=p}', "");
    Expect(0, 125279, '\p{^Gc=p}', "");
    Expect(0, 125279, '\P{Gc=p}', "");
    Expect(1, 125279, '\P{^Gc=p}', "");
    Expect(0, 125280, '\p{Gc=p}', "");
    Expect(1, 125280, '\p{^Gc=p}', "");
    Expect(1, 125280, '\P{Gc=p}', "");
    Expect(0, 125280, '\P{^Gc=p}', "");
    Expect(1, 125279, '\p{Gc=:\Ap\z:}', "");;
    Expect(0, 125280, '\p{Gc=:\Ap\z:}', "");;
    Expect(1, 125279, '\p{Gc=_ P}', "");
    Expect(0, 125279, '\p{^Gc=_ P}', "");
    Expect(0, 125279, '\P{Gc=_ P}', "");
    Expect(1, 125279, '\P{^Gc=_ P}', "");
    Expect(0, 125280, '\p{Gc=_ P}', "");
    Expect(1, 125280, '\p{^Gc=_ P}', "");
    Expect(1, 125280, '\P{Gc=_ P}', "");
    Expect(0, 125280, '\P{^Gc=_ P}', "");
    Error('\p{Category=	/a/PUNCT}');
    Error('\P{Category=	/a/PUNCT}');
    Expect(1, 125279, '\p{Category=:\APunct\z:}', "");;
    Expect(0, 125280, '\p{Category=:\APunct\z:}', "");;
    Expect(1, 125279, '\p{Category=punct}', "");
    Expect(0, 125279, '\p{^Category=punct}', "");
    Expect(0, 125279, '\P{Category=punct}', "");
    Expect(1, 125279, '\P{^Category=punct}', "");
    Expect(0, 125280, '\p{Category=punct}', "");
    Expect(1, 125280, '\p{^Category=punct}', "");
    Expect(1, 125280, '\P{Category=punct}', "");
    Expect(0, 125280, '\P{^Category=punct}', "");
    Expect(1, 125279, '\p{Category=:\Apunct\z:}', "");;
    Expect(0, 125280, '\p{Category=:\Apunct\z:}', "");;
    Expect(1, 125279, '\p{Category= punct}', "");
    Expect(0, 125279, '\p{^Category= punct}', "");
    Expect(0, 125279, '\P{Category= punct}', "");
    Expect(1, 125279, '\P{^Category= punct}', "");
    Expect(0, 125280, '\p{Category= punct}', "");
    Expect(1, 125280, '\p{^Category= punct}', "");
    Expect(1, 125280, '\P{Category= punct}', "");
    Expect(0, 125280, '\P{^Category= punct}', "");
    Error('\p{Is_General_Category=/a/	 Punctuation}');
    Error('\P{Is_General_Category=/a/	 Punctuation}');
    Expect(1, 125279, '\p{Is_General_Category=punctuation}', "");
    Expect(0, 125279, '\p{^Is_General_Category=punctuation}', "");
    Expect(0, 125279, '\P{Is_General_Category=punctuation}', "");
    Expect(1, 125279, '\P{^Is_General_Category=punctuation}', "");
    Expect(0, 125280, '\p{Is_General_Category=punctuation}', "");
    Expect(1, 125280, '\p{^Is_General_Category=punctuation}', "");
    Expect(1, 125280, '\P{Is_General_Category=punctuation}', "");
    Expect(0, 125280, '\P{^Is_General_Category=punctuation}', "");
    Expect(1, 125279, '\p{Is_General_Category=Punctuation}', "");
    Expect(0, 125279, '\p{^Is_General_Category=Punctuation}', "");
    Expect(0, 125279, '\P{Is_General_Category=Punctuation}', "");
    Expect(1, 125279, '\P{^Is_General_Category=Punctuation}', "");
    Expect(0, 125280, '\p{Is_General_Category=Punctuation}', "");
    Expect(1, 125280, '\p{^Is_General_Category=Punctuation}', "");
    Expect(1, 125280, '\P{Is_General_Category=Punctuation}', "");
    Expect(0, 125280, '\P{^Is_General_Category=Punctuation}', "");
    Error('\p{Is_Gc=:=	 P}');
    Error('\P{Is_Gc=:=	 P}');
    Expect(1, 125279, '\p{Is_Gc=p}', "");
    Expect(0, 125279, '\p{^Is_Gc=p}', "");
    Expect(0, 125279, '\P{Is_Gc=p}', "");
    Expect(1, 125279, '\P{^Is_Gc=p}', "");
    Expect(0, 125280, '\p{Is_Gc=p}', "");
    Expect(1, 125280, '\p{^Is_Gc=p}', "");
    Expect(1, 125280, '\P{Is_Gc=p}', "");
    Expect(0, 125280, '\P{^Is_Gc=p}', "");
    Expect(1, 125279, '\p{Is_Gc=_P}', "");
    Expect(0, 125279, '\p{^Is_Gc=_P}', "");
    Expect(0, 125279, '\P{Is_Gc=_P}', "");
    Expect(1, 125279, '\P{^Is_Gc=_P}', "");
    Expect(0, 125280, '\p{Is_Gc=_P}', "");
    Expect(1, 125280, '\p{^Is_Gc=_P}', "");
    Expect(1, 125280, '\P{Is_Gc=_P}', "");
    Expect(0, 125280, '\P{^Is_Gc=_P}', "");
    Error('\p{Is_Category= /a/PUNCT}');
    Error('\P{Is_Category= /a/PUNCT}');
    Expect(1, 125279, '\p{Is_Category: punct}', "");
    Expect(0, 125279, '\p{^Is_Category: punct}', "");
    Expect(0, 125279, '\P{Is_Category: punct}', "");
    Expect(1, 125279, '\P{^Is_Category: punct}', "");
    Expect(0, 125280, '\p{Is_Category: punct}', "");
    Expect(1, 125280, '\p{^Is_Category: punct}', "");
    Expect(1, 125280, '\P{Is_Category: punct}', "");
    Expect(0, 125280, '\P{^Is_Category: punct}', "");
    Expect(1, 125279, '\p{Is_Category=-Punct}', "");
    Expect(0, 125279, '\p{^Is_Category=-Punct}', "");
    Expect(0, 125279, '\P{Is_Category=-Punct}', "");
    Expect(1, 125279, '\P{^Is_Category=-Punct}', "");
    Expect(0, 125280, '\p{Is_Category=-Punct}', "");
    Expect(1, 125280, '\p{^Is_Category=-Punct}', "");
    Expect(1, 125280, '\P{Is_Category=-Punct}', "");
    Expect(0, 125280, '\P{^Is_Category=-Punct}', "");
    Error('\p{General_Category=	-Connector_Punctuation:=}');
    Error('\P{General_Category=	-Connector_Punctuation:=}');
    Expect(1, 65343, '\p{General_Category=:\AConnector_Punctuation\z:}', "");;
    Expect(0, 65344, '\p{General_Category=:\AConnector_Punctuation\z:}', "");;
    Expect(1, 65343, '\p{General_Category=connectorpunctuation}', "");
    Expect(0, 65343, '\p{^General_Category=connectorpunctuation}', "");
    Expect(0, 65343, '\P{General_Category=connectorpunctuation}', "");
    Expect(1, 65343, '\P{^General_Category=connectorpunctuation}', "");
    Expect(0, 65344, '\p{General_Category=connectorpunctuation}', "");
    Expect(1, 65344, '\p{^General_Category=connectorpunctuation}', "");
    Expect(1, 65344, '\P{General_Category=connectorpunctuation}', "");
    Expect(0, 65344, '\P{^General_Category=connectorpunctuation}', "");
    Expect(1, 65343, '\p{General_Category=:\Aconnectorpunctuation\z:}', "");;
    Expect(0, 65344, '\p{General_Category=:\Aconnectorpunctuation\z:}', "");;
    Expect(1, 65343, '\p{General_Category=	-CONNECTOR_Punctuation}', "");
    Expect(0, 65343, '\p{^General_Category=	-CONNECTOR_Punctuation}', "");
    Expect(0, 65343, '\P{General_Category=	-CONNECTOR_Punctuation}', "");
    Expect(1, 65343, '\P{^General_Category=	-CONNECTOR_Punctuation}', "");
    Expect(0, 65344, '\p{General_Category=	-CONNECTOR_Punctuation}', "");
    Expect(1, 65344, '\p{^General_Category=	-CONNECTOR_Punctuation}', "");
    Expect(1, 65344, '\P{General_Category=	-CONNECTOR_Punctuation}', "");
    Expect(0, 65344, '\P{^General_Category=	-CONNECTOR_Punctuation}', "");
    Error('\p{Gc= :=Pc}');
    Error('\P{Gc= :=Pc}');
    Expect(1, 65343, '\p{Gc=:\APc\z:}', "");;
    Expect(0, 65344, '\p{Gc=:\APc\z:}', "");;
    Expect(1, 65343, '\p{Gc=pc}', "");
    Expect(0, 65343, '\p{^Gc=pc}', "");
    Expect(0, 65343, '\P{Gc=pc}', "");
    Expect(1, 65343, '\P{^Gc=pc}', "");
    Expect(0, 65344, '\p{Gc=pc}', "");
    Expect(1, 65344, '\p{^Gc=pc}', "");
    Expect(1, 65344, '\P{Gc=pc}', "");
    Expect(0, 65344, '\P{^Gc=pc}', "");
    Expect(1, 65343, '\p{Gc=:\Apc\z:}', "");;
    Expect(0, 65344, '\p{Gc=:\Apc\z:}', "");;
    Expect(1, 65343, '\p{Gc=		Pc}', "");
    Expect(0, 65343, '\p{^Gc=		Pc}', "");
    Expect(0, 65343, '\P{Gc=		Pc}', "");
    Expect(1, 65343, '\P{^Gc=		Pc}', "");
    Expect(0, 65344, '\p{Gc=		Pc}', "");
    Expect(1, 65344, '\p{^Gc=		Pc}', "");
    Expect(1, 65344, '\P{Gc=		Pc}', "");
    Expect(0, 65344, '\P{^Gc=		Pc}', "");
    Error('\p{Category=-	CONNECTOR_Punctuation/a/}');
    Error('\P{Category=-	CONNECTOR_Punctuation/a/}');
    Expect(1, 65343, '\p{Category=:\AConnector_Punctuation\z:}', "");;
    Expect(0, 65344, '\p{Category=:\AConnector_Punctuation\z:}', "");;
    Expect(1, 65343, '\p{Category:connectorpunctuation}', "");
    Expect(0, 65343, '\p{^Category:connectorpunctuation}', "");
    Expect(0, 65343, '\P{Category:connectorpunctuation}', "");
    Expect(1, 65343, '\P{^Category:connectorpunctuation}', "");
    Expect(0, 65344, '\p{Category:connectorpunctuation}', "");
    Expect(1, 65344, '\p{^Category:connectorpunctuation}', "");
    Expect(1, 65344, '\P{Category:connectorpunctuation}', "");
    Expect(0, 65344, '\P{^Category:connectorpunctuation}', "");
    Expect(1, 65343, '\p{Category=:\Aconnectorpunctuation\z:}', "");;
    Expect(0, 65344, '\p{Category=:\Aconnectorpunctuation\z:}', "");;
    Expect(1, 65343, '\p{Category=	-Connector_Punctuation}', "");
    Expect(0, 65343, '\p{^Category=	-Connector_Punctuation}', "");
    Expect(0, 65343, '\P{Category=	-Connector_Punctuation}', "");
    Expect(1, 65343, '\P{^Category=	-Connector_Punctuation}', "");
    Expect(0, 65344, '\p{Category=	-Connector_Punctuation}', "");
    Expect(1, 65344, '\p{^Category=	-Connector_Punctuation}', "");
    Expect(1, 65344, '\P{Category=	-Connector_Punctuation}', "");
    Expect(0, 65344, '\P{^Category=	-Connector_Punctuation}', "");
    Error('\p{Is_General_Category= :=Pc}');
    Error('\P{Is_General_Category= :=Pc}');
    Expect(1, 65343, '\p{Is_General_Category=pc}', "");
    Expect(0, 65343, '\p{^Is_General_Category=pc}', "");
    Expect(0, 65343, '\P{Is_General_Category=pc}', "");
    Expect(1, 65343, '\P{^Is_General_Category=pc}', "");
    Expect(0, 65344, '\p{Is_General_Category=pc}', "");
    Expect(1, 65344, '\p{^Is_General_Category=pc}', "");
    Expect(1, 65344, '\P{Is_General_Category=pc}', "");
    Expect(0, 65344, '\P{^Is_General_Category=pc}', "");
    Expect(1, 65343, '\p{Is_General_Category=_	Pc}', "");
    Expect(0, 65343, '\p{^Is_General_Category=_	Pc}', "");
    Expect(0, 65343, '\P{Is_General_Category=_	Pc}', "");
    Expect(1, 65343, '\P{^Is_General_Category=_	Pc}', "");
    Expect(0, 65344, '\p{Is_General_Category=_	Pc}', "");
    Expect(1, 65344, '\p{^Is_General_Category=_	Pc}', "");
    Expect(1, 65344, '\P{Is_General_Category=_	Pc}', "");
    Expect(0, 65344, '\P{^Is_General_Category=_	Pc}', "");
    Error('\p{Is_Gc=__Connector_punctuation:=}');
    Error('\P{Is_Gc=__Connector_punctuation:=}');
    Expect(1, 65343, '\p{Is_Gc=connectorpunctuation}', "");
    Expect(0, 65343, '\p{^Is_Gc=connectorpunctuation}', "");
    Expect(0, 65343, '\P{Is_Gc=connectorpunctuation}', "");
    Expect(1, 65343, '\P{^Is_Gc=connectorpunctuation}', "");
    Expect(0, 65344, '\p{Is_Gc=connectorpunctuation}', "");
    Expect(1, 65344, '\p{^Is_Gc=connectorpunctuation}', "");
    Expect(1, 65344, '\P{Is_Gc=connectorpunctuation}', "");
    Expect(0, 65344, '\P{^Is_Gc=connectorpunctuation}', "");
    Expect(1, 65343, '\p{Is_Gc=  CONNECTOR_PUNCTUATION}', "");
    Expect(0, 65343, '\p{^Is_Gc=  CONNECTOR_PUNCTUATION}', "");
    Expect(0, 65343, '\P{Is_Gc=  CONNECTOR_PUNCTUATION}', "");
    Expect(1, 65343, '\P{^Is_Gc=  CONNECTOR_PUNCTUATION}', "");
    Expect(0, 65344, '\p{Is_Gc=  CONNECTOR_PUNCTUATION}', "");
    Expect(1, 65344, '\p{^Is_Gc=  CONNECTOR_PUNCTUATION}', "");
    Expect(1, 65344, '\P{Is_Gc=  CONNECTOR_PUNCTUATION}', "");
    Expect(0, 65344, '\P{^Is_Gc=  CONNECTOR_PUNCTUATION}', "");
    Error('\p{Is_Category=	-pc/a/}');
    Error('\P{Is_Category=	-pc/a/}');
    Expect(1, 65343, '\p{Is_Category=pc}', "");
    Expect(0, 65343, '\p{^Is_Category=pc}', "");
    Expect(0, 65343, '\P{Is_Category=pc}', "");
    Expect(1, 65343, '\P{^Is_Category=pc}', "");
    Expect(0, 65344, '\p{Is_Category=pc}', "");
    Expect(1, 65344, '\p{^Is_Category=pc}', "");
    Expect(1, 65344, '\P{Is_Category=pc}', "");
    Expect(0, 65344, '\P{^Is_Category=pc}', "");
    Expect(1, 65343, '\p{Is_Category=		PC}', "");
    Expect(0, 65343, '\p{^Is_Category=		PC}', "");
    Expect(0, 65343, '\P{Is_Category=		PC}', "");
    Expect(1, 65343, '\P{^Is_Category=		PC}', "");
    Expect(0, 65344, '\p{Is_Category=		PC}', "");
    Expect(1, 65344, '\p{^Is_Category=		PC}', "");
    Expect(1, 65344, '\P{Is_Category=		PC}', "");
    Expect(0, 65344, '\P{^Is_Category=		PC}', "");
    Error('\p{General_Category=:=dash_Punctuation}');
    Error('\P{General_Category=:=dash_Punctuation}');
    Expect(1, 69293, '\p{General_Category=:\ADash_Punctuation\z:}', "");;
    Expect(0, 69294, '\p{General_Category=:\ADash_Punctuation\z:}', "");;
    Expect(1, 69293, '\p{General_Category=dashpunctuation}', "");
    Expect(0, 69293, '\p{^General_Category=dashpunctuation}', "");
    Expect(0, 69293, '\P{General_Category=dashpunctuation}', "");
    Expect(1, 69293, '\P{^General_Category=dashpunctuation}', "");
    Expect(0, 69294, '\p{General_Category=dashpunctuation}', "");
    Expect(1, 69294, '\p{^General_Category=dashpunctuation}', "");
    Expect(1, 69294, '\P{General_Category=dashpunctuation}', "");
    Expect(0, 69294, '\P{^General_Category=dashpunctuation}', "");
    Expect(1, 69293, '\p{General_Category=:\Adashpunctuation\z:}', "");;
    Expect(0, 69294, '\p{General_Category=:\Adashpunctuation\z:}', "");;
    Expect(1, 69293, '\p{General_Category=	 Dash_PUNCTUATION}', "");
    Expect(0, 69293, '\p{^General_Category=	 Dash_PUNCTUATION}', "");
    Expect(0, 69293, '\P{General_Category=	 Dash_PUNCTUATION}', "");
    Expect(1, 69293, '\P{^General_Category=	 Dash_PUNCTUATION}', "");
    Expect(0, 69294, '\p{General_Category=	 Dash_PUNCTUATION}', "");
    Expect(1, 69294, '\p{^General_Category=	 Dash_PUNCTUATION}', "");
    Expect(1, 69294, '\P{General_Category=	 Dash_PUNCTUATION}', "");
    Expect(0, 69294, '\P{^General_Category=	 Dash_PUNCTUATION}', "");
    Error('\p{Gc:   -:=Pd}');
    Error('\P{Gc:   -:=Pd}');
    Expect(1, 69293, '\p{Gc=:\APd\z:}', "");;
    Expect(0, 69294, '\p{Gc=:\APd\z:}', "");;
    Expect(1, 69293, '\p{Gc=pd}', "");
    Expect(0, 69293, '\p{^Gc=pd}', "");
    Expect(0, 69293, '\P{Gc=pd}', "");
    Expect(1, 69293, '\P{^Gc=pd}', "");
    Expect(0, 69294, '\p{Gc=pd}', "");
    Expect(1, 69294, '\p{^Gc=pd}', "");
    Expect(1, 69294, '\P{Gc=pd}', "");
    Expect(0, 69294, '\P{^Gc=pd}', "");
    Expect(1, 69293, '\p{Gc=:\Apd\z:}', "");;
    Expect(0, 69294, '\p{Gc=:\Apd\z:}', "");;
    Expect(1, 69293, '\p{Gc= _pd}', "");
    Expect(0, 69293, '\p{^Gc= _pd}', "");
    Expect(0, 69293, '\P{Gc= _pd}', "");
    Expect(1, 69293, '\P{^Gc= _pd}', "");
    Expect(0, 69294, '\p{Gc= _pd}', "");
    Expect(1, 69294, '\p{^Gc= _pd}', "");
    Expect(1, 69294, '\P{Gc= _pd}', "");
    Expect(0, 69294, '\P{^Gc= _pd}', "");
    Error('\p{Category=-/a/dash_Punctuation}');
    Error('\P{Category=-/a/dash_Punctuation}');
    Expect(1, 69293, '\p{Category=:\ADash_Punctuation\z:}', "");;
    Expect(0, 69294, '\p{Category=:\ADash_Punctuation\z:}', "");;
    Expect(1, 69293, '\p{Category=dashpunctuation}', "");
    Expect(0, 69293, '\p{^Category=dashpunctuation}', "");
    Expect(0, 69293, '\P{Category=dashpunctuation}', "");
    Expect(1, 69293, '\P{^Category=dashpunctuation}', "");
    Expect(0, 69294, '\p{Category=dashpunctuation}', "");
    Expect(1, 69294, '\p{^Category=dashpunctuation}', "");
    Expect(1, 69294, '\P{Category=dashpunctuation}', "");
    Expect(0, 69294, '\P{^Category=dashpunctuation}', "");
    Expect(1, 69293, '\p{Category=:\Adashpunctuation\z:}', "");;
    Expect(0, 69294, '\p{Category=:\Adashpunctuation\z:}', "");;
    Expect(1, 69293, '\p{Category=_dash_Punctuation}', "");
    Expect(0, 69293, '\p{^Category=_dash_Punctuation}', "");
    Expect(0, 69293, '\P{Category=_dash_Punctuation}', "");
    Expect(1, 69293, '\P{^Category=_dash_Punctuation}', "");
    Expect(0, 69294, '\p{Category=_dash_Punctuation}', "");
    Expect(1, 69294, '\p{^Category=_dash_Punctuation}', "");
    Expect(1, 69294, '\P{Category=_dash_Punctuation}', "");
    Expect(0, 69294, '\P{^Category=_dash_Punctuation}', "");
    Error('\p{Is_General_Category=/a/_ pd}');
    Error('\P{Is_General_Category=/a/_ pd}');
    Expect(1, 69293, '\p{Is_General_Category=pd}', "");
    Expect(0, 69293, '\p{^Is_General_Category=pd}', "");
    Expect(0, 69293, '\P{Is_General_Category=pd}', "");
    Expect(1, 69293, '\P{^Is_General_Category=pd}', "");
    Expect(0, 69294, '\p{Is_General_Category=pd}', "");
    Expect(1, 69294, '\p{^Is_General_Category=pd}', "");
    Expect(1, 69294, '\P{Is_General_Category=pd}', "");
    Expect(0, 69294, '\P{^Is_General_Category=pd}', "");
    Expect(1, 69293, '\p{Is_General_Category:- Pd}', "");
    Expect(0, 69293, '\p{^Is_General_Category:- Pd}', "");
    Expect(0, 69293, '\P{Is_General_Category:- Pd}', "");
    Expect(1, 69293, '\P{^Is_General_Category:- Pd}', "");
    Expect(0, 69294, '\p{Is_General_Category:- Pd}', "");
    Expect(1, 69294, '\p{^Is_General_Category:- Pd}', "");
    Expect(1, 69294, '\P{Is_General_Category:- Pd}', "");
    Expect(0, 69294, '\P{^Is_General_Category:- Pd}', "");
    Error('\p{Is_Gc=/a/		Dash_Punctuation}');
    Error('\P{Is_Gc=/a/		Dash_Punctuation}');
    Expect(1, 69293, '\p{Is_Gc=dashpunctuation}', "");
    Expect(0, 69293, '\p{^Is_Gc=dashpunctuation}', "");
    Expect(0, 69293, '\P{Is_Gc=dashpunctuation}', "");
    Expect(1, 69293, '\P{^Is_Gc=dashpunctuation}', "");
    Expect(0, 69294, '\p{Is_Gc=dashpunctuation}', "");
    Expect(1, 69294, '\p{^Is_Gc=dashpunctuation}', "");
    Expect(1, 69294, '\P{Is_Gc=dashpunctuation}', "");
    Expect(0, 69294, '\P{^Is_Gc=dashpunctuation}', "");
    Expect(1, 69293, '\p{Is_Gc=_DASH_punctuation}', "");
    Expect(0, 69293, '\p{^Is_Gc=_DASH_punctuation}', "");
    Expect(0, 69293, '\P{Is_Gc=_DASH_punctuation}', "");
    Expect(1, 69293, '\P{^Is_Gc=_DASH_punctuation}', "");
    Expect(0, 69294, '\p{Is_Gc=_DASH_punctuation}', "");
    Expect(1, 69294, '\p{^Is_Gc=_DASH_punctuation}', "");
    Expect(1, 69294, '\P{Is_Gc=_DASH_punctuation}', "");
    Expect(0, 69294, '\P{^Is_Gc=_DASH_punctuation}', "");
    Error('\p{Is_Category::=--PD}');
    Error('\P{Is_Category::=--PD}');
    Expect(1, 69293, '\p{Is_Category=pd}', "");
    Expect(0, 69293, '\p{^Is_Category=pd}', "");
    Expect(0, 69293, '\P{Is_Category=pd}', "");
    Expect(1, 69293, '\P{^Is_Category=pd}', "");
    Expect(0, 69294, '\p{Is_Category=pd}', "");
    Expect(1, 69294, '\p{^Is_Category=pd}', "");
    Expect(1, 69294, '\P{Is_Category=pd}', "");
    Expect(0, 69294, '\P{^Is_Category=pd}', "");
    Expect(1, 69293, '\p{Is_Category=-pd}', "");
    Expect(0, 69293, '\p{^Is_Category=-pd}', "");
    Expect(0, 69293, '\P{Is_Category=-pd}', "");
    Expect(1, 69293, '\P{^Is_Category=-pd}', "");
    Expect(0, 69294, '\p{Is_Category=-pd}', "");
    Expect(1, 69294, '\p{^Is_Category=-pd}', "");
    Expect(1, 69294, '\P{Is_Category=-pd}', "");
    Expect(0, 69294, '\P{^Is_Category=-pd}', "");
    Error('\p{General_Category: --close_Punctuation/a/}');
    Error('\P{General_Category: --close_Punctuation/a/}');
    Expect(1, 65379, '\p{General_Category=:\AClose_Punctuation\z:}', "");;
    Expect(0, 65380, '\p{General_Category=:\AClose_Punctuation\z:}', "");;
    Expect(1, 65379, '\p{General_Category=closepunctuation}', "");
    Expect(0, 65379, '\p{^General_Category=closepunctuation}', "");
    Expect(0, 65379, '\P{General_Category=closepunctuation}', "");
    Expect(1, 65379, '\P{^General_Category=closepunctuation}', "");
    Expect(0, 65380, '\p{General_Category=closepunctuation}', "");
    Expect(1, 65380, '\p{^General_Category=closepunctuation}', "");
    Expect(1, 65380, '\P{General_Category=closepunctuation}', "");
    Expect(0, 65380, '\P{^General_Category=closepunctuation}', "");
    Expect(1, 65379, '\p{General_Category=:\Aclosepunctuation\z:}', "");;
    Expect(0, 65380, '\p{General_Category=:\Aclosepunctuation\z:}', "");;
    Expect(1, 65379, '\p{General_Category=	 Close_punctuation}', "");
    Expect(0, 65379, '\p{^General_Category=	 Close_punctuation}', "");
    Expect(0, 65379, '\P{General_Category=	 Close_punctuation}', "");
    Expect(1, 65379, '\P{^General_Category=	 Close_punctuation}', "");
    Expect(0, 65380, '\p{General_Category=	 Close_punctuation}', "");
    Expect(1, 65380, '\p{^General_Category=	 Close_punctuation}', "");
    Expect(1, 65380, '\P{General_Category=	 Close_punctuation}', "");
    Expect(0, 65380, '\P{^General_Category=	 Close_punctuation}', "");
    Error('\p{Gc=:=Pe}');
    Error('\P{Gc=:=Pe}');
    Expect(1, 65379, '\p{Gc=:\APe\z:}', "");;
    Expect(0, 65380, '\p{Gc=:\APe\z:}', "");;
    Expect(1, 65379, '\p{Gc=pe}', "");
    Expect(0, 65379, '\p{^Gc=pe}', "");
    Expect(0, 65379, '\P{Gc=pe}', "");
    Expect(1, 65379, '\P{^Gc=pe}', "");
    Expect(0, 65380, '\p{Gc=pe}', "");
    Expect(1, 65380, '\p{^Gc=pe}', "");
    Expect(1, 65380, '\P{Gc=pe}', "");
    Expect(0, 65380, '\P{^Gc=pe}', "");
    Expect(1, 65379, '\p{Gc=:\Ape\z:}', "");;
    Expect(0, 65380, '\p{Gc=:\Ape\z:}', "");;
    Expect(1, 65379, '\p{Gc=	 Pe}', "");
    Expect(0, 65379, '\p{^Gc=	 Pe}', "");
    Expect(0, 65379, '\P{Gc=	 Pe}', "");
    Expect(1, 65379, '\P{^Gc=	 Pe}', "");
    Expect(0, 65380, '\p{Gc=	 Pe}', "");
    Expect(1, 65380, '\p{^Gc=	 Pe}', "");
    Expect(1, 65380, '\P{Gc=	 Pe}', "");
    Expect(0, 65380, '\P{^Gc=	 Pe}', "");
    Error('\p{Category=_:=Close_Punctuation}');
    Error('\P{Category=_:=Close_Punctuation}');
    Expect(1, 65379, '\p{Category=:\AClose_Punctuation\z:}', "");;
    Expect(0, 65380, '\p{Category=:\AClose_Punctuation\z:}', "");;
    Expect(1, 65379, '\p{Category=closepunctuation}', "");
    Expect(0, 65379, '\p{^Category=closepunctuation}', "");
    Expect(0, 65379, '\P{Category=closepunctuation}', "");
    Expect(1, 65379, '\P{^Category=closepunctuation}', "");
    Expect(0, 65380, '\p{Category=closepunctuation}', "");
    Expect(1, 65380, '\p{^Category=closepunctuation}', "");
    Expect(1, 65380, '\P{Category=closepunctuation}', "");
    Expect(0, 65380, '\P{^Category=closepunctuation}', "");
    Expect(1, 65379, '\p{Category=:\Aclosepunctuation\z:}', "");;
    Expect(0, 65380, '\p{Category=:\Aclosepunctuation\z:}', "");;
    Expect(1, 65379, '\p{Category:-_CLOSE_Punctuation}', "");
    Expect(0, 65379, '\p{^Category:-_CLOSE_Punctuation}', "");
    Expect(0, 65379, '\P{Category:-_CLOSE_Punctuation}', "");
    Expect(1, 65379, '\P{^Category:-_CLOSE_Punctuation}', "");
    Expect(0, 65380, '\p{Category:-_CLOSE_Punctuation}', "");
    Expect(1, 65380, '\p{^Category:-_CLOSE_Punctuation}', "");
    Expect(1, 65380, '\P{Category:-_CLOSE_Punctuation}', "");
    Expect(0, 65380, '\P{^Category:-_CLOSE_Punctuation}', "");
    Error('\p{Is_General_Category= :=Pe}');
    Error('\P{Is_General_Category= :=Pe}');
    Expect(1, 65379, '\p{Is_General_Category=pe}', "");
    Expect(0, 65379, '\p{^Is_General_Category=pe}', "");
    Expect(0, 65379, '\P{Is_General_Category=pe}', "");
    Expect(1, 65379, '\P{^Is_General_Category=pe}', "");
    Expect(0, 65380, '\p{Is_General_Category=pe}', "");
    Expect(1, 65380, '\p{^Is_General_Category=pe}', "");
    Expect(1, 65380, '\P{Is_General_Category=pe}', "");
    Expect(0, 65380, '\P{^Is_General_Category=pe}', "");
    Expect(1, 65379, '\p{Is_General_Category=	_Pe}', "");
    Expect(0, 65379, '\p{^Is_General_Category=	_Pe}', "");
    Expect(0, 65379, '\P{Is_General_Category=	_Pe}', "");
    Expect(1, 65379, '\P{^Is_General_Category=	_Pe}', "");
    Expect(0, 65380, '\p{Is_General_Category=	_Pe}', "");
    Expect(1, 65380, '\p{^Is_General_Category=	_Pe}', "");
    Expect(1, 65380, '\P{Is_General_Category=	_Pe}', "");
    Expect(0, 65380, '\P{^Is_General_Category=	_Pe}', "");
    Error('\p{Is_Gc=/a/		Close_Punctuation}');
    Error('\P{Is_Gc=/a/		Close_Punctuation}');
    Expect(1, 65379, '\p{Is_Gc=closepunctuation}', "");
    Expect(0, 65379, '\p{^Is_Gc=closepunctuation}', "");
    Expect(0, 65379, '\P{Is_Gc=closepunctuation}', "");
    Expect(1, 65379, '\P{^Is_Gc=closepunctuation}', "");
    Expect(0, 65380, '\p{Is_Gc=closepunctuation}', "");
    Expect(1, 65380, '\p{^Is_Gc=closepunctuation}', "");
    Expect(1, 65380, '\P{Is_Gc=closepunctuation}', "");
    Expect(0, 65380, '\P{^Is_Gc=closepunctuation}', "");
    Expect(1, 65379, '\p{Is_Gc=-Close_PUNCTUATION}', "");
    Expect(0, 65379, '\p{^Is_Gc=-Close_PUNCTUATION}', "");
    Expect(0, 65379, '\P{Is_Gc=-Close_PUNCTUATION}', "");
    Expect(1, 65379, '\P{^Is_Gc=-Close_PUNCTUATION}', "");
    Expect(0, 65380, '\p{Is_Gc=-Close_PUNCTUATION}', "");
    Expect(1, 65380, '\p{^Is_Gc=-Close_PUNCTUATION}', "");
    Expect(1, 65380, '\P{Is_Gc=-Close_PUNCTUATION}', "");
    Expect(0, 65380, '\P{^Is_Gc=-Close_PUNCTUATION}', "");
    Error('\p{Is_Category=-	pe:=}');
    Error('\P{Is_Category=-	pe:=}');
    Expect(1, 65379, '\p{Is_Category=pe}', "");
    Expect(0, 65379, '\p{^Is_Category=pe}', "");
    Expect(0, 65379, '\P{Is_Category=pe}', "");
    Expect(1, 65379, '\P{^Is_Category=pe}', "");
    Expect(0, 65380, '\p{Is_Category=pe}', "");
    Expect(1, 65380, '\p{^Is_Category=pe}', "");
    Expect(1, 65380, '\P{Is_Category=pe}', "");
    Expect(0, 65380, '\P{^Is_Category=pe}', "");
    Expect(1, 65379, '\p{Is_Category=_Pe}', "");
    Expect(0, 65379, '\p{^Is_Category=_Pe}', "");
    Expect(0, 65379, '\P{Is_Category=_Pe}', "");
    Expect(1, 65379, '\P{^Is_Category=_Pe}', "");
    Expect(0, 65380, '\p{Is_Category=_Pe}', "");
    Expect(1, 65380, '\p{^Is_Category=_Pe}', "");
    Expect(1, 65380, '\P{Is_Category=_Pe}', "");
    Expect(0, 65380, '\P{^Is_Category=_Pe}', "");
    Error('\p{General_Category=-:=Final_PUNCTUATION}');
    Error('\P{General_Category=-:=Final_PUNCTUATION}');
    Expect(1, 11809, '\p{General_Category=:\AFinal_Punctuation\z:}', "");;
    Expect(0, 11810, '\p{General_Category=:\AFinal_Punctuation\z:}', "");;
    Expect(1, 11809, '\p{General_Category=finalpunctuation}', "");
    Expect(0, 11809, '\p{^General_Category=finalpunctuation}', "");
    Expect(0, 11809, '\P{General_Category=finalpunctuation}', "");
    Expect(1, 11809, '\P{^General_Category=finalpunctuation}', "");
    Expect(0, 11810, '\p{General_Category=finalpunctuation}', "");
    Expect(1, 11810, '\p{^General_Category=finalpunctuation}', "");
    Expect(1, 11810, '\P{General_Category=finalpunctuation}', "");
    Expect(0, 11810, '\P{^General_Category=finalpunctuation}', "");
    Expect(1, 11809, '\p{General_Category=:\Afinalpunctuation\z:}', "");;
    Expect(0, 11810, '\p{General_Category=:\Afinalpunctuation\z:}', "");;
    Expect(1, 11809, '\p{General_Category:   	_Final_PUNCTUATION}', "");
    Expect(0, 11809, '\p{^General_Category:   	_Final_PUNCTUATION}', "");
    Expect(0, 11809, '\P{General_Category:   	_Final_PUNCTUATION}', "");
    Expect(1, 11809, '\P{^General_Category:   	_Final_PUNCTUATION}', "");
    Expect(0, 11810, '\p{General_Category:   	_Final_PUNCTUATION}', "");
    Expect(1, 11810, '\p{^General_Category:   	_Final_PUNCTUATION}', "");
    Expect(1, 11810, '\P{General_Category:   	_Final_PUNCTUATION}', "");
    Expect(0, 11810, '\P{^General_Category:   	_Final_PUNCTUATION}', "");
    Error('\p{Gc=/a/_-Pf}');
    Error('\P{Gc=/a/_-Pf}');
    Expect(1, 11809, '\p{Gc=:\APf\z:}', "");;
    Expect(0, 11810, '\p{Gc=:\APf\z:}', "");;
    Expect(1, 11809, '\p{Gc=pf}', "");
    Expect(0, 11809, '\p{^Gc=pf}', "");
    Expect(0, 11809, '\P{Gc=pf}', "");
    Expect(1, 11809, '\P{^Gc=pf}', "");
    Expect(0, 11810, '\p{Gc=pf}', "");
    Expect(1, 11810, '\p{^Gc=pf}', "");
    Expect(1, 11810, '\P{Gc=pf}', "");
    Expect(0, 11810, '\P{^Gc=pf}', "");
    Expect(1, 11809, '\p{Gc=:\Apf\z:}', "");;
    Expect(0, 11810, '\p{Gc=:\Apf\z:}', "");;
    Expect(1, 11809, '\p{Gc=	PF}', "");
    Expect(0, 11809, '\p{^Gc=	PF}', "");
    Expect(0, 11809, '\P{Gc=	PF}', "");
    Expect(1, 11809, '\P{^Gc=	PF}', "");
    Expect(0, 11810, '\p{Gc=	PF}', "");
    Expect(1, 11810, '\p{^Gc=	PF}', "");
    Expect(1, 11810, '\P{Gc=	PF}', "");
    Expect(0, 11810, '\P{^Gc=	PF}', "");
    Error('\p{Category=/a/ 	Final_PUNCTUATION}');
    Error('\P{Category=/a/ 	Final_PUNCTUATION}');
    Expect(1, 11809, '\p{Category=:\AFinal_Punctuation\z:}', "");;
    Expect(0, 11810, '\p{Category=:\AFinal_Punctuation\z:}', "");;
    Expect(1, 11809, '\p{Category=finalpunctuation}', "");
    Expect(0, 11809, '\p{^Category=finalpunctuation}', "");
    Expect(0, 11809, '\P{Category=finalpunctuation}', "");
    Expect(1, 11809, '\P{^Category=finalpunctuation}', "");
    Expect(0, 11810, '\p{Category=finalpunctuation}', "");
    Expect(1, 11810, '\p{^Category=finalpunctuation}', "");
    Expect(1, 11810, '\P{Category=finalpunctuation}', "");
    Expect(0, 11810, '\P{^Category=finalpunctuation}', "");
    Expect(1, 11809, '\p{Category=:\Afinalpunctuation\z:}', "");;
    Expect(0, 11810, '\p{Category=:\Afinalpunctuation\z:}', "");;
    Expect(1, 11809, '\p{Category= Final_PUNCTUATION}', "");
    Expect(0, 11809, '\p{^Category= Final_PUNCTUATION}', "");
    Expect(0, 11809, '\P{Category= Final_PUNCTUATION}', "");
    Expect(1, 11809, '\P{^Category= Final_PUNCTUATION}', "");
    Expect(0, 11810, '\p{Category= Final_PUNCTUATION}', "");
    Expect(1, 11810, '\p{^Category= Final_PUNCTUATION}', "");
    Expect(1, 11810, '\P{Category= Final_PUNCTUATION}', "");
    Expect(0, 11810, '\P{^Category= Final_PUNCTUATION}', "");
    Error('\p{Is_General_Category=_/a/Pf}');
    Error('\P{Is_General_Category=_/a/Pf}');
    Expect(1, 11809, '\p{Is_General_Category=pf}', "");
    Expect(0, 11809, '\p{^Is_General_Category=pf}', "");
    Expect(0, 11809, '\P{Is_General_Category=pf}', "");
    Expect(1, 11809, '\P{^Is_General_Category=pf}', "");
    Expect(0, 11810, '\p{Is_General_Category=pf}', "");
    Expect(1, 11810, '\p{^Is_General_Category=pf}', "");
    Expect(1, 11810, '\P{Is_General_Category=pf}', "");
    Expect(0, 11810, '\P{^Is_General_Category=pf}', "");
    Expect(1, 11809, '\p{Is_General_Category= Pf}', "");
    Expect(0, 11809, '\p{^Is_General_Category= Pf}', "");
    Expect(0, 11809, '\P{Is_General_Category= Pf}', "");
    Expect(1, 11809, '\P{^Is_General_Category= Pf}', "");
    Expect(0, 11810, '\p{Is_General_Category= Pf}', "");
    Expect(1, 11810, '\p{^Is_General_Category= Pf}', "");
    Expect(1, 11810, '\P{Is_General_Category= Pf}', "");
    Expect(0, 11810, '\P{^Is_General_Category= Pf}', "");
    Error('\p{Is_Gc=:=	_final_PUNCTUATION}');
    Error('\P{Is_Gc=:=	_final_PUNCTUATION}');
    Expect(1, 11809, '\p{Is_Gc=finalpunctuation}', "");
    Expect(0, 11809, '\p{^Is_Gc=finalpunctuation}', "");
    Expect(0, 11809, '\P{Is_Gc=finalpunctuation}', "");
    Expect(1, 11809, '\P{^Is_Gc=finalpunctuation}', "");
    Expect(0, 11810, '\p{Is_Gc=finalpunctuation}', "");
    Expect(1, 11810, '\p{^Is_Gc=finalpunctuation}', "");
    Expect(1, 11810, '\P{Is_Gc=finalpunctuation}', "");
    Expect(0, 11810, '\P{^Is_Gc=finalpunctuation}', "");
    Expect(1, 11809, '\p{Is_Gc=-FINAL_PUNCTUATION}', "");
    Expect(0, 11809, '\p{^Is_Gc=-FINAL_PUNCTUATION}', "");
    Expect(0, 11809, '\P{Is_Gc=-FINAL_PUNCTUATION}', "");
    Expect(1, 11809, '\P{^Is_Gc=-FINAL_PUNCTUATION}', "");
    Expect(0, 11810, '\p{Is_Gc=-FINAL_PUNCTUATION}', "");
    Expect(1, 11810, '\p{^Is_Gc=-FINAL_PUNCTUATION}', "");
    Expect(1, 11810, '\P{Is_Gc=-FINAL_PUNCTUATION}', "");
    Expect(0, 11810, '\P{^Is_Gc=-FINAL_PUNCTUATION}', "");
    Error('\p{Is_Category=-_Pf/a/}');
    Error('\P{Is_Category=-_Pf/a/}');
    Expect(1, 11809, '\p{Is_Category=pf}', "");
    Expect(0, 11809, '\p{^Is_Category=pf}', "");
    Expect(0, 11809, '\P{Is_Category=pf}', "");
    Expect(1, 11809, '\P{^Is_Category=pf}', "");
    Expect(0, 11810, '\p{Is_Category=pf}', "");
    Expect(1, 11810, '\p{^Is_Category=pf}', "");
    Expect(1, 11810, '\P{Is_Category=pf}', "");
    Expect(0, 11810, '\P{^Is_Category=pf}', "");
    Expect(1, 11809, '\p{Is_Category=  Pf}', "");
    Expect(0, 11809, '\p{^Is_Category=  Pf}', "");
    Expect(0, 11809, '\P{Is_Category=  Pf}', "");
    Expect(1, 11809, '\P{^Is_Category=  Pf}', "");
    Expect(0, 11810, '\p{Is_Category=  Pf}', "");
    Expect(1, 11810, '\p{^Is_Category=  Pf}', "");
    Expect(1, 11810, '\P{Is_Category=  Pf}', "");
    Expect(0, 11810, '\P{^Is_Category=  Pf}', "");
    Error('\p{General_Category=_:=Initial_Punctuation}');
    Error('\P{General_Category=_:=Initial_Punctuation}');
    Expect(1, 11808, '\p{General_Category=:\AInitial_Punctuation\z:}', "");;
    Expect(0, 11809, '\p{General_Category=:\AInitial_Punctuation\z:}', "");;
    Expect(1, 11808, '\p{General_Category:initialpunctuation}', "");
    Expect(0, 11808, '\p{^General_Category:initialpunctuation}', "");
    Expect(0, 11808, '\P{General_Category:initialpunctuation}', "");
    Expect(1, 11808, '\P{^General_Category:initialpunctuation}', "");
    Expect(0, 11809, '\p{General_Category:initialpunctuation}', "");
    Expect(1, 11809, '\p{^General_Category:initialpunctuation}', "");
    Expect(1, 11809, '\P{General_Category:initialpunctuation}', "");
    Expect(0, 11809, '\P{^General_Category:initialpunctuation}', "");
    Expect(1, 11808, '\p{General_Category=:\Ainitialpunctuation\z:}', "");;
    Expect(0, 11809, '\p{General_Category=:\Ainitialpunctuation\z:}', "");;
    Expect(1, 11808, '\p{General_Category=	 Initial_punctuation}', "");
    Expect(0, 11808, '\p{^General_Category=	 Initial_punctuation}', "");
    Expect(0, 11808, '\P{General_Category=	 Initial_punctuation}', "");
    Expect(1, 11808, '\P{^General_Category=	 Initial_punctuation}', "");
    Expect(0, 11809, '\p{General_Category=	 Initial_punctuation}', "");
    Expect(1, 11809, '\p{^General_Category=	 Initial_punctuation}', "");
    Expect(1, 11809, '\P{General_Category=	 Initial_punctuation}', "");
    Expect(0, 11809, '\P{^General_Category=	 Initial_punctuation}', "");
    Error('\p{Gc=/a/ 	PI}');
    Error('\P{Gc=/a/ 	PI}');
    Expect(1, 11808, '\p{Gc=:\APi\z:}', "");;
    Expect(0, 11809, '\p{Gc=:\APi\z:}', "");;
    Expect(1, 11808, '\p{Gc: pi}', "");
    Expect(0, 11808, '\p{^Gc: pi}', "");
    Expect(0, 11808, '\P{Gc: pi}', "");
    Expect(1, 11808, '\P{^Gc: pi}', "");
    Expect(0, 11809, '\p{Gc: pi}', "");
    Expect(1, 11809, '\p{^Gc: pi}', "");
    Expect(1, 11809, '\P{Gc: pi}', "");
    Expect(0, 11809, '\P{^Gc: pi}', "");
    Expect(1, 11808, '\p{Gc=:\Api\z:}', "");;
    Expect(0, 11809, '\p{Gc=:\Api\z:}', "");;
    Expect(1, 11808, '\p{Gc=		Pi}', "");
    Expect(0, 11808, '\p{^Gc=		Pi}', "");
    Expect(0, 11808, '\P{Gc=		Pi}', "");
    Expect(1, 11808, '\P{^Gc=		Pi}', "");
    Expect(0, 11809, '\p{Gc=		Pi}', "");
    Expect(1, 11809, '\p{^Gc=		Pi}', "");
    Expect(1, 11809, '\P{Gc=		Pi}', "");
    Expect(0, 11809, '\P{^Gc=		Pi}', "");
    Error('\p{Category: _:=INITIAL_PUNCTUATION}');
    Error('\P{Category: _:=INITIAL_PUNCTUATION}');
    Expect(1, 11808, '\p{Category=:\AInitial_Punctuation\z:}', "");;
    Expect(0, 11809, '\p{Category=:\AInitial_Punctuation\z:}', "");;
    Expect(1, 11808, '\p{Category=initialpunctuation}', "");
    Expect(0, 11808, '\p{^Category=initialpunctuation}', "");
    Expect(0, 11808, '\P{Category=initialpunctuation}', "");
    Expect(1, 11808, '\P{^Category=initialpunctuation}', "");
    Expect(0, 11809, '\p{Category=initialpunctuation}', "");
    Expect(1, 11809, '\p{^Category=initialpunctuation}', "");
    Expect(1, 11809, '\P{Category=initialpunctuation}', "");
    Expect(0, 11809, '\P{^Category=initialpunctuation}', "");
    Expect(1, 11808, '\p{Category=:\Ainitialpunctuation\z:}', "");;
    Expect(0, 11809, '\p{Category=:\Ainitialpunctuation\z:}', "");;
    Expect(1, 11808, '\p{Category=-	Initial_PUNCTUATION}', "");
    Expect(0, 11808, '\p{^Category=-	Initial_PUNCTUATION}', "");
    Expect(0, 11808, '\P{Category=-	Initial_PUNCTUATION}', "");
    Expect(1, 11808, '\P{^Category=-	Initial_PUNCTUATION}', "");
    Expect(0, 11809, '\p{Category=-	Initial_PUNCTUATION}', "");
    Expect(1, 11809, '\p{^Category=-	Initial_PUNCTUATION}', "");
    Expect(1, 11809, '\P{Category=-	Initial_PUNCTUATION}', "");
    Expect(0, 11809, '\P{^Category=-	Initial_PUNCTUATION}', "");
    Error('\p{Is_General_Category= :=Pi}');
    Error('\P{Is_General_Category= :=Pi}');
    Expect(1, 11808, '\p{Is_General_Category=pi}', "");
    Expect(0, 11808, '\p{^Is_General_Category=pi}', "");
    Expect(0, 11808, '\P{Is_General_Category=pi}', "");
    Expect(1, 11808, '\P{^Is_General_Category=pi}', "");
    Expect(0, 11809, '\p{Is_General_Category=pi}', "");
    Expect(1, 11809, '\p{^Is_General_Category=pi}', "");
    Expect(1, 11809, '\P{Is_General_Category=pi}', "");
    Expect(0, 11809, '\P{^Is_General_Category=pi}', "");
    Expect(1, 11808, '\p{Is_General_Category=-_pi}', "");
    Expect(0, 11808, '\p{^Is_General_Category=-_pi}', "");
    Expect(0, 11808, '\P{Is_General_Category=-_pi}', "");
    Expect(1, 11808, '\P{^Is_General_Category=-_pi}', "");
    Expect(0, 11809, '\p{Is_General_Category=-_pi}', "");
    Expect(1, 11809, '\p{^Is_General_Category=-_pi}', "");
    Expect(1, 11809, '\P{Is_General_Category=-_pi}', "");
    Expect(0, 11809, '\P{^Is_General_Category=-_pi}', "");
    Error('\p{Is_Gc:   _Initial_Punctuation/a/}');
    Error('\P{Is_Gc:   _Initial_Punctuation/a/}');
    Expect(1, 11808, '\p{Is_Gc=initialpunctuation}', "");
    Expect(0, 11808, '\p{^Is_Gc=initialpunctuation}', "");
    Expect(0, 11808, '\P{Is_Gc=initialpunctuation}', "");
    Expect(1, 11808, '\P{^Is_Gc=initialpunctuation}', "");
    Expect(0, 11809, '\p{Is_Gc=initialpunctuation}', "");
    Expect(1, 11809, '\p{^Is_Gc=initialpunctuation}', "");
    Expect(1, 11809, '\P{Is_Gc=initialpunctuation}', "");
    Expect(0, 11809, '\P{^Is_Gc=initialpunctuation}', "");
    Expect(1, 11808, '\p{Is_Gc= 	initial_PUNCTUATION}', "");
    Expect(0, 11808, '\p{^Is_Gc= 	initial_PUNCTUATION}', "");
    Expect(0, 11808, '\P{Is_Gc= 	initial_PUNCTUATION}', "");
    Expect(1, 11808, '\P{^Is_Gc= 	initial_PUNCTUATION}', "");
    Expect(0, 11809, '\p{Is_Gc= 	initial_PUNCTUATION}', "");
    Expect(1, 11809, '\p{^Is_Gc= 	initial_PUNCTUATION}', "");
    Expect(1, 11809, '\P{Is_Gc= 	initial_PUNCTUATION}', "");
    Expect(0, 11809, '\P{^Is_Gc= 	initial_PUNCTUATION}', "");
    Error('\p{Is_Category=_:=Pi}');
    Error('\P{Is_Category=_:=Pi}');
    Expect(1, 11808, '\p{Is_Category=pi}', "");
    Expect(0, 11808, '\p{^Is_Category=pi}', "");
    Expect(0, 11808, '\P{Is_Category=pi}', "");
    Expect(1, 11808, '\P{^Is_Category=pi}', "");
    Expect(0, 11809, '\p{Is_Category=pi}', "");
    Expect(1, 11809, '\p{^Is_Category=pi}', "");
    Expect(1, 11809, '\P{Is_Category=pi}', "");
    Expect(0, 11809, '\P{^Is_Category=pi}', "");
    Error('\p{General_Category=:= Other_PUNCTUATION}');
    Error('\P{General_Category=:= Other_PUNCTUATION}');
    Expect(1, 125279, '\p{General_Category=:\AOther_Punctuation\z:}', "");;
    Expect(0, 125280, '\p{General_Category=:\AOther_Punctuation\z:}', "");;
    Expect(1, 125279, '\p{General_Category=otherpunctuation}', "");
    Expect(0, 125279, '\p{^General_Category=otherpunctuation}', "");
    Expect(0, 125279, '\P{General_Category=otherpunctuation}', "");
    Expect(1, 125279, '\P{^General_Category=otherpunctuation}', "");
    Expect(0, 125280, '\p{General_Category=otherpunctuation}', "");
    Expect(1, 125280, '\p{^General_Category=otherpunctuation}', "");
    Expect(1, 125280, '\P{General_Category=otherpunctuation}', "");
    Expect(0, 125280, '\P{^General_Category=otherpunctuation}', "");
    Expect(1, 125279, '\p{General_Category=:\Aotherpunctuation\z:}', "");;
    Expect(0, 125280, '\p{General_Category=:\Aotherpunctuation\z:}', "");;
    Expect(1, 125279, '\p{General_Category=_	other_PUNCTUATION}', "");
    Expect(0, 125279, '\p{^General_Category=_	other_PUNCTUATION}', "");
    Expect(0, 125279, '\P{General_Category=_	other_PUNCTUATION}', "");
    Expect(1, 125279, '\P{^General_Category=_	other_PUNCTUATION}', "");
    Expect(0, 125280, '\p{General_Category=_	other_PUNCTUATION}', "");
    Expect(1, 125280, '\p{^General_Category=_	other_PUNCTUATION}', "");
    Expect(1, 125280, '\P{General_Category=_	other_PUNCTUATION}', "");
    Expect(0, 125280, '\P{^General_Category=_	other_PUNCTUATION}', "");
    Error('\p{Gc=/a/ -Po}');
    Error('\P{Gc=/a/ -Po}');
    Expect(1, 125279, '\p{Gc=:\APo\z:}', "");;
    Expect(0, 125280, '\p{Gc=:\APo\z:}', "");;
    Expect(1, 125279, '\p{Gc=po}', "");
    Expect(0, 125279, '\p{^Gc=po}', "");
    Expect(0, 125279, '\P{Gc=po}', "");
    Expect(1, 125279, '\P{^Gc=po}', "");
    Expect(0, 125280, '\p{Gc=po}', "");
    Expect(1, 125280, '\p{^Gc=po}', "");
    Expect(1, 125280, '\P{Gc=po}', "");
    Expect(0, 125280, '\P{^Gc=po}', "");
    Expect(1, 125279, '\p{Gc=:\Apo\z:}', "");;
    Expect(0, 125280, '\p{Gc=:\Apo\z:}', "");;
    Expect(1, 125279, '\p{Gc=_ po}', "");
    Expect(0, 125279, '\p{^Gc=_ po}', "");
    Expect(0, 125279, '\P{Gc=_ po}', "");
    Expect(1, 125279, '\P{^Gc=_ po}', "");
    Expect(0, 125280, '\p{Gc=_ po}', "");
    Expect(1, 125280, '\p{^Gc=_ po}', "");
    Expect(1, 125280, '\P{Gc=_ po}', "");
    Expect(0, 125280, '\P{^Gc=_ po}', "");
    Error('\p{Category=_/a/other_Punctuation}');
    Error('\P{Category=_/a/other_Punctuation}');
    Expect(1, 125279, '\p{Category=:\AOther_Punctuation\z:}', "");;
    Expect(0, 125280, '\p{Category=:\AOther_Punctuation\z:}', "");;
    Expect(1, 125279, '\p{Category=otherpunctuation}', "");
    Expect(0, 125279, '\p{^Category=otherpunctuation}', "");
    Expect(0, 125279, '\P{Category=otherpunctuation}', "");
    Expect(1, 125279, '\P{^Category=otherpunctuation}', "");
    Expect(0, 125280, '\p{Category=otherpunctuation}', "");
    Expect(1, 125280, '\p{^Category=otherpunctuation}', "");
    Expect(1, 125280, '\P{Category=otherpunctuation}', "");
    Expect(0, 125280, '\P{^Category=otherpunctuation}', "");
    Expect(1, 125279, '\p{Category=:\Aotherpunctuation\z:}', "");;
    Expect(0, 125280, '\p{Category=:\Aotherpunctuation\z:}', "");;
    Expect(1, 125279, '\p{Category=_ Other_Punctuation}', "");
    Expect(0, 125279, '\p{^Category=_ Other_Punctuation}', "");
    Expect(0, 125279, '\P{Category=_ Other_Punctuation}', "");
    Expect(1, 125279, '\P{^Category=_ Other_Punctuation}', "");
    Expect(0, 125280, '\p{Category=_ Other_Punctuation}', "");
    Expect(1, 125280, '\p{^Category=_ Other_Punctuation}', "");
    Expect(1, 125280, '\P{Category=_ Other_Punctuation}', "");
    Expect(0, 125280, '\P{^Category=_ Other_Punctuation}', "");
    Error('\p{Is_General_Category=-/a/po}');
    Error('\P{Is_General_Category=-/a/po}');
    Expect(1, 125279, '\p{Is_General_Category: po}', "");
    Expect(0, 125279, '\p{^Is_General_Category: po}', "");
    Expect(0, 125279, '\P{Is_General_Category: po}', "");
    Expect(1, 125279, '\P{^Is_General_Category: po}', "");
    Expect(0, 125280, '\p{Is_General_Category: po}', "");
    Expect(1, 125280, '\p{^Is_General_Category: po}', "");
    Expect(1, 125280, '\P{Is_General_Category: po}', "");
    Expect(0, 125280, '\P{^Is_General_Category: po}', "");
    Expect(1, 125279, '\p{Is_General_Category=-	po}', "");
    Expect(0, 125279, '\p{^Is_General_Category=-	po}', "");
    Expect(0, 125279, '\P{Is_General_Category=-	po}', "");
    Expect(1, 125279, '\P{^Is_General_Category=-	po}', "");
    Expect(0, 125280, '\p{Is_General_Category=-	po}', "");
    Expect(1, 125280, '\p{^Is_General_Category=-	po}', "");
    Expect(1, 125280, '\P{Is_General_Category=-	po}', "");
    Expect(0, 125280, '\P{^Is_General_Category=-	po}', "");
    Error('\p{Is_Gc= 	Other_PUNCTUATION/a/}');
    Error('\P{Is_Gc= 	Other_PUNCTUATION/a/}');
    Expect(1, 125279, '\p{Is_Gc=otherpunctuation}', "");
    Expect(0, 125279, '\p{^Is_Gc=otherpunctuation}', "");
    Expect(0, 125279, '\P{Is_Gc=otherpunctuation}', "");
    Expect(1, 125279, '\P{^Is_Gc=otherpunctuation}', "");
    Expect(0, 125280, '\p{Is_Gc=otherpunctuation}', "");
    Expect(1, 125280, '\p{^Is_Gc=otherpunctuation}', "");
    Expect(1, 125280, '\P{Is_Gc=otherpunctuation}', "");
    Expect(0, 125280, '\P{^Is_Gc=otherpunctuation}', "");
    Expect(1, 125279, '\p{Is_Gc=-_other_PUNCTUATION}', "");
    Expect(0, 125279, '\p{^Is_Gc=-_other_PUNCTUATION}', "");
    Expect(0, 125279, '\P{Is_Gc=-_other_PUNCTUATION}', "");
    Expect(1, 125279, '\P{^Is_Gc=-_other_PUNCTUATION}', "");
    Expect(0, 125280, '\p{Is_Gc=-_other_PUNCTUATION}', "");
    Expect(1, 125280, '\p{^Is_Gc=-_other_PUNCTUATION}', "");
    Expect(1, 125280, '\P{Is_Gc=-_other_PUNCTUATION}', "");
    Expect(0, 125280, '\P{^Is_Gc=-_other_PUNCTUATION}', "");
    Error('\p{Is_Category= -Po:=}');
    Error('\P{Is_Category= -Po:=}');
    Expect(1, 125279, '\p{Is_Category=po}', "");
    Expect(0, 125279, '\p{^Is_Category=po}', "");
    Expect(0, 125279, '\P{Is_Category=po}', "");
    Expect(1, 125279, '\P{^Is_Category=po}', "");
    Expect(0, 125280, '\p{Is_Category=po}', "");
    Expect(1, 125280, '\p{^Is_Category=po}', "");
    Expect(1, 125280, '\P{Is_Category=po}', "");
    Expect(0, 125280, '\P{^Is_Category=po}', "");
    Expect(1, 125279, '\p{Is_Category=_Po}', "");
    Expect(0, 125279, '\p{^Is_Category=_Po}', "");
    Expect(0, 125279, '\P{Is_Category=_Po}', "");
    Expect(1, 125279, '\P{^Is_Category=_Po}', "");
    Expect(0, 125280, '\p{Is_Category=_Po}', "");
    Expect(1, 125280, '\p{^Is_Category=_Po}', "");
    Expect(1, 125280, '\P{Is_Category=_Po}', "");
    Expect(0, 125280, '\P{^Is_Category=_Po}', "");
    Error('\p{General_Category=/a/OPEN_Punctuation}');
    Error('\P{General_Category=/a/OPEN_Punctuation}');
    Expect(1, 65378, '\p{General_Category=:\AOpen_Punctuation\z:}', "");;
    Expect(0, 65379, '\p{General_Category=:\AOpen_Punctuation\z:}', "");;
    Expect(1, 65378, '\p{General_Category=openpunctuation}', "");
    Expect(0, 65378, '\p{^General_Category=openpunctuation}', "");
    Expect(0, 65378, '\P{General_Category=openpunctuation}', "");
    Expect(1, 65378, '\P{^General_Category=openpunctuation}', "");
    Expect(0, 65379, '\p{General_Category=openpunctuation}', "");
    Expect(1, 65379, '\p{^General_Category=openpunctuation}', "");
    Expect(1, 65379, '\P{General_Category=openpunctuation}', "");
    Expect(0, 65379, '\P{^General_Category=openpunctuation}', "");
    Expect(1, 65378, '\p{General_Category=:\Aopenpunctuation\z:}', "");;
    Expect(0, 65379, '\p{General_Category=:\Aopenpunctuation\z:}', "");;
    Expect(1, 65378, '\p{General_Category=  open_Punctuation}', "");
    Expect(0, 65378, '\p{^General_Category=  open_Punctuation}', "");
    Expect(0, 65378, '\P{General_Category=  open_Punctuation}', "");
    Expect(1, 65378, '\P{^General_Category=  open_Punctuation}', "");
    Expect(0, 65379, '\p{General_Category=  open_Punctuation}', "");
    Expect(1, 65379, '\p{^General_Category=  open_Punctuation}', "");
    Expect(1, 65379, '\P{General_Category=  open_Punctuation}', "");
    Expect(0, 65379, '\P{^General_Category=  open_Punctuation}', "");
    Error('\p{Gc=/a/ -Ps}');
    Error('\P{Gc=/a/ -Ps}');
    Expect(1, 65378, '\p{Gc=:\APs\z:}', "");;
    Expect(0, 65379, '\p{Gc=:\APs\z:}', "");;
    Expect(1, 65378, '\p{Gc=ps}', "");
    Expect(0, 65378, '\p{^Gc=ps}', "");
    Expect(0, 65378, '\P{Gc=ps}', "");
    Expect(1, 65378, '\P{^Gc=ps}', "");
    Expect(0, 65379, '\p{Gc=ps}', "");
    Expect(1, 65379, '\p{^Gc=ps}', "");
    Expect(1, 65379, '\P{Gc=ps}', "");
    Expect(0, 65379, '\P{^Gc=ps}', "");
    Expect(1, 65378, '\p{Gc=:\Aps\z:}', "");;
    Expect(0, 65379, '\p{Gc=:\Aps\z:}', "");;
    Expect(1, 65378, '\p{Gc=  PS}', "");
    Expect(0, 65378, '\p{^Gc=  PS}', "");
    Expect(0, 65378, '\P{Gc=  PS}', "");
    Expect(1, 65378, '\P{^Gc=  PS}', "");
    Expect(0, 65379, '\p{Gc=  PS}', "");
    Expect(1, 65379, '\p{^Gc=  PS}', "");
    Expect(1, 65379, '\P{Gc=  PS}', "");
    Expect(0, 65379, '\P{^Gc=  PS}', "");
    Error('\p{Category=/a/ open_PUNCTUATION}');
    Error('\P{Category=/a/ open_PUNCTUATION}');
    Expect(1, 65378, '\p{Category=:\AOpen_Punctuation\z:}', "");;
    Expect(0, 65379, '\p{Category=:\AOpen_Punctuation\z:}', "");;
    Expect(1, 65378, '\p{Category=openpunctuation}', "");
    Expect(0, 65378, '\p{^Category=openpunctuation}', "");
    Expect(0, 65378, '\P{Category=openpunctuation}', "");
    Expect(1, 65378, '\P{^Category=openpunctuation}', "");
    Expect(0, 65379, '\p{Category=openpunctuation}', "");
    Expect(1, 65379, '\p{^Category=openpunctuation}', "");
    Expect(1, 65379, '\P{Category=openpunctuation}', "");
    Expect(0, 65379, '\P{^Category=openpunctuation}', "");
    Expect(1, 65378, '\p{Category=:\Aopenpunctuation\z:}', "");;
    Expect(0, 65379, '\p{Category=:\Aopenpunctuation\z:}', "");;
    Expect(1, 65378, '\p{Category:  	Open_Punctuation}', "");
    Expect(0, 65378, '\p{^Category:  	Open_Punctuation}', "");
    Expect(0, 65378, '\P{Category:  	Open_Punctuation}', "");
    Expect(1, 65378, '\P{^Category:  	Open_Punctuation}', "");
    Expect(0, 65379, '\p{Category:  	Open_Punctuation}', "");
    Expect(1, 65379, '\p{^Category:  	Open_Punctuation}', "");
    Expect(1, 65379, '\P{Category:  	Open_Punctuation}', "");
    Expect(0, 65379, '\P{^Category:  	Open_Punctuation}', "");
    Error('\p{Is_General_Category=:=-_Ps}');
    Error('\P{Is_General_Category=:=-_Ps}');
    Expect(1, 65378, '\p{Is_General_Category=ps}', "");
    Expect(0, 65378, '\p{^Is_General_Category=ps}', "");
    Expect(0, 65378, '\P{Is_General_Category=ps}', "");
    Expect(1, 65378, '\P{^Is_General_Category=ps}', "");
    Expect(0, 65379, '\p{Is_General_Category=ps}', "");
    Expect(1, 65379, '\p{^Is_General_Category=ps}', "");
    Expect(1, 65379, '\P{Is_General_Category=ps}', "");
    Expect(0, 65379, '\P{^Is_General_Category=ps}', "");
    Expect(1, 65378, '\p{Is_General_Category=_PS}', "");
    Expect(0, 65378, '\p{^Is_General_Category=_PS}', "");
    Expect(0, 65378, '\P{Is_General_Category=_PS}', "");
    Expect(1, 65378, '\P{^Is_General_Category=_PS}', "");
    Expect(0, 65379, '\p{Is_General_Category=_PS}', "");
    Expect(1, 65379, '\p{^Is_General_Category=_PS}', "");
    Expect(1, 65379, '\P{Is_General_Category=_PS}', "");
    Expect(0, 65379, '\P{^Is_General_Category=_PS}', "");
    Error('\p{Is_Gc=/a/ OPEN_punctuation}');
    Error('\P{Is_Gc=/a/ OPEN_punctuation}');
    Expect(1, 65378, '\p{Is_Gc=openpunctuation}', "");
    Expect(0, 65378, '\p{^Is_Gc=openpunctuation}', "");
    Expect(0, 65378, '\P{Is_Gc=openpunctuation}', "");
    Expect(1, 65378, '\P{^Is_Gc=openpunctuation}', "");
    Expect(0, 65379, '\p{Is_Gc=openpunctuation}', "");
    Expect(1, 65379, '\p{^Is_Gc=openpunctuation}', "");
    Expect(1, 65379, '\P{Is_Gc=openpunctuation}', "");
    Expect(0, 65379, '\P{^Is_Gc=openpunctuation}', "");
    Expect(1, 65378, '\p{Is_Gc=	_OPEN_PUNCTUATION}', "");
    Expect(0, 65378, '\p{^Is_Gc=	_OPEN_PUNCTUATION}', "");
    Expect(0, 65378, '\P{Is_Gc=	_OPEN_PUNCTUATION}', "");
    Expect(1, 65378, '\P{^Is_Gc=	_OPEN_PUNCTUATION}', "");
    Expect(0, 65379, '\p{Is_Gc=	_OPEN_PUNCTUATION}', "");
    Expect(1, 65379, '\p{^Is_Gc=	_OPEN_PUNCTUATION}', "");
    Expect(1, 65379, '\P{Is_Gc=	_OPEN_PUNCTUATION}', "");
    Expect(0, 65379, '\P{^Is_Gc=	_OPEN_PUNCTUATION}', "");
    Error('\p{Is_Category=/a/_Ps}');
    Error('\P{Is_Category=/a/_Ps}');
    Expect(1, 65378, '\p{Is_Category=ps}', "");
    Expect(0, 65378, '\p{^Is_Category=ps}', "");
    Expect(0, 65378, '\P{Is_Category=ps}', "");
    Expect(1, 65378, '\P{^Is_Category=ps}', "");
    Expect(0, 65379, '\p{Is_Category=ps}', "");
    Expect(1, 65379, '\p{^Is_Category=ps}', "");
    Expect(1, 65379, '\P{Is_Category=ps}', "");
    Expect(0, 65379, '\P{^Is_Category=ps}', "");
    Expect(1, 65378, '\p{Is_Category= 	ps}', "");
    Expect(0, 65378, '\p{^Is_Category= 	ps}', "");
    Expect(0, 65378, '\P{Is_Category= 	ps}', "");
    Expect(1, 65378, '\P{^Is_Category= 	ps}', "");
    Expect(0, 65379, '\p{Is_Category= 	ps}', "");
    Expect(1, 65379, '\p{^Is_Category= 	ps}', "");
    Expect(1, 65379, '\P{Is_Category= 	ps}', "");
    Expect(0, 65379, '\P{^Is_Category= 	ps}', "");
    Error('\p{General_Category=_SYMBOL:=}');
    Error('\P{General_Category=_SYMBOL:=}');
    Expect(1, 129994, '\p{General_Category=:\ASymbol\z:}', "");;
    Expect(0, 129995, '\p{General_Category=:\ASymbol\z:}', "");;
    Expect(1, 129994, '\p{General_Category=symbol}', "");
    Expect(0, 129994, '\p{^General_Category=symbol}', "");
    Expect(0, 129994, '\P{General_Category=symbol}', "");
    Expect(1, 129994, '\P{^General_Category=symbol}', "");
    Expect(0, 129995, '\p{General_Category=symbol}', "");
    Expect(1, 129995, '\p{^General_Category=symbol}', "");
    Expect(1, 129995, '\P{General_Category=symbol}', "");
    Expect(0, 129995, '\P{^General_Category=symbol}', "");
    Expect(1, 129994, '\p{General_Category=:\Asymbol\z:}', "");;
    Expect(0, 129995, '\p{General_Category=:\Asymbol\z:}', "");;
    Expect(1, 129994, '\p{General_Category=_symbol}', "");
    Expect(0, 129994, '\p{^General_Category=_symbol}', "");
    Expect(0, 129994, '\P{General_Category=_symbol}', "");
    Expect(1, 129994, '\P{^General_Category=_symbol}', "");
    Expect(0, 129995, '\p{General_Category=_symbol}', "");
    Expect(1, 129995, '\p{^General_Category=_symbol}', "");
    Expect(1, 129995, '\P{General_Category=_symbol}', "");
    Expect(0, 129995, '\P{^General_Category=_symbol}', "");
    Error('\p{Gc=/a/_S}');
    Error('\P{Gc=/a/_S}');
    Expect(1, 129994, '\p{Gc=:\AS\z:}', "");;
    Expect(0, 129995, '\p{Gc=:\AS\z:}', "");;
    Expect(1, 129994, '\p{Gc=s}', "");
    Expect(0, 129994, '\p{^Gc=s}', "");
    Expect(0, 129994, '\P{Gc=s}', "");
    Expect(1, 129994, '\P{^Gc=s}', "");
    Expect(0, 129995, '\p{Gc=s}', "");
    Expect(1, 129995, '\p{^Gc=s}', "");
    Expect(1, 129995, '\P{Gc=s}', "");
    Expect(0, 129995, '\P{^Gc=s}', "");
    Expect(1, 129994, '\p{Gc=:\As\z:}', "");;
    Expect(0, 129995, '\p{Gc=:\As\z:}', "");;
    Expect(1, 129994, '\p{Gc=	 s}', "");
    Expect(0, 129994, '\p{^Gc=	 s}', "");
    Expect(0, 129994, '\P{Gc=	 s}', "");
    Expect(1, 129994, '\P{^Gc=	 s}', "");
    Expect(0, 129995, '\p{Gc=	 s}', "");
    Expect(1, 129995, '\p{^Gc=	 s}', "");
    Expect(1, 129995, '\P{Gc=	 s}', "");
    Expect(0, 129995, '\P{^Gc=	 s}', "");
    Error('\p{Category= _Symbol:=}');
    Error('\P{Category= _Symbol:=}');
    Expect(1, 129994, '\p{Category=:\ASymbol\z:}', "");;
    Expect(0, 129995, '\p{Category=:\ASymbol\z:}', "");;
    Expect(1, 129994, '\p{Category=symbol}', "");
    Expect(0, 129994, '\p{^Category=symbol}', "");
    Expect(0, 129994, '\P{Category=symbol}', "");
    Expect(1, 129994, '\P{^Category=symbol}', "");
    Expect(0, 129995, '\p{Category=symbol}', "");
    Expect(1, 129995, '\p{^Category=symbol}', "");
    Expect(1, 129995, '\P{Category=symbol}', "");
    Expect(0, 129995, '\P{^Category=symbol}', "");
    Expect(1, 129994, '\p{Category=:\Asymbol\z:}', "");;
    Expect(0, 129995, '\p{Category=:\Asymbol\z:}', "");;
    Expect(1, 129994, '\p{Category=--Symbol}', "");
    Expect(0, 129994, '\p{^Category=--Symbol}', "");
    Expect(0, 129994, '\P{Category=--Symbol}', "");
    Expect(1, 129994, '\P{^Category=--Symbol}', "");
    Expect(0, 129995, '\p{Category=--Symbol}', "");
    Expect(1, 129995, '\p{^Category=--Symbol}', "");
    Expect(1, 129995, '\P{Category=--Symbol}', "");
    Expect(0, 129995, '\P{^Category=--Symbol}', "");
    Error('\p{Is_General_Category=:=s}');
    Error('\P{Is_General_Category=:=s}');
    Expect(1, 129994, '\p{Is_General_Category=s}', "");
    Expect(0, 129994, '\p{^Is_General_Category=s}', "");
    Expect(0, 129994, '\P{Is_General_Category=s}', "");
    Expect(1, 129994, '\P{^Is_General_Category=s}', "");
    Expect(0, 129995, '\p{Is_General_Category=s}', "");
    Expect(1, 129995, '\p{^Is_General_Category=s}', "");
    Expect(1, 129995, '\P{Is_General_Category=s}', "");
    Expect(0, 129995, '\P{^Is_General_Category=s}', "");
    Expect(1, 129994, '\p{Is_General_Category=  S}', "");
    Expect(0, 129994, '\p{^Is_General_Category=  S}', "");
    Expect(0, 129994, '\P{Is_General_Category=  S}', "");
    Expect(1, 129994, '\P{^Is_General_Category=  S}', "");
    Expect(0, 129995, '\p{Is_General_Category=  S}', "");
    Expect(1, 129995, '\p{^Is_General_Category=  S}', "");
    Expect(1, 129995, '\P{Is_General_Category=  S}', "");
    Expect(0, 129995, '\P{^Is_General_Category=  S}', "");
    Error('\p{Is_Gc=	 symbol/a/}');
    Error('\P{Is_Gc=	 symbol/a/}');
    Expect(1, 129994, '\p{Is_Gc=symbol}', "");
    Expect(0, 129994, '\p{^Is_Gc=symbol}', "");
    Expect(0, 129994, '\P{Is_Gc=symbol}', "");
    Expect(1, 129994, '\P{^Is_Gc=symbol}', "");
    Expect(0, 129995, '\p{Is_Gc=symbol}', "");
    Expect(1, 129995, '\p{^Is_Gc=symbol}', "");
    Expect(1, 129995, '\P{Is_Gc=symbol}', "");
    Expect(0, 129995, '\P{^Is_Gc=symbol}', "");
    Expect(1, 129994, '\p{Is_Gc=		symbol}', "");
    Expect(0, 129994, '\p{^Is_Gc=		symbol}', "");
    Expect(0, 129994, '\P{Is_Gc=		symbol}', "");
    Expect(1, 129994, '\P{^Is_Gc=		symbol}', "");
    Expect(0, 129995, '\p{Is_Gc=		symbol}', "");
    Expect(1, 129995, '\p{^Is_Gc=		symbol}', "");
    Expect(1, 129995, '\P{Is_Gc=		symbol}', "");
    Expect(0, 129995, '\P{^Is_Gc=		symbol}', "");
    Error('\p{Is_Category=_S/a/}');
    Error('\P{Is_Category=_S/a/}');
    Expect(1, 129994, '\p{Is_Category=s}', "");
    Expect(0, 129994, '\p{^Is_Category=s}', "");
    Expect(0, 129994, '\P{Is_Category=s}', "");
    Expect(1, 129994, '\P{^Is_Category=s}', "");
    Expect(0, 129995, '\p{Is_Category=s}', "");
    Expect(1, 129995, '\p{^Is_Category=s}', "");
    Expect(1, 129995, '\P{Is_Category=s}', "");
    Expect(0, 129995, '\P{^Is_Category=s}', "");
    Expect(1, 129994, '\p{Is_Category=-S}', "");
    Expect(0, 129994, '\p{^Is_Category=-S}', "");
    Expect(0, 129994, '\P{Is_Category=-S}', "");
    Expect(1, 129994, '\P{^Is_Category=-S}', "");
    Expect(0, 129995, '\p{Is_Category=-S}', "");
    Expect(1, 129995, '\p{^Is_Category=-S}', "");
    Expect(1, 129995, '\P{Is_Category=-S}', "");
    Expect(0, 129995, '\P{^Is_Category=-S}', "");
    Error('\p{General_Category=/a/_CURRENCY_symbol}');
    Error('\P{General_Category=/a/_CURRENCY_symbol}');
    Expect(1, 126128, '\p{General_Category=:\ACurrency_Symbol\z:}', "");;
    Expect(0, 126129, '\p{General_Category=:\ACurrency_Symbol\z:}', "");;
    Expect(1, 126128, '\p{General_Category=currencysymbol}', "");
    Expect(0, 126128, '\p{^General_Category=currencysymbol}', "");
    Expect(0, 126128, '\P{General_Category=currencysymbol}', "");
    Expect(1, 126128, '\P{^General_Category=currencysymbol}', "");
    Expect(0, 126129, '\p{General_Category=currencysymbol}', "");
    Expect(1, 126129, '\p{^General_Category=currencysymbol}', "");
    Expect(1, 126129, '\P{General_Category=currencysymbol}', "");
    Expect(0, 126129, '\P{^General_Category=currencysymbol}', "");
    Expect(1, 126128, '\p{General_Category=:\Acurrencysymbol\z:}', "");;
    Expect(0, 126129, '\p{General_Category=:\Acurrencysymbol\z:}', "");;
    Expect(1, 126128, '\p{General_Category:	_CURRENCY_symbol}', "");
    Expect(0, 126128, '\p{^General_Category:	_CURRENCY_symbol}', "");
    Expect(0, 126128, '\P{General_Category:	_CURRENCY_symbol}', "");
    Expect(1, 126128, '\P{^General_Category:	_CURRENCY_symbol}', "");
    Expect(0, 126129, '\p{General_Category:	_CURRENCY_symbol}', "");
    Expect(1, 126129, '\p{^General_Category:	_CURRENCY_symbol}', "");
    Expect(1, 126129, '\P{General_Category:	_CURRENCY_symbol}', "");
    Expect(0, 126129, '\P{^General_Category:	_CURRENCY_symbol}', "");
    Error('\p{Gc= _SC/a/}');
    Error('\P{Gc= _SC/a/}');
    Expect(1, 126128, '\p{Gc=:\ASc\z:}', "");;
    Expect(0, 126129, '\p{Gc=:\ASc\z:}', "");;
    Expect(1, 126128, '\p{Gc=sc}', "");
    Expect(0, 126128, '\p{^Gc=sc}', "");
    Expect(0, 126128, '\P{Gc=sc}', "");
    Expect(1, 126128, '\P{^Gc=sc}', "");
    Expect(0, 126129, '\p{Gc=sc}', "");
    Expect(1, 126129, '\p{^Gc=sc}', "");
    Expect(1, 126129, '\P{Gc=sc}', "");
    Expect(0, 126129, '\P{^Gc=sc}', "");
    Expect(1, 126128, '\p{Gc=:\Asc\z:}', "");;
    Expect(0, 126129, '\p{Gc=:\Asc\z:}', "");;
    Expect(1, 126128, '\p{Gc=_Sc}', "");
    Expect(0, 126128, '\p{^Gc=_Sc}', "");
    Expect(0, 126128, '\P{Gc=_Sc}', "");
    Expect(1, 126128, '\P{^Gc=_Sc}', "");
    Expect(0, 126129, '\p{Gc=_Sc}', "");
    Expect(1, 126129, '\p{^Gc=_Sc}', "");
    Expect(1, 126129, '\P{Gc=_Sc}', "");
    Expect(0, 126129, '\P{^Gc=_Sc}', "");
    Error('\p{Category=-:=currency_symbol}');
    Error('\P{Category=-:=currency_symbol}');
    Expect(1, 126128, '\p{Category=:\ACurrency_Symbol\z:}', "");;
    Expect(0, 126129, '\p{Category=:\ACurrency_Symbol\z:}', "");;
    Expect(1, 126128, '\p{Category=currencysymbol}', "");
    Expect(0, 126128, '\p{^Category=currencysymbol}', "");
    Expect(0, 126128, '\P{Category=currencysymbol}', "");
    Expect(1, 126128, '\P{^Category=currencysymbol}', "");
    Expect(0, 126129, '\p{Category=currencysymbol}', "");
    Expect(1, 126129, '\p{^Category=currencysymbol}', "");
    Expect(1, 126129, '\P{Category=currencysymbol}', "");
    Expect(0, 126129, '\P{^Category=currencysymbol}', "");
    Expect(1, 126128, '\p{Category=:\Acurrencysymbol\z:}', "");;
    Expect(0, 126129, '\p{Category=:\Acurrencysymbol\z:}', "");;
    Expect(1, 126128, '\p{Category=	-Currency_Symbol}', "");
    Expect(0, 126128, '\p{^Category=	-Currency_Symbol}', "");
    Expect(0, 126128, '\P{Category=	-Currency_Symbol}', "");
    Expect(1, 126128, '\P{^Category=	-Currency_Symbol}', "");
    Expect(0, 126129, '\p{Category=	-Currency_Symbol}', "");
    Expect(1, 126129, '\p{^Category=	-Currency_Symbol}', "");
    Expect(1, 126129, '\P{Category=	-Currency_Symbol}', "");
    Expect(0, 126129, '\P{^Category=	-Currency_Symbol}', "");
    Error('\p{Is_General_Category=/a/_-Sc}');
    Error('\P{Is_General_Category=/a/_-Sc}');
    Expect(1, 126128, '\p{Is_General_Category=sc}', "");
    Expect(0, 126128, '\p{^Is_General_Category=sc}', "");
    Expect(0, 126128, '\P{Is_General_Category=sc}', "");
    Expect(1, 126128, '\P{^Is_General_Category=sc}', "");
    Expect(0, 126129, '\p{Is_General_Category=sc}', "");
    Expect(1, 126129, '\p{^Is_General_Category=sc}', "");
    Expect(1, 126129, '\P{Is_General_Category=sc}', "");
    Expect(0, 126129, '\P{^Is_General_Category=sc}', "");
    Expect(1, 126128, '\p{Is_General_Category=_ Sc}', "");
    Expect(0, 126128, '\p{^Is_General_Category=_ Sc}', "");
    Expect(0, 126128, '\P{Is_General_Category=_ Sc}', "");
    Expect(1, 126128, '\P{^Is_General_Category=_ Sc}', "");
    Expect(0, 126129, '\p{Is_General_Category=_ Sc}', "");
    Expect(1, 126129, '\p{^Is_General_Category=_ Sc}', "");
    Expect(1, 126129, '\P{Is_General_Category=_ Sc}', "");
    Expect(0, 126129, '\P{^Is_General_Category=_ Sc}', "");
    Error('\p{Is_Gc=/a/ Currency_symbol}');
    Error('\P{Is_Gc=/a/ Currency_symbol}');
    Expect(1, 126128, '\p{Is_Gc=currencysymbol}', "");
    Expect(0, 126128, '\p{^Is_Gc=currencysymbol}', "");
    Expect(0, 126128, '\P{Is_Gc=currencysymbol}', "");
    Expect(1, 126128, '\P{^Is_Gc=currencysymbol}', "");
    Expect(0, 126129, '\p{Is_Gc=currencysymbol}', "");
    Expect(1, 126129, '\p{^Is_Gc=currencysymbol}', "");
    Expect(1, 126129, '\P{Is_Gc=currencysymbol}', "");
    Expect(0, 126129, '\P{^Is_Gc=currencysymbol}', "");
    Expect(1, 126128, '\p{Is_Gc=_Currency_Symbol}', "");
    Expect(0, 126128, '\p{^Is_Gc=_Currency_Symbol}', "");
    Expect(0, 126128, '\P{Is_Gc=_Currency_Symbol}', "");
    Expect(1, 126128, '\P{^Is_Gc=_Currency_Symbol}', "");
    Expect(0, 126129, '\p{Is_Gc=_Currency_Symbol}', "");
    Expect(1, 126129, '\p{^Is_Gc=_Currency_Symbol}', "");
    Expect(1, 126129, '\P{Is_Gc=_Currency_Symbol}', "");
    Expect(0, 126129, '\P{^Is_Gc=_Currency_Symbol}', "");
    Error('\p{Is_Category=/a/__Sc}');
    Error('\P{Is_Category=/a/__Sc}');
    Expect(1, 126128, '\p{Is_Category=sc}', "");
    Expect(0, 126128, '\p{^Is_Category=sc}', "");
    Expect(0, 126128, '\P{Is_Category=sc}', "");
    Expect(1, 126128, '\P{^Is_Category=sc}', "");
    Expect(0, 126129, '\p{Is_Category=sc}', "");
    Expect(1, 126129, '\p{^Is_Category=sc}', "");
    Expect(1, 126129, '\P{Is_Category=sc}', "");
    Expect(0, 126129, '\P{^Is_Category=sc}', "");
    Expect(1, 126128, '\p{Is_Category=SC}', "");
    Expect(0, 126128, '\p{^Is_Category=SC}', "");
    Expect(0, 126128, '\P{Is_Category=SC}', "");
    Expect(1, 126128, '\P{^Is_Category=SC}', "");
    Expect(0, 126129, '\p{Is_Category=SC}', "");
    Expect(1, 126129, '\p{^Is_Category=SC}', "");
    Expect(1, 126129, '\P{Is_Category=SC}', "");
    Expect(0, 126129, '\P{^Is_Category=SC}', "");
    Error('\p{General_Category=/a/__Modifier_Symbol}');
    Error('\P{General_Category=/a/__Modifier_Symbol}');
    Expect(1, 127999, '\p{General_Category=:\AModifier_Symbol\z:}', "");;
    Expect(0, 128000, '\p{General_Category=:\AModifier_Symbol\z:}', "");;
    Expect(1, 127999, '\p{General_Category=modifiersymbol}', "");
    Expect(0, 127999, '\p{^General_Category=modifiersymbol}', "");
    Expect(0, 127999, '\P{General_Category=modifiersymbol}', "");
    Expect(1, 127999, '\P{^General_Category=modifiersymbol}', "");
    Expect(0, 128000, '\p{General_Category=modifiersymbol}', "");
    Expect(1, 128000, '\p{^General_Category=modifiersymbol}', "");
    Expect(1, 128000, '\P{General_Category=modifiersymbol}', "");
    Expect(0, 128000, '\P{^General_Category=modifiersymbol}', "");
    Expect(1, 127999, '\p{General_Category=:\Amodifiersymbol\z:}', "");;
    Expect(0, 128000, '\p{General_Category=:\Amodifiersymbol\z:}', "");;
    Expect(1, 127999, '\p{General_Category=		Modifier_symbol}', "");
    Expect(0, 127999, '\p{^General_Category=		Modifier_symbol}', "");
    Expect(0, 127999, '\P{General_Category=		Modifier_symbol}', "");
    Expect(1, 127999, '\P{^General_Category=		Modifier_symbol}', "");
    Expect(0, 128000, '\p{General_Category=		Modifier_symbol}', "");
    Expect(1, 128000, '\p{^General_Category=		Modifier_symbol}', "");
    Expect(1, 128000, '\P{General_Category=		Modifier_symbol}', "");
    Expect(0, 128000, '\P{^General_Category=		Modifier_symbol}', "");
    Error('\p{Gc:   -:=Sk}');
    Error('\P{Gc:   -:=Sk}');
    Expect(1, 127999, '\p{Gc=:\ASk\z:}', "");;
    Expect(0, 128000, '\p{Gc=:\ASk\z:}', "");;
    Expect(1, 127999, '\p{Gc:   sk}', "");
    Expect(0, 127999, '\p{^Gc:   sk}', "");
    Expect(0, 127999, '\P{Gc:   sk}', "");
    Expect(1, 127999, '\P{^Gc:   sk}', "");
    Expect(0, 128000, '\p{Gc:   sk}', "");
    Expect(1, 128000, '\p{^Gc:   sk}', "");
    Expect(1, 128000, '\P{Gc:   sk}', "");
    Expect(0, 128000, '\P{^Gc:   sk}', "");
    Expect(1, 127999, '\p{Gc=:\Ask\z:}', "");;
    Expect(0, 128000, '\p{Gc=:\Ask\z:}', "");;
    Expect(1, 127999, '\p{Gc:   -_Sk}', "");
    Expect(0, 127999, '\p{^Gc:   -_Sk}', "");
    Expect(0, 127999, '\P{Gc:   -_Sk}', "");
    Expect(1, 127999, '\P{^Gc:   -_Sk}', "");
    Expect(0, 128000, '\p{Gc:   -_Sk}', "");
    Expect(1, 128000, '\p{^Gc:   -_Sk}', "");
    Expect(1, 128000, '\P{Gc:   -_Sk}', "");
    Expect(0, 128000, '\P{^Gc:   -_Sk}', "");
    Error('\p{Category= modifier_Symbol/a/}');
    Error('\P{Category= modifier_Symbol/a/}');
    Expect(1, 127999, '\p{Category=:\AModifier_Symbol\z:}', "");;
    Expect(0, 128000, '\p{Category=:\AModifier_Symbol\z:}', "");;
    Expect(1, 127999, '\p{Category:	modifiersymbol}', "");
    Expect(0, 127999, '\p{^Category:	modifiersymbol}', "");
    Expect(0, 127999, '\P{Category:	modifiersymbol}', "");
    Expect(1, 127999, '\P{^Category:	modifiersymbol}', "");
    Expect(0, 128000, '\p{Category:	modifiersymbol}', "");
    Expect(1, 128000, '\p{^Category:	modifiersymbol}', "");
    Expect(1, 128000, '\P{Category:	modifiersymbol}', "");
    Expect(0, 128000, '\P{^Category:	modifiersymbol}', "");
    Expect(1, 127999, '\p{Category=:\Amodifiersymbol\z:}', "");;
    Expect(0, 128000, '\p{Category=:\Amodifiersymbol\z:}', "");;
    Expect(1, 127999, '\p{Category=_-modifier_Symbol}', "");
    Expect(0, 127999, '\p{^Category=_-modifier_Symbol}', "");
    Expect(0, 127999, '\P{Category=_-modifier_Symbol}', "");
    Expect(1, 127999, '\P{^Category=_-modifier_Symbol}', "");
    Expect(0, 128000, '\p{Category=_-modifier_Symbol}', "");
    Expect(1, 128000, '\p{^Category=_-modifier_Symbol}', "");
    Expect(1, 128000, '\P{Category=_-modifier_Symbol}', "");
    Expect(0, 128000, '\P{^Category=_-modifier_Symbol}', "");
    Error('\p{Is_General_Category=/a/ Sk}');
    Error('\P{Is_General_Category=/a/ Sk}');
    Expect(1, 127999, '\p{Is_General_Category=sk}', "");
    Expect(0, 127999, '\p{^Is_General_Category=sk}', "");
    Expect(0, 127999, '\P{Is_General_Category=sk}', "");
    Expect(1, 127999, '\P{^Is_General_Category=sk}', "");
    Expect(0, 128000, '\p{Is_General_Category=sk}', "");
    Expect(1, 128000, '\p{^Is_General_Category=sk}', "");
    Expect(1, 128000, '\P{Is_General_Category=sk}', "");
    Expect(0, 128000, '\P{^Is_General_Category=sk}', "");
    Expect(1, 127999, '\p{Is_General_Category= -SK}', "");
    Expect(0, 127999, '\p{^Is_General_Category= -SK}', "");
    Expect(0, 127999, '\P{Is_General_Category= -SK}', "");
    Expect(1, 127999, '\P{^Is_General_Category= -SK}', "");
    Expect(0, 128000, '\p{Is_General_Category= -SK}', "");
    Expect(1, 128000, '\p{^Is_General_Category= -SK}', "");
    Expect(1, 128000, '\P{Is_General_Category= -SK}', "");
    Expect(0, 128000, '\P{^Is_General_Category= -SK}', "");
    Error('\p{Is_Gc=_/a/MODIFIER_Symbol}');
    Error('\P{Is_Gc=_/a/MODIFIER_Symbol}');
    Expect(1, 127999, '\p{Is_Gc=modifiersymbol}', "");
    Expect(0, 127999, '\p{^Is_Gc=modifiersymbol}', "");
    Expect(0, 127999, '\P{Is_Gc=modifiersymbol}', "");
    Expect(1, 127999, '\P{^Is_Gc=modifiersymbol}', "");
    Expect(0, 128000, '\p{Is_Gc=modifiersymbol}', "");
    Expect(1, 128000, '\p{^Is_Gc=modifiersymbol}', "");
    Expect(1, 128000, '\P{Is_Gc=modifiersymbol}', "");
    Expect(0, 128000, '\P{^Is_Gc=modifiersymbol}', "");
    Expect(1, 127999, '\p{Is_Gc=-modifier_SYMBOL}', "");
    Expect(0, 127999, '\p{^Is_Gc=-modifier_SYMBOL}', "");
    Expect(0, 127999, '\P{Is_Gc=-modifier_SYMBOL}', "");
    Expect(1, 127999, '\P{^Is_Gc=-modifier_SYMBOL}', "");
    Expect(0, 128000, '\p{Is_Gc=-modifier_SYMBOL}', "");
    Expect(1, 128000, '\p{^Is_Gc=-modifier_SYMBOL}', "");
    Expect(1, 128000, '\P{Is_Gc=-modifier_SYMBOL}', "");
    Expect(0, 128000, '\P{^Is_Gc=-modifier_SYMBOL}', "");
    Error('\p{Is_Category=/a/	sk}');
    Error('\P{Is_Category=/a/	sk}');
    Expect(1, 127999, '\p{Is_Category:sk}', "");
    Expect(0, 127999, '\p{^Is_Category:sk}', "");
    Expect(0, 127999, '\P{Is_Category:sk}', "");
    Expect(1, 127999, '\P{^Is_Category:sk}', "");
    Expect(0, 128000, '\p{Is_Category:sk}', "");
    Expect(1, 128000, '\p{^Is_Category:sk}', "");
    Expect(1, 128000, '\P{Is_Category:sk}', "");
    Expect(0, 128000, '\P{^Is_Category:sk}', "");
    Expect(1, 127999, '\p{Is_Category: 	 Sk}', "");
    Expect(0, 127999, '\p{^Is_Category: 	 Sk}', "");
    Expect(0, 127999, '\P{Is_Category: 	 Sk}', "");
    Expect(1, 127999, '\P{^Is_Category: 	 Sk}', "");
    Expect(0, 128000, '\p{Is_Category: 	 Sk}', "");
    Expect(1, 128000, '\p{^Is_Category: 	 Sk}', "");
    Expect(1, 128000, '\P{Is_Category: 	 Sk}', "");
    Expect(0, 128000, '\P{^Is_Category: 	 Sk}', "");
    Error('\p{General_Category=	_Math_Symbol:=}');
    Error('\P{General_Category=	_Math_Symbol:=}');
    Expect(1, 126705, '\p{General_Category=:\AMath_Symbol\z:}', "");;
    Expect(0, 126706, '\p{General_Category=:\AMath_Symbol\z:}', "");;
    Expect(1, 126705, '\p{General_Category=mathsymbol}', "");
    Expect(0, 126705, '\p{^General_Category=mathsymbol}', "");
    Expect(0, 126705, '\P{General_Category=mathsymbol}', "");
    Expect(1, 126705, '\P{^General_Category=mathsymbol}', "");
    Expect(0, 126706, '\p{General_Category=mathsymbol}', "");
    Expect(1, 126706, '\p{^General_Category=mathsymbol}', "");
    Expect(1, 126706, '\P{General_Category=mathsymbol}', "");
    Expect(0, 126706, '\P{^General_Category=mathsymbol}', "");
    Expect(1, 126705, '\p{General_Category=:\Amathsymbol\z:}', "");;
    Expect(0, 126706, '\p{General_Category=:\Amathsymbol\z:}', "");;
    Expect(1, 126705, '\p{General_Category=-_math_SYMBOL}', "");
    Expect(0, 126705, '\p{^General_Category=-_math_SYMBOL}', "");
    Expect(0, 126705, '\P{General_Category=-_math_SYMBOL}', "");
    Expect(1, 126705, '\P{^General_Category=-_math_SYMBOL}', "");
    Expect(0, 126706, '\p{General_Category=-_math_SYMBOL}', "");
    Expect(1, 126706, '\p{^General_Category=-_math_SYMBOL}', "");
    Expect(1, 126706, '\P{General_Category=-_math_SYMBOL}', "");
    Expect(0, 126706, '\P{^General_Category=-_math_SYMBOL}', "");
    Error('\p{Gc=-SM/a/}');
    Error('\P{Gc=-SM/a/}');
    Expect(1, 126705, '\p{Gc=:\ASm\z:}', "");;
    Expect(0, 126706, '\p{Gc=:\ASm\z:}', "");;
    Expect(1, 126705, '\p{Gc=sm}', "");
    Expect(0, 126705, '\p{^Gc=sm}', "");
    Expect(0, 126705, '\P{Gc=sm}', "");
    Expect(1, 126705, '\P{^Gc=sm}', "");
    Expect(0, 126706, '\p{Gc=sm}', "");
    Expect(1, 126706, '\p{^Gc=sm}', "");
    Expect(1, 126706, '\P{Gc=sm}', "");
    Expect(0, 126706, '\P{^Gc=sm}', "");
    Expect(1, 126705, '\p{Gc=:\Asm\z:}', "");;
    Expect(0, 126706, '\p{Gc=:\Asm\z:}', "");;
    Expect(1, 126705, '\p{Gc=- Sm}', "");
    Expect(0, 126705, '\p{^Gc=- Sm}', "");
    Expect(0, 126705, '\P{Gc=- Sm}', "");
    Expect(1, 126705, '\P{^Gc=- Sm}', "");
    Expect(0, 126706, '\p{Gc=- Sm}', "");
    Expect(1, 126706, '\p{^Gc=- Sm}', "");
    Expect(1, 126706, '\P{Gc=- Sm}', "");
    Expect(0, 126706, '\P{^Gc=- Sm}', "");
    Error('\p{Category=:=		MATH_SYMBOL}');
    Error('\P{Category=:=		MATH_SYMBOL}');
    Expect(1, 126705, '\p{Category=:\AMath_Symbol\z:}', "");;
    Expect(0, 126706, '\p{Category=:\AMath_Symbol\z:}', "");;
    Expect(1, 126705, '\p{Category=mathsymbol}', "");
    Expect(0, 126705, '\p{^Category=mathsymbol}', "");
    Expect(0, 126705, '\P{Category=mathsymbol}', "");
    Expect(1, 126705, '\P{^Category=mathsymbol}', "");
    Expect(0, 126706, '\p{Category=mathsymbol}', "");
    Expect(1, 126706, '\p{^Category=mathsymbol}', "");
    Expect(1, 126706, '\P{Category=mathsymbol}', "");
    Expect(0, 126706, '\P{^Category=mathsymbol}', "");
    Expect(1, 126705, '\p{Category=:\Amathsymbol\z:}', "");;
    Expect(0, 126706, '\p{Category=:\Amathsymbol\z:}', "");;
    Expect(1, 126705, '\p{Category=  math_Symbol}', "");
    Expect(0, 126705, '\p{^Category=  math_Symbol}', "");
    Expect(0, 126705, '\P{Category=  math_Symbol}', "");
    Expect(1, 126705, '\P{^Category=  math_Symbol}', "");
    Expect(0, 126706, '\p{Category=  math_Symbol}', "");
    Expect(1, 126706, '\p{^Category=  math_Symbol}', "");
    Expect(1, 126706, '\P{Category=  math_Symbol}', "");
    Expect(0, 126706, '\P{^Category=  math_Symbol}', "");
    Error('\p{Is_General_Category=-_Sm:=}');
    Error('\P{Is_General_Category=-_Sm:=}');
    Expect(1, 126705, '\p{Is_General_Category=sm}', "");
    Expect(0, 126705, '\p{^Is_General_Category=sm}', "");
    Expect(0, 126705, '\P{Is_General_Category=sm}', "");
    Expect(1, 126705, '\P{^Is_General_Category=sm}', "");
    Expect(0, 126706, '\p{Is_General_Category=sm}', "");
    Expect(1, 126706, '\p{^Is_General_Category=sm}', "");
    Expect(1, 126706, '\P{Is_General_Category=sm}', "");
    Expect(0, 126706, '\P{^Is_General_Category=sm}', "");
    Expect(1, 126705, '\p{Is_General_Category=	_sm}', "");
    Expect(0, 126705, '\p{^Is_General_Category=	_sm}', "");
    Expect(0, 126705, '\P{Is_General_Category=	_sm}', "");
    Expect(1, 126705, '\P{^Is_General_Category=	_sm}', "");
    Expect(0, 126706, '\p{Is_General_Category=	_sm}', "");
    Expect(1, 126706, '\p{^Is_General_Category=	_sm}', "");
    Expect(1, 126706, '\P{Is_General_Category=	_sm}', "");
    Expect(0, 126706, '\P{^Is_General_Category=	_sm}', "");
    Error('\p{Is_Gc=	/a/math_Symbol}');
    Error('\P{Is_Gc=	/a/math_Symbol}');
    Expect(1, 126705, '\p{Is_Gc:	mathsymbol}', "");
    Expect(0, 126705, '\p{^Is_Gc:	mathsymbol}', "");
    Expect(0, 126705, '\P{Is_Gc:	mathsymbol}', "");
    Expect(1, 126705, '\P{^Is_Gc:	mathsymbol}', "");
    Expect(0, 126706, '\p{Is_Gc:	mathsymbol}', "");
    Expect(1, 126706, '\p{^Is_Gc:	mathsymbol}', "");
    Expect(1, 126706, '\P{Is_Gc:	mathsymbol}', "");
    Expect(0, 126706, '\P{^Is_Gc:	mathsymbol}', "");
    Expect(1, 126705, '\p{Is_Gc=	-math_Symbol}', "");
    Expect(0, 126705, '\p{^Is_Gc=	-math_Symbol}', "");
    Expect(0, 126705, '\P{Is_Gc=	-math_Symbol}', "");
    Expect(1, 126705, '\P{^Is_Gc=	-math_Symbol}', "");
    Expect(0, 126706, '\p{Is_Gc=	-math_Symbol}', "");
    Expect(1, 126706, '\p{^Is_Gc=	-math_Symbol}', "");
    Expect(1, 126706, '\P{Is_Gc=	-math_Symbol}', "");
    Expect(0, 126706, '\P{^Is_Gc=	-math_Symbol}', "");
    Error('\p{Is_Category= /a/SM}');
    Error('\P{Is_Category= /a/SM}');
    Expect(1, 126705, '\p{Is_Category:   sm}', "");
    Expect(0, 126705, '\p{^Is_Category:   sm}', "");
    Expect(0, 126705, '\P{Is_Category:   sm}', "");
    Expect(1, 126705, '\P{^Is_Category:   sm}', "");
    Expect(0, 126706, '\p{Is_Category:   sm}', "");
    Expect(1, 126706, '\p{^Is_Category:   sm}', "");
    Expect(1, 126706, '\P{Is_Category:   sm}', "");
    Expect(0, 126706, '\P{^Is_Category:   sm}', "");
    Expect(1, 126705, '\p{Is_Category=-sm}', "");
    Expect(0, 126705, '\p{^Is_Category=-sm}', "");
    Expect(0, 126705, '\P{Is_Category=-sm}', "");
    Expect(1, 126705, '\P{^Is_Category=-sm}', "");
    Expect(0, 126706, '\p{Is_Category=-sm}', "");
    Expect(1, 126706, '\p{^Is_Category=-sm}', "");
    Expect(1, 126706, '\P{Is_Category=-sm}', "");
    Expect(0, 126706, '\P{^Is_Category=-sm}', "");
    Error('\p{General_Category=:=	-other_symbol}');
    Error('\P{General_Category=:=	-other_symbol}');
    Expect(1, 129994, '\p{General_Category=:\AOther_Symbol\z:}', "");;
    Expect(0, 129995, '\p{General_Category=:\AOther_Symbol\z:}', "");;
    Expect(1, 129994, '\p{General_Category=othersymbol}', "");
    Expect(0, 129994, '\p{^General_Category=othersymbol}', "");
    Expect(0, 129994, '\P{General_Category=othersymbol}', "");
    Expect(1, 129994, '\P{^General_Category=othersymbol}', "");
    Expect(0, 129995, '\p{General_Category=othersymbol}', "");
    Expect(1, 129995, '\p{^General_Category=othersymbol}', "");
    Expect(1, 129995, '\P{General_Category=othersymbol}', "");
    Expect(0, 129995, '\P{^General_Category=othersymbol}', "");
    Expect(1, 129994, '\p{General_Category=:\Aothersymbol\z:}', "");;
    Expect(0, 129995, '\p{General_Category=:\Aothersymbol\z:}', "");;
    Expect(1, 129994, '\p{General_Category=- other_Symbol}', "");
    Expect(0, 129994, '\p{^General_Category=- other_Symbol}', "");
    Expect(0, 129994, '\P{General_Category=- other_Symbol}', "");
    Expect(1, 129994, '\P{^General_Category=- other_Symbol}', "");
    Expect(0, 129995, '\p{General_Category=- other_Symbol}', "");
    Expect(1, 129995, '\p{^General_Category=- other_Symbol}', "");
    Expect(1, 129995, '\P{General_Category=- other_Symbol}', "");
    Expect(0, 129995, '\P{^General_Category=- other_Symbol}', "");
    Error('\p{Gc=-/a/SO}');
    Error('\P{Gc=-/a/SO}');
    Expect(1, 129994, '\p{Gc=:\ASo\z:}', "");;
    Expect(0, 129995, '\p{Gc=:\ASo\z:}', "");;
    Expect(1, 129994, '\p{Gc=so}', "");
    Expect(0, 129994, '\p{^Gc=so}', "");
    Expect(0, 129994, '\P{Gc=so}', "");
    Expect(1, 129994, '\P{^Gc=so}', "");
    Expect(0, 129995, '\p{Gc=so}', "");
    Expect(1, 129995, '\p{^Gc=so}', "");
    Expect(1, 129995, '\P{Gc=so}', "");
    Expect(0, 129995, '\P{^Gc=so}', "");
    Expect(1, 129994, '\p{Gc=:\Aso\z:}', "");;
    Expect(0, 129995, '\p{Gc=:\Aso\z:}', "");;
    Expect(1, 129994, '\p{Gc=	SO}', "");
    Expect(0, 129994, '\p{^Gc=	SO}', "");
    Expect(0, 129994, '\P{Gc=	SO}', "");
    Expect(1, 129994, '\P{^Gc=	SO}', "");
    Expect(0, 129995, '\p{Gc=	SO}', "");
    Expect(1, 129995, '\p{^Gc=	SO}', "");
    Expect(1, 129995, '\P{Gc=	SO}', "");
    Expect(0, 129995, '\P{^Gc=	SO}', "");
    Error('\p{Category=:=	OTHER_symbol}');
    Error('\P{Category=:=	OTHER_symbol}');
    Expect(1, 129994, '\p{Category=:\AOther_Symbol\z:}', "");;
    Expect(0, 129995, '\p{Category=:\AOther_Symbol\z:}', "");;
    Expect(1, 129994, '\p{Category=othersymbol}', "");
    Expect(0, 129994, '\p{^Category=othersymbol}', "");
    Expect(0, 129994, '\P{Category=othersymbol}', "");
    Expect(1, 129994, '\P{^Category=othersymbol}', "");
    Expect(0, 129995, '\p{Category=othersymbol}', "");
    Expect(1, 129995, '\p{^Category=othersymbol}', "");
    Expect(1, 129995, '\P{Category=othersymbol}', "");
    Expect(0, 129995, '\P{^Category=othersymbol}', "");
    Expect(1, 129994, '\p{Category=:\Aothersymbol\z:}', "");;
    Expect(0, 129995, '\p{Category=:\Aothersymbol\z:}', "");;
    Expect(1, 129994, '\p{Category= Other_Symbol}', "");
    Expect(0, 129994, '\p{^Category= Other_Symbol}', "");
    Expect(0, 129994, '\P{Category= Other_Symbol}', "");
    Expect(1, 129994, '\P{^Category= Other_Symbol}', "");
    Expect(0, 129995, '\p{Category= Other_Symbol}', "");
    Expect(1, 129995, '\p{^Category= Other_Symbol}', "");
    Expect(1, 129995, '\P{Category= Other_Symbol}', "");
    Expect(0, 129995, '\P{^Category= Other_Symbol}', "");
    Error('\p{Is_General_Category=/a/So}');
    Error('\P{Is_General_Category=/a/So}');
    Expect(1, 129994, '\p{Is_General_Category=so}', "");
    Expect(0, 129994, '\p{^Is_General_Category=so}', "");
    Expect(0, 129994, '\P{Is_General_Category=so}', "");
    Expect(1, 129994, '\P{^Is_General_Category=so}', "");
    Expect(0, 129995, '\p{Is_General_Category=so}', "");
    Expect(1, 129995, '\p{^Is_General_Category=so}', "");
    Expect(1, 129995, '\P{Is_General_Category=so}', "");
    Expect(0, 129995, '\P{^Is_General_Category=so}', "");
    Expect(1, 129994, '\p{Is_General_Category:    	SO}', "");
    Expect(0, 129994, '\p{^Is_General_Category:    	SO}', "");
    Expect(0, 129994, '\P{Is_General_Category:    	SO}', "");
    Expect(1, 129994, '\P{^Is_General_Category:    	SO}', "");
    Expect(0, 129995, '\p{Is_General_Category:    	SO}', "");
    Expect(1, 129995, '\p{^Is_General_Category:    	SO}', "");
    Expect(1, 129995, '\P{Is_General_Category:    	SO}', "");
    Expect(0, 129995, '\P{^Is_General_Category:    	SO}', "");
    Error('\p{Is_Gc=:=_OTHER_SYMBOL}');
    Error('\P{Is_Gc=:=_OTHER_SYMBOL}');
    Expect(1, 129994, '\p{Is_Gc=othersymbol}', "");
    Expect(0, 129994, '\p{^Is_Gc=othersymbol}', "");
    Expect(0, 129994, '\P{Is_Gc=othersymbol}', "");
    Expect(1, 129994, '\P{^Is_Gc=othersymbol}', "");
    Expect(0, 129995, '\p{Is_Gc=othersymbol}', "");
    Expect(1, 129995, '\p{^Is_Gc=othersymbol}', "");
    Expect(1, 129995, '\P{Is_Gc=othersymbol}', "");
    Expect(0, 129995, '\P{^Is_Gc=othersymbol}', "");
    Expect(1, 129994, '\p{Is_Gc=	-Other_Symbol}', "");
    Expect(0, 129994, '\p{^Is_Gc=	-Other_Symbol}', "");
    Expect(0, 129994, '\P{Is_Gc=	-Other_Symbol}', "");
    Expect(1, 129994, '\P{^Is_Gc=	-Other_Symbol}', "");
    Expect(0, 129995, '\p{Is_Gc=	-Other_Symbol}', "");
    Expect(1, 129995, '\p{^Is_Gc=	-Other_Symbol}', "");
    Expect(1, 129995, '\P{Is_Gc=	-Other_Symbol}', "");
    Expect(0, 129995, '\P{^Is_Gc=	-Other_Symbol}', "");
    Error('\p{Is_Category=/a/	-so}');
    Error('\P{Is_Category=/a/	-so}');
    Expect(1, 129994, '\p{Is_Category=so}', "");
    Expect(0, 129994, '\p{^Is_Category=so}', "");
    Expect(0, 129994, '\P{Is_Category=so}', "");
    Expect(1, 129994, '\P{^Is_Category=so}', "");
    Expect(0, 129995, '\p{Is_Category=so}', "");
    Expect(1, 129995, '\p{^Is_Category=so}', "");
    Expect(1, 129995, '\P{Is_Category=so}', "");
    Expect(0, 129995, '\P{^Is_Category=so}', "");
    Expect(1, 129994, '\p{Is_Category=_	so}', "");
    Expect(0, 129994, '\p{^Is_Category=_	so}', "");
    Expect(0, 129994, '\P{Is_Category=_	so}', "");
    Expect(1, 129994, '\P{^Is_Category=_	so}', "");
    Expect(0, 129995, '\p{Is_Category=_	so}', "");
    Expect(1, 129995, '\p{^Is_Category=_	so}', "");
    Expect(1, 129995, '\P{Is_Category=_	so}', "");
    Expect(0, 129995, '\P{^Is_Category=_	so}', "");
    Error('\p{General_Category=_Separator/a/}');
    Error('\P{General_Category=_Separator/a/}');
    Expect(1, 12288, '\p{General_Category=:\ASeparator\z:}', "");;
    Expect(0, 12289, '\p{General_Category=:\ASeparator\z:}', "");;
    Expect(1, 12288, '\p{General_Category=separator}', "");
    Expect(0, 12288, '\p{^General_Category=separator}', "");
    Expect(0, 12288, '\P{General_Category=separator}', "");
    Expect(1, 12288, '\P{^General_Category=separator}', "");
    Expect(0, 12289, '\p{General_Category=separator}', "");
    Expect(1, 12289, '\p{^General_Category=separator}', "");
    Expect(1, 12289, '\P{General_Category=separator}', "");
    Expect(0, 12289, '\P{^General_Category=separator}', "");
    Expect(1, 12288, '\p{General_Category=:\Aseparator\z:}', "");;
    Expect(0, 12289, '\p{General_Category=:\Aseparator\z:}', "");;
    Expect(1, 12288, '\p{General_Category=- SEPARATOR}', "");
    Expect(0, 12288, '\p{^General_Category=- SEPARATOR}', "");
    Expect(0, 12288, '\P{General_Category=- SEPARATOR}', "");
    Expect(1, 12288, '\P{^General_Category=- SEPARATOR}', "");
    Expect(0, 12289, '\p{General_Category=- SEPARATOR}', "");
    Expect(1, 12289, '\p{^General_Category=- SEPARATOR}', "");
    Expect(1, 12289, '\P{General_Category=- SEPARATOR}', "");
    Expect(0, 12289, '\P{^General_Category=- SEPARATOR}', "");
    Error('\p{Gc:   :=z}');
    Error('\P{Gc:   :=z}');
    Expect(1, 12288, '\p{Gc=:\AZ\z:}', "");;
    Expect(0, 12289, '\p{Gc=:\AZ\z:}', "");;
    Expect(1, 12288, '\p{Gc=z}', "");
    Expect(0, 12288, '\p{^Gc=z}', "");
    Expect(0, 12288, '\P{Gc=z}', "");
    Expect(1, 12288, '\P{^Gc=z}', "");
    Expect(0, 12289, '\p{Gc=z}', "");
    Expect(1, 12289, '\p{^Gc=z}', "");
    Expect(1, 12289, '\P{Gc=z}', "");
    Expect(0, 12289, '\P{^Gc=z}', "");
    Expect(1, 12288, '\p{Gc=:\Az\z:}', "");;
    Expect(0, 12289, '\p{Gc=:\Az\z:}', "");;
    Expect(1, 12288, '\p{Gc=	 z}', "");
    Expect(0, 12288, '\p{^Gc=	 z}', "");
    Expect(0, 12288, '\P{Gc=	 z}', "");
    Expect(1, 12288, '\P{^Gc=	 z}', "");
    Expect(0, 12289, '\p{Gc=	 z}', "");
    Expect(1, 12289, '\p{^Gc=	 z}', "");
    Expect(1, 12289, '\P{Gc=	 z}', "");
    Expect(0, 12289, '\P{^Gc=	 z}', "");
    Error('\p{Category:   -Separator/a/}');
    Error('\P{Category:   -Separator/a/}');
    Expect(1, 12288, '\p{Category=:\ASeparator\z:}', "");;
    Expect(0, 12289, '\p{Category=:\ASeparator\z:}', "");;
    Expect(1, 12288, '\p{Category=separator}', "");
    Expect(0, 12288, '\p{^Category=separator}', "");
    Expect(0, 12288, '\P{Category=separator}', "");
    Expect(1, 12288, '\P{^Category=separator}', "");
    Expect(0, 12289, '\p{Category=separator}', "");
    Expect(1, 12289, '\p{^Category=separator}', "");
    Expect(1, 12289, '\P{Category=separator}', "");
    Expect(0, 12289, '\P{^Category=separator}', "");
    Expect(1, 12288, '\p{Category=:\Aseparator\z:}', "");;
    Expect(0, 12289, '\p{Category=:\Aseparator\z:}', "");;
    Expect(1, 12288, '\p{Category=	 SEPARATOR}', "");
    Expect(0, 12288, '\p{^Category=	 SEPARATOR}', "");
    Expect(0, 12288, '\P{Category=	 SEPARATOR}', "");
    Expect(1, 12288, '\P{^Category=	 SEPARATOR}', "");
    Expect(0, 12289, '\p{Category=	 SEPARATOR}', "");
    Expect(1, 12289, '\p{^Category=	 SEPARATOR}', "");
    Expect(1, 12289, '\P{Category=	 SEPARATOR}', "");
    Expect(0, 12289, '\P{^Category=	 SEPARATOR}', "");
    Error('\p{Is_General_Category:	/a/-	z}');
    Error('\P{Is_General_Category:	/a/-	z}');
    Expect(1, 12288, '\p{Is_General_Category=z}', "");
    Expect(0, 12288, '\p{^Is_General_Category=z}', "");
    Expect(0, 12288, '\P{Is_General_Category=z}', "");
    Expect(1, 12288, '\P{^Is_General_Category=z}', "");
    Expect(0, 12289, '\p{Is_General_Category=z}', "");
    Expect(1, 12289, '\p{^Is_General_Category=z}', "");
    Expect(1, 12289, '\P{Is_General_Category=z}', "");
    Expect(0, 12289, '\P{^Is_General_Category=z}', "");
    Expect(1, 12288, '\p{Is_General_Category=	-Z}', "");
    Expect(0, 12288, '\p{^Is_General_Category=	-Z}', "");
    Expect(0, 12288, '\P{Is_General_Category=	-Z}', "");
    Expect(1, 12288, '\P{^Is_General_Category=	-Z}', "");
    Expect(0, 12289, '\p{Is_General_Category=	-Z}', "");
    Expect(1, 12289, '\p{^Is_General_Category=	-Z}', "");
    Expect(1, 12289, '\P{Is_General_Category=	-Z}', "");
    Expect(0, 12289, '\P{^Is_General_Category=	-Z}', "");
    Error('\p{Is_Gc=_:=Separator}');
    Error('\P{Is_Gc=_:=Separator}');
    Expect(1, 12288, '\p{Is_Gc=separator}', "");
    Expect(0, 12288, '\p{^Is_Gc=separator}', "");
    Expect(0, 12288, '\P{Is_Gc=separator}', "");
    Expect(1, 12288, '\P{^Is_Gc=separator}', "");
    Expect(0, 12289, '\p{Is_Gc=separator}', "");
    Expect(1, 12289, '\p{^Is_Gc=separator}', "");
    Expect(1, 12289, '\P{Is_Gc=separator}', "");
    Expect(0, 12289, '\P{^Is_Gc=separator}', "");
    Expect(1, 12288, '\p{Is_Gc=	separator}', "");
    Expect(0, 12288, '\p{^Is_Gc=	separator}', "");
    Expect(0, 12288, '\P{Is_Gc=	separator}', "");
    Expect(1, 12288, '\P{^Is_Gc=	separator}', "");
    Expect(0, 12289, '\p{Is_Gc=	separator}', "");
    Expect(1, 12289, '\p{^Is_Gc=	separator}', "");
    Expect(1, 12289, '\P{Is_Gc=	separator}', "");
    Expect(0, 12289, '\P{^Is_Gc=	separator}', "");
    Error('\p{Is_Category:	 :=Z}');
    Error('\P{Is_Category:	 :=Z}');
    Expect(1, 12288, '\p{Is_Category=z}', "");
    Expect(0, 12288, '\p{^Is_Category=z}', "");
    Expect(0, 12288, '\P{Is_Category=z}', "");
    Expect(1, 12288, '\P{^Is_Category=z}', "");
    Expect(0, 12289, '\p{Is_Category=z}', "");
    Expect(1, 12289, '\p{^Is_Category=z}', "");
    Expect(1, 12289, '\P{Is_Category=z}', "");
    Expect(0, 12289, '\P{^Is_Category=z}', "");
    Expect(1, 12288, '\p{Is_Category=-	Z}', "");
    Expect(0, 12288, '\p{^Is_Category=-	Z}', "");
    Expect(0, 12288, '\P{Is_Category=-	Z}', "");
    Expect(1, 12288, '\P{^Is_Category=-	Z}', "");
    Expect(0, 12289, '\p{Is_Category=-	Z}', "");
    Expect(1, 12289, '\p{^Is_Category=-	Z}', "");
    Expect(1, 12289, '\P{Is_Category=-	Z}', "");
    Expect(0, 12289, '\P{^Is_Category=-	Z}', "");
    Error('\p{General_Category=_LINE_SEPARATOR:=}');
    Error('\P{General_Category=_LINE_SEPARATOR:=}');
    Expect(1, 8232, '\p{General_Category=:\ALine_Separator\z:}', "");;
    Expect(0, 8233, '\p{General_Category=:\ALine_Separator\z:}', "");;
    Expect(1, 8232, '\p{General_Category=lineseparator}', "");
    Expect(0, 8232, '\p{^General_Category=lineseparator}', "");
    Expect(0, 8232, '\P{General_Category=lineseparator}', "");
    Expect(1, 8232, '\P{^General_Category=lineseparator}', "");
    Expect(0, 8233, '\p{General_Category=lineseparator}', "");
    Expect(1, 8233, '\p{^General_Category=lineseparator}', "");
    Expect(1, 8233, '\P{General_Category=lineseparator}', "");
    Expect(0, 8233, '\P{^General_Category=lineseparator}', "");
    Expect(1, 8232, '\p{General_Category=:\Alineseparator\z:}', "");;
    Expect(0, 8233, '\p{General_Category=:\Alineseparator\z:}', "");;
    Expect(1, 8232, '\p{General_Category=	_LINE_Separator}', "");
    Expect(0, 8232, '\p{^General_Category=	_LINE_Separator}', "");
    Expect(0, 8232, '\P{General_Category=	_LINE_Separator}', "");
    Expect(1, 8232, '\P{^General_Category=	_LINE_Separator}', "");
    Expect(0, 8233, '\p{General_Category=	_LINE_Separator}', "");
    Expect(1, 8233, '\p{^General_Category=	_LINE_Separator}', "");
    Expect(1, 8233, '\P{General_Category=	_LINE_Separator}', "");
    Expect(0, 8233, '\P{^General_Category=	_LINE_Separator}', "");
    Error('\p{Gc=-	Zl/a/}');
    Error('\P{Gc=-	Zl/a/}');
    Expect(1, 8232, '\p{Gc=:\AZl\z:}', "");;
    Expect(0, 8233, '\p{Gc=:\AZl\z:}', "");;
    Expect(1, 8232, '\p{Gc=zl}', "");
    Expect(0, 8232, '\p{^Gc=zl}', "");
    Expect(0, 8232, '\P{Gc=zl}', "");
    Expect(1, 8232, '\P{^Gc=zl}', "");
    Expect(0, 8233, '\p{Gc=zl}', "");
    Expect(1, 8233, '\p{^Gc=zl}', "");
    Expect(1, 8233, '\P{Gc=zl}', "");
    Expect(0, 8233, '\P{^Gc=zl}', "");
    Expect(1, 8232, '\p{Gc=:\Azl\z:}', "");;
    Expect(0, 8233, '\p{Gc=:\Azl\z:}', "");;
    Expect(1, 8232, '\p{Gc=-_Zl}', "");
    Expect(0, 8232, '\p{^Gc=-_Zl}', "");
    Expect(0, 8232, '\P{Gc=-_Zl}', "");
    Expect(1, 8232, '\P{^Gc=-_Zl}', "");
    Expect(0, 8233, '\p{Gc=-_Zl}', "");
    Expect(1, 8233, '\p{^Gc=-_Zl}', "");
    Expect(1, 8233, '\P{Gc=-_Zl}', "");
    Expect(0, 8233, '\P{^Gc=-_Zl}', "");
    Error('\p{Category=	-line_SEPARATOR/a/}');
    Error('\P{Category=	-line_SEPARATOR/a/}');
    Expect(1, 8232, '\p{Category=:\ALine_Separator\z:}', "");;
    Expect(0, 8233, '\p{Category=:\ALine_Separator\z:}', "");;
    Expect(1, 8232, '\p{Category=lineseparator}', "");
    Expect(0, 8232, '\p{^Category=lineseparator}', "");
    Expect(0, 8232, '\P{Category=lineseparator}', "");
    Expect(1, 8232, '\P{^Category=lineseparator}', "");
    Expect(0, 8233, '\p{Category=lineseparator}', "");
    Expect(1, 8233, '\p{^Category=lineseparator}', "");
    Expect(1, 8233, '\P{Category=lineseparator}', "");
    Expect(0, 8233, '\P{^Category=lineseparator}', "");
    Expect(1, 8232, '\p{Category=:\Alineseparator\z:}', "");;
    Expect(0, 8233, '\p{Category=:\Alineseparator\z:}', "");;
    Expect(1, 8232, '\p{Category=_LINE_Separator}', "");
    Expect(0, 8232, '\p{^Category=_LINE_Separator}', "");
    Expect(0, 8232, '\P{Category=_LINE_Separator}', "");
    Expect(1, 8232, '\P{^Category=_LINE_Separator}', "");
    Expect(0, 8233, '\p{Category=_LINE_Separator}', "");
    Expect(1, 8233, '\p{^Category=_LINE_Separator}', "");
    Expect(1, 8233, '\P{Category=_LINE_Separator}', "");
    Expect(0, 8233, '\P{^Category=_LINE_Separator}', "");
    Error('\p{Is_General_Category=:=-Zl}');
    Error('\P{Is_General_Category=:=-Zl}');
    Expect(1, 8232, '\p{Is_General_Category:	zl}', "");
    Expect(0, 8232, '\p{^Is_General_Category:	zl}', "");
    Expect(0, 8232, '\P{Is_General_Category:	zl}', "");
    Expect(1, 8232, '\P{^Is_General_Category:	zl}', "");
    Expect(0, 8233, '\p{Is_General_Category:	zl}', "");
    Expect(1, 8233, '\p{^Is_General_Category:	zl}', "");
    Expect(1, 8233, '\P{Is_General_Category:	zl}', "");
    Expect(0, 8233, '\P{^Is_General_Category:	zl}', "");
    Expect(1, 8232, '\p{Is_General_Category=-_Zl}', "");
    Expect(0, 8232, '\p{^Is_General_Category=-_Zl}', "");
    Expect(0, 8232, '\P{Is_General_Category=-_Zl}', "");
    Expect(1, 8232, '\P{^Is_General_Category=-_Zl}', "");
    Expect(0, 8233, '\p{Is_General_Category=-_Zl}', "");
    Expect(1, 8233, '\p{^Is_General_Category=-_Zl}', "");
    Expect(1, 8233, '\P{Is_General_Category=-_Zl}', "");
    Expect(0, 8233, '\P{^Is_General_Category=-_Zl}', "");
    Error('\p{Is_Gc=_LINE_separator:=}');
    Error('\P{Is_Gc=_LINE_separator:=}');
    Expect(1, 8232, '\p{Is_Gc=lineseparator}', "");
    Expect(0, 8232, '\p{^Is_Gc=lineseparator}', "");
    Expect(0, 8232, '\P{Is_Gc=lineseparator}', "");
    Expect(1, 8232, '\P{^Is_Gc=lineseparator}', "");
    Expect(0, 8233, '\p{Is_Gc=lineseparator}', "");
    Expect(1, 8233, '\p{^Is_Gc=lineseparator}', "");
    Expect(1, 8233, '\P{Is_Gc=lineseparator}', "");
    Expect(0, 8233, '\P{^Is_Gc=lineseparator}', "");
    Expect(1, 8232, '\p{Is_Gc=-_Line_Separator}', "");
    Expect(0, 8232, '\p{^Is_Gc=-_Line_Separator}', "");
    Expect(0, 8232, '\P{Is_Gc=-_Line_Separator}', "");
    Expect(1, 8232, '\P{^Is_Gc=-_Line_Separator}', "");
    Expect(0, 8233, '\p{Is_Gc=-_Line_Separator}', "");
    Expect(1, 8233, '\p{^Is_Gc=-_Line_Separator}', "");
    Expect(1, 8233, '\P{Is_Gc=-_Line_Separator}', "");
    Expect(0, 8233, '\P{^Is_Gc=-_Line_Separator}', "");
    Error('\p{Is_Category=	_Zl/a/}');
    Error('\P{Is_Category=	_Zl/a/}');
    Expect(1, 8232, '\p{Is_Category=zl}', "");
    Expect(0, 8232, '\p{^Is_Category=zl}', "");
    Expect(0, 8232, '\P{Is_Category=zl}', "");
    Expect(1, 8232, '\P{^Is_Category=zl}', "");
    Expect(0, 8233, '\p{Is_Category=zl}', "");
    Expect(1, 8233, '\p{^Is_Category=zl}', "");
    Expect(1, 8233, '\P{Is_Category=zl}', "");
    Expect(0, 8233, '\P{^Is_Category=zl}', "");
    Expect(1, 8232, '\p{Is_Category=	_Zl}', "");
    Expect(0, 8232, '\p{^Is_Category=	_Zl}', "");
    Expect(0, 8232, '\P{Is_Category=	_Zl}', "");
    Expect(1, 8232, '\P{^Is_Category=	_Zl}', "");
    Expect(0, 8233, '\p{Is_Category=	_Zl}', "");
    Expect(1, 8233, '\p{^Is_Category=	_Zl}', "");
    Expect(1, 8233, '\P{Is_Category=	_Zl}', "");
    Expect(0, 8233, '\P{^Is_Category=	_Zl}', "");
    Error('\p{General_Category=	/a/Paragraph_Separator}');
    Error('\P{General_Category=	/a/Paragraph_Separator}');
    Expect(1, 8233, '\p{General_Category=:\AParagraph_Separator\z:}', "");;
    Expect(0, 8234, '\p{General_Category=:\AParagraph_Separator\z:}', "");;
    Expect(1, 8233, '\p{General_Category=paragraphseparator}', "");
    Expect(0, 8233, '\p{^General_Category=paragraphseparator}', "");
    Expect(0, 8233, '\P{General_Category=paragraphseparator}', "");
    Expect(1, 8233, '\P{^General_Category=paragraphseparator}', "");
    Expect(0, 8234, '\p{General_Category=paragraphseparator}', "");
    Expect(1, 8234, '\p{^General_Category=paragraphseparator}', "");
    Expect(1, 8234, '\P{General_Category=paragraphseparator}', "");
    Expect(0, 8234, '\P{^General_Category=paragraphseparator}', "");
    Expect(1, 8233, '\p{General_Category=:\Aparagraphseparator\z:}', "");;
    Expect(0, 8234, '\p{General_Category=:\Aparagraphseparator\z:}', "");;
    Expect(1, 8233, '\p{General_Category=_ Paragraph_separator}', "");
    Expect(0, 8233, '\p{^General_Category=_ Paragraph_separator}', "");
    Expect(0, 8233, '\P{General_Category=_ Paragraph_separator}', "");
    Expect(1, 8233, '\P{^General_Category=_ Paragraph_separator}', "");
    Expect(0, 8234, '\p{General_Category=_ Paragraph_separator}', "");
    Expect(1, 8234, '\p{^General_Category=_ Paragraph_separator}', "");
    Expect(1, 8234, '\P{General_Category=_ Paragraph_separator}', "");
    Expect(0, 8234, '\P{^General_Category=_ Paragraph_separator}', "");
    Error('\p{Gc=/a/_Zp}');
    Error('\P{Gc=/a/_Zp}');
    Expect(1, 8233, '\p{Gc=:\AZp\z:}', "");;
    Expect(0, 8234, '\p{Gc=:\AZp\z:}', "");;
    Expect(1, 8233, '\p{Gc=zp}', "");
    Expect(0, 8233, '\p{^Gc=zp}', "");
    Expect(0, 8233, '\P{Gc=zp}', "");
    Expect(1, 8233, '\P{^Gc=zp}', "");
    Expect(0, 8234, '\p{Gc=zp}', "");
    Expect(1, 8234, '\p{^Gc=zp}', "");
    Expect(1, 8234, '\P{Gc=zp}', "");
    Expect(0, 8234, '\P{^Gc=zp}', "");
    Expect(1, 8233, '\p{Gc=:\Azp\z:}', "");;
    Expect(0, 8234, '\p{Gc=:\Azp\z:}', "");;
    Expect(1, 8233, '\p{Gc=	 ZP}', "");
    Expect(0, 8233, '\p{^Gc=	 ZP}', "");
    Expect(0, 8233, '\P{Gc=	 ZP}', "");
    Expect(1, 8233, '\P{^Gc=	 ZP}', "");
    Expect(0, 8234, '\p{Gc=	 ZP}', "");
    Expect(1, 8234, '\p{^Gc=	 ZP}', "");
    Expect(1, 8234, '\P{Gc=	 ZP}', "");
    Expect(0, 8234, '\P{^Gc=	 ZP}', "");
    Error('\p{Category=:= 	paragraph_separator}');
    Error('\P{Category=:= 	paragraph_separator}');
    Expect(1, 8233, '\p{Category=:\AParagraph_Separator\z:}', "");;
    Expect(0, 8234, '\p{Category=:\AParagraph_Separator\z:}', "");;
    Expect(1, 8233, '\p{Category=paragraphseparator}', "");
    Expect(0, 8233, '\p{^Category=paragraphseparator}', "");
    Expect(0, 8233, '\P{Category=paragraphseparator}', "");
    Expect(1, 8233, '\P{^Category=paragraphseparator}', "");
    Expect(0, 8234, '\p{Category=paragraphseparator}', "");
    Expect(1, 8234, '\p{^Category=paragraphseparator}', "");
    Expect(1, 8234, '\P{Category=paragraphseparator}', "");
    Expect(0, 8234, '\P{^Category=paragraphseparator}', "");
    Expect(1, 8233, '\p{Category=:\Aparagraphseparator\z:}', "");;
    Expect(0, 8234, '\p{Category=:\Aparagraphseparator\z:}', "");;
    Expect(1, 8233, '\p{Category=  PARAGRAPH_Separator}', "");
    Expect(0, 8233, '\p{^Category=  PARAGRAPH_Separator}', "");
    Expect(0, 8233, '\P{Category=  PARAGRAPH_Separator}', "");
    Expect(1, 8233, '\P{^Category=  PARAGRAPH_Separator}', "");
    Expect(0, 8234, '\p{Category=  PARAGRAPH_Separator}', "");
    Expect(1, 8234, '\p{^Category=  PARAGRAPH_Separator}', "");
    Expect(1, 8234, '\P{Category=  PARAGRAPH_Separator}', "");
    Expect(0, 8234, '\P{^Category=  PARAGRAPH_Separator}', "");
    Error('\p{Is_General_Category:	/a/ -ZP}');
    Error('\P{Is_General_Category:	/a/ -ZP}');
    Expect(1, 8233, '\p{Is_General_Category:zp}', "");
    Expect(0, 8233, '\p{^Is_General_Category:zp}', "");
    Expect(0, 8233, '\P{Is_General_Category:zp}', "");
    Expect(1, 8233, '\P{^Is_General_Category:zp}', "");
    Expect(0, 8234, '\p{Is_General_Category:zp}', "");
    Expect(1, 8234, '\p{^Is_General_Category:zp}', "");
    Expect(1, 8234, '\P{Is_General_Category:zp}', "");
    Expect(0, 8234, '\P{^Is_General_Category:zp}', "");
    Expect(1, 8233, '\p{Is_General_Category=--zp}', "");
    Expect(0, 8233, '\p{^Is_General_Category=--zp}', "");
    Expect(0, 8233, '\P{Is_General_Category=--zp}', "");
    Expect(1, 8233, '\P{^Is_General_Category=--zp}', "");
    Expect(0, 8234, '\p{Is_General_Category=--zp}', "");
    Expect(1, 8234, '\p{^Is_General_Category=--zp}', "");
    Expect(1, 8234, '\P{Is_General_Category=--zp}', "");
    Expect(0, 8234, '\P{^Is_General_Category=--zp}', "");
    Error('\p{Is_Gc= :=PARAGRAPH_Separator}');
    Error('\P{Is_Gc= :=PARAGRAPH_Separator}');
    Expect(1, 8233, '\p{Is_Gc=paragraphseparator}', "");
    Expect(0, 8233, '\p{^Is_Gc=paragraphseparator}', "");
    Expect(0, 8233, '\P{Is_Gc=paragraphseparator}', "");
    Expect(1, 8233, '\P{^Is_Gc=paragraphseparator}', "");
    Expect(0, 8234, '\p{Is_Gc=paragraphseparator}', "");
    Expect(1, 8234, '\p{^Is_Gc=paragraphseparator}', "");
    Expect(1, 8234, '\P{Is_Gc=paragraphseparator}', "");
    Expect(0, 8234, '\P{^Is_Gc=paragraphseparator}', "");
    Expect(1, 8233, '\p{Is_Gc=--paragraph_Separator}', "");
    Expect(0, 8233, '\p{^Is_Gc=--paragraph_Separator}', "");
    Expect(0, 8233, '\P{Is_Gc=--paragraph_Separator}', "");
    Expect(1, 8233, '\P{^Is_Gc=--paragraph_Separator}', "");
    Expect(0, 8234, '\p{Is_Gc=--paragraph_Separator}', "");
    Expect(1, 8234, '\p{^Is_Gc=--paragraph_Separator}', "");
    Expect(1, 8234, '\P{Is_Gc=--paragraph_Separator}', "");
    Expect(0, 8234, '\P{^Is_Gc=--paragraph_Separator}', "");
    Error('\p{Is_Category=/a/--zp}');
    Error('\P{Is_Category=/a/--zp}');
    Expect(1, 8233, '\p{Is_Category=zp}', "");
    Expect(0, 8233, '\p{^Is_Category=zp}', "");
    Expect(0, 8233, '\P{Is_Category=zp}', "");
    Expect(1, 8233, '\P{^Is_Category=zp}', "");
    Expect(0, 8234, '\p{Is_Category=zp}', "");
    Expect(1, 8234, '\p{^Is_Category=zp}', "");
    Expect(1, 8234, '\P{Is_Category=zp}', "");
    Expect(0, 8234, '\P{^Is_Category=zp}', "");
    Expect(1, 8233, '\p{Is_Category= Zp}', "");
    Expect(0, 8233, '\p{^Is_Category= Zp}', "");
    Expect(0, 8233, '\P{Is_Category= Zp}', "");
    Expect(1, 8233, '\P{^Is_Category= Zp}', "");
    Expect(0, 8234, '\p{Is_Category= Zp}', "");
    Expect(1, 8234, '\p{^Is_Category= Zp}', "");
    Expect(1, 8234, '\P{Is_Category= Zp}', "");
    Expect(0, 8234, '\P{^Is_Category= Zp}', "");
    Error('\p{General_Category=:=	 space_Separator}');
    Error('\P{General_Category=:=	 space_Separator}');
    Expect(1, 12288, '\p{General_Category=:\ASpace_Separator\z:}', "");;
    Expect(0, 12289, '\p{General_Category=:\ASpace_Separator\z:}', "");;
    Expect(1, 12288, '\p{General_Category:spaceseparator}', "");
    Expect(0, 12288, '\p{^General_Category:spaceseparator}', "");
    Expect(0, 12288, '\P{General_Category:spaceseparator}', "");
    Expect(1, 12288, '\P{^General_Category:spaceseparator}', "");
    Expect(0, 12289, '\p{General_Category:spaceseparator}', "");
    Expect(1, 12289, '\p{^General_Category:spaceseparator}', "");
    Expect(1, 12289, '\P{General_Category:spaceseparator}', "");
    Expect(0, 12289, '\P{^General_Category:spaceseparator}', "");
    Expect(1, 12288, '\p{General_Category=:\Aspaceseparator\z:}', "");;
    Expect(0, 12289, '\p{General_Category=:\Aspaceseparator\z:}', "");;
    Expect(1, 12288, '\p{General_Category= -space_separator}', "");
    Expect(0, 12288, '\p{^General_Category= -space_separator}', "");
    Expect(0, 12288, '\P{General_Category= -space_separator}', "");
    Expect(1, 12288, '\P{^General_Category= -space_separator}', "");
    Expect(0, 12289, '\p{General_Category= -space_separator}', "");
    Expect(1, 12289, '\p{^General_Category= -space_separator}', "");
    Expect(1, 12289, '\P{General_Category= -space_separator}', "");
    Expect(0, 12289, '\P{^General_Category= -space_separator}', "");
    Error('\p{Gc=:=-Zs}');
    Error('\P{Gc=:=-Zs}');
    Expect(1, 12288, '\p{Gc=:\AZs\z:}', "");;
    Expect(0, 12289, '\p{Gc=:\AZs\z:}', "");;
    Expect(1, 12288, '\p{Gc=zs}', "");
    Expect(0, 12288, '\p{^Gc=zs}', "");
    Expect(0, 12288, '\P{Gc=zs}', "");
    Expect(1, 12288, '\P{^Gc=zs}', "");
    Expect(0, 12289, '\p{Gc=zs}', "");
    Expect(1, 12289, '\p{^Gc=zs}', "");
    Expect(1, 12289, '\P{Gc=zs}', "");
    Expect(0, 12289, '\P{^Gc=zs}', "");
    Expect(1, 12288, '\p{Gc=:\Azs\z:}', "");;
    Expect(0, 12289, '\p{Gc=:\Azs\z:}', "");;
    Expect(1, 12288, '\p{Gc=  ZS}', "");
    Expect(0, 12288, '\p{^Gc=  ZS}', "");
    Expect(0, 12288, '\P{Gc=  ZS}', "");
    Expect(1, 12288, '\P{^Gc=  ZS}', "");
    Expect(0, 12289, '\p{Gc=  ZS}', "");
    Expect(1, 12289, '\p{^Gc=  ZS}', "");
    Expect(1, 12289, '\P{Gc=  ZS}', "");
    Expect(0, 12289, '\P{^Gc=  ZS}', "");
    Error('\p{Category=	-SPACE_SEPARATOR:=}');
    Error('\P{Category=	-SPACE_SEPARATOR:=}');
    Expect(1, 12288, '\p{Category=:\ASpace_Separator\z:}', "");;
    Expect(0, 12289, '\p{Category=:\ASpace_Separator\z:}', "");;
    Expect(1, 12288, '\p{Category=spaceseparator}', "");
    Expect(0, 12288, '\p{^Category=spaceseparator}', "");
    Expect(0, 12288, '\P{Category=spaceseparator}', "");
    Expect(1, 12288, '\P{^Category=spaceseparator}', "");
    Expect(0, 12289, '\p{Category=spaceseparator}', "");
    Expect(1, 12289, '\p{^Category=spaceseparator}', "");
    Expect(1, 12289, '\P{Category=spaceseparator}', "");
    Expect(0, 12289, '\P{^Category=spaceseparator}', "");
    Expect(1, 12288, '\p{Category=:\Aspaceseparator\z:}', "");;
    Expect(0, 12289, '\p{Category=:\Aspaceseparator\z:}', "");;
    Expect(1, 12288, '\p{Category:    SPACE_Separator}', "");
    Expect(0, 12288, '\p{^Category:    SPACE_Separator}', "");
    Expect(0, 12288, '\P{Category:    SPACE_Separator}', "");
    Expect(1, 12288, '\P{^Category:    SPACE_Separator}', "");
    Expect(0, 12289, '\p{Category:    SPACE_Separator}', "");
    Expect(1, 12289, '\p{^Category:    SPACE_Separator}', "");
    Expect(1, 12289, '\P{Category:    SPACE_Separator}', "");
    Expect(0, 12289, '\P{^Category:    SPACE_Separator}', "");
    Error('\p{Is_General_Category=:= -Zs}');
    Error('\P{Is_General_Category=:= -Zs}');
    Expect(1, 12288, '\p{Is_General_Category=zs}', "");
    Expect(0, 12288, '\p{^Is_General_Category=zs}', "");
    Expect(0, 12288, '\P{Is_General_Category=zs}', "");
    Expect(1, 12288, '\P{^Is_General_Category=zs}', "");
    Expect(0, 12289, '\p{Is_General_Category=zs}', "");
    Expect(1, 12289, '\p{^Is_General_Category=zs}', "");
    Expect(1, 12289, '\P{Is_General_Category=zs}', "");
    Expect(0, 12289, '\P{^Is_General_Category=zs}', "");
    Expect(1, 12288, '\p{Is_General_Category=-ZS}', "");
    Expect(0, 12288, '\p{^Is_General_Category=-ZS}', "");
    Expect(0, 12288, '\P{Is_General_Category=-ZS}', "");
    Expect(1, 12288, '\P{^Is_General_Category=-ZS}', "");
    Expect(0, 12289, '\p{Is_General_Category=-ZS}', "");
    Expect(1, 12289, '\p{^Is_General_Category=-ZS}', "");
    Expect(1, 12289, '\P{Is_General_Category=-ZS}', "");
    Expect(0, 12289, '\P{^Is_General_Category=-ZS}', "");
    Error('\p{Is_Gc=	_Space_SEPARATOR:=}');
    Error('\P{Is_Gc=	_Space_SEPARATOR:=}');
    Expect(1, 12288, '\p{Is_Gc: spaceseparator}', "");
    Expect(0, 12288, '\p{^Is_Gc: spaceseparator}', "");
    Expect(0, 12288, '\P{Is_Gc: spaceseparator}', "");
    Expect(1, 12288, '\P{^Is_Gc: spaceseparator}', "");
    Expect(0, 12289, '\p{Is_Gc: spaceseparator}', "");
    Expect(1, 12289, '\p{^Is_Gc: spaceseparator}', "");
    Expect(1, 12289, '\P{Is_Gc: spaceseparator}', "");
    Expect(0, 12289, '\P{^Is_Gc: spaceseparator}', "");
    Expect(1, 12288, '\p{Is_Gc=	SPACE_SEPARATOR}', "");
    Expect(0, 12288, '\p{^Is_Gc=	SPACE_SEPARATOR}', "");
    Expect(0, 12288, '\P{Is_Gc=	SPACE_SEPARATOR}', "");
    Expect(1, 12288, '\P{^Is_Gc=	SPACE_SEPARATOR}', "");
    Expect(0, 12289, '\p{Is_Gc=	SPACE_SEPARATOR}', "");
    Expect(1, 12289, '\p{^Is_Gc=	SPACE_SEPARATOR}', "");
    Expect(1, 12289, '\P{Is_Gc=	SPACE_SEPARATOR}', "");
    Expect(0, 12289, '\P{^Is_Gc=	SPACE_SEPARATOR}', "");
    Error('\p{Is_Category=/a/		zs}');
    Error('\P{Is_Category=/a/		zs}');
    Expect(1, 12288, '\p{Is_Category=zs}', "");
    Expect(0, 12288, '\p{^Is_Category=zs}', "");
    Expect(0, 12288, '\P{Is_Category=zs}', "");
    Expect(1, 12288, '\P{^Is_Category=zs}', "");
    Expect(0, 12289, '\p{Is_Category=zs}', "");
    Expect(1, 12289, '\p{^Is_Category=zs}', "");
    Expect(1, 12289, '\P{Is_Category=zs}', "");
    Expect(0, 12289, '\P{^Is_Category=zs}', "");
    Expect(1, 12288, '\p{Is_Category=__Zs}', "");
    Expect(0, 12288, '\p{^Is_Category=__Zs}', "");
    Expect(0, 12288, '\P{Is_Category=__Zs}', "");
    Expect(1, 12288, '\P{^Is_Category=__Zs}', "");
    Expect(0, 12289, '\p{Is_Category=__Zs}', "");
    Expect(1, 12289, '\p{^Is_Category=__Zs}', "");
    Expect(1, 12289, '\P{Is_Category=__Zs}', "");
    Expect(0, 12289, '\P{^Is_Category=__Zs}', "");
    Error('\p{graphemeclusterbreak}');
    Error('\P{graphemeclusterbreak}');
    Error('\p{gcb}');
    Error('\P{gcb}');
    Error('\p{_perlgcb}');
    Error('\P{_perlgcb}');
    Error('\p{Grapheme_Cluster_Break=- control:=}');
    Error('\P{Grapheme_Cluster_Break=- control:=}');
    Expect(1, 921599, '\p{Grapheme_Cluster_Break=:\AControl\z:}', "");;
    Expect(0, 921600, '\p{Grapheme_Cluster_Break=:\AControl\z:}', "");;
    Expect(1, 921599, '\p{Grapheme_Cluster_Break=control}', "");
    Expect(0, 921599, '\p{^Grapheme_Cluster_Break=control}', "");
    Expect(0, 921599, '\P{Grapheme_Cluster_Break=control}', "");
    Expect(1, 921599, '\P{^Grapheme_Cluster_Break=control}', "");
    Expect(0, 921600, '\p{Grapheme_Cluster_Break=control}', "");
    Expect(1, 921600, '\p{^Grapheme_Cluster_Break=control}', "");
    Expect(1, 921600, '\P{Grapheme_Cluster_Break=control}', "");
    Expect(0, 921600, '\P{^Grapheme_Cluster_Break=control}', "");
    Expect(1, 921599, '\p{Grapheme_Cluster_Break=:\Acontrol\z:}', "");;
    Expect(0, 921600, '\p{Grapheme_Cluster_Break=:\Acontrol\z:}', "");;
    Expect(1, 921599, '\p{Grapheme_Cluster_Break= 	control}', "");
    Expect(0, 921599, '\p{^Grapheme_Cluster_Break= 	control}', "");
    Expect(0, 921599, '\P{Grapheme_Cluster_Break= 	control}', "");
    Expect(1, 921599, '\P{^Grapheme_Cluster_Break= 	control}', "");
    Expect(0, 921600, '\p{Grapheme_Cluster_Break= 	control}', "");
    Expect(1, 921600, '\p{^Grapheme_Cluster_Break= 	control}', "");
    Expect(1, 921600, '\P{Grapheme_Cluster_Break= 	control}', "");
    Expect(0, 921600, '\P{^Grapheme_Cluster_Break= 	control}', "");
    Error('\p{GCB=:=-CN}');
    Error('\P{GCB=:=-CN}');
    Expect(1, 921599, '\p{GCB=:\ACN\z:}', "");;
    Expect(0, 921600, '\p{GCB=:\ACN\z:}', "");;
    Expect(1, 921599, '\p{GCB:	cn}', "");
    Expect(0, 921599, '\p{^GCB:	cn}', "");
    Expect(0, 921599, '\P{GCB:	cn}', "");
    Expect(1, 921599, '\P{^GCB:	cn}', "");
    Expect(0, 921600, '\p{GCB:	cn}', "");
    Expect(1, 921600, '\p{^GCB:	cn}', "");
    Expect(1, 921600, '\P{GCB:	cn}', "");
    Expect(0, 921600, '\P{^GCB:	cn}', "");
    Expect(1, 921599, '\p{GCB=:\Acn\z:}', "");;
    Expect(0, 921600, '\p{GCB=:\Acn\z:}', "");;
    Expect(1, 921599, '\p{GCB=- CN}', "");
    Expect(0, 921599, '\p{^GCB=- CN}', "");
    Expect(0, 921599, '\P{GCB=- CN}', "");
    Expect(1, 921599, '\P{^GCB=- CN}', "");
    Expect(0, 921600, '\p{GCB=- CN}', "");
    Expect(1, 921600, '\p{^GCB=- CN}', "");
    Expect(1, 921600, '\P{GCB=- CN}', "");
    Expect(0, 921600, '\P{^GCB=- CN}', "");
    Error('\p{Is_Grapheme_Cluster_Break=	-control:=}');
    Error('\P{Is_Grapheme_Cluster_Break=	-control:=}');
    Expect(1, 921599, '\p{Is_Grapheme_Cluster_Break=control}', "");
    Expect(0, 921599, '\p{^Is_Grapheme_Cluster_Break=control}', "");
    Expect(0, 921599, '\P{Is_Grapheme_Cluster_Break=control}', "");
    Expect(1, 921599, '\P{^Is_Grapheme_Cluster_Break=control}', "");
    Expect(0, 921600, '\p{Is_Grapheme_Cluster_Break=control}', "");
    Expect(1, 921600, '\p{^Is_Grapheme_Cluster_Break=control}', "");
    Expect(1, 921600, '\P{Is_Grapheme_Cluster_Break=control}', "");
    Expect(0, 921600, '\P{^Is_Grapheme_Cluster_Break=control}', "");
    Expect(1, 921599, '\p{Is_Grapheme_Cluster_Break= 	control}', "");
    Expect(0, 921599, '\p{^Is_Grapheme_Cluster_Break= 	control}', "");
    Expect(0, 921599, '\P{Is_Grapheme_Cluster_Break= 	control}', "");
    Expect(1, 921599, '\P{^Is_Grapheme_Cluster_Break= 	control}', "");
    Expect(0, 921600, '\p{Is_Grapheme_Cluster_Break= 	control}', "");
    Expect(1, 921600, '\p{^Is_Grapheme_Cluster_Break= 	control}', "");
    Expect(1, 921600, '\P{Is_Grapheme_Cluster_Break= 	control}', "");
    Expect(0, 921600, '\P{^Is_Grapheme_Cluster_Break= 	control}', "");
    Error('\p{Is_GCB=	-CN:=}');
    Error('\P{Is_GCB=	-CN:=}');
    Expect(1, 921599, '\p{Is_GCB: cn}', "");
    Expect(0, 921599, '\p{^Is_GCB: cn}', "");
    Expect(0, 921599, '\P{Is_GCB: cn}', "");
    Expect(1, 921599, '\P{^Is_GCB: cn}', "");
    Expect(0, 921600, '\p{Is_GCB: cn}', "");
    Expect(1, 921600, '\p{^Is_GCB: cn}', "");
    Expect(1, 921600, '\P{Is_GCB: cn}', "");
    Expect(0, 921600, '\P{^Is_GCB: cn}', "");
    Expect(1, 921599, '\p{Is_GCB= cn}', "");
    Expect(0, 921599, '\p{^Is_GCB= cn}', "");
    Expect(0, 921599, '\P{Is_GCB= cn}', "");
    Expect(1, 921599, '\P{^Is_GCB= cn}', "");
    Expect(0, 921600, '\p{Is_GCB= cn}', "");
    Expect(1, 921600, '\p{^Is_GCB= cn}', "");
    Expect(1, 921600, '\P{Is_GCB= cn}', "");
    Expect(0, 921600, '\P{^Is_GCB= cn}', "");
    Error('\p{Grapheme_Cluster_Break=:= _CR}');
    Error('\P{Grapheme_Cluster_Break=:= _CR}');
    Expect(1, 13, '\p{Grapheme_Cluster_Break=:\ACR\z:}', "");;
    Expect(0, 14, '\p{Grapheme_Cluster_Break=:\ACR\z:}', "");;
    Expect(1, 13, '\p{Grapheme_Cluster_Break=cr}', "");
    Expect(0, 13, '\p{^Grapheme_Cluster_Break=cr}', "");
    Expect(0, 13, '\P{Grapheme_Cluster_Break=cr}', "");
    Expect(1, 13, '\P{^Grapheme_Cluster_Break=cr}', "");
    Expect(0, 14, '\p{Grapheme_Cluster_Break=cr}', "");
    Expect(1, 14, '\p{^Grapheme_Cluster_Break=cr}', "");
    Expect(1, 14, '\P{Grapheme_Cluster_Break=cr}', "");
    Expect(0, 14, '\P{^Grapheme_Cluster_Break=cr}', "");
    Expect(1, 13, '\p{Grapheme_Cluster_Break=:\Acr\z:}', "");;
    Expect(0, 14, '\p{Grapheme_Cluster_Break=:\Acr\z:}', "");;
    Expect(1, 13, '\p{Grapheme_Cluster_Break=_cr}', "");
    Expect(0, 13, '\p{^Grapheme_Cluster_Break=_cr}', "");
    Expect(0, 13, '\P{Grapheme_Cluster_Break=_cr}', "");
    Expect(1, 13, '\P{^Grapheme_Cluster_Break=_cr}', "");
    Expect(0, 14, '\p{Grapheme_Cluster_Break=_cr}', "");
    Expect(1, 14, '\p{^Grapheme_Cluster_Break=_cr}', "");
    Expect(1, 14, '\P{Grapheme_Cluster_Break=_cr}', "");
    Expect(0, 14, '\P{^Grapheme_Cluster_Break=_cr}', "");
    Error('\p{GCB=:=CR}');
    Error('\P{GCB=:=CR}');
    Expect(1, 13, '\p{GCB=:\ACR\z:}', "");;
    Expect(0, 14, '\p{GCB=:\ACR\z:}', "");;
    Expect(1, 13, '\p{GCB=cr}', "");
    Expect(0, 13, '\p{^GCB=cr}', "");
    Expect(0, 13, '\P{GCB=cr}', "");
    Expect(1, 13, '\P{^GCB=cr}', "");
    Expect(0, 14, '\p{GCB=cr}', "");
    Expect(1, 14, '\p{^GCB=cr}', "");
    Expect(1, 14, '\P{GCB=cr}', "");
    Expect(0, 14, '\P{^GCB=cr}', "");
    Expect(1, 13, '\p{GCB=:\Acr\z:}', "");;
    Expect(0, 14, '\p{GCB=:\Acr\z:}', "");;
    Expect(1, 13, '\p{GCB=CR}', "");
    Expect(0, 13, '\p{^GCB=CR}', "");
    Expect(0, 13, '\P{GCB=CR}', "");
    Expect(1, 13, '\P{^GCB=CR}', "");
    Expect(0, 14, '\p{GCB=CR}', "");
    Expect(1, 14, '\p{^GCB=CR}', "");
    Expect(1, 14, '\P{GCB=CR}', "");
    Expect(0, 14, '\P{^GCB=CR}', "");
    Error('\p{Is_Grapheme_Cluster_Break=/a/CR}');
    Error('\P{Is_Grapheme_Cluster_Break=/a/CR}');
    Expect(1, 13, '\p{Is_Grapheme_Cluster_Break=cr}', "");
    Expect(0, 13, '\p{^Is_Grapheme_Cluster_Break=cr}', "");
    Expect(0, 13, '\P{Is_Grapheme_Cluster_Break=cr}', "");
    Expect(1, 13, '\P{^Is_Grapheme_Cluster_Break=cr}', "");
    Expect(0, 14, '\p{Is_Grapheme_Cluster_Break=cr}', "");
    Expect(1, 14, '\p{^Is_Grapheme_Cluster_Break=cr}', "");
    Expect(1, 14, '\P{Is_Grapheme_Cluster_Break=cr}', "");
    Expect(0, 14, '\P{^Is_Grapheme_Cluster_Break=cr}', "");
    Expect(1, 13, '\p{Is_Grapheme_Cluster_Break= CR}', "");
    Expect(0, 13, '\p{^Is_Grapheme_Cluster_Break= CR}', "");
    Expect(0, 13, '\P{Is_Grapheme_Cluster_Break= CR}', "");
    Expect(1, 13, '\P{^Is_Grapheme_Cluster_Break= CR}', "");
    Expect(0, 14, '\p{Is_Grapheme_Cluster_Break= CR}', "");
    Expect(1, 14, '\p{^Is_Grapheme_Cluster_Break= CR}', "");
    Expect(1, 14, '\P{Is_Grapheme_Cluster_Break= CR}', "");
    Expect(0, 14, '\P{^Is_Grapheme_Cluster_Break= CR}', "");
    Error('\p{Is_GCB=	/a/CR}');
    Error('\P{Is_GCB=	/a/CR}');
    Expect(1, 13, '\p{Is_GCB:   cr}', "");
    Expect(0, 13, '\p{^Is_GCB:   cr}', "");
    Expect(0, 13, '\P{Is_GCB:   cr}', "");
    Expect(1, 13, '\P{^Is_GCB:   cr}', "");
    Expect(0, 14, '\p{Is_GCB:   cr}', "");
    Expect(1, 14, '\p{^Is_GCB:   cr}', "");
    Expect(1, 14, '\P{Is_GCB:   cr}', "");
    Expect(0, 14, '\P{^Is_GCB:   cr}', "");
    Expect(1, 13, '\p{Is_GCB= -CR}', "");
    Expect(0, 13, '\p{^Is_GCB= -CR}', "");
    Expect(0, 13, '\P{Is_GCB= -CR}', "");
    Expect(1, 13, '\P{^Is_GCB= -CR}', "");
    Expect(0, 14, '\p{Is_GCB= -CR}', "");
    Expect(1, 14, '\p{^Is_GCB= -CR}', "");
    Expect(1, 14, '\P{Is_GCB= -CR}', "");
    Expect(0, 14, '\P{^Is_GCB= -CR}', "");
    Error('\p{Grapheme_Cluster_Break=/a/	_E_BASE}');
    Error('\P{Grapheme_Cluster_Break=/a/	_E_BASE}');
    Expect(0, 1, '\p{Grapheme_Cluster_Break=:\AE_Base\z:}', "");;
    Expect(0, 1, '\p{Grapheme_Cluster_Break=ebase}', "");
    Expect(1, 1, '\p{^Grapheme_Cluster_Break=ebase}', "");
    Expect(1, 1, '\P{Grapheme_Cluster_Break=ebase}', "");
    Expect(0, 1, '\P{^Grapheme_Cluster_Break=ebase}', "");
    Expect(0, 1, '\p{Grapheme_Cluster_Break=:\Aebase\z:}', "");;
    Expect(0, 1, '\p{Grapheme_Cluster_Break:   	E_Base}', "");
    Expect(1, 1, '\p{^Grapheme_Cluster_Break:   	E_Base}', "");
    Expect(1, 1, '\P{Grapheme_Cluster_Break:   	E_Base}', "");
    Expect(0, 1, '\P{^Grapheme_Cluster_Break:   	E_Base}', "");
    Error('\p{GCB=/a/_ EB}');
    Error('\P{GCB=/a/_ EB}');
    Expect(0, 1, '\p{GCB=:\AEB\z:}', "");;
    Expect(0, 1, '\p{GCB=eb}', "");
    Expect(1, 1, '\p{^GCB=eb}', "");
    Expect(1, 1, '\P{GCB=eb}', "");
    Expect(0, 1, '\P{^GCB=eb}', "");
    Expect(0, 1, '\p{GCB=:\Aeb\z:}', "");;
    Expect(0, 1, '\p{GCB=-_EB}', "");
    Expect(1, 1, '\p{^GCB=-_EB}', "");
    Expect(1, 1, '\P{GCB=-_EB}', "");
    Expect(0, 1, '\P{^GCB=-_EB}', "");
    Error('\p{Is_Grapheme_Cluster_Break:			E_Base:=}');
    Error('\P{Is_Grapheme_Cluster_Break:			E_Base:=}');
    Expect(0, 1, '\p{Is_Grapheme_Cluster_Break=ebase}', "");
    Expect(1, 1, '\p{^Is_Grapheme_Cluster_Break=ebase}', "");
    Expect(1, 1, '\P{Is_Grapheme_Cluster_Break=ebase}', "");
    Expect(0, 1, '\P{^Is_Grapheme_Cluster_Break=ebase}', "");
    Expect(0, 1, '\p{Is_Grapheme_Cluster_Break= -E_base}', "");
    Expect(1, 1, '\p{^Is_Grapheme_Cluster_Break= -E_base}', "");
    Expect(1, 1, '\P{Is_Grapheme_Cluster_Break= -E_base}', "");
    Expect(0, 1, '\P{^Is_Grapheme_Cluster_Break= -E_base}', "");
    Error('\p{Is_GCB=:=	EB}');
    Error('\P{Is_GCB=:=	EB}');
    Expect(0, 1, '\p{Is_GCB=eb}', "");
    Expect(1, 1, '\p{^Is_GCB=eb}', "");
    Expect(1, 1, '\P{Is_GCB=eb}', "");
    Expect(0, 1, '\P{^Is_GCB=eb}', "");
    Expect(0, 1, '\p{Is_GCB=EB}', "");
    Expect(1, 1, '\p{^Is_GCB=EB}', "");
    Expect(1, 1, '\P{Is_GCB=EB}', "");
    Expect(0, 1, '\P{^Is_GCB=EB}', "");
    Error('\p{Grapheme_Cluster_Break=  E_base_GAZ:=}');
    Error('\P{Grapheme_Cluster_Break=  E_base_GAZ:=}');
    Expect(0, 1, '\p{Grapheme_Cluster_Break=:\AE_Base_GAZ\z:}', "");;
    Expect(0, 1, '\p{Grapheme_Cluster_Break=ebasegaz}', "");
    Expect(1, 1, '\p{^Grapheme_Cluster_Break=ebasegaz}', "");
    Expect(1, 1, '\P{Grapheme_Cluster_Break=ebasegaz}', "");
    Expect(0, 1, '\P{^Grapheme_Cluster_Break=ebasegaz}', "");
    Expect(0, 1, '\p{Grapheme_Cluster_Break=:\Aebasegaz\z:}', "");;
    Expect(0, 1, '\p{Grapheme_Cluster_Break=-_E_Base_GAZ}', "");
    Expect(1, 1, '\p{^Grapheme_Cluster_Break=-_E_Base_GAZ}', "");
    Expect(1, 1, '\P{Grapheme_Cluster_Break=-_E_Base_GAZ}', "");
    Expect(0, 1, '\P{^Grapheme_Cluster_Break=-_E_Base_GAZ}', "");
    Error('\p{GCB=/a/__ebg}');
    Error('\P{GCB=/a/__ebg}');
    Expect(0, 1, '\p{GCB=:\AEBG\z:}', "");;
    Expect(0, 1, '\p{GCB: ebg}', "");
    Expect(1, 1, '\p{^GCB: ebg}', "");
    Expect(1, 1, '\P{GCB: ebg}', "");
    Expect(0, 1, '\P{^GCB: ebg}', "");
    Expect(0, 1, '\p{GCB=:\Aebg\z:}', "");;
    Expect(0, 1, '\p{GCB=_	EBG}', "");
    Expect(1, 1, '\p{^GCB=_	EBG}', "");
    Expect(1, 1, '\P{GCB=_	EBG}', "");
    Expect(0, 1, '\P{^GCB=_	EBG}', "");
    Error('\p{Is_Grapheme_Cluster_Break: /a/	e_Base_gaz}');
    Error('\P{Is_Grapheme_Cluster_Break: /a/	e_Base_gaz}');
    Expect(0, 1, '\p{Is_Grapheme_Cluster_Break=ebasegaz}', "");
    Expect(1, 1, '\p{^Is_Grapheme_Cluster_Break=ebasegaz}', "");
    Expect(1, 1, '\P{Is_Grapheme_Cluster_Break=ebasegaz}', "");
    Expect(0, 1, '\P{^Is_Grapheme_Cluster_Break=ebasegaz}', "");
    Expect(0, 1, '\p{Is_Grapheme_Cluster_Break=- e_Base_GAZ}', "");
    Expect(1, 1, '\p{^Is_Grapheme_Cluster_Break=- e_Base_GAZ}', "");
    Expect(1, 1, '\P{Is_Grapheme_Cluster_Break=- e_Base_GAZ}', "");
    Expect(0, 1, '\P{^Is_Grapheme_Cluster_Break=- e_Base_GAZ}', "");
    Error('\p{Is_GCB=	EBG:=}');
    Error('\P{Is_GCB=	EBG:=}');
    Expect(0, 1, '\p{Is_GCB=ebg}', "");
    Expect(1, 1, '\p{^Is_GCB=ebg}', "");
    Expect(1, 1, '\P{Is_GCB=ebg}', "");
    Expect(0, 1, '\P{^Is_GCB=ebg}', "");
    Expect(0, 1, '\p{Is_GCB= 	ebg}', "");
    Expect(1, 1, '\p{^Is_GCB= 	ebg}', "");
    Expect(1, 1, '\P{Is_GCB= 	ebg}', "");
    Expect(0, 1, '\P{^Is_GCB= 	ebg}', "");
    Error('\p{Grapheme_Cluster_Break=-	E_MODIFIER/a/}');
    Error('\P{Grapheme_Cluster_Break=-	E_MODIFIER/a/}');
    Expect(0, 1, '\p{Grapheme_Cluster_Break=:\AE_Modifier\z:}', "");;
    Expect(0, 1, '\p{Grapheme_Cluster_Break=emodifier}', "");
    Expect(1, 1, '\p{^Grapheme_Cluster_Break=emodifier}', "");
    Expect(1, 1, '\P{Grapheme_Cluster_Break=emodifier}', "");
    Expect(0, 1, '\P{^Grapheme_Cluster_Break=emodifier}', "");
    Expect(0, 1, '\p{Grapheme_Cluster_Break=:\Aemodifier\z:}', "");;
    Expect(0, 1, '\p{Grapheme_Cluster_Break=_e_modifier}', "");
    Expect(1, 1, '\p{^Grapheme_Cluster_Break=_e_modifier}', "");
    Expect(1, 1, '\P{Grapheme_Cluster_Break=_e_modifier}', "");
    Expect(0, 1, '\P{^Grapheme_Cluster_Break=_e_modifier}', "");
    Error('\p{GCB=_/a/EM}');
    Error('\P{GCB=_/a/EM}');
    Expect(0, 1, '\p{GCB=:\AEM\z:}', "");;
    Expect(0, 1, '\p{GCB=em}', "");
    Expect(1, 1, '\p{^GCB=em}', "");
    Expect(1, 1, '\P{GCB=em}', "");
    Expect(0, 1, '\P{^GCB=em}', "");
    Expect(0, 1, '\p{GCB=:\Aem\z:}', "");;
    Expect(0, 1, '\p{GCB=-	EM}', "");
    Expect(1, 1, '\p{^GCB=-	EM}', "");
    Expect(1, 1, '\P{GCB=-	EM}', "");
    Expect(0, 1, '\P{^GCB=-	EM}', "");
    Error('\p{Is_Grapheme_Cluster_Break=__E_modifier/a/}');
    Error('\P{Is_Grapheme_Cluster_Break=__E_modifier/a/}');
    Expect(0, 1, '\p{Is_Grapheme_Cluster_Break=emodifier}', "");
    Expect(1, 1, '\p{^Is_Grapheme_Cluster_Break=emodifier}', "");
    Expect(1, 1, '\P{Is_Grapheme_Cluster_Break=emodifier}', "");
    Expect(0, 1, '\P{^Is_Grapheme_Cluster_Break=emodifier}', "");
    Expect(0, 1, '\p{Is_Grapheme_Cluster_Break=-E_MODIFIER}', "");
    Expect(1, 1, '\p{^Is_Grapheme_Cluster_Break=-E_MODIFIER}', "");
    Expect(1, 1, '\P{Is_Grapheme_Cluster_Break=-E_MODIFIER}', "");
    Expect(0, 1, '\P{^Is_Grapheme_Cluster_Break=-E_MODIFIER}', "");
    Error('\p{Is_GCB=:=- em}');
    Error('\P{Is_GCB=:=- em}');
    Expect(0, 1, '\p{Is_GCB=em}', "");
    Expect(1, 1, '\p{^Is_GCB=em}', "");
    Expect(1, 1, '\P{Is_GCB=em}', "");
    Expect(0, 1, '\P{^Is_GCB=em}', "");
    Expect(0, 1, '\p{Is_GCB=_EM}', "");
    Expect(1, 1, '\p{^Is_GCB=_EM}', "");
    Expect(1, 1, '\P{Is_GCB=_EM}', "");
    Expect(0, 1, '\P{^Is_GCB=_EM}', "");
    Error('\p{Grapheme_Cluster_Break=_-extend/a/}');
    Error('\P{Grapheme_Cluster_Break=_-extend/a/}');
    Expect(1, 917999, '\p{Grapheme_Cluster_Break=:\AExtend\z:}', "");;
    Expect(0, 918000, '\p{Grapheme_Cluster_Break=:\AExtend\z:}', "");;
    Expect(1, 917999, '\p{Grapheme_Cluster_Break=extend}', "");
    Expect(0, 917999, '\p{^Grapheme_Cluster_Break=extend}', "");
    Expect(0, 917999, '\P{Grapheme_Cluster_Break=extend}', "");
    Expect(1, 917999, '\P{^Grapheme_Cluster_Break=extend}', "");
    Expect(0, 918000, '\p{Grapheme_Cluster_Break=extend}', "");
    Expect(1, 918000, '\p{^Grapheme_Cluster_Break=extend}', "");
    Expect(1, 918000, '\P{Grapheme_Cluster_Break=extend}', "");
    Expect(0, 918000, '\P{^Grapheme_Cluster_Break=extend}', "");
    Expect(1, 917999, '\p{Grapheme_Cluster_Break=:\Aextend\z:}', "");;
    Expect(0, 918000, '\p{Grapheme_Cluster_Break=:\Aextend\z:}', "");;
    Expect(1, 917999, '\p{Grapheme_Cluster_Break:	-_EXTEND}', "");
    Expect(0, 917999, '\p{^Grapheme_Cluster_Break:	-_EXTEND}', "");
    Expect(0, 917999, '\P{Grapheme_Cluster_Break:	-_EXTEND}', "");
    Expect(1, 917999, '\P{^Grapheme_Cluster_Break:	-_EXTEND}', "");
    Expect(0, 918000, '\p{Grapheme_Cluster_Break:	-_EXTEND}', "");
    Expect(1, 918000, '\p{^Grapheme_Cluster_Break:	-_EXTEND}', "");
    Expect(1, 918000, '\P{Grapheme_Cluster_Break:	-_EXTEND}', "");
    Expect(0, 918000, '\P{^Grapheme_Cluster_Break:	-_EXTEND}', "");
    Error('\p{GCB=:=		EX}');
    Error('\P{GCB=:=		EX}');
    Expect(1, 917999, '\p{GCB=:\AEX\z:}', "");;
    Expect(0, 918000, '\p{GCB=:\AEX\z:}', "");;
    Expect(1, 917999, '\p{GCB=ex}', "");
    Expect(0, 917999, '\p{^GCB=ex}', "");
    Expect(0, 917999, '\P{GCB=ex}', "");
    Expect(1, 917999, '\P{^GCB=ex}', "");
    Expect(0, 918000, '\p{GCB=ex}', "");
    Expect(1, 918000, '\p{^GCB=ex}', "");
    Expect(1, 918000, '\P{GCB=ex}', "");
    Expect(0, 918000, '\P{^GCB=ex}', "");
    Expect(1, 917999, '\p{GCB=:\Aex\z:}', "");;
    Expect(0, 918000, '\p{GCB=:\Aex\z:}', "");;
    Expect(1, 917999, '\p{GCB:_-EX}', "");
    Expect(0, 917999, '\p{^GCB:_-EX}', "");
    Expect(0, 917999, '\P{GCB:_-EX}', "");
    Expect(1, 917999, '\P{^GCB:_-EX}', "");
    Expect(0, 918000, '\p{GCB:_-EX}', "");
    Expect(1, 918000, '\p{^GCB:_-EX}', "");
    Expect(1, 918000, '\P{GCB:_-EX}', "");
    Expect(0, 918000, '\P{^GCB:_-EX}', "");
    Error('\p{Is_Grapheme_Cluster_Break=	:=Extend}');
    Error('\P{Is_Grapheme_Cluster_Break=	:=Extend}');
    Expect(1, 917999, '\p{Is_Grapheme_Cluster_Break=extend}', "");
    Expect(0, 917999, '\p{^Is_Grapheme_Cluster_Break=extend}', "");
    Expect(0, 917999, '\P{Is_Grapheme_Cluster_Break=extend}', "");
    Expect(1, 917999, '\P{^Is_Grapheme_Cluster_Break=extend}', "");
    Expect(0, 918000, '\p{Is_Grapheme_Cluster_Break=extend}', "");
    Expect(1, 918000, '\p{^Is_Grapheme_Cluster_Break=extend}', "");
    Expect(1, 918000, '\P{Is_Grapheme_Cluster_Break=extend}', "");
    Expect(0, 918000, '\P{^Is_Grapheme_Cluster_Break=extend}', "");
    Expect(1, 917999, '\p{Is_Grapheme_Cluster_Break=	_extend}', "");
    Expect(0, 917999, '\p{^Is_Grapheme_Cluster_Break=	_extend}', "");
    Expect(0, 917999, '\P{Is_Grapheme_Cluster_Break=	_extend}', "");
    Expect(1, 917999, '\P{^Is_Grapheme_Cluster_Break=	_extend}', "");
    Expect(0, 918000, '\p{Is_Grapheme_Cluster_Break=	_extend}', "");
    Expect(1, 918000, '\p{^Is_Grapheme_Cluster_Break=	_extend}', "");
    Expect(1, 918000, '\P{Is_Grapheme_Cluster_Break=	_extend}', "");
    Expect(0, 918000, '\P{^Is_Grapheme_Cluster_Break=	_extend}', "");
    Error('\p{Is_GCB::= -EX}');
    Error('\P{Is_GCB::= -EX}');
    Expect(1, 917999, '\p{Is_GCB=ex}', "");
    Expect(0, 917999, '\p{^Is_GCB=ex}', "");
    Expect(0, 917999, '\P{Is_GCB=ex}', "");
    Expect(1, 917999, '\P{^Is_GCB=ex}', "");
    Expect(0, 918000, '\p{Is_GCB=ex}', "");
    Expect(1, 918000, '\p{^Is_GCB=ex}', "");
    Expect(1, 918000, '\P{Is_GCB=ex}', "");
    Expect(0, 918000, '\P{^Is_GCB=ex}', "");
    Expect(1, 917999, '\p{Is_GCB:   	EX}', "");
    Expect(0, 917999, '\p{^Is_GCB:   	EX}', "");
    Expect(0, 917999, '\P{Is_GCB:   	EX}', "");
    Expect(1, 917999, '\P{^Is_GCB:   	EX}', "");
    Expect(0, 918000, '\p{Is_GCB:   	EX}', "");
    Expect(1, 918000, '\p{^Is_GCB:   	EX}', "");
    Expect(1, 918000, '\P{Is_GCB:   	EX}', "");
    Expect(0, 918000, '\P{^Is_GCB:   	EX}', "");
    Error('\p{Grapheme_Cluster_Break:_	Glue_After_Zwj/a/}');
    Error('\P{Grapheme_Cluster_Break:_	Glue_After_Zwj/a/}');
    Expect(0, 1, '\p{Grapheme_Cluster_Break=:\AGlue_After_Zwj\z:}', "");;
    Expect(0, 1, '\p{Grapheme_Cluster_Break=glueafterzwj}', "");
    Expect(1, 1, '\p{^Grapheme_Cluster_Break=glueafterzwj}', "");
    Expect(1, 1, '\P{Grapheme_Cluster_Break=glueafterzwj}', "");
    Expect(0, 1, '\P{^Grapheme_Cluster_Break=glueafterzwj}', "");
    Expect(0, 1, '\p{Grapheme_Cluster_Break=:\Aglueafterzwj\z:}', "");;
    Expect(0, 1, '\p{Grapheme_Cluster_Break= Glue_After_ZWJ}', "");
    Expect(1, 1, '\p{^Grapheme_Cluster_Break= Glue_After_ZWJ}', "");
    Expect(1, 1, '\P{Grapheme_Cluster_Break= Glue_After_ZWJ}', "");
    Expect(0, 1, '\P{^Grapheme_Cluster_Break= Glue_After_ZWJ}', "");
    Error('\p{GCB=:=--GAZ}');
    Error('\P{GCB=:=--GAZ}');
    Expect(0, 1, '\p{GCB=:\AGAZ\z:}', "");;
    Expect(0, 1, '\p{GCB=gaz}', "");
    Expect(1, 1, '\p{^GCB=gaz}', "");
    Expect(1, 1, '\P{GCB=gaz}', "");
    Expect(0, 1, '\P{^GCB=gaz}', "");
    Expect(0, 1, '\p{GCB=:\Agaz\z:}', "");;
    Expect(0, 1, '\p{GCB=	-GAZ}', "");
    Expect(1, 1, '\p{^GCB=	-GAZ}', "");
    Expect(1, 1, '\P{GCB=	-GAZ}', "");
    Expect(0, 1, '\P{^GCB=	-GAZ}', "");
    Error('\p{Is_Grapheme_Cluster_Break=	-GLUE_After_ZWJ/a/}');
    Error('\P{Is_Grapheme_Cluster_Break=	-GLUE_After_ZWJ/a/}');
    Expect(0, 1, '\p{Is_Grapheme_Cluster_Break=glueafterzwj}', "");
    Expect(1, 1, '\p{^Is_Grapheme_Cluster_Break=glueafterzwj}', "");
    Expect(1, 1, '\P{Is_Grapheme_Cluster_Break=glueafterzwj}', "");
    Expect(0, 1, '\P{^Is_Grapheme_Cluster_Break=glueafterzwj}', "");
    Expect(0, 1, '\p{Is_Grapheme_Cluster_Break=--Glue_After_zwj}', "");
    Expect(1, 1, '\p{^Is_Grapheme_Cluster_Break=--Glue_After_zwj}', "");
    Expect(1, 1, '\P{Is_Grapheme_Cluster_Break=--Glue_After_zwj}', "");
    Expect(0, 1, '\P{^Is_Grapheme_Cluster_Break=--Glue_After_zwj}', "");
    Error('\p{Is_GCB=_ GAZ:=}');
    Error('\P{Is_GCB=_ GAZ:=}');
    Expect(0, 1, '\p{Is_GCB=gaz}', "");
    Expect(1, 1, '\p{^Is_GCB=gaz}', "");
    Expect(1, 1, '\P{Is_GCB=gaz}', "");
    Expect(0, 1, '\P{^Is_GCB=gaz}', "");
    Expect(0, 1, '\p{Is_GCB: __GAZ}', "");
    Expect(1, 1, '\p{^Is_GCB: __GAZ}', "");
    Expect(1, 1, '\P{Is_GCB: __GAZ}', "");
    Expect(0, 1, '\P{^Is_GCB: __GAZ}', "");
    Error('\p{Grapheme_Cluster_Break=__L/a/}');
    Error('\P{Grapheme_Cluster_Break=__L/a/}');
    Expect(1, 43388, '\p{Grapheme_Cluster_Break=:\AL\z:}', "");;
    Expect(0, 43389, '\p{Grapheme_Cluster_Break=:\AL\z:}', "");;
    Expect(1, 43388, '\p{Grapheme_Cluster_Break=l}', "");
    Expect(0, 43388, '\p{^Grapheme_Cluster_Break=l}', "");
    Expect(0, 43388, '\P{Grapheme_Cluster_Break=l}', "");
    Expect(1, 43388, '\P{^Grapheme_Cluster_Break=l}', "");
    Expect(0, 43389, '\p{Grapheme_Cluster_Break=l}', "");
    Expect(1, 43389, '\p{^Grapheme_Cluster_Break=l}', "");
    Expect(1, 43389, '\P{Grapheme_Cluster_Break=l}', "");
    Expect(0, 43389, '\P{^Grapheme_Cluster_Break=l}', "");
    Expect(1, 43388, '\p{Grapheme_Cluster_Break=:\Al\z:}', "");;
    Expect(0, 43389, '\p{Grapheme_Cluster_Break=:\Al\z:}', "");;
    Expect(1, 43388, '\p{Grapheme_Cluster_Break=-L}', "");
    Expect(0, 43388, '\p{^Grapheme_Cluster_Break=-L}', "");
    Expect(0, 43388, '\P{Grapheme_Cluster_Break=-L}', "");
    Expect(1, 43388, '\P{^Grapheme_Cluster_Break=-L}', "");
    Expect(0, 43389, '\p{Grapheme_Cluster_Break=-L}', "");
    Expect(1, 43389, '\p{^Grapheme_Cluster_Break=-L}', "");
    Expect(1, 43389, '\P{Grapheme_Cluster_Break=-L}', "");
    Expect(0, 43389, '\P{^Grapheme_Cluster_Break=-L}', "");
    Error('\p{GCB=/a/  l}');
    Error('\P{GCB=/a/  l}');
    Expect(1, 43388, '\p{GCB=:\AL\z:}', "");;
    Expect(0, 43389, '\p{GCB=:\AL\z:}', "");;
    Expect(1, 43388, '\p{GCB:	l}', "");
    Expect(0, 43388, '\p{^GCB:	l}', "");
    Expect(0, 43388, '\P{GCB:	l}', "");
    Expect(1, 43388, '\P{^GCB:	l}', "");
    Expect(0, 43389, '\p{GCB:	l}', "");
    Expect(1, 43389, '\p{^GCB:	l}', "");
    Expect(1, 43389, '\P{GCB:	l}', "");
    Expect(0, 43389, '\P{^GCB:	l}', "");
    Expect(1, 43388, '\p{GCB=:\Al\z:}', "");;
    Expect(0, 43389, '\p{GCB=:\Al\z:}', "");;
    Expect(1, 43388, '\p{GCB=	L}', "");
    Expect(0, 43388, '\p{^GCB=	L}', "");
    Expect(0, 43388, '\P{GCB=	L}', "");
    Expect(1, 43388, '\P{^GCB=	L}', "");
    Expect(0, 43389, '\p{GCB=	L}', "");
    Expect(1, 43389, '\p{^GCB=	L}', "");
    Expect(1, 43389, '\P{GCB=	L}', "");
    Expect(0, 43389, '\P{^GCB=	L}', "");
    Error('\p{Is_Grapheme_Cluster_Break:	/a/	 l}');
    Error('\P{Is_Grapheme_Cluster_Break:	/a/	 l}');
    Expect(1, 43388, '\p{Is_Grapheme_Cluster_Break=l}', "");
    Expect(0, 43388, '\p{^Is_Grapheme_Cluster_Break=l}', "");
    Expect(0, 43388, '\P{Is_Grapheme_Cluster_Break=l}', "");
    Expect(1, 43388, '\P{^Is_Grapheme_Cluster_Break=l}', "");
    Expect(0, 43389, '\p{Is_Grapheme_Cluster_Break=l}', "");
    Expect(1, 43389, '\p{^Is_Grapheme_Cluster_Break=l}', "");
    Expect(1, 43389, '\P{Is_Grapheme_Cluster_Break=l}', "");
    Expect(0, 43389, '\P{^Is_Grapheme_Cluster_Break=l}', "");
    Expect(1, 43388, '\p{Is_Grapheme_Cluster_Break=		l}', "");
    Expect(0, 43388, '\p{^Is_Grapheme_Cluster_Break=		l}', "");
    Expect(0, 43388, '\P{Is_Grapheme_Cluster_Break=		l}', "");
    Expect(1, 43388, '\P{^Is_Grapheme_Cluster_Break=		l}', "");
    Expect(0, 43389, '\p{Is_Grapheme_Cluster_Break=		l}', "");
    Expect(1, 43389, '\p{^Is_Grapheme_Cluster_Break=		l}', "");
    Expect(1, 43389, '\P{Is_Grapheme_Cluster_Break=		l}', "");
    Expect(0, 43389, '\P{^Is_Grapheme_Cluster_Break=		l}', "");
    Error('\p{Is_GCB:   /a/ L}');
    Error('\P{Is_GCB:   /a/ L}');
    Expect(1, 43388, '\p{Is_GCB=l}', "");
    Expect(0, 43388, '\p{^Is_GCB=l}', "");
    Expect(0, 43388, '\P{Is_GCB=l}', "");
    Expect(1, 43388, '\P{^Is_GCB=l}', "");
    Expect(0, 43389, '\p{Is_GCB=l}', "");
    Expect(1, 43389, '\p{^Is_GCB=l}', "");
    Expect(1, 43389, '\P{Is_GCB=l}', "");
    Expect(0, 43389, '\P{^Is_GCB=l}', "");
    Expect(1, 43388, '\p{Is_GCB= L}', "");
    Expect(0, 43388, '\p{^Is_GCB= L}', "");
    Expect(0, 43388, '\P{Is_GCB= L}', "");
    Expect(1, 43388, '\P{^Is_GCB= L}', "");
    Expect(0, 43389, '\p{Is_GCB= L}', "");
    Expect(1, 43389, '\p{^Is_GCB= L}', "");
    Expect(1, 43389, '\P{Is_GCB= L}', "");
    Expect(0, 43389, '\P{^Is_GCB= L}', "");
    Error('\p{Grapheme_Cluster_Break=:=	-LF}');
    Error('\P{Grapheme_Cluster_Break=:=	-LF}');
    Expect(1, 10, '\p{Grapheme_Cluster_Break=:\ALF\z:}', "");;
    Expect(0, 11, '\p{Grapheme_Cluster_Break=:\ALF\z:}', "");;
    Expect(1, 10, '\p{Grapheme_Cluster_Break=lf}', "");
    Expect(0, 10, '\p{^Grapheme_Cluster_Break=lf}', "");
    Expect(0, 10, '\P{Grapheme_Cluster_Break=lf}', "");
    Expect(1, 10, '\P{^Grapheme_Cluster_Break=lf}', "");
    Expect(0, 11, '\p{Grapheme_Cluster_Break=lf}', "");
    Expect(1, 11, '\p{^Grapheme_Cluster_Break=lf}', "");
    Expect(1, 11, '\P{Grapheme_Cluster_Break=lf}', "");
    Expect(0, 11, '\P{^Grapheme_Cluster_Break=lf}', "");
    Expect(1, 10, '\p{Grapheme_Cluster_Break=:\Alf\z:}', "");;
    Expect(0, 11, '\p{Grapheme_Cluster_Break=:\Alf\z:}', "");;
    Expect(1, 10, '\p{Grapheme_Cluster_Break=_LF}', "");
    Expect(0, 10, '\p{^Grapheme_Cluster_Break=_LF}', "");
    Expect(0, 10, '\P{Grapheme_Cluster_Break=_LF}', "");
    Expect(1, 10, '\P{^Grapheme_Cluster_Break=_LF}', "");
    Expect(0, 11, '\p{Grapheme_Cluster_Break=_LF}', "");
    Expect(1, 11, '\p{^Grapheme_Cluster_Break=_LF}', "");
    Expect(1, 11, '\P{Grapheme_Cluster_Break=_LF}', "");
    Expect(0, 11, '\P{^Grapheme_Cluster_Break=_LF}', "");
    Error('\p{GCB=/a/ LF}');
    Error('\P{GCB=/a/ LF}');
    Expect(1, 10, '\p{GCB=:\ALF\z:}', "");;
    Expect(0, 11, '\p{GCB=:\ALF\z:}', "");;
    Expect(1, 10, '\p{GCB=lf}', "");
    Expect(0, 10, '\p{^GCB=lf}', "");
    Expect(0, 10, '\P{GCB=lf}', "");
    Expect(1, 10, '\P{^GCB=lf}', "");
    Expect(0, 11, '\p{GCB=lf}', "");
    Expect(1, 11, '\p{^GCB=lf}', "");
    Expect(1, 11, '\P{GCB=lf}', "");
    Expect(0, 11, '\P{^GCB=lf}', "");
    Expect(1, 10, '\p{GCB=:\Alf\z:}', "");;
    Expect(0, 11, '\p{GCB=:\Alf\z:}', "");;
    Expect(1, 10, '\p{GCB=  LF}', "");
    Expect(0, 10, '\p{^GCB=  LF}', "");
    Expect(0, 10, '\P{GCB=  LF}', "");
    Expect(1, 10, '\P{^GCB=  LF}', "");
    Expect(0, 11, '\p{GCB=  LF}', "");
    Expect(1, 11, '\p{^GCB=  LF}', "");
    Expect(1, 11, '\P{GCB=  LF}', "");
    Expect(0, 11, '\P{^GCB=  LF}', "");
    Error('\p{Is_Grapheme_Cluster_Break=	lf:=}');
    Error('\P{Is_Grapheme_Cluster_Break=	lf:=}');
    Expect(1, 10, '\p{Is_Grapheme_Cluster_Break=lf}', "");
    Expect(0, 10, '\p{^Is_Grapheme_Cluster_Break=lf}', "");
    Expect(0, 10, '\P{Is_Grapheme_Cluster_Break=lf}', "");
    Expect(1, 10, '\P{^Is_Grapheme_Cluster_Break=lf}', "");
    Expect(0, 11, '\p{Is_Grapheme_Cluster_Break=lf}', "");
    Expect(1, 11, '\p{^Is_Grapheme_Cluster_Break=lf}', "");
    Expect(1, 11, '\P{Is_Grapheme_Cluster_Break=lf}', "");
    Expect(0, 11, '\P{^Is_Grapheme_Cluster_Break=lf}', "");
    Expect(1, 10, '\p{Is_Grapheme_Cluster_Break=_-lf}', "");
    Expect(0, 10, '\p{^Is_Grapheme_Cluster_Break=_-lf}', "");
    Expect(0, 10, '\P{Is_Grapheme_Cluster_Break=_-lf}', "");
    Expect(1, 10, '\P{^Is_Grapheme_Cluster_Break=_-lf}', "");
    Expect(0, 11, '\p{Is_Grapheme_Cluster_Break=_-lf}', "");
    Expect(1, 11, '\p{^Is_Grapheme_Cluster_Break=_-lf}', "");
    Expect(1, 11, '\P{Is_Grapheme_Cluster_Break=_-lf}', "");
    Expect(0, 11, '\P{^Is_Grapheme_Cluster_Break=_-lf}', "");
    Error('\p{Is_GCB:   :=-LF}');
    Error('\P{Is_GCB:   :=-LF}');
    Expect(1, 10, '\p{Is_GCB=lf}', "");
    Expect(0, 10, '\p{^Is_GCB=lf}', "");
    Expect(0, 10, '\P{Is_GCB=lf}', "");
    Expect(1, 10, '\P{^Is_GCB=lf}', "");
    Expect(0, 11, '\p{Is_GCB=lf}', "");
    Expect(1, 11, '\p{^Is_GCB=lf}', "");
    Expect(1, 11, '\P{Is_GCB=lf}', "");
    Expect(0, 11, '\P{^Is_GCB=lf}', "");
    Expect(1, 10, '\p{Is_GCB:	 LF}', "");
    Expect(0, 10, '\p{^Is_GCB:	 LF}', "");
    Expect(0, 10, '\P{Is_GCB:	 LF}', "");
    Expect(1, 10, '\P{^Is_GCB:	 LF}', "");
    Expect(0, 11, '\p{Is_GCB:	 LF}', "");
    Expect(1, 11, '\p{^Is_GCB:	 LF}', "");
    Expect(1, 11, '\P{Is_GCB:	 LF}', "");
    Expect(0, 11, '\P{^Is_GCB:	 LF}', "");
    Error('\p{Grapheme_Cluster_Break: :=LV}');
    Error('\P{Grapheme_Cluster_Break: :=LV}');
    Expect(1, 55176, '\p{Grapheme_Cluster_Break=:\ALV\z:}', "");;
    Expect(0, 55177, '\p{Grapheme_Cluster_Break=:\ALV\z:}', "");;
    Expect(1, 55176, '\p{Grapheme_Cluster_Break=lv}', "");
    Expect(0, 55176, '\p{^Grapheme_Cluster_Break=lv}', "");
    Expect(0, 55176, '\P{Grapheme_Cluster_Break=lv}', "");
    Expect(1, 55176, '\P{^Grapheme_Cluster_Break=lv}', "");
    Expect(0, 55177, '\p{Grapheme_Cluster_Break=lv}', "");
    Expect(1, 55177, '\p{^Grapheme_Cluster_Break=lv}', "");
    Expect(1, 55177, '\P{Grapheme_Cluster_Break=lv}', "");
    Expect(0, 55177, '\P{^Grapheme_Cluster_Break=lv}', "");
    Expect(1, 55176, '\p{Grapheme_Cluster_Break=:\Alv\z:}', "");;
    Expect(0, 55177, '\p{Grapheme_Cluster_Break=:\Alv\z:}', "");;
    Expect(1, 55176, '\p{Grapheme_Cluster_Break= 	LV}', "");
    Expect(0, 55176, '\p{^Grapheme_Cluster_Break= 	LV}', "");
    Expect(0, 55176, '\P{Grapheme_Cluster_Break= 	LV}', "");
    Expect(1, 55176, '\P{^Grapheme_Cluster_Break= 	LV}', "");
    Expect(0, 55177, '\p{Grapheme_Cluster_Break= 	LV}', "");
    Expect(1, 55177, '\p{^Grapheme_Cluster_Break= 	LV}', "");
    Expect(1, 55177, '\P{Grapheme_Cluster_Break= 	LV}', "");
    Expect(0, 55177, '\P{^Grapheme_Cluster_Break= 	LV}', "");
    Error('\p{GCB=/a/lv}');
    Error('\P{GCB=/a/lv}');
    Expect(1, 55176, '\p{GCB=:\ALV\z:}', "");;
    Expect(0, 55177, '\p{GCB=:\ALV\z:}', "");;
    Expect(1, 55176, '\p{GCB=lv}', "");
    Expect(0, 55176, '\p{^GCB=lv}', "");
    Expect(0, 55176, '\P{GCB=lv}', "");
    Expect(1, 55176, '\P{^GCB=lv}', "");
    Expect(0, 55177, '\p{GCB=lv}', "");
    Expect(1, 55177, '\p{^GCB=lv}', "");
    Expect(1, 55177, '\P{GCB=lv}', "");
    Expect(0, 55177, '\P{^GCB=lv}', "");
    Expect(1, 55176, '\p{GCB=:\Alv\z:}', "");;
    Expect(0, 55177, '\p{GCB=:\Alv\z:}', "");;
    Expect(1, 55176, '\p{GCB:   _	LV}', "");
    Expect(0, 55176, '\p{^GCB:   _	LV}', "");
    Expect(0, 55176, '\P{GCB:   _	LV}', "");
    Expect(1, 55176, '\P{^GCB:   _	LV}', "");
    Expect(0, 55177, '\p{GCB:   _	LV}', "");
    Expect(1, 55177, '\p{^GCB:   _	LV}', "");
    Expect(1, 55177, '\P{GCB:   _	LV}', "");
    Expect(0, 55177, '\P{^GCB:   _	LV}', "");
    Error('\p{Is_Grapheme_Cluster_Break=_:=LV}');
    Error('\P{Is_Grapheme_Cluster_Break=_:=LV}');
    Expect(1, 55176, '\p{Is_Grapheme_Cluster_Break=lv}', "");
    Expect(0, 55176, '\p{^Is_Grapheme_Cluster_Break=lv}', "");
    Expect(0, 55176, '\P{Is_Grapheme_Cluster_Break=lv}', "");
    Expect(1, 55176, '\P{^Is_Grapheme_Cluster_Break=lv}', "");
    Expect(0, 55177, '\p{Is_Grapheme_Cluster_Break=lv}', "");
    Expect(1, 55177, '\p{^Is_Grapheme_Cluster_Break=lv}', "");
    Expect(1, 55177, '\P{Is_Grapheme_Cluster_Break=lv}', "");
    Expect(0, 55177, '\P{^Is_Grapheme_Cluster_Break=lv}', "");
    Expect(1, 55176, '\p{Is_Grapheme_Cluster_Break=--LV}', "");
    Expect(0, 55176, '\p{^Is_Grapheme_Cluster_Break=--LV}', "");
    Expect(0, 55176, '\P{Is_Grapheme_Cluster_Break=--LV}', "");
    Expect(1, 55176, '\P{^Is_Grapheme_Cluster_Break=--LV}', "");
    Expect(0, 55177, '\p{Is_Grapheme_Cluster_Break=--LV}', "");
    Expect(1, 55177, '\p{^Is_Grapheme_Cluster_Break=--LV}', "");
    Expect(1, 55177, '\P{Is_Grapheme_Cluster_Break=--LV}', "");
    Expect(0, 55177, '\P{^Is_Grapheme_Cluster_Break=--LV}', "");
    Error('\p{Is_GCB= lv:=}');
    Error('\P{Is_GCB= lv:=}');
    Expect(1, 55176, '\p{Is_GCB=lv}', "");
    Expect(0, 55176, '\p{^Is_GCB=lv}', "");
    Expect(0, 55176, '\P{Is_GCB=lv}', "");
    Expect(1, 55176, '\P{^Is_GCB=lv}', "");
    Expect(0, 55177, '\p{Is_GCB=lv}', "");
    Expect(1, 55177, '\p{^Is_GCB=lv}', "");
    Expect(1, 55177, '\P{Is_GCB=lv}', "");
    Expect(0, 55177, '\P{^Is_GCB=lv}', "");
    Expect(1, 55176, '\p{Is_GCB= -LV}', "");
    Expect(0, 55176, '\p{^Is_GCB= -LV}', "");
    Expect(0, 55176, '\P{Is_GCB= -LV}', "");
    Expect(1, 55176, '\P{^Is_GCB= -LV}', "");
    Expect(0, 55177, '\p{Is_GCB= -LV}', "");
    Expect(1, 55177, '\p{^Is_GCB= -LV}', "");
    Expect(1, 55177, '\P{Is_GCB= -LV}', "");
    Expect(0, 55177, '\P{^Is_GCB= -LV}', "");
    Error('\p{Grapheme_Cluster_Break=		lvt/a/}');
    Error('\P{Grapheme_Cluster_Break=		lvt/a/}');
    Expect(1, 55203, '\p{Grapheme_Cluster_Break=:\ALVT\z:}', "");;
    Expect(0, 55204, '\p{Grapheme_Cluster_Break=:\ALVT\z:}', "");;
    Expect(1, 55203, '\p{Grapheme_Cluster_Break=lvt}', "");
    Expect(0, 55203, '\p{^Grapheme_Cluster_Break=lvt}', "");
    Expect(0, 55203, '\P{Grapheme_Cluster_Break=lvt}', "");
    Expect(1, 55203, '\P{^Grapheme_Cluster_Break=lvt}', "");
    Expect(0, 55204, '\p{Grapheme_Cluster_Break=lvt}', "");
    Expect(1, 55204, '\p{^Grapheme_Cluster_Break=lvt}', "");
    Expect(1, 55204, '\P{Grapheme_Cluster_Break=lvt}', "");
    Expect(0, 55204, '\P{^Grapheme_Cluster_Break=lvt}', "");
    Expect(1, 55203, '\p{Grapheme_Cluster_Break=:\Alvt\z:}', "");;
    Expect(0, 55204, '\p{Grapheme_Cluster_Break=:\Alvt\z:}', "");;
    Expect(1, 55203, '\p{Grapheme_Cluster_Break=_ LVT}', "");
    Expect(0, 55203, '\p{^Grapheme_Cluster_Break=_ LVT}', "");
    Expect(0, 55203, '\P{Grapheme_Cluster_Break=_ LVT}', "");
    Expect(1, 55203, '\P{^Grapheme_Cluster_Break=_ LVT}', "");
    Expect(0, 55204, '\p{Grapheme_Cluster_Break=_ LVT}', "");
    Expect(1, 55204, '\p{^Grapheme_Cluster_Break=_ LVT}', "");
    Expect(1, 55204, '\P{Grapheme_Cluster_Break=_ LVT}', "");
    Expect(0, 55204, '\P{^Grapheme_Cluster_Break=_ LVT}', "");
    Error('\p{GCB=-:=lvt}');
    Error('\P{GCB=-:=lvt}');
    Expect(1, 55203, '\p{GCB=:\ALVT\z:}', "");;
    Expect(0, 55204, '\p{GCB=:\ALVT\z:}', "");;
    Expect(1, 55203, '\p{GCB=lvt}', "");
    Expect(0, 55203, '\p{^GCB=lvt}', "");
    Expect(0, 55203, '\P{GCB=lvt}', "");
    Expect(1, 55203, '\P{^GCB=lvt}', "");
    Expect(0, 55204, '\p{GCB=lvt}', "");
    Expect(1, 55204, '\p{^GCB=lvt}', "");
    Expect(1, 55204, '\P{GCB=lvt}', "");
    Expect(0, 55204, '\P{^GCB=lvt}', "");
    Expect(1, 55203, '\p{GCB=:\Alvt\z:}', "");;
    Expect(0, 55204, '\p{GCB=:\Alvt\z:}', "");;
    Expect(1, 55203, '\p{GCB=--LVT}', "");
    Expect(0, 55203, '\p{^GCB=--LVT}', "");
    Expect(0, 55203, '\P{GCB=--LVT}', "");
    Expect(1, 55203, '\P{^GCB=--LVT}', "");
    Expect(0, 55204, '\p{GCB=--LVT}', "");
    Expect(1, 55204, '\p{^GCB=--LVT}', "");
    Expect(1, 55204, '\P{GCB=--LVT}', "");
    Expect(0, 55204, '\P{^GCB=--LVT}', "");
    Error('\p{Is_Grapheme_Cluster_Break= lvt/a/}');
    Error('\P{Is_Grapheme_Cluster_Break= lvt/a/}');
    Expect(1, 55203, '\p{Is_Grapheme_Cluster_Break=lvt}', "");
    Expect(0, 55203, '\p{^Is_Grapheme_Cluster_Break=lvt}', "");
    Expect(0, 55203, '\P{Is_Grapheme_Cluster_Break=lvt}', "");
    Expect(1, 55203, '\P{^Is_Grapheme_Cluster_Break=lvt}', "");
    Expect(0, 55204, '\p{Is_Grapheme_Cluster_Break=lvt}', "");
    Expect(1, 55204, '\p{^Is_Grapheme_Cluster_Break=lvt}', "");
    Expect(1, 55204, '\P{Is_Grapheme_Cluster_Break=lvt}', "");
    Expect(0, 55204, '\P{^Is_Grapheme_Cluster_Break=lvt}', "");
    Expect(1, 55203, '\p{Is_Grapheme_Cluster_Break:   _-LVT}', "");
    Expect(0, 55203, '\p{^Is_Grapheme_Cluster_Break:   _-LVT}', "");
    Expect(0, 55203, '\P{Is_Grapheme_Cluster_Break:   _-LVT}', "");
    Expect(1, 55203, '\P{^Is_Grapheme_Cluster_Break:   _-LVT}', "");
    Expect(0, 55204, '\p{Is_Grapheme_Cluster_Break:   _-LVT}', "");
    Expect(1, 55204, '\p{^Is_Grapheme_Cluster_Break:   _-LVT}', "");
    Expect(1, 55204, '\P{Is_Grapheme_Cluster_Break:   _-LVT}', "");
    Expect(0, 55204, '\P{^Is_Grapheme_Cluster_Break:   _-LVT}', "");
    Error('\p{Is_GCB=-	LVT:=}');
    Error('\P{Is_GCB=-	LVT:=}');
    Expect(1, 55203, '\p{Is_GCB=lvt}', "");
    Expect(0, 55203, '\p{^Is_GCB=lvt}', "");
    Expect(0, 55203, '\P{Is_GCB=lvt}', "");
    Expect(1, 55203, '\P{^Is_GCB=lvt}', "");
    Expect(0, 55204, '\p{Is_GCB=lvt}', "");
    Expect(1, 55204, '\p{^Is_GCB=lvt}', "");
    Expect(1, 55204, '\P{Is_GCB=lvt}', "");
    Expect(0, 55204, '\P{^Is_GCB=lvt}', "");
    Expect(1, 55203, '\p{Is_GCB=_LVT}', "");
    Expect(0, 55203, '\p{^Is_GCB=_LVT}', "");
    Expect(0, 55203, '\P{Is_GCB=_LVT}', "");
    Expect(1, 55203, '\P{^Is_GCB=_LVT}', "");
    Expect(0, 55204, '\p{Is_GCB=_LVT}', "");
    Expect(1, 55204, '\p{^Is_GCB=_LVT}', "");
    Expect(1, 55204, '\P{Is_GCB=_LVT}', "");
    Expect(0, 55204, '\P{^Is_GCB=_LVT}', "");
    Error('\p{Grapheme_Cluster_Break=-:=Prepend}');
    Error('\P{Grapheme_Cluster_Break=-:=Prepend}');
    Expect(1, 73474, '\p{Grapheme_Cluster_Break=:\APrepend\z:}', "");;
    Expect(0, 73475, '\p{Grapheme_Cluster_Break=:\APrepend\z:}', "");;
    Expect(1, 73474, '\p{Grapheme_Cluster_Break=prepend}', "");
    Expect(0, 73474, '\p{^Grapheme_Cluster_Break=prepend}', "");
    Expect(0, 73474, '\P{Grapheme_Cluster_Break=prepend}', "");
    Expect(1, 73474, '\P{^Grapheme_Cluster_Break=prepend}', "");
    Expect(0, 73475, '\p{Grapheme_Cluster_Break=prepend}', "");
    Expect(1, 73475, '\p{^Grapheme_Cluster_Break=prepend}', "");
    Expect(1, 73475, '\P{Grapheme_Cluster_Break=prepend}', "");
    Expect(0, 73475, '\P{^Grapheme_Cluster_Break=prepend}', "");
    Expect(1, 73474, '\p{Grapheme_Cluster_Break=:\Aprepend\z:}', "");;
    Expect(0, 73475, '\p{Grapheme_Cluster_Break=:\Aprepend\z:}', "");;
    Expect(1, 73474, '\p{Grapheme_Cluster_Break=-_Prepend}', "");
    Expect(0, 73474, '\p{^Grapheme_Cluster_Break=-_Prepend}', "");
    Expect(0, 73474, '\P{Grapheme_Cluster_Break=-_Prepend}', "");
    Expect(1, 73474, '\P{^Grapheme_Cluster_Break=-_Prepend}', "");
    Expect(0, 73475, '\p{Grapheme_Cluster_Break=-_Prepend}', "");
    Expect(1, 73475, '\p{^Grapheme_Cluster_Break=-_Prepend}', "");
    Expect(1, 73475, '\P{Grapheme_Cluster_Break=-_Prepend}', "");
    Expect(0, 73475, '\P{^Grapheme_Cluster_Break=-_Prepend}', "");
    Error('\p{GCB: /a/PP}');
    Error('\P{GCB: /a/PP}');
    Expect(1, 73474, '\p{GCB=:\APP\z:}', "");;
    Expect(0, 73475, '\p{GCB=:\APP\z:}', "");;
    Expect(1, 73474, '\p{GCB=pp}', "");
    Expect(0, 73474, '\p{^GCB=pp}', "");
    Expect(0, 73474, '\P{GCB=pp}', "");
    Expect(1, 73474, '\P{^GCB=pp}', "");
    Expect(0, 73475, '\p{GCB=pp}', "");
    Expect(1, 73475, '\p{^GCB=pp}', "");
    Expect(1, 73475, '\P{GCB=pp}', "");
    Expect(0, 73475, '\P{^GCB=pp}', "");
    Expect(1, 73474, '\p{GCB=:\App\z:}', "");;
    Expect(0, 73475, '\p{GCB=:\App\z:}', "");;
    Expect(1, 73474, '\p{GCB=-pp}', "");
    Expect(0, 73474, '\p{^GCB=-pp}', "");
    Expect(0, 73474, '\P{GCB=-pp}', "");
    Expect(1, 73474, '\P{^GCB=-pp}', "");
    Expect(0, 73475, '\p{GCB=-pp}', "");
    Expect(1, 73475, '\p{^GCB=-pp}', "");
    Expect(1, 73475, '\P{GCB=-pp}', "");
    Expect(0, 73475, '\P{^GCB=-pp}', "");
    Error('\p{Is_Grapheme_Cluster_Break=-/a/Prepend}');
    Error('\P{Is_Grapheme_Cluster_Break=-/a/Prepend}');
    Expect(1, 73474, '\p{Is_Grapheme_Cluster_Break=prepend}', "");
    Expect(0, 73474, '\p{^Is_Grapheme_Cluster_Break=prepend}', "");
    Expect(0, 73474, '\P{Is_Grapheme_Cluster_Break=prepend}', "");
    Expect(1, 73474, '\P{^Is_Grapheme_Cluster_Break=prepend}', "");
    Expect(0, 73475, '\p{Is_Grapheme_Cluster_Break=prepend}', "");
    Expect(1, 73475, '\p{^Is_Grapheme_Cluster_Break=prepend}', "");
    Expect(1, 73475, '\P{Is_Grapheme_Cluster_Break=prepend}', "");
    Expect(0, 73475, '\P{^Is_Grapheme_Cluster_Break=prepend}', "");
    Expect(1, 73474, '\p{Is_Grapheme_Cluster_Break= _Prepend}', "");
    Expect(0, 73474, '\p{^Is_Grapheme_Cluster_Break= _Prepend}', "");
    Expect(0, 73474, '\P{Is_Grapheme_Cluster_Break= _Prepend}', "");
    Expect(1, 73474, '\P{^Is_Grapheme_Cluster_Break= _Prepend}', "");
    Expect(0, 73475, '\p{Is_Grapheme_Cluster_Break= _Prepend}', "");
    Expect(1, 73475, '\p{^Is_Grapheme_Cluster_Break= _Prepend}', "");
    Expect(1, 73475, '\P{Is_Grapheme_Cluster_Break= _Prepend}', "");
    Expect(0, 73475, '\P{^Is_Grapheme_Cluster_Break= _Prepend}', "");
    Error('\p{Is_GCB=:=PP}');
    Error('\P{Is_GCB=:=PP}');
    Expect(1, 73474, '\p{Is_GCB=pp}', "");
    Expect(0, 73474, '\p{^Is_GCB=pp}', "");
    Expect(0, 73474, '\P{Is_GCB=pp}', "");
    Expect(1, 73474, '\P{^Is_GCB=pp}', "");
    Expect(0, 73475, '\p{Is_GCB=pp}', "");
    Expect(1, 73475, '\p{^Is_GCB=pp}', "");
    Expect(1, 73475, '\P{Is_GCB=pp}', "");
    Expect(0, 73475, '\P{^Is_GCB=pp}', "");
    Expect(1, 73474, '\p{Is_GCB=- PP}', "");
    Expect(0, 73474, '\p{^Is_GCB=- PP}', "");
    Expect(0, 73474, '\P{Is_GCB=- PP}', "");
    Expect(1, 73474, '\P{^Is_GCB=- PP}', "");
    Expect(0, 73475, '\p{Is_GCB=- PP}', "");
    Expect(1, 73475, '\p{^Is_GCB=- PP}', "");
    Expect(1, 73475, '\P{Is_GCB=- PP}', "");
    Expect(0, 73475, '\P{^Is_GCB=- PP}', "");
    Error('\p{Grapheme_Cluster_Break=/a/_	Regional_Indicator}');
    Error('\P{Grapheme_Cluster_Break=/a/_	Regional_Indicator}');
    Expect(1, 127487, '\p{Grapheme_Cluster_Break=:\ARegional_Indicator\z:}', "");;
    Expect(0, 127488, '\p{Grapheme_Cluster_Break=:\ARegional_Indicator\z:}', "");;
    Expect(1, 127487, '\p{Grapheme_Cluster_Break=regionalindicator}', "");
    Expect(0, 127487, '\p{^Grapheme_Cluster_Break=regionalindicator}', "");
    Expect(0, 127487, '\P{Grapheme_Cluster_Break=regionalindicator}', "");
    Expect(1, 127487, '\P{^Grapheme_Cluster_Break=regionalindicator}', "");
    Expect(0, 127488, '\p{Grapheme_Cluster_Break=regionalindicator}', "");
    Expect(1, 127488, '\p{^Grapheme_Cluster_Break=regionalindicator}', "");
    Expect(1, 127488, '\P{Grapheme_Cluster_Break=regionalindicator}', "");
    Expect(0, 127488, '\P{^Grapheme_Cluster_Break=regionalindicator}', "");
    Expect(1, 127487, '\p{Grapheme_Cluster_Break=:\Aregionalindicator\z:}', "");;
    Expect(0, 127488, '\p{Grapheme_Cluster_Break=:\Aregionalindicator\z:}', "");;
    Expect(1, 127487, '\p{Grapheme_Cluster_Break=-Regional_INDICATOR}', "");
    Expect(0, 127487, '\p{^Grapheme_Cluster_Break=-Regional_INDICATOR}', "");
    Expect(0, 127487, '\P{Grapheme_Cluster_Break=-Regional_INDICATOR}', "");
    Expect(1, 127487, '\P{^Grapheme_Cluster_Break=-Regional_INDICATOR}', "");
    Expect(0, 127488, '\p{Grapheme_Cluster_Break=-Regional_INDICATOR}', "");
    Expect(1, 127488, '\p{^Grapheme_Cluster_Break=-Regional_INDICATOR}', "");
    Expect(1, 127488, '\P{Grapheme_Cluster_Break=-Regional_INDICATOR}', "");
    Expect(0, 127488, '\P{^Grapheme_Cluster_Break=-Regional_INDICATOR}', "");
    Error('\p{GCB= /a/ri}');
    Error('\P{GCB= /a/ri}');
    Expect(1, 127487, '\p{GCB=:\ARI\z:}', "");;
    Expect(0, 127488, '\p{GCB=:\ARI\z:}', "");;
    Expect(1, 127487, '\p{GCB=ri}', "");
    Expect(0, 127487, '\p{^GCB=ri}', "");
    Expect(0, 127487, '\P{GCB=ri}', "");
    Expect(1, 127487, '\P{^GCB=ri}', "");
    Expect(0, 127488, '\p{GCB=ri}', "");
    Expect(1, 127488, '\p{^GCB=ri}', "");
    Expect(1, 127488, '\P{GCB=ri}', "");
    Expect(0, 127488, '\P{^GCB=ri}', "");
    Expect(1, 127487, '\p{GCB=:\Ari\z:}', "");;
    Expect(0, 127488, '\p{GCB=:\Ari\z:}', "");;
    Expect(1, 127487, '\p{GCB=-_ri}', "");
    Expect(0, 127487, '\p{^GCB=-_ri}', "");
    Expect(0, 127487, '\P{GCB=-_ri}', "");
    Expect(1, 127487, '\P{^GCB=-_ri}', "");
    Expect(0, 127488, '\p{GCB=-_ri}', "");
    Expect(1, 127488, '\p{^GCB=-_ri}', "");
    Expect(1, 127488, '\P{GCB=-_ri}', "");
    Expect(0, 127488, '\P{^GCB=-_ri}', "");
    Error('\p{Is_Grapheme_Cluster_Break=_/a/Regional_INDICATOR}');
    Error('\P{Is_Grapheme_Cluster_Break=_/a/Regional_INDICATOR}');
    Expect(1, 127487, '\p{Is_Grapheme_Cluster_Break=regionalindicator}', "");
    Expect(0, 127487, '\p{^Is_Grapheme_Cluster_Break=regionalindicator}', "");
    Expect(0, 127487, '\P{Is_Grapheme_Cluster_Break=regionalindicator}', "");
    Expect(1, 127487, '\P{^Is_Grapheme_Cluster_Break=regionalindicator}', "");
    Expect(0, 127488, '\p{Is_Grapheme_Cluster_Break=regionalindicator}', "");
    Expect(1, 127488, '\p{^Is_Grapheme_Cluster_Break=regionalindicator}', "");
    Expect(1, 127488, '\P{Is_Grapheme_Cluster_Break=regionalindicator}', "");
    Expect(0, 127488, '\P{^Is_Grapheme_Cluster_Break=regionalindicator}', "");
    Expect(1, 127487, '\p{Is_Grapheme_Cluster_Break=_	regional_indicator}', "");
    Expect(0, 127487, '\p{^Is_Grapheme_Cluster_Break=_	regional_indicator}', "");
    Expect(0, 127487, '\P{Is_Grapheme_Cluster_Break=_	regional_indicator}', "");
    Expect(1, 127487, '\P{^Is_Grapheme_Cluster_Break=_	regional_indicator}', "");
    Expect(0, 127488, '\p{Is_Grapheme_Cluster_Break=_	regional_indicator}', "");
    Expect(1, 127488, '\p{^Is_Grapheme_Cluster_Break=_	regional_indicator}', "");
    Expect(1, 127488, '\P{Is_Grapheme_Cluster_Break=_	regional_indicator}', "");
    Expect(0, 127488, '\P{^Is_Grapheme_Cluster_Break=_	regional_indicator}', "");
    Error('\p{Is_GCB= -RI/a/}');
    Error('\P{Is_GCB= -RI/a/}');
    Expect(1, 127487, '\p{Is_GCB:   ri}', "");
    Expect(0, 127487, '\p{^Is_GCB:   ri}', "");
    Expect(0, 127487, '\P{Is_GCB:   ri}', "");
    Expect(1, 127487, '\P{^Is_GCB:   ri}', "");
    Expect(0, 127488, '\p{Is_GCB:   ri}', "");
    Expect(1, 127488, '\p{^Is_GCB:   ri}', "");
    Expect(1, 127488, '\P{Is_GCB:   ri}', "");
    Expect(0, 127488, '\P{^Is_GCB:   ri}', "");
    Expect(1, 127487, '\p{Is_GCB=  ri}', "");
    Expect(0, 127487, '\p{^Is_GCB=  ri}', "");
    Expect(0, 127487, '\P{Is_GCB=  ri}', "");
    Expect(1, 127487, '\P{^Is_GCB=  ri}', "");
    Expect(0, 127488, '\p{Is_GCB=  ri}', "");
    Expect(1, 127488, '\p{^Is_GCB=  ri}', "");
    Expect(1, 127488, '\P{Is_GCB=  ri}', "");
    Expect(0, 127488, '\P{^Is_GCB=  ri}', "");
    Error('\p{Grapheme_Cluster_Break=	-SpacingMark/a/}');
    Error('\P{Grapheme_Cluster_Break=	-SpacingMark/a/}');
    Expect(1, 119149, '\p{Grapheme_Cluster_Break=:\ASpacingMark\z:}', "");;
    Expect(0, 119150, '\p{Grapheme_Cluster_Break=:\ASpacingMark\z:}', "");;
    Expect(1, 119149, '\p{Grapheme_Cluster_Break=spacingmark}', "");
    Expect(0, 119149, '\p{^Grapheme_Cluster_Break=spacingmark}', "");
    Expect(0, 119149, '\P{Grapheme_Cluster_Break=spacingmark}', "");
    Expect(1, 119149, '\P{^Grapheme_Cluster_Break=spacingmark}', "");
    Expect(0, 119150, '\p{Grapheme_Cluster_Break=spacingmark}', "");
    Expect(1, 119150, '\p{^Grapheme_Cluster_Break=spacingmark}', "");
    Expect(1, 119150, '\P{Grapheme_Cluster_Break=spacingmark}', "");
    Expect(0, 119150, '\P{^Grapheme_Cluster_Break=spacingmark}', "");
    Expect(1, 119149, '\p{Grapheme_Cluster_Break=:\Aspacingmark\z:}', "");;
    Expect(0, 119150, '\p{Grapheme_Cluster_Break=:\Aspacingmark\z:}', "");;
    Expect(1, 119149, '\p{Grapheme_Cluster_Break= 	SpacingMark}', "");
    Expect(0, 119149, '\p{^Grapheme_Cluster_Break= 	SpacingMark}', "");
    Expect(0, 119149, '\P{Grapheme_Cluster_Break= 	SpacingMark}', "");
    Expect(1, 119149, '\P{^Grapheme_Cluster_Break= 	SpacingMark}', "");
    Expect(0, 119150, '\p{Grapheme_Cluster_Break= 	SpacingMark}', "");
    Expect(1, 119150, '\p{^Grapheme_Cluster_Break= 	SpacingMark}', "");
    Expect(1, 119150, '\P{Grapheme_Cluster_Break= 	SpacingMark}', "");
    Expect(0, 119150, '\P{^Grapheme_Cluster_Break= 	SpacingMark}', "");
    Error('\p{GCB=:=		SM}');
    Error('\P{GCB=:=		SM}');
    Expect(1, 119149, '\p{GCB=:\ASM\z:}', "");;
    Expect(0, 119150, '\p{GCB=:\ASM\z:}', "");;
    Expect(1, 119149, '\p{GCB=sm}', "");
    Expect(0, 119149, '\p{^GCB=sm}', "");
    Expect(0, 119149, '\P{GCB=sm}', "");
    Expect(1, 119149, '\P{^GCB=sm}', "");
    Expect(0, 119150, '\p{GCB=sm}', "");
    Expect(1, 119150, '\p{^GCB=sm}', "");
    Expect(1, 119150, '\P{GCB=sm}', "");
    Expect(0, 119150, '\P{^GCB=sm}', "");
    Expect(1, 119149, '\p{GCB=:\Asm\z:}', "");;
    Expect(0, 119150, '\p{GCB=:\Asm\z:}', "");;
    Expect(1, 119149, '\p{GCB=_ sm}', "");
    Expect(0, 119149, '\p{^GCB=_ sm}', "");
    Expect(0, 119149, '\P{GCB=_ sm}', "");
    Expect(1, 119149, '\P{^GCB=_ sm}', "");
    Expect(0, 119150, '\p{GCB=_ sm}', "");
    Expect(1, 119150, '\p{^GCB=_ sm}', "");
    Expect(1, 119150, '\P{GCB=_ sm}', "");
    Expect(0, 119150, '\P{^GCB=_ sm}', "");
    Error('\p{Is_Grapheme_Cluster_Break: -SpacingMark:=}');
    Error('\P{Is_Grapheme_Cluster_Break: -SpacingMark:=}');
    Expect(1, 119149, '\p{Is_Grapheme_Cluster_Break=spacingmark}', "");
    Expect(0, 119149, '\p{^Is_Grapheme_Cluster_Break=spacingmark}', "");
    Expect(0, 119149, '\P{Is_Grapheme_Cluster_Break=spacingmark}', "");
    Expect(1, 119149, '\P{^Is_Grapheme_Cluster_Break=spacingmark}', "");
    Expect(0, 119150, '\p{Is_Grapheme_Cluster_Break=spacingmark}', "");
    Expect(1, 119150, '\p{^Is_Grapheme_Cluster_Break=spacingmark}', "");
    Expect(1, 119150, '\P{Is_Grapheme_Cluster_Break=spacingmark}', "");
    Expect(0, 119150, '\P{^Is_Grapheme_Cluster_Break=spacingmark}', "");
    Expect(1, 119149, '\p{Is_Grapheme_Cluster_Break=_SPACINGMARK}', "");
    Expect(0, 119149, '\p{^Is_Grapheme_Cluster_Break=_SPACINGMARK}', "");
    Expect(0, 119149, '\P{Is_Grapheme_Cluster_Break=_SPACINGMARK}', "");
    Expect(1, 119149, '\P{^Is_Grapheme_Cluster_Break=_SPACINGMARK}', "");
    Expect(0, 119150, '\p{Is_Grapheme_Cluster_Break=_SPACINGMARK}', "");
    Expect(1, 119150, '\p{^Is_Grapheme_Cluster_Break=_SPACINGMARK}', "");
    Expect(1, 119150, '\P{Is_Grapheme_Cluster_Break=_SPACINGMARK}', "");
    Expect(0, 119150, '\P{^Is_Grapheme_Cluster_Break=_SPACINGMARK}', "");
    Error('\p{Is_GCB:-:=sm}');
    Error('\P{Is_GCB:-:=sm}');
    Expect(1, 119149, '\p{Is_GCB=sm}', "");
    Expect(0, 119149, '\p{^Is_GCB=sm}', "");
    Expect(0, 119149, '\P{Is_GCB=sm}', "");
    Expect(1, 119149, '\P{^Is_GCB=sm}', "");
    Expect(0, 119150, '\p{Is_GCB=sm}', "");
    Expect(1, 119150, '\p{^Is_GCB=sm}', "");
    Expect(1, 119150, '\P{Is_GCB=sm}', "");
    Expect(0, 119150, '\P{^Is_GCB=sm}', "");
    Expect(1, 119149, '\p{Is_GCB=_	SM}', "");
    Expect(0, 119149, '\p{^Is_GCB=_	SM}', "");
    Expect(0, 119149, '\P{Is_GCB=_	SM}', "");
    Expect(1, 119149, '\P{^Is_GCB=_	SM}', "");
    Expect(0, 119150, '\p{Is_GCB=_	SM}', "");
    Expect(1, 119150, '\p{^Is_GCB=_	SM}', "");
    Expect(1, 119150, '\P{Is_GCB=_	SM}', "");
    Expect(0, 119150, '\P{^Is_GCB=_	SM}', "");
    Error('\p{Grapheme_Cluster_Break=	/a/t}');
    Error('\P{Grapheme_Cluster_Break=	/a/t}');
    Expect(1, 55291, '\p{Grapheme_Cluster_Break=:\AT\z:}', "");;
    Expect(0, 55292, '\p{Grapheme_Cluster_Break=:\AT\z:}', "");;
    Expect(1, 55291, '\p{Grapheme_Cluster_Break=t}', "");
    Expect(0, 55291, '\p{^Grapheme_Cluster_Break=t}', "");
    Expect(0, 55291, '\P{Grapheme_Cluster_Break=t}', "");
    Expect(1, 55291, '\P{^Grapheme_Cluster_Break=t}', "");
    Expect(0, 55292, '\p{Grapheme_Cluster_Break=t}', "");
    Expect(1, 55292, '\p{^Grapheme_Cluster_Break=t}', "");
    Expect(1, 55292, '\P{Grapheme_Cluster_Break=t}', "");
    Expect(0, 55292, '\P{^Grapheme_Cluster_Break=t}', "");
    Expect(1, 55291, '\p{Grapheme_Cluster_Break=:\At\z:}', "");;
    Expect(0, 55292, '\p{Grapheme_Cluster_Break=:\At\z:}', "");;
    Expect(1, 55291, '\p{Grapheme_Cluster_Break=		T}', "");
    Expect(0, 55291, '\p{^Grapheme_Cluster_Break=		T}', "");
    Expect(0, 55291, '\P{Grapheme_Cluster_Break=		T}', "");
    Expect(1, 55291, '\P{^Grapheme_Cluster_Break=		T}', "");
    Expect(0, 55292, '\p{Grapheme_Cluster_Break=		T}', "");
    Expect(1, 55292, '\p{^Grapheme_Cluster_Break=		T}', "");
    Expect(1, 55292, '\P{Grapheme_Cluster_Break=		T}', "");
    Expect(0, 55292, '\P{^Grapheme_Cluster_Break=		T}', "");
    Error('\p{GCB= T/a/}');
    Error('\P{GCB= T/a/}');
    Expect(1, 55291, '\p{GCB=:\AT\z:}', "");;
    Expect(0, 55292, '\p{GCB=:\AT\z:}', "");;
    Expect(1, 55291, '\p{GCB=t}', "");
    Expect(0, 55291, '\p{^GCB=t}', "");
    Expect(0, 55291, '\P{GCB=t}', "");
    Expect(1, 55291, '\P{^GCB=t}', "");
    Expect(0, 55292, '\p{GCB=t}', "");
    Expect(1, 55292, '\p{^GCB=t}', "");
    Expect(1, 55292, '\P{GCB=t}', "");
    Expect(0, 55292, '\P{^GCB=t}', "");
    Expect(1, 55291, '\p{GCB=:\At\z:}', "");;
    Expect(0, 55292, '\p{GCB=:\At\z:}', "");;
    Expect(1, 55291, '\p{GCB=- T}', "");
    Expect(0, 55291, '\p{^GCB=- T}', "");
    Expect(0, 55291, '\P{GCB=- T}', "");
    Expect(1, 55291, '\P{^GCB=- T}', "");
    Expect(0, 55292, '\p{GCB=- T}', "");
    Expect(1, 55292, '\p{^GCB=- T}', "");
    Expect(1, 55292, '\P{GCB=- T}', "");
    Expect(0, 55292, '\P{^GCB=- T}', "");
    Error('\p{Is_Grapheme_Cluster_Break= /a/T}');
    Error('\P{Is_Grapheme_Cluster_Break= /a/T}');
    Expect(1, 55291, '\p{Is_Grapheme_Cluster_Break:t}', "");
    Expect(0, 55291, '\p{^Is_Grapheme_Cluster_Break:t}', "");
    Expect(0, 55291, '\P{Is_Grapheme_Cluster_Break:t}', "");
    Expect(1, 55291, '\P{^Is_Grapheme_Cluster_Break:t}', "");
    Expect(0, 55292, '\p{Is_Grapheme_Cluster_Break:t}', "");
    Expect(1, 55292, '\p{^Is_Grapheme_Cluster_Break:t}', "");
    Expect(1, 55292, '\P{Is_Grapheme_Cluster_Break:t}', "");
    Expect(0, 55292, '\P{^Is_Grapheme_Cluster_Break:t}', "");
    Expect(1, 55291, '\p{Is_Grapheme_Cluster_Break=-_T}', "");
    Expect(0, 55291, '\p{^Is_Grapheme_Cluster_Break=-_T}', "");
    Expect(0, 55291, '\P{Is_Grapheme_Cluster_Break=-_T}', "");
    Expect(1, 55291, '\P{^Is_Grapheme_Cluster_Break=-_T}', "");
    Expect(0, 55292, '\p{Is_Grapheme_Cluster_Break=-_T}', "");
    Expect(1, 55292, '\p{^Is_Grapheme_Cluster_Break=-_T}', "");
    Expect(1, 55292, '\P{Is_Grapheme_Cluster_Break=-_T}', "");
    Expect(0, 55292, '\P{^Is_Grapheme_Cluster_Break=-_T}', "");
    Error('\p{Is_GCB:	:=	T}');
    Error('\P{Is_GCB:	:=	T}');
    Expect(1, 55291, '\p{Is_GCB=t}', "");
    Expect(0, 55291, '\p{^Is_GCB=t}', "");
    Expect(0, 55291, '\P{Is_GCB=t}', "");
    Expect(1, 55291, '\P{^Is_GCB=t}', "");
    Expect(0, 55292, '\p{Is_GCB=t}', "");
    Expect(1, 55292, '\p{^Is_GCB=t}', "");
    Expect(1, 55292, '\P{Is_GCB=t}', "");
    Expect(0, 55292, '\P{^Is_GCB=t}', "");
    Expect(1, 55291, '\p{Is_GCB=-T}', "");
    Expect(0, 55291, '\p{^Is_GCB=-T}', "");
    Expect(0, 55291, '\P{Is_GCB=-T}', "");
    Expect(1, 55291, '\P{^Is_GCB=-T}', "");
    Expect(0, 55292, '\p{Is_GCB=-T}', "");
    Expect(1, 55292, '\p{^Is_GCB=-T}', "");
    Expect(1, 55292, '\P{Is_GCB=-T}', "");
    Expect(0, 55292, '\P{^Is_GCB=-T}', "");
    Error('\p{Grapheme_Cluster_Break=		V/a/}');
    Error('\P{Grapheme_Cluster_Break=		V/a/}');
    Expect(1, 55238, '\p{Grapheme_Cluster_Break=:\AV\z:}', "");;
    Expect(0, 55239, '\p{Grapheme_Cluster_Break=:\AV\z:}', "");;
    Expect(1, 55238, '\p{Grapheme_Cluster_Break=v}', "");
    Expect(0, 55238, '\p{^Grapheme_Cluster_Break=v}', "");
    Expect(0, 55238, '\P{Grapheme_Cluster_Break=v}', "");
    Expect(1, 55238, '\P{^Grapheme_Cluster_Break=v}', "");
    Expect(0, 55239, '\p{Grapheme_Cluster_Break=v}', "");
    Expect(1, 55239, '\p{^Grapheme_Cluster_Break=v}', "");
    Expect(1, 55239, '\P{Grapheme_Cluster_Break=v}', "");
    Expect(0, 55239, '\P{^Grapheme_Cluster_Break=v}', "");
    Expect(1, 55238, '\p{Grapheme_Cluster_Break=:\Av\z:}', "");;
    Expect(0, 55239, '\p{Grapheme_Cluster_Break=:\Av\z:}', "");;
    Error('\p{GCB:   -/a/V}');
    Error('\P{GCB:   -/a/V}');
    Expect(1, 55238, '\p{GCB=:\AV\z:}', "");;
    Expect(0, 55239, '\p{GCB=:\AV\z:}', "");;
    Expect(1, 55238, '\p{GCB=v}', "");
    Expect(0, 55238, '\p{^GCB=v}', "");
    Expect(0, 55238, '\P{GCB=v}', "");
    Expect(1, 55238, '\P{^GCB=v}', "");
    Expect(0, 55239, '\p{GCB=v}', "");
    Expect(1, 55239, '\p{^GCB=v}', "");
    Expect(1, 55239, '\P{GCB=v}', "");
    Expect(0, 55239, '\P{^GCB=v}', "");
    Expect(1, 55238, '\p{GCB=:\Av\z:}', "");;
    Expect(0, 55239, '\p{GCB=:\Av\z:}', "");;
    Expect(1, 55238, '\p{GCB:    	v}', "");
    Expect(0, 55238, '\p{^GCB:    	v}', "");
    Expect(0, 55238, '\P{GCB:    	v}', "");
    Expect(1, 55238, '\P{^GCB:    	v}', "");
    Expect(0, 55239, '\p{GCB:    	v}', "");
    Expect(1, 55239, '\p{^GCB:    	v}', "");
    Expect(1, 55239, '\P{GCB:    	v}', "");
    Expect(0, 55239, '\P{^GCB:    	v}', "");
    Error('\p{Is_Grapheme_Cluster_Break=-:=V}');
    Error('\P{Is_Grapheme_Cluster_Break=-:=V}');
    Expect(1, 55238, '\p{Is_Grapheme_Cluster_Break=v}', "");
    Expect(0, 55238, '\p{^Is_Grapheme_Cluster_Break=v}', "");
    Expect(0, 55238, '\P{Is_Grapheme_Cluster_Break=v}', "");
    Expect(1, 55238, '\P{^Is_Grapheme_Cluster_Break=v}', "");
    Expect(0, 55239, '\p{Is_Grapheme_Cluster_Break=v}', "");
    Expect(1, 55239, '\p{^Is_Grapheme_Cluster_Break=v}', "");
    Expect(1, 55239, '\P{Is_Grapheme_Cluster_Break=v}', "");
    Expect(0, 55239, '\P{^Is_Grapheme_Cluster_Break=v}', "");
    Expect(1, 55238, '\p{Is_Grapheme_Cluster_Break=_ V}', "");
    Expect(0, 55238, '\p{^Is_Grapheme_Cluster_Break=_ V}', "");
    Expect(0, 55238, '\P{Is_Grapheme_Cluster_Break=_ V}', "");
    Expect(1, 55238, '\P{^Is_Grapheme_Cluster_Break=_ V}', "");
    Expect(0, 55239, '\p{Is_Grapheme_Cluster_Break=_ V}', "");
    Expect(1, 55239, '\p{^Is_Grapheme_Cluster_Break=_ V}', "");
    Expect(1, 55239, '\P{Is_Grapheme_Cluster_Break=_ V}', "");
    Expect(0, 55239, '\P{^Is_Grapheme_Cluster_Break=_ V}', "");
    Error('\p{Is_GCB=:=V}');
    Error('\P{Is_GCB=:=V}');
    Expect(1, 55238, '\p{Is_GCB=v}', "");
    Expect(0, 55238, '\p{^Is_GCB=v}', "");
    Expect(0, 55238, '\P{Is_GCB=v}', "");
    Expect(1, 55238, '\P{^Is_GCB=v}', "");
    Expect(0, 55239, '\p{Is_GCB=v}', "");
    Expect(1, 55239, '\p{^Is_GCB=v}', "");
    Expect(1, 55239, '\P{Is_GCB=v}', "");
    Expect(0, 55239, '\P{^Is_GCB=v}', "");
    Expect(1, 55238, '\p{Is_GCB=_V}', "");
    Expect(0, 55238, '\p{^Is_GCB=_V}', "");
    Expect(0, 55238, '\P{Is_GCB=_V}', "");
    Expect(1, 55238, '\P{^Is_GCB=_V}', "");
    Expect(0, 55239, '\p{Is_GCB=_V}', "");
    Expect(1, 55239, '\p{^Is_GCB=_V}', "");
    Expect(1, 55239, '\P{Is_GCB=_V}', "");
    Expect(0, 55239, '\P{^Is_GCB=_V}', "");
    Error('\p{Grapheme_Cluster_Break=	-OTHER:=}');
    Error('\P{Grapheme_Cluster_Break=	-OTHER:=}');
    Expect(1, 921600, '\p{Grapheme_Cluster_Break=:\AOther\z:}', "");;
    Expect(0, 921599, '\p{Grapheme_Cluster_Break=:\AOther\z:}', "");;
    Expect(1, 921600, '\p{Grapheme_Cluster_Break=other}', "");
    Expect(0, 921600, '\p{^Grapheme_Cluster_Break=other}', "");
    Expect(0, 921600, '\P{Grapheme_Cluster_Break=other}', "");
    Expect(1, 921600, '\P{^Grapheme_Cluster_Break=other}', "");
    Expect(0, 921599, '\p{Grapheme_Cluster_Break=other}', "");
    Expect(1, 921599, '\p{^Grapheme_Cluster_Break=other}', "");
    Expect(1, 921599, '\P{Grapheme_Cluster_Break=other}', "");
    Expect(0, 921599, '\P{^Grapheme_Cluster_Break=other}', "");
    Expect(1, 921600, '\p{Grapheme_Cluster_Break=:\Aother\z:}', "");;
    Expect(0, 921599, '\p{Grapheme_Cluster_Break=:\Aother\z:}', "");;
    Expect(1, 921600, '\p{Grapheme_Cluster_Break=_-other}', "");
    Expect(0, 921600, '\p{^Grapheme_Cluster_Break=_-other}', "");
    Expect(0, 921600, '\P{Grapheme_Cluster_Break=_-other}', "");
    Expect(1, 921600, '\P{^Grapheme_Cluster_Break=_-other}', "");
    Expect(0, 921599, '\p{Grapheme_Cluster_Break=_-other}', "");
    Expect(1, 921599, '\p{^Grapheme_Cluster_Break=_-other}', "");
    Expect(1, 921599, '\P{Grapheme_Cluster_Break=_-other}', "");
    Expect(0, 921599, '\P{^Grapheme_Cluster_Break=_-other}', "");
    Error('\p{GCB=/a/XX}');
    Error('\P{GCB=/a/XX}');
    Expect(1, 921600, '\p{GCB=:\AXX\z:}', "");;
    Expect(0, 921599, '\p{GCB=:\AXX\z:}', "");;
    Expect(1, 921600, '\p{GCB=xx}', "");
    Expect(0, 921600, '\p{^GCB=xx}', "");
    Expect(0, 921600, '\P{GCB=xx}', "");
    Expect(1, 921600, '\P{^GCB=xx}', "");
    Expect(0, 921599, '\p{GCB=xx}', "");
    Expect(1, 921599, '\p{^GCB=xx}', "");
    Expect(1, 921599, '\P{GCB=xx}', "");
    Expect(0, 921599, '\P{^GCB=xx}', "");
    Expect(1, 921600, '\p{GCB=:\Axx\z:}', "");;
    Expect(0, 921599, '\p{GCB=:\Axx\z:}', "");;
    Expect(1, 921600, '\p{GCB=_xx}', "");
    Expect(0, 921600, '\p{^GCB=_xx}', "");
    Expect(0, 921600, '\P{GCB=_xx}', "");
    Expect(1, 921600, '\P{^GCB=_xx}', "");
    Expect(0, 921599, '\p{GCB=_xx}', "");
    Expect(1, 921599, '\p{^GCB=_xx}', "");
    Expect(1, 921599, '\P{GCB=_xx}', "");
    Expect(0, 921599, '\P{^GCB=_xx}', "");
    Error('\p{Is_Grapheme_Cluster_Break=-	other/a/}');
    Error('\P{Is_Grapheme_Cluster_Break=-	other/a/}');
    Expect(1, 921600, '\p{Is_Grapheme_Cluster_Break=other}', "");
    Expect(0, 921600, '\p{^Is_Grapheme_Cluster_Break=other}', "");
    Expect(0, 921600, '\P{Is_Grapheme_Cluster_Break=other}', "");
    Expect(1, 921600, '\P{^Is_Grapheme_Cluster_Break=other}', "");
    Expect(0, 921599, '\p{Is_Grapheme_Cluster_Break=other}', "");
    Expect(1, 921599, '\p{^Is_Grapheme_Cluster_Break=other}', "");
    Expect(1, 921599, '\P{Is_Grapheme_Cluster_Break=other}', "");
    Expect(0, 921599, '\P{^Is_Grapheme_Cluster_Break=other}', "");
    Expect(1, 921600, '\p{Is_Grapheme_Cluster_Break=	OTHER}', "");
    Expect(0, 921600, '\p{^Is_Grapheme_Cluster_Break=	OTHER}', "");
    Expect(0, 921600, '\P{Is_Grapheme_Cluster_Break=	OTHER}', "");
    Expect(1, 921600, '\P{^Is_Grapheme_Cluster_Break=	OTHER}', "");
    Expect(0, 921599, '\p{Is_Grapheme_Cluster_Break=	OTHER}', "");
    Expect(1, 921599, '\p{^Is_Grapheme_Cluster_Break=	OTHER}', "");
    Expect(1, 921599, '\P{Is_Grapheme_Cluster_Break=	OTHER}', "");
    Expect(0, 921599, '\P{^Is_Grapheme_Cluster_Break=	OTHER}', "");
    Error('\p{Is_GCB=:=		XX}');
    Error('\P{Is_GCB=:=		XX}');
    Expect(1, 921600, '\p{Is_GCB=xx}', "");
    Expect(0, 921600, '\p{^Is_GCB=xx}', "");
    Expect(0, 921600, '\P{Is_GCB=xx}', "");
    Expect(1, 921600, '\P{^Is_GCB=xx}', "");
    Expect(0, 921599, '\p{Is_GCB=xx}', "");
    Expect(1, 921599, '\p{^Is_GCB=xx}', "");
    Expect(1, 921599, '\P{Is_GCB=xx}', "");
    Expect(0, 921599, '\P{^Is_GCB=xx}', "");
    Expect(1, 921600, '\p{Is_GCB=XX}', "");
    Expect(0, 921600, '\p{^Is_GCB=XX}', "");
    Expect(0, 921600, '\P{Is_GCB=XX}', "");
    Expect(1, 921600, '\P{^Is_GCB=XX}', "");
    Expect(0, 921599, '\p{Is_GCB=XX}', "");
    Expect(1, 921599, '\p{^Is_GCB=XX}', "");
    Expect(1, 921599, '\P{Is_GCB=XX}', "");
    Expect(0, 921599, '\P{^Is_GCB=XX}', "");
    Error('\p{Grapheme_Cluster_Break=_:=ZWJ}');
    Error('\P{Grapheme_Cluster_Break=_:=ZWJ}');
    Expect(1, 8205, '\p{Grapheme_Cluster_Break=:\AZWJ\z:}', "");;
    Expect(0, 8206, '\p{Grapheme_Cluster_Break=:\AZWJ\z:}', "");;
    Expect(1, 8205, '\p{Grapheme_Cluster_Break:   zwj}', "");
    Expect(0, 8205, '\p{^Grapheme_Cluster_Break:   zwj}', "");
    Expect(0, 8205, '\P{Grapheme_Cluster_Break:   zwj}', "");
    Expect(1, 8205, '\P{^Grapheme_Cluster_Break:   zwj}', "");
    Expect(0, 8206, '\p{Grapheme_Cluster_Break:   zwj}', "");
    Expect(1, 8206, '\p{^Grapheme_Cluster_Break:   zwj}', "");
    Expect(1, 8206, '\P{Grapheme_Cluster_Break:   zwj}', "");
    Expect(0, 8206, '\P{^Grapheme_Cluster_Break:   zwj}', "");
    Expect(1, 8205, '\p{Grapheme_Cluster_Break=:\Azwj\z:}', "");;
    Expect(0, 8206, '\p{Grapheme_Cluster_Break=:\Azwj\z:}', "");;
    Expect(1, 8205, '\p{Grapheme_Cluster_Break=		ZWJ}', "");
    Expect(0, 8205, '\p{^Grapheme_Cluster_Break=		ZWJ}', "");
    Expect(0, 8205, '\P{Grapheme_Cluster_Break=		ZWJ}', "");
    Expect(1, 8205, '\P{^Grapheme_Cluster_Break=		ZWJ}', "");
    Expect(0, 8206, '\p{Grapheme_Cluster_Break=		ZWJ}', "");
    Expect(1, 8206, '\p{^Grapheme_Cluster_Break=		ZWJ}', "");
    Expect(1, 8206, '\P{Grapheme_Cluster_Break=		ZWJ}', "");
    Expect(0, 8206, '\P{^Grapheme_Cluster_Break=		ZWJ}', "");
    Error('\p{GCB=	ZWJ/a/}');
    Error('\P{GCB=	ZWJ/a/}');
    Expect(1, 8205, '\p{GCB=:\AZWJ\z:}', "");;
    Expect(0, 8206, '\p{GCB=:\AZWJ\z:}', "");;
    Expect(1, 8205, '\p{GCB=zwj}', "");
    Expect(0, 8205, '\p{^GCB=zwj}', "");
    Expect(0, 8205, '\P{GCB=zwj}', "");
    Expect(1, 8205, '\P{^GCB=zwj}', "");
    Expect(0, 8206, '\p{GCB=zwj}', "");
    Expect(1, 8206, '\p{^GCB=zwj}', "");
    Expect(1, 8206, '\P{GCB=zwj}', "");
    Expect(0, 8206, '\P{^GCB=zwj}', "");
    Expect(1, 8205, '\p{GCB=:\Azwj\z:}', "");;
    Expect(0, 8206, '\p{GCB=:\Azwj\z:}', "");;
    Expect(1, 8205, '\p{GCB=-	zwj}', "");
    Expect(0, 8205, '\p{^GCB=-	zwj}', "");
    Expect(0, 8205, '\P{GCB=-	zwj}', "");
    Expect(1, 8205, '\P{^GCB=-	zwj}', "");
    Expect(0, 8206, '\p{GCB=-	zwj}', "");
    Expect(1, 8206, '\p{^GCB=-	zwj}', "");
    Expect(1, 8206, '\P{GCB=-	zwj}', "");
    Expect(0, 8206, '\P{^GCB=-	zwj}', "");
    Error('\p{Is_Grapheme_Cluster_Break=_:=ZWJ}');
    Error('\P{Is_Grapheme_Cluster_Break=_:=ZWJ}');
    Expect(1, 8205, '\p{Is_Grapheme_Cluster_Break=zwj}', "");
    Expect(0, 8205, '\p{^Is_Grapheme_Cluster_Break=zwj}', "");
    Expect(0, 8205, '\P{Is_Grapheme_Cluster_Break=zwj}', "");
    Expect(1, 8205, '\P{^Is_Grapheme_Cluster_Break=zwj}', "");
    Expect(0, 8206, '\p{Is_Grapheme_Cluster_Break=zwj}', "");
    Expect(1, 8206, '\p{^Is_Grapheme_Cluster_Break=zwj}', "");
    Expect(1, 8206, '\P{Is_Grapheme_Cluster_Break=zwj}', "");
    Expect(0, 8206, '\P{^Is_Grapheme_Cluster_Break=zwj}', "");
    Expect(1, 8205, '\p{Is_Grapheme_Cluster_Break=  ZWJ}', "");
    Expect(0, 8205, '\p{^Is_Grapheme_Cluster_Break=  ZWJ}', "");
    Expect(0, 8205, '\P{Is_Grapheme_Cluster_Break=  ZWJ}', "");
    Expect(1, 8205, '\P{^Is_Grapheme_Cluster_Break=  ZWJ}', "");
    Expect(0, 8206, '\p{Is_Grapheme_Cluster_Break=  ZWJ}', "");
    Expect(1, 8206, '\p{^Is_Grapheme_Cluster_Break=  ZWJ}', "");
    Expect(1, 8206, '\P{Is_Grapheme_Cluster_Break=  ZWJ}', "");
    Expect(0, 8206, '\P{^Is_Grapheme_Cluster_Break=  ZWJ}', "");
    Error('\p{Is_GCB=:=	_zwj}');
    Error('\P{Is_GCB=:=	_zwj}');
    Expect(1, 8205, '\p{Is_GCB=zwj}', "");
    Expect(0, 8205, '\p{^Is_GCB=zwj}', "");
    Expect(0, 8205, '\P{Is_GCB=zwj}', "");
    Expect(1, 8205, '\P{^Is_GCB=zwj}', "");
    Expect(0, 8206, '\p{Is_GCB=zwj}', "");
    Expect(1, 8206, '\p{^Is_GCB=zwj}', "");
    Expect(1, 8206, '\P{Is_GCB=zwj}', "");
    Expect(0, 8206, '\P{^Is_GCB=zwj}', "");
    Expect(1, 8205, '\p{Is_GCB:   	_ZWJ}', "");
    Expect(0, 8205, '\p{^Is_GCB:   	_ZWJ}', "");
    Expect(0, 8205, '\P{Is_GCB:   	_ZWJ}', "");
    Expect(1, 8205, '\P{^Is_GCB:   	_ZWJ}', "");
    Expect(0, 8206, '\p{Is_GCB:   	_ZWJ}', "");
    Expect(1, 8206, '\p{^Is_GCB:   	_ZWJ}', "");
    Expect(1, 8206, '\P{Is_GCB:   	_ZWJ}', "");
    Expect(0, 8206, '\P{^Is_GCB:   	_ZWJ}', "");
    Error('\p{Grapheme_Base=:= _no}');
    Error('\P{Grapheme_Base=:= _no}');
    Expect(1, 205744, '\p{Grapheme_Base=:\ANo\z:}', "");;
    Expect(0, 205743, '\p{Grapheme_Base=:\ANo\z:}', "");;
    Expect(1, 205744, '\p{Grapheme_Base=no}', "");
    Expect(0, 205744, '\p{^Grapheme_Base=no}', "");
    Expect(0, 205744, '\P{Grapheme_Base=no}', "");
    Expect(1, 205744, '\P{^Grapheme_Base=no}', "");
    Expect(0, 205743, '\p{Grapheme_Base=no}', "");
    Expect(1, 205743, '\p{^Grapheme_Base=no}', "");
    Expect(1, 205743, '\P{Grapheme_Base=no}', "");
    Expect(0, 205743, '\P{^Grapheme_Base=no}', "");
    Expect(1, 205744, '\p{Grapheme_Base=:\Ano\z:}', "");;
    Expect(0, 205743, '\p{Grapheme_Base=:\Ano\z:}', "");;
    Expect(1, 205744, '\p{Grapheme_Base=	_No}', "");
    Expect(0, 205744, '\p{^Grapheme_Base=	_No}', "");
    Expect(0, 205744, '\P{Grapheme_Base=	_No}', "");
    Expect(1, 205744, '\P{^Grapheme_Base=	_No}', "");
    Expect(0, 205743, '\p{Grapheme_Base=	_No}', "");
    Expect(1, 205743, '\p{^Grapheme_Base=	_No}', "");
    Expect(1, 205743, '\P{Grapheme_Base=	_No}', "");
    Expect(0, 205743, '\P{^Grapheme_Base=	_No}', "");
    Error('\p{Gr_Base=	:=N}');
    Error('\P{Gr_Base=	:=N}');
    Expect(1, 205744, '\p{Gr_Base=:\AN\z:}', "");;
    Expect(0, 205743, '\p{Gr_Base=:\AN\z:}', "");;
    Expect(1, 205744, '\p{Gr_Base=n}', "");
    Expect(0, 205744, '\p{^Gr_Base=n}', "");
    Expect(0, 205744, '\P{Gr_Base=n}', "");
    Expect(1, 205744, '\P{^Gr_Base=n}', "");
    Expect(0, 205743, '\p{Gr_Base=n}', "");
    Expect(1, 205743, '\p{^Gr_Base=n}', "");
    Expect(1, 205743, '\P{Gr_Base=n}', "");
    Expect(0, 205743, '\P{^Gr_Base=n}', "");
    Expect(1, 205744, '\p{Gr_Base=:\An\z:}', "");;
    Expect(0, 205743, '\p{Gr_Base=:\An\z:}', "");;
    Expect(1, 205744, '\p{Gr_Base= n}', "");
    Expect(0, 205744, '\p{^Gr_Base= n}', "");
    Expect(0, 205744, '\P{Gr_Base= n}', "");
    Expect(1, 205744, '\P{^Gr_Base= n}', "");
    Expect(0, 205743, '\p{Gr_Base= n}', "");
    Expect(1, 205743, '\p{^Gr_Base= n}', "");
    Expect(1, 205743, '\P{Gr_Base= n}', "");
    Expect(0, 205743, '\P{^Gr_Base= n}', "");
    Error('\p{Is_Grapheme_Base=_/a/f}');
    Error('\P{Is_Grapheme_Base=_/a/f}');
    Expect(1, 205744, '\p{Is_Grapheme_Base:	f}', "");
    Expect(0, 205744, '\p{^Is_Grapheme_Base:	f}', "");
    Expect(0, 205744, '\P{Is_Grapheme_Base:	f}', "");
    Expect(1, 205744, '\P{^Is_Grapheme_Base:	f}', "");
    Expect(0, 205743, '\p{Is_Grapheme_Base:	f}', "");
    Expect(1, 205743, '\p{^Is_Grapheme_Base:	f}', "");
    Expect(1, 205743, '\P{Is_Grapheme_Base:	f}', "");
    Expect(0, 205743, '\P{^Is_Grapheme_Base:	f}', "");
    Expect(1, 205744, '\p{Is_Grapheme_Base=		F}', "");
    Expect(0, 205744, '\p{^Is_Grapheme_Base=		F}', "");
    Expect(0, 205744, '\P{Is_Grapheme_Base=		F}', "");
    Expect(1, 205744, '\P{^Is_Grapheme_Base=		F}', "");
    Expect(0, 205743, '\p{Is_Grapheme_Base=		F}', "");
    Expect(1, 205743, '\p{^Is_Grapheme_Base=		F}', "");
    Expect(1, 205743, '\P{Is_Grapheme_Base=		F}', "");
    Expect(0, 205743, '\P{^Is_Grapheme_Base=		F}', "");
    Error('\p{Is_Gr_Base=:=_-False}');
    Error('\P{Is_Gr_Base=:=_-False}');
    Expect(1, 205744, '\p{Is_Gr_Base: false}', "");
    Expect(0, 205744, '\p{^Is_Gr_Base: false}', "");
    Expect(0, 205744, '\P{Is_Gr_Base: false}', "");
    Expect(1, 205744, '\P{^Is_Gr_Base: false}', "");
    Expect(0, 205743, '\p{Is_Gr_Base: false}', "");
    Expect(1, 205743, '\p{^Is_Gr_Base: false}', "");
    Expect(1, 205743, '\P{Is_Gr_Base: false}', "");
    Expect(0, 205743, '\P{^Is_Gr_Base: false}', "");
    Expect(1, 205744, '\p{Is_Gr_Base:    _FALSE}', "");
    Expect(0, 205744, '\p{^Is_Gr_Base:    _FALSE}', "");
    Expect(0, 205744, '\P{Is_Gr_Base:    _FALSE}', "");
    Expect(1, 205744, '\P{^Is_Gr_Base:    _FALSE}', "");
    Expect(0, 205743, '\p{Is_Gr_Base:    _FALSE}', "");
    Expect(1, 205743, '\p{^Is_Gr_Base:    _FALSE}', "");
    Expect(1, 205743, '\P{Is_Gr_Base:    _FALSE}', "");
    Expect(0, 205743, '\P{^Is_Gr_Base:    _FALSE}', "");
    Error('\p{Grapheme_Base::=	Yes}');
    Error('\P{Grapheme_Base::=	Yes}');
    Expect(1, 205743, '\p{Grapheme_Base=:\AYes\z:}', "");;
    Expect(0, 205744, '\p{Grapheme_Base=:\AYes\z:}', "");;
    Expect(1, 205743, '\p{Grapheme_Base=yes}', "");
    Expect(0, 205743, '\p{^Grapheme_Base=yes}', "");
    Expect(0, 205743, '\P{Grapheme_Base=yes}', "");
    Expect(1, 205743, '\P{^Grapheme_Base=yes}', "");
    Expect(0, 205744, '\p{Grapheme_Base=yes}', "");
    Expect(1, 205744, '\p{^Grapheme_Base=yes}', "");
    Expect(1, 205744, '\P{Grapheme_Base=yes}', "");
    Expect(0, 205744, '\P{^Grapheme_Base=yes}', "");
    Expect(1, 205743, '\p{Grapheme_Base=:\Ayes\z:}', "");;
    Expect(0, 205744, '\p{Grapheme_Base=:\Ayes\z:}', "");;
    Expect(1, 205743, '\p{Grapheme_Base=- YES}', "");
    Expect(0, 205743, '\p{^Grapheme_Base=- YES}', "");
    Expect(0, 205743, '\P{Grapheme_Base=- YES}', "");
    Expect(1, 205743, '\P{^Grapheme_Base=- YES}', "");
    Expect(0, 205744, '\p{Grapheme_Base=- YES}', "");
    Expect(1, 205744, '\p{^Grapheme_Base=- YES}', "");
    Expect(1, 205744, '\P{Grapheme_Base=- YES}', "");
    Expect(0, 205744, '\P{^Grapheme_Base=- YES}', "");
    Error('\p{Gr_Base=/a/	-Y}');
    Error('\P{Gr_Base=/a/	-Y}');
    Expect(1, 205743, '\p{Gr_Base=:\AY\z:}', "");;
    Expect(0, 205744, '\p{Gr_Base=:\AY\z:}', "");;
    Expect(1, 205743, '\p{Gr_Base=y}', "");
    Expect(0, 205743, '\p{^Gr_Base=y}', "");
    Expect(0, 205743, '\P{Gr_Base=y}', "");
    Expect(1, 205743, '\P{^Gr_Base=y}', "");
    Expect(0, 205744, '\p{Gr_Base=y}', "");
    Expect(1, 205744, '\p{^Gr_Base=y}', "");
    Expect(1, 205744, '\P{Gr_Base=y}', "");
    Expect(0, 205744, '\P{^Gr_Base=y}', "");
    Expect(1, 205743, '\p{Gr_Base=:\Ay\z:}', "");;
    Expect(0, 205744, '\p{Gr_Base=:\Ay\z:}', "");;
    Expect(1, 205743, '\p{Gr_Base=--y}', "");
    Expect(0, 205743, '\p{^Gr_Base=--y}', "");
    Expect(0, 205743, '\P{Gr_Base=--y}', "");
    Expect(1, 205743, '\P{^Gr_Base=--y}', "");
    Expect(0, 205744, '\p{Gr_Base=--y}', "");
    Expect(1, 205744, '\p{^Gr_Base=--y}', "");
    Expect(1, 205744, '\P{Gr_Base=--y}', "");
    Expect(0, 205744, '\P{^Gr_Base=--y}', "");
    Error('\p{Is_Grapheme_Base=/a/ -T}');
    Error('\P{Is_Grapheme_Base=/a/ -T}');
    Expect(1, 205743, '\p{Is_Grapheme_Base=t}', "");
    Expect(0, 205743, '\p{^Is_Grapheme_Base=t}', "");
    Expect(0, 205743, '\P{Is_Grapheme_Base=t}', "");
    Expect(1, 205743, '\P{^Is_Grapheme_Base=t}', "");
    Expect(0, 205744, '\p{Is_Grapheme_Base=t}', "");
    Expect(1, 205744, '\p{^Is_Grapheme_Base=t}', "");
    Expect(1, 205744, '\P{Is_Grapheme_Base=t}', "");
    Expect(0, 205744, '\P{^Is_Grapheme_Base=t}', "");
    Expect(1, 205743, '\p{Is_Grapheme_Base= _T}', "");
    Expect(0, 205743, '\p{^Is_Grapheme_Base= _T}', "");
    Expect(0, 205743, '\P{Is_Grapheme_Base= _T}', "");
    Expect(1, 205743, '\P{^Is_Grapheme_Base= _T}', "");
    Expect(0, 205744, '\p{Is_Grapheme_Base= _T}', "");
    Expect(1, 205744, '\p{^Is_Grapheme_Base= _T}', "");
    Expect(1, 205744, '\P{Is_Grapheme_Base= _T}', "");
    Expect(0, 205744, '\P{^Is_Grapheme_Base= _T}', "");
    Error('\p{Is_Gr_Base=/a/		True}');
    Error('\P{Is_Gr_Base=/a/		True}');
    Expect(1, 205743, '\p{Is_Gr_Base=true}', "");
    Expect(0, 205743, '\p{^Is_Gr_Base=true}', "");
    Expect(0, 205743, '\P{Is_Gr_Base=true}', "");
    Expect(1, 205743, '\P{^Is_Gr_Base=true}', "");
    Expect(0, 205744, '\p{Is_Gr_Base=true}', "");
    Expect(1, 205744, '\p{^Is_Gr_Base=true}', "");
    Expect(1, 205744, '\P{Is_Gr_Base=true}', "");
    Expect(0, 205744, '\P{^Is_Gr_Base=true}', "");
    Expect(1, 205743, '\p{Is_Gr_Base=__True}', "");
    Expect(0, 205743, '\p{^Is_Gr_Base=__True}', "");
    Expect(0, 205743, '\P{Is_Gr_Base=__True}', "");
    Expect(1, 205743, '\P{^Is_Gr_Base=__True}', "");
    Expect(0, 205744, '\p{Is_Gr_Base=__True}', "");
    Expect(1, 205744, '\p{^Is_Gr_Base=__True}', "");
    Expect(1, 205744, '\P{Is_Gr_Base=__True}', "");
    Expect(0, 205744, '\P{^Is_Gr_Base=__True}', "");
    Error('\p{Grapheme_Extend=/a/	no}');
    Error('\P{Grapheme_Extend=/a/	no}');
    Expect(1, 918000, '\p{Grapheme_Extend=:\ANo\z:}', "");;
    Expect(0, 917999, '\p{Grapheme_Extend=:\ANo\z:}', "");;
    Expect(1, 918000, '\p{Grapheme_Extend=no}', "");
    Expect(0, 918000, '\p{^Grapheme_Extend=no}', "");
    Expect(0, 918000, '\P{Grapheme_Extend=no}', "");
    Expect(1, 918000, '\P{^Grapheme_Extend=no}', "");
    Expect(0, 917999, '\p{Grapheme_Extend=no}', "");
    Expect(1, 917999, '\p{^Grapheme_Extend=no}', "");
    Expect(1, 917999, '\P{Grapheme_Extend=no}', "");
    Expect(0, 917999, '\P{^Grapheme_Extend=no}', "");
    Expect(1, 918000, '\p{Grapheme_Extend=:\Ano\z:}', "");;
    Expect(0, 917999, '\p{Grapheme_Extend=:\Ano\z:}', "");;
    Expect(1, 918000, '\p{Grapheme_Extend=		No}', "");
    Expect(0, 918000, '\p{^Grapheme_Extend=		No}', "");
    Expect(0, 918000, '\P{Grapheme_Extend=		No}', "");
    Expect(1, 918000, '\P{^Grapheme_Extend=		No}', "");
    Expect(0, 917999, '\p{Grapheme_Extend=		No}', "");
    Expect(1, 917999, '\p{^Grapheme_Extend=		No}', "");
    Expect(1, 917999, '\P{Grapheme_Extend=		No}', "");
    Expect(0, 917999, '\P{^Grapheme_Extend=		No}', "");
    Error('\p{Gr_Ext=	N:=}');
    Error('\P{Gr_Ext=	N:=}');
    Expect(1, 918000, '\p{Gr_Ext=:\AN\z:}', "");;
    Expect(0, 917999, '\p{Gr_Ext=:\AN\z:}', "");;
    Expect(1, 918000, '\p{Gr_Ext: n}', "");
    Expect(0, 918000, '\p{^Gr_Ext: n}', "");
    Expect(0, 918000, '\P{Gr_Ext: n}', "");
    Expect(1, 918000, '\P{^Gr_Ext: n}', "");
    Expect(0, 917999, '\p{Gr_Ext: n}', "");
    Expect(1, 917999, '\p{^Gr_Ext: n}', "");
    Expect(1, 917999, '\P{Gr_Ext: n}', "");
    Expect(0, 917999, '\P{^Gr_Ext: n}', "");
    Expect(1, 918000, '\p{Gr_Ext=:\An\z:}', "");;
    Expect(0, 917999, '\p{Gr_Ext=:\An\z:}', "");;
    Expect(1, 918000, '\p{Gr_Ext= n}', "");
    Expect(0, 918000, '\p{^Gr_Ext= n}', "");
    Expect(0, 918000, '\P{Gr_Ext= n}', "");
    Expect(1, 918000, '\P{^Gr_Ext= n}', "");
    Expect(0, 917999, '\p{Gr_Ext= n}', "");
    Expect(1, 917999, '\p{^Gr_Ext= n}', "");
    Expect(1, 917999, '\P{Gr_Ext= n}', "");
    Expect(0, 917999, '\P{^Gr_Ext= n}', "");
    Error('\p{Is_Grapheme_Extend= -F:=}');
    Error('\P{Is_Grapheme_Extend= -F:=}');
    Expect(1, 918000, '\p{Is_Grapheme_Extend=f}', "");
    Expect(0, 918000, '\p{^Is_Grapheme_Extend=f}', "");
    Expect(0, 918000, '\P{Is_Grapheme_Extend=f}', "");
    Expect(1, 918000, '\P{^Is_Grapheme_Extend=f}', "");
    Expect(0, 917999, '\p{Is_Grapheme_Extend=f}', "");
    Expect(1, 917999, '\p{^Is_Grapheme_Extend=f}', "");
    Expect(1, 917999, '\P{Is_Grapheme_Extend=f}', "");
    Expect(0, 917999, '\P{^Is_Grapheme_Extend=f}', "");
    Expect(1, 918000, '\p{Is_Grapheme_Extend=- F}', "");
    Expect(0, 918000, '\p{^Is_Grapheme_Extend=- F}', "");
    Expect(0, 918000, '\P{Is_Grapheme_Extend=- F}', "");
    Expect(1, 918000, '\P{^Is_Grapheme_Extend=- F}', "");
    Expect(0, 917999, '\p{Is_Grapheme_Extend=- F}', "");
    Expect(1, 917999, '\p{^Is_Grapheme_Extend=- F}', "");
    Expect(1, 917999, '\P{Is_Grapheme_Extend=- F}', "");
    Expect(0, 917999, '\P{^Is_Grapheme_Extend=- F}', "");
    Error('\p{Is_Gr_Ext=:=--False}');
    Error('\P{Is_Gr_Ext=:=--False}');
    Expect(1, 918000, '\p{Is_Gr_Ext=false}', "");
    Expect(0, 918000, '\p{^Is_Gr_Ext=false}', "");
    Expect(0, 918000, '\P{Is_Gr_Ext=false}', "");
    Expect(1, 918000, '\P{^Is_Gr_Ext=false}', "");
    Expect(0, 917999, '\p{Is_Gr_Ext=false}', "");
    Expect(1, 917999, '\p{^Is_Gr_Ext=false}', "");
    Expect(1, 917999, '\P{Is_Gr_Ext=false}', "");
    Expect(0, 917999, '\P{^Is_Gr_Ext=false}', "");
    Expect(1, 918000, '\p{Is_Gr_Ext=_	False}', "");
    Expect(0, 918000, '\p{^Is_Gr_Ext=_	False}', "");
    Expect(0, 918000, '\P{Is_Gr_Ext=_	False}', "");
    Expect(1, 918000, '\P{^Is_Gr_Ext=_	False}', "");
    Expect(0, 917999, '\p{Is_Gr_Ext=_	False}', "");
    Expect(1, 917999, '\p{^Is_Gr_Ext=_	False}', "");
    Expect(1, 917999, '\P{Is_Gr_Ext=_	False}', "");
    Expect(0, 917999, '\P{^Is_Gr_Ext=_	False}', "");
    Error('\p{Grapheme_Extend:    -YES:=}');
    Error('\P{Grapheme_Extend:    -YES:=}');
    Expect(1, 917999, '\p{Grapheme_Extend=:\AYes\z:}', "");;
    Expect(0, 918000, '\p{Grapheme_Extend=:\AYes\z:}', "");;
    Expect(1, 917999, '\p{Grapheme_Extend:	yes}', "");
    Expect(0, 917999, '\p{^Grapheme_Extend:	yes}', "");
    Expect(0, 917999, '\P{Grapheme_Extend:	yes}', "");
    Expect(1, 917999, '\P{^Grapheme_Extend:	yes}', "");
    Expect(0, 918000, '\p{Grapheme_Extend:	yes}', "");
    Expect(1, 918000, '\p{^Grapheme_Extend:	yes}', "");
    Expect(1, 918000, '\P{Grapheme_Extend:	yes}', "");
    Expect(0, 918000, '\P{^Grapheme_Extend:	yes}', "");
    Expect(1, 917999, '\p{Grapheme_Extend=:\Ayes\z:}', "");;
    Expect(0, 918000, '\p{Grapheme_Extend=:\Ayes\z:}', "");;
    Expect(1, 917999, '\p{Grapheme_Extend=- yes}', "");
    Expect(0, 917999, '\p{^Grapheme_Extend=- yes}', "");
    Expect(0, 917999, '\P{Grapheme_Extend=- yes}', "");
    Expect(1, 917999, '\P{^Grapheme_Extend=- yes}', "");
    Expect(0, 918000, '\p{Grapheme_Extend=- yes}', "");
    Expect(1, 918000, '\p{^Grapheme_Extend=- yes}', "");
    Expect(1, 918000, '\P{Grapheme_Extend=- yes}', "");
    Expect(0, 918000, '\P{^Grapheme_Extend=- yes}', "");
    Error('\p{Gr_Ext=_ y:=}');
    Error('\P{Gr_Ext=_ y:=}');
    Expect(1, 917999, '\p{Gr_Ext=:\AY\z:}', "");;
    Expect(0, 918000, '\p{Gr_Ext=:\AY\z:}', "");;
    Expect(1, 917999, '\p{Gr_Ext=y}', "");
    Expect(0, 917999, '\p{^Gr_Ext=y}', "");
    Expect(0, 917999, '\P{Gr_Ext=y}', "");
    Expect(1, 917999, '\P{^Gr_Ext=y}', "");
    Expect(0, 918000, '\p{Gr_Ext=y}', "");
    Expect(1, 918000, '\p{^Gr_Ext=y}', "");
    Expect(1, 918000, '\P{Gr_Ext=y}', "");
    Expect(0, 918000, '\P{^Gr_Ext=y}', "");
    Expect(1, 917999, '\p{Gr_Ext=:\Ay\z:}', "");;
    Expect(0, 918000, '\p{Gr_Ext=:\Ay\z:}', "");;
    Expect(1, 917999, '\p{Gr_Ext=  y}', "");
    Expect(0, 917999, '\p{^Gr_Ext=  y}', "");
    Expect(0, 917999, '\P{Gr_Ext=  y}', "");
    Expect(1, 917999, '\P{^Gr_Ext=  y}', "");
    Expect(0, 918000, '\p{Gr_Ext=  y}', "");
    Expect(1, 918000, '\p{^Gr_Ext=  y}', "");
    Expect(1, 918000, '\P{Gr_Ext=  y}', "");
    Expect(0, 918000, '\P{^Gr_Ext=  y}', "");
    Error('\p{Is_Grapheme_Extend:-T:=}');
    Error('\P{Is_Grapheme_Extend:-T:=}');
    Expect(1, 917999, '\p{Is_Grapheme_Extend=t}', "");
    Expect(0, 917999, '\p{^Is_Grapheme_Extend=t}', "");
    Expect(0, 917999, '\P{Is_Grapheme_Extend=t}', "");
    Expect(1, 917999, '\P{^Is_Grapheme_Extend=t}', "");
    Expect(0, 918000, '\p{Is_Grapheme_Extend=t}', "");
    Expect(1, 918000, '\p{^Is_Grapheme_Extend=t}', "");
    Expect(1, 918000, '\P{Is_Grapheme_Extend=t}', "");
    Expect(0, 918000, '\P{^Is_Grapheme_Extend=t}', "");
    Expect(1, 917999, '\p{Is_Grapheme_Extend=	T}', "");
    Expect(0, 917999, '\p{^Is_Grapheme_Extend=	T}', "");
    Expect(0, 917999, '\P{Is_Grapheme_Extend=	T}', "");
    Expect(1, 917999, '\P{^Is_Grapheme_Extend=	T}', "");
    Expect(0, 918000, '\p{Is_Grapheme_Extend=	T}', "");
    Expect(1, 918000, '\p{^Is_Grapheme_Extend=	T}', "");
    Expect(1, 918000, '\P{Is_Grapheme_Extend=	T}', "");
    Expect(0, 918000, '\P{^Is_Grapheme_Extend=	T}', "");
    Error('\p{Is_Gr_Ext= 	TRUE/a/}');
    Error('\P{Is_Gr_Ext= 	TRUE/a/}');
    Expect(1, 917999, '\p{Is_Gr_Ext=true}', "");
    Expect(0, 917999, '\p{^Is_Gr_Ext=true}', "");
    Expect(0, 917999, '\P{Is_Gr_Ext=true}', "");
    Expect(1, 917999, '\P{^Is_Gr_Ext=true}', "");
    Expect(0, 918000, '\p{Is_Gr_Ext=true}', "");
    Expect(1, 918000, '\p{^Is_Gr_Ext=true}', "");
    Expect(1, 918000, '\P{Is_Gr_Ext=true}', "");
    Expect(0, 918000, '\P{^Is_Gr_Ext=true}', "");
    Expect(1, 917999, '\p{Is_Gr_Ext=True}', "");
    Expect(0, 917999, '\p{^Is_Gr_Ext=True}', "");
    Expect(0, 917999, '\P{Is_Gr_Ext=True}', "");
    Expect(1, 917999, '\P{^Is_Gr_Ext=True}', "");
    Expect(0, 918000, '\p{Is_Gr_Ext=True}', "");
    Expect(1, 918000, '\p{^Is_Gr_Ext=True}', "");
    Expect(1, 918000, '\P{Is_Gr_Ext=True}', "");
    Expect(0, 918000, '\P{^Is_Gr_Ext=True}', "");
    Error('\p{Grapheme_Link:No}');
    Error('\P{Grapheme_Link:No}');
    Error('\p{Gr_Link=N}');
    Error('\P{Gr_Link=N}');
    Error('\p{Is_Grapheme_Link=F}');
    Error('\P{Is_Grapheme_Link=F}');
    Error('\p{Is_Gr_Link=False}');
    Error('\P{Is_Gr_Link=False}');
    Error('\p{Grapheme_Link=Yes}');
    Error('\P{Grapheme_Link=Yes}');
    Error('\p{Gr_Link=Y}');
    Error('\P{Gr_Link=Y}');
    Error('\p{Is_Grapheme_Link=T}');
    Error('\P{Is_Grapheme_Link=T}');
    Error('\p{Is_Gr_Link=True}');
    Error('\P{Is_Gr_Link=True}');
    Error('\p{Hex_Digit=/a/	-No}');
    Error('\P{Hex_Digit=/a/	-No}');
    Expect(1, 65351, '\p{Hex_Digit=:\ANo\z:}', "");;
    Expect(0, 65350, '\p{Hex_Digit=:\ANo\z:}', "");;
    Expect(1, 65351, '\p{Hex_Digit=no}', "");
    Expect(0, 65351, '\p{^Hex_Digit=no}', "");
    Expect(0, 65351, '\P{Hex_Digit=no}', "");
    Expect(1, 65351, '\P{^Hex_Digit=no}', "");
    Expect(0, 65350, '\p{Hex_Digit=no}', "");
    Expect(1, 65350, '\p{^Hex_Digit=no}', "");
    Expect(1, 65350, '\P{Hex_Digit=no}', "");
    Expect(0, 65350, '\P{^Hex_Digit=no}', "");
    Expect(1, 65351, '\p{Hex_Digit=:\Ano\z:}', "");;
    Expect(0, 65350, '\p{Hex_Digit=:\Ano\z:}', "");;
    Expect(1, 65351, '\p{Hex_Digit= no}', "");
    Expect(0, 65351, '\p{^Hex_Digit= no}', "");
    Expect(0, 65351, '\P{Hex_Digit= no}', "");
    Expect(1, 65351, '\P{^Hex_Digit= no}', "");
    Expect(0, 65350, '\p{Hex_Digit= no}', "");
    Expect(1, 65350, '\p{^Hex_Digit= no}', "");
    Expect(1, 65350, '\P{Hex_Digit= no}', "");
    Expect(0, 65350, '\P{^Hex_Digit= no}', "");
    Error('\p{Hex:   :=N}');
    Error('\P{Hex:   :=N}');
    Expect(1, 65351, '\p{Hex=:\AN\z:}', "");;
    Expect(0, 65350, '\p{Hex=:\AN\z:}', "");;
    Expect(1, 65351, '\p{Hex=n}', "");
    Expect(0, 65351, '\p{^Hex=n}', "");
    Expect(0, 65351, '\P{Hex=n}', "");
    Expect(1, 65351, '\P{^Hex=n}', "");
    Expect(0, 65350, '\p{Hex=n}', "");
    Expect(1, 65350, '\p{^Hex=n}', "");
    Expect(1, 65350, '\P{Hex=n}', "");
    Expect(0, 65350, '\P{^Hex=n}', "");
    Expect(1, 65351, '\p{Hex=:\An\z:}', "");;
    Expect(0, 65350, '\p{Hex=:\An\z:}', "");;
    Expect(1, 65351, '\p{Hex=-_N}', "");
    Expect(0, 65351, '\p{^Hex=-_N}', "");
    Expect(0, 65351, '\P{Hex=-_N}', "");
    Expect(1, 65351, '\P{^Hex=-_N}', "");
    Expect(0, 65350, '\p{Hex=-_N}', "");
    Expect(1, 65350, '\p{^Hex=-_N}', "");
    Expect(1, 65350, '\P{Hex=-_N}', "");
    Expect(0, 65350, '\P{^Hex=-_N}', "");
    Error('\p{Is_Hex_Digit= :=f}');
    Error('\P{Is_Hex_Digit= :=f}');
    Expect(1, 65351, '\p{Is_Hex_Digit=f}', "");
    Expect(0, 65351, '\p{^Is_Hex_Digit=f}', "");
    Expect(0, 65351, '\P{Is_Hex_Digit=f}', "");
    Expect(1, 65351, '\P{^Is_Hex_Digit=f}', "");
    Expect(0, 65350, '\p{Is_Hex_Digit=f}', "");
    Expect(1, 65350, '\p{^Is_Hex_Digit=f}', "");
    Expect(1, 65350, '\P{Is_Hex_Digit=f}', "");
    Expect(0, 65350, '\P{^Is_Hex_Digit=f}', "");
    Expect(1, 65351, '\p{Is_Hex_Digit=_-F}', "");
    Expect(0, 65351, '\p{^Is_Hex_Digit=_-F}', "");
    Expect(0, 65351, '\P{Is_Hex_Digit=_-F}', "");
    Expect(1, 65351, '\P{^Is_Hex_Digit=_-F}', "");
    Expect(0, 65350, '\p{Is_Hex_Digit=_-F}', "");
    Expect(1, 65350, '\p{^Is_Hex_Digit=_-F}', "");
    Expect(1, 65350, '\P{Is_Hex_Digit=_-F}', "");
    Expect(0, 65350, '\P{^Is_Hex_Digit=_-F}', "");
    Error('\p{Is_Hex=-	false/a/}');
    Error('\P{Is_Hex=-	false/a/}');
    Expect(1, 65351, '\p{Is_Hex=false}', "");
    Expect(0, 65351, '\p{^Is_Hex=false}', "");
    Expect(0, 65351, '\P{Is_Hex=false}', "");
    Expect(1, 65351, '\P{^Is_Hex=false}', "");
    Expect(0, 65350, '\p{Is_Hex=false}', "");
    Expect(1, 65350, '\p{^Is_Hex=false}', "");
    Expect(1, 65350, '\P{Is_Hex=false}', "");
    Expect(0, 65350, '\P{^Is_Hex=false}', "");
    Expect(1, 65351, '\p{Is_Hex=-	false}', "");
    Expect(0, 65351, '\p{^Is_Hex=-	false}', "");
    Expect(0, 65351, '\P{Is_Hex=-	false}', "");
    Expect(1, 65351, '\P{^Is_Hex=-	false}', "");
    Expect(0, 65350, '\p{Is_Hex=-	false}', "");
    Expect(1, 65350, '\p{^Is_Hex=-	false}', "");
    Expect(1, 65350, '\P{Is_Hex=-	false}', "");
    Expect(0, 65350, '\P{^Is_Hex=-	false}', "");
    Error('\p{Hex_Digit=:=	 YES}');
    Error('\P{Hex_Digit=:=	 YES}');
    Expect(1, 65350, '\p{Hex_Digit=:\AYes\z:}', "");;
    Expect(0, 65351, '\p{Hex_Digit=:\AYes\z:}', "");;
    Expect(1, 65350, '\p{Hex_Digit=yes}', "");
    Expect(0, 65350, '\p{^Hex_Digit=yes}', "");
    Expect(0, 65350, '\P{Hex_Digit=yes}', "");
    Expect(1, 65350, '\P{^Hex_Digit=yes}', "");
    Expect(0, 65351, '\p{Hex_Digit=yes}', "");
    Expect(1, 65351, '\p{^Hex_Digit=yes}', "");
    Expect(1, 65351, '\P{Hex_Digit=yes}', "");
    Expect(0, 65351, '\P{^Hex_Digit=yes}', "");
    Expect(1, 65350, '\p{Hex_Digit=:\Ayes\z:}', "");;
    Expect(0, 65351, '\p{Hex_Digit=:\Ayes\z:}', "");;
    Expect(1, 65350, '\p{Hex_Digit=--YES}', "");
    Expect(0, 65350, '\p{^Hex_Digit=--YES}', "");
    Expect(0, 65350, '\P{Hex_Digit=--YES}', "");
    Expect(1, 65350, '\P{^Hex_Digit=--YES}', "");
    Expect(0, 65351, '\p{Hex_Digit=--YES}', "");
    Expect(1, 65351, '\p{^Hex_Digit=--YES}', "");
    Expect(1, 65351, '\P{Hex_Digit=--YES}', "");
    Expect(0, 65351, '\P{^Hex_Digit=--YES}', "");
    Error('\p{Hex=:=- Y}');
    Error('\P{Hex=:=- Y}');
    Expect(1, 65350, '\p{Hex=:\AY\z:}', "");;
    Expect(0, 65351, '\p{Hex=:\AY\z:}', "");;
    Expect(1, 65350, '\p{Hex=y}', "");
    Expect(0, 65350, '\p{^Hex=y}', "");
    Expect(0, 65350, '\P{Hex=y}', "");
    Expect(1, 65350, '\P{^Hex=y}', "");
    Expect(0, 65351, '\p{Hex=y}', "");
    Expect(1, 65351, '\p{^Hex=y}', "");
    Expect(1, 65351, '\P{Hex=y}', "");
    Expect(0, 65351, '\P{^Hex=y}', "");
    Expect(1, 65350, '\p{Hex=:\Ay\z:}', "");;
    Expect(0, 65351, '\p{Hex=:\Ay\z:}', "");;
    Expect(1, 65350, '\p{Hex=Y}', "");
    Expect(0, 65350, '\p{^Hex=Y}', "");
    Expect(0, 65350, '\P{Hex=Y}', "");
    Expect(1, 65350, '\P{^Hex=Y}', "");
    Expect(0, 65351, '\p{Hex=Y}', "");
    Expect(1, 65351, '\p{^Hex=Y}', "");
    Expect(1, 65351, '\P{Hex=Y}', "");
    Expect(0, 65351, '\P{^Hex=Y}', "");
    Error('\p{Is_Hex_Digit=-/a/t}');
    Error('\P{Is_Hex_Digit=-/a/t}');
    Expect(1, 65350, '\p{Is_Hex_Digit=t}', "");
    Expect(0, 65350, '\p{^Is_Hex_Digit=t}', "");
    Expect(0, 65350, '\P{Is_Hex_Digit=t}', "");
    Expect(1, 65350, '\P{^Is_Hex_Digit=t}', "");
    Expect(0, 65351, '\p{Is_Hex_Digit=t}', "");
    Expect(1, 65351, '\p{^Is_Hex_Digit=t}', "");
    Expect(1, 65351, '\P{Is_Hex_Digit=t}', "");
    Expect(0, 65351, '\P{^Is_Hex_Digit=t}', "");
    Expect(1, 65350, '\p{Is_Hex_Digit=_-T}', "");
    Expect(0, 65350, '\p{^Is_Hex_Digit=_-T}', "");
    Expect(0, 65350, '\P{Is_Hex_Digit=_-T}', "");
    Expect(1, 65350, '\P{^Is_Hex_Digit=_-T}', "");
    Expect(0, 65351, '\p{Is_Hex_Digit=_-T}', "");
    Expect(1, 65351, '\p{^Is_Hex_Digit=_-T}', "");
    Expect(1, 65351, '\P{Is_Hex_Digit=_-T}', "");
    Expect(0, 65351, '\P{^Is_Hex_Digit=_-T}', "");
    Error('\p{Is_Hex=_:=TRUE}');
    Error('\P{Is_Hex=_:=TRUE}');
    Expect(1, 65350, '\p{Is_Hex=true}', "");
    Expect(0, 65350, '\p{^Is_Hex=true}', "");
    Expect(0, 65350, '\P{Is_Hex=true}', "");
    Expect(1, 65350, '\P{^Is_Hex=true}', "");
    Expect(0, 65351, '\p{Is_Hex=true}', "");
    Expect(1, 65351, '\p{^Is_Hex=true}', "");
    Expect(1, 65351, '\P{Is_Hex=true}', "");
    Expect(0, 65351, '\P{^Is_Hex=true}', "");
    Expect(1, 65350, '\p{Is_Hex=	-True}', "");
    Expect(0, 65350, '\p{^Is_Hex=	-True}', "");
    Expect(0, 65350, '\P{Is_Hex=	-True}', "");
    Expect(1, 65350, '\P{^Is_Hex=	-True}', "");
    Expect(0, 65351, '\p{Is_Hex=	-True}', "");
    Expect(1, 65351, '\p{^Is_Hex=	-True}', "");
    Expect(1, 65351, '\P{Is_Hex=	-True}', "");
    Expect(0, 65351, '\P{^Is_Hex=	-True}', "");
    Error('\p{hangulsyllabletype}');
    Error('\P{hangulsyllabletype}');
    Error('\p{hst}');
    Error('\P{hst}');
    Error('\p{Hangul_Syllable_Type=:=leading_Jamo}');
    Error('\P{Hangul_Syllable_Type=:=leading_Jamo}');
    Expect(1, 43388, '\p{Hangul_Syllable_Type=:\ALeading_Jamo\z:}', "");;
    Expect(0, 43389, '\p{Hangul_Syllable_Type=:\ALeading_Jamo\z:}', "");;
    Expect(1, 43388, '\p{Hangul_Syllable_Type: leadingjamo}', "");
    Expect(0, 43388, '\p{^Hangul_Syllable_Type: leadingjamo}', "");
    Expect(0, 43388, '\P{Hangul_Syllable_Type: leadingjamo}', "");
    Expect(1, 43388, '\P{^Hangul_Syllable_Type: leadingjamo}', "");
    Expect(0, 43389, '\p{Hangul_Syllable_Type: leadingjamo}', "");
    Expect(1, 43389, '\p{^Hangul_Syllable_Type: leadingjamo}', "");
    Expect(1, 43389, '\P{Hangul_Syllable_Type: leadingjamo}', "");
    Expect(0, 43389, '\P{^Hangul_Syllable_Type: leadingjamo}', "");
    Expect(1, 43388, '\p{Hangul_Syllable_Type=:\Aleadingjamo\z:}', "");;
    Expect(0, 43389, '\p{Hangul_Syllable_Type=:\Aleadingjamo\z:}', "");;
    Expect(1, 43388, '\p{Hangul_Syllable_Type=- leading_JAMO}', "");
    Expect(0, 43388, '\p{^Hangul_Syllable_Type=- leading_JAMO}', "");
    Expect(0, 43388, '\P{Hangul_Syllable_Type=- leading_JAMO}', "");
    Expect(1, 43388, '\P{^Hangul_Syllable_Type=- leading_JAMO}', "");
    Expect(0, 43389, '\p{Hangul_Syllable_Type=- leading_JAMO}', "");
    Expect(1, 43389, '\p{^Hangul_Syllable_Type=- leading_JAMO}', "");
    Expect(1, 43389, '\P{Hangul_Syllable_Type=- leading_JAMO}', "");
    Expect(0, 43389, '\P{^Hangul_Syllable_Type=- leading_JAMO}', "");
    Error('\p{Hst=:= -L}');
    Error('\P{Hst=:= -L}');
    Expect(1, 43388, '\p{Hst=:\AL\z:}', "");;
    Expect(0, 43389, '\p{Hst=:\AL\z:}', "");;
    Expect(1, 43388, '\p{Hst:l}', "");
    Expect(0, 43388, '\p{^Hst:l}', "");
    Expect(0, 43388, '\P{Hst:l}', "");
    Expect(1, 43388, '\P{^Hst:l}', "");
    Expect(0, 43389, '\p{Hst:l}', "");
    Expect(1, 43389, '\p{^Hst:l}', "");
    Expect(1, 43389, '\P{Hst:l}', "");
    Expect(0, 43389, '\P{^Hst:l}', "");
    Expect(1, 43388, '\p{Hst=:\Al\z:}', "");;
    Expect(0, 43389, '\p{Hst=:\Al\z:}', "");;
    Expect(1, 43388, '\p{Hst=		L}', "");
    Expect(0, 43388, '\p{^Hst=		L}', "");
    Expect(0, 43388, '\P{Hst=		L}', "");
    Expect(1, 43388, '\P{^Hst=		L}', "");
    Expect(0, 43389, '\p{Hst=		L}', "");
    Expect(1, 43389, '\p{^Hst=		L}', "");
    Expect(1, 43389, '\P{Hst=		L}', "");
    Expect(0, 43389, '\P{^Hst=		L}', "");
    Error('\p{Is_Hangul_Syllable_Type: :=-_Leading_jamo}');
    Error('\P{Is_Hangul_Syllable_Type: :=-_Leading_jamo}');
    Expect(1, 43388, '\p{Is_Hangul_Syllable_Type=leadingjamo}', "");
    Expect(0, 43388, '\p{^Is_Hangul_Syllable_Type=leadingjamo}', "");
    Expect(0, 43388, '\P{Is_Hangul_Syllable_Type=leadingjamo}', "");
    Expect(1, 43388, '\P{^Is_Hangul_Syllable_Type=leadingjamo}', "");
    Expect(0, 43389, '\p{Is_Hangul_Syllable_Type=leadingjamo}', "");
    Expect(1, 43389, '\p{^Is_Hangul_Syllable_Type=leadingjamo}', "");
    Expect(1, 43389, '\P{Is_Hangul_Syllable_Type=leadingjamo}', "");
    Expect(0, 43389, '\P{^Is_Hangul_Syllable_Type=leadingjamo}', "");
    Expect(1, 43388, '\p{Is_Hangul_Syllable_Type= _Leading_jamo}', "");
    Expect(0, 43388, '\p{^Is_Hangul_Syllable_Type= _Leading_jamo}', "");
    Expect(0, 43388, '\P{Is_Hangul_Syllable_Type= _Leading_jamo}', "");
    Expect(1, 43388, '\P{^Is_Hangul_Syllable_Type= _Leading_jamo}', "");
    Expect(0, 43389, '\p{Is_Hangul_Syllable_Type= _Leading_jamo}', "");
    Expect(1, 43389, '\p{^Is_Hangul_Syllable_Type= _Leading_jamo}', "");
    Expect(1, 43389, '\P{Is_Hangul_Syllable_Type= _Leading_jamo}', "");
    Expect(0, 43389, '\P{^Is_Hangul_Syllable_Type= _Leading_jamo}', "");
    Error('\p{Is_Hst:   /a/L}');
    Error('\P{Is_Hst:   /a/L}');
    Expect(1, 43388, '\p{Is_Hst=l}', "");
    Expect(0, 43388, '\p{^Is_Hst=l}', "");
    Expect(0, 43388, '\P{Is_Hst=l}', "");
    Expect(1, 43388, '\P{^Is_Hst=l}', "");
    Expect(0, 43389, '\p{Is_Hst=l}', "");
    Expect(1, 43389, '\p{^Is_Hst=l}', "");
    Expect(1, 43389, '\P{Is_Hst=l}', "");
    Expect(0, 43389, '\P{^Is_Hst=l}', "");
    Expect(1, 43388, '\p{Is_Hst= 	l}', "");
    Expect(0, 43388, '\p{^Is_Hst= 	l}', "");
    Expect(0, 43388, '\P{Is_Hst= 	l}', "");
    Expect(1, 43388, '\P{^Is_Hst= 	l}', "");
    Expect(0, 43389, '\p{Is_Hst= 	l}', "");
    Expect(1, 43389, '\p{^Is_Hst= 	l}', "");
    Expect(1, 43389, '\P{Is_Hst= 	l}', "");
    Expect(0, 43389, '\P{^Is_Hst= 	l}', "");
    Error('\p{Hangul_Syllable_Type= _LV_Syllable:=}');
    Error('\P{Hangul_Syllable_Type= _LV_Syllable:=}');
    Expect(1, 55176, '\p{Hangul_Syllable_Type=:\ALV_Syllable\z:}', "");;
    Expect(0, 55177, '\p{Hangul_Syllable_Type=:\ALV_Syllable\z:}', "");;
    Expect(1, 55176, '\p{Hangul_Syllable_Type=lvsyllable}', "");
    Expect(0, 55176, '\p{^Hangul_Syllable_Type=lvsyllable}', "");
    Expect(0, 55176, '\P{Hangul_Syllable_Type=lvsyllable}', "");
    Expect(1, 55176, '\P{^Hangul_Syllable_Type=lvsyllable}', "");
    Expect(0, 55177, '\p{Hangul_Syllable_Type=lvsyllable}', "");
    Expect(1, 55177, '\p{^Hangul_Syllable_Type=lvsyllable}', "");
    Expect(1, 55177, '\P{Hangul_Syllable_Type=lvsyllable}', "");
    Expect(0, 55177, '\P{^Hangul_Syllable_Type=lvsyllable}', "");
    Expect(1, 55176, '\p{Hangul_Syllable_Type=:\Alvsyllable\z:}', "");;
    Expect(0, 55177, '\p{Hangul_Syllable_Type=:\Alvsyllable\z:}', "");;
    Expect(1, 55176, '\p{Hangul_Syllable_Type=--LV_Syllable}', "");
    Expect(0, 55176, '\p{^Hangul_Syllable_Type=--LV_Syllable}', "");
    Expect(0, 55176, '\P{Hangul_Syllable_Type=--LV_Syllable}', "");
    Expect(1, 55176, '\P{^Hangul_Syllable_Type=--LV_Syllable}', "");
    Expect(0, 55177, '\p{Hangul_Syllable_Type=--LV_Syllable}', "");
    Expect(1, 55177, '\p{^Hangul_Syllable_Type=--LV_Syllable}', "");
    Expect(1, 55177, '\P{Hangul_Syllable_Type=--LV_Syllable}', "");
    Expect(0, 55177, '\P{^Hangul_Syllable_Type=--LV_Syllable}', "");
    Error('\p{Hst=:= LV}');
    Error('\P{Hst=:= LV}');
    Expect(1, 55176, '\p{Hst=:\ALV\z:}', "");;
    Expect(0, 55177, '\p{Hst=:\ALV\z:}', "");;
    Expect(1, 55176, '\p{Hst:lv}', "");
    Expect(0, 55176, '\p{^Hst:lv}', "");
    Expect(0, 55176, '\P{Hst:lv}', "");
    Expect(1, 55176, '\P{^Hst:lv}', "");
    Expect(0, 55177, '\p{Hst:lv}', "");
    Expect(1, 55177, '\p{^Hst:lv}', "");
    Expect(1, 55177, '\P{Hst:lv}', "");
    Expect(0, 55177, '\P{^Hst:lv}', "");
    Expect(1, 55176, '\p{Hst=:\Alv\z:}', "");;
    Expect(0, 55177, '\p{Hst=:\Alv\z:}', "");;
    Expect(1, 55176, '\p{Hst: LV}', "");
    Expect(0, 55176, '\p{^Hst: LV}', "");
    Expect(0, 55176, '\P{Hst: LV}', "");
    Expect(1, 55176, '\P{^Hst: LV}', "");
    Expect(0, 55177, '\p{Hst: LV}', "");
    Expect(1, 55177, '\p{^Hst: LV}', "");
    Expect(1, 55177, '\P{Hst: LV}', "");
    Expect(0, 55177, '\P{^Hst: LV}', "");
    Error('\p{Is_Hangul_Syllable_Type=__LV_Syllable:=}');
    Error('\P{Is_Hangul_Syllable_Type=__LV_Syllable:=}');
    Expect(1, 55176, '\p{Is_Hangul_Syllable_Type=lvsyllable}', "");
    Expect(0, 55176, '\p{^Is_Hangul_Syllable_Type=lvsyllable}', "");
    Expect(0, 55176, '\P{Is_Hangul_Syllable_Type=lvsyllable}', "");
    Expect(1, 55176, '\P{^Is_Hangul_Syllable_Type=lvsyllable}', "");
    Expect(0, 55177, '\p{Is_Hangul_Syllable_Type=lvsyllable}', "");
    Expect(1, 55177, '\p{^Is_Hangul_Syllable_Type=lvsyllable}', "");
    Expect(1, 55177, '\P{Is_Hangul_Syllable_Type=lvsyllable}', "");
    Expect(0, 55177, '\P{^Is_Hangul_Syllable_Type=lvsyllable}', "");
    Expect(1, 55176, '\p{Is_Hangul_Syllable_Type=	 LV_Syllable}', "");
    Expect(0, 55176, '\p{^Is_Hangul_Syllable_Type=	 LV_Syllable}', "");
    Expect(0, 55176, '\P{Is_Hangul_Syllable_Type=	 LV_Syllable}', "");
    Expect(1, 55176, '\P{^Is_Hangul_Syllable_Type=	 LV_Syllable}', "");
    Expect(0, 55177, '\p{Is_Hangul_Syllable_Type=	 LV_Syllable}', "");
    Expect(1, 55177, '\p{^Is_Hangul_Syllable_Type=	 LV_Syllable}', "");
    Expect(1, 55177, '\P{Is_Hangul_Syllable_Type=	 LV_Syllable}', "");
    Expect(0, 55177, '\P{^Is_Hangul_Syllable_Type=	 LV_Syllable}', "");
    Error('\p{Is_Hst= :=LV}');
    Error('\P{Is_Hst= :=LV}');
    Expect(1, 55176, '\p{Is_Hst=lv}', "");
    Expect(0, 55176, '\p{^Is_Hst=lv}', "");
    Expect(0, 55176, '\P{Is_Hst=lv}', "");
    Expect(1, 55176, '\P{^Is_Hst=lv}', "");
    Expect(0, 55177, '\p{Is_Hst=lv}', "");
    Expect(1, 55177, '\p{^Is_Hst=lv}', "");
    Expect(1, 55177, '\P{Is_Hst=lv}', "");
    Expect(0, 55177, '\P{^Is_Hst=lv}', "");
    Expect(1, 55176, '\p{Is_Hst=--LV}', "");
    Expect(0, 55176, '\p{^Is_Hst=--LV}', "");
    Expect(0, 55176, '\P{Is_Hst=--LV}', "");
    Expect(1, 55176, '\P{^Is_Hst=--LV}', "");
    Expect(0, 55177, '\p{Is_Hst=--LV}', "");
    Expect(1, 55177, '\p{^Is_Hst=--LV}', "");
    Expect(1, 55177, '\P{Is_Hst=--LV}', "");
    Expect(0, 55177, '\P{^Is_Hst=--LV}', "");
    Error('\p{Hangul_Syllable_Type=-:=LVT_syllable}');
    Error('\P{Hangul_Syllable_Type=-:=LVT_syllable}');
    Expect(1, 55203, '\p{Hangul_Syllable_Type=:\ALVT_Syllable\z:}', "");;
    Expect(0, 55204, '\p{Hangul_Syllable_Type=:\ALVT_Syllable\z:}', "");;
    Expect(1, 55203, '\p{Hangul_Syllable_Type=lvtsyllable}', "");
    Expect(0, 55203, '\p{^Hangul_Syllable_Type=lvtsyllable}', "");
    Expect(0, 55203, '\P{Hangul_Syllable_Type=lvtsyllable}', "");
    Expect(1, 55203, '\P{^Hangul_Syllable_Type=lvtsyllable}', "");
    Expect(0, 55204, '\p{Hangul_Syllable_Type=lvtsyllable}', "");
    Expect(1, 55204, '\p{^Hangul_Syllable_Type=lvtsyllable}', "");
    Expect(1, 55204, '\P{Hangul_Syllable_Type=lvtsyllable}', "");
    Expect(0, 55204, '\P{^Hangul_Syllable_Type=lvtsyllable}', "");
    Expect(1, 55203, '\p{Hangul_Syllable_Type=:\Alvtsyllable\z:}', "");;
    Expect(0, 55204, '\p{Hangul_Syllable_Type=:\Alvtsyllable\z:}', "");;
    Expect(1, 55203, '\p{Hangul_Syllable_Type=- lvt_Syllable}', "");
    Expect(0, 55203, '\p{^Hangul_Syllable_Type=- lvt_Syllable}', "");
    Expect(0, 55203, '\P{Hangul_Syllable_Type=- lvt_Syllable}', "");
    Expect(1, 55203, '\P{^Hangul_Syllable_Type=- lvt_Syllable}', "");
    Expect(0, 55204, '\p{Hangul_Syllable_Type=- lvt_Syllable}', "");
    Expect(1, 55204, '\p{^Hangul_Syllable_Type=- lvt_Syllable}', "");
    Expect(1, 55204, '\P{Hangul_Syllable_Type=- lvt_Syllable}', "");
    Expect(0, 55204, '\P{^Hangul_Syllable_Type=- lvt_Syllable}', "");
    Error('\p{Hst= _LVT:=}');
    Error('\P{Hst= _LVT:=}');
    Expect(1, 55203, '\p{Hst=:\ALVT\z:}', "");;
    Expect(0, 55204, '\p{Hst=:\ALVT\z:}', "");;
    Expect(1, 55203, '\p{Hst=lvt}', "");
    Expect(0, 55203, '\p{^Hst=lvt}', "");
    Expect(0, 55203, '\P{Hst=lvt}', "");
    Expect(1, 55203, '\P{^Hst=lvt}', "");
    Expect(0, 55204, '\p{Hst=lvt}', "");
    Expect(1, 55204, '\p{^Hst=lvt}', "");
    Expect(1, 55204, '\P{Hst=lvt}', "");
    Expect(0, 55204, '\P{^Hst=lvt}', "");
    Expect(1, 55203, '\p{Hst=:\Alvt\z:}', "");;
    Expect(0, 55204, '\p{Hst=:\Alvt\z:}', "");;
    Expect(1, 55203, '\p{Hst: -LVT}', "");
    Expect(0, 55203, '\p{^Hst: -LVT}', "");
    Expect(0, 55203, '\P{Hst: -LVT}', "");
    Expect(1, 55203, '\P{^Hst: -LVT}', "");
    Expect(0, 55204, '\p{Hst: -LVT}', "");
    Expect(1, 55204, '\p{^Hst: -LVT}', "");
    Expect(1, 55204, '\P{Hst: -LVT}', "");
    Expect(0, 55204, '\P{^Hst: -LVT}', "");
    Error('\p{Is_Hangul_Syllable_Type=_lvt_syllable/a/}');
    Error('\P{Is_Hangul_Syllable_Type=_lvt_syllable/a/}');
    Expect(1, 55203, '\p{Is_Hangul_Syllable_Type=lvtsyllable}', "");
    Expect(0, 55203, '\p{^Is_Hangul_Syllable_Type=lvtsyllable}', "");
    Expect(0, 55203, '\P{Is_Hangul_Syllable_Type=lvtsyllable}', "");
    Expect(1, 55203, '\P{^Is_Hangul_Syllable_Type=lvtsyllable}', "");
    Expect(0, 55204, '\p{Is_Hangul_Syllable_Type=lvtsyllable}', "");
    Expect(1, 55204, '\p{^Is_Hangul_Syllable_Type=lvtsyllable}', "");
    Expect(1, 55204, '\P{Is_Hangul_Syllable_Type=lvtsyllable}', "");
    Expect(0, 55204, '\P{^Is_Hangul_Syllable_Type=lvtsyllable}', "");
    Expect(1, 55203, '\p{Is_Hangul_Syllable_Type=	lvt_Syllable}', "");
    Expect(0, 55203, '\p{^Is_Hangul_Syllable_Type=	lvt_Syllable}', "");
    Expect(0, 55203, '\P{Is_Hangul_Syllable_Type=	lvt_Syllable}', "");
    Expect(1, 55203, '\P{^Is_Hangul_Syllable_Type=	lvt_Syllable}', "");
    Expect(0, 55204, '\p{Is_Hangul_Syllable_Type=	lvt_Syllable}', "");
    Expect(1, 55204, '\p{^Is_Hangul_Syllable_Type=	lvt_Syllable}', "");
    Expect(1, 55204, '\P{Is_Hangul_Syllable_Type=	lvt_Syllable}', "");
    Expect(0, 55204, '\P{^Is_Hangul_Syllable_Type=	lvt_Syllable}', "");
    Error('\p{Is_Hst=/a/		LVT}');
    Error('\P{Is_Hst=/a/		LVT}');
    Expect(1, 55203, '\p{Is_Hst=lvt}', "");
    Expect(0, 55203, '\p{^Is_Hst=lvt}', "");
    Expect(0, 55203, '\P{Is_Hst=lvt}', "");
    Expect(1, 55203, '\P{^Is_Hst=lvt}', "");
    Expect(0, 55204, '\p{Is_Hst=lvt}', "");
    Expect(1, 55204, '\p{^Is_Hst=lvt}', "");
    Expect(1, 55204, '\P{Is_Hst=lvt}', "");
    Expect(0, 55204, '\P{^Is_Hst=lvt}', "");
    Expect(1, 55203, '\p{Is_Hst=-_LVT}', "");
    Expect(0, 55203, '\p{^Is_Hst=-_LVT}', "");
    Expect(0, 55203, '\P{Is_Hst=-_LVT}', "");
    Expect(1, 55203, '\P{^Is_Hst=-_LVT}', "");
    Expect(0, 55204, '\p{Is_Hst=-_LVT}', "");
    Expect(1, 55204, '\p{^Is_Hst=-_LVT}', "");
    Expect(1, 55204, '\P{Is_Hst=-_LVT}', "");
    Expect(0, 55204, '\P{^Is_Hst=-_LVT}', "");
    Error('\p{Hangul_Syllable_Type=  not_Applicable/a/}');
    Error('\P{Hangul_Syllable_Type=  not_Applicable/a/}');
    Expect(1, 55292, '\p{Hangul_Syllable_Type=:\ANot_Applicable\z:}', "");;
    Expect(0, 55291, '\p{Hangul_Syllable_Type=:\ANot_Applicable\z:}', "");;
    Expect(1, 55292, '\p{Hangul_Syllable_Type=notapplicable}', "");
    Expect(0, 55292, '\p{^Hangul_Syllable_Type=notapplicable}', "");
    Expect(0, 55292, '\P{Hangul_Syllable_Type=notapplicable}', "");
    Expect(1, 55292, '\P{^Hangul_Syllable_Type=notapplicable}', "");
    Expect(0, 55291, '\p{Hangul_Syllable_Type=notapplicable}', "");
    Expect(1, 55291, '\p{^Hangul_Syllable_Type=notapplicable}', "");
    Expect(1, 55291, '\P{Hangul_Syllable_Type=notapplicable}', "");
    Expect(0, 55291, '\P{^Hangul_Syllable_Type=notapplicable}', "");
    Expect(1, 55292, '\p{Hangul_Syllable_Type=:\Anotapplicable\z:}', "");;
    Expect(0, 55291, '\p{Hangul_Syllable_Type=:\Anotapplicable\z:}', "");;
    Expect(1, 55292, '\p{Hangul_Syllable_Type=	not_APPLICABLE}', "");
    Expect(0, 55292, '\p{^Hangul_Syllable_Type=	not_APPLICABLE}', "");
    Expect(0, 55292, '\P{Hangul_Syllable_Type=	not_APPLICABLE}', "");
    Expect(1, 55292, '\P{^Hangul_Syllable_Type=	not_APPLICABLE}', "");
    Expect(0, 55291, '\p{Hangul_Syllable_Type=	not_APPLICABLE}', "");
    Expect(1, 55291, '\p{^Hangul_Syllable_Type=	not_APPLICABLE}', "");
    Expect(1, 55291, '\P{Hangul_Syllable_Type=	not_APPLICABLE}', "");
    Expect(0, 55291, '\P{^Hangul_Syllable_Type=	not_APPLICABLE}', "");
    Error('\p{Hst=	/a/NA}');
    Error('\P{Hst=	/a/NA}');
    Expect(1, 55292, '\p{Hst=:\ANA\z:}', "");;
    Expect(0, 55291, '\p{Hst=:\ANA\z:}', "");;
    Expect(1, 55292, '\p{Hst=na}', "");
    Expect(0, 55292, '\p{^Hst=na}', "");
    Expect(0, 55292, '\P{Hst=na}', "");
    Expect(1, 55292, '\P{^Hst=na}', "");
    Expect(0, 55291, '\p{Hst=na}', "");
    Expect(1, 55291, '\p{^Hst=na}', "");
    Expect(1, 55291, '\P{Hst=na}', "");
    Expect(0, 55291, '\P{^Hst=na}', "");
    Expect(1, 55292, '\p{Hst=:\Ana\z:}', "");;
    Expect(0, 55291, '\p{Hst=:\Ana\z:}', "");;
    Expect(1, 55292, '\p{Hst= 	NA}', "");
    Expect(0, 55292, '\p{^Hst= 	NA}', "");
    Expect(0, 55292, '\P{Hst= 	NA}', "");
    Expect(1, 55292, '\P{^Hst= 	NA}', "");
    Expect(0, 55291, '\p{Hst= 	NA}', "");
    Expect(1, 55291, '\p{^Hst= 	NA}', "");
    Expect(1, 55291, '\P{Hst= 	NA}', "");
    Expect(0, 55291, '\P{^Hst= 	NA}', "");
    Error('\p{Is_Hangul_Syllable_Type=__not_Applicable:=}');
    Error('\P{Is_Hangul_Syllable_Type=__not_Applicable:=}');
    Expect(1, 55292, '\p{Is_Hangul_Syllable_Type=notapplicable}', "");
    Expect(0, 55292, '\p{^Is_Hangul_Syllable_Type=notapplicable}', "");
    Expect(0, 55292, '\P{Is_Hangul_Syllable_Type=notapplicable}', "");
    Expect(1, 55292, '\P{^Is_Hangul_Syllable_Type=notapplicable}', "");
    Expect(0, 55291, '\p{Is_Hangul_Syllable_Type=notapplicable}', "");
    Expect(1, 55291, '\p{^Is_Hangul_Syllable_Type=notapplicable}', "");
    Expect(1, 55291, '\P{Is_Hangul_Syllable_Type=notapplicable}', "");
    Expect(0, 55291, '\P{^Is_Hangul_Syllable_Type=notapplicable}', "");
    Expect(1, 55292, '\p{Is_Hangul_Syllable_Type=-not_Applicable}', "");
    Expect(0, 55292, '\p{^Is_Hangul_Syllable_Type=-not_Applicable}', "");
    Expect(0, 55292, '\P{Is_Hangul_Syllable_Type=-not_Applicable}', "");
    Expect(1, 55292, '\P{^Is_Hangul_Syllable_Type=-not_Applicable}', "");
    Expect(0, 55291, '\p{Is_Hangul_Syllable_Type=-not_Applicable}', "");
    Expect(1, 55291, '\p{^Is_Hangul_Syllable_Type=-not_Applicable}', "");
    Expect(1, 55291, '\P{Is_Hangul_Syllable_Type=-not_Applicable}', "");
    Expect(0, 55291, '\P{^Is_Hangul_Syllable_Type=-not_Applicable}', "");
    Error('\p{Is_Hst=-NA/a/}');
    Error('\P{Is_Hst=-NA/a/}');
    Expect(1, 55292, '\p{Is_Hst:   na}', "");
    Expect(0, 55292, '\p{^Is_Hst:   na}', "");
    Expect(0, 55292, '\P{Is_Hst:   na}', "");
    Expect(1, 55292, '\P{^Is_Hst:   na}', "");
    Expect(0, 55291, '\p{Is_Hst:   na}', "");
    Expect(1, 55291, '\p{^Is_Hst:   na}', "");
    Expect(1, 55291, '\P{Is_Hst:   na}', "");
    Expect(0, 55291, '\P{^Is_Hst:   na}', "");
    Expect(1, 55292, '\p{Is_Hst=	-NA}', "");
    Expect(0, 55292, '\p{^Is_Hst=	-NA}', "");
    Expect(0, 55292, '\P{Is_Hst=	-NA}', "");
    Expect(1, 55292, '\P{^Is_Hst=	-NA}', "");
    Expect(0, 55291, '\p{Is_Hst=	-NA}', "");
    Expect(1, 55291, '\p{^Is_Hst=	-NA}', "");
    Expect(1, 55291, '\P{Is_Hst=	-NA}', "");
    Expect(0, 55291, '\P{^Is_Hst=	-NA}', "");
    Error('\p{Hangul_Syllable_Type= /a/Trailing_Jamo}');
    Error('\P{Hangul_Syllable_Type= /a/Trailing_Jamo}');
    Expect(1, 55291, '\p{Hangul_Syllable_Type=:\ATrailing_Jamo\z:}', "");;
    Expect(0, 55292, '\p{Hangul_Syllable_Type=:\ATrailing_Jamo\z:}', "");;
    Expect(1, 55291, '\p{Hangul_Syllable_Type=trailingjamo}', "");
    Expect(0, 55291, '\p{^Hangul_Syllable_Type=trailingjamo}', "");
    Expect(0, 55291, '\P{Hangul_Syllable_Type=trailingjamo}', "");
    Expect(1, 55291, '\P{^Hangul_Syllable_Type=trailingjamo}', "");
    Expect(0, 55292, '\p{Hangul_Syllable_Type=trailingjamo}', "");
    Expect(1, 55292, '\p{^Hangul_Syllable_Type=trailingjamo}', "");
    Expect(1, 55292, '\P{Hangul_Syllable_Type=trailingjamo}', "");
    Expect(0, 55292, '\P{^Hangul_Syllable_Type=trailingjamo}', "");
    Expect(1, 55291, '\p{Hangul_Syllable_Type=:\Atrailingjamo\z:}', "");;
    Expect(0, 55292, '\p{Hangul_Syllable_Type=:\Atrailingjamo\z:}', "");;
    Expect(1, 55291, '\p{Hangul_Syllable_Type:	- Trailing_Jamo}', "");
    Expect(0, 55291, '\p{^Hangul_Syllable_Type:	- Trailing_Jamo}', "");
    Expect(0, 55291, '\P{Hangul_Syllable_Type:	- Trailing_Jamo}', "");
    Expect(1, 55291, '\P{^Hangul_Syllable_Type:	- Trailing_Jamo}', "");
    Expect(0, 55292, '\p{Hangul_Syllable_Type:	- Trailing_Jamo}', "");
    Expect(1, 55292, '\p{^Hangul_Syllable_Type:	- Trailing_Jamo}', "");
    Expect(1, 55292, '\P{Hangul_Syllable_Type:	- Trailing_Jamo}', "");
    Expect(0, 55292, '\P{^Hangul_Syllable_Type:	- Trailing_Jamo}', "");
    Error('\p{Hst= :=T}');
    Error('\P{Hst= :=T}');
    Expect(1, 55291, '\p{Hst=:\AT\z:}', "");;
    Expect(0, 55292, '\p{Hst=:\AT\z:}', "");;
    Expect(1, 55291, '\p{Hst=t}', "");
    Expect(0, 55291, '\p{^Hst=t}', "");
    Expect(0, 55291, '\P{Hst=t}', "");
    Expect(1, 55291, '\P{^Hst=t}', "");
    Expect(0, 55292, '\p{Hst=t}', "");
    Expect(1, 55292, '\p{^Hst=t}', "");
    Expect(1, 55292, '\P{Hst=t}', "");
    Expect(0, 55292, '\P{^Hst=t}', "");
    Expect(1, 55291, '\p{Hst=:\At\z:}', "");;
    Expect(0, 55292, '\p{Hst=:\At\z:}', "");;
    Expect(1, 55291, '\p{Hst=_T}', "");
    Expect(0, 55291, '\p{^Hst=_T}', "");
    Expect(0, 55291, '\P{Hst=_T}', "");
    Expect(1, 55291, '\P{^Hst=_T}', "");
    Expect(0, 55292, '\p{Hst=_T}', "");
    Expect(1, 55292, '\p{^Hst=_T}', "");
    Expect(1, 55292, '\P{Hst=_T}', "");
    Expect(0, 55292, '\P{^Hst=_T}', "");
    Error('\p{Is_Hangul_Syllable_Type=:=_ TRAILING_Jamo}');
    Error('\P{Is_Hangul_Syllable_Type=:=_ TRAILING_Jamo}');
    Expect(1, 55291, '\p{Is_Hangul_Syllable_Type: trailingjamo}', "");
    Expect(0, 55291, '\p{^Is_Hangul_Syllable_Type: trailingjamo}', "");
    Expect(0, 55291, '\P{Is_Hangul_Syllable_Type: trailingjamo}', "");
    Expect(1, 55291, '\P{^Is_Hangul_Syllable_Type: trailingjamo}', "");
    Expect(0, 55292, '\p{Is_Hangul_Syllable_Type: trailingjamo}', "");
    Expect(1, 55292, '\p{^Is_Hangul_Syllable_Type: trailingjamo}', "");
    Expect(1, 55292, '\P{Is_Hangul_Syllable_Type: trailingjamo}', "");
    Expect(0, 55292, '\P{^Is_Hangul_Syllable_Type: trailingjamo}', "");
    Expect(1, 55291, '\p{Is_Hangul_Syllable_Type=	_Trailing_Jamo}', "");
    Expect(0, 55291, '\p{^Is_Hangul_Syllable_Type=	_Trailing_Jamo}', "");
    Expect(0, 55291, '\P{Is_Hangul_Syllable_Type=	_Trailing_Jamo}', "");
    Expect(1, 55291, '\P{^Is_Hangul_Syllable_Type=	_Trailing_Jamo}', "");
    Expect(0, 55292, '\p{Is_Hangul_Syllable_Type=	_Trailing_Jamo}', "");
    Expect(1, 55292, '\p{^Is_Hangul_Syllable_Type=	_Trailing_Jamo}', "");
    Expect(1, 55292, '\P{Is_Hangul_Syllable_Type=	_Trailing_Jamo}', "");
    Expect(0, 55292, '\P{^Is_Hangul_Syllable_Type=	_Trailing_Jamo}', "");
    Error('\p{Is_Hst=:=	T}');
    Error('\P{Is_Hst=:=	T}');
    Expect(1, 55291, '\p{Is_Hst=t}', "");
    Expect(0, 55291, '\p{^Is_Hst=t}', "");
    Expect(0, 55291, '\P{Is_Hst=t}', "");
    Expect(1, 55291, '\P{^Is_Hst=t}', "");
    Expect(0, 55292, '\p{Is_Hst=t}', "");
    Expect(1, 55292, '\p{^Is_Hst=t}', "");
    Expect(1, 55292, '\P{Is_Hst=t}', "");
    Expect(0, 55292, '\P{^Is_Hst=t}', "");
    Expect(1, 55291, '\p{Is_Hst=-T}', "");
    Expect(0, 55291, '\p{^Is_Hst=-T}', "");
    Expect(0, 55291, '\P{Is_Hst=-T}', "");
    Expect(1, 55291, '\P{^Is_Hst=-T}', "");
    Expect(0, 55292, '\p{Is_Hst=-T}', "");
    Expect(1, 55292, '\p{^Is_Hst=-T}', "");
    Expect(1, 55292, '\P{Is_Hst=-T}', "");
    Expect(0, 55292, '\P{^Is_Hst=-T}', "");
    Error('\p{Hangul_Syllable_Type=-	Vowel_Jamo:=}');
    Error('\P{Hangul_Syllable_Type=-	Vowel_Jamo:=}');
    Expect(1, 55238, '\p{Hangul_Syllable_Type=:\AVowel_Jamo\z:}', "");;
    Expect(0, 55239, '\p{Hangul_Syllable_Type=:\AVowel_Jamo\z:}', "");;
    Expect(1, 55238, '\p{Hangul_Syllable_Type=voweljamo}', "");
    Expect(0, 55238, '\p{^Hangul_Syllable_Type=voweljamo}', "");
    Expect(0, 55238, '\P{Hangul_Syllable_Type=voweljamo}', "");
    Expect(1, 55238, '\P{^Hangul_Syllable_Type=voweljamo}', "");
    Expect(0, 55239, '\p{Hangul_Syllable_Type=voweljamo}', "");
    Expect(1, 55239, '\p{^Hangul_Syllable_Type=voweljamo}', "");
    Expect(1, 55239, '\P{Hangul_Syllable_Type=voweljamo}', "");
    Expect(0, 55239, '\P{^Hangul_Syllable_Type=voweljamo}', "");
    Expect(1, 55238, '\p{Hangul_Syllable_Type=:\Avoweljamo\z:}', "");;
    Expect(0, 55239, '\p{Hangul_Syllable_Type=:\Avoweljamo\z:}', "");;
    Expect(1, 55238, '\p{Hangul_Syllable_Type=	 vowel_Jamo}', "");
    Expect(0, 55238, '\p{^Hangul_Syllable_Type=	 vowel_Jamo}', "");
    Expect(0, 55238, '\P{Hangul_Syllable_Type=	 vowel_Jamo}', "");
    Expect(1, 55238, '\P{^Hangul_Syllable_Type=	 vowel_Jamo}', "");
    Expect(0, 55239, '\p{Hangul_Syllable_Type=	 vowel_Jamo}', "");
    Expect(1, 55239, '\p{^Hangul_Syllable_Type=	 vowel_Jamo}', "");
    Expect(1, 55239, '\P{Hangul_Syllable_Type=	 vowel_Jamo}', "");
    Expect(0, 55239, '\P{^Hangul_Syllable_Type=	 vowel_Jamo}', "");
    Error('\p{Hst=/a/ 	V}');
    Error('\P{Hst=/a/ 	V}');
    Expect(1, 55238, '\p{Hst=:\AV\z:}', "");;
    Expect(0, 55239, '\p{Hst=:\AV\z:}', "");;
    Expect(1, 55238, '\p{Hst=v}', "");
    Expect(0, 55238, '\p{^Hst=v}', "");
    Expect(0, 55238, '\P{Hst=v}', "");
    Expect(1, 55238, '\P{^Hst=v}', "");
    Expect(0, 55239, '\p{Hst=v}', "");
    Expect(1, 55239, '\p{^Hst=v}', "");
    Expect(1, 55239, '\P{Hst=v}', "");
    Expect(0, 55239, '\P{^Hst=v}', "");
    Expect(1, 55238, '\p{Hst=:\Av\z:}', "");;
    Expect(0, 55239, '\p{Hst=:\Av\z:}', "");;
    Expect(1, 55238, '\p{Hst=-V}', "");
    Expect(0, 55238, '\p{^Hst=-V}', "");
    Expect(0, 55238, '\P{Hst=-V}', "");
    Expect(1, 55238, '\P{^Hst=-V}', "");
    Expect(0, 55239, '\p{Hst=-V}', "");
    Expect(1, 55239, '\p{^Hst=-V}', "");
    Expect(1, 55239, '\P{Hst=-V}', "");
    Expect(0, 55239, '\P{^Hst=-V}', "");
    Error('\p{Is_Hangul_Syllable_Type=/a/_	vowel_JAMO}');
    Error('\P{Is_Hangul_Syllable_Type=/a/_	vowel_JAMO}');
    Expect(1, 55238, '\p{Is_Hangul_Syllable_Type=voweljamo}', "");
    Expect(0, 55238, '\p{^Is_Hangul_Syllable_Type=voweljamo}', "");
    Expect(0, 55238, '\P{Is_Hangul_Syllable_Type=voweljamo}', "");
    Expect(1, 55238, '\P{^Is_Hangul_Syllable_Type=voweljamo}', "");
    Expect(0, 55239, '\p{Is_Hangul_Syllable_Type=voweljamo}', "");
    Expect(1, 55239, '\p{^Is_Hangul_Syllable_Type=voweljamo}', "");
    Expect(1, 55239, '\P{Is_Hangul_Syllable_Type=voweljamo}', "");
    Expect(0, 55239, '\P{^Is_Hangul_Syllable_Type=voweljamo}', "");
    Expect(1, 55238, '\p{Is_Hangul_Syllable_Type=  VOWEL_JAMO}', "");
    Expect(0, 55238, '\p{^Is_Hangul_Syllable_Type=  VOWEL_JAMO}', "");
    Expect(0, 55238, '\P{Is_Hangul_Syllable_Type=  VOWEL_JAMO}', "");
    Expect(1, 55238, '\P{^Is_Hangul_Syllable_Type=  VOWEL_JAMO}', "");
    Expect(0, 55239, '\p{Is_Hangul_Syllable_Type=  VOWEL_JAMO}', "");
    Expect(1, 55239, '\p{^Is_Hangul_Syllable_Type=  VOWEL_JAMO}', "");
    Expect(1, 55239, '\P{Is_Hangul_Syllable_Type=  VOWEL_JAMO}', "");
    Expect(0, 55239, '\P{^Is_Hangul_Syllable_Type=  VOWEL_JAMO}', "");
    Error('\p{Is_Hst=:=  V}');
    Error('\P{Is_Hst=:=  V}');
    Expect(1, 55238, '\p{Is_Hst=v}', "");
    Expect(0, 55238, '\p{^Is_Hst=v}', "");
    Expect(0, 55238, '\P{Is_Hst=v}', "");
    Expect(1, 55238, '\P{^Is_Hst=v}', "");
    Expect(0, 55239, '\p{Is_Hst=v}', "");
    Expect(1, 55239, '\p{^Is_Hst=v}', "");
    Expect(1, 55239, '\P{Is_Hst=v}', "");
    Expect(0, 55239, '\P{^Is_Hst=v}', "");
    Expect(1, 55238, '\p{Is_Hst= -V}', "");
    Expect(0, 55238, '\p{^Is_Hst= -V}', "");
    Expect(0, 55238, '\P{Is_Hst= -V}', "");
    Expect(1, 55238, '\P{^Is_Hst= -V}', "");
    Expect(0, 55239, '\p{Is_Hst= -V}', "");
    Expect(1, 55239, '\p{^Is_Hst= -V}', "");
    Expect(1, 55239, '\P{Is_Hst= -V}', "");
    Expect(0, 55239, '\P{^Is_Hst= -V}', "");
    Error('\p{Hyphen= 	No/a/}');
    Error('\P{Hyphen= 	No/a/}');
    Expect(1, 65382, '\p{Hyphen=no}', 'deprecated');
    Expect(0, 65382, '\p{^Hyphen=no}', 'deprecated');
    Expect(0, 65382, '\P{Hyphen=no}', 'deprecated');
    Expect(1, 65382, '\P{^Hyphen=no}', 'deprecated');
    Expect(0, 65381, '\p{Hyphen=no}', 'deprecated');
    Expect(1, 65381, '\p{^Hyphen=no}', 'deprecated');
    Expect(1, 65381, '\P{Hyphen=no}', 'deprecated');
    Expect(0, 65381, '\P{^Hyphen=no}', 'deprecated');
    Expect(1, 65382, '\p{Hyphen=-NO}', 'deprecated');
    Expect(0, 65382, '\p{^Hyphen=-NO}', 'deprecated');
    Expect(0, 65382, '\P{Hyphen=-NO}', 'deprecated');
    Expect(1, 65382, '\P{^Hyphen=-NO}', 'deprecated');
    Expect(0, 65381, '\p{Hyphen=-NO}', 'deprecated');
    Expect(1, 65381, '\p{^Hyphen=-NO}', 'deprecated');
    Expect(1, 65381, '\P{Hyphen=-NO}', 'deprecated');
    Expect(0, 65381, '\P{^Hyphen=-NO}', 'deprecated');
    Error('\p{Is_Hyphen=	:=N}');
    Error('\P{Is_Hyphen=	:=N}');
    Expect(1, 65382, '\p{Is_Hyphen=n}', 'deprecated');
    Expect(0, 65382, '\p{^Is_Hyphen=n}', 'deprecated');
    Expect(0, 65382, '\P{Is_Hyphen=n}', 'deprecated');
    Expect(1, 65382, '\P{^Is_Hyphen=n}', 'deprecated');
    Expect(0, 65381, '\p{Is_Hyphen=n}', 'deprecated');
    Expect(1, 65381, '\p{^Is_Hyphen=n}', 'deprecated');
    Expect(1, 65381, '\P{Is_Hyphen=n}', 'deprecated');
    Expect(0, 65381, '\P{^Is_Hyphen=n}', 'deprecated');
    Expect(1, 65382, '\p{Is_Hyphen=		n}', 'deprecated');
    Expect(0, 65382, '\p{^Is_Hyphen=		n}', 'deprecated');
    Expect(0, 65382, '\P{Is_Hyphen=		n}', 'deprecated');
    Expect(1, 65382, '\P{^Is_Hyphen=		n}', 'deprecated');
    Expect(0, 65381, '\p{Is_Hyphen=		n}', 'deprecated');
    Expect(1, 65381, '\p{^Is_Hyphen=		n}', 'deprecated');
    Expect(1, 65381, '\P{Is_Hyphen=		n}', 'deprecated');
    Expect(0, 65381, '\P{^Is_Hyphen=		n}', 'deprecated');
    Error('\p{Hyphen=:=	F}');
    Error('\P{Hyphen=:=	F}');
    Expect(1, 65382, '\p{Hyphen=:\AF\z:}', 'deprecated');;
    Expect(0, 65381, '\p{Hyphen=:\AF\z:}', 'deprecated');;
    Expect(1, 65382, '\p{Hyphen=f}', 'deprecated');
    Expect(0, 65382, '\p{^Hyphen=f}', 'deprecated');
    Expect(0, 65382, '\P{Hyphen=f}', 'deprecated');
    Expect(1, 65382, '\P{^Hyphen=f}', 'deprecated');
    Expect(0, 65381, '\p{Hyphen=f}', 'deprecated');
    Expect(1, 65381, '\p{^Hyphen=f}', 'deprecated');
    Expect(1, 65381, '\P{Hyphen=f}', 'deprecated');
    Expect(0, 65381, '\P{^Hyphen=f}', 'deprecated');
    Expect(1, 65382, '\p{Hyphen=:\Af\z:}', 'deprecated');;
    Expect(0, 65381, '\p{Hyphen=:\Af\z:}', 'deprecated');;
    Expect(1, 65382, '\p{Hyphen:   	f}', 'deprecated');
    Expect(0, 65382, '\p{^Hyphen:   	f}', 'deprecated');
    Expect(0, 65382, '\P{Hyphen:   	f}', 'deprecated');
    Expect(1, 65382, '\P{^Hyphen:   	f}', 'deprecated');
    Expect(0, 65381, '\p{Hyphen:   	f}', 'deprecated');
    Expect(1, 65381, '\p{^Hyphen:   	f}', 'deprecated');
    Expect(1, 65381, '\P{Hyphen:   	f}', 'deprecated');
    Expect(0, 65381, '\P{^Hyphen:   	f}', 'deprecated');
    Error('\p{Is_Hyphen=  False/a/}');
    Error('\P{Is_Hyphen=  False/a/}');
    Expect(1, 65382, '\p{Is_Hyphen=false}', 'deprecated');
    Expect(0, 65382, '\p{^Is_Hyphen=false}', 'deprecated');
    Expect(0, 65382, '\P{Is_Hyphen=false}', 'deprecated');
    Expect(1, 65382, '\P{^Is_Hyphen=false}', 'deprecated');
    Expect(0, 65381, '\p{Is_Hyphen=false}', 'deprecated');
    Expect(1, 65381, '\p{^Is_Hyphen=false}', 'deprecated');
    Expect(1, 65381, '\P{Is_Hyphen=false}', 'deprecated');
    Expect(0, 65381, '\P{^Is_Hyphen=false}', 'deprecated');
    Expect(1, 65382, '\p{Is_Hyphen= FALSE}', 'deprecated');
    Expect(0, 65382, '\p{^Is_Hyphen= FALSE}', 'deprecated');
    Expect(0, 65382, '\P{Is_Hyphen= FALSE}', 'deprecated');
    Expect(1, 65382, '\P{^Is_Hyphen= FALSE}', 'deprecated');
    Expect(0, 65381, '\p{Is_Hyphen= FALSE}', 'deprecated');
    Expect(1, 65381, '\p{^Is_Hyphen= FALSE}', 'deprecated');
    Expect(1, 65381, '\P{Is_Hyphen= FALSE}', 'deprecated');
    Expect(0, 65381, '\P{^Is_Hyphen= FALSE}', 'deprecated');
    Error('\p{Hyphen= _Yes:=}');
    Error('\P{Hyphen= _Yes:=}');
    Expect(1, 65381, '\p{Hyphen=yes}', 'deprecated');
    Expect(0, 65381, '\p{^Hyphen=yes}', 'deprecated');
    Expect(0, 65381, '\P{Hyphen=yes}', 'deprecated');
    Expect(1, 65381, '\P{^Hyphen=yes}', 'deprecated');
    Expect(0, 65382, '\p{Hyphen=yes}', 'deprecated');
    Expect(1, 65382, '\p{^Hyphen=yes}', 'deprecated');
    Expect(1, 65382, '\P{Hyphen=yes}', 'deprecated');
    Expect(0, 65382, '\P{^Hyphen=yes}', 'deprecated');
    Expect(1, 65381, '\p{Hyphen=		yes}', 'deprecated');
    Expect(0, 65381, '\p{^Hyphen=		yes}', 'deprecated');
    Expect(0, 65381, '\P{Hyphen=		yes}', 'deprecated');
    Expect(1, 65381, '\P{^Hyphen=		yes}', 'deprecated');
    Expect(0, 65382, '\p{Hyphen=		yes}', 'deprecated');
    Expect(1, 65382, '\p{^Hyphen=		yes}', 'deprecated');
    Expect(1, 65382, '\P{Hyphen=		yes}', 'deprecated');
    Expect(0, 65382, '\P{^Hyphen=		yes}', 'deprecated');
    Error('\p{Is_Hyphen=_-Y:=}');
    Error('\P{Is_Hyphen=_-Y:=}');
    Expect(1, 65381, '\p{Is_Hyphen=y}', 'deprecated');
    Expect(0, 65381, '\p{^Is_Hyphen=y}', 'deprecated');
    Expect(0, 65381, '\P{Is_Hyphen=y}', 'deprecated');
    Expect(1, 65381, '\P{^Is_Hyphen=y}', 'deprecated');
    Expect(0, 65382, '\p{Is_Hyphen=y}', 'deprecated');
    Expect(1, 65382, '\p{^Is_Hyphen=y}', 'deprecated');
    Expect(1, 65382, '\P{Is_Hyphen=y}', 'deprecated');
    Expect(0, 65382, '\P{^Is_Hyphen=y}', 'deprecated');
    Expect(1, 65381, '\p{Is_Hyphen=	y}', 'deprecated');
    Expect(0, 65381, '\p{^Is_Hyphen=	y}', 'deprecated');
    Expect(0, 65381, '\P{Is_Hyphen=	y}', 'deprecated');
    Expect(1, 65381, '\P{^Is_Hyphen=	y}', 'deprecated');
    Expect(0, 65382, '\p{Is_Hyphen=	y}', 'deprecated');
    Expect(1, 65382, '\p{^Is_Hyphen=	y}', 'deprecated');
    Expect(1, 65382, '\P{Is_Hyphen=	y}', 'deprecated');
    Expect(0, 65382, '\P{^Is_Hyphen=	y}', 'deprecated');
    Error('\p{Hyphen=_t:=}');
    Error('\P{Hyphen=_t:=}');
    Expect(1, 65381, '\p{Hyphen=:\AT\z:}', 'deprecated');;
    Expect(0, 65382, '\p{Hyphen=:\AT\z:}', 'deprecated');;
    Expect(1, 65381, '\p{Hyphen=t}', 'deprecated');
    Expect(0, 65381, '\p{^Hyphen=t}', 'deprecated');
    Expect(0, 65381, '\P{Hyphen=t}', 'deprecated');
    Expect(1, 65381, '\P{^Hyphen=t}', 'deprecated');
    Expect(0, 65382, '\p{Hyphen=t}', 'deprecated');
    Expect(1, 65382, '\p{^Hyphen=t}', 'deprecated');
    Expect(1, 65382, '\P{Hyphen=t}', 'deprecated');
    Expect(0, 65382, '\P{^Hyphen=t}', 'deprecated');
    Expect(1, 65381, '\p{Hyphen=:\At\z:}', 'deprecated');;
    Expect(0, 65382, '\p{Hyphen=:\At\z:}', 'deprecated');;
    Expect(1, 65381, '\p{Hyphen=_ t}', 'deprecated');
    Expect(0, 65381, '\p{^Hyphen=_ t}', 'deprecated');
    Expect(0, 65381, '\P{Hyphen=_ t}', 'deprecated');
    Expect(1, 65381, '\P{^Hyphen=_ t}', 'deprecated');
    Expect(0, 65382, '\p{Hyphen=_ t}', 'deprecated');
    Expect(1, 65382, '\p{^Hyphen=_ t}', 'deprecated');
    Expect(1, 65382, '\P{Hyphen=_ t}', 'deprecated');
    Expect(0, 65382, '\P{^Hyphen=_ t}', 'deprecated');
    Error('\p{Is_Hyphen=	 true/a/}');
    Error('\P{Is_Hyphen=	 true/a/}');
    Expect(1, 65381, '\p{Is_Hyphen=true}', 'deprecated');
    Expect(0, 65381, '\p{^Is_Hyphen=true}', 'deprecated');
    Expect(0, 65381, '\P{Is_Hyphen=true}', 'deprecated');
    Expect(1, 65381, '\P{^Is_Hyphen=true}', 'deprecated');
    Expect(0, 65382, '\p{Is_Hyphen=true}', 'deprecated');
    Expect(1, 65382, '\p{^Is_Hyphen=true}', 'deprecated');
    Expect(1, 65382, '\P{Is_Hyphen=true}', 'deprecated');
    Expect(0, 65382, '\P{^Is_Hyphen=true}', 'deprecated');
    Expect(1, 65381, '\p{Is_Hyphen=_ TRUE}', 'deprecated');
    Expect(0, 65381, '\p{^Is_Hyphen=_ TRUE}', 'deprecated');
    Expect(0, 65381, '\P{Is_Hyphen=_ TRUE}', 'deprecated');
    Expect(1, 65381, '\P{^Is_Hyphen=_ TRUE}', 'deprecated');
    Expect(0, 65382, '\p{Is_Hyphen=_ TRUE}', 'deprecated');
    Expect(1, 65382, '\p{^Is_Hyphen=_ TRUE}', 'deprecated');
    Expect(1, 65382, '\P{Is_Hyphen=_ TRUE}', 'deprecated');
    Expect(0, 65382, '\P{^Is_Hyphen=_ TRUE}', 'deprecated');
    Error('\p{ID_Continue=	No/a/}');
    Error('\P{ID_Continue=	No/a/}');
    Expect(1, 918000, '\p{ID_Continue=:\ANo\z:}', "");;
    Expect(0, 917999, '\p{ID_Continue=:\ANo\z:}', "");;
    Expect(1, 918000, '\p{ID_Continue=no}', "");
    Expect(0, 918000, '\p{^ID_Continue=no}', "");
    Expect(0, 918000, '\P{ID_Continue=no}', "");
    Expect(1, 918000, '\P{^ID_Continue=no}', "");
    Expect(0, 917999, '\p{ID_Continue=no}', "");
    Expect(1, 917999, '\p{^ID_Continue=no}', "");
    Expect(1, 917999, '\P{ID_Continue=no}', "");
    Expect(0, 917999, '\P{^ID_Continue=no}', "");
    Expect(1, 918000, '\p{ID_Continue=:\Ano\z:}', "");;
    Expect(0, 917999, '\p{ID_Continue=:\Ano\z:}', "");;
    Expect(1, 918000, '\p{ID_Continue=-No}', "");
    Expect(0, 918000, '\p{^ID_Continue=-No}', "");
    Expect(0, 918000, '\P{ID_Continue=-No}', "");
    Expect(1, 918000, '\P{^ID_Continue=-No}', "");
    Expect(0, 917999, '\p{ID_Continue=-No}', "");
    Expect(1, 917999, '\p{^ID_Continue=-No}', "");
    Expect(1, 917999, '\P{ID_Continue=-No}', "");
    Expect(0, 917999, '\P{^ID_Continue=-No}', "");
    Error('\p{IDC=	-N/a/}');
    Error('\P{IDC=	-N/a/}');
    Expect(1, 918000, '\p{IDC=:\AN\z:}', "");;
    Expect(0, 917999, '\p{IDC=:\AN\z:}', "");;
    Expect(1, 918000, '\p{IDC=n}', "");
    Expect(0, 918000, '\p{^IDC=n}', "");
    Expect(0, 918000, '\P{IDC=n}', "");
    Expect(1, 918000, '\P{^IDC=n}', "");
    Expect(0, 917999, '\p{IDC=n}', "");
    Expect(1, 917999, '\p{^IDC=n}', "");
    Expect(1, 917999, '\P{IDC=n}', "");
    Expect(0, 917999, '\P{^IDC=n}', "");
    Expect(1, 918000, '\p{IDC=:\An\z:}', "");;
    Expect(0, 917999, '\p{IDC=:\An\z:}', "");;
    Expect(1, 918000, '\p{IDC=_	N}', "");
    Expect(0, 918000, '\p{^IDC=_	N}', "");
    Expect(0, 918000, '\P{IDC=_	N}', "");
    Expect(1, 918000, '\P{^IDC=_	N}', "");
    Expect(0, 917999, '\p{IDC=_	N}', "");
    Expect(1, 917999, '\p{^IDC=_	N}', "");
    Expect(1, 917999, '\P{IDC=_	N}', "");
    Expect(0, 917999, '\P{^IDC=_	N}', "");
    Error('\p{Is_ID_Continue=	/a/f}');
    Error('\P{Is_ID_Continue=	/a/f}');
    Expect(1, 918000, '\p{Is_ID_Continue=f}', "");
    Expect(0, 918000, '\p{^Is_ID_Continue=f}', "");
    Expect(0, 918000, '\P{Is_ID_Continue=f}', "");
    Expect(1, 918000, '\P{^Is_ID_Continue=f}', "");
    Expect(0, 917999, '\p{Is_ID_Continue=f}', "");
    Expect(1, 917999, '\p{^Is_ID_Continue=f}', "");
    Expect(1, 917999, '\P{Is_ID_Continue=f}', "");
    Expect(0, 917999, '\P{^Is_ID_Continue=f}', "");
    Expect(1, 918000, '\p{Is_ID_Continue=	f}', "");
    Expect(0, 918000, '\p{^Is_ID_Continue=	f}', "");
    Expect(0, 918000, '\P{Is_ID_Continue=	f}', "");
    Expect(1, 918000, '\P{^Is_ID_Continue=	f}', "");
    Expect(0, 917999, '\p{Is_ID_Continue=	f}', "");
    Expect(1, 917999, '\p{^Is_ID_Continue=	f}', "");
    Expect(1, 917999, '\P{Is_ID_Continue=	f}', "");
    Expect(0, 917999, '\P{^Is_ID_Continue=	f}', "");
    Error('\p{Is_IDC=/a/_ FALSE}');
    Error('\P{Is_IDC=/a/_ FALSE}');
    Expect(1, 918000, '\p{Is_IDC=false}', "");
    Expect(0, 918000, '\p{^Is_IDC=false}', "");
    Expect(0, 918000, '\P{Is_IDC=false}', "");
    Expect(1, 918000, '\P{^Is_IDC=false}', "");
    Expect(0, 917999, '\p{Is_IDC=false}', "");
    Expect(1, 917999, '\p{^Is_IDC=false}', "");
    Expect(1, 917999, '\P{Is_IDC=false}', "");
    Expect(0, 917999, '\P{^Is_IDC=false}', "");
    Expect(1, 918000, '\p{Is_IDC=__False}', "");
    Expect(0, 918000, '\p{^Is_IDC=__False}', "");
    Expect(0, 918000, '\P{Is_IDC=__False}', "");
    Expect(1, 918000, '\P{^Is_IDC=__False}', "");
    Expect(0, 917999, '\p{Is_IDC=__False}', "");
    Expect(1, 917999, '\p{^Is_IDC=__False}', "");
    Expect(1, 917999, '\P{Is_IDC=__False}', "");
    Expect(0, 917999, '\P{^Is_IDC=__False}', "");
    Error('\p{ID_Continue=/a/_yes}');
    Error('\P{ID_Continue=/a/_yes}');
    Expect(1, 917999, '\p{ID_Continue=:\AYes\z:}', "");;
    Expect(0, 918000, '\p{ID_Continue=:\AYes\z:}', "");;
    Expect(1, 917999, '\p{ID_Continue=yes}', "");
    Expect(0, 917999, '\p{^ID_Continue=yes}', "");
    Expect(0, 917999, '\P{ID_Continue=yes}', "");
    Expect(1, 917999, '\P{^ID_Continue=yes}', "");
    Expect(0, 918000, '\p{ID_Continue=yes}', "");
    Expect(1, 918000, '\p{^ID_Continue=yes}', "");
    Expect(1, 918000, '\P{ID_Continue=yes}', "");
    Expect(0, 918000, '\P{^ID_Continue=yes}', "");
    Expect(1, 917999, '\p{ID_Continue=:\Ayes\z:}', "");;
    Expect(0, 918000, '\p{ID_Continue=:\Ayes\z:}', "");;
    Expect(1, 917999, '\p{ID_Continue= Yes}', "");
    Expect(0, 917999, '\p{^ID_Continue= Yes}', "");
    Expect(0, 917999, '\P{ID_Continue= Yes}', "");
    Expect(1, 917999, '\P{^ID_Continue= Yes}', "");
    Expect(0, 918000, '\p{ID_Continue= Yes}', "");
    Expect(1, 918000, '\p{^ID_Continue= Yes}', "");
    Expect(1, 918000, '\P{ID_Continue= Yes}', "");
    Expect(0, 918000, '\P{^ID_Continue= Yes}', "");
    Error('\p{IDC=	:=Y}');
    Error('\P{IDC=	:=Y}');
    Expect(1, 917999, '\p{IDC=:\AY\z:}', "");;
    Expect(0, 918000, '\p{IDC=:\AY\z:}', "");;
    Expect(1, 917999, '\p{IDC=y}', "");
    Expect(0, 917999, '\p{^IDC=y}', "");
    Expect(0, 917999, '\P{IDC=y}', "");
    Expect(1, 917999, '\P{^IDC=y}', "");
    Expect(0, 918000, '\p{IDC=y}', "");
    Expect(1, 918000, '\p{^IDC=y}', "");
    Expect(1, 918000, '\P{IDC=y}', "");
    Expect(0, 918000, '\P{^IDC=y}', "");
    Expect(1, 917999, '\p{IDC=:\Ay\z:}', "");;
    Expect(0, 918000, '\p{IDC=:\Ay\z:}', "");;
    Expect(1, 917999, '\p{IDC= Y}', "");
    Expect(0, 917999, '\p{^IDC= Y}', "");
    Expect(0, 917999, '\P{IDC= Y}', "");
    Expect(1, 917999, '\P{^IDC= Y}', "");
    Expect(0, 918000, '\p{IDC= Y}', "");
    Expect(1, 918000, '\p{^IDC= Y}', "");
    Expect(1, 918000, '\P{IDC= Y}', "");
    Expect(0, 918000, '\P{^IDC= Y}', "");
    Error('\p{Is_ID_Continue=-/a/T}');
    Error('\P{Is_ID_Continue=-/a/T}');
    Expect(1, 917999, '\p{Is_ID_Continue=t}', "");
    Expect(0, 917999, '\p{^Is_ID_Continue=t}', "");
    Expect(0, 917999, '\P{Is_ID_Continue=t}', "");
    Expect(1, 917999, '\P{^Is_ID_Continue=t}', "");
    Expect(0, 918000, '\p{Is_ID_Continue=t}', "");
    Expect(1, 918000, '\p{^Is_ID_Continue=t}', "");
    Expect(1, 918000, '\P{Is_ID_Continue=t}', "");
    Expect(0, 918000, '\P{^Is_ID_Continue=t}', "");
    Expect(1, 917999, '\p{Is_ID_Continue=	T}', "");
    Expect(0, 917999, '\p{^Is_ID_Continue=	T}', "");
    Expect(0, 917999, '\P{Is_ID_Continue=	T}', "");
    Expect(1, 917999, '\P{^Is_ID_Continue=	T}', "");
    Expect(0, 918000, '\p{Is_ID_Continue=	T}', "");
    Expect(1, 918000, '\p{^Is_ID_Continue=	T}', "");
    Expect(1, 918000, '\P{Is_ID_Continue=	T}', "");
    Expect(0, 918000, '\P{^Is_ID_Continue=	T}', "");
    Error('\p{Is_IDC=	 true:=}');
    Error('\P{Is_IDC=	 true:=}');
    Expect(1, 917999, '\p{Is_IDC=true}', "");
    Expect(0, 917999, '\p{^Is_IDC=true}', "");
    Expect(0, 917999, '\P{Is_IDC=true}', "");
    Expect(1, 917999, '\P{^Is_IDC=true}', "");
    Expect(0, 918000, '\p{Is_IDC=true}', "");
    Expect(1, 918000, '\p{^Is_IDC=true}', "");
    Expect(1, 918000, '\P{Is_IDC=true}', "");
    Expect(0, 918000, '\P{^Is_IDC=true}', "");
    Expect(1, 917999, '\p{Is_IDC= -True}', "");
    Expect(0, 917999, '\p{^Is_IDC= -True}', "");
    Expect(0, 917999, '\P{Is_IDC= -True}', "");
    Expect(1, 917999, '\P{^Is_IDC= -True}', "");
    Expect(0, 918000, '\p{Is_IDC= -True}', "");
    Expect(1, 918000, '\p{^Is_IDC= -True}', "");
    Expect(1, 918000, '\P{Is_IDC= -True}', "");
    Expect(0, 918000, '\P{^Is_IDC= -True}', "");
    Error('\p{identifierstatus}');
    Error('\P{identifierstatus}');
    Error('\p{Identifier_Status=_Allowed:=}');
    Error('\P{Identifier_Status=_Allowed:=}');
    Expect(1, 205743, '\p{Identifier_Status=:\AAllowed\z:}', "");;
    Expect(0, 205744, '\p{Identifier_Status=:\AAllowed\z:}', "");;
    Expect(1, 205743, '\p{Identifier_Status=allowed}', "");
    Expect(0, 205743, '\p{^Identifier_Status=allowed}', "");
    Expect(0, 205743, '\P{Identifier_Status=allowed}', "");
    Expect(1, 205743, '\P{^Identifier_Status=allowed}', "");
    Expect(0, 205744, '\p{Identifier_Status=allowed}', "");
    Expect(1, 205744, '\p{^Identifier_Status=allowed}', "");
    Expect(1, 205744, '\P{Identifier_Status=allowed}', "");
    Expect(0, 205744, '\P{^Identifier_Status=allowed}', "");
    Expect(1, 205743, '\p{Identifier_Status=:\Aallowed\z:}', "");;
    Expect(0, 205744, '\p{Identifier_Status=:\Aallowed\z:}', "");;
    Expect(1, 205743, '\p{Identifier_Status=_Allowed}', "");
    Expect(0, 205743, '\p{^Identifier_Status=_Allowed}', "");
    Expect(0, 205743, '\P{Identifier_Status=_Allowed}', "");
    Expect(1, 205743, '\P{^Identifier_Status=_Allowed}', "");
    Expect(0, 205744, '\p{Identifier_Status=_Allowed}', "");
    Expect(1, 205744, '\p{^Identifier_Status=_Allowed}', "");
    Expect(1, 205744, '\P{Identifier_Status=_Allowed}', "");
    Expect(0, 205744, '\P{^Identifier_Status=_Allowed}', "");
    Error('\p{Is_Identifier_Status:   	/a/Allowed}');
    Error('\P{Is_Identifier_Status:   	/a/Allowed}');
    Expect(1, 205743, '\p{Is_Identifier_Status=allowed}', "");
    Expect(0, 205743, '\p{^Is_Identifier_Status=allowed}', "");
    Expect(0, 205743, '\P{Is_Identifier_Status=allowed}', "");
    Expect(1, 205743, '\P{^Is_Identifier_Status=allowed}', "");
    Expect(0, 205744, '\p{Is_Identifier_Status=allowed}', "");
    Expect(1, 205744, '\p{^Is_Identifier_Status=allowed}', "");
    Expect(1, 205744, '\P{Is_Identifier_Status=allowed}', "");
    Expect(0, 205744, '\P{^Is_Identifier_Status=allowed}', "");
    Expect(1, 205743, '\p{Is_Identifier_Status=_	allowed}', "");
    Expect(0, 205743, '\p{^Is_Identifier_Status=_	allowed}', "");
    Expect(0, 205743, '\P{Is_Identifier_Status=_	allowed}', "");
    Expect(1, 205743, '\P{^Is_Identifier_Status=_	allowed}', "");
    Expect(0, 205744, '\p{Is_Identifier_Status=_	allowed}', "");
    Expect(1, 205744, '\p{^Is_Identifier_Status=_	allowed}', "");
    Expect(1, 205744, '\P{Is_Identifier_Status=_	allowed}', "");
    Expect(0, 205744, '\P{^Is_Identifier_Status=_	allowed}', "");
    Error('\p{Identifier_Status=-_Restricted/a/}');
    Error('\P{Identifier_Status=-_Restricted/a/}');
    Expect(1, 205744, '\p{Identifier_Status=:\ARestricted\z:}', "");;
    Expect(0, 205743, '\p{Identifier_Status=:\ARestricted\z:}', "");;
    Expect(1, 205744, '\p{Identifier_Status=restricted}', "");
    Expect(0, 205744, '\p{^Identifier_Status=restricted}', "");
    Expect(0, 205744, '\P{Identifier_Status=restricted}', "");
    Expect(1, 205744, '\P{^Identifier_Status=restricted}', "");
    Expect(0, 205743, '\p{Identifier_Status=restricted}', "");
    Expect(1, 205743, '\p{^Identifier_Status=restricted}', "");
    Expect(1, 205743, '\P{Identifier_Status=restricted}', "");
    Expect(0, 205743, '\P{^Identifier_Status=restricted}', "");
    Expect(1, 205744, '\p{Identifier_Status=:\Arestricted\z:}', "");;
    Expect(0, 205743, '\p{Identifier_Status=:\Arestricted\z:}', "");;
    Expect(1, 205744, '\p{Identifier_Status=	 Restricted}', "");
    Expect(0, 205744, '\p{^Identifier_Status=	 Restricted}', "");
    Expect(0, 205744, '\P{Identifier_Status=	 Restricted}', "");
    Expect(1, 205744, '\P{^Identifier_Status=	 Restricted}', "");
    Expect(0, 205743, '\p{Identifier_Status=	 Restricted}', "");
    Expect(1, 205743, '\p{^Identifier_Status=	 Restricted}', "");
    Expect(1, 205743, '\P{Identifier_Status=	 Restricted}', "");
    Expect(0, 205743, '\P{^Identifier_Status=	 Restricted}', "");
    Error('\p{Is_Identifier_Status=	:=Restricted}');
    Error('\P{Is_Identifier_Status=	:=Restricted}');
    Expect(1, 205744, '\p{Is_Identifier_Status=restricted}', "");
    Expect(0, 205744, '\p{^Is_Identifier_Status=restricted}', "");
    Expect(0, 205744, '\P{Is_Identifier_Status=restricted}', "");
    Expect(1, 205744, '\P{^Is_Identifier_Status=restricted}', "");
    Expect(0, 205743, '\p{Is_Identifier_Status=restricted}', "");
    Expect(1, 205743, '\p{^Is_Identifier_Status=restricted}', "");
    Expect(1, 205743, '\P{Is_Identifier_Status=restricted}', "");
    Expect(0, 205743, '\P{^Is_Identifier_Status=restricted}', "");
    Expect(1, 205744, '\p{Is_Identifier_Status=	-Restricted}', "");
    Expect(0, 205744, '\p{^Is_Identifier_Status=	-Restricted}', "");
    Expect(0, 205744, '\P{Is_Identifier_Status=	-Restricted}', "");
    Expect(1, 205744, '\P{^Is_Identifier_Status=	-Restricted}', "");
    Expect(0, 205743, '\p{Is_Identifier_Status=	-Restricted}', "");
    Expect(1, 205743, '\p{^Is_Identifier_Status=	-Restricted}', "");
    Expect(1, 205743, '\P{Is_Identifier_Status=	-Restricted}', "");
    Expect(0, 205743, '\P{^Is_Identifier_Status=	-Restricted}', "");
    Error('\p{identifiertype}');
    Error('\P{identifiertype}');
    Error('\p{Identifier_Type=:=		Default_Ignorable}');
    Error('\P{Identifier_Type=:=		Default_Ignorable}');
    Expect(1, 917999, '\p{Identifier_Type=:\ADefault_Ignorable\z:}', "");;
    Expect(0, 918000, '\p{Identifier_Type=:\ADefault_Ignorable\z:}', "");;
    Expect(1, 917999, '\p{Identifier_Type=defaultignorable}', "");
    Expect(0, 917999, '\p{^Identifier_Type=defaultignorable}', "");
    Expect(0, 917999, '\P{Identifier_Type=defaultignorable}', "");
    Expect(1, 917999, '\P{^Identifier_Type=defaultignorable}', "");
    Expect(0, 918000, '\p{Identifier_Type=defaultignorable}', "");
    Expect(1, 918000, '\p{^Identifier_Type=defaultignorable}', "");
    Expect(1, 918000, '\P{Identifier_Type=defaultignorable}', "");
    Expect(0, 918000, '\P{^Identifier_Type=defaultignorable}', "");
    Expect(1, 917999, '\p{Identifier_Type=:\Adefaultignorable\z:}', "");;
    Expect(0, 918000, '\p{Identifier_Type=:\Adefaultignorable\z:}', "");;
    Expect(1, 917999, '\p{Identifier_Type=	Default_Ignorable}', "");
    Expect(0, 917999, '\p{^Identifier_Type=	Default_Ignorable}', "");
    Expect(0, 917999, '\P{Identifier_Type=	Default_Ignorable}', "");
    Expect(1, 917999, '\P{^Identifier_Type=	Default_Ignorable}', "");
    Expect(0, 918000, '\p{Identifier_Type=	Default_Ignorable}', "");
    Expect(1, 918000, '\p{^Identifier_Type=	Default_Ignorable}', "");
    Expect(1, 918000, '\P{Identifier_Type=	Default_Ignorable}', "");
    Expect(0, 918000, '\P{^Identifier_Type=	Default_Ignorable}', "");
    Error('\p{Is_Identifier_Type=/a/		Default_Ignorable}');
    Error('\P{Is_Identifier_Type=/a/		Default_Ignorable}');
    Expect(1, 917999, '\p{Is_Identifier_Type=defaultignorable}', "");
    Expect(0, 917999, '\p{^Is_Identifier_Type=defaultignorable}', "");
    Expect(0, 917999, '\P{Is_Identifier_Type=defaultignorable}', "");
    Expect(1, 917999, '\P{^Is_Identifier_Type=defaultignorable}', "");
    Expect(0, 918000, '\p{Is_Identifier_Type=defaultignorable}', "");
    Expect(1, 918000, '\p{^Is_Identifier_Type=defaultignorable}', "");
    Expect(1, 918000, '\P{Is_Identifier_Type=defaultignorable}', "");
    Expect(0, 918000, '\P{^Is_Identifier_Type=defaultignorable}', "");
    Expect(1, 917999, '\p{Is_Identifier_Type=__Default_Ignorable}', "");
    Expect(0, 917999, '\p{^Is_Identifier_Type=__Default_Ignorable}', "");
    Expect(0, 917999, '\P{Is_Identifier_Type=__Default_Ignorable}', "");
    Expect(1, 917999, '\P{^Is_Identifier_Type=__Default_Ignorable}', "");
    Expect(0, 918000, '\p{Is_Identifier_Type=__Default_Ignorable}', "");
    Expect(1, 918000, '\p{^Is_Identifier_Type=__Default_Ignorable}', "");
    Expect(1, 918000, '\P{Is_Identifier_Type=__Default_Ignorable}', "");
    Expect(0, 918000, '\P{^Is_Identifier_Type=__Default_Ignorable}', "");
    Error('\p{Identifier_Type=/a/-	Deprecated}');
    Error('\P{Identifier_Type=/a/-	Deprecated}');
    Expect(1, 917505, '\p{Identifier_Type=:\ADeprecated\z:}', "");;
    Expect(0, 917506, '\p{Identifier_Type=:\ADeprecated\z:}', "");;
    Expect(1, 917505, '\p{Identifier_Type=deprecated}', "");
    Expect(0, 917505, '\p{^Identifier_Type=deprecated}', "");
    Expect(0, 917505, '\P{Identifier_Type=deprecated}', "");
    Expect(1, 917505, '\P{^Identifier_Type=deprecated}', "");
    Expect(0, 917506, '\p{Identifier_Type=deprecated}', "");
    Expect(1, 917506, '\p{^Identifier_Type=deprecated}', "");
    Expect(1, 917506, '\P{Identifier_Type=deprecated}', "");
    Expect(0, 917506, '\P{^Identifier_Type=deprecated}', "");
    Expect(1, 917505, '\p{Identifier_Type=:\Adeprecated\z:}', "");;
    Expect(0, 917506, '\p{Identifier_Type=:\Adeprecated\z:}', "");;
    Expect(1, 917505, '\p{Identifier_Type=  Deprecated}', "");
    Expect(0, 917505, '\p{^Identifier_Type=  Deprecated}', "");
    Expect(0, 917505, '\P{Identifier_Type=  Deprecated}', "");
    Expect(1, 917505, '\P{^Identifier_Type=  Deprecated}', "");
    Expect(0, 917506, '\p{Identifier_Type=  Deprecated}', "");
    Expect(1, 917506, '\p{^Identifier_Type=  Deprecated}', "");
    Expect(1, 917506, '\P{Identifier_Type=  Deprecated}', "");
    Expect(0, 917506, '\P{^Identifier_Type=  Deprecated}', "");
    Error('\p{Is_Identifier_Type:   Deprecated/a/}');
    Error('\P{Is_Identifier_Type:   Deprecated/a/}');
    Expect(1, 917505, '\p{Is_Identifier_Type=deprecated}', "");
    Expect(0, 917505, '\p{^Is_Identifier_Type=deprecated}', "");
    Expect(0, 917505, '\P{Is_Identifier_Type=deprecated}', "");
    Expect(1, 917505, '\P{^Is_Identifier_Type=deprecated}', "");
    Expect(0, 917506, '\p{Is_Identifier_Type=deprecated}', "");
    Expect(1, 917506, '\p{^Is_Identifier_Type=deprecated}', "");
    Expect(1, 917506, '\P{Is_Identifier_Type=deprecated}', "");
    Expect(0, 917506, '\P{^Is_Identifier_Type=deprecated}', "");
    Expect(1, 917505, '\p{Is_Identifier_Type:  DEPRECATED}', "");
    Expect(0, 917505, '\p{^Is_Identifier_Type:  DEPRECATED}', "");
    Expect(0, 917505, '\P{Is_Identifier_Type:  DEPRECATED}', "");
    Expect(1, 917505, '\P{^Is_Identifier_Type:  DEPRECATED}', "");
    Expect(0, 917506, '\p{Is_Identifier_Type:  DEPRECATED}', "");
    Expect(1, 917506, '\p{^Is_Identifier_Type:  DEPRECATED}', "");
    Expect(1, 917506, '\P{Is_Identifier_Type:  DEPRECATED}', "");
    Expect(0, 917506, '\P{^Is_Identifier_Type:  DEPRECATED}', "");
    Error('\p{Identifier_Type=/a/Exclusion}');
    Error('\P{Identifier_Type=/a/Exclusion}');
    Expect(1, 125142, '\p{Identifier_Type=:\AExclusion\z:}', "");;
    Expect(0, 125143, '\p{Identifier_Type=:\AExclusion\z:}', "");;
    Expect(1, 125142, '\p{Identifier_Type=exclusion}', "");
    Expect(0, 125142, '\p{^Identifier_Type=exclusion}', "");
    Expect(0, 125142, '\P{Identifier_Type=exclusion}', "");
    Expect(1, 125142, '\P{^Identifier_Type=exclusion}', "");
    Expect(0, 125143, '\p{Identifier_Type=exclusion}', "");
    Expect(1, 125143, '\p{^Identifier_Type=exclusion}', "");
    Expect(1, 125143, '\P{Identifier_Type=exclusion}', "");
    Expect(0, 125143, '\P{^Identifier_Type=exclusion}', "");
    Expect(1, 125142, '\p{Identifier_Type=:\Aexclusion\z:}', "");;
    Expect(0, 125143, '\p{Identifier_Type=:\Aexclusion\z:}', "");;
    Expect(1, 125142, '\p{Identifier_Type=	 Exclusion}', "");
    Expect(0, 125142, '\p{^Identifier_Type=	 Exclusion}', "");
    Expect(0, 125142, '\P{Identifier_Type=	 Exclusion}', "");
    Expect(1, 125142, '\P{^Identifier_Type=	 Exclusion}', "");
    Expect(0, 125143, '\p{Identifier_Type=	 Exclusion}', "");
    Expect(1, 125143, '\p{^Identifier_Type=	 Exclusion}', "");
    Expect(1, 125143, '\P{Identifier_Type=	 Exclusion}', "");
    Expect(0, 125143, '\P{^Identifier_Type=	 Exclusion}', "");
    Error('\p{Is_Identifier_Type=-Exclusion:=}');
    Error('\P{Is_Identifier_Type=-Exclusion:=}');
    Expect(1, 125142, '\p{Is_Identifier_Type=exclusion}', "");
    Expect(0, 125142, '\p{^Is_Identifier_Type=exclusion}', "");
    Expect(0, 125142, '\P{Is_Identifier_Type=exclusion}', "");
    Expect(1, 125142, '\P{^Is_Identifier_Type=exclusion}', "");
    Expect(0, 125143, '\p{Is_Identifier_Type=exclusion}', "");
    Expect(1, 125143, '\p{^Is_Identifier_Type=exclusion}', "");
    Expect(1, 125143, '\P{Is_Identifier_Type=exclusion}', "");
    Expect(0, 125143, '\P{^Is_Identifier_Type=exclusion}', "");
    Expect(1, 125142, '\p{Is_Identifier_Type=	-EXCLUSION}', "");
    Expect(0, 125142, '\p{^Is_Identifier_Type=	-EXCLUSION}', "");
    Expect(0, 125142, '\P{Is_Identifier_Type=	-EXCLUSION}', "");
    Expect(1, 125142, '\P{^Is_Identifier_Type=	-EXCLUSION}', "");
    Expect(0, 125143, '\p{Is_Identifier_Type=	-EXCLUSION}', "");
    Expect(1, 125143, '\p{^Is_Identifier_Type=	-EXCLUSION}', "");
    Expect(1, 125143, '\P{Is_Identifier_Type=	-EXCLUSION}', "");
    Expect(0, 125143, '\P{^Is_Identifier_Type=	-EXCLUSION}', "");
    Error('\p{Identifier_Type=_:=INCLUSION}');
    Error('\P{Identifier_Type=_:=INCLUSION}');
    Expect(1, 12539, '\p{Identifier_Type=:\AInclusion\z:}', "");;
    Expect(0, 12540, '\p{Identifier_Type=:\AInclusion\z:}', "");;
    Expect(1, 12539, '\p{Identifier_Type=inclusion}', "");
    Expect(0, 12539, '\p{^Identifier_Type=inclusion}', "");
    Expect(0, 12539, '\P{Identifier_Type=inclusion}', "");
    Expect(1, 12539, '\P{^Identifier_Type=inclusion}', "");
    Expect(0, 12540, '\p{Identifier_Type=inclusion}', "");
    Expect(1, 12540, '\p{^Identifier_Type=inclusion}', "");
    Expect(1, 12540, '\P{Identifier_Type=inclusion}', "");
    Expect(0, 12540, '\P{^Identifier_Type=inclusion}', "");
    Expect(1, 12539, '\p{Identifier_Type=:\Ainclusion\z:}', "");;
    Expect(0, 12540, '\p{Identifier_Type=:\Ainclusion\z:}', "");;
    Expect(1, 12539, '\p{Identifier_Type=__INCLUSION}', "");
    Expect(0, 12539, '\p{^Identifier_Type=__INCLUSION}', "");
    Expect(0, 12539, '\P{Identifier_Type=__INCLUSION}', "");
    Expect(1, 12539, '\P{^Identifier_Type=__INCLUSION}', "");
    Expect(0, 12540, '\p{Identifier_Type=__INCLUSION}', "");
    Expect(1, 12540, '\p{^Identifier_Type=__INCLUSION}', "");
    Expect(1, 12540, '\P{Identifier_Type=__INCLUSION}', "");
    Expect(0, 12540, '\P{^Identifier_Type=__INCLUSION}', "");
    Error('\p{Is_Identifier_Type=_	Inclusion/a/}');
    Error('\P{Is_Identifier_Type=_	Inclusion/a/}');
    Expect(1, 12539, '\p{Is_Identifier_Type=inclusion}', "");
    Expect(0, 12539, '\p{^Is_Identifier_Type=inclusion}', "");
    Expect(0, 12539, '\P{Is_Identifier_Type=inclusion}', "");
    Expect(1, 12539, '\P{^Is_Identifier_Type=inclusion}', "");
    Expect(0, 12540, '\p{Is_Identifier_Type=inclusion}', "");
    Expect(1, 12540, '\p{^Is_Identifier_Type=inclusion}', "");
    Expect(1, 12540, '\P{Is_Identifier_Type=inclusion}', "");
    Expect(0, 12540, '\P{^Is_Identifier_Type=inclusion}', "");
    Expect(1, 12539, '\p{Is_Identifier_Type=_-inclusion}', "");
    Expect(0, 12539, '\p{^Is_Identifier_Type=_-inclusion}', "");
    Expect(0, 12539, '\P{Is_Identifier_Type=_-inclusion}', "");
    Expect(1, 12539, '\P{^Is_Identifier_Type=_-inclusion}', "");
    Expect(0, 12540, '\p{Is_Identifier_Type=_-inclusion}', "");
    Expect(1, 12540, '\p{^Is_Identifier_Type=_-inclusion}', "");
    Expect(1, 12540, '\P{Is_Identifier_Type=_-inclusion}', "");
    Expect(0, 12540, '\P{^Is_Identifier_Type=_-inclusion}', "");
    Error('\p{Identifier_Type=_:=limited_Use}');
    Error('\P{Identifier_Type=_:=limited_Use}');
    Expect(1, 125279, '\p{Identifier_Type=:\ALimited_Use\z:}', "");;
    Expect(0, 125280, '\p{Identifier_Type=:\ALimited_Use\z:}', "");;
    Expect(1, 125279, '\p{Identifier_Type=limiteduse}', "");
    Expect(0, 125279, '\p{^Identifier_Type=limiteduse}', "");
    Expect(0, 125279, '\P{Identifier_Type=limiteduse}', "");
    Expect(1, 125279, '\P{^Identifier_Type=limiteduse}', "");
    Expect(0, 125280, '\p{Identifier_Type=limiteduse}', "");
    Expect(1, 125280, '\p{^Identifier_Type=limiteduse}', "");
    Expect(1, 125280, '\P{Identifier_Type=limiteduse}', "");
    Expect(0, 125280, '\P{^Identifier_Type=limiteduse}', "");
    Expect(1, 125279, '\p{Identifier_Type=:\Alimiteduse\z:}', "");;
    Expect(0, 125280, '\p{Identifier_Type=:\Alimiteduse\z:}', "");;
    Expect(1, 125279, '\p{Identifier_Type=	LIMITED_use}', "");
    Expect(0, 125279, '\p{^Identifier_Type=	LIMITED_use}', "");
    Expect(0, 125279, '\P{Identifier_Type=	LIMITED_use}', "");
    Expect(1, 125279, '\P{^Identifier_Type=	LIMITED_use}', "");
    Expect(0, 125280, '\p{Identifier_Type=	LIMITED_use}', "");
    Expect(1, 125280, '\p{^Identifier_Type=	LIMITED_use}', "");
    Expect(1, 125280, '\P{Identifier_Type=	LIMITED_use}', "");
    Expect(0, 125280, '\P{^Identifier_Type=	LIMITED_use}', "");
    Error('\p{Is_Identifier_Type=/a/_Limited_use}');
    Error('\P{Is_Identifier_Type=/a/_Limited_use}');
    Expect(1, 125279, '\p{Is_Identifier_Type=limiteduse}', "");
    Expect(0, 125279, '\p{^Is_Identifier_Type=limiteduse}', "");
    Expect(0, 125279, '\P{Is_Identifier_Type=limiteduse}', "");
    Expect(1, 125279, '\P{^Is_Identifier_Type=limiteduse}', "");
    Expect(0, 125280, '\p{Is_Identifier_Type=limiteduse}', "");
    Expect(1, 125280, '\p{^Is_Identifier_Type=limiteduse}', "");
    Expect(1, 125280, '\P{Is_Identifier_Type=limiteduse}', "");
    Expect(0, 125280, '\P{^Is_Identifier_Type=limiteduse}', "");
    Expect(1, 125279, '\p{Is_Identifier_Type=_	LIMITED_Use}', "");
    Expect(0, 125279, '\p{^Is_Identifier_Type=_	LIMITED_Use}', "");
    Expect(0, 125279, '\P{Is_Identifier_Type=_	LIMITED_Use}', "");
    Expect(1, 125279, '\P{^Is_Identifier_Type=_	LIMITED_Use}', "");
    Expect(0, 125280, '\p{Is_Identifier_Type=_	LIMITED_Use}', "");
    Expect(1, 125280, '\p{^Is_Identifier_Type=_	LIMITED_Use}', "");
    Expect(1, 125280, '\P{Is_Identifier_Type=_	LIMITED_Use}', "");
    Expect(0, 125280, '\P{^Is_Identifier_Type=_	LIMITED_Use}', "");
    Error('\p{Identifier_Type=/a/		not_Character}');
    Error('\P{Identifier_Type=/a/		not_Character}');
    Expect(1, 918000, '\p{Identifier_Type=:\ANot_Character\z:}', "");;
    Expect(0, 917999, '\p{Identifier_Type=:\ANot_Character\z:}', "");;
    Expect(1, 918000, '\p{Identifier_Type=notcharacter}', "");
    Expect(0, 918000, '\p{^Identifier_Type=notcharacter}', "");
    Expect(0, 918000, '\P{Identifier_Type=notcharacter}', "");
    Expect(1, 918000, '\P{^Identifier_Type=notcharacter}', "");
    Expect(0, 917999, '\p{Identifier_Type=notcharacter}', "");
    Expect(1, 917999, '\p{^Identifier_Type=notcharacter}', "");
    Expect(1, 917999, '\P{Identifier_Type=notcharacter}', "");
    Expect(0, 917999, '\P{^Identifier_Type=notcharacter}', "");
    Expect(1, 918000, '\p{Identifier_Type=:\Anotcharacter\z:}', "");;
    Expect(0, 917999, '\p{Identifier_Type=:\Anotcharacter\z:}', "");;
    Expect(1, 918000, '\p{Identifier_Type= Not_Character}', "");
    Expect(0, 918000, '\p{^Identifier_Type= Not_Character}', "");
    Expect(0, 918000, '\P{Identifier_Type= Not_Character}', "");
    Expect(1, 918000, '\P{^Identifier_Type= Not_Character}', "");
    Expect(0, 917999, '\p{Identifier_Type= Not_Character}', "");
    Expect(1, 917999, '\p{^Identifier_Type= Not_Character}', "");
    Expect(1, 917999, '\P{Identifier_Type= Not_Character}', "");
    Expect(0, 917999, '\P{^Identifier_Type= Not_Character}', "");
    Error('\p{Is_Identifier_Type=:=  Not_CHARACTER}');
    Error('\P{Is_Identifier_Type=:=  Not_CHARACTER}');
    Expect(1, 918000, '\p{Is_Identifier_Type=notcharacter}', "");
    Expect(0, 918000, '\p{^Is_Identifier_Type=notcharacter}', "");
    Expect(0, 918000, '\P{Is_Identifier_Type=notcharacter}', "");
    Expect(1, 918000, '\P{^Is_Identifier_Type=notcharacter}', "");
    Expect(0, 917999, '\p{Is_Identifier_Type=notcharacter}', "");
    Expect(1, 917999, '\p{^Is_Identifier_Type=notcharacter}', "");
    Expect(1, 917999, '\P{Is_Identifier_Type=notcharacter}', "");
    Expect(0, 917999, '\P{^Is_Identifier_Type=notcharacter}', "");
    Expect(1, 918000, '\p{Is_Identifier_Type= Not_Character}', "");
    Expect(0, 918000, '\p{^Is_Identifier_Type= Not_Character}', "");
    Expect(0, 918000, '\P{Is_Identifier_Type= Not_Character}', "");
    Expect(1, 918000, '\P{^Is_Identifier_Type= Not_Character}', "");
    Expect(0, 917999, '\p{Is_Identifier_Type= Not_Character}', "");
    Expect(1, 917999, '\p{^Is_Identifier_Type= Not_Character}', "");
    Expect(1, 917999, '\P{Is_Identifier_Type= Not_Character}', "");
    Expect(0, 917999, '\P{^Is_Identifier_Type= Not_Character}', "");
    Error('\p{Identifier_Type=- not_NFKC/a/}');
    Error('\P{Identifier_Type=- not_NFKC/a/}');
    Expect(1, 195101, '\p{Identifier_Type=:\ANot_NFKC\z:}', "");;
    Expect(0, 195102, '\p{Identifier_Type=:\ANot_NFKC\z:}', "");;
    Expect(1, 195101, '\p{Identifier_Type=notnfkc}', "");
    Expect(0, 195101, '\p{^Identifier_Type=notnfkc}', "");
    Expect(0, 195101, '\P{Identifier_Type=notnfkc}', "");
    Expect(1, 195101, '\P{^Identifier_Type=notnfkc}', "");
    Expect(0, 195102, '\p{Identifier_Type=notnfkc}', "");
    Expect(1, 195102, '\p{^Identifier_Type=notnfkc}', "");
    Expect(1, 195102, '\P{Identifier_Type=notnfkc}', "");
    Expect(0, 195102, '\P{^Identifier_Type=notnfkc}', "");
    Expect(1, 195101, '\p{Identifier_Type=:\Anotnfkc\z:}', "");;
    Expect(0, 195102, '\p{Identifier_Type=:\Anotnfkc\z:}', "");;
    Expect(1, 195101, '\p{Identifier_Type= -Not_nfkc}', "");
    Expect(0, 195101, '\p{^Identifier_Type= -Not_nfkc}', "");
    Expect(0, 195101, '\P{Identifier_Type= -Not_nfkc}', "");
    Expect(1, 195101, '\P{^Identifier_Type= -Not_nfkc}', "");
    Expect(0, 195102, '\p{Identifier_Type= -Not_nfkc}', "");
    Expect(1, 195102, '\p{^Identifier_Type= -Not_nfkc}', "");
    Expect(1, 195102, '\P{Identifier_Type= -Not_nfkc}', "");
    Expect(0, 195102, '\P{^Identifier_Type= -Not_nfkc}', "");
    Error('\p{Is_Identifier_Type=	Not_nfkc:=}');
    Error('\P{Is_Identifier_Type=	Not_nfkc:=}');
    Expect(1, 195101, '\p{Is_Identifier_Type=notnfkc}', "");
    Expect(0, 195101, '\p{^Is_Identifier_Type=notnfkc}', "");
    Expect(0, 195101, '\P{Is_Identifier_Type=notnfkc}', "");
    Expect(1, 195101, '\P{^Is_Identifier_Type=notnfkc}', "");
    Expect(0, 195102, '\p{Is_Identifier_Type=notnfkc}', "");
    Expect(1, 195102, '\p{^Is_Identifier_Type=notnfkc}', "");
    Expect(1, 195102, '\P{Is_Identifier_Type=notnfkc}', "");
    Expect(0, 195102, '\P{^Is_Identifier_Type=notnfkc}', "");
    Expect(1, 195101, '\p{Is_Identifier_Type= -Not_NFKC}', "");
    Expect(0, 195101, '\p{^Is_Identifier_Type= -Not_NFKC}', "");
    Expect(0, 195101, '\P{Is_Identifier_Type= -Not_NFKC}', "");
    Expect(1, 195101, '\P{^Is_Identifier_Type= -Not_NFKC}', "");
    Expect(0, 195102, '\p{Is_Identifier_Type= -Not_NFKC}', "");
    Expect(1, 195102, '\p{^Is_Identifier_Type= -Not_NFKC}', "");
    Expect(1, 195102, '\P{Is_Identifier_Type= -Not_NFKC}', "");
    Expect(0, 195102, '\P{^Is_Identifier_Type= -Not_NFKC}', "");
    Error('\p{Identifier_Type=/a/_not_XID}');
    Error('\P{Identifier_Type=/a/_not_XID}');
    Expect(1, 129994, '\p{Identifier_Type=:\ANot_XID\z:}', "");;
    Expect(0, 129995, '\p{Identifier_Type=:\ANot_XID\z:}', "");;
    Expect(1, 129994, '\p{Identifier_Type:   notxid}', "");
    Expect(0, 129994, '\p{^Identifier_Type:   notxid}', "");
    Expect(0, 129994, '\P{Identifier_Type:   notxid}', "");
    Expect(1, 129994, '\P{^Identifier_Type:   notxid}', "");
    Expect(0, 129995, '\p{Identifier_Type:   notxid}', "");
    Expect(1, 129995, '\p{^Identifier_Type:   notxid}', "");
    Expect(1, 129995, '\P{Identifier_Type:   notxid}', "");
    Expect(0, 129995, '\P{^Identifier_Type:   notxid}', "");
    Expect(1, 129994, '\p{Identifier_Type=:\Anotxid\z:}', "");;
    Expect(0, 129995, '\p{Identifier_Type=:\Anotxid\z:}', "");;
    Expect(1, 129994, '\p{Identifier_Type=	_NOT_XID}', "");
    Expect(0, 129994, '\p{^Identifier_Type=	_NOT_XID}', "");
    Expect(0, 129994, '\P{Identifier_Type=	_NOT_XID}', "");
    Expect(1, 129994, '\P{^Identifier_Type=	_NOT_XID}', "");
    Expect(0, 129995, '\p{Identifier_Type=	_NOT_XID}', "");
    Expect(1, 129995, '\p{^Identifier_Type=	_NOT_XID}', "");
    Expect(1, 129995, '\P{Identifier_Type=	_NOT_XID}', "");
    Expect(0, 129995, '\P{^Identifier_Type=	_NOT_XID}', "");
    Error('\p{Is_Identifier_Type= -Not_XID:=}');
    Error('\P{Is_Identifier_Type= -Not_XID:=}');
    Expect(1, 129994, '\p{Is_Identifier_Type=notxid}', "");
    Expect(0, 129994, '\p{^Is_Identifier_Type=notxid}', "");
    Expect(0, 129994, '\P{Is_Identifier_Type=notxid}', "");
    Expect(1, 129994, '\P{^Is_Identifier_Type=notxid}', "");
    Expect(0, 129995, '\p{Is_Identifier_Type=notxid}', "");
    Expect(1, 129995, '\p{^Is_Identifier_Type=notxid}', "");
    Expect(1, 129995, '\P{Is_Identifier_Type=notxid}', "");
    Expect(0, 129995, '\P{^Is_Identifier_Type=notxid}', "");
    Expect(1, 129994, '\p{Is_Identifier_Type= _not_xid}', "");
    Expect(0, 129994, '\p{^Is_Identifier_Type= _not_xid}', "");
    Expect(0, 129994, '\P{Is_Identifier_Type= _not_xid}', "");
    Expect(1, 129994, '\P{^Is_Identifier_Type= _not_xid}', "");
    Expect(0, 129995, '\p{Is_Identifier_Type= _not_xid}', "");
    Expect(1, 129995, '\p{^Is_Identifier_Type= _not_xid}', "");
    Expect(1, 129995, '\P{Is_Identifier_Type= _not_xid}', "");
    Expect(0, 129995, '\P{^Is_Identifier_Type= _not_xid}', "");
    Error('\p{Identifier_Type=-	OBSOLETE:=}');
    Error('\P{Identifier_Type=-	OBSOLETE:=}');
    Expect(1, 119365, '\p{Identifier_Type=:\AObsolete\z:}', "");;
    Expect(0, 119366, '\p{Identifier_Type=:\AObsolete\z:}', "");;
    Expect(1, 119365, '\p{Identifier_Type=obsolete}', "");
    Expect(0, 119365, '\p{^Identifier_Type=obsolete}', "");
    Expect(0, 119365, '\P{Identifier_Type=obsolete}', "");
    Expect(1, 119365, '\P{^Identifier_Type=obsolete}', "");
    Expect(0, 119366, '\p{Identifier_Type=obsolete}', "");
    Expect(1, 119366, '\p{^Identifier_Type=obsolete}', "");
    Expect(1, 119366, '\P{Identifier_Type=obsolete}', "");
    Expect(0, 119366, '\P{^Identifier_Type=obsolete}', "");
    Expect(1, 119365, '\p{Identifier_Type=:\Aobsolete\z:}', "");;
    Expect(0, 119366, '\p{Identifier_Type=:\Aobsolete\z:}', "");;
    Expect(1, 119365, '\p{Identifier_Type:_-obsolete}', "");
    Expect(0, 119365, '\p{^Identifier_Type:_-obsolete}', "");
    Expect(0, 119365, '\P{Identifier_Type:_-obsolete}', "");
    Expect(1, 119365, '\P{^Identifier_Type:_-obsolete}', "");
    Expect(0, 119366, '\p{Identifier_Type:_-obsolete}', "");
    Expect(1, 119366, '\p{^Identifier_Type:_-obsolete}', "");
    Expect(1, 119366, '\P{Identifier_Type:_-obsolete}', "");
    Expect(0, 119366, '\P{^Identifier_Type:_-obsolete}', "");
    Error('\p{Is_Identifier_Type=:=	obsolete}');
    Error('\P{Is_Identifier_Type=:=	obsolete}');
    Expect(1, 119365, '\p{Is_Identifier_Type=obsolete}', "");
    Expect(0, 119365, '\p{^Is_Identifier_Type=obsolete}', "");
    Expect(0, 119365, '\P{Is_Identifier_Type=obsolete}', "");
    Expect(1, 119365, '\P{^Is_Identifier_Type=obsolete}', "");
    Expect(0, 119366, '\p{Is_Identifier_Type=obsolete}', "");
    Expect(1, 119366, '\p{^Is_Identifier_Type=obsolete}', "");
    Expect(1, 119366, '\P{Is_Identifier_Type=obsolete}', "");
    Expect(0, 119366, '\P{^Is_Identifier_Type=obsolete}', "");
    Expect(1, 119365, '\p{Is_Identifier_Type: -Obsolete}', "");
    Expect(0, 119365, '\p{^Is_Identifier_Type: -Obsolete}', "");
    Expect(0, 119365, '\P{Is_Identifier_Type: -Obsolete}', "");
    Expect(1, 119365, '\P{^Is_Identifier_Type: -Obsolete}', "");
    Expect(0, 119366, '\p{Is_Identifier_Type: -Obsolete}', "");
    Expect(1, 119366, '\p{^Is_Identifier_Type: -Obsolete}', "");
    Expect(1, 119366, '\P{Is_Identifier_Type: -Obsolete}', "");
    Expect(0, 119366, '\P{^Is_Identifier_Type: -Obsolete}', "");
    Error('\p{Identifier_Type=	Recommended/a/}');
    Error('\P{Identifier_Type=	Recommended/a/}');
    Expect(1, 205743, '\p{Identifier_Type=:\ARecommended\z:}', "");;
    Expect(0, 205744, '\p{Identifier_Type=:\ARecommended\z:}', "");;
    Expect(1, 205743, '\p{Identifier_Type=recommended}', "");
    Expect(0, 205743, '\p{^Identifier_Type=recommended}', "");
    Expect(0, 205743, '\P{Identifier_Type=recommended}', "");
    Expect(1, 205743, '\P{^Identifier_Type=recommended}', "");
    Expect(0, 205744, '\p{Identifier_Type=recommended}', "");
    Expect(1, 205744, '\p{^Identifier_Type=recommended}', "");
    Expect(1, 205744, '\P{Identifier_Type=recommended}', "");
    Expect(0, 205744, '\P{^Identifier_Type=recommended}', "");
    Expect(1, 205743, '\p{Identifier_Type=:\Arecommended\z:}', "");;
    Expect(0, 205744, '\p{Identifier_Type=:\Arecommended\z:}', "");;
    Expect(1, 205743, '\p{Identifier_Type=_ RECOMMENDED}', "");
    Expect(0, 205743, '\p{^Identifier_Type=_ RECOMMENDED}', "");
    Expect(0, 205743, '\P{Identifier_Type=_ RECOMMENDED}', "");
    Expect(1, 205743, '\P{^Identifier_Type=_ RECOMMENDED}', "");
    Expect(0, 205744, '\p{Identifier_Type=_ RECOMMENDED}', "");
    Expect(1, 205744, '\p{^Identifier_Type=_ RECOMMENDED}', "");
    Expect(1, 205744, '\P{Identifier_Type=_ RECOMMENDED}', "");
    Expect(0, 205744, '\P{^Identifier_Type=_ RECOMMENDED}', "");
    Error('\p{Is_Identifier_Type=:=--recommended}');
    Error('\P{Is_Identifier_Type=:=--recommended}');
    Expect(1, 205743, '\p{Is_Identifier_Type=recommended}', "");
    Expect(0, 205743, '\p{^Is_Identifier_Type=recommended}', "");
    Expect(0, 205743, '\P{Is_Identifier_Type=recommended}', "");
    Expect(1, 205743, '\P{^Is_Identifier_Type=recommended}', "");
    Expect(0, 205744, '\p{Is_Identifier_Type=recommended}', "");
    Expect(1, 205744, '\p{^Is_Identifier_Type=recommended}', "");
    Expect(1, 205744, '\P{Is_Identifier_Type=recommended}', "");
    Expect(0, 205744, '\P{^Is_Identifier_Type=recommended}', "");
    Expect(1, 205743, '\p{Is_Identifier_Type=	Recommended}', "");
    Expect(0, 205743, '\p{^Is_Identifier_Type=	Recommended}', "");
    Expect(0, 205743, '\P{Is_Identifier_Type=	Recommended}', "");
    Expect(1, 205743, '\P{^Is_Identifier_Type=	Recommended}', "");
    Expect(0, 205744, '\p{Is_Identifier_Type=	Recommended}', "");
    Expect(1, 205744, '\p{^Is_Identifier_Type=	Recommended}', "");
    Expect(1, 205744, '\P{Is_Identifier_Type=	Recommended}', "");
    Expect(0, 205744, '\P{^Is_Identifier_Type=	Recommended}', "");
    Error('\p{Identifier_Type:   :=	technical}');
    Error('\P{Identifier_Type:   :=	technical}');
    Expect(1, 119638, '\p{Identifier_Type=:\ATechnical\z:}', "");;
    Expect(0, 119639, '\p{Identifier_Type=:\ATechnical\z:}', "");;
    Expect(1, 119638, '\p{Identifier_Type=technical}', "");
    Expect(0, 119638, '\p{^Identifier_Type=technical}', "");
    Expect(0, 119638, '\P{Identifier_Type=technical}', "");
    Expect(1, 119638, '\P{^Identifier_Type=technical}', "");
    Expect(0, 119639, '\p{Identifier_Type=technical}', "");
    Expect(1, 119639, '\p{^Identifier_Type=technical}', "");
    Expect(1, 119639, '\P{Identifier_Type=technical}', "");
    Expect(0, 119639, '\P{^Identifier_Type=technical}', "");
    Expect(1, 119638, '\p{Identifier_Type=:\Atechnical\z:}', "");;
    Expect(0, 119639, '\p{Identifier_Type=:\Atechnical\z:}', "");;
    Expect(1, 119638, '\p{Identifier_Type=-	TECHNICAL}', "");
    Expect(0, 119638, '\p{^Identifier_Type=-	TECHNICAL}', "");
    Expect(0, 119638, '\P{Identifier_Type=-	TECHNICAL}', "");
    Expect(1, 119638, '\P{^Identifier_Type=-	TECHNICAL}', "");
    Expect(0, 119639, '\p{Identifier_Type=-	TECHNICAL}', "");
    Expect(1, 119639, '\p{^Identifier_Type=-	TECHNICAL}', "");
    Expect(1, 119639, '\P{Identifier_Type=-	TECHNICAL}', "");
    Expect(0, 119639, '\P{^Identifier_Type=-	TECHNICAL}', "");
    Error('\p{Is_Identifier_Type=/a/-_Technical}');
    Error('\P{Is_Identifier_Type=/a/-_Technical}');
    Expect(1, 119638, '\p{Is_Identifier_Type=technical}', "");
    Expect(0, 119638, '\p{^Is_Identifier_Type=technical}', "");
    Expect(0, 119638, '\P{Is_Identifier_Type=technical}', "");
    Expect(1, 119638, '\P{^Is_Identifier_Type=technical}', "");
    Expect(0, 119639, '\p{Is_Identifier_Type=technical}', "");
    Expect(1, 119639, '\p{^Is_Identifier_Type=technical}', "");
    Expect(1, 119639, '\P{Is_Identifier_Type=technical}', "");
    Expect(0, 119639, '\P{^Is_Identifier_Type=technical}', "");
    Expect(1, 119638, '\p{Is_Identifier_Type=--technical}', "");
    Expect(0, 119638, '\p{^Is_Identifier_Type=--technical}', "");
    Expect(0, 119638, '\P{Is_Identifier_Type=--technical}', "");
    Expect(1, 119638, '\P{^Is_Identifier_Type=--technical}', "");
    Expect(0, 119639, '\p{Is_Identifier_Type=--technical}', "");
    Expect(1, 119639, '\p{^Is_Identifier_Type=--technical}', "");
    Expect(1, 119639, '\P{Is_Identifier_Type=--technical}', "");
    Expect(0, 119639, '\P{^Is_Identifier_Type=--technical}', "");
    Error('\p{Identifier_Type=:=__Uncommon_Use}');
    Error('\P{Identifier_Type=:=__Uncommon_Use}');
    Expect(1, 128335, '\p{Identifier_Type=:\AUncommon_Use\z:}', "");;
    Expect(0, 128336, '\p{Identifier_Type=:\AUncommon_Use\z:}', "");;
    Expect(1, 128335, '\p{Identifier_Type: uncommonuse}', "");
    Expect(0, 128335, '\p{^Identifier_Type: uncommonuse}', "");
    Expect(0, 128335, '\P{Identifier_Type: uncommonuse}', "");
    Expect(1, 128335, '\P{^Identifier_Type: uncommonuse}', "");
    Expect(0, 128336, '\p{Identifier_Type: uncommonuse}', "");
    Expect(1, 128336, '\p{^Identifier_Type: uncommonuse}', "");
    Expect(1, 128336, '\P{Identifier_Type: uncommonuse}', "");
    Expect(0, 128336, '\P{^Identifier_Type: uncommonuse}', "");
    Expect(1, 128335, '\p{Identifier_Type=:\Auncommonuse\z:}', "");;
    Expect(0, 128336, '\p{Identifier_Type=:\Auncommonuse\z:}', "");;
    Expect(1, 128335, '\p{Identifier_Type: 	uncommon_use}', "");
    Expect(0, 128335, '\p{^Identifier_Type: 	uncommon_use}', "");
    Expect(0, 128335, '\P{Identifier_Type: 	uncommon_use}', "");
    Expect(1, 128335, '\P{^Identifier_Type: 	uncommon_use}', "");
    Expect(0, 128336, '\p{Identifier_Type: 	uncommon_use}', "");
    Expect(1, 128336, '\p{^Identifier_Type: 	uncommon_use}', "");
    Expect(1, 128336, '\P{Identifier_Type: 	uncommon_use}', "");
    Expect(0, 128336, '\P{^Identifier_Type: 	uncommon_use}', "");
    Error('\p{Is_Identifier_Type=	:=uncommon_use}');
    Error('\P{Is_Identifier_Type=	:=uncommon_use}');
    Expect(1, 128335, '\p{Is_Identifier_Type:	uncommonuse}', "");
    Expect(0, 128335, '\p{^Is_Identifier_Type:	uncommonuse}', "");
    Expect(0, 128335, '\P{Is_Identifier_Type:	uncommonuse}', "");
    Expect(1, 128335, '\P{^Is_Identifier_Type:	uncommonuse}', "");
    Expect(0, 128336, '\p{Is_Identifier_Type:	uncommonuse}', "");
    Expect(1, 128336, '\p{^Is_Identifier_Type:	uncommonuse}', "");
    Expect(1, 128336, '\P{Is_Identifier_Type:	uncommonuse}', "");
    Expect(0, 128336, '\P{^Is_Identifier_Type:	uncommonuse}', "");
    Expect(1, 128335, '\p{Is_Identifier_Type=_-uncommon_Use}', "");
    Expect(0, 128335, '\p{^Is_Identifier_Type=_-uncommon_Use}', "");
    Expect(0, 128335, '\P{Is_Identifier_Type=_-uncommon_Use}', "");
    Expect(1, 128335, '\P{^Is_Identifier_Type=_-uncommon_Use}', "");
    Expect(0, 128336, '\p{Is_Identifier_Type=_-uncommon_Use}', "");
    Expect(1, 128336, '\p{^Is_Identifier_Type=_-uncommon_Use}', "");
    Expect(1, 128336, '\P{Is_Identifier_Type=_-uncommon_Use}', "");
    Expect(0, 128336, '\P{^Is_Identifier_Type=_-uncommon_Use}', "");
    Error('\p{Ideographic=-_NO:=}');
    Error('\P{Ideographic=-_NO:=}');
    Expect(1, 205744, '\p{Ideographic=:\ANo\z:}', "");;
    Expect(0, 205743, '\p{Ideographic=:\ANo\z:}', "");;
    Expect(1, 205744, '\p{Ideographic=no}', "");
    Expect(0, 205744, '\p{^Ideographic=no}', "");
    Expect(0, 205744, '\P{Ideographic=no}', "");
    Expect(1, 205744, '\P{^Ideographic=no}', "");
    Expect(0, 205743, '\p{Ideographic=no}', "");
    Expect(1, 205743, '\p{^Ideographic=no}', "");
    Expect(1, 205743, '\P{Ideographic=no}', "");
    Expect(0, 205743, '\P{^Ideographic=no}', "");
    Expect(1, 205744, '\p{Ideographic=:\Ano\z:}', "");;
    Expect(0, 205743, '\p{Ideographic=:\Ano\z:}', "");;
    Expect(1, 205744, '\p{Ideographic:	 -No}', "");
    Expect(0, 205744, '\p{^Ideographic:	 -No}', "");
    Expect(0, 205744, '\P{Ideographic:	 -No}', "");
    Expect(1, 205744, '\P{^Ideographic:	 -No}', "");
    Expect(0, 205743, '\p{Ideographic:	 -No}', "");
    Expect(1, 205743, '\p{^Ideographic:	 -No}', "");
    Expect(1, 205743, '\P{Ideographic:	 -No}', "");
    Expect(0, 205743, '\P{^Ideographic:	 -No}', "");
    Error('\p{Ideo=	_N:=}');
    Error('\P{Ideo=	_N:=}');
    Expect(1, 205744, '\p{Ideo=:\AN\z:}', "");;
    Expect(0, 205743, '\p{Ideo=:\AN\z:}', "");;
    Expect(1, 205744, '\p{Ideo=n}', "");
    Expect(0, 205744, '\p{^Ideo=n}', "");
    Expect(0, 205744, '\P{Ideo=n}', "");
    Expect(1, 205744, '\P{^Ideo=n}', "");
    Expect(0, 205743, '\p{Ideo=n}', "");
    Expect(1, 205743, '\p{^Ideo=n}', "");
    Expect(1, 205743, '\P{Ideo=n}', "");
    Expect(0, 205743, '\P{^Ideo=n}', "");
    Expect(1, 205744, '\p{Ideo=:\An\z:}', "");;
    Expect(0, 205743, '\p{Ideo=:\An\z:}', "");;
    Expect(1, 205744, '\p{Ideo= N}', "");
    Expect(0, 205744, '\p{^Ideo= N}', "");
    Expect(0, 205744, '\P{Ideo= N}', "");
    Expect(1, 205744, '\P{^Ideo= N}', "");
    Expect(0, 205743, '\p{Ideo= N}', "");
    Expect(1, 205743, '\p{^Ideo= N}', "");
    Expect(1, 205743, '\P{Ideo= N}', "");
    Expect(0, 205743, '\P{^Ideo= N}', "");
    Error('\p{Is_Ideographic=_/a/F}');
    Error('\P{Is_Ideographic=_/a/F}');
    Expect(1, 205744, '\p{Is_Ideographic=f}', "");
    Expect(0, 205744, '\p{^Is_Ideographic=f}', "");
    Expect(0, 205744, '\P{Is_Ideographic=f}', "");
    Expect(1, 205744, '\P{^Is_Ideographic=f}', "");
    Expect(0, 205743, '\p{Is_Ideographic=f}', "");
    Expect(1, 205743, '\p{^Is_Ideographic=f}', "");
    Expect(1, 205743, '\P{Is_Ideographic=f}', "");
    Expect(0, 205743, '\P{^Is_Ideographic=f}', "");
    Expect(1, 205744, '\p{Is_Ideographic=_f}', "");
    Expect(0, 205744, '\p{^Is_Ideographic=_f}', "");
    Expect(0, 205744, '\P{Is_Ideographic=_f}', "");
    Expect(1, 205744, '\P{^Is_Ideographic=_f}', "");
    Expect(0, 205743, '\p{Is_Ideographic=_f}', "");
    Expect(1, 205743, '\p{^Is_Ideographic=_f}', "");
    Expect(1, 205743, '\P{Is_Ideographic=_f}', "");
    Expect(0, 205743, '\P{^Is_Ideographic=_f}', "");
    Error('\p{Is_Ideo:		-False:=}');
    Error('\P{Is_Ideo:		-False:=}');
    Expect(1, 205744, '\p{Is_Ideo=false}', "");
    Expect(0, 205744, '\p{^Is_Ideo=false}', "");
    Expect(0, 205744, '\P{Is_Ideo=false}', "");
    Expect(1, 205744, '\P{^Is_Ideo=false}', "");
    Expect(0, 205743, '\p{Is_Ideo=false}', "");
    Expect(1, 205743, '\p{^Is_Ideo=false}', "");
    Expect(1, 205743, '\P{Is_Ideo=false}', "");
    Expect(0, 205743, '\P{^Is_Ideo=false}', "");
    Expect(1, 205744, '\p{Is_Ideo=  false}', "");
    Expect(0, 205744, '\p{^Is_Ideo=  false}', "");
    Expect(0, 205744, '\P{Is_Ideo=  false}', "");
    Expect(1, 205744, '\P{^Is_Ideo=  false}', "");
    Expect(0, 205743, '\p{Is_Ideo=  false}', "");
    Expect(1, 205743, '\p{^Is_Ideo=  false}', "");
    Expect(1, 205743, '\P{Is_Ideo=  false}', "");
    Expect(0, 205743, '\P{^Is_Ideo=  false}', "");
    Error('\p{Ideographic:   /a/  Yes}');
    Error('\P{Ideographic:   /a/  Yes}');
    Expect(1, 205743, '\p{Ideographic=:\AYes\z:}', "");;
    Expect(0, 205744, '\p{Ideographic=:\AYes\z:}', "");;
    Expect(1, 205743, '\p{Ideographic=yes}', "");
    Expect(0, 205743, '\p{^Ideographic=yes}', "");
    Expect(0, 205743, '\P{Ideographic=yes}', "");
    Expect(1, 205743, '\P{^Ideographic=yes}', "");
    Expect(0, 205744, '\p{Ideographic=yes}', "");
    Expect(1, 205744, '\p{^Ideographic=yes}', "");
    Expect(1, 205744, '\P{Ideographic=yes}', "");
    Expect(0, 205744, '\P{^Ideographic=yes}', "");
    Expect(1, 205743, '\p{Ideographic=:\Ayes\z:}', "");;
    Expect(0, 205744, '\p{Ideographic=:\Ayes\z:}', "");;
    Expect(1, 205743, '\p{Ideographic=	_Yes}', "");
    Expect(0, 205743, '\p{^Ideographic=	_Yes}', "");
    Expect(0, 205743, '\P{Ideographic=	_Yes}', "");
    Expect(1, 205743, '\P{^Ideographic=	_Yes}', "");
    Expect(0, 205744, '\p{Ideographic=	_Yes}', "");
    Expect(1, 205744, '\p{^Ideographic=	_Yes}', "");
    Expect(1, 205744, '\P{Ideographic=	_Yes}', "");
    Expect(0, 205744, '\P{^Ideographic=	_Yes}', "");
    Error('\p{Ideo=_:=Y}');
    Error('\P{Ideo=_:=Y}');
    Expect(1, 205743, '\p{Ideo=:\AY\z:}', "");;
    Expect(0, 205744, '\p{Ideo=:\AY\z:}', "");;
    Expect(1, 205743, '\p{Ideo=y}', "");
    Expect(0, 205743, '\p{^Ideo=y}', "");
    Expect(0, 205743, '\P{Ideo=y}', "");
    Expect(1, 205743, '\P{^Ideo=y}', "");
    Expect(0, 205744, '\p{Ideo=y}', "");
    Expect(1, 205744, '\p{^Ideo=y}', "");
    Expect(1, 205744, '\P{Ideo=y}', "");
    Expect(0, 205744, '\P{^Ideo=y}', "");
    Expect(1, 205743, '\p{Ideo=:\Ay\z:}', "");;
    Expect(0, 205744, '\p{Ideo=:\Ay\z:}', "");;
    Expect(1, 205743, '\p{Ideo=__Y}', "");
    Expect(0, 205743, '\p{^Ideo=__Y}', "");
    Expect(0, 205743, '\P{Ideo=__Y}', "");
    Expect(1, 205743, '\P{^Ideo=__Y}', "");
    Expect(0, 205744, '\p{Ideo=__Y}', "");
    Expect(1, 205744, '\p{^Ideo=__Y}', "");
    Expect(1, 205744, '\P{Ideo=__Y}', "");
    Expect(0, 205744, '\P{^Ideo=__Y}', "");
    Error('\p{Is_Ideographic=	_T/a/}');
    Error('\P{Is_Ideographic=	_T/a/}');
    Expect(1, 205743, '\p{Is_Ideographic=t}', "");
    Expect(0, 205743, '\p{^Is_Ideographic=t}', "");
    Expect(0, 205743, '\P{Is_Ideographic=t}', "");
    Expect(1, 205743, '\P{^Is_Ideographic=t}', "");
    Expect(0, 205744, '\p{Is_Ideographic=t}', "");
    Expect(1, 205744, '\p{^Is_Ideographic=t}', "");
    Expect(1, 205744, '\P{Is_Ideographic=t}', "");
    Expect(0, 205744, '\P{^Is_Ideographic=t}', "");
    Expect(1, 205743, '\p{Is_Ideographic=-t}', "");
    Expect(0, 205743, '\p{^Is_Ideographic=-t}', "");
    Expect(0, 205743, '\P{Is_Ideographic=-t}', "");
    Expect(1, 205743, '\P{^Is_Ideographic=-t}', "");
    Expect(0, 205744, '\p{Is_Ideographic=-t}', "");
    Expect(1, 205744, '\p{^Is_Ideographic=-t}', "");
    Expect(1, 205744, '\P{Is_Ideographic=-t}', "");
    Expect(0, 205744, '\P{^Is_Ideographic=-t}', "");
    Error('\p{Is_Ideo=:= True}');
    Error('\P{Is_Ideo=:= True}');
    Expect(1, 205743, '\p{Is_Ideo=true}', "");
    Expect(0, 205743, '\p{^Is_Ideo=true}', "");
    Expect(0, 205743, '\P{Is_Ideo=true}', "");
    Expect(1, 205743, '\P{^Is_Ideo=true}', "");
    Expect(0, 205744, '\p{Is_Ideo=true}', "");
    Expect(1, 205744, '\p{^Is_Ideo=true}', "");
    Expect(1, 205744, '\P{Is_Ideo=true}', "");
    Expect(0, 205744, '\P{^Is_Ideo=true}', "");
    Expect(1, 205743, '\p{Is_Ideo=-	True}', "");
    Expect(0, 205743, '\p{^Is_Ideo=-	True}', "");
    Expect(0, 205743, '\P{Is_Ideo=-	True}', "");
    Expect(1, 205743, '\P{^Is_Ideo=-	True}', "");
    Expect(0, 205744, '\p{Is_Ideo=-	True}', "");
    Expect(1, 205744, '\p{^Is_Ideo=-	True}', "");
    Expect(1, 205744, '\P{Is_Ideo=-	True}', "");
    Expect(0, 205744, '\P{^Is_Ideo=-	True}', "");
    Error('\p{ID_Start=:=_no}');
    Error('\P{ID_Start=:=_no}');
    Expect(1, 205744, '\p{ID_Start=:\ANo\z:}', "");;
    Expect(0, 205743, '\p{ID_Start=:\ANo\z:}', "");;
    Expect(1, 205744, '\p{ID_Start=no}', "");
    Expect(0, 205744, '\p{^ID_Start=no}', "");
    Expect(0, 205744, '\P{ID_Start=no}', "");
    Expect(1, 205744, '\P{^ID_Start=no}', "");
    Expect(0, 205743, '\p{ID_Start=no}', "");
    Expect(1, 205743, '\p{^ID_Start=no}', "");
    Expect(1, 205743, '\P{ID_Start=no}', "");
    Expect(0, 205743, '\P{^ID_Start=no}', "");
    Expect(1, 205744, '\p{ID_Start=:\Ano\z:}', "");;
    Expect(0, 205743, '\p{ID_Start=:\Ano\z:}', "");;
    Expect(1, 205744, '\p{ID_Start=-_NO}', "");
    Expect(0, 205744, '\p{^ID_Start=-_NO}', "");
    Expect(0, 205744, '\P{ID_Start=-_NO}', "");
    Expect(1, 205744, '\P{^ID_Start=-_NO}', "");
    Expect(0, 205743, '\p{ID_Start=-_NO}', "");
    Expect(1, 205743, '\p{^ID_Start=-_NO}', "");
    Expect(1, 205743, '\P{ID_Start=-_NO}', "");
    Expect(0, 205743, '\P{^ID_Start=-_NO}', "");
    Error('\p{IDS=  n:=}');
    Error('\P{IDS=  n:=}');
    Expect(1, 205744, '\p{IDS=:\AN\z:}', "");;
    Expect(0, 205743, '\p{IDS=:\AN\z:}', "");;
    Expect(1, 205744, '\p{IDS=n}', "");
    Expect(0, 205744, '\p{^IDS=n}', "");
    Expect(0, 205744, '\P{IDS=n}', "");
    Expect(1, 205744, '\P{^IDS=n}', "");
    Expect(0, 205743, '\p{IDS=n}', "");
    Expect(1, 205743, '\p{^IDS=n}', "");
    Expect(1, 205743, '\P{IDS=n}', "");
    Expect(0, 205743, '\P{^IDS=n}', "");
    Expect(1, 205744, '\p{IDS=:\An\z:}', "");;
    Expect(0, 205743, '\p{IDS=:\An\z:}', "");;
    Expect(1, 205744, '\p{IDS=_-N}', "");
    Expect(0, 205744, '\p{^IDS=_-N}', "");
    Expect(0, 205744, '\P{IDS=_-N}', "");
    Expect(1, 205744, '\P{^IDS=_-N}', "");
    Expect(0, 205743, '\p{IDS=_-N}', "");
    Expect(1, 205743, '\p{^IDS=_-N}', "");
    Expect(1, 205743, '\P{IDS=_-N}', "");
    Expect(0, 205743, '\P{^IDS=_-N}', "");
    Error('\p{Is_ID_Start=:=-_F}');
    Error('\P{Is_ID_Start=:=-_F}');
    Expect(1, 205744, '\p{Is_ID_Start=f}', "");
    Expect(0, 205744, '\p{^Is_ID_Start=f}', "");
    Expect(0, 205744, '\P{Is_ID_Start=f}', "");
    Expect(1, 205744, '\P{^Is_ID_Start=f}', "");
    Expect(0, 205743, '\p{Is_ID_Start=f}', "");
    Expect(1, 205743, '\p{^Is_ID_Start=f}', "");
    Expect(1, 205743, '\P{Is_ID_Start=f}', "");
    Expect(0, 205743, '\P{^Is_ID_Start=f}', "");
    Expect(1, 205744, '\p{Is_ID_Start= 	F}', "");
    Expect(0, 205744, '\p{^Is_ID_Start= 	F}', "");
    Expect(0, 205744, '\P{Is_ID_Start= 	F}', "");
    Expect(1, 205744, '\P{^Is_ID_Start= 	F}', "");
    Expect(0, 205743, '\p{Is_ID_Start= 	F}', "");
    Expect(1, 205743, '\p{^Is_ID_Start= 	F}', "");
    Expect(1, 205743, '\P{Is_ID_Start= 	F}', "");
    Expect(0, 205743, '\P{^Is_ID_Start= 	F}', "");
    Error('\p{Is_IDS=/a/	-False}');
    Error('\P{Is_IDS=/a/	-False}');
    Expect(1, 205744, '\p{Is_IDS=false}', "");
    Expect(0, 205744, '\p{^Is_IDS=false}', "");
    Expect(0, 205744, '\P{Is_IDS=false}', "");
    Expect(1, 205744, '\P{^Is_IDS=false}', "");
    Expect(0, 205743, '\p{Is_IDS=false}', "");
    Expect(1, 205743, '\p{^Is_IDS=false}', "");
    Expect(1, 205743, '\P{Is_IDS=false}', "");
    Expect(0, 205743, '\P{^Is_IDS=false}', "");
    Expect(1, 205744, '\p{Is_IDS= false}', "");
    Expect(0, 205744, '\p{^Is_IDS= false}', "");
    Expect(0, 205744, '\P{Is_IDS= false}', "");
    Expect(1, 205744, '\P{^Is_IDS= false}', "");
    Expect(0, 205743, '\p{Is_IDS= false}', "");
    Expect(1, 205743, '\p{^Is_IDS= false}', "");
    Expect(1, 205743, '\P{Is_IDS= false}', "");
    Expect(0, 205743, '\P{^Is_IDS= false}', "");
    Error('\p{ID_Start=/a/-	YES}');
    Error('\P{ID_Start=/a/-	YES}');
    Expect(1, 205743, '\p{ID_Start=:\AYes\z:}', "");;
    Expect(0, 205744, '\p{ID_Start=:\AYes\z:}', "");;
    Expect(1, 205743, '\p{ID_Start:   yes}', "");
    Expect(0, 205743, '\p{^ID_Start:   yes}', "");
    Expect(0, 205743, '\P{ID_Start:   yes}', "");
    Expect(1, 205743, '\P{^ID_Start:   yes}', "");
    Expect(0, 205744, '\p{ID_Start:   yes}', "");
    Expect(1, 205744, '\p{^ID_Start:   yes}', "");
    Expect(1, 205744, '\P{ID_Start:   yes}', "");
    Expect(0, 205744, '\P{^ID_Start:   yes}', "");
    Expect(1, 205743, '\p{ID_Start=:\Ayes\z:}', "");;
    Expect(0, 205744, '\p{ID_Start=:\Ayes\z:}', "");;
    Expect(1, 205743, '\p{ID_Start= -Yes}', "");
    Expect(0, 205743, '\p{^ID_Start= -Yes}', "");
    Expect(0, 205743, '\P{ID_Start= -Yes}', "");
    Expect(1, 205743, '\P{^ID_Start= -Yes}', "");
    Expect(0, 205744, '\p{ID_Start= -Yes}', "");
    Expect(1, 205744, '\p{^ID_Start= -Yes}', "");
    Expect(1, 205744, '\P{ID_Start= -Yes}', "");
    Expect(0, 205744, '\P{^ID_Start= -Yes}', "");
    Error('\p{IDS:   -_y:=}');
    Error('\P{IDS:   -_y:=}');
    Expect(1, 205743, '\p{IDS=:\AY\z:}', "");;
    Expect(0, 205744, '\p{IDS=:\AY\z:}', "");;
    Expect(1, 205743, '\p{IDS=y}', "");
    Expect(0, 205743, '\p{^IDS=y}', "");
    Expect(0, 205743, '\P{IDS=y}', "");
    Expect(1, 205743, '\P{^IDS=y}', "");
    Expect(0, 205744, '\p{IDS=y}', "");
    Expect(1, 205744, '\p{^IDS=y}', "");
    Expect(1, 205744, '\P{IDS=y}', "");
    Expect(0, 205744, '\P{^IDS=y}', "");
    Expect(1, 205743, '\p{IDS=:\Ay\z:}', "");;
    Expect(0, 205744, '\p{IDS=:\Ay\z:}', "");;
    Expect(1, 205743, '\p{IDS=-Y}', "");
    Expect(0, 205743, '\p{^IDS=-Y}', "");
    Expect(0, 205743, '\P{IDS=-Y}', "");
    Expect(1, 205743, '\P{^IDS=-Y}', "");
    Expect(0, 205744, '\p{IDS=-Y}', "");
    Expect(1, 205744, '\p{^IDS=-Y}', "");
    Expect(1, 205744, '\P{IDS=-Y}', "");
    Expect(0, 205744, '\P{^IDS=-Y}', "");
    Error('\p{Is_ID_Start=	t:=}');
    Error('\P{Is_ID_Start=	t:=}');
    Expect(1, 205743, '\p{Is_ID_Start=t}', "");
    Expect(0, 205743, '\p{^Is_ID_Start=t}', "");
    Expect(0, 205743, '\P{Is_ID_Start=t}', "");
    Expect(1, 205743, '\P{^Is_ID_Start=t}', "");
    Expect(0, 205744, '\p{Is_ID_Start=t}', "");
    Expect(1, 205744, '\p{^Is_ID_Start=t}', "");
    Expect(1, 205744, '\P{Is_ID_Start=t}', "");
    Expect(0, 205744, '\P{^Is_ID_Start=t}', "");
    Expect(1, 205743, '\p{Is_ID_Start=--T}', "");
    Expect(0, 205743, '\p{^Is_ID_Start=--T}', "");
    Expect(0, 205743, '\P{Is_ID_Start=--T}', "");
    Expect(1, 205743, '\P{^Is_ID_Start=--T}', "");
    Expect(0, 205744, '\p{Is_ID_Start=--T}', "");
    Expect(1, 205744, '\p{^Is_ID_Start=--T}', "");
    Expect(1, 205744, '\P{Is_ID_Start=--T}', "");
    Expect(0, 205744, '\P{^Is_ID_Start=--T}', "");
    Error('\p{Is_IDS=_ TRUE/a/}');
    Error('\P{Is_IDS=_ TRUE/a/}');
    Expect(1, 205743, '\p{Is_IDS=true}', "");
    Expect(0, 205743, '\p{^Is_IDS=true}', "");
    Expect(0, 205743, '\P{Is_IDS=true}', "");
    Expect(1, 205743, '\P{^Is_IDS=true}', "");
    Expect(0, 205744, '\p{Is_IDS=true}', "");
    Expect(1, 205744, '\p{^Is_IDS=true}', "");
    Expect(1, 205744, '\P{Is_IDS=true}', "");
    Expect(0, 205744, '\P{^Is_IDS=true}', "");
    Expect(1, 205743, '\p{Is_IDS=_-TRUE}', "");
    Expect(0, 205743, '\p{^Is_IDS=_-TRUE}', "");
    Expect(0, 205743, '\P{Is_IDS=_-TRUE}', "");
    Expect(1, 205743, '\P{^Is_IDS=_-TRUE}', "");
    Expect(0, 205744, '\p{Is_IDS=_-TRUE}', "");
    Expect(1, 205744, '\p{^Is_IDS=_-TRUE}', "");
    Expect(1, 205744, '\P{Is_IDS=_-TRUE}', "");
    Expect(0, 205744, '\P{^Is_IDS=_-TRUE}', "");
    Error('\p{IDS_Binary_Operator=-	NO/a/}');
    Error('\P{IDS_Binary_Operator=-	NO/a/}');
    Expect(1, 12284, '\p{IDS_Binary_Operator=:\ANo\z:}', "");;
    Expect(0, 12283, '\p{IDS_Binary_Operator=:\ANo\z:}', "");;
    Expect(1, 12284, '\p{IDS_Binary_Operator=no}', "");
    Expect(0, 12284, '\p{^IDS_Binary_Operator=no}', "");
    Expect(0, 12284, '\P{IDS_Binary_Operator=no}', "");
    Expect(1, 12284, '\P{^IDS_Binary_Operator=no}', "");
    Expect(0, 12283, '\p{IDS_Binary_Operator=no}', "");
    Expect(1, 12283, '\p{^IDS_Binary_Operator=no}', "");
    Expect(1, 12283, '\P{IDS_Binary_Operator=no}', "");
    Expect(0, 12283, '\P{^IDS_Binary_Operator=no}', "");
    Expect(1, 12284, '\p{IDS_Binary_Operator=:\Ano\z:}', "");;
    Expect(0, 12283, '\p{IDS_Binary_Operator=:\Ano\z:}', "");;
    Expect(1, 12284, '\p{IDS_Binary_Operator:		 NO}', "");
    Expect(0, 12284, '\p{^IDS_Binary_Operator:		 NO}', "");
    Expect(0, 12284, '\P{IDS_Binary_Operator:		 NO}', "");
    Expect(1, 12284, '\P{^IDS_Binary_Operator:		 NO}', "");
    Expect(0, 12283, '\p{IDS_Binary_Operator:		 NO}', "");
    Expect(1, 12283, '\p{^IDS_Binary_Operator:		 NO}', "");
    Expect(1, 12283, '\P{IDS_Binary_Operator:		 NO}', "");
    Expect(0, 12283, '\P{^IDS_Binary_Operator:		 NO}', "");
    Error('\p{IDSB=--N/a/}');
    Error('\P{IDSB=--N/a/}');
    Expect(1, 12284, '\p{IDSB=:\AN\z:}', "");;
    Expect(0, 12283, '\p{IDSB=:\AN\z:}', "");;
    Expect(1, 12284, '\p{IDSB=n}', "");
    Expect(0, 12284, '\p{^IDSB=n}', "");
    Expect(0, 12284, '\P{IDSB=n}', "");
    Expect(1, 12284, '\P{^IDSB=n}', "");
    Expect(0, 12283, '\p{IDSB=n}', "");
    Expect(1, 12283, '\p{^IDSB=n}', "");
    Expect(1, 12283, '\P{IDSB=n}', "");
    Expect(0, 12283, '\P{^IDSB=n}', "");
    Expect(1, 12284, '\p{IDSB=:\An\z:}', "");;
    Expect(0, 12283, '\p{IDSB=:\An\z:}', "");;
    Expect(1, 12284, '\p{IDSB=		N}', "");
    Expect(0, 12284, '\p{^IDSB=		N}', "");
    Expect(0, 12284, '\P{IDSB=		N}', "");
    Expect(1, 12284, '\P{^IDSB=		N}', "");
    Expect(0, 12283, '\p{IDSB=		N}', "");
    Expect(1, 12283, '\p{^IDSB=		N}', "");
    Expect(1, 12283, '\P{IDSB=		N}', "");
    Expect(0, 12283, '\P{^IDSB=		N}', "");
    Error('\p{Is_IDS_Binary_Operator=-/a/F}');
    Error('\P{Is_IDS_Binary_Operator=-/a/F}');
    Expect(1, 12284, '\p{Is_IDS_Binary_Operator=f}', "");
    Expect(0, 12284, '\p{^Is_IDS_Binary_Operator=f}', "");
    Expect(0, 12284, '\P{Is_IDS_Binary_Operator=f}', "");
    Expect(1, 12284, '\P{^Is_IDS_Binary_Operator=f}', "");
    Expect(0, 12283, '\p{Is_IDS_Binary_Operator=f}', "");
    Expect(1, 12283, '\p{^Is_IDS_Binary_Operator=f}', "");
    Expect(1, 12283, '\P{Is_IDS_Binary_Operator=f}', "");
    Expect(0, 12283, '\P{^Is_IDS_Binary_Operator=f}', "");
    Expect(1, 12284, '\p{Is_IDS_Binary_Operator=--F}', "");
    Expect(0, 12284, '\p{^Is_IDS_Binary_Operator=--F}', "");
    Expect(0, 12284, '\P{Is_IDS_Binary_Operator=--F}', "");
    Expect(1, 12284, '\P{^Is_IDS_Binary_Operator=--F}', "");
    Expect(0, 12283, '\p{Is_IDS_Binary_Operator=--F}', "");
    Expect(1, 12283, '\p{^Is_IDS_Binary_Operator=--F}', "");
    Expect(1, 12283, '\P{Is_IDS_Binary_Operator=--F}', "");
    Expect(0, 12283, '\P{^Is_IDS_Binary_Operator=--F}', "");
    Error('\p{Is_IDSB=- false:=}');
    Error('\P{Is_IDSB=- false:=}');
    Expect(1, 12284, '\p{Is_IDSB=false}', "");
    Expect(0, 12284, '\p{^Is_IDSB=false}', "");
    Expect(0, 12284, '\P{Is_IDSB=false}', "");
    Expect(1, 12284, '\P{^Is_IDSB=false}', "");
    Expect(0, 12283, '\p{Is_IDSB=false}', "");
    Expect(1, 12283, '\p{^Is_IDSB=false}', "");
    Expect(1, 12283, '\P{Is_IDSB=false}', "");
    Expect(0, 12283, '\P{^Is_IDSB=false}', "");
    Expect(1, 12284, '\p{Is_IDSB=_	FALSE}', "");
    Expect(0, 12284, '\p{^Is_IDSB=_	FALSE}', "");
    Expect(0, 12284, '\P{Is_IDSB=_	FALSE}', "");
    Expect(1, 12284, '\P{^Is_IDSB=_	FALSE}', "");
    Expect(0, 12283, '\p{Is_IDSB=_	FALSE}', "");
    Expect(1, 12283, '\p{^Is_IDSB=_	FALSE}', "");
    Expect(1, 12283, '\P{Is_IDSB=_	FALSE}', "");
    Expect(0, 12283, '\P{^Is_IDSB=_	FALSE}', "");
    Error('\p{IDS_Binary_Operator=-:=Yes}');
    Error('\P{IDS_Binary_Operator=-:=Yes}');
    Expect(1, 12283, '\p{IDS_Binary_Operator=:\AYes\z:}', "");;
    Expect(0, 12284, '\p{IDS_Binary_Operator=:\AYes\z:}', "");;
    Expect(1, 12283, '\p{IDS_Binary_Operator=yes}', "");
    Expect(0, 12283, '\p{^IDS_Binary_Operator=yes}', "");
    Expect(0, 12283, '\P{IDS_Binary_Operator=yes}', "");
    Expect(1, 12283, '\P{^IDS_Binary_Operator=yes}', "");
    Expect(0, 12284, '\p{IDS_Binary_Operator=yes}', "");
    Expect(1, 12284, '\p{^IDS_Binary_Operator=yes}', "");
    Expect(1, 12284, '\P{IDS_Binary_Operator=yes}', "");
    Expect(0, 12284, '\P{^IDS_Binary_Operator=yes}', "");
    Expect(1, 12283, '\p{IDS_Binary_Operator=:\Ayes\z:}', "");;
    Expect(0, 12284, '\p{IDS_Binary_Operator=:\Ayes\z:}', "");;
    Expect(1, 12283, '\p{IDS_Binary_Operator=-_Yes}', "");
    Expect(0, 12283, '\p{^IDS_Binary_Operator=-_Yes}', "");
    Expect(0, 12283, '\P{IDS_Binary_Operator=-_Yes}', "");
    Expect(1, 12283, '\P{^IDS_Binary_Operator=-_Yes}', "");
    Expect(0, 12284, '\p{IDS_Binary_Operator=-_Yes}', "");
    Expect(1, 12284, '\p{^IDS_Binary_Operator=-_Yes}', "");
    Expect(1, 12284, '\P{IDS_Binary_Operator=-_Yes}', "");
    Expect(0, 12284, '\P{^IDS_Binary_Operator=-_Yes}', "");
    Error('\p{IDSB=	Y:=}');
    Error('\P{IDSB=	Y:=}');
    Expect(1, 12283, '\p{IDSB=:\AY\z:}', "");;
    Expect(0, 12284, '\p{IDSB=:\AY\z:}', "");;
    Expect(1, 12283, '\p{IDSB=y}', "");
    Expect(0, 12283, '\p{^IDSB=y}', "");
    Expect(0, 12283, '\P{IDSB=y}', "");
    Expect(1, 12283, '\P{^IDSB=y}', "");
    Expect(0, 12284, '\p{IDSB=y}', "");
    Expect(1, 12284, '\p{^IDSB=y}', "");
    Expect(1, 12284, '\P{IDSB=y}', "");
    Expect(0, 12284, '\P{^IDSB=y}', "");
    Expect(1, 12283, '\p{IDSB=:\Ay\z:}', "");;
    Expect(0, 12284, '\p{IDSB=:\Ay\z:}', "");;
    Expect(1, 12283, '\p{IDSB:   		Y}', "");
    Expect(0, 12283, '\p{^IDSB:   		Y}', "");
    Expect(0, 12283, '\P{IDSB:   		Y}', "");
    Expect(1, 12283, '\P{^IDSB:   		Y}', "");
    Expect(0, 12284, '\p{IDSB:   		Y}', "");
    Expect(1, 12284, '\p{^IDSB:   		Y}', "");
    Expect(1, 12284, '\P{IDSB:   		Y}', "");
    Expect(0, 12284, '\P{^IDSB:   		Y}', "");
    Error('\p{Is_IDS_Binary_Operator=_/a/t}');
    Error('\P{Is_IDS_Binary_Operator=_/a/t}');
    Expect(1, 12283, '\p{Is_IDS_Binary_Operator=t}', "");
    Expect(0, 12283, '\p{^Is_IDS_Binary_Operator=t}', "");
    Expect(0, 12283, '\P{Is_IDS_Binary_Operator=t}', "");
    Expect(1, 12283, '\P{^Is_IDS_Binary_Operator=t}', "");
    Expect(0, 12284, '\p{Is_IDS_Binary_Operator=t}', "");
    Expect(1, 12284, '\p{^Is_IDS_Binary_Operator=t}', "");
    Expect(1, 12284, '\P{Is_IDS_Binary_Operator=t}', "");
    Expect(0, 12284, '\P{^Is_IDS_Binary_Operator=t}', "");
    Expect(1, 12283, '\p{Is_IDS_Binary_Operator:_T}', "");
    Expect(0, 12283, '\p{^Is_IDS_Binary_Operator:_T}', "");
    Expect(0, 12283, '\P{Is_IDS_Binary_Operator:_T}', "");
    Expect(1, 12283, '\P{^Is_IDS_Binary_Operator:_T}', "");
    Expect(0, 12284, '\p{Is_IDS_Binary_Operator:_T}', "");
    Expect(1, 12284, '\p{^Is_IDS_Binary_Operator:_T}', "");
    Expect(1, 12284, '\P{Is_IDS_Binary_Operator:_T}', "");
    Expect(0, 12284, '\P{^Is_IDS_Binary_Operator:_T}', "");
    Error('\p{Is_IDSB=_/a/True}');
    Error('\P{Is_IDSB=_/a/True}');
    Expect(1, 12283, '\p{Is_IDSB=true}', "");
    Expect(0, 12283, '\p{^Is_IDSB=true}', "");
    Expect(0, 12283, '\P{Is_IDSB=true}', "");
    Expect(1, 12283, '\P{^Is_IDSB=true}', "");
    Expect(0, 12284, '\p{Is_IDSB=true}', "");
    Expect(1, 12284, '\p{^Is_IDSB=true}', "");
    Expect(1, 12284, '\P{Is_IDSB=true}', "");
    Expect(0, 12284, '\P{^Is_IDSB=true}', "");
    Expect(1, 12283, '\p{Is_IDSB= true}', "");
    Expect(0, 12283, '\p{^Is_IDSB= true}', "");
    Expect(0, 12283, '\P{Is_IDSB= true}', "");
    Expect(1, 12283, '\P{^Is_IDSB= true}', "");
    Expect(0, 12284, '\p{Is_IDSB= true}', "");
    Expect(1, 12284, '\p{^Is_IDSB= true}', "");
    Expect(1, 12284, '\P{Is_IDSB= true}', "");
    Expect(0, 12284, '\P{^Is_IDSB= true}', "");
    Error('\p{IDS_Trinary_Operator=	/a/No}');
    Error('\P{IDS_Trinary_Operator=	/a/No}');
    Expect(1, 12276, '\p{IDS_Trinary_Operator=:\ANo\z:}', "");;
    Expect(0, 12275, '\p{IDS_Trinary_Operator=:\ANo\z:}', "");;
    Expect(1, 12276, '\p{IDS_Trinary_Operator=no}', "");
    Expect(0, 12276, '\p{^IDS_Trinary_Operator=no}', "");
    Expect(0, 12276, '\P{IDS_Trinary_Operator=no}', "");
    Expect(1, 12276, '\P{^IDS_Trinary_Operator=no}', "");
    Expect(0, 12275, '\p{IDS_Trinary_Operator=no}', "");
    Expect(1, 12275, '\p{^IDS_Trinary_Operator=no}', "");
    Expect(1, 12275, '\P{IDS_Trinary_Operator=no}', "");
    Expect(0, 12275, '\P{^IDS_Trinary_Operator=no}', "");
    Expect(1, 12276, '\p{IDS_Trinary_Operator=:\Ano\z:}', "");;
    Expect(0, 12275, '\p{IDS_Trinary_Operator=:\Ano\z:}', "");;
    Expect(1, 12276, '\p{IDS_Trinary_Operator=	no}', "");
    Expect(0, 12276, '\p{^IDS_Trinary_Operator=	no}', "");
    Expect(0, 12276, '\P{IDS_Trinary_Operator=	no}', "");
    Expect(1, 12276, '\P{^IDS_Trinary_Operator=	no}', "");
    Expect(0, 12275, '\p{IDS_Trinary_Operator=	no}', "");
    Expect(1, 12275, '\p{^IDS_Trinary_Operator=	no}', "");
    Expect(1, 12275, '\P{IDS_Trinary_Operator=	no}', "");
    Expect(0, 12275, '\P{^IDS_Trinary_Operator=	no}', "");
    Error('\p{IDST=/a/- N}');
    Error('\P{IDST=/a/- N}');
    Expect(1, 12276, '\p{IDST=:\AN\z:}', "");;
    Expect(0, 12275, '\p{IDST=:\AN\z:}', "");;
    Expect(1, 12276, '\p{IDST=n}', "");
    Expect(0, 12276, '\p{^IDST=n}', "");
    Expect(0, 12276, '\P{IDST=n}', "");
    Expect(1, 12276, '\P{^IDST=n}', "");
    Expect(0, 12275, '\p{IDST=n}', "");
    Expect(1, 12275, '\p{^IDST=n}', "");
    Expect(1, 12275, '\P{IDST=n}', "");
    Expect(0, 12275, '\P{^IDST=n}', "");
    Expect(1, 12276, '\p{IDST=:\An\z:}', "");;
    Expect(0, 12275, '\p{IDST=:\An\z:}', "");;
    Expect(1, 12276, '\p{IDST=__N}', "");
    Expect(0, 12276, '\p{^IDST=__N}', "");
    Expect(0, 12276, '\P{IDST=__N}', "");
    Expect(1, 12276, '\P{^IDST=__N}', "");
    Expect(0, 12275, '\p{IDST=__N}', "");
    Expect(1, 12275, '\p{^IDST=__N}', "");
    Expect(1, 12275, '\P{IDST=__N}', "");
    Expect(0, 12275, '\P{^IDST=__N}', "");
    Error('\p{Is_IDS_Trinary_Operator=	-F:=}');
    Error('\P{Is_IDS_Trinary_Operator=	-F:=}');
    Expect(1, 12276, '\p{Is_IDS_Trinary_Operator=f}', "");
    Expect(0, 12276, '\p{^Is_IDS_Trinary_Operator=f}', "");
    Expect(0, 12276, '\P{Is_IDS_Trinary_Operator=f}', "");
    Expect(1, 12276, '\P{^Is_IDS_Trinary_Operator=f}', "");
    Expect(0, 12275, '\p{Is_IDS_Trinary_Operator=f}', "");
    Expect(1, 12275, '\p{^Is_IDS_Trinary_Operator=f}', "");
    Expect(1, 12275, '\P{Is_IDS_Trinary_Operator=f}', "");
    Expect(0, 12275, '\P{^Is_IDS_Trinary_Operator=f}', "");
    Expect(1, 12276, '\p{Is_IDS_Trinary_Operator=	_f}', "");
    Expect(0, 12276, '\p{^Is_IDS_Trinary_Operator=	_f}', "");
    Expect(0, 12276, '\P{Is_IDS_Trinary_Operator=	_f}', "");
    Expect(1, 12276, '\P{^Is_IDS_Trinary_Operator=	_f}', "");
    Expect(0, 12275, '\p{Is_IDS_Trinary_Operator=	_f}', "");
    Expect(1, 12275, '\p{^Is_IDS_Trinary_Operator=	_f}', "");
    Expect(1, 12275, '\P{Is_IDS_Trinary_Operator=	_f}', "");
    Expect(0, 12275, '\P{^Is_IDS_Trinary_Operator=	_f}', "");
    Error('\p{Is_IDST= :=false}');
    Error('\P{Is_IDST= :=false}');
    Expect(1, 12276, '\p{Is_IDST=false}', "");
    Expect(0, 12276, '\p{^Is_IDST=false}', "");
    Expect(0, 12276, '\P{Is_IDST=false}', "");
    Expect(1, 12276, '\P{^Is_IDST=false}', "");
    Expect(0, 12275, '\p{Is_IDST=false}', "");
    Expect(1, 12275, '\p{^Is_IDST=false}', "");
    Expect(1, 12275, '\P{Is_IDST=false}', "");
    Expect(0, 12275, '\P{^Is_IDST=false}', "");
    Expect(1, 12276, '\p{Is_IDST: 		False}', "");
    Expect(0, 12276, '\p{^Is_IDST: 		False}', "");
    Expect(0, 12276, '\P{Is_IDST: 		False}', "");
    Expect(1, 12276, '\P{^Is_IDST: 		False}', "");
    Expect(0, 12275, '\p{Is_IDST: 		False}', "");
    Expect(1, 12275, '\p{^Is_IDST: 		False}', "");
    Expect(1, 12275, '\P{Is_IDST: 		False}', "");
    Expect(0, 12275, '\P{^Is_IDST: 		False}', "");
    Error('\p{IDS_Trinary_Operator=:=- Yes}');
    Error('\P{IDS_Trinary_Operator=:=- Yes}');
    Expect(1, 12275, '\p{IDS_Trinary_Operator=:\AYes\z:}', "");;
    Expect(0, 12276, '\p{IDS_Trinary_Operator=:\AYes\z:}', "");;
    Expect(1, 12275, '\p{IDS_Trinary_Operator=yes}', "");
    Expect(0, 12275, '\p{^IDS_Trinary_Operator=yes}', "");
    Expect(0, 12275, '\P{IDS_Trinary_Operator=yes}', "");
    Expect(1, 12275, '\P{^IDS_Trinary_Operator=yes}', "");
    Expect(0, 12276, '\p{IDS_Trinary_Operator=yes}', "");
    Expect(1, 12276, '\p{^IDS_Trinary_Operator=yes}', "");
    Expect(1, 12276, '\P{IDS_Trinary_Operator=yes}', "");
    Expect(0, 12276, '\P{^IDS_Trinary_Operator=yes}', "");
    Expect(1, 12275, '\p{IDS_Trinary_Operator=:\Ayes\z:}', "");;
    Expect(0, 12276, '\p{IDS_Trinary_Operator=:\Ayes\z:}', "");;
    Expect(1, 12275, '\p{IDS_Trinary_Operator=_-yes}', "");
    Expect(0, 12275, '\p{^IDS_Trinary_Operator=_-yes}', "");
    Expect(0, 12275, '\P{IDS_Trinary_Operator=_-yes}', "");
    Expect(1, 12275, '\P{^IDS_Trinary_Operator=_-yes}', "");
    Expect(0, 12276, '\p{IDS_Trinary_Operator=_-yes}', "");
    Expect(1, 12276, '\p{^IDS_Trinary_Operator=_-yes}', "");
    Expect(1, 12276, '\P{IDS_Trinary_Operator=_-yes}', "");
    Expect(0, 12276, '\P{^IDS_Trinary_Operator=_-yes}', "");
    Error('\p{IDST=-:=Y}');
    Error('\P{IDST=-:=Y}');
    Expect(1, 12275, '\p{IDST=:\AY\z:}', "");;
    Expect(0, 12276, '\p{IDST=:\AY\z:}', "");;
    Expect(1, 12275, '\p{IDST=y}', "");
    Expect(0, 12275, '\p{^IDST=y}', "");
    Expect(0, 12275, '\P{IDST=y}', "");
    Expect(1, 12275, '\P{^IDST=y}', "");
    Expect(0, 12276, '\p{IDST=y}', "");
    Expect(1, 12276, '\p{^IDST=y}', "");
    Expect(1, 12276, '\P{IDST=y}', "");
    Expect(0, 12276, '\P{^IDST=y}', "");
    Expect(1, 12275, '\p{IDST=:\Ay\z:}', "");;
    Expect(0, 12276, '\p{IDST=:\Ay\z:}', "");;
    Expect(1, 12275, '\p{IDST=		Y}', "");
    Expect(0, 12275, '\p{^IDST=		Y}', "");
    Expect(0, 12275, '\P{IDST=		Y}', "");
    Expect(1, 12275, '\P{^IDST=		Y}', "");
    Expect(0, 12276, '\p{IDST=		Y}', "");
    Expect(1, 12276, '\p{^IDST=		Y}', "");
    Expect(1, 12276, '\P{IDST=		Y}', "");
    Expect(0, 12276, '\P{^IDST=		Y}', "");
    Error('\p{Is_IDS_Trinary_Operator=:=_	T}');
    Error('\P{Is_IDS_Trinary_Operator=:=_	T}');
    Expect(1, 12275, '\p{Is_IDS_Trinary_Operator=t}', "");
    Expect(0, 12275, '\p{^Is_IDS_Trinary_Operator=t}', "");
    Expect(0, 12275, '\P{Is_IDS_Trinary_Operator=t}', "");
    Expect(1, 12275, '\P{^Is_IDS_Trinary_Operator=t}', "");
    Expect(0, 12276, '\p{Is_IDS_Trinary_Operator=t}', "");
    Expect(1, 12276, '\p{^Is_IDS_Trinary_Operator=t}', "");
    Expect(1, 12276, '\P{Is_IDS_Trinary_Operator=t}', "");
    Expect(0, 12276, '\P{^Is_IDS_Trinary_Operator=t}', "");
    Expect(1, 12275, '\p{Is_IDS_Trinary_Operator=		T}', "");
    Expect(0, 12275, '\p{^Is_IDS_Trinary_Operator=		T}', "");
    Expect(0, 12275, '\P{Is_IDS_Trinary_Operator=		T}', "");
    Expect(1, 12275, '\P{^Is_IDS_Trinary_Operator=		T}', "");
    Expect(0, 12276, '\p{Is_IDS_Trinary_Operator=		T}', "");
    Expect(1, 12276, '\p{^Is_IDS_Trinary_Operator=		T}', "");
    Expect(1, 12276, '\P{Is_IDS_Trinary_Operator=		T}', "");
    Expect(0, 12276, '\P{^Is_IDS_Trinary_Operator=		T}', "");
    Error('\p{Is_IDST=/a/	TRUE}');
    Error('\P{Is_IDST=/a/	TRUE}');
    Expect(1, 12275, '\p{Is_IDST=true}', "");
    Expect(0, 12275, '\p{^Is_IDST=true}', "");
    Expect(0, 12275, '\P{Is_IDST=true}', "");
    Expect(1, 12275, '\P{^Is_IDST=true}', "");
    Expect(0, 12276, '\p{Is_IDST=true}', "");
    Expect(1, 12276, '\p{^Is_IDST=true}', "");
    Expect(1, 12276, '\P{Is_IDST=true}', "");
    Expect(0, 12276, '\P{^Is_IDST=true}', "");
    Expect(1, 12275, '\p{Is_IDST=--True}', "");
    Expect(0, 12275, '\p{^Is_IDST=--True}', "");
    Expect(0, 12275, '\P{Is_IDST=--True}', "");
    Expect(1, 12275, '\P{^Is_IDST=--True}', "");
    Expect(0, 12276, '\p{Is_IDST=--True}', "");
    Expect(1, 12276, '\p{^Is_IDST=--True}', "");
    Expect(1, 12276, '\P{Is_IDST=--True}', "");
    Expect(0, 12276, '\P{^Is_IDST=--True}', "");
    Error('\p{presentin}');
    Error('\P{presentin}');
    Error('\p{in}');
    Error('\P{in}');
    Error('\p{Present_In=/a/00001.1}');
    Error('\P{Present_In=/a/00001.1}');
    Expect(1, 65533, '\p{Present_In=:\A1.1\z:}', "");;
    Expect(0, 65536, '\p{Present_In=:\A1.1\z:}', "");;
    Expect(1, 65533, '\p{Present_In:   +0_1.1}', "");
    Expect(0, 65533, '\p{^Present_In:   +0_1.1}', "");
    Expect(0, 65533, '\P{Present_In:   +0_1.1}', "");
    Expect(1, 65533, '\P{^Present_In:   +0_1.1}', "");
    Expect(0, 65536, '\p{Present_In:   +0_1.1}', "");
    Expect(1, 65536, '\p{^Present_In:   +0_1.1}', "");
    Expect(1, 65536, '\P{Present_In:   +0_1.1}', "");
    Expect(0, 65536, '\P{^Present_In:   +0_1.1}', "");
    Error('\p{In=:=- V1_1}');
    Error('\P{In=:=- V1_1}');
    Expect(1, 65533, '\p{In=:\AV1_1\z:}', "");;
    Expect(0, 65536, '\p{In=:\AV1_1\z:}', "");;
    Expect(1, 65533, '\p{In=v11}', "");
    Expect(0, 65533, '\p{^In=v11}', "");
    Expect(0, 65533, '\P{In=v11}', "");
    Expect(1, 65533, '\P{^In=v11}', "");
    Expect(0, 65536, '\p{In=v11}', "");
    Expect(1, 65536, '\p{^In=v11}', "");
    Expect(1, 65536, '\P{In=v11}', "");
    Expect(0, 65536, '\P{^In=v11}', "");
    Expect(1, 65533, '\p{In=:\Av11\z:}', "");;
    Expect(0, 65536, '\p{In=:\Av11\z:}', "");;
    Expect(1, 65533, '\p{In=-	V1_1}', "");
    Expect(0, 65533, '\p{^In=-	V1_1}', "");
    Expect(0, 65533, '\P{In=-	V1_1}', "");
    Expect(1, 65533, '\P{^In=-	V1_1}', "");
    Expect(0, 65536, '\p{In=-	V1_1}', "");
    Expect(1, 65536, '\p{^In=-	V1_1}', "");
    Expect(1, 65536, '\P{In=-	V1_1}', "");
    Expect(0, 65536, '\P{^In=-	V1_1}', "");
    Error('\p{Is_Present_In:   - +001.1/a/}');
    Error('\P{Is_Present_In:   - +001.1/a/}');
    Expect(1, 65533, '\p{Is_Present_In=01.1}', "");
    Expect(0, 65533, '\p{^Is_Present_In=01.1}', "");
    Expect(0, 65533, '\P{Is_Present_In=01.1}', "");
    Expect(1, 65533, '\P{^Is_Present_In=01.1}', "");
    Expect(0, 65536, '\p{Is_Present_In=01.1}', "");
    Expect(1, 65536, '\p{^Is_Present_In=01.1}', "");
    Expect(1, 65536, '\P{Is_Present_In=01.1}', "");
    Expect(0, 65536, '\P{^Is_Present_In=01.1}', "");
    Error('\p{Is_In:   -/a/V1_1}');
    Error('\P{Is_In:   -/a/V1_1}');
    Expect(1, 65533, '\p{Is_In=v11}', "");
    Expect(0, 65533, '\p{^Is_In=v11}', "");
    Expect(0, 65533, '\P{Is_In=v11}', "");
    Expect(1, 65533, '\P{^Is_In=v11}', "");
    Expect(0, 65536, '\p{Is_In=v11}', "");
    Expect(1, 65536, '\p{^Is_In=v11}', "");
    Expect(1, 65536, '\P{Is_In=v11}', "");
    Expect(0, 65536, '\P{^Is_In=v11}', "");
    Expect(1, 65533, '\p{Is_In=-V1_1}', "");
    Expect(0, 65533, '\p{^Is_In=-V1_1}', "");
    Expect(0, 65533, '\P{Is_In=-V1_1}', "");
    Expect(1, 65533, '\P{^Is_In=-V1_1}', "");
    Expect(0, 65536, '\p{Is_In=-V1_1}', "");
    Expect(1, 65536, '\p{^Is_In=-V1_1}', "");
    Expect(1, 65536, '\P{Is_In=-V1_1}', "");
    Expect(0, 65536, '\P{^Is_In=-V1_1}', "");
    Error('\p{Present_In=/a/-	000000001_0.0}');
    Error('\P{Present_In=/a/-	000000001_0.0}');
    Expect(1, 983040, '\p{Present_In=:\A10.0\z:}', "");;
    Expect(0, 983037, '\p{Present_In=:\A10.0\z:}', "");;
    Expect(1, 983040, '\p{Present_In=0000000010.0}', "");
    Expect(0, 983040, '\p{^Present_In=0000000010.0}', "");
    Expect(0, 983040, '\P{Present_In=0000000010.0}', "");
    Expect(1, 983040, '\P{^Present_In=0000000010.0}', "");
    Expect(0, 983037, '\p{Present_In=0000000010.0}', "");
    Expect(1, 983037, '\p{^Present_In=0000000010.0}', "");
    Expect(1, 983037, '\P{Present_In=0000000010.0}', "");
    Expect(0, 983037, '\P{^Present_In=0000000010.0}', "");
    Error('\p{In=:=V10_0}');
    Error('\P{In=:=V10_0}');
    Expect(1, 983040, '\p{In=:\AV10_0\z:}', "");;
    Expect(0, 983037, '\p{In=:\AV10_0\z:}', "");;
    Expect(1, 983040, '\p{In=v100}', "");
    Expect(0, 983040, '\p{^In=v100}', "");
    Expect(0, 983040, '\P{In=v100}', "");
    Expect(1, 983040, '\P{^In=v100}', "");
    Expect(0, 983037, '\p{In=v100}', "");
    Expect(1, 983037, '\p{^In=v100}', "");
    Expect(1, 983037, '\P{In=v100}', "");
    Expect(0, 983037, '\P{^In=v100}', "");
    Expect(1, 983040, '\p{In=:\Av100\z:}', "");;
    Expect(0, 983037, '\p{In=:\Av100\z:}', "");;
    Expect(1, 983040, '\p{In= V10_0}', "");
    Expect(0, 983040, '\p{^In= V10_0}', "");
    Expect(0, 983040, '\P{In= V10_0}', "");
    Expect(1, 983040, '\P{^In= V10_0}', "");
    Expect(0, 983037, '\p{In= V10_0}', "");
    Expect(1, 983037, '\p{^In= V10_0}', "");
    Expect(1, 983037, '\P{In= V10_0}', "");
    Expect(0, 983037, '\P{^In= V10_0}', "");
    Error('\p{Is_Present_In::=-000010.0}');
    Error('\P{Is_Present_In::=-000010.0}');
    Expect(1, 983040, '\p{Is_Present_In=+0010.0}', "");
    Expect(0, 983040, '\p{^Is_Present_In=+0010.0}', "");
    Expect(0, 983040, '\P{Is_Present_In=+0010.0}', "");
    Expect(1, 983040, '\P{^Is_Present_In=+0010.0}', "");
    Expect(0, 983037, '\p{Is_Present_In=+0010.0}', "");
    Expect(1, 983037, '\p{^Is_Present_In=+0010.0}', "");
    Expect(1, 983037, '\P{Is_Present_In=+0010.0}', "");
    Expect(0, 983037, '\P{^Is_Present_In=+0010.0}', "");
    Error('\p{Is_In=:=-_V10_0}');
    Error('\P{Is_In=:=-_V10_0}');
    Expect(1, 983040, '\p{Is_In=v100}', "");
    Expect(0, 983040, '\p{^Is_In=v100}', "");
    Expect(0, 983040, '\P{Is_In=v100}', "");
    Expect(1, 983040, '\P{^Is_In=v100}', "");
    Expect(0, 983037, '\p{Is_In=v100}', "");
    Expect(1, 983037, '\p{^Is_In=v100}', "");
    Expect(1, 983037, '\P{Is_In=v100}', "");
    Expect(0, 983037, '\P{^Is_In=v100}', "");
    Expect(1, 983040, '\p{Is_In: -V10_0}', "");
    Expect(0, 983040, '\p{^Is_In: -V10_0}', "");
    Expect(0, 983040, '\P{Is_In: -V10_0}', "");
    Expect(1, 983040, '\P{^Is_In: -V10_0}', "");
    Expect(0, 983037, '\p{Is_In: -V10_0}', "");
    Expect(1, 983037, '\p{^Is_In: -V10_0}', "");
    Expect(1, 983037, '\P{Is_In: -V10_0}', "");
    Expect(0, 983037, '\P{^Is_In: -V10_0}', "");
    Error('\p{Present_In:	_:=000000001_1.0}');
    Error('\P{Present_In:	_:=000000001_1.0}');
    Expect(1, 983040, '\p{Present_In=:\A11.0\z:}', "");;
    Expect(0, 983037, '\p{Present_In=:\A11.0\z:}', "");;
    Expect(1, 983040, '\p{Present_In=0_0_0_0_0_0_0_0_011.0}', "");
    Expect(0, 983040, '\p{^Present_In=0_0_0_0_0_0_0_0_011.0}', "");
    Expect(0, 983040, '\P{Present_In=0_0_0_0_0_0_0_0_011.0}', "");
    Expect(1, 983040, '\P{^Present_In=0_0_0_0_0_0_0_0_011.0}', "");
    Expect(0, 983037, '\p{Present_In=0_0_0_0_0_0_0_0_011.0}', "");
    Expect(1, 983037, '\p{^Present_In=0_0_0_0_0_0_0_0_011.0}', "");
    Expect(1, 983037, '\P{Present_In=0_0_0_0_0_0_0_0_011.0}', "");
    Expect(0, 983037, '\P{^Present_In=0_0_0_0_0_0_0_0_011.0}', "");
    Error('\p{In=	V11_0/a/}');
    Error('\P{In=	V11_0/a/}');
    Expect(1, 983040, '\p{In=:\AV11_0\z:}', "");;
    Expect(0, 983037, '\p{In=:\AV11_0\z:}', "");;
    Expect(1, 983040, '\p{In: v110}', "");
    Expect(0, 983040, '\p{^In: v110}', "");
    Expect(0, 983040, '\P{In: v110}', "");
    Expect(1, 983040, '\P{^In: v110}', "");
    Expect(0, 983037, '\p{In: v110}', "");
    Expect(1, 983037, '\p{^In: v110}', "");
    Expect(1, 983037, '\P{In: v110}', "");
    Expect(0, 983037, '\P{^In: v110}', "");
    Expect(1, 983040, '\p{In=:\Av110\z:}', "");;
    Expect(0, 983037, '\p{In=:\Av110\z:}', "");;
    Expect(1, 983040, '\p{In=-v11_0}', "");
    Expect(0, 983040, '\p{^In=-v11_0}', "");
    Expect(0, 983040, '\P{In=-v11_0}', "");
    Expect(1, 983040, '\P{^In=-v11_0}', "");
    Expect(0, 983037, '\p{In=-v11_0}', "");
    Expect(1, 983037, '\p{^In=-v11_0}', "");
    Expect(1, 983037, '\P{In=-v11_0}', "");
    Expect(0, 983037, '\P{^In=-v11_0}', "");
    Error('\p{Is_Present_In= /a/1_1.0}');
    Error('\P{Is_Present_In= /a/1_1.0}');
    Expect(1, 983040, '\p{Is_Present_In=+00_00_11.0}', "");
    Expect(0, 983040, '\p{^Is_Present_In=+00_00_11.0}', "");
    Expect(0, 983040, '\P{Is_Present_In=+00_00_11.0}', "");
    Expect(1, 983040, '\P{^Is_Present_In=+00_00_11.0}', "");
    Expect(0, 983037, '\p{Is_Present_In=+00_00_11.0}', "");
    Expect(1, 983037, '\p{^Is_Present_In=+00_00_11.0}', "");
    Expect(1, 983037, '\P{Is_Present_In=+00_00_11.0}', "");
    Expect(0, 983037, '\P{^Is_Present_In=+00_00_11.0}', "");
    Error('\p{Is_In=_V11_0:=}');
    Error('\P{Is_In=_V11_0:=}');
    Expect(1, 983040, '\p{Is_In=v110}', "");
    Expect(0, 983040, '\p{^Is_In=v110}', "");
    Expect(0, 983040, '\P{Is_In=v110}', "");
    Expect(1, 983040, '\P{^Is_In=v110}', "");
    Expect(0, 983037, '\p{Is_In=v110}', "");
    Expect(1, 983037, '\p{^Is_In=v110}', "");
    Expect(1, 983037, '\P{Is_In=v110}', "");
    Expect(0, 983037, '\P{^Is_In=v110}', "");
    Expect(1, 983040, '\p{Is_In=	V11_0}', "");
    Expect(0, 983040, '\p{^Is_In=	V11_0}', "");
    Expect(0, 983040, '\P{Is_In=	V11_0}', "");
    Expect(1, 983040, '\P{^Is_In=	V11_0}', "");
    Expect(0, 983037, '\p{Is_In=	V11_0}', "");
    Expect(1, 983037, '\p{^Is_In=	V11_0}', "");
    Expect(1, 983037, '\P{Is_In=	V11_0}', "");
    Expect(0, 983037, '\P{^Is_In=	V11_0}', "");
    Error('\p{Present_In=  00000000012.0/a/}');
    Error('\P{Present_In=  00000000012.0/a/}');
    Expect(1, 983040, '\p{Present_In=:\A12.0\z:}', "");;
    Expect(0, 983037, '\p{Present_In=:\A12.0\z:}', "");;
    Expect(1, 983040, '\p{Present_In=001_2.0}', "");
    Expect(0, 983040, '\p{^Present_In=001_2.0}', "");
    Expect(0, 983040, '\P{Present_In=001_2.0}', "");
    Expect(1, 983040, '\P{^Present_In=001_2.0}', "");
    Expect(0, 983037, '\p{Present_In=001_2.0}', "");
    Expect(1, 983037, '\p{^Present_In=001_2.0}', "");
    Expect(1, 983037, '\P{Present_In=001_2.0}', "");
    Expect(0, 983037, '\P{^Present_In=001_2.0}', "");
    Error('\p{In=/a/	_v12_0}');
    Error('\P{In=/a/	_v12_0}');
    Expect(1, 983040, '\p{In=:\AV12_0\z:}', "");;
    Expect(0, 983037, '\p{In=:\AV12_0\z:}', "");;
    Expect(1, 983040, '\p{In=v120}', "");
    Expect(0, 983040, '\p{^In=v120}', "");
    Expect(0, 983040, '\P{In=v120}', "");
    Expect(1, 983040, '\P{^In=v120}', "");
    Expect(0, 983037, '\p{In=v120}', "");
    Expect(1, 983037, '\p{^In=v120}', "");
    Expect(1, 983037, '\P{In=v120}', "");
    Expect(0, 983037, '\P{^In=v120}', "");
    Expect(1, 983040, '\p{In=:\Av120\z:}', "");;
    Expect(0, 983037, '\p{In=:\Av120\z:}', "");;
    Expect(1, 983040, '\p{In=		v12_0}', "");
    Expect(0, 983040, '\p{^In=		v12_0}', "");
    Expect(0, 983040, '\P{In=		v12_0}', "");
    Expect(1, 983040, '\P{^In=		v12_0}', "");
    Expect(0, 983037, '\p{In=		v12_0}', "");
    Expect(1, 983037, '\p{^In=		v12_0}', "");
    Expect(1, 983037, '\P{In=		v12_0}', "");
    Expect(0, 983037, '\P{^In=		v12_0}', "");
    Error('\p{Is_Present_In=:=	0012.0}');
    Error('\P{Is_Present_In=:=	0012.0}');
    Expect(1, 983040, '\p{Is_Present_In=00000_00001_2.0}', "");
    Expect(0, 983040, '\p{^Is_Present_In=00000_00001_2.0}', "");
    Expect(0, 983040, '\P{Is_Present_In=00000_00001_2.0}', "");
    Expect(1, 983040, '\P{^Is_Present_In=00000_00001_2.0}', "");
    Expect(0, 983037, '\p{Is_Present_In=00000_00001_2.0}', "");
    Expect(1, 983037, '\p{^Is_Present_In=00000_00001_2.0}', "");
    Expect(1, 983037, '\P{Is_Present_In=00000_00001_2.0}', "");
    Expect(0, 983037, '\P{^Is_Present_In=00000_00001_2.0}', "");
    Error('\p{Is_In=	 v12_0/a/}');
    Error('\P{Is_In=	 v12_0/a/}');
    Expect(1, 983040, '\p{Is_In=v120}', "");
    Expect(0, 983040, '\p{^Is_In=v120}', "");
    Expect(0, 983040, '\P{Is_In=v120}', "");
    Expect(1, 983040, '\P{^Is_In=v120}', "");
    Expect(0, 983037, '\p{Is_In=v120}', "");
    Expect(1, 983037, '\p{^Is_In=v120}', "");
    Expect(1, 983037, '\P{Is_In=v120}', "");
    Expect(0, 983037, '\P{^Is_In=v120}', "");
    Expect(1, 983040, '\p{Is_In=	V12_0}', "");
    Expect(0, 983040, '\p{^Is_In=	V12_0}', "");
    Expect(0, 983040, '\P{Is_In=	V12_0}', "");
    Expect(1, 983040, '\P{^Is_In=	V12_0}', "");
    Expect(0, 983037, '\p{Is_In=	V12_0}', "");
    Expect(1, 983037, '\p{^Is_In=	V12_0}', "");
    Expect(1, 983037, '\P{Is_In=	V12_0}', "");
    Expect(0, 983037, '\P{^Is_In=	V12_0}', "");
    Error('\p{Present_In=/a/_+0000_0001_2.1}');
    Error('\P{Present_In=/a/_+0000_0001_2.1}');
    Expect(1, 983040, '\p{Present_In=:\A12.1\z:}', "");;
    Expect(0, 983037, '\p{Present_In=:\A12.1\z:}', "");;
    Expect(1, 983040, '\p{Present_In=0_0_0_0_0_012.1}', "");
    Expect(0, 983040, '\p{^Present_In=0_0_0_0_0_012.1}', "");
    Expect(0, 983040, '\P{Present_In=0_0_0_0_0_012.1}', "");
    Expect(1, 983040, '\P{^Present_In=0_0_0_0_0_012.1}', "");
    Expect(0, 983037, '\p{Present_In=0_0_0_0_0_012.1}', "");
    Expect(1, 983037, '\p{^Present_In=0_0_0_0_0_012.1}', "");
    Expect(1, 983037, '\P{Present_In=0_0_0_0_0_012.1}', "");
    Expect(0, 983037, '\P{^Present_In=0_0_0_0_0_012.1}', "");
    Error('\p{In=	V12_1/a/}');
    Error('\P{In=	V12_1/a/}');
    Expect(1, 983040, '\p{In=:\AV12_1\z:}', "");;
    Expect(0, 983037, '\p{In=:\AV12_1\z:}', "");;
    Expect(1, 983040, '\p{In=v121}', "");
    Expect(0, 983040, '\p{^In=v121}', "");
    Expect(0, 983040, '\P{In=v121}', "");
    Expect(1, 983040, '\P{^In=v121}', "");
    Expect(0, 983037, '\p{In=v121}', "");
    Expect(1, 983037, '\p{^In=v121}', "");
    Expect(1, 983037, '\P{In=v121}', "");
    Expect(0, 983037, '\P{^In=v121}', "");
    Expect(1, 983040, '\p{In=:\Av121\z:}', "");;
    Expect(0, 983037, '\p{In=:\Av121\z:}', "");;
    Expect(1, 983040, '\p{In:    V12_1}', "");
    Expect(0, 983040, '\p{^In:    V12_1}', "");
    Expect(0, 983040, '\P{In:    V12_1}', "");
    Expect(1, 983040, '\P{^In:    V12_1}', "");
    Expect(0, 983037, '\p{In:    V12_1}', "");
    Expect(1, 983037, '\p{^In:    V12_1}', "");
    Expect(1, 983037, '\P{In:    V12_1}', "");
    Expect(0, 983037, '\P{^In:    V12_1}', "");
    Error('\p{Is_Present_In=/a/_-0000000012.1}');
    Error('\P{Is_Present_In=/a/_-0000000012.1}');
    Expect(1, 983040, '\p{Is_Present_In=0_0_12.1}', "");
    Expect(0, 983040, '\p{^Is_Present_In=0_0_12.1}', "");
    Expect(0, 983040, '\P{Is_Present_In=0_0_12.1}', "");
    Expect(1, 983040, '\P{^Is_Present_In=0_0_12.1}', "");
    Expect(0, 983037, '\p{Is_Present_In=0_0_12.1}', "");
    Expect(1, 983037, '\p{^Is_Present_In=0_0_12.1}', "");
    Expect(1, 983037, '\P{Is_Present_In=0_0_12.1}', "");
    Expect(0, 983037, '\P{^Is_Present_In=0_0_12.1}', "");
    Error('\p{Is_In=:=	 V12_1}');
    Error('\P{Is_In=:=	 V12_1}');
    Expect(1, 983040, '\p{Is_In=v121}', "");
    Expect(0, 983040, '\p{^Is_In=v121}', "");
    Expect(0, 983040, '\P{Is_In=v121}', "");
    Expect(1, 983040, '\P{^Is_In=v121}', "");
    Expect(0, 983037, '\p{Is_In=v121}', "");
    Expect(1, 983037, '\p{^Is_In=v121}', "");
    Expect(1, 983037, '\P{Is_In=v121}', "");
    Expect(0, 983037, '\P{^Is_In=v121}', "");
    Expect(1, 983040, '\p{Is_In=_V12_1}', "");
    Expect(0, 983040, '\p{^Is_In=_V12_1}', "");
    Expect(0, 983040, '\P{Is_In=_V12_1}', "");
    Expect(1, 983040, '\P{^Is_In=_V12_1}', "");
    Expect(0, 983037, '\p{Is_In=_V12_1}', "");
    Expect(1, 983037, '\p{^Is_In=_V12_1}', "");
    Expect(1, 983037, '\P{Is_In=_V12_1}', "");
    Expect(0, 983037, '\P{^Is_In=_V12_1}', "");
    Error('\p{Present_In=	0000001_3.0/a/}');
    Error('\P{Present_In=	0000001_3.0/a/}');
    Expect(1, 983040, '\p{Present_In=:\A13.0\z:}', "");;
    Expect(0, 983037, '\p{Present_In=:\A13.0\z:}', "");;
    Expect(1, 983040, '\p{Present_In=1_3.0}', "");
    Expect(0, 983040, '\p{^Present_In=1_3.0}', "");
    Expect(0, 983040, '\P{Present_In=1_3.0}', "");
    Expect(1, 983040, '\P{^Present_In=1_3.0}', "");
    Expect(0, 983037, '\p{Present_In=1_3.0}', "");
    Expect(1, 983037, '\p{^Present_In=1_3.0}', "");
    Expect(1, 983037, '\P{Present_In=1_3.0}', "");
    Expect(0, 983037, '\P{^Present_In=1_3.0}', "");
    Error('\p{In=/a/ _V13_0}');
    Error('\P{In=/a/ _V13_0}');
    Expect(1, 983040, '\p{In=:\AV13_0\z:}', "");;
    Expect(0, 983037, '\p{In=:\AV13_0\z:}', "");;
    Expect(1, 983040, '\p{In:   v130}', "");
    Expect(0, 983040, '\p{^In:   v130}', "");
    Expect(0, 983040, '\P{In:   v130}', "");
    Expect(1, 983040, '\P{^In:   v130}', "");
    Expect(0, 983037, '\p{In:   v130}', "");
    Expect(1, 983037, '\p{^In:   v130}', "");
    Expect(1, 983037, '\P{In:   v130}', "");
    Expect(0, 983037, '\P{^In:   v130}', "");
    Expect(1, 983040, '\p{In=:\Av130\z:}', "");;
    Expect(0, 983037, '\p{In=:\Av130\z:}', "");;
    Expect(1, 983040, '\p{In=	V13_0}', "");
    Expect(0, 983040, '\p{^In=	V13_0}', "");
    Expect(0, 983040, '\P{In=	V13_0}', "");
    Expect(1, 983040, '\P{^In=	V13_0}', "");
    Expect(0, 983037, '\p{In=	V13_0}', "");
    Expect(1, 983037, '\p{^In=	V13_0}', "");
    Expect(1, 983037, '\P{In=	V13_0}', "");
    Expect(0, 983037, '\P{^In=	V13_0}', "");
    Error('\p{Is_Present_In: -/a/013.0}');
    Error('\P{Is_Present_In: -/a/013.0}');
    Expect(1, 983040, '\p{Is_Present_In=013.0}', "");
    Expect(0, 983040, '\p{^Is_Present_In=013.0}', "");
    Expect(0, 983040, '\P{Is_Present_In=013.0}', "");
    Expect(1, 983040, '\P{^Is_Present_In=013.0}', "");
    Expect(0, 983037, '\p{Is_Present_In=013.0}', "");
    Expect(1, 983037, '\p{^Is_Present_In=013.0}', "");
    Expect(1, 983037, '\P{Is_Present_In=013.0}', "");
    Expect(0, 983037, '\P{^Is_Present_In=013.0}', "");
    Error('\p{Is_In= V13_0:=}');
    Error('\P{Is_In= V13_0:=}');
    Expect(1, 983040, '\p{Is_In:   v130}', "");
    Expect(0, 983040, '\p{^Is_In:   v130}', "");
    Expect(0, 983040, '\P{Is_In:   v130}', "");
    Expect(1, 983040, '\P{^Is_In:   v130}', "");
    Expect(0, 983037, '\p{Is_In:   v130}', "");
    Expect(1, 983037, '\p{^Is_In:   v130}', "");
    Expect(1, 983037, '\P{Is_In:   v130}', "");
    Expect(0, 983037, '\P{^Is_In:   v130}', "");
    Expect(1, 983040, '\p{Is_In:		V13_0}', "");
    Expect(0, 983040, '\p{^Is_In:		V13_0}', "");
    Expect(0, 983040, '\P{Is_In:		V13_0}', "");
    Expect(1, 983040, '\P{^Is_In:		V13_0}', "");
    Expect(0, 983037, '\p{Is_In:		V13_0}', "");
    Expect(1, 983037, '\p{^Is_In:		V13_0}', "");
    Expect(1, 983037, '\P{Is_In:		V13_0}', "");
    Expect(0, 983037, '\P{^Is_In:		V13_0}', "");
    Error('\p{Present_In=/a/-	0000014.0}');
    Error('\P{Present_In=/a/-	0000014.0}');
    Expect(1, 983040, '\p{Present_In=:\A14.0\z:}', "");;
    Expect(0, 983037, '\p{Present_In=:\A14.0\z:}', "");;
    Expect(1, 983040, '\p{Present_In: 0000000001_4.0}', "");
    Expect(0, 983040, '\p{^Present_In: 0000000001_4.0}', "");
    Expect(0, 983040, '\P{Present_In: 0000000001_4.0}', "");
    Expect(1, 983040, '\P{^Present_In: 0000000001_4.0}', "");
    Expect(0, 983037, '\p{Present_In: 0000000001_4.0}', "");
    Expect(1, 983037, '\p{^Present_In: 0000000001_4.0}', "");
    Expect(1, 983037, '\P{Present_In: 0000000001_4.0}', "");
    Expect(0, 983037, '\P{^Present_In: 0000000001_4.0}', "");
    Error('\p{In=:=  V14_0}');
    Error('\P{In=:=  V14_0}');
    Expect(1, 983040, '\p{In=:\AV14_0\z:}', "");;
    Expect(0, 983037, '\p{In=:\AV14_0\z:}', "");;
    Expect(1, 983040, '\p{In=v140}', "");
    Expect(0, 983040, '\p{^In=v140}', "");
    Expect(0, 983040, '\P{In=v140}', "");
    Expect(1, 983040, '\P{^In=v140}', "");
    Expect(0, 983037, '\p{In=v140}', "");
    Expect(1, 983037, '\p{^In=v140}', "");
    Expect(1, 983037, '\P{In=v140}', "");
    Expect(0, 983037, '\P{^In=v140}', "");
    Expect(1, 983040, '\p{In=:\Av140\z:}', "");;
    Expect(0, 983037, '\p{In=:\Av140\z:}', "");;
    Expect(1, 983040, '\p{In=V14_0}', "");
    Expect(0, 983040, '\p{^In=V14_0}', "");
    Expect(0, 983040, '\P{In=V14_0}', "");
    Expect(1, 983040, '\P{^In=V14_0}', "");
    Expect(0, 983037, '\p{In=V14_0}', "");
    Expect(1, 983037, '\p{^In=V14_0}', "");
    Expect(1, 983037, '\P{In=V14_0}', "");
    Expect(0, 983037, '\P{^In=V14_0}', "");
    Error('\p{Is_Present_In=/a/- +000014.0}');
    Error('\P{Is_Present_In=/a/- +000014.0}');
    Expect(1, 983040, '\p{Is_Present_In=000000014.0}', "");
    Expect(0, 983040, '\p{^Is_Present_In=000000014.0}', "");
    Expect(0, 983040, '\P{Is_Present_In=000000014.0}', "");
    Expect(1, 983040, '\P{^Is_Present_In=000000014.0}', "");
    Expect(0, 983037, '\p{Is_Present_In=000000014.0}', "");
    Expect(1, 983037, '\p{^Is_Present_In=000000014.0}', "");
    Expect(1, 983037, '\P{Is_Present_In=000000014.0}', "");
    Expect(0, 983037, '\P{^Is_Present_In=000000014.0}', "");
    Error('\p{Is_In=/a/-V14_0}');
    Error('\P{Is_In=/a/-V14_0}');
    Expect(1, 983040, '\p{Is_In=v140}', "");
    Expect(0, 983040, '\p{^Is_In=v140}', "");
    Expect(0, 983040, '\P{Is_In=v140}', "");
    Expect(1, 983040, '\P{^Is_In=v140}', "");
    Expect(0, 983037, '\p{Is_In=v140}', "");
    Expect(1, 983037, '\p{^Is_In=v140}', "");
    Expect(1, 983037, '\P{Is_In=v140}', "");
    Expect(0, 983037, '\P{^Is_In=v140}', "");
    Expect(1, 983040, '\p{Is_In:   _ v14_0}', "");
    Expect(0, 983040, '\p{^Is_In:   _ v14_0}', "");
    Expect(0, 983040, '\P{Is_In:   _ v14_0}', "");
    Expect(1, 983040, '\P{^Is_In:   _ v14_0}', "");
    Expect(0, 983037, '\p{Is_In:   _ v14_0}', "");
    Expect(1, 983037, '\p{^Is_In:   _ v14_0}', "");
    Expect(1, 983037, '\P{Is_In:   _ v14_0}', "");
    Expect(0, 983037, '\P{^Is_In:   _ v14_0}', "");
    Error('\p{Present_In=	00000015.0:=}');
    Error('\P{Present_In=	00000015.0:=}');
    Expect(1, 983040, '\p{Present_In=:\A15.0\z:}', "");;
    Expect(0, 983037, '\p{Present_In=:\A15.0\z:}', "");;
    Expect(1, 983040, '\p{Present_In=0000000015.0}', "");
    Expect(0, 983040, '\p{^Present_In=0000000015.0}', "");
    Expect(0, 983040, '\P{Present_In=0000000015.0}', "");
    Expect(1, 983040, '\P{^Present_In=0000000015.0}', "");
    Expect(0, 983037, '\p{Present_In=0000000015.0}', "");
    Expect(1, 983037, '\p{^Present_In=0000000015.0}', "");
    Expect(1, 983037, '\P{Present_In=0000000015.0}', "");
    Expect(0, 983037, '\P{^Present_In=0000000015.0}', "");
    Error('\p{In=/a/v15_0}');
    Error('\P{In=/a/v15_0}');
    Expect(1, 983040, '\p{In=:\AV15_0\z:}', "");;
    Expect(0, 983037, '\p{In=:\AV15_0\z:}', "");;
    Expect(1, 983040, '\p{In=v150}', "");
    Expect(0, 983040, '\p{^In=v150}', "");
    Expect(0, 983040, '\P{In=v150}', "");
    Expect(1, 983040, '\P{^In=v150}', "");
    Expect(0, 983037, '\p{In=v150}', "");
    Expect(1, 983037, '\p{^In=v150}', "");
    Expect(1, 983037, '\P{In=v150}', "");
    Expect(0, 983037, '\P{^In=v150}', "");
    Expect(1, 983040, '\p{In=:\Av150\z:}', "");;
    Expect(0, 983037, '\p{In=:\Av150\z:}', "");;
    Expect(1, 983040, '\p{In=	 V15_0}', "");
    Expect(0, 983040, '\p{^In=	 V15_0}', "");
    Expect(0, 983040, '\P{In=	 V15_0}', "");
    Expect(1, 983040, '\P{^In=	 V15_0}', "");
    Expect(0, 983037, '\p{In=	 V15_0}', "");
    Expect(1, 983037, '\p{^In=	 V15_0}', "");
    Expect(1, 983037, '\P{In=	 V15_0}', "");
    Expect(0, 983037, '\P{^In=	 V15_0}', "");
    Error('\p{Is_Present_In=:=_	+01_5.0}');
    Error('\P{Is_Present_In=:=_	+01_5.0}');
    Expect(1, 983040, '\p{Is_Present_In:   0_0_0_0_0_0_015.0}', "");
    Expect(0, 983040, '\p{^Is_Present_In:   0_0_0_0_0_0_015.0}', "");
    Expect(0, 983040, '\P{Is_Present_In:   0_0_0_0_0_0_015.0}', "");
    Expect(1, 983040, '\P{^Is_Present_In:   0_0_0_0_0_0_015.0}', "");
    Expect(0, 983037, '\p{Is_Present_In:   0_0_0_0_0_0_015.0}', "");
    Expect(1, 983037, '\p{^Is_Present_In:   0_0_0_0_0_0_015.0}', "");
    Expect(1, 983037, '\P{Is_Present_In:   0_0_0_0_0_0_015.0}', "");
    Expect(0, 983037, '\P{^Is_Present_In:   0_0_0_0_0_0_015.0}', "");
    Error('\p{Is_In=_:=V15_0}');
    Error('\P{Is_In=_:=V15_0}');
    Expect(1, 983040, '\p{Is_In:	v150}', "");
    Expect(0, 983040, '\p{^Is_In:	v150}', "");
    Expect(0, 983040, '\P{Is_In:	v150}', "");
    Expect(1, 983040, '\P{^Is_In:	v150}', "");
    Expect(0, 983037, '\p{Is_In:	v150}', "");
    Expect(1, 983037, '\p{^Is_In:	v150}', "");
    Expect(1, 983037, '\P{Is_In:	v150}', "");
    Expect(0, 983037, '\P{^Is_In:	v150}', "");
    Expect(1, 983040, '\p{Is_In= -V15_0}', "");
    Expect(0, 983040, '\p{^Is_In= -V15_0}', "");
    Expect(0, 983040, '\P{Is_In= -V15_0}', "");
    Expect(1, 983040, '\P{^Is_In= -V15_0}', "");
    Expect(0, 983037, '\p{Is_In= -V15_0}', "");
    Expect(1, 983037, '\p{^Is_In= -V15_0}', "");
    Expect(1, 983037, '\P{Is_In= -V15_0}', "");
    Expect(0, 983037, '\P{^Is_In= -V15_0}', "");
    Error('\p{Present_In=:=	_+000002.0}');
    Error('\P{Present_In=:=	_+000002.0}');
    Expect(1, 983040, '\p{Present_In=:\A2.0\z:}', "");;
    Expect(0, 983037, '\p{Present_In=:\A2.0\z:}', "");;
    Expect(1, 983040, '\p{Present_In=0000000002.0}', "");
    Expect(0, 983040, '\p{^Present_In=0000000002.0}', "");
    Expect(0, 983040, '\P{Present_In=0000000002.0}', "");
    Expect(1, 983040, '\P{^Present_In=0000000002.0}', "");
    Expect(0, 983037, '\p{Present_In=0000000002.0}', "");
    Expect(1, 983037, '\p{^Present_In=0000000002.0}', "");
    Expect(1, 983037, '\P{Present_In=0000000002.0}', "");
    Expect(0, 983037, '\P{^Present_In=0000000002.0}', "");
    Error('\p{In=/a/V2_0}');
    Error('\P{In=/a/V2_0}');
    Expect(1, 983040, '\p{In=:\AV2_0\z:}', "");;
    Expect(0, 983037, '\p{In=:\AV2_0\z:}', "");;
    Expect(1, 983040, '\p{In=v20}', "");
    Expect(0, 983040, '\p{^In=v20}', "");
    Expect(0, 983040, '\P{In=v20}', "");
    Expect(1, 983040, '\P{^In=v20}', "");
    Expect(0, 983037, '\p{In=v20}', "");
    Expect(1, 983037, '\p{^In=v20}', "");
    Expect(1, 983037, '\P{In=v20}', "");
    Expect(0, 983037, '\P{^In=v20}', "");
    Expect(1, 983040, '\p{In=:\Av20\z:}', "");;
    Expect(0, 983037, '\p{In=:\Av20\z:}', "");;
    Expect(1, 983040, '\p{In=	V2_0}', "");
    Expect(0, 983040, '\p{^In=	V2_0}', "");
    Expect(0, 983040, '\P{In=	V2_0}', "");
    Expect(1, 983040, '\P{^In=	V2_0}', "");
    Expect(0, 983037, '\p{In=	V2_0}', "");
    Expect(1, 983037, '\p{^In=	V2_0}', "");
    Expect(1, 983037, '\P{In=	V2_0}', "");
    Expect(0, 983037, '\P{^In=	V2_0}', "");
    Error('\p{Is_Present_In=_:=00_2.0}');
    Error('\P{Is_Present_In=_:=00_2.0}');
    Expect(1, 983040, '\p{Is_Present_In=00000002.0}', "");
    Expect(0, 983040, '\p{^Is_Present_In=00000002.0}', "");
    Expect(0, 983040, '\P{Is_Present_In=00000002.0}', "");
    Expect(1, 983040, '\P{^Is_Present_In=00000002.0}', "");
    Expect(0, 983037, '\p{Is_Present_In=00000002.0}', "");
    Expect(1, 983037, '\p{^Is_Present_In=00000002.0}', "");
    Expect(1, 983037, '\P{Is_Present_In=00000002.0}', "");
    Expect(0, 983037, '\P{^Is_Present_In=00000002.0}', "");
    Error('\p{Is_In=-/a/V2_0}');
    Error('\P{Is_In=-/a/V2_0}');
    Expect(1, 983040, '\p{Is_In=v20}', "");
    Expect(0, 983040, '\p{^Is_In=v20}', "");
    Expect(0, 983040, '\P{Is_In=v20}', "");
    Expect(1, 983040, '\P{^Is_In=v20}', "");
    Expect(0, 983037, '\p{Is_In=v20}', "");
    Expect(1, 983037, '\p{^Is_In=v20}', "");
    Expect(1, 983037, '\P{Is_In=v20}', "");
    Expect(0, 983037, '\P{^Is_In=v20}', "");
    Expect(1, 983040, '\p{Is_In=V2_0}', "");
    Expect(0, 983040, '\p{^Is_In=V2_0}', "");
    Expect(0, 983040, '\P{Is_In=V2_0}', "");
    Expect(1, 983040, '\P{^Is_In=V2_0}', "");
    Expect(0, 983037, '\p{Is_In=V2_0}', "");
    Expect(1, 983037, '\p{^Is_In=V2_0}', "");
    Expect(1, 983037, '\P{Is_In=V2_0}', "");
    Expect(0, 983037, '\P{^Is_In=V2_0}', "");
    Error('\p{Present_In=	-2.1/a/}');
    Error('\P{Present_In=	-2.1/a/}');
    Expect(1, 983040, '\p{Present_In=:\A2.1\z:}', "");;
    Expect(0, 983037, '\p{Present_In=:\A2.1\z:}', "");;
    Expect(1, 983040, '\p{Present_In=0_0_0_0_0_0_0002.1}', "");
    Expect(0, 983040, '\p{^Present_In=0_0_0_0_0_0_0002.1}', "");
    Expect(0, 983040, '\P{Present_In=0_0_0_0_0_0_0002.1}', "");
    Expect(1, 983040, '\P{^Present_In=0_0_0_0_0_0_0002.1}', "");
    Expect(0, 983037, '\p{Present_In=0_0_0_0_0_0_0002.1}', "");
    Expect(1, 983037, '\p{^Present_In=0_0_0_0_0_0_0002.1}', "");
    Expect(1, 983037, '\P{Present_In=0_0_0_0_0_0_0002.1}', "");
    Expect(0, 983037, '\P{^Present_In=0_0_0_0_0_0_0002.1}', "");
    Error('\p{In=/a/_-V2_1}');
    Error('\P{In=/a/_-V2_1}');
    Expect(1, 983040, '\p{In=:\AV2_1\z:}', "");;
    Expect(0, 983037, '\p{In=:\AV2_1\z:}', "");;
    Expect(1, 983040, '\p{In=v21}', "");
    Expect(0, 983040, '\p{^In=v21}', "");
    Expect(0, 983040, '\P{In=v21}', "");
    Expect(1, 983040, '\P{^In=v21}', "");
    Expect(0, 983037, '\p{In=v21}', "");
    Expect(1, 983037, '\p{^In=v21}', "");
    Expect(1, 983037, '\P{In=v21}', "");
    Expect(0, 983037, '\P{^In=v21}', "");
    Expect(1, 983040, '\p{In=:\Av21\z:}', "");;
    Expect(0, 983037, '\p{In=:\Av21\z:}', "");;
    Expect(1, 983040, '\p{In= 	v2_1}', "");
    Expect(0, 983040, '\p{^In= 	v2_1}', "");
    Expect(0, 983040, '\P{In= 	v2_1}', "");
    Expect(1, 983040, '\P{^In= 	v2_1}', "");
    Expect(0, 983037, '\p{In= 	v2_1}', "");
    Expect(1, 983037, '\p{^In= 	v2_1}', "");
    Expect(1, 983037, '\P{In= 	v2_1}', "");
    Expect(0, 983037, '\P{^In= 	v2_1}', "");
    Error('\p{Is_Present_In=/a/+000_000_2.1}');
    Error('\P{Is_Present_In=/a/+000_000_2.1}');
    Expect(1, 983040, '\p{Is_Present_In=00000002.1}', "");
    Expect(0, 983040, '\p{^Is_Present_In=00000002.1}', "");
    Expect(0, 983040, '\P{Is_Present_In=00000002.1}', "");
    Expect(1, 983040, '\P{^Is_Present_In=00000002.1}', "");
    Expect(0, 983037, '\p{Is_Present_In=00000002.1}', "");
    Expect(1, 983037, '\p{^Is_Present_In=00000002.1}', "");
    Expect(1, 983037, '\P{Is_Present_In=00000002.1}', "");
    Expect(0, 983037, '\P{^Is_Present_In=00000002.1}', "");
    Error('\p{Is_In=/a/_V2_1}');
    Error('\P{Is_In=/a/_V2_1}');
    Expect(1, 983040, '\p{Is_In: v21}', "");
    Expect(0, 983040, '\p{^Is_In: v21}', "");
    Expect(0, 983040, '\P{Is_In: v21}', "");
    Expect(1, 983040, '\P{^Is_In: v21}', "");
    Expect(0, 983037, '\p{Is_In: v21}', "");
    Expect(1, 983037, '\p{^Is_In: v21}', "");
    Expect(1, 983037, '\P{Is_In: v21}', "");
    Expect(0, 983037, '\P{^Is_In: v21}', "");
    Expect(1, 983040, '\p{Is_In=_-V2_1}', "");
    Expect(0, 983040, '\p{^Is_In=_-V2_1}', "");
    Expect(0, 983040, '\P{Is_In=_-V2_1}', "");
    Expect(1, 983040, '\P{^Is_In=_-V2_1}', "");
    Expect(0, 983037, '\p{Is_In=_-V2_1}', "");
    Expect(1, 983037, '\p{^Is_In=_-V2_1}', "");
    Expect(1, 983037, '\P{Is_In=_-V2_1}', "");
    Expect(0, 983037, '\P{^Is_In=_-V2_1}', "");
    Error('\p{Present_In= _3.0:=}');
    Error('\P{Present_In= _3.0:=}');
    Expect(1, 983040, '\p{Present_In=:\A3.0\z:}', "");;
    Expect(0, 983037, '\p{Present_In=:\A3.0\z:}', "");;
    Expect(1, 983040, '\p{Present_In=0000_3.0}', "");
    Expect(0, 983040, '\p{^Present_In=0000_3.0}', "");
    Expect(0, 983040, '\P{Present_In=0000_3.0}', "");
    Expect(1, 983040, '\P{^Present_In=0000_3.0}', "");
    Expect(0, 983037, '\p{Present_In=0000_3.0}', "");
    Expect(1, 983037, '\p{^Present_In=0000_3.0}', "");
    Expect(1, 983037, '\P{Present_In=0000_3.0}', "");
    Expect(0, 983037, '\P{^Present_In=0000_3.0}', "");
    Error('\p{In=_/a/V3_0}');
    Error('\P{In=_/a/V3_0}');
    Expect(1, 983040, '\p{In=:\AV3_0\z:}', "");;
    Expect(0, 983037, '\p{In=:\AV3_0\z:}', "");;
    Expect(1, 983040, '\p{In=v30}', "");
    Expect(0, 983040, '\p{^In=v30}', "");
    Expect(0, 983040, '\P{In=v30}', "");
    Expect(1, 983040, '\P{^In=v30}', "");
    Expect(0, 983037, '\p{In=v30}', "");
    Expect(1, 983037, '\p{^In=v30}', "");
    Expect(1, 983037, '\P{In=v30}', "");
    Expect(0, 983037, '\P{^In=v30}', "");
    Expect(1, 983040, '\p{In=:\Av30\z:}', "");;
    Expect(0, 983037, '\p{In=:\Av30\z:}', "");;
    Expect(1, 983040, '\p{In=	 V3_0}', "");
    Expect(0, 983040, '\p{^In=	 V3_0}', "");
    Expect(0, 983040, '\P{In=	 V3_0}', "");
    Expect(1, 983040, '\P{^In=	 V3_0}', "");
    Expect(0, 983037, '\p{In=	 V3_0}', "");
    Expect(1, 983037, '\p{^In=	 V3_0}', "");
    Expect(1, 983037, '\P{In=	 V3_0}', "");
    Expect(0, 983037, '\P{^In=	 V3_0}', "");
    Error('\p{Is_Present_In=_3.0/a/}');
    Error('\P{Is_Present_In=_3.0/a/}');
    Expect(1, 983040, '\p{Is_Present_In: 000000003.0}', "");
    Expect(0, 983040, '\p{^Is_Present_In: 000000003.0}', "");
    Expect(0, 983040, '\P{Is_Present_In: 000000003.0}', "");
    Expect(1, 983040, '\P{^Is_Present_In: 000000003.0}', "");
    Expect(0, 983037, '\p{Is_Present_In: 000000003.0}', "");
    Expect(1, 983037, '\p{^Is_Present_In: 000000003.0}', "");
    Expect(1, 983037, '\P{Is_Present_In: 000000003.0}', "");
    Expect(0, 983037, '\P{^Is_Present_In: 000000003.0}', "");
    Error('\p{Is_In=-/a/V3_0}');
    Error('\P{Is_In=-/a/V3_0}');
    Expect(1, 983040, '\p{Is_In=v30}', "");
    Expect(0, 983040, '\p{^Is_In=v30}', "");
    Expect(0, 983040, '\P{Is_In=v30}', "");
    Expect(1, 983040, '\P{^Is_In=v30}', "");
    Expect(0, 983037, '\p{Is_In=v30}', "");
    Expect(1, 983037, '\p{^Is_In=v30}', "");
    Expect(1, 983037, '\P{Is_In=v30}', "");
    Expect(0, 983037, '\P{^Is_In=v30}', "");
    Expect(1, 983040, '\p{Is_In= -v3_0}', "");
    Expect(0, 983040, '\p{^Is_In= -v3_0}', "");
    Expect(0, 983040, '\P{Is_In= -v3_0}', "");
    Expect(1, 983040, '\P{^Is_In= -v3_0}', "");
    Expect(0, 983037, '\p{Is_In= -v3_0}', "");
    Expect(1, 983037, '\p{^Is_In= -v3_0}', "");
    Expect(1, 983037, '\P{Is_In= -v3_0}', "");
    Expect(0, 983037, '\P{^Is_In= -v3_0}', "");
    Error('\p{Present_In=:=	_00003.1}');
    Error('\P{Present_In=:=	_00003.1}');
    Expect(1, 983040, '\p{Present_In=:\A3.1\z:}', "");;
    Expect(0, 983037, '\p{Present_In=:\A3.1\z:}', "");;
    Expect(1, 983040, '\p{Present_In=0000000003.1}', "");
    Expect(0, 983040, '\p{^Present_In=0000000003.1}', "");
    Expect(0, 983040, '\P{Present_In=0000000003.1}', "");
    Expect(1, 983040, '\P{^Present_In=0000000003.1}', "");
    Expect(0, 983037, '\p{Present_In=0000000003.1}', "");
    Expect(1, 983037, '\p{^Present_In=0000000003.1}', "");
    Expect(1, 983037, '\P{Present_In=0000000003.1}', "");
    Expect(0, 983037, '\P{^Present_In=0000000003.1}', "");
    Error('\p{In=	:=V3_1}');
    Error('\P{In=	:=V3_1}');
    Expect(1, 983040, '\p{In=:\AV3_1\z:}', "");;
    Expect(0, 983037, '\p{In=:\AV3_1\z:}', "");;
    Expect(1, 983040, '\p{In:v31}', "");
    Expect(0, 983040, '\p{^In:v31}', "");
    Expect(0, 983040, '\P{In:v31}', "");
    Expect(1, 983040, '\P{^In:v31}', "");
    Expect(0, 983037, '\p{In:v31}', "");
    Expect(1, 983037, '\p{^In:v31}', "");
    Expect(1, 983037, '\P{In:v31}', "");
    Expect(0, 983037, '\P{^In:v31}', "");
    Expect(1, 983040, '\p{In=:\Av31\z:}', "");;
    Expect(0, 983037, '\p{In=:\Av31\z:}', "");;
    Expect(1, 983040, '\p{In:    v3_1}', "");
    Expect(0, 983040, '\p{^In:    v3_1}', "");
    Expect(0, 983040, '\P{In:    v3_1}', "");
    Expect(1, 983040, '\P{^In:    v3_1}', "");
    Expect(0, 983037, '\p{In:    v3_1}', "");
    Expect(1, 983037, '\p{^In:    v3_1}', "");
    Expect(1, 983037, '\P{In:    v3_1}', "");
    Expect(0, 983037, '\P{^In:    v3_1}', "");
    Error('\p{Is_Present_In=/a/_-00003.1}');
    Error('\P{Is_Present_In=/a/_-00003.1}');
    Expect(1, 983040, '\p{Is_Present_In=0_3.1}', "");
    Expect(0, 983040, '\p{^Is_Present_In=0_3.1}', "");
    Expect(0, 983040, '\P{Is_Present_In=0_3.1}', "");
    Expect(1, 983040, '\P{^Is_Present_In=0_3.1}', "");
    Expect(0, 983037, '\p{Is_Present_In=0_3.1}', "");
    Expect(1, 983037, '\p{^Is_Present_In=0_3.1}', "");
    Expect(1, 983037, '\P{Is_Present_In=0_3.1}', "");
    Expect(0, 983037, '\P{^Is_Present_In=0_3.1}', "");
    Error('\p{Is_In=	 V3_1/a/}');
    Error('\P{Is_In=	 V3_1/a/}');
    Expect(1, 983040, '\p{Is_In=v31}', "");
    Expect(0, 983040, '\p{^Is_In=v31}', "");
    Expect(0, 983040, '\P{Is_In=v31}', "");
    Expect(1, 983040, '\P{^Is_In=v31}', "");
    Expect(0, 983037, '\p{Is_In=v31}', "");
    Expect(1, 983037, '\p{^Is_In=v31}', "");
    Expect(1, 983037, '\P{Is_In=v31}', "");
    Expect(0, 983037, '\P{^Is_In=v31}', "");
    Expect(1, 983040, '\p{Is_In=__V3_1}', "");
    Expect(0, 983040, '\p{^Is_In=__V3_1}', "");
    Expect(0, 983040, '\P{Is_In=__V3_1}', "");
    Expect(1, 983040, '\P{^Is_In=__V3_1}', "");
    Expect(0, 983037, '\p{Is_In=__V3_1}', "");
    Expect(1, 983037, '\p{^Is_In=__V3_1}', "");
    Expect(1, 983037, '\P{Is_In=__V3_1}', "");
    Expect(0, 983037, '\P{^Is_In=__V3_1}', "");
    Error('\p{Present_In=/a/_	0000003.2}');
    Error('\P{Present_In=/a/_	0000003.2}');
    Expect(1, 983040, '\p{Present_In=:\A3.2\z:}', "");;
    Expect(0, 983037, '\p{Present_In=:\A3.2\z:}', "");;
    Expect(1, 983040, '\p{Present_In=0_0_0_0_0_03.2}', "");
    Expect(0, 983040, '\p{^Present_In=0_0_0_0_0_03.2}', "");
    Expect(0, 983040, '\P{Present_In=0_0_0_0_0_03.2}', "");
    Expect(1, 983040, '\P{^Present_In=0_0_0_0_0_03.2}', "");
    Expect(0, 983037, '\p{Present_In=0_0_0_0_0_03.2}', "");
    Expect(1, 983037, '\p{^Present_In=0_0_0_0_0_03.2}', "");
    Expect(1, 983037, '\P{Present_In=0_0_0_0_0_03.2}', "");
    Expect(0, 983037, '\P{^Present_In=0_0_0_0_0_03.2}', "");
    Error('\p{In=_/a/V3_2}');
    Error('\P{In=_/a/V3_2}');
    Expect(1, 983040, '\p{In=:\AV3_2\z:}', "");;
    Expect(0, 983037, '\p{In=:\AV3_2\z:}', "");;
    Expect(1, 983040, '\p{In=v32}', "");
    Expect(0, 983040, '\p{^In=v32}', "");
    Expect(0, 983040, '\P{In=v32}', "");
    Expect(1, 983040, '\P{^In=v32}', "");
    Expect(0, 983037, '\p{In=v32}', "");
    Expect(1, 983037, '\p{^In=v32}', "");
    Expect(1, 983037, '\P{In=v32}', "");
    Expect(0, 983037, '\P{^In=v32}', "");
    Expect(1, 983040, '\p{In=:\Av32\z:}', "");;
    Expect(0, 983037, '\p{In=:\Av32\z:}', "");;
    Expect(1, 983040, '\p{In=- v3_2}', "");
    Expect(0, 983040, '\p{^In=- v3_2}', "");
    Expect(0, 983040, '\P{In=- v3_2}', "");
    Expect(1, 983040, '\P{^In=- v3_2}', "");
    Expect(0, 983037, '\p{In=- v3_2}', "");
    Expect(1, 983037, '\p{^In=- v3_2}', "");
    Expect(1, 983037, '\P{In=- v3_2}', "");
    Expect(0, 983037, '\P{^In=- v3_2}', "");
    Error('\p{Is_Present_In=	-00003.2/a/}');
    Error('\P{Is_Present_In=	-00003.2/a/}');
    Expect(1, 983040, '\p{Is_Present_In=+00_00_00_03.2}', "");
    Expect(0, 983040, '\p{^Is_Present_In=+00_00_00_03.2}', "");
    Expect(0, 983040, '\P{Is_Present_In=+00_00_00_03.2}', "");
    Expect(1, 983040, '\P{^Is_Present_In=+00_00_00_03.2}', "");
    Expect(0, 983037, '\p{Is_Present_In=+00_00_00_03.2}', "");
    Expect(1, 983037, '\p{^Is_Present_In=+00_00_00_03.2}', "");
    Expect(1, 983037, '\P{Is_Present_In=+00_00_00_03.2}', "");
    Expect(0, 983037, '\P{^Is_Present_In=+00_00_00_03.2}', "");
    Error('\p{Is_In=	 V3_2/a/}');
    Error('\P{Is_In=	 V3_2/a/}');
    Expect(1, 983040, '\p{Is_In:   v32}', "");
    Expect(0, 983040, '\p{^Is_In:   v32}', "");
    Expect(0, 983040, '\P{Is_In:   v32}', "");
    Expect(1, 983040, '\P{^Is_In:   v32}', "");
    Expect(0, 983037, '\p{Is_In:   v32}', "");
    Expect(1, 983037, '\p{^Is_In:   v32}', "");
    Expect(1, 983037, '\P{Is_In:   v32}', "");
    Expect(0, 983037, '\P{^Is_In:   v32}', "");
    Expect(1, 983040, '\p{Is_In=		V3_2}', "");
    Expect(0, 983040, '\p{^Is_In=		V3_2}', "");
    Expect(0, 983040, '\P{Is_In=		V3_2}', "");
    Expect(1, 983040, '\P{^Is_In=		V3_2}', "");
    Expect(0, 983037, '\p{Is_In=		V3_2}', "");
    Expect(1, 983037, '\p{^Is_In=		V3_2}', "");
    Expect(1, 983037, '\P{Is_In=		V3_2}', "");
    Expect(0, 983037, '\P{^Is_In=		V3_2}', "");
    Error('\p{Present_In=-_00_00_00_04.0/a/}');
    Error('\P{Present_In=-_00_00_00_04.0/a/}');
    Expect(1, 983040, '\p{Present_In=:\A4.0\z:}', "");;
    Expect(0, 983037, '\p{Present_In=:\A4.0\z:}', "");;
    Expect(1, 983040, '\p{Present_In=+0_4.0}', "");
    Expect(0, 983040, '\p{^Present_In=+0_4.0}', "");
    Expect(0, 983040, '\P{Present_In=+0_4.0}', "");
    Expect(1, 983040, '\P{^Present_In=+0_4.0}', "");
    Expect(0, 983037, '\p{Present_In=+0_4.0}', "");
    Expect(1, 983037, '\p{^Present_In=+0_4.0}', "");
    Expect(1, 983037, '\P{Present_In=+0_4.0}', "");
    Expect(0, 983037, '\P{^Present_In=+0_4.0}', "");
    Error('\p{In=:=_V4_0}');
    Error('\P{In=:=_V4_0}');
    Expect(1, 983040, '\p{In=:\AV4_0\z:}', "");;
    Expect(0, 983037, '\p{In=:\AV4_0\z:}', "");;
    Expect(1, 983040, '\p{In=v40}', "");
    Expect(0, 983040, '\p{^In=v40}', "");
    Expect(0, 983040, '\P{In=v40}', "");
    Expect(1, 983040, '\P{^In=v40}', "");
    Expect(0, 983037, '\p{In=v40}', "");
    Expect(1, 983037, '\p{^In=v40}', "");
    Expect(1, 983037, '\P{In=v40}', "");
    Expect(0, 983037, '\P{^In=v40}', "");
    Expect(1, 983040, '\p{In=:\Av40\z:}', "");;
    Expect(0, 983037, '\p{In=:\Av40\z:}', "");;
    Expect(1, 983040, '\p{In=_v4_0}', "");
    Expect(0, 983040, '\p{^In=_v4_0}', "");
    Expect(0, 983040, '\P{In=_v4_0}', "");
    Expect(1, 983040, '\P{^In=_v4_0}', "");
    Expect(0, 983037, '\p{In=_v4_0}', "");
    Expect(1, 983037, '\p{^In=_v4_0}', "");
    Expect(1, 983037, '\P{In=_v4_0}', "");
    Expect(0, 983037, '\P{^In=_v4_0}', "");
    Error('\p{Is_Present_In= -+04.0/a/}');
    Error('\P{Is_Present_In= -+04.0/a/}');
    Expect(1, 983040, '\p{Is_Present_In=00_4.0}', "");
    Expect(0, 983040, '\p{^Is_Present_In=00_4.0}', "");
    Expect(0, 983040, '\P{Is_Present_In=00_4.0}', "");
    Expect(1, 983040, '\P{^Is_Present_In=00_4.0}', "");
    Expect(0, 983037, '\p{Is_Present_In=00_4.0}', "");
    Expect(1, 983037, '\p{^Is_Present_In=00_4.0}', "");
    Expect(1, 983037, '\P{Is_Present_In=00_4.0}', "");
    Expect(0, 983037, '\P{^Is_Present_In=00_4.0}', "");
    Error('\p{Is_In=	-V4_0:=}');
    Error('\P{Is_In=	-V4_0:=}');
    Expect(1, 983040, '\p{Is_In=v40}', "");
    Expect(0, 983040, '\p{^Is_In=v40}', "");
    Expect(0, 983040, '\P{Is_In=v40}', "");
    Expect(1, 983040, '\P{^Is_In=v40}', "");
    Expect(0, 983037, '\p{Is_In=v40}', "");
    Expect(1, 983037, '\p{^Is_In=v40}', "");
    Expect(1, 983037, '\P{Is_In=v40}', "");
    Expect(0, 983037, '\P{^Is_In=v40}', "");
    Expect(1, 983040, '\p{Is_In=__V4_0}', "");
    Expect(0, 983040, '\p{^Is_In=__V4_0}', "");
    Expect(0, 983040, '\P{Is_In=__V4_0}', "");
    Expect(1, 983040, '\P{^Is_In=__V4_0}', "");
    Expect(0, 983037, '\p{Is_In=__V4_0}', "");
    Expect(1, 983037, '\p{^Is_In=__V4_0}', "");
    Expect(1, 983037, '\P{Is_In=__V4_0}', "");
    Expect(0, 983037, '\P{^Is_In=__V4_0}', "");
    Error('\p{Present_In=/a/-_+0_0_0_0_0004.1}');
    Error('\P{Present_In=/a/-_+0_0_0_0_0004.1}');
    Expect(1, 983040, '\p{Present_In=:\A4.1\z:}', "");;
    Expect(0, 983037, '\p{Present_In=:\A4.1\z:}', "");;
    Expect(1, 983040, '\p{Present_In=0_0_0_0_004.1}', "");
    Expect(0, 983040, '\p{^Present_In=0_0_0_0_004.1}', "");
    Expect(0, 983040, '\P{Present_In=0_0_0_0_004.1}', "");
    Expect(1, 983040, '\P{^Present_In=0_0_0_0_004.1}', "");
    Expect(0, 983037, '\p{Present_In=0_0_0_0_004.1}', "");
    Expect(1, 983037, '\p{^Present_In=0_0_0_0_004.1}', "");
    Expect(1, 983037, '\P{Present_In=0_0_0_0_004.1}', "");
    Expect(0, 983037, '\P{^Present_In=0_0_0_0_004.1}', "");
    Error('\p{In= /a/V4_1}');
    Error('\P{In= /a/V4_1}');
    Expect(1, 983040, '\p{In=:\AV4_1\z:}', "");;
    Expect(0, 983037, '\p{In=:\AV4_1\z:}', "");;
    Expect(1, 983040, '\p{In=v41}', "");
    Expect(0, 983040, '\p{^In=v41}', "");
    Expect(0, 983040, '\P{In=v41}', "");
    Expect(1, 983040, '\P{^In=v41}', "");
    Expect(0, 983037, '\p{In=v41}', "");
    Expect(1, 983037, '\p{^In=v41}', "");
    Expect(1, 983037, '\P{In=v41}', "");
    Expect(0, 983037, '\P{^In=v41}', "");
    Expect(1, 983040, '\p{In=:\Av41\z:}', "");;
    Expect(0, 983037, '\p{In=:\Av41\z:}', "");;
    Expect(1, 983040, '\p{In:-	V4_1}', "");
    Expect(0, 983040, '\p{^In:-	V4_1}', "");
    Expect(0, 983040, '\P{In:-	V4_1}', "");
    Expect(1, 983040, '\P{^In:-	V4_1}', "");
    Expect(0, 983037, '\p{In:-	V4_1}', "");
    Expect(1, 983037, '\p{^In:-	V4_1}', "");
    Expect(1, 983037, '\P{In:-	V4_1}', "");
    Expect(0, 983037, '\P{^In:-	V4_1}', "");
    Error('\p{Is_Present_In:   :=000000004.1}');
    Error('\P{Is_Present_In:   :=000000004.1}');
    Expect(1, 983040, '\p{Is_Present_In=0000000004.1}', "");
    Expect(0, 983040, '\p{^Is_Present_In=0000000004.1}', "");
    Expect(0, 983040, '\P{Is_Present_In=0000000004.1}', "");
    Expect(1, 983040, '\P{^Is_Present_In=0000000004.1}', "");
    Expect(0, 983037, '\p{Is_Present_In=0000000004.1}', "");
    Expect(1, 983037, '\p{^Is_Present_In=0000000004.1}', "");
    Expect(1, 983037, '\P{Is_Present_In=0000000004.1}', "");
    Expect(0, 983037, '\P{^Is_Present_In=0000000004.1}', "");
    Error('\p{Is_In:   -/a/V4_1}');
    Error('\P{Is_In:   -/a/V4_1}');
    Expect(1, 983040, '\p{Is_In=v41}', "");
    Expect(0, 983040, '\p{^Is_In=v41}', "");
    Expect(0, 983040, '\P{Is_In=v41}', "");
    Expect(1, 983040, '\P{^Is_In=v41}', "");
    Expect(0, 983037, '\p{Is_In=v41}', "");
    Expect(1, 983037, '\p{^Is_In=v41}', "");
    Expect(1, 983037, '\P{Is_In=v41}', "");
    Expect(0, 983037, '\P{^Is_In=v41}', "");
    Expect(1, 983040, '\p{Is_In=_ v4_1}', "");
    Expect(0, 983040, '\p{^Is_In=_ v4_1}', "");
    Expect(0, 983040, '\P{Is_In=_ v4_1}', "");
    Expect(1, 983040, '\P{^Is_In=_ v4_1}', "");
    Expect(0, 983037, '\p{Is_In=_ v4_1}', "");
    Expect(1, 983037, '\p{^Is_In=_ v4_1}', "");
    Expect(1, 983037, '\P{Is_In=_ v4_1}', "");
    Expect(0, 983037, '\P{^Is_In=_ v4_1}', "");
    Error('\p{Present_In=_0005.0:=}');
    Error('\P{Present_In=_0005.0:=}');
    Expect(1, 983040, '\p{Present_In=:\A5.0\z:}', "");;
    Expect(0, 983037, '\p{Present_In=:\A5.0\z:}', "");;
    Expect(1, 983040, '\p{Present_In=000005.0}', "");
    Expect(0, 983040, '\p{^Present_In=000005.0}', "");
    Expect(0, 983040, '\P{Present_In=000005.0}', "");
    Expect(1, 983040, '\P{^Present_In=000005.0}', "");
    Expect(0, 983037, '\p{Present_In=000005.0}', "");
    Expect(1, 983037, '\p{^Present_In=000005.0}', "");
    Expect(1, 983037, '\P{Present_In=000005.0}', "");
    Expect(0, 983037, '\P{^Present_In=000005.0}', "");
    Error('\p{In= V5_0/a/}');
    Error('\P{In= V5_0/a/}');
    Expect(1, 983040, '\p{In=:\AV5_0\z:}', "");;
    Expect(0, 983037, '\p{In=:\AV5_0\z:}', "");;
    Expect(1, 983040, '\p{In=v50}', "");
    Expect(0, 983040, '\p{^In=v50}', "");
    Expect(0, 983040, '\P{In=v50}', "");
    Expect(1, 983040, '\P{^In=v50}', "");
    Expect(0, 983037, '\p{In=v50}', "");
    Expect(1, 983037, '\p{^In=v50}', "");
    Expect(1, 983037, '\P{In=v50}', "");
    Expect(0, 983037, '\P{^In=v50}', "");
    Expect(1, 983040, '\p{In=:\Av50\z:}', "");;
    Expect(0, 983037, '\p{In=:\Av50\z:}', "");;
    Expect(1, 983040, '\p{In=_V5_0}', "");
    Expect(0, 983040, '\p{^In=_V5_0}', "");
    Expect(0, 983040, '\P{In=_V5_0}', "");
    Expect(1, 983040, '\P{^In=_V5_0}', "");
    Expect(0, 983037, '\p{In=_V5_0}', "");
    Expect(1, 983037, '\p{^In=_V5_0}', "");
    Expect(1, 983037, '\P{In=_V5_0}', "");
    Expect(0, 983037, '\P{^In=_V5_0}', "");
    Error('\p{Is_Present_In=:=--000005.0}');
    Error('\P{Is_Present_In=:=--000005.0}');
    Expect(1, 983040, '\p{Is_Present_In=+0_0_0_0_005.0}', "");
    Expect(0, 983040, '\p{^Is_Present_In=+0_0_0_0_005.0}', "");
    Expect(0, 983040, '\P{Is_Present_In=+0_0_0_0_005.0}', "");
    Expect(1, 983040, '\P{^Is_Present_In=+0_0_0_0_005.0}', "");
    Expect(0, 983037, '\p{Is_Present_In=+0_0_0_0_005.0}', "");
    Expect(1, 983037, '\p{^Is_Present_In=+0_0_0_0_005.0}', "");
    Expect(1, 983037, '\P{Is_Present_In=+0_0_0_0_005.0}', "");
    Expect(0, 983037, '\P{^Is_Present_In=+0_0_0_0_005.0}', "");
    Error('\p{Is_In= :=v5_0}');
    Error('\P{Is_In= :=v5_0}');
    Expect(1, 983040, '\p{Is_In=v50}', "");
    Expect(0, 983040, '\p{^Is_In=v50}', "");
    Expect(0, 983040, '\P{Is_In=v50}', "");
    Expect(1, 983040, '\P{^Is_In=v50}', "");
    Expect(0, 983037, '\p{Is_In=v50}', "");
    Expect(1, 983037, '\p{^Is_In=v50}', "");
    Expect(1, 983037, '\P{Is_In=v50}', "");
    Expect(0, 983037, '\P{^Is_In=v50}', "");
    Expect(1, 983040, '\p{Is_In: _ v5_0}', "");
    Expect(0, 983040, '\p{^Is_In: _ v5_0}', "");
    Expect(0, 983040, '\P{Is_In: _ v5_0}', "");
    Expect(1, 983040, '\P{^Is_In: _ v5_0}', "");
    Expect(0, 983037, '\p{Is_In: _ v5_0}', "");
    Expect(1, 983037, '\p{^Is_In: _ v5_0}', "");
    Expect(1, 983037, '\P{Is_In: _ v5_0}', "");
    Expect(0, 983037, '\P{^Is_In: _ v5_0}', "");
    Error('\p{Present_In=/a/-_0005.1}');
    Error('\P{Present_In=/a/-_0005.1}');
    Expect(1, 983040, '\p{Present_In=:\A5.1\z:}', "");;
    Expect(0, 983037, '\p{Present_In=:\A5.1\z:}', "");;
    Expect(1, 983040, '\p{Present_In=000000005.1}', "");
    Expect(0, 983040, '\p{^Present_In=000000005.1}', "");
    Expect(0, 983040, '\P{Present_In=000000005.1}', "");
    Expect(1, 983040, '\P{^Present_In=000000005.1}', "");
    Expect(0, 983037, '\p{Present_In=000000005.1}', "");
    Expect(1, 983037, '\p{^Present_In=000000005.1}', "");
    Expect(1, 983037, '\P{Present_In=000000005.1}', "");
    Expect(0, 983037, '\P{^Present_In=000000005.1}', "");
    Error('\p{In=/a/V5_1}');
    Error('\P{In=/a/V5_1}');
    Expect(1, 983040, '\p{In=:\AV5_1\z:}', "");;
    Expect(0, 983037, '\p{In=:\AV5_1\z:}', "");;
    Expect(1, 983040, '\p{In=v51}', "");
    Expect(0, 983040, '\p{^In=v51}', "");
    Expect(0, 983040, '\P{In=v51}', "");
    Expect(1, 983040, '\P{^In=v51}', "");
    Expect(0, 983037, '\p{In=v51}', "");
    Expect(1, 983037, '\p{^In=v51}', "");
    Expect(1, 983037, '\P{In=v51}', "");
    Expect(0, 983037, '\P{^In=v51}', "");
    Expect(1, 983040, '\p{In=:\Av51\z:}', "");;
    Expect(0, 983037, '\p{In=:\Av51\z:}', "");;
    Expect(1, 983040, '\p{In=_	V5_1}', "");
    Expect(0, 983040, '\p{^In=_	V5_1}', "");
    Expect(0, 983040, '\P{In=_	V5_1}', "");
    Expect(1, 983040, '\P{^In=_	V5_1}', "");
    Expect(0, 983037, '\p{In=_	V5_1}', "");
    Expect(1, 983037, '\p{^In=_	V5_1}', "");
    Expect(1, 983037, '\P{In=_	V5_1}', "");
    Expect(0, 983037, '\P{^In=_	V5_1}', "");
    Error('\p{Is_Present_In=-	+0005.1/a/}');
    Error('\P{Is_Present_In=-	+0005.1/a/}');
    Expect(1, 983040, '\p{Is_Present_In=0_5.1}', "");
    Expect(0, 983040, '\p{^Is_Present_In=0_5.1}', "");
    Expect(0, 983040, '\P{Is_Present_In=0_5.1}', "");
    Expect(1, 983040, '\P{^Is_Present_In=0_5.1}', "");
    Expect(0, 983037, '\p{Is_Present_In=0_5.1}', "");
    Expect(1, 983037, '\p{^Is_Present_In=0_5.1}', "");
    Expect(1, 983037, '\P{Is_Present_In=0_5.1}', "");
    Expect(0, 983037, '\P{^Is_Present_In=0_5.1}', "");
    Error('\p{Is_In= V5_1:=}');
    Error('\P{Is_In= V5_1:=}');
    Expect(1, 983040, '\p{Is_In=v51}', "");
    Expect(0, 983040, '\p{^Is_In=v51}', "");
    Expect(0, 983040, '\P{Is_In=v51}', "");
    Expect(1, 983040, '\P{^Is_In=v51}', "");
    Expect(0, 983037, '\p{Is_In=v51}', "");
    Expect(1, 983037, '\p{^Is_In=v51}', "");
    Expect(1, 983037, '\P{Is_In=v51}', "");
    Expect(0, 983037, '\P{^Is_In=v51}', "");
    Expect(1, 983040, '\p{Is_In=--v5_1}', "");
    Expect(0, 983040, '\p{^Is_In=--v5_1}', "");
    Expect(0, 983040, '\P{Is_In=--v5_1}', "");
    Expect(1, 983040, '\P{^Is_In=--v5_1}', "");
    Expect(0, 983037, '\p{Is_In=--v5_1}', "");
    Expect(1, 983037, '\p{^Is_In=--v5_1}', "");
    Expect(1, 983037, '\P{Is_In=--v5_1}', "");
    Expect(0, 983037, '\P{^Is_In=--v5_1}', "");
    Error('\p{Present_In=:=--000_5.2}');
    Error('\P{Present_In=:=--000_5.2}');
    Expect(1, 983040, '\p{Present_In=:\A5.2\z:}', "");;
    Expect(0, 983037, '\p{Present_In=:\A5.2\z:}', "");;
    Expect(1, 983040, '\p{Present_In=000000005.2}', "");
    Expect(0, 983040, '\p{^Present_In=000000005.2}', "");
    Expect(0, 983040, '\P{Present_In=000000005.2}', "");
    Expect(1, 983040, '\P{^Present_In=000000005.2}', "");
    Expect(0, 983037, '\p{Present_In=000000005.2}', "");
    Expect(1, 983037, '\p{^Present_In=000000005.2}', "");
    Expect(1, 983037, '\P{Present_In=000000005.2}', "");
    Expect(0, 983037, '\P{^Present_In=000000005.2}', "");
    Error('\p{In=/a/--V5_2}');
    Error('\P{In=/a/--V5_2}');
    Expect(1, 983040, '\p{In=:\AV5_2\z:}', "");;
    Expect(0, 983037, '\p{In=:\AV5_2\z:}', "");;
    Expect(1, 983040, '\p{In=v52}', "");
    Expect(0, 983040, '\p{^In=v52}', "");
    Expect(0, 983040, '\P{In=v52}', "");
    Expect(1, 983040, '\P{^In=v52}', "");
    Expect(0, 983037, '\p{In=v52}', "");
    Expect(1, 983037, '\p{^In=v52}', "");
    Expect(1, 983037, '\P{In=v52}', "");
    Expect(0, 983037, '\P{^In=v52}', "");
    Expect(1, 983040, '\p{In=:\Av52\z:}', "");;
    Expect(0, 983037, '\p{In=:\Av52\z:}', "");;
    Expect(1, 983040, '\p{In=-	v5_2}', "");
    Expect(0, 983040, '\p{^In=-	v5_2}', "");
    Expect(0, 983040, '\P{In=-	v5_2}', "");
    Expect(1, 983040, '\P{^In=-	v5_2}', "");
    Expect(0, 983037, '\p{In=-	v5_2}', "");
    Expect(1, 983037, '\p{^In=-	v5_2}', "");
    Expect(1, 983037, '\P{In=-	v5_2}', "");
    Expect(0, 983037, '\P{^In=-	v5_2}', "");
    Error('\p{Is_Present_In=:=--0000005.2}');
    Error('\P{Is_Present_In=:=--0000005.2}');
    Expect(1, 983040, '\p{Is_Present_In=000_000_000_5.2}', "");
    Expect(0, 983040, '\p{^Is_Present_In=000_000_000_5.2}', "");
    Expect(0, 983040, '\P{Is_Present_In=000_000_000_5.2}', "");
    Expect(1, 983040, '\P{^Is_Present_In=000_000_000_5.2}', "");
    Expect(0, 983037, '\p{Is_Present_In=000_000_000_5.2}', "");
    Expect(1, 983037, '\p{^Is_Present_In=000_000_000_5.2}', "");
    Expect(1, 983037, '\P{Is_Present_In=000_000_000_5.2}', "");
    Expect(0, 983037, '\P{^Is_Present_In=000_000_000_5.2}', "");
    Error('\p{Is_In=-/a/V5_2}');
    Error('\P{Is_In=-/a/V5_2}');
    Expect(1, 983040, '\p{Is_In=v52}', "");
    Expect(0, 983040, '\p{^Is_In=v52}', "");
    Expect(0, 983040, '\P{Is_In=v52}', "");
    Expect(1, 983040, '\P{^Is_In=v52}', "");
    Expect(0, 983037, '\p{Is_In=v52}', "");
    Expect(1, 983037, '\p{^Is_In=v52}', "");
    Expect(1, 983037, '\P{Is_In=v52}', "");
    Expect(0, 983037, '\P{^Is_In=v52}', "");
    Expect(1, 983040, '\p{Is_In=__V5_2}', "");
    Expect(0, 983040, '\p{^Is_In=__V5_2}', "");
    Expect(0, 983040, '\P{Is_In=__V5_2}', "");
    Expect(1, 983040, '\P{^Is_In=__V5_2}', "");
    Expect(0, 983037, '\p{Is_In=__V5_2}', "");
    Expect(1, 983037, '\p{^Is_In=__V5_2}', "");
    Expect(1, 983037, '\P{Is_In=__V5_2}', "");
    Expect(0, 983037, '\P{^Is_In=__V5_2}', "");
    Error('\p{Present_In=-/a/00000006.0}');
    Error('\P{Present_In=-/a/00000006.0}');
    Expect(1, 983040, '\p{Present_In=:\A6.0\z:}', "");;
    Expect(0, 983037, '\p{Present_In=:\A6.0\z:}', "");;
    Expect(1, 983040, '\p{Present_In=006.0}', "");
    Expect(0, 983040, '\p{^Present_In=006.0}', "");
    Expect(0, 983040, '\P{Present_In=006.0}', "");
    Expect(1, 983040, '\P{^Present_In=006.0}', "");
    Expect(0, 983037, '\p{Present_In=006.0}', "");
    Expect(1, 983037, '\p{^Present_In=006.0}', "");
    Expect(1, 983037, '\P{Present_In=006.0}', "");
    Expect(0, 983037, '\P{^Present_In=006.0}', "");
    Error('\p{In=:=  V6_0}');
    Error('\P{In=:=  V6_0}');
    Expect(1, 983040, '\p{In=:\AV6_0\z:}', "");;
    Expect(0, 983037, '\p{In=:\AV6_0\z:}', "");;
    Expect(1, 983040, '\p{In=v60}', "");
    Expect(0, 983040, '\p{^In=v60}', "");
    Expect(0, 983040, '\P{In=v60}', "");
    Expect(1, 983040, '\P{^In=v60}', "");
    Expect(0, 983037, '\p{In=v60}', "");
    Expect(1, 983037, '\p{^In=v60}', "");
    Expect(1, 983037, '\P{In=v60}', "");
    Expect(0, 983037, '\P{^In=v60}', "");
    Expect(1, 983040, '\p{In=:\Av60\z:}', "");;
    Expect(0, 983037, '\p{In=:\Av60\z:}', "");;
    Expect(1, 983040, '\p{In= 	V6_0}', "");
    Expect(0, 983040, '\p{^In= 	V6_0}', "");
    Expect(0, 983040, '\P{In= 	V6_0}', "");
    Expect(1, 983040, '\P{^In= 	V6_0}', "");
    Expect(0, 983037, '\p{In= 	V6_0}', "");
    Expect(1, 983037, '\p{^In= 	V6_0}', "");
    Expect(1, 983037, '\P{In= 	V6_0}', "");
    Expect(0, 983037, '\P{^In= 	V6_0}', "");
    Error('\p{Is_Present_In:    :=+0000000006.0}');
    Error('\P{Is_Present_In:    :=+0000000006.0}');
    Expect(1, 983040, '\p{Is_Present_In=00006.0}', "");
    Expect(0, 983040, '\p{^Is_Present_In=00006.0}', "");
    Expect(0, 983040, '\P{Is_Present_In=00006.0}', "");
    Expect(1, 983040, '\P{^Is_Present_In=00006.0}', "");
    Expect(0, 983037, '\p{Is_Present_In=00006.0}', "");
    Expect(1, 983037, '\p{^Is_Present_In=00006.0}', "");
    Expect(1, 983037, '\P{Is_Present_In=00006.0}', "");
    Expect(0, 983037, '\P{^Is_Present_In=00006.0}', "");
    Error('\p{Is_In=:= V6_0}');
    Error('\P{Is_In=:= V6_0}');
    Expect(1, 983040, '\p{Is_In=v60}', "");
    Expect(0, 983040, '\p{^Is_In=v60}', "");
    Expect(0, 983040, '\P{Is_In=v60}', "");
    Expect(1, 983040, '\P{^Is_In=v60}', "");
    Expect(0, 983037, '\p{Is_In=v60}', "");
    Expect(1, 983037, '\p{^Is_In=v60}', "");
    Expect(1, 983037, '\P{Is_In=v60}', "");
    Expect(0, 983037, '\P{^Is_In=v60}', "");
    Expect(1, 983040, '\p{Is_In=_	v6_0}', "");
    Expect(0, 983040, '\p{^Is_In=_	v6_0}', "");
    Expect(0, 983040, '\P{Is_In=_	v6_0}', "");
    Expect(1, 983040, '\P{^Is_In=_	v6_0}', "");
    Expect(0, 983037, '\p{Is_In=_	v6_0}', "");
    Expect(1, 983037, '\p{^Is_In=_	v6_0}', "");
    Expect(1, 983037, '\P{Is_In=_	v6_0}', "");
    Expect(0, 983037, '\P{^Is_In=_	v6_0}', "");
    Error('\p{Present_In=-0000_0000_6.1:=}');
    Error('\P{Present_In=-0000_0000_6.1:=}');
    Expect(1, 983040, '\p{Present_In=:\A6.1\z:}', "");;
    Expect(0, 983037, '\p{Present_In=:\A6.1\z:}', "");;
    Expect(1, 983040, '\p{Present_In=0_0_0_06.1}', "");
    Expect(0, 983040, '\p{^Present_In=0_0_0_06.1}', "");
    Expect(0, 983040, '\P{Present_In=0_0_0_06.1}', "");
    Expect(1, 983040, '\P{^Present_In=0_0_0_06.1}', "");
    Expect(0, 983037, '\p{Present_In=0_0_0_06.1}', "");
    Expect(1, 983037, '\p{^Present_In=0_0_0_06.1}', "");
    Expect(1, 983037, '\P{Present_In=0_0_0_06.1}', "");
    Expect(0, 983037, '\P{^Present_In=0_0_0_06.1}', "");
    Error('\p{In= 	V6_1/a/}');
    Error('\P{In= 	V6_1/a/}');
    Expect(1, 983040, '\p{In=:\AV6_1\z:}', "");;
    Expect(0, 983037, '\p{In=:\AV6_1\z:}', "");;
    Expect(1, 983040, '\p{In=v61}', "");
    Expect(0, 983040, '\p{^In=v61}', "");
    Expect(0, 983040, '\P{In=v61}', "");
    Expect(1, 983040, '\P{^In=v61}', "");
    Expect(0, 983037, '\p{In=v61}', "");
    Expect(1, 983037, '\p{^In=v61}', "");
    Expect(1, 983037, '\P{In=v61}', "");
    Expect(0, 983037, '\P{^In=v61}', "");
    Expect(1, 983040, '\p{In=:\Av61\z:}', "");;
    Expect(0, 983037, '\p{In=:\Av61\z:}', "");;
    Expect(1, 983040, '\p{In=	V6_1}', "");
    Expect(0, 983040, '\p{^In=	V6_1}', "");
    Expect(0, 983040, '\P{In=	V6_1}', "");
    Expect(1, 983040, '\P{^In=	V6_1}', "");
    Expect(0, 983037, '\p{In=	V6_1}', "");
    Expect(1, 983037, '\p{^In=	V6_1}', "");
    Expect(1, 983037, '\P{In=	V6_1}', "");
    Expect(0, 983037, '\P{^In=	V6_1}', "");
    Error('\p{Is_Present_In=- +006.1/a/}');
    Error('\P{Is_Present_In=- +006.1/a/}');
    Expect(1, 983040, '\p{Is_Present_In=6.1}', "");
    Expect(0, 983040, '\p{^Is_Present_In=6.1}', "");
    Expect(0, 983040, '\P{Is_Present_In=6.1}', "");
    Expect(1, 983040, '\P{^Is_Present_In=6.1}', "");
    Expect(0, 983037, '\p{Is_Present_In=6.1}', "");
    Expect(1, 983037, '\p{^Is_Present_In=6.1}', "");
    Expect(1, 983037, '\P{Is_Present_In=6.1}', "");
    Expect(0, 983037, '\P{^Is_Present_In=6.1}', "");
    Error('\p{Is_In=	/a/V6_1}');
    Error('\P{Is_In=	/a/V6_1}');
    Expect(1, 983040, '\p{Is_In=v61}', "");
    Expect(0, 983040, '\p{^Is_In=v61}', "");
    Expect(0, 983040, '\P{Is_In=v61}', "");
    Expect(1, 983040, '\P{^Is_In=v61}', "");
    Expect(0, 983037, '\p{Is_In=v61}', "");
    Expect(1, 983037, '\p{^Is_In=v61}', "");
    Expect(1, 983037, '\P{Is_In=v61}', "");
    Expect(0, 983037, '\P{^Is_In=v61}', "");
    Expect(1, 983040, '\p{Is_In=	_V6_1}', "");
    Expect(0, 983040, '\p{^Is_In=	_V6_1}', "");
    Expect(0, 983040, '\P{Is_In=	_V6_1}', "");
    Expect(1, 983040, '\P{^Is_In=	_V6_1}', "");
    Expect(0, 983037, '\p{Is_In=	_V6_1}', "");
    Expect(1, 983037, '\p{^Is_In=	_V6_1}', "");
    Expect(1, 983037, '\P{Is_In=	_V6_1}', "");
    Expect(0, 983037, '\P{^Is_In=	_V6_1}', "");
    Error('\p{Present_In:_/a/00_00_6.2}');
    Error('\P{Present_In:_/a/00_00_6.2}');
    Expect(1, 983040, '\p{Present_In=:\A6.2\z:}', "");;
    Expect(0, 983037, '\p{Present_In=:\A6.2\z:}', "");;
    Expect(1, 983040, '\p{Present_In=006.2}', "");
    Expect(0, 983040, '\p{^Present_In=006.2}', "");
    Expect(0, 983040, '\P{Present_In=006.2}', "");
    Expect(1, 983040, '\P{^Present_In=006.2}', "");
    Expect(0, 983037, '\p{Present_In=006.2}', "");
    Expect(1, 983037, '\p{^Present_In=006.2}', "");
    Expect(1, 983037, '\P{Present_In=006.2}', "");
    Expect(0, 983037, '\P{^Present_In=006.2}', "");
    Error('\p{In=:=	-V6_2}');
    Error('\P{In=:=	-V6_2}');
    Expect(1, 983040, '\p{In=:\AV6_2\z:}', "");;
    Expect(0, 983037, '\p{In=:\AV6_2\z:}', "");;
    Expect(1, 983040, '\p{In=v62}', "");
    Expect(0, 983040, '\p{^In=v62}', "");
    Expect(0, 983040, '\P{In=v62}', "");
    Expect(1, 983040, '\P{^In=v62}', "");
    Expect(0, 983037, '\p{In=v62}', "");
    Expect(1, 983037, '\p{^In=v62}', "");
    Expect(1, 983037, '\P{In=v62}', "");
    Expect(0, 983037, '\P{^In=v62}', "");
    Expect(1, 983040, '\p{In=:\Av62\z:}', "");;
    Expect(0, 983037, '\p{In=:\Av62\z:}', "");;
    Expect(1, 983040, '\p{In: 		v6_2}', "");
    Expect(0, 983040, '\p{^In: 		v6_2}', "");
    Expect(0, 983040, '\P{In: 		v6_2}', "");
    Expect(1, 983040, '\P{^In: 		v6_2}', "");
    Expect(0, 983037, '\p{In: 		v6_2}', "");
    Expect(1, 983037, '\p{^In: 		v6_2}', "");
    Expect(1, 983037, '\P{In: 		v6_2}', "");
    Expect(0, 983037, '\P{^In: 		v6_2}', "");
    Error('\p{Is_Present_In=_+06.2:=}');
    Error('\P{Is_Present_In=_+06.2:=}');
    Expect(1, 983040, '\p{Is_Present_In:	0_0_0_0_0_0_0_06.2}', "");
    Expect(0, 983040, '\p{^Is_Present_In:	0_0_0_0_0_0_0_06.2}', "");
    Expect(0, 983040, '\P{Is_Present_In:	0_0_0_0_0_0_0_06.2}', "");
    Expect(1, 983040, '\P{^Is_Present_In:	0_0_0_0_0_0_0_06.2}', "");
    Expect(0, 983037, '\p{Is_Present_In:	0_0_0_0_0_0_0_06.2}', "");
    Expect(1, 983037, '\p{^Is_Present_In:	0_0_0_0_0_0_0_06.2}', "");
    Expect(1, 983037, '\P{Is_Present_In:	0_0_0_0_0_0_0_06.2}', "");
    Expect(0, 983037, '\P{^Is_Present_In:	0_0_0_0_0_0_0_06.2}', "");
    Error('\p{Is_In=/a/	_V6_2}');
    Error('\P{Is_In=/a/	_V6_2}');
    Expect(1, 983040, '\p{Is_In=v62}', "");
    Expect(0, 983040, '\p{^Is_In=v62}', "");
    Expect(0, 983040, '\P{Is_In=v62}', "");
    Expect(1, 983040, '\P{^Is_In=v62}', "");
    Expect(0, 983037, '\p{Is_In=v62}', "");
    Expect(1, 983037, '\p{^Is_In=v62}', "");
    Expect(1, 983037, '\P{Is_In=v62}', "");
    Expect(0, 983037, '\P{^Is_In=v62}', "");
    Expect(1, 983040, '\p{Is_In= _V6_2}', "");
    Expect(0, 983040, '\p{^Is_In= _V6_2}', "");
    Expect(0, 983040, '\P{Is_In= _V6_2}', "");
    Expect(1, 983040, '\P{^Is_In= _V6_2}', "");
    Expect(0, 983037, '\p{Is_In= _V6_2}', "");
    Expect(1, 983037, '\p{^Is_In= _V6_2}', "");
    Expect(1, 983037, '\P{Is_In= _V6_2}', "");
    Expect(0, 983037, '\P{^Is_In= _V6_2}', "");
    Error('\p{Present_In=/a/  +0_0_0_0_0_0_0_06.3}');
    Error('\P{Present_In=/a/  +0_0_0_0_0_0_0_06.3}');
    Expect(1, 983040, '\p{Present_In=:\A6.3\z:}', "");;
    Expect(0, 983037, '\p{Present_In=:\A6.3\z:}', "");;
    Expect(1, 983040, '\p{Present_In=+06.3}', "");
    Expect(0, 983040, '\p{^Present_In=+06.3}', "");
    Expect(0, 983040, '\P{Present_In=+06.3}', "");
    Expect(1, 983040, '\P{^Present_In=+06.3}', "");
    Expect(0, 983037, '\p{Present_In=+06.3}', "");
    Expect(1, 983037, '\p{^Present_In=+06.3}', "");
    Expect(1, 983037, '\P{Present_In=+06.3}', "");
    Expect(0, 983037, '\P{^Present_In=+06.3}', "");
    Error('\p{In= -V6_3:=}');
    Error('\P{In= -V6_3:=}');
    Expect(1, 983040, '\p{In=:\AV6_3\z:}', "");;
    Expect(0, 983037, '\p{In=:\AV6_3\z:}', "");;
    Expect(1, 983040, '\p{In=v63}', "");
    Expect(0, 983040, '\p{^In=v63}', "");
    Expect(0, 983040, '\P{In=v63}', "");
    Expect(1, 983040, '\P{^In=v63}', "");
    Expect(0, 983037, '\p{In=v63}', "");
    Expect(1, 983037, '\p{^In=v63}', "");
    Expect(1, 983037, '\P{In=v63}', "");
    Expect(0, 983037, '\P{^In=v63}', "");
    Expect(1, 983040, '\p{In=:\Av63\z:}', "");;
    Expect(0, 983037, '\p{In=:\Av63\z:}', "");;
    Expect(1, 983040, '\p{In=_ V6_3}', "");
    Expect(0, 983040, '\p{^In=_ V6_3}', "");
    Expect(0, 983040, '\P{In=_ V6_3}', "");
    Expect(1, 983040, '\P{^In=_ V6_3}', "");
    Expect(0, 983037, '\p{In=_ V6_3}', "");
    Expect(1, 983037, '\p{^In=_ V6_3}', "");
    Expect(1, 983037, '\P{In=_ V6_3}', "");
    Expect(0, 983037, '\P{^In=_ V6_3}', "");
    Error('\p{Is_Present_In:	/a/  0000006.3}');
    Error('\P{Is_Present_In:	/a/  0000006.3}');
    Expect(1, 983040, '\p{Is_Present_In=0_0_06.3}', "");
    Expect(0, 983040, '\p{^Is_Present_In=0_0_06.3}', "");
    Expect(0, 983040, '\P{Is_Present_In=0_0_06.3}', "");
    Expect(1, 983040, '\P{^Is_Present_In=0_0_06.3}', "");
    Expect(0, 983037, '\p{Is_Present_In=0_0_06.3}', "");
    Expect(1, 983037, '\p{^Is_Present_In=0_0_06.3}', "");
    Expect(1, 983037, '\P{Is_Present_In=0_0_06.3}', "");
    Expect(0, 983037, '\P{^Is_Present_In=0_0_06.3}', "");
    Error('\p{Is_In=:=- V6_3}');
    Error('\P{Is_In=:=- V6_3}');
    Expect(1, 983040, '\p{Is_In=v63}', "");
    Expect(0, 983040, '\p{^Is_In=v63}', "");
    Expect(0, 983040, '\P{Is_In=v63}', "");
    Expect(1, 983040, '\P{^Is_In=v63}', "");
    Expect(0, 983037, '\p{Is_In=v63}', "");
    Expect(1, 983037, '\p{^Is_In=v63}', "");
    Expect(1, 983037, '\P{Is_In=v63}', "");
    Expect(0, 983037, '\P{^Is_In=v63}', "");
    Expect(1, 983040, '\p{Is_In=--V6_3}', "");
    Expect(0, 983040, '\p{^Is_In=--V6_3}', "");
    Expect(0, 983040, '\P{Is_In=--V6_3}', "");
    Expect(1, 983040, '\P{^Is_In=--V6_3}', "");
    Expect(0, 983037, '\p{Is_In=--V6_3}', "");
    Expect(1, 983037, '\p{^Is_In=--V6_3}', "");
    Expect(1, 983037, '\P{Is_In=--V6_3}', "");
    Expect(0, 983037, '\P{^Is_In=--V6_3}', "");
    Error('\p{Present_In=-:=000007.0}');
    Error('\P{Present_In=-:=000007.0}');
    Expect(1, 983040, '\p{Present_In=:\A7.0\z:}', "");;
    Expect(0, 983037, '\p{Present_In=:\A7.0\z:}', "");;
    Expect(1, 983040, '\p{Present_In=00_00_00_7.0}', "");
    Expect(0, 983040, '\p{^Present_In=00_00_00_7.0}', "");
    Expect(0, 983040, '\P{Present_In=00_00_00_7.0}', "");
    Expect(1, 983040, '\P{^Present_In=00_00_00_7.0}', "");
    Expect(0, 983037, '\p{Present_In=00_00_00_7.0}', "");
    Expect(1, 983037, '\p{^Present_In=00_00_00_7.0}', "");
    Expect(1, 983037, '\P{Present_In=00_00_00_7.0}', "");
    Expect(0, 983037, '\P{^Present_In=00_00_00_7.0}', "");
    Error('\p{In=:=v7_0}');
    Error('\P{In=:=v7_0}');
    Expect(1, 983040, '\p{In=:\AV7_0\z:}', "");;
    Expect(0, 983037, '\p{In=:\AV7_0\z:}', "");;
    Expect(1, 983040, '\p{In=v70}', "");
    Expect(0, 983040, '\p{^In=v70}', "");
    Expect(0, 983040, '\P{In=v70}', "");
    Expect(1, 983040, '\P{^In=v70}', "");
    Expect(0, 983037, '\p{In=v70}', "");
    Expect(1, 983037, '\p{^In=v70}', "");
    Expect(1, 983037, '\P{In=v70}', "");
    Expect(0, 983037, '\P{^In=v70}', "");
    Expect(1, 983040, '\p{In=:\Av70\z:}', "");;
    Expect(0, 983037, '\p{In=:\Av70\z:}', "");;
    Expect(1, 983040, '\p{In= 	V7_0}', "");
    Expect(0, 983040, '\p{^In= 	V7_0}', "");
    Expect(0, 983040, '\P{In= 	V7_0}', "");
    Expect(1, 983040, '\P{^In= 	V7_0}', "");
    Expect(0, 983037, '\p{In= 	V7_0}', "");
    Expect(1, 983037, '\p{^In= 	V7_0}', "");
    Expect(1, 983037, '\P{In= 	V7_0}', "");
    Expect(0, 983037, '\P{^In= 	V7_0}', "");
    Error('\p{Is_Present_In=	0_0_0_07.0:=}');
    Error('\P{Is_Present_In=	0_0_0_07.0:=}');
    Expect(1, 983040, '\p{Is_Present_In=000000000_7.0}', "");
    Expect(0, 983040, '\p{^Is_Present_In=000000000_7.0}', "");
    Expect(0, 983040, '\P{Is_Present_In=000000000_7.0}', "");
    Expect(1, 983040, '\P{^Is_Present_In=000000000_7.0}', "");
    Expect(0, 983037, '\p{Is_Present_In=000000000_7.0}', "");
    Expect(1, 983037, '\p{^Is_Present_In=000000000_7.0}', "");
    Expect(1, 983037, '\P{Is_Present_In=000000000_7.0}', "");
    Expect(0, 983037, '\P{^Is_Present_In=000000000_7.0}', "");
    Error('\p{Is_In=-_V7_0/a/}');
    Error('\P{Is_In=-_V7_0/a/}');
    Expect(1, 983040, '\p{Is_In:	v70}', "");
    Expect(0, 983040, '\p{^Is_In:	v70}', "");
    Expect(0, 983040, '\P{Is_In:	v70}', "");
    Expect(1, 983040, '\P{^Is_In:	v70}', "");
    Expect(0, 983037, '\p{Is_In:	v70}', "");
    Expect(1, 983037, '\p{^Is_In:	v70}', "");
    Expect(1, 983037, '\P{Is_In:	v70}', "");
    Expect(0, 983037, '\P{^Is_In:	v70}', "");
    Expect(1, 983040, '\p{Is_In=	-V7_0}', "");
    Expect(0, 983040, '\p{^Is_In=	-V7_0}', "");
    Expect(0, 983040, '\P{Is_In=	-V7_0}', "");
    Expect(1, 983040, '\P{^Is_In=	-V7_0}', "");
    Expect(0, 983037, '\p{Is_In=	-V7_0}', "");
    Expect(1, 983037, '\p{^Is_In=	-V7_0}', "");
    Expect(1, 983037, '\P{Is_In=	-V7_0}', "");
    Expect(0, 983037, '\P{^Is_In=	-V7_0}', "");
    Error('\p{Present_In=-+0_0_08.0/a/}');
    Error('\P{Present_In=-+0_0_08.0/a/}');
    Expect(1, 983040, '\p{Present_In=:\A8.0\z:}', "");;
    Expect(0, 983037, '\p{Present_In=:\A8.0\z:}', "");;
    Expect(1, 983040, '\p{Present_In=0_0_0_0_0_08.0}', "");
    Expect(0, 983040, '\p{^Present_In=0_0_0_0_0_08.0}', "");
    Expect(0, 983040, '\P{Present_In=0_0_0_0_0_08.0}', "");
    Expect(1, 983040, '\P{^Present_In=0_0_0_0_0_08.0}', "");
    Expect(0, 983037, '\p{Present_In=0_0_0_0_0_08.0}', "");
    Expect(1, 983037, '\p{^Present_In=0_0_0_0_0_08.0}', "");
    Expect(1, 983037, '\P{Present_In=0_0_0_0_0_08.0}', "");
    Expect(0, 983037, '\P{^Present_In=0_0_0_0_0_08.0}', "");
    Error('\p{In=_/a/V8_0}');
    Error('\P{In=_/a/V8_0}');
    Expect(1, 983040, '\p{In=:\AV8_0\z:}', "");;
    Expect(0, 983037, '\p{In=:\AV8_0\z:}', "");;
    Expect(1, 983040, '\p{In=v80}', "");
    Expect(0, 983040, '\p{^In=v80}', "");
    Expect(0, 983040, '\P{In=v80}', "");
    Expect(1, 983040, '\P{^In=v80}', "");
    Expect(0, 983037, '\p{In=v80}', "");
    Expect(1, 983037, '\p{^In=v80}', "");
    Expect(1, 983037, '\P{In=v80}', "");
    Expect(0, 983037, '\P{^In=v80}', "");
    Expect(1, 983040, '\p{In=:\Av80\z:}', "");;
    Expect(0, 983037, '\p{In=:\Av80\z:}', "");;
    Expect(1, 983040, '\p{In=-V8_0}', "");
    Expect(0, 983040, '\p{^In=-V8_0}', "");
    Expect(0, 983040, '\P{In=-V8_0}', "");
    Expect(1, 983040, '\P{^In=-V8_0}', "");
    Expect(0, 983037, '\p{In=-V8_0}', "");
    Expect(1, 983037, '\p{^In=-V8_0}', "");
    Expect(1, 983037, '\P{In=-V8_0}', "");
    Expect(0, 983037, '\P{^In=-V8_0}', "");
    Error('\p{Is_Present_In=-00008.0/a/}');
    Error('\P{Is_Present_In=-00008.0/a/}');
    Expect(1, 983040, '\p{Is_Present_In=000_8.0}', "");
    Expect(0, 983040, '\p{^Is_Present_In=000_8.0}', "");
    Expect(0, 983040, '\P{Is_Present_In=000_8.0}', "");
    Expect(1, 983040, '\P{^Is_Present_In=000_8.0}', "");
    Expect(0, 983037, '\p{Is_Present_In=000_8.0}', "");
    Expect(1, 983037, '\p{^Is_Present_In=000_8.0}', "");
    Expect(1, 983037, '\P{Is_Present_In=000_8.0}', "");
    Expect(0, 983037, '\P{^Is_Present_In=000_8.0}', "");
    Error('\p{Is_In=-V8_0/a/}');
    Error('\P{Is_In=-V8_0/a/}');
    Expect(1, 983040, '\p{Is_In=v80}', "");
    Expect(0, 983040, '\p{^Is_In=v80}', "");
    Expect(0, 983040, '\P{Is_In=v80}', "");
    Expect(1, 983040, '\P{^Is_In=v80}', "");
    Expect(0, 983037, '\p{Is_In=v80}', "");
    Expect(1, 983037, '\p{^Is_In=v80}', "");
    Expect(1, 983037, '\P{Is_In=v80}', "");
    Expect(0, 983037, '\P{^Is_In=v80}', "");
    Expect(1, 983040, '\p{Is_In=-_V8_0}', "");
    Expect(0, 983040, '\p{^Is_In=-_V8_0}', "");
    Expect(0, 983040, '\P{Is_In=-_V8_0}', "");
    Expect(1, 983040, '\P{^Is_In=-_V8_0}', "");
    Expect(0, 983037, '\p{Is_In=-_V8_0}', "");
    Expect(1, 983037, '\p{^Is_In=-_V8_0}', "");
    Expect(1, 983037, '\P{Is_In=-_V8_0}', "");
    Expect(0, 983037, '\P{^Is_In=-_V8_0}', "");
    Error('\p{Present_In= -09.0/a/}');
    Error('\P{Present_In= -09.0/a/}');
    Expect(1, 983040, '\p{Present_In=:\A9.0\z:}', "");;
    Expect(0, 983037, '\p{Present_In=:\A9.0\z:}', "");;
    Expect(1, 983040, '\p{Present_In=+0_0_0_0_0_0_0_0_09.0}', "");
    Expect(0, 983040, '\p{^Present_In=+0_0_0_0_0_0_0_0_09.0}', "");
    Expect(0, 983040, '\P{Present_In=+0_0_0_0_0_0_0_0_09.0}', "");
    Expect(1, 983040, '\P{^Present_In=+0_0_0_0_0_0_0_0_09.0}', "");
    Expect(0, 983037, '\p{Present_In=+0_0_0_0_0_0_0_0_09.0}', "");
    Expect(1, 983037, '\p{^Present_In=+0_0_0_0_0_0_0_0_09.0}', "");
    Expect(1, 983037, '\P{Present_In=+0_0_0_0_0_0_0_0_09.0}', "");
    Expect(0, 983037, '\P{^Present_In=+0_0_0_0_0_0_0_0_09.0}', "");
    Error('\p{In=:=V9_0}');
    Error('\P{In=:=V9_0}');
    Expect(1, 983040, '\p{In=:\AV9_0\z:}', "");;
    Expect(0, 983037, '\p{In=:\AV9_0\z:}', "");;
    Expect(1, 983040, '\p{In=v90}', "");
    Expect(0, 983040, '\p{^In=v90}', "");
    Expect(0, 983040, '\P{In=v90}', "");
    Expect(1, 983040, '\P{^In=v90}', "");
    Expect(0, 983037, '\p{In=v90}', "");
    Expect(1, 983037, '\p{^In=v90}', "");
    Expect(1, 983037, '\P{In=v90}', "");
    Expect(0, 983037, '\P{^In=v90}', "");
    Expect(1, 983040, '\p{In=:\Av90\z:}', "");;
    Expect(0, 983037, '\p{In=:\Av90\z:}', "");;
    Expect(1, 983040, '\p{In= V9_0}', "");
    Expect(0, 983040, '\p{^In= V9_0}', "");
    Expect(0, 983040, '\P{In= V9_0}', "");
    Expect(1, 983040, '\P{^In= V9_0}', "");
    Expect(0, 983037, '\p{In= V9_0}', "");
    Expect(1, 983037, '\p{^In= V9_0}', "");
    Expect(1, 983037, '\P{In= V9_0}', "");
    Expect(0, 983037, '\P{^In= V9_0}', "");
    Error('\p{Is_Present_In:-:=9.0}');
    Error('\P{Is_Present_In:-:=9.0}');
    Expect(1, 983040, '\p{Is_Present_In=000009.0}', "");
    Expect(0, 983040, '\p{^Is_Present_In=000009.0}', "");
    Expect(0, 983040, '\P{Is_Present_In=000009.0}', "");
    Expect(1, 983040, '\P{^Is_Present_In=000009.0}', "");
    Expect(0, 983037, '\p{Is_Present_In=000009.0}', "");
    Expect(1, 983037, '\p{^Is_Present_In=000009.0}', "");
    Expect(1, 983037, '\P{Is_Present_In=000009.0}', "");
    Expect(0, 983037, '\P{^Is_Present_In=000009.0}', "");
    Error('\p{Is_In=	:=V9_0}');
    Error('\P{Is_In=	:=V9_0}');
    Expect(1, 983040, '\p{Is_In=v90}', "");
    Expect(0, 983040, '\p{^Is_In=v90}', "");
    Expect(0, 983040, '\P{Is_In=v90}', "");
    Expect(1, 983040, '\P{^Is_In=v90}', "");
    Expect(0, 983037, '\p{Is_In=v90}', "");
    Expect(1, 983037, '\p{^Is_In=v90}', "");
    Expect(1, 983037, '\P{Is_In=v90}', "");
    Expect(0, 983037, '\P{^Is_In=v90}', "");
    Expect(1, 983040, '\p{Is_In=	_V9_0}', "");
    Expect(0, 983040, '\p{^Is_In=	_V9_0}', "");
    Expect(0, 983040, '\P{Is_In=	_V9_0}', "");
    Expect(1, 983040, '\P{^Is_In=	_V9_0}', "");
    Expect(0, 983037, '\p{Is_In=	_V9_0}', "");
    Expect(1, 983037, '\p{^Is_In=	_V9_0}', "");
    Expect(1, 983037, '\P{Is_In=	_V9_0}', "");
    Expect(0, 983037, '\P{^Is_In=	_V9_0}', "");
    Error('\p{Present_In=	UNASSIGNED:=}');
    Error('\P{Present_In=	UNASSIGNED:=}');
    Expect(1, 983037, '\p{Present_In=:\AUnassigned\z:}', "");;
    Expect(0, 983040, '\p{Present_In=:\AUnassigned\z:}', "");;
    Expect(1, 983037, '\p{Present_In: unassigned}', "");
    Expect(0, 983037, '\p{^Present_In: unassigned}', "");
    Expect(0, 983037, '\P{Present_In: unassigned}', "");
    Expect(1, 983037, '\P{^Present_In: unassigned}', "");
    Expect(0, 983040, '\p{Present_In: unassigned}', "");
    Expect(1, 983040, '\p{^Present_In: unassigned}', "");
    Expect(1, 983040, '\P{Present_In: unassigned}', "");
    Expect(0, 983040, '\P{^Present_In: unassigned}', "");
    Expect(1, 983037, '\p{Present_In=:\Aunassigned\z:}', "");;
    Expect(0, 983040, '\p{Present_In=:\Aunassigned\z:}', "");;
    Expect(1, 983037, '\p{Present_In=--unassigned}', "");
    Expect(0, 983037, '\p{^Present_In=--unassigned}', "");
    Expect(0, 983037, '\P{Present_In=--unassigned}', "");
    Expect(1, 983037, '\P{^Present_In=--unassigned}', "");
    Expect(0, 983040, '\p{Present_In=--unassigned}', "");
    Expect(1, 983040, '\p{^Present_In=--unassigned}', "");
    Expect(1, 983040, '\P{Present_In=--unassigned}', "");
    Expect(0, 983040, '\P{^Present_In=--unassigned}', "");
    Error('\p{In=:= 	NA}');
    Error('\P{In=:= 	NA}');
    Expect(1, 983037, '\p{In=:\ANA\z:}', "");;
    Expect(0, 983040, '\p{In=:\ANA\z:}', "");;
    Expect(1, 983037, '\p{In=na}', "");
    Expect(0, 983037, '\p{^In=na}', "");
    Expect(0, 983037, '\P{In=na}', "");
    Expect(1, 983037, '\P{^In=na}', "");
    Expect(0, 983040, '\p{In=na}', "");
    Expect(1, 983040, '\p{^In=na}', "");
    Expect(1, 983040, '\P{In=na}', "");
    Expect(0, 983040, '\P{^In=na}', "");
    Expect(1, 983037, '\p{In=:\Ana\z:}', "");;
    Expect(0, 983040, '\p{In=:\Ana\z:}', "");;
    Expect(1, 983037, '\p{In=__na}', "");
    Expect(0, 983037, '\p{^In=__na}', "");
    Expect(0, 983037, '\P{In=__na}', "");
    Expect(1, 983037, '\P{^In=__na}', "");
    Expect(0, 983040, '\p{In=__na}', "");
    Expect(1, 983040, '\p{^In=__na}', "");
    Expect(1, 983040, '\P{In=__na}', "");
    Expect(0, 983040, '\P{^In=__na}', "");
    Error('\p{Is_Present_In:	_/a/Unassigned}');
    Error('\P{Is_Present_In:	_/a/Unassigned}');
    Expect(1, 983037, '\p{Is_Present_In:   unassigned}', "");
    Expect(0, 983037, '\p{^Is_Present_In:   unassigned}', "");
    Expect(0, 983037, '\P{Is_Present_In:   unassigned}', "");
    Expect(1, 983037, '\P{^Is_Present_In:   unassigned}', "");
    Expect(0, 983040, '\p{Is_Present_In:   unassigned}', "");
    Expect(1, 983040, '\p{^Is_Present_In:   unassigned}', "");
    Expect(1, 983040, '\P{Is_Present_In:   unassigned}', "");
    Expect(0, 983040, '\P{^Is_Present_In:   unassigned}', "");
    Expect(1, 983037, '\p{Is_Present_In=- UNASSIGNED}', "");
    Expect(0, 983037, '\p{^Is_Present_In=- UNASSIGNED}', "");
    Expect(0, 983037, '\P{Is_Present_In=- UNASSIGNED}', "");
    Expect(1, 983037, '\P{^Is_Present_In=- UNASSIGNED}', "");
    Expect(0, 983040, '\p{Is_Present_In=- UNASSIGNED}', "");
    Expect(1, 983040, '\p{^Is_Present_In=- UNASSIGNED}', "");
    Expect(1, 983040, '\P{Is_Present_In=- UNASSIGNED}', "");
    Expect(0, 983040, '\P{^Is_Present_In=- UNASSIGNED}', "");
    Error('\p{Is_In=_/a/NA}');
    Error('\P{Is_In=_/a/NA}');
    Expect(1, 983037, '\p{Is_In=na}', "");
    Expect(0, 983037, '\p{^Is_In=na}', "");
    Expect(0, 983037, '\P{Is_In=na}', "");
    Expect(1, 983037, '\P{^Is_In=na}', "");
    Expect(0, 983040, '\p{Is_In=na}', "");
    Expect(1, 983040, '\p{^Is_In=na}', "");
    Expect(1, 983040, '\P{Is_In=na}', "");
    Expect(0, 983040, '\P{^Is_In=na}', "");
    Expect(1, 983037, '\p{Is_In= na}', "");
    Expect(0, 983037, '\p{^Is_In= na}', "");
    Expect(0, 983037, '\P{Is_In= na}', "");
    Expect(1, 983037, '\P{^Is_In= na}', "");
    Expect(0, 983040, '\p{Is_In= na}', "");
    Expect(1, 983040, '\p{^Is_In= na}', "");
    Expect(1, 983040, '\P{Is_In= na}', "");
    Expect(0, 983040, '\P{^Is_In= na}', "");
    Error('\p{indicpositionalcategory}');
    Error('\P{indicpositionalcategory}');
    Error('\p{inpc}');
    Error('\P{inpc}');
    Error('\p{Indic_Positional_Category=/a/ -bottom}');
    Error('\P{Indic_Positional_Category=/a/ -bottom}');
    Expect(1, 73530, '\p{Indic_Positional_Category=:\ABottom\z:}', "");;
    Expect(0, 73531, '\p{Indic_Positional_Category=:\ABottom\z:}', "");;
    Expect(1, 73530, '\p{Indic_Positional_Category=bottom}', "");
    Expect(0, 73530, '\p{^Indic_Positional_Category=bottom}', "");
    Expect(0, 73530, '\P{Indic_Positional_Category=bottom}', "");
    Expect(1, 73530, '\P{^Indic_Positional_Category=bottom}', "");
    Expect(0, 73531, '\p{Indic_Positional_Category=bottom}', "");
    Expect(1, 73531, '\p{^Indic_Positional_Category=bottom}', "");
    Expect(1, 73531, '\P{Indic_Positional_Category=bottom}', "");
    Expect(0, 73531, '\P{^Indic_Positional_Category=bottom}', "");
    Expect(1, 73530, '\p{Indic_Positional_Category=:\Abottom\z:}', "");;
    Expect(0, 73531, '\p{Indic_Positional_Category=:\Abottom\z:}', "");;
    Expect(1, 73530, '\p{Indic_Positional_Category=_-Bottom}', "");
    Expect(0, 73530, '\p{^Indic_Positional_Category=_-Bottom}', "");
    Expect(0, 73530, '\P{Indic_Positional_Category=_-Bottom}', "");
    Expect(1, 73530, '\P{^Indic_Positional_Category=_-Bottom}', "");
    Expect(0, 73531, '\p{Indic_Positional_Category=_-Bottom}', "");
    Expect(1, 73531, '\p{^Indic_Positional_Category=_-Bottom}', "");
    Expect(1, 73531, '\P{Indic_Positional_Category=_-Bottom}', "");
    Expect(0, 73531, '\P{^Indic_Positional_Category=_-Bottom}', "");
    Error('\p{InPC=-	Bottom:=}');
    Error('\P{InPC=-	Bottom:=}');
    Expect(1, 73530, '\p{InPC=:\ABottom\z:}', "");;
    Expect(0, 73531, '\p{InPC=:\ABottom\z:}', "");;
    Expect(1, 73530, '\p{InPC=bottom}', "");
    Expect(0, 73530, '\p{^InPC=bottom}', "");
    Expect(0, 73530, '\P{InPC=bottom}', "");
    Expect(1, 73530, '\P{^InPC=bottom}', "");
    Expect(0, 73531, '\p{InPC=bottom}', "");
    Expect(1, 73531, '\p{^InPC=bottom}', "");
    Expect(1, 73531, '\P{InPC=bottom}', "");
    Expect(0, 73531, '\P{^InPC=bottom}', "");
    Expect(1, 73530, '\p{InPC=:\Abottom\z:}', "");;
    Expect(0, 73531, '\p{InPC=:\Abottom\z:}', "");;
    Expect(1, 73530, '\p{InPC=-	Bottom}', "");
    Expect(0, 73530, '\p{^InPC=-	Bottom}', "");
    Expect(0, 73530, '\P{InPC=-	Bottom}', "");
    Expect(1, 73530, '\P{^InPC=-	Bottom}', "");
    Expect(0, 73531, '\p{InPC=-	Bottom}', "");
    Expect(1, 73531, '\p{^InPC=-	Bottom}', "");
    Expect(1, 73531, '\P{InPC=-	Bottom}', "");
    Expect(0, 73531, '\P{^InPC=-	Bottom}', "");
    Error('\p{Is_Indic_Positional_Category=_ bottom:=}');
    Error('\P{Is_Indic_Positional_Category=_ bottom:=}');
    Expect(1, 73530, '\p{Is_Indic_Positional_Category=bottom}', "");
    Expect(0, 73530, '\p{^Is_Indic_Positional_Category=bottom}', "");
    Expect(0, 73530, '\P{Is_Indic_Positional_Category=bottom}', "");
    Expect(1, 73530, '\P{^Is_Indic_Positional_Category=bottom}', "");
    Expect(0, 73531, '\p{Is_Indic_Positional_Category=bottom}', "");
    Expect(1, 73531, '\p{^Is_Indic_Positional_Category=bottom}', "");
    Expect(1, 73531, '\P{Is_Indic_Positional_Category=bottom}', "");
    Expect(0, 73531, '\P{^Is_Indic_Positional_Category=bottom}', "");
    Expect(1, 73530, '\p{Is_Indic_Positional_Category=-	BOTTOM}', "");
    Expect(0, 73530, '\p{^Is_Indic_Positional_Category=-	BOTTOM}', "");
    Expect(0, 73530, '\P{Is_Indic_Positional_Category=-	BOTTOM}', "");
    Expect(1, 73530, '\P{^Is_Indic_Positional_Category=-	BOTTOM}', "");
    Expect(0, 73531, '\p{Is_Indic_Positional_Category=-	BOTTOM}', "");
    Expect(1, 73531, '\p{^Is_Indic_Positional_Category=-	BOTTOM}', "");
    Expect(1, 73531, '\P{Is_Indic_Positional_Category=-	BOTTOM}', "");
    Expect(0, 73531, '\P{^Is_Indic_Positional_Category=-	BOTTOM}', "");
    Error('\p{Is_InPC=-BOTTOM:=}');
    Error('\P{Is_InPC=-BOTTOM:=}');
    Expect(1, 73530, '\p{Is_InPC=bottom}', "");
    Expect(0, 73530, '\p{^Is_InPC=bottom}', "");
    Expect(0, 73530, '\P{Is_InPC=bottom}', "");
    Expect(1, 73530, '\P{^Is_InPC=bottom}', "");
    Expect(0, 73531, '\p{Is_InPC=bottom}', "");
    Expect(1, 73531, '\p{^Is_InPC=bottom}', "");
    Expect(1, 73531, '\P{Is_InPC=bottom}', "");
    Expect(0, 73531, '\P{^Is_InPC=bottom}', "");
    Expect(1, 73530, '\p{Is_InPC=_ bottom}', "");
    Expect(0, 73530, '\p{^Is_InPC=_ bottom}', "");
    Expect(0, 73530, '\P{Is_InPC=_ bottom}', "");
    Expect(1, 73530, '\P{^Is_InPC=_ bottom}', "");
    Expect(0, 73531, '\p{Is_InPC=_ bottom}', "");
    Expect(1, 73531, '\p{^Is_InPC=_ bottom}', "");
    Expect(1, 73531, '\P{Is_InPC=_ bottom}', "");
    Expect(0, 73531, '\P{^Is_InPC=_ bottom}', "");
    Error('\p{Indic_Positional_Category=:=_	Bottom_AND_Left}');
    Error('\P{Indic_Positional_Category=:=_	Bottom_AND_Left}');
    Expect(1, 43455, '\p{Indic_Positional_Category=:\ABottom_And_Left\z:}', "");;
    Expect(0, 43456, '\p{Indic_Positional_Category=:\ABottom_And_Left\z:}', "");;
    Expect(1, 43455, '\p{Indic_Positional_Category=bottomandleft}', "");
    Expect(0, 43455, '\p{^Indic_Positional_Category=bottomandleft}', "");
    Expect(0, 43455, '\P{Indic_Positional_Category=bottomandleft}', "");
    Expect(1, 43455, '\P{^Indic_Positional_Category=bottomandleft}', "");
    Expect(0, 43456, '\p{Indic_Positional_Category=bottomandleft}', "");
    Expect(1, 43456, '\p{^Indic_Positional_Category=bottomandleft}', "");
    Expect(1, 43456, '\P{Indic_Positional_Category=bottomandleft}', "");
    Expect(0, 43456, '\P{^Indic_Positional_Category=bottomandleft}', "");
    Expect(1, 43455, '\p{Indic_Positional_Category=:\Abottomandleft\z:}', "");;
    Expect(0, 43456, '\p{Indic_Positional_Category=:\Abottomandleft\z:}', "");;
    Expect(1, 43455, '\p{Indic_Positional_Category=_	Bottom_And_Left}', "");
    Expect(0, 43455, '\p{^Indic_Positional_Category=_	Bottom_And_Left}', "");
    Expect(0, 43455, '\P{Indic_Positional_Category=_	Bottom_And_Left}', "");
    Expect(1, 43455, '\P{^Indic_Positional_Category=_	Bottom_And_Left}', "");
    Expect(0, 43456, '\p{Indic_Positional_Category=_	Bottom_And_Left}', "");
    Expect(1, 43456, '\p{^Indic_Positional_Category=_	Bottom_And_Left}', "");
    Expect(1, 43456, '\P{Indic_Positional_Category=_	Bottom_And_Left}', "");
    Expect(0, 43456, '\P{^Indic_Positional_Category=_	Bottom_And_Left}', "");
    Error('\p{InPC=- BOTTOM_AND_LEFT:=}');
    Error('\P{InPC=- BOTTOM_AND_LEFT:=}');
    Expect(1, 43455, '\p{InPC=:\ABottom_And_Left\z:}', "");;
    Expect(0, 43456, '\p{InPC=:\ABottom_And_Left\z:}', "");;
    Expect(1, 43455, '\p{InPC=bottomandleft}', "");
    Expect(0, 43455, '\p{^InPC=bottomandleft}', "");
    Expect(0, 43455, '\P{InPC=bottomandleft}', "");
    Expect(1, 43455, '\P{^InPC=bottomandleft}', "");
    Expect(0, 43456, '\p{InPC=bottomandleft}', "");
    Expect(1, 43456, '\p{^InPC=bottomandleft}', "");
    Expect(1, 43456, '\P{InPC=bottomandleft}', "");
    Expect(0, 43456, '\P{^InPC=bottomandleft}', "");
    Expect(1, 43455, '\p{InPC=:\Abottomandleft\z:}', "");;
    Expect(0, 43456, '\p{InPC=:\Abottomandleft\z:}', "");;
    Expect(1, 43455, '\p{InPC:	_-Bottom_AND_LEFT}', "");
    Expect(0, 43455, '\p{^InPC:	_-Bottom_AND_LEFT}', "");
    Expect(0, 43455, '\P{InPC:	_-Bottom_AND_LEFT}', "");
    Expect(1, 43455, '\P{^InPC:	_-Bottom_AND_LEFT}', "");
    Expect(0, 43456, '\p{InPC:	_-Bottom_AND_LEFT}', "");
    Expect(1, 43456, '\p{^InPC:	_-Bottom_AND_LEFT}', "");
    Expect(1, 43456, '\P{InPC:	_-Bottom_AND_LEFT}', "");
    Expect(0, 43456, '\P{^InPC:	_-Bottom_AND_LEFT}', "");
    Error('\p{Is_Indic_Positional_Category=/a/_bottom_and_Left}');
    Error('\P{Is_Indic_Positional_Category=/a/_bottom_and_Left}');
    Expect(1, 43455, '\p{Is_Indic_Positional_Category=bottomandleft}', "");
    Expect(0, 43455, '\p{^Is_Indic_Positional_Category=bottomandleft}', "");
    Expect(0, 43455, '\P{Is_Indic_Positional_Category=bottomandleft}', "");
    Expect(1, 43455, '\P{^Is_Indic_Positional_Category=bottomandleft}', "");
    Expect(0, 43456, '\p{Is_Indic_Positional_Category=bottomandleft}', "");
    Expect(1, 43456, '\p{^Is_Indic_Positional_Category=bottomandleft}', "");
    Expect(1, 43456, '\P{Is_Indic_Positional_Category=bottomandleft}', "");
    Expect(0, 43456, '\P{^Is_Indic_Positional_Category=bottomandleft}', "");
    Expect(1, 43455, '\p{Is_Indic_Positional_Category=-_bottom_and_left}', "");
    Expect(0, 43455, '\p{^Is_Indic_Positional_Category=-_bottom_and_left}', "");
    Expect(0, 43455, '\P{Is_Indic_Positional_Category=-_bottom_and_left}', "");
    Expect(1, 43455, '\P{^Is_Indic_Positional_Category=-_bottom_and_left}', "");
    Expect(0, 43456, '\p{Is_Indic_Positional_Category=-_bottom_and_left}', "");
    Expect(1, 43456, '\p{^Is_Indic_Positional_Category=-_bottom_and_left}', "");
    Expect(1, 43456, '\P{Is_Indic_Positional_Category=-_bottom_and_left}', "");
    Expect(0, 43456, '\P{^Is_Indic_Positional_Category=-_bottom_and_left}', "");
    Error('\p{Is_InPC=:=_-Bottom_and_Left}');
    Error('\P{Is_InPC=:=_-Bottom_and_Left}');
    Expect(1, 43455, '\p{Is_InPC:	bottomandleft}', "");
    Expect(0, 43455, '\p{^Is_InPC:	bottomandleft}', "");
    Expect(0, 43455, '\P{Is_InPC:	bottomandleft}', "");
    Expect(1, 43455, '\P{^Is_InPC:	bottomandleft}', "");
    Expect(0, 43456, '\p{Is_InPC:	bottomandleft}', "");
    Expect(1, 43456, '\p{^Is_InPC:	bottomandleft}', "");
    Expect(1, 43456, '\P{Is_InPC:	bottomandleft}', "");
    Expect(0, 43456, '\P{^Is_InPC:	bottomandleft}', "");
    Expect(1, 43455, '\p{Is_InPC=- BOTTOM_And_Left}', "");
    Expect(0, 43455, '\p{^Is_InPC=- BOTTOM_And_Left}', "");
    Expect(0, 43455, '\P{Is_InPC=- BOTTOM_And_Left}', "");
    Expect(1, 43455, '\P{^Is_InPC=- BOTTOM_And_Left}', "");
    Expect(0, 43456, '\p{Is_InPC=- BOTTOM_And_Left}', "");
    Expect(1, 43456, '\p{^Is_InPC=- BOTTOM_And_Left}', "");
    Expect(1, 43456, '\P{Is_InPC=- BOTTOM_And_Left}', "");
    Expect(0, 43456, '\P{^Is_InPC=- BOTTOM_And_Left}', "");
    Error('\p{Indic_Positional_Category=	 BOTTOM_and_Right:=}');
    Error('\P{Indic_Positional_Category=	 BOTTOM_and_Right:=}');
    Expect(1, 72002, '\p{Indic_Positional_Category=:\ABottom_And_Right\z:}', "");;
    Expect(0, 72003, '\p{Indic_Positional_Category=:\ABottom_And_Right\z:}', "");;
    Expect(1, 72002, '\p{Indic_Positional_Category=bottomandright}', "");
    Expect(0, 72002, '\p{^Indic_Positional_Category=bottomandright}', "");
    Expect(0, 72002, '\P{Indic_Positional_Category=bottomandright}', "");
    Expect(1, 72002, '\P{^Indic_Positional_Category=bottomandright}', "");
    Expect(0, 72003, '\p{Indic_Positional_Category=bottomandright}', "");
    Expect(1, 72003, '\p{^Indic_Positional_Category=bottomandright}', "");
    Expect(1, 72003, '\P{Indic_Positional_Category=bottomandright}', "");
    Expect(0, 72003, '\P{^Indic_Positional_Category=bottomandright}', "");
    Expect(1, 72002, '\p{Indic_Positional_Category=:\Abottomandright\z:}', "");;
    Expect(0, 72003, '\p{Indic_Positional_Category=:\Abottomandright\z:}', "");;
    Expect(1, 72002, '\p{Indic_Positional_Category=  Bottom_And_Right}', "");
    Expect(0, 72002, '\p{^Indic_Positional_Category=  Bottom_And_Right}', "");
    Expect(0, 72002, '\P{Indic_Positional_Category=  Bottom_And_Right}', "");
    Expect(1, 72002, '\P{^Indic_Positional_Category=  Bottom_And_Right}', "");
    Expect(0, 72003, '\p{Indic_Positional_Category=  Bottom_And_Right}', "");
    Expect(1, 72003, '\p{^Indic_Positional_Category=  Bottom_And_Right}', "");
    Expect(1, 72003, '\P{Indic_Positional_Category=  Bottom_And_Right}', "");
    Expect(0, 72003, '\P{^Indic_Positional_Category=  Bottom_And_Right}', "");
    Error('\p{InPC= 	bottom_AND_right/a/}');
    Error('\P{InPC= 	bottom_AND_right/a/}');
    Expect(1, 72002, '\p{InPC=:\ABottom_And_Right\z:}', "");;
    Expect(0, 72003, '\p{InPC=:\ABottom_And_Right\z:}', "");;
    Expect(1, 72002, '\p{InPC=bottomandright}', "");
    Expect(0, 72002, '\p{^InPC=bottomandright}', "");
    Expect(0, 72002, '\P{InPC=bottomandright}', "");
    Expect(1, 72002, '\P{^InPC=bottomandright}', "");
    Expect(0, 72003, '\p{InPC=bottomandright}', "");
    Expect(1, 72003, '\p{^InPC=bottomandright}', "");
    Expect(1, 72003, '\P{InPC=bottomandright}', "");
    Expect(0, 72003, '\P{^InPC=bottomandright}', "");
    Expect(1, 72002, '\p{InPC=:\Abottomandright\z:}', "");;
    Expect(0, 72003, '\p{InPC=:\Abottomandright\z:}', "");;
    Expect(1, 72002, '\p{InPC= _Bottom_AND_Right}', "");
    Expect(0, 72002, '\p{^InPC= _Bottom_AND_Right}', "");
    Expect(0, 72002, '\P{InPC= _Bottom_AND_Right}', "");
    Expect(1, 72002, '\P{^InPC= _Bottom_AND_Right}', "");
    Expect(0, 72003, '\p{InPC= _Bottom_AND_Right}', "");
    Expect(1, 72003, '\p{^InPC= _Bottom_AND_Right}', "");
    Expect(1, 72003, '\P{InPC= _Bottom_AND_Right}', "");
    Expect(0, 72003, '\P{^InPC= _Bottom_AND_Right}', "");
    Error('\p{Is_Indic_Positional_Category:-_Bottom_And_RIGHT:=}');
    Error('\P{Is_Indic_Positional_Category:-_Bottom_And_RIGHT:=}');
    Expect(1, 72002, '\p{Is_Indic_Positional_Category=bottomandright}', "");
    Expect(0, 72002, '\p{^Is_Indic_Positional_Category=bottomandright}', "");
    Expect(0, 72002, '\P{Is_Indic_Positional_Category=bottomandright}', "");
    Expect(1, 72002, '\P{^Is_Indic_Positional_Category=bottomandright}', "");
    Expect(0, 72003, '\p{Is_Indic_Positional_Category=bottomandright}', "");
    Expect(1, 72003, '\p{^Is_Indic_Positional_Category=bottomandright}', "");
    Expect(1, 72003, '\P{Is_Indic_Positional_Category=bottomandright}', "");
    Expect(0, 72003, '\P{^Is_Indic_Positional_Category=bottomandright}', "");
    Expect(1, 72002, '\p{Is_Indic_Positional_Category:	-bottom_AND_Right}', "");
    Expect(0, 72002, '\p{^Is_Indic_Positional_Category:	-bottom_AND_Right}', "");
    Expect(0, 72002, '\P{Is_Indic_Positional_Category:	-bottom_AND_Right}', "");
    Expect(1, 72002, '\P{^Is_Indic_Positional_Category:	-bottom_AND_Right}', "");
    Expect(0, 72003, '\p{Is_Indic_Positional_Category:	-bottom_AND_Right}', "");
    Expect(1, 72003, '\p{^Is_Indic_Positional_Category:	-bottom_AND_Right}', "");
    Expect(1, 72003, '\P{Is_Indic_Positional_Category:	-bottom_AND_Right}', "");
    Expect(0, 72003, '\P{^Is_Indic_Positional_Category:	-bottom_AND_Right}', "");
    Error('\p{Is_InPC=	_Bottom_And_Right/a/}');
    Error('\P{Is_InPC=	_Bottom_And_Right/a/}');
    Expect(1, 72002, '\p{Is_InPC=bottomandright}', "");
    Expect(0, 72002, '\p{^Is_InPC=bottomandright}', "");
    Expect(0, 72002, '\P{Is_InPC=bottomandright}', "");
    Expect(1, 72002, '\P{^Is_InPC=bottomandright}', "");
    Expect(0, 72003, '\p{Is_InPC=bottomandright}', "");
    Expect(1, 72003, '\p{^Is_InPC=bottomandright}', "");
    Expect(1, 72003, '\P{Is_InPC=bottomandright}', "");
    Expect(0, 72003, '\P{^Is_InPC=bottomandright}', "");
    Expect(1, 72002, '\p{Is_InPC=_Bottom_AND_Right}', "");
    Expect(0, 72002, '\p{^Is_InPC=_Bottom_AND_Right}', "");
    Expect(0, 72002, '\P{Is_InPC=_Bottom_AND_Right}', "");
    Expect(1, 72002, '\P{^Is_InPC=_Bottom_AND_Right}', "");
    Expect(0, 72003, '\p{Is_InPC=_Bottom_AND_Right}', "");
    Expect(1, 72003, '\p{^Is_InPC=_Bottom_AND_Right}', "");
    Expect(1, 72003, '\P{Is_InPC=_Bottom_AND_Right}', "");
    Expect(0, 72003, '\P{^Is_InPC=_Bottom_AND_Right}', "");
    Error('\p{Indic_Positional_Category=:= -Left}');
    Error('\P{Indic_Positional_Category=:= -Left}');
    Expect(1, 73535, '\p{Indic_Positional_Category=:\ALeft\z:}', "");;
    Expect(0, 73536, '\p{Indic_Positional_Category=:\ALeft\z:}', "");;
    Expect(1, 73535, '\p{Indic_Positional_Category=left}', "");
    Expect(0, 73535, '\p{^Indic_Positional_Category=left}', "");
    Expect(0, 73535, '\P{Indic_Positional_Category=left}', "");
    Expect(1, 73535, '\P{^Indic_Positional_Category=left}', "");
    Expect(0, 73536, '\p{Indic_Positional_Category=left}', "");
    Expect(1, 73536, '\p{^Indic_Positional_Category=left}', "");
    Expect(1, 73536, '\P{Indic_Positional_Category=left}', "");
    Expect(0, 73536, '\P{^Indic_Positional_Category=left}', "");
    Expect(1, 73535, '\p{Indic_Positional_Category=:\Aleft\z:}', "");;
    Expect(0, 73536, '\p{Indic_Positional_Category=:\Aleft\z:}', "");;
    Expect(1, 73535, '\p{Indic_Positional_Category= 	Left}', "");
    Expect(0, 73535, '\p{^Indic_Positional_Category= 	Left}', "");
    Expect(0, 73535, '\P{Indic_Positional_Category= 	Left}', "");
    Expect(1, 73535, '\P{^Indic_Positional_Category= 	Left}', "");
    Expect(0, 73536, '\p{Indic_Positional_Category= 	Left}', "");
    Expect(1, 73536, '\p{^Indic_Positional_Category= 	Left}', "");
    Expect(1, 73536, '\P{Indic_Positional_Category= 	Left}', "");
    Expect(0, 73536, '\P{^Indic_Positional_Category= 	Left}', "");
    Error('\p{InPC=/a/-left}');
    Error('\P{InPC=/a/-left}');
    Expect(1, 73535, '\p{InPC=:\ALeft\z:}', "");;
    Expect(0, 73536, '\p{InPC=:\ALeft\z:}', "");;
    Expect(1, 73535, '\p{InPC=left}', "");
    Expect(0, 73535, '\p{^InPC=left}', "");
    Expect(0, 73535, '\P{InPC=left}', "");
    Expect(1, 73535, '\P{^InPC=left}', "");
    Expect(0, 73536, '\p{InPC=left}', "");
    Expect(1, 73536, '\p{^InPC=left}', "");
    Expect(1, 73536, '\P{InPC=left}', "");
    Expect(0, 73536, '\P{^InPC=left}', "");
    Expect(1, 73535, '\p{InPC=:\Aleft\z:}', "");;
    Expect(0, 73536, '\p{InPC=:\Aleft\z:}', "");;
    Expect(1, 73535, '\p{InPC=	LEFT}', "");
    Expect(0, 73535, '\p{^InPC=	LEFT}', "");
    Expect(0, 73535, '\P{InPC=	LEFT}', "");
    Expect(1, 73535, '\P{^InPC=	LEFT}', "");
    Expect(0, 73536, '\p{InPC=	LEFT}', "");
    Expect(1, 73536, '\p{^InPC=	LEFT}', "");
    Expect(1, 73536, '\P{InPC=	LEFT}', "");
    Expect(0, 73536, '\P{^InPC=	LEFT}', "");
    Error('\p{Is_Indic_Positional_Category=:= Left}');
    Error('\P{Is_Indic_Positional_Category=:= Left}');
    Expect(1, 73535, '\p{Is_Indic_Positional_Category=left}', "");
    Expect(0, 73535, '\p{^Is_Indic_Positional_Category=left}', "");
    Expect(0, 73535, '\P{Is_Indic_Positional_Category=left}', "");
    Expect(1, 73535, '\P{^Is_Indic_Positional_Category=left}', "");
    Expect(0, 73536, '\p{Is_Indic_Positional_Category=left}', "");
    Expect(1, 73536, '\p{^Is_Indic_Positional_Category=left}', "");
    Expect(1, 73536, '\P{Is_Indic_Positional_Category=left}', "");
    Expect(0, 73536, '\P{^Is_Indic_Positional_Category=left}', "");
    Expect(1, 73535, '\p{Is_Indic_Positional_Category= 	Left}', "");
    Expect(0, 73535, '\p{^Is_Indic_Positional_Category= 	Left}', "");
    Expect(0, 73535, '\P{Is_Indic_Positional_Category= 	Left}', "");
    Expect(1, 73535, '\P{^Is_Indic_Positional_Category= 	Left}', "");
    Expect(0, 73536, '\p{Is_Indic_Positional_Category= 	Left}', "");
    Expect(1, 73536, '\p{^Is_Indic_Positional_Category= 	Left}', "");
    Expect(1, 73536, '\P{Is_Indic_Positional_Category= 	Left}', "");
    Expect(0, 73536, '\P{^Is_Indic_Positional_Category= 	Left}', "");
    Error('\p{Is_InPC=	 LEFT/a/}');
    Error('\P{Is_InPC=	 LEFT/a/}');
    Expect(1, 73535, '\p{Is_InPC=left}', "");
    Expect(0, 73535, '\p{^Is_InPC=left}', "");
    Expect(0, 73535, '\P{Is_InPC=left}', "");
    Expect(1, 73535, '\P{^Is_InPC=left}', "");
    Expect(0, 73536, '\p{Is_InPC=left}', "");
    Expect(1, 73536, '\p{^Is_InPC=left}', "");
    Expect(1, 73536, '\P{Is_InPC=left}', "");
    Expect(0, 73536, '\P{^Is_InPC=left}', "");
    Expect(1, 73535, '\p{Is_InPC:   	Left}', "");
    Expect(0, 73535, '\p{^Is_InPC:   	Left}', "");
    Expect(0, 73535, '\P{Is_InPC:   	Left}', "");
    Expect(1, 73535, '\P{^Is_InPC:   	Left}', "");
    Expect(0, 73536, '\p{Is_InPC:   	Left}', "");
    Expect(1, 73536, '\p{^Is_InPC:   	Left}', "");
    Expect(1, 73536, '\P{Is_InPC:   	Left}', "");
    Expect(0, 73536, '\P{^Is_InPC:   	Left}', "");
    Error('\p{Indic_Positional_Category=-/a/LEFT_and_Right}');
    Error('\P{Indic_Positional_Category=-/a/LEFT_and_Right}');
    Expect(1, 71992, '\p{Indic_Positional_Category=:\ALeft_And_Right\z:}', "");;
    Expect(0, 71993, '\p{Indic_Positional_Category=:\ALeft_And_Right\z:}', "");;
    Expect(1, 71992, '\p{Indic_Positional_Category=leftandright}', "");
    Expect(0, 71992, '\p{^Indic_Positional_Category=leftandright}', "");
    Expect(0, 71992, '\P{Indic_Positional_Category=leftandright}', "");
    Expect(1, 71992, '\P{^Indic_Positional_Category=leftandright}', "");
    Expect(0, 71993, '\p{Indic_Positional_Category=leftandright}', "");
    Expect(1, 71993, '\p{^Indic_Positional_Category=leftandright}', "");
    Expect(1, 71993, '\P{Indic_Positional_Category=leftandright}', "");
    Expect(0, 71993, '\P{^Indic_Positional_Category=leftandright}', "");
    Expect(1, 71992, '\p{Indic_Positional_Category=:\Aleftandright\z:}', "");;
    Expect(0, 71993, '\p{Indic_Positional_Category=:\Aleftandright\z:}', "");;
    Expect(1, 71992, '\p{Indic_Positional_Category=left_AND_RIGHT}', "");
    Expect(0, 71992, '\p{^Indic_Positional_Category=left_AND_RIGHT}', "");
    Expect(0, 71992, '\P{Indic_Positional_Category=left_AND_RIGHT}', "");
    Expect(1, 71992, '\P{^Indic_Positional_Category=left_AND_RIGHT}', "");
    Expect(0, 71993, '\p{Indic_Positional_Category=left_AND_RIGHT}', "");
    Expect(1, 71993, '\p{^Indic_Positional_Category=left_AND_RIGHT}', "");
    Expect(1, 71993, '\P{Indic_Positional_Category=left_AND_RIGHT}', "");
    Expect(0, 71993, '\P{^Indic_Positional_Category=left_AND_RIGHT}', "");
    Error('\p{InPC:	/a/	-LEFT_and_RIGHT}');
    Error('\P{InPC:	/a/	-LEFT_and_RIGHT}');
    Expect(1, 71992, '\p{InPC=:\ALeft_And_Right\z:}', "");;
    Expect(0, 71993, '\p{InPC=:\ALeft_And_Right\z:}', "");;
    Expect(1, 71992, '\p{InPC=leftandright}', "");
    Expect(0, 71992, '\p{^InPC=leftandright}', "");
    Expect(0, 71992, '\P{InPC=leftandright}', "");
    Expect(1, 71992, '\P{^InPC=leftandright}', "");
    Expect(0, 71993, '\p{InPC=leftandright}', "");
    Expect(1, 71993, '\p{^InPC=leftandright}', "");
    Expect(1, 71993, '\P{InPC=leftandright}', "");
    Expect(0, 71993, '\P{^InPC=leftandright}', "");
    Expect(1, 71992, '\p{InPC=:\Aleftandright\z:}', "");;
    Expect(0, 71993, '\p{InPC=:\Aleftandright\z:}', "");;
    Expect(1, 71992, '\p{InPC:  LEFT_AND_Right}', "");
    Expect(0, 71992, '\p{^InPC:  LEFT_AND_Right}', "");
    Expect(0, 71992, '\P{InPC:  LEFT_AND_Right}', "");
    Expect(1, 71992, '\P{^InPC:  LEFT_AND_Right}', "");
    Expect(0, 71993, '\p{InPC:  LEFT_AND_Right}', "");
    Expect(1, 71993, '\p{^InPC:  LEFT_AND_Right}', "");
    Expect(1, 71993, '\P{InPC:  LEFT_AND_Right}', "");
    Expect(0, 71993, '\P{^InPC:  LEFT_AND_Right}', "");
    Error('\p{Is_Indic_Positional_Category=  Left_And_Right:=}');
    Error('\P{Is_Indic_Positional_Category=  Left_And_Right:=}');
    Expect(1, 71992, '\p{Is_Indic_Positional_Category=leftandright}', "");
    Expect(0, 71992, '\p{^Is_Indic_Positional_Category=leftandright}', "");
    Expect(0, 71992, '\P{Is_Indic_Positional_Category=leftandright}', "");
    Expect(1, 71992, '\P{^Is_Indic_Positional_Category=leftandright}', "");
    Expect(0, 71993, '\p{Is_Indic_Positional_Category=leftandright}', "");
    Expect(1, 71993, '\p{^Is_Indic_Positional_Category=leftandright}', "");
    Expect(1, 71993, '\P{Is_Indic_Positional_Category=leftandright}', "");
    Expect(0, 71993, '\P{^Is_Indic_Positional_Category=leftandright}', "");
    Expect(1, 71992, '\p{Is_Indic_Positional_Category= Left_and_RIGHT}', "");
    Expect(0, 71992, '\p{^Is_Indic_Positional_Category= Left_and_RIGHT}', "");
    Expect(0, 71992, '\P{Is_Indic_Positional_Category= Left_and_RIGHT}', "");
    Expect(1, 71992, '\P{^Is_Indic_Positional_Category= Left_and_RIGHT}', "");
    Expect(0, 71993, '\p{Is_Indic_Positional_Category= Left_and_RIGHT}', "");
    Expect(1, 71993, '\p{^Is_Indic_Positional_Category= Left_and_RIGHT}', "");
    Expect(1, 71993, '\P{Is_Indic_Positional_Category= Left_and_RIGHT}', "");
    Expect(0, 71993, '\P{^Is_Indic_Positional_Category= Left_and_RIGHT}', "");
    Error('\p{Is_InPC=/a/_LEFT_and_Right}');
    Error('\P{Is_InPC=/a/_LEFT_and_Right}');
    Expect(1, 71992, '\p{Is_InPC=leftandright}', "");
    Expect(0, 71992, '\p{^Is_InPC=leftandright}', "");
    Expect(0, 71992, '\P{Is_InPC=leftandright}', "");
    Expect(1, 71992, '\P{^Is_InPC=leftandright}', "");
    Expect(0, 71993, '\p{Is_InPC=leftandright}', "");
    Expect(1, 71993, '\p{^Is_InPC=leftandright}', "");
    Expect(1, 71993, '\P{Is_InPC=leftandright}', "");
    Expect(0, 71993, '\P{^Is_InPC=leftandright}', "");
    Expect(1, 71992, '\p{Is_InPC=	Left_AND_Right}', "");
    Expect(0, 71992, '\p{^Is_InPC=	Left_AND_Right}', "");
    Expect(0, 71992, '\P{Is_InPC=	Left_AND_Right}', "");
    Expect(1, 71992, '\P{^Is_InPC=	Left_AND_Right}', "");
    Expect(0, 71993, '\p{Is_InPC=	Left_AND_Right}', "");
    Expect(1, 71993, '\p{^Is_InPC=	Left_AND_Right}', "");
    Expect(1, 71993, '\P{Is_InPC=	Left_AND_Right}', "");
    Expect(0, 71993, '\P{^Is_InPC=	Left_AND_Right}', "");
    Error('\p{Indic_Positional_Category=/a/ -na}');
    Error('\P{Indic_Positional_Category=/a/ -na}');
    Expect(1, 73538, '\p{Indic_Positional_Category=:\ANA\z:}', "");;
    Expect(0, 73537, '\p{Indic_Positional_Category=:\ANA\z:}', "");;
    Expect(1, 73538, '\p{Indic_Positional_Category=na}', "");
    Expect(0, 73538, '\p{^Indic_Positional_Category=na}', "");
    Expect(0, 73538, '\P{Indic_Positional_Category=na}', "");
    Expect(1, 73538, '\P{^Indic_Positional_Category=na}', "");
    Expect(0, 73537, '\p{Indic_Positional_Category=na}', "");
    Expect(1, 73537, '\p{^Indic_Positional_Category=na}', "");
    Expect(1, 73537, '\P{Indic_Positional_Category=na}', "");
    Expect(0, 73537, '\P{^Indic_Positional_Category=na}', "");
    Expect(1, 73538, '\p{Indic_Positional_Category=:\Ana\z:}', "");;
    Expect(0, 73537, '\p{Indic_Positional_Category=:\Ana\z:}', "");;
    Expect(1, 73538, '\p{Indic_Positional_Category:   _	NA}', "");
    Expect(0, 73538, '\p{^Indic_Positional_Category:   _	NA}', "");
    Expect(0, 73538, '\P{Indic_Positional_Category:   _	NA}', "");
    Expect(1, 73538, '\P{^Indic_Positional_Category:   _	NA}', "");
    Expect(0, 73537, '\p{Indic_Positional_Category:   _	NA}', "");
    Expect(1, 73537, '\p{^Indic_Positional_Category:   _	NA}', "");
    Expect(1, 73537, '\P{Indic_Positional_Category:   _	NA}', "");
    Expect(0, 73537, '\P{^Indic_Positional_Category:   _	NA}', "");
    Error('\p{InPC:  /a/NA}');
    Error('\P{InPC:  /a/NA}');
    Expect(1, 73538, '\p{InPC=:\ANA\z:}', "");;
    Expect(0, 73537, '\p{InPC=:\ANA\z:}', "");;
    Expect(1, 73538, '\p{InPC:na}', "");
    Expect(0, 73538, '\p{^InPC:na}', "");
    Expect(0, 73538, '\P{InPC:na}', "");
    Expect(1, 73538, '\P{^InPC:na}', "");
    Expect(0, 73537, '\p{InPC:na}', "");
    Expect(1, 73537, '\p{^InPC:na}', "");
    Expect(1, 73537, '\P{InPC:na}', "");
    Expect(0, 73537, '\P{^InPC:na}', "");
    Expect(1, 73538, '\p{InPC=:\Ana\z:}', "");;
    Expect(0, 73537, '\p{InPC=:\Ana\z:}', "");;
    Expect(1, 73538, '\p{InPC:-	na}', "");
    Expect(0, 73538, '\p{^InPC:-	na}', "");
    Expect(0, 73538, '\P{InPC:-	na}', "");
    Expect(1, 73538, '\P{^InPC:-	na}', "");
    Expect(0, 73537, '\p{InPC:-	na}', "");
    Expect(1, 73537, '\p{^InPC:-	na}', "");
    Expect(1, 73537, '\P{InPC:-	na}', "");
    Expect(0, 73537, '\P{^InPC:-	na}', "");
    Error('\p{Is_Indic_Positional_Category= -na/a/}');
    Error('\P{Is_Indic_Positional_Category= -na/a/}');
    Expect(1, 73538, '\p{Is_Indic_Positional_Category=na}', "");
    Expect(0, 73538, '\p{^Is_Indic_Positional_Category=na}', "");
    Expect(0, 73538, '\P{Is_Indic_Positional_Category=na}', "");
    Expect(1, 73538, '\P{^Is_Indic_Positional_Category=na}', "");
    Expect(0, 73537, '\p{Is_Indic_Positional_Category=na}', "");
    Expect(1, 73537, '\p{^Is_Indic_Positional_Category=na}', "");
    Expect(1, 73537, '\P{Is_Indic_Positional_Category=na}', "");
    Expect(0, 73537, '\P{^Is_Indic_Positional_Category=na}', "");
    Expect(1, 73538, '\p{Is_Indic_Positional_Category=  NA}', "");
    Expect(0, 73538, '\p{^Is_Indic_Positional_Category=  NA}', "");
    Expect(0, 73538, '\P{Is_Indic_Positional_Category=  NA}', "");
    Expect(1, 73538, '\P{^Is_Indic_Positional_Category=  NA}', "");
    Expect(0, 73537, '\p{Is_Indic_Positional_Category=  NA}', "");
    Expect(1, 73537, '\p{^Is_Indic_Positional_Category=  NA}', "");
    Expect(1, 73537, '\P{Is_Indic_Positional_Category=  NA}', "");
    Expect(0, 73537, '\P{^Is_Indic_Positional_Category=  NA}', "");
    Error('\p{Is_InPC=	 NA:=}');
    Error('\P{Is_InPC=	 NA:=}');
    Expect(1, 73538, '\p{Is_InPC:   na}', "");
    Expect(0, 73538, '\p{^Is_InPC:   na}', "");
    Expect(0, 73538, '\P{Is_InPC:   na}', "");
    Expect(1, 73538, '\P{^Is_InPC:   na}', "");
    Expect(0, 73537, '\p{Is_InPC:   na}', "");
    Expect(1, 73537, '\p{^Is_InPC:   na}', "");
    Expect(1, 73537, '\P{Is_InPC:   na}', "");
    Expect(0, 73537, '\P{^Is_InPC:   na}', "");
    Expect(1, 73538, '\p{Is_InPC:   - na}', "");
    Expect(0, 73538, '\p{^Is_InPC:   - na}', "");
    Expect(0, 73538, '\P{Is_InPC:   - na}', "");
    Expect(1, 73538, '\P{^Is_InPC:   - na}', "");
    Expect(0, 73537, '\p{Is_InPC:   - na}', "");
    Expect(1, 73537, '\p{^Is_InPC:   - na}', "");
    Expect(1, 73537, '\P{Is_InPC:   - na}', "");
    Expect(0, 73537, '\P{^Is_InPC:   - na}', "");
    Error('\p{Indic_Positional_Category=- overstruck:=}');
    Error('\P{Indic_Positional_Category=- overstruck:=}');
    Expect(1, 68102, '\p{Indic_Positional_Category=:\AOverstruck\z:}', "");;
    Expect(0, 68103, '\p{Indic_Positional_Category=:\AOverstruck\z:}', "");;
    Expect(1, 68102, '\p{Indic_Positional_Category=overstruck}', "");
    Expect(0, 68102, '\p{^Indic_Positional_Category=overstruck}', "");
    Expect(0, 68102, '\P{Indic_Positional_Category=overstruck}', "");
    Expect(1, 68102, '\P{^Indic_Positional_Category=overstruck}', "");
    Expect(0, 68103, '\p{Indic_Positional_Category=overstruck}', "");
    Expect(1, 68103, '\p{^Indic_Positional_Category=overstruck}', "");
    Expect(1, 68103, '\P{Indic_Positional_Category=overstruck}', "");
    Expect(0, 68103, '\P{^Indic_Positional_Category=overstruck}', "");
    Expect(1, 68102, '\p{Indic_Positional_Category=:\Aoverstruck\z:}', "");;
    Expect(0, 68103, '\p{Indic_Positional_Category=:\Aoverstruck\z:}', "");;
    Expect(1, 68102, '\p{Indic_Positional_Category=	-Overstruck}', "");
    Expect(0, 68102, '\p{^Indic_Positional_Category=	-Overstruck}', "");
    Expect(0, 68102, '\P{Indic_Positional_Category=	-Overstruck}', "");
    Expect(1, 68102, '\P{^Indic_Positional_Category=	-Overstruck}', "");
    Expect(0, 68103, '\p{Indic_Positional_Category=	-Overstruck}', "");
    Expect(1, 68103, '\p{^Indic_Positional_Category=	-Overstruck}', "");
    Expect(1, 68103, '\P{Indic_Positional_Category=	-Overstruck}', "");
    Expect(0, 68103, '\P{^Indic_Positional_Category=	-Overstruck}', "");
    Error('\p{InPC:	 :=overstruck}');
    Error('\P{InPC:	 :=overstruck}');
    Expect(1, 68102, '\p{InPC=:\AOverstruck\z:}', "");;
    Expect(0, 68103, '\p{InPC=:\AOverstruck\z:}', "");;
    Expect(1, 68102, '\p{InPC=overstruck}', "");
    Expect(0, 68102, '\p{^InPC=overstruck}', "");
    Expect(0, 68102, '\P{InPC=overstruck}', "");
    Expect(1, 68102, '\P{^InPC=overstruck}', "");
    Expect(0, 68103, '\p{InPC=overstruck}', "");
    Expect(1, 68103, '\p{^InPC=overstruck}', "");
    Expect(1, 68103, '\P{InPC=overstruck}', "");
    Expect(0, 68103, '\P{^InPC=overstruck}', "");
    Expect(1, 68102, '\p{InPC=:\Aoverstruck\z:}', "");;
    Expect(0, 68103, '\p{InPC=:\Aoverstruck\z:}', "");;
    Expect(1, 68102, '\p{InPC=-OVERSTRUCK}', "");
    Expect(0, 68102, '\p{^InPC=-OVERSTRUCK}', "");
    Expect(0, 68102, '\P{InPC=-OVERSTRUCK}', "");
    Expect(1, 68102, '\P{^InPC=-OVERSTRUCK}', "");
    Expect(0, 68103, '\p{InPC=-OVERSTRUCK}', "");
    Expect(1, 68103, '\p{^InPC=-OVERSTRUCK}', "");
    Expect(1, 68103, '\P{InPC=-OVERSTRUCK}', "");
    Expect(0, 68103, '\P{^InPC=-OVERSTRUCK}', "");
    Error('\p{Is_Indic_Positional_Category=/a/	 Overstruck}');
    Error('\P{Is_Indic_Positional_Category=/a/	 Overstruck}');
    Expect(1, 68102, '\p{Is_Indic_Positional_Category=overstruck}', "");
    Expect(0, 68102, '\p{^Is_Indic_Positional_Category=overstruck}', "");
    Expect(0, 68102, '\P{Is_Indic_Positional_Category=overstruck}', "");
    Expect(1, 68102, '\P{^Is_Indic_Positional_Category=overstruck}', "");
    Expect(0, 68103, '\p{Is_Indic_Positional_Category=overstruck}', "");
    Expect(1, 68103, '\p{^Is_Indic_Positional_Category=overstruck}', "");
    Expect(1, 68103, '\P{Is_Indic_Positional_Category=overstruck}', "");
    Expect(0, 68103, '\P{^Is_Indic_Positional_Category=overstruck}', "");
    Expect(1, 68102, '\p{Is_Indic_Positional_Category=_Overstruck}', "");
    Expect(0, 68102, '\p{^Is_Indic_Positional_Category=_Overstruck}', "");
    Expect(0, 68102, '\P{Is_Indic_Positional_Category=_Overstruck}', "");
    Expect(1, 68102, '\P{^Is_Indic_Positional_Category=_Overstruck}', "");
    Expect(0, 68103, '\p{Is_Indic_Positional_Category=_Overstruck}', "");
    Expect(1, 68103, '\p{^Is_Indic_Positional_Category=_Overstruck}', "");
    Expect(1, 68103, '\P{Is_Indic_Positional_Category=_Overstruck}', "");
    Expect(0, 68103, '\P{^Is_Indic_Positional_Category=_Overstruck}', "");
    Error('\p{Is_InPC=	-Overstruck:=}');
    Error('\P{Is_InPC=	-Overstruck:=}');
    Expect(1, 68102, '\p{Is_InPC=overstruck}', "");
    Expect(0, 68102, '\p{^Is_InPC=overstruck}', "");
    Expect(0, 68102, '\P{Is_InPC=overstruck}', "");
    Expect(1, 68102, '\P{^Is_InPC=overstruck}', "");
    Expect(0, 68103, '\p{Is_InPC=overstruck}', "");
    Expect(1, 68103, '\p{^Is_InPC=overstruck}', "");
    Expect(1, 68103, '\P{Is_InPC=overstruck}', "");
    Expect(0, 68103, '\P{^Is_InPC=overstruck}', "");
    Expect(1, 68102, '\p{Is_InPC:    	overstruck}', "");
    Expect(0, 68102, '\p{^Is_InPC:    	overstruck}', "");
    Expect(0, 68102, '\P{Is_InPC:    	overstruck}', "");
    Expect(1, 68102, '\P{^Is_InPC:    	overstruck}', "");
    Expect(0, 68103, '\p{Is_InPC:    	overstruck}', "");
    Expect(1, 68103, '\p{^Is_InPC:    	overstruck}', "");
    Expect(1, 68103, '\P{Is_InPC:    	overstruck}', "");
    Expect(0, 68103, '\P{^Is_InPC:    	overstruck}', "");
    Error('\p{Indic_Positional_Category=:=	 Right}');
    Error('\P{Indic_Positional_Category=:=	 Right}');
    Expect(1, 73537, '\p{Indic_Positional_Category=:\ARight\z:}', "");;
    Expect(0, 73538, '\p{Indic_Positional_Category=:\ARight\z:}', "");;
    Expect(1, 73537, '\p{Indic_Positional_Category=right}', "");
    Expect(0, 73537, '\p{^Indic_Positional_Category=right}', "");
    Expect(0, 73537, '\P{Indic_Positional_Category=right}', "");
    Expect(1, 73537, '\P{^Indic_Positional_Category=right}', "");
    Expect(0, 73538, '\p{Indic_Positional_Category=right}', "");
    Expect(1, 73538, '\p{^Indic_Positional_Category=right}', "");
    Expect(1, 73538, '\P{Indic_Positional_Category=right}', "");
    Expect(0, 73538, '\P{^Indic_Positional_Category=right}', "");
    Expect(1, 73537, '\p{Indic_Positional_Category=:\Aright\z:}', "");;
    Expect(0, 73538, '\p{Indic_Positional_Category=:\Aright\z:}', "");;
    Expect(1, 73537, '\p{Indic_Positional_Category=	right}', "");
    Expect(0, 73537, '\p{^Indic_Positional_Category=	right}', "");
    Expect(0, 73537, '\P{Indic_Positional_Category=	right}', "");
    Expect(1, 73537, '\P{^Indic_Positional_Category=	right}', "");
    Expect(0, 73538, '\p{Indic_Positional_Category=	right}', "");
    Expect(1, 73538, '\p{^Indic_Positional_Category=	right}', "");
    Expect(1, 73538, '\P{Indic_Positional_Category=	right}', "");
    Expect(0, 73538, '\P{^Indic_Positional_Category=	right}', "");
    Error('\p{InPC=	_Right/a/}');
    Error('\P{InPC=	_Right/a/}');
    Expect(1, 73537, '\p{InPC=:\ARight\z:}', "");;
    Expect(0, 73538, '\p{InPC=:\ARight\z:}', "");;
    Expect(1, 73537, '\p{InPC=right}', "");
    Expect(0, 73537, '\p{^InPC=right}', "");
    Expect(0, 73537, '\P{InPC=right}', "");
    Expect(1, 73537, '\P{^InPC=right}', "");
    Expect(0, 73538, '\p{InPC=right}', "");
    Expect(1, 73538, '\p{^InPC=right}', "");
    Expect(1, 73538, '\P{InPC=right}', "");
    Expect(0, 73538, '\P{^InPC=right}', "");
    Expect(1, 73537, '\p{InPC=:\Aright\z:}', "");;
    Expect(0, 73538, '\p{InPC=:\Aright\z:}', "");;
    Expect(1, 73537, '\p{InPC=	right}', "");
    Expect(0, 73537, '\p{^InPC=	right}', "");
    Expect(0, 73537, '\P{InPC=	right}', "");
    Expect(1, 73537, '\P{^InPC=	right}', "");
    Expect(0, 73538, '\p{InPC=	right}', "");
    Expect(1, 73538, '\p{^InPC=	right}', "");
    Expect(1, 73538, '\P{InPC=	right}', "");
    Expect(0, 73538, '\P{^InPC=	right}', "");
    Error('\p{Is_Indic_Positional_Category=_/a/RIGHT}');
    Error('\P{Is_Indic_Positional_Category=_/a/RIGHT}');
    Expect(1, 73537, '\p{Is_Indic_Positional_Category=right}', "");
    Expect(0, 73537, '\p{^Is_Indic_Positional_Category=right}', "");
    Expect(0, 73537, '\P{Is_Indic_Positional_Category=right}', "");
    Expect(1, 73537, '\P{^Is_Indic_Positional_Category=right}', "");
    Expect(0, 73538, '\p{Is_Indic_Positional_Category=right}', "");
    Expect(1, 73538, '\p{^Is_Indic_Positional_Category=right}', "");
    Expect(1, 73538, '\P{Is_Indic_Positional_Category=right}', "");
    Expect(0, 73538, '\P{^Is_Indic_Positional_Category=right}', "");
    Expect(1, 73537, '\p{Is_Indic_Positional_Category=-	Right}', "");
    Expect(0, 73537, '\p{^Is_Indic_Positional_Category=-	Right}', "");
    Expect(0, 73537, '\P{Is_Indic_Positional_Category=-	Right}', "");
    Expect(1, 73537, '\P{^Is_Indic_Positional_Category=-	Right}', "");
    Expect(0, 73538, '\p{Is_Indic_Positional_Category=-	Right}', "");
    Expect(1, 73538, '\p{^Is_Indic_Positional_Category=-	Right}', "");
    Expect(1, 73538, '\P{Is_Indic_Positional_Category=-	Right}', "");
    Expect(0, 73538, '\P{^Is_Indic_Positional_Category=-	Right}', "");
    Error('\p{Is_InPC=/a/Right}');
    Error('\P{Is_InPC=/a/Right}');
    Expect(1, 73537, '\p{Is_InPC=right}', "");
    Expect(0, 73537, '\p{^Is_InPC=right}', "");
    Expect(0, 73537, '\P{Is_InPC=right}', "");
    Expect(1, 73537, '\P{^Is_InPC=right}', "");
    Expect(0, 73538, '\p{Is_InPC=right}', "");
    Expect(1, 73538, '\p{^Is_InPC=right}', "");
    Expect(1, 73538, '\P{Is_InPC=right}', "");
    Expect(0, 73538, '\P{^Is_InPC=right}', "");
    Expect(1, 73537, '\p{Is_InPC=-	right}', "");
    Expect(0, 73537, '\p{^Is_InPC=-	right}', "");
    Expect(0, 73537, '\P{Is_InPC=-	right}', "");
    Expect(1, 73537, '\P{^Is_InPC=-	right}', "");
    Expect(0, 73538, '\p{Is_InPC=-	right}', "");
    Expect(1, 73538, '\p{^Is_InPC=-	right}', "");
    Expect(1, 73538, '\P{Is_InPC=-	right}', "");
    Expect(0, 73538, '\P{^Is_InPC=-	right}', "");
    Error('\p{Indic_Positional_Category=_:=TOP}');
    Error('\P{Indic_Positional_Category=_:=TOP}');
    Expect(1, 73536, '\p{Indic_Positional_Category=:\ATop\z:}', "");;
    Expect(0, 73537, '\p{Indic_Positional_Category=:\ATop\z:}', "");;
    Expect(1, 73536, '\p{Indic_Positional_Category=top}', "");
    Expect(0, 73536, '\p{^Indic_Positional_Category=top}', "");
    Expect(0, 73536, '\P{Indic_Positional_Category=top}', "");
    Expect(1, 73536, '\P{^Indic_Positional_Category=top}', "");
    Expect(0, 73537, '\p{Indic_Positional_Category=top}', "");
    Expect(1, 73537, '\p{^Indic_Positional_Category=top}', "");
    Expect(1, 73537, '\P{Indic_Positional_Category=top}', "");
    Expect(0, 73537, '\P{^Indic_Positional_Category=top}', "");
    Expect(1, 73536, '\p{Indic_Positional_Category=:\Atop\z:}', "");;
    Expect(0, 73537, '\p{Indic_Positional_Category=:\Atop\z:}', "");;
    Expect(1, 73536, '\p{Indic_Positional_Category=-TOP}', "");
    Expect(0, 73536, '\p{^Indic_Positional_Category=-TOP}', "");
    Expect(0, 73536, '\P{Indic_Positional_Category=-TOP}', "");
    Expect(1, 73536, '\P{^Indic_Positional_Category=-TOP}', "");
    Expect(0, 73537, '\p{Indic_Positional_Category=-TOP}', "");
    Expect(1, 73537, '\p{^Indic_Positional_Category=-TOP}', "");
    Expect(1, 73537, '\P{Indic_Positional_Category=-TOP}', "");
    Expect(0, 73537, '\P{^Indic_Positional_Category=-TOP}', "");
    Error('\p{InPC=-TOP:=}');
    Error('\P{InPC=-TOP:=}');
    Expect(1, 73536, '\p{InPC=:\ATop\z:}', "");;
    Expect(0, 73537, '\p{InPC=:\ATop\z:}', "");;
    Expect(1, 73536, '\p{InPC=top}', "");
    Expect(0, 73536, '\p{^InPC=top}', "");
    Expect(0, 73536, '\P{InPC=top}', "");
    Expect(1, 73536, '\P{^InPC=top}', "");
    Expect(0, 73537, '\p{InPC=top}', "");
    Expect(1, 73537, '\p{^InPC=top}', "");
    Expect(1, 73537, '\P{InPC=top}', "");
    Expect(0, 73537, '\P{^InPC=top}', "");
    Expect(1, 73536, '\p{InPC=:\Atop\z:}', "");;
    Expect(0, 73537, '\p{InPC=:\Atop\z:}', "");;
    Expect(1, 73536, '\p{InPC=_ TOP}', "");
    Expect(0, 73536, '\p{^InPC=_ TOP}', "");
    Expect(0, 73536, '\P{InPC=_ TOP}', "");
    Expect(1, 73536, '\P{^InPC=_ TOP}', "");
    Expect(0, 73537, '\p{InPC=_ TOP}', "");
    Expect(1, 73537, '\p{^InPC=_ TOP}', "");
    Expect(1, 73537, '\P{InPC=_ TOP}', "");
    Expect(0, 73537, '\P{^InPC=_ TOP}', "");
    Error('\p{Is_Indic_Positional_Category=Top:=}');
    Error('\P{Is_Indic_Positional_Category=Top:=}');
    Expect(1, 73536, '\p{Is_Indic_Positional_Category=top}', "");
    Expect(0, 73536, '\p{^Is_Indic_Positional_Category=top}', "");
    Expect(0, 73536, '\P{Is_Indic_Positional_Category=top}', "");
    Expect(1, 73536, '\P{^Is_Indic_Positional_Category=top}', "");
    Expect(0, 73537, '\p{Is_Indic_Positional_Category=top}', "");
    Expect(1, 73537, '\p{^Is_Indic_Positional_Category=top}', "");
    Expect(1, 73537, '\P{Is_Indic_Positional_Category=top}', "");
    Expect(0, 73537, '\P{^Is_Indic_Positional_Category=top}', "");
    Expect(1, 73536, '\p{Is_Indic_Positional_Category=-Top}', "");
    Expect(0, 73536, '\p{^Is_Indic_Positional_Category=-Top}', "");
    Expect(0, 73536, '\P{Is_Indic_Positional_Category=-Top}', "");
    Expect(1, 73536, '\P{^Is_Indic_Positional_Category=-Top}', "");
    Expect(0, 73537, '\p{Is_Indic_Positional_Category=-Top}', "");
    Expect(1, 73537, '\p{^Is_Indic_Positional_Category=-Top}', "");
    Expect(1, 73537, '\P{Is_Indic_Positional_Category=-Top}', "");
    Expect(0, 73537, '\P{^Is_Indic_Positional_Category=-Top}', "");
    Error('\p{Is_InPC=:=Top}');
    Error('\P{Is_InPC=:=Top}');
    Expect(1, 73536, '\p{Is_InPC=top}', "");
    Expect(0, 73536, '\p{^Is_InPC=top}', "");
    Expect(0, 73536, '\P{Is_InPC=top}', "");
    Expect(1, 73536, '\P{^Is_InPC=top}', "");
    Expect(0, 73537, '\p{Is_InPC=top}', "");
    Expect(1, 73537, '\p{^Is_InPC=top}', "");
    Expect(1, 73537, '\P{Is_InPC=top}', "");
    Expect(0, 73537, '\P{^Is_InPC=top}', "");
    Expect(1, 73536, '\p{Is_InPC=	 Top}', "");
    Expect(0, 73536, '\p{^Is_InPC=	 Top}', "");
    Expect(0, 73536, '\P{Is_InPC=	 Top}', "");
    Expect(1, 73536, '\P{^Is_InPC=	 Top}', "");
    Expect(0, 73537, '\p{Is_InPC=	 Top}', "");
    Expect(1, 73537, '\p{^Is_InPC=	 Top}', "");
    Expect(1, 73537, '\P{Is_InPC=	 Top}', "");
    Expect(0, 73537, '\P{^Is_InPC=	 Top}', "");
    Error('\p{Indic_Positional_Category=/a/--Top_AND_Bottom}');
    Error('\P{Indic_Positional_Category=/a/--Top_AND_Bottom}');
    Expect(1, 69935, '\p{Indic_Positional_Category=:\ATop_And_Bottom\z:}', "");;
    Expect(0, 69936, '\p{Indic_Positional_Category=:\ATop_And_Bottom\z:}', "");;
    Expect(1, 69935, '\p{Indic_Positional_Category=topandbottom}', "");
    Expect(0, 69935, '\p{^Indic_Positional_Category=topandbottom}', "");
    Expect(0, 69935, '\P{Indic_Positional_Category=topandbottom}', "");
    Expect(1, 69935, '\P{^Indic_Positional_Category=topandbottom}', "");
    Expect(0, 69936, '\p{Indic_Positional_Category=topandbottom}', "");
    Expect(1, 69936, '\p{^Indic_Positional_Category=topandbottom}', "");
    Expect(1, 69936, '\P{Indic_Positional_Category=topandbottom}', "");
    Expect(0, 69936, '\P{^Indic_Positional_Category=topandbottom}', "");
    Expect(1, 69935, '\p{Indic_Positional_Category=:\Atopandbottom\z:}', "");;
    Expect(0, 69936, '\p{Indic_Positional_Category=:\Atopandbottom\z:}', "");;
    Expect(1, 69935, '\p{Indic_Positional_Category=-	Top_And_BOTTOM}', "");
    Expect(0, 69935, '\p{^Indic_Positional_Category=-	Top_And_BOTTOM}', "");
    Expect(0, 69935, '\P{Indic_Positional_Category=-	Top_And_BOTTOM}', "");
    Expect(1, 69935, '\P{^Indic_Positional_Category=-	Top_And_BOTTOM}', "");
    Expect(0, 69936, '\p{Indic_Positional_Category=-	Top_And_BOTTOM}', "");
    Expect(1, 69936, '\p{^Indic_Positional_Category=-	Top_And_BOTTOM}', "");
    Expect(1, 69936, '\P{Indic_Positional_Category=-	Top_And_BOTTOM}', "");
    Expect(0, 69936, '\P{^Indic_Positional_Category=-	Top_And_BOTTOM}', "");
    Error('\p{InPC=:=top_and_BOTTOM}');
    Error('\P{InPC=:=top_and_BOTTOM}');
    Expect(1, 69935, '\p{InPC=:\ATop_And_Bottom\z:}', "");;
    Expect(0, 69936, '\p{InPC=:\ATop_And_Bottom\z:}', "");;
    Expect(1, 69935, '\p{InPC=topandbottom}', "");
    Expect(0, 69935, '\p{^InPC=topandbottom}', "");
    Expect(0, 69935, '\P{InPC=topandbottom}', "");
    Expect(1, 69935, '\P{^InPC=topandbottom}', "");
    Expect(0, 69936, '\p{InPC=topandbottom}', "");
    Expect(1, 69936, '\p{^InPC=topandbottom}', "");
    Expect(1, 69936, '\P{InPC=topandbottom}', "");
    Expect(0, 69936, '\P{^InPC=topandbottom}', "");
    Expect(1, 69935, '\p{InPC=:\Atopandbottom\z:}', "");;
    Expect(0, 69936, '\p{InPC=:\Atopandbottom\z:}', "");;
    Expect(1, 69935, '\p{InPC=Top_And_bottom}', "");
    Expect(0, 69935, '\p{^InPC=Top_And_bottom}', "");
    Expect(0, 69935, '\P{InPC=Top_And_bottom}', "");
    Expect(1, 69935, '\P{^InPC=Top_And_bottom}', "");
    Expect(0, 69936, '\p{InPC=Top_And_bottom}', "");
    Expect(1, 69936, '\p{^InPC=Top_And_bottom}', "");
    Expect(1, 69936, '\P{InPC=Top_And_bottom}', "");
    Expect(0, 69936, '\P{^InPC=Top_And_bottom}', "");
    Error('\p{Is_Indic_Positional_Category=/a/Top_AND_BOTTOM}');
    Error('\P{Is_Indic_Positional_Category=/a/Top_AND_BOTTOM}');
    Expect(1, 69935, '\p{Is_Indic_Positional_Category=topandbottom}', "");
    Expect(0, 69935, '\p{^Is_Indic_Positional_Category=topandbottom}', "");
    Expect(0, 69935, '\P{Is_Indic_Positional_Category=topandbottom}', "");
    Expect(1, 69935, '\P{^Is_Indic_Positional_Category=topandbottom}', "");
    Expect(0, 69936, '\p{Is_Indic_Positional_Category=topandbottom}', "");
    Expect(1, 69936, '\p{^Is_Indic_Positional_Category=topandbottom}', "");
    Expect(1, 69936, '\P{Is_Indic_Positional_Category=topandbottom}', "");
    Expect(0, 69936, '\P{^Is_Indic_Positional_Category=topandbottom}', "");
    Expect(1, 69935, '\p{Is_Indic_Positional_Category=-_Top_and_Bottom}', "");
    Expect(0, 69935, '\p{^Is_Indic_Positional_Category=-_Top_and_Bottom}', "");
    Expect(0, 69935, '\P{Is_Indic_Positional_Category=-_Top_and_Bottom}', "");
    Expect(1, 69935, '\P{^Is_Indic_Positional_Category=-_Top_and_Bottom}', "");
    Expect(0, 69936, '\p{Is_Indic_Positional_Category=-_Top_and_Bottom}', "");
    Expect(1, 69936, '\p{^Is_Indic_Positional_Category=-_Top_and_Bottom}', "");
    Expect(1, 69936, '\P{Is_Indic_Positional_Category=-_Top_and_Bottom}', "");
    Expect(0, 69936, '\P{^Is_Indic_Positional_Category=-_Top_and_Bottom}', "");
    Error('\p{Is_InPC=/a/--TOP_and_Bottom}');
    Error('\P{Is_InPC=/a/--TOP_and_Bottom}');
    Expect(1, 69935, '\p{Is_InPC=topandbottom}', "");
    Expect(0, 69935, '\p{^Is_InPC=topandbottom}', "");
    Expect(0, 69935, '\P{Is_InPC=topandbottom}', "");
    Expect(1, 69935, '\P{^Is_InPC=topandbottom}', "");
    Expect(0, 69936, '\p{Is_InPC=topandbottom}', "");
    Expect(1, 69936, '\p{^Is_InPC=topandbottom}', "");
    Expect(1, 69936, '\P{Is_InPC=topandbottom}', "");
    Expect(0, 69936, '\P{^Is_InPC=topandbottom}', "");
    Expect(1, 69935, '\p{Is_InPC= _TOP_and_BOTTOM}', "");
    Expect(0, 69935, '\p{^Is_InPC= _TOP_and_BOTTOM}', "");
    Expect(0, 69935, '\P{Is_InPC= _TOP_and_BOTTOM}', "");
    Expect(1, 69935, '\P{^Is_InPC= _TOP_and_BOTTOM}', "");
    Expect(0, 69936, '\p{Is_InPC= _TOP_and_BOTTOM}', "");
    Expect(1, 69936, '\p{^Is_InPC= _TOP_and_BOTTOM}', "");
    Expect(1, 69936, '\P{Is_InPC= _TOP_and_BOTTOM}', "");
    Expect(0, 69936, '\P{^Is_InPC= _TOP_and_BOTTOM}', "");
    Error('\p{Indic_Positional_Category=/a/Top_And_Bottom_and_left}');
    Error('\P{Indic_Positional_Category=/a/Top_And_Bottom_and_left}');
    Expect(1, 71454, '\p{Indic_Positional_Category=:\ATop_And_Bottom_And_Left\z:}', "");;
    Expect(0, 71455, '\p{Indic_Positional_Category=:\ATop_And_Bottom_And_Left\z:}', "");;
    Expect(1, 71454, '\p{Indic_Positional_Category=topandbottomandleft}', "");
    Expect(0, 71454, '\p{^Indic_Positional_Category=topandbottomandleft}', "");
    Expect(0, 71454, '\P{Indic_Positional_Category=topandbottomandleft}', "");
    Expect(1, 71454, '\P{^Indic_Positional_Category=topandbottomandleft}', "");
    Expect(0, 71455, '\p{Indic_Positional_Category=topandbottomandleft}', "");
    Expect(1, 71455, '\p{^Indic_Positional_Category=topandbottomandleft}', "");
    Expect(1, 71455, '\P{Indic_Positional_Category=topandbottomandleft}', "");
    Expect(0, 71455, '\P{^Indic_Positional_Category=topandbottomandleft}', "");
    Expect(1, 71454, '\p{Indic_Positional_Category=:\Atopandbottomandleft\z:}', "");;
    Expect(0, 71455, '\p{Indic_Positional_Category=:\Atopandbottomandleft\z:}', "");;
    Expect(1, 71454, '\p{Indic_Positional_Category=--top_AND_BOTTOM_AND_LEFT}', "");
    Expect(0, 71454, '\p{^Indic_Positional_Category=--top_AND_BOTTOM_AND_LEFT}', "");
    Expect(0, 71454, '\P{Indic_Positional_Category=--top_AND_BOTTOM_AND_LEFT}', "");
    Expect(1, 71454, '\P{^Indic_Positional_Category=--top_AND_BOTTOM_AND_LEFT}', "");
    Expect(0, 71455, '\p{Indic_Positional_Category=--top_AND_BOTTOM_AND_LEFT}', "");
    Expect(1, 71455, '\p{^Indic_Positional_Category=--top_AND_BOTTOM_AND_LEFT}', "");
    Expect(1, 71455, '\P{Indic_Positional_Category=--top_AND_BOTTOM_AND_LEFT}', "");
    Expect(0, 71455, '\P{^Indic_Positional_Category=--top_AND_BOTTOM_AND_LEFT}', "");
    Error('\p{InPC=/a/	top_And_bottom_and_left}');
    Error('\P{InPC=/a/	top_And_bottom_and_left}');
    Expect(1, 71454, '\p{InPC=:\ATop_And_Bottom_And_Left\z:}', "");;
    Expect(0, 71455, '\p{InPC=:\ATop_And_Bottom_And_Left\z:}', "");;
    Expect(1, 71454, '\p{InPC=topandbottomandleft}', "");
    Expect(0, 71454, '\p{^InPC=topandbottomandleft}', "");
    Expect(0, 71454, '\P{InPC=topandbottomandleft}', "");
    Expect(1, 71454, '\P{^InPC=topandbottomandleft}', "");
    Expect(0, 71455, '\p{InPC=topandbottomandleft}', "");
    Expect(1, 71455, '\p{^InPC=topandbottomandleft}', "");
    Expect(1, 71455, '\P{InPC=topandbottomandleft}', "");
    Expect(0, 71455, '\P{^InPC=topandbottomandleft}', "");
    Expect(1, 71454, '\p{InPC=:\Atopandbottomandleft\z:}', "");;
    Expect(0, 71455, '\p{InPC=:\Atopandbottomandleft\z:}', "");;
    Expect(1, 71454, '\p{InPC:   -Top_AND_Bottom_And_Left}', "");
    Expect(0, 71454, '\p{^InPC:   -Top_AND_Bottom_And_Left}', "");
    Expect(0, 71454, '\P{InPC:   -Top_AND_Bottom_And_Left}', "");
    Expect(1, 71454, '\P{^InPC:   -Top_AND_Bottom_And_Left}', "");
    Expect(0, 71455, '\p{InPC:   -Top_AND_Bottom_And_Left}', "");
    Expect(1, 71455, '\p{^InPC:   -Top_AND_Bottom_And_Left}', "");
    Expect(1, 71455, '\P{InPC:   -Top_AND_Bottom_And_Left}', "");
    Expect(0, 71455, '\P{^InPC:   -Top_AND_Bottom_And_Left}', "");
    Error('\p{Is_Indic_Positional_Category=_ top_And_BOTTOM_And_left/a/}');
    Error('\P{Is_Indic_Positional_Category=_ top_And_BOTTOM_And_left/a/}');
    Expect(1, 71454, '\p{Is_Indic_Positional_Category=topandbottomandleft}', "");
    Expect(0, 71454, '\p{^Is_Indic_Positional_Category=topandbottomandleft}', "");
    Expect(0, 71454, '\P{Is_Indic_Positional_Category=topandbottomandleft}', "");
    Expect(1, 71454, '\P{^Is_Indic_Positional_Category=topandbottomandleft}', "");
    Expect(0, 71455, '\p{Is_Indic_Positional_Category=topandbottomandleft}', "");
    Expect(1, 71455, '\p{^Is_Indic_Positional_Category=topandbottomandleft}', "");
    Expect(1, 71455, '\P{Is_Indic_Positional_Category=topandbottomandleft}', "");
    Expect(0, 71455, '\P{^Is_Indic_Positional_Category=topandbottomandleft}', "");
    Expect(1, 71454, '\p{Is_Indic_Positional_Category=-_Top_And_Bottom_AND_left}', "");
    Expect(0, 71454, '\p{^Is_Indic_Positional_Category=-_Top_And_Bottom_AND_left}', "");
    Expect(0, 71454, '\P{Is_Indic_Positional_Category=-_Top_And_Bottom_AND_left}', "");
    Expect(1, 71454, '\P{^Is_Indic_Positional_Category=-_Top_And_Bottom_AND_left}', "");
    Expect(0, 71455, '\p{Is_Indic_Positional_Category=-_Top_And_Bottom_AND_left}', "");
    Expect(1, 71455, '\p{^Is_Indic_Positional_Category=-_Top_And_Bottom_AND_left}', "");
    Expect(1, 71455, '\P{Is_Indic_Positional_Category=-_Top_And_Bottom_AND_left}', "");
    Expect(0, 71455, '\P{^Is_Indic_Positional_Category=-_Top_And_Bottom_AND_left}', "");
    Error('\p{Is_InPC=/a/--top_And_bottom_AND_LEFT}');
    Error('\P{Is_InPC=/a/--top_And_bottom_AND_LEFT}');
    Expect(1, 71454, '\p{Is_InPC=topandbottomandleft}', "");
    Expect(0, 71454, '\p{^Is_InPC=topandbottomandleft}', "");
    Expect(0, 71454, '\P{Is_InPC=topandbottomandleft}', "");
    Expect(1, 71454, '\P{^Is_InPC=topandbottomandleft}', "");
    Expect(0, 71455, '\p{Is_InPC=topandbottomandleft}', "");
    Expect(1, 71455, '\p{^Is_InPC=topandbottomandleft}', "");
    Expect(1, 71455, '\P{Is_InPC=topandbottomandleft}', "");
    Expect(0, 71455, '\P{^Is_InPC=topandbottomandleft}', "");
    Expect(1, 71454, '\p{Is_InPC=	Top_And_Bottom_And_left}', "");
    Expect(0, 71454, '\p{^Is_InPC=	Top_And_Bottom_And_left}', "");
    Expect(0, 71454, '\P{Is_InPC=	Top_And_Bottom_And_left}', "");
    Expect(1, 71454, '\P{^Is_InPC=	Top_And_Bottom_And_left}', "");
    Expect(0, 71455, '\p{Is_InPC=	Top_And_Bottom_And_left}', "");
    Expect(1, 71455, '\p{^Is_InPC=	Top_And_Bottom_And_left}', "");
    Expect(1, 71455, '\P{Is_InPC=	Top_And_Bottom_And_left}', "");
    Expect(0, 71455, '\P{^Is_InPC=	Top_And_Bottom_And_left}', "");
    Error('\p{Indic_Positional_Category=:=  TOP_AND_Bottom_And_right}');
    Error('\P{Indic_Positional_Category=:=  TOP_AND_Bottom_And_right}');
    Expect(1, 6973, '\p{Indic_Positional_Category=:\ATop_And_Bottom_And_Right\z:}', "");;
    Expect(0, 6974, '\p{Indic_Positional_Category=:\ATop_And_Bottom_And_Right\z:}', "");;
    Expect(1, 6973, '\p{Indic_Positional_Category=topandbottomandright}', "");
    Expect(0, 6973, '\p{^Indic_Positional_Category=topandbottomandright}', "");
    Expect(0, 6973, '\P{Indic_Positional_Category=topandbottomandright}', "");
    Expect(1, 6973, '\P{^Indic_Positional_Category=topandbottomandright}', "");
    Expect(0, 6974, '\p{Indic_Positional_Category=topandbottomandright}', "");
    Expect(1, 6974, '\p{^Indic_Positional_Category=topandbottomandright}', "");
    Expect(1, 6974, '\P{Indic_Positional_Category=topandbottomandright}', "");
    Expect(0, 6974, '\P{^Indic_Positional_Category=topandbottomandright}', "");
    Expect(1, 6973, '\p{Indic_Positional_Category=:\Atopandbottomandright\z:}', "");;
    Expect(0, 6974, '\p{Indic_Positional_Category=:\Atopandbottomandright\z:}', "");;
    Expect(1, 6973, '\p{Indic_Positional_Category=_	top_AND_BOTTOM_AND_RIGHT}', "");
    Expect(0, 6973, '\p{^Indic_Positional_Category=_	top_AND_BOTTOM_AND_RIGHT}', "");
    Expect(0, 6973, '\P{Indic_Positional_Category=_	top_AND_BOTTOM_AND_RIGHT}', "");
    Expect(1, 6973, '\P{^Indic_Positional_Category=_	top_AND_BOTTOM_AND_RIGHT}', "");
    Expect(0, 6974, '\p{Indic_Positional_Category=_	top_AND_BOTTOM_AND_RIGHT}', "");
    Expect(1, 6974, '\p{^Indic_Positional_Category=_	top_AND_BOTTOM_AND_RIGHT}', "");
    Expect(1, 6974, '\P{Indic_Positional_Category=_	top_AND_BOTTOM_AND_RIGHT}', "");
    Expect(0, 6974, '\P{^Indic_Positional_Category=_	top_AND_BOTTOM_AND_RIGHT}', "");
    Error('\p{InPC= /a/Top_AND_BOTTOM_And_Right}');
    Error('\P{InPC= /a/Top_AND_BOTTOM_And_Right}');
    Expect(1, 6973, '\p{InPC=:\ATop_And_Bottom_And_Right\z:}', "");;
    Expect(0, 6974, '\p{InPC=:\ATop_And_Bottom_And_Right\z:}', "");;
    Expect(1, 6973, '\p{InPC=topandbottomandright}', "");
    Expect(0, 6973, '\p{^InPC=topandbottomandright}', "");
    Expect(0, 6973, '\P{InPC=topandbottomandright}', "");
    Expect(1, 6973, '\P{^InPC=topandbottomandright}', "");
    Expect(0, 6974, '\p{InPC=topandbottomandright}', "");
    Expect(1, 6974, '\p{^InPC=topandbottomandright}', "");
    Expect(1, 6974, '\P{InPC=topandbottomandright}', "");
    Expect(0, 6974, '\P{^InPC=topandbottomandright}', "");
    Expect(1, 6973, '\p{InPC=:\Atopandbottomandright\z:}', "");;
    Expect(0, 6974, '\p{InPC=:\Atopandbottomandright\z:}', "");;
    Expect(1, 6973, '\p{InPC=	_top_And_BOTTOM_and_right}', "");
    Expect(0, 6973, '\p{^InPC=	_top_And_BOTTOM_and_right}', "");
    Expect(0, 6973, '\P{InPC=	_top_And_BOTTOM_and_right}', "");
    Expect(1, 6973, '\P{^InPC=	_top_And_BOTTOM_and_right}', "");
    Expect(0, 6974, '\p{InPC=	_top_And_BOTTOM_and_right}', "");
    Expect(1, 6974, '\p{^InPC=	_top_And_BOTTOM_and_right}', "");
    Expect(1, 6974, '\P{InPC=	_top_And_BOTTOM_and_right}', "");
    Expect(0, 6974, '\P{^InPC=	_top_And_BOTTOM_and_right}', "");
    Error('\p{Is_Indic_Positional_Category:   	Top_And_Bottom_AND_Right/a/}');
    Error('\P{Is_Indic_Positional_Category:   	Top_And_Bottom_AND_Right/a/}');
    Expect(1, 6973, '\p{Is_Indic_Positional_Category=topandbottomandright}', "");
    Expect(0, 6973, '\p{^Is_Indic_Positional_Category=topandbottomandright}', "");
    Expect(0, 6973, '\P{Is_Indic_Positional_Category=topandbottomandright}', "");
    Expect(1, 6973, '\P{^Is_Indic_Positional_Category=topandbottomandright}', "");
    Expect(0, 6974, '\p{Is_Indic_Positional_Category=topandbottomandright}', "");
    Expect(1, 6974, '\p{^Is_Indic_Positional_Category=topandbottomandright}', "");
    Expect(1, 6974, '\P{Is_Indic_Positional_Category=topandbottomandright}', "");
    Expect(0, 6974, '\P{^Is_Indic_Positional_Category=topandbottomandright}', "");
    Expect(1, 6973, '\p{Is_Indic_Positional_Category=_	Top_AND_BOTTOM_And_RIGHT}', "");
    Expect(0, 6973, '\p{^Is_Indic_Positional_Category=_	Top_AND_BOTTOM_And_RIGHT}', "");
    Expect(0, 6973, '\P{Is_Indic_Positional_Category=_	Top_AND_BOTTOM_And_RIGHT}', "");
    Expect(1, 6973, '\P{^Is_Indic_Positional_Category=_	Top_AND_BOTTOM_And_RIGHT}', "");
    Expect(0, 6974, '\p{Is_Indic_Positional_Category=_	Top_AND_BOTTOM_And_RIGHT}', "");
    Expect(1, 6974, '\p{^Is_Indic_Positional_Category=_	Top_AND_BOTTOM_And_RIGHT}', "");
    Expect(1, 6974, '\P{Is_Indic_Positional_Category=_	Top_AND_BOTTOM_And_RIGHT}', "");
    Expect(0, 6974, '\P{^Is_Indic_Positional_Category=_	Top_AND_BOTTOM_And_RIGHT}', "");
    Error('\p{Is_InPC=	_Top_and_bottom_And_Right/a/}');
    Error('\P{Is_InPC=	_Top_and_bottom_And_Right/a/}');
    Expect(1, 6973, '\p{Is_InPC=topandbottomandright}', "");
    Expect(0, 6973, '\p{^Is_InPC=topandbottomandright}', "");
    Expect(0, 6973, '\P{Is_InPC=topandbottomandright}', "");
    Expect(1, 6973, '\P{^Is_InPC=topandbottomandright}', "");
    Expect(0, 6974, '\p{Is_InPC=topandbottomandright}', "");
    Expect(1, 6974, '\p{^Is_InPC=topandbottomandright}', "");
    Expect(1, 6974, '\P{Is_InPC=topandbottomandright}', "");
    Expect(0, 6974, '\P{^Is_InPC=topandbottomandright}', "");
    Expect(1, 6973, '\p{Is_InPC=-	Top_and_Bottom_And_Right}', "");
    Expect(0, 6973, '\p{^Is_InPC=-	Top_and_Bottom_And_Right}', "");
    Expect(0, 6973, '\P{Is_InPC=-	Top_and_Bottom_And_Right}', "");
    Expect(1, 6973, '\P{^Is_InPC=-	Top_and_Bottom_And_Right}', "");
    Expect(0, 6974, '\p{Is_InPC=-	Top_and_Bottom_And_Right}', "");
    Expect(1, 6974, '\p{^Is_InPC=-	Top_and_Bottom_And_Right}', "");
    Expect(1, 6974, '\P{Is_InPC=-	Top_and_Bottom_And_Right}', "");
    Expect(0, 6974, '\P{^Is_InPC=-	Top_and_Bottom_And_Right}', "");
    Error('\p{Indic_Positional_Category=_-top_And_Left:=}');
    Error('\P{Indic_Positional_Category=_-top_And_Left:=}');
    Expect(1, 71097, '\p{Indic_Positional_Category=:\ATop_And_Left\z:}', "");;
    Expect(0, 71098, '\p{Indic_Positional_Category=:\ATop_And_Left\z:}', "");;
    Expect(1, 71097, '\p{Indic_Positional_Category=topandleft}', "");
    Expect(0, 71097, '\p{^Indic_Positional_Category=topandleft}', "");
    Expect(0, 71097, '\P{Indic_Positional_Category=topandleft}', "");
    Expect(1, 71097, '\P{^Indic_Positional_Category=topandleft}', "");
    Expect(0, 71098, '\p{Indic_Positional_Category=topandleft}', "");
    Expect(1, 71098, '\p{^Indic_Positional_Category=topandleft}', "");
    Expect(1, 71098, '\P{Indic_Positional_Category=topandleft}', "");
    Expect(0, 71098, '\P{^Indic_Positional_Category=topandleft}', "");
    Expect(1, 71097, '\p{Indic_Positional_Category=:\Atopandleft\z:}', "");;
    Expect(0, 71098, '\p{Indic_Positional_Category=:\Atopandleft\z:}', "");;
    Expect(1, 71097, '\p{Indic_Positional_Category:_-top_AND_LEFT}', "");
    Expect(0, 71097, '\p{^Indic_Positional_Category:_-top_AND_LEFT}', "");
    Expect(0, 71097, '\P{Indic_Positional_Category:_-top_AND_LEFT}', "");
    Expect(1, 71097, '\P{^Indic_Positional_Category:_-top_AND_LEFT}', "");
    Expect(0, 71098, '\p{Indic_Positional_Category:_-top_AND_LEFT}', "");
    Expect(1, 71098, '\p{^Indic_Positional_Category:_-top_AND_LEFT}', "");
    Expect(1, 71098, '\P{Indic_Positional_Category:_-top_AND_LEFT}', "");
    Expect(0, 71098, '\P{^Indic_Positional_Category:_-top_AND_LEFT}', "");
    Error('\p{InPC: :=__TOP_AND_LEFT}');
    Error('\P{InPC: :=__TOP_AND_LEFT}');
    Expect(1, 71097, '\p{InPC=:\ATop_And_Left\z:}', "");;
    Expect(0, 71098, '\p{InPC=:\ATop_And_Left\z:}', "");;
    Expect(1, 71097, '\p{InPC=topandleft}', "");
    Expect(0, 71097, '\p{^InPC=topandleft}', "");
    Expect(0, 71097, '\P{InPC=topandleft}', "");
    Expect(1, 71097, '\P{^InPC=topandleft}', "");
    Expect(0, 71098, '\p{InPC=topandleft}', "");
    Expect(1, 71098, '\p{^InPC=topandleft}', "");
    Expect(1, 71098, '\P{InPC=topandleft}', "");
    Expect(0, 71098, '\P{^InPC=topandleft}', "");
    Expect(1, 71097, '\p{InPC=:\Atopandleft\z:}', "");;
    Expect(0, 71098, '\p{InPC=:\Atopandleft\z:}', "");;
    Expect(1, 71097, '\p{InPC=	_Top_and_left}', "");
    Expect(0, 71097, '\p{^InPC=	_Top_and_left}', "");
    Expect(0, 71097, '\P{InPC=	_Top_and_left}', "");
    Expect(1, 71097, '\P{^InPC=	_Top_and_left}', "");
    Expect(0, 71098, '\p{InPC=	_Top_and_left}', "");
    Expect(1, 71098, '\p{^InPC=	_Top_and_left}', "");
    Expect(1, 71098, '\P{InPC=	_Top_and_left}', "");
    Expect(0, 71098, '\P{^InPC=	_Top_and_left}', "");
    Error('\p{Is_Indic_Positional_Category=-top_and_Left:=}');
    Error('\P{Is_Indic_Positional_Category=-top_and_Left:=}');
    Expect(1, 71097, '\p{Is_Indic_Positional_Category=topandleft}', "");
    Expect(0, 71097, '\p{^Is_Indic_Positional_Category=topandleft}', "");
    Expect(0, 71097, '\P{Is_Indic_Positional_Category=topandleft}', "");
    Expect(1, 71097, '\P{^Is_Indic_Positional_Category=topandleft}', "");
    Expect(0, 71098, '\p{Is_Indic_Positional_Category=topandleft}', "");
    Expect(1, 71098, '\p{^Is_Indic_Positional_Category=topandleft}', "");
    Expect(1, 71098, '\P{Is_Indic_Positional_Category=topandleft}', "");
    Expect(0, 71098, '\P{^Is_Indic_Positional_Category=topandleft}', "");
    Expect(1, 71097, '\p{Is_Indic_Positional_Category:     Top_And_Left}', "");
    Expect(0, 71097, '\p{^Is_Indic_Positional_Category:     Top_And_Left}', "");
    Expect(0, 71097, '\P{Is_Indic_Positional_Category:     Top_And_Left}', "");
    Expect(1, 71097, '\P{^Is_Indic_Positional_Category:     Top_And_Left}', "");
    Expect(0, 71098, '\p{Is_Indic_Positional_Category:     Top_And_Left}', "");
    Expect(1, 71098, '\p{^Is_Indic_Positional_Category:     Top_And_Left}', "");
    Expect(1, 71098, '\P{Is_Indic_Positional_Category:     Top_And_Left}', "");
    Expect(0, 71098, '\P{^Is_Indic_Positional_Category:     Top_And_Left}', "");
    Error('\p{Is_InPC=:=_	TOP_And_Left}');
    Error('\P{Is_InPC=:=_	TOP_And_Left}');
    Expect(1, 71097, '\p{Is_InPC=topandleft}', "");
    Expect(0, 71097, '\p{^Is_InPC=topandleft}', "");
    Expect(0, 71097, '\P{Is_InPC=topandleft}', "");
    Expect(1, 71097, '\P{^Is_InPC=topandleft}', "");
    Expect(0, 71098, '\p{Is_InPC=topandleft}', "");
    Expect(1, 71098, '\p{^Is_InPC=topandleft}', "");
    Expect(1, 71098, '\P{Is_InPC=topandleft}', "");
    Expect(0, 71098, '\P{^Is_InPC=topandleft}', "");
    Expect(1, 71097, '\p{Is_InPC=Top_AND_LEFT}', "");
    Expect(0, 71097, '\p{^Is_InPC=Top_AND_LEFT}', "");
    Expect(0, 71097, '\P{Is_InPC=Top_AND_LEFT}', "");
    Expect(1, 71097, '\P{^Is_InPC=Top_AND_LEFT}', "");
    Expect(0, 71098, '\p{Is_InPC=Top_AND_LEFT}', "");
    Expect(1, 71098, '\p{^Is_InPC=Top_AND_LEFT}', "");
    Expect(1, 71098, '\P{Is_InPC=Top_AND_LEFT}', "");
    Expect(0, 71098, '\P{^Is_InPC=Top_AND_LEFT}', "");
    Error('\p{Indic_Positional_Category:   _TOP_And_Left_And_Right:=}');
    Error('\P{Indic_Positional_Category:   _TOP_And_Left_And_Right:=}');
    Expect(1, 71099, '\p{Indic_Positional_Category=:\ATop_And_Left_And_Right\z:}', "");;
    Expect(0, 71100, '\p{Indic_Positional_Category=:\ATop_And_Left_And_Right\z:}', "");;
    Expect(1, 71099, '\p{Indic_Positional_Category=topandleftandright}', "");
    Expect(0, 71099, '\p{^Indic_Positional_Category=topandleftandright}', "");
    Expect(0, 71099, '\P{Indic_Positional_Category=topandleftandright}', "");
    Expect(1, 71099, '\P{^Indic_Positional_Category=topandleftandright}', "");
    Expect(0, 71100, '\p{Indic_Positional_Category=topandleftandright}', "");
    Expect(1, 71100, '\p{^Indic_Positional_Category=topandleftandright}', "");
    Expect(1, 71100, '\P{Indic_Positional_Category=topandleftandright}', "");
    Expect(0, 71100, '\P{^Indic_Positional_Category=topandleftandright}', "");
    Expect(1, 71099, '\p{Indic_Positional_Category=:\Atopandleftandright\z:}', "");;
    Expect(0, 71100, '\p{Indic_Positional_Category=:\Atopandleftandright\z:}', "");;
    Expect(1, 71099, '\p{Indic_Positional_Category=Top_And_Left_AND_Right}', "");
    Expect(0, 71099, '\p{^Indic_Positional_Category=Top_And_Left_AND_Right}', "");
    Expect(0, 71099, '\P{Indic_Positional_Category=Top_And_Left_AND_Right}', "");
    Expect(1, 71099, '\P{^Indic_Positional_Category=Top_And_Left_AND_Right}', "");
    Expect(0, 71100, '\p{Indic_Positional_Category=Top_And_Left_AND_Right}', "");
    Expect(1, 71100, '\p{^Indic_Positional_Category=Top_And_Left_AND_Right}', "");
    Expect(1, 71100, '\P{Indic_Positional_Category=Top_And_Left_AND_Right}', "");
    Expect(0, 71100, '\P{^Indic_Positional_Category=Top_And_Left_AND_Right}', "");
    Error('\p{InPC=/a/  TOP_And_LEFT_And_right}');
    Error('\P{InPC=/a/  TOP_And_LEFT_And_right}');
    Expect(1, 71099, '\p{InPC=:\ATop_And_Left_And_Right\z:}', "");;
    Expect(0, 71100, '\p{InPC=:\ATop_And_Left_And_Right\z:}', "");;
    Expect(1, 71099, '\p{InPC:	topandleftandright}', "");
    Expect(0, 71099, '\p{^InPC:	topandleftandright}', "");
    Expect(0, 71099, '\P{InPC:	topandleftandright}', "");
    Expect(1, 71099, '\P{^InPC:	topandleftandright}', "");
    Expect(0, 71100, '\p{InPC:	topandleftandright}', "");
    Expect(1, 71100, '\p{^InPC:	topandleftandright}', "");
    Expect(1, 71100, '\P{InPC:	topandleftandright}', "");
    Expect(0, 71100, '\P{^InPC:	topandleftandright}', "");
    Expect(1, 71099, '\p{InPC=:\Atopandleftandright\z:}', "");;
    Expect(0, 71100, '\p{InPC=:\Atopandleftandright\z:}', "");;
    Expect(1, 71099, '\p{InPC=_ Top_And_Left_AND_Right}', "");
    Expect(0, 71099, '\p{^InPC=_ Top_And_Left_AND_Right}', "");
    Expect(0, 71099, '\P{InPC=_ Top_And_Left_AND_Right}', "");
    Expect(1, 71099, '\P{^InPC=_ Top_And_Left_AND_Right}', "");
    Expect(0, 71100, '\p{InPC=_ Top_And_Left_AND_Right}', "");
    Expect(1, 71100, '\p{^InPC=_ Top_And_Left_AND_Right}', "");
    Expect(1, 71100, '\P{InPC=_ Top_And_Left_AND_Right}', "");
    Expect(0, 71100, '\P{^InPC=_ Top_And_Left_AND_Right}', "");
    Error('\p{Is_Indic_Positional_Category=-_Top_And_Left_and_RIGHT/a/}');
    Error('\P{Is_Indic_Positional_Category=-_Top_And_Left_and_RIGHT/a/}');
    Expect(1, 71099, '\p{Is_Indic_Positional_Category=topandleftandright}', "");
    Expect(0, 71099, '\p{^Is_Indic_Positional_Category=topandleftandright}', "");
    Expect(0, 71099, '\P{Is_Indic_Positional_Category=topandleftandright}', "");
    Expect(1, 71099, '\P{^Is_Indic_Positional_Category=topandleftandright}', "");
    Expect(0, 71100, '\p{Is_Indic_Positional_Category=topandleftandright}', "");
    Expect(1, 71100, '\p{^Is_Indic_Positional_Category=topandleftandright}', "");
    Expect(1, 71100, '\P{Is_Indic_Positional_Category=topandleftandright}', "");
    Expect(0, 71100, '\P{^Is_Indic_Positional_Category=topandleftandright}', "");
    Expect(1, 71099, '\p{Is_Indic_Positional_Category=-top_And_LEFT_AND_right}', "");
    Expect(0, 71099, '\p{^Is_Indic_Positional_Category=-top_And_LEFT_AND_right}', "");
    Expect(0, 71099, '\P{Is_Indic_Positional_Category=-top_And_LEFT_AND_right}', "");
    Expect(1, 71099, '\P{^Is_Indic_Positional_Category=-top_And_LEFT_AND_right}', "");
    Expect(0, 71100, '\p{Is_Indic_Positional_Category=-top_And_LEFT_AND_right}', "");
    Expect(1, 71100, '\p{^Is_Indic_Positional_Category=-top_And_LEFT_AND_right}', "");
    Expect(1, 71100, '\P{Is_Indic_Positional_Category=-top_And_LEFT_AND_right}', "");
    Expect(0, 71100, '\P{^Is_Indic_Positional_Category=-top_And_LEFT_AND_right}', "");
    Error('\p{Is_InPC=:=	-TOP_And_Left_AND_right}');
    Error('\P{Is_InPC=:=	-TOP_And_Left_AND_right}');
    Expect(1, 71099, '\p{Is_InPC=topandleftandright}', "");
    Expect(0, 71099, '\p{^Is_InPC=topandleftandright}', "");
    Expect(0, 71099, '\P{Is_InPC=topandleftandright}', "");
    Expect(1, 71099, '\P{^Is_InPC=topandleftandright}', "");
    Expect(0, 71100, '\p{Is_InPC=topandleftandright}', "");
    Expect(1, 71100, '\p{^Is_InPC=topandleftandright}', "");
    Expect(1, 71100, '\P{Is_InPC=topandleftandright}', "");
    Expect(0, 71100, '\P{^Is_InPC=topandleftandright}', "");
    Expect(1, 71099, '\p{Is_InPC= top_and_left_and_Right}', "");
    Expect(0, 71099, '\p{^Is_InPC= top_and_left_and_Right}', "");
    Expect(0, 71099, '\P{Is_InPC= top_and_left_and_Right}', "");
    Expect(1, 71099, '\P{^Is_InPC= top_and_left_and_Right}', "");
    Expect(0, 71100, '\p{Is_InPC= top_and_left_and_Right}', "");
    Expect(1, 71100, '\p{^Is_InPC= top_and_left_and_Right}', "");
    Expect(1, 71100, '\P{Is_InPC= top_and_left_and_Right}', "");
    Expect(0, 71100, '\P{^Is_InPC= top_and_left_and_Right}', "");
    Error('\p{Indic_Positional_Category=/a/TOP_and_right}');
    Error('\P{Indic_Positional_Category=/a/TOP_and_right}');
    Expect(1, 70195, '\p{Indic_Positional_Category=:\ATop_And_Right\z:}', "");;
    Expect(0, 70196, '\p{Indic_Positional_Category=:\ATop_And_Right\z:}', "");;
    Expect(1, 70195, '\p{Indic_Positional_Category=topandright}', "");
    Expect(0, 70195, '\p{^Indic_Positional_Category=topandright}', "");
    Expect(0, 70195, '\P{Indic_Positional_Category=topandright}', "");
    Expect(1, 70195, '\P{^Indic_Positional_Category=topandright}', "");
    Expect(0, 70196, '\p{Indic_Positional_Category=topandright}', "");
    Expect(1, 70196, '\p{^Indic_Positional_Category=topandright}', "");
    Expect(1, 70196, '\P{Indic_Positional_Category=topandright}', "");
    Expect(0, 70196, '\P{^Indic_Positional_Category=topandright}', "");
    Expect(1, 70195, '\p{Indic_Positional_Category=:\Atopandright\z:}', "");;
    Expect(0, 70196, '\p{Indic_Positional_Category=:\Atopandright\z:}', "");;
    Expect(1, 70195, '\p{Indic_Positional_Category= top_And_Right}', "");
    Expect(0, 70195, '\p{^Indic_Positional_Category= top_And_Right}', "");
    Expect(0, 70195, '\P{Indic_Positional_Category= top_And_Right}', "");
    Expect(1, 70195, '\P{^Indic_Positional_Category= top_And_Right}', "");
    Expect(0, 70196, '\p{Indic_Positional_Category= top_And_Right}', "");
    Expect(1, 70196, '\p{^Indic_Positional_Category= top_And_Right}', "");
    Expect(1, 70196, '\P{Indic_Positional_Category= top_And_Right}', "");
    Expect(0, 70196, '\P{^Indic_Positional_Category= top_And_Right}', "");
    Error('\p{InPC=_/a/Top_AND_right}');
    Error('\P{InPC=_/a/Top_AND_right}');
    Expect(1, 70195, '\p{InPC=:\ATop_And_Right\z:}', "");;
    Expect(0, 70196, '\p{InPC=:\ATop_And_Right\z:}', "");;
    Expect(1, 70195, '\p{InPC=topandright}', "");
    Expect(0, 70195, '\p{^InPC=topandright}', "");
    Expect(0, 70195, '\P{InPC=topandright}', "");
    Expect(1, 70195, '\P{^InPC=topandright}', "");
    Expect(0, 70196, '\p{InPC=topandright}', "");
    Expect(1, 70196, '\p{^InPC=topandright}', "");
    Expect(1, 70196, '\P{InPC=topandright}', "");
    Expect(0, 70196, '\P{^InPC=topandright}', "");
    Expect(1, 70195, '\p{InPC=:\Atopandright\z:}', "");;
    Expect(0, 70196, '\p{InPC=:\Atopandright\z:}', "");;
    Expect(1, 70195, '\p{InPC=	Top_AND_RIGHT}', "");
    Expect(0, 70195, '\p{^InPC=	Top_AND_RIGHT}', "");
    Expect(0, 70195, '\P{InPC=	Top_AND_RIGHT}', "");
    Expect(1, 70195, '\P{^InPC=	Top_AND_RIGHT}', "");
    Expect(0, 70196, '\p{InPC=	Top_AND_RIGHT}', "");
    Expect(1, 70196, '\p{^InPC=	Top_AND_RIGHT}', "");
    Expect(1, 70196, '\P{InPC=	Top_AND_RIGHT}', "");
    Expect(0, 70196, '\P{^InPC=	Top_AND_RIGHT}', "");
    Error('\p{Is_Indic_Positional_Category= :=top_And_Right}');
    Error('\P{Is_Indic_Positional_Category= :=top_And_Right}');
    Expect(1, 70195, '\p{Is_Indic_Positional_Category=topandright}', "");
    Expect(0, 70195, '\p{^Is_Indic_Positional_Category=topandright}', "");
    Expect(0, 70195, '\P{Is_Indic_Positional_Category=topandright}', "");
    Expect(1, 70195, '\P{^Is_Indic_Positional_Category=topandright}', "");
    Expect(0, 70196, '\p{Is_Indic_Positional_Category=topandright}', "");
    Expect(1, 70196, '\p{^Is_Indic_Positional_Category=topandright}', "");
    Expect(1, 70196, '\P{Is_Indic_Positional_Category=topandright}', "");
    Expect(0, 70196, '\P{^Is_Indic_Positional_Category=topandright}', "");
    Expect(1, 70195, '\p{Is_Indic_Positional_Category=_	Top_AND_Right}', "");
    Expect(0, 70195, '\p{^Is_Indic_Positional_Category=_	Top_AND_Right}', "");
    Expect(0, 70195, '\P{Is_Indic_Positional_Category=_	Top_AND_Right}', "");
    Expect(1, 70195, '\P{^Is_Indic_Positional_Category=_	Top_AND_Right}', "");
    Expect(0, 70196, '\p{Is_Indic_Positional_Category=_	Top_AND_Right}', "");
    Expect(1, 70196, '\p{^Is_Indic_Positional_Category=_	Top_AND_Right}', "");
    Expect(1, 70196, '\P{Is_Indic_Positional_Category=_	Top_AND_Right}', "");
    Expect(0, 70196, '\P{^Is_Indic_Positional_Category=_	Top_AND_Right}', "");
    Error('\p{Is_InPC=:=		TOP_and_RIGHT}');
    Error('\P{Is_InPC=:=		TOP_and_RIGHT}');
    Expect(1, 70195, '\p{Is_InPC:	topandright}', "");
    Expect(0, 70195, '\p{^Is_InPC:	topandright}', "");
    Expect(0, 70195, '\P{Is_InPC:	topandright}', "");
    Expect(1, 70195, '\P{^Is_InPC:	topandright}', "");
    Expect(0, 70196, '\p{Is_InPC:	topandright}', "");
    Expect(1, 70196, '\p{^Is_InPC:	topandright}', "");
    Expect(1, 70196, '\P{Is_InPC:	topandright}', "");
    Expect(0, 70196, '\P{^Is_InPC:	topandright}', "");
    Expect(1, 70195, '\p{Is_InPC= _top_AND_Right}', "");
    Expect(0, 70195, '\p{^Is_InPC= _top_AND_Right}', "");
    Expect(0, 70195, '\P{Is_InPC= _top_AND_Right}', "");
    Expect(1, 70195, '\P{^Is_InPC= _top_AND_Right}', "");
    Expect(0, 70196, '\p{Is_InPC= _top_AND_Right}', "");
    Expect(1, 70196, '\p{^Is_InPC= _top_AND_Right}', "");
    Expect(1, 70196, '\P{Is_InPC= _top_AND_Right}', "");
    Expect(0, 70196, '\P{^Is_InPC= _top_AND_Right}', "");
    Error('\p{Indic_Positional_Category: 	/a/visual_Order_Left}');
    Error('\P{Indic_Positional_Category: 	/a/visual_Order_Left}');
    Expect(1, 43708, '\p{Indic_Positional_Category=:\AVisual_Order_Left\z:}', "");;
    Expect(0, 43709, '\p{Indic_Positional_Category=:\AVisual_Order_Left\z:}', "");;
    Expect(1, 43708, '\p{Indic_Positional_Category=visualorderleft}', "");
    Expect(0, 43708, '\p{^Indic_Positional_Category=visualorderleft}', "");
    Expect(0, 43708, '\P{Indic_Positional_Category=visualorderleft}', "");
    Expect(1, 43708, '\P{^Indic_Positional_Category=visualorderleft}', "");
    Expect(0, 43709, '\p{Indic_Positional_Category=visualorderleft}', "");
    Expect(1, 43709, '\p{^Indic_Positional_Category=visualorderleft}', "");
    Expect(1, 43709, '\P{Indic_Positional_Category=visualorderleft}', "");
    Expect(0, 43709, '\P{^Indic_Positional_Category=visualorderleft}', "");
    Expect(1, 43708, '\p{Indic_Positional_Category=:\Avisualorderleft\z:}', "");;
    Expect(0, 43709, '\p{Indic_Positional_Category=:\Avisualorderleft\z:}', "");;
    Expect(1, 43708, '\p{Indic_Positional_Category=--visual_order_LEFT}', "");
    Expect(0, 43708, '\p{^Indic_Positional_Category=--visual_order_LEFT}', "");
    Expect(0, 43708, '\P{Indic_Positional_Category=--visual_order_LEFT}', "");
    Expect(1, 43708, '\P{^Indic_Positional_Category=--visual_order_LEFT}', "");
    Expect(0, 43709, '\p{Indic_Positional_Category=--visual_order_LEFT}', "");
    Expect(1, 43709, '\p{^Indic_Positional_Category=--visual_order_LEFT}', "");
    Expect(1, 43709, '\P{Indic_Positional_Category=--visual_order_LEFT}', "");
    Expect(0, 43709, '\P{^Indic_Positional_Category=--visual_order_LEFT}', "");
    Error('\p{InPC=	:=Visual_Order_Left}');
    Error('\P{InPC=	:=Visual_Order_Left}');
    Expect(1, 43708, '\p{InPC=:\AVisual_Order_Left\z:}', "");;
    Expect(0, 43709, '\p{InPC=:\AVisual_Order_Left\z:}', "");;
    Expect(1, 43708, '\p{InPC:visualorderleft}', "");
    Expect(0, 43708, '\p{^InPC:visualorderleft}', "");
    Expect(0, 43708, '\P{InPC:visualorderleft}', "");
    Expect(1, 43708, '\P{^InPC:visualorderleft}', "");
    Expect(0, 43709, '\p{InPC:visualorderleft}', "");
    Expect(1, 43709, '\p{^InPC:visualorderleft}', "");
    Expect(1, 43709, '\P{InPC:visualorderleft}', "");
    Expect(0, 43709, '\P{^InPC:visualorderleft}', "");
    Expect(1, 43708, '\p{InPC=:\Avisualorderleft\z:}', "");;
    Expect(0, 43709, '\p{InPC=:\Avisualorderleft\z:}', "");;
    Expect(1, 43708, '\p{InPC= _Visual_Order_left}', "");
    Expect(0, 43708, '\p{^InPC= _Visual_Order_left}', "");
    Expect(0, 43708, '\P{InPC= _Visual_Order_left}', "");
    Expect(1, 43708, '\P{^InPC= _Visual_Order_left}', "");
    Expect(0, 43709, '\p{InPC= _Visual_Order_left}', "");
    Expect(1, 43709, '\p{^InPC= _Visual_Order_left}', "");
    Expect(1, 43709, '\P{InPC= _Visual_Order_left}', "");
    Expect(0, 43709, '\P{^InPC= _Visual_Order_left}', "");
    Error('\p{Is_Indic_Positional_Category=- Visual_order_left/a/}');
    Error('\P{Is_Indic_Positional_Category=- Visual_order_left/a/}');
    Expect(1, 43708, '\p{Is_Indic_Positional_Category=visualorderleft}', "");
    Expect(0, 43708, '\p{^Is_Indic_Positional_Category=visualorderleft}', "");
    Expect(0, 43708, '\P{Is_Indic_Positional_Category=visualorderleft}', "");
    Expect(1, 43708, '\P{^Is_Indic_Positional_Category=visualorderleft}', "");
    Expect(0, 43709, '\p{Is_Indic_Positional_Category=visualorderleft}', "");
    Expect(1, 43709, '\p{^Is_Indic_Positional_Category=visualorderleft}', "");
    Expect(1, 43709, '\P{Is_Indic_Positional_Category=visualorderleft}', "");
    Expect(0, 43709, '\P{^Is_Indic_Positional_Category=visualorderleft}', "");
    Expect(1, 43708, '\p{Is_Indic_Positional_Category=	 VISUAL_Order_Left}', "");
    Expect(0, 43708, '\p{^Is_Indic_Positional_Category=	 VISUAL_Order_Left}', "");
    Expect(0, 43708, '\P{Is_Indic_Positional_Category=	 VISUAL_Order_Left}', "");
    Expect(1, 43708, '\P{^Is_Indic_Positional_Category=	 VISUAL_Order_Left}', "");
    Expect(0, 43709, '\p{Is_Indic_Positional_Category=	 VISUAL_Order_Left}', "");
    Expect(1, 43709, '\p{^Is_Indic_Positional_Category=	 VISUAL_Order_Left}', "");
    Expect(1, 43709, '\P{Is_Indic_Positional_Category=	 VISUAL_Order_Left}', "");
    Expect(0, 43709, '\P{^Is_Indic_Positional_Category=	 VISUAL_Order_Left}', "");
    Error('\p{Is_InPC=:=_VISUAL_Order_Left}');
    Error('\P{Is_InPC=:=_VISUAL_Order_Left}');
    Expect(1, 43708, '\p{Is_InPC=visualorderleft}', "");
    Expect(0, 43708, '\p{^Is_InPC=visualorderleft}', "");
    Expect(0, 43708, '\P{Is_InPC=visualorderleft}', "");
    Expect(1, 43708, '\P{^Is_InPC=visualorderleft}', "");
    Expect(0, 43709, '\p{Is_InPC=visualorderleft}', "");
    Expect(1, 43709, '\p{^Is_InPC=visualorderleft}', "");
    Expect(1, 43709, '\P{Is_InPC=visualorderleft}', "");
    Expect(0, 43709, '\P{^Is_InPC=visualorderleft}', "");
    Expect(1, 43708, '\p{Is_InPC= VISUAL_order_Left}', "");
    Expect(0, 43708, '\p{^Is_InPC= VISUAL_order_Left}', "");
    Expect(0, 43708, '\P{Is_InPC= VISUAL_order_Left}', "");
    Expect(1, 43708, '\P{^Is_InPC= VISUAL_order_Left}', "");
    Expect(0, 43709, '\p{Is_InPC= VISUAL_order_Left}', "");
    Expect(1, 43709, '\p{^Is_InPC= VISUAL_order_Left}', "");
    Expect(1, 43709, '\P{Is_InPC= VISUAL_order_Left}', "");
    Expect(0, 43709, '\P{^Is_InPC= VISUAL_order_Left}', "");
    Error('\p{indicsyllabiccategory}');
    Error('\P{indicsyllabiccategory}');
    Error('\p{insc}');
    Error('\P{insc}');
    Error('\p{Indic_Syllabic_Category=  AVAGRAHA:=}');
    Error('\P{Indic_Syllabic_Category=  AVAGRAHA:=}');
    Expect(1, 72768, '\p{Indic_Syllabic_Category=:\AAvagraha\z:}', "");;
    Expect(0, 72769, '\p{Indic_Syllabic_Category=:\AAvagraha\z:}', "");;
    Expect(1, 72768, '\p{Indic_Syllabic_Category=avagraha}', "");
    Expect(0, 72768, '\p{^Indic_Syllabic_Category=avagraha}', "");
    Expect(0, 72768, '\P{Indic_Syllabic_Category=avagraha}', "");
    Expect(1, 72768, '\P{^Indic_Syllabic_Category=avagraha}', "");
    Expect(0, 72769, '\p{Indic_Syllabic_Category=avagraha}', "");
    Expect(1, 72769, '\p{^Indic_Syllabic_Category=avagraha}', "");
    Expect(1, 72769, '\P{Indic_Syllabic_Category=avagraha}', "");
    Expect(0, 72769, '\P{^Indic_Syllabic_Category=avagraha}', "");
    Expect(1, 72768, '\p{Indic_Syllabic_Category=:\Aavagraha\z:}', "");;
    Expect(0, 72769, '\p{Indic_Syllabic_Category=:\Aavagraha\z:}', "");;
    Expect(1, 72768, '\p{Indic_Syllabic_Category= AVAGRAHA}', "");
    Expect(0, 72768, '\p{^Indic_Syllabic_Category= AVAGRAHA}', "");
    Expect(0, 72768, '\P{Indic_Syllabic_Category= AVAGRAHA}', "");
    Expect(1, 72768, '\P{^Indic_Syllabic_Category= AVAGRAHA}', "");
    Expect(0, 72769, '\p{Indic_Syllabic_Category= AVAGRAHA}', "");
    Expect(1, 72769, '\p{^Indic_Syllabic_Category= AVAGRAHA}', "");
    Expect(1, 72769, '\P{Indic_Syllabic_Category= AVAGRAHA}', "");
    Expect(0, 72769, '\P{^Indic_Syllabic_Category= AVAGRAHA}', "");
    Error('\p{InSC=	-AVAGRAHA/a/}');
    Error('\P{InSC=	-AVAGRAHA/a/}');
    Expect(1, 72768, '\p{InSC=:\AAvagraha\z:}', "");;
    Expect(0, 72769, '\p{InSC=:\AAvagraha\z:}', "");;
    Expect(1, 72768, '\p{InSC=avagraha}', "");
    Expect(0, 72768, '\p{^InSC=avagraha}', "");
    Expect(0, 72768, '\P{InSC=avagraha}', "");
    Expect(1, 72768, '\P{^InSC=avagraha}', "");
    Expect(0, 72769, '\p{InSC=avagraha}', "");
    Expect(1, 72769, '\p{^InSC=avagraha}', "");
    Expect(1, 72769, '\P{InSC=avagraha}', "");
    Expect(0, 72769, '\P{^InSC=avagraha}', "");
    Expect(1, 72768, '\p{InSC=:\Aavagraha\z:}', "");;
    Expect(0, 72769, '\p{InSC=:\Aavagraha\z:}', "");;
    Expect(1, 72768, '\p{InSC=_ AVAGRAHA}', "");
    Expect(0, 72768, '\p{^InSC=_ AVAGRAHA}', "");
    Expect(0, 72768, '\P{InSC=_ AVAGRAHA}', "");
    Expect(1, 72768, '\P{^InSC=_ AVAGRAHA}', "");
    Expect(0, 72769, '\p{InSC=_ AVAGRAHA}', "");
    Expect(1, 72769, '\p{^InSC=_ AVAGRAHA}', "");
    Expect(1, 72769, '\P{InSC=_ AVAGRAHA}', "");
    Expect(0, 72769, '\P{^InSC=_ AVAGRAHA}', "");
    Error('\p{Is_Indic_Syllabic_Category= Avagraha:=}');
    Error('\P{Is_Indic_Syllabic_Category= Avagraha:=}');
    Expect(1, 72768, '\p{Is_Indic_Syllabic_Category=avagraha}', "");
    Expect(0, 72768, '\p{^Is_Indic_Syllabic_Category=avagraha}', "");
    Expect(0, 72768, '\P{Is_Indic_Syllabic_Category=avagraha}', "");
    Expect(1, 72768, '\P{^Is_Indic_Syllabic_Category=avagraha}', "");
    Expect(0, 72769, '\p{Is_Indic_Syllabic_Category=avagraha}', "");
    Expect(1, 72769, '\p{^Is_Indic_Syllabic_Category=avagraha}', "");
    Expect(1, 72769, '\P{Is_Indic_Syllabic_Category=avagraha}', "");
    Expect(0, 72769, '\P{^Is_Indic_Syllabic_Category=avagraha}', "");
    Expect(1, 72768, '\p{Is_Indic_Syllabic_Category=	Avagraha}', "");
    Expect(0, 72768, '\p{^Is_Indic_Syllabic_Category=	Avagraha}', "");
    Expect(0, 72768, '\P{Is_Indic_Syllabic_Category=	Avagraha}', "");
    Expect(1, 72768, '\P{^Is_Indic_Syllabic_Category=	Avagraha}', "");
    Expect(0, 72769, '\p{Is_Indic_Syllabic_Category=	Avagraha}', "");
    Expect(1, 72769, '\p{^Is_Indic_Syllabic_Category=	Avagraha}', "");
    Expect(1, 72769, '\P{Is_Indic_Syllabic_Category=	Avagraha}', "");
    Expect(0, 72769, '\P{^Is_Indic_Syllabic_Category=	Avagraha}', "");
    Error('\p{Is_InSC=_/a/AVAGRAHA}');
    Error('\P{Is_InSC=_/a/AVAGRAHA}');
    Expect(1, 72768, '\p{Is_InSC=avagraha}', "");
    Expect(0, 72768, '\p{^Is_InSC=avagraha}', "");
    Expect(0, 72768, '\P{Is_InSC=avagraha}', "");
    Expect(1, 72768, '\P{^Is_InSC=avagraha}', "");
    Expect(0, 72769, '\p{Is_InSC=avagraha}', "");
    Expect(1, 72769, '\p{^Is_InSC=avagraha}', "");
    Expect(1, 72769, '\P{Is_InSC=avagraha}', "");
    Expect(0, 72769, '\P{^Is_InSC=avagraha}', "");
    Expect(1, 72768, '\p{Is_InSC=	-avagraha}', "");
    Expect(0, 72768, '\p{^Is_InSC=	-avagraha}', "");
    Expect(0, 72768, '\P{Is_InSC=	-avagraha}', "");
    Expect(1, 72768, '\P{^Is_InSC=	-avagraha}', "");
    Expect(0, 72769, '\p{Is_InSC=	-avagraha}', "");
    Expect(1, 72769, '\p{^Is_InSC=	-avagraha}', "");
    Expect(1, 72769, '\P{Is_InSC=	-avagraha}', "");
    Expect(0, 72769, '\P{^Is_InSC=	-avagraha}', "");
    Error('\p{Indic_Syllabic_Category=/a/Bindu}');
    Error('\P{Indic_Syllabic_Category=/a/Bindu}');
    Expect(1, 73473, '\p{Indic_Syllabic_Category=:\ABindu\z:}', "");;
    Expect(0, 73474, '\p{Indic_Syllabic_Category=:\ABindu\z:}', "");;
    Expect(1, 73473, '\p{Indic_Syllabic_Category=bindu}', "");
    Expect(0, 73473, '\p{^Indic_Syllabic_Category=bindu}', "");
    Expect(0, 73473, '\P{Indic_Syllabic_Category=bindu}', "");
    Expect(1, 73473, '\P{^Indic_Syllabic_Category=bindu}', "");
    Expect(0, 73474, '\p{Indic_Syllabic_Category=bindu}', "");
    Expect(1, 73474, '\p{^Indic_Syllabic_Category=bindu}', "");
    Expect(1, 73474, '\P{Indic_Syllabic_Category=bindu}', "");
    Expect(0, 73474, '\P{^Indic_Syllabic_Category=bindu}', "");
    Expect(1, 73473, '\p{Indic_Syllabic_Category=:\Abindu\z:}', "");;
    Expect(0, 73474, '\p{Indic_Syllabic_Category=:\Abindu\z:}', "");;
    Expect(1, 73473, '\p{Indic_Syllabic_Category=__BINDU}', "");
    Expect(0, 73473, '\p{^Indic_Syllabic_Category=__BINDU}', "");
    Expect(0, 73473, '\P{Indic_Syllabic_Category=__BINDU}', "");
    Expect(1, 73473, '\P{^Indic_Syllabic_Category=__BINDU}', "");
    Expect(0, 73474, '\p{Indic_Syllabic_Category=__BINDU}', "");
    Expect(1, 73474, '\p{^Indic_Syllabic_Category=__BINDU}', "");
    Expect(1, 73474, '\P{Indic_Syllabic_Category=__BINDU}', "");
    Expect(0, 73474, '\P{^Indic_Syllabic_Category=__BINDU}', "");
    Error('\p{InSC=	/a/bindu}');
    Error('\P{InSC=	/a/bindu}');
    Expect(1, 73473, '\p{InSC=:\ABindu\z:}', "");;
    Expect(0, 73474, '\p{InSC=:\ABindu\z:}', "");;
    Expect(1, 73473, '\p{InSC=bindu}', "");
    Expect(0, 73473, '\p{^InSC=bindu}', "");
    Expect(0, 73473, '\P{InSC=bindu}', "");
    Expect(1, 73473, '\P{^InSC=bindu}', "");
    Expect(0, 73474, '\p{InSC=bindu}', "");
    Expect(1, 73474, '\p{^InSC=bindu}', "");
    Expect(1, 73474, '\P{InSC=bindu}', "");
    Expect(0, 73474, '\P{^InSC=bindu}', "");
    Expect(1, 73473, '\p{InSC=:\Abindu\z:}', "");;
    Expect(0, 73474, '\p{InSC=:\Abindu\z:}', "");;
    Expect(1, 73473, '\p{InSC=	bindu}', "");
    Expect(0, 73473, '\p{^InSC=	bindu}', "");
    Expect(0, 73473, '\P{InSC=	bindu}', "");
    Expect(1, 73473, '\P{^InSC=	bindu}', "");
    Expect(0, 73474, '\p{InSC=	bindu}', "");
    Expect(1, 73474, '\p{^InSC=	bindu}', "");
    Expect(1, 73474, '\P{InSC=	bindu}', "");
    Expect(0, 73474, '\P{^InSC=	bindu}', "");
    Error('\p{Is_Indic_Syllabic_Category=	/a/Bindu}');
    Error('\P{Is_Indic_Syllabic_Category=	/a/Bindu}');
    Expect(1, 73473, '\p{Is_Indic_Syllabic_Category=bindu}', "");
    Expect(0, 73473, '\p{^Is_Indic_Syllabic_Category=bindu}', "");
    Expect(0, 73473, '\P{Is_Indic_Syllabic_Category=bindu}', "");
    Expect(1, 73473, '\P{^Is_Indic_Syllabic_Category=bindu}', "");
    Expect(0, 73474, '\p{Is_Indic_Syllabic_Category=bindu}', "");
    Expect(1, 73474, '\p{^Is_Indic_Syllabic_Category=bindu}', "");
    Expect(1, 73474, '\P{Is_Indic_Syllabic_Category=bindu}', "");
    Expect(0, 73474, '\P{^Is_Indic_Syllabic_Category=bindu}', "");
    Expect(1, 73473, '\p{Is_Indic_Syllabic_Category=-	Bindu}', "");
    Expect(0, 73473, '\p{^Is_Indic_Syllabic_Category=-	Bindu}', "");
    Expect(0, 73473, '\P{Is_Indic_Syllabic_Category=-	Bindu}', "");
    Expect(1, 73473, '\P{^Is_Indic_Syllabic_Category=-	Bindu}', "");
    Expect(0, 73474, '\p{Is_Indic_Syllabic_Category=-	Bindu}', "");
    Expect(1, 73474, '\p{^Is_Indic_Syllabic_Category=-	Bindu}', "");
    Expect(1, 73474, '\P{Is_Indic_Syllabic_Category=-	Bindu}', "");
    Expect(0, 73474, '\P{^Is_Indic_Syllabic_Category=-	Bindu}', "");
    Error('\p{Is_InSC=/a/__BINDU}');
    Error('\P{Is_InSC=/a/__BINDU}');
    Expect(1, 73473, '\p{Is_InSC=bindu}', "");
    Expect(0, 73473, '\p{^Is_InSC=bindu}', "");
    Expect(0, 73473, '\P{Is_InSC=bindu}', "");
    Expect(1, 73473, '\P{^Is_InSC=bindu}', "");
    Expect(0, 73474, '\p{Is_InSC=bindu}', "");
    Expect(1, 73474, '\p{^Is_InSC=bindu}', "");
    Expect(1, 73474, '\P{Is_InSC=bindu}', "");
    Expect(0, 73474, '\P{^Is_InSC=bindu}', "");
    Expect(1, 73473, '\p{Is_InSC=	_Bindu}', "");
    Expect(0, 73473, '\p{^Is_InSC=	_Bindu}', "");
    Expect(0, 73473, '\P{Is_InSC=	_Bindu}', "");
    Expect(1, 73473, '\P{^Is_InSC=	_Bindu}', "");
    Expect(0, 73474, '\p{Is_InSC=	_Bindu}', "");
    Expect(1, 73474, '\p{^Is_InSC=	_Bindu}', "");
    Expect(1, 73474, '\P{Is_InSC=	_Bindu}', "");
    Expect(0, 73474, '\P{^Is_InSC=	_Bindu}', "");
    Error('\p{Indic_Syllabic_Category:	:=Brahmi_JOINING_Number}');
    Error('\P{Indic_Syllabic_Category:	:=Brahmi_JOINING_Number}');
    Expect(1, 69733, '\p{Indic_Syllabic_Category=:\ABrahmi_Joining_Number\z:}', "");;
    Expect(0, 69734, '\p{Indic_Syllabic_Category=:\ABrahmi_Joining_Number\z:}', "");;
    Expect(1, 69733, '\p{Indic_Syllabic_Category: brahmijoiningnumber}', "");
    Expect(0, 69733, '\p{^Indic_Syllabic_Category: brahmijoiningnumber}', "");
    Expect(0, 69733, '\P{Indic_Syllabic_Category: brahmijoiningnumber}', "");
    Expect(1, 69733, '\P{^Indic_Syllabic_Category: brahmijoiningnumber}', "");
    Expect(0, 69734, '\p{Indic_Syllabic_Category: brahmijoiningnumber}', "");
    Expect(1, 69734, '\p{^Indic_Syllabic_Category: brahmijoiningnumber}', "");
    Expect(1, 69734, '\P{Indic_Syllabic_Category: brahmijoiningnumber}', "");
    Expect(0, 69734, '\P{^Indic_Syllabic_Category: brahmijoiningnumber}', "");
    Expect(1, 69733, '\p{Indic_Syllabic_Category=:\Abrahmijoiningnumber\z:}', "");;
    Expect(0, 69734, '\p{Indic_Syllabic_Category=:\Abrahmijoiningnumber\z:}', "");;
    Expect(1, 69733, '\p{Indic_Syllabic_Category=_-Brahmi_JOINING_number}', "");
    Expect(0, 69733, '\p{^Indic_Syllabic_Category=_-Brahmi_JOINING_number}', "");
    Expect(0, 69733, '\P{Indic_Syllabic_Category=_-Brahmi_JOINING_number}', "");
    Expect(1, 69733, '\P{^Indic_Syllabic_Category=_-Brahmi_JOINING_number}', "");
    Expect(0, 69734, '\p{Indic_Syllabic_Category=_-Brahmi_JOINING_number}', "");
    Expect(1, 69734, '\p{^Indic_Syllabic_Category=_-Brahmi_JOINING_number}', "");
    Expect(1, 69734, '\P{Indic_Syllabic_Category=_-Brahmi_JOINING_number}', "");
    Expect(0, 69734, '\P{^Indic_Syllabic_Category=_-Brahmi_JOINING_number}', "");
    Error('\p{InSC=-	Brahmi_Joining_Number:=}');
    Error('\P{InSC=-	Brahmi_Joining_Number:=}');
    Expect(1, 69733, '\p{InSC=:\ABrahmi_Joining_Number\z:}', "");;
    Expect(0, 69734, '\p{InSC=:\ABrahmi_Joining_Number\z:}', "");;
    Expect(1, 69733, '\p{InSC=brahmijoiningnumber}', "");
    Expect(0, 69733, '\p{^InSC=brahmijoiningnumber}', "");
    Expect(0, 69733, '\P{InSC=brahmijoiningnumber}', "");
    Expect(1, 69733, '\P{^InSC=brahmijoiningnumber}', "");
    Expect(0, 69734, '\p{InSC=brahmijoiningnumber}', "");
    Expect(1, 69734, '\p{^InSC=brahmijoiningnumber}', "");
    Expect(1, 69734, '\P{InSC=brahmijoiningnumber}', "");
    Expect(0, 69734, '\P{^InSC=brahmijoiningnumber}', "");
    Expect(1, 69733, '\p{InSC=:\Abrahmijoiningnumber\z:}', "");;
    Expect(0, 69734, '\p{InSC=:\Abrahmijoiningnumber\z:}', "");;
    Expect(1, 69733, '\p{InSC=  Brahmi_Joining_Number}', "");
    Expect(0, 69733, '\p{^InSC=  Brahmi_Joining_Number}', "");
    Expect(0, 69733, '\P{InSC=  Brahmi_Joining_Number}', "");
    Expect(1, 69733, '\P{^InSC=  Brahmi_Joining_Number}', "");
    Expect(0, 69734, '\p{InSC=  Brahmi_Joining_Number}', "");
    Expect(1, 69734, '\p{^InSC=  Brahmi_Joining_Number}', "");
    Expect(1, 69734, '\P{InSC=  Brahmi_Joining_Number}', "");
    Expect(0, 69734, '\P{^InSC=  Brahmi_Joining_Number}', "");
    Error('\p{Is_Indic_Syllabic_Category=	/a/Brahmi_JOINING_number}');
    Error('\P{Is_Indic_Syllabic_Category=	/a/Brahmi_JOINING_number}');
    Expect(1, 69733, '\p{Is_Indic_Syllabic_Category=brahmijoiningnumber}', "");
    Expect(0, 69733, '\p{^Is_Indic_Syllabic_Category=brahmijoiningnumber}', "");
    Expect(0, 69733, '\P{Is_Indic_Syllabic_Category=brahmijoiningnumber}', "");
    Expect(1, 69733, '\P{^Is_Indic_Syllabic_Category=brahmijoiningnumber}', "");
    Expect(0, 69734, '\p{Is_Indic_Syllabic_Category=brahmijoiningnumber}', "");
    Expect(1, 69734, '\p{^Is_Indic_Syllabic_Category=brahmijoiningnumber}', "");
    Expect(1, 69734, '\P{Is_Indic_Syllabic_Category=brahmijoiningnumber}', "");
    Expect(0, 69734, '\P{^Is_Indic_Syllabic_Category=brahmijoiningnumber}', "");
    Expect(1, 69733, '\p{Is_Indic_Syllabic_Category:    Brahmi_Joining_Number}', "");
    Expect(0, 69733, '\p{^Is_Indic_Syllabic_Category:    Brahmi_Joining_Number}', "");
    Expect(0, 69733, '\P{Is_Indic_Syllabic_Category:    Brahmi_Joining_Number}', "");
    Expect(1, 69733, '\P{^Is_Indic_Syllabic_Category:    Brahmi_Joining_Number}', "");
    Expect(0, 69734, '\p{Is_Indic_Syllabic_Category:    Brahmi_Joining_Number}', "");
    Expect(1, 69734, '\p{^Is_Indic_Syllabic_Category:    Brahmi_Joining_Number}', "");
    Expect(1, 69734, '\P{Is_Indic_Syllabic_Category:    Brahmi_Joining_Number}', "");
    Expect(0, 69734, '\P{^Is_Indic_Syllabic_Category:    Brahmi_Joining_Number}', "");
    Error('\p{Is_InSC=	/a/brahmi_Joining_Number}');
    Error('\P{Is_InSC=	/a/brahmi_Joining_Number}');
    Expect(1, 69733, '\p{Is_InSC=brahmijoiningnumber}', "");
    Expect(0, 69733, '\p{^Is_InSC=brahmijoiningnumber}', "");
    Expect(0, 69733, '\P{Is_InSC=brahmijoiningnumber}', "");
    Expect(1, 69733, '\P{^Is_InSC=brahmijoiningnumber}', "");
    Expect(0, 69734, '\p{Is_InSC=brahmijoiningnumber}', "");
    Expect(1, 69734, '\p{^Is_InSC=brahmijoiningnumber}', "");
    Expect(1, 69734, '\P{Is_InSC=brahmijoiningnumber}', "");
    Expect(0, 69734, '\P{^Is_InSC=brahmijoiningnumber}', "");
    Expect(1, 69733, '\p{Is_InSC=- brahmi_joining_number}', "");
    Expect(0, 69733, '\p{^Is_InSC=- brahmi_joining_number}', "");
    Expect(0, 69733, '\P{Is_InSC=- brahmi_joining_number}', "");
    Expect(1, 69733, '\P{^Is_InSC=- brahmi_joining_number}', "");
    Expect(0, 69734, '\p{Is_InSC=- brahmi_joining_number}', "");
    Expect(1, 69734, '\p{^Is_InSC=- brahmi_joining_number}', "");
    Expect(1, 69734, '\P{Is_InSC=- brahmi_joining_number}', "");
    Expect(0, 69734, '\P{^Is_InSC=- brahmi_joining_number}', "");
    Error('\p{Indic_Syllabic_Category=:=_Cantillation_Mark}');
    Error('\P{Indic_Syllabic_Category=:=_Cantillation_Mark}');
    Expect(1, 70516, '\p{Indic_Syllabic_Category=:\ACantillation_Mark\z:}', "");;
    Expect(0, 70517, '\p{Indic_Syllabic_Category=:\ACantillation_Mark\z:}', "");;
    Expect(1, 70516, '\p{Indic_Syllabic_Category=cantillationmark}', "");
    Expect(0, 70516, '\p{^Indic_Syllabic_Category=cantillationmark}', "");
    Expect(0, 70516, '\P{Indic_Syllabic_Category=cantillationmark}', "");
    Expect(1, 70516, '\P{^Indic_Syllabic_Category=cantillationmark}', "");
    Expect(0, 70517, '\p{Indic_Syllabic_Category=cantillationmark}', "");
    Expect(1, 70517, '\p{^Indic_Syllabic_Category=cantillationmark}', "");
    Expect(1, 70517, '\P{Indic_Syllabic_Category=cantillationmark}', "");
    Expect(0, 70517, '\P{^Indic_Syllabic_Category=cantillationmark}', "");
    Expect(1, 70516, '\p{Indic_Syllabic_Category=:\Acantillationmark\z:}', "");;
    Expect(0, 70517, '\p{Indic_Syllabic_Category=:\Acantillationmark\z:}', "");;
    Expect(1, 70516, '\p{Indic_Syllabic_Category=  Cantillation_Mark}', "");
    Expect(0, 70516, '\p{^Indic_Syllabic_Category=  Cantillation_Mark}', "");
    Expect(0, 70516, '\P{Indic_Syllabic_Category=  Cantillation_Mark}', "");
    Expect(1, 70516, '\P{^Indic_Syllabic_Category=  Cantillation_Mark}', "");
    Expect(0, 70517, '\p{Indic_Syllabic_Category=  Cantillation_Mark}', "");
    Expect(1, 70517, '\p{^Indic_Syllabic_Category=  Cantillation_Mark}', "");
    Expect(1, 70517, '\P{Indic_Syllabic_Category=  Cantillation_Mark}', "");
    Expect(0, 70517, '\P{^Indic_Syllabic_Category=  Cantillation_Mark}', "");
    Error('\p{InSC=/a/ CANTILLATION_mark}');
    Error('\P{InSC=/a/ CANTILLATION_mark}');
    Expect(1, 70516, '\p{InSC=:\ACantillation_Mark\z:}', "");;
    Expect(0, 70517, '\p{InSC=:\ACantillation_Mark\z:}', "");;
    Expect(1, 70516, '\p{InSC=cantillationmark}', "");
    Expect(0, 70516, '\p{^InSC=cantillationmark}', "");
    Expect(0, 70516, '\P{InSC=cantillationmark}', "");
    Expect(1, 70516, '\P{^InSC=cantillationmark}', "");
    Expect(0, 70517, '\p{InSC=cantillationmark}', "");
    Expect(1, 70517, '\p{^InSC=cantillationmark}', "");
    Expect(1, 70517, '\P{InSC=cantillationmark}', "");
    Expect(0, 70517, '\P{^InSC=cantillationmark}', "");
    Expect(1, 70516, '\p{InSC=:\Acantillationmark\z:}', "");;
    Expect(0, 70517, '\p{InSC=:\Acantillationmark\z:}', "");;
    Expect(1, 70516, '\p{InSC=_	CANTILLATION_Mark}', "");
    Expect(0, 70516, '\p{^InSC=_	CANTILLATION_Mark}', "");
    Expect(0, 70516, '\P{InSC=_	CANTILLATION_Mark}', "");
    Expect(1, 70516, '\P{^InSC=_	CANTILLATION_Mark}', "");
    Expect(0, 70517, '\p{InSC=_	CANTILLATION_Mark}', "");
    Expect(1, 70517, '\p{^InSC=_	CANTILLATION_Mark}', "");
    Expect(1, 70517, '\P{InSC=_	CANTILLATION_Mark}', "");
    Expect(0, 70517, '\P{^InSC=_	CANTILLATION_Mark}', "");
    Error('\p{Is_Indic_Syllabic_Category=_/a/Cantillation_mark}');
    Error('\P{Is_Indic_Syllabic_Category=_/a/Cantillation_mark}');
    Expect(1, 70516, '\p{Is_Indic_Syllabic_Category=cantillationmark}', "");
    Expect(0, 70516, '\p{^Is_Indic_Syllabic_Category=cantillationmark}', "");
    Expect(0, 70516, '\P{Is_Indic_Syllabic_Category=cantillationmark}', "");
    Expect(1, 70516, '\P{^Is_Indic_Syllabic_Category=cantillationmark}', "");
    Expect(0, 70517, '\p{Is_Indic_Syllabic_Category=cantillationmark}', "");
    Expect(1, 70517, '\p{^Is_Indic_Syllabic_Category=cantillationmark}', "");
    Expect(1, 70517, '\P{Is_Indic_Syllabic_Category=cantillationmark}', "");
    Expect(0, 70517, '\P{^Is_Indic_Syllabic_Category=cantillationmark}', "");
    Expect(1, 70516, '\p{Is_Indic_Syllabic_Category= 	Cantillation_mark}', "");
    Expect(0, 70516, '\p{^Is_Indic_Syllabic_Category= 	Cantillation_mark}', "");
    Expect(0, 70516, '\P{Is_Indic_Syllabic_Category= 	Cantillation_mark}', "");
    Expect(1, 70516, '\P{^Is_Indic_Syllabic_Category= 	Cantillation_mark}', "");
    Expect(0, 70517, '\p{Is_Indic_Syllabic_Category= 	Cantillation_mark}', "");
    Expect(1, 70517, '\p{^Is_Indic_Syllabic_Category= 	Cantillation_mark}', "");
    Expect(1, 70517, '\P{Is_Indic_Syllabic_Category= 	Cantillation_mark}', "");
    Expect(0, 70517, '\P{^Is_Indic_Syllabic_Category= 	Cantillation_mark}', "");
    Error('\p{Is_InSC=/a/_Cantillation_Mark}');
    Error('\P{Is_InSC=/a/_Cantillation_Mark}');
    Expect(1, 70516, '\p{Is_InSC=cantillationmark}', "");
    Expect(0, 70516, '\p{^Is_InSC=cantillationmark}', "");
    Expect(0, 70516, '\P{Is_InSC=cantillationmark}', "");
    Expect(1, 70516, '\P{^Is_InSC=cantillationmark}', "");
    Expect(0, 70517, '\p{Is_InSC=cantillationmark}', "");
    Expect(1, 70517, '\p{^Is_InSC=cantillationmark}', "");
    Expect(1, 70517, '\P{Is_InSC=cantillationmark}', "");
    Expect(0, 70517, '\P{^Is_InSC=cantillationmark}', "");
    Expect(1, 70516, '\p{Is_InSC:	 _Cantillation_mark}', "");
    Expect(0, 70516, '\p{^Is_InSC:	 _Cantillation_mark}', "");
    Expect(0, 70516, '\P{Is_InSC:	 _Cantillation_mark}', "");
    Expect(1, 70516, '\P{^Is_InSC:	 _Cantillation_mark}', "");
    Expect(0, 70517, '\p{Is_InSC:	 _Cantillation_mark}', "");
    Expect(1, 70517, '\p{^Is_InSC:	 _Cantillation_mark}', "");
    Expect(1, 70517, '\P{Is_InSC:	 _Cantillation_mark}', "");
    Expect(0, 70517, '\P{^Is_InSC:	 _Cantillation_mark}', "");
    Error('\p{Indic_Syllabic_Category=:=--consonant}');
    Error('\P{Indic_Syllabic_Category=:=--consonant}');
    Expect(1, 73523, '\p{Indic_Syllabic_Category=:\AConsonant\z:}', "");;
    Expect(0, 73524, '\p{Indic_Syllabic_Category=:\AConsonant\z:}', "");;
    Expect(1, 73523, '\p{Indic_Syllabic_Category=consonant}', "");
    Expect(0, 73523, '\p{^Indic_Syllabic_Category=consonant}', "");
    Expect(0, 73523, '\P{Indic_Syllabic_Category=consonant}', "");
    Expect(1, 73523, '\P{^Indic_Syllabic_Category=consonant}', "");
    Expect(0, 73524, '\p{Indic_Syllabic_Category=consonant}', "");
    Expect(1, 73524, '\p{^Indic_Syllabic_Category=consonant}', "");
    Expect(1, 73524, '\P{Indic_Syllabic_Category=consonant}', "");
    Expect(0, 73524, '\P{^Indic_Syllabic_Category=consonant}', "");
    Expect(1, 73523, '\p{Indic_Syllabic_Category=:\Aconsonant\z:}', "");;
    Expect(0, 73524, '\p{Indic_Syllabic_Category=:\Aconsonant\z:}', "");;
    Expect(1, 73523, '\p{Indic_Syllabic_Category=__consonant}', "");
    Expect(0, 73523, '\p{^Indic_Syllabic_Category=__consonant}', "");
    Expect(0, 73523, '\P{Indic_Syllabic_Category=__consonant}', "");
    Expect(1, 73523, '\P{^Indic_Syllabic_Category=__consonant}', "");
    Expect(0, 73524, '\p{Indic_Syllabic_Category=__consonant}', "");
    Expect(1, 73524, '\p{^Indic_Syllabic_Category=__consonant}', "");
    Expect(1, 73524, '\P{Indic_Syllabic_Category=__consonant}', "");
    Expect(0, 73524, '\P{^Indic_Syllabic_Category=__consonant}', "");
    Error('\p{InSC=:= Consonant}');
    Error('\P{InSC=:= Consonant}');
    Expect(1, 73523, '\p{InSC=:\AConsonant\z:}', "");;
    Expect(0, 73524, '\p{InSC=:\AConsonant\z:}', "");;
    Expect(1, 73523, '\p{InSC=consonant}', "");
    Expect(0, 73523, '\p{^InSC=consonant}', "");
    Expect(0, 73523, '\P{InSC=consonant}', "");
    Expect(1, 73523, '\P{^InSC=consonant}', "");
    Expect(0, 73524, '\p{InSC=consonant}', "");
    Expect(1, 73524, '\p{^InSC=consonant}', "");
    Expect(1, 73524, '\P{InSC=consonant}', "");
    Expect(0, 73524, '\P{^InSC=consonant}', "");
    Expect(1, 73523, '\p{InSC=:\Aconsonant\z:}', "");;
    Expect(0, 73524, '\p{InSC=:\Aconsonant\z:}', "");;
    Expect(1, 73523, '\p{InSC=-_consonant}', "");
    Expect(0, 73523, '\p{^InSC=-_consonant}', "");
    Expect(0, 73523, '\P{InSC=-_consonant}', "");
    Expect(1, 73523, '\P{^InSC=-_consonant}', "");
    Expect(0, 73524, '\p{InSC=-_consonant}', "");
    Expect(1, 73524, '\p{^InSC=-_consonant}', "");
    Expect(1, 73524, '\P{InSC=-_consonant}', "");
    Expect(0, 73524, '\P{^InSC=-_consonant}', "");
    Error('\p{Is_Indic_Syllabic_Category=/a/-Consonant}');
    Error('\P{Is_Indic_Syllabic_Category=/a/-Consonant}');
    Expect(1, 73523, '\p{Is_Indic_Syllabic_Category:	consonant}', "");
    Expect(0, 73523, '\p{^Is_Indic_Syllabic_Category:	consonant}', "");
    Expect(0, 73523, '\P{Is_Indic_Syllabic_Category:	consonant}', "");
    Expect(1, 73523, '\P{^Is_Indic_Syllabic_Category:	consonant}', "");
    Expect(0, 73524, '\p{Is_Indic_Syllabic_Category:	consonant}', "");
    Expect(1, 73524, '\p{^Is_Indic_Syllabic_Category:	consonant}', "");
    Expect(1, 73524, '\P{Is_Indic_Syllabic_Category:	consonant}', "");
    Expect(0, 73524, '\P{^Is_Indic_Syllabic_Category:	consonant}', "");
    Expect(1, 73523, '\p{Is_Indic_Syllabic_Category=Consonant}', "");
    Expect(0, 73523, '\p{^Is_Indic_Syllabic_Category=Consonant}', "");
    Expect(0, 73523, '\P{Is_Indic_Syllabic_Category=Consonant}', "");
    Expect(1, 73523, '\P{^Is_Indic_Syllabic_Category=Consonant}', "");
    Expect(0, 73524, '\p{Is_Indic_Syllabic_Category=Consonant}', "");
    Expect(1, 73524, '\p{^Is_Indic_Syllabic_Category=Consonant}', "");
    Expect(1, 73524, '\P{Is_Indic_Syllabic_Category=Consonant}', "");
    Expect(0, 73524, '\P{^Is_Indic_Syllabic_Category=Consonant}', "");
    Error('\p{Is_InSC= Consonant/a/}');
    Error('\P{Is_InSC= Consonant/a/}');
    Expect(1, 73523, '\p{Is_InSC=consonant}', "");
    Expect(0, 73523, '\p{^Is_InSC=consonant}', "");
    Expect(0, 73523, '\P{Is_InSC=consonant}', "");
    Expect(1, 73523, '\P{^Is_InSC=consonant}', "");
    Expect(0, 73524, '\p{Is_InSC=consonant}', "");
    Expect(1, 73524, '\p{^Is_InSC=consonant}', "");
    Expect(1, 73524, '\P{Is_InSC=consonant}', "");
    Expect(0, 73524, '\P{^Is_InSC=consonant}', "");
    Expect(1, 73523, '\p{Is_InSC:	 CONSONANT}', "");
    Expect(0, 73523, '\p{^Is_InSC:	 CONSONANT}', "");
    Expect(0, 73523, '\P{Is_InSC:	 CONSONANT}', "");
    Expect(1, 73523, '\P{^Is_InSC:	 CONSONANT}', "");
    Expect(0, 73524, '\p{Is_InSC:	 CONSONANT}', "");
    Expect(1, 73524, '\p{^Is_InSC:	 CONSONANT}', "");
    Expect(1, 73524, '\P{Is_InSC:	 CONSONANT}', "");
    Expect(0, 73524, '\P{^Is_InSC:	 CONSONANT}', "");
    Error('\p{Indic_Syllabic_Category=	-Consonant_Dead/a/}');
    Error('\P{Indic_Syllabic_Category=	-Consonant_Dead/a/}');
    Expect(1, 7411, '\p{Indic_Syllabic_Category=:\AConsonant_Dead\z:}', "");;
    Expect(0, 7412, '\p{Indic_Syllabic_Category=:\AConsonant_Dead\z:}', "");;
    Expect(1, 7411, '\p{Indic_Syllabic_Category=consonantdead}', "");
    Expect(0, 7411, '\p{^Indic_Syllabic_Category=consonantdead}', "");
    Expect(0, 7411, '\P{Indic_Syllabic_Category=consonantdead}', "");
    Expect(1, 7411, '\P{^Indic_Syllabic_Category=consonantdead}', "");
    Expect(0, 7412, '\p{Indic_Syllabic_Category=consonantdead}', "");
    Expect(1, 7412, '\p{^Indic_Syllabic_Category=consonantdead}', "");
    Expect(1, 7412, '\P{Indic_Syllabic_Category=consonantdead}', "");
    Expect(0, 7412, '\P{^Indic_Syllabic_Category=consonantdead}', "");
    Expect(1, 7411, '\p{Indic_Syllabic_Category=:\Aconsonantdead\z:}', "");;
    Expect(0, 7412, '\p{Indic_Syllabic_Category=:\Aconsonantdead\z:}', "");;
    Expect(1, 7411, '\p{Indic_Syllabic_Category= _Consonant_dead}', "");
    Expect(0, 7411, '\p{^Indic_Syllabic_Category= _Consonant_dead}', "");
    Expect(0, 7411, '\P{Indic_Syllabic_Category= _Consonant_dead}', "");
    Expect(1, 7411, '\P{^Indic_Syllabic_Category= _Consonant_dead}', "");
    Expect(0, 7412, '\p{Indic_Syllabic_Category= _Consonant_dead}', "");
    Expect(1, 7412, '\p{^Indic_Syllabic_Category= _Consonant_dead}', "");
    Expect(1, 7412, '\P{Indic_Syllabic_Category= _Consonant_dead}', "");
    Expect(0, 7412, '\P{^Indic_Syllabic_Category= _Consonant_dead}', "");
    Error('\p{InSC=_consonant_dead/a/}');
    Error('\P{InSC=_consonant_dead/a/}');
    Expect(1, 7411, '\p{InSC=:\AConsonant_Dead\z:}', "");;
    Expect(0, 7412, '\p{InSC=:\AConsonant_Dead\z:}', "");;
    Expect(1, 7411, '\p{InSC:	consonantdead}', "");
    Expect(0, 7411, '\p{^InSC:	consonantdead}', "");
    Expect(0, 7411, '\P{InSC:	consonantdead}', "");
    Expect(1, 7411, '\P{^InSC:	consonantdead}', "");
    Expect(0, 7412, '\p{InSC:	consonantdead}', "");
    Expect(1, 7412, '\p{^InSC:	consonantdead}', "");
    Expect(1, 7412, '\P{InSC:	consonantdead}', "");
    Expect(0, 7412, '\P{^InSC:	consonantdead}', "");
    Expect(1, 7411, '\p{InSC=:\Aconsonantdead\z:}', "");;
    Expect(0, 7412, '\p{InSC=:\Aconsonantdead\z:}', "");;
    Expect(1, 7411, '\p{InSC=__consonant_Dead}', "");
    Expect(0, 7411, '\p{^InSC=__consonant_Dead}', "");
    Expect(0, 7411, '\P{InSC=__consonant_Dead}', "");
    Expect(1, 7411, '\P{^InSC=__consonant_Dead}', "");
    Expect(0, 7412, '\p{InSC=__consonant_Dead}', "");
    Expect(1, 7412, '\p{^InSC=__consonant_Dead}', "");
    Expect(1, 7412, '\P{InSC=__consonant_Dead}', "");
    Expect(0, 7412, '\P{^InSC=__consonant_Dead}', "");
    Error('\p{Is_Indic_Syllabic_Category=	/a/Consonant_Dead}');
    Error('\P{Is_Indic_Syllabic_Category=	/a/Consonant_Dead}');
    Expect(1, 7411, '\p{Is_Indic_Syllabic_Category=consonantdead}', "");
    Expect(0, 7411, '\p{^Is_Indic_Syllabic_Category=consonantdead}', "");
    Expect(0, 7411, '\P{Is_Indic_Syllabic_Category=consonantdead}', "");
    Expect(1, 7411, '\P{^Is_Indic_Syllabic_Category=consonantdead}', "");
    Expect(0, 7412, '\p{Is_Indic_Syllabic_Category=consonantdead}', "");
    Expect(1, 7412, '\p{^Is_Indic_Syllabic_Category=consonantdead}', "");
    Expect(1, 7412, '\P{Is_Indic_Syllabic_Category=consonantdead}', "");
    Expect(0, 7412, '\P{^Is_Indic_Syllabic_Category=consonantdead}', "");
    Expect(1, 7411, '\p{Is_Indic_Syllabic_Category=-	Consonant_DEAD}', "");
    Expect(0, 7411, '\p{^Is_Indic_Syllabic_Category=-	Consonant_DEAD}', "");
    Expect(0, 7411, '\P{Is_Indic_Syllabic_Category=-	Consonant_DEAD}', "");
    Expect(1, 7411, '\P{^Is_Indic_Syllabic_Category=-	Consonant_DEAD}', "");
    Expect(0, 7412, '\p{Is_Indic_Syllabic_Category=-	Consonant_DEAD}', "");
    Expect(1, 7412, '\p{^Is_Indic_Syllabic_Category=-	Consonant_DEAD}', "");
    Expect(1, 7412, '\P{Is_Indic_Syllabic_Category=-	Consonant_DEAD}', "");
    Expect(0, 7412, '\P{^Is_Indic_Syllabic_Category=-	Consonant_DEAD}', "");
    Error('\p{Is_InSC=:=Consonant_Dead}');
    Error('\P{Is_InSC=:=Consonant_Dead}');
    Expect(1, 7411, '\p{Is_InSC=consonantdead}', "");
    Expect(0, 7411, '\p{^Is_InSC=consonantdead}', "");
    Expect(0, 7411, '\P{Is_InSC=consonantdead}', "");
    Expect(1, 7411, '\P{^Is_InSC=consonantdead}', "");
    Expect(0, 7412, '\p{Is_InSC=consonantdead}', "");
    Expect(1, 7412, '\p{^Is_InSC=consonantdead}', "");
    Expect(1, 7412, '\P{Is_InSC=consonantdead}', "");
    Expect(0, 7412, '\P{^Is_InSC=consonantdead}', "");
    Expect(1, 7411, '\p{Is_InSC=		Consonant_Dead}', "");
    Expect(0, 7411, '\p{^Is_InSC=		Consonant_Dead}', "");
    Expect(0, 7411, '\P{Is_InSC=		Consonant_Dead}', "");
    Expect(1, 7411, '\P{^Is_InSC=		Consonant_Dead}', "");
    Expect(0, 7412, '\p{Is_InSC=		Consonant_Dead}', "");
    Expect(1, 7412, '\p{^Is_InSC=		Consonant_Dead}', "");
    Expect(1, 7412, '\P{Is_InSC=		Consonant_Dead}', "");
    Expect(0, 7412, '\P{^Is_InSC=		Consonant_Dead}', "");
    Error('\p{Indic_Syllabic_Category:/a/_-Consonant_final}');
    Error('\P{Indic_Syllabic_Category:/a/_-Consonant_final}');
    Expect(1, 72341, '\p{Indic_Syllabic_Category=:\AConsonant_Final\z:}', "");;
    Expect(0, 72342, '\p{Indic_Syllabic_Category=:\AConsonant_Final\z:}', "");;
    Expect(1, 72341, '\p{Indic_Syllabic_Category=consonantfinal}', "");
    Expect(0, 72341, '\p{^Indic_Syllabic_Category=consonantfinal}', "");
    Expect(0, 72341, '\P{Indic_Syllabic_Category=consonantfinal}', "");
    Expect(1, 72341, '\P{^Indic_Syllabic_Category=consonantfinal}', "");
    Expect(0, 72342, '\p{Indic_Syllabic_Category=consonantfinal}', "");
    Expect(1, 72342, '\p{^Indic_Syllabic_Category=consonantfinal}', "");
    Expect(1, 72342, '\P{Indic_Syllabic_Category=consonantfinal}', "");
    Expect(0, 72342, '\P{^Indic_Syllabic_Category=consonantfinal}', "");
    Expect(1, 72341, '\p{Indic_Syllabic_Category=:\Aconsonantfinal\z:}', "");;
    Expect(0, 72342, '\p{Indic_Syllabic_Category=:\Aconsonantfinal\z:}', "");;
    Expect(1, 72341, '\p{Indic_Syllabic_Category=_ CONSONANT_final}', "");
    Expect(0, 72341, '\p{^Indic_Syllabic_Category=_ CONSONANT_final}', "");
    Expect(0, 72341, '\P{Indic_Syllabic_Category=_ CONSONANT_final}', "");
    Expect(1, 72341, '\P{^Indic_Syllabic_Category=_ CONSONANT_final}', "");
    Expect(0, 72342, '\p{Indic_Syllabic_Category=_ CONSONANT_final}', "");
    Expect(1, 72342, '\p{^Indic_Syllabic_Category=_ CONSONANT_final}', "");
    Expect(1, 72342, '\P{Indic_Syllabic_Category=_ CONSONANT_final}', "");
    Expect(0, 72342, '\P{^Indic_Syllabic_Category=_ CONSONANT_final}', "");
    Error('\p{InSC=-/a/Consonant_final}');
    Error('\P{InSC=-/a/Consonant_final}');
    Expect(1, 72341, '\p{InSC=:\AConsonant_Final\z:}', "");;
    Expect(0, 72342, '\p{InSC=:\AConsonant_Final\z:}', "");;
    Expect(1, 72341, '\p{InSC=consonantfinal}', "");
    Expect(0, 72341, '\p{^InSC=consonantfinal}', "");
    Expect(0, 72341, '\P{InSC=consonantfinal}', "");
    Expect(1, 72341, '\P{^InSC=consonantfinal}', "");
    Expect(0, 72342, '\p{InSC=consonantfinal}', "");
    Expect(1, 72342, '\p{^InSC=consonantfinal}', "");
    Expect(1, 72342, '\P{InSC=consonantfinal}', "");
    Expect(0, 72342, '\P{^InSC=consonantfinal}', "");
    Expect(1, 72341, '\p{InSC=:\Aconsonantfinal\z:}', "");;
    Expect(0, 72342, '\p{InSC=:\Aconsonantfinal\z:}', "");;
    Expect(1, 72341, '\p{InSC=	_Consonant_Final}', "");
    Expect(0, 72341, '\p{^InSC=	_Consonant_Final}', "");
    Expect(0, 72341, '\P{InSC=	_Consonant_Final}', "");
    Expect(1, 72341, '\P{^InSC=	_Consonant_Final}', "");
    Expect(0, 72342, '\p{InSC=	_Consonant_Final}', "");
    Expect(1, 72342, '\p{^InSC=	_Consonant_Final}', "");
    Expect(1, 72342, '\P{InSC=	_Consonant_Final}', "");
    Expect(0, 72342, '\P{^InSC=	_Consonant_Final}', "");
    Error('\p{Is_Indic_Syllabic_Category=_ CONSONANT_Final:=}');
    Error('\P{Is_Indic_Syllabic_Category=_ CONSONANT_Final:=}');
    Expect(1, 72341, '\p{Is_Indic_Syllabic_Category=consonantfinal}', "");
    Expect(0, 72341, '\p{^Is_Indic_Syllabic_Category=consonantfinal}', "");
    Expect(0, 72341, '\P{Is_Indic_Syllabic_Category=consonantfinal}', "");
    Expect(1, 72341, '\P{^Is_Indic_Syllabic_Category=consonantfinal}', "");
    Expect(0, 72342, '\p{Is_Indic_Syllabic_Category=consonantfinal}', "");
    Expect(1, 72342, '\p{^Is_Indic_Syllabic_Category=consonantfinal}', "");
    Expect(1, 72342, '\P{Is_Indic_Syllabic_Category=consonantfinal}', "");
    Expect(0, 72342, '\P{^Is_Indic_Syllabic_Category=consonantfinal}', "");
    Expect(1, 72341, '\p{Is_Indic_Syllabic_Category=_	Consonant_Final}', "");
    Expect(0, 72341, '\p{^Is_Indic_Syllabic_Category=_	Consonant_Final}', "");
    Expect(0, 72341, '\P{Is_Indic_Syllabic_Category=_	Consonant_Final}', "");
    Expect(1, 72341, '\P{^Is_Indic_Syllabic_Category=_	Consonant_Final}', "");
    Expect(0, 72342, '\p{Is_Indic_Syllabic_Category=_	Consonant_Final}', "");
    Expect(1, 72342, '\p{^Is_Indic_Syllabic_Category=_	Consonant_Final}', "");
    Expect(1, 72342, '\P{Is_Indic_Syllabic_Category=_	Consonant_Final}', "");
    Expect(0, 72342, '\P{^Is_Indic_Syllabic_Category=_	Consonant_Final}', "");
    Error('\p{Is_InSC=_:=Consonant_Final}');
    Error('\P{Is_InSC=_:=Consonant_Final}');
    Expect(1, 72341, '\p{Is_InSC=consonantfinal}', "");
    Expect(0, 72341, '\p{^Is_InSC=consonantfinal}', "");
    Expect(0, 72341, '\P{Is_InSC=consonantfinal}', "");
    Expect(1, 72341, '\P{^Is_InSC=consonantfinal}', "");
    Expect(0, 72342, '\p{Is_InSC=consonantfinal}', "");
    Expect(1, 72342, '\p{^Is_InSC=consonantfinal}', "");
    Expect(1, 72342, '\P{Is_InSC=consonantfinal}', "");
    Expect(0, 72342, '\P{^Is_InSC=consonantfinal}', "");
    Expect(1, 72341, '\p{Is_InSC: -consonant_FINAL}', "");
    Expect(0, 72341, '\p{^Is_InSC: -consonant_FINAL}', "");
    Expect(0, 72341, '\P{Is_InSC: -consonant_FINAL}', "");
    Expect(1, 72341, '\P{^Is_InSC: -consonant_FINAL}', "");
    Expect(0, 72342, '\p{Is_InSC: -consonant_FINAL}', "");
    Expect(1, 72342, '\p{^Is_InSC: -consonant_FINAL}', "");
    Expect(1, 72342, '\P{Is_InSC: -consonant_FINAL}', "");
    Expect(0, 72342, '\P{^Is_InSC: -consonant_FINAL}', "");
    Error('\p{Indic_Syllabic_Category:	:= 	consonant_head_letter}');
    Error('\P{Indic_Syllabic_Category:	:= 	consonant_head_letter}');
    Expect(1, 3980, '\p{Indic_Syllabic_Category=:\AConsonant_Head_Letter\z:}', "");;
    Expect(0, 3981, '\p{Indic_Syllabic_Category=:\AConsonant_Head_Letter\z:}', "");;
    Expect(1, 3980, '\p{Indic_Syllabic_Category=consonantheadletter}', "");
    Expect(0, 3980, '\p{^Indic_Syllabic_Category=consonantheadletter}', "");
    Expect(0, 3980, '\P{Indic_Syllabic_Category=consonantheadletter}', "");
    Expect(1, 3980, '\P{^Indic_Syllabic_Category=consonantheadletter}', "");
    Expect(0, 3981, '\p{Indic_Syllabic_Category=consonantheadletter}', "");
    Expect(1, 3981, '\p{^Indic_Syllabic_Category=consonantheadletter}', "");
    Expect(1, 3981, '\P{Indic_Syllabic_Category=consonantheadletter}', "");
    Expect(0, 3981, '\P{^Indic_Syllabic_Category=consonantheadletter}', "");
    Expect(1, 3980, '\p{Indic_Syllabic_Category=:\Aconsonantheadletter\z:}', "");;
    Expect(0, 3981, '\p{Indic_Syllabic_Category=:\Aconsonantheadletter\z:}', "");;
    Expect(1, 3980, '\p{Indic_Syllabic_Category=  Consonant_Head_LETTER}', "");
    Expect(0, 3980, '\p{^Indic_Syllabic_Category=  Consonant_Head_LETTER}', "");
    Expect(0, 3980, '\P{Indic_Syllabic_Category=  Consonant_Head_LETTER}', "");
    Expect(1, 3980, '\P{^Indic_Syllabic_Category=  Consonant_Head_LETTER}', "");
    Expect(0, 3981, '\p{Indic_Syllabic_Category=  Consonant_Head_LETTER}', "");
    Expect(1, 3981, '\p{^Indic_Syllabic_Category=  Consonant_Head_LETTER}', "");
    Expect(1, 3981, '\P{Indic_Syllabic_Category=  Consonant_Head_LETTER}', "");
    Expect(0, 3981, '\P{^Indic_Syllabic_Category=  Consonant_Head_LETTER}', "");
    Error('\p{InSC=:= Consonant_head_Letter}');
    Error('\P{InSC=:= Consonant_head_Letter}');
    Expect(1, 3980, '\p{InSC=:\AConsonant_Head_Letter\z:}', "");;
    Expect(0, 3981, '\p{InSC=:\AConsonant_Head_Letter\z:}', "");;
    Expect(1, 3980, '\p{InSC=consonantheadletter}', "");
    Expect(0, 3980, '\p{^InSC=consonantheadletter}', "");
    Expect(0, 3980, '\P{InSC=consonantheadletter}', "");
    Expect(1, 3980, '\P{^InSC=consonantheadletter}', "");
    Expect(0, 3981, '\p{InSC=consonantheadletter}', "");
    Expect(1, 3981, '\p{^InSC=consonantheadletter}', "");
    Expect(1, 3981, '\P{InSC=consonantheadletter}', "");
    Expect(0, 3981, '\P{^InSC=consonantheadletter}', "");
    Expect(1, 3980, '\p{InSC=:\Aconsonantheadletter\z:}', "");;
    Expect(0, 3981, '\p{InSC=:\Aconsonantheadletter\z:}', "");;
    Expect(1, 3980, '\p{InSC=-	CONSONANT_head_LETTER}', "");
    Expect(0, 3980, '\p{^InSC=-	CONSONANT_head_LETTER}', "");
    Expect(0, 3980, '\P{InSC=-	CONSONANT_head_LETTER}', "");
    Expect(1, 3980, '\P{^InSC=-	CONSONANT_head_LETTER}', "");
    Expect(0, 3981, '\p{InSC=-	CONSONANT_head_LETTER}', "");
    Expect(1, 3981, '\p{^InSC=-	CONSONANT_head_LETTER}', "");
    Expect(1, 3981, '\P{InSC=-	CONSONANT_head_LETTER}', "");
    Expect(0, 3981, '\P{^InSC=-	CONSONANT_head_LETTER}', "");
    Error('\p{Is_Indic_Syllabic_Category=	_Consonant_Head_Letter:=}');
    Error('\P{Is_Indic_Syllabic_Category=	_Consonant_Head_Letter:=}');
    Expect(1, 3980, '\p{Is_Indic_Syllabic_Category=consonantheadletter}', "");
    Expect(0, 3980, '\p{^Is_Indic_Syllabic_Category=consonantheadletter}', "");
    Expect(0, 3980, '\P{Is_Indic_Syllabic_Category=consonantheadletter}', "");
    Expect(1, 3980, '\P{^Is_Indic_Syllabic_Category=consonantheadletter}', "");
    Expect(0, 3981, '\p{Is_Indic_Syllabic_Category=consonantheadletter}', "");
    Expect(1, 3981, '\p{^Is_Indic_Syllabic_Category=consonantheadletter}', "");
    Expect(1, 3981, '\P{Is_Indic_Syllabic_Category=consonantheadletter}', "");
    Expect(0, 3981, '\P{^Is_Indic_Syllabic_Category=consonantheadletter}', "");
    Expect(1, 3980, '\p{Is_Indic_Syllabic_Category=-	consonant_HEAD_Letter}', "");
    Expect(0, 3980, '\p{^Is_Indic_Syllabic_Category=-	consonant_HEAD_Letter}', "");
    Expect(0, 3980, '\P{Is_Indic_Syllabic_Category=-	consonant_HEAD_Letter}', "");
    Expect(1, 3980, '\P{^Is_Indic_Syllabic_Category=-	consonant_HEAD_Letter}', "");
    Expect(0, 3981, '\p{Is_Indic_Syllabic_Category=-	consonant_HEAD_Letter}', "");
    Expect(1, 3981, '\p{^Is_Indic_Syllabic_Category=-	consonant_HEAD_Letter}', "");
    Expect(1, 3981, '\P{Is_Indic_Syllabic_Category=-	consonant_HEAD_Letter}', "");
    Expect(0, 3981, '\P{^Is_Indic_Syllabic_Category=-	consonant_HEAD_Letter}', "");
    Error('\p{Is_InSC=	Consonant_head_Letter:=}');
    Error('\P{Is_InSC=	Consonant_head_Letter:=}');
    Expect(1, 3980, '\p{Is_InSC=consonantheadletter}', "");
    Expect(0, 3980, '\p{^Is_InSC=consonantheadletter}', "");
    Expect(0, 3980, '\P{Is_InSC=consonantheadletter}', "");
    Expect(1, 3980, '\P{^Is_InSC=consonantheadletter}', "");
    Expect(0, 3981, '\p{Is_InSC=consonantheadletter}', "");
    Expect(1, 3981, '\p{^Is_InSC=consonantheadletter}', "");
    Expect(1, 3981, '\P{Is_InSC=consonantheadletter}', "");
    Expect(0, 3981, '\P{^Is_InSC=consonantheadletter}', "");
    Expect(1, 3980, '\p{Is_InSC=_CONSONANT_head_Letter}', "");
    Expect(0, 3980, '\p{^Is_InSC=_CONSONANT_head_Letter}', "");
    Expect(0, 3980, '\P{Is_InSC=_CONSONANT_head_Letter}', "");
    Expect(1, 3980, '\P{^Is_InSC=_CONSONANT_head_Letter}', "");
    Expect(0, 3981, '\p{Is_InSC=_CONSONANT_head_Letter}', "");
    Expect(1, 3981, '\p{^Is_InSC=_CONSONANT_head_Letter}', "");
    Expect(1, 3981, '\P{Is_InSC=_CONSONANT_head_Letter}', "");
    Expect(0, 3981, '\P{^Is_InSC=_CONSONANT_head_Letter}', "");
    Error('\p{Indic_Syllabic_Category=_ Consonant_Initial_Postfixed/a/}');
    Error('\P{Indic_Syllabic_Category=_ Consonant_Initial_Postfixed/a/}');
    Expect(1, 6746, '\p{Indic_Syllabic_Category=:\AConsonant_Initial_Postfixed\z:}', "");;
    Expect(0, 6747, '\p{Indic_Syllabic_Category=:\AConsonant_Initial_Postfixed\z:}', "");;
    Expect(1, 6746, '\p{Indic_Syllabic_Category:	consonantinitialpostfixed}', "");
    Expect(0, 6746, '\p{^Indic_Syllabic_Category:	consonantinitialpostfixed}', "");
    Expect(0, 6746, '\P{Indic_Syllabic_Category:	consonantinitialpostfixed}', "");
    Expect(1, 6746, '\P{^Indic_Syllabic_Category:	consonantinitialpostfixed}', "");
    Expect(0, 6747, '\p{Indic_Syllabic_Category:	consonantinitialpostfixed}', "");
    Expect(1, 6747, '\p{^Indic_Syllabic_Category:	consonantinitialpostfixed}', "");
    Expect(1, 6747, '\P{Indic_Syllabic_Category:	consonantinitialpostfixed}', "");
    Expect(0, 6747, '\P{^Indic_Syllabic_Category:	consonantinitialpostfixed}', "");
    Expect(1, 6746, '\p{Indic_Syllabic_Category=:\Aconsonantinitialpostfixed\z:}', "");;
    Expect(0, 6747, '\p{Indic_Syllabic_Category=:\Aconsonantinitialpostfixed\z:}', "");;
    Expect(1, 6746, '\p{Indic_Syllabic_Category=--consonant_Initial_Postfixed}', "");
    Expect(0, 6746, '\p{^Indic_Syllabic_Category=--consonant_Initial_Postfixed}', "");
    Expect(0, 6746, '\P{Indic_Syllabic_Category=--consonant_Initial_Postfixed}', "");
    Expect(1, 6746, '\P{^Indic_Syllabic_Category=--consonant_Initial_Postfixed}', "");
    Expect(0, 6747, '\p{Indic_Syllabic_Category=--consonant_Initial_Postfixed}', "");
    Expect(1, 6747, '\p{^Indic_Syllabic_Category=--consonant_Initial_Postfixed}', "");
    Expect(1, 6747, '\P{Indic_Syllabic_Category=--consonant_Initial_Postfixed}', "");
    Expect(0, 6747, '\P{^Indic_Syllabic_Category=--consonant_Initial_Postfixed}', "");
    Error('\p{InSC=	Consonant_initial_POSTFIXED:=}');
    Error('\P{InSC=	Consonant_initial_POSTFIXED:=}');
    Expect(1, 6746, '\p{InSC=:\AConsonant_Initial_Postfixed\z:}', "");;
    Expect(0, 6747, '\p{InSC=:\AConsonant_Initial_Postfixed\z:}', "");;
    Expect(1, 6746, '\p{InSC=consonantinitialpostfixed}', "");
    Expect(0, 6746, '\p{^InSC=consonantinitialpostfixed}', "");
    Expect(0, 6746, '\P{InSC=consonantinitialpostfixed}', "");
    Expect(1, 6746, '\P{^InSC=consonantinitialpostfixed}', "");
    Expect(0, 6747, '\p{InSC=consonantinitialpostfixed}', "");
    Expect(1, 6747, '\p{^InSC=consonantinitialpostfixed}', "");
    Expect(1, 6747, '\P{InSC=consonantinitialpostfixed}', "");
    Expect(0, 6747, '\P{^InSC=consonantinitialpostfixed}', "");
    Expect(1, 6746, '\p{InSC=:\Aconsonantinitialpostfixed\z:}', "");;
    Expect(0, 6747, '\p{InSC=:\Aconsonantinitialpostfixed\z:}', "");;
    Expect(1, 6746, '\p{InSC=_consonant_INITIAL_postfixed}', "");
    Expect(0, 6746, '\p{^InSC=_consonant_INITIAL_postfixed}', "");
    Expect(0, 6746, '\P{InSC=_consonant_INITIAL_postfixed}', "");
    Expect(1, 6746, '\P{^InSC=_consonant_INITIAL_postfixed}', "");
    Expect(0, 6747, '\p{InSC=_consonant_INITIAL_postfixed}', "");
    Expect(1, 6747, '\p{^InSC=_consonant_INITIAL_postfixed}', "");
    Expect(1, 6747, '\P{InSC=_consonant_INITIAL_postfixed}', "");
    Expect(0, 6747, '\P{^InSC=_consonant_INITIAL_postfixed}', "");
    Error('\p{Is_Indic_Syllabic_Category=/a/Consonant_Initial_Postfixed}');
    Error('\P{Is_Indic_Syllabic_Category=/a/Consonant_Initial_Postfixed}');
    Expect(1, 6746, '\p{Is_Indic_Syllabic_Category:	consonantinitialpostfixed}', "");
    Expect(0, 6746, '\p{^Is_Indic_Syllabic_Category:	consonantinitialpostfixed}', "");
    Expect(0, 6746, '\P{Is_Indic_Syllabic_Category:	consonantinitialpostfixed}', "");
    Expect(1, 6746, '\P{^Is_Indic_Syllabic_Category:	consonantinitialpostfixed}', "");
    Expect(0, 6747, '\p{Is_Indic_Syllabic_Category:	consonantinitialpostfixed}', "");
    Expect(1, 6747, '\p{^Is_Indic_Syllabic_Category:	consonantinitialpostfixed}', "");
    Expect(1, 6747, '\P{Is_Indic_Syllabic_Category:	consonantinitialpostfixed}', "");
    Expect(0, 6747, '\P{^Is_Indic_Syllabic_Category:	consonantinitialpostfixed}', "");
    Expect(1, 6746, '\p{Is_Indic_Syllabic_Category= _Consonant_Initial_POSTFIXED}', "");
    Expect(0, 6746, '\p{^Is_Indic_Syllabic_Category= _Consonant_Initial_POSTFIXED}', "");
    Expect(0, 6746, '\P{Is_Indic_Syllabic_Category= _Consonant_Initial_POSTFIXED}', "");
    Expect(1, 6746, '\P{^Is_Indic_Syllabic_Category= _Consonant_Initial_POSTFIXED}', "");
    Expect(0, 6747, '\p{Is_Indic_Syllabic_Category= _Consonant_Initial_POSTFIXED}', "");
    Expect(1, 6747, '\p{^Is_Indic_Syllabic_Category= _Consonant_Initial_POSTFIXED}', "");
    Expect(1, 6747, '\P{Is_Indic_Syllabic_Category= _Consonant_Initial_POSTFIXED}', "");
    Expect(0, 6747, '\P{^Is_Indic_Syllabic_Category= _Consonant_Initial_POSTFIXED}', "");
    Error('\p{Is_InSC=/a/--Consonant_initial_postfixed}');
    Error('\P{Is_InSC=/a/--Consonant_initial_postfixed}');
    Expect(1, 6746, '\p{Is_InSC=consonantinitialpostfixed}', "");
    Expect(0, 6746, '\p{^Is_InSC=consonantinitialpostfixed}', "");
    Expect(0, 6746, '\P{Is_InSC=consonantinitialpostfixed}', "");
    Expect(1, 6746, '\P{^Is_InSC=consonantinitialpostfixed}', "");
    Expect(0, 6747, '\p{Is_InSC=consonantinitialpostfixed}', "");
    Expect(1, 6747, '\p{^Is_InSC=consonantinitialpostfixed}', "");
    Expect(1, 6747, '\P{Is_InSC=consonantinitialpostfixed}', "");
    Expect(0, 6747, '\P{^Is_InSC=consonantinitialpostfixed}', "");
    Expect(1, 6746, '\p{Is_InSC=		consonant_Initial_Postfixed}', "");
    Expect(0, 6746, '\p{^Is_InSC=		consonant_Initial_Postfixed}', "");
    Expect(0, 6746, '\P{Is_InSC=		consonant_Initial_Postfixed}', "");
    Expect(1, 6746, '\P{^Is_InSC=		consonant_Initial_Postfixed}', "");
    Expect(0, 6747, '\p{Is_InSC=		consonant_Initial_Postfixed}', "");
    Expect(1, 6747, '\p{^Is_InSC=		consonant_Initial_Postfixed}', "");
    Expect(1, 6747, '\P{Is_InSC=		consonant_Initial_Postfixed}', "");
    Expect(0, 6747, '\P{^Is_InSC=		consonant_Initial_Postfixed}', "");
    Error('\p{Indic_Syllabic_Category=_:=consonant_Killer}');
    Error('\P{Indic_Syllabic_Category=_:=consonant_Killer}');
    Expect(1, 6093, '\p{Indic_Syllabic_Category=:\AConsonant_Killer\z:}', "");;
    Expect(0, 6094, '\p{Indic_Syllabic_Category=:\AConsonant_Killer\z:}', "");;
    Expect(1, 6093, '\p{Indic_Syllabic_Category=consonantkiller}', "");
    Expect(0, 6093, '\p{^Indic_Syllabic_Category=consonantkiller}', "");
    Expect(0, 6093, '\P{Indic_Syllabic_Category=consonantkiller}', "");
    Expect(1, 6093, '\P{^Indic_Syllabic_Category=consonantkiller}', "");
    Expect(0, 6094, '\p{Indic_Syllabic_Category=consonantkiller}', "");
    Expect(1, 6094, '\p{^Indic_Syllabic_Category=consonantkiller}', "");
    Expect(1, 6094, '\P{Indic_Syllabic_Category=consonantkiller}', "");
    Expect(0, 6094, '\P{^Indic_Syllabic_Category=consonantkiller}', "");
    Expect(1, 6093, '\p{Indic_Syllabic_Category=:\Aconsonantkiller\z:}', "");;
    Expect(0, 6094, '\p{Indic_Syllabic_Category=:\Aconsonantkiller\z:}', "");;
    Expect(1, 6093, '\p{Indic_Syllabic_Category=_-consonant_killer}', "");
    Expect(0, 6093, '\p{^Indic_Syllabic_Category=_-consonant_killer}', "");
    Expect(0, 6093, '\P{Indic_Syllabic_Category=_-consonant_killer}', "");
    Expect(1, 6093, '\P{^Indic_Syllabic_Category=_-consonant_killer}', "");
    Expect(0, 6094, '\p{Indic_Syllabic_Category=_-consonant_killer}', "");
    Expect(1, 6094, '\p{^Indic_Syllabic_Category=_-consonant_killer}', "");
    Expect(1, 6094, '\P{Indic_Syllabic_Category=_-consonant_killer}', "");
    Expect(0, 6094, '\P{^Indic_Syllabic_Category=_-consonant_killer}', "");
    Error('\p{InSC= -CONSONANT_killer/a/}');
    Error('\P{InSC= -CONSONANT_killer/a/}');
    Expect(1, 6093, '\p{InSC=:\AConsonant_Killer\z:}', "");;
    Expect(0, 6094, '\p{InSC=:\AConsonant_Killer\z:}', "");;
    Expect(1, 6093, '\p{InSC=consonantkiller}', "");
    Expect(0, 6093, '\p{^InSC=consonantkiller}', "");
    Expect(0, 6093, '\P{InSC=consonantkiller}', "");
    Expect(1, 6093, '\P{^InSC=consonantkiller}', "");
    Expect(0, 6094, '\p{InSC=consonantkiller}', "");
    Expect(1, 6094, '\p{^InSC=consonantkiller}', "");
    Expect(1, 6094, '\P{InSC=consonantkiller}', "");
    Expect(0, 6094, '\P{^InSC=consonantkiller}', "");
    Expect(1, 6093, '\p{InSC=:\Aconsonantkiller\z:}', "");;
    Expect(0, 6094, '\p{InSC=:\Aconsonantkiller\z:}', "");;
    Expect(1, 6093, '\p{InSC=_CONSONANT_killer}', "");
    Expect(0, 6093, '\p{^InSC=_CONSONANT_killer}', "");
    Expect(0, 6093, '\P{InSC=_CONSONANT_killer}', "");
    Expect(1, 6093, '\P{^InSC=_CONSONANT_killer}', "");
    Expect(0, 6094, '\p{InSC=_CONSONANT_killer}', "");
    Expect(1, 6094, '\p{^InSC=_CONSONANT_killer}', "");
    Expect(1, 6094, '\P{InSC=_CONSONANT_killer}', "");
    Expect(0, 6094, '\P{^InSC=_CONSONANT_killer}', "");
    Error('\p{Is_Indic_Syllabic_Category=- consonant_Killer/a/}');
    Error('\P{Is_Indic_Syllabic_Category=- consonant_Killer/a/}');
    Expect(1, 6093, '\p{Is_Indic_Syllabic_Category=consonantkiller}', "");
    Expect(0, 6093, '\p{^Is_Indic_Syllabic_Category=consonantkiller}', "");
    Expect(0, 6093, '\P{Is_Indic_Syllabic_Category=consonantkiller}', "");
    Expect(1, 6093, '\P{^Is_Indic_Syllabic_Category=consonantkiller}', "");
    Expect(0, 6094, '\p{Is_Indic_Syllabic_Category=consonantkiller}', "");
    Expect(1, 6094, '\p{^Is_Indic_Syllabic_Category=consonantkiller}', "");
    Expect(1, 6094, '\P{Is_Indic_Syllabic_Category=consonantkiller}', "");
    Expect(0, 6094, '\P{^Is_Indic_Syllabic_Category=consonantkiller}', "");
    Expect(1, 6093, '\p{Is_Indic_Syllabic_Category=  consonant_Killer}', "");
    Expect(0, 6093, '\p{^Is_Indic_Syllabic_Category=  consonant_Killer}', "");
    Expect(0, 6093, '\P{Is_Indic_Syllabic_Category=  consonant_Killer}', "");
    Expect(1, 6093, '\P{^Is_Indic_Syllabic_Category=  consonant_Killer}', "");
    Expect(0, 6094, '\p{Is_Indic_Syllabic_Category=  consonant_Killer}', "");
    Expect(1, 6094, '\p{^Is_Indic_Syllabic_Category=  consonant_Killer}', "");
    Expect(1, 6094, '\P{Is_Indic_Syllabic_Category=  consonant_Killer}', "");
    Expect(0, 6094, '\P{^Is_Indic_Syllabic_Category=  consonant_Killer}', "");
    Error('\p{Is_InSC= 	Consonant_Killer:=}');
    Error('\P{Is_InSC= 	Consonant_Killer:=}');
    Expect(1, 6093, '\p{Is_InSC=consonantkiller}', "");
    Expect(0, 6093, '\p{^Is_InSC=consonantkiller}', "");
    Expect(0, 6093, '\P{Is_InSC=consonantkiller}', "");
    Expect(1, 6093, '\P{^Is_InSC=consonantkiller}', "");
    Expect(0, 6094, '\p{Is_InSC=consonantkiller}', "");
    Expect(1, 6094, '\p{^Is_InSC=consonantkiller}', "");
    Expect(1, 6094, '\P{Is_InSC=consonantkiller}', "");
    Expect(0, 6094, '\P{^Is_InSC=consonantkiller}', "");
    Expect(1, 6093, '\p{Is_InSC=	-Consonant_Killer}', "");
    Expect(0, 6093, '\p{^Is_InSC=	-Consonant_Killer}', "");
    Expect(0, 6093, '\P{Is_InSC=	-Consonant_Killer}', "");
    Expect(1, 6093, '\P{^Is_InSC=	-Consonant_Killer}', "");
    Expect(0, 6094, '\p{Is_InSC=	-Consonant_Killer}', "");
    Expect(1, 6094, '\p{^Is_InSC=	-Consonant_Killer}', "");
    Expect(1, 6094, '\P{Is_InSC=	-Consonant_Killer}', "");
    Expect(0, 6094, '\P{^Is_InSC=	-Consonant_Killer}', "");
    Error('\p{Indic_Syllabic_Category=_Consonant_Medial/a/}');
    Error('\P{Indic_Syllabic_Category=_Consonant_Medial/a/}');
    Expect(1, 73031, '\p{Indic_Syllabic_Category=:\AConsonant_Medial\z:}', "");;
    Expect(0, 73032, '\p{Indic_Syllabic_Category=:\AConsonant_Medial\z:}', "");;
    Expect(1, 73031, '\p{Indic_Syllabic_Category=consonantmedial}', "");
    Expect(0, 73031, '\p{^Indic_Syllabic_Category=consonantmedial}', "");
    Expect(0, 73031, '\P{Indic_Syllabic_Category=consonantmedial}', "");
    Expect(1, 73031, '\P{^Indic_Syllabic_Category=consonantmedial}', "");
    Expect(0, 73032, '\p{Indic_Syllabic_Category=consonantmedial}', "");
    Expect(1, 73032, '\p{^Indic_Syllabic_Category=consonantmedial}', "");
    Expect(1, 73032, '\P{Indic_Syllabic_Category=consonantmedial}', "");
    Expect(0, 73032, '\P{^Indic_Syllabic_Category=consonantmedial}', "");
    Expect(1, 73031, '\p{Indic_Syllabic_Category=:\Aconsonantmedial\z:}', "");;
    Expect(0, 73032, '\p{Indic_Syllabic_Category=:\Aconsonantmedial\z:}', "");;
    Expect(1, 73031, '\p{Indic_Syllabic_Category=Consonant_Medial}', "");
    Expect(0, 73031, '\p{^Indic_Syllabic_Category=Consonant_Medial}', "");
    Expect(0, 73031, '\P{Indic_Syllabic_Category=Consonant_Medial}', "");
    Expect(1, 73031, '\P{^Indic_Syllabic_Category=Consonant_Medial}', "");
    Expect(0, 73032, '\p{Indic_Syllabic_Category=Consonant_Medial}', "");
    Expect(1, 73032, '\p{^Indic_Syllabic_Category=Consonant_Medial}', "");
    Expect(1, 73032, '\P{Indic_Syllabic_Category=Consonant_Medial}', "");
    Expect(0, 73032, '\P{^Indic_Syllabic_Category=Consonant_Medial}', "");
    Error('\p{InSC=	CONSONANT_Medial:=}');
    Error('\P{InSC=	CONSONANT_Medial:=}');
    Expect(1, 73031, '\p{InSC=:\AConsonant_Medial\z:}', "");;
    Expect(0, 73032, '\p{InSC=:\AConsonant_Medial\z:}', "");;
    Expect(1, 73031, '\p{InSC=consonantmedial}', "");
    Expect(0, 73031, '\p{^InSC=consonantmedial}', "");
    Expect(0, 73031, '\P{InSC=consonantmedial}', "");
    Expect(1, 73031, '\P{^InSC=consonantmedial}', "");
    Expect(0, 73032, '\p{InSC=consonantmedial}', "");
    Expect(1, 73032, '\p{^InSC=consonantmedial}', "");
    Expect(1, 73032, '\P{InSC=consonantmedial}', "");
    Expect(0, 73032, '\P{^InSC=consonantmedial}', "");
    Expect(1, 73031, '\p{InSC=:\Aconsonantmedial\z:}', "");;
    Expect(0, 73032, '\p{InSC=:\Aconsonantmedial\z:}', "");;
    Expect(1, 73031, '\p{InSC:   	Consonant_medial}', "");
    Expect(0, 73031, '\p{^InSC:   	Consonant_medial}', "");
    Expect(0, 73031, '\P{InSC:   	Consonant_medial}', "");
    Expect(1, 73031, '\P{^InSC:   	Consonant_medial}', "");
    Expect(0, 73032, '\p{InSC:   	Consonant_medial}', "");
    Expect(1, 73032, '\p{^InSC:   	Consonant_medial}', "");
    Expect(1, 73032, '\P{InSC:   	Consonant_medial}', "");
    Expect(0, 73032, '\P{^InSC:   	Consonant_medial}', "");
    Error('\p{Is_Indic_Syllabic_Category= :=consonant_Medial}');
    Error('\P{Is_Indic_Syllabic_Category= :=consonant_Medial}');
    Expect(1, 73031, '\p{Is_Indic_Syllabic_Category:	consonantmedial}', "");
    Expect(0, 73031, '\p{^Is_Indic_Syllabic_Category:	consonantmedial}', "");
    Expect(0, 73031, '\P{Is_Indic_Syllabic_Category:	consonantmedial}', "");
    Expect(1, 73031, '\P{^Is_Indic_Syllabic_Category:	consonantmedial}', "");
    Expect(0, 73032, '\p{Is_Indic_Syllabic_Category:	consonantmedial}', "");
    Expect(1, 73032, '\p{^Is_Indic_Syllabic_Category:	consonantmedial}', "");
    Expect(1, 73032, '\P{Is_Indic_Syllabic_Category:	consonantmedial}', "");
    Expect(0, 73032, '\P{^Is_Indic_Syllabic_Category:	consonantmedial}', "");
    Expect(1, 73031, '\p{Is_Indic_Syllabic_Category=_ CONSONANT_Medial}', "");
    Expect(0, 73031, '\p{^Is_Indic_Syllabic_Category=_ CONSONANT_Medial}', "");
    Expect(0, 73031, '\P{Is_Indic_Syllabic_Category=_ CONSONANT_Medial}', "");
    Expect(1, 73031, '\P{^Is_Indic_Syllabic_Category=_ CONSONANT_Medial}', "");
    Expect(0, 73032, '\p{Is_Indic_Syllabic_Category=_ CONSONANT_Medial}', "");
    Expect(1, 73032, '\p{^Is_Indic_Syllabic_Category=_ CONSONANT_Medial}', "");
    Expect(1, 73032, '\P{Is_Indic_Syllabic_Category=_ CONSONANT_Medial}', "");
    Expect(0, 73032, '\P{^Is_Indic_Syllabic_Category=_ CONSONANT_Medial}', "");
    Error('\p{Is_InSC=/a/	 CONSONANT_Medial}');
    Error('\P{Is_InSC=/a/	 CONSONANT_Medial}');
    Expect(1, 73031, '\p{Is_InSC:consonantmedial}', "");
    Expect(0, 73031, '\p{^Is_InSC:consonantmedial}', "");
    Expect(0, 73031, '\P{Is_InSC:consonantmedial}', "");
    Expect(1, 73031, '\P{^Is_InSC:consonantmedial}', "");
    Expect(0, 73032, '\p{Is_InSC:consonantmedial}', "");
    Expect(1, 73032, '\p{^Is_InSC:consonantmedial}', "");
    Expect(1, 73032, '\P{Is_InSC:consonantmedial}', "");
    Expect(0, 73032, '\P{^Is_InSC:consonantmedial}', "");
    Expect(1, 73031, '\p{Is_InSC=_-Consonant_MEDIAL}', "");
    Expect(0, 73031, '\p{^Is_InSC=_-Consonant_MEDIAL}', "");
    Expect(0, 73031, '\P{Is_InSC=_-Consonant_MEDIAL}', "");
    Expect(1, 73031, '\P{^Is_InSC=_-Consonant_MEDIAL}', "");
    Expect(0, 73032, '\p{Is_InSC=_-Consonant_MEDIAL}', "");
    Expect(1, 73032, '\p{^Is_InSC=_-Consonant_MEDIAL}', "");
    Expect(1, 73032, '\P{Is_InSC=_-Consonant_MEDIAL}', "");
    Expect(0, 73032, '\P{^Is_InSC=_-Consonant_MEDIAL}', "");
    Error('\p{Indic_Syllabic_Category= :=Consonant_Placeholder}');
    Error('\P{Indic_Syllabic_Category= :=Consonant_Placeholder}');
    Expect(1, 73458, '\p{Indic_Syllabic_Category=:\AConsonant_Placeholder\z:}', "");;
    Expect(0, 73459, '\p{Indic_Syllabic_Category=:\AConsonant_Placeholder\z:}', "");;
    Expect(1, 73458, '\p{Indic_Syllabic_Category=consonantplaceholder}', "");
    Expect(0, 73458, '\p{^Indic_Syllabic_Category=consonantplaceholder}', "");
    Expect(0, 73458, '\P{Indic_Syllabic_Category=consonantplaceholder}', "");
    Expect(1, 73458, '\P{^Indic_Syllabic_Category=consonantplaceholder}', "");
    Expect(0, 73459, '\p{Indic_Syllabic_Category=consonantplaceholder}', "");
    Expect(1, 73459, '\p{^Indic_Syllabic_Category=consonantplaceholder}', "");
    Expect(1, 73459, '\P{Indic_Syllabic_Category=consonantplaceholder}', "");
    Expect(0, 73459, '\P{^Indic_Syllabic_Category=consonantplaceholder}', "");
    Expect(1, 73458, '\p{Indic_Syllabic_Category=:\Aconsonantplaceholder\z:}', "");;
    Expect(0, 73459, '\p{Indic_Syllabic_Category=:\Aconsonantplaceholder\z:}', "");;
    Expect(1, 73458, '\p{Indic_Syllabic_Category:		_Consonant_placeholder}', "");
    Expect(0, 73458, '\p{^Indic_Syllabic_Category:		_Consonant_placeholder}', "");
    Expect(0, 73458, '\P{Indic_Syllabic_Category:		_Consonant_placeholder}', "");
    Expect(1, 73458, '\P{^Indic_Syllabic_Category:		_Consonant_placeholder}', "");
    Expect(0, 73459, '\p{Indic_Syllabic_Category:		_Consonant_placeholder}', "");
    Expect(1, 73459, '\p{^Indic_Syllabic_Category:		_Consonant_placeholder}', "");
    Expect(1, 73459, '\P{Indic_Syllabic_Category:		_Consonant_placeholder}', "");
    Expect(0, 73459, '\P{^Indic_Syllabic_Category:		_Consonant_placeholder}', "");
    Error('\p{InSC=	_consonant_PLACEHOLDER/a/}');
    Error('\P{InSC=	_consonant_PLACEHOLDER/a/}');
    Expect(1, 73458, '\p{InSC=:\AConsonant_Placeholder\z:}', "");;
    Expect(0, 73459, '\p{InSC=:\AConsonant_Placeholder\z:}', "");;
    Expect(1, 73458, '\p{InSC=consonantplaceholder}', "");
    Expect(0, 73458, '\p{^InSC=consonantplaceholder}', "");
    Expect(0, 73458, '\P{InSC=consonantplaceholder}', "");
    Expect(1, 73458, '\P{^InSC=consonantplaceholder}', "");
    Expect(0, 73459, '\p{InSC=consonantplaceholder}', "");
    Expect(1, 73459, '\p{^InSC=consonantplaceholder}', "");
    Expect(1, 73459, '\P{InSC=consonantplaceholder}', "");
    Expect(0, 73459, '\P{^InSC=consonantplaceholder}', "");
    Expect(1, 73458, '\p{InSC=:\Aconsonantplaceholder\z:}', "");;
    Expect(0, 73459, '\p{InSC=:\Aconsonantplaceholder\z:}', "");;
    Expect(1, 73458, '\p{InSC=		Consonant_Placeholder}', "");
    Expect(0, 73458, '\p{^InSC=		Consonant_Placeholder}', "");
    Expect(0, 73458, '\P{InSC=		Consonant_Placeholder}', "");
    Expect(1, 73458, '\P{^InSC=		Consonant_Placeholder}', "");
    Expect(0, 73459, '\p{InSC=		Consonant_Placeholder}', "");
    Expect(1, 73459, '\p{^InSC=		Consonant_Placeholder}', "");
    Expect(1, 73459, '\P{InSC=		Consonant_Placeholder}', "");
    Expect(0, 73459, '\P{^InSC=		Consonant_Placeholder}', "");
    Error('\p{Is_Indic_Syllabic_Category=-/a/CONSONANT_placeholder}');
    Error('\P{Is_Indic_Syllabic_Category=-/a/CONSONANT_placeholder}');
    Expect(1, 73458, '\p{Is_Indic_Syllabic_Category=consonantplaceholder}', "");
    Expect(0, 73458, '\p{^Is_Indic_Syllabic_Category=consonantplaceholder}', "");
    Expect(0, 73458, '\P{Is_Indic_Syllabic_Category=consonantplaceholder}', "");
    Expect(1, 73458, '\P{^Is_Indic_Syllabic_Category=consonantplaceholder}', "");
    Expect(0, 73459, '\p{Is_Indic_Syllabic_Category=consonantplaceholder}', "");
    Expect(1, 73459, '\p{^Is_Indic_Syllabic_Category=consonantplaceholder}', "");
    Expect(1, 73459, '\P{Is_Indic_Syllabic_Category=consonantplaceholder}', "");
    Expect(0, 73459, '\P{^Is_Indic_Syllabic_Category=consonantplaceholder}', "");
    Expect(1, 73458, '\p{Is_Indic_Syllabic_Category= 	consonant_Placeholder}', "");
    Expect(0, 73458, '\p{^Is_Indic_Syllabic_Category= 	consonant_Placeholder}', "");
    Expect(0, 73458, '\P{Is_Indic_Syllabic_Category= 	consonant_Placeholder}', "");
    Expect(1, 73458, '\P{^Is_Indic_Syllabic_Category= 	consonant_Placeholder}', "");
    Expect(0, 73459, '\p{Is_Indic_Syllabic_Category= 	consonant_Placeholder}', "");
    Expect(1, 73459, '\p{^Is_Indic_Syllabic_Category= 	consonant_Placeholder}', "");
    Expect(1, 73459, '\P{Is_Indic_Syllabic_Category= 	consonant_Placeholder}', "");
    Expect(0, 73459, '\P{^Is_Indic_Syllabic_Category= 	consonant_Placeholder}', "");
    Error('\p{Is_InSC=	:=CONSONANT_placeholder}');
    Error('\P{Is_InSC=	:=CONSONANT_placeholder}');
    Expect(1, 73458, '\p{Is_InSC=consonantplaceholder}', "");
    Expect(0, 73458, '\p{^Is_InSC=consonantplaceholder}', "");
    Expect(0, 73458, '\P{Is_InSC=consonantplaceholder}', "");
    Expect(1, 73458, '\P{^Is_InSC=consonantplaceholder}', "");
    Expect(0, 73459, '\p{Is_InSC=consonantplaceholder}', "");
    Expect(1, 73459, '\p{^Is_InSC=consonantplaceholder}', "");
    Expect(1, 73459, '\P{Is_InSC=consonantplaceholder}', "");
    Expect(0, 73459, '\P{^Is_InSC=consonantplaceholder}', "");
    Expect(1, 73458, '\p{Is_InSC=__CONSONANT_Placeholder}', "");
    Expect(0, 73458, '\p{^Is_InSC=__CONSONANT_Placeholder}', "");
    Expect(0, 73458, '\P{Is_InSC=__CONSONANT_Placeholder}', "");
    Expect(1, 73458, '\P{^Is_InSC=__CONSONANT_Placeholder}', "");
    Expect(0, 73459, '\p{Is_InSC=__CONSONANT_Placeholder}', "");
    Expect(1, 73459, '\p{^Is_InSC=__CONSONANT_Placeholder}', "");
    Expect(1, 73459, '\P{Is_InSC=__CONSONANT_Placeholder}', "");
    Expect(0, 73459, '\P{^Is_InSC=__CONSONANT_Placeholder}', "");
    Error('\p{Indic_Syllabic_Category=:=-	consonant_Preceding_Repha}');
    Error('\P{Indic_Syllabic_Category=:=-	consonant_Preceding_Repha}');
    Expect(1, 73474, '\p{Indic_Syllabic_Category=:\AConsonant_Preceding_Repha\z:}', "");;
    Expect(0, 73475, '\p{Indic_Syllabic_Category=:\AConsonant_Preceding_Repha\z:}', "");;
    Expect(1, 73474, '\p{Indic_Syllabic_Category=consonantprecedingrepha}', "");
    Expect(0, 73474, '\p{^Indic_Syllabic_Category=consonantprecedingrepha}', "");
    Expect(0, 73474, '\P{Indic_Syllabic_Category=consonantprecedingrepha}', "");
    Expect(1, 73474, '\P{^Indic_Syllabic_Category=consonantprecedingrepha}', "");
    Expect(0, 73475, '\p{Indic_Syllabic_Category=consonantprecedingrepha}', "");
    Expect(1, 73475, '\p{^Indic_Syllabic_Category=consonantprecedingrepha}', "");
    Expect(1, 73475, '\P{Indic_Syllabic_Category=consonantprecedingrepha}', "");
    Expect(0, 73475, '\P{^Indic_Syllabic_Category=consonantprecedingrepha}', "");
    Expect(1, 73474, '\p{Indic_Syllabic_Category=:\Aconsonantprecedingrepha\z:}', "");;
    Expect(0, 73475, '\p{Indic_Syllabic_Category=:\Aconsonantprecedingrepha\z:}', "");;
    Expect(1, 73474, '\p{Indic_Syllabic_Category=	Consonant_Preceding_repha}', "");
    Expect(0, 73474, '\p{^Indic_Syllabic_Category=	Consonant_Preceding_repha}', "");
    Expect(0, 73474, '\P{Indic_Syllabic_Category=	Consonant_Preceding_repha}', "");
    Expect(1, 73474, '\P{^Indic_Syllabic_Category=	Consonant_Preceding_repha}', "");
    Expect(0, 73475, '\p{Indic_Syllabic_Category=	Consonant_Preceding_repha}', "");
    Expect(1, 73475, '\p{^Indic_Syllabic_Category=	Consonant_Preceding_repha}', "");
    Expect(1, 73475, '\P{Indic_Syllabic_Category=	Consonant_Preceding_repha}', "");
    Expect(0, 73475, '\P{^Indic_Syllabic_Category=	Consonant_Preceding_repha}', "");
    Error('\p{InSC=	 CONSONANT_Preceding_Repha/a/}');
    Error('\P{InSC=	 CONSONANT_Preceding_Repha/a/}');
    Expect(1, 73474, '\p{InSC=:\AConsonant_Preceding_Repha\z:}', "");;
    Expect(0, 73475, '\p{InSC=:\AConsonant_Preceding_Repha\z:}', "");;
    Expect(1, 73474, '\p{InSC=consonantprecedingrepha}', "");
    Expect(0, 73474, '\p{^InSC=consonantprecedingrepha}', "");
    Expect(0, 73474, '\P{InSC=consonantprecedingrepha}', "");
    Expect(1, 73474, '\P{^InSC=consonantprecedingrepha}', "");
    Expect(0, 73475, '\p{InSC=consonantprecedingrepha}', "");
    Expect(1, 73475, '\p{^InSC=consonantprecedingrepha}', "");
    Expect(1, 73475, '\P{InSC=consonantprecedingrepha}', "");
    Expect(0, 73475, '\P{^InSC=consonantprecedingrepha}', "");
    Expect(1, 73474, '\p{InSC=:\Aconsonantprecedingrepha\z:}', "");;
    Expect(0, 73475, '\p{InSC=:\Aconsonantprecedingrepha\z:}', "");;
    Expect(1, 73474, '\p{InSC:   - consonant_PRECEDING_REPHA}', "");
    Expect(0, 73474, '\p{^InSC:   - consonant_PRECEDING_REPHA}', "");
    Expect(0, 73474, '\P{InSC:   - consonant_PRECEDING_REPHA}', "");
    Expect(1, 73474, '\P{^InSC:   - consonant_PRECEDING_REPHA}', "");
    Expect(0, 73475, '\p{InSC:   - consonant_PRECEDING_REPHA}', "");
    Expect(1, 73475, '\p{^InSC:   - consonant_PRECEDING_REPHA}', "");
    Expect(1, 73475, '\P{InSC:   - consonant_PRECEDING_REPHA}', "");
    Expect(0, 73475, '\P{^InSC:   - consonant_PRECEDING_REPHA}', "");
    Error('\p{Is_Indic_Syllabic_Category=	:=consonant_Preceding_Repha}');
    Error('\P{Is_Indic_Syllabic_Category=	:=consonant_Preceding_Repha}');
    Expect(1, 73474, '\p{Is_Indic_Syllabic_Category=consonantprecedingrepha}', "");
    Expect(0, 73474, '\p{^Is_Indic_Syllabic_Category=consonantprecedingrepha}', "");
    Expect(0, 73474, '\P{Is_Indic_Syllabic_Category=consonantprecedingrepha}', "");
    Expect(1, 73474, '\P{^Is_Indic_Syllabic_Category=consonantprecedingrepha}', "");
    Expect(0, 73475, '\p{Is_Indic_Syllabic_Category=consonantprecedingrepha}', "");
    Expect(1, 73475, '\p{^Is_Indic_Syllabic_Category=consonantprecedingrepha}', "");
    Expect(1, 73475, '\P{Is_Indic_Syllabic_Category=consonantprecedingrepha}', "");
    Expect(0, 73475, '\P{^Is_Indic_Syllabic_Category=consonantprecedingrepha}', "");
    Expect(1, 73474, '\p{Is_Indic_Syllabic_Category: _	Consonant_PRECEDING_Repha}', "");
    Expect(0, 73474, '\p{^Is_Indic_Syllabic_Category: _	Consonant_PRECEDING_Repha}', "");
    Expect(0, 73474, '\P{Is_Indic_Syllabic_Category: _	Consonant_PRECEDING_Repha}', "");
    Expect(1, 73474, '\P{^Is_Indic_Syllabic_Category: _	Consonant_PRECEDING_Repha}', "");
    Expect(0, 73475, '\p{Is_Indic_Syllabic_Category: _	Consonant_PRECEDING_Repha}', "");
    Expect(1, 73475, '\p{^Is_Indic_Syllabic_Category: _	Consonant_PRECEDING_Repha}', "");
    Expect(1, 73475, '\P{Is_Indic_Syllabic_Category: _	Consonant_PRECEDING_Repha}', "");
    Expect(0, 73475, '\P{^Is_Indic_Syllabic_Category: _	Consonant_PRECEDING_Repha}', "");
    Error('\p{Is_InSC= -Consonant_preceding_REPHA/a/}');
    Error('\P{Is_InSC= -Consonant_preceding_REPHA/a/}');
    Expect(1, 73474, '\p{Is_InSC=consonantprecedingrepha}', "");
    Expect(0, 73474, '\p{^Is_InSC=consonantprecedingrepha}', "");
    Expect(0, 73474, '\P{Is_InSC=consonantprecedingrepha}', "");
    Expect(1, 73474, '\P{^Is_InSC=consonantprecedingrepha}', "");
    Expect(0, 73475, '\p{Is_InSC=consonantprecedingrepha}', "");
    Expect(1, 73475, '\p{^Is_InSC=consonantprecedingrepha}', "");
    Expect(1, 73475, '\P{Is_InSC=consonantprecedingrepha}', "");
    Expect(0, 73475, '\P{^Is_InSC=consonantprecedingrepha}', "");
    Expect(1, 73474, '\p{Is_InSC=__consonant_PRECEDING_Repha}', "");
    Expect(0, 73474, '\p{^Is_InSC=__consonant_PRECEDING_Repha}', "");
    Expect(0, 73474, '\P{Is_InSC=__consonant_PRECEDING_Repha}', "");
    Expect(1, 73474, '\P{^Is_InSC=__consonant_PRECEDING_Repha}', "");
    Expect(0, 73475, '\p{Is_InSC=__consonant_PRECEDING_Repha}', "");
    Expect(1, 73475, '\p{^Is_InSC=__consonant_PRECEDING_Repha}', "");
    Expect(1, 73475, '\P{Is_InSC=__consonant_PRECEDING_Repha}', "");
    Expect(0, 73475, '\P{^Is_InSC=__consonant_PRECEDING_Repha}', "");
    Error('\p{Indic_Syllabic_Category=-/a/consonant_PREFIXED}');
    Error('\P{Indic_Syllabic_Category=-/a/consonant_PREFIXED}');
    Expect(1, 72329, '\p{Indic_Syllabic_Category=:\AConsonant_Prefixed\z:}', "");;
    Expect(0, 72330, '\p{Indic_Syllabic_Category=:\AConsonant_Prefixed\z:}', "");;
    Expect(1, 72329, '\p{Indic_Syllabic_Category=consonantprefixed}', "");
    Expect(0, 72329, '\p{^Indic_Syllabic_Category=consonantprefixed}', "");
    Expect(0, 72329, '\P{Indic_Syllabic_Category=consonantprefixed}', "");
    Expect(1, 72329, '\P{^Indic_Syllabic_Category=consonantprefixed}', "");
    Expect(0, 72330, '\p{Indic_Syllabic_Category=consonantprefixed}', "");
    Expect(1, 72330, '\p{^Indic_Syllabic_Category=consonantprefixed}', "");
    Expect(1, 72330, '\P{Indic_Syllabic_Category=consonantprefixed}', "");
    Expect(0, 72330, '\P{^Indic_Syllabic_Category=consonantprefixed}', "");
    Expect(1, 72329, '\p{Indic_Syllabic_Category=:\Aconsonantprefixed\z:}', "");;
    Expect(0, 72330, '\p{Indic_Syllabic_Category=:\Aconsonantprefixed\z:}', "");;
    Expect(1, 72329, '\p{Indic_Syllabic_Category= Consonant_prefixed}', "");
    Expect(0, 72329, '\p{^Indic_Syllabic_Category= Consonant_prefixed}', "");
    Expect(0, 72329, '\P{Indic_Syllabic_Category= Consonant_prefixed}', "");
    Expect(1, 72329, '\P{^Indic_Syllabic_Category= Consonant_prefixed}', "");
    Expect(0, 72330, '\p{Indic_Syllabic_Category= Consonant_prefixed}', "");
    Expect(1, 72330, '\p{^Indic_Syllabic_Category= Consonant_prefixed}', "");
    Expect(1, 72330, '\P{Indic_Syllabic_Category= Consonant_prefixed}', "");
    Expect(0, 72330, '\P{^Indic_Syllabic_Category= Consonant_prefixed}', "");
    Error('\p{InSC=	_Consonant_Prefixed/a/}');
    Error('\P{InSC=	_Consonant_Prefixed/a/}');
    Expect(1, 72329, '\p{InSC=:\AConsonant_Prefixed\z:}', "");;
    Expect(0, 72330, '\p{InSC=:\AConsonant_Prefixed\z:}', "");;
    Expect(1, 72329, '\p{InSC=consonantprefixed}', "");
    Expect(0, 72329, '\p{^InSC=consonantprefixed}', "");
    Expect(0, 72329, '\P{InSC=consonantprefixed}', "");
    Expect(1, 72329, '\P{^InSC=consonantprefixed}', "");
    Expect(0, 72330, '\p{InSC=consonantprefixed}', "");
    Expect(1, 72330, '\p{^InSC=consonantprefixed}', "");
    Expect(1, 72330, '\P{InSC=consonantprefixed}', "");
    Expect(0, 72330, '\P{^InSC=consonantprefixed}', "");
    Expect(1, 72329, '\p{InSC=:\Aconsonantprefixed\z:}', "");;
    Expect(0, 72330, '\p{InSC=:\Aconsonantprefixed\z:}', "");;
    Expect(1, 72329, '\p{InSC:-Consonant_prefixed}', "");
    Expect(0, 72329, '\p{^InSC:-Consonant_prefixed}', "");
    Expect(0, 72329, '\P{InSC:-Consonant_prefixed}', "");
    Expect(1, 72329, '\P{^InSC:-Consonant_prefixed}', "");
    Expect(0, 72330, '\p{InSC:-Consonant_prefixed}', "");
    Expect(1, 72330, '\p{^InSC:-Consonant_prefixed}', "");
    Expect(1, 72330, '\P{InSC:-Consonant_prefixed}', "");
    Expect(0, 72330, '\P{^InSC:-Consonant_prefixed}', "");
    Error('\p{Is_Indic_Syllabic_Category=_ CONSONANT_Prefixed:=}');
    Error('\P{Is_Indic_Syllabic_Category=_ CONSONANT_Prefixed:=}');
    Expect(1, 72329, '\p{Is_Indic_Syllabic_Category=consonantprefixed}', "");
    Expect(0, 72329, '\p{^Is_Indic_Syllabic_Category=consonantprefixed}', "");
    Expect(0, 72329, '\P{Is_Indic_Syllabic_Category=consonantprefixed}', "");
    Expect(1, 72329, '\P{^Is_Indic_Syllabic_Category=consonantprefixed}', "");
    Expect(0, 72330, '\p{Is_Indic_Syllabic_Category=consonantprefixed}', "");
    Expect(1, 72330, '\p{^Is_Indic_Syllabic_Category=consonantprefixed}', "");
    Expect(1, 72330, '\P{Is_Indic_Syllabic_Category=consonantprefixed}', "");
    Expect(0, 72330, '\P{^Is_Indic_Syllabic_Category=consonantprefixed}', "");
    Expect(1, 72329, '\p{Is_Indic_Syllabic_Category:Consonant_Prefixed}', "");
    Expect(0, 72329, '\p{^Is_Indic_Syllabic_Category:Consonant_Prefixed}', "");
    Expect(0, 72329, '\P{Is_Indic_Syllabic_Category:Consonant_Prefixed}', "");
    Expect(1, 72329, '\P{^Is_Indic_Syllabic_Category:Consonant_Prefixed}', "");
    Expect(0, 72330, '\p{Is_Indic_Syllabic_Category:Consonant_Prefixed}', "");
    Expect(1, 72330, '\p{^Is_Indic_Syllabic_Category:Consonant_Prefixed}', "");
    Expect(1, 72330, '\P{Is_Indic_Syllabic_Category:Consonant_Prefixed}', "");
    Expect(0, 72330, '\P{^Is_Indic_Syllabic_Category:Consonant_Prefixed}', "");
    Error('\p{Is_InSC=	Consonant_PREFIXED:=}');
    Error('\P{Is_InSC=	Consonant_PREFIXED:=}');
    Expect(1, 72329, '\p{Is_InSC=consonantprefixed}', "");
    Expect(0, 72329, '\p{^Is_InSC=consonantprefixed}', "");
    Expect(0, 72329, '\P{Is_InSC=consonantprefixed}', "");
    Expect(1, 72329, '\P{^Is_InSC=consonantprefixed}', "");
    Expect(0, 72330, '\p{Is_InSC=consonantprefixed}', "");
    Expect(1, 72330, '\p{^Is_InSC=consonantprefixed}', "");
    Expect(1, 72330, '\P{Is_InSC=consonantprefixed}', "");
    Expect(0, 72330, '\P{^Is_InSC=consonantprefixed}', "");
    Expect(1, 72329, '\p{Is_InSC:			CONSONANT_PREFIXED}', "");
    Expect(0, 72329, '\p{^Is_InSC:			CONSONANT_PREFIXED}', "");
    Expect(0, 72329, '\P{Is_InSC:			CONSONANT_PREFIXED}', "");
    Expect(1, 72329, '\P{^Is_InSC:			CONSONANT_PREFIXED}', "");
    Expect(0, 72330, '\p{Is_InSC:			CONSONANT_PREFIXED}', "");
    Expect(1, 72330, '\p{^Is_InSC:			CONSONANT_PREFIXED}', "");
    Expect(1, 72330, '\P{Is_InSC:			CONSONANT_PREFIXED}', "");
    Expect(0, 72330, '\P{^Is_InSC:			CONSONANT_PREFIXED}', "");
    Error('\p{Indic_Syllabic_Category=:=-CONSONANT_SUBJOINED}');
    Error('\P{Indic_Syllabic_Category=:=-CONSONANT_SUBJOINED}');
    Expect(1, 72879, '\p{Indic_Syllabic_Category=:\AConsonant_Subjoined\z:}', "");;
    Expect(0, 72880, '\p{Indic_Syllabic_Category=:\AConsonant_Subjoined\z:}', "");;
    Expect(1, 72879, '\p{Indic_Syllabic_Category=consonantsubjoined}', "");
    Expect(0, 72879, '\p{^Indic_Syllabic_Category=consonantsubjoined}', "");
    Expect(0, 72879, '\P{Indic_Syllabic_Category=consonantsubjoined}', "");
    Expect(1, 72879, '\P{^Indic_Syllabic_Category=consonantsubjoined}', "");
    Expect(0, 72880, '\p{Indic_Syllabic_Category=consonantsubjoined}', "");
    Expect(1, 72880, '\p{^Indic_Syllabic_Category=consonantsubjoined}', "");
    Expect(1, 72880, '\P{Indic_Syllabic_Category=consonantsubjoined}', "");
    Expect(0, 72880, '\P{^Indic_Syllabic_Category=consonantsubjoined}', "");
    Expect(1, 72879, '\p{Indic_Syllabic_Category=:\Aconsonantsubjoined\z:}', "");;
    Expect(0, 72880, '\p{Indic_Syllabic_Category=:\Aconsonantsubjoined\z:}', "");;
    Expect(1, 72879, '\p{Indic_Syllabic_Category=_-consonant_Subjoined}', "");
    Expect(0, 72879, '\p{^Indic_Syllabic_Category=_-consonant_Subjoined}', "");
    Expect(0, 72879, '\P{Indic_Syllabic_Category=_-consonant_Subjoined}', "");
    Expect(1, 72879, '\P{^Indic_Syllabic_Category=_-consonant_Subjoined}', "");
    Expect(0, 72880, '\p{Indic_Syllabic_Category=_-consonant_Subjoined}', "");
    Expect(1, 72880, '\p{^Indic_Syllabic_Category=_-consonant_Subjoined}', "");
    Expect(1, 72880, '\P{Indic_Syllabic_Category=_-consonant_Subjoined}', "");
    Expect(0, 72880, '\P{^Indic_Syllabic_Category=_-consonant_Subjoined}', "");
    Error('\p{InSC:   :=-_Consonant_subjoined}');
    Error('\P{InSC:   :=-_Consonant_subjoined}');
    Expect(1, 72879, '\p{InSC=:\AConsonant_Subjoined\z:}', "");;
    Expect(0, 72880, '\p{InSC=:\AConsonant_Subjoined\z:}', "");;
    Expect(1, 72879, '\p{InSC=consonantsubjoined}', "");
    Expect(0, 72879, '\p{^InSC=consonantsubjoined}', "");
    Expect(0, 72879, '\P{InSC=consonantsubjoined}', "");
    Expect(1, 72879, '\P{^InSC=consonantsubjoined}', "");
    Expect(0, 72880, '\p{InSC=consonantsubjoined}', "");
    Expect(1, 72880, '\p{^InSC=consonantsubjoined}', "");
    Expect(1, 72880, '\P{InSC=consonantsubjoined}', "");
    Expect(0, 72880, '\P{^InSC=consonantsubjoined}', "");
    Expect(1, 72879, '\p{InSC=:\Aconsonantsubjoined\z:}', "");;
    Expect(0, 72880, '\p{InSC=:\Aconsonantsubjoined\z:}', "");;
    Expect(1, 72879, '\p{InSC= consonant_subjoined}', "");
    Expect(0, 72879, '\p{^InSC= consonant_subjoined}', "");
    Expect(0, 72879, '\P{InSC= consonant_subjoined}', "");
    Expect(1, 72879, '\P{^InSC= consonant_subjoined}', "");
    Expect(0, 72880, '\p{InSC= consonant_subjoined}', "");
    Expect(1, 72880, '\p{^InSC= consonant_subjoined}', "");
    Expect(1, 72880, '\P{InSC= consonant_subjoined}', "");
    Expect(0, 72880, '\P{^InSC= consonant_subjoined}', "");
    Error('\p{Is_Indic_Syllabic_Category=/a/Consonant_Subjoined}');
    Error('\P{Is_Indic_Syllabic_Category=/a/Consonant_Subjoined}');
    Expect(1, 72879, '\p{Is_Indic_Syllabic_Category=consonantsubjoined}', "");
    Expect(0, 72879, '\p{^Is_Indic_Syllabic_Category=consonantsubjoined}', "");
    Expect(0, 72879, '\P{Is_Indic_Syllabic_Category=consonantsubjoined}', "");
    Expect(1, 72879, '\P{^Is_Indic_Syllabic_Category=consonantsubjoined}', "");
    Expect(0, 72880, '\p{Is_Indic_Syllabic_Category=consonantsubjoined}', "");
    Expect(1, 72880, '\p{^Is_Indic_Syllabic_Category=consonantsubjoined}', "");
    Expect(1, 72880, '\P{Is_Indic_Syllabic_Category=consonantsubjoined}', "");
    Expect(0, 72880, '\P{^Is_Indic_Syllabic_Category=consonantsubjoined}', "");
    Expect(1, 72879, '\p{Is_Indic_Syllabic_Category= CONSONANT_Subjoined}', "");
    Expect(0, 72879, '\p{^Is_Indic_Syllabic_Category= CONSONANT_Subjoined}', "");
    Expect(0, 72879, '\P{Is_Indic_Syllabic_Category= CONSONANT_Subjoined}', "");
    Expect(1, 72879, '\P{^Is_Indic_Syllabic_Category= CONSONANT_Subjoined}', "");
    Expect(0, 72880, '\p{Is_Indic_Syllabic_Category= CONSONANT_Subjoined}', "");
    Expect(1, 72880, '\p{^Is_Indic_Syllabic_Category= CONSONANT_Subjoined}', "");
    Expect(1, 72880, '\P{Is_Indic_Syllabic_Category= CONSONANT_Subjoined}', "");
    Expect(0, 72880, '\P{^Is_Indic_Syllabic_Category= CONSONANT_Subjoined}', "");
    Error('\p{Is_InSC=-_CONSONANT_subjoined:=}');
    Error('\P{Is_InSC=-_CONSONANT_subjoined:=}');
    Expect(1, 72879, '\p{Is_InSC=consonantsubjoined}', "");
    Expect(0, 72879, '\p{^Is_InSC=consonantsubjoined}', "");
    Expect(0, 72879, '\P{Is_InSC=consonantsubjoined}', "");
    Expect(1, 72879, '\P{^Is_InSC=consonantsubjoined}', "");
    Expect(0, 72880, '\p{Is_InSC=consonantsubjoined}', "");
    Expect(1, 72880, '\p{^Is_InSC=consonantsubjoined}', "");
    Expect(1, 72880, '\P{Is_InSC=consonantsubjoined}', "");
    Expect(0, 72880, '\P{^Is_InSC=consonantsubjoined}', "");
    Expect(1, 72879, '\p{Is_InSC= Consonant_Subjoined}', "");
    Expect(0, 72879, '\p{^Is_InSC= Consonant_Subjoined}', "");
    Expect(0, 72879, '\P{Is_InSC= Consonant_Subjoined}', "");
    Expect(1, 72879, '\P{^Is_InSC= Consonant_Subjoined}', "");
    Expect(0, 72880, '\p{Is_InSC= Consonant_Subjoined}', "");
    Expect(1, 72880, '\p{^Is_InSC= Consonant_Subjoined}', "");
    Expect(1, 72880, '\P{Is_InSC= Consonant_Subjoined}', "");
    Expect(0, 72880, '\P{^Is_InSC= Consonant_Subjoined}', "");
    Error('\p{Indic_Syllabic_Category=	_Consonant_Succeeding_Repha/a/}');
    Error('\P{Indic_Syllabic_Category=	_Consonant_Succeeding_Repha/a/}');
    Expect(1, 6092, '\p{Indic_Syllabic_Category=:\AConsonant_Succeeding_Repha\z:}', "");;
    Expect(0, 6093, '\p{Indic_Syllabic_Category=:\AConsonant_Succeeding_Repha\z:}', "");;
    Expect(1, 6092, '\p{Indic_Syllabic_Category=consonantsucceedingrepha}', "");
    Expect(0, 6092, '\p{^Indic_Syllabic_Category=consonantsucceedingrepha}', "");
    Expect(0, 6092, '\P{Indic_Syllabic_Category=consonantsucceedingrepha}', "");
    Expect(1, 6092, '\P{^Indic_Syllabic_Category=consonantsucceedingrepha}', "");
    Expect(0, 6093, '\p{Indic_Syllabic_Category=consonantsucceedingrepha}', "");
    Expect(1, 6093, '\p{^Indic_Syllabic_Category=consonantsucceedingrepha}', "");
    Expect(1, 6093, '\P{Indic_Syllabic_Category=consonantsucceedingrepha}', "");
    Expect(0, 6093, '\P{^Indic_Syllabic_Category=consonantsucceedingrepha}', "");
    Expect(1, 6092, '\p{Indic_Syllabic_Category=:\Aconsonantsucceedingrepha\z:}', "");;
    Expect(0, 6093, '\p{Indic_Syllabic_Category=:\Aconsonantsucceedingrepha\z:}', "");;
    Expect(1, 6092, '\p{Indic_Syllabic_Category=_CONSONANT_SUCCEEDING_Repha}', "");
    Expect(0, 6092, '\p{^Indic_Syllabic_Category=_CONSONANT_SUCCEEDING_Repha}', "");
    Expect(0, 6092, '\P{Indic_Syllabic_Category=_CONSONANT_SUCCEEDING_Repha}', "");
    Expect(1, 6092, '\P{^Indic_Syllabic_Category=_CONSONANT_SUCCEEDING_Repha}', "");
    Expect(0, 6093, '\p{Indic_Syllabic_Category=_CONSONANT_SUCCEEDING_Repha}', "");
    Expect(1, 6093, '\p{^Indic_Syllabic_Category=_CONSONANT_SUCCEEDING_Repha}', "");
    Expect(1, 6093, '\P{Indic_Syllabic_Category=_CONSONANT_SUCCEEDING_Repha}', "");
    Expect(0, 6093, '\P{^Indic_Syllabic_Category=_CONSONANT_SUCCEEDING_Repha}', "");
    Error('\p{InSC= :=Consonant_Succeeding_Repha}');
    Error('\P{InSC= :=Consonant_Succeeding_Repha}');
    Expect(1, 6092, '\p{InSC=:\AConsonant_Succeeding_Repha\z:}', "");;
    Expect(0, 6093, '\p{InSC=:\AConsonant_Succeeding_Repha\z:}', "");;
    Expect(1, 6092, '\p{InSC=consonantsucceedingrepha}', "");
    Expect(0, 6092, '\p{^InSC=consonantsucceedingrepha}', "");
    Expect(0, 6092, '\P{InSC=consonantsucceedingrepha}', "");
    Expect(1, 6092, '\P{^InSC=consonantsucceedingrepha}', "");
    Expect(0, 6093, '\p{InSC=consonantsucceedingrepha}', "");
    Expect(1, 6093, '\p{^InSC=consonantsucceedingrepha}', "");
    Expect(1, 6093, '\P{InSC=consonantsucceedingrepha}', "");
    Expect(0, 6093, '\P{^InSC=consonantsucceedingrepha}', "");
    Expect(1, 6092, '\p{InSC=:\Aconsonantsucceedingrepha\z:}', "");;
    Expect(0, 6093, '\p{InSC=:\Aconsonantsucceedingrepha\z:}', "");;
    Expect(1, 6092, '\p{InSC=_CONSONANT_Succeeding_REPHA}', "");
    Expect(0, 6092, '\p{^InSC=_CONSONANT_Succeeding_REPHA}', "");
    Expect(0, 6092, '\P{InSC=_CONSONANT_Succeeding_REPHA}', "");
    Expect(1, 6092, '\P{^InSC=_CONSONANT_Succeeding_REPHA}', "");
    Expect(0, 6093, '\p{InSC=_CONSONANT_Succeeding_REPHA}', "");
    Expect(1, 6093, '\p{^InSC=_CONSONANT_Succeeding_REPHA}', "");
    Expect(1, 6093, '\P{InSC=_CONSONANT_Succeeding_REPHA}', "");
    Expect(0, 6093, '\P{^InSC=_CONSONANT_Succeeding_REPHA}', "");
    Error('\p{Is_Indic_Syllabic_Category=/a/	-Consonant_succeeding_repha}');
    Error('\P{Is_Indic_Syllabic_Category=/a/	-Consonant_succeeding_repha}');
    Expect(1, 6092, '\p{Is_Indic_Syllabic_Category=consonantsucceedingrepha}', "");
    Expect(0, 6092, '\p{^Is_Indic_Syllabic_Category=consonantsucceedingrepha}', "");
    Expect(0, 6092, '\P{Is_Indic_Syllabic_Category=consonantsucceedingrepha}', "");
    Expect(1, 6092, '\P{^Is_Indic_Syllabic_Category=consonantsucceedingrepha}', "");
    Expect(0, 6093, '\p{Is_Indic_Syllabic_Category=consonantsucceedingrepha}', "");
    Expect(1, 6093, '\p{^Is_Indic_Syllabic_Category=consonantsucceedingrepha}', "");
    Expect(1, 6093, '\P{Is_Indic_Syllabic_Category=consonantsucceedingrepha}', "");
    Expect(0, 6093, '\P{^Is_Indic_Syllabic_Category=consonantsucceedingrepha}', "");
    Expect(1, 6092, '\p{Is_Indic_Syllabic_Category=_consonant_SUCCEEDING_Repha}', "");
    Expect(0, 6092, '\p{^Is_Indic_Syllabic_Category=_consonant_SUCCEEDING_Repha}', "");
    Expect(0, 6092, '\P{Is_Indic_Syllabic_Category=_consonant_SUCCEEDING_Repha}', "");
    Expect(1, 6092, '\P{^Is_Indic_Syllabic_Category=_consonant_SUCCEEDING_Repha}', "");
    Expect(0, 6093, '\p{Is_Indic_Syllabic_Category=_consonant_SUCCEEDING_Repha}', "");
    Expect(1, 6093, '\p{^Is_Indic_Syllabic_Category=_consonant_SUCCEEDING_Repha}', "");
    Expect(1, 6093, '\P{Is_Indic_Syllabic_Category=_consonant_SUCCEEDING_Repha}', "");
    Expect(0, 6093, '\P{^Is_Indic_Syllabic_Category=_consonant_SUCCEEDING_Repha}', "");
    Error('\p{Is_InSC= :=Consonant_Succeeding_Repha}');
    Error('\P{Is_InSC= :=Consonant_Succeeding_Repha}');
    Expect(1, 6092, '\p{Is_InSC=consonantsucceedingrepha}', "");
    Expect(0, 6092, '\p{^Is_InSC=consonantsucceedingrepha}', "");
    Expect(0, 6092, '\P{Is_InSC=consonantsucceedingrepha}', "");
    Expect(1, 6092, '\P{^Is_InSC=consonantsucceedingrepha}', "");
    Expect(0, 6093, '\p{Is_InSC=consonantsucceedingrepha}', "");
    Expect(1, 6093, '\p{^Is_InSC=consonantsucceedingrepha}', "");
    Expect(1, 6093, '\P{Is_InSC=consonantsucceedingrepha}', "");
    Expect(0, 6093, '\P{^Is_InSC=consonantsucceedingrepha}', "");
    Expect(1, 6092, '\p{Is_InSC:	-	Consonant_SUCCEEDING_Repha}', "");
    Expect(0, 6092, '\p{^Is_InSC:	-	Consonant_SUCCEEDING_Repha}', "");
    Expect(0, 6092, '\P{Is_InSC:	-	Consonant_SUCCEEDING_Repha}', "");
    Expect(1, 6092, '\P{^Is_InSC:	-	Consonant_SUCCEEDING_Repha}', "");
    Expect(0, 6093, '\p{Is_InSC:	-	Consonant_SUCCEEDING_Repha}', "");
    Expect(1, 6093, '\p{^Is_InSC:	-	Consonant_SUCCEEDING_Repha}', "");
    Expect(1, 6093, '\P{Is_InSC:	-	Consonant_SUCCEEDING_Repha}', "");
    Expect(0, 6093, '\P{^Is_InSC:	-	Consonant_SUCCEEDING_Repha}', "");
    Error('\p{Indic_Syllabic_Category=/a/	consonant_with_stacker}');
    Error('\P{Indic_Syllabic_Category=/a/	consonant_with_stacker}');
    Expect(1, 70753, '\p{Indic_Syllabic_Category=:\AConsonant_With_Stacker\z:}', "");;
    Expect(0, 70754, '\p{Indic_Syllabic_Category=:\AConsonant_With_Stacker\z:}', "");;
    Expect(1, 70753, '\p{Indic_Syllabic_Category=consonantwithstacker}', "");
    Expect(0, 70753, '\p{^Indic_Syllabic_Category=consonantwithstacker}', "");
    Expect(0, 70753, '\P{Indic_Syllabic_Category=consonantwithstacker}', "");
    Expect(1, 70753, '\P{^Indic_Syllabic_Category=consonantwithstacker}', "");
    Expect(0, 70754, '\p{Indic_Syllabic_Category=consonantwithstacker}', "");
    Expect(1, 70754, '\p{^Indic_Syllabic_Category=consonantwithstacker}', "");
    Expect(1, 70754, '\P{Indic_Syllabic_Category=consonantwithstacker}', "");
    Expect(0, 70754, '\P{^Indic_Syllabic_Category=consonantwithstacker}', "");
    Expect(1, 70753, '\p{Indic_Syllabic_Category=:\Aconsonantwithstacker\z:}', "");;
    Expect(0, 70754, '\p{Indic_Syllabic_Category=:\Aconsonantwithstacker\z:}', "");;
    Expect(1, 70753, '\p{Indic_Syllabic_Category=	-Consonant_With_STACKER}', "");
    Expect(0, 70753, '\p{^Indic_Syllabic_Category=	-Consonant_With_STACKER}', "");
    Expect(0, 70753, '\P{Indic_Syllabic_Category=	-Consonant_With_STACKER}', "");
    Expect(1, 70753, '\P{^Indic_Syllabic_Category=	-Consonant_With_STACKER}', "");
    Expect(0, 70754, '\p{Indic_Syllabic_Category=	-Consonant_With_STACKER}', "");
    Expect(1, 70754, '\p{^Indic_Syllabic_Category=	-Consonant_With_STACKER}', "");
    Expect(1, 70754, '\P{Indic_Syllabic_Category=	-Consonant_With_STACKER}', "");
    Expect(0, 70754, '\P{^Indic_Syllabic_Category=	-Consonant_With_STACKER}', "");
    Error('\p{InSC=-_consonant_with_STACKER/a/}');
    Error('\P{InSC=-_consonant_with_STACKER/a/}');
    Expect(1, 70753, '\p{InSC=:\AConsonant_With_Stacker\z:}', "");;
    Expect(0, 70754, '\p{InSC=:\AConsonant_With_Stacker\z:}', "");;
    Expect(1, 70753, '\p{InSC=consonantwithstacker}', "");
    Expect(0, 70753, '\p{^InSC=consonantwithstacker}', "");
    Expect(0, 70753, '\P{InSC=consonantwithstacker}', "");
    Expect(1, 70753, '\P{^InSC=consonantwithstacker}', "");
    Expect(0, 70754, '\p{InSC=consonantwithstacker}', "");
    Expect(1, 70754, '\p{^InSC=consonantwithstacker}', "");
    Expect(1, 70754, '\P{InSC=consonantwithstacker}', "");
    Expect(0, 70754, '\P{^InSC=consonantwithstacker}', "");
    Expect(1, 70753, '\p{InSC=:\Aconsonantwithstacker\z:}', "");;
    Expect(0, 70754, '\p{InSC=:\Aconsonantwithstacker\z:}', "");;
    Expect(1, 70753, '\p{InSC=--Consonant_WITH_STACKER}', "");
    Expect(0, 70753, '\p{^InSC=--Consonant_WITH_STACKER}', "");
    Expect(0, 70753, '\P{InSC=--Consonant_WITH_STACKER}', "");
    Expect(1, 70753, '\P{^InSC=--Consonant_WITH_STACKER}', "");
    Expect(0, 70754, '\p{InSC=--Consonant_WITH_STACKER}', "");
    Expect(1, 70754, '\p{^InSC=--Consonant_WITH_STACKER}', "");
    Expect(1, 70754, '\P{InSC=--Consonant_WITH_STACKER}', "");
    Expect(0, 70754, '\P{^InSC=--Consonant_WITH_STACKER}', "");
    Error('\p{Is_Indic_Syllabic_Category=:=Consonant_with_stacker}');
    Error('\P{Is_Indic_Syllabic_Category=:=Consonant_with_stacker}');
    Expect(1, 70753, '\p{Is_Indic_Syllabic_Category=consonantwithstacker}', "");
    Expect(0, 70753, '\p{^Is_Indic_Syllabic_Category=consonantwithstacker}', "");
    Expect(0, 70753, '\P{Is_Indic_Syllabic_Category=consonantwithstacker}', "");
    Expect(1, 70753, '\P{^Is_Indic_Syllabic_Category=consonantwithstacker}', "");
    Expect(0, 70754, '\p{Is_Indic_Syllabic_Category=consonantwithstacker}', "");
    Expect(1, 70754, '\p{^Is_Indic_Syllabic_Category=consonantwithstacker}', "");
    Expect(1, 70754, '\P{Is_Indic_Syllabic_Category=consonantwithstacker}', "");
    Expect(0, 70754, '\P{^Is_Indic_Syllabic_Category=consonantwithstacker}', "");
    Expect(1, 70753, '\p{Is_Indic_Syllabic_Category=_ CONSONANT_WITH_stacker}', "");
    Expect(0, 70753, '\p{^Is_Indic_Syllabic_Category=_ CONSONANT_WITH_stacker}', "");
    Expect(0, 70753, '\P{Is_Indic_Syllabic_Category=_ CONSONANT_WITH_stacker}', "");
    Expect(1, 70753, '\P{^Is_Indic_Syllabic_Category=_ CONSONANT_WITH_stacker}', "");
    Expect(0, 70754, '\p{Is_Indic_Syllabic_Category=_ CONSONANT_WITH_stacker}', "");
    Expect(1, 70754, '\p{^Is_Indic_Syllabic_Category=_ CONSONANT_WITH_stacker}', "");
    Expect(1, 70754, '\P{Is_Indic_Syllabic_Category=_ CONSONANT_WITH_stacker}', "");
    Expect(0, 70754, '\P{^Is_Indic_Syllabic_Category=_ CONSONANT_WITH_stacker}', "");
    Error('\p{Is_InSC=/a/CONSONANT_With_stacker}');
    Error('\P{Is_InSC=/a/CONSONANT_With_stacker}');
    Expect(1, 70753, '\p{Is_InSC=consonantwithstacker}', "");
    Expect(0, 70753, '\p{^Is_InSC=consonantwithstacker}', "");
    Expect(0, 70753, '\P{Is_InSC=consonantwithstacker}', "");
    Expect(1, 70753, '\P{^Is_InSC=consonantwithstacker}', "");
    Expect(0, 70754, '\p{Is_InSC=consonantwithstacker}', "");
    Expect(1, 70754, '\p{^Is_InSC=consonantwithstacker}', "");
    Expect(1, 70754, '\P{Is_InSC=consonantwithstacker}', "");
    Expect(0, 70754, '\P{^Is_InSC=consonantwithstacker}', "");
    Expect(1, 70753, '\p{Is_InSC=-	Consonant_with_Stacker}', "");
    Expect(0, 70753, '\p{^Is_InSC=-	Consonant_with_Stacker}', "");
    Expect(0, 70753, '\P{Is_InSC=-	Consonant_with_Stacker}', "");
    Expect(1, 70753, '\P{^Is_InSC=-	Consonant_with_Stacker}', "");
    Expect(0, 70754, '\p{Is_InSC=-	Consonant_with_Stacker}', "");
    Expect(1, 70754, '\p{^Is_InSC=-	Consonant_with_Stacker}', "");
    Expect(1, 70754, '\P{Is_InSC=-	Consonant_with_Stacker}', "");
    Expect(0, 70754, '\P{^Is_InSC=-	Consonant_with_Stacker}', "");
    Error('\p{Indic_Syllabic_Category=:=--GEMINATION_Mark}');
    Error('\P{Indic_Syllabic_Category=:=--GEMINATION_Mark}');
    Expect(1, 72344, '\p{Indic_Syllabic_Category=:\AGemination_Mark\z:}', "");;
    Expect(0, 72345, '\p{Indic_Syllabic_Category=:\AGemination_Mark\z:}', "");;
    Expect(1, 72344, '\p{Indic_Syllabic_Category=geminationmark}', "");
    Expect(0, 72344, '\p{^Indic_Syllabic_Category=geminationmark}', "");
    Expect(0, 72344, '\P{Indic_Syllabic_Category=geminationmark}', "");
    Expect(1, 72344, '\P{^Indic_Syllabic_Category=geminationmark}', "");
    Expect(0, 72345, '\p{Indic_Syllabic_Category=geminationmark}', "");
    Expect(1, 72345, '\p{^Indic_Syllabic_Category=geminationmark}', "");
    Expect(1, 72345, '\P{Indic_Syllabic_Category=geminationmark}', "");
    Expect(0, 72345, '\P{^Indic_Syllabic_Category=geminationmark}', "");
    Expect(1, 72344, '\p{Indic_Syllabic_Category=:\Ageminationmark\z:}', "");;
    Expect(0, 72345, '\p{Indic_Syllabic_Category=:\Ageminationmark\z:}', "");;
    Expect(1, 72344, '\p{Indic_Syllabic_Category=_	Gemination_Mark}', "");
    Expect(0, 72344, '\p{^Indic_Syllabic_Category=_	Gemination_Mark}', "");
    Expect(0, 72344, '\P{Indic_Syllabic_Category=_	Gemination_Mark}', "");
    Expect(1, 72344, '\P{^Indic_Syllabic_Category=_	Gemination_Mark}', "");
    Expect(0, 72345, '\p{Indic_Syllabic_Category=_	Gemination_Mark}', "");
    Expect(1, 72345, '\p{^Indic_Syllabic_Category=_	Gemination_Mark}', "");
    Expect(1, 72345, '\P{Indic_Syllabic_Category=_	Gemination_Mark}', "");
    Expect(0, 72345, '\P{^Indic_Syllabic_Category=_	Gemination_Mark}', "");
    Error('\p{InSC=/a/- Gemination_mark}');
    Error('\P{InSC=/a/- Gemination_mark}');
    Expect(1, 72344, '\p{InSC=:\AGemination_Mark\z:}', "");;
    Expect(0, 72345, '\p{InSC=:\AGemination_Mark\z:}', "");;
    Expect(1, 72344, '\p{InSC=geminationmark}', "");
    Expect(0, 72344, '\p{^InSC=geminationmark}', "");
    Expect(0, 72344, '\P{InSC=geminationmark}', "");
    Expect(1, 72344, '\P{^InSC=geminationmark}', "");
    Expect(0, 72345, '\p{InSC=geminationmark}', "");
    Expect(1, 72345, '\p{^InSC=geminationmark}', "");
    Expect(1, 72345, '\P{InSC=geminationmark}', "");
    Expect(0, 72345, '\P{^InSC=geminationmark}', "");
    Expect(1, 72344, '\p{InSC=:\Ageminationmark\z:}', "");;
    Expect(0, 72345, '\p{InSC=:\Ageminationmark\z:}', "");;
    Expect(1, 72344, '\p{InSC=	_GEMINATION_mark}', "");
    Expect(0, 72344, '\p{^InSC=	_GEMINATION_mark}', "");
    Expect(0, 72344, '\P{InSC=	_GEMINATION_mark}', "");
    Expect(1, 72344, '\P{^InSC=	_GEMINATION_mark}', "");
    Expect(0, 72345, '\p{InSC=	_GEMINATION_mark}', "");
    Expect(1, 72345, '\p{^InSC=	_GEMINATION_mark}', "");
    Expect(1, 72345, '\P{InSC=	_GEMINATION_mark}', "");
    Expect(0, 72345, '\P{^InSC=	_GEMINATION_mark}', "");
    Error('\p{Is_Indic_Syllabic_Category=-_GEMINATION_mark:=}');
    Error('\P{Is_Indic_Syllabic_Category=-_GEMINATION_mark:=}');
    Expect(1, 72344, '\p{Is_Indic_Syllabic_Category=geminationmark}', "");
    Expect(0, 72344, '\p{^Is_Indic_Syllabic_Category=geminationmark}', "");
    Expect(0, 72344, '\P{Is_Indic_Syllabic_Category=geminationmark}', "");
    Expect(1, 72344, '\P{^Is_Indic_Syllabic_Category=geminationmark}', "");
    Expect(0, 72345, '\p{Is_Indic_Syllabic_Category=geminationmark}', "");
    Expect(1, 72345, '\p{^Is_Indic_Syllabic_Category=geminationmark}', "");
    Expect(1, 72345, '\P{Is_Indic_Syllabic_Category=geminationmark}', "");
    Expect(0, 72345, '\P{^Is_Indic_Syllabic_Category=geminationmark}', "");
    Expect(1, 72344, '\p{Is_Indic_Syllabic_Category= _Gemination_mark}', "");
    Expect(0, 72344, '\p{^Is_Indic_Syllabic_Category= _Gemination_mark}', "");
    Expect(0, 72344, '\P{Is_Indic_Syllabic_Category= _Gemination_mark}', "");
    Expect(1, 72344, '\P{^Is_Indic_Syllabic_Category= _Gemination_mark}', "");
    Expect(0, 72345, '\p{Is_Indic_Syllabic_Category= _Gemination_mark}', "");
    Expect(1, 72345, '\p{^Is_Indic_Syllabic_Category= _Gemination_mark}', "");
    Expect(1, 72345, '\P{Is_Indic_Syllabic_Category= _Gemination_mark}', "");
    Expect(0, 72345, '\P{^Is_Indic_Syllabic_Category= _Gemination_mark}', "");
    Error('\p{Is_InSC=/a/ 	GEMINATION_mark}');
    Error('\P{Is_InSC=/a/ 	GEMINATION_mark}');
    Expect(1, 72344, '\p{Is_InSC=geminationmark}', "");
    Expect(0, 72344, '\p{^Is_InSC=geminationmark}', "");
    Expect(0, 72344, '\P{Is_InSC=geminationmark}', "");
    Expect(1, 72344, '\P{^Is_InSC=geminationmark}', "");
    Expect(0, 72345, '\p{Is_InSC=geminationmark}', "");
    Expect(1, 72345, '\p{^Is_InSC=geminationmark}', "");
    Expect(1, 72345, '\P{Is_InSC=geminationmark}', "");
    Expect(0, 72345, '\P{^Is_InSC=geminationmark}', "");
    Expect(1, 72344, '\p{Is_InSC=_-gemination_Mark}', "");
    Expect(0, 72344, '\p{^Is_InSC=_-gemination_Mark}', "");
    Expect(0, 72344, '\P{Is_InSC=_-gemination_Mark}', "");
    Expect(1, 72344, '\P{^Is_InSC=_-gemination_Mark}', "");
    Expect(0, 72345, '\p{Is_InSC=_-gemination_Mark}', "");
    Expect(1, 72345, '\p{^Is_InSC=_-gemination_Mark}', "");
    Expect(1, 72345, '\P{Is_InSC=_-gemination_Mark}', "");
    Expect(0, 72345, '\P{^Is_InSC=_-gemination_Mark}', "");
    Error('\p{Indic_Syllabic_Category=/a/-_INVISIBLE_STACKER}');
    Error('\P{Indic_Syllabic_Category=/a/-_INVISIBLE_STACKER}');
    Expect(1, 73538, '\p{Indic_Syllabic_Category=:\AInvisible_Stacker\z:}', "");;
    Expect(0, 73539, '\p{Indic_Syllabic_Category=:\AInvisible_Stacker\z:}', "");;
    Expect(1, 73538, '\p{Indic_Syllabic_Category=invisiblestacker}', "");
    Expect(0, 73538, '\p{^Indic_Syllabic_Category=invisiblestacker}', "");
    Expect(0, 73538, '\P{Indic_Syllabic_Category=invisiblestacker}', "");
    Expect(1, 73538, '\P{^Indic_Syllabic_Category=invisiblestacker}', "");
    Expect(0, 73539, '\p{Indic_Syllabic_Category=invisiblestacker}', "");
    Expect(1, 73539, '\p{^Indic_Syllabic_Category=invisiblestacker}', "");
    Expect(1, 73539, '\P{Indic_Syllabic_Category=invisiblestacker}', "");
    Expect(0, 73539, '\P{^Indic_Syllabic_Category=invisiblestacker}', "");
    Expect(1, 73538, '\p{Indic_Syllabic_Category=:\Ainvisiblestacker\z:}', "");;
    Expect(0, 73539, '\p{Indic_Syllabic_Category=:\Ainvisiblestacker\z:}', "");;
    Expect(1, 73538, '\p{Indic_Syllabic_Category=	INVISIBLE_Stacker}', "");
    Expect(0, 73538, '\p{^Indic_Syllabic_Category=	INVISIBLE_Stacker}', "");
    Expect(0, 73538, '\P{Indic_Syllabic_Category=	INVISIBLE_Stacker}', "");
    Expect(1, 73538, '\P{^Indic_Syllabic_Category=	INVISIBLE_Stacker}', "");
    Expect(0, 73539, '\p{Indic_Syllabic_Category=	INVISIBLE_Stacker}', "");
    Expect(1, 73539, '\p{^Indic_Syllabic_Category=	INVISIBLE_Stacker}', "");
    Expect(1, 73539, '\P{Indic_Syllabic_Category=	INVISIBLE_Stacker}', "");
    Expect(0, 73539, '\P{^Indic_Syllabic_Category=	INVISIBLE_Stacker}', "");
    Error('\p{InSC=	Invisible_STACKER:=}');
    Error('\P{InSC=	Invisible_STACKER:=}');
    Expect(1, 73538, '\p{InSC=:\AInvisible_Stacker\z:}', "");;
    Expect(0, 73539, '\p{InSC=:\AInvisible_Stacker\z:}', "");;
    Expect(1, 73538, '\p{InSC=invisiblestacker}', "");
    Expect(0, 73538, '\p{^InSC=invisiblestacker}', "");
    Expect(0, 73538, '\P{InSC=invisiblestacker}', "");
    Expect(1, 73538, '\P{^InSC=invisiblestacker}', "");
    Expect(0, 73539, '\p{InSC=invisiblestacker}', "");
    Expect(1, 73539, '\p{^InSC=invisiblestacker}', "");
    Expect(1, 73539, '\P{InSC=invisiblestacker}', "");
    Expect(0, 73539, '\P{^InSC=invisiblestacker}', "");
    Expect(1, 73538, '\p{InSC=:\Ainvisiblestacker\z:}', "");;
    Expect(0, 73539, '\p{InSC=:\Ainvisiblestacker\z:}', "");;
    Expect(1, 73538, '\p{InSC=	_Invisible_STACKER}', "");
    Expect(0, 73538, '\p{^InSC=	_Invisible_STACKER}', "");
    Expect(0, 73538, '\P{InSC=	_Invisible_STACKER}', "");
    Expect(1, 73538, '\P{^InSC=	_Invisible_STACKER}', "");
    Expect(0, 73539, '\p{InSC=	_Invisible_STACKER}', "");
    Expect(1, 73539, '\p{^InSC=	_Invisible_STACKER}', "");
    Expect(1, 73539, '\P{InSC=	_Invisible_STACKER}', "");
    Expect(0, 73539, '\P{^InSC=	_Invisible_STACKER}', "");
    Error('\p{Is_Indic_Syllabic_Category:	/a/	_Invisible_Stacker}');
    Error('\P{Is_Indic_Syllabic_Category:	/a/	_Invisible_Stacker}');
    Expect(1, 73538, '\p{Is_Indic_Syllabic_Category=invisiblestacker}', "");
    Expect(0, 73538, '\p{^Is_Indic_Syllabic_Category=invisiblestacker}', "");
    Expect(0, 73538, '\P{Is_Indic_Syllabic_Category=invisiblestacker}', "");
    Expect(1, 73538, '\P{^Is_Indic_Syllabic_Category=invisiblestacker}', "");
    Expect(0, 73539, '\p{Is_Indic_Syllabic_Category=invisiblestacker}', "");
    Expect(1, 73539, '\p{^Is_Indic_Syllabic_Category=invisiblestacker}', "");
    Expect(1, 73539, '\P{Is_Indic_Syllabic_Category=invisiblestacker}', "");
    Expect(0, 73539, '\P{^Is_Indic_Syllabic_Category=invisiblestacker}', "");
    Expect(1, 73538, '\p{Is_Indic_Syllabic_Category=-	invisible_Stacker}', "");
    Expect(0, 73538, '\p{^Is_Indic_Syllabic_Category=-	invisible_Stacker}', "");
    Expect(0, 73538, '\P{Is_Indic_Syllabic_Category=-	invisible_Stacker}', "");
    Expect(1, 73538, '\P{^Is_Indic_Syllabic_Category=-	invisible_Stacker}', "");
    Expect(0, 73539, '\p{Is_Indic_Syllabic_Category=-	invisible_Stacker}', "");
    Expect(1, 73539, '\p{^Is_Indic_Syllabic_Category=-	invisible_Stacker}', "");
    Expect(1, 73539, '\P{Is_Indic_Syllabic_Category=-	invisible_Stacker}', "");
    Expect(0, 73539, '\P{^Is_Indic_Syllabic_Category=-	invisible_Stacker}', "");
    Error('\p{Is_InSC= /a/invisible_STACKER}');
    Error('\P{Is_InSC= /a/invisible_STACKER}');
    Expect(1, 73538, '\p{Is_InSC=invisiblestacker}', "");
    Expect(0, 73538, '\p{^Is_InSC=invisiblestacker}', "");
    Expect(0, 73538, '\P{Is_InSC=invisiblestacker}', "");
    Expect(1, 73538, '\P{^Is_InSC=invisiblestacker}', "");
    Expect(0, 73539, '\p{Is_InSC=invisiblestacker}', "");
    Expect(1, 73539, '\p{^Is_InSC=invisiblestacker}', "");
    Expect(1, 73539, '\P{Is_InSC=invisiblestacker}', "");
    Expect(0, 73539, '\P{^Is_InSC=invisiblestacker}', "");
    Expect(1, 73538, '\p{Is_InSC=	invisible_Stacker}', "");
    Expect(0, 73538, '\p{^Is_InSC=	invisible_Stacker}', "");
    Expect(0, 73538, '\P{Is_InSC=	invisible_Stacker}', "");
    Expect(1, 73538, '\P{^Is_InSC=	invisible_Stacker}', "");
    Expect(0, 73539, '\p{Is_InSC=	invisible_Stacker}', "");
    Expect(1, 73539, '\p{^Is_InSC=	invisible_Stacker}', "");
    Expect(1, 73539, '\P{Is_InSC=	invisible_Stacker}', "");
    Expect(0, 73539, '\P{^Is_InSC=	invisible_Stacker}', "");
    Error('\p{Indic_Syllabic_Category= /a/Joiner}');
    Error('\P{Indic_Syllabic_Category= /a/Joiner}');
    Expect(1, 8205, '\p{Indic_Syllabic_Category=:\AJoiner\z:}', "");;
    Expect(0, 8206, '\p{Indic_Syllabic_Category=:\AJoiner\z:}', "");;
    Expect(1, 8205, '\p{Indic_Syllabic_Category=joiner}', "");
    Expect(0, 8205, '\p{^Indic_Syllabic_Category=joiner}', "");
    Expect(0, 8205, '\P{Indic_Syllabic_Category=joiner}', "");
    Expect(1, 8205, '\P{^Indic_Syllabic_Category=joiner}', "");
    Expect(0, 8206, '\p{Indic_Syllabic_Category=joiner}', "");
    Expect(1, 8206, '\p{^Indic_Syllabic_Category=joiner}', "");
    Expect(1, 8206, '\P{Indic_Syllabic_Category=joiner}', "");
    Expect(0, 8206, '\P{^Indic_Syllabic_Category=joiner}', "");
    Expect(1, 8205, '\p{Indic_Syllabic_Category=:\Ajoiner\z:}', "");;
    Expect(0, 8206, '\p{Indic_Syllabic_Category=:\Ajoiner\z:}', "");;
    Expect(1, 8205, '\p{Indic_Syllabic_Category=_	JOINER}', "");
    Expect(0, 8205, '\p{^Indic_Syllabic_Category=_	JOINER}', "");
    Expect(0, 8205, '\P{Indic_Syllabic_Category=_	JOINER}', "");
    Expect(1, 8205, '\P{^Indic_Syllabic_Category=_	JOINER}', "");
    Expect(0, 8206, '\p{Indic_Syllabic_Category=_	JOINER}', "");
    Expect(1, 8206, '\p{^Indic_Syllabic_Category=_	JOINER}', "");
    Expect(1, 8206, '\P{Indic_Syllabic_Category=_	JOINER}', "");
    Expect(0, 8206, '\P{^Indic_Syllabic_Category=_	JOINER}', "");
    Error('\p{InSC: _JOINER:=}');
    Error('\P{InSC: _JOINER:=}');
    Expect(1, 8205, '\p{InSC=:\AJoiner\z:}', "");;
    Expect(0, 8206, '\p{InSC=:\AJoiner\z:}', "");;
    Expect(1, 8205, '\p{InSC=joiner}', "");
    Expect(0, 8205, '\p{^InSC=joiner}', "");
    Expect(0, 8205, '\P{InSC=joiner}', "");
    Expect(1, 8205, '\P{^InSC=joiner}', "");
    Expect(0, 8206, '\p{InSC=joiner}', "");
    Expect(1, 8206, '\p{^InSC=joiner}', "");
    Expect(1, 8206, '\P{InSC=joiner}', "");
    Expect(0, 8206, '\P{^InSC=joiner}', "");
    Expect(1, 8205, '\p{InSC=:\Ajoiner\z:}', "");;
    Expect(0, 8206, '\p{InSC=:\Ajoiner\z:}', "");;
    Expect(1, 8205, '\p{InSC: __Joiner}', "");
    Expect(0, 8205, '\p{^InSC: __Joiner}', "");
    Expect(0, 8205, '\P{InSC: __Joiner}', "");
    Expect(1, 8205, '\P{^InSC: __Joiner}', "");
    Expect(0, 8206, '\p{InSC: __Joiner}', "");
    Expect(1, 8206, '\p{^InSC: __Joiner}', "");
    Expect(1, 8206, '\P{InSC: __Joiner}', "");
    Expect(0, 8206, '\P{^InSC: __Joiner}', "");
    Error('\p{Is_Indic_Syllabic_Category=_-joiner:=}');
    Error('\P{Is_Indic_Syllabic_Category=_-joiner:=}');
    Expect(1, 8205, '\p{Is_Indic_Syllabic_Category=joiner}', "");
    Expect(0, 8205, '\p{^Is_Indic_Syllabic_Category=joiner}', "");
    Expect(0, 8205, '\P{Is_Indic_Syllabic_Category=joiner}', "");
    Expect(1, 8205, '\P{^Is_Indic_Syllabic_Category=joiner}', "");
    Expect(0, 8206, '\p{Is_Indic_Syllabic_Category=joiner}', "");
    Expect(1, 8206, '\p{^Is_Indic_Syllabic_Category=joiner}', "");
    Expect(1, 8206, '\P{Is_Indic_Syllabic_Category=joiner}', "");
    Expect(0, 8206, '\P{^Is_Indic_Syllabic_Category=joiner}', "");
    Expect(1, 8205, '\p{Is_Indic_Syllabic_Category= -Joiner}', "");
    Expect(0, 8205, '\p{^Is_Indic_Syllabic_Category= -Joiner}', "");
    Expect(0, 8205, '\P{Is_Indic_Syllabic_Category= -Joiner}', "");
    Expect(1, 8205, '\P{^Is_Indic_Syllabic_Category= -Joiner}', "");
    Expect(0, 8206, '\p{Is_Indic_Syllabic_Category= -Joiner}', "");
    Expect(1, 8206, '\p{^Is_Indic_Syllabic_Category= -Joiner}', "");
    Expect(1, 8206, '\P{Is_Indic_Syllabic_Category= -Joiner}', "");
    Expect(0, 8206, '\P{^Is_Indic_Syllabic_Category= -Joiner}', "");
    Error('\p{Is_InSC=- joiner/a/}');
    Error('\P{Is_InSC=- joiner/a/}');
    Expect(1, 8205, '\p{Is_InSC=joiner}', "");
    Expect(0, 8205, '\p{^Is_InSC=joiner}', "");
    Expect(0, 8205, '\P{Is_InSC=joiner}', "");
    Expect(1, 8205, '\P{^Is_InSC=joiner}', "");
    Expect(0, 8206, '\p{Is_InSC=joiner}', "");
    Expect(1, 8206, '\p{^Is_InSC=joiner}', "");
    Expect(1, 8206, '\P{Is_InSC=joiner}', "");
    Expect(0, 8206, '\P{^Is_InSC=joiner}', "");
    Expect(1, 8205, '\p{Is_InSC=	joiner}', "");
    Expect(0, 8205, '\p{^Is_InSC=	joiner}', "");
    Expect(0, 8205, '\P{Is_InSC=	joiner}', "");
    Expect(1, 8205, '\P{^Is_InSC=	joiner}', "");
    Expect(0, 8206, '\p{Is_InSC=	joiner}', "");
    Expect(1, 8206, '\p{^Is_InSC=	joiner}', "");
    Expect(1, 8206, '\P{Is_InSC=	joiner}', "");
    Expect(0, 8206, '\P{^Is_InSC=	joiner}', "");
    Error('\p{Indic_Syllabic_Category=/a/-_Modifying_letter}');
    Error('\P{Indic_Syllabic_Category=/a/-_Modifying_letter}');
    Expect(1, 2947, '\p{Indic_Syllabic_Category=:\AModifying_Letter\z:}', "");;
    Expect(0, 2948, '\p{Indic_Syllabic_Category=:\AModifying_Letter\z:}', "");;
    Expect(1, 2947, '\p{Indic_Syllabic_Category=modifyingletter}', "");
    Expect(0, 2947, '\p{^Indic_Syllabic_Category=modifyingletter}', "");
    Expect(0, 2947, '\P{Indic_Syllabic_Category=modifyingletter}', "");
    Expect(1, 2947, '\P{^Indic_Syllabic_Category=modifyingletter}', "");
    Expect(0, 2948, '\p{Indic_Syllabic_Category=modifyingletter}', "");
    Expect(1, 2948, '\p{^Indic_Syllabic_Category=modifyingletter}', "");
    Expect(1, 2948, '\P{Indic_Syllabic_Category=modifyingletter}', "");
    Expect(0, 2948, '\P{^Indic_Syllabic_Category=modifyingletter}', "");
    Expect(1, 2947, '\p{Indic_Syllabic_Category=:\Amodifyingletter\z:}', "");;
    Expect(0, 2948, '\p{Indic_Syllabic_Category=:\Amodifyingletter\z:}', "");;
    Expect(1, 2947, '\p{Indic_Syllabic_Category=	 Modifying_LETTER}', "");
    Expect(0, 2947, '\p{^Indic_Syllabic_Category=	 Modifying_LETTER}', "");
    Expect(0, 2947, '\P{Indic_Syllabic_Category=	 Modifying_LETTER}', "");
    Expect(1, 2947, '\P{^Indic_Syllabic_Category=	 Modifying_LETTER}', "");
    Expect(0, 2948, '\p{Indic_Syllabic_Category=	 Modifying_LETTER}', "");
    Expect(1, 2948, '\p{^Indic_Syllabic_Category=	 Modifying_LETTER}', "");
    Expect(1, 2948, '\P{Indic_Syllabic_Category=	 Modifying_LETTER}', "");
    Expect(0, 2948, '\P{^Indic_Syllabic_Category=	 Modifying_LETTER}', "");
    Error('\p{InSC=	_Modifying_Letter:=}');
    Error('\P{InSC=	_Modifying_Letter:=}');
    Expect(1, 2947, '\p{InSC=:\AModifying_Letter\z:}', "");;
    Expect(0, 2948, '\p{InSC=:\AModifying_Letter\z:}', "");;
    Expect(1, 2947, '\p{InSC:modifyingletter}', "");
    Expect(0, 2947, '\p{^InSC:modifyingletter}', "");
    Expect(0, 2947, '\P{InSC:modifyingletter}', "");
    Expect(1, 2947, '\P{^InSC:modifyingletter}', "");
    Expect(0, 2948, '\p{InSC:modifyingletter}', "");
    Expect(1, 2948, '\p{^InSC:modifyingletter}', "");
    Expect(1, 2948, '\P{InSC:modifyingletter}', "");
    Expect(0, 2948, '\P{^InSC:modifyingletter}', "");
    Expect(1, 2947, '\p{InSC=:\Amodifyingletter\z:}', "");;
    Expect(0, 2948, '\p{InSC=:\Amodifyingletter\z:}', "");;
    Expect(1, 2947, '\p{InSC=_modifying_Letter}', "");
    Expect(0, 2947, '\p{^InSC=_modifying_Letter}', "");
    Expect(0, 2947, '\P{InSC=_modifying_Letter}', "");
    Expect(1, 2947, '\P{^InSC=_modifying_Letter}', "");
    Expect(0, 2948, '\p{InSC=_modifying_Letter}', "");
    Expect(1, 2948, '\p{^InSC=_modifying_Letter}', "");
    Expect(1, 2948, '\P{InSC=_modifying_Letter}', "");
    Expect(0, 2948, '\P{^InSC=_modifying_Letter}', "");
    Error('\p{Is_Indic_Syllabic_Category=_:=MODIFYING_Letter}');
    Error('\P{Is_Indic_Syllabic_Category=_:=MODIFYING_Letter}');
    Expect(1, 2947, '\p{Is_Indic_Syllabic_Category=modifyingletter}', "");
    Expect(0, 2947, '\p{^Is_Indic_Syllabic_Category=modifyingletter}', "");
    Expect(0, 2947, '\P{Is_Indic_Syllabic_Category=modifyingletter}', "");
    Expect(1, 2947, '\P{^Is_Indic_Syllabic_Category=modifyingletter}', "");
    Expect(0, 2948, '\p{Is_Indic_Syllabic_Category=modifyingletter}', "");
    Expect(1, 2948, '\p{^Is_Indic_Syllabic_Category=modifyingletter}', "");
    Expect(1, 2948, '\P{Is_Indic_Syllabic_Category=modifyingletter}', "");
    Expect(0, 2948, '\P{^Is_Indic_Syllabic_Category=modifyingletter}', "");
    Expect(1, 2947, '\p{Is_Indic_Syllabic_Category=modifying_LETTER}', "");
    Expect(0, 2947, '\p{^Is_Indic_Syllabic_Category=modifying_LETTER}', "");
    Expect(0, 2947, '\P{Is_Indic_Syllabic_Category=modifying_LETTER}', "");
    Expect(1, 2947, '\P{^Is_Indic_Syllabic_Category=modifying_LETTER}', "");
    Expect(0, 2948, '\p{Is_Indic_Syllabic_Category=modifying_LETTER}', "");
    Expect(1, 2948, '\p{^Is_Indic_Syllabic_Category=modifying_LETTER}', "");
    Expect(1, 2948, '\P{Is_Indic_Syllabic_Category=modifying_LETTER}', "");
    Expect(0, 2948, '\P{^Is_Indic_Syllabic_Category=modifying_LETTER}', "");
    Error('\p{Is_InSC=_	Modifying_letter:=}');
    Error('\P{Is_InSC=_	Modifying_letter:=}');
    Expect(1, 2947, '\p{Is_InSC=modifyingletter}', "");
    Expect(0, 2947, '\p{^Is_InSC=modifyingletter}', "");
    Expect(0, 2947, '\P{Is_InSC=modifyingletter}', "");
    Expect(1, 2947, '\P{^Is_InSC=modifyingletter}', "");
    Expect(0, 2948, '\p{Is_InSC=modifyingletter}', "");
    Expect(1, 2948, '\p{^Is_InSC=modifyingletter}', "");
    Expect(1, 2948, '\P{Is_InSC=modifyingletter}', "");
    Expect(0, 2948, '\P{^Is_InSC=modifyingletter}', "");
    Expect(1, 2947, '\p{Is_InSC=	_Modifying_Letter}', "");
    Expect(0, 2947, '\p{^Is_InSC=	_Modifying_Letter}', "");
    Expect(0, 2947, '\P{Is_InSC=	_Modifying_Letter}', "");
    Expect(1, 2947, '\P{^Is_InSC=	_Modifying_Letter}', "");
    Expect(0, 2948, '\p{Is_InSC=	_Modifying_Letter}', "");
    Expect(1, 2948, '\p{^Is_InSC=	_Modifying_Letter}', "");
    Expect(1, 2948, '\P{Is_InSC=	_Modifying_Letter}', "");
    Expect(0, 2948, '\P{^Is_InSC=	_Modifying_Letter}', "");
    Error('\p{Indic_Syllabic_Category=-_non_Joiner:=}');
    Error('\P{Indic_Syllabic_Category=-_non_Joiner:=}');
    Expect(1, 8204, '\p{Indic_Syllabic_Category=:\ANon_Joiner\z:}', "");;
    Expect(0, 8205, '\p{Indic_Syllabic_Category=:\ANon_Joiner\z:}', "");;
    Expect(1, 8204, '\p{Indic_Syllabic_Category=nonjoiner}', "");
    Expect(0, 8204, '\p{^Indic_Syllabic_Category=nonjoiner}', "");
    Expect(0, 8204, '\P{Indic_Syllabic_Category=nonjoiner}', "");
    Expect(1, 8204, '\P{^Indic_Syllabic_Category=nonjoiner}', "");
    Expect(0, 8205, '\p{Indic_Syllabic_Category=nonjoiner}', "");
    Expect(1, 8205, '\p{^Indic_Syllabic_Category=nonjoiner}', "");
    Expect(1, 8205, '\P{Indic_Syllabic_Category=nonjoiner}', "");
    Expect(0, 8205, '\P{^Indic_Syllabic_Category=nonjoiner}', "");
    Expect(1, 8204, '\p{Indic_Syllabic_Category=:\Anonjoiner\z:}', "");;
    Expect(0, 8205, '\p{Indic_Syllabic_Category=:\Anonjoiner\z:}', "");;
    Expect(1, 8204, '\p{Indic_Syllabic_Category:	_NON_Joiner}', "");
    Expect(0, 8204, '\p{^Indic_Syllabic_Category:	_NON_Joiner}', "");
    Expect(0, 8204, '\P{Indic_Syllabic_Category:	_NON_Joiner}', "");
    Expect(1, 8204, '\P{^Indic_Syllabic_Category:	_NON_Joiner}', "");
    Expect(0, 8205, '\p{Indic_Syllabic_Category:	_NON_Joiner}', "");
    Expect(1, 8205, '\p{^Indic_Syllabic_Category:	_NON_Joiner}', "");
    Expect(1, 8205, '\P{Indic_Syllabic_Category:	_NON_Joiner}', "");
    Expect(0, 8205, '\P{^Indic_Syllabic_Category:	_NON_Joiner}', "");
    Error('\p{InSC=-Non_JOINER/a/}');
    Error('\P{InSC=-Non_JOINER/a/}');
    Expect(1, 8204, '\p{InSC=:\ANon_Joiner\z:}', "");;
    Expect(0, 8205, '\p{InSC=:\ANon_Joiner\z:}', "");;
    Expect(1, 8204, '\p{InSC:nonjoiner}', "");
    Expect(0, 8204, '\p{^InSC:nonjoiner}', "");
    Expect(0, 8204, '\P{InSC:nonjoiner}', "");
    Expect(1, 8204, '\P{^InSC:nonjoiner}', "");
    Expect(0, 8205, '\p{InSC:nonjoiner}', "");
    Expect(1, 8205, '\p{^InSC:nonjoiner}', "");
    Expect(1, 8205, '\P{InSC:nonjoiner}', "");
    Expect(0, 8205, '\P{^InSC:nonjoiner}', "");
    Expect(1, 8204, '\p{InSC=:\Anonjoiner\z:}', "");;
    Expect(0, 8205, '\p{InSC=:\Anonjoiner\z:}', "");;
    Expect(1, 8204, '\p{InSC=-	Non_Joiner}', "");
    Expect(0, 8204, '\p{^InSC=-	Non_Joiner}', "");
    Expect(0, 8204, '\P{InSC=-	Non_Joiner}', "");
    Expect(1, 8204, '\P{^InSC=-	Non_Joiner}', "");
    Expect(0, 8205, '\p{InSC=-	Non_Joiner}', "");
    Expect(1, 8205, '\p{^InSC=-	Non_Joiner}', "");
    Expect(1, 8205, '\P{InSC=-	Non_Joiner}', "");
    Expect(0, 8205, '\P{^InSC=-	Non_Joiner}', "");
    Error('\p{Is_Indic_Syllabic_Category=-:=NON_JOINER}');
    Error('\P{Is_Indic_Syllabic_Category=-:=NON_JOINER}');
    Expect(1, 8204, '\p{Is_Indic_Syllabic_Category:	nonjoiner}', "");
    Expect(0, 8204, '\p{^Is_Indic_Syllabic_Category:	nonjoiner}', "");
    Expect(0, 8204, '\P{Is_Indic_Syllabic_Category:	nonjoiner}', "");
    Expect(1, 8204, '\P{^Is_Indic_Syllabic_Category:	nonjoiner}', "");
    Expect(0, 8205, '\p{Is_Indic_Syllabic_Category:	nonjoiner}', "");
    Expect(1, 8205, '\p{^Is_Indic_Syllabic_Category:	nonjoiner}', "");
    Expect(1, 8205, '\P{Is_Indic_Syllabic_Category:	nonjoiner}', "");
    Expect(0, 8205, '\P{^Is_Indic_Syllabic_Category:	nonjoiner}', "");
    Expect(1, 8204, '\p{Is_Indic_Syllabic_Category= 	Non_JOINER}', "");
    Expect(0, 8204, '\p{^Is_Indic_Syllabic_Category= 	Non_JOINER}', "");
    Expect(0, 8204, '\P{Is_Indic_Syllabic_Category= 	Non_JOINER}', "");
    Expect(1, 8204, '\P{^Is_Indic_Syllabic_Category= 	Non_JOINER}', "");
    Expect(0, 8205, '\p{Is_Indic_Syllabic_Category= 	Non_JOINER}', "");
    Expect(1, 8205, '\p{^Is_Indic_Syllabic_Category= 	Non_JOINER}', "");
    Expect(1, 8205, '\P{Is_Indic_Syllabic_Category= 	Non_JOINER}', "");
    Expect(0, 8205, '\P{^Is_Indic_Syllabic_Category= 	Non_JOINER}', "");
    Error('\p{Is_InSC:	/a/	non_Joiner}');
    Error('\P{Is_InSC:	/a/	non_Joiner}');
    Expect(1, 8204, '\p{Is_InSC=nonjoiner}', "");
    Expect(0, 8204, '\p{^Is_InSC=nonjoiner}', "");
    Expect(0, 8204, '\P{Is_InSC=nonjoiner}', "");
    Expect(1, 8204, '\P{^Is_InSC=nonjoiner}', "");
    Expect(0, 8205, '\p{Is_InSC=nonjoiner}', "");
    Expect(1, 8205, '\p{^Is_InSC=nonjoiner}', "");
    Expect(1, 8205, '\P{Is_InSC=nonjoiner}', "");
    Expect(0, 8205, '\P{^Is_InSC=nonjoiner}', "");
    Expect(1, 8204, '\p{Is_InSC=		Non_JOINER}', "");
    Expect(0, 8204, '\p{^Is_InSC=		Non_JOINER}', "");
    Expect(0, 8204, '\P{Is_InSC=		Non_JOINER}', "");
    Expect(1, 8204, '\P{^Is_InSC=		Non_JOINER}', "");
    Expect(0, 8205, '\p{Is_InSC=		Non_JOINER}', "");
    Expect(1, 8205, '\p{^Is_InSC=		Non_JOINER}', "");
    Expect(1, 8205, '\P{Is_InSC=		Non_JOINER}', "");
    Expect(0, 8205, '\P{^Is_InSC=		Non_JOINER}', "");
    Error('\p{Indic_Syllabic_Category=  Nukta/a/}');
    Error('\P{Indic_Syllabic_Category=  Nukta/a/}');
    Expect(1, 73026, '\p{Indic_Syllabic_Category=:\ANukta\z:}', "");;
    Expect(0, 73027, '\p{Indic_Syllabic_Category=:\ANukta\z:}', "");;
    Expect(1, 73026, '\p{Indic_Syllabic_Category=nukta}', "");
    Expect(0, 73026, '\p{^Indic_Syllabic_Category=nukta}', "");
    Expect(0, 73026, '\P{Indic_Syllabic_Category=nukta}', "");
    Expect(1, 73026, '\P{^Indic_Syllabic_Category=nukta}', "");
    Expect(0, 73027, '\p{Indic_Syllabic_Category=nukta}', "");
    Expect(1, 73027, '\p{^Indic_Syllabic_Category=nukta}', "");
    Expect(1, 73027, '\P{Indic_Syllabic_Category=nukta}', "");
    Expect(0, 73027, '\P{^Indic_Syllabic_Category=nukta}', "");
    Expect(1, 73026, '\p{Indic_Syllabic_Category=:\Anukta\z:}', "");;
    Expect(0, 73027, '\p{Indic_Syllabic_Category=:\Anukta\z:}', "");;
    Expect(1, 73026, '\p{Indic_Syllabic_Category= 	Nukta}', "");
    Expect(0, 73026, '\p{^Indic_Syllabic_Category= 	Nukta}', "");
    Expect(0, 73026, '\P{Indic_Syllabic_Category= 	Nukta}', "");
    Expect(1, 73026, '\P{^Indic_Syllabic_Category= 	Nukta}', "");
    Expect(0, 73027, '\p{Indic_Syllabic_Category= 	Nukta}', "");
    Expect(1, 73027, '\p{^Indic_Syllabic_Category= 	Nukta}', "");
    Expect(1, 73027, '\P{Indic_Syllabic_Category= 	Nukta}', "");
    Expect(0, 73027, '\P{^Indic_Syllabic_Category= 	Nukta}', "");
    Error('\p{InSC=-/a/nukta}');
    Error('\P{InSC=-/a/nukta}');
    Expect(1, 73026, '\p{InSC=:\ANukta\z:}', "");;
    Expect(0, 73027, '\p{InSC=:\ANukta\z:}', "");;
    Expect(1, 73026, '\p{InSC=nukta}', "");
    Expect(0, 73026, '\p{^InSC=nukta}', "");
    Expect(0, 73026, '\P{InSC=nukta}', "");
    Expect(1, 73026, '\P{^InSC=nukta}', "");
    Expect(0, 73027, '\p{InSC=nukta}', "");
    Expect(1, 73027, '\p{^InSC=nukta}', "");
    Expect(1, 73027, '\P{InSC=nukta}', "");
    Expect(0, 73027, '\P{^InSC=nukta}', "");
    Expect(1, 73026, '\p{InSC=:\Anukta\z:}', "");;
    Expect(0, 73027, '\p{InSC=:\Anukta\z:}', "");;
    Expect(1, 73026, '\p{InSC=	NUKTA}', "");
    Expect(0, 73026, '\p{^InSC=	NUKTA}', "");
    Expect(0, 73026, '\P{InSC=	NUKTA}', "");
    Expect(1, 73026, '\P{^InSC=	NUKTA}', "");
    Expect(0, 73027, '\p{InSC=	NUKTA}', "");
    Expect(1, 73027, '\p{^InSC=	NUKTA}', "");
    Expect(1, 73027, '\P{InSC=	NUKTA}', "");
    Expect(0, 73027, '\P{^InSC=	NUKTA}', "");
    Error('\p{Is_Indic_Syllabic_Category=-_Nukta:=}');
    Error('\P{Is_Indic_Syllabic_Category=-_Nukta:=}');
    Expect(1, 73026, '\p{Is_Indic_Syllabic_Category: nukta}', "");
    Expect(0, 73026, '\p{^Is_Indic_Syllabic_Category: nukta}', "");
    Expect(0, 73026, '\P{Is_Indic_Syllabic_Category: nukta}', "");
    Expect(1, 73026, '\P{^Is_Indic_Syllabic_Category: nukta}', "");
    Expect(0, 73027, '\p{Is_Indic_Syllabic_Category: nukta}', "");
    Expect(1, 73027, '\p{^Is_Indic_Syllabic_Category: nukta}', "");
    Expect(1, 73027, '\P{Is_Indic_Syllabic_Category: nukta}', "");
    Expect(0, 73027, '\P{^Is_Indic_Syllabic_Category: nukta}', "");
    Expect(1, 73026, '\p{Is_Indic_Syllabic_Category=_nukta}', "");
    Expect(0, 73026, '\p{^Is_Indic_Syllabic_Category=_nukta}', "");
    Expect(0, 73026, '\P{Is_Indic_Syllabic_Category=_nukta}', "");
    Expect(1, 73026, '\P{^Is_Indic_Syllabic_Category=_nukta}', "");
    Expect(0, 73027, '\p{Is_Indic_Syllabic_Category=_nukta}', "");
    Expect(1, 73027, '\p{^Is_Indic_Syllabic_Category=_nukta}', "");
    Expect(1, 73027, '\P{Is_Indic_Syllabic_Category=_nukta}', "");
    Expect(0, 73027, '\P{^Is_Indic_Syllabic_Category=_nukta}', "");
    Error('\p{Is_InSC=_:=NUKTA}');
    Error('\P{Is_InSC=_:=NUKTA}');
    Expect(1, 73026, '\p{Is_InSC=nukta}', "");
    Expect(0, 73026, '\p{^Is_InSC=nukta}', "");
    Expect(0, 73026, '\P{Is_InSC=nukta}', "");
    Expect(1, 73026, '\P{^Is_InSC=nukta}', "");
    Expect(0, 73027, '\p{Is_InSC=nukta}', "");
    Expect(1, 73027, '\p{^Is_InSC=nukta}', "");
    Expect(1, 73027, '\P{Is_InSC=nukta}', "");
    Expect(0, 73027, '\P{^Is_InSC=nukta}', "");
    Expect(1, 73026, '\p{Is_InSC=--Nukta}', "");
    Expect(0, 73026, '\p{^Is_InSC=--Nukta}', "");
    Expect(0, 73026, '\P{Is_InSC=--Nukta}', "");
    Expect(1, 73026, '\P{^Is_InSC=--Nukta}', "");
    Expect(0, 73027, '\p{Is_InSC=--Nukta}', "");
    Expect(1, 73027, '\p{^Is_InSC=--Nukta}', "");
    Expect(1, 73027, '\P{Is_InSC=--Nukta}', "");
    Expect(0, 73027, '\P{^Is_InSC=--Nukta}', "");
    Error('\p{Indic_Syllabic_Category= -Number/a/}');
    Error('\P{Indic_Syllabic_Category= -Number/a/}');
    Expect(1, 73561, '\p{Indic_Syllabic_Category=:\ANumber\z:}', "");;
    Expect(0, 73562, '\p{Indic_Syllabic_Category=:\ANumber\z:}', "");;
    Expect(1, 73561, '\p{Indic_Syllabic_Category=number}', "");
    Expect(0, 73561, '\p{^Indic_Syllabic_Category=number}', "");
    Expect(0, 73561, '\P{Indic_Syllabic_Category=number}', "");
    Expect(1, 73561, '\P{^Indic_Syllabic_Category=number}', "");
    Expect(0, 73562, '\p{Indic_Syllabic_Category=number}', "");
    Expect(1, 73562, '\p{^Indic_Syllabic_Category=number}', "");
    Expect(1, 73562, '\P{Indic_Syllabic_Category=number}', "");
    Expect(0, 73562, '\P{^Indic_Syllabic_Category=number}', "");
    Expect(1, 73561, '\p{Indic_Syllabic_Category=:\Anumber\z:}', "");;
    Expect(0, 73562, '\p{Indic_Syllabic_Category=:\Anumber\z:}', "");;
    Expect(1, 73561, '\p{Indic_Syllabic_Category=-_Number}', "");
    Expect(0, 73561, '\p{^Indic_Syllabic_Category=-_Number}', "");
    Expect(0, 73561, '\P{Indic_Syllabic_Category=-_Number}', "");
    Expect(1, 73561, '\P{^Indic_Syllabic_Category=-_Number}', "");
    Expect(0, 73562, '\p{Indic_Syllabic_Category=-_Number}', "");
    Expect(1, 73562, '\p{^Indic_Syllabic_Category=-_Number}', "");
    Expect(1, 73562, '\P{Indic_Syllabic_Category=-_Number}', "");
    Expect(0, 73562, '\P{^Indic_Syllabic_Category=-_Number}', "");
    Error('\p{InSC=:=Number}');
    Error('\P{InSC=:=Number}');
    Expect(1, 73561, '\p{InSC=:\ANumber\z:}', "");;
    Expect(0, 73562, '\p{InSC=:\ANumber\z:}', "");;
    Expect(1, 73561, '\p{InSC=number}', "");
    Expect(0, 73561, '\p{^InSC=number}', "");
    Expect(0, 73561, '\P{InSC=number}', "");
    Expect(1, 73561, '\P{^InSC=number}', "");
    Expect(0, 73562, '\p{InSC=number}', "");
    Expect(1, 73562, '\p{^InSC=number}', "");
    Expect(1, 73562, '\P{InSC=number}', "");
    Expect(0, 73562, '\P{^InSC=number}', "");
    Expect(1, 73561, '\p{InSC=:\Anumber\z:}', "");;
    Expect(0, 73562, '\p{InSC=:\Anumber\z:}', "");;
    Expect(1, 73561, '\p{InSC=-_Number}', "");
    Expect(0, 73561, '\p{^InSC=-_Number}', "");
    Expect(0, 73561, '\P{InSC=-_Number}', "");
    Expect(1, 73561, '\P{^InSC=-_Number}', "");
    Expect(0, 73562, '\p{InSC=-_Number}', "");
    Expect(1, 73562, '\p{^InSC=-_Number}', "");
    Expect(1, 73562, '\P{InSC=-_Number}', "");
    Expect(0, 73562, '\P{^InSC=-_Number}', "");
    Error('\p{Is_Indic_Syllabic_Category=--Number/a/}');
    Error('\P{Is_Indic_Syllabic_Category=--Number/a/}');
    Expect(1, 73561, '\p{Is_Indic_Syllabic_Category=number}', "");
    Expect(0, 73561, '\p{^Is_Indic_Syllabic_Category=number}', "");
    Expect(0, 73561, '\P{Is_Indic_Syllabic_Category=number}', "");
    Expect(1, 73561, '\P{^Is_Indic_Syllabic_Category=number}', "");
    Expect(0, 73562, '\p{Is_Indic_Syllabic_Category=number}', "");
    Expect(1, 73562, '\p{^Is_Indic_Syllabic_Category=number}', "");
    Expect(1, 73562, '\P{Is_Indic_Syllabic_Category=number}', "");
    Expect(0, 73562, '\P{^Is_Indic_Syllabic_Category=number}', "");
    Expect(1, 73561, '\p{Is_Indic_Syllabic_Category=		Number}', "");
    Expect(0, 73561, '\p{^Is_Indic_Syllabic_Category=		Number}', "");
    Expect(0, 73561, '\P{Is_Indic_Syllabic_Category=		Number}', "");
    Expect(1, 73561, '\P{^Is_Indic_Syllabic_Category=		Number}', "");
    Expect(0, 73562, '\p{Is_Indic_Syllabic_Category=		Number}', "");
    Expect(1, 73562, '\p{^Is_Indic_Syllabic_Category=		Number}', "");
    Expect(1, 73562, '\P{Is_Indic_Syllabic_Category=		Number}', "");
    Expect(0, 73562, '\P{^Is_Indic_Syllabic_Category=		Number}', "");
    Error('\p{Is_InSC=__Number:=}');
    Error('\P{Is_InSC=__Number:=}');
    Expect(1, 73561, '\p{Is_InSC: number}', "");
    Expect(0, 73561, '\p{^Is_InSC: number}', "");
    Expect(0, 73561, '\P{Is_InSC: number}', "");
    Expect(1, 73561, '\P{^Is_InSC: number}', "");
    Expect(0, 73562, '\p{Is_InSC: number}', "");
    Expect(1, 73562, '\p{^Is_InSC: number}', "");
    Expect(1, 73562, '\P{Is_InSC: number}', "");
    Expect(0, 73562, '\P{^Is_InSC: number}', "");
    Expect(1, 73561, '\p{Is_InSC=	Number}', "");
    Expect(0, 73561, '\p{^Is_InSC=	Number}', "");
    Expect(0, 73561, '\P{Is_InSC=	Number}', "");
    Expect(1, 73561, '\P{^Is_InSC=	Number}', "");
    Expect(0, 73562, '\p{Is_InSC=	Number}', "");
    Expect(1, 73562, '\p{^Is_InSC=	Number}', "");
    Expect(1, 73562, '\P{Is_InSC=	Number}', "");
    Expect(0, 73562, '\P{^Is_InSC=	Number}', "");
    Error('\p{Indic_Syllabic_Category=-:=Number_JOINER}');
    Error('\P{Indic_Syllabic_Category=-:=Number_JOINER}');
    Expect(1, 69759, '\p{Indic_Syllabic_Category=:\ANumber_Joiner\z:}', "");;
    Expect(0, 69760, '\p{Indic_Syllabic_Category=:\ANumber_Joiner\z:}', "");;
    Expect(1, 69759, '\p{Indic_Syllabic_Category=numberjoiner}', "");
    Expect(0, 69759, '\p{^Indic_Syllabic_Category=numberjoiner}', "");
    Expect(0, 69759, '\P{Indic_Syllabic_Category=numberjoiner}', "");
    Expect(1, 69759, '\P{^Indic_Syllabic_Category=numberjoiner}', "");
    Expect(0, 69760, '\p{Indic_Syllabic_Category=numberjoiner}', "");
    Expect(1, 69760, '\p{^Indic_Syllabic_Category=numberjoiner}', "");
    Expect(1, 69760, '\P{Indic_Syllabic_Category=numberjoiner}', "");
    Expect(0, 69760, '\P{^Indic_Syllabic_Category=numberjoiner}', "");
    Expect(1, 69759, '\p{Indic_Syllabic_Category=:\Anumberjoiner\z:}', "");;
    Expect(0, 69760, '\p{Indic_Syllabic_Category=:\Anumberjoiner\z:}', "");;
    Expect(1, 69759, '\p{Indic_Syllabic_Category=-	Number_Joiner}', "");
    Expect(0, 69759, '\p{^Indic_Syllabic_Category=-	Number_Joiner}', "");
    Expect(0, 69759, '\P{Indic_Syllabic_Category=-	Number_Joiner}', "");
    Expect(1, 69759, '\P{^Indic_Syllabic_Category=-	Number_Joiner}', "");
    Expect(0, 69760, '\p{Indic_Syllabic_Category=-	Number_Joiner}', "");
    Expect(1, 69760, '\p{^Indic_Syllabic_Category=-	Number_Joiner}', "");
    Expect(1, 69760, '\P{Indic_Syllabic_Category=-	Number_Joiner}', "");
    Expect(0, 69760, '\P{^Indic_Syllabic_Category=-	Number_Joiner}', "");
    Error('\p{InSC=:= Number_Joiner}');
    Error('\P{InSC=:= Number_Joiner}');
    Expect(1, 69759, '\p{InSC=:\ANumber_Joiner\z:}', "");;
    Expect(0, 69760, '\p{InSC=:\ANumber_Joiner\z:}', "");;
    Expect(1, 69759, '\p{InSC=numberjoiner}', "");
    Expect(0, 69759, '\p{^InSC=numberjoiner}', "");
    Expect(0, 69759, '\P{InSC=numberjoiner}', "");
    Expect(1, 69759, '\P{^InSC=numberjoiner}', "");
    Expect(0, 69760, '\p{InSC=numberjoiner}', "");
    Expect(1, 69760, '\p{^InSC=numberjoiner}', "");
    Expect(1, 69760, '\P{InSC=numberjoiner}', "");
    Expect(0, 69760, '\P{^InSC=numberjoiner}', "");
    Expect(1, 69759, '\p{InSC=:\Anumberjoiner\z:}', "");;
    Expect(0, 69760, '\p{InSC=:\Anumberjoiner\z:}', "");;
    Expect(1, 69759, '\p{InSC=_	NUMBER_Joiner}', "");
    Expect(0, 69759, '\p{^InSC=_	NUMBER_Joiner}', "");
    Expect(0, 69759, '\P{InSC=_	NUMBER_Joiner}', "");
    Expect(1, 69759, '\P{^InSC=_	NUMBER_Joiner}', "");
    Expect(0, 69760, '\p{InSC=_	NUMBER_Joiner}', "");
    Expect(1, 69760, '\p{^InSC=_	NUMBER_Joiner}', "");
    Expect(1, 69760, '\P{InSC=_	NUMBER_Joiner}', "");
    Expect(0, 69760, '\P{^InSC=_	NUMBER_Joiner}', "");
    Error('\p{Is_Indic_Syllabic_Category=	_NUMBER_JOINER/a/}');
    Error('\P{Is_Indic_Syllabic_Category=	_NUMBER_JOINER/a/}');
    Expect(1, 69759, '\p{Is_Indic_Syllabic_Category=numberjoiner}', "");
    Expect(0, 69759, '\p{^Is_Indic_Syllabic_Category=numberjoiner}', "");
    Expect(0, 69759, '\P{Is_Indic_Syllabic_Category=numberjoiner}', "");
    Expect(1, 69759, '\P{^Is_Indic_Syllabic_Category=numberjoiner}', "");
    Expect(0, 69760, '\p{Is_Indic_Syllabic_Category=numberjoiner}', "");
    Expect(1, 69760, '\p{^Is_Indic_Syllabic_Category=numberjoiner}', "");
    Expect(1, 69760, '\P{Is_Indic_Syllabic_Category=numberjoiner}', "");
    Expect(0, 69760, '\P{^Is_Indic_Syllabic_Category=numberjoiner}', "");
    Expect(1, 69759, '\p{Is_Indic_Syllabic_Category=_NUMBER_JOINER}', "");
    Expect(0, 69759, '\p{^Is_Indic_Syllabic_Category=_NUMBER_JOINER}', "");
    Expect(0, 69759, '\P{Is_Indic_Syllabic_Category=_NUMBER_JOINER}', "");
    Expect(1, 69759, '\P{^Is_Indic_Syllabic_Category=_NUMBER_JOINER}', "");
    Expect(0, 69760, '\p{Is_Indic_Syllabic_Category=_NUMBER_JOINER}', "");
    Expect(1, 69760, '\p{^Is_Indic_Syllabic_Category=_NUMBER_JOINER}', "");
    Expect(1, 69760, '\P{Is_Indic_Syllabic_Category=_NUMBER_JOINER}', "");
    Expect(0, 69760, '\P{^Is_Indic_Syllabic_Category=_NUMBER_JOINER}', "");
    Error('\p{Is_InSC=:=Number_JOINER}');
    Error('\P{Is_InSC=:=Number_JOINER}');
    Expect(1, 69759, '\p{Is_InSC=numberjoiner}', "");
    Expect(0, 69759, '\p{^Is_InSC=numberjoiner}', "");
    Expect(0, 69759, '\P{Is_InSC=numberjoiner}', "");
    Expect(1, 69759, '\P{^Is_InSC=numberjoiner}', "");
    Expect(0, 69760, '\p{Is_InSC=numberjoiner}', "");
    Expect(1, 69760, '\p{^Is_InSC=numberjoiner}', "");
    Expect(1, 69760, '\P{Is_InSC=numberjoiner}', "");
    Expect(0, 69760, '\P{^Is_InSC=numberjoiner}', "");
    Expect(1, 69759, '\p{Is_InSC=	 NUMBER_JOINER}', "");
    Expect(0, 69759, '\p{^Is_InSC=	 NUMBER_JOINER}', "");
    Expect(0, 69759, '\P{Is_InSC=	 NUMBER_JOINER}', "");
    Expect(1, 69759, '\P{^Is_InSC=	 NUMBER_JOINER}', "");
    Expect(0, 69760, '\p{Is_InSC=	 NUMBER_JOINER}', "");
    Expect(1, 69760, '\p{^Is_InSC=	 NUMBER_JOINER}', "");
    Expect(1, 69760, '\P{Is_InSC=	 NUMBER_JOINER}', "");
    Expect(0, 69760, '\P{^Is_InSC=	 NUMBER_JOINER}', "");
    Error('\p{Indic_Syllabic_Category=:=-	other}');
    Error('\P{Indic_Syllabic_Category=:=-	other}');
    Expect(1, 73562, '\p{Indic_Syllabic_Category=:\AOther\z:}', "");;
    Expect(0, 73561, '\p{Indic_Syllabic_Category=:\AOther\z:}', "");;
    Expect(1, 73562, '\p{Indic_Syllabic_Category=other}', "");
    Expect(0, 73562, '\p{^Indic_Syllabic_Category=other}', "");
    Expect(0, 73562, '\P{Indic_Syllabic_Category=other}', "");
    Expect(1, 73562, '\P{^Indic_Syllabic_Category=other}', "");
    Expect(0, 73561, '\p{Indic_Syllabic_Category=other}', "");
    Expect(1, 73561, '\p{^Indic_Syllabic_Category=other}', "");
    Expect(1, 73561, '\P{Indic_Syllabic_Category=other}', "");
    Expect(0, 73561, '\P{^Indic_Syllabic_Category=other}', "");
    Expect(1, 73562, '\p{Indic_Syllabic_Category=:\Aother\z:}', "");;
    Expect(0, 73561, '\p{Indic_Syllabic_Category=:\Aother\z:}', "");;
    Expect(1, 73562, '\p{Indic_Syllabic_Category: 	Other}', "");
    Expect(0, 73562, '\p{^Indic_Syllabic_Category: 	Other}', "");
    Expect(0, 73562, '\P{Indic_Syllabic_Category: 	Other}', "");
    Expect(1, 73562, '\P{^Indic_Syllabic_Category: 	Other}', "");
    Expect(0, 73561, '\p{Indic_Syllabic_Category: 	Other}', "");
    Expect(1, 73561, '\p{^Indic_Syllabic_Category: 	Other}', "");
    Expect(1, 73561, '\P{Indic_Syllabic_Category: 	Other}', "");
    Expect(0, 73561, '\P{^Indic_Syllabic_Category: 	Other}', "");
    Error('\p{InSC=/a/other}');
    Error('\P{InSC=/a/other}');
    Expect(1, 73562, '\p{InSC=:\AOther\z:}', "");;
    Expect(0, 73561, '\p{InSC=:\AOther\z:}', "");;
    Expect(1, 73562, '\p{InSC=other}', "");
    Expect(0, 73562, '\p{^InSC=other}', "");
    Expect(0, 73562, '\P{InSC=other}', "");
    Expect(1, 73562, '\P{^InSC=other}', "");
    Expect(0, 73561, '\p{InSC=other}', "");
    Expect(1, 73561, '\p{^InSC=other}', "");
    Expect(1, 73561, '\P{InSC=other}', "");
    Expect(0, 73561, '\P{^InSC=other}', "");
    Expect(1, 73562, '\p{InSC=:\Aother\z:}', "");;
    Expect(0, 73561, '\p{InSC=:\Aother\z:}', "");;
    Expect(1, 73562, '\p{InSC=	_OTHER}', "");
    Expect(0, 73562, '\p{^InSC=	_OTHER}', "");
    Expect(0, 73562, '\P{InSC=	_OTHER}', "");
    Expect(1, 73562, '\P{^InSC=	_OTHER}', "");
    Expect(0, 73561, '\p{InSC=	_OTHER}', "");
    Expect(1, 73561, '\p{^InSC=	_OTHER}', "");
    Expect(1, 73561, '\P{InSC=	_OTHER}', "");
    Expect(0, 73561, '\P{^InSC=	_OTHER}', "");
    Error('\p{Is_Indic_Syllabic_Category=_/a/OTHER}');
    Error('\P{Is_Indic_Syllabic_Category=_/a/OTHER}');
    Expect(1, 73562, '\p{Is_Indic_Syllabic_Category=other}', "");
    Expect(0, 73562, '\p{^Is_Indic_Syllabic_Category=other}', "");
    Expect(0, 73562, '\P{Is_Indic_Syllabic_Category=other}', "");
    Expect(1, 73562, '\P{^Is_Indic_Syllabic_Category=other}', "");
    Expect(0, 73561, '\p{Is_Indic_Syllabic_Category=other}', "");
    Expect(1, 73561, '\p{^Is_Indic_Syllabic_Category=other}', "");
    Expect(1, 73561, '\P{Is_Indic_Syllabic_Category=other}', "");
    Expect(0, 73561, '\P{^Is_Indic_Syllabic_Category=other}', "");
    Expect(1, 73562, '\p{Is_Indic_Syllabic_Category= Other}', "");
    Expect(0, 73562, '\p{^Is_Indic_Syllabic_Category= Other}', "");
    Expect(0, 73562, '\P{Is_Indic_Syllabic_Category= Other}', "");
    Expect(1, 73562, '\P{^Is_Indic_Syllabic_Category= Other}', "");
    Expect(0, 73561, '\p{Is_Indic_Syllabic_Category= Other}', "");
    Expect(1, 73561, '\p{^Is_Indic_Syllabic_Category= Other}', "");
    Expect(1, 73561, '\P{Is_Indic_Syllabic_Category= Other}', "");
    Expect(0, 73561, '\P{^Is_Indic_Syllabic_Category= Other}', "");
    Error('\p{Is_InSC= _OTHER:=}');
    Error('\P{Is_InSC= _OTHER:=}');
    Expect(1, 73562, '\p{Is_InSC=other}', "");
    Expect(0, 73562, '\p{^Is_InSC=other}', "");
    Expect(0, 73562, '\P{Is_InSC=other}', "");
    Expect(1, 73562, '\P{^Is_InSC=other}', "");
    Expect(0, 73561, '\p{Is_InSC=other}', "");
    Expect(1, 73561, '\p{^Is_InSC=other}', "");
    Expect(1, 73561, '\P{Is_InSC=other}', "");
    Expect(0, 73561, '\P{^Is_InSC=other}', "");
    Expect(1, 73562, '\p{Is_InSC=-	other}', "");
    Expect(0, 73562, '\p{^Is_InSC=-	other}', "");
    Expect(0, 73562, '\P{Is_InSC=-	other}', "");
    Expect(1, 73562, '\P{^Is_InSC=-	other}', "");
    Expect(0, 73561, '\p{Is_InSC=-	other}', "");
    Expect(1, 73561, '\p{^Is_InSC=-	other}', "");
    Expect(1, 73561, '\P{Is_InSC=-	other}', "");
    Expect(0, 73561, '\P{^Is_InSC=-	other}', "");
    Error('\p{Indic_Syllabic_Category= _pure_killer/a/}');
    Error('\P{Indic_Syllabic_Category= _pure_killer/a/}');
    Expect(1, 73537, '\p{Indic_Syllabic_Category=:\APure_Killer\z:}', "");;
    Expect(0, 73538, '\p{Indic_Syllabic_Category=:\APure_Killer\z:}', "");;
    Expect(1, 73537, '\p{Indic_Syllabic_Category:	purekiller}', "");
    Expect(0, 73537, '\p{^Indic_Syllabic_Category:	purekiller}', "");
    Expect(0, 73537, '\P{Indic_Syllabic_Category:	purekiller}', "");
    Expect(1, 73537, '\P{^Indic_Syllabic_Category:	purekiller}', "");
    Expect(0, 73538, '\p{Indic_Syllabic_Category:	purekiller}', "");
    Expect(1, 73538, '\p{^Indic_Syllabic_Category:	purekiller}', "");
    Expect(1, 73538, '\P{Indic_Syllabic_Category:	purekiller}', "");
    Expect(0, 73538, '\P{^Indic_Syllabic_Category:	purekiller}', "");
    Expect(1, 73537, '\p{Indic_Syllabic_Category=:\Apurekiller\z:}', "");;
    Expect(0, 73538, '\p{Indic_Syllabic_Category=:\Apurekiller\z:}', "");;
    Expect(1, 73537, '\p{Indic_Syllabic_Category=	_pure_KILLER}', "");
    Expect(0, 73537, '\p{^Indic_Syllabic_Category=	_pure_KILLER}', "");
    Expect(0, 73537, '\P{Indic_Syllabic_Category=	_pure_KILLER}', "");
    Expect(1, 73537, '\P{^Indic_Syllabic_Category=	_pure_KILLER}', "");
    Expect(0, 73538, '\p{Indic_Syllabic_Category=	_pure_KILLER}', "");
    Expect(1, 73538, '\p{^Indic_Syllabic_Category=	_pure_KILLER}', "");
    Expect(1, 73538, '\P{Indic_Syllabic_Category=	_pure_KILLER}', "");
    Expect(0, 73538, '\P{^Indic_Syllabic_Category=	_pure_KILLER}', "");
    Error('\p{InSC=_/a/pure_killer}');
    Error('\P{InSC=_/a/pure_killer}');
    Expect(1, 73537, '\p{InSC=:\APure_Killer\z:}', "");;
    Expect(0, 73538, '\p{InSC=:\APure_Killer\z:}', "");;
    Expect(1, 73537, '\p{InSC=purekiller}', "");
    Expect(0, 73537, '\p{^InSC=purekiller}', "");
    Expect(0, 73537, '\P{InSC=purekiller}', "");
    Expect(1, 73537, '\P{^InSC=purekiller}', "");
    Expect(0, 73538, '\p{InSC=purekiller}', "");
    Expect(1, 73538, '\p{^InSC=purekiller}', "");
    Expect(1, 73538, '\P{InSC=purekiller}', "");
    Expect(0, 73538, '\P{^InSC=purekiller}', "");
    Expect(1, 73537, '\p{InSC=:\Apurekiller\z:}', "");;
    Expect(0, 73538, '\p{InSC=:\Apurekiller\z:}', "");;
    Expect(1, 73537, '\p{InSC=-Pure_Killer}', "");
    Expect(0, 73537, '\p{^InSC=-Pure_Killer}', "");
    Expect(0, 73537, '\P{InSC=-Pure_Killer}', "");
    Expect(1, 73537, '\P{^InSC=-Pure_Killer}', "");
    Expect(0, 73538, '\p{InSC=-Pure_Killer}', "");
    Expect(1, 73538, '\p{^InSC=-Pure_Killer}', "");
    Expect(1, 73538, '\P{InSC=-Pure_Killer}', "");
    Expect(0, 73538, '\P{^InSC=-Pure_Killer}', "");
    Error('\p{Is_Indic_Syllabic_Category=  Pure_KILLER/a/}');
    Error('\P{Is_Indic_Syllabic_Category=  Pure_KILLER/a/}');
    Expect(1, 73537, '\p{Is_Indic_Syllabic_Category=purekiller}', "");
    Expect(0, 73537, '\p{^Is_Indic_Syllabic_Category=purekiller}', "");
    Expect(0, 73537, '\P{Is_Indic_Syllabic_Category=purekiller}', "");
    Expect(1, 73537, '\P{^Is_Indic_Syllabic_Category=purekiller}', "");
    Expect(0, 73538, '\p{Is_Indic_Syllabic_Category=purekiller}', "");
    Expect(1, 73538, '\p{^Is_Indic_Syllabic_Category=purekiller}', "");
    Expect(1, 73538, '\P{Is_Indic_Syllabic_Category=purekiller}', "");
    Expect(0, 73538, '\P{^Is_Indic_Syllabic_Category=purekiller}', "");
    Expect(1, 73537, '\p{Is_Indic_Syllabic_Category=-	pure_Killer}', "");
    Expect(0, 73537, '\p{^Is_Indic_Syllabic_Category=-	pure_Killer}', "");
    Expect(0, 73537, '\P{Is_Indic_Syllabic_Category=-	pure_Killer}', "");
    Expect(1, 73537, '\P{^Is_Indic_Syllabic_Category=-	pure_Killer}', "");
    Expect(0, 73538, '\p{Is_Indic_Syllabic_Category=-	pure_Killer}', "");
    Expect(1, 73538, '\p{^Is_Indic_Syllabic_Category=-	pure_Killer}', "");
    Expect(1, 73538, '\P{Is_Indic_Syllabic_Category=-	pure_Killer}', "");
    Expect(0, 73538, '\P{^Is_Indic_Syllabic_Category=-	pure_Killer}', "");
    Error('\p{Is_InSC=:=_Pure_Killer}');
    Error('\P{Is_InSC=:=_Pure_Killer}');
    Expect(1, 73537, '\p{Is_InSC=purekiller}', "");
    Expect(0, 73537, '\p{^Is_InSC=purekiller}', "");
    Expect(0, 73537, '\P{Is_InSC=purekiller}', "");
    Expect(1, 73537, '\P{^Is_InSC=purekiller}', "");
    Expect(0, 73538, '\p{Is_InSC=purekiller}', "");
    Expect(1, 73538, '\p{^Is_InSC=purekiller}', "");
    Expect(1, 73538, '\P{Is_InSC=purekiller}', "");
    Expect(0, 73538, '\P{^Is_InSC=purekiller}', "");
    Expect(1, 73537, '\p{Is_InSC=--pure_killer}', "");
    Expect(0, 73537, '\p{^Is_InSC=--pure_killer}', "");
    Expect(0, 73537, '\P{Is_InSC=--pure_killer}', "");
    Expect(1, 73537, '\P{^Is_InSC=--pure_killer}', "");
    Expect(0, 73538, '\p{Is_InSC=--pure_killer}', "");
    Expect(1, 73538, '\p{^Is_InSC=--pure_killer}', "");
    Expect(1, 73538, '\P{Is_InSC=--pure_killer}', "");
    Expect(0, 73538, '\P{^Is_InSC=--pure_killer}', "");
    Error('\p{Indic_Syllabic_Category= /a/REGISTER_shifter}');
    Error('\P{Indic_Syllabic_Category= /a/REGISTER_shifter}');
    Expect(1, 6090, '\p{Indic_Syllabic_Category=:\ARegister_Shifter\z:}', "");;
    Expect(0, 6091, '\p{Indic_Syllabic_Category=:\ARegister_Shifter\z:}', "");;
    Expect(1, 6090, '\p{Indic_Syllabic_Category=registershifter}', "");
    Expect(0, 6090, '\p{^Indic_Syllabic_Category=registershifter}', "");
    Expect(0, 6090, '\P{Indic_Syllabic_Category=registershifter}', "");
    Expect(1, 6090, '\P{^Indic_Syllabic_Category=registershifter}', "");
    Expect(0, 6091, '\p{Indic_Syllabic_Category=registershifter}', "");
    Expect(1, 6091, '\p{^Indic_Syllabic_Category=registershifter}', "");
    Expect(1, 6091, '\P{Indic_Syllabic_Category=registershifter}', "");
    Expect(0, 6091, '\P{^Indic_Syllabic_Category=registershifter}', "");
    Expect(1, 6090, '\p{Indic_Syllabic_Category=:\Aregistershifter\z:}', "");;
    Expect(0, 6091, '\p{Indic_Syllabic_Category=:\Aregistershifter\z:}', "");;
    Expect(1, 6090, '\p{Indic_Syllabic_Category:    Register_shifter}', "");
    Expect(0, 6090, '\p{^Indic_Syllabic_Category:    Register_shifter}', "");
    Expect(0, 6090, '\P{Indic_Syllabic_Category:    Register_shifter}', "");
    Expect(1, 6090, '\P{^Indic_Syllabic_Category:    Register_shifter}', "");
    Expect(0, 6091, '\p{Indic_Syllabic_Category:    Register_shifter}', "");
    Expect(1, 6091, '\p{^Indic_Syllabic_Category:    Register_shifter}', "");
    Expect(1, 6091, '\P{Indic_Syllabic_Category:    Register_shifter}', "");
    Expect(0, 6091, '\P{^Indic_Syllabic_Category:    Register_shifter}', "");
    Error('\p{InSC=	_Register_Shifter/a/}');
    Error('\P{InSC=	_Register_Shifter/a/}');
    Expect(1, 6090, '\p{InSC=:\ARegister_Shifter\z:}', "");;
    Expect(0, 6091, '\p{InSC=:\ARegister_Shifter\z:}', "");;
    Expect(1, 6090, '\p{InSC=registershifter}', "");
    Expect(0, 6090, '\p{^InSC=registershifter}', "");
    Expect(0, 6090, '\P{InSC=registershifter}', "");
    Expect(1, 6090, '\P{^InSC=registershifter}', "");
    Expect(0, 6091, '\p{InSC=registershifter}', "");
    Expect(1, 6091, '\p{^InSC=registershifter}', "");
    Expect(1, 6091, '\P{InSC=registershifter}', "");
    Expect(0, 6091, '\P{^InSC=registershifter}', "");
    Expect(1, 6090, '\p{InSC=:\Aregistershifter\z:}', "");;
    Expect(0, 6091, '\p{InSC=:\Aregistershifter\z:}', "");;
    Expect(1, 6090, '\p{InSC= _Register_shifter}', "");
    Expect(0, 6090, '\p{^InSC= _Register_shifter}', "");
    Expect(0, 6090, '\P{InSC= _Register_shifter}', "");
    Expect(1, 6090, '\P{^InSC= _Register_shifter}', "");
    Expect(0, 6091, '\p{InSC= _Register_shifter}', "");
    Expect(1, 6091, '\p{^InSC= _Register_shifter}', "");
    Expect(1, 6091, '\P{InSC= _Register_shifter}', "");
    Expect(0, 6091, '\P{^InSC= _Register_shifter}', "");
    Error('\p{Is_Indic_Syllabic_Category=:=Register_Shifter}');
    Error('\P{Is_Indic_Syllabic_Category=:=Register_Shifter}');
    Expect(1, 6090, '\p{Is_Indic_Syllabic_Category=registershifter}', "");
    Expect(0, 6090, '\p{^Is_Indic_Syllabic_Category=registershifter}', "");
    Expect(0, 6090, '\P{Is_Indic_Syllabic_Category=registershifter}', "");
    Expect(1, 6090, '\P{^Is_Indic_Syllabic_Category=registershifter}', "");
    Expect(0, 6091, '\p{Is_Indic_Syllabic_Category=registershifter}', "");
    Expect(1, 6091, '\p{^Is_Indic_Syllabic_Category=registershifter}', "");
    Expect(1, 6091, '\P{Is_Indic_Syllabic_Category=registershifter}', "");
    Expect(0, 6091, '\P{^Is_Indic_Syllabic_Category=registershifter}', "");
    Expect(1, 6090, '\p{Is_Indic_Syllabic_Category=	REGISTER_SHIFTER}', "");
    Expect(0, 6090, '\p{^Is_Indic_Syllabic_Category=	REGISTER_SHIFTER}', "");
    Expect(0, 6090, '\P{Is_Indic_Syllabic_Category=	REGISTER_SHIFTER}', "");
    Expect(1, 6090, '\P{^Is_Indic_Syllabic_Category=	REGISTER_SHIFTER}', "");
    Expect(0, 6091, '\p{Is_Indic_Syllabic_Category=	REGISTER_SHIFTER}', "");
    Expect(1, 6091, '\p{^Is_Indic_Syllabic_Category=	REGISTER_SHIFTER}', "");
    Expect(1, 6091, '\P{Is_Indic_Syllabic_Category=	REGISTER_SHIFTER}', "");
    Expect(0, 6091, '\P{^Is_Indic_Syllabic_Category=	REGISTER_SHIFTER}', "");
    Error('\p{Is_InSC=	_Register_shifter:=}');
    Error('\P{Is_InSC=	_Register_shifter:=}');
    Expect(1, 6090, '\p{Is_InSC=registershifter}', "");
    Expect(0, 6090, '\p{^Is_InSC=registershifter}', "");
    Expect(0, 6090, '\P{Is_InSC=registershifter}', "");
    Expect(1, 6090, '\P{^Is_InSC=registershifter}', "");
    Expect(0, 6091, '\p{Is_InSC=registershifter}', "");
    Expect(1, 6091, '\p{^Is_InSC=registershifter}', "");
    Expect(1, 6091, '\P{Is_InSC=registershifter}', "");
    Expect(0, 6091, '\P{^Is_InSC=registershifter}', "");
    Expect(1, 6090, '\p{Is_InSC:    Register_Shifter}', "");
    Expect(0, 6090, '\p{^Is_InSC:    Register_Shifter}', "");
    Expect(0, 6090, '\P{Is_InSC:    Register_Shifter}', "");
    Expect(1, 6090, '\P{^Is_InSC:    Register_Shifter}', "");
    Expect(0, 6091, '\p{Is_InSC:    Register_Shifter}', "");
    Expect(1, 6091, '\p{^Is_InSC:    Register_Shifter}', "");
    Expect(1, 6091, '\P{Is_InSC:    Register_Shifter}', "");
    Expect(0, 6091, '\P{^Is_InSC:    Register_Shifter}', "");
    Error('\p{Indic_Syllabic_Category=/a/--syllable_MODIFIER}');
    Error('\P{Indic_Syllabic_Category=/a/--syllable_MODIFIER}');
    Expect(1, 72243, '\p{Indic_Syllabic_Category=:\ASyllable_Modifier\z:}', "");;
    Expect(0, 72244, '\p{Indic_Syllabic_Category=:\ASyllable_Modifier\z:}', "");;
    Expect(1, 72243, '\p{Indic_Syllabic_Category=syllablemodifier}', "");
    Expect(0, 72243, '\p{^Indic_Syllabic_Category=syllablemodifier}', "");
    Expect(0, 72243, '\P{Indic_Syllabic_Category=syllablemodifier}', "");
    Expect(1, 72243, '\P{^Indic_Syllabic_Category=syllablemodifier}', "");
    Expect(0, 72244, '\p{Indic_Syllabic_Category=syllablemodifier}', "");
    Expect(1, 72244, '\p{^Indic_Syllabic_Category=syllablemodifier}', "");
    Expect(1, 72244, '\P{Indic_Syllabic_Category=syllablemodifier}', "");
    Expect(0, 72244, '\P{^Indic_Syllabic_Category=syllablemodifier}', "");
    Expect(1, 72243, '\p{Indic_Syllabic_Category=:\Asyllablemodifier\z:}', "");;
    Expect(0, 72244, '\p{Indic_Syllabic_Category=:\Asyllablemodifier\z:}', "");;
    Expect(1, 72243, '\p{Indic_Syllabic_Category=		Syllable_Modifier}', "");
    Expect(0, 72243, '\p{^Indic_Syllabic_Category=		Syllable_Modifier}', "");
    Expect(0, 72243, '\P{Indic_Syllabic_Category=		Syllable_Modifier}', "");
    Expect(1, 72243, '\P{^Indic_Syllabic_Category=		Syllable_Modifier}', "");
    Expect(0, 72244, '\p{Indic_Syllabic_Category=		Syllable_Modifier}', "");
    Expect(1, 72244, '\p{^Indic_Syllabic_Category=		Syllable_Modifier}', "");
    Expect(1, 72244, '\P{Indic_Syllabic_Category=		Syllable_Modifier}', "");
    Expect(0, 72244, '\P{^Indic_Syllabic_Category=		Syllable_Modifier}', "");
    Error('\p{InSC=/a/ Syllable_MODIFIER}');
    Error('\P{InSC=/a/ Syllable_MODIFIER}');
    Expect(1, 72243, '\p{InSC=:\ASyllable_Modifier\z:}', "");;
    Expect(0, 72244, '\p{InSC=:\ASyllable_Modifier\z:}', "");;
    Expect(1, 72243, '\p{InSC=syllablemodifier}', "");
    Expect(0, 72243, '\p{^InSC=syllablemodifier}', "");
    Expect(0, 72243, '\P{InSC=syllablemodifier}', "");
    Expect(1, 72243, '\P{^InSC=syllablemodifier}', "");
    Expect(0, 72244, '\p{InSC=syllablemodifier}', "");
    Expect(1, 72244, '\p{^InSC=syllablemodifier}', "");
    Expect(1, 72244, '\P{InSC=syllablemodifier}', "");
    Expect(0, 72244, '\P{^InSC=syllablemodifier}', "");
    Expect(1, 72243, '\p{InSC=:\Asyllablemodifier\z:}', "");;
    Expect(0, 72244, '\p{InSC=:\Asyllablemodifier\z:}', "");;
    Expect(1, 72243, '\p{InSC=  SYLLABLE_MODIFIER}', "");
    Expect(0, 72243, '\p{^InSC=  SYLLABLE_MODIFIER}', "");
    Expect(0, 72243, '\P{InSC=  SYLLABLE_MODIFIER}', "");
    Expect(1, 72243, '\P{^InSC=  SYLLABLE_MODIFIER}', "");
    Expect(0, 72244, '\p{InSC=  SYLLABLE_MODIFIER}', "");
    Expect(1, 72244, '\p{^InSC=  SYLLABLE_MODIFIER}', "");
    Expect(1, 72244, '\P{InSC=  SYLLABLE_MODIFIER}', "");
    Expect(0, 72244, '\P{^InSC=  SYLLABLE_MODIFIER}', "");
    Error('\p{Is_Indic_Syllabic_Category=_:=SYLLABLE_modifier}');
    Error('\P{Is_Indic_Syllabic_Category=_:=SYLLABLE_modifier}');
    Expect(1, 72243, '\p{Is_Indic_Syllabic_Category=syllablemodifier}', "");
    Expect(0, 72243, '\p{^Is_Indic_Syllabic_Category=syllablemodifier}', "");
    Expect(0, 72243, '\P{Is_Indic_Syllabic_Category=syllablemodifier}', "");
    Expect(1, 72243, '\P{^Is_Indic_Syllabic_Category=syllablemodifier}', "");
    Expect(0, 72244, '\p{Is_Indic_Syllabic_Category=syllablemodifier}', "");
    Expect(1, 72244, '\p{^Is_Indic_Syllabic_Category=syllablemodifier}', "");
    Expect(1, 72244, '\P{Is_Indic_Syllabic_Category=syllablemodifier}', "");
    Expect(0, 72244, '\P{^Is_Indic_Syllabic_Category=syllablemodifier}', "");
    Expect(1, 72243, '\p{Is_Indic_Syllabic_Category= Syllable_modifier}', "");
    Expect(0, 72243, '\p{^Is_Indic_Syllabic_Category= Syllable_modifier}', "");
    Expect(0, 72243, '\P{Is_Indic_Syllabic_Category= Syllable_modifier}', "");
    Expect(1, 72243, '\P{^Is_Indic_Syllabic_Category= Syllable_modifier}', "");
    Expect(0, 72244, '\p{Is_Indic_Syllabic_Category= Syllable_modifier}', "");
    Expect(1, 72244, '\p{^Is_Indic_Syllabic_Category= Syllable_modifier}', "");
    Expect(1, 72244, '\P{Is_Indic_Syllabic_Category= Syllable_modifier}', "");
    Expect(0, 72244, '\P{^Is_Indic_Syllabic_Category= Syllable_modifier}', "");
    Error('\p{Is_InSC:	__syllable_Modifier/a/}');
    Error('\P{Is_InSC:	__syllable_Modifier/a/}');
    Expect(1, 72243, '\p{Is_InSC=syllablemodifier}', "");
    Expect(0, 72243, '\p{^Is_InSC=syllablemodifier}', "");
    Expect(0, 72243, '\P{Is_InSC=syllablemodifier}', "");
    Expect(1, 72243, '\P{^Is_InSC=syllablemodifier}', "");
    Expect(0, 72244, '\p{Is_InSC=syllablemodifier}', "");
    Expect(1, 72244, '\p{^Is_InSC=syllablemodifier}', "");
    Expect(1, 72244, '\P{Is_InSC=syllablemodifier}', "");
    Expect(0, 72244, '\P{^Is_InSC=syllablemodifier}', "");
    Expect(1, 72243, '\p{Is_InSC=-	SYLLABLE_Modifier}', "");
    Expect(0, 72243, '\p{^Is_InSC=-	SYLLABLE_Modifier}', "");
    Expect(0, 72243, '\P{Is_InSC=-	SYLLABLE_Modifier}', "");
    Expect(1, 72243, '\P{^Is_InSC=-	SYLLABLE_Modifier}', "");
    Expect(0, 72244, '\p{Is_InSC=-	SYLLABLE_Modifier}', "");
    Expect(1, 72244, '\p{^Is_InSC=-	SYLLABLE_Modifier}', "");
    Expect(1, 72244, '\P{Is_InSC=-	SYLLABLE_Modifier}', "");
    Expect(0, 72244, '\P{^Is_InSC=-	SYLLABLE_Modifier}', "");
    Error('\p{Indic_Syllabic_Category= TONE_Letter/a/}');
    Error('\P{Indic_Syllabic_Category= TONE_Letter/a/}');
    Expect(1, 43714, '\p{Indic_Syllabic_Category=:\ATone_Letter\z:}', "");;
    Expect(0, 43715, '\p{Indic_Syllabic_Category=:\ATone_Letter\z:}', "");;
    Expect(1, 43714, '\p{Indic_Syllabic_Category=toneletter}', "");
    Expect(0, 43714, '\p{^Indic_Syllabic_Category=toneletter}', "");
    Expect(0, 43714, '\P{Indic_Syllabic_Category=toneletter}', "");
    Expect(1, 43714, '\P{^Indic_Syllabic_Category=toneletter}', "");
    Expect(0, 43715, '\p{Indic_Syllabic_Category=toneletter}', "");
    Expect(1, 43715, '\p{^Indic_Syllabic_Category=toneletter}', "");
    Expect(1, 43715, '\P{Indic_Syllabic_Category=toneletter}', "");
    Expect(0, 43715, '\P{^Indic_Syllabic_Category=toneletter}', "");
    Expect(1, 43714, '\p{Indic_Syllabic_Category=:\Atoneletter\z:}', "");;
    Expect(0, 43715, '\p{Indic_Syllabic_Category=:\Atoneletter\z:}', "");;
    Expect(1, 43714, '\p{Indic_Syllabic_Category=- Tone_LETTER}', "");
    Expect(0, 43714, '\p{^Indic_Syllabic_Category=- Tone_LETTER}', "");
    Expect(0, 43714, '\P{Indic_Syllabic_Category=- Tone_LETTER}', "");
    Expect(1, 43714, '\P{^Indic_Syllabic_Category=- Tone_LETTER}', "");
    Expect(0, 43715, '\p{Indic_Syllabic_Category=- Tone_LETTER}', "");
    Expect(1, 43715, '\p{^Indic_Syllabic_Category=- Tone_LETTER}', "");
    Expect(1, 43715, '\P{Indic_Syllabic_Category=- Tone_LETTER}', "");
    Expect(0, 43715, '\P{^Indic_Syllabic_Category=- Tone_LETTER}', "");
    Error('\p{InSC:/a/ tone_LETTER}');
    Error('\P{InSC:/a/ tone_LETTER}');
    Expect(1, 43714, '\p{InSC=:\ATone_Letter\z:}', "");;
    Expect(0, 43715, '\p{InSC=:\ATone_Letter\z:}', "");;
    Expect(1, 43714, '\p{InSC=toneletter}', "");
    Expect(0, 43714, '\p{^InSC=toneletter}', "");
    Expect(0, 43714, '\P{InSC=toneletter}', "");
    Expect(1, 43714, '\P{^InSC=toneletter}', "");
    Expect(0, 43715, '\p{InSC=toneletter}', "");
    Expect(1, 43715, '\p{^InSC=toneletter}', "");
    Expect(1, 43715, '\P{InSC=toneletter}', "");
    Expect(0, 43715, '\P{^InSC=toneletter}', "");
    Expect(1, 43714, '\p{InSC=:\Atoneletter\z:}', "");;
    Expect(0, 43715, '\p{InSC=:\Atoneletter\z:}', "");;
    Expect(1, 43714, '\p{InSC=	 Tone_letter}', "");
    Expect(0, 43714, '\p{^InSC=	 Tone_letter}', "");
    Expect(0, 43714, '\P{InSC=	 Tone_letter}', "");
    Expect(1, 43714, '\P{^InSC=	 Tone_letter}', "");
    Expect(0, 43715, '\p{InSC=	 Tone_letter}', "");
    Expect(1, 43715, '\p{^InSC=	 Tone_letter}', "");
    Expect(1, 43715, '\P{InSC=	 Tone_letter}', "");
    Expect(0, 43715, '\P{^InSC=	 Tone_letter}', "");
    Error('\p{Is_Indic_Syllabic_Category=/a/Tone_Letter}');
    Error('\P{Is_Indic_Syllabic_Category=/a/Tone_Letter}');
    Expect(1, 43714, '\p{Is_Indic_Syllabic_Category:toneletter}', "");
    Expect(0, 43714, '\p{^Is_Indic_Syllabic_Category:toneletter}', "");
    Expect(0, 43714, '\P{Is_Indic_Syllabic_Category:toneletter}', "");
    Expect(1, 43714, '\P{^Is_Indic_Syllabic_Category:toneletter}', "");
    Expect(0, 43715, '\p{Is_Indic_Syllabic_Category:toneletter}', "");
    Expect(1, 43715, '\p{^Is_Indic_Syllabic_Category:toneletter}', "");
    Expect(1, 43715, '\P{Is_Indic_Syllabic_Category:toneletter}', "");
    Expect(0, 43715, '\P{^Is_Indic_Syllabic_Category:toneletter}', "");
    Expect(1, 43714, '\p{Is_Indic_Syllabic_Category=	 tone_letter}', "");
    Expect(0, 43714, '\p{^Is_Indic_Syllabic_Category=	 tone_letter}', "");
    Expect(0, 43714, '\P{Is_Indic_Syllabic_Category=	 tone_letter}', "");
    Expect(1, 43714, '\P{^Is_Indic_Syllabic_Category=	 tone_letter}', "");
    Expect(0, 43715, '\p{Is_Indic_Syllabic_Category=	 tone_letter}', "");
    Expect(1, 43715, '\p{^Is_Indic_Syllabic_Category=	 tone_letter}', "");
    Expect(1, 43715, '\P{Is_Indic_Syllabic_Category=	 tone_letter}', "");
    Expect(0, 43715, '\P{^Is_Indic_Syllabic_Category=	 tone_letter}', "");
    Error('\p{Is_InSC=__Tone_letter:=}');
    Error('\P{Is_InSC=__Tone_letter:=}');
    Expect(1, 43714, '\p{Is_InSC:   toneletter}', "");
    Expect(0, 43714, '\p{^Is_InSC:   toneletter}', "");
    Expect(0, 43714, '\P{Is_InSC:   toneletter}', "");
    Expect(1, 43714, '\P{^Is_InSC:   toneletter}', "");
    Expect(0, 43715, '\p{Is_InSC:   toneletter}', "");
    Expect(1, 43715, '\p{^Is_InSC:   toneletter}', "");
    Expect(1, 43715, '\P{Is_InSC:   toneletter}', "");
    Expect(0, 43715, '\P{^Is_InSC:   toneletter}', "");
    Expect(1, 43714, '\p{Is_InSC= -tone_Letter}', "");
    Expect(0, 43714, '\p{^Is_InSC= -tone_Letter}', "");
    Expect(0, 43714, '\P{Is_InSC= -tone_Letter}', "");
    Expect(1, 43714, '\P{^Is_InSC= -tone_Letter}', "");
    Expect(0, 43715, '\p{Is_InSC= -tone_Letter}', "");
    Expect(1, 43715, '\p{^Is_InSC= -tone_Letter}', "");
    Expect(1, 43715, '\P{Is_InSC= -tone_Letter}', "");
    Expect(0, 43715, '\P{^Is_InSC= -tone_Letter}', "");
    Error('\p{Indic_Syllabic_Category=_:=tone_Mark}');
    Error('\P{Indic_Syllabic_Category=_:=tone_Mark}');
    Expect(1, 44012, '\p{Indic_Syllabic_Category=:\ATone_Mark\z:}', "");;
    Expect(0, 44013, '\p{Indic_Syllabic_Category=:\ATone_Mark\z:}', "");;
    Expect(1, 44012, '\p{Indic_Syllabic_Category=tonemark}', "");
    Expect(0, 44012, '\p{^Indic_Syllabic_Category=tonemark}', "");
    Expect(0, 44012, '\P{Indic_Syllabic_Category=tonemark}', "");
    Expect(1, 44012, '\P{^Indic_Syllabic_Category=tonemark}', "");
    Expect(0, 44013, '\p{Indic_Syllabic_Category=tonemark}', "");
    Expect(1, 44013, '\p{^Indic_Syllabic_Category=tonemark}', "");
    Expect(1, 44013, '\P{Indic_Syllabic_Category=tonemark}', "");
    Expect(0, 44013, '\P{^Indic_Syllabic_Category=tonemark}', "");
    Expect(1, 44012, '\p{Indic_Syllabic_Category=:\Atonemark\z:}', "");;
    Expect(0, 44013, '\p{Indic_Syllabic_Category=:\Atonemark\z:}', "");;
    Expect(1, 44012, '\p{Indic_Syllabic_Category=	-tone_Mark}', "");
    Expect(0, 44012, '\p{^Indic_Syllabic_Category=	-tone_Mark}', "");
    Expect(0, 44012, '\P{Indic_Syllabic_Category=	-tone_Mark}', "");
    Expect(1, 44012, '\P{^Indic_Syllabic_Category=	-tone_Mark}', "");
    Expect(0, 44013, '\p{Indic_Syllabic_Category=	-tone_Mark}', "");
    Expect(1, 44013, '\p{^Indic_Syllabic_Category=	-tone_Mark}', "");
    Expect(1, 44013, '\P{Indic_Syllabic_Category=	-tone_Mark}', "");
    Expect(0, 44013, '\P{^Indic_Syllabic_Category=	-tone_Mark}', "");
    Error('\p{InSC=:=	-Tone_Mark}');
    Error('\P{InSC=:=	-Tone_Mark}');
    Expect(1, 44012, '\p{InSC=:\ATone_Mark\z:}', "");;
    Expect(0, 44013, '\p{InSC=:\ATone_Mark\z:}', "");;
    Expect(1, 44012, '\p{InSC=tonemark}', "");
    Expect(0, 44012, '\p{^InSC=tonemark}', "");
    Expect(0, 44012, '\P{InSC=tonemark}', "");
    Expect(1, 44012, '\P{^InSC=tonemark}', "");
    Expect(0, 44013, '\p{InSC=tonemark}', "");
    Expect(1, 44013, '\p{^InSC=tonemark}', "");
    Expect(1, 44013, '\P{InSC=tonemark}', "");
    Expect(0, 44013, '\P{^InSC=tonemark}', "");
    Expect(1, 44012, '\p{InSC=:\Atonemark\z:}', "");;
    Expect(0, 44013, '\p{InSC=:\Atonemark\z:}', "");;
    Expect(1, 44012, '\p{InSC= 	TONE_Mark}', "");
    Expect(0, 44012, '\p{^InSC= 	TONE_Mark}', "");
    Expect(0, 44012, '\P{InSC= 	TONE_Mark}', "");
    Expect(1, 44012, '\P{^InSC= 	TONE_Mark}', "");
    Expect(0, 44013, '\p{InSC= 	TONE_Mark}', "");
    Expect(1, 44013, '\p{^InSC= 	TONE_Mark}', "");
    Expect(1, 44013, '\P{InSC= 	TONE_Mark}', "");
    Expect(0, 44013, '\P{^InSC= 	TONE_Mark}', "");
    Error('\p{Is_Indic_Syllabic_Category=_ tone_MARK:=}');
    Error('\P{Is_Indic_Syllabic_Category=_ tone_MARK:=}');
    Expect(1, 44012, '\p{Is_Indic_Syllabic_Category=tonemark}', "");
    Expect(0, 44012, '\p{^Is_Indic_Syllabic_Category=tonemark}', "");
    Expect(0, 44012, '\P{Is_Indic_Syllabic_Category=tonemark}', "");
    Expect(1, 44012, '\P{^Is_Indic_Syllabic_Category=tonemark}', "");
    Expect(0, 44013, '\p{Is_Indic_Syllabic_Category=tonemark}', "");
    Expect(1, 44013, '\p{^Is_Indic_Syllabic_Category=tonemark}', "");
    Expect(1, 44013, '\P{Is_Indic_Syllabic_Category=tonemark}', "");
    Expect(0, 44013, '\P{^Is_Indic_Syllabic_Category=tonemark}', "");
    Expect(1, 44012, '\p{Is_Indic_Syllabic_Category=-Tone_mark}', "");
    Expect(0, 44012, '\p{^Is_Indic_Syllabic_Category=-Tone_mark}', "");
    Expect(0, 44012, '\P{Is_Indic_Syllabic_Category=-Tone_mark}', "");
    Expect(1, 44012, '\P{^Is_Indic_Syllabic_Category=-Tone_mark}', "");
    Expect(0, 44013, '\p{Is_Indic_Syllabic_Category=-Tone_mark}', "");
    Expect(1, 44013, '\p{^Is_Indic_Syllabic_Category=-Tone_mark}', "");
    Expect(1, 44013, '\P{Is_Indic_Syllabic_Category=-Tone_mark}', "");
    Expect(0, 44013, '\P{^Is_Indic_Syllabic_Category=-Tone_mark}', "");
    Error('\p{Is_InSC:   /a/	 Tone_Mark}');
    Error('\P{Is_InSC:   /a/	 Tone_Mark}');
    Expect(1, 44012, '\p{Is_InSC=tonemark}', "");
    Expect(0, 44012, '\p{^Is_InSC=tonemark}', "");
    Expect(0, 44012, '\P{Is_InSC=tonemark}', "");
    Expect(1, 44012, '\P{^Is_InSC=tonemark}', "");
    Expect(0, 44013, '\p{Is_InSC=tonemark}', "");
    Expect(1, 44013, '\p{^Is_InSC=tonemark}', "");
    Expect(1, 44013, '\P{Is_InSC=tonemark}', "");
    Expect(0, 44013, '\P{^Is_InSC=tonemark}', "");
    Expect(1, 44012, '\p{Is_InSC:   _Tone_Mark}', "");
    Expect(0, 44012, '\p{^Is_InSC:   _Tone_Mark}', "");
    Expect(0, 44012, '\P{Is_InSC:   _Tone_Mark}', "");
    Expect(1, 44012, '\P{^Is_InSC:   _Tone_Mark}', "");
    Expect(0, 44013, '\p{Is_InSC:   _Tone_Mark}', "");
    Expect(1, 44013, '\p{^Is_InSC:   _Tone_Mark}', "");
    Expect(1, 44013, '\P{Is_InSC:   _Tone_Mark}', "");
    Expect(0, 44013, '\P{^Is_InSC:   _Tone_Mark}', "");
    Error('\p{Indic_Syllabic_Category=/a/--Virama}');
    Error('\P{Indic_Syllabic_Category=/a/--Virama}');
    Expect(1, 72767, '\p{Indic_Syllabic_Category=:\AVirama\z:}', "");;
    Expect(0, 72768, '\p{Indic_Syllabic_Category=:\AVirama\z:}', "");;
    Expect(1, 72767, '\p{Indic_Syllabic_Category=virama}', "");
    Expect(0, 72767, '\p{^Indic_Syllabic_Category=virama}', "");
    Expect(0, 72767, '\P{Indic_Syllabic_Category=virama}', "");
    Expect(1, 72767, '\P{^Indic_Syllabic_Category=virama}', "");
    Expect(0, 72768, '\p{Indic_Syllabic_Category=virama}', "");
    Expect(1, 72768, '\p{^Indic_Syllabic_Category=virama}', "");
    Expect(1, 72768, '\P{Indic_Syllabic_Category=virama}', "");
    Expect(0, 72768, '\P{^Indic_Syllabic_Category=virama}', "");
    Expect(1, 72767, '\p{Indic_Syllabic_Category=:\Avirama\z:}', "");;
    Expect(0, 72768, '\p{Indic_Syllabic_Category=:\Avirama\z:}', "");;
    Expect(1, 72767, '\p{Indic_Syllabic_Category=- Virama}', "");
    Expect(0, 72767, '\p{^Indic_Syllabic_Category=- Virama}', "");
    Expect(0, 72767, '\P{Indic_Syllabic_Category=- Virama}', "");
    Expect(1, 72767, '\P{^Indic_Syllabic_Category=- Virama}', "");
    Expect(0, 72768, '\p{Indic_Syllabic_Category=- Virama}', "");
    Expect(1, 72768, '\p{^Indic_Syllabic_Category=- Virama}', "");
    Expect(1, 72768, '\P{Indic_Syllabic_Category=- Virama}', "");
    Expect(0, 72768, '\P{^Indic_Syllabic_Category=- Virama}', "");
    Error('\p{InSC:_:=Virama}');
    Error('\P{InSC:_:=Virama}');
    Expect(1, 72767, '\p{InSC=:\AVirama\z:}', "");;
    Expect(0, 72768, '\p{InSC=:\AVirama\z:}', "");;
    Expect(1, 72767, '\p{InSC:   virama}', "");
    Expect(0, 72767, '\p{^InSC:   virama}', "");
    Expect(0, 72767, '\P{InSC:   virama}', "");
    Expect(1, 72767, '\P{^InSC:   virama}', "");
    Expect(0, 72768, '\p{InSC:   virama}', "");
    Expect(1, 72768, '\p{^InSC:   virama}', "");
    Expect(1, 72768, '\P{InSC:   virama}', "");
    Expect(0, 72768, '\P{^InSC:   virama}', "");
    Expect(1, 72767, '\p{InSC=:\Avirama\z:}', "");;
    Expect(0, 72768, '\p{InSC=:\Avirama\z:}', "");;
    Expect(1, 72767, '\p{InSC= -virama}', "");
    Expect(0, 72767, '\p{^InSC= -virama}', "");
    Expect(0, 72767, '\P{InSC= -virama}', "");
    Expect(1, 72767, '\P{^InSC= -virama}', "");
    Expect(0, 72768, '\p{InSC= -virama}', "");
    Expect(1, 72768, '\p{^InSC= -virama}', "");
    Expect(1, 72768, '\P{InSC= -virama}', "");
    Expect(0, 72768, '\P{^InSC= -virama}', "");
    Error('\p{Is_Indic_Syllabic_Category:	:=_	Virama}');
    Error('\P{Is_Indic_Syllabic_Category:	:=_	Virama}');
    Expect(1, 72767, '\p{Is_Indic_Syllabic_Category=virama}', "");
    Expect(0, 72767, '\p{^Is_Indic_Syllabic_Category=virama}', "");
    Expect(0, 72767, '\P{Is_Indic_Syllabic_Category=virama}', "");
    Expect(1, 72767, '\P{^Is_Indic_Syllabic_Category=virama}', "");
    Expect(0, 72768, '\p{Is_Indic_Syllabic_Category=virama}', "");
    Expect(1, 72768, '\p{^Is_Indic_Syllabic_Category=virama}', "");
    Expect(1, 72768, '\P{Is_Indic_Syllabic_Category=virama}', "");
    Expect(0, 72768, '\P{^Is_Indic_Syllabic_Category=virama}', "");
    Expect(1, 72767, '\p{Is_Indic_Syllabic_Category=_-VIRAMA}', "");
    Expect(0, 72767, '\p{^Is_Indic_Syllabic_Category=_-VIRAMA}', "");
    Expect(0, 72767, '\P{Is_Indic_Syllabic_Category=_-VIRAMA}', "");
    Expect(1, 72767, '\P{^Is_Indic_Syllabic_Category=_-VIRAMA}', "");
    Expect(0, 72768, '\p{Is_Indic_Syllabic_Category=_-VIRAMA}', "");
    Expect(1, 72768, '\p{^Is_Indic_Syllabic_Category=_-VIRAMA}', "");
    Expect(1, 72768, '\P{Is_Indic_Syllabic_Category=_-VIRAMA}', "");
    Expect(0, 72768, '\P{^Is_Indic_Syllabic_Category=_-VIRAMA}', "");
    Error('\p{Is_InSC=-Virama:=}');
    Error('\P{Is_InSC=-Virama:=}');
    Expect(1, 72767, '\p{Is_InSC=virama}', "");
    Expect(0, 72767, '\p{^Is_InSC=virama}', "");
    Expect(0, 72767, '\P{Is_InSC=virama}', "");
    Expect(1, 72767, '\P{^Is_InSC=virama}', "");
    Expect(0, 72768, '\p{Is_InSC=virama}', "");
    Expect(1, 72768, '\p{^Is_InSC=virama}', "");
    Expect(1, 72768, '\P{Is_InSC=virama}', "");
    Expect(0, 72768, '\P{^Is_InSC=virama}', "");
    Expect(1, 72767, '\p{Is_InSC=Virama}', "");
    Expect(0, 72767, '\p{^Is_InSC=Virama}', "");
    Expect(0, 72767, '\P{Is_InSC=Virama}', "");
    Expect(1, 72767, '\P{^Is_InSC=Virama}', "");
    Expect(0, 72768, '\p{Is_InSC=Virama}', "");
    Expect(1, 72768, '\p{^Is_InSC=Virama}', "");
    Expect(1, 72768, '\P{Is_InSC=Virama}', "");
    Expect(0, 72768, '\P{^Is_InSC=Virama}', "");
    Error('\p{Indic_Syllabic_Category:   _-VISARGA/a/}');
    Error('\P{Indic_Syllabic_Category:   _-VISARGA/a/}');
    Expect(1, 73475, '\p{Indic_Syllabic_Category=:\AVisarga\z:}', "");;
    Expect(0, 73476, '\p{Indic_Syllabic_Category=:\AVisarga\z:}', "");;
    Expect(1, 73475, '\p{Indic_Syllabic_Category=visarga}', "");
    Expect(0, 73475, '\p{^Indic_Syllabic_Category=visarga}', "");
    Expect(0, 73475, '\P{Indic_Syllabic_Category=visarga}', "");
    Expect(1, 73475, '\P{^Indic_Syllabic_Category=visarga}', "");
    Expect(0, 73476, '\p{Indic_Syllabic_Category=visarga}', "");
    Expect(1, 73476, '\p{^Indic_Syllabic_Category=visarga}', "");
    Expect(1, 73476, '\P{Indic_Syllabic_Category=visarga}', "");
    Expect(0, 73476, '\P{^Indic_Syllabic_Category=visarga}', "");
    Expect(1, 73475, '\p{Indic_Syllabic_Category=:\Avisarga\z:}', "");;
    Expect(0, 73476, '\p{Indic_Syllabic_Category=:\Avisarga\z:}', "");;
    Expect(1, 73475, '\p{Indic_Syllabic_Category=	Visarga}', "");
    Expect(0, 73475, '\p{^Indic_Syllabic_Category=	Visarga}', "");
    Expect(0, 73475, '\P{Indic_Syllabic_Category=	Visarga}', "");
    Expect(1, 73475, '\P{^Indic_Syllabic_Category=	Visarga}', "");
    Expect(0, 73476, '\p{Indic_Syllabic_Category=	Visarga}', "");
    Expect(1, 73476, '\p{^Indic_Syllabic_Category=	Visarga}', "");
    Expect(1, 73476, '\P{Indic_Syllabic_Category=	Visarga}', "");
    Expect(0, 73476, '\P{^Indic_Syllabic_Category=	Visarga}', "");
    Error('\p{InSC=_:=visarga}');
    Error('\P{InSC=_:=visarga}');
    Expect(1, 73475, '\p{InSC=:\AVisarga\z:}', "");;
    Expect(0, 73476, '\p{InSC=:\AVisarga\z:}', "");;
    Expect(1, 73475, '\p{InSC:visarga}', "");
    Expect(0, 73475, '\p{^InSC:visarga}', "");
    Expect(0, 73475, '\P{InSC:visarga}', "");
    Expect(1, 73475, '\P{^InSC:visarga}', "");
    Expect(0, 73476, '\p{InSC:visarga}', "");
    Expect(1, 73476, '\p{^InSC:visarga}', "");
    Expect(1, 73476, '\P{InSC:visarga}', "");
    Expect(0, 73476, '\P{^InSC:visarga}', "");
    Expect(1, 73475, '\p{InSC=:\Avisarga\z:}', "");;
    Expect(0, 73476, '\p{InSC=:\Avisarga\z:}', "");;
    Expect(1, 73475, '\p{InSC=_VISARGA}', "");
    Expect(0, 73475, '\p{^InSC=_VISARGA}', "");
    Expect(0, 73475, '\P{InSC=_VISARGA}', "");
    Expect(1, 73475, '\P{^InSC=_VISARGA}', "");
    Expect(0, 73476, '\p{InSC=_VISARGA}', "");
    Expect(1, 73476, '\p{^InSC=_VISARGA}', "");
    Expect(1, 73476, '\P{InSC=_VISARGA}', "");
    Expect(0, 73476, '\P{^InSC=_VISARGA}', "");
    Error('\p{Is_Indic_Syllabic_Category=	_VISARGA/a/}');
    Error('\P{Is_Indic_Syllabic_Category=	_VISARGA/a/}');
    Expect(1, 73475, '\p{Is_Indic_Syllabic_Category=visarga}', "");
    Expect(0, 73475, '\p{^Is_Indic_Syllabic_Category=visarga}', "");
    Expect(0, 73475, '\P{Is_Indic_Syllabic_Category=visarga}', "");
    Expect(1, 73475, '\P{^Is_Indic_Syllabic_Category=visarga}', "");
    Expect(0, 73476, '\p{Is_Indic_Syllabic_Category=visarga}', "");
    Expect(1, 73476, '\p{^Is_Indic_Syllabic_Category=visarga}', "");
    Expect(1, 73476, '\P{Is_Indic_Syllabic_Category=visarga}', "");
    Expect(0, 73476, '\P{^Is_Indic_Syllabic_Category=visarga}', "");
    Expect(1, 73475, '\p{Is_Indic_Syllabic_Category: -VISARGA}', "");
    Expect(0, 73475, '\p{^Is_Indic_Syllabic_Category: -VISARGA}', "");
    Expect(0, 73475, '\P{Is_Indic_Syllabic_Category: -VISARGA}', "");
    Expect(1, 73475, '\P{^Is_Indic_Syllabic_Category: -VISARGA}', "");
    Expect(0, 73476, '\p{Is_Indic_Syllabic_Category: -VISARGA}', "");
    Expect(1, 73476, '\p{^Is_Indic_Syllabic_Category: -VISARGA}', "");
    Expect(1, 73476, '\P{Is_Indic_Syllabic_Category: -VISARGA}', "");
    Expect(0, 73476, '\P{^Is_Indic_Syllabic_Category: -VISARGA}', "");
    Error('\p{Is_InSC:	:=_VISARGA}');
    Error('\P{Is_InSC:	:=_VISARGA}');
    Expect(1, 73475, '\p{Is_InSC: visarga}', "");
    Expect(0, 73475, '\p{^Is_InSC: visarga}', "");
    Expect(0, 73475, '\P{Is_InSC: visarga}', "");
    Expect(1, 73475, '\P{^Is_InSC: visarga}', "");
    Expect(0, 73476, '\p{Is_InSC: visarga}', "");
    Expect(1, 73476, '\p{^Is_InSC: visarga}', "");
    Expect(1, 73476, '\P{Is_InSC: visarga}', "");
    Expect(0, 73476, '\P{^Is_InSC: visarga}', "");
    Expect(1, 73475, '\p{Is_InSC=	visarga}', "");
    Expect(0, 73475, '\p{^Is_InSC=	visarga}', "");
    Expect(0, 73475, '\P{Is_InSC=	visarga}', "");
    Expect(1, 73475, '\P{^Is_InSC=	visarga}', "");
    Expect(0, 73476, '\p{Is_InSC=	visarga}', "");
    Expect(1, 73476, '\p{^Is_InSC=	visarga}', "");
    Expect(1, 73476, '\P{Is_InSC=	visarga}', "");
    Expect(0, 73476, '\P{^Is_InSC=	visarga}', "");
    Error('\p{Indic_Syllabic_Category:   _	Vowel/a/}');
    Error('\P{Indic_Syllabic_Category:   _	Vowel/a/}');
    Expect(1, 69972, '\p{Indic_Syllabic_Category=:\AVowel\z:}', "");;
    Expect(0, 69973, '\p{Indic_Syllabic_Category=:\AVowel\z:}', "");;
    Expect(1, 69972, '\p{Indic_Syllabic_Category=vowel}', "");
    Expect(0, 69972, '\p{^Indic_Syllabic_Category=vowel}', "");
    Expect(0, 69972, '\P{Indic_Syllabic_Category=vowel}', "");
    Expect(1, 69972, '\P{^Indic_Syllabic_Category=vowel}', "");
    Expect(0, 69973, '\p{Indic_Syllabic_Category=vowel}', "");
    Expect(1, 69973, '\p{^Indic_Syllabic_Category=vowel}', "");
    Expect(1, 69973, '\P{Indic_Syllabic_Category=vowel}', "");
    Expect(0, 69973, '\P{^Indic_Syllabic_Category=vowel}', "");
    Expect(1, 69972, '\p{Indic_Syllabic_Category=:\Avowel\z:}', "");;
    Expect(0, 69973, '\p{Indic_Syllabic_Category=:\Avowel\z:}', "");;
    Expect(1, 69972, '\p{Indic_Syllabic_Category=_-Vowel}', "");
    Expect(0, 69972, '\p{^Indic_Syllabic_Category=_-Vowel}', "");
    Expect(0, 69972, '\P{Indic_Syllabic_Category=_-Vowel}', "");
    Expect(1, 69972, '\P{^Indic_Syllabic_Category=_-Vowel}', "");
    Expect(0, 69973, '\p{Indic_Syllabic_Category=_-Vowel}', "");
    Expect(1, 69973, '\p{^Indic_Syllabic_Category=_-Vowel}', "");
    Expect(1, 69973, '\P{Indic_Syllabic_Category=_-Vowel}', "");
    Expect(0, 69973, '\P{^Indic_Syllabic_Category=_-Vowel}', "");
    Error('\p{InSC=-:=Vowel}');
    Error('\P{InSC=-:=Vowel}');
    Expect(1, 69972, '\p{InSC=:\AVowel\z:}', "");;
    Expect(0, 69973, '\p{InSC=:\AVowel\z:}', "");;
    Expect(1, 69972, '\p{InSC=vowel}', "");
    Expect(0, 69972, '\p{^InSC=vowel}', "");
    Expect(0, 69972, '\P{InSC=vowel}', "");
    Expect(1, 69972, '\P{^InSC=vowel}', "");
    Expect(0, 69973, '\p{InSC=vowel}', "");
    Expect(1, 69973, '\p{^InSC=vowel}', "");
    Expect(1, 69973, '\P{InSC=vowel}', "");
    Expect(0, 69973, '\P{^InSC=vowel}', "");
    Expect(1, 69972, '\p{InSC=:\Avowel\z:}', "");;
    Expect(0, 69973, '\p{InSC=:\Avowel\z:}', "");;
    Expect(1, 69972, '\p{InSC=-Vowel}', "");
    Expect(0, 69972, '\p{^InSC=-Vowel}', "");
    Expect(0, 69972, '\P{InSC=-Vowel}', "");
    Expect(1, 69972, '\P{^InSC=-Vowel}', "");
    Expect(0, 69973, '\p{InSC=-Vowel}', "");
    Expect(1, 69973, '\p{^InSC=-Vowel}', "");
    Expect(1, 69973, '\P{InSC=-Vowel}', "");
    Expect(0, 69973, '\P{^InSC=-Vowel}', "");
    Error('\p{Is_Indic_Syllabic_Category= VOWEL:=}');
    Error('\P{Is_Indic_Syllabic_Category= VOWEL:=}');
    Expect(1, 69972, '\p{Is_Indic_Syllabic_Category=vowel}', "");
    Expect(0, 69972, '\p{^Is_Indic_Syllabic_Category=vowel}', "");
    Expect(0, 69972, '\P{Is_Indic_Syllabic_Category=vowel}', "");
    Expect(1, 69972, '\P{^Is_Indic_Syllabic_Category=vowel}', "");
    Expect(0, 69973, '\p{Is_Indic_Syllabic_Category=vowel}', "");
    Expect(1, 69973, '\p{^Is_Indic_Syllabic_Category=vowel}', "");
    Expect(1, 69973, '\P{Is_Indic_Syllabic_Category=vowel}', "");
    Expect(0, 69973, '\P{^Is_Indic_Syllabic_Category=vowel}', "");
    Expect(1, 69972, '\p{Is_Indic_Syllabic_Category=_ Vowel}', "");
    Expect(0, 69972, '\p{^Is_Indic_Syllabic_Category=_ Vowel}', "");
    Expect(0, 69972, '\P{Is_Indic_Syllabic_Category=_ Vowel}', "");
    Expect(1, 69972, '\P{^Is_Indic_Syllabic_Category=_ Vowel}', "");
    Expect(0, 69973, '\p{Is_Indic_Syllabic_Category=_ Vowel}', "");
    Expect(1, 69973, '\p{^Is_Indic_Syllabic_Category=_ Vowel}', "");
    Expect(1, 69973, '\P{Is_Indic_Syllabic_Category=_ Vowel}', "");
    Expect(0, 69973, '\P{^Is_Indic_Syllabic_Category=_ Vowel}', "");
    Error('\p{Is_InSC=	vowel:=}');
    Error('\P{Is_InSC=	vowel:=}');
    Expect(1, 69972, '\p{Is_InSC:vowel}', "");
    Expect(0, 69972, '\p{^Is_InSC:vowel}', "");
    Expect(0, 69972, '\P{Is_InSC:vowel}', "");
    Expect(1, 69972, '\P{^Is_InSC:vowel}', "");
    Expect(0, 69973, '\p{Is_InSC:vowel}', "");
    Expect(1, 69973, '\p{^Is_InSC:vowel}', "");
    Expect(1, 69973, '\P{Is_InSC:vowel}', "");
    Expect(0, 69973, '\P{^Is_InSC:vowel}', "");
    Expect(1, 69972, '\p{Is_InSC=_ VOWEL}', "");
    Expect(0, 69972, '\p{^Is_InSC=_ VOWEL}', "");
    Expect(0, 69972, '\P{Is_InSC=_ VOWEL}', "");
    Expect(1, 69972, '\P{^Is_InSC=_ VOWEL}', "");
    Expect(0, 69973, '\p{Is_InSC=_ VOWEL}', "");
    Expect(1, 69973, '\p{^Is_InSC=_ VOWEL}', "");
    Expect(1, 69973, '\P{Is_InSC=_ VOWEL}', "");
    Expect(0, 69973, '\P{^Is_InSC=_ VOWEL}', "");
    Error('\p{Indic_Syllabic_Category=/a/-Vowel_Dependent}');
    Error('\P{Indic_Syllabic_Category=/a/-Vowel_Dependent}');
    Expect(1, 73536, '\p{Indic_Syllabic_Category=:\AVowel_Dependent\z:}', "");;
    Expect(0, 73537, '\p{Indic_Syllabic_Category=:\AVowel_Dependent\z:}', "");;
    Expect(1, 73536, '\p{Indic_Syllabic_Category=voweldependent}', "");
    Expect(0, 73536, '\p{^Indic_Syllabic_Category=voweldependent}', "");
    Expect(0, 73536, '\P{Indic_Syllabic_Category=voweldependent}', "");
    Expect(1, 73536, '\P{^Indic_Syllabic_Category=voweldependent}', "");
    Expect(0, 73537, '\p{Indic_Syllabic_Category=voweldependent}', "");
    Expect(1, 73537, '\p{^Indic_Syllabic_Category=voweldependent}', "");
    Expect(1, 73537, '\P{Indic_Syllabic_Category=voweldependent}', "");
    Expect(0, 73537, '\P{^Indic_Syllabic_Category=voweldependent}', "");
    Expect(1, 73536, '\p{Indic_Syllabic_Category=:\Avoweldependent\z:}', "");;
    Expect(0, 73537, '\p{Indic_Syllabic_Category=:\Avoweldependent\z:}', "");;
    Expect(1, 73536, '\p{Indic_Syllabic_Category=__Vowel_Dependent}', "");
    Expect(0, 73536, '\p{^Indic_Syllabic_Category=__Vowel_Dependent}', "");
    Expect(0, 73536, '\P{Indic_Syllabic_Category=__Vowel_Dependent}', "");
    Expect(1, 73536, '\P{^Indic_Syllabic_Category=__Vowel_Dependent}', "");
    Expect(0, 73537, '\p{Indic_Syllabic_Category=__Vowel_Dependent}', "");
    Expect(1, 73537, '\p{^Indic_Syllabic_Category=__Vowel_Dependent}', "");
    Expect(1, 73537, '\P{Indic_Syllabic_Category=__Vowel_Dependent}', "");
    Expect(0, 73537, '\P{^Indic_Syllabic_Category=__Vowel_Dependent}', "");
    Error('\p{InSC=/a/_ Vowel_DEPENDENT}');
    Error('\P{InSC=/a/_ Vowel_DEPENDENT}');
    Expect(1, 73536, '\p{InSC=:\AVowel_Dependent\z:}', "");;
    Expect(0, 73537, '\p{InSC=:\AVowel_Dependent\z:}', "");;
    Expect(1, 73536, '\p{InSC=voweldependent}', "");
    Expect(0, 73536, '\p{^InSC=voweldependent}', "");
    Expect(0, 73536, '\P{InSC=voweldependent}', "");
    Expect(1, 73536, '\P{^InSC=voweldependent}', "");
    Expect(0, 73537, '\p{InSC=voweldependent}', "");
    Expect(1, 73537, '\p{^InSC=voweldependent}', "");
    Expect(1, 73537, '\P{InSC=voweldependent}', "");
    Expect(0, 73537, '\P{^InSC=voweldependent}', "");
    Expect(1, 73536, '\p{InSC=:\Avoweldependent\z:}', "");;
    Expect(0, 73537, '\p{InSC=:\Avoweldependent\z:}', "");;
    Expect(1, 73536, '\p{InSC:	 -VOWEL_Dependent}', "");
    Expect(0, 73536, '\p{^InSC:	 -VOWEL_Dependent}', "");
    Expect(0, 73536, '\P{InSC:	 -VOWEL_Dependent}', "");
    Expect(1, 73536, '\P{^InSC:	 -VOWEL_Dependent}', "");
    Expect(0, 73537, '\p{InSC:	 -VOWEL_Dependent}', "");
    Expect(1, 73537, '\p{^InSC:	 -VOWEL_Dependent}', "");
    Expect(1, 73537, '\P{InSC:	 -VOWEL_Dependent}', "");
    Expect(0, 73537, '\P{^InSC:	 -VOWEL_Dependent}', "");
    Error('\p{Is_Indic_Syllabic_Category= :=VOWEL_Dependent}');
    Error('\P{Is_Indic_Syllabic_Category= :=VOWEL_Dependent}');
    Expect(1, 73536, '\p{Is_Indic_Syllabic_Category=voweldependent}', "");
    Expect(0, 73536, '\p{^Is_Indic_Syllabic_Category=voweldependent}', "");
    Expect(0, 73536, '\P{Is_Indic_Syllabic_Category=voweldependent}', "");
    Expect(1, 73536, '\P{^Is_Indic_Syllabic_Category=voweldependent}', "");
    Expect(0, 73537, '\p{Is_Indic_Syllabic_Category=voweldependent}', "");
    Expect(1, 73537, '\p{^Is_Indic_Syllabic_Category=voweldependent}', "");
    Expect(1, 73537, '\P{Is_Indic_Syllabic_Category=voweldependent}', "");
    Expect(0, 73537, '\P{^Is_Indic_Syllabic_Category=voweldependent}', "");
    Expect(1, 73536, '\p{Is_Indic_Syllabic_Category=_Vowel_DEPENDENT}', "");
    Expect(0, 73536, '\p{^Is_Indic_Syllabic_Category=_Vowel_DEPENDENT}', "");
    Expect(0, 73536, '\P{Is_Indic_Syllabic_Category=_Vowel_DEPENDENT}', "");
    Expect(1, 73536, '\P{^Is_Indic_Syllabic_Category=_Vowel_DEPENDENT}', "");
    Expect(0, 73537, '\p{Is_Indic_Syllabic_Category=_Vowel_DEPENDENT}', "");
    Expect(1, 73537, '\p{^Is_Indic_Syllabic_Category=_Vowel_DEPENDENT}', "");
    Expect(1, 73537, '\P{Is_Indic_Syllabic_Category=_Vowel_DEPENDENT}', "");
    Expect(0, 73537, '\P{^Is_Indic_Syllabic_Category=_Vowel_DEPENDENT}', "");
    Error('\p{Is_InSC=/a/--vowel_Dependent}');
    Error('\P{Is_InSC=/a/--vowel_Dependent}');
    Expect(1, 73536, '\p{Is_InSC=voweldependent}', "");
    Expect(0, 73536, '\p{^Is_InSC=voweldependent}', "");
    Expect(0, 73536, '\P{Is_InSC=voweldependent}', "");
    Expect(1, 73536, '\P{^Is_InSC=voweldependent}', "");
    Expect(0, 73537, '\p{Is_InSC=voweldependent}', "");
    Expect(1, 73537, '\p{^Is_InSC=voweldependent}', "");
    Expect(1, 73537, '\P{Is_InSC=voweldependent}', "");
    Expect(0, 73537, '\P{^Is_InSC=voweldependent}', "");
    Expect(1, 73536, '\p{Is_InSC=_	vowel_Dependent}', "");
    Expect(0, 73536, '\p{^Is_InSC=_	vowel_Dependent}', "");
    Expect(0, 73536, '\P{Is_InSC=_	vowel_Dependent}', "");
    Expect(1, 73536, '\P{^Is_InSC=_	vowel_Dependent}', "");
    Expect(0, 73537, '\p{Is_InSC=_	vowel_Dependent}', "");
    Expect(1, 73537, '\p{^Is_InSC=_	vowel_Dependent}', "");
    Expect(1, 73537, '\P{Is_InSC=_	vowel_Dependent}', "");
    Expect(0, 73537, '\P{^Is_InSC=_	vowel_Dependent}', "");
    Error('\p{Indic_Syllabic_Category:    /a/Vowel_INDEPENDENT}');
    Error('\P{Indic_Syllabic_Category:    /a/Vowel_INDEPENDENT}');
    Expect(1, 73488, '\p{Indic_Syllabic_Category=:\AVowel_Independent\z:}', "");;
    Expect(0, 73489, '\p{Indic_Syllabic_Category=:\AVowel_Independent\z:}', "");;
    Expect(1, 73488, '\p{Indic_Syllabic_Category=vowelindependent}', "");
    Expect(0, 73488, '\p{^Indic_Syllabic_Category=vowelindependent}', "");
    Expect(0, 73488, '\P{Indic_Syllabic_Category=vowelindependent}', "");
    Expect(1, 73488, '\P{^Indic_Syllabic_Category=vowelindependent}', "");
    Expect(0, 73489, '\p{Indic_Syllabic_Category=vowelindependent}', "");
    Expect(1, 73489, '\p{^Indic_Syllabic_Category=vowelindependent}', "");
    Expect(1, 73489, '\P{Indic_Syllabic_Category=vowelindependent}', "");
    Expect(0, 73489, '\P{^Indic_Syllabic_Category=vowelindependent}', "");
    Expect(1, 73488, '\p{Indic_Syllabic_Category=:\Avowelindependent\z:}', "");;
    Expect(0, 73489, '\p{Indic_Syllabic_Category=:\Avowelindependent\z:}', "");;
    Expect(1, 73488, '\p{Indic_Syllabic_Category=- vowel_Independent}', "");
    Expect(0, 73488, '\p{^Indic_Syllabic_Category=- vowel_Independent}', "");
    Expect(0, 73488, '\P{Indic_Syllabic_Category=- vowel_Independent}', "");
    Expect(1, 73488, '\P{^Indic_Syllabic_Category=- vowel_Independent}', "");
    Expect(0, 73489, '\p{Indic_Syllabic_Category=- vowel_Independent}', "");
    Expect(1, 73489, '\p{^Indic_Syllabic_Category=- vowel_Independent}', "");
    Expect(1, 73489, '\P{Indic_Syllabic_Category=- vowel_Independent}', "");
    Expect(0, 73489, '\P{^Indic_Syllabic_Category=- vowel_Independent}', "");
    Error('\p{InSC= Vowel_independent:=}');
    Error('\P{InSC= Vowel_independent:=}');
    Expect(1, 73488, '\p{InSC=:\AVowel_Independent\z:}', "");;
    Expect(0, 73489, '\p{InSC=:\AVowel_Independent\z:}', "");;
    Expect(1, 73488, '\p{InSC=vowelindependent}', "");
    Expect(0, 73488, '\p{^InSC=vowelindependent}', "");
    Expect(0, 73488, '\P{InSC=vowelindependent}', "");
    Expect(1, 73488, '\P{^InSC=vowelindependent}', "");
    Expect(0, 73489, '\p{InSC=vowelindependent}', "");
    Expect(1, 73489, '\p{^InSC=vowelindependent}', "");
    Expect(1, 73489, '\P{InSC=vowelindependent}', "");
    Expect(0, 73489, '\P{^InSC=vowelindependent}', "");
    Expect(1, 73488, '\p{InSC=:\Avowelindependent\z:}', "");;
    Expect(0, 73489, '\p{InSC=:\Avowelindependent\z:}', "");;
    Expect(1, 73488, '\p{InSC:   -	Vowel_independent}', "");
    Expect(0, 73488, '\p{^InSC:   -	Vowel_independent}', "");
    Expect(0, 73488, '\P{InSC:   -	Vowel_independent}', "");
    Expect(1, 73488, '\P{^InSC:   -	Vowel_independent}', "");
    Expect(0, 73489, '\p{InSC:   -	Vowel_independent}', "");
    Expect(1, 73489, '\p{^InSC:   -	Vowel_independent}', "");
    Expect(1, 73489, '\P{InSC:   -	Vowel_independent}', "");
    Expect(0, 73489, '\P{^InSC:   -	Vowel_independent}', "");
    Error('\p{Is_Indic_Syllabic_Category= 	VOWEL_INDEPENDENT:=}');
    Error('\P{Is_Indic_Syllabic_Category= 	VOWEL_INDEPENDENT:=}');
    Expect(1, 73488, '\p{Is_Indic_Syllabic_Category=vowelindependent}', "");
    Expect(0, 73488, '\p{^Is_Indic_Syllabic_Category=vowelindependent}', "");
    Expect(0, 73488, '\P{Is_Indic_Syllabic_Category=vowelindependent}', "");
    Expect(1, 73488, '\P{^Is_Indic_Syllabic_Category=vowelindependent}', "");
    Expect(0, 73489, '\p{Is_Indic_Syllabic_Category=vowelindependent}', "");
    Expect(1, 73489, '\p{^Is_Indic_Syllabic_Category=vowelindependent}', "");
    Expect(1, 73489, '\P{Is_Indic_Syllabic_Category=vowelindependent}', "");
    Expect(0, 73489, '\P{^Is_Indic_Syllabic_Category=vowelindependent}', "");
    Expect(1, 73488, '\p{Is_Indic_Syllabic_Category=	_Vowel_Independent}', "");
    Expect(0, 73488, '\p{^Is_Indic_Syllabic_Category=	_Vowel_Independent}', "");
    Expect(0, 73488, '\P{Is_Indic_Syllabic_Category=	_Vowel_Independent}', "");
    Expect(1, 73488, '\P{^Is_Indic_Syllabic_Category=	_Vowel_Independent}', "");
    Expect(0, 73489, '\p{Is_Indic_Syllabic_Category=	_Vowel_Independent}', "");
    Expect(1, 73489, '\p{^Is_Indic_Syllabic_Category=	_Vowel_Independent}', "");
    Expect(1, 73489, '\P{Is_Indic_Syllabic_Category=	_Vowel_Independent}', "");
    Expect(0, 73489, '\P{^Is_Indic_Syllabic_Category=	_Vowel_Independent}', "");
    Error('\p{Is_InSC=/a/  vowel_INDEPENDENT}');
    Error('\P{Is_InSC=/a/  vowel_INDEPENDENT}');
    Expect(1, 73488, '\p{Is_InSC=vowelindependent}', "");
    Expect(0, 73488, '\p{^Is_InSC=vowelindependent}', "");
    Expect(0, 73488, '\P{Is_InSC=vowelindependent}', "");
    Expect(1, 73488, '\P{^Is_InSC=vowelindependent}', "");
    Expect(0, 73489, '\p{Is_InSC=vowelindependent}', "");
    Expect(1, 73489, '\p{^Is_InSC=vowelindependent}', "");
    Expect(1, 73489, '\P{Is_InSC=vowelindependent}', "");
    Expect(0, 73489, '\P{^Is_InSC=vowelindependent}', "");
    Expect(1, 73488, '\p{Is_InSC:	 vowel_Independent}', "");
    Expect(0, 73488, '\p{^Is_InSC:	 vowel_Independent}', "");
    Expect(0, 73488, '\P{Is_InSC:	 vowel_Independent}', "");
    Expect(1, 73488, '\P{^Is_InSC:	 vowel_Independent}', "");
    Expect(0, 73489, '\p{Is_InSC:	 vowel_Independent}', "");
    Expect(1, 73489, '\p{^Is_InSC:	 vowel_Independent}', "");
    Expect(1, 73489, '\P{Is_InSC:	 vowel_Independent}', "");
    Expect(0, 73489, '\P{^Is_InSC:	 vowel_Independent}', "");
    Error('\p{isocomment}');
    Error('\P{isocomment}');
    Error('\p{joininggroup}');
    Error('\P{joininggroup}');
    Error('\p{jg}');
    Error('\P{jg}');
    Error('\p{Joining_Group=/a/AFRICAN_feh}');
    Error('\P{Joining_Group=/a/AFRICAN_feh}');
    Expect(1, 2235, '\p{Joining_Group=:\AAfrican_Feh\z:}', "");;
    Expect(0, 2236, '\p{Joining_Group=:\AAfrican_Feh\z:}', "");;
    Expect(1, 2235, '\p{Joining_Group=africanfeh}', "");
    Expect(0, 2235, '\p{^Joining_Group=africanfeh}', "");
    Expect(0, 2235, '\P{Joining_Group=africanfeh}', "");
    Expect(1, 2235, '\P{^Joining_Group=africanfeh}', "");
    Expect(0, 2236, '\p{Joining_Group=africanfeh}', "");
    Expect(1, 2236, '\p{^Joining_Group=africanfeh}', "");
    Expect(1, 2236, '\P{Joining_Group=africanfeh}', "");
    Expect(0, 2236, '\P{^Joining_Group=africanfeh}', "");
    Expect(1, 2235, '\p{Joining_Group=:\Aafricanfeh\z:}', "");;
    Expect(0, 2236, '\p{Joining_Group=:\Aafricanfeh\z:}', "");;
    Expect(1, 2235, '\p{Joining_Group=_African_FEH}', "");
    Expect(0, 2235, '\p{^Joining_Group=_African_FEH}', "");
    Expect(0, 2235, '\P{Joining_Group=_African_FEH}', "");
    Expect(1, 2235, '\P{^Joining_Group=_African_FEH}', "");
    Expect(0, 2236, '\p{Joining_Group=_African_FEH}', "");
    Expect(1, 2236, '\p{^Joining_Group=_African_FEH}', "");
    Expect(1, 2236, '\P{Joining_Group=_African_FEH}', "");
    Expect(0, 2236, '\P{^Joining_Group=_African_FEH}', "");
    Error('\p{Jg=/a/_AFRICAN_FEH}');
    Error('\P{Jg=/a/_AFRICAN_FEH}');
    Expect(1, 2235, '\p{Jg=:\AAfrican_Feh\z:}', "");;
    Expect(0, 2236, '\p{Jg=:\AAfrican_Feh\z:}', "");;
    Expect(1, 2235, '\p{Jg=africanfeh}', "");
    Expect(0, 2235, '\p{^Jg=africanfeh}', "");
    Expect(0, 2235, '\P{Jg=africanfeh}', "");
    Expect(1, 2235, '\P{^Jg=africanfeh}', "");
    Expect(0, 2236, '\p{Jg=africanfeh}', "");
    Expect(1, 2236, '\p{^Jg=africanfeh}', "");
    Expect(1, 2236, '\P{Jg=africanfeh}', "");
    Expect(0, 2236, '\P{^Jg=africanfeh}', "");
    Expect(1, 2235, '\p{Jg=:\Aafricanfeh\z:}', "");;
    Expect(0, 2236, '\p{Jg=:\Aafricanfeh\z:}', "");;
    Expect(1, 2235, '\p{Jg=-African_Feh}', "");
    Expect(0, 2235, '\p{^Jg=-African_Feh}', "");
    Expect(0, 2235, '\P{Jg=-African_Feh}', "");
    Expect(1, 2235, '\P{^Jg=-African_Feh}', "");
    Expect(0, 2236, '\p{Jg=-African_Feh}', "");
    Expect(1, 2236, '\p{^Jg=-African_Feh}', "");
    Expect(1, 2236, '\P{Jg=-African_Feh}', "");
    Expect(0, 2236, '\P{^Jg=-African_Feh}', "");
    Error('\p{Is_Joining_Group=:=_-African_Feh}');
    Error('\P{Is_Joining_Group=:=_-African_Feh}');
    Expect(1, 2235, '\p{Is_Joining_Group=africanfeh}', "");
    Expect(0, 2235, '\p{^Is_Joining_Group=africanfeh}', "");
    Expect(0, 2235, '\P{Is_Joining_Group=africanfeh}', "");
    Expect(1, 2235, '\P{^Is_Joining_Group=africanfeh}', "");
    Expect(0, 2236, '\p{Is_Joining_Group=africanfeh}', "");
    Expect(1, 2236, '\p{^Is_Joining_Group=africanfeh}', "");
    Expect(1, 2236, '\P{Is_Joining_Group=africanfeh}', "");
    Expect(0, 2236, '\P{^Is_Joining_Group=africanfeh}', "");
    Expect(1, 2235, '\p{Is_Joining_Group=  African_Feh}', "");
    Expect(0, 2235, '\p{^Is_Joining_Group=  African_Feh}', "");
    Expect(0, 2235, '\P{Is_Joining_Group=  African_Feh}', "");
    Expect(1, 2235, '\P{^Is_Joining_Group=  African_Feh}', "");
    Expect(0, 2236, '\p{Is_Joining_Group=  African_Feh}', "");
    Expect(1, 2236, '\p{^Is_Joining_Group=  African_Feh}', "");
    Expect(1, 2236, '\P{Is_Joining_Group=  African_Feh}', "");
    Expect(0, 2236, '\P{^Is_Joining_Group=  African_Feh}', "");
    Error('\p{Is_Jg=/a/	 African_Feh}');
    Error('\P{Is_Jg=/a/	 African_Feh}');
    Expect(1, 2235, '\p{Is_Jg=africanfeh}', "");
    Expect(0, 2235, '\p{^Is_Jg=africanfeh}', "");
    Expect(0, 2235, '\P{Is_Jg=africanfeh}', "");
    Expect(1, 2235, '\P{^Is_Jg=africanfeh}', "");
    Expect(0, 2236, '\p{Is_Jg=africanfeh}', "");
    Expect(1, 2236, '\p{^Is_Jg=africanfeh}', "");
    Expect(1, 2236, '\P{Is_Jg=africanfeh}', "");
    Expect(0, 2236, '\P{^Is_Jg=africanfeh}', "");
    Expect(1, 2235, '\p{Is_Jg=	-African_FEH}', "");
    Expect(0, 2235, '\p{^Is_Jg=	-African_FEH}', "");
    Expect(0, 2235, '\P{Is_Jg=	-African_FEH}', "");
    Expect(1, 2235, '\P{^Is_Jg=	-African_FEH}', "");
    Expect(0, 2236, '\p{Is_Jg=	-African_FEH}', "");
    Expect(1, 2236, '\p{^Is_Jg=	-African_FEH}', "");
    Expect(1, 2236, '\P{Is_Jg=	-African_FEH}', "");
    Expect(0, 2236, '\P{^Is_Jg=	-African_FEH}', "");
    Error('\p{Joining_Group=/a/AFRICAN_Noon}');
    Error('\P{Joining_Group=/a/AFRICAN_Noon}');
    Expect(1, 2237, '\p{Joining_Group=:\AAfrican_Noon\z:}', "");;
    Expect(0, 2238, '\p{Joining_Group=:\AAfrican_Noon\z:}', "");;
    Expect(1, 2237, '\p{Joining_Group=africannoon}', "");
    Expect(0, 2237, '\p{^Joining_Group=africannoon}', "");
    Expect(0, 2237, '\P{Joining_Group=africannoon}', "");
    Expect(1, 2237, '\P{^Joining_Group=africannoon}', "");
    Expect(0, 2238, '\p{Joining_Group=africannoon}', "");
    Expect(1, 2238, '\p{^Joining_Group=africannoon}', "");
    Expect(1, 2238, '\P{Joining_Group=africannoon}', "");
    Expect(0, 2238, '\P{^Joining_Group=africannoon}', "");
    Expect(1, 2237, '\p{Joining_Group=:\Aafricannoon\z:}', "");;
    Expect(0, 2238, '\p{Joining_Group=:\Aafricannoon\z:}', "");;
    Expect(1, 2237, '\p{Joining_Group=_	AFRICAN_NOON}', "");
    Expect(0, 2237, '\p{^Joining_Group=_	AFRICAN_NOON}', "");
    Expect(0, 2237, '\P{Joining_Group=_	AFRICAN_NOON}', "");
    Expect(1, 2237, '\P{^Joining_Group=_	AFRICAN_NOON}', "");
    Expect(0, 2238, '\p{Joining_Group=_	AFRICAN_NOON}', "");
    Expect(1, 2238, '\p{^Joining_Group=_	AFRICAN_NOON}', "");
    Expect(1, 2238, '\P{Joining_Group=_	AFRICAN_NOON}', "");
    Expect(0, 2238, '\P{^Joining_Group=_	AFRICAN_NOON}', "");
    Error('\p{Jg= /a/AFRICAN_Noon}');
    Error('\P{Jg= /a/AFRICAN_Noon}');
    Expect(1, 2237, '\p{Jg=:\AAfrican_Noon\z:}', "");;
    Expect(0, 2238, '\p{Jg=:\AAfrican_Noon\z:}', "");;
    Expect(1, 2237, '\p{Jg=africannoon}', "");
    Expect(0, 2237, '\p{^Jg=africannoon}', "");
    Expect(0, 2237, '\P{Jg=africannoon}', "");
    Expect(1, 2237, '\P{^Jg=africannoon}', "");
    Expect(0, 2238, '\p{Jg=africannoon}', "");
    Expect(1, 2238, '\p{^Jg=africannoon}', "");
    Expect(1, 2238, '\P{Jg=africannoon}', "");
    Expect(0, 2238, '\P{^Jg=africannoon}', "");
    Expect(1, 2237, '\p{Jg=:\Aafricannoon\z:}', "");;
    Expect(0, 2238, '\p{Jg=:\Aafricannoon\z:}', "");;
    Expect(1, 2237, '\p{Jg= African_NOON}', "");
    Expect(0, 2237, '\p{^Jg= African_NOON}', "");
    Expect(0, 2237, '\P{Jg= African_NOON}', "");
    Expect(1, 2237, '\P{^Jg= African_NOON}', "");
    Expect(0, 2238, '\p{Jg= African_NOON}', "");
    Expect(1, 2238, '\p{^Jg= African_NOON}', "");
    Expect(1, 2238, '\P{Jg= African_NOON}', "");
    Expect(0, 2238, '\P{^Jg= African_NOON}', "");
    Error('\p{Is_Joining_Group=_ African_Noon:=}');
    Error('\P{Is_Joining_Group=_ African_Noon:=}');
    Expect(1, 2237, '\p{Is_Joining_Group=africannoon}', "");
    Expect(0, 2237, '\p{^Is_Joining_Group=africannoon}', "");
    Expect(0, 2237, '\P{Is_Joining_Group=africannoon}', "");
    Expect(1, 2237, '\P{^Is_Joining_Group=africannoon}', "");
    Expect(0, 2238, '\p{Is_Joining_Group=africannoon}', "");
    Expect(1, 2238, '\p{^Is_Joining_Group=africannoon}', "");
    Expect(1, 2238, '\P{Is_Joining_Group=africannoon}', "");
    Expect(0, 2238, '\P{^Is_Joining_Group=africannoon}', "");
    Expect(1, 2237, '\p{Is_Joining_Group=	_AFRICAN_noon}', "");
    Expect(0, 2237, '\p{^Is_Joining_Group=	_AFRICAN_noon}', "");
    Expect(0, 2237, '\P{Is_Joining_Group=	_AFRICAN_noon}', "");
    Expect(1, 2237, '\P{^Is_Joining_Group=	_AFRICAN_noon}', "");
    Expect(0, 2238, '\p{Is_Joining_Group=	_AFRICAN_noon}', "");
    Expect(1, 2238, '\p{^Is_Joining_Group=	_AFRICAN_noon}', "");
    Expect(1, 2238, '\P{Is_Joining_Group=	_AFRICAN_noon}', "");
    Expect(0, 2238, '\P{^Is_Joining_Group=	_AFRICAN_noon}', "");
    Error('\p{Is_Jg=:=_African_noon}');
    Error('\P{Is_Jg=:=_African_noon}');
    Expect(1, 2237, '\p{Is_Jg: africannoon}', "");
    Expect(0, 2237, '\p{^Is_Jg: africannoon}', "");
    Expect(0, 2237, '\P{Is_Jg: africannoon}', "");
    Expect(1, 2237, '\P{^Is_Jg: africannoon}', "");
    Expect(0, 2238, '\p{Is_Jg: africannoon}', "");
    Expect(1, 2238, '\p{^Is_Jg: africannoon}', "");
    Expect(1, 2238, '\P{Is_Jg: africannoon}', "");
    Expect(0, 2238, '\P{^Is_Jg: africannoon}', "");
    Expect(1, 2237, '\p{Is_Jg=	African_noon}', "");
    Expect(0, 2237, '\p{^Is_Jg=	African_noon}', "");
    Expect(0, 2237, '\P{Is_Jg=	African_noon}', "");
    Expect(1, 2237, '\P{^Is_Jg=	African_noon}', "");
    Expect(0, 2238, '\p{Is_Jg=	African_noon}', "");
    Expect(1, 2238, '\p{^Is_Jg=	African_noon}', "");
    Expect(1, 2238, '\P{Is_Jg=	African_noon}', "");
    Expect(0, 2238, '\P{^Is_Jg=	African_noon}', "");
    Error('\p{Joining_Group= /a/african_QAF}');
    Error('\P{Joining_Group= /a/african_QAF}');
    Expect(1, 2244, '\p{Joining_Group=:\AAfrican_Qaf\z:}', "");;
    Expect(0, 2245, '\p{Joining_Group=:\AAfrican_Qaf\z:}', "");;
    Expect(1, 2244, '\p{Joining_Group=africanqaf}', "");
    Expect(0, 2244, '\p{^Joining_Group=africanqaf}', "");
    Expect(0, 2244, '\P{Joining_Group=africanqaf}', "");
    Expect(1, 2244, '\P{^Joining_Group=africanqaf}', "");
    Expect(0, 2245, '\p{Joining_Group=africanqaf}', "");
    Expect(1, 2245, '\p{^Joining_Group=africanqaf}', "");
    Expect(1, 2245, '\P{Joining_Group=africanqaf}', "");
    Expect(0, 2245, '\P{^Joining_Group=africanqaf}', "");
    Expect(1, 2244, '\p{Joining_Group=:\Aafricanqaf\z:}', "");;
    Expect(0, 2245, '\p{Joining_Group=:\Aafricanqaf\z:}', "");;
    Expect(1, 2244, '\p{Joining_Group:	 AFRICAN_qaf}', "");
    Expect(0, 2244, '\p{^Joining_Group:	 AFRICAN_qaf}', "");
    Expect(0, 2244, '\P{Joining_Group:	 AFRICAN_qaf}', "");
    Expect(1, 2244, '\P{^Joining_Group:	 AFRICAN_qaf}', "");
    Expect(0, 2245, '\p{Joining_Group:	 AFRICAN_qaf}', "");
    Expect(1, 2245, '\p{^Joining_Group:	 AFRICAN_qaf}', "");
    Expect(1, 2245, '\P{Joining_Group:	 AFRICAN_qaf}', "");
    Expect(0, 2245, '\P{^Joining_Group:	 AFRICAN_qaf}', "");
    Error('\p{Jg=-African_qaf:=}');
    Error('\P{Jg=-African_qaf:=}');
    Expect(1, 2244, '\p{Jg=:\AAfrican_Qaf\z:}', "");;
    Expect(0, 2245, '\p{Jg=:\AAfrican_Qaf\z:}', "");;
    Expect(1, 2244, '\p{Jg=africanqaf}', "");
    Expect(0, 2244, '\p{^Jg=africanqaf}', "");
    Expect(0, 2244, '\P{Jg=africanqaf}', "");
    Expect(1, 2244, '\P{^Jg=africanqaf}', "");
    Expect(0, 2245, '\p{Jg=africanqaf}', "");
    Expect(1, 2245, '\p{^Jg=africanqaf}', "");
    Expect(1, 2245, '\P{Jg=africanqaf}', "");
    Expect(0, 2245, '\P{^Jg=africanqaf}', "");
    Expect(1, 2244, '\p{Jg=:\Aafricanqaf\z:}', "");;
    Expect(0, 2245, '\p{Jg=:\Aafricanqaf\z:}', "");;
    Expect(1, 2244, '\p{Jg=	 African_QAF}', "");
    Expect(0, 2244, '\p{^Jg=	 African_QAF}', "");
    Expect(0, 2244, '\P{Jg=	 African_QAF}', "");
    Expect(1, 2244, '\P{^Jg=	 African_QAF}', "");
    Expect(0, 2245, '\p{Jg=	 African_QAF}', "");
    Expect(1, 2245, '\p{^Jg=	 African_QAF}', "");
    Expect(1, 2245, '\P{Jg=	 African_QAF}', "");
    Expect(0, 2245, '\P{^Jg=	 African_QAF}', "");
    Error('\p{Is_Joining_Group=	african_Qaf:=}');
    Error('\P{Is_Joining_Group=	african_Qaf:=}');
    Expect(1, 2244, '\p{Is_Joining_Group=africanqaf}', "");
    Expect(0, 2244, '\p{^Is_Joining_Group=africanqaf}', "");
    Expect(0, 2244, '\P{Is_Joining_Group=africanqaf}', "");
    Expect(1, 2244, '\P{^Is_Joining_Group=africanqaf}', "");
    Expect(0, 2245, '\p{Is_Joining_Group=africanqaf}', "");
    Expect(1, 2245, '\p{^Is_Joining_Group=africanqaf}', "");
    Expect(1, 2245, '\P{Is_Joining_Group=africanqaf}', "");
    Expect(0, 2245, '\P{^Is_Joining_Group=africanqaf}', "");
    Expect(1, 2244, '\p{Is_Joining_Group=	 African_Qaf}', "");
    Expect(0, 2244, '\p{^Is_Joining_Group=	 African_Qaf}', "");
    Expect(0, 2244, '\P{Is_Joining_Group=	 African_Qaf}', "");
    Expect(1, 2244, '\P{^Is_Joining_Group=	 African_Qaf}', "");
    Expect(0, 2245, '\p{Is_Joining_Group=	 African_Qaf}', "");
    Expect(1, 2245, '\p{^Is_Joining_Group=	 African_Qaf}', "");
    Expect(1, 2245, '\P{Is_Joining_Group=	 African_Qaf}', "");
    Expect(0, 2245, '\P{^Is_Joining_Group=	 African_Qaf}', "");
    Error('\p{Is_Jg=	_AFRICAN_QAF:=}');
    Error('\P{Is_Jg=	_AFRICAN_QAF:=}');
    Expect(1, 2244, '\p{Is_Jg=africanqaf}', "");
    Expect(0, 2244, '\p{^Is_Jg=africanqaf}', "");
    Expect(0, 2244, '\P{Is_Jg=africanqaf}', "");
    Expect(1, 2244, '\P{^Is_Jg=africanqaf}', "");
    Expect(0, 2245, '\p{Is_Jg=africanqaf}', "");
    Expect(1, 2245, '\p{^Is_Jg=africanqaf}', "");
    Expect(1, 2245, '\P{Is_Jg=africanqaf}', "");
    Expect(0, 2245, '\P{^Is_Jg=africanqaf}', "");
    Expect(1, 2244, '\p{Is_Jg=_	African_QAF}', "");
    Expect(0, 2244, '\p{^Is_Jg=_	African_QAF}', "");
    Expect(0, 2244, '\P{Is_Jg=_	African_QAF}', "");
    Expect(1, 2244, '\P{^Is_Jg=_	African_QAF}', "");
    Expect(0, 2245, '\p{Is_Jg=_	African_QAF}', "");
    Expect(1, 2245, '\p{^Is_Jg=_	African_QAF}', "");
    Expect(1, 2245, '\P{Is_Jg=_	African_QAF}', "");
    Expect(0, 2245, '\P{^Is_Jg=_	African_QAF}', "");
    Error('\p{Joining_Group= 	AIN/a/}');
    Error('\P{Joining_Group= 	AIN/a/}');
    Expect(1, 2243, '\p{Joining_Group=:\AAin\z:}', "");;
    Expect(0, 2244, '\p{Joining_Group=:\AAin\z:}', "");;
    Expect(1, 2243, '\p{Joining_Group=ain}', "");
    Expect(0, 2243, '\p{^Joining_Group=ain}', "");
    Expect(0, 2243, '\P{Joining_Group=ain}', "");
    Expect(1, 2243, '\P{^Joining_Group=ain}', "");
    Expect(0, 2244, '\p{Joining_Group=ain}', "");
    Expect(1, 2244, '\p{^Joining_Group=ain}', "");
    Expect(1, 2244, '\P{Joining_Group=ain}', "");
    Expect(0, 2244, '\P{^Joining_Group=ain}', "");
    Expect(1, 2243, '\p{Joining_Group=:\Aain\z:}', "");;
    Expect(0, 2244, '\p{Joining_Group=:\Aain\z:}', "");;
    Expect(1, 2243, '\p{Joining_Group=  Ain}', "");
    Expect(0, 2243, '\p{^Joining_Group=  Ain}', "");
    Expect(0, 2243, '\P{Joining_Group=  Ain}', "");
    Expect(1, 2243, '\P{^Joining_Group=  Ain}', "");
    Expect(0, 2244, '\p{Joining_Group=  Ain}', "");
    Expect(1, 2244, '\p{^Joining_Group=  Ain}', "");
    Expect(1, 2244, '\P{Joining_Group=  Ain}', "");
    Expect(0, 2244, '\P{^Joining_Group=  Ain}', "");
    Error('\p{Jg=:=_	ain}');
    Error('\P{Jg=:=_	ain}');
    Expect(1, 2243, '\p{Jg=:\AAin\z:}', "");;
    Expect(0, 2244, '\p{Jg=:\AAin\z:}', "");;
    Expect(1, 2243, '\p{Jg=ain}', "");
    Expect(0, 2243, '\p{^Jg=ain}', "");
    Expect(0, 2243, '\P{Jg=ain}', "");
    Expect(1, 2243, '\P{^Jg=ain}', "");
    Expect(0, 2244, '\p{Jg=ain}', "");
    Expect(1, 2244, '\p{^Jg=ain}', "");
    Expect(1, 2244, '\P{Jg=ain}', "");
    Expect(0, 2244, '\P{^Jg=ain}', "");
    Expect(1, 2243, '\p{Jg=:\Aain\z:}', "");;
    Expect(0, 2244, '\p{Jg=:\Aain\z:}', "");;
    Expect(1, 2243, '\p{Jg=  ain}', "");
    Expect(0, 2243, '\p{^Jg=  ain}', "");
    Expect(0, 2243, '\P{Jg=  ain}', "");
    Expect(1, 2243, '\P{^Jg=  ain}', "");
    Expect(0, 2244, '\p{Jg=  ain}', "");
    Expect(1, 2244, '\p{^Jg=  ain}', "");
    Expect(1, 2244, '\P{Jg=  ain}', "");
    Expect(0, 2244, '\P{^Jg=  ain}', "");
    Error('\p{Is_Joining_Group=	_ain/a/}');
    Error('\P{Is_Joining_Group=	_ain/a/}');
    Expect(1, 2243, '\p{Is_Joining_Group=ain}', "");
    Expect(0, 2243, '\p{^Is_Joining_Group=ain}', "");
    Expect(0, 2243, '\P{Is_Joining_Group=ain}', "");
    Expect(1, 2243, '\P{^Is_Joining_Group=ain}', "");
    Expect(0, 2244, '\p{Is_Joining_Group=ain}', "");
    Expect(1, 2244, '\p{^Is_Joining_Group=ain}', "");
    Expect(1, 2244, '\P{Is_Joining_Group=ain}', "");
    Expect(0, 2244, '\P{^Is_Joining_Group=ain}', "");
    Expect(1, 2243, '\p{Is_Joining_Group: -_AIN}', "");
    Expect(0, 2243, '\p{^Is_Joining_Group: -_AIN}', "");
    Expect(0, 2243, '\P{Is_Joining_Group: -_AIN}', "");
    Expect(1, 2243, '\P{^Is_Joining_Group: -_AIN}', "");
    Expect(0, 2244, '\p{Is_Joining_Group: -_AIN}', "");
    Expect(1, 2244, '\p{^Is_Joining_Group: -_AIN}', "");
    Expect(1, 2244, '\P{Is_Joining_Group: -_AIN}', "");
    Expect(0, 2244, '\P{^Is_Joining_Group: -_AIN}', "");
    Error('\p{Is_Jg= /a/AIN}');
    Error('\P{Is_Jg= /a/AIN}');
    Expect(1, 2243, '\p{Is_Jg=ain}', "");
    Expect(0, 2243, '\p{^Is_Jg=ain}', "");
    Expect(0, 2243, '\P{Is_Jg=ain}', "");
    Expect(1, 2243, '\P{^Is_Jg=ain}', "");
    Expect(0, 2244, '\p{Is_Jg=ain}', "");
    Expect(1, 2244, '\p{^Is_Jg=ain}', "");
    Expect(1, 2244, '\P{Is_Jg=ain}', "");
    Expect(0, 2244, '\P{^Is_Jg=ain}', "");
    Expect(1, 2243, '\p{Is_Jg= Ain}', "");
    Expect(0, 2243, '\p{^Is_Jg= Ain}', "");
    Expect(0, 2243, '\P{Is_Jg= Ain}', "");
    Expect(1, 2243, '\P{^Is_Jg= Ain}', "");
    Expect(0, 2244, '\p{Is_Jg= Ain}', "");
    Expect(1, 2244, '\p{^Is_Jg= Ain}', "");
    Expect(1, 2244, '\P{Is_Jg= Ain}', "");
    Expect(0, 2244, '\P{^Is_Jg= Ain}', "");
    Error('\p{Joining_Group=/a/	_alaph}');
    Error('\P{Joining_Group=/a/	_alaph}');
    Expect(1, 1808, '\p{Joining_Group=:\AAlaph\z:}', "");;
    Expect(0, 1809, '\p{Joining_Group=:\AAlaph\z:}', "");;
    Expect(1, 1808, '\p{Joining_Group=alaph}', "");
    Expect(0, 1808, '\p{^Joining_Group=alaph}', "");
    Expect(0, 1808, '\P{Joining_Group=alaph}', "");
    Expect(1, 1808, '\P{^Joining_Group=alaph}', "");
    Expect(0, 1809, '\p{Joining_Group=alaph}', "");
    Expect(1, 1809, '\p{^Joining_Group=alaph}', "");
    Expect(1, 1809, '\P{Joining_Group=alaph}', "");
    Expect(0, 1809, '\P{^Joining_Group=alaph}', "");
    Expect(1, 1808, '\p{Joining_Group=:\Aalaph\z:}', "");;
    Expect(0, 1809, '\p{Joining_Group=:\Aalaph\z:}', "");;
    Expect(1, 1808, '\p{Joining_Group= 	ALAPH}', "");
    Expect(0, 1808, '\p{^Joining_Group= 	ALAPH}', "");
    Expect(0, 1808, '\P{Joining_Group= 	ALAPH}', "");
    Expect(1, 1808, '\P{^Joining_Group= 	ALAPH}', "");
    Expect(0, 1809, '\p{Joining_Group= 	ALAPH}', "");
    Expect(1, 1809, '\p{^Joining_Group= 	ALAPH}', "");
    Expect(1, 1809, '\P{Joining_Group= 	ALAPH}', "");
    Expect(0, 1809, '\P{^Joining_Group= 	ALAPH}', "");
    Error('\p{Jg=_/a/Alaph}');
    Error('\P{Jg=_/a/Alaph}');
    Expect(1, 1808, '\p{Jg=:\AAlaph\z:}', "");;
    Expect(0, 1809, '\p{Jg=:\AAlaph\z:}', "");;
    Expect(1, 1808, '\p{Jg=alaph}', "");
    Expect(0, 1808, '\p{^Jg=alaph}', "");
    Expect(0, 1808, '\P{Jg=alaph}', "");
    Expect(1, 1808, '\P{^Jg=alaph}', "");
    Expect(0, 1809, '\p{Jg=alaph}', "");
    Expect(1, 1809, '\p{^Jg=alaph}', "");
    Expect(1, 1809, '\P{Jg=alaph}', "");
    Expect(0, 1809, '\P{^Jg=alaph}', "");
    Expect(1, 1808, '\p{Jg=:\Aalaph\z:}', "");;
    Expect(0, 1809, '\p{Jg=:\Aalaph\z:}', "");;
    Expect(1, 1808, '\p{Jg=__Alaph}', "");
    Expect(0, 1808, '\p{^Jg=__Alaph}', "");
    Expect(0, 1808, '\P{Jg=__Alaph}', "");
    Expect(1, 1808, '\P{^Jg=__Alaph}', "");
    Expect(0, 1809, '\p{Jg=__Alaph}', "");
    Expect(1, 1809, '\p{^Jg=__Alaph}', "");
    Expect(1, 1809, '\P{Jg=__Alaph}', "");
    Expect(0, 1809, '\P{^Jg=__Alaph}', "");
    Error('\p{Is_Joining_Group=  alaph/a/}');
    Error('\P{Is_Joining_Group=  alaph/a/}');
    Expect(1, 1808, '\p{Is_Joining_Group:	alaph}', "");
    Expect(0, 1808, '\p{^Is_Joining_Group:	alaph}', "");
    Expect(0, 1808, '\P{Is_Joining_Group:	alaph}', "");
    Expect(1, 1808, '\P{^Is_Joining_Group:	alaph}', "");
    Expect(0, 1809, '\p{Is_Joining_Group:	alaph}', "");
    Expect(1, 1809, '\p{^Is_Joining_Group:	alaph}', "");
    Expect(1, 1809, '\P{Is_Joining_Group:	alaph}', "");
    Expect(0, 1809, '\P{^Is_Joining_Group:	alaph}', "");
    Expect(1, 1808, '\p{Is_Joining_Group= -Alaph}', "");
    Expect(0, 1808, '\p{^Is_Joining_Group= -Alaph}', "");
    Expect(0, 1808, '\P{Is_Joining_Group= -Alaph}', "");
    Expect(1, 1808, '\P{^Is_Joining_Group= -Alaph}', "");
    Expect(0, 1809, '\p{Is_Joining_Group= -Alaph}', "");
    Expect(1, 1809, '\p{^Is_Joining_Group= -Alaph}', "");
    Expect(1, 1809, '\P{Is_Joining_Group= -Alaph}', "");
    Expect(0, 1809, '\P{^Is_Joining_Group= -Alaph}', "");
    Error('\p{Is_Jg:    /a/ALAPH}');
    Error('\P{Is_Jg:    /a/ALAPH}');
    Expect(1, 1808, '\p{Is_Jg=alaph}', "");
    Expect(0, 1808, '\p{^Is_Jg=alaph}', "");
    Expect(0, 1808, '\P{Is_Jg=alaph}', "");
    Expect(1, 1808, '\P{^Is_Jg=alaph}', "");
    Expect(0, 1809, '\p{Is_Jg=alaph}', "");
    Expect(1, 1809, '\p{^Is_Jg=alaph}', "");
    Expect(1, 1809, '\P{Is_Jg=alaph}', "");
    Expect(0, 1809, '\P{^Is_Jg=alaph}', "");
    Expect(1, 1808, '\p{Is_Jg= _Alaph}', "");
    Expect(0, 1808, '\p{^Is_Jg= _Alaph}', "");
    Expect(0, 1808, '\P{Is_Jg= _Alaph}', "");
    Expect(1, 1808, '\P{^Is_Jg= _Alaph}', "");
    Expect(0, 1809, '\p{Is_Jg= _Alaph}', "");
    Expect(1, 1809, '\p{^Is_Jg= _Alaph}', "");
    Expect(1, 1809, '\P{Is_Jg= _Alaph}', "");
    Expect(0, 1809, '\P{^Is_Jg= _Alaph}', "");
    Error('\p{Joining_Group= Alef/a/}');
    Error('\P{Joining_Group= Alef/a/}');
    Expect(1, 2178, '\p{Joining_Group=:\AAlef\z:}', "");;
    Expect(0, 2179, '\p{Joining_Group=:\AAlef\z:}', "");;
    Expect(1, 2178, '\p{Joining_Group=alef}', "");
    Expect(0, 2178, '\p{^Joining_Group=alef}', "");
    Expect(0, 2178, '\P{Joining_Group=alef}', "");
    Expect(1, 2178, '\P{^Joining_Group=alef}', "");
    Expect(0, 2179, '\p{Joining_Group=alef}', "");
    Expect(1, 2179, '\p{^Joining_Group=alef}', "");
    Expect(1, 2179, '\P{Joining_Group=alef}', "");
    Expect(0, 2179, '\P{^Joining_Group=alef}', "");
    Expect(1, 2178, '\p{Joining_Group=:\Aalef\z:}', "");;
    Expect(0, 2179, '\p{Joining_Group=:\Aalef\z:}', "");;
    Expect(1, 2178, '\p{Joining_Group=-_Alef}', "");
    Expect(0, 2178, '\p{^Joining_Group=-_Alef}', "");
    Expect(0, 2178, '\P{Joining_Group=-_Alef}', "");
    Expect(1, 2178, '\P{^Joining_Group=-_Alef}', "");
    Expect(0, 2179, '\p{Joining_Group=-_Alef}', "");
    Expect(1, 2179, '\p{^Joining_Group=-_Alef}', "");
    Expect(1, 2179, '\P{Joining_Group=-_Alef}', "");
    Expect(0, 2179, '\P{^Joining_Group=-_Alef}', "");
    Error('\p{Jg= :=alef}');
    Error('\P{Jg= :=alef}');
    Expect(1, 2178, '\p{Jg=:\AAlef\z:}', "");;
    Expect(0, 2179, '\p{Jg=:\AAlef\z:}', "");;
    Expect(1, 2178, '\p{Jg=alef}', "");
    Expect(0, 2178, '\p{^Jg=alef}', "");
    Expect(0, 2178, '\P{Jg=alef}', "");
    Expect(1, 2178, '\P{^Jg=alef}', "");
    Expect(0, 2179, '\p{Jg=alef}', "");
    Expect(1, 2179, '\p{^Jg=alef}', "");
    Expect(1, 2179, '\P{Jg=alef}', "");
    Expect(0, 2179, '\P{^Jg=alef}', "");
    Expect(1, 2178, '\p{Jg=:\Aalef\z:}', "");;
    Expect(0, 2179, '\p{Jg=:\Aalef\z:}', "");;
    Expect(1, 2178, '\p{Jg=_	Alef}', "");
    Expect(0, 2178, '\p{^Jg=_	Alef}', "");
    Expect(0, 2178, '\P{Jg=_	Alef}', "");
    Expect(1, 2178, '\P{^Jg=_	Alef}', "");
    Expect(0, 2179, '\p{Jg=_	Alef}', "");
    Expect(1, 2179, '\p{^Jg=_	Alef}', "");
    Expect(1, 2179, '\P{Jg=_	Alef}', "");
    Expect(0, 2179, '\P{^Jg=_	Alef}', "");
    Error('\p{Is_Joining_Group=_:=Alef}');
    Error('\P{Is_Joining_Group=_:=Alef}');
    Expect(1, 2178, '\p{Is_Joining_Group=alef}', "");
    Expect(0, 2178, '\p{^Is_Joining_Group=alef}', "");
    Expect(0, 2178, '\P{Is_Joining_Group=alef}', "");
    Expect(1, 2178, '\P{^Is_Joining_Group=alef}', "");
    Expect(0, 2179, '\p{Is_Joining_Group=alef}', "");
    Expect(1, 2179, '\p{^Is_Joining_Group=alef}', "");
    Expect(1, 2179, '\P{Is_Joining_Group=alef}', "");
    Expect(0, 2179, '\P{^Is_Joining_Group=alef}', "");
    Expect(1, 2178, '\p{Is_Joining_Group=	_Alef}', "");
    Expect(0, 2178, '\p{^Is_Joining_Group=	_Alef}', "");
    Expect(0, 2178, '\P{Is_Joining_Group=	_Alef}', "");
    Expect(1, 2178, '\P{^Is_Joining_Group=	_Alef}', "");
    Expect(0, 2179, '\p{Is_Joining_Group=	_Alef}', "");
    Expect(1, 2179, '\p{^Is_Joining_Group=	_Alef}', "");
    Expect(1, 2179, '\P{Is_Joining_Group=	_Alef}', "");
    Expect(0, 2179, '\P{^Is_Joining_Group=	_Alef}', "");
    Error('\p{Is_Jg:   /a/ Alef}');
    Error('\P{Is_Jg:   /a/ Alef}');
    Expect(1, 2178, '\p{Is_Jg=alef}', "");
    Expect(0, 2178, '\p{^Is_Jg=alef}', "");
    Expect(0, 2178, '\P{Is_Jg=alef}', "");
    Expect(1, 2178, '\P{^Is_Jg=alef}', "");
    Expect(0, 2179, '\p{Is_Jg=alef}', "");
    Expect(1, 2179, '\p{^Is_Jg=alef}', "");
    Expect(1, 2179, '\P{Is_Jg=alef}', "");
    Expect(0, 2179, '\P{^Is_Jg=alef}', "");
    Expect(1, 2178, '\p{Is_Jg= Alef}', "");
    Expect(0, 2178, '\p{^Is_Jg= Alef}', "");
    Expect(0, 2178, '\P{Is_Jg= Alef}', "");
    Expect(1, 2178, '\P{^Is_Jg= Alef}', "");
    Expect(0, 2179, '\p{Is_Jg= Alef}', "");
    Expect(1, 2179, '\p{^Is_Jg= Alef}', "");
    Expect(1, 2179, '\P{Is_Jg= Alef}', "");
    Expect(0, 2179, '\P{^Is_Jg= Alef}', "");
    Error('\p{Joining_Group=/a/ -BEH}');
    Error('\P{Joining_Group=/a/ -BEH}');
    Expect(1, 2240, '\p{Joining_Group=:\ABeh\z:}', "");;
    Expect(0, 2241, '\p{Joining_Group=:\ABeh\z:}', "");;
    Expect(1, 2240, '\p{Joining_Group=beh}', "");
    Expect(0, 2240, '\p{^Joining_Group=beh}', "");
    Expect(0, 2240, '\P{Joining_Group=beh}', "");
    Expect(1, 2240, '\P{^Joining_Group=beh}', "");
    Expect(0, 2241, '\p{Joining_Group=beh}', "");
    Expect(1, 2241, '\p{^Joining_Group=beh}', "");
    Expect(1, 2241, '\P{Joining_Group=beh}', "");
    Expect(0, 2241, '\P{^Joining_Group=beh}', "");
    Expect(1, 2240, '\p{Joining_Group=:\Abeh\z:}', "");;
    Expect(0, 2241, '\p{Joining_Group=:\Abeh\z:}', "");;
    Expect(1, 2240, '\p{Joining_Group= beh}', "");
    Expect(0, 2240, '\p{^Joining_Group= beh}', "");
    Expect(0, 2240, '\P{Joining_Group= beh}', "");
    Expect(1, 2240, '\P{^Joining_Group= beh}', "");
    Expect(0, 2241, '\p{Joining_Group= beh}', "");
    Expect(1, 2241, '\p{^Joining_Group= beh}', "");
    Expect(1, 2241, '\P{Joining_Group= beh}', "");
    Expect(0, 2241, '\P{^Joining_Group= beh}', "");
    Error('\p{Jg=:=__Beh}');
    Error('\P{Jg=:=__Beh}');
    Expect(1, 2240, '\p{Jg=:\ABeh\z:}', "");;
    Expect(0, 2241, '\p{Jg=:\ABeh\z:}', "");;
    Expect(1, 2240, '\p{Jg=beh}', "");
    Expect(0, 2240, '\p{^Jg=beh}', "");
    Expect(0, 2240, '\P{Jg=beh}', "");
    Expect(1, 2240, '\P{^Jg=beh}', "");
    Expect(0, 2241, '\p{Jg=beh}', "");
    Expect(1, 2241, '\p{^Jg=beh}', "");
    Expect(1, 2241, '\P{Jg=beh}', "");
    Expect(0, 2241, '\P{^Jg=beh}', "");
    Expect(1, 2240, '\p{Jg=:\Abeh\z:}', "");;
    Expect(0, 2241, '\p{Jg=:\Abeh\z:}', "");;
    Expect(1, 2240, '\p{Jg=-beh}', "");
    Expect(0, 2240, '\p{^Jg=-beh}', "");
    Expect(0, 2240, '\P{Jg=-beh}', "");
    Expect(1, 2240, '\P{^Jg=-beh}', "");
    Expect(0, 2241, '\p{Jg=-beh}', "");
    Expect(1, 2241, '\p{^Jg=-beh}', "");
    Expect(1, 2241, '\P{Jg=-beh}', "");
    Expect(0, 2241, '\P{^Jg=-beh}', "");
    Error('\p{Is_Joining_Group=/a/	Beh}');
    Error('\P{Is_Joining_Group=/a/	Beh}');
    Expect(1, 2240, '\p{Is_Joining_Group=beh}', "");
    Expect(0, 2240, '\p{^Is_Joining_Group=beh}', "");
    Expect(0, 2240, '\P{Is_Joining_Group=beh}', "");
    Expect(1, 2240, '\P{^Is_Joining_Group=beh}', "");
    Expect(0, 2241, '\p{Is_Joining_Group=beh}', "");
    Expect(1, 2241, '\p{^Is_Joining_Group=beh}', "");
    Expect(1, 2241, '\P{Is_Joining_Group=beh}', "");
    Expect(0, 2241, '\P{^Is_Joining_Group=beh}', "");
    Expect(1, 2240, '\p{Is_Joining_Group:     beh}', "");
    Expect(0, 2240, '\p{^Is_Joining_Group:     beh}', "");
    Expect(0, 2240, '\P{Is_Joining_Group:     beh}', "");
    Expect(1, 2240, '\P{^Is_Joining_Group:     beh}', "");
    Expect(0, 2241, '\p{Is_Joining_Group:     beh}', "");
    Expect(1, 2241, '\p{^Is_Joining_Group:     beh}', "");
    Expect(1, 2241, '\P{Is_Joining_Group:     beh}', "");
    Expect(0, 2241, '\P{^Is_Joining_Group:     beh}', "");
    Error('\p{Is_Jg=/a/Beh}');
    Error('\P{Is_Jg=/a/Beh}');
    Expect(1, 2240, '\p{Is_Jg=beh}', "");
    Expect(0, 2240, '\p{^Is_Jg=beh}', "");
    Expect(0, 2240, '\P{Is_Jg=beh}', "");
    Expect(1, 2240, '\P{^Is_Jg=beh}', "");
    Expect(0, 2241, '\p{Is_Jg=beh}', "");
    Expect(1, 2241, '\p{^Is_Jg=beh}', "");
    Expect(1, 2241, '\P{Is_Jg=beh}', "");
    Expect(0, 2241, '\P{^Is_Jg=beh}', "");
    Expect(1, 2240, '\p{Is_Jg=- Beh}', "");
    Expect(0, 2240, '\p{^Is_Jg=- Beh}', "");
    Expect(0, 2240, '\P{Is_Jg=- Beh}', "");
    Expect(1, 2240, '\P{^Is_Jg=- Beh}', "");
    Expect(0, 2241, '\p{Is_Jg=- Beh}', "");
    Expect(1, 2241, '\p{^Is_Jg=- Beh}', "");
    Expect(1, 2241, '\P{Is_Jg=- Beh}', "");
    Expect(0, 2241, '\P{^Is_Jg=- Beh}', "");
    Error('\p{Joining_Group=:=-_BETH}');
    Error('\P{Joining_Group=:=-_BETH}');
    Expect(1, 1837, '\p{Joining_Group=:\ABeth\z:}', "");;
    Expect(0, 1838, '\p{Joining_Group=:\ABeth\z:}', "");;
    Expect(1, 1837, '\p{Joining_Group=beth}', "");
    Expect(0, 1837, '\p{^Joining_Group=beth}', "");
    Expect(0, 1837, '\P{Joining_Group=beth}', "");
    Expect(1, 1837, '\P{^Joining_Group=beth}', "");
    Expect(0, 1838, '\p{Joining_Group=beth}', "");
    Expect(1, 1838, '\p{^Joining_Group=beth}', "");
    Expect(1, 1838, '\P{Joining_Group=beth}', "");
    Expect(0, 1838, '\P{^Joining_Group=beth}', "");
    Expect(1, 1837, '\p{Joining_Group=:\Abeth\z:}', "");;
    Expect(0, 1838, '\p{Joining_Group=:\Abeth\z:}', "");;
    Error('\p{Jg=-	beth:=}');
    Error('\P{Jg=-	beth:=}');
    Expect(1, 1837, '\p{Jg=:\ABeth\z:}', "");;
    Expect(0, 1838, '\p{Jg=:\ABeth\z:}', "");;
    Expect(1, 1837, '\p{Jg=beth}', "");
    Expect(0, 1837, '\p{^Jg=beth}', "");
    Expect(0, 1837, '\P{Jg=beth}', "");
    Expect(1, 1837, '\P{^Jg=beth}', "");
    Expect(0, 1838, '\p{Jg=beth}', "");
    Expect(1, 1838, '\p{^Jg=beth}', "");
    Expect(1, 1838, '\P{Jg=beth}', "");
    Expect(0, 1838, '\P{^Jg=beth}', "");
    Expect(1, 1837, '\p{Jg=:\Abeth\z:}', "");;
    Expect(0, 1838, '\p{Jg=:\Abeth\z:}', "");;
    Expect(1, 1837, '\p{Jg=_BETH}', "");
    Expect(0, 1837, '\p{^Jg=_BETH}', "");
    Expect(0, 1837, '\P{Jg=_BETH}', "");
    Expect(1, 1837, '\P{^Jg=_BETH}', "");
    Expect(0, 1838, '\p{Jg=_BETH}', "");
    Expect(1, 1838, '\p{^Jg=_BETH}', "");
    Expect(1, 1838, '\P{Jg=_BETH}', "");
    Expect(0, 1838, '\P{^Jg=_BETH}', "");
    Error('\p{Is_Joining_Group=:=	beth}');
    Error('\P{Is_Joining_Group=:=	beth}');
    Expect(1, 1837, '\p{Is_Joining_Group=beth}', "");
    Expect(0, 1837, '\p{^Is_Joining_Group=beth}', "");
    Expect(0, 1837, '\P{Is_Joining_Group=beth}', "");
    Expect(1, 1837, '\P{^Is_Joining_Group=beth}', "");
    Expect(0, 1838, '\p{Is_Joining_Group=beth}', "");
    Expect(1, 1838, '\p{^Is_Joining_Group=beth}', "");
    Expect(1, 1838, '\P{Is_Joining_Group=beth}', "");
    Expect(0, 1838, '\P{^Is_Joining_Group=beth}', "");
    Expect(1, 1837, '\p{Is_Joining_Group= 	Beth}', "");
    Expect(0, 1837, '\p{^Is_Joining_Group= 	Beth}', "");
    Expect(0, 1837, '\P{Is_Joining_Group= 	Beth}', "");
    Expect(1, 1837, '\P{^Is_Joining_Group= 	Beth}', "");
    Expect(0, 1838, '\p{Is_Joining_Group= 	Beth}', "");
    Expect(1, 1838, '\p{^Is_Joining_Group= 	Beth}', "");
    Expect(1, 1838, '\P{Is_Joining_Group= 	Beth}', "");
    Expect(0, 1838, '\P{^Is_Joining_Group= 	Beth}', "");
    Error('\p{Is_Jg=-_Beth:=}');
    Error('\P{Is_Jg=-_Beth:=}');
    Expect(1, 1837, '\p{Is_Jg=beth}', "");
    Expect(0, 1837, '\p{^Is_Jg=beth}', "");
    Expect(0, 1837, '\P{Is_Jg=beth}', "");
    Expect(1, 1837, '\P{^Is_Jg=beth}', "");
    Expect(0, 1838, '\p{Is_Jg=beth}', "");
    Expect(1, 1838, '\p{^Is_Jg=beth}', "");
    Expect(1, 1838, '\P{Is_Jg=beth}', "");
    Expect(0, 1838, '\P{^Is_Jg=beth}', "");
    Expect(1, 1837, '\p{Is_Jg=-beth}', "");
    Expect(0, 1837, '\p{^Is_Jg=-beth}', "");
    Expect(0, 1837, '\P{Is_Jg=-beth}', "");
    Expect(1, 1837, '\P{^Is_Jg=-beth}', "");
    Expect(0, 1838, '\p{Is_Jg=-beth}', "");
    Expect(1, 1838, '\p{^Is_Jg=-beth}', "");
    Expect(1, 1838, '\P{Is_Jg=-beth}', "");
    Expect(0, 1838, '\P{^Is_Jg=-beth}', "");
    Error('\p{Joining_Group:   	:=burushaski_YEH_barree}');
    Error('\P{Joining_Group:   	:=burushaski_YEH_barree}');
    Expect(1, 1915, '\p{Joining_Group=:\ABurushaski_Yeh_Barree\z:}', "");;
    Expect(0, 1916, '\p{Joining_Group=:\ABurushaski_Yeh_Barree\z:}', "");;
    Expect(1, 1915, '\p{Joining_Group: burushaskiyehbarree}', "");
    Expect(0, 1915, '\p{^Joining_Group: burushaskiyehbarree}', "");
    Expect(0, 1915, '\P{Joining_Group: burushaskiyehbarree}', "");
    Expect(1, 1915, '\P{^Joining_Group: burushaskiyehbarree}', "");
    Expect(0, 1916, '\p{Joining_Group: burushaskiyehbarree}', "");
    Expect(1, 1916, '\p{^Joining_Group: burushaskiyehbarree}', "");
    Expect(1, 1916, '\P{Joining_Group: burushaskiyehbarree}', "");
    Expect(0, 1916, '\P{^Joining_Group: burushaskiyehbarree}', "");
    Expect(1, 1915, '\p{Joining_Group=:\Aburushaskiyehbarree\z:}', "");;
    Expect(0, 1916, '\p{Joining_Group=:\Aburushaskiyehbarree\z:}', "");;
    Expect(1, 1915, '\p{Joining_Group= -Burushaski_YEH_Barree}', "");
    Expect(0, 1915, '\p{^Joining_Group= -Burushaski_YEH_Barree}', "");
    Expect(0, 1915, '\P{Joining_Group= -Burushaski_YEH_Barree}', "");
    Expect(1, 1915, '\P{^Joining_Group= -Burushaski_YEH_Barree}', "");
    Expect(0, 1916, '\p{Joining_Group= -Burushaski_YEH_Barree}', "");
    Expect(1, 1916, '\p{^Joining_Group= -Burushaski_YEH_Barree}', "");
    Expect(1, 1916, '\P{Joining_Group= -Burushaski_YEH_Barree}', "");
    Expect(0, 1916, '\P{^Joining_Group= -Burushaski_YEH_Barree}', "");
    Error('\p{Jg=	BURUSHASKI_Yeh_barree/a/}');
    Error('\P{Jg=	BURUSHASKI_Yeh_barree/a/}');
    Expect(1, 1915, '\p{Jg=:\ABurushaski_Yeh_Barree\z:}', "");;
    Expect(0, 1916, '\p{Jg=:\ABurushaski_Yeh_Barree\z:}', "");;
    Expect(1, 1915, '\p{Jg=burushaskiyehbarree}', "");
    Expect(0, 1915, '\p{^Jg=burushaskiyehbarree}', "");
    Expect(0, 1915, '\P{Jg=burushaskiyehbarree}', "");
    Expect(1, 1915, '\P{^Jg=burushaskiyehbarree}', "");
    Expect(0, 1916, '\p{Jg=burushaskiyehbarree}', "");
    Expect(1, 1916, '\p{^Jg=burushaskiyehbarree}', "");
    Expect(1, 1916, '\P{Jg=burushaskiyehbarree}', "");
    Expect(0, 1916, '\P{^Jg=burushaskiyehbarree}', "");
    Expect(1, 1915, '\p{Jg=:\Aburushaskiyehbarree\z:}', "");;
    Expect(0, 1916, '\p{Jg=:\Aburushaskiyehbarree\z:}', "");;
    Expect(1, 1915, '\p{Jg=_-burushaski_Yeh_Barree}', "");
    Expect(0, 1915, '\p{^Jg=_-burushaski_Yeh_Barree}', "");
    Expect(0, 1915, '\P{Jg=_-burushaski_Yeh_Barree}', "");
    Expect(1, 1915, '\P{^Jg=_-burushaski_Yeh_Barree}', "");
    Expect(0, 1916, '\p{Jg=_-burushaski_Yeh_Barree}', "");
    Expect(1, 1916, '\p{^Jg=_-burushaski_Yeh_Barree}', "");
    Expect(1, 1916, '\P{Jg=_-burushaski_Yeh_Barree}', "");
    Expect(0, 1916, '\P{^Jg=_-burushaski_Yeh_Barree}', "");
    Error('\p{Is_Joining_Group= /a/BURUSHASKI_Yeh_Barree}');
    Error('\P{Is_Joining_Group= /a/BURUSHASKI_Yeh_Barree}');
    Expect(1, 1915, '\p{Is_Joining_Group=burushaskiyehbarree}', "");
    Expect(0, 1915, '\p{^Is_Joining_Group=burushaskiyehbarree}', "");
    Expect(0, 1915, '\P{Is_Joining_Group=burushaskiyehbarree}', "");
    Expect(1, 1915, '\P{^Is_Joining_Group=burushaskiyehbarree}', "");
    Expect(0, 1916, '\p{Is_Joining_Group=burushaskiyehbarree}', "");
    Expect(1, 1916, '\p{^Is_Joining_Group=burushaskiyehbarree}', "");
    Expect(1, 1916, '\P{Is_Joining_Group=burushaskiyehbarree}', "");
    Expect(0, 1916, '\P{^Is_Joining_Group=burushaskiyehbarree}', "");
    Expect(1, 1915, '\p{Is_Joining_Group=_-burushaski_YEH_barree}', "");
    Expect(0, 1915, '\p{^Is_Joining_Group=_-burushaski_YEH_barree}', "");
    Expect(0, 1915, '\P{Is_Joining_Group=_-burushaski_YEH_barree}', "");
    Expect(1, 1915, '\P{^Is_Joining_Group=_-burushaski_YEH_barree}', "");
    Expect(0, 1916, '\p{Is_Joining_Group=_-burushaski_YEH_barree}', "");
    Expect(1, 1916, '\p{^Is_Joining_Group=_-burushaski_YEH_barree}', "");
    Expect(1, 1916, '\P{Is_Joining_Group=_-burushaski_YEH_barree}', "");
    Expect(0, 1916, '\P{^Is_Joining_Group=_-burushaski_YEH_barree}', "");
    Error('\p{Is_Jg=/a/	BURUSHASKI_Yeh_barree}');
    Error('\P{Is_Jg=/a/	BURUSHASKI_Yeh_barree}');
    Expect(1, 1915, '\p{Is_Jg=burushaskiyehbarree}', "");
    Expect(0, 1915, '\p{^Is_Jg=burushaskiyehbarree}', "");
    Expect(0, 1915, '\P{Is_Jg=burushaskiyehbarree}', "");
    Expect(1, 1915, '\P{^Is_Jg=burushaskiyehbarree}', "");
    Expect(0, 1916, '\p{Is_Jg=burushaskiyehbarree}', "");
    Expect(1, 1916, '\p{^Is_Jg=burushaskiyehbarree}', "");
    Expect(1, 1916, '\P{Is_Jg=burushaskiyehbarree}', "");
    Expect(0, 1916, '\P{^Is_Jg=burushaskiyehbarree}', "");
    Expect(1, 1915, '\p{Is_Jg= -Burushaski_YEH_Barree}', "");
    Expect(0, 1915, '\p{^Is_Jg= -Burushaski_YEH_Barree}', "");
    Expect(0, 1915, '\P{Is_Jg= -Burushaski_YEH_Barree}', "");
    Expect(1, 1915, '\P{^Is_Jg= -Burushaski_YEH_Barree}', "");
    Expect(0, 1916, '\p{Is_Jg= -Burushaski_YEH_Barree}', "");
    Expect(1, 1916, '\p{^Is_Jg= -Burushaski_YEH_Barree}', "");
    Expect(1, 1916, '\P{Is_Jg= -Burushaski_YEH_Barree}', "");
    Expect(0, 1916, '\P{^Is_Jg= -Burushaski_YEH_Barree}', "");
    Error('\p{Joining_Group=:= -dal}');
    Error('\P{Joining_Group=:= -dal}');
    Expect(1, 2222, '\p{Joining_Group=:\ADal\z:}', "");;
    Expect(0, 2223, '\p{Joining_Group=:\ADal\z:}', "");;
    Expect(1, 2222, '\p{Joining_Group=dal}', "");
    Expect(0, 2222, '\p{^Joining_Group=dal}', "");
    Expect(0, 2222, '\P{Joining_Group=dal}', "");
    Expect(1, 2222, '\P{^Joining_Group=dal}', "");
    Expect(0, 2223, '\p{Joining_Group=dal}', "");
    Expect(1, 2223, '\p{^Joining_Group=dal}', "");
    Expect(1, 2223, '\P{Joining_Group=dal}', "");
    Expect(0, 2223, '\P{^Joining_Group=dal}', "");
    Expect(1, 2222, '\p{Joining_Group=:\Adal\z:}', "");;
    Expect(0, 2223, '\p{Joining_Group=:\Adal\z:}', "");;
    Expect(1, 2222, '\p{Joining_Group=_Dal}', "");
    Expect(0, 2222, '\p{^Joining_Group=_Dal}', "");
    Expect(0, 2222, '\P{Joining_Group=_Dal}', "");
    Expect(1, 2222, '\P{^Joining_Group=_Dal}', "");
    Expect(0, 2223, '\p{Joining_Group=_Dal}', "");
    Expect(1, 2223, '\p{^Joining_Group=_Dal}', "");
    Expect(1, 2223, '\P{Joining_Group=_Dal}', "");
    Expect(0, 2223, '\P{^Joining_Group=_Dal}', "");
    Error('\p{Jg=/a/ _Dal}');
    Error('\P{Jg=/a/ _Dal}');
    Expect(1, 2222, '\p{Jg=:\ADal\z:}', "");;
    Expect(0, 2223, '\p{Jg=:\ADal\z:}', "");;
    Expect(1, 2222, '\p{Jg=dal}', "");
    Expect(0, 2222, '\p{^Jg=dal}', "");
    Expect(0, 2222, '\P{Jg=dal}', "");
    Expect(1, 2222, '\P{^Jg=dal}', "");
    Expect(0, 2223, '\p{Jg=dal}', "");
    Expect(1, 2223, '\p{^Jg=dal}', "");
    Expect(1, 2223, '\P{Jg=dal}', "");
    Expect(0, 2223, '\P{^Jg=dal}', "");
    Expect(1, 2222, '\p{Jg=:\Adal\z:}', "");;
    Expect(0, 2223, '\p{Jg=:\Adal\z:}', "");;
    Expect(1, 2222, '\p{Jg= -dal}', "");
    Expect(0, 2222, '\p{^Jg= -dal}', "");
    Expect(0, 2222, '\P{Jg= -dal}', "");
    Expect(1, 2222, '\P{^Jg= -dal}', "");
    Expect(0, 2223, '\p{Jg= -dal}', "");
    Expect(1, 2223, '\p{^Jg= -dal}', "");
    Expect(1, 2223, '\P{Jg= -dal}', "");
    Expect(0, 2223, '\P{^Jg= -dal}', "");
    Error('\p{Is_Joining_Group=:=	 Dal}');
    Error('\P{Is_Joining_Group=:=	 Dal}');
    Expect(1, 2222, '\p{Is_Joining_Group:   dal}', "");
    Expect(0, 2222, '\p{^Is_Joining_Group:   dal}', "");
    Expect(0, 2222, '\P{Is_Joining_Group:   dal}', "");
    Expect(1, 2222, '\P{^Is_Joining_Group:   dal}', "");
    Expect(0, 2223, '\p{Is_Joining_Group:   dal}', "");
    Expect(1, 2223, '\p{^Is_Joining_Group:   dal}', "");
    Expect(1, 2223, '\P{Is_Joining_Group:   dal}', "");
    Expect(0, 2223, '\P{^Is_Joining_Group:   dal}', "");
    Expect(1, 2222, '\p{Is_Joining_Group= dal}', "");
    Expect(0, 2222, '\p{^Is_Joining_Group= dal}', "");
    Expect(0, 2222, '\P{Is_Joining_Group= dal}', "");
    Expect(1, 2222, '\P{^Is_Joining_Group= dal}', "");
    Expect(0, 2223, '\p{Is_Joining_Group= dal}', "");
    Expect(1, 2223, '\p{^Is_Joining_Group= dal}', "");
    Expect(1, 2223, '\P{Is_Joining_Group= dal}', "");
    Expect(0, 2223, '\P{^Is_Joining_Group= dal}', "");
    Error('\p{Is_Jg=:= dal}');
    Error('\P{Is_Jg=:= dal}');
    Expect(1, 2222, '\p{Is_Jg:dal}', "");
    Expect(0, 2222, '\p{^Is_Jg:dal}', "");
    Expect(0, 2222, '\P{Is_Jg:dal}', "");
    Expect(1, 2222, '\P{^Is_Jg:dal}', "");
    Expect(0, 2223, '\p{Is_Jg:dal}', "");
    Expect(1, 2223, '\p{^Is_Jg:dal}', "");
    Expect(1, 2223, '\P{Is_Jg:dal}', "");
    Expect(0, 2223, '\P{^Is_Jg:dal}', "");
    Expect(1, 2222, '\p{Is_Jg=-	Dal}', "");
    Expect(0, 2222, '\p{^Is_Jg=-	Dal}', "");
    Expect(0, 2222, '\P{Is_Jg=-	Dal}', "");
    Expect(1, 2222, '\P{^Is_Jg=-	Dal}', "");
    Expect(0, 2223, '\p{Is_Jg=-	Dal}', "");
    Expect(1, 2223, '\p{^Is_Jg=-	Dal}', "");
    Expect(1, 2223, '\P{Is_Jg=-	Dal}', "");
    Expect(0, 2223, '\P{^Is_Jg=-	Dal}', "");
    Error('\p{Joining_Group=:=__DALATH_RISH}');
    Error('\P{Joining_Group=:=__DALATH_RISH}');
    Expect(1, 1839, '\p{Joining_Group=:\ADalath_Rish\z:}', "");;
    Expect(0, 1840, '\p{Joining_Group=:\ADalath_Rish\z:}', "");;
    Expect(1, 1839, '\p{Joining_Group:   dalathrish}', "");
    Expect(0, 1839, '\p{^Joining_Group:   dalathrish}', "");
    Expect(0, 1839, '\P{Joining_Group:   dalathrish}', "");
    Expect(1, 1839, '\P{^Joining_Group:   dalathrish}', "");
    Expect(0, 1840, '\p{Joining_Group:   dalathrish}', "");
    Expect(1, 1840, '\p{^Joining_Group:   dalathrish}', "");
    Expect(1, 1840, '\P{Joining_Group:   dalathrish}', "");
    Expect(0, 1840, '\P{^Joining_Group:   dalathrish}', "");
    Expect(1, 1839, '\p{Joining_Group=:\Adalathrish\z:}', "");;
    Expect(0, 1840, '\p{Joining_Group=:\Adalathrish\z:}', "");;
    Expect(1, 1839, '\p{Joining_Group= _dalath_Rish}', "");
    Expect(0, 1839, '\p{^Joining_Group= _dalath_Rish}', "");
    Expect(0, 1839, '\P{Joining_Group= _dalath_Rish}', "");
    Expect(1, 1839, '\P{^Joining_Group= _dalath_Rish}', "");
    Expect(0, 1840, '\p{Joining_Group= _dalath_Rish}', "");
    Expect(1, 1840, '\p{^Joining_Group= _dalath_Rish}', "");
    Expect(1, 1840, '\P{Joining_Group= _dalath_Rish}', "");
    Expect(0, 1840, '\P{^Joining_Group= _dalath_Rish}', "");
    Error('\p{Jg=:= Dalath_RISH}');
    Error('\P{Jg=:= Dalath_RISH}');
    Expect(1, 1839, '\p{Jg=:\ADalath_Rish\z:}', "");;
    Expect(0, 1840, '\p{Jg=:\ADalath_Rish\z:}', "");;
    Expect(1, 1839, '\p{Jg=dalathrish}', "");
    Expect(0, 1839, '\p{^Jg=dalathrish}', "");
    Expect(0, 1839, '\P{Jg=dalathrish}', "");
    Expect(1, 1839, '\P{^Jg=dalathrish}', "");
    Expect(0, 1840, '\p{Jg=dalathrish}', "");
    Expect(1, 1840, '\p{^Jg=dalathrish}', "");
    Expect(1, 1840, '\P{Jg=dalathrish}', "");
    Expect(0, 1840, '\P{^Jg=dalathrish}', "");
    Expect(1, 1839, '\p{Jg=:\Adalathrish\z:}', "");;
    Expect(0, 1840, '\p{Jg=:\Adalathrish\z:}', "");;
    Expect(1, 1839, '\p{Jg:_ DALATH_Rish}', "");
    Expect(0, 1839, '\p{^Jg:_ DALATH_Rish}', "");
    Expect(0, 1839, '\P{Jg:_ DALATH_Rish}', "");
    Expect(1, 1839, '\P{^Jg:_ DALATH_Rish}', "");
    Expect(0, 1840, '\p{Jg:_ DALATH_Rish}', "");
    Expect(1, 1840, '\p{^Jg:_ DALATH_Rish}', "");
    Expect(1, 1840, '\P{Jg:_ DALATH_Rish}', "");
    Expect(0, 1840, '\P{^Jg:_ DALATH_Rish}', "");
    Error('\p{Is_Joining_Group= :=DALATH_rish}');
    Error('\P{Is_Joining_Group= :=DALATH_rish}');
    Expect(1, 1839, '\p{Is_Joining_Group=dalathrish}', "");
    Expect(0, 1839, '\p{^Is_Joining_Group=dalathrish}', "");
    Expect(0, 1839, '\P{Is_Joining_Group=dalathrish}', "");
    Expect(1, 1839, '\P{^Is_Joining_Group=dalathrish}', "");
    Expect(0, 1840, '\p{Is_Joining_Group=dalathrish}', "");
    Expect(1, 1840, '\p{^Is_Joining_Group=dalathrish}', "");
    Expect(1, 1840, '\P{Is_Joining_Group=dalathrish}', "");
    Expect(0, 1840, '\P{^Is_Joining_Group=dalathrish}', "");
    Expect(1, 1839, '\p{Is_Joining_Group=--DALATH_rish}', "");
    Expect(0, 1839, '\p{^Is_Joining_Group=--DALATH_rish}', "");
    Expect(0, 1839, '\P{Is_Joining_Group=--DALATH_rish}', "");
    Expect(1, 1839, '\P{^Is_Joining_Group=--DALATH_rish}', "");
    Expect(0, 1840, '\p{Is_Joining_Group=--DALATH_rish}', "");
    Expect(1, 1840, '\p{^Is_Joining_Group=--DALATH_rish}', "");
    Expect(1, 1840, '\P{Is_Joining_Group=--DALATH_rish}', "");
    Expect(0, 1840, '\P{^Is_Joining_Group=--DALATH_rish}', "");
    Error('\p{Is_Jg=:=  Dalath_Rish}');
    Error('\P{Is_Jg=:=  Dalath_Rish}');
    Expect(1, 1839, '\p{Is_Jg=dalathrish}', "");
    Expect(0, 1839, '\p{^Is_Jg=dalathrish}', "");
    Expect(0, 1839, '\P{Is_Jg=dalathrish}', "");
    Expect(1, 1839, '\P{^Is_Jg=dalathrish}', "");
    Expect(0, 1840, '\p{Is_Jg=dalathrish}', "");
    Expect(1, 1840, '\p{^Is_Jg=dalathrish}', "");
    Expect(1, 1840, '\P{Is_Jg=dalathrish}', "");
    Expect(0, 1840, '\P{^Is_Jg=dalathrish}', "");
    Expect(1, 1839, '\p{Is_Jg=_	dalath_RISH}', "");
    Expect(0, 1839, '\p{^Is_Jg=_	dalath_RISH}', "");
    Expect(0, 1839, '\P{Is_Jg=_	dalath_RISH}', "");
    Expect(1, 1839, '\P{^Is_Jg=_	dalath_RISH}', "");
    Expect(0, 1840, '\p{Is_Jg=_	dalath_RISH}', "");
    Expect(1, 1840, '\p{^Is_Jg=_	dalath_RISH}', "");
    Expect(1, 1840, '\P{Is_Jg=_	dalath_RISH}', "");
    Expect(0, 1840, '\P{^Is_Jg=_	dalath_RISH}', "");
    Error('\p{Joining_Group=- E:=}');
    Error('\P{Joining_Group=- E:=}');
    Expect(1, 1829, '\p{Joining_Group=:\AE\z:}', "");;
    Expect(0, 1830, '\p{Joining_Group=:\AE\z:}', "");;
    Expect(1, 1829, '\p{Joining_Group=e}', "");
    Expect(0, 1829, '\p{^Joining_Group=e}', "");
    Expect(0, 1829, '\P{Joining_Group=e}', "");
    Expect(1, 1829, '\P{^Joining_Group=e}', "");
    Expect(0, 1830, '\p{Joining_Group=e}', "");
    Expect(1, 1830, '\p{^Joining_Group=e}', "");
    Expect(1, 1830, '\P{Joining_Group=e}', "");
    Expect(0, 1830, '\P{^Joining_Group=e}', "");
    Expect(1, 1829, '\p{Joining_Group=:\Ae\z:}', "");;
    Expect(0, 1830, '\p{Joining_Group=:\Ae\z:}', "");;
    Error('\p{Jg:   -_E:=}');
    Error('\P{Jg:   -_E:=}');
    Expect(1, 1829, '\p{Jg=:\AE\z:}', "");;
    Expect(0, 1830, '\p{Jg=:\AE\z:}', "");;
    Expect(1, 1829, '\p{Jg:	e}', "");
    Expect(0, 1829, '\p{^Jg:	e}', "");
    Expect(0, 1829, '\P{Jg:	e}', "");
    Expect(1, 1829, '\P{^Jg:	e}', "");
    Expect(0, 1830, '\p{Jg:	e}', "");
    Expect(1, 1830, '\p{^Jg:	e}', "");
    Expect(1, 1830, '\P{Jg:	e}', "");
    Expect(0, 1830, '\P{^Jg:	e}', "");
    Expect(1, 1829, '\p{Jg=:\Ae\z:}', "");;
    Expect(0, 1830, '\p{Jg=:\Ae\z:}', "");;
    Expect(1, 1829, '\p{Jg: 		E}', "");
    Expect(0, 1829, '\p{^Jg: 		E}', "");
    Expect(0, 1829, '\P{Jg: 		E}', "");
    Expect(1, 1829, '\P{^Jg: 		E}', "");
    Expect(0, 1830, '\p{Jg: 		E}', "");
    Expect(1, 1830, '\p{^Jg: 		E}', "");
    Expect(1, 1830, '\P{Jg: 		E}', "");
    Expect(0, 1830, '\P{^Jg: 		E}', "");
    Error('\p{Is_Joining_Group=:=-e}');
    Error('\P{Is_Joining_Group=:=-e}');
    Expect(1, 1829, '\p{Is_Joining_Group=e}', "");
    Expect(0, 1829, '\p{^Is_Joining_Group=e}', "");
    Expect(0, 1829, '\P{Is_Joining_Group=e}', "");
    Expect(1, 1829, '\P{^Is_Joining_Group=e}', "");
    Expect(0, 1830, '\p{Is_Joining_Group=e}', "");
    Expect(1, 1830, '\p{^Is_Joining_Group=e}', "");
    Expect(1, 1830, '\P{Is_Joining_Group=e}', "");
    Expect(0, 1830, '\P{^Is_Joining_Group=e}', "");
    Expect(1, 1829, '\p{Is_Joining_Group: E}', "");
    Expect(0, 1829, '\p{^Is_Joining_Group: E}', "");
    Expect(0, 1829, '\P{Is_Joining_Group: E}', "");
    Expect(1, 1829, '\P{^Is_Joining_Group: E}', "");
    Expect(0, 1830, '\p{Is_Joining_Group: E}', "");
    Expect(1, 1830, '\p{^Is_Joining_Group: E}', "");
    Expect(1, 1830, '\P{Is_Joining_Group: E}', "");
    Expect(0, 1830, '\P{^Is_Joining_Group: E}', "");
    Error('\p{Is_Jg=/a/_ e}');
    Error('\P{Is_Jg=/a/_ e}');
    Expect(1, 1829, '\p{Is_Jg=e}', "");
    Expect(0, 1829, '\p{^Is_Jg=e}', "");
    Expect(0, 1829, '\P{Is_Jg=e}', "");
    Expect(1, 1829, '\P{^Is_Jg=e}', "");
    Expect(0, 1830, '\p{Is_Jg=e}', "");
    Expect(1, 1830, '\p{^Is_Jg=e}', "");
    Expect(1, 1830, '\P{Is_Jg=e}', "");
    Expect(0, 1830, '\P{^Is_Jg=e}', "");
    Expect(1, 1829, '\p{Is_Jg=-_E}', "");
    Expect(0, 1829, '\p{^Is_Jg=-_E}', "");
    Expect(0, 1829, '\P{Is_Jg=-_E}', "");
    Expect(1, 1829, '\P{^Is_Jg=-_E}', "");
    Expect(0, 1830, '\p{Is_Jg=-_E}', "");
    Expect(1, 1830, '\p{^Is_Jg=-_E}', "");
    Expect(1, 1830, '\P{Is_Jg=-_E}', "");
    Expect(0, 1830, '\P{^Is_Jg=-_E}', "");
    Error('\p{Joining_Group=/a/Farsi_yeh}');
    Error('\P{Joining_Group=/a/Farsi_yeh}');
    Expect(1, 1910, '\p{Joining_Group=:\AFarsi_Yeh\z:}', "");;
    Expect(0, 1911, '\p{Joining_Group=:\AFarsi_Yeh\z:}', "");;
    Expect(1, 1910, '\p{Joining_Group=farsiyeh}', "");
    Expect(0, 1910, '\p{^Joining_Group=farsiyeh}', "");
    Expect(0, 1910, '\P{Joining_Group=farsiyeh}', "");
    Expect(1, 1910, '\P{^Joining_Group=farsiyeh}', "");
    Expect(0, 1911, '\p{Joining_Group=farsiyeh}', "");
    Expect(1, 1911, '\p{^Joining_Group=farsiyeh}', "");
    Expect(1, 1911, '\P{Joining_Group=farsiyeh}', "");
    Expect(0, 1911, '\P{^Joining_Group=farsiyeh}', "");
    Expect(1, 1910, '\p{Joining_Group=:\Afarsiyeh\z:}', "");;
    Expect(0, 1911, '\p{Joining_Group=:\Afarsiyeh\z:}', "");;
    Expect(1, 1910, '\p{Joining_Group=_-Farsi_Yeh}', "");
    Expect(0, 1910, '\p{^Joining_Group=_-Farsi_Yeh}', "");
    Expect(0, 1910, '\P{Joining_Group=_-Farsi_Yeh}', "");
    Expect(1, 1910, '\P{^Joining_Group=_-Farsi_Yeh}', "");
    Expect(0, 1911, '\p{Joining_Group=_-Farsi_Yeh}', "");
    Expect(1, 1911, '\p{^Joining_Group=_-Farsi_Yeh}', "");
    Expect(1, 1911, '\P{Joining_Group=_-Farsi_Yeh}', "");
    Expect(0, 1911, '\P{^Joining_Group=_-Farsi_Yeh}', "");
    Error('\p{Jg:   /a/- farsi_YEH}');
    Error('\P{Jg:   /a/- farsi_YEH}');
    Expect(1, 1910, '\p{Jg=:\AFarsi_Yeh\z:}', "");;
    Expect(0, 1911, '\p{Jg=:\AFarsi_Yeh\z:}', "");;
    Expect(1, 1910, '\p{Jg=farsiyeh}', "");
    Expect(0, 1910, '\p{^Jg=farsiyeh}', "");
    Expect(0, 1910, '\P{Jg=farsiyeh}', "");
    Expect(1, 1910, '\P{^Jg=farsiyeh}', "");
    Expect(0, 1911, '\p{Jg=farsiyeh}', "");
    Expect(1, 1911, '\p{^Jg=farsiyeh}', "");
    Expect(1, 1911, '\P{Jg=farsiyeh}', "");
    Expect(0, 1911, '\P{^Jg=farsiyeh}', "");
    Expect(1, 1910, '\p{Jg=:\Afarsiyeh\z:}', "");;
    Expect(0, 1911, '\p{Jg=:\Afarsiyeh\z:}', "");;
    Expect(1, 1910, '\p{Jg:   _Farsi_Yeh}', "");
    Expect(0, 1910, '\p{^Jg:   _Farsi_Yeh}', "");
    Expect(0, 1910, '\P{Jg:   _Farsi_Yeh}', "");
    Expect(1, 1910, '\P{^Jg:   _Farsi_Yeh}', "");
    Expect(0, 1911, '\p{Jg:   _Farsi_Yeh}', "");
    Expect(1, 1911, '\p{^Jg:   _Farsi_Yeh}', "");
    Expect(1, 1911, '\P{Jg:   _Farsi_Yeh}', "");
    Expect(0, 1911, '\P{^Jg:   _Farsi_Yeh}', "");
    Error('\p{Is_Joining_Group=Farsi_yeh/a/}');
    Error('\P{Is_Joining_Group=Farsi_yeh/a/}');
    Expect(1, 1910, '\p{Is_Joining_Group=farsiyeh}', "");
    Expect(0, 1910, '\p{^Is_Joining_Group=farsiyeh}', "");
    Expect(0, 1910, '\P{Is_Joining_Group=farsiyeh}', "");
    Expect(1, 1910, '\P{^Is_Joining_Group=farsiyeh}', "");
    Expect(0, 1911, '\p{Is_Joining_Group=farsiyeh}', "");
    Expect(1, 1911, '\p{^Is_Joining_Group=farsiyeh}', "");
    Expect(1, 1911, '\P{Is_Joining_Group=farsiyeh}', "");
    Expect(0, 1911, '\P{^Is_Joining_Group=farsiyeh}', "");
    Expect(1, 1910, '\p{Is_Joining_Group=-	FARSI_YEH}', "");
    Expect(0, 1910, '\p{^Is_Joining_Group=-	FARSI_YEH}', "");
    Expect(0, 1910, '\P{Is_Joining_Group=-	FARSI_YEH}', "");
    Expect(1, 1910, '\P{^Is_Joining_Group=-	FARSI_YEH}', "");
    Expect(0, 1911, '\p{Is_Joining_Group=-	FARSI_YEH}', "");
    Expect(1, 1911, '\p{^Is_Joining_Group=-	FARSI_YEH}', "");
    Expect(1, 1911, '\P{Is_Joining_Group=-	FARSI_YEH}', "");
    Expect(0, 1911, '\P{^Is_Joining_Group=-	FARSI_YEH}', "");
    Error('\p{Is_Jg= /a/farsi_yeh}');
    Error('\P{Is_Jg= /a/farsi_yeh}');
    Expect(1, 1910, '\p{Is_Jg=farsiyeh}', "");
    Expect(0, 1910, '\p{^Is_Jg=farsiyeh}', "");
    Expect(0, 1910, '\P{Is_Jg=farsiyeh}', "");
    Expect(1, 1910, '\P{^Is_Jg=farsiyeh}', "");
    Expect(0, 1911, '\p{Is_Jg=farsiyeh}', "");
    Expect(1, 1911, '\p{^Is_Jg=farsiyeh}', "");
    Expect(1, 1911, '\P{Is_Jg=farsiyeh}', "");
    Expect(0, 1911, '\P{^Is_Jg=farsiyeh}', "");
    Expect(1, 1910, '\p{Is_Jg=_-Farsi_Yeh}', "");
    Expect(0, 1910, '\p{^Is_Jg=_-Farsi_Yeh}', "");
    Expect(0, 1910, '\P{Is_Jg=_-Farsi_Yeh}', "");
    Expect(1, 1910, '\P{^Is_Jg=_-Farsi_Yeh}', "");
    Expect(0, 1911, '\p{Is_Jg=_-Farsi_Yeh}', "");
    Expect(1, 1911, '\p{^Is_Jg=_-Farsi_Yeh}', "");
    Expect(1, 1911, '\P{Is_Jg=_-Farsi_Yeh}', "");
    Expect(0, 1911, '\P{^Is_Jg=_-Farsi_Yeh}', "");
    Error('\p{Joining_Group=:=-Fe}');
    Error('\P{Joining_Group=:=-Fe}');
    Expect(1, 1871, '\p{Joining_Group=:\AFe\z:}', "");;
    Expect(0, 1872, '\p{Joining_Group=:\AFe\z:}', "");;
    Expect(1, 1871, '\p{Joining_Group=fe}', "");
    Expect(0, 1871, '\p{^Joining_Group=fe}', "");
    Expect(0, 1871, '\P{Joining_Group=fe}', "");
    Expect(1, 1871, '\P{^Joining_Group=fe}', "");
    Expect(0, 1872, '\p{Joining_Group=fe}', "");
    Expect(1, 1872, '\p{^Joining_Group=fe}', "");
    Expect(1, 1872, '\P{Joining_Group=fe}', "");
    Expect(0, 1872, '\P{^Joining_Group=fe}', "");
    Expect(1, 1871, '\p{Joining_Group=:\Afe\z:}', "");;
    Expect(0, 1872, '\p{Joining_Group=:\Afe\z:}', "");;
    Expect(1, 1871, '\p{Joining_Group: _ Fe}', "");
    Expect(0, 1871, '\p{^Joining_Group: _ Fe}', "");
    Expect(0, 1871, '\P{Joining_Group: _ Fe}', "");
    Expect(1, 1871, '\P{^Joining_Group: _ Fe}', "");
    Expect(0, 1872, '\p{Joining_Group: _ Fe}', "");
    Expect(1, 1872, '\p{^Joining_Group: _ Fe}', "");
    Expect(1, 1872, '\P{Joining_Group: _ Fe}', "");
    Expect(0, 1872, '\P{^Joining_Group: _ Fe}', "");
    Error('\p{Jg:	-/a/Fe}');
    Error('\P{Jg:	-/a/Fe}');
    Expect(1, 1871, '\p{Jg=:\AFe\z:}', "");;
    Expect(0, 1872, '\p{Jg=:\AFe\z:}', "");;
    Expect(1, 1871, '\p{Jg=fe}', "");
    Expect(0, 1871, '\p{^Jg=fe}', "");
    Expect(0, 1871, '\P{Jg=fe}', "");
    Expect(1, 1871, '\P{^Jg=fe}', "");
    Expect(0, 1872, '\p{Jg=fe}', "");
    Expect(1, 1872, '\p{^Jg=fe}', "");
    Expect(1, 1872, '\P{Jg=fe}', "");
    Expect(0, 1872, '\P{^Jg=fe}', "");
    Expect(1, 1871, '\p{Jg=:\Afe\z:}', "");;
    Expect(0, 1872, '\p{Jg=:\Afe\z:}', "");;
    Expect(1, 1871, '\p{Jg=	_FE}', "");
    Expect(0, 1871, '\p{^Jg=	_FE}', "");
    Expect(0, 1871, '\P{Jg=	_FE}', "");
    Expect(1, 1871, '\P{^Jg=	_FE}', "");
    Expect(0, 1872, '\p{Jg=	_FE}', "");
    Expect(1, 1872, '\p{^Jg=	_FE}', "");
    Expect(1, 1872, '\P{Jg=	_FE}', "");
    Expect(0, 1872, '\P{^Jg=	_FE}', "");
    Error('\p{Is_Joining_Group: :=	Fe}');
    Error('\P{Is_Joining_Group: :=	Fe}');
    Expect(1, 1871, '\p{Is_Joining_Group=fe}', "");
    Expect(0, 1871, '\p{^Is_Joining_Group=fe}', "");
    Expect(0, 1871, '\P{Is_Joining_Group=fe}', "");
    Expect(1, 1871, '\P{^Is_Joining_Group=fe}', "");
    Expect(0, 1872, '\p{Is_Joining_Group=fe}', "");
    Expect(1, 1872, '\p{^Is_Joining_Group=fe}', "");
    Expect(1, 1872, '\P{Is_Joining_Group=fe}', "");
    Expect(0, 1872, '\P{^Is_Joining_Group=fe}', "");
    Expect(1, 1871, '\p{Is_Joining_Group=_-fe}', "");
    Expect(0, 1871, '\p{^Is_Joining_Group=_-fe}', "");
    Expect(0, 1871, '\P{Is_Joining_Group=_-fe}', "");
    Expect(1, 1871, '\P{^Is_Joining_Group=_-fe}', "");
    Expect(0, 1872, '\p{Is_Joining_Group=_-fe}', "");
    Expect(1, 1872, '\p{^Is_Joining_Group=_-fe}', "");
    Expect(1, 1872, '\P{Is_Joining_Group=_-fe}', "");
    Expect(0, 1872, '\P{^Is_Joining_Group=_-fe}', "");
    Error('\p{Is_Jg=:= 	fe}');
    Error('\P{Is_Jg=:= 	fe}');
    Expect(1, 1871, '\p{Is_Jg=fe}', "");
    Expect(0, 1871, '\p{^Is_Jg=fe}', "");
    Expect(0, 1871, '\P{Is_Jg=fe}', "");
    Expect(1, 1871, '\P{^Is_Jg=fe}', "");
    Expect(0, 1872, '\p{Is_Jg=fe}', "");
    Expect(1, 1872, '\p{^Is_Jg=fe}', "");
    Expect(1, 1872, '\P{Is_Jg=fe}', "");
    Expect(0, 1872, '\P{^Is_Jg=fe}', "");
    Expect(1, 1871, '\p{Is_Jg=_	FE}', "");
    Expect(0, 1871, '\p{^Is_Jg=_	FE}', "");
    Expect(0, 1871, '\P{Is_Jg=_	FE}', "");
    Expect(1, 1871, '\P{^Is_Jg=_	FE}', "");
    Expect(0, 1872, '\p{Is_Jg=_	FE}', "");
    Expect(1, 1872, '\p{^Is_Jg=_	FE}', "");
    Expect(1, 1872, '\P{Is_Jg=_	FE}', "");
    Expect(0, 1872, '\P{^Is_Jg=_	FE}', "");
    Error('\p{Joining_Group: -FEH:=}');
    Error('\P{Joining_Group: -FEH:=}');
    Expect(1, 2212, '\p{Joining_Group=:\AFeh\z:}', "");;
    Expect(0, 2213, '\p{Joining_Group=:\AFeh\z:}', "");;
    Expect(1, 2212, '\p{Joining_Group=feh}', "");
    Expect(0, 2212, '\p{^Joining_Group=feh}', "");
    Expect(0, 2212, '\P{Joining_Group=feh}', "");
    Expect(1, 2212, '\P{^Joining_Group=feh}', "");
    Expect(0, 2213, '\p{Joining_Group=feh}', "");
    Expect(1, 2213, '\p{^Joining_Group=feh}', "");
    Expect(1, 2213, '\P{Joining_Group=feh}', "");
    Expect(0, 2213, '\P{^Joining_Group=feh}', "");
    Expect(1, 2212, '\p{Joining_Group=:\Afeh\z:}', "");;
    Expect(0, 2213, '\p{Joining_Group=:\Afeh\z:}', "");;
    Expect(1, 2212, '\p{Joining_Group=  Feh}', "");
    Expect(0, 2212, '\p{^Joining_Group=  Feh}', "");
    Expect(0, 2212, '\P{Joining_Group=  Feh}', "");
    Expect(1, 2212, '\P{^Joining_Group=  Feh}', "");
    Expect(0, 2213, '\p{Joining_Group=  Feh}', "");
    Expect(1, 2213, '\p{^Joining_Group=  Feh}', "");
    Expect(1, 2213, '\P{Joining_Group=  Feh}', "");
    Expect(0, 2213, '\P{^Joining_Group=  Feh}', "");
    Error('\p{Jg=_:=feh}');
    Error('\P{Jg=_:=feh}');
    Expect(1, 2212, '\p{Jg=:\AFeh\z:}', "");;
    Expect(0, 2213, '\p{Jg=:\AFeh\z:}', "");;
    Expect(1, 2212, '\p{Jg:   feh}', "");
    Expect(0, 2212, '\p{^Jg:   feh}', "");
    Expect(0, 2212, '\P{Jg:   feh}', "");
    Expect(1, 2212, '\P{^Jg:   feh}', "");
    Expect(0, 2213, '\p{Jg:   feh}', "");
    Expect(1, 2213, '\p{^Jg:   feh}', "");
    Expect(1, 2213, '\P{Jg:   feh}', "");
    Expect(0, 2213, '\P{^Jg:   feh}', "");
    Expect(1, 2212, '\p{Jg=:\Afeh\z:}', "");;
    Expect(0, 2213, '\p{Jg=:\Afeh\z:}', "");;
    Expect(1, 2212, '\p{Jg= _Feh}', "");
    Expect(0, 2212, '\p{^Jg= _Feh}', "");
    Expect(0, 2212, '\P{Jg= _Feh}', "");
    Expect(1, 2212, '\P{^Jg= _Feh}', "");
    Expect(0, 2213, '\p{Jg= _Feh}', "");
    Expect(1, 2213, '\p{^Jg= _Feh}', "");
    Expect(1, 2213, '\P{Jg= _Feh}', "");
    Expect(0, 2213, '\P{^Jg= _Feh}', "");
    Error('\p{Is_Joining_Group=/a/-	FEH}');
    Error('\P{Is_Joining_Group=/a/-	FEH}');
    Expect(1, 2212, '\p{Is_Joining_Group=feh}', "");
    Expect(0, 2212, '\p{^Is_Joining_Group=feh}', "");
    Expect(0, 2212, '\P{Is_Joining_Group=feh}', "");
    Expect(1, 2212, '\P{^Is_Joining_Group=feh}', "");
    Expect(0, 2213, '\p{Is_Joining_Group=feh}', "");
    Expect(1, 2213, '\p{^Is_Joining_Group=feh}', "");
    Expect(1, 2213, '\P{Is_Joining_Group=feh}', "");
    Expect(0, 2213, '\P{^Is_Joining_Group=feh}', "");
    Expect(1, 2212, '\p{Is_Joining_Group=	-Feh}', "");
    Expect(0, 2212, '\p{^Is_Joining_Group=	-Feh}', "");
    Expect(0, 2212, '\P{Is_Joining_Group=	-Feh}', "");
    Expect(1, 2212, '\P{^Is_Joining_Group=	-Feh}', "");
    Expect(0, 2213, '\p{Is_Joining_Group=	-Feh}', "");
    Expect(1, 2213, '\p{^Is_Joining_Group=	-Feh}', "");
    Expect(1, 2213, '\P{Is_Joining_Group=	-Feh}', "");
    Expect(0, 2213, '\P{^Is_Joining_Group=	-Feh}', "");
    Error('\p{Is_Jg=_Feh:=}');
    Error('\P{Is_Jg=_Feh:=}');
    Expect(1, 2212, '\p{Is_Jg=feh}', "");
    Expect(0, 2212, '\p{^Is_Jg=feh}', "");
    Expect(0, 2212, '\P{Is_Jg=feh}', "");
    Expect(1, 2212, '\P{^Is_Jg=feh}', "");
    Expect(0, 2213, '\p{Is_Jg=feh}', "");
    Expect(1, 2213, '\p{^Is_Jg=feh}', "");
    Expect(1, 2213, '\P{Is_Jg=feh}', "");
    Expect(0, 2213, '\P{^Is_Jg=feh}', "");
    Expect(1, 2212, '\p{Is_Jg:- feh}', "");
    Expect(0, 2212, '\p{^Is_Jg:- feh}', "");
    Expect(0, 2212, '\P{Is_Jg:- feh}', "");
    Expect(1, 2212, '\P{^Is_Jg:- feh}', "");
    Expect(0, 2213, '\p{Is_Jg:- feh}', "");
    Expect(1, 2213, '\p{^Is_Jg:- feh}', "");
    Expect(1, 2213, '\P{Is_Jg:- feh}', "");
    Expect(0, 2213, '\P{^Is_Jg:- feh}', "");
    Error('\p{Joining_Group=_:=Final_Semkath}');
    Error('\P{Joining_Group=_:=Final_Semkath}');
    Expect(1, 1828, '\p{Joining_Group=:\AFinal_Semkath\z:}', "");;
    Expect(0, 1829, '\p{Joining_Group=:\AFinal_Semkath\z:}', "");;
    Expect(1, 1828, '\p{Joining_Group:finalsemkath}', "");
    Expect(0, 1828, '\p{^Joining_Group:finalsemkath}', "");
    Expect(0, 1828, '\P{Joining_Group:finalsemkath}', "");
    Expect(1, 1828, '\P{^Joining_Group:finalsemkath}', "");
    Expect(0, 1829, '\p{Joining_Group:finalsemkath}', "");
    Expect(1, 1829, '\p{^Joining_Group:finalsemkath}', "");
    Expect(1, 1829, '\P{Joining_Group:finalsemkath}', "");
    Expect(0, 1829, '\P{^Joining_Group:finalsemkath}', "");
    Expect(1, 1828, '\p{Joining_Group=:\Afinalsemkath\z:}', "");;
    Expect(0, 1829, '\p{Joining_Group=:\Afinalsemkath\z:}', "");;
    Expect(1, 1828, '\p{Joining_Group=_ FINAL_Semkath}', "");
    Expect(0, 1828, '\p{^Joining_Group=_ FINAL_Semkath}', "");
    Expect(0, 1828, '\P{Joining_Group=_ FINAL_Semkath}', "");
    Expect(1, 1828, '\P{^Joining_Group=_ FINAL_Semkath}', "");
    Expect(0, 1829, '\p{Joining_Group=_ FINAL_Semkath}', "");
    Expect(1, 1829, '\p{^Joining_Group=_ FINAL_Semkath}', "");
    Expect(1, 1829, '\P{Joining_Group=_ FINAL_Semkath}', "");
    Expect(0, 1829, '\P{^Joining_Group=_ FINAL_Semkath}', "");
    Error('\p{Jg=	 Final_semkath:=}');
    Error('\P{Jg=	 Final_semkath:=}');
    Expect(1, 1828, '\p{Jg=:\AFinal_Semkath\z:}', "");;
    Expect(0, 1829, '\p{Jg=:\AFinal_Semkath\z:}', "");;
    Expect(1, 1828, '\p{Jg=finalsemkath}', "");
    Expect(0, 1828, '\p{^Jg=finalsemkath}', "");
    Expect(0, 1828, '\P{Jg=finalsemkath}', "");
    Expect(1, 1828, '\P{^Jg=finalsemkath}', "");
    Expect(0, 1829, '\p{Jg=finalsemkath}', "");
    Expect(1, 1829, '\p{^Jg=finalsemkath}', "");
    Expect(1, 1829, '\P{Jg=finalsemkath}', "");
    Expect(0, 1829, '\P{^Jg=finalsemkath}', "");
    Expect(1, 1828, '\p{Jg=:\Afinalsemkath\z:}', "");;
    Expect(0, 1829, '\p{Jg=:\Afinalsemkath\z:}', "");;
    Expect(1, 1828, '\p{Jg=_FINAL_SEMKATH}', "");
    Expect(0, 1828, '\p{^Jg=_FINAL_SEMKATH}', "");
    Expect(0, 1828, '\P{Jg=_FINAL_SEMKATH}', "");
    Expect(1, 1828, '\P{^Jg=_FINAL_SEMKATH}', "");
    Expect(0, 1829, '\p{Jg=_FINAL_SEMKATH}', "");
    Expect(1, 1829, '\p{^Jg=_FINAL_SEMKATH}', "");
    Expect(1, 1829, '\P{Jg=_FINAL_SEMKATH}', "");
    Expect(0, 1829, '\P{^Jg=_FINAL_SEMKATH}', "");
    Error('\p{Is_Joining_Group=  FINAL_Semkath:=}');
    Error('\P{Is_Joining_Group=  FINAL_Semkath:=}');
    Expect(1, 1828, '\p{Is_Joining_Group=finalsemkath}', "");
    Expect(0, 1828, '\p{^Is_Joining_Group=finalsemkath}', "");
    Expect(0, 1828, '\P{Is_Joining_Group=finalsemkath}', "");
    Expect(1, 1828, '\P{^Is_Joining_Group=finalsemkath}', "");
    Expect(0, 1829, '\p{Is_Joining_Group=finalsemkath}', "");
    Expect(1, 1829, '\p{^Is_Joining_Group=finalsemkath}', "");
    Expect(1, 1829, '\P{Is_Joining_Group=finalsemkath}', "");
    Expect(0, 1829, '\P{^Is_Joining_Group=finalsemkath}', "");
    Expect(1, 1828, '\p{Is_Joining_Group: _Final_Semkath}', "");
    Expect(0, 1828, '\p{^Is_Joining_Group: _Final_Semkath}', "");
    Expect(0, 1828, '\P{Is_Joining_Group: _Final_Semkath}', "");
    Expect(1, 1828, '\P{^Is_Joining_Group: _Final_Semkath}', "");
    Expect(0, 1829, '\p{Is_Joining_Group: _Final_Semkath}', "");
    Expect(1, 1829, '\p{^Is_Joining_Group: _Final_Semkath}', "");
    Expect(1, 1829, '\P{Is_Joining_Group: _Final_Semkath}', "");
    Expect(0, 1829, '\P{^Is_Joining_Group: _Final_Semkath}', "");
    Error('\p{Is_Jg=_-FINAL_Semkath:=}');
    Error('\P{Is_Jg=_-FINAL_Semkath:=}');
    Expect(1, 1828, '\p{Is_Jg=finalsemkath}', "");
    Expect(0, 1828, '\p{^Is_Jg=finalsemkath}', "");
    Expect(0, 1828, '\P{Is_Jg=finalsemkath}', "");
    Expect(1, 1828, '\P{^Is_Jg=finalsemkath}', "");
    Expect(0, 1829, '\p{Is_Jg=finalsemkath}', "");
    Expect(1, 1829, '\p{^Is_Jg=finalsemkath}', "");
    Expect(1, 1829, '\P{Is_Jg=finalsemkath}', "");
    Expect(0, 1829, '\P{^Is_Jg=finalsemkath}', "");
    Expect(1, 1828, '\p{Is_Jg=	FINAL_Semkath}', "");
    Expect(0, 1828, '\p{^Is_Jg=	FINAL_Semkath}', "");
    Expect(0, 1828, '\P{Is_Jg=	FINAL_Semkath}', "");
    Expect(1, 1828, '\P{^Is_Jg=	FINAL_Semkath}', "");
    Expect(0, 1829, '\p{Is_Jg=	FINAL_Semkath}', "");
    Expect(1, 1829, '\p{^Is_Jg=	FINAL_Semkath}', "");
    Expect(1, 1829, '\P{Is_Jg=	FINAL_Semkath}', "");
    Expect(0, 1829, '\P{^Is_Jg=	FINAL_Semkath}', "");
    Error('\p{Joining_Group=_GAF/a/}');
    Error('\P{Joining_Group=_GAF/a/}');
    Expect(1, 2248, '\p{Joining_Group=:\AGaf\z:}', "");;
    Expect(0, 2249, '\p{Joining_Group=:\AGaf\z:}', "");;
    Expect(1, 2248, '\p{Joining_Group=gaf}', "");
    Expect(0, 2248, '\p{^Joining_Group=gaf}', "");
    Expect(0, 2248, '\P{Joining_Group=gaf}', "");
    Expect(1, 2248, '\P{^Joining_Group=gaf}', "");
    Expect(0, 2249, '\p{Joining_Group=gaf}', "");
    Expect(1, 2249, '\p{^Joining_Group=gaf}', "");
    Expect(1, 2249, '\P{Joining_Group=gaf}', "");
    Expect(0, 2249, '\P{^Joining_Group=gaf}', "");
    Expect(1, 2248, '\p{Joining_Group=:\Agaf\z:}', "");;
    Expect(0, 2249, '\p{Joining_Group=:\Agaf\z:}', "");;
    Expect(1, 2248, '\p{Joining_Group=-Gaf}', "");
    Expect(0, 2248, '\p{^Joining_Group=-Gaf}', "");
    Expect(0, 2248, '\P{Joining_Group=-Gaf}', "");
    Expect(1, 2248, '\P{^Joining_Group=-Gaf}', "");
    Expect(0, 2249, '\p{Joining_Group=-Gaf}', "");
    Expect(1, 2249, '\p{^Joining_Group=-Gaf}', "");
    Expect(1, 2249, '\P{Joining_Group=-Gaf}', "");
    Expect(0, 2249, '\P{^Joining_Group=-Gaf}', "");
    Error('\p{Jg=_:=Gaf}');
    Error('\P{Jg=_:=Gaf}');
    Expect(1, 2248, '\p{Jg=:\AGaf\z:}', "");;
    Expect(0, 2249, '\p{Jg=:\AGaf\z:}', "");;
    Expect(1, 2248, '\p{Jg=gaf}', "");
    Expect(0, 2248, '\p{^Jg=gaf}', "");
    Expect(0, 2248, '\P{Jg=gaf}', "");
    Expect(1, 2248, '\P{^Jg=gaf}', "");
    Expect(0, 2249, '\p{Jg=gaf}', "");
    Expect(1, 2249, '\p{^Jg=gaf}', "");
    Expect(1, 2249, '\P{Jg=gaf}', "");
    Expect(0, 2249, '\P{^Jg=gaf}', "");
    Expect(1, 2248, '\p{Jg=:\Agaf\z:}', "");;
    Expect(0, 2249, '\p{Jg=:\Agaf\z:}', "");;
    Error('\p{Is_Joining_Group=	_gaf:=}');
    Error('\P{Is_Joining_Group=	_gaf:=}');
    Expect(1, 2248, '\p{Is_Joining_Group=gaf}', "");
    Expect(0, 2248, '\p{^Is_Joining_Group=gaf}', "");
    Expect(0, 2248, '\P{Is_Joining_Group=gaf}', "");
    Expect(1, 2248, '\P{^Is_Joining_Group=gaf}', "");
    Expect(0, 2249, '\p{Is_Joining_Group=gaf}', "");
    Expect(1, 2249, '\p{^Is_Joining_Group=gaf}', "");
    Expect(1, 2249, '\P{Is_Joining_Group=gaf}', "");
    Expect(0, 2249, '\P{^Is_Joining_Group=gaf}', "");
    Expect(1, 2248, '\p{Is_Joining_Group= Gaf}', "");
    Expect(0, 2248, '\p{^Is_Joining_Group= Gaf}', "");
    Expect(0, 2248, '\P{Is_Joining_Group= Gaf}', "");
    Expect(1, 2248, '\P{^Is_Joining_Group= Gaf}', "");
    Expect(0, 2249, '\p{Is_Joining_Group= Gaf}', "");
    Expect(1, 2249, '\p{^Is_Joining_Group= Gaf}', "");
    Expect(1, 2249, '\P{Is_Joining_Group= Gaf}', "");
    Expect(0, 2249, '\P{^Is_Joining_Group= Gaf}', "");
    Error('\p{Is_Jg=	 Gaf:=}');
    Error('\P{Is_Jg=	 Gaf:=}');
    Expect(1, 2248, '\p{Is_Jg=gaf}', "");
    Expect(0, 2248, '\p{^Is_Jg=gaf}', "");
    Expect(0, 2248, '\P{Is_Jg=gaf}', "");
    Expect(1, 2248, '\P{^Is_Jg=gaf}', "");
    Expect(0, 2249, '\p{Is_Jg=gaf}', "");
    Expect(1, 2249, '\p{^Is_Jg=gaf}', "");
    Expect(1, 2249, '\P{Is_Jg=gaf}', "");
    Expect(0, 2249, '\P{^Is_Jg=gaf}', "");
    Expect(1, 2248, '\p{Is_Jg=	-GAF}', "");
    Expect(0, 2248, '\p{^Is_Jg=	-GAF}', "");
    Expect(0, 2248, '\P{Is_Jg=	-GAF}', "");
    Expect(1, 2248, '\P{^Is_Jg=	-GAF}', "");
    Expect(0, 2249, '\p{Is_Jg=	-GAF}', "");
    Expect(1, 2249, '\p{^Is_Jg=	-GAF}', "");
    Expect(1, 2249, '\P{Is_Jg=	-GAF}', "");
    Expect(0, 2249, '\P{^Is_Jg=	-GAF}', "");
    Error('\p{Joining_Group=GAMAL:=}');
    Error('\P{Joining_Group=GAMAL:=}');
    Expect(1, 1838, '\p{Joining_Group=:\AGamal\z:}', "");;
    Expect(0, 1839, '\p{Joining_Group=:\AGamal\z:}', "");;
    Expect(1, 1838, '\p{Joining_Group=gamal}', "");
    Expect(0, 1838, '\p{^Joining_Group=gamal}', "");
    Expect(0, 1838, '\P{Joining_Group=gamal}', "");
    Expect(1, 1838, '\P{^Joining_Group=gamal}', "");
    Expect(0, 1839, '\p{Joining_Group=gamal}', "");
    Expect(1, 1839, '\p{^Joining_Group=gamal}', "");
    Expect(1, 1839, '\P{Joining_Group=gamal}', "");
    Expect(0, 1839, '\P{^Joining_Group=gamal}', "");
    Expect(1, 1838, '\p{Joining_Group=:\Agamal\z:}', "");;
    Expect(0, 1839, '\p{Joining_Group=:\Agamal\z:}', "");;
    Expect(1, 1838, '\p{Joining_Group:		gamal}', "");
    Expect(0, 1838, '\p{^Joining_Group:		gamal}', "");
    Expect(0, 1838, '\P{Joining_Group:		gamal}', "");
    Expect(1, 1838, '\P{^Joining_Group:		gamal}', "");
    Expect(0, 1839, '\p{Joining_Group:		gamal}', "");
    Expect(1, 1839, '\p{^Joining_Group:		gamal}', "");
    Expect(1, 1839, '\P{Joining_Group:		gamal}', "");
    Expect(0, 1839, '\P{^Joining_Group:		gamal}', "");
    Error('\p{Jg= -gamal:=}');
    Error('\P{Jg= -gamal:=}');
    Expect(1, 1838, '\p{Jg=:\AGamal\z:}', "");;
    Expect(0, 1839, '\p{Jg=:\AGamal\z:}', "");;
    Expect(1, 1838, '\p{Jg=gamal}', "");
    Expect(0, 1838, '\p{^Jg=gamal}', "");
    Expect(0, 1838, '\P{Jg=gamal}', "");
    Expect(1, 1838, '\P{^Jg=gamal}', "");
    Expect(0, 1839, '\p{Jg=gamal}', "");
    Expect(1, 1839, '\p{^Jg=gamal}', "");
    Expect(1, 1839, '\P{Jg=gamal}', "");
    Expect(0, 1839, '\P{^Jg=gamal}', "");
    Expect(1, 1838, '\p{Jg=:\Agamal\z:}', "");;
    Expect(0, 1839, '\p{Jg=:\Agamal\z:}', "");;
    Expect(1, 1838, '\p{Jg=-Gamal}', "");
    Expect(0, 1838, '\p{^Jg=-Gamal}', "");
    Expect(0, 1838, '\P{Jg=-Gamal}', "");
    Expect(1, 1838, '\P{^Jg=-Gamal}', "");
    Expect(0, 1839, '\p{Jg=-Gamal}', "");
    Expect(1, 1839, '\p{^Jg=-Gamal}', "");
    Expect(1, 1839, '\P{Jg=-Gamal}', "");
    Expect(0, 1839, '\P{^Jg=-Gamal}', "");
    Error('\p{Is_Joining_Group=:=-	Gamal}');
    Error('\P{Is_Joining_Group=:=-	Gamal}');
    Expect(1, 1838, '\p{Is_Joining_Group=gamal}', "");
    Expect(0, 1838, '\p{^Is_Joining_Group=gamal}', "");
    Expect(0, 1838, '\P{Is_Joining_Group=gamal}', "");
    Expect(1, 1838, '\P{^Is_Joining_Group=gamal}', "");
    Expect(0, 1839, '\p{Is_Joining_Group=gamal}', "");
    Expect(1, 1839, '\p{^Is_Joining_Group=gamal}', "");
    Expect(1, 1839, '\P{Is_Joining_Group=gamal}', "");
    Expect(0, 1839, '\P{^Is_Joining_Group=gamal}', "");
    Expect(1, 1838, '\p{Is_Joining_Group=	Gamal}', "");
    Expect(0, 1838, '\p{^Is_Joining_Group=	Gamal}', "");
    Expect(0, 1838, '\P{Is_Joining_Group=	Gamal}', "");
    Expect(1, 1838, '\P{^Is_Joining_Group=	Gamal}', "");
    Expect(0, 1839, '\p{Is_Joining_Group=	Gamal}', "");
    Expect(1, 1839, '\p{^Is_Joining_Group=	Gamal}', "");
    Expect(1, 1839, '\P{Is_Joining_Group=	Gamal}', "");
    Expect(0, 1839, '\P{^Is_Joining_Group=	Gamal}', "");
    Error('\p{Is_Jg: Gamal/a/}');
    Error('\P{Is_Jg: Gamal/a/}');
    Expect(1, 1838, '\p{Is_Jg=gamal}', "");
    Expect(0, 1838, '\p{^Is_Jg=gamal}', "");
    Expect(0, 1838, '\P{Is_Jg=gamal}', "");
    Expect(1, 1838, '\P{^Is_Jg=gamal}', "");
    Expect(0, 1839, '\p{Is_Jg=gamal}', "");
    Expect(1, 1839, '\p{^Is_Jg=gamal}', "");
    Expect(1, 1839, '\P{Is_Jg=gamal}', "");
    Expect(0, 1839, '\P{^Is_Jg=gamal}', "");
    Expect(1, 1838, '\p{Is_Jg=  Gamal}', "");
    Expect(0, 1838, '\p{^Is_Jg=  Gamal}', "");
    Expect(0, 1838, '\P{Is_Jg=  Gamal}', "");
    Expect(1, 1838, '\P{^Is_Jg=  Gamal}', "");
    Expect(0, 1839, '\p{Is_Jg=  Gamal}', "");
    Expect(1, 1839, '\p{^Is_Jg=  Gamal}', "");
    Expect(1, 1839, '\P{Is_Jg=  Gamal}', "");
    Expect(0, 1839, '\P{^Is_Jg=  Gamal}', "");
    Error('\p{Joining_Group=/a/Hah}');
    Error('\P{Joining_Group=/a/Hah}');
    Expect(1, 2246, '\p{Joining_Group=:\AHah\z:}', "");;
    Expect(0, 2247, '\p{Joining_Group=:\AHah\z:}', "");;
    Expect(1, 2246, '\p{Joining_Group=hah}', "");
    Expect(0, 2246, '\p{^Joining_Group=hah}', "");
    Expect(0, 2246, '\P{Joining_Group=hah}', "");
    Expect(1, 2246, '\P{^Joining_Group=hah}', "");
    Expect(0, 2247, '\p{Joining_Group=hah}', "");
    Expect(1, 2247, '\p{^Joining_Group=hah}', "");
    Expect(1, 2247, '\P{Joining_Group=hah}', "");
    Expect(0, 2247, '\P{^Joining_Group=hah}', "");
    Expect(1, 2246, '\p{Joining_Group=:\Ahah\z:}', "");;
    Expect(0, 2247, '\p{Joining_Group=:\Ahah\z:}', "");;
    Expect(1, 2246, '\p{Joining_Group:    Hah}', "");
    Expect(0, 2246, '\p{^Joining_Group:    Hah}', "");
    Expect(0, 2246, '\P{Joining_Group:    Hah}', "");
    Expect(1, 2246, '\P{^Joining_Group:    Hah}', "");
    Expect(0, 2247, '\p{Joining_Group:    Hah}', "");
    Expect(1, 2247, '\p{^Joining_Group:    Hah}', "");
    Expect(1, 2247, '\P{Joining_Group:    Hah}', "");
    Expect(0, 2247, '\P{^Joining_Group:    Hah}', "");
    Error('\p{Jg=:= -Hah}');
    Error('\P{Jg=:= -Hah}');
    Expect(1, 2246, '\p{Jg=:\AHah\z:}', "");;
    Expect(0, 2247, '\p{Jg=:\AHah\z:}', "");;
    Expect(1, 2246, '\p{Jg=hah}', "");
    Expect(0, 2246, '\p{^Jg=hah}', "");
    Expect(0, 2246, '\P{Jg=hah}', "");
    Expect(1, 2246, '\P{^Jg=hah}', "");
    Expect(0, 2247, '\p{Jg=hah}', "");
    Expect(1, 2247, '\p{^Jg=hah}', "");
    Expect(1, 2247, '\P{Jg=hah}', "");
    Expect(0, 2247, '\P{^Jg=hah}', "");
    Expect(1, 2246, '\p{Jg=:\Ahah\z:}', "");;
    Expect(0, 2247, '\p{Jg=:\Ahah\z:}', "");;
    Expect(1, 2246, '\p{Jg=	HAH}', "");
    Expect(0, 2246, '\p{^Jg=	HAH}', "");
    Expect(0, 2246, '\P{Jg=	HAH}', "");
    Expect(1, 2246, '\P{^Jg=	HAH}', "");
    Expect(0, 2247, '\p{Jg=	HAH}', "");
    Expect(1, 2247, '\p{^Jg=	HAH}', "");
    Expect(1, 2247, '\P{Jg=	HAH}', "");
    Expect(0, 2247, '\P{^Jg=	HAH}', "");
    Error('\p{Is_Joining_Group=:=_Hah}');
    Error('\P{Is_Joining_Group=:=_Hah}');
    Expect(1, 2246, '\p{Is_Joining_Group=hah}', "");
    Expect(0, 2246, '\p{^Is_Joining_Group=hah}', "");
    Expect(0, 2246, '\P{Is_Joining_Group=hah}', "");
    Expect(1, 2246, '\P{^Is_Joining_Group=hah}', "");
    Expect(0, 2247, '\p{Is_Joining_Group=hah}', "");
    Expect(1, 2247, '\p{^Is_Joining_Group=hah}', "");
    Expect(1, 2247, '\P{Is_Joining_Group=hah}', "");
    Expect(0, 2247, '\P{^Is_Joining_Group=hah}', "");
    Expect(1, 2246, '\p{Is_Joining_Group:--Hah}', "");
    Expect(0, 2246, '\p{^Is_Joining_Group:--Hah}', "");
    Expect(0, 2246, '\P{Is_Joining_Group:--Hah}', "");
    Expect(1, 2246, '\P{^Is_Joining_Group:--Hah}', "");
    Expect(0, 2247, '\p{Is_Joining_Group:--Hah}', "");
    Expect(1, 2247, '\p{^Is_Joining_Group:--Hah}', "");
    Expect(1, 2247, '\P{Is_Joining_Group:--Hah}', "");
    Expect(0, 2247, '\P{^Is_Joining_Group:--Hah}', "");
    Error('\p{Is_Jg=_ HAH/a/}');
    Error('\P{Is_Jg=_ HAH/a/}');
    Expect(1, 2246, '\p{Is_Jg=hah}', "");
    Expect(0, 2246, '\p{^Is_Jg=hah}', "");
    Expect(0, 2246, '\P{Is_Jg=hah}', "");
    Expect(1, 2246, '\P{^Is_Jg=hah}', "");
    Expect(0, 2247, '\p{Is_Jg=hah}', "");
    Expect(1, 2247, '\p{^Is_Jg=hah}', "");
    Expect(1, 2247, '\P{Is_Jg=hah}', "");
    Expect(0, 2247, '\P{^Is_Jg=hah}', "");
    Expect(1, 2246, '\p{Is_Jg=_Hah}', "");
    Expect(0, 2246, '\p{^Is_Jg=_Hah}', "");
    Expect(0, 2246, '\P{Is_Jg=_Hah}', "");
    Expect(1, 2246, '\P{^Is_Jg=_Hah}', "");
    Expect(0, 2247, '\p{Is_Jg=_Hah}', "");
    Expect(1, 2247, '\p{^Is_Jg=_Hah}', "");
    Expect(1, 2247, '\P{Is_Jg=_Hah}', "");
    Expect(0, 2247, '\P{^Is_Jg=_Hah}', "");
    Error('\p{Joining_Group:   	:=hanifi_Rohingya_KINNA_ya}');
    Error('\P{Joining_Group:   	:=hanifi_Rohingya_KINNA_ya}');
    Expect(1, 68899, '\p{Joining_Group=:\AHanifi_Rohingya_Kinna_Ya\z:}', "");;
    Expect(0, 68900, '\p{Joining_Group=:\AHanifi_Rohingya_Kinna_Ya\z:}', "");;
    Expect(1, 68899, '\p{Joining_Group=hanifirohingyakinnaya}', "");
    Expect(0, 68899, '\p{^Joining_Group=hanifirohingyakinnaya}', "");
    Expect(0, 68899, '\P{Joining_Group=hanifirohingyakinnaya}', "");
    Expect(1, 68899, '\P{^Joining_Group=hanifirohingyakinnaya}', "");
    Expect(0, 68900, '\p{Joining_Group=hanifirohingyakinnaya}', "");
    Expect(1, 68900, '\p{^Joining_Group=hanifirohingyakinnaya}', "");
    Expect(1, 68900, '\P{Joining_Group=hanifirohingyakinnaya}', "");
    Expect(0, 68900, '\P{^Joining_Group=hanifirohingyakinnaya}', "");
    Expect(1, 68899, '\p{Joining_Group=:\Ahanifirohingyakinnaya\z:}', "");;
    Expect(0, 68900, '\p{Joining_Group=:\Ahanifirohingyakinnaya\z:}', "");;
    Expect(1, 68899, '\p{Joining_Group= 	HANIFI_Rohingya_kinna_Ya}', "");
    Expect(0, 68899, '\p{^Joining_Group= 	HANIFI_Rohingya_kinna_Ya}', "");
    Expect(0, 68899, '\P{Joining_Group= 	HANIFI_Rohingya_kinna_Ya}', "");
    Expect(1, 68899, '\P{^Joining_Group= 	HANIFI_Rohingya_kinna_Ya}', "");
    Expect(0, 68900, '\p{Joining_Group= 	HANIFI_Rohingya_kinna_Ya}', "");
    Expect(1, 68900, '\p{^Joining_Group= 	HANIFI_Rohingya_kinna_Ya}', "");
    Expect(1, 68900, '\P{Joining_Group= 	HANIFI_Rohingya_kinna_Ya}', "");
    Expect(0, 68900, '\P{^Joining_Group= 	HANIFI_Rohingya_kinna_Ya}', "");
    Error('\p{Jg=-_Hanifi_ROHINGYA_Kinna_Ya/a/}');
    Error('\P{Jg=-_Hanifi_ROHINGYA_Kinna_Ya/a/}');
    Expect(1, 68899, '\p{Jg=:\AHanifi_Rohingya_Kinna_Ya\z:}', "");;
    Expect(0, 68900, '\p{Jg=:\AHanifi_Rohingya_Kinna_Ya\z:}', "");;
    Expect(1, 68899, '\p{Jg=hanifirohingyakinnaya}', "");
    Expect(0, 68899, '\p{^Jg=hanifirohingyakinnaya}', "");
    Expect(0, 68899, '\P{Jg=hanifirohingyakinnaya}', "");
    Expect(1, 68899, '\P{^Jg=hanifirohingyakinnaya}', "");
    Expect(0, 68900, '\p{Jg=hanifirohingyakinnaya}', "");
    Expect(1, 68900, '\p{^Jg=hanifirohingyakinnaya}', "");
    Expect(1, 68900, '\P{Jg=hanifirohingyakinnaya}', "");
    Expect(0, 68900, '\P{^Jg=hanifirohingyakinnaya}', "");
    Expect(1, 68899, '\p{Jg=:\Ahanifirohingyakinnaya\z:}', "");;
    Expect(0, 68900, '\p{Jg=:\Ahanifirohingyakinnaya\z:}', "");;
    Expect(1, 68899, '\p{Jg=- hanifi_Rohingya_Kinna_Ya}', "");
    Expect(0, 68899, '\p{^Jg=- hanifi_Rohingya_Kinna_Ya}', "");
    Expect(0, 68899, '\P{Jg=- hanifi_Rohingya_Kinna_Ya}', "");
    Expect(1, 68899, '\P{^Jg=- hanifi_Rohingya_Kinna_Ya}', "");
    Expect(0, 68900, '\p{Jg=- hanifi_Rohingya_Kinna_Ya}', "");
    Expect(1, 68900, '\p{^Jg=- hanifi_Rohingya_Kinna_Ya}', "");
    Expect(1, 68900, '\P{Jg=- hanifi_Rohingya_Kinna_Ya}', "");
    Expect(0, 68900, '\P{^Jg=- hanifi_Rohingya_Kinna_Ya}', "");
    Error('\p{Is_Joining_Group= _HANIFI_ROHINGYA_Kinna_Ya:=}');
    Error('\P{Is_Joining_Group= _HANIFI_ROHINGYA_Kinna_Ya:=}');
    Expect(1, 68899, '\p{Is_Joining_Group=hanifirohingyakinnaya}', "");
    Expect(0, 68899, '\p{^Is_Joining_Group=hanifirohingyakinnaya}', "");
    Expect(0, 68899, '\P{Is_Joining_Group=hanifirohingyakinnaya}', "");
    Expect(1, 68899, '\P{^Is_Joining_Group=hanifirohingyakinnaya}', "");
    Expect(0, 68900, '\p{Is_Joining_Group=hanifirohingyakinnaya}', "");
    Expect(1, 68900, '\p{^Is_Joining_Group=hanifirohingyakinnaya}', "");
    Expect(1, 68900, '\P{Is_Joining_Group=hanifirohingyakinnaya}', "");
    Expect(0, 68900, '\P{^Is_Joining_Group=hanifirohingyakinnaya}', "");
    Expect(1, 68899, '\p{Is_Joining_Group=	-Hanifi_rohingya_Kinna_Ya}', "");
    Expect(0, 68899, '\p{^Is_Joining_Group=	-Hanifi_rohingya_Kinna_Ya}', "");
    Expect(0, 68899, '\P{Is_Joining_Group=	-Hanifi_rohingya_Kinna_Ya}', "");
    Expect(1, 68899, '\P{^Is_Joining_Group=	-Hanifi_rohingya_Kinna_Ya}', "");
    Expect(0, 68900, '\p{Is_Joining_Group=	-Hanifi_rohingya_Kinna_Ya}', "");
    Expect(1, 68900, '\p{^Is_Joining_Group=	-Hanifi_rohingya_Kinna_Ya}', "");
    Expect(1, 68900, '\P{Is_Joining_Group=	-Hanifi_rohingya_Kinna_Ya}', "");
    Expect(0, 68900, '\P{^Is_Joining_Group=	-Hanifi_rohingya_Kinna_Ya}', "");
    Error('\p{Is_Jg=-hanifi_Rohingya_Kinna_ya/a/}');
    Error('\P{Is_Jg=-hanifi_Rohingya_Kinna_ya/a/}');
    Expect(1, 68899, '\p{Is_Jg=hanifirohingyakinnaya}', "");
    Expect(0, 68899, '\p{^Is_Jg=hanifirohingyakinnaya}', "");
    Expect(0, 68899, '\P{Is_Jg=hanifirohingyakinnaya}', "");
    Expect(1, 68899, '\P{^Is_Jg=hanifirohingyakinnaya}', "");
    Expect(0, 68900, '\p{Is_Jg=hanifirohingyakinnaya}', "");
    Expect(1, 68900, '\p{^Is_Jg=hanifirohingyakinnaya}', "");
    Expect(1, 68900, '\P{Is_Jg=hanifirohingyakinnaya}', "");
    Expect(0, 68900, '\P{^Is_Jg=hanifirohingyakinnaya}', "");
    Expect(1, 68899, '\p{Is_Jg=- Hanifi_ROHINGYA_KINNA_ya}', "");
    Expect(0, 68899, '\p{^Is_Jg=- Hanifi_ROHINGYA_KINNA_ya}', "");
    Expect(0, 68899, '\P{Is_Jg=- Hanifi_ROHINGYA_KINNA_ya}', "");
    Expect(1, 68899, '\P{^Is_Jg=- Hanifi_ROHINGYA_KINNA_ya}', "");
    Expect(0, 68900, '\p{Is_Jg=- Hanifi_ROHINGYA_KINNA_ya}', "");
    Expect(1, 68900, '\p{^Is_Jg=- Hanifi_ROHINGYA_KINNA_ya}', "");
    Expect(1, 68900, '\P{Is_Jg=- Hanifi_ROHINGYA_KINNA_ya}', "");
    Expect(0, 68900, '\P{^Is_Jg=- Hanifi_ROHINGYA_KINNA_ya}', "");
    Error('\p{Joining_Group=_:=HANIFI_Rohingya_pa}');
    Error('\P{Joining_Group=_:=HANIFI_Rohingya_pa}');
    Expect(1, 68892, '\p{Joining_Group=:\AHanifi_Rohingya_Pa\z:}', "");;
    Expect(0, 68893, '\p{Joining_Group=:\AHanifi_Rohingya_Pa\z:}', "");;
    Expect(1, 68892, '\p{Joining_Group=hanifirohingyapa}', "");
    Expect(0, 68892, '\p{^Joining_Group=hanifirohingyapa}', "");
    Expect(0, 68892, '\P{Joining_Group=hanifirohingyapa}', "");
    Expect(1, 68892, '\P{^Joining_Group=hanifirohingyapa}', "");
    Expect(0, 68893, '\p{Joining_Group=hanifirohingyapa}', "");
    Expect(1, 68893, '\p{^Joining_Group=hanifirohingyapa}', "");
    Expect(1, 68893, '\P{Joining_Group=hanifirohingyapa}', "");
    Expect(0, 68893, '\P{^Joining_Group=hanifirohingyapa}', "");
    Expect(1, 68892, '\p{Joining_Group=:\Ahanifirohingyapa\z:}', "");;
    Expect(0, 68893, '\p{Joining_Group=:\Ahanifirohingyapa\z:}', "");;
    Expect(1, 68892, '\p{Joining_Group=-	HANIFI_Rohingya_pa}', "");
    Expect(0, 68892, '\p{^Joining_Group=-	HANIFI_Rohingya_pa}', "");
    Expect(0, 68892, '\P{Joining_Group=-	HANIFI_Rohingya_pa}', "");
    Expect(1, 68892, '\P{^Joining_Group=-	HANIFI_Rohingya_pa}', "");
    Expect(0, 68893, '\p{Joining_Group=-	HANIFI_Rohingya_pa}', "");
    Expect(1, 68893, '\p{^Joining_Group=-	HANIFI_Rohingya_pa}', "");
    Expect(1, 68893, '\P{Joining_Group=-	HANIFI_Rohingya_pa}', "");
    Expect(0, 68893, '\P{^Joining_Group=-	HANIFI_Rohingya_pa}', "");
    Error('\p{Jg=_-HANIFI_ROHINGYA_pa:=}');
    Error('\P{Jg=_-HANIFI_ROHINGYA_pa:=}');
    Expect(1, 68892, '\p{Jg=:\AHanifi_Rohingya_Pa\z:}', "");;
    Expect(0, 68893, '\p{Jg=:\AHanifi_Rohingya_Pa\z:}', "");;
    Expect(1, 68892, '\p{Jg=hanifirohingyapa}', "");
    Expect(0, 68892, '\p{^Jg=hanifirohingyapa}', "");
    Expect(0, 68892, '\P{Jg=hanifirohingyapa}', "");
    Expect(1, 68892, '\P{^Jg=hanifirohingyapa}', "");
    Expect(0, 68893, '\p{Jg=hanifirohingyapa}', "");
    Expect(1, 68893, '\p{^Jg=hanifirohingyapa}', "");
    Expect(1, 68893, '\P{Jg=hanifirohingyapa}', "");
    Expect(0, 68893, '\P{^Jg=hanifirohingyapa}', "");
    Expect(1, 68892, '\p{Jg=:\Ahanifirohingyapa\z:}', "");;
    Expect(0, 68893, '\p{Jg=:\Ahanifirohingyapa\z:}', "");;
    Expect(1, 68892, '\p{Jg=  hanifi_rohingya_PA}', "");
    Expect(0, 68892, '\p{^Jg=  hanifi_rohingya_PA}', "");
    Expect(0, 68892, '\P{Jg=  hanifi_rohingya_PA}', "");
    Expect(1, 68892, '\P{^Jg=  hanifi_rohingya_PA}', "");
    Expect(0, 68893, '\p{Jg=  hanifi_rohingya_PA}', "");
    Expect(1, 68893, '\p{^Jg=  hanifi_rohingya_PA}', "");
    Expect(1, 68893, '\P{Jg=  hanifi_rohingya_PA}', "");
    Expect(0, 68893, '\P{^Jg=  hanifi_rohingya_PA}', "");
    Error('\p{Is_Joining_Group::=-	Hanifi_ROHINGYA_PA}');
    Error('\P{Is_Joining_Group::=-	Hanifi_ROHINGYA_PA}');
    Expect(1, 68892, '\p{Is_Joining_Group=hanifirohingyapa}', "");
    Expect(0, 68892, '\p{^Is_Joining_Group=hanifirohingyapa}', "");
    Expect(0, 68892, '\P{Is_Joining_Group=hanifirohingyapa}', "");
    Expect(1, 68892, '\P{^Is_Joining_Group=hanifirohingyapa}', "");
    Expect(0, 68893, '\p{Is_Joining_Group=hanifirohingyapa}', "");
    Expect(1, 68893, '\p{^Is_Joining_Group=hanifirohingyapa}', "");
    Expect(1, 68893, '\P{Is_Joining_Group=hanifirohingyapa}', "");
    Expect(0, 68893, '\P{^Is_Joining_Group=hanifirohingyapa}', "");
    Expect(1, 68892, '\p{Is_Joining_Group= Hanifi_rohingya_Pa}', "");
    Expect(0, 68892, '\p{^Is_Joining_Group= Hanifi_rohingya_Pa}', "");
    Expect(0, 68892, '\P{Is_Joining_Group= Hanifi_rohingya_Pa}', "");
    Expect(1, 68892, '\P{^Is_Joining_Group= Hanifi_rohingya_Pa}', "");
    Expect(0, 68893, '\p{Is_Joining_Group= Hanifi_rohingya_Pa}', "");
    Expect(1, 68893, '\p{^Is_Joining_Group= Hanifi_rohingya_Pa}', "");
    Expect(1, 68893, '\P{Is_Joining_Group= Hanifi_rohingya_Pa}', "");
    Expect(0, 68893, '\P{^Is_Joining_Group= Hanifi_rohingya_Pa}', "");
    Error('\p{Is_Jg=:=hanifi_ROHINGYA_Pa}');
    Error('\P{Is_Jg=:=hanifi_ROHINGYA_Pa}');
    Expect(1, 68892, '\p{Is_Jg=hanifirohingyapa}', "");
    Expect(0, 68892, '\p{^Is_Jg=hanifirohingyapa}', "");
    Expect(0, 68892, '\P{Is_Jg=hanifirohingyapa}', "");
    Expect(1, 68892, '\P{^Is_Jg=hanifirohingyapa}', "");
    Expect(0, 68893, '\p{Is_Jg=hanifirohingyapa}', "");
    Expect(1, 68893, '\p{^Is_Jg=hanifirohingyapa}', "");
    Expect(1, 68893, '\P{Is_Jg=hanifirohingyapa}', "");
    Expect(0, 68893, '\P{^Is_Jg=hanifirohingyapa}', "");
    Expect(1, 68892, '\p{Is_Jg= 	Hanifi_Rohingya_pa}', "");
    Expect(0, 68892, '\p{^Is_Jg= 	Hanifi_Rohingya_pa}', "");
    Expect(0, 68892, '\P{Is_Jg= 	Hanifi_Rohingya_pa}', "");
    Expect(1, 68892, '\P{^Is_Jg= 	Hanifi_Rohingya_pa}', "");
    Expect(0, 68893, '\p{Is_Jg= 	Hanifi_Rohingya_pa}', "");
    Expect(1, 68893, '\p{^Is_Jg= 	Hanifi_Rohingya_pa}', "");
    Expect(1, 68893, '\P{Is_Jg= 	Hanifi_Rohingya_pa}', "");
    Expect(0, 68893, '\P{^Is_Jg= 	Hanifi_Rohingya_pa}', "");
    Error('\p{Joining_Group=_:=He}');
    Error('\P{Joining_Group=_:=He}');
    Expect(1, 1815, '\p{Joining_Group=:\AHe\z:}', "");;
    Expect(0, 1816, '\p{Joining_Group=:\AHe\z:}', "");;
    Expect(1, 1815, '\p{Joining_Group=he}', "");
    Expect(0, 1815, '\p{^Joining_Group=he}', "");
    Expect(0, 1815, '\P{Joining_Group=he}', "");
    Expect(1, 1815, '\P{^Joining_Group=he}', "");
    Expect(0, 1816, '\p{Joining_Group=he}', "");
    Expect(1, 1816, '\p{^Joining_Group=he}', "");
    Expect(1, 1816, '\P{Joining_Group=he}', "");
    Expect(0, 1816, '\P{^Joining_Group=he}', "");
    Expect(1, 1815, '\p{Joining_Group=:\Ahe\z:}', "");;
    Expect(0, 1816, '\p{Joining_Group=:\Ahe\z:}', "");;
    Expect(1, 1815, '\p{Joining_Group=	He}', "");
    Expect(0, 1815, '\p{^Joining_Group=	He}', "");
    Expect(0, 1815, '\P{Joining_Group=	He}', "");
    Expect(1, 1815, '\P{^Joining_Group=	He}', "");
    Expect(0, 1816, '\p{Joining_Group=	He}', "");
    Expect(1, 1816, '\p{^Joining_Group=	He}', "");
    Expect(1, 1816, '\P{Joining_Group=	He}', "");
    Expect(0, 1816, '\P{^Joining_Group=	He}', "");
    Error('\p{Jg=-/a/He}');
    Error('\P{Jg=-/a/He}');
    Expect(1, 1815, '\p{Jg=:\AHe\z:}', "");;
    Expect(0, 1816, '\p{Jg=:\AHe\z:}', "");;
    Expect(1, 1815, '\p{Jg:	he}', "");
    Expect(0, 1815, '\p{^Jg:	he}', "");
    Expect(0, 1815, '\P{Jg:	he}', "");
    Expect(1, 1815, '\P{^Jg:	he}', "");
    Expect(0, 1816, '\p{Jg:	he}', "");
    Expect(1, 1816, '\p{^Jg:	he}', "");
    Expect(1, 1816, '\P{Jg:	he}', "");
    Expect(0, 1816, '\P{^Jg:	he}', "");
    Expect(1, 1815, '\p{Jg=:\Ahe\z:}', "");;
    Expect(0, 1816, '\p{Jg=:\Ahe\z:}', "");;
    Expect(1, 1815, '\p{Jg=-_He}', "");
    Expect(0, 1815, '\p{^Jg=-_He}', "");
    Expect(0, 1815, '\P{Jg=-_He}', "");
    Expect(1, 1815, '\P{^Jg=-_He}', "");
    Expect(0, 1816, '\p{Jg=-_He}', "");
    Expect(1, 1816, '\p{^Jg=-_He}', "");
    Expect(1, 1816, '\P{Jg=-_He}', "");
    Expect(0, 1816, '\P{^Jg=-_He}', "");
    Error('\p{Is_Joining_Group:	he/a/}');
    Error('\P{Is_Joining_Group:	he/a/}');
    Expect(1, 1815, '\p{Is_Joining_Group=he}', "");
    Expect(0, 1815, '\p{^Is_Joining_Group=he}', "");
    Expect(0, 1815, '\P{Is_Joining_Group=he}', "");
    Expect(1, 1815, '\P{^Is_Joining_Group=he}', "");
    Expect(0, 1816, '\p{Is_Joining_Group=he}', "");
    Expect(1, 1816, '\p{^Is_Joining_Group=he}', "");
    Expect(1, 1816, '\P{Is_Joining_Group=he}', "");
    Expect(0, 1816, '\P{^Is_Joining_Group=he}', "");
    Expect(1, 1815, '\p{Is_Joining_Group= 	HE}', "");
    Expect(0, 1815, '\p{^Is_Joining_Group= 	HE}', "");
    Expect(0, 1815, '\P{Is_Joining_Group= 	HE}', "");
    Expect(1, 1815, '\P{^Is_Joining_Group= 	HE}', "");
    Expect(0, 1816, '\p{Is_Joining_Group= 	HE}', "");
    Expect(1, 1816, '\p{^Is_Joining_Group= 	HE}', "");
    Expect(1, 1816, '\P{Is_Joining_Group= 	HE}', "");
    Expect(0, 1816, '\P{^Is_Joining_Group= 	HE}', "");
    Error('\p{Is_Jg= /a/HE}');
    Error('\P{Is_Jg= /a/HE}');
    Expect(1, 1815, '\p{Is_Jg=he}', "");
    Expect(0, 1815, '\p{^Is_Jg=he}', "");
    Expect(0, 1815, '\P{Is_Jg=he}', "");
    Expect(1, 1815, '\P{^Is_Jg=he}', "");
    Expect(0, 1816, '\p{Is_Jg=he}', "");
    Expect(1, 1816, '\p{^Is_Jg=he}', "");
    Expect(1, 1816, '\P{Is_Jg=he}', "");
    Expect(0, 1816, '\P{^Is_Jg=he}', "");
    Expect(1, 1815, '\p{Is_Jg=	-HE}', "");
    Expect(0, 1815, '\p{^Is_Jg=	-HE}', "");
    Expect(0, 1815, '\P{Is_Jg=	-HE}', "");
    Expect(1, 1815, '\P{^Is_Jg=	-HE}', "");
    Expect(0, 1816, '\p{Is_Jg=	-HE}', "");
    Expect(1, 1816, '\p{^Is_Jg=	-HE}', "");
    Expect(1, 1816, '\P{Is_Jg=	-HE}', "");
    Expect(0, 1816, '\P{^Is_Jg=	-HE}', "");
    Error('\p{Joining_Group=_:=HEH}');
    Error('\P{Joining_Group=_:=HEH}');
    Expect(1, 1607, '\p{Joining_Group=:\AHeh\z:}', "");;
    Expect(0, 1608, '\p{Joining_Group=:\AHeh\z:}', "");;
    Expect(1, 1607, '\p{Joining_Group:   heh}', "");
    Expect(0, 1607, '\p{^Joining_Group:   heh}', "");
    Expect(0, 1607, '\P{Joining_Group:   heh}', "");
    Expect(1, 1607, '\P{^Joining_Group:   heh}', "");
    Expect(0, 1608, '\p{Joining_Group:   heh}', "");
    Expect(1, 1608, '\p{^Joining_Group:   heh}', "");
    Expect(1, 1608, '\P{Joining_Group:   heh}', "");
    Expect(0, 1608, '\P{^Joining_Group:   heh}', "");
    Expect(1, 1607, '\p{Joining_Group=:\Aheh\z:}', "");;
    Expect(0, 1608, '\p{Joining_Group=:\Aheh\z:}', "");;
    Expect(1, 1607, '\p{Joining_Group=		HEH}', "");
    Expect(0, 1607, '\p{^Joining_Group=		HEH}', "");
    Expect(0, 1607, '\P{Joining_Group=		HEH}', "");
    Expect(1, 1607, '\P{^Joining_Group=		HEH}', "");
    Expect(0, 1608, '\p{Joining_Group=		HEH}', "");
    Expect(1, 1608, '\p{^Joining_Group=		HEH}', "");
    Expect(1, 1608, '\P{Joining_Group=		HEH}', "");
    Expect(0, 1608, '\P{^Joining_Group=		HEH}', "");
    Error('\p{Jg= -Heh:=}');
    Error('\P{Jg= -Heh:=}');
    Expect(1, 1607, '\p{Jg=:\AHeh\z:}', "");;
    Expect(0, 1608, '\p{Jg=:\AHeh\z:}', "");;
    Expect(1, 1607, '\p{Jg=heh}', "");
    Expect(0, 1607, '\p{^Jg=heh}', "");
    Expect(0, 1607, '\P{Jg=heh}', "");
    Expect(1, 1607, '\P{^Jg=heh}', "");
    Expect(0, 1608, '\p{Jg=heh}', "");
    Expect(1, 1608, '\p{^Jg=heh}', "");
    Expect(1, 1608, '\P{Jg=heh}', "");
    Expect(0, 1608, '\P{^Jg=heh}', "");
    Expect(1, 1607, '\p{Jg=:\Aheh\z:}', "");;
    Expect(0, 1608, '\p{Jg=:\Aheh\z:}', "");;
    Expect(1, 1607, '\p{Jg= 	Heh}', "");
    Expect(0, 1607, '\p{^Jg= 	Heh}', "");
    Expect(0, 1607, '\P{Jg= 	Heh}', "");
    Expect(1, 1607, '\P{^Jg= 	Heh}', "");
    Expect(0, 1608, '\p{Jg= 	Heh}', "");
    Expect(1, 1608, '\p{^Jg= 	Heh}', "");
    Expect(1, 1608, '\P{Jg= 	Heh}', "");
    Expect(0, 1608, '\P{^Jg= 	Heh}', "");
    Error('\p{Is_Joining_Group=/a/-heh}');
    Error('\P{Is_Joining_Group=/a/-heh}');
    Expect(1, 1607, '\p{Is_Joining_Group=heh}', "");
    Expect(0, 1607, '\p{^Is_Joining_Group=heh}', "");
    Expect(0, 1607, '\P{Is_Joining_Group=heh}', "");
    Expect(1, 1607, '\P{^Is_Joining_Group=heh}', "");
    Expect(0, 1608, '\p{Is_Joining_Group=heh}', "");
    Expect(1, 1608, '\p{^Is_Joining_Group=heh}', "");
    Expect(1, 1608, '\P{Is_Joining_Group=heh}', "");
    Expect(0, 1608, '\P{^Is_Joining_Group=heh}', "");
    Expect(1, 1607, '\p{Is_Joining_Group:- HEH}', "");
    Expect(0, 1607, '\p{^Is_Joining_Group:- HEH}', "");
    Expect(0, 1607, '\P{Is_Joining_Group:- HEH}', "");
    Expect(1, 1607, '\P{^Is_Joining_Group:- HEH}', "");
    Expect(0, 1608, '\p{Is_Joining_Group:- HEH}', "");
    Expect(1, 1608, '\p{^Is_Joining_Group:- HEH}', "");
    Expect(1, 1608, '\P{Is_Joining_Group:- HEH}', "");
    Expect(0, 1608, '\P{^Is_Joining_Group:- HEH}', "");
    Error('\p{Is_Jg=:=	-Heh}');
    Error('\P{Is_Jg=:=	-Heh}');
    Expect(1, 1607, '\p{Is_Jg=heh}', "");
    Expect(0, 1607, '\p{^Is_Jg=heh}', "");
    Expect(0, 1607, '\P{Is_Jg=heh}', "");
    Expect(1, 1607, '\P{^Is_Jg=heh}', "");
    Expect(0, 1608, '\p{Is_Jg=heh}', "");
    Expect(1, 1608, '\p{^Is_Jg=heh}', "");
    Expect(1, 1608, '\P{Is_Jg=heh}', "");
    Expect(0, 1608, '\P{^Is_Jg=heh}', "");
    Expect(1, 1607, '\p{Is_Jg:  _Heh}', "");
    Expect(0, 1607, '\p{^Is_Jg:  _Heh}', "");
    Expect(0, 1607, '\P{Is_Jg:  _Heh}', "");
    Expect(1, 1607, '\P{^Is_Jg:  _Heh}', "");
    Expect(0, 1608, '\p{Is_Jg:  _Heh}', "");
    Expect(1, 1608, '\p{^Is_Jg:  _Heh}', "");
    Expect(1, 1608, '\P{Is_Jg:  _Heh}', "");
    Expect(0, 1608, '\P{^Is_Jg:  _Heh}', "");
    Error('\p{Joining_Group=_ HEH_GOAL/a/}');
    Error('\P{Joining_Group=_ HEH_GOAL/a/}');
    Expect(1, 1730, '\p{Joining_Group=:\AHeh_Goal\z:}', "");;
    Expect(0, 1731, '\p{Joining_Group=:\AHeh_Goal\z:}', "");;
    Expect(1, 1730, '\p{Joining_Group=hehgoal}', "");
    Expect(0, 1730, '\p{^Joining_Group=hehgoal}', "");
    Expect(0, 1730, '\P{Joining_Group=hehgoal}', "");
    Expect(1, 1730, '\P{^Joining_Group=hehgoal}', "");
    Expect(0, 1731, '\p{Joining_Group=hehgoal}', "");
    Expect(1, 1731, '\p{^Joining_Group=hehgoal}', "");
    Expect(1, 1731, '\P{Joining_Group=hehgoal}', "");
    Expect(0, 1731, '\P{^Joining_Group=hehgoal}', "");
    Expect(1, 1730, '\p{Joining_Group=:\Ahehgoal\z:}', "");;
    Expect(0, 1731, '\p{Joining_Group=:\Ahehgoal\z:}', "");;
    Expect(1, 1730, '\p{Joining_Group= _Heh_goal}', "");
    Expect(0, 1730, '\p{^Joining_Group= _Heh_goal}', "");
    Expect(0, 1730, '\P{Joining_Group= _Heh_goal}', "");
    Expect(1, 1730, '\P{^Joining_Group= _Heh_goal}', "");
    Expect(0, 1731, '\p{Joining_Group= _Heh_goal}', "");
    Expect(1, 1731, '\p{^Joining_Group= _Heh_goal}', "");
    Expect(1, 1731, '\P{Joining_Group= _Heh_goal}', "");
    Expect(0, 1731, '\P{^Joining_Group= _Heh_goal}', "");
    Error('\p{Jg=_:=HEH_Goal}');
    Error('\P{Jg=_:=HEH_Goal}');
    Expect(1, 1730, '\p{Jg=:\AHeh_Goal\z:}', "");;
    Expect(0, 1731, '\p{Jg=:\AHeh_Goal\z:}', "");;
    Expect(1, 1730, '\p{Jg=hehgoal}', "");
    Expect(0, 1730, '\p{^Jg=hehgoal}', "");
    Expect(0, 1730, '\P{Jg=hehgoal}', "");
    Expect(1, 1730, '\P{^Jg=hehgoal}', "");
    Expect(0, 1731, '\p{Jg=hehgoal}', "");
    Expect(1, 1731, '\p{^Jg=hehgoal}', "");
    Expect(1, 1731, '\P{Jg=hehgoal}', "");
    Expect(0, 1731, '\P{^Jg=hehgoal}', "");
    Expect(1, 1730, '\p{Jg=:\Ahehgoal\z:}', "");;
    Expect(0, 1731, '\p{Jg=:\Ahehgoal\z:}', "");;
    Expect(1, 1730, '\p{Jg=- heh_goal}', "");
    Expect(0, 1730, '\p{^Jg=- heh_goal}', "");
    Expect(0, 1730, '\P{Jg=- heh_goal}', "");
    Expect(1, 1730, '\P{^Jg=- heh_goal}', "");
    Expect(0, 1731, '\p{Jg=- heh_goal}', "");
    Expect(1, 1731, '\p{^Jg=- heh_goal}', "");
    Expect(1, 1731, '\P{Jg=- heh_goal}', "");
    Expect(0, 1731, '\P{^Jg=- heh_goal}', "");
    Error('\p{Is_Joining_Group=:=	_HEH_Goal}');
    Error('\P{Is_Joining_Group=:=	_HEH_Goal}');
    Expect(1, 1730, '\p{Is_Joining_Group=hehgoal}', "");
    Expect(0, 1730, '\p{^Is_Joining_Group=hehgoal}', "");
    Expect(0, 1730, '\P{Is_Joining_Group=hehgoal}', "");
    Expect(1, 1730, '\P{^Is_Joining_Group=hehgoal}', "");
    Expect(0, 1731, '\p{Is_Joining_Group=hehgoal}', "");
    Expect(1, 1731, '\p{^Is_Joining_Group=hehgoal}', "");
    Expect(1, 1731, '\P{Is_Joining_Group=hehgoal}', "");
    Expect(0, 1731, '\P{^Is_Joining_Group=hehgoal}', "");
    Expect(1, 1730, '\p{Is_Joining_Group=	-HEH_Goal}', "");
    Expect(0, 1730, '\p{^Is_Joining_Group=	-HEH_Goal}', "");
    Expect(0, 1730, '\P{Is_Joining_Group=	-HEH_Goal}', "");
    Expect(1, 1730, '\P{^Is_Joining_Group=	-HEH_Goal}', "");
    Expect(0, 1731, '\p{Is_Joining_Group=	-HEH_Goal}', "");
    Expect(1, 1731, '\p{^Is_Joining_Group=	-HEH_Goal}', "");
    Expect(1, 1731, '\P{Is_Joining_Group=	-HEH_Goal}', "");
    Expect(0, 1731, '\P{^Is_Joining_Group=	-HEH_Goal}', "");
    Error('\p{Is_Jg=Heh_goal/a/}');
    Error('\P{Is_Jg=Heh_goal/a/}');
    Expect(1, 1730, '\p{Is_Jg=hehgoal}', "");
    Expect(0, 1730, '\p{^Is_Jg=hehgoal}', "");
    Expect(0, 1730, '\P{Is_Jg=hehgoal}', "");
    Expect(1, 1730, '\P{^Is_Jg=hehgoal}', "");
    Expect(0, 1731, '\p{Is_Jg=hehgoal}', "");
    Expect(1, 1731, '\p{^Is_Jg=hehgoal}', "");
    Expect(1, 1731, '\P{Is_Jg=hehgoal}', "");
    Expect(0, 1731, '\P{^Is_Jg=hehgoal}', "");
    Expect(1, 1730, '\p{Is_Jg=_ HEH_Goal}', "");
    Expect(0, 1730, '\p{^Is_Jg=_ HEH_Goal}', "");
    Expect(0, 1730, '\P{Is_Jg=_ HEH_Goal}', "");
    Expect(1, 1730, '\P{^Is_Jg=_ HEH_Goal}', "");
    Expect(0, 1731, '\p{Is_Jg=_ HEH_Goal}', "");
    Expect(1, 1731, '\p{^Is_Jg=_ HEH_Goal}', "");
    Expect(1, 1731, '\P{Is_Jg=_ HEH_Goal}', "");
    Expect(0, 1731, '\P{^Is_Jg=_ HEH_Goal}', "");
    Error('\p{Joining_Group=:=heth}');
    Error('\P{Joining_Group=:=heth}');
    Expect(1, 1818, '\p{Joining_Group=:\AHeth\z:}', "");;
    Expect(0, 1819, '\p{Joining_Group=:\AHeth\z:}', "");;
    Expect(1, 1818, '\p{Joining_Group=heth}', "");
    Expect(0, 1818, '\p{^Joining_Group=heth}', "");
    Expect(0, 1818, '\P{Joining_Group=heth}', "");
    Expect(1, 1818, '\P{^Joining_Group=heth}', "");
    Expect(0, 1819, '\p{Joining_Group=heth}', "");
    Expect(1, 1819, '\p{^Joining_Group=heth}', "");
    Expect(1, 1819, '\P{Joining_Group=heth}', "");
    Expect(0, 1819, '\P{^Joining_Group=heth}', "");
    Expect(1, 1818, '\p{Joining_Group=:\Aheth\z:}', "");;
    Expect(0, 1819, '\p{Joining_Group=:\Aheth\z:}', "");;
    Expect(1, 1818, '\p{Joining_Group=-heth}', "");
    Expect(0, 1818, '\p{^Joining_Group=-heth}', "");
    Expect(0, 1818, '\P{Joining_Group=-heth}', "");
    Expect(1, 1818, '\P{^Joining_Group=-heth}', "");
    Expect(0, 1819, '\p{Joining_Group=-heth}', "");
    Expect(1, 1819, '\p{^Joining_Group=-heth}', "");
    Expect(1, 1819, '\P{Joining_Group=-heth}', "");
    Expect(0, 1819, '\P{^Joining_Group=-heth}', "");
    Error('\p{Jg=/a/_Heth}');
    Error('\P{Jg=/a/_Heth}');
    Expect(1, 1818, '\p{Jg=:\AHeth\z:}', "");;
    Expect(0, 1819, '\p{Jg=:\AHeth\z:}', "");;
    Expect(1, 1818, '\p{Jg=heth}', "");
    Expect(0, 1818, '\p{^Jg=heth}', "");
    Expect(0, 1818, '\P{Jg=heth}', "");
    Expect(1, 1818, '\P{^Jg=heth}', "");
    Expect(0, 1819, '\p{Jg=heth}', "");
    Expect(1, 1819, '\p{^Jg=heth}', "");
    Expect(1, 1819, '\P{Jg=heth}', "");
    Expect(0, 1819, '\P{^Jg=heth}', "");
    Expect(1, 1818, '\p{Jg=:\Aheth\z:}', "");;
    Expect(0, 1819, '\p{Jg=:\Aheth\z:}', "");;
    Expect(1, 1818, '\p{Jg:	_heth}', "");
    Expect(0, 1818, '\p{^Jg:	_heth}', "");
    Expect(0, 1818, '\P{Jg:	_heth}', "");
    Expect(1, 1818, '\P{^Jg:	_heth}', "");
    Expect(0, 1819, '\p{Jg:	_heth}', "");
    Expect(1, 1819, '\p{^Jg:	_heth}', "");
    Expect(1, 1819, '\P{Jg:	_heth}', "");
    Expect(0, 1819, '\P{^Jg:	_heth}', "");
    Error('\p{Is_Joining_Group=:=	 heth}');
    Error('\P{Is_Joining_Group=:=	 heth}');
    Expect(1, 1818, '\p{Is_Joining_Group=heth}', "");
    Expect(0, 1818, '\p{^Is_Joining_Group=heth}', "");
    Expect(0, 1818, '\P{Is_Joining_Group=heth}', "");
    Expect(1, 1818, '\P{^Is_Joining_Group=heth}', "");
    Expect(0, 1819, '\p{Is_Joining_Group=heth}', "");
    Expect(1, 1819, '\p{^Is_Joining_Group=heth}', "");
    Expect(1, 1819, '\P{Is_Joining_Group=heth}', "");
    Expect(0, 1819, '\P{^Is_Joining_Group=heth}', "");
    Expect(1, 1818, '\p{Is_Joining_Group=-Heth}', "");
    Expect(0, 1818, '\p{^Is_Joining_Group=-Heth}', "");
    Expect(0, 1818, '\P{Is_Joining_Group=-Heth}', "");
    Expect(1, 1818, '\P{^Is_Joining_Group=-Heth}', "");
    Expect(0, 1819, '\p{Is_Joining_Group=-Heth}', "");
    Expect(1, 1819, '\p{^Is_Joining_Group=-Heth}', "");
    Expect(1, 1819, '\P{Is_Joining_Group=-Heth}', "");
    Expect(0, 1819, '\P{^Is_Joining_Group=-Heth}', "");
    Error('\p{Is_Jg=_Heth/a/}');
    Error('\P{Is_Jg=_Heth/a/}');
    Expect(1, 1818, '\p{Is_Jg=heth}', "");
    Expect(0, 1818, '\p{^Is_Jg=heth}', "");
    Expect(0, 1818, '\P{Is_Jg=heth}', "");
    Expect(1, 1818, '\P{^Is_Jg=heth}', "");
    Expect(0, 1819, '\p{Is_Jg=heth}', "");
    Expect(1, 1819, '\p{^Is_Jg=heth}', "");
    Expect(1, 1819, '\P{Is_Jg=heth}', "");
    Expect(0, 1819, '\P{^Is_Jg=heth}', "");
    Expect(1, 1818, '\p{Is_Jg=--HETH}', "");
    Expect(0, 1818, '\p{^Is_Jg=--HETH}', "");
    Expect(0, 1818, '\P{Is_Jg=--HETH}', "");
    Expect(1, 1818, '\P{^Is_Jg=--HETH}', "");
    Expect(0, 1819, '\p{Is_Jg=--HETH}', "");
    Expect(1, 1819, '\p{^Is_Jg=--HETH}', "");
    Expect(1, 1819, '\P{Is_Jg=--HETH}', "");
    Expect(0, 1819, '\P{^Is_Jg=--HETH}', "");
    Error('\p{Joining_Group= kaf/a/}');
    Error('\P{Joining_Group= kaf/a/}');
    Expect(1, 2228, '\p{Joining_Group=:\AKaf\z:}', "");;
    Expect(0, 2229, '\p{Joining_Group=:\AKaf\z:}', "");;
    Expect(1, 2228, '\p{Joining_Group=kaf}', "");
    Expect(0, 2228, '\p{^Joining_Group=kaf}', "");
    Expect(0, 2228, '\P{Joining_Group=kaf}', "");
    Expect(1, 2228, '\P{^Joining_Group=kaf}', "");
    Expect(0, 2229, '\p{Joining_Group=kaf}', "");
    Expect(1, 2229, '\p{^Joining_Group=kaf}', "");
    Expect(1, 2229, '\P{Joining_Group=kaf}', "");
    Expect(0, 2229, '\P{^Joining_Group=kaf}', "");
    Expect(1, 2228, '\p{Joining_Group=:\Akaf\z:}', "");;
    Expect(0, 2229, '\p{Joining_Group=:\Akaf\z:}', "");;
    Expect(1, 2228, '\p{Joining_Group=-KAF}', "");
    Expect(0, 2228, '\p{^Joining_Group=-KAF}', "");
    Expect(0, 2228, '\P{Joining_Group=-KAF}', "");
    Expect(1, 2228, '\P{^Joining_Group=-KAF}', "");
    Expect(0, 2229, '\p{Joining_Group=-KAF}', "");
    Expect(1, 2229, '\p{^Joining_Group=-KAF}', "");
    Expect(1, 2229, '\P{Joining_Group=-KAF}', "");
    Expect(0, 2229, '\P{^Joining_Group=-KAF}', "");
    Error('\p{Jg=-/a/Kaf}');
    Error('\P{Jg=-/a/Kaf}');
    Expect(1, 2228, '\p{Jg=:\AKaf\z:}', "");;
    Expect(0, 2229, '\p{Jg=:\AKaf\z:}', "");;
    Expect(1, 2228, '\p{Jg=kaf}', "");
    Expect(0, 2228, '\p{^Jg=kaf}', "");
    Expect(0, 2228, '\P{Jg=kaf}', "");
    Expect(1, 2228, '\P{^Jg=kaf}', "");
    Expect(0, 2229, '\p{Jg=kaf}', "");
    Expect(1, 2229, '\p{^Jg=kaf}', "");
    Expect(1, 2229, '\P{Jg=kaf}', "");
    Expect(0, 2229, '\P{^Jg=kaf}', "");
    Expect(1, 2228, '\p{Jg=:\Akaf\z:}', "");;
    Expect(0, 2229, '\p{Jg=:\Akaf\z:}', "");;
    Expect(1, 2228, '\p{Jg= -KAF}', "");
    Expect(0, 2228, '\p{^Jg= -KAF}', "");
    Expect(0, 2228, '\P{Jg= -KAF}', "");
    Expect(1, 2228, '\P{^Jg= -KAF}', "");
    Expect(0, 2229, '\p{Jg= -KAF}', "");
    Expect(1, 2229, '\p{^Jg= -KAF}', "");
    Expect(1, 2229, '\P{Jg= -KAF}', "");
    Expect(0, 2229, '\P{^Jg= -KAF}', "");
    Error('\p{Is_Joining_Group=-_Kaf:=}');
    Error('\P{Is_Joining_Group=-_Kaf:=}');
    Expect(1, 2228, '\p{Is_Joining_Group=kaf}', "");
    Expect(0, 2228, '\p{^Is_Joining_Group=kaf}', "");
    Expect(0, 2228, '\P{Is_Joining_Group=kaf}', "");
    Expect(1, 2228, '\P{^Is_Joining_Group=kaf}', "");
    Expect(0, 2229, '\p{Is_Joining_Group=kaf}', "");
    Expect(1, 2229, '\p{^Is_Joining_Group=kaf}', "");
    Expect(1, 2229, '\P{Is_Joining_Group=kaf}', "");
    Expect(0, 2229, '\P{^Is_Joining_Group=kaf}', "");
    Expect(1, 2228, '\p{Is_Joining_Group=-_KAF}', "");
    Expect(0, 2228, '\p{^Is_Joining_Group=-_KAF}', "");
    Expect(0, 2228, '\P{Is_Joining_Group=-_KAF}', "");
    Expect(1, 2228, '\P{^Is_Joining_Group=-_KAF}', "");
    Expect(0, 2229, '\p{Is_Joining_Group=-_KAF}', "");
    Expect(1, 2229, '\p{^Is_Joining_Group=-_KAF}', "");
    Expect(1, 2229, '\P{Is_Joining_Group=-_KAF}', "");
    Expect(0, 2229, '\P{^Is_Joining_Group=-_KAF}', "");
    Error('\p{Is_Jg=--Kaf/a/}');
    Error('\P{Is_Jg=--Kaf/a/}');
    Expect(1, 2228, '\p{Is_Jg=kaf}', "");
    Expect(0, 2228, '\p{^Is_Jg=kaf}', "");
    Expect(0, 2228, '\P{Is_Jg=kaf}', "");
    Expect(1, 2228, '\P{^Is_Jg=kaf}', "");
    Expect(0, 2229, '\p{Is_Jg=kaf}', "");
    Expect(1, 2229, '\p{^Is_Jg=kaf}', "");
    Expect(1, 2229, '\P{Is_Jg=kaf}', "");
    Expect(0, 2229, '\P{^Is_Jg=kaf}', "");
    Expect(1, 2228, '\p{Is_Jg=	-Kaf}', "");
    Expect(0, 2228, '\p{^Is_Jg=	-Kaf}', "");
    Expect(0, 2228, '\P{Is_Jg=	-Kaf}', "");
    Expect(1, 2228, '\P{^Is_Jg=	-Kaf}', "");
    Expect(0, 2229, '\p{Is_Jg=	-Kaf}', "");
    Expect(1, 2229, '\p{^Is_Jg=	-Kaf}', "");
    Expect(1, 2229, '\P{Is_Jg=	-Kaf}', "");
    Expect(0, 2229, '\P{^Is_Jg=	-Kaf}', "");
    Error('\p{Joining_Group=_:=KAPH}');
    Error('\P{Joining_Group=_:=KAPH}');
    Expect(1, 1823, '\p{Joining_Group=:\AKaph\z:}', "");;
    Expect(0, 1824, '\p{Joining_Group=:\AKaph\z:}', "");;
    Expect(1, 1823, '\p{Joining_Group=kaph}', "");
    Expect(0, 1823, '\p{^Joining_Group=kaph}', "");
    Expect(0, 1823, '\P{Joining_Group=kaph}', "");
    Expect(1, 1823, '\P{^Joining_Group=kaph}', "");
    Expect(0, 1824, '\p{Joining_Group=kaph}', "");
    Expect(1, 1824, '\p{^Joining_Group=kaph}', "");
    Expect(1, 1824, '\P{Joining_Group=kaph}', "");
    Expect(0, 1824, '\P{^Joining_Group=kaph}', "");
    Expect(1, 1823, '\p{Joining_Group=:\Akaph\z:}', "");;
    Expect(0, 1824, '\p{Joining_Group=:\Akaph\z:}', "");;
    Expect(1, 1823, '\p{Joining_Group=- Kaph}', "");
    Expect(0, 1823, '\p{^Joining_Group=- Kaph}', "");
    Expect(0, 1823, '\P{Joining_Group=- Kaph}', "");
    Expect(1, 1823, '\P{^Joining_Group=- Kaph}', "");
    Expect(0, 1824, '\p{Joining_Group=- Kaph}', "");
    Expect(1, 1824, '\p{^Joining_Group=- Kaph}', "");
    Expect(1, 1824, '\P{Joining_Group=- Kaph}', "");
    Expect(0, 1824, '\P{^Joining_Group=- Kaph}', "");
    Error('\p{Jg: _	kaph/a/}');
    Error('\P{Jg: _	kaph/a/}');
    Expect(1, 1823, '\p{Jg=:\AKaph\z:}', "");;
    Expect(0, 1824, '\p{Jg=:\AKaph\z:}', "");;
    Expect(1, 1823, '\p{Jg=kaph}', "");
    Expect(0, 1823, '\p{^Jg=kaph}', "");
    Expect(0, 1823, '\P{Jg=kaph}', "");
    Expect(1, 1823, '\P{^Jg=kaph}', "");
    Expect(0, 1824, '\p{Jg=kaph}', "");
    Expect(1, 1824, '\p{^Jg=kaph}', "");
    Expect(1, 1824, '\P{Jg=kaph}', "");
    Expect(0, 1824, '\P{^Jg=kaph}', "");
    Expect(1, 1823, '\p{Jg=:\Akaph\z:}', "");;
    Expect(0, 1824, '\p{Jg=:\Akaph\z:}', "");;
    Expect(1, 1823, '\p{Jg=_-kaph}', "");
    Expect(0, 1823, '\p{^Jg=_-kaph}', "");
    Expect(0, 1823, '\P{Jg=_-kaph}', "");
    Expect(1, 1823, '\P{^Jg=_-kaph}', "");
    Expect(0, 1824, '\p{Jg=_-kaph}', "");
    Expect(1, 1824, '\p{^Jg=_-kaph}', "");
    Expect(1, 1824, '\P{Jg=_-kaph}', "");
    Expect(0, 1824, '\P{^Jg=_-kaph}', "");
    Error('\p{Is_Joining_Group:    /a/Kaph}');
    Error('\P{Is_Joining_Group:    /a/Kaph}');
    Expect(1, 1823, '\p{Is_Joining_Group=kaph}', "");
    Expect(0, 1823, '\p{^Is_Joining_Group=kaph}', "");
    Expect(0, 1823, '\P{Is_Joining_Group=kaph}', "");
    Expect(1, 1823, '\P{^Is_Joining_Group=kaph}', "");
    Expect(0, 1824, '\p{Is_Joining_Group=kaph}', "");
    Expect(1, 1824, '\p{^Is_Joining_Group=kaph}', "");
    Expect(1, 1824, '\P{Is_Joining_Group=kaph}', "");
    Expect(0, 1824, '\P{^Is_Joining_Group=kaph}', "");
    Expect(1, 1823, '\p{Is_Joining_Group=  Kaph}', "");
    Expect(0, 1823, '\p{^Is_Joining_Group=  Kaph}', "");
    Expect(0, 1823, '\P{Is_Joining_Group=  Kaph}', "");
    Expect(1, 1823, '\P{^Is_Joining_Group=  Kaph}', "");
    Expect(0, 1824, '\p{Is_Joining_Group=  Kaph}', "");
    Expect(1, 1824, '\p{^Is_Joining_Group=  Kaph}', "");
    Expect(1, 1824, '\P{Is_Joining_Group=  Kaph}', "");
    Expect(0, 1824, '\P{^Is_Joining_Group=  Kaph}', "");
    Error('\p{Is_Jg=-	Kaph/a/}');
    Error('\P{Is_Jg=-	Kaph/a/}');
    Expect(1, 1823, '\p{Is_Jg=kaph}', "");
    Expect(0, 1823, '\p{^Is_Jg=kaph}', "");
    Expect(0, 1823, '\P{Is_Jg=kaph}', "");
    Expect(1, 1823, '\P{^Is_Jg=kaph}', "");
    Expect(0, 1824, '\p{Is_Jg=kaph}', "");
    Expect(1, 1824, '\p{^Is_Jg=kaph}', "");
    Expect(1, 1824, '\P{Is_Jg=kaph}', "");
    Expect(0, 1824, '\P{^Is_Jg=kaph}', "");
    Expect(1, 1823, '\p{Is_Jg=-	KAPH}', "");
    Expect(0, 1823, '\p{^Is_Jg=-	KAPH}', "");
    Expect(0, 1823, '\P{Is_Jg=-	KAPH}', "");
    Expect(1, 1823, '\P{^Is_Jg=-	KAPH}', "");
    Expect(0, 1824, '\p{Is_Jg=-	KAPH}', "");
    Expect(1, 1824, '\p{^Is_Jg=-	KAPH}', "");
    Expect(1, 1824, '\P{Is_Jg=-	KAPH}', "");
    Expect(0, 1824, '\P{^Is_Jg=-	KAPH}', "");
    Error('\p{Joining_Group=	-Khaph/a/}');
    Error('\P{Joining_Group=	-Khaph/a/}');
    Expect(1, 1870, '\p{Joining_Group=:\AKhaph\z:}', "");;
    Expect(0, 1871, '\p{Joining_Group=:\AKhaph\z:}', "");;
    Expect(1, 1870, '\p{Joining_Group=khaph}', "");
    Expect(0, 1870, '\p{^Joining_Group=khaph}', "");
    Expect(0, 1870, '\P{Joining_Group=khaph}', "");
    Expect(1, 1870, '\P{^Joining_Group=khaph}', "");
    Expect(0, 1871, '\p{Joining_Group=khaph}', "");
    Expect(1, 1871, '\p{^Joining_Group=khaph}', "");
    Expect(1, 1871, '\P{Joining_Group=khaph}', "");
    Expect(0, 1871, '\P{^Joining_Group=khaph}', "");
    Expect(1, 1870, '\p{Joining_Group=:\Akhaph\z:}', "");;
    Expect(0, 1871, '\p{Joining_Group=:\Akhaph\z:}', "");;
    Expect(1, 1870, '\p{Joining_Group=  Khaph}', "");
    Expect(0, 1870, '\p{^Joining_Group=  Khaph}', "");
    Expect(0, 1870, '\P{Joining_Group=  Khaph}', "");
    Expect(1, 1870, '\P{^Joining_Group=  Khaph}', "");
    Expect(0, 1871, '\p{Joining_Group=  Khaph}', "");
    Expect(1, 1871, '\p{^Joining_Group=  Khaph}', "");
    Expect(1, 1871, '\P{Joining_Group=  Khaph}', "");
    Expect(0, 1871, '\P{^Joining_Group=  Khaph}', "");
    Error('\p{Jg=:=_ khaph}');
    Error('\P{Jg=:=_ khaph}');
    Expect(1, 1870, '\p{Jg=:\AKhaph\z:}', "");;
    Expect(0, 1871, '\p{Jg=:\AKhaph\z:}', "");;
    Expect(1, 1870, '\p{Jg=khaph}', "");
    Expect(0, 1870, '\p{^Jg=khaph}', "");
    Expect(0, 1870, '\P{Jg=khaph}', "");
    Expect(1, 1870, '\P{^Jg=khaph}', "");
    Expect(0, 1871, '\p{Jg=khaph}', "");
    Expect(1, 1871, '\p{^Jg=khaph}', "");
    Expect(1, 1871, '\P{Jg=khaph}', "");
    Expect(0, 1871, '\P{^Jg=khaph}', "");
    Expect(1, 1870, '\p{Jg=:\Akhaph\z:}', "");;
    Expect(0, 1871, '\p{Jg=:\Akhaph\z:}', "");;
    Expect(1, 1870, '\p{Jg=-Khaph}', "");
    Expect(0, 1870, '\p{^Jg=-Khaph}', "");
    Expect(0, 1870, '\P{Jg=-Khaph}', "");
    Expect(1, 1870, '\P{^Jg=-Khaph}', "");
    Expect(0, 1871, '\p{Jg=-Khaph}', "");
    Expect(1, 1871, '\p{^Jg=-Khaph}', "");
    Expect(1, 1871, '\P{Jg=-Khaph}', "");
    Expect(0, 1871, '\P{^Jg=-Khaph}', "");
    Error('\p{Is_Joining_Group=/a/- Khaph}');
    Error('\P{Is_Joining_Group=/a/- Khaph}');
    Expect(1, 1870, '\p{Is_Joining_Group=khaph}', "");
    Expect(0, 1870, '\p{^Is_Joining_Group=khaph}', "");
    Expect(0, 1870, '\P{Is_Joining_Group=khaph}', "");
    Expect(1, 1870, '\P{^Is_Joining_Group=khaph}', "");
    Expect(0, 1871, '\p{Is_Joining_Group=khaph}', "");
    Expect(1, 1871, '\p{^Is_Joining_Group=khaph}', "");
    Expect(1, 1871, '\P{Is_Joining_Group=khaph}', "");
    Expect(0, 1871, '\P{^Is_Joining_Group=khaph}', "");
    Expect(1, 1870, '\p{Is_Joining_Group=_KHAPH}', "");
    Expect(0, 1870, '\p{^Is_Joining_Group=_KHAPH}', "");
    Expect(0, 1870, '\P{Is_Joining_Group=_KHAPH}', "");
    Expect(1, 1870, '\P{^Is_Joining_Group=_KHAPH}', "");
    Expect(0, 1871, '\p{Is_Joining_Group=_KHAPH}', "");
    Expect(1, 1871, '\p{^Is_Joining_Group=_KHAPH}', "");
    Expect(1, 1871, '\P{Is_Joining_Group=_KHAPH}', "");
    Expect(0, 1871, '\P{^Is_Joining_Group=_KHAPH}', "");
    Error('\p{Is_Jg=:=__khaph}');
    Error('\P{Is_Jg=:=__khaph}');
    Expect(1, 1870, '\p{Is_Jg=khaph}', "");
    Expect(0, 1870, '\p{^Is_Jg=khaph}', "");
    Expect(0, 1870, '\P{Is_Jg=khaph}', "");
    Expect(1, 1870, '\P{^Is_Jg=khaph}', "");
    Expect(0, 1871, '\p{Is_Jg=khaph}', "");
    Expect(1, 1871, '\p{^Is_Jg=khaph}', "");
    Expect(1, 1871, '\P{Is_Jg=khaph}', "");
    Expect(0, 1871, '\P{^Is_Jg=khaph}', "");
    Expect(1, 1870, '\p{Is_Jg=-KHAPH}', "");
    Expect(0, 1870, '\p{^Is_Jg=-KHAPH}', "");
    Expect(0, 1870, '\P{Is_Jg=-KHAPH}', "");
    Expect(1, 1870, '\P{^Is_Jg=-KHAPH}', "");
    Expect(0, 1871, '\p{Is_Jg=-KHAPH}', "");
    Expect(1, 1871, '\p{^Is_Jg=-KHAPH}', "");
    Expect(1, 1871, '\P{Is_Jg=-KHAPH}', "");
    Expect(0, 1871, '\P{^Is_Jg=-KHAPH}', "");
    Error('\p{Joining_Group= KNOTTED_HEH/a/}');
    Error('\P{Joining_Group= KNOTTED_HEH/a/}');
    Expect(1, 1791, '\p{Joining_Group=:\AKnotted_Heh\z:}', "");;
    Expect(0, 1792, '\p{Joining_Group=:\AKnotted_Heh\z:}', "");;
    Expect(1, 1791, '\p{Joining_Group: knottedheh}', "");
    Expect(0, 1791, '\p{^Joining_Group: knottedheh}', "");
    Expect(0, 1791, '\P{Joining_Group: knottedheh}', "");
    Expect(1, 1791, '\P{^Joining_Group: knottedheh}', "");
    Expect(0, 1792, '\p{Joining_Group: knottedheh}', "");
    Expect(1, 1792, '\p{^Joining_Group: knottedheh}', "");
    Expect(1, 1792, '\P{Joining_Group: knottedheh}', "");
    Expect(0, 1792, '\P{^Joining_Group: knottedheh}', "");
    Expect(1, 1791, '\p{Joining_Group=:\Aknottedheh\z:}', "");;
    Expect(0, 1792, '\p{Joining_Group=:\Aknottedheh\z:}', "");;
    Expect(1, 1791, '\p{Joining_Group:		-Knotted_HEH}', "");
    Expect(0, 1791, '\p{^Joining_Group:		-Knotted_HEH}', "");
    Expect(0, 1791, '\P{Joining_Group:		-Knotted_HEH}', "");
    Expect(1, 1791, '\P{^Joining_Group:		-Knotted_HEH}', "");
    Expect(0, 1792, '\p{Joining_Group:		-Knotted_HEH}', "");
    Expect(1, 1792, '\p{^Joining_Group:		-Knotted_HEH}', "");
    Expect(1, 1792, '\P{Joining_Group:		-Knotted_HEH}', "");
    Expect(0, 1792, '\P{^Joining_Group:		-Knotted_HEH}', "");
    Error('\p{Jg=/a/-Knotted_HEH}');
    Error('\P{Jg=/a/-Knotted_HEH}');
    Expect(1, 1791, '\p{Jg=:\AKnotted_Heh\z:}', "");;
    Expect(0, 1792, '\p{Jg=:\AKnotted_Heh\z:}', "");;
    Expect(1, 1791, '\p{Jg=knottedheh}', "");
    Expect(0, 1791, '\p{^Jg=knottedheh}', "");
    Expect(0, 1791, '\P{Jg=knottedheh}', "");
    Expect(1, 1791, '\P{^Jg=knottedheh}', "");
    Expect(0, 1792, '\p{Jg=knottedheh}', "");
    Expect(1, 1792, '\p{^Jg=knottedheh}', "");
    Expect(1, 1792, '\P{Jg=knottedheh}', "");
    Expect(0, 1792, '\P{^Jg=knottedheh}', "");
    Expect(1, 1791, '\p{Jg=:\Aknottedheh\z:}', "");;
    Expect(0, 1792, '\p{Jg=:\Aknottedheh\z:}', "");;
    Expect(1, 1791, '\p{Jg=	knotted_HEH}', "");
    Expect(0, 1791, '\p{^Jg=	knotted_HEH}', "");
    Expect(0, 1791, '\P{Jg=	knotted_HEH}', "");
    Expect(1, 1791, '\P{^Jg=	knotted_HEH}', "");
    Expect(0, 1792, '\p{Jg=	knotted_HEH}', "");
    Expect(1, 1792, '\p{^Jg=	knotted_HEH}', "");
    Expect(1, 1792, '\P{Jg=	knotted_HEH}', "");
    Expect(0, 1792, '\P{^Jg=	knotted_HEH}', "");
    Error('\p{Is_Joining_Group=/a/_Knotted_Heh}');
    Error('\P{Is_Joining_Group=/a/_Knotted_Heh}');
    Expect(1, 1791, '\p{Is_Joining_Group=knottedheh}', "");
    Expect(0, 1791, '\p{^Is_Joining_Group=knottedheh}', "");
    Expect(0, 1791, '\P{Is_Joining_Group=knottedheh}', "");
    Expect(1, 1791, '\P{^Is_Joining_Group=knottedheh}', "");
    Expect(0, 1792, '\p{Is_Joining_Group=knottedheh}', "");
    Expect(1, 1792, '\p{^Is_Joining_Group=knottedheh}', "");
    Expect(1, 1792, '\P{Is_Joining_Group=knottedheh}', "");
    Expect(0, 1792, '\P{^Is_Joining_Group=knottedheh}', "");
    Expect(1, 1791, '\p{Is_Joining_Group=	knotted_HEH}', "");
    Expect(0, 1791, '\p{^Is_Joining_Group=	knotted_HEH}', "");
    Expect(0, 1791, '\P{Is_Joining_Group=	knotted_HEH}', "");
    Expect(1, 1791, '\P{^Is_Joining_Group=	knotted_HEH}', "");
    Expect(0, 1792, '\p{Is_Joining_Group=	knotted_HEH}', "");
    Expect(1, 1792, '\p{^Is_Joining_Group=	knotted_HEH}', "");
    Expect(1, 1792, '\P{Is_Joining_Group=	knotted_HEH}', "");
    Expect(0, 1792, '\P{^Is_Joining_Group=	knotted_HEH}', "");
    Error('\p{Is_Jg=  KNOTTED_Heh/a/}');
    Error('\P{Is_Jg=  KNOTTED_Heh/a/}');
    Expect(1, 1791, '\p{Is_Jg=knottedheh}', "");
    Expect(0, 1791, '\p{^Is_Jg=knottedheh}', "");
    Expect(0, 1791, '\P{Is_Jg=knottedheh}', "");
    Expect(1, 1791, '\P{^Is_Jg=knottedheh}', "");
    Expect(0, 1792, '\p{Is_Jg=knottedheh}', "");
    Expect(1, 1792, '\p{^Is_Jg=knottedheh}', "");
    Expect(1, 1792, '\P{Is_Jg=knottedheh}', "");
    Expect(0, 1792, '\P{^Is_Jg=knottedheh}', "");
    Expect(1, 1791, '\p{Is_Jg=_	Knotted_HEH}', "");
    Expect(0, 1791, '\p{^Is_Jg=_	Knotted_HEH}', "");
    Expect(0, 1791, '\P{Is_Jg=_	Knotted_HEH}', "");
    Expect(1, 1791, '\P{^Is_Jg=_	Knotted_HEH}', "");
    Expect(0, 1792, '\p{Is_Jg=_	Knotted_HEH}', "");
    Expect(1, 1792, '\p{^Is_Jg=_	Knotted_HEH}', "");
    Expect(1, 1792, '\P{Is_Jg=_	Knotted_HEH}', "");
    Expect(0, 1792, '\P{^Is_Jg=_	Knotted_HEH}', "");
    Error('\p{Joining_Group:   -lam/a/}');
    Error('\P{Joining_Group:   -lam/a/}');
    Expect(1, 2247, '\p{Joining_Group=:\ALam\z:}', "");;
    Expect(0, 2248, '\p{Joining_Group=:\ALam\z:}', "");;
    Expect(1, 2247, '\p{Joining_Group=lam}', "");
    Expect(0, 2247, '\p{^Joining_Group=lam}', "");
    Expect(0, 2247, '\P{Joining_Group=lam}', "");
    Expect(1, 2247, '\P{^Joining_Group=lam}', "");
    Expect(0, 2248, '\p{Joining_Group=lam}', "");
    Expect(1, 2248, '\p{^Joining_Group=lam}', "");
    Expect(1, 2248, '\P{Joining_Group=lam}', "");
    Expect(0, 2248, '\P{^Joining_Group=lam}', "");
    Expect(1, 2247, '\p{Joining_Group=:\Alam\z:}', "");;
    Expect(0, 2248, '\p{Joining_Group=:\Alam\z:}', "");;
    Expect(1, 2247, '\p{Joining_Group=	Lam}', "");
    Expect(0, 2247, '\p{^Joining_Group=	Lam}', "");
    Expect(0, 2247, '\P{Joining_Group=	Lam}', "");
    Expect(1, 2247, '\P{^Joining_Group=	Lam}', "");
    Expect(0, 2248, '\p{Joining_Group=	Lam}', "");
    Expect(1, 2248, '\p{^Joining_Group=	Lam}', "");
    Expect(1, 2248, '\P{Joining_Group=	Lam}', "");
    Expect(0, 2248, '\P{^Joining_Group=	Lam}', "");
    Error('\p{Jg=	:=Lam}');
    Error('\P{Jg=	:=Lam}');
    Expect(1, 2247, '\p{Jg=:\ALam\z:}', "");;
    Expect(0, 2248, '\p{Jg=:\ALam\z:}', "");;
    Expect(1, 2247, '\p{Jg=lam}', "");
    Expect(0, 2247, '\p{^Jg=lam}', "");
    Expect(0, 2247, '\P{Jg=lam}', "");
    Expect(1, 2247, '\P{^Jg=lam}', "");
    Expect(0, 2248, '\p{Jg=lam}', "");
    Expect(1, 2248, '\p{^Jg=lam}', "");
    Expect(1, 2248, '\P{Jg=lam}', "");
    Expect(0, 2248, '\P{^Jg=lam}', "");
    Expect(1, 2247, '\p{Jg=:\Alam\z:}', "");;
    Expect(0, 2248, '\p{Jg=:\Alam\z:}', "");;
    Expect(1, 2247, '\p{Jg=_-LAM}', "");
    Expect(0, 2247, '\p{^Jg=_-LAM}', "");
    Expect(0, 2247, '\P{Jg=_-LAM}', "");
    Expect(1, 2247, '\P{^Jg=_-LAM}', "");
    Expect(0, 2248, '\p{Jg=_-LAM}', "");
    Expect(1, 2248, '\p{^Jg=_-LAM}', "");
    Expect(1, 2248, '\P{Jg=_-LAM}', "");
    Expect(0, 2248, '\P{^Jg=_-LAM}', "");
    Error('\p{Is_Joining_Group=/a/lam}');
    Error('\P{Is_Joining_Group=/a/lam}');
    Expect(1, 2247, '\p{Is_Joining_Group=lam}', "");
    Expect(0, 2247, '\p{^Is_Joining_Group=lam}', "");
    Expect(0, 2247, '\P{Is_Joining_Group=lam}', "");
    Expect(1, 2247, '\P{^Is_Joining_Group=lam}', "");
    Expect(0, 2248, '\p{Is_Joining_Group=lam}', "");
    Expect(1, 2248, '\p{^Is_Joining_Group=lam}', "");
    Expect(1, 2248, '\P{Is_Joining_Group=lam}', "");
    Expect(0, 2248, '\P{^Is_Joining_Group=lam}', "");
    Expect(1, 2247, '\p{Is_Joining_Group=	Lam}', "");
    Expect(0, 2247, '\p{^Is_Joining_Group=	Lam}', "");
    Expect(0, 2247, '\P{Is_Joining_Group=	Lam}', "");
    Expect(1, 2247, '\P{^Is_Joining_Group=	Lam}', "");
    Expect(0, 2248, '\p{Is_Joining_Group=	Lam}', "");
    Expect(1, 2248, '\p{^Is_Joining_Group=	Lam}', "");
    Expect(1, 2248, '\P{Is_Joining_Group=	Lam}', "");
    Expect(0, 2248, '\P{^Is_Joining_Group=	Lam}', "");
    Error('\p{Is_Jg=_/a/lam}');
    Error('\P{Is_Jg=_/a/lam}');
    Expect(1, 2247, '\p{Is_Jg=lam}', "");
    Expect(0, 2247, '\p{^Is_Jg=lam}', "");
    Expect(0, 2247, '\P{Is_Jg=lam}', "");
    Expect(1, 2247, '\P{^Is_Jg=lam}', "");
    Expect(0, 2248, '\p{Is_Jg=lam}', "");
    Expect(1, 2248, '\p{^Is_Jg=lam}', "");
    Expect(1, 2248, '\P{Is_Jg=lam}', "");
    Expect(0, 2248, '\P{^Is_Jg=lam}', "");
    Expect(1, 2247, '\p{Is_Jg=-LAM}', "");
    Expect(0, 2247, '\p{^Is_Jg=-LAM}', "");
    Expect(0, 2247, '\P{Is_Jg=-LAM}', "");
    Expect(1, 2247, '\P{^Is_Jg=-LAM}', "");
    Expect(0, 2248, '\p{Is_Jg=-LAM}', "");
    Expect(1, 2248, '\p{^Is_Jg=-LAM}', "");
    Expect(1, 2248, '\P{Is_Jg=-LAM}', "");
    Expect(0, 2248, '\P{^Is_Jg=-LAM}', "");
    Error('\p{Joining_Group=/a/_-Lamadh}');
    Error('\P{Joining_Group=/a/_-Lamadh}');
    Expect(1, 1824, '\p{Joining_Group=:\ALamadh\z:}', "");;
    Expect(0, 1825, '\p{Joining_Group=:\ALamadh\z:}', "");;
    Expect(1, 1824, '\p{Joining_Group=lamadh}', "");
    Expect(0, 1824, '\p{^Joining_Group=lamadh}', "");
    Expect(0, 1824, '\P{Joining_Group=lamadh}', "");
    Expect(1, 1824, '\P{^Joining_Group=lamadh}', "");
    Expect(0, 1825, '\p{Joining_Group=lamadh}', "");
    Expect(1, 1825, '\p{^Joining_Group=lamadh}', "");
    Expect(1, 1825, '\P{Joining_Group=lamadh}', "");
    Expect(0, 1825, '\P{^Joining_Group=lamadh}', "");
    Expect(1, 1824, '\p{Joining_Group=:\Alamadh\z:}', "");;
    Expect(0, 1825, '\p{Joining_Group=:\Alamadh\z:}', "");;
    Expect(1, 1824, '\p{Joining_Group=	_lamadh}', "");
    Expect(0, 1824, '\p{^Joining_Group=	_lamadh}', "");
    Expect(0, 1824, '\P{Joining_Group=	_lamadh}', "");
    Expect(1, 1824, '\P{^Joining_Group=	_lamadh}', "");
    Expect(0, 1825, '\p{Joining_Group=	_lamadh}', "");
    Expect(1, 1825, '\p{^Joining_Group=	_lamadh}', "");
    Expect(1, 1825, '\P{Joining_Group=	_lamadh}', "");
    Expect(0, 1825, '\P{^Joining_Group=	_lamadh}', "");
    Error('\p{Jg=_-Lamadh/a/}');
    Error('\P{Jg=_-Lamadh/a/}');
    Expect(1, 1824, '\p{Jg=:\ALamadh\z:}', "");;
    Expect(0, 1825, '\p{Jg=:\ALamadh\z:}', "");;
    Expect(1, 1824, '\p{Jg=lamadh}', "");
    Expect(0, 1824, '\p{^Jg=lamadh}', "");
    Expect(0, 1824, '\P{Jg=lamadh}', "");
    Expect(1, 1824, '\P{^Jg=lamadh}', "");
    Expect(0, 1825, '\p{Jg=lamadh}', "");
    Expect(1, 1825, '\p{^Jg=lamadh}', "");
    Expect(1, 1825, '\P{Jg=lamadh}', "");
    Expect(0, 1825, '\P{^Jg=lamadh}', "");
    Expect(1, 1824, '\p{Jg=:\Alamadh\z:}', "");;
    Expect(0, 1825, '\p{Jg=:\Alamadh\z:}', "");;
    Expect(1, 1824, '\p{Jg= lamadh}', "");
    Expect(0, 1824, '\p{^Jg= lamadh}', "");
    Expect(0, 1824, '\P{Jg= lamadh}', "");
    Expect(1, 1824, '\P{^Jg= lamadh}', "");
    Expect(0, 1825, '\p{Jg= lamadh}', "");
    Expect(1, 1825, '\p{^Jg= lamadh}', "");
    Expect(1, 1825, '\P{Jg= lamadh}', "");
    Expect(0, 1825, '\P{^Jg= lamadh}', "");
    Error('\p{Is_Joining_Group=_/a/Lamadh}');
    Error('\P{Is_Joining_Group=_/a/Lamadh}');
    Expect(1, 1824, '\p{Is_Joining_Group=lamadh}', "");
    Expect(0, 1824, '\p{^Is_Joining_Group=lamadh}', "");
    Expect(0, 1824, '\P{Is_Joining_Group=lamadh}', "");
    Expect(1, 1824, '\P{^Is_Joining_Group=lamadh}', "");
    Expect(0, 1825, '\p{Is_Joining_Group=lamadh}', "");
    Expect(1, 1825, '\p{^Is_Joining_Group=lamadh}', "");
    Expect(1, 1825, '\P{Is_Joining_Group=lamadh}', "");
    Expect(0, 1825, '\P{^Is_Joining_Group=lamadh}', "");
    Expect(1, 1824, '\p{Is_Joining_Group= 	lamadh}', "");
    Expect(0, 1824, '\p{^Is_Joining_Group= 	lamadh}', "");
    Expect(0, 1824, '\P{Is_Joining_Group= 	lamadh}', "");
    Expect(1, 1824, '\P{^Is_Joining_Group= 	lamadh}', "");
    Expect(0, 1825, '\p{Is_Joining_Group= 	lamadh}', "");
    Expect(1, 1825, '\p{^Is_Joining_Group= 	lamadh}', "");
    Expect(1, 1825, '\P{Is_Joining_Group= 	lamadh}', "");
    Expect(0, 1825, '\P{^Is_Joining_Group= 	lamadh}', "");
    Error('\p{Is_Jg: /a/		LAMADH}');
    Error('\P{Is_Jg: /a/		LAMADH}');
    Expect(1, 1824, '\p{Is_Jg=lamadh}', "");
    Expect(0, 1824, '\p{^Is_Jg=lamadh}', "");
    Expect(0, 1824, '\P{Is_Jg=lamadh}', "");
    Expect(1, 1824, '\P{^Is_Jg=lamadh}', "");
    Expect(0, 1825, '\p{Is_Jg=lamadh}', "");
    Expect(1, 1825, '\p{^Is_Jg=lamadh}', "");
    Expect(1, 1825, '\P{Is_Jg=lamadh}', "");
    Expect(0, 1825, '\P{^Is_Jg=lamadh}', "");
    Expect(1, 1824, '\p{Is_Jg: 		LAMADH}', "");
    Expect(0, 1824, '\p{^Is_Jg: 		LAMADH}', "");
    Expect(0, 1824, '\P{Is_Jg: 		LAMADH}', "");
    Expect(1, 1824, '\P{^Is_Jg: 		LAMADH}', "");
    Expect(0, 1825, '\p{Is_Jg: 		LAMADH}', "");
    Expect(1, 1825, '\p{^Is_Jg: 		LAMADH}', "");
    Expect(1, 1825, '\P{Is_Jg: 		LAMADH}', "");
    Expect(0, 1825, '\P{^Is_Jg: 		LAMADH}', "");
    Error('\p{Joining_Group=/a/malayalam_bha}');
    Error('\P{Joining_Group=/a/malayalam_bha}');
    Expect(1, 2150, '\p{Joining_Group=:\AMalayalam_Bha\z:}', "");;
    Expect(0, 2151, '\p{Joining_Group=:\AMalayalam_Bha\z:}', "");;
    Expect(1, 2150, '\p{Joining_Group=malayalambha}', "");
    Expect(0, 2150, '\p{^Joining_Group=malayalambha}', "");
    Expect(0, 2150, '\P{Joining_Group=malayalambha}', "");
    Expect(1, 2150, '\P{^Joining_Group=malayalambha}', "");
    Expect(0, 2151, '\p{Joining_Group=malayalambha}', "");
    Expect(1, 2151, '\p{^Joining_Group=malayalambha}', "");
    Expect(1, 2151, '\P{Joining_Group=malayalambha}', "");
    Expect(0, 2151, '\P{^Joining_Group=malayalambha}', "");
    Expect(1, 2150, '\p{Joining_Group=:\Amalayalambha\z:}', "");;
    Expect(0, 2151, '\p{Joining_Group=:\Amalayalambha\z:}', "");;
    Expect(1, 2150, '\p{Joining_Group=MALAYALAM_BHA}', "");
    Expect(0, 2150, '\p{^Joining_Group=MALAYALAM_BHA}', "");
    Expect(0, 2150, '\P{Joining_Group=MALAYALAM_BHA}', "");
    Expect(1, 2150, '\P{^Joining_Group=MALAYALAM_BHA}', "");
    Expect(0, 2151, '\p{Joining_Group=MALAYALAM_BHA}', "");
    Expect(1, 2151, '\p{^Joining_Group=MALAYALAM_BHA}', "");
    Expect(1, 2151, '\P{Joining_Group=MALAYALAM_BHA}', "");
    Expect(0, 2151, '\P{^Joining_Group=MALAYALAM_BHA}', "");
    Error('\p{Jg=/a/malayalam_Bha}');
    Error('\P{Jg=/a/malayalam_Bha}');
    Expect(1, 2150, '\p{Jg=:\AMalayalam_Bha\z:}', "");;
    Expect(0, 2151, '\p{Jg=:\AMalayalam_Bha\z:}', "");;
    Expect(1, 2150, '\p{Jg=malayalambha}', "");
    Expect(0, 2150, '\p{^Jg=malayalambha}', "");
    Expect(0, 2150, '\P{Jg=malayalambha}', "");
    Expect(1, 2150, '\P{^Jg=malayalambha}', "");
    Expect(0, 2151, '\p{Jg=malayalambha}', "");
    Expect(1, 2151, '\p{^Jg=malayalambha}', "");
    Expect(1, 2151, '\P{Jg=malayalambha}', "");
    Expect(0, 2151, '\P{^Jg=malayalambha}', "");
    Expect(1, 2150, '\p{Jg=:\Amalayalambha\z:}', "");;
    Expect(0, 2151, '\p{Jg=:\Amalayalambha\z:}', "");;
    Expect(1, 2150, '\p{Jg= Malayalam_BHA}', "");
    Expect(0, 2150, '\p{^Jg= Malayalam_BHA}', "");
    Expect(0, 2150, '\P{Jg= Malayalam_BHA}', "");
    Expect(1, 2150, '\P{^Jg= Malayalam_BHA}', "");
    Expect(0, 2151, '\p{Jg= Malayalam_BHA}', "");
    Expect(1, 2151, '\p{^Jg= Malayalam_BHA}', "");
    Expect(1, 2151, '\P{Jg= Malayalam_BHA}', "");
    Expect(0, 2151, '\P{^Jg= Malayalam_BHA}', "");
    Error('\p{Is_Joining_Group=_	Malayalam_bha:=}');
    Error('\P{Is_Joining_Group=_	Malayalam_bha:=}');
    Expect(1, 2150, '\p{Is_Joining_Group=malayalambha}', "");
    Expect(0, 2150, '\p{^Is_Joining_Group=malayalambha}', "");
    Expect(0, 2150, '\P{Is_Joining_Group=malayalambha}', "");
    Expect(1, 2150, '\P{^Is_Joining_Group=malayalambha}', "");
    Expect(0, 2151, '\p{Is_Joining_Group=malayalambha}', "");
    Expect(1, 2151, '\p{^Is_Joining_Group=malayalambha}', "");
    Expect(1, 2151, '\P{Is_Joining_Group=malayalambha}', "");
    Expect(0, 2151, '\P{^Is_Joining_Group=malayalambha}', "");
    Expect(1, 2150, '\p{Is_Joining_Group=	-Malayalam_Bha}', "");
    Expect(0, 2150, '\p{^Is_Joining_Group=	-Malayalam_Bha}', "");
    Expect(0, 2150, '\P{Is_Joining_Group=	-Malayalam_Bha}', "");
    Expect(1, 2150, '\P{^Is_Joining_Group=	-Malayalam_Bha}', "");
    Expect(0, 2151, '\p{Is_Joining_Group=	-Malayalam_Bha}', "");
    Expect(1, 2151, '\p{^Is_Joining_Group=	-Malayalam_Bha}', "");
    Expect(1, 2151, '\P{Is_Joining_Group=	-Malayalam_Bha}', "");
    Expect(0, 2151, '\P{^Is_Joining_Group=	-Malayalam_Bha}', "");
    Error('\p{Is_Jg=/a/	-Malayalam_Bha}');
    Error('\P{Is_Jg=/a/	-Malayalam_Bha}');
    Expect(1, 2150, '\p{Is_Jg=malayalambha}', "");
    Expect(0, 2150, '\p{^Is_Jg=malayalambha}', "");
    Expect(0, 2150, '\P{Is_Jg=malayalambha}', "");
    Expect(1, 2150, '\P{^Is_Jg=malayalambha}', "");
    Expect(0, 2151, '\p{Is_Jg=malayalambha}', "");
    Expect(1, 2151, '\p{^Is_Jg=malayalambha}', "");
    Expect(1, 2151, '\P{Is_Jg=malayalambha}', "");
    Expect(0, 2151, '\P{^Is_Jg=malayalambha}', "");
    Expect(1, 2150, '\p{Is_Jg=- Malayalam_Bha}', "");
    Expect(0, 2150, '\p{^Is_Jg=- Malayalam_Bha}', "");
    Expect(0, 2150, '\P{Is_Jg=- Malayalam_Bha}', "");
    Expect(1, 2150, '\P{^Is_Jg=- Malayalam_Bha}', "");
    Expect(0, 2151, '\p{Is_Jg=- Malayalam_Bha}', "");
    Expect(1, 2151, '\p{^Is_Jg=- Malayalam_Bha}', "");
    Expect(1, 2151, '\P{Is_Jg=- Malayalam_Bha}', "");
    Expect(0, 2151, '\P{^Is_Jg=- Malayalam_Bha}', "");
    Error('\p{Joining_Group=-:=Malayalam_JA}');
    Error('\P{Joining_Group=-:=Malayalam_JA}');
    Expect(1, 2145, '\p{Joining_Group=:\AMalayalam_Ja\z:}', "");;
    Expect(0, 2146, '\p{Joining_Group=:\AMalayalam_Ja\z:}', "");;
    Expect(1, 2145, '\p{Joining_Group=malayalamja}', "");
    Expect(0, 2145, '\p{^Joining_Group=malayalamja}', "");
    Expect(0, 2145, '\P{Joining_Group=malayalamja}', "");
    Expect(1, 2145, '\P{^Joining_Group=malayalamja}', "");
    Expect(0, 2146, '\p{Joining_Group=malayalamja}', "");
    Expect(1, 2146, '\p{^Joining_Group=malayalamja}', "");
    Expect(1, 2146, '\P{Joining_Group=malayalamja}', "");
    Expect(0, 2146, '\P{^Joining_Group=malayalamja}', "");
    Expect(1, 2145, '\p{Joining_Group=:\Amalayalamja\z:}', "");;
    Expect(0, 2146, '\p{Joining_Group=:\Amalayalamja\z:}', "");;
    Expect(1, 2145, '\p{Joining_Group=	_malayalam_JA}', "");
    Expect(0, 2145, '\p{^Joining_Group=	_malayalam_JA}', "");
    Expect(0, 2145, '\P{Joining_Group=	_malayalam_JA}', "");
    Expect(1, 2145, '\P{^Joining_Group=	_malayalam_JA}', "");
    Expect(0, 2146, '\p{Joining_Group=	_malayalam_JA}', "");
    Expect(1, 2146, '\p{^Joining_Group=	_malayalam_JA}', "");
    Expect(1, 2146, '\P{Joining_Group=	_malayalam_JA}', "");
    Expect(0, 2146, '\P{^Joining_Group=	_malayalam_JA}', "");
    Error('\p{Jg=	-MALAYALAM_ja:=}');
    Error('\P{Jg=	-MALAYALAM_ja:=}');
    Expect(1, 2145, '\p{Jg=:\AMalayalam_Ja\z:}', "");;
    Expect(0, 2146, '\p{Jg=:\AMalayalam_Ja\z:}', "");;
    Expect(1, 2145, '\p{Jg=malayalamja}', "");
    Expect(0, 2145, '\p{^Jg=malayalamja}', "");
    Expect(0, 2145, '\P{Jg=malayalamja}', "");
    Expect(1, 2145, '\P{^Jg=malayalamja}', "");
    Expect(0, 2146, '\p{Jg=malayalamja}', "");
    Expect(1, 2146, '\p{^Jg=malayalamja}', "");
    Expect(1, 2146, '\P{Jg=malayalamja}', "");
    Expect(0, 2146, '\P{^Jg=malayalamja}', "");
    Expect(1, 2145, '\p{Jg=:\Amalayalamja\z:}', "");;
    Expect(0, 2146, '\p{Jg=:\Amalayalamja\z:}', "");;
    Expect(1, 2145, '\p{Jg=-MALAYALAM_Ja}', "");
    Expect(0, 2145, '\p{^Jg=-MALAYALAM_Ja}', "");
    Expect(0, 2145, '\P{Jg=-MALAYALAM_Ja}', "");
    Expect(1, 2145, '\P{^Jg=-MALAYALAM_Ja}', "");
    Expect(0, 2146, '\p{Jg=-MALAYALAM_Ja}', "");
    Expect(1, 2146, '\p{^Jg=-MALAYALAM_Ja}', "");
    Expect(1, 2146, '\P{Jg=-MALAYALAM_Ja}', "");
    Expect(0, 2146, '\P{^Jg=-MALAYALAM_Ja}', "");
    Error('\p{Is_Joining_Group=	/a/Malayalam_Ja}');
    Error('\P{Is_Joining_Group=	/a/Malayalam_Ja}');
    Expect(1, 2145, '\p{Is_Joining_Group=malayalamja}', "");
    Expect(0, 2145, '\p{^Is_Joining_Group=malayalamja}', "");
    Expect(0, 2145, '\P{Is_Joining_Group=malayalamja}', "");
    Expect(1, 2145, '\P{^Is_Joining_Group=malayalamja}', "");
    Expect(0, 2146, '\p{Is_Joining_Group=malayalamja}', "");
    Expect(1, 2146, '\p{^Is_Joining_Group=malayalamja}', "");
    Expect(1, 2146, '\P{Is_Joining_Group=malayalamja}', "");
    Expect(0, 2146, '\P{^Is_Joining_Group=malayalamja}', "");
    Expect(1, 2145, '\p{Is_Joining_Group=	MALAYALAM_Ja}', "");
    Expect(0, 2145, '\p{^Is_Joining_Group=	MALAYALAM_Ja}', "");
    Expect(0, 2145, '\P{Is_Joining_Group=	MALAYALAM_Ja}', "");
    Expect(1, 2145, '\P{^Is_Joining_Group=	MALAYALAM_Ja}', "");
    Expect(0, 2146, '\p{Is_Joining_Group=	MALAYALAM_Ja}', "");
    Expect(1, 2146, '\p{^Is_Joining_Group=	MALAYALAM_Ja}', "");
    Expect(1, 2146, '\P{Is_Joining_Group=	MALAYALAM_Ja}', "");
    Expect(0, 2146, '\P{^Is_Joining_Group=	MALAYALAM_Ja}', "");
    Error('\p{Is_Jg:   __malayalam_ja:=}');
    Error('\P{Is_Jg:   __malayalam_ja:=}');
    Expect(1, 2145, '\p{Is_Jg=malayalamja}', "");
    Expect(0, 2145, '\p{^Is_Jg=malayalamja}', "");
    Expect(0, 2145, '\P{Is_Jg=malayalamja}', "");
    Expect(1, 2145, '\P{^Is_Jg=malayalamja}', "");
    Expect(0, 2146, '\p{Is_Jg=malayalamja}', "");
    Expect(1, 2146, '\p{^Is_Jg=malayalamja}', "");
    Expect(1, 2146, '\P{Is_Jg=malayalamja}', "");
    Expect(0, 2146, '\P{^Is_Jg=malayalamja}', "");
    Expect(1, 2145, '\p{Is_Jg= -Malayalam_JA}', "");
    Expect(0, 2145, '\p{^Is_Jg= -Malayalam_JA}', "");
    Expect(0, 2145, '\P{Is_Jg= -Malayalam_JA}', "");
    Expect(1, 2145, '\P{^Is_Jg= -Malayalam_JA}', "");
    Expect(0, 2146, '\p{Is_Jg= -Malayalam_JA}', "");
    Expect(1, 2146, '\p{^Is_Jg= -Malayalam_JA}', "");
    Expect(1, 2146, '\P{Is_Jg= -Malayalam_JA}', "");
    Expect(0, 2146, '\P{^Is_Jg= -Malayalam_JA}', "");
    Error('\p{Joining_Group= Malayalam_Lla:=}');
    Error('\P{Joining_Group= Malayalam_Lla:=}');
    Expect(1, 2152, '\p{Joining_Group=:\AMalayalam_Lla\z:}', "");;
    Expect(0, 2153, '\p{Joining_Group=:\AMalayalam_Lla\z:}', "");;
    Expect(1, 2152, '\p{Joining_Group=malayalamlla}', "");
    Expect(0, 2152, '\p{^Joining_Group=malayalamlla}', "");
    Expect(0, 2152, '\P{Joining_Group=malayalamlla}', "");
    Expect(1, 2152, '\P{^Joining_Group=malayalamlla}', "");
    Expect(0, 2153, '\p{Joining_Group=malayalamlla}', "");
    Expect(1, 2153, '\p{^Joining_Group=malayalamlla}', "");
    Expect(1, 2153, '\P{Joining_Group=malayalamlla}', "");
    Expect(0, 2153, '\P{^Joining_Group=malayalamlla}', "");
    Expect(1, 2152, '\p{Joining_Group=:\Amalayalamlla\z:}', "");;
    Expect(0, 2153, '\p{Joining_Group=:\Amalayalamlla\z:}', "");;
    Expect(1, 2152, '\p{Joining_Group=  MALAYALAM_Lla}', "");
    Expect(0, 2152, '\p{^Joining_Group=  MALAYALAM_Lla}', "");
    Expect(0, 2152, '\P{Joining_Group=  MALAYALAM_Lla}', "");
    Expect(1, 2152, '\P{^Joining_Group=  MALAYALAM_Lla}', "");
    Expect(0, 2153, '\p{Joining_Group=  MALAYALAM_Lla}', "");
    Expect(1, 2153, '\p{^Joining_Group=  MALAYALAM_Lla}', "");
    Expect(1, 2153, '\P{Joining_Group=  MALAYALAM_Lla}', "");
    Expect(0, 2153, '\P{^Joining_Group=  MALAYALAM_Lla}', "");
    Error('\p{Jg=	-malayalam_lla/a/}');
    Error('\P{Jg=	-malayalam_lla/a/}');
    Expect(1, 2152, '\p{Jg=:\AMalayalam_Lla\z:}', "");;
    Expect(0, 2153, '\p{Jg=:\AMalayalam_Lla\z:}', "");;
    Expect(1, 2152, '\p{Jg=malayalamlla}', "");
    Expect(0, 2152, '\p{^Jg=malayalamlla}', "");
    Expect(0, 2152, '\P{Jg=malayalamlla}', "");
    Expect(1, 2152, '\P{^Jg=malayalamlla}', "");
    Expect(0, 2153, '\p{Jg=malayalamlla}', "");
    Expect(1, 2153, '\p{^Jg=malayalamlla}', "");
    Expect(1, 2153, '\P{Jg=malayalamlla}', "");
    Expect(0, 2153, '\P{^Jg=malayalamlla}', "");
    Expect(1, 2152, '\p{Jg=:\Amalayalamlla\z:}', "");;
    Expect(0, 2153, '\p{Jg=:\Amalayalamlla\z:}', "");;
    Expect(1, 2152, '\p{Jg= Malayalam_LLA}', "");
    Expect(0, 2152, '\p{^Jg= Malayalam_LLA}', "");
    Expect(0, 2152, '\P{Jg= Malayalam_LLA}', "");
    Expect(1, 2152, '\P{^Jg= Malayalam_LLA}', "");
    Expect(0, 2153, '\p{Jg= Malayalam_LLA}', "");
    Expect(1, 2153, '\p{^Jg= Malayalam_LLA}', "");
    Expect(1, 2153, '\P{Jg= Malayalam_LLA}', "");
    Expect(0, 2153, '\P{^Jg= Malayalam_LLA}', "");
    Error('\p{Is_Joining_Group=/a/ -Malayalam_LLA}');
    Error('\P{Is_Joining_Group=/a/ -Malayalam_LLA}');
    Expect(1, 2152, '\p{Is_Joining_Group=malayalamlla}', "");
    Expect(0, 2152, '\p{^Is_Joining_Group=malayalamlla}', "");
    Expect(0, 2152, '\P{Is_Joining_Group=malayalamlla}', "");
    Expect(1, 2152, '\P{^Is_Joining_Group=malayalamlla}', "");
    Expect(0, 2153, '\p{Is_Joining_Group=malayalamlla}', "");
    Expect(1, 2153, '\p{^Is_Joining_Group=malayalamlla}', "");
    Expect(1, 2153, '\P{Is_Joining_Group=malayalamlla}', "");
    Expect(0, 2153, '\P{^Is_Joining_Group=malayalamlla}', "");
    Expect(1, 2152, '\p{Is_Joining_Group= 	Malayalam_Lla}', "");
    Expect(0, 2152, '\p{^Is_Joining_Group= 	Malayalam_Lla}', "");
    Expect(0, 2152, '\P{Is_Joining_Group= 	Malayalam_Lla}', "");
    Expect(1, 2152, '\P{^Is_Joining_Group= 	Malayalam_Lla}', "");
    Expect(0, 2153, '\p{Is_Joining_Group= 	Malayalam_Lla}', "");
    Expect(1, 2153, '\p{^Is_Joining_Group= 	Malayalam_Lla}', "");
    Expect(1, 2153, '\P{Is_Joining_Group= 	Malayalam_Lla}', "");
    Expect(0, 2153, '\P{^Is_Joining_Group= 	Malayalam_Lla}', "");
    Error('\p{Is_Jg=	 malayalam_Lla:=}');
    Error('\P{Is_Jg=	 malayalam_Lla:=}');
    Expect(1, 2152, '\p{Is_Jg=malayalamlla}', "");
    Expect(0, 2152, '\p{^Is_Jg=malayalamlla}', "");
    Expect(0, 2152, '\P{Is_Jg=malayalamlla}', "");
    Expect(1, 2152, '\P{^Is_Jg=malayalamlla}', "");
    Expect(0, 2153, '\p{Is_Jg=malayalamlla}', "");
    Expect(1, 2153, '\p{^Is_Jg=malayalamlla}', "");
    Expect(1, 2153, '\P{Is_Jg=malayalamlla}', "");
    Expect(0, 2153, '\P{^Is_Jg=malayalamlla}', "");
    Expect(1, 2152, '\p{Is_Jg=-MALAYALAM_Lla}', "");
    Expect(0, 2152, '\p{^Is_Jg=-MALAYALAM_Lla}', "");
    Expect(0, 2152, '\P{Is_Jg=-MALAYALAM_Lla}', "");
    Expect(1, 2152, '\P{^Is_Jg=-MALAYALAM_Lla}', "");
    Expect(0, 2153, '\p{Is_Jg=-MALAYALAM_Lla}', "");
    Expect(1, 2153, '\p{^Is_Jg=-MALAYALAM_Lla}', "");
    Expect(1, 2153, '\P{Is_Jg=-MALAYALAM_Lla}', "");
    Expect(0, 2153, '\P{^Is_Jg=-MALAYALAM_Lla}', "");
    Error('\p{Joining_Group= /a/Malayalam_llla}');
    Error('\P{Joining_Group= /a/Malayalam_llla}');
    Expect(1, 2153, '\p{Joining_Group=:\AMalayalam_Llla\z:}', "");;
    Expect(0, 2154, '\p{Joining_Group=:\AMalayalam_Llla\z:}', "");;
    Expect(1, 2153, '\p{Joining_Group=malayalamllla}', "");
    Expect(0, 2153, '\p{^Joining_Group=malayalamllla}', "");
    Expect(0, 2153, '\P{Joining_Group=malayalamllla}', "");
    Expect(1, 2153, '\P{^Joining_Group=malayalamllla}', "");
    Expect(0, 2154, '\p{Joining_Group=malayalamllla}', "");
    Expect(1, 2154, '\p{^Joining_Group=malayalamllla}', "");
    Expect(1, 2154, '\P{Joining_Group=malayalamllla}', "");
    Expect(0, 2154, '\P{^Joining_Group=malayalamllla}', "");
    Expect(1, 2153, '\p{Joining_Group=:\Amalayalamllla\z:}', "");;
    Expect(0, 2154, '\p{Joining_Group=:\Amalayalamllla\z:}', "");;
    Expect(1, 2153, '\p{Joining_Group=--Malayalam_Llla}', "");
    Expect(0, 2153, '\p{^Joining_Group=--Malayalam_Llla}', "");
    Expect(0, 2153, '\P{Joining_Group=--Malayalam_Llla}', "");
    Expect(1, 2153, '\P{^Joining_Group=--Malayalam_Llla}', "");
    Expect(0, 2154, '\p{Joining_Group=--Malayalam_Llla}', "");
    Expect(1, 2154, '\p{^Joining_Group=--Malayalam_Llla}', "");
    Expect(1, 2154, '\P{Joining_Group=--Malayalam_Llla}', "");
    Expect(0, 2154, '\P{^Joining_Group=--Malayalam_Llla}', "");
    Error('\p{Jg=/a/-MALAYALAM_Llla}');
    Error('\P{Jg=/a/-MALAYALAM_Llla}');
    Expect(1, 2153, '\p{Jg=:\AMalayalam_Llla\z:}', "");;
    Expect(0, 2154, '\p{Jg=:\AMalayalam_Llla\z:}', "");;
    Expect(1, 2153, '\p{Jg=malayalamllla}', "");
    Expect(0, 2153, '\p{^Jg=malayalamllla}', "");
    Expect(0, 2153, '\P{Jg=malayalamllla}', "");
    Expect(1, 2153, '\P{^Jg=malayalamllla}', "");
    Expect(0, 2154, '\p{Jg=malayalamllla}', "");
    Expect(1, 2154, '\p{^Jg=malayalamllla}', "");
    Expect(1, 2154, '\P{Jg=malayalamllla}', "");
    Expect(0, 2154, '\P{^Jg=malayalamllla}', "");
    Expect(1, 2153, '\p{Jg=:\Amalayalamllla\z:}', "");;
    Expect(0, 2154, '\p{Jg=:\Amalayalamllla\z:}', "");;
    Expect(1, 2153, '\p{Jg=  malayalam_Llla}', "");
    Expect(0, 2153, '\p{^Jg=  malayalam_Llla}', "");
    Expect(0, 2153, '\P{Jg=  malayalam_Llla}', "");
    Expect(1, 2153, '\P{^Jg=  malayalam_Llla}', "");
    Expect(0, 2154, '\p{Jg=  malayalam_Llla}', "");
    Expect(1, 2154, '\p{^Jg=  malayalam_Llla}', "");
    Expect(1, 2154, '\P{Jg=  malayalam_Llla}', "");
    Expect(0, 2154, '\P{^Jg=  malayalam_Llla}', "");
    Error('\p{Is_Joining_Group=/a/	-malayalam_Llla}');
    Error('\P{Is_Joining_Group=/a/	-malayalam_Llla}');
    Expect(1, 2153, '\p{Is_Joining_Group=malayalamllla}', "");
    Expect(0, 2153, '\p{^Is_Joining_Group=malayalamllla}', "");
    Expect(0, 2153, '\P{Is_Joining_Group=malayalamllla}', "");
    Expect(1, 2153, '\P{^Is_Joining_Group=malayalamllla}', "");
    Expect(0, 2154, '\p{Is_Joining_Group=malayalamllla}', "");
    Expect(1, 2154, '\p{^Is_Joining_Group=malayalamllla}', "");
    Expect(1, 2154, '\P{Is_Joining_Group=malayalamllla}', "");
    Expect(0, 2154, '\P{^Is_Joining_Group=malayalamllla}', "");
    Expect(1, 2153, '\p{Is_Joining_Group= -malayalam_llla}', "");
    Expect(0, 2153, '\p{^Is_Joining_Group= -malayalam_llla}', "");
    Expect(0, 2153, '\P{Is_Joining_Group= -malayalam_llla}', "");
    Expect(1, 2153, '\P{^Is_Joining_Group= -malayalam_llla}', "");
    Expect(0, 2154, '\p{Is_Joining_Group= -malayalam_llla}', "");
    Expect(1, 2154, '\p{^Is_Joining_Group= -malayalam_llla}', "");
    Expect(1, 2154, '\P{Is_Joining_Group= -malayalam_llla}', "");
    Expect(0, 2154, '\P{^Is_Joining_Group= -malayalam_llla}', "");
    Error('\p{Is_Jg: /a/MALAYALAM_Llla}');
    Error('\P{Is_Jg: /a/MALAYALAM_Llla}');
    Expect(1, 2153, '\p{Is_Jg=malayalamllla}', "");
    Expect(0, 2153, '\p{^Is_Jg=malayalamllla}', "");
    Expect(0, 2153, '\P{Is_Jg=malayalamllla}', "");
    Expect(1, 2153, '\P{^Is_Jg=malayalamllla}', "");
    Expect(0, 2154, '\p{Is_Jg=malayalamllla}', "");
    Expect(1, 2154, '\p{^Is_Jg=malayalamllla}', "");
    Expect(1, 2154, '\P{Is_Jg=malayalamllla}', "");
    Expect(0, 2154, '\P{^Is_Jg=malayalamllla}', "");
    Expect(1, 2153, '\p{Is_Jg=__MALAYALAM_LLLA}', "");
    Expect(0, 2153, '\p{^Is_Jg=__MALAYALAM_LLLA}', "");
    Expect(0, 2153, '\P{Is_Jg=__MALAYALAM_LLLA}', "");
    Expect(1, 2153, '\P{^Is_Jg=__MALAYALAM_LLLA}', "");
    Expect(0, 2154, '\p{Is_Jg=__MALAYALAM_LLLA}', "");
    Expect(1, 2154, '\p{^Is_Jg=__MALAYALAM_LLLA}', "");
    Expect(1, 2154, '\P{Is_Jg=__MALAYALAM_LLLA}', "");
    Expect(0, 2154, '\P{^Is_Jg=__MALAYALAM_LLLA}', "");
    Error('\p{Joining_Group=:=_Malayalam_Nga}');
    Error('\P{Joining_Group=:=_Malayalam_Nga}');
    Expect(1, 2144, '\p{Joining_Group=:\AMalayalam_Nga\z:}', "");;
    Expect(0, 2145, '\p{Joining_Group=:\AMalayalam_Nga\z:}', "");;
    Expect(1, 2144, '\p{Joining_Group=malayalamnga}', "");
    Expect(0, 2144, '\p{^Joining_Group=malayalamnga}', "");
    Expect(0, 2144, '\P{Joining_Group=malayalamnga}', "");
    Expect(1, 2144, '\P{^Joining_Group=malayalamnga}', "");
    Expect(0, 2145, '\p{Joining_Group=malayalamnga}', "");
    Expect(1, 2145, '\p{^Joining_Group=malayalamnga}', "");
    Expect(1, 2145, '\P{Joining_Group=malayalamnga}', "");
    Expect(0, 2145, '\P{^Joining_Group=malayalamnga}', "");
    Expect(1, 2144, '\p{Joining_Group=:\Amalayalamnga\z:}', "");;
    Expect(0, 2145, '\p{Joining_Group=:\Amalayalamnga\z:}', "");;
    Expect(1, 2144, '\p{Joining_Group=- malayalam_Nga}', "");
    Expect(0, 2144, '\p{^Joining_Group=- malayalam_Nga}', "");
    Expect(0, 2144, '\P{Joining_Group=- malayalam_Nga}', "");
    Expect(1, 2144, '\P{^Joining_Group=- malayalam_Nga}', "");
    Expect(0, 2145, '\p{Joining_Group=- malayalam_Nga}', "");
    Expect(1, 2145, '\p{^Joining_Group=- malayalam_Nga}', "");
    Expect(1, 2145, '\P{Joining_Group=- malayalam_Nga}', "");
    Expect(0, 2145, '\P{^Joining_Group=- malayalam_Nga}', "");
    Error('\p{Jg=:=_MALAYALAM_NGA}');
    Error('\P{Jg=:=_MALAYALAM_NGA}');
    Expect(1, 2144, '\p{Jg=:\AMalayalam_Nga\z:}', "");;
    Expect(0, 2145, '\p{Jg=:\AMalayalam_Nga\z:}', "");;
    Expect(1, 2144, '\p{Jg=malayalamnga}', "");
    Expect(0, 2144, '\p{^Jg=malayalamnga}', "");
    Expect(0, 2144, '\P{Jg=malayalamnga}', "");
    Expect(1, 2144, '\P{^Jg=malayalamnga}', "");
    Expect(0, 2145, '\p{Jg=malayalamnga}', "");
    Expect(1, 2145, '\p{^Jg=malayalamnga}', "");
    Expect(1, 2145, '\P{Jg=malayalamnga}', "");
    Expect(0, 2145, '\P{^Jg=malayalamnga}', "");
    Expect(1, 2144, '\p{Jg=:\Amalayalamnga\z:}', "");;
    Expect(0, 2145, '\p{Jg=:\Amalayalamnga\z:}', "");;
    Expect(1, 2144, '\p{Jg= malayalam_nga}', "");
    Expect(0, 2144, '\p{^Jg= malayalam_nga}', "");
    Expect(0, 2144, '\P{Jg= malayalam_nga}', "");
    Expect(1, 2144, '\P{^Jg= malayalam_nga}', "");
    Expect(0, 2145, '\p{Jg= malayalam_nga}', "");
    Expect(1, 2145, '\p{^Jg= malayalam_nga}', "");
    Expect(1, 2145, '\P{Jg= malayalam_nga}', "");
    Expect(0, 2145, '\P{^Jg= malayalam_nga}', "");
    Error('\p{Is_Joining_Group: /a/- MALAYALAM_Nga}');
    Error('\P{Is_Joining_Group: /a/- MALAYALAM_Nga}');
    Expect(1, 2144, '\p{Is_Joining_Group=malayalamnga}', "");
    Expect(0, 2144, '\p{^Is_Joining_Group=malayalamnga}', "");
    Expect(0, 2144, '\P{Is_Joining_Group=malayalamnga}', "");
    Expect(1, 2144, '\P{^Is_Joining_Group=malayalamnga}', "");
    Expect(0, 2145, '\p{Is_Joining_Group=malayalamnga}', "");
    Expect(1, 2145, '\p{^Is_Joining_Group=malayalamnga}', "");
    Expect(1, 2145, '\P{Is_Joining_Group=malayalamnga}', "");
    Expect(0, 2145, '\P{^Is_Joining_Group=malayalamnga}', "");
    Expect(1, 2144, '\p{Is_Joining_Group=Malayalam_Nga}', "");
    Expect(0, 2144, '\p{^Is_Joining_Group=Malayalam_Nga}', "");
    Expect(0, 2144, '\P{Is_Joining_Group=Malayalam_Nga}', "");
    Expect(1, 2144, '\P{^Is_Joining_Group=Malayalam_Nga}', "");
    Expect(0, 2145, '\p{Is_Joining_Group=Malayalam_Nga}', "");
    Expect(1, 2145, '\p{^Is_Joining_Group=Malayalam_Nga}', "");
    Expect(1, 2145, '\P{Is_Joining_Group=Malayalam_Nga}', "");
    Expect(0, 2145, '\P{^Is_Joining_Group=Malayalam_Nga}', "");
    Error('\p{Is_Jg: /a/ Malayalam_Nga}');
    Error('\P{Is_Jg: /a/ Malayalam_Nga}');
    Expect(1, 2144, '\p{Is_Jg=malayalamnga}', "");
    Expect(0, 2144, '\p{^Is_Jg=malayalamnga}', "");
    Expect(0, 2144, '\P{Is_Jg=malayalamnga}', "");
    Expect(1, 2144, '\P{^Is_Jg=malayalamnga}', "");
    Expect(0, 2145, '\p{Is_Jg=malayalamnga}', "");
    Expect(1, 2145, '\p{^Is_Jg=malayalamnga}', "");
    Expect(1, 2145, '\P{Is_Jg=malayalamnga}', "");
    Expect(0, 2145, '\P{^Is_Jg=malayalamnga}', "");
    Expect(1, 2144, '\p{Is_Jg=-	MALAYALAM_Nga}', "");
    Expect(0, 2144, '\p{^Is_Jg=-	MALAYALAM_Nga}', "");
    Expect(0, 2144, '\P{Is_Jg=-	MALAYALAM_Nga}', "");
    Expect(1, 2144, '\P{^Is_Jg=-	MALAYALAM_Nga}', "");
    Expect(0, 2145, '\p{Is_Jg=-	MALAYALAM_Nga}', "");
    Expect(1, 2145, '\p{^Is_Jg=-	MALAYALAM_Nga}', "");
    Expect(1, 2145, '\P{Is_Jg=-	MALAYALAM_Nga}', "");
    Expect(0, 2145, '\P{^Is_Jg=-	MALAYALAM_Nga}', "");
    Error('\p{Joining_Group=_/a/malayalam_Nna}');
    Error('\P{Joining_Group=_/a/malayalam_Nna}');
    Expect(1, 2148, '\p{Joining_Group=:\AMalayalam_Nna\z:}', "");;
    Expect(0, 2149, '\p{Joining_Group=:\AMalayalam_Nna\z:}', "");;
    Expect(1, 2148, '\p{Joining_Group=malayalamnna}', "");
    Expect(0, 2148, '\p{^Joining_Group=malayalamnna}', "");
    Expect(0, 2148, '\P{Joining_Group=malayalamnna}', "");
    Expect(1, 2148, '\P{^Joining_Group=malayalamnna}', "");
    Expect(0, 2149, '\p{Joining_Group=malayalamnna}', "");
    Expect(1, 2149, '\p{^Joining_Group=malayalamnna}', "");
    Expect(1, 2149, '\P{Joining_Group=malayalamnna}', "");
    Expect(0, 2149, '\P{^Joining_Group=malayalamnna}', "");
    Expect(1, 2148, '\p{Joining_Group=:\Amalayalamnna\z:}', "");;
    Expect(0, 2149, '\p{Joining_Group=:\Amalayalamnna\z:}', "");;
    Expect(1, 2148, '\p{Joining_Group=-_Malayalam_nna}', "");
    Expect(0, 2148, '\p{^Joining_Group=-_Malayalam_nna}', "");
    Expect(0, 2148, '\P{Joining_Group=-_Malayalam_nna}', "");
    Expect(1, 2148, '\P{^Joining_Group=-_Malayalam_nna}', "");
    Expect(0, 2149, '\p{Joining_Group=-_Malayalam_nna}', "");
    Expect(1, 2149, '\p{^Joining_Group=-_Malayalam_nna}', "");
    Expect(1, 2149, '\P{Joining_Group=-_Malayalam_nna}', "");
    Expect(0, 2149, '\P{^Joining_Group=-_Malayalam_nna}', "");
    Error('\p{Jg=:=_Malayalam_nna}');
    Error('\P{Jg=:=_Malayalam_nna}');
    Expect(1, 2148, '\p{Jg=:\AMalayalam_Nna\z:}', "");;
    Expect(0, 2149, '\p{Jg=:\AMalayalam_Nna\z:}', "");;
    Expect(1, 2148, '\p{Jg=malayalamnna}', "");
    Expect(0, 2148, '\p{^Jg=malayalamnna}', "");
    Expect(0, 2148, '\P{Jg=malayalamnna}', "");
    Expect(1, 2148, '\P{^Jg=malayalamnna}', "");
    Expect(0, 2149, '\p{Jg=malayalamnna}', "");
    Expect(1, 2149, '\p{^Jg=malayalamnna}', "");
    Expect(1, 2149, '\P{Jg=malayalamnna}', "");
    Expect(0, 2149, '\P{^Jg=malayalamnna}', "");
    Expect(1, 2148, '\p{Jg=:\Amalayalamnna\z:}', "");;
    Expect(0, 2149, '\p{Jg=:\Amalayalamnna\z:}', "");;
    Expect(1, 2148, '\p{Jg=  malayalam_Nna}', "");
    Expect(0, 2148, '\p{^Jg=  malayalam_Nna}', "");
    Expect(0, 2148, '\P{Jg=  malayalam_Nna}', "");
    Expect(1, 2148, '\P{^Jg=  malayalam_Nna}', "");
    Expect(0, 2149, '\p{Jg=  malayalam_Nna}', "");
    Expect(1, 2149, '\p{^Jg=  malayalam_Nna}', "");
    Expect(1, 2149, '\P{Jg=  malayalam_Nna}', "");
    Expect(0, 2149, '\P{^Jg=  malayalam_Nna}', "");
    Error('\p{Is_Joining_Group=__MALAYALAM_Nna:=}');
    Error('\P{Is_Joining_Group=__MALAYALAM_Nna:=}');
    Expect(1, 2148, '\p{Is_Joining_Group=malayalamnna}', "");
    Expect(0, 2148, '\p{^Is_Joining_Group=malayalamnna}', "");
    Expect(0, 2148, '\P{Is_Joining_Group=malayalamnna}', "");
    Expect(1, 2148, '\P{^Is_Joining_Group=malayalamnna}', "");
    Expect(0, 2149, '\p{Is_Joining_Group=malayalamnna}', "");
    Expect(1, 2149, '\p{^Is_Joining_Group=malayalamnna}', "");
    Expect(1, 2149, '\P{Is_Joining_Group=malayalamnna}', "");
    Expect(0, 2149, '\P{^Is_Joining_Group=malayalamnna}', "");
    Expect(1, 2148, '\p{Is_Joining_Group:	-	MALAYALAM_nna}', "");
    Expect(0, 2148, '\p{^Is_Joining_Group:	-	MALAYALAM_nna}', "");
    Expect(0, 2148, '\P{Is_Joining_Group:	-	MALAYALAM_nna}', "");
    Expect(1, 2148, '\P{^Is_Joining_Group:	-	MALAYALAM_nna}', "");
    Expect(0, 2149, '\p{Is_Joining_Group:	-	MALAYALAM_nna}', "");
    Expect(1, 2149, '\p{^Is_Joining_Group:	-	MALAYALAM_nna}', "");
    Expect(1, 2149, '\P{Is_Joining_Group:	-	MALAYALAM_nna}', "");
    Expect(0, 2149, '\P{^Is_Joining_Group:	-	MALAYALAM_nna}', "");
    Error('\p{Is_Jg=:=--malayalam_nna}');
    Error('\P{Is_Jg=:=--malayalam_nna}');
    Expect(1, 2148, '\p{Is_Jg=malayalamnna}', "");
    Expect(0, 2148, '\p{^Is_Jg=malayalamnna}', "");
    Expect(0, 2148, '\P{Is_Jg=malayalamnna}', "");
    Expect(1, 2148, '\P{^Is_Jg=malayalamnna}', "");
    Expect(0, 2149, '\p{Is_Jg=malayalamnna}', "");
    Expect(1, 2149, '\p{^Is_Jg=malayalamnna}', "");
    Expect(1, 2149, '\P{Is_Jg=malayalamnna}', "");
    Expect(0, 2149, '\P{^Is_Jg=malayalamnna}', "");
    Expect(1, 2148, '\p{Is_Jg=	-Malayalam_NNA}', "");
    Expect(0, 2148, '\p{^Is_Jg=	-Malayalam_NNA}', "");
    Expect(0, 2148, '\P{Is_Jg=	-Malayalam_NNA}', "");
    Expect(1, 2148, '\P{^Is_Jg=	-Malayalam_NNA}', "");
    Expect(0, 2149, '\p{Is_Jg=	-Malayalam_NNA}', "");
    Expect(1, 2149, '\p{^Is_Jg=	-Malayalam_NNA}', "");
    Expect(1, 2149, '\P{Is_Jg=	-Malayalam_NNA}', "");
    Expect(0, 2149, '\P{^Is_Jg=	-Malayalam_NNA}', "");
    Error('\p{Joining_Group=_/a/malayalam_nnna}');
    Error('\P{Joining_Group=_/a/malayalam_nnna}');
    Expect(1, 2149, '\p{Joining_Group=:\AMalayalam_Nnna\z:}', "");;
    Expect(0, 2150, '\p{Joining_Group=:\AMalayalam_Nnna\z:}', "");;
    Expect(1, 2149, '\p{Joining_Group:	malayalamnnna}', "");
    Expect(0, 2149, '\p{^Joining_Group:	malayalamnnna}', "");
    Expect(0, 2149, '\P{Joining_Group:	malayalamnnna}', "");
    Expect(1, 2149, '\P{^Joining_Group:	malayalamnnna}', "");
    Expect(0, 2150, '\p{Joining_Group:	malayalamnnna}', "");
    Expect(1, 2150, '\p{^Joining_Group:	malayalamnnna}', "");
    Expect(1, 2150, '\P{Joining_Group:	malayalamnnna}', "");
    Expect(0, 2150, '\P{^Joining_Group:	malayalamnnna}', "");
    Expect(1, 2149, '\p{Joining_Group=:\Amalayalamnnna\z:}', "");;
    Expect(0, 2150, '\p{Joining_Group=:\Amalayalamnnna\z:}', "");;
    Expect(1, 2149, '\p{Joining_Group=-MALAYALAM_Nnna}', "");
    Expect(0, 2149, '\p{^Joining_Group=-MALAYALAM_Nnna}', "");
    Expect(0, 2149, '\P{Joining_Group=-MALAYALAM_Nnna}', "");
    Expect(1, 2149, '\P{^Joining_Group=-MALAYALAM_Nnna}', "");
    Expect(0, 2150, '\p{Joining_Group=-MALAYALAM_Nnna}', "");
    Expect(1, 2150, '\p{^Joining_Group=-MALAYALAM_Nnna}', "");
    Expect(1, 2150, '\P{Joining_Group=-MALAYALAM_Nnna}', "");
    Expect(0, 2150, '\P{^Joining_Group=-MALAYALAM_Nnna}', "");
    Error('\p{Jg: _	MALAYALAM_NNNA:=}');
    Error('\P{Jg: _	MALAYALAM_NNNA:=}');
    Expect(1, 2149, '\p{Jg=:\AMalayalam_Nnna\z:}', "");;
    Expect(0, 2150, '\p{Jg=:\AMalayalam_Nnna\z:}', "");;
    Expect(1, 2149, '\p{Jg=malayalamnnna}', "");
    Expect(0, 2149, '\p{^Jg=malayalamnnna}', "");
    Expect(0, 2149, '\P{Jg=malayalamnnna}', "");
    Expect(1, 2149, '\P{^Jg=malayalamnnna}', "");
    Expect(0, 2150, '\p{Jg=malayalamnnna}', "");
    Expect(1, 2150, '\p{^Jg=malayalamnnna}', "");
    Expect(1, 2150, '\P{Jg=malayalamnnna}', "");
    Expect(0, 2150, '\P{^Jg=malayalamnnna}', "");
    Expect(1, 2149, '\p{Jg=:\Amalayalamnnna\z:}', "");;
    Expect(0, 2150, '\p{Jg=:\Amalayalamnnna\z:}', "");;
    Expect(1, 2149, '\p{Jg=-Malayalam_nnna}', "");
    Expect(0, 2149, '\p{^Jg=-Malayalam_nnna}', "");
    Expect(0, 2149, '\P{Jg=-Malayalam_nnna}', "");
    Expect(1, 2149, '\P{^Jg=-Malayalam_nnna}', "");
    Expect(0, 2150, '\p{Jg=-Malayalam_nnna}', "");
    Expect(1, 2150, '\p{^Jg=-Malayalam_nnna}', "");
    Expect(1, 2150, '\P{Jg=-Malayalam_nnna}', "");
    Expect(0, 2150, '\P{^Jg=-Malayalam_nnna}', "");
    Error('\p{Is_Joining_Group=/a/_	MALAYALAM_NNNA}');
    Error('\P{Is_Joining_Group=/a/_	MALAYALAM_NNNA}');
    Expect(1, 2149, '\p{Is_Joining_Group=malayalamnnna}', "");
    Expect(0, 2149, '\p{^Is_Joining_Group=malayalamnnna}', "");
    Expect(0, 2149, '\P{Is_Joining_Group=malayalamnnna}', "");
    Expect(1, 2149, '\P{^Is_Joining_Group=malayalamnnna}', "");
    Expect(0, 2150, '\p{Is_Joining_Group=malayalamnnna}', "");
    Expect(1, 2150, '\p{^Is_Joining_Group=malayalamnnna}', "");
    Expect(1, 2150, '\P{Is_Joining_Group=malayalamnnna}', "");
    Expect(0, 2150, '\P{^Is_Joining_Group=malayalamnnna}', "");
    Expect(1, 2149, '\p{Is_Joining_Group:	_malayalam_NNNA}', "");
    Expect(0, 2149, '\p{^Is_Joining_Group:	_malayalam_NNNA}', "");
    Expect(0, 2149, '\P{Is_Joining_Group:	_malayalam_NNNA}', "");
    Expect(1, 2149, '\P{^Is_Joining_Group:	_malayalam_NNNA}', "");
    Expect(0, 2150, '\p{Is_Joining_Group:	_malayalam_NNNA}', "");
    Expect(1, 2150, '\p{^Is_Joining_Group:	_malayalam_NNNA}', "");
    Expect(1, 2150, '\P{Is_Joining_Group:	_malayalam_NNNA}', "");
    Expect(0, 2150, '\P{^Is_Joining_Group:	_malayalam_NNNA}', "");
    Error('\p{Is_Jg=-/a/malayalam_Nnna}');
    Error('\P{Is_Jg=-/a/malayalam_Nnna}');
    Expect(1, 2149, '\p{Is_Jg=malayalamnnna}', "");
    Expect(0, 2149, '\p{^Is_Jg=malayalamnnna}', "");
    Expect(0, 2149, '\P{Is_Jg=malayalamnnna}', "");
    Expect(1, 2149, '\P{^Is_Jg=malayalamnnna}', "");
    Expect(0, 2150, '\p{Is_Jg=malayalamnnna}', "");
    Expect(1, 2150, '\p{^Is_Jg=malayalamnnna}', "");
    Expect(1, 2150, '\P{Is_Jg=malayalamnnna}', "");
    Expect(0, 2150, '\P{^Is_Jg=malayalamnnna}', "");
    Expect(1, 2149, '\p{Is_Jg=- malayalam_Nnna}', "");
    Expect(0, 2149, '\p{^Is_Jg=- malayalam_Nnna}', "");
    Expect(0, 2149, '\P{Is_Jg=- malayalam_Nnna}', "");
    Expect(1, 2149, '\P{^Is_Jg=- malayalam_Nnna}', "");
    Expect(0, 2150, '\p{Is_Jg=- malayalam_Nnna}', "");
    Expect(1, 2150, '\p{^Is_Jg=- malayalam_Nnna}', "");
    Expect(1, 2150, '\P{Is_Jg=- malayalam_Nnna}', "");
    Expect(0, 2150, '\P{^Is_Jg=- malayalam_Nnna}', "");
    Error('\p{Joining_Group=	/a/MALAYALAM_Nya}');
    Error('\P{Joining_Group=	/a/MALAYALAM_Nya}');
    Expect(1, 2146, '\p{Joining_Group=:\AMalayalam_Nya\z:}', "");;
    Expect(0, 2147, '\p{Joining_Group=:\AMalayalam_Nya\z:}', "");;
    Expect(1, 2146, '\p{Joining_Group=malayalamnya}', "");
    Expect(0, 2146, '\p{^Joining_Group=malayalamnya}', "");
    Expect(0, 2146, '\P{Joining_Group=malayalamnya}', "");
    Expect(1, 2146, '\P{^Joining_Group=malayalamnya}', "");
    Expect(0, 2147, '\p{Joining_Group=malayalamnya}', "");
    Expect(1, 2147, '\p{^Joining_Group=malayalamnya}', "");
    Expect(1, 2147, '\P{Joining_Group=malayalamnya}', "");
    Expect(0, 2147, '\P{^Joining_Group=malayalamnya}', "");
    Expect(1, 2146, '\p{Joining_Group=:\Amalayalamnya\z:}', "");;
    Expect(0, 2147, '\p{Joining_Group=:\Amalayalamnya\z:}', "");;
    Expect(1, 2146, '\p{Joining_Group= 	MALAYALAM_Nya}', "");
    Expect(0, 2146, '\p{^Joining_Group= 	MALAYALAM_Nya}', "");
    Expect(0, 2146, '\P{Joining_Group= 	MALAYALAM_Nya}', "");
    Expect(1, 2146, '\P{^Joining_Group= 	MALAYALAM_Nya}', "");
    Expect(0, 2147, '\p{Joining_Group= 	MALAYALAM_Nya}', "");
    Expect(1, 2147, '\p{^Joining_Group= 	MALAYALAM_Nya}', "");
    Expect(1, 2147, '\P{Joining_Group= 	MALAYALAM_Nya}', "");
    Expect(0, 2147, '\P{^Joining_Group= 	MALAYALAM_Nya}', "");
    Error('\p{Jg=malayalam_Nya/a/}');
    Error('\P{Jg=malayalam_Nya/a/}');
    Expect(1, 2146, '\p{Jg=:\AMalayalam_Nya\z:}', "");;
    Expect(0, 2147, '\p{Jg=:\AMalayalam_Nya\z:}', "");;
    Expect(1, 2146, '\p{Jg=malayalamnya}', "");
    Expect(0, 2146, '\p{^Jg=malayalamnya}', "");
    Expect(0, 2146, '\P{Jg=malayalamnya}', "");
    Expect(1, 2146, '\P{^Jg=malayalamnya}', "");
    Expect(0, 2147, '\p{Jg=malayalamnya}', "");
    Expect(1, 2147, '\p{^Jg=malayalamnya}', "");
    Expect(1, 2147, '\P{Jg=malayalamnya}', "");
    Expect(0, 2147, '\P{^Jg=malayalamnya}', "");
    Expect(1, 2146, '\p{Jg=:\Amalayalamnya\z:}', "");;
    Expect(0, 2147, '\p{Jg=:\Amalayalamnya\z:}', "");;
    Expect(1, 2146, '\p{Jg=malayalam_nya}', "");
    Expect(0, 2146, '\p{^Jg=malayalam_nya}', "");
    Expect(0, 2146, '\P{Jg=malayalam_nya}', "");
    Expect(1, 2146, '\P{^Jg=malayalam_nya}', "");
    Expect(0, 2147, '\p{Jg=malayalam_nya}', "");
    Expect(1, 2147, '\p{^Jg=malayalam_nya}', "");
    Expect(1, 2147, '\P{Jg=malayalam_nya}', "");
    Expect(0, 2147, '\P{^Jg=malayalam_nya}', "");
    Error('\p{Is_Joining_Group:   _malayalam_Nya/a/}');
    Error('\P{Is_Joining_Group:   _malayalam_Nya/a/}');
    Expect(1, 2146, '\p{Is_Joining_Group=malayalamnya}', "");
    Expect(0, 2146, '\p{^Is_Joining_Group=malayalamnya}', "");
    Expect(0, 2146, '\P{Is_Joining_Group=malayalamnya}', "");
    Expect(1, 2146, '\P{^Is_Joining_Group=malayalamnya}', "");
    Expect(0, 2147, '\p{Is_Joining_Group=malayalamnya}', "");
    Expect(1, 2147, '\p{^Is_Joining_Group=malayalamnya}', "");
    Expect(1, 2147, '\P{Is_Joining_Group=malayalamnya}', "");
    Expect(0, 2147, '\P{^Is_Joining_Group=malayalamnya}', "");
    Expect(1, 2146, '\p{Is_Joining_Group= _Malayalam_NYA}', "");
    Expect(0, 2146, '\p{^Is_Joining_Group= _Malayalam_NYA}', "");
    Expect(0, 2146, '\P{Is_Joining_Group= _Malayalam_NYA}', "");
    Expect(1, 2146, '\P{^Is_Joining_Group= _Malayalam_NYA}', "");
    Expect(0, 2147, '\p{Is_Joining_Group= _Malayalam_NYA}', "");
    Expect(1, 2147, '\p{^Is_Joining_Group= _Malayalam_NYA}', "");
    Expect(1, 2147, '\P{Is_Joining_Group= _Malayalam_NYA}', "");
    Expect(0, 2147, '\P{^Is_Joining_Group= _Malayalam_NYA}', "");
    Error('\p{Is_Jg:		/a/MALAYALAM_NYA}');
    Error('\P{Is_Jg:		/a/MALAYALAM_NYA}');
    Expect(1, 2146, '\p{Is_Jg=malayalamnya}', "");
    Expect(0, 2146, '\p{^Is_Jg=malayalamnya}', "");
    Expect(0, 2146, '\P{Is_Jg=malayalamnya}', "");
    Expect(1, 2146, '\P{^Is_Jg=malayalamnya}', "");
    Expect(0, 2147, '\p{Is_Jg=malayalamnya}', "");
    Expect(1, 2147, '\p{^Is_Jg=malayalamnya}', "");
    Expect(1, 2147, '\P{Is_Jg=malayalamnya}', "");
    Expect(0, 2147, '\P{^Is_Jg=malayalamnya}', "");
    Expect(1, 2146, '\p{Is_Jg=		Malayalam_NYA}', "");
    Expect(0, 2146, '\p{^Is_Jg=		Malayalam_NYA}', "");
    Expect(0, 2146, '\P{Is_Jg=		Malayalam_NYA}', "");
    Expect(1, 2146, '\P{^Is_Jg=		Malayalam_NYA}', "");
    Expect(0, 2147, '\p{Is_Jg=		Malayalam_NYA}', "");
    Expect(1, 2147, '\p{^Is_Jg=		Malayalam_NYA}', "");
    Expect(1, 2147, '\P{Is_Jg=		Malayalam_NYA}', "");
    Expect(0, 2147, '\P{^Is_Jg=		Malayalam_NYA}', "");
    Error('\p{Joining_Group= _malayalam_Ra:=}');
    Error('\P{Joining_Group= _malayalam_Ra:=}');
    Expect(1, 2151, '\p{Joining_Group=:\AMalayalam_Ra\z:}', "");;
    Expect(0, 2152, '\p{Joining_Group=:\AMalayalam_Ra\z:}', "");;
    Expect(1, 2151, '\p{Joining_Group=malayalamra}', "");
    Expect(0, 2151, '\p{^Joining_Group=malayalamra}', "");
    Expect(0, 2151, '\P{Joining_Group=malayalamra}', "");
    Expect(1, 2151, '\P{^Joining_Group=malayalamra}', "");
    Expect(0, 2152, '\p{Joining_Group=malayalamra}', "");
    Expect(1, 2152, '\p{^Joining_Group=malayalamra}', "");
    Expect(1, 2152, '\P{Joining_Group=malayalamra}', "");
    Expect(0, 2152, '\P{^Joining_Group=malayalamra}', "");
    Expect(1, 2151, '\p{Joining_Group=:\Amalayalamra\z:}', "");;
    Expect(0, 2152, '\p{Joining_Group=:\Amalayalamra\z:}', "");;
    Expect(1, 2151, '\p{Joining_Group:-MALAYALAM_Ra}', "");
    Expect(0, 2151, '\p{^Joining_Group:-MALAYALAM_Ra}', "");
    Expect(0, 2151, '\P{Joining_Group:-MALAYALAM_Ra}', "");
    Expect(1, 2151, '\P{^Joining_Group:-MALAYALAM_Ra}', "");
    Expect(0, 2152, '\p{Joining_Group:-MALAYALAM_Ra}', "");
    Expect(1, 2152, '\p{^Joining_Group:-MALAYALAM_Ra}', "");
    Expect(1, 2152, '\P{Joining_Group:-MALAYALAM_Ra}', "");
    Expect(0, 2152, '\P{^Joining_Group:-MALAYALAM_Ra}', "");
    Error('\p{Jg=	MALAYALAM_ra/a/}');
    Error('\P{Jg=	MALAYALAM_ra/a/}');
    Expect(1, 2151, '\p{Jg=:\AMalayalam_Ra\z:}', "");;
    Expect(0, 2152, '\p{Jg=:\AMalayalam_Ra\z:}', "");;
    Expect(1, 2151, '\p{Jg:   malayalamra}', "");
    Expect(0, 2151, '\p{^Jg:   malayalamra}', "");
    Expect(0, 2151, '\P{Jg:   malayalamra}', "");
    Expect(1, 2151, '\P{^Jg:   malayalamra}', "");
    Expect(0, 2152, '\p{Jg:   malayalamra}', "");
    Expect(1, 2152, '\p{^Jg:   malayalamra}', "");
    Expect(1, 2152, '\P{Jg:   malayalamra}', "");
    Expect(0, 2152, '\P{^Jg:   malayalamra}', "");
    Expect(1, 2151, '\p{Jg=:\Amalayalamra\z:}', "");;
    Expect(0, 2152, '\p{Jg=:\Amalayalamra\z:}', "");;
    Expect(1, 2151, '\p{Jg=-	malayalam_RA}', "");
    Expect(0, 2151, '\p{^Jg=-	malayalam_RA}', "");
    Expect(0, 2151, '\P{Jg=-	malayalam_RA}', "");
    Expect(1, 2151, '\P{^Jg=-	malayalam_RA}', "");
    Expect(0, 2152, '\p{Jg=-	malayalam_RA}', "");
    Expect(1, 2152, '\p{^Jg=-	malayalam_RA}', "");
    Expect(1, 2152, '\P{Jg=-	malayalam_RA}', "");
    Expect(0, 2152, '\P{^Jg=-	malayalam_RA}', "");
    Error('\p{Is_Joining_Group=-:=malayalam_ra}');
    Error('\P{Is_Joining_Group=-:=malayalam_ra}');
    Expect(1, 2151, '\p{Is_Joining_Group=malayalamra}', "");
    Expect(0, 2151, '\p{^Is_Joining_Group=malayalamra}', "");
    Expect(0, 2151, '\P{Is_Joining_Group=malayalamra}', "");
    Expect(1, 2151, '\P{^Is_Joining_Group=malayalamra}', "");
    Expect(0, 2152, '\p{Is_Joining_Group=malayalamra}', "");
    Expect(1, 2152, '\p{^Is_Joining_Group=malayalamra}', "");
    Expect(1, 2152, '\P{Is_Joining_Group=malayalamra}', "");
    Expect(0, 2152, '\P{^Is_Joining_Group=malayalamra}', "");
    Expect(1, 2151, '\p{Is_Joining_Group= Malayalam_RA}', "");
    Expect(0, 2151, '\p{^Is_Joining_Group= Malayalam_RA}', "");
    Expect(0, 2151, '\P{Is_Joining_Group= Malayalam_RA}', "");
    Expect(1, 2151, '\P{^Is_Joining_Group= Malayalam_RA}', "");
    Expect(0, 2152, '\p{Is_Joining_Group= Malayalam_RA}', "");
    Expect(1, 2152, '\p{^Is_Joining_Group= Malayalam_RA}', "");
    Expect(1, 2152, '\P{Is_Joining_Group= Malayalam_RA}', "");
    Expect(0, 2152, '\P{^Is_Joining_Group= Malayalam_RA}', "");
    Error('\p{Is_Jg:	 :=Malayalam_Ra}');
    Error('\P{Is_Jg:	 :=Malayalam_Ra}');
    Expect(1, 2151, '\p{Is_Jg:   malayalamra}', "");
    Expect(0, 2151, '\p{^Is_Jg:   malayalamra}', "");
    Expect(0, 2151, '\P{Is_Jg:   malayalamra}', "");
    Expect(1, 2151, '\P{^Is_Jg:   malayalamra}', "");
    Expect(0, 2152, '\p{Is_Jg:   malayalamra}', "");
    Expect(1, 2152, '\p{^Is_Jg:   malayalamra}', "");
    Expect(1, 2152, '\P{Is_Jg:   malayalamra}', "");
    Expect(0, 2152, '\P{^Is_Jg:   malayalamra}', "");
    Expect(1, 2151, '\p{Is_Jg=	malayalam_RA}', "");
    Expect(0, 2151, '\p{^Is_Jg=	malayalam_RA}', "");
    Expect(0, 2151, '\P{Is_Jg=	malayalam_RA}', "");
    Expect(1, 2151, '\P{^Is_Jg=	malayalam_RA}', "");
    Expect(0, 2152, '\p{Is_Jg=	malayalam_RA}', "");
    Expect(1, 2152, '\p{^Is_Jg=	malayalam_RA}', "");
    Expect(1, 2152, '\P{Is_Jg=	malayalam_RA}', "");
    Expect(0, 2152, '\P{^Is_Jg=	malayalam_RA}', "");
    Error('\p{Joining_Group=_-Malayalam_SSA:=}');
    Error('\P{Joining_Group=_-Malayalam_SSA:=}');
    Expect(1, 2154, '\p{Joining_Group=:\AMalayalam_Ssa\z:}', "");;
    Expect(0, 2155, '\p{Joining_Group=:\AMalayalam_Ssa\z:}', "");;
    Expect(1, 2154, '\p{Joining_Group=malayalamssa}', "");
    Expect(0, 2154, '\p{^Joining_Group=malayalamssa}', "");
    Expect(0, 2154, '\P{Joining_Group=malayalamssa}', "");
    Expect(1, 2154, '\P{^Joining_Group=malayalamssa}', "");
    Expect(0, 2155, '\p{Joining_Group=malayalamssa}', "");
    Expect(1, 2155, '\p{^Joining_Group=malayalamssa}', "");
    Expect(1, 2155, '\P{Joining_Group=malayalamssa}', "");
    Expect(0, 2155, '\P{^Joining_Group=malayalamssa}', "");
    Expect(1, 2154, '\p{Joining_Group=:\Amalayalamssa\z:}', "");;
    Expect(0, 2155, '\p{Joining_Group=:\Amalayalamssa\z:}', "");;
    Expect(1, 2154, '\p{Joining_Group=	Malayalam_ssa}', "");
    Expect(0, 2154, '\p{^Joining_Group=	Malayalam_ssa}', "");
    Expect(0, 2154, '\P{Joining_Group=	Malayalam_ssa}', "");
    Expect(1, 2154, '\P{^Joining_Group=	Malayalam_ssa}', "");
    Expect(0, 2155, '\p{Joining_Group=	Malayalam_ssa}', "");
    Expect(1, 2155, '\p{^Joining_Group=	Malayalam_ssa}', "");
    Expect(1, 2155, '\P{Joining_Group=	Malayalam_ssa}', "");
    Expect(0, 2155, '\P{^Joining_Group=	Malayalam_ssa}', "");
    Error('\p{Jg=	-MALAYALAM_ssa/a/}');
    Error('\P{Jg=	-MALAYALAM_ssa/a/}');
    Expect(1, 2154, '\p{Jg=:\AMalayalam_Ssa\z:}', "");;
    Expect(0, 2155, '\p{Jg=:\AMalayalam_Ssa\z:}', "");;
    Expect(1, 2154, '\p{Jg=malayalamssa}', "");
    Expect(0, 2154, '\p{^Jg=malayalamssa}', "");
    Expect(0, 2154, '\P{Jg=malayalamssa}', "");
    Expect(1, 2154, '\P{^Jg=malayalamssa}', "");
    Expect(0, 2155, '\p{Jg=malayalamssa}', "");
    Expect(1, 2155, '\p{^Jg=malayalamssa}', "");
    Expect(1, 2155, '\P{Jg=malayalamssa}', "");
    Expect(0, 2155, '\P{^Jg=malayalamssa}', "");
    Expect(1, 2154, '\p{Jg=:\Amalayalamssa\z:}', "");;
    Expect(0, 2155, '\p{Jg=:\Amalayalamssa\z:}', "");;
    Expect(1, 2154, '\p{Jg=_-Malayalam_ssa}', "");
    Expect(0, 2154, '\p{^Jg=_-Malayalam_ssa}', "");
    Expect(0, 2154, '\P{Jg=_-Malayalam_ssa}', "");
    Expect(1, 2154, '\P{^Jg=_-Malayalam_ssa}', "");
    Expect(0, 2155, '\p{Jg=_-Malayalam_ssa}', "");
    Expect(1, 2155, '\p{^Jg=_-Malayalam_ssa}', "");
    Expect(1, 2155, '\P{Jg=_-Malayalam_ssa}', "");
    Expect(0, 2155, '\P{^Jg=_-Malayalam_ssa}', "");
    Error('\p{Is_Joining_Group= _malayalam_ssa/a/}');
    Error('\P{Is_Joining_Group= _malayalam_ssa/a/}');
    Expect(1, 2154, '\p{Is_Joining_Group=malayalamssa}', "");
    Expect(0, 2154, '\p{^Is_Joining_Group=malayalamssa}', "");
    Expect(0, 2154, '\P{Is_Joining_Group=malayalamssa}', "");
    Expect(1, 2154, '\P{^Is_Joining_Group=malayalamssa}', "");
    Expect(0, 2155, '\p{Is_Joining_Group=malayalamssa}', "");
    Expect(1, 2155, '\p{^Is_Joining_Group=malayalamssa}', "");
    Expect(1, 2155, '\P{Is_Joining_Group=malayalamssa}', "");
    Expect(0, 2155, '\P{^Is_Joining_Group=malayalamssa}', "");
    Expect(1, 2154, '\p{Is_Joining_Group=Malayalam_Ssa}', "");
    Expect(0, 2154, '\p{^Is_Joining_Group=Malayalam_Ssa}', "");
    Expect(0, 2154, '\P{Is_Joining_Group=Malayalam_Ssa}', "");
    Expect(1, 2154, '\P{^Is_Joining_Group=Malayalam_Ssa}', "");
    Expect(0, 2155, '\p{Is_Joining_Group=Malayalam_Ssa}', "");
    Expect(1, 2155, '\p{^Is_Joining_Group=Malayalam_Ssa}', "");
    Expect(1, 2155, '\P{Is_Joining_Group=Malayalam_Ssa}', "");
    Expect(0, 2155, '\P{^Is_Joining_Group=Malayalam_Ssa}', "");
    Error('\p{Is_Jg=-:=Malayalam_SSA}');
    Error('\P{Is_Jg=-:=Malayalam_SSA}');
    Expect(1, 2154, '\p{Is_Jg:   malayalamssa}', "");
    Expect(0, 2154, '\p{^Is_Jg:   malayalamssa}', "");
    Expect(0, 2154, '\P{Is_Jg:   malayalamssa}', "");
    Expect(1, 2154, '\P{^Is_Jg:   malayalamssa}', "");
    Expect(0, 2155, '\p{Is_Jg:   malayalamssa}', "");
    Expect(1, 2155, '\p{^Is_Jg:   malayalamssa}', "");
    Expect(1, 2155, '\P{Is_Jg:   malayalamssa}', "");
    Expect(0, 2155, '\P{^Is_Jg:   malayalamssa}', "");
    Expect(1, 2154, '\p{Is_Jg:	_-MALAYALAM_Ssa}', "");
    Expect(0, 2154, '\p{^Is_Jg:	_-MALAYALAM_Ssa}', "");
    Expect(0, 2154, '\P{Is_Jg:	_-MALAYALAM_Ssa}', "");
    Expect(1, 2154, '\P{^Is_Jg:	_-MALAYALAM_Ssa}', "");
    Expect(0, 2155, '\p{Is_Jg:	_-MALAYALAM_Ssa}', "");
    Expect(1, 2155, '\p{^Is_Jg:	_-MALAYALAM_Ssa}', "");
    Expect(1, 2155, '\P{Is_Jg:	_-MALAYALAM_Ssa}', "");
    Expect(0, 2155, '\P{^Is_Jg:	_-MALAYALAM_Ssa}', "");
    Error('\p{Joining_Group= Malayalam_tta/a/}');
    Error('\P{Joining_Group= Malayalam_tta/a/}');
    Expect(1, 2147, '\p{Joining_Group=:\AMalayalam_Tta\z:}', "");;
    Expect(0, 2148, '\p{Joining_Group=:\AMalayalam_Tta\z:}', "");;
    Expect(1, 2147, '\p{Joining_Group=malayalamtta}', "");
    Expect(0, 2147, '\p{^Joining_Group=malayalamtta}', "");
    Expect(0, 2147, '\P{Joining_Group=malayalamtta}', "");
    Expect(1, 2147, '\P{^Joining_Group=malayalamtta}', "");
    Expect(0, 2148, '\p{Joining_Group=malayalamtta}', "");
    Expect(1, 2148, '\p{^Joining_Group=malayalamtta}', "");
    Expect(1, 2148, '\P{Joining_Group=malayalamtta}', "");
    Expect(0, 2148, '\P{^Joining_Group=malayalamtta}', "");
    Expect(1, 2147, '\p{Joining_Group=:\Amalayalamtta\z:}', "");;
    Expect(0, 2148, '\p{Joining_Group=:\Amalayalamtta\z:}', "");;
    Expect(1, 2147, '\p{Joining_Group=-	Malayalam_TTA}', "");
    Expect(0, 2147, '\p{^Joining_Group=-	Malayalam_TTA}', "");
    Expect(0, 2147, '\P{Joining_Group=-	Malayalam_TTA}', "");
    Expect(1, 2147, '\P{^Joining_Group=-	Malayalam_TTA}', "");
    Expect(0, 2148, '\p{Joining_Group=-	Malayalam_TTA}', "");
    Expect(1, 2148, '\p{^Joining_Group=-	Malayalam_TTA}', "");
    Expect(1, 2148, '\P{Joining_Group=-	Malayalam_TTA}', "");
    Expect(0, 2148, '\P{^Joining_Group=-	Malayalam_TTA}', "");
    Error('\p{Jg=- malayalam_Tta:=}');
    Error('\P{Jg=- malayalam_Tta:=}');
    Expect(1, 2147, '\p{Jg=:\AMalayalam_Tta\z:}', "");;
    Expect(0, 2148, '\p{Jg=:\AMalayalam_Tta\z:}', "");;
    Expect(1, 2147, '\p{Jg=malayalamtta}', "");
    Expect(0, 2147, '\p{^Jg=malayalamtta}', "");
    Expect(0, 2147, '\P{Jg=malayalamtta}', "");
    Expect(1, 2147, '\P{^Jg=malayalamtta}', "");
    Expect(0, 2148, '\p{Jg=malayalamtta}', "");
    Expect(1, 2148, '\p{^Jg=malayalamtta}', "");
    Expect(1, 2148, '\P{Jg=malayalamtta}', "");
    Expect(0, 2148, '\P{^Jg=malayalamtta}', "");
    Expect(1, 2147, '\p{Jg=:\Amalayalamtta\z:}', "");;
    Expect(0, 2148, '\p{Jg=:\Amalayalamtta\z:}', "");;
    Expect(1, 2147, '\p{Jg=-MALAYALAM_Tta}', "");
    Expect(0, 2147, '\p{^Jg=-MALAYALAM_Tta}', "");
    Expect(0, 2147, '\P{Jg=-MALAYALAM_Tta}', "");
    Expect(1, 2147, '\P{^Jg=-MALAYALAM_Tta}', "");
    Expect(0, 2148, '\p{Jg=-MALAYALAM_Tta}', "");
    Expect(1, 2148, '\p{^Jg=-MALAYALAM_Tta}', "");
    Expect(1, 2148, '\P{Jg=-MALAYALAM_Tta}', "");
    Expect(0, 2148, '\P{^Jg=-MALAYALAM_Tta}', "");
    Error('\p{Is_Joining_Group=:=_MALAYALAM_TTA}');
    Error('\P{Is_Joining_Group=:=_MALAYALAM_TTA}');
    Expect(1, 2147, '\p{Is_Joining_Group=malayalamtta}', "");
    Expect(0, 2147, '\p{^Is_Joining_Group=malayalamtta}', "");
    Expect(0, 2147, '\P{Is_Joining_Group=malayalamtta}', "");
    Expect(1, 2147, '\P{^Is_Joining_Group=malayalamtta}', "");
    Expect(0, 2148, '\p{Is_Joining_Group=malayalamtta}', "");
    Expect(1, 2148, '\p{^Is_Joining_Group=malayalamtta}', "");
    Expect(1, 2148, '\P{Is_Joining_Group=malayalamtta}', "");
    Expect(0, 2148, '\P{^Is_Joining_Group=malayalamtta}', "");
    Expect(1, 2147, '\p{Is_Joining_Group= 	Malayalam_tta}', "");
    Expect(0, 2147, '\p{^Is_Joining_Group= 	Malayalam_tta}', "");
    Expect(0, 2147, '\P{Is_Joining_Group= 	Malayalam_tta}', "");
    Expect(1, 2147, '\P{^Is_Joining_Group= 	Malayalam_tta}', "");
    Expect(0, 2148, '\p{Is_Joining_Group= 	Malayalam_tta}', "");
    Expect(1, 2148, '\p{^Is_Joining_Group= 	Malayalam_tta}', "");
    Expect(1, 2148, '\P{Is_Joining_Group= 	Malayalam_tta}', "");
    Expect(0, 2148, '\P{^Is_Joining_Group= 	Malayalam_tta}', "");
    Error('\p{Is_Jg=  Malayalam_Tta:=}');
    Error('\P{Is_Jg=  Malayalam_Tta:=}');
    Expect(1, 2147, '\p{Is_Jg=malayalamtta}', "");
    Expect(0, 2147, '\p{^Is_Jg=malayalamtta}', "");
    Expect(0, 2147, '\P{Is_Jg=malayalamtta}', "");
    Expect(1, 2147, '\P{^Is_Jg=malayalamtta}', "");
    Expect(0, 2148, '\p{Is_Jg=malayalamtta}', "");
    Expect(1, 2148, '\p{^Is_Jg=malayalamtta}', "");
    Expect(1, 2148, '\P{Is_Jg=malayalamtta}', "");
    Expect(0, 2148, '\P{^Is_Jg=malayalamtta}', "");
    Expect(1, 2147, '\p{Is_Jg=_ malayalam_Tta}', "");
    Expect(0, 2147, '\p{^Is_Jg=_ malayalam_Tta}', "");
    Expect(0, 2147, '\P{Is_Jg=_ malayalam_Tta}', "");
    Expect(1, 2147, '\P{^Is_Jg=_ malayalam_Tta}', "");
    Expect(0, 2148, '\p{Is_Jg=_ malayalam_Tta}', "");
    Expect(1, 2148, '\p{^Is_Jg=_ malayalam_Tta}', "");
    Expect(1, 2148, '\P{Is_Jg=_ malayalam_Tta}', "");
    Expect(0, 2148, '\P{^Is_Jg=_ malayalam_Tta}', "");
    Error('\p{Joining_Group=/a/ 	MANICHAEAN_aleph}');
    Error('\P{Joining_Group=/a/ 	MANICHAEAN_aleph}');
    Expect(1, 68288, '\p{Joining_Group=:\AManichaean_Aleph\z:}', "");;
    Expect(0, 68289, '\p{Joining_Group=:\AManichaean_Aleph\z:}', "");;
    Expect(1, 68288, '\p{Joining_Group=manichaeanaleph}', "");
    Expect(0, 68288, '\p{^Joining_Group=manichaeanaleph}', "");
    Expect(0, 68288, '\P{Joining_Group=manichaeanaleph}', "");
    Expect(1, 68288, '\P{^Joining_Group=manichaeanaleph}', "");
    Expect(0, 68289, '\p{Joining_Group=manichaeanaleph}', "");
    Expect(1, 68289, '\p{^Joining_Group=manichaeanaleph}', "");
    Expect(1, 68289, '\P{Joining_Group=manichaeanaleph}', "");
    Expect(0, 68289, '\P{^Joining_Group=manichaeanaleph}', "");
    Expect(1, 68288, '\p{Joining_Group=:\Amanichaeanaleph\z:}', "");;
    Expect(0, 68289, '\p{Joining_Group=:\Amanichaeanaleph\z:}', "");;
    Expect(1, 68288, '\p{Joining_Group=__Manichaean_Aleph}', "");
    Expect(0, 68288, '\p{^Joining_Group=__Manichaean_Aleph}', "");
    Expect(0, 68288, '\P{Joining_Group=__Manichaean_Aleph}', "");
    Expect(1, 68288, '\P{^Joining_Group=__Manichaean_Aleph}', "");
    Expect(0, 68289, '\p{Joining_Group=__Manichaean_Aleph}', "");
    Expect(1, 68289, '\p{^Joining_Group=__Manichaean_Aleph}', "");
    Expect(1, 68289, '\P{Joining_Group=__Manichaean_Aleph}', "");
    Expect(0, 68289, '\P{^Joining_Group=__Manichaean_Aleph}', "");
    Error('\p{Jg= :=MANICHAEAN_ALEPH}');
    Error('\P{Jg= :=MANICHAEAN_ALEPH}');
    Expect(1, 68288, '\p{Jg=:\AManichaean_Aleph\z:}', "");;
    Expect(0, 68289, '\p{Jg=:\AManichaean_Aleph\z:}', "");;
    Expect(1, 68288, '\p{Jg=manichaeanaleph}', "");
    Expect(0, 68288, '\p{^Jg=manichaeanaleph}', "");
    Expect(0, 68288, '\P{Jg=manichaeanaleph}', "");
    Expect(1, 68288, '\P{^Jg=manichaeanaleph}', "");
    Expect(0, 68289, '\p{Jg=manichaeanaleph}', "");
    Expect(1, 68289, '\p{^Jg=manichaeanaleph}', "");
    Expect(1, 68289, '\P{Jg=manichaeanaleph}', "");
    Expect(0, 68289, '\P{^Jg=manichaeanaleph}', "");
    Expect(1, 68288, '\p{Jg=:\Amanichaeanaleph\z:}', "");;
    Expect(0, 68289, '\p{Jg=:\Amanichaeanaleph\z:}', "");;
    Expect(1, 68288, '\p{Jg=	_MANICHAEAN_ALEPH}', "");
    Expect(0, 68288, '\p{^Jg=	_MANICHAEAN_ALEPH}', "");
    Expect(0, 68288, '\P{Jg=	_MANICHAEAN_ALEPH}', "");
    Expect(1, 68288, '\P{^Jg=	_MANICHAEAN_ALEPH}', "");
    Expect(0, 68289, '\p{Jg=	_MANICHAEAN_ALEPH}', "");
    Expect(1, 68289, '\p{^Jg=	_MANICHAEAN_ALEPH}', "");
    Expect(1, 68289, '\P{Jg=	_MANICHAEAN_ALEPH}', "");
    Expect(0, 68289, '\P{^Jg=	_MANICHAEAN_ALEPH}', "");
    Error('\p{Is_Joining_Group::=Manichaean_aleph}');
    Error('\P{Is_Joining_Group::=Manichaean_aleph}');
    Expect(1, 68288, '\p{Is_Joining_Group:	manichaeanaleph}', "");
    Expect(0, 68288, '\p{^Is_Joining_Group:	manichaeanaleph}', "");
    Expect(0, 68288, '\P{Is_Joining_Group:	manichaeanaleph}', "");
    Expect(1, 68288, '\P{^Is_Joining_Group:	manichaeanaleph}', "");
    Expect(0, 68289, '\p{Is_Joining_Group:	manichaeanaleph}', "");
    Expect(1, 68289, '\p{^Is_Joining_Group:	manichaeanaleph}', "");
    Expect(1, 68289, '\P{Is_Joining_Group:	manichaeanaleph}', "");
    Expect(0, 68289, '\P{^Is_Joining_Group:	manichaeanaleph}', "");
    Expect(1, 68288, '\p{Is_Joining_Group=	-Manichaean_Aleph}', "");
    Expect(0, 68288, '\p{^Is_Joining_Group=	-Manichaean_Aleph}', "");
    Expect(0, 68288, '\P{Is_Joining_Group=	-Manichaean_Aleph}', "");
    Expect(1, 68288, '\P{^Is_Joining_Group=	-Manichaean_Aleph}', "");
    Expect(0, 68289, '\p{Is_Joining_Group=	-Manichaean_Aleph}', "");
    Expect(1, 68289, '\p{^Is_Joining_Group=	-Manichaean_Aleph}', "");
    Expect(1, 68289, '\P{Is_Joining_Group=	-Manichaean_Aleph}', "");
    Expect(0, 68289, '\P{^Is_Joining_Group=	-Manichaean_Aleph}', "");
    Error('\p{Is_Jg=:=Manichaean_ALEPH}');
    Error('\P{Is_Jg=:=Manichaean_ALEPH}');
    Expect(1, 68288, '\p{Is_Jg=manichaeanaleph}', "");
    Expect(0, 68288, '\p{^Is_Jg=manichaeanaleph}', "");
    Expect(0, 68288, '\P{Is_Jg=manichaeanaleph}', "");
    Expect(1, 68288, '\P{^Is_Jg=manichaeanaleph}', "");
    Expect(0, 68289, '\p{Is_Jg=manichaeanaleph}', "");
    Expect(1, 68289, '\p{^Is_Jg=manichaeanaleph}', "");
    Expect(1, 68289, '\P{Is_Jg=manichaeanaleph}', "");
    Expect(0, 68289, '\P{^Is_Jg=manichaeanaleph}', "");
    Expect(1, 68288, '\p{Is_Jg=- MANICHAEAN_Aleph}', "");
    Expect(0, 68288, '\p{^Is_Jg=- MANICHAEAN_Aleph}', "");
    Expect(0, 68288, '\P{Is_Jg=- MANICHAEAN_Aleph}', "");
    Expect(1, 68288, '\P{^Is_Jg=- MANICHAEAN_Aleph}', "");
    Expect(0, 68289, '\p{Is_Jg=- MANICHAEAN_Aleph}', "");
    Expect(1, 68289, '\p{^Is_Jg=- MANICHAEAN_Aleph}', "");
    Expect(1, 68289, '\P{Is_Jg=- MANICHAEAN_Aleph}', "");
    Expect(0, 68289, '\P{^Is_Jg=- MANICHAEAN_Aleph}', "");
    Error('\p{Joining_Group=_:=Manichaean_AYIN}');
    Error('\P{Joining_Group=_:=Manichaean_AYIN}');
    Expect(1, 68314, '\p{Joining_Group=:\AManichaean_Ayin\z:}', "");;
    Expect(0, 68315, '\p{Joining_Group=:\AManichaean_Ayin\z:}', "");;
    Expect(1, 68314, '\p{Joining_Group=manichaeanayin}', "");
    Expect(0, 68314, '\p{^Joining_Group=manichaeanayin}', "");
    Expect(0, 68314, '\P{Joining_Group=manichaeanayin}', "");
    Expect(1, 68314, '\P{^Joining_Group=manichaeanayin}', "");
    Expect(0, 68315, '\p{Joining_Group=manichaeanayin}', "");
    Expect(1, 68315, '\p{^Joining_Group=manichaeanayin}', "");
    Expect(1, 68315, '\P{Joining_Group=manichaeanayin}', "");
    Expect(0, 68315, '\P{^Joining_Group=manichaeanayin}', "");
    Expect(1, 68314, '\p{Joining_Group=:\Amanichaeanayin\z:}', "");;
    Expect(0, 68315, '\p{Joining_Group=:\Amanichaeanayin\z:}', "");;
    Expect(1, 68314, '\p{Joining_Group=	Manichaean_ayin}', "");
    Expect(0, 68314, '\p{^Joining_Group=	Manichaean_ayin}', "");
    Expect(0, 68314, '\P{Joining_Group=	Manichaean_ayin}', "");
    Expect(1, 68314, '\P{^Joining_Group=	Manichaean_ayin}', "");
    Expect(0, 68315, '\p{Joining_Group=	Manichaean_ayin}', "");
    Expect(1, 68315, '\p{^Joining_Group=	Manichaean_ayin}', "");
    Expect(1, 68315, '\P{Joining_Group=	Manichaean_ayin}', "");
    Expect(0, 68315, '\P{^Joining_Group=	Manichaean_ayin}', "");
    Error('\p{Jg=:=- MANICHAEAN_Ayin}');
    Error('\P{Jg=:=- MANICHAEAN_Ayin}');
    Expect(1, 68314, '\p{Jg=:\AManichaean_Ayin\z:}', "");;
    Expect(0, 68315, '\p{Jg=:\AManichaean_Ayin\z:}', "");;
    Expect(1, 68314, '\p{Jg=manichaeanayin}', "");
    Expect(0, 68314, '\p{^Jg=manichaeanayin}', "");
    Expect(0, 68314, '\P{Jg=manichaeanayin}', "");
    Expect(1, 68314, '\P{^Jg=manichaeanayin}', "");
    Expect(0, 68315, '\p{Jg=manichaeanayin}', "");
    Expect(1, 68315, '\p{^Jg=manichaeanayin}', "");
    Expect(1, 68315, '\P{Jg=manichaeanayin}', "");
    Expect(0, 68315, '\P{^Jg=manichaeanayin}', "");
    Expect(1, 68314, '\p{Jg=:\Amanichaeanayin\z:}', "");;
    Expect(0, 68315, '\p{Jg=:\Amanichaeanayin\z:}', "");;
    Expect(1, 68314, '\p{Jg=_	MANICHAEAN_Ayin}', "");
    Expect(0, 68314, '\p{^Jg=_	MANICHAEAN_Ayin}', "");
    Expect(0, 68314, '\P{Jg=_	MANICHAEAN_Ayin}', "");
    Expect(1, 68314, '\P{^Jg=_	MANICHAEAN_Ayin}', "");
    Expect(0, 68315, '\p{Jg=_	MANICHAEAN_Ayin}', "");
    Expect(1, 68315, '\p{^Jg=_	MANICHAEAN_Ayin}', "");
    Expect(1, 68315, '\P{Jg=_	MANICHAEAN_Ayin}', "");
    Expect(0, 68315, '\P{^Jg=_	MANICHAEAN_Ayin}', "");
    Error('\p{Is_Joining_Group=_	Manichaean_ayin/a/}');
    Error('\P{Is_Joining_Group=_	Manichaean_ayin/a/}');
    Expect(1, 68314, '\p{Is_Joining_Group=manichaeanayin}', "");
    Expect(0, 68314, '\p{^Is_Joining_Group=manichaeanayin}', "");
    Expect(0, 68314, '\P{Is_Joining_Group=manichaeanayin}', "");
    Expect(1, 68314, '\P{^Is_Joining_Group=manichaeanayin}', "");
    Expect(0, 68315, '\p{Is_Joining_Group=manichaeanayin}', "");
    Expect(1, 68315, '\p{^Is_Joining_Group=manichaeanayin}', "");
    Expect(1, 68315, '\P{Is_Joining_Group=manichaeanayin}', "");
    Expect(0, 68315, '\P{^Is_Joining_Group=manichaeanayin}', "");
    Expect(1, 68314, '\p{Is_Joining_Group=-Manichaean_Ayin}', "");
    Expect(0, 68314, '\p{^Is_Joining_Group=-Manichaean_Ayin}', "");
    Expect(0, 68314, '\P{Is_Joining_Group=-Manichaean_Ayin}', "");
    Expect(1, 68314, '\P{^Is_Joining_Group=-Manichaean_Ayin}', "");
    Expect(0, 68315, '\p{Is_Joining_Group=-Manichaean_Ayin}', "");
    Expect(1, 68315, '\p{^Is_Joining_Group=-Manichaean_Ayin}', "");
    Expect(1, 68315, '\P{Is_Joining_Group=-Manichaean_Ayin}', "");
    Expect(0, 68315, '\P{^Is_Joining_Group=-Manichaean_Ayin}', "");
    Error('\p{Is_Jg=/a/_-Manichaean_Ayin}');
    Error('\P{Is_Jg=/a/_-Manichaean_Ayin}');
    Expect(1, 68314, '\p{Is_Jg=manichaeanayin}', "");
    Expect(0, 68314, '\p{^Is_Jg=manichaeanayin}', "");
    Expect(0, 68314, '\P{Is_Jg=manichaeanayin}', "");
    Expect(1, 68314, '\P{^Is_Jg=manichaeanayin}', "");
    Expect(0, 68315, '\p{Is_Jg=manichaeanayin}', "");
    Expect(1, 68315, '\p{^Is_Jg=manichaeanayin}', "");
    Expect(1, 68315, '\P{Is_Jg=manichaeanayin}', "");
    Expect(0, 68315, '\P{^Is_Jg=manichaeanayin}', "");
    Expect(1, 68314, '\p{Is_Jg= _Manichaean_Ayin}', "");
    Expect(0, 68314, '\p{^Is_Jg= _Manichaean_Ayin}', "");
    Expect(0, 68314, '\P{Is_Jg= _Manichaean_Ayin}', "");
    Expect(1, 68314, '\P{^Is_Jg= _Manichaean_Ayin}', "");
    Expect(0, 68315, '\p{Is_Jg= _Manichaean_Ayin}', "");
    Expect(1, 68315, '\p{^Is_Jg= _Manichaean_Ayin}', "");
    Expect(1, 68315, '\P{Is_Jg= _Manichaean_Ayin}', "");
    Expect(0, 68315, '\P{^Is_Jg= _Manichaean_Ayin}', "");
    Error('\p{Joining_Group=/a/	Manichaean_beth}');
    Error('\P{Joining_Group=/a/	Manichaean_beth}');
    Expect(1, 68290, '\p{Joining_Group=:\AManichaean_Beth\z:}', "");;
    Expect(0, 68291, '\p{Joining_Group=:\AManichaean_Beth\z:}', "");;
    Expect(1, 68290, '\p{Joining_Group=manichaeanbeth}', "");
    Expect(0, 68290, '\p{^Joining_Group=manichaeanbeth}', "");
    Expect(0, 68290, '\P{Joining_Group=manichaeanbeth}', "");
    Expect(1, 68290, '\P{^Joining_Group=manichaeanbeth}', "");
    Expect(0, 68291, '\p{Joining_Group=manichaeanbeth}', "");
    Expect(1, 68291, '\p{^Joining_Group=manichaeanbeth}', "");
    Expect(1, 68291, '\P{Joining_Group=manichaeanbeth}', "");
    Expect(0, 68291, '\P{^Joining_Group=manichaeanbeth}', "");
    Expect(1, 68290, '\p{Joining_Group=:\Amanichaeanbeth\z:}', "");;
    Expect(0, 68291, '\p{Joining_Group=:\Amanichaeanbeth\z:}', "");;
    Expect(1, 68290, '\p{Joining_Group=MANICHAEAN_beth}', "");
    Expect(0, 68290, '\p{^Joining_Group=MANICHAEAN_beth}', "");
    Expect(0, 68290, '\P{Joining_Group=MANICHAEAN_beth}', "");
    Expect(1, 68290, '\P{^Joining_Group=MANICHAEAN_beth}', "");
    Expect(0, 68291, '\p{Joining_Group=MANICHAEAN_beth}', "");
    Expect(1, 68291, '\p{^Joining_Group=MANICHAEAN_beth}', "");
    Expect(1, 68291, '\P{Joining_Group=MANICHAEAN_beth}', "");
    Expect(0, 68291, '\P{^Joining_Group=MANICHAEAN_beth}', "");
    Error('\p{Jg:   /a/-_Manichaean_Beth}');
    Error('\P{Jg:   /a/-_Manichaean_Beth}');
    Expect(1, 68290, '\p{Jg=:\AManichaean_Beth\z:}', "");;
    Expect(0, 68291, '\p{Jg=:\AManichaean_Beth\z:}', "");;
    Expect(1, 68290, '\p{Jg=manichaeanbeth}', "");
    Expect(0, 68290, '\p{^Jg=manichaeanbeth}', "");
    Expect(0, 68290, '\P{Jg=manichaeanbeth}', "");
    Expect(1, 68290, '\P{^Jg=manichaeanbeth}', "");
    Expect(0, 68291, '\p{Jg=manichaeanbeth}', "");
    Expect(1, 68291, '\p{^Jg=manichaeanbeth}', "");
    Expect(1, 68291, '\P{Jg=manichaeanbeth}', "");
    Expect(0, 68291, '\P{^Jg=manichaeanbeth}', "");
    Expect(1, 68290, '\p{Jg=:\Amanichaeanbeth\z:}', "");;
    Expect(0, 68291, '\p{Jg=:\Amanichaeanbeth\z:}', "");;
    Expect(1, 68290, '\p{Jg: -	Manichaean_BETH}', "");
    Expect(0, 68290, '\p{^Jg: -	Manichaean_BETH}', "");
    Expect(0, 68290, '\P{Jg: -	Manichaean_BETH}', "");
    Expect(1, 68290, '\P{^Jg: -	Manichaean_BETH}', "");
    Expect(0, 68291, '\p{Jg: -	Manichaean_BETH}', "");
    Expect(1, 68291, '\p{^Jg: -	Manichaean_BETH}', "");
    Expect(1, 68291, '\P{Jg: -	Manichaean_BETH}', "");
    Expect(0, 68291, '\P{^Jg: -	Manichaean_BETH}', "");
    Error('\p{Is_Joining_Group=-	Manichaean_Beth:=}');
    Error('\P{Is_Joining_Group=-	Manichaean_Beth:=}');
    Expect(1, 68290, '\p{Is_Joining_Group:	manichaeanbeth}', "");
    Expect(0, 68290, '\p{^Is_Joining_Group:	manichaeanbeth}', "");
    Expect(0, 68290, '\P{Is_Joining_Group:	manichaeanbeth}', "");
    Expect(1, 68290, '\P{^Is_Joining_Group:	manichaeanbeth}', "");
    Expect(0, 68291, '\p{Is_Joining_Group:	manichaeanbeth}', "");
    Expect(1, 68291, '\p{^Is_Joining_Group:	manichaeanbeth}', "");
    Expect(1, 68291, '\P{Is_Joining_Group:	manichaeanbeth}', "");
    Expect(0, 68291, '\P{^Is_Joining_Group:	manichaeanbeth}', "");
    Expect(1, 68290, '\p{Is_Joining_Group: 	Manichaean_BETH}', "");
    Expect(0, 68290, '\p{^Is_Joining_Group: 	Manichaean_BETH}', "");
    Expect(0, 68290, '\P{Is_Joining_Group: 	Manichaean_BETH}', "");
    Expect(1, 68290, '\P{^Is_Joining_Group: 	Manichaean_BETH}', "");
    Expect(0, 68291, '\p{Is_Joining_Group: 	Manichaean_BETH}', "");
    Expect(1, 68291, '\p{^Is_Joining_Group: 	Manichaean_BETH}', "");
    Expect(1, 68291, '\P{Is_Joining_Group: 	Manichaean_BETH}', "");
    Expect(0, 68291, '\P{^Is_Joining_Group: 	Manichaean_BETH}', "");
    Error('\p{Is_Jg=_-Manichaean_beth/a/}');
    Error('\P{Is_Jg=_-Manichaean_beth/a/}');
    Expect(1, 68290, '\p{Is_Jg=manichaeanbeth}', "");
    Expect(0, 68290, '\p{^Is_Jg=manichaeanbeth}', "");
    Expect(0, 68290, '\P{Is_Jg=manichaeanbeth}', "");
    Expect(1, 68290, '\P{^Is_Jg=manichaeanbeth}', "");
    Expect(0, 68291, '\p{Is_Jg=manichaeanbeth}', "");
    Expect(1, 68291, '\p{^Is_Jg=manichaeanbeth}', "");
    Expect(1, 68291, '\P{Is_Jg=manichaeanbeth}', "");
    Expect(0, 68291, '\P{^Is_Jg=manichaeanbeth}', "");
    Expect(1, 68290, '\p{Is_Jg=_MANICHAEAN_Beth}', "");
    Expect(0, 68290, '\p{^Is_Jg=_MANICHAEAN_Beth}', "");
    Expect(0, 68290, '\P{Is_Jg=_MANICHAEAN_Beth}', "");
    Expect(1, 68290, '\P{^Is_Jg=_MANICHAEAN_Beth}', "");
    Expect(0, 68291, '\p{Is_Jg=_MANICHAEAN_Beth}', "");
    Expect(1, 68291, '\p{^Is_Jg=_MANICHAEAN_Beth}', "");
    Expect(1, 68291, '\P{Is_Jg=_MANICHAEAN_Beth}', "");
    Expect(0, 68291, '\P{^Is_Jg=_MANICHAEAN_Beth}', "");
    Error('\p{Joining_Group=:=	 MANICHAEAN_Daleth}');
    Error('\P{Joining_Group=:=	 MANICHAEAN_Daleth}');
    Expect(1, 68293, '\p{Joining_Group=:\AManichaean_Daleth\z:}', "");;
    Expect(0, 68294, '\p{Joining_Group=:\AManichaean_Daleth\z:}', "");;
    Expect(1, 68293, '\p{Joining_Group=manichaeandaleth}', "");
    Expect(0, 68293, '\p{^Joining_Group=manichaeandaleth}', "");
    Expect(0, 68293, '\P{Joining_Group=manichaeandaleth}', "");
    Expect(1, 68293, '\P{^Joining_Group=manichaeandaleth}', "");
    Expect(0, 68294, '\p{Joining_Group=manichaeandaleth}', "");
    Expect(1, 68294, '\p{^Joining_Group=manichaeandaleth}', "");
    Expect(1, 68294, '\P{Joining_Group=manichaeandaleth}', "");
    Expect(0, 68294, '\P{^Joining_Group=manichaeandaleth}', "");
    Expect(1, 68293, '\p{Joining_Group=:\Amanichaeandaleth\z:}', "");;
    Expect(0, 68294, '\p{Joining_Group=:\Amanichaeandaleth\z:}', "");;
    Expect(1, 68293, '\p{Joining_Group=- MANICHAEAN_Daleth}', "");
    Expect(0, 68293, '\p{^Joining_Group=- MANICHAEAN_Daleth}', "");
    Expect(0, 68293, '\P{Joining_Group=- MANICHAEAN_Daleth}', "");
    Expect(1, 68293, '\P{^Joining_Group=- MANICHAEAN_Daleth}', "");
    Expect(0, 68294, '\p{Joining_Group=- MANICHAEAN_Daleth}', "");
    Expect(1, 68294, '\p{^Joining_Group=- MANICHAEAN_Daleth}', "");
    Expect(1, 68294, '\P{Joining_Group=- MANICHAEAN_Daleth}', "");
    Expect(0, 68294, '\P{^Joining_Group=- MANICHAEAN_Daleth}', "");
    Error('\p{Jg=	 Manichaean_Daleth/a/}');
    Error('\P{Jg=	 Manichaean_Daleth/a/}');
    Expect(1, 68293, '\p{Jg=:\AManichaean_Daleth\z:}', "");;
    Expect(0, 68294, '\p{Jg=:\AManichaean_Daleth\z:}', "");;
    Expect(1, 68293, '\p{Jg=manichaeandaleth}', "");
    Expect(0, 68293, '\p{^Jg=manichaeandaleth}', "");
    Expect(0, 68293, '\P{Jg=manichaeandaleth}', "");
    Expect(1, 68293, '\P{^Jg=manichaeandaleth}', "");
    Expect(0, 68294, '\p{Jg=manichaeandaleth}', "");
    Expect(1, 68294, '\p{^Jg=manichaeandaleth}', "");
    Expect(1, 68294, '\P{Jg=manichaeandaleth}', "");
    Expect(0, 68294, '\P{^Jg=manichaeandaleth}', "");
    Expect(1, 68293, '\p{Jg=:\Amanichaeandaleth\z:}', "");;
    Expect(0, 68294, '\p{Jg=:\Amanichaeandaleth\z:}', "");;
    Expect(1, 68293, '\p{Jg=--Manichaean_DALETH}', "");
    Expect(0, 68293, '\p{^Jg=--Manichaean_DALETH}', "");
    Expect(0, 68293, '\P{Jg=--Manichaean_DALETH}', "");
    Expect(1, 68293, '\P{^Jg=--Manichaean_DALETH}', "");
    Expect(0, 68294, '\p{Jg=--Manichaean_DALETH}', "");
    Expect(1, 68294, '\p{^Jg=--Manichaean_DALETH}', "");
    Expect(1, 68294, '\P{Jg=--Manichaean_DALETH}', "");
    Expect(0, 68294, '\P{^Jg=--Manichaean_DALETH}', "");
    Error('\p{Is_Joining_Group: __Manichaean_DALETH:=}');
    Error('\P{Is_Joining_Group: __Manichaean_DALETH:=}');
    Expect(1, 68293, '\p{Is_Joining_Group=manichaeandaleth}', "");
    Expect(0, 68293, '\p{^Is_Joining_Group=manichaeandaleth}', "");
    Expect(0, 68293, '\P{Is_Joining_Group=manichaeandaleth}', "");
    Expect(1, 68293, '\P{^Is_Joining_Group=manichaeandaleth}', "");
    Expect(0, 68294, '\p{Is_Joining_Group=manichaeandaleth}', "");
    Expect(1, 68294, '\p{^Is_Joining_Group=manichaeandaleth}', "");
    Expect(1, 68294, '\P{Is_Joining_Group=manichaeandaleth}', "");
    Expect(0, 68294, '\P{^Is_Joining_Group=manichaeandaleth}', "");
    Expect(1, 68293, '\p{Is_Joining_Group=-MANICHAEAN_Daleth}', "");
    Expect(0, 68293, '\p{^Is_Joining_Group=-MANICHAEAN_Daleth}', "");
    Expect(0, 68293, '\P{Is_Joining_Group=-MANICHAEAN_Daleth}', "");
    Expect(1, 68293, '\P{^Is_Joining_Group=-MANICHAEAN_Daleth}', "");
    Expect(0, 68294, '\p{Is_Joining_Group=-MANICHAEAN_Daleth}', "");
    Expect(1, 68294, '\p{^Is_Joining_Group=-MANICHAEAN_Daleth}', "");
    Expect(1, 68294, '\P{Is_Joining_Group=-MANICHAEAN_Daleth}', "");
    Expect(0, 68294, '\P{^Is_Joining_Group=-MANICHAEAN_Daleth}', "");
    Error('\p{Is_Jg=_Manichaean_Daleth/a/}');
    Error('\P{Is_Jg=_Manichaean_Daleth/a/}');
    Expect(1, 68293, '\p{Is_Jg=manichaeandaleth}', "");
    Expect(0, 68293, '\p{^Is_Jg=manichaeandaleth}', "");
    Expect(0, 68293, '\P{Is_Jg=manichaeandaleth}', "");
    Expect(1, 68293, '\P{^Is_Jg=manichaeandaleth}', "");
    Expect(0, 68294, '\p{Is_Jg=manichaeandaleth}', "");
    Expect(1, 68294, '\p{^Is_Jg=manichaeandaleth}', "");
    Expect(1, 68294, '\P{Is_Jg=manichaeandaleth}', "");
    Expect(0, 68294, '\P{^Is_Jg=manichaeandaleth}', "");
    Expect(1, 68293, '\p{Is_Jg=--Manichaean_Daleth}', "");
    Expect(0, 68293, '\p{^Is_Jg=--Manichaean_Daleth}', "");
    Expect(0, 68293, '\P{Is_Jg=--Manichaean_Daleth}', "");
    Expect(1, 68293, '\P{^Is_Jg=--Manichaean_Daleth}', "");
    Expect(0, 68294, '\p{Is_Jg=--Manichaean_Daleth}', "");
    Expect(1, 68294, '\p{^Is_Jg=--Manichaean_Daleth}', "");
    Expect(1, 68294, '\P{Is_Jg=--Manichaean_Daleth}', "");
    Expect(0, 68294, '\P{^Is_Jg=--Manichaean_Daleth}', "");
    Error('\p{Joining_Group=/a/ manichaean_dhamedh}');
    Error('\P{Joining_Group=/a/ manichaean_dhamedh}');
    Expect(1, 68308, '\p{Joining_Group=:\AManichaean_Dhamedh\z:}', "");;
    Expect(0, 68309, '\p{Joining_Group=:\AManichaean_Dhamedh\z:}', "");;
    Expect(1, 68308, '\p{Joining_Group=manichaeandhamedh}', "");
    Expect(0, 68308, '\p{^Joining_Group=manichaeandhamedh}', "");
    Expect(0, 68308, '\P{Joining_Group=manichaeandhamedh}', "");
    Expect(1, 68308, '\P{^Joining_Group=manichaeandhamedh}', "");
    Expect(0, 68309, '\p{Joining_Group=manichaeandhamedh}', "");
    Expect(1, 68309, '\p{^Joining_Group=manichaeandhamedh}', "");
    Expect(1, 68309, '\P{Joining_Group=manichaeandhamedh}', "");
    Expect(0, 68309, '\P{^Joining_Group=manichaeandhamedh}', "");
    Expect(1, 68308, '\p{Joining_Group=:\Amanichaeandhamedh\z:}', "");;
    Expect(0, 68309, '\p{Joining_Group=:\Amanichaeandhamedh\z:}', "");;
    Expect(1, 68308, '\p{Joining_Group= manichaean_Dhamedh}', "");
    Expect(0, 68308, '\p{^Joining_Group= manichaean_Dhamedh}', "");
    Expect(0, 68308, '\P{Joining_Group= manichaean_Dhamedh}', "");
    Expect(1, 68308, '\P{^Joining_Group= manichaean_Dhamedh}', "");
    Expect(0, 68309, '\p{Joining_Group= manichaean_Dhamedh}', "");
    Expect(1, 68309, '\p{^Joining_Group= manichaean_Dhamedh}', "");
    Expect(1, 68309, '\P{Joining_Group= manichaean_Dhamedh}', "");
    Expect(0, 68309, '\P{^Joining_Group= manichaean_Dhamedh}', "");
    Error('\p{Jg=	-MANICHAEAN_DHAMEDH:=}');
    Error('\P{Jg=	-MANICHAEAN_DHAMEDH:=}');
    Expect(1, 68308, '\p{Jg=:\AManichaean_Dhamedh\z:}', "");;
    Expect(0, 68309, '\p{Jg=:\AManichaean_Dhamedh\z:}', "");;
    Expect(1, 68308, '\p{Jg=manichaeandhamedh}', "");
    Expect(0, 68308, '\p{^Jg=manichaeandhamedh}', "");
    Expect(0, 68308, '\P{Jg=manichaeandhamedh}', "");
    Expect(1, 68308, '\P{^Jg=manichaeandhamedh}', "");
    Expect(0, 68309, '\p{Jg=manichaeandhamedh}', "");
    Expect(1, 68309, '\p{^Jg=manichaeandhamedh}', "");
    Expect(1, 68309, '\P{Jg=manichaeandhamedh}', "");
    Expect(0, 68309, '\P{^Jg=manichaeandhamedh}', "");
    Expect(1, 68308, '\p{Jg=:\Amanichaeandhamedh\z:}', "");;
    Expect(0, 68309, '\p{Jg=:\Amanichaeandhamedh\z:}', "");;
    Expect(1, 68308, '\p{Jg=-_Manichaean_dhamedh}', "");
    Expect(0, 68308, '\p{^Jg=-_Manichaean_dhamedh}', "");
    Expect(0, 68308, '\P{Jg=-_Manichaean_dhamedh}', "");
    Expect(1, 68308, '\P{^Jg=-_Manichaean_dhamedh}', "");
    Expect(0, 68309, '\p{Jg=-_Manichaean_dhamedh}', "");
    Expect(1, 68309, '\p{^Jg=-_Manichaean_dhamedh}', "");
    Expect(1, 68309, '\P{Jg=-_Manichaean_dhamedh}', "");
    Expect(0, 68309, '\P{^Jg=-_Manichaean_dhamedh}', "");
    Error('\p{Is_Joining_Group=:=	 Manichaean_dhamedh}');
    Error('\P{Is_Joining_Group=:=	 Manichaean_dhamedh}');
    Expect(1, 68308, '\p{Is_Joining_Group=manichaeandhamedh}', "");
    Expect(0, 68308, '\p{^Is_Joining_Group=manichaeandhamedh}', "");
    Expect(0, 68308, '\P{Is_Joining_Group=manichaeandhamedh}', "");
    Expect(1, 68308, '\P{^Is_Joining_Group=manichaeandhamedh}', "");
    Expect(0, 68309, '\p{Is_Joining_Group=manichaeandhamedh}', "");
    Expect(1, 68309, '\p{^Is_Joining_Group=manichaeandhamedh}', "");
    Expect(1, 68309, '\P{Is_Joining_Group=manichaeandhamedh}', "");
    Expect(0, 68309, '\P{^Is_Joining_Group=manichaeandhamedh}', "");
    Expect(1, 68308, '\p{Is_Joining_Group=-MANICHAEAN_Dhamedh}', "");
    Expect(0, 68308, '\p{^Is_Joining_Group=-MANICHAEAN_Dhamedh}', "");
    Expect(0, 68308, '\P{Is_Joining_Group=-MANICHAEAN_Dhamedh}', "");
    Expect(1, 68308, '\P{^Is_Joining_Group=-MANICHAEAN_Dhamedh}', "");
    Expect(0, 68309, '\p{Is_Joining_Group=-MANICHAEAN_Dhamedh}', "");
    Expect(1, 68309, '\p{^Is_Joining_Group=-MANICHAEAN_Dhamedh}', "");
    Expect(1, 68309, '\P{Is_Joining_Group=-MANICHAEAN_Dhamedh}', "");
    Expect(0, 68309, '\P{^Is_Joining_Group=-MANICHAEAN_Dhamedh}', "");
    Error('\p{Is_Jg=:=manichaean_Dhamedh}');
    Error('\P{Is_Jg=:=manichaean_Dhamedh}');
    Expect(1, 68308, '\p{Is_Jg=manichaeandhamedh}', "");
    Expect(0, 68308, '\p{^Is_Jg=manichaeandhamedh}', "");
    Expect(0, 68308, '\P{Is_Jg=manichaeandhamedh}', "");
    Expect(1, 68308, '\P{^Is_Jg=manichaeandhamedh}', "");
    Expect(0, 68309, '\p{Is_Jg=manichaeandhamedh}', "");
    Expect(1, 68309, '\p{^Is_Jg=manichaeandhamedh}', "");
    Expect(1, 68309, '\P{Is_Jg=manichaeandhamedh}', "");
    Expect(0, 68309, '\P{^Is_Jg=manichaeandhamedh}', "");
    Expect(1, 68308, '\p{Is_Jg= -Manichaean_Dhamedh}', "");
    Expect(0, 68308, '\p{^Is_Jg= -Manichaean_Dhamedh}', "");
    Expect(0, 68308, '\P{Is_Jg= -Manichaean_Dhamedh}', "");
    Expect(1, 68308, '\P{^Is_Jg= -Manichaean_Dhamedh}', "");
    Expect(0, 68309, '\p{Is_Jg= -Manichaean_Dhamedh}', "");
    Expect(1, 68309, '\p{^Is_Jg= -Manichaean_Dhamedh}', "");
    Expect(1, 68309, '\P{Is_Jg= -Manichaean_Dhamedh}', "");
    Expect(0, 68309, '\P{^Is_Jg= -Manichaean_Dhamedh}', "");
    Error('\p{Joining_Group:	:=Manichaean_five}');
    Error('\P{Joining_Group:	:=Manichaean_five}');
    Expect(1, 68332, '\p{Joining_Group=:\AManichaean_Five\z:}', "");;
    Expect(0, 68333, '\p{Joining_Group=:\AManichaean_Five\z:}', "");;
    Expect(1, 68332, '\p{Joining_Group=manichaeanfive}', "");
    Expect(0, 68332, '\p{^Joining_Group=manichaeanfive}', "");
    Expect(0, 68332, '\P{Joining_Group=manichaeanfive}', "");
    Expect(1, 68332, '\P{^Joining_Group=manichaeanfive}', "");
    Expect(0, 68333, '\p{Joining_Group=manichaeanfive}', "");
    Expect(1, 68333, '\p{^Joining_Group=manichaeanfive}', "");
    Expect(1, 68333, '\P{Joining_Group=manichaeanfive}', "");
    Expect(0, 68333, '\P{^Joining_Group=manichaeanfive}', "");
    Expect(1, 68332, '\p{Joining_Group=:\Amanichaeanfive\z:}', "");;
    Expect(0, 68333, '\p{Joining_Group=:\Amanichaeanfive\z:}', "");;
    Expect(1, 68332, '\p{Joining_Group=  manichaean_Five}', "");
    Expect(0, 68332, '\p{^Joining_Group=  manichaean_Five}', "");
    Expect(0, 68332, '\P{Joining_Group=  manichaean_Five}', "");
    Expect(1, 68332, '\P{^Joining_Group=  manichaean_Five}', "");
    Expect(0, 68333, '\p{Joining_Group=  manichaean_Five}', "");
    Expect(1, 68333, '\p{^Joining_Group=  manichaean_Five}', "");
    Expect(1, 68333, '\P{Joining_Group=  manichaean_Five}', "");
    Expect(0, 68333, '\P{^Joining_Group=  manichaean_Five}', "");
    Error('\p{Jg=_Manichaean_Five:=}');
    Error('\P{Jg=_Manichaean_Five:=}');
    Expect(1, 68332, '\p{Jg=:\AManichaean_Five\z:}', "");;
    Expect(0, 68333, '\p{Jg=:\AManichaean_Five\z:}', "");;
    Expect(1, 68332, '\p{Jg=manichaeanfive}', "");
    Expect(0, 68332, '\p{^Jg=manichaeanfive}', "");
    Expect(0, 68332, '\P{Jg=manichaeanfive}', "");
    Expect(1, 68332, '\P{^Jg=manichaeanfive}', "");
    Expect(0, 68333, '\p{Jg=manichaeanfive}', "");
    Expect(1, 68333, '\p{^Jg=manichaeanfive}', "");
    Expect(1, 68333, '\P{Jg=manichaeanfive}', "");
    Expect(0, 68333, '\P{^Jg=manichaeanfive}', "");
    Expect(1, 68332, '\p{Jg=:\Amanichaeanfive\z:}', "");;
    Expect(0, 68333, '\p{Jg=:\Amanichaeanfive\z:}', "");;
    Expect(1, 68332, '\p{Jg=_manichaean_five}', "");
    Expect(0, 68332, '\p{^Jg=_manichaean_five}', "");
    Expect(0, 68332, '\P{Jg=_manichaean_five}', "");
    Expect(1, 68332, '\P{^Jg=_manichaean_five}', "");
    Expect(0, 68333, '\p{Jg=_manichaean_five}', "");
    Expect(1, 68333, '\p{^Jg=_manichaean_five}', "");
    Expect(1, 68333, '\P{Jg=_manichaean_five}', "");
    Expect(0, 68333, '\P{^Jg=_manichaean_five}', "");
    Error('\p{Is_Joining_Group=:=  manichaean_Five}');
    Error('\P{Is_Joining_Group=:=  manichaean_Five}');
    Expect(1, 68332, '\p{Is_Joining_Group=manichaeanfive}', "");
    Expect(0, 68332, '\p{^Is_Joining_Group=manichaeanfive}', "");
    Expect(0, 68332, '\P{Is_Joining_Group=manichaeanfive}', "");
    Expect(1, 68332, '\P{^Is_Joining_Group=manichaeanfive}', "");
    Expect(0, 68333, '\p{Is_Joining_Group=manichaeanfive}', "");
    Expect(1, 68333, '\p{^Is_Joining_Group=manichaeanfive}', "");
    Expect(1, 68333, '\P{Is_Joining_Group=manichaeanfive}', "");
    Expect(0, 68333, '\P{^Is_Joining_Group=manichaeanfive}', "");
    Expect(1, 68332, '\p{Is_Joining_Group=	_Manichaean_FIVE}', "");
    Expect(0, 68332, '\p{^Is_Joining_Group=	_Manichaean_FIVE}', "");
    Expect(0, 68332, '\P{Is_Joining_Group=	_Manichaean_FIVE}', "");
    Expect(1, 68332, '\P{^Is_Joining_Group=	_Manichaean_FIVE}', "");
    Expect(0, 68333, '\p{Is_Joining_Group=	_Manichaean_FIVE}', "");
    Expect(1, 68333, '\p{^Is_Joining_Group=	_Manichaean_FIVE}', "");
    Expect(1, 68333, '\P{Is_Joining_Group=	_Manichaean_FIVE}', "");
    Expect(0, 68333, '\P{^Is_Joining_Group=	_Manichaean_FIVE}', "");
    Error('\p{Is_Jg:	:= -MANICHAEAN_FIVE}');
    Error('\P{Is_Jg:	:= -MANICHAEAN_FIVE}');
    Expect(1, 68332, '\p{Is_Jg:   manichaeanfive}', "");
    Expect(0, 68332, '\p{^Is_Jg:   manichaeanfive}', "");
    Expect(0, 68332, '\P{Is_Jg:   manichaeanfive}', "");
    Expect(1, 68332, '\P{^Is_Jg:   manichaeanfive}', "");
    Expect(0, 68333, '\p{Is_Jg:   manichaeanfive}', "");
    Expect(1, 68333, '\p{^Is_Jg:   manichaeanfive}', "");
    Expect(1, 68333, '\P{Is_Jg:   manichaeanfive}', "");
    Expect(0, 68333, '\P{^Is_Jg:   manichaeanfive}', "");
    Expect(1, 68332, '\p{Is_Jg=	Manichaean_FIVE}', "");
    Expect(0, 68332, '\p{^Is_Jg=	Manichaean_FIVE}', "");
    Expect(0, 68332, '\P{Is_Jg=	Manichaean_FIVE}', "");
    Expect(1, 68332, '\P{^Is_Jg=	Manichaean_FIVE}', "");
    Expect(0, 68333, '\p{Is_Jg=	Manichaean_FIVE}', "");
    Expect(1, 68333, '\p{^Is_Jg=	Manichaean_FIVE}', "");
    Expect(1, 68333, '\P{Is_Jg=	Manichaean_FIVE}', "");
    Expect(0, 68333, '\P{^Is_Jg=	Manichaean_FIVE}', "");
    Error('\p{Joining_Group:   -_manichaean_GIMEL:=}');
    Error('\P{Joining_Group:   -_manichaean_GIMEL:=}');
    Expect(1, 68292, '\p{Joining_Group=:\AManichaean_Gimel\z:}', "");;
    Expect(0, 68293, '\p{Joining_Group=:\AManichaean_Gimel\z:}', "");;
    Expect(1, 68292, '\p{Joining_Group=manichaeangimel}', "");
    Expect(0, 68292, '\p{^Joining_Group=manichaeangimel}', "");
    Expect(0, 68292, '\P{Joining_Group=manichaeangimel}', "");
    Expect(1, 68292, '\P{^Joining_Group=manichaeangimel}', "");
    Expect(0, 68293, '\p{Joining_Group=manichaeangimel}', "");
    Expect(1, 68293, '\p{^Joining_Group=manichaeangimel}', "");
    Expect(1, 68293, '\P{Joining_Group=manichaeangimel}', "");
    Expect(0, 68293, '\P{^Joining_Group=manichaeangimel}', "");
    Expect(1, 68292, '\p{Joining_Group=:\Amanichaeangimel\z:}', "");;
    Expect(0, 68293, '\p{Joining_Group=:\Amanichaeangimel\z:}', "");;
    Expect(1, 68292, '\p{Joining_Group=		MANICHAEAN_GIMEL}', "");
    Expect(0, 68292, '\p{^Joining_Group=		MANICHAEAN_GIMEL}', "");
    Expect(0, 68292, '\P{Joining_Group=		MANICHAEAN_GIMEL}', "");
    Expect(1, 68292, '\P{^Joining_Group=		MANICHAEAN_GIMEL}', "");
    Expect(0, 68293, '\p{Joining_Group=		MANICHAEAN_GIMEL}', "");
    Expect(1, 68293, '\p{^Joining_Group=		MANICHAEAN_GIMEL}', "");
    Expect(1, 68293, '\P{Joining_Group=		MANICHAEAN_GIMEL}', "");
    Expect(0, 68293, '\P{^Joining_Group=		MANICHAEAN_GIMEL}', "");
    Error('\p{Jg=	:=manichaean_gimel}');
    Error('\P{Jg=	:=manichaean_gimel}');
    Expect(1, 68292, '\p{Jg=:\AManichaean_Gimel\z:}', "");;
    Expect(0, 68293, '\p{Jg=:\AManichaean_Gimel\z:}', "");;
    Expect(1, 68292, '\p{Jg=manichaeangimel}', "");
    Expect(0, 68292, '\p{^Jg=manichaeangimel}', "");
    Expect(0, 68292, '\P{Jg=manichaeangimel}', "");
    Expect(1, 68292, '\P{^Jg=manichaeangimel}', "");
    Expect(0, 68293, '\p{Jg=manichaeangimel}', "");
    Expect(1, 68293, '\p{^Jg=manichaeangimel}', "");
    Expect(1, 68293, '\P{Jg=manichaeangimel}', "");
    Expect(0, 68293, '\P{^Jg=manichaeangimel}', "");
    Expect(1, 68292, '\p{Jg=:\Amanichaeangimel\z:}', "");;
    Expect(0, 68293, '\p{Jg=:\Amanichaeangimel\z:}', "");;
    Expect(1, 68292, '\p{Jg= 	Manichaean_Gimel}', "");
    Expect(0, 68292, '\p{^Jg= 	Manichaean_Gimel}', "");
    Expect(0, 68292, '\P{Jg= 	Manichaean_Gimel}', "");
    Expect(1, 68292, '\P{^Jg= 	Manichaean_Gimel}', "");
    Expect(0, 68293, '\p{Jg= 	Manichaean_Gimel}', "");
    Expect(1, 68293, '\p{^Jg= 	Manichaean_Gimel}', "");
    Expect(1, 68293, '\P{Jg= 	Manichaean_Gimel}', "");
    Expect(0, 68293, '\P{^Jg= 	Manichaean_Gimel}', "");
    Error('\p{Is_Joining_Group=/a/MANICHAEAN_gimel}');
    Error('\P{Is_Joining_Group=/a/MANICHAEAN_gimel}');
    Expect(1, 68292, '\p{Is_Joining_Group=manichaeangimel}', "");
    Expect(0, 68292, '\p{^Is_Joining_Group=manichaeangimel}', "");
    Expect(0, 68292, '\P{Is_Joining_Group=manichaeangimel}', "");
    Expect(1, 68292, '\P{^Is_Joining_Group=manichaeangimel}', "");
    Expect(0, 68293, '\p{Is_Joining_Group=manichaeangimel}', "");
    Expect(1, 68293, '\p{^Is_Joining_Group=manichaeangimel}', "");
    Expect(1, 68293, '\P{Is_Joining_Group=manichaeangimel}', "");
    Expect(0, 68293, '\P{^Is_Joining_Group=manichaeangimel}', "");
    Expect(1, 68292, '\p{Is_Joining_Group=-manichaean_Gimel}', "");
    Expect(0, 68292, '\p{^Is_Joining_Group=-manichaean_Gimel}', "");
    Expect(0, 68292, '\P{Is_Joining_Group=-manichaean_Gimel}', "");
    Expect(1, 68292, '\P{^Is_Joining_Group=-manichaean_Gimel}', "");
    Expect(0, 68293, '\p{Is_Joining_Group=-manichaean_Gimel}', "");
    Expect(1, 68293, '\p{^Is_Joining_Group=-manichaean_Gimel}', "");
    Expect(1, 68293, '\P{Is_Joining_Group=-manichaean_Gimel}', "");
    Expect(0, 68293, '\P{^Is_Joining_Group=-manichaean_Gimel}', "");
    Error('\p{Is_Jg=:= -Manichaean_Gimel}');
    Error('\P{Is_Jg=:= -Manichaean_Gimel}');
    Expect(1, 68292, '\p{Is_Jg=manichaeangimel}', "");
    Expect(0, 68292, '\p{^Is_Jg=manichaeangimel}', "");
    Expect(0, 68292, '\P{Is_Jg=manichaeangimel}', "");
    Expect(1, 68292, '\P{^Is_Jg=manichaeangimel}', "");
    Expect(0, 68293, '\p{Is_Jg=manichaeangimel}', "");
    Expect(1, 68293, '\p{^Is_Jg=manichaeangimel}', "");
    Expect(1, 68293, '\P{Is_Jg=manichaeangimel}', "");
    Expect(0, 68293, '\P{^Is_Jg=manichaeangimel}', "");
    Expect(1, 68292, '\p{Is_Jg=-manichaean_Gimel}', "");
    Expect(0, 68292, '\p{^Is_Jg=-manichaean_Gimel}', "");
    Expect(0, 68292, '\P{Is_Jg=-manichaean_Gimel}', "");
    Expect(1, 68292, '\P{^Is_Jg=-manichaean_Gimel}', "");
    Expect(0, 68293, '\p{Is_Jg=-manichaean_Gimel}', "");
    Expect(1, 68293, '\p{^Is_Jg=-manichaean_Gimel}', "");
    Expect(1, 68293, '\P{Is_Jg=-manichaean_Gimel}', "");
    Expect(0, 68293, '\P{^Is_Jg=-manichaean_Gimel}', "");
    Error('\p{Joining_Group:-_Manichaean_heth:=}');
    Error('\P{Joining_Group:-_Manichaean_heth:=}');
    Expect(1, 68301, '\p{Joining_Group=:\AManichaean_Heth\z:}', "");;
    Expect(0, 68302, '\p{Joining_Group=:\AManichaean_Heth\z:}', "");;
    Expect(1, 68301, '\p{Joining_Group=manichaeanheth}', "");
    Expect(0, 68301, '\p{^Joining_Group=manichaeanheth}', "");
    Expect(0, 68301, '\P{Joining_Group=manichaeanheth}', "");
    Expect(1, 68301, '\P{^Joining_Group=manichaeanheth}', "");
    Expect(0, 68302, '\p{Joining_Group=manichaeanheth}', "");
    Expect(1, 68302, '\p{^Joining_Group=manichaeanheth}', "");
    Expect(1, 68302, '\P{Joining_Group=manichaeanheth}', "");
    Expect(0, 68302, '\P{^Joining_Group=manichaeanheth}', "");
    Expect(1, 68301, '\p{Joining_Group=:\Amanichaeanheth\z:}', "");;
    Expect(0, 68302, '\p{Joining_Group=:\Amanichaeanheth\z:}', "");;
    Expect(1, 68301, '\p{Joining_Group=	Manichaean_Heth}', "");
    Expect(0, 68301, '\p{^Joining_Group=	Manichaean_Heth}', "");
    Expect(0, 68301, '\P{Joining_Group=	Manichaean_Heth}', "");
    Expect(1, 68301, '\P{^Joining_Group=	Manichaean_Heth}', "");
    Expect(0, 68302, '\p{Joining_Group=	Manichaean_Heth}', "");
    Expect(1, 68302, '\p{^Joining_Group=	Manichaean_Heth}', "");
    Expect(1, 68302, '\P{Joining_Group=	Manichaean_Heth}', "");
    Expect(0, 68302, '\P{^Joining_Group=	Manichaean_Heth}', "");
    Error('\p{Jg:		/a/MANICHAEAN_Heth}');
    Error('\P{Jg:		/a/MANICHAEAN_Heth}');
    Expect(1, 68301, '\p{Jg=:\AManichaean_Heth\z:}', "");;
    Expect(0, 68302, '\p{Jg=:\AManichaean_Heth\z:}', "");;
    Expect(1, 68301, '\p{Jg=manichaeanheth}', "");
    Expect(0, 68301, '\p{^Jg=manichaeanheth}', "");
    Expect(0, 68301, '\P{Jg=manichaeanheth}', "");
    Expect(1, 68301, '\P{^Jg=manichaeanheth}', "");
    Expect(0, 68302, '\p{Jg=manichaeanheth}', "");
    Expect(1, 68302, '\p{^Jg=manichaeanheth}', "");
    Expect(1, 68302, '\P{Jg=manichaeanheth}', "");
    Expect(0, 68302, '\P{^Jg=manichaeanheth}', "");
    Expect(1, 68301, '\p{Jg=:\Amanichaeanheth\z:}', "");;
    Expect(0, 68302, '\p{Jg=:\Amanichaeanheth\z:}', "");;
    Expect(1, 68301, '\p{Jg=__Manichaean_HETH}', "");
    Expect(0, 68301, '\p{^Jg=__Manichaean_HETH}', "");
    Expect(0, 68301, '\P{Jg=__Manichaean_HETH}', "");
    Expect(1, 68301, '\P{^Jg=__Manichaean_HETH}', "");
    Expect(0, 68302, '\p{Jg=__Manichaean_HETH}', "");
    Expect(1, 68302, '\p{^Jg=__Manichaean_HETH}', "");
    Expect(1, 68302, '\P{Jg=__Manichaean_HETH}', "");
    Expect(0, 68302, '\P{^Jg=__Manichaean_HETH}', "");
    Error('\p{Is_Joining_Group=:=-_Manichaean_Heth}');
    Error('\P{Is_Joining_Group=:=-_Manichaean_Heth}');
    Expect(1, 68301, '\p{Is_Joining_Group=manichaeanheth}', "");
    Expect(0, 68301, '\p{^Is_Joining_Group=manichaeanheth}', "");
    Expect(0, 68301, '\P{Is_Joining_Group=manichaeanheth}', "");
    Expect(1, 68301, '\P{^Is_Joining_Group=manichaeanheth}', "");
    Expect(0, 68302, '\p{Is_Joining_Group=manichaeanheth}', "");
    Expect(1, 68302, '\p{^Is_Joining_Group=manichaeanheth}', "");
    Expect(1, 68302, '\P{Is_Joining_Group=manichaeanheth}', "");
    Expect(0, 68302, '\P{^Is_Joining_Group=manichaeanheth}', "");
    Expect(1, 68301, '\p{Is_Joining_Group=	_Manichaean_heth}', "");
    Expect(0, 68301, '\p{^Is_Joining_Group=	_Manichaean_heth}', "");
    Expect(0, 68301, '\P{Is_Joining_Group=	_Manichaean_heth}', "");
    Expect(1, 68301, '\P{^Is_Joining_Group=	_Manichaean_heth}', "");
    Expect(0, 68302, '\p{Is_Joining_Group=	_Manichaean_heth}', "");
    Expect(1, 68302, '\p{^Is_Joining_Group=	_Manichaean_heth}', "");
    Expect(1, 68302, '\P{Is_Joining_Group=	_Manichaean_heth}', "");
    Expect(0, 68302, '\P{^Is_Joining_Group=	_Manichaean_heth}', "");
    Error('\p{Is_Jg=manichaean_Heth/a/}');
    Error('\P{Is_Jg=manichaean_Heth/a/}');
    Expect(1, 68301, '\p{Is_Jg=manichaeanheth}', "");
    Expect(0, 68301, '\p{^Is_Jg=manichaeanheth}', "");
    Expect(0, 68301, '\P{Is_Jg=manichaeanheth}', "");
    Expect(1, 68301, '\P{^Is_Jg=manichaeanheth}', "");
    Expect(0, 68302, '\p{Is_Jg=manichaeanheth}', "");
    Expect(1, 68302, '\p{^Is_Jg=manichaeanheth}', "");
    Expect(1, 68302, '\P{Is_Jg=manichaeanheth}', "");
    Expect(0, 68302, '\P{^Is_Jg=manichaeanheth}', "");
    Expect(1, 68301, '\p{Is_Jg:	-	Manichaean_HETH}', "");
    Expect(0, 68301, '\p{^Is_Jg:	-	Manichaean_HETH}', "");
    Expect(0, 68301, '\P{Is_Jg:	-	Manichaean_HETH}', "");
    Expect(1, 68301, '\P{^Is_Jg:	-	Manichaean_HETH}', "");
    Expect(0, 68302, '\p{Is_Jg:	-	Manichaean_HETH}', "");
    Expect(1, 68302, '\p{^Is_Jg:	-	Manichaean_HETH}', "");
    Expect(1, 68302, '\P{Is_Jg:	-	Manichaean_HETH}', "");
    Expect(0, 68302, '\P{^Is_Jg:	-	Manichaean_HETH}', "");
    Error('\p{Joining_Group= MANICHAEAN_HUNDRED:=}');
    Error('\P{Joining_Group= MANICHAEAN_HUNDRED:=}');
    Expect(1, 68335, '\p{Joining_Group=:\AManichaean_Hundred\z:}', "");;
    Expect(0, 68336, '\p{Joining_Group=:\AManichaean_Hundred\z:}', "");;
    Expect(1, 68335, '\p{Joining_Group=manichaeanhundred}', "");
    Expect(0, 68335, '\p{^Joining_Group=manichaeanhundred}', "");
    Expect(0, 68335, '\P{Joining_Group=manichaeanhundred}', "");
    Expect(1, 68335, '\P{^Joining_Group=manichaeanhundred}', "");
    Expect(0, 68336, '\p{Joining_Group=manichaeanhundred}', "");
    Expect(1, 68336, '\p{^Joining_Group=manichaeanhundred}', "");
    Expect(1, 68336, '\P{Joining_Group=manichaeanhundred}', "");
    Expect(0, 68336, '\P{^Joining_Group=manichaeanhundred}', "");
    Expect(1, 68335, '\p{Joining_Group=:\Amanichaeanhundred\z:}', "");;
    Expect(0, 68336, '\p{Joining_Group=:\Amanichaeanhundred\z:}', "");;
    Expect(1, 68335, '\p{Joining_Group= -MANICHAEAN_Hundred}', "");
    Expect(0, 68335, '\p{^Joining_Group= -MANICHAEAN_Hundred}', "");
    Expect(0, 68335, '\P{Joining_Group= -MANICHAEAN_Hundred}', "");
    Expect(1, 68335, '\P{^Joining_Group= -MANICHAEAN_Hundred}', "");
    Expect(0, 68336, '\p{Joining_Group= -MANICHAEAN_Hundred}', "");
    Expect(1, 68336, '\p{^Joining_Group= -MANICHAEAN_Hundred}', "");
    Expect(1, 68336, '\P{Joining_Group= -MANICHAEAN_Hundred}', "");
    Expect(0, 68336, '\P{^Joining_Group= -MANICHAEAN_Hundred}', "");
    Error('\p{Jg=/a/MANICHAEAN_hundred}');
    Error('\P{Jg=/a/MANICHAEAN_hundred}');
    Expect(1, 68335, '\p{Jg=:\AManichaean_Hundred\z:}', "");;
    Expect(0, 68336, '\p{Jg=:\AManichaean_Hundred\z:}', "");;
    Expect(1, 68335, '\p{Jg: manichaeanhundred}', "");
    Expect(0, 68335, '\p{^Jg: manichaeanhundred}', "");
    Expect(0, 68335, '\P{Jg: manichaeanhundred}', "");
    Expect(1, 68335, '\P{^Jg: manichaeanhundred}', "");
    Expect(0, 68336, '\p{Jg: manichaeanhundred}', "");
    Expect(1, 68336, '\p{^Jg: manichaeanhundred}', "");
    Expect(1, 68336, '\P{Jg: manichaeanhundred}', "");
    Expect(0, 68336, '\P{^Jg: manichaeanhundred}', "");
    Expect(1, 68335, '\p{Jg=:\Amanichaeanhundred\z:}', "");;
    Expect(0, 68336, '\p{Jg=:\Amanichaeanhundred\z:}', "");;
    Expect(1, 68335, '\p{Jg=	manichaean_hundred}', "");
    Expect(0, 68335, '\p{^Jg=	manichaean_hundred}', "");
    Expect(0, 68335, '\P{Jg=	manichaean_hundred}', "");
    Expect(1, 68335, '\P{^Jg=	manichaean_hundred}', "");
    Expect(0, 68336, '\p{Jg=	manichaean_hundred}', "");
    Expect(1, 68336, '\p{^Jg=	manichaean_hundred}', "");
    Expect(1, 68336, '\P{Jg=	manichaean_hundred}', "");
    Expect(0, 68336, '\P{^Jg=	manichaean_hundred}', "");
    Error('\p{Is_Joining_Group=_-manichaean_Hundred/a/}');
    Error('\P{Is_Joining_Group=_-manichaean_Hundred/a/}');
    Expect(1, 68335, '\p{Is_Joining_Group=manichaeanhundred}', "");
    Expect(0, 68335, '\p{^Is_Joining_Group=manichaeanhundred}', "");
    Expect(0, 68335, '\P{Is_Joining_Group=manichaeanhundred}', "");
    Expect(1, 68335, '\P{^Is_Joining_Group=manichaeanhundred}', "");
    Expect(0, 68336, '\p{Is_Joining_Group=manichaeanhundred}', "");
    Expect(1, 68336, '\p{^Is_Joining_Group=manichaeanhundred}', "");
    Expect(1, 68336, '\P{Is_Joining_Group=manichaeanhundred}', "");
    Expect(0, 68336, '\P{^Is_Joining_Group=manichaeanhundred}', "");
    Expect(1, 68335, '\p{Is_Joining_Group= -Manichaean_Hundred}', "");
    Expect(0, 68335, '\p{^Is_Joining_Group= -Manichaean_Hundred}', "");
    Expect(0, 68335, '\P{Is_Joining_Group= -Manichaean_Hundred}', "");
    Expect(1, 68335, '\P{^Is_Joining_Group= -Manichaean_Hundred}', "");
    Expect(0, 68336, '\p{Is_Joining_Group= -Manichaean_Hundred}', "");
    Expect(1, 68336, '\p{^Is_Joining_Group= -Manichaean_Hundred}', "");
    Expect(1, 68336, '\P{Is_Joining_Group= -Manichaean_Hundred}', "");
    Expect(0, 68336, '\P{^Is_Joining_Group= -Manichaean_Hundred}', "");
    Error('\p{Is_Jg:	 :=Manichaean_HUNDRED}');
    Error('\P{Is_Jg:	 :=Manichaean_HUNDRED}');
    Expect(1, 68335, '\p{Is_Jg=manichaeanhundred}', "");
    Expect(0, 68335, '\p{^Is_Jg=manichaeanhundred}', "");
    Expect(0, 68335, '\P{Is_Jg=manichaeanhundred}', "");
    Expect(1, 68335, '\P{^Is_Jg=manichaeanhundred}', "");
    Expect(0, 68336, '\p{Is_Jg=manichaeanhundred}', "");
    Expect(1, 68336, '\p{^Is_Jg=manichaeanhundred}', "");
    Expect(1, 68336, '\P{Is_Jg=manichaeanhundred}', "");
    Expect(0, 68336, '\P{^Is_Jg=manichaeanhundred}', "");
    Expect(1, 68335, '\p{Is_Jg= -MANICHAEAN_hundred}', "");
    Expect(0, 68335, '\p{^Is_Jg= -MANICHAEAN_hundred}', "");
    Expect(0, 68335, '\P{Is_Jg= -MANICHAEAN_hundred}', "");
    Expect(1, 68335, '\P{^Is_Jg= -MANICHAEAN_hundred}', "");
    Expect(0, 68336, '\p{Is_Jg= -MANICHAEAN_hundred}', "");
    Expect(1, 68336, '\p{^Is_Jg= -MANICHAEAN_hundred}', "");
    Expect(1, 68336, '\P{Is_Jg= -MANICHAEAN_hundred}', "");
    Expect(0, 68336, '\P{^Is_Jg= -MANICHAEAN_hundred}', "");
    Error('\p{Joining_Group=:=manichaean_KAPH}');
    Error('\P{Joining_Group=:=manichaean_KAPH}');
    Expect(1, 68306, '\p{Joining_Group=:\AManichaean_Kaph\z:}', "");;
    Expect(0, 68307, '\p{Joining_Group=:\AManichaean_Kaph\z:}', "");;
    Expect(1, 68306, '\p{Joining_Group:manichaeankaph}', "");
    Expect(0, 68306, '\p{^Joining_Group:manichaeankaph}', "");
    Expect(0, 68306, '\P{Joining_Group:manichaeankaph}', "");
    Expect(1, 68306, '\P{^Joining_Group:manichaeankaph}', "");
    Expect(0, 68307, '\p{Joining_Group:manichaeankaph}', "");
    Expect(1, 68307, '\p{^Joining_Group:manichaeankaph}', "");
    Expect(1, 68307, '\P{Joining_Group:manichaeankaph}', "");
    Expect(0, 68307, '\P{^Joining_Group:manichaeankaph}', "");
    Expect(1, 68306, '\p{Joining_Group=:\Amanichaeankaph\z:}', "");;
    Expect(0, 68307, '\p{Joining_Group=:\Amanichaeankaph\z:}', "");;
    Expect(1, 68306, '\p{Joining_Group:	_	manichaean_Kaph}', "");
    Expect(0, 68306, '\p{^Joining_Group:	_	manichaean_Kaph}', "");
    Expect(0, 68306, '\P{Joining_Group:	_	manichaean_Kaph}', "");
    Expect(1, 68306, '\P{^Joining_Group:	_	manichaean_Kaph}', "");
    Expect(0, 68307, '\p{Joining_Group:	_	manichaean_Kaph}', "");
    Expect(1, 68307, '\p{^Joining_Group:	_	manichaean_Kaph}', "");
    Expect(1, 68307, '\P{Joining_Group:	_	manichaean_Kaph}', "");
    Expect(0, 68307, '\P{^Joining_Group:	_	manichaean_Kaph}', "");
    Error('\p{Jg= -MANICHAEAN_Kaph:=}');
    Error('\P{Jg= -MANICHAEAN_Kaph:=}');
    Expect(1, 68306, '\p{Jg=:\AManichaean_Kaph\z:}', "");;
    Expect(0, 68307, '\p{Jg=:\AManichaean_Kaph\z:}', "");;
    Expect(1, 68306, '\p{Jg:	manichaeankaph}', "");
    Expect(0, 68306, '\p{^Jg:	manichaeankaph}', "");
    Expect(0, 68306, '\P{Jg:	manichaeankaph}', "");
    Expect(1, 68306, '\P{^Jg:	manichaeankaph}', "");
    Expect(0, 68307, '\p{Jg:	manichaeankaph}', "");
    Expect(1, 68307, '\p{^Jg:	manichaeankaph}', "");
    Expect(1, 68307, '\P{Jg:	manichaeankaph}', "");
    Expect(0, 68307, '\P{^Jg:	manichaeankaph}', "");
    Expect(1, 68306, '\p{Jg=:\Amanichaeankaph\z:}', "");;
    Expect(0, 68307, '\p{Jg=:\Amanichaeankaph\z:}', "");;
    Expect(1, 68306, '\p{Jg=MANICHAEAN_KAPH}', "");
    Expect(0, 68306, '\p{^Jg=MANICHAEAN_KAPH}', "");
    Expect(0, 68306, '\P{Jg=MANICHAEAN_KAPH}', "");
    Expect(1, 68306, '\P{^Jg=MANICHAEAN_KAPH}', "");
    Expect(0, 68307, '\p{Jg=MANICHAEAN_KAPH}', "");
    Expect(1, 68307, '\p{^Jg=MANICHAEAN_KAPH}', "");
    Expect(1, 68307, '\P{Jg=MANICHAEAN_KAPH}', "");
    Expect(0, 68307, '\P{^Jg=MANICHAEAN_KAPH}', "");
    Error('\p{Is_Joining_Group=		Manichaean_kaph/a/}');
    Error('\P{Is_Joining_Group=		Manichaean_kaph/a/}');
    Expect(1, 68306, '\p{Is_Joining_Group=manichaeankaph}', "");
    Expect(0, 68306, '\p{^Is_Joining_Group=manichaeankaph}', "");
    Expect(0, 68306, '\P{Is_Joining_Group=manichaeankaph}', "");
    Expect(1, 68306, '\P{^Is_Joining_Group=manichaeankaph}', "");
    Expect(0, 68307, '\p{Is_Joining_Group=manichaeankaph}', "");
    Expect(1, 68307, '\p{^Is_Joining_Group=manichaeankaph}', "");
    Expect(1, 68307, '\P{Is_Joining_Group=manichaeankaph}', "");
    Expect(0, 68307, '\P{^Is_Joining_Group=manichaeankaph}', "");
    Expect(1, 68306, '\p{Is_Joining_Group=	-Manichaean_Kaph}', "");
    Expect(0, 68306, '\p{^Is_Joining_Group=	-Manichaean_Kaph}', "");
    Expect(0, 68306, '\P{Is_Joining_Group=	-Manichaean_Kaph}', "");
    Expect(1, 68306, '\P{^Is_Joining_Group=	-Manichaean_Kaph}', "");
    Expect(0, 68307, '\p{Is_Joining_Group=	-Manichaean_Kaph}', "");
    Expect(1, 68307, '\p{^Is_Joining_Group=	-Manichaean_Kaph}', "");
    Expect(1, 68307, '\P{Is_Joining_Group=	-Manichaean_Kaph}', "");
    Expect(0, 68307, '\P{^Is_Joining_Group=	-Manichaean_Kaph}', "");
    Error('\p{Is_Jg: :=--Manichaean_Kaph}');
    Error('\P{Is_Jg: :=--Manichaean_Kaph}');
    Expect(1, 68306, '\p{Is_Jg=manichaeankaph}', "");
    Expect(0, 68306, '\p{^Is_Jg=manichaeankaph}', "");
    Expect(0, 68306, '\P{Is_Jg=manichaeankaph}', "");
    Expect(1, 68306, '\P{^Is_Jg=manichaeankaph}', "");
    Expect(0, 68307, '\p{Is_Jg=manichaeankaph}', "");
    Expect(1, 68307, '\p{^Is_Jg=manichaeankaph}', "");
    Expect(1, 68307, '\P{Is_Jg=manichaeankaph}', "");
    Expect(0, 68307, '\P{^Is_Jg=manichaeankaph}', "");
    Expect(1, 68306, '\p{Is_Jg=	_Manichaean_KAPH}', "");
    Expect(0, 68306, '\p{^Is_Jg=	_Manichaean_KAPH}', "");
    Expect(0, 68306, '\P{Is_Jg=	_Manichaean_KAPH}', "");
    Expect(1, 68306, '\P{^Is_Jg=	_Manichaean_KAPH}', "");
    Expect(0, 68307, '\p{Is_Jg=	_Manichaean_KAPH}', "");
    Expect(1, 68307, '\p{^Is_Jg=	_Manichaean_KAPH}', "");
    Expect(1, 68307, '\P{Is_Jg=	_Manichaean_KAPH}', "");
    Expect(0, 68307, '\P{^Is_Jg=	_Manichaean_KAPH}', "");
    Error('\p{Joining_Group: := MANICHAEAN_Lamedh}');
    Error('\P{Joining_Group: := MANICHAEAN_Lamedh}');
    Expect(1, 68307, '\p{Joining_Group=:\AManichaean_Lamedh\z:}', "");;
    Expect(0, 68308, '\p{Joining_Group=:\AManichaean_Lamedh\z:}', "");;
    Expect(1, 68307, '\p{Joining_Group=manichaeanlamedh}', "");
    Expect(0, 68307, '\p{^Joining_Group=manichaeanlamedh}', "");
    Expect(0, 68307, '\P{Joining_Group=manichaeanlamedh}', "");
    Expect(1, 68307, '\P{^Joining_Group=manichaeanlamedh}', "");
    Expect(0, 68308, '\p{Joining_Group=manichaeanlamedh}', "");
    Expect(1, 68308, '\p{^Joining_Group=manichaeanlamedh}', "");
    Expect(1, 68308, '\P{Joining_Group=manichaeanlamedh}', "");
    Expect(0, 68308, '\P{^Joining_Group=manichaeanlamedh}', "");
    Expect(1, 68307, '\p{Joining_Group=:\Amanichaeanlamedh\z:}', "");;
    Expect(0, 68308, '\p{Joining_Group=:\Amanichaeanlamedh\z:}', "");;
    Expect(1, 68307, '\p{Joining_Group=	_MANICHAEAN_Lamedh}', "");
    Expect(0, 68307, '\p{^Joining_Group=	_MANICHAEAN_Lamedh}', "");
    Expect(0, 68307, '\P{Joining_Group=	_MANICHAEAN_Lamedh}', "");
    Expect(1, 68307, '\P{^Joining_Group=	_MANICHAEAN_Lamedh}', "");
    Expect(0, 68308, '\p{Joining_Group=	_MANICHAEAN_Lamedh}', "");
    Expect(1, 68308, '\p{^Joining_Group=	_MANICHAEAN_Lamedh}', "");
    Expect(1, 68308, '\P{Joining_Group=	_MANICHAEAN_Lamedh}', "");
    Expect(0, 68308, '\P{^Joining_Group=	_MANICHAEAN_Lamedh}', "");
    Error('\p{Jg:   /a/	-Manichaean_Lamedh}');
    Error('\P{Jg:   /a/	-Manichaean_Lamedh}');
    Expect(1, 68307, '\p{Jg=:\AManichaean_Lamedh\z:}', "");;
    Expect(0, 68308, '\p{Jg=:\AManichaean_Lamedh\z:}', "");;
    Expect(1, 68307, '\p{Jg=manichaeanlamedh}', "");
    Expect(0, 68307, '\p{^Jg=manichaeanlamedh}', "");
    Expect(0, 68307, '\P{Jg=manichaeanlamedh}', "");
    Expect(1, 68307, '\P{^Jg=manichaeanlamedh}', "");
    Expect(0, 68308, '\p{Jg=manichaeanlamedh}', "");
    Expect(1, 68308, '\p{^Jg=manichaeanlamedh}', "");
    Expect(1, 68308, '\P{Jg=manichaeanlamedh}', "");
    Expect(0, 68308, '\P{^Jg=manichaeanlamedh}', "");
    Expect(1, 68307, '\p{Jg=:\Amanichaeanlamedh\z:}', "");;
    Expect(0, 68308, '\p{Jg=:\Amanichaeanlamedh\z:}', "");;
    Expect(1, 68307, '\p{Jg:   -Manichaean_lamedh}', "");
    Expect(0, 68307, '\p{^Jg:   -Manichaean_lamedh}', "");
    Expect(0, 68307, '\P{Jg:   -Manichaean_lamedh}', "");
    Expect(1, 68307, '\P{^Jg:   -Manichaean_lamedh}', "");
    Expect(0, 68308, '\p{Jg:   -Manichaean_lamedh}', "");
    Expect(1, 68308, '\p{^Jg:   -Manichaean_lamedh}', "");
    Expect(1, 68308, '\P{Jg:   -Manichaean_lamedh}', "");
    Expect(0, 68308, '\P{^Jg:   -Manichaean_lamedh}', "");
    Error('\p{Is_Joining_Group=/a/manichaean_Lamedh}');
    Error('\P{Is_Joining_Group=/a/manichaean_Lamedh}');
    Expect(1, 68307, '\p{Is_Joining_Group=manichaeanlamedh}', "");
    Expect(0, 68307, '\p{^Is_Joining_Group=manichaeanlamedh}', "");
    Expect(0, 68307, '\P{Is_Joining_Group=manichaeanlamedh}', "");
    Expect(1, 68307, '\P{^Is_Joining_Group=manichaeanlamedh}', "");
    Expect(0, 68308, '\p{Is_Joining_Group=manichaeanlamedh}', "");
    Expect(1, 68308, '\p{^Is_Joining_Group=manichaeanlamedh}', "");
    Expect(1, 68308, '\P{Is_Joining_Group=manichaeanlamedh}', "");
    Expect(0, 68308, '\P{^Is_Joining_Group=manichaeanlamedh}', "");
    Expect(1, 68307, '\p{Is_Joining_Group=_ Manichaean_Lamedh}', "");
    Expect(0, 68307, '\p{^Is_Joining_Group=_ Manichaean_Lamedh}', "");
    Expect(0, 68307, '\P{Is_Joining_Group=_ Manichaean_Lamedh}', "");
    Expect(1, 68307, '\P{^Is_Joining_Group=_ Manichaean_Lamedh}', "");
    Expect(0, 68308, '\p{Is_Joining_Group=_ Manichaean_Lamedh}', "");
    Expect(1, 68308, '\p{^Is_Joining_Group=_ Manichaean_Lamedh}', "");
    Expect(1, 68308, '\P{Is_Joining_Group=_ Manichaean_Lamedh}', "");
    Expect(0, 68308, '\P{^Is_Joining_Group=_ Manichaean_Lamedh}', "");
    Error('\p{Is_Jg=	-MANICHAEAN_lamedh:=}');
    Error('\P{Is_Jg=	-MANICHAEAN_lamedh:=}');
    Expect(1, 68307, '\p{Is_Jg=manichaeanlamedh}', "");
    Expect(0, 68307, '\p{^Is_Jg=manichaeanlamedh}', "");
    Expect(0, 68307, '\P{Is_Jg=manichaeanlamedh}', "");
    Expect(1, 68307, '\P{^Is_Jg=manichaeanlamedh}', "");
    Expect(0, 68308, '\p{Is_Jg=manichaeanlamedh}', "");
    Expect(1, 68308, '\p{^Is_Jg=manichaeanlamedh}', "");
    Expect(1, 68308, '\P{Is_Jg=manichaeanlamedh}', "");
    Expect(0, 68308, '\P{^Is_Jg=manichaeanlamedh}', "");
    Expect(1, 68307, '\p{Is_Jg=_ MANICHAEAN_lamedh}', "");
    Expect(0, 68307, '\p{^Is_Jg=_ MANICHAEAN_lamedh}', "");
    Expect(0, 68307, '\P{Is_Jg=_ MANICHAEAN_lamedh}', "");
    Expect(1, 68307, '\P{^Is_Jg=_ MANICHAEAN_lamedh}', "");
    Expect(0, 68308, '\p{Is_Jg=_ MANICHAEAN_lamedh}', "");
    Expect(1, 68308, '\p{^Is_Jg=_ MANICHAEAN_lamedh}', "");
    Expect(1, 68308, '\P{Is_Jg=_ MANICHAEAN_lamedh}', "");
    Expect(0, 68308, '\P{^Is_Jg=_ MANICHAEAN_lamedh}', "");
    Error('\p{Joining_Group=/a/_ MANICHAEAN_mem}');
    Error('\P{Joining_Group=/a/_ MANICHAEAN_mem}');
    Expect(1, 68310, '\p{Joining_Group=:\AManichaean_Mem\z:}', "");;
    Expect(0, 68311, '\p{Joining_Group=:\AManichaean_Mem\z:}', "");;
    Expect(1, 68310, '\p{Joining_Group=manichaeanmem}', "");
    Expect(0, 68310, '\p{^Joining_Group=manichaeanmem}', "");
    Expect(0, 68310, '\P{Joining_Group=manichaeanmem}', "");
    Expect(1, 68310, '\P{^Joining_Group=manichaeanmem}', "");
    Expect(0, 68311, '\p{Joining_Group=manichaeanmem}', "");
    Expect(1, 68311, '\p{^Joining_Group=manichaeanmem}', "");
    Expect(1, 68311, '\P{Joining_Group=manichaeanmem}', "");
    Expect(0, 68311, '\P{^Joining_Group=manichaeanmem}', "");
    Expect(1, 68310, '\p{Joining_Group=:\Amanichaeanmem\z:}', "");;
    Expect(0, 68311, '\p{Joining_Group=:\Amanichaeanmem\z:}', "");;
    Expect(1, 68310, '\p{Joining_Group=-Manichaean_Mem}', "");
    Expect(0, 68310, '\p{^Joining_Group=-Manichaean_Mem}', "");
    Expect(0, 68310, '\P{Joining_Group=-Manichaean_Mem}', "");
    Expect(1, 68310, '\P{^Joining_Group=-Manichaean_Mem}', "");
    Expect(0, 68311, '\p{Joining_Group=-Manichaean_Mem}', "");
    Expect(1, 68311, '\p{^Joining_Group=-Manichaean_Mem}', "");
    Expect(1, 68311, '\P{Joining_Group=-Manichaean_Mem}', "");
    Expect(0, 68311, '\P{^Joining_Group=-Manichaean_Mem}', "");
    Error('\p{Jg=	MANICHAEAN_mem/a/}');
    Error('\P{Jg=	MANICHAEAN_mem/a/}');
    Expect(1, 68310, '\p{Jg=:\AManichaean_Mem\z:}', "");;
    Expect(0, 68311, '\p{Jg=:\AManichaean_Mem\z:}', "");;
    Expect(1, 68310, '\p{Jg=manichaeanmem}', "");
    Expect(0, 68310, '\p{^Jg=manichaeanmem}', "");
    Expect(0, 68310, '\P{Jg=manichaeanmem}', "");
    Expect(1, 68310, '\P{^Jg=manichaeanmem}', "");
    Expect(0, 68311, '\p{Jg=manichaeanmem}', "");
    Expect(1, 68311, '\p{^Jg=manichaeanmem}', "");
    Expect(1, 68311, '\P{Jg=manichaeanmem}', "");
    Expect(0, 68311, '\P{^Jg=manichaeanmem}', "");
    Expect(1, 68310, '\p{Jg=:\Amanichaeanmem\z:}', "");;
    Expect(0, 68311, '\p{Jg=:\Amanichaeanmem\z:}', "");;
    Expect(1, 68310, '\p{Jg=-Manichaean_Mem}', "");
    Expect(0, 68310, '\p{^Jg=-Manichaean_Mem}', "");
    Expect(0, 68310, '\P{Jg=-Manichaean_Mem}', "");
    Expect(1, 68310, '\P{^Jg=-Manichaean_Mem}', "");
    Expect(0, 68311, '\p{Jg=-Manichaean_Mem}', "");
    Expect(1, 68311, '\p{^Jg=-Manichaean_Mem}', "");
    Expect(1, 68311, '\P{Jg=-Manichaean_Mem}', "");
    Expect(0, 68311, '\P{^Jg=-Manichaean_Mem}', "");
    Error('\p{Is_Joining_Group=_ manichaean_Mem:=}');
    Error('\P{Is_Joining_Group=_ manichaean_Mem:=}');
    Expect(1, 68310, '\p{Is_Joining_Group=manichaeanmem}', "");
    Expect(0, 68310, '\p{^Is_Joining_Group=manichaeanmem}', "");
    Expect(0, 68310, '\P{Is_Joining_Group=manichaeanmem}', "");
    Expect(1, 68310, '\P{^Is_Joining_Group=manichaeanmem}', "");
    Expect(0, 68311, '\p{Is_Joining_Group=manichaeanmem}', "");
    Expect(1, 68311, '\p{^Is_Joining_Group=manichaeanmem}', "");
    Expect(1, 68311, '\P{Is_Joining_Group=manichaeanmem}', "");
    Expect(0, 68311, '\P{^Is_Joining_Group=manichaeanmem}', "");
    Expect(1, 68310, '\p{Is_Joining_Group=		Manichaean_Mem}', "");
    Expect(0, 68310, '\p{^Is_Joining_Group=		Manichaean_Mem}', "");
    Expect(0, 68310, '\P{Is_Joining_Group=		Manichaean_Mem}', "");
    Expect(1, 68310, '\P{^Is_Joining_Group=		Manichaean_Mem}', "");
    Expect(0, 68311, '\p{Is_Joining_Group=		Manichaean_Mem}', "");
    Expect(1, 68311, '\p{^Is_Joining_Group=		Manichaean_Mem}', "");
    Expect(1, 68311, '\P{Is_Joining_Group=		Manichaean_Mem}', "");
    Expect(0, 68311, '\P{^Is_Joining_Group=		Manichaean_Mem}', "");
    Error('\p{Is_Jg= :=Manichaean_mem}');
    Error('\P{Is_Jg= :=Manichaean_mem}');
    Expect(1, 68310, '\p{Is_Jg=manichaeanmem}', "");
    Expect(0, 68310, '\p{^Is_Jg=manichaeanmem}', "");
    Expect(0, 68310, '\P{Is_Jg=manichaeanmem}', "");
    Expect(1, 68310, '\P{^Is_Jg=manichaeanmem}', "");
    Expect(0, 68311, '\p{Is_Jg=manichaeanmem}', "");
    Expect(1, 68311, '\p{^Is_Jg=manichaeanmem}', "");
    Expect(1, 68311, '\P{Is_Jg=manichaeanmem}', "");
    Expect(0, 68311, '\P{^Is_Jg=manichaeanmem}', "");
    Expect(1, 68310, '\p{Is_Jg=	MANICHAEAN_mem}', "");
    Expect(0, 68310, '\p{^Is_Jg=	MANICHAEAN_mem}', "");
    Expect(0, 68310, '\P{Is_Jg=	MANICHAEAN_mem}', "");
    Expect(1, 68310, '\P{^Is_Jg=	MANICHAEAN_mem}', "");
    Expect(0, 68311, '\p{Is_Jg=	MANICHAEAN_mem}', "");
    Expect(1, 68311, '\p{^Is_Jg=	MANICHAEAN_mem}', "");
    Expect(1, 68311, '\P{Is_Jg=	MANICHAEAN_mem}', "");
    Expect(0, 68311, '\P{^Is_Jg=	MANICHAEAN_mem}', "");
    Error('\p{Joining_Group=-MANICHAEAN_Nun/a/}');
    Error('\P{Joining_Group=-MANICHAEAN_Nun/a/}');
    Expect(1, 68311, '\p{Joining_Group=:\AManichaean_Nun\z:}', "");;
    Expect(0, 68312, '\p{Joining_Group=:\AManichaean_Nun\z:}', "");;
    Expect(1, 68311, '\p{Joining_Group=manichaeannun}', "");
    Expect(0, 68311, '\p{^Joining_Group=manichaeannun}', "");
    Expect(0, 68311, '\P{Joining_Group=manichaeannun}', "");
    Expect(1, 68311, '\P{^Joining_Group=manichaeannun}', "");
    Expect(0, 68312, '\p{Joining_Group=manichaeannun}', "");
    Expect(1, 68312, '\p{^Joining_Group=manichaeannun}', "");
    Expect(1, 68312, '\P{Joining_Group=manichaeannun}', "");
    Expect(0, 68312, '\P{^Joining_Group=manichaeannun}', "");
    Expect(1, 68311, '\p{Joining_Group=:\Amanichaeannun\z:}', "");;
    Expect(0, 68312, '\p{Joining_Group=:\Amanichaeannun\z:}', "");;
    Expect(1, 68311, '\p{Joining_Group=  Manichaean_Nun}', "");
    Expect(0, 68311, '\p{^Joining_Group=  Manichaean_Nun}', "");
    Expect(0, 68311, '\P{Joining_Group=  Manichaean_Nun}', "");
    Expect(1, 68311, '\P{^Joining_Group=  Manichaean_Nun}', "");
    Expect(0, 68312, '\p{Joining_Group=  Manichaean_Nun}', "");
    Expect(1, 68312, '\p{^Joining_Group=  Manichaean_Nun}', "");
    Expect(1, 68312, '\P{Joining_Group=  Manichaean_Nun}', "");
    Expect(0, 68312, '\P{^Joining_Group=  Manichaean_Nun}', "");
    Error('\p{Jg=_Manichaean_Nun/a/}');
    Error('\P{Jg=_Manichaean_Nun/a/}');
    Expect(1, 68311, '\p{Jg=:\AManichaean_Nun\z:}', "");;
    Expect(0, 68312, '\p{Jg=:\AManichaean_Nun\z:}', "");;
    Expect(1, 68311, '\p{Jg: manichaeannun}', "");
    Expect(0, 68311, '\p{^Jg: manichaeannun}', "");
    Expect(0, 68311, '\P{Jg: manichaeannun}', "");
    Expect(1, 68311, '\P{^Jg: manichaeannun}', "");
    Expect(0, 68312, '\p{Jg: manichaeannun}', "");
    Expect(1, 68312, '\p{^Jg: manichaeannun}', "");
    Expect(1, 68312, '\P{Jg: manichaeannun}', "");
    Expect(0, 68312, '\P{^Jg: manichaeannun}', "");
    Expect(1, 68311, '\p{Jg=:\Amanichaeannun\z:}', "");;
    Expect(0, 68312, '\p{Jg=:\Amanichaeannun\z:}', "");;
    Expect(1, 68311, '\p{Jg=_-MANICHAEAN_NUN}', "");
    Expect(0, 68311, '\p{^Jg=_-MANICHAEAN_NUN}', "");
    Expect(0, 68311, '\P{Jg=_-MANICHAEAN_NUN}', "");
    Expect(1, 68311, '\P{^Jg=_-MANICHAEAN_NUN}', "");
    Expect(0, 68312, '\p{Jg=_-MANICHAEAN_NUN}', "");
    Expect(1, 68312, '\p{^Jg=_-MANICHAEAN_NUN}', "");
    Expect(1, 68312, '\P{Jg=_-MANICHAEAN_NUN}', "");
    Expect(0, 68312, '\P{^Jg=_-MANICHAEAN_NUN}', "");
    Error('\p{Is_Joining_Group=--manichaean_Nun:=}');
    Error('\P{Is_Joining_Group=--manichaean_Nun:=}');
    Expect(1, 68311, '\p{Is_Joining_Group=manichaeannun}', "");
    Expect(0, 68311, '\p{^Is_Joining_Group=manichaeannun}', "");
    Expect(0, 68311, '\P{Is_Joining_Group=manichaeannun}', "");
    Expect(1, 68311, '\P{^Is_Joining_Group=manichaeannun}', "");
    Expect(0, 68312, '\p{Is_Joining_Group=manichaeannun}', "");
    Expect(1, 68312, '\p{^Is_Joining_Group=manichaeannun}', "");
    Expect(1, 68312, '\P{Is_Joining_Group=manichaeannun}', "");
    Expect(0, 68312, '\P{^Is_Joining_Group=manichaeannun}', "");
    Expect(1, 68311, '\p{Is_Joining_Group= -Manichaean_NUN}', "");
    Expect(0, 68311, '\p{^Is_Joining_Group= -Manichaean_NUN}', "");
    Expect(0, 68311, '\P{Is_Joining_Group= -Manichaean_NUN}', "");
    Expect(1, 68311, '\P{^Is_Joining_Group= -Manichaean_NUN}', "");
    Expect(0, 68312, '\p{Is_Joining_Group= -Manichaean_NUN}', "");
    Expect(1, 68312, '\p{^Is_Joining_Group= -Manichaean_NUN}', "");
    Expect(1, 68312, '\P{Is_Joining_Group= -Manichaean_NUN}', "");
    Expect(0, 68312, '\P{^Is_Joining_Group= -Manichaean_NUN}', "");
    Error('\p{Is_Jg=/a/--Manichaean_nun}');
    Error('\P{Is_Jg=/a/--Manichaean_nun}');
    Expect(1, 68311, '\p{Is_Jg:   manichaeannun}', "");
    Expect(0, 68311, '\p{^Is_Jg:   manichaeannun}', "");
    Expect(0, 68311, '\P{Is_Jg:   manichaeannun}', "");
    Expect(1, 68311, '\P{^Is_Jg:   manichaeannun}', "");
    Expect(0, 68312, '\p{Is_Jg:   manichaeannun}', "");
    Expect(1, 68312, '\p{^Is_Jg:   manichaeannun}', "");
    Expect(1, 68312, '\P{Is_Jg:   manichaeannun}', "");
    Expect(0, 68312, '\P{^Is_Jg:   manichaeannun}', "");
    Expect(1, 68311, '\p{Is_Jg=  manichaean_NUN}', "");
    Expect(0, 68311, '\p{^Is_Jg=  manichaean_NUN}', "");
    Expect(0, 68311, '\P{Is_Jg=  manichaean_NUN}', "");
    Expect(1, 68311, '\P{^Is_Jg=  manichaean_NUN}', "");
    Expect(0, 68312, '\p{Is_Jg=  manichaean_NUN}', "");
    Expect(1, 68312, '\p{^Is_Jg=  manichaean_NUN}', "");
    Expect(1, 68312, '\P{Is_Jg=  manichaean_NUN}', "");
    Expect(0, 68312, '\P{^Is_Jg=  manichaean_NUN}', "");
    Error('\p{Joining_Group=_-Manichaean_One:=}');
    Error('\P{Joining_Group=_-Manichaean_One:=}');
    Expect(1, 68331, '\p{Joining_Group=:\AManichaean_One\z:}', "");;
    Expect(0, 68332, '\p{Joining_Group=:\AManichaean_One\z:}', "");;
    Expect(1, 68331, '\p{Joining_Group=manichaeanone}', "");
    Expect(0, 68331, '\p{^Joining_Group=manichaeanone}', "");
    Expect(0, 68331, '\P{Joining_Group=manichaeanone}', "");
    Expect(1, 68331, '\P{^Joining_Group=manichaeanone}', "");
    Expect(0, 68332, '\p{Joining_Group=manichaeanone}', "");
    Expect(1, 68332, '\p{^Joining_Group=manichaeanone}', "");
    Expect(1, 68332, '\P{Joining_Group=manichaeanone}', "");
    Expect(0, 68332, '\P{^Joining_Group=manichaeanone}', "");
    Expect(1, 68331, '\p{Joining_Group=:\Amanichaeanone\z:}', "");;
    Expect(0, 68332, '\p{Joining_Group=:\Amanichaeanone\z:}', "");;
    Expect(1, 68331, '\p{Joining_Group=--Manichaean_ONE}', "");
    Expect(0, 68331, '\p{^Joining_Group=--Manichaean_ONE}', "");
    Expect(0, 68331, '\P{Joining_Group=--Manichaean_ONE}', "");
    Expect(1, 68331, '\P{^Joining_Group=--Manichaean_ONE}', "");
    Expect(0, 68332, '\p{Joining_Group=--Manichaean_ONE}', "");
    Expect(1, 68332, '\p{^Joining_Group=--Manichaean_ONE}', "");
    Expect(1, 68332, '\P{Joining_Group=--Manichaean_ONE}', "");
    Expect(0, 68332, '\P{^Joining_Group=--Manichaean_ONE}', "");
    Error('\p{Jg= /a/manichaean_One}');
    Error('\P{Jg= /a/manichaean_One}');
    Expect(1, 68331, '\p{Jg=:\AManichaean_One\z:}', "");;
    Expect(0, 68332, '\p{Jg=:\AManichaean_One\z:}', "");;
    Expect(1, 68331, '\p{Jg=manichaeanone}', "");
    Expect(0, 68331, '\p{^Jg=manichaeanone}', "");
    Expect(0, 68331, '\P{Jg=manichaeanone}', "");
    Expect(1, 68331, '\P{^Jg=manichaeanone}', "");
    Expect(0, 68332, '\p{Jg=manichaeanone}', "");
    Expect(1, 68332, '\p{^Jg=manichaeanone}', "");
    Expect(1, 68332, '\P{Jg=manichaeanone}', "");
    Expect(0, 68332, '\P{^Jg=manichaeanone}', "");
    Expect(1, 68331, '\p{Jg=:\Amanichaeanone\z:}', "");;
    Expect(0, 68332, '\p{Jg=:\Amanichaeanone\z:}', "");;
    Expect(1, 68331, '\p{Jg=__manichaean_One}', "");
    Expect(0, 68331, '\p{^Jg=__manichaean_One}', "");
    Expect(0, 68331, '\P{Jg=__manichaean_One}', "");
    Expect(1, 68331, '\P{^Jg=__manichaean_One}', "");
    Expect(0, 68332, '\p{Jg=__manichaean_One}', "");
    Expect(1, 68332, '\p{^Jg=__manichaean_One}', "");
    Expect(1, 68332, '\P{Jg=__manichaean_One}', "");
    Expect(0, 68332, '\P{^Jg=__manichaean_One}', "");
    Error('\p{Is_Joining_Group: -MANICHAEAN_one/a/}');
    Error('\P{Is_Joining_Group: -MANICHAEAN_one/a/}');
    Expect(1, 68331, '\p{Is_Joining_Group=manichaeanone}', "");
    Expect(0, 68331, '\p{^Is_Joining_Group=manichaeanone}', "");
    Expect(0, 68331, '\P{Is_Joining_Group=manichaeanone}', "");
    Expect(1, 68331, '\P{^Is_Joining_Group=manichaeanone}', "");
    Expect(0, 68332, '\p{Is_Joining_Group=manichaeanone}', "");
    Expect(1, 68332, '\p{^Is_Joining_Group=manichaeanone}', "");
    Expect(1, 68332, '\P{Is_Joining_Group=manichaeanone}', "");
    Expect(0, 68332, '\P{^Is_Joining_Group=manichaeanone}', "");
    Expect(1, 68331, '\p{Is_Joining_Group=_-Manichaean_One}', "");
    Expect(0, 68331, '\p{^Is_Joining_Group=_-Manichaean_One}', "");
    Expect(0, 68331, '\P{Is_Joining_Group=_-Manichaean_One}', "");
    Expect(1, 68331, '\P{^Is_Joining_Group=_-Manichaean_One}', "");
    Expect(0, 68332, '\p{Is_Joining_Group=_-Manichaean_One}', "");
    Expect(1, 68332, '\p{^Is_Joining_Group=_-Manichaean_One}', "");
    Expect(1, 68332, '\P{Is_Joining_Group=_-Manichaean_One}', "");
    Expect(0, 68332, '\P{^Is_Joining_Group=_-Manichaean_One}', "");
    Error('\p{Is_Jg=/a/_ Manichaean_one}');
    Error('\P{Is_Jg=/a/_ Manichaean_one}');
    Expect(1, 68331, '\p{Is_Jg=manichaeanone}', "");
    Expect(0, 68331, '\p{^Is_Jg=manichaeanone}', "");
    Expect(0, 68331, '\P{Is_Jg=manichaeanone}', "");
    Expect(1, 68331, '\P{^Is_Jg=manichaeanone}', "");
    Expect(0, 68332, '\p{Is_Jg=manichaeanone}', "");
    Expect(1, 68332, '\p{^Is_Jg=manichaeanone}', "");
    Expect(1, 68332, '\P{Is_Jg=manichaeanone}', "");
    Expect(0, 68332, '\P{^Is_Jg=manichaeanone}', "");
    Expect(1, 68331, '\p{Is_Jg: _manichaean_one}', "");
    Expect(0, 68331, '\p{^Is_Jg: _manichaean_one}', "");
    Expect(0, 68331, '\P{Is_Jg: _manichaean_one}', "");
    Expect(1, 68331, '\P{^Is_Jg: _manichaean_one}', "");
    Expect(0, 68332, '\p{Is_Jg: _manichaean_one}', "");
    Expect(1, 68332, '\p{^Is_Jg: _manichaean_one}', "");
    Expect(1, 68332, '\P{Is_Jg: _manichaean_one}', "");
    Expect(0, 68332, '\P{^Is_Jg: _manichaean_one}', "");
    Error('\p{Joining_Group=	:=MANICHAEAN_PE}');
    Error('\P{Joining_Group=	:=MANICHAEAN_PE}');
    Expect(1, 68316, '\p{Joining_Group=:\AManichaean_Pe\z:}', "");;
    Expect(0, 68317, '\p{Joining_Group=:\AManichaean_Pe\z:}', "");;
    Expect(1, 68316, '\p{Joining_Group=manichaeanpe}', "");
    Expect(0, 68316, '\p{^Joining_Group=manichaeanpe}', "");
    Expect(0, 68316, '\P{Joining_Group=manichaeanpe}', "");
    Expect(1, 68316, '\P{^Joining_Group=manichaeanpe}', "");
    Expect(0, 68317, '\p{Joining_Group=manichaeanpe}', "");
    Expect(1, 68317, '\p{^Joining_Group=manichaeanpe}', "");
    Expect(1, 68317, '\P{Joining_Group=manichaeanpe}', "");
    Expect(0, 68317, '\P{^Joining_Group=manichaeanpe}', "");
    Expect(1, 68316, '\p{Joining_Group=:\Amanichaeanpe\z:}', "");;
    Expect(0, 68317, '\p{Joining_Group=:\Amanichaeanpe\z:}', "");;
    Expect(1, 68316, '\p{Joining_Group=	Manichaean_Pe}', "");
    Expect(0, 68316, '\p{^Joining_Group=	Manichaean_Pe}', "");
    Expect(0, 68316, '\P{Joining_Group=	Manichaean_Pe}', "");
    Expect(1, 68316, '\P{^Joining_Group=	Manichaean_Pe}', "");
    Expect(0, 68317, '\p{Joining_Group=	Manichaean_Pe}', "");
    Expect(1, 68317, '\p{^Joining_Group=	Manichaean_Pe}', "");
    Expect(1, 68317, '\P{Joining_Group=	Manichaean_Pe}', "");
    Expect(0, 68317, '\P{^Joining_Group=	Manichaean_Pe}', "");
    Error('\p{Jg: /a/_ MANICHAEAN_PE}');
    Error('\P{Jg: /a/_ MANICHAEAN_PE}');
    Expect(1, 68316, '\p{Jg=:\AManichaean_Pe\z:}', "");;
    Expect(0, 68317, '\p{Jg=:\AManichaean_Pe\z:}', "");;
    Expect(1, 68316, '\p{Jg=manichaeanpe}', "");
    Expect(0, 68316, '\p{^Jg=manichaeanpe}', "");
    Expect(0, 68316, '\P{Jg=manichaeanpe}', "");
    Expect(1, 68316, '\P{^Jg=manichaeanpe}', "");
    Expect(0, 68317, '\p{Jg=manichaeanpe}', "");
    Expect(1, 68317, '\p{^Jg=manichaeanpe}', "");
    Expect(1, 68317, '\P{Jg=manichaeanpe}', "");
    Expect(0, 68317, '\P{^Jg=manichaeanpe}', "");
    Expect(1, 68316, '\p{Jg=:\Amanichaeanpe\z:}', "");;
    Expect(0, 68317, '\p{Jg=:\Amanichaeanpe\z:}', "");;
    Expect(1, 68316, '\p{Jg=	Manichaean_PE}', "");
    Expect(0, 68316, '\p{^Jg=	Manichaean_PE}', "");
    Expect(0, 68316, '\P{Jg=	Manichaean_PE}', "");
    Expect(1, 68316, '\P{^Jg=	Manichaean_PE}', "");
    Expect(0, 68317, '\p{Jg=	Manichaean_PE}', "");
    Expect(1, 68317, '\p{^Jg=	Manichaean_PE}', "");
    Expect(1, 68317, '\P{Jg=	Manichaean_PE}', "");
    Expect(0, 68317, '\P{^Jg=	Manichaean_PE}', "");
    Error('\p{Is_Joining_Group=_-manichaean_Pe/a/}');
    Error('\P{Is_Joining_Group=_-manichaean_Pe/a/}');
    Expect(1, 68316, '\p{Is_Joining_Group: manichaeanpe}', "");
    Expect(0, 68316, '\p{^Is_Joining_Group: manichaeanpe}', "");
    Expect(0, 68316, '\P{Is_Joining_Group: manichaeanpe}', "");
    Expect(1, 68316, '\P{^Is_Joining_Group: manichaeanpe}', "");
    Expect(0, 68317, '\p{Is_Joining_Group: manichaeanpe}', "");
    Expect(1, 68317, '\p{^Is_Joining_Group: manichaeanpe}', "");
    Expect(1, 68317, '\P{Is_Joining_Group: manichaeanpe}', "");
    Expect(0, 68317, '\P{^Is_Joining_Group: manichaeanpe}', "");
    Expect(1, 68316, '\p{Is_Joining_Group:   __Manichaean_Pe}', "");
    Expect(0, 68316, '\p{^Is_Joining_Group:   __Manichaean_Pe}', "");
    Expect(0, 68316, '\P{Is_Joining_Group:   __Manichaean_Pe}', "");
    Expect(1, 68316, '\P{^Is_Joining_Group:   __Manichaean_Pe}', "");
    Expect(0, 68317, '\p{Is_Joining_Group:   __Manichaean_Pe}', "");
    Expect(1, 68317, '\p{^Is_Joining_Group:   __Manichaean_Pe}', "");
    Expect(1, 68317, '\P{Is_Joining_Group:   __Manichaean_Pe}', "");
    Expect(0, 68317, '\P{^Is_Joining_Group:   __Manichaean_Pe}', "");
    Error('\p{Is_Jg=_Manichaean_Pe:=}');
    Error('\P{Is_Jg=_Manichaean_Pe:=}');
    Expect(1, 68316, '\p{Is_Jg=manichaeanpe}', "");
    Expect(0, 68316, '\p{^Is_Jg=manichaeanpe}', "");
    Expect(0, 68316, '\P{Is_Jg=manichaeanpe}', "");
    Expect(1, 68316, '\P{^Is_Jg=manichaeanpe}', "");
    Expect(0, 68317, '\p{Is_Jg=manichaeanpe}', "");
    Expect(1, 68317, '\p{^Is_Jg=manichaeanpe}', "");
    Expect(1, 68317, '\P{Is_Jg=manichaeanpe}', "");
    Expect(0, 68317, '\P{^Is_Jg=manichaeanpe}', "");
    Expect(1, 68316, '\p{Is_Jg=	MANICHAEAN_PE}', "");
    Expect(0, 68316, '\p{^Is_Jg=	MANICHAEAN_PE}', "");
    Expect(0, 68316, '\P{Is_Jg=	MANICHAEAN_PE}', "");
    Expect(1, 68316, '\P{^Is_Jg=	MANICHAEAN_PE}', "");
    Expect(0, 68317, '\p{Is_Jg=	MANICHAEAN_PE}', "");
    Expect(1, 68317, '\p{^Is_Jg=	MANICHAEAN_PE}', "");
    Expect(1, 68317, '\P{Is_Jg=	MANICHAEAN_PE}', "");
    Expect(0, 68317, '\P{^Is_Jg=	MANICHAEAN_PE}', "");
    Error('\p{Joining_Group= -Manichaean_QOPH/a/}');
    Error('\P{Joining_Group= -Manichaean_QOPH/a/}');
    Expect(1, 68320, '\p{Joining_Group=:\AManichaean_Qoph\z:}', "");;
    Expect(0, 68321, '\p{Joining_Group=:\AManichaean_Qoph\z:}', "");;
    Expect(1, 68320, '\p{Joining_Group=manichaeanqoph}', "");
    Expect(0, 68320, '\p{^Joining_Group=manichaeanqoph}', "");
    Expect(0, 68320, '\P{Joining_Group=manichaeanqoph}', "");
    Expect(1, 68320, '\P{^Joining_Group=manichaeanqoph}', "");
    Expect(0, 68321, '\p{Joining_Group=manichaeanqoph}', "");
    Expect(1, 68321, '\p{^Joining_Group=manichaeanqoph}', "");
    Expect(1, 68321, '\P{Joining_Group=manichaeanqoph}', "");
    Expect(0, 68321, '\P{^Joining_Group=manichaeanqoph}', "");
    Expect(1, 68320, '\p{Joining_Group=:\Amanichaeanqoph\z:}', "");;
    Expect(0, 68321, '\p{Joining_Group=:\Amanichaeanqoph\z:}', "");;
    Expect(1, 68320, '\p{Joining_Group: _-Manichaean_qoph}', "");
    Expect(0, 68320, '\p{^Joining_Group: _-Manichaean_qoph}', "");
    Expect(0, 68320, '\P{Joining_Group: _-Manichaean_qoph}', "");
    Expect(1, 68320, '\P{^Joining_Group: _-Manichaean_qoph}', "");
    Expect(0, 68321, '\p{Joining_Group: _-Manichaean_qoph}', "");
    Expect(1, 68321, '\p{^Joining_Group: _-Manichaean_qoph}', "");
    Expect(1, 68321, '\P{Joining_Group: _-Manichaean_qoph}', "");
    Expect(0, 68321, '\P{^Joining_Group: _-Manichaean_qoph}', "");
    Error('\p{Jg=:= MANICHAEAN_Qoph}');
    Error('\P{Jg=:= MANICHAEAN_Qoph}');
    Expect(1, 68320, '\p{Jg=:\AManichaean_Qoph\z:}', "");;
    Expect(0, 68321, '\p{Jg=:\AManichaean_Qoph\z:}', "");;
    Expect(1, 68320, '\p{Jg=manichaeanqoph}', "");
    Expect(0, 68320, '\p{^Jg=manichaeanqoph}', "");
    Expect(0, 68320, '\P{Jg=manichaeanqoph}', "");
    Expect(1, 68320, '\P{^Jg=manichaeanqoph}', "");
    Expect(0, 68321, '\p{Jg=manichaeanqoph}', "");
    Expect(1, 68321, '\p{^Jg=manichaeanqoph}', "");
    Expect(1, 68321, '\P{Jg=manichaeanqoph}', "");
    Expect(0, 68321, '\P{^Jg=manichaeanqoph}', "");
    Expect(1, 68320, '\p{Jg=:\Amanichaeanqoph\z:}', "");;
    Expect(0, 68321, '\p{Jg=:\Amanichaeanqoph\z:}', "");;
    Expect(1, 68320, '\p{Jg=_-MANICHAEAN_Qoph}', "");
    Expect(0, 68320, '\p{^Jg=_-MANICHAEAN_Qoph}', "");
    Expect(0, 68320, '\P{Jg=_-MANICHAEAN_Qoph}', "");
    Expect(1, 68320, '\P{^Jg=_-MANICHAEAN_Qoph}', "");
    Expect(0, 68321, '\p{Jg=_-MANICHAEAN_Qoph}', "");
    Expect(1, 68321, '\p{^Jg=_-MANICHAEAN_Qoph}', "");
    Expect(1, 68321, '\P{Jg=_-MANICHAEAN_Qoph}', "");
    Expect(0, 68321, '\P{^Jg=_-MANICHAEAN_Qoph}', "");
    Error('\p{Is_Joining_Group:   -:=manichaean_qoph}');
    Error('\P{Is_Joining_Group:   -:=manichaean_qoph}');
    Expect(1, 68320, '\p{Is_Joining_Group=manichaeanqoph}', "");
    Expect(0, 68320, '\p{^Is_Joining_Group=manichaeanqoph}', "");
    Expect(0, 68320, '\P{Is_Joining_Group=manichaeanqoph}', "");
    Expect(1, 68320, '\P{^Is_Joining_Group=manichaeanqoph}', "");
    Expect(0, 68321, '\p{Is_Joining_Group=manichaeanqoph}', "");
    Expect(1, 68321, '\p{^Is_Joining_Group=manichaeanqoph}', "");
    Expect(1, 68321, '\P{Is_Joining_Group=manichaeanqoph}', "");
    Expect(0, 68321, '\P{^Is_Joining_Group=manichaeanqoph}', "");
    Expect(1, 68320, '\p{Is_Joining_Group=-MANICHAEAN_qoph}', "");
    Expect(0, 68320, '\p{^Is_Joining_Group=-MANICHAEAN_qoph}', "");
    Expect(0, 68320, '\P{Is_Joining_Group=-MANICHAEAN_qoph}', "");
    Expect(1, 68320, '\P{^Is_Joining_Group=-MANICHAEAN_qoph}', "");
    Expect(0, 68321, '\p{Is_Joining_Group=-MANICHAEAN_qoph}', "");
    Expect(1, 68321, '\p{^Is_Joining_Group=-MANICHAEAN_qoph}', "");
    Expect(1, 68321, '\P{Is_Joining_Group=-MANICHAEAN_qoph}', "");
    Expect(0, 68321, '\P{^Is_Joining_Group=-MANICHAEAN_qoph}', "");
    Error('\p{Is_Jg=_MANICHAEAN_Qoph/a/}');
    Error('\P{Is_Jg=_MANICHAEAN_Qoph/a/}');
    Expect(1, 68320, '\p{Is_Jg=manichaeanqoph}', "");
    Expect(0, 68320, '\p{^Is_Jg=manichaeanqoph}', "");
    Expect(0, 68320, '\P{Is_Jg=manichaeanqoph}', "");
    Expect(1, 68320, '\P{^Is_Jg=manichaeanqoph}', "");
    Expect(0, 68321, '\p{Is_Jg=manichaeanqoph}', "");
    Expect(1, 68321, '\p{^Is_Jg=manichaeanqoph}', "");
    Expect(1, 68321, '\P{Is_Jg=manichaeanqoph}', "");
    Expect(0, 68321, '\P{^Is_Jg=manichaeanqoph}', "");
    Expect(1, 68320, '\p{Is_Jg=  MANICHAEAN_qoph}', "");
    Expect(0, 68320, '\p{^Is_Jg=  MANICHAEAN_qoph}', "");
    Expect(0, 68320, '\P{Is_Jg=  MANICHAEAN_qoph}', "");
    Expect(1, 68320, '\P{^Is_Jg=  MANICHAEAN_qoph}', "");
    Expect(0, 68321, '\p{Is_Jg=  MANICHAEAN_qoph}', "");
    Expect(1, 68321, '\p{^Is_Jg=  MANICHAEAN_qoph}', "");
    Expect(1, 68321, '\P{Is_Jg=  MANICHAEAN_qoph}', "");
    Expect(0, 68321, '\P{^Is_Jg=  MANICHAEAN_qoph}', "");
    Error('\p{Joining_Group=	:=Manichaean_resh}');
    Error('\P{Joining_Group=	:=Manichaean_resh}');
    Expect(1, 68321, '\p{Joining_Group=:\AManichaean_Resh\z:}', "");;
    Expect(0, 68322, '\p{Joining_Group=:\AManichaean_Resh\z:}', "");;
    Expect(1, 68321, '\p{Joining_Group=manichaeanresh}', "");
    Expect(0, 68321, '\p{^Joining_Group=manichaeanresh}', "");
    Expect(0, 68321, '\P{Joining_Group=manichaeanresh}', "");
    Expect(1, 68321, '\P{^Joining_Group=manichaeanresh}', "");
    Expect(0, 68322, '\p{Joining_Group=manichaeanresh}', "");
    Expect(1, 68322, '\p{^Joining_Group=manichaeanresh}', "");
    Expect(1, 68322, '\P{Joining_Group=manichaeanresh}', "");
    Expect(0, 68322, '\P{^Joining_Group=manichaeanresh}', "");
    Expect(1, 68321, '\p{Joining_Group=:\Amanichaeanresh\z:}', "");;
    Expect(0, 68322, '\p{Joining_Group=:\Amanichaeanresh\z:}', "");;
    Expect(1, 68321, '\p{Joining_Group:   	Manichaean_Resh}', "");
    Expect(0, 68321, '\p{^Joining_Group:   	Manichaean_Resh}', "");
    Expect(0, 68321, '\P{Joining_Group:   	Manichaean_Resh}', "");
    Expect(1, 68321, '\P{^Joining_Group:   	Manichaean_Resh}', "");
    Expect(0, 68322, '\p{Joining_Group:   	Manichaean_Resh}', "");
    Expect(1, 68322, '\p{^Joining_Group:   	Manichaean_Resh}', "");
    Expect(1, 68322, '\P{Joining_Group:   	Manichaean_Resh}', "");
    Expect(0, 68322, '\P{^Joining_Group:   	Manichaean_Resh}', "");
    Error('\p{Jg=/a/_Manichaean_Resh}');
    Error('\P{Jg=/a/_Manichaean_Resh}');
    Expect(1, 68321, '\p{Jg=:\AManichaean_Resh\z:}', "");;
    Expect(0, 68322, '\p{Jg=:\AManichaean_Resh\z:}', "");;
    Expect(1, 68321, '\p{Jg=manichaeanresh}', "");
    Expect(0, 68321, '\p{^Jg=manichaeanresh}', "");
    Expect(0, 68321, '\P{Jg=manichaeanresh}', "");
    Expect(1, 68321, '\P{^Jg=manichaeanresh}', "");
    Expect(0, 68322, '\p{Jg=manichaeanresh}', "");
    Expect(1, 68322, '\p{^Jg=manichaeanresh}', "");
    Expect(1, 68322, '\P{Jg=manichaeanresh}', "");
    Expect(0, 68322, '\P{^Jg=manichaeanresh}', "");
    Expect(1, 68321, '\p{Jg=:\Amanichaeanresh\z:}', "");;
    Expect(0, 68322, '\p{Jg=:\Amanichaeanresh\z:}', "");;
    Expect(1, 68321, '\p{Jg=--manichaean_Resh}', "");
    Expect(0, 68321, '\p{^Jg=--manichaean_Resh}', "");
    Expect(0, 68321, '\P{Jg=--manichaean_Resh}', "");
    Expect(1, 68321, '\P{^Jg=--manichaean_Resh}', "");
    Expect(0, 68322, '\p{Jg=--manichaean_Resh}', "");
    Expect(1, 68322, '\p{^Jg=--manichaean_Resh}', "");
    Expect(1, 68322, '\P{Jg=--manichaean_Resh}', "");
    Expect(0, 68322, '\P{^Jg=--manichaean_Resh}', "");
    Error('\p{Is_Joining_Group=	Manichaean_RESH:=}');
    Error('\P{Is_Joining_Group=	Manichaean_RESH:=}');
    Expect(1, 68321, '\p{Is_Joining_Group=manichaeanresh}', "");
    Expect(0, 68321, '\p{^Is_Joining_Group=manichaeanresh}', "");
    Expect(0, 68321, '\P{Is_Joining_Group=manichaeanresh}', "");
    Expect(1, 68321, '\P{^Is_Joining_Group=manichaeanresh}', "");
    Expect(0, 68322, '\p{Is_Joining_Group=manichaeanresh}', "");
    Expect(1, 68322, '\p{^Is_Joining_Group=manichaeanresh}', "");
    Expect(1, 68322, '\P{Is_Joining_Group=manichaeanresh}', "");
    Expect(0, 68322, '\P{^Is_Joining_Group=manichaeanresh}', "");
    Expect(1, 68321, '\p{Is_Joining_Group=_ manichaean_Resh}', "");
    Expect(0, 68321, '\p{^Is_Joining_Group=_ manichaean_Resh}', "");
    Expect(0, 68321, '\P{Is_Joining_Group=_ manichaean_Resh}', "");
    Expect(1, 68321, '\P{^Is_Joining_Group=_ manichaean_Resh}', "");
    Expect(0, 68322, '\p{Is_Joining_Group=_ manichaean_Resh}', "");
    Expect(1, 68322, '\p{^Is_Joining_Group=_ manichaean_Resh}', "");
    Expect(1, 68322, '\P{Is_Joining_Group=_ manichaean_Resh}', "");
    Expect(0, 68322, '\P{^Is_Joining_Group=_ manichaean_Resh}', "");
    Error('\p{Is_Jg=		MANICHAEAN_Resh/a/}');
    Error('\P{Is_Jg=		MANICHAEAN_Resh/a/}');
    Expect(1, 68321, '\p{Is_Jg=manichaeanresh}', "");
    Expect(0, 68321, '\p{^Is_Jg=manichaeanresh}', "");
    Expect(0, 68321, '\P{Is_Jg=manichaeanresh}', "");
    Expect(1, 68321, '\P{^Is_Jg=manichaeanresh}', "");
    Expect(0, 68322, '\p{Is_Jg=manichaeanresh}', "");
    Expect(1, 68322, '\p{^Is_Jg=manichaeanresh}', "");
    Expect(1, 68322, '\P{Is_Jg=manichaeanresh}', "");
    Expect(0, 68322, '\P{^Is_Jg=manichaeanresh}', "");
    Expect(1, 68321, '\p{Is_Jg=__MANICHAEAN_resh}', "");
    Expect(0, 68321, '\p{^Is_Jg=__MANICHAEAN_resh}', "");
    Expect(0, 68321, '\P{Is_Jg=__MANICHAEAN_resh}', "");
    Expect(1, 68321, '\P{^Is_Jg=__MANICHAEAN_resh}', "");
    Expect(0, 68322, '\p{Is_Jg=__MANICHAEAN_resh}', "");
    Expect(1, 68322, '\p{^Is_Jg=__MANICHAEAN_resh}', "");
    Expect(1, 68322, '\P{Is_Jg=__MANICHAEAN_resh}', "");
    Expect(0, 68322, '\P{^Is_Jg=__MANICHAEAN_resh}', "");
    Error('\p{Joining_Group=-	MANICHAEAN_Sadhe:=}');
    Error('\P{Joining_Group=-	MANICHAEAN_Sadhe:=}');
    Expect(1, 68317, '\p{Joining_Group=:\AManichaean_Sadhe\z:}', "");;
    Expect(0, 68318, '\p{Joining_Group=:\AManichaean_Sadhe\z:}', "");;
    Expect(1, 68317, '\p{Joining_Group=manichaeansadhe}', "");
    Expect(0, 68317, '\p{^Joining_Group=manichaeansadhe}', "");
    Expect(0, 68317, '\P{Joining_Group=manichaeansadhe}', "");
    Expect(1, 68317, '\P{^Joining_Group=manichaeansadhe}', "");
    Expect(0, 68318, '\p{Joining_Group=manichaeansadhe}', "");
    Expect(1, 68318, '\p{^Joining_Group=manichaeansadhe}', "");
    Expect(1, 68318, '\P{Joining_Group=manichaeansadhe}', "");
    Expect(0, 68318, '\P{^Joining_Group=manichaeansadhe}', "");
    Expect(1, 68317, '\p{Joining_Group=:\Amanichaeansadhe\z:}', "");;
    Expect(0, 68318, '\p{Joining_Group=:\Amanichaeansadhe\z:}', "");;
    Expect(1, 68317, '\p{Joining_Group= -manichaean_SADHE}', "");
    Expect(0, 68317, '\p{^Joining_Group= -manichaean_SADHE}', "");
    Expect(0, 68317, '\P{Joining_Group= -manichaean_SADHE}', "");
    Expect(1, 68317, '\P{^Joining_Group= -manichaean_SADHE}', "");
    Expect(0, 68318, '\p{Joining_Group= -manichaean_SADHE}', "");
    Expect(1, 68318, '\p{^Joining_Group= -manichaean_SADHE}', "");
    Expect(1, 68318, '\P{Joining_Group= -manichaean_SADHE}', "");
    Expect(0, 68318, '\P{^Joining_Group= -manichaean_SADHE}', "");
    Error('\p{Jg=:= -manichaean_Sadhe}');
    Error('\P{Jg=:= -manichaean_Sadhe}');
    Expect(1, 68317, '\p{Jg=:\AManichaean_Sadhe\z:}', "");;
    Expect(0, 68318, '\p{Jg=:\AManichaean_Sadhe\z:}', "");;
    Expect(1, 68317, '\p{Jg=manichaeansadhe}', "");
    Expect(0, 68317, '\p{^Jg=manichaeansadhe}', "");
    Expect(0, 68317, '\P{Jg=manichaeansadhe}', "");
    Expect(1, 68317, '\P{^Jg=manichaeansadhe}', "");
    Expect(0, 68318, '\p{Jg=manichaeansadhe}', "");
    Expect(1, 68318, '\p{^Jg=manichaeansadhe}', "");
    Expect(1, 68318, '\P{Jg=manichaeansadhe}', "");
    Expect(0, 68318, '\P{^Jg=manichaeansadhe}', "");
    Expect(1, 68317, '\p{Jg=:\Amanichaeansadhe\z:}', "");;
    Expect(0, 68318, '\p{Jg=:\Amanichaeansadhe\z:}', "");;
    Expect(1, 68317, '\p{Jg: 	manichaean_Sadhe}', "");
    Expect(0, 68317, '\p{^Jg: 	manichaean_Sadhe}', "");
    Expect(0, 68317, '\P{Jg: 	manichaean_Sadhe}', "");
    Expect(1, 68317, '\P{^Jg: 	manichaean_Sadhe}', "");
    Expect(0, 68318, '\p{Jg: 	manichaean_Sadhe}', "");
    Expect(1, 68318, '\p{^Jg: 	manichaean_Sadhe}', "");
    Expect(1, 68318, '\P{Jg: 	manichaean_Sadhe}', "");
    Expect(0, 68318, '\P{^Jg: 	manichaean_Sadhe}', "");
    Error('\p{Is_Joining_Group=/a/_ Manichaean_Sadhe}');
    Error('\P{Is_Joining_Group=/a/_ Manichaean_Sadhe}');
    Expect(1, 68317, '\p{Is_Joining_Group=manichaeansadhe}', "");
    Expect(0, 68317, '\p{^Is_Joining_Group=manichaeansadhe}', "");
    Expect(0, 68317, '\P{Is_Joining_Group=manichaeansadhe}', "");
    Expect(1, 68317, '\P{^Is_Joining_Group=manichaeansadhe}', "");
    Expect(0, 68318, '\p{Is_Joining_Group=manichaeansadhe}', "");
    Expect(1, 68318, '\p{^Is_Joining_Group=manichaeansadhe}', "");
    Expect(1, 68318, '\P{Is_Joining_Group=manichaeansadhe}', "");
    Expect(0, 68318, '\P{^Is_Joining_Group=manichaeansadhe}', "");
    Expect(1, 68317, '\p{Is_Joining_Group=  manichaean_SADHE}', "");
    Expect(0, 68317, '\p{^Is_Joining_Group=  manichaean_SADHE}', "");
    Expect(0, 68317, '\P{Is_Joining_Group=  manichaean_SADHE}', "");
    Expect(1, 68317, '\P{^Is_Joining_Group=  manichaean_SADHE}', "");
    Expect(0, 68318, '\p{Is_Joining_Group=  manichaean_SADHE}', "");
    Expect(1, 68318, '\p{^Is_Joining_Group=  manichaean_SADHE}', "");
    Expect(1, 68318, '\P{Is_Joining_Group=  manichaean_SADHE}', "");
    Expect(0, 68318, '\P{^Is_Joining_Group=  manichaean_SADHE}', "");
    Error('\p{Is_Jg=	Manichaean_Sadhe/a/}');
    Error('\P{Is_Jg=	Manichaean_Sadhe/a/}');
    Expect(1, 68317, '\p{Is_Jg:   manichaeansadhe}', "");
    Expect(0, 68317, '\p{^Is_Jg:   manichaeansadhe}', "");
    Expect(0, 68317, '\P{Is_Jg:   manichaeansadhe}', "");
    Expect(1, 68317, '\P{^Is_Jg:   manichaeansadhe}', "");
    Expect(0, 68318, '\p{Is_Jg:   manichaeansadhe}', "");
    Expect(1, 68318, '\p{^Is_Jg:   manichaeansadhe}', "");
    Expect(1, 68318, '\P{Is_Jg:   manichaeansadhe}', "");
    Expect(0, 68318, '\P{^Is_Jg:   manichaeansadhe}', "");
    Expect(1, 68317, '\p{Is_Jg=Manichaean_SADHE}', "");
    Expect(0, 68317, '\p{^Is_Jg=Manichaean_SADHE}', "");
    Expect(0, 68317, '\P{Is_Jg=Manichaean_SADHE}', "");
    Expect(1, 68317, '\P{^Is_Jg=Manichaean_SADHE}', "");
    Expect(0, 68318, '\p{Is_Jg=Manichaean_SADHE}', "");
    Expect(1, 68318, '\p{^Is_Jg=Manichaean_SADHE}', "");
    Expect(1, 68318, '\P{Is_Jg=Manichaean_SADHE}', "");
    Expect(0, 68318, '\P{^Is_Jg=Manichaean_SADHE}', "");
    Error('\p{Joining_Group=__manichaean_SAMEKH:=}');
    Error('\P{Joining_Group=__manichaean_SAMEKH:=}');
    Expect(1, 68312, '\p{Joining_Group=:\AManichaean_Samekh\z:}', "");;
    Expect(0, 68313, '\p{Joining_Group=:\AManichaean_Samekh\z:}', "");;
    Expect(1, 68312, '\p{Joining_Group=manichaeansamekh}', "");
    Expect(0, 68312, '\p{^Joining_Group=manichaeansamekh}', "");
    Expect(0, 68312, '\P{Joining_Group=manichaeansamekh}', "");
    Expect(1, 68312, '\P{^Joining_Group=manichaeansamekh}', "");
    Expect(0, 68313, '\p{Joining_Group=manichaeansamekh}', "");
    Expect(1, 68313, '\p{^Joining_Group=manichaeansamekh}', "");
    Expect(1, 68313, '\P{Joining_Group=manichaeansamekh}', "");
    Expect(0, 68313, '\P{^Joining_Group=manichaeansamekh}', "");
    Expect(1, 68312, '\p{Joining_Group=:\Amanichaeansamekh\z:}', "");;
    Expect(0, 68313, '\p{Joining_Group=:\Amanichaeansamekh\z:}', "");;
    Expect(1, 68312, '\p{Joining_Group=	manichaean_Samekh}', "");
    Expect(0, 68312, '\p{^Joining_Group=	manichaean_Samekh}', "");
    Expect(0, 68312, '\P{Joining_Group=	manichaean_Samekh}', "");
    Expect(1, 68312, '\P{^Joining_Group=	manichaean_Samekh}', "");
    Expect(0, 68313, '\p{Joining_Group=	manichaean_Samekh}', "");
    Expect(1, 68313, '\p{^Joining_Group=	manichaean_Samekh}', "");
    Expect(1, 68313, '\P{Joining_Group=	manichaean_Samekh}', "");
    Expect(0, 68313, '\P{^Joining_Group=	manichaean_Samekh}', "");
    Error('\p{Jg=:=_-manichaean_SAMEKH}');
    Error('\P{Jg=:=_-manichaean_SAMEKH}');
    Expect(1, 68312, '\p{Jg=:\AManichaean_Samekh\z:}', "");;
    Expect(0, 68313, '\p{Jg=:\AManichaean_Samekh\z:}', "");;
    Expect(1, 68312, '\p{Jg=manichaeansamekh}', "");
    Expect(0, 68312, '\p{^Jg=manichaeansamekh}', "");
    Expect(0, 68312, '\P{Jg=manichaeansamekh}', "");
    Expect(1, 68312, '\P{^Jg=manichaeansamekh}', "");
    Expect(0, 68313, '\p{Jg=manichaeansamekh}', "");
    Expect(1, 68313, '\p{^Jg=manichaeansamekh}', "");
    Expect(1, 68313, '\P{Jg=manichaeansamekh}', "");
    Expect(0, 68313, '\P{^Jg=manichaeansamekh}', "");
    Expect(1, 68312, '\p{Jg=:\Amanichaeansamekh\z:}', "");;
    Expect(0, 68313, '\p{Jg=:\Amanichaeansamekh\z:}', "");;
    Expect(1, 68312, '\p{Jg: _-Manichaean_SAMEKH}', "");
    Expect(0, 68312, '\p{^Jg: _-Manichaean_SAMEKH}', "");
    Expect(0, 68312, '\P{Jg: _-Manichaean_SAMEKH}', "");
    Expect(1, 68312, '\P{^Jg: _-Manichaean_SAMEKH}', "");
    Expect(0, 68313, '\p{Jg: _-Manichaean_SAMEKH}', "");
    Expect(1, 68313, '\p{^Jg: _-Manichaean_SAMEKH}', "");
    Expect(1, 68313, '\P{Jg: _-Manichaean_SAMEKH}', "");
    Expect(0, 68313, '\P{^Jg: _-Manichaean_SAMEKH}', "");
    Error('\p{Is_Joining_Group=	Manichaean_Samekh:=}');
    Error('\P{Is_Joining_Group=	Manichaean_Samekh:=}');
    Expect(1, 68312, '\p{Is_Joining_Group=manichaeansamekh}', "");
    Expect(0, 68312, '\p{^Is_Joining_Group=manichaeansamekh}', "");
    Expect(0, 68312, '\P{Is_Joining_Group=manichaeansamekh}', "");
    Expect(1, 68312, '\P{^Is_Joining_Group=manichaeansamekh}', "");
    Expect(0, 68313, '\p{Is_Joining_Group=manichaeansamekh}', "");
    Expect(1, 68313, '\p{^Is_Joining_Group=manichaeansamekh}', "");
    Expect(1, 68313, '\P{Is_Joining_Group=manichaeansamekh}', "");
    Expect(0, 68313, '\P{^Is_Joining_Group=manichaeansamekh}', "");
    Expect(1, 68312, '\p{Is_Joining_Group=_Manichaean_SAMEKH}', "");
    Expect(0, 68312, '\p{^Is_Joining_Group=_Manichaean_SAMEKH}', "");
    Expect(0, 68312, '\P{Is_Joining_Group=_Manichaean_SAMEKH}', "");
    Expect(1, 68312, '\P{^Is_Joining_Group=_Manichaean_SAMEKH}', "");
    Expect(0, 68313, '\p{Is_Joining_Group=_Manichaean_SAMEKH}', "");
    Expect(1, 68313, '\p{^Is_Joining_Group=_Manichaean_SAMEKH}', "");
    Expect(1, 68313, '\P{Is_Joining_Group=_Manichaean_SAMEKH}', "");
    Expect(0, 68313, '\P{^Is_Joining_Group=_Manichaean_SAMEKH}', "");
    Error('\p{Is_Jg=	:=Manichaean_Samekh}');
    Error('\P{Is_Jg=	:=Manichaean_Samekh}');
    Expect(1, 68312, '\p{Is_Jg:   manichaeansamekh}', "");
    Expect(0, 68312, '\p{^Is_Jg:   manichaeansamekh}', "");
    Expect(0, 68312, '\P{Is_Jg:   manichaeansamekh}', "");
    Expect(1, 68312, '\P{^Is_Jg:   manichaeansamekh}', "");
    Expect(0, 68313, '\p{Is_Jg:   manichaeansamekh}', "");
    Expect(1, 68313, '\p{^Is_Jg:   manichaeansamekh}', "");
    Expect(1, 68313, '\P{Is_Jg:   manichaeansamekh}', "");
    Expect(0, 68313, '\P{^Is_Jg:   manichaeansamekh}', "");
    Expect(1, 68312, '\p{Is_Jg=-	Manichaean_samekh}', "");
    Expect(0, 68312, '\p{^Is_Jg=-	Manichaean_samekh}', "");
    Expect(0, 68312, '\P{Is_Jg=-	Manichaean_samekh}', "");
    Expect(1, 68312, '\P{^Is_Jg=-	Manichaean_samekh}', "");
    Expect(0, 68313, '\p{Is_Jg=-	Manichaean_samekh}', "");
    Expect(1, 68313, '\p{^Is_Jg=-	Manichaean_samekh}', "");
    Expect(1, 68313, '\P{Is_Jg=-	Manichaean_samekh}', "");
    Expect(0, 68313, '\P{^Is_Jg=-	Manichaean_samekh}', "");
    Error('\p{Joining_Group=-:=manichaean_Taw}');
    Error('\P{Joining_Group=-:=manichaean_Taw}');
    Expect(1, 68324, '\p{Joining_Group=:\AManichaean_Taw\z:}', "");;
    Expect(0, 68325, '\p{Joining_Group=:\AManichaean_Taw\z:}', "");;
    Expect(1, 68324, '\p{Joining_Group=manichaeantaw}', "");
    Expect(0, 68324, '\p{^Joining_Group=manichaeantaw}', "");
    Expect(0, 68324, '\P{Joining_Group=manichaeantaw}', "");
    Expect(1, 68324, '\P{^Joining_Group=manichaeantaw}', "");
    Expect(0, 68325, '\p{Joining_Group=manichaeantaw}', "");
    Expect(1, 68325, '\p{^Joining_Group=manichaeantaw}', "");
    Expect(1, 68325, '\P{Joining_Group=manichaeantaw}', "");
    Expect(0, 68325, '\P{^Joining_Group=manichaeantaw}', "");
    Expect(1, 68324, '\p{Joining_Group=:\Amanichaeantaw\z:}', "");;
    Expect(0, 68325, '\p{Joining_Group=:\Amanichaeantaw\z:}', "");;
    Expect(1, 68324, '\p{Joining_Group:		MANICHAEAN_TAW}', "");
    Expect(0, 68324, '\p{^Joining_Group:		MANICHAEAN_TAW}', "");
    Expect(0, 68324, '\P{Joining_Group:		MANICHAEAN_TAW}', "");
    Expect(1, 68324, '\P{^Joining_Group:		MANICHAEAN_TAW}', "");
    Expect(0, 68325, '\p{Joining_Group:		MANICHAEAN_TAW}', "");
    Expect(1, 68325, '\p{^Joining_Group:		MANICHAEAN_TAW}', "");
    Expect(1, 68325, '\P{Joining_Group:		MANICHAEAN_TAW}', "");
    Expect(0, 68325, '\P{^Joining_Group:		MANICHAEAN_TAW}', "");
    Error('\p{Jg= :=manichaean_TAW}');
    Error('\P{Jg= :=manichaean_TAW}');
    Expect(1, 68324, '\p{Jg=:\AManichaean_Taw\z:}', "");;
    Expect(0, 68325, '\p{Jg=:\AManichaean_Taw\z:}', "");;
    Expect(1, 68324, '\p{Jg=manichaeantaw}', "");
    Expect(0, 68324, '\p{^Jg=manichaeantaw}', "");
    Expect(0, 68324, '\P{Jg=manichaeantaw}', "");
    Expect(1, 68324, '\P{^Jg=manichaeantaw}', "");
    Expect(0, 68325, '\p{Jg=manichaeantaw}', "");
    Expect(1, 68325, '\p{^Jg=manichaeantaw}', "");
    Expect(1, 68325, '\P{Jg=manichaeantaw}', "");
    Expect(0, 68325, '\P{^Jg=manichaeantaw}', "");
    Expect(1, 68324, '\p{Jg=:\Amanichaeantaw\z:}', "");;
    Expect(0, 68325, '\p{Jg=:\Amanichaeantaw\z:}', "");;
    Expect(1, 68324, '\p{Jg=-	manichaean_taw}', "");
    Expect(0, 68324, '\p{^Jg=-	manichaean_taw}', "");
    Expect(0, 68324, '\P{Jg=-	manichaean_taw}', "");
    Expect(1, 68324, '\P{^Jg=-	manichaean_taw}', "");
    Expect(0, 68325, '\p{Jg=-	manichaean_taw}', "");
    Expect(1, 68325, '\p{^Jg=-	manichaean_taw}', "");
    Expect(1, 68325, '\P{Jg=-	manichaean_taw}', "");
    Expect(0, 68325, '\P{^Jg=-	manichaean_taw}', "");
    Error('\p{Is_Joining_Group=/a/	_manichaean_Taw}');
    Error('\P{Is_Joining_Group=/a/	_manichaean_Taw}');
    Expect(1, 68324, '\p{Is_Joining_Group: manichaeantaw}', "");
    Expect(0, 68324, '\p{^Is_Joining_Group: manichaeantaw}', "");
    Expect(0, 68324, '\P{Is_Joining_Group: manichaeantaw}', "");
    Expect(1, 68324, '\P{^Is_Joining_Group: manichaeantaw}', "");
    Expect(0, 68325, '\p{Is_Joining_Group: manichaeantaw}', "");
    Expect(1, 68325, '\p{^Is_Joining_Group: manichaeantaw}', "");
    Expect(1, 68325, '\P{Is_Joining_Group: manichaeantaw}', "");
    Expect(0, 68325, '\P{^Is_Joining_Group: manichaeantaw}', "");
    Expect(1, 68324, '\p{Is_Joining_Group=--Manichaean_Taw}', "");
    Expect(0, 68324, '\p{^Is_Joining_Group=--Manichaean_Taw}', "");
    Expect(0, 68324, '\P{Is_Joining_Group=--Manichaean_Taw}', "");
    Expect(1, 68324, '\P{^Is_Joining_Group=--Manichaean_Taw}', "");
    Expect(0, 68325, '\p{Is_Joining_Group=--Manichaean_Taw}', "");
    Expect(1, 68325, '\p{^Is_Joining_Group=--Manichaean_Taw}', "");
    Expect(1, 68325, '\P{Is_Joining_Group=--Manichaean_Taw}', "");
    Expect(0, 68325, '\P{^Is_Joining_Group=--Manichaean_Taw}', "");
    Error('\p{Is_Jg=	_manichaean_Taw:=}');
    Error('\P{Is_Jg=	_manichaean_Taw:=}');
    Expect(1, 68324, '\p{Is_Jg=manichaeantaw}', "");
    Expect(0, 68324, '\p{^Is_Jg=manichaeantaw}', "");
    Expect(0, 68324, '\P{Is_Jg=manichaeantaw}', "");
    Expect(1, 68324, '\P{^Is_Jg=manichaeantaw}', "");
    Expect(0, 68325, '\p{Is_Jg=manichaeantaw}', "");
    Expect(1, 68325, '\p{^Is_Jg=manichaeantaw}', "");
    Expect(1, 68325, '\P{Is_Jg=manichaeantaw}', "");
    Expect(0, 68325, '\P{^Is_Jg=manichaeantaw}', "");
    Expect(1, 68324, '\p{Is_Jg:	manichaean_taw}', "");
    Expect(0, 68324, '\p{^Is_Jg:	manichaean_taw}', "");
    Expect(0, 68324, '\P{Is_Jg:	manichaean_taw}', "");
    Expect(1, 68324, '\P{^Is_Jg:	manichaean_taw}', "");
    Expect(0, 68325, '\p{Is_Jg:	manichaean_taw}', "");
    Expect(1, 68325, '\p{^Is_Jg:	manichaean_taw}', "");
    Expect(1, 68325, '\P{Is_Jg:	manichaean_taw}', "");
    Expect(0, 68325, '\P{^Is_Jg:	manichaean_taw}', "");
    Error('\p{Joining_Group=:=_-manichaean_TEN}');
    Error('\P{Joining_Group=:=_-manichaean_TEN}');
    Expect(1, 68333, '\p{Joining_Group=:\AManichaean_Ten\z:}', "");;
    Expect(0, 68334, '\p{Joining_Group=:\AManichaean_Ten\z:}', "");;
    Expect(1, 68333, '\p{Joining_Group=manichaeanten}', "");
    Expect(0, 68333, '\p{^Joining_Group=manichaeanten}', "");
    Expect(0, 68333, '\P{Joining_Group=manichaeanten}', "");
    Expect(1, 68333, '\P{^Joining_Group=manichaeanten}', "");
    Expect(0, 68334, '\p{Joining_Group=manichaeanten}', "");
    Expect(1, 68334, '\p{^Joining_Group=manichaeanten}', "");
    Expect(1, 68334, '\P{Joining_Group=manichaeanten}', "");
    Expect(0, 68334, '\P{^Joining_Group=manichaeanten}', "");
    Expect(1, 68333, '\p{Joining_Group=:\Amanichaeanten\z:}', "");;
    Expect(0, 68334, '\p{Joining_Group=:\Amanichaeanten\z:}', "");;
    Expect(1, 68333, '\p{Joining_Group=--Manichaean_TEN}', "");
    Expect(0, 68333, '\p{^Joining_Group=--Manichaean_TEN}', "");
    Expect(0, 68333, '\P{Joining_Group=--Manichaean_TEN}', "");
    Expect(1, 68333, '\P{^Joining_Group=--Manichaean_TEN}', "");
    Expect(0, 68334, '\p{Joining_Group=--Manichaean_TEN}', "");
    Expect(1, 68334, '\p{^Joining_Group=--Manichaean_TEN}', "");
    Expect(1, 68334, '\P{Joining_Group=--Manichaean_TEN}', "");
    Expect(0, 68334, '\P{^Joining_Group=--Manichaean_TEN}', "");
    Error('\p{Jg=/a/MANICHAEAN_TEN}');
    Error('\P{Jg=/a/MANICHAEAN_TEN}');
    Expect(1, 68333, '\p{Jg=:\AManichaean_Ten\z:}', "");;
    Expect(0, 68334, '\p{Jg=:\AManichaean_Ten\z:}', "");;
    Expect(1, 68333, '\p{Jg=manichaeanten}', "");
    Expect(0, 68333, '\p{^Jg=manichaeanten}', "");
    Expect(0, 68333, '\P{Jg=manichaeanten}', "");
    Expect(1, 68333, '\P{^Jg=manichaeanten}', "");
    Expect(0, 68334, '\p{Jg=manichaeanten}', "");
    Expect(1, 68334, '\p{^Jg=manichaeanten}', "");
    Expect(1, 68334, '\P{Jg=manichaeanten}', "");
    Expect(0, 68334, '\P{^Jg=manichaeanten}', "");
    Expect(1, 68333, '\p{Jg=:\Amanichaeanten\z:}', "");;
    Expect(0, 68334, '\p{Jg=:\Amanichaeanten\z:}', "");;
    Expect(1, 68333, '\p{Jg:   _ manichaean_ten}', "");
    Expect(0, 68333, '\p{^Jg:   _ manichaean_ten}', "");
    Expect(0, 68333, '\P{Jg:   _ manichaean_ten}', "");
    Expect(1, 68333, '\P{^Jg:   _ manichaean_ten}', "");
    Expect(0, 68334, '\p{Jg:   _ manichaean_ten}', "");
    Expect(1, 68334, '\p{^Jg:   _ manichaean_ten}', "");
    Expect(1, 68334, '\P{Jg:   _ manichaean_ten}', "");
    Expect(0, 68334, '\P{^Jg:   _ manichaean_ten}', "");
    Error('\p{Is_Joining_Group: 	 Manichaean_Ten:=}');
    Error('\P{Is_Joining_Group: 	 Manichaean_Ten:=}');
    Expect(1, 68333, '\p{Is_Joining_Group=manichaeanten}', "");
    Expect(0, 68333, '\p{^Is_Joining_Group=manichaeanten}', "");
    Expect(0, 68333, '\P{Is_Joining_Group=manichaeanten}', "");
    Expect(1, 68333, '\P{^Is_Joining_Group=manichaeanten}', "");
    Expect(0, 68334, '\p{Is_Joining_Group=manichaeanten}', "");
    Expect(1, 68334, '\p{^Is_Joining_Group=manichaeanten}', "");
    Expect(1, 68334, '\P{Is_Joining_Group=manichaeanten}', "");
    Expect(0, 68334, '\P{^Is_Joining_Group=manichaeanten}', "");
    Expect(1, 68333, '\p{Is_Joining_Group=-_Manichaean_TEN}', "");
    Expect(0, 68333, '\p{^Is_Joining_Group=-_Manichaean_TEN}', "");
    Expect(0, 68333, '\P{Is_Joining_Group=-_Manichaean_TEN}', "");
    Expect(1, 68333, '\P{^Is_Joining_Group=-_Manichaean_TEN}', "");
    Expect(0, 68334, '\p{Is_Joining_Group=-_Manichaean_TEN}', "");
    Expect(1, 68334, '\p{^Is_Joining_Group=-_Manichaean_TEN}', "");
    Expect(1, 68334, '\P{Is_Joining_Group=-_Manichaean_TEN}', "");
    Expect(0, 68334, '\P{^Is_Joining_Group=-_Manichaean_TEN}', "");
    Error('\p{Is_Jg:   _:=manichaean_TEN}');
    Error('\P{Is_Jg:   _:=manichaean_TEN}');
    Expect(1, 68333, '\p{Is_Jg=manichaeanten}', "");
    Expect(0, 68333, '\p{^Is_Jg=manichaeanten}', "");
    Expect(0, 68333, '\P{Is_Jg=manichaeanten}', "");
    Expect(1, 68333, '\P{^Is_Jg=manichaeanten}', "");
    Expect(0, 68334, '\p{Is_Jg=manichaeanten}', "");
    Expect(1, 68334, '\p{^Is_Jg=manichaeanten}', "");
    Expect(1, 68334, '\P{Is_Jg=manichaeanten}', "");
    Expect(0, 68334, '\P{^Is_Jg=manichaeanten}', "");
    Expect(1, 68333, '\p{Is_Jg=	Manichaean_Ten}', "");
    Expect(0, 68333, '\p{^Is_Jg=	Manichaean_Ten}', "");
    Expect(0, 68333, '\P{Is_Jg=	Manichaean_Ten}', "");
    Expect(1, 68333, '\P{^Is_Jg=	Manichaean_Ten}', "");
    Expect(0, 68334, '\p{Is_Jg=	Manichaean_Ten}', "");
    Expect(1, 68334, '\p{^Is_Jg=	Manichaean_Ten}', "");
    Expect(1, 68334, '\P{Is_Jg=	Manichaean_Ten}', "");
    Expect(0, 68334, '\P{^Is_Jg=	Manichaean_Ten}', "");
    Error('\p{Joining_Group=- Manichaean_Teth:=}');
    Error('\P{Joining_Group=- Manichaean_Teth:=}');
    Expect(1, 68302, '\p{Joining_Group=:\AManichaean_Teth\z:}', "");;
    Expect(0, 68303, '\p{Joining_Group=:\AManichaean_Teth\z:}', "");;
    Expect(1, 68302, '\p{Joining_Group=manichaeanteth}', "");
    Expect(0, 68302, '\p{^Joining_Group=manichaeanteth}', "");
    Expect(0, 68302, '\P{Joining_Group=manichaeanteth}', "");
    Expect(1, 68302, '\P{^Joining_Group=manichaeanteth}', "");
    Expect(0, 68303, '\p{Joining_Group=manichaeanteth}', "");
    Expect(1, 68303, '\p{^Joining_Group=manichaeanteth}', "");
    Expect(1, 68303, '\P{Joining_Group=manichaeanteth}', "");
    Expect(0, 68303, '\P{^Joining_Group=manichaeanteth}', "");
    Expect(1, 68302, '\p{Joining_Group=:\Amanichaeanteth\z:}', "");;
    Expect(0, 68303, '\p{Joining_Group=:\Amanichaeanteth\z:}', "");;
    Expect(1, 68302, '\p{Joining_Group=		Manichaean_Teth}', "");
    Expect(0, 68302, '\p{^Joining_Group=		Manichaean_Teth}', "");
    Expect(0, 68302, '\P{Joining_Group=		Manichaean_Teth}', "");
    Expect(1, 68302, '\P{^Joining_Group=		Manichaean_Teth}', "");
    Expect(0, 68303, '\p{Joining_Group=		Manichaean_Teth}', "");
    Expect(1, 68303, '\p{^Joining_Group=		Manichaean_Teth}', "");
    Expect(1, 68303, '\P{Joining_Group=		Manichaean_Teth}', "");
    Expect(0, 68303, '\P{^Joining_Group=		Manichaean_Teth}', "");
    Error('\p{Jg=/a/_ Manichaean_TETH}');
    Error('\P{Jg=/a/_ Manichaean_TETH}');
    Expect(1, 68302, '\p{Jg=:\AManichaean_Teth\z:}', "");;
    Expect(0, 68303, '\p{Jg=:\AManichaean_Teth\z:}', "");;
    Expect(1, 68302, '\p{Jg=manichaeanteth}', "");
    Expect(0, 68302, '\p{^Jg=manichaeanteth}', "");
    Expect(0, 68302, '\P{Jg=manichaeanteth}', "");
    Expect(1, 68302, '\P{^Jg=manichaeanteth}', "");
    Expect(0, 68303, '\p{Jg=manichaeanteth}', "");
    Expect(1, 68303, '\p{^Jg=manichaeanteth}', "");
    Expect(1, 68303, '\P{Jg=manichaeanteth}', "");
    Expect(0, 68303, '\P{^Jg=manichaeanteth}', "");
    Expect(1, 68302, '\p{Jg=:\Amanichaeanteth\z:}', "");;
    Expect(0, 68303, '\p{Jg=:\Amanichaeanteth\z:}', "");;
    Expect(1, 68302, '\p{Jg=MANICHAEAN_Teth}', "");
    Expect(0, 68302, '\p{^Jg=MANICHAEAN_Teth}', "");
    Expect(0, 68302, '\P{Jg=MANICHAEAN_Teth}', "");
    Expect(1, 68302, '\P{^Jg=MANICHAEAN_Teth}', "");
    Expect(0, 68303, '\p{Jg=MANICHAEAN_Teth}', "");
    Expect(1, 68303, '\p{^Jg=MANICHAEAN_Teth}', "");
    Expect(1, 68303, '\P{Jg=MANICHAEAN_Teth}', "");
    Expect(0, 68303, '\P{^Jg=MANICHAEAN_Teth}', "");
    Error('\p{Is_Joining_Group: :=  manichaean_TETH}');
    Error('\P{Is_Joining_Group: :=  manichaean_TETH}');
    Expect(1, 68302, '\p{Is_Joining_Group=manichaeanteth}', "");
    Expect(0, 68302, '\p{^Is_Joining_Group=manichaeanteth}', "");
    Expect(0, 68302, '\P{Is_Joining_Group=manichaeanteth}', "");
    Expect(1, 68302, '\P{^Is_Joining_Group=manichaeanteth}', "");
    Expect(0, 68303, '\p{Is_Joining_Group=manichaeanteth}', "");
    Expect(1, 68303, '\p{^Is_Joining_Group=manichaeanteth}', "");
    Expect(1, 68303, '\P{Is_Joining_Group=manichaeanteth}', "");
    Expect(0, 68303, '\P{^Is_Joining_Group=manichaeanteth}', "");
    Expect(1, 68302, '\p{Is_Joining_Group=_	Manichaean_Teth}', "");
    Expect(0, 68302, '\p{^Is_Joining_Group=_	Manichaean_Teth}', "");
    Expect(0, 68302, '\P{Is_Joining_Group=_	Manichaean_Teth}', "");
    Expect(1, 68302, '\P{^Is_Joining_Group=_	Manichaean_Teth}', "");
    Expect(0, 68303, '\p{Is_Joining_Group=_	Manichaean_Teth}', "");
    Expect(1, 68303, '\p{^Is_Joining_Group=_	Manichaean_Teth}', "");
    Expect(1, 68303, '\P{Is_Joining_Group=_	Manichaean_Teth}', "");
    Expect(0, 68303, '\P{^Is_Joining_Group=_	Manichaean_Teth}', "");
    Error('\p{Is_Jg=/a/_ Manichaean_Teth}');
    Error('\P{Is_Jg=/a/_ Manichaean_Teth}');
    Expect(1, 68302, '\p{Is_Jg=manichaeanteth}', "");
    Expect(0, 68302, '\p{^Is_Jg=manichaeanteth}', "");
    Expect(0, 68302, '\P{Is_Jg=manichaeanteth}', "");
    Expect(1, 68302, '\P{^Is_Jg=manichaeanteth}', "");
    Expect(0, 68303, '\p{Is_Jg=manichaeanteth}', "");
    Expect(1, 68303, '\p{^Is_Jg=manichaeanteth}', "");
    Expect(1, 68303, '\P{Is_Jg=manichaeanteth}', "");
    Expect(0, 68303, '\P{^Is_Jg=manichaeanteth}', "");
    Expect(1, 68302, '\p{Is_Jg= _Manichaean_teth}', "");
    Expect(0, 68302, '\p{^Is_Jg= _Manichaean_teth}', "");
    Expect(0, 68302, '\P{Is_Jg= _Manichaean_teth}', "");
    Expect(1, 68302, '\P{^Is_Jg= _Manichaean_teth}', "");
    Expect(0, 68303, '\p{Is_Jg= _Manichaean_teth}', "");
    Expect(1, 68303, '\p{^Is_Jg= _Manichaean_teth}', "");
    Expect(1, 68303, '\P{Is_Jg= _Manichaean_teth}', "");
    Expect(0, 68303, '\P{^Is_Jg= _Manichaean_teth}', "");
    Error('\p{Joining_Group:- Manichaean_THAMEDH/a/}');
    Error('\P{Joining_Group:- Manichaean_THAMEDH/a/}');
    Expect(1, 68309, '\p{Joining_Group=:\AManichaean_Thamedh\z:}', "");;
    Expect(0, 68310, '\p{Joining_Group=:\AManichaean_Thamedh\z:}', "");;
    Expect(1, 68309, '\p{Joining_Group=manichaeanthamedh}', "");
    Expect(0, 68309, '\p{^Joining_Group=manichaeanthamedh}', "");
    Expect(0, 68309, '\P{Joining_Group=manichaeanthamedh}', "");
    Expect(1, 68309, '\P{^Joining_Group=manichaeanthamedh}', "");
    Expect(0, 68310, '\p{Joining_Group=manichaeanthamedh}', "");
    Expect(1, 68310, '\p{^Joining_Group=manichaeanthamedh}', "");
    Expect(1, 68310, '\P{Joining_Group=manichaeanthamedh}', "");
    Expect(0, 68310, '\P{^Joining_Group=manichaeanthamedh}', "");
    Expect(1, 68309, '\p{Joining_Group=:\Amanichaeanthamedh\z:}', "");;
    Expect(0, 68310, '\p{Joining_Group=:\Amanichaeanthamedh\z:}', "");;
    Expect(1, 68309, '\p{Joining_Group:_manichaean_THAMEDH}', "");
    Expect(0, 68309, '\p{^Joining_Group:_manichaean_THAMEDH}', "");
    Expect(0, 68309, '\P{Joining_Group:_manichaean_THAMEDH}', "");
    Expect(1, 68309, '\P{^Joining_Group:_manichaean_THAMEDH}', "");
    Expect(0, 68310, '\p{Joining_Group:_manichaean_THAMEDH}', "");
    Expect(1, 68310, '\p{^Joining_Group:_manichaean_THAMEDH}', "");
    Expect(1, 68310, '\P{Joining_Group:_manichaean_THAMEDH}', "");
    Expect(0, 68310, '\P{^Joining_Group:_manichaean_THAMEDH}', "");
    Error('\p{Jg=/a/_	Manichaean_THAMEDH}');
    Error('\P{Jg=/a/_	Manichaean_THAMEDH}');
    Expect(1, 68309, '\p{Jg=:\AManichaean_Thamedh\z:}', "");;
    Expect(0, 68310, '\p{Jg=:\AManichaean_Thamedh\z:}', "");;
    Expect(1, 68309, '\p{Jg=manichaeanthamedh}', "");
    Expect(0, 68309, '\p{^Jg=manichaeanthamedh}', "");
    Expect(0, 68309, '\P{Jg=manichaeanthamedh}', "");
    Expect(1, 68309, '\P{^Jg=manichaeanthamedh}', "");
    Expect(0, 68310, '\p{Jg=manichaeanthamedh}', "");
    Expect(1, 68310, '\p{^Jg=manichaeanthamedh}', "");
    Expect(1, 68310, '\P{Jg=manichaeanthamedh}', "");
    Expect(0, 68310, '\P{^Jg=manichaeanthamedh}', "");
    Expect(1, 68309, '\p{Jg=:\Amanichaeanthamedh\z:}', "");;
    Expect(0, 68310, '\p{Jg=:\Amanichaeanthamedh\z:}', "");;
    Expect(1, 68309, '\p{Jg=Manichaean_Thamedh}', "");
    Expect(0, 68309, '\p{^Jg=Manichaean_Thamedh}', "");
    Expect(0, 68309, '\P{Jg=Manichaean_Thamedh}', "");
    Expect(1, 68309, '\P{^Jg=Manichaean_Thamedh}', "");
    Expect(0, 68310, '\p{Jg=Manichaean_Thamedh}', "");
    Expect(1, 68310, '\p{^Jg=Manichaean_Thamedh}', "");
    Expect(1, 68310, '\P{Jg=Manichaean_Thamedh}', "");
    Expect(0, 68310, '\P{^Jg=Manichaean_Thamedh}', "");
    Error('\p{Is_Joining_Group=:=  Manichaean_Thamedh}');
    Error('\P{Is_Joining_Group=:=  Manichaean_Thamedh}');
    Expect(1, 68309, '\p{Is_Joining_Group=manichaeanthamedh}', "");
    Expect(0, 68309, '\p{^Is_Joining_Group=manichaeanthamedh}', "");
    Expect(0, 68309, '\P{Is_Joining_Group=manichaeanthamedh}', "");
    Expect(1, 68309, '\P{^Is_Joining_Group=manichaeanthamedh}', "");
    Expect(0, 68310, '\p{Is_Joining_Group=manichaeanthamedh}', "");
    Expect(1, 68310, '\p{^Is_Joining_Group=manichaeanthamedh}', "");
    Expect(1, 68310, '\P{Is_Joining_Group=manichaeanthamedh}', "");
    Expect(0, 68310, '\P{^Is_Joining_Group=manichaeanthamedh}', "");
    Expect(1, 68309, '\p{Is_Joining_Group=-	Manichaean_thamedh}', "");
    Expect(0, 68309, '\p{^Is_Joining_Group=-	Manichaean_thamedh}', "");
    Expect(0, 68309, '\P{Is_Joining_Group=-	Manichaean_thamedh}', "");
    Expect(1, 68309, '\P{^Is_Joining_Group=-	Manichaean_thamedh}', "");
    Expect(0, 68310, '\p{Is_Joining_Group=-	Manichaean_thamedh}', "");
    Expect(1, 68310, '\p{^Is_Joining_Group=-	Manichaean_thamedh}', "");
    Expect(1, 68310, '\P{Is_Joining_Group=-	Manichaean_thamedh}', "");
    Expect(0, 68310, '\P{^Is_Joining_Group=-	Manichaean_thamedh}', "");
    Error('\p{Is_Jg=-:=manichaean_Thamedh}');
    Error('\P{Is_Jg=-:=manichaean_Thamedh}');
    Expect(1, 68309, '\p{Is_Jg=manichaeanthamedh}', "");
    Expect(0, 68309, '\p{^Is_Jg=manichaeanthamedh}', "");
    Expect(0, 68309, '\P{Is_Jg=manichaeanthamedh}', "");
    Expect(1, 68309, '\P{^Is_Jg=manichaeanthamedh}', "");
    Expect(0, 68310, '\p{Is_Jg=manichaeanthamedh}', "");
    Expect(1, 68310, '\p{^Is_Jg=manichaeanthamedh}', "");
    Expect(1, 68310, '\P{Is_Jg=manichaeanthamedh}', "");
    Expect(0, 68310, '\P{^Is_Jg=manichaeanthamedh}', "");
    Expect(1, 68309, '\p{Is_Jg=  manichaean_Thamedh}', "");
    Expect(0, 68309, '\p{^Is_Jg=  manichaean_Thamedh}', "");
    Expect(0, 68309, '\P{Is_Jg=  manichaean_Thamedh}', "");
    Expect(1, 68309, '\P{^Is_Jg=  manichaean_Thamedh}', "");
    Expect(0, 68310, '\p{Is_Jg=  manichaean_Thamedh}', "");
    Expect(1, 68310, '\p{^Is_Jg=  manichaean_Thamedh}', "");
    Expect(1, 68310, '\P{Is_Jg=  manichaean_Thamedh}', "");
    Expect(0, 68310, '\P{^Is_Jg=  manichaean_Thamedh}', "");
    Error('\p{Joining_Group=:=	-Manichaean_twenty}');
    Error('\P{Joining_Group=:=	-Manichaean_twenty}');
    Expect(1, 68334, '\p{Joining_Group=:\AManichaean_Twenty\z:}', "");;
    Expect(0, 68335, '\p{Joining_Group=:\AManichaean_Twenty\z:}', "");;
    Expect(1, 68334, '\p{Joining_Group=manichaeantwenty}', "");
    Expect(0, 68334, '\p{^Joining_Group=manichaeantwenty}', "");
    Expect(0, 68334, '\P{Joining_Group=manichaeantwenty}', "");
    Expect(1, 68334, '\P{^Joining_Group=manichaeantwenty}', "");
    Expect(0, 68335, '\p{Joining_Group=manichaeantwenty}', "");
    Expect(1, 68335, '\p{^Joining_Group=manichaeantwenty}', "");
    Expect(1, 68335, '\P{Joining_Group=manichaeantwenty}', "");
    Expect(0, 68335, '\P{^Joining_Group=manichaeantwenty}', "");
    Expect(1, 68334, '\p{Joining_Group=:\Amanichaeantwenty\z:}', "");;
    Expect(0, 68335, '\p{Joining_Group=:\Amanichaeantwenty\z:}', "");;
    Expect(1, 68334, '\p{Joining_Group=manichaean_Twenty}', "");
    Expect(0, 68334, '\p{^Joining_Group=manichaean_Twenty}', "");
    Expect(0, 68334, '\P{Joining_Group=manichaean_Twenty}', "");
    Expect(1, 68334, '\P{^Joining_Group=manichaean_Twenty}', "");
    Expect(0, 68335, '\p{Joining_Group=manichaean_Twenty}', "");
    Expect(1, 68335, '\p{^Joining_Group=manichaean_Twenty}', "");
    Expect(1, 68335, '\P{Joining_Group=manichaean_Twenty}', "");
    Expect(0, 68335, '\P{^Joining_Group=manichaean_Twenty}', "");
    Error('\p{Jg:_manichaean_TWENTY/a/}');
    Error('\P{Jg:_manichaean_TWENTY/a/}');
    Expect(1, 68334, '\p{Jg=:\AManichaean_Twenty\z:}', "");;
    Expect(0, 68335, '\p{Jg=:\AManichaean_Twenty\z:}', "");;
    Expect(1, 68334, '\p{Jg=manichaeantwenty}', "");
    Expect(0, 68334, '\p{^Jg=manichaeantwenty}', "");
    Expect(0, 68334, '\P{Jg=manichaeantwenty}', "");
    Expect(1, 68334, '\P{^Jg=manichaeantwenty}', "");
    Expect(0, 68335, '\p{Jg=manichaeantwenty}', "");
    Expect(1, 68335, '\p{^Jg=manichaeantwenty}', "");
    Expect(1, 68335, '\P{Jg=manichaeantwenty}', "");
    Expect(0, 68335, '\P{^Jg=manichaeantwenty}', "");
    Expect(1, 68334, '\p{Jg=:\Amanichaeantwenty\z:}', "");;
    Expect(0, 68335, '\p{Jg=:\Amanichaeantwenty\z:}', "");;
    Expect(1, 68334, '\p{Jg:   -	MANICHAEAN_Twenty}', "");
    Expect(0, 68334, '\p{^Jg:   -	MANICHAEAN_Twenty}', "");
    Expect(0, 68334, '\P{Jg:   -	MANICHAEAN_Twenty}', "");
    Expect(1, 68334, '\P{^Jg:   -	MANICHAEAN_Twenty}', "");
    Expect(0, 68335, '\p{Jg:   -	MANICHAEAN_Twenty}', "");
    Expect(1, 68335, '\p{^Jg:   -	MANICHAEAN_Twenty}', "");
    Expect(1, 68335, '\P{Jg:   -	MANICHAEAN_Twenty}', "");
    Expect(0, 68335, '\P{^Jg:   -	MANICHAEAN_Twenty}', "");
    Error('\p{Is_Joining_Group=/a/Manichaean_TWENTY}');
    Error('\P{Is_Joining_Group=/a/Manichaean_TWENTY}');
    Expect(1, 68334, '\p{Is_Joining_Group=manichaeantwenty}', "");
    Expect(0, 68334, '\p{^Is_Joining_Group=manichaeantwenty}', "");
    Expect(0, 68334, '\P{Is_Joining_Group=manichaeantwenty}', "");
    Expect(1, 68334, '\P{^Is_Joining_Group=manichaeantwenty}', "");
    Expect(0, 68335, '\p{Is_Joining_Group=manichaeantwenty}', "");
    Expect(1, 68335, '\p{^Is_Joining_Group=manichaeantwenty}', "");
    Expect(1, 68335, '\P{Is_Joining_Group=manichaeantwenty}', "");
    Expect(0, 68335, '\P{^Is_Joining_Group=manichaeantwenty}', "");
    Expect(1, 68334, '\p{Is_Joining_Group= -Manichaean_Twenty}', "");
    Expect(0, 68334, '\p{^Is_Joining_Group= -Manichaean_Twenty}', "");
    Expect(0, 68334, '\P{Is_Joining_Group= -Manichaean_Twenty}', "");
    Expect(1, 68334, '\P{^Is_Joining_Group= -Manichaean_Twenty}', "");
    Expect(0, 68335, '\p{Is_Joining_Group= -Manichaean_Twenty}', "");
    Expect(1, 68335, '\p{^Is_Joining_Group= -Manichaean_Twenty}', "");
    Expect(1, 68335, '\P{Is_Joining_Group= -Manichaean_Twenty}', "");
    Expect(0, 68335, '\P{^Is_Joining_Group= -Manichaean_Twenty}', "");
    Error('\p{Is_Jg=/a/	Manichaean_Twenty}');
    Error('\P{Is_Jg=/a/	Manichaean_Twenty}');
    Expect(1, 68334, '\p{Is_Jg=manichaeantwenty}', "");
    Expect(0, 68334, '\p{^Is_Jg=manichaeantwenty}', "");
    Expect(0, 68334, '\P{Is_Jg=manichaeantwenty}', "");
    Expect(1, 68334, '\P{^Is_Jg=manichaeantwenty}', "");
    Expect(0, 68335, '\p{Is_Jg=manichaeantwenty}', "");
    Expect(1, 68335, '\p{^Is_Jg=manichaeantwenty}', "");
    Expect(1, 68335, '\P{Is_Jg=manichaeantwenty}', "");
    Expect(0, 68335, '\P{^Is_Jg=manichaeantwenty}', "");
    Expect(1, 68334, '\p{Is_Jg=--Manichaean_Twenty}', "");
    Expect(0, 68334, '\p{^Is_Jg=--Manichaean_Twenty}', "");
    Expect(0, 68334, '\P{Is_Jg=--Manichaean_Twenty}', "");
    Expect(1, 68334, '\P{^Is_Jg=--Manichaean_Twenty}', "");
    Expect(0, 68335, '\p{Is_Jg=--Manichaean_Twenty}', "");
    Expect(1, 68335, '\p{^Is_Jg=--Manichaean_Twenty}', "");
    Expect(1, 68335, '\P{Is_Jg=--Manichaean_Twenty}', "");
    Expect(0, 68335, '\P{^Is_Jg=--Manichaean_Twenty}', "");
    Error('\p{Joining_Group=-/a/Manichaean_Waw}');
    Error('\P{Joining_Group=-/a/Manichaean_Waw}');
    Expect(1, 68295, '\p{Joining_Group=:\AManichaean_Waw\z:}', "");;
    Expect(0, 68296, '\p{Joining_Group=:\AManichaean_Waw\z:}', "");;
    Expect(1, 68295, '\p{Joining_Group=manichaeanwaw}', "");
    Expect(0, 68295, '\p{^Joining_Group=manichaeanwaw}', "");
    Expect(0, 68295, '\P{Joining_Group=manichaeanwaw}', "");
    Expect(1, 68295, '\P{^Joining_Group=manichaeanwaw}', "");
    Expect(0, 68296, '\p{Joining_Group=manichaeanwaw}', "");
    Expect(1, 68296, '\p{^Joining_Group=manichaeanwaw}', "");
    Expect(1, 68296, '\P{Joining_Group=manichaeanwaw}', "");
    Expect(0, 68296, '\P{^Joining_Group=manichaeanwaw}', "");
    Expect(1, 68295, '\p{Joining_Group=:\Amanichaeanwaw\z:}', "");;
    Expect(0, 68296, '\p{Joining_Group=:\Amanichaeanwaw\z:}', "");;
    Expect(1, 68295, '\p{Joining_Group=--manichaean_WAW}', "");
    Expect(0, 68295, '\p{^Joining_Group=--manichaean_WAW}', "");
    Expect(0, 68295, '\P{Joining_Group=--manichaean_WAW}', "");
    Expect(1, 68295, '\P{^Joining_Group=--manichaean_WAW}', "");
    Expect(0, 68296, '\p{Joining_Group=--manichaean_WAW}', "");
    Expect(1, 68296, '\p{^Joining_Group=--manichaean_WAW}', "");
    Expect(1, 68296, '\P{Joining_Group=--manichaean_WAW}', "");
    Expect(0, 68296, '\P{^Joining_Group=--manichaean_WAW}', "");
    Error('\p{Jg=	 MANICHAEAN_Waw:=}');
    Error('\P{Jg=	 MANICHAEAN_Waw:=}');
    Expect(1, 68295, '\p{Jg=:\AManichaean_Waw\z:}', "");;
    Expect(0, 68296, '\p{Jg=:\AManichaean_Waw\z:}', "");;
    Expect(1, 68295, '\p{Jg=manichaeanwaw}', "");
    Expect(0, 68295, '\p{^Jg=manichaeanwaw}', "");
    Expect(0, 68295, '\P{Jg=manichaeanwaw}', "");
    Expect(1, 68295, '\P{^Jg=manichaeanwaw}', "");
    Expect(0, 68296, '\p{Jg=manichaeanwaw}', "");
    Expect(1, 68296, '\p{^Jg=manichaeanwaw}', "");
    Expect(1, 68296, '\P{Jg=manichaeanwaw}', "");
    Expect(0, 68296, '\P{^Jg=manichaeanwaw}', "");
    Expect(1, 68295, '\p{Jg=:\Amanichaeanwaw\z:}', "");;
    Expect(0, 68296, '\p{Jg=:\Amanichaeanwaw\z:}', "");;
    Expect(1, 68295, '\p{Jg=_-Manichaean_WAW}', "");
    Expect(0, 68295, '\p{^Jg=_-Manichaean_WAW}', "");
    Expect(0, 68295, '\P{Jg=_-Manichaean_WAW}', "");
    Expect(1, 68295, '\P{^Jg=_-Manichaean_WAW}', "");
    Expect(0, 68296, '\p{Jg=_-Manichaean_WAW}', "");
    Expect(1, 68296, '\p{^Jg=_-Manichaean_WAW}', "");
    Expect(1, 68296, '\P{Jg=_-Manichaean_WAW}', "");
    Expect(0, 68296, '\P{^Jg=_-Manichaean_WAW}', "");
    Error('\p{Is_Joining_Group=	_Manichaean_waw:=}');
    Error('\P{Is_Joining_Group=	_Manichaean_waw:=}');
    Expect(1, 68295, '\p{Is_Joining_Group: manichaeanwaw}', "");
    Expect(0, 68295, '\p{^Is_Joining_Group: manichaeanwaw}', "");
    Expect(0, 68295, '\P{Is_Joining_Group: manichaeanwaw}', "");
    Expect(1, 68295, '\P{^Is_Joining_Group: manichaeanwaw}', "");
    Expect(0, 68296, '\p{Is_Joining_Group: manichaeanwaw}', "");
    Expect(1, 68296, '\p{^Is_Joining_Group: manichaeanwaw}', "");
    Expect(1, 68296, '\P{Is_Joining_Group: manichaeanwaw}', "");
    Expect(0, 68296, '\P{^Is_Joining_Group: manichaeanwaw}', "");
    Expect(1, 68295, '\p{Is_Joining_Group=--manichaean_Waw}', "");
    Expect(0, 68295, '\p{^Is_Joining_Group=--manichaean_Waw}', "");
    Expect(0, 68295, '\P{Is_Joining_Group=--manichaean_Waw}', "");
    Expect(1, 68295, '\P{^Is_Joining_Group=--manichaean_Waw}', "");
    Expect(0, 68296, '\p{Is_Joining_Group=--manichaean_Waw}', "");
    Expect(1, 68296, '\p{^Is_Joining_Group=--manichaean_Waw}', "");
    Expect(1, 68296, '\P{Is_Joining_Group=--manichaean_Waw}', "");
    Expect(0, 68296, '\P{^Is_Joining_Group=--manichaean_Waw}', "");
    Error('\p{Is_Jg=--manichaean_waw/a/}');
    Error('\P{Is_Jg=--manichaean_waw/a/}');
    Expect(1, 68295, '\p{Is_Jg=manichaeanwaw}', "");
    Expect(0, 68295, '\p{^Is_Jg=manichaeanwaw}', "");
    Expect(0, 68295, '\P{Is_Jg=manichaeanwaw}', "");
    Expect(1, 68295, '\P{^Is_Jg=manichaeanwaw}', "");
    Expect(0, 68296, '\p{Is_Jg=manichaeanwaw}', "");
    Expect(1, 68296, '\p{^Is_Jg=manichaeanwaw}', "");
    Expect(1, 68296, '\P{Is_Jg=manichaeanwaw}', "");
    Expect(0, 68296, '\P{^Is_Jg=manichaeanwaw}', "");
    Expect(1, 68295, '\p{Is_Jg=_-manichaean_Waw}', "");
    Expect(0, 68295, '\p{^Is_Jg=_-manichaean_Waw}', "");
    Expect(0, 68295, '\P{Is_Jg=_-manichaean_Waw}', "");
    Expect(1, 68295, '\P{^Is_Jg=_-manichaean_Waw}', "");
    Expect(0, 68296, '\p{Is_Jg=_-manichaean_Waw}', "");
    Expect(1, 68296, '\p{^Is_Jg=_-manichaean_Waw}', "");
    Expect(1, 68296, '\P{Is_Jg=_-manichaean_Waw}', "");
    Expect(0, 68296, '\P{^Is_Jg=_-manichaean_Waw}', "");
    Error('\p{Joining_Group=/a/Manichaean_Yodh}');
    Error('\P{Joining_Group=/a/Manichaean_Yodh}');
    Expect(1, 68303, '\p{Joining_Group=:\AManichaean_Yodh\z:}', "");;
    Expect(0, 68304, '\p{Joining_Group=:\AManichaean_Yodh\z:}', "");;
    Expect(1, 68303, '\p{Joining_Group=manichaeanyodh}', "");
    Expect(0, 68303, '\p{^Joining_Group=manichaeanyodh}', "");
    Expect(0, 68303, '\P{Joining_Group=manichaeanyodh}', "");
    Expect(1, 68303, '\P{^Joining_Group=manichaeanyodh}', "");
    Expect(0, 68304, '\p{Joining_Group=manichaeanyodh}', "");
    Expect(1, 68304, '\p{^Joining_Group=manichaeanyodh}', "");
    Expect(1, 68304, '\P{Joining_Group=manichaeanyodh}', "");
    Expect(0, 68304, '\P{^Joining_Group=manichaeanyodh}', "");
    Expect(1, 68303, '\p{Joining_Group=:\Amanichaeanyodh\z:}', "");;
    Expect(0, 68304, '\p{Joining_Group=:\Amanichaeanyodh\z:}', "");;
    Expect(1, 68303, '\p{Joining_Group=MANICHAEAN_Yodh}', "");
    Expect(0, 68303, '\p{^Joining_Group=MANICHAEAN_Yodh}', "");
    Expect(0, 68303, '\P{Joining_Group=MANICHAEAN_Yodh}', "");
    Expect(1, 68303, '\P{^Joining_Group=MANICHAEAN_Yodh}', "");
    Expect(0, 68304, '\p{Joining_Group=MANICHAEAN_Yodh}', "");
    Expect(1, 68304, '\p{^Joining_Group=MANICHAEAN_Yodh}', "");
    Expect(1, 68304, '\P{Joining_Group=MANICHAEAN_Yodh}', "");
    Expect(0, 68304, '\P{^Joining_Group=MANICHAEAN_Yodh}', "");
    Error('\p{Jg=	Manichaean_Yodh/a/}');
    Error('\P{Jg=	Manichaean_Yodh/a/}');
    Expect(1, 68303, '\p{Jg=:\AManichaean_Yodh\z:}', "");;
    Expect(0, 68304, '\p{Jg=:\AManichaean_Yodh\z:}', "");;
    Expect(1, 68303, '\p{Jg=manichaeanyodh}', "");
    Expect(0, 68303, '\p{^Jg=manichaeanyodh}', "");
    Expect(0, 68303, '\P{Jg=manichaeanyodh}', "");
    Expect(1, 68303, '\P{^Jg=manichaeanyodh}', "");
    Expect(0, 68304, '\p{Jg=manichaeanyodh}', "");
    Expect(1, 68304, '\p{^Jg=manichaeanyodh}', "");
    Expect(1, 68304, '\P{Jg=manichaeanyodh}', "");
    Expect(0, 68304, '\P{^Jg=manichaeanyodh}', "");
    Expect(1, 68303, '\p{Jg=:\Amanichaeanyodh\z:}', "");;
    Expect(0, 68304, '\p{Jg=:\Amanichaeanyodh\z:}', "");;
    Expect(1, 68303, '\p{Jg=  Manichaean_YODH}', "");
    Expect(0, 68303, '\p{^Jg=  Manichaean_YODH}', "");
    Expect(0, 68303, '\P{Jg=  Manichaean_YODH}', "");
    Expect(1, 68303, '\P{^Jg=  Manichaean_YODH}', "");
    Expect(0, 68304, '\p{Jg=  Manichaean_YODH}', "");
    Expect(1, 68304, '\p{^Jg=  Manichaean_YODH}', "");
    Expect(1, 68304, '\P{Jg=  Manichaean_YODH}', "");
    Expect(0, 68304, '\P{^Jg=  Manichaean_YODH}', "");
    Error('\p{Is_Joining_Group=	-Manichaean_yodh/a/}');
    Error('\P{Is_Joining_Group=	-Manichaean_yodh/a/}');
    Expect(1, 68303, '\p{Is_Joining_Group=manichaeanyodh}', "");
    Expect(0, 68303, '\p{^Is_Joining_Group=manichaeanyodh}', "");
    Expect(0, 68303, '\P{Is_Joining_Group=manichaeanyodh}', "");
    Expect(1, 68303, '\P{^Is_Joining_Group=manichaeanyodh}', "");
    Expect(0, 68304, '\p{Is_Joining_Group=manichaeanyodh}', "");
    Expect(1, 68304, '\p{^Is_Joining_Group=manichaeanyodh}', "");
    Expect(1, 68304, '\P{Is_Joining_Group=manichaeanyodh}', "");
    Expect(0, 68304, '\P{^Is_Joining_Group=manichaeanyodh}', "");
    Expect(1, 68303, '\p{Is_Joining_Group: 	MANICHAEAN_Yodh}', "");
    Expect(0, 68303, '\p{^Is_Joining_Group: 	MANICHAEAN_Yodh}', "");
    Expect(0, 68303, '\P{Is_Joining_Group: 	MANICHAEAN_Yodh}', "");
    Expect(1, 68303, '\P{^Is_Joining_Group: 	MANICHAEAN_Yodh}', "");
    Expect(0, 68304, '\p{Is_Joining_Group: 	MANICHAEAN_Yodh}', "");
    Expect(1, 68304, '\p{^Is_Joining_Group: 	MANICHAEAN_Yodh}', "");
    Expect(1, 68304, '\P{Is_Joining_Group: 	MANICHAEAN_Yodh}', "");
    Expect(0, 68304, '\P{^Is_Joining_Group: 	MANICHAEAN_Yodh}', "");
    Error('\p{Is_Jg=:=-Manichaean_yodh}');
    Error('\P{Is_Jg=:=-Manichaean_yodh}');
    Expect(1, 68303, '\p{Is_Jg=manichaeanyodh}', "");
    Expect(0, 68303, '\p{^Is_Jg=manichaeanyodh}', "");
    Expect(0, 68303, '\P{Is_Jg=manichaeanyodh}', "");
    Expect(1, 68303, '\P{^Is_Jg=manichaeanyodh}', "");
    Expect(0, 68304, '\p{Is_Jg=manichaeanyodh}', "");
    Expect(1, 68304, '\p{^Is_Jg=manichaeanyodh}', "");
    Expect(1, 68304, '\P{Is_Jg=manichaeanyodh}', "");
    Expect(0, 68304, '\P{^Is_Jg=manichaeanyodh}', "");
    Expect(1, 68303, '\p{Is_Jg=	-MANICHAEAN_Yodh}', "");
    Expect(0, 68303, '\p{^Is_Jg=	-MANICHAEAN_Yodh}', "");
    Expect(0, 68303, '\P{Is_Jg=	-MANICHAEAN_Yodh}', "");
    Expect(1, 68303, '\P{^Is_Jg=	-MANICHAEAN_Yodh}', "");
    Expect(0, 68304, '\p{Is_Jg=	-MANICHAEAN_Yodh}', "");
    Expect(1, 68304, '\p{^Is_Jg=	-MANICHAEAN_Yodh}', "");
    Expect(1, 68304, '\P{Is_Jg=	-MANICHAEAN_Yodh}', "");
    Expect(0, 68304, '\P{^Is_Jg=	-MANICHAEAN_Yodh}', "");
    Error('\p{Joining_Group=/a/  Manichaean_ZAYIN}');
    Error('\P{Joining_Group=/a/  Manichaean_ZAYIN}');
    Expect(1, 68298, '\p{Joining_Group=:\AManichaean_Zayin\z:}', "");;
    Expect(0, 68299, '\p{Joining_Group=:\AManichaean_Zayin\z:}', "");;
    Expect(1, 68298, '\p{Joining_Group=manichaeanzayin}', "");
    Expect(0, 68298, '\p{^Joining_Group=manichaeanzayin}', "");
    Expect(0, 68298, '\P{Joining_Group=manichaeanzayin}', "");
    Expect(1, 68298, '\P{^Joining_Group=manichaeanzayin}', "");
    Expect(0, 68299, '\p{Joining_Group=manichaeanzayin}', "");
    Expect(1, 68299, '\p{^Joining_Group=manichaeanzayin}', "");
    Expect(1, 68299, '\P{Joining_Group=manichaeanzayin}', "");
    Expect(0, 68299, '\P{^Joining_Group=manichaeanzayin}', "");
    Expect(1, 68298, '\p{Joining_Group=:\Amanichaeanzayin\z:}', "");;
    Expect(0, 68299, '\p{Joining_Group=:\Amanichaeanzayin\z:}', "");;
    Expect(1, 68298, '\p{Joining_Group:   -manichaean_Zayin}', "");
    Expect(0, 68298, '\p{^Joining_Group:   -manichaean_Zayin}', "");
    Expect(0, 68298, '\P{Joining_Group:   -manichaean_Zayin}', "");
    Expect(1, 68298, '\P{^Joining_Group:   -manichaean_Zayin}', "");
    Expect(0, 68299, '\p{Joining_Group:   -manichaean_Zayin}', "");
    Expect(1, 68299, '\p{^Joining_Group:   -manichaean_Zayin}', "");
    Expect(1, 68299, '\P{Joining_Group:   -manichaean_Zayin}', "");
    Expect(0, 68299, '\P{^Joining_Group:   -manichaean_Zayin}', "");
    Error('\p{Jg=-:=MANICHAEAN_Zayin}');
    Error('\P{Jg=-:=MANICHAEAN_Zayin}');
    Expect(1, 68298, '\p{Jg=:\AManichaean_Zayin\z:}', "");;
    Expect(0, 68299, '\p{Jg=:\AManichaean_Zayin\z:}', "");;
    Expect(1, 68298, '\p{Jg=manichaeanzayin}', "");
    Expect(0, 68298, '\p{^Jg=manichaeanzayin}', "");
    Expect(0, 68298, '\P{Jg=manichaeanzayin}', "");
    Expect(1, 68298, '\P{^Jg=manichaeanzayin}', "");
    Expect(0, 68299, '\p{Jg=manichaeanzayin}', "");
    Expect(1, 68299, '\p{^Jg=manichaeanzayin}', "");
    Expect(1, 68299, '\P{Jg=manichaeanzayin}', "");
    Expect(0, 68299, '\P{^Jg=manichaeanzayin}', "");
    Expect(1, 68298, '\p{Jg=:\Amanichaeanzayin\z:}', "");;
    Expect(0, 68299, '\p{Jg=:\Amanichaeanzayin\z:}', "");;
    Expect(1, 68298, '\p{Jg=- Manichaean_Zayin}', "");
    Expect(0, 68298, '\p{^Jg=- Manichaean_Zayin}', "");
    Expect(0, 68298, '\P{Jg=- Manichaean_Zayin}', "");
    Expect(1, 68298, '\P{^Jg=- Manichaean_Zayin}', "");
    Expect(0, 68299, '\p{Jg=- Manichaean_Zayin}', "");
    Expect(1, 68299, '\p{^Jg=- Manichaean_Zayin}', "");
    Expect(1, 68299, '\P{Jg=- Manichaean_Zayin}', "");
    Expect(0, 68299, '\P{^Jg=- Manichaean_Zayin}', "");
    Error('\p{Is_Joining_Group=:=_	Manichaean_zayin}');
    Error('\P{Is_Joining_Group=:=_	Manichaean_zayin}');
    Expect(1, 68298, '\p{Is_Joining_Group=manichaeanzayin}', "");
    Expect(0, 68298, '\p{^Is_Joining_Group=manichaeanzayin}', "");
    Expect(0, 68298, '\P{Is_Joining_Group=manichaeanzayin}', "");
    Expect(1, 68298, '\P{^Is_Joining_Group=manichaeanzayin}', "");
    Expect(0, 68299, '\p{Is_Joining_Group=manichaeanzayin}', "");
    Expect(1, 68299, '\p{^Is_Joining_Group=manichaeanzayin}', "");
    Expect(1, 68299, '\P{Is_Joining_Group=manichaeanzayin}', "");
    Expect(0, 68299, '\P{^Is_Joining_Group=manichaeanzayin}', "");
    Expect(1, 68298, '\p{Is_Joining_Group=Manichaean_ZAYIN}', "");
    Expect(0, 68298, '\p{^Is_Joining_Group=Manichaean_ZAYIN}', "");
    Expect(0, 68298, '\P{Is_Joining_Group=Manichaean_ZAYIN}', "");
    Expect(1, 68298, '\P{^Is_Joining_Group=Manichaean_ZAYIN}', "");
    Expect(0, 68299, '\p{Is_Joining_Group=Manichaean_ZAYIN}', "");
    Expect(1, 68299, '\p{^Is_Joining_Group=Manichaean_ZAYIN}', "");
    Expect(1, 68299, '\P{Is_Joining_Group=Manichaean_ZAYIN}', "");
    Expect(0, 68299, '\P{^Is_Joining_Group=Manichaean_ZAYIN}', "");
    Error('\p{Is_Jg=/a/ -MANICHAEAN_Zayin}');
    Error('\P{Is_Jg=/a/ -MANICHAEAN_Zayin}');
    Expect(1, 68298, '\p{Is_Jg=manichaeanzayin}', "");
    Expect(0, 68298, '\p{^Is_Jg=manichaeanzayin}', "");
    Expect(0, 68298, '\P{Is_Jg=manichaeanzayin}', "");
    Expect(1, 68298, '\P{^Is_Jg=manichaeanzayin}', "");
    Expect(0, 68299, '\p{Is_Jg=manichaeanzayin}', "");
    Expect(1, 68299, '\p{^Is_Jg=manichaeanzayin}', "");
    Expect(1, 68299, '\P{Is_Jg=manichaeanzayin}', "");
    Expect(0, 68299, '\P{^Is_Jg=manichaeanzayin}', "");
    Expect(1, 68298, '\p{Is_Jg=  Manichaean_Zayin}', "");
    Expect(0, 68298, '\p{^Is_Jg=  Manichaean_Zayin}', "");
    Expect(0, 68298, '\P{Is_Jg=  Manichaean_Zayin}', "");
    Expect(1, 68298, '\P{^Is_Jg=  Manichaean_Zayin}', "");
    Expect(0, 68299, '\p{Is_Jg=  Manichaean_Zayin}', "");
    Expect(1, 68299, '\p{^Is_Jg=  Manichaean_Zayin}', "");
    Expect(1, 68299, '\P{Is_Jg=  Manichaean_Zayin}', "");
    Expect(0, 68299, '\P{^Is_Jg=  Manichaean_Zayin}', "");
    Error('\p{Joining_Group=/a/Meem}');
    Error('\P{Joining_Group=/a/Meem}');
    Expect(1, 2215, '\p{Joining_Group=:\AMeem\z:}', "");;
    Expect(0, 2216, '\p{Joining_Group=:\AMeem\z:}', "");;
    Expect(1, 2215, '\p{Joining_Group=meem}', "");
    Expect(0, 2215, '\p{^Joining_Group=meem}', "");
    Expect(0, 2215, '\P{Joining_Group=meem}', "");
    Expect(1, 2215, '\P{^Joining_Group=meem}', "");
    Expect(0, 2216, '\p{Joining_Group=meem}', "");
    Expect(1, 2216, '\p{^Joining_Group=meem}', "");
    Expect(1, 2216, '\P{Joining_Group=meem}', "");
    Expect(0, 2216, '\P{^Joining_Group=meem}', "");
    Expect(1, 2215, '\p{Joining_Group=:\Ameem\z:}', "");;
    Expect(0, 2216, '\p{Joining_Group=:\Ameem\z:}', "");;
    Expect(1, 2215, '\p{Joining_Group:		MEEM}', "");
    Expect(0, 2215, '\p{^Joining_Group:		MEEM}', "");
    Expect(0, 2215, '\P{Joining_Group:		MEEM}', "");
    Expect(1, 2215, '\P{^Joining_Group:		MEEM}', "");
    Expect(0, 2216, '\p{Joining_Group:		MEEM}', "");
    Expect(1, 2216, '\p{^Joining_Group:		MEEM}', "");
    Expect(1, 2216, '\P{Joining_Group:		MEEM}', "");
    Expect(0, 2216, '\P{^Joining_Group:		MEEM}', "");
    Error('\p{Jg=_meem:=}');
    Error('\P{Jg=_meem:=}');
    Expect(1, 2215, '\p{Jg=:\AMeem\z:}', "");;
    Expect(0, 2216, '\p{Jg=:\AMeem\z:}', "");;
    Expect(1, 2215, '\p{Jg=meem}', "");
    Expect(0, 2215, '\p{^Jg=meem}', "");
    Expect(0, 2215, '\P{Jg=meem}', "");
    Expect(1, 2215, '\P{^Jg=meem}', "");
    Expect(0, 2216, '\p{Jg=meem}', "");
    Expect(1, 2216, '\p{^Jg=meem}', "");
    Expect(1, 2216, '\P{Jg=meem}', "");
    Expect(0, 2216, '\P{^Jg=meem}', "");
    Expect(1, 2215, '\p{Jg=:\Ameem\z:}', "");;
    Expect(0, 2216, '\p{Jg=:\Ameem\z:}', "");;
    Expect(1, 2215, '\p{Jg=	_Meem}', "");
    Expect(0, 2215, '\p{^Jg=	_Meem}', "");
    Expect(0, 2215, '\P{Jg=	_Meem}', "");
    Expect(1, 2215, '\P{^Jg=	_Meem}', "");
    Expect(0, 2216, '\p{Jg=	_Meem}', "");
    Expect(1, 2216, '\p{^Jg=	_Meem}', "");
    Expect(1, 2216, '\P{Jg=	_Meem}', "");
    Expect(0, 2216, '\P{^Jg=	_Meem}', "");
    Error('\p{Is_Joining_Group=/a/	 Meem}');
    Error('\P{Is_Joining_Group=/a/	 Meem}');
    Expect(1, 2215, '\p{Is_Joining_Group=meem}', "");
    Expect(0, 2215, '\p{^Is_Joining_Group=meem}', "");
    Expect(0, 2215, '\P{Is_Joining_Group=meem}', "");
    Expect(1, 2215, '\P{^Is_Joining_Group=meem}', "");
    Expect(0, 2216, '\p{Is_Joining_Group=meem}', "");
    Expect(1, 2216, '\p{^Is_Joining_Group=meem}', "");
    Expect(1, 2216, '\P{Is_Joining_Group=meem}', "");
    Expect(0, 2216, '\P{^Is_Joining_Group=meem}', "");
    Expect(1, 2215, '\p{Is_Joining_Group=-Meem}', "");
    Expect(0, 2215, '\p{^Is_Joining_Group=-Meem}', "");
    Expect(0, 2215, '\P{Is_Joining_Group=-Meem}', "");
    Expect(1, 2215, '\P{^Is_Joining_Group=-Meem}', "");
    Expect(0, 2216, '\p{Is_Joining_Group=-Meem}', "");
    Expect(1, 2216, '\p{^Is_Joining_Group=-Meem}', "");
    Expect(1, 2216, '\P{Is_Joining_Group=-Meem}', "");
    Expect(0, 2216, '\P{^Is_Joining_Group=-Meem}', "");
    Error('\p{Is_Jg:	:=	_MEEM}');
    Error('\P{Is_Jg:	:=	_MEEM}');
    Expect(1, 2215, '\p{Is_Jg=meem}', "");
    Expect(0, 2215, '\p{^Is_Jg=meem}', "");
    Expect(0, 2215, '\P{Is_Jg=meem}', "");
    Expect(1, 2215, '\P{^Is_Jg=meem}', "");
    Expect(0, 2216, '\p{Is_Jg=meem}', "");
    Expect(1, 2216, '\p{^Is_Jg=meem}', "");
    Expect(1, 2216, '\P{Is_Jg=meem}', "");
    Expect(0, 2216, '\P{^Is_Jg=meem}', "");
    Expect(1, 2215, '\p{Is_Jg=Meem}', "");
    Expect(0, 2215, '\p{^Is_Jg=Meem}', "");
    Expect(0, 2215, '\P{Is_Jg=Meem}', "");
    Expect(1, 2215, '\P{^Is_Jg=Meem}', "");
    Expect(0, 2216, '\p{Is_Jg=Meem}', "");
    Expect(1, 2216, '\p{^Is_Jg=Meem}', "");
    Expect(1, 2216, '\P{Is_Jg=Meem}', "");
    Expect(0, 2216, '\P{^Is_Jg=Meem}', "");
    Error('\p{Joining_Group=:=MIM}');
    Error('\P{Joining_Group=:=MIM}');
    Expect(1, 1825, '\p{Joining_Group=:\AMim\z:}', "");;
    Expect(0, 1826, '\p{Joining_Group=:\AMim\z:}', "");;
    Expect(1, 1825, '\p{Joining_Group=mim}', "");
    Expect(0, 1825, '\p{^Joining_Group=mim}', "");
    Expect(0, 1825, '\P{Joining_Group=mim}', "");
    Expect(1, 1825, '\P{^Joining_Group=mim}', "");
    Expect(0, 1826, '\p{Joining_Group=mim}', "");
    Expect(1, 1826, '\p{^Joining_Group=mim}', "");
    Expect(1, 1826, '\P{Joining_Group=mim}', "");
    Expect(0, 1826, '\P{^Joining_Group=mim}', "");
    Expect(1, 1825, '\p{Joining_Group=:\Amim\z:}', "");;
    Expect(0, 1826, '\p{Joining_Group=:\Amim\z:}', "");;
    Expect(1, 1825, '\p{Joining_Group=_-MIM}', "");
    Expect(0, 1825, '\p{^Joining_Group=_-MIM}', "");
    Expect(0, 1825, '\P{Joining_Group=_-MIM}', "");
    Expect(1, 1825, '\P{^Joining_Group=_-MIM}', "");
    Expect(0, 1826, '\p{Joining_Group=_-MIM}', "");
    Expect(1, 1826, '\p{^Joining_Group=_-MIM}', "");
    Expect(1, 1826, '\P{Joining_Group=_-MIM}', "");
    Expect(0, 1826, '\P{^Joining_Group=_-MIM}', "");
    Error('\p{Jg=/a/-_Mim}');
    Error('\P{Jg=/a/-_Mim}');
    Expect(1, 1825, '\p{Jg=:\AMim\z:}', "");;
    Expect(0, 1826, '\p{Jg=:\AMim\z:}', "");;
    Expect(1, 1825, '\p{Jg=mim}', "");
    Expect(0, 1825, '\p{^Jg=mim}', "");
    Expect(0, 1825, '\P{Jg=mim}', "");
    Expect(1, 1825, '\P{^Jg=mim}', "");
    Expect(0, 1826, '\p{Jg=mim}', "");
    Expect(1, 1826, '\p{^Jg=mim}', "");
    Expect(1, 1826, '\P{Jg=mim}', "");
    Expect(0, 1826, '\P{^Jg=mim}', "");
    Expect(1, 1825, '\p{Jg=:\Amim\z:}', "");;
    Expect(0, 1826, '\p{Jg=:\Amim\z:}', "");;
    Expect(1, 1825, '\p{Jg=_-MIM}', "");
    Expect(0, 1825, '\p{^Jg=_-MIM}', "");
    Expect(0, 1825, '\P{Jg=_-MIM}', "");
    Expect(1, 1825, '\P{^Jg=_-MIM}', "");
    Expect(0, 1826, '\p{Jg=_-MIM}', "");
    Expect(1, 1826, '\p{^Jg=_-MIM}', "");
    Expect(1, 1826, '\P{Jg=_-MIM}', "");
    Expect(0, 1826, '\P{^Jg=_-MIM}', "");
    Error('\p{Is_Joining_Group= /a/Mim}');
    Error('\P{Is_Joining_Group= /a/Mim}');
    Expect(1, 1825, '\p{Is_Joining_Group=mim}', "");
    Expect(0, 1825, '\p{^Is_Joining_Group=mim}', "");
    Expect(0, 1825, '\P{Is_Joining_Group=mim}', "");
    Expect(1, 1825, '\P{^Is_Joining_Group=mim}', "");
    Expect(0, 1826, '\p{Is_Joining_Group=mim}', "");
    Expect(1, 1826, '\p{^Is_Joining_Group=mim}', "");
    Expect(1, 1826, '\P{Is_Joining_Group=mim}', "");
    Expect(0, 1826, '\P{^Is_Joining_Group=mim}', "");
    Expect(1, 1825, '\p{Is_Joining_Group:-_MIM}', "");
    Expect(0, 1825, '\p{^Is_Joining_Group:-_MIM}', "");
    Expect(0, 1825, '\P{Is_Joining_Group:-_MIM}', "");
    Expect(1, 1825, '\P{^Is_Joining_Group:-_MIM}', "");
    Expect(0, 1826, '\p{Is_Joining_Group:-_MIM}', "");
    Expect(1, 1826, '\p{^Is_Joining_Group:-_MIM}', "");
    Expect(1, 1826, '\P{Is_Joining_Group:-_MIM}', "");
    Expect(0, 1826, '\P{^Is_Joining_Group:-_MIM}', "");
    Error('\p{Is_Jg=	/a/Mim}');
    Error('\P{Is_Jg=	/a/Mim}');
    Expect(1, 1825, '\p{Is_Jg=mim}', "");
    Expect(0, 1825, '\p{^Is_Jg=mim}', "");
    Expect(0, 1825, '\P{Is_Jg=mim}', "");
    Expect(1, 1825, '\P{^Is_Jg=mim}', "");
    Expect(0, 1826, '\p{Is_Jg=mim}', "");
    Expect(1, 1826, '\p{^Is_Jg=mim}', "");
    Expect(1, 1826, '\P{Is_Jg=mim}', "");
    Expect(0, 1826, '\P{^Is_Jg=mim}', "");
    Expect(1, 1825, '\p{Is_Jg=__Mim}', "");
    Expect(0, 1825, '\p{^Is_Jg=__Mim}', "");
    Expect(0, 1825, '\P{Is_Jg=__Mim}', "");
    Expect(1, 1825, '\P{^Is_Jg=__Mim}', "");
    Expect(0, 1826, '\p{Is_Jg=__Mim}', "");
    Expect(1, 1826, '\p{^Is_Jg=__Mim}', "");
    Expect(1, 1826, '\P{Is_Jg=__Mim}', "");
    Expect(0, 1826, '\P{^Is_Jg=__Mim}', "");
    Error('\p{Joining_Group=__no_JOINING_Group/a/}');
    Error('\P{Joining_Group=__no_JOINING_Group/a/}');
    Expect(1, 68900, '\p{Joining_Group=:\ANo_Joining_Group\z:}', "");;
    Expect(0, 68899, '\p{Joining_Group=:\ANo_Joining_Group\z:}', "");;
    Expect(1, 68900, '\p{Joining_Group=nojoininggroup}', "");
    Expect(0, 68900, '\p{^Joining_Group=nojoininggroup}', "");
    Expect(0, 68900, '\P{Joining_Group=nojoininggroup}', "");
    Expect(1, 68900, '\P{^Joining_Group=nojoininggroup}', "");
    Expect(0, 68899, '\p{Joining_Group=nojoininggroup}', "");
    Expect(1, 68899, '\p{^Joining_Group=nojoininggroup}', "");
    Expect(1, 68899, '\P{Joining_Group=nojoininggroup}', "");
    Expect(0, 68899, '\P{^Joining_Group=nojoininggroup}', "");
    Expect(1, 68900, '\p{Joining_Group=:\Anojoininggroup\z:}', "");;
    Expect(0, 68899, '\p{Joining_Group=:\Anojoininggroup\z:}', "");;
    Expect(1, 68900, '\p{Joining_Group:   -No_Joining_GROUP}', "");
    Expect(0, 68900, '\p{^Joining_Group:   -No_Joining_GROUP}', "");
    Expect(0, 68900, '\P{Joining_Group:   -No_Joining_GROUP}', "");
    Expect(1, 68900, '\P{^Joining_Group:   -No_Joining_GROUP}', "");
    Expect(0, 68899, '\p{Joining_Group:   -No_Joining_GROUP}', "");
    Expect(1, 68899, '\p{^Joining_Group:   -No_Joining_GROUP}', "");
    Expect(1, 68899, '\P{Joining_Group:   -No_Joining_GROUP}', "");
    Expect(0, 68899, '\P{^Joining_Group:   -No_Joining_GROUP}', "");
    Error('\p{Jg=/a/_-No_joining_GROUP}');
    Error('\P{Jg=/a/_-No_joining_GROUP}');
    Expect(1, 68900, '\p{Jg=:\ANo_Joining_Group\z:}', "");;
    Expect(0, 68899, '\p{Jg=:\ANo_Joining_Group\z:}', "");;
    Expect(1, 68900, '\p{Jg=nojoininggroup}', "");
    Expect(0, 68900, '\p{^Jg=nojoininggroup}', "");
    Expect(0, 68900, '\P{Jg=nojoininggroup}', "");
    Expect(1, 68900, '\P{^Jg=nojoininggroup}', "");
    Expect(0, 68899, '\p{Jg=nojoininggroup}', "");
    Expect(1, 68899, '\p{^Jg=nojoininggroup}', "");
    Expect(1, 68899, '\P{Jg=nojoininggroup}', "");
    Expect(0, 68899, '\P{^Jg=nojoininggroup}', "");
    Expect(1, 68900, '\p{Jg=:\Anojoininggroup\z:}', "");;
    Expect(0, 68899, '\p{Jg=:\Anojoininggroup\z:}', "");;
    Expect(1, 68900, '\p{Jg=_ No_joining_Group}', "");
    Expect(0, 68900, '\p{^Jg=_ No_joining_Group}', "");
    Expect(0, 68900, '\P{Jg=_ No_joining_Group}', "");
    Expect(1, 68900, '\P{^Jg=_ No_joining_Group}', "");
    Expect(0, 68899, '\p{Jg=_ No_joining_Group}', "");
    Expect(1, 68899, '\p{^Jg=_ No_joining_Group}', "");
    Expect(1, 68899, '\P{Jg=_ No_joining_Group}', "");
    Expect(0, 68899, '\P{^Jg=_ No_joining_Group}', "");
    Error('\p{Is_Joining_Group=/a/ _No_JOINING_group}');
    Error('\P{Is_Joining_Group=/a/ _No_JOINING_group}');
    Expect(1, 68900, '\p{Is_Joining_Group=nojoininggroup}', "");
    Expect(0, 68900, '\p{^Is_Joining_Group=nojoininggroup}', "");
    Expect(0, 68900, '\P{Is_Joining_Group=nojoininggroup}', "");
    Expect(1, 68900, '\P{^Is_Joining_Group=nojoininggroup}', "");
    Expect(0, 68899, '\p{Is_Joining_Group=nojoininggroup}', "");
    Expect(1, 68899, '\p{^Is_Joining_Group=nojoininggroup}', "");
    Expect(1, 68899, '\P{Is_Joining_Group=nojoininggroup}', "");
    Expect(0, 68899, '\P{^Is_Joining_Group=nojoininggroup}', "");
    Expect(1, 68900, '\p{Is_Joining_Group=_NO_Joining_GROUP}', "");
    Expect(0, 68900, '\p{^Is_Joining_Group=_NO_Joining_GROUP}', "");
    Expect(0, 68900, '\P{Is_Joining_Group=_NO_Joining_GROUP}', "");
    Expect(1, 68900, '\P{^Is_Joining_Group=_NO_Joining_GROUP}', "");
    Expect(0, 68899, '\p{Is_Joining_Group=_NO_Joining_GROUP}', "");
    Expect(1, 68899, '\p{^Is_Joining_Group=_NO_Joining_GROUP}', "");
    Expect(1, 68899, '\P{Is_Joining_Group=_NO_Joining_GROUP}', "");
    Expect(0, 68899, '\P{^Is_Joining_Group=_NO_Joining_GROUP}', "");
    Error('\p{Is_Jg=	No_JOINING_Group:=}');
    Error('\P{Is_Jg=	No_JOINING_Group:=}');
    Expect(1, 68900, '\p{Is_Jg=nojoininggroup}', "");
    Expect(0, 68900, '\p{^Is_Jg=nojoininggroup}', "");
    Expect(0, 68900, '\P{Is_Jg=nojoininggroup}', "");
    Expect(1, 68900, '\P{^Is_Jg=nojoininggroup}', "");
    Expect(0, 68899, '\p{Is_Jg=nojoininggroup}', "");
    Expect(1, 68899, '\p{^Is_Jg=nojoininggroup}', "");
    Expect(1, 68899, '\P{Is_Jg=nojoininggroup}', "");
    Expect(0, 68899, '\P{^Is_Jg=nojoininggroup}', "");
    Expect(1, 68900, '\p{Is_Jg=	No_joining_Group}', "");
    Expect(0, 68900, '\p{^Is_Jg=	No_joining_Group}', "");
    Expect(0, 68900, '\P{Is_Jg=	No_joining_Group}', "");
    Expect(1, 68900, '\P{^Is_Jg=	No_joining_Group}', "");
    Expect(0, 68899, '\p{Is_Jg=	No_joining_Group}', "");
    Expect(1, 68899, '\p{^Is_Jg=	No_joining_Group}', "");
    Expect(1, 68899, '\P{Is_Jg=	No_joining_Group}', "");
    Expect(0, 68899, '\P{^Is_Jg=	No_joining_Group}', "");
    Error('\p{Joining_Group=_Noon:=}');
    Error('\P{Joining_Group=_Noon:=}');
    Expect(1, 2185, '\p{Joining_Group=:\ANoon\z:}', "");;
    Expect(0, 2186, '\p{Joining_Group=:\ANoon\z:}', "");;
    Expect(1, 2185, '\p{Joining_Group=noon}', "");
    Expect(0, 2185, '\p{^Joining_Group=noon}', "");
    Expect(0, 2185, '\P{Joining_Group=noon}', "");
    Expect(1, 2185, '\P{^Joining_Group=noon}', "");
    Expect(0, 2186, '\p{Joining_Group=noon}', "");
    Expect(1, 2186, '\p{^Joining_Group=noon}', "");
    Expect(1, 2186, '\P{Joining_Group=noon}', "");
    Expect(0, 2186, '\P{^Joining_Group=noon}', "");
    Expect(1, 2185, '\p{Joining_Group=:\Anoon\z:}', "");;
    Expect(0, 2186, '\p{Joining_Group=:\Anoon\z:}', "");;
    Expect(1, 2185, '\p{Joining_Group=__noon}', "");
    Expect(0, 2185, '\p{^Joining_Group=__noon}', "");
    Expect(0, 2185, '\P{Joining_Group=__noon}', "");
    Expect(1, 2185, '\P{^Joining_Group=__noon}', "");
    Expect(0, 2186, '\p{Joining_Group=__noon}', "");
    Expect(1, 2186, '\p{^Joining_Group=__noon}', "");
    Expect(1, 2186, '\P{Joining_Group=__noon}', "");
    Expect(0, 2186, '\P{^Joining_Group=__noon}', "");
    Error('\p{Jg=--NOON:=}');
    Error('\P{Jg=--NOON:=}');
    Expect(1, 2185, '\p{Jg=:\ANoon\z:}', "");;
    Expect(0, 2186, '\p{Jg=:\ANoon\z:}', "");;
    Expect(1, 2185, '\p{Jg=noon}', "");
    Expect(0, 2185, '\p{^Jg=noon}', "");
    Expect(0, 2185, '\P{Jg=noon}', "");
    Expect(1, 2185, '\P{^Jg=noon}', "");
    Expect(0, 2186, '\p{Jg=noon}', "");
    Expect(1, 2186, '\p{^Jg=noon}', "");
    Expect(1, 2186, '\P{Jg=noon}', "");
    Expect(0, 2186, '\P{^Jg=noon}', "");
    Expect(1, 2185, '\p{Jg=:\Anoon\z:}', "");;
    Expect(0, 2186, '\p{Jg=:\Anoon\z:}', "");;
    Expect(1, 2185, '\p{Jg=	Noon}', "");
    Expect(0, 2185, '\p{^Jg=	Noon}', "");
    Expect(0, 2185, '\P{Jg=	Noon}', "");
    Expect(1, 2185, '\P{^Jg=	Noon}', "");
    Expect(0, 2186, '\p{Jg=	Noon}', "");
    Expect(1, 2186, '\p{^Jg=	Noon}', "");
    Expect(1, 2186, '\P{Jg=	Noon}', "");
    Expect(0, 2186, '\P{^Jg=	Noon}', "");
    Error('\p{Is_Joining_Group=/a/  Noon}');
    Error('\P{Is_Joining_Group=/a/  Noon}');
    Expect(1, 2185, '\p{Is_Joining_Group=noon}', "");
    Expect(0, 2185, '\p{^Is_Joining_Group=noon}', "");
    Expect(0, 2185, '\P{Is_Joining_Group=noon}', "");
    Expect(1, 2185, '\P{^Is_Joining_Group=noon}', "");
    Expect(0, 2186, '\p{Is_Joining_Group=noon}', "");
    Expect(1, 2186, '\p{^Is_Joining_Group=noon}', "");
    Expect(1, 2186, '\P{Is_Joining_Group=noon}', "");
    Expect(0, 2186, '\P{^Is_Joining_Group=noon}', "");
    Expect(1, 2185, '\p{Is_Joining_Group=__NOON}', "");
    Expect(0, 2185, '\p{^Is_Joining_Group=__NOON}', "");
    Expect(0, 2185, '\P{Is_Joining_Group=__NOON}', "");
    Expect(1, 2185, '\P{^Is_Joining_Group=__NOON}', "");
    Expect(0, 2186, '\p{Is_Joining_Group=__NOON}', "");
    Expect(1, 2186, '\p{^Is_Joining_Group=__NOON}', "");
    Expect(1, 2186, '\P{Is_Joining_Group=__NOON}', "");
    Expect(0, 2186, '\P{^Is_Joining_Group=__NOON}', "");
    Error('\p{Is_Jg=:=_ NOON}');
    Error('\P{Is_Jg=:=_ NOON}');
    Expect(1, 2185, '\p{Is_Jg=noon}', "");
    Expect(0, 2185, '\p{^Is_Jg=noon}', "");
    Expect(0, 2185, '\P{Is_Jg=noon}', "");
    Expect(1, 2185, '\P{^Is_Jg=noon}', "");
    Expect(0, 2186, '\p{Is_Jg=noon}', "");
    Expect(1, 2186, '\p{^Is_Jg=noon}', "");
    Expect(1, 2186, '\P{Is_Jg=noon}', "");
    Expect(0, 2186, '\P{^Is_Jg=noon}', "");
    Expect(1, 2185, '\p{Is_Jg=	-Noon}', "");
    Expect(0, 2185, '\p{^Is_Jg=	-Noon}', "");
    Expect(0, 2185, '\P{Is_Jg=	-Noon}', "");
    Expect(1, 2185, '\P{^Is_Jg=	-Noon}', "");
    Expect(0, 2186, '\p{Is_Jg=	-Noon}', "");
    Expect(1, 2186, '\p{^Is_Jg=	-Noon}', "");
    Expect(1, 2186, '\P{Is_Jg=	-Noon}', "");
    Expect(0, 2186, '\P{^Is_Jg=	-Noon}', "");
    Error('\p{Joining_Group=/a/	Nun}');
    Error('\P{Joining_Group=/a/	Nun}');
    Expect(1, 1826, '\p{Joining_Group=:\ANun\z:}', "");;
    Expect(0, 1827, '\p{Joining_Group=:\ANun\z:}', "");;
    Expect(1, 1826, '\p{Joining_Group=nun}', "");
    Expect(0, 1826, '\p{^Joining_Group=nun}', "");
    Expect(0, 1826, '\P{Joining_Group=nun}', "");
    Expect(1, 1826, '\P{^Joining_Group=nun}', "");
    Expect(0, 1827, '\p{Joining_Group=nun}', "");
    Expect(1, 1827, '\p{^Joining_Group=nun}', "");
    Expect(1, 1827, '\P{Joining_Group=nun}', "");
    Expect(0, 1827, '\P{^Joining_Group=nun}', "");
    Expect(1, 1826, '\p{Joining_Group=:\Anun\z:}', "");;
    Expect(0, 1827, '\p{Joining_Group=:\Anun\z:}', "");;
    Expect(1, 1826, '\p{Joining_Group=- nun}', "");
    Expect(0, 1826, '\p{^Joining_Group=- nun}', "");
    Expect(0, 1826, '\P{Joining_Group=- nun}', "");
    Expect(1, 1826, '\P{^Joining_Group=- nun}', "");
    Expect(0, 1827, '\p{Joining_Group=- nun}', "");
    Expect(1, 1827, '\p{^Joining_Group=- nun}', "");
    Expect(1, 1827, '\P{Joining_Group=- nun}', "");
    Expect(0, 1827, '\P{^Joining_Group=- nun}', "");
    Error('\p{Jg=--Nun:=}');
    Error('\P{Jg=--Nun:=}');
    Expect(1, 1826, '\p{Jg=:\ANun\z:}', "");;
    Expect(0, 1827, '\p{Jg=:\ANun\z:}', "");;
    Expect(1, 1826, '\p{Jg=nun}', "");
    Expect(0, 1826, '\p{^Jg=nun}', "");
    Expect(0, 1826, '\P{Jg=nun}', "");
    Expect(1, 1826, '\P{^Jg=nun}', "");
    Expect(0, 1827, '\p{Jg=nun}', "");
    Expect(1, 1827, '\p{^Jg=nun}', "");
    Expect(1, 1827, '\P{Jg=nun}', "");
    Expect(0, 1827, '\P{^Jg=nun}', "");
    Expect(1, 1826, '\p{Jg=:\Anun\z:}', "");;
    Expect(0, 1827, '\p{Jg=:\Anun\z:}', "");;
    Expect(1, 1826, '\p{Jg=	 NUN}', "");
    Expect(0, 1826, '\p{^Jg=	 NUN}', "");
    Expect(0, 1826, '\P{Jg=	 NUN}', "");
    Expect(1, 1826, '\P{^Jg=	 NUN}', "");
    Expect(0, 1827, '\p{Jg=	 NUN}', "");
    Expect(1, 1827, '\p{^Jg=	 NUN}', "");
    Expect(1, 1827, '\P{Jg=	 NUN}', "");
    Expect(0, 1827, '\P{^Jg=	 NUN}', "");
    Error('\p{Is_Joining_Group=/a/_	NUN}');
    Error('\P{Is_Joining_Group=/a/_	NUN}');
    Expect(1, 1826, '\p{Is_Joining_Group=nun}', "");
    Expect(0, 1826, '\p{^Is_Joining_Group=nun}', "");
    Expect(0, 1826, '\P{Is_Joining_Group=nun}', "");
    Expect(1, 1826, '\P{^Is_Joining_Group=nun}', "");
    Expect(0, 1827, '\p{Is_Joining_Group=nun}', "");
    Expect(1, 1827, '\p{^Is_Joining_Group=nun}', "");
    Expect(1, 1827, '\P{Is_Joining_Group=nun}', "");
    Expect(0, 1827, '\P{^Is_Joining_Group=nun}', "");
    Expect(1, 1826, '\p{Is_Joining_Group=_Nun}', "");
    Expect(0, 1826, '\p{^Is_Joining_Group=_Nun}', "");
    Expect(0, 1826, '\P{Is_Joining_Group=_Nun}', "");
    Expect(1, 1826, '\P{^Is_Joining_Group=_Nun}', "");
    Expect(0, 1827, '\p{Is_Joining_Group=_Nun}', "");
    Expect(1, 1827, '\p{^Is_Joining_Group=_Nun}', "");
    Expect(1, 1827, '\P{Is_Joining_Group=_Nun}', "");
    Expect(0, 1827, '\P{^Is_Joining_Group=_Nun}', "");
    Error('\p{Is_Jg=__Nun/a/}');
    Error('\P{Is_Jg=__Nun/a/}');
    Expect(1, 1826, '\p{Is_Jg=nun}', "");
    Expect(0, 1826, '\p{^Is_Jg=nun}', "");
    Expect(0, 1826, '\P{Is_Jg=nun}', "");
    Expect(1, 1826, '\P{^Is_Jg=nun}', "");
    Expect(0, 1827, '\p{Is_Jg=nun}', "");
    Expect(1, 1827, '\p{^Is_Jg=nun}', "");
    Expect(1, 1827, '\P{Is_Jg=nun}', "");
    Expect(0, 1827, '\P{^Is_Jg=nun}', "");
    Expect(1, 1826, '\p{Is_Jg=	NUN}', "");
    Expect(0, 1826, '\p{^Is_Jg=	NUN}', "");
    Expect(0, 1826, '\P{Is_Jg=	NUN}', "");
    Expect(1, 1826, '\P{^Is_Jg=	NUN}', "");
    Expect(0, 1827, '\p{Is_Jg=	NUN}', "");
    Expect(1, 1827, '\p{^Is_Jg=	NUN}', "");
    Expect(1, 1827, '\P{Is_Jg=	NUN}', "");
    Expect(0, 1827, '\P{^Is_Jg=	NUN}', "");
    Error('\p{Joining_Group=	/a/NYA}');
    Error('\P{Joining_Group=	/a/NYA}');
    Expect(1, 1725, '\p{Joining_Group=:\ANya\z:}', "");;
    Expect(0, 1726, '\p{Joining_Group=:\ANya\z:}', "");;
    Expect(1, 1725, '\p{Joining_Group=nya}', "");
    Expect(0, 1725, '\p{^Joining_Group=nya}', "");
    Expect(0, 1725, '\P{Joining_Group=nya}', "");
    Expect(1, 1725, '\P{^Joining_Group=nya}', "");
    Expect(0, 1726, '\p{Joining_Group=nya}', "");
    Expect(1, 1726, '\p{^Joining_Group=nya}', "");
    Expect(1, 1726, '\P{Joining_Group=nya}', "");
    Expect(0, 1726, '\P{^Joining_Group=nya}', "");
    Expect(1, 1725, '\p{Joining_Group=:\Anya\z:}', "");;
    Expect(0, 1726, '\p{Joining_Group=:\Anya\z:}', "");;
    Expect(1, 1725, '\p{Joining_Group= Nya}', "");
    Expect(0, 1725, '\p{^Joining_Group= Nya}', "");
    Expect(0, 1725, '\P{Joining_Group= Nya}', "");
    Expect(1, 1725, '\P{^Joining_Group= Nya}', "");
    Expect(0, 1726, '\p{Joining_Group= Nya}', "");
    Expect(1, 1726, '\p{^Joining_Group= Nya}', "");
    Expect(1, 1726, '\P{Joining_Group= Nya}', "");
    Expect(0, 1726, '\P{^Joining_Group= Nya}', "");
    Error('\p{Jg: --nya/a/}');
    Error('\P{Jg: --nya/a/}');
    Expect(1, 1725, '\p{Jg=:\ANya\z:}', "");;
    Expect(0, 1726, '\p{Jg=:\ANya\z:}', "");;
    Expect(1, 1725, '\p{Jg=nya}', "");
    Expect(0, 1725, '\p{^Jg=nya}', "");
    Expect(0, 1725, '\P{Jg=nya}', "");
    Expect(1, 1725, '\P{^Jg=nya}', "");
    Expect(0, 1726, '\p{Jg=nya}', "");
    Expect(1, 1726, '\p{^Jg=nya}', "");
    Expect(1, 1726, '\P{Jg=nya}', "");
    Expect(0, 1726, '\P{^Jg=nya}', "");
    Expect(1, 1725, '\p{Jg=:\Anya\z:}', "");;
    Expect(0, 1726, '\p{Jg=:\Anya\z:}', "");;
    Expect(1, 1725, '\p{Jg=- NYA}', "");
    Expect(0, 1725, '\p{^Jg=- NYA}', "");
    Expect(0, 1725, '\P{Jg=- NYA}', "");
    Expect(1, 1725, '\P{^Jg=- NYA}', "");
    Expect(0, 1726, '\p{Jg=- NYA}', "");
    Expect(1, 1726, '\p{^Jg=- NYA}', "");
    Expect(1, 1726, '\P{Jg=- NYA}', "");
    Expect(0, 1726, '\P{^Jg=- NYA}', "");
    Error('\p{Is_Joining_Group=/a/	_nya}');
    Error('\P{Is_Joining_Group=/a/	_nya}');
    Expect(1, 1725, '\p{Is_Joining_Group=nya}', "");
    Expect(0, 1725, '\p{^Is_Joining_Group=nya}', "");
    Expect(0, 1725, '\P{Is_Joining_Group=nya}', "");
    Expect(1, 1725, '\P{^Is_Joining_Group=nya}', "");
    Expect(0, 1726, '\p{Is_Joining_Group=nya}', "");
    Expect(1, 1726, '\p{^Is_Joining_Group=nya}', "");
    Expect(1, 1726, '\P{Is_Joining_Group=nya}', "");
    Expect(0, 1726, '\P{^Is_Joining_Group=nya}', "");
    Expect(1, 1725, '\p{Is_Joining_Group=	NYA}', "");
    Expect(0, 1725, '\p{^Is_Joining_Group=	NYA}', "");
    Expect(0, 1725, '\P{Is_Joining_Group=	NYA}', "");
    Expect(1, 1725, '\P{^Is_Joining_Group=	NYA}', "");
    Expect(0, 1726, '\p{Is_Joining_Group=	NYA}', "");
    Expect(1, 1726, '\p{^Is_Joining_Group=	NYA}', "");
    Expect(1, 1726, '\P{Is_Joining_Group=	NYA}', "");
    Expect(0, 1726, '\P{^Is_Joining_Group=	NYA}', "");
    Error('\p{Is_Jg=/a/-nya}');
    Error('\P{Is_Jg=/a/-nya}');
    Expect(1, 1725, '\p{Is_Jg=nya}', "");
    Expect(0, 1725, '\p{^Is_Jg=nya}', "");
    Expect(0, 1725, '\P{Is_Jg=nya}', "");
    Expect(1, 1725, '\P{^Is_Jg=nya}', "");
    Expect(0, 1726, '\p{Is_Jg=nya}', "");
    Expect(1, 1726, '\p{^Is_Jg=nya}', "");
    Expect(1, 1726, '\P{Is_Jg=nya}', "");
    Expect(0, 1726, '\P{^Is_Jg=nya}', "");
    Expect(1, 1725, '\p{Is_Jg=	Nya}', "");
    Expect(0, 1725, '\p{^Is_Jg=	Nya}', "");
    Expect(0, 1725, '\P{Is_Jg=	Nya}', "");
    Expect(1, 1725, '\P{^Is_Jg=	Nya}', "");
    Expect(0, 1726, '\p{Is_Jg=	Nya}', "");
    Expect(1, 1726, '\p{^Is_Jg=	Nya}', "");
    Expect(1, 1726, '\P{Is_Jg=	Nya}', "");
    Expect(0, 1726, '\P{^Is_Jg=	Nya}', "");
    Error('\p{Joining_Group=/a/ PE}');
    Error('\P{Joining_Group=/a/ PE}');
    Expect(1, 1830, '\p{Joining_Group=:\APe\z:}', "");;
    Expect(0, 1831, '\p{Joining_Group=:\APe\z:}', "");;
    Expect(1, 1830, '\p{Joining_Group:pe}', "");
    Expect(0, 1830, '\p{^Joining_Group:pe}', "");
    Expect(0, 1830, '\P{Joining_Group:pe}', "");
    Expect(1, 1830, '\P{^Joining_Group:pe}', "");
    Expect(0, 1831, '\p{Joining_Group:pe}', "");
    Expect(1, 1831, '\p{^Joining_Group:pe}', "");
    Expect(1, 1831, '\P{Joining_Group:pe}', "");
    Expect(0, 1831, '\P{^Joining_Group:pe}', "");
    Expect(1, 1830, '\p{Joining_Group=:\Ape\z:}', "");;
    Expect(0, 1831, '\p{Joining_Group=:\Ape\z:}', "");;
    Expect(1, 1830, '\p{Joining_Group=	Pe}', "");
    Expect(0, 1830, '\p{^Joining_Group=	Pe}', "");
    Expect(0, 1830, '\P{Joining_Group=	Pe}', "");
    Expect(1, 1830, '\P{^Joining_Group=	Pe}', "");
    Expect(0, 1831, '\p{Joining_Group=	Pe}', "");
    Expect(1, 1831, '\p{^Joining_Group=	Pe}', "");
    Expect(1, 1831, '\P{Joining_Group=	Pe}', "");
    Expect(0, 1831, '\P{^Joining_Group=	Pe}', "");
    Error('\p{Jg=_:=PE}');
    Error('\P{Jg=_:=PE}');
    Expect(1, 1830, '\p{Jg=:\APe\z:}', "");;
    Expect(0, 1831, '\p{Jg=:\APe\z:}', "");;
    Expect(1, 1830, '\p{Jg:   pe}', "");
    Expect(0, 1830, '\p{^Jg:   pe}', "");
    Expect(0, 1830, '\P{Jg:   pe}', "");
    Expect(1, 1830, '\P{^Jg:   pe}', "");
    Expect(0, 1831, '\p{Jg:   pe}', "");
    Expect(1, 1831, '\p{^Jg:   pe}', "");
    Expect(1, 1831, '\P{Jg:   pe}', "");
    Expect(0, 1831, '\P{^Jg:   pe}', "");
    Expect(1, 1830, '\p{Jg=:\Ape\z:}', "");;
    Expect(0, 1831, '\p{Jg=:\Ape\z:}', "");;
    Expect(1, 1830, '\p{Jg=_Pe}', "");
    Expect(0, 1830, '\p{^Jg=_Pe}', "");
    Expect(0, 1830, '\P{Jg=_Pe}', "");
    Expect(1, 1830, '\P{^Jg=_Pe}', "");
    Expect(0, 1831, '\p{Jg=_Pe}', "");
    Expect(1, 1831, '\p{^Jg=_Pe}', "");
    Expect(1, 1831, '\P{Jg=_Pe}', "");
    Expect(0, 1831, '\P{^Jg=_Pe}', "");
    Error('\p{Is_Joining_Group=/a/ PE}');
    Error('\P{Is_Joining_Group=/a/ PE}');
    Expect(1, 1830, '\p{Is_Joining_Group=pe}', "");
    Expect(0, 1830, '\p{^Is_Joining_Group=pe}', "");
    Expect(0, 1830, '\P{Is_Joining_Group=pe}', "");
    Expect(1, 1830, '\P{^Is_Joining_Group=pe}', "");
    Expect(0, 1831, '\p{Is_Joining_Group=pe}', "");
    Expect(1, 1831, '\p{^Is_Joining_Group=pe}', "");
    Expect(1, 1831, '\P{Is_Joining_Group=pe}', "");
    Expect(0, 1831, '\P{^Is_Joining_Group=pe}', "");
    Expect(1, 1830, '\p{Is_Joining_Group=--PE}', "");
    Expect(0, 1830, '\p{^Is_Joining_Group=--PE}', "");
    Expect(0, 1830, '\P{Is_Joining_Group=--PE}', "");
    Expect(1, 1830, '\P{^Is_Joining_Group=--PE}', "");
    Expect(0, 1831, '\p{Is_Joining_Group=--PE}', "");
    Expect(1, 1831, '\p{^Is_Joining_Group=--PE}', "");
    Expect(1, 1831, '\P{Is_Joining_Group=--PE}', "");
    Expect(0, 1831, '\P{^Is_Joining_Group=--PE}', "");
    Error('\p{Is_Jg=:=_Pe}');
    Error('\P{Is_Jg=:=_Pe}');
    Expect(1, 1830, '\p{Is_Jg=pe}', "");
    Expect(0, 1830, '\p{^Is_Jg=pe}', "");
    Expect(0, 1830, '\P{Is_Jg=pe}', "");
    Expect(1, 1830, '\P{^Is_Jg=pe}', "");
    Expect(0, 1831, '\p{Is_Jg=pe}', "");
    Expect(1, 1831, '\p{^Is_Jg=pe}', "");
    Expect(1, 1831, '\P{Is_Jg=pe}', "");
    Expect(0, 1831, '\P{^Is_Jg=pe}', "");
    Expect(1, 1830, '\p{Is_Jg=_PE}', "");
    Expect(0, 1830, '\p{^Is_Jg=_PE}', "");
    Expect(0, 1830, '\P{Is_Jg=_PE}', "");
    Expect(1, 1830, '\P{^Is_Jg=_PE}', "");
    Expect(0, 1831, '\p{Is_Jg=_PE}', "");
    Expect(1, 1831, '\p{^Is_Jg=_PE}', "");
    Expect(1, 1831, '\P{Is_Jg=_PE}', "");
    Expect(0, 1831, '\P{^Is_Jg=_PE}', "");
    Error('\p{Joining_Group=	 QAF:=}');
    Error('\P{Joining_Group=	 QAF:=}');
    Expect(1, 2229, '\p{Joining_Group=:\AQaf\z:}', "");;
    Expect(0, 2230, '\p{Joining_Group=:\AQaf\z:}', "");;
    Expect(1, 2229, '\p{Joining_Group=qaf}', "");
    Expect(0, 2229, '\p{^Joining_Group=qaf}', "");
    Expect(0, 2229, '\P{Joining_Group=qaf}', "");
    Expect(1, 2229, '\P{^Joining_Group=qaf}', "");
    Expect(0, 2230, '\p{Joining_Group=qaf}', "");
    Expect(1, 2230, '\p{^Joining_Group=qaf}', "");
    Expect(1, 2230, '\P{Joining_Group=qaf}', "");
    Expect(0, 2230, '\P{^Joining_Group=qaf}', "");
    Expect(1, 2229, '\p{Joining_Group=:\Aqaf\z:}', "");;
    Expect(0, 2230, '\p{Joining_Group=:\Aqaf\z:}', "");;
    Expect(1, 2229, '\p{Joining_Group=_ QAF}', "");
    Expect(0, 2229, '\p{^Joining_Group=_ QAF}', "");
    Expect(0, 2229, '\P{Joining_Group=_ QAF}', "");
    Expect(1, 2229, '\P{^Joining_Group=_ QAF}', "");
    Expect(0, 2230, '\p{Joining_Group=_ QAF}', "");
    Expect(1, 2230, '\p{^Joining_Group=_ QAF}', "");
    Expect(1, 2230, '\P{Joining_Group=_ QAF}', "");
    Expect(0, 2230, '\P{^Joining_Group=_ QAF}', "");
    Error('\p{Jg=:=Qaf}');
    Error('\P{Jg=:=Qaf}');
    Expect(1, 2229, '\p{Jg=:\AQaf\z:}', "");;
    Expect(0, 2230, '\p{Jg=:\AQaf\z:}', "");;
    Expect(1, 2229, '\p{Jg=qaf}', "");
    Expect(0, 2229, '\p{^Jg=qaf}', "");
    Expect(0, 2229, '\P{Jg=qaf}', "");
    Expect(1, 2229, '\P{^Jg=qaf}', "");
    Expect(0, 2230, '\p{Jg=qaf}', "");
    Expect(1, 2230, '\p{^Jg=qaf}', "");
    Expect(1, 2230, '\P{Jg=qaf}', "");
    Expect(0, 2230, '\P{^Jg=qaf}', "");
    Expect(1, 2229, '\p{Jg=:\Aqaf\z:}', "");;
    Expect(0, 2230, '\p{Jg=:\Aqaf\z:}', "");;
    Error('\p{Is_Joining_Group=/a/-Qaf}');
    Error('\P{Is_Joining_Group=/a/-Qaf}');
    Expect(1, 2229, '\p{Is_Joining_Group=qaf}', "");
    Expect(0, 2229, '\p{^Is_Joining_Group=qaf}', "");
    Expect(0, 2229, '\P{Is_Joining_Group=qaf}', "");
    Expect(1, 2229, '\P{^Is_Joining_Group=qaf}', "");
    Expect(0, 2230, '\p{Is_Joining_Group=qaf}', "");
    Expect(1, 2230, '\p{^Is_Joining_Group=qaf}', "");
    Expect(1, 2230, '\P{Is_Joining_Group=qaf}', "");
    Expect(0, 2230, '\P{^Is_Joining_Group=qaf}', "");
    Expect(1, 2229, '\p{Is_Joining_Group= 	Qaf}', "");
    Expect(0, 2229, '\p{^Is_Joining_Group= 	Qaf}', "");
    Expect(0, 2229, '\P{Is_Joining_Group= 	Qaf}', "");
    Expect(1, 2229, '\P{^Is_Joining_Group= 	Qaf}', "");
    Expect(0, 2230, '\p{Is_Joining_Group= 	Qaf}', "");
    Expect(1, 2230, '\p{^Is_Joining_Group= 	Qaf}', "");
    Expect(1, 2230, '\P{Is_Joining_Group= 	Qaf}', "");
    Expect(0, 2230, '\P{^Is_Joining_Group= 	Qaf}', "");
    Error('\p{Is_Jg= /a/qaf}');
    Error('\P{Is_Jg= /a/qaf}');
    Expect(1, 2229, '\p{Is_Jg=qaf}', "");
    Expect(0, 2229, '\p{^Is_Jg=qaf}', "");
    Expect(0, 2229, '\P{Is_Jg=qaf}', "");
    Expect(1, 2229, '\P{^Is_Jg=qaf}', "");
    Expect(0, 2230, '\p{Is_Jg=qaf}', "");
    Expect(1, 2230, '\p{^Is_Jg=qaf}', "");
    Expect(1, 2230, '\P{Is_Jg=qaf}', "");
    Expect(0, 2230, '\P{^Is_Jg=qaf}', "");
    Expect(1, 2229, '\p{Is_Jg=	Qaf}', "");
    Expect(0, 2229, '\p{^Is_Jg=	Qaf}', "");
    Expect(0, 2229, '\P{Is_Jg=	Qaf}', "");
    Expect(1, 2229, '\P{^Is_Jg=	Qaf}', "");
    Expect(0, 2230, '\p{Is_Jg=	Qaf}', "");
    Expect(1, 2230, '\p{^Is_Jg=	Qaf}', "");
    Expect(1, 2230, '\P{Is_Jg=	Qaf}', "");
    Expect(0, 2230, '\P{^Is_Jg=	Qaf}', "");
    Error('\p{Joining_Group=_:=Qaph}');
    Error('\P{Joining_Group=_:=Qaph}');
    Expect(1, 1833, '\p{Joining_Group=:\AQaph\z:}', "");;
    Expect(0, 1834, '\p{Joining_Group=:\AQaph\z:}', "");;
    Expect(1, 1833, '\p{Joining_Group=qaph}', "");
    Expect(0, 1833, '\p{^Joining_Group=qaph}', "");
    Expect(0, 1833, '\P{Joining_Group=qaph}', "");
    Expect(1, 1833, '\P{^Joining_Group=qaph}', "");
    Expect(0, 1834, '\p{Joining_Group=qaph}', "");
    Expect(1, 1834, '\p{^Joining_Group=qaph}', "");
    Expect(1, 1834, '\P{Joining_Group=qaph}', "");
    Expect(0, 1834, '\P{^Joining_Group=qaph}', "");
    Expect(1, 1833, '\p{Joining_Group=:\Aqaph\z:}', "");;
    Expect(0, 1834, '\p{Joining_Group=:\Aqaph\z:}', "");;
    Expect(1, 1833, '\p{Joining_Group=_Qaph}', "");
    Expect(0, 1833, '\p{^Joining_Group=_Qaph}', "");
    Expect(0, 1833, '\P{Joining_Group=_Qaph}', "");
    Expect(1, 1833, '\P{^Joining_Group=_Qaph}', "");
    Expect(0, 1834, '\p{Joining_Group=_Qaph}', "");
    Expect(1, 1834, '\p{^Joining_Group=_Qaph}', "");
    Expect(1, 1834, '\P{Joining_Group=_Qaph}', "");
    Expect(0, 1834, '\P{^Joining_Group=_Qaph}', "");
    Error('\p{Jg=_:=Qaph}');
    Error('\P{Jg=_:=Qaph}');
    Expect(1, 1833, '\p{Jg=:\AQaph\z:}', "");;
    Expect(0, 1834, '\p{Jg=:\AQaph\z:}', "");;
    Expect(1, 1833, '\p{Jg=qaph}', "");
    Expect(0, 1833, '\p{^Jg=qaph}', "");
    Expect(0, 1833, '\P{Jg=qaph}', "");
    Expect(1, 1833, '\P{^Jg=qaph}', "");
    Expect(0, 1834, '\p{Jg=qaph}', "");
    Expect(1, 1834, '\p{^Jg=qaph}', "");
    Expect(1, 1834, '\P{Jg=qaph}', "");
    Expect(0, 1834, '\P{^Jg=qaph}', "");
    Expect(1, 1833, '\p{Jg=:\Aqaph\z:}', "");;
    Expect(0, 1834, '\p{Jg=:\Aqaph\z:}', "");;
    Expect(1, 1833, '\p{Jg=	QAPH}', "");
    Expect(0, 1833, '\p{^Jg=	QAPH}', "");
    Expect(0, 1833, '\P{Jg=	QAPH}', "");
    Expect(1, 1833, '\P{^Jg=	QAPH}', "");
    Expect(0, 1834, '\p{Jg=	QAPH}', "");
    Expect(1, 1834, '\p{^Jg=	QAPH}', "");
    Expect(1, 1834, '\P{Jg=	QAPH}', "");
    Expect(0, 1834, '\P{^Jg=	QAPH}', "");
    Error('\p{Is_Joining_Group=Qaph:=}');
    Error('\P{Is_Joining_Group=Qaph:=}');
    Expect(1, 1833, '\p{Is_Joining_Group=qaph}', "");
    Expect(0, 1833, '\p{^Is_Joining_Group=qaph}', "");
    Expect(0, 1833, '\P{Is_Joining_Group=qaph}', "");
    Expect(1, 1833, '\P{^Is_Joining_Group=qaph}', "");
    Expect(0, 1834, '\p{Is_Joining_Group=qaph}', "");
    Expect(1, 1834, '\p{^Is_Joining_Group=qaph}', "");
    Expect(1, 1834, '\P{Is_Joining_Group=qaph}', "");
    Expect(0, 1834, '\P{^Is_Joining_Group=qaph}', "");
    Expect(1, 1833, '\p{Is_Joining_Group=-QAPH}', "");
    Expect(0, 1833, '\p{^Is_Joining_Group=-QAPH}', "");
    Expect(0, 1833, '\P{Is_Joining_Group=-QAPH}', "");
    Expect(1, 1833, '\P{^Is_Joining_Group=-QAPH}', "");
    Expect(0, 1834, '\p{Is_Joining_Group=-QAPH}', "");
    Expect(1, 1834, '\p{^Is_Joining_Group=-QAPH}', "");
    Expect(1, 1834, '\P{Is_Joining_Group=-QAPH}', "");
    Expect(0, 1834, '\P{^Is_Joining_Group=-QAPH}', "");
    Error('\p{Is_Jg=__qaph/a/}');
    Error('\P{Is_Jg=__qaph/a/}');
    Expect(1, 1833, '\p{Is_Jg:   qaph}', "");
    Expect(0, 1833, '\p{^Is_Jg:   qaph}', "");
    Expect(0, 1833, '\P{Is_Jg:   qaph}', "");
    Expect(1, 1833, '\P{^Is_Jg:   qaph}', "");
    Expect(0, 1834, '\p{Is_Jg:   qaph}', "");
    Expect(1, 1834, '\p{^Is_Jg:   qaph}', "");
    Expect(1, 1834, '\P{Is_Jg:   qaph}', "");
    Expect(0, 1834, '\P{^Is_Jg:   qaph}', "");
    Expect(1, 1833, '\p{Is_Jg=__qaph}', "");
    Expect(0, 1833, '\p{^Is_Jg=__qaph}', "");
    Expect(0, 1833, '\P{Is_Jg=__qaph}', "");
    Expect(1, 1833, '\P{^Is_Jg=__qaph}', "");
    Expect(0, 1834, '\p{Is_Jg=__qaph}', "");
    Expect(1, 1834, '\p{^Is_Jg=__qaph}', "");
    Expect(1, 1834, '\P{Is_Jg=__qaph}', "");
    Expect(0, 1834, '\P{^Is_Jg=__qaph}', "");
    Error('\p{Joining_Group=-:=reh}');
    Error('\P{Joining_Group=-:=reh}');
    Expect(1, 2233, '\p{Joining_Group=:\AReh\z:}', "");;
    Expect(0, 2234, '\p{Joining_Group=:\AReh\z:}', "");;
    Expect(1, 2233, '\p{Joining_Group=reh}', "");
    Expect(0, 2233, '\p{^Joining_Group=reh}', "");
    Expect(0, 2233, '\P{Joining_Group=reh}', "");
    Expect(1, 2233, '\P{^Joining_Group=reh}', "");
    Expect(0, 2234, '\p{Joining_Group=reh}', "");
    Expect(1, 2234, '\p{^Joining_Group=reh}', "");
    Expect(1, 2234, '\P{Joining_Group=reh}', "");
    Expect(0, 2234, '\P{^Joining_Group=reh}', "");
    Expect(1, 2233, '\p{Joining_Group=:\Areh\z:}', "");;
    Expect(0, 2234, '\p{Joining_Group=:\Areh\z:}', "");;
    Expect(1, 2233, '\p{Joining_Group= 	Reh}', "");
    Expect(0, 2233, '\p{^Joining_Group= 	Reh}', "");
    Expect(0, 2233, '\P{Joining_Group= 	Reh}', "");
    Expect(1, 2233, '\P{^Joining_Group= 	Reh}', "");
    Expect(0, 2234, '\p{Joining_Group= 	Reh}', "");
    Expect(1, 2234, '\p{^Joining_Group= 	Reh}', "");
    Expect(1, 2234, '\P{Joining_Group= 	Reh}', "");
    Expect(0, 2234, '\P{^Joining_Group= 	Reh}', "");
    Error('\p{Jg=	Reh/a/}');
    Error('\P{Jg=	Reh/a/}');
    Expect(1, 2233, '\p{Jg=:\AReh\z:}', "");;
    Expect(0, 2234, '\p{Jg=:\AReh\z:}', "");;
    Expect(1, 2233, '\p{Jg=reh}', "");
    Expect(0, 2233, '\p{^Jg=reh}', "");
    Expect(0, 2233, '\P{Jg=reh}', "");
    Expect(1, 2233, '\P{^Jg=reh}', "");
    Expect(0, 2234, '\p{Jg=reh}', "");
    Expect(1, 2234, '\p{^Jg=reh}', "");
    Expect(1, 2234, '\P{Jg=reh}', "");
    Expect(0, 2234, '\P{^Jg=reh}', "");
    Expect(1, 2233, '\p{Jg=:\Areh\z:}', "");;
    Expect(0, 2234, '\p{Jg=:\Areh\z:}', "");;
    Expect(1, 2233, '\p{Jg= Reh}', "");
    Expect(0, 2233, '\p{^Jg= Reh}', "");
    Expect(0, 2233, '\P{Jg= Reh}', "");
    Expect(1, 2233, '\P{^Jg= Reh}', "");
    Expect(0, 2234, '\p{Jg= Reh}', "");
    Expect(1, 2234, '\p{^Jg= Reh}', "");
    Expect(1, 2234, '\P{Jg= Reh}', "");
    Expect(0, 2234, '\P{^Jg= Reh}', "");
    Error('\p{Is_Joining_Group=		REH:=}');
    Error('\P{Is_Joining_Group=		REH:=}');
    Expect(1, 2233, '\p{Is_Joining_Group=reh}', "");
    Expect(0, 2233, '\p{^Is_Joining_Group=reh}', "");
    Expect(0, 2233, '\P{Is_Joining_Group=reh}', "");
    Expect(1, 2233, '\P{^Is_Joining_Group=reh}', "");
    Expect(0, 2234, '\p{Is_Joining_Group=reh}', "");
    Expect(1, 2234, '\p{^Is_Joining_Group=reh}', "");
    Expect(1, 2234, '\P{Is_Joining_Group=reh}', "");
    Expect(0, 2234, '\P{^Is_Joining_Group=reh}', "");
    Expect(1, 2233, '\p{Is_Joining_Group=-REH}', "");
    Expect(0, 2233, '\p{^Is_Joining_Group=-REH}', "");
    Expect(0, 2233, '\P{Is_Joining_Group=-REH}', "");
    Expect(1, 2233, '\P{^Is_Joining_Group=-REH}', "");
    Expect(0, 2234, '\p{Is_Joining_Group=-REH}', "");
    Expect(1, 2234, '\p{^Is_Joining_Group=-REH}', "");
    Expect(1, 2234, '\P{Is_Joining_Group=-REH}', "");
    Expect(0, 2234, '\P{^Is_Joining_Group=-REH}', "");
    Error('\p{Is_Jg=:=-REH}');
    Error('\P{Is_Jg=:=-REH}');
    Expect(1, 2233, '\p{Is_Jg=reh}', "");
    Expect(0, 2233, '\p{^Is_Jg=reh}', "");
    Expect(0, 2233, '\P{Is_Jg=reh}', "");
    Expect(1, 2233, '\P{^Is_Jg=reh}', "");
    Expect(0, 2234, '\p{Is_Jg=reh}', "");
    Expect(1, 2234, '\p{^Is_Jg=reh}', "");
    Expect(1, 2234, '\P{Is_Jg=reh}', "");
    Expect(0, 2234, '\P{^Is_Jg=reh}', "");
    Expect(1, 2233, '\p{Is_Jg= -REH}', "");
    Expect(0, 2233, '\p{^Is_Jg= -REH}', "");
    Expect(0, 2233, '\P{Is_Jg= -REH}', "");
    Expect(1, 2233, '\P{^Is_Jg= -REH}', "");
    Expect(0, 2234, '\p{Is_Jg= -REH}', "");
    Expect(1, 2234, '\p{^Is_Jg= -REH}', "");
    Expect(1, 2234, '\P{Is_Jg= -REH}', "");
    Expect(0, 2234, '\P{^Is_Jg= -REH}', "");
    Error('\p{Joining_Group=- Reversed_PE:=}');
    Error('\P{Joining_Group=- Reversed_PE:=}');
    Expect(1, 1831, '\p{Joining_Group=:\AReversed_Pe\z:}', "");;
    Expect(0, 1832, '\p{Joining_Group=:\AReversed_Pe\z:}', "");;
    Expect(1, 1831, '\p{Joining_Group=reversedpe}', "");
    Expect(0, 1831, '\p{^Joining_Group=reversedpe}', "");
    Expect(0, 1831, '\P{Joining_Group=reversedpe}', "");
    Expect(1, 1831, '\P{^Joining_Group=reversedpe}', "");
    Expect(0, 1832, '\p{Joining_Group=reversedpe}', "");
    Expect(1, 1832, '\p{^Joining_Group=reversedpe}', "");
    Expect(1, 1832, '\P{Joining_Group=reversedpe}', "");
    Expect(0, 1832, '\P{^Joining_Group=reversedpe}', "");
    Expect(1, 1831, '\p{Joining_Group=:\Areversedpe\z:}', "");;
    Expect(0, 1832, '\p{Joining_Group=:\Areversedpe\z:}', "");;
    Expect(1, 1831, '\p{Joining_Group:    Reversed_PE}', "");
    Expect(0, 1831, '\p{^Joining_Group:    Reversed_PE}', "");
    Expect(0, 1831, '\P{Joining_Group:    Reversed_PE}', "");
    Expect(1, 1831, '\P{^Joining_Group:    Reversed_PE}', "");
    Expect(0, 1832, '\p{Joining_Group:    Reversed_PE}', "");
    Expect(1, 1832, '\p{^Joining_Group:    Reversed_PE}', "");
    Expect(1, 1832, '\P{Joining_Group:    Reversed_PE}', "");
    Expect(0, 1832, '\P{^Joining_Group:    Reversed_PE}', "");
    Error('\p{Jg=/a/Reversed_PE}');
    Error('\P{Jg=/a/Reversed_PE}');
    Expect(1, 1831, '\p{Jg=:\AReversed_Pe\z:}', "");;
    Expect(0, 1832, '\p{Jg=:\AReversed_Pe\z:}', "");;
    Expect(1, 1831, '\p{Jg=reversedpe}', "");
    Expect(0, 1831, '\p{^Jg=reversedpe}', "");
    Expect(0, 1831, '\P{Jg=reversedpe}', "");
    Expect(1, 1831, '\P{^Jg=reversedpe}', "");
    Expect(0, 1832, '\p{Jg=reversedpe}', "");
    Expect(1, 1832, '\p{^Jg=reversedpe}', "");
    Expect(1, 1832, '\P{Jg=reversedpe}', "");
    Expect(0, 1832, '\P{^Jg=reversedpe}', "");
    Expect(1, 1831, '\p{Jg=:\Areversedpe\z:}', "");;
    Expect(0, 1832, '\p{Jg=:\Areversedpe\z:}', "");;
    Expect(1, 1831, '\p{Jg=_	reversed_PE}', "");
    Expect(0, 1831, '\p{^Jg=_	reversed_PE}', "");
    Expect(0, 1831, '\P{Jg=_	reversed_PE}', "");
    Expect(1, 1831, '\P{^Jg=_	reversed_PE}', "");
    Expect(0, 1832, '\p{Jg=_	reversed_PE}', "");
    Expect(1, 1832, '\p{^Jg=_	reversed_PE}', "");
    Expect(1, 1832, '\P{Jg=_	reversed_PE}', "");
    Expect(0, 1832, '\P{^Jg=_	reversed_PE}', "");
    Error('\p{Is_Joining_Group: /a/-Reversed_Pe}');
    Error('\P{Is_Joining_Group: /a/-Reversed_Pe}');
    Expect(1, 1831, '\p{Is_Joining_Group=reversedpe}', "");
    Expect(0, 1831, '\p{^Is_Joining_Group=reversedpe}', "");
    Expect(0, 1831, '\P{Is_Joining_Group=reversedpe}', "");
    Expect(1, 1831, '\P{^Is_Joining_Group=reversedpe}', "");
    Expect(0, 1832, '\p{Is_Joining_Group=reversedpe}', "");
    Expect(1, 1832, '\p{^Is_Joining_Group=reversedpe}', "");
    Expect(1, 1832, '\P{Is_Joining_Group=reversedpe}', "");
    Expect(0, 1832, '\P{^Is_Joining_Group=reversedpe}', "");
    Expect(1, 1831, '\p{Is_Joining_Group=_reversed_Pe}', "");
    Expect(0, 1831, '\p{^Is_Joining_Group=_reversed_Pe}', "");
    Expect(0, 1831, '\P{Is_Joining_Group=_reversed_Pe}', "");
    Expect(1, 1831, '\P{^Is_Joining_Group=_reversed_Pe}', "");
    Expect(0, 1832, '\p{Is_Joining_Group=_reversed_Pe}', "");
    Expect(1, 1832, '\p{^Is_Joining_Group=_reversed_Pe}', "");
    Expect(1, 1832, '\P{Is_Joining_Group=_reversed_Pe}', "");
    Expect(0, 1832, '\P{^Is_Joining_Group=_reversed_Pe}', "");
    Error('\p{Is_Jg=/a/ _Reversed_pe}');
    Error('\P{Is_Jg=/a/ _Reversed_pe}');
    Expect(1, 1831, '\p{Is_Jg=reversedpe}', "");
    Expect(0, 1831, '\p{^Is_Jg=reversedpe}', "");
    Expect(0, 1831, '\P{Is_Jg=reversedpe}', "");
    Expect(1, 1831, '\P{^Is_Jg=reversedpe}', "");
    Expect(0, 1832, '\p{Is_Jg=reversedpe}', "");
    Expect(1, 1832, '\p{^Is_Jg=reversedpe}', "");
    Expect(1, 1832, '\P{Is_Jg=reversedpe}', "");
    Expect(0, 1832, '\P{^Is_Jg=reversedpe}', "");
    Expect(1, 1831, '\p{Is_Jg=--reversed_Pe}', "");
    Expect(0, 1831, '\p{^Is_Jg=--reversed_Pe}', "");
    Expect(0, 1831, '\P{Is_Jg=--reversed_Pe}', "");
    Expect(1, 1831, '\P{^Is_Jg=--reversed_Pe}', "");
    Expect(0, 1832, '\p{Is_Jg=--reversed_Pe}', "");
    Expect(1, 1832, '\p{^Is_Jg=--reversed_Pe}', "");
    Expect(1, 1832, '\P{Is_Jg=--reversed_Pe}', "");
    Expect(0, 1832, '\P{^Is_Jg=--reversed_Pe}', "");
    Error('\p{Joining_Group=:=Rohingya_yeh}');
    Error('\P{Joining_Group=:=Rohingya_yeh}');
    Expect(1, 2220, '\p{Joining_Group=:\ARohingya_Yeh\z:}', "");;
    Expect(0, 2221, '\p{Joining_Group=:\ARohingya_Yeh\z:}', "");;
    Expect(1, 2220, '\p{Joining_Group=rohingyayeh}', "");
    Expect(0, 2220, '\p{^Joining_Group=rohingyayeh}', "");
    Expect(0, 2220, '\P{Joining_Group=rohingyayeh}', "");
    Expect(1, 2220, '\P{^Joining_Group=rohingyayeh}', "");
    Expect(0, 2221, '\p{Joining_Group=rohingyayeh}', "");
    Expect(1, 2221, '\p{^Joining_Group=rohingyayeh}', "");
    Expect(1, 2221, '\P{Joining_Group=rohingyayeh}', "");
    Expect(0, 2221, '\P{^Joining_Group=rohingyayeh}', "");
    Expect(1, 2220, '\p{Joining_Group=:\Arohingyayeh\z:}', "");;
    Expect(0, 2221, '\p{Joining_Group=:\Arohingyayeh\z:}', "");;
    Expect(1, 2220, '\p{Joining_Group=	_Rohingya_yeh}', "");
    Expect(0, 2220, '\p{^Joining_Group=	_Rohingya_yeh}', "");
    Expect(0, 2220, '\P{Joining_Group=	_Rohingya_yeh}', "");
    Expect(1, 2220, '\P{^Joining_Group=	_Rohingya_yeh}', "");
    Expect(0, 2221, '\p{Joining_Group=	_Rohingya_yeh}', "");
    Expect(1, 2221, '\p{^Joining_Group=	_Rohingya_yeh}', "");
    Expect(1, 2221, '\P{Joining_Group=	_Rohingya_yeh}', "");
    Expect(0, 2221, '\P{^Joining_Group=	_Rohingya_yeh}', "");
    Error('\p{Jg=	 Rohingya_YEH:=}');
    Error('\P{Jg=	 Rohingya_YEH:=}');
    Expect(1, 2220, '\p{Jg=:\ARohingya_Yeh\z:}', "");;
    Expect(0, 2221, '\p{Jg=:\ARohingya_Yeh\z:}', "");;
    Expect(1, 2220, '\p{Jg=rohingyayeh}', "");
    Expect(0, 2220, '\p{^Jg=rohingyayeh}', "");
    Expect(0, 2220, '\P{Jg=rohingyayeh}', "");
    Expect(1, 2220, '\P{^Jg=rohingyayeh}', "");
    Expect(0, 2221, '\p{Jg=rohingyayeh}', "");
    Expect(1, 2221, '\p{^Jg=rohingyayeh}', "");
    Expect(1, 2221, '\P{Jg=rohingyayeh}', "");
    Expect(0, 2221, '\P{^Jg=rohingyayeh}', "");
    Expect(1, 2220, '\p{Jg=:\Arohingyayeh\z:}', "");;
    Expect(0, 2221, '\p{Jg=:\Arohingyayeh\z:}', "");;
    Expect(1, 2220, '\p{Jg=_	rohingya_yeh}', "");
    Expect(0, 2220, '\p{^Jg=_	rohingya_yeh}', "");
    Expect(0, 2220, '\P{Jg=_	rohingya_yeh}', "");
    Expect(1, 2220, '\P{^Jg=_	rohingya_yeh}', "");
    Expect(0, 2221, '\p{Jg=_	rohingya_yeh}', "");
    Expect(1, 2221, '\p{^Jg=_	rohingya_yeh}', "");
    Expect(1, 2221, '\P{Jg=_	rohingya_yeh}', "");
    Expect(0, 2221, '\P{^Jg=_	rohingya_yeh}', "");
    Error('\p{Is_Joining_Group=:=ROHINGYA_YEH}');
    Error('\P{Is_Joining_Group=:=ROHINGYA_YEH}');
    Expect(1, 2220, '\p{Is_Joining_Group=rohingyayeh}', "");
    Expect(0, 2220, '\p{^Is_Joining_Group=rohingyayeh}', "");
    Expect(0, 2220, '\P{Is_Joining_Group=rohingyayeh}', "");
    Expect(1, 2220, '\P{^Is_Joining_Group=rohingyayeh}', "");
    Expect(0, 2221, '\p{Is_Joining_Group=rohingyayeh}', "");
    Expect(1, 2221, '\p{^Is_Joining_Group=rohingyayeh}', "");
    Expect(1, 2221, '\P{Is_Joining_Group=rohingyayeh}', "");
    Expect(0, 2221, '\P{^Is_Joining_Group=rohingyayeh}', "");
    Expect(1, 2220, '\p{Is_Joining_Group=-	Rohingya_YEH}', "");
    Expect(0, 2220, '\p{^Is_Joining_Group=-	Rohingya_YEH}', "");
    Expect(0, 2220, '\P{Is_Joining_Group=-	Rohingya_YEH}', "");
    Expect(1, 2220, '\P{^Is_Joining_Group=-	Rohingya_YEH}', "");
    Expect(0, 2221, '\p{Is_Joining_Group=-	Rohingya_YEH}', "");
    Expect(1, 2221, '\p{^Is_Joining_Group=-	Rohingya_YEH}', "");
    Expect(1, 2221, '\P{Is_Joining_Group=-	Rohingya_YEH}', "");
    Expect(0, 2221, '\P{^Is_Joining_Group=-	Rohingya_YEH}', "");
    Error('\p{Is_Jg:-/a/ROHINGYA_Yeh}');
    Error('\P{Is_Jg:-/a/ROHINGYA_Yeh}');
    Expect(1, 2220, '\p{Is_Jg=rohingyayeh}', "");
    Expect(0, 2220, '\p{^Is_Jg=rohingyayeh}', "");
    Expect(0, 2220, '\P{Is_Jg=rohingyayeh}', "");
    Expect(1, 2220, '\P{^Is_Jg=rohingyayeh}', "");
    Expect(0, 2221, '\p{Is_Jg=rohingyayeh}', "");
    Expect(1, 2221, '\p{^Is_Jg=rohingyayeh}', "");
    Expect(1, 2221, '\P{Is_Jg=rohingyayeh}', "");
    Expect(0, 2221, '\P{^Is_Jg=rohingyayeh}', "");
    Expect(1, 2220, '\p{Is_Jg= _Rohingya_YEH}', "");
    Expect(0, 2220, '\p{^Is_Jg= _Rohingya_YEH}', "");
    Expect(0, 2220, '\P{Is_Jg= _Rohingya_YEH}', "");
    Expect(1, 2220, '\P{^Is_Jg= _Rohingya_YEH}', "");
    Expect(0, 2221, '\p{Is_Jg= _Rohingya_YEH}', "");
    Expect(1, 2221, '\p{^Is_Jg= _Rohingya_YEH}', "");
    Expect(1, 2221, '\P{Is_Jg= _Rohingya_YEH}', "");
    Expect(0, 2221, '\P{^Is_Jg= _Rohingya_YEH}', "");
    Error('\p{Joining_Group=:=	_SAD}');
    Error('\P{Joining_Group=:=	_SAD}');
    Expect(1, 2223, '\p{Joining_Group=:\ASad\z:}', "");;
    Expect(0, 2224, '\p{Joining_Group=:\ASad\z:}', "");;
    Expect(1, 2223, '\p{Joining_Group=sad}', "");
    Expect(0, 2223, '\p{^Joining_Group=sad}', "");
    Expect(0, 2223, '\P{Joining_Group=sad}', "");
    Expect(1, 2223, '\P{^Joining_Group=sad}', "");
    Expect(0, 2224, '\p{Joining_Group=sad}', "");
    Expect(1, 2224, '\p{^Joining_Group=sad}', "");
    Expect(1, 2224, '\P{Joining_Group=sad}', "");
    Expect(0, 2224, '\P{^Joining_Group=sad}', "");
    Expect(1, 2223, '\p{Joining_Group=:\Asad\z:}', "");;
    Expect(0, 2224, '\p{Joining_Group=:\Asad\z:}', "");;
    Expect(1, 2223, '\p{Joining_Group=	Sad}', "");
    Expect(0, 2223, '\p{^Joining_Group=	Sad}', "");
    Expect(0, 2223, '\P{Joining_Group=	Sad}', "");
    Expect(1, 2223, '\P{^Joining_Group=	Sad}', "");
    Expect(0, 2224, '\p{Joining_Group=	Sad}', "");
    Expect(1, 2224, '\p{^Joining_Group=	Sad}', "");
    Expect(1, 2224, '\P{Joining_Group=	Sad}', "");
    Expect(0, 2224, '\P{^Joining_Group=	Sad}', "");
    Error('\p{Jg=/a/_	sad}');
    Error('\P{Jg=/a/_	sad}');
    Expect(1, 2223, '\p{Jg=:\ASad\z:}', "");;
    Expect(0, 2224, '\p{Jg=:\ASad\z:}', "");;
    Expect(1, 2223, '\p{Jg=sad}', "");
    Expect(0, 2223, '\p{^Jg=sad}', "");
    Expect(0, 2223, '\P{Jg=sad}', "");
    Expect(1, 2223, '\P{^Jg=sad}', "");
    Expect(0, 2224, '\p{Jg=sad}', "");
    Expect(1, 2224, '\p{^Jg=sad}', "");
    Expect(1, 2224, '\P{Jg=sad}', "");
    Expect(0, 2224, '\P{^Jg=sad}', "");
    Expect(1, 2223, '\p{Jg=:\Asad\z:}', "");;
    Expect(0, 2224, '\p{Jg=:\Asad\z:}', "");;
    Expect(1, 2223, '\p{Jg=	Sad}', "");
    Expect(0, 2223, '\p{^Jg=	Sad}', "");
    Expect(0, 2223, '\P{Jg=	Sad}', "");
    Expect(1, 2223, '\P{^Jg=	Sad}', "");
    Expect(0, 2224, '\p{Jg=	Sad}', "");
    Expect(1, 2224, '\p{^Jg=	Sad}', "");
    Expect(1, 2224, '\P{Jg=	Sad}', "");
    Expect(0, 2224, '\P{^Jg=	Sad}', "");
    Error('\p{Is_Joining_Group= Sad/a/}');
    Error('\P{Is_Joining_Group= Sad/a/}');
    Expect(1, 2223, '\p{Is_Joining_Group=sad}', "");
    Expect(0, 2223, '\p{^Is_Joining_Group=sad}', "");
    Expect(0, 2223, '\P{Is_Joining_Group=sad}', "");
    Expect(1, 2223, '\P{^Is_Joining_Group=sad}', "");
    Expect(0, 2224, '\p{Is_Joining_Group=sad}', "");
    Expect(1, 2224, '\p{^Is_Joining_Group=sad}', "");
    Expect(1, 2224, '\P{Is_Joining_Group=sad}', "");
    Expect(0, 2224, '\P{^Is_Joining_Group=sad}', "");
    Expect(1, 2223, '\p{Is_Joining_Group= Sad}', "");
    Expect(0, 2223, '\p{^Is_Joining_Group= Sad}', "");
    Expect(0, 2223, '\P{Is_Joining_Group= Sad}', "");
    Expect(1, 2223, '\P{^Is_Joining_Group= Sad}', "");
    Expect(0, 2224, '\p{Is_Joining_Group= Sad}', "");
    Expect(1, 2224, '\p{^Is_Joining_Group= Sad}', "");
    Expect(1, 2224, '\P{Is_Joining_Group= Sad}', "");
    Expect(0, 2224, '\P{^Is_Joining_Group= Sad}', "");
    Error('\p{Is_Jg= sad/a/}');
    Error('\P{Is_Jg= sad/a/}');
    Expect(1, 2223, '\p{Is_Jg:   sad}', "");
    Expect(0, 2223, '\p{^Is_Jg:   sad}', "");
    Expect(0, 2223, '\P{Is_Jg:   sad}', "");
    Expect(1, 2223, '\P{^Is_Jg:   sad}', "");
    Expect(0, 2224, '\p{Is_Jg:   sad}', "");
    Expect(1, 2224, '\p{^Is_Jg:   sad}', "");
    Expect(1, 2224, '\P{Is_Jg:   sad}', "");
    Expect(0, 2224, '\P{^Is_Jg:   sad}', "");
    Expect(1, 2223, '\p{Is_Jg=	sad}', "");
    Expect(0, 2223, '\p{^Is_Jg=	sad}', "");
    Expect(0, 2223, '\P{Is_Jg=	sad}', "");
    Expect(1, 2223, '\P{^Is_Jg=	sad}', "");
    Expect(0, 2224, '\p{Is_Jg=	sad}', "");
    Expect(1, 2224, '\p{^Is_Jg=	sad}', "");
    Expect(1, 2224, '\P{Is_Jg=	sad}', "");
    Expect(0, 2224, '\P{^Is_Jg=	sad}', "");
    Error('\p{Joining_Group= :=Sadhe}');
    Error('\P{Joining_Group= :=Sadhe}');
    Expect(1, 1832, '\p{Joining_Group=:\ASadhe\z:}', "");;
    Expect(0, 1833, '\p{Joining_Group=:\ASadhe\z:}', "");;
    Expect(1, 1832, '\p{Joining_Group:	sadhe}', "");
    Expect(0, 1832, '\p{^Joining_Group:	sadhe}', "");
    Expect(0, 1832, '\P{Joining_Group:	sadhe}', "");
    Expect(1, 1832, '\P{^Joining_Group:	sadhe}', "");
    Expect(0, 1833, '\p{Joining_Group:	sadhe}', "");
    Expect(1, 1833, '\p{^Joining_Group:	sadhe}', "");
    Expect(1, 1833, '\P{Joining_Group:	sadhe}', "");
    Expect(0, 1833, '\P{^Joining_Group:	sadhe}', "");
    Expect(1, 1832, '\p{Joining_Group=:\Asadhe\z:}', "");;
    Expect(0, 1833, '\p{Joining_Group=:\Asadhe\z:}', "");;
    Expect(1, 1832, '\p{Joining_Group= _Sadhe}', "");
    Expect(0, 1832, '\p{^Joining_Group= _Sadhe}', "");
    Expect(0, 1832, '\P{Joining_Group= _Sadhe}', "");
    Expect(1, 1832, '\P{^Joining_Group= _Sadhe}', "");
    Expect(0, 1833, '\p{Joining_Group= _Sadhe}', "");
    Expect(1, 1833, '\p{^Joining_Group= _Sadhe}', "");
    Expect(1, 1833, '\P{Joining_Group= _Sadhe}', "");
    Expect(0, 1833, '\P{^Joining_Group= _Sadhe}', "");
    Error('\p{Jg=/a/ Sadhe}');
    Error('\P{Jg=/a/ Sadhe}');
    Expect(1, 1832, '\p{Jg=:\ASadhe\z:}', "");;
    Expect(0, 1833, '\p{Jg=:\ASadhe\z:}', "");;
    Expect(1, 1832, '\p{Jg=sadhe}', "");
    Expect(0, 1832, '\p{^Jg=sadhe}', "");
    Expect(0, 1832, '\P{Jg=sadhe}', "");
    Expect(1, 1832, '\P{^Jg=sadhe}', "");
    Expect(0, 1833, '\p{Jg=sadhe}', "");
    Expect(1, 1833, '\p{^Jg=sadhe}', "");
    Expect(1, 1833, '\P{Jg=sadhe}', "");
    Expect(0, 1833, '\P{^Jg=sadhe}', "");
    Expect(1, 1832, '\p{Jg=:\Asadhe\z:}', "");;
    Expect(0, 1833, '\p{Jg=:\Asadhe\z:}', "");;
    Expect(1, 1832, '\p{Jg=		sadhe}', "");
    Expect(0, 1832, '\p{^Jg=		sadhe}', "");
    Expect(0, 1832, '\P{Jg=		sadhe}', "");
    Expect(1, 1832, '\P{^Jg=		sadhe}', "");
    Expect(0, 1833, '\p{Jg=		sadhe}', "");
    Expect(1, 1833, '\p{^Jg=		sadhe}', "");
    Expect(1, 1833, '\P{Jg=		sadhe}', "");
    Expect(0, 1833, '\P{^Jg=		sadhe}', "");
    Error('\p{Is_Joining_Group=	-sadhe:=}');
    Error('\P{Is_Joining_Group=	-sadhe:=}');
    Expect(1, 1832, '\p{Is_Joining_Group=sadhe}', "");
    Expect(0, 1832, '\p{^Is_Joining_Group=sadhe}', "");
    Expect(0, 1832, '\P{Is_Joining_Group=sadhe}', "");
    Expect(1, 1832, '\P{^Is_Joining_Group=sadhe}', "");
    Expect(0, 1833, '\p{Is_Joining_Group=sadhe}', "");
    Expect(1, 1833, '\p{^Is_Joining_Group=sadhe}', "");
    Expect(1, 1833, '\P{Is_Joining_Group=sadhe}', "");
    Expect(0, 1833, '\P{^Is_Joining_Group=sadhe}', "");
    Expect(1, 1832, '\p{Is_Joining_Group=-Sadhe}', "");
    Expect(0, 1832, '\p{^Is_Joining_Group=-Sadhe}', "");
    Expect(0, 1832, '\P{Is_Joining_Group=-Sadhe}', "");
    Expect(1, 1832, '\P{^Is_Joining_Group=-Sadhe}', "");
    Expect(0, 1833, '\p{Is_Joining_Group=-Sadhe}', "");
    Expect(1, 1833, '\p{^Is_Joining_Group=-Sadhe}', "");
    Expect(1, 1833, '\P{Is_Joining_Group=-Sadhe}', "");
    Expect(0, 1833, '\P{^Is_Joining_Group=-Sadhe}', "");
    Error('\p{Is_Jg=	/a/SADHE}');
    Error('\P{Is_Jg=	/a/SADHE}');
    Expect(1, 1832, '\p{Is_Jg=sadhe}', "");
    Expect(0, 1832, '\p{^Is_Jg=sadhe}', "");
    Expect(0, 1832, '\P{Is_Jg=sadhe}', "");
    Expect(1, 1832, '\P{^Is_Jg=sadhe}', "");
    Expect(0, 1833, '\p{Is_Jg=sadhe}', "");
    Expect(1, 1833, '\p{^Is_Jg=sadhe}', "");
    Expect(1, 1833, '\P{Is_Jg=sadhe}', "");
    Expect(0, 1833, '\P{^Is_Jg=sadhe}', "");
    Expect(1, 1832, '\p{Is_Jg:    Sadhe}', "");
    Expect(0, 1832, '\p{^Is_Jg:    Sadhe}', "");
    Expect(0, 1832, '\P{Is_Jg:    Sadhe}', "");
    Expect(1, 1832, '\P{^Is_Jg:    Sadhe}', "");
    Expect(0, 1833, '\p{Is_Jg:    Sadhe}', "");
    Expect(1, 1833, '\p{^Is_Jg:    Sadhe}', "");
    Expect(1, 1833, '\P{Is_Jg:    Sadhe}', "");
    Expect(0, 1833, '\P{^Is_Jg:    Sadhe}', "");
    Error('\p{Joining_Group=/a/Seen}');
    Error('\P{Joining_Group=/a/Seen}');
    Expect(1, 1918, '\p{Joining_Group=:\ASeen\z:}', "");;
    Expect(0, 1919, '\p{Joining_Group=:\ASeen\z:}', "");;
    Expect(1, 1918, '\p{Joining_Group=seen}', "");
    Expect(0, 1918, '\p{^Joining_Group=seen}', "");
    Expect(0, 1918, '\P{Joining_Group=seen}', "");
    Expect(1, 1918, '\P{^Joining_Group=seen}', "");
    Expect(0, 1919, '\p{Joining_Group=seen}', "");
    Expect(1, 1919, '\p{^Joining_Group=seen}', "");
    Expect(1, 1919, '\P{Joining_Group=seen}', "");
    Expect(0, 1919, '\P{^Joining_Group=seen}', "");
    Expect(1, 1918, '\p{Joining_Group=:\Aseen\z:}', "");;
    Expect(0, 1919, '\p{Joining_Group=:\Aseen\z:}', "");;
    Expect(1, 1918, '\p{Joining_Group=  SEEN}', "");
    Expect(0, 1918, '\p{^Joining_Group=  SEEN}', "");
    Expect(0, 1918, '\P{Joining_Group=  SEEN}', "");
    Expect(1, 1918, '\P{^Joining_Group=  SEEN}', "");
    Expect(0, 1919, '\p{Joining_Group=  SEEN}', "");
    Expect(1, 1919, '\p{^Joining_Group=  SEEN}', "");
    Expect(1, 1919, '\P{Joining_Group=  SEEN}', "");
    Expect(0, 1919, '\P{^Joining_Group=  SEEN}', "");
    Error('\p{Jg=:=	 seen}');
    Error('\P{Jg=:=	 seen}');
    Expect(1, 1918, '\p{Jg=:\ASeen\z:}', "");;
    Expect(0, 1919, '\p{Jg=:\ASeen\z:}', "");;
    Expect(1, 1918, '\p{Jg:   seen}', "");
    Expect(0, 1918, '\p{^Jg:   seen}', "");
    Expect(0, 1918, '\P{Jg:   seen}', "");
    Expect(1, 1918, '\P{^Jg:   seen}', "");
    Expect(0, 1919, '\p{Jg:   seen}', "");
    Expect(1, 1919, '\p{^Jg:   seen}', "");
    Expect(1, 1919, '\P{Jg:   seen}', "");
    Expect(0, 1919, '\P{^Jg:   seen}', "");
    Expect(1, 1918, '\p{Jg=:\Aseen\z:}', "");;
    Expect(0, 1919, '\p{Jg=:\Aseen\z:}', "");;
    Expect(1, 1918, '\p{Jg=-Seen}', "");
    Expect(0, 1918, '\p{^Jg=-Seen}', "");
    Expect(0, 1918, '\P{Jg=-Seen}', "");
    Expect(1, 1918, '\P{^Jg=-Seen}', "");
    Expect(0, 1919, '\p{Jg=-Seen}', "");
    Expect(1, 1919, '\p{^Jg=-Seen}', "");
    Expect(1, 1919, '\P{Jg=-Seen}', "");
    Expect(0, 1919, '\P{^Jg=-Seen}', "");
    Error('\p{Is_Joining_Group=_/a/Seen}');
    Error('\P{Is_Joining_Group=_/a/Seen}');
    Expect(1, 1918, '\p{Is_Joining_Group=seen}', "");
    Expect(0, 1918, '\p{^Is_Joining_Group=seen}', "");
    Expect(0, 1918, '\P{Is_Joining_Group=seen}', "");
    Expect(1, 1918, '\P{^Is_Joining_Group=seen}', "");
    Expect(0, 1919, '\p{Is_Joining_Group=seen}', "");
    Expect(1, 1919, '\p{^Is_Joining_Group=seen}', "");
    Expect(1, 1919, '\P{Is_Joining_Group=seen}', "");
    Expect(0, 1919, '\P{^Is_Joining_Group=seen}', "");
    Expect(1, 1918, '\p{Is_Joining_Group= _seen}', "");
    Expect(0, 1918, '\p{^Is_Joining_Group= _seen}', "");
    Expect(0, 1918, '\P{Is_Joining_Group= _seen}', "");
    Expect(1, 1918, '\P{^Is_Joining_Group= _seen}', "");
    Expect(0, 1919, '\p{Is_Joining_Group= _seen}', "");
    Expect(1, 1919, '\p{^Is_Joining_Group= _seen}', "");
    Expect(1, 1919, '\P{Is_Joining_Group= _seen}', "");
    Expect(0, 1919, '\P{^Is_Joining_Group= _seen}', "");
    Error('\p{Is_Jg=:=_ Seen}');
    Error('\P{Is_Jg=:=_ Seen}');
    Expect(1, 1918, '\p{Is_Jg=seen}', "");
    Expect(0, 1918, '\p{^Is_Jg=seen}', "");
    Expect(0, 1918, '\P{Is_Jg=seen}', "");
    Expect(1, 1918, '\P{^Is_Jg=seen}', "");
    Expect(0, 1919, '\p{Is_Jg=seen}', "");
    Expect(1, 1919, '\p{^Is_Jg=seen}', "");
    Expect(1, 1919, '\P{Is_Jg=seen}', "");
    Expect(0, 1919, '\P{^Is_Jg=seen}', "");
    Expect(1, 1918, '\p{Is_Jg= -Seen}', "");
    Expect(0, 1918, '\p{^Is_Jg= -Seen}', "");
    Expect(0, 1918, '\P{Is_Jg= -Seen}', "");
    Expect(1, 1918, '\P{^Is_Jg= -Seen}', "");
    Expect(0, 1919, '\p{Is_Jg= -Seen}', "");
    Expect(1, 1919, '\p{^Is_Jg= -Seen}', "");
    Expect(1, 1919, '\P{Is_Jg= -Seen}', "");
    Expect(0, 1919, '\P{^Is_Jg= -Seen}', "");
    Error('\p{Joining_Group=-:=SEMKATH}');
    Error('\P{Joining_Group=-:=SEMKATH}');
    Expect(1, 1827, '\p{Joining_Group=:\ASemkath\z:}', "");;
    Expect(0, 1828, '\p{Joining_Group=:\ASemkath\z:}', "");;
    Expect(1, 1827, '\p{Joining_Group=semkath}', "");
    Expect(0, 1827, '\p{^Joining_Group=semkath}', "");
    Expect(0, 1827, '\P{Joining_Group=semkath}', "");
    Expect(1, 1827, '\P{^Joining_Group=semkath}', "");
    Expect(0, 1828, '\p{Joining_Group=semkath}', "");
    Expect(1, 1828, '\p{^Joining_Group=semkath}', "");
    Expect(1, 1828, '\P{Joining_Group=semkath}', "");
    Expect(0, 1828, '\P{^Joining_Group=semkath}', "");
    Expect(1, 1827, '\p{Joining_Group=:\Asemkath\z:}', "");;
    Expect(0, 1828, '\p{Joining_Group=:\Asemkath\z:}', "");;
    Expect(1, 1827, '\p{Joining_Group=-	Semkath}', "");
    Expect(0, 1827, '\p{^Joining_Group=-	Semkath}', "");
    Expect(0, 1827, '\P{Joining_Group=-	Semkath}', "");
    Expect(1, 1827, '\P{^Joining_Group=-	Semkath}', "");
    Expect(0, 1828, '\p{Joining_Group=-	Semkath}', "");
    Expect(1, 1828, '\p{^Joining_Group=-	Semkath}', "");
    Expect(1, 1828, '\P{Joining_Group=-	Semkath}', "");
    Expect(0, 1828, '\P{^Joining_Group=-	Semkath}', "");
    Error('\p{Jg=		semkath/a/}');
    Error('\P{Jg=		semkath/a/}');
    Expect(1, 1827, '\p{Jg=:\ASemkath\z:}', "");;
    Expect(0, 1828, '\p{Jg=:\ASemkath\z:}', "");;
    Expect(1, 1827, '\p{Jg: semkath}', "");
    Expect(0, 1827, '\p{^Jg: semkath}', "");
    Expect(0, 1827, '\P{Jg: semkath}', "");
    Expect(1, 1827, '\P{^Jg: semkath}', "");
    Expect(0, 1828, '\p{Jg: semkath}', "");
    Expect(1, 1828, '\p{^Jg: semkath}', "");
    Expect(1, 1828, '\P{Jg: semkath}', "");
    Expect(0, 1828, '\P{^Jg: semkath}', "");
    Expect(1, 1827, '\p{Jg=:\Asemkath\z:}', "");;
    Expect(0, 1828, '\p{Jg=:\Asemkath\z:}', "");;
    Error('\p{Is_Joining_Group=/a/ Semkath}');
    Error('\P{Is_Joining_Group=/a/ Semkath}');
    Expect(1, 1827, '\p{Is_Joining_Group=semkath}', "");
    Expect(0, 1827, '\p{^Is_Joining_Group=semkath}', "");
    Expect(0, 1827, '\P{Is_Joining_Group=semkath}', "");
    Expect(1, 1827, '\P{^Is_Joining_Group=semkath}', "");
    Expect(0, 1828, '\p{Is_Joining_Group=semkath}', "");
    Expect(1, 1828, '\p{^Is_Joining_Group=semkath}', "");
    Expect(1, 1828, '\P{Is_Joining_Group=semkath}', "");
    Expect(0, 1828, '\P{^Is_Joining_Group=semkath}', "");
    Expect(1, 1827, '\p{Is_Joining_Group=_-semkath}', "");
    Expect(0, 1827, '\p{^Is_Joining_Group=_-semkath}', "");
    Expect(0, 1827, '\P{Is_Joining_Group=_-semkath}', "");
    Expect(1, 1827, '\P{^Is_Joining_Group=_-semkath}', "");
    Expect(0, 1828, '\p{Is_Joining_Group=_-semkath}', "");
    Expect(1, 1828, '\p{^Is_Joining_Group=_-semkath}', "");
    Expect(1, 1828, '\P{Is_Joining_Group=_-semkath}', "");
    Expect(0, 1828, '\P{^Is_Joining_Group=_-semkath}', "");
    Error('\p{Is_Jg=-:=SEMKATH}');
    Error('\P{Is_Jg=-:=SEMKATH}');
    Expect(1, 1827, '\p{Is_Jg=semkath}', "");
    Expect(0, 1827, '\p{^Is_Jg=semkath}', "");
    Expect(0, 1827, '\P{Is_Jg=semkath}', "");
    Expect(1, 1827, '\P{^Is_Jg=semkath}', "");
    Expect(0, 1828, '\p{Is_Jg=semkath}', "");
    Expect(1, 1828, '\p{^Is_Jg=semkath}', "");
    Expect(1, 1828, '\P{Is_Jg=semkath}', "");
    Expect(0, 1828, '\P{^Is_Jg=semkath}', "");
    Expect(1, 1827, '\p{Is_Jg=_Semkath}', "");
    Expect(0, 1827, '\p{^Is_Jg=_Semkath}', "");
    Expect(0, 1827, '\P{Is_Jg=_Semkath}', "");
    Expect(1, 1827, '\P{^Is_Jg=_Semkath}', "");
    Expect(0, 1828, '\p{Is_Jg=_Semkath}', "");
    Expect(1, 1828, '\p{^Is_Jg=_Semkath}', "");
    Expect(1, 1828, '\P{Is_Jg=_Semkath}', "");
    Expect(0, 1828, '\P{^Is_Jg=_Semkath}', "");
    Error('\p{Joining_Group=-Shin/a/}');
    Error('\P{Joining_Group=-Shin/a/}');
    Expect(1, 1835, '\p{Joining_Group=:\AShin\z:}', "");;
    Expect(0, 1836, '\p{Joining_Group=:\AShin\z:}', "");;
    Expect(1, 1835, '\p{Joining_Group=shin}', "");
    Expect(0, 1835, '\p{^Joining_Group=shin}', "");
    Expect(0, 1835, '\P{Joining_Group=shin}', "");
    Expect(1, 1835, '\P{^Joining_Group=shin}', "");
    Expect(0, 1836, '\p{Joining_Group=shin}', "");
    Expect(1, 1836, '\p{^Joining_Group=shin}', "");
    Expect(1, 1836, '\P{Joining_Group=shin}', "");
    Expect(0, 1836, '\P{^Joining_Group=shin}', "");
    Expect(1, 1835, '\p{Joining_Group=:\Ashin\z:}', "");;
    Expect(0, 1836, '\p{Joining_Group=:\Ashin\z:}', "");;
    Expect(1, 1835, '\p{Joining_Group=-shin}', "");
    Expect(0, 1835, '\p{^Joining_Group=-shin}', "");
    Expect(0, 1835, '\P{Joining_Group=-shin}', "");
    Expect(1, 1835, '\P{^Joining_Group=-shin}', "");
    Expect(0, 1836, '\p{Joining_Group=-shin}', "");
    Expect(1, 1836, '\p{^Joining_Group=-shin}', "");
    Expect(1, 1836, '\P{Joining_Group=-shin}', "");
    Expect(0, 1836, '\P{^Joining_Group=-shin}', "");
    Error('\p{Jg:   :=Shin}');
    Error('\P{Jg:   :=Shin}');
    Expect(1, 1835, '\p{Jg=:\AShin\z:}', "");;
    Expect(0, 1836, '\p{Jg=:\AShin\z:}', "");;
    Expect(1, 1835, '\p{Jg=shin}', "");
    Expect(0, 1835, '\p{^Jg=shin}', "");
    Expect(0, 1835, '\P{Jg=shin}', "");
    Expect(1, 1835, '\P{^Jg=shin}', "");
    Expect(0, 1836, '\p{Jg=shin}', "");
    Expect(1, 1836, '\p{^Jg=shin}', "");
    Expect(1, 1836, '\P{Jg=shin}', "");
    Expect(0, 1836, '\P{^Jg=shin}', "");
    Expect(1, 1835, '\p{Jg=:\Ashin\z:}', "");;
    Expect(0, 1836, '\p{Jg=:\Ashin\z:}', "");;
    Expect(1, 1835, '\p{Jg= Shin}', "");
    Expect(0, 1835, '\p{^Jg= Shin}', "");
    Expect(0, 1835, '\P{Jg= Shin}', "");
    Expect(1, 1835, '\P{^Jg= Shin}', "");
    Expect(0, 1836, '\p{Jg= Shin}', "");
    Expect(1, 1836, '\p{^Jg= Shin}', "");
    Expect(1, 1836, '\P{Jg= Shin}', "");
    Expect(0, 1836, '\P{^Jg= Shin}', "");
    Error('\p{Is_Joining_Group: :=Shin}');
    Error('\P{Is_Joining_Group: :=Shin}');
    Expect(1, 1835, '\p{Is_Joining_Group=shin}', "");
    Expect(0, 1835, '\p{^Is_Joining_Group=shin}', "");
    Expect(0, 1835, '\P{Is_Joining_Group=shin}', "");
    Expect(1, 1835, '\P{^Is_Joining_Group=shin}', "");
    Expect(0, 1836, '\p{Is_Joining_Group=shin}', "");
    Expect(1, 1836, '\p{^Is_Joining_Group=shin}', "");
    Expect(1, 1836, '\P{Is_Joining_Group=shin}', "");
    Expect(0, 1836, '\P{^Is_Joining_Group=shin}', "");
    Expect(1, 1835, '\p{Is_Joining_Group=__shin}', "");
    Expect(0, 1835, '\p{^Is_Joining_Group=__shin}', "");
    Expect(0, 1835, '\P{Is_Joining_Group=__shin}', "");
    Expect(1, 1835, '\P{^Is_Joining_Group=__shin}', "");
    Expect(0, 1836, '\p{Is_Joining_Group=__shin}', "");
    Expect(1, 1836, '\p{^Is_Joining_Group=__shin}', "");
    Expect(1, 1836, '\P{Is_Joining_Group=__shin}', "");
    Expect(0, 1836, '\P{^Is_Joining_Group=__shin}', "");
    Error('\p{Is_Jg=		Shin/a/}');
    Error('\P{Is_Jg=		Shin/a/}');
    Expect(1, 1835, '\p{Is_Jg=shin}', "");
    Expect(0, 1835, '\p{^Is_Jg=shin}', "");
    Expect(0, 1835, '\P{Is_Jg=shin}', "");
    Expect(1, 1835, '\P{^Is_Jg=shin}', "");
    Expect(0, 1836, '\p{Is_Jg=shin}', "");
    Expect(1, 1836, '\p{^Is_Jg=shin}', "");
    Expect(1, 1836, '\P{Is_Jg=shin}', "");
    Expect(0, 1836, '\P{^Is_Jg=shin}', "");
    Expect(1, 1835, '\p{Is_Jg:_-Shin}', "");
    Expect(0, 1835, '\p{^Is_Jg:_-Shin}', "");
    Expect(0, 1835, '\P{Is_Jg:_-Shin}', "");
    Expect(1, 1835, '\P{^Is_Jg:_-Shin}', "");
    Expect(0, 1836, '\p{Is_Jg:_-Shin}', "");
    Expect(1, 1836, '\p{^Is_Jg:_-Shin}', "");
    Expect(1, 1836, '\P{Is_Jg:_-Shin}', "");
    Expect(0, 1836, '\P{^Is_Jg:_-Shin}', "");
    Error('\p{Joining_Group= :=STRAIGHT_Waw}');
    Error('\P{Joining_Group= :=STRAIGHT_Waw}');
    Expect(1, 2225, '\p{Joining_Group=:\AStraight_Waw\z:}', "");;
    Expect(0, 2226, '\p{Joining_Group=:\AStraight_Waw\z:}', "");;
    Expect(1, 2225, '\p{Joining_Group=straightwaw}', "");
    Expect(0, 2225, '\p{^Joining_Group=straightwaw}', "");
    Expect(0, 2225, '\P{Joining_Group=straightwaw}', "");
    Expect(1, 2225, '\P{^Joining_Group=straightwaw}', "");
    Expect(0, 2226, '\p{Joining_Group=straightwaw}', "");
    Expect(1, 2226, '\p{^Joining_Group=straightwaw}', "");
    Expect(1, 2226, '\P{Joining_Group=straightwaw}', "");
    Expect(0, 2226, '\P{^Joining_Group=straightwaw}', "");
    Expect(1, 2225, '\p{Joining_Group=:\Astraightwaw\z:}', "");;
    Expect(0, 2226, '\p{Joining_Group=:\Astraightwaw\z:}', "");;
    Expect(1, 2225, '\p{Joining_Group=_Straight_WAW}', "");
    Expect(0, 2225, '\p{^Joining_Group=_Straight_WAW}', "");
    Expect(0, 2225, '\P{Joining_Group=_Straight_WAW}', "");
    Expect(1, 2225, '\P{^Joining_Group=_Straight_WAW}', "");
    Expect(0, 2226, '\p{Joining_Group=_Straight_WAW}', "");
    Expect(1, 2226, '\p{^Joining_Group=_Straight_WAW}', "");
    Expect(1, 2226, '\P{Joining_Group=_Straight_WAW}', "");
    Expect(0, 2226, '\P{^Joining_Group=_Straight_WAW}', "");
    Error('\p{Jg= -straight_Waw/a/}');
    Error('\P{Jg= -straight_Waw/a/}');
    Expect(1, 2225, '\p{Jg=:\AStraight_Waw\z:}', "");;
    Expect(0, 2226, '\p{Jg=:\AStraight_Waw\z:}', "");;
    Expect(1, 2225, '\p{Jg=straightwaw}', "");
    Expect(0, 2225, '\p{^Jg=straightwaw}', "");
    Expect(0, 2225, '\P{Jg=straightwaw}', "");
    Expect(1, 2225, '\P{^Jg=straightwaw}', "");
    Expect(0, 2226, '\p{Jg=straightwaw}', "");
    Expect(1, 2226, '\p{^Jg=straightwaw}', "");
    Expect(1, 2226, '\P{Jg=straightwaw}', "");
    Expect(0, 2226, '\P{^Jg=straightwaw}', "");
    Expect(1, 2225, '\p{Jg=:\Astraightwaw\z:}', "");;
    Expect(0, 2226, '\p{Jg=:\Astraightwaw\z:}', "");;
    Expect(1, 2225, '\p{Jg=	straight_Waw}', "");
    Expect(0, 2225, '\p{^Jg=	straight_Waw}', "");
    Expect(0, 2225, '\P{Jg=	straight_Waw}', "");
    Expect(1, 2225, '\P{^Jg=	straight_Waw}', "");
    Expect(0, 2226, '\p{Jg=	straight_Waw}', "");
    Expect(1, 2226, '\p{^Jg=	straight_Waw}', "");
    Expect(1, 2226, '\P{Jg=	straight_Waw}', "");
    Expect(0, 2226, '\P{^Jg=	straight_Waw}', "");
    Error('\p{Is_Joining_Group=:=_Straight_Waw}');
    Error('\P{Is_Joining_Group=:=_Straight_Waw}');
    Expect(1, 2225, '\p{Is_Joining_Group=straightwaw}', "");
    Expect(0, 2225, '\p{^Is_Joining_Group=straightwaw}', "");
    Expect(0, 2225, '\P{Is_Joining_Group=straightwaw}', "");
    Expect(1, 2225, '\P{^Is_Joining_Group=straightwaw}', "");
    Expect(0, 2226, '\p{Is_Joining_Group=straightwaw}', "");
    Expect(1, 2226, '\p{^Is_Joining_Group=straightwaw}', "");
    Expect(1, 2226, '\P{Is_Joining_Group=straightwaw}', "");
    Expect(0, 2226, '\P{^Is_Joining_Group=straightwaw}', "");
    Expect(1, 2225, '\p{Is_Joining_Group= -straight_Waw}', "");
    Expect(0, 2225, '\p{^Is_Joining_Group= -straight_Waw}', "");
    Expect(0, 2225, '\P{Is_Joining_Group= -straight_Waw}', "");
    Expect(1, 2225, '\P{^Is_Joining_Group= -straight_Waw}', "");
    Expect(0, 2226, '\p{Is_Joining_Group= -straight_Waw}', "");
    Expect(1, 2226, '\p{^Is_Joining_Group= -straight_Waw}', "");
    Expect(1, 2226, '\P{Is_Joining_Group= -straight_Waw}', "");
    Expect(0, 2226, '\P{^Is_Joining_Group= -straight_Waw}', "");
    Error('\p{Is_Jg::=-_Straight_WAW}');
    Error('\P{Is_Jg::=-_Straight_WAW}');
    Expect(1, 2225, '\p{Is_Jg=straightwaw}', "");
    Expect(0, 2225, '\p{^Is_Jg=straightwaw}', "");
    Expect(0, 2225, '\P{Is_Jg=straightwaw}', "");
    Expect(1, 2225, '\P{^Is_Jg=straightwaw}', "");
    Expect(0, 2226, '\p{Is_Jg=straightwaw}', "");
    Expect(1, 2226, '\p{^Is_Jg=straightwaw}', "");
    Expect(1, 2226, '\P{Is_Jg=straightwaw}', "");
    Expect(0, 2226, '\P{^Is_Jg=straightwaw}', "");
    Expect(1, 2225, '\p{Is_Jg=	 Straight_Waw}', "");
    Expect(0, 2225, '\p{^Is_Jg=	 Straight_Waw}', "");
    Expect(0, 2225, '\P{Is_Jg=	 Straight_Waw}', "");
    Expect(1, 2225, '\P{^Is_Jg=	 Straight_Waw}', "");
    Expect(0, 2226, '\p{Is_Jg=	 Straight_Waw}', "");
    Expect(1, 2226, '\p{^Is_Jg=	 Straight_Waw}', "");
    Expect(1, 2226, '\P{Is_Jg=	 Straight_Waw}', "");
    Expect(0, 2226, '\P{^Is_Jg=	 Straight_Waw}', "");
    Error('\p{Joining_Group=:=	SWASH_Kaf}');
    Error('\P{Joining_Group=:=	SWASH_Kaf}');
    Expect(1, 1706, '\p{Joining_Group=:\ASwash_Kaf\z:}', "");;
    Expect(0, 1707, '\p{Joining_Group=:\ASwash_Kaf\z:}', "");;
    Expect(1, 1706, '\p{Joining_Group=swashkaf}', "");
    Expect(0, 1706, '\p{^Joining_Group=swashkaf}', "");
    Expect(0, 1706, '\P{Joining_Group=swashkaf}', "");
    Expect(1, 1706, '\P{^Joining_Group=swashkaf}', "");
    Expect(0, 1707, '\p{Joining_Group=swashkaf}', "");
    Expect(1, 1707, '\p{^Joining_Group=swashkaf}', "");
    Expect(1, 1707, '\P{Joining_Group=swashkaf}', "");
    Expect(0, 1707, '\P{^Joining_Group=swashkaf}', "");
    Expect(1, 1706, '\p{Joining_Group=:\Aswashkaf\z:}', "");;
    Expect(0, 1707, '\p{Joining_Group=:\Aswashkaf\z:}', "");;
    Expect(1, 1706, '\p{Joining_Group=	 swash_Kaf}', "");
    Expect(0, 1706, '\p{^Joining_Group=	 swash_Kaf}', "");
    Expect(0, 1706, '\P{Joining_Group=	 swash_Kaf}', "");
    Expect(1, 1706, '\P{^Joining_Group=	 swash_Kaf}', "");
    Expect(0, 1707, '\p{Joining_Group=	 swash_Kaf}', "");
    Expect(1, 1707, '\p{^Joining_Group=	 swash_Kaf}', "");
    Expect(1, 1707, '\P{Joining_Group=	 swash_Kaf}', "");
    Expect(0, 1707, '\P{^Joining_Group=	 swash_Kaf}', "");
    Error('\p{Jg= :=Swash_Kaf}');
    Error('\P{Jg= :=Swash_Kaf}');
    Expect(1, 1706, '\p{Jg=:\ASwash_Kaf\z:}', "");;
    Expect(0, 1707, '\p{Jg=:\ASwash_Kaf\z:}', "");;
    Expect(1, 1706, '\p{Jg=swashkaf}', "");
    Expect(0, 1706, '\p{^Jg=swashkaf}', "");
    Expect(0, 1706, '\P{Jg=swashkaf}', "");
    Expect(1, 1706, '\P{^Jg=swashkaf}', "");
    Expect(0, 1707, '\p{Jg=swashkaf}', "");
    Expect(1, 1707, '\p{^Jg=swashkaf}', "");
    Expect(1, 1707, '\P{Jg=swashkaf}', "");
    Expect(0, 1707, '\P{^Jg=swashkaf}', "");
    Expect(1, 1706, '\p{Jg=:\Aswashkaf\z:}', "");;
    Expect(0, 1707, '\p{Jg=:\Aswashkaf\z:}', "");;
    Expect(1, 1706, '\p{Jg=	Swash_Kaf}', "");
    Expect(0, 1706, '\p{^Jg=	Swash_Kaf}', "");
    Expect(0, 1706, '\P{Jg=	Swash_Kaf}', "");
    Expect(1, 1706, '\P{^Jg=	Swash_Kaf}', "");
    Expect(0, 1707, '\p{Jg=	Swash_Kaf}', "");
    Expect(1, 1707, '\p{^Jg=	Swash_Kaf}', "");
    Expect(1, 1707, '\P{Jg=	Swash_Kaf}', "");
    Expect(0, 1707, '\P{^Jg=	Swash_Kaf}', "");
    Error('\p{Is_Joining_Group=	SWASH_Kaf:=}');
    Error('\P{Is_Joining_Group=	SWASH_Kaf:=}');
    Expect(1, 1706, '\p{Is_Joining_Group=swashkaf}', "");
    Expect(0, 1706, '\p{^Is_Joining_Group=swashkaf}', "");
    Expect(0, 1706, '\P{Is_Joining_Group=swashkaf}', "");
    Expect(1, 1706, '\P{^Is_Joining_Group=swashkaf}', "");
    Expect(0, 1707, '\p{Is_Joining_Group=swashkaf}', "");
    Expect(1, 1707, '\p{^Is_Joining_Group=swashkaf}', "");
    Expect(1, 1707, '\P{Is_Joining_Group=swashkaf}', "");
    Expect(0, 1707, '\P{^Is_Joining_Group=swashkaf}', "");
    Expect(1, 1706, '\p{Is_Joining_Group:   	_Swash_kaf}', "");
    Expect(0, 1706, '\p{^Is_Joining_Group:   	_Swash_kaf}', "");
    Expect(0, 1706, '\P{Is_Joining_Group:   	_Swash_kaf}', "");
    Expect(1, 1706, '\P{^Is_Joining_Group:   	_Swash_kaf}', "");
    Expect(0, 1707, '\p{Is_Joining_Group:   	_Swash_kaf}', "");
    Expect(1, 1707, '\p{^Is_Joining_Group:   	_Swash_kaf}', "");
    Expect(1, 1707, '\P{Is_Joining_Group:   	_Swash_kaf}', "");
    Expect(0, 1707, '\P{^Is_Joining_Group:   	_Swash_kaf}', "");
    Error('\p{Is_Jg=	 SWASH_Kaf:=}');
    Error('\P{Is_Jg=	 SWASH_Kaf:=}');
    Expect(1, 1706, '\p{Is_Jg:swashkaf}', "");
    Expect(0, 1706, '\p{^Is_Jg:swashkaf}', "");
    Expect(0, 1706, '\P{Is_Jg:swashkaf}', "");
    Expect(1, 1706, '\P{^Is_Jg:swashkaf}', "");
    Expect(0, 1707, '\p{Is_Jg:swashkaf}', "");
    Expect(1, 1707, '\p{^Is_Jg:swashkaf}', "");
    Expect(1, 1707, '\P{Is_Jg:swashkaf}', "");
    Expect(0, 1707, '\P{^Is_Jg:swashkaf}', "");
    Expect(1, 1706, '\p{Is_Jg: _Swash_KAF}', "");
    Expect(0, 1706, '\p{^Is_Jg: _Swash_KAF}', "");
    Expect(0, 1706, '\P{Is_Jg: _Swash_KAF}', "");
    Expect(1, 1706, '\P{^Is_Jg: _Swash_KAF}', "");
    Expect(0, 1707, '\p{Is_Jg: _Swash_KAF}', "");
    Expect(1, 1707, '\p{^Is_Jg: _Swash_KAF}', "");
    Expect(1, 1707, '\P{Is_Jg: _Swash_KAF}', "");
    Expect(0, 1707, '\P{^Is_Jg: _Swash_KAF}', "");
    Error('\p{Joining_Group= 	SYRIAC_WAW:=}');
    Error('\P{Joining_Group= 	SYRIAC_WAW:=}');
    Expect(1, 1816, '\p{Joining_Group=:\ASyriac_Waw\z:}', "");;
    Expect(0, 1817, '\p{Joining_Group=:\ASyriac_Waw\z:}', "");;
    Expect(1, 1816, '\p{Joining_Group:   syriacwaw}', "");
    Expect(0, 1816, '\p{^Joining_Group:   syriacwaw}', "");
    Expect(0, 1816, '\P{Joining_Group:   syriacwaw}', "");
    Expect(1, 1816, '\P{^Joining_Group:   syriacwaw}', "");
    Expect(0, 1817, '\p{Joining_Group:   syriacwaw}', "");
    Expect(1, 1817, '\p{^Joining_Group:   syriacwaw}', "");
    Expect(1, 1817, '\P{Joining_Group:   syriacwaw}', "");
    Expect(0, 1817, '\P{^Joining_Group:   syriacwaw}', "");
    Expect(1, 1816, '\p{Joining_Group=:\Asyriacwaw\z:}', "");;
    Expect(0, 1817, '\p{Joining_Group=:\Asyriacwaw\z:}', "");;
    Expect(1, 1816, '\p{Joining_Group=	-Syriac_Waw}', "");
    Expect(0, 1816, '\p{^Joining_Group=	-Syriac_Waw}', "");
    Expect(0, 1816, '\P{Joining_Group=	-Syriac_Waw}', "");
    Expect(1, 1816, '\P{^Joining_Group=	-Syriac_Waw}', "");
    Expect(0, 1817, '\p{Joining_Group=	-Syriac_Waw}', "");
    Expect(1, 1817, '\p{^Joining_Group=	-Syriac_Waw}', "");
    Expect(1, 1817, '\P{Joining_Group=	-Syriac_Waw}', "");
    Expect(0, 1817, '\P{^Joining_Group=	-Syriac_Waw}', "");
    Error('\p{Jg:	/a/-_SYRIAC_waw}');
    Error('\P{Jg:	/a/-_SYRIAC_waw}');
    Expect(1, 1816, '\p{Jg=:\ASyriac_Waw\z:}', "");;
    Expect(0, 1817, '\p{Jg=:\ASyriac_Waw\z:}', "");;
    Expect(1, 1816, '\p{Jg:syriacwaw}', "");
    Expect(0, 1816, '\p{^Jg:syriacwaw}', "");
    Expect(0, 1816, '\P{Jg:syriacwaw}', "");
    Expect(1, 1816, '\P{^Jg:syriacwaw}', "");
    Expect(0, 1817, '\p{Jg:syriacwaw}', "");
    Expect(1, 1817, '\p{^Jg:syriacwaw}', "");
    Expect(1, 1817, '\P{Jg:syriacwaw}', "");
    Expect(0, 1817, '\P{^Jg:syriacwaw}', "");
    Expect(1, 1816, '\p{Jg=:\Asyriacwaw\z:}', "");;
    Expect(0, 1817, '\p{Jg=:\Asyriacwaw\z:}', "");;
    Expect(1, 1816, '\p{Jg=-_Syriac_Waw}', "");
    Expect(0, 1816, '\p{^Jg=-_Syriac_Waw}', "");
    Expect(0, 1816, '\P{Jg=-_Syriac_Waw}', "");
    Expect(1, 1816, '\P{^Jg=-_Syriac_Waw}', "");
    Expect(0, 1817, '\p{Jg=-_Syriac_Waw}', "");
    Expect(1, 1817, '\p{^Jg=-_Syriac_Waw}', "");
    Expect(1, 1817, '\P{Jg=-_Syriac_Waw}', "");
    Expect(0, 1817, '\P{^Jg=-_Syriac_Waw}', "");
    Error('\p{Is_Joining_Group:	 	syriac_waw:=}');
    Error('\P{Is_Joining_Group:	 	syriac_waw:=}');
    Expect(1, 1816, '\p{Is_Joining_Group=syriacwaw}', "");
    Expect(0, 1816, '\p{^Is_Joining_Group=syriacwaw}', "");
    Expect(0, 1816, '\P{Is_Joining_Group=syriacwaw}', "");
    Expect(1, 1816, '\P{^Is_Joining_Group=syriacwaw}', "");
    Expect(0, 1817, '\p{Is_Joining_Group=syriacwaw}', "");
    Expect(1, 1817, '\p{^Is_Joining_Group=syriacwaw}', "");
    Expect(1, 1817, '\P{Is_Joining_Group=syriacwaw}', "");
    Expect(0, 1817, '\P{^Is_Joining_Group=syriacwaw}', "");
    Expect(1, 1816, '\p{Is_Joining_Group=_ syriac_Waw}', "");
    Expect(0, 1816, '\p{^Is_Joining_Group=_ syriac_Waw}', "");
    Expect(0, 1816, '\P{Is_Joining_Group=_ syriac_Waw}', "");
    Expect(1, 1816, '\P{^Is_Joining_Group=_ syriac_Waw}', "");
    Expect(0, 1817, '\p{Is_Joining_Group=_ syriac_Waw}', "");
    Expect(1, 1817, '\p{^Is_Joining_Group=_ syriac_Waw}', "");
    Expect(1, 1817, '\P{Is_Joining_Group=_ syriac_Waw}', "");
    Expect(0, 1817, '\P{^Is_Joining_Group=_ syriac_Waw}', "");
    Error('\p{Is_Jg=:=Syriac_waw}');
    Error('\P{Is_Jg=:=Syriac_waw}');
    Expect(1, 1816, '\p{Is_Jg=syriacwaw}', "");
    Expect(0, 1816, '\p{^Is_Jg=syriacwaw}', "");
    Expect(0, 1816, '\P{Is_Jg=syriacwaw}', "");
    Expect(1, 1816, '\P{^Is_Jg=syriacwaw}', "");
    Expect(0, 1817, '\p{Is_Jg=syriacwaw}', "");
    Expect(1, 1817, '\p{^Is_Jg=syriacwaw}', "");
    Expect(1, 1817, '\P{Is_Jg=syriacwaw}', "");
    Expect(0, 1817, '\P{^Is_Jg=syriacwaw}', "");
    Expect(1, 1816, '\p{Is_Jg=- syriac_waw}', "");
    Expect(0, 1816, '\p{^Is_Jg=- syriac_waw}', "");
    Expect(0, 1816, '\P{Is_Jg=- syriac_waw}', "");
    Expect(1, 1816, '\P{^Is_Jg=- syriac_waw}', "");
    Expect(0, 1817, '\p{Is_Jg=- syriac_waw}', "");
    Expect(1, 1817, '\p{^Is_Jg=- syriac_waw}', "");
    Expect(1, 1817, '\P{Is_Jg=- syriac_waw}', "");
    Expect(0, 1817, '\P{^Is_Jg=- syriac_waw}', "");
    Error('\p{Joining_Group= :=tah}');
    Error('\P{Joining_Group= :=tah}');
    Expect(1, 2211, '\p{Joining_Group=:\ATah\z:}', "");;
    Expect(0, 2212, '\p{Joining_Group=:\ATah\z:}', "");;
    Expect(1, 2211, '\p{Joining_Group=tah}', "");
    Expect(0, 2211, '\p{^Joining_Group=tah}', "");
    Expect(0, 2211, '\P{Joining_Group=tah}', "");
    Expect(1, 2211, '\P{^Joining_Group=tah}', "");
    Expect(0, 2212, '\p{Joining_Group=tah}', "");
    Expect(1, 2212, '\p{^Joining_Group=tah}', "");
    Expect(1, 2212, '\P{Joining_Group=tah}', "");
    Expect(0, 2212, '\P{^Joining_Group=tah}', "");
    Expect(1, 2211, '\p{Joining_Group=:\Atah\z:}', "");;
    Expect(0, 2212, '\p{Joining_Group=:\Atah\z:}', "");;
    Expect(1, 2211, '\p{Joining_Group= Tah}', "");
    Expect(0, 2211, '\p{^Joining_Group= Tah}', "");
    Expect(0, 2211, '\P{Joining_Group= Tah}', "");
    Expect(1, 2211, '\P{^Joining_Group= Tah}', "");
    Expect(0, 2212, '\p{Joining_Group= Tah}', "");
    Expect(1, 2212, '\p{^Joining_Group= Tah}', "");
    Expect(1, 2212, '\P{Joining_Group= Tah}', "");
    Expect(0, 2212, '\P{^Joining_Group= Tah}', "");
    Error('\p{Jg=	_Tah:=}');
    Error('\P{Jg=	_Tah:=}');
    Expect(1, 2211, '\p{Jg=:\ATah\z:}', "");;
    Expect(0, 2212, '\p{Jg=:\ATah\z:}', "");;
    Expect(1, 2211, '\p{Jg=tah}', "");
    Expect(0, 2211, '\p{^Jg=tah}', "");
    Expect(0, 2211, '\P{Jg=tah}', "");
    Expect(1, 2211, '\P{^Jg=tah}', "");
    Expect(0, 2212, '\p{Jg=tah}', "");
    Expect(1, 2212, '\p{^Jg=tah}', "");
    Expect(1, 2212, '\P{Jg=tah}', "");
    Expect(0, 2212, '\P{^Jg=tah}', "");
    Expect(1, 2211, '\p{Jg=:\Atah\z:}', "");;
    Expect(0, 2212, '\p{Jg=:\Atah\z:}', "");;
    Expect(1, 2211, '\p{Jg=-tah}', "");
    Expect(0, 2211, '\p{^Jg=-tah}', "");
    Expect(0, 2211, '\P{Jg=-tah}', "");
    Expect(1, 2211, '\P{^Jg=-tah}', "");
    Expect(0, 2212, '\p{Jg=-tah}', "");
    Expect(1, 2212, '\p{^Jg=-tah}', "");
    Expect(1, 2212, '\P{Jg=-tah}', "");
    Expect(0, 2212, '\P{^Jg=-tah}', "");
    Error('\p{Is_Joining_Group=	:=TAH}');
    Error('\P{Is_Joining_Group=	:=TAH}');
    Expect(1, 2211, '\p{Is_Joining_Group=tah}', "");
    Expect(0, 2211, '\p{^Is_Joining_Group=tah}', "");
    Expect(0, 2211, '\P{Is_Joining_Group=tah}', "");
    Expect(1, 2211, '\P{^Is_Joining_Group=tah}', "");
    Expect(0, 2212, '\p{Is_Joining_Group=tah}', "");
    Expect(1, 2212, '\p{^Is_Joining_Group=tah}', "");
    Expect(1, 2212, '\P{Is_Joining_Group=tah}', "");
    Expect(0, 2212, '\P{^Is_Joining_Group=tah}', "");
    Expect(1, 2211, '\p{Is_Joining_Group= Tah}', "");
    Expect(0, 2211, '\p{^Is_Joining_Group= Tah}', "");
    Expect(0, 2211, '\P{Is_Joining_Group= Tah}', "");
    Expect(1, 2211, '\P{^Is_Joining_Group= Tah}', "");
    Expect(0, 2212, '\p{Is_Joining_Group= Tah}', "");
    Expect(1, 2212, '\p{^Is_Joining_Group= Tah}', "");
    Expect(1, 2212, '\P{Is_Joining_Group= Tah}', "");
    Expect(0, 2212, '\P{^Is_Joining_Group= Tah}', "");
    Error('\p{Is_Jg=	Tah/a/}');
    Error('\P{Is_Jg=	Tah/a/}');
    Expect(1, 2211, '\p{Is_Jg: tah}', "");
    Expect(0, 2211, '\p{^Is_Jg: tah}', "");
    Expect(0, 2211, '\P{Is_Jg: tah}', "");
    Expect(1, 2211, '\P{^Is_Jg: tah}', "");
    Expect(0, 2212, '\p{Is_Jg: tah}', "");
    Expect(1, 2212, '\p{^Is_Jg: tah}', "");
    Expect(1, 2212, '\P{Is_Jg: tah}', "");
    Expect(0, 2212, '\P{^Is_Jg: tah}', "");
    Error('\p{Joining_Group=:=_ Taw}');
    Error('\P{Joining_Group=:=_ Taw}');
    Expect(1, 1836, '\p{Joining_Group=:\ATaw\z:}', "");;
    Expect(0, 1837, '\p{Joining_Group=:\ATaw\z:}', "");;
    Expect(1, 1836, '\p{Joining_Group=taw}', "");
    Expect(0, 1836, '\p{^Joining_Group=taw}', "");
    Expect(0, 1836, '\P{Joining_Group=taw}', "");
    Expect(1, 1836, '\P{^Joining_Group=taw}', "");
    Expect(0, 1837, '\p{Joining_Group=taw}', "");
    Expect(1, 1837, '\p{^Joining_Group=taw}', "");
    Expect(1, 1837, '\P{Joining_Group=taw}', "");
    Expect(0, 1837, '\P{^Joining_Group=taw}', "");
    Expect(1, 1836, '\p{Joining_Group=:\Ataw\z:}', "");;
    Expect(0, 1837, '\p{Joining_Group=:\Ataw\z:}', "");;
    Expect(1, 1836, '\p{Joining_Group=-Taw}', "");
    Expect(0, 1836, '\p{^Joining_Group=-Taw}', "");
    Expect(0, 1836, '\P{Joining_Group=-Taw}', "");
    Expect(1, 1836, '\P{^Joining_Group=-Taw}', "");
    Expect(0, 1837, '\p{Joining_Group=-Taw}', "");
    Expect(1, 1837, '\p{^Joining_Group=-Taw}', "");
    Expect(1, 1837, '\P{Joining_Group=-Taw}', "");
    Expect(0, 1837, '\P{^Joining_Group=-Taw}', "");
    Error('\p{Jg= TAW:=}');
    Error('\P{Jg= TAW:=}');
    Expect(1, 1836, '\p{Jg=:\ATaw\z:}', "");;
    Expect(0, 1837, '\p{Jg=:\ATaw\z:}', "");;
    Expect(1, 1836, '\p{Jg=taw}', "");
    Expect(0, 1836, '\p{^Jg=taw}', "");
    Expect(0, 1836, '\P{Jg=taw}', "");
    Expect(1, 1836, '\P{^Jg=taw}', "");
    Expect(0, 1837, '\p{Jg=taw}', "");
    Expect(1, 1837, '\p{^Jg=taw}', "");
    Expect(1, 1837, '\P{Jg=taw}', "");
    Expect(0, 1837, '\P{^Jg=taw}', "");
    Expect(1, 1836, '\p{Jg=:\Ataw\z:}', "");;
    Expect(0, 1837, '\p{Jg=:\Ataw\z:}', "");;
    Expect(1, 1836, '\p{Jg=-_Taw}', "");
    Expect(0, 1836, '\p{^Jg=-_Taw}', "");
    Expect(0, 1836, '\P{Jg=-_Taw}', "");
    Expect(1, 1836, '\P{^Jg=-_Taw}', "");
    Expect(0, 1837, '\p{Jg=-_Taw}', "");
    Expect(1, 1837, '\p{^Jg=-_Taw}', "");
    Expect(1, 1837, '\P{Jg=-_Taw}', "");
    Expect(0, 1837, '\P{^Jg=-_Taw}', "");
    Error('\p{Is_Joining_Group=/a/__TAW}');
    Error('\P{Is_Joining_Group=/a/__TAW}');
    Expect(1, 1836, '\p{Is_Joining_Group: taw}', "");
    Expect(0, 1836, '\p{^Is_Joining_Group: taw}', "");
    Expect(0, 1836, '\P{Is_Joining_Group: taw}', "");
    Expect(1, 1836, '\P{^Is_Joining_Group: taw}', "");
    Expect(0, 1837, '\p{Is_Joining_Group: taw}', "");
    Expect(1, 1837, '\p{^Is_Joining_Group: taw}', "");
    Expect(1, 1837, '\P{Is_Joining_Group: taw}', "");
    Expect(0, 1837, '\P{^Is_Joining_Group: taw}', "");
    Expect(1, 1836, '\p{Is_Joining_Group= TAW}', "");
    Expect(0, 1836, '\p{^Is_Joining_Group= TAW}', "");
    Expect(0, 1836, '\P{Is_Joining_Group= TAW}', "");
    Expect(1, 1836, '\P{^Is_Joining_Group= TAW}', "");
    Expect(0, 1837, '\p{Is_Joining_Group= TAW}', "");
    Expect(1, 1837, '\p{^Is_Joining_Group= TAW}', "");
    Expect(1, 1837, '\P{Is_Joining_Group= TAW}', "");
    Expect(0, 1837, '\P{^Is_Joining_Group= TAW}', "");
    Error('\p{Is_Jg=:=-Taw}');
    Error('\P{Is_Jg=:=-Taw}');
    Expect(1, 1836, '\p{Is_Jg=taw}', "");
    Expect(0, 1836, '\p{^Is_Jg=taw}', "");
    Expect(0, 1836, '\P{Is_Jg=taw}', "");
    Expect(1, 1836, '\P{^Is_Jg=taw}', "");
    Expect(0, 1837, '\p{Is_Jg=taw}', "");
    Expect(1, 1837, '\p{^Is_Jg=taw}', "");
    Expect(1, 1837, '\P{Is_Jg=taw}', "");
    Expect(0, 1837, '\P{^Is_Jg=taw}', "");
    Expect(1, 1836, '\p{Is_Jg=__taw}', "");
    Expect(0, 1836, '\p{^Is_Jg=__taw}', "");
    Expect(0, 1836, '\P{Is_Jg=__taw}', "");
    Expect(1, 1836, '\P{^Is_Jg=__taw}', "");
    Expect(0, 1837, '\p{Is_Jg=__taw}', "");
    Expect(1, 1837, '\p{^Is_Jg=__taw}', "");
    Expect(1, 1837, '\P{Is_Jg=__taw}', "");
    Expect(0, 1837, '\P{^Is_Jg=__taw}', "");
    Error('\p{Joining_Group:-Teh_Marbuta:=}');
    Error('\P{Joining_Group:-Teh_Marbuta:=}');
    Expect(1, 1749, '\p{Joining_Group=:\ATeh_Marbuta\z:}', "");;
    Expect(0, 1750, '\p{Joining_Group=:\ATeh_Marbuta\z:}', "");;
    Expect(1, 1749, '\p{Joining_Group=tehmarbuta}', "");
    Expect(0, 1749, '\p{^Joining_Group=tehmarbuta}', "");
    Expect(0, 1749, '\P{Joining_Group=tehmarbuta}', "");
    Expect(1, 1749, '\P{^Joining_Group=tehmarbuta}', "");
    Expect(0, 1750, '\p{Joining_Group=tehmarbuta}', "");
    Expect(1, 1750, '\p{^Joining_Group=tehmarbuta}', "");
    Expect(1, 1750, '\P{Joining_Group=tehmarbuta}', "");
    Expect(0, 1750, '\P{^Joining_Group=tehmarbuta}', "");
    Expect(1, 1749, '\p{Joining_Group=:\Atehmarbuta\z:}', "");;
    Expect(0, 1750, '\p{Joining_Group=:\Atehmarbuta\z:}', "");;
    Expect(1, 1749, '\p{Joining_Group=		TEH_MARBUTA}', "");
    Expect(0, 1749, '\p{^Joining_Group=		TEH_MARBUTA}', "");
    Expect(0, 1749, '\P{Joining_Group=		TEH_MARBUTA}', "");
    Expect(1, 1749, '\P{^Joining_Group=		TEH_MARBUTA}', "");
    Expect(0, 1750, '\p{Joining_Group=		TEH_MARBUTA}', "");
    Expect(1, 1750, '\p{^Joining_Group=		TEH_MARBUTA}', "");
    Expect(1, 1750, '\P{Joining_Group=		TEH_MARBUTA}', "");
    Expect(0, 1750, '\P{^Joining_Group=		TEH_MARBUTA}', "");
    Error('\p{Jg= _Teh_Marbuta:=}');
    Error('\P{Jg= _Teh_Marbuta:=}');
    Expect(1, 1749, '\p{Jg=:\ATeh_Marbuta\z:}', "");;
    Expect(0, 1750, '\p{Jg=:\ATeh_Marbuta\z:}', "");;
    Expect(1, 1749, '\p{Jg=tehmarbuta}', "");
    Expect(0, 1749, '\p{^Jg=tehmarbuta}', "");
    Expect(0, 1749, '\P{Jg=tehmarbuta}', "");
    Expect(1, 1749, '\P{^Jg=tehmarbuta}', "");
    Expect(0, 1750, '\p{Jg=tehmarbuta}', "");
    Expect(1, 1750, '\p{^Jg=tehmarbuta}', "");
    Expect(1, 1750, '\P{Jg=tehmarbuta}', "");
    Expect(0, 1750, '\P{^Jg=tehmarbuta}', "");
    Expect(1, 1749, '\p{Jg=:\Atehmarbuta\z:}', "");;
    Expect(0, 1750, '\p{Jg=:\Atehmarbuta\z:}', "");;
    Expect(1, 1749, '\p{Jg=_-teh_MARBUTA}', "");
    Expect(0, 1749, '\p{^Jg=_-teh_MARBUTA}', "");
    Expect(0, 1749, '\P{Jg=_-teh_MARBUTA}', "");
    Expect(1, 1749, '\P{^Jg=_-teh_MARBUTA}', "");
    Expect(0, 1750, '\p{Jg=_-teh_MARBUTA}', "");
    Expect(1, 1750, '\p{^Jg=_-teh_MARBUTA}', "");
    Expect(1, 1750, '\P{Jg=_-teh_MARBUTA}', "");
    Expect(0, 1750, '\P{^Jg=_-teh_MARBUTA}', "");
    Error('\p{Is_Joining_Group=-	teh_Marbuta/a/}');
    Error('\P{Is_Joining_Group=-	teh_Marbuta/a/}');
    Expect(1, 1749, '\p{Is_Joining_Group=tehmarbuta}', "");
    Expect(0, 1749, '\p{^Is_Joining_Group=tehmarbuta}', "");
    Expect(0, 1749, '\P{Is_Joining_Group=tehmarbuta}', "");
    Expect(1, 1749, '\P{^Is_Joining_Group=tehmarbuta}', "");
    Expect(0, 1750, '\p{Is_Joining_Group=tehmarbuta}', "");
    Expect(1, 1750, '\p{^Is_Joining_Group=tehmarbuta}', "");
    Expect(1, 1750, '\P{Is_Joining_Group=tehmarbuta}', "");
    Expect(0, 1750, '\P{^Is_Joining_Group=tehmarbuta}', "");
    Expect(1, 1749, '\p{Is_Joining_Group=-Teh_marbuta}', "");
    Expect(0, 1749, '\p{^Is_Joining_Group=-Teh_marbuta}', "");
    Expect(0, 1749, '\P{Is_Joining_Group=-Teh_marbuta}', "");
    Expect(1, 1749, '\P{^Is_Joining_Group=-Teh_marbuta}', "");
    Expect(0, 1750, '\p{Is_Joining_Group=-Teh_marbuta}', "");
    Expect(1, 1750, '\p{^Is_Joining_Group=-Teh_marbuta}', "");
    Expect(1, 1750, '\P{Is_Joining_Group=-Teh_marbuta}', "");
    Expect(0, 1750, '\P{^Is_Joining_Group=-Teh_marbuta}', "");
    Error('\p{Is_Jg:   /a/ Teh_Marbuta}');
    Error('\P{Is_Jg:   /a/ Teh_Marbuta}');
    Expect(1, 1749, '\p{Is_Jg=tehmarbuta}', "");
    Expect(0, 1749, '\p{^Is_Jg=tehmarbuta}', "");
    Expect(0, 1749, '\P{Is_Jg=tehmarbuta}', "");
    Expect(1, 1749, '\P{^Is_Jg=tehmarbuta}', "");
    Expect(0, 1750, '\p{Is_Jg=tehmarbuta}', "");
    Expect(1, 1750, '\p{^Is_Jg=tehmarbuta}', "");
    Expect(1, 1750, '\P{Is_Jg=tehmarbuta}', "");
    Expect(0, 1750, '\P{^Is_Jg=tehmarbuta}', "");
    Expect(1, 1749, '\p{Is_Jg= Teh_marbuta}', "");
    Expect(0, 1749, '\p{^Is_Jg= Teh_marbuta}', "");
    Expect(0, 1749, '\P{Is_Jg= Teh_marbuta}', "");
    Expect(1, 1749, '\P{^Is_Jg= Teh_marbuta}', "");
    Expect(0, 1750, '\p{Is_Jg= Teh_marbuta}', "");
    Expect(1, 1750, '\p{^Is_Jg= Teh_marbuta}', "");
    Expect(1, 1750, '\P{Is_Jg= Teh_marbuta}', "");
    Expect(0, 1750, '\P{^Is_Jg= Teh_marbuta}', "");
    Error('\p{Joining_Group= :=Hamza_On_HEH_Goal}');
    Error('\P{Joining_Group= :=Hamza_On_HEH_Goal}');
    Expect(1, 1731, '\p{Joining_Group=:\AHamza_On_Heh_Goal\z:}', "");;
    Expect(0, 1732, '\p{Joining_Group=:\AHamza_On_Heh_Goal\z:}', "");;
    Expect(1, 1731, '\p{Joining_Group=hamzaonhehgoal}', "");
    Expect(0, 1731, '\p{^Joining_Group=hamzaonhehgoal}', "");
    Expect(0, 1731, '\P{Joining_Group=hamzaonhehgoal}', "");
    Expect(1, 1731, '\P{^Joining_Group=hamzaonhehgoal}', "");
    Expect(0, 1732, '\p{Joining_Group=hamzaonhehgoal}', "");
    Expect(1, 1732, '\p{^Joining_Group=hamzaonhehgoal}', "");
    Expect(1, 1732, '\P{Joining_Group=hamzaonhehgoal}', "");
    Expect(0, 1732, '\P{^Joining_Group=hamzaonhehgoal}', "");
    Expect(1, 1731, '\p{Joining_Group=:\Ahamzaonhehgoal\z:}', "");;
    Expect(0, 1732, '\p{Joining_Group=:\Ahamzaonhehgoal\z:}', "");;
    Expect(1, 1731, '\p{Joining_Group= 	Hamza_on_Heh_goal}', "");
    Expect(0, 1731, '\p{^Joining_Group= 	Hamza_on_Heh_goal}', "");
    Expect(0, 1731, '\P{Joining_Group= 	Hamza_on_Heh_goal}', "");
    Expect(1, 1731, '\P{^Joining_Group= 	Hamza_on_Heh_goal}', "");
    Expect(0, 1732, '\p{Joining_Group= 	Hamza_on_Heh_goal}', "");
    Expect(1, 1732, '\p{^Joining_Group= 	Hamza_on_Heh_goal}', "");
    Expect(1, 1732, '\P{Joining_Group= 	Hamza_on_Heh_goal}', "");
    Expect(0, 1732, '\P{^Joining_Group= 	Hamza_on_Heh_goal}', "");
    Error('\p{Jg=/a/- Teh_MARBUTA_Goal}');
    Error('\P{Jg=/a/- Teh_MARBUTA_Goal}');
    Expect(1, 1731, '\p{Jg=:\ATeh_Marbuta_Goal\z:}', "");;
    Expect(0, 1732, '\p{Jg=:\ATeh_Marbuta_Goal\z:}', "");;
    Expect(1, 1731, '\p{Jg=tehmarbutagoal}', "");
    Expect(0, 1731, '\p{^Jg=tehmarbutagoal}', "");
    Expect(0, 1731, '\P{Jg=tehmarbutagoal}', "");
    Expect(1, 1731, '\P{^Jg=tehmarbutagoal}', "");
    Expect(0, 1732, '\p{Jg=tehmarbutagoal}', "");
    Expect(1, 1732, '\p{^Jg=tehmarbutagoal}', "");
    Expect(1, 1732, '\P{Jg=tehmarbutagoal}', "");
    Expect(0, 1732, '\P{^Jg=tehmarbutagoal}', "");
    Expect(1, 1731, '\p{Jg=:\Atehmarbutagoal\z:}', "");;
    Expect(0, 1732, '\p{Jg=:\Atehmarbutagoal\z:}', "");;
    Expect(1, 1731, '\p{Jg=_teh_Marbuta_goal}', "");
    Expect(0, 1731, '\p{^Jg=_teh_Marbuta_goal}', "");
    Expect(0, 1731, '\P{Jg=_teh_Marbuta_goal}', "");
    Expect(1, 1731, '\P{^Jg=_teh_Marbuta_goal}', "");
    Expect(0, 1732, '\p{Jg=_teh_Marbuta_goal}', "");
    Expect(1, 1732, '\p{^Jg=_teh_Marbuta_goal}', "");
    Expect(1, 1732, '\P{Jg=_teh_Marbuta_goal}', "");
    Expect(0, 1732, '\P{^Jg=_teh_Marbuta_goal}', "");
    Error('\p{Is_Joining_Group=:=_HAMZA_on_HEH_GOAL}');
    Error('\P{Is_Joining_Group=:=_HAMZA_on_HEH_GOAL}');
    Expect(1, 1731, '\p{Is_Joining_Group:hamzaonhehgoal}', "");
    Expect(0, 1731, '\p{^Is_Joining_Group:hamzaonhehgoal}', "");
    Expect(0, 1731, '\P{Is_Joining_Group:hamzaonhehgoal}', "");
    Expect(1, 1731, '\P{^Is_Joining_Group:hamzaonhehgoal}', "");
    Expect(0, 1732, '\p{Is_Joining_Group:hamzaonhehgoal}', "");
    Expect(1, 1732, '\p{^Is_Joining_Group:hamzaonhehgoal}', "");
    Expect(1, 1732, '\P{Is_Joining_Group:hamzaonhehgoal}', "");
    Expect(0, 1732, '\P{^Is_Joining_Group:hamzaonhehgoal}', "");
    Expect(1, 1731, '\p{Is_Joining_Group:		hamza_on_HEH_Goal}', "");
    Expect(0, 1731, '\p{^Is_Joining_Group:		hamza_on_HEH_Goal}', "");
    Expect(0, 1731, '\P{Is_Joining_Group:		hamza_on_HEH_Goal}', "");
    Expect(1, 1731, '\P{^Is_Joining_Group:		hamza_on_HEH_Goal}', "");
    Expect(0, 1732, '\p{Is_Joining_Group:		hamza_on_HEH_Goal}', "");
    Expect(1, 1732, '\p{^Is_Joining_Group:		hamza_on_HEH_Goal}', "");
    Expect(1, 1732, '\P{Is_Joining_Group:		hamza_on_HEH_Goal}', "");
    Expect(0, 1732, '\P{^Is_Joining_Group:		hamza_on_HEH_Goal}', "");
    Error('\p{Is_Jg:   -/a/Teh_MARBUTA_GOAL}');
    Error('\P{Is_Jg:   -/a/Teh_MARBUTA_GOAL}');
    Expect(1, 1731, '\p{Is_Jg=tehmarbutagoal}', "");
    Expect(0, 1731, '\p{^Is_Jg=tehmarbutagoal}', "");
    Expect(0, 1731, '\P{Is_Jg=tehmarbutagoal}', "");
    Expect(1, 1731, '\P{^Is_Jg=tehmarbutagoal}', "");
    Expect(0, 1732, '\p{Is_Jg=tehmarbutagoal}', "");
    Expect(1, 1732, '\p{^Is_Jg=tehmarbutagoal}', "");
    Expect(1, 1732, '\P{Is_Jg=tehmarbutagoal}', "");
    Expect(0, 1732, '\P{^Is_Jg=tehmarbutagoal}', "");
    Expect(1, 1731, '\p{Is_Jg=	_Teh_Marbuta_Goal}', "");
    Expect(0, 1731, '\p{^Is_Jg=	_Teh_Marbuta_Goal}', "");
    Expect(0, 1731, '\P{Is_Jg=	_Teh_Marbuta_Goal}', "");
    Expect(1, 1731, '\P{^Is_Jg=	_Teh_Marbuta_Goal}', "");
    Expect(0, 1732, '\p{Is_Jg=	_Teh_Marbuta_Goal}', "");
    Expect(1, 1732, '\p{^Is_Jg=	_Teh_Marbuta_Goal}', "");
    Expect(1, 1732, '\P{Is_Jg=	_Teh_Marbuta_Goal}', "");
    Expect(0, 1732, '\P{^Is_Jg=	_Teh_Marbuta_Goal}', "");
    Error('\p{Joining_Group=--Teth/a/}');
    Error('\P{Joining_Group=--Teth/a/}');
    Expect(1, 1820, '\p{Joining_Group=:\ATeth\z:}', "");;
    Expect(0, 1821, '\p{Joining_Group=:\ATeth\z:}', "");;
    Expect(1, 1820, '\p{Joining_Group=teth}', "");
    Expect(0, 1820, '\p{^Joining_Group=teth}', "");
    Expect(0, 1820, '\P{Joining_Group=teth}', "");
    Expect(1, 1820, '\P{^Joining_Group=teth}', "");
    Expect(0, 1821, '\p{Joining_Group=teth}', "");
    Expect(1, 1821, '\p{^Joining_Group=teth}', "");
    Expect(1, 1821, '\P{Joining_Group=teth}', "");
    Expect(0, 1821, '\P{^Joining_Group=teth}', "");
    Expect(1, 1820, '\p{Joining_Group=:\Ateth\z:}', "");;
    Expect(0, 1821, '\p{Joining_Group=:\Ateth\z:}', "");;
    Expect(1, 1820, '\p{Joining_Group=_teth}', "");
    Expect(0, 1820, '\p{^Joining_Group=_teth}', "");
    Expect(0, 1820, '\P{Joining_Group=_teth}', "");
    Expect(1, 1820, '\P{^Joining_Group=_teth}', "");
    Expect(0, 1821, '\p{Joining_Group=_teth}', "");
    Expect(1, 1821, '\p{^Joining_Group=_teth}', "");
    Expect(1, 1821, '\P{Joining_Group=_teth}', "");
    Expect(0, 1821, '\P{^Joining_Group=_teth}', "");
    Error('\p{Jg=_:=teth}');
    Error('\P{Jg=_:=teth}');
    Expect(1, 1820, '\p{Jg=:\ATeth\z:}', "");;
    Expect(0, 1821, '\p{Jg=:\ATeth\z:}', "");;
    Expect(1, 1820, '\p{Jg=teth}', "");
    Expect(0, 1820, '\p{^Jg=teth}', "");
    Expect(0, 1820, '\P{Jg=teth}', "");
    Expect(1, 1820, '\P{^Jg=teth}', "");
    Expect(0, 1821, '\p{Jg=teth}', "");
    Expect(1, 1821, '\p{^Jg=teth}', "");
    Expect(1, 1821, '\P{Jg=teth}', "");
    Expect(0, 1821, '\P{^Jg=teth}', "");
    Expect(1, 1820, '\p{Jg=:\Ateth\z:}', "");;
    Expect(0, 1821, '\p{Jg=:\Ateth\z:}', "");;
    Expect(1, 1820, '\p{Jg=_ Teth}', "");
    Expect(0, 1820, '\p{^Jg=_ Teth}', "");
    Expect(0, 1820, '\P{Jg=_ Teth}', "");
    Expect(1, 1820, '\P{^Jg=_ Teth}', "");
    Expect(0, 1821, '\p{Jg=_ Teth}', "");
    Expect(1, 1821, '\p{^Jg=_ Teth}', "");
    Expect(1, 1821, '\P{Jg=_ Teth}', "");
    Expect(0, 1821, '\P{^Jg=_ Teth}', "");
    Error('\p{Is_Joining_Group=	TETH/a/}');
    Error('\P{Is_Joining_Group=	TETH/a/}');
    Expect(1, 1820, '\p{Is_Joining_Group=teth}', "");
    Expect(0, 1820, '\p{^Is_Joining_Group=teth}', "");
    Expect(0, 1820, '\P{Is_Joining_Group=teth}', "");
    Expect(1, 1820, '\P{^Is_Joining_Group=teth}', "");
    Expect(0, 1821, '\p{Is_Joining_Group=teth}', "");
    Expect(1, 1821, '\p{^Is_Joining_Group=teth}', "");
    Expect(1, 1821, '\P{Is_Joining_Group=teth}', "");
    Expect(0, 1821, '\P{^Is_Joining_Group=teth}', "");
    Expect(1, 1820, '\p{Is_Joining_Group: __Teth}', "");
    Expect(0, 1820, '\p{^Is_Joining_Group: __Teth}', "");
    Expect(0, 1820, '\P{Is_Joining_Group: __Teth}', "");
    Expect(1, 1820, '\P{^Is_Joining_Group: __Teth}', "");
    Expect(0, 1821, '\p{Is_Joining_Group: __Teth}', "");
    Expect(1, 1821, '\p{^Is_Joining_Group: __Teth}', "");
    Expect(1, 1821, '\P{Is_Joining_Group: __Teth}', "");
    Expect(0, 1821, '\P{^Is_Joining_Group: __Teth}', "");
    Error('\p{Is_Jg= :=Teth}');
    Error('\P{Is_Jg= :=Teth}');
    Expect(1, 1820, '\p{Is_Jg=teth}', "");
    Expect(0, 1820, '\p{^Is_Jg=teth}', "");
    Expect(0, 1820, '\P{Is_Jg=teth}', "");
    Expect(1, 1820, '\P{^Is_Jg=teth}', "");
    Expect(0, 1821, '\p{Is_Jg=teth}', "");
    Expect(1, 1821, '\p{^Is_Jg=teth}', "");
    Expect(1, 1821, '\P{Is_Jg=teth}', "");
    Expect(0, 1821, '\P{^Is_Jg=teth}', "");
    Expect(1, 1820, '\p{Is_Jg: 		teth}', "");
    Expect(0, 1820, '\p{^Is_Jg: 		teth}', "");
    Expect(0, 1820, '\P{Is_Jg: 		teth}', "");
    Expect(1, 1820, '\P{^Is_Jg: 		teth}', "");
    Expect(0, 1821, '\p{Is_Jg: 		teth}', "");
    Expect(1, 1821, '\p{^Is_Jg: 		teth}', "");
    Expect(1, 1821, '\P{Is_Jg: 		teth}', "");
    Expect(0, 1821, '\P{^Is_Jg: 		teth}', "");
    Error('\p{Joining_Group=/a/__Thin_Yeh}');
    Error('\P{Joining_Group=/a/__Thin_Yeh}');
    Expect(1, 2182, '\p{Joining_Group=:\AThin_Yeh\z:}', "");;
    Expect(0, 2183, '\p{Joining_Group=:\AThin_Yeh\z:}', "");;
    Expect(1, 2182, '\p{Joining_Group=thinyeh}', "");
    Expect(0, 2182, '\p{^Joining_Group=thinyeh}', "");
    Expect(0, 2182, '\P{Joining_Group=thinyeh}', "");
    Expect(1, 2182, '\P{^Joining_Group=thinyeh}', "");
    Expect(0, 2183, '\p{Joining_Group=thinyeh}', "");
    Expect(1, 2183, '\p{^Joining_Group=thinyeh}', "");
    Expect(1, 2183, '\P{Joining_Group=thinyeh}', "");
    Expect(0, 2183, '\P{^Joining_Group=thinyeh}', "");
    Expect(1, 2182, '\p{Joining_Group=:\Athinyeh\z:}', "");;
    Expect(0, 2183, '\p{Joining_Group=:\Athinyeh\z:}', "");;
    Expect(1, 2182, '\p{Joining_Group=_THIN_Yeh}', "");
    Expect(0, 2182, '\p{^Joining_Group=_THIN_Yeh}', "");
    Expect(0, 2182, '\P{Joining_Group=_THIN_Yeh}', "");
    Expect(1, 2182, '\P{^Joining_Group=_THIN_Yeh}', "");
    Expect(0, 2183, '\p{Joining_Group=_THIN_Yeh}', "");
    Expect(1, 2183, '\p{^Joining_Group=_THIN_Yeh}', "");
    Expect(1, 2183, '\P{Joining_Group=_THIN_Yeh}', "");
    Expect(0, 2183, '\P{^Joining_Group=_THIN_Yeh}', "");
    Error('\p{Jg=:=-	THIN_YEH}');
    Error('\P{Jg=:=-	THIN_YEH}');
    Expect(1, 2182, '\p{Jg=:\AThin_Yeh\z:}', "");;
    Expect(0, 2183, '\p{Jg=:\AThin_Yeh\z:}', "");;
    Expect(1, 2182, '\p{Jg=thinyeh}', "");
    Expect(0, 2182, '\p{^Jg=thinyeh}', "");
    Expect(0, 2182, '\P{Jg=thinyeh}', "");
    Expect(1, 2182, '\P{^Jg=thinyeh}', "");
    Expect(0, 2183, '\p{Jg=thinyeh}', "");
    Expect(1, 2183, '\p{^Jg=thinyeh}', "");
    Expect(1, 2183, '\P{Jg=thinyeh}', "");
    Expect(0, 2183, '\P{^Jg=thinyeh}', "");
    Expect(1, 2182, '\p{Jg=:\Athinyeh\z:}', "");;
    Expect(0, 2183, '\p{Jg=:\Athinyeh\z:}', "");;
    Expect(1, 2182, '\p{Jg=	-thin_YEH}', "");
    Expect(0, 2182, '\p{^Jg=	-thin_YEH}', "");
    Expect(0, 2182, '\P{Jg=	-thin_YEH}', "");
    Expect(1, 2182, '\P{^Jg=	-thin_YEH}', "");
    Expect(0, 2183, '\p{Jg=	-thin_YEH}', "");
    Expect(1, 2183, '\p{^Jg=	-thin_YEH}', "");
    Expect(1, 2183, '\P{Jg=	-thin_YEH}', "");
    Expect(0, 2183, '\P{^Jg=	-thin_YEH}', "");
    Error('\p{Is_Joining_Group= -THIN_YEH:=}');
    Error('\P{Is_Joining_Group= -THIN_YEH:=}');
    Expect(1, 2182, '\p{Is_Joining_Group:thinyeh}', "");
    Expect(0, 2182, '\p{^Is_Joining_Group:thinyeh}', "");
    Expect(0, 2182, '\P{Is_Joining_Group:thinyeh}', "");
    Expect(1, 2182, '\P{^Is_Joining_Group:thinyeh}', "");
    Expect(0, 2183, '\p{Is_Joining_Group:thinyeh}', "");
    Expect(1, 2183, '\p{^Is_Joining_Group:thinyeh}', "");
    Expect(1, 2183, '\P{Is_Joining_Group:thinyeh}', "");
    Expect(0, 2183, '\P{^Is_Joining_Group:thinyeh}', "");
    Expect(1, 2182, '\p{Is_Joining_Group=-Thin_YEH}', "");
    Expect(0, 2182, '\p{^Is_Joining_Group=-Thin_YEH}', "");
    Expect(0, 2182, '\P{Is_Joining_Group=-Thin_YEH}', "");
    Expect(1, 2182, '\P{^Is_Joining_Group=-Thin_YEH}', "");
    Expect(0, 2183, '\p{Is_Joining_Group=-Thin_YEH}', "");
    Expect(1, 2183, '\p{^Is_Joining_Group=-Thin_YEH}', "");
    Expect(1, 2183, '\P{Is_Joining_Group=-Thin_YEH}', "");
    Expect(0, 2183, '\P{^Is_Joining_Group=-Thin_YEH}', "");
    Error('\p{Is_Jg=-_THIN_Yeh:=}');
    Error('\P{Is_Jg=-_THIN_Yeh:=}');
    Expect(1, 2182, '\p{Is_Jg=thinyeh}', "");
    Expect(0, 2182, '\p{^Is_Jg=thinyeh}', "");
    Expect(0, 2182, '\P{Is_Jg=thinyeh}', "");
    Expect(1, 2182, '\P{^Is_Jg=thinyeh}', "");
    Expect(0, 2183, '\p{Is_Jg=thinyeh}', "");
    Expect(1, 2183, '\p{^Is_Jg=thinyeh}', "");
    Expect(1, 2183, '\P{Is_Jg=thinyeh}', "");
    Expect(0, 2183, '\P{^Is_Jg=thinyeh}', "");
    Expect(1, 2182, '\p{Is_Jg=- Thin_Yeh}', "");
    Expect(0, 2182, '\p{^Is_Jg=- Thin_Yeh}', "");
    Expect(0, 2182, '\P{Is_Jg=- Thin_Yeh}', "");
    Expect(1, 2182, '\P{^Is_Jg=- Thin_Yeh}', "");
    Expect(0, 2183, '\p{Is_Jg=- Thin_Yeh}', "");
    Expect(1, 2183, '\p{^Is_Jg=- Thin_Yeh}', "");
    Expect(1, 2183, '\P{Is_Jg=- Thin_Yeh}', "");
    Expect(0, 2183, '\P{^Is_Jg=- Thin_Yeh}', "");
    Error('\p{Joining_Group=:= Vertical_Tail}');
    Error('\P{Joining_Group=:= Vertical_Tail}');
    Expect(1, 2190, '\p{Joining_Group=:\AVertical_Tail\z:}', "");;
    Expect(0, 2191, '\p{Joining_Group=:\AVertical_Tail\z:}', "");;
    Expect(1, 2190, '\p{Joining_Group=verticaltail}', "");
    Expect(0, 2190, '\p{^Joining_Group=verticaltail}', "");
    Expect(0, 2190, '\P{Joining_Group=verticaltail}', "");
    Expect(1, 2190, '\P{^Joining_Group=verticaltail}', "");
    Expect(0, 2191, '\p{Joining_Group=verticaltail}', "");
    Expect(1, 2191, '\p{^Joining_Group=verticaltail}', "");
    Expect(1, 2191, '\P{Joining_Group=verticaltail}', "");
    Expect(0, 2191, '\P{^Joining_Group=verticaltail}', "");
    Expect(1, 2190, '\p{Joining_Group=:\Averticaltail\z:}', "");;
    Expect(0, 2191, '\p{Joining_Group=:\Averticaltail\z:}', "");;
    Expect(1, 2190, '\p{Joining_Group=_Vertical_Tail}', "");
    Expect(0, 2190, '\p{^Joining_Group=_Vertical_Tail}', "");
    Expect(0, 2190, '\P{Joining_Group=_Vertical_Tail}', "");
    Expect(1, 2190, '\P{^Joining_Group=_Vertical_Tail}', "");
    Expect(0, 2191, '\p{Joining_Group=_Vertical_Tail}', "");
    Expect(1, 2191, '\p{^Joining_Group=_Vertical_Tail}', "");
    Expect(1, 2191, '\P{Joining_Group=_Vertical_Tail}', "");
    Expect(0, 2191, '\P{^Joining_Group=_Vertical_Tail}', "");
    Error('\p{Jg=	:=Vertical_Tail}');
    Error('\P{Jg=	:=Vertical_Tail}');
    Expect(1, 2190, '\p{Jg=:\AVertical_Tail\z:}', "");;
    Expect(0, 2191, '\p{Jg=:\AVertical_Tail\z:}', "");;
    Expect(1, 2190, '\p{Jg=verticaltail}', "");
    Expect(0, 2190, '\p{^Jg=verticaltail}', "");
    Expect(0, 2190, '\P{Jg=verticaltail}', "");
    Expect(1, 2190, '\P{^Jg=verticaltail}', "");
    Expect(0, 2191, '\p{Jg=verticaltail}', "");
    Expect(1, 2191, '\p{^Jg=verticaltail}', "");
    Expect(1, 2191, '\P{Jg=verticaltail}', "");
    Expect(0, 2191, '\P{^Jg=verticaltail}', "");
    Expect(1, 2190, '\p{Jg=:\Averticaltail\z:}', "");;
    Expect(0, 2191, '\p{Jg=:\Averticaltail\z:}', "");;
    Expect(1, 2190, '\p{Jg:   	Vertical_Tail}', "");
    Expect(0, 2190, '\p{^Jg:   	Vertical_Tail}', "");
    Expect(0, 2190, '\P{Jg:   	Vertical_Tail}', "");
    Expect(1, 2190, '\P{^Jg:   	Vertical_Tail}', "");
    Expect(0, 2191, '\p{Jg:   	Vertical_Tail}', "");
    Expect(1, 2191, '\p{^Jg:   	Vertical_Tail}', "");
    Expect(1, 2191, '\P{Jg:   	Vertical_Tail}', "");
    Expect(0, 2191, '\P{^Jg:   	Vertical_Tail}', "");
    Error('\p{Is_Joining_Group:	:= VERTICAL_TAIL}');
    Error('\P{Is_Joining_Group:	:= VERTICAL_TAIL}');
    Expect(1, 2190, '\p{Is_Joining_Group:	verticaltail}', "");
    Expect(0, 2190, '\p{^Is_Joining_Group:	verticaltail}', "");
    Expect(0, 2190, '\P{Is_Joining_Group:	verticaltail}', "");
    Expect(1, 2190, '\P{^Is_Joining_Group:	verticaltail}', "");
    Expect(0, 2191, '\p{Is_Joining_Group:	verticaltail}', "");
    Expect(1, 2191, '\p{^Is_Joining_Group:	verticaltail}', "");
    Expect(1, 2191, '\P{Is_Joining_Group:	verticaltail}', "");
    Expect(0, 2191, '\P{^Is_Joining_Group:	verticaltail}', "");
    Expect(1, 2190, '\p{Is_Joining_Group=-	vertical_Tail}', "");
    Expect(0, 2190, '\p{^Is_Joining_Group=-	vertical_Tail}', "");
    Expect(0, 2190, '\P{Is_Joining_Group=-	vertical_Tail}', "");
    Expect(1, 2190, '\P{^Is_Joining_Group=-	vertical_Tail}', "");
    Expect(0, 2191, '\p{Is_Joining_Group=-	vertical_Tail}', "");
    Expect(1, 2191, '\p{^Is_Joining_Group=-	vertical_Tail}', "");
    Expect(1, 2191, '\P{Is_Joining_Group=-	vertical_Tail}', "");
    Expect(0, 2191, '\P{^Is_Joining_Group=-	vertical_Tail}', "");
    Error('\p{Is_Jg: /a/-	vertical_Tail}');
    Error('\P{Is_Jg: /a/-	vertical_Tail}');
    Expect(1, 2190, '\p{Is_Jg=verticaltail}', "");
    Expect(0, 2190, '\p{^Is_Jg=verticaltail}', "");
    Expect(0, 2190, '\P{Is_Jg=verticaltail}', "");
    Expect(1, 2190, '\P{^Is_Jg=verticaltail}', "");
    Expect(0, 2191, '\p{Is_Jg=verticaltail}', "");
    Expect(1, 2191, '\p{^Is_Jg=verticaltail}', "");
    Expect(1, 2191, '\P{Is_Jg=verticaltail}', "");
    Expect(0, 2191, '\P{^Is_Jg=verticaltail}', "");
    Expect(1, 2190, '\p{Is_Jg=_-VERTICAL_TAIL}', "");
    Expect(0, 2190, '\p{^Is_Jg=_-VERTICAL_TAIL}', "");
    Expect(0, 2190, '\P{Is_Jg=_-VERTICAL_TAIL}', "");
    Expect(1, 2190, '\P{^Is_Jg=_-VERTICAL_TAIL}', "");
    Expect(0, 2191, '\p{Is_Jg=_-VERTICAL_TAIL}', "");
    Expect(1, 2191, '\p{^Is_Jg=_-VERTICAL_TAIL}', "");
    Expect(1, 2191, '\P{Is_Jg=_-VERTICAL_TAIL}', "");
    Expect(0, 2191, '\P{^Is_Jg=_-VERTICAL_TAIL}', "");
    Error('\p{Joining_Group=/a/waw}');
    Error('\P{Joining_Group=/a/waw}');
    Expect(1, 2219, '\p{Joining_Group=:\AWaw\z:}', "");;
    Expect(0, 2220, '\p{Joining_Group=:\AWaw\z:}', "");;
    Expect(1, 2219, '\p{Joining_Group=waw}', "");
    Expect(0, 2219, '\p{^Joining_Group=waw}', "");
    Expect(0, 2219, '\P{Joining_Group=waw}', "");
    Expect(1, 2219, '\P{^Joining_Group=waw}', "");
    Expect(0, 2220, '\p{Joining_Group=waw}', "");
    Expect(1, 2220, '\p{^Joining_Group=waw}', "");
    Expect(1, 2220, '\P{Joining_Group=waw}', "");
    Expect(0, 2220, '\P{^Joining_Group=waw}', "");
    Expect(1, 2219, '\p{Joining_Group=:\Awaw\z:}', "");;
    Expect(0, 2220, '\p{Joining_Group=:\Awaw\z:}', "");;
    Expect(1, 2219, '\p{Joining_Group= _Waw}', "");
    Expect(0, 2219, '\p{^Joining_Group= _Waw}', "");
    Expect(0, 2219, '\P{Joining_Group= _Waw}', "");
    Expect(1, 2219, '\P{^Joining_Group= _Waw}', "");
    Expect(0, 2220, '\p{Joining_Group= _Waw}', "");
    Expect(1, 2220, '\p{^Joining_Group= _Waw}', "");
    Expect(1, 2220, '\P{Joining_Group= _Waw}', "");
    Expect(0, 2220, '\P{^Joining_Group= _Waw}', "");
    Error('\p{Jg=:=  Waw}');
    Error('\P{Jg=:=  Waw}');
    Expect(1, 2219, '\p{Jg=:\AWaw\z:}', "");;
    Expect(0, 2220, '\p{Jg=:\AWaw\z:}', "");;
    Expect(1, 2219, '\p{Jg=waw}', "");
    Expect(0, 2219, '\p{^Jg=waw}', "");
    Expect(0, 2219, '\P{Jg=waw}', "");
    Expect(1, 2219, '\P{^Jg=waw}', "");
    Expect(0, 2220, '\p{Jg=waw}', "");
    Expect(1, 2220, '\p{^Jg=waw}', "");
    Expect(1, 2220, '\P{Jg=waw}', "");
    Expect(0, 2220, '\P{^Jg=waw}', "");
    Expect(1, 2219, '\p{Jg=:\Awaw\z:}', "");;
    Expect(0, 2220, '\p{Jg=:\Awaw\z:}', "");;
    Expect(1, 2219, '\p{Jg= 	Waw}', "");
    Expect(0, 2219, '\p{^Jg= 	Waw}', "");
    Expect(0, 2219, '\P{Jg= 	Waw}', "");
    Expect(1, 2219, '\P{^Jg= 	Waw}', "");
    Expect(0, 2220, '\p{Jg= 	Waw}', "");
    Expect(1, 2220, '\p{^Jg= 	Waw}', "");
    Expect(1, 2220, '\P{Jg= 	Waw}', "");
    Expect(0, 2220, '\P{^Jg= 	Waw}', "");
    Error('\p{Is_Joining_Group=	Waw/a/}');
    Error('\P{Is_Joining_Group=	Waw/a/}');
    Expect(1, 2219, '\p{Is_Joining_Group=waw}', "");
    Expect(0, 2219, '\p{^Is_Joining_Group=waw}', "");
    Expect(0, 2219, '\P{Is_Joining_Group=waw}', "");
    Expect(1, 2219, '\P{^Is_Joining_Group=waw}', "");
    Expect(0, 2220, '\p{Is_Joining_Group=waw}', "");
    Expect(1, 2220, '\p{^Is_Joining_Group=waw}', "");
    Expect(1, 2220, '\P{Is_Joining_Group=waw}', "");
    Expect(0, 2220, '\P{^Is_Joining_Group=waw}', "");
    Expect(1, 2219, '\p{Is_Joining_Group=	 Waw}', "");
    Expect(0, 2219, '\p{^Is_Joining_Group=	 Waw}', "");
    Expect(0, 2219, '\P{Is_Joining_Group=	 Waw}', "");
    Expect(1, 2219, '\P{^Is_Joining_Group=	 Waw}', "");
    Expect(0, 2220, '\p{Is_Joining_Group=	 Waw}', "");
    Expect(1, 2220, '\p{^Is_Joining_Group=	 Waw}', "");
    Expect(1, 2220, '\P{Is_Joining_Group=	 Waw}', "");
    Expect(0, 2220, '\P{^Is_Joining_Group=	 Waw}', "");
    Error('\p{Is_Jg= :=Waw}');
    Error('\P{Is_Jg= :=Waw}');
    Expect(1, 2219, '\p{Is_Jg=waw}', "");
    Expect(0, 2219, '\p{^Is_Jg=waw}', "");
    Expect(0, 2219, '\P{Is_Jg=waw}', "");
    Expect(1, 2219, '\P{^Is_Jg=waw}', "");
    Expect(0, 2220, '\p{Is_Jg=waw}', "");
    Expect(1, 2220, '\p{^Is_Jg=waw}', "");
    Expect(1, 2220, '\P{Is_Jg=waw}', "");
    Expect(0, 2220, '\P{^Is_Jg=waw}', "");
    Expect(1, 2219, '\p{Is_Jg= _WAW}', "");
    Expect(0, 2219, '\p{^Is_Jg= _WAW}', "");
    Expect(0, 2219, '\P{Is_Jg= _WAW}', "");
    Expect(1, 2219, '\P{^Is_Jg= _WAW}', "");
    Expect(0, 2220, '\p{Is_Jg= _WAW}', "");
    Expect(1, 2220, '\p{^Is_Jg= _WAW}', "");
    Expect(1, 2220, '\P{Is_Jg= _WAW}', "");
    Expect(0, 2220, '\P{^Is_Jg= _WAW}', "");
    Error('\p{Joining_Group=-Yeh:=}');
    Error('\P{Joining_Group=-Yeh:=}');
    Expect(1, 2234, '\p{Joining_Group=:\AYeh\z:}', "");;
    Expect(0, 2235, '\p{Joining_Group=:\AYeh\z:}', "");;
    Expect(1, 2234, '\p{Joining_Group=yeh}', "");
    Expect(0, 2234, '\p{^Joining_Group=yeh}', "");
    Expect(0, 2234, '\P{Joining_Group=yeh}', "");
    Expect(1, 2234, '\P{^Joining_Group=yeh}', "");
    Expect(0, 2235, '\p{Joining_Group=yeh}', "");
    Expect(1, 2235, '\p{^Joining_Group=yeh}', "");
    Expect(1, 2235, '\P{Joining_Group=yeh}', "");
    Expect(0, 2235, '\P{^Joining_Group=yeh}', "");
    Expect(1, 2234, '\p{Joining_Group=:\Ayeh\z:}', "");;
    Expect(0, 2235, '\p{Joining_Group=:\Ayeh\z:}', "");;
    Expect(1, 2234, '\p{Joining_Group=__YEH}', "");
    Expect(0, 2234, '\p{^Joining_Group=__YEH}', "");
    Expect(0, 2234, '\P{Joining_Group=__YEH}', "");
    Expect(1, 2234, '\P{^Joining_Group=__YEH}', "");
    Expect(0, 2235, '\p{Joining_Group=__YEH}', "");
    Expect(1, 2235, '\p{^Joining_Group=__YEH}', "");
    Expect(1, 2235, '\P{Joining_Group=__YEH}', "");
    Expect(0, 2235, '\P{^Joining_Group=__YEH}', "");
    Error('\p{Jg: -YEH/a/}');
    Error('\P{Jg: -YEH/a/}');
    Expect(1, 2234, '\p{Jg=:\AYeh\z:}', "");;
    Expect(0, 2235, '\p{Jg=:\AYeh\z:}', "");;
    Expect(1, 2234, '\p{Jg=yeh}', "");
    Expect(0, 2234, '\p{^Jg=yeh}', "");
    Expect(0, 2234, '\P{Jg=yeh}', "");
    Expect(1, 2234, '\P{^Jg=yeh}', "");
    Expect(0, 2235, '\p{Jg=yeh}', "");
    Expect(1, 2235, '\p{^Jg=yeh}', "");
    Expect(1, 2235, '\P{Jg=yeh}', "");
    Expect(0, 2235, '\P{^Jg=yeh}', "");
    Expect(1, 2234, '\p{Jg=:\Ayeh\z:}', "");;
    Expect(0, 2235, '\p{Jg=:\Ayeh\z:}', "");;
    Expect(1, 2234, '\p{Jg=_	Yeh}', "");
    Expect(0, 2234, '\p{^Jg=_	Yeh}', "");
    Expect(0, 2234, '\P{Jg=_	Yeh}', "");
    Expect(1, 2234, '\P{^Jg=_	Yeh}', "");
    Expect(0, 2235, '\p{Jg=_	Yeh}', "");
    Expect(1, 2235, '\p{^Jg=_	Yeh}', "");
    Expect(1, 2235, '\P{Jg=_	Yeh}', "");
    Expect(0, 2235, '\P{^Jg=_	Yeh}', "");
    Error('\p{Is_Joining_Group=/a/	-yeh}');
    Error('\P{Is_Joining_Group=/a/	-yeh}');
    Expect(1, 2234, '\p{Is_Joining_Group=yeh}', "");
    Expect(0, 2234, '\p{^Is_Joining_Group=yeh}', "");
    Expect(0, 2234, '\P{Is_Joining_Group=yeh}', "");
    Expect(1, 2234, '\P{^Is_Joining_Group=yeh}', "");
    Expect(0, 2235, '\p{Is_Joining_Group=yeh}', "");
    Expect(1, 2235, '\p{^Is_Joining_Group=yeh}', "");
    Expect(1, 2235, '\P{Is_Joining_Group=yeh}', "");
    Expect(0, 2235, '\P{^Is_Joining_Group=yeh}', "");
    Expect(1, 2234, '\p{Is_Joining_Group=  Yeh}', "");
    Expect(0, 2234, '\p{^Is_Joining_Group=  Yeh}', "");
    Expect(0, 2234, '\P{Is_Joining_Group=  Yeh}', "");
    Expect(1, 2234, '\P{^Is_Joining_Group=  Yeh}', "");
    Expect(0, 2235, '\p{Is_Joining_Group=  Yeh}', "");
    Expect(1, 2235, '\p{^Is_Joining_Group=  Yeh}', "");
    Expect(1, 2235, '\P{Is_Joining_Group=  Yeh}', "");
    Expect(0, 2235, '\P{^Is_Joining_Group=  Yeh}', "");
    Error('\p{Is_Jg=_Yeh/a/}');
    Error('\P{Is_Jg=_Yeh/a/}');
    Expect(1, 2234, '\p{Is_Jg=yeh}', "");
    Expect(0, 2234, '\p{^Is_Jg=yeh}', "");
    Expect(0, 2234, '\P{Is_Jg=yeh}', "");
    Expect(1, 2234, '\P{^Is_Jg=yeh}', "");
    Expect(0, 2235, '\p{Is_Jg=yeh}', "");
    Expect(1, 2235, '\p{^Is_Jg=yeh}', "");
    Expect(1, 2235, '\P{Is_Jg=yeh}', "");
    Expect(0, 2235, '\P{^Is_Jg=yeh}', "");
    Expect(1, 2234, '\p{Is_Jg=  Yeh}', "");
    Expect(0, 2234, '\p{^Is_Jg=  Yeh}', "");
    Expect(0, 2234, '\P{Is_Jg=  Yeh}', "");
    Expect(1, 2234, '\P{^Is_Jg=  Yeh}', "");
    Expect(0, 2235, '\p{Is_Jg=  Yeh}', "");
    Expect(1, 2235, '\p{^Is_Jg=  Yeh}', "");
    Expect(1, 2235, '\P{Is_Jg=  Yeh}', "");
    Expect(0, 2235, '\P{^Is_Jg=  Yeh}', "");
    Error('\p{Joining_Group=- yeh_Barree:=}');
    Error('\P{Joining_Group=- yeh_Barree:=}');
    Expect(1, 1747, '\p{Joining_Group=:\AYeh_Barree\z:}', "");;
    Expect(0, 1748, '\p{Joining_Group=:\AYeh_Barree\z:}', "");;
    Expect(1, 1747, '\p{Joining_Group=yehbarree}', "");
    Expect(0, 1747, '\p{^Joining_Group=yehbarree}', "");
    Expect(0, 1747, '\P{Joining_Group=yehbarree}', "");
    Expect(1, 1747, '\P{^Joining_Group=yehbarree}', "");
    Expect(0, 1748, '\p{Joining_Group=yehbarree}', "");
    Expect(1, 1748, '\p{^Joining_Group=yehbarree}', "");
    Expect(1, 1748, '\P{Joining_Group=yehbarree}', "");
    Expect(0, 1748, '\P{^Joining_Group=yehbarree}', "");
    Expect(1, 1747, '\p{Joining_Group=:\Ayehbarree\z:}', "");;
    Expect(0, 1748, '\p{Joining_Group=:\Ayehbarree\z:}', "");;
    Expect(1, 1747, '\p{Joining_Group:	 yeh_Barree}', "");
    Expect(0, 1747, '\p{^Joining_Group:	 yeh_Barree}', "");
    Expect(0, 1747, '\P{Joining_Group:	 yeh_Barree}', "");
    Expect(1, 1747, '\P{^Joining_Group:	 yeh_Barree}', "");
    Expect(0, 1748, '\p{Joining_Group:	 yeh_Barree}', "");
    Expect(1, 1748, '\p{^Joining_Group:	 yeh_Barree}', "");
    Expect(1, 1748, '\P{Joining_Group:	 yeh_Barree}', "");
    Expect(0, 1748, '\P{^Joining_Group:	 yeh_Barree}', "");
    Error('\p{Jg=:=	-Yeh_barree}');
    Error('\P{Jg=:=	-Yeh_barree}');
    Expect(1, 1747, '\p{Jg=:\AYeh_Barree\z:}', "");;
    Expect(0, 1748, '\p{Jg=:\AYeh_Barree\z:}', "");;
    Expect(1, 1747, '\p{Jg: yehbarree}', "");
    Expect(0, 1747, '\p{^Jg: yehbarree}', "");
    Expect(0, 1747, '\P{Jg: yehbarree}', "");
    Expect(1, 1747, '\P{^Jg: yehbarree}', "");
    Expect(0, 1748, '\p{Jg: yehbarree}', "");
    Expect(1, 1748, '\p{^Jg: yehbarree}', "");
    Expect(1, 1748, '\P{Jg: yehbarree}', "");
    Expect(0, 1748, '\P{^Jg: yehbarree}', "");
    Expect(1, 1747, '\p{Jg=:\Ayehbarree\z:}', "");;
    Expect(0, 1748, '\p{Jg=:\Ayehbarree\z:}', "");;
    Expect(1, 1747, '\p{Jg=	Yeh_barree}', "");
    Expect(0, 1747, '\p{^Jg=	Yeh_barree}', "");
    Expect(0, 1747, '\P{Jg=	Yeh_barree}', "");
    Expect(1, 1747, '\P{^Jg=	Yeh_barree}', "");
    Expect(0, 1748, '\p{Jg=	Yeh_barree}', "");
    Expect(1, 1748, '\p{^Jg=	Yeh_barree}', "");
    Expect(1, 1748, '\P{Jg=	Yeh_barree}', "");
    Expect(0, 1748, '\P{^Jg=	Yeh_barree}', "");
    Error('\p{Is_Joining_Group=/a/Yeh_Barree}');
    Error('\P{Is_Joining_Group=/a/Yeh_Barree}');
    Expect(1, 1747, '\p{Is_Joining_Group=yehbarree}', "");
    Expect(0, 1747, '\p{^Is_Joining_Group=yehbarree}', "");
    Expect(0, 1747, '\P{Is_Joining_Group=yehbarree}', "");
    Expect(1, 1747, '\P{^Is_Joining_Group=yehbarree}', "");
    Expect(0, 1748, '\p{Is_Joining_Group=yehbarree}', "");
    Expect(1, 1748, '\p{^Is_Joining_Group=yehbarree}', "");
    Expect(1, 1748, '\P{Is_Joining_Group=yehbarree}', "");
    Expect(0, 1748, '\P{^Is_Joining_Group=yehbarree}', "");
    Expect(1, 1747, '\p{Is_Joining_Group=-	Yeh_Barree}', "");
    Expect(0, 1747, '\p{^Is_Joining_Group=-	Yeh_Barree}', "");
    Expect(0, 1747, '\P{Is_Joining_Group=-	Yeh_Barree}', "");
    Expect(1, 1747, '\P{^Is_Joining_Group=-	Yeh_Barree}', "");
    Expect(0, 1748, '\p{Is_Joining_Group=-	Yeh_Barree}', "");
    Expect(1, 1748, '\p{^Is_Joining_Group=-	Yeh_Barree}', "");
    Expect(1, 1748, '\P{Is_Joining_Group=-	Yeh_Barree}', "");
    Expect(0, 1748, '\P{^Is_Joining_Group=-	Yeh_Barree}', "");
    Error('\p{Is_Jg= Yeh_BARREE:=}');
    Error('\P{Is_Jg= Yeh_BARREE:=}');
    Expect(1, 1747, '\p{Is_Jg=yehbarree}', "");
    Expect(0, 1747, '\p{^Is_Jg=yehbarree}', "");
    Expect(0, 1747, '\P{Is_Jg=yehbarree}', "");
    Expect(1, 1747, '\P{^Is_Jg=yehbarree}', "");
    Expect(0, 1748, '\p{Is_Jg=yehbarree}', "");
    Expect(1, 1748, '\p{^Is_Jg=yehbarree}', "");
    Expect(1, 1748, '\P{Is_Jg=yehbarree}', "");
    Expect(0, 1748, '\P{^Is_Jg=yehbarree}', "");
    Expect(1, 1747, '\p{Is_Jg=_Yeh_BARREE}', "");
    Expect(0, 1747, '\p{^Is_Jg=_Yeh_BARREE}', "");
    Expect(0, 1747, '\P{Is_Jg=_Yeh_BARREE}', "");
    Expect(1, 1747, '\P{^Is_Jg=_Yeh_BARREE}', "");
    Expect(0, 1748, '\p{Is_Jg=_Yeh_BARREE}', "");
    Expect(1, 1748, '\p{^Is_Jg=_Yeh_BARREE}', "");
    Expect(1, 1748, '\P{Is_Jg=_Yeh_BARREE}', "");
    Expect(0, 1748, '\P{^Is_Jg=_Yeh_BARREE}', "");
    Error('\p{Joining_Group:    -yeh_With_Tail/a/}');
    Error('\P{Joining_Group:    -yeh_With_Tail/a/}');
    Expect(1, 1741, '\p{Joining_Group=:\AYeh_With_Tail\z:}', "");;
    Expect(0, 1742, '\p{Joining_Group=:\AYeh_With_Tail\z:}', "");;
    Expect(1, 1741, '\p{Joining_Group: yehwithtail}', "");
    Expect(0, 1741, '\p{^Joining_Group: yehwithtail}', "");
    Expect(0, 1741, '\P{Joining_Group: yehwithtail}', "");
    Expect(1, 1741, '\P{^Joining_Group: yehwithtail}', "");
    Expect(0, 1742, '\p{Joining_Group: yehwithtail}', "");
    Expect(1, 1742, '\p{^Joining_Group: yehwithtail}', "");
    Expect(1, 1742, '\P{Joining_Group: yehwithtail}', "");
    Expect(0, 1742, '\P{^Joining_Group: yehwithtail}', "");
    Expect(1, 1741, '\p{Joining_Group=:\Ayehwithtail\z:}', "");;
    Expect(0, 1742, '\p{Joining_Group=:\Ayehwithtail\z:}', "");;
    Expect(1, 1741, '\p{Joining_Group= Yeh_with_tail}', "");
    Expect(0, 1741, '\p{^Joining_Group= Yeh_with_tail}', "");
    Expect(0, 1741, '\P{Joining_Group= Yeh_with_tail}', "");
    Expect(1, 1741, '\P{^Joining_Group= Yeh_with_tail}', "");
    Expect(0, 1742, '\p{Joining_Group= Yeh_with_tail}', "");
    Expect(1, 1742, '\p{^Joining_Group= Yeh_with_tail}', "");
    Expect(1, 1742, '\P{Joining_Group= Yeh_with_tail}', "");
    Expect(0, 1742, '\P{^Joining_Group= Yeh_with_tail}', "");
    Error('\p{Jg=		Yeh_With_Tail/a/}');
    Error('\P{Jg=		Yeh_With_Tail/a/}');
    Expect(1, 1741, '\p{Jg=:\AYeh_With_Tail\z:}', "");;
    Expect(0, 1742, '\p{Jg=:\AYeh_With_Tail\z:}', "");;
    Expect(1, 1741, '\p{Jg=yehwithtail}', "");
    Expect(0, 1741, '\p{^Jg=yehwithtail}', "");
    Expect(0, 1741, '\P{Jg=yehwithtail}', "");
    Expect(1, 1741, '\P{^Jg=yehwithtail}', "");
    Expect(0, 1742, '\p{Jg=yehwithtail}', "");
    Expect(1, 1742, '\p{^Jg=yehwithtail}', "");
    Expect(1, 1742, '\P{Jg=yehwithtail}', "");
    Expect(0, 1742, '\P{^Jg=yehwithtail}', "");
    Expect(1, 1741, '\p{Jg=:\Ayehwithtail\z:}', "");;
    Expect(0, 1742, '\p{Jg=:\Ayehwithtail\z:}', "");;
    Expect(1, 1741, '\p{Jg= YEH_With_Tail}', "");
    Expect(0, 1741, '\p{^Jg= YEH_With_Tail}', "");
    Expect(0, 1741, '\P{Jg= YEH_With_Tail}', "");
    Expect(1, 1741, '\P{^Jg= YEH_With_Tail}', "");
    Expect(0, 1742, '\p{Jg= YEH_With_Tail}', "");
    Expect(1, 1742, '\p{^Jg= YEH_With_Tail}', "");
    Expect(1, 1742, '\P{Jg= YEH_With_Tail}', "");
    Expect(0, 1742, '\P{^Jg= YEH_With_Tail}', "");
    Error('\p{Is_Joining_Group=:=- Yeh_With_Tail}');
    Error('\P{Is_Joining_Group=:=- Yeh_With_Tail}');
    Expect(1, 1741, '\p{Is_Joining_Group=yehwithtail}', "");
    Expect(0, 1741, '\p{^Is_Joining_Group=yehwithtail}', "");
    Expect(0, 1741, '\P{Is_Joining_Group=yehwithtail}', "");
    Expect(1, 1741, '\P{^Is_Joining_Group=yehwithtail}', "");
    Expect(0, 1742, '\p{Is_Joining_Group=yehwithtail}', "");
    Expect(1, 1742, '\p{^Is_Joining_Group=yehwithtail}', "");
    Expect(1, 1742, '\P{Is_Joining_Group=yehwithtail}', "");
    Expect(0, 1742, '\P{^Is_Joining_Group=yehwithtail}', "");
    Expect(1, 1741, '\p{Is_Joining_Group=-_yeh_WITH_Tail}', "");
    Expect(0, 1741, '\p{^Is_Joining_Group=-_yeh_WITH_Tail}', "");
    Expect(0, 1741, '\P{Is_Joining_Group=-_yeh_WITH_Tail}', "");
    Expect(1, 1741, '\P{^Is_Joining_Group=-_yeh_WITH_Tail}', "");
    Expect(0, 1742, '\p{Is_Joining_Group=-_yeh_WITH_Tail}', "");
    Expect(1, 1742, '\p{^Is_Joining_Group=-_yeh_WITH_Tail}', "");
    Expect(1, 1742, '\P{Is_Joining_Group=-_yeh_WITH_Tail}', "");
    Expect(0, 1742, '\P{^Is_Joining_Group=-_yeh_WITH_Tail}', "");
    Error('\p{Is_Jg=--yeh_WITH_TAIL:=}');
    Error('\P{Is_Jg=--yeh_WITH_TAIL:=}');
    Expect(1, 1741, '\p{Is_Jg=yehwithtail}', "");
    Expect(0, 1741, '\p{^Is_Jg=yehwithtail}', "");
    Expect(0, 1741, '\P{Is_Jg=yehwithtail}', "");
    Expect(1, 1741, '\P{^Is_Jg=yehwithtail}', "");
    Expect(0, 1742, '\p{Is_Jg=yehwithtail}', "");
    Expect(1, 1742, '\p{^Is_Jg=yehwithtail}', "");
    Expect(1, 1742, '\P{Is_Jg=yehwithtail}', "");
    Expect(0, 1742, '\P{^Is_Jg=yehwithtail}', "");
    Expect(1, 1741, '\p{Is_Jg=	_yeh_with_Tail}', "");
    Expect(0, 1741, '\p{^Is_Jg=	_yeh_with_Tail}', "");
    Expect(0, 1741, '\P{Is_Jg=	_yeh_with_Tail}', "");
    Expect(1, 1741, '\P{^Is_Jg=	_yeh_with_Tail}', "");
    Expect(0, 1742, '\p{Is_Jg=	_yeh_with_Tail}', "");
    Expect(1, 1742, '\p{^Is_Jg=	_yeh_with_Tail}', "");
    Expect(1, 1742, '\P{Is_Jg=	_yeh_with_Tail}', "");
    Expect(0, 1742, '\P{^Is_Jg=	_yeh_with_Tail}', "");
    Error('\p{Joining_Group=:=  yudh}');
    Error('\P{Joining_Group=:=  yudh}');
    Expect(1, 1821, '\p{Joining_Group=:\AYudh\z:}', "");;
    Expect(0, 1822, '\p{Joining_Group=:\AYudh\z:}', "");;
    Expect(1, 1821, '\p{Joining_Group=yudh}', "");
    Expect(0, 1821, '\p{^Joining_Group=yudh}', "");
    Expect(0, 1821, '\P{Joining_Group=yudh}', "");
    Expect(1, 1821, '\P{^Joining_Group=yudh}', "");
    Expect(0, 1822, '\p{Joining_Group=yudh}', "");
    Expect(1, 1822, '\p{^Joining_Group=yudh}', "");
    Expect(1, 1822, '\P{Joining_Group=yudh}', "");
    Expect(0, 1822, '\P{^Joining_Group=yudh}', "");
    Expect(1, 1821, '\p{Joining_Group=:\Ayudh\z:}', "");;
    Expect(0, 1822, '\p{Joining_Group=:\Ayudh\z:}', "");;
    Expect(1, 1821, '\p{Joining_Group=_	YUDH}', "");
    Expect(0, 1821, '\p{^Joining_Group=_	YUDH}', "");
    Expect(0, 1821, '\P{Joining_Group=_	YUDH}', "");
    Expect(1, 1821, '\P{^Joining_Group=_	YUDH}', "");
    Expect(0, 1822, '\p{Joining_Group=_	YUDH}', "");
    Expect(1, 1822, '\p{^Joining_Group=_	YUDH}', "");
    Expect(1, 1822, '\P{Joining_Group=_	YUDH}', "");
    Expect(0, 1822, '\P{^Joining_Group=_	YUDH}', "");
    Error('\p{Jg=_:=YUDH}');
    Error('\P{Jg=_:=YUDH}');
    Expect(1, 1821, '\p{Jg=:\AYudh\z:}', "");;
    Expect(0, 1822, '\p{Jg=:\AYudh\z:}', "");;
    Expect(1, 1821, '\p{Jg: yudh}', "");
    Expect(0, 1821, '\p{^Jg: yudh}', "");
    Expect(0, 1821, '\P{Jg: yudh}', "");
    Expect(1, 1821, '\P{^Jg: yudh}', "");
    Expect(0, 1822, '\p{Jg: yudh}', "");
    Expect(1, 1822, '\p{^Jg: yudh}', "");
    Expect(1, 1822, '\P{Jg: yudh}', "");
    Expect(0, 1822, '\P{^Jg: yudh}', "");
    Expect(1, 1821, '\p{Jg=:\Ayudh\z:}', "");;
    Expect(0, 1822, '\p{Jg=:\Ayudh\z:}', "");;
    Expect(1, 1821, '\p{Jg=_Yudh}', "");
    Expect(0, 1821, '\p{^Jg=_Yudh}', "");
    Expect(0, 1821, '\P{Jg=_Yudh}', "");
    Expect(1, 1821, '\P{^Jg=_Yudh}', "");
    Expect(0, 1822, '\p{Jg=_Yudh}', "");
    Expect(1, 1822, '\p{^Jg=_Yudh}', "");
    Expect(1, 1822, '\P{Jg=_Yudh}', "");
    Expect(0, 1822, '\P{^Jg=_Yudh}', "");
    Error('\p{Is_Joining_Group=_-YUDH/a/}');
    Error('\P{Is_Joining_Group=_-YUDH/a/}');
    Expect(1, 1821, '\p{Is_Joining_Group=yudh}', "");
    Expect(0, 1821, '\p{^Is_Joining_Group=yudh}', "");
    Expect(0, 1821, '\P{Is_Joining_Group=yudh}', "");
    Expect(1, 1821, '\P{^Is_Joining_Group=yudh}', "");
    Expect(0, 1822, '\p{Is_Joining_Group=yudh}', "");
    Expect(1, 1822, '\p{^Is_Joining_Group=yudh}', "");
    Expect(1, 1822, '\P{Is_Joining_Group=yudh}', "");
    Expect(0, 1822, '\P{^Is_Joining_Group=yudh}', "");
    Expect(1, 1821, '\p{Is_Joining_Group:	 	Yudh}', "");
    Expect(0, 1821, '\p{^Is_Joining_Group:	 	Yudh}', "");
    Expect(0, 1821, '\P{Is_Joining_Group:	 	Yudh}', "");
    Expect(1, 1821, '\P{^Is_Joining_Group:	 	Yudh}', "");
    Expect(0, 1822, '\p{Is_Joining_Group:	 	Yudh}', "");
    Expect(1, 1822, '\p{^Is_Joining_Group:	 	Yudh}', "");
    Expect(1, 1822, '\P{Is_Joining_Group:	 	Yudh}', "");
    Expect(0, 1822, '\P{^Is_Joining_Group:	 	Yudh}', "");
    Error('\p{Is_Jg=-YUDH/a/}');
    Error('\P{Is_Jg=-YUDH/a/}');
    Expect(1, 1821, '\p{Is_Jg=yudh}', "");
    Expect(0, 1821, '\p{^Is_Jg=yudh}', "");
    Expect(0, 1821, '\P{Is_Jg=yudh}', "");
    Expect(1, 1821, '\P{^Is_Jg=yudh}', "");
    Expect(0, 1822, '\p{Is_Jg=yudh}', "");
    Expect(1, 1822, '\p{^Is_Jg=yudh}', "");
    Expect(1, 1822, '\P{Is_Jg=yudh}', "");
    Expect(0, 1822, '\P{^Is_Jg=yudh}', "");
    Expect(1, 1821, '\p{Is_Jg=-	Yudh}', "");
    Expect(0, 1821, '\p{^Is_Jg=-	Yudh}', "");
    Expect(0, 1821, '\P{Is_Jg=-	Yudh}', "");
    Expect(1, 1821, '\P{^Is_Jg=-	Yudh}', "");
    Expect(0, 1822, '\p{Is_Jg=-	Yudh}', "");
    Expect(1, 1822, '\p{^Is_Jg=-	Yudh}', "");
    Expect(1, 1822, '\P{Is_Jg=-	Yudh}', "");
    Expect(0, 1822, '\P{^Is_Jg=-	Yudh}', "");
    Error('\p{Joining_Group=_:=Yudh_he}');
    Error('\P{Joining_Group=_:=Yudh_he}');
    Expect(1, 1822, '\p{Joining_Group=:\AYudh_He\z:}', "");;
    Expect(0, 1823, '\p{Joining_Group=:\AYudh_He\z:}', "");;
    Expect(1, 1822, '\p{Joining_Group=yudhhe}', "");
    Expect(0, 1822, '\p{^Joining_Group=yudhhe}', "");
    Expect(0, 1822, '\P{Joining_Group=yudhhe}', "");
    Expect(1, 1822, '\P{^Joining_Group=yudhhe}', "");
    Expect(0, 1823, '\p{Joining_Group=yudhhe}', "");
    Expect(1, 1823, '\p{^Joining_Group=yudhhe}', "");
    Expect(1, 1823, '\P{Joining_Group=yudhhe}', "");
    Expect(0, 1823, '\P{^Joining_Group=yudhhe}', "");
    Expect(1, 1822, '\p{Joining_Group=:\Ayudhhe\z:}', "");;
    Expect(0, 1823, '\p{Joining_Group=:\Ayudhhe\z:}', "");;
    Expect(1, 1822, '\p{Joining_Group= yudh_He}', "");
    Expect(0, 1822, '\p{^Joining_Group= yudh_He}', "");
    Expect(0, 1822, '\P{Joining_Group= yudh_He}', "");
    Expect(1, 1822, '\P{^Joining_Group= yudh_He}', "");
    Expect(0, 1823, '\p{Joining_Group= yudh_He}', "");
    Expect(1, 1823, '\p{^Joining_Group= yudh_He}', "");
    Expect(1, 1823, '\P{Joining_Group= yudh_He}', "");
    Expect(0, 1823, '\P{^Joining_Group= yudh_He}', "");
    Error('\p{Jg=:=-YUDH_HE}');
    Error('\P{Jg=:=-YUDH_HE}');
    Expect(1, 1822, '\p{Jg=:\AYudh_He\z:}', "");;
    Expect(0, 1823, '\p{Jg=:\AYudh_He\z:}', "");;
    Expect(1, 1822, '\p{Jg=yudhhe}', "");
    Expect(0, 1822, '\p{^Jg=yudhhe}', "");
    Expect(0, 1822, '\P{Jg=yudhhe}', "");
    Expect(1, 1822, '\P{^Jg=yudhhe}', "");
    Expect(0, 1823, '\p{Jg=yudhhe}', "");
    Expect(1, 1823, '\p{^Jg=yudhhe}', "");
    Expect(1, 1823, '\P{Jg=yudhhe}', "");
    Expect(0, 1823, '\P{^Jg=yudhhe}', "");
    Expect(1, 1822, '\p{Jg=:\Ayudhhe\z:}', "");;
    Expect(0, 1823, '\p{Jg=:\Ayudhhe\z:}', "");;
    Expect(1, 1822, '\p{Jg=-Yudh_He}', "");
    Expect(0, 1822, '\p{^Jg=-Yudh_He}', "");
    Expect(0, 1822, '\P{Jg=-Yudh_He}', "");
    Expect(1, 1822, '\P{^Jg=-Yudh_He}', "");
    Expect(0, 1823, '\p{Jg=-Yudh_He}', "");
    Expect(1, 1823, '\p{^Jg=-Yudh_He}', "");
    Expect(1, 1823, '\P{Jg=-Yudh_He}', "");
    Expect(0, 1823, '\P{^Jg=-Yudh_He}', "");
    Error('\p{Is_Joining_Group=:=yudh_HE}');
    Error('\P{Is_Joining_Group=:=yudh_HE}');
    Expect(1, 1822, '\p{Is_Joining_Group=yudhhe}', "");
    Expect(0, 1822, '\p{^Is_Joining_Group=yudhhe}', "");
    Expect(0, 1822, '\P{Is_Joining_Group=yudhhe}', "");
    Expect(1, 1822, '\P{^Is_Joining_Group=yudhhe}', "");
    Expect(0, 1823, '\p{Is_Joining_Group=yudhhe}', "");
    Expect(1, 1823, '\p{^Is_Joining_Group=yudhhe}', "");
    Expect(1, 1823, '\P{Is_Joining_Group=yudhhe}', "");
    Expect(0, 1823, '\P{^Is_Joining_Group=yudhhe}', "");
    Expect(1, 1822, '\p{Is_Joining_Group= 	Yudh_He}', "");
    Expect(0, 1822, '\p{^Is_Joining_Group= 	Yudh_He}', "");
    Expect(0, 1822, '\P{Is_Joining_Group= 	Yudh_He}', "");
    Expect(1, 1822, '\P{^Is_Joining_Group= 	Yudh_He}', "");
    Expect(0, 1823, '\p{Is_Joining_Group= 	Yudh_He}', "");
    Expect(1, 1823, '\p{^Is_Joining_Group= 	Yudh_He}', "");
    Expect(1, 1823, '\P{Is_Joining_Group= 	Yudh_He}', "");
    Expect(0, 1823, '\P{^Is_Joining_Group= 	Yudh_He}', "");
    Error('\p{Is_Jg=:=Yudh_HE}');
    Error('\P{Is_Jg=:=Yudh_HE}');
    Expect(1, 1822, '\p{Is_Jg=yudhhe}', "");
    Expect(0, 1822, '\p{^Is_Jg=yudhhe}', "");
    Expect(0, 1822, '\P{Is_Jg=yudhhe}', "");
    Expect(1, 1822, '\P{^Is_Jg=yudhhe}', "");
    Expect(0, 1823, '\p{Is_Jg=yudhhe}', "");
    Expect(1, 1823, '\p{^Is_Jg=yudhhe}', "");
    Expect(1, 1823, '\P{Is_Jg=yudhhe}', "");
    Expect(0, 1823, '\P{^Is_Jg=yudhhe}', "");
    Expect(1, 1822, '\p{Is_Jg=		yudh_he}', "");
    Expect(0, 1822, '\p{^Is_Jg=		yudh_he}', "");
    Expect(0, 1822, '\P{Is_Jg=		yudh_he}', "");
    Expect(1, 1822, '\P{^Is_Jg=		yudh_he}', "");
    Expect(0, 1823, '\p{Is_Jg=		yudh_he}', "");
    Expect(1, 1823, '\p{^Is_Jg=		yudh_he}', "");
    Expect(1, 1823, '\P{Is_Jg=		yudh_he}', "");
    Expect(0, 1823, '\P{^Is_Jg=		yudh_he}', "");
    Error('\p{Joining_Group=:=-_zain}');
    Error('\P{Joining_Group=:=-_zain}');
    Expect(1, 1817, '\p{Joining_Group=:\AZain\z:}', "");;
    Expect(0, 1818, '\p{Joining_Group=:\AZain\z:}', "");;
    Expect(1, 1817, '\p{Joining_Group=zain}', "");
    Expect(0, 1817, '\p{^Joining_Group=zain}', "");
    Expect(0, 1817, '\P{Joining_Group=zain}', "");
    Expect(1, 1817, '\P{^Joining_Group=zain}', "");
    Expect(0, 1818, '\p{Joining_Group=zain}', "");
    Expect(1, 1818, '\p{^Joining_Group=zain}', "");
    Expect(1, 1818, '\P{Joining_Group=zain}', "");
    Expect(0, 1818, '\P{^Joining_Group=zain}', "");
    Expect(1, 1817, '\p{Joining_Group=:\Azain\z:}', "");;
    Expect(0, 1818, '\p{Joining_Group=:\Azain\z:}', "");;
    Expect(1, 1817, '\p{Joining_Group=-Zain}', "");
    Expect(0, 1817, '\p{^Joining_Group=-Zain}', "");
    Expect(0, 1817, '\P{Joining_Group=-Zain}', "");
    Expect(1, 1817, '\P{^Joining_Group=-Zain}', "");
    Expect(0, 1818, '\p{Joining_Group=-Zain}', "");
    Expect(1, 1818, '\p{^Joining_Group=-Zain}', "");
    Expect(1, 1818, '\P{Joining_Group=-Zain}', "");
    Expect(0, 1818, '\P{^Joining_Group=-Zain}', "");
    Error('\p{Jg: :=Zain}');
    Error('\P{Jg: :=Zain}');
    Expect(1, 1817, '\p{Jg=:\AZain\z:}', "");;
    Expect(0, 1818, '\p{Jg=:\AZain\z:}', "");;
    Expect(1, 1817, '\p{Jg:	zain}', "");
    Expect(0, 1817, '\p{^Jg:	zain}', "");
    Expect(0, 1817, '\P{Jg:	zain}', "");
    Expect(1, 1817, '\P{^Jg:	zain}', "");
    Expect(0, 1818, '\p{Jg:	zain}', "");
    Expect(1, 1818, '\p{^Jg:	zain}', "");
    Expect(1, 1818, '\P{Jg:	zain}', "");
    Expect(0, 1818, '\P{^Jg:	zain}', "");
    Expect(1, 1817, '\p{Jg=:\Azain\z:}', "");;
    Expect(0, 1818, '\p{Jg=:\Azain\z:}', "");;
    Expect(1, 1817, '\p{Jg=-	zain}', "");
    Expect(0, 1817, '\p{^Jg=-	zain}', "");
    Expect(0, 1817, '\P{Jg=-	zain}', "");
    Expect(1, 1817, '\P{^Jg=-	zain}', "");
    Expect(0, 1818, '\p{Jg=-	zain}', "");
    Expect(1, 1818, '\p{^Jg=-	zain}', "");
    Expect(1, 1818, '\P{Jg=-	zain}', "");
    Expect(0, 1818, '\P{^Jg=-	zain}', "");
    Error('\p{Is_Joining_Group: :=	ZAIN}');
    Error('\P{Is_Joining_Group: :=	ZAIN}');
    Expect(1, 1817, '\p{Is_Joining_Group=zain}', "");
    Expect(0, 1817, '\p{^Is_Joining_Group=zain}', "");
    Expect(0, 1817, '\P{Is_Joining_Group=zain}', "");
    Expect(1, 1817, '\P{^Is_Joining_Group=zain}', "");
    Expect(0, 1818, '\p{Is_Joining_Group=zain}', "");
    Expect(1, 1818, '\p{^Is_Joining_Group=zain}', "");
    Expect(1, 1818, '\P{Is_Joining_Group=zain}', "");
    Expect(0, 1818, '\P{^Is_Joining_Group=zain}', "");
    Expect(1, 1817, '\p{Is_Joining_Group=	-Zain}', "");
    Expect(0, 1817, '\p{^Is_Joining_Group=	-Zain}', "");
    Expect(0, 1817, '\P{Is_Joining_Group=	-Zain}', "");
    Expect(1, 1817, '\P{^Is_Joining_Group=	-Zain}', "");
    Expect(0, 1818, '\p{Is_Joining_Group=	-Zain}', "");
    Expect(1, 1818, '\p{^Is_Joining_Group=	-Zain}', "");
    Expect(1, 1818, '\P{Is_Joining_Group=	-Zain}', "");
    Expect(0, 1818, '\P{^Is_Joining_Group=	-Zain}', "");
    Error('\p{Is_Jg=-ZAIN:=}');
    Error('\P{Is_Jg=-ZAIN:=}');
    Expect(1, 1817, '\p{Is_Jg=zain}', "");
    Expect(0, 1817, '\p{^Is_Jg=zain}', "");
    Expect(0, 1817, '\P{Is_Jg=zain}', "");
    Expect(1, 1817, '\P{^Is_Jg=zain}', "");
    Expect(0, 1818, '\p{Is_Jg=zain}', "");
    Expect(1, 1818, '\p{^Is_Jg=zain}', "");
    Expect(1, 1818, '\P{Is_Jg=zain}', "");
    Expect(0, 1818, '\P{^Is_Jg=zain}', "");
    Expect(1, 1817, '\p{Is_Jg=	-Zain}', "");
    Expect(0, 1817, '\p{^Is_Jg=	-Zain}', "");
    Expect(0, 1817, '\P{Is_Jg=	-Zain}', "");
    Expect(1, 1817, '\P{^Is_Jg=	-Zain}', "");
    Expect(0, 1818, '\p{Is_Jg=	-Zain}', "");
    Expect(1, 1818, '\p{^Is_Jg=	-Zain}', "");
    Expect(1, 1818, '\P{Is_Jg=	-Zain}', "");
    Expect(0, 1818, '\P{^Is_Jg=	-Zain}', "");
    Error('\p{Joining_Group=	-Zhain/a/}');
    Error('\P{Joining_Group=	-Zhain/a/}');
    Expect(1, 1869, '\p{Joining_Group=:\AZhain\z:}', "");;
    Expect(0, 1870, '\p{Joining_Group=:\AZhain\z:}', "");;
    Expect(1, 1869, '\p{Joining_Group=zhain}', "");
    Expect(0, 1869, '\p{^Joining_Group=zhain}', "");
    Expect(0, 1869, '\P{Joining_Group=zhain}', "");
    Expect(1, 1869, '\P{^Joining_Group=zhain}', "");
    Expect(0, 1870, '\p{Joining_Group=zhain}', "");
    Expect(1, 1870, '\p{^Joining_Group=zhain}', "");
    Expect(1, 1870, '\P{Joining_Group=zhain}', "");
    Expect(0, 1870, '\P{^Joining_Group=zhain}', "");
    Expect(1, 1869, '\p{Joining_Group=:\Azhain\z:}', "");;
    Expect(0, 1870, '\p{Joining_Group=:\Azhain\z:}', "");;
    Expect(1, 1869, '\p{Joining_Group= _Zhain}', "");
    Expect(0, 1869, '\p{^Joining_Group= _Zhain}', "");
    Expect(0, 1869, '\P{Joining_Group= _Zhain}', "");
    Expect(1, 1869, '\P{^Joining_Group= _Zhain}', "");
    Expect(0, 1870, '\p{Joining_Group= _Zhain}', "");
    Expect(1, 1870, '\p{^Joining_Group= _Zhain}', "");
    Expect(1, 1870, '\P{Joining_Group= _Zhain}', "");
    Expect(0, 1870, '\P{^Joining_Group= _Zhain}', "");
    Error('\p{Jg=_Zhain/a/}');
    Error('\P{Jg=_Zhain/a/}');
    Expect(1, 1869, '\p{Jg=:\AZhain\z:}', "");;
    Expect(0, 1870, '\p{Jg=:\AZhain\z:}', "");;
    Expect(1, 1869, '\p{Jg=zhain}', "");
    Expect(0, 1869, '\p{^Jg=zhain}', "");
    Expect(0, 1869, '\P{Jg=zhain}', "");
    Expect(1, 1869, '\P{^Jg=zhain}', "");
    Expect(0, 1870, '\p{Jg=zhain}', "");
    Expect(1, 1870, '\p{^Jg=zhain}', "");
    Expect(1, 1870, '\P{Jg=zhain}', "");
    Expect(0, 1870, '\P{^Jg=zhain}', "");
    Expect(1, 1869, '\p{Jg=:\Azhain\z:}', "");;
    Expect(0, 1870, '\p{Jg=:\Azhain\z:}', "");;
    Expect(1, 1869, '\p{Jg=  zhain}', "");
    Expect(0, 1869, '\p{^Jg=  zhain}', "");
    Expect(0, 1869, '\P{Jg=  zhain}', "");
    Expect(1, 1869, '\P{^Jg=  zhain}', "");
    Expect(0, 1870, '\p{Jg=  zhain}', "");
    Expect(1, 1870, '\p{^Jg=  zhain}', "");
    Expect(1, 1870, '\P{Jg=  zhain}', "");
    Expect(0, 1870, '\P{^Jg=  zhain}', "");
    Error('\p{Is_Joining_Group=	/a/zhain}');
    Error('\P{Is_Joining_Group=	/a/zhain}');
    Expect(1, 1869, '\p{Is_Joining_Group=zhain}', "");
    Expect(0, 1869, '\p{^Is_Joining_Group=zhain}', "");
    Expect(0, 1869, '\P{Is_Joining_Group=zhain}', "");
    Expect(1, 1869, '\P{^Is_Joining_Group=zhain}', "");
    Expect(0, 1870, '\p{Is_Joining_Group=zhain}', "");
    Expect(1, 1870, '\p{^Is_Joining_Group=zhain}', "");
    Expect(1, 1870, '\P{Is_Joining_Group=zhain}', "");
    Expect(0, 1870, '\P{^Is_Joining_Group=zhain}', "");
    Expect(1, 1869, '\p{Is_Joining_Group: ZHAIN}', "");
    Expect(0, 1869, '\p{^Is_Joining_Group: ZHAIN}', "");
    Expect(0, 1869, '\P{Is_Joining_Group: ZHAIN}', "");
    Expect(1, 1869, '\P{^Is_Joining_Group: ZHAIN}', "");
    Expect(0, 1870, '\p{Is_Joining_Group: ZHAIN}', "");
    Expect(1, 1870, '\p{^Is_Joining_Group: ZHAIN}', "");
    Expect(1, 1870, '\P{Is_Joining_Group: ZHAIN}', "");
    Expect(0, 1870, '\P{^Is_Joining_Group: ZHAIN}', "");
    Error('\p{Is_Jg=/a/-_Zhain}');
    Error('\P{Is_Jg=/a/-_Zhain}');
    Expect(1, 1869, '\p{Is_Jg=zhain}', "");
    Expect(0, 1869, '\p{^Is_Jg=zhain}', "");
    Expect(0, 1869, '\P{Is_Jg=zhain}', "");
    Expect(1, 1869, '\P{^Is_Jg=zhain}', "");
    Expect(0, 1870, '\p{Is_Jg=zhain}', "");
    Expect(1, 1870, '\p{^Is_Jg=zhain}', "");
    Expect(1, 1870, '\P{Is_Jg=zhain}', "");
    Expect(0, 1870, '\P{^Is_Jg=zhain}', "");
    Expect(1, 1869, '\p{Is_Jg=		Zhain}', "");
    Expect(0, 1869, '\p{^Is_Jg=		Zhain}', "");
    Expect(0, 1869, '\P{Is_Jg=		Zhain}', "");
    Expect(1, 1869, '\P{^Is_Jg=		Zhain}', "");
    Expect(0, 1870, '\p{Is_Jg=		Zhain}', "");
    Expect(1, 1870, '\p{^Is_Jg=		Zhain}', "");
    Expect(1, 1870, '\P{Is_Jg=		Zhain}', "");
    Expect(0, 1870, '\P{^Is_Jg=		Zhain}', "");
    Error('\p{Join_Control=/a/--NO}');
    Error('\P{Join_Control=/a/--NO}');
    Expect(1, 8206, '\p{Join_Control=:\ANo\z:}', "");;
    Expect(0, 8205, '\p{Join_Control=:\ANo\z:}', "");;
    Expect(1, 8206, '\p{Join_Control=no}', "");
    Expect(0, 8206, '\p{^Join_Control=no}', "");
    Expect(0, 8206, '\P{Join_Control=no}', "");
    Expect(1, 8206, '\P{^Join_Control=no}', "");
    Expect(0, 8205, '\p{Join_Control=no}', "");
    Expect(1, 8205, '\p{^Join_Control=no}', "");
    Expect(1, 8205, '\P{Join_Control=no}', "");
    Expect(0, 8205, '\P{^Join_Control=no}', "");
    Expect(1, 8206, '\p{Join_Control=:\Ano\z:}', "");;
    Expect(0, 8205, '\p{Join_Control=:\Ano\z:}', "");;
    Expect(1, 8206, '\p{Join_Control=__NO}', "");
    Expect(0, 8206, '\p{^Join_Control=__NO}', "");
    Expect(0, 8206, '\P{Join_Control=__NO}', "");
    Expect(1, 8206, '\P{^Join_Control=__NO}', "");
    Expect(0, 8205, '\p{Join_Control=__NO}', "");
    Expect(1, 8205, '\p{^Join_Control=__NO}', "");
    Expect(1, 8205, '\P{Join_Control=__NO}', "");
    Expect(0, 8205, '\P{^Join_Control=__NO}', "");
    Error('\p{Join_C=--n:=}');
    Error('\P{Join_C=--n:=}');
    Expect(1, 8206, '\p{Join_C=:\AN\z:}', "");;
    Expect(0, 8205, '\p{Join_C=:\AN\z:}', "");;
    Expect(1, 8206, '\p{Join_C=n}', "");
    Expect(0, 8206, '\p{^Join_C=n}', "");
    Expect(0, 8206, '\P{Join_C=n}', "");
    Expect(1, 8206, '\P{^Join_C=n}', "");
    Expect(0, 8205, '\p{Join_C=n}', "");
    Expect(1, 8205, '\p{^Join_C=n}', "");
    Expect(1, 8205, '\P{Join_C=n}', "");
    Expect(0, 8205, '\P{^Join_C=n}', "");
    Expect(1, 8206, '\p{Join_C=:\An\z:}', "");;
    Expect(0, 8205, '\p{Join_C=:\An\z:}', "");;
    Expect(1, 8206, '\p{Join_C=_N}', "");
    Expect(0, 8206, '\p{^Join_C=_N}', "");
    Expect(0, 8206, '\P{Join_C=_N}', "");
    Expect(1, 8206, '\P{^Join_C=_N}', "");
    Expect(0, 8205, '\p{Join_C=_N}', "");
    Expect(1, 8205, '\p{^Join_C=_N}', "");
    Expect(1, 8205, '\P{Join_C=_N}', "");
    Expect(0, 8205, '\P{^Join_C=_N}', "");
    Error('\p{Is_Join_Control=-/a/f}');
    Error('\P{Is_Join_Control=-/a/f}');
    Expect(1, 8206, '\p{Is_Join_Control=f}', "");
    Expect(0, 8206, '\p{^Is_Join_Control=f}', "");
    Expect(0, 8206, '\P{Is_Join_Control=f}', "");
    Expect(1, 8206, '\P{^Is_Join_Control=f}', "");
    Expect(0, 8205, '\p{Is_Join_Control=f}', "");
    Expect(1, 8205, '\p{^Is_Join_Control=f}', "");
    Expect(1, 8205, '\P{Is_Join_Control=f}', "");
    Expect(0, 8205, '\P{^Is_Join_Control=f}', "");
    Expect(1, 8206, '\p{Is_Join_Control=-F}', "");
    Expect(0, 8206, '\p{^Is_Join_Control=-F}', "");
    Expect(0, 8206, '\P{Is_Join_Control=-F}', "");
    Expect(1, 8206, '\P{^Is_Join_Control=-F}', "");
    Expect(0, 8205, '\p{Is_Join_Control=-F}', "");
    Expect(1, 8205, '\p{^Is_Join_Control=-F}', "");
    Expect(1, 8205, '\P{Is_Join_Control=-F}', "");
    Expect(0, 8205, '\P{^Is_Join_Control=-F}', "");
    Error('\p{Is_Join_C=	:=False}');
    Error('\P{Is_Join_C=	:=False}');
    Expect(1, 8206, '\p{Is_Join_C=false}', "");
    Expect(0, 8206, '\p{^Is_Join_C=false}', "");
    Expect(0, 8206, '\P{Is_Join_C=false}', "");
    Expect(1, 8206, '\P{^Is_Join_C=false}', "");
    Expect(0, 8205, '\p{Is_Join_C=false}', "");
    Expect(1, 8205, '\p{^Is_Join_C=false}', "");
    Expect(1, 8205, '\P{Is_Join_C=false}', "");
    Expect(0, 8205, '\P{^Is_Join_C=false}', "");
    Expect(1, 8206, '\p{Is_Join_C: 	false}', "");
    Expect(0, 8206, '\p{^Is_Join_C: 	false}', "");
    Expect(0, 8206, '\P{Is_Join_C: 	false}', "");
    Expect(1, 8206, '\P{^Is_Join_C: 	false}', "");
    Expect(0, 8205, '\p{Is_Join_C: 	false}', "");
    Expect(1, 8205, '\p{^Is_Join_C: 	false}', "");
    Expect(1, 8205, '\P{Is_Join_C: 	false}', "");
    Expect(0, 8205, '\P{^Is_Join_C: 	false}', "");
    Error('\p{Join_Control=:= yes}');
    Error('\P{Join_Control=:= yes}');
    Expect(1, 8205, '\p{Join_Control=:\AYes\z:}', "");;
    Expect(0, 8206, '\p{Join_Control=:\AYes\z:}', "");;
    Expect(1, 8205, '\p{Join_Control=yes}', "");
    Expect(0, 8205, '\p{^Join_Control=yes}', "");
    Expect(0, 8205, '\P{Join_Control=yes}', "");
    Expect(1, 8205, '\P{^Join_Control=yes}', "");
    Expect(0, 8206, '\p{Join_Control=yes}', "");
    Expect(1, 8206, '\p{^Join_Control=yes}', "");
    Expect(1, 8206, '\P{Join_Control=yes}', "");
    Expect(0, 8206, '\P{^Join_Control=yes}', "");
    Expect(1, 8205, '\p{Join_Control=:\Ayes\z:}', "");;
    Expect(0, 8206, '\p{Join_Control=:\Ayes\z:}', "");;
    Expect(1, 8205, '\p{Join_Control=	Yes}', "");
    Expect(0, 8205, '\p{^Join_Control=	Yes}', "");
    Expect(0, 8205, '\P{Join_Control=	Yes}', "");
    Expect(1, 8205, '\P{^Join_Control=	Yes}', "");
    Expect(0, 8206, '\p{Join_Control=	Yes}', "");
    Expect(1, 8206, '\p{^Join_Control=	Yes}', "");
    Expect(1, 8206, '\P{Join_Control=	Yes}', "");
    Expect(0, 8206, '\P{^Join_Control=	Yes}', "");
    Error('\p{Join_C=/a/__y}');
    Error('\P{Join_C=/a/__y}');
    Expect(1, 8205, '\p{Join_C=:\AY\z:}', "");;
    Expect(0, 8206, '\p{Join_C=:\AY\z:}', "");;
    Expect(1, 8205, '\p{Join_C=y}', "");
    Expect(0, 8205, '\p{^Join_C=y}', "");
    Expect(0, 8205, '\P{Join_C=y}', "");
    Expect(1, 8205, '\P{^Join_C=y}', "");
    Expect(0, 8206, '\p{Join_C=y}', "");
    Expect(1, 8206, '\p{^Join_C=y}', "");
    Expect(1, 8206, '\P{Join_C=y}', "");
    Expect(0, 8206, '\P{^Join_C=y}', "");
    Expect(1, 8205, '\p{Join_C=:\Ay\z:}', "");;
    Expect(0, 8206, '\p{Join_C=:\Ay\z:}', "");;
    Expect(1, 8205, '\p{Join_C= -Y}', "");
    Expect(0, 8205, '\p{^Join_C= -Y}', "");
    Expect(0, 8205, '\P{Join_C= -Y}', "");
    Expect(1, 8205, '\P{^Join_C= -Y}', "");
    Expect(0, 8206, '\p{Join_C= -Y}', "");
    Expect(1, 8206, '\p{^Join_C= -Y}', "");
    Expect(1, 8206, '\P{Join_C= -Y}', "");
    Expect(0, 8206, '\P{^Join_C= -Y}', "");
    Error('\p{Is_Join_Control=/a/T}');
    Error('\P{Is_Join_Control=/a/T}');
    Expect(1, 8205, '\p{Is_Join_Control=t}', "");
    Expect(0, 8205, '\p{^Is_Join_Control=t}', "");
    Expect(0, 8205, '\P{Is_Join_Control=t}', "");
    Expect(1, 8205, '\P{^Is_Join_Control=t}', "");
    Expect(0, 8206, '\p{Is_Join_Control=t}', "");
    Expect(1, 8206, '\p{^Is_Join_Control=t}', "");
    Expect(1, 8206, '\P{Is_Join_Control=t}', "");
    Expect(0, 8206, '\P{^Is_Join_Control=t}', "");
    Expect(1, 8205, '\p{Is_Join_Control=-T}', "");
    Expect(0, 8205, '\p{^Is_Join_Control=-T}', "");
    Expect(0, 8205, '\P{Is_Join_Control=-T}', "");
    Expect(1, 8205, '\P{^Is_Join_Control=-T}', "");
    Expect(0, 8206, '\p{Is_Join_Control=-T}', "");
    Expect(1, 8206, '\p{^Is_Join_Control=-T}', "");
    Expect(1, 8206, '\P{Is_Join_Control=-T}', "");
    Expect(0, 8206, '\P{^Is_Join_Control=-T}', "");
    Error('\p{Is_Join_C=:=__true}');
    Error('\P{Is_Join_C=:=__true}');
    Expect(1, 8205, '\p{Is_Join_C=true}', "");
    Expect(0, 8205, '\p{^Is_Join_C=true}', "");
    Expect(0, 8205, '\P{Is_Join_C=true}', "");
    Expect(1, 8205, '\P{^Is_Join_C=true}', "");
    Expect(0, 8206, '\p{Is_Join_C=true}', "");
    Expect(1, 8206, '\p{^Is_Join_C=true}', "");
    Expect(1, 8206, '\P{Is_Join_C=true}', "");
    Expect(0, 8206, '\P{^Is_Join_C=true}', "");
    Expect(1, 8205, '\p{Is_Join_C=__TRUE}', "");
    Expect(0, 8205, '\p{^Is_Join_C=__TRUE}', "");
    Expect(0, 8205, '\P{Is_Join_C=__TRUE}', "");
    Expect(1, 8205, '\P{^Is_Join_C=__TRUE}', "");
    Expect(0, 8206, '\p{Is_Join_C=__TRUE}', "");
    Expect(1, 8206, '\p{^Is_Join_C=__TRUE}', "");
    Expect(1, 8206, '\P{Is_Join_C=__TRUE}', "");
    Expect(0, 8206, '\P{^Is_Join_C=__TRUE}', "");
    Error('\p{jamoshortname}');
    Error('\P{jamoshortname}');
    Error('\p{jsn}');
    Error('\P{jsn}');
    Error('\p{Jamo_Short_Name:A}');
    Error('\P{Jamo_Short_Name:A}');
    Error('\p{JSN:A}');
    Error('\P{JSN:A}');
    Error('\p{Is_Jamo_Short_Name=A}');
    Error('\P{Is_Jamo_Short_Name=A}');
    Error('\p{Is_JSN=A}');
    Error('\P{Is_JSN=A}');
    Error('\p{Jamo_Short_Name=AE}');
    Error('\P{Jamo_Short_Name=AE}');
    Error('\p{JSN:	AE}');
    Error('\P{JSN:	AE}');
    Error('\p{Is_Jamo_Short_Name=AE}');
    Error('\P{Is_Jamo_Short_Name=AE}');
    Error('\p{Is_JSN=AE}');
    Error('\P{Is_JSN=AE}');
    Error('\p{Jamo_Short_Name=B}');
    Error('\P{Jamo_Short_Name=B}');
    Error('\p{JSN=B}');
    Error('\P{JSN=B}');
    Error('\p{Is_Jamo_Short_Name=B}');
    Error('\P{Is_Jamo_Short_Name=B}');
    Error('\p{Is_JSN=B}');
    Error('\P{Is_JSN=B}');
    Error('\p{Jamo_Short_Name=BB}');
    Error('\P{Jamo_Short_Name=BB}');
    Error('\p{JSN=BB}');
    Error('\P{JSN=BB}');
    Error('\p{Is_Jamo_Short_Name=BB}');
    Error('\P{Is_Jamo_Short_Name=BB}');
    Error('\p{Is_JSN=BB}');
    Error('\P{Is_JSN=BB}');
    Error('\p{Jamo_Short_Name=BS}');
    Error('\P{Jamo_Short_Name=BS}');
    Error('\p{JSN:	BS}');
    Error('\P{JSN:	BS}');
    Error('\p{Is_Jamo_Short_Name: BS}');
    Error('\P{Is_Jamo_Short_Name: BS}');
    Error('\p{Is_JSN=BS}');
    Error('\P{Is_JSN=BS}');
    Error('\p{Jamo_Short_Name=C}');
    Error('\P{Jamo_Short_Name=C}');
    Error('\p{JSN=C}');
    Error('\P{JSN=C}');
    Error('\p{Is_Jamo_Short_Name:	C}');
    Error('\P{Is_Jamo_Short_Name:	C}');
    Error('\p{Is_JSN=C}');
    Error('\P{Is_JSN=C}');
    Error('\p{Jamo_Short_Name=D}');
    Error('\P{Jamo_Short_Name=D}');
    Error('\p{JSN=D}');
    Error('\P{JSN=D}');
    Error('\p{Is_Jamo_Short_Name=D}');
    Error('\P{Is_Jamo_Short_Name=D}');
    Error('\p{Is_JSN=D}');
    Error('\P{Is_JSN=D}');
    Error('\p{Jamo_Short_Name=DD}');
    Error('\P{Jamo_Short_Name=DD}');
    Error('\p{JSN=DD}');
    Error('\P{JSN=DD}');
    Error('\p{Is_Jamo_Short_Name=DD}');
    Error('\P{Is_Jamo_Short_Name=DD}');
    Error('\p{Is_JSN=DD}');
    Error('\P{Is_JSN=DD}');
    Error('\p{Jamo_Short_Name=E}');
    Error('\P{Jamo_Short_Name=E}');
    Error('\p{JSN=E}');
    Error('\P{JSN=E}');
    Error('\p{Is_Jamo_Short_Name=E}');
    Error('\P{Is_Jamo_Short_Name=E}');
    Error('\p{Is_JSN=E}');
    Error('\P{Is_JSN=E}');
    Error('\p{Jamo_Short_Name=EO}');
    Error('\P{Jamo_Short_Name=EO}');
    Error('\p{JSN=EO}');
    Error('\P{JSN=EO}');
    Error('\p{Is_Jamo_Short_Name:EO}');
    Error('\P{Is_Jamo_Short_Name:EO}');
    Error('\p{Is_JSN=EO}');
    Error('\P{Is_JSN=EO}');
    Error('\p{Jamo_Short_Name=EU}');
    Error('\P{Jamo_Short_Name=EU}');
    Error('\p{JSN=EU}');
    Error('\P{JSN=EU}');
    Error('\p{Is_Jamo_Short_Name=EU}');
    Error('\P{Is_Jamo_Short_Name=EU}');
    Error('\p{Is_JSN=EU}');
    Error('\P{Is_JSN=EU}');
    Error('\p{Jamo_Short_Name=G}');
    Error('\P{Jamo_Short_Name=G}');
    Error('\p{JSN=G}');
    Error('\P{JSN=G}');
    Error('\p{Is_Jamo_Short_Name:G}');
    Error('\P{Is_Jamo_Short_Name:G}');
    Error('\p{Is_JSN=G}');
    Error('\P{Is_JSN=G}');
    Error('\p{Jamo_Short_Name:GG}');
    Error('\P{Jamo_Short_Name:GG}');
    Error('\p{JSN=GG}');
    Error('\P{JSN=GG}');
    Error('\p{Is_Jamo_Short_Name=GG}');
    Error('\P{Is_Jamo_Short_Name=GG}');
    Error('\p{Is_JSN=GG}');
    Error('\P{Is_JSN=GG}');
    Error('\p{Jamo_Short_Name=GS}');
    Error('\P{Jamo_Short_Name=GS}');
    Error('\p{JSN=GS}');
    Error('\P{JSN=GS}');
    Error('\p{Is_Jamo_Short_Name=GS}');
    Error('\P{Is_Jamo_Short_Name=GS}');
    Error('\p{Is_JSN:	GS}');
    Error('\P{Is_JSN:	GS}');
    Error('\p{Jamo_Short_Name=H}');
    Error('\P{Jamo_Short_Name=H}');
    Error('\p{JSN=H}');
    Error('\P{JSN=H}');
    Error('\p{Is_Jamo_Short_Name=H}');
    Error('\P{Is_Jamo_Short_Name=H}');
    Error('\p{Is_JSN:   H}');
    Error('\P{Is_JSN:   H}');
    Error('\p{Jamo_Short_Name=I}');
    Error('\P{Jamo_Short_Name=I}');
    Error('\p{JSN=I}');
    Error('\P{JSN=I}');
    Error('\p{Is_Jamo_Short_Name=I}');
    Error('\P{Is_Jamo_Short_Name=I}');
    Error('\p{Is_JSN=I}');
    Error('\P{Is_JSN=I}');
    Error('\p{Jamo_Short_Name=J}');
    Error('\P{Jamo_Short_Name=J}');
    Error('\p{JSN=J}');
    Error('\P{JSN=J}');
    Error('\p{Is_Jamo_Short_Name=J}');
    Error('\P{Is_Jamo_Short_Name=J}');
    Error('\p{Is_JSN=J}');
    Error('\P{Is_JSN=J}');
    Error('\p{Jamo_Short_Name=JJ}');
    Error('\P{Jamo_Short_Name=JJ}');
    Error('\p{JSN=JJ}');
    Error('\P{JSN=JJ}');
    Error('\p{Is_Jamo_Short_Name=JJ}');
    Error('\P{Is_Jamo_Short_Name=JJ}');
    Error('\p{Is_JSN=JJ}');
    Error('\P{Is_JSN=JJ}');
    Error('\p{Jamo_Short_Name=K}');
    Error('\P{Jamo_Short_Name=K}');
    Error('\p{JSN=K}');
    Error('\P{JSN=K}');
    Error('\p{Is_Jamo_Short_Name=K}');
    Error('\P{Is_Jamo_Short_Name=K}');
    Error('\p{Is_JSN=K}');
    Error('\P{Is_JSN=K}');
    Error('\p{Jamo_Short_Name: L}');
    Error('\P{Jamo_Short_Name: L}');
    Error('\p{JSN=L}');
    Error('\P{JSN=L}');
    Error('\p{Is_Jamo_Short_Name:   L}');
    Error('\P{Is_Jamo_Short_Name:   L}');
    Error('\p{Is_JSN=L}');
    Error('\P{Is_JSN=L}');
    Error('\p{Jamo_Short_Name=LB}');
    Error('\P{Jamo_Short_Name=LB}');
    Error('\p{JSN=LB}');
    Error('\P{JSN=LB}');
    Error('\p{Is_Jamo_Short_Name=LB}');
    Error('\P{Is_Jamo_Short_Name=LB}');
    Error('\p{Is_JSN=LB}');
    Error('\P{Is_JSN=LB}');
    Error('\p{Jamo_Short_Name=LG}');
    Error('\P{Jamo_Short_Name=LG}');
    Error('\p{JSN=LG}');
    Error('\P{JSN=LG}');
    Error('\p{Is_Jamo_Short_Name=LG}');
    Error('\P{Is_Jamo_Short_Name=LG}');
    Error('\p{Is_JSN=LG}');
    Error('\P{Is_JSN=LG}');
    Error('\p{Jamo_Short_Name=LH}');
    Error('\P{Jamo_Short_Name=LH}');
    Error('\p{JSN=LH}');
    Error('\P{JSN=LH}');
    Error('\p{Is_Jamo_Short_Name:   LH}');
    Error('\P{Is_Jamo_Short_Name:   LH}');
    Error('\p{Is_JSN=LH}');
    Error('\P{Is_JSN=LH}');
    Error('\p{Jamo_Short_Name=LM}');
    Error('\P{Jamo_Short_Name=LM}');
    Error('\p{JSN=LM}');
    Error('\P{JSN=LM}');
    Error('\p{Is_Jamo_Short_Name=LM}');
    Error('\P{Is_Jamo_Short_Name=LM}');
    Error('\p{Is_JSN=LM}');
    Error('\P{Is_JSN=LM}');
    Error('\p{Jamo_Short_Name=LP}');
    Error('\P{Jamo_Short_Name=LP}');
    Error('\p{JSN=LP}');
    Error('\P{JSN=LP}');
    Error('\p{Is_Jamo_Short_Name=LP}');
    Error('\P{Is_Jamo_Short_Name=LP}');
    Error('\p{Is_JSN=LP}');
    Error('\P{Is_JSN=LP}');
    Error('\p{Jamo_Short_Name=LS}');
    Error('\P{Jamo_Short_Name=LS}');
    Error('\p{JSN=LS}');
    Error('\P{JSN=LS}');
    Error('\p{Is_Jamo_Short_Name=LS}');
    Error('\P{Is_Jamo_Short_Name=LS}');
    Error('\p{Is_JSN:	LS}');
    Error('\P{Is_JSN:	LS}');
    Error('\p{Jamo_Short_Name=LT}');
    Error('\P{Jamo_Short_Name=LT}');
    Error('\p{JSN=LT}');
    Error('\P{JSN=LT}');
    Error('\p{Is_Jamo_Short_Name=LT}');
    Error('\P{Is_Jamo_Short_Name=LT}');
    Error('\p{Is_JSN=LT}');
    Error('\P{Is_JSN=LT}');
    Error('\p{Jamo_Short_Name=M}');
    Error('\P{Jamo_Short_Name=M}');
    Error('\p{JSN=M}');
    Error('\P{JSN=M}');
    Error('\p{Is_Jamo_Short_Name=M}');
    Error('\P{Is_Jamo_Short_Name=M}');
    Error('\p{Is_JSN=M}');
    Error('\P{Is_JSN=M}');
    Error('\p{Jamo_Short_Name=N}');
    Error('\P{Jamo_Short_Name=N}');
    Error('\p{JSN=N}');
    Error('\P{JSN=N}');
    Error('\p{Is_Jamo_Short_Name=N}');
    Error('\P{Is_Jamo_Short_Name=N}');
    Error('\p{Is_JSN=N}');
    Error('\P{Is_JSN=N}');
    Error('\p{Jamo_Short_Name=NG}');
    Error('\P{Jamo_Short_Name=NG}');
    Error('\p{JSN=NG}');
    Error('\P{JSN=NG}');
    Error('\p{Is_Jamo_Short_Name: NG}');
    Error('\P{Is_Jamo_Short_Name: NG}');
    Error('\p{Is_JSN: NG}');
    Error('\P{Is_JSN: NG}');
    Error('\p{Jamo_Short_Name=NH}');
    Error('\P{Jamo_Short_Name=NH}');
    Error('\p{JSN: NH}');
    Error('\P{JSN: NH}');
    Error('\p{Is_Jamo_Short_Name=NH}');
    Error('\P{Is_Jamo_Short_Name=NH}');
    Error('\p{Is_JSN=NH}');
    Error('\P{Is_JSN=NH}');
    Error('\p{Jamo_Short_Name=NJ}');
    Error('\P{Jamo_Short_Name=NJ}');
    Error('\p{JSN=NJ}');
    Error('\P{JSN=NJ}');
    Error('\p{Is_Jamo_Short_Name=NJ}');
    Error('\P{Is_Jamo_Short_Name=NJ}');
    Error('\p{Is_JSN=NJ}');
    Error('\P{Is_JSN=NJ}');
    Error('\p{Jamo_Short_Name=O}');
    Error('\P{Jamo_Short_Name=O}');
    Error('\p{JSN=O}');
    Error('\P{JSN=O}');
    Error('\p{Is_Jamo_Short_Name=O}');
    Error('\P{Is_Jamo_Short_Name=O}');
    Error('\p{Is_JSN:   O}');
    Error('\P{Is_JSN:   O}');
    Error('\p{Jamo_Short_Name=OE}');
    Error('\P{Jamo_Short_Name=OE}');
    Error('\p{JSN=OE}');
    Error('\P{JSN=OE}');
    Error('\p{Is_Jamo_Short_Name=OE}');
    Error('\P{Is_Jamo_Short_Name=OE}');
    Error('\p{Is_JSN=OE}');
    Error('\P{Is_JSN=OE}');
    Error('\p{Jamo_Short_Name: P}');
    Error('\P{Jamo_Short_Name: P}');
    Error('\p{JSN=P}');
    Error('\P{JSN=P}');
    Error('\p{Is_Jamo_Short_Name=P}');
    Error('\P{Is_Jamo_Short_Name=P}');
    Error('\p{Is_JSN=P}');
    Error('\P{Is_JSN=P}');
    Error('\p{Jamo_Short_Name=R}');
    Error('\P{Jamo_Short_Name=R}');
    Error('\p{JSN=R}');
    Error('\P{JSN=R}');
    Error('\p{Is_Jamo_Short_Name=R}');
    Error('\P{Is_Jamo_Short_Name=R}');
    Error('\p{Is_JSN=R}');
    Error('\P{Is_JSN=R}');
    Error('\p{Jamo_Short_Name=S}');
    Error('\P{Jamo_Short_Name=S}');
    Error('\p{JSN=S}');
    Error('\P{JSN=S}');
    Error('\p{Is_Jamo_Short_Name=S}');
    Error('\P{Is_Jamo_Short_Name=S}');
    Error('\p{Is_JSN=S}');
    Error('\P{Is_JSN=S}');
    Error('\p{Jamo_Short_Name=SS}');
    Error('\P{Jamo_Short_Name=SS}');
    Error('\p{JSN=SS}');
    Error('\P{JSN=SS}');
    Error('\p{Is_Jamo_Short_Name=SS}');
    Error('\P{Is_Jamo_Short_Name=SS}');
    Error('\p{Is_JSN: SS}');
    Error('\P{Is_JSN: SS}');
    Error('\p{Jamo_Short_Name=T}');
    Error('\P{Jamo_Short_Name=T}');
    Error('\p{JSN=T}');
    Error('\P{JSN=T}');
    Error('\p{Is_Jamo_Short_Name=T}');
    Error('\P{Is_Jamo_Short_Name=T}');
    Error('\p{Is_JSN=T}');
    Error('\P{Is_JSN=T}');
    Error('\p{Jamo_Short_Name=U}');
    Error('\P{Jamo_Short_Name=U}');
    Error('\p{JSN=U}');
    Error('\P{JSN=U}');
    Error('\p{Is_Jamo_Short_Name=U}');
    Error('\P{Is_Jamo_Short_Name=U}');
    Error('\p{Is_JSN=U}');
    Error('\P{Is_JSN=U}');
    Error('\p{Jamo_Short_Name=WA}');
    Error('\P{Jamo_Short_Name=WA}');
    Error('\p{JSN=WA}');
    Error('\P{JSN=WA}');
    Error('\p{Is_Jamo_Short_Name=WA}');
    Error('\P{Is_Jamo_Short_Name=WA}');
    Error('\p{Is_JSN=WA}');
    Error('\P{Is_JSN=WA}');
    Error('\p{Jamo_Short_Name=WAE}');
    Error('\P{Jamo_Short_Name=WAE}');
    Error('\p{JSN=WAE}');
    Error('\P{JSN=WAE}');
    Error('\p{Is_Jamo_Short_Name=WAE}');
    Error('\P{Is_Jamo_Short_Name=WAE}');
    Error('\p{Is_JSN=WAE}');
    Error('\P{Is_JSN=WAE}');
    Error('\p{Jamo_Short_Name: WE}');
    Error('\P{Jamo_Short_Name: WE}');
    Error('\p{JSN:   WE}');
    Error('\P{JSN:   WE}');
    Error('\p{Is_Jamo_Short_Name=WE}');
    Error('\P{Is_Jamo_Short_Name=WE}');
    Error('\p{Is_JSN=WE}');
    Error('\P{Is_JSN=WE}');
    Error('\p{Jamo_Short_Name=WEO}');
    Error('\P{Jamo_Short_Name=WEO}');
    Error('\p{JSN=WEO}');
    Error('\P{JSN=WEO}');
    Error('\p{Is_Jamo_Short_Name=WEO}');
    Error('\P{Is_Jamo_Short_Name=WEO}');
    Error('\p{Is_JSN=WEO}');
    Error('\P{Is_JSN=WEO}');
    Error('\p{Jamo_Short_Name=WI}');
    Error('\P{Jamo_Short_Name=WI}');
    Error('\p{JSN=WI}');
    Error('\P{JSN=WI}');
    Error('\p{Is_Jamo_Short_Name=WI}');
    Error('\P{Is_Jamo_Short_Name=WI}');
    Error('\p{Is_JSN=WI}');
    Error('\P{Is_JSN=WI}');
    Error('\p{Jamo_Short_Name=YA}');
    Error('\P{Jamo_Short_Name=YA}');
    Error('\p{JSN=YA}');
    Error('\P{JSN=YA}');
    Error('\p{Is_Jamo_Short_Name=YA}');
    Error('\P{Is_Jamo_Short_Name=YA}');
    Error('\p{Is_JSN=YA}');
    Error('\P{Is_JSN=YA}');
    Error('\p{Jamo_Short_Name=YAE}');
    Error('\P{Jamo_Short_Name=YAE}');
    Error('\p{JSN=YAE}');
    Error('\P{JSN=YAE}');
    Error('\p{Is_Jamo_Short_Name=YAE}');
    Error('\P{Is_Jamo_Short_Name=YAE}');
    Error('\p{Is_JSN:   YAE}');
    Error('\P{Is_JSN:   YAE}');
    Error('\p{Jamo_Short_Name=YE}');
    Error('\P{Jamo_Short_Name=YE}');
    Error('\p{JSN=YE}');
    Error('\P{JSN=YE}');
    Error('\p{Is_Jamo_Short_Name:	YE}');
    Error('\P{Is_Jamo_Short_Name:	YE}');
    Error('\p{Is_JSN=YE}');
    Error('\P{Is_JSN=YE}');
    Error('\p{Jamo_Short_Name=YEO}');
    Error('\P{Jamo_Short_Name=YEO}');
    Error('\p{JSN=YEO}');
    Error('\P{JSN=YEO}');
    Error('\p{Is_Jamo_Short_Name=YEO}');
    Error('\P{Is_Jamo_Short_Name=YEO}');
    Error('\p{Is_JSN=YEO}');
    Error('\P{Is_JSN=YEO}');
    Error('\p{Jamo_Short_Name=YI}');
    Error('\P{Jamo_Short_Name=YI}');
    Error('\p{JSN=YI}');
    Error('\P{JSN=YI}');
    Error('\p{Is_Jamo_Short_Name=YI}');
    Error('\P{Is_Jamo_Short_Name=YI}');
    Error('\p{Is_JSN=YI}');
    Error('\P{Is_JSN=YI}');
    Error('\p{Jamo_Short_Name=YO}');
    Error('\P{Jamo_Short_Name=YO}');
    Error('\p{JSN=YO}');
    Error('\P{JSN=YO}');
    Error('\p{Is_Jamo_Short_Name=YO}');
    Error('\P{Is_Jamo_Short_Name=YO}');
    Error('\p{Is_JSN=YO}');
    Error('\P{Is_JSN=YO}');
    Error('\p{Jamo_Short_Name=YU}');
    Error('\P{Jamo_Short_Name=YU}');
    Error('\p{JSN=YU}');
    Error('\P{JSN=YU}');
    Error('\p{Is_Jamo_Short_Name=YU}');
    Error('\P{Is_Jamo_Short_Name=YU}');
    Error('\p{Is_JSN=YU}');
    Error('\P{Is_JSN=YU}');
    Error('\p{joiningtype}');
    Error('\P{joiningtype}');
    Error('\p{jt}');
    Error('\P{jt}');
    Error('\p{Joining_Type=:=-JOIN_Causing}');
    Error('\P{Joining_Type=:=-JOIN_Causing}');
    Expect(1, 8205, '\p{Joining_Type=:\AJoin_Causing\z:}', "");;
    Expect(0, 8206, '\p{Joining_Type=:\AJoin_Causing\z:}', "");;
    Expect(1, 8205, '\p{Joining_Type=joincausing}', "");
    Expect(0, 8205, '\p{^Joining_Type=joincausing}', "");
    Expect(0, 8205, '\P{Joining_Type=joincausing}', "");
    Expect(1, 8205, '\P{^Joining_Type=joincausing}', "");
    Expect(0, 8206, '\p{Joining_Type=joincausing}', "");
    Expect(1, 8206, '\p{^Joining_Type=joincausing}', "");
    Expect(1, 8206, '\P{Joining_Type=joincausing}', "");
    Expect(0, 8206, '\P{^Joining_Type=joincausing}', "");
    Expect(1, 8205, '\p{Joining_Type=:\Ajoincausing\z:}', "");;
    Expect(0, 8206, '\p{Joining_Type=:\Ajoincausing\z:}', "");;
    Expect(1, 8205, '\p{Joining_Type=- Join_causing}', "");
    Expect(0, 8205, '\p{^Joining_Type=- Join_causing}', "");
    Expect(0, 8205, '\P{Joining_Type=- Join_causing}', "");
    Expect(1, 8205, '\P{^Joining_Type=- Join_causing}', "");
    Expect(0, 8206, '\p{Joining_Type=- Join_causing}', "");
    Expect(1, 8206, '\p{^Joining_Type=- Join_causing}', "");
    Expect(1, 8206, '\P{Joining_Type=- Join_causing}', "");
    Expect(0, 8206, '\P{^Joining_Type=- Join_causing}', "");
    Error('\p{Jt=-C:=}');
    Error('\P{Jt=-C:=}');
    Expect(1, 8205, '\p{Jt=:\AC\z:}', "");;
    Expect(0, 8206, '\p{Jt=:\AC\z:}', "");;
    Expect(1, 8205, '\p{Jt:c}', "");
    Expect(0, 8205, '\p{^Jt:c}', "");
    Expect(0, 8205, '\P{Jt:c}', "");
    Expect(1, 8205, '\P{^Jt:c}', "");
    Expect(0, 8206, '\p{Jt:c}', "");
    Expect(1, 8206, '\p{^Jt:c}', "");
    Expect(1, 8206, '\P{Jt:c}', "");
    Expect(0, 8206, '\P{^Jt:c}', "");
    Expect(1, 8205, '\p{Jt=:\Ac\z:}', "");;
    Expect(0, 8206, '\p{Jt=:\Ac\z:}', "");;
    Expect(1, 8205, '\p{Jt=	_C}', "");
    Expect(0, 8205, '\p{^Jt=	_C}', "");
    Expect(0, 8205, '\P{Jt=	_C}', "");
    Expect(1, 8205, '\P{^Jt=	_C}', "");
    Expect(0, 8206, '\p{Jt=	_C}', "");
    Expect(1, 8206, '\p{^Jt=	_C}', "");
    Expect(1, 8206, '\P{Jt=	_C}', "");
    Expect(0, 8206, '\P{^Jt=	_C}', "");
    Error('\p{Is_Joining_Type=	/a/JOIN_CAUSING}');
    Error('\P{Is_Joining_Type=	/a/JOIN_CAUSING}');
    Expect(1, 8205, '\p{Is_Joining_Type=joincausing}', "");
    Expect(0, 8205, '\p{^Is_Joining_Type=joincausing}', "");
    Expect(0, 8205, '\P{Is_Joining_Type=joincausing}', "");
    Expect(1, 8205, '\P{^Is_Joining_Type=joincausing}', "");
    Expect(0, 8206, '\p{Is_Joining_Type=joincausing}', "");
    Expect(1, 8206, '\p{^Is_Joining_Type=joincausing}', "");
    Expect(1, 8206, '\P{Is_Joining_Type=joincausing}', "");
    Expect(0, 8206, '\P{^Is_Joining_Type=joincausing}', "");
    Expect(1, 8205, '\p{Is_Joining_Type=  Join_causing}', "");
    Expect(0, 8205, '\p{^Is_Joining_Type=  Join_causing}', "");
    Expect(0, 8205, '\P{Is_Joining_Type=  Join_causing}', "");
    Expect(1, 8205, '\P{^Is_Joining_Type=  Join_causing}', "");
    Expect(0, 8206, '\p{Is_Joining_Type=  Join_causing}', "");
    Expect(1, 8206, '\p{^Is_Joining_Type=  Join_causing}', "");
    Expect(1, 8206, '\P{Is_Joining_Type=  Join_causing}', "");
    Expect(0, 8206, '\P{^Is_Joining_Type=  Join_causing}', "");
    Error('\p{Is_Jt= C/a/}');
    Error('\P{Is_Jt= C/a/}');
    Expect(1, 8205, '\p{Is_Jt=c}', "");
    Expect(0, 8205, '\p{^Is_Jt=c}', "");
    Expect(0, 8205, '\P{Is_Jt=c}', "");
    Expect(1, 8205, '\P{^Is_Jt=c}', "");
    Expect(0, 8206, '\p{Is_Jt=c}', "");
    Expect(1, 8206, '\p{^Is_Jt=c}', "");
    Expect(1, 8206, '\P{Is_Jt=c}', "");
    Expect(0, 8206, '\P{^Is_Jt=c}', "");
    Expect(1, 8205, '\p{Is_Jt=	C}', "");
    Expect(0, 8205, '\p{^Is_Jt=	C}', "");
    Expect(0, 8205, '\P{Is_Jt=	C}', "");
    Expect(1, 8205, '\P{^Is_Jt=	C}', "");
    Expect(0, 8206, '\p{Is_Jt=	C}', "");
    Expect(1, 8206, '\p{^Is_Jt=	C}', "");
    Expect(1, 8206, '\P{Is_Jt=	C}', "");
    Expect(0, 8206, '\P{^Is_Jt=	C}', "");
    Error('\p{Joining_Type=:=	-DUAL_joining}');
    Error('\P{Joining_Type=:=	-DUAL_joining}');
    Expect(1, 125251, '\p{Joining_Type=:\ADual_Joining\z:}', "");;
    Expect(0, 125252, '\p{Joining_Type=:\ADual_Joining\z:}', "");;
    Expect(1, 125251, '\p{Joining_Type=dualjoining}', "");
    Expect(0, 125251, '\p{^Joining_Type=dualjoining}', "");
    Expect(0, 125251, '\P{Joining_Type=dualjoining}', "");
    Expect(1, 125251, '\P{^Joining_Type=dualjoining}', "");
    Expect(0, 125252, '\p{Joining_Type=dualjoining}', "");
    Expect(1, 125252, '\p{^Joining_Type=dualjoining}', "");
    Expect(1, 125252, '\P{Joining_Type=dualjoining}', "");
    Expect(0, 125252, '\P{^Joining_Type=dualjoining}', "");
    Expect(1, 125251, '\p{Joining_Type=:\Adualjoining\z:}', "");;
    Expect(0, 125252, '\p{Joining_Type=:\Adualjoining\z:}', "");;
    Expect(1, 125251, '\p{Joining_Type=	DUAL_JOINING}', "");
    Expect(0, 125251, '\p{^Joining_Type=	DUAL_JOINING}', "");
    Expect(0, 125251, '\P{Joining_Type=	DUAL_JOINING}', "");
    Expect(1, 125251, '\P{^Joining_Type=	DUAL_JOINING}', "");
    Expect(0, 125252, '\p{Joining_Type=	DUAL_JOINING}', "");
    Expect(1, 125252, '\p{^Joining_Type=	DUAL_JOINING}', "");
    Expect(1, 125252, '\P{Joining_Type=	DUAL_JOINING}', "");
    Expect(0, 125252, '\P{^Joining_Type=	DUAL_JOINING}', "");
    Error('\p{Jt:   /a/_	D}');
    Error('\P{Jt:   /a/_	D}');
    Expect(1, 125251, '\p{Jt=:\AD\z:}', "");;
    Expect(0, 125252, '\p{Jt=:\AD\z:}', "");;
    Expect(1, 125251, '\p{Jt=d}', "");
    Expect(0, 125251, '\p{^Jt=d}', "");
    Expect(0, 125251, '\P{Jt=d}', "");
    Expect(1, 125251, '\P{^Jt=d}', "");
    Expect(0, 125252, '\p{Jt=d}', "");
    Expect(1, 125252, '\p{^Jt=d}', "");
    Expect(1, 125252, '\P{Jt=d}', "");
    Expect(0, 125252, '\P{^Jt=d}', "");
    Expect(1, 125251, '\p{Jt=:\Ad\z:}', "");;
    Expect(0, 125252, '\p{Jt=:\Ad\z:}', "");;
    Expect(1, 125251, '\p{Jt=	 D}', "");
    Expect(0, 125251, '\p{^Jt=	 D}', "");
    Expect(0, 125251, '\P{Jt=	 D}', "");
    Expect(1, 125251, '\P{^Jt=	 D}', "");
    Expect(0, 125252, '\p{Jt=	 D}', "");
    Expect(1, 125252, '\p{^Jt=	 D}', "");
    Expect(1, 125252, '\P{Jt=	 D}', "");
    Expect(0, 125252, '\P{^Jt=	 D}', "");
    Error('\p{Is_Joining_Type:   :=_-DUAL_Joining}');
    Error('\P{Is_Joining_Type:   :=_-DUAL_Joining}');
    Expect(1, 125251, '\p{Is_Joining_Type=dualjoining}', "");
    Expect(0, 125251, '\p{^Is_Joining_Type=dualjoining}', "");
    Expect(0, 125251, '\P{Is_Joining_Type=dualjoining}', "");
    Expect(1, 125251, '\P{^Is_Joining_Type=dualjoining}', "");
    Expect(0, 125252, '\p{Is_Joining_Type=dualjoining}', "");
    Expect(1, 125252, '\p{^Is_Joining_Type=dualjoining}', "");
    Expect(1, 125252, '\P{Is_Joining_Type=dualjoining}', "");
    Expect(0, 125252, '\P{^Is_Joining_Type=dualjoining}', "");
    Expect(1, 125251, '\p{Is_Joining_Type=-DUAL_joining}', "");
    Expect(0, 125251, '\p{^Is_Joining_Type=-DUAL_joining}', "");
    Expect(0, 125251, '\P{Is_Joining_Type=-DUAL_joining}', "");
    Expect(1, 125251, '\P{^Is_Joining_Type=-DUAL_joining}', "");
    Expect(0, 125252, '\p{Is_Joining_Type=-DUAL_joining}', "");
    Expect(1, 125252, '\p{^Is_Joining_Type=-DUAL_joining}', "");
    Expect(1, 125252, '\P{Is_Joining_Type=-DUAL_joining}', "");
    Expect(0, 125252, '\P{^Is_Joining_Type=-DUAL_joining}', "");
    Error('\p{Is_Jt=/a/_	D}');
    Error('\P{Is_Jt=/a/_	D}');
    Expect(1, 125251, '\p{Is_Jt=d}', "");
    Expect(0, 125251, '\p{^Is_Jt=d}', "");
    Expect(0, 125251, '\P{Is_Jt=d}', "");
    Expect(1, 125251, '\P{^Is_Jt=d}', "");
    Expect(0, 125252, '\p{Is_Jt=d}', "");
    Expect(1, 125252, '\p{^Is_Jt=d}', "");
    Expect(1, 125252, '\P{Is_Jt=d}', "");
    Expect(0, 125252, '\P{^Is_Jt=d}', "");
    Expect(1, 125251, '\p{Is_Jt=	D}', "");
    Expect(0, 125251, '\p{^Is_Jt=	D}', "");
    Expect(0, 125251, '\P{Is_Jt=	D}', "");
    Expect(1, 125251, '\P{^Is_Jt=	D}', "");
    Expect(0, 125252, '\p{Is_Jt=	D}', "");
    Expect(1, 125252, '\p{^Is_Jt=	D}', "");
    Expect(1, 125252, '\P{Is_Jt=	D}', "");
    Expect(0, 125252, '\P{^Is_Jt=	D}', "");
    Error('\p{Joining_Type= left_Joining/a/}');
    Error('\P{Joining_Type= left_Joining/a/}');
    Expect(1, 69579, '\p{Joining_Type=:\ALeft_Joining\z:}', "");;
    Expect(0, 69580, '\p{Joining_Type=:\ALeft_Joining\z:}', "");;
    Expect(1, 69579, '\p{Joining_Type=leftjoining}', "");
    Expect(0, 69579, '\p{^Joining_Type=leftjoining}', "");
    Expect(0, 69579, '\P{Joining_Type=leftjoining}', "");
    Expect(1, 69579, '\P{^Joining_Type=leftjoining}', "");
    Expect(0, 69580, '\p{Joining_Type=leftjoining}', "");
    Expect(1, 69580, '\p{^Joining_Type=leftjoining}', "");
    Expect(1, 69580, '\P{Joining_Type=leftjoining}', "");
    Expect(0, 69580, '\P{^Joining_Type=leftjoining}', "");
    Expect(1, 69579, '\p{Joining_Type=:\Aleftjoining\z:}', "");;
    Expect(0, 69580, '\p{Joining_Type=:\Aleftjoining\z:}', "");;
    Expect(1, 69579, '\p{Joining_Type=-left_JOINING}', "");
    Expect(0, 69579, '\p{^Joining_Type=-left_JOINING}', "");
    Expect(0, 69579, '\P{Joining_Type=-left_JOINING}', "");
    Expect(1, 69579, '\P{^Joining_Type=-left_JOINING}', "");
    Expect(0, 69580, '\p{Joining_Type=-left_JOINING}', "");
    Expect(1, 69580, '\p{^Joining_Type=-left_JOINING}', "");
    Expect(1, 69580, '\P{Joining_Type=-left_JOINING}', "");
    Expect(0, 69580, '\P{^Joining_Type=-left_JOINING}', "");
    Error('\p{Jt= /a/L}');
    Error('\P{Jt= /a/L}');
    Expect(1, 69579, '\p{Jt=:\AL\z:}', "");;
    Expect(0, 69580, '\p{Jt=:\AL\z:}', "");;
    Expect(1, 69579, '\p{Jt=l}', "");
    Expect(0, 69579, '\p{^Jt=l}', "");
    Expect(0, 69579, '\P{Jt=l}', "");
    Expect(1, 69579, '\P{^Jt=l}', "");
    Expect(0, 69580, '\p{Jt=l}', "");
    Expect(1, 69580, '\p{^Jt=l}', "");
    Expect(1, 69580, '\P{Jt=l}', "");
    Expect(0, 69580, '\P{^Jt=l}', "");
    Expect(1, 69579, '\p{Jt=:\Al\z:}', "");;
    Expect(0, 69580, '\p{Jt=:\Al\z:}', "");;
    Expect(1, 69579, '\p{Jt=	 L}', "");
    Expect(0, 69579, '\p{^Jt=	 L}', "");
    Expect(0, 69579, '\P{Jt=	 L}', "");
    Expect(1, 69579, '\P{^Jt=	 L}', "");
    Expect(0, 69580, '\p{Jt=	 L}', "");
    Expect(1, 69580, '\p{^Jt=	 L}', "");
    Expect(1, 69580, '\P{Jt=	 L}', "");
    Expect(0, 69580, '\P{^Jt=	 L}', "");
    Error('\p{Is_Joining_Type:     Left_Joining:=}');
    Error('\P{Is_Joining_Type:     Left_Joining:=}');
    Expect(1, 69579, '\p{Is_Joining_Type:	leftjoining}', "");
    Expect(0, 69579, '\p{^Is_Joining_Type:	leftjoining}', "");
    Expect(0, 69579, '\P{Is_Joining_Type:	leftjoining}', "");
    Expect(1, 69579, '\P{^Is_Joining_Type:	leftjoining}', "");
    Expect(0, 69580, '\p{Is_Joining_Type:	leftjoining}', "");
    Expect(1, 69580, '\p{^Is_Joining_Type:	leftjoining}', "");
    Expect(1, 69580, '\P{Is_Joining_Type:	leftjoining}', "");
    Expect(0, 69580, '\P{^Is_Joining_Type:	leftjoining}', "");
    Expect(1, 69579, '\p{Is_Joining_Type=	-Left_JOINING}', "");
    Expect(0, 69579, '\p{^Is_Joining_Type=	-Left_JOINING}', "");
    Expect(0, 69579, '\P{Is_Joining_Type=	-Left_JOINING}', "");
    Expect(1, 69579, '\P{^Is_Joining_Type=	-Left_JOINING}', "");
    Expect(0, 69580, '\p{Is_Joining_Type=	-Left_JOINING}', "");
    Expect(1, 69580, '\p{^Is_Joining_Type=	-Left_JOINING}', "");
    Expect(1, 69580, '\P{Is_Joining_Type=	-Left_JOINING}', "");
    Expect(0, 69580, '\P{^Is_Joining_Type=	-Left_JOINING}', "");
    Error('\p{Is_Jt=-:=L}');
    Error('\P{Is_Jt=-:=L}');
    Expect(1, 69579, '\p{Is_Jt: l}', "");
    Expect(0, 69579, '\p{^Is_Jt: l}', "");
    Expect(0, 69579, '\P{Is_Jt: l}', "");
    Expect(1, 69579, '\P{^Is_Jt: l}', "");
    Expect(0, 69580, '\p{Is_Jt: l}', "");
    Expect(1, 69580, '\p{^Is_Jt: l}', "");
    Expect(1, 69580, '\P{Is_Jt: l}', "");
    Expect(0, 69580, '\P{^Is_Jt: l}', "");
    Expect(1, 69579, '\p{Is_Jt=- l}', "");
    Expect(0, 69579, '\p{^Is_Jt=- l}', "");
    Expect(0, 69579, '\P{Is_Jt=- l}', "");
    Expect(1, 69579, '\P{^Is_Jt=- l}', "");
    Expect(0, 69580, '\p{Is_Jt=- l}', "");
    Expect(1, 69580, '\p{^Is_Jt=- l}', "");
    Expect(1, 69580, '\P{Is_Jt=- l}', "");
    Expect(0, 69580, '\P{^Is_Jt=- l}', "");
    Error('\p{Joining_Type=_:=Right_JOINING}');
    Error('\P{Joining_Type=_:=Right_JOINING}');
    Expect(1, 69577, '\p{Joining_Type=:\ARight_Joining\z:}', "");;
    Expect(0, 69578, '\p{Joining_Type=:\ARight_Joining\z:}', "");;
    Expect(1, 69577, '\p{Joining_Type=rightjoining}', "");
    Expect(0, 69577, '\p{^Joining_Type=rightjoining}', "");
    Expect(0, 69577, '\P{Joining_Type=rightjoining}', "");
    Expect(1, 69577, '\P{^Joining_Type=rightjoining}', "");
    Expect(0, 69578, '\p{Joining_Type=rightjoining}', "");
    Expect(1, 69578, '\p{^Joining_Type=rightjoining}', "");
    Expect(1, 69578, '\P{Joining_Type=rightjoining}', "");
    Expect(0, 69578, '\P{^Joining_Type=rightjoining}', "");
    Expect(1, 69577, '\p{Joining_Type=:\Arightjoining\z:}', "");;
    Expect(0, 69578, '\p{Joining_Type=:\Arightjoining\z:}', "");;
    Expect(1, 69577, '\p{Joining_Type=	_Right_Joining}', "");
    Expect(0, 69577, '\p{^Joining_Type=	_Right_Joining}', "");
    Expect(0, 69577, '\P{Joining_Type=	_Right_Joining}', "");
    Expect(1, 69577, '\P{^Joining_Type=	_Right_Joining}', "");
    Expect(0, 69578, '\p{Joining_Type=	_Right_Joining}', "");
    Expect(1, 69578, '\p{^Joining_Type=	_Right_Joining}', "");
    Expect(1, 69578, '\P{Joining_Type=	_Right_Joining}', "");
    Expect(0, 69578, '\P{^Joining_Type=	_Right_Joining}', "");
    Error('\p{Jt=	_R/a/}');
    Error('\P{Jt=	_R/a/}');
    Expect(1, 69577, '\p{Jt=:\AR\z:}', "");;
    Expect(0, 69578, '\p{Jt=:\AR\z:}', "");;
    Expect(1, 69577, '\p{Jt:	r}', "");
    Expect(0, 69577, '\p{^Jt:	r}', "");
    Expect(0, 69577, '\P{Jt:	r}', "");
    Expect(1, 69577, '\P{^Jt:	r}', "");
    Expect(0, 69578, '\p{Jt:	r}', "");
    Expect(1, 69578, '\p{^Jt:	r}', "");
    Expect(1, 69578, '\P{Jt:	r}', "");
    Expect(0, 69578, '\P{^Jt:	r}', "");
    Expect(1, 69577, '\p{Jt=:\Ar\z:}', "");;
    Expect(0, 69578, '\p{Jt=:\Ar\z:}', "");;
    Expect(1, 69577, '\p{Jt= R}', "");
    Expect(0, 69577, '\p{^Jt= R}', "");
    Expect(0, 69577, '\P{Jt= R}', "");
    Expect(1, 69577, '\P{^Jt= R}', "");
    Expect(0, 69578, '\p{Jt= R}', "");
    Expect(1, 69578, '\p{^Jt= R}', "");
    Expect(1, 69578, '\P{Jt= R}', "");
    Expect(0, 69578, '\P{^Jt= R}', "");
    Error('\p{Is_Joining_Type=_/a/Right_JOINING}');
    Error('\P{Is_Joining_Type=_/a/Right_JOINING}');
    Expect(1, 69577, '\p{Is_Joining_Type: rightjoining}', "");
    Expect(0, 69577, '\p{^Is_Joining_Type: rightjoining}', "");
    Expect(0, 69577, '\P{Is_Joining_Type: rightjoining}', "");
    Expect(1, 69577, '\P{^Is_Joining_Type: rightjoining}', "");
    Expect(0, 69578, '\p{Is_Joining_Type: rightjoining}', "");
    Expect(1, 69578, '\p{^Is_Joining_Type: rightjoining}', "");
    Expect(1, 69578, '\P{Is_Joining_Type: rightjoining}', "");
    Expect(0, 69578, '\P{^Is_Joining_Type: rightjoining}', "");
    Expect(1, 69577, '\p{Is_Joining_Type=-	RIGHT_Joining}', "");
    Expect(0, 69577, '\p{^Is_Joining_Type=-	RIGHT_Joining}', "");
    Expect(0, 69577, '\P{Is_Joining_Type=-	RIGHT_Joining}', "");
    Expect(1, 69577, '\P{^Is_Joining_Type=-	RIGHT_Joining}', "");
    Expect(0, 69578, '\p{Is_Joining_Type=-	RIGHT_Joining}', "");
    Expect(1, 69578, '\p{^Is_Joining_Type=-	RIGHT_Joining}', "");
    Expect(1, 69578, '\P{Is_Joining_Type=-	RIGHT_Joining}', "");
    Expect(0, 69578, '\P{^Is_Joining_Type=-	RIGHT_Joining}', "");
    Error('\p{Is_Jt=  R/a/}');
    Error('\P{Is_Jt=  R/a/}');
    Expect(1, 69577, '\p{Is_Jt=r}', "");
    Expect(0, 69577, '\p{^Is_Jt=r}', "");
    Expect(0, 69577, '\P{Is_Jt=r}', "");
    Expect(1, 69577, '\P{^Is_Jt=r}', "");
    Expect(0, 69578, '\p{Is_Jt=r}', "");
    Expect(1, 69578, '\p{^Is_Jt=r}', "");
    Expect(1, 69578, '\P{Is_Jt=r}', "");
    Expect(0, 69578, '\P{^Is_Jt=r}', "");
    Expect(1, 69577, '\p{Is_Jt=	-R}', "");
    Expect(0, 69577, '\p{^Is_Jt=	-R}', "");
    Expect(0, 69577, '\P{Is_Jt=	-R}', "");
    Expect(1, 69577, '\P{^Is_Jt=	-R}', "");
    Expect(0, 69578, '\p{Is_Jt=	-R}', "");
    Expect(1, 69578, '\p{^Is_Jt=	-R}', "");
    Expect(1, 69578, '\P{Is_Jt=	-R}', "");
    Expect(0, 69578, '\P{^Is_Jt=	-R}', "");
    Error('\p{Joining_Type=:=_-TRANSPARENT}');
    Error('\P{Joining_Type=:=_-TRANSPARENT}');
    Expect(1, 917999, '\p{Joining_Type=:\ATransparent\z:}', "");;
    Expect(0, 918000, '\p{Joining_Type=:\ATransparent\z:}', "");;
    Expect(1, 917999, '\p{Joining_Type:	transparent}', "");
    Expect(0, 917999, '\p{^Joining_Type:	transparent}', "");
    Expect(0, 917999, '\P{Joining_Type:	transparent}', "");
    Expect(1, 917999, '\P{^Joining_Type:	transparent}', "");
    Expect(0, 918000, '\p{Joining_Type:	transparent}', "");
    Expect(1, 918000, '\p{^Joining_Type:	transparent}', "");
    Expect(1, 918000, '\P{Joining_Type:	transparent}', "");
    Expect(0, 918000, '\P{^Joining_Type:	transparent}', "");
    Expect(1, 917999, '\p{Joining_Type=:\Atransparent\z:}', "");;
    Expect(0, 918000, '\p{Joining_Type=:\Atransparent\z:}', "");;
    Expect(1, 917999, '\p{Joining_Type=	 TRANSPARENT}', "");
    Expect(0, 917999, '\p{^Joining_Type=	 TRANSPARENT}', "");
    Expect(0, 917999, '\P{Joining_Type=	 TRANSPARENT}', "");
    Expect(1, 917999, '\P{^Joining_Type=	 TRANSPARENT}', "");
    Expect(0, 918000, '\p{Joining_Type=	 TRANSPARENT}', "");
    Expect(1, 918000, '\p{^Joining_Type=	 TRANSPARENT}', "");
    Expect(1, 918000, '\P{Joining_Type=	 TRANSPARENT}', "");
    Expect(0, 918000, '\P{^Joining_Type=	 TRANSPARENT}', "");
    Error('\p{Jt=_:=t}');
    Error('\P{Jt=_:=t}');
    Expect(1, 917999, '\p{Jt=:\AT\z:}', "");;
    Expect(0, 918000, '\p{Jt=:\AT\z:}', "");;
    Expect(1, 917999, '\p{Jt=t}', "");
    Expect(0, 917999, '\p{^Jt=t}', "");
    Expect(0, 917999, '\P{Jt=t}', "");
    Expect(1, 917999, '\P{^Jt=t}', "");
    Expect(0, 918000, '\p{Jt=t}', "");
    Expect(1, 918000, '\p{^Jt=t}', "");
    Expect(1, 918000, '\P{Jt=t}', "");
    Expect(0, 918000, '\P{^Jt=t}', "");
    Expect(1, 917999, '\p{Jt=:\At\z:}', "");;
    Expect(0, 918000, '\p{Jt=:\At\z:}', "");;
    Expect(1, 917999, '\p{Jt=-	T}', "");
    Expect(0, 917999, '\p{^Jt=-	T}', "");
    Expect(0, 917999, '\P{Jt=-	T}', "");
    Expect(1, 917999, '\P{^Jt=-	T}', "");
    Expect(0, 918000, '\p{Jt=-	T}', "");
    Expect(1, 918000, '\p{^Jt=-	T}', "");
    Expect(1, 918000, '\P{Jt=-	T}', "");
    Expect(0, 918000, '\P{^Jt=-	T}', "");
    Error('\p{Is_Joining_Type=-/a/Transparent}');
    Error('\P{Is_Joining_Type=-/a/Transparent}');
    Expect(1, 917999, '\p{Is_Joining_Type=transparent}', "");
    Expect(0, 917999, '\p{^Is_Joining_Type=transparent}', "");
    Expect(0, 917999, '\P{Is_Joining_Type=transparent}', "");
    Expect(1, 917999, '\P{^Is_Joining_Type=transparent}', "");
    Expect(0, 918000, '\p{Is_Joining_Type=transparent}', "");
    Expect(1, 918000, '\p{^Is_Joining_Type=transparent}', "");
    Expect(1, 918000, '\P{Is_Joining_Type=transparent}', "");
    Expect(0, 918000, '\P{^Is_Joining_Type=transparent}', "");
    Expect(1, 917999, '\p{Is_Joining_Type=-	Transparent}', "");
    Expect(0, 917999, '\p{^Is_Joining_Type=-	Transparent}', "");
    Expect(0, 917999, '\P{Is_Joining_Type=-	Transparent}', "");
    Expect(1, 917999, '\P{^Is_Joining_Type=-	Transparent}', "");
    Expect(0, 918000, '\p{Is_Joining_Type=-	Transparent}', "");
    Expect(1, 918000, '\p{^Is_Joining_Type=-	Transparent}', "");
    Expect(1, 918000, '\P{Is_Joining_Type=-	Transparent}', "");
    Expect(0, 918000, '\P{^Is_Joining_Type=-	Transparent}', "");
    Error('\p{Is_Jt:-:=T}');
    Error('\P{Is_Jt:-:=T}');
    Expect(1, 917999, '\p{Is_Jt=t}', "");
    Expect(0, 917999, '\p{^Is_Jt=t}', "");
    Expect(0, 917999, '\P{Is_Jt=t}', "");
    Expect(1, 917999, '\P{^Is_Jt=t}', "");
    Expect(0, 918000, '\p{Is_Jt=t}', "");
    Expect(1, 918000, '\p{^Is_Jt=t}', "");
    Expect(1, 918000, '\P{Is_Jt=t}', "");
    Expect(0, 918000, '\P{^Is_Jt=t}', "");
    Expect(1, 917999, '\p{Is_Jt=	T}', "");
    Expect(0, 917999, '\p{^Is_Jt=	T}', "");
    Expect(0, 917999, '\P{Is_Jt=	T}', "");
    Expect(1, 917999, '\P{^Is_Jt=	T}', "");
    Expect(0, 918000, '\p{Is_Jt=	T}', "");
    Expect(1, 918000, '\p{^Is_Jt=	T}', "");
    Expect(1, 918000, '\P{Is_Jt=	T}', "");
    Expect(0, 918000, '\P{^Is_Jt=	T}', "");
    Error('\p{Joining_Type=:= _Non_joining}');
    Error('\P{Joining_Type=:= _Non_joining}');
    Expect(1, 918000, '\p{Joining_Type=:\ANon_Joining\z:}', "");;
    Expect(0, 917999, '\p{Joining_Type=:\ANon_Joining\z:}', "");;
    Expect(1, 918000, '\p{Joining_Type=nonjoining}', "");
    Expect(0, 918000, '\p{^Joining_Type=nonjoining}', "");
    Expect(0, 918000, '\P{Joining_Type=nonjoining}', "");
    Expect(1, 918000, '\P{^Joining_Type=nonjoining}', "");
    Expect(0, 917999, '\p{Joining_Type=nonjoining}', "");
    Expect(1, 917999, '\p{^Joining_Type=nonjoining}', "");
    Expect(1, 917999, '\P{Joining_Type=nonjoining}', "");
    Expect(0, 917999, '\P{^Joining_Type=nonjoining}', "");
    Expect(1, 918000, '\p{Joining_Type=:\Anonjoining\z:}', "");;
    Expect(0, 917999, '\p{Joining_Type=:\Anonjoining\z:}', "");;
    Expect(1, 918000, '\p{Joining_Type=-	Non_Joining}', "");
    Expect(0, 918000, '\p{^Joining_Type=-	Non_Joining}', "");
    Expect(0, 918000, '\P{Joining_Type=-	Non_Joining}', "");
    Expect(1, 918000, '\P{^Joining_Type=-	Non_Joining}', "");
    Expect(0, 917999, '\p{Joining_Type=-	Non_Joining}', "");
    Expect(1, 917999, '\p{^Joining_Type=-	Non_Joining}', "");
    Expect(1, 917999, '\P{Joining_Type=-	Non_Joining}', "");
    Expect(0, 917999, '\P{^Joining_Type=-	Non_Joining}', "");
    Error('\p{Jt=:=_u}');
    Error('\P{Jt=:=_u}');
    Expect(1, 918000, '\p{Jt=:\AU\z:}', "");;
    Expect(0, 917999, '\p{Jt=:\AU\z:}', "");;
    Expect(1, 918000, '\p{Jt=u}', "");
    Expect(0, 918000, '\p{^Jt=u}', "");
    Expect(0, 918000, '\P{Jt=u}', "");
    Expect(1, 918000, '\P{^Jt=u}', "");
    Expect(0, 917999, '\p{Jt=u}', "");
    Expect(1, 917999, '\p{^Jt=u}', "");
    Expect(1, 917999, '\P{Jt=u}', "");
    Expect(0, 917999, '\P{^Jt=u}', "");
    Expect(1, 918000, '\p{Jt=:\Au\z:}', "");;
    Expect(0, 917999, '\p{Jt=:\Au\z:}', "");;
    Expect(1, 918000, '\p{Jt=_	u}', "");
    Expect(0, 918000, '\p{^Jt=_	u}', "");
    Expect(0, 918000, '\P{Jt=_	u}', "");
    Expect(1, 918000, '\P{^Jt=_	u}', "");
    Expect(0, 917999, '\p{Jt=_	u}', "");
    Expect(1, 917999, '\p{^Jt=_	u}', "");
    Expect(1, 917999, '\P{Jt=_	u}', "");
    Expect(0, 917999, '\P{^Jt=_	u}', "");
    Error('\p{Is_Joining_Type=/a/ NON_JOINING}');
    Error('\P{Is_Joining_Type=/a/ NON_JOINING}');
    Expect(1, 918000, '\p{Is_Joining_Type=nonjoining}', "");
    Expect(0, 918000, '\p{^Is_Joining_Type=nonjoining}', "");
    Expect(0, 918000, '\P{Is_Joining_Type=nonjoining}', "");
    Expect(1, 918000, '\P{^Is_Joining_Type=nonjoining}', "");
    Expect(0, 917999, '\p{Is_Joining_Type=nonjoining}', "");
    Expect(1, 917999, '\p{^Is_Joining_Type=nonjoining}', "");
    Expect(1, 917999, '\P{Is_Joining_Type=nonjoining}', "");
    Expect(0, 917999, '\P{^Is_Joining_Type=nonjoining}', "");
    Expect(1, 918000, '\p{Is_Joining_Type:_Non_Joining}', "");
    Expect(0, 918000, '\p{^Is_Joining_Type:_Non_Joining}', "");
    Expect(0, 918000, '\P{Is_Joining_Type:_Non_Joining}', "");
    Expect(1, 918000, '\P{^Is_Joining_Type:_Non_Joining}', "");
    Expect(0, 917999, '\p{Is_Joining_Type:_Non_Joining}', "");
    Expect(1, 917999, '\p{^Is_Joining_Type:_Non_Joining}', "");
    Expect(1, 917999, '\P{Is_Joining_Type:_Non_Joining}', "");
    Expect(0, 917999, '\P{^Is_Joining_Type:_Non_Joining}', "");
    Error('\p{Is_Jt:	:=U}');
    Error('\P{Is_Jt:	:=U}');
    Expect(1, 918000, '\p{Is_Jt=u}', "");
    Expect(0, 918000, '\p{^Is_Jt=u}', "");
    Expect(0, 918000, '\P{Is_Jt=u}', "");
    Expect(1, 918000, '\P{^Is_Jt=u}', "");
    Expect(0, 917999, '\p{Is_Jt=u}', "");
    Expect(1, 917999, '\p{^Is_Jt=u}', "");
    Expect(1, 917999, '\P{Is_Jt=u}', "");
    Expect(0, 917999, '\P{^Is_Jt=u}', "");
    Expect(1, 918000, '\p{Is_Jt=_	U}', "");
    Expect(0, 918000, '\p{^Is_Jt=_	U}', "");
    Expect(0, 918000, '\P{Is_Jt=_	U}', "");
    Expect(1, 918000, '\P{^Is_Jt=_	U}', "");
    Expect(0, 917999, '\p{Is_Jt=_	U}', "");
    Expect(1, 917999, '\p{^Is_Jt=_	U}', "");
    Expect(1, 917999, '\P{Is_Jt=_	U}', "");
    Expect(0, 917999, '\P{^Is_Jt=_	U}', "");
    Error('\p{linebreak}');
    Error('\P{linebreak}');
    Error('\p{lb}');
    Error('\P{lb}');
    Error('\p{Line_Break=/a/-ambiguous}');
    Error('\P{Line_Break=/a/-ambiguous}');
    Expect(1, 127404, '\p{Line_Break=:\AAmbiguous\z:}', "");;
    Expect(0, 127405, '\p{Line_Break=:\AAmbiguous\z:}', "");;
    Expect(1, 127404, '\p{Line_Break=ambiguous}', "");
    Expect(0, 127404, '\p{^Line_Break=ambiguous}', "");
    Expect(0, 127404, '\P{Line_Break=ambiguous}', "");
    Expect(1, 127404, '\P{^Line_Break=ambiguous}', "");
    Expect(0, 127405, '\p{Line_Break=ambiguous}', "");
    Expect(1, 127405, '\p{^Line_Break=ambiguous}', "");
    Expect(1, 127405, '\P{Line_Break=ambiguous}', "");
    Expect(0, 127405, '\P{^Line_Break=ambiguous}', "");
    Expect(1, 127404, '\p{Line_Break=:\Aambiguous\z:}', "");;
    Expect(0, 127405, '\p{Line_Break=:\Aambiguous\z:}', "");;
    Expect(1, 127404, '\p{Line_Break=__Ambiguous}', "");
    Expect(0, 127404, '\p{^Line_Break=__Ambiguous}', "");
    Expect(0, 127404, '\P{Line_Break=__Ambiguous}', "");
    Expect(1, 127404, '\P{^Line_Break=__Ambiguous}', "");
    Expect(0, 127405, '\p{Line_Break=__Ambiguous}', "");
    Expect(1, 127405, '\p{^Line_Break=__Ambiguous}', "");
    Expect(1, 127405, '\P{Line_Break=__Ambiguous}', "");
    Expect(0, 127405, '\P{^Line_Break=__Ambiguous}', "");
    Error('\p{Lb:	:=_AI}');
    Error('\P{Lb:	:=_AI}');
    Expect(1, 127404, '\p{Lb=:\AAI\z:}', "");;
    Expect(0, 127405, '\p{Lb=:\AAI\z:}', "");;
    Expect(1, 127404, '\p{Lb=ai}', "");
    Expect(0, 127404, '\p{^Lb=ai}', "");
    Expect(0, 127404, '\P{Lb=ai}', "");
    Expect(1, 127404, '\P{^Lb=ai}', "");
    Expect(0, 127405, '\p{Lb=ai}', "");
    Expect(1, 127405, '\p{^Lb=ai}', "");
    Expect(1, 127405, '\P{Lb=ai}', "");
    Expect(0, 127405, '\P{^Lb=ai}', "");
    Expect(1, 127404, '\p{Lb=:\Aai\z:}', "");;
    Expect(0, 127405, '\p{Lb=:\Aai\z:}', "");;
    Expect(1, 127404, '\p{Lb= AI}', "");
    Expect(0, 127404, '\p{^Lb= AI}', "");
    Expect(0, 127404, '\P{Lb= AI}', "");
    Expect(1, 127404, '\P{^Lb= AI}', "");
    Expect(0, 127405, '\p{Lb= AI}', "");
    Expect(1, 127405, '\p{^Lb= AI}', "");
    Expect(1, 127405, '\P{Lb= AI}', "");
    Expect(0, 127405, '\P{^Lb= AI}', "");
    Error('\p{Is_Line_Break=	:=Ambiguous}');
    Error('\P{Is_Line_Break=	:=Ambiguous}');
    Expect(1, 127404, '\p{Is_Line_Break=ambiguous}', "");
    Expect(0, 127404, '\p{^Is_Line_Break=ambiguous}', "");
    Expect(0, 127404, '\P{Is_Line_Break=ambiguous}', "");
    Expect(1, 127404, '\P{^Is_Line_Break=ambiguous}', "");
    Expect(0, 127405, '\p{Is_Line_Break=ambiguous}', "");
    Expect(1, 127405, '\p{^Is_Line_Break=ambiguous}', "");
    Expect(1, 127405, '\P{Is_Line_Break=ambiguous}', "");
    Expect(0, 127405, '\P{^Is_Line_Break=ambiguous}', "");
    Expect(1, 127404, '\p{Is_Line_Break=	Ambiguous}', "");
    Expect(0, 127404, '\p{^Is_Line_Break=	Ambiguous}', "");
    Expect(0, 127404, '\P{Is_Line_Break=	Ambiguous}', "");
    Expect(1, 127404, '\P{^Is_Line_Break=	Ambiguous}', "");
    Expect(0, 127405, '\p{Is_Line_Break=	Ambiguous}', "");
    Expect(1, 127405, '\p{^Is_Line_Break=	Ambiguous}', "");
    Expect(1, 127405, '\P{Is_Line_Break=	Ambiguous}', "");
    Expect(0, 127405, '\P{^Is_Line_Break=	Ambiguous}', "");
    Error('\p{Is_Lb:-_ai:=}');
    Error('\P{Is_Lb:-_ai:=}');
    Expect(1, 127404, '\p{Is_Lb=ai}', "");
    Expect(0, 127404, '\p{^Is_Lb=ai}', "");
    Expect(0, 127404, '\P{Is_Lb=ai}', "");
    Expect(1, 127404, '\P{^Is_Lb=ai}', "");
    Expect(0, 127405, '\p{Is_Lb=ai}', "");
    Expect(1, 127405, '\p{^Is_Lb=ai}', "");
    Expect(1, 127405, '\P{Is_Lb=ai}', "");
    Expect(0, 127405, '\P{^Is_Lb=ai}', "");
    Expect(1, 127404, '\p{Is_Lb=	-AI}', "");
    Expect(0, 127404, '\p{^Is_Lb=	-AI}', "");
    Expect(0, 127404, '\P{Is_Lb=	-AI}', "");
    Expect(1, 127404, '\P{^Is_Lb=	-AI}', "");
    Expect(0, 127405, '\p{Is_Lb=	-AI}', "");
    Expect(1, 127405, '\p{^Is_Lb=	-AI}', "");
    Expect(1, 127405, '\P{Is_Lb=	-AI}', "");
    Expect(0, 127405, '\P{^Is_Lb=	-AI}', "");
    Error('\p{Line_Break=:= _alphabetic}');
    Error('\P{Line_Break=:= _alphabetic}');
    Expect(1, 129994, '\p{Line_Break=:\AAlphabetic\z:}', "");;
    Expect(0, 129995, '\p{Line_Break=:\AAlphabetic\z:}', "");;
    Expect(1, 129994, '\p{Line_Break=alphabetic}', "");
    Expect(0, 129994, '\p{^Line_Break=alphabetic}', "");
    Expect(0, 129994, '\P{Line_Break=alphabetic}', "");
    Expect(1, 129994, '\P{^Line_Break=alphabetic}', "");
    Expect(0, 129995, '\p{Line_Break=alphabetic}', "");
    Expect(1, 129995, '\p{^Line_Break=alphabetic}', "");
    Expect(1, 129995, '\P{Line_Break=alphabetic}', "");
    Expect(0, 129995, '\P{^Line_Break=alphabetic}', "");
    Expect(1, 129994, '\p{Line_Break=:\Aalphabetic\z:}', "");;
    Expect(0, 129995, '\p{Line_Break=:\Aalphabetic\z:}', "");;
    Expect(1, 129994, '\p{Line_Break=_	ALPHABETIC}', "");
    Expect(0, 129994, '\p{^Line_Break=_	ALPHABETIC}', "");
    Expect(0, 129994, '\P{Line_Break=_	ALPHABETIC}', "");
    Expect(1, 129994, '\P{^Line_Break=_	ALPHABETIC}', "");
    Expect(0, 129995, '\p{Line_Break=_	ALPHABETIC}', "");
    Expect(1, 129995, '\p{^Line_Break=_	ALPHABETIC}', "");
    Expect(1, 129995, '\P{Line_Break=_	ALPHABETIC}', "");
    Expect(0, 129995, '\P{^Line_Break=_	ALPHABETIC}', "");
    Error('\p{Lb=:=	_AL}');
    Error('\P{Lb=:=	_AL}');
    Expect(1, 129994, '\p{Lb=:\AAL\z:}', "");;
    Expect(0, 129995, '\p{Lb=:\AAL\z:}', "");;
    Expect(1, 129994, '\p{Lb=al}', "");
    Expect(0, 129994, '\p{^Lb=al}', "");
    Expect(0, 129994, '\P{Lb=al}', "");
    Expect(1, 129994, '\P{^Lb=al}', "");
    Expect(0, 129995, '\p{Lb=al}', "");
    Expect(1, 129995, '\p{^Lb=al}', "");
    Expect(1, 129995, '\P{Lb=al}', "");
    Expect(0, 129995, '\P{^Lb=al}', "");
    Expect(1, 129994, '\p{Lb=:\Aal\z:}', "");;
    Expect(0, 129995, '\p{Lb=:\Aal\z:}', "");;
    Expect(1, 129994, '\p{Lb=-AL}', "");
    Expect(0, 129994, '\p{^Lb=-AL}', "");
    Expect(0, 129994, '\P{Lb=-AL}', "");
    Expect(1, 129994, '\P{^Lb=-AL}', "");
    Expect(0, 129995, '\p{Lb=-AL}', "");
    Expect(1, 129995, '\p{^Lb=-AL}', "");
    Expect(1, 129995, '\P{Lb=-AL}', "");
    Expect(0, 129995, '\P{^Lb=-AL}', "");
    Error('\p{Is_Line_Break:   	-Alphabetic:=}');
    Error('\P{Is_Line_Break:   	-Alphabetic:=}');
    Expect(1, 129994, '\p{Is_Line_Break=alphabetic}', "");
    Expect(0, 129994, '\p{^Is_Line_Break=alphabetic}', "");
    Expect(0, 129994, '\P{Is_Line_Break=alphabetic}', "");
    Expect(1, 129994, '\P{^Is_Line_Break=alphabetic}', "");
    Expect(0, 129995, '\p{Is_Line_Break=alphabetic}', "");
    Expect(1, 129995, '\p{^Is_Line_Break=alphabetic}', "");
    Expect(1, 129995, '\P{Is_Line_Break=alphabetic}', "");
    Expect(0, 129995, '\P{^Is_Line_Break=alphabetic}', "");
    Expect(1, 129994, '\p{Is_Line_Break= Alphabetic}', "");
    Expect(0, 129994, '\p{^Is_Line_Break= Alphabetic}', "");
    Expect(0, 129994, '\P{Is_Line_Break= Alphabetic}', "");
    Expect(1, 129994, '\P{^Is_Line_Break= Alphabetic}', "");
    Expect(0, 129995, '\p{Is_Line_Break= Alphabetic}', "");
    Expect(1, 129995, '\p{^Is_Line_Break= Alphabetic}', "");
    Expect(1, 129995, '\P{Is_Line_Break= Alphabetic}', "");
    Expect(0, 129995, '\P{^Is_Line_Break= Alphabetic}', "");
    Error('\p{Is_Lb=-:=AL}');
    Error('\P{Is_Lb=-:=AL}');
    Expect(1, 129994, '\p{Is_Lb=al}', "");
    Expect(0, 129994, '\p{^Is_Lb=al}', "");
    Expect(0, 129994, '\P{Is_Lb=al}', "");
    Expect(1, 129994, '\P{^Is_Lb=al}', "");
    Expect(0, 129995, '\p{Is_Lb=al}', "");
    Expect(1, 129995, '\p{^Is_Lb=al}', "");
    Expect(1, 129995, '\P{Is_Lb=al}', "");
    Expect(0, 129995, '\P{^Is_Lb=al}', "");
    Expect(1, 129994, '\p{Is_Lb=	AL}', "");
    Expect(0, 129994, '\p{^Is_Lb=	AL}', "");
    Expect(0, 129994, '\P{Is_Lb=	AL}', "");
    Expect(1, 129994, '\P{^Is_Lb=	AL}', "");
    Expect(0, 129995, '\p{Is_Lb=	AL}', "");
    Expect(1, 129995, '\p{^Is_Lb=	AL}', "");
    Expect(1, 129995, '\P{Is_Lb=	AL}', "");
    Expect(0, 129995, '\P{^Is_Lb=	AL}', "");
    Error('\p{Line_Break=:=	BREAK_BOTH}');
    Error('\P{Line_Break=:=	BREAK_BOTH}');
    Expect(1, 11835, '\p{Line_Break=:\ABreak_Both\z:}', "");;
    Expect(0, 11836, '\p{Line_Break=:\ABreak_Both\z:}', "");;
    Expect(1, 11835, '\p{Line_Break=breakboth}', "");
    Expect(0, 11835, '\p{^Line_Break=breakboth}', "");
    Expect(0, 11835, '\P{Line_Break=breakboth}', "");
    Expect(1, 11835, '\P{^Line_Break=breakboth}', "");
    Expect(0, 11836, '\p{Line_Break=breakboth}', "");
    Expect(1, 11836, '\p{^Line_Break=breakboth}', "");
    Expect(1, 11836, '\P{Line_Break=breakboth}', "");
    Expect(0, 11836, '\P{^Line_Break=breakboth}', "");
    Expect(1, 11835, '\p{Line_Break=:\Abreakboth\z:}', "");;
    Expect(0, 11836, '\p{Line_Break=:\Abreakboth\z:}', "");;
    Expect(1, 11835, '\p{Line_Break=-_break_Both}', "");
    Expect(0, 11835, '\p{^Line_Break=-_break_Both}', "");
    Expect(0, 11835, '\P{Line_Break=-_break_Both}', "");
    Expect(1, 11835, '\P{^Line_Break=-_break_Both}', "");
    Expect(0, 11836, '\p{Line_Break=-_break_Both}', "");
    Expect(1, 11836, '\p{^Line_Break=-_break_Both}', "");
    Expect(1, 11836, '\P{Line_Break=-_break_Both}', "");
    Expect(0, 11836, '\P{^Line_Break=-_break_Both}', "");
    Error('\p{Lb= 	B2:=}');
    Error('\P{Lb= 	B2:=}');
    Expect(1, 11835, '\p{Lb=:\AB2\z:}', "");;
    Expect(0, 11836, '\p{Lb=:\AB2\z:}', "");;
    Expect(1, 11835, '\p{Lb=b2}', "");
    Expect(0, 11835, '\p{^Lb=b2}', "");
    Expect(0, 11835, '\P{Lb=b2}', "");
    Expect(1, 11835, '\P{^Lb=b2}', "");
    Expect(0, 11836, '\p{Lb=b2}', "");
    Expect(1, 11836, '\p{^Lb=b2}', "");
    Expect(1, 11836, '\P{Lb=b2}', "");
    Expect(0, 11836, '\P{^Lb=b2}', "");
    Expect(1, 11835, '\p{Lb=:\Ab2\z:}', "");;
    Expect(0, 11836, '\p{Lb=:\Ab2\z:}', "");;
    Expect(1, 11835, '\p{Lb=		B2}', "");
    Expect(0, 11835, '\p{^Lb=		B2}', "");
    Expect(0, 11835, '\P{Lb=		B2}', "");
    Expect(1, 11835, '\P{^Lb=		B2}', "");
    Expect(0, 11836, '\p{Lb=		B2}', "");
    Expect(1, 11836, '\p{^Lb=		B2}', "");
    Expect(1, 11836, '\P{Lb=		B2}', "");
    Expect(0, 11836, '\P{^Lb=		B2}', "");
    Error('\p{Is_Line_Break=:=-	Break_both}');
    Error('\P{Is_Line_Break=:=-	Break_both}');
    Expect(1, 11835, '\p{Is_Line_Break=breakboth}', "");
    Expect(0, 11835, '\p{^Is_Line_Break=breakboth}', "");
    Expect(0, 11835, '\P{Is_Line_Break=breakboth}', "");
    Expect(1, 11835, '\P{^Is_Line_Break=breakboth}', "");
    Expect(0, 11836, '\p{Is_Line_Break=breakboth}', "");
    Expect(1, 11836, '\p{^Is_Line_Break=breakboth}', "");
    Expect(1, 11836, '\P{Is_Line_Break=breakboth}', "");
    Expect(0, 11836, '\P{^Is_Line_Break=breakboth}', "");
    Expect(1, 11835, '\p{Is_Line_Break=	 Break_both}', "");
    Expect(0, 11835, '\p{^Is_Line_Break=	 Break_both}', "");
    Expect(0, 11835, '\P{Is_Line_Break=	 Break_both}', "");
    Expect(1, 11835, '\P{^Is_Line_Break=	 Break_both}', "");
    Expect(0, 11836, '\p{Is_Line_Break=	 Break_both}', "");
    Expect(1, 11836, '\p{^Is_Line_Break=	 Break_both}', "");
    Expect(1, 11836, '\P{Is_Line_Break=	 Break_both}', "");
    Expect(0, 11836, '\P{^Is_Line_Break=	 Break_both}', "");
    Error('\p{Is_Lb=-/a/B2}');
    Error('\P{Is_Lb=-/a/B2}');
    Expect(1, 11835, '\p{Is_Lb: b2}', "");
    Expect(0, 11835, '\p{^Is_Lb: b2}', "");
    Expect(0, 11835, '\P{Is_Lb: b2}', "");
    Expect(1, 11835, '\P{^Is_Lb: b2}', "");
    Expect(0, 11836, '\p{Is_Lb: b2}', "");
    Expect(1, 11836, '\p{^Is_Lb: b2}', "");
    Expect(1, 11836, '\P{Is_Lb: b2}', "");
    Expect(0, 11836, '\P{^Is_Lb: b2}', "");
    Expect(1, 11835, '\p{Is_Lb=__B2}', "");
    Expect(0, 11835, '\p{^Is_Lb=__B2}', "");
    Expect(0, 11835, '\P{Is_Lb=__B2}', "");
    Expect(1, 11835, '\P{^Is_Lb=__B2}', "");
    Expect(0, 11836, '\p{Is_Lb=__B2}', "");
    Expect(1, 11836, '\p{^Is_Lb=__B2}', "");
    Expect(1, 11836, '\P{Is_Lb=__B2}', "");
    Expect(0, 11836, '\P{^Is_Lb=__B2}', "");
    Error('\p{Line_Break=:=	Break_AFTER}');
    Error('\P{Line_Break=:=	Break_AFTER}');
    Expect(1, 121482, '\p{Line_Break=:\ABreak_After\z:}', "");;
    Expect(0, 121483, '\p{Line_Break=:\ABreak_After\z:}', "");;
    Expect(1, 121482, '\p{Line_Break=breakafter}', "");
    Expect(0, 121482, '\p{^Line_Break=breakafter}', "");
    Expect(0, 121482, '\P{Line_Break=breakafter}', "");
    Expect(1, 121482, '\P{^Line_Break=breakafter}', "");
    Expect(0, 121483, '\p{Line_Break=breakafter}', "");
    Expect(1, 121483, '\p{^Line_Break=breakafter}', "");
    Expect(1, 121483, '\P{Line_Break=breakafter}', "");
    Expect(0, 121483, '\P{^Line_Break=breakafter}', "");
    Expect(1, 121482, '\p{Line_Break=:\Abreakafter\z:}', "");;
    Expect(0, 121483, '\p{Line_Break=:\Abreakafter\z:}', "");;
    Expect(1, 121482, '\p{Line_Break=__Break_After}', "");
    Expect(0, 121482, '\p{^Line_Break=__Break_After}', "");
    Expect(0, 121482, '\P{Line_Break=__Break_After}', "");
    Expect(1, 121482, '\P{^Line_Break=__Break_After}', "");
    Expect(0, 121483, '\p{Line_Break=__Break_After}', "");
    Expect(1, 121483, '\p{^Line_Break=__Break_After}', "");
    Expect(1, 121483, '\P{Line_Break=__Break_After}', "");
    Expect(0, 121483, '\P{^Line_Break=__Break_After}', "");
    Error('\p{Lb=	BA/a/}');
    Error('\P{Lb=	BA/a/}');
    Expect(1, 121482, '\p{Lb=:\ABA\z:}', "");;
    Expect(0, 121483, '\p{Lb=:\ABA\z:}', "");;
    Expect(1, 121482, '\p{Lb=ba}', "");
    Expect(0, 121482, '\p{^Lb=ba}', "");
    Expect(0, 121482, '\P{Lb=ba}', "");
    Expect(1, 121482, '\P{^Lb=ba}', "");
    Expect(0, 121483, '\p{Lb=ba}', "");
    Expect(1, 121483, '\p{^Lb=ba}', "");
    Expect(1, 121483, '\P{Lb=ba}', "");
    Expect(0, 121483, '\P{^Lb=ba}', "");
    Expect(1, 121482, '\p{Lb=:\Aba\z:}', "");;
    Expect(0, 121483, '\p{Lb=:\Aba\z:}', "");;
    Expect(1, 121482, '\p{Lb=-BA}', "");
    Expect(0, 121482, '\p{^Lb=-BA}', "");
    Expect(0, 121482, '\P{Lb=-BA}', "");
    Expect(1, 121482, '\P{^Lb=-BA}', "");
    Expect(0, 121483, '\p{Lb=-BA}', "");
    Expect(1, 121483, '\p{^Lb=-BA}', "");
    Expect(1, 121483, '\P{Lb=-BA}', "");
    Expect(0, 121483, '\P{^Lb=-BA}', "");
    Error('\p{Is_Line_Break:	_/a/Break_After}');
    Error('\P{Is_Line_Break:	_/a/Break_After}');
    Expect(1, 121482, '\p{Is_Line_Break=breakafter}', "");
    Expect(0, 121482, '\p{^Is_Line_Break=breakafter}', "");
    Expect(0, 121482, '\P{Is_Line_Break=breakafter}', "");
    Expect(1, 121482, '\P{^Is_Line_Break=breakafter}', "");
    Expect(0, 121483, '\p{Is_Line_Break=breakafter}', "");
    Expect(1, 121483, '\p{^Is_Line_Break=breakafter}', "");
    Expect(1, 121483, '\P{Is_Line_Break=breakafter}', "");
    Expect(0, 121483, '\P{^Is_Line_Break=breakafter}', "");
    Expect(1, 121482, '\p{Is_Line_Break=BREAK_After}', "");
    Expect(0, 121482, '\p{^Is_Line_Break=BREAK_After}', "");
    Expect(0, 121482, '\P{Is_Line_Break=BREAK_After}', "");
    Expect(1, 121482, '\P{^Is_Line_Break=BREAK_After}', "");
    Expect(0, 121483, '\p{Is_Line_Break=BREAK_After}', "");
    Expect(1, 121483, '\p{^Is_Line_Break=BREAK_After}', "");
    Expect(1, 121483, '\P{Is_Line_Break=BREAK_After}', "");
    Expect(0, 121483, '\P{^Is_Line_Break=BREAK_After}', "");
    Error('\p{Is_Lb:		BA/a/}');
    Error('\P{Is_Lb:		BA/a/}');
    Expect(1, 121482, '\p{Is_Lb=ba}', "");
    Expect(0, 121482, '\p{^Is_Lb=ba}', "");
    Expect(0, 121482, '\P{Is_Lb=ba}', "");
    Expect(1, 121482, '\P{^Is_Lb=ba}', "");
    Expect(0, 121483, '\p{Is_Lb=ba}', "");
    Expect(1, 121483, '\p{^Is_Lb=ba}', "");
    Expect(1, 121483, '\P{Is_Lb=ba}', "");
    Expect(0, 121483, '\P{^Is_Lb=ba}', "");
    Expect(1, 121482, '\p{Is_Lb=- ba}', "");
    Expect(0, 121482, '\p{^Is_Lb=- ba}', "");
    Expect(0, 121482, '\P{Is_Lb=- ba}', "");
    Expect(1, 121482, '\P{^Is_Lb=- ba}', "");
    Expect(0, 121483, '\p{Is_Lb=- ba}', "");
    Expect(1, 121483, '\p{^Is_Lb=- ba}', "");
    Expect(1, 121483, '\P{Is_Lb=- ba}', "");
    Expect(0, 121483, '\P{^Is_Lb=- ba}', "");
    Error('\p{Line_Break=/a/__Break_Before}');
    Error('\P{Line_Break=/a/__Break_Before}');
    Expect(1, 72816, '\p{Line_Break=:\ABreak_Before\z:}', "");;
    Expect(0, 72817, '\p{Line_Break=:\ABreak_Before\z:}', "");;
    Expect(1, 72816, '\p{Line_Break=breakbefore}', "");
    Expect(0, 72816, '\p{^Line_Break=breakbefore}', "");
    Expect(0, 72816, '\P{Line_Break=breakbefore}', "");
    Expect(1, 72816, '\P{^Line_Break=breakbefore}', "");
    Expect(0, 72817, '\p{Line_Break=breakbefore}', "");
    Expect(1, 72817, '\p{^Line_Break=breakbefore}', "");
    Expect(1, 72817, '\P{Line_Break=breakbefore}', "");
    Expect(0, 72817, '\P{^Line_Break=breakbefore}', "");
    Expect(1, 72816, '\p{Line_Break=:\Abreakbefore\z:}', "");;
    Expect(0, 72817, '\p{Line_Break=:\Abreakbefore\z:}', "");;
    Expect(1, 72816, '\p{Line_Break=_ break_BEFORE}', "");
    Expect(0, 72816, '\p{^Line_Break=_ break_BEFORE}', "");
    Expect(0, 72816, '\P{Line_Break=_ break_BEFORE}', "");
    Expect(1, 72816, '\P{^Line_Break=_ break_BEFORE}', "");
    Expect(0, 72817, '\p{Line_Break=_ break_BEFORE}', "");
    Expect(1, 72817, '\p{^Line_Break=_ break_BEFORE}', "");
    Expect(1, 72817, '\P{Line_Break=_ break_BEFORE}', "");
    Expect(0, 72817, '\P{^Line_Break=_ break_BEFORE}', "");
    Error('\p{Lb=:=BB}');
    Error('\P{Lb=:=BB}');
    Expect(1, 72816, '\p{Lb=:\ABB\z:}', "");;
    Expect(0, 72817, '\p{Lb=:\ABB\z:}', "");;
    Expect(1, 72816, '\p{Lb=bb}', "");
    Expect(0, 72816, '\p{^Lb=bb}', "");
    Expect(0, 72816, '\P{Lb=bb}', "");
    Expect(1, 72816, '\P{^Lb=bb}', "");
    Expect(0, 72817, '\p{Lb=bb}', "");
    Expect(1, 72817, '\p{^Lb=bb}', "");
    Expect(1, 72817, '\P{Lb=bb}', "");
    Expect(0, 72817, '\P{^Lb=bb}', "");
    Expect(1, 72816, '\p{Lb=:\Abb\z:}', "");;
    Expect(0, 72817, '\p{Lb=:\Abb\z:}', "");;
    Expect(1, 72816, '\p{Lb=_ BB}', "");
    Expect(0, 72816, '\p{^Lb=_ BB}', "");
    Expect(0, 72816, '\P{Lb=_ BB}', "");
    Expect(1, 72816, '\P{^Lb=_ BB}', "");
    Expect(0, 72817, '\p{Lb=_ BB}', "");
    Expect(1, 72817, '\p{^Lb=_ BB}', "");
    Expect(1, 72817, '\P{Lb=_ BB}', "");
    Expect(0, 72817, '\P{^Lb=_ BB}', "");
    Error('\p{Is_Line_Break=	/a/Break_before}');
    Error('\P{Is_Line_Break=	/a/Break_before}');
    Expect(1, 72816, '\p{Is_Line_Break=breakbefore}', "");
    Expect(0, 72816, '\p{^Is_Line_Break=breakbefore}', "");
    Expect(0, 72816, '\P{Is_Line_Break=breakbefore}', "");
    Expect(1, 72816, '\P{^Is_Line_Break=breakbefore}', "");
    Expect(0, 72817, '\p{Is_Line_Break=breakbefore}', "");
    Expect(1, 72817, '\p{^Is_Line_Break=breakbefore}', "");
    Expect(1, 72817, '\P{Is_Line_Break=breakbefore}', "");
    Expect(0, 72817, '\P{^Is_Line_Break=breakbefore}', "");
    Expect(1, 72816, '\p{Is_Line_Break= Break_before}', "");
    Expect(0, 72816, '\p{^Is_Line_Break= Break_before}', "");
    Expect(0, 72816, '\P{Is_Line_Break= Break_before}', "");
    Expect(1, 72816, '\P{^Is_Line_Break= Break_before}', "");
    Expect(0, 72817, '\p{Is_Line_Break= Break_before}', "");
    Expect(1, 72817, '\p{^Is_Line_Break= Break_before}', "");
    Expect(1, 72817, '\P{Is_Line_Break= Break_before}', "");
    Expect(0, 72817, '\P{^Is_Line_Break= Break_before}', "");
    Error('\p{Is_Lb:		_BB:=}');
    Error('\P{Is_Lb:		_BB:=}');
    Expect(1, 72816, '\p{Is_Lb:   bb}', "");
    Expect(0, 72816, '\p{^Is_Lb:   bb}', "");
    Expect(0, 72816, '\P{Is_Lb:   bb}', "");
    Expect(1, 72816, '\P{^Is_Lb:   bb}', "");
    Expect(0, 72817, '\p{Is_Lb:   bb}', "");
    Expect(1, 72817, '\p{^Is_Lb:   bb}', "");
    Expect(1, 72817, '\P{Is_Lb:   bb}', "");
    Expect(0, 72817, '\P{^Is_Lb:   bb}', "");
    Expect(1, 72816, '\p{Is_Lb=		BB}', "");
    Expect(0, 72816, '\p{^Is_Lb=		BB}', "");
    Expect(0, 72816, '\P{Is_Lb=		BB}', "");
    Expect(1, 72816, '\P{^Is_Lb=		BB}', "");
    Expect(0, 72817, '\p{Is_Lb=		BB}', "");
    Expect(1, 72817, '\p{^Is_Lb=		BB}', "");
    Expect(1, 72817, '\P{Is_Lb=		BB}', "");
    Expect(0, 72817, '\P{^Is_Lb=		BB}', "");
    Error('\p{Line_Break: :=	 Mandatory_BREAK}');
    Error('\P{Line_Break: :=	 Mandatory_BREAK}');
    Expect(1, 8233, '\p{Line_Break=:\AMandatory_Break\z:}', "");;
    Expect(0, 8234, '\p{Line_Break=:\AMandatory_Break\z:}', "");;
    Expect(1, 8233, '\p{Line_Break:mandatorybreak}', "");
    Expect(0, 8233, '\p{^Line_Break:mandatorybreak}', "");
    Expect(0, 8233, '\P{Line_Break:mandatorybreak}', "");
    Expect(1, 8233, '\P{^Line_Break:mandatorybreak}', "");
    Expect(0, 8234, '\p{Line_Break:mandatorybreak}', "");
    Expect(1, 8234, '\p{^Line_Break:mandatorybreak}', "");
    Expect(1, 8234, '\P{Line_Break:mandatorybreak}', "");
    Expect(0, 8234, '\P{^Line_Break:mandatorybreak}', "");
    Expect(1, 8233, '\p{Line_Break=:\Amandatorybreak\z:}', "");;
    Expect(0, 8234, '\p{Line_Break=:\Amandatorybreak\z:}', "");;
    Expect(1, 8233, '\p{Line_Break=  mandatory_BREAK}', "");
    Expect(0, 8233, '\p{^Line_Break=  mandatory_BREAK}', "");
    Expect(0, 8233, '\P{Line_Break=  mandatory_BREAK}', "");
    Expect(1, 8233, '\P{^Line_Break=  mandatory_BREAK}', "");
    Expect(0, 8234, '\p{Line_Break=  mandatory_BREAK}', "");
    Expect(1, 8234, '\p{^Line_Break=  mandatory_BREAK}', "");
    Expect(1, 8234, '\P{Line_Break=  mandatory_BREAK}', "");
    Expect(0, 8234, '\P{^Line_Break=  mandatory_BREAK}', "");
    Error('\p{Lb=	:=BK}');
    Error('\P{Lb=	:=BK}');
    Expect(1, 8233, '\p{Lb=:\ABK\z:}', "");;
    Expect(0, 8234, '\p{Lb=:\ABK\z:}', "");;
    Expect(1, 8233, '\p{Lb=bk}', "");
    Expect(0, 8233, '\p{^Lb=bk}', "");
    Expect(0, 8233, '\P{Lb=bk}', "");
    Expect(1, 8233, '\P{^Lb=bk}', "");
    Expect(0, 8234, '\p{Lb=bk}', "");
    Expect(1, 8234, '\p{^Lb=bk}', "");
    Expect(1, 8234, '\P{Lb=bk}', "");
    Expect(0, 8234, '\P{^Lb=bk}', "");
    Expect(1, 8233, '\p{Lb=:\Abk\z:}', "");;
    Expect(0, 8234, '\p{Lb=:\Abk\z:}', "");;
    Expect(1, 8233, '\p{Lb=  BK}', "");
    Expect(0, 8233, '\p{^Lb=  BK}', "");
    Expect(0, 8233, '\P{Lb=  BK}', "");
    Expect(1, 8233, '\P{^Lb=  BK}', "");
    Expect(0, 8234, '\p{Lb=  BK}', "");
    Expect(1, 8234, '\p{^Lb=  BK}', "");
    Expect(1, 8234, '\P{Lb=  BK}', "");
    Expect(0, 8234, '\P{^Lb=  BK}', "");
    Error('\p{Is_Line_Break: _/a/mandatory_BREAK}');
    Error('\P{Is_Line_Break: _/a/mandatory_BREAK}');
    Expect(1, 8233, '\p{Is_Line_Break=mandatorybreak}', "");
    Expect(0, 8233, '\p{^Is_Line_Break=mandatorybreak}', "");
    Expect(0, 8233, '\P{Is_Line_Break=mandatorybreak}', "");
    Expect(1, 8233, '\P{^Is_Line_Break=mandatorybreak}', "");
    Expect(0, 8234, '\p{Is_Line_Break=mandatorybreak}', "");
    Expect(1, 8234, '\p{^Is_Line_Break=mandatorybreak}', "");
    Expect(1, 8234, '\P{Is_Line_Break=mandatorybreak}', "");
    Expect(0, 8234, '\P{^Is_Line_Break=mandatorybreak}', "");
    Expect(1, 8233, '\p{Is_Line_Break=		Mandatory_Break}', "");
    Expect(0, 8233, '\p{^Is_Line_Break=		Mandatory_Break}', "");
    Expect(0, 8233, '\P{Is_Line_Break=		Mandatory_Break}', "");
    Expect(1, 8233, '\P{^Is_Line_Break=		Mandatory_Break}', "");
    Expect(0, 8234, '\p{Is_Line_Break=		Mandatory_Break}', "");
    Expect(1, 8234, '\p{^Is_Line_Break=		Mandatory_Break}', "");
    Expect(1, 8234, '\P{Is_Line_Break=		Mandatory_Break}', "");
    Expect(0, 8234, '\P{^Is_Line_Break=		Mandatory_Break}', "");
    Error('\p{Is_Lb=_BK:=}');
    Error('\P{Is_Lb=_BK:=}');
    Expect(1, 8233, '\p{Is_Lb=bk}', "");
    Expect(0, 8233, '\p{^Is_Lb=bk}', "");
    Expect(0, 8233, '\P{Is_Lb=bk}', "");
    Expect(1, 8233, '\P{^Is_Lb=bk}', "");
    Expect(0, 8234, '\p{Is_Lb=bk}', "");
    Expect(1, 8234, '\p{^Is_Lb=bk}', "");
    Expect(1, 8234, '\P{Is_Lb=bk}', "");
    Expect(0, 8234, '\P{^Is_Lb=bk}', "");
    Expect(1, 8233, '\p{Is_Lb=_ BK}', "");
    Expect(0, 8233, '\p{^Is_Lb=_ BK}', "");
    Expect(0, 8233, '\P{Is_Lb=_ BK}', "");
    Expect(1, 8233, '\P{^Is_Lb=_ BK}', "");
    Expect(0, 8234, '\p{Is_Lb=_ BK}', "");
    Expect(1, 8234, '\p{^Is_Lb=_ BK}', "");
    Expect(1, 8234, '\P{Is_Lb=_ BK}', "");
    Expect(0, 8234, '\P{^Is_Lb=_ BK}', "");
    Error('\p{Line_Break= Contingent_break:=}');
    Error('\P{Line_Break= Contingent_break:=}');
    Expect(1, 65532, '\p{Line_Break=:\AContingent_Break\z:}', "");;
    Expect(0, 65533, '\p{Line_Break=:\AContingent_Break\z:}', "");;
    Expect(1, 65532, '\p{Line_Break=contingentbreak}', "");
    Expect(0, 65532, '\p{^Line_Break=contingentbreak}', "");
    Expect(0, 65532, '\P{Line_Break=contingentbreak}', "");
    Expect(1, 65532, '\P{^Line_Break=contingentbreak}', "");
    Expect(0, 65533, '\p{Line_Break=contingentbreak}', "");
    Expect(1, 65533, '\p{^Line_Break=contingentbreak}', "");
    Expect(1, 65533, '\P{Line_Break=contingentbreak}', "");
    Expect(0, 65533, '\P{^Line_Break=contingentbreak}', "");
    Expect(1, 65532, '\p{Line_Break=:\Acontingentbreak\z:}', "");;
    Expect(0, 65533, '\p{Line_Break=:\Acontingentbreak\z:}', "");;
    Expect(1, 65532, '\p{Line_Break:   	_Contingent_break}', "");
    Expect(0, 65532, '\p{^Line_Break:   	_Contingent_break}', "");
    Expect(0, 65532, '\P{Line_Break:   	_Contingent_break}', "");
    Expect(1, 65532, '\P{^Line_Break:   	_Contingent_break}', "");
    Expect(0, 65533, '\p{Line_Break:   	_Contingent_break}', "");
    Expect(1, 65533, '\p{^Line_Break:   	_Contingent_break}', "");
    Expect(1, 65533, '\P{Line_Break:   	_Contingent_break}', "");
    Expect(0, 65533, '\P{^Line_Break:   	_Contingent_break}', "");
    Error('\p{Lb=- CB/a/}');
    Error('\P{Lb=- CB/a/}');
    Expect(1, 65532, '\p{Lb=:\ACB\z:}', "");;
    Expect(0, 65533, '\p{Lb=:\ACB\z:}', "");;
    Expect(1, 65532, '\p{Lb:cb}', "");
    Expect(0, 65532, '\p{^Lb:cb}', "");
    Expect(0, 65532, '\P{Lb:cb}', "");
    Expect(1, 65532, '\P{^Lb:cb}', "");
    Expect(0, 65533, '\p{Lb:cb}', "");
    Expect(1, 65533, '\p{^Lb:cb}', "");
    Expect(1, 65533, '\P{Lb:cb}', "");
    Expect(0, 65533, '\P{^Lb:cb}', "");
    Expect(1, 65532, '\p{Lb=:\Acb\z:}', "");;
    Expect(0, 65533, '\p{Lb=:\Acb\z:}', "");;
    Error('\p{Is_Line_Break=_:=contingent_Break}');
    Error('\P{Is_Line_Break=_:=contingent_Break}');
    Expect(1, 65532, '\p{Is_Line_Break=contingentbreak}', "");
    Expect(0, 65532, '\p{^Is_Line_Break=contingentbreak}', "");
    Expect(0, 65532, '\P{Is_Line_Break=contingentbreak}', "");
    Expect(1, 65532, '\P{^Is_Line_Break=contingentbreak}', "");
    Expect(0, 65533, '\p{Is_Line_Break=contingentbreak}', "");
    Expect(1, 65533, '\p{^Is_Line_Break=contingentbreak}', "");
    Expect(1, 65533, '\P{Is_Line_Break=contingentbreak}', "");
    Expect(0, 65533, '\P{^Is_Line_Break=contingentbreak}', "");
    Expect(1, 65532, '\p{Is_Line_Break=  Contingent_Break}', "");
    Expect(0, 65532, '\p{^Is_Line_Break=  Contingent_Break}', "");
    Expect(0, 65532, '\P{Is_Line_Break=  Contingent_Break}', "");
    Expect(1, 65532, '\P{^Is_Line_Break=  Contingent_Break}', "");
    Expect(0, 65533, '\p{Is_Line_Break=  Contingent_Break}', "");
    Expect(1, 65533, '\p{^Is_Line_Break=  Contingent_Break}', "");
    Expect(1, 65533, '\P{Is_Line_Break=  Contingent_Break}', "");
    Expect(0, 65533, '\P{^Is_Line_Break=  Contingent_Break}', "");
    Error('\p{Is_Lb=/a/_-CB}');
    Error('\P{Is_Lb=/a/_-CB}');
    Expect(1, 65532, '\p{Is_Lb=cb}', "");
    Expect(0, 65532, '\p{^Is_Lb=cb}', "");
    Expect(0, 65532, '\P{Is_Lb=cb}', "");
    Expect(1, 65532, '\P{^Is_Lb=cb}', "");
    Expect(0, 65533, '\p{Is_Lb=cb}', "");
    Expect(1, 65533, '\p{^Is_Lb=cb}', "");
    Expect(1, 65533, '\P{Is_Lb=cb}', "");
    Expect(0, 65533, '\P{^Is_Lb=cb}', "");
    Expect(1, 65532, '\p{Is_Lb=-_CB}', "");
    Expect(0, 65532, '\p{^Is_Lb=-_CB}', "");
    Expect(0, 65532, '\P{Is_Lb=-_CB}', "");
    Expect(1, 65532, '\P{^Is_Lb=-_CB}', "");
    Expect(0, 65533, '\p{Is_Lb=-_CB}', "");
    Expect(1, 65533, '\p{^Is_Lb=-_CB}', "");
    Expect(1, 65533, '\P{Is_Lb=-_CB}', "");
    Expect(0, 65533, '\P{^Is_Lb=-_CB}', "");
    Error('\p{Line_Break=:=conditional_japanese_STARTER}');
    Error('\P{Line_Break=:=conditional_japanese_STARTER}');
    Expect(1, 110951, '\p{Line_Break=:\AConditional_Japanese_Starter\z:}', "");;
    Expect(0, 110952, '\p{Line_Break=:\AConditional_Japanese_Starter\z:}', "");;
    Expect(1, 110951, '\p{Line_Break=conditionaljapanesestarter}', "");
    Expect(0, 110951, '\p{^Line_Break=conditionaljapanesestarter}', "");
    Expect(0, 110951, '\P{Line_Break=conditionaljapanesestarter}', "");
    Expect(1, 110951, '\P{^Line_Break=conditionaljapanesestarter}', "");
    Expect(0, 110952, '\p{Line_Break=conditionaljapanesestarter}', "");
    Expect(1, 110952, '\p{^Line_Break=conditionaljapanesestarter}', "");
    Expect(1, 110952, '\P{Line_Break=conditionaljapanesestarter}', "");
    Expect(0, 110952, '\P{^Line_Break=conditionaljapanesestarter}', "");
    Expect(1, 110951, '\p{Line_Break=:\Aconditionaljapanesestarter\z:}', "");;
    Expect(0, 110952, '\p{Line_Break=:\Aconditionaljapanesestarter\z:}', "");;
    Expect(1, 110951, '\p{Line_Break=-_Conditional_Japanese_Starter}', "");
    Expect(0, 110951, '\p{^Line_Break=-_Conditional_Japanese_Starter}', "");
    Expect(0, 110951, '\P{Line_Break=-_Conditional_Japanese_Starter}', "");
    Expect(1, 110951, '\P{^Line_Break=-_Conditional_Japanese_Starter}', "");
    Expect(0, 110952, '\p{Line_Break=-_Conditional_Japanese_Starter}', "");
    Expect(1, 110952, '\p{^Line_Break=-_Conditional_Japanese_Starter}', "");
    Expect(1, 110952, '\P{Line_Break=-_Conditional_Japanese_Starter}', "");
    Expect(0, 110952, '\P{^Line_Break=-_Conditional_Japanese_Starter}', "");
    Error('\p{Lb=  cj/a/}');
    Error('\P{Lb=  cj/a/}');
    Expect(1, 110951, '\p{Lb=:\ACJ\z:}', "");;
    Expect(0, 110952, '\p{Lb=:\ACJ\z:}', "");;
    Expect(1, 110951, '\p{Lb=cj}', "");
    Expect(0, 110951, '\p{^Lb=cj}', "");
    Expect(0, 110951, '\P{Lb=cj}', "");
    Expect(1, 110951, '\P{^Lb=cj}', "");
    Expect(0, 110952, '\p{Lb=cj}', "");
    Expect(1, 110952, '\p{^Lb=cj}', "");
    Expect(1, 110952, '\P{Lb=cj}', "");
    Expect(0, 110952, '\P{^Lb=cj}', "");
    Expect(1, 110951, '\p{Lb=:\Acj\z:}', "");;
    Expect(0, 110952, '\p{Lb=:\Acj\z:}', "");;
    Expect(1, 110951, '\p{Lb=__CJ}', "");
    Expect(0, 110951, '\p{^Lb=__CJ}', "");
    Expect(0, 110951, '\P{Lb=__CJ}', "");
    Expect(1, 110951, '\P{^Lb=__CJ}', "");
    Expect(0, 110952, '\p{Lb=__CJ}', "");
    Expect(1, 110952, '\p{^Lb=__CJ}', "");
    Expect(1, 110952, '\P{Lb=__CJ}', "");
    Expect(0, 110952, '\P{^Lb=__CJ}', "");
    Error('\p{Is_Line_Break=:=_-CONDITIONAL_japanese_STARTER}');
    Error('\P{Is_Line_Break=:=_-CONDITIONAL_japanese_STARTER}');
    Expect(1, 110951, '\p{Is_Line_Break=conditionaljapanesestarter}', "");
    Expect(0, 110951, '\p{^Is_Line_Break=conditionaljapanesestarter}', "");
    Expect(0, 110951, '\P{Is_Line_Break=conditionaljapanesestarter}', "");
    Expect(1, 110951, '\P{^Is_Line_Break=conditionaljapanesestarter}', "");
    Expect(0, 110952, '\p{Is_Line_Break=conditionaljapanesestarter}', "");
    Expect(1, 110952, '\p{^Is_Line_Break=conditionaljapanesestarter}', "");
    Expect(1, 110952, '\P{Is_Line_Break=conditionaljapanesestarter}', "");
    Expect(0, 110952, '\P{^Is_Line_Break=conditionaljapanesestarter}', "");
    Expect(1, 110951, '\p{Is_Line_Break=_	Conditional_Japanese_Starter}', "");
    Expect(0, 110951, '\p{^Is_Line_Break=_	Conditional_Japanese_Starter}', "");
    Expect(0, 110951, '\P{Is_Line_Break=_	Conditional_Japanese_Starter}', "");
    Expect(1, 110951, '\P{^Is_Line_Break=_	Conditional_Japanese_Starter}', "");
    Expect(0, 110952, '\p{Is_Line_Break=_	Conditional_Japanese_Starter}', "");
    Expect(1, 110952, '\p{^Is_Line_Break=_	Conditional_Japanese_Starter}', "");
    Expect(1, 110952, '\P{Is_Line_Break=_	Conditional_Japanese_Starter}', "");
    Expect(0, 110952, '\P{^Is_Line_Break=_	Conditional_Japanese_Starter}', "");
    Error('\p{Is_Lb=:=  cj}');
    Error('\P{Is_Lb=:=  cj}');
    Expect(1, 110951, '\p{Is_Lb=cj}', "");
    Expect(0, 110951, '\p{^Is_Lb=cj}', "");
    Expect(0, 110951, '\P{Is_Lb=cj}', "");
    Expect(1, 110951, '\P{^Is_Lb=cj}', "");
    Expect(0, 110952, '\p{Is_Lb=cj}', "");
    Expect(1, 110952, '\p{^Is_Lb=cj}', "");
    Expect(1, 110952, '\P{Is_Lb=cj}', "");
    Expect(0, 110952, '\P{^Is_Lb=cj}', "");
    Expect(1, 110951, '\p{Is_Lb:		-cj}', "");
    Expect(0, 110951, '\p{^Is_Lb:		-cj}', "");
    Expect(0, 110951, '\P{Is_Lb:		-cj}', "");
    Expect(1, 110951, '\P{^Is_Lb:		-cj}', "");
    Expect(0, 110952, '\p{Is_Lb:		-cj}', "");
    Expect(1, 110952, '\p{^Is_Lb:		-cj}', "");
    Expect(1, 110952, '\P{Is_Lb:		-cj}', "");
    Expect(0, 110952, '\P{^Is_Lb:		-cj}', "");
    Error('\p{Line_Break=__CLOSE_Punctuation:=}');
    Error('\P{Line_Break=__CLOSE_Punctuation:=}');
    Expect(1, 83407, '\p{Line_Break=:\AClose_Punctuation\z:}', "");;
    Expect(0, 83408, '\p{Line_Break=:\AClose_Punctuation\z:}', "");;
    Expect(1, 83407, '\p{Line_Break=closepunctuation}', "");
    Expect(0, 83407, '\p{^Line_Break=closepunctuation}', "");
    Expect(0, 83407, '\P{Line_Break=closepunctuation}', "");
    Expect(1, 83407, '\P{^Line_Break=closepunctuation}', "");
    Expect(0, 83408, '\p{Line_Break=closepunctuation}', "");
    Expect(1, 83408, '\p{^Line_Break=closepunctuation}', "");
    Expect(1, 83408, '\P{Line_Break=closepunctuation}', "");
    Expect(0, 83408, '\P{^Line_Break=closepunctuation}', "");
    Expect(1, 83407, '\p{Line_Break=:\Aclosepunctuation\z:}', "");;
    Expect(0, 83408, '\p{Line_Break=:\Aclosepunctuation\z:}', "");;
    Expect(1, 83407, '\p{Line_Break=	-CLOSE_Punctuation}', "");
    Expect(0, 83407, '\p{^Line_Break=	-CLOSE_Punctuation}', "");
    Expect(0, 83407, '\P{Line_Break=	-CLOSE_Punctuation}', "");
    Expect(1, 83407, '\P{^Line_Break=	-CLOSE_Punctuation}', "");
    Expect(0, 83408, '\p{Line_Break=	-CLOSE_Punctuation}', "");
    Expect(1, 83408, '\p{^Line_Break=	-CLOSE_Punctuation}', "");
    Expect(1, 83408, '\P{Line_Break=	-CLOSE_Punctuation}', "");
    Expect(0, 83408, '\P{^Line_Break=	-CLOSE_Punctuation}', "");
    Error('\p{Lb:   _/a/cl}');
    Error('\P{Lb:   _/a/cl}');
    Expect(1, 83407, '\p{Lb=:\ACL\z:}', "");;
    Expect(0, 83408, '\p{Lb=:\ACL\z:}', "");;
    Expect(1, 83407, '\p{Lb=cl}', "");
    Expect(0, 83407, '\p{^Lb=cl}', "");
    Expect(0, 83407, '\P{Lb=cl}', "");
    Expect(1, 83407, '\P{^Lb=cl}', "");
    Expect(0, 83408, '\p{Lb=cl}', "");
    Expect(1, 83408, '\p{^Lb=cl}', "");
    Expect(1, 83408, '\P{Lb=cl}', "");
    Expect(0, 83408, '\P{^Lb=cl}', "");
    Expect(1, 83407, '\p{Lb=:\Acl\z:}', "");;
    Expect(0, 83408, '\p{Lb=:\Acl\z:}', "");;
    Expect(1, 83407, '\p{Lb=	CL}', "");
    Expect(0, 83407, '\p{^Lb=	CL}', "");
    Expect(0, 83407, '\P{Lb=	CL}', "");
    Expect(1, 83407, '\P{^Lb=	CL}', "");
    Expect(0, 83408, '\p{Lb=	CL}', "");
    Expect(1, 83408, '\p{^Lb=	CL}', "");
    Expect(1, 83408, '\P{Lb=	CL}', "");
    Expect(0, 83408, '\P{^Lb=	CL}', "");
    Error('\p{Is_Line_Break=/a/ Close_Punctuation}');
    Error('\P{Is_Line_Break=/a/ Close_Punctuation}');
    Expect(1, 83407, '\p{Is_Line_Break=closepunctuation}', "");
    Expect(0, 83407, '\p{^Is_Line_Break=closepunctuation}', "");
    Expect(0, 83407, '\P{Is_Line_Break=closepunctuation}', "");
    Expect(1, 83407, '\P{^Is_Line_Break=closepunctuation}', "");
    Expect(0, 83408, '\p{Is_Line_Break=closepunctuation}', "");
    Expect(1, 83408, '\p{^Is_Line_Break=closepunctuation}', "");
    Expect(1, 83408, '\P{Is_Line_Break=closepunctuation}', "");
    Expect(0, 83408, '\P{^Is_Line_Break=closepunctuation}', "");
    Expect(1, 83407, '\p{Is_Line_Break=	 Close_PUNCTUATION}', "");
    Expect(0, 83407, '\p{^Is_Line_Break=	 Close_PUNCTUATION}', "");
    Expect(0, 83407, '\P{Is_Line_Break=	 Close_PUNCTUATION}', "");
    Expect(1, 83407, '\P{^Is_Line_Break=	 Close_PUNCTUATION}', "");
    Expect(0, 83408, '\p{Is_Line_Break=	 Close_PUNCTUATION}', "");
    Expect(1, 83408, '\p{^Is_Line_Break=	 Close_PUNCTUATION}', "");
    Expect(1, 83408, '\P{Is_Line_Break=	 Close_PUNCTUATION}', "");
    Expect(0, 83408, '\P{^Is_Line_Break=	 Close_PUNCTUATION}', "");
    Error('\p{Is_Lb=:=cl}');
    Error('\P{Is_Lb=:=cl}');
    Expect(1, 83407, '\p{Is_Lb:	cl}', "");
    Expect(0, 83407, '\p{^Is_Lb:	cl}', "");
    Expect(0, 83407, '\P{Is_Lb:	cl}', "");
    Expect(1, 83407, '\P{^Is_Lb:	cl}', "");
    Expect(0, 83408, '\p{Is_Lb:	cl}', "");
    Expect(1, 83408, '\p{^Is_Lb:	cl}', "");
    Expect(1, 83408, '\P{Is_Lb:	cl}', "");
    Expect(0, 83408, '\P{^Is_Lb:	cl}', "");
    Expect(1, 83407, '\p{Is_Lb= CL}', "");
    Expect(0, 83407, '\p{^Is_Lb= CL}', "");
    Expect(0, 83407, '\P{Is_Lb= CL}', "");
    Expect(1, 83407, '\P{^Is_Lb= CL}', "");
    Expect(0, 83408, '\p{Is_Lb= CL}', "");
    Expect(1, 83408, '\p{^Is_Lb= CL}', "");
    Expect(1, 83408, '\P{Is_Lb= CL}', "");
    Expect(0, 83408, '\P{^Is_Lb= CL}', "");
    Error('\p{Line_Break=:=_combining_Mark}');
    Error('\P{Line_Break=:=_combining_Mark}');
    Expect(1, 917999, '\p{Line_Break=:\ACombining_Mark\z:}', "");;
    Expect(0, 918000, '\p{Line_Break=:\ACombining_Mark\z:}', "");;
    Expect(1, 917999, '\p{Line_Break=combiningmark}', "");
    Expect(0, 917999, '\p{^Line_Break=combiningmark}', "");
    Expect(0, 917999, '\P{Line_Break=combiningmark}', "");
    Expect(1, 917999, '\P{^Line_Break=combiningmark}', "");
    Expect(0, 918000, '\p{Line_Break=combiningmark}', "");
    Expect(1, 918000, '\p{^Line_Break=combiningmark}', "");
    Expect(1, 918000, '\P{Line_Break=combiningmark}', "");
    Expect(0, 918000, '\P{^Line_Break=combiningmark}', "");
    Expect(1, 917999, '\p{Line_Break=:\Acombiningmark\z:}', "");;
    Expect(0, 918000, '\p{Line_Break=:\Acombiningmark\z:}', "");;
    Expect(1, 917999, '\p{Line_Break=	_combining_Mark}', "");
    Expect(0, 917999, '\p{^Line_Break=	_combining_Mark}', "");
    Expect(0, 917999, '\P{Line_Break=	_combining_Mark}', "");
    Expect(1, 917999, '\P{^Line_Break=	_combining_Mark}', "");
    Expect(0, 918000, '\p{Line_Break=	_combining_Mark}', "");
    Expect(1, 918000, '\p{^Line_Break=	_combining_Mark}', "");
    Expect(1, 918000, '\P{Line_Break=	_combining_Mark}', "");
    Expect(0, 918000, '\P{^Line_Break=	_combining_Mark}', "");
    Error('\p{Lb=_/a/CM}');
    Error('\P{Lb=_/a/CM}');
    Expect(1, 917999, '\p{Lb=:\ACM\z:}', "");;
    Expect(0, 918000, '\p{Lb=:\ACM\z:}', "");;
    Expect(1, 917999, '\p{Lb=cm}', "");
    Expect(0, 917999, '\p{^Lb=cm}', "");
    Expect(0, 917999, '\P{Lb=cm}', "");
    Expect(1, 917999, '\P{^Lb=cm}', "");
    Expect(0, 918000, '\p{Lb=cm}', "");
    Expect(1, 918000, '\p{^Lb=cm}', "");
    Expect(1, 918000, '\P{Lb=cm}', "");
    Expect(0, 918000, '\P{^Lb=cm}', "");
    Expect(1, 917999, '\p{Lb=:\Acm\z:}', "");;
    Expect(0, 918000, '\p{Lb=:\Acm\z:}', "");;
    Expect(1, 917999, '\p{Lb=	_CM}', "");
    Expect(0, 917999, '\p{^Lb=	_CM}', "");
    Expect(0, 917999, '\P{Lb=	_CM}', "");
    Expect(1, 917999, '\P{^Lb=	_CM}', "");
    Expect(0, 918000, '\p{Lb=	_CM}', "");
    Expect(1, 918000, '\p{^Lb=	_CM}', "");
    Expect(1, 918000, '\P{Lb=	_CM}', "");
    Expect(0, 918000, '\P{^Lb=	_CM}', "");
    Error('\p{Is_Line_Break=-_Combining_Mark:=}');
    Error('\P{Is_Line_Break=-_Combining_Mark:=}');
    Expect(1, 917999, '\p{Is_Line_Break=combiningmark}', "");
    Expect(0, 917999, '\p{^Is_Line_Break=combiningmark}', "");
    Expect(0, 917999, '\P{Is_Line_Break=combiningmark}', "");
    Expect(1, 917999, '\P{^Is_Line_Break=combiningmark}', "");
    Expect(0, 918000, '\p{Is_Line_Break=combiningmark}', "");
    Expect(1, 918000, '\p{^Is_Line_Break=combiningmark}', "");
    Expect(1, 918000, '\P{Is_Line_Break=combiningmark}', "");
    Expect(0, 918000, '\P{^Is_Line_Break=combiningmark}', "");
    Expect(1, 917999, '\p{Is_Line_Break= Combining_Mark}', "");
    Expect(0, 917999, '\p{^Is_Line_Break= Combining_Mark}', "");
    Expect(0, 917999, '\P{Is_Line_Break= Combining_Mark}', "");
    Expect(1, 917999, '\P{^Is_Line_Break= Combining_Mark}', "");
    Expect(0, 918000, '\p{Is_Line_Break= Combining_Mark}', "");
    Expect(1, 918000, '\p{^Is_Line_Break= Combining_Mark}', "");
    Expect(1, 918000, '\P{Is_Line_Break= Combining_Mark}', "");
    Expect(0, 918000, '\P{^Is_Line_Break= Combining_Mark}', "");
    Error('\p{Is_Lb=/a/- CM}');
    Error('\P{Is_Lb=/a/- CM}');
    Expect(1, 917999, '\p{Is_Lb=cm}', "");
    Expect(0, 917999, '\p{^Is_Lb=cm}', "");
    Expect(0, 917999, '\P{Is_Lb=cm}', "");
    Expect(1, 917999, '\P{^Is_Lb=cm}', "");
    Expect(0, 918000, '\p{Is_Lb=cm}', "");
    Expect(1, 918000, '\p{^Is_Lb=cm}', "");
    Expect(1, 918000, '\P{Is_Lb=cm}', "");
    Expect(0, 918000, '\P{^Is_Lb=cm}', "");
    Expect(1, 917999, '\p{Is_Lb=  CM}', "");
    Expect(0, 917999, '\p{^Is_Lb=  CM}', "");
    Expect(0, 917999, '\P{Is_Lb=  CM}', "");
    Expect(1, 917999, '\P{^Is_Lb=  CM}', "");
    Expect(0, 918000, '\p{Is_Lb=  CM}', "");
    Expect(1, 918000, '\p{^Is_Lb=  CM}', "");
    Expect(1, 918000, '\P{Is_Lb=  CM}', "");
    Expect(0, 918000, '\P{^Is_Lb=  CM}', "");
    Error('\p{Line_Break=- Close_parenthesis:=}');
    Error('\P{Line_Break=- Close_parenthesis:=}');
    Expect(1, 93, '\p{Line_Break=:\AClose_Parenthesis\z:}', "");;
    Expect(0, 94, '\p{Line_Break=:\AClose_Parenthesis\z:}', "");;
    Expect(1, 93, '\p{Line_Break=closeparenthesis}', "");
    Expect(0, 93, '\p{^Line_Break=closeparenthesis}', "");
    Expect(0, 93, '\P{Line_Break=closeparenthesis}', "");
    Expect(1, 93, '\P{^Line_Break=closeparenthesis}', "");
    Expect(0, 94, '\p{Line_Break=closeparenthesis}', "");
    Expect(1, 94, '\p{^Line_Break=closeparenthesis}', "");
    Expect(1, 94, '\P{Line_Break=closeparenthesis}', "");
    Expect(0, 94, '\P{^Line_Break=closeparenthesis}', "");
    Expect(1, 93, '\p{Line_Break=:\Acloseparenthesis\z:}', "");;
    Expect(0, 94, '\p{Line_Break=:\Acloseparenthesis\z:}', "");;
    Expect(1, 93, '\p{Line_Break= CLOSE_PARENTHESIS}', "");
    Expect(0, 93, '\p{^Line_Break= CLOSE_PARENTHESIS}', "");
    Expect(0, 93, '\P{Line_Break= CLOSE_PARENTHESIS}', "");
    Expect(1, 93, '\P{^Line_Break= CLOSE_PARENTHESIS}', "");
    Expect(0, 94, '\p{Line_Break= CLOSE_PARENTHESIS}', "");
    Expect(1, 94, '\p{^Line_Break= CLOSE_PARENTHESIS}', "");
    Expect(1, 94, '\P{Line_Break= CLOSE_PARENTHESIS}', "");
    Expect(0, 94, '\P{^Line_Break= CLOSE_PARENTHESIS}', "");
    Error('\p{Lb=	/a/CP}');
    Error('\P{Lb=	/a/CP}');
    Expect(1, 93, '\p{Lb=:\ACP\z:}', "");;
    Expect(0, 94, '\p{Lb=:\ACP\z:}', "");;
    Expect(1, 93, '\p{Lb=cp}', "");
    Expect(0, 93, '\p{^Lb=cp}', "");
    Expect(0, 93, '\P{Lb=cp}', "");
    Expect(1, 93, '\P{^Lb=cp}', "");
    Expect(0, 94, '\p{Lb=cp}', "");
    Expect(1, 94, '\p{^Lb=cp}', "");
    Expect(1, 94, '\P{Lb=cp}', "");
    Expect(0, 94, '\P{^Lb=cp}', "");
    Expect(1, 93, '\p{Lb=:\Acp\z:}', "");;
    Expect(0, 94, '\p{Lb=:\Acp\z:}', "");;
    Expect(1, 93, '\p{Lb=_	cp}', "");
    Expect(0, 93, '\p{^Lb=_	cp}', "");
    Expect(0, 93, '\P{Lb=_	cp}', "");
    Expect(1, 93, '\P{^Lb=_	cp}', "");
    Expect(0, 94, '\p{Lb=_	cp}', "");
    Expect(1, 94, '\p{^Lb=_	cp}', "");
    Expect(1, 94, '\P{Lb=_	cp}', "");
    Expect(0, 94, '\P{^Lb=_	cp}', "");
    Error('\p{Is_Line_Break=:=_ close_Parenthesis}');
    Error('\P{Is_Line_Break=:=_ close_Parenthesis}');
    Expect(1, 93, '\p{Is_Line_Break=closeparenthesis}', "");
    Expect(0, 93, '\p{^Is_Line_Break=closeparenthesis}', "");
    Expect(0, 93, '\P{Is_Line_Break=closeparenthesis}', "");
    Expect(1, 93, '\P{^Is_Line_Break=closeparenthesis}', "");
    Expect(0, 94, '\p{Is_Line_Break=closeparenthesis}', "");
    Expect(1, 94, '\p{^Is_Line_Break=closeparenthesis}', "");
    Expect(1, 94, '\P{Is_Line_Break=closeparenthesis}', "");
    Expect(0, 94, '\P{^Is_Line_Break=closeparenthesis}', "");
    Expect(1, 93, '\p{Is_Line_Break=-close_parenthesis}', "");
    Expect(0, 93, '\p{^Is_Line_Break=-close_parenthesis}', "");
    Expect(0, 93, '\P{Is_Line_Break=-close_parenthesis}', "");
    Expect(1, 93, '\P{^Is_Line_Break=-close_parenthesis}', "");
    Expect(0, 94, '\p{Is_Line_Break=-close_parenthesis}', "");
    Expect(1, 94, '\p{^Is_Line_Break=-close_parenthesis}', "");
    Expect(1, 94, '\P{Is_Line_Break=-close_parenthesis}', "");
    Expect(0, 94, '\P{^Is_Line_Break=-close_parenthesis}', "");
    Error('\p{Is_Lb=:=CP}');
    Error('\P{Is_Lb=:=CP}');
    Expect(1, 93, '\p{Is_Lb=cp}', "");
    Expect(0, 93, '\p{^Is_Lb=cp}', "");
    Expect(0, 93, '\P{Is_Lb=cp}', "");
    Expect(1, 93, '\P{^Is_Lb=cp}', "");
    Expect(0, 94, '\p{Is_Lb=cp}', "");
    Expect(1, 94, '\p{^Is_Lb=cp}', "");
    Expect(1, 94, '\P{Is_Lb=cp}', "");
    Expect(0, 94, '\P{^Is_Lb=cp}', "");
    Expect(1, 93, '\p{Is_Lb=-CP}', "");
    Expect(0, 93, '\p{^Is_Lb=-CP}', "");
    Expect(0, 93, '\P{Is_Lb=-CP}', "");
    Expect(1, 93, '\P{^Is_Lb=-CP}', "");
    Expect(0, 94, '\p{Is_Lb=-CP}', "");
    Expect(1, 94, '\p{^Is_Lb=-CP}', "");
    Expect(1, 94, '\P{Is_Lb=-CP}', "");
    Expect(0, 94, '\P{^Is_Lb=-CP}', "");
    Error('\p{Line_Break=		CARRIAGE_RETURN:=}');
    Error('\P{Line_Break=		CARRIAGE_RETURN:=}');
    Expect(1, 13, '\p{Line_Break=:\ACarriage_Return\z:}', "");;
    Expect(0, 14, '\p{Line_Break=:\ACarriage_Return\z:}', "");;
    Expect(1, 13, '\p{Line_Break=carriagereturn}', "");
    Expect(0, 13, '\p{^Line_Break=carriagereturn}', "");
    Expect(0, 13, '\P{Line_Break=carriagereturn}', "");
    Expect(1, 13, '\P{^Line_Break=carriagereturn}', "");
    Expect(0, 14, '\p{Line_Break=carriagereturn}', "");
    Expect(1, 14, '\p{^Line_Break=carriagereturn}', "");
    Expect(1, 14, '\P{Line_Break=carriagereturn}', "");
    Expect(0, 14, '\P{^Line_Break=carriagereturn}', "");
    Expect(1, 13, '\p{Line_Break=:\Acarriagereturn\z:}', "");;
    Expect(0, 14, '\p{Line_Break=:\Acarriagereturn\z:}', "");;
    Expect(1, 13, '\p{Line_Break:   		Carriage_Return}', "");
    Expect(0, 13, '\p{^Line_Break:   		Carriage_Return}', "");
    Expect(0, 13, '\P{Line_Break:   		Carriage_Return}', "");
    Expect(1, 13, '\P{^Line_Break:   		Carriage_Return}', "");
    Expect(0, 14, '\p{Line_Break:   		Carriage_Return}', "");
    Expect(1, 14, '\p{^Line_Break:   		Carriage_Return}', "");
    Expect(1, 14, '\P{Line_Break:   		Carriage_Return}', "");
    Expect(0, 14, '\P{^Line_Break:   		Carriage_Return}', "");
    Error('\p{Lb= CR/a/}');
    Error('\P{Lb= CR/a/}');
    Expect(1, 13, '\p{Lb=:\ACR\z:}', "");;
    Expect(0, 14, '\p{Lb=:\ACR\z:}', "");;
    Expect(1, 13, '\p{Lb:   cr}', "");
    Expect(0, 13, '\p{^Lb:   cr}', "");
    Expect(0, 13, '\P{Lb:   cr}', "");
    Expect(1, 13, '\P{^Lb:   cr}', "");
    Expect(0, 14, '\p{Lb:   cr}', "");
    Expect(1, 14, '\p{^Lb:   cr}', "");
    Expect(1, 14, '\P{Lb:   cr}', "");
    Expect(0, 14, '\P{^Lb:   cr}', "");
    Expect(1, 13, '\p{Lb=:\Acr\z:}', "");;
    Expect(0, 14, '\p{Lb=:\Acr\z:}', "");;
    Expect(1, 13, '\p{Lb=  CR}', "");
    Expect(0, 13, '\p{^Lb=  CR}', "");
    Expect(0, 13, '\P{Lb=  CR}', "");
    Expect(1, 13, '\P{^Lb=  CR}', "");
    Expect(0, 14, '\p{Lb=  CR}', "");
    Expect(1, 14, '\p{^Lb=  CR}', "");
    Expect(1, 14, '\P{Lb=  CR}', "");
    Expect(0, 14, '\P{^Lb=  CR}', "");
    Error('\p{Is_Line_Break=_/a/Carriage_RETURN}');
    Error('\P{Is_Line_Break=_/a/Carriage_RETURN}');
    Expect(1, 13, '\p{Is_Line_Break:carriagereturn}', "");
    Expect(0, 13, '\p{^Is_Line_Break:carriagereturn}', "");
    Expect(0, 13, '\P{Is_Line_Break:carriagereturn}', "");
    Expect(1, 13, '\P{^Is_Line_Break:carriagereturn}', "");
    Expect(0, 14, '\p{Is_Line_Break:carriagereturn}', "");
    Expect(1, 14, '\p{^Is_Line_Break:carriagereturn}', "");
    Expect(1, 14, '\P{Is_Line_Break:carriagereturn}', "");
    Expect(0, 14, '\P{^Is_Line_Break:carriagereturn}', "");
    Expect(1, 13, '\p{Is_Line_Break=	 Carriage_RETURN}', "");
    Expect(0, 13, '\p{^Is_Line_Break=	 Carriage_RETURN}', "");
    Expect(0, 13, '\P{Is_Line_Break=	 Carriage_RETURN}', "");
    Expect(1, 13, '\P{^Is_Line_Break=	 Carriage_RETURN}', "");
    Expect(0, 14, '\p{Is_Line_Break=	 Carriage_RETURN}', "");
    Expect(1, 14, '\p{^Is_Line_Break=	 Carriage_RETURN}', "");
    Expect(1, 14, '\P{Is_Line_Break=	 Carriage_RETURN}', "");
    Expect(0, 14, '\P{^Is_Line_Break=	 Carriage_RETURN}', "");
    Error('\p{Is_Lb=:= cr}');
    Error('\P{Is_Lb=:= cr}');
    Expect(1, 13, '\p{Is_Lb:cr}', "");
    Expect(0, 13, '\p{^Is_Lb:cr}', "");
    Expect(0, 13, '\P{Is_Lb:cr}', "");
    Expect(1, 13, '\P{^Is_Lb:cr}', "");
    Expect(0, 14, '\p{Is_Lb:cr}', "");
    Expect(1, 14, '\p{^Is_Lb:cr}', "");
    Expect(1, 14, '\P{Is_Lb:cr}', "");
    Expect(0, 14, '\P{^Is_Lb:cr}', "");
    Expect(1, 13, '\p{Is_Lb=--cr}', "");
    Expect(0, 13, '\p{^Is_Lb=--cr}', "");
    Expect(0, 13, '\P{Is_Lb=--cr}', "");
    Expect(1, 13, '\P{^Is_Lb=--cr}', "");
    Expect(0, 14, '\p{Is_Lb=--cr}', "");
    Expect(1, 14, '\p{^Is_Lb=--cr}', "");
    Expect(1, 14, '\P{Is_Lb=--cr}', "");
    Expect(0, 14, '\P{^Is_Lb=--cr}', "");
    Error('\p{Line_Break=-_E_base/a/}');
    Error('\P{Line_Break=-_E_base/a/}');
    Expect(1, 129784, '\p{Line_Break=:\AE_Base\z:}', "");;
    Expect(0, 129785, '\p{Line_Break=:\AE_Base\z:}', "");;
    Expect(1, 129784, '\p{Line_Break=ebase}', "");
    Expect(0, 129784, '\p{^Line_Break=ebase}', "");
    Expect(0, 129784, '\P{Line_Break=ebase}', "");
    Expect(1, 129784, '\P{^Line_Break=ebase}', "");
    Expect(0, 129785, '\p{Line_Break=ebase}', "");
    Expect(1, 129785, '\p{^Line_Break=ebase}', "");
    Expect(1, 129785, '\P{Line_Break=ebase}', "");
    Expect(0, 129785, '\P{^Line_Break=ebase}', "");
    Expect(1, 129784, '\p{Line_Break=:\Aebase\z:}', "");;
    Expect(0, 129785, '\p{Line_Break=:\Aebase\z:}', "");;
    Expect(1, 129784, '\p{Line_Break=_ E_BASE}', "");
    Expect(0, 129784, '\p{^Line_Break=_ E_BASE}', "");
    Expect(0, 129784, '\P{Line_Break=_ E_BASE}', "");
    Expect(1, 129784, '\P{^Line_Break=_ E_BASE}', "");
    Expect(0, 129785, '\p{Line_Break=_ E_BASE}', "");
    Expect(1, 129785, '\p{^Line_Break=_ E_BASE}', "");
    Expect(1, 129785, '\P{Line_Break=_ E_BASE}', "");
    Expect(0, 129785, '\P{^Line_Break=_ E_BASE}', "");
    Error('\p{Lb=_-EB:=}');
    Error('\P{Lb=_-EB:=}');
    Expect(1, 129784, '\p{Lb=:\AEB\z:}', "");;
    Expect(0, 129785, '\p{Lb=:\AEB\z:}', "");;
    Expect(1, 129784, '\p{Lb=eb}', "");
    Expect(0, 129784, '\p{^Lb=eb}', "");
    Expect(0, 129784, '\P{Lb=eb}', "");
    Expect(1, 129784, '\P{^Lb=eb}', "");
    Expect(0, 129785, '\p{Lb=eb}', "");
    Expect(1, 129785, '\p{^Lb=eb}', "");
    Expect(1, 129785, '\P{Lb=eb}', "");
    Expect(0, 129785, '\P{^Lb=eb}', "");
    Expect(1, 129784, '\p{Lb=:\Aeb\z:}', "");;
    Expect(0, 129785, '\p{Lb=:\Aeb\z:}', "");;
    Expect(1, 129784, '\p{Lb=--EB}', "");
    Expect(0, 129784, '\p{^Lb=--EB}', "");
    Expect(0, 129784, '\P{Lb=--EB}', "");
    Expect(1, 129784, '\P{^Lb=--EB}', "");
    Expect(0, 129785, '\p{Lb=--EB}', "");
    Expect(1, 129785, '\p{^Lb=--EB}', "");
    Expect(1, 129785, '\P{Lb=--EB}', "");
    Expect(0, 129785, '\P{^Lb=--EB}', "");
    Error('\p{Is_Line_Break=:=E_Base}');
    Error('\P{Is_Line_Break=:=E_Base}');
    Expect(1, 129784, '\p{Is_Line_Break=ebase}', "");
    Expect(0, 129784, '\p{^Is_Line_Break=ebase}', "");
    Expect(0, 129784, '\P{Is_Line_Break=ebase}', "");
    Expect(1, 129784, '\P{^Is_Line_Break=ebase}', "");
    Expect(0, 129785, '\p{Is_Line_Break=ebase}', "");
    Expect(1, 129785, '\p{^Is_Line_Break=ebase}', "");
    Expect(1, 129785, '\P{Is_Line_Break=ebase}', "");
    Expect(0, 129785, '\P{^Is_Line_Break=ebase}', "");
    Expect(1, 129784, '\p{Is_Line_Break=		E_BASE}', "");
    Expect(0, 129784, '\p{^Is_Line_Break=		E_BASE}', "");
    Expect(0, 129784, '\P{Is_Line_Break=		E_BASE}', "");
    Expect(1, 129784, '\P{^Is_Line_Break=		E_BASE}', "");
    Expect(0, 129785, '\p{Is_Line_Break=		E_BASE}', "");
    Expect(1, 129785, '\p{^Is_Line_Break=		E_BASE}', "");
    Expect(1, 129785, '\P{Is_Line_Break=		E_BASE}', "");
    Expect(0, 129785, '\P{^Is_Line_Break=		E_BASE}', "");
    Error('\p{Is_Lb=/a/	-EB}');
    Error('\P{Is_Lb=/a/	-EB}');
    Expect(1, 129784, '\p{Is_Lb=eb}', "");
    Expect(0, 129784, '\p{^Is_Lb=eb}', "");
    Expect(0, 129784, '\P{Is_Lb=eb}', "");
    Expect(1, 129784, '\P{^Is_Lb=eb}', "");
    Expect(0, 129785, '\p{Is_Lb=eb}', "");
    Expect(1, 129785, '\p{^Is_Lb=eb}', "");
    Expect(1, 129785, '\P{Is_Lb=eb}', "");
    Expect(0, 129785, '\P{^Is_Lb=eb}', "");
    Expect(1, 129784, '\p{Is_Lb=_	EB}', "");
    Expect(0, 129784, '\p{^Is_Lb=_	EB}', "");
    Expect(0, 129784, '\P{Is_Lb=_	EB}', "");
    Expect(1, 129784, '\P{^Is_Lb=_	EB}', "");
    Expect(0, 129785, '\p{Is_Lb=_	EB}', "");
    Expect(1, 129785, '\p{^Is_Lb=_	EB}', "");
    Expect(1, 129785, '\P{Is_Lb=_	EB}', "");
    Expect(0, 129785, '\P{^Is_Lb=_	EB}', "");
    Error('\p{Line_Break=-E_modifier/a/}');
    Error('\P{Line_Break=-E_modifier/a/}');
    Expect(1, 127999, '\p{Line_Break=:\AE_Modifier\z:}', "");;
    Expect(0, 128000, '\p{Line_Break=:\AE_Modifier\z:}', "");;
    Expect(1, 127999, '\p{Line_Break=emodifier}', "");
    Expect(0, 127999, '\p{^Line_Break=emodifier}', "");
    Expect(0, 127999, '\P{Line_Break=emodifier}', "");
    Expect(1, 127999, '\P{^Line_Break=emodifier}', "");
    Expect(0, 128000, '\p{Line_Break=emodifier}', "");
    Expect(1, 128000, '\p{^Line_Break=emodifier}', "");
    Expect(1, 128000, '\P{Line_Break=emodifier}', "");
    Expect(0, 128000, '\P{^Line_Break=emodifier}', "");
    Expect(1, 127999, '\p{Line_Break=:\Aemodifier\z:}', "");;
    Expect(0, 128000, '\p{Line_Break=:\Aemodifier\z:}', "");;
    Expect(1, 127999, '\p{Line_Break=	_E_Modifier}', "");
    Expect(0, 127999, '\p{^Line_Break=	_E_Modifier}', "");
    Expect(0, 127999, '\P{Line_Break=	_E_Modifier}', "");
    Expect(1, 127999, '\P{^Line_Break=	_E_Modifier}', "");
    Expect(0, 128000, '\p{Line_Break=	_E_Modifier}', "");
    Expect(1, 128000, '\p{^Line_Break=	_E_Modifier}', "");
    Expect(1, 128000, '\P{Line_Break=	_E_Modifier}', "");
    Expect(0, 128000, '\P{^Line_Break=	_E_Modifier}', "");
    Error('\p{Lb:	/a/ EM}');
    Error('\P{Lb:	/a/ EM}');
    Expect(1, 127999, '\p{Lb=:\AEM\z:}', "");;
    Expect(0, 128000, '\p{Lb=:\AEM\z:}', "");;
    Expect(1, 127999, '\p{Lb=em}', "");
    Expect(0, 127999, '\p{^Lb=em}', "");
    Expect(0, 127999, '\P{Lb=em}', "");
    Expect(1, 127999, '\P{^Lb=em}', "");
    Expect(0, 128000, '\p{Lb=em}', "");
    Expect(1, 128000, '\p{^Lb=em}', "");
    Expect(1, 128000, '\P{Lb=em}', "");
    Expect(0, 128000, '\P{^Lb=em}', "");
    Expect(1, 127999, '\p{Lb=:\Aem\z:}', "");;
    Expect(0, 128000, '\p{Lb=:\Aem\z:}', "");;
    Expect(1, 127999, '\p{Lb=-em}', "");
    Expect(0, 127999, '\p{^Lb=-em}', "");
    Expect(0, 127999, '\P{Lb=-em}', "");
    Expect(1, 127999, '\P{^Lb=-em}', "");
    Expect(0, 128000, '\p{Lb=-em}', "");
    Expect(1, 128000, '\p{^Lb=-em}', "");
    Expect(1, 128000, '\P{Lb=-em}', "");
    Expect(0, 128000, '\P{^Lb=-em}', "");
    Error('\p{Is_Line_Break= :=e_Modifier}');
    Error('\P{Is_Line_Break= :=e_Modifier}');
    Expect(1, 127999, '\p{Is_Line_Break=emodifier}', "");
    Expect(0, 127999, '\p{^Is_Line_Break=emodifier}', "");
    Expect(0, 127999, '\P{Is_Line_Break=emodifier}', "");
    Expect(1, 127999, '\P{^Is_Line_Break=emodifier}', "");
    Expect(0, 128000, '\p{Is_Line_Break=emodifier}', "");
    Expect(1, 128000, '\p{^Is_Line_Break=emodifier}', "");
    Expect(1, 128000, '\P{Is_Line_Break=emodifier}', "");
    Expect(0, 128000, '\P{^Is_Line_Break=emodifier}', "");
    Expect(1, 127999, '\p{Is_Line_Break=_ E_Modifier}', "");
    Expect(0, 127999, '\p{^Is_Line_Break=_ E_Modifier}', "");
    Expect(0, 127999, '\P{Is_Line_Break=_ E_Modifier}', "");
    Expect(1, 127999, '\P{^Is_Line_Break=_ E_Modifier}', "");
    Expect(0, 128000, '\p{Is_Line_Break=_ E_Modifier}', "");
    Expect(1, 128000, '\p{^Is_Line_Break=_ E_Modifier}', "");
    Expect(1, 128000, '\P{Is_Line_Break=_ E_Modifier}', "");
    Expect(0, 128000, '\P{^Is_Line_Break=_ E_Modifier}', "");
    Error('\p{Is_Lb=/a/	_EM}');
    Error('\P{Is_Lb=/a/	_EM}');
    Expect(1, 127999, '\p{Is_Lb=em}', "");
    Expect(0, 127999, '\p{^Is_Lb=em}', "");
    Expect(0, 127999, '\P{Is_Lb=em}', "");
    Expect(1, 127999, '\P{^Is_Lb=em}', "");
    Expect(0, 128000, '\p{Is_Lb=em}', "");
    Expect(1, 128000, '\p{^Is_Lb=em}', "");
    Expect(1, 128000, '\P{Is_Lb=em}', "");
    Expect(0, 128000, '\P{^Is_Lb=em}', "");
    Expect(1, 127999, '\p{Is_Lb=_ EM}', "");
    Expect(0, 127999, '\p{^Is_Lb=_ EM}', "");
    Expect(0, 127999, '\P{Is_Lb=_ EM}', "");
    Expect(1, 127999, '\P{^Is_Lb=_ EM}', "");
    Expect(0, 128000, '\p{Is_Lb=_ EM}', "");
    Expect(1, 128000, '\p{^Is_Lb=_ EM}', "");
    Expect(1, 128000, '\P{Is_Lb=_ EM}', "");
    Expect(0, 128000, '\P{^Is_Lb=_ EM}', "");
    Error('\p{Line_Break=-/a/Exclamation}');
    Error('\P{Line_Break=-/a/Exclamation}');
    Expect(1, 72817, '\p{Line_Break=:\AExclamation\z:}', "");;
    Expect(0, 72818, '\p{Line_Break=:\AExclamation\z:}', "");;
    Expect(1, 72817, '\p{Line_Break=exclamation}', "");
    Expect(0, 72817, '\p{^Line_Break=exclamation}', "");
    Expect(0, 72817, '\P{Line_Break=exclamation}', "");
    Expect(1, 72817, '\P{^Line_Break=exclamation}', "");
    Expect(0, 72818, '\p{Line_Break=exclamation}', "");
    Expect(1, 72818, '\p{^Line_Break=exclamation}', "");
    Expect(1, 72818, '\P{Line_Break=exclamation}', "");
    Expect(0, 72818, '\P{^Line_Break=exclamation}', "");
    Expect(1, 72817, '\p{Line_Break=:\Aexclamation\z:}', "");;
    Expect(0, 72818, '\p{Line_Break=:\Aexclamation\z:}', "");;
    Expect(1, 72817, '\p{Line_Break= exclamation}', "");
    Expect(0, 72817, '\p{^Line_Break= exclamation}', "");
    Expect(0, 72817, '\P{Line_Break= exclamation}', "");
    Expect(1, 72817, '\P{^Line_Break= exclamation}', "");
    Expect(0, 72818, '\p{Line_Break= exclamation}', "");
    Expect(1, 72818, '\p{^Line_Break= exclamation}', "");
    Expect(1, 72818, '\P{Line_Break= exclamation}', "");
    Expect(0, 72818, '\P{^Line_Break= exclamation}', "");
    Error('\p{Lb=-/a/EX}');
    Error('\P{Lb=-/a/EX}');
    Expect(1, 72817, '\p{Lb=:\AEX\z:}', "");;
    Expect(0, 72818, '\p{Lb=:\AEX\z:}', "");;
    Expect(1, 72817, '\p{Lb=ex}', "");
    Expect(0, 72817, '\p{^Lb=ex}', "");
    Expect(0, 72817, '\P{Lb=ex}', "");
    Expect(1, 72817, '\P{^Lb=ex}', "");
    Expect(0, 72818, '\p{Lb=ex}', "");
    Expect(1, 72818, '\p{^Lb=ex}', "");
    Expect(1, 72818, '\P{Lb=ex}', "");
    Expect(0, 72818, '\P{^Lb=ex}', "");
    Expect(1, 72817, '\p{Lb=:\Aex\z:}', "");;
    Expect(0, 72818, '\p{Lb=:\Aex\z:}', "");;
    Expect(1, 72817, '\p{Lb=  EX}', "");
    Expect(0, 72817, '\p{^Lb=  EX}', "");
    Expect(0, 72817, '\P{Lb=  EX}', "");
    Expect(1, 72817, '\P{^Lb=  EX}', "");
    Expect(0, 72818, '\p{Lb=  EX}', "");
    Expect(1, 72818, '\p{^Lb=  EX}', "");
    Expect(1, 72818, '\P{Lb=  EX}', "");
    Expect(0, 72818, '\P{^Lb=  EX}', "");
    Error('\p{Is_Line_Break=:=_-EXCLAMATION}');
    Error('\P{Is_Line_Break=:=_-EXCLAMATION}');
    Expect(1, 72817, '\p{Is_Line_Break=exclamation}', "");
    Expect(0, 72817, '\p{^Is_Line_Break=exclamation}', "");
    Expect(0, 72817, '\P{Is_Line_Break=exclamation}', "");
    Expect(1, 72817, '\P{^Is_Line_Break=exclamation}', "");
    Expect(0, 72818, '\p{Is_Line_Break=exclamation}', "");
    Expect(1, 72818, '\p{^Is_Line_Break=exclamation}', "");
    Expect(1, 72818, '\P{Is_Line_Break=exclamation}', "");
    Expect(0, 72818, '\P{^Is_Line_Break=exclamation}', "");
    Expect(1, 72817, '\p{Is_Line_Break=_-EXCLAMATION}', "");
    Expect(0, 72817, '\p{^Is_Line_Break=_-EXCLAMATION}', "");
    Expect(0, 72817, '\P{Is_Line_Break=_-EXCLAMATION}', "");
    Expect(1, 72817, '\P{^Is_Line_Break=_-EXCLAMATION}', "");
    Expect(0, 72818, '\p{Is_Line_Break=_-EXCLAMATION}', "");
    Expect(1, 72818, '\p{^Is_Line_Break=_-EXCLAMATION}', "");
    Expect(1, 72818, '\P{Is_Line_Break=_-EXCLAMATION}', "");
    Expect(0, 72818, '\P{^Is_Line_Break=_-EXCLAMATION}', "");
    Error('\p{Is_Lb=	:=EX}');
    Error('\P{Is_Lb=	:=EX}');
    Expect(1, 72817, '\p{Is_Lb=ex}', "");
    Expect(0, 72817, '\p{^Is_Lb=ex}', "");
    Expect(0, 72817, '\P{Is_Lb=ex}', "");
    Expect(1, 72817, '\P{^Is_Lb=ex}', "");
    Expect(0, 72818, '\p{Is_Lb=ex}', "");
    Expect(1, 72818, '\p{^Is_Lb=ex}', "");
    Expect(1, 72818, '\P{Is_Lb=ex}', "");
    Expect(0, 72818, '\P{^Is_Lb=ex}', "");
    Expect(1, 72817, '\p{Is_Lb=- EX}', "");
    Expect(0, 72817, '\p{^Is_Lb=- EX}', "");
    Expect(0, 72817, '\P{Is_Lb=- EX}', "");
    Expect(1, 72817, '\P{^Is_Lb=- EX}', "");
    Expect(0, 72818, '\p{Is_Lb=- EX}', "");
    Expect(1, 72818, '\p{^Is_Lb=- EX}', "");
    Expect(1, 72818, '\P{Is_Lb=- EX}', "");
    Expect(0, 72818, '\P{^Is_Lb=- EX}', "");
    Error('\p{Line_Break=:=Glue}');
    Error('\P{Line_Break=:=Glue}');
    Expect(1, 94180, '\p{Line_Break=:\AGlue\z:}', "");;
    Expect(0, 94181, '\p{Line_Break=:\AGlue\z:}', "");;
    Expect(1, 94180, '\p{Line_Break=glue}', "");
    Expect(0, 94180, '\p{^Line_Break=glue}', "");
    Expect(0, 94180, '\P{Line_Break=glue}', "");
    Expect(1, 94180, '\P{^Line_Break=glue}', "");
    Expect(0, 94181, '\p{Line_Break=glue}', "");
    Expect(1, 94181, '\p{^Line_Break=glue}', "");
    Expect(1, 94181, '\P{Line_Break=glue}', "");
    Expect(0, 94181, '\P{^Line_Break=glue}', "");
    Expect(1, 94180, '\p{Line_Break=:\Aglue\z:}', "");;
    Expect(0, 94181, '\p{Line_Break=:\Aglue\z:}', "");;
    Expect(1, 94180, '\p{Line_Break:   -glue}', "");
    Expect(0, 94180, '\p{^Line_Break:   -glue}', "");
    Expect(0, 94180, '\P{Line_Break:   -glue}', "");
    Expect(1, 94180, '\P{^Line_Break:   -glue}', "");
    Expect(0, 94181, '\p{Line_Break:   -glue}', "");
    Expect(1, 94181, '\p{^Line_Break:   -glue}', "");
    Expect(1, 94181, '\P{Line_Break:   -glue}', "");
    Expect(0, 94181, '\P{^Line_Break:   -glue}', "");
    Error('\p{Lb=  GL/a/}');
    Error('\P{Lb=  GL/a/}');
    Expect(1, 94180, '\p{Lb=:\AGL\z:}', "");;
    Expect(0, 94181, '\p{Lb=:\AGL\z:}', "");;
    Expect(1, 94180, '\p{Lb=gl}', "");
    Expect(0, 94180, '\p{^Lb=gl}', "");
    Expect(0, 94180, '\P{Lb=gl}', "");
    Expect(1, 94180, '\P{^Lb=gl}', "");
    Expect(0, 94181, '\p{Lb=gl}', "");
    Expect(1, 94181, '\p{^Lb=gl}', "");
    Expect(1, 94181, '\P{Lb=gl}', "");
    Expect(0, 94181, '\P{^Lb=gl}', "");
    Expect(1, 94180, '\p{Lb=:\Agl\z:}', "");;
    Expect(0, 94181, '\p{Lb=:\Agl\z:}', "");;
    Expect(1, 94180, '\p{Lb=GL}', "");
    Expect(0, 94180, '\p{^Lb=GL}', "");
    Expect(0, 94180, '\P{Lb=GL}', "");
    Expect(1, 94180, '\P{^Lb=GL}', "");
    Expect(0, 94181, '\p{Lb=GL}', "");
    Expect(1, 94181, '\p{^Lb=GL}', "");
    Expect(1, 94181, '\P{Lb=GL}', "");
    Expect(0, 94181, '\P{^Lb=GL}', "");
    Error('\p{Is_Line_Break=:=Glue}');
    Error('\P{Is_Line_Break=:=Glue}');
    Expect(1, 94180, '\p{Is_Line_Break=glue}', "");
    Expect(0, 94180, '\p{^Is_Line_Break=glue}', "");
    Expect(0, 94180, '\P{Is_Line_Break=glue}', "");
    Expect(1, 94180, '\P{^Is_Line_Break=glue}', "");
    Expect(0, 94181, '\p{Is_Line_Break=glue}', "");
    Expect(1, 94181, '\p{^Is_Line_Break=glue}', "");
    Expect(1, 94181, '\P{Is_Line_Break=glue}', "");
    Expect(0, 94181, '\P{^Is_Line_Break=glue}', "");
    Expect(1, 94180, '\p{Is_Line_Break=__Glue}', "");
    Expect(0, 94180, '\p{^Is_Line_Break=__Glue}', "");
    Expect(0, 94180, '\P{Is_Line_Break=__Glue}', "");
    Expect(1, 94180, '\P{^Is_Line_Break=__Glue}', "");
    Expect(0, 94181, '\p{Is_Line_Break=__Glue}', "");
    Expect(1, 94181, '\p{^Is_Line_Break=__Glue}', "");
    Expect(1, 94181, '\P{Is_Line_Break=__Glue}', "");
    Expect(0, 94181, '\P{^Is_Line_Break=__Glue}', "");
    Error('\p{Is_Lb=:=		GL}');
    Error('\P{Is_Lb=:=		GL}');
    Expect(1, 94180, '\p{Is_Lb=gl}', "");
    Expect(0, 94180, '\p{^Is_Lb=gl}', "");
    Expect(0, 94180, '\P{Is_Lb=gl}', "");
    Expect(1, 94180, '\P{^Is_Lb=gl}', "");
    Expect(0, 94181, '\p{Is_Lb=gl}', "");
    Expect(1, 94181, '\p{^Is_Lb=gl}', "");
    Expect(1, 94181, '\P{Is_Lb=gl}', "");
    Expect(0, 94181, '\P{^Is_Lb=gl}', "");
    Expect(1, 94180, '\p{Is_Lb=	 GL}', "");
    Expect(0, 94180, '\p{^Is_Lb=	 GL}', "");
    Expect(0, 94180, '\P{Is_Lb=	 GL}', "");
    Expect(1, 94180, '\P{^Is_Lb=	 GL}', "");
    Expect(0, 94181, '\p{Is_Lb=	 GL}', "");
    Expect(1, 94181, '\p{^Is_Lb=	 GL}', "");
    Expect(1, 94181, '\P{Is_Lb=	 GL}', "");
    Expect(0, 94181, '\P{^Is_Lb=	 GL}', "");
    Error('\p{Line_Break=	 H2:=}');
    Error('\P{Line_Break=	 H2:=}');
    Expect(1, 55176, '\p{Line_Break=:\AH2\z:}', "");;
    Expect(0, 55177, '\p{Line_Break=:\AH2\z:}', "");;
    Expect(1, 55176, '\p{Line_Break=h2}', "");
    Expect(0, 55176, '\p{^Line_Break=h2}', "");
    Expect(0, 55176, '\P{Line_Break=h2}', "");
    Expect(1, 55176, '\P{^Line_Break=h2}', "");
    Expect(0, 55177, '\p{Line_Break=h2}', "");
    Expect(1, 55177, '\p{^Line_Break=h2}', "");
    Expect(1, 55177, '\P{Line_Break=h2}', "");
    Expect(0, 55177, '\P{^Line_Break=h2}', "");
    Expect(1, 55176, '\p{Line_Break=:\Ah2\z:}', "");;
    Expect(0, 55177, '\p{Line_Break=:\Ah2\z:}', "");;
    Expect(1, 55176, '\p{Line_Break=		H2}', "");
    Expect(0, 55176, '\p{^Line_Break=		H2}', "");
    Expect(0, 55176, '\P{Line_Break=		H2}', "");
    Expect(1, 55176, '\P{^Line_Break=		H2}', "");
    Expect(0, 55177, '\p{Line_Break=		H2}', "");
    Expect(1, 55177, '\p{^Line_Break=		H2}', "");
    Expect(1, 55177, '\P{Line_Break=		H2}', "");
    Expect(0, 55177, '\P{^Line_Break=		H2}', "");
    Error('\p{Lb=:= -H2}');
    Error('\P{Lb=:= -H2}');
    Expect(1, 55176, '\p{Lb=:\AH2\z:}', "");;
    Expect(0, 55177, '\p{Lb=:\AH2\z:}', "");;
    Expect(1, 55176, '\p{Lb=h2}', "");
    Expect(0, 55176, '\p{^Lb=h2}', "");
    Expect(0, 55176, '\P{Lb=h2}', "");
    Expect(1, 55176, '\P{^Lb=h2}', "");
    Expect(0, 55177, '\p{Lb=h2}', "");
    Expect(1, 55177, '\p{^Lb=h2}', "");
    Expect(1, 55177, '\P{Lb=h2}', "");
    Expect(0, 55177, '\P{^Lb=h2}', "");
    Expect(1, 55176, '\p{Lb=:\Ah2\z:}', "");;
    Expect(0, 55177, '\p{Lb=:\Ah2\z:}', "");;
    Expect(1, 55176, '\p{Lb=__H2}', "");
    Expect(0, 55176, '\p{^Lb=__H2}', "");
    Expect(0, 55176, '\P{Lb=__H2}', "");
    Expect(1, 55176, '\P{^Lb=__H2}', "");
    Expect(0, 55177, '\p{Lb=__H2}', "");
    Expect(1, 55177, '\p{^Lb=__H2}', "");
    Expect(1, 55177, '\P{Lb=__H2}', "");
    Expect(0, 55177, '\P{^Lb=__H2}', "");
    Error('\p{Is_Line_Break=:= _H2}');
    Error('\P{Is_Line_Break=:= _H2}');
    Expect(1, 55176, '\p{Is_Line_Break=h2}', "");
    Expect(0, 55176, '\p{^Is_Line_Break=h2}', "");
    Expect(0, 55176, '\P{Is_Line_Break=h2}', "");
    Expect(1, 55176, '\P{^Is_Line_Break=h2}', "");
    Expect(0, 55177, '\p{Is_Line_Break=h2}', "");
    Expect(1, 55177, '\p{^Is_Line_Break=h2}', "");
    Expect(1, 55177, '\P{Is_Line_Break=h2}', "");
    Expect(0, 55177, '\P{^Is_Line_Break=h2}', "");
    Expect(1, 55176, '\p{Is_Line_Break=	 H2}', "");
    Expect(0, 55176, '\p{^Is_Line_Break=	 H2}', "");
    Expect(0, 55176, '\P{Is_Line_Break=	 H2}', "");
    Expect(1, 55176, '\P{^Is_Line_Break=	 H2}', "");
    Expect(0, 55177, '\p{Is_Line_Break=	 H2}', "");
    Expect(1, 55177, '\p{^Is_Line_Break=	 H2}', "");
    Expect(1, 55177, '\P{Is_Line_Break=	 H2}', "");
    Expect(0, 55177, '\P{^Is_Line_Break=	 H2}', "");
    Error('\p{Is_Lb: 	H2:=}');
    Error('\P{Is_Lb: 	H2:=}');
    Expect(1, 55176, '\p{Is_Lb=h2}', "");
    Expect(0, 55176, '\p{^Is_Lb=h2}', "");
    Expect(0, 55176, '\P{Is_Lb=h2}', "");
    Expect(1, 55176, '\P{^Is_Lb=h2}', "");
    Expect(0, 55177, '\p{Is_Lb=h2}', "");
    Expect(1, 55177, '\p{^Is_Lb=h2}', "");
    Expect(1, 55177, '\P{Is_Lb=h2}', "");
    Expect(0, 55177, '\P{^Is_Lb=h2}', "");
    Expect(1, 55176, '\p{Is_Lb=H2}', "");
    Expect(0, 55176, '\p{^Is_Lb=H2}', "");
    Expect(0, 55176, '\P{Is_Lb=H2}', "");
    Expect(1, 55176, '\P{^Is_Lb=H2}', "");
    Expect(0, 55177, '\p{Is_Lb=H2}', "");
    Expect(1, 55177, '\p{^Is_Lb=H2}', "");
    Expect(1, 55177, '\P{Is_Lb=H2}', "");
    Expect(0, 55177, '\P{^Is_Lb=H2}', "");
    Error('\p{Line_Break=:= h3}');
    Error('\P{Line_Break=:= h3}');
    Expect(1, 55203, '\p{Line_Break=:\AH3\z:}', "");;
    Expect(0, 55204, '\p{Line_Break=:\AH3\z:}', "");;
    Expect(1, 55203, '\p{Line_Break=h3}', "");
    Expect(0, 55203, '\p{^Line_Break=h3}', "");
    Expect(0, 55203, '\P{Line_Break=h3}', "");
    Expect(1, 55203, '\P{^Line_Break=h3}', "");
    Expect(0, 55204, '\p{Line_Break=h3}', "");
    Expect(1, 55204, '\p{^Line_Break=h3}', "");
    Expect(1, 55204, '\P{Line_Break=h3}', "");
    Expect(0, 55204, '\P{^Line_Break=h3}', "");
    Expect(1, 55203, '\p{Line_Break=:\Ah3\z:}', "");;
    Expect(0, 55204, '\p{Line_Break=:\Ah3\z:}', "");;
    Expect(1, 55203, '\p{Line_Break:   _ H3}', "");
    Expect(0, 55203, '\p{^Line_Break:   _ H3}', "");
    Expect(0, 55203, '\P{Line_Break:   _ H3}', "");
    Expect(1, 55203, '\P{^Line_Break:   _ H3}', "");
    Expect(0, 55204, '\p{Line_Break:   _ H3}', "");
    Expect(1, 55204, '\p{^Line_Break:   _ H3}', "");
    Expect(1, 55204, '\P{Line_Break:   _ H3}', "");
    Expect(0, 55204, '\P{^Line_Break:   _ H3}', "");
    Error('\p{Lb=_ H3/a/}');
    Error('\P{Lb=_ H3/a/}');
    Expect(1, 55203, '\p{Lb=:\AH3\z:}', "");;
    Expect(0, 55204, '\p{Lb=:\AH3\z:}', "");;
    Expect(1, 55203, '\p{Lb=h3}', "");
    Expect(0, 55203, '\p{^Lb=h3}', "");
    Expect(0, 55203, '\P{Lb=h3}', "");
    Expect(1, 55203, '\P{^Lb=h3}', "");
    Expect(0, 55204, '\p{Lb=h3}', "");
    Expect(1, 55204, '\p{^Lb=h3}', "");
    Expect(1, 55204, '\P{Lb=h3}', "");
    Expect(0, 55204, '\P{^Lb=h3}', "");
    Expect(1, 55203, '\p{Lb=:\Ah3\z:}', "");;
    Expect(0, 55204, '\p{Lb=:\Ah3\z:}', "");;
    Expect(1, 55203, '\p{Lb=	 H3}', "");
    Expect(0, 55203, '\p{^Lb=	 H3}', "");
    Expect(0, 55203, '\P{Lb=	 H3}', "");
    Expect(1, 55203, '\P{^Lb=	 H3}', "");
    Expect(0, 55204, '\p{Lb=	 H3}', "");
    Expect(1, 55204, '\p{^Lb=	 H3}', "");
    Expect(1, 55204, '\P{Lb=	 H3}', "");
    Expect(0, 55204, '\P{^Lb=	 H3}', "");
    Error('\p{Is_Line_Break=/a/- H3}');
    Error('\P{Is_Line_Break=/a/- H3}');
    Expect(1, 55203, '\p{Is_Line_Break=h3}', "");
    Expect(0, 55203, '\p{^Is_Line_Break=h3}', "");
    Expect(0, 55203, '\P{Is_Line_Break=h3}', "");
    Expect(1, 55203, '\P{^Is_Line_Break=h3}', "");
    Expect(0, 55204, '\p{Is_Line_Break=h3}', "");
    Expect(1, 55204, '\p{^Is_Line_Break=h3}', "");
    Expect(1, 55204, '\P{Is_Line_Break=h3}', "");
    Expect(0, 55204, '\P{^Is_Line_Break=h3}', "");
    Expect(1, 55203, '\p{Is_Line_Break=_ h3}', "");
    Expect(0, 55203, '\p{^Is_Line_Break=_ h3}', "");
    Expect(0, 55203, '\P{Is_Line_Break=_ h3}', "");
    Expect(1, 55203, '\P{^Is_Line_Break=_ h3}', "");
    Expect(0, 55204, '\p{Is_Line_Break=_ h3}', "");
    Expect(1, 55204, '\p{^Is_Line_Break=_ h3}', "");
    Expect(1, 55204, '\P{Is_Line_Break=_ h3}', "");
    Expect(0, 55204, '\P{^Is_Line_Break=_ h3}', "");
    Error('\p{Is_Lb=	H3:=}');
    Error('\P{Is_Lb=	H3:=}');
    Expect(1, 55203, '\p{Is_Lb:   h3}', "");
    Expect(0, 55203, '\p{^Is_Lb:   h3}', "");
    Expect(0, 55203, '\P{Is_Lb:   h3}', "");
    Expect(1, 55203, '\P{^Is_Lb:   h3}', "");
    Expect(0, 55204, '\p{Is_Lb:   h3}', "");
    Expect(1, 55204, '\p{^Is_Lb:   h3}', "");
    Expect(1, 55204, '\P{Is_Lb:   h3}', "");
    Expect(0, 55204, '\P{^Is_Lb:   h3}', "");
    Expect(1, 55203, '\p{Is_Lb=		H3}', "");
    Expect(0, 55203, '\p{^Is_Lb=		H3}', "");
    Expect(0, 55203, '\P{Is_Lb=		H3}', "");
    Expect(1, 55203, '\P{^Is_Lb=		H3}', "");
    Expect(0, 55204, '\p{Is_Lb=		H3}', "");
    Expect(1, 55204, '\p{^Is_Lb=		H3}', "");
    Expect(1, 55204, '\P{Is_Lb=		H3}', "");
    Expect(0, 55204, '\P{^Is_Lb=		H3}', "");
    Error('\p{Line_Break=__Hebrew_letter/a/}');
    Error('\P{Line_Break=__Hebrew_letter/a/}');
    Expect(1, 64335, '\p{Line_Break=:\AHebrew_Letter\z:}', "");;
    Expect(0, 64336, '\p{Line_Break=:\AHebrew_Letter\z:}', "");;
    Expect(1, 64335, '\p{Line_Break=hebrewletter}', "");
    Expect(0, 64335, '\p{^Line_Break=hebrewletter}', "");
    Expect(0, 64335, '\P{Line_Break=hebrewletter}', "");
    Expect(1, 64335, '\P{^Line_Break=hebrewletter}', "");
    Expect(0, 64336, '\p{Line_Break=hebrewletter}', "");
    Expect(1, 64336, '\p{^Line_Break=hebrewletter}', "");
    Expect(1, 64336, '\P{Line_Break=hebrewletter}', "");
    Expect(0, 64336, '\P{^Line_Break=hebrewletter}', "");
    Expect(1, 64335, '\p{Line_Break=:\Ahebrewletter\z:}', "");;
    Expect(0, 64336, '\p{Line_Break=:\Ahebrewletter\z:}', "");;
    Expect(1, 64335, '\p{Line_Break=_	hebrew_LETTER}', "");
    Expect(0, 64335, '\p{^Line_Break=_	hebrew_LETTER}', "");
    Expect(0, 64335, '\P{Line_Break=_	hebrew_LETTER}', "");
    Expect(1, 64335, '\P{^Line_Break=_	hebrew_LETTER}', "");
    Expect(0, 64336, '\p{Line_Break=_	hebrew_LETTER}', "");
    Expect(1, 64336, '\p{^Line_Break=_	hebrew_LETTER}', "");
    Expect(1, 64336, '\P{Line_Break=_	hebrew_LETTER}', "");
    Expect(0, 64336, '\P{^Line_Break=_	hebrew_LETTER}', "");
    Error('\p{Lb= :=hl}');
    Error('\P{Lb= :=hl}');
    Expect(1, 64335, '\p{Lb=:\AHL\z:}', "");;
    Expect(0, 64336, '\p{Lb=:\AHL\z:}', "");;
    Expect(1, 64335, '\p{Lb=hl}', "");
    Expect(0, 64335, '\p{^Lb=hl}', "");
    Expect(0, 64335, '\P{Lb=hl}', "");
    Expect(1, 64335, '\P{^Lb=hl}', "");
    Expect(0, 64336, '\p{Lb=hl}', "");
    Expect(1, 64336, '\p{^Lb=hl}', "");
    Expect(1, 64336, '\P{Lb=hl}', "");
    Expect(0, 64336, '\P{^Lb=hl}', "");
    Expect(1, 64335, '\p{Lb=:\Ahl\z:}', "");;
    Expect(0, 64336, '\p{Lb=:\Ahl\z:}', "");;
    Expect(1, 64335, '\p{Lb=_HL}', "");
    Expect(0, 64335, '\p{^Lb=_HL}', "");
    Expect(0, 64335, '\P{Lb=_HL}', "");
    Expect(1, 64335, '\P{^Lb=_HL}', "");
    Expect(0, 64336, '\p{Lb=_HL}', "");
    Expect(1, 64336, '\p{^Lb=_HL}', "");
    Expect(1, 64336, '\P{Lb=_HL}', "");
    Expect(0, 64336, '\P{^Lb=_HL}', "");
    Error('\p{Is_Line_Break= Hebrew_Letter:=}');
    Error('\P{Is_Line_Break= Hebrew_Letter:=}');
    Expect(1, 64335, '\p{Is_Line_Break=hebrewletter}', "");
    Expect(0, 64335, '\p{^Is_Line_Break=hebrewletter}', "");
    Expect(0, 64335, '\P{Is_Line_Break=hebrewletter}', "");
    Expect(1, 64335, '\P{^Is_Line_Break=hebrewletter}', "");
    Expect(0, 64336, '\p{Is_Line_Break=hebrewletter}', "");
    Expect(1, 64336, '\p{^Is_Line_Break=hebrewletter}', "");
    Expect(1, 64336, '\P{Is_Line_Break=hebrewletter}', "");
    Expect(0, 64336, '\P{^Is_Line_Break=hebrewletter}', "");
    Expect(1, 64335, '\p{Is_Line_Break: -	Hebrew_Letter}', "");
    Expect(0, 64335, '\p{^Is_Line_Break: -	Hebrew_Letter}', "");
    Expect(0, 64335, '\P{Is_Line_Break: -	Hebrew_Letter}', "");
    Expect(1, 64335, '\P{^Is_Line_Break: -	Hebrew_Letter}', "");
    Expect(0, 64336, '\p{Is_Line_Break: -	Hebrew_Letter}', "");
    Expect(1, 64336, '\p{^Is_Line_Break: -	Hebrew_Letter}', "");
    Expect(1, 64336, '\P{Is_Line_Break: -	Hebrew_Letter}', "");
    Expect(0, 64336, '\P{^Is_Line_Break: -	Hebrew_Letter}', "");
    Error('\p{Is_Lb=	/a/hl}');
    Error('\P{Is_Lb=	/a/hl}');
    Expect(1, 64335, '\p{Is_Lb=hl}', "");
    Expect(0, 64335, '\p{^Is_Lb=hl}', "");
    Expect(0, 64335, '\P{Is_Lb=hl}', "");
    Expect(1, 64335, '\P{^Is_Lb=hl}', "");
    Expect(0, 64336, '\p{Is_Lb=hl}', "");
    Expect(1, 64336, '\p{^Is_Lb=hl}', "");
    Expect(1, 64336, '\P{Is_Lb=hl}', "");
    Expect(0, 64336, '\P{^Is_Lb=hl}', "");
    Expect(1, 64335, '\p{Is_Lb=__hl}', "");
    Expect(0, 64335, '\p{^Is_Lb=__hl}', "");
    Expect(0, 64335, '\P{Is_Lb=__hl}', "");
    Expect(1, 64335, '\P{^Is_Lb=__hl}', "");
    Expect(0, 64336, '\p{Is_Lb=__hl}', "");
    Expect(1, 64336, '\p{^Is_Lb=__hl}', "");
    Expect(1, 64336, '\P{Is_Lb=__hl}', "");
    Expect(0, 64336, '\P{^Is_Lb=__hl}', "");
    Error('\p{Line_Break= 	HYPHEN:=}');
    Error('\P{Line_Break= 	HYPHEN:=}');
    Expect(1, 45, '\p{Line_Break=:\AHyphen\z:}', "");;
    Expect(0, 46, '\p{Line_Break=:\AHyphen\z:}', "");;
    Expect(1, 45, '\p{Line_Break=hyphen}', "");
    Expect(0, 45, '\p{^Line_Break=hyphen}', "");
    Expect(0, 45, '\P{Line_Break=hyphen}', "");
    Expect(1, 45, '\P{^Line_Break=hyphen}', "");
    Expect(0, 46, '\p{Line_Break=hyphen}', "");
    Expect(1, 46, '\p{^Line_Break=hyphen}', "");
    Expect(1, 46, '\P{Line_Break=hyphen}', "");
    Expect(0, 46, '\P{^Line_Break=hyphen}', "");
    Expect(1, 45, '\p{Line_Break=:\Ahyphen\z:}', "");;
    Expect(0, 46, '\p{Line_Break=:\Ahyphen\z:}', "");;
    Expect(1, 45, '\p{Line_Break=-	HYPHEN}', "");
    Expect(0, 45, '\p{^Line_Break=-	HYPHEN}', "");
    Expect(0, 45, '\P{Line_Break=-	HYPHEN}', "");
    Expect(1, 45, '\P{^Line_Break=-	HYPHEN}', "");
    Expect(0, 46, '\p{Line_Break=-	HYPHEN}', "");
    Expect(1, 46, '\p{^Line_Break=-	HYPHEN}', "");
    Expect(1, 46, '\P{Line_Break=-	HYPHEN}', "");
    Expect(0, 46, '\P{^Line_Break=-	HYPHEN}', "");
    Error('\p{Lb=/a/hy}');
    Error('\P{Lb=/a/hy}');
    Expect(1, 45, '\p{Lb=:\AHY\z:}', "");;
    Expect(0, 46, '\p{Lb=:\AHY\z:}', "");;
    Expect(1, 45, '\p{Lb=hy}', "");
    Expect(0, 45, '\p{^Lb=hy}', "");
    Expect(0, 45, '\P{Lb=hy}', "");
    Expect(1, 45, '\P{^Lb=hy}', "");
    Expect(0, 46, '\p{Lb=hy}', "");
    Expect(1, 46, '\p{^Lb=hy}', "");
    Expect(1, 46, '\P{Lb=hy}', "");
    Expect(0, 46, '\P{^Lb=hy}', "");
    Expect(1, 45, '\p{Lb=:\Ahy\z:}', "");;
    Expect(0, 46, '\p{Lb=:\Ahy\z:}', "");;
    Expect(1, 45, '\p{Lb:  HY}', "");
    Expect(0, 45, '\p{^Lb:  HY}', "");
    Expect(0, 45, '\P{Lb:  HY}', "");
    Expect(1, 45, '\P{^Lb:  HY}', "");
    Expect(0, 46, '\p{Lb:  HY}', "");
    Expect(1, 46, '\p{^Lb:  HY}', "");
    Expect(1, 46, '\P{Lb:  HY}', "");
    Expect(0, 46, '\P{^Lb:  HY}', "");
    Error('\p{Is_Line_Break=_/a/hyphen}');
    Error('\P{Is_Line_Break=_/a/hyphen}');
    Expect(1, 45, '\p{Is_Line_Break=hyphen}', "");
    Expect(0, 45, '\p{^Is_Line_Break=hyphen}', "");
    Expect(0, 45, '\P{Is_Line_Break=hyphen}', "");
    Expect(1, 45, '\P{^Is_Line_Break=hyphen}', "");
    Expect(0, 46, '\p{Is_Line_Break=hyphen}', "");
    Expect(1, 46, '\p{^Is_Line_Break=hyphen}', "");
    Expect(1, 46, '\P{Is_Line_Break=hyphen}', "");
    Expect(0, 46, '\P{^Is_Line_Break=hyphen}', "");
    Expect(1, 45, '\p{Is_Line_Break:	--Hyphen}', "");
    Expect(0, 45, '\p{^Is_Line_Break:	--Hyphen}', "");
    Expect(0, 45, '\P{Is_Line_Break:	--Hyphen}', "");
    Expect(1, 45, '\P{^Is_Line_Break:	--Hyphen}', "");
    Expect(0, 46, '\p{Is_Line_Break:	--Hyphen}', "");
    Expect(1, 46, '\p{^Is_Line_Break:	--Hyphen}', "");
    Expect(1, 46, '\P{Is_Line_Break:	--Hyphen}', "");
    Expect(0, 46, '\P{^Is_Line_Break:	--Hyphen}', "");
    Error('\p{Is_Lb=/a/hy}');
    Error('\P{Is_Lb=/a/hy}');
    Expect(1, 45, '\p{Is_Lb=hy}', "");
    Expect(0, 45, '\p{^Is_Lb=hy}', "");
    Expect(0, 45, '\P{Is_Lb=hy}', "");
    Expect(1, 45, '\P{^Is_Lb=hy}', "");
    Expect(0, 46, '\p{Is_Lb=hy}', "");
    Expect(1, 46, '\p{^Is_Lb=hy}', "");
    Expect(1, 46, '\P{Is_Lb=hy}', "");
    Expect(0, 46, '\P{^Is_Lb=hy}', "");
    Expect(1, 45, '\p{Is_Lb:   -_hy}', "");
    Expect(0, 45, '\p{^Is_Lb:   -_hy}', "");
    Expect(0, 45, '\P{Is_Lb:   -_hy}', "");
    Expect(1, 45, '\P{^Is_Lb:   -_hy}', "");
    Expect(0, 46, '\p{Is_Lb:   -_hy}', "");
    Expect(1, 46, '\p{^Is_Lb:   -_hy}', "");
    Expect(1, 46, '\P{Is_Lb:   -_hy}', "");
    Expect(0, 46, '\P{^Is_Lb:   -_hy}', "");
    Error('\p{Line_Break=-ideographic:=}');
    Error('\P{Line_Break=-ideographic:=}');
    Expect(1, 262141, '\p{Line_Break=:\AIdeographic\z:}', "");;
    Expect(0, 262144, '\p{Line_Break=:\AIdeographic\z:}', "");;
    Expect(1, 262141, '\p{Line_Break=ideographic}', "");
    Expect(0, 262141, '\p{^Line_Break=ideographic}', "");
    Expect(0, 262141, '\P{Line_Break=ideographic}', "");
    Expect(1, 262141, '\P{^Line_Break=ideographic}', "");
    Expect(0, 262144, '\p{Line_Break=ideographic}', "");
    Expect(1, 262144, '\p{^Line_Break=ideographic}', "");
    Expect(1, 262144, '\P{Line_Break=ideographic}', "");
    Expect(0, 262144, '\P{^Line_Break=ideographic}', "");
    Expect(1, 262141, '\p{Line_Break=:\Aideographic\z:}', "");;
    Expect(0, 262144, '\p{Line_Break=:\Aideographic\z:}', "");;
    Expect(1, 262141, '\p{Line_Break= -Ideographic}', "");
    Expect(0, 262141, '\p{^Line_Break= -Ideographic}', "");
    Expect(0, 262141, '\P{Line_Break= -Ideographic}', "");
    Expect(1, 262141, '\P{^Line_Break= -Ideographic}', "");
    Expect(0, 262144, '\p{Line_Break= -Ideographic}', "");
    Expect(1, 262144, '\p{^Line_Break= -Ideographic}', "");
    Expect(1, 262144, '\P{Line_Break= -Ideographic}', "");
    Expect(0, 262144, '\P{^Line_Break= -Ideographic}', "");
    Error('\p{Lb=-/a/ID}');
    Error('\P{Lb=-/a/ID}');
    Expect(1, 262141, '\p{Lb=:\AID\z:}', "");;
    Expect(0, 262144, '\p{Lb=:\AID\z:}', "");;
    Expect(1, 262141, '\p{Lb=id}', "");
    Expect(0, 262141, '\p{^Lb=id}', "");
    Expect(0, 262141, '\P{Lb=id}', "");
    Expect(1, 262141, '\P{^Lb=id}', "");
    Expect(0, 262144, '\p{Lb=id}', "");
    Expect(1, 262144, '\p{^Lb=id}', "");
    Expect(1, 262144, '\P{Lb=id}', "");
    Expect(0, 262144, '\P{^Lb=id}', "");
    Expect(1, 262141, '\p{Lb=:\Aid\z:}', "");;
    Expect(0, 262144, '\p{Lb=:\Aid\z:}', "");;
    Expect(1, 262141, '\p{Lb=_ID}', "");
    Expect(0, 262141, '\p{^Lb=_ID}', "");
    Expect(0, 262141, '\P{Lb=_ID}', "");
    Expect(1, 262141, '\P{^Lb=_ID}', "");
    Expect(0, 262144, '\p{Lb=_ID}', "");
    Expect(1, 262144, '\p{^Lb=_ID}', "");
    Expect(1, 262144, '\P{Lb=_ID}', "");
    Expect(0, 262144, '\P{^Lb=_ID}', "");
    Error('\p{Is_Line_Break=:=__IDEOGRAPHIC}');
    Error('\P{Is_Line_Break=:=__IDEOGRAPHIC}');
    Expect(1, 262141, '\p{Is_Line_Break=ideographic}', "");
    Expect(0, 262141, '\p{^Is_Line_Break=ideographic}', "");
    Expect(0, 262141, '\P{Is_Line_Break=ideographic}', "");
    Expect(1, 262141, '\P{^Is_Line_Break=ideographic}', "");
    Expect(0, 262144, '\p{Is_Line_Break=ideographic}', "");
    Expect(1, 262144, '\p{^Is_Line_Break=ideographic}', "");
    Expect(1, 262144, '\P{Is_Line_Break=ideographic}', "");
    Expect(0, 262144, '\P{^Is_Line_Break=ideographic}', "");
    Expect(1, 262141, '\p{Is_Line_Break=_Ideographic}', "");
    Expect(0, 262141, '\p{^Is_Line_Break=_Ideographic}', "");
    Expect(0, 262141, '\P{Is_Line_Break=_Ideographic}', "");
    Expect(1, 262141, '\P{^Is_Line_Break=_Ideographic}', "");
    Expect(0, 262144, '\p{Is_Line_Break=_Ideographic}', "");
    Expect(1, 262144, '\p{^Is_Line_Break=_Ideographic}', "");
    Expect(1, 262144, '\P{Is_Line_Break=_Ideographic}', "");
    Expect(0, 262144, '\P{^Is_Line_Break=_Ideographic}', "");
    Error('\p{Is_Lb=:=_ID}');
    Error('\P{Is_Lb=:=_ID}');
    Expect(1, 262141, '\p{Is_Lb=id}', "");
    Expect(0, 262141, '\p{^Is_Lb=id}', "");
    Expect(0, 262141, '\P{Is_Lb=id}', "");
    Expect(1, 262141, '\P{^Is_Lb=id}', "");
    Expect(0, 262144, '\p{Is_Lb=id}', "");
    Expect(1, 262144, '\p{^Is_Lb=id}', "");
    Expect(1, 262144, '\P{Is_Lb=id}', "");
    Expect(0, 262144, '\P{^Is_Lb=id}', "");
    Expect(1, 262141, '\p{Is_Lb= ID}', "");
    Expect(0, 262141, '\p{^Is_Lb= ID}', "");
    Expect(0, 262141, '\P{Is_Lb= ID}', "");
    Expect(1, 262141, '\P{^Is_Lb= ID}', "");
    Expect(0, 262144, '\p{Is_Lb= ID}', "");
    Expect(1, 262144, '\p{^Is_Lb= ID}', "");
    Expect(1, 262144, '\P{Is_Lb= ID}', "");
    Expect(0, 262144, '\P{^Is_Lb= ID}', "");
    Error('\p{Line_Break=_/a/Inseparable}');
    Error('\P{Line_Break=_/a/Inseparable}');
    Expect(1, 68342, '\p{Line_Break=:\AInseparable\z:}', "");;
    Expect(0, 68343, '\p{Line_Break=:\AInseparable\z:}', "");;
    Expect(1, 68342, '\p{Line_Break=inseparable}', "");
    Expect(0, 68342, '\p{^Line_Break=inseparable}', "");
    Expect(0, 68342, '\P{Line_Break=inseparable}', "");
    Expect(1, 68342, '\P{^Line_Break=inseparable}', "");
    Expect(0, 68343, '\p{Line_Break=inseparable}', "");
    Expect(1, 68343, '\p{^Line_Break=inseparable}', "");
    Expect(1, 68343, '\P{Line_Break=inseparable}', "");
    Expect(0, 68343, '\P{^Line_Break=inseparable}', "");
    Expect(1, 68342, '\p{Line_Break=:\Ainseparable\z:}', "");;
    Expect(0, 68343, '\p{Line_Break=:\Ainseparable\z:}', "");;
    Expect(1, 68342, '\p{Line_Break=		Inseparable}', "");
    Expect(0, 68342, '\p{^Line_Break=		Inseparable}', "");
    Expect(0, 68342, '\P{Line_Break=		Inseparable}', "");
    Expect(1, 68342, '\P{^Line_Break=		Inseparable}', "");
    Expect(0, 68343, '\p{Line_Break=		Inseparable}', "");
    Expect(1, 68343, '\p{^Line_Break=		Inseparable}', "");
    Expect(1, 68343, '\P{Line_Break=		Inseparable}', "");
    Expect(0, 68343, '\P{^Line_Break=		Inseparable}', "");
    Error('\p{Lb:/a/_IN}');
    Error('\P{Lb:/a/_IN}');
    Expect(1, 68342, '\p{Lb=:\AIN\z:}', "");;
    Expect(0, 68343, '\p{Lb=:\AIN\z:}', "");;
    Expect(1, 68342, '\p{Lb=in}', "");
    Expect(0, 68342, '\p{^Lb=in}', "");
    Expect(0, 68342, '\P{Lb=in}', "");
    Expect(1, 68342, '\P{^Lb=in}', "");
    Expect(0, 68343, '\p{Lb=in}', "");
    Expect(1, 68343, '\p{^Lb=in}', "");
    Expect(1, 68343, '\P{Lb=in}', "");
    Expect(0, 68343, '\P{^Lb=in}', "");
    Expect(1, 68342, '\p{Lb=:\Ain\z:}', "");;
    Expect(0, 68343, '\p{Lb=:\Ain\z:}', "");;
    Expect(1, 68342, '\p{Lb=	_IN}', "");
    Expect(0, 68342, '\p{^Lb=	_IN}', "");
    Expect(0, 68342, '\P{Lb=	_IN}', "");
    Expect(1, 68342, '\P{^Lb=	_IN}', "");
    Expect(0, 68343, '\p{Lb=	_IN}', "");
    Expect(1, 68343, '\p{^Lb=	_IN}', "");
    Expect(1, 68343, '\P{Lb=	_IN}', "");
    Expect(0, 68343, '\P{^Lb=	_IN}', "");
    Error('\p{Is_Line_Break=/a/Inseperable}');
    Error('\P{Is_Line_Break=/a/Inseperable}');
    Expect(1, 68342, '\p{Is_Line_Break=inseperable}', "");
    Expect(0, 68342, '\p{^Is_Line_Break=inseperable}', "");
    Expect(0, 68342, '\P{Is_Line_Break=inseperable}', "");
    Expect(1, 68342, '\P{^Is_Line_Break=inseperable}', "");
    Expect(0, 68343, '\p{Is_Line_Break=inseperable}', "");
    Expect(1, 68343, '\p{^Is_Line_Break=inseperable}', "");
    Expect(1, 68343, '\P{Is_Line_Break=inseperable}', "");
    Expect(0, 68343, '\P{^Is_Line_Break=inseperable}', "");
    Expect(1, 68342, '\p{Is_Line_Break=- Inseperable}', "");
    Expect(0, 68342, '\p{^Is_Line_Break=- Inseperable}', "");
    Expect(0, 68342, '\P{Is_Line_Break=- Inseperable}', "");
    Expect(1, 68342, '\P{^Is_Line_Break=- Inseperable}', "");
    Expect(0, 68343, '\p{Is_Line_Break=- Inseperable}', "");
    Expect(1, 68343, '\p{^Is_Line_Break=- Inseperable}', "");
    Expect(1, 68343, '\P{Is_Line_Break=- Inseperable}', "");
    Expect(0, 68343, '\P{^Is_Line_Break=- Inseperable}', "");
    Error('\p{Is_Lb:	:=Inseparable}');
    Error('\P{Is_Lb:	:=Inseparable}');
    Expect(1, 68342, '\p{Is_Lb=inseparable}', "");
    Expect(0, 68342, '\p{^Is_Lb=inseparable}', "");
    Expect(0, 68342, '\P{Is_Lb=inseparable}', "");
    Expect(1, 68342, '\P{^Is_Lb=inseparable}', "");
    Expect(0, 68343, '\p{Is_Lb=inseparable}', "");
    Expect(1, 68343, '\p{^Is_Lb=inseparable}', "");
    Expect(1, 68343, '\P{Is_Lb=inseparable}', "");
    Expect(0, 68343, '\P{^Is_Lb=inseparable}', "");
    Expect(1, 68342, '\p{Is_Lb=_-INSEPARABLE}', "");
    Expect(0, 68342, '\p{^Is_Lb=_-INSEPARABLE}', "");
    Expect(0, 68342, '\P{Is_Lb=_-INSEPARABLE}', "");
    Expect(1, 68342, '\P{^Is_Lb=_-INSEPARABLE}', "");
    Expect(0, 68343, '\p{Is_Lb=_-INSEPARABLE}', "");
    Expect(1, 68343, '\p{^Is_Lb=_-INSEPARABLE}', "");
    Expect(1, 68343, '\P{Is_Lb=_-INSEPARABLE}', "");
    Expect(0, 68343, '\P{^Is_Lb=_-INSEPARABLE}', "");
    Error('\p{Line_Break= :=infix_NUMERIC}');
    Error('\P{Line_Break= :=infix_NUMERIC}');
    Expect(1, 65044, '\p{Line_Break=:\AInfix_Numeric\z:}', "");;
    Expect(0, 65045, '\p{Line_Break=:\AInfix_Numeric\z:}', "");;
    Expect(1, 65044, '\p{Line_Break=infixnumeric}', "");
    Expect(0, 65044, '\p{^Line_Break=infixnumeric}', "");
    Expect(0, 65044, '\P{Line_Break=infixnumeric}', "");
    Expect(1, 65044, '\P{^Line_Break=infixnumeric}', "");
    Expect(0, 65045, '\p{Line_Break=infixnumeric}', "");
    Expect(1, 65045, '\p{^Line_Break=infixnumeric}', "");
    Expect(1, 65045, '\P{Line_Break=infixnumeric}', "");
    Expect(0, 65045, '\P{^Line_Break=infixnumeric}', "");
    Expect(1, 65044, '\p{Line_Break=:\Ainfixnumeric\z:}', "");;
    Expect(0, 65045, '\p{Line_Break=:\Ainfixnumeric\z:}', "");;
    Expect(1, 65044, '\p{Line_Break=-_INFIX_Numeric}', "");
    Expect(0, 65044, '\p{^Line_Break=-_INFIX_Numeric}', "");
    Expect(0, 65044, '\P{Line_Break=-_INFIX_Numeric}', "");
    Expect(1, 65044, '\P{^Line_Break=-_INFIX_Numeric}', "");
    Expect(0, 65045, '\p{Line_Break=-_INFIX_Numeric}', "");
    Expect(1, 65045, '\p{^Line_Break=-_INFIX_Numeric}', "");
    Expect(1, 65045, '\P{Line_Break=-_INFIX_Numeric}', "");
    Expect(0, 65045, '\P{^Line_Break=-_INFIX_Numeric}', "");
    Error('\p{Lb=- IS/a/}');
    Error('\P{Lb=- IS/a/}');
    Expect(1, 65044, '\p{Lb=:\AIS\z:}', "");;
    Expect(0, 65045, '\p{Lb=:\AIS\z:}', "");;
    Expect(1, 65044, '\p{Lb=is}', "");
    Expect(0, 65044, '\p{^Lb=is}', "");
    Expect(0, 65044, '\P{Lb=is}', "");
    Expect(1, 65044, '\P{^Lb=is}', "");
    Expect(0, 65045, '\p{Lb=is}', "");
    Expect(1, 65045, '\p{^Lb=is}', "");
    Expect(1, 65045, '\P{Lb=is}', "");
    Expect(0, 65045, '\P{^Lb=is}', "");
    Expect(1, 65044, '\p{Lb=:\Ais\z:}', "");;
    Expect(0, 65045, '\p{Lb=:\Ais\z:}', "");;
    Expect(1, 65044, '\p{Lb= _IS}', "");
    Expect(0, 65044, '\p{^Lb= _IS}', "");
    Expect(0, 65044, '\P{Lb= _IS}', "");
    Expect(1, 65044, '\P{^Lb= _IS}', "");
    Expect(0, 65045, '\p{Lb= _IS}', "");
    Expect(1, 65045, '\p{^Lb= _IS}', "");
    Expect(1, 65045, '\P{Lb= _IS}', "");
    Expect(0, 65045, '\P{^Lb= _IS}', "");
    Error('\p{Is_Line_Break:_	Infix_Numeric/a/}');
    Error('\P{Is_Line_Break:_	Infix_Numeric/a/}');
    Expect(1, 65044, '\p{Is_Line_Break: infixnumeric}', "");
    Expect(0, 65044, '\p{^Is_Line_Break: infixnumeric}', "");
    Expect(0, 65044, '\P{Is_Line_Break: infixnumeric}', "");
    Expect(1, 65044, '\P{^Is_Line_Break: infixnumeric}', "");
    Expect(0, 65045, '\p{Is_Line_Break: infixnumeric}', "");
    Expect(1, 65045, '\p{^Is_Line_Break: infixnumeric}', "");
    Expect(1, 65045, '\P{Is_Line_Break: infixnumeric}', "");
    Expect(0, 65045, '\P{^Is_Line_Break: infixnumeric}', "");
    Expect(1, 65044, '\p{Is_Line_Break= Infix_NUMERIC}', "");
    Expect(0, 65044, '\p{^Is_Line_Break= Infix_NUMERIC}', "");
    Expect(0, 65044, '\P{Is_Line_Break= Infix_NUMERIC}', "");
    Expect(1, 65044, '\P{^Is_Line_Break= Infix_NUMERIC}', "");
    Expect(0, 65045, '\p{Is_Line_Break= Infix_NUMERIC}', "");
    Expect(1, 65045, '\p{^Is_Line_Break= Infix_NUMERIC}', "");
    Expect(1, 65045, '\P{Is_Line_Break= Infix_NUMERIC}', "");
    Expect(0, 65045, '\P{^Is_Line_Break= Infix_NUMERIC}', "");
    Error('\p{Is_Lb=	:=IS}');
    Error('\P{Is_Lb=	:=IS}');
    Expect(1, 65044, '\p{Is_Lb=is}', "");
    Expect(0, 65044, '\p{^Is_Lb=is}', "");
    Expect(0, 65044, '\P{Is_Lb=is}', "");
    Expect(1, 65044, '\P{^Is_Lb=is}', "");
    Expect(0, 65045, '\p{Is_Lb=is}', "");
    Expect(1, 65045, '\p{^Is_Lb=is}', "");
    Expect(1, 65045, '\P{Is_Lb=is}', "");
    Expect(0, 65045, '\P{^Is_Lb=is}', "");
    Expect(1, 65044, '\p{Is_Lb=	_is}', "");
    Expect(0, 65044, '\p{^Is_Lb=	_is}', "");
    Expect(0, 65044, '\P{Is_Lb=	_is}', "");
    Expect(1, 65044, '\P{^Is_Lb=	_is}', "");
    Expect(0, 65045, '\p{Is_Lb=	_is}', "");
    Expect(1, 65045, '\p{^Is_Lb=	_is}', "");
    Expect(1, 65045, '\P{Is_Lb=	_is}', "");
    Expect(0, 65045, '\P{^Is_Lb=	_is}', "");
    Error('\p{Line_Break=_/a/JL}');
    Error('\P{Line_Break=_/a/JL}');
    Expect(1, 43388, '\p{Line_Break=:\AJL\z:}', "");;
    Expect(0, 43389, '\p{Line_Break=:\AJL\z:}', "");;
    Expect(1, 43388, '\p{Line_Break=jl}', "");
    Expect(0, 43388, '\p{^Line_Break=jl}', "");
    Expect(0, 43388, '\P{Line_Break=jl}', "");
    Expect(1, 43388, '\P{^Line_Break=jl}', "");
    Expect(0, 43389, '\p{Line_Break=jl}', "");
    Expect(1, 43389, '\p{^Line_Break=jl}', "");
    Expect(1, 43389, '\P{Line_Break=jl}', "");
    Expect(0, 43389, '\P{^Line_Break=jl}', "");
    Expect(1, 43388, '\p{Line_Break=:\Ajl\z:}', "");;
    Expect(0, 43389, '\p{Line_Break=:\Ajl\z:}', "");;
    Expect(1, 43388, '\p{Line_Break:   	_JL}', "");
    Expect(0, 43388, '\p{^Line_Break:   	_JL}', "");
    Expect(0, 43388, '\P{Line_Break:   	_JL}', "");
    Expect(1, 43388, '\P{^Line_Break:   	_JL}', "");
    Expect(0, 43389, '\p{Line_Break:   	_JL}', "");
    Expect(1, 43389, '\p{^Line_Break:   	_JL}', "");
    Expect(1, 43389, '\P{Line_Break:   	_JL}', "");
    Expect(0, 43389, '\P{^Line_Break:   	_JL}', "");
    Error('\p{Lb=--JL:=}');
    Error('\P{Lb=--JL:=}');
    Expect(1, 43388, '\p{Lb=:\AJL\z:}', "");;
    Expect(0, 43389, '\p{Lb=:\AJL\z:}', "");;
    Expect(1, 43388, '\p{Lb=jl}', "");
    Expect(0, 43388, '\p{^Lb=jl}', "");
    Expect(0, 43388, '\P{Lb=jl}', "");
    Expect(1, 43388, '\P{^Lb=jl}', "");
    Expect(0, 43389, '\p{Lb=jl}', "");
    Expect(1, 43389, '\p{^Lb=jl}', "");
    Expect(1, 43389, '\P{Lb=jl}', "");
    Expect(0, 43389, '\P{^Lb=jl}', "");
    Expect(1, 43388, '\p{Lb=:\Ajl\z:}', "");;
    Expect(0, 43389, '\p{Lb=:\Ajl\z:}', "");;
    Expect(1, 43388, '\p{Lb=-_JL}', "");
    Expect(0, 43388, '\p{^Lb=-_JL}', "");
    Expect(0, 43388, '\P{Lb=-_JL}', "");
    Expect(1, 43388, '\P{^Lb=-_JL}', "");
    Expect(0, 43389, '\p{Lb=-_JL}', "");
    Expect(1, 43389, '\p{^Lb=-_JL}', "");
    Expect(1, 43389, '\P{Lb=-_JL}', "");
    Expect(0, 43389, '\P{^Lb=-_JL}', "");
    Error('\p{Is_Line_Break=/a/  JL}');
    Error('\P{Is_Line_Break=/a/  JL}');
    Expect(1, 43388, '\p{Is_Line_Break: jl}', "");
    Expect(0, 43388, '\p{^Is_Line_Break: jl}', "");
    Expect(0, 43388, '\P{Is_Line_Break: jl}', "");
    Expect(1, 43388, '\P{^Is_Line_Break: jl}', "");
    Expect(0, 43389, '\p{Is_Line_Break: jl}', "");
    Expect(1, 43389, '\p{^Is_Line_Break: jl}', "");
    Expect(1, 43389, '\P{Is_Line_Break: jl}', "");
    Expect(0, 43389, '\P{^Is_Line_Break: jl}', "");
    Expect(1, 43388, '\p{Is_Line_Break= _jl}', "");
    Expect(0, 43388, '\p{^Is_Line_Break= _jl}', "");
    Expect(0, 43388, '\P{Is_Line_Break= _jl}', "");
    Expect(1, 43388, '\P{^Is_Line_Break= _jl}', "");
    Expect(0, 43389, '\p{Is_Line_Break= _jl}', "");
    Expect(1, 43389, '\p{^Is_Line_Break= _jl}', "");
    Expect(1, 43389, '\P{Is_Line_Break= _jl}', "");
    Expect(0, 43389, '\P{^Is_Line_Break= _jl}', "");
    Error('\p{Is_Lb=-JL/a/}');
    Error('\P{Is_Lb=-JL/a/}');
    Expect(1, 43388, '\p{Is_Lb=jl}', "");
    Expect(0, 43388, '\p{^Is_Lb=jl}', "");
    Expect(0, 43388, '\P{Is_Lb=jl}', "");
    Expect(1, 43388, '\P{^Is_Lb=jl}', "");
    Expect(0, 43389, '\p{Is_Lb=jl}', "");
    Expect(1, 43389, '\p{^Is_Lb=jl}', "");
    Expect(1, 43389, '\P{Is_Lb=jl}', "");
    Expect(0, 43389, '\P{^Is_Lb=jl}', "");
    Expect(1, 43388, '\p{Is_Lb=__JL}', "");
    Expect(0, 43388, '\p{^Is_Lb=__JL}', "");
    Expect(0, 43388, '\P{Is_Lb=__JL}', "");
    Expect(1, 43388, '\P{^Is_Lb=__JL}', "");
    Expect(0, 43389, '\p{Is_Lb=__JL}', "");
    Expect(1, 43389, '\p{^Is_Lb=__JL}', "");
    Expect(1, 43389, '\P{Is_Lb=__JL}', "");
    Expect(0, 43389, '\P{^Is_Lb=__JL}', "");
    Error('\p{Line_Break=	_JT/a/}');
    Error('\P{Line_Break=	_JT/a/}');
    Expect(1, 55291, '\p{Line_Break=:\AJT\z:}', "");;
    Expect(0, 55292, '\p{Line_Break=:\AJT\z:}', "");;
    Expect(1, 55291, '\p{Line_Break:	jt}', "");
    Expect(0, 55291, '\p{^Line_Break:	jt}', "");
    Expect(0, 55291, '\P{Line_Break:	jt}', "");
    Expect(1, 55291, '\P{^Line_Break:	jt}', "");
    Expect(0, 55292, '\p{Line_Break:	jt}', "");
    Expect(1, 55292, '\p{^Line_Break:	jt}', "");
    Expect(1, 55292, '\P{Line_Break:	jt}', "");
    Expect(0, 55292, '\P{^Line_Break:	jt}', "");
    Expect(1, 55291, '\p{Line_Break=:\Ajt\z:}', "");;
    Expect(0, 55292, '\p{Line_Break=:\Ajt\z:}', "");;
    Expect(1, 55291, '\p{Line_Break=_JT}', "");
    Expect(0, 55291, '\p{^Line_Break=_JT}', "");
    Expect(0, 55291, '\P{Line_Break=_JT}', "");
    Expect(1, 55291, '\P{^Line_Break=_JT}', "");
    Expect(0, 55292, '\p{Line_Break=_JT}', "");
    Expect(1, 55292, '\p{^Line_Break=_JT}', "");
    Expect(1, 55292, '\P{Line_Break=_JT}', "");
    Expect(0, 55292, '\P{^Line_Break=_JT}', "");
    Error('\p{Lb:_:=JT}');
    Error('\P{Lb:_:=JT}');
    Expect(1, 55291, '\p{Lb=:\AJT\z:}', "");;
    Expect(0, 55292, '\p{Lb=:\AJT\z:}', "");;
    Expect(1, 55291, '\p{Lb=jt}', "");
    Expect(0, 55291, '\p{^Lb=jt}', "");
    Expect(0, 55291, '\P{Lb=jt}', "");
    Expect(1, 55291, '\P{^Lb=jt}', "");
    Expect(0, 55292, '\p{Lb=jt}', "");
    Expect(1, 55292, '\p{^Lb=jt}', "");
    Expect(1, 55292, '\P{Lb=jt}', "");
    Expect(0, 55292, '\P{^Lb=jt}', "");
    Expect(1, 55291, '\p{Lb=:\Ajt\z:}', "");;
    Expect(0, 55292, '\p{Lb=:\Ajt\z:}', "");;
    Expect(1, 55291, '\p{Lb= JT}', "");
    Expect(0, 55291, '\p{^Lb= JT}', "");
    Expect(0, 55291, '\P{Lb= JT}', "");
    Expect(1, 55291, '\P{^Lb= JT}', "");
    Expect(0, 55292, '\p{Lb= JT}', "");
    Expect(1, 55292, '\p{^Lb= JT}', "");
    Expect(1, 55292, '\P{Lb= JT}', "");
    Expect(0, 55292, '\P{^Lb= JT}', "");
    Error('\p{Is_Line_Break=/a/	-JT}');
    Error('\P{Is_Line_Break=/a/	-JT}');
    Expect(1, 55291, '\p{Is_Line_Break=jt}', "");
    Expect(0, 55291, '\p{^Is_Line_Break=jt}', "");
    Expect(0, 55291, '\P{Is_Line_Break=jt}', "");
    Expect(1, 55291, '\P{^Is_Line_Break=jt}', "");
    Expect(0, 55292, '\p{Is_Line_Break=jt}', "");
    Expect(1, 55292, '\p{^Is_Line_Break=jt}', "");
    Expect(1, 55292, '\P{Is_Line_Break=jt}', "");
    Expect(0, 55292, '\P{^Is_Line_Break=jt}', "");
    Expect(1, 55291, '\p{Is_Line_Break=-	jt}', "");
    Expect(0, 55291, '\p{^Is_Line_Break=-	jt}', "");
    Expect(0, 55291, '\P{Is_Line_Break=-	jt}', "");
    Expect(1, 55291, '\P{^Is_Line_Break=-	jt}', "");
    Expect(0, 55292, '\p{Is_Line_Break=-	jt}', "");
    Expect(1, 55292, '\p{^Is_Line_Break=-	jt}', "");
    Expect(1, 55292, '\P{Is_Line_Break=-	jt}', "");
    Expect(0, 55292, '\P{^Is_Line_Break=-	jt}', "");
    Error('\p{Is_Lb= :=jt}');
    Error('\P{Is_Lb= :=jt}');
    Expect(1, 55291, '\p{Is_Lb=jt}', "");
    Expect(0, 55291, '\p{^Is_Lb=jt}', "");
    Expect(0, 55291, '\P{Is_Lb=jt}', "");
    Expect(1, 55291, '\P{^Is_Lb=jt}', "");
    Expect(0, 55292, '\p{Is_Lb=jt}', "");
    Expect(1, 55292, '\p{^Is_Lb=jt}', "");
    Expect(1, 55292, '\P{Is_Lb=jt}', "");
    Expect(0, 55292, '\P{^Is_Lb=jt}', "");
    Expect(1, 55291, '\p{Is_Lb=__jt}', "");
    Expect(0, 55291, '\p{^Is_Lb=__jt}', "");
    Expect(0, 55291, '\P{Is_Lb=__jt}', "");
    Expect(1, 55291, '\P{^Is_Lb=__jt}', "");
    Expect(0, 55292, '\p{Is_Lb=__jt}', "");
    Expect(1, 55292, '\p{^Is_Lb=__jt}', "");
    Expect(1, 55292, '\P{Is_Lb=__jt}', "");
    Expect(0, 55292, '\P{^Is_Lb=__jt}', "");
    Error('\p{Line_Break=_JV/a/}');
    Error('\P{Line_Break=_JV/a/}');
    Expect(1, 55238, '\p{Line_Break=:\AJV\z:}', "");;
    Expect(0, 55239, '\p{Line_Break=:\AJV\z:}', "");;
    Expect(1, 55238, '\p{Line_Break=jv}', "");
    Expect(0, 55238, '\p{^Line_Break=jv}', "");
    Expect(0, 55238, '\P{Line_Break=jv}', "");
    Expect(1, 55238, '\P{^Line_Break=jv}', "");
    Expect(0, 55239, '\p{Line_Break=jv}', "");
    Expect(1, 55239, '\p{^Line_Break=jv}', "");
    Expect(1, 55239, '\P{Line_Break=jv}', "");
    Expect(0, 55239, '\P{^Line_Break=jv}', "");
    Expect(1, 55238, '\p{Line_Break=:\Ajv\z:}', "");;
    Expect(0, 55239, '\p{Line_Break=:\Ajv\z:}', "");;
    Expect(1, 55238, '\p{Line_Break=  JV}', "");
    Expect(0, 55238, '\p{^Line_Break=  JV}', "");
    Expect(0, 55238, '\P{Line_Break=  JV}', "");
    Expect(1, 55238, '\P{^Line_Break=  JV}', "");
    Expect(0, 55239, '\p{Line_Break=  JV}', "");
    Expect(1, 55239, '\p{^Line_Break=  JV}', "");
    Expect(1, 55239, '\P{Line_Break=  JV}', "");
    Expect(0, 55239, '\P{^Line_Break=  JV}', "");
    Error('\p{Lb=:=--JV}');
    Error('\P{Lb=:=--JV}');
    Expect(1, 55238, '\p{Lb=:\AJV\z:}', "");;
    Expect(0, 55239, '\p{Lb=:\AJV\z:}', "");;
    Expect(1, 55238, '\p{Lb=jv}', "");
    Expect(0, 55238, '\p{^Lb=jv}', "");
    Expect(0, 55238, '\P{Lb=jv}', "");
    Expect(1, 55238, '\P{^Lb=jv}', "");
    Expect(0, 55239, '\p{Lb=jv}', "");
    Expect(1, 55239, '\p{^Lb=jv}', "");
    Expect(1, 55239, '\P{Lb=jv}', "");
    Expect(0, 55239, '\P{^Lb=jv}', "");
    Expect(1, 55238, '\p{Lb=:\Ajv\z:}', "");;
    Expect(0, 55239, '\p{Lb=:\Ajv\z:}', "");;
    Expect(1, 55238, '\p{Lb=JV}', "");
    Expect(0, 55238, '\p{^Lb=JV}', "");
    Expect(0, 55238, '\P{Lb=JV}', "");
    Expect(1, 55238, '\P{^Lb=JV}', "");
    Expect(0, 55239, '\p{Lb=JV}', "");
    Expect(1, 55239, '\p{^Lb=JV}', "");
    Expect(1, 55239, '\P{Lb=JV}', "");
    Expect(0, 55239, '\P{^Lb=JV}', "");
    Error('\p{Is_Line_Break= :=jv}');
    Error('\P{Is_Line_Break= :=jv}');
    Expect(1, 55238, '\p{Is_Line_Break: jv}', "");
    Expect(0, 55238, '\p{^Is_Line_Break: jv}', "");
    Expect(0, 55238, '\P{Is_Line_Break: jv}', "");
    Expect(1, 55238, '\P{^Is_Line_Break: jv}', "");
    Expect(0, 55239, '\p{Is_Line_Break: jv}', "");
    Expect(1, 55239, '\p{^Is_Line_Break: jv}', "");
    Expect(1, 55239, '\P{Is_Line_Break: jv}', "");
    Expect(0, 55239, '\P{^Is_Line_Break: jv}', "");
    Expect(1, 55238, '\p{Is_Line_Break=	 JV}', "");
    Expect(0, 55238, '\p{^Is_Line_Break=	 JV}', "");
    Expect(0, 55238, '\P{Is_Line_Break=	 JV}', "");
    Expect(1, 55238, '\P{^Is_Line_Break=	 JV}', "");
    Expect(0, 55239, '\p{Is_Line_Break=	 JV}', "");
    Expect(1, 55239, '\p{^Is_Line_Break=	 JV}', "");
    Expect(1, 55239, '\P{Is_Line_Break=	 JV}', "");
    Expect(0, 55239, '\P{^Is_Line_Break=	 JV}', "");
    Error('\p{Is_Lb=JV:=}');
    Error('\P{Is_Lb=JV:=}');
    Expect(1, 55238, '\p{Is_Lb=jv}', "");
    Expect(0, 55238, '\p{^Is_Lb=jv}', "");
    Expect(0, 55238, '\P{Is_Lb=jv}', "");
    Expect(1, 55238, '\P{^Is_Lb=jv}', "");
    Expect(0, 55239, '\p{Is_Lb=jv}', "");
    Expect(1, 55239, '\p{^Is_Lb=jv}', "");
    Expect(1, 55239, '\P{Is_Lb=jv}', "");
    Expect(0, 55239, '\P{^Is_Lb=jv}', "");
    Expect(1, 55238, '\p{Is_Lb=_-JV}', "");
    Expect(0, 55238, '\p{^Is_Lb=_-JV}', "");
    Expect(0, 55238, '\P{Is_Lb=_-JV}', "");
    Expect(1, 55238, '\P{^Is_Lb=_-JV}', "");
    Expect(0, 55239, '\p{Is_Lb=_-JV}', "");
    Expect(1, 55239, '\p{^Is_Lb=_-JV}', "");
    Expect(1, 55239, '\P{Is_Lb=_-JV}', "");
    Expect(0, 55239, '\P{^Is_Lb=_-JV}', "");
    Error('\p{Line_Break=	_line_feed:=}');
    Error('\P{Line_Break=	_line_feed:=}');
    Expect(1, 10, '\p{Line_Break=:\ALine_Feed\z:}', "");;
    Expect(0, 11, '\p{Line_Break=:\ALine_Feed\z:}', "");;
    Expect(1, 10, '\p{Line_Break=linefeed}', "");
    Expect(0, 10, '\p{^Line_Break=linefeed}', "");
    Expect(0, 10, '\P{Line_Break=linefeed}', "");
    Expect(1, 10, '\P{^Line_Break=linefeed}', "");
    Expect(0, 11, '\p{Line_Break=linefeed}', "");
    Expect(1, 11, '\p{^Line_Break=linefeed}', "");
    Expect(1, 11, '\P{Line_Break=linefeed}', "");
    Expect(0, 11, '\P{^Line_Break=linefeed}', "");
    Expect(1, 10, '\p{Line_Break=:\Alinefeed\z:}', "");;
    Expect(0, 11, '\p{Line_Break=:\Alinefeed\z:}', "");;
    Expect(1, 10, '\p{Line_Break:	LINE_FEED}', "");
    Expect(0, 10, '\p{^Line_Break:	LINE_FEED}', "");
    Expect(0, 10, '\P{Line_Break:	LINE_FEED}', "");
    Expect(1, 10, '\P{^Line_Break:	LINE_FEED}', "");
    Expect(0, 11, '\p{Line_Break:	LINE_FEED}', "");
    Expect(1, 11, '\p{^Line_Break:	LINE_FEED}', "");
    Expect(1, 11, '\P{Line_Break:	LINE_FEED}', "");
    Expect(0, 11, '\P{^Line_Break:	LINE_FEED}', "");
    Error('\p{Lb=_:=LF}');
    Error('\P{Lb=_:=LF}');
    Expect(1, 10, '\p{Lb=:\ALF\z:}', "");;
    Expect(0, 11, '\p{Lb=:\ALF\z:}', "");;
    Expect(1, 10, '\p{Lb=lf}', "");
    Expect(0, 10, '\p{^Lb=lf}', "");
    Expect(0, 10, '\P{Lb=lf}', "");
    Expect(1, 10, '\P{^Lb=lf}', "");
    Expect(0, 11, '\p{Lb=lf}', "");
    Expect(1, 11, '\p{^Lb=lf}', "");
    Expect(1, 11, '\P{Lb=lf}', "");
    Expect(0, 11, '\P{^Lb=lf}', "");
    Expect(1, 10, '\p{Lb=:\Alf\z:}', "");;
    Expect(0, 11, '\p{Lb=:\Alf\z:}', "");;
    Expect(1, 10, '\p{Lb= LF}', "");
    Expect(0, 10, '\p{^Lb= LF}', "");
    Expect(0, 10, '\P{Lb= LF}', "");
    Expect(1, 10, '\P{^Lb= LF}', "");
    Expect(0, 11, '\p{Lb= LF}', "");
    Expect(1, 11, '\p{^Lb= LF}', "");
    Expect(1, 11, '\P{Lb= LF}', "");
    Expect(0, 11, '\P{^Lb= LF}', "");
    Error('\p{Is_Line_Break= 	Line_Feed/a/}');
    Error('\P{Is_Line_Break= 	Line_Feed/a/}');
    Expect(1, 10, '\p{Is_Line_Break:	linefeed}', "");
    Expect(0, 10, '\p{^Is_Line_Break:	linefeed}', "");
    Expect(0, 10, '\P{Is_Line_Break:	linefeed}', "");
    Expect(1, 10, '\P{^Is_Line_Break:	linefeed}', "");
    Expect(0, 11, '\p{Is_Line_Break:	linefeed}', "");
    Expect(1, 11, '\p{^Is_Line_Break:	linefeed}', "");
    Expect(1, 11, '\P{Is_Line_Break:	linefeed}', "");
    Expect(0, 11, '\P{^Is_Line_Break:	linefeed}', "");
    Expect(1, 10, '\p{Is_Line_Break=_Line_FEED}', "");
    Expect(0, 10, '\p{^Is_Line_Break=_Line_FEED}', "");
    Expect(0, 10, '\P{Is_Line_Break=_Line_FEED}', "");
    Expect(1, 10, '\P{^Is_Line_Break=_Line_FEED}', "");
    Expect(0, 11, '\p{Is_Line_Break=_Line_FEED}', "");
    Expect(1, 11, '\p{^Is_Line_Break=_Line_FEED}', "");
    Expect(1, 11, '\P{Is_Line_Break=_Line_FEED}', "");
    Expect(0, 11, '\P{^Is_Line_Break=_Line_FEED}', "");
    Error('\p{Is_Lb=	:=LF}');
    Error('\P{Is_Lb=	:=LF}');
    Expect(1, 10, '\p{Is_Lb=lf}', "");
    Expect(0, 10, '\p{^Is_Lb=lf}', "");
    Expect(0, 10, '\P{Is_Lb=lf}', "");
    Expect(1, 10, '\P{^Is_Lb=lf}', "");
    Expect(0, 11, '\p{Is_Lb=lf}', "");
    Expect(1, 11, '\p{^Is_Lb=lf}', "");
    Expect(1, 11, '\P{Is_Lb=lf}', "");
    Expect(0, 11, '\P{^Is_Lb=lf}', "");
    Expect(1, 10, '\p{Is_Lb= _LF}', "");
    Expect(0, 10, '\p{^Is_Lb= _LF}', "");
    Expect(0, 10, '\P{Is_Lb= _LF}', "");
    Expect(1, 10, '\P{^Is_Lb= _LF}', "");
    Expect(0, 11, '\p{Is_Lb= _LF}', "");
    Expect(1, 11, '\p{^Is_Lb= _LF}', "");
    Expect(1, 11, '\P{Is_Lb= _LF}', "");
    Expect(0, 11, '\P{^Is_Lb= _LF}', "");
    Error('\p{Line_Break= :=Next_Line}');
    Error('\P{Line_Break= :=Next_Line}');
    Expect(1, 133, '\p{Line_Break=:\ANext_Line\z:}', "");;
    Expect(0, 134, '\p{Line_Break=:\ANext_Line\z:}', "");;
    Expect(1, 133, '\p{Line_Break=nextline}', "");
    Expect(0, 133, '\p{^Line_Break=nextline}', "");
    Expect(0, 133, '\P{Line_Break=nextline}', "");
    Expect(1, 133, '\P{^Line_Break=nextline}', "");
    Expect(0, 134, '\p{Line_Break=nextline}', "");
    Expect(1, 134, '\p{^Line_Break=nextline}', "");
    Expect(1, 134, '\P{Line_Break=nextline}', "");
    Expect(0, 134, '\P{^Line_Break=nextline}', "");
    Expect(1, 133, '\p{Line_Break=:\Anextline\z:}', "");;
    Expect(0, 134, '\p{Line_Break=:\Anextline\z:}', "");;
    Expect(1, 133, '\p{Line_Break=	Next_line}', "");
    Expect(0, 133, '\p{^Line_Break=	Next_line}', "");
    Expect(0, 133, '\P{Line_Break=	Next_line}', "");
    Expect(1, 133, '\P{^Line_Break=	Next_line}', "");
    Expect(0, 134, '\p{Line_Break=	Next_line}', "");
    Expect(1, 134, '\p{^Line_Break=	Next_line}', "");
    Expect(1, 134, '\P{Line_Break=	Next_line}', "");
    Expect(0, 134, '\P{^Line_Break=	Next_line}', "");
    Error('\p{Lb= _nl:=}');
    Error('\P{Lb= _nl:=}');
    Expect(1, 133, '\p{Lb=:\ANL\z:}', "");;
    Expect(0, 134, '\p{Lb=:\ANL\z:}', "");;
    Expect(1, 133, '\p{Lb=nl}', "");
    Expect(0, 133, '\p{^Lb=nl}', "");
    Expect(0, 133, '\P{Lb=nl}', "");
    Expect(1, 133, '\P{^Lb=nl}', "");
    Expect(0, 134, '\p{Lb=nl}', "");
    Expect(1, 134, '\p{^Lb=nl}', "");
    Expect(1, 134, '\P{Lb=nl}', "");
    Expect(0, 134, '\P{^Lb=nl}', "");
    Expect(1, 133, '\p{Lb=:\Anl\z:}', "");;
    Expect(0, 134, '\p{Lb=:\Anl\z:}', "");;
    Expect(1, 133, '\p{Lb:	-nl}', "");
    Expect(0, 133, '\p{^Lb:	-nl}', "");
    Expect(0, 133, '\P{Lb:	-nl}', "");
    Expect(1, 133, '\P{^Lb:	-nl}', "");
    Expect(0, 134, '\p{Lb:	-nl}', "");
    Expect(1, 134, '\p{^Lb:	-nl}', "");
    Expect(1, 134, '\P{Lb:	-nl}', "");
    Expect(0, 134, '\P{^Lb:	-nl}', "");
    Error('\p{Is_Line_Break=_ next_Line/a/}');
    Error('\P{Is_Line_Break=_ next_Line/a/}');
    Expect(1, 133, '\p{Is_Line_Break:	nextline}', "");
    Expect(0, 133, '\p{^Is_Line_Break:	nextline}', "");
    Expect(0, 133, '\P{Is_Line_Break:	nextline}', "");
    Expect(1, 133, '\P{^Is_Line_Break:	nextline}', "");
    Expect(0, 134, '\p{Is_Line_Break:	nextline}', "");
    Expect(1, 134, '\p{^Is_Line_Break:	nextline}', "");
    Expect(1, 134, '\P{Is_Line_Break:	nextline}', "");
    Expect(0, 134, '\P{^Is_Line_Break:	nextline}', "");
    Expect(1, 133, '\p{Is_Line_Break=_Next_LINE}', "");
    Expect(0, 133, '\p{^Is_Line_Break=_Next_LINE}', "");
    Expect(0, 133, '\P{Is_Line_Break=_Next_LINE}', "");
    Expect(1, 133, '\P{^Is_Line_Break=_Next_LINE}', "");
    Expect(0, 134, '\p{Is_Line_Break=_Next_LINE}', "");
    Expect(1, 134, '\p{^Is_Line_Break=_Next_LINE}', "");
    Expect(1, 134, '\P{Is_Line_Break=_Next_LINE}', "");
    Expect(0, 134, '\P{^Is_Line_Break=_Next_LINE}', "");
    Error('\p{Is_Lb:			NL/a/}');
    Error('\P{Is_Lb:			NL/a/}');
    Expect(1, 133, '\p{Is_Lb=nl}', "");
    Expect(0, 133, '\p{^Is_Lb=nl}', "");
    Expect(0, 133, '\P{Is_Lb=nl}', "");
    Expect(1, 133, '\P{^Is_Lb=nl}', "");
    Expect(0, 134, '\p{Is_Lb=nl}', "");
    Expect(1, 134, '\p{^Is_Lb=nl}', "");
    Expect(1, 134, '\P{Is_Lb=nl}', "");
    Expect(0, 134, '\P{^Is_Lb=nl}', "");
    Expect(1, 133, '\p{Is_Lb= -NL}', "");
    Expect(0, 133, '\p{^Is_Lb= -NL}', "");
    Expect(0, 133, '\P{Is_Lb= -NL}', "");
    Expect(1, 133, '\P{^Is_Lb= -NL}', "");
    Expect(0, 134, '\p{Is_Lb= -NL}', "");
    Expect(1, 134, '\p{^Is_Lb= -NL}', "");
    Expect(1, 134, '\P{Is_Lb= -NL}', "");
    Expect(0, 134, '\P{^Is_Lb= -NL}', "");
    Error('\p{Line_Break=:=_ NONSTARTER}');
    Error('\P{Line_Break=:=_ NONSTARTER}');
    Expect(1, 128635, '\p{Line_Break=:\ANonstarter\z:}', "");;
    Expect(0, 128636, '\p{Line_Break=:\ANonstarter\z:}', "");;
    Expect(1, 128635, '\p{Line_Break=nonstarter}', "");
    Expect(0, 128635, '\p{^Line_Break=nonstarter}', "");
    Expect(0, 128635, '\P{Line_Break=nonstarter}', "");
    Expect(1, 128635, '\P{^Line_Break=nonstarter}', "");
    Expect(0, 128636, '\p{Line_Break=nonstarter}', "");
    Expect(1, 128636, '\p{^Line_Break=nonstarter}', "");
    Expect(1, 128636, '\P{Line_Break=nonstarter}', "");
    Expect(0, 128636, '\P{^Line_Break=nonstarter}', "");
    Expect(1, 128635, '\p{Line_Break=:\Anonstarter\z:}', "");;
    Expect(0, 128636, '\p{Line_Break=:\Anonstarter\z:}', "");;
    Expect(1, 128635, '\p{Line_Break=  NONSTARTER}', "");
    Expect(0, 128635, '\p{^Line_Break=  NONSTARTER}', "");
    Expect(0, 128635, '\P{Line_Break=  NONSTARTER}', "");
    Expect(1, 128635, '\P{^Line_Break=  NONSTARTER}', "");
    Expect(0, 128636, '\p{Line_Break=  NONSTARTER}', "");
    Expect(1, 128636, '\p{^Line_Break=  NONSTARTER}', "");
    Expect(1, 128636, '\P{Line_Break=  NONSTARTER}', "");
    Expect(0, 128636, '\P{^Line_Break=  NONSTARTER}', "");
    Error('\p{Lb=/a/_	NS}');
    Error('\P{Lb=/a/_	NS}');
    Expect(1, 128635, '\p{Lb=:\ANS\z:}', "");;
    Expect(0, 128636, '\p{Lb=:\ANS\z:}', "");;
    Expect(1, 128635, '\p{Lb=ns}', "");
    Expect(0, 128635, '\p{^Lb=ns}', "");
    Expect(0, 128635, '\P{Lb=ns}', "");
    Expect(1, 128635, '\P{^Lb=ns}', "");
    Expect(0, 128636, '\p{Lb=ns}', "");
    Expect(1, 128636, '\p{^Lb=ns}', "");
    Expect(1, 128636, '\P{Lb=ns}', "");
    Expect(0, 128636, '\P{^Lb=ns}', "");
    Expect(1, 128635, '\p{Lb=:\Ans\z:}', "");;
    Expect(0, 128636, '\p{Lb=:\Ans\z:}', "");;
    Expect(1, 128635, '\p{Lb=	NS}', "");
    Expect(0, 128635, '\p{^Lb=	NS}', "");
    Expect(0, 128635, '\P{Lb=	NS}', "");
    Expect(1, 128635, '\P{^Lb=	NS}', "");
    Expect(0, 128636, '\p{Lb=	NS}', "");
    Expect(1, 128636, '\p{^Lb=	NS}', "");
    Expect(1, 128636, '\P{Lb=	NS}', "");
    Expect(0, 128636, '\P{^Lb=	NS}', "");
    Error('\p{Is_Line_Break=:=-_Nonstarter}');
    Error('\P{Is_Line_Break=:=-_Nonstarter}');
    Expect(1, 128635, '\p{Is_Line_Break=nonstarter}', "");
    Expect(0, 128635, '\p{^Is_Line_Break=nonstarter}', "");
    Expect(0, 128635, '\P{Is_Line_Break=nonstarter}', "");
    Expect(1, 128635, '\P{^Is_Line_Break=nonstarter}', "");
    Expect(0, 128636, '\p{Is_Line_Break=nonstarter}', "");
    Expect(1, 128636, '\p{^Is_Line_Break=nonstarter}', "");
    Expect(1, 128636, '\P{Is_Line_Break=nonstarter}', "");
    Expect(0, 128636, '\P{^Is_Line_Break=nonstarter}', "");
    Expect(1, 128635, '\p{Is_Line_Break= _NONSTARTER}', "");
    Expect(0, 128635, '\p{^Is_Line_Break= _NONSTARTER}', "");
    Expect(0, 128635, '\P{Is_Line_Break= _NONSTARTER}', "");
    Expect(1, 128635, '\P{^Is_Line_Break= _NONSTARTER}', "");
    Expect(0, 128636, '\p{Is_Line_Break= _NONSTARTER}', "");
    Expect(1, 128636, '\p{^Is_Line_Break= _NONSTARTER}', "");
    Expect(1, 128636, '\P{Is_Line_Break= _NONSTARTER}', "");
    Expect(0, 128636, '\P{^Is_Line_Break= _NONSTARTER}', "");
    Error('\p{Is_Lb=/a/- NS}');
    Error('\P{Is_Lb=/a/- NS}');
    Expect(1, 128635, '\p{Is_Lb=ns}', "");
    Expect(0, 128635, '\p{^Is_Lb=ns}', "");
    Expect(0, 128635, '\P{Is_Lb=ns}', "");
    Expect(1, 128635, '\P{^Is_Lb=ns}', "");
    Expect(0, 128636, '\p{Is_Lb=ns}', "");
    Expect(1, 128636, '\p{^Is_Lb=ns}', "");
    Expect(1, 128636, '\P{Is_Lb=ns}', "");
    Expect(0, 128636, '\P{^Is_Lb=ns}', "");
    Expect(1, 128635, '\p{Is_Lb=_ ns}', "");
    Expect(0, 128635, '\p{^Is_Lb=_ ns}', "");
    Expect(0, 128635, '\P{Is_Lb=_ ns}', "");
    Expect(1, 128635, '\P{^Is_Lb=_ ns}', "");
    Expect(0, 128636, '\p{Is_Lb=_ ns}', "");
    Expect(1, 128636, '\p{^Is_Lb=_ ns}', "");
    Expect(1, 128636, '\P{Is_Lb=_ ns}', "");
    Expect(0, 128636, '\P{^Is_Lb=_ ns}', "");
    Error('\p{Line_Break:   /a/	numeric}');
    Error('\P{Line_Break:   /a/	numeric}');
    Expect(1, 130041, '\p{Line_Break=:\ANumeric\z:}', "");;
    Expect(0, 130042, '\p{Line_Break=:\ANumeric\z:}', "");;
    Expect(1, 130041, '\p{Line_Break=numeric}', "");
    Expect(0, 130041, '\p{^Line_Break=numeric}', "");
    Expect(0, 130041, '\P{Line_Break=numeric}', "");
    Expect(1, 130041, '\P{^Line_Break=numeric}', "");
    Expect(0, 130042, '\p{Line_Break=numeric}', "");
    Expect(1, 130042, '\p{^Line_Break=numeric}', "");
    Expect(1, 130042, '\P{Line_Break=numeric}', "");
    Expect(0, 130042, '\P{^Line_Break=numeric}', "");
    Expect(1, 130041, '\p{Line_Break=:\Anumeric\z:}', "");;
    Expect(0, 130042, '\p{Line_Break=:\Anumeric\z:}', "");;
    Expect(1, 130041, '\p{Line_Break=Numeric}', "");
    Expect(0, 130041, '\p{^Line_Break=Numeric}', "");
    Expect(0, 130041, '\P{Line_Break=Numeric}', "");
    Expect(1, 130041, '\P{^Line_Break=Numeric}', "");
    Expect(0, 130042, '\p{Line_Break=Numeric}', "");
    Expect(1, 130042, '\p{^Line_Break=Numeric}', "");
    Expect(1, 130042, '\P{Line_Break=Numeric}', "");
    Expect(0, 130042, '\P{^Line_Break=Numeric}', "");
    Error('\p{Lb:	:=nu}');
    Error('\P{Lb:	:=nu}');
    Expect(1, 130041, '\p{Lb=:\ANU\z:}', "");;
    Expect(0, 130042, '\p{Lb=:\ANU\z:}', "");;
    Expect(1, 130041, '\p{Lb:nu}', "");
    Expect(0, 130041, '\p{^Lb:nu}', "");
    Expect(0, 130041, '\P{Lb:nu}', "");
    Expect(1, 130041, '\P{^Lb:nu}', "");
    Expect(0, 130042, '\p{Lb:nu}', "");
    Expect(1, 130042, '\p{^Lb:nu}', "");
    Expect(1, 130042, '\P{Lb:nu}', "");
    Expect(0, 130042, '\P{^Lb:nu}', "");
    Expect(1, 130041, '\p{Lb=:\Anu\z:}', "");;
    Expect(0, 130042, '\p{Lb=:\Anu\z:}', "");;
    Expect(1, 130041, '\p{Lb=-NU}', "");
    Expect(0, 130041, '\p{^Lb=-NU}', "");
    Expect(0, 130041, '\P{Lb=-NU}', "");
    Expect(1, 130041, '\P{^Lb=-NU}', "");
    Expect(0, 130042, '\p{Lb=-NU}', "");
    Expect(1, 130042, '\p{^Lb=-NU}', "");
    Expect(1, 130042, '\P{Lb=-NU}', "");
    Expect(0, 130042, '\P{^Lb=-NU}', "");
    Error('\p{Is_Line_Break= NUMERIC:=}');
    Error('\P{Is_Line_Break= NUMERIC:=}');
    Expect(1, 130041, '\p{Is_Line_Break:   numeric}', "");
    Expect(0, 130041, '\p{^Is_Line_Break:   numeric}', "");
    Expect(0, 130041, '\P{Is_Line_Break:   numeric}', "");
    Expect(1, 130041, '\P{^Is_Line_Break:   numeric}', "");
    Expect(0, 130042, '\p{Is_Line_Break:   numeric}', "");
    Expect(1, 130042, '\p{^Is_Line_Break:   numeric}', "");
    Expect(1, 130042, '\P{Is_Line_Break:   numeric}', "");
    Expect(0, 130042, '\P{^Is_Line_Break:   numeric}', "");
    Expect(1, 130041, '\p{Is_Line_Break=--Numeric}', "");
    Expect(0, 130041, '\p{^Is_Line_Break=--Numeric}', "");
    Expect(0, 130041, '\P{Is_Line_Break=--Numeric}', "");
    Expect(1, 130041, '\P{^Is_Line_Break=--Numeric}', "");
    Expect(0, 130042, '\p{Is_Line_Break=--Numeric}', "");
    Expect(1, 130042, '\p{^Is_Line_Break=--Numeric}', "");
    Expect(1, 130042, '\P{Is_Line_Break=--Numeric}', "");
    Expect(0, 130042, '\P{^Is_Line_Break=--Numeric}', "");
    Error('\p{Is_Lb=_/a/NU}');
    Error('\P{Is_Lb=_/a/NU}');
    Expect(1, 130041, '\p{Is_Lb=nu}', "");
    Expect(0, 130041, '\p{^Is_Lb=nu}', "");
    Expect(0, 130041, '\P{Is_Lb=nu}', "");
    Expect(1, 130041, '\P{^Is_Lb=nu}', "");
    Expect(0, 130042, '\p{Is_Lb=nu}', "");
    Expect(1, 130042, '\p{^Is_Lb=nu}', "");
    Expect(1, 130042, '\P{Is_Lb=nu}', "");
    Expect(0, 130042, '\P{^Is_Lb=nu}', "");
    Expect(1, 130041, '\p{Is_Lb=	nu}', "");
    Expect(0, 130041, '\p{^Is_Lb=	nu}', "");
    Expect(0, 130041, '\P{Is_Lb=	nu}', "");
    Expect(1, 130041, '\P{^Is_Lb=	nu}', "");
    Expect(0, 130042, '\p{Is_Lb=	nu}', "");
    Expect(1, 130042, '\p{^Is_Lb=	nu}', "");
    Expect(1, 130042, '\P{Is_Lb=	nu}', "");
    Expect(0, 130042, '\P{^Is_Lb=	nu}', "");
    Error('\p{Line_Break=/a/  Open_PUNCTUATION}');
    Error('\P{Line_Break=/a/  Open_PUNCTUATION}');
    Expect(1, 125279, '\p{Line_Break=:\AOpen_Punctuation\z:}', "");;
    Expect(0, 125280, '\p{Line_Break=:\AOpen_Punctuation\z:}', "");;
    Expect(1, 125279, '\p{Line_Break=openpunctuation}', "");
    Expect(0, 125279, '\p{^Line_Break=openpunctuation}', "");
    Expect(0, 125279, '\P{Line_Break=openpunctuation}', "");
    Expect(1, 125279, '\P{^Line_Break=openpunctuation}', "");
    Expect(0, 125280, '\p{Line_Break=openpunctuation}', "");
    Expect(1, 125280, '\p{^Line_Break=openpunctuation}', "");
    Expect(1, 125280, '\P{Line_Break=openpunctuation}', "");
    Expect(0, 125280, '\P{^Line_Break=openpunctuation}', "");
    Expect(1, 125279, '\p{Line_Break=:\Aopenpunctuation\z:}', "");;
    Expect(0, 125280, '\p{Line_Break=:\Aopenpunctuation\z:}', "");;
    Expect(1, 125279, '\p{Line_Break=_-Open_punctuation}', "");
    Expect(0, 125279, '\p{^Line_Break=_-Open_punctuation}', "");
    Expect(0, 125279, '\P{Line_Break=_-Open_punctuation}', "");
    Expect(1, 125279, '\P{^Line_Break=_-Open_punctuation}', "");
    Expect(0, 125280, '\p{Line_Break=_-Open_punctuation}', "");
    Expect(1, 125280, '\p{^Line_Break=_-Open_punctuation}', "");
    Expect(1, 125280, '\P{Line_Break=_-Open_punctuation}', "");
    Expect(0, 125280, '\P{^Line_Break=_-Open_punctuation}', "");
    Error('\p{Lb= /a/op}');
    Error('\P{Lb= /a/op}');
    Expect(1, 125279, '\p{Lb=:\AOP\z:}', "");;
    Expect(0, 125280, '\p{Lb=:\AOP\z:}', "");;
    Expect(1, 125279, '\p{Lb: op}', "");
    Expect(0, 125279, '\p{^Lb: op}', "");
    Expect(0, 125279, '\P{Lb: op}', "");
    Expect(1, 125279, '\P{^Lb: op}', "");
    Expect(0, 125280, '\p{Lb: op}', "");
    Expect(1, 125280, '\p{^Lb: op}', "");
    Expect(1, 125280, '\P{Lb: op}', "");
    Expect(0, 125280, '\P{^Lb: op}', "");
    Expect(1, 125279, '\p{Lb=:\Aop\z:}', "");;
    Expect(0, 125280, '\p{Lb=:\Aop\z:}', "");;
    Expect(1, 125279, '\p{Lb=_op}', "");
    Expect(0, 125279, '\p{^Lb=_op}', "");
    Expect(0, 125279, '\P{Lb=_op}', "");
    Expect(1, 125279, '\P{^Lb=_op}', "");
    Expect(0, 125280, '\p{Lb=_op}', "");
    Expect(1, 125280, '\p{^Lb=_op}', "");
    Expect(1, 125280, '\P{Lb=_op}', "");
    Expect(0, 125280, '\P{^Lb=_op}', "");
    Error('\p{Is_Line_Break= 	Open_Punctuation:=}');
    Error('\P{Is_Line_Break= 	Open_Punctuation:=}');
    Expect(1, 125279, '\p{Is_Line_Break=openpunctuation}', "");
    Expect(0, 125279, '\p{^Is_Line_Break=openpunctuation}', "");
    Expect(0, 125279, '\P{Is_Line_Break=openpunctuation}', "");
    Expect(1, 125279, '\P{^Is_Line_Break=openpunctuation}', "");
    Expect(0, 125280, '\p{Is_Line_Break=openpunctuation}', "");
    Expect(1, 125280, '\p{^Is_Line_Break=openpunctuation}', "");
    Expect(1, 125280, '\P{Is_Line_Break=openpunctuation}', "");
    Expect(0, 125280, '\P{^Is_Line_Break=openpunctuation}', "");
    Expect(1, 125279, '\p{Is_Line_Break=_-Open_PUNCTUATION}', "");
    Expect(0, 125279, '\p{^Is_Line_Break=_-Open_PUNCTUATION}', "");
    Expect(0, 125279, '\P{Is_Line_Break=_-Open_PUNCTUATION}', "");
    Expect(1, 125279, '\P{^Is_Line_Break=_-Open_PUNCTUATION}', "");
    Expect(0, 125280, '\p{Is_Line_Break=_-Open_PUNCTUATION}', "");
    Expect(1, 125280, '\p{^Is_Line_Break=_-Open_PUNCTUATION}', "");
    Expect(1, 125280, '\P{Is_Line_Break=_-Open_PUNCTUATION}', "");
    Expect(0, 125280, '\P{^Is_Line_Break=_-Open_PUNCTUATION}', "");
    Error('\p{Is_Lb=-:=op}');
    Error('\P{Is_Lb=-:=op}');
    Expect(1, 125279, '\p{Is_Lb:op}', "");
    Expect(0, 125279, '\p{^Is_Lb:op}', "");
    Expect(0, 125279, '\P{Is_Lb:op}', "");
    Expect(1, 125279, '\P{^Is_Lb:op}', "");
    Expect(0, 125280, '\p{Is_Lb:op}', "");
    Expect(1, 125280, '\p{^Is_Lb:op}', "");
    Expect(1, 125280, '\P{Is_Lb:op}', "");
    Expect(0, 125280, '\P{^Is_Lb:op}', "");
    Expect(1, 125279, '\p{Is_Lb=__OP}', "");
    Expect(0, 125279, '\p{^Is_Lb=__OP}', "");
    Expect(0, 125279, '\P{Is_Lb=__OP}', "");
    Expect(1, 125279, '\P{^Is_Lb=__OP}', "");
    Expect(0, 125280, '\p{Is_Lb=__OP}', "");
    Expect(1, 125280, '\p{^Is_Lb=__OP}', "");
    Expect(1, 125280, '\P{Is_Lb=__OP}', "");
    Expect(0, 125280, '\P{^Is_Lb=__OP}', "");
    Error('\p{Line_Break=_	postfix_numeric:=}');
    Error('\P{Line_Break=_	postfix_numeric:=}');
    Expect(1, 126128, '\p{Line_Break=:\APostfix_Numeric\z:}', "");;
    Expect(0, 126129, '\p{Line_Break=:\APostfix_Numeric\z:}', "");;
    Expect(1, 126128, '\p{Line_Break=postfixnumeric}', "");
    Expect(0, 126128, '\p{^Line_Break=postfixnumeric}', "");
    Expect(0, 126128, '\P{Line_Break=postfixnumeric}', "");
    Expect(1, 126128, '\P{^Line_Break=postfixnumeric}', "");
    Expect(0, 126129, '\p{Line_Break=postfixnumeric}', "");
    Expect(1, 126129, '\p{^Line_Break=postfixnumeric}', "");
    Expect(1, 126129, '\P{Line_Break=postfixnumeric}', "");
    Expect(0, 126129, '\P{^Line_Break=postfixnumeric}', "");
    Expect(1, 126128, '\p{Line_Break=:\Apostfixnumeric\z:}', "");;
    Expect(0, 126129, '\p{Line_Break=:\Apostfixnumeric\z:}', "");;
    Expect(1, 126128, '\p{Line_Break=_ POSTFIX_Numeric}', "");
    Expect(0, 126128, '\p{^Line_Break=_ POSTFIX_Numeric}', "");
    Expect(0, 126128, '\P{Line_Break=_ POSTFIX_Numeric}', "");
    Expect(1, 126128, '\P{^Line_Break=_ POSTFIX_Numeric}', "");
    Expect(0, 126129, '\p{Line_Break=_ POSTFIX_Numeric}', "");
    Expect(1, 126129, '\p{^Line_Break=_ POSTFIX_Numeric}', "");
    Expect(1, 126129, '\P{Line_Break=_ POSTFIX_Numeric}', "");
    Expect(0, 126129, '\P{^Line_Break=_ POSTFIX_Numeric}', "");
    Error('\p{Lb=_	po:=}');
    Error('\P{Lb=_	po:=}');
    Expect(1, 126128, '\p{Lb=:\APO\z:}', "");;
    Expect(0, 126129, '\p{Lb=:\APO\z:}', "");;
    Expect(1, 126128, '\p{Lb=po}', "");
    Expect(0, 126128, '\p{^Lb=po}', "");
    Expect(0, 126128, '\P{Lb=po}', "");
    Expect(1, 126128, '\P{^Lb=po}', "");
    Expect(0, 126129, '\p{Lb=po}', "");
    Expect(1, 126129, '\p{^Lb=po}', "");
    Expect(1, 126129, '\P{Lb=po}', "");
    Expect(0, 126129, '\P{^Lb=po}', "");
    Expect(1, 126128, '\p{Lb=:\Apo\z:}', "");;
    Expect(0, 126129, '\p{Lb=:\Apo\z:}', "");;
    Expect(1, 126128, '\p{Lb=-_PO}', "");
    Expect(0, 126128, '\p{^Lb=-_PO}', "");
    Expect(0, 126128, '\P{Lb=-_PO}', "");
    Expect(1, 126128, '\P{^Lb=-_PO}', "");
    Expect(0, 126129, '\p{Lb=-_PO}', "");
    Expect(1, 126129, '\p{^Lb=-_PO}', "");
    Expect(1, 126129, '\P{Lb=-_PO}', "");
    Expect(0, 126129, '\P{^Lb=-_PO}', "");
    Error('\p{Is_Line_Break= _Postfix_Numeric:=}');
    Error('\P{Is_Line_Break= _Postfix_Numeric:=}');
    Expect(1, 126128, '\p{Is_Line_Break=postfixnumeric}', "");
    Expect(0, 126128, '\p{^Is_Line_Break=postfixnumeric}', "");
    Expect(0, 126128, '\P{Is_Line_Break=postfixnumeric}', "");
    Expect(1, 126128, '\P{^Is_Line_Break=postfixnumeric}', "");
    Expect(0, 126129, '\p{Is_Line_Break=postfixnumeric}', "");
    Expect(1, 126129, '\p{^Is_Line_Break=postfixnumeric}', "");
    Expect(1, 126129, '\P{Is_Line_Break=postfixnumeric}', "");
    Expect(0, 126129, '\P{^Is_Line_Break=postfixnumeric}', "");
    Expect(1, 126128, '\p{Is_Line_Break=_-Postfix_Numeric}', "");
    Expect(0, 126128, '\p{^Is_Line_Break=_-Postfix_Numeric}', "");
    Expect(0, 126128, '\P{Is_Line_Break=_-Postfix_Numeric}', "");
    Expect(1, 126128, '\P{^Is_Line_Break=_-Postfix_Numeric}', "");
    Expect(0, 126129, '\p{Is_Line_Break=_-Postfix_Numeric}', "");
    Expect(1, 126129, '\p{^Is_Line_Break=_-Postfix_Numeric}', "");
    Expect(1, 126129, '\P{Is_Line_Break=_-Postfix_Numeric}', "");
    Expect(0, 126129, '\P{^Is_Line_Break=_-Postfix_Numeric}', "");
    Error('\p{Is_Lb:_:=po}');
    Error('\P{Is_Lb:_:=po}');
    Expect(1, 126128, '\p{Is_Lb=po}', "");
    Expect(0, 126128, '\p{^Is_Lb=po}', "");
    Expect(0, 126128, '\P{Is_Lb=po}', "");
    Expect(1, 126128, '\P{^Is_Lb=po}', "");
    Expect(0, 126129, '\p{Is_Lb=po}', "");
    Expect(1, 126129, '\p{^Is_Lb=po}', "");
    Expect(1, 126129, '\P{Is_Lb=po}', "");
    Expect(0, 126129, '\P{^Is_Lb=po}', "");
    Expect(1, 126128, '\p{Is_Lb:_ PO}', "");
    Expect(0, 126128, '\p{^Is_Lb:_ PO}', "");
    Expect(0, 126128, '\P{Is_Lb:_ PO}', "");
    Expect(1, 126128, '\P{^Is_Lb:_ PO}', "");
    Expect(0, 126129, '\p{Is_Lb:_ PO}', "");
    Expect(1, 126129, '\p{^Is_Lb:_ PO}', "");
    Expect(1, 126129, '\P{Is_Lb:_ PO}', "");
    Expect(0, 126129, '\P{^Is_Lb:_ PO}', "");
    Error('\p{Line_Break=/a/Prefix_Numeric}');
    Error('\P{Line_Break=/a/Prefix_Numeric}');
    Expect(1, 123647, '\p{Line_Break=:\APrefix_Numeric\z:}', "");;
    Expect(0, 123648, '\p{Line_Break=:\APrefix_Numeric\z:}', "");;
    Expect(1, 123647, '\p{Line_Break=prefixnumeric}', "");
    Expect(0, 123647, '\p{^Line_Break=prefixnumeric}', "");
    Expect(0, 123647, '\P{Line_Break=prefixnumeric}', "");
    Expect(1, 123647, '\P{^Line_Break=prefixnumeric}', "");
    Expect(0, 123648, '\p{Line_Break=prefixnumeric}', "");
    Expect(1, 123648, '\p{^Line_Break=prefixnumeric}', "");
    Expect(1, 123648, '\P{Line_Break=prefixnumeric}', "");
    Expect(0, 123648, '\P{^Line_Break=prefixnumeric}', "");
    Expect(1, 123647, '\p{Line_Break=:\Aprefixnumeric\z:}', "");;
    Expect(0, 123648, '\p{Line_Break=:\Aprefixnumeric\z:}', "");;
    Expect(1, 123647, '\p{Line_Break: 	 prefix_NUMERIC}', "");
    Expect(0, 123647, '\p{^Line_Break: 	 prefix_NUMERIC}', "");
    Expect(0, 123647, '\P{Line_Break: 	 prefix_NUMERIC}', "");
    Expect(1, 123647, '\P{^Line_Break: 	 prefix_NUMERIC}', "");
    Expect(0, 123648, '\p{Line_Break: 	 prefix_NUMERIC}', "");
    Expect(1, 123648, '\p{^Line_Break: 	 prefix_NUMERIC}', "");
    Expect(1, 123648, '\P{Line_Break: 	 prefix_NUMERIC}', "");
    Expect(0, 123648, '\P{^Line_Break: 	 prefix_NUMERIC}', "");
    Error('\p{Lb=_:=PR}');
    Error('\P{Lb=_:=PR}');
    Expect(1, 123647, '\p{Lb=:\APR\z:}', "");;
    Expect(0, 123648, '\p{Lb=:\APR\z:}', "");;
    Expect(1, 123647, '\p{Lb=pr}', "");
    Expect(0, 123647, '\p{^Lb=pr}', "");
    Expect(0, 123647, '\P{Lb=pr}', "");
    Expect(1, 123647, '\P{^Lb=pr}', "");
    Expect(0, 123648, '\p{Lb=pr}', "");
    Expect(1, 123648, '\p{^Lb=pr}', "");
    Expect(1, 123648, '\P{Lb=pr}', "");
    Expect(0, 123648, '\P{^Lb=pr}', "");
    Expect(1, 123647, '\p{Lb=:\Apr\z:}', "");;
    Expect(0, 123648, '\p{Lb=:\Apr\z:}', "");;
    Expect(1, 123647, '\p{Lb=__PR}', "");
    Expect(0, 123647, '\p{^Lb=__PR}', "");
    Expect(0, 123647, '\P{Lb=__PR}', "");
    Expect(1, 123647, '\P{^Lb=__PR}', "");
    Expect(0, 123648, '\p{Lb=__PR}', "");
    Expect(1, 123648, '\p{^Lb=__PR}', "");
    Expect(1, 123648, '\P{Lb=__PR}', "");
    Expect(0, 123648, '\P{^Lb=__PR}', "");
    Error('\p{Is_Line_Break=__PREFIX_Numeric/a/}');
    Error('\P{Is_Line_Break=__PREFIX_Numeric/a/}');
    Expect(1, 123647, '\p{Is_Line_Break=prefixnumeric}', "");
    Expect(0, 123647, '\p{^Is_Line_Break=prefixnumeric}', "");
    Expect(0, 123647, '\P{Is_Line_Break=prefixnumeric}', "");
    Expect(1, 123647, '\P{^Is_Line_Break=prefixnumeric}', "");
    Expect(0, 123648, '\p{Is_Line_Break=prefixnumeric}', "");
    Expect(1, 123648, '\p{^Is_Line_Break=prefixnumeric}', "");
    Expect(1, 123648, '\P{Is_Line_Break=prefixnumeric}', "");
    Expect(0, 123648, '\P{^Is_Line_Break=prefixnumeric}', "");
    Expect(1, 123647, '\p{Is_Line_Break:	-PREFIX_NUMERIC}', "");
    Expect(0, 123647, '\p{^Is_Line_Break:	-PREFIX_NUMERIC}', "");
    Expect(0, 123647, '\P{Is_Line_Break:	-PREFIX_NUMERIC}', "");
    Expect(1, 123647, '\P{^Is_Line_Break:	-PREFIX_NUMERIC}', "");
    Expect(0, 123648, '\p{Is_Line_Break:	-PREFIX_NUMERIC}', "");
    Expect(1, 123648, '\p{^Is_Line_Break:	-PREFIX_NUMERIC}', "");
    Expect(1, 123648, '\P{Is_Line_Break:	-PREFIX_NUMERIC}', "");
    Expect(0, 123648, '\P{^Is_Line_Break:	-PREFIX_NUMERIC}', "");
    Error('\p{Is_Lb:    :=PR}');
    Error('\P{Is_Lb:    :=PR}');
    Expect(1, 123647, '\p{Is_Lb=pr}', "");
    Expect(0, 123647, '\p{^Is_Lb=pr}', "");
    Expect(0, 123647, '\P{Is_Lb=pr}', "");
    Expect(1, 123647, '\P{^Is_Lb=pr}', "");
    Expect(0, 123648, '\p{Is_Lb=pr}', "");
    Expect(1, 123648, '\p{^Is_Lb=pr}', "");
    Expect(1, 123648, '\P{Is_Lb=pr}', "");
    Expect(0, 123648, '\P{^Is_Lb=pr}', "");
    Expect(1, 123647, '\p{Is_Lb=-_PR}', "");
    Expect(0, 123647, '\p{^Is_Lb=-_PR}', "");
    Expect(0, 123647, '\P{Is_Lb=-_PR}', "");
    Expect(1, 123647, '\P{^Is_Lb=-_PR}', "");
    Expect(0, 123648, '\p{Is_Lb=-_PR}', "");
    Expect(1, 123648, '\p{^Is_Lb=-_PR}', "");
    Expect(1, 123648, '\P{Is_Lb=-_PR}', "");
    Expect(0, 123648, '\P{^Is_Lb=-_PR}', "");
    Error('\p{Line_Break=/a/	QUOTATION}');
    Error('\P{Line_Break=/a/	QUOTATION}');
    Expect(1, 128632, '\p{Line_Break=:\AQuotation\z:}', "");;
    Expect(0, 128633, '\p{Line_Break=:\AQuotation\z:}', "");;
    Expect(1, 128632, '\p{Line_Break=quotation}', "");
    Expect(0, 128632, '\p{^Line_Break=quotation}', "");
    Expect(0, 128632, '\P{Line_Break=quotation}', "");
    Expect(1, 128632, '\P{^Line_Break=quotation}', "");
    Expect(0, 128633, '\p{Line_Break=quotation}', "");
    Expect(1, 128633, '\p{^Line_Break=quotation}', "");
    Expect(1, 128633, '\P{Line_Break=quotation}', "");
    Expect(0, 128633, '\P{^Line_Break=quotation}', "");
    Expect(1, 128632, '\p{Line_Break=:\Aquotation\z:}', "");;
    Expect(0, 128633, '\p{Line_Break=:\Aquotation\z:}', "");;
    Expect(1, 128632, '\p{Line_Break=	_Quotation}', "");
    Expect(0, 128632, '\p{^Line_Break=	_Quotation}', "");
    Expect(0, 128632, '\P{Line_Break=	_Quotation}', "");
    Expect(1, 128632, '\P{^Line_Break=	_Quotation}', "");
    Expect(0, 128633, '\p{Line_Break=	_Quotation}', "");
    Expect(1, 128633, '\p{^Line_Break=	_Quotation}', "");
    Expect(1, 128633, '\P{Line_Break=	_Quotation}', "");
    Expect(0, 128633, '\P{^Line_Break=	_Quotation}', "");
    Error('\p{Lb=_QU/a/}');
    Error('\P{Lb=_QU/a/}');
    Expect(1, 128632, '\p{Lb=:\AQU\z:}', "");;
    Expect(0, 128633, '\p{Lb=:\AQU\z:}', "");;
    Expect(1, 128632, '\p{Lb:   qu}', "");
    Expect(0, 128632, '\p{^Lb:   qu}', "");
    Expect(0, 128632, '\P{Lb:   qu}', "");
    Expect(1, 128632, '\P{^Lb:   qu}', "");
    Expect(0, 128633, '\p{Lb:   qu}', "");
    Expect(1, 128633, '\p{^Lb:   qu}', "");
    Expect(1, 128633, '\P{Lb:   qu}', "");
    Expect(0, 128633, '\P{^Lb:   qu}', "");
    Expect(1, 128632, '\p{Lb=:\Aqu\z:}', "");;
    Expect(0, 128633, '\p{Lb=:\Aqu\z:}', "");;
    Expect(1, 128632, '\p{Lb=-_QU}', "");
    Expect(0, 128632, '\p{^Lb=-_QU}', "");
    Expect(0, 128632, '\P{Lb=-_QU}', "");
    Expect(1, 128632, '\P{^Lb=-_QU}', "");
    Expect(0, 128633, '\p{Lb=-_QU}', "");
    Expect(1, 128633, '\p{^Lb=-_QU}', "");
    Expect(1, 128633, '\P{Lb=-_QU}', "");
    Expect(0, 128633, '\P{^Lb=-_QU}', "");
    Error('\p{Is_Line_Break=	:=Quotation}');
    Error('\P{Is_Line_Break=	:=Quotation}');
    Expect(1, 128632, '\p{Is_Line_Break=quotation}', "");
    Expect(0, 128632, '\p{^Is_Line_Break=quotation}', "");
    Expect(0, 128632, '\P{Is_Line_Break=quotation}', "");
    Expect(1, 128632, '\P{^Is_Line_Break=quotation}', "");
    Expect(0, 128633, '\p{Is_Line_Break=quotation}', "");
    Expect(1, 128633, '\p{^Is_Line_Break=quotation}', "");
    Expect(1, 128633, '\P{Is_Line_Break=quotation}', "");
    Expect(0, 128633, '\P{^Is_Line_Break=quotation}', "");
    Expect(1, 128632, '\p{Is_Line_Break= _Quotation}', "");
    Expect(0, 128632, '\p{^Is_Line_Break= _Quotation}', "");
    Expect(0, 128632, '\P{Is_Line_Break= _Quotation}', "");
    Expect(1, 128632, '\P{^Is_Line_Break= _Quotation}', "");
    Expect(0, 128633, '\p{Is_Line_Break= _Quotation}', "");
    Expect(1, 128633, '\p{^Is_Line_Break= _Quotation}', "");
    Expect(1, 128633, '\P{Is_Line_Break= _Quotation}', "");
    Expect(0, 128633, '\P{^Is_Line_Break= _Quotation}', "");
    Error('\p{Is_Lb=/a/QU}');
    Error('\P{Is_Lb=/a/QU}');
    Expect(1, 128632, '\p{Is_Lb=qu}', "");
    Expect(0, 128632, '\p{^Is_Lb=qu}', "");
    Expect(0, 128632, '\P{Is_Lb=qu}', "");
    Expect(1, 128632, '\P{^Is_Lb=qu}', "");
    Expect(0, 128633, '\p{Is_Lb=qu}', "");
    Expect(1, 128633, '\p{^Is_Lb=qu}', "");
    Expect(1, 128633, '\P{Is_Lb=qu}', "");
    Expect(0, 128633, '\P{^Is_Lb=qu}', "");
    Expect(1, 128632, '\p{Is_Lb:__qu}', "");
    Expect(0, 128632, '\p{^Is_Lb:__qu}', "");
    Expect(0, 128632, '\P{Is_Lb:__qu}', "");
    Expect(1, 128632, '\P{^Is_Lb:__qu}', "");
    Expect(0, 128633, '\p{Is_Lb:__qu}', "");
    Expect(1, 128633, '\p{^Is_Lb:__qu}', "");
    Expect(1, 128633, '\P{Is_Lb:__qu}', "");
    Expect(0, 128633, '\P{^Is_Lb:__qu}', "");
    Error('\p{Line_Break=/a/	Regional_Indicator}');
    Error('\P{Line_Break=/a/	Regional_Indicator}');
    Expect(1, 127487, '\p{Line_Break=:\ARegional_Indicator\z:}', "");;
    Expect(0, 127488, '\p{Line_Break=:\ARegional_Indicator\z:}', "");;
    Expect(1, 127487, '\p{Line_Break=regionalindicator}', "");
    Expect(0, 127487, '\p{^Line_Break=regionalindicator}', "");
    Expect(0, 127487, '\P{Line_Break=regionalindicator}', "");
    Expect(1, 127487, '\P{^Line_Break=regionalindicator}', "");
    Expect(0, 127488, '\p{Line_Break=regionalindicator}', "");
    Expect(1, 127488, '\p{^Line_Break=regionalindicator}', "");
    Expect(1, 127488, '\P{Line_Break=regionalindicator}', "");
    Expect(0, 127488, '\P{^Line_Break=regionalindicator}', "");
    Expect(1, 127487, '\p{Line_Break=:\Aregionalindicator\z:}', "");;
    Expect(0, 127488, '\p{Line_Break=:\Aregionalindicator\z:}', "");;
    Expect(1, 127487, '\p{Line_Break=	-regional_INDICATOR}', "");
    Expect(0, 127487, '\p{^Line_Break=	-regional_INDICATOR}', "");
    Expect(0, 127487, '\P{Line_Break=	-regional_INDICATOR}', "");
    Expect(1, 127487, '\P{^Line_Break=	-regional_INDICATOR}', "");
    Expect(0, 127488, '\p{Line_Break=	-regional_INDICATOR}', "");
    Expect(1, 127488, '\p{^Line_Break=	-regional_INDICATOR}', "");
    Expect(1, 127488, '\P{Line_Break=	-regional_INDICATOR}', "");
    Expect(0, 127488, '\P{^Line_Break=	-regional_INDICATOR}', "");
    Error('\p{Lb= RI/a/}');
    Error('\P{Lb= RI/a/}');
    Expect(1, 127487, '\p{Lb=:\ARI\z:}', "");;
    Expect(0, 127488, '\p{Lb=:\ARI\z:}', "");;
    Expect(1, 127487, '\p{Lb=ri}', "");
    Expect(0, 127487, '\p{^Lb=ri}', "");
    Expect(0, 127487, '\P{Lb=ri}', "");
    Expect(1, 127487, '\P{^Lb=ri}', "");
    Expect(0, 127488, '\p{Lb=ri}', "");
    Expect(1, 127488, '\p{^Lb=ri}', "");
    Expect(1, 127488, '\P{Lb=ri}', "");
    Expect(0, 127488, '\P{^Lb=ri}', "");
    Expect(1, 127487, '\p{Lb=:\Ari\z:}', "");;
    Expect(0, 127488, '\p{Lb=:\Ari\z:}', "");;
    Expect(1, 127487, '\p{Lb= _RI}', "");
    Expect(0, 127487, '\p{^Lb= _RI}', "");
    Expect(0, 127487, '\P{Lb= _RI}', "");
    Expect(1, 127487, '\P{^Lb= _RI}', "");
    Expect(0, 127488, '\p{Lb= _RI}', "");
    Expect(1, 127488, '\p{^Lb= _RI}', "");
    Expect(1, 127488, '\P{Lb= _RI}', "");
    Expect(0, 127488, '\P{^Lb= _RI}', "");
    Error('\p{Is_Line_Break=	/a/regional_Indicator}');
    Error('\P{Is_Line_Break=	/a/regional_Indicator}');
    Expect(1, 127487, '\p{Is_Line_Break=regionalindicator}', "");
    Expect(0, 127487, '\p{^Is_Line_Break=regionalindicator}', "");
    Expect(0, 127487, '\P{Is_Line_Break=regionalindicator}', "");
    Expect(1, 127487, '\P{^Is_Line_Break=regionalindicator}', "");
    Expect(0, 127488, '\p{Is_Line_Break=regionalindicator}', "");
    Expect(1, 127488, '\p{^Is_Line_Break=regionalindicator}', "");
    Expect(1, 127488, '\P{Is_Line_Break=regionalindicator}', "");
    Expect(0, 127488, '\P{^Is_Line_Break=regionalindicator}', "");
    Expect(1, 127487, '\p{Is_Line_Break=--regional_indicator}', "");
    Expect(0, 127487, '\p{^Is_Line_Break=--regional_indicator}', "");
    Expect(0, 127487, '\P{Is_Line_Break=--regional_indicator}', "");
    Expect(1, 127487, '\P{^Is_Line_Break=--regional_indicator}', "");
    Expect(0, 127488, '\p{Is_Line_Break=--regional_indicator}', "");
    Expect(1, 127488, '\p{^Is_Line_Break=--regional_indicator}', "");
    Expect(1, 127488, '\P{Is_Line_Break=--regional_indicator}', "");
    Expect(0, 127488, '\P{^Is_Line_Break=--regional_indicator}', "");
    Error('\p{Is_Lb=:=_ri}');
    Error('\P{Is_Lb=:=_ri}');
    Expect(1, 127487, '\p{Is_Lb=ri}', "");
    Expect(0, 127487, '\p{^Is_Lb=ri}', "");
    Expect(0, 127487, '\P{Is_Lb=ri}', "");
    Expect(1, 127487, '\P{^Is_Lb=ri}', "");
    Expect(0, 127488, '\p{Is_Lb=ri}', "");
    Expect(1, 127488, '\p{^Is_Lb=ri}', "");
    Expect(1, 127488, '\P{Is_Lb=ri}', "");
    Expect(0, 127488, '\P{^Is_Lb=ri}', "");
    Expect(1, 127487, '\p{Is_Lb= 	RI}', "");
    Expect(0, 127487, '\p{^Is_Lb= 	RI}', "");
    Expect(0, 127487, '\P{Is_Lb= 	RI}', "");
    Expect(1, 127487, '\P{^Is_Lb= 	RI}', "");
    Expect(0, 127488, '\p{Is_Lb= 	RI}', "");
    Expect(1, 127488, '\p{^Is_Lb= 	RI}', "");
    Expect(1, 127488, '\P{Is_Lb= 	RI}', "");
    Expect(0, 127488, '\P{^Is_Lb= 	RI}', "");
    Error('\p{Line_Break=/a/complex_context}');
    Error('\P{Line_Break=/a/complex_context}');
    Expect(1, 71494, '\p{Line_Break=:\AComplex_Context\z:}', "");;
    Expect(0, 71495, '\p{Line_Break=:\AComplex_Context\z:}', "");;
    Expect(1, 71494, '\p{Line_Break=complexcontext}', "");
    Expect(0, 71494, '\p{^Line_Break=complexcontext}', "");
    Expect(0, 71494, '\P{Line_Break=complexcontext}', "");
    Expect(1, 71494, '\P{^Line_Break=complexcontext}', "");
    Expect(0, 71495, '\p{Line_Break=complexcontext}', "");
    Expect(1, 71495, '\p{^Line_Break=complexcontext}', "");
    Expect(1, 71495, '\P{Line_Break=complexcontext}', "");
    Expect(0, 71495, '\P{^Line_Break=complexcontext}', "");
    Expect(1, 71494, '\p{Line_Break=:\Acomplexcontext\z:}', "");;
    Expect(0, 71495, '\p{Line_Break=:\Acomplexcontext\z:}', "");;
    Expect(1, 71494, '\p{Line_Break=__complex_Context}', "");
    Expect(0, 71494, '\p{^Line_Break=__complex_Context}', "");
    Expect(0, 71494, '\P{Line_Break=__complex_Context}', "");
    Expect(1, 71494, '\P{^Line_Break=__complex_Context}', "");
    Expect(0, 71495, '\p{Line_Break=__complex_Context}', "");
    Expect(1, 71495, '\p{^Line_Break=__complex_Context}', "");
    Expect(1, 71495, '\P{Line_Break=__complex_Context}', "");
    Expect(0, 71495, '\P{^Line_Break=__complex_Context}', "");
    Error('\p{Lb=:= 	sa}');
    Error('\P{Lb=:= 	sa}');
    Expect(1, 71494, '\p{Lb=:\ASA\z:}', "");;
    Expect(0, 71495, '\p{Lb=:\ASA\z:}', "");;
    Expect(1, 71494, '\p{Lb=sa}', "");
    Expect(0, 71494, '\p{^Lb=sa}', "");
    Expect(0, 71494, '\P{Lb=sa}', "");
    Expect(1, 71494, '\P{^Lb=sa}', "");
    Expect(0, 71495, '\p{Lb=sa}', "");
    Expect(1, 71495, '\p{^Lb=sa}', "");
    Expect(1, 71495, '\P{Lb=sa}', "");
    Expect(0, 71495, '\P{^Lb=sa}', "");
    Expect(1, 71494, '\p{Lb=:\Asa\z:}', "");;
    Expect(0, 71495, '\p{Lb=:\Asa\z:}', "");;
    Expect(1, 71494, '\p{Lb=_	SA}', "");
    Expect(0, 71494, '\p{^Lb=_	SA}', "");
    Expect(0, 71494, '\P{Lb=_	SA}', "");
    Expect(1, 71494, '\P{^Lb=_	SA}', "");
    Expect(0, 71495, '\p{Lb=_	SA}', "");
    Expect(1, 71495, '\p{^Lb=_	SA}', "");
    Expect(1, 71495, '\P{Lb=_	SA}', "");
    Expect(0, 71495, '\P{^Lb=_	SA}', "");
    Error('\p{Is_Line_Break= :=Complex_Context}');
    Error('\P{Is_Line_Break= :=Complex_Context}');
    Expect(1, 71494, '\p{Is_Line_Break=complexcontext}', "");
    Expect(0, 71494, '\p{^Is_Line_Break=complexcontext}', "");
    Expect(0, 71494, '\P{Is_Line_Break=complexcontext}', "");
    Expect(1, 71494, '\P{^Is_Line_Break=complexcontext}', "");
    Expect(0, 71495, '\p{Is_Line_Break=complexcontext}', "");
    Expect(1, 71495, '\p{^Is_Line_Break=complexcontext}', "");
    Expect(1, 71495, '\P{Is_Line_Break=complexcontext}', "");
    Expect(0, 71495, '\P{^Is_Line_Break=complexcontext}', "");
    Expect(1, 71494, '\p{Is_Line_Break= COMPLEX_context}', "");
    Expect(0, 71494, '\p{^Is_Line_Break= COMPLEX_context}', "");
    Expect(0, 71494, '\P{Is_Line_Break= COMPLEX_context}', "");
    Expect(1, 71494, '\P{^Is_Line_Break= COMPLEX_context}', "");
    Expect(0, 71495, '\p{Is_Line_Break= COMPLEX_context}', "");
    Expect(1, 71495, '\p{^Is_Line_Break= COMPLEX_context}', "");
    Expect(1, 71495, '\P{Is_Line_Break= COMPLEX_context}', "");
    Expect(0, 71495, '\P{^Is_Line_Break= COMPLEX_context}', "");
    Error('\p{Is_Lb=/a/SA}');
    Error('\P{Is_Lb=/a/SA}');
    Expect(1, 71494, '\p{Is_Lb=sa}', "");
    Expect(0, 71494, '\p{^Is_Lb=sa}', "");
    Expect(0, 71494, '\P{Is_Lb=sa}', "");
    Expect(1, 71494, '\P{^Is_Lb=sa}', "");
    Expect(0, 71495, '\p{Is_Lb=sa}', "");
    Expect(1, 71495, '\p{^Is_Lb=sa}', "");
    Expect(1, 71495, '\P{Is_Lb=sa}', "");
    Expect(0, 71495, '\P{^Is_Lb=sa}', "");
    Expect(1, 71494, '\p{Is_Lb:	--SA}', "");
    Expect(0, 71494, '\p{^Is_Lb:	--SA}', "");
    Expect(0, 71494, '\P{Is_Lb:	--SA}', "");
    Expect(1, 71494, '\P{^Is_Lb:	--SA}', "");
    Expect(0, 71495, '\p{Is_Lb:	--SA}', "");
    Expect(1, 71495, '\p{^Is_Lb:	--SA}', "");
    Expect(1, 71495, '\P{Is_Lb:	--SA}', "");
    Expect(0, 71495, '\P{^Is_Lb:	--SA}', "");
    Error('\p{Line_Break=/a/_Surrogate}');
    Error('\P{Line_Break=/a/_Surrogate}');
    Expect(1, 57343, '\p{Line_Break=surrogate}', 'deprecated');
    Expect(0, 57343, '\p{^Line_Break=surrogate}', 'deprecated');
    Expect(0, 57343, '\P{Line_Break=surrogate}', 'deprecated');
    Expect(1, 57343, '\P{^Line_Break=surrogate}', 'deprecated');
    Expect(0, 57344, '\p{Line_Break=surrogate}', 'deprecated');
    Expect(1, 57344, '\p{^Line_Break=surrogate}', 'deprecated');
    Expect(1, 57344, '\P{Line_Break=surrogate}', 'deprecated');
    Expect(0, 57344, '\P{^Line_Break=surrogate}', 'deprecated');
    Expect(1, 57343, '\p{Line_Break:     surrogate}', 'deprecated');
    Expect(0, 57343, '\p{^Line_Break:     surrogate}', 'deprecated');
    Expect(0, 57343, '\P{Line_Break:     surrogate}', 'deprecated');
    Expect(1, 57343, '\P{^Line_Break:     surrogate}', 'deprecated');
    Expect(0, 57344, '\p{Line_Break:     surrogate}', 'deprecated');
    Expect(1, 57344, '\p{^Line_Break:     surrogate}', 'deprecated');
    Expect(1, 57344, '\P{Line_Break:     surrogate}', 'deprecated');
    Expect(0, 57344, '\P{^Line_Break:     surrogate}', 'deprecated');
    Error('\p{Lb=	_SG/a/}');
    Error('\P{Lb=	_SG/a/}');
    Expect(1, 57343, '\p{Lb=sg}', 'deprecated');
    Expect(0, 57343, '\p{^Lb=sg}', 'deprecated');
    Expect(0, 57343, '\P{Lb=sg}', 'deprecated');
    Expect(1, 57343, '\P{^Lb=sg}', 'deprecated');
    Expect(0, 57344, '\p{Lb=sg}', 'deprecated');
    Expect(1, 57344, '\p{^Lb=sg}', 'deprecated');
    Expect(1, 57344, '\P{Lb=sg}', 'deprecated');
    Expect(0, 57344, '\P{^Lb=sg}', 'deprecated');
    Expect(1, 57343, '\p{Lb= _SG}', 'deprecated');
    Expect(0, 57343, '\p{^Lb= _SG}', 'deprecated');
    Expect(0, 57343, '\P{Lb= _SG}', 'deprecated');
    Expect(1, 57343, '\P{^Lb= _SG}', 'deprecated');
    Expect(0, 57344, '\p{Lb= _SG}', 'deprecated');
    Expect(1, 57344, '\p{^Lb= _SG}', 'deprecated');
    Expect(1, 57344, '\P{Lb= _SG}', 'deprecated');
    Expect(0, 57344, '\P{^Lb= _SG}', 'deprecated');
    Error('\p{Is_Line_Break= Surrogate/a/}');
    Error('\P{Is_Line_Break= Surrogate/a/}');
    Expect(1, 57343, '\p{Is_Line_Break=surrogate}', 'deprecated');
    Expect(0, 57343, '\p{^Is_Line_Break=surrogate}', 'deprecated');
    Expect(0, 57343, '\P{Is_Line_Break=surrogate}', 'deprecated');
    Expect(1, 57343, '\P{^Is_Line_Break=surrogate}', 'deprecated');
    Expect(0, 57344, '\p{Is_Line_Break=surrogate}', 'deprecated');
    Expect(1, 57344, '\p{^Is_Line_Break=surrogate}', 'deprecated');
    Expect(1, 57344, '\P{Is_Line_Break=surrogate}', 'deprecated');
    Expect(0, 57344, '\P{^Is_Line_Break=surrogate}', 'deprecated');
    Expect(1, 57343, '\p{Is_Line_Break=-Surrogate}', 'deprecated');
    Expect(0, 57343, '\p{^Is_Line_Break=-Surrogate}', 'deprecated');
    Expect(0, 57343, '\P{Is_Line_Break=-Surrogate}', 'deprecated');
    Expect(1, 57343, '\P{^Is_Line_Break=-Surrogate}', 'deprecated');
    Expect(0, 57344, '\p{Is_Line_Break=-Surrogate}', 'deprecated');
    Expect(1, 57344, '\p{^Is_Line_Break=-Surrogate}', 'deprecated');
    Expect(1, 57344, '\P{Is_Line_Break=-Surrogate}', 'deprecated');
    Expect(0, 57344, '\P{^Is_Line_Break=-Surrogate}', 'deprecated');
    Error('\p{Is_Lb=_:=SG}');
    Error('\P{Is_Lb=_:=SG}');
    Expect(1, 57343, '\p{Is_Lb=sg}', 'deprecated');
    Expect(0, 57343, '\p{^Is_Lb=sg}', 'deprecated');
    Expect(0, 57343, '\P{Is_Lb=sg}', 'deprecated');
    Expect(1, 57343, '\P{^Is_Lb=sg}', 'deprecated');
    Expect(0, 57344, '\p{Is_Lb=sg}', 'deprecated');
    Expect(1, 57344, '\p{^Is_Lb=sg}', 'deprecated');
    Expect(1, 57344, '\P{Is_Lb=sg}', 'deprecated');
    Expect(0, 57344, '\P{^Is_Lb=sg}', 'deprecated');
    Expect(1, 57343, '\p{Is_Lb=	_SG}', 'deprecated');
    Expect(0, 57343, '\p{^Is_Lb=	_SG}', 'deprecated');
    Expect(0, 57343, '\P{Is_Lb=	_SG}', 'deprecated');
    Expect(1, 57343, '\P{^Is_Lb=	_SG}', 'deprecated');
    Expect(0, 57344, '\p{Is_Lb=	_SG}', 'deprecated');
    Expect(1, 57344, '\p{^Is_Lb=	_SG}', 'deprecated');
    Expect(1, 57344, '\P{Is_Lb=	_SG}', 'deprecated');
    Expect(0, 57344, '\P{^Is_Lb=	_SG}', 'deprecated');
    Error('\p{Line_Break= :=Space}');
    Error('\P{Line_Break= :=Space}');
    Expect(1, 32, '\p{Line_Break=:\ASpace\z:}', "");;
    Expect(0, 33, '\p{Line_Break=:\ASpace\z:}', "");;
    Expect(1, 32, '\p{Line_Break=space}', "");
    Expect(0, 32, '\p{^Line_Break=space}', "");
    Expect(0, 32, '\P{Line_Break=space}', "");
    Expect(1, 32, '\P{^Line_Break=space}', "");
    Expect(0, 33, '\p{Line_Break=space}', "");
    Expect(1, 33, '\p{^Line_Break=space}', "");
    Expect(1, 33, '\P{Line_Break=space}', "");
    Expect(0, 33, '\P{^Line_Break=space}', "");
    Expect(1, 32, '\p{Line_Break=:\Aspace\z:}', "");;
    Expect(0, 33, '\p{Line_Break=:\Aspace\z:}', "");;
    Expect(1, 32, '\p{Line_Break=__space}', "");
    Expect(0, 32, '\p{^Line_Break=__space}', "");
    Expect(0, 32, '\P{Line_Break=__space}', "");
    Expect(1, 32, '\P{^Line_Break=__space}', "");
    Expect(0, 33, '\p{Line_Break=__space}', "");
    Expect(1, 33, '\p{^Line_Break=__space}', "");
    Expect(1, 33, '\P{Line_Break=__space}', "");
    Expect(0, 33, '\P{^Line_Break=__space}', "");
    Error('\p{Lb=:=sp}');
    Error('\P{Lb=:=sp}');
    Expect(1, 32, '\p{Lb=:\ASP\z:}', "");;
    Expect(0, 33, '\p{Lb=:\ASP\z:}', "");;
    Expect(1, 32, '\p{Lb=sp}', "");
    Expect(0, 32, '\p{^Lb=sp}', "");
    Expect(0, 32, '\P{Lb=sp}', "");
    Expect(1, 32, '\P{^Lb=sp}', "");
    Expect(0, 33, '\p{Lb=sp}', "");
    Expect(1, 33, '\p{^Lb=sp}', "");
    Expect(1, 33, '\P{Lb=sp}', "");
    Expect(0, 33, '\P{^Lb=sp}', "");
    Expect(1, 32, '\p{Lb=:\Asp\z:}', "");;
    Expect(0, 33, '\p{Lb=:\Asp\z:}', "");;
    Expect(1, 32, '\p{Lb:-sp}', "");
    Expect(0, 32, '\p{^Lb:-sp}', "");
    Expect(0, 32, '\P{Lb:-sp}', "");
    Expect(1, 32, '\P{^Lb:-sp}', "");
    Expect(0, 33, '\p{Lb:-sp}', "");
    Expect(1, 33, '\p{^Lb:-sp}', "");
    Expect(1, 33, '\P{Lb:-sp}', "");
    Expect(0, 33, '\P{^Lb:-sp}', "");
    Error('\p{Is_Line_Break=_/a/Space}');
    Error('\P{Is_Line_Break=_/a/Space}');
    Expect(1, 32, '\p{Is_Line_Break=space}', "");
    Expect(0, 32, '\p{^Is_Line_Break=space}', "");
    Expect(0, 32, '\P{Is_Line_Break=space}', "");
    Expect(1, 32, '\P{^Is_Line_Break=space}', "");
    Expect(0, 33, '\p{Is_Line_Break=space}', "");
    Expect(1, 33, '\p{^Is_Line_Break=space}', "");
    Expect(1, 33, '\P{Is_Line_Break=space}', "");
    Expect(0, 33, '\P{^Is_Line_Break=space}', "");
    Expect(1, 32, '\p{Is_Line_Break=	-Space}', "");
    Expect(0, 32, '\p{^Is_Line_Break=	-Space}', "");
    Expect(0, 32, '\P{Is_Line_Break=	-Space}', "");
    Expect(1, 32, '\P{^Is_Line_Break=	-Space}', "");
    Expect(0, 33, '\p{Is_Line_Break=	-Space}', "");
    Expect(1, 33, '\p{^Is_Line_Break=	-Space}', "");
    Expect(1, 33, '\P{Is_Line_Break=	-Space}', "");
    Expect(0, 33, '\P{^Is_Line_Break=	-Space}', "");
    Error('\p{Is_Lb=:=  SP}');
    Error('\P{Is_Lb=:=  SP}');
    Expect(1, 32, '\p{Is_Lb=sp}', "");
    Expect(0, 32, '\p{^Is_Lb=sp}', "");
    Expect(0, 32, '\P{Is_Lb=sp}', "");
    Expect(1, 32, '\P{^Is_Lb=sp}', "");
    Expect(0, 33, '\p{Is_Lb=sp}', "");
    Expect(1, 33, '\p{^Is_Lb=sp}', "");
    Expect(1, 33, '\P{Is_Lb=sp}', "");
    Expect(0, 33, '\P{^Is_Lb=sp}', "");
    Expect(1, 32, '\p{Is_Lb= SP}', "");
    Expect(0, 32, '\p{^Is_Lb= SP}', "");
    Expect(0, 32, '\P{Is_Lb= SP}', "");
    Expect(1, 32, '\P{^Is_Lb= SP}', "");
    Expect(0, 33, '\p{Is_Lb= SP}', "");
    Expect(1, 33, '\p{^Is_Lb= SP}', "");
    Expect(1, 33, '\P{Is_Lb= SP}', "");
    Expect(0, 33, '\P{^Is_Lb= SP}', "");
    Error('\p{Line_Break=	-Break_SYMBOLS:=}');
    Error('\P{Line_Break=	-Break_SYMBOLS:=}');
    Expect(1, 47, '\p{Line_Break=:\ABreak_Symbols\z:}', "");;
    Expect(0, 48, '\p{Line_Break=:\ABreak_Symbols\z:}', "");;
    Expect(1, 47, '\p{Line_Break=breaksymbols}', "");
    Expect(0, 47, '\p{^Line_Break=breaksymbols}', "");
    Expect(0, 47, '\P{Line_Break=breaksymbols}', "");
    Expect(1, 47, '\P{^Line_Break=breaksymbols}', "");
    Expect(0, 48, '\p{Line_Break=breaksymbols}', "");
    Expect(1, 48, '\p{^Line_Break=breaksymbols}', "");
    Expect(1, 48, '\P{Line_Break=breaksymbols}', "");
    Expect(0, 48, '\P{^Line_Break=breaksymbols}', "");
    Expect(1, 47, '\p{Line_Break=:\Abreaksymbols\z:}', "");;
    Expect(0, 48, '\p{Line_Break=:\Abreaksymbols\z:}', "");;
    Expect(1, 47, '\p{Line_Break: -Break_Symbols}', "");
    Expect(0, 47, '\p{^Line_Break: -Break_Symbols}', "");
    Expect(0, 47, '\P{Line_Break: -Break_Symbols}', "");
    Expect(1, 47, '\P{^Line_Break: -Break_Symbols}', "");
    Expect(0, 48, '\p{Line_Break: -Break_Symbols}', "");
    Expect(1, 48, '\p{^Line_Break: -Break_Symbols}', "");
    Expect(1, 48, '\P{Line_Break: -Break_Symbols}', "");
    Expect(0, 48, '\P{^Line_Break: -Break_Symbols}', "");
    Error('\p{Lb:-	SY/a/}');
    Error('\P{Lb:-	SY/a/}');
    Expect(1, 47, '\p{Lb=:\ASY\z:}', "");;
    Expect(0, 48, '\p{Lb=:\ASY\z:}', "");;
    Expect(1, 47, '\p{Lb=sy}', "");
    Expect(0, 47, '\p{^Lb=sy}', "");
    Expect(0, 47, '\P{Lb=sy}', "");
    Expect(1, 47, '\P{^Lb=sy}', "");
    Expect(0, 48, '\p{Lb=sy}', "");
    Expect(1, 48, '\p{^Lb=sy}', "");
    Expect(1, 48, '\P{Lb=sy}', "");
    Expect(0, 48, '\P{^Lb=sy}', "");
    Expect(1, 47, '\p{Lb=:\Asy\z:}', "");;
    Expect(0, 48, '\p{Lb=:\Asy\z:}', "");;
    Expect(1, 47, '\p{Lb=--SY}', "");
    Expect(0, 47, '\p{^Lb=--SY}', "");
    Expect(0, 47, '\P{Lb=--SY}', "");
    Expect(1, 47, '\P{^Lb=--SY}', "");
    Expect(0, 48, '\p{Lb=--SY}', "");
    Expect(1, 48, '\p{^Lb=--SY}', "");
    Expect(1, 48, '\P{Lb=--SY}', "");
    Expect(0, 48, '\P{^Lb=--SY}', "");
    Error('\p{Is_Line_Break=/a/--BREAK_SYMBOLS}');
    Error('\P{Is_Line_Break=/a/--BREAK_SYMBOLS}');
    Expect(1, 47, '\p{Is_Line_Break=breaksymbols}', "");
    Expect(0, 47, '\p{^Is_Line_Break=breaksymbols}', "");
    Expect(0, 47, '\P{Is_Line_Break=breaksymbols}', "");
    Expect(1, 47, '\P{^Is_Line_Break=breaksymbols}', "");
    Expect(0, 48, '\p{Is_Line_Break=breaksymbols}', "");
    Expect(1, 48, '\p{^Is_Line_Break=breaksymbols}', "");
    Expect(1, 48, '\P{Is_Line_Break=breaksymbols}', "");
    Expect(0, 48, '\P{^Is_Line_Break=breaksymbols}', "");
    Expect(1, 47, '\p{Is_Line_Break=		Break_Symbols}', "");
    Expect(0, 47, '\p{^Is_Line_Break=		Break_Symbols}', "");
    Expect(0, 47, '\P{Is_Line_Break=		Break_Symbols}', "");
    Expect(1, 47, '\P{^Is_Line_Break=		Break_Symbols}', "");
    Expect(0, 48, '\p{Is_Line_Break=		Break_Symbols}', "");
    Expect(1, 48, '\p{^Is_Line_Break=		Break_Symbols}', "");
    Expect(1, 48, '\P{Is_Line_Break=		Break_Symbols}', "");
    Expect(0, 48, '\P{^Is_Line_Break=		Break_Symbols}', "");
    Error('\p{Is_Lb= SY/a/}');
    Error('\P{Is_Lb= SY/a/}');
    Expect(1, 47, '\p{Is_Lb=sy}', "");
    Expect(0, 47, '\p{^Is_Lb=sy}', "");
    Expect(0, 47, '\P{Is_Lb=sy}', "");
    Expect(1, 47, '\P{^Is_Lb=sy}', "");
    Expect(0, 48, '\p{Is_Lb=sy}', "");
    Expect(1, 48, '\p{^Is_Lb=sy}', "");
    Expect(1, 48, '\P{Is_Lb=sy}', "");
    Expect(0, 48, '\P{^Is_Lb=sy}', "");
    Expect(1, 47, '\p{Is_Lb=	 SY}', "");
    Expect(0, 47, '\p{^Is_Lb=	 SY}', "");
    Expect(0, 47, '\P{Is_Lb=	 SY}', "");
    Expect(1, 47, '\P{^Is_Lb=	 SY}', "");
    Expect(0, 48, '\p{Is_Lb=	 SY}', "");
    Expect(1, 48, '\p{^Is_Lb=	 SY}', "");
    Expect(1, 48, '\P{Is_Lb=	 SY}', "");
    Expect(0, 48, '\P{^Is_Lb=	 SY}', "");
    Error('\p{Line_Break=:=--Word_joiner}');
    Error('\P{Line_Break=:=--Word_joiner}');
    Expect(1, 65279, '\p{Line_Break=:\AWord_Joiner\z:}', "");;
    Expect(0, 65280, '\p{Line_Break=:\AWord_Joiner\z:}', "");;
    Expect(1, 65279, '\p{Line_Break=wordjoiner}', "");
    Expect(0, 65279, '\p{^Line_Break=wordjoiner}', "");
    Expect(0, 65279, '\P{Line_Break=wordjoiner}', "");
    Expect(1, 65279, '\P{^Line_Break=wordjoiner}', "");
    Expect(0, 65280, '\p{Line_Break=wordjoiner}', "");
    Expect(1, 65280, '\p{^Line_Break=wordjoiner}', "");
    Expect(1, 65280, '\P{Line_Break=wordjoiner}', "");
    Expect(0, 65280, '\P{^Line_Break=wordjoiner}', "");
    Expect(1, 65279, '\p{Line_Break=:\Awordjoiner\z:}', "");;
    Expect(0, 65280, '\p{Line_Break=:\Awordjoiner\z:}', "");;
    Expect(1, 65279, '\p{Line_Break=	 Word_Joiner}', "");
    Expect(0, 65279, '\p{^Line_Break=	 Word_Joiner}', "");
    Expect(0, 65279, '\P{Line_Break=	 Word_Joiner}', "");
    Expect(1, 65279, '\P{^Line_Break=	 Word_Joiner}', "");
    Expect(0, 65280, '\p{Line_Break=	 Word_Joiner}', "");
    Expect(1, 65280, '\p{^Line_Break=	 Word_Joiner}', "");
    Expect(1, 65280, '\P{Line_Break=	 Word_Joiner}', "");
    Expect(0, 65280, '\P{^Line_Break=	 Word_Joiner}', "");
    Error('\p{Lb=_WJ/a/}');
    Error('\P{Lb=_WJ/a/}');
    Expect(1, 65279, '\p{Lb=:\AWJ\z:}', "");;
    Expect(0, 65280, '\p{Lb=:\AWJ\z:}', "");;
    Expect(1, 65279, '\p{Lb=wj}', "");
    Expect(0, 65279, '\p{^Lb=wj}', "");
    Expect(0, 65279, '\P{Lb=wj}', "");
    Expect(1, 65279, '\P{^Lb=wj}', "");
    Expect(0, 65280, '\p{Lb=wj}', "");
    Expect(1, 65280, '\p{^Lb=wj}', "");
    Expect(1, 65280, '\P{Lb=wj}', "");
    Expect(0, 65280, '\P{^Lb=wj}', "");
    Expect(1, 65279, '\p{Lb=:\Awj\z:}', "");;
    Expect(0, 65280, '\p{Lb=:\Awj\z:}', "");;
    Expect(1, 65279, '\p{Lb=_WJ}', "");
    Expect(0, 65279, '\p{^Lb=_WJ}', "");
    Expect(0, 65279, '\P{Lb=_WJ}', "");
    Expect(1, 65279, '\P{^Lb=_WJ}', "");
    Expect(0, 65280, '\p{Lb=_WJ}', "");
    Expect(1, 65280, '\p{^Lb=_WJ}', "");
    Expect(1, 65280, '\P{Lb=_WJ}', "");
    Expect(0, 65280, '\P{^Lb=_WJ}', "");
    Error('\p{Is_Line_Break=	/a/Word_JOINER}');
    Error('\P{Is_Line_Break=	/a/Word_JOINER}');
    Expect(1, 65279, '\p{Is_Line_Break=wordjoiner}', "");
    Expect(0, 65279, '\p{^Is_Line_Break=wordjoiner}', "");
    Expect(0, 65279, '\P{Is_Line_Break=wordjoiner}', "");
    Expect(1, 65279, '\P{^Is_Line_Break=wordjoiner}', "");
    Expect(0, 65280, '\p{Is_Line_Break=wordjoiner}', "");
    Expect(1, 65280, '\p{^Is_Line_Break=wordjoiner}', "");
    Expect(1, 65280, '\P{Is_Line_Break=wordjoiner}', "");
    Expect(0, 65280, '\P{^Is_Line_Break=wordjoiner}', "");
    Expect(1, 65279, '\p{Is_Line_Break=	 word_JOINER}', "");
    Expect(0, 65279, '\p{^Is_Line_Break=	 word_JOINER}', "");
    Expect(0, 65279, '\P{Is_Line_Break=	 word_JOINER}', "");
    Expect(1, 65279, '\P{^Is_Line_Break=	 word_JOINER}', "");
    Expect(0, 65280, '\p{Is_Line_Break=	 word_JOINER}', "");
    Expect(1, 65280, '\p{^Is_Line_Break=	 word_JOINER}', "");
    Expect(1, 65280, '\P{Is_Line_Break=	 word_JOINER}', "");
    Expect(0, 65280, '\P{^Is_Line_Break=	 word_JOINER}', "");
    Error('\p{Is_Lb=--WJ/a/}');
    Error('\P{Is_Lb=--WJ/a/}');
    Expect(1, 65279, '\p{Is_Lb=wj}', "");
    Expect(0, 65279, '\p{^Is_Lb=wj}', "");
    Expect(0, 65279, '\P{Is_Lb=wj}', "");
    Expect(1, 65279, '\P{^Is_Lb=wj}', "");
    Expect(0, 65280, '\p{Is_Lb=wj}', "");
    Expect(1, 65280, '\p{^Is_Lb=wj}', "");
    Expect(1, 65280, '\P{Is_Lb=wj}', "");
    Expect(0, 65280, '\P{^Is_Lb=wj}', "");
    Expect(1, 65279, '\p{Is_Lb=_WJ}', "");
    Expect(0, 65279, '\p{^Is_Lb=_WJ}', "");
    Expect(0, 65279, '\P{Is_Lb=_WJ}', "");
    Expect(1, 65279, '\P{^Is_Lb=_WJ}', "");
    Expect(0, 65280, '\p{Is_Lb=_WJ}', "");
    Expect(1, 65280, '\p{^Is_Lb=_WJ}', "");
    Expect(1, 65280, '\P{Is_Lb=_WJ}', "");
    Expect(0, 65280, '\P{^Is_Lb=_WJ}', "");
    Error('\p{Line_Break=/a/- Unknown}');
    Error('\P{Line_Break=/a/- Unknown}');
    Expect(1, 918000, '\p{Line_Break=:\AUnknown\z:}', "");;
    Expect(0, 917999, '\p{Line_Break=:\AUnknown\z:}', "");;
    Expect(1, 918000, '\p{Line_Break=unknown}', "");
    Expect(0, 918000, '\p{^Line_Break=unknown}', "");
    Expect(0, 918000, '\P{Line_Break=unknown}', "");
    Expect(1, 918000, '\P{^Line_Break=unknown}', "");
    Expect(0, 917999, '\p{Line_Break=unknown}', "");
    Expect(1, 917999, '\p{^Line_Break=unknown}', "");
    Expect(1, 917999, '\P{Line_Break=unknown}', "");
    Expect(0, 917999, '\P{^Line_Break=unknown}', "");
    Expect(1, 918000, '\p{Line_Break=:\Aunknown\z:}', "");;
    Expect(0, 917999, '\p{Line_Break=:\Aunknown\z:}', "");;
    Expect(1, 918000, '\p{Line_Break=-Unknown}', "");
    Expect(0, 918000, '\p{^Line_Break=-Unknown}', "");
    Expect(0, 918000, '\P{Line_Break=-Unknown}', "");
    Expect(1, 918000, '\P{^Line_Break=-Unknown}', "");
    Expect(0, 917999, '\p{Line_Break=-Unknown}', "");
    Expect(1, 917999, '\p{^Line_Break=-Unknown}', "");
    Expect(1, 917999, '\P{Line_Break=-Unknown}', "");
    Expect(0, 917999, '\P{^Line_Break=-Unknown}', "");
    Error('\p{Lb=		XX/a/}');
    Error('\P{Lb=		XX/a/}');
    Expect(1, 918000, '\p{Lb=:\AXX\z:}', "");;
    Expect(0, 917999, '\p{Lb=:\AXX\z:}', "");;
    Expect(1, 918000, '\p{Lb=xx}', "");
    Expect(0, 918000, '\p{^Lb=xx}', "");
    Expect(0, 918000, '\P{Lb=xx}', "");
    Expect(1, 918000, '\P{^Lb=xx}', "");
    Expect(0, 917999, '\p{Lb=xx}', "");
    Expect(1, 917999, '\p{^Lb=xx}', "");
    Expect(1, 917999, '\P{Lb=xx}', "");
    Expect(0, 917999, '\P{^Lb=xx}', "");
    Expect(1, 918000, '\p{Lb=:\Axx\z:}', "");;
    Expect(0, 917999, '\p{Lb=:\Axx\z:}', "");;
    Expect(1, 918000, '\p{Lb=XX}', "");
    Expect(0, 918000, '\p{^Lb=XX}', "");
    Expect(0, 918000, '\P{Lb=XX}', "");
    Expect(1, 918000, '\P{^Lb=XX}', "");
    Expect(0, 917999, '\p{Lb=XX}', "");
    Expect(1, 917999, '\p{^Lb=XX}', "");
    Expect(1, 917999, '\P{Lb=XX}', "");
    Expect(0, 917999, '\P{^Lb=XX}', "");
    Error('\p{Is_Line_Break=_ UNKNOWN/a/}');
    Error('\P{Is_Line_Break=_ UNKNOWN/a/}');
    Expect(1, 918000, '\p{Is_Line_Break=unknown}', "");
    Expect(0, 918000, '\p{^Is_Line_Break=unknown}', "");
    Expect(0, 918000, '\P{Is_Line_Break=unknown}', "");
    Expect(1, 918000, '\P{^Is_Line_Break=unknown}', "");
    Expect(0, 917999, '\p{Is_Line_Break=unknown}', "");
    Expect(1, 917999, '\p{^Is_Line_Break=unknown}', "");
    Expect(1, 917999, '\P{Is_Line_Break=unknown}', "");
    Expect(0, 917999, '\P{^Is_Line_Break=unknown}', "");
    Expect(1, 918000, '\p{Is_Line_Break=-	unknown}', "");
    Expect(0, 918000, '\p{^Is_Line_Break=-	unknown}', "");
    Expect(0, 918000, '\P{Is_Line_Break=-	unknown}', "");
    Expect(1, 918000, '\P{^Is_Line_Break=-	unknown}', "");
    Expect(0, 917999, '\p{Is_Line_Break=-	unknown}', "");
    Expect(1, 917999, '\p{^Is_Line_Break=-	unknown}', "");
    Expect(1, 917999, '\P{Is_Line_Break=-	unknown}', "");
    Expect(0, 917999, '\P{^Is_Line_Break=-	unknown}', "");
    Error('\p{Is_Lb=_-XX:=}');
    Error('\P{Is_Lb=_-XX:=}');
    Expect(1, 918000, '\p{Is_Lb: xx}', "");
    Expect(0, 918000, '\p{^Is_Lb: xx}', "");
    Expect(0, 918000, '\P{Is_Lb: xx}', "");
    Expect(1, 918000, '\P{^Is_Lb: xx}', "");
    Expect(0, 917999, '\p{Is_Lb: xx}', "");
    Expect(1, 917999, '\p{^Is_Lb: xx}', "");
    Expect(1, 917999, '\P{Is_Lb: xx}', "");
    Expect(0, 917999, '\P{^Is_Lb: xx}', "");
    Expect(1, 918000, '\p{Is_Lb:   		XX}', "");
    Expect(0, 918000, '\p{^Is_Lb:   		XX}', "");
    Expect(0, 918000, '\P{Is_Lb:   		XX}', "");
    Expect(1, 918000, '\P{^Is_Lb:   		XX}', "");
    Expect(0, 917999, '\p{Is_Lb:   		XX}', "");
    Expect(1, 917999, '\p{^Is_Lb:   		XX}', "");
    Expect(1, 917999, '\P{Is_Lb:   		XX}', "");
    Expect(0, 917999, '\P{^Is_Lb:   		XX}', "");
    Error('\p{Line_Break= :=ZWSpace}');
    Error('\P{Line_Break= :=ZWSpace}');
    Expect(1, 8203, '\p{Line_Break=:\AZWSpace\z:}', "");;
    Expect(0, 8204, '\p{Line_Break=:\AZWSpace\z:}', "");;
    Expect(1, 8203, '\p{Line_Break=zwspace}', "");
    Expect(0, 8203, '\p{^Line_Break=zwspace}', "");
    Expect(0, 8203, '\P{Line_Break=zwspace}', "");
    Expect(1, 8203, '\P{^Line_Break=zwspace}', "");
    Expect(0, 8204, '\p{Line_Break=zwspace}', "");
    Expect(1, 8204, '\p{^Line_Break=zwspace}', "");
    Expect(1, 8204, '\P{Line_Break=zwspace}', "");
    Expect(0, 8204, '\P{^Line_Break=zwspace}', "");
    Expect(1, 8203, '\p{Line_Break=:\Azwspace\z:}', "");;
    Expect(0, 8204, '\p{Line_Break=:\Azwspace\z:}', "");;
    Expect(1, 8203, '\p{Line_Break=-_ZWSPACE}', "");
    Expect(0, 8203, '\p{^Line_Break=-_ZWSPACE}', "");
    Expect(0, 8203, '\P{Line_Break=-_ZWSPACE}', "");
    Expect(1, 8203, '\P{^Line_Break=-_ZWSPACE}', "");
    Expect(0, 8204, '\p{Line_Break=-_ZWSPACE}', "");
    Expect(1, 8204, '\p{^Line_Break=-_ZWSPACE}', "");
    Expect(1, 8204, '\P{Line_Break=-_ZWSPACE}', "");
    Expect(0, 8204, '\P{^Line_Break=-_ZWSPACE}', "");
    Error('\p{Lb=	ZW:=}');
    Error('\P{Lb=	ZW:=}');
    Expect(1, 8203, '\p{Lb=:\AZW\z:}', "");;
    Expect(0, 8204, '\p{Lb=:\AZW\z:}', "");;
    Expect(1, 8203, '\p{Lb: zw}', "");
    Expect(0, 8203, '\p{^Lb: zw}', "");
    Expect(0, 8203, '\P{Lb: zw}', "");
    Expect(1, 8203, '\P{^Lb: zw}', "");
    Expect(0, 8204, '\p{Lb: zw}', "");
    Expect(1, 8204, '\p{^Lb: zw}', "");
    Expect(1, 8204, '\P{Lb: zw}', "");
    Expect(0, 8204, '\P{^Lb: zw}', "");
    Expect(1, 8203, '\p{Lb=:\Azw\z:}', "");;
    Expect(0, 8204, '\p{Lb=:\Azw\z:}', "");;
    Expect(1, 8203, '\p{Lb= 	ZW}', "");
    Expect(0, 8203, '\p{^Lb= 	ZW}', "");
    Expect(0, 8203, '\P{Lb= 	ZW}', "");
    Expect(1, 8203, '\P{^Lb= 	ZW}', "");
    Expect(0, 8204, '\p{Lb= 	ZW}', "");
    Expect(1, 8204, '\p{^Lb= 	ZW}', "");
    Expect(1, 8204, '\P{Lb= 	ZW}', "");
    Expect(0, 8204, '\P{^Lb= 	ZW}', "");
    Error('\p{Is_Line_Break=	 ZWSpace/a/}');
    Error('\P{Is_Line_Break=	 ZWSpace/a/}');
    Expect(1, 8203, '\p{Is_Line_Break=zwspace}', "");
    Expect(0, 8203, '\p{^Is_Line_Break=zwspace}', "");
    Expect(0, 8203, '\P{Is_Line_Break=zwspace}', "");
    Expect(1, 8203, '\P{^Is_Line_Break=zwspace}', "");
    Expect(0, 8204, '\p{Is_Line_Break=zwspace}', "");
    Expect(1, 8204, '\p{^Is_Line_Break=zwspace}', "");
    Expect(1, 8204, '\P{Is_Line_Break=zwspace}', "");
    Expect(0, 8204, '\P{^Is_Line_Break=zwspace}', "");
    Expect(1, 8203, '\p{Is_Line_Break=	ZWSpace}', "");
    Expect(0, 8203, '\p{^Is_Line_Break=	ZWSpace}', "");
    Expect(0, 8203, '\P{Is_Line_Break=	ZWSpace}', "");
    Expect(1, 8203, '\P{^Is_Line_Break=	ZWSpace}', "");
    Expect(0, 8204, '\p{Is_Line_Break=	ZWSpace}', "");
    Expect(1, 8204, '\p{^Is_Line_Break=	ZWSpace}', "");
    Expect(1, 8204, '\P{Is_Line_Break=	ZWSpace}', "");
    Expect(0, 8204, '\P{^Is_Line_Break=	ZWSpace}', "");
    Error('\p{Is_Lb=	-zw:=}');
    Error('\P{Is_Lb=	-zw:=}');
    Expect(1, 8203, '\p{Is_Lb=zw}', "");
    Expect(0, 8203, '\p{^Is_Lb=zw}', "");
    Expect(0, 8203, '\P{Is_Lb=zw}', "");
    Expect(1, 8203, '\P{^Is_Lb=zw}', "");
    Expect(0, 8204, '\p{Is_Lb=zw}', "");
    Expect(1, 8204, '\p{^Is_Lb=zw}', "");
    Expect(1, 8204, '\P{Is_Lb=zw}', "");
    Expect(0, 8204, '\P{^Is_Lb=zw}', "");
    Expect(1, 8203, '\p{Is_Lb= zw}', "");
    Expect(0, 8203, '\p{^Is_Lb= zw}', "");
    Expect(0, 8203, '\P{Is_Lb= zw}', "");
    Expect(1, 8203, '\P{^Is_Lb= zw}', "");
    Expect(0, 8204, '\p{Is_Lb= zw}', "");
    Expect(1, 8204, '\p{^Is_Lb= zw}', "");
    Expect(1, 8204, '\P{Is_Lb= zw}', "");
    Expect(0, 8204, '\P{^Is_Lb= zw}', "");
    Error('\p{Line_Break=:=ZWJ}');
    Error('\P{Line_Break=:=ZWJ}');
    Expect(1, 8205, '\p{Line_Break=:\AZWJ\z:}', "");;
    Expect(0, 8206, '\p{Line_Break=:\AZWJ\z:}', "");;
    Expect(1, 8205, '\p{Line_Break=zwj}', "");
    Expect(0, 8205, '\p{^Line_Break=zwj}', "");
    Expect(0, 8205, '\P{Line_Break=zwj}', "");
    Expect(1, 8205, '\P{^Line_Break=zwj}', "");
    Expect(0, 8206, '\p{Line_Break=zwj}', "");
    Expect(1, 8206, '\p{^Line_Break=zwj}', "");
    Expect(1, 8206, '\P{Line_Break=zwj}', "");
    Expect(0, 8206, '\P{^Line_Break=zwj}', "");
    Expect(1, 8205, '\p{Line_Break=:\Azwj\z:}', "");;
    Expect(0, 8206, '\p{Line_Break=:\Azwj\z:}', "");;
    Expect(1, 8205, '\p{Line_Break=	ZWJ}', "");
    Expect(0, 8205, '\p{^Line_Break=	ZWJ}', "");
    Expect(0, 8205, '\P{Line_Break=	ZWJ}', "");
    Expect(1, 8205, '\P{^Line_Break=	ZWJ}', "");
    Expect(0, 8206, '\p{Line_Break=	ZWJ}', "");
    Expect(1, 8206, '\p{^Line_Break=	ZWJ}', "");
    Expect(1, 8206, '\P{Line_Break=	ZWJ}', "");
    Expect(0, 8206, '\P{^Line_Break=	ZWJ}', "");
    Error('\p{Lb=-/a/ZWJ}');
    Error('\P{Lb=-/a/ZWJ}');
    Expect(1, 8205, '\p{Lb=:\AZWJ\z:}', "");;
    Expect(0, 8206, '\p{Lb=:\AZWJ\z:}', "");;
    Expect(1, 8205, '\p{Lb=zwj}', "");
    Expect(0, 8205, '\p{^Lb=zwj}', "");
    Expect(0, 8205, '\P{Lb=zwj}', "");
    Expect(1, 8205, '\P{^Lb=zwj}', "");
    Expect(0, 8206, '\p{Lb=zwj}', "");
    Expect(1, 8206, '\p{^Lb=zwj}', "");
    Expect(1, 8206, '\P{Lb=zwj}', "");
    Expect(0, 8206, '\P{^Lb=zwj}', "");
    Expect(1, 8205, '\p{Lb=:\Azwj\z:}', "");;
    Expect(0, 8206, '\p{Lb=:\Azwj\z:}', "");;
    Expect(1, 8205, '\p{Lb=_	ZWJ}', "");
    Expect(0, 8205, '\p{^Lb=_	ZWJ}', "");
    Expect(0, 8205, '\P{Lb=_	ZWJ}', "");
    Expect(1, 8205, '\P{^Lb=_	ZWJ}', "");
    Expect(0, 8206, '\p{Lb=_	ZWJ}', "");
    Expect(1, 8206, '\p{^Lb=_	ZWJ}', "");
    Expect(1, 8206, '\P{Lb=_	ZWJ}', "");
    Expect(0, 8206, '\P{^Lb=_	ZWJ}', "");
    Error('\p{Is_Line_Break=:=-ZWJ}');
    Error('\P{Is_Line_Break=:=-ZWJ}');
    Expect(1, 8205, '\p{Is_Line_Break=zwj}', "");
    Expect(0, 8205, '\p{^Is_Line_Break=zwj}', "");
    Expect(0, 8205, '\P{Is_Line_Break=zwj}', "");
    Expect(1, 8205, '\P{^Is_Line_Break=zwj}', "");
    Expect(0, 8206, '\p{Is_Line_Break=zwj}', "");
    Expect(1, 8206, '\p{^Is_Line_Break=zwj}', "");
    Expect(1, 8206, '\P{Is_Line_Break=zwj}', "");
    Expect(0, 8206, '\P{^Is_Line_Break=zwj}', "");
    Expect(1, 8205, '\p{Is_Line_Break=		ZWJ}', "");
    Expect(0, 8205, '\p{^Is_Line_Break=		ZWJ}', "");
    Expect(0, 8205, '\P{Is_Line_Break=		ZWJ}', "");
    Expect(1, 8205, '\P{^Is_Line_Break=		ZWJ}', "");
    Expect(0, 8206, '\p{Is_Line_Break=		ZWJ}', "");
    Expect(1, 8206, '\p{^Is_Line_Break=		ZWJ}', "");
    Expect(1, 8206, '\P{Is_Line_Break=		ZWJ}', "");
    Expect(0, 8206, '\P{^Is_Line_Break=		ZWJ}', "");
    Error('\p{Is_Lb=/a/_-ZWJ}');
    Error('\P{Is_Lb=/a/_-ZWJ}');
    Expect(1, 8205, '\p{Is_Lb:   zwj}', "");
    Expect(0, 8205, '\p{^Is_Lb:   zwj}', "");
    Expect(0, 8205, '\P{Is_Lb:   zwj}', "");
    Expect(1, 8205, '\P{^Is_Lb:   zwj}', "");
    Expect(0, 8206, '\p{Is_Lb:   zwj}', "");
    Expect(1, 8206, '\p{^Is_Lb:   zwj}', "");
    Expect(1, 8206, '\P{Is_Lb:   zwj}', "");
    Expect(0, 8206, '\P{^Is_Lb:   zwj}', "");
    Expect(1, 8205, '\p{Is_Lb= _zwj}', "");
    Expect(0, 8205, '\p{^Is_Lb= _zwj}', "");
    Expect(0, 8205, '\P{Is_Lb= _zwj}', "");
    Expect(1, 8205, '\P{^Is_Lb= _zwj}', "");
    Expect(0, 8206, '\p{Is_Lb= _zwj}', "");
    Expect(1, 8206, '\p{^Is_Lb= _zwj}', "");
    Expect(1, 8206, '\P{Is_Lb= _zwj}', "");
    Expect(0, 8206, '\P{^Is_Lb= _zwj}', "");
    Error('\p{lowercasemapping}');
    Error('\P{lowercasemapping}');
    Error('\p{Logical_Order_Exception=-no/a/}');
    Error('\P{Logical_Order_Exception=-no/a/}');
    Expect(1, 43709, '\p{Logical_Order_Exception=:\ANo\z:}', "");;
    Expect(0, 43708, '\p{Logical_Order_Exception=:\ANo\z:}', "");;
    Expect(1, 43709, '\p{Logical_Order_Exception:	no}', "");
    Expect(0, 43709, '\p{^Logical_Order_Exception:	no}', "");
    Expect(0, 43709, '\P{Logical_Order_Exception:	no}', "");
    Expect(1, 43709, '\P{^Logical_Order_Exception:	no}', "");
    Expect(0, 43708, '\p{Logical_Order_Exception:	no}', "");
    Expect(1, 43708, '\p{^Logical_Order_Exception:	no}', "");
    Expect(1, 43708, '\P{Logical_Order_Exception:	no}', "");
    Expect(0, 43708, '\P{^Logical_Order_Exception:	no}', "");
    Expect(1, 43709, '\p{Logical_Order_Exception=:\Ano\z:}', "");;
    Expect(0, 43708, '\p{Logical_Order_Exception=:\Ano\z:}', "");;
    Expect(1, 43709, '\p{Logical_Order_Exception:__no}', "");
    Expect(0, 43709, '\p{^Logical_Order_Exception:__no}', "");
    Expect(0, 43709, '\P{Logical_Order_Exception:__no}', "");
    Expect(1, 43709, '\P{^Logical_Order_Exception:__no}', "");
    Expect(0, 43708, '\p{Logical_Order_Exception:__no}', "");
    Expect(1, 43708, '\p{^Logical_Order_Exception:__no}', "");
    Expect(1, 43708, '\P{Logical_Order_Exception:__no}', "");
    Expect(0, 43708, '\P{^Logical_Order_Exception:__no}', "");
    Error('\p{LOE=:=n}');
    Error('\P{LOE=:=n}');
    Expect(1, 43709, '\p{LOE=:\AN\z:}', "");;
    Expect(0, 43708, '\p{LOE=:\AN\z:}', "");;
    Expect(1, 43709, '\p{LOE=n}', "");
    Expect(0, 43709, '\p{^LOE=n}', "");
    Expect(0, 43709, '\P{LOE=n}', "");
    Expect(1, 43709, '\P{^LOE=n}', "");
    Expect(0, 43708, '\p{LOE=n}', "");
    Expect(1, 43708, '\p{^LOE=n}', "");
    Expect(1, 43708, '\P{LOE=n}', "");
    Expect(0, 43708, '\P{^LOE=n}', "");
    Expect(1, 43709, '\p{LOE=:\An\z:}', "");;
    Expect(0, 43708, '\p{LOE=:\An\z:}', "");;
    Expect(1, 43709, '\p{LOE=_	N}', "");
    Expect(0, 43709, '\p{^LOE=_	N}', "");
    Expect(0, 43709, '\P{LOE=_	N}', "");
    Expect(1, 43709, '\P{^LOE=_	N}', "");
    Expect(0, 43708, '\p{LOE=_	N}', "");
    Expect(1, 43708, '\p{^LOE=_	N}', "");
    Expect(1, 43708, '\P{LOE=_	N}', "");
    Expect(0, 43708, '\P{^LOE=_	N}', "");
    Error('\p{Is_Logical_Order_Exception=/a/		F}');
    Error('\P{Is_Logical_Order_Exception=/a/		F}');
    Expect(1, 43709, '\p{Is_Logical_Order_Exception=f}', "");
    Expect(0, 43709, '\p{^Is_Logical_Order_Exception=f}', "");
    Expect(0, 43709, '\P{Is_Logical_Order_Exception=f}', "");
    Expect(1, 43709, '\P{^Is_Logical_Order_Exception=f}', "");
    Expect(0, 43708, '\p{Is_Logical_Order_Exception=f}', "");
    Expect(1, 43708, '\p{^Is_Logical_Order_Exception=f}', "");
    Expect(1, 43708, '\P{Is_Logical_Order_Exception=f}', "");
    Expect(0, 43708, '\P{^Is_Logical_Order_Exception=f}', "");
    Expect(1, 43709, '\p{Is_Logical_Order_Exception= 	F}', "");
    Expect(0, 43709, '\p{^Is_Logical_Order_Exception= 	F}', "");
    Expect(0, 43709, '\P{Is_Logical_Order_Exception= 	F}', "");
    Expect(1, 43709, '\P{^Is_Logical_Order_Exception= 	F}', "");
    Expect(0, 43708, '\p{Is_Logical_Order_Exception= 	F}', "");
    Expect(1, 43708, '\p{^Is_Logical_Order_Exception= 	F}', "");
    Expect(1, 43708, '\P{Is_Logical_Order_Exception= 	F}', "");
    Expect(0, 43708, '\P{^Is_Logical_Order_Exception= 	F}', "");
    Error('\p{Is_LOE=:=	 FALSE}');
    Error('\P{Is_LOE=:=	 FALSE}');
    Expect(1, 43709, '\p{Is_LOE=false}', "");
    Expect(0, 43709, '\p{^Is_LOE=false}', "");
    Expect(0, 43709, '\P{Is_LOE=false}', "");
    Expect(1, 43709, '\P{^Is_LOE=false}', "");
    Expect(0, 43708, '\p{Is_LOE=false}', "");
    Expect(1, 43708, '\p{^Is_LOE=false}', "");
    Expect(1, 43708, '\P{Is_LOE=false}', "");
    Expect(0, 43708, '\P{^Is_LOE=false}', "");
    Expect(1, 43709, '\p{Is_LOE:   __False}', "");
    Expect(0, 43709, '\p{^Is_LOE:   __False}', "");
    Expect(0, 43709, '\P{Is_LOE:   __False}', "");
    Expect(1, 43709, '\P{^Is_LOE:   __False}', "");
    Expect(0, 43708, '\p{Is_LOE:   __False}', "");
    Expect(1, 43708, '\p{^Is_LOE:   __False}', "");
    Expect(1, 43708, '\P{Is_LOE:   __False}', "");
    Expect(0, 43708, '\P{^Is_LOE:   __False}', "");
    Error('\p{Logical_Order_Exception=/a/yes}');
    Error('\P{Logical_Order_Exception=/a/yes}');
    Expect(1, 43708, '\p{Logical_Order_Exception=:\AYes\z:}', "");;
    Expect(0, 43709, '\p{Logical_Order_Exception=:\AYes\z:}', "");;
    Expect(1, 43708, '\p{Logical_Order_Exception=yes}', "");
    Expect(0, 43708, '\p{^Logical_Order_Exception=yes}', "");
    Expect(0, 43708, '\P{Logical_Order_Exception=yes}', "");
    Expect(1, 43708, '\P{^Logical_Order_Exception=yes}', "");
    Expect(0, 43709, '\p{Logical_Order_Exception=yes}', "");
    Expect(1, 43709, '\p{^Logical_Order_Exception=yes}', "");
    Expect(1, 43709, '\P{Logical_Order_Exception=yes}', "");
    Expect(0, 43709, '\P{^Logical_Order_Exception=yes}', "");
    Expect(1, 43708, '\p{Logical_Order_Exception=:\Ayes\z:}', "");;
    Expect(0, 43709, '\p{Logical_Order_Exception=:\Ayes\z:}', "");;
    Expect(1, 43708, '\p{Logical_Order_Exception=  Yes}', "");
    Expect(0, 43708, '\p{^Logical_Order_Exception=  Yes}', "");
    Expect(0, 43708, '\P{Logical_Order_Exception=  Yes}', "");
    Expect(1, 43708, '\P{^Logical_Order_Exception=  Yes}', "");
    Expect(0, 43709, '\p{Logical_Order_Exception=  Yes}', "");
    Expect(1, 43709, '\p{^Logical_Order_Exception=  Yes}', "");
    Expect(1, 43709, '\P{Logical_Order_Exception=  Yes}', "");
    Expect(0, 43709, '\P{^Logical_Order_Exception=  Yes}', "");
    Error('\p{LOE=/a/  y}');
    Error('\P{LOE=/a/  y}');
    Expect(1, 43708, '\p{LOE=:\AY\z:}', "");;
    Expect(0, 43709, '\p{LOE=:\AY\z:}', "");;
    Expect(1, 43708, '\p{LOE=y}', "");
    Expect(0, 43708, '\p{^LOE=y}', "");
    Expect(0, 43708, '\P{LOE=y}', "");
    Expect(1, 43708, '\P{^LOE=y}', "");
    Expect(0, 43709, '\p{LOE=y}', "");
    Expect(1, 43709, '\p{^LOE=y}', "");
    Expect(1, 43709, '\P{LOE=y}', "");
    Expect(0, 43709, '\P{^LOE=y}', "");
    Expect(1, 43708, '\p{LOE=:\Ay\z:}', "");;
    Expect(0, 43709, '\p{LOE=:\Ay\z:}', "");;
    Expect(1, 43708, '\p{LOE=	 y}', "");
    Expect(0, 43708, '\p{^LOE=	 y}', "");
    Expect(0, 43708, '\P{LOE=	 y}', "");
    Expect(1, 43708, '\P{^LOE=	 y}', "");
    Expect(0, 43709, '\p{LOE=	 y}', "");
    Expect(1, 43709, '\p{^LOE=	 y}', "");
    Expect(1, 43709, '\P{LOE=	 y}', "");
    Expect(0, 43709, '\P{^LOE=	 y}', "");
    Error('\p{Is_Logical_Order_Exception=_/a/T}');
    Error('\P{Is_Logical_Order_Exception=_/a/T}');
    Expect(1, 43708, '\p{Is_Logical_Order_Exception=t}', "");
    Expect(0, 43708, '\p{^Is_Logical_Order_Exception=t}', "");
    Expect(0, 43708, '\P{Is_Logical_Order_Exception=t}', "");
    Expect(1, 43708, '\P{^Is_Logical_Order_Exception=t}', "");
    Expect(0, 43709, '\p{Is_Logical_Order_Exception=t}', "");
    Expect(1, 43709, '\p{^Is_Logical_Order_Exception=t}', "");
    Expect(1, 43709, '\P{Is_Logical_Order_Exception=t}', "");
    Expect(0, 43709, '\P{^Is_Logical_Order_Exception=t}', "");
    Expect(1, 43708, '\p{Is_Logical_Order_Exception=_T}', "");
    Expect(0, 43708, '\p{^Is_Logical_Order_Exception=_T}', "");
    Expect(0, 43708, '\P{Is_Logical_Order_Exception=_T}', "");
    Expect(1, 43708, '\P{^Is_Logical_Order_Exception=_T}', "");
    Expect(0, 43709, '\p{Is_Logical_Order_Exception=_T}', "");
    Expect(1, 43709, '\p{^Is_Logical_Order_Exception=_T}', "");
    Expect(1, 43709, '\P{Is_Logical_Order_Exception=_T}', "");
    Expect(0, 43709, '\P{^Is_Logical_Order_Exception=_T}', "");
    Error('\p{Is_LOE=  TRUE/a/}');
    Error('\P{Is_LOE=  TRUE/a/}');
    Expect(1, 43708, '\p{Is_LOE=true}', "");
    Expect(0, 43708, '\p{^Is_LOE=true}', "");
    Expect(0, 43708, '\P{Is_LOE=true}', "");
    Expect(1, 43708, '\P{^Is_LOE=true}', "");
    Expect(0, 43709, '\p{Is_LOE=true}', "");
    Expect(1, 43709, '\p{^Is_LOE=true}', "");
    Expect(1, 43709, '\P{Is_LOE=true}', "");
    Expect(0, 43709, '\P{^Is_LOE=true}', "");
    Expect(1, 43708, '\p{Is_LOE=-_True}', "");
    Expect(0, 43708, '\p{^Is_LOE=-_True}', "");
    Expect(0, 43708, '\P{Is_LOE=-_True}', "");
    Expect(1, 43708, '\P{^Is_LOE=-_True}', "");
    Expect(0, 43709, '\p{Is_LOE=-_True}', "");
    Expect(1, 43709, '\p{^Is_LOE=-_True}', "");
    Expect(1, 43709, '\P{Is_LOE=-_True}', "");
    Expect(0, 43709, '\P{^Is_LOE=-_True}', "");
    Error('\p{Lowercase= :=no}');
    Error('\P{Lowercase= :=no}');
    Expect(1, 125252, '\p{Lowercase=:\ANo\z:}', "");;
    Expect(0, 125251, '\p{Lowercase=:\ANo\z:}', "");;
    Expect(1, 125252, '\p{Lowercase=no}', "");
    Expect(0, 125252, '\p{^Lowercase=no}', "");
    Expect(0, 125252, '\P{Lowercase=no}', "");
    Expect(1, 125252, '\P{^Lowercase=no}', "");
    Expect(0, 125251, '\p{Lowercase=no}', "");
    Expect(1, 125251, '\p{^Lowercase=no}', "");
    Expect(1, 125251, '\P{Lowercase=no}', "");
    Expect(0, 125251, '\P{^Lowercase=no}', "");
    Expect(1, 125252, '\p{Lowercase=:\Ano\z:}', "");;
    Expect(0, 125251, '\p{Lowercase=:\Ano\z:}', "");;
    Expect(1, 125252, '\p{Lowercase=_No}', "");
    Expect(0, 125252, '\p{^Lowercase=_No}', "");
    Expect(0, 125252, '\P{Lowercase=_No}', "");
    Expect(1, 125252, '\P{^Lowercase=_No}', "");
    Expect(0, 125251, '\p{Lowercase=_No}', "");
    Expect(1, 125251, '\p{^Lowercase=_No}', "");
    Expect(1, 125251, '\P{Lowercase=_No}', "");
    Expect(0, 125251, '\P{^Lowercase=_No}', "");
    Error('\p{Lower= _N:=}');
    Error('\P{Lower= _N:=}');
    Expect(1, 125252, '\p{Lower=:\AN\z:}', "");;
    Expect(0, 125251, '\p{Lower=:\AN\z:}', "");;
    Expect(1, 125252, '\p{Lower=n}', "");
    Expect(0, 125252, '\p{^Lower=n}', "");
    Expect(0, 125252, '\P{Lower=n}', "");
    Expect(1, 125252, '\P{^Lower=n}', "");
    Expect(0, 125251, '\p{Lower=n}', "");
    Expect(1, 125251, '\p{^Lower=n}', "");
    Expect(1, 125251, '\P{Lower=n}', "");
    Expect(0, 125251, '\P{^Lower=n}', "");
    Expect(1, 125252, '\p{Lower=:\An\z:}', "");;
    Expect(0, 125251, '\p{Lower=:\An\z:}', "");;
    Expect(1, 125252, '\p{Lower= -N}', "");
    Expect(0, 125252, '\p{^Lower= -N}', "");
    Expect(0, 125252, '\P{Lower= -N}', "");
    Expect(1, 125252, '\P{^Lower= -N}', "");
    Expect(0, 125251, '\p{Lower= -N}', "");
    Expect(1, 125251, '\p{^Lower= -N}', "");
    Expect(1, 125251, '\P{Lower= -N}', "");
    Expect(0, 125251, '\P{^Lower= -N}', "");
    Error('\p{Is_Lowercase=-	F:=}');
    Error('\P{Is_Lowercase=-	F:=}');
    Expect(1, 125252, '\p{Is_Lowercase=f}', "");
    Expect(0, 125252, '\p{^Is_Lowercase=f}', "");
    Expect(0, 125252, '\P{Is_Lowercase=f}', "");
    Expect(1, 125252, '\P{^Is_Lowercase=f}', "");
    Expect(0, 125251, '\p{Is_Lowercase=f}', "");
    Expect(1, 125251, '\p{^Is_Lowercase=f}', "");
    Expect(1, 125251, '\P{Is_Lowercase=f}', "");
    Expect(0, 125251, '\P{^Is_Lowercase=f}', "");
    Expect(1, 125252, '\p{Is_Lowercase= F}', "");
    Expect(0, 125252, '\p{^Is_Lowercase= F}', "");
    Expect(0, 125252, '\P{Is_Lowercase= F}', "");
    Expect(1, 125252, '\P{^Is_Lowercase= F}', "");
    Expect(0, 125251, '\p{Is_Lowercase= F}', "");
    Expect(1, 125251, '\p{^Is_Lowercase= F}', "");
    Expect(1, 125251, '\P{Is_Lowercase= F}', "");
    Expect(0, 125251, '\P{^Is_Lowercase= F}', "");
    Error('\p{Is_Lower=:=False}');
    Error('\P{Is_Lower=:=False}');
    Expect(1, 125252, '\p{Is_Lower=false}', "");
    Expect(0, 125252, '\p{^Is_Lower=false}', "");
    Expect(0, 125252, '\P{Is_Lower=false}', "");
    Expect(1, 125252, '\P{^Is_Lower=false}', "");
    Expect(0, 125251, '\p{Is_Lower=false}', "");
    Expect(1, 125251, '\p{^Is_Lower=false}', "");
    Expect(1, 125251, '\P{Is_Lower=false}', "");
    Expect(0, 125251, '\P{^Is_Lower=false}', "");
    Error('\p{Lowercase=-Yes/a/}');
    Error('\P{Lowercase=-Yes/a/}');
    Expect(1, 125251, '\p{Lowercase=:\AYes\z:}', "");;
    Expect(0, 125252, '\p{Lowercase=:\AYes\z:}', "");;
    Expect(1, 125251, '\p{Lowercase=yes}', "");
    Expect(0, 125251, '\p{^Lowercase=yes}', "");
    Expect(0, 125251, '\P{Lowercase=yes}', "");
    Expect(1, 125251, '\P{^Lowercase=yes}', "");
    Expect(0, 125252, '\p{Lowercase=yes}', "");
    Expect(1, 125252, '\p{^Lowercase=yes}', "");
    Expect(1, 125252, '\P{Lowercase=yes}', "");
    Expect(0, 125252, '\P{^Lowercase=yes}', "");
    Expect(1, 125251, '\p{Lowercase=:\Ayes\z:}', "");;
    Expect(0, 125252, '\p{Lowercase=:\Ayes\z:}', "");;
    Expect(1, 125251, '\p{Lowercase=_-YES}', "");
    Expect(0, 125251, '\p{^Lowercase=_-YES}', "");
    Expect(0, 125251, '\P{Lowercase=_-YES}', "");
    Expect(1, 125251, '\P{^Lowercase=_-YES}', "");
    Expect(0, 125252, '\p{Lowercase=_-YES}', "");
    Expect(1, 125252, '\p{^Lowercase=_-YES}', "");
    Expect(1, 125252, '\P{Lowercase=_-YES}', "");
    Expect(0, 125252, '\P{^Lowercase=_-YES}', "");
    Error('\p{Lower=_Y:=}');
    Error('\P{Lower=_Y:=}');
    Expect(1, 125251, '\p{Lower=:\AY\z:}', "");;
    Expect(0, 125252, '\p{Lower=:\AY\z:}', "");;
    Expect(1, 125251, '\p{Lower=y}', "");
    Expect(0, 125251, '\p{^Lower=y}', "");
    Expect(0, 125251, '\P{Lower=y}', "");
    Expect(1, 125251, '\P{^Lower=y}', "");
    Expect(0, 125252, '\p{Lower=y}', "");
    Expect(1, 125252, '\p{^Lower=y}', "");
    Expect(1, 125252, '\P{Lower=y}', "");
    Expect(0, 125252, '\P{^Lower=y}', "");
    Expect(1, 125251, '\p{Lower=:\Ay\z:}', "");;
    Expect(0, 125252, '\p{Lower=:\Ay\z:}', "");;
    Expect(1, 125251, '\p{Lower=		Y}', "");
    Expect(0, 125251, '\p{^Lower=		Y}', "");
    Expect(0, 125251, '\P{Lower=		Y}', "");
    Expect(1, 125251, '\P{^Lower=		Y}', "");
    Expect(0, 125252, '\p{Lower=		Y}', "");
    Expect(1, 125252, '\p{^Lower=		Y}', "");
    Expect(1, 125252, '\P{Lower=		Y}', "");
    Expect(0, 125252, '\P{^Lower=		Y}', "");
    Error('\p{Is_Lowercase=	/a/T}');
    Error('\P{Is_Lowercase=	/a/T}');
    Expect(1, 125251, '\p{Is_Lowercase=t}', "");
    Expect(0, 125251, '\p{^Is_Lowercase=t}', "");
    Expect(0, 125251, '\P{Is_Lowercase=t}', "");
    Expect(1, 125251, '\P{^Is_Lowercase=t}', "");
    Expect(0, 125252, '\p{Is_Lowercase=t}', "");
    Expect(1, 125252, '\p{^Is_Lowercase=t}', "");
    Expect(1, 125252, '\P{Is_Lowercase=t}', "");
    Expect(0, 125252, '\P{^Is_Lowercase=t}', "");
    Expect(1, 125251, '\p{Is_Lowercase=	-T}', "");
    Expect(0, 125251, '\p{^Is_Lowercase=	-T}', "");
    Expect(0, 125251, '\P{Is_Lowercase=	-T}', "");
    Expect(1, 125251, '\P{^Is_Lowercase=	-T}', "");
    Expect(0, 125252, '\p{Is_Lowercase=	-T}', "");
    Expect(1, 125252, '\p{^Is_Lowercase=	-T}', "");
    Expect(1, 125252, '\P{Is_Lowercase=	-T}', "");
    Expect(0, 125252, '\P{^Is_Lowercase=	-T}', "");
    Error('\p{Is_Lower=/a/ 	TRUE}');
    Error('\P{Is_Lower=/a/ 	TRUE}');
    Expect(1, 125251, '\p{Is_Lower=true}', "");
    Expect(0, 125251, '\p{^Is_Lower=true}', "");
    Expect(0, 125251, '\P{Is_Lower=true}', "");
    Expect(1, 125251, '\P{^Is_Lower=true}', "");
    Expect(0, 125252, '\p{Is_Lower=true}', "");
    Expect(1, 125252, '\p{^Is_Lower=true}', "");
    Expect(1, 125252, '\P{Is_Lower=true}', "");
    Expect(0, 125252, '\P{^Is_Lower=true}', "");
    Expect(1, 125251, '\p{Is_Lower: -TRUE}', "");
    Expect(0, 125251, '\p{^Is_Lower: -TRUE}', "");
    Expect(0, 125251, '\P{Is_Lower: -TRUE}', "");
    Expect(1, 125251, '\P{^Is_Lower: -TRUE}', "");
    Expect(0, 125252, '\p{Is_Lower: -TRUE}', "");
    Expect(1, 125252, '\p{^Is_Lower: -TRUE}', "");
    Expect(1, 125252, '\P{Is_Lower: -TRUE}', "");
    Expect(0, 125252, '\P{^Is_Lower: -TRUE}', "");
    Error('\p{Math=/a/  No}');
    Error('\P{Math=/a/  No}');
    Expect(1, 126706, '\p{Math=:\ANo\z:}', "");;
    Expect(0, 126705, '\p{Math=:\ANo\z:}', "");;
    Expect(1, 126706, '\p{Math=no}', "");
    Expect(0, 126706, '\p{^Math=no}', "");
    Expect(0, 126706, '\P{Math=no}', "");
    Expect(1, 126706, '\P{^Math=no}', "");
    Expect(0, 126705, '\p{Math=no}', "");
    Expect(1, 126705, '\p{^Math=no}', "");
    Expect(1, 126705, '\P{Math=no}', "");
    Expect(0, 126705, '\P{^Math=no}', "");
    Expect(1, 126706, '\p{Math=:\Ano\z:}', "");;
    Expect(0, 126705, '\p{Math=:\Ano\z:}', "");;
    Expect(1, 126706, '\p{Math= 	NO}', "");
    Expect(0, 126706, '\p{^Math= 	NO}', "");
    Expect(0, 126706, '\P{Math= 	NO}', "");
    Expect(1, 126706, '\P{^Math= 	NO}', "");
    Expect(0, 126705, '\p{Math= 	NO}', "");
    Expect(1, 126705, '\p{^Math= 	NO}', "");
    Expect(1, 126705, '\P{Math= 	NO}', "");
    Expect(0, 126705, '\P{^Math= 	NO}', "");
    Error('\p{Is_Math=	:=N}');
    Error('\P{Is_Math=	:=N}');
    Expect(1, 126706, '\p{Is_Math=n}', "");
    Expect(0, 126706, '\p{^Is_Math=n}', "");
    Expect(0, 126706, '\P{Is_Math=n}', "");
    Expect(1, 126706, '\P{^Is_Math=n}', "");
    Expect(0, 126705, '\p{Is_Math=n}', "");
    Expect(1, 126705, '\p{^Is_Math=n}', "");
    Expect(1, 126705, '\P{Is_Math=n}', "");
    Expect(0, 126705, '\P{^Is_Math=n}', "");
    Expect(1, 126706, '\p{Is_Math=N}', "");
    Expect(0, 126706, '\p{^Is_Math=N}', "");
    Expect(0, 126706, '\P{Is_Math=N}', "");
    Expect(1, 126706, '\P{^Is_Math=N}', "");
    Expect(0, 126705, '\p{Is_Math=N}', "");
    Expect(1, 126705, '\p{^Is_Math=N}', "");
    Expect(1, 126705, '\P{Is_Math=N}', "");
    Expect(0, 126705, '\P{^Is_Math=N}', "");
    Error('\p{Math: -:=F}');
    Error('\P{Math: -:=F}');
    Expect(1, 126706, '\p{Math=:\AF\z:}', "");;
    Expect(0, 126705, '\p{Math=:\AF\z:}', "");;
    Expect(1, 126706, '\p{Math=f}', "");
    Expect(0, 126706, '\p{^Math=f}', "");
    Expect(0, 126706, '\P{Math=f}', "");
    Expect(1, 126706, '\P{^Math=f}', "");
    Expect(0, 126705, '\p{Math=f}', "");
    Expect(1, 126705, '\p{^Math=f}', "");
    Expect(1, 126705, '\P{Math=f}', "");
    Expect(0, 126705, '\P{^Math=f}', "");
    Expect(1, 126706, '\p{Math=:\Af\z:}', "");;
    Expect(0, 126705, '\p{Math=:\Af\z:}', "");;
    Expect(1, 126706, '\p{Math=	F}', "");
    Expect(0, 126706, '\p{^Math=	F}', "");
    Expect(0, 126706, '\P{Math=	F}', "");
    Expect(1, 126706, '\P{^Math=	F}', "");
    Expect(0, 126705, '\p{Math=	F}', "");
    Expect(1, 126705, '\p{^Math=	F}', "");
    Expect(1, 126705, '\P{Math=	F}', "");
    Expect(0, 126705, '\P{^Math=	F}', "");
    Error('\p{Is_Math=/a/  False}');
    Error('\P{Is_Math=/a/  False}');
    Expect(1, 126706, '\p{Is_Math=false}', "");
    Expect(0, 126706, '\p{^Is_Math=false}', "");
    Expect(0, 126706, '\P{Is_Math=false}', "");
    Expect(1, 126706, '\P{^Is_Math=false}', "");
    Expect(0, 126705, '\p{Is_Math=false}', "");
    Expect(1, 126705, '\p{^Is_Math=false}', "");
    Expect(1, 126705, '\P{Is_Math=false}', "");
    Expect(0, 126705, '\P{^Is_Math=false}', "");
    Expect(1, 126706, '\p{Is_Math:	  False}', "");
    Expect(0, 126706, '\p{^Is_Math:	  False}', "");
    Expect(0, 126706, '\P{Is_Math:	  False}', "");
    Expect(1, 126706, '\P{^Is_Math:	  False}', "");
    Expect(0, 126705, '\p{Is_Math:	  False}', "");
    Expect(1, 126705, '\p{^Is_Math:	  False}', "");
    Expect(1, 126705, '\P{Is_Math:	  False}', "");
    Expect(0, 126705, '\P{^Is_Math:	  False}', "");
    Error('\p{Math=- Yes:=}');
    Error('\P{Math=- Yes:=}');
    Expect(1, 126705, '\p{Math=:\AYes\z:}', "");;
    Expect(0, 126706, '\p{Math=:\AYes\z:}', "");;
    Expect(1, 126705, '\p{Math=yes}', "");
    Expect(0, 126705, '\p{^Math=yes}', "");
    Expect(0, 126705, '\P{Math=yes}', "");
    Expect(1, 126705, '\P{^Math=yes}', "");
    Expect(0, 126706, '\p{Math=yes}', "");
    Expect(1, 126706, '\p{^Math=yes}', "");
    Expect(1, 126706, '\P{Math=yes}', "");
    Expect(0, 126706, '\P{^Math=yes}', "");
    Expect(1, 126705, '\p{Math=:\Ayes\z:}', "");;
    Expect(0, 126706, '\p{Math=:\Ayes\z:}', "");;
    Expect(1, 126705, '\p{Math=  yes}', "");
    Expect(0, 126705, '\p{^Math=  yes}', "");
    Expect(0, 126705, '\P{Math=  yes}', "");
    Expect(1, 126705, '\P{^Math=  yes}', "");
    Expect(0, 126706, '\p{Math=  yes}', "");
    Expect(1, 126706, '\p{^Math=  yes}', "");
    Expect(1, 126706, '\P{Math=  yes}', "");
    Expect(0, 126706, '\P{^Math=  yes}', "");
    Error('\p{Is_Math=		y:=}');
    Error('\P{Is_Math=		y:=}');
    Expect(1, 126705, '\p{Is_Math=y}', "");
    Expect(0, 126705, '\p{^Is_Math=y}', "");
    Expect(0, 126705, '\P{Is_Math=y}', "");
    Expect(1, 126705, '\P{^Is_Math=y}', "");
    Expect(0, 126706, '\p{Is_Math=y}', "");
    Expect(1, 126706, '\p{^Is_Math=y}', "");
    Expect(1, 126706, '\P{Is_Math=y}', "");
    Expect(0, 126706, '\P{^Is_Math=y}', "");
    Expect(1, 126705, '\p{Is_Math:  _Y}', "");
    Expect(0, 126705, '\p{^Is_Math:  _Y}', "");
    Expect(0, 126705, '\P{Is_Math:  _Y}', "");
    Expect(1, 126705, '\P{^Is_Math:  _Y}', "");
    Expect(0, 126706, '\p{Is_Math:  _Y}', "");
    Expect(1, 126706, '\p{^Is_Math:  _Y}', "");
    Expect(1, 126706, '\P{Is_Math:  _Y}', "");
    Expect(0, 126706, '\P{^Is_Math:  _Y}', "");
    Error('\p{Math=/a/_t}');
    Error('\P{Math=/a/_t}');
    Expect(1, 126705, '\p{Math=:\AT\z:}', "");;
    Expect(0, 126706, '\p{Math=:\AT\z:}', "");;
    Expect(1, 126705, '\p{Math=t}', "");
    Expect(0, 126705, '\p{^Math=t}', "");
    Expect(0, 126705, '\P{Math=t}', "");
    Expect(1, 126705, '\P{^Math=t}', "");
    Expect(0, 126706, '\p{Math=t}', "");
    Expect(1, 126706, '\p{^Math=t}', "");
    Expect(1, 126706, '\P{Math=t}', "");
    Expect(0, 126706, '\P{^Math=t}', "");
    Expect(1, 126705, '\p{Math=:\At\z:}', "");;
    Expect(0, 126706, '\p{Math=:\At\z:}', "");;
    Expect(1, 126705, '\p{Math=-T}', "");
    Expect(0, 126705, '\p{^Math=-T}', "");
    Expect(0, 126705, '\P{Math=-T}', "");
    Expect(1, 126705, '\P{^Math=-T}', "");
    Expect(0, 126706, '\p{Math=-T}', "");
    Expect(1, 126706, '\p{^Math=-T}', "");
    Expect(1, 126706, '\P{Math=-T}', "");
    Expect(0, 126706, '\P{^Math=-T}', "");
    Error('\p{Is_Math=-/a/True}');
    Error('\P{Is_Math=-/a/True}');
    Expect(1, 126705, '\p{Is_Math=true}', "");
    Expect(0, 126705, '\p{^Is_Math=true}', "");
    Expect(0, 126705, '\P{Is_Math=true}', "");
    Expect(1, 126705, '\P{^Is_Math=true}', "");
    Expect(0, 126706, '\p{Is_Math=true}', "");
    Expect(1, 126706, '\p{^Is_Math=true}', "");
    Expect(1, 126706, '\P{Is_Math=true}', "");
    Expect(0, 126706, '\P{^Is_Math=true}', "");
    Expect(1, 126705, '\p{Is_Math=	-TRUE}', "");
    Expect(0, 126705, '\p{^Is_Math=	-TRUE}', "");
    Expect(0, 126705, '\P{Is_Math=	-TRUE}', "");
    Expect(1, 126705, '\P{^Is_Math=	-TRUE}', "");
    Expect(0, 126706, '\p{Is_Math=	-TRUE}', "");
    Expect(1, 126706, '\p{^Is_Math=	-TRUE}', "");
    Expect(1, 126706, '\P{Is_Math=	-TRUE}', "");
    Expect(0, 126706, '\P{^Is_Math=	-TRUE}', "");
    Error('\p{name}');
    Error('\P{name}');
    Error('\p{na}');
    Error('\P{na}');
    Error('\p{unicode1name}');
    Error('\P{unicode1name}');
    Error('\p{na1}');
    Error('\P{na1}');
    Error('\p{namealias}');
    Error('\P{namealias}');
    Error('\p{_perlnamealias}');
    Error('\P{_perlnamealias}');
    Error('\p{Noncharacter_Code_Point=:=	-No}');
    Error('\P{Noncharacter_Code_Point=:=	-No}');
    Expect(1, 1114109, '\p{Noncharacter_Code_Point=:\ANo\z:}', "");;
    Expect(0, 1114111, '\p{Noncharacter_Code_Point=:\ANo\z:}', "");;
    Expect(1, 1114109, '\p{Noncharacter_Code_Point:	no}', "");
    Expect(0, 1114109, '\p{^Noncharacter_Code_Point:	no}', "");
    Expect(0, 1114109, '\P{Noncharacter_Code_Point:	no}', "");
    Expect(1, 1114109, '\P{^Noncharacter_Code_Point:	no}', "");
    Expect(0, 1114111, '\p{Noncharacter_Code_Point:	no}', "");
    Expect(1, 1114111, '\p{^Noncharacter_Code_Point:	no}', "");
    Expect(1, 1114111, '\P{Noncharacter_Code_Point:	no}', "");
    Expect(0, 1114111, '\P{^Noncharacter_Code_Point:	no}', "");
    Expect(1, 1114109, '\p{Noncharacter_Code_Point=:\Ano\z:}', "");;
    Expect(0, 1114111, '\p{Noncharacter_Code_Point=:\Ano\z:}', "");;
    Expect(1, 1114109, '\p{Noncharacter_Code_Point=		No}', "");
    Expect(0, 1114109, '\p{^Noncharacter_Code_Point=		No}', "");
    Expect(0, 1114109, '\P{Noncharacter_Code_Point=		No}', "");
    Expect(1, 1114109, '\P{^Noncharacter_Code_Point=		No}', "");
    Expect(0, 1114111, '\p{Noncharacter_Code_Point=		No}', "");
    Expect(1, 1114111, '\p{^Noncharacter_Code_Point=		No}', "");
    Expect(1, 1114111, '\P{Noncharacter_Code_Point=		No}', "");
    Expect(0, 1114111, '\P{^Noncharacter_Code_Point=		No}', "");
    Error('\p{NChar=:=_-N}');
    Error('\P{NChar=:=_-N}');
    Expect(1, 1114109, '\p{NChar=:\AN\z:}', "");;
    Expect(0, 1114111, '\p{NChar=:\AN\z:}', "");;
    Expect(1, 1114109, '\p{NChar=n}', "");
    Expect(0, 1114109, '\p{^NChar=n}', "");
    Expect(0, 1114109, '\P{NChar=n}', "");
    Expect(1, 1114109, '\P{^NChar=n}', "");
    Expect(0, 1114111, '\p{NChar=n}', "");
    Expect(1, 1114111, '\p{^NChar=n}', "");
    Expect(1, 1114111, '\P{NChar=n}', "");
    Expect(0, 1114111, '\P{^NChar=n}', "");
    Expect(1, 1114109, '\p{NChar=:\An\z:}', "");;
    Expect(0, 1114111, '\p{NChar=:\An\z:}', "");;
    Expect(1, 1114109, '\p{NChar:-N}', "");
    Expect(0, 1114109, '\p{^NChar:-N}', "");
    Expect(0, 1114109, '\P{NChar:-N}', "");
    Expect(1, 1114109, '\P{^NChar:-N}', "");
    Expect(0, 1114111, '\p{NChar:-N}', "");
    Expect(1, 1114111, '\p{^NChar:-N}', "");
    Expect(1, 1114111, '\P{NChar:-N}', "");
    Expect(0, 1114111, '\P{^NChar:-N}', "");
    Error('\p{Is_Noncharacter_Code_Point=:=	f}');
    Error('\P{Is_Noncharacter_Code_Point=:=	f}');
    Expect(1, 1114109, '\p{Is_Noncharacter_Code_Point=f}', "");
    Expect(0, 1114109, '\p{^Is_Noncharacter_Code_Point=f}', "");
    Expect(0, 1114109, '\P{Is_Noncharacter_Code_Point=f}', "");
    Expect(1, 1114109, '\P{^Is_Noncharacter_Code_Point=f}', "");
    Expect(0, 1114111, '\p{Is_Noncharacter_Code_Point=f}', "");
    Expect(1, 1114111, '\p{^Is_Noncharacter_Code_Point=f}', "");
    Expect(1, 1114111, '\P{Is_Noncharacter_Code_Point=f}', "");
    Expect(0, 1114111, '\P{^Is_Noncharacter_Code_Point=f}', "");
    Expect(1, 1114109, '\p{Is_Noncharacter_Code_Point=_f}', "");
    Expect(0, 1114109, '\p{^Is_Noncharacter_Code_Point=_f}', "");
    Expect(0, 1114109, '\P{Is_Noncharacter_Code_Point=_f}', "");
    Expect(1, 1114109, '\P{^Is_Noncharacter_Code_Point=_f}', "");
    Expect(0, 1114111, '\p{Is_Noncharacter_Code_Point=_f}', "");
    Expect(1, 1114111, '\p{^Is_Noncharacter_Code_Point=_f}', "");
    Expect(1, 1114111, '\P{Is_Noncharacter_Code_Point=_f}', "");
    Expect(0, 1114111, '\P{^Is_Noncharacter_Code_Point=_f}', "");
    Error('\p{Is_NChar=:=-FALSE}');
    Error('\P{Is_NChar=:=-FALSE}');
    Expect(1, 1114109, '\p{Is_NChar=false}', "");
    Expect(0, 1114109, '\p{^Is_NChar=false}', "");
    Expect(0, 1114109, '\P{Is_NChar=false}', "");
    Expect(1, 1114109, '\P{^Is_NChar=false}', "");
    Expect(0, 1114111, '\p{Is_NChar=false}', "");
    Expect(1, 1114111, '\p{^Is_NChar=false}', "");
    Expect(1, 1114111, '\P{Is_NChar=false}', "");
    Expect(0, 1114111, '\P{^Is_NChar=false}', "");
    Expect(1, 1114109, '\p{Is_NChar= -false}', "");
    Expect(0, 1114109, '\p{^Is_NChar= -false}', "");
    Expect(0, 1114109, '\P{Is_NChar= -false}', "");
    Expect(1, 1114109, '\P{^Is_NChar= -false}', "");
    Expect(0, 1114111, '\p{Is_NChar= -false}', "");
    Expect(1, 1114111, '\p{^Is_NChar= -false}', "");
    Expect(1, 1114111, '\P{Is_NChar= -false}', "");
    Expect(0, 1114111, '\P{^Is_NChar= -false}', "");
    Error('\p{Noncharacter_Code_Point=:= -Yes}');
    Error('\P{Noncharacter_Code_Point=:= -Yes}');
    Expect(1, 1114111, '\p{Noncharacter_Code_Point=:\AYes\z:}', "");;
    Expect(0, 1114109, '\p{Noncharacter_Code_Point=:\AYes\z:}', "");;
    Expect(1, 1114111, '\p{Noncharacter_Code_Point=yes}', "");
    Expect(0, 1114111, '\p{^Noncharacter_Code_Point=yes}', "");
    Expect(0, 1114111, '\P{Noncharacter_Code_Point=yes}', "");
    Expect(1, 1114111, '\P{^Noncharacter_Code_Point=yes}', "");
    Expect(0, 1114109, '\p{Noncharacter_Code_Point=yes}', "");
    Expect(1, 1114109, '\p{^Noncharacter_Code_Point=yes}', "");
    Expect(1, 1114109, '\P{Noncharacter_Code_Point=yes}', "");
    Expect(0, 1114109, '\P{^Noncharacter_Code_Point=yes}', "");
    Expect(1, 1114111, '\p{Noncharacter_Code_Point=:\Ayes\z:}', "");;
    Expect(0, 1114109, '\p{Noncharacter_Code_Point=:\Ayes\z:}', "");;
    Expect(1, 1114111, '\p{Noncharacter_Code_Point:  _YES}', "");
    Expect(0, 1114111, '\p{^Noncharacter_Code_Point:  _YES}', "");
    Expect(0, 1114111, '\P{Noncharacter_Code_Point:  _YES}', "");
    Expect(1, 1114111, '\P{^Noncharacter_Code_Point:  _YES}', "");
    Expect(0, 1114109, '\p{Noncharacter_Code_Point:  _YES}', "");
    Expect(1, 1114109, '\p{^Noncharacter_Code_Point:  _YES}', "");
    Expect(1, 1114109, '\P{Noncharacter_Code_Point:  _YES}', "");
    Expect(0, 1114109, '\P{^Noncharacter_Code_Point:  _YES}', "");
    Error('\p{NChar=_	Y/a/}');
    Error('\P{NChar=_	Y/a/}');
    Expect(1, 1114111, '\p{NChar=:\AY\z:}', "");;
    Expect(0, 1114109, '\p{NChar=:\AY\z:}', "");;
    Expect(1, 1114111, '\p{NChar=y}', "");
    Expect(0, 1114111, '\p{^NChar=y}', "");
    Expect(0, 1114111, '\P{NChar=y}', "");
    Expect(1, 1114111, '\P{^NChar=y}', "");
    Expect(0, 1114109, '\p{NChar=y}', "");
    Expect(1, 1114109, '\p{^NChar=y}', "");
    Expect(1, 1114109, '\P{NChar=y}', "");
    Expect(0, 1114109, '\P{^NChar=y}', "");
    Expect(1, 1114111, '\p{NChar=:\Ay\z:}', "");;
    Expect(0, 1114109, '\p{NChar=:\Ay\z:}', "");;
    Expect(1, 1114111, '\p{NChar=_-Y}', "");
    Expect(0, 1114111, '\p{^NChar=_-Y}', "");
    Expect(0, 1114111, '\P{NChar=_-Y}', "");
    Expect(1, 1114111, '\P{^NChar=_-Y}', "");
    Expect(0, 1114109, '\p{NChar=_-Y}', "");
    Expect(1, 1114109, '\p{^NChar=_-Y}', "");
    Expect(1, 1114109, '\P{NChar=_-Y}', "");
    Expect(0, 1114109, '\P{^NChar=_-Y}', "");
    Error('\p{Is_Noncharacter_Code_Point=_	T:=}');
    Error('\P{Is_Noncharacter_Code_Point=_	T:=}');
    Expect(1, 1114111, '\p{Is_Noncharacter_Code_Point=t}', "");
    Expect(0, 1114111, '\p{^Is_Noncharacter_Code_Point=t}', "");
    Expect(0, 1114111, '\P{Is_Noncharacter_Code_Point=t}', "");
    Expect(1, 1114111, '\P{^Is_Noncharacter_Code_Point=t}', "");
    Expect(0, 1114109, '\p{Is_Noncharacter_Code_Point=t}', "");
    Expect(1, 1114109, '\p{^Is_Noncharacter_Code_Point=t}', "");
    Expect(1, 1114109, '\P{Is_Noncharacter_Code_Point=t}', "");
    Expect(0, 1114109, '\P{^Is_Noncharacter_Code_Point=t}', "");
    Expect(1, 1114111, '\p{Is_Noncharacter_Code_Point: -T}', "");
    Expect(0, 1114111, '\p{^Is_Noncharacter_Code_Point: -T}', "");
    Expect(0, 1114111, '\P{Is_Noncharacter_Code_Point: -T}', "");
    Expect(1, 1114111, '\P{^Is_Noncharacter_Code_Point: -T}', "");
    Expect(0, 1114109, '\p{Is_Noncharacter_Code_Point: -T}', "");
    Expect(1, 1114109, '\p{^Is_Noncharacter_Code_Point: -T}', "");
    Expect(1, 1114109, '\P{Is_Noncharacter_Code_Point: -T}', "");
    Expect(0, 1114109, '\P{^Is_Noncharacter_Code_Point: -T}', "");
    Error('\p{Is_NChar=/a/ _TRUE}');
    Error('\P{Is_NChar=/a/ _TRUE}');
    Expect(1, 1114111, '\p{Is_NChar=true}', "");
    Expect(0, 1114111, '\p{^Is_NChar=true}', "");
    Expect(0, 1114111, '\P{Is_NChar=true}', "");
    Expect(1, 1114111, '\P{^Is_NChar=true}', "");
    Expect(0, 1114109, '\p{Is_NChar=true}', "");
    Expect(1, 1114109, '\p{^Is_NChar=true}', "");
    Expect(1, 1114109, '\P{Is_NChar=true}', "");
    Expect(0, 1114109, '\P{^Is_NChar=true}', "");
    Expect(1, 1114111, '\p{Is_NChar=	TRUE}', "");
    Expect(0, 1114111, '\p{^Is_NChar=	TRUE}', "");
    Expect(0, 1114111, '\P{Is_NChar=	TRUE}', "");
    Expect(1, 1114111, '\P{^Is_NChar=	TRUE}', "");
    Expect(0, 1114109, '\p{Is_NChar=	TRUE}', "");
    Expect(1, 1114109, '\p{^Is_NChar=	TRUE}', "");
    Expect(1, 1114109, '\P{Is_NChar=	TRUE}', "");
    Expect(0, 1114109, '\P{^Is_NChar=	TRUE}', "");
    Error('\p{nfcquickcheck}');
    Error('\P{nfcquickcheck}');
    Error('\p{nfcqc}');
    Error('\P{nfcqc}');
    Error('\p{NFC_Quick_Check=_-MAYBE:=}');
    Error('\P{NFC_Quick_Check=_-MAYBE:=}');
    Expect(1, 71984, '\p{NFC_Quick_Check=:\AMaybe\z:}', "");;
    Expect(0, 71985, '\p{NFC_Quick_Check=:\AMaybe\z:}', "");;
    Expect(1, 71984, '\p{NFC_Quick_Check=maybe}', "");
    Expect(0, 71984, '\p{^NFC_Quick_Check=maybe}', "");
    Expect(0, 71984, '\P{NFC_Quick_Check=maybe}', "");
    Expect(1, 71984, '\P{^NFC_Quick_Check=maybe}', "");
    Expect(0, 71985, '\p{NFC_Quick_Check=maybe}', "");
    Expect(1, 71985, '\p{^NFC_Quick_Check=maybe}', "");
    Expect(1, 71985, '\P{NFC_Quick_Check=maybe}', "");
    Expect(0, 71985, '\P{^NFC_Quick_Check=maybe}', "");
    Expect(1, 71984, '\p{NFC_Quick_Check=:\Amaybe\z:}', "");;
    Expect(0, 71985, '\p{NFC_Quick_Check=:\Amaybe\z:}', "");;
    Expect(1, 71984, '\p{NFC_Quick_Check=_Maybe}', "");
    Expect(0, 71984, '\p{^NFC_Quick_Check=_Maybe}', "");
    Expect(0, 71984, '\P{NFC_Quick_Check=_Maybe}', "");
    Expect(1, 71984, '\P{^NFC_Quick_Check=_Maybe}', "");
    Expect(0, 71985, '\p{NFC_Quick_Check=_Maybe}', "");
    Expect(1, 71985, '\p{^NFC_Quick_Check=_Maybe}', "");
    Expect(1, 71985, '\P{NFC_Quick_Check=_Maybe}', "");
    Expect(0, 71985, '\P{^NFC_Quick_Check=_Maybe}', "");
    Error('\p{NFC_QC=  M:=}');
    Error('\P{NFC_QC=  M:=}');
    Expect(1, 71984, '\p{NFC_QC=:\AM\z:}', "");;
    Expect(0, 71985, '\p{NFC_QC=:\AM\z:}', "");;
    Expect(1, 71984, '\p{NFC_QC=m}', "");
    Expect(0, 71984, '\p{^NFC_QC=m}', "");
    Expect(0, 71984, '\P{NFC_QC=m}', "");
    Expect(1, 71984, '\P{^NFC_QC=m}', "");
    Expect(0, 71985, '\p{NFC_QC=m}', "");
    Expect(1, 71985, '\p{^NFC_QC=m}', "");
    Expect(1, 71985, '\P{NFC_QC=m}', "");
    Expect(0, 71985, '\P{^NFC_QC=m}', "");
    Expect(1, 71984, '\p{NFC_QC=:\Am\z:}', "");;
    Expect(0, 71985, '\p{NFC_QC=:\Am\z:}', "");;
    Expect(1, 71984, '\p{NFC_QC=_M}', "");
    Expect(0, 71984, '\p{^NFC_QC=_M}', "");
    Expect(0, 71984, '\P{NFC_QC=_M}', "");
    Expect(1, 71984, '\P{^NFC_QC=_M}', "");
    Expect(0, 71985, '\p{NFC_QC=_M}', "");
    Expect(1, 71985, '\p{^NFC_QC=_M}', "");
    Expect(1, 71985, '\P{NFC_QC=_M}', "");
    Expect(0, 71985, '\P{^NFC_QC=_M}', "");
    Error('\p{Is_NFC_Quick_Check: 	Maybe/a/}');
    Error('\P{Is_NFC_Quick_Check: 	Maybe/a/}');
    Expect(1, 71984, '\p{Is_NFC_Quick_Check=maybe}', "");
    Expect(0, 71984, '\p{^Is_NFC_Quick_Check=maybe}', "");
    Expect(0, 71984, '\P{Is_NFC_Quick_Check=maybe}', "");
    Expect(1, 71984, '\P{^Is_NFC_Quick_Check=maybe}', "");
    Expect(0, 71985, '\p{Is_NFC_Quick_Check=maybe}', "");
    Expect(1, 71985, '\p{^Is_NFC_Quick_Check=maybe}', "");
    Expect(1, 71985, '\P{Is_NFC_Quick_Check=maybe}', "");
    Expect(0, 71985, '\P{^Is_NFC_Quick_Check=maybe}', "");
    Expect(1, 71984, '\p{Is_NFC_Quick_Check=	MAYBE}', "");
    Expect(0, 71984, '\p{^Is_NFC_Quick_Check=	MAYBE}', "");
    Expect(0, 71984, '\P{Is_NFC_Quick_Check=	MAYBE}', "");
    Expect(1, 71984, '\P{^Is_NFC_Quick_Check=	MAYBE}', "");
    Expect(0, 71985, '\p{Is_NFC_Quick_Check=	MAYBE}', "");
    Expect(1, 71985, '\p{^Is_NFC_Quick_Check=	MAYBE}', "");
    Expect(1, 71985, '\P{Is_NFC_Quick_Check=	MAYBE}', "");
    Expect(0, 71985, '\P{^Is_NFC_Quick_Check=	MAYBE}', "");
    Error('\p{Is_NFC_QC=	-M:=}');
    Error('\P{Is_NFC_QC=	-M:=}');
    Expect(1, 71984, '\p{Is_NFC_QC=m}', "");
    Expect(0, 71984, '\p{^Is_NFC_QC=m}', "");
    Expect(0, 71984, '\P{Is_NFC_QC=m}', "");
    Expect(1, 71984, '\P{^Is_NFC_QC=m}', "");
    Expect(0, 71985, '\p{Is_NFC_QC=m}', "");
    Expect(1, 71985, '\p{^Is_NFC_QC=m}', "");
    Expect(1, 71985, '\P{Is_NFC_QC=m}', "");
    Expect(0, 71985, '\P{^Is_NFC_QC=m}', "");
    Expect(1, 71984, '\p{Is_NFC_QC=- m}', "");
    Expect(0, 71984, '\p{^Is_NFC_QC=- m}', "");
    Expect(0, 71984, '\P{Is_NFC_QC=- m}', "");
    Expect(1, 71984, '\P{^Is_NFC_QC=- m}', "");
    Expect(0, 71985, '\p{Is_NFC_QC=- m}', "");
    Expect(1, 71985, '\p{^Is_NFC_QC=- m}', "");
    Expect(1, 71985, '\P{Is_NFC_QC=- m}', "");
    Expect(0, 71985, '\P{^Is_NFC_QC=- m}', "");
    Error('\p{NFC_Quick_Check=:=__No}');
    Error('\P{NFC_Quick_Check=:=__No}');
    Expect(1, 195101, '\p{NFC_Quick_Check=:\ANo\z:}', "");;
    Expect(0, 195102, '\p{NFC_Quick_Check=:\ANo\z:}', "");;
    Expect(1, 195101, '\p{NFC_Quick_Check=no}', "");
    Expect(0, 195101, '\p{^NFC_Quick_Check=no}', "");
    Expect(0, 195101, '\P{NFC_Quick_Check=no}', "");
    Expect(1, 195101, '\P{^NFC_Quick_Check=no}', "");
    Expect(0, 195102, '\p{NFC_Quick_Check=no}', "");
    Expect(1, 195102, '\p{^NFC_Quick_Check=no}', "");
    Expect(1, 195102, '\P{NFC_Quick_Check=no}', "");
    Expect(0, 195102, '\P{^NFC_Quick_Check=no}', "");
    Expect(1, 195101, '\p{NFC_Quick_Check=:\Ano\z:}', "");;
    Expect(0, 195102, '\p{NFC_Quick_Check=:\Ano\z:}', "");;
    Expect(1, 195101, '\p{NFC_Quick_Check= _No}', "");
    Expect(0, 195101, '\p{^NFC_Quick_Check= _No}', "");
    Expect(0, 195101, '\P{NFC_Quick_Check= _No}', "");
    Expect(1, 195101, '\P{^NFC_Quick_Check= _No}', "");
    Expect(0, 195102, '\p{NFC_Quick_Check= _No}', "");
    Expect(1, 195102, '\p{^NFC_Quick_Check= _No}', "");
    Expect(1, 195102, '\P{NFC_Quick_Check= _No}', "");
    Expect(0, 195102, '\P{^NFC_Quick_Check= _No}', "");
    Error('\p{NFC_QC=:= N}');
    Error('\P{NFC_QC=:= N}');
    Expect(1, 195101, '\p{NFC_QC=:\AN\z:}', "");;
    Expect(0, 195102, '\p{NFC_QC=:\AN\z:}', "");;
    Expect(1, 195101, '\p{NFC_QC=n}', "");
    Expect(0, 195101, '\p{^NFC_QC=n}', "");
    Expect(0, 195101, '\P{NFC_QC=n}', "");
    Expect(1, 195101, '\P{^NFC_QC=n}', "");
    Expect(0, 195102, '\p{NFC_QC=n}', "");
    Expect(1, 195102, '\p{^NFC_QC=n}', "");
    Expect(1, 195102, '\P{NFC_QC=n}', "");
    Expect(0, 195102, '\P{^NFC_QC=n}', "");
    Expect(1, 195101, '\p{NFC_QC=:\An\z:}', "");;
    Expect(0, 195102, '\p{NFC_QC=:\An\z:}', "");;
    Expect(1, 195101, '\p{NFC_QC=	_N}', "");
    Expect(0, 195101, '\p{^NFC_QC=	_N}', "");
    Expect(0, 195101, '\P{NFC_QC=	_N}', "");
    Expect(1, 195101, '\P{^NFC_QC=	_N}', "");
    Expect(0, 195102, '\p{NFC_QC=	_N}', "");
    Expect(1, 195102, '\p{^NFC_QC=	_N}', "");
    Expect(1, 195102, '\P{NFC_QC=	_N}', "");
    Expect(0, 195102, '\P{^NFC_QC=	_N}', "");
    Error('\p{Is_NFC_Quick_Check=/a/_NO}');
    Error('\P{Is_NFC_Quick_Check=/a/_NO}');
    Expect(1, 195101, '\p{Is_NFC_Quick_Check=no}', "");
    Expect(0, 195101, '\p{^Is_NFC_Quick_Check=no}', "");
    Expect(0, 195101, '\P{Is_NFC_Quick_Check=no}', "");
    Expect(1, 195101, '\P{^Is_NFC_Quick_Check=no}', "");
    Expect(0, 195102, '\p{Is_NFC_Quick_Check=no}', "");
    Expect(1, 195102, '\p{^Is_NFC_Quick_Check=no}', "");
    Expect(1, 195102, '\P{Is_NFC_Quick_Check=no}', "");
    Expect(0, 195102, '\P{^Is_NFC_Quick_Check=no}', "");
    Expect(1, 195101, '\p{Is_NFC_Quick_Check= _No}', "");
    Expect(0, 195101, '\p{^Is_NFC_Quick_Check= _No}', "");
    Expect(0, 195101, '\P{Is_NFC_Quick_Check= _No}', "");
    Expect(1, 195101, '\P{^Is_NFC_Quick_Check= _No}', "");
    Expect(0, 195102, '\p{Is_NFC_Quick_Check= _No}', "");
    Expect(1, 195102, '\p{^Is_NFC_Quick_Check= _No}', "");
    Expect(1, 195102, '\P{Is_NFC_Quick_Check= _No}', "");
    Expect(0, 195102, '\P{^Is_NFC_Quick_Check= _No}', "");
    Error('\p{Is_NFC_QC= _N/a/}');
    Error('\P{Is_NFC_QC= _N/a/}');
    Expect(1, 195101, '\p{Is_NFC_QC=n}', "");
    Expect(0, 195101, '\p{^Is_NFC_QC=n}', "");
    Expect(0, 195101, '\P{Is_NFC_QC=n}', "");
    Expect(1, 195101, '\P{^Is_NFC_QC=n}', "");
    Expect(0, 195102, '\p{Is_NFC_QC=n}', "");
    Expect(1, 195102, '\p{^Is_NFC_QC=n}', "");
    Expect(1, 195102, '\P{Is_NFC_QC=n}', "");
    Expect(0, 195102, '\P{^Is_NFC_QC=n}', "");
    Expect(1, 195101, '\p{Is_NFC_QC= _N}', "");
    Expect(0, 195101, '\p{^Is_NFC_QC= _N}', "");
    Expect(0, 195101, '\P{Is_NFC_QC= _N}', "");
    Expect(1, 195101, '\P{^Is_NFC_QC= _N}', "");
    Expect(0, 195102, '\p{Is_NFC_QC= _N}', "");
    Expect(1, 195102, '\p{^Is_NFC_QC= _N}', "");
    Expect(1, 195102, '\P{Is_NFC_QC= _N}', "");
    Expect(0, 195102, '\P{^Is_NFC_QC= _N}', "");
    Error('\p{NFC_Quick_Check=-YES:=}');
    Error('\P{NFC_Quick_Check=-YES:=}');
    Expect(1, 195102, '\p{NFC_Quick_Check=:\AYes\z:}', "");;
    Expect(0, 195101, '\p{NFC_Quick_Check=:\AYes\z:}', "");;
    Expect(1, 195102, '\p{NFC_Quick_Check=yes}', "");
    Expect(0, 195102, '\p{^NFC_Quick_Check=yes}', "");
    Expect(0, 195102, '\P{NFC_Quick_Check=yes}', "");
    Expect(1, 195102, '\P{^NFC_Quick_Check=yes}', "");
    Expect(0, 195101, '\p{NFC_Quick_Check=yes}', "");
    Expect(1, 195101, '\p{^NFC_Quick_Check=yes}', "");
    Expect(1, 195101, '\P{NFC_Quick_Check=yes}', "");
    Expect(0, 195101, '\P{^NFC_Quick_Check=yes}', "");
    Expect(1, 195102, '\p{NFC_Quick_Check=:\Ayes\z:}', "");;
    Expect(0, 195101, '\p{NFC_Quick_Check=:\Ayes\z:}', "");;
    Expect(1, 195102, '\p{NFC_Quick_Check=	_YES}', "");
    Expect(0, 195102, '\p{^NFC_Quick_Check=	_YES}', "");
    Expect(0, 195102, '\P{NFC_Quick_Check=	_YES}', "");
    Expect(1, 195102, '\P{^NFC_Quick_Check=	_YES}', "");
    Expect(0, 195101, '\p{NFC_Quick_Check=	_YES}', "");
    Expect(1, 195101, '\p{^NFC_Quick_Check=	_YES}', "");
    Expect(1, 195101, '\P{NFC_Quick_Check=	_YES}', "");
    Expect(0, 195101, '\P{^NFC_Quick_Check=	_YES}', "");
    Error('\p{NFC_QC=-	Y:=}');
    Error('\P{NFC_QC=-	Y:=}');
    Expect(1, 195102, '\p{NFC_QC=:\AY\z:}', "");;
    Expect(0, 195101, '\p{NFC_QC=:\AY\z:}', "");;
    Expect(1, 195102, '\p{NFC_QC=y}', "");
    Expect(0, 195102, '\p{^NFC_QC=y}', "");
    Expect(0, 195102, '\P{NFC_QC=y}', "");
    Expect(1, 195102, '\P{^NFC_QC=y}', "");
    Expect(0, 195101, '\p{NFC_QC=y}', "");
    Expect(1, 195101, '\p{^NFC_QC=y}', "");
    Expect(1, 195101, '\P{NFC_QC=y}', "");
    Expect(0, 195101, '\P{^NFC_QC=y}', "");
    Expect(1, 195102, '\p{NFC_QC=:\Ay\z:}', "");;
    Expect(0, 195101, '\p{NFC_QC=:\Ay\z:}', "");;
    Expect(1, 195102, '\p{NFC_QC= 	Y}', "");
    Expect(0, 195102, '\p{^NFC_QC= 	Y}', "");
    Expect(0, 195102, '\P{NFC_QC= 	Y}', "");
    Expect(1, 195102, '\P{^NFC_QC= 	Y}', "");
    Expect(0, 195101, '\p{NFC_QC= 	Y}', "");
    Expect(1, 195101, '\p{^NFC_QC= 	Y}', "");
    Expect(1, 195101, '\P{NFC_QC= 	Y}', "");
    Expect(0, 195101, '\P{^NFC_QC= 	Y}', "");
    Error('\p{Is_NFC_Quick_Check=-/a/Yes}');
    Error('\P{Is_NFC_Quick_Check=-/a/Yes}');
    Expect(1, 195102, '\p{Is_NFC_Quick_Check=yes}', "");
    Expect(0, 195102, '\p{^Is_NFC_Quick_Check=yes}', "");
    Expect(0, 195102, '\P{Is_NFC_Quick_Check=yes}', "");
    Expect(1, 195102, '\P{^Is_NFC_Quick_Check=yes}', "");
    Expect(0, 195101, '\p{Is_NFC_Quick_Check=yes}', "");
    Expect(1, 195101, '\p{^Is_NFC_Quick_Check=yes}', "");
    Expect(1, 195101, '\P{Is_NFC_Quick_Check=yes}', "");
    Expect(0, 195101, '\P{^Is_NFC_Quick_Check=yes}', "");
    Expect(1, 195102, '\p{Is_NFC_Quick_Check=--YES}', "");
    Expect(0, 195102, '\p{^Is_NFC_Quick_Check=--YES}', "");
    Expect(0, 195102, '\P{Is_NFC_Quick_Check=--YES}', "");
    Expect(1, 195102, '\P{^Is_NFC_Quick_Check=--YES}', "");
    Expect(0, 195101, '\p{Is_NFC_Quick_Check=--YES}', "");
    Expect(1, 195101, '\p{^Is_NFC_Quick_Check=--YES}', "");
    Expect(1, 195101, '\P{Is_NFC_Quick_Check=--YES}', "");
    Expect(0, 195101, '\P{^Is_NFC_Quick_Check=--YES}', "");
    Error('\p{Is_NFC_QC=Y:=}');
    Error('\P{Is_NFC_QC=Y:=}');
    Expect(1, 195102, '\p{Is_NFC_QC=y}', "");
    Expect(0, 195102, '\p{^Is_NFC_QC=y}', "");
    Expect(0, 195102, '\P{Is_NFC_QC=y}', "");
    Expect(1, 195102, '\P{^Is_NFC_QC=y}', "");
    Expect(0, 195101, '\p{Is_NFC_QC=y}', "");
    Expect(1, 195101, '\p{^Is_NFC_QC=y}', "");
    Expect(1, 195101, '\P{Is_NFC_QC=y}', "");
    Expect(0, 195101, '\P{^Is_NFC_QC=y}', "");
    Expect(1, 195102, '\p{Is_NFC_QC= 	Y}', "");
    Expect(0, 195102, '\p{^Is_NFC_QC= 	Y}', "");
    Expect(0, 195102, '\P{Is_NFC_QC= 	Y}', "");
    Expect(1, 195102, '\P{^Is_NFC_QC= 	Y}', "");
    Expect(0, 195101, '\p{Is_NFC_QC= 	Y}', "");
    Expect(1, 195101, '\p{^Is_NFC_QC= 	Y}', "");
    Expect(1, 195101, '\P{Is_NFC_QC= 	Y}', "");
    Expect(0, 195101, '\P{^Is_NFC_QC= 	Y}', "");
    Error('\p{nfdquickcheck}');
    Error('\P{nfdquickcheck}');
    Error('\p{nfdqc}');
    Error('\P{nfdqc}');
    Error('\p{NFD_Quick_Check= _No/a/}');
    Error('\P{NFD_Quick_Check= _No/a/}');
    Expect(1, 195101, '\p{NFD_Quick_Check=:\ANo\z:}', "");;
    Expect(0, 195102, '\p{NFD_Quick_Check=:\ANo\z:}', "");;
    Expect(1, 195101, '\p{NFD_Quick_Check=no}', "");
    Expect(0, 195101, '\p{^NFD_Quick_Check=no}', "");
    Expect(0, 195101, '\P{NFD_Quick_Check=no}', "");
    Expect(1, 195101, '\P{^NFD_Quick_Check=no}', "");
    Expect(0, 195102, '\p{NFD_Quick_Check=no}', "");
    Expect(1, 195102, '\p{^NFD_Quick_Check=no}', "");
    Expect(1, 195102, '\P{NFD_Quick_Check=no}', "");
    Expect(0, 195102, '\P{^NFD_Quick_Check=no}', "");
    Expect(1, 195101, '\p{NFD_Quick_Check=:\Ano\z:}', "");;
    Expect(0, 195102, '\p{NFD_Quick_Check=:\Ano\z:}', "");;
    Expect(1, 195101, '\p{NFD_Quick_Check:_-No}', "");
    Expect(0, 195101, '\p{^NFD_Quick_Check:_-No}', "");
    Expect(0, 195101, '\P{NFD_Quick_Check:_-No}', "");
    Expect(1, 195101, '\P{^NFD_Quick_Check:_-No}', "");
    Expect(0, 195102, '\p{NFD_Quick_Check:_-No}', "");
    Expect(1, 195102, '\p{^NFD_Quick_Check:_-No}', "");
    Expect(1, 195102, '\P{NFD_Quick_Check:_-No}', "");
    Expect(0, 195102, '\P{^NFD_Quick_Check:_-No}', "");
    Error('\p{NFD_QC=	:=N}');
    Error('\P{NFD_QC=	:=N}');
    Expect(1, 195101, '\p{NFD_QC=:\AN\z:}', "");;
    Expect(0, 195102, '\p{NFD_QC=:\AN\z:}', "");;
    Expect(1, 195101, '\p{NFD_QC=n}', "");
    Expect(0, 195101, '\p{^NFD_QC=n}', "");
    Expect(0, 195101, '\P{NFD_QC=n}', "");
    Expect(1, 195101, '\P{^NFD_QC=n}', "");
    Expect(0, 195102, '\p{NFD_QC=n}', "");
    Expect(1, 195102, '\p{^NFD_QC=n}', "");
    Expect(1, 195102, '\P{NFD_QC=n}', "");
    Expect(0, 195102, '\P{^NFD_QC=n}', "");
    Expect(1, 195101, '\p{NFD_QC=:\An\z:}', "");;
    Expect(0, 195102, '\p{NFD_QC=:\An\z:}', "");;
    Expect(1, 195101, '\p{NFD_QC= -N}', "");
    Expect(0, 195101, '\p{^NFD_QC= -N}', "");
    Expect(0, 195101, '\P{NFD_QC= -N}', "");
    Expect(1, 195101, '\P{^NFD_QC= -N}', "");
    Expect(0, 195102, '\p{NFD_QC= -N}', "");
    Expect(1, 195102, '\p{^NFD_QC= -N}', "");
    Expect(1, 195102, '\P{NFD_QC= -N}', "");
    Expect(0, 195102, '\P{^NFD_QC= -N}', "");
    Error('\p{Is_NFD_Quick_Check=/a/-_no}');
    Error('\P{Is_NFD_Quick_Check=/a/-_no}');
    Expect(1, 195101, '\p{Is_NFD_Quick_Check=no}', "");
    Expect(0, 195101, '\p{^Is_NFD_Quick_Check=no}', "");
    Expect(0, 195101, '\P{Is_NFD_Quick_Check=no}', "");
    Expect(1, 195101, '\P{^Is_NFD_Quick_Check=no}', "");
    Expect(0, 195102, '\p{Is_NFD_Quick_Check=no}', "");
    Expect(1, 195102, '\p{^Is_NFD_Quick_Check=no}', "");
    Expect(1, 195102, '\P{Is_NFD_Quick_Check=no}', "");
    Expect(0, 195102, '\P{^Is_NFD_Quick_Check=no}', "");
    Expect(1, 195101, '\p{Is_NFD_Quick_Check= 	No}', "");
    Expect(0, 195101, '\p{^Is_NFD_Quick_Check= 	No}', "");
    Expect(0, 195101, '\P{Is_NFD_Quick_Check= 	No}', "");
    Expect(1, 195101, '\P{^Is_NFD_Quick_Check= 	No}', "");
    Expect(0, 195102, '\p{Is_NFD_Quick_Check= 	No}', "");
    Expect(1, 195102, '\p{^Is_NFD_Quick_Check= 	No}', "");
    Expect(1, 195102, '\P{Is_NFD_Quick_Check= 	No}', "");
    Expect(0, 195102, '\P{^Is_NFD_Quick_Check= 	No}', "");
    Error('\p{Is_NFD_QC= N:=}');
    Error('\P{Is_NFD_QC= N:=}');
    Expect(1, 195101, '\p{Is_NFD_QC: n}', "");
    Expect(0, 195101, '\p{^Is_NFD_QC: n}', "");
    Expect(0, 195101, '\P{Is_NFD_QC: n}', "");
    Expect(1, 195101, '\P{^Is_NFD_QC: n}', "");
    Expect(0, 195102, '\p{Is_NFD_QC: n}', "");
    Expect(1, 195102, '\p{^Is_NFD_QC: n}', "");
    Expect(1, 195102, '\P{Is_NFD_QC: n}', "");
    Expect(0, 195102, '\P{^Is_NFD_QC: n}', "");
    Expect(1, 195101, '\p{Is_NFD_QC=_N}', "");
    Expect(0, 195101, '\p{^Is_NFD_QC=_N}', "");
    Expect(0, 195101, '\P{Is_NFD_QC=_N}', "");
    Expect(1, 195101, '\P{^Is_NFD_QC=_N}', "");
    Expect(0, 195102, '\p{Is_NFD_QC=_N}', "");
    Expect(1, 195102, '\p{^Is_NFD_QC=_N}', "");
    Expect(1, 195102, '\P{Is_NFD_QC=_N}', "");
    Expect(0, 195102, '\P{^Is_NFD_QC=_N}', "");
    Error('\p{NFD_Quick_Check=-	Yes/a/}');
    Error('\P{NFD_Quick_Check=-	Yes/a/}');
    Expect(1, 195102, '\p{NFD_Quick_Check=:\AYes\z:}', "");;
    Expect(0, 195101, '\p{NFD_Quick_Check=:\AYes\z:}', "");;
    Expect(1, 195102, '\p{NFD_Quick_Check=yes}', "");
    Expect(0, 195102, '\p{^NFD_Quick_Check=yes}', "");
    Expect(0, 195102, '\P{NFD_Quick_Check=yes}', "");
    Expect(1, 195102, '\P{^NFD_Quick_Check=yes}', "");
    Expect(0, 195101, '\p{NFD_Quick_Check=yes}', "");
    Expect(1, 195101, '\p{^NFD_Quick_Check=yes}', "");
    Expect(1, 195101, '\P{NFD_Quick_Check=yes}', "");
    Expect(0, 195101, '\P{^NFD_Quick_Check=yes}', "");
    Expect(1, 195102, '\p{NFD_Quick_Check=:\Ayes\z:}', "");;
    Expect(0, 195101, '\p{NFD_Quick_Check=:\Ayes\z:}', "");;
    Expect(1, 195102, '\p{NFD_Quick_Check= 	YES}', "");
    Expect(0, 195102, '\p{^NFD_Quick_Check= 	YES}', "");
    Expect(0, 195102, '\P{NFD_Quick_Check= 	YES}', "");
    Expect(1, 195102, '\P{^NFD_Quick_Check= 	YES}', "");
    Expect(0, 195101, '\p{NFD_Quick_Check= 	YES}', "");
    Expect(1, 195101, '\p{^NFD_Quick_Check= 	YES}', "");
    Expect(1, 195101, '\P{NFD_Quick_Check= 	YES}', "");
    Expect(0, 195101, '\P{^NFD_Quick_Check= 	YES}', "");
    Error('\p{NFD_QC=:= _Y}');
    Error('\P{NFD_QC=:= _Y}');
    Expect(1, 195102, '\p{NFD_QC=:\AY\z:}', "");;
    Expect(0, 195101, '\p{NFD_QC=:\AY\z:}', "");;
    Expect(1, 195102, '\p{NFD_QC:	y}', "");
    Expect(0, 195102, '\p{^NFD_QC:	y}', "");
    Expect(0, 195102, '\P{NFD_QC:	y}', "");
    Expect(1, 195102, '\P{^NFD_QC:	y}', "");
    Expect(0, 195101, '\p{NFD_QC:	y}', "");
    Expect(1, 195101, '\p{^NFD_QC:	y}', "");
    Expect(1, 195101, '\P{NFD_QC:	y}', "");
    Expect(0, 195101, '\P{^NFD_QC:	y}', "");
    Expect(1, 195102, '\p{NFD_QC=:\Ay\z:}', "");;
    Expect(0, 195101, '\p{NFD_QC=:\Ay\z:}', "");;
    Expect(1, 195102, '\p{NFD_QC:	-_Y}', "");
    Expect(0, 195102, '\p{^NFD_QC:	-_Y}', "");
    Expect(0, 195102, '\P{NFD_QC:	-_Y}', "");
    Expect(1, 195102, '\P{^NFD_QC:	-_Y}', "");
    Expect(0, 195101, '\p{NFD_QC:	-_Y}', "");
    Expect(1, 195101, '\p{^NFD_QC:	-_Y}', "");
    Expect(1, 195101, '\P{NFD_QC:	-_Y}', "");
    Expect(0, 195101, '\P{^NFD_QC:	-_Y}', "");
    Error('\p{Is_NFD_Quick_Check=:= 	yes}');
    Error('\P{Is_NFD_Quick_Check=:= 	yes}');
    Expect(1, 195102, '\p{Is_NFD_Quick_Check=yes}', "");
    Expect(0, 195102, '\p{^Is_NFD_Quick_Check=yes}', "");
    Expect(0, 195102, '\P{Is_NFD_Quick_Check=yes}', "");
    Expect(1, 195102, '\P{^Is_NFD_Quick_Check=yes}', "");
    Expect(0, 195101, '\p{Is_NFD_Quick_Check=yes}', "");
    Expect(1, 195101, '\p{^Is_NFD_Quick_Check=yes}', "");
    Expect(1, 195101, '\P{Is_NFD_Quick_Check=yes}', "");
    Expect(0, 195101, '\P{^Is_NFD_Quick_Check=yes}', "");
    Expect(1, 195102, '\p{Is_NFD_Quick_Check=	yes}', "");
    Expect(0, 195102, '\p{^Is_NFD_Quick_Check=	yes}', "");
    Expect(0, 195102, '\P{Is_NFD_Quick_Check=	yes}', "");
    Expect(1, 195102, '\P{^Is_NFD_Quick_Check=	yes}', "");
    Expect(0, 195101, '\p{Is_NFD_Quick_Check=	yes}', "");
    Expect(1, 195101, '\p{^Is_NFD_Quick_Check=	yes}', "");
    Expect(1, 195101, '\P{Is_NFD_Quick_Check=	yes}', "");
    Expect(0, 195101, '\P{^Is_NFD_Quick_Check=	yes}', "");
    Error('\p{Is_NFD_QC=/a/  Y}');
    Error('\P{Is_NFD_QC=/a/  Y}');
    Expect(1, 195102, '\p{Is_NFD_QC=y}', "");
    Expect(0, 195102, '\p{^Is_NFD_QC=y}', "");
    Expect(0, 195102, '\P{Is_NFD_QC=y}', "");
    Expect(1, 195102, '\P{^Is_NFD_QC=y}', "");
    Expect(0, 195101, '\p{Is_NFD_QC=y}', "");
    Expect(1, 195101, '\p{^Is_NFD_QC=y}', "");
    Expect(1, 195101, '\P{Is_NFD_QC=y}', "");
    Expect(0, 195101, '\P{^Is_NFD_QC=y}', "");
    Expect(1, 195102, '\p{Is_NFD_QC:	-Y}', "");
    Expect(0, 195102, '\p{^Is_NFD_QC:	-Y}', "");
    Expect(0, 195102, '\P{Is_NFD_QC:	-Y}', "");
    Expect(1, 195102, '\P{^Is_NFD_QC:	-Y}', "");
    Expect(0, 195101, '\p{Is_NFD_QC:	-Y}', "");
    Expect(1, 195101, '\p{^Is_NFD_QC:	-Y}', "");
    Expect(1, 195101, '\P{Is_NFD_QC:	-Y}', "");
    Expect(0, 195101, '\P{^Is_NFD_QC:	-Y}', "");
    Error('\p{nfkccasefold}');
    Error('\P{nfkccasefold}');
    Error('\p{nfkccf}');
    Error('\P{nfkccf}');
    Error('\p{nfkcquickcheck}');
    Error('\P{nfkcquickcheck}');
    Error('\p{nfkcqc}');
    Error('\P{nfkcqc}');
    Error('\p{NFKC_Quick_Check=/a/	_Maybe}');
    Error('\P{NFKC_Quick_Check=/a/	_Maybe}');
    Expect(1, 71984, '\p{NFKC_Quick_Check=:\AMaybe\z:}', "");;
    Expect(0, 71985, '\p{NFKC_Quick_Check=:\AMaybe\z:}', "");;
    Expect(1, 71984, '\p{NFKC_Quick_Check=maybe}', "");
    Expect(0, 71984, '\p{^NFKC_Quick_Check=maybe}', "");
    Expect(0, 71984, '\P{NFKC_Quick_Check=maybe}', "");
    Expect(1, 71984, '\P{^NFKC_Quick_Check=maybe}', "");
    Expect(0, 71985, '\p{NFKC_Quick_Check=maybe}', "");
    Expect(1, 71985, '\p{^NFKC_Quick_Check=maybe}', "");
    Expect(1, 71985, '\P{NFKC_Quick_Check=maybe}', "");
    Expect(0, 71985, '\P{^NFKC_Quick_Check=maybe}', "");
    Expect(1, 71984, '\p{NFKC_Quick_Check=:\Amaybe\z:}', "");;
    Expect(0, 71985, '\p{NFKC_Quick_Check=:\Amaybe\z:}', "");;
    Expect(1, 71984, '\p{NFKC_Quick_Check=  MAYBE}', "");
    Expect(0, 71984, '\p{^NFKC_Quick_Check=  MAYBE}', "");
    Expect(0, 71984, '\P{NFKC_Quick_Check=  MAYBE}', "");
    Expect(1, 71984, '\P{^NFKC_Quick_Check=  MAYBE}', "");
    Expect(0, 71985, '\p{NFKC_Quick_Check=  MAYBE}', "");
    Expect(1, 71985, '\p{^NFKC_Quick_Check=  MAYBE}', "");
    Expect(1, 71985, '\P{NFKC_Quick_Check=  MAYBE}', "");
    Expect(0, 71985, '\P{^NFKC_Quick_Check=  MAYBE}', "");
    Error('\p{NFKC_QC=/a/	-M}');
    Error('\P{NFKC_QC=/a/	-M}');
    Expect(1, 71984, '\p{NFKC_QC=:\AM\z:}', "");;
    Expect(0, 71985, '\p{NFKC_QC=:\AM\z:}', "");;
    Expect(1, 71984, '\p{NFKC_QC=m}', "");
    Expect(0, 71984, '\p{^NFKC_QC=m}', "");
    Expect(0, 71984, '\P{NFKC_QC=m}', "");
    Expect(1, 71984, '\P{^NFKC_QC=m}', "");
    Expect(0, 71985, '\p{NFKC_QC=m}', "");
    Expect(1, 71985, '\p{^NFKC_QC=m}', "");
    Expect(1, 71985, '\P{NFKC_QC=m}', "");
    Expect(0, 71985, '\P{^NFKC_QC=m}', "");
    Expect(1, 71984, '\p{NFKC_QC=:\Am\z:}', "");;
    Expect(0, 71985, '\p{NFKC_QC=:\Am\z:}', "");;
    Expect(1, 71984, '\p{NFKC_QC=_M}', "");
    Expect(0, 71984, '\p{^NFKC_QC=_M}', "");
    Expect(0, 71984, '\P{NFKC_QC=_M}', "");
    Expect(1, 71984, '\P{^NFKC_QC=_M}', "");
    Expect(0, 71985, '\p{NFKC_QC=_M}', "");
    Expect(1, 71985, '\p{^NFKC_QC=_M}', "");
    Expect(1, 71985, '\P{NFKC_QC=_M}', "");
    Expect(0, 71985, '\P{^NFKC_QC=_M}', "");
    Error('\p{Is_NFKC_Quick_Check=		Maybe/a/}');
    Error('\P{Is_NFKC_Quick_Check=		Maybe/a/}');
    Expect(1, 71984, '\p{Is_NFKC_Quick_Check=maybe}', "");
    Expect(0, 71984, '\p{^Is_NFKC_Quick_Check=maybe}', "");
    Expect(0, 71984, '\P{Is_NFKC_Quick_Check=maybe}', "");
    Expect(1, 71984, '\P{^Is_NFKC_Quick_Check=maybe}', "");
    Expect(0, 71985, '\p{Is_NFKC_Quick_Check=maybe}', "");
    Expect(1, 71985, '\p{^Is_NFKC_Quick_Check=maybe}', "");
    Expect(1, 71985, '\P{Is_NFKC_Quick_Check=maybe}', "");
    Expect(0, 71985, '\P{^Is_NFKC_Quick_Check=maybe}', "");
    Expect(1, 71984, '\p{Is_NFKC_Quick_Check=		Maybe}', "");
    Expect(0, 71984, '\p{^Is_NFKC_Quick_Check=		Maybe}', "");
    Expect(0, 71984, '\P{Is_NFKC_Quick_Check=		Maybe}', "");
    Expect(1, 71984, '\P{^Is_NFKC_Quick_Check=		Maybe}', "");
    Expect(0, 71985, '\p{Is_NFKC_Quick_Check=		Maybe}', "");
    Expect(1, 71985, '\p{^Is_NFKC_Quick_Check=		Maybe}', "");
    Expect(1, 71985, '\P{Is_NFKC_Quick_Check=		Maybe}', "");
    Expect(0, 71985, '\P{^Is_NFKC_Quick_Check=		Maybe}', "");
    Error('\p{Is_NFKC_QC=:=	-M}');
    Error('\P{Is_NFKC_QC=:=	-M}');
    Expect(1, 71984, '\p{Is_NFKC_QC=m}', "");
    Expect(0, 71984, '\p{^Is_NFKC_QC=m}', "");
    Expect(0, 71984, '\P{Is_NFKC_QC=m}', "");
    Expect(1, 71984, '\P{^Is_NFKC_QC=m}', "");
    Expect(0, 71985, '\p{Is_NFKC_QC=m}', "");
    Expect(1, 71985, '\p{^Is_NFKC_QC=m}', "");
    Expect(1, 71985, '\P{Is_NFKC_QC=m}', "");
    Expect(0, 71985, '\P{^Is_NFKC_QC=m}', "");
    Expect(1, 71984, '\p{Is_NFKC_QC=- M}', "");
    Expect(0, 71984, '\p{^Is_NFKC_QC=- M}', "");
    Expect(0, 71984, '\P{Is_NFKC_QC=- M}', "");
    Expect(1, 71984, '\P{^Is_NFKC_QC=- M}', "");
    Expect(0, 71985, '\p{Is_NFKC_QC=- M}', "");
    Expect(1, 71985, '\p{^Is_NFKC_QC=- M}', "");
    Expect(1, 71985, '\P{Is_NFKC_QC=- M}', "");
    Expect(0, 71985, '\P{^Is_NFKC_QC=- M}', "");
    Error('\p{NFKC_Quick_Check: :=	-NO}');
    Error('\P{NFKC_Quick_Check: :=	-NO}');
    Expect(1, 195101, '\p{NFKC_Quick_Check=:\ANo\z:}', "");;
    Expect(0, 195102, '\p{NFKC_Quick_Check=:\ANo\z:}', "");;
    Expect(1, 195101, '\p{NFKC_Quick_Check=no}', "");
    Expect(0, 195101, '\p{^NFKC_Quick_Check=no}', "");
    Expect(0, 195101, '\P{NFKC_Quick_Check=no}', "");
    Expect(1, 195101, '\P{^NFKC_Quick_Check=no}', "");
    Expect(0, 195102, '\p{NFKC_Quick_Check=no}', "");
    Expect(1, 195102, '\p{^NFKC_Quick_Check=no}', "");
    Expect(1, 195102, '\P{NFKC_Quick_Check=no}', "");
    Expect(0, 195102, '\P{^NFKC_Quick_Check=no}', "");
    Expect(1, 195101, '\p{NFKC_Quick_Check=:\Ano\z:}', "");;
    Expect(0, 195102, '\p{NFKC_Quick_Check=:\Ano\z:}', "");;
    Expect(1, 195101, '\p{NFKC_Quick_Check=	-NO}', "");
    Expect(0, 195101, '\p{^NFKC_Quick_Check=	-NO}', "");
    Expect(0, 195101, '\P{NFKC_Quick_Check=	-NO}', "");
    Expect(1, 195101, '\P{^NFKC_Quick_Check=	-NO}', "");
    Expect(0, 195102, '\p{NFKC_Quick_Check=	-NO}', "");
    Expect(1, 195102, '\p{^NFKC_Quick_Check=	-NO}', "");
    Expect(1, 195102, '\P{NFKC_Quick_Check=	-NO}', "");
    Expect(0, 195102, '\P{^NFKC_Quick_Check=	-NO}', "");
    Error('\p{NFKC_QC: /a/	 n}');
    Error('\P{NFKC_QC: /a/	 n}');
    Expect(1, 195101, '\p{NFKC_QC=:\AN\z:}', "");;
    Expect(0, 195102, '\p{NFKC_QC=:\AN\z:}', "");;
    Expect(1, 195101, '\p{NFKC_QC=n}', "");
    Expect(0, 195101, '\p{^NFKC_QC=n}', "");
    Expect(0, 195101, '\P{NFKC_QC=n}', "");
    Expect(1, 195101, '\P{^NFKC_QC=n}', "");
    Expect(0, 195102, '\p{NFKC_QC=n}', "");
    Expect(1, 195102, '\p{^NFKC_QC=n}', "");
    Expect(1, 195102, '\P{NFKC_QC=n}', "");
    Expect(0, 195102, '\P{^NFKC_QC=n}', "");
    Expect(1, 195101, '\p{NFKC_QC=:\An\z:}', "");;
    Expect(0, 195102, '\p{NFKC_QC=:\An\z:}', "");;
    Expect(1, 195101, '\p{NFKC_QC=N}', "");
    Expect(0, 195101, '\p{^NFKC_QC=N}', "");
    Expect(0, 195101, '\P{NFKC_QC=N}', "");
    Expect(1, 195101, '\P{^NFKC_QC=N}', "");
    Expect(0, 195102, '\p{NFKC_QC=N}', "");
    Expect(1, 195102, '\p{^NFKC_QC=N}', "");
    Expect(1, 195102, '\P{NFKC_QC=N}', "");
    Expect(0, 195102, '\P{^NFKC_QC=N}', "");
    Error('\p{Is_NFKC_Quick_Check=_-no/a/}');
    Error('\P{Is_NFKC_Quick_Check=_-no/a/}');
    Expect(1, 195101, '\p{Is_NFKC_Quick_Check=no}', "");
    Expect(0, 195101, '\p{^Is_NFKC_Quick_Check=no}', "");
    Expect(0, 195101, '\P{Is_NFKC_Quick_Check=no}', "");
    Expect(1, 195101, '\P{^Is_NFKC_Quick_Check=no}', "");
    Expect(0, 195102, '\p{Is_NFKC_Quick_Check=no}', "");
    Expect(1, 195102, '\p{^Is_NFKC_Quick_Check=no}', "");
    Expect(1, 195102, '\P{Is_NFKC_Quick_Check=no}', "");
    Expect(0, 195102, '\P{^Is_NFKC_Quick_Check=no}', "");
    Expect(1, 195101, '\p{Is_NFKC_Quick_Check=	No}', "");
    Expect(0, 195101, '\p{^Is_NFKC_Quick_Check=	No}', "");
    Expect(0, 195101, '\P{Is_NFKC_Quick_Check=	No}', "");
    Expect(1, 195101, '\P{^Is_NFKC_Quick_Check=	No}', "");
    Expect(0, 195102, '\p{Is_NFKC_Quick_Check=	No}', "");
    Expect(1, 195102, '\p{^Is_NFKC_Quick_Check=	No}', "");
    Expect(1, 195102, '\P{Is_NFKC_Quick_Check=	No}', "");
    Expect(0, 195102, '\P{^Is_NFKC_Quick_Check=	No}', "");
    Error('\p{Is_NFKC_QC=:=	-N}');
    Error('\P{Is_NFKC_QC=:=	-N}');
    Expect(1, 195101, '\p{Is_NFKC_QC=n}', "");
    Expect(0, 195101, '\p{^Is_NFKC_QC=n}', "");
    Expect(0, 195101, '\P{Is_NFKC_QC=n}', "");
    Expect(1, 195101, '\P{^Is_NFKC_QC=n}', "");
    Expect(0, 195102, '\p{Is_NFKC_QC=n}', "");
    Expect(1, 195102, '\p{^Is_NFKC_QC=n}', "");
    Expect(1, 195102, '\P{Is_NFKC_QC=n}', "");
    Expect(0, 195102, '\P{^Is_NFKC_QC=n}', "");
    Expect(1, 195101, '\p{Is_NFKC_QC=  n}', "");
    Expect(0, 195101, '\p{^Is_NFKC_QC=  n}', "");
    Expect(0, 195101, '\P{Is_NFKC_QC=  n}', "");
    Expect(1, 195101, '\P{^Is_NFKC_QC=  n}', "");
    Expect(0, 195102, '\p{Is_NFKC_QC=  n}', "");
    Expect(1, 195102, '\p{^Is_NFKC_QC=  n}', "");
    Expect(1, 195102, '\P{Is_NFKC_QC=  n}', "");
    Expect(0, 195102, '\P{^Is_NFKC_QC=  n}', "");
    Error('\p{NFKC_Quick_Check=YES/a/}');
    Error('\P{NFKC_Quick_Check=YES/a/}');
    Expect(1, 195102, '\p{NFKC_Quick_Check=:\AYes\z:}', "");;
    Expect(0, 195101, '\p{NFKC_Quick_Check=:\AYes\z:}', "");;
    Expect(1, 195102, '\p{NFKC_Quick_Check=yes}', "");
    Expect(0, 195102, '\p{^NFKC_Quick_Check=yes}', "");
    Expect(0, 195102, '\P{NFKC_Quick_Check=yes}', "");
    Expect(1, 195102, '\P{^NFKC_Quick_Check=yes}', "");
    Expect(0, 195101, '\p{NFKC_Quick_Check=yes}', "");
    Expect(1, 195101, '\p{^NFKC_Quick_Check=yes}', "");
    Expect(1, 195101, '\P{NFKC_Quick_Check=yes}', "");
    Expect(0, 195101, '\P{^NFKC_Quick_Check=yes}', "");
    Expect(1, 195102, '\p{NFKC_Quick_Check=:\Ayes\z:}', "");;
    Expect(0, 195101, '\p{NFKC_Quick_Check=:\Ayes\z:}', "");;
    Expect(1, 195102, '\p{NFKC_Quick_Check:__Yes}', "");
    Expect(0, 195102, '\p{^NFKC_Quick_Check:__Yes}', "");
    Expect(0, 195102, '\P{NFKC_Quick_Check:__Yes}', "");
    Expect(1, 195102, '\P{^NFKC_Quick_Check:__Yes}', "");
    Expect(0, 195101, '\p{NFKC_Quick_Check:__Yes}', "");
    Expect(1, 195101, '\p{^NFKC_Quick_Check:__Yes}', "");
    Expect(1, 195101, '\P{NFKC_Quick_Check:__Yes}', "");
    Expect(0, 195101, '\P{^NFKC_Quick_Check:__Yes}', "");
    Error('\p{NFKC_QC=_ y:=}');
    Error('\P{NFKC_QC=_ y:=}');
    Expect(1, 195102, '\p{NFKC_QC=:\AY\z:}', "");;
    Expect(0, 195101, '\p{NFKC_QC=:\AY\z:}', "");;
    Expect(1, 195102, '\p{NFKC_QC=y}', "");
    Expect(0, 195102, '\p{^NFKC_QC=y}', "");
    Expect(0, 195102, '\P{NFKC_QC=y}', "");
    Expect(1, 195102, '\P{^NFKC_QC=y}', "");
    Expect(0, 195101, '\p{NFKC_QC=y}', "");
    Expect(1, 195101, '\p{^NFKC_QC=y}', "");
    Expect(1, 195101, '\P{NFKC_QC=y}', "");
    Expect(0, 195101, '\P{^NFKC_QC=y}', "");
    Expect(1, 195102, '\p{NFKC_QC=:\Ay\z:}', "");;
    Expect(0, 195101, '\p{NFKC_QC=:\Ay\z:}', "");;
    Expect(1, 195102, '\p{NFKC_QC=	Y}', "");
    Expect(0, 195102, '\p{^NFKC_QC=	Y}', "");
    Expect(0, 195102, '\P{NFKC_QC=	Y}', "");
    Expect(1, 195102, '\P{^NFKC_QC=	Y}', "");
    Expect(0, 195101, '\p{NFKC_QC=	Y}', "");
    Expect(1, 195101, '\p{^NFKC_QC=	Y}', "");
    Expect(1, 195101, '\P{NFKC_QC=	Y}', "");
    Expect(0, 195101, '\P{^NFKC_QC=	Y}', "");
    Error('\p{Is_NFKC_Quick_Check:/a/	yes}');
    Error('\P{Is_NFKC_Quick_Check:/a/	yes}');
    Expect(1, 195102, '\p{Is_NFKC_Quick_Check=yes}', "");
    Expect(0, 195102, '\p{^Is_NFKC_Quick_Check=yes}', "");
    Expect(0, 195102, '\P{Is_NFKC_Quick_Check=yes}', "");
    Expect(1, 195102, '\P{^Is_NFKC_Quick_Check=yes}', "");
    Expect(0, 195101, '\p{Is_NFKC_Quick_Check=yes}', "");
    Expect(1, 195101, '\p{^Is_NFKC_Quick_Check=yes}', "");
    Expect(1, 195101, '\P{Is_NFKC_Quick_Check=yes}', "");
    Expect(0, 195101, '\P{^Is_NFKC_Quick_Check=yes}', "");
    Expect(1, 195102, '\p{Is_NFKC_Quick_Check=-yes}', "");
    Expect(0, 195102, '\p{^Is_NFKC_Quick_Check=-yes}', "");
    Expect(0, 195102, '\P{Is_NFKC_Quick_Check=-yes}', "");
    Expect(1, 195102, '\P{^Is_NFKC_Quick_Check=-yes}', "");
    Expect(0, 195101, '\p{Is_NFKC_Quick_Check=-yes}', "");
    Expect(1, 195101, '\p{^Is_NFKC_Quick_Check=-yes}', "");
    Expect(1, 195101, '\P{Is_NFKC_Quick_Check=-yes}', "");
    Expect(0, 195101, '\P{^Is_NFKC_Quick_Check=-yes}', "");
    Error('\p{Is_NFKC_QC=:=y}');
    Error('\P{Is_NFKC_QC=:=y}');
    Expect(1, 195102, '\p{Is_NFKC_QC=y}', "");
    Expect(0, 195102, '\p{^Is_NFKC_QC=y}', "");
    Expect(0, 195102, '\P{Is_NFKC_QC=y}', "");
    Expect(1, 195102, '\P{^Is_NFKC_QC=y}', "");
    Expect(0, 195101, '\p{Is_NFKC_QC=y}', "");
    Expect(1, 195101, '\p{^Is_NFKC_QC=y}', "");
    Expect(1, 195101, '\P{Is_NFKC_QC=y}', "");
    Expect(0, 195101, '\P{^Is_NFKC_QC=y}', "");
    Expect(1, 195102, '\p{Is_NFKC_QC=	Y}', "");
    Expect(0, 195102, '\p{^Is_NFKC_QC=	Y}', "");
    Expect(0, 195102, '\P{Is_NFKC_QC=	Y}', "");
    Expect(1, 195102, '\P{^Is_NFKC_QC=	Y}', "");
    Expect(0, 195101, '\p{Is_NFKC_QC=	Y}', "");
    Expect(1, 195101, '\p{^Is_NFKC_QC=	Y}', "");
    Expect(1, 195101, '\P{Is_NFKC_QC=	Y}', "");
    Expect(0, 195101, '\P{^Is_NFKC_QC=	Y}', "");
    Error('\p{nfkdquickcheck}');
    Error('\P{nfkdquickcheck}');
    Error('\p{nfkdqc}');
    Error('\P{nfkdqc}');
    Error('\p{NFKD_Quick_Check=-_NO:=}');
    Error('\P{NFKD_Quick_Check=-_NO:=}');
    Expect(1, 195101, '\p{NFKD_Quick_Check=:\ANo\z:}', "");;
    Expect(0, 195102, '\p{NFKD_Quick_Check=:\ANo\z:}', "");;
    Expect(1, 195101, '\p{NFKD_Quick_Check=no}', "");
    Expect(0, 195101, '\p{^NFKD_Quick_Check=no}', "");
    Expect(0, 195101, '\P{NFKD_Quick_Check=no}', "");
    Expect(1, 195101, '\P{^NFKD_Quick_Check=no}', "");
    Expect(0, 195102, '\p{NFKD_Quick_Check=no}', "");
    Expect(1, 195102, '\p{^NFKD_Quick_Check=no}', "");
    Expect(1, 195102, '\P{NFKD_Quick_Check=no}', "");
    Expect(0, 195102, '\P{^NFKD_Quick_Check=no}', "");
    Expect(1, 195101, '\p{NFKD_Quick_Check=:\Ano\z:}', "");;
    Expect(0, 195102, '\p{NFKD_Quick_Check=:\Ano\z:}', "");;
    Expect(1, 195101, '\p{NFKD_Quick_Check=	_NO}', "");
    Expect(0, 195101, '\p{^NFKD_Quick_Check=	_NO}', "");
    Expect(0, 195101, '\P{NFKD_Quick_Check=	_NO}', "");
    Expect(1, 195101, '\P{^NFKD_Quick_Check=	_NO}', "");
    Expect(0, 195102, '\p{NFKD_Quick_Check=	_NO}', "");
    Expect(1, 195102, '\p{^NFKD_Quick_Check=	_NO}', "");
    Expect(1, 195102, '\P{NFKD_Quick_Check=	_NO}', "");
    Expect(0, 195102, '\P{^NFKD_Quick_Check=	_NO}', "");
    Error('\p{NFKD_QC=:=	_N}');
    Error('\P{NFKD_QC=:=	_N}');
    Expect(1, 195101, '\p{NFKD_QC=:\AN\z:}', "");;
    Expect(0, 195102, '\p{NFKD_QC=:\AN\z:}', "");;
    Expect(1, 195101, '\p{NFKD_QC=n}', "");
    Expect(0, 195101, '\p{^NFKD_QC=n}', "");
    Expect(0, 195101, '\P{NFKD_QC=n}', "");
    Expect(1, 195101, '\P{^NFKD_QC=n}', "");
    Expect(0, 195102, '\p{NFKD_QC=n}', "");
    Expect(1, 195102, '\p{^NFKD_QC=n}', "");
    Expect(1, 195102, '\P{NFKD_QC=n}', "");
    Expect(0, 195102, '\P{^NFKD_QC=n}', "");
    Expect(1, 195101, '\p{NFKD_QC=:\An\z:}', "");;
    Expect(0, 195102, '\p{NFKD_QC=:\An\z:}', "");;
    Expect(1, 195101, '\p{NFKD_QC=		N}', "");
    Expect(0, 195101, '\p{^NFKD_QC=		N}', "");
    Expect(0, 195101, '\P{NFKD_QC=		N}', "");
    Expect(1, 195101, '\P{^NFKD_QC=		N}', "");
    Expect(0, 195102, '\p{NFKD_QC=		N}', "");
    Expect(1, 195102, '\p{^NFKD_QC=		N}', "");
    Expect(1, 195102, '\P{NFKD_QC=		N}', "");
    Expect(0, 195102, '\P{^NFKD_QC=		N}', "");
    Error('\p{Is_NFKD_Quick_Check:   --No:=}');
    Error('\P{Is_NFKD_Quick_Check:   --No:=}');
    Expect(1, 195101, '\p{Is_NFKD_Quick_Check=no}', "");
    Expect(0, 195101, '\p{^Is_NFKD_Quick_Check=no}', "");
    Expect(0, 195101, '\P{Is_NFKD_Quick_Check=no}', "");
    Expect(1, 195101, '\P{^Is_NFKD_Quick_Check=no}', "");
    Expect(0, 195102, '\p{Is_NFKD_Quick_Check=no}', "");
    Expect(1, 195102, '\p{^Is_NFKD_Quick_Check=no}', "");
    Expect(1, 195102, '\P{Is_NFKD_Quick_Check=no}', "");
    Expect(0, 195102, '\P{^Is_NFKD_Quick_Check=no}', "");
    Expect(1, 195101, '\p{Is_NFKD_Quick_Check=	 No}', "");
    Expect(0, 195101, '\p{^Is_NFKD_Quick_Check=	 No}', "");
    Expect(0, 195101, '\P{Is_NFKD_Quick_Check=	 No}', "");
    Expect(1, 195101, '\P{^Is_NFKD_Quick_Check=	 No}', "");
    Expect(0, 195102, '\p{Is_NFKD_Quick_Check=	 No}', "");
    Expect(1, 195102, '\p{^Is_NFKD_Quick_Check=	 No}', "");
    Expect(1, 195102, '\P{Is_NFKD_Quick_Check=	 No}', "");
    Expect(0, 195102, '\P{^Is_NFKD_Quick_Check=	 No}', "");
    Error('\p{Is_NFKD_QC=/a/-_N}');
    Error('\P{Is_NFKD_QC=/a/-_N}');
    Expect(1, 195101, '\p{Is_NFKD_QC:   n}', "");
    Expect(0, 195101, '\p{^Is_NFKD_QC:   n}', "");
    Expect(0, 195101, '\P{Is_NFKD_QC:   n}', "");
    Expect(1, 195101, '\P{^Is_NFKD_QC:   n}', "");
    Expect(0, 195102, '\p{Is_NFKD_QC:   n}', "");
    Expect(1, 195102, '\p{^Is_NFKD_QC:   n}', "");
    Expect(1, 195102, '\P{Is_NFKD_QC:   n}', "");
    Expect(0, 195102, '\P{^Is_NFKD_QC:   n}', "");
    Expect(1, 195101, '\p{Is_NFKD_QC= N}', "");
    Expect(0, 195101, '\p{^Is_NFKD_QC= N}', "");
    Expect(0, 195101, '\P{Is_NFKD_QC= N}', "");
    Expect(1, 195101, '\P{^Is_NFKD_QC= N}', "");
    Expect(0, 195102, '\p{Is_NFKD_QC= N}', "");
    Expect(1, 195102, '\p{^Is_NFKD_QC= N}', "");
    Expect(1, 195102, '\P{Is_NFKD_QC= N}', "");
    Expect(0, 195102, '\P{^Is_NFKD_QC= N}', "");
    Error('\p{NFKD_Quick_Check=/a/-_yes}');
    Error('\P{NFKD_Quick_Check=/a/-_yes}');
    Expect(1, 195102, '\p{NFKD_Quick_Check=:\AYes\z:}', "");;
    Expect(0, 195101, '\p{NFKD_Quick_Check=:\AYes\z:}', "");;
    Expect(1, 195102, '\p{NFKD_Quick_Check=yes}', "");
    Expect(0, 195102, '\p{^NFKD_Quick_Check=yes}', "");
    Expect(0, 195102, '\P{NFKD_Quick_Check=yes}', "");
    Expect(1, 195102, '\P{^NFKD_Quick_Check=yes}', "");
    Expect(0, 195101, '\p{NFKD_Quick_Check=yes}', "");
    Expect(1, 195101, '\p{^NFKD_Quick_Check=yes}', "");
    Expect(1, 195101, '\P{NFKD_Quick_Check=yes}', "");
    Expect(0, 195101, '\P{^NFKD_Quick_Check=yes}', "");
    Expect(1, 195102, '\p{NFKD_Quick_Check=:\Ayes\z:}', "");;
    Expect(0, 195101, '\p{NFKD_Quick_Check=:\Ayes\z:}', "");;
    Expect(1, 195102, '\p{NFKD_Quick_Check=-Yes}', "");
    Expect(0, 195102, '\p{^NFKD_Quick_Check=-Yes}', "");
    Expect(0, 195102, '\P{NFKD_Quick_Check=-Yes}', "");
    Expect(1, 195102, '\P{^NFKD_Quick_Check=-Yes}', "");
    Expect(0, 195101, '\p{NFKD_Quick_Check=-Yes}', "");
    Expect(1, 195101, '\p{^NFKD_Quick_Check=-Yes}', "");
    Expect(1, 195101, '\P{NFKD_Quick_Check=-Yes}', "");
    Expect(0, 195101, '\P{^NFKD_Quick_Check=-Yes}', "");
    Error('\p{NFKD_QC:/a/Y}');
    Error('\P{NFKD_QC:/a/Y}');
    Expect(1, 195102, '\p{NFKD_QC=:\AY\z:}', "");;
    Expect(0, 195101, '\p{NFKD_QC=:\AY\z:}', "");;
    Expect(1, 195102, '\p{NFKD_QC:	y}', "");
    Expect(0, 195102, '\p{^NFKD_QC:	y}', "");
    Expect(0, 195102, '\P{NFKD_QC:	y}', "");
    Expect(1, 195102, '\P{^NFKD_QC:	y}', "");
    Expect(0, 195101, '\p{NFKD_QC:	y}', "");
    Expect(1, 195101, '\p{^NFKD_QC:	y}', "");
    Expect(1, 195101, '\P{NFKD_QC:	y}', "");
    Expect(0, 195101, '\P{^NFKD_QC:	y}', "");
    Expect(1, 195102, '\p{NFKD_QC=:\Ay\z:}', "");;
    Expect(0, 195101, '\p{NFKD_QC=:\Ay\z:}', "");;
    Expect(1, 195102, '\p{NFKD_QC=__Y}', "");
    Expect(0, 195102, '\p{^NFKD_QC=__Y}', "");
    Expect(0, 195102, '\P{NFKD_QC=__Y}', "");
    Expect(1, 195102, '\P{^NFKD_QC=__Y}', "");
    Expect(0, 195101, '\p{NFKD_QC=__Y}', "");
    Expect(1, 195101, '\p{^NFKD_QC=__Y}', "");
    Expect(1, 195101, '\P{NFKD_QC=__Y}', "");
    Expect(0, 195101, '\P{^NFKD_QC=__Y}', "");
    Error('\p{Is_NFKD_Quick_Check=	-Yes/a/}');
    Error('\P{Is_NFKD_Quick_Check=	-Yes/a/}');
    Expect(1, 195102, '\p{Is_NFKD_Quick_Check=yes}', "");
    Expect(0, 195102, '\p{^Is_NFKD_Quick_Check=yes}', "");
    Expect(0, 195102, '\P{Is_NFKD_Quick_Check=yes}', "");
    Expect(1, 195102, '\P{^Is_NFKD_Quick_Check=yes}', "");
    Expect(0, 195101, '\p{Is_NFKD_Quick_Check=yes}', "");
    Expect(1, 195101, '\p{^Is_NFKD_Quick_Check=yes}', "");
    Expect(1, 195101, '\P{Is_NFKD_Quick_Check=yes}', "");
    Expect(0, 195101, '\P{^Is_NFKD_Quick_Check=yes}', "");
    Expect(1, 195102, '\p{Is_NFKD_Quick_Check=Yes}', "");
    Expect(0, 195102, '\p{^Is_NFKD_Quick_Check=Yes}', "");
    Expect(0, 195102, '\P{Is_NFKD_Quick_Check=Yes}', "");
    Expect(1, 195102, '\P{^Is_NFKD_Quick_Check=Yes}', "");
    Expect(0, 195101, '\p{Is_NFKD_Quick_Check=Yes}', "");
    Expect(1, 195101, '\p{^Is_NFKD_Quick_Check=Yes}', "");
    Expect(1, 195101, '\P{Is_NFKD_Quick_Check=Yes}', "");
    Expect(0, 195101, '\P{^Is_NFKD_Quick_Check=Yes}', "");
    Error('\p{Is_NFKD_QC=	 Y:=}');
    Error('\P{Is_NFKD_QC=	 Y:=}');
    Expect(1, 195102, '\p{Is_NFKD_QC=y}', "");
    Expect(0, 195102, '\p{^Is_NFKD_QC=y}', "");
    Expect(0, 195102, '\P{Is_NFKD_QC=y}', "");
    Expect(1, 195102, '\P{^Is_NFKD_QC=y}', "");
    Expect(0, 195101, '\p{Is_NFKD_QC=y}', "");
    Expect(1, 195101, '\p{^Is_NFKD_QC=y}', "");
    Expect(1, 195101, '\P{Is_NFKD_QC=y}', "");
    Expect(0, 195101, '\P{^Is_NFKD_QC=y}', "");
    Expect(1, 195102, '\p{Is_NFKD_QC=  Y}', "");
    Expect(0, 195102, '\p{^Is_NFKD_QC=  Y}', "");
    Expect(0, 195102, '\P{Is_NFKD_QC=  Y}', "");
    Expect(1, 195102, '\P{^Is_NFKD_QC=  Y}', "");
    Expect(0, 195101, '\p{Is_NFKD_QC=  Y}', "");
    Expect(1, 195101, '\p{^Is_NFKD_QC=  Y}', "");
    Expect(1, 195101, '\P{Is_NFKD_QC=  Y}', "");
    Expect(0, 195101, '\P{^Is_NFKD_QC=  Y}', "");
    Error('\p{numerictype}');
    Error('\P{numerictype}');
    Error('\p{nt}');
    Error('\P{nt}');
    Error('\p{Numeric_Type:	/a/_Decimal}');
    Error('\P{Numeric_Type:	/a/_Decimal}');
    Expect(1, 130041, '\p{Numeric_Type=:\ADecimal\z:}', "");;
    Expect(0, 130042, '\p{Numeric_Type=:\ADecimal\z:}', "");;
    Expect(1, 130041, '\p{Numeric_Type=decimal}', "");
    Expect(0, 130041, '\p{^Numeric_Type=decimal}', "");
    Expect(0, 130041, '\P{Numeric_Type=decimal}', "");
    Expect(1, 130041, '\P{^Numeric_Type=decimal}', "");
    Expect(0, 130042, '\p{Numeric_Type=decimal}', "");
    Expect(1, 130042, '\p{^Numeric_Type=decimal}', "");
    Expect(1, 130042, '\P{Numeric_Type=decimal}', "");
    Expect(0, 130042, '\P{^Numeric_Type=decimal}', "");
    Expect(1, 130041, '\p{Numeric_Type=:\Adecimal\z:}', "");;
    Expect(0, 130042, '\p{Numeric_Type=:\Adecimal\z:}', "");;
    Expect(1, 130041, '\p{Numeric_Type=	 Decimal}', "");
    Expect(0, 130041, '\p{^Numeric_Type=	 Decimal}', "");
    Expect(0, 130041, '\P{Numeric_Type=	 Decimal}', "");
    Expect(1, 130041, '\P{^Numeric_Type=	 Decimal}', "");
    Expect(0, 130042, '\p{Numeric_Type=	 Decimal}', "");
    Expect(1, 130042, '\p{^Numeric_Type=	 Decimal}', "");
    Expect(1, 130042, '\P{Numeric_Type=	 Decimal}', "");
    Expect(0, 130042, '\P{^Numeric_Type=	 Decimal}', "");
    Error('\p{Nt=_:=De}');
    Error('\P{Nt=_:=De}');
    Expect(1, 130041, '\p{Nt=:\ADe\z:}', "");;
    Expect(0, 130042, '\p{Nt=:\ADe\z:}', "");;
    Expect(1, 130041, '\p{Nt=de}', "");
    Expect(0, 130041, '\p{^Nt=de}', "");
    Expect(0, 130041, '\P{Nt=de}', "");
    Expect(1, 130041, '\P{^Nt=de}', "");
    Expect(0, 130042, '\p{Nt=de}', "");
    Expect(1, 130042, '\p{^Nt=de}', "");
    Expect(1, 130042, '\P{Nt=de}', "");
    Expect(0, 130042, '\P{^Nt=de}', "");
    Expect(1, 130041, '\p{Nt=:\Ade\z:}', "");;
    Expect(0, 130042, '\p{Nt=:\Ade\z:}', "");;
    Expect(1, 130041, '\p{Nt=		De}', "");
    Expect(0, 130041, '\p{^Nt=		De}', "");
    Expect(0, 130041, '\P{Nt=		De}', "");
    Expect(1, 130041, '\P{^Nt=		De}', "");
    Expect(0, 130042, '\p{Nt=		De}', "");
    Expect(1, 130042, '\p{^Nt=		De}', "");
    Expect(1, 130042, '\P{Nt=		De}', "");
    Expect(0, 130042, '\P{^Nt=		De}', "");
    Error('\p{Is_Numeric_Type=	:=DECIMAL}');
    Error('\P{Is_Numeric_Type=	:=DECIMAL}');
    Expect(1, 130041, '\p{Is_Numeric_Type=decimal}', "");
    Expect(0, 130041, '\p{^Is_Numeric_Type=decimal}', "");
    Expect(0, 130041, '\P{Is_Numeric_Type=decimal}', "");
    Expect(1, 130041, '\P{^Is_Numeric_Type=decimal}', "");
    Expect(0, 130042, '\p{Is_Numeric_Type=decimal}', "");
    Expect(1, 130042, '\p{^Is_Numeric_Type=decimal}', "");
    Expect(1, 130042, '\P{Is_Numeric_Type=decimal}', "");
    Expect(0, 130042, '\P{^Is_Numeric_Type=decimal}', "");
    Expect(1, 130041, '\p{Is_Numeric_Type=_decimal}', "");
    Expect(0, 130041, '\p{^Is_Numeric_Type=_decimal}', "");
    Expect(0, 130041, '\P{Is_Numeric_Type=_decimal}', "");
    Expect(1, 130041, '\P{^Is_Numeric_Type=_decimal}', "");
    Expect(0, 130042, '\p{Is_Numeric_Type=_decimal}', "");
    Expect(1, 130042, '\p{^Is_Numeric_Type=_decimal}', "");
    Expect(1, 130042, '\P{Is_Numeric_Type=_decimal}', "");
    Expect(0, 130042, '\P{^Is_Numeric_Type=_decimal}', "");
    Error('\p{Is_Nt=/a/de}');
    Error('\P{Is_Nt=/a/de}');
    Expect(1, 130041, '\p{Is_Nt=de}', "");
    Expect(0, 130041, '\p{^Is_Nt=de}', "");
    Expect(0, 130041, '\P{Is_Nt=de}', "");
    Expect(1, 130041, '\P{^Is_Nt=de}', "");
    Expect(0, 130042, '\p{Is_Nt=de}', "");
    Expect(1, 130042, '\p{^Is_Nt=de}', "");
    Expect(1, 130042, '\P{Is_Nt=de}', "");
    Expect(0, 130042, '\P{^Is_Nt=de}', "");
    Expect(1, 130041, '\p{Is_Nt= 	de}', "");
    Expect(0, 130041, '\p{^Is_Nt= 	de}', "");
    Expect(0, 130041, '\P{Is_Nt= 	de}', "");
    Expect(1, 130041, '\P{^Is_Nt= 	de}', "");
    Expect(0, 130042, '\p{Is_Nt= 	de}', "");
    Expect(1, 130042, '\p{^Is_Nt= 	de}', "");
    Expect(1, 130042, '\P{Is_Nt= 	de}', "");
    Expect(0, 130042, '\P{^Is_Nt= 	de}', "");
    Error('\p{Numeric_Type=:=-	digit}');
    Error('\P{Numeric_Type=:=-	digit}');
    Expect(1, 127242, '\p{Numeric_Type=:\ADigit\z:}', "");;
    Expect(0, 127243, '\p{Numeric_Type=:\ADigit\z:}', "");;
    Expect(1, 127242, '\p{Numeric_Type=digit}', "");
    Expect(0, 127242, '\p{^Numeric_Type=digit}', "");
    Expect(0, 127242, '\P{Numeric_Type=digit}', "");
    Expect(1, 127242, '\P{^Numeric_Type=digit}', "");
    Expect(0, 127243, '\p{Numeric_Type=digit}', "");
    Expect(1, 127243, '\p{^Numeric_Type=digit}', "");
    Expect(1, 127243, '\P{Numeric_Type=digit}', "");
    Expect(0, 127243, '\P{^Numeric_Type=digit}', "");
    Expect(1, 127242, '\p{Numeric_Type=:\Adigit\z:}', "");;
    Expect(0, 127243, '\p{Numeric_Type=:\Adigit\z:}', "");;
    Expect(1, 127242, '\p{Numeric_Type=	DIGIT}', "");
    Expect(0, 127242, '\p{^Numeric_Type=	DIGIT}', "");
    Expect(0, 127242, '\P{Numeric_Type=	DIGIT}', "");
    Expect(1, 127242, '\P{^Numeric_Type=	DIGIT}', "");
    Expect(0, 127243, '\p{Numeric_Type=	DIGIT}', "");
    Expect(1, 127243, '\p{^Numeric_Type=	DIGIT}', "");
    Expect(1, 127243, '\P{Numeric_Type=	DIGIT}', "");
    Expect(0, 127243, '\P{^Numeric_Type=	DIGIT}', "");
    Error('\p{Nt= di/a/}');
    Error('\P{Nt= di/a/}');
    Expect(1, 127242, '\p{Nt=:\ADi\z:}', "");;
    Expect(0, 127243, '\p{Nt=:\ADi\z:}', "");;
    Expect(1, 127242, '\p{Nt=di}', "");
    Expect(0, 127242, '\p{^Nt=di}', "");
    Expect(0, 127242, '\P{Nt=di}', "");
    Expect(1, 127242, '\P{^Nt=di}', "");
    Expect(0, 127243, '\p{Nt=di}', "");
    Expect(1, 127243, '\p{^Nt=di}', "");
    Expect(1, 127243, '\P{Nt=di}', "");
    Expect(0, 127243, '\P{^Nt=di}', "");
    Expect(1, 127242, '\p{Nt=:\Adi\z:}', "");;
    Expect(0, 127243, '\p{Nt=:\Adi\z:}', "");;
    Expect(1, 127242, '\p{Nt=--Di}', "");
    Expect(0, 127242, '\p{^Nt=--Di}', "");
    Expect(0, 127242, '\P{Nt=--Di}', "");
    Expect(1, 127242, '\P{^Nt=--Di}', "");
    Expect(0, 127243, '\p{Nt=--Di}', "");
    Expect(1, 127243, '\p{^Nt=--Di}', "");
    Expect(1, 127243, '\P{Nt=--Di}', "");
    Expect(0, 127243, '\P{^Nt=--Di}', "");
    Error('\p{Is_Numeric_Type=__DIGIT:=}');
    Error('\P{Is_Numeric_Type=__DIGIT:=}');
    Expect(1, 127242, '\p{Is_Numeric_Type:   digit}', "");
    Expect(0, 127242, '\p{^Is_Numeric_Type:   digit}', "");
    Expect(0, 127242, '\P{Is_Numeric_Type:   digit}', "");
    Expect(1, 127242, '\P{^Is_Numeric_Type:   digit}', "");
    Expect(0, 127243, '\p{Is_Numeric_Type:   digit}', "");
    Expect(1, 127243, '\p{^Is_Numeric_Type:   digit}', "");
    Expect(1, 127243, '\P{Is_Numeric_Type:   digit}', "");
    Expect(0, 127243, '\P{^Is_Numeric_Type:   digit}', "");
    Expect(1, 127242, '\p{Is_Numeric_Type=		Digit}', "");
    Expect(0, 127242, '\p{^Is_Numeric_Type=		Digit}', "");
    Expect(0, 127242, '\P{Is_Numeric_Type=		Digit}', "");
    Expect(1, 127242, '\P{^Is_Numeric_Type=		Digit}', "");
    Expect(0, 127243, '\p{Is_Numeric_Type=		Digit}', "");
    Expect(1, 127243, '\p{^Is_Numeric_Type=		Digit}', "");
    Expect(1, 127243, '\P{Is_Numeric_Type=		Digit}', "");
    Expect(0, 127243, '\P{^Is_Numeric_Type=		Digit}', "");
    Error('\p{Is_Nt:/a/di}');
    Error('\P{Is_Nt:/a/di}');
    Expect(1, 127242, '\p{Is_Nt=di}', "");
    Expect(0, 127242, '\p{^Is_Nt=di}', "");
    Expect(0, 127242, '\P{Is_Nt=di}', "");
    Expect(1, 127242, '\P{^Is_Nt=di}', "");
    Expect(0, 127243, '\p{Is_Nt=di}', "");
    Expect(1, 127243, '\p{^Is_Nt=di}', "");
    Expect(1, 127243, '\P{Is_Nt=di}', "");
    Expect(0, 127243, '\P{^Is_Nt=di}', "");
    Expect(1, 127242, '\p{Is_Nt=	Di}', "");
    Expect(0, 127242, '\p{^Is_Nt=	Di}', "");
    Expect(0, 127242, '\P{Is_Nt=	Di}', "");
    Expect(1, 127242, '\P{^Is_Nt=	Di}', "");
    Expect(0, 127243, '\p{Is_Nt=	Di}', "");
    Expect(1, 127243, '\p{^Is_Nt=	Di}', "");
    Expect(1, 127243, '\P{Is_Nt=	Di}', "");
    Expect(0, 127243, '\P{^Is_Nt=	Di}', "");
    Error('\p{Numeric_Type=/a/	-None}');
    Error('\P{Numeric_Type=/a/	-None}');
    Expect(1, 194705, '\p{Numeric_Type=:\ANone\z:}', "");;
    Expect(0, 194704, '\p{Numeric_Type=:\ANone\z:}', "");;
    Expect(1, 194705, '\p{Numeric_Type=none}', "");
    Expect(0, 194705, '\p{^Numeric_Type=none}', "");
    Expect(0, 194705, '\P{Numeric_Type=none}', "");
    Expect(1, 194705, '\P{^Numeric_Type=none}', "");
    Expect(0, 194704, '\p{Numeric_Type=none}', "");
    Expect(1, 194704, '\p{^Numeric_Type=none}', "");
    Expect(1, 194704, '\P{Numeric_Type=none}', "");
    Expect(0, 194704, '\P{^Numeric_Type=none}', "");
    Expect(1, 194705, '\p{Numeric_Type=:\Anone\z:}', "");;
    Expect(0, 194704, '\p{Numeric_Type=:\Anone\z:}', "");;
    Expect(1, 194705, '\p{Numeric_Type:	-	none}', "");
    Expect(0, 194705, '\p{^Numeric_Type:	-	none}', "");
    Expect(0, 194705, '\P{Numeric_Type:	-	none}', "");
    Expect(1, 194705, '\P{^Numeric_Type:	-	none}', "");
    Expect(0, 194704, '\p{Numeric_Type:	-	none}', "");
    Expect(1, 194704, '\p{^Numeric_Type:	-	none}', "");
    Expect(1, 194704, '\P{Numeric_Type:	-	none}', "");
    Expect(0, 194704, '\P{^Numeric_Type:	-	none}', "");
    Error('\p{Nt=:=	_None}');
    Error('\P{Nt=:=	_None}');
    Expect(1, 194705, '\p{Nt=:\ANone\z:}', "");;
    Expect(0, 194704, '\p{Nt=:\ANone\z:}', "");;
    Expect(1, 194705, '\p{Nt=none}', "");
    Expect(0, 194705, '\p{^Nt=none}', "");
    Expect(0, 194705, '\P{Nt=none}', "");
    Expect(1, 194705, '\P{^Nt=none}', "");
    Expect(0, 194704, '\p{Nt=none}', "");
    Expect(1, 194704, '\p{^Nt=none}', "");
    Expect(1, 194704, '\P{Nt=none}', "");
    Expect(0, 194704, '\P{^Nt=none}', "");
    Expect(1, 194705, '\p{Nt=:\Anone\z:}', "");;
    Expect(0, 194704, '\p{Nt=:\Anone\z:}', "");;
    Expect(1, 194705, '\p{Nt=_None}', "");
    Expect(0, 194705, '\p{^Nt=_None}', "");
    Expect(0, 194705, '\P{Nt=_None}', "");
    Expect(1, 194705, '\P{^Nt=_None}', "");
    Expect(0, 194704, '\p{Nt=_None}', "");
    Expect(1, 194704, '\p{^Nt=_None}', "");
    Expect(1, 194704, '\P{Nt=_None}', "");
    Expect(0, 194704, '\P{^Nt=_None}', "");
    Error('\p{Is_Numeric_Type=:=-	None}');
    Error('\P{Is_Numeric_Type=:=-	None}');
    Expect(1, 194705, '\p{Is_Numeric_Type=none}', "");
    Expect(0, 194705, '\p{^Is_Numeric_Type=none}', "");
    Expect(0, 194705, '\P{Is_Numeric_Type=none}', "");
    Expect(1, 194705, '\P{^Is_Numeric_Type=none}', "");
    Expect(0, 194704, '\p{Is_Numeric_Type=none}', "");
    Expect(1, 194704, '\p{^Is_Numeric_Type=none}', "");
    Expect(1, 194704, '\P{Is_Numeric_Type=none}', "");
    Expect(0, 194704, '\P{^Is_Numeric_Type=none}', "");
    Expect(1, 194705, '\p{Is_Numeric_Type=-	NONE}', "");
    Expect(0, 194705, '\p{^Is_Numeric_Type=-	NONE}', "");
    Expect(0, 194705, '\P{Is_Numeric_Type=-	NONE}', "");
    Expect(1, 194705, '\P{^Is_Numeric_Type=-	NONE}', "");
    Expect(0, 194704, '\p{Is_Numeric_Type=-	NONE}', "");
    Expect(1, 194704, '\p{^Is_Numeric_Type=-	NONE}', "");
    Expect(1, 194704, '\P{Is_Numeric_Type=-	NONE}', "");
    Expect(0, 194704, '\P{^Is_Numeric_Type=-	NONE}', "");
    Error('\p{Is_Nt=/a/None}');
    Error('\P{Is_Nt=/a/None}');
    Expect(1, 194705, '\p{Is_Nt=none}', "");
    Expect(0, 194705, '\p{^Is_Nt=none}', "");
    Expect(0, 194705, '\P{Is_Nt=none}', "");
    Expect(1, 194705, '\P{^Is_Nt=none}', "");
    Expect(0, 194704, '\p{Is_Nt=none}', "");
    Expect(1, 194704, '\p{^Is_Nt=none}', "");
    Expect(1, 194704, '\P{Is_Nt=none}', "");
    Expect(0, 194704, '\P{^Is_Nt=none}', "");
    Expect(1, 194705, '\p{Is_Nt=_None}', "");
    Expect(0, 194705, '\p{^Is_Nt=_None}', "");
    Expect(0, 194705, '\P{Is_Nt=_None}', "");
    Expect(1, 194705, '\P{^Is_Nt=_None}', "");
    Expect(0, 194704, '\p{Is_Nt=_None}', "");
    Expect(1, 194704, '\p{^Is_Nt=_None}', "");
    Expect(1, 194704, '\P{Is_Nt=_None}', "");
    Expect(0, 194704, '\P{^Is_Nt=_None}', "");
    Error('\p{Numeric_Type=_/a/numeric}');
    Error('\P{Numeric_Type=_/a/numeric}');
    Expect(1, 194704, '\p{Numeric_Type=:\ANumeric\z:}', "");;
    Expect(0, 194705, '\p{Numeric_Type=:\ANumeric\z:}', "");;
    Expect(1, 194704, '\p{Numeric_Type=numeric}', "");
    Expect(0, 194704, '\p{^Numeric_Type=numeric}', "");
    Expect(0, 194704, '\P{Numeric_Type=numeric}', "");
    Expect(1, 194704, '\P{^Numeric_Type=numeric}', "");
    Expect(0, 194705, '\p{Numeric_Type=numeric}', "");
    Expect(1, 194705, '\p{^Numeric_Type=numeric}', "");
    Expect(1, 194705, '\P{Numeric_Type=numeric}', "");
    Expect(0, 194705, '\P{^Numeric_Type=numeric}', "");
    Expect(1, 194704, '\p{Numeric_Type=:\Anumeric\z:}', "");;
    Expect(0, 194705, '\p{Numeric_Type=:\Anumeric\z:}', "");;
    Expect(1, 194704, '\p{Numeric_Type:   	numeric}', "");
    Expect(0, 194704, '\p{^Numeric_Type:   	numeric}', "");
    Expect(0, 194704, '\P{Numeric_Type:   	numeric}', "");
    Expect(1, 194704, '\P{^Numeric_Type:   	numeric}', "");
    Expect(0, 194705, '\p{Numeric_Type:   	numeric}', "");
    Expect(1, 194705, '\p{^Numeric_Type:   	numeric}', "");
    Expect(1, 194705, '\P{Numeric_Type:   	numeric}', "");
    Expect(0, 194705, '\P{^Numeric_Type:   	numeric}', "");
    Error('\p{Nt=	/a/nu}');
    Error('\P{Nt=	/a/nu}');
    Expect(1, 194704, '\p{Nt=:\ANu\z:}', "");;
    Expect(0, 194705, '\p{Nt=:\ANu\z:}', "");;
    Expect(1, 194704, '\p{Nt=nu}', "");
    Expect(0, 194704, '\p{^Nt=nu}', "");
    Expect(0, 194704, '\P{Nt=nu}', "");
    Expect(1, 194704, '\P{^Nt=nu}', "");
    Expect(0, 194705, '\p{Nt=nu}', "");
    Expect(1, 194705, '\p{^Nt=nu}', "");
    Expect(1, 194705, '\P{Nt=nu}', "");
    Expect(0, 194705, '\P{^Nt=nu}', "");
    Expect(1, 194704, '\p{Nt=:\Anu\z:}', "");;
    Expect(0, 194705, '\p{Nt=:\Anu\z:}', "");;
    Expect(1, 194704, '\p{Nt=_-nu}', "");
    Expect(0, 194704, '\p{^Nt=_-nu}', "");
    Expect(0, 194704, '\P{Nt=_-nu}', "");
    Expect(1, 194704, '\P{^Nt=_-nu}', "");
    Expect(0, 194705, '\p{Nt=_-nu}', "");
    Expect(1, 194705, '\p{^Nt=_-nu}', "");
    Expect(1, 194705, '\P{Nt=_-nu}', "");
    Expect(0, 194705, '\P{^Nt=_-nu}', "");
    Error('\p{Is_Numeric_Type= numeric:=}');
    Error('\P{Is_Numeric_Type= numeric:=}');
    Expect(1, 194704, '\p{Is_Numeric_Type=numeric}', "");
    Expect(0, 194704, '\p{^Is_Numeric_Type=numeric}', "");
    Expect(0, 194704, '\P{Is_Numeric_Type=numeric}', "");
    Expect(1, 194704, '\P{^Is_Numeric_Type=numeric}', "");
    Expect(0, 194705, '\p{Is_Numeric_Type=numeric}', "");
    Expect(1, 194705, '\p{^Is_Numeric_Type=numeric}', "");
    Expect(1, 194705, '\P{Is_Numeric_Type=numeric}', "");
    Expect(0, 194705, '\P{^Is_Numeric_Type=numeric}', "");
    Expect(1, 194704, '\p{Is_Numeric_Type=	-numeric}', "");
    Expect(0, 194704, '\p{^Is_Numeric_Type=	-numeric}', "");
    Expect(0, 194704, '\P{Is_Numeric_Type=	-numeric}', "");
    Expect(1, 194704, '\P{^Is_Numeric_Type=	-numeric}', "");
    Expect(0, 194705, '\p{Is_Numeric_Type=	-numeric}', "");
    Expect(1, 194705, '\p{^Is_Numeric_Type=	-numeric}', "");
    Expect(1, 194705, '\P{Is_Numeric_Type=	-numeric}', "");
    Expect(0, 194705, '\P{^Is_Numeric_Type=	-numeric}', "");
    Error('\p{Is_Nt=/a/-_Nu}');
    Error('\P{Is_Nt=/a/-_Nu}');
    Expect(1, 194704, '\p{Is_Nt=nu}', "");
    Expect(0, 194704, '\p{^Is_Nt=nu}', "");
    Expect(0, 194704, '\P{Is_Nt=nu}', "");
    Expect(1, 194704, '\P{^Is_Nt=nu}', "");
    Expect(0, 194705, '\p{Is_Nt=nu}', "");
    Expect(1, 194705, '\p{^Is_Nt=nu}', "");
    Expect(1, 194705, '\P{Is_Nt=nu}', "");
    Expect(0, 194705, '\P{^Is_Nt=nu}', "");
    Expect(1, 194704, '\p{Is_Nt=-	Nu}', "");
    Expect(0, 194704, '\p{^Is_Nt=-	Nu}', "");
    Expect(0, 194704, '\P{Is_Nt=-	Nu}', "");
    Expect(1, 194704, '\P{^Is_Nt=-	Nu}', "");
    Expect(0, 194705, '\p{Is_Nt=-	Nu}', "");
    Expect(1, 194705, '\p{^Is_Nt=-	Nu}', "");
    Expect(1, 194705, '\P{Is_Nt=-	Nu}', "");
    Expect(0, 194705, '\P{^Is_Nt=-	Nu}', "");
    Error('\p{numericvalue}');
    Error('\P{numericvalue}');
    Error('\p{nv}');
    Error('\P{nv}');
    Error('\p{Numeric_Value:	:=-0000000001/002}');
    Error('\P{Numeric_Value:	:=-0000000001/002}');
    Expect(1, 3891, '\p{Numeric_Value=:\A-1/2\z:}', "");;
    Expect(0, 3892, '\p{Numeric_Value=:\A-1/2\z:}', "");;
    Expect(1, 3891, '\p{Numeric_Value=-00001/000002}', "");
    Expect(0, 3891, '\p{^Numeric_Value=-00001/000002}', "");
    Expect(0, 3891, '\P{Numeric_Value=-00001/000002}', "");
    Expect(1, 3891, '\P{^Numeric_Value=-00001/000002}', "");
    Expect(0, 3892, '\p{Numeric_Value=-00001/000002}', "");
    Expect(1, 3892, '\p{^Numeric_Value=-00001/000002}', "");
    Expect(1, 3892, '\P{Numeric_Value=-00001/000002}', "");
    Expect(0, 3892, '\P{^Numeric_Value=-00001/000002}', "");
    Expect(1, 3891, '\p{Numeric_Value=-60/120}', "");
    Expect(0, 3891, '\p{^Numeric_Value=-60/120}', "");
    Expect(0, 3891, '\P{Numeric_Value=-60/120}', "");
    Expect(1, 3891, '\P{^Numeric_Value=-60/120}', "");
    Expect(0, 3892, '\p{Numeric_Value=-60/120}', "");
    Expect(1, 3892, '\p{^Numeric_Value=-60/120}', "");
    Expect(1, 3892, '\P{Numeric_Value=-60/120}', "");
    Expect(0, 3892, '\P{^Numeric_Value=-60/120}', "");
    Expect(1, 3891, '\p{Numeric_Value=-5.0e-01}', "");
    Expect(0, 3891, '\p{^Numeric_Value=-5.0e-01}', "");
    Expect(0, 3891, '\P{Numeric_Value=-5.0e-01}', "");
    Expect(1, 3891, '\P{^Numeric_Value=-5.0e-01}', "");
    Expect(0, 3892, '\p{Numeric_Value=-5.0e-01}', "");
    Expect(1, 3892, '\p{^Numeric_Value=-5.0e-01}', "");
    Expect(1, 3892, '\P{Numeric_Value=-5.0e-01}', "");
    Expect(0, 3892, '\P{^Numeric_Value=-5.0e-01}', "");
    Expect(1, 3891, '\p{Numeric_Value=-0.5}', "");
    Expect(0, 3891, '\p{^Numeric_Value=-0.5}', "");
    Expect(0, 3891, '\P{Numeric_Value=-0.5}', "");
    Expect(1, 3891, '\P{^Numeric_Value=-0.5}', "");
    Expect(0, 3892, '\p{Numeric_Value=-0.5}', "");
    Expect(1, 3892, '\p{^Numeric_Value=-0.5}', "");
    Expect(1, 3892, '\P{Numeric_Value=-0.5}', "");
    Expect(0, 3892, '\P{^Numeric_Value=-0.5}', "");
    Expect(1, 3891, '\p{Numeric_Value=-5.00e-01}', "");
    Expect(0, 3891, '\p{^Numeric_Value=-5.00e-01}', "");
    Expect(0, 3891, '\P{Numeric_Value=-5.00e-01}', "");
    Expect(1, 3891, '\P{^Numeric_Value=-5.00e-01}', "");
    Expect(0, 3892, '\p{Numeric_Value=-5.00e-01}', "");
    Expect(1, 3892, '\p{^Numeric_Value=-5.00e-01}', "");
    Expect(1, 3892, '\P{Numeric_Value=-5.00e-01}', "");
    Expect(0, 3892, '\P{^Numeric_Value=-5.00e-01}', "");
    Expect(1, 3891, '\p{Numeric_Value=-0.50}', "");
    Expect(0, 3891, '\p{^Numeric_Value=-0.50}', "");
    Expect(0, 3891, '\P{Numeric_Value=-0.50}', "");
    Expect(1, 3891, '\P{^Numeric_Value=-0.50}', "");
    Expect(0, 3892, '\p{Numeric_Value=-0.50}', "");
    Expect(1, 3892, '\p{^Numeric_Value=-0.50}', "");
    Expect(1, 3892, '\P{Numeric_Value=-0.50}', "");
    Expect(0, 3892, '\P{^Numeric_Value=-0.50}', "");
    Error('\p{Nv:	 :=-00000001/00002}');
    Error('\P{Nv:	 :=-00000001/00002}');
    Expect(1, 3891, '\p{Nv=:\A-1/2\z:}', "");;
    Expect(0, 3892, '\p{Nv=:\A-1/2\z:}', "");;
    Expect(1, 3891, '\p{Nv=-000000001/0000000002}', "");
    Expect(0, 3891, '\p{^Nv=-000000001/0000000002}', "");
    Expect(0, 3891, '\P{Nv=-000000001/0000000002}', "");
    Expect(1, 3891, '\P{^Nv=-000000001/0000000002}', "");
    Expect(0, 3892, '\p{Nv=-000000001/0000000002}', "");
    Expect(1, 3892, '\p{^Nv=-000000001/0000000002}', "");
    Expect(1, 3892, '\P{Nv=-000000001/0000000002}', "");
    Expect(0, 3892, '\P{^Nv=-000000001/0000000002}', "");
    Expect(1, 3891, '\p{Nv=-60/120}', "");
    Expect(0, 3891, '\p{^Nv=-60/120}', "");
    Expect(0, 3891, '\P{Nv=-60/120}', "");
    Expect(1, 3891, '\P{^Nv=-60/120}', "");
    Expect(0, 3892, '\p{Nv=-60/120}', "");
    Expect(1, 3892, '\p{^Nv=-60/120}', "");
    Expect(1, 3892, '\P{Nv=-60/120}', "");
    Expect(0, 3892, '\P{^Nv=-60/120}', "");
    Expect(1, 3891, '\p{Nv=-5.0e-01}', "");
    Expect(0, 3891, '\p{^Nv=-5.0e-01}', "");
    Expect(0, 3891, '\P{Nv=-5.0e-01}', "");
    Expect(1, 3891, '\P{^Nv=-5.0e-01}', "");
    Expect(0, 3892, '\p{Nv=-5.0e-01}', "");
    Expect(1, 3892, '\p{^Nv=-5.0e-01}', "");
    Expect(1, 3892, '\P{Nv=-5.0e-01}', "");
    Expect(0, 3892, '\P{^Nv=-5.0e-01}', "");
    Expect(1, 3891, '\p{Nv=-0.5}', "");
    Expect(0, 3891, '\p{^Nv=-0.5}', "");
    Expect(0, 3891, '\P{Nv=-0.5}', "");
    Expect(1, 3891, '\P{^Nv=-0.5}', "");
    Expect(0, 3892, '\p{Nv=-0.5}', "");
    Expect(1, 3892, '\p{^Nv=-0.5}', "");
    Expect(1, 3892, '\P{Nv=-0.5}', "");
    Expect(0, 3892, '\P{^Nv=-0.5}', "");
    Expect(1, 3891, '\p{Nv=-5.00e-01}', "");
    Expect(0, 3891, '\p{^Nv=-5.00e-01}', "");
    Expect(0, 3891, '\P{Nv=-5.00e-01}', "");
    Expect(1, 3891, '\P{^Nv=-5.00e-01}', "");
    Expect(0, 3892, '\p{Nv=-5.00e-01}', "");
    Expect(1, 3892, '\p{^Nv=-5.00e-01}', "");
    Expect(1, 3892, '\P{Nv=-5.00e-01}', "");
    Expect(0, 3892, '\P{^Nv=-5.00e-01}', "");
    Expect(1, 3891, '\p{Nv: -0.50}', "");
    Expect(0, 3891, '\p{^Nv: -0.50}', "");
    Expect(0, 3891, '\P{Nv: -0.50}', "");
    Expect(1, 3891, '\P{^Nv: -0.50}', "");
    Expect(0, 3892, '\p{Nv: -0.50}', "");
    Expect(1, 3892, '\p{^Nv: -0.50}', "");
    Expect(1, 3892, '\P{Nv: -0.50}', "");
    Expect(0, 3892, '\P{^Nv: -0.50}', "");
    Error('\p{Is_Numeric_Value:   ---001/0000002/a/}');
    Error('\P{Is_Numeric_Value:   ---001/0000002/a/}');
    Expect(1, 3891, '\p{Is_Numeric_Value=-0000000001/2}', "");
    Expect(0, 3891, '\p{^Is_Numeric_Value=-0000000001/2}', "");
    Expect(0, 3891, '\P{Is_Numeric_Value=-0000000001/2}', "");
    Expect(1, 3891, '\P{^Is_Numeric_Value=-0000000001/2}', "");
    Expect(0, 3892, '\p{Is_Numeric_Value=-0000000001/2}', "");
    Expect(1, 3892, '\p{^Is_Numeric_Value=-0000000001/2}', "");
    Expect(1, 3892, '\P{Is_Numeric_Value=-0000000001/2}', "");
    Expect(0, 3892, '\P{^Is_Numeric_Value=-0000000001/2}', "");
    Expect(1, 3891, '\p{Is_Numeric_Value=-60/120}', "");
    Expect(0, 3891, '\p{^Is_Numeric_Value=-60/120}', "");
    Expect(0, 3891, '\P{Is_Numeric_Value=-60/120}', "");
    Expect(1, 3891, '\P{^Is_Numeric_Value=-60/120}', "");
    Expect(0, 3892, '\p{Is_Numeric_Value=-60/120}', "");
    Expect(1, 3892, '\p{^Is_Numeric_Value=-60/120}', "");
    Expect(1, 3892, '\P{Is_Numeric_Value=-60/120}', "");
    Expect(0, 3892, '\P{^Is_Numeric_Value=-60/120}', "");
    Expect(1, 3891, '\p{Is_Numeric_Value=-5.0e-01}', "");
    Expect(0, 3891, '\p{^Is_Numeric_Value=-5.0e-01}', "");
    Expect(0, 3891, '\P{Is_Numeric_Value=-5.0e-01}', "");
    Expect(1, 3891, '\P{^Is_Numeric_Value=-5.0e-01}', "");
    Expect(0, 3892, '\p{Is_Numeric_Value=-5.0e-01}', "");
    Expect(1, 3892, '\p{^Is_Numeric_Value=-5.0e-01}', "");
    Expect(1, 3892, '\P{Is_Numeric_Value=-5.0e-01}', "");
    Expect(0, 3892, '\P{^Is_Numeric_Value=-5.0e-01}', "");
    Expect(1, 3891, '\p{Is_Numeric_Value=-0.5}', "");
    Expect(0, 3891, '\p{^Is_Numeric_Value=-0.5}', "");
    Expect(0, 3891, '\P{Is_Numeric_Value=-0.5}', "");
    Expect(1, 3891, '\P{^Is_Numeric_Value=-0.5}', "");
    Expect(0, 3892, '\p{Is_Numeric_Value=-0.5}', "");
    Expect(1, 3892, '\p{^Is_Numeric_Value=-0.5}', "");
    Expect(1, 3892, '\P{Is_Numeric_Value=-0.5}', "");
    Expect(0, 3892, '\P{^Is_Numeric_Value=-0.5}', "");
    Expect(1, 3891, '\p{Is_Numeric_Value=-5.00e-01}', "");
    Expect(0, 3891, '\p{^Is_Numeric_Value=-5.00e-01}', "");
    Expect(0, 3891, '\P{Is_Numeric_Value=-5.00e-01}', "");
    Expect(1, 3891, '\P{^Is_Numeric_Value=-5.00e-01}', "");
    Expect(0, 3892, '\p{Is_Numeric_Value=-5.00e-01}', "");
    Expect(1, 3892, '\p{^Is_Numeric_Value=-5.00e-01}', "");
    Expect(1, 3892, '\P{Is_Numeric_Value=-5.00e-01}', "");
    Expect(0, 3892, '\P{^Is_Numeric_Value=-5.00e-01}', "");
    Expect(1, 3891, '\p{Is_Numeric_Value=-0.50}', "");
    Expect(0, 3891, '\p{^Is_Numeric_Value=-0.50}', "");
    Expect(0, 3891, '\P{Is_Numeric_Value=-0.50}', "");
    Expect(1, 3891, '\P{^Is_Numeric_Value=-0.50}', "");
    Expect(0, 3892, '\p{Is_Numeric_Value=-0.50}', "");
    Expect(1, 3892, '\p{^Is_Numeric_Value=-0.50}', "");
    Expect(1, 3892, '\P{Is_Numeric_Value=-0.50}', "");
    Expect(0, 3892, '\P{^Is_Numeric_Value=-0.50}', "");
    Error('\p{Is_Nv=/a/-000000001/002}');
    Error('\P{Is_Nv=/a/-000000001/002}');
    Expect(1, 3891, '\p{Is_Nv=-000000001/002}', "");
    Expect(0, 3891, '\p{^Is_Nv=-000000001/002}', "");
    Expect(0, 3891, '\P{Is_Nv=-000000001/002}', "");
    Expect(1, 3891, '\P{^Is_Nv=-000000001/002}', "");
    Expect(0, 3892, '\p{Is_Nv=-000000001/002}', "");
    Expect(1, 3892, '\p{^Is_Nv=-000000001/002}', "");
    Expect(1, 3892, '\P{Is_Nv=-000000001/002}', "");
    Expect(0, 3892, '\P{^Is_Nv=-000000001/002}', "");
    Expect(1, 3891, '\p{Is_Nv:	-60/120}', "");
    Expect(0, 3891, '\p{^Is_Nv:	-60/120}', "");
    Expect(0, 3891, '\P{Is_Nv:	-60/120}', "");
    Expect(1, 3891, '\P{^Is_Nv:	-60/120}', "");
    Expect(0, 3892, '\p{Is_Nv:	-60/120}', "");
    Expect(1, 3892, '\p{^Is_Nv:	-60/120}', "");
    Expect(1, 3892, '\P{Is_Nv:	-60/120}', "");
    Expect(0, 3892, '\P{^Is_Nv:	-60/120}', "");
    Expect(1, 3891, '\p{Is_Nv:	-5.0e-01}', "");
    Expect(0, 3891, '\p{^Is_Nv:	-5.0e-01}', "");
    Expect(0, 3891, '\P{Is_Nv:	-5.0e-01}', "");
    Expect(1, 3891, '\P{^Is_Nv:	-5.0e-01}', "");
    Expect(0, 3892, '\p{Is_Nv:	-5.0e-01}', "");
    Expect(1, 3892, '\p{^Is_Nv:	-5.0e-01}', "");
    Expect(1, 3892, '\P{Is_Nv:	-5.0e-01}', "");
    Expect(0, 3892, '\P{^Is_Nv:	-5.0e-01}', "");
    Expect(1, 3891, '\p{Is_Nv=-0.5}', "");
    Expect(0, 3891, '\p{^Is_Nv=-0.5}', "");
    Expect(0, 3891, '\P{Is_Nv=-0.5}', "");
    Expect(1, 3891, '\P{^Is_Nv=-0.5}', "");
    Expect(0, 3892, '\p{Is_Nv=-0.5}', "");
    Expect(1, 3892, '\p{^Is_Nv=-0.5}', "");
    Expect(1, 3892, '\P{Is_Nv=-0.5}', "");
    Expect(0, 3892, '\P{^Is_Nv=-0.5}', "");
    Expect(1, 3891, '\p{Is_Nv=-5.00e-01}', "");
    Expect(0, 3891, '\p{^Is_Nv=-5.00e-01}', "");
    Expect(0, 3891, '\P{Is_Nv=-5.00e-01}', "");
    Expect(1, 3891, '\P{^Is_Nv=-5.00e-01}', "");
    Expect(0, 3892, '\p{Is_Nv=-5.00e-01}', "");
    Expect(1, 3892, '\p{^Is_Nv=-5.00e-01}', "");
    Expect(1, 3892, '\P{Is_Nv=-5.00e-01}', "");
    Expect(0, 3892, '\P{^Is_Nv=-5.00e-01}', "");
    Expect(1, 3891, '\p{Is_Nv=-0.50}', "");
    Expect(0, 3891, '\p{^Is_Nv=-0.50}', "");
    Expect(0, 3891, '\P{Is_Nv=-0.50}', "");
    Expect(1, 3891, '\P{^Is_Nv=-0.50}', "");
    Expect(0, 3892, '\p{Is_Nv=-0.50}', "");
    Expect(1, 3892, '\p{^Is_Nv=-0.50}', "");
    Expect(1, 3892, '\P{Is_Nv=-0.50}', "");
    Expect(0, 3892, '\P{^Is_Nv=-0.50}', "");
    Error('\p{Numeric_Value=_:=+00_00_0}');
    Error('\P{Numeric_Value=_:=+00_00_0}');
    Expect(1, 130032, '\p{Numeric_Value=:\A0\z:}', "");;
    Expect(0, 130033, '\p{Numeric_Value=:\A0\z:}', "");;
    Expect(1, 130032, '\p{Numeric_Value=0000000}', "");
    Expect(0, 130032, '\p{^Numeric_Value=0000000}', "");
    Expect(0, 130032, '\P{Numeric_Value=0000000}', "");
    Expect(1, 130032, '\P{^Numeric_Value=0000000}', "");
    Expect(0, 130033, '\p{Numeric_Value=0000000}', "");
    Expect(1, 130033, '\p{^Numeric_Value=0000000}', "");
    Expect(1, 130033, '\P{Numeric_Value=0000000}', "");
    Expect(0, 130033, '\P{^Numeric_Value=0000000}', "");
    Expect(1, 130032, '\p{Numeric_Value=0.000000000000000e+00}', "");
    Expect(0, 130032, '\p{^Numeric_Value=0.000000000000000e+00}', "");
    Expect(0, 130032, '\P{Numeric_Value=0.000000000000000e+00}', "");
    Expect(1, 130032, '\P{^Numeric_Value=0.000000000000000e+00}', "");
    Expect(0, 130033, '\p{Numeric_Value=0.000000000000000e+00}', "");
    Expect(1, 130033, '\p{^Numeric_Value=0.000000000000000e+00}', "");
    Expect(1, 130033, '\P{Numeric_Value=0.000000000000000e+00}', "");
    Expect(0, 130033, '\P{^Numeric_Value=0.000000000000000e+00}', "");
    Error('\p{Nv=/a/-+0_0_0_000}');
    Error('\P{Nv=/a/-+0_0_0_000}');
    Expect(1, 130032, '\p{Nv=:\A0\z:}', "");;
    Expect(0, 130033, '\p{Nv=:\A0\z:}', "");;
    Expect(1, 130032, '\p{Nv=+00000000}', "");
    Expect(0, 130032, '\p{^Nv=+00000000}', "");
    Expect(0, 130032, '\P{Nv=+00000000}', "");
    Expect(1, 130032, '\P{^Nv=+00000000}', "");
    Expect(0, 130033, '\p{Nv=+00000000}', "");
    Expect(1, 130033, '\p{^Nv=+00000000}', "");
    Expect(1, 130033, '\P{Nv=+00000000}', "");
    Expect(0, 130033, '\P{^Nv=+00000000}', "");
    Expect(1, 130032, '\p{Nv=0.000000000000000e+00}', "");
    Expect(0, 130032, '\p{^Nv=0.000000000000000e+00}', "");
    Expect(0, 130032, '\P{Nv=0.000000000000000e+00}', "");
    Expect(1, 130032, '\P{^Nv=0.000000000000000e+00}', "");
    Expect(0, 130033, '\p{Nv=0.000000000000000e+00}', "");
    Expect(1, 130033, '\p{^Nv=0.000000000000000e+00}', "");
    Expect(1, 130033, '\P{Nv=0.000000000000000e+00}', "");
    Expect(0, 130033, '\P{^Nv=0.000000000000000e+00}', "");
    Error('\p{Is_Numeric_Value=/a/00_0}');
    Error('\P{Is_Numeric_Value=/a/00_0}');
    Expect(1, 130032, '\p{Is_Numeric_Value=+00000_0}', "");
    Expect(0, 130032, '\p{^Is_Numeric_Value=+00000_0}', "");
    Expect(0, 130032, '\P{Is_Numeric_Value=+00000_0}', "");
    Expect(1, 130032, '\P{^Is_Numeric_Value=+00000_0}', "");
    Expect(0, 130033, '\p{Is_Numeric_Value=+00000_0}', "");
    Expect(1, 130033, '\p{^Is_Numeric_Value=+00000_0}', "");
    Expect(1, 130033, '\P{Is_Numeric_Value=+00000_0}', "");
    Expect(0, 130033, '\P{^Is_Numeric_Value=+00000_0}', "");
    Expect(1, 130032, '\p{Is_Numeric_Value=0.000000000000000e+00}', "");
    Expect(0, 130032, '\p{^Is_Numeric_Value=0.000000000000000e+00}', "");
    Expect(0, 130032, '\P{Is_Numeric_Value=0.000000000000000e+00}', "");
    Expect(1, 130032, '\P{^Is_Numeric_Value=0.000000000000000e+00}', "");
    Expect(0, 130033, '\p{Is_Numeric_Value=0.000000000000000e+00}', "");
    Expect(1, 130033, '\p{^Is_Numeric_Value=0.000000000000000e+00}', "");
    Expect(1, 130033, '\P{Is_Numeric_Value=0.000000000000000e+00}', "");
    Expect(0, 130033, '\P{^Is_Numeric_Value=0.000000000000000e+00}', "");
    Error('\p{Is_Nv=-	0000000_0/a/}');
    Error('\P{Is_Nv=-	0000000_0/a/}');
    Expect(1, 130032, '\p{Is_Nv=+000}', "");
    Expect(0, 130032, '\p{^Is_Nv=+000}', "");
    Expect(0, 130032, '\P{Is_Nv=+000}', "");
    Expect(1, 130032, '\P{^Is_Nv=+000}', "");
    Expect(0, 130033, '\p{Is_Nv=+000}', "");
    Expect(1, 130033, '\p{^Is_Nv=+000}', "");
    Expect(1, 130033, '\P{Is_Nv=+000}', "");
    Expect(0, 130033, '\P{^Is_Nv=+000}', "");
    Expect(1, 130032, '\p{Is_Nv=0.000000000000000e+00}', "");
    Expect(0, 130032, '\p{^Is_Nv=0.000000000000000e+00}', "");
    Expect(0, 130032, '\P{Is_Nv=0.000000000000000e+00}', "");
    Expect(1, 130032, '\P{^Is_Nv=0.000000000000000e+00}', "");
    Expect(0, 130033, '\p{Is_Nv=0.000000000000000e+00}', "");
    Expect(1, 130033, '\p{^Is_Nv=0.000000000000000e+00}', "");
    Expect(1, 130033, '\P{Is_Nv=0.000000000000000e+00}', "");
    Expect(0, 130033, '\P{^Is_Nv=0.000000000000000e+00}', "");
    Error('\p{Numeric_Value=:=  1}');
    Error('\P{Numeric_Value=:=  1}');
    Expect(1, 133418, '\p{Numeric_Value=:\A1\z:}', "");;
    Expect(0, 133419, '\p{Numeric_Value=:\A1\z:}', "");;
    Expect(1, 133418, '\p{Numeric_Value:	0_0_0_01}', "");
    Expect(0, 133418, '\p{^Numeric_Value:	0_0_0_01}', "");
    Expect(0, 133418, '\P{Numeric_Value:	0_0_0_01}', "");
    Expect(1, 133418, '\P{^Numeric_Value:	0_0_0_01}', "");
    Expect(0, 133419, '\p{Numeric_Value:	0_0_0_01}', "");
    Expect(1, 133419, '\p{^Numeric_Value:	0_0_0_01}', "");
    Expect(1, 133419, '\P{Numeric_Value:	0_0_0_01}', "");
    Expect(0, 133419, '\P{^Numeric_Value:	0_0_0_01}', "");
    Expect(1, 133418, '\p{Numeric_Value=1.000000000000000e+00}', "");
    Expect(0, 133418, '\p{^Numeric_Value=1.000000000000000e+00}', "");
    Expect(0, 133418, '\P{Numeric_Value=1.000000000000000e+00}', "");
    Expect(1, 133418, '\P{^Numeric_Value=1.000000000000000e+00}', "");
    Expect(0, 133419, '\p{Numeric_Value=1.000000000000000e+00}', "");
    Expect(1, 133419, '\p{^Numeric_Value=1.000000000000000e+00}', "");
    Expect(1, 133419, '\P{Numeric_Value=1.000000000000000e+00}', "");
    Expect(0, 133419, '\P{^Numeric_Value=1.000000000000000e+00}', "");
    Error('\p{Nv=/a/ _001}');
    Error('\P{Nv=/a/ _001}');
    Expect(1, 133418, '\p{Nv=:\A1\z:}', "");;
    Expect(0, 133419, '\p{Nv=:\A1\z:}', "");;
    Expect(1, 133418, '\p{Nv: 00_00_00_1}', "");
    Expect(0, 133418, '\p{^Nv: 00_00_00_1}', "");
    Expect(0, 133418, '\P{Nv: 00_00_00_1}', "");
    Expect(1, 133418, '\P{^Nv: 00_00_00_1}', "");
    Expect(0, 133419, '\p{Nv: 00_00_00_1}', "");
    Expect(1, 133419, '\p{^Nv: 00_00_00_1}', "");
    Expect(1, 133419, '\P{Nv: 00_00_00_1}', "");
    Expect(0, 133419, '\P{^Nv: 00_00_00_1}', "");
    Expect(1, 133418, '\p{Nv=1.000000000000000e+00}', "");
    Expect(0, 133418, '\p{^Nv=1.000000000000000e+00}', "");
    Expect(0, 133418, '\P{Nv=1.000000000000000e+00}', "");
    Expect(1, 133418, '\P{^Nv=1.000000000000000e+00}', "");
    Expect(0, 133419, '\p{Nv=1.000000000000000e+00}', "");
    Expect(1, 133419, '\p{^Nv=1.000000000000000e+00}', "");
    Expect(1, 133419, '\P{Nv=1.000000000000000e+00}', "");
    Expect(0, 133419, '\P{^Nv=1.000000000000000e+00}', "");
    Error('\p{Is_Numeric_Value=  0_0_0_0_001:=}');
    Error('\P{Is_Numeric_Value=  0_0_0_0_001:=}');
    Expect(1, 133418, '\p{Is_Numeric_Value=001}', "");
    Expect(0, 133418, '\p{^Is_Numeric_Value=001}', "");
    Expect(0, 133418, '\P{Is_Numeric_Value=001}', "");
    Expect(1, 133418, '\P{^Is_Numeric_Value=001}', "");
    Expect(0, 133419, '\p{Is_Numeric_Value=001}', "");
    Expect(1, 133419, '\p{^Is_Numeric_Value=001}', "");
    Expect(1, 133419, '\P{Is_Numeric_Value=001}', "");
    Expect(0, 133419, '\P{^Is_Numeric_Value=001}', "");
    Expect(1, 133418, '\p{Is_Numeric_Value=1.000000000000000e+00}', "");
    Expect(0, 133418, '\p{^Is_Numeric_Value=1.000000000000000e+00}', "");
    Expect(0, 133418, '\P{Is_Numeric_Value=1.000000000000000e+00}', "");
    Expect(1, 133418, '\P{^Is_Numeric_Value=1.000000000000000e+00}', "");
    Expect(0, 133419, '\p{Is_Numeric_Value=1.000000000000000e+00}', "");
    Expect(1, 133419, '\p{^Is_Numeric_Value=1.000000000000000e+00}', "");
    Expect(1, 133419, '\P{Is_Numeric_Value=1.000000000000000e+00}', "");
    Expect(0, 133419, '\P{^Is_Numeric_Value=1.000000000000000e+00}', "");
    Error('\p{Is_Nv=_:=01}');
    Error('\P{Is_Nv=_:=01}');
    Expect(1, 133418, '\p{Is_Nv=00_1}', "");
    Expect(0, 133418, '\p{^Is_Nv=00_1}', "");
    Expect(0, 133418, '\P{Is_Nv=00_1}', "");
    Expect(1, 133418, '\P{^Is_Nv=00_1}', "");
    Expect(0, 133419, '\p{Is_Nv=00_1}', "");
    Expect(1, 133419, '\p{^Is_Nv=00_1}', "");
    Expect(1, 133419, '\P{Is_Nv=00_1}', "");
    Expect(0, 133419, '\P{^Is_Nv=00_1}', "");
    Expect(1, 133418, '\p{Is_Nv=1.000000000000000e+00}', "");
    Expect(0, 133418, '\p{^Is_Nv=1.000000000000000e+00}', "");
    Expect(0, 133418, '\P{Is_Nv=1.000000000000000e+00}', "");
    Expect(1, 133418, '\P{^Is_Nv=1.000000000000000e+00}', "");
    Expect(0, 133419, '\p{Is_Nv=1.000000000000000e+00}', "");
    Expect(1, 133419, '\p{^Is_Nv=1.000000000000000e+00}', "");
    Expect(1, 133419, '\P{Is_Nv=1.000000000000000e+00}', "");
    Expect(0, 133419, '\P{^Is_Nv=1.000000000000000e+00}', "");
    Error('\p{Numeric_Value: +00000001/0010/a/}');
    Error('\P{Numeric_Value: +00000001/0010/a/}');
    Expect(1, 73675, '\p{Numeric_Value=:\A1/10\z:}', "");;
    Expect(0, 73676, '\p{Numeric_Value=:\A1/10\z:}', "");;
    Expect(1, 73675, '\p{Numeric_Value=+1/0000010}', "");
    Expect(0, 73675, '\p{^Numeric_Value=+1/0000010}', "");
    Expect(0, 73675, '\P{Numeric_Value=+1/0000010}', "");
    Expect(1, 73675, '\P{^Numeric_Value=+1/0000010}', "");
    Expect(0, 73676, '\p{Numeric_Value=+1/0000010}', "");
    Expect(1, 73676, '\p{^Numeric_Value=+1/0000010}', "");
    Expect(1, 73676, '\P{Numeric_Value=+1/0000010}', "");
    Expect(0, 73676, '\P{^Numeric_Value=+1/0000010}', "");
    Expect(1, 73675, '\p{Numeric_Value=60/600}', "");
    Expect(0, 73675, '\p{^Numeric_Value=60/600}', "");
    Expect(0, 73675, '\P{Numeric_Value=60/600}', "");
    Expect(1, 73675, '\P{^Numeric_Value=60/600}', "");
    Expect(0, 73676, '\p{Numeric_Value=60/600}', "");
    Expect(1, 73676, '\p{^Numeric_Value=60/600}', "");
    Expect(1, 73676, '\P{Numeric_Value=60/600}', "");
    Expect(0, 73676, '\P{^Numeric_Value=60/600}', "");
    Expect(1, 73675, '\p{Numeric_Value=1.0e-01}', "");
    Expect(0, 73675, '\p{^Numeric_Value=1.0e-01}', "");
    Expect(0, 73675, '\P{Numeric_Value=1.0e-01}', "");
    Expect(1, 73675, '\P{^Numeric_Value=1.0e-01}', "");
    Expect(0, 73676, '\p{Numeric_Value=1.0e-01}', "");
    Expect(1, 73676, '\p{^Numeric_Value=1.0e-01}', "");
    Expect(1, 73676, '\P{Numeric_Value=1.0e-01}', "");
    Expect(0, 73676, '\P{^Numeric_Value=1.0e-01}', "");
    Expect(1, 73675, '\p{Numeric_Value=0.1}', "");
    Expect(0, 73675, '\p{^Numeric_Value=0.1}', "");
    Expect(0, 73675, '\P{Numeric_Value=0.1}', "");
    Expect(1, 73675, '\P{^Numeric_Value=0.1}', "");
    Expect(0, 73676, '\p{Numeric_Value=0.1}', "");
    Expect(1, 73676, '\p{^Numeric_Value=0.1}', "");
    Expect(1, 73676, '\P{Numeric_Value=0.1}', "");
    Expect(0, 73676, '\P{^Numeric_Value=0.1}', "");
    Expect(1, 73675, '\p{Numeric_Value=1.00e-01}', "");
    Expect(0, 73675, '\p{^Numeric_Value=1.00e-01}', "");
    Expect(0, 73675, '\P{Numeric_Value=1.00e-01}', "");
    Expect(1, 73675, '\P{^Numeric_Value=1.00e-01}', "");
    Expect(0, 73676, '\p{Numeric_Value=1.00e-01}', "");
    Expect(1, 73676, '\p{^Numeric_Value=1.00e-01}', "");
    Expect(1, 73676, '\P{Numeric_Value=1.00e-01}', "");
    Expect(0, 73676, '\P{^Numeric_Value=1.00e-01}', "");
    Expect(1, 73675, '\p{Numeric_Value=0.10}', "");
    Expect(0, 73675, '\p{^Numeric_Value=0.10}', "");
    Expect(0, 73675, '\P{Numeric_Value=0.10}', "");
    Expect(1, 73675, '\P{^Numeric_Value=0.10}', "");
    Expect(0, 73676, '\p{Numeric_Value=0.10}', "");
    Expect(1, 73676, '\p{^Numeric_Value=0.10}', "");
    Expect(1, 73676, '\P{Numeric_Value=0.10}', "");
    Expect(0, 73676, '\P{^Numeric_Value=0.10}', "");
    Error('\p{Nv=:=_00000001/0000000010}');
    Error('\P{Nv=:=_00000001/0000000010}');
    Expect(1, 73675, '\p{Nv=:\A1/10\z:}', "");;
    Expect(0, 73676, '\p{Nv=:\A1/10\z:}', "");;
    Expect(1, 73675, '\p{Nv=+0001/0010}', "");
    Expect(0, 73675, '\p{^Nv=+0001/0010}', "");
    Expect(0, 73675, '\P{Nv=+0001/0010}', "");
    Expect(1, 73675, '\P{^Nv=+0001/0010}', "");
    Expect(0, 73676, '\p{Nv=+0001/0010}', "");
    Expect(1, 73676, '\p{^Nv=+0001/0010}', "");
    Expect(1, 73676, '\P{Nv=+0001/0010}', "");
    Expect(0, 73676, '\P{^Nv=+0001/0010}', "");
    Expect(1, 73675, '\p{Nv:60/600}', "");
    Expect(0, 73675, '\p{^Nv:60/600}', "");
    Expect(0, 73675, '\P{Nv:60/600}', "");
    Expect(1, 73675, '\P{^Nv:60/600}', "");
    Expect(0, 73676, '\p{Nv:60/600}', "");
    Expect(1, 73676, '\p{^Nv:60/600}', "");
    Expect(1, 73676, '\P{Nv:60/600}', "");
    Expect(0, 73676, '\P{^Nv:60/600}', "");
    Expect(1, 73675, '\p{Nv=1.0e-01}', "");
    Expect(0, 73675, '\p{^Nv=1.0e-01}', "");
    Expect(0, 73675, '\P{Nv=1.0e-01}', "");
    Expect(1, 73675, '\P{^Nv=1.0e-01}', "");
    Expect(0, 73676, '\p{Nv=1.0e-01}', "");
    Expect(1, 73676, '\p{^Nv=1.0e-01}', "");
    Expect(1, 73676, '\P{Nv=1.0e-01}', "");
    Expect(0, 73676, '\P{^Nv=1.0e-01}', "");
    Expect(1, 73675, '\p{Nv: 0.1}', "");
    Expect(0, 73675, '\p{^Nv: 0.1}', "");
    Expect(0, 73675, '\P{Nv: 0.1}', "");
    Expect(1, 73675, '\P{^Nv: 0.1}', "");
    Expect(0, 73676, '\p{Nv: 0.1}', "");
    Expect(1, 73676, '\p{^Nv: 0.1}', "");
    Expect(1, 73676, '\P{Nv: 0.1}', "");
    Expect(0, 73676, '\P{^Nv: 0.1}', "");
    Expect(1, 73675, '\p{Nv=1.00e-01}', "");
    Expect(0, 73675, '\p{^Nv=1.00e-01}', "");
    Expect(0, 73675, '\P{Nv=1.00e-01}', "");
    Expect(1, 73675, '\P{^Nv=1.00e-01}', "");
    Expect(0, 73676, '\p{Nv=1.00e-01}', "");
    Expect(1, 73676, '\p{^Nv=1.00e-01}', "");
    Expect(1, 73676, '\P{Nv=1.00e-01}', "");
    Expect(0, 73676, '\P{^Nv=1.00e-01}', "");
    Expect(1, 73675, '\p{Nv=0.10}', "");
    Expect(0, 73675, '\p{^Nv=0.10}', "");
    Expect(0, 73675, '\P{Nv=0.10}', "");
    Expect(1, 73675, '\P{^Nv=0.10}', "");
    Expect(0, 73676, '\p{Nv=0.10}', "");
    Expect(1, 73676, '\p{^Nv=0.10}', "");
    Expect(1, 73676, '\P{Nv=0.10}', "");
    Expect(0, 73676, '\P{^Nv=0.10}', "");
    Error('\p{Is_Numeric_Value=/a/__00000001/0000000010}');
    Error('\P{Is_Numeric_Value=/a/__00000001/0000000010}');
    Expect(1, 73675, '\p{Is_Numeric_Value=000001/00000000010}', "");
    Expect(0, 73675, '\p{^Is_Numeric_Value=000001/00000000010}', "");
    Expect(0, 73675, '\P{Is_Numeric_Value=000001/00000000010}', "");
    Expect(1, 73675, '\P{^Is_Numeric_Value=000001/00000000010}', "");
    Expect(0, 73676, '\p{Is_Numeric_Value=000001/00000000010}', "");
    Expect(1, 73676, '\p{^Is_Numeric_Value=000001/00000000010}', "");
    Expect(1, 73676, '\P{Is_Numeric_Value=000001/00000000010}', "");
    Expect(0, 73676, '\P{^Is_Numeric_Value=000001/00000000010}', "");
    Expect(1, 73675, '\p{Is_Numeric_Value=60/600}', "");
    Expect(0, 73675, '\p{^Is_Numeric_Value=60/600}', "");
    Expect(0, 73675, '\P{Is_Numeric_Value=60/600}', "");
    Expect(1, 73675, '\P{^Is_Numeric_Value=60/600}', "");
    Expect(0, 73676, '\p{Is_Numeric_Value=60/600}', "");
    Expect(1, 73676, '\p{^Is_Numeric_Value=60/600}', "");
    Expect(1, 73676, '\P{Is_Numeric_Value=60/600}', "");
    Expect(0, 73676, '\P{^Is_Numeric_Value=60/600}', "");
    Expect(1, 73675, '\p{Is_Numeric_Value=1.0e-01}', "");
    Expect(0, 73675, '\p{^Is_Numeric_Value=1.0e-01}', "");
    Expect(0, 73675, '\P{Is_Numeric_Value=1.0e-01}', "");
    Expect(1, 73675, '\P{^Is_Numeric_Value=1.0e-01}', "");
    Expect(0, 73676, '\p{Is_Numeric_Value=1.0e-01}', "");
    Expect(1, 73676, '\p{^Is_Numeric_Value=1.0e-01}', "");
    Expect(1, 73676, '\P{Is_Numeric_Value=1.0e-01}', "");
    Expect(0, 73676, '\P{^Is_Numeric_Value=1.0e-01}', "");
    Expect(1, 73675, '\p{Is_Numeric_Value=0.1}', "");
    Expect(0, 73675, '\p{^Is_Numeric_Value=0.1}', "");
    Expect(0, 73675, '\P{Is_Numeric_Value=0.1}', "");
    Expect(1, 73675, '\P{^Is_Numeric_Value=0.1}', "");
    Expect(0, 73676, '\p{Is_Numeric_Value=0.1}', "");
    Expect(1, 73676, '\p{^Is_Numeric_Value=0.1}', "");
    Expect(1, 73676, '\P{Is_Numeric_Value=0.1}', "");
    Expect(0, 73676, '\P{^Is_Numeric_Value=0.1}', "");
    Expect(1, 73675, '\p{Is_Numeric_Value=1.00e-01}', "");
    Expect(0, 73675, '\p{^Is_Numeric_Value=1.00e-01}', "");
    Expect(0, 73675, '\P{Is_Numeric_Value=1.00e-01}', "");
    Expect(1, 73675, '\P{^Is_Numeric_Value=1.00e-01}', "");
    Expect(0, 73676, '\p{Is_Numeric_Value=1.00e-01}', "");
    Expect(1, 73676, '\p{^Is_Numeric_Value=1.00e-01}', "");
    Expect(1, 73676, '\P{Is_Numeric_Value=1.00e-01}', "");
    Expect(0, 73676, '\P{^Is_Numeric_Value=1.00e-01}', "");
    Expect(1, 73675, '\p{Is_Numeric_Value=0.10}', "");
    Expect(0, 73675, '\p{^Is_Numeric_Value=0.10}', "");
    Expect(0, 73675, '\P{Is_Numeric_Value=0.10}', "");
    Expect(1, 73675, '\P{^Is_Numeric_Value=0.10}', "");
    Expect(0, 73676, '\p{Is_Numeric_Value=0.10}', "");
    Expect(1, 73676, '\p{^Is_Numeric_Value=0.10}', "");
    Expect(1, 73676, '\P{Is_Numeric_Value=0.10}', "");
    Expect(0, 73676, '\P{^Is_Numeric_Value=0.10}', "");
    Error('\p{Is_Nv=-:=0000001/000000010}');
    Error('\P{Is_Nv=-:=0000001/000000010}');
    Expect(1, 73675, '\p{Is_Nv:   00000001/000010}', "");
    Expect(0, 73675, '\p{^Is_Nv:   00000001/000010}', "");
    Expect(0, 73675, '\P{Is_Nv:   00000001/000010}', "");
    Expect(1, 73675, '\P{^Is_Nv:   00000001/000010}', "");
    Expect(0, 73676, '\p{Is_Nv:   00000001/000010}', "");
    Expect(1, 73676, '\p{^Is_Nv:   00000001/000010}', "");
    Expect(1, 73676, '\P{Is_Nv:   00000001/000010}', "");
    Expect(0, 73676, '\P{^Is_Nv:   00000001/000010}', "");
    Expect(1, 73675, '\p{Is_Nv=60/600}', "");
    Expect(0, 73675, '\p{^Is_Nv=60/600}', "");
    Expect(0, 73675, '\P{Is_Nv=60/600}', "");
    Expect(1, 73675, '\P{^Is_Nv=60/600}', "");
    Expect(0, 73676, '\p{Is_Nv=60/600}', "");
    Expect(1, 73676, '\p{^Is_Nv=60/600}', "");
    Expect(1, 73676, '\P{Is_Nv=60/600}', "");
    Expect(0, 73676, '\P{^Is_Nv=60/600}', "");
    Expect(1, 73675, '\p{Is_Nv=1.0e-01}', "");
    Expect(0, 73675, '\p{^Is_Nv=1.0e-01}', "");
    Expect(0, 73675, '\P{Is_Nv=1.0e-01}', "");
    Expect(1, 73675, '\P{^Is_Nv=1.0e-01}', "");
    Expect(0, 73676, '\p{Is_Nv=1.0e-01}', "");
    Expect(1, 73676, '\p{^Is_Nv=1.0e-01}', "");
    Expect(1, 73676, '\P{Is_Nv=1.0e-01}', "");
    Expect(0, 73676, '\P{^Is_Nv=1.0e-01}', "");
    Expect(1, 73675, '\p{Is_Nv=0.1}', "");
    Expect(0, 73675, '\p{^Is_Nv=0.1}', "");
    Expect(0, 73675, '\P{Is_Nv=0.1}', "");
    Expect(1, 73675, '\P{^Is_Nv=0.1}', "");
    Expect(0, 73676, '\p{Is_Nv=0.1}', "");
    Expect(1, 73676, '\p{^Is_Nv=0.1}', "");
    Expect(1, 73676, '\P{Is_Nv=0.1}', "");
    Expect(0, 73676, '\P{^Is_Nv=0.1}', "");
    Expect(1, 73675, '\p{Is_Nv=1.00e-01}', "");
    Expect(0, 73675, '\p{^Is_Nv=1.00e-01}', "");
    Expect(0, 73675, '\P{Is_Nv=1.00e-01}', "");
    Expect(1, 73675, '\P{^Is_Nv=1.00e-01}', "");
    Expect(0, 73676, '\p{Is_Nv=1.00e-01}', "");
    Expect(1, 73676, '\p{^Is_Nv=1.00e-01}', "");
    Expect(1, 73676, '\P{Is_Nv=1.00e-01}', "");
    Expect(0, 73676, '\P{^Is_Nv=1.00e-01}', "");
    Expect(1, 73675, '\p{Is_Nv=0.10}', "");
    Expect(0, 73675, '\p{^Is_Nv=0.10}', "");
    Expect(0, 73675, '\P{Is_Nv=0.10}', "");
    Expect(1, 73675, '\P{^Is_Nv=0.10}', "");
    Expect(0, 73676, '\p{Is_Nv=0.10}', "");
    Expect(1, 73676, '\p{^Is_Nv=0.10}', "");
    Expect(1, 73676, '\P{Is_Nv=0.10}', "");
    Expect(0, 73676, '\P{^Is_Nv=0.10}', "");
    Error('\p{Numeric_Value=/a/00001/0000012}');
    Error('\P{Numeric_Value=/a/00001/0000012}');
    Expect(1, 68086, '\p{Numeric_Value=:\A1/12\z:}', "");;
    Expect(0, 68087, '\p{Numeric_Value=:\A1/12\z:}', "");;
    Expect(1, 68086, '\p{Numeric_Value=000000001/000012}', "");
    Expect(0, 68086, '\p{^Numeric_Value=000000001/000012}', "");
    Expect(0, 68086, '\P{Numeric_Value=000000001/000012}', "");
    Expect(1, 68086, '\P{^Numeric_Value=000000001/000012}', "");
    Expect(0, 68087, '\p{Numeric_Value=000000001/000012}', "");
    Expect(1, 68087, '\p{^Numeric_Value=000000001/000012}', "");
    Expect(1, 68087, '\P{Numeric_Value=000000001/000012}', "");
    Expect(0, 68087, '\P{^Numeric_Value=000000001/000012}', "");
    Expect(1, 68086, '\p{Numeric_Value=60/720}', "");
    Expect(0, 68086, '\p{^Numeric_Value=60/720}', "");
    Expect(0, 68086, '\P{Numeric_Value=60/720}', "");
    Expect(1, 68086, '\P{^Numeric_Value=60/720}', "");
    Expect(0, 68087, '\p{Numeric_Value=60/720}', "");
    Expect(1, 68087, '\p{^Numeric_Value=60/720}', "");
    Expect(1, 68087, '\P{Numeric_Value=60/720}', "");
    Expect(0, 68087, '\P{^Numeric_Value=60/720}', "");
    Error('\p{Numeric_Value=8.3e-02}');
    Error('\P{Numeric_Value=8.3e-02}');
    Error('\p{Numeric_Value=8.33e-02}');
    Error('\P{Numeric_Value=8.33e-02}');
    Error('\p{Numeric_Value=0.08}');
    Error('\P{Numeric_Value=0.08}');
    Expect(1, 68086, '\p{Numeric_Value=8.333e-02}', "");
    Expect(0, 68086, '\p{^Numeric_Value=8.333e-02}', "");
    Expect(0, 68086, '\P{Numeric_Value=8.333e-02}', "");
    Expect(1, 68086, '\P{^Numeric_Value=8.333e-02}', "");
    Expect(0, 68087, '\p{Numeric_Value=8.333e-02}', "");
    Expect(1, 68087, '\p{^Numeric_Value=8.333e-02}', "");
    Expect(1, 68087, '\P{Numeric_Value=8.333e-02}', "");
    Expect(0, 68087, '\P{^Numeric_Value=8.333e-02}', "");
    Error('\p{Numeric_Value=0.083}');
    Error('\P{Numeric_Value=0.083}');
    Expect(1, 68086, '\p{Numeric_Value=8.3333e-02}', "");
    Expect(0, 68086, '\p{^Numeric_Value=8.3333e-02}', "");
    Expect(0, 68086, '\P{Numeric_Value=8.3333e-02}', "");
    Expect(1, 68086, '\P{^Numeric_Value=8.3333e-02}', "");
    Expect(0, 68087, '\p{Numeric_Value=8.3333e-02}', "");
    Expect(1, 68087, '\p{^Numeric_Value=8.3333e-02}', "");
    Expect(1, 68087, '\P{Numeric_Value=8.3333e-02}', "");
    Expect(0, 68087, '\P{^Numeric_Value=8.3333e-02}', "");
    Error('\p{Numeric_Value=0.0833}');
    Error('\P{Numeric_Value=0.0833}');
    Expect(1, 68086, '\p{Numeric_Value=8.33333e-02}', "");
    Expect(0, 68086, '\p{^Numeric_Value=8.33333e-02}', "");
    Expect(0, 68086, '\P{Numeric_Value=8.33333e-02}', "");
    Expect(1, 68086, '\P{^Numeric_Value=8.33333e-02}', "");
    Expect(0, 68087, '\p{Numeric_Value=8.33333e-02}', "");
    Expect(1, 68087, '\p{^Numeric_Value=8.33333e-02}', "");
    Expect(1, 68087, '\P{Numeric_Value=8.33333e-02}', "");
    Expect(0, 68087, '\P{^Numeric_Value=8.33333e-02}', "");
    Expect(1, 68086, '\p{Numeric_Value=0.08333}', "");
    Expect(0, 68086, '\p{^Numeric_Value=0.08333}', "");
    Expect(0, 68086, '\P{Numeric_Value=0.08333}', "");
    Expect(1, 68086, '\P{^Numeric_Value=0.08333}', "");
    Expect(0, 68087, '\p{Numeric_Value=0.08333}', "");
    Expect(1, 68087, '\p{^Numeric_Value=0.08333}', "");
    Expect(1, 68087, '\P{Numeric_Value=0.08333}', "");
    Expect(0, 68087, '\P{^Numeric_Value=0.08333}', "");
    Expect(1, 68086, '\p{Numeric_Value=8.333333e-02}', "");
    Expect(0, 68086, '\p{^Numeric_Value=8.333333e-02}', "");
    Expect(0, 68086, '\P{Numeric_Value=8.333333e-02}', "");
    Expect(1, 68086, '\P{^Numeric_Value=8.333333e-02}', "");
    Expect(0, 68087, '\p{Numeric_Value=8.333333e-02}', "");
    Expect(1, 68087, '\p{^Numeric_Value=8.333333e-02}', "");
    Expect(1, 68087, '\P{Numeric_Value=8.333333e-02}', "");
    Expect(0, 68087, '\P{^Numeric_Value=8.333333e-02}', "");
    Expect(1, 68086, '\p{Numeric_Value=0.083333}', "");
    Expect(0, 68086, '\p{^Numeric_Value=0.083333}', "");
    Expect(0, 68086, '\P{Numeric_Value=0.083333}', "");
    Expect(1, 68086, '\P{^Numeric_Value=0.083333}', "");
    Expect(0, 68087, '\p{Numeric_Value=0.083333}', "");
    Expect(1, 68087, '\p{^Numeric_Value=0.083333}', "");
    Expect(1, 68087, '\P{Numeric_Value=0.083333}', "");
    Expect(0, 68087, '\P{^Numeric_Value=0.083333}', "");
    Error('\p{Nv=/a/_01/0012}');
    Error('\P{Nv=/a/_01/0012}');
    Expect(1, 68086, '\p{Nv=:\A1/12\z:}', "");;
    Expect(0, 68087, '\p{Nv=:\A1/12\z:}', "");;
    Expect(1, 68086, '\p{Nv=+01/00012}', "");
    Expect(0, 68086, '\p{^Nv=+01/00012}', "");
    Expect(0, 68086, '\P{Nv=+01/00012}', "");
    Expect(1, 68086, '\P{^Nv=+01/00012}', "");
    Expect(0, 68087, '\p{Nv=+01/00012}', "");
    Expect(1, 68087, '\p{^Nv=+01/00012}', "");
    Expect(1, 68087, '\P{Nv=+01/00012}', "");
    Expect(0, 68087, '\P{^Nv=+01/00012}', "");
    Expect(1, 68086, '\p{Nv=60/720}', "");
    Expect(0, 68086, '\p{^Nv=60/720}', "");
    Expect(0, 68086, '\P{Nv=60/720}', "");
    Expect(1, 68086, '\P{^Nv=60/720}', "");
    Expect(0, 68087, '\p{Nv=60/720}', "");
    Expect(1, 68087, '\p{^Nv=60/720}', "");
    Expect(1, 68087, '\P{Nv=60/720}', "");
    Expect(0, 68087, '\P{^Nv=60/720}', "");
    Error('\p{Nv=8.3e-02}');
    Error('\P{Nv=8.3e-02}');
    Error('\p{Nv=8.33e-02}');
    Error('\P{Nv=8.33e-02}');
    Error('\p{Nv=0.08}');
    Error('\P{Nv=0.08}');
    Expect(1, 68086, '\p{Nv=8.333e-02}', "");
    Expect(0, 68086, '\p{^Nv=8.333e-02}', "");
    Expect(0, 68086, '\P{Nv=8.333e-02}', "");
    Expect(1, 68086, '\P{^Nv=8.333e-02}', "");
    Expect(0, 68087, '\p{Nv=8.333e-02}', "");
    Expect(1, 68087, '\p{^Nv=8.333e-02}', "");
    Expect(1, 68087, '\P{Nv=8.333e-02}', "");
    Expect(0, 68087, '\P{^Nv=8.333e-02}', "");
    Error('\p{Nv=0.083}');
    Error('\P{Nv=0.083}');
    Expect(1, 68086, '\p{Nv=8.3333e-02}', "");
    Expect(0, 68086, '\p{^Nv=8.3333e-02}', "");
    Expect(0, 68086, '\P{Nv=8.3333e-02}', "");
    Expect(1, 68086, '\P{^Nv=8.3333e-02}', "");
    Expect(0, 68087, '\p{Nv=8.3333e-02}', "");
    Expect(1, 68087, '\p{^Nv=8.3333e-02}', "");
    Expect(1, 68087, '\P{Nv=8.3333e-02}', "");
    Expect(0, 68087, '\P{^Nv=8.3333e-02}', "");
    Error('\p{Nv:0.0833}');
    Error('\P{Nv:0.0833}');
    Expect(1, 68086, '\p{Nv=8.33333e-02}', "");
    Expect(0, 68086, '\p{^Nv=8.33333e-02}', "");
    Expect(0, 68086, '\P{Nv=8.33333e-02}', "");
    Expect(1, 68086, '\P{^Nv=8.33333e-02}', "");
    Expect(0, 68087, '\p{Nv=8.33333e-02}', "");
    Expect(1, 68087, '\p{^Nv=8.33333e-02}', "");
    Expect(1, 68087, '\P{Nv=8.33333e-02}', "");
    Expect(0, 68087, '\P{^Nv=8.33333e-02}', "");
    Expect(1, 68086, '\p{Nv=0.08333}', "");
    Expect(0, 68086, '\p{^Nv=0.08333}', "");
    Expect(0, 68086, '\P{Nv=0.08333}', "");
    Expect(1, 68086, '\P{^Nv=0.08333}', "");
    Expect(0, 68087, '\p{Nv=0.08333}', "");
    Expect(1, 68087, '\p{^Nv=0.08333}', "");
    Expect(1, 68087, '\P{Nv=0.08333}', "");
    Expect(0, 68087, '\P{^Nv=0.08333}', "");
    Expect(1, 68086, '\p{Nv=8.333333e-02}', "");
    Expect(0, 68086, '\p{^Nv=8.333333e-02}', "");
    Expect(0, 68086, '\P{Nv=8.333333e-02}', "");
    Expect(1, 68086, '\P{^Nv=8.333333e-02}', "");
    Expect(0, 68087, '\p{Nv=8.333333e-02}', "");
    Expect(1, 68087, '\p{^Nv=8.333333e-02}', "");
    Expect(1, 68087, '\P{Nv=8.333333e-02}', "");
    Expect(0, 68087, '\P{^Nv=8.333333e-02}', "");
    Expect(1, 68086, '\p{Nv=0.083333}', "");
    Expect(0, 68086, '\p{^Nv=0.083333}', "");
    Expect(0, 68086, '\P{Nv=0.083333}', "");
    Expect(1, 68086, '\P{^Nv=0.083333}', "");
    Expect(0, 68087, '\p{Nv=0.083333}', "");
    Expect(1, 68087, '\p{^Nv=0.083333}', "");
    Expect(1, 68087, '\P{Nv=0.083333}', "");
    Expect(0, 68087, '\P{^Nv=0.083333}', "");
    Error('\p{Is_Numeric_Value:_ 01/00000000012/a/}');
    Error('\P{Is_Numeric_Value:_ 01/00000000012/a/}');
    Expect(1, 68086, '\p{Is_Numeric_Value=0000001/12}', "");
    Expect(0, 68086, '\p{^Is_Numeric_Value=0000001/12}', "");
    Expect(0, 68086, '\P{Is_Numeric_Value=0000001/12}', "");
    Expect(1, 68086, '\P{^Is_Numeric_Value=0000001/12}', "");
    Expect(0, 68087, '\p{Is_Numeric_Value=0000001/12}', "");
    Expect(1, 68087, '\p{^Is_Numeric_Value=0000001/12}', "");
    Expect(1, 68087, '\P{Is_Numeric_Value=0000001/12}', "");
    Expect(0, 68087, '\P{^Is_Numeric_Value=0000001/12}', "");
    Expect(1, 68086, '\p{Is_Numeric_Value=60/720}', "");
    Expect(0, 68086, '\p{^Is_Numeric_Value=60/720}', "");
    Expect(0, 68086, '\P{Is_Numeric_Value=60/720}', "");
    Expect(1, 68086, '\P{^Is_Numeric_Value=60/720}', "");
    Expect(0, 68087, '\p{Is_Numeric_Value=60/720}', "");
    Expect(1, 68087, '\p{^Is_Numeric_Value=60/720}', "");
    Expect(1, 68087, '\P{Is_Numeric_Value=60/720}', "");
    Expect(0, 68087, '\P{^Is_Numeric_Value=60/720}', "");
    Error('\p{Is_Numeric_Value=8.3e-02}');
    Error('\P{Is_Numeric_Value=8.3e-02}');
    Error('\p{Is_Numeric_Value=8.33e-02}');
    Error('\P{Is_Numeric_Value=8.33e-02}');
    Error('\p{Is_Numeric_Value=0.08}');
    Error('\P{Is_Numeric_Value=0.08}');
    Expect(1, 68086, '\p{Is_Numeric_Value=8.333e-02}', "");
    Expect(0, 68086, '\p{^Is_Numeric_Value=8.333e-02}', "");
    Expect(0, 68086, '\P{Is_Numeric_Value=8.333e-02}', "");
    Expect(1, 68086, '\P{^Is_Numeric_Value=8.333e-02}', "");
    Expect(0, 68087, '\p{Is_Numeric_Value=8.333e-02}', "");
    Expect(1, 68087, '\p{^Is_Numeric_Value=8.333e-02}', "");
    Expect(1, 68087, '\P{Is_Numeric_Value=8.333e-02}', "");
    Expect(0, 68087, '\P{^Is_Numeric_Value=8.333e-02}', "");
    Error('\p{Is_Numeric_Value=0.083}');
    Error('\P{Is_Numeric_Value=0.083}');
    Expect(1, 68086, '\p{Is_Numeric_Value=8.3333e-02}', "");
    Expect(0, 68086, '\p{^Is_Numeric_Value=8.3333e-02}', "");
    Expect(0, 68086, '\P{Is_Numeric_Value=8.3333e-02}', "");
    Expect(1, 68086, '\P{^Is_Numeric_Value=8.3333e-02}', "");
    Expect(0, 68087, '\p{Is_Numeric_Value=8.3333e-02}', "");
    Expect(1, 68087, '\p{^Is_Numeric_Value=8.3333e-02}', "");
    Expect(1, 68087, '\P{Is_Numeric_Value=8.3333e-02}', "");
    Expect(0, 68087, '\P{^Is_Numeric_Value=8.3333e-02}', "");
    Error('\p{Is_Numeric_Value=0.0833}');
    Error('\P{Is_Numeric_Value=0.0833}');
    Expect(1, 68086, '\p{Is_Numeric_Value=8.33333e-02}', "");
    Expect(0, 68086, '\p{^Is_Numeric_Value=8.33333e-02}', "");
    Expect(0, 68086, '\P{Is_Numeric_Value=8.33333e-02}', "");
    Expect(1, 68086, '\P{^Is_Numeric_Value=8.33333e-02}', "");
    Expect(0, 68087, '\p{Is_Numeric_Value=8.33333e-02}', "");
    Expect(1, 68087, '\p{^Is_Numeric_Value=8.33333e-02}', "");
    Expect(1, 68087, '\P{Is_Numeric_Value=8.33333e-02}', "");
    Expect(0, 68087, '\P{^Is_Numeric_Value=8.33333e-02}', "");
    Expect(1, 68086, '\p{Is_Numeric_Value=0.08333}', "");
    Expect(0, 68086, '\p{^Is_Numeric_Value=0.08333}', "");
    Expect(0, 68086, '\P{Is_Numeric_Value=0.08333}', "");
    Expect(1, 68086, '\P{^Is_Numeric_Value=0.08333}', "");
    Expect(0, 68087, '\p{Is_Numeric_Value=0.08333}', "");
    Expect(1, 68087, '\p{^Is_Numeric_Value=0.08333}', "");
    Expect(1, 68087, '\P{Is_Numeric_Value=0.08333}', "");
    Expect(0, 68087, '\P{^Is_Numeric_Value=0.08333}', "");
    Expect(1, 68086, '\p{Is_Numeric_Value=8.333333e-02}', "");
    Expect(0, 68086, '\p{^Is_Numeric_Value=8.333333e-02}', "");
    Expect(0, 68086, '\P{Is_Numeric_Value=8.333333e-02}', "");
    Expect(1, 68086, '\P{^Is_Numeric_Value=8.333333e-02}', "");
    Expect(0, 68087, '\p{Is_Numeric_Value=8.333333e-02}', "");
    Expect(1, 68087, '\p{^Is_Numeric_Value=8.333333e-02}', "");
    Expect(1, 68087, '\P{Is_Numeric_Value=8.333333e-02}', "");
    Expect(0, 68087, '\P{^Is_Numeric_Value=8.333333e-02}', "");
    Expect(1, 68086, '\p{Is_Numeric_Value=0.083333}', "");
    Expect(0, 68086, '\p{^Is_Numeric_Value=0.083333}', "");
    Expect(0, 68086, '\P{Is_Numeric_Value=0.083333}', "");
    Expect(1, 68086, '\P{^Is_Numeric_Value=0.083333}', "");
    Expect(0, 68087, '\p{Is_Numeric_Value=0.083333}', "");
    Expect(1, 68087, '\p{^Is_Numeric_Value=0.083333}', "");
    Expect(1, 68087, '\P{Is_Numeric_Value=0.083333}', "");
    Expect(0, 68087, '\P{^Is_Numeric_Value=0.083333}', "");
    Error('\p{Is_Nv= :=0000001/0000000012}');
    Error('\P{Is_Nv= :=0000001/0000000012}');
    Expect(1, 68086, '\p{Is_Nv=0000001/000000012}', "");
    Expect(0, 68086, '\p{^Is_Nv=0000001/000000012}', "");
    Expect(0, 68086, '\P{Is_Nv=0000001/000000012}', "");
    Expect(1, 68086, '\P{^Is_Nv=0000001/000000012}', "");
    Expect(0, 68087, '\p{Is_Nv=0000001/000000012}', "");
    Expect(1, 68087, '\p{^Is_Nv=0000001/000000012}', "");
    Expect(1, 68087, '\P{Is_Nv=0000001/000000012}', "");
    Expect(0, 68087, '\P{^Is_Nv=0000001/000000012}', "");
    Expect(1, 68086, '\p{Is_Nv=60/720}', "");
    Expect(0, 68086, '\p{^Is_Nv=60/720}', "");
    Expect(0, 68086, '\P{Is_Nv=60/720}', "");
    Expect(1, 68086, '\P{^Is_Nv=60/720}', "");
    Expect(0, 68087, '\p{Is_Nv=60/720}', "");
    Expect(1, 68087, '\p{^Is_Nv=60/720}', "");
    Expect(1, 68087, '\P{Is_Nv=60/720}', "");
    Expect(0, 68087, '\P{^Is_Nv=60/720}', "");
    Error('\p{Is_Nv=8.3e-02}');
    Error('\P{Is_Nv=8.3e-02}');
    Error('\p{Is_Nv=8.33e-02}');
    Error('\P{Is_Nv=8.33e-02}');
    Error('\p{Is_Nv=0.08}');
    Error('\P{Is_Nv=0.08}');
    Expect(1, 68086, '\p{Is_Nv=8.333e-02}', "");
    Expect(0, 68086, '\p{^Is_Nv=8.333e-02}', "");
    Expect(0, 68086, '\P{Is_Nv=8.333e-02}', "");
    Expect(1, 68086, '\P{^Is_Nv=8.333e-02}', "");
    Expect(0, 68087, '\p{Is_Nv=8.333e-02}', "");
    Expect(1, 68087, '\p{^Is_Nv=8.333e-02}', "");
    Expect(1, 68087, '\P{Is_Nv=8.333e-02}', "");
    Expect(0, 68087, '\P{^Is_Nv=8.333e-02}', "");
    Error('\p{Is_Nv=0.083}');
    Error('\P{Is_Nv=0.083}');
    Expect(1, 68086, '\p{Is_Nv=8.3333e-02}', "");
    Expect(0, 68086, '\p{^Is_Nv=8.3333e-02}', "");
    Expect(0, 68086, '\P{Is_Nv=8.3333e-02}', "");
    Expect(1, 68086, '\P{^Is_Nv=8.3333e-02}', "");
    Expect(0, 68087, '\p{Is_Nv=8.3333e-02}', "");
    Expect(1, 68087, '\p{^Is_Nv=8.3333e-02}', "");
    Expect(1, 68087, '\P{Is_Nv=8.3333e-02}', "");
    Expect(0, 68087, '\P{^Is_Nv=8.3333e-02}', "");
    Error('\p{Is_Nv:0.0833}');
    Error('\P{Is_Nv:0.0833}');
    Expect(1, 68086, '\p{Is_Nv=8.33333e-02}', "");
    Expect(0, 68086, '\p{^Is_Nv=8.33333e-02}', "");
    Expect(0, 68086, '\P{Is_Nv=8.33333e-02}', "");
    Expect(1, 68086, '\P{^Is_Nv=8.33333e-02}', "");
    Expect(0, 68087, '\p{Is_Nv=8.33333e-02}', "");
    Expect(1, 68087, '\p{^Is_Nv=8.33333e-02}', "");
    Expect(1, 68087, '\P{Is_Nv=8.33333e-02}', "");
    Expect(0, 68087, '\P{^Is_Nv=8.33333e-02}', "");
    Expect(1, 68086, '\p{Is_Nv=0.08333}', "");
    Expect(0, 68086, '\p{^Is_Nv=0.08333}', "");
    Expect(0, 68086, '\P{Is_Nv=0.08333}', "");
    Expect(1, 68086, '\P{^Is_Nv=0.08333}', "");
    Expect(0, 68087, '\p{Is_Nv=0.08333}', "");
    Expect(1, 68087, '\p{^Is_Nv=0.08333}', "");
    Expect(1, 68087, '\P{Is_Nv=0.08333}', "");
    Expect(0, 68087, '\P{^Is_Nv=0.08333}', "");
    Expect(1, 68086, '\p{Is_Nv=8.333333e-02}', "");
    Expect(0, 68086, '\p{^Is_Nv=8.333333e-02}', "");
    Expect(0, 68086, '\P{Is_Nv=8.333333e-02}', "");
    Expect(1, 68086, '\P{^Is_Nv=8.333333e-02}', "");
    Expect(0, 68087, '\p{Is_Nv=8.333333e-02}', "");
    Expect(1, 68087, '\p{^Is_Nv=8.333333e-02}', "");
    Expect(1, 68087, '\P{Is_Nv=8.333333e-02}', "");
    Expect(0, 68087, '\P{^Is_Nv=8.333333e-02}', "");
    Expect(1, 68086, '\p{Is_Nv=0.083333}', "");
    Expect(0, 68086, '\p{^Is_Nv=0.083333}', "");
    Expect(0, 68086, '\P{Is_Nv=0.083333}', "");
    Expect(1, 68086, '\P{^Is_Nv=0.083333}', "");
    Expect(0, 68087, '\p{Is_Nv=0.083333}', "");
    Expect(1, 68087, '\p{^Is_Nv=0.083333}', "");
    Expect(1, 68087, '\P{Is_Nv=0.083333}', "");
    Expect(0, 68087, '\P{^Is_Nv=0.083333}', "");
    Error('\p{Numeric_Value: 	+001/0016/a/}');
    Error('\P{Numeric_Value: 	+001/0016/a/}');
    Expect(1, 73674, '\p{Numeric_Value=:\A1/16\z:}', "");;
    Expect(0, 73675, '\p{Numeric_Value=:\A1/16\z:}', "");;
    Expect(1, 73674, '\p{Numeric_Value=0000000001/16}', "");
    Expect(0, 73674, '\p{^Numeric_Value=0000000001/16}', "");
    Expect(0, 73674, '\P{Numeric_Value=0000000001/16}', "");
    Expect(1, 73674, '\P{^Numeric_Value=0000000001/16}', "");
    Expect(0, 73675, '\p{Numeric_Value=0000000001/16}', "");
    Expect(1, 73675, '\p{^Numeric_Value=0000000001/16}', "");
    Expect(1, 73675, '\P{Numeric_Value=0000000001/16}', "");
    Expect(0, 73675, '\P{^Numeric_Value=0000000001/16}', "");
    Expect(1, 73674, '\p{Numeric_Value=60/960}', "");
    Expect(0, 73674, '\p{^Numeric_Value=60/960}', "");
    Expect(0, 73674, '\P{Numeric_Value=60/960}', "");
    Expect(1, 73674, '\P{^Numeric_Value=60/960}', "");
    Expect(0, 73675, '\p{Numeric_Value=60/960}', "");
    Expect(1, 73675, '\p{^Numeric_Value=60/960}', "");
    Expect(1, 73675, '\P{Numeric_Value=60/960}', "");
    Expect(0, 73675, '\P{^Numeric_Value=60/960}', "");
    Error('\p{Numeric_Value=6.2e-02}');
    Error('\P{Numeric_Value=6.2e-02}');
    Expect(1, 73674, '\p{Numeric_Value=6.25e-02}', "");
    Expect(0, 73674, '\p{^Numeric_Value=6.25e-02}', "");
    Expect(0, 73674, '\P{Numeric_Value=6.25e-02}', "");
    Expect(1, 73674, '\P{^Numeric_Value=6.25e-02}', "");
    Expect(0, 73675, '\p{Numeric_Value=6.25e-02}', "");
    Expect(1, 73675, '\p{^Numeric_Value=6.25e-02}', "");
    Expect(1, 73675, '\P{Numeric_Value=6.25e-02}', "");
    Expect(0, 73675, '\P{^Numeric_Value=6.25e-02}', "");
    Error('\p{Numeric_Value=0.06}');
    Error('\P{Numeric_Value=0.06}');
    Expect(1, 73674, '\p{Numeric_Value=6.250e-02}', "");
    Expect(0, 73674, '\p{^Numeric_Value=6.250e-02}', "");
    Expect(0, 73674, '\P{Numeric_Value=6.250e-02}', "");
    Expect(1, 73674, '\P{^Numeric_Value=6.250e-02}', "");
    Expect(0, 73675, '\p{Numeric_Value=6.250e-02}', "");
    Expect(1, 73675, '\p{^Numeric_Value=6.250e-02}', "");
    Expect(1, 73675, '\P{Numeric_Value=6.250e-02}', "");
    Expect(0, 73675, '\P{^Numeric_Value=6.250e-02}', "");
    Error('\p{Numeric_Value=0.062}');
    Error('\P{Numeric_Value=0.062}');
    Expect(1, 73674, '\p{Numeric_Value=6.2500e-02}', "");
    Expect(0, 73674, '\p{^Numeric_Value=6.2500e-02}', "");
    Expect(0, 73674, '\P{Numeric_Value=6.2500e-02}', "");
    Expect(1, 73674, '\P{^Numeric_Value=6.2500e-02}', "");
    Expect(0, 73675, '\p{Numeric_Value=6.2500e-02}', "");
    Expect(1, 73675, '\p{^Numeric_Value=6.2500e-02}', "");
    Expect(1, 73675, '\P{Numeric_Value=6.2500e-02}', "");
    Expect(0, 73675, '\P{^Numeric_Value=6.2500e-02}', "");
    Expect(1, 73674, '\p{Numeric_Value=0.0625}', "");
    Expect(0, 73674, '\p{^Numeric_Value=0.0625}', "");
    Expect(0, 73674, '\P{Numeric_Value=0.0625}', "");
    Expect(1, 73674, '\P{^Numeric_Value=0.0625}', "");
    Expect(0, 73675, '\p{Numeric_Value=0.0625}', "");
    Expect(1, 73675, '\p{^Numeric_Value=0.0625}', "");
    Expect(1, 73675, '\P{Numeric_Value=0.0625}', "");
    Expect(0, 73675, '\P{^Numeric_Value=0.0625}', "");
    Expect(1, 73674, '\p{Numeric_Value:	6.25000e-02}', "");
    Expect(0, 73674, '\p{^Numeric_Value:	6.25000e-02}', "");
    Expect(0, 73674, '\P{Numeric_Value:	6.25000e-02}', "");
    Expect(1, 73674, '\P{^Numeric_Value:	6.25000e-02}', "");
    Expect(0, 73675, '\p{Numeric_Value:	6.25000e-02}', "");
    Expect(1, 73675, '\p{^Numeric_Value:	6.25000e-02}', "");
    Expect(1, 73675, '\P{Numeric_Value:	6.25000e-02}', "");
    Expect(0, 73675, '\P{^Numeric_Value:	6.25000e-02}', "");
    Expect(1, 73674, '\p{Numeric_Value=0.06250}', "");
    Expect(0, 73674, '\p{^Numeric_Value=0.06250}', "");
    Expect(0, 73674, '\P{Numeric_Value=0.06250}', "");
    Expect(1, 73674, '\P{^Numeric_Value=0.06250}', "");
    Expect(0, 73675, '\p{Numeric_Value=0.06250}', "");
    Expect(1, 73675, '\p{^Numeric_Value=0.06250}', "");
    Expect(1, 73675, '\P{Numeric_Value=0.06250}', "");
    Expect(0, 73675, '\P{^Numeric_Value=0.06250}', "");
    Error('\p{Nv=:=00000001/016}');
    Error('\P{Nv=:=00000001/016}');
    Expect(1, 73674, '\p{Nv=:\A1/16\z:}', "");;
    Expect(0, 73675, '\p{Nv=:\A1/16\z:}', "");;
    Expect(1, 73674, '\p{Nv=01/16}', "");
    Expect(0, 73674, '\p{^Nv=01/16}', "");
    Expect(0, 73674, '\P{Nv=01/16}', "");
    Expect(1, 73674, '\P{^Nv=01/16}', "");
    Expect(0, 73675, '\p{Nv=01/16}', "");
    Expect(1, 73675, '\p{^Nv=01/16}', "");
    Expect(1, 73675, '\P{Nv=01/16}', "");
    Expect(0, 73675, '\P{^Nv=01/16}', "");
    Expect(1, 73674, '\p{Nv=60/960}', "");
    Expect(0, 73674, '\p{^Nv=60/960}', "");
    Expect(0, 73674, '\P{Nv=60/960}', "");
    Expect(1, 73674, '\P{^Nv=60/960}', "");
    Expect(0, 73675, '\p{Nv=60/960}', "");
    Expect(1, 73675, '\p{^Nv=60/960}', "");
    Expect(1, 73675, '\P{Nv=60/960}', "");
    Expect(0, 73675, '\P{^Nv=60/960}', "");
    Error('\p{Nv=6.2e-02}');
    Error('\P{Nv=6.2e-02}');
    Expect(1, 73674, '\p{Nv=6.25e-02}', "");
    Expect(0, 73674, '\p{^Nv=6.25e-02}', "");
    Expect(0, 73674, '\P{Nv=6.25e-02}', "");
    Expect(1, 73674, '\P{^Nv=6.25e-02}', "");
    Expect(0, 73675, '\p{Nv=6.25e-02}', "");
    Expect(1, 73675, '\p{^Nv=6.25e-02}', "");
    Expect(1, 73675, '\P{Nv=6.25e-02}', "");
    Expect(0, 73675, '\P{^Nv=6.25e-02}', "");
    Error('\p{Nv=0.06}');
    Error('\P{Nv=0.06}');
    Expect(1, 73674, '\p{Nv=6.250e-02}', "");
    Expect(0, 73674, '\p{^Nv=6.250e-02}', "");
    Expect(0, 73674, '\P{Nv=6.250e-02}', "");
    Expect(1, 73674, '\P{^Nv=6.250e-02}', "");
    Expect(0, 73675, '\p{Nv=6.250e-02}', "");
    Expect(1, 73675, '\p{^Nv=6.250e-02}', "");
    Expect(1, 73675, '\P{Nv=6.250e-02}', "");
    Expect(0, 73675, '\P{^Nv=6.250e-02}', "");
    Error('\p{Nv=0.062}');
    Error('\P{Nv=0.062}');
    Expect(1, 73674, '\p{Nv=6.2500e-02}', "");
    Expect(0, 73674, '\p{^Nv=6.2500e-02}', "");
    Expect(0, 73674, '\P{Nv=6.2500e-02}', "");
    Expect(1, 73674, '\P{^Nv=6.2500e-02}', "");
    Expect(0, 73675, '\p{Nv=6.2500e-02}', "");
    Expect(1, 73675, '\p{^Nv=6.2500e-02}', "");
    Expect(1, 73675, '\P{Nv=6.2500e-02}', "");
    Expect(0, 73675, '\P{^Nv=6.2500e-02}', "");
    Expect(1, 73674, '\p{Nv=0.0625}', "");
    Expect(0, 73674, '\p{^Nv=0.0625}', "");
    Expect(0, 73674, '\P{Nv=0.0625}', "");
    Expect(1, 73674, '\P{^Nv=0.0625}', "");
    Expect(0, 73675, '\p{Nv=0.0625}', "");
    Expect(1, 73675, '\p{^Nv=0.0625}', "");
    Expect(1, 73675, '\P{Nv=0.0625}', "");
    Expect(0, 73675, '\P{^Nv=0.0625}', "");
    Expect(1, 73674, '\p{Nv=6.25000e-02}', "");
    Expect(0, 73674, '\p{^Nv=6.25000e-02}', "");
    Expect(0, 73674, '\P{Nv=6.25000e-02}', "");
    Expect(1, 73674, '\P{^Nv=6.25000e-02}', "");
    Expect(0, 73675, '\p{Nv=6.25000e-02}', "");
    Expect(1, 73675, '\p{^Nv=6.25000e-02}', "");
    Expect(1, 73675, '\P{Nv=6.25000e-02}', "");
    Expect(0, 73675, '\P{^Nv=6.25000e-02}', "");
    Expect(1, 73674, '\p{Nv=0.06250}', "");
    Expect(0, 73674, '\p{^Nv=0.06250}', "");
    Expect(0, 73674, '\P{Nv=0.06250}', "");
    Expect(1, 73674, '\P{^Nv=0.06250}', "");
    Expect(0, 73675, '\p{Nv=0.06250}', "");
    Expect(1, 73675, '\p{^Nv=0.06250}', "");
    Expect(1, 73675, '\P{Nv=0.06250}', "");
    Expect(0, 73675, '\P{^Nv=0.06250}', "");
    Error('\p{Is_Numeric_Value=-:=+0000001/0000016}');
    Error('\P{Is_Numeric_Value=-:=+0000001/0000016}');
    Expect(1, 73674, '\p{Is_Numeric_Value=00001/0000016}', "");
    Expect(0, 73674, '\p{^Is_Numeric_Value=00001/0000016}', "");
    Expect(0, 73674, '\P{Is_Numeric_Value=00001/0000016}', "");
    Expect(1, 73674, '\P{^Is_Numeric_Value=00001/0000016}', "");
    Expect(0, 73675, '\p{Is_Numeric_Value=00001/0000016}', "");
    Expect(1, 73675, '\p{^Is_Numeric_Value=00001/0000016}', "");
    Expect(1, 73675, '\P{Is_Numeric_Value=00001/0000016}', "");
    Expect(0, 73675, '\P{^Is_Numeric_Value=00001/0000016}', "");
    Expect(1, 73674, '\p{Is_Numeric_Value=60/960}', "");
    Expect(0, 73674, '\p{^Is_Numeric_Value=60/960}', "");
    Expect(0, 73674, '\P{Is_Numeric_Value=60/960}', "");
    Expect(1, 73674, '\P{^Is_Numeric_Value=60/960}', "");
    Expect(0, 73675, '\p{Is_Numeric_Value=60/960}', "");
    Expect(1, 73675, '\p{^Is_Numeric_Value=60/960}', "");
    Expect(1, 73675, '\P{Is_Numeric_Value=60/960}', "");
    Expect(0, 73675, '\P{^Is_Numeric_Value=60/960}', "");
    Error('\p{Is_Numeric_Value=6.2e-02}');
    Error('\P{Is_Numeric_Value=6.2e-02}');
    Expect(1, 73674, '\p{Is_Numeric_Value: 6.25e-02}', "");
    Expect(0, 73674, '\p{^Is_Numeric_Value: 6.25e-02}', "");
    Expect(0, 73674, '\P{Is_Numeric_Value: 6.25e-02}', "");
    Expect(1, 73674, '\P{^Is_Numeric_Value: 6.25e-02}', "");
    Expect(0, 73675, '\p{Is_Numeric_Value: 6.25e-02}', "");
    Expect(1, 73675, '\p{^Is_Numeric_Value: 6.25e-02}', "");
    Expect(1, 73675, '\P{Is_Numeric_Value: 6.25e-02}', "");
    Expect(0, 73675, '\P{^Is_Numeric_Value: 6.25e-02}', "");
    Error('\p{Is_Numeric_Value=0.06}');
    Error('\P{Is_Numeric_Value=0.06}');
    Expect(1, 73674, '\p{Is_Numeric_Value=6.250e-02}', "");
    Expect(0, 73674, '\p{^Is_Numeric_Value=6.250e-02}', "");
    Expect(0, 73674, '\P{Is_Numeric_Value=6.250e-02}', "");
    Expect(1, 73674, '\P{^Is_Numeric_Value=6.250e-02}', "");
    Expect(0, 73675, '\p{Is_Numeric_Value=6.250e-02}', "");
    Expect(1, 73675, '\p{^Is_Numeric_Value=6.250e-02}', "");
    Expect(1, 73675, '\P{Is_Numeric_Value=6.250e-02}', "");
    Expect(0, 73675, '\P{^Is_Numeric_Value=6.250e-02}', "");
    Error('\p{Is_Numeric_Value=0.062}');
    Error('\P{Is_Numeric_Value=0.062}');
    Expect(1, 73674, '\p{Is_Numeric_Value=6.2500e-02}', "");
    Expect(0, 73674, '\p{^Is_Numeric_Value=6.2500e-02}', "");
    Expect(0, 73674, '\P{Is_Numeric_Value=6.2500e-02}', "");
    Expect(1, 73674, '\P{^Is_Numeric_Value=6.2500e-02}', "");
    Expect(0, 73675, '\p{Is_Numeric_Value=6.2500e-02}', "");
    Expect(1, 73675, '\p{^Is_Numeric_Value=6.2500e-02}', "");
    Expect(1, 73675, '\P{Is_Numeric_Value=6.2500e-02}', "");
    Expect(0, 73675, '\P{^Is_Numeric_Value=6.2500e-02}', "");
    Expect(1, 73674, '\p{Is_Numeric_Value=0.0625}', "");
    Expect(0, 73674, '\p{^Is_Numeric_Value=0.0625}', "");
    Expect(0, 73674, '\P{Is_Numeric_Value=0.0625}', "");
    Expect(1, 73674, '\P{^Is_Numeric_Value=0.0625}', "");
    Expect(0, 73675, '\p{Is_Numeric_Value=0.0625}', "");
    Expect(1, 73675, '\p{^Is_Numeric_Value=0.0625}', "");
    Expect(1, 73675, '\P{Is_Numeric_Value=0.0625}', "");
    Expect(0, 73675, '\P{^Is_Numeric_Value=0.0625}', "");
    Expect(1, 73674, '\p{Is_Numeric_Value=6.25000e-02}', "");
    Expect(0, 73674, '\p{^Is_Numeric_Value=6.25000e-02}', "");
    Expect(0, 73674, '\P{Is_Numeric_Value=6.25000e-02}', "");
    Expect(1, 73674, '\P{^Is_Numeric_Value=6.25000e-02}', "");
    Expect(0, 73675, '\p{Is_Numeric_Value=6.25000e-02}', "");
    Expect(1, 73675, '\p{^Is_Numeric_Value=6.25000e-02}', "");
    Expect(1, 73675, '\P{Is_Numeric_Value=6.25000e-02}', "");
    Expect(0, 73675, '\P{^Is_Numeric_Value=6.25000e-02}', "");
    Expect(1, 73674, '\p{Is_Numeric_Value=0.06250}', "");
    Expect(0, 73674, '\p{^Is_Numeric_Value=0.06250}', "");
    Expect(0, 73674, '\P{Is_Numeric_Value=0.06250}', "");
    Expect(1, 73674, '\P{^Is_Numeric_Value=0.06250}', "");
    Expect(0, 73675, '\p{Is_Numeric_Value=0.06250}', "");
    Expect(1, 73675, '\p{^Is_Numeric_Value=0.06250}', "");
    Expect(1, 73675, '\P{Is_Numeric_Value=0.06250}', "");
    Expect(0, 73675, '\P{^Is_Numeric_Value=0.06250}', "");
    Error('\p{Is_Nv::= _00001/0000000016}');
    Error('\P{Is_Nv::= _00001/0000000016}');
    Expect(1, 73674, '\p{Is_Nv=00000001/16}', "");
    Expect(0, 73674, '\p{^Is_Nv=00000001/16}', "");
    Expect(0, 73674, '\P{Is_Nv=00000001/16}', "");
    Expect(1, 73674, '\P{^Is_Nv=00000001/16}', "");
    Expect(0, 73675, '\p{Is_Nv=00000001/16}', "");
    Expect(1, 73675, '\p{^Is_Nv=00000001/16}', "");
    Expect(1, 73675, '\P{Is_Nv=00000001/16}', "");
    Expect(0, 73675, '\P{^Is_Nv=00000001/16}', "");
    Expect(1, 73674, '\p{Is_Nv=60/960}', "");
    Expect(0, 73674, '\p{^Is_Nv=60/960}', "");
    Expect(0, 73674, '\P{Is_Nv=60/960}', "");
    Expect(1, 73674, '\P{^Is_Nv=60/960}', "");
    Expect(0, 73675, '\p{Is_Nv=60/960}', "");
    Expect(1, 73675, '\p{^Is_Nv=60/960}', "");
    Expect(1, 73675, '\P{Is_Nv=60/960}', "");
    Expect(0, 73675, '\P{^Is_Nv=60/960}', "");
    Error('\p{Is_Nv:	6.2e-02}');
    Error('\P{Is_Nv:	6.2e-02}');
    Expect(1, 73674, '\p{Is_Nv=6.25e-02}', "");
    Expect(0, 73674, '\p{^Is_Nv=6.25e-02}', "");
    Expect(0, 73674, '\P{Is_Nv=6.25e-02}', "");
    Expect(1, 73674, '\P{^Is_Nv=6.25e-02}', "");
    Expect(0, 73675, '\p{Is_Nv=6.25e-02}', "");
    Expect(1, 73675, '\p{^Is_Nv=6.25e-02}', "");
    Expect(1, 73675, '\P{Is_Nv=6.25e-02}', "");
    Expect(0, 73675, '\P{^Is_Nv=6.25e-02}', "");
    Error('\p{Is_Nv=0.06}');
    Error('\P{Is_Nv=0.06}');
    Expect(1, 73674, '\p{Is_Nv=6.250e-02}', "");
    Expect(0, 73674, '\p{^Is_Nv=6.250e-02}', "");
    Expect(0, 73674, '\P{Is_Nv=6.250e-02}', "");
    Expect(1, 73674, '\P{^Is_Nv=6.250e-02}', "");
    Expect(0, 73675, '\p{Is_Nv=6.250e-02}', "");
    Expect(1, 73675, '\p{^Is_Nv=6.250e-02}', "");
    Expect(1, 73675, '\P{Is_Nv=6.250e-02}', "");
    Expect(0, 73675, '\P{^Is_Nv=6.250e-02}', "");
    Error('\p{Is_Nv=0.062}');
    Error('\P{Is_Nv=0.062}');
    Expect(1, 73674, '\p{Is_Nv=6.2500e-02}', "");
    Expect(0, 73674, '\p{^Is_Nv=6.2500e-02}', "");
    Expect(0, 73674, '\P{Is_Nv=6.2500e-02}', "");
    Expect(1, 73674, '\P{^Is_Nv=6.2500e-02}', "");
    Expect(0, 73675, '\p{Is_Nv=6.2500e-02}', "");
    Expect(1, 73675, '\p{^Is_Nv=6.2500e-02}', "");
    Expect(1, 73675, '\P{Is_Nv=6.2500e-02}', "");
    Expect(0, 73675, '\P{^Is_Nv=6.2500e-02}', "");
    Expect(1, 73674, '\p{Is_Nv=0.0625}', "");
    Expect(0, 73674, '\p{^Is_Nv=0.0625}', "");
    Expect(0, 73674, '\P{Is_Nv=0.0625}', "");
    Expect(1, 73674, '\P{^Is_Nv=0.0625}', "");
    Expect(0, 73675, '\p{Is_Nv=0.0625}', "");
    Expect(1, 73675, '\p{^Is_Nv=0.0625}', "");
    Expect(1, 73675, '\P{Is_Nv=0.0625}', "");
    Expect(0, 73675, '\P{^Is_Nv=0.0625}', "");
    Expect(1, 73674, '\p{Is_Nv=6.25000e-02}', "");
    Expect(0, 73674, '\p{^Is_Nv=6.25000e-02}', "");
    Expect(0, 73674, '\P{Is_Nv=6.25000e-02}', "");
    Expect(1, 73674, '\P{^Is_Nv=6.25000e-02}', "");
    Expect(0, 73675, '\p{Is_Nv=6.25000e-02}', "");
    Expect(1, 73675, '\p{^Is_Nv=6.25000e-02}', "");
    Expect(1, 73675, '\P{Is_Nv=6.25000e-02}', "");
    Expect(0, 73675, '\P{^Is_Nv=6.25000e-02}', "");
    Expect(1, 73674, '\p{Is_Nv=0.06250}', "");
    Expect(0, 73674, '\p{^Is_Nv=0.06250}', "");
    Expect(0, 73674, '\P{Is_Nv=0.06250}', "");
    Expect(1, 73674, '\P{^Is_Nv=0.06250}', "");
    Expect(0, 73675, '\p{Is_Nv=0.06250}', "");
    Expect(1, 73675, '\p{^Is_Nv=0.06250}', "");
    Expect(1, 73675, '\P{Is_Nv=0.06250}', "");
    Expect(0, 73675, '\P{^Is_Nv=0.06250}', "");
    Error('\p{Numeric_Value=	/a/+0000000001/000000000160}');
    Error('\P{Numeric_Value=	/a/+0000000001/000000000160}');
    Expect(1, 73665, '\p{Numeric_Value=:\A1/160\z:}', "");;
    Expect(0, 73666, '\p{Numeric_Value=:\A1/160\z:}', "");;
    Expect(1, 73665, '\p{Numeric_Value:001/00000000160}', "");
    Expect(0, 73665, '\p{^Numeric_Value:001/00000000160}', "");
    Expect(0, 73665, '\P{Numeric_Value:001/00000000160}', "");
    Expect(1, 73665, '\P{^Numeric_Value:001/00000000160}', "");
    Expect(0, 73666, '\p{Numeric_Value:001/00000000160}', "");
    Expect(1, 73666, '\p{^Numeric_Value:001/00000000160}', "");
    Expect(1, 73666, '\P{Numeric_Value:001/00000000160}', "");
    Expect(0, 73666, '\P{^Numeric_Value:001/00000000160}', "");
    Expect(1, 73665, '\p{Numeric_Value=60/9600}', "");
    Expect(0, 73665, '\p{^Numeric_Value=60/9600}', "");
    Expect(0, 73665, '\P{Numeric_Value=60/9600}', "");
    Expect(1, 73665, '\P{^Numeric_Value=60/9600}', "");
    Expect(0, 73666, '\p{Numeric_Value=60/9600}', "");
    Expect(1, 73666, '\p{^Numeric_Value=60/9600}', "");
    Expect(1, 73666, '\P{Numeric_Value=60/9600}', "");
    Expect(0, 73666, '\P{^Numeric_Value=60/9600}', "");
    Error('\p{Numeric_Value=6.3e-03}');
    Error('\P{Numeric_Value=6.3e-03}');
    Expect(1, 73665, '\p{Numeric_Value=6.25e-03}', "");
    Expect(0, 73665, '\p{^Numeric_Value=6.25e-03}', "");
    Expect(0, 73665, '\P{Numeric_Value=6.25e-03}', "");
    Expect(1, 73665, '\P{^Numeric_Value=6.25e-03}', "");
    Expect(0, 73666, '\p{Numeric_Value=6.25e-03}', "");
    Expect(1, 73666, '\p{^Numeric_Value=6.25e-03}', "");
    Expect(1, 73666, '\P{Numeric_Value=6.25e-03}', "");
    Expect(0, 73666, '\P{^Numeric_Value=6.25e-03}', "");
    Error('\p{Numeric_Value=0.01}');
    Error('\P{Numeric_Value=0.01}');
    Expect(1, 73665, '\p{Numeric_Value=6.250e-03}', "");
    Expect(0, 73665, '\p{^Numeric_Value=6.250e-03}', "");
    Expect(0, 73665, '\P{Numeric_Value=6.250e-03}', "");
    Expect(1, 73665, '\P{^Numeric_Value=6.250e-03}', "");
    Expect(0, 73666, '\p{Numeric_Value=6.250e-03}', "");
    Expect(1, 73666, '\p{^Numeric_Value=6.250e-03}', "");
    Expect(1, 73666, '\P{Numeric_Value=6.250e-03}', "");
    Expect(0, 73666, '\P{^Numeric_Value=6.250e-03}', "");
    Error('\p{Numeric_Value=0.006}');
    Error('\P{Numeric_Value=0.006}');
    Expect(1, 73665, '\p{Numeric_Value=6.2500e-03}', "");
    Expect(0, 73665, '\p{^Numeric_Value=6.2500e-03}', "");
    Expect(0, 73665, '\P{Numeric_Value=6.2500e-03}', "");
    Expect(1, 73665, '\P{^Numeric_Value=6.2500e-03}', "");
    Expect(0, 73666, '\p{Numeric_Value=6.2500e-03}', "");
    Expect(1, 73666, '\p{^Numeric_Value=6.2500e-03}', "");
    Expect(1, 73666, '\P{Numeric_Value=6.2500e-03}', "");
    Expect(0, 73666, '\P{^Numeric_Value=6.2500e-03}', "");
    Error('\p{Numeric_Value=0.0063}');
    Error('\P{Numeric_Value=0.0063}');
    Expect(1, 73665, '\p{Numeric_Value=6.25000e-03}', "");
    Expect(0, 73665, '\p{^Numeric_Value=6.25000e-03}', "");
    Expect(0, 73665, '\P{Numeric_Value=6.25000e-03}', "");
    Expect(1, 73665, '\P{^Numeric_Value=6.25000e-03}', "");
    Expect(0, 73666, '\p{Numeric_Value=6.25000e-03}', "");
    Expect(1, 73666, '\p{^Numeric_Value=6.25000e-03}', "");
    Expect(1, 73666, '\P{Numeric_Value=6.25000e-03}', "");
    Expect(0, 73666, '\P{^Numeric_Value=6.25000e-03}', "");
    Expect(1, 73665, '\p{Numeric_Value=0.00625}', "");
    Expect(0, 73665, '\p{^Numeric_Value=0.00625}', "");
    Expect(0, 73665, '\P{Numeric_Value=0.00625}', "");
    Expect(1, 73665, '\P{^Numeric_Value=0.00625}', "");
    Expect(0, 73666, '\p{Numeric_Value=0.00625}', "");
    Expect(1, 73666, '\p{^Numeric_Value=0.00625}', "");
    Expect(1, 73666, '\P{Numeric_Value=0.00625}', "");
    Expect(0, 73666, '\P{^Numeric_Value=0.00625}', "");
    Expect(1, 73665, '\p{Numeric_Value=6.250000e-03}', "");
    Expect(0, 73665, '\p{^Numeric_Value=6.250000e-03}', "");
    Expect(0, 73665, '\P{Numeric_Value=6.250000e-03}', "");
    Expect(1, 73665, '\P{^Numeric_Value=6.250000e-03}', "");
    Expect(0, 73666, '\p{Numeric_Value=6.250000e-03}', "");
    Expect(1, 73666, '\p{^Numeric_Value=6.250000e-03}', "");
    Expect(1, 73666, '\P{Numeric_Value=6.250000e-03}', "");
    Expect(0, 73666, '\P{^Numeric_Value=6.250000e-03}', "");
    Expect(1, 73665, '\p{Numeric_Value=0.006250}', "");
    Expect(0, 73665, '\p{^Numeric_Value=0.006250}', "");
    Expect(0, 73665, '\P{Numeric_Value=0.006250}', "");
    Expect(1, 73665, '\P{^Numeric_Value=0.006250}', "");
    Expect(0, 73666, '\p{Numeric_Value=0.006250}', "");
    Expect(1, 73666, '\p{^Numeric_Value=0.006250}', "");
    Expect(1, 73666, '\P{Numeric_Value=0.006250}', "");
    Expect(0, 73666, '\P{^Numeric_Value=0.006250}', "");
    Error('\p{Nv: -+0000001/00160/a/}');
    Error('\P{Nv: -+0000001/00160/a/}');
    Expect(1, 73665, '\p{Nv=:\A1/160\z:}', "");;
    Expect(0, 73666, '\p{Nv=:\A1/160\z:}', "");;
    Expect(1, 73665, '\p{Nv=000000001/0000000160}', "");
    Expect(0, 73665, '\p{^Nv=000000001/0000000160}', "");
    Expect(0, 73665, '\P{Nv=000000001/0000000160}', "");
    Expect(1, 73665, '\P{^Nv=000000001/0000000160}', "");
    Expect(0, 73666, '\p{Nv=000000001/0000000160}', "");
    Expect(1, 73666, '\p{^Nv=000000001/0000000160}', "");
    Expect(1, 73666, '\P{Nv=000000001/0000000160}', "");
    Expect(0, 73666, '\P{^Nv=000000001/0000000160}', "");
    Expect(1, 73665, '\p{Nv=60/9600}', "");
    Expect(0, 73665, '\p{^Nv=60/9600}', "");
    Expect(0, 73665, '\P{Nv=60/9600}', "");
    Expect(1, 73665, '\P{^Nv=60/9600}', "");
    Expect(0, 73666, '\p{Nv=60/9600}', "");
    Expect(1, 73666, '\p{^Nv=60/9600}', "");
    Expect(1, 73666, '\P{Nv=60/9600}', "");
    Expect(0, 73666, '\P{^Nv=60/9600}', "");
    Error('\p{Nv=6.3e-03}');
    Error('\P{Nv=6.3e-03}');
    Expect(1, 73665, '\p{Nv=6.25e-03}', "");
    Expect(0, 73665, '\p{^Nv=6.25e-03}', "");
    Expect(0, 73665, '\P{Nv=6.25e-03}', "");
    Expect(1, 73665, '\P{^Nv=6.25e-03}', "");
    Expect(0, 73666, '\p{Nv=6.25e-03}', "");
    Expect(1, 73666, '\p{^Nv=6.25e-03}', "");
    Expect(1, 73666, '\P{Nv=6.25e-03}', "");
    Expect(0, 73666, '\P{^Nv=6.25e-03}', "");
    Error('\p{Nv=0.01}');
    Error('\P{Nv=0.01}');
    Expect(1, 73665, '\p{Nv=6.250e-03}', "");
    Expect(0, 73665, '\p{^Nv=6.250e-03}', "");
    Expect(0, 73665, '\P{Nv=6.250e-03}', "");
    Expect(1, 73665, '\P{^Nv=6.250e-03}', "");
    Expect(0, 73666, '\p{Nv=6.250e-03}', "");
    Expect(1, 73666, '\p{^Nv=6.250e-03}', "");
    Expect(1, 73666, '\P{Nv=6.250e-03}', "");
    Expect(0, 73666, '\P{^Nv=6.250e-03}', "");
    Error('\p{Nv=0.006}');
    Error('\P{Nv=0.006}');
    Expect(1, 73665, '\p{Nv:	6.2500e-03}', "");
    Expect(0, 73665, '\p{^Nv:	6.2500e-03}', "");
    Expect(0, 73665, '\P{Nv:	6.2500e-03}', "");
    Expect(1, 73665, '\P{^Nv:	6.2500e-03}', "");
    Expect(0, 73666, '\p{Nv:	6.2500e-03}', "");
    Expect(1, 73666, '\p{^Nv:	6.2500e-03}', "");
    Expect(1, 73666, '\P{Nv:	6.2500e-03}', "");
    Expect(0, 73666, '\P{^Nv:	6.2500e-03}', "");
    Error('\p{Nv=0.0063}');
    Error('\P{Nv=0.0063}');
    Expect(1, 73665, '\p{Nv=6.25000e-03}', "");
    Expect(0, 73665, '\p{^Nv=6.25000e-03}', "");
    Expect(0, 73665, '\P{Nv=6.25000e-03}', "");
    Expect(1, 73665, '\P{^Nv=6.25000e-03}', "");
    Expect(0, 73666, '\p{Nv=6.25000e-03}', "");
    Expect(1, 73666, '\p{^Nv=6.25000e-03}', "");
    Expect(1, 73666, '\P{Nv=6.25000e-03}', "");
    Expect(0, 73666, '\P{^Nv=6.25000e-03}', "");
    Expect(1, 73665, '\p{Nv=0.00625}', "");
    Expect(0, 73665, '\p{^Nv=0.00625}', "");
    Expect(0, 73665, '\P{Nv=0.00625}', "");
    Expect(1, 73665, '\P{^Nv=0.00625}', "");
    Expect(0, 73666, '\p{Nv=0.00625}', "");
    Expect(1, 73666, '\p{^Nv=0.00625}', "");
    Expect(1, 73666, '\P{Nv=0.00625}', "");
    Expect(0, 73666, '\P{^Nv=0.00625}', "");
    Expect(1, 73665, '\p{Nv=6.250000e-03}', "");
    Expect(0, 73665, '\p{^Nv=6.250000e-03}', "");
    Expect(0, 73665, '\P{Nv=6.250000e-03}', "");
    Expect(1, 73665, '\P{^Nv=6.250000e-03}', "");
    Expect(0, 73666, '\p{Nv=6.250000e-03}', "");
    Expect(1, 73666, '\p{^Nv=6.250000e-03}', "");
    Expect(1, 73666, '\P{Nv=6.250000e-03}', "");
    Expect(0, 73666, '\P{^Nv=6.250000e-03}', "");
    Expect(1, 73665, '\p{Nv:   0.006250}', "");
    Expect(0, 73665, '\p{^Nv:   0.006250}', "");
    Expect(0, 73665, '\P{Nv:   0.006250}', "");
    Expect(1, 73665, '\P{^Nv:   0.006250}', "");
    Expect(0, 73666, '\p{Nv:   0.006250}', "");
    Expect(1, 73666, '\p{^Nv:   0.006250}', "");
    Expect(1, 73666, '\P{Nv:   0.006250}', "");
    Expect(0, 73666, '\P{^Nv:   0.006250}', "");
    Error('\p{Is_Numeric_Value=	:=0000001/00000160}');
    Error('\P{Is_Numeric_Value=	:=0000001/00000160}');
    Expect(1, 73665, '\p{Is_Numeric_Value=0000000001/00000000160}', "");
    Expect(0, 73665, '\p{^Is_Numeric_Value=0000000001/00000000160}', "");
    Expect(0, 73665, '\P{Is_Numeric_Value=0000000001/00000000160}', "");
    Expect(1, 73665, '\P{^Is_Numeric_Value=0000000001/00000000160}', "");
    Expect(0, 73666, '\p{Is_Numeric_Value=0000000001/00000000160}', "");
    Expect(1, 73666, '\p{^Is_Numeric_Value=0000000001/00000000160}', "");
    Expect(1, 73666, '\P{Is_Numeric_Value=0000000001/00000000160}', "");
    Expect(0, 73666, '\P{^Is_Numeric_Value=0000000001/00000000160}', "");
    Expect(1, 73665, '\p{Is_Numeric_Value=60/9600}', "");
    Expect(0, 73665, '\p{^Is_Numeric_Value=60/9600}', "");
    Expect(0, 73665, '\P{Is_Numeric_Value=60/9600}', "");
    Expect(1, 73665, '\P{^Is_Numeric_Value=60/9600}', "");
    Expect(0, 73666, '\p{Is_Numeric_Value=60/9600}', "");
    Expect(1, 73666, '\p{^Is_Numeric_Value=60/9600}', "");
    Expect(1, 73666, '\P{Is_Numeric_Value=60/9600}', "");
    Expect(0, 73666, '\P{^Is_Numeric_Value=60/9600}', "");
    Error('\p{Is_Numeric_Value=6.3e-03}');
    Error('\P{Is_Numeric_Value=6.3e-03}');
    Expect(1, 73665, '\p{Is_Numeric_Value=6.25e-03}', "");
    Expect(0, 73665, '\p{^Is_Numeric_Value=6.25e-03}', "");
    Expect(0, 73665, '\P{Is_Numeric_Value=6.25e-03}', "");
    Expect(1, 73665, '\P{^Is_Numeric_Value=6.25e-03}', "");
    Expect(0, 73666, '\p{Is_Numeric_Value=6.25e-03}', "");
    Expect(1, 73666, '\p{^Is_Numeric_Value=6.25e-03}', "");
    Expect(1, 73666, '\P{Is_Numeric_Value=6.25e-03}', "");
    Expect(0, 73666, '\P{^Is_Numeric_Value=6.25e-03}', "");
    Error('\p{Is_Numeric_Value=0.01}');
    Error('\P{Is_Numeric_Value=0.01}');
    Expect(1, 73665, '\p{Is_Numeric_Value=6.250e-03}', "");
    Expect(0, 73665, '\p{^Is_Numeric_Value=6.250e-03}', "");
    Expect(0, 73665, '\P{Is_Numeric_Value=6.250e-03}', "");
    Expect(1, 73665, '\P{^Is_Numeric_Value=6.250e-03}', "");
    Expect(0, 73666, '\p{Is_Numeric_Value=6.250e-03}', "");
    Expect(1, 73666, '\p{^Is_Numeric_Value=6.250e-03}', "");
    Expect(1, 73666, '\P{Is_Numeric_Value=6.250e-03}', "");
    Expect(0, 73666, '\P{^Is_Numeric_Value=6.250e-03}', "");
    Error('\p{Is_Numeric_Value=0.006}');
    Error('\P{Is_Numeric_Value=0.006}');
    Expect(1, 73665, '\p{Is_Numeric_Value=6.2500e-03}', "");
    Expect(0, 73665, '\p{^Is_Numeric_Value=6.2500e-03}', "");
    Expect(0, 73665, '\P{Is_Numeric_Value=6.2500e-03}', "");
    Expect(1, 73665, '\P{^Is_Numeric_Value=6.2500e-03}', "");
    Expect(0, 73666, '\p{Is_Numeric_Value=6.2500e-03}', "");
    Expect(1, 73666, '\p{^Is_Numeric_Value=6.2500e-03}', "");
    Expect(1, 73666, '\P{Is_Numeric_Value=6.2500e-03}', "");
    Expect(0, 73666, '\P{^Is_Numeric_Value=6.2500e-03}', "");
    Error('\p{Is_Numeric_Value=0.0063}');
    Error('\P{Is_Numeric_Value=0.0063}');
    Expect(1, 73665, '\p{Is_Numeric_Value=6.25000e-03}', "");
    Expect(0, 73665, '\p{^Is_Numeric_Value=6.25000e-03}', "");
    Expect(0, 73665, '\P{Is_Numeric_Value=6.25000e-03}', "");
    Expect(1, 73665, '\P{^Is_Numeric_Value=6.25000e-03}', "");
    Expect(0, 73666, '\p{Is_Numeric_Value=6.25000e-03}', "");
    Expect(1, 73666, '\p{^Is_Numeric_Value=6.25000e-03}', "");
    Expect(1, 73666, '\P{Is_Numeric_Value=6.25000e-03}', "");
    Expect(0, 73666, '\P{^Is_Numeric_Value=6.25000e-03}', "");
    Expect(1, 73665, '\p{Is_Numeric_Value: 0.00625}', "");
    Expect(0, 73665, '\p{^Is_Numeric_Value: 0.00625}', "");
    Expect(0, 73665, '\P{Is_Numeric_Value: 0.00625}', "");
    Expect(1, 73665, '\P{^Is_Numeric_Value: 0.00625}', "");
    Expect(0, 73666, '\p{Is_Numeric_Value: 0.00625}', "");
    Expect(1, 73666, '\p{^Is_Numeric_Value: 0.00625}', "");
    Expect(1, 73666, '\P{Is_Numeric_Value: 0.00625}', "");
    Expect(0, 73666, '\P{^Is_Numeric_Value: 0.00625}', "");
    Expect(1, 73665, '\p{Is_Numeric_Value:	6.250000e-03}', "");
    Expect(0, 73665, '\p{^Is_Numeric_Value:	6.250000e-03}', "");
    Expect(0, 73665, '\P{Is_Numeric_Value:	6.250000e-03}', "");
    Expect(1, 73665, '\P{^Is_Numeric_Value:	6.250000e-03}', "");
    Expect(0, 73666, '\p{Is_Numeric_Value:	6.250000e-03}', "");
    Expect(1, 73666, '\p{^Is_Numeric_Value:	6.250000e-03}', "");
    Expect(1, 73666, '\P{Is_Numeric_Value:	6.250000e-03}', "");
    Expect(0, 73666, '\P{^Is_Numeric_Value:	6.250000e-03}', "");
    Expect(1, 73665, '\p{Is_Numeric_Value=0.006250}', "");
    Expect(0, 73665, '\p{^Is_Numeric_Value=0.006250}', "");
    Expect(0, 73665, '\P{Is_Numeric_Value=0.006250}', "");
    Expect(1, 73665, '\P{^Is_Numeric_Value=0.006250}', "");
    Expect(0, 73666, '\p{Is_Numeric_Value=0.006250}', "");
    Expect(1, 73666, '\p{^Is_Numeric_Value=0.006250}', "");
    Expect(1, 73666, '\P{Is_Numeric_Value=0.006250}', "");
    Expect(0, 73666, '\P{^Is_Numeric_Value=0.006250}', "");
    Error('\p{Is_Nv=_/a/000000001/000160}');
    Error('\P{Is_Nv=_/a/000000001/000160}');
    Expect(1, 73665, '\p{Is_Nv=00000001/160}', "");
    Expect(0, 73665, '\p{^Is_Nv=00000001/160}', "");
    Expect(0, 73665, '\P{Is_Nv=00000001/160}', "");
    Expect(1, 73665, '\P{^Is_Nv=00000001/160}', "");
    Expect(0, 73666, '\p{Is_Nv=00000001/160}', "");
    Expect(1, 73666, '\p{^Is_Nv=00000001/160}', "");
    Expect(1, 73666, '\P{Is_Nv=00000001/160}', "");
    Expect(0, 73666, '\P{^Is_Nv=00000001/160}', "");
    Expect(1, 73665, '\p{Is_Nv=60/9600}', "");
    Expect(0, 73665, '\p{^Is_Nv=60/9600}', "");
    Expect(0, 73665, '\P{Is_Nv=60/9600}', "");
    Expect(1, 73665, '\P{^Is_Nv=60/9600}', "");
    Expect(0, 73666, '\p{Is_Nv=60/9600}', "");
    Expect(1, 73666, '\p{^Is_Nv=60/9600}', "");
    Expect(1, 73666, '\P{Is_Nv=60/9600}', "");
    Expect(0, 73666, '\P{^Is_Nv=60/9600}', "");
    Error('\p{Is_Nv=6.3e-03}');
    Error('\P{Is_Nv=6.3e-03}');
    Expect(1, 73665, '\p{Is_Nv: 6.25e-03}', "");
    Expect(0, 73665, '\p{^Is_Nv: 6.25e-03}', "");
    Expect(0, 73665, '\P{Is_Nv: 6.25e-03}', "");
    Expect(1, 73665, '\P{^Is_Nv: 6.25e-03}', "");
    Expect(0, 73666, '\p{Is_Nv: 6.25e-03}', "");
    Expect(1, 73666, '\p{^Is_Nv: 6.25e-03}', "");
    Expect(1, 73666, '\P{Is_Nv: 6.25e-03}', "");
    Expect(0, 73666, '\P{^Is_Nv: 6.25e-03}', "");
    Error('\p{Is_Nv=0.01}');
    Error('\P{Is_Nv=0.01}');
    Expect(1, 73665, '\p{Is_Nv=6.250e-03}', "");
    Expect(0, 73665, '\p{^Is_Nv=6.250e-03}', "");
    Expect(0, 73665, '\P{Is_Nv=6.250e-03}', "");
    Expect(1, 73665, '\P{^Is_Nv=6.250e-03}', "");
    Expect(0, 73666, '\p{Is_Nv=6.250e-03}', "");
    Expect(1, 73666, '\p{^Is_Nv=6.250e-03}', "");
    Expect(1, 73666, '\P{Is_Nv=6.250e-03}', "");
    Expect(0, 73666, '\P{^Is_Nv=6.250e-03}', "");
    Error('\p{Is_Nv=0.006}');
    Error('\P{Is_Nv=0.006}');
    Expect(1, 73665, '\p{Is_Nv=6.2500e-03}', "");
    Expect(0, 73665, '\p{^Is_Nv=6.2500e-03}', "");
    Expect(0, 73665, '\P{Is_Nv=6.2500e-03}', "");
    Expect(1, 73665, '\P{^Is_Nv=6.2500e-03}', "");
    Expect(0, 73666, '\p{Is_Nv=6.2500e-03}', "");
    Expect(1, 73666, '\p{^Is_Nv=6.2500e-03}', "");
    Expect(1, 73666, '\P{Is_Nv=6.2500e-03}', "");
    Expect(0, 73666, '\P{^Is_Nv=6.2500e-03}', "");
    Error('\p{Is_Nv:   0.0063}');
    Error('\P{Is_Nv:   0.0063}');
    Expect(1, 73665, '\p{Is_Nv=6.25000e-03}', "");
    Expect(0, 73665, '\p{^Is_Nv=6.25000e-03}', "");
    Expect(0, 73665, '\P{Is_Nv=6.25000e-03}', "");
    Expect(1, 73665, '\P{^Is_Nv=6.25000e-03}', "");
    Expect(0, 73666, '\p{Is_Nv=6.25000e-03}', "");
    Expect(1, 73666, '\p{^Is_Nv=6.25000e-03}', "");
    Expect(1, 73666, '\P{Is_Nv=6.25000e-03}', "");
    Expect(0, 73666, '\P{^Is_Nv=6.25000e-03}', "");
    Expect(1, 73665, '\p{Is_Nv=0.00625}', "");
    Expect(0, 73665, '\p{^Is_Nv=0.00625}', "");
    Expect(0, 73665, '\P{Is_Nv=0.00625}', "");
    Expect(1, 73665, '\P{^Is_Nv=0.00625}', "");
    Expect(0, 73666, '\p{Is_Nv=0.00625}', "");
    Expect(1, 73666, '\p{^Is_Nv=0.00625}', "");
    Expect(1, 73666, '\P{Is_Nv=0.00625}', "");
    Expect(0, 73666, '\P{^Is_Nv=0.00625}', "");
    Expect(1, 73665, '\p{Is_Nv=6.250000e-03}', "");
    Expect(0, 73665, '\p{^Is_Nv=6.250000e-03}', "");
    Expect(0, 73665, '\P{Is_Nv=6.250000e-03}', "");
    Expect(1, 73665, '\P{^Is_Nv=6.250000e-03}', "");
    Expect(0, 73666, '\p{Is_Nv=6.250000e-03}', "");
    Expect(1, 73666, '\p{^Is_Nv=6.250000e-03}', "");
    Expect(1, 73666, '\P{Is_Nv=6.250000e-03}', "");
    Expect(0, 73666, '\P{^Is_Nv=6.250000e-03}', "");
    Expect(1, 73665, '\p{Is_Nv=0.006250}', "");
    Expect(0, 73665, '\p{^Is_Nv=0.006250}', "");
    Expect(0, 73665, '\P{Is_Nv=0.006250}', "");
    Expect(1, 73665, '\P{^Is_Nv=0.006250}', "");
    Expect(0, 73666, '\p{Is_Nv=0.006250}', "");
    Expect(1, 73666, '\p{^Is_Nv=0.006250}', "");
    Expect(1, 73666, '\P{Is_Nv=0.006250}', "");
    Expect(0, 73666, '\P{^Is_Nv=0.006250}', "");
    Error('\p{Numeric_Value=/a/ -+000001/0000000002}');
    Error('\P{Numeric_Value=/a/ -+000001/0000000002}');
    Expect(1, 126268, '\p{Numeric_Value=:\A1/2\z:}', "");;
    Expect(0, 126269, '\p{Numeric_Value=:\A1/2\z:}', "");;
    Expect(1, 126268, '\p{Numeric_Value=+0000001/0000002}', "");
    Expect(0, 126268, '\p{^Numeric_Value=+0000001/0000002}', "");
    Expect(0, 126268, '\P{Numeric_Value=+0000001/0000002}', "");
    Expect(1, 126268, '\P{^Numeric_Value=+0000001/0000002}', "");
    Expect(0, 126269, '\p{Numeric_Value=+0000001/0000002}', "");
    Expect(1, 126269, '\p{^Numeric_Value=+0000001/0000002}', "");
    Expect(1, 126269, '\P{Numeric_Value=+0000001/0000002}', "");
    Expect(0, 126269, '\P{^Numeric_Value=+0000001/0000002}', "");
    Expect(1, 126268, '\p{Numeric_Value=60/120}', "");
    Expect(0, 126268, '\p{^Numeric_Value=60/120}', "");
    Expect(0, 126268, '\P{Numeric_Value=60/120}', "");
    Expect(1, 126268, '\P{^Numeric_Value=60/120}', "");
    Expect(0, 126269, '\p{Numeric_Value=60/120}', "");
    Expect(1, 126269, '\p{^Numeric_Value=60/120}', "");
    Expect(1, 126269, '\P{Numeric_Value=60/120}', "");
    Expect(0, 126269, '\P{^Numeric_Value=60/120}', "");
    Expect(1, 126268, '\p{Numeric_Value=5.0e-01}', "");
    Expect(0, 126268, '\p{^Numeric_Value=5.0e-01}', "");
    Expect(0, 126268, '\P{Numeric_Value=5.0e-01}', "");
    Expect(1, 126268, '\P{^Numeric_Value=5.0e-01}', "");
    Expect(0, 126269, '\p{Numeric_Value=5.0e-01}', "");
    Expect(1, 126269, '\p{^Numeric_Value=5.0e-01}', "");
    Expect(1, 126269, '\P{Numeric_Value=5.0e-01}', "");
    Expect(0, 126269, '\P{^Numeric_Value=5.0e-01}', "");
    Expect(1, 126268, '\p{Numeric_Value=0.5}', "");
    Expect(0, 126268, '\p{^Numeric_Value=0.5}', "");
    Expect(0, 126268, '\P{Numeric_Value=0.5}', "");
    Expect(1, 126268, '\P{^Numeric_Value=0.5}', "");
    Expect(0, 126269, '\p{Numeric_Value=0.5}', "");
    Expect(1, 126269, '\p{^Numeric_Value=0.5}', "");
    Expect(1, 126269, '\P{Numeric_Value=0.5}', "");
    Expect(0, 126269, '\P{^Numeric_Value=0.5}', "");
    Expect(1, 126268, '\p{Numeric_Value=5.00e-01}', "");
    Expect(0, 126268, '\p{^Numeric_Value=5.00e-01}', "");
    Expect(0, 126268, '\P{Numeric_Value=5.00e-01}', "");
    Expect(1, 126268, '\P{^Numeric_Value=5.00e-01}', "");
    Expect(0, 126269, '\p{Numeric_Value=5.00e-01}', "");
    Expect(1, 126269, '\p{^Numeric_Value=5.00e-01}', "");
    Expect(1, 126269, '\P{Numeric_Value=5.00e-01}', "");
    Expect(0, 126269, '\P{^Numeric_Value=5.00e-01}', "");
    Expect(1, 126268, '\p{Numeric_Value:0.50}', "");
    Expect(0, 126268, '\p{^Numeric_Value:0.50}', "");
    Expect(0, 126268, '\P{Numeric_Value:0.50}', "");
    Expect(1, 126268, '\P{^Numeric_Value:0.50}', "");
    Expect(0, 126269, '\p{Numeric_Value:0.50}', "");
    Expect(1, 126269, '\p{^Numeric_Value:0.50}', "");
    Expect(1, 126269, '\P{Numeric_Value:0.50}', "");
    Expect(0, 126269, '\P{^Numeric_Value:0.50}', "");
    Error('\p{Nv= /a/00001/000002}');
    Error('\P{Nv= /a/00001/000002}');
    Expect(1, 126268, '\p{Nv=:\A1/2\z:}', "");;
    Expect(0, 126269, '\p{Nv=:\A1/2\z:}', "");;
    Expect(1, 126268, '\p{Nv=0001/002}', "");
    Expect(0, 126268, '\p{^Nv=0001/002}', "");
    Expect(0, 126268, '\P{Nv=0001/002}', "");
    Expect(1, 126268, '\P{^Nv=0001/002}', "");
    Expect(0, 126269, '\p{Nv=0001/002}', "");
    Expect(1, 126269, '\p{^Nv=0001/002}', "");
    Expect(1, 126269, '\P{Nv=0001/002}', "");
    Expect(0, 126269, '\P{^Nv=0001/002}', "");
    Expect(1, 126268, '\p{Nv: 60/120}', "");
    Expect(0, 126268, '\p{^Nv: 60/120}', "");
    Expect(0, 126268, '\P{Nv: 60/120}', "");
    Expect(1, 126268, '\P{^Nv: 60/120}', "");
    Expect(0, 126269, '\p{Nv: 60/120}', "");
    Expect(1, 126269, '\p{^Nv: 60/120}', "");
    Expect(1, 126269, '\P{Nv: 60/120}', "");
    Expect(0, 126269, '\P{^Nv: 60/120}', "");
    Expect(1, 126268, '\p{Nv=5.0e-01}', "");
    Expect(0, 126268, '\p{^Nv=5.0e-01}', "");
    Expect(0, 126268, '\P{Nv=5.0e-01}', "");
    Expect(1, 126268, '\P{^Nv=5.0e-01}', "");
    Expect(0, 126269, '\p{Nv=5.0e-01}', "");
    Expect(1, 126269, '\p{^Nv=5.0e-01}', "");
    Expect(1, 126269, '\P{Nv=5.0e-01}', "");
    Expect(0, 126269, '\P{^Nv=5.0e-01}', "");
    Expect(1, 126268, '\p{Nv=0.5}', "");
    Expect(0, 126268, '\p{^Nv=0.5}', "");
    Expect(0, 126268, '\P{Nv=0.5}', "");
    Expect(1, 126268, '\P{^Nv=0.5}', "");
    Expect(0, 126269, '\p{Nv=0.5}', "");
    Expect(1, 126269, '\p{^Nv=0.5}', "");
    Expect(1, 126269, '\P{Nv=0.5}', "");
    Expect(0, 126269, '\P{^Nv=0.5}', "");
    Expect(1, 126268, '\p{Nv=5.00e-01}', "");
    Expect(0, 126268, '\p{^Nv=5.00e-01}', "");
    Expect(0, 126268, '\P{Nv=5.00e-01}', "");
    Expect(1, 126268, '\P{^Nv=5.00e-01}', "");
    Expect(0, 126269, '\p{Nv=5.00e-01}', "");
    Expect(1, 126269, '\p{^Nv=5.00e-01}', "");
    Expect(1, 126269, '\P{Nv=5.00e-01}', "");
    Expect(0, 126269, '\P{^Nv=5.00e-01}', "");
    Expect(1, 126268, '\p{Nv=0.50}', "");
    Expect(0, 126268, '\p{^Nv=0.50}', "");
    Expect(0, 126268, '\P{Nv=0.50}', "");
    Expect(1, 126268, '\P{^Nv=0.50}', "");
    Expect(0, 126269, '\p{Nv=0.50}', "");
    Expect(1, 126269, '\p{^Nv=0.50}', "");
    Expect(1, 126269, '\P{Nv=0.50}', "");
    Expect(0, 126269, '\P{^Nv=0.50}', "");
    Error('\p{Is_Numeric_Value=:=__+000000001/2}');
    Error('\P{Is_Numeric_Value=:=__+000000001/2}');
    Expect(1, 126268, '\p{Is_Numeric_Value=+0001/2}', "");
    Expect(0, 126268, '\p{^Is_Numeric_Value=+0001/2}', "");
    Expect(0, 126268, '\P{Is_Numeric_Value=+0001/2}', "");
    Expect(1, 126268, '\P{^Is_Numeric_Value=+0001/2}', "");
    Expect(0, 126269, '\p{Is_Numeric_Value=+0001/2}', "");
    Expect(1, 126269, '\p{^Is_Numeric_Value=+0001/2}', "");
    Expect(1, 126269, '\P{Is_Numeric_Value=+0001/2}', "");
    Expect(0, 126269, '\P{^Is_Numeric_Value=+0001/2}', "");
    Expect(1, 126268, '\p{Is_Numeric_Value:	60/120}', "");
    Expect(0, 126268, '\p{^Is_Numeric_Value:	60/120}', "");
    Expect(0, 126268, '\P{Is_Numeric_Value:	60/120}', "");
    Expect(1, 126268, '\P{^Is_Numeric_Value:	60/120}', "");
    Expect(0, 126269, '\p{Is_Numeric_Value:	60/120}', "");
    Expect(1, 126269, '\p{^Is_Numeric_Value:	60/120}', "");
    Expect(1, 126269, '\P{Is_Numeric_Value:	60/120}', "");
    Expect(0, 126269, '\P{^Is_Numeric_Value:	60/120}', "");
    Expect(1, 126268, '\p{Is_Numeric_Value=5.0e-01}', "");
    Expect(0, 126268, '\p{^Is_Numeric_Value=5.0e-01}', "");
    Expect(0, 126268, '\P{Is_Numeric_Value=5.0e-01}', "");
    Expect(1, 126268, '\P{^Is_Numeric_Value=5.0e-01}', "");
    Expect(0, 126269, '\p{Is_Numeric_Value=5.0e-01}', "");
    Expect(1, 126269, '\p{^Is_Numeric_Value=5.0e-01}', "");
    Expect(1, 126269, '\P{Is_Numeric_Value=5.0e-01}', "");
    Expect(0, 126269, '\P{^Is_Numeric_Value=5.0e-01}', "");
    Expect(1, 126268, '\p{Is_Numeric_Value=0.5}', "");
    Expect(0, 126268, '\p{^Is_Numeric_Value=0.5}', "");
    Expect(0, 126268, '\P{Is_Numeric_Value=0.5}', "");
    Expect(1, 126268, '\P{^Is_Numeric_Value=0.5}', "");
    Expect(0, 126269, '\p{Is_Numeric_Value=0.5}', "");
    Expect(1, 126269, '\p{^Is_Numeric_Value=0.5}', "");
    Expect(1, 126269, '\P{Is_Numeric_Value=0.5}', "");
    Expect(0, 126269, '\P{^Is_Numeric_Value=0.5}', "");
    Expect(1, 126268, '\p{Is_Numeric_Value=5.00e-01}', "");
    Expect(0, 126268, '\p{^Is_Numeric_Value=5.00e-01}', "");
    Expect(0, 126268, '\P{Is_Numeric_Value=5.00e-01}', "");
    Expect(1, 126268, '\P{^Is_Numeric_Value=5.00e-01}', "");
    Expect(0, 126269, '\p{Is_Numeric_Value=5.00e-01}', "");
    Expect(1, 126269, '\p{^Is_Numeric_Value=5.00e-01}', "");
    Expect(1, 126269, '\P{Is_Numeric_Value=5.00e-01}', "");
    Expect(0, 126269, '\P{^Is_Numeric_Value=5.00e-01}', "");
    Expect(1, 126268, '\p{Is_Numeric_Value=0.50}', "");
    Expect(0, 126268, '\p{^Is_Numeric_Value=0.50}', "");
    Expect(0, 126268, '\P{Is_Numeric_Value=0.50}', "");
    Expect(1, 126268, '\P{^Is_Numeric_Value=0.50}', "");
    Expect(0, 126269, '\p{Is_Numeric_Value=0.50}', "");
    Expect(1, 126269, '\p{^Is_Numeric_Value=0.50}', "");
    Expect(1, 126269, '\P{Is_Numeric_Value=0.50}', "");
    Expect(0, 126269, '\P{^Is_Numeric_Value=0.50}', "");
    Error('\p{Is_Nv:   	/a/01/00000002}');
    Error('\P{Is_Nv:   	/a/01/00000002}');
    Expect(1, 126268, '\p{Is_Nv=0000000001/02}', "");
    Expect(0, 126268, '\p{^Is_Nv=0000000001/02}', "");
    Expect(0, 126268, '\P{Is_Nv=0000000001/02}', "");
    Expect(1, 126268, '\P{^Is_Nv=0000000001/02}', "");
    Expect(0, 126269, '\p{Is_Nv=0000000001/02}', "");
    Expect(1, 126269, '\p{^Is_Nv=0000000001/02}', "");
    Expect(1, 126269, '\P{Is_Nv=0000000001/02}', "");
    Expect(0, 126269, '\P{^Is_Nv=0000000001/02}', "");
    Expect(1, 126268, '\p{Is_Nv:   60/120}', "");
    Expect(0, 126268, '\p{^Is_Nv:   60/120}', "");
    Expect(0, 126268, '\P{Is_Nv:   60/120}', "");
    Expect(1, 126268, '\P{^Is_Nv:   60/120}', "");
    Expect(0, 126269, '\p{Is_Nv:   60/120}', "");
    Expect(1, 126269, '\p{^Is_Nv:   60/120}', "");
    Expect(1, 126269, '\P{Is_Nv:   60/120}', "");
    Expect(0, 126269, '\P{^Is_Nv:   60/120}', "");
    Expect(1, 126268, '\p{Is_Nv: 5.0e-01}', "");
    Expect(0, 126268, '\p{^Is_Nv: 5.0e-01}', "");
    Expect(0, 126268, '\P{Is_Nv: 5.0e-01}', "");
    Expect(1, 126268, '\P{^Is_Nv: 5.0e-01}', "");
    Expect(0, 126269, '\p{Is_Nv: 5.0e-01}', "");
    Expect(1, 126269, '\p{^Is_Nv: 5.0e-01}', "");
    Expect(1, 126269, '\P{Is_Nv: 5.0e-01}', "");
    Expect(0, 126269, '\P{^Is_Nv: 5.0e-01}', "");
    Expect(1, 126268, '\p{Is_Nv=0.5}', "");
    Expect(0, 126268, '\p{^Is_Nv=0.5}', "");
    Expect(0, 126268, '\P{Is_Nv=0.5}', "");
    Expect(1, 126268, '\P{^Is_Nv=0.5}', "");
    Expect(0, 126269, '\p{Is_Nv=0.5}', "");
    Expect(1, 126269, '\p{^Is_Nv=0.5}', "");
    Expect(1, 126269, '\P{Is_Nv=0.5}', "");
    Expect(0, 126269, '\P{^Is_Nv=0.5}', "");
    Expect(1, 126268, '\p{Is_Nv=5.00e-01}', "");
    Expect(0, 126268, '\p{^Is_Nv=5.00e-01}', "");
    Expect(0, 126268, '\P{Is_Nv=5.00e-01}', "");
    Expect(1, 126268, '\P{^Is_Nv=5.00e-01}', "");
    Expect(0, 126269, '\p{Is_Nv=5.00e-01}', "");
    Expect(1, 126269, '\p{^Is_Nv=5.00e-01}', "");
    Expect(1, 126269, '\P{Is_Nv=5.00e-01}', "");
    Expect(0, 126269, '\P{^Is_Nv=5.00e-01}', "");
    Expect(1, 126268, '\p{Is_Nv:   0.50}', "");
    Expect(0, 126268, '\p{^Is_Nv:   0.50}', "");
    Expect(0, 126268, '\P{Is_Nv:   0.50}', "");
    Expect(1, 126268, '\P{^Is_Nv:   0.50}', "");
    Expect(0, 126269, '\p{Is_Nv:   0.50}', "");
    Expect(1, 126269, '\p{^Is_Nv:   0.50}', "");
    Expect(1, 126269, '\P{Is_Nv:   0.50}', "");
    Expect(0, 126269, '\P{^Is_Nv:   0.50}', "");
    Error('\p{Numeric_Value=:= 	1/00000000020}');
    Error('\P{Numeric_Value=:= 	1/00000000020}');
    Expect(1, 73672, '\p{Numeric_Value=:\A1/20\z:}', "");;
    Expect(0, 73673, '\p{Numeric_Value=:\A1/20\z:}', "");;
    Expect(1, 73672, '\p{Numeric_Value=+001/00020}', "");
    Expect(0, 73672, '\p{^Numeric_Value=+001/00020}', "");
    Expect(0, 73672, '\P{Numeric_Value=+001/00020}', "");
    Expect(1, 73672, '\P{^Numeric_Value=+001/00020}', "");
    Expect(0, 73673, '\p{Numeric_Value=+001/00020}', "");
    Expect(1, 73673, '\p{^Numeric_Value=+001/00020}', "");
    Expect(1, 73673, '\P{Numeric_Value=+001/00020}', "");
    Expect(0, 73673, '\P{^Numeric_Value=+001/00020}', "");
    Expect(1, 73672, '\p{Numeric_Value=60/1200}', "");
    Expect(0, 73672, '\p{^Numeric_Value=60/1200}', "");
    Expect(0, 73672, '\P{Numeric_Value=60/1200}', "");
    Expect(1, 73672, '\P{^Numeric_Value=60/1200}', "");
    Expect(0, 73673, '\p{Numeric_Value=60/1200}', "");
    Expect(1, 73673, '\p{^Numeric_Value=60/1200}', "");
    Expect(1, 73673, '\P{Numeric_Value=60/1200}', "");
    Expect(0, 73673, '\P{^Numeric_Value=60/1200}', "");
    Expect(1, 73672, '\p{Numeric_Value=5.0e-02}', "");
    Expect(0, 73672, '\p{^Numeric_Value=5.0e-02}', "");
    Expect(0, 73672, '\P{Numeric_Value=5.0e-02}', "");
    Expect(1, 73672, '\P{^Numeric_Value=5.0e-02}', "");
    Expect(0, 73673, '\p{Numeric_Value=5.0e-02}', "");
    Expect(1, 73673, '\p{^Numeric_Value=5.0e-02}', "");
    Expect(1, 73673, '\P{Numeric_Value=5.0e-02}', "");
    Expect(0, 73673, '\P{^Numeric_Value=5.0e-02}', "");
    Expect(1, 73672, '\p{Numeric_Value=5.00e-02}', "");
    Expect(0, 73672, '\p{^Numeric_Value=5.00e-02}', "");
    Expect(0, 73672, '\P{Numeric_Value=5.00e-02}', "");
    Expect(1, 73672, '\P{^Numeric_Value=5.00e-02}', "");
    Expect(0, 73673, '\p{Numeric_Value=5.00e-02}', "");
    Expect(1, 73673, '\p{^Numeric_Value=5.00e-02}', "");
    Expect(1, 73673, '\P{Numeric_Value=5.00e-02}', "");
    Expect(0, 73673, '\P{^Numeric_Value=5.00e-02}', "");
    Expect(1, 73672, '\p{Numeric_Value=0.05}', "");
    Expect(0, 73672, '\p{^Numeric_Value=0.05}', "");
    Expect(0, 73672, '\P{Numeric_Value=0.05}', "");
    Expect(1, 73672, '\P{^Numeric_Value=0.05}', "");
    Expect(0, 73673, '\p{Numeric_Value=0.05}', "");
    Expect(1, 73673, '\p{^Numeric_Value=0.05}', "");
    Expect(1, 73673, '\P{Numeric_Value=0.05}', "");
    Expect(0, 73673, '\P{^Numeric_Value=0.05}', "");
    Expect(1, 73672, '\p{Numeric_Value=5.000e-02}', "");
    Expect(0, 73672, '\p{^Numeric_Value=5.000e-02}', "");
    Expect(0, 73672, '\P{Numeric_Value=5.000e-02}', "");
    Expect(1, 73672, '\P{^Numeric_Value=5.000e-02}', "");
    Expect(0, 73673, '\p{Numeric_Value=5.000e-02}', "");
    Expect(1, 73673, '\p{^Numeric_Value=5.000e-02}', "");
    Expect(1, 73673, '\P{Numeric_Value=5.000e-02}', "");
    Expect(0, 73673, '\P{^Numeric_Value=5.000e-02}', "");
    Expect(1, 73672, '\p{Numeric_Value=0.050}', "");
    Expect(0, 73672, '\p{^Numeric_Value=0.050}', "");
    Expect(0, 73672, '\P{Numeric_Value=0.050}', "");
    Expect(1, 73672, '\P{^Numeric_Value=0.050}', "");
    Expect(0, 73673, '\p{Numeric_Value=0.050}', "");
    Expect(1, 73673, '\p{^Numeric_Value=0.050}', "");
    Expect(1, 73673, '\P{Numeric_Value=0.050}', "");
    Expect(0, 73673, '\P{^Numeric_Value=0.050}', "");
    Error('\p{Nv=/a/0001/00000020}');
    Error('\P{Nv=/a/0001/00000020}');
    Expect(1, 73672, '\p{Nv=:\A1/20\z:}', "");;
    Expect(0, 73673, '\p{Nv=:\A1/20\z:}', "");;
    Expect(1, 73672, '\p{Nv=+0000001/000020}', "");
    Expect(0, 73672, '\p{^Nv=+0000001/000020}', "");
    Expect(0, 73672, '\P{Nv=+0000001/000020}', "");
    Expect(1, 73672, '\P{^Nv=+0000001/000020}', "");
    Expect(0, 73673, '\p{Nv=+0000001/000020}', "");
    Expect(1, 73673, '\p{^Nv=+0000001/000020}', "");
    Expect(1, 73673, '\P{Nv=+0000001/000020}', "");
    Expect(0, 73673, '\P{^Nv=+0000001/000020}', "");
    Expect(1, 73672, '\p{Nv=60/1200}', "");
    Expect(0, 73672, '\p{^Nv=60/1200}', "");
    Expect(0, 73672, '\P{Nv=60/1200}', "");
    Expect(1, 73672, '\P{^Nv=60/1200}', "");
    Expect(0, 73673, '\p{Nv=60/1200}', "");
    Expect(1, 73673, '\p{^Nv=60/1200}', "");
    Expect(1, 73673, '\P{Nv=60/1200}', "");
    Expect(0, 73673, '\P{^Nv=60/1200}', "");
    Expect(1, 73672, '\p{Nv=5.0e-02}', "");
    Expect(0, 73672, '\p{^Nv=5.0e-02}', "");
    Expect(0, 73672, '\P{Nv=5.0e-02}', "");
    Expect(1, 73672, '\P{^Nv=5.0e-02}', "");
    Expect(0, 73673, '\p{Nv=5.0e-02}', "");
    Expect(1, 73673, '\p{^Nv=5.0e-02}', "");
    Expect(1, 73673, '\P{Nv=5.0e-02}', "");
    Expect(0, 73673, '\P{^Nv=5.0e-02}', "");
    Expect(1, 73672, '\p{Nv=5.00e-02}', "");
    Expect(0, 73672, '\p{^Nv=5.00e-02}', "");
    Expect(0, 73672, '\P{Nv=5.00e-02}', "");
    Expect(1, 73672, '\P{^Nv=5.00e-02}', "");
    Expect(0, 73673, '\p{Nv=5.00e-02}', "");
    Expect(1, 73673, '\p{^Nv=5.00e-02}', "");
    Expect(1, 73673, '\P{Nv=5.00e-02}', "");
    Expect(0, 73673, '\P{^Nv=5.00e-02}', "");
    Expect(1, 73672, '\p{Nv=0.05}', "");
    Expect(0, 73672, '\p{^Nv=0.05}', "");
    Expect(0, 73672, '\P{Nv=0.05}', "");
    Expect(1, 73672, '\P{^Nv=0.05}', "");
    Expect(0, 73673, '\p{Nv=0.05}', "");
    Expect(1, 73673, '\p{^Nv=0.05}', "");
    Expect(1, 73673, '\P{Nv=0.05}', "");
    Expect(0, 73673, '\P{^Nv=0.05}', "");
    Expect(1, 73672, '\p{Nv=5.000e-02}', "");
    Expect(0, 73672, '\p{^Nv=5.000e-02}', "");
    Expect(0, 73672, '\P{Nv=5.000e-02}', "");
    Expect(1, 73672, '\P{^Nv=5.000e-02}', "");
    Expect(0, 73673, '\p{Nv=5.000e-02}', "");
    Expect(1, 73673, '\p{^Nv=5.000e-02}', "");
    Expect(1, 73673, '\P{Nv=5.000e-02}', "");
    Expect(0, 73673, '\P{^Nv=5.000e-02}', "");
    Expect(1, 73672, '\p{Nv=0.050}', "");
    Expect(0, 73672, '\p{^Nv=0.050}', "");
    Expect(0, 73672, '\P{Nv=0.050}', "");
    Expect(1, 73672, '\P{^Nv=0.050}', "");
    Expect(0, 73673, '\p{Nv=0.050}', "");
    Expect(1, 73673, '\p{^Nv=0.050}', "");
    Expect(1, 73673, '\P{Nv=0.050}', "");
    Expect(0, 73673, '\P{^Nv=0.050}', "");
    Error('\p{Is_Numeric_Value=/a/00001/00000020}');
    Error('\P{Is_Numeric_Value=/a/00001/00000020}');
    Expect(1, 73672, '\p{Is_Numeric_Value=+1/000000020}', "");
    Expect(0, 73672, '\p{^Is_Numeric_Value=+1/000000020}', "");
    Expect(0, 73672, '\P{Is_Numeric_Value=+1/000000020}', "");
    Expect(1, 73672, '\P{^Is_Numeric_Value=+1/000000020}', "");
    Expect(0, 73673, '\p{Is_Numeric_Value=+1/000000020}', "");
    Expect(1, 73673, '\p{^Is_Numeric_Value=+1/000000020}', "");
    Expect(1, 73673, '\P{Is_Numeric_Value=+1/000000020}', "");
    Expect(0, 73673, '\P{^Is_Numeric_Value=+1/000000020}', "");
    Expect(1, 73672, '\p{Is_Numeric_Value=60/1200}', "");
    Expect(0, 73672, '\p{^Is_Numeric_Value=60/1200}', "");
    Expect(0, 73672, '\P{Is_Numeric_Value=60/1200}', "");
    Expect(1, 73672, '\P{^Is_Numeric_Value=60/1200}', "");
    Expect(0, 73673, '\p{Is_Numeric_Value=60/1200}', "");
    Expect(1, 73673, '\p{^Is_Numeric_Value=60/1200}', "");
    Expect(1, 73673, '\P{Is_Numeric_Value=60/1200}', "");
    Expect(0, 73673, '\P{^Is_Numeric_Value=60/1200}', "");
    Expect(1, 73672, '\p{Is_Numeric_Value:	5.0e-02}', "");
    Expect(0, 73672, '\p{^Is_Numeric_Value:	5.0e-02}', "");
    Expect(0, 73672, '\P{Is_Numeric_Value:	5.0e-02}', "");
    Expect(1, 73672, '\P{^Is_Numeric_Value:	5.0e-02}', "");
    Expect(0, 73673, '\p{Is_Numeric_Value:	5.0e-02}', "");
    Expect(1, 73673, '\p{^Is_Numeric_Value:	5.0e-02}', "");
    Expect(1, 73673, '\P{Is_Numeric_Value:	5.0e-02}', "");
    Expect(0, 73673, '\P{^Is_Numeric_Value:	5.0e-02}', "");
    Expect(1, 73672, '\p{Is_Numeric_Value=5.00e-02}', "");
    Expect(0, 73672, '\p{^Is_Numeric_Value=5.00e-02}', "");
    Expect(0, 73672, '\P{Is_Numeric_Value=5.00e-02}', "");
    Expect(1, 73672, '\P{^Is_Numeric_Value=5.00e-02}', "");
    Expect(0, 73673, '\p{Is_Numeric_Value=5.00e-02}', "");
    Expect(1, 73673, '\p{^Is_Numeric_Value=5.00e-02}', "");
    Expect(1, 73673, '\P{Is_Numeric_Value=5.00e-02}', "");
    Expect(0, 73673, '\P{^Is_Numeric_Value=5.00e-02}', "");
    Expect(1, 73672, '\p{Is_Numeric_Value=0.05}', "");
    Expect(0, 73672, '\p{^Is_Numeric_Value=0.05}', "");
    Expect(0, 73672, '\P{Is_Numeric_Value=0.05}', "");
    Expect(1, 73672, '\P{^Is_Numeric_Value=0.05}', "");
    Expect(0, 73673, '\p{Is_Numeric_Value=0.05}', "");
    Expect(1, 73673, '\p{^Is_Numeric_Value=0.05}', "");
    Expect(1, 73673, '\P{Is_Numeric_Value=0.05}', "");
    Expect(0, 73673, '\P{^Is_Numeric_Value=0.05}', "");
    Expect(1, 73672, '\p{Is_Numeric_Value:   5.000e-02}', "");
    Expect(0, 73672, '\p{^Is_Numeric_Value:   5.000e-02}', "");
    Expect(0, 73672, '\P{Is_Numeric_Value:   5.000e-02}', "");
    Expect(1, 73672, '\P{^Is_Numeric_Value:   5.000e-02}', "");
    Expect(0, 73673, '\p{Is_Numeric_Value:   5.000e-02}', "");
    Expect(1, 73673, '\p{^Is_Numeric_Value:   5.000e-02}', "");
    Expect(1, 73673, '\P{Is_Numeric_Value:   5.000e-02}', "");
    Expect(0, 73673, '\P{^Is_Numeric_Value:   5.000e-02}', "");
    Expect(1, 73672, '\p{Is_Numeric_Value:	0.050}', "");
    Expect(0, 73672, '\p{^Is_Numeric_Value:	0.050}', "");
    Expect(0, 73672, '\P{Is_Numeric_Value:	0.050}', "");
    Expect(1, 73672, '\P{^Is_Numeric_Value:	0.050}', "");
    Expect(0, 73673, '\p{Is_Numeric_Value:	0.050}', "");
    Expect(1, 73673, '\p{^Is_Numeric_Value:	0.050}', "");
    Expect(1, 73673, '\P{Is_Numeric_Value:	0.050}', "");
    Expect(0, 73673, '\P{^Is_Numeric_Value:	0.050}', "");
    Error('\p{Is_Nv=/a/	_+001/0000020}');
    Error('\P{Is_Nv=/a/	_+001/0000020}');
    Expect(1, 73672, '\p{Is_Nv=+0000001/000020}', "");
    Expect(0, 73672, '\p{^Is_Nv=+0000001/000020}', "");
    Expect(0, 73672, '\P{Is_Nv=+0000001/000020}', "");
    Expect(1, 73672, '\P{^Is_Nv=+0000001/000020}', "");
    Expect(0, 73673, '\p{Is_Nv=+0000001/000020}', "");
    Expect(1, 73673, '\p{^Is_Nv=+0000001/000020}', "");
    Expect(1, 73673, '\P{Is_Nv=+0000001/000020}', "");
    Expect(0, 73673, '\P{^Is_Nv=+0000001/000020}', "");
    Expect(1, 73672, '\p{Is_Nv=60/1200}', "");
    Expect(0, 73672, '\p{^Is_Nv=60/1200}', "");
    Expect(0, 73672, '\P{Is_Nv=60/1200}', "");
    Expect(1, 73672, '\P{^Is_Nv=60/1200}', "");
    Expect(0, 73673, '\p{Is_Nv=60/1200}', "");
    Expect(1, 73673, '\p{^Is_Nv=60/1200}', "");
    Expect(1, 73673, '\P{Is_Nv=60/1200}', "");
    Expect(0, 73673, '\P{^Is_Nv=60/1200}', "");
    Expect(1, 73672, '\p{Is_Nv=5.0e-02}', "");
    Expect(0, 73672, '\p{^Is_Nv=5.0e-02}', "");
    Expect(0, 73672, '\P{Is_Nv=5.0e-02}', "");
    Expect(1, 73672, '\P{^Is_Nv=5.0e-02}', "");
    Expect(0, 73673, '\p{Is_Nv=5.0e-02}', "");
    Expect(1, 73673, '\p{^Is_Nv=5.0e-02}', "");
    Expect(1, 73673, '\P{Is_Nv=5.0e-02}', "");
    Expect(0, 73673, '\P{^Is_Nv=5.0e-02}', "");
    Expect(1, 73672, '\p{Is_Nv=5.00e-02}', "");
    Expect(0, 73672, '\p{^Is_Nv=5.00e-02}', "");
    Expect(0, 73672, '\P{Is_Nv=5.00e-02}', "");
    Expect(1, 73672, '\P{^Is_Nv=5.00e-02}', "");
    Expect(0, 73673, '\p{Is_Nv=5.00e-02}', "");
    Expect(1, 73673, '\p{^Is_Nv=5.00e-02}', "");
    Expect(1, 73673, '\P{Is_Nv=5.00e-02}', "");
    Expect(0, 73673, '\P{^Is_Nv=5.00e-02}', "");
    Expect(1, 73672, '\p{Is_Nv=0.05}', "");
    Expect(0, 73672, '\p{^Is_Nv=0.05}', "");
    Expect(0, 73672, '\P{Is_Nv=0.05}', "");
    Expect(1, 73672, '\P{^Is_Nv=0.05}', "");
    Expect(0, 73673, '\p{Is_Nv=0.05}', "");
    Expect(1, 73673, '\p{^Is_Nv=0.05}', "");
    Expect(1, 73673, '\P{Is_Nv=0.05}', "");
    Expect(0, 73673, '\P{^Is_Nv=0.05}', "");
    Expect(1, 73672, '\p{Is_Nv:5.000e-02}', "");
    Expect(0, 73672, '\p{^Is_Nv:5.000e-02}', "");
    Expect(0, 73672, '\P{Is_Nv:5.000e-02}', "");
    Expect(1, 73672, '\P{^Is_Nv:5.000e-02}', "");
    Expect(0, 73673, '\p{Is_Nv:5.000e-02}', "");
    Expect(1, 73673, '\p{^Is_Nv:5.000e-02}', "");
    Expect(1, 73673, '\P{Is_Nv:5.000e-02}', "");
    Expect(0, 73673, '\P{^Is_Nv:5.000e-02}', "");
    Expect(1, 73672, '\p{Is_Nv=0.050}', "");
    Expect(0, 73672, '\p{^Is_Nv=0.050}', "");
    Expect(0, 73672, '\P{Is_Nv=0.050}', "");
    Expect(1, 73672, '\P{^Is_Nv=0.050}', "");
    Expect(0, 73673, '\p{Is_Nv=0.050}', "");
    Expect(1, 73673, '\p{^Is_Nv=0.050}', "");
    Expect(1, 73673, '\P{Is_Nv=0.050}', "");
    Expect(0, 73673, '\P{^Is_Nv=0.050}', "");
    Error('\p{Numeric_Value:	 :=000001/00003}');
    Error('\P{Numeric_Value:	 :=000001/00003}');
    Expect(1, 74853, '\p{Numeric_Value=:\A1/3\z:}', "");;
    Expect(0, 74854, '\p{Numeric_Value=:\A1/3\z:}', "");;
    Expect(1, 74853, '\p{Numeric_Value=1/0000003}', "");
    Expect(0, 74853, '\p{^Numeric_Value=1/0000003}', "");
    Expect(0, 74853, '\P{Numeric_Value=1/0000003}', "");
    Expect(1, 74853, '\P{^Numeric_Value=1/0000003}', "");
    Expect(0, 74854, '\p{Numeric_Value=1/0000003}', "");
    Expect(1, 74854, '\p{^Numeric_Value=1/0000003}', "");
    Expect(1, 74854, '\P{Numeric_Value=1/0000003}', "");
    Expect(0, 74854, '\P{^Numeric_Value=1/0000003}', "");
    Expect(1, 74853, '\p{Numeric_Value=60/180}', "");
    Expect(0, 74853, '\p{^Numeric_Value=60/180}', "");
    Expect(0, 74853, '\P{Numeric_Value=60/180}', "");
    Expect(1, 74853, '\P{^Numeric_Value=60/180}', "");
    Expect(0, 74854, '\p{Numeric_Value=60/180}', "");
    Expect(1, 74854, '\p{^Numeric_Value=60/180}', "");
    Expect(1, 74854, '\P{Numeric_Value=60/180}', "");
    Expect(0, 74854, '\P{^Numeric_Value=60/180}', "");
    Error('\p{Numeric_Value:   3.3e-01}');
    Error('\P{Numeric_Value:   3.3e-01}');
    Error('\p{Numeric_Value=0.3}');
    Error('\P{Numeric_Value=0.3}');
    Error('\p{Numeric_Value=3.33e-01}');
    Error('\P{Numeric_Value=3.33e-01}');
    Error('\p{Numeric_Value=0.33}');
    Error('\P{Numeric_Value=0.33}');
    Expect(1, 74853, '\p{Numeric_Value=3.333e-01}', "");
    Expect(0, 74853, '\p{^Numeric_Value=3.333e-01}', "");
    Expect(0, 74853, '\P{Numeric_Value=3.333e-01}', "");
    Expect(1, 74853, '\P{^Numeric_Value=3.333e-01}', "");
    Expect(0, 74854, '\p{Numeric_Value=3.333e-01}', "");
    Expect(1, 74854, '\p{^Numeric_Value=3.333e-01}', "");
    Expect(1, 74854, '\P{Numeric_Value=3.333e-01}', "");
    Expect(0, 74854, '\P{^Numeric_Value=3.333e-01}', "");
    Error('\p{Numeric_Value: 0.333}');
    Error('\P{Numeric_Value: 0.333}');
    Expect(1, 74853, '\p{Numeric_Value:   3.3333e-01}', "");
    Expect(0, 74853, '\p{^Numeric_Value:   3.3333e-01}', "");
    Expect(0, 74853, '\P{Numeric_Value:   3.3333e-01}', "");
    Expect(1, 74853, '\P{^Numeric_Value:   3.3333e-01}', "");
    Expect(0, 74854, '\p{Numeric_Value:   3.3333e-01}', "");
    Expect(1, 74854, '\p{^Numeric_Value:   3.3333e-01}', "");
    Expect(1, 74854, '\P{Numeric_Value:   3.3333e-01}', "");
    Expect(0, 74854, '\P{^Numeric_Value:   3.3333e-01}', "");
    Expect(1, 74853, '\p{Numeric_Value=0.3333}', "");
    Expect(0, 74853, '\p{^Numeric_Value=0.3333}', "");
    Expect(0, 74853, '\P{Numeric_Value=0.3333}', "");
    Expect(1, 74853, '\P{^Numeric_Value=0.3333}', "");
    Expect(0, 74854, '\p{Numeric_Value=0.3333}', "");
    Expect(1, 74854, '\p{^Numeric_Value=0.3333}', "");
    Expect(1, 74854, '\P{Numeric_Value=0.3333}', "");
    Expect(0, 74854, '\P{^Numeric_Value=0.3333}', "");
    Expect(1, 74853, '\p{Numeric_Value=3.33333e-01}', "");
    Expect(0, 74853, '\p{^Numeric_Value=3.33333e-01}', "");
    Expect(0, 74853, '\P{Numeric_Value=3.33333e-01}', "");
    Expect(1, 74853, '\P{^Numeric_Value=3.33333e-01}', "");
    Expect(0, 74854, '\p{Numeric_Value=3.33333e-01}', "");
    Expect(1, 74854, '\p{^Numeric_Value=3.33333e-01}', "");
    Expect(1, 74854, '\P{Numeric_Value=3.33333e-01}', "");
    Expect(0, 74854, '\P{^Numeric_Value=3.33333e-01}', "");
    Expect(1, 74853, '\p{Numeric_Value=0.33333}', "");
    Expect(0, 74853, '\p{^Numeric_Value=0.33333}', "");
    Expect(0, 74853, '\P{Numeric_Value=0.33333}', "");
    Expect(1, 74853, '\P{^Numeric_Value=0.33333}', "");
    Expect(0, 74854, '\p{Numeric_Value=0.33333}', "");
    Expect(1, 74854, '\p{^Numeric_Value=0.33333}', "");
    Expect(1, 74854, '\P{Numeric_Value=0.33333}', "");
    Expect(0, 74854, '\P{^Numeric_Value=0.33333}', "");
    Error('\p{Nv=/a/_	+000001/00000003}');
    Error('\P{Nv=/a/_	+000001/00000003}');
    Expect(1, 74853, '\p{Nv=:\A1/3\z:}', "");;
    Expect(0, 74854, '\p{Nv=:\A1/3\z:}', "");;
    Expect(1, 74853, '\p{Nv:   0000001/03}', "");
    Expect(0, 74853, '\p{^Nv:   0000001/03}', "");
    Expect(0, 74853, '\P{Nv:   0000001/03}', "");
    Expect(1, 74853, '\P{^Nv:   0000001/03}', "");
    Expect(0, 74854, '\p{Nv:   0000001/03}', "");
    Expect(1, 74854, '\p{^Nv:   0000001/03}', "");
    Expect(1, 74854, '\P{Nv:   0000001/03}', "");
    Expect(0, 74854, '\P{^Nv:   0000001/03}', "");
    Expect(1, 74853, '\p{Nv: 60/180}', "");
    Expect(0, 74853, '\p{^Nv: 60/180}', "");
    Expect(0, 74853, '\P{Nv: 60/180}', "");
    Expect(1, 74853, '\P{^Nv: 60/180}', "");
    Expect(0, 74854, '\p{Nv: 60/180}', "");
    Expect(1, 74854, '\p{^Nv: 60/180}', "");
    Expect(1, 74854, '\P{Nv: 60/180}', "");
    Expect(0, 74854, '\P{^Nv: 60/180}', "");
    Error('\p{Nv=3.3e-01}');
    Error('\P{Nv=3.3e-01}');
    Error('\p{Nv=0.3}');
    Error('\P{Nv=0.3}');
    Error('\p{Nv: 3.33e-01}');
    Error('\P{Nv: 3.33e-01}');
    Error('\p{Nv=0.33}');
    Error('\P{Nv=0.33}');
    Expect(1, 74853, '\p{Nv: 3.333e-01}', "");
    Expect(0, 74853, '\p{^Nv: 3.333e-01}', "");
    Expect(0, 74853, '\P{Nv: 3.333e-01}', "");
    Expect(1, 74853, '\P{^Nv: 3.333e-01}', "");
    Expect(0, 74854, '\p{Nv: 3.333e-01}', "");
    Expect(1, 74854, '\p{^Nv: 3.333e-01}', "");
    Expect(1, 74854, '\P{Nv: 3.333e-01}', "");
    Expect(0, 74854, '\P{^Nv: 3.333e-01}', "");
    Error('\p{Nv=0.333}');
    Error('\P{Nv=0.333}');
    Expect(1, 74853, '\p{Nv=3.3333e-01}', "");
    Expect(0, 74853, '\p{^Nv=3.3333e-01}', "");
    Expect(0, 74853, '\P{Nv=3.3333e-01}', "");
    Expect(1, 74853, '\P{^Nv=3.3333e-01}', "");
    Expect(0, 74854, '\p{Nv=3.3333e-01}', "");
    Expect(1, 74854, '\p{^Nv=3.3333e-01}', "");
    Expect(1, 74854, '\P{Nv=3.3333e-01}', "");
    Expect(0, 74854, '\P{^Nv=3.3333e-01}', "");
    Expect(1, 74853, '\p{Nv:	0.3333}', "");
    Expect(0, 74853, '\p{^Nv:	0.3333}', "");
    Expect(0, 74853, '\P{Nv:	0.3333}', "");
    Expect(1, 74853, '\P{^Nv:	0.3333}', "");
    Expect(0, 74854, '\p{Nv:	0.3333}', "");
    Expect(1, 74854, '\p{^Nv:	0.3333}', "");
    Expect(1, 74854, '\P{Nv:	0.3333}', "");
    Expect(0, 74854, '\P{^Nv:	0.3333}', "");
    Expect(1, 74853, '\p{Nv=3.33333e-01}', "");
    Expect(0, 74853, '\p{^Nv=3.33333e-01}', "");
    Expect(0, 74853, '\P{Nv=3.33333e-01}', "");
    Expect(1, 74853, '\P{^Nv=3.33333e-01}', "");
    Expect(0, 74854, '\p{Nv=3.33333e-01}', "");
    Expect(1, 74854, '\p{^Nv=3.33333e-01}', "");
    Expect(1, 74854, '\P{Nv=3.33333e-01}', "");
    Expect(0, 74854, '\P{^Nv=3.33333e-01}', "");
    Expect(1, 74853, '\p{Nv: 0.33333}', "");
    Expect(0, 74853, '\p{^Nv: 0.33333}', "");
    Expect(0, 74853, '\P{Nv: 0.33333}', "");
    Expect(1, 74853, '\P{^Nv: 0.33333}', "");
    Expect(0, 74854, '\p{Nv: 0.33333}', "");
    Expect(1, 74854, '\p{^Nv: 0.33333}', "");
    Expect(1, 74854, '\P{Nv: 0.33333}', "");
    Expect(0, 74854, '\P{^Nv: 0.33333}', "");
    Error('\p{Is_Numeric_Value=-/a/0000001/0003}');
    Error('\P{Is_Numeric_Value=-/a/0000001/0003}');
    Expect(1, 74853, '\p{Is_Numeric_Value=0000000001/0000000003}', "");
    Expect(0, 74853, '\p{^Is_Numeric_Value=0000000001/0000000003}', "");
    Expect(0, 74853, '\P{Is_Numeric_Value=0000000001/0000000003}', "");
    Expect(1, 74853, '\P{^Is_Numeric_Value=0000000001/0000000003}', "");
    Expect(0, 74854, '\p{Is_Numeric_Value=0000000001/0000000003}', "");
    Expect(1, 74854, '\p{^Is_Numeric_Value=0000000001/0000000003}', "");
    Expect(1, 74854, '\P{Is_Numeric_Value=0000000001/0000000003}', "");
    Expect(0, 74854, '\P{^Is_Numeric_Value=0000000001/0000000003}', "");
    Expect(1, 74853, '\p{Is_Numeric_Value=60/180}', "");
    Expect(0, 74853, '\p{^Is_Numeric_Value=60/180}', "");
    Expect(0, 74853, '\P{Is_Numeric_Value=60/180}', "");
    Expect(1, 74853, '\P{^Is_Numeric_Value=60/180}', "");
    Expect(0, 74854, '\p{Is_Numeric_Value=60/180}', "");
    Expect(1, 74854, '\p{^Is_Numeric_Value=60/180}', "");
    Expect(1, 74854, '\P{Is_Numeric_Value=60/180}', "");
    Expect(0, 74854, '\P{^Is_Numeric_Value=60/180}', "");
    Error('\p{Is_Numeric_Value=3.3e-01}');
    Error('\P{Is_Numeric_Value=3.3e-01}');
    Error('\p{Is_Numeric_Value=0.3}');
    Error('\P{Is_Numeric_Value=0.3}');
    Error('\p{Is_Numeric_Value=3.33e-01}');
    Error('\P{Is_Numeric_Value=3.33e-01}');
    Error('\p{Is_Numeric_Value: 0.33}');
    Error('\P{Is_Numeric_Value: 0.33}');
    Expect(1, 74853, '\p{Is_Numeric_Value=3.333e-01}', "");
    Expect(0, 74853, '\p{^Is_Numeric_Value=3.333e-01}', "");
    Expect(0, 74853, '\P{Is_Numeric_Value=3.333e-01}', "");
    Expect(1, 74853, '\P{^Is_Numeric_Value=3.333e-01}', "");
    Expect(0, 74854, '\p{Is_Numeric_Value=3.333e-01}', "");
    Expect(1, 74854, '\p{^Is_Numeric_Value=3.333e-01}', "");
    Expect(1, 74854, '\P{Is_Numeric_Value=3.333e-01}', "");
    Expect(0, 74854, '\P{^Is_Numeric_Value=3.333e-01}', "");
    Error('\p{Is_Numeric_Value=0.333}');
    Error('\P{Is_Numeric_Value=0.333}');
    Expect(1, 74853, '\p{Is_Numeric_Value:   3.3333e-01}', "");
    Expect(0, 74853, '\p{^Is_Numeric_Value:   3.3333e-01}', "");
    Expect(0, 74853, '\P{Is_Numeric_Value:   3.3333e-01}', "");
    Expect(1, 74853, '\P{^Is_Numeric_Value:   3.3333e-01}', "");
    Expect(0, 74854, '\p{Is_Numeric_Value:   3.3333e-01}', "");
    Expect(1, 74854, '\p{^Is_Numeric_Value:   3.3333e-01}', "");
    Expect(1, 74854, '\P{Is_Numeric_Value:   3.3333e-01}', "");
    Expect(0, 74854, '\P{^Is_Numeric_Value:   3.3333e-01}', "");
    Expect(1, 74853, '\p{Is_Numeric_Value=0.3333}', "");
    Expect(0, 74853, '\p{^Is_Numeric_Value=0.3333}', "");
    Expect(0, 74853, '\P{Is_Numeric_Value=0.3333}', "");
    Expect(1, 74853, '\P{^Is_Numeric_Value=0.3333}', "");
    Expect(0, 74854, '\p{Is_Numeric_Value=0.3333}', "");
    Expect(1, 74854, '\p{^Is_Numeric_Value=0.3333}', "");
    Expect(1, 74854, '\P{Is_Numeric_Value=0.3333}', "");
    Expect(0, 74854, '\P{^Is_Numeric_Value=0.3333}', "");
    Expect(1, 74853, '\p{Is_Numeric_Value=3.33333e-01}', "");
    Expect(0, 74853, '\p{^Is_Numeric_Value=3.33333e-01}', "");
    Expect(0, 74853, '\P{Is_Numeric_Value=3.33333e-01}', "");
    Expect(1, 74853, '\P{^Is_Numeric_Value=3.33333e-01}', "");
    Expect(0, 74854, '\p{Is_Numeric_Value=3.33333e-01}', "");
    Expect(1, 74854, '\p{^Is_Numeric_Value=3.33333e-01}', "");
    Expect(1, 74854, '\P{Is_Numeric_Value=3.33333e-01}', "");
    Expect(0, 74854, '\P{^Is_Numeric_Value=3.33333e-01}', "");
    Expect(1, 74853, '\p{Is_Numeric_Value:   0.33333}', "");
    Expect(0, 74853, '\p{^Is_Numeric_Value:   0.33333}', "");
    Expect(0, 74853, '\P{Is_Numeric_Value:   0.33333}', "");
    Expect(1, 74853, '\P{^Is_Numeric_Value:   0.33333}', "");
    Expect(0, 74854, '\p{Is_Numeric_Value:   0.33333}', "");
    Expect(1, 74854, '\p{^Is_Numeric_Value:   0.33333}', "");
    Expect(1, 74854, '\P{Is_Numeric_Value:   0.33333}', "");
    Expect(0, 74854, '\P{^Is_Numeric_Value:   0.33333}', "");
    Error('\p{Is_Nv= :=00001/000000003}');
    Error('\P{Is_Nv= :=00001/000000003}');
    Expect(1, 74853, '\p{Is_Nv=1/00000003}', "");
    Expect(0, 74853, '\p{^Is_Nv=1/00000003}', "");
    Expect(0, 74853, '\P{Is_Nv=1/00000003}', "");
    Expect(1, 74853, '\P{^Is_Nv=1/00000003}', "");
    Expect(0, 74854, '\p{Is_Nv=1/00000003}', "");
    Expect(1, 74854, '\p{^Is_Nv=1/00000003}', "");
    Expect(1, 74854, '\P{Is_Nv=1/00000003}', "");
    Expect(0, 74854, '\P{^Is_Nv=1/00000003}', "");
    Expect(1, 74853, '\p{Is_Nv=60/180}', "");
    Expect(0, 74853, '\p{^Is_Nv=60/180}', "");
    Expect(0, 74853, '\P{Is_Nv=60/180}', "");
    Expect(1, 74853, '\P{^Is_Nv=60/180}', "");
    Expect(0, 74854, '\p{Is_Nv=60/180}', "");
    Expect(1, 74854, '\p{^Is_Nv=60/180}', "");
    Expect(1, 74854, '\P{Is_Nv=60/180}', "");
    Expect(0, 74854, '\P{^Is_Nv=60/180}', "");
    Error('\p{Is_Nv:3.3e-01}');
    Error('\P{Is_Nv:3.3e-01}');
    Error('\p{Is_Nv=0.3}');
    Error('\P{Is_Nv=0.3}');
    Error('\p{Is_Nv=3.33e-01}');
    Error('\P{Is_Nv=3.33e-01}');
    Error('\p{Is_Nv=0.33}');
    Error('\P{Is_Nv=0.33}');
    Expect(1, 74853, '\p{Is_Nv=3.333e-01}', "");
    Expect(0, 74853, '\p{^Is_Nv=3.333e-01}', "");
    Expect(0, 74853, '\P{Is_Nv=3.333e-01}', "");
    Expect(1, 74853, '\P{^Is_Nv=3.333e-01}', "");
    Expect(0, 74854, '\p{Is_Nv=3.333e-01}', "");
    Expect(1, 74854, '\p{^Is_Nv=3.333e-01}', "");
    Expect(1, 74854, '\P{Is_Nv=3.333e-01}', "");
    Expect(0, 74854, '\P{^Is_Nv=3.333e-01}', "");
    Error('\p{Is_Nv: 0.333}');
    Error('\P{Is_Nv: 0.333}');
    Expect(1, 74853, '\p{Is_Nv=3.3333e-01}', "");
    Expect(0, 74853, '\p{^Is_Nv=3.3333e-01}', "");
    Expect(0, 74853, '\P{Is_Nv=3.3333e-01}', "");
    Expect(1, 74853, '\P{^Is_Nv=3.3333e-01}', "");
    Expect(0, 74854, '\p{Is_Nv=3.3333e-01}', "");
    Expect(1, 74854, '\p{^Is_Nv=3.3333e-01}', "");
    Expect(1, 74854, '\P{Is_Nv=3.3333e-01}', "");
    Expect(0, 74854, '\P{^Is_Nv=3.3333e-01}', "");
    Expect(1, 74853, '\p{Is_Nv=0.3333}', "");
    Expect(0, 74853, '\p{^Is_Nv=0.3333}', "");
    Expect(0, 74853, '\P{Is_Nv=0.3333}', "");
    Expect(1, 74853, '\P{^Is_Nv=0.3333}', "");
    Expect(0, 74854, '\p{Is_Nv=0.3333}', "");
    Expect(1, 74854, '\p{^Is_Nv=0.3333}', "");
    Expect(1, 74854, '\P{Is_Nv=0.3333}', "");
    Expect(0, 74854, '\P{^Is_Nv=0.3333}', "");
    Expect(1, 74853, '\p{Is_Nv=3.33333e-01}', "");
    Expect(0, 74853, '\p{^Is_Nv=3.33333e-01}', "");
    Expect(0, 74853, '\P{Is_Nv=3.33333e-01}', "");
    Expect(1, 74853, '\P{^Is_Nv=3.33333e-01}', "");
    Expect(0, 74854, '\p{Is_Nv=3.33333e-01}', "");
    Expect(1, 74854, '\p{^Is_Nv=3.33333e-01}', "");
    Expect(1, 74854, '\P{Is_Nv=3.33333e-01}', "");
    Expect(0, 74854, '\P{^Is_Nv=3.33333e-01}', "");
    Expect(1, 74853, '\p{Is_Nv=0.33333}', "");
    Expect(0, 74853, '\p{^Is_Nv=0.33333}', "");
    Expect(0, 74853, '\P{Is_Nv=0.33333}', "");
    Expect(1, 74853, '\P{^Is_Nv=0.33333}', "");
    Expect(0, 74854, '\p{Is_Nv=0.33333}', "");
    Expect(1, 74854, '\p{^Is_Nv=0.33333}', "");
    Expect(1, 74854, '\P{Is_Nv=0.33333}', "");
    Expect(0, 74854, '\P{^Is_Nv=0.33333}', "");
    Error('\p{Numeric_Value= 	+1/000032:=}');
    Error('\P{Numeric_Value= 	+1/000032:=}');
    Expect(1, 73669, '\p{Numeric_Value=:\A1/32\z:}', "");;
    Expect(0, 73670, '\p{Numeric_Value=:\A1/32\z:}', "");;
    Expect(1, 73669, '\p{Numeric_Value=000001/000000032}', "");
    Expect(0, 73669, '\p{^Numeric_Value=000001/000000032}', "");
    Expect(0, 73669, '\P{Numeric_Value=000001/000000032}', "");
    Expect(1, 73669, '\P{^Numeric_Value=000001/000000032}', "");
    Expect(0, 73670, '\p{Numeric_Value=000001/000000032}', "");
    Expect(1, 73670, '\p{^Numeric_Value=000001/000000032}', "");
    Expect(1, 73670, '\P{Numeric_Value=000001/000000032}', "");
    Expect(0, 73670, '\P{^Numeric_Value=000001/000000032}', "");
    Expect(1, 73669, '\p{Numeric_Value=60/1920}', "");
    Expect(0, 73669, '\p{^Numeric_Value=60/1920}', "");
    Expect(0, 73669, '\P{Numeric_Value=60/1920}', "");
    Expect(1, 73669, '\P{^Numeric_Value=60/1920}', "");
    Expect(0, 73670, '\p{Numeric_Value=60/1920}', "");
    Expect(1, 73670, '\p{^Numeric_Value=60/1920}', "");
    Expect(1, 73670, '\P{Numeric_Value=60/1920}', "");
    Expect(0, 73670, '\P{^Numeric_Value=60/1920}', "");
    Error('\p{Numeric_Value=3.1e-02}');
    Error('\P{Numeric_Value=3.1e-02}');
    Error('\p{Numeric_Value: 3.12e-02}');
    Error('\P{Numeric_Value: 3.12e-02}');
    Error('\p{Numeric_Value=0.03}');
    Error('\P{Numeric_Value=0.03}');
    Expect(1, 73669, '\p{Numeric_Value=3.125e-02}', "");
    Expect(0, 73669, '\p{^Numeric_Value=3.125e-02}', "");
    Expect(0, 73669, '\P{Numeric_Value=3.125e-02}', "");
    Expect(1, 73669, '\P{^Numeric_Value=3.125e-02}', "");
    Expect(0, 73670, '\p{Numeric_Value=3.125e-02}', "");
    Expect(1, 73670, '\p{^Numeric_Value=3.125e-02}', "");
    Expect(1, 73670, '\P{Numeric_Value=3.125e-02}', "");
    Expect(0, 73670, '\P{^Numeric_Value=3.125e-02}', "");
    Error('\p{Numeric_Value=0.031}');
    Error('\P{Numeric_Value=0.031}');
    Expect(1, 73669, '\p{Numeric_Value=3.1250e-02}', "");
    Expect(0, 73669, '\p{^Numeric_Value=3.1250e-02}', "");
    Expect(0, 73669, '\P{Numeric_Value=3.1250e-02}', "");
    Expect(1, 73669, '\P{^Numeric_Value=3.1250e-02}', "");
    Expect(0, 73670, '\p{Numeric_Value=3.1250e-02}', "");
    Expect(1, 73670, '\p{^Numeric_Value=3.1250e-02}', "");
    Expect(1, 73670, '\P{Numeric_Value=3.1250e-02}', "");
    Expect(0, 73670, '\P{^Numeric_Value=3.1250e-02}', "");
    Error('\p{Numeric_Value=0.0312}');
    Error('\P{Numeric_Value=0.0312}');
    Expect(1, 73669, '\p{Numeric_Value=3.12500e-02}', "");
    Expect(0, 73669, '\p{^Numeric_Value=3.12500e-02}', "");
    Expect(0, 73669, '\P{Numeric_Value=3.12500e-02}', "");
    Expect(1, 73669, '\P{^Numeric_Value=3.12500e-02}', "");
    Expect(0, 73670, '\p{Numeric_Value=3.12500e-02}', "");
    Expect(1, 73670, '\p{^Numeric_Value=3.12500e-02}', "");
    Expect(1, 73670, '\P{Numeric_Value=3.12500e-02}', "");
    Expect(0, 73670, '\P{^Numeric_Value=3.12500e-02}', "");
    Expect(1, 73669, '\p{Numeric_Value=0.03125}', "");
    Expect(0, 73669, '\p{^Numeric_Value=0.03125}', "");
    Expect(0, 73669, '\P{Numeric_Value=0.03125}', "");
    Expect(1, 73669, '\P{^Numeric_Value=0.03125}', "");
    Expect(0, 73670, '\p{Numeric_Value=0.03125}', "");
    Expect(1, 73670, '\p{^Numeric_Value=0.03125}', "");
    Expect(1, 73670, '\P{Numeric_Value=0.03125}', "");
    Expect(0, 73670, '\P{^Numeric_Value=0.03125}', "");
    Expect(1, 73669, '\p{Numeric_Value=3.125000e-02}', "");
    Expect(0, 73669, '\p{^Numeric_Value=3.125000e-02}', "");
    Expect(0, 73669, '\P{Numeric_Value=3.125000e-02}', "");
    Expect(1, 73669, '\P{^Numeric_Value=3.125000e-02}', "");
    Expect(0, 73670, '\p{Numeric_Value=3.125000e-02}', "");
    Expect(1, 73670, '\p{^Numeric_Value=3.125000e-02}', "");
    Expect(1, 73670, '\P{Numeric_Value=3.125000e-02}', "");
    Expect(0, 73670, '\P{^Numeric_Value=3.125000e-02}', "");
    Expect(1, 73669, '\p{Numeric_Value=0.031250}', "");
    Expect(0, 73669, '\p{^Numeric_Value=0.031250}', "");
    Expect(0, 73669, '\P{Numeric_Value=0.031250}', "");
    Expect(1, 73669, '\P{^Numeric_Value=0.031250}', "");
    Expect(0, 73670, '\p{Numeric_Value=0.031250}', "");
    Expect(1, 73670, '\p{^Numeric_Value=0.031250}', "");
    Expect(1, 73670, '\P{Numeric_Value=0.031250}', "");
    Expect(0, 73670, '\P{^Numeric_Value=0.031250}', "");
    Error('\p{Nv: /a/		+0000001/00000000032}');
    Error('\P{Nv: /a/		+0000001/00000000032}');
    Expect(1, 73669, '\p{Nv=:\A1/32\z:}', "");;
    Expect(0, 73670, '\p{Nv=:\A1/32\z:}', "");;
    Expect(1, 73669, '\p{Nv:1/32}', "");
    Expect(0, 73669, '\p{^Nv:1/32}', "");
    Expect(0, 73669, '\P{Nv:1/32}', "");
    Expect(1, 73669, '\P{^Nv:1/32}', "");
    Expect(0, 73670, '\p{Nv:1/32}', "");
    Expect(1, 73670, '\p{^Nv:1/32}', "");
    Expect(1, 73670, '\P{Nv:1/32}', "");
    Expect(0, 73670, '\P{^Nv:1/32}', "");
    Expect(1, 73669, '\p{Nv=60/1920}', "");
    Expect(0, 73669, '\p{^Nv=60/1920}', "");
    Expect(0, 73669, '\P{Nv=60/1920}', "");
    Expect(1, 73669, '\P{^Nv=60/1920}', "");
    Expect(0, 73670, '\p{Nv=60/1920}', "");
    Expect(1, 73670, '\p{^Nv=60/1920}', "");
    Expect(1, 73670, '\P{Nv=60/1920}', "");
    Expect(0, 73670, '\P{^Nv=60/1920}', "");
    Error('\p{Nv=3.1e-02}');
    Error('\P{Nv=3.1e-02}');
    Error('\p{Nv=3.12e-02}');
    Error('\P{Nv=3.12e-02}');
    Error('\p{Nv=0.03}');
    Error('\P{Nv=0.03}');
    Expect(1, 73669, '\p{Nv=3.125e-02}', "");
    Expect(0, 73669, '\p{^Nv=3.125e-02}', "");
    Expect(0, 73669, '\P{Nv=3.125e-02}', "");
    Expect(1, 73669, '\P{^Nv=3.125e-02}', "");
    Expect(0, 73670, '\p{Nv=3.125e-02}', "");
    Expect(1, 73670, '\p{^Nv=3.125e-02}', "");
    Expect(1, 73670, '\P{Nv=3.125e-02}', "");
    Expect(0, 73670, '\P{^Nv=3.125e-02}', "");
    Error('\p{Nv=0.031}');
    Error('\P{Nv=0.031}');
    Expect(1, 73669, '\p{Nv=3.1250e-02}', "");
    Expect(0, 73669, '\p{^Nv=3.1250e-02}', "");
    Expect(0, 73669, '\P{Nv=3.1250e-02}', "");
    Expect(1, 73669, '\P{^Nv=3.1250e-02}', "");
    Expect(0, 73670, '\p{Nv=3.1250e-02}', "");
    Expect(1, 73670, '\p{^Nv=3.1250e-02}', "");
    Expect(1, 73670, '\P{Nv=3.1250e-02}', "");
    Expect(0, 73670, '\P{^Nv=3.1250e-02}', "");
    Error('\p{Nv=0.0312}');
    Error('\P{Nv=0.0312}');
    Expect(1, 73669, '\p{Nv=3.12500e-02}', "");
    Expect(0, 73669, '\p{^Nv=3.12500e-02}', "");
    Expect(0, 73669, '\P{Nv=3.12500e-02}', "");
    Expect(1, 73669, '\P{^Nv=3.12500e-02}', "");
    Expect(0, 73670, '\p{Nv=3.12500e-02}', "");
    Expect(1, 73670, '\p{^Nv=3.12500e-02}', "");
    Expect(1, 73670, '\P{Nv=3.12500e-02}', "");
    Expect(0, 73670, '\P{^Nv=3.12500e-02}', "");
    Expect(1, 73669, '\p{Nv=0.03125}', "");
    Expect(0, 73669, '\p{^Nv=0.03125}', "");
    Expect(0, 73669, '\P{Nv=0.03125}', "");
    Expect(1, 73669, '\P{^Nv=0.03125}', "");
    Expect(0, 73670, '\p{Nv=0.03125}', "");
    Expect(1, 73670, '\p{^Nv=0.03125}', "");
    Expect(1, 73670, '\P{Nv=0.03125}', "");
    Expect(0, 73670, '\P{^Nv=0.03125}', "");
    Expect(1, 73669, '\p{Nv=3.125000e-02}', "");
    Expect(0, 73669, '\p{^Nv=3.125000e-02}', "");
    Expect(0, 73669, '\P{Nv=3.125000e-02}', "");
    Expect(1, 73669, '\P{^Nv=3.125000e-02}', "");
    Expect(0, 73670, '\p{Nv=3.125000e-02}', "");
    Expect(1, 73670, '\p{^Nv=3.125000e-02}', "");
    Expect(1, 73670, '\P{Nv=3.125000e-02}', "");
    Expect(0, 73670, '\P{^Nv=3.125000e-02}', "");
    Expect(1, 73669, '\p{Nv=0.031250}', "");
    Expect(0, 73669, '\p{^Nv=0.031250}', "");
    Expect(0, 73669, '\P{Nv=0.031250}', "");
    Expect(1, 73669, '\P{^Nv=0.031250}', "");
    Expect(0, 73670, '\p{Nv=0.031250}', "");
    Expect(1, 73670, '\p{^Nv=0.031250}', "");
    Expect(1, 73670, '\P{Nv=0.031250}', "");
    Expect(0, 73670, '\P{^Nv=0.031250}', "");
    Error('\p{Is_Numeric_Value=-0000000001/00000032/a/}');
    Error('\P{Is_Numeric_Value=-0000000001/00000032/a/}');
    Expect(1, 73669, '\p{Is_Numeric_Value=+000000001/00032}', "");
    Expect(0, 73669, '\p{^Is_Numeric_Value=+000000001/00032}', "");
    Expect(0, 73669, '\P{Is_Numeric_Value=+000000001/00032}', "");
    Expect(1, 73669, '\P{^Is_Numeric_Value=+000000001/00032}', "");
    Expect(0, 73670, '\p{Is_Numeric_Value=+000000001/00032}', "");
    Expect(1, 73670, '\p{^Is_Numeric_Value=+000000001/00032}', "");
    Expect(1, 73670, '\P{Is_Numeric_Value=+000000001/00032}', "");
    Expect(0, 73670, '\P{^Is_Numeric_Value=+000000001/00032}', "");
    Expect(1, 73669, '\p{Is_Numeric_Value=60/1920}', "");
    Expect(0, 73669, '\p{^Is_Numeric_Value=60/1920}', "");
    Expect(0, 73669, '\P{Is_Numeric_Value=60/1920}', "");
    Expect(1, 73669, '\P{^Is_Numeric_Value=60/1920}', "");
    Expect(0, 73670, '\p{Is_Numeric_Value=60/1920}', "");
    Expect(1, 73670, '\p{^Is_Numeric_Value=60/1920}', "");
    Expect(1, 73670, '\P{Is_Numeric_Value=60/1920}', "");
    Expect(0, 73670, '\P{^Is_Numeric_Value=60/1920}', "");
    Error('\p{Is_Numeric_Value=3.1e-02}');
    Error('\P{Is_Numeric_Value=3.1e-02}');
    Error('\p{Is_Numeric_Value=3.12e-02}');
    Error('\P{Is_Numeric_Value=3.12e-02}');
    Error('\p{Is_Numeric_Value=0.03}');
    Error('\P{Is_Numeric_Value=0.03}');
    Expect(1, 73669, '\p{Is_Numeric_Value=3.125e-02}', "");
    Expect(0, 73669, '\p{^Is_Numeric_Value=3.125e-02}', "");
    Expect(0, 73669, '\P{Is_Numeric_Value=3.125e-02}', "");
    Expect(1, 73669, '\P{^Is_Numeric_Value=3.125e-02}', "");
    Expect(0, 73670, '\p{Is_Numeric_Value=3.125e-02}', "");
    Expect(1, 73670, '\p{^Is_Numeric_Value=3.125e-02}', "");
    Expect(1, 73670, '\P{Is_Numeric_Value=3.125e-02}', "");
    Expect(0, 73670, '\P{^Is_Numeric_Value=3.125e-02}', "");
    Error('\p{Is_Numeric_Value=0.031}');
    Error('\P{Is_Numeric_Value=0.031}');
    Expect(1, 73669, '\p{Is_Numeric_Value=3.1250e-02}', "");
    Expect(0, 73669, '\p{^Is_Numeric_Value=3.1250e-02}', "");
    Expect(0, 73669, '\P{Is_Numeric_Value=3.1250e-02}', "");
    Expect(1, 73669, '\P{^Is_Numeric_Value=3.1250e-02}', "");
    Expect(0, 73670, '\p{Is_Numeric_Value=3.1250e-02}', "");
    Expect(1, 73670, '\p{^Is_Numeric_Value=3.1250e-02}', "");
    Expect(1, 73670, '\P{Is_Numeric_Value=3.1250e-02}', "");
    Expect(0, 73670, '\P{^Is_Numeric_Value=3.1250e-02}', "");
    Error('\p{Is_Numeric_Value=0.0312}');
    Error('\P{Is_Numeric_Value=0.0312}');
    Expect(1, 73669, '\p{Is_Numeric_Value=3.12500e-02}', "");
    Expect(0, 73669, '\p{^Is_Numeric_Value=3.12500e-02}', "");
    Expect(0, 73669, '\P{Is_Numeric_Value=3.12500e-02}', "");
    Expect(1, 73669, '\P{^Is_Numeric_Value=3.12500e-02}', "");
    Expect(0, 73670, '\p{Is_Numeric_Value=3.12500e-02}', "");
    Expect(1, 73670, '\p{^Is_Numeric_Value=3.12500e-02}', "");
    Expect(1, 73670, '\P{Is_Numeric_Value=3.12500e-02}', "");
    Expect(0, 73670, '\P{^Is_Numeric_Value=3.12500e-02}', "");
    Expect(1, 73669, '\p{Is_Numeric_Value=0.03125}', "");
    Expect(0, 73669, '\p{^Is_Numeric_Value=0.03125}', "");
    Expect(0, 73669, '\P{Is_Numeric_Value=0.03125}', "");
    Expect(1, 73669, '\P{^Is_Numeric_Value=0.03125}', "");
    Expect(0, 73670, '\p{Is_Numeric_Value=0.03125}', "");
    Expect(1, 73670, '\p{^Is_Numeric_Value=0.03125}', "");
    Expect(1, 73670, '\P{Is_Numeric_Value=0.03125}', "");
    Expect(0, 73670, '\P{^Is_Numeric_Value=0.03125}', "");
    Expect(1, 73669, '\p{Is_Numeric_Value=3.125000e-02}', "");
    Expect(0, 73669, '\p{^Is_Numeric_Value=3.125000e-02}', "");
    Expect(0, 73669, '\P{Is_Numeric_Value=3.125000e-02}', "");
    Expect(1, 73669, '\P{^Is_Numeric_Value=3.125000e-02}', "");
    Expect(0, 73670, '\p{Is_Numeric_Value=3.125000e-02}', "");
    Expect(1, 73670, '\p{^Is_Numeric_Value=3.125000e-02}', "");
    Expect(1, 73670, '\P{Is_Numeric_Value=3.125000e-02}', "");
    Expect(0, 73670, '\P{^Is_Numeric_Value=3.125000e-02}', "");
    Expect(1, 73669, '\p{Is_Numeric_Value=0.031250}', "");
    Expect(0, 73669, '\p{^Is_Numeric_Value=0.031250}', "");
    Expect(0, 73669, '\P{Is_Numeric_Value=0.031250}', "");
    Expect(1, 73669, '\P{^Is_Numeric_Value=0.031250}', "");
    Expect(0, 73670, '\p{Is_Numeric_Value=0.031250}', "");
    Expect(1, 73670, '\p{^Is_Numeric_Value=0.031250}', "");
    Expect(1, 73670, '\P{Is_Numeric_Value=0.031250}', "");
    Expect(0, 73670, '\P{^Is_Numeric_Value=0.031250}', "");
    Error('\p{Is_Nv= 01/000032:=}');
    Error('\P{Is_Nv= 01/000032:=}');
    Expect(1, 73669, '\p{Is_Nv=+0001/032}', "");
    Expect(0, 73669, '\p{^Is_Nv=+0001/032}', "");
    Expect(0, 73669, '\P{Is_Nv=+0001/032}', "");
    Expect(1, 73669, '\P{^Is_Nv=+0001/032}', "");
    Expect(0, 73670, '\p{Is_Nv=+0001/032}', "");
    Expect(1, 73670, '\p{^Is_Nv=+0001/032}', "");
    Expect(1, 73670, '\P{Is_Nv=+0001/032}', "");
    Expect(0, 73670, '\P{^Is_Nv=+0001/032}', "");
    Expect(1, 73669, '\p{Is_Nv=60/1920}', "");
    Expect(0, 73669, '\p{^Is_Nv=60/1920}', "");
    Expect(0, 73669, '\P{Is_Nv=60/1920}', "");
    Expect(1, 73669, '\P{^Is_Nv=60/1920}', "");
    Expect(0, 73670, '\p{Is_Nv=60/1920}', "");
    Expect(1, 73670, '\p{^Is_Nv=60/1920}', "");
    Expect(1, 73670, '\P{Is_Nv=60/1920}', "");
    Expect(0, 73670, '\P{^Is_Nv=60/1920}', "");
    Error('\p{Is_Nv=3.1e-02}');
    Error('\P{Is_Nv=3.1e-02}');
    Error('\p{Is_Nv=3.12e-02}');
    Error('\P{Is_Nv=3.12e-02}');
    Error('\p{Is_Nv=0.03}');
    Error('\P{Is_Nv=0.03}');
    Expect(1, 73669, '\p{Is_Nv: 3.125e-02}', "");
    Expect(0, 73669, '\p{^Is_Nv: 3.125e-02}', "");
    Expect(0, 73669, '\P{Is_Nv: 3.125e-02}', "");
    Expect(1, 73669, '\P{^Is_Nv: 3.125e-02}', "");
    Expect(0, 73670, '\p{Is_Nv: 3.125e-02}', "");
    Expect(1, 73670, '\p{^Is_Nv: 3.125e-02}', "");
    Expect(1, 73670, '\P{Is_Nv: 3.125e-02}', "");
    Expect(0, 73670, '\P{^Is_Nv: 3.125e-02}', "");
    Error('\p{Is_Nv:0.031}');
    Error('\P{Is_Nv:0.031}');
    Expect(1, 73669, '\p{Is_Nv=3.1250e-02}', "");
    Expect(0, 73669, '\p{^Is_Nv=3.1250e-02}', "");
    Expect(0, 73669, '\P{Is_Nv=3.1250e-02}', "");
    Expect(1, 73669, '\P{^Is_Nv=3.1250e-02}', "");
    Expect(0, 73670, '\p{Is_Nv=3.1250e-02}', "");
    Expect(1, 73670, '\p{^Is_Nv=3.1250e-02}', "");
    Expect(1, 73670, '\P{Is_Nv=3.1250e-02}', "");
    Expect(0, 73670, '\P{^Is_Nv=3.1250e-02}', "");
    Error('\p{Is_Nv=0.0312}');
    Error('\P{Is_Nv=0.0312}');
    Expect(1, 73669, '\p{Is_Nv=3.12500e-02}', "");
    Expect(0, 73669, '\p{^Is_Nv=3.12500e-02}', "");
    Expect(0, 73669, '\P{Is_Nv=3.12500e-02}', "");
    Expect(1, 73669, '\P{^Is_Nv=3.12500e-02}', "");
    Expect(0, 73670, '\p{Is_Nv=3.12500e-02}', "");
    Expect(1, 73670, '\p{^Is_Nv=3.12500e-02}', "");
    Expect(1, 73670, '\P{Is_Nv=3.12500e-02}', "");
    Expect(0, 73670, '\P{^Is_Nv=3.12500e-02}', "");
    Expect(1, 73669, '\p{Is_Nv=0.03125}', "");
    Expect(0, 73669, '\p{^Is_Nv=0.03125}', "");
    Expect(0, 73669, '\P{Is_Nv=0.03125}', "");
    Expect(1, 73669, '\P{^Is_Nv=0.03125}', "");
    Expect(0, 73670, '\p{Is_Nv=0.03125}', "");
    Expect(1, 73670, '\p{^Is_Nv=0.03125}', "");
    Expect(1, 73670, '\P{Is_Nv=0.03125}', "");
    Expect(0, 73670, '\P{^Is_Nv=0.03125}', "");
    Expect(1, 73669, '\p{Is_Nv=3.125000e-02}', "");
    Expect(0, 73669, '\p{^Is_Nv=3.125000e-02}', "");
    Expect(0, 73669, '\P{Is_Nv=3.125000e-02}', "");
    Expect(1, 73669, '\P{^Is_Nv=3.125000e-02}', "");
    Expect(0, 73670, '\p{Is_Nv=3.125000e-02}', "");
    Expect(1, 73670, '\p{^Is_Nv=3.125000e-02}', "");
    Expect(1, 73670, '\P{Is_Nv=3.125000e-02}', "");
    Expect(0, 73670, '\P{^Is_Nv=3.125000e-02}', "");
    Expect(1, 73669, '\p{Is_Nv=0.031250}', "");
    Expect(0, 73669, '\p{^Is_Nv=0.031250}', "");
    Expect(0, 73669, '\P{Is_Nv=0.031250}', "");
    Expect(1, 73669, '\P{^Is_Nv=0.031250}', "");
    Expect(0, 73670, '\p{Is_Nv=0.031250}', "");
    Expect(1, 73670, '\p{^Is_Nv=0.031250}', "");
    Expect(1, 73670, '\P{Is_Nv=0.031250}', "");
    Expect(0, 73670, '\P{^Is_Nv=0.031250}', "");
    Error('\p{Numeric_Value=-:=000000001/000320}');
    Error('\P{Numeric_Value=-:=000000001/000320}');
    Expect(1, 73684, '\p{Numeric_Value=:\A1/320\z:}', "");;
    Expect(0, 73685, '\p{Numeric_Value=:\A1/320\z:}', "");;
    Expect(1, 73684, '\p{Numeric_Value=000000001/320}', "");
    Expect(0, 73684, '\p{^Numeric_Value=000000001/320}', "");
    Expect(0, 73684, '\P{Numeric_Value=000000001/320}', "");
    Expect(1, 73684, '\P{^Numeric_Value=000000001/320}', "");
    Expect(0, 73685, '\p{Numeric_Value=000000001/320}', "");
    Expect(1, 73685, '\p{^Numeric_Value=000000001/320}', "");
    Expect(1, 73685, '\P{Numeric_Value=000000001/320}', "");
    Expect(0, 73685, '\P{^Numeric_Value=000000001/320}', "");
    Expect(1, 73684, '\p{Numeric_Value=60/19200}', "");
    Expect(0, 73684, '\p{^Numeric_Value=60/19200}', "");
    Expect(0, 73684, '\P{Numeric_Value=60/19200}', "");
    Expect(1, 73684, '\P{^Numeric_Value=60/19200}', "");
    Expect(0, 73685, '\p{Numeric_Value=60/19200}', "");
    Expect(1, 73685, '\p{^Numeric_Value=60/19200}', "");
    Expect(1, 73685, '\P{Numeric_Value=60/19200}', "");
    Expect(0, 73685, '\P{^Numeric_Value=60/19200}', "");
    Error('\p{Numeric_Value=3.1e-03}');
    Error('\P{Numeric_Value=3.1e-03}');
    Error('\p{Numeric_Value=3.13e-03}');
    Error('\P{Numeric_Value=3.13e-03}');
    Expect(1, 73684, '\p{Numeric_Value=3.125e-03}', "");
    Expect(0, 73684, '\p{^Numeric_Value=3.125e-03}', "");
    Expect(0, 73684, '\P{Numeric_Value=3.125e-03}', "");
    Expect(1, 73684, '\P{^Numeric_Value=3.125e-03}', "");
    Expect(0, 73685, '\p{Numeric_Value=3.125e-03}', "");
    Expect(1, 73685, '\p{^Numeric_Value=3.125e-03}', "");
    Expect(1, 73685, '\P{Numeric_Value=3.125e-03}', "");
    Expect(0, 73685, '\P{^Numeric_Value=3.125e-03}', "");
    Error('\p{Numeric_Value:0.003}');
    Error('\P{Numeric_Value:0.003}');
    Expect(1, 73684, '\p{Numeric_Value=3.1250e-03}', "");
    Expect(0, 73684, '\p{^Numeric_Value=3.1250e-03}', "");
    Expect(0, 73684, '\P{Numeric_Value=3.1250e-03}', "");
    Expect(1, 73684, '\P{^Numeric_Value=3.1250e-03}', "");
    Expect(0, 73685, '\p{Numeric_Value=3.1250e-03}', "");
    Expect(1, 73685, '\p{^Numeric_Value=3.1250e-03}', "");
    Expect(1, 73685, '\P{Numeric_Value=3.1250e-03}', "");
    Expect(0, 73685, '\P{^Numeric_Value=3.1250e-03}', "");
    Error('\p{Numeric_Value=0.0031}');
    Error('\P{Numeric_Value=0.0031}');
    Expect(1, 73684, '\p{Numeric_Value=3.12500e-03}', "");
    Expect(0, 73684, '\p{^Numeric_Value=3.12500e-03}', "");
    Expect(0, 73684, '\P{Numeric_Value=3.12500e-03}', "");
    Expect(1, 73684, '\P{^Numeric_Value=3.12500e-03}', "");
    Expect(0, 73685, '\p{Numeric_Value=3.12500e-03}', "");
    Expect(1, 73685, '\p{^Numeric_Value=3.12500e-03}', "");
    Expect(1, 73685, '\P{Numeric_Value=3.12500e-03}', "");
    Expect(0, 73685, '\P{^Numeric_Value=3.12500e-03}', "");
    Error('\p{Numeric_Value=0.00313}');
    Error('\P{Numeric_Value=0.00313}');
    Expect(1, 73684, '\p{Numeric_Value=3.125000e-03}', "");
    Expect(0, 73684, '\p{^Numeric_Value=3.125000e-03}', "");
    Expect(0, 73684, '\P{Numeric_Value=3.125000e-03}', "");
    Expect(1, 73684, '\P{^Numeric_Value=3.125000e-03}', "");
    Expect(0, 73685, '\p{Numeric_Value=3.125000e-03}', "");
    Expect(1, 73685, '\p{^Numeric_Value=3.125000e-03}', "");
    Expect(1, 73685, '\P{Numeric_Value=3.125000e-03}', "");
    Expect(0, 73685, '\P{^Numeric_Value=3.125000e-03}', "");
    Expect(1, 73684, '\p{Numeric_Value=0.003125}', "");
    Expect(0, 73684, '\p{^Numeric_Value=0.003125}', "");
    Expect(0, 73684, '\P{Numeric_Value=0.003125}', "");
    Expect(1, 73684, '\P{^Numeric_Value=0.003125}', "");
    Expect(0, 73685, '\p{Numeric_Value=0.003125}', "");
    Expect(1, 73685, '\p{^Numeric_Value=0.003125}', "");
    Expect(1, 73685, '\P{Numeric_Value=0.003125}', "");
    Expect(0, 73685, '\P{^Numeric_Value=0.003125}', "");
    Expect(1, 73684, '\p{Numeric_Value=3.1250000e-03}', "");
    Expect(0, 73684, '\p{^Numeric_Value=3.1250000e-03}', "");
    Expect(0, 73684, '\P{Numeric_Value=3.1250000e-03}', "");
    Expect(1, 73684, '\P{^Numeric_Value=3.1250000e-03}', "");
    Expect(0, 73685, '\p{Numeric_Value=3.1250000e-03}', "");
    Expect(1, 73685, '\p{^Numeric_Value=3.1250000e-03}', "");
    Expect(1, 73685, '\P{Numeric_Value=3.1250000e-03}', "");
    Expect(0, 73685, '\P{^Numeric_Value=3.1250000e-03}', "");
    Expect(1, 73684, '\p{Numeric_Value:   0.0031250}', "");
    Expect(0, 73684, '\p{^Numeric_Value:   0.0031250}', "");
    Expect(0, 73684, '\P{Numeric_Value:   0.0031250}', "");
    Expect(1, 73684, '\P{^Numeric_Value:   0.0031250}', "");
    Expect(0, 73685, '\p{Numeric_Value:   0.0031250}', "");
    Expect(1, 73685, '\p{^Numeric_Value:   0.0031250}', "");
    Expect(1, 73685, '\P{Numeric_Value:   0.0031250}', "");
    Expect(0, 73685, '\P{^Numeric_Value:   0.0031250}', "");
    Error('\p{Nv=/a/1/0000000320}');
    Error('\P{Nv=/a/1/0000000320}');
    Expect(1, 73684, '\p{Nv=:\A1/320\z:}', "");;
    Expect(0, 73685, '\p{Nv=:\A1/320\z:}', "");;
    Expect(1, 73684, '\p{Nv=+0000000001/320}', "");
    Expect(0, 73684, '\p{^Nv=+0000000001/320}', "");
    Expect(0, 73684, '\P{Nv=+0000000001/320}', "");
    Expect(1, 73684, '\P{^Nv=+0000000001/320}', "");
    Expect(0, 73685, '\p{Nv=+0000000001/320}', "");
    Expect(1, 73685, '\p{^Nv=+0000000001/320}', "");
    Expect(1, 73685, '\P{Nv=+0000000001/320}', "");
    Expect(0, 73685, '\P{^Nv=+0000000001/320}', "");
    Expect(1, 73684, '\p{Nv=60/19200}', "");
    Expect(0, 73684, '\p{^Nv=60/19200}', "");
    Expect(0, 73684, '\P{Nv=60/19200}', "");
    Expect(1, 73684, '\P{^Nv=60/19200}', "");
    Expect(0, 73685, '\p{Nv=60/19200}', "");
    Expect(1, 73685, '\p{^Nv=60/19200}', "");
    Expect(1, 73685, '\P{Nv=60/19200}', "");
    Expect(0, 73685, '\P{^Nv=60/19200}', "");
    Error('\p{Nv=3.1e-03}');
    Error('\P{Nv=3.1e-03}');
    Error('\p{Nv=3.13e-03}');
    Error('\P{Nv=3.13e-03}');
    Expect(1, 73684, '\p{Nv=3.125e-03}', "");
    Expect(0, 73684, '\p{^Nv=3.125e-03}', "");
    Expect(0, 73684, '\P{Nv=3.125e-03}', "");
    Expect(1, 73684, '\P{^Nv=3.125e-03}', "");
    Expect(0, 73685, '\p{Nv=3.125e-03}', "");
    Expect(1, 73685, '\p{^Nv=3.125e-03}', "");
    Expect(1, 73685, '\P{Nv=3.125e-03}', "");
    Expect(0, 73685, '\P{^Nv=3.125e-03}', "");
    Error('\p{Nv=0.003}');
    Error('\P{Nv=0.003}');
    Expect(1, 73684, '\p{Nv=3.1250e-03}', "");
    Expect(0, 73684, '\p{^Nv=3.1250e-03}', "");
    Expect(0, 73684, '\P{Nv=3.1250e-03}', "");
    Expect(1, 73684, '\P{^Nv=3.1250e-03}', "");
    Expect(0, 73685, '\p{Nv=3.1250e-03}', "");
    Expect(1, 73685, '\p{^Nv=3.1250e-03}', "");
    Expect(1, 73685, '\P{Nv=3.1250e-03}', "");
    Expect(0, 73685, '\P{^Nv=3.1250e-03}', "");
    Error('\p{Nv=0.0031}');
    Error('\P{Nv=0.0031}');
    Expect(1, 73684, '\p{Nv=3.12500e-03}', "");
    Expect(0, 73684, '\p{^Nv=3.12500e-03}', "");
    Expect(0, 73684, '\P{Nv=3.12500e-03}', "");
    Expect(1, 73684, '\P{^Nv=3.12500e-03}', "");
    Expect(0, 73685, '\p{Nv=3.12500e-03}', "");
    Expect(1, 73685, '\p{^Nv=3.12500e-03}', "");
    Expect(1, 73685, '\P{Nv=3.12500e-03}', "");
    Expect(0, 73685, '\P{^Nv=3.12500e-03}', "");
    Error('\p{Nv=0.00313}');
    Error('\P{Nv=0.00313}');
    Expect(1, 73684, '\p{Nv=3.125000e-03}', "");
    Expect(0, 73684, '\p{^Nv=3.125000e-03}', "");
    Expect(0, 73684, '\P{Nv=3.125000e-03}', "");
    Expect(1, 73684, '\P{^Nv=3.125000e-03}', "");
    Expect(0, 73685, '\p{Nv=3.125000e-03}', "");
    Expect(1, 73685, '\p{^Nv=3.125000e-03}', "");
    Expect(1, 73685, '\P{Nv=3.125000e-03}', "");
    Expect(0, 73685, '\P{^Nv=3.125000e-03}', "");
    Expect(1, 73684, '\p{Nv=0.003125}', "");
    Expect(0, 73684, '\p{^Nv=0.003125}', "");
    Expect(0, 73684, '\P{Nv=0.003125}', "");
    Expect(1, 73684, '\P{^Nv=0.003125}', "");
    Expect(0, 73685, '\p{Nv=0.003125}', "");
    Expect(1, 73685, '\p{^Nv=0.003125}', "");
    Expect(1, 73685, '\P{Nv=0.003125}', "");
    Expect(0, 73685, '\P{^Nv=0.003125}', "");
    Expect(1, 73684, '\p{Nv=3.1250000e-03}', "");
    Expect(0, 73684, '\p{^Nv=3.1250000e-03}', "");
    Expect(0, 73684, '\P{Nv=3.1250000e-03}', "");
    Expect(1, 73684, '\P{^Nv=3.1250000e-03}', "");
    Expect(0, 73685, '\p{Nv=3.1250000e-03}', "");
    Expect(1, 73685, '\p{^Nv=3.1250000e-03}', "");
    Expect(1, 73685, '\P{Nv=3.1250000e-03}', "");
    Expect(0, 73685, '\P{^Nv=3.1250000e-03}', "");
    Expect(1, 73684, '\p{Nv=0.0031250}', "");
    Expect(0, 73684, '\p{^Nv=0.0031250}', "");
    Expect(0, 73684, '\P{Nv=0.0031250}', "");
    Expect(1, 73684, '\P{^Nv=0.0031250}', "");
    Expect(0, 73685, '\p{Nv=0.0031250}', "");
    Expect(1, 73685, '\p{^Nv=0.0031250}', "");
    Expect(1, 73685, '\P{Nv=0.0031250}', "");
    Expect(0, 73685, '\P{^Nv=0.0031250}', "");
    Error('\p{Is_Numeric_Value=/a/  00000001/000000320}');
    Error('\P{Is_Numeric_Value=/a/  00000001/000000320}');
    Expect(1, 73684, '\p{Is_Numeric_Value=+000001/000320}', "");
    Expect(0, 73684, '\p{^Is_Numeric_Value=+000001/000320}', "");
    Expect(0, 73684, '\P{Is_Numeric_Value=+000001/000320}', "");
    Expect(1, 73684, '\P{^Is_Numeric_Value=+000001/000320}', "");
    Expect(0, 73685, '\p{Is_Numeric_Value=+000001/000320}', "");
    Expect(1, 73685, '\p{^Is_Numeric_Value=+000001/000320}', "");
    Expect(1, 73685, '\P{Is_Numeric_Value=+000001/000320}', "");
    Expect(0, 73685, '\P{^Is_Numeric_Value=+000001/000320}', "");
    Expect(1, 73684, '\p{Is_Numeric_Value=60/19200}', "");
    Expect(0, 73684, '\p{^Is_Numeric_Value=60/19200}', "");
    Expect(0, 73684, '\P{Is_Numeric_Value=60/19200}', "");
    Expect(1, 73684, '\P{^Is_Numeric_Value=60/19200}', "");
    Expect(0, 73685, '\p{Is_Numeric_Value=60/19200}', "");
    Expect(1, 73685, '\p{^Is_Numeric_Value=60/19200}', "");
    Expect(1, 73685, '\P{Is_Numeric_Value=60/19200}', "");
    Expect(0, 73685, '\P{^Is_Numeric_Value=60/19200}', "");
    Error('\p{Is_Numeric_Value=3.1e-03}');
    Error('\P{Is_Numeric_Value=3.1e-03}');
    Error('\p{Is_Numeric_Value=3.13e-03}');
    Error('\P{Is_Numeric_Value=3.13e-03}');
    Expect(1, 73684, '\p{Is_Numeric_Value=3.125e-03}', "");
    Expect(0, 73684, '\p{^Is_Numeric_Value=3.125e-03}', "");
    Expect(0, 73684, '\P{Is_Numeric_Value=3.125e-03}', "");
    Expect(1, 73684, '\P{^Is_Numeric_Value=3.125e-03}', "");
    Expect(0, 73685, '\p{Is_Numeric_Value=3.125e-03}', "");
    Expect(1, 73685, '\p{^Is_Numeric_Value=3.125e-03}', "");
    Expect(1, 73685, '\P{Is_Numeric_Value=3.125e-03}', "");
    Expect(0, 73685, '\P{^Is_Numeric_Value=3.125e-03}', "");
    Error('\p{Is_Numeric_Value:   0.003}');
    Error('\P{Is_Numeric_Value:   0.003}');
    Expect(1, 73684, '\p{Is_Numeric_Value=3.1250e-03}', "");
    Expect(0, 73684, '\p{^Is_Numeric_Value=3.1250e-03}', "");
    Expect(0, 73684, '\P{Is_Numeric_Value=3.1250e-03}', "");
    Expect(1, 73684, '\P{^Is_Numeric_Value=3.1250e-03}', "");
    Expect(0, 73685, '\p{Is_Numeric_Value=3.1250e-03}', "");
    Expect(1, 73685, '\p{^Is_Numeric_Value=3.1250e-03}', "");
    Expect(1, 73685, '\P{Is_Numeric_Value=3.1250e-03}', "");
    Expect(0, 73685, '\P{^Is_Numeric_Value=3.1250e-03}', "");
    Error('\p{Is_Numeric_Value=0.0031}');
    Error('\P{Is_Numeric_Value=0.0031}');
    Expect(1, 73684, '\p{Is_Numeric_Value=3.12500e-03}', "");
    Expect(0, 73684, '\p{^Is_Numeric_Value=3.12500e-03}', "");
    Expect(0, 73684, '\P{Is_Numeric_Value=3.12500e-03}', "");
    Expect(1, 73684, '\P{^Is_Numeric_Value=3.12500e-03}', "");
    Expect(0, 73685, '\p{Is_Numeric_Value=3.12500e-03}', "");
    Expect(1, 73685, '\p{^Is_Numeric_Value=3.12500e-03}', "");
    Expect(1, 73685, '\P{Is_Numeric_Value=3.12500e-03}', "");
    Expect(0, 73685, '\P{^Is_Numeric_Value=3.12500e-03}', "");
    Error('\p{Is_Numeric_Value:	0.00313}');
    Error('\P{Is_Numeric_Value:	0.00313}');
    Expect(1, 73684, '\p{Is_Numeric_Value=3.125000e-03}', "");
    Expect(0, 73684, '\p{^Is_Numeric_Value=3.125000e-03}', "");
    Expect(0, 73684, '\P{Is_Numeric_Value=3.125000e-03}', "");
    Expect(1, 73684, '\P{^Is_Numeric_Value=3.125000e-03}', "");
    Expect(0, 73685, '\p{Is_Numeric_Value=3.125000e-03}', "");
    Expect(1, 73685, '\p{^Is_Numeric_Value=3.125000e-03}', "");
    Expect(1, 73685, '\P{Is_Numeric_Value=3.125000e-03}', "");
    Expect(0, 73685, '\P{^Is_Numeric_Value=3.125000e-03}', "");
    Expect(1, 73684, '\p{Is_Numeric_Value=0.003125}', "");
    Expect(0, 73684, '\p{^Is_Numeric_Value=0.003125}', "");
    Expect(0, 73684, '\P{Is_Numeric_Value=0.003125}', "");
    Expect(1, 73684, '\P{^Is_Numeric_Value=0.003125}', "");
    Expect(0, 73685, '\p{Is_Numeric_Value=0.003125}', "");
    Expect(1, 73685, '\p{^Is_Numeric_Value=0.003125}', "");
    Expect(1, 73685, '\P{Is_Numeric_Value=0.003125}', "");
    Expect(0, 73685, '\P{^Is_Numeric_Value=0.003125}', "");
    Expect(1, 73684, '\p{Is_Numeric_Value=3.1250000e-03}', "");
    Expect(0, 73684, '\p{^Is_Numeric_Value=3.1250000e-03}', "");
    Expect(0, 73684, '\P{Is_Numeric_Value=3.1250000e-03}', "");
    Expect(1, 73684, '\P{^Is_Numeric_Value=3.1250000e-03}', "");
    Expect(0, 73685, '\p{Is_Numeric_Value=3.1250000e-03}', "");
    Expect(1, 73685, '\p{^Is_Numeric_Value=3.1250000e-03}', "");
    Expect(1, 73685, '\P{Is_Numeric_Value=3.1250000e-03}', "");
    Expect(0, 73685, '\P{^Is_Numeric_Value=3.1250000e-03}', "");
    Expect(1, 73684, '\p{Is_Numeric_Value=0.0031250}', "");
    Expect(0, 73684, '\p{^Is_Numeric_Value=0.0031250}', "");
    Expect(0, 73684, '\P{Is_Numeric_Value=0.0031250}', "");
    Expect(1, 73684, '\P{^Is_Numeric_Value=0.0031250}', "");
    Expect(0, 73685, '\p{Is_Numeric_Value=0.0031250}', "");
    Expect(1, 73685, '\p{^Is_Numeric_Value=0.0031250}', "");
    Expect(1, 73685, '\P{Is_Numeric_Value=0.0031250}', "");
    Expect(0, 73685, '\P{^Is_Numeric_Value=0.0031250}', "");
    Error('\p{Is_Nv:  _0000000001/000320/a/}');
    Error('\P{Is_Nv:  _0000000001/000320/a/}');
    Expect(1, 73684, '\p{Is_Nv=1/00000000320}', "");
    Expect(0, 73684, '\p{^Is_Nv=1/00000000320}', "");
    Expect(0, 73684, '\P{Is_Nv=1/00000000320}', "");
    Expect(1, 73684, '\P{^Is_Nv=1/00000000320}', "");
    Expect(0, 73685, '\p{Is_Nv=1/00000000320}', "");
    Expect(1, 73685, '\p{^Is_Nv=1/00000000320}', "");
    Expect(1, 73685, '\P{Is_Nv=1/00000000320}', "");
    Expect(0, 73685, '\P{^Is_Nv=1/00000000320}', "");
    Expect(1, 73684, '\p{Is_Nv=60/19200}', "");
    Expect(0, 73684, '\p{^Is_Nv=60/19200}', "");
    Expect(0, 73684, '\P{Is_Nv=60/19200}', "");
    Expect(1, 73684, '\P{^Is_Nv=60/19200}', "");
    Expect(0, 73685, '\p{Is_Nv=60/19200}', "");
    Expect(1, 73685, '\p{^Is_Nv=60/19200}', "");
    Expect(1, 73685, '\P{Is_Nv=60/19200}', "");
    Expect(0, 73685, '\P{^Is_Nv=60/19200}', "");
    Error('\p{Is_Nv=3.1e-03}');
    Error('\P{Is_Nv=3.1e-03}');
    Error('\p{Is_Nv=3.13e-03}');
    Error('\P{Is_Nv=3.13e-03}');
    Expect(1, 73684, '\p{Is_Nv=3.125e-03}', "");
    Expect(0, 73684, '\p{^Is_Nv=3.125e-03}', "");
    Expect(0, 73684, '\P{Is_Nv=3.125e-03}', "");
    Expect(1, 73684, '\P{^Is_Nv=3.125e-03}', "");
    Expect(0, 73685, '\p{Is_Nv=3.125e-03}', "");
    Expect(1, 73685, '\p{^Is_Nv=3.125e-03}', "");
    Expect(1, 73685, '\P{Is_Nv=3.125e-03}', "");
    Expect(0, 73685, '\P{^Is_Nv=3.125e-03}', "");
    Error('\p{Is_Nv=0.003}');
    Error('\P{Is_Nv=0.003}');
    Expect(1, 73684, '\p{Is_Nv=3.1250e-03}', "");
    Expect(0, 73684, '\p{^Is_Nv=3.1250e-03}', "");
    Expect(0, 73684, '\P{Is_Nv=3.1250e-03}', "");
    Expect(1, 73684, '\P{^Is_Nv=3.1250e-03}', "");
    Expect(0, 73685, '\p{Is_Nv=3.1250e-03}', "");
    Expect(1, 73685, '\p{^Is_Nv=3.1250e-03}', "");
    Expect(1, 73685, '\P{Is_Nv=3.1250e-03}', "");
    Expect(0, 73685, '\P{^Is_Nv=3.1250e-03}', "");
    Error('\p{Is_Nv=0.0031}');
    Error('\P{Is_Nv=0.0031}');
    Expect(1, 73684, '\p{Is_Nv:3.12500e-03}', "");
    Expect(0, 73684, '\p{^Is_Nv:3.12500e-03}', "");
    Expect(0, 73684, '\P{Is_Nv:3.12500e-03}', "");
    Expect(1, 73684, '\P{^Is_Nv:3.12500e-03}', "");
    Expect(0, 73685, '\p{Is_Nv:3.12500e-03}', "");
    Expect(1, 73685, '\p{^Is_Nv:3.12500e-03}', "");
    Expect(1, 73685, '\P{Is_Nv:3.12500e-03}', "");
    Expect(0, 73685, '\P{^Is_Nv:3.12500e-03}', "");
    Error('\p{Is_Nv=0.00313}');
    Error('\P{Is_Nv=0.00313}');
    Expect(1, 73684, '\p{Is_Nv=3.125000e-03}', "");
    Expect(0, 73684, '\p{^Is_Nv=3.125000e-03}', "");
    Expect(0, 73684, '\P{Is_Nv=3.125000e-03}', "");
    Expect(1, 73684, '\P{^Is_Nv=3.125000e-03}', "");
    Expect(0, 73685, '\p{Is_Nv=3.125000e-03}', "");
    Expect(1, 73685, '\p{^Is_Nv=3.125000e-03}', "");
    Expect(1, 73685, '\P{Is_Nv=3.125000e-03}', "");
    Expect(0, 73685, '\P{^Is_Nv=3.125000e-03}', "");
    Expect(1, 73684, '\p{Is_Nv=0.003125}', "");
    Expect(0, 73684, '\p{^Is_Nv=0.003125}', "");
    Expect(0, 73684, '\P{Is_Nv=0.003125}', "");
    Expect(1, 73684, '\P{^Is_Nv=0.003125}', "");
    Expect(0, 73685, '\p{Is_Nv=0.003125}', "");
    Expect(1, 73685, '\p{^Is_Nv=0.003125}', "");
    Expect(1, 73685, '\P{Is_Nv=0.003125}', "");
    Expect(0, 73685, '\P{^Is_Nv=0.003125}', "");
    Expect(1, 73684, '\p{Is_Nv=3.1250000e-03}', "");
    Expect(0, 73684, '\p{^Is_Nv=3.1250000e-03}', "");
    Expect(0, 73684, '\P{Is_Nv=3.1250000e-03}', "");
    Expect(1, 73684, '\P{^Is_Nv=3.1250000e-03}', "");
    Expect(0, 73685, '\p{Is_Nv=3.1250000e-03}', "");
    Expect(1, 73685, '\p{^Is_Nv=3.1250000e-03}', "");
    Expect(1, 73685, '\P{Is_Nv=3.1250000e-03}', "");
    Expect(0, 73685, '\P{^Is_Nv=3.1250000e-03}', "");
    Expect(1, 73684, '\p{Is_Nv=0.0031250}', "");
    Expect(0, 73684, '\p{^Is_Nv=0.0031250}', "");
    Expect(0, 73684, '\P{Is_Nv=0.0031250}', "");
    Expect(1, 73684, '\P{^Is_Nv=0.0031250}', "");
    Expect(0, 73685, '\p{Is_Nv=0.0031250}', "");
    Expect(1, 73685, '\p{^Is_Nv=0.0031250}', "");
    Expect(1, 73685, '\P{Is_Nv=0.0031250}', "");
    Expect(0, 73685, '\P{^Is_Nv=0.0031250}', "");
    Error('\p{Numeric_Value=  000000001/00000004:=}');
    Error('\P{Numeric_Value=  000000001/00000004:=}');
    Expect(1, 126125, '\p{Numeric_Value=:\A1/4\z:}', "");;
    Expect(0, 126126, '\p{Numeric_Value=:\A1/4\z:}', "");;
    Expect(1, 126125, '\p{Numeric_Value=+01/4}', "");
    Expect(0, 126125, '\p{^Numeric_Value=+01/4}', "");
    Expect(0, 126125, '\P{Numeric_Value=+01/4}', "");
    Expect(1, 126125, '\P{^Numeric_Value=+01/4}', "");
    Expect(0, 126126, '\p{Numeric_Value=+01/4}', "");
    Expect(1, 126126, '\p{^Numeric_Value=+01/4}', "");
    Expect(1, 126126, '\P{Numeric_Value=+01/4}', "");
    Expect(0, 126126, '\P{^Numeric_Value=+01/4}', "");
    Expect(1, 126125, '\p{Numeric_Value=60/240}', "");
    Expect(0, 126125, '\p{^Numeric_Value=60/240}', "");
    Expect(0, 126125, '\P{Numeric_Value=60/240}', "");
    Expect(1, 126125, '\P{^Numeric_Value=60/240}', "");
    Expect(0, 126126, '\p{Numeric_Value=60/240}', "");
    Expect(1, 126126, '\p{^Numeric_Value=60/240}', "");
    Expect(1, 126126, '\P{Numeric_Value=60/240}', "");
    Expect(0, 126126, '\P{^Numeric_Value=60/240}', "");
    Expect(1, 126125, '\p{Numeric_Value=2.5e-01}', "");
    Expect(0, 126125, '\p{^Numeric_Value=2.5e-01}', "");
    Expect(0, 126125, '\P{Numeric_Value=2.5e-01}', "");
    Expect(1, 126125, '\P{^Numeric_Value=2.5e-01}', "");
    Expect(0, 126126, '\p{Numeric_Value=2.5e-01}', "");
    Expect(1, 126126, '\p{^Numeric_Value=2.5e-01}', "");
    Expect(1, 126126, '\P{Numeric_Value=2.5e-01}', "");
    Expect(0, 126126, '\P{^Numeric_Value=2.5e-01}', "");
    Expect(1, 126125, '\p{Numeric_Value:   2.50e-01}', "");
    Expect(0, 126125, '\p{^Numeric_Value:   2.50e-01}', "");
    Expect(0, 126125, '\P{Numeric_Value:   2.50e-01}', "");
    Expect(1, 126125, '\P{^Numeric_Value:   2.50e-01}', "");
    Expect(0, 126126, '\p{Numeric_Value:   2.50e-01}', "");
    Expect(1, 126126, '\p{^Numeric_Value:   2.50e-01}', "");
    Expect(1, 126126, '\P{Numeric_Value:   2.50e-01}', "");
    Expect(0, 126126, '\P{^Numeric_Value:   2.50e-01}', "");
    Expect(1, 126125, '\p{Numeric_Value=0.25}', "");
    Expect(0, 126125, '\p{^Numeric_Value=0.25}', "");
    Expect(0, 126125, '\P{Numeric_Value=0.25}', "");
    Expect(1, 126125, '\P{^Numeric_Value=0.25}', "");
    Expect(0, 126126, '\p{Numeric_Value=0.25}', "");
    Expect(1, 126126, '\p{^Numeric_Value=0.25}', "");
    Expect(1, 126126, '\P{Numeric_Value=0.25}', "");
    Expect(0, 126126, '\P{^Numeric_Value=0.25}', "");
    Expect(1, 126125, '\p{Numeric_Value=2.500e-01}', "");
    Expect(0, 126125, '\p{^Numeric_Value=2.500e-01}', "");
    Expect(0, 126125, '\P{Numeric_Value=2.500e-01}', "");
    Expect(1, 126125, '\P{^Numeric_Value=2.500e-01}', "");
    Expect(0, 126126, '\p{Numeric_Value=2.500e-01}', "");
    Expect(1, 126126, '\p{^Numeric_Value=2.500e-01}', "");
    Expect(1, 126126, '\P{Numeric_Value=2.500e-01}', "");
    Expect(0, 126126, '\P{^Numeric_Value=2.500e-01}', "");
    Expect(1, 126125, '\p{Numeric_Value:   0.250}', "");
    Expect(0, 126125, '\p{^Numeric_Value:   0.250}', "");
    Expect(0, 126125, '\P{Numeric_Value:   0.250}', "");
    Expect(1, 126125, '\P{^Numeric_Value:   0.250}', "");
    Expect(0, 126126, '\p{Numeric_Value:   0.250}', "");
    Expect(1, 126126, '\p{^Numeric_Value:   0.250}', "");
    Expect(1, 126126, '\P{Numeric_Value:   0.250}', "");
    Expect(0, 126126, '\P{^Numeric_Value:   0.250}', "");
    Error('\p{Nv=_/a/01/0000004}');
    Error('\P{Nv=_/a/01/0000004}');
    Expect(1, 126125, '\p{Nv=:\A1/4\z:}', "");;
    Expect(0, 126126, '\p{Nv=:\A1/4\z:}', "");;
    Expect(1, 126125, '\p{Nv=0000000001/0000004}', "");
    Expect(0, 126125, '\p{^Nv=0000000001/0000004}', "");
    Expect(0, 126125, '\P{Nv=0000000001/0000004}', "");
    Expect(1, 126125, '\P{^Nv=0000000001/0000004}', "");
    Expect(0, 126126, '\p{Nv=0000000001/0000004}', "");
    Expect(1, 126126, '\p{^Nv=0000000001/0000004}', "");
    Expect(1, 126126, '\P{Nv=0000000001/0000004}', "");
    Expect(0, 126126, '\P{^Nv=0000000001/0000004}', "");
    Expect(1, 126125, '\p{Nv:   60/240}', "");
    Expect(0, 126125, '\p{^Nv:   60/240}', "");
    Expect(0, 126125, '\P{Nv:   60/240}', "");
    Expect(1, 126125, '\P{^Nv:   60/240}', "");
    Expect(0, 126126, '\p{Nv:   60/240}', "");
    Expect(1, 126126, '\p{^Nv:   60/240}', "");
    Expect(1, 126126, '\P{Nv:   60/240}', "");
    Expect(0, 126126, '\P{^Nv:   60/240}', "");
    Expect(1, 126125, '\p{Nv=2.5e-01}', "");
    Expect(0, 126125, '\p{^Nv=2.5e-01}', "");
    Expect(0, 126125, '\P{Nv=2.5e-01}', "");
    Expect(1, 126125, '\P{^Nv=2.5e-01}', "");
    Expect(0, 126126, '\p{Nv=2.5e-01}', "");
    Expect(1, 126126, '\p{^Nv=2.5e-01}', "");
    Expect(1, 126126, '\P{Nv=2.5e-01}', "");
    Expect(0, 126126, '\P{^Nv=2.5e-01}', "");
    Expect(1, 126125, '\p{Nv=2.50e-01}', "");
    Expect(0, 126125, '\p{^Nv=2.50e-01}', "");
    Expect(0, 126125, '\P{Nv=2.50e-01}', "");
    Expect(1, 126125, '\P{^Nv=2.50e-01}', "");
    Expect(0, 126126, '\p{Nv=2.50e-01}', "");
    Expect(1, 126126, '\p{^Nv=2.50e-01}', "");
    Expect(1, 126126, '\P{Nv=2.50e-01}', "");
    Expect(0, 126126, '\P{^Nv=2.50e-01}', "");
    Expect(1, 126125, '\p{Nv=0.25}', "");
    Expect(0, 126125, '\p{^Nv=0.25}', "");
    Expect(0, 126125, '\P{Nv=0.25}', "");
    Expect(1, 126125, '\P{^Nv=0.25}', "");
    Expect(0, 126126, '\p{Nv=0.25}', "");
    Expect(1, 126126, '\p{^Nv=0.25}', "");
    Expect(1, 126126, '\P{Nv=0.25}', "");
    Expect(0, 126126, '\P{^Nv=0.25}', "");
    Expect(1, 126125, '\p{Nv: 2.500e-01}', "");
    Expect(0, 126125, '\p{^Nv: 2.500e-01}', "");
    Expect(0, 126125, '\P{Nv: 2.500e-01}', "");
    Expect(1, 126125, '\P{^Nv: 2.500e-01}', "");
    Expect(0, 126126, '\p{Nv: 2.500e-01}', "");
    Expect(1, 126126, '\p{^Nv: 2.500e-01}', "");
    Expect(1, 126126, '\P{Nv: 2.500e-01}', "");
    Expect(0, 126126, '\P{^Nv: 2.500e-01}', "");
    Expect(1, 126125, '\p{Nv=0.250}', "");
    Expect(0, 126125, '\p{^Nv=0.250}', "");
    Expect(0, 126125, '\P{Nv=0.250}', "");
    Expect(1, 126125, '\P{^Nv=0.250}', "");
    Expect(0, 126126, '\p{Nv=0.250}', "");
    Expect(1, 126126, '\p{^Nv=0.250}', "");
    Expect(1, 126126, '\P{Nv=0.250}', "");
    Expect(0, 126126, '\P{^Nv=0.250}', "");
    Error('\p{Is_Numeric_Value=_ 01/0004/a/}');
    Error('\P{Is_Numeric_Value=_ 01/0004/a/}');
    Expect(1, 126125, '\p{Is_Numeric_Value=0001/004}', "");
    Expect(0, 126125, '\p{^Is_Numeric_Value=0001/004}', "");
    Expect(0, 126125, '\P{Is_Numeric_Value=0001/004}', "");
    Expect(1, 126125, '\P{^Is_Numeric_Value=0001/004}', "");
    Expect(0, 126126, '\p{Is_Numeric_Value=0001/004}', "");
    Expect(1, 126126, '\p{^Is_Numeric_Value=0001/004}', "");
    Expect(1, 126126, '\P{Is_Numeric_Value=0001/004}', "");
    Expect(0, 126126, '\P{^Is_Numeric_Value=0001/004}', "");
    Expect(1, 126125, '\p{Is_Numeric_Value: 60/240}', "");
    Expect(0, 126125, '\p{^Is_Numeric_Value: 60/240}', "");
    Expect(0, 126125, '\P{Is_Numeric_Value: 60/240}', "");
    Expect(1, 126125, '\P{^Is_Numeric_Value: 60/240}', "");
    Expect(0, 126126, '\p{Is_Numeric_Value: 60/240}', "");
    Expect(1, 126126, '\p{^Is_Numeric_Value: 60/240}', "");
    Expect(1, 126126, '\P{Is_Numeric_Value: 60/240}', "");
    Expect(0, 126126, '\P{^Is_Numeric_Value: 60/240}', "");
    Expect(1, 126125, '\p{Is_Numeric_Value: 2.5e-01}', "");
    Expect(0, 126125, '\p{^Is_Numeric_Value: 2.5e-01}', "");
    Expect(0, 126125, '\P{Is_Numeric_Value: 2.5e-01}', "");
    Expect(1, 126125, '\P{^Is_Numeric_Value: 2.5e-01}', "");
    Expect(0, 126126, '\p{Is_Numeric_Value: 2.5e-01}', "");
    Expect(1, 126126, '\p{^Is_Numeric_Value: 2.5e-01}', "");
    Expect(1, 126126, '\P{Is_Numeric_Value: 2.5e-01}', "");
    Expect(0, 126126, '\P{^Is_Numeric_Value: 2.5e-01}', "");
    Expect(1, 126125, '\p{Is_Numeric_Value=2.50e-01}', "");
    Expect(0, 126125, '\p{^Is_Numeric_Value=2.50e-01}', "");
    Expect(0, 126125, '\P{Is_Numeric_Value=2.50e-01}', "");
    Expect(1, 126125, '\P{^Is_Numeric_Value=2.50e-01}', "");
    Expect(0, 126126, '\p{Is_Numeric_Value=2.50e-01}', "");
    Expect(1, 126126, '\p{^Is_Numeric_Value=2.50e-01}', "");
    Expect(1, 126126, '\P{Is_Numeric_Value=2.50e-01}', "");
    Expect(0, 126126, '\P{^Is_Numeric_Value=2.50e-01}', "");
    Expect(1, 126125, '\p{Is_Numeric_Value=0.25}', "");
    Expect(0, 126125, '\p{^Is_Numeric_Value=0.25}', "");
    Expect(0, 126125, '\P{Is_Numeric_Value=0.25}', "");
    Expect(1, 126125, '\P{^Is_Numeric_Value=0.25}', "");
    Expect(0, 126126, '\p{Is_Numeric_Value=0.25}', "");
    Expect(1, 126126, '\p{^Is_Numeric_Value=0.25}', "");
    Expect(1, 126126, '\P{Is_Numeric_Value=0.25}', "");
    Expect(0, 126126, '\P{^Is_Numeric_Value=0.25}', "");
    Expect(1, 126125, '\p{Is_Numeric_Value=2.500e-01}', "");
    Expect(0, 126125, '\p{^Is_Numeric_Value=2.500e-01}', "");
    Expect(0, 126125, '\P{Is_Numeric_Value=2.500e-01}', "");
    Expect(1, 126125, '\P{^Is_Numeric_Value=2.500e-01}', "");
    Expect(0, 126126, '\p{Is_Numeric_Value=2.500e-01}', "");
    Expect(1, 126126, '\p{^Is_Numeric_Value=2.500e-01}', "");
    Expect(1, 126126, '\P{Is_Numeric_Value=2.500e-01}', "");
    Expect(0, 126126, '\P{^Is_Numeric_Value=2.500e-01}', "");
    Expect(1, 126125, '\p{Is_Numeric_Value=0.250}', "");
    Expect(0, 126125, '\p{^Is_Numeric_Value=0.250}', "");
    Expect(0, 126125, '\P{Is_Numeric_Value=0.250}', "");
    Expect(1, 126125, '\P{^Is_Numeric_Value=0.250}', "");
    Expect(0, 126126, '\p{Is_Numeric_Value=0.250}', "");
    Expect(1, 126126, '\p{^Is_Numeric_Value=0.250}', "");
    Expect(1, 126126, '\P{Is_Numeric_Value=0.250}', "");
    Expect(0, 126126, '\P{^Is_Numeric_Value=0.250}', "");
    Error('\p{Is_Nv:    /a/+00000001/000000004}');
    Error('\P{Is_Nv:    /a/+00000001/000000004}');
    Expect(1, 126125, '\p{Is_Nv=00001/0000004}', "");
    Expect(0, 126125, '\p{^Is_Nv=00001/0000004}', "");
    Expect(0, 126125, '\P{Is_Nv=00001/0000004}', "");
    Expect(1, 126125, '\P{^Is_Nv=00001/0000004}', "");
    Expect(0, 126126, '\p{Is_Nv=00001/0000004}', "");
    Expect(1, 126126, '\p{^Is_Nv=00001/0000004}', "");
    Expect(1, 126126, '\P{Is_Nv=00001/0000004}', "");
    Expect(0, 126126, '\P{^Is_Nv=00001/0000004}', "");
    Expect(1, 126125, '\p{Is_Nv=60/240}', "");
    Expect(0, 126125, '\p{^Is_Nv=60/240}', "");
    Expect(0, 126125, '\P{Is_Nv=60/240}', "");
    Expect(1, 126125, '\P{^Is_Nv=60/240}', "");
    Expect(0, 126126, '\p{Is_Nv=60/240}', "");
    Expect(1, 126126, '\p{^Is_Nv=60/240}', "");
    Expect(1, 126126, '\P{Is_Nv=60/240}', "");
    Expect(0, 126126, '\P{^Is_Nv=60/240}', "");
    Expect(1, 126125, '\p{Is_Nv=2.5e-01}', "");
    Expect(0, 126125, '\p{^Is_Nv=2.5e-01}', "");
    Expect(0, 126125, '\P{Is_Nv=2.5e-01}', "");
    Expect(1, 126125, '\P{^Is_Nv=2.5e-01}', "");
    Expect(0, 126126, '\p{Is_Nv=2.5e-01}', "");
    Expect(1, 126126, '\p{^Is_Nv=2.5e-01}', "");
    Expect(1, 126126, '\P{Is_Nv=2.5e-01}', "");
    Expect(0, 126126, '\P{^Is_Nv=2.5e-01}', "");
    Expect(1, 126125, '\p{Is_Nv=2.50e-01}', "");
    Expect(0, 126125, '\p{^Is_Nv=2.50e-01}', "");
    Expect(0, 126125, '\P{Is_Nv=2.50e-01}', "");
    Expect(1, 126125, '\P{^Is_Nv=2.50e-01}', "");
    Expect(0, 126126, '\p{Is_Nv=2.50e-01}', "");
    Expect(1, 126126, '\p{^Is_Nv=2.50e-01}', "");
    Expect(1, 126126, '\P{Is_Nv=2.50e-01}', "");
    Expect(0, 126126, '\P{^Is_Nv=2.50e-01}', "");
    Expect(1, 126125, '\p{Is_Nv=0.25}', "");
    Expect(0, 126125, '\p{^Is_Nv=0.25}', "");
    Expect(0, 126125, '\P{Is_Nv=0.25}', "");
    Expect(1, 126125, '\P{^Is_Nv=0.25}', "");
    Expect(0, 126126, '\p{Is_Nv=0.25}', "");
    Expect(1, 126126, '\p{^Is_Nv=0.25}', "");
    Expect(1, 126126, '\P{Is_Nv=0.25}', "");
    Expect(0, 126126, '\P{^Is_Nv=0.25}', "");
    Expect(1, 126125, '\p{Is_Nv=2.500e-01}', "");
    Expect(0, 126125, '\p{^Is_Nv=2.500e-01}', "");
    Expect(0, 126125, '\P{Is_Nv=2.500e-01}', "");
    Expect(1, 126125, '\P{^Is_Nv=2.500e-01}', "");
    Expect(0, 126126, '\p{Is_Nv=2.500e-01}', "");
    Expect(1, 126126, '\p{^Is_Nv=2.500e-01}', "");
    Expect(1, 126126, '\P{Is_Nv=2.500e-01}', "");
    Expect(0, 126126, '\P{^Is_Nv=2.500e-01}', "");
    Expect(1, 126125, '\p{Is_Nv=0.250}', "");
    Expect(0, 126125, '\p{^Is_Nv=0.250}', "");
    Expect(0, 126125, '\P{Is_Nv=0.250}', "");
    Expect(1, 126125, '\P{^Is_Nv=0.250}', "");
    Expect(0, 126126, '\p{Is_Nv=0.250}', "");
    Expect(1, 126126, '\p{^Is_Nv=0.250}', "");
    Expect(1, 126126, '\P{Is_Nv=0.250}', "");
    Expect(0, 126126, '\P{^Is_Nv=0.250}', "");
    Error('\p{Numeric_Value=/a/+0000001/040}');
    Error('\P{Numeric_Value=/a/+0000001/040}');
    Expect(1, 73668, '\p{Numeric_Value=:\A1/40\z:}', "");;
    Expect(0, 73669, '\p{Numeric_Value=:\A1/40\z:}', "");;
    Expect(1, 73668, '\p{Numeric_Value=00000001/0000040}', "");
    Expect(0, 73668, '\p{^Numeric_Value=00000001/0000040}', "");
    Expect(0, 73668, '\P{Numeric_Value=00000001/0000040}', "");
    Expect(1, 73668, '\P{^Numeric_Value=00000001/0000040}', "");
    Expect(0, 73669, '\p{Numeric_Value=00000001/0000040}', "");
    Expect(1, 73669, '\p{^Numeric_Value=00000001/0000040}', "");
    Expect(1, 73669, '\P{Numeric_Value=00000001/0000040}', "");
    Expect(0, 73669, '\P{^Numeric_Value=00000001/0000040}', "");
    Expect(1, 73668, '\p{Numeric_Value:	60/2400}', "");
    Expect(0, 73668, '\p{^Numeric_Value:	60/2400}', "");
    Expect(0, 73668, '\P{Numeric_Value:	60/2400}', "");
    Expect(1, 73668, '\P{^Numeric_Value:	60/2400}', "");
    Expect(0, 73669, '\p{Numeric_Value:	60/2400}', "");
    Expect(1, 73669, '\p{^Numeric_Value:	60/2400}', "");
    Expect(1, 73669, '\P{Numeric_Value:	60/2400}', "");
    Expect(0, 73669, '\P{^Numeric_Value:	60/2400}', "");
    Expect(1, 73668, '\p{Numeric_Value=2.5e-02}', "");
    Expect(0, 73668, '\p{^Numeric_Value=2.5e-02}', "");
    Expect(0, 73668, '\P{Numeric_Value=2.5e-02}', "");
    Expect(1, 73668, '\P{^Numeric_Value=2.5e-02}', "");
    Expect(0, 73669, '\p{Numeric_Value=2.5e-02}', "");
    Expect(1, 73669, '\p{^Numeric_Value=2.5e-02}', "");
    Expect(1, 73669, '\P{Numeric_Value=2.5e-02}', "");
    Expect(0, 73669, '\P{^Numeric_Value=2.5e-02}', "");
    Expect(1, 73668, '\p{Numeric_Value=2.50e-02}', "");
    Expect(0, 73668, '\p{^Numeric_Value=2.50e-02}', "");
    Expect(0, 73668, '\P{Numeric_Value=2.50e-02}', "");
    Expect(1, 73668, '\P{^Numeric_Value=2.50e-02}', "");
    Expect(0, 73669, '\p{Numeric_Value=2.50e-02}', "");
    Expect(1, 73669, '\p{^Numeric_Value=2.50e-02}', "");
    Expect(1, 73669, '\P{Numeric_Value=2.50e-02}', "");
    Expect(0, 73669, '\P{^Numeric_Value=2.50e-02}', "");
    Error('\p{Numeric_Value=0.03}');
    Error('\P{Numeric_Value=0.03}');
    Expect(1, 73668, '\p{Numeric_Value=2.500e-02}', "");
    Expect(0, 73668, '\p{^Numeric_Value=2.500e-02}', "");
    Expect(0, 73668, '\P{Numeric_Value=2.500e-02}', "");
    Expect(1, 73668, '\P{^Numeric_Value=2.500e-02}', "");
    Expect(0, 73669, '\p{Numeric_Value=2.500e-02}', "");
    Expect(1, 73669, '\p{^Numeric_Value=2.500e-02}', "");
    Expect(1, 73669, '\P{Numeric_Value=2.500e-02}', "");
    Expect(0, 73669, '\P{^Numeric_Value=2.500e-02}', "");
    Expect(1, 73668, '\p{Numeric_Value=0.025}', "");
    Expect(0, 73668, '\p{^Numeric_Value=0.025}', "");
    Expect(0, 73668, '\P{Numeric_Value=0.025}', "");
    Expect(1, 73668, '\P{^Numeric_Value=0.025}', "");
    Expect(0, 73669, '\p{Numeric_Value=0.025}', "");
    Expect(1, 73669, '\p{^Numeric_Value=0.025}', "");
    Expect(1, 73669, '\P{Numeric_Value=0.025}', "");
    Expect(0, 73669, '\P{^Numeric_Value=0.025}', "");
    Expect(1, 73668, '\p{Numeric_Value=2.5000e-02}', "");
    Expect(0, 73668, '\p{^Numeric_Value=2.5000e-02}', "");
    Expect(0, 73668, '\P{Numeric_Value=2.5000e-02}', "");
    Expect(1, 73668, '\P{^Numeric_Value=2.5000e-02}', "");
    Expect(0, 73669, '\p{Numeric_Value=2.5000e-02}', "");
    Expect(1, 73669, '\p{^Numeric_Value=2.5000e-02}', "");
    Expect(1, 73669, '\P{Numeric_Value=2.5000e-02}', "");
    Expect(0, 73669, '\P{^Numeric_Value=2.5000e-02}', "");
    Expect(1, 73668, '\p{Numeric_Value=0.0250}', "");
    Expect(0, 73668, '\p{^Numeric_Value=0.0250}', "");
    Expect(0, 73668, '\P{Numeric_Value=0.0250}', "");
    Expect(1, 73668, '\P{^Numeric_Value=0.0250}', "");
    Expect(0, 73669, '\p{Numeric_Value=0.0250}', "");
    Expect(1, 73669, '\p{^Numeric_Value=0.0250}', "");
    Expect(1, 73669, '\P{Numeric_Value=0.0250}', "");
    Expect(0, 73669, '\P{^Numeric_Value=0.0250}', "");
    Error('\p{Nv=:= 00001/000040}');
    Error('\P{Nv=:= 00001/000040}');
    Expect(1, 73668, '\p{Nv=:\A1/40\z:}', "");;
    Expect(0, 73669, '\p{Nv=:\A1/40\z:}', "");;
    Expect(1, 73668, '\p{Nv=0001/00000000040}', "");
    Expect(0, 73668, '\p{^Nv=0001/00000000040}', "");
    Expect(0, 73668, '\P{Nv=0001/00000000040}', "");
    Expect(1, 73668, '\P{^Nv=0001/00000000040}', "");
    Expect(0, 73669, '\p{Nv=0001/00000000040}', "");
    Expect(1, 73669, '\p{^Nv=0001/00000000040}', "");
    Expect(1, 73669, '\P{Nv=0001/00000000040}', "");
    Expect(0, 73669, '\P{^Nv=0001/00000000040}', "");
    Expect(1, 73668, '\p{Nv=60/2400}', "");
    Expect(0, 73668, '\p{^Nv=60/2400}', "");
    Expect(0, 73668, '\P{Nv=60/2400}', "");
    Expect(1, 73668, '\P{^Nv=60/2400}', "");
    Expect(0, 73669, '\p{Nv=60/2400}', "");
    Expect(1, 73669, '\p{^Nv=60/2400}', "");
    Expect(1, 73669, '\P{Nv=60/2400}', "");
    Expect(0, 73669, '\P{^Nv=60/2400}', "");
    Expect(1, 73668, '\p{Nv=2.5e-02}', "");
    Expect(0, 73668, '\p{^Nv=2.5e-02}', "");
    Expect(0, 73668, '\P{Nv=2.5e-02}', "");
    Expect(1, 73668, '\P{^Nv=2.5e-02}', "");
    Expect(0, 73669, '\p{Nv=2.5e-02}', "");
    Expect(1, 73669, '\p{^Nv=2.5e-02}', "");
    Expect(1, 73669, '\P{Nv=2.5e-02}', "");
    Expect(0, 73669, '\P{^Nv=2.5e-02}', "");
    Expect(1, 73668, '\p{Nv=2.50e-02}', "");
    Expect(0, 73668, '\p{^Nv=2.50e-02}', "");
    Expect(0, 73668, '\P{Nv=2.50e-02}', "");
    Expect(1, 73668, '\P{^Nv=2.50e-02}', "");
    Expect(0, 73669, '\p{Nv=2.50e-02}', "");
    Expect(1, 73669, '\p{^Nv=2.50e-02}', "");
    Expect(1, 73669, '\P{Nv=2.50e-02}', "");
    Expect(0, 73669, '\P{^Nv=2.50e-02}', "");
    Error('\p{Nv=0.03}');
    Error('\P{Nv=0.03}');
    Expect(1, 73668, '\p{Nv=2.500e-02}', "");
    Expect(0, 73668, '\p{^Nv=2.500e-02}', "");
    Expect(0, 73668, '\P{Nv=2.500e-02}', "");
    Expect(1, 73668, '\P{^Nv=2.500e-02}', "");
    Expect(0, 73669, '\p{Nv=2.500e-02}', "");
    Expect(1, 73669, '\p{^Nv=2.500e-02}', "");
    Expect(1, 73669, '\P{Nv=2.500e-02}', "");
    Expect(0, 73669, '\P{^Nv=2.500e-02}', "");
    Expect(1, 73668, '\p{Nv=0.025}', "");
    Expect(0, 73668, '\p{^Nv=0.025}', "");
    Expect(0, 73668, '\P{Nv=0.025}', "");
    Expect(1, 73668, '\P{^Nv=0.025}', "");
    Expect(0, 73669, '\p{Nv=0.025}', "");
    Expect(1, 73669, '\p{^Nv=0.025}', "");
    Expect(1, 73669, '\P{Nv=0.025}', "");
    Expect(0, 73669, '\P{^Nv=0.025}', "");
    Expect(1, 73668, '\p{Nv=2.5000e-02}', "");
    Expect(0, 73668, '\p{^Nv=2.5000e-02}', "");
    Expect(0, 73668, '\P{Nv=2.5000e-02}', "");
    Expect(1, 73668, '\P{^Nv=2.5000e-02}', "");
    Expect(0, 73669, '\p{Nv=2.5000e-02}', "");
    Expect(1, 73669, '\p{^Nv=2.5000e-02}', "");
    Expect(1, 73669, '\P{Nv=2.5000e-02}', "");
    Expect(0, 73669, '\P{^Nv=2.5000e-02}', "");
    Expect(1, 73668, '\p{Nv=0.0250}', "");
    Expect(0, 73668, '\p{^Nv=0.0250}', "");
    Expect(0, 73668, '\P{Nv=0.0250}', "");
    Expect(1, 73668, '\P{^Nv=0.0250}', "");
    Expect(0, 73669, '\p{Nv=0.0250}', "");
    Expect(1, 73669, '\p{^Nv=0.0250}', "");
    Expect(1, 73669, '\P{Nv=0.0250}', "");
    Expect(0, 73669, '\P{^Nv=0.0250}', "");
    Error('\p{Is_Numeric_Value=:=0000000001/000000040}');
    Error('\P{Is_Numeric_Value=:=0000000001/000000040}');
    Expect(1, 73668, '\p{Is_Numeric_Value=+00000001/000040}', "");
    Expect(0, 73668, '\p{^Is_Numeric_Value=+00000001/000040}', "");
    Expect(0, 73668, '\P{Is_Numeric_Value=+00000001/000040}', "");
    Expect(1, 73668, '\P{^Is_Numeric_Value=+00000001/000040}', "");
    Expect(0, 73669, '\p{Is_Numeric_Value=+00000001/000040}', "");
    Expect(1, 73669, '\p{^Is_Numeric_Value=+00000001/000040}', "");
    Expect(1, 73669, '\P{Is_Numeric_Value=+00000001/000040}', "");
    Expect(0, 73669, '\P{^Is_Numeric_Value=+00000001/000040}', "");
    Expect(1, 73668, '\p{Is_Numeric_Value:	60/2400}', "");
    Expect(0, 73668, '\p{^Is_Numeric_Value:	60/2400}', "");
    Expect(0, 73668, '\P{Is_Numeric_Value:	60/2400}', "");
    Expect(1, 73668, '\P{^Is_Numeric_Value:	60/2400}', "");
    Expect(0, 73669, '\p{Is_Numeric_Value:	60/2400}', "");
    Expect(1, 73669, '\p{^Is_Numeric_Value:	60/2400}', "");
    Expect(1, 73669, '\P{Is_Numeric_Value:	60/2400}', "");
    Expect(0, 73669, '\P{^Is_Numeric_Value:	60/2400}', "");
    Expect(1, 73668, '\p{Is_Numeric_Value: 2.5e-02}', "");
    Expect(0, 73668, '\p{^Is_Numeric_Value: 2.5e-02}', "");
    Expect(0, 73668, '\P{Is_Numeric_Value: 2.5e-02}', "");
    Expect(1, 73668, '\P{^Is_Numeric_Value: 2.5e-02}', "");
    Expect(0, 73669, '\p{Is_Numeric_Value: 2.5e-02}', "");
    Expect(1, 73669, '\p{^Is_Numeric_Value: 2.5e-02}', "");
    Expect(1, 73669, '\P{Is_Numeric_Value: 2.5e-02}', "");
    Expect(0, 73669, '\P{^Is_Numeric_Value: 2.5e-02}', "");
    Expect(1, 73668, '\p{Is_Numeric_Value=2.50e-02}', "");
    Expect(0, 73668, '\p{^Is_Numeric_Value=2.50e-02}', "");
    Expect(0, 73668, '\P{Is_Numeric_Value=2.50e-02}', "");
    Expect(1, 73668, '\P{^Is_Numeric_Value=2.50e-02}', "");
    Expect(0, 73669, '\p{Is_Numeric_Value=2.50e-02}', "");
    Expect(1, 73669, '\p{^Is_Numeric_Value=2.50e-02}', "");
    Expect(1, 73669, '\P{Is_Numeric_Value=2.50e-02}', "");
    Expect(0, 73669, '\P{^Is_Numeric_Value=2.50e-02}', "");
    Error('\p{Is_Numeric_Value:   0.03}');
    Error('\P{Is_Numeric_Value:   0.03}');
    Expect(1, 73668, '\p{Is_Numeric_Value=2.500e-02}', "");
    Expect(0, 73668, '\p{^Is_Numeric_Value=2.500e-02}', "");
    Expect(0, 73668, '\P{Is_Numeric_Value=2.500e-02}', "");
    Expect(1, 73668, '\P{^Is_Numeric_Value=2.500e-02}', "");
    Expect(0, 73669, '\p{Is_Numeric_Value=2.500e-02}', "");
    Expect(1, 73669, '\p{^Is_Numeric_Value=2.500e-02}', "");
    Expect(1, 73669, '\P{Is_Numeric_Value=2.500e-02}', "");
    Expect(0, 73669, '\P{^Is_Numeric_Value=2.500e-02}', "");
    Expect(1, 73668, '\p{Is_Numeric_Value=0.025}', "");
    Expect(0, 73668, '\p{^Is_Numeric_Value=0.025}', "");
    Expect(0, 73668, '\P{Is_Numeric_Value=0.025}', "");
    Expect(1, 73668, '\P{^Is_Numeric_Value=0.025}', "");
    Expect(0, 73669, '\p{Is_Numeric_Value=0.025}', "");
    Expect(1, 73669, '\p{^Is_Numeric_Value=0.025}', "");
    Expect(1, 73669, '\P{Is_Numeric_Value=0.025}', "");
    Expect(0, 73669, '\P{^Is_Numeric_Value=0.025}', "");
    Expect(1, 73668, '\p{Is_Numeric_Value=2.5000e-02}', "");
    Expect(0, 73668, '\p{^Is_Numeric_Value=2.5000e-02}', "");
    Expect(0, 73668, '\P{Is_Numeric_Value=2.5000e-02}', "");
    Expect(1, 73668, '\P{^Is_Numeric_Value=2.5000e-02}', "");
    Expect(0, 73669, '\p{Is_Numeric_Value=2.5000e-02}', "");
    Expect(1, 73669, '\p{^Is_Numeric_Value=2.5000e-02}', "");
    Expect(1, 73669, '\P{Is_Numeric_Value=2.5000e-02}', "");
    Expect(0, 73669, '\P{^Is_Numeric_Value=2.5000e-02}', "");
    Expect(1, 73668, '\p{Is_Numeric_Value=0.0250}', "");
    Expect(0, 73668, '\p{^Is_Numeric_Value=0.0250}', "");
    Expect(0, 73668, '\P{Is_Numeric_Value=0.0250}', "");
    Expect(1, 73668, '\P{^Is_Numeric_Value=0.0250}', "");
    Expect(0, 73669, '\p{Is_Numeric_Value=0.0250}', "");
    Expect(1, 73669, '\p{^Is_Numeric_Value=0.0250}', "");
    Expect(1, 73669, '\P{Is_Numeric_Value=0.0250}', "");
    Expect(0, 73669, '\P{^Is_Numeric_Value=0.0250}', "");
    Error('\p{Is_Nv=/a/_ 00000001/0000000040}');
    Error('\P{Is_Nv=/a/_ 00000001/0000000040}');
    Expect(1, 73668, '\p{Is_Nv=+001/00040}', "");
    Expect(0, 73668, '\p{^Is_Nv=+001/00040}', "");
    Expect(0, 73668, '\P{Is_Nv=+001/00040}', "");
    Expect(1, 73668, '\P{^Is_Nv=+001/00040}', "");
    Expect(0, 73669, '\p{Is_Nv=+001/00040}', "");
    Expect(1, 73669, '\p{^Is_Nv=+001/00040}', "");
    Expect(1, 73669, '\P{Is_Nv=+001/00040}', "");
    Expect(0, 73669, '\P{^Is_Nv=+001/00040}', "");
    Expect(1, 73668, '\p{Is_Nv=60/2400}', "");
    Expect(0, 73668, '\p{^Is_Nv=60/2400}', "");
    Expect(0, 73668, '\P{Is_Nv=60/2400}', "");
    Expect(1, 73668, '\P{^Is_Nv=60/2400}', "");
    Expect(0, 73669, '\p{Is_Nv=60/2400}', "");
    Expect(1, 73669, '\p{^Is_Nv=60/2400}', "");
    Expect(1, 73669, '\P{Is_Nv=60/2400}', "");
    Expect(0, 73669, '\P{^Is_Nv=60/2400}', "");
    Expect(1, 73668, '\p{Is_Nv=2.5e-02}', "");
    Expect(0, 73668, '\p{^Is_Nv=2.5e-02}', "");
    Expect(0, 73668, '\P{Is_Nv=2.5e-02}', "");
    Expect(1, 73668, '\P{^Is_Nv=2.5e-02}', "");
    Expect(0, 73669, '\p{Is_Nv=2.5e-02}', "");
    Expect(1, 73669, '\p{^Is_Nv=2.5e-02}', "");
    Expect(1, 73669, '\P{Is_Nv=2.5e-02}', "");
    Expect(0, 73669, '\P{^Is_Nv=2.5e-02}', "");
    Expect(1, 73668, '\p{Is_Nv=2.50e-02}', "");
    Expect(0, 73668, '\p{^Is_Nv=2.50e-02}', "");
    Expect(0, 73668, '\P{Is_Nv=2.50e-02}', "");
    Expect(1, 73668, '\P{^Is_Nv=2.50e-02}', "");
    Expect(0, 73669, '\p{Is_Nv=2.50e-02}', "");
    Expect(1, 73669, '\p{^Is_Nv=2.50e-02}', "");
    Expect(1, 73669, '\P{Is_Nv=2.50e-02}', "");
    Expect(0, 73669, '\P{^Is_Nv=2.50e-02}', "");
    Error('\p{Is_Nv:0.03}');
    Error('\P{Is_Nv:0.03}');
    Expect(1, 73668, '\p{Is_Nv=2.500e-02}', "");
    Expect(0, 73668, '\p{^Is_Nv=2.500e-02}', "");
    Expect(0, 73668, '\P{Is_Nv=2.500e-02}', "");
    Expect(1, 73668, '\P{^Is_Nv=2.500e-02}', "");
    Expect(0, 73669, '\p{Is_Nv=2.500e-02}', "");
    Expect(1, 73669, '\p{^Is_Nv=2.500e-02}', "");
    Expect(1, 73669, '\P{Is_Nv=2.500e-02}', "");
    Expect(0, 73669, '\P{^Is_Nv=2.500e-02}', "");
    Expect(1, 73668, '\p{Is_Nv=0.025}', "");
    Expect(0, 73668, '\p{^Is_Nv=0.025}', "");
    Expect(0, 73668, '\P{Is_Nv=0.025}', "");
    Expect(1, 73668, '\P{^Is_Nv=0.025}', "");
    Expect(0, 73669, '\p{Is_Nv=0.025}', "");
    Expect(1, 73669, '\p{^Is_Nv=0.025}', "");
    Expect(1, 73669, '\P{Is_Nv=0.025}', "");
    Expect(0, 73669, '\P{^Is_Nv=0.025}', "");
    Expect(1, 73668, '\p{Is_Nv=2.5000e-02}', "");
    Expect(0, 73668, '\p{^Is_Nv=2.5000e-02}', "");
    Expect(0, 73668, '\P{Is_Nv=2.5000e-02}', "");
    Expect(1, 73668, '\P{^Is_Nv=2.5000e-02}', "");
    Expect(0, 73669, '\p{Is_Nv=2.5000e-02}', "");
    Expect(1, 73669, '\p{^Is_Nv=2.5000e-02}', "");
    Expect(1, 73669, '\P{Is_Nv=2.5000e-02}', "");
    Expect(0, 73669, '\P{^Is_Nv=2.5000e-02}', "");
    Expect(1, 73668, '\p{Is_Nv: 0.0250}', "");
    Expect(0, 73668, '\p{^Is_Nv: 0.0250}', "");
    Expect(0, 73668, '\P{Is_Nv: 0.0250}', "");
    Expect(1, 73668, '\P{^Is_Nv: 0.0250}', "");
    Expect(0, 73669, '\p{Is_Nv: 0.0250}', "");
    Expect(1, 73669, '\p{^Is_Nv: 0.0250}', "");
    Expect(1, 73669, '\P{Is_Nv: 0.0250}', "");
    Expect(0, 73669, '\P{^Is_Nv: 0.0250}', "");
    Error('\p{Numeric_Value:   :=	 0000001/000005}');
    Error('\P{Numeric_Value:   :=	 0000001/000005}');
    Expect(1, 73679, '\p{Numeric_Value=:\A1/5\z:}', "");;
    Expect(0, 73680, '\p{Numeric_Value=:\A1/5\z:}', "");;
    Expect(1, 73679, '\p{Numeric_Value=+01/000000005}', "");
    Expect(0, 73679, '\p{^Numeric_Value=+01/000000005}', "");
    Expect(0, 73679, '\P{Numeric_Value=+01/000000005}', "");
    Expect(1, 73679, '\P{^Numeric_Value=+01/000000005}', "");
    Expect(0, 73680, '\p{Numeric_Value=+01/000000005}', "");
    Expect(1, 73680, '\p{^Numeric_Value=+01/000000005}', "");
    Expect(1, 73680, '\P{Numeric_Value=+01/000000005}', "");
    Expect(0, 73680, '\P{^Numeric_Value=+01/000000005}', "");
    Expect(1, 73679, '\p{Numeric_Value=60/300}', "");
    Expect(0, 73679, '\p{^Numeric_Value=60/300}', "");
    Expect(0, 73679, '\P{Numeric_Value=60/300}', "");
    Expect(1, 73679, '\P{^Numeric_Value=60/300}', "");
    Expect(0, 73680, '\p{Numeric_Value=60/300}', "");
    Expect(1, 73680, '\p{^Numeric_Value=60/300}', "");
    Expect(1, 73680, '\P{Numeric_Value=60/300}', "");
    Expect(0, 73680, '\P{^Numeric_Value=60/300}', "");
    Expect(1, 73679, '\p{Numeric_Value=2.0e-01}', "");
    Expect(0, 73679, '\p{^Numeric_Value=2.0e-01}', "");
    Expect(0, 73679, '\P{Numeric_Value=2.0e-01}', "");
    Expect(1, 73679, '\P{^Numeric_Value=2.0e-01}', "");
    Expect(0, 73680, '\p{Numeric_Value=2.0e-01}', "");
    Expect(1, 73680, '\p{^Numeric_Value=2.0e-01}', "");
    Expect(1, 73680, '\P{Numeric_Value=2.0e-01}', "");
    Expect(0, 73680, '\P{^Numeric_Value=2.0e-01}', "");
    Expect(1, 73679, '\p{Numeric_Value=0.2}', "");
    Expect(0, 73679, '\p{^Numeric_Value=0.2}', "");
    Expect(0, 73679, '\P{Numeric_Value=0.2}', "");
    Expect(1, 73679, '\P{^Numeric_Value=0.2}', "");
    Expect(0, 73680, '\p{Numeric_Value=0.2}', "");
    Expect(1, 73680, '\p{^Numeric_Value=0.2}', "");
    Expect(1, 73680, '\P{Numeric_Value=0.2}', "");
    Expect(0, 73680, '\P{^Numeric_Value=0.2}', "");
    Expect(1, 73679, '\p{Numeric_Value=2.00e-01}', "");
    Expect(0, 73679, '\p{^Numeric_Value=2.00e-01}', "");
    Expect(0, 73679, '\P{Numeric_Value=2.00e-01}', "");
    Expect(1, 73679, '\P{^Numeric_Value=2.00e-01}', "");
    Expect(0, 73680, '\p{Numeric_Value=2.00e-01}', "");
    Expect(1, 73680, '\p{^Numeric_Value=2.00e-01}', "");
    Expect(1, 73680, '\P{Numeric_Value=2.00e-01}', "");
    Expect(0, 73680, '\P{^Numeric_Value=2.00e-01}', "");
    Expect(1, 73679, '\p{Numeric_Value=0.20}', "");
    Expect(0, 73679, '\p{^Numeric_Value=0.20}', "");
    Expect(0, 73679, '\P{Numeric_Value=0.20}', "");
    Expect(1, 73679, '\P{^Numeric_Value=0.20}', "");
    Expect(0, 73680, '\p{Numeric_Value=0.20}', "");
    Expect(1, 73680, '\p{^Numeric_Value=0.20}', "");
    Expect(1, 73680, '\P{Numeric_Value=0.20}', "");
    Expect(0, 73680, '\P{^Numeric_Value=0.20}', "");
    Error('\p{Nv=-_001/0000000005/a/}');
    Error('\P{Nv=-_001/0000000005/a/}');
    Expect(1, 73679, '\p{Nv=:\A1/5\z:}', "");;
    Expect(0, 73680, '\p{Nv=:\A1/5\z:}', "");;
    Expect(1, 73679, '\p{Nv=+00000001/0000000005}', "");
    Expect(0, 73679, '\p{^Nv=+00000001/0000000005}', "");
    Expect(0, 73679, '\P{Nv=+00000001/0000000005}', "");
    Expect(1, 73679, '\P{^Nv=+00000001/0000000005}', "");
    Expect(0, 73680, '\p{Nv=+00000001/0000000005}', "");
    Expect(1, 73680, '\p{^Nv=+00000001/0000000005}', "");
    Expect(1, 73680, '\P{Nv=+00000001/0000000005}', "");
    Expect(0, 73680, '\P{^Nv=+00000001/0000000005}', "");
    Expect(1, 73679, '\p{Nv=60/300}', "");
    Expect(0, 73679, '\p{^Nv=60/300}', "");
    Expect(0, 73679, '\P{Nv=60/300}', "");
    Expect(1, 73679, '\P{^Nv=60/300}', "");
    Expect(0, 73680, '\p{Nv=60/300}', "");
    Expect(1, 73680, '\p{^Nv=60/300}', "");
    Expect(1, 73680, '\P{Nv=60/300}', "");
    Expect(0, 73680, '\P{^Nv=60/300}', "");
    Expect(1, 73679, '\p{Nv=2.0e-01}', "");
    Expect(0, 73679, '\p{^Nv=2.0e-01}', "");
    Expect(0, 73679, '\P{Nv=2.0e-01}', "");
    Expect(1, 73679, '\P{^Nv=2.0e-01}', "");
    Expect(0, 73680, '\p{Nv=2.0e-01}', "");
    Expect(1, 73680, '\p{^Nv=2.0e-01}', "");
    Expect(1, 73680, '\P{Nv=2.0e-01}', "");
    Expect(0, 73680, '\P{^Nv=2.0e-01}', "");
    Expect(1, 73679, '\p{Nv=0.2}', "");
    Expect(0, 73679, '\p{^Nv=0.2}', "");
    Expect(0, 73679, '\P{Nv=0.2}', "");
    Expect(1, 73679, '\P{^Nv=0.2}', "");
    Expect(0, 73680, '\p{Nv=0.2}', "");
    Expect(1, 73680, '\p{^Nv=0.2}', "");
    Expect(1, 73680, '\P{Nv=0.2}', "");
    Expect(0, 73680, '\P{^Nv=0.2}', "");
    Expect(1, 73679, '\p{Nv:	2.00e-01}', "");
    Expect(0, 73679, '\p{^Nv:	2.00e-01}', "");
    Expect(0, 73679, '\P{Nv:	2.00e-01}', "");
    Expect(1, 73679, '\P{^Nv:	2.00e-01}', "");
    Expect(0, 73680, '\p{Nv:	2.00e-01}', "");
    Expect(1, 73680, '\p{^Nv:	2.00e-01}', "");
    Expect(1, 73680, '\P{Nv:	2.00e-01}', "");
    Expect(0, 73680, '\P{^Nv:	2.00e-01}', "");
    Expect(1, 73679, '\p{Nv=0.20}', "");
    Expect(0, 73679, '\p{^Nv=0.20}', "");
    Expect(0, 73679, '\P{Nv=0.20}', "");
    Expect(1, 73679, '\P{^Nv=0.20}', "");
    Expect(0, 73680, '\p{Nv=0.20}', "");
    Expect(1, 73680, '\p{^Nv=0.20}', "");
    Expect(1, 73680, '\P{Nv=0.20}', "");
    Expect(0, 73680, '\P{^Nv=0.20}', "");
    Error('\p{Is_Numeric_Value=/a/	01/05}');
    Error('\P{Is_Numeric_Value=/a/	01/05}');
    Expect(1, 73679, '\p{Is_Numeric_Value:   +00001/0000000005}', "");
    Expect(0, 73679, '\p{^Is_Numeric_Value:   +00001/0000000005}', "");
    Expect(0, 73679, '\P{Is_Numeric_Value:   +00001/0000000005}', "");
    Expect(1, 73679, '\P{^Is_Numeric_Value:   +00001/0000000005}', "");
    Expect(0, 73680, '\p{Is_Numeric_Value:   +00001/0000000005}', "");
    Expect(1, 73680, '\p{^Is_Numeric_Value:   +00001/0000000005}', "");
    Expect(1, 73680, '\P{Is_Numeric_Value:   +00001/0000000005}', "");
    Expect(0, 73680, '\P{^Is_Numeric_Value:   +00001/0000000005}', "");
    Expect(1, 73679, '\p{Is_Numeric_Value=60/300}', "");
    Expect(0, 73679, '\p{^Is_Numeric_Value=60/300}', "");
    Expect(0, 73679, '\P{Is_Numeric_Value=60/300}', "");
    Expect(1, 73679, '\P{^Is_Numeric_Value=60/300}', "");
    Expect(0, 73680, '\p{Is_Numeric_Value=60/300}', "");
    Expect(1, 73680, '\p{^Is_Numeric_Value=60/300}', "");
    Expect(1, 73680, '\P{Is_Numeric_Value=60/300}', "");
    Expect(0, 73680, '\P{^Is_Numeric_Value=60/300}', "");
    Expect(1, 73679, '\p{Is_Numeric_Value=2.0e-01}', "");
    Expect(0, 73679, '\p{^Is_Numeric_Value=2.0e-01}', "");
    Expect(0, 73679, '\P{Is_Numeric_Value=2.0e-01}', "");
    Expect(1, 73679, '\P{^Is_Numeric_Value=2.0e-01}', "");
    Expect(0, 73680, '\p{Is_Numeric_Value=2.0e-01}', "");
    Expect(1, 73680, '\p{^Is_Numeric_Value=2.0e-01}', "");
    Expect(1, 73680, '\P{Is_Numeric_Value=2.0e-01}', "");
    Expect(0, 73680, '\P{^Is_Numeric_Value=2.0e-01}', "");
    Expect(1, 73679, '\p{Is_Numeric_Value=0.2}', "");
    Expect(0, 73679, '\p{^Is_Numeric_Value=0.2}', "");
    Expect(0, 73679, '\P{Is_Numeric_Value=0.2}', "");
    Expect(1, 73679, '\P{^Is_Numeric_Value=0.2}', "");
    Expect(0, 73680, '\p{Is_Numeric_Value=0.2}', "");
    Expect(1, 73680, '\p{^Is_Numeric_Value=0.2}', "");
    Expect(1, 73680, '\P{Is_Numeric_Value=0.2}', "");
    Expect(0, 73680, '\P{^Is_Numeric_Value=0.2}', "");
    Expect(1, 73679, '\p{Is_Numeric_Value=2.00e-01}', "");
    Expect(0, 73679, '\p{^Is_Numeric_Value=2.00e-01}', "");
    Expect(0, 73679, '\P{Is_Numeric_Value=2.00e-01}', "");
    Expect(1, 73679, '\P{^Is_Numeric_Value=2.00e-01}', "");
    Expect(0, 73680, '\p{Is_Numeric_Value=2.00e-01}', "");
    Expect(1, 73680, '\p{^Is_Numeric_Value=2.00e-01}', "");
    Expect(1, 73680, '\P{Is_Numeric_Value=2.00e-01}', "");
    Expect(0, 73680, '\P{^Is_Numeric_Value=2.00e-01}', "");
    Expect(1, 73679, '\p{Is_Numeric_Value=0.20}', "");
    Expect(0, 73679, '\p{^Is_Numeric_Value=0.20}', "");
    Expect(0, 73679, '\P{Is_Numeric_Value=0.20}', "");
    Expect(1, 73679, '\P{^Is_Numeric_Value=0.20}', "");
    Expect(0, 73680, '\p{Is_Numeric_Value=0.20}', "");
    Expect(1, 73680, '\p{^Is_Numeric_Value=0.20}', "");
    Expect(1, 73680, '\P{Is_Numeric_Value=0.20}', "");
    Expect(0, 73680, '\P{^Is_Numeric_Value=0.20}', "");
    Error('\p{Is_Nv=:= _+00001/00000005}');
    Error('\P{Is_Nv=:= _+00001/00000005}');
    Expect(1, 73679, '\p{Is_Nv=0001/005}', "");
    Expect(0, 73679, '\p{^Is_Nv=0001/005}', "");
    Expect(0, 73679, '\P{Is_Nv=0001/005}', "");
    Expect(1, 73679, '\P{^Is_Nv=0001/005}', "");
    Expect(0, 73680, '\p{Is_Nv=0001/005}', "");
    Expect(1, 73680, '\p{^Is_Nv=0001/005}', "");
    Expect(1, 73680, '\P{Is_Nv=0001/005}', "");
    Expect(0, 73680, '\P{^Is_Nv=0001/005}', "");
    Expect(1, 73679, '\p{Is_Nv=60/300}', "");
    Expect(0, 73679, '\p{^Is_Nv=60/300}', "");
    Expect(0, 73679, '\P{Is_Nv=60/300}', "");
    Expect(1, 73679, '\P{^Is_Nv=60/300}', "");
    Expect(0, 73680, '\p{Is_Nv=60/300}', "");
    Expect(1, 73680, '\p{^Is_Nv=60/300}', "");
    Expect(1, 73680, '\P{Is_Nv=60/300}', "");
    Expect(0, 73680, '\P{^Is_Nv=60/300}', "");
    Expect(1, 73679, '\p{Is_Nv=2.0e-01}', "");
    Expect(0, 73679, '\p{^Is_Nv=2.0e-01}', "");
    Expect(0, 73679, '\P{Is_Nv=2.0e-01}', "");
    Expect(1, 73679, '\P{^Is_Nv=2.0e-01}', "");
    Expect(0, 73680, '\p{Is_Nv=2.0e-01}', "");
    Expect(1, 73680, '\p{^Is_Nv=2.0e-01}', "");
    Expect(1, 73680, '\P{Is_Nv=2.0e-01}', "");
    Expect(0, 73680, '\P{^Is_Nv=2.0e-01}', "");
    Expect(1, 73679, '\p{Is_Nv=0.2}', "");
    Expect(0, 73679, '\p{^Is_Nv=0.2}', "");
    Expect(0, 73679, '\P{Is_Nv=0.2}', "");
    Expect(1, 73679, '\P{^Is_Nv=0.2}', "");
    Expect(0, 73680, '\p{Is_Nv=0.2}', "");
    Expect(1, 73680, '\p{^Is_Nv=0.2}', "");
    Expect(1, 73680, '\P{Is_Nv=0.2}', "");
    Expect(0, 73680, '\P{^Is_Nv=0.2}', "");
    Expect(1, 73679, '\p{Is_Nv=2.00e-01}', "");
    Expect(0, 73679, '\p{^Is_Nv=2.00e-01}', "");
    Expect(0, 73679, '\P{Is_Nv=2.00e-01}', "");
    Expect(1, 73679, '\P{^Is_Nv=2.00e-01}', "");
    Expect(0, 73680, '\p{Is_Nv=2.00e-01}', "");
    Expect(1, 73680, '\p{^Is_Nv=2.00e-01}', "");
    Expect(1, 73680, '\P{Is_Nv=2.00e-01}', "");
    Expect(0, 73680, '\P{^Is_Nv=2.00e-01}', "");
    Expect(1, 73679, '\p{Is_Nv=0.20}', "");
    Expect(0, 73679, '\p{^Is_Nv=0.20}', "");
    Expect(0, 73679, '\P{Is_Nv=0.20}', "");
    Expect(1, 73679, '\P{^Is_Nv=0.20}', "");
    Expect(0, 73680, '\p{Is_Nv=0.20}', "");
    Expect(1, 73680, '\p{^Is_Nv=0.20}', "");
    Expect(1, 73680, '\P{Is_Nv=0.20}', "");
    Expect(0, 73680, '\P{^Is_Nv=0.20}', "");
    Error('\p{Numeric_Value=	/a/001/6}');
    Error('\P{Numeric_Value=	/a/001/6}');
    Expect(1, 126269, '\p{Numeric_Value=:\A1/6\z:}', "");;
    Expect(0, 126270, '\p{Numeric_Value=:\A1/6\z:}', "");;
    Expect(1, 126269, '\p{Numeric_Value=01/6}', "");
    Expect(0, 126269, '\p{^Numeric_Value=01/6}', "");
    Expect(0, 126269, '\P{Numeric_Value=01/6}', "");
    Expect(1, 126269, '\P{^Numeric_Value=01/6}', "");
    Expect(0, 126270, '\p{Numeric_Value=01/6}', "");
    Expect(1, 126270, '\p{^Numeric_Value=01/6}', "");
    Expect(1, 126270, '\P{Numeric_Value=01/6}', "");
    Expect(0, 126270, '\P{^Numeric_Value=01/6}', "");
    Expect(1, 126269, '\p{Numeric_Value=60/360}', "");
    Expect(0, 126269, '\p{^Numeric_Value=60/360}', "");
    Expect(0, 126269, '\P{Numeric_Value=60/360}', "");
    Expect(1, 126269, '\P{^Numeric_Value=60/360}', "");
    Expect(0, 126270, '\p{Numeric_Value=60/360}', "");
    Expect(1, 126270, '\p{^Numeric_Value=60/360}', "");
    Expect(1, 126270, '\P{Numeric_Value=60/360}', "");
    Expect(0, 126270, '\P{^Numeric_Value=60/360}', "");
    Error('\p{Numeric_Value=1.7e-01}');
    Error('\P{Numeric_Value=1.7e-01}');
    Error('\p{Numeric_Value=1.67e-01}');
    Error('\P{Numeric_Value=1.67e-01}');
    Error('\p{Numeric_Value=0.17}');
    Error('\P{Numeric_Value=0.17}');
    Expect(1, 126269, '\p{Numeric_Value=1.667e-01}', "");
    Expect(0, 126269, '\p{^Numeric_Value=1.667e-01}', "");
    Expect(0, 126269, '\P{Numeric_Value=1.667e-01}', "");
    Expect(1, 126269, '\P{^Numeric_Value=1.667e-01}', "");
    Expect(0, 126270, '\p{Numeric_Value=1.667e-01}', "");
    Expect(1, 126270, '\p{^Numeric_Value=1.667e-01}', "");
    Expect(1, 126270, '\P{Numeric_Value=1.667e-01}', "");
    Expect(0, 126270, '\P{^Numeric_Value=1.667e-01}', "");
    Error('\p{Numeric_Value:	0.167}');
    Error('\P{Numeric_Value:	0.167}');
    Expect(1, 126269, '\p{Numeric_Value=1.6667e-01}', "");
    Expect(0, 126269, '\p{^Numeric_Value=1.6667e-01}', "");
    Expect(0, 126269, '\P{Numeric_Value=1.6667e-01}', "");
    Expect(1, 126269, '\P{^Numeric_Value=1.6667e-01}', "");
    Expect(0, 126270, '\p{Numeric_Value=1.6667e-01}', "");
    Expect(1, 126270, '\p{^Numeric_Value=1.6667e-01}', "");
    Expect(1, 126270, '\P{Numeric_Value=1.6667e-01}', "");
    Expect(0, 126270, '\P{^Numeric_Value=1.6667e-01}', "");
    Expect(1, 126269, '\p{Numeric_Value=0.1667}', "");
    Expect(0, 126269, '\p{^Numeric_Value=0.1667}', "");
    Expect(0, 126269, '\P{Numeric_Value=0.1667}', "");
    Expect(1, 126269, '\P{^Numeric_Value=0.1667}', "");
    Expect(0, 126270, '\p{Numeric_Value=0.1667}', "");
    Expect(1, 126270, '\p{^Numeric_Value=0.1667}', "");
    Expect(1, 126270, '\P{Numeric_Value=0.1667}', "");
    Expect(0, 126270, '\P{^Numeric_Value=0.1667}', "");
    Expect(1, 126269, '\p{Numeric_Value=1.66667e-01}', "");
    Expect(0, 126269, '\p{^Numeric_Value=1.66667e-01}', "");
    Expect(0, 126269, '\P{Numeric_Value=1.66667e-01}', "");
    Expect(1, 126269, '\P{^Numeric_Value=1.66667e-01}', "");
    Expect(0, 126270, '\p{Numeric_Value=1.66667e-01}', "");
    Expect(1, 126270, '\p{^Numeric_Value=1.66667e-01}', "");
    Expect(1, 126270, '\P{Numeric_Value=1.66667e-01}', "");
    Expect(0, 126270, '\P{^Numeric_Value=1.66667e-01}', "");
    Expect(1, 126269, '\p{Numeric_Value=0.16667}', "");
    Expect(0, 126269, '\p{^Numeric_Value=0.16667}', "");
    Expect(0, 126269, '\P{Numeric_Value=0.16667}', "");
    Expect(1, 126269, '\P{^Numeric_Value=0.16667}', "");
    Expect(0, 126270, '\p{Numeric_Value=0.16667}', "");
    Expect(1, 126270, '\p{^Numeric_Value=0.16667}', "");
    Expect(1, 126270, '\P{Numeric_Value=0.16667}', "");
    Expect(0, 126270, '\P{^Numeric_Value=0.16667}', "");
    Error('\p{Nv:_ 001/000006/a/}');
    Error('\P{Nv:_ 001/000006/a/}');
    Expect(1, 126269, '\p{Nv=:\A1/6\z:}', "");;
    Expect(0, 126270, '\p{Nv=:\A1/6\z:}', "");;
    Expect(1, 126269, '\p{Nv=+000001/000000006}', "");
    Expect(0, 126269, '\p{^Nv=+000001/000000006}', "");
    Expect(0, 126269, '\P{Nv=+000001/000000006}', "");
    Expect(1, 126269, '\P{^Nv=+000001/000000006}', "");
    Expect(0, 126270, '\p{Nv=+000001/000000006}', "");
    Expect(1, 126270, '\p{^Nv=+000001/000000006}', "");
    Expect(1, 126270, '\P{Nv=+000001/000000006}', "");
    Expect(0, 126270, '\P{^Nv=+000001/000000006}', "");
    Expect(1, 126269, '\p{Nv: 60/360}', "");
    Expect(0, 126269, '\p{^Nv: 60/360}', "");
    Expect(0, 126269, '\P{Nv: 60/360}', "");
    Expect(1, 126269, '\P{^Nv: 60/360}', "");
    Expect(0, 126270, '\p{Nv: 60/360}', "");
    Expect(1, 126270, '\p{^Nv: 60/360}', "");
    Expect(1, 126270, '\P{Nv: 60/360}', "");
    Expect(0, 126270, '\P{^Nv: 60/360}', "");
    Error('\p{Nv=1.7e-01}');
    Error('\P{Nv=1.7e-01}');
    Error('\p{Nv=1.67e-01}');
    Error('\P{Nv=1.67e-01}');
    Error('\p{Nv=0.17}');
    Error('\P{Nv=0.17}');
    Expect(1, 126269, '\p{Nv=1.667e-01}', "");
    Expect(0, 126269, '\p{^Nv=1.667e-01}', "");
    Expect(0, 126269, '\P{Nv=1.667e-01}', "");
    Expect(1, 126269, '\P{^Nv=1.667e-01}', "");
    Expect(0, 126270, '\p{Nv=1.667e-01}', "");
    Expect(1, 126270, '\p{^Nv=1.667e-01}', "");
    Expect(1, 126270, '\P{Nv=1.667e-01}', "");
    Expect(0, 126270, '\P{^Nv=1.667e-01}', "");
    Error('\p{Nv=0.167}');
    Error('\P{Nv=0.167}');
    Expect(1, 126269, '\p{Nv=1.6667e-01}', "");
    Expect(0, 126269, '\p{^Nv=1.6667e-01}', "");
    Expect(0, 126269, '\P{Nv=1.6667e-01}', "");
    Expect(1, 126269, '\P{^Nv=1.6667e-01}', "");
    Expect(0, 126270, '\p{Nv=1.6667e-01}', "");
    Expect(1, 126270, '\p{^Nv=1.6667e-01}', "");
    Expect(1, 126270, '\P{Nv=1.6667e-01}', "");
    Expect(0, 126270, '\P{^Nv=1.6667e-01}', "");
    Expect(1, 126269, '\p{Nv=0.1667}', "");
    Expect(0, 126269, '\p{^Nv=0.1667}', "");
    Expect(0, 126269, '\P{Nv=0.1667}', "");
    Expect(1, 126269, '\P{^Nv=0.1667}', "");
    Expect(0, 126270, '\p{Nv=0.1667}', "");
    Expect(1, 126270, '\p{^Nv=0.1667}', "");
    Expect(1, 126270, '\P{Nv=0.1667}', "");
    Expect(0, 126270, '\P{^Nv=0.1667}', "");
    Expect(1, 126269, '\p{Nv=1.66667e-01}', "");
    Expect(0, 126269, '\p{^Nv=1.66667e-01}', "");
    Expect(0, 126269, '\P{Nv=1.66667e-01}', "");
    Expect(1, 126269, '\P{^Nv=1.66667e-01}', "");
    Expect(0, 126270, '\p{Nv=1.66667e-01}', "");
    Expect(1, 126270, '\p{^Nv=1.66667e-01}', "");
    Expect(1, 126270, '\P{Nv=1.66667e-01}', "");
    Expect(0, 126270, '\P{^Nv=1.66667e-01}', "");
    Expect(1, 126269, '\p{Nv=0.16667}', "");
    Expect(0, 126269, '\p{^Nv=0.16667}', "");
    Expect(0, 126269, '\P{Nv=0.16667}', "");
    Expect(1, 126269, '\P{^Nv=0.16667}', "");
    Expect(0, 126270, '\p{Nv=0.16667}', "");
    Expect(1, 126270, '\p{^Nv=0.16667}', "");
    Expect(1, 126270, '\P{Nv=0.16667}', "");
    Expect(0, 126270, '\P{^Nv=0.16667}', "");
    Error('\p{Is_Numeric_Value=/a/_001/000006}');
    Error('\P{Is_Numeric_Value=/a/_001/000006}');
    Expect(1, 126269, '\p{Is_Numeric_Value=1/0000000006}', "");
    Expect(0, 126269, '\p{^Is_Numeric_Value=1/0000000006}', "");
    Expect(0, 126269, '\P{Is_Numeric_Value=1/0000000006}', "");
    Expect(1, 126269, '\P{^Is_Numeric_Value=1/0000000006}', "");
    Expect(0, 126270, '\p{Is_Numeric_Value=1/0000000006}', "");
    Expect(1, 126270, '\p{^Is_Numeric_Value=1/0000000006}', "");
    Expect(1, 126270, '\P{Is_Numeric_Value=1/0000000006}', "");
    Expect(0, 126270, '\P{^Is_Numeric_Value=1/0000000006}', "");
    Expect(1, 126269, '\p{Is_Numeric_Value=60/360}', "");
    Expect(0, 126269, '\p{^Is_Numeric_Value=60/360}', "");
    Expect(0, 126269, '\P{Is_Numeric_Value=60/360}', "");
    Expect(1, 126269, '\P{^Is_Numeric_Value=60/360}', "");
    Expect(0, 126270, '\p{Is_Numeric_Value=60/360}', "");
    Expect(1, 126270, '\p{^Is_Numeric_Value=60/360}', "");
    Expect(1, 126270, '\P{Is_Numeric_Value=60/360}', "");
    Expect(0, 126270, '\P{^Is_Numeric_Value=60/360}', "");
    Error('\p{Is_Numeric_Value:1.7e-01}');
    Error('\P{Is_Numeric_Value:1.7e-01}');
    Error('\p{Is_Numeric_Value=1.67e-01}');
    Error('\P{Is_Numeric_Value=1.67e-01}');
    Error('\p{Is_Numeric_Value=0.17}');
    Error('\P{Is_Numeric_Value=0.17}');
    Expect(1, 126269, '\p{Is_Numeric_Value=1.667e-01}', "");
    Expect(0, 126269, '\p{^Is_Numeric_Value=1.667e-01}', "");
    Expect(0, 126269, '\P{Is_Numeric_Value=1.667e-01}', "");
    Expect(1, 126269, '\P{^Is_Numeric_Value=1.667e-01}', "");
    Expect(0, 126270, '\p{Is_Numeric_Value=1.667e-01}', "");
    Expect(1, 126270, '\p{^Is_Numeric_Value=1.667e-01}', "");
    Expect(1, 126270, '\P{Is_Numeric_Value=1.667e-01}', "");
    Expect(0, 126270, '\P{^Is_Numeric_Value=1.667e-01}', "");
    Error('\p{Is_Numeric_Value=0.167}');
    Error('\P{Is_Numeric_Value=0.167}');
    Expect(1, 126269, '\p{Is_Numeric_Value:1.6667e-01}', "");
    Expect(0, 126269, '\p{^Is_Numeric_Value:1.6667e-01}', "");
    Expect(0, 126269, '\P{Is_Numeric_Value:1.6667e-01}', "");
    Expect(1, 126269, '\P{^Is_Numeric_Value:1.6667e-01}', "");
    Expect(0, 126270, '\p{Is_Numeric_Value:1.6667e-01}', "");
    Expect(1, 126270, '\p{^Is_Numeric_Value:1.6667e-01}', "");
    Expect(1, 126270, '\P{Is_Numeric_Value:1.6667e-01}', "");
    Expect(0, 126270, '\P{^Is_Numeric_Value:1.6667e-01}', "");
    Expect(1, 126269, '\p{Is_Numeric_Value:	0.1667}', "");
    Expect(0, 126269, '\p{^Is_Numeric_Value:	0.1667}', "");
    Expect(0, 126269, '\P{Is_Numeric_Value:	0.1667}', "");
    Expect(1, 126269, '\P{^Is_Numeric_Value:	0.1667}', "");
    Expect(0, 126270, '\p{Is_Numeric_Value:	0.1667}', "");
    Expect(1, 126270, '\p{^Is_Numeric_Value:	0.1667}', "");
    Expect(1, 126270, '\P{Is_Numeric_Value:	0.1667}', "");
    Expect(0, 126270, '\P{^Is_Numeric_Value:	0.1667}', "");
    Expect(1, 126269, '\p{Is_Numeric_Value=1.66667e-01}', "");
    Expect(0, 126269, '\p{^Is_Numeric_Value=1.66667e-01}', "");
    Expect(0, 126269, '\P{Is_Numeric_Value=1.66667e-01}', "");
    Expect(1, 126269, '\P{^Is_Numeric_Value=1.66667e-01}', "");
    Expect(0, 126270, '\p{Is_Numeric_Value=1.66667e-01}', "");
    Expect(1, 126270, '\p{^Is_Numeric_Value=1.66667e-01}', "");
    Expect(1, 126270, '\P{Is_Numeric_Value=1.66667e-01}', "");
    Expect(0, 126270, '\P{^Is_Numeric_Value=1.66667e-01}', "");
    Expect(1, 126269, '\p{Is_Numeric_Value=0.16667}', "");
    Expect(0, 126269, '\p{^Is_Numeric_Value=0.16667}', "");
    Expect(0, 126269, '\P{Is_Numeric_Value=0.16667}', "");
    Expect(1, 126269, '\P{^Is_Numeric_Value=0.16667}', "");
    Expect(0, 126270, '\p{Is_Numeric_Value=0.16667}', "");
    Expect(1, 126270, '\p{^Is_Numeric_Value=0.16667}', "");
    Expect(1, 126270, '\P{Is_Numeric_Value=0.16667}', "");
    Expect(0, 126270, '\P{^Is_Numeric_Value=0.16667}', "");
    Error('\p{Is_Nv= /a/0001/0006}');
    Error('\P{Is_Nv= /a/0001/0006}');
    Expect(1, 126269, '\p{Is_Nv=00000001/000000006}', "");
    Expect(0, 126269, '\p{^Is_Nv=00000001/000000006}', "");
    Expect(0, 126269, '\P{Is_Nv=00000001/000000006}', "");
    Expect(1, 126269, '\P{^Is_Nv=00000001/000000006}', "");
    Expect(0, 126270, '\p{Is_Nv=00000001/000000006}', "");
    Expect(1, 126270, '\p{^Is_Nv=00000001/000000006}', "");
    Expect(1, 126270, '\P{Is_Nv=00000001/000000006}', "");
    Expect(0, 126270, '\P{^Is_Nv=00000001/000000006}', "");
    Expect(1, 126269, '\p{Is_Nv=60/360}', "");
    Expect(0, 126269, '\p{^Is_Nv=60/360}', "");
    Expect(0, 126269, '\P{Is_Nv=60/360}', "");
    Expect(1, 126269, '\P{^Is_Nv=60/360}', "");
    Expect(0, 126270, '\p{Is_Nv=60/360}', "");
    Expect(1, 126270, '\p{^Is_Nv=60/360}', "");
    Expect(1, 126270, '\P{Is_Nv=60/360}', "");
    Expect(0, 126270, '\P{^Is_Nv=60/360}', "");
    Error('\p{Is_Nv=1.7e-01}');
    Error('\P{Is_Nv=1.7e-01}');
    Error('\p{Is_Nv=1.67e-01}');
    Error('\P{Is_Nv=1.67e-01}');
    Error('\p{Is_Nv=0.17}');
    Error('\P{Is_Nv=0.17}');
    Expect(1, 126269, '\p{Is_Nv=1.667e-01}', "");
    Expect(0, 126269, '\p{^Is_Nv=1.667e-01}', "");
    Expect(0, 126269, '\P{Is_Nv=1.667e-01}', "");
    Expect(1, 126269, '\P{^Is_Nv=1.667e-01}', "");
    Expect(0, 126270, '\p{Is_Nv=1.667e-01}', "");
    Expect(1, 126270, '\p{^Is_Nv=1.667e-01}', "");
    Expect(1, 126270, '\P{Is_Nv=1.667e-01}', "");
    Expect(0, 126270, '\P{^Is_Nv=1.667e-01}', "");
    Error('\p{Is_Nv=0.167}');
    Error('\P{Is_Nv=0.167}');
    Expect(1, 126269, '\p{Is_Nv=1.6667e-01}', "");
    Expect(0, 126269, '\p{^Is_Nv=1.6667e-01}', "");
    Expect(0, 126269, '\P{Is_Nv=1.6667e-01}', "");
    Expect(1, 126269, '\P{^Is_Nv=1.6667e-01}', "");
    Expect(0, 126270, '\p{Is_Nv=1.6667e-01}', "");
    Expect(1, 126270, '\p{^Is_Nv=1.6667e-01}', "");
    Expect(1, 126270, '\P{Is_Nv=1.6667e-01}', "");
    Expect(0, 126270, '\P{^Is_Nv=1.6667e-01}', "");
    Expect(1, 126269, '\p{Is_Nv:   0.1667}', "");
    Expect(0, 126269, '\p{^Is_Nv:   0.1667}', "");
    Expect(0, 126269, '\P{Is_Nv:   0.1667}', "");
    Expect(1, 126269, '\P{^Is_Nv:   0.1667}', "");
    Expect(0, 126270, '\p{Is_Nv:   0.1667}', "");
    Expect(1, 126270, '\p{^Is_Nv:   0.1667}', "");
    Expect(1, 126270, '\P{Is_Nv:   0.1667}', "");
    Expect(0, 126270, '\P{^Is_Nv:   0.1667}', "");
    Expect(1, 126269, '\p{Is_Nv=1.66667e-01}', "");
    Expect(0, 126269, '\p{^Is_Nv=1.66667e-01}', "");
    Expect(0, 126269, '\P{Is_Nv=1.66667e-01}', "");
    Expect(1, 126269, '\P{^Is_Nv=1.66667e-01}', "");
    Expect(0, 126270, '\p{Is_Nv=1.66667e-01}', "");
    Expect(1, 126270, '\p{^Is_Nv=1.66667e-01}', "");
    Expect(1, 126270, '\P{Is_Nv=1.66667e-01}', "");
    Expect(0, 126270, '\P{^Is_Nv=1.66667e-01}', "");
    Expect(1, 126269, '\p{Is_Nv=0.16667}', "");
    Expect(0, 126269, '\p{^Is_Nv=0.16667}', "");
    Expect(0, 126269, '\P{Is_Nv=0.16667}', "");
    Expect(1, 126269, '\P{^Is_Nv=0.16667}', "");
    Expect(0, 126270, '\p{Is_Nv=0.16667}', "");
    Expect(1, 126270, '\p{^Is_Nv=0.16667}', "");
    Expect(1, 126270, '\P{Is_Nv=0.16667}', "");
    Expect(0, 126270, '\P{^Is_Nv=0.16667}', "");
    Error('\p{Numeric_Value: 	000001/64/a/}');
    Error('\P{Numeric_Value: 	000001/64/a/}');
    Expect(1, 73667, '\p{Numeric_Value=:\A1/64\z:}', "");;
    Expect(0, 73668, '\p{Numeric_Value=:\A1/64\z:}', "");;
    Expect(1, 73667, '\p{Numeric_Value=0000000001/000064}', "");
    Expect(0, 73667, '\p{^Numeric_Value=0000000001/000064}', "");
    Expect(0, 73667, '\P{Numeric_Value=0000000001/000064}', "");
    Expect(1, 73667, '\P{^Numeric_Value=0000000001/000064}', "");
    Expect(0, 73668, '\p{Numeric_Value=0000000001/000064}', "");
    Expect(1, 73668, '\p{^Numeric_Value=0000000001/000064}', "");
    Expect(1, 73668, '\P{Numeric_Value=0000000001/000064}', "");
    Expect(0, 73668, '\P{^Numeric_Value=0000000001/000064}', "");
    Expect(1, 73667, '\p{Numeric_Value=60/3840}', "");
    Expect(0, 73667, '\p{^Numeric_Value=60/3840}', "");
    Expect(0, 73667, '\P{Numeric_Value=60/3840}', "");
    Expect(1, 73667, '\P{^Numeric_Value=60/3840}', "");
    Expect(0, 73668, '\p{Numeric_Value=60/3840}', "");
    Expect(1, 73668, '\p{^Numeric_Value=60/3840}', "");
    Expect(1, 73668, '\P{Numeric_Value=60/3840}', "");
    Expect(0, 73668, '\P{^Numeric_Value=60/3840}', "");
    Error('\p{Numeric_Value=1.6e-02}');
    Error('\P{Numeric_Value=1.6e-02}');
    Error('\p{Numeric_Value=1.56e-02}');
    Error('\P{Numeric_Value=1.56e-02}');
    Error('\p{Numeric_Value:0.02}');
    Error('\P{Numeric_Value:0.02}');
    Expect(1, 73667, '\p{Numeric_Value=1.562e-02}', "");
    Expect(0, 73667, '\p{^Numeric_Value=1.562e-02}', "");
    Expect(0, 73667, '\P{Numeric_Value=1.562e-02}', "");
    Expect(1, 73667, '\P{^Numeric_Value=1.562e-02}', "");
    Expect(0, 73668, '\p{Numeric_Value=1.562e-02}', "");
    Expect(1, 73668, '\p{^Numeric_Value=1.562e-02}', "");
    Expect(1, 73668, '\P{Numeric_Value=1.562e-02}', "");
    Expect(0, 73668, '\P{^Numeric_Value=1.562e-02}', "");
    Error('\p{Numeric_Value=0.016}');
    Error('\P{Numeric_Value=0.016}');
    Expect(1, 73667, '\p{Numeric_Value=1.5625e-02}', "");
    Expect(0, 73667, '\p{^Numeric_Value=1.5625e-02}', "");
    Expect(0, 73667, '\P{Numeric_Value=1.5625e-02}', "");
    Expect(1, 73667, '\P{^Numeric_Value=1.5625e-02}', "");
    Expect(0, 73668, '\p{Numeric_Value=1.5625e-02}', "");
    Expect(1, 73668, '\p{^Numeric_Value=1.5625e-02}', "");
    Expect(1, 73668, '\P{Numeric_Value=1.5625e-02}', "");
    Expect(0, 73668, '\P{^Numeric_Value=1.5625e-02}', "");
    Error('\p{Numeric_Value=0.0156}');
    Error('\P{Numeric_Value=0.0156}');
    Expect(1, 73667, '\p{Numeric_Value=1.56250e-02}', "");
    Expect(0, 73667, '\p{^Numeric_Value=1.56250e-02}', "");
    Expect(0, 73667, '\P{Numeric_Value=1.56250e-02}', "");
    Expect(1, 73667, '\P{^Numeric_Value=1.56250e-02}', "");
    Expect(0, 73668, '\p{Numeric_Value=1.56250e-02}', "");
    Expect(1, 73668, '\p{^Numeric_Value=1.56250e-02}', "");
    Expect(1, 73668, '\P{Numeric_Value=1.56250e-02}', "");
    Expect(0, 73668, '\P{^Numeric_Value=1.56250e-02}', "");
    Expect(1, 73667, '\p{Numeric_Value=0.01562}', "");
    Expect(0, 73667, '\p{^Numeric_Value=0.01562}', "");
    Expect(0, 73667, '\P{Numeric_Value=0.01562}', "");
    Expect(1, 73667, '\P{^Numeric_Value=0.01562}', "");
    Expect(0, 73668, '\p{Numeric_Value=0.01562}', "");
    Expect(1, 73668, '\p{^Numeric_Value=0.01562}', "");
    Expect(1, 73668, '\P{Numeric_Value=0.01562}', "");
    Expect(0, 73668, '\P{^Numeric_Value=0.01562}', "");
    Expect(1, 73667, '\p{Numeric_Value=1.562500e-02}', "");
    Expect(0, 73667, '\p{^Numeric_Value=1.562500e-02}', "");
    Expect(0, 73667, '\P{Numeric_Value=1.562500e-02}', "");
    Expect(1, 73667, '\P{^Numeric_Value=1.562500e-02}', "");
    Expect(0, 73668, '\p{Numeric_Value=1.562500e-02}', "");
    Expect(1, 73668, '\p{^Numeric_Value=1.562500e-02}', "");
    Expect(1, 73668, '\P{Numeric_Value=1.562500e-02}', "");
    Expect(0, 73668, '\P{^Numeric_Value=1.562500e-02}', "");
    Expect(1, 73667, '\p{Numeric_Value=0.015625}', "");
    Expect(0, 73667, '\p{^Numeric_Value=0.015625}', "");
    Expect(0, 73667, '\P{Numeric_Value=0.015625}', "");
    Expect(1, 73667, '\P{^Numeric_Value=0.015625}', "");
    Expect(0, 73668, '\p{Numeric_Value=0.015625}', "");
    Expect(1, 73668, '\p{^Numeric_Value=0.015625}', "");
    Expect(1, 73668, '\P{Numeric_Value=0.015625}', "");
    Expect(0, 73668, '\P{^Numeric_Value=0.015625}', "");
    Error('\p{Nv: _ 0001/00000064:=}');
    Error('\P{Nv: _ 0001/00000064:=}');
    Expect(1, 73667, '\p{Nv=:\A1/64\z:}', "");;
    Expect(0, 73668, '\p{Nv=:\A1/64\z:}', "");;
    Expect(1, 73667, '\p{Nv=+0000000001/000064}', "");
    Expect(0, 73667, '\p{^Nv=+0000000001/000064}', "");
    Expect(0, 73667, '\P{Nv=+0000000001/000064}', "");
    Expect(1, 73667, '\P{^Nv=+0000000001/000064}', "");
    Expect(0, 73668, '\p{Nv=+0000000001/000064}', "");
    Expect(1, 73668, '\p{^Nv=+0000000001/000064}', "");
    Expect(1, 73668, '\P{Nv=+0000000001/000064}', "");
    Expect(0, 73668, '\P{^Nv=+0000000001/000064}', "");
    Expect(1, 73667, '\p{Nv=60/3840}', "");
    Expect(0, 73667, '\p{^Nv=60/3840}', "");
    Expect(0, 73667, '\P{Nv=60/3840}', "");
    Expect(1, 73667, '\P{^Nv=60/3840}', "");
    Expect(0, 73668, '\p{Nv=60/3840}', "");
    Expect(1, 73668, '\p{^Nv=60/3840}', "");
    Expect(1, 73668, '\P{Nv=60/3840}', "");
    Expect(0, 73668, '\P{^Nv=60/3840}', "");
    Error('\p{Nv=1.6e-02}');
    Error('\P{Nv=1.6e-02}');
    Error('\p{Nv=1.56e-02}');
    Error('\P{Nv=1.56e-02}');
    Error('\p{Nv:0.02}');
    Error('\P{Nv:0.02}');
    Expect(1, 73667, '\p{Nv=1.562e-02}', "");
    Expect(0, 73667, '\p{^Nv=1.562e-02}', "");
    Expect(0, 73667, '\P{Nv=1.562e-02}', "");
    Expect(1, 73667, '\P{^Nv=1.562e-02}', "");
    Expect(0, 73668, '\p{Nv=1.562e-02}', "");
    Expect(1, 73668, '\p{^Nv=1.562e-02}', "");
    Expect(1, 73668, '\P{Nv=1.562e-02}', "");
    Expect(0, 73668, '\P{^Nv=1.562e-02}', "");
    Error('\p{Nv=0.016}');
    Error('\P{Nv=0.016}');
    Expect(1, 73667, '\p{Nv=1.5625e-02}', "");
    Expect(0, 73667, '\p{^Nv=1.5625e-02}', "");
    Expect(0, 73667, '\P{Nv=1.5625e-02}', "");
    Expect(1, 73667, '\P{^Nv=1.5625e-02}', "");
    Expect(0, 73668, '\p{Nv=1.5625e-02}', "");
    Expect(1, 73668, '\p{^Nv=1.5625e-02}', "");
    Expect(1, 73668, '\P{Nv=1.5625e-02}', "");
    Expect(0, 73668, '\P{^Nv=1.5625e-02}', "");
    Error('\p{Nv=0.0156}');
    Error('\P{Nv=0.0156}');
    Expect(1, 73667, '\p{Nv=1.56250e-02}', "");
    Expect(0, 73667, '\p{^Nv=1.56250e-02}', "");
    Expect(0, 73667, '\P{Nv=1.56250e-02}', "");
    Expect(1, 73667, '\P{^Nv=1.56250e-02}', "");
    Expect(0, 73668, '\p{Nv=1.56250e-02}', "");
    Expect(1, 73668, '\p{^Nv=1.56250e-02}', "");
    Expect(1, 73668, '\P{Nv=1.56250e-02}', "");
    Expect(0, 73668, '\P{^Nv=1.56250e-02}', "");
    Expect(1, 73667, '\p{Nv=0.01562}', "");
    Expect(0, 73667, '\p{^Nv=0.01562}', "");
    Expect(0, 73667, '\P{Nv=0.01562}', "");
    Expect(1, 73667, '\P{^Nv=0.01562}', "");
    Expect(0, 73668, '\p{Nv=0.01562}', "");
    Expect(1, 73668, '\p{^Nv=0.01562}', "");
    Expect(1, 73668, '\P{Nv=0.01562}', "");
    Expect(0, 73668, '\P{^Nv=0.01562}', "");
    Expect(1, 73667, '\p{Nv=1.562500e-02}', "");
    Expect(0, 73667, '\p{^Nv=1.562500e-02}', "");
    Expect(0, 73667, '\P{Nv=1.562500e-02}', "");
    Expect(1, 73667, '\P{^Nv=1.562500e-02}', "");
    Expect(0, 73668, '\p{Nv=1.562500e-02}', "");
    Expect(1, 73668, '\p{^Nv=1.562500e-02}', "");
    Expect(1, 73668, '\P{Nv=1.562500e-02}', "");
    Expect(0, 73668, '\P{^Nv=1.562500e-02}', "");
    Expect(1, 73667, '\p{Nv=0.015625}', "");
    Expect(0, 73667, '\p{^Nv=0.015625}', "");
    Expect(0, 73667, '\P{Nv=0.015625}', "");
    Expect(1, 73667, '\P{^Nv=0.015625}', "");
    Expect(0, 73668, '\p{Nv=0.015625}', "");
    Expect(1, 73668, '\p{^Nv=0.015625}', "");
    Expect(1, 73668, '\P{Nv=0.015625}', "");
    Expect(0, 73668, '\P{^Nv=0.015625}', "");
    Error('\p{Is_Numeric_Value=:=	0000000001/0000000064}');
    Error('\P{Is_Numeric_Value=:=	0000000001/0000000064}');
    Expect(1, 73667, '\p{Is_Numeric_Value=000001/00000064}', "");
    Expect(0, 73667, '\p{^Is_Numeric_Value=000001/00000064}', "");
    Expect(0, 73667, '\P{Is_Numeric_Value=000001/00000064}', "");
    Expect(1, 73667, '\P{^Is_Numeric_Value=000001/00000064}', "");
    Expect(0, 73668, '\p{Is_Numeric_Value=000001/00000064}', "");
    Expect(1, 73668, '\p{^Is_Numeric_Value=000001/00000064}', "");
    Expect(1, 73668, '\P{Is_Numeric_Value=000001/00000064}', "");
    Expect(0, 73668, '\P{^Is_Numeric_Value=000001/00000064}', "");
    Expect(1, 73667, '\p{Is_Numeric_Value=60/3840}', "");
    Expect(0, 73667, '\p{^Is_Numeric_Value=60/3840}', "");
    Expect(0, 73667, '\P{Is_Numeric_Value=60/3840}', "");
    Expect(1, 73667, '\P{^Is_Numeric_Value=60/3840}', "");
    Expect(0, 73668, '\p{Is_Numeric_Value=60/3840}', "");
    Expect(1, 73668, '\p{^Is_Numeric_Value=60/3840}', "");
    Expect(1, 73668, '\P{Is_Numeric_Value=60/3840}', "");
    Expect(0, 73668, '\P{^Is_Numeric_Value=60/3840}', "");
    Error('\p{Is_Numeric_Value:   1.6e-02}');
    Error('\P{Is_Numeric_Value:   1.6e-02}');
    Error('\p{Is_Numeric_Value:1.56e-02}');
    Error('\P{Is_Numeric_Value:1.56e-02}');
    Error('\p{Is_Numeric_Value=0.02}');
    Error('\P{Is_Numeric_Value=0.02}');
    Expect(1, 73667, '\p{Is_Numeric_Value=1.562e-02}', "");
    Expect(0, 73667, '\p{^Is_Numeric_Value=1.562e-02}', "");
    Expect(0, 73667, '\P{Is_Numeric_Value=1.562e-02}', "");
    Expect(1, 73667, '\P{^Is_Numeric_Value=1.562e-02}', "");
    Expect(0, 73668, '\p{Is_Numeric_Value=1.562e-02}', "");
    Expect(1, 73668, '\p{^Is_Numeric_Value=1.562e-02}', "");
    Expect(1, 73668, '\P{Is_Numeric_Value=1.562e-02}', "");
    Expect(0, 73668, '\P{^Is_Numeric_Value=1.562e-02}', "");
    Error('\p{Is_Numeric_Value:   0.016}');
    Error('\P{Is_Numeric_Value:   0.016}');
    Expect(1, 73667, '\p{Is_Numeric_Value=1.5625e-02}', "");
    Expect(0, 73667, '\p{^Is_Numeric_Value=1.5625e-02}', "");
    Expect(0, 73667, '\P{Is_Numeric_Value=1.5625e-02}', "");
    Expect(1, 73667, '\P{^Is_Numeric_Value=1.5625e-02}', "");
    Expect(0, 73668, '\p{Is_Numeric_Value=1.5625e-02}', "");
    Expect(1, 73668, '\p{^Is_Numeric_Value=1.5625e-02}', "");
    Expect(1, 73668, '\P{Is_Numeric_Value=1.5625e-02}', "");
    Expect(0, 73668, '\P{^Is_Numeric_Value=1.5625e-02}', "");
    Error('\p{Is_Numeric_Value=0.0156}');
    Error('\P{Is_Numeric_Value=0.0156}');
    Expect(1, 73667, '\p{Is_Numeric_Value=1.56250e-02}', "");
    Expect(0, 73667, '\p{^Is_Numeric_Value=1.56250e-02}', "");
    Expect(0, 73667, '\P{Is_Numeric_Value=1.56250e-02}', "");
    Expect(1, 73667, '\P{^Is_Numeric_Value=1.56250e-02}', "");
    Expect(0, 73668, '\p{Is_Numeric_Value=1.56250e-02}', "");
    Expect(1, 73668, '\p{^Is_Numeric_Value=1.56250e-02}', "");
    Expect(1, 73668, '\P{Is_Numeric_Value=1.56250e-02}', "");
    Expect(0, 73668, '\P{^Is_Numeric_Value=1.56250e-02}', "");
    Expect(1, 73667, '\p{Is_Numeric_Value=0.01562}', "");
    Expect(0, 73667, '\p{^Is_Numeric_Value=0.01562}', "");
    Expect(0, 73667, '\P{Is_Numeric_Value=0.01562}', "");
    Expect(1, 73667, '\P{^Is_Numeric_Value=0.01562}', "");
    Expect(0, 73668, '\p{Is_Numeric_Value=0.01562}', "");
    Expect(1, 73668, '\p{^Is_Numeric_Value=0.01562}', "");
    Expect(1, 73668, '\P{Is_Numeric_Value=0.01562}', "");
    Expect(0, 73668, '\P{^Is_Numeric_Value=0.01562}', "");
    Expect(1, 73667, '\p{Is_Numeric_Value=1.562500e-02}', "");
    Expect(0, 73667, '\p{^Is_Numeric_Value=1.562500e-02}', "");
    Expect(0, 73667, '\P{Is_Numeric_Value=1.562500e-02}', "");
    Expect(1, 73667, '\P{^Is_Numeric_Value=1.562500e-02}', "");
    Expect(0, 73668, '\p{Is_Numeric_Value=1.562500e-02}', "");
    Expect(1, 73668, '\p{^Is_Numeric_Value=1.562500e-02}', "");
    Expect(1, 73668, '\P{Is_Numeric_Value=1.562500e-02}', "");
    Expect(0, 73668, '\P{^Is_Numeric_Value=1.562500e-02}', "");
    Expect(1, 73667, '\p{Is_Numeric_Value=0.015625}', "");
    Expect(0, 73667, '\p{^Is_Numeric_Value=0.015625}', "");
    Expect(0, 73667, '\P{Is_Numeric_Value=0.015625}', "");
    Expect(1, 73667, '\P{^Is_Numeric_Value=0.015625}', "");
    Expect(0, 73668, '\p{Is_Numeric_Value=0.015625}', "");
    Expect(1, 73668, '\p{^Is_Numeric_Value=0.015625}', "");
    Expect(1, 73668, '\P{Is_Numeric_Value=0.015625}', "");
    Expect(0, 73668, '\P{^Is_Numeric_Value=0.015625}', "");
    Error('\p{Is_Nv=_ 00001/64/a/}');
    Error('\P{Is_Nv=_ 00001/64/a/}');
    Expect(1, 73667, '\p{Is_Nv=+0000000001/0064}', "");
    Expect(0, 73667, '\p{^Is_Nv=+0000000001/0064}', "");
    Expect(0, 73667, '\P{Is_Nv=+0000000001/0064}', "");
    Expect(1, 73667, '\P{^Is_Nv=+0000000001/0064}', "");
    Expect(0, 73668, '\p{Is_Nv=+0000000001/0064}', "");
    Expect(1, 73668, '\p{^Is_Nv=+0000000001/0064}', "");
    Expect(1, 73668, '\P{Is_Nv=+0000000001/0064}', "");
    Expect(0, 73668, '\P{^Is_Nv=+0000000001/0064}', "");
    Expect(1, 73667, '\p{Is_Nv=60/3840}', "");
    Expect(0, 73667, '\p{^Is_Nv=60/3840}', "");
    Expect(0, 73667, '\P{Is_Nv=60/3840}', "");
    Expect(1, 73667, '\P{^Is_Nv=60/3840}', "");
    Expect(0, 73668, '\p{Is_Nv=60/3840}', "");
    Expect(1, 73668, '\p{^Is_Nv=60/3840}', "");
    Expect(1, 73668, '\P{Is_Nv=60/3840}', "");
    Expect(0, 73668, '\P{^Is_Nv=60/3840}', "");
    Error('\p{Is_Nv=1.6e-02}');
    Error('\P{Is_Nv=1.6e-02}');
    Error('\p{Is_Nv=1.56e-02}');
    Error('\P{Is_Nv=1.56e-02}');
    Error('\p{Is_Nv=0.02}');
    Error('\P{Is_Nv=0.02}');
    Expect(1, 73667, '\p{Is_Nv=1.562e-02}', "");
    Expect(0, 73667, '\p{^Is_Nv=1.562e-02}', "");
    Expect(0, 73667, '\P{Is_Nv=1.562e-02}', "");
    Expect(1, 73667, '\P{^Is_Nv=1.562e-02}', "");
    Expect(0, 73668, '\p{Is_Nv=1.562e-02}', "");
    Expect(1, 73668, '\p{^Is_Nv=1.562e-02}', "");
    Expect(1, 73668, '\P{Is_Nv=1.562e-02}', "");
    Expect(0, 73668, '\P{^Is_Nv=1.562e-02}', "");
    Error('\p{Is_Nv=0.016}');
    Error('\P{Is_Nv=0.016}');
    Expect(1, 73667, '\p{Is_Nv=1.5625e-02}', "");
    Expect(0, 73667, '\p{^Is_Nv=1.5625e-02}', "");
    Expect(0, 73667, '\P{Is_Nv=1.5625e-02}', "");
    Expect(1, 73667, '\P{^Is_Nv=1.5625e-02}', "");
    Expect(0, 73668, '\p{Is_Nv=1.5625e-02}', "");
    Expect(1, 73668, '\p{^Is_Nv=1.5625e-02}', "");
    Expect(1, 73668, '\P{Is_Nv=1.5625e-02}', "");
    Expect(0, 73668, '\P{^Is_Nv=1.5625e-02}', "");
    Error('\p{Is_Nv=0.0156}');
    Error('\P{Is_Nv=0.0156}');
    Expect(1, 73667, '\p{Is_Nv=1.56250e-02}', "");
    Expect(0, 73667, '\p{^Is_Nv=1.56250e-02}', "");
    Expect(0, 73667, '\P{Is_Nv=1.56250e-02}', "");
    Expect(1, 73667, '\P{^Is_Nv=1.56250e-02}', "");
    Expect(0, 73668, '\p{Is_Nv=1.56250e-02}', "");
    Expect(1, 73668, '\p{^Is_Nv=1.56250e-02}', "");
    Expect(1, 73668, '\P{Is_Nv=1.56250e-02}', "");
    Expect(0, 73668, '\P{^Is_Nv=1.56250e-02}', "");
    Expect(1, 73667, '\p{Is_Nv=0.01562}', "");
    Expect(0, 73667, '\p{^Is_Nv=0.01562}', "");
    Expect(0, 73667, '\P{Is_Nv=0.01562}', "");
    Expect(1, 73667, '\P{^Is_Nv=0.01562}', "");
    Expect(0, 73668, '\p{Is_Nv=0.01562}', "");
    Expect(1, 73668, '\p{^Is_Nv=0.01562}', "");
    Expect(1, 73668, '\P{Is_Nv=0.01562}', "");
    Expect(0, 73668, '\P{^Is_Nv=0.01562}', "");
    Expect(1, 73667, '\p{Is_Nv=1.562500e-02}', "");
    Expect(0, 73667, '\p{^Is_Nv=1.562500e-02}', "");
    Expect(0, 73667, '\P{Is_Nv=1.562500e-02}', "");
    Expect(1, 73667, '\P{^Is_Nv=1.562500e-02}', "");
    Expect(0, 73668, '\p{Is_Nv=1.562500e-02}', "");
    Expect(1, 73668, '\p{^Is_Nv=1.562500e-02}', "");
    Expect(1, 73668, '\P{Is_Nv=1.562500e-02}', "");
    Expect(0, 73668, '\P{^Is_Nv=1.562500e-02}', "");
    Expect(1, 73667, '\p{Is_Nv=0.015625}', "");
    Expect(0, 73667, '\p{^Is_Nv=0.015625}', "");
    Expect(0, 73667, '\P{Is_Nv=0.015625}', "");
    Expect(1, 73667, '\P{^Is_Nv=0.015625}', "");
    Expect(0, 73668, '\p{Is_Nv=0.015625}', "");
    Expect(1, 73668, '\p{^Is_Nv=0.015625}', "");
    Expect(1, 73668, '\P{Is_Nv=0.015625}', "");
    Expect(0, 73668, '\P{^Is_Nv=0.015625}', "");
    Error('\p{Numeric_Value=-/a/+000001/000007}');
    Error('\P{Numeric_Value=-/a/+000001/000007}');
    Expect(1, 8528, '\p{Numeric_Value=:\A1/7\z:}', "");;
    Expect(0, 8529, '\p{Numeric_Value=:\A1/7\z:}', "");;
    Expect(1, 8528, '\p{Numeric_Value:00000001/000000007}', "");
    Expect(0, 8528, '\p{^Numeric_Value:00000001/000000007}', "");
    Expect(0, 8528, '\P{Numeric_Value:00000001/000000007}', "");
    Expect(1, 8528, '\P{^Numeric_Value:00000001/000000007}', "");
    Expect(0, 8529, '\p{Numeric_Value:00000001/000000007}', "");
    Expect(1, 8529, '\p{^Numeric_Value:00000001/000000007}', "");
    Expect(1, 8529, '\P{Numeric_Value:00000001/000000007}', "");
    Expect(0, 8529, '\P{^Numeric_Value:00000001/000000007}', "");
    Expect(1, 8528, '\p{Numeric_Value=60/420}', "");
    Expect(0, 8528, '\p{^Numeric_Value=60/420}', "");
    Expect(0, 8528, '\P{Numeric_Value=60/420}', "");
    Expect(1, 8528, '\P{^Numeric_Value=60/420}', "");
    Expect(0, 8529, '\p{Numeric_Value=60/420}', "");
    Expect(1, 8529, '\p{^Numeric_Value=60/420}', "");
    Expect(1, 8529, '\P{Numeric_Value=60/420}', "");
    Expect(0, 8529, '\P{^Numeric_Value=60/420}', "");
    Error('\p{Numeric_Value:1.4e-01}');
    Error('\P{Numeric_Value:1.4e-01}');
    Error('\p{Numeric_Value=1.43e-01}');
    Error('\P{Numeric_Value=1.43e-01}');
    Error('\p{Numeric_Value=0.14}');
    Error('\P{Numeric_Value=0.14}');
    Expect(1, 8528, '\p{Numeric_Value: 1.429e-01}', "");
    Expect(0, 8528, '\p{^Numeric_Value: 1.429e-01}', "");
    Expect(0, 8528, '\P{Numeric_Value: 1.429e-01}', "");
    Expect(1, 8528, '\P{^Numeric_Value: 1.429e-01}', "");
    Expect(0, 8529, '\p{Numeric_Value: 1.429e-01}', "");
    Expect(1, 8529, '\p{^Numeric_Value: 1.429e-01}', "");
    Expect(1, 8529, '\P{Numeric_Value: 1.429e-01}', "");
    Expect(0, 8529, '\P{^Numeric_Value: 1.429e-01}', "");
    Error('\p{Numeric_Value=0.143}');
    Error('\P{Numeric_Value=0.143}');
    Expect(1, 8528, '\p{Numeric_Value=1.4286e-01}', "");
    Expect(0, 8528, '\p{^Numeric_Value=1.4286e-01}', "");
    Expect(0, 8528, '\P{Numeric_Value=1.4286e-01}', "");
    Expect(1, 8528, '\P{^Numeric_Value=1.4286e-01}', "");
    Expect(0, 8529, '\p{Numeric_Value=1.4286e-01}', "");
    Expect(1, 8529, '\p{^Numeric_Value=1.4286e-01}', "");
    Expect(1, 8529, '\P{Numeric_Value=1.4286e-01}', "");
    Expect(0, 8529, '\P{^Numeric_Value=1.4286e-01}', "");
    Expect(1, 8528, '\p{Numeric_Value=0.1429}', "");
    Expect(0, 8528, '\p{^Numeric_Value=0.1429}', "");
    Expect(0, 8528, '\P{Numeric_Value=0.1429}', "");
    Expect(1, 8528, '\P{^Numeric_Value=0.1429}', "");
    Expect(0, 8529, '\p{Numeric_Value=0.1429}', "");
    Expect(1, 8529, '\p{^Numeric_Value=0.1429}', "");
    Expect(1, 8529, '\P{Numeric_Value=0.1429}', "");
    Expect(0, 8529, '\P{^Numeric_Value=0.1429}', "");
    Expect(1, 8528, '\p{Numeric_Value=1.42857e-01}', "");
    Expect(0, 8528, '\p{^Numeric_Value=1.42857e-01}', "");
    Expect(0, 8528, '\P{Numeric_Value=1.42857e-01}', "");
    Expect(1, 8528, '\P{^Numeric_Value=1.42857e-01}', "");
    Expect(0, 8529, '\p{Numeric_Value=1.42857e-01}', "");
    Expect(1, 8529, '\p{^Numeric_Value=1.42857e-01}', "");
    Expect(1, 8529, '\P{Numeric_Value=1.42857e-01}', "");
    Expect(0, 8529, '\P{^Numeric_Value=1.42857e-01}', "");
    Expect(1, 8528, '\p{Numeric_Value=0.14286}', "");
    Expect(0, 8528, '\p{^Numeric_Value=0.14286}', "");
    Expect(0, 8528, '\P{Numeric_Value=0.14286}', "");
    Expect(1, 8528, '\P{^Numeric_Value=0.14286}', "");
    Expect(0, 8529, '\p{Numeric_Value=0.14286}', "");
    Expect(1, 8529, '\p{^Numeric_Value=0.14286}', "");
    Expect(1, 8529, '\P{Numeric_Value=0.14286}', "");
    Expect(0, 8529, '\P{^Numeric_Value=0.14286}', "");
    Error('\p{Nv:	-_000000001/07/a/}');
    Error('\P{Nv:	-_000000001/07/a/}');
    Expect(1, 8528, '\p{Nv=:\A1/7\z:}', "");;
    Expect(0, 8529, '\p{Nv=:\A1/7\z:}', "");;
    Expect(1, 8528, '\p{Nv=000001/7}', "");
    Expect(0, 8528, '\p{^Nv=000001/7}', "");
    Expect(0, 8528, '\P{Nv=000001/7}', "");
    Expect(1, 8528, '\P{^Nv=000001/7}', "");
    Expect(0, 8529, '\p{Nv=000001/7}', "");
    Expect(1, 8529, '\p{^Nv=000001/7}', "");
    Expect(1, 8529, '\P{Nv=000001/7}', "");
    Expect(0, 8529, '\P{^Nv=000001/7}', "");
    Expect(1, 8528, '\p{Nv=60/420}', "");
    Expect(0, 8528, '\p{^Nv=60/420}', "");
    Expect(0, 8528, '\P{Nv=60/420}', "");
    Expect(1, 8528, '\P{^Nv=60/420}', "");
    Expect(0, 8529, '\p{Nv=60/420}', "");
    Expect(1, 8529, '\p{^Nv=60/420}', "");
    Expect(1, 8529, '\P{Nv=60/420}', "");
    Expect(0, 8529, '\P{^Nv=60/420}', "");
    Error('\p{Nv=1.4e-01}');
    Error('\P{Nv=1.4e-01}');
    Error('\p{Nv=1.43e-01}');
    Error('\P{Nv=1.43e-01}');
    Error('\p{Nv=0.14}');
    Error('\P{Nv=0.14}');
    Expect(1, 8528, '\p{Nv=1.429e-01}', "");
    Expect(0, 8528, '\p{^Nv=1.429e-01}', "");
    Expect(0, 8528, '\P{Nv=1.429e-01}', "");
    Expect(1, 8528, '\P{^Nv=1.429e-01}', "");
    Expect(0, 8529, '\p{Nv=1.429e-01}', "");
    Expect(1, 8529, '\p{^Nv=1.429e-01}', "");
    Expect(1, 8529, '\P{Nv=1.429e-01}', "");
    Expect(0, 8529, '\P{^Nv=1.429e-01}', "");
    Error('\p{Nv=0.143}');
    Error('\P{Nv=0.143}');
    Expect(1, 8528, '\p{Nv=1.4286e-01}', "");
    Expect(0, 8528, '\p{^Nv=1.4286e-01}', "");
    Expect(0, 8528, '\P{Nv=1.4286e-01}', "");
    Expect(1, 8528, '\P{^Nv=1.4286e-01}', "");
    Expect(0, 8529, '\p{Nv=1.4286e-01}', "");
    Expect(1, 8529, '\p{^Nv=1.4286e-01}', "");
    Expect(1, 8529, '\P{Nv=1.4286e-01}', "");
    Expect(0, 8529, '\P{^Nv=1.4286e-01}', "");
    Expect(1, 8528, '\p{Nv=0.1429}', "");
    Expect(0, 8528, '\p{^Nv=0.1429}', "");
    Expect(0, 8528, '\P{Nv=0.1429}', "");
    Expect(1, 8528, '\P{^Nv=0.1429}', "");
    Expect(0, 8529, '\p{Nv=0.1429}', "");
    Expect(1, 8529, '\p{^Nv=0.1429}', "");
    Expect(1, 8529, '\P{Nv=0.1429}', "");
    Expect(0, 8529, '\P{^Nv=0.1429}', "");
    Expect(1, 8528, '\p{Nv:	1.42857e-01}', "");
    Expect(0, 8528, '\p{^Nv:	1.42857e-01}', "");
    Expect(0, 8528, '\P{Nv:	1.42857e-01}', "");
    Expect(1, 8528, '\P{^Nv:	1.42857e-01}', "");
    Expect(0, 8529, '\p{Nv:	1.42857e-01}', "");
    Expect(1, 8529, '\p{^Nv:	1.42857e-01}', "");
    Expect(1, 8529, '\P{Nv:	1.42857e-01}', "");
    Expect(0, 8529, '\P{^Nv:	1.42857e-01}', "");
    Expect(1, 8528, '\p{Nv=0.14286}', "");
    Expect(0, 8528, '\p{^Nv=0.14286}', "");
    Expect(0, 8528, '\P{Nv=0.14286}', "");
    Expect(1, 8528, '\P{^Nv=0.14286}', "");
    Expect(0, 8529, '\p{Nv=0.14286}', "");
    Expect(1, 8529, '\p{^Nv=0.14286}', "");
    Expect(1, 8529, '\P{Nv=0.14286}', "");
    Expect(0, 8529, '\P{^Nv=0.14286}', "");
    Error('\p{Is_Numeric_Value:	  +00000001/0007:=}');
    Error('\P{Is_Numeric_Value:	  +00000001/0007:=}');
    Expect(1, 8528, '\p{Is_Numeric_Value:	01/0000000007}', "");
    Expect(0, 8528, '\p{^Is_Numeric_Value:	01/0000000007}', "");
    Expect(0, 8528, '\P{Is_Numeric_Value:	01/0000000007}', "");
    Expect(1, 8528, '\P{^Is_Numeric_Value:	01/0000000007}', "");
    Expect(0, 8529, '\p{Is_Numeric_Value:	01/0000000007}', "");
    Expect(1, 8529, '\p{^Is_Numeric_Value:	01/0000000007}', "");
    Expect(1, 8529, '\P{Is_Numeric_Value:	01/0000000007}', "");
    Expect(0, 8529, '\P{^Is_Numeric_Value:	01/0000000007}', "");
    Expect(1, 8528, '\p{Is_Numeric_Value:   60/420}', "");
    Expect(0, 8528, '\p{^Is_Numeric_Value:   60/420}', "");
    Expect(0, 8528, '\P{Is_Numeric_Value:   60/420}', "");
    Expect(1, 8528, '\P{^Is_Numeric_Value:   60/420}', "");
    Expect(0, 8529, '\p{Is_Numeric_Value:   60/420}', "");
    Expect(1, 8529, '\p{^Is_Numeric_Value:   60/420}', "");
    Expect(1, 8529, '\P{Is_Numeric_Value:   60/420}', "");
    Expect(0, 8529, '\P{^Is_Numeric_Value:   60/420}', "");
    Error('\p{Is_Numeric_Value=1.4e-01}');
    Error('\P{Is_Numeric_Value=1.4e-01}');
    Error('\p{Is_Numeric_Value=1.43e-01}');
    Error('\P{Is_Numeric_Value=1.43e-01}');
    Error('\p{Is_Numeric_Value=0.14}');
    Error('\P{Is_Numeric_Value=0.14}');
    Expect(1, 8528, '\p{Is_Numeric_Value=1.429e-01}', "");
    Expect(0, 8528, '\p{^Is_Numeric_Value=1.429e-01}', "");
    Expect(0, 8528, '\P{Is_Numeric_Value=1.429e-01}', "");
    Expect(1, 8528, '\P{^Is_Numeric_Value=1.429e-01}', "");
    Expect(0, 8529, '\p{Is_Numeric_Value=1.429e-01}', "");
    Expect(1, 8529, '\p{^Is_Numeric_Value=1.429e-01}', "");
    Expect(1, 8529, '\P{Is_Numeric_Value=1.429e-01}', "");
    Expect(0, 8529, '\P{^Is_Numeric_Value=1.429e-01}', "");
    Error('\p{Is_Numeric_Value=0.143}');
    Error('\P{Is_Numeric_Value=0.143}');
    Expect(1, 8528, '\p{Is_Numeric_Value=1.4286e-01}', "");
    Expect(0, 8528, '\p{^Is_Numeric_Value=1.4286e-01}', "");
    Expect(0, 8528, '\P{Is_Numeric_Value=1.4286e-01}', "");
    Expect(1, 8528, '\P{^Is_Numeric_Value=1.4286e-01}', "");
    Expect(0, 8529, '\p{Is_Numeric_Value=1.4286e-01}', "");
    Expect(1, 8529, '\p{^Is_Numeric_Value=1.4286e-01}', "");
    Expect(1, 8529, '\P{Is_Numeric_Value=1.4286e-01}', "");
    Expect(0, 8529, '\P{^Is_Numeric_Value=1.4286e-01}', "");
    Expect(1, 8528, '\p{Is_Numeric_Value=0.1429}', "");
    Expect(0, 8528, '\p{^Is_Numeric_Value=0.1429}', "");
    Expect(0, 8528, '\P{Is_Numeric_Value=0.1429}', "");
    Expect(1, 8528, '\P{^Is_Numeric_Value=0.1429}', "");
    Expect(0, 8529, '\p{Is_Numeric_Value=0.1429}', "");
    Expect(1, 8529, '\p{^Is_Numeric_Value=0.1429}', "");
    Expect(1, 8529, '\P{Is_Numeric_Value=0.1429}', "");
    Expect(0, 8529, '\P{^Is_Numeric_Value=0.1429}', "");
    Expect(1, 8528, '\p{Is_Numeric_Value: 1.42857e-01}', "");
    Expect(0, 8528, '\p{^Is_Numeric_Value: 1.42857e-01}', "");
    Expect(0, 8528, '\P{Is_Numeric_Value: 1.42857e-01}', "");
    Expect(1, 8528, '\P{^Is_Numeric_Value: 1.42857e-01}', "");
    Expect(0, 8529, '\p{Is_Numeric_Value: 1.42857e-01}', "");
    Expect(1, 8529, '\p{^Is_Numeric_Value: 1.42857e-01}', "");
    Expect(1, 8529, '\P{Is_Numeric_Value: 1.42857e-01}', "");
    Expect(0, 8529, '\P{^Is_Numeric_Value: 1.42857e-01}', "");
    Expect(1, 8528, '\p{Is_Numeric_Value=0.14286}', "");
    Expect(0, 8528, '\p{^Is_Numeric_Value=0.14286}', "");
    Expect(0, 8528, '\P{Is_Numeric_Value=0.14286}', "");
    Expect(1, 8528, '\P{^Is_Numeric_Value=0.14286}', "");
    Expect(0, 8529, '\p{Is_Numeric_Value=0.14286}', "");
    Expect(1, 8529, '\p{^Is_Numeric_Value=0.14286}', "");
    Expect(1, 8529, '\P{Is_Numeric_Value=0.14286}', "");
    Expect(0, 8529, '\P{^Is_Numeric_Value=0.14286}', "");
    Error('\p{Is_Nv=:=00000001/000000007}');
    Error('\P{Is_Nv=:=00000001/000000007}');
    Expect(1, 8528, '\p{Is_Nv=+00000001/0000007}', "");
    Expect(0, 8528, '\p{^Is_Nv=+00000001/0000007}', "");
    Expect(0, 8528, '\P{Is_Nv=+00000001/0000007}', "");
    Expect(1, 8528, '\P{^Is_Nv=+00000001/0000007}', "");
    Expect(0, 8529, '\p{Is_Nv=+00000001/0000007}', "");
    Expect(1, 8529, '\p{^Is_Nv=+00000001/0000007}', "");
    Expect(1, 8529, '\P{Is_Nv=+00000001/0000007}', "");
    Expect(0, 8529, '\P{^Is_Nv=+00000001/0000007}', "");
    Expect(1, 8528, '\p{Is_Nv=60/420}', "");
    Expect(0, 8528, '\p{^Is_Nv=60/420}', "");
    Expect(0, 8528, '\P{Is_Nv=60/420}', "");
    Expect(1, 8528, '\P{^Is_Nv=60/420}', "");
    Expect(0, 8529, '\p{Is_Nv=60/420}', "");
    Expect(1, 8529, '\p{^Is_Nv=60/420}', "");
    Expect(1, 8529, '\P{Is_Nv=60/420}', "");
    Expect(0, 8529, '\P{^Is_Nv=60/420}', "");
    Error('\p{Is_Nv:   1.4e-01}');
    Error('\P{Is_Nv:   1.4e-01}');
    Error('\p{Is_Nv=1.43e-01}');
    Error('\P{Is_Nv=1.43e-01}');
    Error('\p{Is_Nv=0.14}');
    Error('\P{Is_Nv=0.14}');
    Expect(1, 8528, '\p{Is_Nv=1.429e-01}', "");
    Expect(0, 8528, '\p{^Is_Nv=1.429e-01}', "");
    Expect(0, 8528, '\P{Is_Nv=1.429e-01}', "");
    Expect(1, 8528, '\P{^Is_Nv=1.429e-01}', "");
    Expect(0, 8529, '\p{Is_Nv=1.429e-01}', "");
    Expect(1, 8529, '\p{^Is_Nv=1.429e-01}', "");
    Expect(1, 8529, '\P{Is_Nv=1.429e-01}', "");
    Expect(0, 8529, '\P{^Is_Nv=1.429e-01}', "");
    Error('\p{Is_Nv=0.143}');
    Error('\P{Is_Nv=0.143}');
    Expect(1, 8528, '\p{Is_Nv=1.4286e-01}', "");
    Expect(0, 8528, '\p{^Is_Nv=1.4286e-01}', "");
    Expect(0, 8528, '\P{Is_Nv=1.4286e-01}', "");
    Expect(1, 8528, '\P{^Is_Nv=1.4286e-01}', "");
    Expect(0, 8529, '\p{Is_Nv=1.4286e-01}', "");
    Expect(1, 8529, '\p{^Is_Nv=1.4286e-01}', "");
    Expect(1, 8529, '\P{Is_Nv=1.4286e-01}', "");
    Expect(0, 8529, '\P{^Is_Nv=1.4286e-01}', "");
    Expect(1, 8528, '\p{Is_Nv: 0.1429}', "");
    Expect(0, 8528, '\p{^Is_Nv: 0.1429}', "");
    Expect(0, 8528, '\P{Is_Nv: 0.1429}', "");
    Expect(1, 8528, '\P{^Is_Nv: 0.1429}', "");
    Expect(0, 8529, '\p{Is_Nv: 0.1429}', "");
    Expect(1, 8529, '\p{^Is_Nv: 0.1429}', "");
    Expect(1, 8529, '\P{Is_Nv: 0.1429}', "");
    Expect(0, 8529, '\P{^Is_Nv: 0.1429}', "");
    Expect(1, 8528, '\p{Is_Nv=1.42857e-01}', "");
    Expect(0, 8528, '\p{^Is_Nv=1.42857e-01}', "");
    Expect(0, 8528, '\P{Is_Nv=1.42857e-01}', "");
    Expect(1, 8528, '\P{^Is_Nv=1.42857e-01}', "");
    Expect(0, 8529, '\p{Is_Nv=1.42857e-01}', "");
    Expect(1, 8529, '\p{^Is_Nv=1.42857e-01}', "");
    Expect(1, 8529, '\P{Is_Nv=1.42857e-01}', "");
    Expect(0, 8529, '\P{^Is_Nv=1.42857e-01}', "");
    Expect(1, 8528, '\p{Is_Nv=0.14286}', "");
    Expect(0, 8528, '\p{^Is_Nv=0.14286}', "");
    Expect(0, 8528, '\P{Is_Nv=0.14286}', "");
    Expect(1, 8528, '\P{^Is_Nv=0.14286}', "");
    Expect(0, 8529, '\p{Is_Nv=0.14286}', "");
    Expect(1, 8529, '\p{^Is_Nv=0.14286}', "");
    Expect(1, 8529, '\P{Is_Nv=0.14286}', "");
    Expect(0, 8529, '\P{^Is_Nv=0.14286}', "");
    Error('\p{Numeric_Value=/a/-_01/00008}');
    Error('\P{Numeric_Value=/a/-_01/00008}');
    Expect(1, 74847, '\p{Numeric_Value=:\A1/8\z:}', "");;
    Expect(0, 74848, '\p{Numeric_Value=:\A1/8\z:}', "");;
    Expect(1, 74847, '\p{Numeric_Value=0000000001/00000008}', "");
    Expect(0, 74847, '\p{^Numeric_Value=0000000001/00000008}', "");
    Expect(0, 74847, '\P{Numeric_Value=0000000001/00000008}', "");
    Expect(1, 74847, '\P{^Numeric_Value=0000000001/00000008}', "");
    Expect(0, 74848, '\p{Numeric_Value=0000000001/00000008}', "");
    Expect(1, 74848, '\p{^Numeric_Value=0000000001/00000008}', "");
    Expect(1, 74848, '\P{Numeric_Value=0000000001/00000008}', "");
    Expect(0, 74848, '\P{^Numeric_Value=0000000001/00000008}', "");
    Expect(1, 74847, '\p{Numeric_Value=60/480}', "");
    Expect(0, 74847, '\p{^Numeric_Value=60/480}', "");
    Expect(0, 74847, '\P{Numeric_Value=60/480}', "");
    Expect(1, 74847, '\P{^Numeric_Value=60/480}', "");
    Expect(0, 74848, '\p{Numeric_Value=60/480}', "");
    Expect(1, 74848, '\p{^Numeric_Value=60/480}', "");
    Expect(1, 74848, '\P{Numeric_Value=60/480}', "");
    Expect(0, 74848, '\P{^Numeric_Value=60/480}', "");
    Error('\p{Numeric_Value:1.2e-01}');
    Error('\P{Numeric_Value:1.2e-01}');
    Expect(1, 74847, '\p{Numeric_Value=1.25e-01}', "");
    Expect(0, 74847, '\p{^Numeric_Value=1.25e-01}', "");
    Expect(0, 74847, '\P{Numeric_Value=1.25e-01}', "");
    Expect(1, 74847, '\P{^Numeric_Value=1.25e-01}', "");
    Expect(0, 74848, '\p{Numeric_Value=1.25e-01}', "");
    Expect(1, 74848, '\p{^Numeric_Value=1.25e-01}', "");
    Expect(1, 74848, '\P{Numeric_Value=1.25e-01}', "");
    Expect(0, 74848, '\P{^Numeric_Value=1.25e-01}', "");
    Error('\p{Numeric_Value=0.12}');
    Error('\P{Numeric_Value=0.12}');
    Expect(1, 74847, '\p{Numeric_Value=1.250e-01}', "");
    Expect(0, 74847, '\p{^Numeric_Value=1.250e-01}', "");
    Expect(0, 74847, '\P{Numeric_Value=1.250e-01}', "");
    Expect(1, 74847, '\P{^Numeric_Value=1.250e-01}', "");
    Expect(0, 74848, '\p{Numeric_Value=1.250e-01}', "");
    Expect(1, 74848, '\p{^Numeric_Value=1.250e-01}', "");
    Expect(1, 74848, '\P{Numeric_Value=1.250e-01}', "");
    Expect(0, 74848, '\P{^Numeric_Value=1.250e-01}', "");
    Expect(1, 74847, '\p{Numeric_Value:0.125}', "");
    Expect(0, 74847, '\p{^Numeric_Value:0.125}', "");
    Expect(0, 74847, '\P{Numeric_Value:0.125}', "");
    Expect(1, 74847, '\P{^Numeric_Value:0.125}', "");
    Expect(0, 74848, '\p{Numeric_Value:0.125}', "");
    Expect(1, 74848, '\p{^Numeric_Value:0.125}', "");
    Expect(1, 74848, '\P{Numeric_Value:0.125}', "");
    Expect(0, 74848, '\P{^Numeric_Value:0.125}', "");
    Expect(1, 74847, '\p{Numeric_Value=1.2500e-01}', "");
    Expect(0, 74847, '\p{^Numeric_Value=1.2500e-01}', "");
    Expect(0, 74847, '\P{Numeric_Value=1.2500e-01}', "");
    Expect(1, 74847, '\P{^Numeric_Value=1.2500e-01}', "");
    Expect(0, 74848, '\p{Numeric_Value=1.2500e-01}', "");
    Expect(1, 74848, '\p{^Numeric_Value=1.2500e-01}', "");
    Expect(1, 74848, '\P{Numeric_Value=1.2500e-01}', "");
    Expect(0, 74848, '\P{^Numeric_Value=1.2500e-01}', "");
    Expect(1, 74847, '\p{Numeric_Value=0.1250}', "");
    Expect(0, 74847, '\p{^Numeric_Value=0.1250}', "");
    Expect(0, 74847, '\P{Numeric_Value=0.1250}', "");
    Expect(1, 74847, '\P{^Numeric_Value=0.1250}', "");
    Expect(0, 74848, '\p{Numeric_Value=0.1250}', "");
    Expect(1, 74848, '\p{^Numeric_Value=0.1250}', "");
    Expect(1, 74848, '\P{Numeric_Value=0.1250}', "");
    Expect(0, 74848, '\P{^Numeric_Value=0.1250}', "");
    Error('\p{Nv= 	+000000001/008/a/}');
    Error('\P{Nv= 	+000000001/008/a/}');
    Expect(1, 74847, '\p{Nv=:\A1/8\z:}', "");;
    Expect(0, 74848, '\p{Nv=:\A1/8\z:}', "");;
    Expect(1, 74847, '\p{Nv=000000001/008}', "");
    Expect(0, 74847, '\p{^Nv=000000001/008}', "");
    Expect(0, 74847, '\P{Nv=000000001/008}', "");
    Expect(1, 74847, '\P{^Nv=000000001/008}', "");
    Expect(0, 74848, '\p{Nv=000000001/008}', "");
    Expect(1, 74848, '\p{^Nv=000000001/008}', "");
    Expect(1, 74848, '\P{Nv=000000001/008}', "");
    Expect(0, 74848, '\P{^Nv=000000001/008}', "");
    Expect(1, 74847, '\p{Nv=60/480}', "");
    Expect(0, 74847, '\p{^Nv=60/480}', "");
    Expect(0, 74847, '\P{Nv=60/480}', "");
    Expect(1, 74847, '\P{^Nv=60/480}', "");
    Expect(0, 74848, '\p{Nv=60/480}', "");
    Expect(1, 74848, '\p{^Nv=60/480}', "");
    Expect(1, 74848, '\P{Nv=60/480}', "");
    Expect(0, 74848, '\P{^Nv=60/480}', "");
    Error('\p{Nv=1.2e-01}');
    Error('\P{Nv=1.2e-01}');
    Expect(1, 74847, '\p{Nv: 1.25e-01}', "");
    Expect(0, 74847, '\p{^Nv: 1.25e-01}', "");
    Expect(0, 74847, '\P{Nv: 1.25e-01}', "");
    Expect(1, 74847, '\P{^Nv: 1.25e-01}', "");
    Expect(0, 74848, '\p{Nv: 1.25e-01}', "");
    Expect(1, 74848, '\p{^Nv: 1.25e-01}', "");
    Expect(1, 74848, '\P{Nv: 1.25e-01}', "");
    Expect(0, 74848, '\P{^Nv: 1.25e-01}', "");
    Error('\p{Nv=0.12}');
    Error('\P{Nv=0.12}');
    Expect(1, 74847, '\p{Nv=1.250e-01}', "");
    Expect(0, 74847, '\p{^Nv=1.250e-01}', "");
    Expect(0, 74847, '\P{Nv=1.250e-01}', "");
    Expect(1, 74847, '\P{^Nv=1.250e-01}', "");
    Expect(0, 74848, '\p{Nv=1.250e-01}', "");
    Expect(1, 74848, '\p{^Nv=1.250e-01}', "");
    Expect(1, 74848, '\P{Nv=1.250e-01}', "");
    Expect(0, 74848, '\P{^Nv=1.250e-01}', "");
    Expect(1, 74847, '\p{Nv: 0.125}', "");
    Expect(0, 74847, '\p{^Nv: 0.125}', "");
    Expect(0, 74847, '\P{Nv: 0.125}', "");
    Expect(1, 74847, '\P{^Nv: 0.125}', "");
    Expect(0, 74848, '\p{Nv: 0.125}', "");
    Expect(1, 74848, '\p{^Nv: 0.125}', "");
    Expect(1, 74848, '\P{Nv: 0.125}', "");
    Expect(0, 74848, '\P{^Nv: 0.125}', "");
    Expect(1, 74847, '\p{Nv=1.2500e-01}', "");
    Expect(0, 74847, '\p{^Nv=1.2500e-01}', "");
    Expect(0, 74847, '\P{Nv=1.2500e-01}', "");
    Expect(1, 74847, '\P{^Nv=1.2500e-01}', "");
    Expect(0, 74848, '\p{Nv=1.2500e-01}', "");
    Expect(1, 74848, '\p{^Nv=1.2500e-01}', "");
    Expect(1, 74848, '\P{Nv=1.2500e-01}', "");
    Expect(0, 74848, '\P{^Nv=1.2500e-01}', "");
    Expect(1, 74847, '\p{Nv=0.1250}', "");
    Expect(0, 74847, '\p{^Nv=0.1250}', "");
    Expect(0, 74847, '\P{Nv=0.1250}', "");
    Expect(1, 74847, '\P{^Nv=0.1250}', "");
    Expect(0, 74848, '\p{Nv=0.1250}', "");
    Expect(1, 74848, '\p{^Nv=0.1250}', "");
    Expect(1, 74848, '\P{Nv=0.1250}', "");
    Expect(0, 74848, '\P{^Nv=0.1250}', "");
    Error('\p{Is_Numeric_Value=/a/  1/008}');
    Error('\P{Is_Numeric_Value=/a/  1/008}');
    Expect(1, 74847, '\p{Is_Numeric_Value=+001/000000008}', "");
    Expect(0, 74847, '\p{^Is_Numeric_Value=+001/000000008}', "");
    Expect(0, 74847, '\P{Is_Numeric_Value=+001/000000008}', "");
    Expect(1, 74847, '\P{^Is_Numeric_Value=+001/000000008}', "");
    Expect(0, 74848, '\p{Is_Numeric_Value=+001/000000008}', "");
    Expect(1, 74848, '\p{^Is_Numeric_Value=+001/000000008}', "");
    Expect(1, 74848, '\P{Is_Numeric_Value=+001/000000008}', "");
    Expect(0, 74848, '\P{^Is_Numeric_Value=+001/000000008}', "");
    Expect(1, 74847, '\p{Is_Numeric_Value=60/480}', "");
    Expect(0, 74847, '\p{^Is_Numeric_Value=60/480}', "");
    Expect(0, 74847, '\P{Is_Numeric_Value=60/480}', "");
    Expect(1, 74847, '\P{^Is_Numeric_Value=60/480}', "");
    Expect(0, 74848, '\p{Is_Numeric_Value=60/480}', "");
    Expect(1, 74848, '\p{^Is_Numeric_Value=60/480}', "");
    Expect(1, 74848, '\P{Is_Numeric_Value=60/480}', "");
    Expect(0, 74848, '\P{^Is_Numeric_Value=60/480}', "");
    Error('\p{Is_Numeric_Value=1.2e-01}');
    Error('\P{Is_Numeric_Value=1.2e-01}');
    Expect(1, 74847, '\p{Is_Numeric_Value=1.25e-01}', "");
    Expect(0, 74847, '\p{^Is_Numeric_Value=1.25e-01}', "");
    Expect(0, 74847, '\P{Is_Numeric_Value=1.25e-01}', "");
    Expect(1, 74847, '\P{^Is_Numeric_Value=1.25e-01}', "");
    Expect(0, 74848, '\p{Is_Numeric_Value=1.25e-01}', "");
    Expect(1, 74848, '\p{^Is_Numeric_Value=1.25e-01}', "");
    Expect(1, 74848, '\P{Is_Numeric_Value=1.25e-01}', "");
    Expect(0, 74848, '\P{^Is_Numeric_Value=1.25e-01}', "");
    Error('\p{Is_Numeric_Value: 0.12}');
    Error('\P{Is_Numeric_Value: 0.12}');
    Expect(1, 74847, '\p{Is_Numeric_Value=1.250e-01}', "");
    Expect(0, 74847, '\p{^Is_Numeric_Value=1.250e-01}', "");
    Expect(0, 74847, '\P{Is_Numeric_Value=1.250e-01}', "");
    Expect(1, 74847, '\P{^Is_Numeric_Value=1.250e-01}', "");
    Expect(0, 74848, '\p{Is_Numeric_Value=1.250e-01}', "");
    Expect(1, 74848, '\p{^Is_Numeric_Value=1.250e-01}', "");
    Expect(1, 74848, '\P{Is_Numeric_Value=1.250e-01}', "");
    Expect(0, 74848, '\P{^Is_Numeric_Value=1.250e-01}', "");
    Expect(1, 74847, '\p{Is_Numeric_Value=0.125}', "");
    Expect(0, 74847, '\p{^Is_Numeric_Value=0.125}', "");
    Expect(0, 74847, '\P{Is_Numeric_Value=0.125}', "");
    Expect(1, 74847, '\P{^Is_Numeric_Value=0.125}', "");
    Expect(0, 74848, '\p{Is_Numeric_Value=0.125}', "");
    Expect(1, 74848, '\p{^Is_Numeric_Value=0.125}', "");
    Expect(1, 74848, '\P{Is_Numeric_Value=0.125}', "");
    Expect(0, 74848, '\P{^Is_Numeric_Value=0.125}', "");
    Expect(1, 74847, '\p{Is_Numeric_Value=1.2500e-01}', "");
    Expect(0, 74847, '\p{^Is_Numeric_Value=1.2500e-01}', "");
    Expect(0, 74847, '\P{Is_Numeric_Value=1.2500e-01}', "");
    Expect(1, 74847, '\P{^Is_Numeric_Value=1.2500e-01}', "");
    Expect(0, 74848, '\p{Is_Numeric_Value=1.2500e-01}', "");
    Expect(1, 74848, '\p{^Is_Numeric_Value=1.2500e-01}', "");
    Expect(1, 74848, '\P{Is_Numeric_Value=1.2500e-01}', "");
    Expect(0, 74848, '\P{^Is_Numeric_Value=1.2500e-01}', "");
    Expect(1, 74847, '\p{Is_Numeric_Value:	0.1250}', "");
    Expect(0, 74847, '\p{^Is_Numeric_Value:	0.1250}', "");
    Expect(0, 74847, '\P{Is_Numeric_Value:	0.1250}', "");
    Expect(1, 74847, '\P{^Is_Numeric_Value:	0.1250}', "");
    Expect(0, 74848, '\p{Is_Numeric_Value:	0.1250}', "");
    Expect(1, 74848, '\p{^Is_Numeric_Value:	0.1250}', "");
    Expect(1, 74848, '\P{Is_Numeric_Value:	0.1250}', "");
    Expect(0, 74848, '\P{^Is_Numeric_Value:	0.1250}', "");
    Error('\p{Is_Nv=:=-000000001/00008}');
    Error('\P{Is_Nv=:=-000000001/00008}');
    Expect(1, 74847, '\p{Is_Nv=0000000001/08}', "");
    Expect(0, 74847, '\p{^Is_Nv=0000000001/08}', "");
    Expect(0, 74847, '\P{Is_Nv=0000000001/08}', "");
    Expect(1, 74847, '\P{^Is_Nv=0000000001/08}', "");
    Expect(0, 74848, '\p{Is_Nv=0000000001/08}', "");
    Expect(1, 74848, '\p{^Is_Nv=0000000001/08}', "");
    Expect(1, 74848, '\P{Is_Nv=0000000001/08}', "");
    Expect(0, 74848, '\P{^Is_Nv=0000000001/08}', "");
    Expect(1, 74847, '\p{Is_Nv=60/480}', "");
    Expect(0, 74847, '\p{^Is_Nv=60/480}', "");
    Expect(0, 74847, '\P{Is_Nv=60/480}', "");
    Expect(1, 74847, '\P{^Is_Nv=60/480}', "");
    Expect(0, 74848, '\p{Is_Nv=60/480}', "");
    Expect(1, 74848, '\p{^Is_Nv=60/480}', "");
    Expect(1, 74848, '\P{Is_Nv=60/480}', "");
    Expect(0, 74848, '\P{^Is_Nv=60/480}', "");
    Error('\p{Is_Nv=1.2e-01}');
    Error('\P{Is_Nv=1.2e-01}');
    Expect(1, 74847, '\p{Is_Nv=1.25e-01}', "");
    Expect(0, 74847, '\p{^Is_Nv=1.25e-01}', "");
    Expect(0, 74847, '\P{Is_Nv=1.25e-01}', "");
    Expect(1, 74847, '\P{^Is_Nv=1.25e-01}', "");
    Expect(0, 74848, '\p{Is_Nv=1.25e-01}', "");
    Expect(1, 74848, '\p{^Is_Nv=1.25e-01}', "");
    Expect(1, 74848, '\P{Is_Nv=1.25e-01}', "");
    Expect(0, 74848, '\P{^Is_Nv=1.25e-01}', "");
    Error('\p{Is_Nv=0.12}');
    Error('\P{Is_Nv=0.12}');
    Expect(1, 74847, '\p{Is_Nv=1.250e-01}', "");
    Expect(0, 74847, '\p{^Is_Nv=1.250e-01}', "");
    Expect(0, 74847, '\P{Is_Nv=1.250e-01}', "");
    Expect(1, 74847, '\P{^Is_Nv=1.250e-01}', "");
    Expect(0, 74848, '\p{Is_Nv=1.250e-01}', "");
    Expect(1, 74848, '\p{^Is_Nv=1.250e-01}', "");
    Expect(1, 74848, '\P{Is_Nv=1.250e-01}', "");
    Expect(0, 74848, '\P{^Is_Nv=1.250e-01}', "");
    Expect(1, 74847, '\p{Is_Nv: 0.125}', "");
    Expect(0, 74847, '\p{^Is_Nv: 0.125}', "");
    Expect(0, 74847, '\P{Is_Nv: 0.125}', "");
    Expect(1, 74847, '\P{^Is_Nv: 0.125}', "");
    Expect(0, 74848, '\p{Is_Nv: 0.125}', "");
    Expect(1, 74848, '\p{^Is_Nv: 0.125}', "");
    Expect(1, 74848, '\P{Is_Nv: 0.125}', "");
    Expect(0, 74848, '\P{^Is_Nv: 0.125}', "");
    Expect(1, 74847, '\p{Is_Nv=1.2500e-01}', "");
    Expect(0, 74847, '\p{^Is_Nv=1.2500e-01}', "");
    Expect(0, 74847, '\P{Is_Nv=1.2500e-01}', "");
    Expect(1, 74847, '\P{^Is_Nv=1.2500e-01}', "");
    Expect(0, 74848, '\p{Is_Nv=1.2500e-01}', "");
    Expect(1, 74848, '\p{^Is_Nv=1.2500e-01}', "");
    Expect(1, 74848, '\P{Is_Nv=1.2500e-01}', "");
    Expect(0, 74848, '\P{^Is_Nv=1.2500e-01}', "");
    Expect(1, 74847, '\p{Is_Nv=0.1250}', "");
    Expect(0, 74847, '\p{^Is_Nv=0.1250}', "");
    Expect(0, 74847, '\P{Is_Nv=0.1250}', "");
    Expect(1, 74847, '\P{^Is_Nv=0.1250}', "");
    Expect(0, 74848, '\p{Is_Nv=0.1250}', "");
    Expect(1, 74848, '\p{^Is_Nv=0.1250}', "");
    Expect(1, 74848, '\P{Is_Nv=0.1250}', "");
    Expect(0, 74848, '\P{^Is_Nv=0.1250}', "");
    Error('\p{Numeric_Value=_:=001/000000080}');
    Error('\P{Numeric_Value=_:=001/000000080}');
    Expect(1, 73666, '\p{Numeric_Value=:\A1/80\z:}', "");;
    Expect(0, 73667, '\p{Numeric_Value=:\A1/80\z:}', "");;
    Expect(1, 73666, '\p{Numeric_Value=+00001/000080}', "");
    Expect(0, 73666, '\p{^Numeric_Value=+00001/000080}', "");
    Expect(0, 73666, '\P{Numeric_Value=+00001/000080}', "");
    Expect(1, 73666, '\P{^Numeric_Value=+00001/000080}', "");
    Expect(0, 73667, '\p{Numeric_Value=+00001/000080}', "");
    Expect(1, 73667, '\p{^Numeric_Value=+00001/000080}', "");
    Expect(1, 73667, '\P{Numeric_Value=+00001/000080}', "");
    Expect(0, 73667, '\P{^Numeric_Value=+00001/000080}', "");
    Expect(1, 73666, '\p{Numeric_Value=60/4800}', "");
    Expect(0, 73666, '\p{^Numeric_Value=60/4800}', "");
    Expect(0, 73666, '\P{Numeric_Value=60/4800}', "");
    Expect(1, 73666, '\P{^Numeric_Value=60/4800}', "");
    Expect(0, 73667, '\p{Numeric_Value=60/4800}', "");
    Expect(1, 73667, '\p{^Numeric_Value=60/4800}', "");
    Expect(1, 73667, '\P{Numeric_Value=60/4800}', "");
    Expect(0, 73667, '\P{^Numeric_Value=60/4800}', "");
    Error('\p{Numeric_Value=1.3e-02}');
    Error('\P{Numeric_Value=1.3e-02}');
    Expect(1, 73666, '\p{Numeric_Value=1.25e-02}', "");
    Expect(0, 73666, '\p{^Numeric_Value=1.25e-02}', "");
    Expect(0, 73666, '\P{Numeric_Value=1.25e-02}', "");
    Expect(1, 73666, '\P{^Numeric_Value=1.25e-02}', "");
    Expect(0, 73667, '\p{Numeric_Value=1.25e-02}', "");
    Expect(1, 73667, '\p{^Numeric_Value=1.25e-02}', "");
    Expect(1, 73667, '\P{Numeric_Value=1.25e-02}', "");
    Expect(0, 73667, '\P{^Numeric_Value=1.25e-02}', "");
    Error('\p{Numeric_Value=0.01}');
    Error('\P{Numeric_Value=0.01}');
    Expect(1, 73666, '\p{Numeric_Value=1.250e-02}', "");
    Expect(0, 73666, '\p{^Numeric_Value=1.250e-02}', "");
    Expect(0, 73666, '\P{Numeric_Value=1.250e-02}', "");
    Expect(1, 73666, '\P{^Numeric_Value=1.250e-02}', "");
    Expect(0, 73667, '\p{Numeric_Value=1.250e-02}', "");
    Expect(1, 73667, '\p{^Numeric_Value=1.250e-02}', "");
    Expect(1, 73667, '\P{Numeric_Value=1.250e-02}', "");
    Expect(0, 73667, '\P{^Numeric_Value=1.250e-02}', "");
    Error('\p{Numeric_Value:   0.013}');
    Error('\P{Numeric_Value:   0.013}');
    Expect(1, 73666, '\p{Numeric_Value=1.2500e-02}', "");
    Expect(0, 73666, '\p{^Numeric_Value=1.2500e-02}', "");
    Expect(0, 73666, '\P{Numeric_Value=1.2500e-02}', "");
    Expect(1, 73666, '\P{^Numeric_Value=1.2500e-02}', "");
    Expect(0, 73667, '\p{Numeric_Value=1.2500e-02}', "");
    Expect(1, 73667, '\p{^Numeric_Value=1.2500e-02}', "");
    Expect(1, 73667, '\P{Numeric_Value=1.2500e-02}', "");
    Expect(0, 73667, '\P{^Numeric_Value=1.2500e-02}', "");
    Expect(1, 73666, '\p{Numeric_Value=0.0125}', "");
    Expect(0, 73666, '\p{^Numeric_Value=0.0125}', "");
    Expect(0, 73666, '\P{Numeric_Value=0.0125}', "");
    Expect(1, 73666, '\P{^Numeric_Value=0.0125}', "");
    Expect(0, 73667, '\p{Numeric_Value=0.0125}', "");
    Expect(1, 73667, '\p{^Numeric_Value=0.0125}', "");
    Expect(1, 73667, '\P{Numeric_Value=0.0125}', "");
    Expect(0, 73667, '\P{^Numeric_Value=0.0125}', "");
    Expect(1, 73666, '\p{Numeric_Value=1.25000e-02}', "");
    Expect(0, 73666, '\p{^Numeric_Value=1.25000e-02}', "");
    Expect(0, 73666, '\P{Numeric_Value=1.25000e-02}', "");
    Expect(1, 73666, '\P{^Numeric_Value=1.25000e-02}', "");
    Expect(0, 73667, '\p{Numeric_Value=1.25000e-02}', "");
    Expect(1, 73667, '\p{^Numeric_Value=1.25000e-02}', "");
    Expect(1, 73667, '\P{Numeric_Value=1.25000e-02}', "");
    Expect(0, 73667, '\P{^Numeric_Value=1.25000e-02}', "");
    Expect(1, 73666, '\p{Numeric_Value=0.01250}', "");
    Expect(0, 73666, '\p{^Numeric_Value=0.01250}', "");
    Expect(0, 73666, '\P{Numeric_Value=0.01250}', "");
    Expect(1, 73666, '\P{^Numeric_Value=0.01250}', "");
    Expect(0, 73667, '\p{Numeric_Value=0.01250}', "");
    Expect(1, 73667, '\p{^Numeric_Value=0.01250}', "");
    Expect(1, 73667, '\P{Numeric_Value=0.01250}', "");
    Expect(0, 73667, '\P{^Numeric_Value=0.01250}', "");
    Error('\p{Nv=  1/00000080:=}');
    Error('\P{Nv=  1/00000080:=}');
    Expect(1, 73666, '\p{Nv=:\A1/80\z:}', "");;
    Expect(0, 73667, '\p{Nv=:\A1/80\z:}', "");;
    Expect(1, 73666, '\p{Nv=1/00000080}', "");
    Expect(0, 73666, '\p{^Nv=1/00000080}', "");
    Expect(0, 73666, '\P{Nv=1/00000080}', "");
    Expect(1, 73666, '\P{^Nv=1/00000080}', "");
    Expect(0, 73667, '\p{Nv=1/00000080}', "");
    Expect(1, 73667, '\p{^Nv=1/00000080}', "");
    Expect(1, 73667, '\P{Nv=1/00000080}', "");
    Expect(0, 73667, '\P{^Nv=1/00000080}', "");
    Expect(1, 73666, '\p{Nv=60/4800}', "");
    Expect(0, 73666, '\p{^Nv=60/4800}', "");
    Expect(0, 73666, '\P{Nv=60/4800}', "");
    Expect(1, 73666, '\P{^Nv=60/4800}', "");
    Expect(0, 73667, '\p{Nv=60/4800}', "");
    Expect(1, 73667, '\p{^Nv=60/4800}', "");
    Expect(1, 73667, '\P{Nv=60/4800}', "");
    Expect(0, 73667, '\P{^Nv=60/4800}', "");
    Error('\p{Nv=1.3e-02}');
    Error('\P{Nv=1.3e-02}');
    Expect(1, 73666, '\p{Nv=1.25e-02}', "");
    Expect(0, 73666, '\p{^Nv=1.25e-02}', "");
    Expect(0, 73666, '\P{Nv=1.25e-02}', "");
    Expect(1, 73666, '\P{^Nv=1.25e-02}', "");
    Expect(0, 73667, '\p{Nv=1.25e-02}', "");
    Expect(1, 73667, '\p{^Nv=1.25e-02}', "");
    Expect(1, 73667, '\P{Nv=1.25e-02}', "");
    Expect(0, 73667, '\P{^Nv=1.25e-02}', "");
    Error('\p{Nv=0.01}');
    Error('\P{Nv=0.01}');
    Expect(1, 73666, '\p{Nv=1.250e-02}', "");
    Expect(0, 73666, '\p{^Nv=1.250e-02}', "");
    Expect(0, 73666, '\P{Nv=1.250e-02}', "");
    Expect(1, 73666, '\P{^Nv=1.250e-02}', "");
    Expect(0, 73667, '\p{Nv=1.250e-02}', "");
    Expect(1, 73667, '\p{^Nv=1.250e-02}', "");
    Expect(1, 73667, '\P{Nv=1.250e-02}', "");
    Expect(0, 73667, '\P{^Nv=1.250e-02}', "");
    Error('\p{Nv=0.013}');
    Error('\P{Nv=0.013}');
    Expect(1, 73666, '\p{Nv=1.2500e-02}', "");
    Expect(0, 73666, '\p{^Nv=1.2500e-02}', "");
    Expect(0, 73666, '\P{Nv=1.2500e-02}', "");
    Expect(1, 73666, '\P{^Nv=1.2500e-02}', "");
    Expect(0, 73667, '\p{Nv=1.2500e-02}', "");
    Expect(1, 73667, '\p{^Nv=1.2500e-02}', "");
    Expect(1, 73667, '\P{Nv=1.2500e-02}', "");
    Expect(0, 73667, '\P{^Nv=1.2500e-02}', "");
    Expect(1, 73666, '\p{Nv:	0.0125}', "");
    Expect(0, 73666, '\p{^Nv:	0.0125}', "");
    Expect(0, 73666, '\P{Nv:	0.0125}', "");
    Expect(1, 73666, '\P{^Nv:	0.0125}', "");
    Expect(0, 73667, '\p{Nv:	0.0125}', "");
    Expect(1, 73667, '\p{^Nv:	0.0125}', "");
    Expect(1, 73667, '\P{Nv:	0.0125}', "");
    Expect(0, 73667, '\P{^Nv:	0.0125}', "");
    Expect(1, 73666, '\p{Nv=1.25000e-02}', "");
    Expect(0, 73666, '\p{^Nv=1.25000e-02}', "");
    Expect(0, 73666, '\P{Nv=1.25000e-02}', "");
    Expect(1, 73666, '\P{^Nv=1.25000e-02}', "");
    Expect(0, 73667, '\p{Nv=1.25000e-02}', "");
    Expect(1, 73667, '\p{^Nv=1.25000e-02}', "");
    Expect(1, 73667, '\P{Nv=1.25000e-02}', "");
    Expect(0, 73667, '\P{^Nv=1.25000e-02}', "");
    Expect(1, 73666, '\p{Nv=0.01250}', "");
    Expect(0, 73666, '\p{^Nv=0.01250}', "");
    Expect(0, 73666, '\P{Nv=0.01250}', "");
    Expect(1, 73666, '\P{^Nv=0.01250}', "");
    Expect(0, 73667, '\p{Nv=0.01250}', "");
    Expect(1, 73667, '\p{^Nv=0.01250}', "");
    Expect(1, 73667, '\P{Nv=0.01250}', "");
    Expect(0, 73667, '\P{^Nv=0.01250}', "");
    Error('\p{Is_Numeric_Value=:=_ 00000001/000000080}');
    Error('\P{Is_Numeric_Value=:=_ 00000001/000000080}');
    Expect(1, 73666, '\p{Is_Numeric_Value=+0000000001/00000080}', "");
    Expect(0, 73666, '\p{^Is_Numeric_Value=+0000000001/00000080}', "");
    Expect(0, 73666, '\P{Is_Numeric_Value=+0000000001/00000080}', "");
    Expect(1, 73666, '\P{^Is_Numeric_Value=+0000000001/00000080}', "");
    Expect(0, 73667, '\p{Is_Numeric_Value=+0000000001/00000080}', "");
    Expect(1, 73667, '\p{^Is_Numeric_Value=+0000000001/00000080}', "");
    Expect(1, 73667, '\P{Is_Numeric_Value=+0000000001/00000080}', "");
    Expect(0, 73667, '\P{^Is_Numeric_Value=+0000000001/00000080}', "");
    Expect(1, 73666, '\p{Is_Numeric_Value=60/4800}', "");
    Expect(0, 73666, '\p{^Is_Numeric_Value=60/4800}', "");
    Expect(0, 73666, '\P{Is_Numeric_Value=60/4800}', "");
    Expect(1, 73666, '\P{^Is_Numeric_Value=60/4800}', "");
    Expect(0, 73667, '\p{Is_Numeric_Value=60/4800}', "");
    Expect(1, 73667, '\p{^Is_Numeric_Value=60/4800}', "");
    Expect(1, 73667, '\P{Is_Numeric_Value=60/4800}', "");
    Expect(0, 73667, '\P{^Is_Numeric_Value=60/4800}', "");
    Error('\p{Is_Numeric_Value=1.3e-02}');
    Error('\P{Is_Numeric_Value=1.3e-02}');
    Expect(1, 73666, '\p{Is_Numeric_Value=1.25e-02}', "");
    Expect(0, 73666, '\p{^Is_Numeric_Value=1.25e-02}', "");
    Expect(0, 73666, '\P{Is_Numeric_Value=1.25e-02}', "");
    Expect(1, 73666, '\P{^Is_Numeric_Value=1.25e-02}', "");
    Expect(0, 73667, '\p{Is_Numeric_Value=1.25e-02}', "");
    Expect(1, 73667, '\p{^Is_Numeric_Value=1.25e-02}', "");
    Expect(1, 73667, '\P{Is_Numeric_Value=1.25e-02}', "");
    Expect(0, 73667, '\P{^Is_Numeric_Value=1.25e-02}', "");
    Error('\p{Is_Numeric_Value=0.01}');
    Error('\P{Is_Numeric_Value=0.01}');
    Expect(1, 73666, '\p{Is_Numeric_Value=1.250e-02}', "");
    Expect(0, 73666, '\p{^Is_Numeric_Value=1.250e-02}', "");
    Expect(0, 73666, '\P{Is_Numeric_Value=1.250e-02}', "");
    Expect(1, 73666, '\P{^Is_Numeric_Value=1.250e-02}', "");
    Expect(0, 73667, '\p{Is_Numeric_Value=1.250e-02}', "");
    Expect(1, 73667, '\p{^Is_Numeric_Value=1.250e-02}', "");
    Expect(1, 73667, '\P{Is_Numeric_Value=1.250e-02}', "");
    Expect(0, 73667, '\P{^Is_Numeric_Value=1.250e-02}', "");
    Error('\p{Is_Numeric_Value=0.013}');
    Error('\P{Is_Numeric_Value=0.013}');
    Expect(1, 73666, '\p{Is_Numeric_Value=1.2500e-02}', "");
    Expect(0, 73666, '\p{^Is_Numeric_Value=1.2500e-02}', "");
    Expect(0, 73666, '\P{Is_Numeric_Value=1.2500e-02}', "");
    Expect(1, 73666, '\P{^Is_Numeric_Value=1.2500e-02}', "");
    Expect(0, 73667, '\p{Is_Numeric_Value=1.2500e-02}', "");
    Expect(1, 73667, '\p{^Is_Numeric_Value=1.2500e-02}', "");
    Expect(1, 73667, '\P{Is_Numeric_Value=1.2500e-02}', "");
    Expect(0, 73667, '\P{^Is_Numeric_Value=1.2500e-02}', "");
    Expect(1, 73666, '\p{Is_Numeric_Value=0.0125}', "");
    Expect(0, 73666, '\p{^Is_Numeric_Value=0.0125}', "");
    Expect(0, 73666, '\P{Is_Numeric_Value=0.0125}', "");
    Expect(1, 73666, '\P{^Is_Numeric_Value=0.0125}', "");
    Expect(0, 73667, '\p{Is_Numeric_Value=0.0125}', "");
    Expect(1, 73667, '\p{^Is_Numeric_Value=0.0125}', "");
    Expect(1, 73667, '\P{Is_Numeric_Value=0.0125}', "");
    Expect(0, 73667, '\P{^Is_Numeric_Value=0.0125}', "");
    Expect(1, 73666, '\p{Is_Numeric_Value=1.25000e-02}', "");
    Expect(0, 73666, '\p{^Is_Numeric_Value=1.25000e-02}', "");
    Expect(0, 73666, '\P{Is_Numeric_Value=1.25000e-02}', "");
    Expect(1, 73666, '\P{^Is_Numeric_Value=1.25000e-02}', "");
    Expect(0, 73667, '\p{Is_Numeric_Value=1.25000e-02}', "");
    Expect(1, 73667, '\p{^Is_Numeric_Value=1.25000e-02}', "");
    Expect(1, 73667, '\P{Is_Numeric_Value=1.25000e-02}', "");
    Expect(0, 73667, '\P{^Is_Numeric_Value=1.25000e-02}', "");
    Expect(1, 73666, '\p{Is_Numeric_Value=0.01250}', "");
    Expect(0, 73666, '\p{^Is_Numeric_Value=0.01250}', "");
    Expect(0, 73666, '\P{Is_Numeric_Value=0.01250}', "");
    Expect(1, 73666, '\P{^Is_Numeric_Value=0.01250}', "");
    Expect(0, 73667, '\p{Is_Numeric_Value=0.01250}', "");
    Expect(1, 73667, '\p{^Is_Numeric_Value=0.01250}', "");
    Expect(1, 73667, '\P{Is_Numeric_Value=0.01250}', "");
    Expect(0, 73667, '\P{^Is_Numeric_Value=0.01250}', "");
    Error('\p{Is_Nv: _ +0000001/0000080/a/}');
    Error('\P{Is_Nv: _ +0000001/0000080/a/}');
    Expect(1, 73666, '\p{Is_Nv=0000001/0000080}', "");
    Expect(0, 73666, '\p{^Is_Nv=0000001/0000080}', "");
    Expect(0, 73666, '\P{Is_Nv=0000001/0000080}', "");
    Expect(1, 73666, '\P{^Is_Nv=0000001/0000080}', "");
    Expect(0, 73667, '\p{Is_Nv=0000001/0000080}', "");
    Expect(1, 73667, '\p{^Is_Nv=0000001/0000080}', "");
    Expect(1, 73667, '\P{Is_Nv=0000001/0000080}', "");
    Expect(0, 73667, '\P{^Is_Nv=0000001/0000080}', "");
    Expect(1, 73666, '\p{Is_Nv=60/4800}', "");
    Expect(0, 73666, '\p{^Is_Nv=60/4800}', "");
    Expect(0, 73666, '\P{Is_Nv=60/4800}', "");
    Expect(1, 73666, '\P{^Is_Nv=60/4800}', "");
    Expect(0, 73667, '\p{Is_Nv=60/4800}', "");
    Expect(1, 73667, '\p{^Is_Nv=60/4800}', "");
    Expect(1, 73667, '\P{Is_Nv=60/4800}', "");
    Expect(0, 73667, '\P{^Is_Nv=60/4800}', "");
    Error('\p{Is_Nv=1.3e-02}');
    Error('\P{Is_Nv=1.3e-02}');
    Expect(1, 73666, '\p{Is_Nv=1.25e-02}', "");
    Expect(0, 73666, '\p{^Is_Nv=1.25e-02}', "");
    Expect(0, 73666, '\P{Is_Nv=1.25e-02}', "");
    Expect(1, 73666, '\P{^Is_Nv=1.25e-02}', "");
    Expect(0, 73667, '\p{Is_Nv=1.25e-02}', "");
    Expect(1, 73667, '\p{^Is_Nv=1.25e-02}', "");
    Expect(1, 73667, '\P{Is_Nv=1.25e-02}', "");
    Expect(0, 73667, '\P{^Is_Nv=1.25e-02}', "");
    Error('\p{Is_Nv=0.01}');
    Error('\P{Is_Nv=0.01}');
    Expect(1, 73666, '\p{Is_Nv=1.250e-02}', "");
    Expect(0, 73666, '\p{^Is_Nv=1.250e-02}', "");
    Expect(0, 73666, '\P{Is_Nv=1.250e-02}', "");
    Expect(1, 73666, '\P{^Is_Nv=1.250e-02}', "");
    Expect(0, 73667, '\p{Is_Nv=1.250e-02}', "");
    Expect(1, 73667, '\p{^Is_Nv=1.250e-02}', "");
    Expect(1, 73667, '\P{Is_Nv=1.250e-02}', "");
    Expect(0, 73667, '\P{^Is_Nv=1.250e-02}', "");
    Error('\p{Is_Nv=0.013}');
    Error('\P{Is_Nv=0.013}');
    Expect(1, 73666, '\p{Is_Nv=1.2500e-02}', "");
    Expect(0, 73666, '\p{^Is_Nv=1.2500e-02}', "");
    Expect(0, 73666, '\P{Is_Nv=1.2500e-02}', "");
    Expect(1, 73666, '\P{^Is_Nv=1.2500e-02}', "");
    Expect(0, 73667, '\p{Is_Nv=1.2500e-02}', "");
    Expect(1, 73667, '\p{^Is_Nv=1.2500e-02}', "");
    Expect(1, 73667, '\P{Is_Nv=1.2500e-02}', "");
    Expect(0, 73667, '\P{^Is_Nv=1.2500e-02}', "");
    Expect(1, 73666, '\p{Is_Nv=0.0125}', "");
    Expect(0, 73666, '\p{^Is_Nv=0.0125}', "");
    Expect(0, 73666, '\P{Is_Nv=0.0125}', "");
    Expect(1, 73666, '\P{^Is_Nv=0.0125}', "");
    Expect(0, 73667, '\p{Is_Nv=0.0125}', "");
    Expect(1, 73667, '\p{^Is_Nv=0.0125}', "");
    Expect(1, 73667, '\P{Is_Nv=0.0125}', "");
    Expect(0, 73667, '\P{^Is_Nv=0.0125}', "");
    Expect(1, 73666, '\p{Is_Nv=1.25000e-02}', "");
    Expect(0, 73666, '\p{^Is_Nv=1.25000e-02}', "");
    Expect(0, 73666, '\P{Is_Nv=1.25000e-02}', "");
    Expect(1, 73666, '\P{^Is_Nv=1.25000e-02}', "");
    Expect(0, 73667, '\p{Is_Nv=1.25000e-02}', "");
    Expect(1, 73667, '\p{^Is_Nv=1.25000e-02}', "");
    Expect(1, 73667, '\P{Is_Nv=1.25000e-02}', "");
    Expect(0, 73667, '\P{^Is_Nv=1.25000e-02}', "");
    Expect(1, 73666, '\p{Is_Nv=0.01250}', "");
    Expect(0, 73666, '\p{^Is_Nv=0.01250}', "");
    Expect(0, 73666, '\P{Is_Nv=0.01250}', "");
    Expect(1, 73666, '\P{^Is_Nv=0.01250}', "");
    Expect(0, 73667, '\p{Is_Nv=0.01250}', "");
    Expect(1, 73667, '\p{^Is_Nv=0.01250}', "");
    Expect(1, 73667, '\P{Is_Nv=0.01250}', "");
    Expect(0, 73667, '\P{^Is_Nv=0.01250}', "");
    Error('\p{Numeric_Value=_/a/000000001/09}');
    Error('\P{Numeric_Value=_/a/000000001/09}');
    Expect(1, 8529, '\p{Numeric_Value=:\A1/9\z:}', "");;
    Expect(0, 8530, '\p{Numeric_Value=:\A1/9\z:}', "");;
    Expect(1, 8529, '\p{Numeric_Value=0000000001/0009}', "");
    Expect(0, 8529, '\p{^Numeric_Value=0000000001/0009}', "");
    Expect(0, 8529, '\P{Numeric_Value=0000000001/0009}', "");
    Expect(1, 8529, '\P{^Numeric_Value=0000000001/0009}', "");
    Expect(0, 8530, '\p{Numeric_Value=0000000001/0009}', "");
    Expect(1, 8530, '\p{^Numeric_Value=0000000001/0009}', "");
    Expect(1, 8530, '\P{Numeric_Value=0000000001/0009}', "");
    Expect(0, 8530, '\P{^Numeric_Value=0000000001/0009}', "");
    Expect(1, 8529, '\p{Numeric_Value=60/540}', "");
    Expect(0, 8529, '\p{^Numeric_Value=60/540}', "");
    Expect(0, 8529, '\P{Numeric_Value=60/540}', "");
    Expect(1, 8529, '\P{^Numeric_Value=60/540}', "");
    Expect(0, 8530, '\p{Numeric_Value=60/540}', "");
    Expect(1, 8530, '\p{^Numeric_Value=60/540}', "");
    Expect(1, 8530, '\P{Numeric_Value=60/540}', "");
    Expect(0, 8530, '\P{^Numeric_Value=60/540}', "");
    Error('\p{Numeric_Value=1.1e-01}');
    Error('\P{Numeric_Value=1.1e-01}');
    Error('\p{Numeric_Value:1.11e-01}');
    Error('\P{Numeric_Value:1.11e-01}');
    Error('\p{Numeric_Value=0.11}');
    Error('\P{Numeric_Value=0.11}');
    Expect(1, 8529, '\p{Numeric_Value=1.111e-01}', "");
    Expect(0, 8529, '\p{^Numeric_Value=1.111e-01}', "");
    Expect(0, 8529, '\P{Numeric_Value=1.111e-01}', "");
    Expect(1, 8529, '\P{^Numeric_Value=1.111e-01}', "");
    Expect(0, 8530, '\p{Numeric_Value=1.111e-01}', "");
    Expect(1, 8530, '\p{^Numeric_Value=1.111e-01}', "");
    Expect(1, 8530, '\P{Numeric_Value=1.111e-01}', "");
    Expect(0, 8530, '\P{^Numeric_Value=1.111e-01}', "");
    Error('\p{Numeric_Value=0.111}');
    Error('\P{Numeric_Value=0.111}');
    Expect(1, 8529, '\p{Numeric_Value:1.1111e-01}', "");
    Expect(0, 8529, '\p{^Numeric_Value:1.1111e-01}', "");
    Expect(0, 8529, '\P{Numeric_Value:1.1111e-01}', "");
    Expect(1, 8529, '\P{^Numeric_Value:1.1111e-01}', "");
    Expect(0, 8530, '\p{Numeric_Value:1.1111e-01}', "");
    Expect(1, 8530, '\p{^Numeric_Value:1.1111e-01}', "");
    Expect(1, 8530, '\P{Numeric_Value:1.1111e-01}', "");
    Expect(0, 8530, '\P{^Numeric_Value:1.1111e-01}', "");
    Expect(1, 8529, '\p{Numeric_Value:	0.1111}', "");
    Expect(0, 8529, '\p{^Numeric_Value:	0.1111}', "");
    Expect(0, 8529, '\P{Numeric_Value:	0.1111}', "");
    Expect(1, 8529, '\P{^Numeric_Value:	0.1111}', "");
    Expect(0, 8530, '\p{Numeric_Value:	0.1111}', "");
    Expect(1, 8530, '\p{^Numeric_Value:	0.1111}', "");
    Expect(1, 8530, '\P{Numeric_Value:	0.1111}', "");
    Expect(0, 8530, '\P{^Numeric_Value:	0.1111}', "");
    Expect(1, 8529, '\p{Numeric_Value=1.11111e-01}', "");
    Expect(0, 8529, '\p{^Numeric_Value=1.11111e-01}', "");
    Expect(0, 8529, '\P{Numeric_Value=1.11111e-01}', "");
    Expect(1, 8529, '\P{^Numeric_Value=1.11111e-01}', "");
    Expect(0, 8530, '\p{Numeric_Value=1.11111e-01}', "");
    Expect(1, 8530, '\p{^Numeric_Value=1.11111e-01}', "");
    Expect(1, 8530, '\P{Numeric_Value=1.11111e-01}', "");
    Expect(0, 8530, '\P{^Numeric_Value=1.11111e-01}', "");
    Expect(1, 8529, '\p{Numeric_Value=0.11111}', "");
    Expect(0, 8529, '\p{^Numeric_Value=0.11111}', "");
    Expect(0, 8529, '\P{Numeric_Value=0.11111}', "");
    Expect(1, 8529, '\P{^Numeric_Value=0.11111}', "");
    Expect(0, 8530, '\p{Numeric_Value=0.11111}', "");
    Expect(1, 8530, '\p{^Numeric_Value=0.11111}', "");
    Expect(1, 8530, '\P{Numeric_Value=0.11111}', "");
    Expect(0, 8530, '\P{^Numeric_Value=0.11111}', "");
    Error('\p{Nv=:=	 00001/0009}');
    Error('\P{Nv=:=	 00001/0009}');
    Expect(1, 8529, '\p{Nv=:\A1/9\z:}', "");;
    Expect(0, 8530, '\p{Nv=:\A1/9\z:}', "");;
    Expect(1, 8529, '\p{Nv=+00000001/0000000009}', "");
    Expect(0, 8529, '\p{^Nv=+00000001/0000000009}', "");
    Expect(0, 8529, '\P{Nv=+00000001/0000000009}', "");
    Expect(1, 8529, '\P{^Nv=+00000001/0000000009}', "");
    Expect(0, 8530, '\p{Nv=+00000001/0000000009}', "");
    Expect(1, 8530, '\p{^Nv=+00000001/0000000009}', "");
    Expect(1, 8530, '\P{Nv=+00000001/0000000009}', "");
    Expect(0, 8530, '\P{^Nv=+00000001/0000000009}', "");
    Expect(1, 8529, '\p{Nv=60/540}', "");
    Expect(0, 8529, '\p{^Nv=60/540}', "");
    Expect(0, 8529, '\P{Nv=60/540}', "");
    Expect(1, 8529, '\P{^Nv=60/540}', "");
    Expect(0, 8530, '\p{Nv=60/540}', "");
    Expect(1, 8530, '\p{^Nv=60/540}', "");
    Expect(1, 8530, '\P{Nv=60/540}', "");
    Expect(0, 8530, '\P{^Nv=60/540}', "");
    Error('\p{Nv=1.1e-01}');
    Error('\P{Nv=1.1e-01}');
    Error('\p{Nv=1.11e-01}');
    Error('\P{Nv=1.11e-01}');
    Error('\p{Nv=0.11}');
    Error('\P{Nv=0.11}');
    Expect(1, 8529, '\p{Nv=1.111e-01}', "");
    Expect(0, 8529, '\p{^Nv=1.111e-01}', "");
    Expect(0, 8529, '\P{Nv=1.111e-01}', "");
    Expect(1, 8529, '\P{^Nv=1.111e-01}', "");
    Expect(0, 8530, '\p{Nv=1.111e-01}', "");
    Expect(1, 8530, '\p{^Nv=1.111e-01}', "");
    Expect(1, 8530, '\P{Nv=1.111e-01}', "");
    Expect(0, 8530, '\P{^Nv=1.111e-01}', "");
    Error('\p{Nv=0.111}');
    Error('\P{Nv=0.111}');
    Expect(1, 8529, '\p{Nv=1.1111e-01}', "");
    Expect(0, 8529, '\p{^Nv=1.1111e-01}', "");
    Expect(0, 8529, '\P{Nv=1.1111e-01}', "");
    Expect(1, 8529, '\P{^Nv=1.1111e-01}', "");
    Expect(0, 8530, '\p{Nv=1.1111e-01}', "");
    Expect(1, 8530, '\p{^Nv=1.1111e-01}', "");
    Expect(1, 8530, '\P{Nv=1.1111e-01}', "");
    Expect(0, 8530, '\P{^Nv=1.1111e-01}', "");
    Expect(1, 8529, '\p{Nv=0.1111}', "");
    Expect(0, 8529, '\p{^Nv=0.1111}', "");
    Expect(0, 8529, '\P{Nv=0.1111}', "");
    Expect(1, 8529, '\P{^Nv=0.1111}', "");
    Expect(0, 8530, '\p{Nv=0.1111}', "");
    Expect(1, 8530, '\p{^Nv=0.1111}', "");
    Expect(1, 8530, '\P{Nv=0.1111}', "");
    Expect(0, 8530, '\P{^Nv=0.1111}', "");
    Expect(1, 8529, '\p{Nv=1.11111e-01}', "");
    Expect(0, 8529, '\p{^Nv=1.11111e-01}', "");
    Expect(0, 8529, '\P{Nv=1.11111e-01}', "");
    Expect(1, 8529, '\P{^Nv=1.11111e-01}', "");
    Expect(0, 8530, '\p{Nv=1.11111e-01}', "");
    Expect(1, 8530, '\p{^Nv=1.11111e-01}', "");
    Expect(1, 8530, '\P{Nv=1.11111e-01}', "");
    Expect(0, 8530, '\P{^Nv=1.11111e-01}', "");
    Expect(1, 8529, '\p{Nv=0.11111}', "");
    Expect(0, 8529, '\p{^Nv=0.11111}', "");
    Expect(0, 8529, '\P{Nv=0.11111}', "");
    Expect(1, 8529, '\P{^Nv=0.11111}', "");
    Expect(0, 8530, '\p{Nv=0.11111}', "");
    Expect(1, 8530, '\p{^Nv=0.11111}', "");
    Expect(1, 8530, '\P{Nv=0.11111}', "");
    Expect(0, 8530, '\P{^Nv=0.11111}', "");
    Error('\p{Is_Numeric_Value=:=  000001/000000009}');
    Error('\P{Is_Numeric_Value=:=  000001/000000009}');
    Expect(1, 8529, '\p{Is_Numeric_Value=0001/009}', "");
    Expect(0, 8529, '\p{^Is_Numeric_Value=0001/009}', "");
    Expect(0, 8529, '\P{Is_Numeric_Value=0001/009}', "");
    Expect(1, 8529, '\P{^Is_Numeric_Value=0001/009}', "");
    Expect(0, 8530, '\p{Is_Numeric_Value=0001/009}', "");
    Expect(1, 8530, '\p{^Is_Numeric_Value=0001/009}', "");
    Expect(1, 8530, '\P{Is_Numeric_Value=0001/009}', "");
    Expect(0, 8530, '\P{^Is_Numeric_Value=0001/009}', "");
    Expect(1, 8529, '\p{Is_Numeric_Value:	60/540}', "");
    Expect(0, 8529, '\p{^Is_Numeric_Value:	60/540}', "");
    Expect(0, 8529, '\P{Is_Numeric_Value:	60/540}', "");
    Expect(1, 8529, '\P{^Is_Numeric_Value:	60/540}', "");
    Expect(0, 8530, '\p{Is_Numeric_Value:	60/540}', "");
    Expect(1, 8530, '\p{^Is_Numeric_Value:	60/540}', "");
    Expect(1, 8530, '\P{Is_Numeric_Value:	60/540}', "");
    Expect(0, 8530, '\P{^Is_Numeric_Value:	60/540}', "");
    Error('\p{Is_Numeric_Value=1.1e-01}');
    Error('\P{Is_Numeric_Value=1.1e-01}');
    Error('\p{Is_Numeric_Value=1.11e-01}');
    Error('\P{Is_Numeric_Value=1.11e-01}');
    Error('\p{Is_Numeric_Value=0.11}');
    Error('\P{Is_Numeric_Value=0.11}');
    Expect(1, 8529, '\p{Is_Numeric_Value=1.111e-01}', "");
    Expect(0, 8529, '\p{^Is_Numeric_Value=1.111e-01}', "");
    Expect(0, 8529, '\P{Is_Numeric_Value=1.111e-01}', "");
    Expect(1, 8529, '\P{^Is_Numeric_Value=1.111e-01}', "");
    Expect(0, 8530, '\p{Is_Numeric_Value=1.111e-01}', "");
    Expect(1, 8530, '\p{^Is_Numeric_Value=1.111e-01}', "");
    Expect(1, 8530, '\P{Is_Numeric_Value=1.111e-01}', "");
    Expect(0, 8530, '\P{^Is_Numeric_Value=1.111e-01}', "");
    Error('\p{Is_Numeric_Value=0.111}');
    Error('\P{Is_Numeric_Value=0.111}');
    Expect(1, 8529, '\p{Is_Numeric_Value=1.1111e-01}', "");
    Expect(0, 8529, '\p{^Is_Numeric_Value=1.1111e-01}', "");
    Expect(0, 8529, '\P{Is_Numeric_Value=1.1111e-01}', "");
    Expect(1, 8529, '\P{^Is_Numeric_Value=1.1111e-01}', "");
    Expect(0, 8530, '\p{Is_Numeric_Value=1.1111e-01}', "");
    Expect(1, 8530, '\p{^Is_Numeric_Value=1.1111e-01}', "");
    Expect(1, 8530, '\P{Is_Numeric_Value=1.1111e-01}', "");
    Expect(0, 8530, '\P{^Is_Numeric_Value=1.1111e-01}', "");
    Expect(1, 8529, '\p{Is_Numeric_Value=0.1111}', "");
    Expect(0, 8529, '\p{^Is_Numeric_Value=0.1111}', "");
    Expect(0, 8529, '\P{Is_Numeric_Value=0.1111}', "");
    Expect(1, 8529, '\P{^Is_Numeric_Value=0.1111}', "");
    Expect(0, 8530, '\p{Is_Numeric_Value=0.1111}', "");
    Expect(1, 8530, '\p{^Is_Numeric_Value=0.1111}', "");
    Expect(1, 8530, '\P{Is_Numeric_Value=0.1111}', "");
    Expect(0, 8530, '\P{^Is_Numeric_Value=0.1111}', "");
    Expect(1, 8529, '\p{Is_Numeric_Value=1.11111e-01}', "");
    Expect(0, 8529, '\p{^Is_Numeric_Value=1.11111e-01}', "");
    Expect(0, 8529, '\P{Is_Numeric_Value=1.11111e-01}', "");
    Expect(1, 8529, '\P{^Is_Numeric_Value=1.11111e-01}', "");
    Expect(0, 8530, '\p{Is_Numeric_Value=1.11111e-01}', "");
    Expect(1, 8530, '\p{^Is_Numeric_Value=1.11111e-01}', "");
    Expect(1, 8530, '\P{Is_Numeric_Value=1.11111e-01}', "");
    Expect(0, 8530, '\P{^Is_Numeric_Value=1.11111e-01}', "");
    Expect(1, 8529, '\p{Is_Numeric_Value=0.11111}', "");
    Expect(0, 8529, '\p{^Is_Numeric_Value=0.11111}', "");
    Expect(0, 8529, '\P{Is_Numeric_Value=0.11111}', "");
    Expect(1, 8529, '\P{^Is_Numeric_Value=0.11111}', "");
    Expect(0, 8530, '\p{Is_Numeric_Value=0.11111}', "");
    Expect(1, 8530, '\p{^Is_Numeric_Value=0.11111}', "");
    Expect(1, 8530, '\P{Is_Numeric_Value=0.11111}', "");
    Expect(0, 8530, '\P{^Is_Numeric_Value=0.11111}', "");
    Error('\p{Is_Nv=-/a/+000000001/0009}');
    Error('\P{Is_Nv=-/a/+000000001/0009}');
    Expect(1, 8529, '\p{Is_Nv=000000001/09}', "");
    Expect(0, 8529, '\p{^Is_Nv=000000001/09}', "");
    Expect(0, 8529, '\P{Is_Nv=000000001/09}', "");
    Expect(1, 8529, '\P{^Is_Nv=000000001/09}', "");
    Expect(0, 8530, '\p{Is_Nv=000000001/09}', "");
    Expect(1, 8530, '\p{^Is_Nv=000000001/09}', "");
    Expect(1, 8530, '\P{Is_Nv=000000001/09}', "");
    Expect(0, 8530, '\P{^Is_Nv=000000001/09}', "");
    Expect(1, 8529, '\p{Is_Nv=60/540}', "");
    Expect(0, 8529, '\p{^Is_Nv=60/540}', "");
    Expect(0, 8529, '\P{Is_Nv=60/540}', "");
    Expect(1, 8529, '\P{^Is_Nv=60/540}', "");
    Expect(0, 8530, '\p{Is_Nv=60/540}', "");
    Expect(1, 8530, '\p{^Is_Nv=60/540}', "");
    Expect(1, 8530, '\P{Is_Nv=60/540}', "");
    Expect(0, 8530, '\P{^Is_Nv=60/540}', "");
    Error('\p{Is_Nv=1.1e-01}');
    Error('\P{Is_Nv=1.1e-01}');
    Error('\p{Is_Nv=1.11e-01}');
    Error('\P{Is_Nv=1.11e-01}');
    Error('\p{Is_Nv=0.11}');
    Error('\P{Is_Nv=0.11}');
    Expect(1, 8529, '\p{Is_Nv=1.111e-01}', "");
    Expect(0, 8529, '\p{^Is_Nv=1.111e-01}', "");
    Expect(0, 8529, '\P{Is_Nv=1.111e-01}', "");
    Expect(1, 8529, '\P{^Is_Nv=1.111e-01}', "");
    Expect(0, 8530, '\p{Is_Nv=1.111e-01}', "");
    Expect(1, 8530, '\p{^Is_Nv=1.111e-01}', "");
    Expect(1, 8530, '\P{Is_Nv=1.111e-01}', "");
    Expect(0, 8530, '\P{^Is_Nv=1.111e-01}', "");
    Error('\p{Is_Nv=0.111}');
    Error('\P{Is_Nv=0.111}');
    Expect(1, 8529, '\p{Is_Nv=1.1111e-01}', "");
    Expect(0, 8529, '\p{^Is_Nv=1.1111e-01}', "");
    Expect(0, 8529, '\P{Is_Nv=1.1111e-01}', "");
    Expect(1, 8529, '\P{^Is_Nv=1.1111e-01}', "");
    Expect(0, 8530, '\p{Is_Nv=1.1111e-01}', "");
    Expect(1, 8530, '\p{^Is_Nv=1.1111e-01}', "");
    Expect(1, 8530, '\P{Is_Nv=1.1111e-01}', "");
    Expect(0, 8530, '\P{^Is_Nv=1.1111e-01}', "");
    Expect(1, 8529, '\p{Is_Nv=0.1111}', "");
    Expect(0, 8529, '\p{^Is_Nv=0.1111}', "");
    Expect(0, 8529, '\P{Is_Nv=0.1111}', "");
    Expect(1, 8529, '\P{^Is_Nv=0.1111}', "");
    Expect(0, 8530, '\p{Is_Nv=0.1111}', "");
    Expect(1, 8530, '\p{^Is_Nv=0.1111}', "");
    Expect(1, 8530, '\P{Is_Nv=0.1111}', "");
    Expect(0, 8530, '\P{^Is_Nv=0.1111}', "");
    Expect(1, 8529, '\p{Is_Nv=1.11111e-01}', "");
    Expect(0, 8529, '\p{^Is_Nv=1.11111e-01}', "");
    Expect(0, 8529, '\P{Is_Nv=1.11111e-01}', "");
    Expect(1, 8529, '\P{^Is_Nv=1.11111e-01}', "");
    Expect(0, 8530, '\p{Is_Nv=1.11111e-01}', "");
    Expect(1, 8530, '\p{^Is_Nv=1.11111e-01}', "");
    Expect(1, 8530, '\P{Is_Nv=1.11111e-01}', "");
    Expect(0, 8530, '\P{^Is_Nv=1.11111e-01}', "");
    Expect(1, 8529, '\p{Is_Nv=0.11111}', "");
    Expect(0, 8529, '\p{^Is_Nv=0.11111}', "");
    Expect(0, 8529, '\P{Is_Nv=0.11111}', "");
    Expect(1, 8529, '\P{^Is_Nv=0.11111}', "");
    Expect(0, 8530, '\p{Is_Nv=0.11111}', "");
    Expect(1, 8530, '\p{^Is_Nv=0.11111}', "");
    Expect(1, 8530, '\P{Is_Nv=0.11111}', "");
    Expect(0, 8530, '\P{^Is_Nv=0.11111}', "");
    Error('\p{Numeric_Value=--00_00_01_0:=}');
    Error('\P{Numeric_Value=--00_00_01_0:=}');
    Expect(1, 126263, '\p{Numeric_Value=:\A10\z:}', "");;
    Expect(0, 126264, '\p{Numeric_Value=:\A10\z:}', "");;
    Expect(1, 126263, '\p{Numeric_Value=00_00_00_10}', "");
    Expect(0, 126263, '\p{^Numeric_Value=00_00_00_10}', "");
    Expect(0, 126263, '\P{Numeric_Value=00_00_00_10}', "");
    Expect(1, 126263, '\P{^Numeric_Value=00_00_00_10}', "");
    Expect(0, 126264, '\p{Numeric_Value=00_00_00_10}', "");
    Expect(1, 126264, '\p{^Numeric_Value=00_00_00_10}', "");
    Expect(1, 126264, '\P{Numeric_Value=00_00_00_10}', "");
    Expect(0, 126264, '\P{^Numeric_Value=00_00_00_10}', "");
    Expect(1, 126263, '\p{Numeric_Value=1.000000000000000e+01}', "");
    Expect(0, 126263, '\p{^Numeric_Value=1.000000000000000e+01}', "");
    Expect(0, 126263, '\P{Numeric_Value=1.000000000000000e+01}', "");
    Expect(1, 126263, '\P{^Numeric_Value=1.000000000000000e+01}', "");
    Expect(0, 126264, '\p{Numeric_Value=1.000000000000000e+01}', "");
    Expect(1, 126264, '\p{^Numeric_Value=1.000000000000000e+01}', "");
    Expect(1, 126264, '\P{Numeric_Value=1.000000000000000e+01}', "");
    Expect(0, 126264, '\P{^Numeric_Value=1.000000000000000e+01}', "");
    Error('\p{Nv=	:=000010}');
    Error('\P{Nv=	:=000010}');
    Expect(1, 126263, '\p{Nv=:\A10\z:}', "");;
    Expect(0, 126264, '\p{Nv=:\A10\z:}', "");;
    Expect(1, 126263, '\p{Nv=00000000010}', "");
    Expect(0, 126263, '\p{^Nv=00000000010}', "");
    Expect(0, 126263, '\P{Nv=00000000010}', "");
    Expect(1, 126263, '\P{^Nv=00000000010}', "");
    Expect(0, 126264, '\p{Nv=00000000010}', "");
    Expect(1, 126264, '\p{^Nv=00000000010}', "");
    Expect(1, 126264, '\P{Nv=00000000010}', "");
    Expect(0, 126264, '\P{^Nv=00000000010}', "");
    Expect(1, 126263, '\p{Nv=1.000000000000000e+01}', "");
    Expect(0, 126263, '\p{^Nv=1.000000000000000e+01}', "");
    Expect(0, 126263, '\P{Nv=1.000000000000000e+01}', "");
    Expect(1, 126263, '\P{^Nv=1.000000000000000e+01}', "");
    Expect(0, 126264, '\p{Nv=1.000000000000000e+01}', "");
    Expect(1, 126264, '\p{^Nv=1.000000000000000e+01}', "");
    Expect(1, 126264, '\P{Nv=1.000000000000000e+01}', "");
    Expect(0, 126264, '\P{^Nv=1.000000000000000e+01}', "");
    Error('\p{Is_Numeric_Value=:=  0001_0}');
    Error('\P{Is_Numeric_Value=:=  0001_0}');
    Expect(1, 126263, '\p{Is_Numeric_Value: 1_0}', "");
    Expect(0, 126263, '\p{^Is_Numeric_Value: 1_0}', "");
    Expect(0, 126263, '\P{Is_Numeric_Value: 1_0}', "");
    Expect(1, 126263, '\P{^Is_Numeric_Value: 1_0}', "");
    Expect(0, 126264, '\p{Is_Numeric_Value: 1_0}', "");
    Expect(1, 126264, '\p{^Is_Numeric_Value: 1_0}', "");
    Expect(1, 126264, '\P{Is_Numeric_Value: 1_0}', "");
    Expect(0, 126264, '\P{^Is_Numeric_Value: 1_0}', "");
    Expect(1, 126263, '\p{Is_Numeric_Value=1.000000000000000e+01}', "");
    Expect(0, 126263, '\p{^Is_Numeric_Value=1.000000000000000e+01}', "");
    Expect(0, 126263, '\P{Is_Numeric_Value=1.000000000000000e+01}', "");
    Expect(1, 126263, '\P{^Is_Numeric_Value=1.000000000000000e+01}', "");
    Expect(0, 126264, '\p{Is_Numeric_Value=1.000000000000000e+01}', "");
    Expect(1, 126264, '\p{^Is_Numeric_Value=1.000000000000000e+01}', "");
    Expect(1, 126264, '\P{Is_Numeric_Value=1.000000000000000e+01}', "");
    Expect(0, 126264, '\P{^Is_Numeric_Value=1.000000000000000e+01}', "");
    Error('\p{Is_Nv= :=0_0_0_0_0_0_0010}');
    Error('\P{Is_Nv= :=0_0_0_0_0_0_0010}');
    Expect(1, 126263, '\p{Is_Nv=+0_0_0_0_0_0_0_010}', "");
    Expect(0, 126263, '\p{^Is_Nv=+0_0_0_0_0_0_0_010}', "");
    Expect(0, 126263, '\P{Is_Nv=+0_0_0_0_0_0_0_010}', "");
    Expect(1, 126263, '\P{^Is_Nv=+0_0_0_0_0_0_0_010}', "");
    Expect(0, 126264, '\p{Is_Nv=+0_0_0_0_0_0_0_010}', "");
    Expect(1, 126264, '\p{^Is_Nv=+0_0_0_0_0_0_0_010}', "");
    Expect(1, 126264, '\P{Is_Nv=+0_0_0_0_0_0_0_010}', "");
    Expect(0, 126264, '\P{^Is_Nv=+0_0_0_0_0_0_0_010}', "");
    Expect(1, 126263, '\p{Is_Nv=1.000000000000000e+01}', "");
    Expect(0, 126263, '\p{^Is_Nv=1.000000000000000e+01}', "");
    Expect(0, 126263, '\P{Is_Nv=1.000000000000000e+01}', "");
    Expect(1, 126263, '\P{^Is_Nv=1.000000000000000e+01}', "");
    Expect(0, 126264, '\p{Is_Nv=1.000000000000000e+01}', "");
    Expect(1, 126264, '\p{^Is_Nv=1.000000000000000e+01}', "");
    Expect(1, 126264, '\P{Is_Nv=1.000000000000000e+01}', "");
    Expect(0, 126264, '\P{^Is_Nv=1.000000000000000e+01}', "");
    Error('\p{Numeric_Value=-00000100/a/}');
    Error('\P{Numeric_Value=-00000100/a/}');
    Expect(1, 126227, '\p{Numeric_Value=:\A100\z:}', "");;
    Expect(0, 126228, '\p{Numeric_Value=:\A100\z:}', "");;
    Expect(1, 126227, '\p{Numeric_Value=+0_0_0_0_0_0_0_0_0_1_00}', "");
    Expect(0, 126227, '\p{^Numeric_Value=+0_0_0_0_0_0_0_0_0_1_00}', "");
    Expect(0, 126227, '\P{Numeric_Value=+0_0_0_0_0_0_0_0_0_1_00}', "");
    Expect(1, 126227, '\P{^Numeric_Value=+0_0_0_0_0_0_0_0_0_1_00}', "");
    Expect(0, 126228, '\p{Numeric_Value=+0_0_0_0_0_0_0_0_0_1_00}', "");
    Expect(1, 126228, '\p{^Numeric_Value=+0_0_0_0_0_0_0_0_0_1_00}', "");
    Expect(1, 126228, '\P{Numeric_Value=+0_0_0_0_0_0_0_0_0_1_00}', "");
    Expect(0, 126228, '\P{^Numeric_Value=+0_0_0_0_0_0_0_0_0_1_00}', "");
    Expect(1, 126227, '\p{Numeric_Value=1.000000000000000e+02}', "");
    Expect(0, 126227, '\p{^Numeric_Value=1.000000000000000e+02}', "");
    Expect(0, 126227, '\P{Numeric_Value=1.000000000000000e+02}', "");
    Expect(1, 126227, '\P{^Numeric_Value=1.000000000000000e+02}', "");
    Expect(0, 126228, '\p{Numeric_Value=1.000000000000000e+02}', "");
    Expect(1, 126228, '\p{^Numeric_Value=1.000000000000000e+02}', "");
    Expect(1, 126228, '\P{Numeric_Value=1.000000000000000e+02}', "");
    Expect(0, 126228, '\P{^Numeric_Value=1.000000000000000e+02}', "");
    Error('\p{Nv=-:=0100}');
    Error('\P{Nv=-:=0100}');
    Expect(1, 126227, '\p{Nv=:\A100\z:}', "");;
    Expect(0, 126228, '\p{Nv=:\A100\z:}', "");;
    Expect(1, 126227, '\p{Nv=00000_00010_0}', "");
    Expect(0, 126227, '\p{^Nv=00000_00010_0}', "");
    Expect(0, 126227, '\P{Nv=00000_00010_0}', "");
    Expect(1, 126227, '\P{^Nv=00000_00010_0}', "");
    Expect(0, 126228, '\p{Nv=00000_00010_0}', "");
    Expect(1, 126228, '\p{^Nv=00000_00010_0}', "");
    Expect(1, 126228, '\P{Nv=00000_00010_0}', "");
    Expect(0, 126228, '\P{^Nv=00000_00010_0}', "");
    Expect(1, 126227, '\p{Nv:	1.000000000000000e+02}', "");
    Expect(0, 126227, '\p{^Nv:	1.000000000000000e+02}', "");
    Expect(0, 126227, '\P{Nv:	1.000000000000000e+02}', "");
    Expect(1, 126227, '\P{^Nv:	1.000000000000000e+02}', "");
    Expect(0, 126228, '\p{Nv:	1.000000000000000e+02}', "");
    Expect(1, 126228, '\p{^Nv:	1.000000000000000e+02}', "");
    Expect(1, 126228, '\P{Nv:	1.000000000000000e+02}', "");
    Expect(0, 126228, '\P{^Nv:	1.000000000000000e+02}', "");
    Error('\p{Is_Numeric_Value= +00_00_01_00:=}');
    Error('\P{Is_Numeric_Value= +00_00_01_00:=}');
    Expect(1, 126227, '\p{Is_Numeric_Value=000000000100}', "");
    Expect(0, 126227, '\p{^Is_Numeric_Value=000000000100}', "");
    Expect(0, 126227, '\P{Is_Numeric_Value=000000000100}', "");
    Expect(1, 126227, '\P{^Is_Numeric_Value=000000000100}', "");
    Expect(0, 126228, '\p{Is_Numeric_Value=000000000100}', "");
    Expect(1, 126228, '\p{^Is_Numeric_Value=000000000100}', "");
    Expect(1, 126228, '\P{Is_Numeric_Value=000000000100}', "");
    Expect(0, 126228, '\P{^Is_Numeric_Value=000000000100}', "");
    Expect(1, 126227, '\p{Is_Numeric_Value=1.000000000000000e+02}', "");
    Expect(0, 126227, '\p{^Is_Numeric_Value=1.000000000000000e+02}', "");
    Expect(0, 126227, '\P{Is_Numeric_Value=1.000000000000000e+02}', "");
    Expect(1, 126227, '\P{^Is_Numeric_Value=1.000000000000000e+02}', "");
    Expect(0, 126228, '\p{Is_Numeric_Value=1.000000000000000e+02}', "");
    Expect(1, 126228, '\p{^Is_Numeric_Value=1.000000000000000e+02}', "");
    Expect(1, 126228, '\P{Is_Numeric_Value=1.000000000000000e+02}', "");
    Expect(0, 126228, '\P{^Is_Numeric_Value=1.000000000000000e+02}', "");
    Error('\p{Is_Nv: :=-+000000000100}');
    Error('\P{Is_Nv: :=-+000000000100}');
    Expect(1, 126227, '\p{Is_Nv:10_0}', "");
    Expect(0, 126227, '\p{^Is_Nv:10_0}', "");
    Expect(0, 126227, '\P{Is_Nv:10_0}', "");
    Expect(1, 126227, '\P{^Is_Nv:10_0}', "");
    Expect(0, 126228, '\p{Is_Nv:10_0}', "");
    Expect(1, 126228, '\p{^Is_Nv:10_0}', "");
    Expect(1, 126228, '\P{Is_Nv:10_0}', "");
    Expect(0, 126228, '\P{^Is_Nv:10_0}', "");
    Expect(1, 126227, '\p{Is_Nv=1.000000000000000e+02}', "");
    Expect(0, 126227, '\p{^Is_Nv=1.000000000000000e+02}', "");
    Expect(0, 126227, '\P{Is_Nv=1.000000000000000e+02}', "");
    Expect(1, 126227, '\P{^Is_Nv=1.000000000000000e+02}', "");
    Expect(0, 126228, '\p{Is_Nv=1.000000000000000e+02}', "");
    Expect(1, 126228, '\p{^Is_Nv=1.000000000000000e+02}', "");
    Expect(1, 126228, '\P{Is_Nv=1.000000000000000e+02}', "");
    Expect(0, 126228, '\P{^Is_Nv=1.000000000000000e+02}', "");
    Error('\p{Numeric_Value=:=00_01_00_0}');
    Error('\P{Numeric_Value=:=00_01_00_0}');
    Expect(1, 126236, '\p{Numeric_Value=:\A1000\z:}', "");;
    Expect(0, 126237, '\p{Numeric_Value=:\A1000\z:}', "");;
    Expect(1, 126236, '\p{Numeric_Value=+0000001000}', "");
    Expect(0, 126236, '\p{^Numeric_Value=+0000001000}', "");
    Expect(0, 126236, '\P{Numeric_Value=+0000001000}', "");
    Expect(1, 126236, '\P{^Numeric_Value=+0000001000}', "");
    Expect(0, 126237, '\p{Numeric_Value=+0000001000}', "");
    Expect(1, 126237, '\p{^Numeric_Value=+0000001000}', "");
    Expect(1, 126237, '\P{Numeric_Value=+0000001000}', "");
    Expect(0, 126237, '\P{^Numeric_Value=+0000001000}', "");
    Expect(1, 126236, '\p{Numeric_Value=1.000000000000000e+03}', "");
    Expect(0, 126236, '\p{^Numeric_Value=1.000000000000000e+03}', "");
    Expect(0, 126236, '\P{Numeric_Value=1.000000000000000e+03}', "");
    Expect(1, 126236, '\P{^Numeric_Value=1.000000000000000e+03}', "");
    Expect(0, 126237, '\p{Numeric_Value=1.000000000000000e+03}', "");
    Expect(1, 126237, '\p{^Numeric_Value=1.000000000000000e+03}', "");
    Expect(1, 126237, '\P{Numeric_Value=1.000000000000000e+03}', "");
    Expect(0, 126237, '\P{^Numeric_Value=1.000000000000000e+03}', "");
    Error('\p{Nv=	_+000_010_00/a/}');
    Error('\P{Nv=	_+000_010_00/a/}');
    Expect(1, 126236, '\p{Nv=:\A1000\z:}', "");;
    Expect(0, 126237, '\p{Nv=:\A1000\z:}', "");;
    Expect(1, 126236, '\p{Nv=1000}', "");
    Expect(0, 126236, '\p{^Nv=1000}', "");
    Expect(0, 126236, '\P{Nv=1000}', "");
    Expect(1, 126236, '\P{^Nv=1000}', "");
    Expect(0, 126237, '\p{Nv=1000}', "");
    Expect(1, 126237, '\p{^Nv=1000}', "");
    Expect(1, 126237, '\P{Nv=1000}', "");
    Expect(0, 126237, '\P{^Nv=1000}', "");
    Expect(1, 126236, '\p{Nv=1.000000000000000e+03}', "");
    Expect(0, 126236, '\p{^Nv=1.000000000000000e+03}', "");
    Expect(0, 126236, '\P{Nv=1.000000000000000e+03}', "");
    Expect(1, 126236, '\P{^Nv=1.000000000000000e+03}', "");
    Expect(0, 126237, '\p{Nv=1.000000000000000e+03}', "");
    Expect(1, 126237, '\p{^Nv=1.000000000000000e+03}', "");
    Expect(1, 126237, '\P{Nv=1.000000000000000e+03}', "");
    Expect(0, 126237, '\P{^Nv=1.000000000000000e+03}', "");
    Error('\p{Is_Numeric_Value= _1000/a/}');
    Error('\P{Is_Numeric_Value= _1000/a/}');
    Expect(1, 126236, '\p{Is_Numeric_Value=+0001000}', "");
    Expect(0, 126236, '\p{^Is_Numeric_Value=+0001000}', "");
    Expect(0, 126236, '\P{Is_Numeric_Value=+0001000}', "");
    Expect(1, 126236, '\P{^Is_Numeric_Value=+0001000}', "");
    Expect(0, 126237, '\p{Is_Numeric_Value=+0001000}', "");
    Expect(1, 126237, '\p{^Is_Numeric_Value=+0001000}', "");
    Expect(1, 126237, '\P{Is_Numeric_Value=+0001000}', "");
    Expect(0, 126237, '\P{^Is_Numeric_Value=+0001000}', "");
    Expect(1, 126236, '\p{Is_Numeric_Value=1.000000000000000e+03}', "");
    Expect(0, 126236, '\p{^Is_Numeric_Value=1.000000000000000e+03}', "");
    Expect(0, 126236, '\P{Is_Numeric_Value=1.000000000000000e+03}', "");
    Expect(1, 126236, '\P{^Is_Numeric_Value=1.000000000000000e+03}', "");
    Expect(0, 126237, '\p{Is_Numeric_Value=1.000000000000000e+03}', "");
    Expect(1, 126237, '\p{^Is_Numeric_Value=1.000000000000000e+03}', "");
    Expect(1, 126237, '\P{Is_Numeric_Value=1.000000000000000e+03}', "");
    Expect(0, 126237, '\P{^Is_Numeric_Value=1.000000000000000e+03}', "");
    Error('\p{Is_Nv=-:=01000}');
    Error('\P{Is_Nv=-:=01000}');
    Expect(1, 126236, '\p{Is_Nv=01000}', "");
    Expect(0, 126236, '\p{^Is_Nv=01000}', "");
    Expect(0, 126236, '\P{Is_Nv=01000}', "");
    Expect(1, 126236, '\P{^Is_Nv=01000}', "");
    Expect(0, 126237, '\p{Is_Nv=01000}', "");
    Expect(1, 126237, '\p{^Is_Nv=01000}', "");
    Expect(1, 126237, '\P{Is_Nv=01000}', "");
    Expect(0, 126237, '\P{^Is_Nv=01000}', "");
    Expect(1, 126236, '\p{Is_Nv=1.000000000000000e+03}', "");
    Expect(0, 126236, '\p{^Is_Nv=1.000000000000000e+03}', "");
    Expect(0, 126236, '\P{Is_Nv=1.000000000000000e+03}', "");
    Expect(1, 126236, '\P{^Is_Nv=1.000000000000000e+03}', "");
    Expect(0, 126237, '\p{Is_Nv=1.000000000000000e+03}', "");
    Expect(1, 126237, '\p{^Is_Nv=1.000000000000000e+03}', "");
    Expect(1, 126237, '\P{Is_Nv=1.000000000000000e+03}', "");
    Expect(0, 126237, '\P{^Is_Nv=1.000000000000000e+03}', "");
    Error('\p{Numeric_Value=--00_00_01_00_00/a/}');
    Error('\P{Numeric_Value=--00_00_01_00_00/a/}');
    Expect(1, 126267, '\p{Numeric_Value=:\A10000\z:}', "");;
    Expect(0, 126268, '\p{Numeric_Value=:\A10000\z:}', "");;
    Expect(1, 126267, '\p{Numeric_Value=00_00_00_00_10_000}', "");
    Expect(0, 126267, '\p{^Numeric_Value=00_00_00_00_10_000}', "");
    Expect(0, 126267, '\P{Numeric_Value=00_00_00_00_10_000}', "");
    Expect(1, 126267, '\P{^Numeric_Value=00_00_00_00_10_000}', "");
    Expect(0, 126268, '\p{Numeric_Value=00_00_00_00_10_000}', "");
    Expect(1, 126268, '\p{^Numeric_Value=00_00_00_00_10_000}', "");
    Expect(1, 126268, '\P{Numeric_Value=00_00_00_00_10_000}', "");
    Expect(0, 126268, '\P{^Numeric_Value=00_00_00_00_10_000}', "");
    Expect(1, 126267, '\p{Numeric_Value:1.000000000000000e+04}', "");
    Expect(0, 126267, '\p{^Numeric_Value:1.000000000000000e+04}', "");
    Expect(0, 126267, '\P{Numeric_Value:1.000000000000000e+04}', "");
    Expect(1, 126267, '\P{^Numeric_Value:1.000000000000000e+04}', "");
    Expect(0, 126268, '\p{Numeric_Value:1.000000000000000e+04}', "");
    Expect(1, 126268, '\p{^Numeric_Value:1.000000000000000e+04}', "");
    Expect(1, 126268, '\P{Numeric_Value:1.000000000000000e+04}', "");
    Expect(0, 126268, '\P{^Numeric_Value:1.000000000000000e+04}', "");
    Error('\p{Nv=:= -00010000}');
    Error('\P{Nv=:= -00010000}');
    Expect(1, 126267, '\p{Nv=:\A10000\z:}', "");;
    Expect(0, 126268, '\p{Nv=:\A10000\z:}', "");;
    Expect(1, 126267, '\p{Nv:   00001000_0}', "");
    Expect(0, 126267, '\p{^Nv:   00001000_0}', "");
    Expect(0, 126267, '\P{Nv:   00001000_0}', "");
    Expect(1, 126267, '\P{^Nv:   00001000_0}', "");
    Expect(0, 126268, '\p{Nv:   00001000_0}', "");
    Expect(1, 126268, '\p{^Nv:   00001000_0}', "");
    Expect(1, 126268, '\P{Nv:   00001000_0}', "");
    Expect(0, 126268, '\P{^Nv:   00001000_0}', "");
    Expect(1, 126267, '\p{Nv=1.000000000000000e+04}', "");
    Expect(0, 126267, '\p{^Nv=1.000000000000000e+04}', "");
    Expect(0, 126267, '\P{Nv=1.000000000000000e+04}', "");
    Expect(1, 126267, '\P{^Nv=1.000000000000000e+04}', "");
    Expect(0, 126268, '\p{Nv=1.000000000000000e+04}', "");
    Expect(1, 126268, '\p{^Nv=1.000000000000000e+04}', "");
    Expect(1, 126268, '\P{Nv=1.000000000000000e+04}', "");
    Expect(0, 126268, '\P{^Nv=1.000000000000000e+04}', "");
    Error('\p{Is_Numeric_Value=:=	0_0_0_1_0000}');
    Error('\P{Is_Numeric_Value=:=	0_0_0_1_0000}');
    Expect(1, 126267, '\p{Is_Numeric_Value=+0_0_0_0_0_0_0_0_1_0000}', "");
    Expect(0, 126267, '\p{^Is_Numeric_Value=+0_0_0_0_0_0_0_0_1_0000}', "");
    Expect(0, 126267, '\P{Is_Numeric_Value=+0_0_0_0_0_0_0_0_1_0000}', "");
    Expect(1, 126267, '\P{^Is_Numeric_Value=+0_0_0_0_0_0_0_0_1_0000}', "");
    Expect(0, 126268, '\p{Is_Numeric_Value=+0_0_0_0_0_0_0_0_1_0000}', "");
    Expect(1, 126268, '\p{^Is_Numeric_Value=+0_0_0_0_0_0_0_0_1_0000}', "");
    Expect(1, 126268, '\P{Is_Numeric_Value=+0_0_0_0_0_0_0_0_1_0000}', "");
    Expect(0, 126268, '\P{^Is_Numeric_Value=+0_0_0_0_0_0_0_0_1_0000}', "");
    Expect(1, 126267, '\p{Is_Numeric_Value=1.000000000000000e+04}', "");
    Expect(0, 126267, '\p{^Is_Numeric_Value=1.000000000000000e+04}', "");
    Expect(0, 126267, '\P{Is_Numeric_Value=1.000000000000000e+04}', "");
    Expect(1, 126267, '\P{^Is_Numeric_Value=1.000000000000000e+04}', "");
    Expect(0, 126268, '\p{Is_Numeric_Value=1.000000000000000e+04}', "");
    Expect(1, 126268, '\p{^Is_Numeric_Value=1.000000000000000e+04}', "");
    Expect(1, 126268, '\P{Is_Numeric_Value=1.000000000000000e+04}', "");
    Expect(0, 126268, '\P{^Is_Numeric_Value=1.000000000000000e+04}', "");
    Error('\p{Is_Nv=	/a/00_10_00_0}');
    Error('\P{Is_Nv=	/a/00_10_00_0}');
    Expect(1, 126267, '\p{Is_Nv=000_000_010_000}', "");
    Expect(0, 126267, '\p{^Is_Nv=000_000_010_000}', "");
    Expect(0, 126267, '\P{Is_Nv=000_000_010_000}', "");
    Expect(1, 126267, '\P{^Is_Nv=000_000_010_000}', "");
    Expect(0, 126268, '\p{Is_Nv=000_000_010_000}', "");
    Expect(1, 126268, '\p{^Is_Nv=000_000_010_000}', "");
    Expect(1, 126268, '\P{Is_Nv=000_000_010_000}', "");
    Expect(0, 126268, '\P{^Is_Nv=000_000_010_000}', "");
    Expect(1, 126267, '\p{Is_Nv=1.000000000000000e+04}', "");
    Expect(0, 126267, '\p{^Is_Nv=1.000000000000000e+04}', "");
    Expect(0, 126267, '\P{Is_Nv=1.000000000000000e+04}', "");
    Expect(1, 126267, '\P{^Is_Nv=1.000000000000000e+04}', "");
    Expect(0, 126268, '\p{Is_Nv=1.000000000000000e+04}', "");
    Expect(1, 126268, '\p{^Is_Nv=1.000000000000000e+04}', "");
    Expect(1, 126268, '\P{Is_Nv=1.000000000000000e+04}', "");
    Expect(0, 126268, '\P{^Is_Nv=1.000000000000000e+04}', "");
    Error('\p{Numeric_Value= :=00_01_00_00_0}');
    Error('\P{Numeric_Value= :=00_01_00_00_0}');
    Expect(1, 126132, '\p{Numeric_Value=:\A100000\z:}', "");;
    Expect(0, 126133, '\p{Numeric_Value=:\A100000\z:}', "");;
    Expect(1, 126132, '\p{Numeric_Value=0_0_0_1_0_0_0_00}', "");
    Expect(0, 126132, '\p{^Numeric_Value=0_0_0_1_0_0_0_00}', "");
    Expect(0, 126132, '\P{Numeric_Value=0_0_0_1_0_0_0_00}', "");
    Expect(1, 126132, '\P{^Numeric_Value=0_0_0_1_0_0_0_00}', "");
    Expect(0, 126133, '\p{Numeric_Value=0_0_0_1_0_0_0_00}', "");
    Expect(1, 126133, '\p{^Numeric_Value=0_0_0_1_0_0_0_00}', "");
    Expect(1, 126133, '\P{Numeric_Value=0_0_0_1_0_0_0_00}', "");
    Expect(0, 126133, '\P{^Numeric_Value=0_0_0_1_0_0_0_00}', "");
    Expect(1, 126132, '\p{Numeric_Value=1.000000000000000e+05}', "");
    Expect(0, 126132, '\p{^Numeric_Value=1.000000000000000e+05}', "");
    Expect(0, 126132, '\P{Numeric_Value=1.000000000000000e+05}', "");
    Expect(1, 126132, '\P{^Numeric_Value=1.000000000000000e+05}', "");
    Expect(0, 126133, '\p{Numeric_Value=1.000000000000000e+05}', "");
    Expect(1, 126133, '\p{^Numeric_Value=1.000000000000000e+05}', "");
    Expect(1, 126133, '\P{Numeric_Value=1.000000000000000e+05}', "");
    Expect(0, 126133, '\P{^Numeric_Value=1.000000000000000e+05}', "");
    Error('\p{Nv=	-+00000100000/a/}');
    Error('\P{Nv=	-+00000100000/a/}');
    Expect(1, 126132, '\p{Nv=:\A100000\z:}', "");;
    Expect(0, 126133, '\p{Nv=:\A100000\z:}', "");;
    Expect(1, 126132, '\p{Nv=100000}', "");
    Expect(0, 126132, '\p{^Nv=100000}', "");
    Expect(0, 126132, '\P{Nv=100000}', "");
    Expect(1, 126132, '\P{^Nv=100000}', "");
    Expect(0, 126133, '\p{Nv=100000}', "");
    Expect(1, 126133, '\p{^Nv=100000}', "");
    Expect(1, 126133, '\P{Nv=100000}', "");
    Expect(0, 126133, '\P{^Nv=100000}', "");
    Expect(1, 126132, '\p{Nv=1.000000000000000e+05}', "");
    Expect(0, 126132, '\p{^Nv=1.000000000000000e+05}', "");
    Expect(0, 126132, '\P{Nv=1.000000000000000e+05}', "");
    Expect(1, 126132, '\P{^Nv=1.000000000000000e+05}', "");
    Expect(0, 126133, '\p{Nv=1.000000000000000e+05}', "");
    Expect(1, 126133, '\p{^Nv=1.000000000000000e+05}', "");
    Expect(1, 126133, '\P{Nv=1.000000000000000e+05}', "");
    Expect(0, 126133, '\P{^Nv=1.000000000000000e+05}', "");
    Error('\p{Is_Numeric_Value:	_:=+0100000}');
    Error('\P{Is_Numeric_Value:	_:=+0100000}');
    Expect(1, 126132, '\p{Is_Numeric_Value=+000000000100000}', "");
    Expect(0, 126132, '\p{^Is_Numeric_Value=+000000000100000}', "");
    Expect(0, 126132, '\P{Is_Numeric_Value=+000000000100000}', "");
    Expect(1, 126132, '\P{^Is_Numeric_Value=+000000000100000}', "");
    Expect(0, 126133, '\p{Is_Numeric_Value=+000000000100000}', "");
    Expect(1, 126133, '\p{^Is_Numeric_Value=+000000000100000}', "");
    Expect(1, 126133, '\P{Is_Numeric_Value=+000000000100000}', "");
    Expect(0, 126133, '\P{^Is_Numeric_Value=+000000000100000}', "");
    Expect(1, 126132, '\p{Is_Numeric_Value=1.000000000000000e+05}', "");
    Expect(0, 126132, '\p{^Is_Numeric_Value=1.000000000000000e+05}', "");
    Expect(0, 126132, '\P{Is_Numeric_Value=1.000000000000000e+05}', "");
    Expect(1, 126132, '\P{^Is_Numeric_Value=1.000000000000000e+05}', "");
    Expect(0, 126133, '\p{Is_Numeric_Value=1.000000000000000e+05}', "");
    Expect(1, 126133, '\p{^Is_Numeric_Value=1.000000000000000e+05}', "");
    Expect(1, 126133, '\P{Is_Numeric_Value=1.000000000000000e+05}', "");
    Expect(0, 126133, '\P{^Is_Numeric_Value=1.000000000000000e+05}', "");
    Error('\p{Is_Nv= :=0100000}');
    Error('\P{Is_Nv= :=0100000}');
    Expect(1, 126132, '\p{Is_Nv:	0_0_0_0_1_0_0_0_00}', "");
    Expect(0, 126132, '\p{^Is_Nv:	0_0_0_0_1_0_0_0_00}', "");
    Expect(0, 126132, '\P{Is_Nv:	0_0_0_0_1_0_0_0_00}', "");
    Expect(1, 126132, '\P{^Is_Nv:	0_0_0_0_1_0_0_0_00}', "");
    Expect(0, 126133, '\p{Is_Nv:	0_0_0_0_1_0_0_0_00}', "");
    Expect(1, 126133, '\p{^Is_Nv:	0_0_0_0_1_0_0_0_00}', "");
    Expect(1, 126133, '\P{Is_Nv:	0_0_0_0_1_0_0_0_00}', "");
    Expect(0, 126133, '\P{^Is_Nv:	0_0_0_0_1_0_0_0_00}', "");
    Expect(1, 126132, '\p{Is_Nv=1.000000000000000e+05}', "");
    Expect(0, 126132, '\p{^Is_Nv=1.000000000000000e+05}', "");
    Expect(0, 126132, '\P{Is_Nv=1.000000000000000e+05}', "");
    Expect(1, 126132, '\P{^Is_Nv=1.000000000000000e+05}', "");
    Expect(0, 126133, '\p{Is_Nv=1.000000000000000e+05}', "");
    Expect(1, 126133, '\p{^Is_Nv=1.000000000000000e+05}', "");
    Expect(1, 126133, '\P{Is_Nv=1.000000000000000e+05}', "");
    Expect(0, 126133, '\P{^Is_Nv=1.000000000000000e+05}', "");
    Error('\p{Numeric_Value=-+000_000_000_100_0000:=}');
    Error('\P{Numeric_Value=-+000_000_000_100_0000:=}');
    Expect(1, 93022, '\p{Numeric_Value=:\A1000000\z:}', "");;
    Expect(0, 93023, '\p{Numeric_Value=:\A1000000\z:}', "");;
    Expect(1, 93022, '\p{Numeric_Value=+10_00_00_0}', "");
    Expect(0, 93022, '\p{^Numeric_Value=+10_00_00_0}', "");
    Expect(0, 93022, '\P{Numeric_Value=+10_00_00_0}', "");
    Expect(1, 93022, '\P{^Numeric_Value=+10_00_00_0}', "");
    Expect(0, 93023, '\p{Numeric_Value=+10_00_00_0}', "");
    Expect(1, 93023, '\p{^Numeric_Value=+10_00_00_0}', "");
    Expect(1, 93023, '\P{Numeric_Value=+10_00_00_0}', "");
    Expect(0, 93023, '\P{^Numeric_Value=+10_00_00_0}', "");
    Expect(1, 93022, '\p{Numeric_Value=1.000000000000000e+06}', "");
    Expect(0, 93022, '\p{^Numeric_Value=1.000000000000000e+06}', "");
    Expect(0, 93022, '\P{Numeric_Value=1.000000000000000e+06}', "");
    Expect(1, 93022, '\P{^Numeric_Value=1.000000000000000e+06}', "");
    Expect(0, 93023, '\p{Numeric_Value=1.000000000000000e+06}', "");
    Expect(1, 93023, '\p{^Numeric_Value=1.000000000000000e+06}', "");
    Expect(1, 93023, '\P{Numeric_Value=1.000000000000000e+06}', "");
    Expect(0, 93023, '\P{^Numeric_Value=1.000000000000000e+06}', "");
    Error('\p{Nv= +001000000:=}');
    Error('\P{Nv= +001000000:=}');
    Expect(1, 93022, '\p{Nv=:\A1000000\z:}', "");;
    Expect(0, 93023, '\p{Nv=:\A1000000\z:}', "");;
    Expect(1, 93022, '\p{Nv=01000000}', "");
    Expect(0, 93022, '\p{^Nv=01000000}', "");
    Expect(0, 93022, '\P{Nv=01000000}', "");
    Expect(1, 93022, '\P{^Nv=01000000}', "");
    Expect(0, 93023, '\p{Nv=01000000}', "");
    Expect(1, 93023, '\p{^Nv=01000000}', "");
    Expect(1, 93023, '\P{Nv=01000000}', "");
    Expect(0, 93023, '\P{^Nv=01000000}', "");
    Expect(1, 93022, '\p{Nv=1.000000000000000e+06}', "");
    Expect(0, 93022, '\p{^Nv=1.000000000000000e+06}', "");
    Expect(0, 93022, '\P{Nv=1.000000000000000e+06}', "");
    Expect(1, 93022, '\P{^Nv=1.000000000000000e+06}', "");
    Expect(0, 93023, '\p{Nv=1.000000000000000e+06}', "");
    Expect(1, 93023, '\p{^Nv=1.000000000000000e+06}', "");
    Expect(1, 93023, '\P{Nv=1.000000000000000e+06}', "");
    Expect(0, 93023, '\P{^Nv=1.000000000000000e+06}', "");
    Error('\p{Is_Numeric_Value=	:=1000000}');
    Error('\P{Is_Numeric_Value=	:=1000000}');
    Expect(1, 93022, '\p{Is_Numeric_Value=000000100000_0}', "");
    Expect(0, 93022, '\p{^Is_Numeric_Value=000000100000_0}', "");
    Expect(0, 93022, '\P{Is_Numeric_Value=000000100000_0}', "");
    Expect(1, 93022, '\P{^Is_Numeric_Value=000000100000_0}', "");
    Expect(0, 93023, '\p{Is_Numeric_Value=000000100000_0}', "");
    Expect(1, 93023, '\p{^Is_Numeric_Value=000000100000_0}', "");
    Expect(1, 93023, '\P{Is_Numeric_Value=000000100000_0}', "");
    Expect(0, 93023, '\P{^Is_Numeric_Value=000000100000_0}', "");
    Expect(1, 93022, '\p{Is_Numeric_Value=1.000000000000000e+06}', "");
    Expect(0, 93022, '\p{^Is_Numeric_Value=1.000000000000000e+06}', "");
    Expect(0, 93022, '\P{Is_Numeric_Value=1.000000000000000e+06}', "");
    Expect(1, 93022, '\P{^Is_Numeric_Value=1.000000000000000e+06}', "");
    Expect(0, 93023, '\p{Is_Numeric_Value=1.000000000000000e+06}', "");
    Expect(1, 93023, '\p{^Is_Numeric_Value=1.000000000000000e+06}', "");
    Expect(1, 93023, '\P{Is_Numeric_Value=1.000000000000000e+06}', "");
    Expect(0, 93023, '\P{^Is_Numeric_Value=1.000000000000000e+06}', "");
    Error('\p{Is_Nv=/a/_+0000001000000}');
    Error('\P{Is_Nv=/a/_+0000001000000}');
    Expect(1, 93022, '\p{Is_Nv:000000001000000}', "");
    Expect(0, 93022, '\p{^Is_Nv:000000001000000}', "");
    Expect(0, 93022, '\P{Is_Nv:000000001000000}', "");
    Expect(1, 93022, '\P{^Is_Nv:000000001000000}', "");
    Expect(0, 93023, '\p{Is_Nv:000000001000000}', "");
    Expect(1, 93023, '\p{^Is_Nv:000000001000000}', "");
    Expect(1, 93023, '\P{Is_Nv:000000001000000}', "");
    Expect(0, 93023, '\P{^Is_Nv:000000001000000}', "");
    Expect(1, 93022, '\p{Is_Nv=1.000000000000000e+06}', "");
    Expect(0, 93022, '\p{^Is_Nv=1.000000000000000e+06}', "");
    Expect(0, 93022, '\P{Is_Nv=1.000000000000000e+06}', "");
    Expect(1, 93022, '\P{^Is_Nv=1.000000000000000e+06}', "");
    Expect(0, 93023, '\p{Is_Nv=1.000000000000000e+06}', "");
    Expect(1, 93023, '\p{^Is_Nv=1.000000000000000e+06}', "");
    Expect(1, 93023, '\P{Is_Nv=1.000000000000000e+06}', "");
    Expect(0, 93023, '\P{^Is_Nv=1.000000000000000e+06}', "");
    Error('\p{Numeric_Value=- 0010000000/a/}');
    Error('\P{Numeric_Value=- 0010000000/a/}');
    Expect(1, 126113, '\p{Numeric_Value=:\A10000000\z:}', "");;
    Expect(0, 126114, '\p{Numeric_Value=:\A10000000\z:}', "");;
    Expect(1, 126113, '\p{Numeric_Value=1000000_0}', "");
    Expect(0, 126113, '\p{^Numeric_Value=1000000_0}', "");
    Expect(0, 126113, '\P{Numeric_Value=1000000_0}', "");
    Expect(1, 126113, '\P{^Numeric_Value=1000000_0}', "");
    Expect(0, 126114, '\p{Numeric_Value=1000000_0}', "");
    Expect(1, 126114, '\p{^Numeric_Value=1000000_0}', "");
    Expect(1, 126114, '\P{Numeric_Value=1000000_0}', "");
    Expect(0, 126114, '\P{^Numeric_Value=1000000_0}', "");
    Expect(1, 126113, '\p{Numeric_Value=1.000000000000000e+07}', "");
    Expect(0, 126113, '\p{^Numeric_Value=1.000000000000000e+07}', "");
    Expect(0, 126113, '\P{Numeric_Value=1.000000000000000e+07}', "");
    Expect(1, 126113, '\P{^Numeric_Value=1.000000000000000e+07}', "");
    Expect(0, 126114, '\p{Numeric_Value=1.000000000000000e+07}', "");
    Expect(1, 126114, '\p{^Numeric_Value=1.000000000000000e+07}', "");
    Expect(1, 126114, '\P{Numeric_Value=1.000000000000000e+07}', "");
    Expect(0, 126114, '\P{^Numeric_Value=1.000000000000000e+07}', "");
    Error('\p{Nv=_	00_00_01_00_00_00_0/a/}');
    Error('\P{Nv=_	00_00_01_00_00_00_0/a/}');
    Expect(1, 126113, '\p{Nv=:\A10000000\z:}', "");;
    Expect(0, 126114, '\p{Nv=:\A10000000\z:}', "");;
    Expect(1, 126113, '\p{Nv: 00000010000000}', "");
    Expect(0, 126113, '\p{^Nv: 00000010000000}', "");
    Expect(0, 126113, '\P{Nv: 00000010000000}', "");
    Expect(1, 126113, '\P{^Nv: 00000010000000}', "");
    Expect(0, 126114, '\p{Nv: 00000010000000}', "");
    Expect(1, 126114, '\p{^Nv: 00000010000000}', "");
    Expect(1, 126114, '\P{Nv: 00000010000000}', "");
    Expect(0, 126114, '\P{^Nv: 00000010000000}', "");
    Expect(1, 126113, '\p{Nv=1.000000000000000e+07}', "");
    Expect(0, 126113, '\p{^Nv=1.000000000000000e+07}', "");
    Expect(0, 126113, '\P{Nv=1.000000000000000e+07}', "");
    Expect(1, 126113, '\P{^Nv=1.000000000000000e+07}', "");
    Expect(0, 126114, '\p{Nv=1.000000000000000e+07}', "");
    Expect(1, 126114, '\p{^Nv=1.000000000000000e+07}', "");
    Expect(1, 126114, '\P{Nv=1.000000000000000e+07}', "");
    Expect(0, 126114, '\P{^Nv=1.000000000000000e+07}', "");
    Error('\p{Is_Numeric_Value=-00000_00001_00000_00/a/}');
    Error('\P{Is_Numeric_Value=-00000_00001_00000_00/a/}');
    Expect(1, 126113, '\p{Is_Numeric_Value=+0_0_0_0_0_1_0_0_00000}', "");
    Expect(0, 126113, '\p{^Is_Numeric_Value=+0_0_0_0_0_1_0_0_00000}', "");
    Expect(0, 126113, '\P{Is_Numeric_Value=+0_0_0_0_0_1_0_0_00000}', "");
    Expect(1, 126113, '\P{^Is_Numeric_Value=+0_0_0_0_0_1_0_0_00000}', "");
    Expect(0, 126114, '\p{Is_Numeric_Value=+0_0_0_0_0_1_0_0_00000}', "");
    Expect(1, 126114, '\p{^Is_Numeric_Value=+0_0_0_0_0_1_0_0_00000}', "");
    Expect(1, 126114, '\P{Is_Numeric_Value=+0_0_0_0_0_1_0_0_00000}', "");
    Expect(0, 126114, '\P{^Is_Numeric_Value=+0_0_0_0_0_1_0_0_00000}', "");
    Expect(1, 126113, '\p{Is_Numeric_Value=1.000000000000000e+07}', "");
    Expect(0, 126113, '\p{^Is_Numeric_Value=1.000000000000000e+07}', "");
    Expect(0, 126113, '\P{Is_Numeric_Value=1.000000000000000e+07}', "");
    Expect(1, 126113, '\P{^Is_Numeric_Value=1.000000000000000e+07}', "");
    Expect(0, 126114, '\p{Is_Numeric_Value=1.000000000000000e+07}', "");
    Expect(1, 126114, '\p{^Is_Numeric_Value=1.000000000000000e+07}', "");
    Expect(1, 126114, '\P{Is_Numeric_Value=1.000000000000000e+07}', "");
    Expect(0, 126114, '\P{^Is_Numeric_Value=1.000000000000000e+07}', "");
    Error('\p{Is_Nv=_	+010000000/a/}');
    Error('\P{Is_Nv=_	+010000000/a/}');
    Expect(1, 126113, '\p{Is_Nv=0_0_0_0_0_0_0_0_1_0_0_0_0_0_00}', "");
    Expect(0, 126113, '\p{^Is_Nv=0_0_0_0_0_0_0_0_1_0_0_0_0_0_00}', "");
    Expect(0, 126113, '\P{Is_Nv=0_0_0_0_0_0_0_0_1_0_0_0_0_0_00}', "");
    Expect(1, 126113, '\P{^Is_Nv=0_0_0_0_0_0_0_0_1_0_0_0_0_0_00}', "");
    Expect(0, 126114, '\p{Is_Nv=0_0_0_0_0_0_0_0_1_0_0_0_0_0_00}', "");
    Expect(1, 126114, '\p{^Is_Nv=0_0_0_0_0_0_0_0_1_0_0_0_0_0_00}', "");
    Expect(1, 126114, '\P{Is_Nv=0_0_0_0_0_0_0_0_1_0_0_0_0_0_00}', "");
    Expect(0, 126114, '\P{^Is_Nv=0_0_0_0_0_0_0_0_1_0_0_0_0_0_00}', "");
    Expect(1, 126113, '\p{Is_Nv=1.000000000000000e+07}', "");
    Expect(0, 126113, '\p{^Is_Nv=1.000000000000000e+07}', "");
    Expect(0, 126113, '\P{Is_Nv=1.000000000000000e+07}', "");
    Expect(1, 126113, '\P{^Is_Nv=1.000000000000000e+07}', "");
    Expect(0, 126114, '\p{Is_Nv=1.000000000000000e+07}', "");
    Expect(1, 126114, '\p{^Is_Nv=1.000000000000000e+07}', "");
    Expect(1, 126114, '\P{Is_Nv=1.000000000000000e+07}', "");
    Expect(0, 126114, '\P{^Is_Nv=1.000000000000000e+07}', "");
    Error('\p{Numeric_Value::=-	+00100000000}');
    Error('\P{Numeric_Value::=-	+00100000000}');
    Expect(1, 93023, '\p{Numeric_Value=:\A100000000\z:}', "");;
    Expect(0, 93024, '\p{Numeric_Value=:\A100000000\z:}', "");;
    Expect(1, 93023, '\p{Numeric_Value:   0_0_0_0_0_0_0_0_0_1_0_0_0_0_0000}', "");
    Expect(0, 93023, '\p{^Numeric_Value:   0_0_0_0_0_0_0_0_0_1_0_0_0_0_0000}', "");
    Expect(0, 93023, '\P{Numeric_Value:   0_0_0_0_0_0_0_0_0_1_0_0_0_0_0000}', "");
    Expect(1, 93023, '\P{^Numeric_Value:   0_0_0_0_0_0_0_0_0_1_0_0_0_0_0000}', "");
    Expect(0, 93024, '\p{Numeric_Value:   0_0_0_0_0_0_0_0_0_1_0_0_0_0_0000}', "");
    Expect(1, 93024, '\p{^Numeric_Value:   0_0_0_0_0_0_0_0_0_1_0_0_0_0_0000}', "");
    Expect(1, 93024, '\P{Numeric_Value:   0_0_0_0_0_0_0_0_0_1_0_0_0_0_0000}', "");
    Expect(0, 93024, '\P{^Numeric_Value:   0_0_0_0_0_0_0_0_0_1_0_0_0_0_0000}', "");
    Expect(1, 93023, '\p{Numeric_Value=1.000000000000000e+08}', "");
    Expect(0, 93023, '\p{^Numeric_Value=1.000000000000000e+08}', "");
    Expect(0, 93023, '\P{Numeric_Value=1.000000000000000e+08}', "");
    Expect(1, 93023, '\P{^Numeric_Value=1.000000000000000e+08}', "");
    Expect(0, 93024, '\p{Numeric_Value=1.000000000000000e+08}', "");
    Expect(1, 93024, '\p{^Numeric_Value=1.000000000000000e+08}', "");
    Expect(1, 93024, '\P{Numeric_Value=1.000000000000000e+08}', "");
    Expect(0, 93024, '\P{^Numeric_Value=1.000000000000000e+08}', "");
    Error('\p{Nv=/a/		+0100000000}');
    Error('\P{Nv=/a/		+0100000000}');
    Expect(1, 93023, '\p{Nv=:\A100000000\z:}', "");;
    Expect(0, 93024, '\p{Nv=:\A100000000\z:}', "");;
    Expect(1, 93023, '\p{Nv=+00000000100000000}', "");
    Expect(0, 93023, '\p{^Nv=+00000000100000000}', "");
    Expect(0, 93023, '\P{Nv=+00000000100000000}', "");
    Expect(1, 93023, '\P{^Nv=+00000000100000000}', "");
    Expect(0, 93024, '\p{Nv=+00000000100000000}', "");
    Expect(1, 93024, '\p{^Nv=+00000000100000000}', "");
    Expect(1, 93024, '\P{Nv=+00000000100000000}', "");
    Expect(0, 93024, '\P{^Nv=+00000000100000000}', "");
    Expect(1, 93023, '\p{Nv=1.000000000000000e+08}', "");
    Expect(0, 93023, '\p{^Nv=1.000000000000000e+08}', "");
    Expect(0, 93023, '\P{Nv=1.000000000000000e+08}', "");
    Expect(1, 93023, '\P{^Nv=1.000000000000000e+08}', "");
    Expect(0, 93024, '\p{Nv=1.000000000000000e+08}', "");
    Expect(1, 93024, '\p{^Nv=1.000000000000000e+08}', "");
    Expect(1, 93024, '\P{Nv=1.000000000000000e+08}', "");
    Expect(0, 93024, '\P{^Nv=1.000000000000000e+08}', "");
    Error('\p{Is_Numeric_Value=-_00_00_10_00_00_00_0:=}');
    Error('\P{Is_Numeric_Value=-_00_00_10_00_00_00_0:=}');
    Expect(1, 93023, '\p{Is_Numeric_Value=+0_0_0_1_0_0_0_00000}', "");
    Expect(0, 93023, '\p{^Is_Numeric_Value=+0_0_0_1_0_0_0_00000}', "");
    Expect(0, 93023, '\P{Is_Numeric_Value=+0_0_0_1_0_0_0_00000}', "");
    Expect(1, 93023, '\P{^Is_Numeric_Value=+0_0_0_1_0_0_0_00000}', "");
    Expect(0, 93024, '\p{Is_Numeric_Value=+0_0_0_1_0_0_0_00000}', "");
    Expect(1, 93024, '\p{^Is_Numeric_Value=+0_0_0_1_0_0_0_00000}', "");
    Expect(1, 93024, '\P{Is_Numeric_Value=+0_0_0_1_0_0_0_00000}', "");
    Expect(0, 93024, '\P{^Is_Numeric_Value=+0_0_0_1_0_0_0_00000}', "");
    Expect(1, 93023, '\p{Is_Numeric_Value=1.000000000000000e+08}', "");
    Expect(0, 93023, '\p{^Is_Numeric_Value=1.000000000000000e+08}', "");
    Expect(0, 93023, '\P{Is_Numeric_Value=1.000000000000000e+08}', "");
    Expect(1, 93023, '\P{^Is_Numeric_Value=1.000000000000000e+08}', "");
    Expect(0, 93024, '\p{Is_Numeric_Value=1.000000000000000e+08}', "");
    Expect(1, 93024, '\p{^Is_Numeric_Value=1.000000000000000e+08}', "");
    Expect(1, 93024, '\P{Is_Numeric_Value=1.000000000000000e+08}', "");
    Expect(0, 93024, '\P{^Is_Numeric_Value=1.000000000000000e+08}', "");
    Error('\p{Is_Nv=	-00000100000000:=}');
    Error('\P{Is_Nv=	-00000100000000:=}');
    Expect(1, 93023, '\p{Is_Nv=00_10_00_00_000}', "");
    Expect(0, 93023, '\p{^Is_Nv=00_10_00_00_000}', "");
    Expect(0, 93023, '\P{Is_Nv=00_10_00_00_000}', "");
    Expect(1, 93023, '\P{^Is_Nv=00_10_00_00_000}', "");
    Expect(0, 93024, '\p{Is_Nv=00_10_00_00_000}', "");
    Expect(1, 93024, '\p{^Is_Nv=00_10_00_00_000}', "");
    Expect(1, 93024, '\P{Is_Nv=00_10_00_00_000}', "");
    Expect(0, 93024, '\P{^Is_Nv=00_10_00_00_000}', "");
    Expect(1, 93023, '\p{Is_Nv=1.000000000000000e+08}', "");
    Expect(0, 93023, '\p{^Is_Nv=1.000000000000000e+08}', "");
    Expect(0, 93023, '\P{Is_Nv=1.000000000000000e+08}', "");
    Expect(1, 93023, '\P{^Is_Nv=1.000000000000000e+08}', "");
    Expect(0, 93024, '\p{Is_Nv=1.000000000000000e+08}', "");
    Expect(1, 93024, '\p{^Is_Nv=1.000000000000000e+08}', "");
    Expect(1, 93024, '\P{Is_Nv=1.000000000000000e+08}', "");
    Expect(0, 93024, '\P{^Is_Nv=1.000000000000000e+08}', "");
    Error('\p{Numeric_Value=/a/ +0000010000000000}');
    Error('\P{Numeric_Value=/a/ +0000010000000000}');
    Expect(1, 93024, '\p{Numeric_Value=:\A10000000000\z:}', "");;
    Expect(0, 93025, '\p{Numeric_Value=:\A10000000000\z:}', "");;
    Expect(1, 93024, '\p{Numeric_Value=0_1_0_0_0_0_0_0_0_000}', "");
    Expect(0, 93024, '\p{^Numeric_Value=0_1_0_0_0_0_0_0_0_000}', "");
    Expect(0, 93024, '\P{Numeric_Value=0_1_0_0_0_0_0_0_0_000}', "");
    Expect(1, 93024, '\P{^Numeric_Value=0_1_0_0_0_0_0_0_0_000}', "");
    Expect(0, 93025, '\p{Numeric_Value=0_1_0_0_0_0_0_0_0_000}', "");
    Expect(1, 93025, '\p{^Numeric_Value=0_1_0_0_0_0_0_0_0_000}', "");
    Expect(1, 93025, '\P{Numeric_Value=0_1_0_0_0_0_0_0_0_000}', "");
    Expect(0, 93025, '\P{^Numeric_Value=0_1_0_0_0_0_0_0_0_000}', "");
    Expect(1, 93024, '\p{Numeric_Value=1.000000000000000e+10}', "");
    Expect(0, 93024, '\p{^Numeric_Value=1.000000000000000e+10}', "");
    Expect(0, 93024, '\P{Numeric_Value=1.000000000000000e+10}', "");
    Expect(1, 93024, '\P{^Numeric_Value=1.000000000000000e+10}', "");
    Expect(0, 93025, '\p{Numeric_Value=1.000000000000000e+10}', "");
    Expect(1, 93025, '\p{^Numeric_Value=1.000000000000000e+10}', "");
    Expect(1, 93025, '\P{Numeric_Value=1.000000000000000e+10}', "");
    Expect(0, 93025, '\P{^Numeric_Value=1.000000000000000e+10}', "");
    Error('\p{Nv=  000000010000000000:=}');
    Error('\P{Nv=  000000010000000000:=}');
    Expect(1, 93024, '\p{Nv=:\A10000000000\z:}', "");;
    Expect(0, 93025, '\p{Nv=:\A10000000000\z:}', "");;
    Expect(1, 93024, '\p{Nv=10_00_00_00_000}', "");
    Expect(0, 93024, '\p{^Nv=10_00_00_00_000}', "");
    Expect(0, 93024, '\P{Nv=10_00_00_00_000}', "");
    Expect(1, 93024, '\P{^Nv=10_00_00_00_000}', "");
    Expect(0, 93025, '\p{Nv=10_00_00_00_000}', "");
    Expect(1, 93025, '\p{^Nv=10_00_00_00_000}', "");
    Expect(1, 93025, '\P{Nv=10_00_00_00_000}', "");
    Expect(0, 93025, '\P{^Nv=10_00_00_00_000}', "");
    Expect(1, 93024, '\p{Nv=1.000000000000000e+10}', "");
    Expect(0, 93024, '\p{^Nv=1.000000000000000e+10}', "");
    Expect(0, 93024, '\P{Nv=1.000000000000000e+10}', "");
    Expect(1, 93024, '\P{^Nv=1.000000000000000e+10}', "");
    Expect(0, 93025, '\p{Nv=1.000000000000000e+10}', "");
    Expect(1, 93025, '\p{^Nv=1.000000000000000e+10}', "");
    Expect(1, 93025, '\P{Nv=1.000000000000000e+10}', "");
    Expect(0, 93025, '\P{^Nv=1.000000000000000e+10}', "");
    Error('\p{Is_Numeric_Value= 010000000000:=}');
    Error('\P{Is_Numeric_Value= 010000000000:=}');
    Expect(1, 93024, '\p{Is_Numeric_Value=+001_000_000_000_0}', "");
    Expect(0, 93024, '\p{^Is_Numeric_Value=+001_000_000_000_0}', "");
    Expect(0, 93024, '\P{Is_Numeric_Value=+001_000_000_000_0}', "");
    Expect(1, 93024, '\P{^Is_Numeric_Value=+001_000_000_000_0}', "");
    Expect(0, 93025, '\p{Is_Numeric_Value=+001_000_000_000_0}', "");
    Expect(1, 93025, '\p{^Is_Numeric_Value=+001_000_000_000_0}', "");
    Expect(1, 93025, '\P{Is_Numeric_Value=+001_000_000_000_0}', "");
    Expect(0, 93025, '\P{^Is_Numeric_Value=+001_000_000_000_0}', "");
    Expect(1, 93024, '\p{Is_Numeric_Value=1.000000000000000e+10}', "");
    Expect(0, 93024, '\p{^Is_Numeric_Value=1.000000000000000e+10}', "");
    Expect(0, 93024, '\P{Is_Numeric_Value=1.000000000000000e+10}', "");
    Expect(1, 93024, '\P{^Is_Numeric_Value=1.000000000000000e+10}', "");
    Expect(0, 93025, '\p{Is_Numeric_Value=1.000000000000000e+10}', "");
    Expect(1, 93025, '\p{^Is_Numeric_Value=1.000000000000000e+10}', "");
    Expect(1, 93025, '\P{Is_Numeric_Value=1.000000000000000e+10}', "");
    Expect(0, 93025, '\P{^Is_Numeric_Value=1.000000000000000e+10}', "");
    Error('\p{Is_Nv=		00_00_01_00_00_00_0000/a/}');
    Error('\P{Is_Nv=		00_00_01_00_00_00_0000/a/}');
    Expect(1, 93024, '\p{Is_Nv=0000010000000000}', "");
    Expect(0, 93024, '\p{^Is_Nv=0000010000000000}', "");
    Expect(0, 93024, '\P{Is_Nv=0000010000000000}', "");
    Expect(1, 93024, '\P{^Is_Nv=0000010000000000}', "");
    Expect(0, 93025, '\p{Is_Nv=0000010000000000}', "");
    Expect(1, 93025, '\p{^Is_Nv=0000010000000000}', "");
    Expect(1, 93025, '\P{Is_Nv=0000010000000000}', "");
    Expect(0, 93025, '\P{^Is_Nv=0000010000000000}', "");
    Expect(1, 93024, '\p{Is_Nv=1.000000000000000e+10}', "");
    Expect(0, 93024, '\p{^Is_Nv=1.000000000000000e+10}', "");
    Expect(0, 93024, '\P{Is_Nv=1.000000000000000e+10}', "");
    Expect(1, 93024, '\P{^Is_Nv=1.000000000000000e+10}', "");
    Expect(0, 93025, '\p{Is_Nv=1.000000000000000e+10}', "");
    Expect(1, 93025, '\p{^Is_Nv=1.000000000000000e+10}', "");
    Expect(1, 93025, '\P{Is_Nv=1.000000000000000e+10}', "");
    Expect(0, 93025, '\P{^Is_Nv=1.000000000000000e+10}', "");
    Error('\p{Numeric_Value: /a/	 00001000000000000}');
    Error('\P{Numeric_Value: /a/	 00001000000000000}');
    Expect(1, 93025, '\p{Numeric_Value=:\A1000000000000\z:}', "");;
    Expect(0, 93026, '\p{Numeric_Value=:\A1000000000000\z:}', "");;
    Expect(1, 93025, '\p{Numeric_Value=+0000000_0010000_0000000_0}', "");
    Expect(0, 93025, '\p{^Numeric_Value=+0000000_0010000_0000000_0}', "");
    Expect(0, 93025, '\P{Numeric_Value=+0000000_0010000_0000000_0}', "");
    Expect(1, 93025, '\P{^Numeric_Value=+0000000_0010000_0000000_0}', "");
    Expect(0, 93026, '\p{Numeric_Value=+0000000_0010000_0000000_0}', "");
    Expect(1, 93026, '\p{^Numeric_Value=+0000000_0010000_0000000_0}', "");
    Expect(1, 93026, '\P{Numeric_Value=+0000000_0010000_0000000_0}', "");
    Expect(0, 93026, '\P{^Numeric_Value=+0000000_0010000_0000000_0}', "");
    Expect(1, 93025, '\p{Numeric_Value=1.000000000000000e+12}', "");
    Expect(0, 93025, '\p{^Numeric_Value=1.000000000000000e+12}', "");
    Expect(0, 93025, '\P{Numeric_Value=1.000000000000000e+12}', "");
    Expect(1, 93025, '\P{^Numeric_Value=1.000000000000000e+12}', "");
    Expect(0, 93026, '\p{Numeric_Value=1.000000000000000e+12}', "");
    Expect(1, 93026, '\p{^Numeric_Value=1.000000000000000e+12}', "");
    Expect(1, 93026, '\P{Numeric_Value=1.000000000000000e+12}', "");
    Expect(0, 93026, '\P{^Numeric_Value=1.000000000000000e+12}', "");
    Error('\p{Nv=		000001000000000000:=}');
    Error('\P{Nv=		000001000000000000:=}');
    Expect(1, 93025, '\p{Nv=:\A1000000000000\z:}', "");;
    Expect(0, 93026, '\p{Nv=:\A1000000000000\z:}', "");;
    Expect(1, 93025, '\p{Nv=0_0_0_0_0_0_0_0_1_0_0_0_0_0_0000000}', "");
    Expect(0, 93025, '\p{^Nv=0_0_0_0_0_0_0_0_1_0_0_0_0_0_0000000}', "");
    Expect(0, 93025, '\P{Nv=0_0_0_0_0_0_0_0_1_0_0_0_0_0_0000000}', "");
    Expect(1, 93025, '\P{^Nv=0_0_0_0_0_0_0_0_1_0_0_0_0_0_0000000}', "");
    Expect(0, 93026, '\p{Nv=0_0_0_0_0_0_0_0_1_0_0_0_0_0_0000000}', "");
    Expect(1, 93026, '\p{^Nv=0_0_0_0_0_0_0_0_1_0_0_0_0_0_0000000}', "");
    Expect(1, 93026, '\P{Nv=0_0_0_0_0_0_0_0_1_0_0_0_0_0_0000000}', "");
    Expect(0, 93026, '\P{^Nv=0_0_0_0_0_0_0_0_1_0_0_0_0_0_0000000}', "");
    Expect(1, 93025, '\p{Nv=1.000000000000000e+12}', "");
    Expect(0, 93025, '\p{^Nv=1.000000000000000e+12}', "");
    Expect(0, 93025, '\P{Nv=1.000000000000000e+12}', "");
    Expect(1, 93025, '\P{^Nv=1.000000000000000e+12}', "");
    Expect(0, 93026, '\p{Nv=1.000000000000000e+12}', "");
    Expect(1, 93026, '\p{^Nv=1.000000000000000e+12}', "");
    Expect(1, 93026, '\P{Nv=1.000000000000000e+12}', "");
    Expect(0, 93026, '\P{^Nv=1.000000000000000e+12}', "");
    Error('\p{Is_Numeric_Value:   -	00001000000000000:=}');
    Error('\P{Is_Numeric_Value:   -	00001000000000000:=}');
    Expect(1, 93025, '\p{Is_Numeric_Value=1000000000000}', "");
    Expect(0, 93025, '\p{^Is_Numeric_Value=1000000000000}', "");
    Expect(0, 93025, '\P{Is_Numeric_Value=1000000000000}', "");
    Expect(1, 93025, '\P{^Is_Numeric_Value=1000000000000}', "");
    Expect(0, 93026, '\p{Is_Numeric_Value=1000000000000}', "");
    Expect(1, 93026, '\p{^Is_Numeric_Value=1000000000000}', "");
    Expect(1, 93026, '\P{Is_Numeric_Value=1000000000000}', "");
    Expect(0, 93026, '\P{^Is_Numeric_Value=1000000000000}', "");
    Expect(1, 93025, '\p{Is_Numeric_Value=1.000000000000000e+12}', "");
    Expect(0, 93025, '\p{^Is_Numeric_Value=1.000000000000000e+12}', "");
    Expect(0, 93025, '\P{Is_Numeric_Value=1.000000000000000e+12}', "");
    Expect(1, 93025, '\P{^Is_Numeric_Value=1.000000000000000e+12}', "");
    Expect(0, 93026, '\p{Is_Numeric_Value=1.000000000000000e+12}', "");
    Expect(1, 93026, '\p{^Is_Numeric_Value=1.000000000000000e+12}', "");
    Expect(1, 93026, '\P{Is_Numeric_Value=1.000000000000000e+12}', "");
    Expect(0, 93026, '\P{^Is_Numeric_Value=1.000000000000000e+12}', "");
    Error('\p{Is_Nv=-00_00_10_00_00_00_00000/a/}');
    Error('\P{Is_Nv=-00_00_10_00_00_00_00000/a/}');
    Expect(1, 93025, '\p{Is_Nv=0_0_0_0_0_0_0_1_0_0_0_0_0_0_0_0_0_000}', "");
    Expect(0, 93025, '\p{^Is_Nv=0_0_0_0_0_0_0_1_0_0_0_0_0_0_0_0_0_000}', "");
    Expect(0, 93025, '\P{Is_Nv=0_0_0_0_0_0_0_1_0_0_0_0_0_0_0_0_0_000}', "");
    Expect(1, 93025, '\P{^Is_Nv=0_0_0_0_0_0_0_1_0_0_0_0_0_0_0_0_0_000}', "");
    Expect(0, 93026, '\p{Is_Nv=0_0_0_0_0_0_0_1_0_0_0_0_0_0_0_0_0_000}', "");
    Expect(1, 93026, '\p{^Is_Nv=0_0_0_0_0_0_0_1_0_0_0_0_0_0_0_0_0_000}', "");
    Expect(1, 93026, '\P{Is_Nv=0_0_0_0_0_0_0_1_0_0_0_0_0_0_0_0_0_000}', "");
    Expect(0, 93026, '\P{^Is_Nv=0_0_0_0_0_0_0_1_0_0_0_0_0_0_0_0_0_000}', "");
    Expect(1, 93025, '\p{Is_Nv=1.000000000000000e+12}', "");
    Expect(0, 93025, '\p{^Is_Nv=1.000000000000000e+12}', "");
    Expect(0, 93025, '\P{Is_Nv=1.000000000000000e+12}', "");
    Expect(1, 93025, '\P{^Is_Nv=1.000000000000000e+12}', "");
    Expect(0, 93026, '\p{Is_Nv=1.000000000000000e+12}', "");
    Expect(1, 93026, '\p{^Is_Nv=1.000000000000000e+12}', "");
    Expect(1, 93026, '\P{Is_Nv=1.000000000000000e+12}', "");
    Expect(0, 93026, '\P{^Is_Nv=1.000000000000000e+12}', "");
    Error('\p{Numeric_Value= -+00_00_00_00_01_1/a/}');
    Error('\P{Numeric_Value= -+00_00_00_00_01_1/a/}');
    Expect(1, 119531, '\p{Numeric_Value=:\A11\z:}', "");;
    Expect(0, 119532, '\p{Numeric_Value=:\A11\z:}', "");;
    Expect(1, 119531, '\p{Numeric_Value=+00000011}', "");
    Expect(0, 119531, '\p{^Numeric_Value=+00000011}', "");
    Expect(0, 119531, '\P{Numeric_Value=+00000011}', "");
    Expect(1, 119531, '\P{^Numeric_Value=+00000011}', "");
    Expect(0, 119532, '\p{Numeric_Value=+00000011}', "");
    Expect(1, 119532, '\p{^Numeric_Value=+00000011}', "");
    Expect(1, 119532, '\P{Numeric_Value=+00000011}', "");
    Expect(0, 119532, '\P{^Numeric_Value=+00000011}', "");
    Expect(1, 119531, '\p{Numeric_Value=1.100000000000000e+01}', "");
    Expect(0, 119531, '\p{^Numeric_Value=1.100000000000000e+01}', "");
    Expect(0, 119531, '\P{Numeric_Value=1.100000000000000e+01}', "");
    Expect(1, 119531, '\P{^Numeric_Value=1.100000000000000e+01}', "");
    Expect(0, 119532, '\p{Numeric_Value=1.100000000000000e+01}', "");
    Expect(1, 119532, '\p{^Numeric_Value=1.100000000000000e+01}', "");
    Expect(1, 119532, '\P{Numeric_Value=1.100000000000000e+01}', "");
    Expect(0, 119532, '\P{^Numeric_Value=1.100000000000000e+01}', "");
    Error('\p{Nv=/a/ 	000000011}');
    Error('\P{Nv=/a/ 	000000011}');
    Expect(1, 119531, '\p{Nv=:\A11\z:}', "");;
    Expect(0, 119532, '\p{Nv=:\A11\z:}', "");;
    Expect(1, 119531, '\p{Nv=00_00_01_1}', "");
    Expect(0, 119531, '\p{^Nv=00_00_01_1}', "");
    Expect(0, 119531, '\P{Nv=00_00_01_1}', "");
    Expect(1, 119531, '\P{^Nv=00_00_01_1}', "");
    Expect(0, 119532, '\p{Nv=00_00_01_1}', "");
    Expect(1, 119532, '\p{^Nv=00_00_01_1}', "");
    Expect(1, 119532, '\P{Nv=00_00_01_1}', "");
    Expect(0, 119532, '\P{^Nv=00_00_01_1}', "");
    Expect(1, 119531, '\p{Nv=1.100000000000000e+01}', "");
    Expect(0, 119531, '\p{^Nv=1.100000000000000e+01}', "");
    Expect(0, 119531, '\P{Nv=1.100000000000000e+01}', "");
    Expect(1, 119531, '\P{^Nv=1.100000000000000e+01}', "");
    Expect(0, 119532, '\p{Nv=1.100000000000000e+01}', "");
    Expect(1, 119532, '\p{^Nv=1.100000000000000e+01}', "");
    Expect(1, 119532, '\P{Nv=1.100000000000000e+01}', "");
    Expect(0, 119532, '\P{^Nv=1.100000000000000e+01}', "");
    Error('\p{Is_Numeric_Value=/a/_-00_00_11}');
    Error('\P{Is_Numeric_Value=/a/_-00_00_11}');
    Expect(1, 119531, '\p{Is_Numeric_Value=011}', "");
    Expect(0, 119531, '\p{^Is_Numeric_Value=011}', "");
    Expect(0, 119531, '\P{Is_Numeric_Value=011}', "");
    Expect(1, 119531, '\P{^Is_Numeric_Value=011}', "");
    Expect(0, 119532, '\p{Is_Numeric_Value=011}', "");
    Expect(1, 119532, '\p{^Is_Numeric_Value=011}', "");
    Expect(1, 119532, '\P{Is_Numeric_Value=011}', "");
    Expect(0, 119532, '\P{^Is_Numeric_Value=011}', "");
    Expect(1, 119531, '\p{Is_Numeric_Value=1.100000000000000e+01}', "");
    Expect(0, 119531, '\p{^Is_Numeric_Value=1.100000000000000e+01}', "");
    Expect(0, 119531, '\P{Is_Numeric_Value=1.100000000000000e+01}', "");
    Expect(1, 119531, '\P{^Is_Numeric_Value=1.100000000000000e+01}', "");
    Expect(0, 119532, '\p{Is_Numeric_Value=1.100000000000000e+01}', "");
    Expect(1, 119532, '\p{^Is_Numeric_Value=1.100000000000000e+01}', "");
    Expect(1, 119532, '\P{Is_Numeric_Value=1.100000000000000e+01}', "");
    Expect(0, 119532, '\P{^Is_Numeric_Value=1.100000000000000e+01}', "");
    Error('\p{Is_Nv= +0_0_0_0_0_0_011/a/}');
    Error('\P{Is_Nv= +0_0_0_0_0_0_011/a/}');
    Expect(1, 119531, '\p{Is_Nv:	+11}', "");
    Expect(0, 119531, '\p{^Is_Nv:	+11}', "");
    Expect(0, 119531, '\P{Is_Nv:	+11}', "");
    Expect(1, 119531, '\P{^Is_Nv:	+11}', "");
    Expect(0, 119532, '\p{Is_Nv:	+11}', "");
    Expect(1, 119532, '\p{^Is_Nv:	+11}', "");
    Expect(1, 119532, '\P{Is_Nv:	+11}', "");
    Expect(0, 119532, '\P{^Is_Nv:	+11}', "");
    Expect(1, 119531, '\p{Is_Nv=1.100000000000000e+01}', "");
    Expect(0, 119531, '\p{^Is_Nv=1.100000000000000e+01}', "");
    Expect(0, 119531, '\P{Is_Nv=1.100000000000000e+01}', "");
    Expect(1, 119531, '\P{^Is_Nv=1.100000000000000e+01}', "");
    Expect(0, 119532, '\p{Is_Nv=1.100000000000000e+01}', "");
    Expect(1, 119532, '\p{^Is_Nv=1.100000000000000e+01}', "");
    Expect(1, 119532, '\P{Is_Nv=1.100000000000000e+01}', "");
    Expect(0, 119532, '\P{^Is_Nv=1.100000000000000e+01}', "");
    Error('\p{Numeric_Value= /a/+0000000011/0000000012}');
    Error('\P{Numeric_Value= /a/+0000000011/0000000012}');
    Expect(1, 68028, '\p{Numeric_Value=:\A11/12\z:}', "");;
    Expect(0, 68029, '\p{Numeric_Value=:\A11/12\z:}', "");;
    Expect(1, 68028, '\p{Numeric_Value:	011/12}', "");
    Expect(0, 68028, '\p{^Numeric_Value:	011/12}', "");
    Expect(0, 68028, '\P{Numeric_Value:	011/12}', "");
    Expect(1, 68028, '\P{^Numeric_Value:	011/12}', "");
    Expect(0, 68029, '\p{Numeric_Value:	011/12}', "");
    Expect(1, 68029, '\p{^Numeric_Value:	011/12}', "");
    Expect(1, 68029, '\P{Numeric_Value:	011/12}', "");
    Expect(0, 68029, '\P{^Numeric_Value:	011/12}', "");
    Expect(1, 68028, '\p{Numeric_Value=660/720}', "");
    Expect(0, 68028, '\p{^Numeric_Value=660/720}', "");
    Expect(0, 68028, '\P{Numeric_Value=660/720}', "");
    Expect(1, 68028, '\P{^Numeric_Value=660/720}', "");
    Expect(0, 68029, '\p{Numeric_Value=660/720}', "");
    Expect(1, 68029, '\p{^Numeric_Value=660/720}', "");
    Expect(1, 68029, '\P{Numeric_Value=660/720}', "");
    Expect(0, 68029, '\P{^Numeric_Value=660/720}', "");
    Error('\p{Numeric_Value=9.2e-01}');
    Error('\P{Numeric_Value=9.2e-01}');
    Error('\p{Numeric_Value:	0.9}');
    Error('\P{Numeric_Value:	0.9}');
    Error('\p{Numeric_Value=9.17e-01}');
    Error('\P{Numeric_Value=9.17e-01}');
    Error('\p{Numeric_Value=0.92}');
    Error('\P{Numeric_Value=0.92}');
    Expect(1, 68028, '\p{Numeric_Value=9.167e-01}', "");
    Expect(0, 68028, '\p{^Numeric_Value=9.167e-01}', "");
    Expect(0, 68028, '\P{Numeric_Value=9.167e-01}', "");
    Expect(1, 68028, '\P{^Numeric_Value=9.167e-01}', "");
    Expect(0, 68029, '\p{Numeric_Value=9.167e-01}', "");
    Expect(1, 68029, '\p{^Numeric_Value=9.167e-01}', "");
    Expect(1, 68029, '\P{Numeric_Value=9.167e-01}', "");
    Expect(0, 68029, '\P{^Numeric_Value=9.167e-01}', "");
    Error('\p{Numeric_Value: 0.917}');
    Error('\P{Numeric_Value: 0.917}');
    Expect(1, 68028, '\p{Numeric_Value=9.1667e-01}', "");
    Expect(0, 68028, '\p{^Numeric_Value=9.1667e-01}', "");
    Expect(0, 68028, '\P{Numeric_Value=9.1667e-01}', "");
    Expect(1, 68028, '\P{^Numeric_Value=9.1667e-01}', "");
    Expect(0, 68029, '\p{Numeric_Value=9.1667e-01}', "");
    Expect(1, 68029, '\p{^Numeric_Value=9.1667e-01}', "");
    Expect(1, 68029, '\P{Numeric_Value=9.1667e-01}', "");
    Expect(0, 68029, '\P{^Numeric_Value=9.1667e-01}', "");
    Expect(1, 68028, '\p{Numeric_Value=0.9167}', "");
    Expect(0, 68028, '\p{^Numeric_Value=0.9167}', "");
    Expect(0, 68028, '\P{Numeric_Value=0.9167}', "");
    Expect(1, 68028, '\P{^Numeric_Value=0.9167}', "");
    Expect(0, 68029, '\p{Numeric_Value=0.9167}', "");
    Expect(1, 68029, '\p{^Numeric_Value=0.9167}', "");
    Expect(1, 68029, '\P{Numeric_Value=0.9167}', "");
    Expect(0, 68029, '\P{^Numeric_Value=0.9167}', "");
    Expect(1, 68028, '\p{Numeric_Value=9.16667e-01}', "");
    Expect(0, 68028, '\p{^Numeric_Value=9.16667e-01}', "");
    Expect(0, 68028, '\P{Numeric_Value=9.16667e-01}', "");
    Expect(1, 68028, '\P{^Numeric_Value=9.16667e-01}', "");
    Expect(0, 68029, '\p{Numeric_Value=9.16667e-01}', "");
    Expect(1, 68029, '\p{^Numeric_Value=9.16667e-01}', "");
    Expect(1, 68029, '\P{Numeric_Value=9.16667e-01}', "");
    Expect(0, 68029, '\P{^Numeric_Value=9.16667e-01}', "");
    Expect(1, 68028, '\p{Numeric_Value=0.91667}', "");
    Expect(0, 68028, '\p{^Numeric_Value=0.91667}', "");
    Expect(0, 68028, '\P{Numeric_Value=0.91667}', "");
    Expect(1, 68028, '\P{^Numeric_Value=0.91667}', "");
    Expect(0, 68029, '\p{Numeric_Value=0.91667}', "");
    Expect(1, 68029, '\p{^Numeric_Value=0.91667}', "");
    Expect(1, 68029, '\P{Numeric_Value=0.91667}', "");
    Expect(0, 68029, '\P{^Numeric_Value=0.91667}', "");
    Error('\p{Nv=	/a/00000011/12}');
    Error('\P{Nv=	/a/00000011/12}');
    Expect(1, 68028, '\p{Nv=:\A11/12\z:}', "");;
    Expect(0, 68029, '\p{Nv=:\A11/12\z:}', "");;
    Expect(1, 68028, '\p{Nv=+00011/012}', "");
    Expect(0, 68028, '\p{^Nv=+00011/012}', "");
    Expect(0, 68028, '\P{Nv=+00011/012}', "");
    Expect(1, 68028, '\P{^Nv=+00011/012}', "");
    Expect(0, 68029, '\p{Nv=+00011/012}', "");
    Expect(1, 68029, '\p{^Nv=+00011/012}', "");
    Expect(1, 68029, '\P{Nv=+00011/012}', "");
    Expect(0, 68029, '\P{^Nv=+00011/012}', "");
    Expect(1, 68028, '\p{Nv=660/720}', "");
    Expect(0, 68028, '\p{^Nv=660/720}', "");
    Expect(0, 68028, '\P{Nv=660/720}', "");
    Expect(1, 68028, '\P{^Nv=660/720}', "");
    Expect(0, 68029, '\p{Nv=660/720}', "");
    Expect(1, 68029, '\p{^Nv=660/720}', "");
    Expect(1, 68029, '\P{Nv=660/720}', "");
    Expect(0, 68029, '\P{^Nv=660/720}', "");
    Error('\p{Nv=9.2e-01}');
    Error('\P{Nv=9.2e-01}');
    Error('\p{Nv:0.9}');
    Error('\P{Nv:0.9}');
    Error('\p{Nv=9.17e-01}');
    Error('\P{Nv=9.17e-01}');
    Error('\p{Nv=0.92}');
    Error('\P{Nv=0.92}');
    Expect(1, 68028, '\p{Nv:   9.167e-01}', "");
    Expect(0, 68028, '\p{^Nv:   9.167e-01}', "");
    Expect(0, 68028, '\P{Nv:   9.167e-01}', "");
    Expect(1, 68028, '\P{^Nv:   9.167e-01}', "");
    Expect(0, 68029, '\p{Nv:   9.167e-01}', "");
    Expect(1, 68029, '\p{^Nv:   9.167e-01}', "");
    Expect(1, 68029, '\P{Nv:   9.167e-01}', "");
    Expect(0, 68029, '\P{^Nv:   9.167e-01}', "");
    Error('\p{Nv=0.917}');
    Error('\P{Nv=0.917}');
    Expect(1, 68028, '\p{Nv=9.1667e-01}', "");
    Expect(0, 68028, '\p{^Nv=9.1667e-01}', "");
    Expect(0, 68028, '\P{Nv=9.1667e-01}', "");
    Expect(1, 68028, '\P{^Nv=9.1667e-01}', "");
    Expect(0, 68029, '\p{Nv=9.1667e-01}', "");
    Expect(1, 68029, '\p{^Nv=9.1667e-01}', "");
    Expect(1, 68029, '\P{Nv=9.1667e-01}', "");
    Expect(0, 68029, '\P{^Nv=9.1667e-01}', "");
    Expect(1, 68028, '\p{Nv=0.9167}', "");
    Expect(0, 68028, '\p{^Nv=0.9167}', "");
    Expect(0, 68028, '\P{Nv=0.9167}', "");
    Expect(1, 68028, '\P{^Nv=0.9167}', "");
    Expect(0, 68029, '\p{Nv=0.9167}', "");
    Expect(1, 68029, '\p{^Nv=0.9167}', "");
    Expect(1, 68029, '\P{Nv=0.9167}', "");
    Expect(0, 68029, '\P{^Nv=0.9167}', "");
    Expect(1, 68028, '\p{Nv: 9.16667e-01}', "");
    Expect(0, 68028, '\p{^Nv: 9.16667e-01}', "");
    Expect(0, 68028, '\P{Nv: 9.16667e-01}', "");
    Expect(1, 68028, '\P{^Nv: 9.16667e-01}', "");
    Expect(0, 68029, '\p{Nv: 9.16667e-01}', "");
    Expect(1, 68029, '\p{^Nv: 9.16667e-01}', "");
    Expect(1, 68029, '\P{Nv: 9.16667e-01}', "");
    Expect(0, 68029, '\P{^Nv: 9.16667e-01}', "");
    Expect(1, 68028, '\p{Nv=0.91667}', "");
    Expect(0, 68028, '\p{^Nv=0.91667}', "");
    Expect(0, 68028, '\P{Nv=0.91667}', "");
    Expect(1, 68028, '\P{^Nv=0.91667}', "");
    Expect(0, 68029, '\p{Nv=0.91667}', "");
    Expect(1, 68029, '\p{^Nv=0.91667}', "");
    Expect(1, 68029, '\P{Nv=0.91667}', "");
    Expect(0, 68029, '\P{^Nv=0.91667}', "");
    Error('\p{Is_Numeric_Value= _00011/0012:=}');
    Error('\P{Is_Numeric_Value= _00011/0012:=}');
    Expect(1, 68028, '\p{Is_Numeric_Value:   11/000012}', "");
    Expect(0, 68028, '\p{^Is_Numeric_Value:   11/000012}', "");
    Expect(0, 68028, '\P{Is_Numeric_Value:   11/000012}', "");
    Expect(1, 68028, '\P{^Is_Numeric_Value:   11/000012}', "");
    Expect(0, 68029, '\p{Is_Numeric_Value:   11/000012}', "");
    Expect(1, 68029, '\p{^Is_Numeric_Value:   11/000012}', "");
    Expect(1, 68029, '\P{Is_Numeric_Value:   11/000012}', "");
    Expect(0, 68029, '\P{^Is_Numeric_Value:   11/000012}', "");
    Expect(1, 68028, '\p{Is_Numeric_Value: 660/720}', "");
    Expect(0, 68028, '\p{^Is_Numeric_Value: 660/720}', "");
    Expect(0, 68028, '\P{Is_Numeric_Value: 660/720}', "");
    Expect(1, 68028, '\P{^Is_Numeric_Value: 660/720}', "");
    Expect(0, 68029, '\p{Is_Numeric_Value: 660/720}', "");
    Expect(1, 68029, '\p{^Is_Numeric_Value: 660/720}', "");
    Expect(1, 68029, '\P{Is_Numeric_Value: 660/720}', "");
    Expect(0, 68029, '\P{^Is_Numeric_Value: 660/720}', "");
    Error('\p{Is_Numeric_Value=9.2e-01}');
    Error('\P{Is_Numeric_Value=9.2e-01}');
    Error('\p{Is_Numeric_Value=0.9}');
    Error('\P{Is_Numeric_Value=0.9}');
    Error('\p{Is_Numeric_Value=9.17e-01}');
    Error('\P{Is_Numeric_Value=9.17e-01}');
    Error('\p{Is_Numeric_Value:	0.92}');
    Error('\P{Is_Numeric_Value:	0.92}');
    Expect(1, 68028, '\p{Is_Numeric_Value=9.167e-01}', "");
    Expect(0, 68028, '\p{^Is_Numeric_Value=9.167e-01}', "");
    Expect(0, 68028, '\P{Is_Numeric_Value=9.167e-01}', "");
    Expect(1, 68028, '\P{^Is_Numeric_Value=9.167e-01}', "");
    Expect(0, 68029, '\p{Is_Numeric_Value=9.167e-01}', "");
    Expect(1, 68029, '\p{^Is_Numeric_Value=9.167e-01}', "");
    Expect(1, 68029, '\P{Is_Numeric_Value=9.167e-01}', "");
    Expect(0, 68029, '\P{^Is_Numeric_Value=9.167e-01}', "");
    Error('\p{Is_Numeric_Value=0.917}');
    Error('\P{Is_Numeric_Value=0.917}');
    Expect(1, 68028, '\p{Is_Numeric_Value=9.1667e-01}', "");
    Expect(0, 68028, '\p{^Is_Numeric_Value=9.1667e-01}', "");
    Expect(0, 68028, '\P{Is_Numeric_Value=9.1667e-01}', "");
    Expect(1, 68028, '\P{^Is_Numeric_Value=9.1667e-01}', "");
    Expect(0, 68029, '\p{Is_Numeric_Value=9.1667e-01}', "");
    Expect(1, 68029, '\p{^Is_Numeric_Value=9.1667e-01}', "");
    Expect(1, 68029, '\P{Is_Numeric_Value=9.1667e-01}', "");
    Expect(0, 68029, '\P{^Is_Numeric_Value=9.1667e-01}', "");
    Expect(1, 68028, '\p{Is_Numeric_Value: 0.9167}', "");
    Expect(0, 68028, '\p{^Is_Numeric_Value: 0.9167}', "");
    Expect(0, 68028, '\P{Is_Numeric_Value: 0.9167}', "");
    Expect(1, 68028, '\P{^Is_Numeric_Value: 0.9167}', "");
    Expect(0, 68029, '\p{Is_Numeric_Value: 0.9167}', "");
    Expect(1, 68029, '\p{^Is_Numeric_Value: 0.9167}', "");
    Expect(1, 68029, '\P{Is_Numeric_Value: 0.9167}', "");
    Expect(0, 68029, '\P{^Is_Numeric_Value: 0.9167}', "");
    Expect(1, 68028, '\p{Is_Numeric_Value=9.16667e-01}', "");
    Expect(0, 68028, '\p{^Is_Numeric_Value=9.16667e-01}', "");
    Expect(0, 68028, '\P{Is_Numeric_Value=9.16667e-01}', "");
    Expect(1, 68028, '\P{^Is_Numeric_Value=9.16667e-01}', "");
    Expect(0, 68029, '\p{Is_Numeric_Value=9.16667e-01}', "");
    Expect(1, 68029, '\p{^Is_Numeric_Value=9.16667e-01}', "");
    Expect(1, 68029, '\P{Is_Numeric_Value=9.16667e-01}', "");
    Expect(0, 68029, '\P{^Is_Numeric_Value=9.16667e-01}', "");
    Expect(1, 68028, '\p{Is_Numeric_Value=0.91667}', "");
    Expect(0, 68028, '\p{^Is_Numeric_Value=0.91667}', "");
    Expect(0, 68028, '\P{Is_Numeric_Value=0.91667}', "");
    Expect(1, 68028, '\P{^Is_Numeric_Value=0.91667}', "");
    Expect(0, 68029, '\p{Is_Numeric_Value=0.91667}', "");
    Expect(1, 68029, '\p{^Is_Numeric_Value=0.91667}', "");
    Expect(1, 68029, '\P{Is_Numeric_Value=0.91667}', "");
    Expect(0, 68029, '\P{^Is_Numeric_Value=0.91667}', "");
    Error('\p{Is_Nv=__0011/000012:=}');
    Error('\P{Is_Nv=__0011/000012:=}');
    Expect(1, 68028, '\p{Is_Nv=000011/0012}', "");
    Expect(0, 68028, '\p{^Is_Nv=000011/0012}', "");
    Expect(0, 68028, '\P{Is_Nv=000011/0012}', "");
    Expect(1, 68028, '\P{^Is_Nv=000011/0012}', "");
    Expect(0, 68029, '\p{Is_Nv=000011/0012}', "");
    Expect(1, 68029, '\p{^Is_Nv=000011/0012}', "");
    Expect(1, 68029, '\P{Is_Nv=000011/0012}', "");
    Expect(0, 68029, '\P{^Is_Nv=000011/0012}', "");
    Expect(1, 68028, '\p{Is_Nv=660/720}', "");
    Expect(0, 68028, '\p{^Is_Nv=660/720}', "");
    Expect(0, 68028, '\P{Is_Nv=660/720}', "");
    Expect(1, 68028, '\P{^Is_Nv=660/720}', "");
    Expect(0, 68029, '\p{Is_Nv=660/720}', "");
    Expect(1, 68029, '\p{^Is_Nv=660/720}', "");
    Expect(1, 68029, '\P{Is_Nv=660/720}', "");
    Expect(0, 68029, '\P{^Is_Nv=660/720}', "");
    Error('\p{Is_Nv=9.2e-01}');
    Error('\P{Is_Nv=9.2e-01}');
    Error('\p{Is_Nv=0.9}');
    Error('\P{Is_Nv=0.9}');
    Error('\p{Is_Nv=9.17e-01}');
    Error('\P{Is_Nv=9.17e-01}');
    Error('\p{Is_Nv=0.92}');
    Error('\P{Is_Nv=0.92}');
    Expect(1, 68028, '\p{Is_Nv=9.167e-01}', "");
    Expect(0, 68028, '\p{^Is_Nv=9.167e-01}', "");
    Expect(0, 68028, '\P{Is_Nv=9.167e-01}', "");
    Expect(1, 68028, '\P{^Is_Nv=9.167e-01}', "");
    Expect(0, 68029, '\p{Is_Nv=9.167e-01}', "");
    Expect(1, 68029, '\p{^Is_Nv=9.167e-01}', "");
    Expect(1, 68029, '\P{Is_Nv=9.167e-01}', "");
    Expect(0, 68029, '\P{^Is_Nv=9.167e-01}', "");
    Error('\p{Is_Nv=0.917}');
    Error('\P{Is_Nv=0.917}');
    Expect(1, 68028, '\p{Is_Nv=9.1667e-01}', "");
    Expect(0, 68028, '\p{^Is_Nv=9.1667e-01}', "");
    Expect(0, 68028, '\P{Is_Nv=9.1667e-01}', "");
    Expect(1, 68028, '\P{^Is_Nv=9.1667e-01}', "");
    Expect(0, 68029, '\p{Is_Nv=9.1667e-01}', "");
    Expect(1, 68029, '\p{^Is_Nv=9.1667e-01}', "");
    Expect(1, 68029, '\P{Is_Nv=9.1667e-01}', "");
    Expect(0, 68029, '\P{^Is_Nv=9.1667e-01}', "");
    Expect(1, 68028, '\p{Is_Nv:0.9167}', "");
    Expect(0, 68028, '\p{^Is_Nv:0.9167}', "");
    Expect(0, 68028, '\P{Is_Nv:0.9167}', "");
    Expect(1, 68028, '\P{^Is_Nv:0.9167}', "");
    Expect(0, 68029, '\p{Is_Nv:0.9167}', "");
    Expect(1, 68029, '\p{^Is_Nv:0.9167}', "");
    Expect(1, 68029, '\P{Is_Nv:0.9167}', "");
    Expect(0, 68029, '\P{^Is_Nv:0.9167}', "");
    Expect(1, 68028, '\p{Is_Nv=9.16667e-01}', "");
    Expect(0, 68028, '\p{^Is_Nv=9.16667e-01}', "");
    Expect(0, 68028, '\P{Is_Nv=9.16667e-01}', "");
    Expect(1, 68028, '\P{^Is_Nv=9.16667e-01}', "");
    Expect(0, 68029, '\p{Is_Nv=9.16667e-01}', "");
    Expect(1, 68029, '\p{^Is_Nv=9.16667e-01}', "");
    Expect(1, 68029, '\P{Is_Nv=9.16667e-01}', "");
    Expect(0, 68029, '\P{^Is_Nv=9.16667e-01}', "");
    Expect(1, 68028, '\p{Is_Nv=0.91667}', "");
    Expect(0, 68028, '\p{^Is_Nv=0.91667}', "");
    Expect(0, 68028, '\P{Is_Nv=0.91667}', "");
    Expect(1, 68028, '\P{^Is_Nv=0.91667}', "");
    Expect(0, 68029, '\p{Is_Nv=0.91667}', "");
    Expect(1, 68029, '\p{^Is_Nv=0.91667}', "");
    Expect(1, 68029, '\P{Is_Nv=0.91667}', "");
    Expect(0, 68029, '\P{^Is_Nv=0.91667}', "");
    Error('\p{Numeric_Value:	-+00011/2/a/}');
    Error('\P{Numeric_Value:	-+00011/2/a/}');
    Expect(1, 3887, '\p{Numeric_Value=:\A11/2\z:}', "");;
    Expect(0, 3888, '\p{Numeric_Value=:\A11/2\z:}', "");;
    Expect(1, 3887, '\p{Numeric_Value=+0000000011/0000002}', "");
    Expect(0, 3887, '\p{^Numeric_Value=+0000000011/0000002}', "");
    Expect(0, 3887, '\P{Numeric_Value=+0000000011/0000002}', "");
    Expect(1, 3887, '\P{^Numeric_Value=+0000000011/0000002}', "");
    Expect(0, 3888, '\p{Numeric_Value=+0000000011/0000002}', "");
    Expect(1, 3888, '\p{^Numeric_Value=+0000000011/0000002}', "");
    Expect(1, 3888, '\P{Numeric_Value=+0000000011/0000002}', "");
    Expect(0, 3888, '\P{^Numeric_Value=+0000000011/0000002}', "");
    Expect(1, 3887, '\p{Numeric_Value=660/120}', "");
    Expect(0, 3887, '\p{^Numeric_Value=660/120}', "");
    Expect(0, 3887, '\P{Numeric_Value=660/120}', "");
    Expect(1, 3887, '\P{^Numeric_Value=660/120}', "");
    Expect(0, 3888, '\p{Numeric_Value=660/120}', "");
    Expect(1, 3888, '\p{^Numeric_Value=660/120}', "");
    Expect(1, 3888, '\P{Numeric_Value=660/120}', "");
    Expect(0, 3888, '\P{^Numeric_Value=660/120}', "");
    Expect(1, 3887, '\p{Numeric_Value=5.5e+00}', "");
    Expect(0, 3887, '\p{^Numeric_Value=5.5e+00}', "");
    Expect(0, 3887, '\P{Numeric_Value=5.5e+00}', "");
    Expect(1, 3887, '\P{^Numeric_Value=5.5e+00}', "");
    Expect(0, 3888, '\p{Numeric_Value=5.5e+00}', "");
    Expect(1, 3888, '\p{^Numeric_Value=5.5e+00}', "");
    Expect(1, 3888, '\P{Numeric_Value=5.5e+00}', "");
    Expect(0, 3888, '\P{^Numeric_Value=5.5e+00}', "");
    Expect(1, 3887, '\p{Numeric_Value=5.5}', "");
    Expect(0, 3887, '\p{^Numeric_Value=5.5}', "");
    Expect(0, 3887, '\P{Numeric_Value=5.5}', "");
    Expect(1, 3887, '\P{^Numeric_Value=5.5}', "");
    Expect(0, 3888, '\p{Numeric_Value=5.5}', "");
    Expect(1, 3888, '\p{^Numeric_Value=5.5}', "");
    Expect(1, 3888, '\P{Numeric_Value=5.5}', "");
    Expect(0, 3888, '\P{^Numeric_Value=5.5}', "");
    Expect(1, 3887, '\p{Numeric_Value=5.50e+00}', "");
    Expect(0, 3887, '\p{^Numeric_Value=5.50e+00}', "");
    Expect(0, 3887, '\P{Numeric_Value=5.50e+00}', "");
    Expect(1, 3887, '\P{^Numeric_Value=5.50e+00}', "");
    Expect(0, 3888, '\p{Numeric_Value=5.50e+00}', "");
    Expect(1, 3888, '\p{^Numeric_Value=5.50e+00}', "");
    Expect(1, 3888, '\P{Numeric_Value=5.50e+00}', "");
    Expect(0, 3888, '\P{^Numeric_Value=5.50e+00}', "");
    Expect(1, 3887, '\p{Numeric_Value=5.50}', "");
    Expect(0, 3887, '\p{^Numeric_Value=5.50}', "");
    Expect(0, 3887, '\P{Numeric_Value=5.50}', "");
    Expect(1, 3887, '\P{^Numeric_Value=5.50}', "");
    Expect(0, 3888, '\p{Numeric_Value=5.50}', "");
    Expect(1, 3888, '\p{^Numeric_Value=5.50}', "");
    Expect(1, 3888, '\P{Numeric_Value=5.50}', "");
    Expect(0, 3888, '\P{^Numeric_Value=5.50}', "");
    Error('\p{Nv=:= 11/000000002}');
    Error('\P{Nv=:= 11/000000002}');
    Expect(1, 3887, '\p{Nv=:\A11/2\z:}', "");;
    Expect(0, 3888, '\p{Nv=:\A11/2\z:}', "");;
    Expect(1, 3887, '\p{Nv=011/02}', "");
    Expect(0, 3887, '\p{^Nv=011/02}', "");
    Expect(0, 3887, '\P{Nv=011/02}', "");
    Expect(1, 3887, '\P{^Nv=011/02}', "");
    Expect(0, 3888, '\p{Nv=011/02}', "");
    Expect(1, 3888, '\p{^Nv=011/02}', "");
    Expect(1, 3888, '\P{Nv=011/02}', "");
    Expect(0, 3888, '\P{^Nv=011/02}', "");
    Expect(1, 3887, '\p{Nv=660/120}', "");
    Expect(0, 3887, '\p{^Nv=660/120}', "");
    Expect(0, 3887, '\P{Nv=660/120}', "");
    Expect(1, 3887, '\P{^Nv=660/120}', "");
    Expect(0, 3888, '\p{Nv=660/120}', "");
    Expect(1, 3888, '\p{^Nv=660/120}', "");
    Expect(1, 3888, '\P{Nv=660/120}', "");
    Expect(0, 3888, '\P{^Nv=660/120}', "");
    Expect(1, 3887, '\p{Nv=5.5e+00}', "");
    Expect(0, 3887, '\p{^Nv=5.5e+00}', "");
    Expect(0, 3887, '\P{Nv=5.5e+00}', "");
    Expect(1, 3887, '\P{^Nv=5.5e+00}', "");
    Expect(0, 3888, '\p{Nv=5.5e+00}', "");
    Expect(1, 3888, '\p{^Nv=5.5e+00}', "");
    Expect(1, 3888, '\P{Nv=5.5e+00}', "");
    Expect(0, 3888, '\P{^Nv=5.5e+00}', "");
    Expect(1, 3887, '\p{Nv=5.5}', "");
    Expect(0, 3887, '\p{^Nv=5.5}', "");
    Expect(0, 3887, '\P{Nv=5.5}', "");
    Expect(1, 3887, '\P{^Nv=5.5}', "");
    Expect(0, 3888, '\p{Nv=5.5}', "");
    Expect(1, 3888, '\p{^Nv=5.5}', "");
    Expect(1, 3888, '\P{Nv=5.5}', "");
    Expect(0, 3888, '\P{^Nv=5.5}', "");
    Expect(1, 3887, '\p{Nv=5.50e+00}', "");
    Expect(0, 3887, '\p{^Nv=5.50e+00}', "");
    Expect(0, 3887, '\P{Nv=5.50e+00}', "");
    Expect(1, 3887, '\P{^Nv=5.50e+00}', "");
    Expect(0, 3888, '\p{Nv=5.50e+00}', "");
    Expect(1, 3888, '\p{^Nv=5.50e+00}', "");
    Expect(1, 3888, '\P{Nv=5.50e+00}', "");
    Expect(0, 3888, '\P{^Nv=5.50e+00}', "");
    Expect(1, 3887, '\p{Nv: 5.50}', "");
    Expect(0, 3887, '\p{^Nv: 5.50}', "");
    Expect(0, 3887, '\P{Nv: 5.50}', "");
    Expect(1, 3887, '\P{^Nv: 5.50}', "");
    Expect(0, 3888, '\p{Nv: 5.50}', "");
    Expect(1, 3888, '\p{^Nv: 5.50}', "");
    Expect(1, 3888, '\P{Nv: 5.50}', "");
    Expect(0, 3888, '\P{^Nv: 5.50}', "");
    Error('\p{Is_Numeric_Value=-	+11/00000002:=}');
    Error('\P{Is_Numeric_Value=-	+11/00000002:=}');
    Expect(1, 3887, '\p{Is_Numeric_Value=+00000011/0000000002}', "");
    Expect(0, 3887, '\p{^Is_Numeric_Value=+00000011/0000000002}', "");
    Expect(0, 3887, '\P{Is_Numeric_Value=+00000011/0000000002}', "");
    Expect(1, 3887, '\P{^Is_Numeric_Value=+00000011/0000000002}', "");
    Expect(0, 3888, '\p{Is_Numeric_Value=+00000011/0000000002}', "");
    Expect(1, 3888, '\p{^Is_Numeric_Value=+00000011/0000000002}', "");
    Expect(1, 3888, '\P{Is_Numeric_Value=+00000011/0000000002}', "");
    Expect(0, 3888, '\P{^Is_Numeric_Value=+00000011/0000000002}', "");
    Expect(1, 3887, '\p{Is_Numeric_Value:	660/120}', "");
    Expect(0, 3887, '\p{^Is_Numeric_Value:	660/120}', "");
    Expect(0, 3887, '\P{Is_Numeric_Value:	660/120}', "");
    Expect(1, 3887, '\P{^Is_Numeric_Value:	660/120}', "");
    Expect(0, 3888, '\p{Is_Numeric_Value:	660/120}', "");
    Expect(1, 3888, '\p{^Is_Numeric_Value:	660/120}', "");
    Expect(1, 3888, '\P{Is_Numeric_Value:	660/120}', "");
    Expect(0, 3888, '\P{^Is_Numeric_Value:	660/120}', "");
    Expect(1, 3887, '\p{Is_Numeric_Value=5.5e+00}', "");
    Expect(0, 3887, '\p{^Is_Numeric_Value=5.5e+00}', "");
    Expect(0, 3887, '\P{Is_Numeric_Value=5.5e+00}', "");
    Expect(1, 3887, '\P{^Is_Numeric_Value=5.5e+00}', "");
    Expect(0, 3888, '\p{Is_Numeric_Value=5.5e+00}', "");
    Expect(1, 3888, '\p{^Is_Numeric_Value=5.5e+00}', "");
    Expect(1, 3888, '\P{Is_Numeric_Value=5.5e+00}', "");
    Expect(0, 3888, '\P{^Is_Numeric_Value=5.5e+00}', "");
    Expect(1, 3887, '\p{Is_Numeric_Value=5.5}', "");
    Expect(0, 3887, '\p{^Is_Numeric_Value=5.5}', "");
    Expect(0, 3887, '\P{Is_Numeric_Value=5.5}', "");
    Expect(1, 3887, '\P{^Is_Numeric_Value=5.5}', "");
    Expect(0, 3888, '\p{Is_Numeric_Value=5.5}', "");
    Expect(1, 3888, '\p{^Is_Numeric_Value=5.5}', "");
    Expect(1, 3888, '\P{Is_Numeric_Value=5.5}', "");
    Expect(0, 3888, '\P{^Is_Numeric_Value=5.5}', "");
    Expect(1, 3887, '\p{Is_Numeric_Value=5.50e+00}', "");
    Expect(0, 3887, '\p{^Is_Numeric_Value=5.50e+00}', "");
    Expect(0, 3887, '\P{Is_Numeric_Value=5.50e+00}', "");
    Expect(1, 3887, '\P{^Is_Numeric_Value=5.50e+00}', "");
    Expect(0, 3888, '\p{Is_Numeric_Value=5.50e+00}', "");
    Expect(1, 3888, '\p{^Is_Numeric_Value=5.50e+00}', "");
    Expect(1, 3888, '\P{Is_Numeric_Value=5.50e+00}', "");
    Expect(0, 3888, '\P{^Is_Numeric_Value=5.50e+00}', "");
    Expect(1, 3887, '\p{Is_Numeric_Value: 5.50}', "");
    Expect(0, 3887, '\p{^Is_Numeric_Value: 5.50}', "");
    Expect(0, 3887, '\P{Is_Numeric_Value: 5.50}', "");
    Expect(1, 3887, '\P{^Is_Numeric_Value: 5.50}', "");
    Expect(0, 3888, '\p{Is_Numeric_Value: 5.50}', "");
    Expect(1, 3888, '\p{^Is_Numeric_Value: 5.50}', "");
    Expect(1, 3888, '\P{Is_Numeric_Value: 5.50}', "");
    Expect(0, 3888, '\P{^Is_Numeric_Value: 5.50}', "");
    Error('\p{Is_Nv=:= 	00000011/002}');
    Error('\P{Is_Nv=:= 	00000011/002}');
    Expect(1, 3887, '\p{Is_Nv:	0011/0002}', "");
    Expect(0, 3887, '\p{^Is_Nv:	0011/0002}', "");
    Expect(0, 3887, '\P{Is_Nv:	0011/0002}', "");
    Expect(1, 3887, '\P{^Is_Nv:	0011/0002}', "");
    Expect(0, 3888, '\p{Is_Nv:	0011/0002}', "");
    Expect(1, 3888, '\p{^Is_Nv:	0011/0002}', "");
    Expect(1, 3888, '\P{Is_Nv:	0011/0002}', "");
    Expect(0, 3888, '\P{^Is_Nv:	0011/0002}', "");
    Expect(1, 3887, '\p{Is_Nv=660/120}', "");
    Expect(0, 3887, '\p{^Is_Nv=660/120}', "");
    Expect(0, 3887, '\P{Is_Nv=660/120}', "");
    Expect(1, 3887, '\P{^Is_Nv=660/120}', "");
    Expect(0, 3888, '\p{Is_Nv=660/120}', "");
    Expect(1, 3888, '\p{^Is_Nv=660/120}', "");
    Expect(1, 3888, '\P{Is_Nv=660/120}', "");
    Expect(0, 3888, '\P{^Is_Nv=660/120}', "");
    Expect(1, 3887, '\p{Is_Nv=5.5e+00}', "");
    Expect(0, 3887, '\p{^Is_Nv=5.5e+00}', "");
    Expect(0, 3887, '\P{Is_Nv=5.5e+00}', "");
    Expect(1, 3887, '\P{^Is_Nv=5.5e+00}', "");
    Expect(0, 3888, '\p{Is_Nv=5.5e+00}', "");
    Expect(1, 3888, '\p{^Is_Nv=5.5e+00}', "");
    Expect(1, 3888, '\P{Is_Nv=5.5e+00}', "");
    Expect(0, 3888, '\P{^Is_Nv=5.5e+00}', "");
    Expect(1, 3887, '\p{Is_Nv=5.5}', "");
    Expect(0, 3887, '\p{^Is_Nv=5.5}', "");
    Expect(0, 3887, '\P{Is_Nv=5.5}', "");
    Expect(1, 3887, '\P{^Is_Nv=5.5}', "");
    Expect(0, 3888, '\p{Is_Nv=5.5}', "");
    Expect(1, 3888, '\p{^Is_Nv=5.5}', "");
    Expect(1, 3888, '\P{Is_Nv=5.5}', "");
    Expect(0, 3888, '\P{^Is_Nv=5.5}', "");
    Expect(1, 3887, '\p{Is_Nv=5.50e+00}', "");
    Expect(0, 3887, '\p{^Is_Nv=5.50e+00}', "");
    Expect(0, 3887, '\P{Is_Nv=5.50e+00}', "");
    Expect(1, 3887, '\P{^Is_Nv=5.50e+00}', "");
    Expect(0, 3888, '\p{Is_Nv=5.50e+00}', "");
    Expect(1, 3888, '\p{^Is_Nv=5.50e+00}', "");
    Expect(1, 3888, '\P{Is_Nv=5.50e+00}', "");
    Expect(0, 3888, '\P{^Is_Nv=5.50e+00}', "");
    Expect(1, 3887, '\p{Is_Nv:5.50}', "");
    Expect(0, 3887, '\p{^Is_Nv:5.50}', "");
    Expect(0, 3887, '\P{Is_Nv:5.50}', "");
    Expect(1, 3887, '\P{^Is_Nv:5.50}', "");
    Expect(0, 3888, '\p{Is_Nv:5.50}', "");
    Expect(1, 3888, '\p{^Is_Nv:5.50}', "");
    Expect(1, 3888, '\P{Is_Nv:5.50}', "");
    Expect(0, 3888, '\P{^Is_Nv:5.50}', "");
    Error('\p{Numeric_Value= :=12}');
    Error('\P{Numeric_Value= :=12}');
    Expect(1, 119532, '\p{Numeric_Value=:\A12\z:}', "");;
    Expect(0, 119533, '\p{Numeric_Value=:\A12\z:}', "");;
    Expect(1, 119532, '\p{Numeric_Value=0000000012}', "");
    Expect(0, 119532, '\p{^Numeric_Value=0000000012}', "");
    Expect(0, 119532, '\P{Numeric_Value=0000000012}', "");
    Expect(1, 119532, '\P{^Numeric_Value=0000000012}', "");
    Expect(0, 119533, '\p{Numeric_Value=0000000012}', "");
    Expect(1, 119533, '\p{^Numeric_Value=0000000012}', "");
    Expect(1, 119533, '\P{Numeric_Value=0000000012}', "");
    Expect(0, 119533, '\P{^Numeric_Value=0000000012}', "");
    Expect(1, 119532, '\p{Numeric_Value=1.200000000000000e+01}', "");
    Expect(0, 119532, '\p{^Numeric_Value=1.200000000000000e+01}', "");
    Expect(0, 119532, '\P{Numeric_Value=1.200000000000000e+01}', "");
    Expect(1, 119532, '\P{^Numeric_Value=1.200000000000000e+01}', "");
    Expect(0, 119533, '\p{Numeric_Value=1.200000000000000e+01}', "");
    Expect(1, 119533, '\p{^Numeric_Value=1.200000000000000e+01}', "");
    Expect(1, 119533, '\P{Numeric_Value=1.200000000000000e+01}', "");
    Expect(0, 119533, '\P{^Numeric_Value=1.200000000000000e+01}', "");
    Error('\p{Nv=:=	_+00000000012}');
    Error('\P{Nv=:=	_+00000000012}');
    Expect(1, 119532, '\p{Nv=:\A12\z:}', "");;
    Expect(0, 119533, '\p{Nv=:\A12\z:}', "");;
    Expect(1, 119532, '\p{Nv=00001_2}', "");
    Expect(0, 119532, '\p{^Nv=00001_2}', "");
    Expect(0, 119532, '\P{Nv=00001_2}', "");
    Expect(1, 119532, '\P{^Nv=00001_2}', "");
    Expect(0, 119533, '\p{Nv=00001_2}', "");
    Expect(1, 119533, '\p{^Nv=00001_2}', "");
    Expect(1, 119533, '\P{Nv=00001_2}', "");
    Expect(0, 119533, '\P{^Nv=00001_2}', "");
    Expect(1, 119532, '\p{Nv=1.200000000000000e+01}', "");
    Expect(0, 119532, '\p{^Nv=1.200000000000000e+01}', "");
    Expect(0, 119532, '\P{Nv=1.200000000000000e+01}', "");
    Expect(1, 119532, '\P{^Nv=1.200000000000000e+01}', "");
    Expect(0, 119533, '\p{Nv=1.200000000000000e+01}', "");
    Expect(1, 119533, '\p{^Nv=1.200000000000000e+01}', "");
    Expect(1, 119533, '\P{Nv=1.200000000000000e+01}', "");
    Expect(0, 119533, '\P{^Nv=1.200000000000000e+01}', "");
    Error('\p{Is_Numeric_Value=:=		0000_0001_2}');
    Error('\P{Is_Numeric_Value=:=		0000_0001_2}');
    Expect(1, 119532, '\p{Is_Numeric_Value: 00012}', "");
    Expect(0, 119532, '\p{^Is_Numeric_Value: 00012}', "");
    Expect(0, 119532, '\P{Is_Numeric_Value: 00012}', "");
    Expect(1, 119532, '\P{^Is_Numeric_Value: 00012}', "");
    Expect(0, 119533, '\p{Is_Numeric_Value: 00012}', "");
    Expect(1, 119533, '\p{^Is_Numeric_Value: 00012}', "");
    Expect(1, 119533, '\P{Is_Numeric_Value: 00012}', "");
    Expect(0, 119533, '\P{^Is_Numeric_Value: 00012}', "");
    Expect(1, 119532, '\p{Is_Numeric_Value=1.200000000000000e+01}', "");
    Expect(0, 119532, '\p{^Is_Numeric_Value=1.200000000000000e+01}', "");
    Expect(0, 119532, '\P{Is_Numeric_Value=1.200000000000000e+01}', "");
    Expect(1, 119532, '\P{^Is_Numeric_Value=1.200000000000000e+01}', "");
    Expect(0, 119533, '\p{Is_Numeric_Value=1.200000000000000e+01}', "");
    Expect(1, 119533, '\p{^Is_Numeric_Value=1.200000000000000e+01}', "");
    Expect(1, 119533, '\P{Is_Numeric_Value=1.200000000000000e+01}', "");
    Expect(0, 119533, '\P{^Is_Numeric_Value=1.200000000000000e+01}', "");
    Error('\p{Is_Nv=/a/	+0_0_0_0_0012}');
    Error('\P{Is_Nv=/a/	+0_0_0_0_0012}');
    Expect(1, 119532, '\p{Is_Nv=+0012}', "");
    Expect(0, 119532, '\p{^Is_Nv=+0012}', "");
    Expect(0, 119532, '\P{Is_Nv=+0012}', "");
    Expect(1, 119532, '\P{^Is_Nv=+0012}', "");
    Expect(0, 119533, '\p{Is_Nv=+0012}', "");
    Expect(1, 119533, '\p{^Is_Nv=+0012}', "");
    Expect(1, 119533, '\P{Is_Nv=+0012}', "");
    Expect(0, 119533, '\P{^Is_Nv=+0012}', "");
    Expect(1, 119532, '\p{Is_Nv=1.200000000000000e+01}', "");
    Expect(0, 119532, '\p{^Is_Nv=1.200000000000000e+01}', "");
    Expect(0, 119532, '\P{Is_Nv=1.200000000000000e+01}', "");
    Expect(1, 119532, '\P{^Is_Nv=1.200000000000000e+01}', "");
    Expect(0, 119533, '\p{Is_Nv=1.200000000000000e+01}', "");
    Expect(1, 119533, '\p{^Is_Nv=1.200000000000000e+01}', "");
    Expect(1, 119533, '\P{Is_Nv=1.200000000000000e+01}', "");
    Expect(0, 119533, '\P{^Is_Nv=1.200000000000000e+01}', "");
    Error('\p{Numeric_Value: :=  000000013}');
    Error('\P{Numeric_Value: :=  000000013}');
    Expect(1, 119533, '\p{Numeric_Value=:\A13\z:}', "");;
    Expect(0, 119534, '\p{Numeric_Value=:\A13\z:}', "");;
    Expect(1, 119533, '\p{Numeric_Value=+0001_3}', "");
    Expect(0, 119533, '\p{^Numeric_Value=+0001_3}', "");
    Expect(0, 119533, '\P{Numeric_Value=+0001_3}', "");
    Expect(1, 119533, '\P{^Numeric_Value=+0001_3}', "");
    Expect(0, 119534, '\p{Numeric_Value=+0001_3}', "");
    Expect(1, 119534, '\p{^Numeric_Value=+0001_3}', "");
    Expect(1, 119534, '\P{Numeric_Value=+0001_3}', "");
    Expect(0, 119534, '\P{^Numeric_Value=+0001_3}', "");
    Expect(1, 119533, '\p{Numeric_Value=1.300000000000000e+01}', "");
    Expect(0, 119533, '\p{^Numeric_Value=1.300000000000000e+01}', "");
    Expect(0, 119533, '\P{Numeric_Value=1.300000000000000e+01}', "");
    Expect(1, 119533, '\P{^Numeric_Value=1.300000000000000e+01}', "");
    Expect(0, 119534, '\p{Numeric_Value=1.300000000000000e+01}', "");
    Expect(1, 119534, '\p{^Numeric_Value=1.300000000000000e+01}', "");
    Expect(1, 119534, '\P{Numeric_Value=1.300000000000000e+01}', "");
    Expect(0, 119534, '\P{^Numeric_Value=1.300000000000000e+01}', "");
    Error('\p{Nv=/a/000000001_3}');
    Error('\P{Nv=/a/000000001_3}');
    Expect(1, 119533, '\p{Nv=:\A13\z:}', "");;
    Expect(0, 119534, '\p{Nv=:\A13\z:}', "");;
    Expect(1, 119533, '\p{Nv=00001_3}', "");
    Expect(0, 119533, '\p{^Nv=00001_3}', "");
    Expect(0, 119533, '\P{Nv=00001_3}', "");
    Expect(1, 119533, '\P{^Nv=00001_3}', "");
    Expect(0, 119534, '\p{Nv=00001_3}', "");
    Expect(1, 119534, '\p{^Nv=00001_3}', "");
    Expect(1, 119534, '\P{Nv=00001_3}', "");
    Expect(0, 119534, '\P{^Nv=00001_3}', "");
    Expect(1, 119533, '\p{Nv=1.300000000000000e+01}', "");
    Expect(0, 119533, '\p{^Nv=1.300000000000000e+01}', "");
    Expect(0, 119533, '\P{Nv=1.300000000000000e+01}', "");
    Expect(1, 119533, '\P{^Nv=1.300000000000000e+01}', "");
    Expect(0, 119534, '\p{Nv=1.300000000000000e+01}', "");
    Expect(1, 119534, '\p{^Nv=1.300000000000000e+01}', "");
    Expect(1, 119534, '\P{Nv=1.300000000000000e+01}', "");
    Expect(0, 119534, '\P{^Nv=1.300000000000000e+01}', "");
    Error('\p{Is_Numeric_Value=:=-	+013}');
    Error('\P{Is_Numeric_Value=:=-	+013}');
    Expect(1, 119533, '\p{Is_Numeric_Value=+1_3}', "");
    Expect(0, 119533, '\p{^Is_Numeric_Value=+1_3}', "");
    Expect(0, 119533, '\P{Is_Numeric_Value=+1_3}', "");
    Expect(1, 119533, '\P{^Is_Numeric_Value=+1_3}', "");
    Expect(0, 119534, '\p{Is_Numeric_Value=+1_3}', "");
    Expect(1, 119534, '\p{^Is_Numeric_Value=+1_3}', "");
    Expect(1, 119534, '\P{Is_Numeric_Value=+1_3}', "");
    Expect(0, 119534, '\P{^Is_Numeric_Value=+1_3}', "");
    Expect(1, 119533, '\p{Is_Numeric_Value=1.300000000000000e+01}', "");
    Expect(0, 119533, '\p{^Is_Numeric_Value=1.300000000000000e+01}', "");
    Expect(0, 119533, '\P{Is_Numeric_Value=1.300000000000000e+01}', "");
    Expect(1, 119533, '\P{^Is_Numeric_Value=1.300000000000000e+01}', "");
    Expect(0, 119534, '\p{Is_Numeric_Value=1.300000000000000e+01}', "");
    Expect(1, 119534, '\p{^Is_Numeric_Value=1.300000000000000e+01}', "");
    Expect(1, 119534, '\P{Is_Numeric_Value=1.300000000000000e+01}', "");
    Expect(0, 119534, '\P{^Is_Numeric_Value=1.300000000000000e+01}', "");
    Error('\p{Is_Nv=/a/	_+0001_3}');
    Error('\P{Is_Nv=/a/	_+0001_3}');
    Expect(1, 119533, '\p{Is_Nv:00_01_3}', "");
    Expect(0, 119533, '\p{^Is_Nv:00_01_3}', "");
    Expect(0, 119533, '\P{Is_Nv:00_01_3}', "");
    Expect(1, 119533, '\P{^Is_Nv:00_01_3}', "");
    Expect(0, 119534, '\p{Is_Nv:00_01_3}', "");
    Expect(1, 119534, '\p{^Is_Nv:00_01_3}', "");
    Expect(1, 119534, '\P{Is_Nv:00_01_3}', "");
    Expect(0, 119534, '\P{^Is_Nv:00_01_3}', "");
    Expect(1, 119533, '\p{Is_Nv=1.300000000000000e+01}', "");
    Expect(0, 119533, '\p{^Is_Nv=1.300000000000000e+01}', "");
    Expect(0, 119533, '\P{Is_Nv=1.300000000000000e+01}', "");
    Expect(1, 119533, '\P{^Is_Nv=1.300000000000000e+01}', "");
    Expect(0, 119534, '\p{Is_Nv=1.300000000000000e+01}', "");
    Expect(1, 119534, '\p{^Is_Nv=1.300000000000000e+01}', "");
    Expect(1, 119534, '\P{Is_Nv=1.300000000000000e+01}', "");
    Expect(0, 119534, '\P{^Is_Nv=1.300000000000000e+01}', "");
    Error('\p{Numeric_Value=-/a/013/02}');
    Error('\P{Numeric_Value=-/a/013/02}');
    Expect(1, 3888, '\p{Numeric_Value=:\A13/2\z:}', "");;
    Expect(0, 3889, '\p{Numeric_Value=:\A13/2\z:}', "");;
    Expect(1, 3888, '\p{Numeric_Value:   00013/00002}', "");
    Expect(0, 3888, '\p{^Numeric_Value:   00013/00002}', "");
    Expect(0, 3888, '\P{Numeric_Value:   00013/00002}', "");
    Expect(1, 3888, '\P{^Numeric_Value:   00013/00002}', "");
    Expect(0, 3889, '\p{Numeric_Value:   00013/00002}', "");
    Expect(1, 3889, '\p{^Numeric_Value:   00013/00002}', "");
    Expect(1, 3889, '\P{Numeric_Value:   00013/00002}', "");
    Expect(0, 3889, '\P{^Numeric_Value:   00013/00002}', "");
    Expect(1, 3888, '\p{Numeric_Value=780/120}', "");
    Expect(0, 3888, '\p{^Numeric_Value=780/120}', "");
    Expect(0, 3888, '\P{Numeric_Value=780/120}', "");
    Expect(1, 3888, '\P{^Numeric_Value=780/120}', "");
    Expect(0, 3889, '\p{Numeric_Value=780/120}', "");
    Expect(1, 3889, '\p{^Numeric_Value=780/120}', "");
    Expect(1, 3889, '\P{Numeric_Value=780/120}', "");
    Expect(0, 3889, '\P{^Numeric_Value=780/120}', "");
    Expect(1, 3888, '\p{Numeric_Value=6.5e+00}', "");
    Expect(0, 3888, '\p{^Numeric_Value=6.5e+00}', "");
    Expect(0, 3888, '\P{Numeric_Value=6.5e+00}', "");
    Expect(1, 3888, '\P{^Numeric_Value=6.5e+00}', "");
    Expect(0, 3889, '\p{Numeric_Value=6.5e+00}', "");
    Expect(1, 3889, '\p{^Numeric_Value=6.5e+00}', "");
    Expect(1, 3889, '\P{Numeric_Value=6.5e+00}', "");
    Expect(0, 3889, '\P{^Numeric_Value=6.5e+00}', "");
    Expect(1, 3888, '\p{Numeric_Value=6.5}', "");
    Expect(0, 3888, '\p{^Numeric_Value=6.5}', "");
    Expect(0, 3888, '\P{Numeric_Value=6.5}', "");
    Expect(1, 3888, '\P{^Numeric_Value=6.5}', "");
    Expect(0, 3889, '\p{Numeric_Value=6.5}', "");
    Expect(1, 3889, '\p{^Numeric_Value=6.5}', "");
    Expect(1, 3889, '\P{Numeric_Value=6.5}', "");
    Expect(0, 3889, '\P{^Numeric_Value=6.5}', "");
    Expect(1, 3888, '\p{Numeric_Value=6.50e+00}', "");
    Expect(0, 3888, '\p{^Numeric_Value=6.50e+00}', "");
    Expect(0, 3888, '\P{Numeric_Value=6.50e+00}', "");
    Expect(1, 3888, '\P{^Numeric_Value=6.50e+00}', "");
    Expect(0, 3889, '\p{Numeric_Value=6.50e+00}', "");
    Expect(1, 3889, '\p{^Numeric_Value=6.50e+00}', "");
    Expect(1, 3889, '\P{Numeric_Value=6.50e+00}', "");
    Expect(0, 3889, '\P{^Numeric_Value=6.50e+00}', "");
    Expect(1, 3888, '\p{Numeric_Value=6.50}', "");
    Expect(0, 3888, '\p{^Numeric_Value=6.50}', "");
    Expect(0, 3888, '\P{Numeric_Value=6.50}', "");
    Expect(1, 3888, '\P{^Numeric_Value=6.50}', "");
    Expect(0, 3889, '\p{Numeric_Value=6.50}', "");
    Expect(1, 3889, '\p{^Numeric_Value=6.50}', "");
    Expect(1, 3889, '\P{Numeric_Value=6.50}', "");
    Expect(0, 3889, '\P{^Numeric_Value=6.50}', "");
    Error('\p{Nv=/a/-_000013/0002}');
    Error('\P{Nv=/a/-_000013/0002}');
    Expect(1, 3888, '\p{Nv=:\A13/2\z:}', "");;
    Expect(0, 3889, '\p{Nv=:\A13/2\z:}', "");;
    Expect(1, 3888, '\p{Nv:	0000013/00000002}', "");
    Expect(0, 3888, '\p{^Nv:	0000013/00000002}', "");
    Expect(0, 3888, '\P{Nv:	0000013/00000002}', "");
    Expect(1, 3888, '\P{^Nv:	0000013/00000002}', "");
    Expect(0, 3889, '\p{Nv:	0000013/00000002}', "");
    Expect(1, 3889, '\p{^Nv:	0000013/00000002}', "");
    Expect(1, 3889, '\P{Nv:	0000013/00000002}', "");
    Expect(0, 3889, '\P{^Nv:	0000013/00000002}', "");
    Expect(1, 3888, '\p{Nv=780/120}', "");
    Expect(0, 3888, '\p{^Nv=780/120}', "");
    Expect(0, 3888, '\P{Nv=780/120}', "");
    Expect(1, 3888, '\P{^Nv=780/120}', "");
    Expect(0, 3889, '\p{Nv=780/120}', "");
    Expect(1, 3889, '\p{^Nv=780/120}', "");
    Expect(1, 3889, '\P{Nv=780/120}', "");
    Expect(0, 3889, '\P{^Nv=780/120}', "");
    Expect(1, 3888, '\p{Nv:	6.5e+00}', "");
    Expect(0, 3888, '\p{^Nv:	6.5e+00}', "");
    Expect(0, 3888, '\P{Nv:	6.5e+00}', "");
    Expect(1, 3888, '\P{^Nv:	6.5e+00}', "");
    Expect(0, 3889, '\p{Nv:	6.5e+00}', "");
    Expect(1, 3889, '\p{^Nv:	6.5e+00}', "");
    Expect(1, 3889, '\P{Nv:	6.5e+00}', "");
    Expect(0, 3889, '\P{^Nv:	6.5e+00}', "");
    Expect(1, 3888, '\p{Nv=6.5}', "");
    Expect(0, 3888, '\p{^Nv=6.5}', "");
    Expect(0, 3888, '\P{Nv=6.5}', "");
    Expect(1, 3888, '\P{^Nv=6.5}', "");
    Expect(0, 3889, '\p{Nv=6.5}', "");
    Expect(1, 3889, '\p{^Nv=6.5}', "");
    Expect(1, 3889, '\P{Nv=6.5}', "");
    Expect(0, 3889, '\P{^Nv=6.5}', "");
    Expect(1, 3888, '\p{Nv=6.50e+00}', "");
    Expect(0, 3888, '\p{^Nv=6.50e+00}', "");
    Expect(0, 3888, '\P{Nv=6.50e+00}', "");
    Expect(1, 3888, '\P{^Nv=6.50e+00}', "");
    Expect(0, 3889, '\p{Nv=6.50e+00}', "");
    Expect(1, 3889, '\p{^Nv=6.50e+00}', "");
    Expect(1, 3889, '\P{Nv=6.50e+00}', "");
    Expect(0, 3889, '\P{^Nv=6.50e+00}', "");
    Expect(1, 3888, '\p{Nv=6.50}', "");
    Expect(0, 3888, '\p{^Nv=6.50}', "");
    Expect(0, 3888, '\P{Nv=6.50}', "");
    Expect(1, 3888, '\P{^Nv=6.50}', "");
    Expect(0, 3889, '\p{Nv=6.50}', "");
    Expect(1, 3889, '\p{^Nv=6.50}', "");
    Expect(1, 3889, '\P{Nv=6.50}', "");
    Expect(0, 3889, '\P{^Nv=6.50}', "");
    Error('\p{Is_Numeric_Value=/a/013/002}');
    Error('\P{Is_Numeric_Value=/a/013/002}');
    Expect(1, 3888, '\p{Is_Numeric_Value=+013/02}', "");
    Expect(0, 3888, '\p{^Is_Numeric_Value=+013/02}', "");
    Expect(0, 3888, '\P{Is_Numeric_Value=+013/02}', "");
    Expect(1, 3888, '\P{^Is_Numeric_Value=+013/02}', "");
    Expect(0, 3889, '\p{Is_Numeric_Value=+013/02}', "");
    Expect(1, 3889, '\p{^Is_Numeric_Value=+013/02}', "");
    Expect(1, 3889, '\P{Is_Numeric_Value=+013/02}', "");
    Expect(0, 3889, '\P{^Is_Numeric_Value=+013/02}', "");
    Expect(1, 3888, '\p{Is_Numeric_Value=780/120}', "");
    Expect(0, 3888, '\p{^Is_Numeric_Value=780/120}', "");
    Expect(0, 3888, '\P{Is_Numeric_Value=780/120}', "");
    Expect(1, 3888, '\P{^Is_Numeric_Value=780/120}', "");
    Expect(0, 3889, '\p{Is_Numeric_Value=780/120}', "");
    Expect(1, 3889, '\p{^Is_Numeric_Value=780/120}', "");
    Expect(1, 3889, '\P{Is_Numeric_Value=780/120}', "");
    Expect(0, 3889, '\P{^Is_Numeric_Value=780/120}', "");
    Expect(1, 3888, '\p{Is_Numeric_Value:   6.5e+00}', "");
    Expect(0, 3888, '\p{^Is_Numeric_Value:   6.5e+00}', "");
    Expect(0, 3888, '\P{Is_Numeric_Value:   6.5e+00}', "");
    Expect(1, 3888, '\P{^Is_Numeric_Value:   6.5e+00}', "");
    Expect(0, 3889, '\p{Is_Numeric_Value:   6.5e+00}', "");
    Expect(1, 3889, '\p{^Is_Numeric_Value:   6.5e+00}', "");
    Expect(1, 3889, '\P{Is_Numeric_Value:   6.5e+00}', "");
    Expect(0, 3889, '\P{^Is_Numeric_Value:   6.5e+00}', "");
    Expect(1, 3888, '\p{Is_Numeric_Value=6.5}', "");
    Expect(0, 3888, '\p{^Is_Numeric_Value=6.5}', "");
    Expect(0, 3888, '\P{Is_Numeric_Value=6.5}', "");
    Expect(1, 3888, '\P{^Is_Numeric_Value=6.5}', "");
    Expect(0, 3889, '\p{Is_Numeric_Value=6.5}', "");
    Expect(1, 3889, '\p{^Is_Numeric_Value=6.5}', "");
    Expect(1, 3889, '\P{Is_Numeric_Value=6.5}', "");
    Expect(0, 3889, '\P{^Is_Numeric_Value=6.5}', "");
    Expect(1, 3888, '\p{Is_Numeric_Value=6.50e+00}', "");
    Expect(0, 3888, '\p{^Is_Numeric_Value=6.50e+00}', "");
    Expect(0, 3888, '\P{Is_Numeric_Value=6.50e+00}', "");
    Expect(1, 3888, '\P{^Is_Numeric_Value=6.50e+00}', "");
    Expect(0, 3889, '\p{Is_Numeric_Value=6.50e+00}', "");
    Expect(1, 3889, '\p{^Is_Numeric_Value=6.50e+00}', "");
    Expect(1, 3889, '\P{Is_Numeric_Value=6.50e+00}', "");
    Expect(0, 3889, '\P{^Is_Numeric_Value=6.50e+00}', "");
    Expect(1, 3888, '\p{Is_Numeric_Value=6.50}', "");
    Expect(0, 3888, '\p{^Is_Numeric_Value=6.50}', "");
    Expect(0, 3888, '\P{Is_Numeric_Value=6.50}', "");
    Expect(1, 3888, '\P{^Is_Numeric_Value=6.50}', "");
    Expect(0, 3889, '\p{Is_Numeric_Value=6.50}', "");
    Expect(1, 3889, '\p{^Is_Numeric_Value=6.50}', "");
    Expect(1, 3889, '\P{Is_Numeric_Value=6.50}', "");
    Expect(0, 3889, '\P{^Is_Numeric_Value=6.50}', "");
    Error('\p{Is_Nv=_+013/0002/a/}');
    Error('\P{Is_Nv=_+013/0002/a/}');
    Expect(1, 3888, '\p{Is_Nv=00000000013/0000000002}', "");
    Expect(0, 3888, '\p{^Is_Nv=00000000013/0000000002}', "");
    Expect(0, 3888, '\P{Is_Nv=00000000013/0000000002}', "");
    Expect(1, 3888, '\P{^Is_Nv=00000000013/0000000002}', "");
    Expect(0, 3889, '\p{Is_Nv=00000000013/0000000002}', "");
    Expect(1, 3889, '\p{^Is_Nv=00000000013/0000000002}', "");
    Expect(1, 3889, '\P{Is_Nv=00000000013/0000000002}', "");
    Expect(0, 3889, '\P{^Is_Nv=00000000013/0000000002}', "");
    Expect(1, 3888, '\p{Is_Nv=780/120}', "");
    Expect(0, 3888, '\p{^Is_Nv=780/120}', "");
    Expect(0, 3888, '\P{Is_Nv=780/120}', "");
    Expect(1, 3888, '\P{^Is_Nv=780/120}', "");
    Expect(0, 3889, '\p{Is_Nv=780/120}', "");
    Expect(1, 3889, '\p{^Is_Nv=780/120}', "");
    Expect(1, 3889, '\P{Is_Nv=780/120}', "");
    Expect(0, 3889, '\P{^Is_Nv=780/120}', "");
    Expect(1, 3888, '\p{Is_Nv:	6.5e+00}', "");
    Expect(0, 3888, '\p{^Is_Nv:	6.5e+00}', "");
    Expect(0, 3888, '\P{Is_Nv:	6.5e+00}', "");
    Expect(1, 3888, '\P{^Is_Nv:	6.5e+00}', "");
    Expect(0, 3889, '\p{Is_Nv:	6.5e+00}', "");
    Expect(1, 3889, '\p{^Is_Nv:	6.5e+00}', "");
    Expect(1, 3889, '\P{Is_Nv:	6.5e+00}', "");
    Expect(0, 3889, '\P{^Is_Nv:	6.5e+00}', "");
    Expect(1, 3888, '\p{Is_Nv=6.5}', "");
    Expect(0, 3888, '\p{^Is_Nv=6.5}', "");
    Expect(0, 3888, '\P{Is_Nv=6.5}', "");
    Expect(1, 3888, '\P{^Is_Nv=6.5}', "");
    Expect(0, 3889, '\p{Is_Nv=6.5}', "");
    Expect(1, 3889, '\p{^Is_Nv=6.5}', "");
    Expect(1, 3889, '\P{Is_Nv=6.5}', "");
    Expect(0, 3889, '\P{^Is_Nv=6.5}', "");
    Expect(1, 3888, '\p{Is_Nv=6.50e+00}', "");
    Expect(0, 3888, '\p{^Is_Nv=6.50e+00}', "");
    Expect(0, 3888, '\P{Is_Nv=6.50e+00}', "");
    Expect(1, 3888, '\P{^Is_Nv=6.50e+00}', "");
    Expect(0, 3889, '\p{Is_Nv=6.50e+00}', "");
    Expect(1, 3889, '\p{^Is_Nv=6.50e+00}', "");
    Expect(1, 3889, '\P{Is_Nv=6.50e+00}', "");
    Expect(0, 3889, '\P{^Is_Nv=6.50e+00}', "");
    Expect(1, 3888, '\p{Is_Nv=6.50}', "");
    Expect(0, 3888, '\p{^Is_Nv=6.50}', "");
    Expect(0, 3888, '\P{Is_Nv=6.50}', "");
    Expect(1, 3888, '\P{^Is_Nv=6.50}', "");
    Expect(0, 3889, '\p{Is_Nv=6.50}', "");
    Expect(1, 3889, '\p{^Is_Nv=6.50}', "");
    Expect(1, 3889, '\P{Is_Nv=6.50}', "");
    Expect(0, 3889, '\P{^Is_Nv=6.50}', "");
    Error('\p{Numeric_Value=:=_0_0_0_0_0_0_014}');
    Error('\P{Numeric_Value=:=_0_0_0_0_0_0_014}');
    Expect(1, 119534, '\p{Numeric_Value=:\A14\z:}', "");;
    Expect(0, 119535, '\p{Numeric_Value=:\A14\z:}', "");;
    Expect(1, 119534, '\p{Numeric_Value=000014}', "");
    Expect(0, 119534, '\p{^Numeric_Value=000014}', "");
    Expect(0, 119534, '\P{Numeric_Value=000014}', "");
    Expect(1, 119534, '\P{^Numeric_Value=000014}', "");
    Expect(0, 119535, '\p{Numeric_Value=000014}', "");
    Expect(1, 119535, '\p{^Numeric_Value=000014}', "");
    Expect(1, 119535, '\P{Numeric_Value=000014}', "");
    Expect(0, 119535, '\P{^Numeric_Value=000014}', "");
    Expect(1, 119534, '\p{Numeric_Value=1.400000000000000e+01}', "");
    Expect(0, 119534, '\p{^Numeric_Value=1.400000000000000e+01}', "");
    Expect(0, 119534, '\P{Numeric_Value=1.400000000000000e+01}', "");
    Expect(1, 119534, '\P{^Numeric_Value=1.400000000000000e+01}', "");
    Expect(0, 119535, '\p{Numeric_Value=1.400000000000000e+01}', "");
    Expect(1, 119535, '\p{^Numeric_Value=1.400000000000000e+01}', "");
    Expect(1, 119535, '\P{Numeric_Value=1.400000000000000e+01}', "");
    Expect(0, 119535, '\P{^Numeric_Value=1.400000000000000e+01}', "");
    Error('\p{Nv=:=00000000014}');
    Error('\P{Nv=:=00000000014}');
    Expect(1, 119534, '\p{Nv=:\A14\z:}', "");;
    Expect(0, 119535, '\p{Nv=:\A14\z:}', "");;
    Expect(1, 119534, '\p{Nv=01_4}', "");
    Expect(0, 119534, '\p{^Nv=01_4}', "");
    Expect(0, 119534, '\P{Nv=01_4}', "");
    Expect(1, 119534, '\P{^Nv=01_4}', "");
    Expect(0, 119535, '\p{Nv=01_4}', "");
    Expect(1, 119535, '\p{^Nv=01_4}', "");
    Expect(1, 119535, '\P{Nv=01_4}', "");
    Expect(0, 119535, '\P{^Nv=01_4}', "");
    Expect(1, 119534, '\p{Nv=1.400000000000000e+01}', "");
    Expect(0, 119534, '\p{^Nv=1.400000000000000e+01}', "");
    Expect(0, 119534, '\P{Nv=1.400000000000000e+01}', "");
    Expect(1, 119534, '\P{^Nv=1.400000000000000e+01}', "");
    Expect(0, 119535, '\p{Nv=1.400000000000000e+01}', "");
    Expect(1, 119535, '\p{^Nv=1.400000000000000e+01}', "");
    Expect(1, 119535, '\P{Nv=1.400000000000000e+01}', "");
    Expect(0, 119535, '\P{^Nv=1.400000000000000e+01}', "");
    Error('\p{Is_Numeric_Value=	+00_00_01_4/a/}');
    Error('\P{Is_Numeric_Value=	+00_00_01_4/a/}');
    Expect(1, 119534, '\p{Is_Numeric_Value: 0_0_0_0_0014}', "");
    Expect(0, 119534, '\p{^Is_Numeric_Value: 0_0_0_0_0014}', "");
    Expect(0, 119534, '\P{Is_Numeric_Value: 0_0_0_0_0014}', "");
    Expect(1, 119534, '\P{^Is_Numeric_Value: 0_0_0_0_0014}', "");
    Expect(0, 119535, '\p{Is_Numeric_Value: 0_0_0_0_0014}', "");
    Expect(1, 119535, '\p{^Is_Numeric_Value: 0_0_0_0_0014}', "");
    Expect(1, 119535, '\P{Is_Numeric_Value: 0_0_0_0_0014}', "");
    Expect(0, 119535, '\P{^Is_Numeric_Value: 0_0_0_0_0014}', "");
    Expect(1, 119534, '\p{Is_Numeric_Value=1.400000000000000e+01}', "");
    Expect(0, 119534, '\p{^Is_Numeric_Value=1.400000000000000e+01}', "");
    Expect(0, 119534, '\P{Is_Numeric_Value=1.400000000000000e+01}', "");
    Expect(1, 119534, '\P{^Is_Numeric_Value=1.400000000000000e+01}', "");
    Expect(0, 119535, '\p{Is_Numeric_Value=1.400000000000000e+01}', "");
    Expect(1, 119535, '\p{^Is_Numeric_Value=1.400000000000000e+01}', "");
    Expect(1, 119535, '\P{Is_Numeric_Value=1.400000000000000e+01}', "");
    Expect(0, 119535, '\P{^Is_Numeric_Value=1.400000000000000e+01}', "");
    Error('\p{Is_Nv=	000000014:=}');
    Error('\P{Is_Nv=	000000014:=}');
    Expect(1, 119534, '\p{Is_Nv: 00_00_00_00_014}', "");
    Expect(0, 119534, '\p{^Is_Nv: 00_00_00_00_014}', "");
    Expect(0, 119534, '\P{Is_Nv: 00_00_00_00_014}', "");
    Expect(1, 119534, '\P{^Is_Nv: 00_00_00_00_014}', "");
    Expect(0, 119535, '\p{Is_Nv: 00_00_00_00_014}', "");
    Expect(1, 119535, '\p{^Is_Nv: 00_00_00_00_014}', "");
    Expect(1, 119535, '\P{Is_Nv: 00_00_00_00_014}', "");
    Expect(0, 119535, '\P{^Is_Nv: 00_00_00_00_014}', "");
    Expect(1, 119534, '\p{Is_Nv=1.400000000000000e+01}', "");
    Expect(0, 119534, '\p{^Is_Nv=1.400000000000000e+01}', "");
    Expect(0, 119534, '\P{Is_Nv=1.400000000000000e+01}', "");
    Expect(1, 119534, '\P{^Is_Nv=1.400000000000000e+01}', "");
    Expect(0, 119535, '\p{Is_Nv=1.400000000000000e+01}', "");
    Expect(1, 119535, '\p{^Is_Nv=1.400000000000000e+01}', "");
    Expect(1, 119535, '\P{Is_Nv=1.400000000000000e+01}', "");
    Expect(0, 119535, '\P{^Is_Nv=1.400000000000000e+01}', "");
    Error('\p{Numeric_Value=00_00_01_5:=}');
    Error('\P{Numeric_Value=00_00_01_5:=}');
    Expect(1, 119535, '\p{Numeric_Value=:\A15\z:}', "");;
    Expect(0, 119536, '\p{Numeric_Value=:\A15\z:}', "");;
    Expect(1, 119535, '\p{Numeric_Value=000000015}', "");
    Expect(0, 119535, '\p{^Numeric_Value=000000015}', "");
    Expect(0, 119535, '\P{Numeric_Value=000000015}', "");
    Expect(1, 119535, '\P{^Numeric_Value=000000015}', "");
    Expect(0, 119536, '\p{Numeric_Value=000000015}', "");
    Expect(1, 119536, '\p{^Numeric_Value=000000015}', "");
    Expect(1, 119536, '\P{Numeric_Value=000000015}', "");
    Expect(0, 119536, '\P{^Numeric_Value=000000015}', "");
    Expect(1, 119535, '\p{Numeric_Value=1.500000000000000e+01}', "");
    Expect(0, 119535, '\p{^Numeric_Value=1.500000000000000e+01}', "");
    Expect(0, 119535, '\P{Numeric_Value=1.500000000000000e+01}', "");
    Expect(1, 119535, '\P{^Numeric_Value=1.500000000000000e+01}', "");
    Expect(0, 119536, '\p{Numeric_Value=1.500000000000000e+01}', "");
    Expect(1, 119536, '\p{^Numeric_Value=1.500000000000000e+01}', "");
    Expect(1, 119536, '\P{Numeric_Value=1.500000000000000e+01}', "");
    Expect(0, 119536, '\P{^Numeric_Value=1.500000000000000e+01}', "");
    Error('\p{Nv:		/a/00_00_00_015}');
    Error('\P{Nv:		/a/00_00_00_015}');
    Expect(1, 119535, '\p{Nv=:\A15\z:}', "");;
    Expect(0, 119536, '\p{Nv=:\A15\z:}', "");;
    Expect(1, 119535, '\p{Nv=+15}', "");
    Expect(0, 119535, '\p{^Nv=+15}', "");
    Expect(0, 119535, '\P{Nv=+15}', "");
    Expect(1, 119535, '\P{^Nv=+15}', "");
    Expect(0, 119536, '\p{Nv=+15}', "");
    Expect(1, 119536, '\p{^Nv=+15}', "");
    Expect(1, 119536, '\P{Nv=+15}', "");
    Expect(0, 119536, '\P{^Nv=+15}', "");
    Expect(1, 119535, '\p{Nv=1.500000000000000e+01}', "");
    Expect(0, 119535, '\p{^Nv=1.500000000000000e+01}', "");
    Expect(0, 119535, '\P{Nv=1.500000000000000e+01}', "");
    Expect(1, 119535, '\P{^Nv=1.500000000000000e+01}', "");
    Expect(0, 119536, '\p{Nv=1.500000000000000e+01}', "");
    Expect(1, 119536, '\p{^Nv=1.500000000000000e+01}', "");
    Expect(1, 119536, '\P{Nv=1.500000000000000e+01}', "");
    Expect(0, 119536, '\P{^Nv=1.500000000000000e+01}', "");
    Error('\p{Is_Numeric_Value=:= 15}');
    Error('\P{Is_Numeric_Value=:= 15}');
    Expect(1, 119535, '\p{Is_Numeric_Value=+01_5}', "");
    Expect(0, 119535, '\p{^Is_Numeric_Value=+01_5}', "");
    Expect(0, 119535, '\P{Is_Numeric_Value=+01_5}', "");
    Expect(1, 119535, '\P{^Is_Numeric_Value=+01_5}', "");
    Expect(0, 119536, '\p{Is_Numeric_Value=+01_5}', "");
    Expect(1, 119536, '\p{^Is_Numeric_Value=+01_5}', "");
    Expect(1, 119536, '\P{Is_Numeric_Value=+01_5}', "");
    Expect(0, 119536, '\P{^Is_Numeric_Value=+01_5}', "");
    Expect(1, 119535, '\p{Is_Numeric_Value=1.500000000000000e+01}', "");
    Expect(0, 119535, '\p{^Is_Numeric_Value=1.500000000000000e+01}', "");
    Expect(0, 119535, '\P{Is_Numeric_Value=1.500000000000000e+01}', "");
    Expect(1, 119535, '\P{^Is_Numeric_Value=1.500000000000000e+01}', "");
    Expect(0, 119536, '\p{Is_Numeric_Value=1.500000000000000e+01}', "");
    Expect(1, 119536, '\p{^Is_Numeric_Value=1.500000000000000e+01}', "");
    Expect(1, 119536, '\P{Is_Numeric_Value=1.500000000000000e+01}', "");
    Expect(0, 119536, '\P{^Is_Numeric_Value=1.500000000000000e+01}', "");
    Error('\p{Is_Nv=_:=+0015}');
    Error('\P{Is_Nv=_:=+0015}');
    Expect(1, 119535, '\p{Is_Nv=+0_0_0_0_0015}', "");
    Expect(0, 119535, '\p{^Is_Nv=+0_0_0_0_0015}', "");
    Expect(0, 119535, '\P{Is_Nv=+0_0_0_0_0015}', "");
    Expect(1, 119535, '\P{^Is_Nv=+0_0_0_0_0015}', "");
    Expect(0, 119536, '\p{Is_Nv=+0_0_0_0_0015}', "");
    Expect(1, 119536, '\p{^Is_Nv=+0_0_0_0_0015}', "");
    Expect(1, 119536, '\P{Is_Nv=+0_0_0_0_0015}', "");
    Expect(0, 119536, '\P{^Is_Nv=+0_0_0_0_0015}', "");
    Expect(1, 119535, '\p{Is_Nv=1.500000000000000e+01}', "");
    Expect(0, 119535, '\p{^Is_Nv=1.500000000000000e+01}', "");
    Expect(0, 119535, '\P{Is_Nv=1.500000000000000e+01}', "");
    Expect(1, 119535, '\P{^Is_Nv=1.500000000000000e+01}', "");
    Expect(0, 119536, '\p{Is_Nv=1.500000000000000e+01}', "");
    Expect(1, 119536, '\p{^Is_Nv=1.500000000000000e+01}', "");
    Expect(1, 119536, '\P{Is_Nv=1.500000000000000e+01}', "");
    Expect(0, 119536, '\P{^Is_Nv=1.500000000000000e+01}', "");
    Error('\p{Numeric_Value: _00000015/0000002/a/}');
    Error('\P{Numeric_Value: _00000015/0000002/a/}');
    Expect(1, 3889, '\p{Numeric_Value=:\A15/2\z:}', "");;
    Expect(0, 3890, '\p{Numeric_Value=:\A15/2\z:}', "");;
    Expect(1, 3889, '\p{Numeric_Value:	0000000015/0000000002}', "");
    Expect(0, 3889, '\p{^Numeric_Value:	0000000015/0000000002}', "");
    Expect(0, 3889, '\P{Numeric_Value:	0000000015/0000000002}', "");
    Expect(1, 3889, '\P{^Numeric_Value:	0000000015/0000000002}', "");
    Expect(0, 3890, '\p{Numeric_Value:	0000000015/0000000002}', "");
    Expect(1, 3890, '\p{^Numeric_Value:	0000000015/0000000002}', "");
    Expect(1, 3890, '\P{Numeric_Value:	0000000015/0000000002}', "");
    Expect(0, 3890, '\P{^Numeric_Value:	0000000015/0000000002}', "");
    Expect(1, 3889, '\p{Numeric_Value=900/120}', "");
    Expect(0, 3889, '\p{^Numeric_Value=900/120}', "");
    Expect(0, 3889, '\P{Numeric_Value=900/120}', "");
    Expect(1, 3889, '\P{^Numeric_Value=900/120}', "");
    Expect(0, 3890, '\p{Numeric_Value=900/120}', "");
    Expect(1, 3890, '\p{^Numeric_Value=900/120}', "");
    Expect(1, 3890, '\P{Numeric_Value=900/120}', "");
    Expect(0, 3890, '\P{^Numeric_Value=900/120}', "");
    Expect(1, 3889, '\p{Numeric_Value=7.5e+00}', "");
    Expect(0, 3889, '\p{^Numeric_Value=7.5e+00}', "");
    Expect(0, 3889, '\P{Numeric_Value=7.5e+00}', "");
    Expect(1, 3889, '\P{^Numeric_Value=7.5e+00}', "");
    Expect(0, 3890, '\p{Numeric_Value=7.5e+00}', "");
    Expect(1, 3890, '\p{^Numeric_Value=7.5e+00}', "");
    Expect(1, 3890, '\P{Numeric_Value=7.5e+00}', "");
    Expect(0, 3890, '\P{^Numeric_Value=7.5e+00}', "");
    Expect(1, 3889, '\p{Numeric_Value=7.5}', "");
    Expect(0, 3889, '\p{^Numeric_Value=7.5}', "");
    Expect(0, 3889, '\P{Numeric_Value=7.5}', "");
    Expect(1, 3889, '\P{^Numeric_Value=7.5}', "");
    Expect(0, 3890, '\p{Numeric_Value=7.5}', "");
    Expect(1, 3890, '\p{^Numeric_Value=7.5}', "");
    Expect(1, 3890, '\P{Numeric_Value=7.5}', "");
    Expect(0, 3890, '\P{^Numeric_Value=7.5}', "");
    Expect(1, 3889, '\p{Numeric_Value=7.50e+00}', "");
    Expect(0, 3889, '\p{^Numeric_Value=7.50e+00}', "");
    Expect(0, 3889, '\P{Numeric_Value=7.50e+00}', "");
    Expect(1, 3889, '\P{^Numeric_Value=7.50e+00}', "");
    Expect(0, 3890, '\p{Numeric_Value=7.50e+00}', "");
    Expect(1, 3890, '\p{^Numeric_Value=7.50e+00}', "");
    Expect(1, 3890, '\P{Numeric_Value=7.50e+00}', "");
    Expect(0, 3890, '\P{^Numeric_Value=7.50e+00}', "");
    Expect(1, 3889, '\p{Numeric_Value=7.50}', "");
    Expect(0, 3889, '\p{^Numeric_Value=7.50}', "");
    Expect(0, 3889, '\P{Numeric_Value=7.50}', "");
    Expect(1, 3889, '\P{^Numeric_Value=7.50}', "");
    Expect(0, 3890, '\p{Numeric_Value=7.50}', "");
    Expect(1, 3890, '\p{^Numeric_Value=7.50}', "");
    Expect(1, 3890, '\P{Numeric_Value=7.50}', "");
    Expect(0, 3890, '\P{^Numeric_Value=7.50}', "");
    Error('\p{Nv=:=	+0015/002}');
    Error('\P{Nv=:=	+0015/002}');
    Expect(1, 3889, '\p{Nv=:\A15/2\z:}', "");;
    Expect(0, 3890, '\p{Nv=:\A15/2\z:}', "");;
    Expect(1, 3889, '\p{Nv=+000015/000002}', "");
    Expect(0, 3889, '\p{^Nv=+000015/000002}', "");
    Expect(0, 3889, '\P{Nv=+000015/000002}', "");
    Expect(1, 3889, '\P{^Nv=+000015/000002}', "");
    Expect(0, 3890, '\p{Nv=+000015/000002}', "");
    Expect(1, 3890, '\p{^Nv=+000015/000002}', "");
    Expect(1, 3890, '\P{Nv=+000015/000002}', "");
    Expect(0, 3890, '\P{^Nv=+000015/000002}', "");
    Expect(1, 3889, '\p{Nv=900/120}', "");
    Expect(0, 3889, '\p{^Nv=900/120}', "");
    Expect(0, 3889, '\P{Nv=900/120}', "");
    Expect(1, 3889, '\P{^Nv=900/120}', "");
    Expect(0, 3890, '\p{Nv=900/120}', "");
    Expect(1, 3890, '\p{^Nv=900/120}', "");
    Expect(1, 3890, '\P{Nv=900/120}', "");
    Expect(0, 3890, '\P{^Nv=900/120}', "");
    Expect(1, 3889, '\p{Nv=7.5e+00}', "");
    Expect(0, 3889, '\p{^Nv=7.5e+00}', "");
    Expect(0, 3889, '\P{Nv=7.5e+00}', "");
    Expect(1, 3889, '\P{^Nv=7.5e+00}', "");
    Expect(0, 3890, '\p{Nv=7.5e+00}', "");
    Expect(1, 3890, '\p{^Nv=7.5e+00}', "");
    Expect(1, 3890, '\P{Nv=7.5e+00}', "");
    Expect(0, 3890, '\P{^Nv=7.5e+00}', "");
    Expect(1, 3889, '\p{Nv=7.5}', "");
    Expect(0, 3889, '\p{^Nv=7.5}', "");
    Expect(0, 3889, '\P{Nv=7.5}', "");
    Expect(1, 3889, '\P{^Nv=7.5}', "");
    Expect(0, 3890, '\p{Nv=7.5}', "");
    Expect(1, 3890, '\p{^Nv=7.5}', "");
    Expect(1, 3890, '\P{Nv=7.5}', "");
    Expect(0, 3890, '\P{^Nv=7.5}', "");
    Expect(1, 3889, '\p{Nv=7.50e+00}', "");
    Expect(0, 3889, '\p{^Nv=7.50e+00}', "");
    Expect(0, 3889, '\P{Nv=7.50e+00}', "");
    Expect(1, 3889, '\P{^Nv=7.50e+00}', "");
    Expect(0, 3890, '\p{Nv=7.50e+00}', "");
    Expect(1, 3890, '\p{^Nv=7.50e+00}', "");
    Expect(1, 3890, '\P{Nv=7.50e+00}', "");
    Expect(0, 3890, '\P{^Nv=7.50e+00}', "");
    Expect(1, 3889, '\p{Nv=7.50}', "");
    Expect(0, 3889, '\p{^Nv=7.50}', "");
    Expect(0, 3889, '\P{Nv=7.50}', "");
    Expect(1, 3889, '\P{^Nv=7.50}', "");
    Expect(0, 3890, '\p{Nv=7.50}', "");
    Expect(1, 3890, '\p{^Nv=7.50}', "");
    Expect(1, 3890, '\P{Nv=7.50}', "");
    Expect(0, 3890, '\P{^Nv=7.50}', "");
    Error('\p{Is_Numeric_Value=_:=00000015/0000002}');
    Error('\P{Is_Numeric_Value=_:=00000015/0000002}');
    Expect(1, 3889, '\p{Is_Numeric_Value:015/0002}', "");
    Expect(0, 3889, '\p{^Is_Numeric_Value:015/0002}', "");
    Expect(0, 3889, '\P{Is_Numeric_Value:015/0002}', "");
    Expect(1, 3889, '\P{^Is_Numeric_Value:015/0002}', "");
    Expect(0, 3890, '\p{Is_Numeric_Value:015/0002}', "");
    Expect(1, 3890, '\p{^Is_Numeric_Value:015/0002}', "");
    Expect(1, 3890, '\P{Is_Numeric_Value:015/0002}', "");
    Expect(0, 3890, '\P{^Is_Numeric_Value:015/0002}', "");
    Expect(1, 3889, '\p{Is_Numeric_Value=900/120}', "");
    Expect(0, 3889, '\p{^Is_Numeric_Value=900/120}', "");
    Expect(0, 3889, '\P{Is_Numeric_Value=900/120}', "");
    Expect(1, 3889, '\P{^Is_Numeric_Value=900/120}', "");
    Expect(0, 3890, '\p{Is_Numeric_Value=900/120}', "");
    Expect(1, 3890, '\p{^Is_Numeric_Value=900/120}', "");
    Expect(1, 3890, '\P{Is_Numeric_Value=900/120}', "");
    Expect(0, 3890, '\P{^Is_Numeric_Value=900/120}', "");
    Expect(1, 3889, '\p{Is_Numeric_Value=7.5e+00}', "");
    Expect(0, 3889, '\p{^Is_Numeric_Value=7.5e+00}', "");
    Expect(0, 3889, '\P{Is_Numeric_Value=7.5e+00}', "");
    Expect(1, 3889, '\P{^Is_Numeric_Value=7.5e+00}', "");
    Expect(0, 3890, '\p{Is_Numeric_Value=7.5e+00}', "");
    Expect(1, 3890, '\p{^Is_Numeric_Value=7.5e+00}', "");
    Expect(1, 3890, '\P{Is_Numeric_Value=7.5e+00}', "");
    Expect(0, 3890, '\P{^Is_Numeric_Value=7.5e+00}', "");
    Expect(1, 3889, '\p{Is_Numeric_Value=7.5}', "");
    Expect(0, 3889, '\p{^Is_Numeric_Value=7.5}', "");
    Expect(0, 3889, '\P{Is_Numeric_Value=7.5}', "");
    Expect(1, 3889, '\P{^Is_Numeric_Value=7.5}', "");
    Expect(0, 3890, '\p{Is_Numeric_Value=7.5}', "");
    Expect(1, 3890, '\p{^Is_Numeric_Value=7.5}', "");
    Expect(1, 3890, '\P{Is_Numeric_Value=7.5}', "");
    Expect(0, 3890, '\P{^Is_Numeric_Value=7.5}', "");
    Expect(1, 3889, '\p{Is_Numeric_Value=7.50e+00}', "");
    Expect(0, 3889, '\p{^Is_Numeric_Value=7.50e+00}', "");
    Expect(0, 3889, '\P{Is_Numeric_Value=7.50e+00}', "");
    Expect(1, 3889, '\P{^Is_Numeric_Value=7.50e+00}', "");
    Expect(0, 3890, '\p{Is_Numeric_Value=7.50e+00}', "");
    Expect(1, 3890, '\p{^Is_Numeric_Value=7.50e+00}', "");
    Expect(1, 3890, '\P{Is_Numeric_Value=7.50e+00}', "");
    Expect(0, 3890, '\P{^Is_Numeric_Value=7.50e+00}', "");
    Expect(1, 3889, '\p{Is_Numeric_Value=7.50}', "");
    Expect(0, 3889, '\p{^Is_Numeric_Value=7.50}', "");
    Expect(0, 3889, '\P{Is_Numeric_Value=7.50}', "");
    Expect(1, 3889, '\P{^Is_Numeric_Value=7.50}', "");
    Expect(0, 3890, '\p{Is_Numeric_Value=7.50}', "");
    Expect(1, 3890, '\p{^Is_Numeric_Value=7.50}', "");
    Expect(1, 3890, '\P{Is_Numeric_Value=7.50}', "");
    Expect(0, 3890, '\P{^Is_Numeric_Value=7.50}', "");
    Error('\p{Is_Nv=:=	-15/002}');
    Error('\P{Is_Nv=:=	-15/002}');
    Expect(1, 3889, '\p{Is_Nv=00000000015/002}', "");
    Expect(0, 3889, '\p{^Is_Nv=00000000015/002}', "");
    Expect(0, 3889, '\P{Is_Nv=00000000015/002}', "");
    Expect(1, 3889, '\P{^Is_Nv=00000000015/002}', "");
    Expect(0, 3890, '\p{Is_Nv=00000000015/002}', "");
    Expect(1, 3890, '\p{^Is_Nv=00000000015/002}', "");
    Expect(1, 3890, '\P{Is_Nv=00000000015/002}', "");
    Expect(0, 3890, '\P{^Is_Nv=00000000015/002}', "");
    Expect(1, 3889, '\p{Is_Nv=900/120}', "");
    Expect(0, 3889, '\p{^Is_Nv=900/120}', "");
    Expect(0, 3889, '\P{Is_Nv=900/120}', "");
    Expect(1, 3889, '\P{^Is_Nv=900/120}', "");
    Expect(0, 3890, '\p{Is_Nv=900/120}', "");
    Expect(1, 3890, '\p{^Is_Nv=900/120}', "");
    Expect(1, 3890, '\P{Is_Nv=900/120}', "");
    Expect(0, 3890, '\P{^Is_Nv=900/120}', "");
    Expect(1, 3889, '\p{Is_Nv=7.5e+00}', "");
    Expect(0, 3889, '\p{^Is_Nv=7.5e+00}', "");
    Expect(0, 3889, '\P{Is_Nv=7.5e+00}', "");
    Expect(1, 3889, '\P{^Is_Nv=7.5e+00}', "");
    Expect(0, 3890, '\p{Is_Nv=7.5e+00}', "");
    Expect(1, 3890, '\p{^Is_Nv=7.5e+00}', "");
    Expect(1, 3890, '\P{Is_Nv=7.5e+00}', "");
    Expect(0, 3890, '\P{^Is_Nv=7.5e+00}', "");
    Expect(1, 3889, '\p{Is_Nv=7.5}', "");
    Expect(0, 3889, '\p{^Is_Nv=7.5}', "");
    Expect(0, 3889, '\P{Is_Nv=7.5}', "");
    Expect(1, 3889, '\P{^Is_Nv=7.5}', "");
    Expect(0, 3890, '\p{Is_Nv=7.5}', "");
    Expect(1, 3890, '\p{^Is_Nv=7.5}', "");
    Expect(1, 3890, '\P{Is_Nv=7.5}', "");
    Expect(0, 3890, '\P{^Is_Nv=7.5}', "");
    Expect(1, 3889, '\p{Is_Nv=7.50e+00}', "");
    Expect(0, 3889, '\p{^Is_Nv=7.50e+00}', "");
    Expect(0, 3889, '\P{Is_Nv=7.50e+00}', "");
    Expect(1, 3889, '\P{^Is_Nv=7.50e+00}', "");
    Expect(0, 3890, '\p{Is_Nv=7.50e+00}', "");
    Expect(1, 3890, '\p{^Is_Nv=7.50e+00}', "");
    Expect(1, 3890, '\P{Is_Nv=7.50e+00}', "");
    Expect(0, 3890, '\P{^Is_Nv=7.50e+00}', "");
    Expect(1, 3889, '\p{Is_Nv=7.50}', "");
    Expect(0, 3889, '\p{^Is_Nv=7.50}', "");
    Expect(0, 3889, '\P{Is_Nv=7.50}', "");
    Expect(1, 3889, '\P{^Is_Nv=7.50}', "");
    Expect(0, 3890, '\p{Is_Nv=7.50}', "");
    Expect(1, 3890, '\p{^Is_Nv=7.50}', "");
    Expect(1, 3890, '\P{Is_Nv=7.50}', "");
    Expect(0, 3890, '\P{^Is_Nv=7.50}', "");
    Error('\p{Numeric_Value=:=16}');
    Error('\P{Numeric_Value=:=16}');
    Expect(1, 119536, '\p{Numeric_Value=:\A16\z:}', "");;
    Expect(0, 119537, '\p{Numeric_Value=:\A16\z:}', "");;
    Expect(1, 119536, '\p{Numeric_Value=0000016}', "");
    Expect(0, 119536, '\p{^Numeric_Value=0000016}', "");
    Expect(0, 119536, '\P{Numeric_Value=0000016}', "");
    Expect(1, 119536, '\P{^Numeric_Value=0000016}', "");
    Expect(0, 119537, '\p{Numeric_Value=0000016}', "");
    Expect(1, 119537, '\p{^Numeric_Value=0000016}', "");
    Expect(1, 119537, '\P{Numeric_Value=0000016}', "");
    Expect(0, 119537, '\P{^Numeric_Value=0000016}', "");
    Expect(1, 119536, '\p{Numeric_Value=1.600000000000000e+01}', "");
    Expect(0, 119536, '\p{^Numeric_Value=1.600000000000000e+01}', "");
    Expect(0, 119536, '\P{Numeric_Value=1.600000000000000e+01}', "");
    Expect(1, 119536, '\P{^Numeric_Value=1.600000000000000e+01}', "");
    Expect(0, 119537, '\p{Numeric_Value=1.600000000000000e+01}', "");
    Expect(1, 119537, '\p{^Numeric_Value=1.600000000000000e+01}', "");
    Expect(1, 119537, '\P{Numeric_Value=1.600000000000000e+01}', "");
    Expect(0, 119537, '\P{^Numeric_Value=1.600000000000000e+01}', "");
    Error('\p{Nv=:=  0001_6}');
    Error('\P{Nv=:=  0001_6}');
    Expect(1, 119536, '\p{Nv=:\A16\z:}', "");;
    Expect(0, 119537, '\p{Nv=:\A16\z:}', "");;
    Expect(1, 119536, '\p{Nv=+000_000_16}', "");
    Expect(0, 119536, '\p{^Nv=+000_000_16}', "");
    Expect(0, 119536, '\P{Nv=+000_000_16}', "");
    Expect(1, 119536, '\P{^Nv=+000_000_16}', "");
    Expect(0, 119537, '\p{Nv=+000_000_16}', "");
    Expect(1, 119537, '\p{^Nv=+000_000_16}', "");
    Expect(1, 119537, '\P{Nv=+000_000_16}', "");
    Expect(0, 119537, '\P{^Nv=+000_000_16}', "");
    Expect(1, 119536, '\p{Nv=1.600000000000000e+01}', "");
    Expect(0, 119536, '\p{^Nv=1.600000000000000e+01}', "");
    Expect(0, 119536, '\P{Nv=1.600000000000000e+01}', "");
    Expect(1, 119536, '\P{^Nv=1.600000000000000e+01}', "");
    Expect(0, 119537, '\p{Nv=1.600000000000000e+01}', "");
    Expect(1, 119537, '\p{^Nv=1.600000000000000e+01}', "");
    Expect(1, 119537, '\P{Nv=1.600000000000000e+01}', "");
    Expect(0, 119537, '\P{^Nv=1.600000000000000e+01}', "");
    Error('\p{Is_Numeric_Value=:=0_0_0_0_016}');
    Error('\P{Is_Numeric_Value=:=0_0_0_0_016}');
    Expect(1, 119536, '\p{Is_Numeric_Value=0016}', "");
    Expect(0, 119536, '\p{^Is_Numeric_Value=0016}', "");
    Expect(0, 119536, '\P{Is_Numeric_Value=0016}', "");
    Expect(1, 119536, '\P{^Is_Numeric_Value=0016}', "");
    Expect(0, 119537, '\p{Is_Numeric_Value=0016}', "");
    Expect(1, 119537, '\p{^Is_Numeric_Value=0016}', "");
    Expect(1, 119537, '\P{Is_Numeric_Value=0016}', "");
    Expect(0, 119537, '\P{^Is_Numeric_Value=0016}', "");
    Expect(1, 119536, '\p{Is_Numeric_Value=1.600000000000000e+01}', "");
    Expect(0, 119536, '\p{^Is_Numeric_Value=1.600000000000000e+01}', "");
    Expect(0, 119536, '\P{Is_Numeric_Value=1.600000000000000e+01}', "");
    Expect(1, 119536, '\P{^Is_Numeric_Value=1.600000000000000e+01}', "");
    Expect(0, 119537, '\p{Is_Numeric_Value=1.600000000000000e+01}', "");
    Expect(1, 119537, '\p{^Is_Numeric_Value=1.600000000000000e+01}', "");
    Expect(1, 119537, '\P{Is_Numeric_Value=1.600000000000000e+01}', "");
    Expect(0, 119537, '\P{^Is_Numeric_Value=1.600000000000000e+01}', "");
    Error('\p{Is_Nv=/a/--1_6}');
    Error('\P{Is_Nv=/a/--1_6}');
    Expect(1, 119536, '\p{Is_Nv:   0000016}', "");
    Expect(0, 119536, '\p{^Is_Nv:   0000016}', "");
    Expect(0, 119536, '\P{Is_Nv:   0000016}', "");
    Expect(1, 119536, '\P{^Is_Nv:   0000016}', "");
    Expect(0, 119537, '\p{Is_Nv:   0000016}', "");
    Expect(1, 119537, '\p{^Is_Nv:   0000016}', "");
    Expect(1, 119537, '\P{Is_Nv:   0000016}', "");
    Expect(0, 119537, '\P{^Is_Nv:   0000016}', "");
    Expect(1, 119536, '\p{Is_Nv=1.600000000000000e+01}', "");
    Expect(0, 119536, '\p{^Is_Nv=1.600000000000000e+01}', "");
    Expect(0, 119536, '\P{Is_Nv=1.600000000000000e+01}', "");
    Expect(1, 119536, '\P{^Is_Nv=1.600000000000000e+01}', "");
    Expect(0, 119537, '\p{Is_Nv=1.600000000000000e+01}', "");
    Expect(1, 119537, '\p{^Is_Nv=1.600000000000000e+01}', "");
    Expect(1, 119537, '\P{Is_Nv=1.600000000000000e+01}', "");
    Expect(0, 119537, '\P{^Is_Nv=1.600000000000000e+01}', "");
    Error('\p{Numeric_Value=/a/_0_0_0_0_0_0_0_17}');
    Error('\P{Numeric_Value=/a/_0_0_0_0_0_0_0_17}');
    Expect(1, 119537, '\p{Numeric_Value=:\A17\z:}', "");;
    Expect(0, 119538, '\p{Numeric_Value=:\A17\z:}', "");;
    Expect(1, 119537, '\p{Numeric_Value=0_0_0_0_0_0017}', "");
    Expect(0, 119537, '\p{^Numeric_Value=0_0_0_0_0_0017}', "");
    Expect(0, 119537, '\P{Numeric_Value=0_0_0_0_0_0017}', "");
    Expect(1, 119537, '\P{^Numeric_Value=0_0_0_0_0_0017}', "");
    Expect(0, 119538, '\p{Numeric_Value=0_0_0_0_0_0017}', "");
    Expect(1, 119538, '\p{^Numeric_Value=0_0_0_0_0_0017}', "");
    Expect(1, 119538, '\P{Numeric_Value=0_0_0_0_0_0017}', "");
    Expect(0, 119538, '\P{^Numeric_Value=0_0_0_0_0_0017}', "");
    Expect(1, 119537, '\p{Numeric_Value=1.700000000000000e+01}', "");
    Expect(0, 119537, '\p{^Numeric_Value=1.700000000000000e+01}', "");
    Expect(0, 119537, '\P{Numeric_Value=1.700000000000000e+01}', "");
    Expect(1, 119537, '\P{^Numeric_Value=1.700000000000000e+01}', "");
    Expect(0, 119538, '\p{Numeric_Value=1.700000000000000e+01}', "");
    Expect(1, 119538, '\p{^Numeric_Value=1.700000000000000e+01}', "");
    Expect(1, 119538, '\P{Numeric_Value=1.700000000000000e+01}', "");
    Expect(0, 119538, '\P{^Numeric_Value=1.700000000000000e+01}', "");
    Error('\p{Nv=_	0_0_0_0_0_0_0017/a/}');
    Error('\P{Nv=_	0_0_0_0_0_0_0017/a/}');
    Expect(1, 119537, '\p{Nv=:\A17\z:}', "");;
    Expect(0, 119538, '\p{Nv=:\A17\z:}', "");;
    Expect(1, 119537, '\p{Nv=00000_00001_7}', "");
    Expect(0, 119537, '\p{^Nv=00000_00001_7}', "");
    Expect(0, 119537, '\P{Nv=00000_00001_7}', "");
    Expect(1, 119537, '\P{^Nv=00000_00001_7}', "");
    Expect(0, 119538, '\p{Nv=00000_00001_7}', "");
    Expect(1, 119538, '\p{^Nv=00000_00001_7}', "");
    Expect(1, 119538, '\P{Nv=00000_00001_7}', "");
    Expect(0, 119538, '\P{^Nv=00000_00001_7}', "");
    Expect(1, 119537, '\p{Nv=1.700000000000000e+01}', "");
    Expect(0, 119537, '\p{^Nv=1.700000000000000e+01}', "");
    Expect(0, 119537, '\P{Nv=1.700000000000000e+01}', "");
    Expect(1, 119537, '\P{^Nv=1.700000000000000e+01}', "");
    Expect(0, 119538, '\p{Nv=1.700000000000000e+01}', "");
    Expect(1, 119538, '\p{^Nv=1.700000000000000e+01}', "");
    Expect(1, 119538, '\P{Nv=1.700000000000000e+01}', "");
    Expect(0, 119538, '\P{^Nv=1.700000000000000e+01}', "");
    Error('\p{Is_Numeric_Value=_:=+0_0_0_0_0_0_0_0_0_17}');
    Error('\P{Is_Numeric_Value=_:=+0_0_0_0_0_0_0_0_0_17}');
    Expect(1, 119537, '\p{Is_Numeric_Value=+17}', "");
    Expect(0, 119537, '\p{^Is_Numeric_Value=+17}', "");
    Expect(0, 119537, '\P{Is_Numeric_Value=+17}', "");
    Expect(1, 119537, '\P{^Is_Numeric_Value=+17}', "");
    Expect(0, 119538, '\p{Is_Numeric_Value=+17}', "");
    Expect(1, 119538, '\p{^Is_Numeric_Value=+17}', "");
    Expect(1, 119538, '\P{Is_Numeric_Value=+17}', "");
    Expect(0, 119538, '\P{^Is_Numeric_Value=+17}', "");
    Expect(1, 119537, '\p{Is_Numeric_Value: 1.700000000000000e+01}', "");
    Expect(0, 119537, '\p{^Is_Numeric_Value: 1.700000000000000e+01}', "");
    Expect(0, 119537, '\P{Is_Numeric_Value: 1.700000000000000e+01}', "");
    Expect(1, 119537, '\P{^Is_Numeric_Value: 1.700000000000000e+01}', "");
    Expect(0, 119538, '\p{Is_Numeric_Value: 1.700000000000000e+01}', "");
    Expect(1, 119538, '\p{^Is_Numeric_Value: 1.700000000000000e+01}', "");
    Expect(1, 119538, '\P{Is_Numeric_Value: 1.700000000000000e+01}', "");
    Expect(0, 119538, '\P{^Is_Numeric_Value: 1.700000000000000e+01}', "");
    Error('\p{Is_Nv=_/a/00_00_01_7}');
    Error('\P{Is_Nv=_/a/00_00_01_7}');
    Expect(1, 119537, '\p{Is_Nv=00000017}', "");
    Expect(0, 119537, '\p{^Is_Nv=00000017}', "");
    Expect(0, 119537, '\P{Is_Nv=00000017}', "");
    Expect(1, 119537, '\P{^Is_Nv=00000017}', "");
    Expect(0, 119538, '\p{Is_Nv=00000017}', "");
    Expect(1, 119538, '\p{^Is_Nv=00000017}', "");
    Expect(1, 119538, '\P{Is_Nv=00000017}', "");
    Expect(0, 119538, '\P{^Is_Nv=00000017}', "");
    Expect(1, 119537, '\p{Is_Nv=1.700000000000000e+01}', "");
    Expect(0, 119537, '\p{^Is_Nv=1.700000000000000e+01}', "");
    Expect(0, 119537, '\P{Is_Nv=1.700000000000000e+01}', "");
    Expect(1, 119537, '\P{^Is_Nv=1.700000000000000e+01}', "");
    Expect(0, 119538, '\p{Is_Nv=1.700000000000000e+01}', "");
    Expect(1, 119538, '\p{^Is_Nv=1.700000000000000e+01}', "");
    Expect(1, 119538, '\P{Is_Nv=1.700000000000000e+01}', "");
    Expect(0, 119538, '\P{^Is_Nv=1.700000000000000e+01}', "");
    Error('\p{Numeric_Value=- +000000017/0002/a/}');
    Error('\P{Numeric_Value=- +000000017/0002/a/}');
    Expect(1, 3890, '\p{Numeric_Value=:\A17/2\z:}', "");;
    Expect(0, 3891, '\p{Numeric_Value=:\A17/2\z:}', "");;
    Expect(1, 3890, '\p{Numeric_Value=0000000017/002}', "");
    Expect(0, 3890, '\p{^Numeric_Value=0000000017/002}', "");
    Expect(0, 3890, '\P{Numeric_Value=0000000017/002}', "");
    Expect(1, 3890, '\P{^Numeric_Value=0000000017/002}', "");
    Expect(0, 3891, '\p{Numeric_Value=0000000017/002}', "");
    Expect(1, 3891, '\p{^Numeric_Value=0000000017/002}', "");
    Expect(1, 3891, '\P{Numeric_Value=0000000017/002}', "");
    Expect(0, 3891, '\P{^Numeric_Value=0000000017/002}', "");
    Expect(1, 3890, '\p{Numeric_Value=1020/120}', "");
    Expect(0, 3890, '\p{^Numeric_Value=1020/120}', "");
    Expect(0, 3890, '\P{Numeric_Value=1020/120}', "");
    Expect(1, 3890, '\P{^Numeric_Value=1020/120}', "");
    Expect(0, 3891, '\p{Numeric_Value=1020/120}', "");
    Expect(1, 3891, '\p{^Numeric_Value=1020/120}', "");
    Expect(1, 3891, '\P{Numeric_Value=1020/120}', "");
    Expect(0, 3891, '\P{^Numeric_Value=1020/120}', "");
    Expect(1, 3890, '\p{Numeric_Value: 8.5e+00}', "");
    Expect(0, 3890, '\p{^Numeric_Value: 8.5e+00}', "");
    Expect(0, 3890, '\P{Numeric_Value: 8.5e+00}', "");
    Expect(1, 3890, '\P{^Numeric_Value: 8.5e+00}', "");
    Expect(0, 3891, '\p{Numeric_Value: 8.5e+00}', "");
    Expect(1, 3891, '\p{^Numeric_Value: 8.5e+00}', "");
    Expect(1, 3891, '\P{Numeric_Value: 8.5e+00}', "");
    Expect(0, 3891, '\P{^Numeric_Value: 8.5e+00}', "");
    Expect(1, 3890, '\p{Numeric_Value=8.5}', "");
    Expect(0, 3890, '\p{^Numeric_Value=8.5}', "");
    Expect(0, 3890, '\P{Numeric_Value=8.5}', "");
    Expect(1, 3890, '\P{^Numeric_Value=8.5}', "");
    Expect(0, 3891, '\p{Numeric_Value=8.5}', "");
    Expect(1, 3891, '\p{^Numeric_Value=8.5}', "");
    Expect(1, 3891, '\P{Numeric_Value=8.5}', "");
    Expect(0, 3891, '\P{^Numeric_Value=8.5}', "");
    Expect(1, 3890, '\p{Numeric_Value=8.50e+00}', "");
    Expect(0, 3890, '\p{^Numeric_Value=8.50e+00}', "");
    Expect(0, 3890, '\P{Numeric_Value=8.50e+00}', "");
    Expect(1, 3890, '\P{^Numeric_Value=8.50e+00}', "");
    Expect(0, 3891, '\p{Numeric_Value=8.50e+00}', "");
    Expect(1, 3891, '\p{^Numeric_Value=8.50e+00}', "");
    Expect(1, 3891, '\P{Numeric_Value=8.50e+00}', "");
    Expect(0, 3891, '\P{^Numeric_Value=8.50e+00}', "");
    Expect(1, 3890, '\p{Numeric_Value: 8.50}', "");
    Expect(0, 3890, '\p{^Numeric_Value: 8.50}', "");
    Expect(0, 3890, '\P{Numeric_Value: 8.50}', "");
    Expect(1, 3890, '\P{^Numeric_Value: 8.50}', "");
    Expect(0, 3891, '\p{Numeric_Value: 8.50}', "");
    Expect(1, 3891, '\p{^Numeric_Value: 8.50}', "");
    Expect(1, 3891, '\P{Numeric_Value: 8.50}', "");
    Expect(0, 3891, '\P{^Numeric_Value: 8.50}', "");
    Error('\p{Nv=:=	0017/0000000002}');
    Error('\P{Nv=:=	0017/0000000002}');
    Expect(1, 3890, '\p{Nv=:\A17/2\z:}', "");;
    Expect(0, 3891, '\p{Nv=:\A17/2\z:}', "");;
    Expect(1, 3890, '\p{Nv=00000000017/000000002}', "");
    Expect(0, 3890, '\p{^Nv=00000000017/000000002}', "");
    Expect(0, 3890, '\P{Nv=00000000017/000000002}', "");
    Expect(1, 3890, '\P{^Nv=00000000017/000000002}', "");
    Expect(0, 3891, '\p{Nv=00000000017/000000002}', "");
    Expect(1, 3891, '\p{^Nv=00000000017/000000002}', "");
    Expect(1, 3891, '\P{Nv=00000000017/000000002}', "");
    Expect(0, 3891, '\P{^Nv=00000000017/000000002}', "");
    Expect(1, 3890, '\p{Nv=1020/120}', "");
    Expect(0, 3890, '\p{^Nv=1020/120}', "");
    Expect(0, 3890, '\P{Nv=1020/120}', "");
    Expect(1, 3890, '\P{^Nv=1020/120}', "");
    Expect(0, 3891, '\p{Nv=1020/120}', "");
    Expect(1, 3891, '\p{^Nv=1020/120}', "");
    Expect(1, 3891, '\P{Nv=1020/120}', "");
    Expect(0, 3891, '\P{^Nv=1020/120}', "");
    Expect(1, 3890, '\p{Nv=8.5e+00}', "");
    Expect(0, 3890, '\p{^Nv=8.5e+00}', "");
    Expect(0, 3890, '\P{Nv=8.5e+00}', "");
    Expect(1, 3890, '\P{^Nv=8.5e+00}', "");
    Expect(0, 3891, '\p{Nv=8.5e+00}', "");
    Expect(1, 3891, '\p{^Nv=8.5e+00}', "");
    Expect(1, 3891, '\P{Nv=8.5e+00}', "");
    Expect(0, 3891, '\P{^Nv=8.5e+00}', "");
    Expect(1, 3890, '\p{Nv=8.5}', "");
    Expect(0, 3890, '\p{^Nv=8.5}', "");
    Expect(0, 3890, '\P{Nv=8.5}', "");
    Expect(1, 3890, '\P{^Nv=8.5}', "");
    Expect(0, 3891, '\p{Nv=8.5}', "");
    Expect(1, 3891, '\p{^Nv=8.5}', "");
    Expect(1, 3891, '\P{Nv=8.5}', "");
    Expect(0, 3891, '\P{^Nv=8.5}', "");
    Expect(1, 3890, '\p{Nv=8.50e+00}', "");
    Expect(0, 3890, '\p{^Nv=8.50e+00}', "");
    Expect(0, 3890, '\P{Nv=8.50e+00}', "");
    Expect(1, 3890, '\P{^Nv=8.50e+00}', "");
    Expect(0, 3891, '\p{Nv=8.50e+00}', "");
    Expect(1, 3891, '\p{^Nv=8.50e+00}', "");
    Expect(1, 3891, '\P{Nv=8.50e+00}', "");
    Expect(0, 3891, '\P{^Nv=8.50e+00}', "");
    Expect(1, 3890, '\p{Nv=8.50}', "");
    Expect(0, 3890, '\p{^Nv=8.50}', "");
    Expect(0, 3890, '\P{Nv=8.50}', "");
    Expect(1, 3890, '\P{^Nv=8.50}', "");
    Expect(0, 3891, '\p{Nv=8.50}', "");
    Expect(1, 3891, '\p{^Nv=8.50}', "");
    Expect(1, 3891, '\P{Nv=8.50}', "");
    Expect(0, 3891, '\P{^Nv=8.50}', "");
    Error('\p{Is_Numeric_Value=/a/_0017/0002}');
    Error('\P{Is_Numeric_Value=/a/_0017/0002}');
    Expect(1, 3890, '\p{Is_Numeric_Value=0000000017/00000002}', "");
    Expect(0, 3890, '\p{^Is_Numeric_Value=0000000017/00000002}', "");
    Expect(0, 3890, '\P{Is_Numeric_Value=0000000017/00000002}', "");
    Expect(1, 3890, '\P{^Is_Numeric_Value=0000000017/00000002}', "");
    Expect(0, 3891, '\p{Is_Numeric_Value=0000000017/00000002}', "");
    Expect(1, 3891, '\p{^Is_Numeric_Value=0000000017/00000002}', "");
    Expect(1, 3891, '\P{Is_Numeric_Value=0000000017/00000002}', "");
    Expect(0, 3891, '\P{^Is_Numeric_Value=0000000017/00000002}', "");
    Expect(1, 3890, '\p{Is_Numeric_Value:   1020/120}', "");
    Expect(0, 3890, '\p{^Is_Numeric_Value:   1020/120}', "");
    Expect(0, 3890, '\P{Is_Numeric_Value:   1020/120}', "");
    Expect(1, 3890, '\P{^Is_Numeric_Value:   1020/120}', "");
    Expect(0, 3891, '\p{Is_Numeric_Value:   1020/120}', "");
    Expect(1, 3891, '\p{^Is_Numeric_Value:   1020/120}', "");
    Expect(1, 3891, '\P{Is_Numeric_Value:   1020/120}', "");
    Expect(0, 3891, '\P{^Is_Numeric_Value:   1020/120}', "");
    Expect(1, 3890, '\p{Is_Numeric_Value=8.5e+00}', "");
    Expect(0, 3890, '\p{^Is_Numeric_Value=8.5e+00}', "");
    Expect(0, 3890, '\P{Is_Numeric_Value=8.5e+00}', "");
    Expect(1, 3890, '\P{^Is_Numeric_Value=8.5e+00}', "");
    Expect(0, 3891, '\p{Is_Numeric_Value=8.5e+00}', "");
    Expect(1, 3891, '\p{^Is_Numeric_Value=8.5e+00}', "");
    Expect(1, 3891, '\P{Is_Numeric_Value=8.5e+00}', "");
    Expect(0, 3891, '\P{^Is_Numeric_Value=8.5e+00}', "");
    Expect(1, 3890, '\p{Is_Numeric_Value=8.5}', "");
    Expect(0, 3890, '\p{^Is_Numeric_Value=8.5}', "");
    Expect(0, 3890, '\P{Is_Numeric_Value=8.5}', "");
    Expect(1, 3890, '\P{^Is_Numeric_Value=8.5}', "");
    Expect(0, 3891, '\p{Is_Numeric_Value=8.5}', "");
    Expect(1, 3891, '\p{^Is_Numeric_Value=8.5}', "");
    Expect(1, 3891, '\P{Is_Numeric_Value=8.5}', "");
    Expect(0, 3891, '\P{^Is_Numeric_Value=8.5}', "");
    Expect(1, 3890, '\p{Is_Numeric_Value=8.50e+00}', "");
    Expect(0, 3890, '\p{^Is_Numeric_Value=8.50e+00}', "");
    Expect(0, 3890, '\P{Is_Numeric_Value=8.50e+00}', "");
    Expect(1, 3890, '\P{^Is_Numeric_Value=8.50e+00}', "");
    Expect(0, 3891, '\p{Is_Numeric_Value=8.50e+00}', "");
    Expect(1, 3891, '\p{^Is_Numeric_Value=8.50e+00}', "");
    Expect(1, 3891, '\P{Is_Numeric_Value=8.50e+00}', "");
    Expect(0, 3891, '\P{^Is_Numeric_Value=8.50e+00}', "");
    Expect(1, 3890, '\p{Is_Numeric_Value=8.50}', "");
    Expect(0, 3890, '\p{^Is_Numeric_Value=8.50}', "");
    Expect(0, 3890, '\P{Is_Numeric_Value=8.50}', "");
    Expect(1, 3890, '\P{^Is_Numeric_Value=8.50}', "");
    Expect(0, 3891, '\p{Is_Numeric_Value=8.50}', "");
    Expect(1, 3891, '\p{^Is_Numeric_Value=8.50}', "");
    Expect(1, 3891, '\P{Is_Numeric_Value=8.50}', "");
    Expect(0, 3891, '\P{^Is_Numeric_Value=8.50}', "");
    Error('\p{Is_Nv=:=	_0000017/2}');
    Error('\P{Is_Nv=:=	_0000017/2}');
    Expect(1, 3890, '\p{Is_Nv=00000000017/002}', "");
    Expect(0, 3890, '\p{^Is_Nv=00000000017/002}', "");
    Expect(0, 3890, '\P{Is_Nv=00000000017/002}', "");
    Expect(1, 3890, '\P{^Is_Nv=00000000017/002}', "");
    Expect(0, 3891, '\p{Is_Nv=00000000017/002}', "");
    Expect(1, 3891, '\p{^Is_Nv=00000000017/002}', "");
    Expect(1, 3891, '\P{Is_Nv=00000000017/002}', "");
    Expect(0, 3891, '\P{^Is_Nv=00000000017/002}', "");
    Expect(1, 3890, '\p{Is_Nv=1020/120}', "");
    Expect(0, 3890, '\p{^Is_Nv=1020/120}', "");
    Expect(0, 3890, '\P{Is_Nv=1020/120}', "");
    Expect(1, 3890, '\P{^Is_Nv=1020/120}', "");
    Expect(0, 3891, '\p{Is_Nv=1020/120}', "");
    Expect(1, 3891, '\p{^Is_Nv=1020/120}', "");
    Expect(1, 3891, '\P{Is_Nv=1020/120}', "");
    Expect(0, 3891, '\P{^Is_Nv=1020/120}', "");
    Expect(1, 3890, '\p{Is_Nv=8.5e+00}', "");
    Expect(0, 3890, '\p{^Is_Nv=8.5e+00}', "");
    Expect(0, 3890, '\P{Is_Nv=8.5e+00}', "");
    Expect(1, 3890, '\P{^Is_Nv=8.5e+00}', "");
    Expect(0, 3891, '\p{Is_Nv=8.5e+00}', "");
    Expect(1, 3891, '\p{^Is_Nv=8.5e+00}', "");
    Expect(1, 3891, '\P{Is_Nv=8.5e+00}', "");
    Expect(0, 3891, '\P{^Is_Nv=8.5e+00}', "");
    Expect(1, 3890, '\p{Is_Nv=8.5}', "");
    Expect(0, 3890, '\p{^Is_Nv=8.5}', "");
    Expect(0, 3890, '\P{Is_Nv=8.5}', "");
    Expect(1, 3890, '\P{^Is_Nv=8.5}', "");
    Expect(0, 3891, '\p{Is_Nv=8.5}', "");
    Expect(1, 3891, '\p{^Is_Nv=8.5}', "");
    Expect(1, 3891, '\P{Is_Nv=8.5}', "");
    Expect(0, 3891, '\P{^Is_Nv=8.5}', "");
    Expect(1, 3890, '\p{Is_Nv:   8.50e+00}', "");
    Expect(0, 3890, '\p{^Is_Nv:   8.50e+00}', "");
    Expect(0, 3890, '\P{Is_Nv:   8.50e+00}', "");
    Expect(1, 3890, '\P{^Is_Nv:   8.50e+00}', "");
    Expect(0, 3891, '\p{Is_Nv:   8.50e+00}', "");
    Expect(1, 3891, '\p{^Is_Nv:   8.50e+00}', "");
    Expect(1, 3891, '\P{Is_Nv:   8.50e+00}', "");
    Expect(0, 3891, '\P{^Is_Nv:   8.50e+00}', "");
    Expect(1, 3890, '\p{Is_Nv=8.50}', "");
    Expect(0, 3890, '\p{^Is_Nv=8.50}', "");
    Expect(0, 3890, '\P{Is_Nv=8.50}', "");
    Expect(1, 3890, '\P{^Is_Nv=8.50}', "");
    Expect(0, 3891, '\p{Is_Nv=8.50}', "");
    Expect(1, 3891, '\p{^Is_Nv=8.50}', "");
    Expect(1, 3891, '\P{Is_Nv=8.50}', "");
    Expect(0, 3891, '\P{^Is_Nv=8.50}', "");
    Error('\p{Numeric_Value=/a/_+00000018}');
    Error('\P{Numeric_Value=/a/_+00000018}');
    Expect(1, 119538, '\p{Numeric_Value=:\A18\z:}', "");;
    Expect(0, 119539, '\p{Numeric_Value=:\A18\z:}', "");;
    Expect(1, 119538, '\p{Numeric_Value=0018}', "");
    Expect(0, 119538, '\p{^Numeric_Value=0018}', "");
    Expect(0, 119538, '\P{Numeric_Value=0018}', "");
    Expect(1, 119538, '\P{^Numeric_Value=0018}', "");
    Expect(0, 119539, '\p{Numeric_Value=0018}', "");
    Expect(1, 119539, '\p{^Numeric_Value=0018}', "");
    Expect(1, 119539, '\P{Numeric_Value=0018}', "");
    Expect(0, 119539, '\P{^Numeric_Value=0018}', "");
    Expect(1, 119538, '\p{Numeric_Value=1.800000000000000e+01}', "");
    Expect(0, 119538, '\p{^Numeric_Value=1.800000000000000e+01}', "");
    Expect(0, 119538, '\P{Numeric_Value=1.800000000000000e+01}', "");
    Expect(1, 119538, '\P{^Numeric_Value=1.800000000000000e+01}', "");
    Expect(0, 119539, '\p{Numeric_Value=1.800000000000000e+01}', "");
    Expect(1, 119539, '\p{^Numeric_Value=1.800000000000000e+01}', "");
    Expect(1, 119539, '\P{Numeric_Value=1.800000000000000e+01}', "");
    Expect(0, 119539, '\P{^Numeric_Value=1.800000000000000e+01}', "");
    Error('\p{Nv=-/a/0_0_0_0_0_0_0018}');
    Error('\P{Nv=-/a/0_0_0_0_0_0_0018}');
    Expect(1, 119538, '\p{Nv=:\A18\z:}', "");;
    Expect(0, 119539, '\p{Nv=:\A18\z:}', "");;
    Expect(1, 119538, '\p{Nv=000000018}', "");
    Expect(0, 119538, '\p{^Nv=000000018}', "");
    Expect(0, 119538, '\P{Nv=000000018}', "");
    Expect(1, 119538, '\P{^Nv=000000018}', "");
    Expect(0, 119539, '\p{Nv=000000018}', "");
    Expect(1, 119539, '\p{^Nv=000000018}', "");
    Expect(1, 119539, '\P{Nv=000000018}', "");
    Expect(0, 119539, '\P{^Nv=000000018}', "");
    Expect(1, 119538, '\p{Nv=1.800000000000000e+01}', "");
    Expect(0, 119538, '\p{^Nv=1.800000000000000e+01}', "");
    Expect(0, 119538, '\P{Nv=1.800000000000000e+01}', "");
    Expect(1, 119538, '\P{^Nv=1.800000000000000e+01}', "");
    Expect(0, 119539, '\p{Nv=1.800000000000000e+01}', "");
    Expect(1, 119539, '\p{^Nv=1.800000000000000e+01}', "");
    Expect(1, 119539, '\P{Nv=1.800000000000000e+01}', "");
    Expect(0, 119539, '\P{^Nv=1.800000000000000e+01}', "");
    Error('\p{Is_Numeric_Value=_-00001_8:=}');
    Error('\P{Is_Numeric_Value=_-00001_8:=}');
    Expect(1, 119538, '\p{Is_Numeric_Value=+000000018}', "");
    Expect(0, 119538, '\p{^Is_Numeric_Value=+000000018}', "");
    Expect(0, 119538, '\P{Is_Numeric_Value=+000000018}', "");
    Expect(1, 119538, '\P{^Is_Numeric_Value=+000000018}', "");
    Expect(0, 119539, '\p{Is_Numeric_Value=+000000018}', "");
    Expect(1, 119539, '\p{^Is_Numeric_Value=+000000018}', "");
    Expect(1, 119539, '\P{Is_Numeric_Value=+000000018}', "");
    Expect(0, 119539, '\P{^Is_Numeric_Value=+000000018}', "");
    Expect(1, 119538, '\p{Is_Numeric_Value:   1.800000000000000e+01}', "");
    Expect(0, 119538, '\p{^Is_Numeric_Value:   1.800000000000000e+01}', "");
    Expect(0, 119538, '\P{Is_Numeric_Value:   1.800000000000000e+01}', "");
    Expect(1, 119538, '\P{^Is_Numeric_Value:   1.800000000000000e+01}', "");
    Expect(0, 119539, '\p{Is_Numeric_Value:   1.800000000000000e+01}', "");
    Expect(1, 119539, '\p{^Is_Numeric_Value:   1.800000000000000e+01}', "");
    Expect(1, 119539, '\P{Is_Numeric_Value:   1.800000000000000e+01}', "");
    Expect(0, 119539, '\P{^Is_Numeric_Value:   1.800000000000000e+01}', "");
    Error('\p{Is_Nv=/a/ 	0_0_0_0_0_0_0_018}');
    Error('\P{Is_Nv=/a/ 	0_0_0_0_0_0_0_018}');
    Expect(1, 119538, '\p{Is_Nv:01_8}', "");
    Expect(0, 119538, '\p{^Is_Nv:01_8}', "");
    Expect(0, 119538, '\P{Is_Nv:01_8}', "");
    Expect(1, 119538, '\P{^Is_Nv:01_8}', "");
    Expect(0, 119539, '\p{Is_Nv:01_8}', "");
    Expect(1, 119539, '\p{^Is_Nv:01_8}', "");
    Expect(1, 119539, '\P{Is_Nv:01_8}', "");
    Expect(0, 119539, '\P{^Is_Nv:01_8}', "");
    Expect(1, 119538, '\p{Is_Nv=1.800000000000000e+01}', "");
    Expect(0, 119538, '\p{^Is_Nv=1.800000000000000e+01}', "");
    Expect(0, 119538, '\P{Is_Nv=1.800000000000000e+01}', "");
    Expect(1, 119538, '\P{^Is_Nv=1.800000000000000e+01}', "");
    Expect(0, 119539, '\p{Is_Nv=1.800000000000000e+01}', "");
    Expect(1, 119539, '\p{^Is_Nv=1.800000000000000e+01}', "");
    Expect(1, 119539, '\P{Is_Nv=1.800000000000000e+01}', "");
    Expect(0, 119539, '\P{^Is_Nv=1.800000000000000e+01}', "");
    Error('\p{Numeric_Value=_ 0_0_0_19:=}');
    Error('\P{Numeric_Value=_ 0_0_0_19:=}');
    Expect(1, 119539, '\p{Numeric_Value=:\A19\z:}', "");;
    Expect(0, 119540, '\p{Numeric_Value=:\A19\z:}', "");;
    Expect(1, 119539, '\p{Numeric_Value=0_0_0_0_0_0_0019}', "");
    Expect(0, 119539, '\p{^Numeric_Value=0_0_0_0_0_0_0019}', "");
    Expect(0, 119539, '\P{Numeric_Value=0_0_0_0_0_0_0019}', "");
    Expect(1, 119539, '\P{^Numeric_Value=0_0_0_0_0_0_0019}', "");
    Expect(0, 119540, '\p{Numeric_Value=0_0_0_0_0_0_0019}', "");
    Expect(1, 119540, '\p{^Numeric_Value=0_0_0_0_0_0_0019}', "");
    Expect(1, 119540, '\P{Numeric_Value=0_0_0_0_0_0_0019}', "");
    Expect(0, 119540, '\P{^Numeric_Value=0_0_0_0_0_0_0019}', "");
    Expect(1, 119539, '\p{Numeric_Value=1.900000000000000e+01}', "");
    Expect(0, 119539, '\p{^Numeric_Value=1.900000000000000e+01}', "");
    Expect(0, 119539, '\P{Numeric_Value=1.900000000000000e+01}', "");
    Expect(1, 119539, '\P{^Numeric_Value=1.900000000000000e+01}', "");
    Expect(0, 119540, '\p{Numeric_Value=1.900000000000000e+01}', "");
    Expect(1, 119540, '\p{^Numeric_Value=1.900000000000000e+01}', "");
    Expect(1, 119540, '\P{Numeric_Value=1.900000000000000e+01}', "");
    Expect(0, 119540, '\P{^Numeric_Value=1.900000000000000e+01}', "");
    Error('\p{Nv=_000019/a/}');
    Error('\P{Nv=_000019/a/}');
    Expect(1, 119539, '\p{Nv=:\A19\z:}', "");;
    Expect(0, 119540, '\p{Nv=:\A19\z:}', "");;
    Expect(1, 119539, '\p{Nv=0000000019}', "");
    Expect(0, 119539, '\p{^Nv=0000000019}', "");
    Expect(0, 119539, '\P{Nv=0000000019}', "");
    Expect(1, 119539, '\P{^Nv=0000000019}', "");
    Expect(0, 119540, '\p{Nv=0000000019}', "");
    Expect(1, 119540, '\p{^Nv=0000000019}', "");
    Expect(1, 119540, '\P{Nv=0000000019}', "");
    Expect(0, 119540, '\P{^Nv=0000000019}', "");
    Expect(1, 119539, '\p{Nv=1.900000000000000e+01}', "");
    Expect(0, 119539, '\p{^Nv=1.900000000000000e+01}', "");
    Expect(0, 119539, '\P{Nv=1.900000000000000e+01}', "");
    Expect(1, 119539, '\P{^Nv=1.900000000000000e+01}', "");
    Expect(0, 119540, '\p{Nv=1.900000000000000e+01}', "");
    Expect(1, 119540, '\p{^Nv=1.900000000000000e+01}', "");
    Expect(1, 119540, '\P{Nv=1.900000000000000e+01}', "");
    Expect(0, 119540, '\P{^Nv=1.900000000000000e+01}', "");
    Error('\p{Is_Numeric_Value=:=		000_001_9}');
    Error('\P{Is_Numeric_Value=:=		000_001_9}');
    Expect(1, 119539, '\p{Is_Numeric_Value=00000000019}', "");
    Expect(0, 119539, '\p{^Is_Numeric_Value=00000000019}', "");
    Expect(0, 119539, '\P{Is_Numeric_Value=00000000019}', "");
    Expect(1, 119539, '\P{^Is_Numeric_Value=00000000019}', "");
    Expect(0, 119540, '\p{Is_Numeric_Value=00000000019}', "");
    Expect(1, 119540, '\p{^Is_Numeric_Value=00000000019}', "");
    Expect(1, 119540, '\P{Is_Numeric_Value=00000000019}', "");
    Expect(0, 119540, '\P{^Is_Numeric_Value=00000000019}', "");
    Expect(1, 119539, '\p{Is_Numeric_Value:1.900000000000000e+01}', "");
    Expect(0, 119539, '\p{^Is_Numeric_Value:1.900000000000000e+01}', "");
    Expect(0, 119539, '\P{Is_Numeric_Value:1.900000000000000e+01}', "");
    Expect(1, 119539, '\P{^Is_Numeric_Value:1.900000000000000e+01}', "");
    Expect(0, 119540, '\p{Is_Numeric_Value:1.900000000000000e+01}', "");
    Expect(1, 119540, '\p{^Is_Numeric_Value:1.900000000000000e+01}', "");
    Expect(1, 119540, '\P{Is_Numeric_Value:1.900000000000000e+01}', "");
    Expect(0, 119540, '\P{^Is_Numeric_Value:1.900000000000000e+01}', "");
    Error('\p{Is_Nv=/a/_-00_00_00_01_9}');
    Error('\P{Is_Nv=/a/_-00_00_00_01_9}');
    Expect(1, 119539, '\p{Is_Nv=0_0_0_0_0_0_0019}', "");
    Expect(0, 119539, '\p{^Is_Nv=0_0_0_0_0_0_0019}', "");
    Expect(0, 119539, '\P{Is_Nv=0_0_0_0_0_0_0019}', "");
    Expect(1, 119539, '\P{^Is_Nv=0_0_0_0_0_0_0019}', "");
    Expect(0, 119540, '\p{Is_Nv=0_0_0_0_0_0_0019}', "");
    Expect(1, 119540, '\p{^Is_Nv=0_0_0_0_0_0_0019}', "");
    Expect(1, 119540, '\P{Is_Nv=0_0_0_0_0_0_0019}', "");
    Expect(0, 119540, '\P{^Is_Nv=0_0_0_0_0_0_0019}', "");
    Expect(1, 119539, '\p{Is_Nv=1.900000000000000e+01}', "");
    Expect(0, 119539, '\p{^Is_Nv=1.900000000000000e+01}', "");
    Expect(0, 119539, '\P{Is_Nv=1.900000000000000e+01}', "");
    Expect(1, 119539, '\P{^Is_Nv=1.900000000000000e+01}', "");
    Expect(0, 119540, '\p{Is_Nv=1.900000000000000e+01}', "");
    Expect(1, 119540, '\p{^Is_Nv=1.900000000000000e+01}', "");
    Expect(1, 119540, '\P{Is_Nv=1.900000000000000e+01}', "");
    Expect(0, 119540, '\P{^Is_Nv=1.900000000000000e+01}', "");
    Error('\p{Numeric_Value=/a/00002}');
    Error('\P{Numeric_Value=/a/00002}');
    Expect(1, 140176, '\p{Numeric_Value=:\A2\z:}', "");;
    Expect(0, 140177, '\p{Numeric_Value=:\A2\z:}', "");;
    Expect(1, 140176, '\p{Numeric_Value=0_0_0_0_0_02}', "");
    Expect(0, 140176, '\p{^Numeric_Value=0_0_0_0_0_02}', "");
    Expect(0, 140176, '\P{Numeric_Value=0_0_0_0_0_02}', "");
    Expect(1, 140176, '\P{^Numeric_Value=0_0_0_0_0_02}', "");
    Expect(0, 140177, '\p{Numeric_Value=0_0_0_0_0_02}', "");
    Expect(1, 140177, '\p{^Numeric_Value=0_0_0_0_0_02}', "");
    Expect(1, 140177, '\P{Numeric_Value=0_0_0_0_0_02}', "");
    Expect(0, 140177, '\P{^Numeric_Value=0_0_0_0_0_02}', "");
    Expect(1, 140176, '\p{Numeric_Value=2.000000000000000e+00}', "");
    Expect(0, 140176, '\p{^Numeric_Value=2.000000000000000e+00}', "");
    Expect(0, 140176, '\P{Numeric_Value=2.000000000000000e+00}', "");
    Expect(1, 140176, '\P{^Numeric_Value=2.000000000000000e+00}', "");
    Expect(0, 140177, '\p{Numeric_Value=2.000000000000000e+00}', "");
    Expect(1, 140177, '\p{^Numeric_Value=2.000000000000000e+00}', "");
    Expect(1, 140177, '\P{Numeric_Value=2.000000000000000e+00}', "");
    Expect(0, 140177, '\P{^Numeric_Value=2.000000000000000e+00}', "");
    Error('\p{Nv= 	+000_2:=}');
    Error('\P{Nv= 	+000_2:=}');
    Expect(1, 140176, '\p{Nv=:\A2\z:}', "");;
    Expect(0, 140177, '\p{Nv=:\A2\z:}', "");;
    Expect(1, 140176, '\p{Nv=+0000000_2}', "");
    Expect(0, 140176, '\p{^Nv=+0000000_2}', "");
    Expect(0, 140176, '\P{Nv=+0000000_2}', "");
    Expect(1, 140176, '\P{^Nv=+0000000_2}', "");
    Expect(0, 140177, '\p{Nv=+0000000_2}', "");
    Expect(1, 140177, '\p{^Nv=+0000000_2}', "");
    Expect(1, 140177, '\P{Nv=+0000000_2}', "");
    Expect(0, 140177, '\P{^Nv=+0000000_2}', "");
    Expect(1, 140176, '\p{Nv=2.000000000000000e+00}', "");
    Expect(0, 140176, '\p{^Nv=2.000000000000000e+00}', "");
    Expect(0, 140176, '\P{Nv=2.000000000000000e+00}', "");
    Expect(1, 140176, '\P{^Nv=2.000000000000000e+00}', "");
    Expect(0, 140177, '\p{Nv=2.000000000000000e+00}', "");
    Expect(1, 140177, '\p{^Nv=2.000000000000000e+00}', "");
    Expect(1, 140177, '\P{Nv=2.000000000000000e+00}', "");
    Expect(0, 140177, '\P{^Nv=2.000000000000000e+00}', "");
    Error('\p{Is_Numeric_Value=	/a/00000002}');
    Error('\P{Is_Numeric_Value=	/a/00000002}');
    Expect(1, 140176, '\p{Is_Numeric_Value=0_0_0_0_0_02}', "");
    Expect(0, 140176, '\p{^Is_Numeric_Value=0_0_0_0_0_02}', "");
    Expect(0, 140176, '\P{Is_Numeric_Value=0_0_0_0_0_02}', "");
    Expect(1, 140176, '\P{^Is_Numeric_Value=0_0_0_0_0_02}', "");
    Expect(0, 140177, '\p{Is_Numeric_Value=0_0_0_0_0_02}', "");
    Expect(1, 140177, '\p{^Is_Numeric_Value=0_0_0_0_0_02}', "");
    Expect(1, 140177, '\P{Is_Numeric_Value=0_0_0_0_0_02}', "");
    Expect(0, 140177, '\P{^Is_Numeric_Value=0_0_0_0_0_02}', "");
    Expect(1, 140176, '\p{Is_Numeric_Value=2.000000000000000e+00}', "");
    Expect(0, 140176, '\p{^Is_Numeric_Value=2.000000000000000e+00}', "");
    Expect(0, 140176, '\P{Is_Numeric_Value=2.000000000000000e+00}', "");
    Expect(1, 140176, '\P{^Is_Numeric_Value=2.000000000000000e+00}', "");
    Expect(0, 140177, '\p{Is_Numeric_Value=2.000000000000000e+00}', "");
    Expect(1, 140177, '\p{^Is_Numeric_Value=2.000000000000000e+00}', "");
    Expect(1, 140177, '\P{Is_Numeric_Value=2.000000000000000e+00}', "");
    Expect(0, 140177, '\P{^Is_Numeric_Value=2.000000000000000e+00}', "");
    Error('\p{Is_Nv:		 +000002:=}');
    Error('\P{Is_Nv:		 +000002:=}');
    Expect(1, 140176, '\p{Is_Nv=+002}', "");
    Expect(0, 140176, '\p{^Is_Nv=+002}', "");
    Expect(0, 140176, '\P{Is_Nv=+002}', "");
    Expect(1, 140176, '\P{^Is_Nv=+002}', "");
    Expect(0, 140177, '\p{Is_Nv=+002}', "");
    Expect(1, 140177, '\p{^Is_Nv=+002}', "");
    Expect(1, 140177, '\P{Is_Nv=+002}', "");
    Expect(0, 140177, '\P{^Is_Nv=+002}', "");
    Expect(1, 140176, '\p{Is_Nv=2.000000000000000e+00}', "");
    Expect(0, 140176, '\p{^Is_Nv=2.000000000000000e+00}', "");
    Expect(0, 140176, '\P{Is_Nv=2.000000000000000e+00}', "");
    Expect(1, 140176, '\P{^Is_Nv=2.000000000000000e+00}', "");
    Expect(0, 140177, '\p{Is_Nv=2.000000000000000e+00}', "");
    Expect(1, 140177, '\p{^Is_Nv=2.000000000000000e+00}', "");
    Expect(1, 140177, '\P{Is_Nv=2.000000000000000e+00}', "");
    Expect(0, 140177, '\P{^Is_Nv=2.000000000000000e+00}', "");
    Error('\p{Numeric_Value=/a/ 	+2/3}');
    Error('\P{Numeric_Value=/a/ 	+2/3}');
    Expect(1, 74854, '\p{Numeric_Value=:\A2/3\z:}', "");;
    Expect(0, 74855, '\p{Numeric_Value=:\A2/3\z:}', "");;
    Expect(1, 74854, '\p{Numeric_Value=+0000000002/000003}', "");
    Expect(0, 74854, '\p{^Numeric_Value=+0000000002/000003}', "");
    Expect(0, 74854, '\P{Numeric_Value=+0000000002/000003}', "");
    Expect(1, 74854, '\P{^Numeric_Value=+0000000002/000003}', "");
    Expect(0, 74855, '\p{Numeric_Value=+0000000002/000003}', "");
    Expect(1, 74855, '\p{^Numeric_Value=+0000000002/000003}', "");
    Expect(1, 74855, '\P{Numeric_Value=+0000000002/000003}', "");
    Expect(0, 74855, '\P{^Numeric_Value=+0000000002/000003}', "");
    Expect(1, 74854, '\p{Numeric_Value=120/180}', "");
    Expect(0, 74854, '\p{^Numeric_Value=120/180}', "");
    Expect(0, 74854, '\P{Numeric_Value=120/180}', "");
    Expect(1, 74854, '\P{^Numeric_Value=120/180}', "");
    Expect(0, 74855, '\p{Numeric_Value=120/180}', "");
    Expect(1, 74855, '\p{^Numeric_Value=120/180}', "");
    Expect(1, 74855, '\P{Numeric_Value=120/180}', "");
    Expect(0, 74855, '\P{^Numeric_Value=120/180}', "");
    Error('\p{Numeric_Value=6.7e-01}');
    Error('\P{Numeric_Value=6.7e-01}');
    Error('\p{Numeric_Value=0.7}');
    Error('\P{Numeric_Value=0.7}');
    Error('\p{Numeric_Value=6.67e-01}');
    Error('\P{Numeric_Value=6.67e-01}');
    Error('\p{Numeric_Value=0.67}');
    Error('\P{Numeric_Value=0.67}');
    Expect(1, 74854, '\p{Numeric_Value=6.667e-01}', "");
    Expect(0, 74854, '\p{^Numeric_Value=6.667e-01}', "");
    Expect(0, 74854, '\P{Numeric_Value=6.667e-01}', "");
    Expect(1, 74854, '\P{^Numeric_Value=6.667e-01}', "");
    Expect(0, 74855, '\p{Numeric_Value=6.667e-01}', "");
    Expect(1, 74855, '\p{^Numeric_Value=6.667e-01}', "");
    Expect(1, 74855, '\P{Numeric_Value=6.667e-01}', "");
    Expect(0, 74855, '\P{^Numeric_Value=6.667e-01}', "");
    Error('\p{Numeric_Value=0.667}');
    Error('\P{Numeric_Value=0.667}');
    Expect(1, 74854, '\p{Numeric_Value=6.6667e-01}', "");
    Expect(0, 74854, '\p{^Numeric_Value=6.6667e-01}', "");
    Expect(0, 74854, '\P{Numeric_Value=6.6667e-01}', "");
    Expect(1, 74854, '\P{^Numeric_Value=6.6667e-01}', "");
    Expect(0, 74855, '\p{Numeric_Value=6.6667e-01}', "");
    Expect(1, 74855, '\p{^Numeric_Value=6.6667e-01}', "");
    Expect(1, 74855, '\P{Numeric_Value=6.6667e-01}', "");
    Expect(0, 74855, '\P{^Numeric_Value=6.6667e-01}', "");
    Expect(1, 74854, '\p{Numeric_Value=0.6667}', "");
    Expect(0, 74854, '\p{^Numeric_Value=0.6667}', "");
    Expect(0, 74854, '\P{Numeric_Value=0.6667}', "");
    Expect(1, 74854, '\P{^Numeric_Value=0.6667}', "");
    Expect(0, 74855, '\p{Numeric_Value=0.6667}', "");
    Expect(1, 74855, '\p{^Numeric_Value=0.6667}', "");
    Expect(1, 74855, '\P{Numeric_Value=0.6667}', "");
    Expect(0, 74855, '\P{^Numeric_Value=0.6667}', "");
    Expect(1, 74854, '\p{Numeric_Value=6.66667e-01}', "");
    Expect(0, 74854, '\p{^Numeric_Value=6.66667e-01}', "");
    Expect(0, 74854, '\P{Numeric_Value=6.66667e-01}', "");
    Expect(1, 74854, '\P{^Numeric_Value=6.66667e-01}', "");
    Expect(0, 74855, '\p{Numeric_Value=6.66667e-01}', "");
    Expect(1, 74855, '\p{^Numeric_Value=6.66667e-01}', "");
    Expect(1, 74855, '\P{Numeric_Value=6.66667e-01}', "");
    Expect(0, 74855, '\P{^Numeric_Value=6.66667e-01}', "");
    Expect(1, 74854, '\p{Numeric_Value=0.66667}', "");
    Expect(0, 74854, '\p{^Numeric_Value=0.66667}', "");
    Expect(0, 74854, '\P{Numeric_Value=0.66667}', "");
    Expect(1, 74854, '\P{^Numeric_Value=0.66667}', "");
    Expect(0, 74855, '\p{Numeric_Value=0.66667}', "");
    Expect(1, 74855, '\p{^Numeric_Value=0.66667}', "");
    Expect(1, 74855, '\P{Numeric_Value=0.66667}', "");
    Expect(0, 74855, '\P{^Numeric_Value=0.66667}', "");
    Error('\p{Nv=_-002/000000003/a/}');
    Error('\P{Nv=_-002/000000003/a/}');
    Expect(1, 74854, '\p{Nv=:\A2/3\z:}', "");;
    Expect(0, 74855, '\p{Nv=:\A2/3\z:}', "");;
    Expect(1, 74854, '\p{Nv=0000000002/0003}', "");
    Expect(0, 74854, '\p{^Nv=0000000002/0003}', "");
    Expect(0, 74854, '\P{Nv=0000000002/0003}', "");
    Expect(1, 74854, '\P{^Nv=0000000002/0003}', "");
    Expect(0, 74855, '\p{Nv=0000000002/0003}', "");
    Expect(1, 74855, '\p{^Nv=0000000002/0003}', "");
    Expect(1, 74855, '\P{Nv=0000000002/0003}', "");
    Expect(0, 74855, '\P{^Nv=0000000002/0003}', "");
    Expect(1, 74854, '\p{Nv=120/180}', "");
    Expect(0, 74854, '\p{^Nv=120/180}', "");
    Expect(0, 74854, '\P{Nv=120/180}', "");
    Expect(1, 74854, '\P{^Nv=120/180}', "");
    Expect(0, 74855, '\p{Nv=120/180}', "");
    Expect(1, 74855, '\p{^Nv=120/180}', "");
    Expect(1, 74855, '\P{Nv=120/180}', "");
    Expect(0, 74855, '\P{^Nv=120/180}', "");
    Error('\p{Nv=6.7e-01}');
    Error('\P{Nv=6.7e-01}');
    Error('\p{Nv=0.7}');
    Error('\P{Nv=0.7}');
    Error('\p{Nv=6.67e-01}');
    Error('\P{Nv=6.67e-01}');
    Error('\p{Nv:	0.67}');
    Error('\P{Nv:	0.67}');
    Expect(1, 74854, '\p{Nv=6.667e-01}', "");
    Expect(0, 74854, '\p{^Nv=6.667e-01}', "");
    Expect(0, 74854, '\P{Nv=6.667e-01}', "");
    Expect(1, 74854, '\P{^Nv=6.667e-01}', "");
    Expect(0, 74855, '\p{Nv=6.667e-01}', "");
    Expect(1, 74855, '\p{^Nv=6.667e-01}', "");
    Expect(1, 74855, '\P{Nv=6.667e-01}', "");
    Expect(0, 74855, '\P{^Nv=6.667e-01}', "");
    Error('\p{Nv=0.667}');
    Error('\P{Nv=0.667}');
    Expect(1, 74854, '\p{Nv=6.6667e-01}', "");
    Expect(0, 74854, '\p{^Nv=6.6667e-01}', "");
    Expect(0, 74854, '\P{Nv=6.6667e-01}', "");
    Expect(1, 74854, '\P{^Nv=6.6667e-01}', "");
    Expect(0, 74855, '\p{Nv=6.6667e-01}', "");
    Expect(1, 74855, '\p{^Nv=6.6667e-01}', "");
    Expect(1, 74855, '\P{Nv=6.6667e-01}', "");
    Expect(0, 74855, '\P{^Nv=6.6667e-01}', "");
    Expect(1, 74854, '\p{Nv=0.6667}', "");
    Expect(0, 74854, '\p{^Nv=0.6667}', "");
    Expect(0, 74854, '\P{Nv=0.6667}', "");
    Expect(1, 74854, '\P{^Nv=0.6667}', "");
    Expect(0, 74855, '\p{Nv=0.6667}', "");
    Expect(1, 74855, '\p{^Nv=0.6667}', "");
    Expect(1, 74855, '\P{Nv=0.6667}', "");
    Expect(0, 74855, '\P{^Nv=0.6667}', "");
    Expect(1, 74854, '\p{Nv=6.66667e-01}', "");
    Expect(0, 74854, '\p{^Nv=6.66667e-01}', "");
    Expect(0, 74854, '\P{Nv=6.66667e-01}', "");
    Expect(1, 74854, '\P{^Nv=6.66667e-01}', "");
    Expect(0, 74855, '\p{Nv=6.66667e-01}', "");
    Expect(1, 74855, '\p{^Nv=6.66667e-01}', "");
    Expect(1, 74855, '\P{Nv=6.66667e-01}', "");
    Expect(0, 74855, '\P{^Nv=6.66667e-01}', "");
    Expect(1, 74854, '\p{Nv=0.66667}', "");
    Expect(0, 74854, '\p{^Nv=0.66667}', "");
    Expect(0, 74854, '\P{Nv=0.66667}', "");
    Expect(1, 74854, '\P{^Nv=0.66667}', "");
    Expect(0, 74855, '\p{Nv=0.66667}', "");
    Expect(1, 74855, '\p{^Nv=0.66667}', "");
    Expect(1, 74855, '\P{Nv=0.66667}', "");
    Expect(0, 74855, '\P{^Nv=0.66667}', "");
    Error('\p{Is_Numeric_Value=:= +2/00000003}');
    Error('\P{Is_Numeric_Value=:= +2/00000003}');
    Expect(1, 74854, '\p{Is_Numeric_Value=+02/0000000003}', "");
    Expect(0, 74854, '\p{^Is_Numeric_Value=+02/0000000003}', "");
    Expect(0, 74854, '\P{Is_Numeric_Value=+02/0000000003}', "");
    Expect(1, 74854, '\P{^Is_Numeric_Value=+02/0000000003}', "");
    Expect(0, 74855, '\p{Is_Numeric_Value=+02/0000000003}', "");
    Expect(1, 74855, '\p{^Is_Numeric_Value=+02/0000000003}', "");
    Expect(1, 74855, '\P{Is_Numeric_Value=+02/0000000003}', "");
    Expect(0, 74855, '\P{^Is_Numeric_Value=+02/0000000003}', "");
    Expect(1, 74854, '\p{Is_Numeric_Value:	120/180}', "");
    Expect(0, 74854, '\p{^Is_Numeric_Value:	120/180}', "");
    Expect(0, 74854, '\P{Is_Numeric_Value:	120/180}', "");
    Expect(1, 74854, '\P{^Is_Numeric_Value:	120/180}', "");
    Expect(0, 74855, '\p{Is_Numeric_Value:	120/180}', "");
    Expect(1, 74855, '\p{^Is_Numeric_Value:	120/180}', "");
    Expect(1, 74855, '\P{Is_Numeric_Value:	120/180}', "");
    Expect(0, 74855, '\P{^Is_Numeric_Value:	120/180}', "");
    Error('\p{Is_Numeric_Value=6.7e-01}');
    Error('\P{Is_Numeric_Value=6.7e-01}');
    Error('\p{Is_Numeric_Value=0.7}');
    Error('\P{Is_Numeric_Value=0.7}');
    Error('\p{Is_Numeric_Value=6.67e-01}');
    Error('\P{Is_Numeric_Value=6.67e-01}');
    Error('\p{Is_Numeric_Value=0.67}');
    Error('\P{Is_Numeric_Value=0.67}');
    Expect(1, 74854, '\p{Is_Numeric_Value=6.667e-01}', "");
    Expect(0, 74854, '\p{^Is_Numeric_Value=6.667e-01}', "");
    Expect(0, 74854, '\P{Is_Numeric_Value=6.667e-01}', "");
    Expect(1, 74854, '\P{^Is_Numeric_Value=6.667e-01}', "");
    Expect(0, 74855, '\p{Is_Numeric_Value=6.667e-01}', "");
    Expect(1, 74855, '\p{^Is_Numeric_Value=6.667e-01}', "");
    Expect(1, 74855, '\P{Is_Numeric_Value=6.667e-01}', "");
    Expect(0, 74855, '\P{^Is_Numeric_Value=6.667e-01}', "");
    Error('\p{Is_Numeric_Value=0.667}');
    Error('\P{Is_Numeric_Value=0.667}');
    Expect(1, 74854, '\p{Is_Numeric_Value=6.6667e-01}', "");
    Expect(0, 74854, '\p{^Is_Numeric_Value=6.6667e-01}', "");
    Expect(0, 74854, '\P{Is_Numeric_Value=6.6667e-01}', "");
    Expect(1, 74854, '\P{^Is_Numeric_Value=6.6667e-01}', "");
    Expect(0, 74855, '\p{Is_Numeric_Value=6.6667e-01}', "");
    Expect(1, 74855, '\p{^Is_Numeric_Value=6.6667e-01}', "");
    Expect(1, 74855, '\P{Is_Numeric_Value=6.6667e-01}', "");
    Expect(0, 74855, '\P{^Is_Numeric_Value=6.6667e-01}', "");
    Expect(1, 74854, '\p{Is_Numeric_Value=0.6667}', "");
    Expect(0, 74854, '\p{^Is_Numeric_Value=0.6667}', "");
    Expect(0, 74854, '\P{Is_Numeric_Value=0.6667}', "");
    Expect(1, 74854, '\P{^Is_Numeric_Value=0.6667}', "");
    Expect(0, 74855, '\p{Is_Numeric_Value=0.6667}', "");
    Expect(1, 74855, '\p{^Is_Numeric_Value=0.6667}', "");
    Expect(1, 74855, '\P{Is_Numeric_Value=0.6667}', "");
    Expect(0, 74855, '\P{^Is_Numeric_Value=0.6667}', "");
    Expect(1, 74854, '\p{Is_Numeric_Value=6.66667e-01}', "");
    Expect(0, 74854, '\p{^Is_Numeric_Value=6.66667e-01}', "");
    Expect(0, 74854, '\P{Is_Numeric_Value=6.66667e-01}', "");
    Expect(1, 74854, '\P{^Is_Numeric_Value=6.66667e-01}', "");
    Expect(0, 74855, '\p{Is_Numeric_Value=6.66667e-01}', "");
    Expect(1, 74855, '\p{^Is_Numeric_Value=6.66667e-01}', "");
    Expect(1, 74855, '\P{Is_Numeric_Value=6.66667e-01}', "");
    Expect(0, 74855, '\P{^Is_Numeric_Value=6.66667e-01}', "");
    Expect(1, 74854, '\p{Is_Numeric_Value=0.66667}', "");
    Expect(0, 74854, '\p{^Is_Numeric_Value=0.66667}', "");
    Expect(0, 74854, '\P{Is_Numeric_Value=0.66667}', "");
    Expect(1, 74854, '\P{^Is_Numeric_Value=0.66667}', "");
    Expect(0, 74855, '\p{Is_Numeric_Value=0.66667}', "");
    Expect(1, 74855, '\p{^Is_Numeric_Value=0.66667}', "");
    Expect(1, 74855, '\P{Is_Numeric_Value=0.66667}', "");
    Expect(0, 74855, '\P{^Is_Numeric_Value=0.66667}', "");
    Error('\p{Is_Nv=-/a/000002/03}');
    Error('\P{Is_Nv=-/a/000002/03}');
    Expect(1, 74854, '\p{Is_Nv=+2/0000003}', "");
    Expect(0, 74854, '\p{^Is_Nv=+2/0000003}', "");
    Expect(0, 74854, '\P{Is_Nv=+2/0000003}', "");
    Expect(1, 74854, '\P{^Is_Nv=+2/0000003}', "");
    Expect(0, 74855, '\p{Is_Nv=+2/0000003}', "");
    Expect(1, 74855, '\p{^Is_Nv=+2/0000003}', "");
    Expect(1, 74855, '\P{Is_Nv=+2/0000003}', "");
    Expect(0, 74855, '\P{^Is_Nv=+2/0000003}', "");
    Expect(1, 74854, '\p{Is_Nv=120/180}', "");
    Expect(0, 74854, '\p{^Is_Nv=120/180}', "");
    Expect(0, 74854, '\P{Is_Nv=120/180}', "");
    Expect(1, 74854, '\P{^Is_Nv=120/180}', "");
    Expect(0, 74855, '\p{Is_Nv=120/180}', "");
    Expect(1, 74855, '\p{^Is_Nv=120/180}', "");
    Expect(1, 74855, '\P{Is_Nv=120/180}', "");
    Expect(0, 74855, '\P{^Is_Nv=120/180}', "");
    Error('\p{Is_Nv=6.7e-01}');
    Error('\P{Is_Nv=6.7e-01}');
    Error('\p{Is_Nv:0.7}');
    Error('\P{Is_Nv:0.7}');
    Error('\p{Is_Nv=6.67e-01}');
    Error('\P{Is_Nv=6.67e-01}');
    Error('\p{Is_Nv=0.67}');
    Error('\P{Is_Nv=0.67}');
    Expect(1, 74854, '\p{Is_Nv=6.667e-01}', "");
    Expect(0, 74854, '\p{^Is_Nv=6.667e-01}', "");
    Expect(0, 74854, '\P{Is_Nv=6.667e-01}', "");
    Expect(1, 74854, '\P{^Is_Nv=6.667e-01}', "");
    Expect(0, 74855, '\p{Is_Nv=6.667e-01}', "");
    Expect(1, 74855, '\p{^Is_Nv=6.667e-01}', "");
    Expect(1, 74855, '\P{Is_Nv=6.667e-01}', "");
    Expect(0, 74855, '\P{^Is_Nv=6.667e-01}', "");
    Error('\p{Is_Nv=0.667}');
    Error('\P{Is_Nv=0.667}');
    Expect(1, 74854, '\p{Is_Nv=6.6667e-01}', "");
    Expect(0, 74854, '\p{^Is_Nv=6.6667e-01}', "");
    Expect(0, 74854, '\P{Is_Nv=6.6667e-01}', "");
    Expect(1, 74854, '\P{^Is_Nv=6.6667e-01}', "");
    Expect(0, 74855, '\p{Is_Nv=6.6667e-01}', "");
    Expect(1, 74855, '\p{^Is_Nv=6.6667e-01}', "");
    Expect(1, 74855, '\P{Is_Nv=6.6667e-01}', "");
    Expect(0, 74855, '\P{^Is_Nv=6.6667e-01}', "");
    Expect(1, 74854, '\p{Is_Nv=0.6667}', "");
    Expect(0, 74854, '\p{^Is_Nv=0.6667}', "");
    Expect(0, 74854, '\P{Is_Nv=0.6667}', "");
    Expect(1, 74854, '\P{^Is_Nv=0.6667}', "");
    Expect(0, 74855, '\p{Is_Nv=0.6667}', "");
    Expect(1, 74855, '\p{^Is_Nv=0.6667}', "");
    Expect(1, 74855, '\P{Is_Nv=0.6667}', "");
    Expect(0, 74855, '\P{^Is_Nv=0.6667}', "");
    Expect(1, 74854, '\p{Is_Nv=6.66667e-01}', "");
    Expect(0, 74854, '\p{^Is_Nv=6.66667e-01}', "");
    Expect(0, 74854, '\P{Is_Nv=6.66667e-01}', "");
    Expect(1, 74854, '\P{^Is_Nv=6.66667e-01}', "");
    Expect(0, 74855, '\p{Is_Nv=6.66667e-01}', "");
    Expect(1, 74855, '\p{^Is_Nv=6.66667e-01}', "");
    Expect(1, 74855, '\P{Is_Nv=6.66667e-01}', "");
    Expect(0, 74855, '\P{^Is_Nv=6.66667e-01}', "");
    Expect(1, 74854, '\p{Is_Nv=0.66667}', "");
    Expect(0, 74854, '\p{^Is_Nv=0.66667}', "");
    Expect(0, 74854, '\P{Is_Nv=0.66667}', "");
    Expect(1, 74854, '\P{^Is_Nv=0.66667}', "");
    Expect(0, 74855, '\p{Is_Nv=0.66667}', "");
    Expect(1, 74855, '\p{^Is_Nv=0.66667}', "");
    Expect(1, 74855, '\P{Is_Nv=0.66667}', "");
    Expect(0, 74855, '\P{^Is_Nv=0.66667}', "");
    Error('\p{Numeric_Value=-0002/00000005:=}');
    Error('\P{Numeric_Value=-0002/00000005:=}');
    Expect(1, 8534, '\p{Numeric_Value=:\A2/5\z:}', "");;
    Expect(0, 8535, '\p{Numeric_Value=:\A2/5\z:}', "");;
    Expect(1, 8534, '\p{Numeric_Value=2/000005}', "");
    Expect(0, 8534, '\p{^Numeric_Value=2/000005}', "");
    Expect(0, 8534, '\P{Numeric_Value=2/000005}', "");
    Expect(1, 8534, '\P{^Numeric_Value=2/000005}', "");
    Expect(0, 8535, '\p{Numeric_Value=2/000005}', "");
    Expect(1, 8535, '\p{^Numeric_Value=2/000005}', "");
    Expect(1, 8535, '\P{Numeric_Value=2/000005}', "");
    Expect(0, 8535, '\P{^Numeric_Value=2/000005}', "");
    Expect(1, 8534, '\p{Numeric_Value=120/300}', "");
    Expect(0, 8534, '\p{^Numeric_Value=120/300}', "");
    Expect(0, 8534, '\P{Numeric_Value=120/300}', "");
    Expect(1, 8534, '\P{^Numeric_Value=120/300}', "");
    Expect(0, 8535, '\p{Numeric_Value=120/300}', "");
    Expect(1, 8535, '\p{^Numeric_Value=120/300}', "");
    Expect(1, 8535, '\P{Numeric_Value=120/300}', "");
    Expect(0, 8535, '\P{^Numeric_Value=120/300}', "");
    Expect(1, 8534, '\p{Numeric_Value=4.0e-01}', "");
    Expect(0, 8534, '\p{^Numeric_Value=4.0e-01}', "");
    Expect(0, 8534, '\P{Numeric_Value=4.0e-01}', "");
    Expect(1, 8534, '\P{^Numeric_Value=4.0e-01}', "");
    Expect(0, 8535, '\p{Numeric_Value=4.0e-01}', "");
    Expect(1, 8535, '\p{^Numeric_Value=4.0e-01}', "");
    Expect(1, 8535, '\P{Numeric_Value=4.0e-01}', "");
    Expect(0, 8535, '\P{^Numeric_Value=4.0e-01}', "");
    Expect(1, 8534, '\p{Numeric_Value=0.4}', "");
    Expect(0, 8534, '\p{^Numeric_Value=0.4}', "");
    Expect(0, 8534, '\P{Numeric_Value=0.4}', "");
    Expect(1, 8534, '\P{^Numeric_Value=0.4}', "");
    Expect(0, 8535, '\p{Numeric_Value=0.4}', "");
    Expect(1, 8535, '\p{^Numeric_Value=0.4}', "");
    Expect(1, 8535, '\P{Numeric_Value=0.4}', "");
    Expect(0, 8535, '\P{^Numeric_Value=0.4}', "");
    Expect(1, 8534, '\p{Numeric_Value=4.00e-01}', "");
    Expect(0, 8534, '\p{^Numeric_Value=4.00e-01}', "");
    Expect(0, 8534, '\P{Numeric_Value=4.00e-01}', "");
    Expect(1, 8534, '\P{^Numeric_Value=4.00e-01}', "");
    Expect(0, 8535, '\p{Numeric_Value=4.00e-01}', "");
    Expect(1, 8535, '\p{^Numeric_Value=4.00e-01}', "");
    Expect(1, 8535, '\P{Numeric_Value=4.00e-01}', "");
    Expect(0, 8535, '\P{^Numeric_Value=4.00e-01}', "");
    Expect(1, 8534, '\p{Numeric_Value=0.40}', "");
    Expect(0, 8534, '\p{^Numeric_Value=0.40}', "");
    Expect(0, 8534, '\P{Numeric_Value=0.40}', "");
    Expect(1, 8534, '\P{^Numeric_Value=0.40}', "");
    Expect(0, 8535, '\p{Numeric_Value=0.40}', "");
    Expect(1, 8535, '\p{^Numeric_Value=0.40}', "");
    Expect(1, 8535, '\P{Numeric_Value=0.40}', "");
    Expect(0, 8535, '\P{^Numeric_Value=0.40}', "");
    Error('\p{Nv= 	+00000002/000000005:=}');
    Error('\P{Nv= 	+00000002/000000005:=}');
    Expect(1, 8534, '\p{Nv=:\A2/5\z:}', "");;
    Expect(0, 8535, '\p{Nv=:\A2/5\z:}', "");;
    Expect(1, 8534, '\p{Nv=+00002/0000000005}', "");
    Expect(0, 8534, '\p{^Nv=+00002/0000000005}', "");
    Expect(0, 8534, '\P{Nv=+00002/0000000005}', "");
    Expect(1, 8534, '\P{^Nv=+00002/0000000005}', "");
    Expect(0, 8535, '\p{Nv=+00002/0000000005}', "");
    Expect(1, 8535, '\p{^Nv=+00002/0000000005}', "");
    Expect(1, 8535, '\P{Nv=+00002/0000000005}', "");
    Expect(0, 8535, '\P{^Nv=+00002/0000000005}', "");
    Expect(1, 8534, '\p{Nv:   120/300}', "");
    Expect(0, 8534, '\p{^Nv:   120/300}', "");
    Expect(0, 8534, '\P{Nv:   120/300}', "");
    Expect(1, 8534, '\P{^Nv:   120/300}', "");
    Expect(0, 8535, '\p{Nv:   120/300}', "");
    Expect(1, 8535, '\p{^Nv:   120/300}', "");
    Expect(1, 8535, '\P{Nv:   120/300}', "");
    Expect(0, 8535, '\P{^Nv:   120/300}', "");
    Expect(1, 8534, '\p{Nv=4.0e-01}', "");
    Expect(0, 8534, '\p{^Nv=4.0e-01}', "");
    Expect(0, 8534, '\P{Nv=4.0e-01}', "");
    Expect(1, 8534, '\P{^Nv=4.0e-01}', "");
    Expect(0, 8535, '\p{Nv=4.0e-01}', "");
    Expect(1, 8535, '\p{^Nv=4.0e-01}', "");
    Expect(1, 8535, '\P{Nv=4.0e-01}', "");
    Expect(0, 8535, '\P{^Nv=4.0e-01}', "");
    Expect(1, 8534, '\p{Nv=0.4}', "");
    Expect(0, 8534, '\p{^Nv=0.4}', "");
    Expect(0, 8534, '\P{Nv=0.4}', "");
    Expect(1, 8534, '\P{^Nv=0.4}', "");
    Expect(0, 8535, '\p{Nv=0.4}', "");
    Expect(1, 8535, '\p{^Nv=0.4}', "");
    Expect(1, 8535, '\P{Nv=0.4}', "");
    Expect(0, 8535, '\P{^Nv=0.4}', "");
    Expect(1, 8534, '\p{Nv=4.00e-01}', "");
    Expect(0, 8534, '\p{^Nv=4.00e-01}', "");
    Expect(0, 8534, '\P{Nv=4.00e-01}', "");
    Expect(1, 8534, '\P{^Nv=4.00e-01}', "");
    Expect(0, 8535, '\p{Nv=4.00e-01}', "");
    Expect(1, 8535, '\p{^Nv=4.00e-01}', "");
    Expect(1, 8535, '\P{Nv=4.00e-01}', "");
    Expect(0, 8535, '\P{^Nv=4.00e-01}', "");
    Expect(1, 8534, '\p{Nv=0.40}', "");
    Expect(0, 8534, '\p{^Nv=0.40}', "");
    Expect(0, 8534, '\P{Nv=0.40}', "");
    Expect(1, 8534, '\P{^Nv=0.40}', "");
    Expect(0, 8535, '\p{Nv=0.40}', "");
    Expect(1, 8535, '\p{^Nv=0.40}', "");
    Expect(1, 8535, '\P{Nv=0.40}', "");
    Expect(0, 8535, '\P{^Nv=0.40}', "");
    Error('\p{Is_Numeric_Value= +00000002/000000005/a/}');
    Error('\P{Is_Numeric_Value= +00000002/000000005/a/}');
    Expect(1, 8534, '\p{Is_Numeric_Value=000002/00000005}', "");
    Expect(0, 8534, '\p{^Is_Numeric_Value=000002/00000005}', "");
    Expect(0, 8534, '\P{Is_Numeric_Value=000002/00000005}', "");
    Expect(1, 8534, '\P{^Is_Numeric_Value=000002/00000005}', "");
    Expect(0, 8535, '\p{Is_Numeric_Value=000002/00000005}', "");
    Expect(1, 8535, '\p{^Is_Numeric_Value=000002/00000005}', "");
    Expect(1, 8535, '\P{Is_Numeric_Value=000002/00000005}', "");
    Expect(0, 8535, '\P{^Is_Numeric_Value=000002/00000005}', "");
    Expect(1, 8534, '\p{Is_Numeric_Value=120/300}', "");
    Expect(0, 8534, '\p{^Is_Numeric_Value=120/300}', "");
    Expect(0, 8534, '\P{Is_Numeric_Value=120/300}', "");
    Expect(1, 8534, '\P{^Is_Numeric_Value=120/300}', "");
    Expect(0, 8535, '\p{Is_Numeric_Value=120/300}', "");
    Expect(1, 8535, '\p{^Is_Numeric_Value=120/300}', "");
    Expect(1, 8535, '\P{Is_Numeric_Value=120/300}', "");
    Expect(0, 8535, '\P{^Is_Numeric_Value=120/300}', "");
    Expect(1, 8534, '\p{Is_Numeric_Value=4.0e-01}', "");
    Expect(0, 8534, '\p{^Is_Numeric_Value=4.0e-01}', "");
    Expect(0, 8534, '\P{Is_Numeric_Value=4.0e-01}', "");
    Expect(1, 8534, '\P{^Is_Numeric_Value=4.0e-01}', "");
    Expect(0, 8535, '\p{Is_Numeric_Value=4.0e-01}', "");
    Expect(1, 8535, '\p{^Is_Numeric_Value=4.0e-01}', "");
    Expect(1, 8535, '\P{Is_Numeric_Value=4.0e-01}', "");
    Expect(0, 8535, '\P{^Is_Numeric_Value=4.0e-01}', "");
    Expect(1, 8534, '\p{Is_Numeric_Value=0.4}', "");
    Expect(0, 8534, '\p{^Is_Numeric_Value=0.4}', "");
    Expect(0, 8534, '\P{Is_Numeric_Value=0.4}', "");
    Expect(1, 8534, '\P{^Is_Numeric_Value=0.4}', "");
    Expect(0, 8535, '\p{Is_Numeric_Value=0.4}', "");
    Expect(1, 8535, '\p{^Is_Numeric_Value=0.4}', "");
    Expect(1, 8535, '\P{Is_Numeric_Value=0.4}', "");
    Expect(0, 8535, '\P{^Is_Numeric_Value=0.4}', "");
    Expect(1, 8534, '\p{Is_Numeric_Value=4.00e-01}', "");
    Expect(0, 8534, '\p{^Is_Numeric_Value=4.00e-01}', "");
    Expect(0, 8534, '\P{Is_Numeric_Value=4.00e-01}', "");
    Expect(1, 8534, '\P{^Is_Numeric_Value=4.00e-01}', "");
    Expect(0, 8535, '\p{Is_Numeric_Value=4.00e-01}', "");
    Expect(1, 8535, '\p{^Is_Numeric_Value=4.00e-01}', "");
    Expect(1, 8535, '\P{Is_Numeric_Value=4.00e-01}', "");
    Expect(0, 8535, '\P{^Is_Numeric_Value=4.00e-01}', "");
    Expect(1, 8534, '\p{Is_Numeric_Value=0.40}', "");
    Expect(0, 8534, '\p{^Is_Numeric_Value=0.40}', "");
    Expect(0, 8534, '\P{Is_Numeric_Value=0.40}', "");
    Expect(1, 8534, '\P{^Is_Numeric_Value=0.40}', "");
    Expect(0, 8535, '\p{Is_Numeric_Value=0.40}', "");
    Expect(1, 8535, '\p{^Is_Numeric_Value=0.40}', "");
    Expect(1, 8535, '\P{Is_Numeric_Value=0.40}', "");
    Expect(0, 8535, '\P{^Is_Numeric_Value=0.40}', "");
    Error('\p{Is_Nv=-	+000002/000005:=}');
    Error('\P{Is_Nv=-	+000002/000005:=}');
    Expect(1, 8534, '\p{Is_Nv=0000000002/00005}', "");
    Expect(0, 8534, '\p{^Is_Nv=0000000002/00005}', "");
    Expect(0, 8534, '\P{Is_Nv=0000000002/00005}', "");
    Expect(1, 8534, '\P{^Is_Nv=0000000002/00005}', "");
    Expect(0, 8535, '\p{Is_Nv=0000000002/00005}', "");
    Expect(1, 8535, '\p{^Is_Nv=0000000002/00005}', "");
    Expect(1, 8535, '\P{Is_Nv=0000000002/00005}', "");
    Expect(0, 8535, '\P{^Is_Nv=0000000002/00005}', "");
    Expect(1, 8534, '\p{Is_Nv=120/300}', "");
    Expect(0, 8534, '\p{^Is_Nv=120/300}', "");
    Expect(0, 8534, '\P{Is_Nv=120/300}', "");
    Expect(1, 8534, '\P{^Is_Nv=120/300}', "");
    Expect(0, 8535, '\p{Is_Nv=120/300}', "");
    Expect(1, 8535, '\p{^Is_Nv=120/300}', "");
    Expect(1, 8535, '\P{Is_Nv=120/300}', "");
    Expect(0, 8535, '\P{^Is_Nv=120/300}', "");
    Expect(1, 8534, '\p{Is_Nv=4.0e-01}', "");
    Expect(0, 8534, '\p{^Is_Nv=4.0e-01}', "");
    Expect(0, 8534, '\P{Is_Nv=4.0e-01}', "");
    Expect(1, 8534, '\P{^Is_Nv=4.0e-01}', "");
    Expect(0, 8535, '\p{Is_Nv=4.0e-01}', "");
    Expect(1, 8535, '\p{^Is_Nv=4.0e-01}', "");
    Expect(1, 8535, '\P{Is_Nv=4.0e-01}', "");
    Expect(0, 8535, '\P{^Is_Nv=4.0e-01}', "");
    Expect(1, 8534, '\p{Is_Nv=0.4}', "");
    Expect(0, 8534, '\p{^Is_Nv=0.4}', "");
    Expect(0, 8534, '\P{Is_Nv=0.4}', "");
    Expect(1, 8534, '\P{^Is_Nv=0.4}', "");
    Expect(0, 8535, '\p{Is_Nv=0.4}', "");
    Expect(1, 8535, '\p{^Is_Nv=0.4}', "");
    Expect(1, 8535, '\P{Is_Nv=0.4}', "");
    Expect(0, 8535, '\P{^Is_Nv=0.4}', "");
    Expect(1, 8534, '\p{Is_Nv=4.00e-01}', "");
    Expect(0, 8534, '\p{^Is_Nv=4.00e-01}', "");
    Expect(0, 8534, '\P{Is_Nv=4.00e-01}', "");
    Expect(1, 8534, '\P{^Is_Nv=4.00e-01}', "");
    Expect(0, 8535, '\p{Is_Nv=4.00e-01}', "");
    Expect(1, 8535, '\p{^Is_Nv=4.00e-01}', "");
    Expect(1, 8535, '\P{Is_Nv=4.00e-01}', "");
    Expect(0, 8535, '\P{^Is_Nv=4.00e-01}', "");
    Expect(1, 8534, '\p{Is_Nv:0.40}', "");
    Expect(0, 8534, '\p{^Is_Nv:0.40}', "");
    Expect(0, 8534, '\P{Is_Nv:0.40}', "");
    Expect(1, 8534, '\P{^Is_Nv:0.40}', "");
    Expect(0, 8535, '\p{Is_Nv:0.40}', "");
    Expect(1, 8535, '\p{^Is_Nv:0.40}', "");
    Expect(1, 8535, '\P{Is_Nv:0.40}', "");
    Expect(0, 8535, '\P{^Is_Nv:0.40}', "");
    Error('\p{Numeric_Value= :=020}');
    Error('\P{Numeric_Value= :=020}');
    Expect(1, 126219, '\p{Numeric_Value=:\A20\z:}', "");;
    Expect(0, 126220, '\p{Numeric_Value=:\A20\z:}', "");;
    Expect(1, 126219, '\p{Numeric_Value=+00_02_0}', "");
    Expect(0, 126219, '\p{^Numeric_Value=+00_02_0}', "");
    Expect(0, 126219, '\P{Numeric_Value=+00_02_0}', "");
    Expect(1, 126219, '\P{^Numeric_Value=+00_02_0}', "");
    Expect(0, 126220, '\p{Numeric_Value=+00_02_0}', "");
    Expect(1, 126220, '\p{^Numeric_Value=+00_02_0}', "");
    Expect(1, 126220, '\P{Numeric_Value=+00_02_0}', "");
    Expect(0, 126220, '\P{^Numeric_Value=+00_02_0}', "");
    Expect(1, 126219, '\p{Numeric_Value=2.000000000000000e+01}', "");
    Expect(0, 126219, '\p{^Numeric_Value=2.000000000000000e+01}', "");
    Expect(0, 126219, '\P{Numeric_Value=2.000000000000000e+01}', "");
    Expect(1, 126219, '\P{^Numeric_Value=2.000000000000000e+01}', "");
    Expect(0, 126220, '\p{Numeric_Value=2.000000000000000e+01}', "");
    Expect(1, 126220, '\p{^Numeric_Value=2.000000000000000e+01}', "");
    Expect(1, 126220, '\P{Numeric_Value=2.000000000000000e+01}', "");
    Expect(0, 126220, '\P{^Numeric_Value=2.000000000000000e+01}', "");
    Error('\p{Nv=:=-	02_0}');
    Error('\P{Nv=:=-	02_0}');
    Expect(1, 126219, '\p{Nv=:\A20\z:}', "");;
    Expect(0, 126220, '\p{Nv=:\A20\z:}', "");;
    Expect(1, 126219, '\p{Nv=+0_0_0_0_20}', "");
    Expect(0, 126219, '\p{^Nv=+0_0_0_0_20}', "");
    Expect(0, 126219, '\P{Nv=+0_0_0_0_20}', "");
    Expect(1, 126219, '\P{^Nv=+0_0_0_0_20}', "");
    Expect(0, 126220, '\p{Nv=+0_0_0_0_20}', "");
    Expect(1, 126220, '\p{^Nv=+0_0_0_0_20}', "");
    Expect(1, 126220, '\P{Nv=+0_0_0_0_20}', "");
    Expect(0, 126220, '\P{^Nv=+0_0_0_0_20}', "");
    Expect(1, 126219, '\p{Nv=2.000000000000000e+01}', "");
    Expect(0, 126219, '\p{^Nv=2.000000000000000e+01}', "");
    Expect(0, 126219, '\P{Nv=2.000000000000000e+01}', "");
    Expect(1, 126219, '\P{^Nv=2.000000000000000e+01}', "");
    Expect(0, 126220, '\p{Nv=2.000000000000000e+01}', "");
    Expect(1, 126220, '\p{^Nv=2.000000000000000e+01}', "");
    Expect(1, 126220, '\P{Nv=2.000000000000000e+01}', "");
    Expect(0, 126220, '\P{^Nv=2.000000000000000e+01}', "");
    Error('\p{Is_Numeric_Value=/a/_-+000020}');
    Error('\P{Is_Numeric_Value=/a/_-+000020}');
    Expect(1, 126219, '\p{Is_Numeric_Value=0020}', "");
    Expect(0, 126219, '\p{^Is_Numeric_Value=0020}', "");
    Expect(0, 126219, '\P{Is_Numeric_Value=0020}', "");
    Expect(1, 126219, '\P{^Is_Numeric_Value=0020}', "");
    Expect(0, 126220, '\p{Is_Numeric_Value=0020}', "");
    Expect(1, 126220, '\p{^Is_Numeric_Value=0020}', "");
    Expect(1, 126220, '\P{Is_Numeric_Value=0020}', "");
    Expect(0, 126220, '\P{^Is_Numeric_Value=0020}', "");
    Expect(1, 126219, '\p{Is_Numeric_Value=2.000000000000000e+01}', "");
    Expect(0, 126219, '\p{^Is_Numeric_Value=2.000000000000000e+01}', "");
    Expect(0, 126219, '\P{Is_Numeric_Value=2.000000000000000e+01}', "");
    Expect(1, 126219, '\P{^Is_Numeric_Value=2.000000000000000e+01}', "");
    Expect(0, 126220, '\p{Is_Numeric_Value=2.000000000000000e+01}', "");
    Expect(1, 126220, '\p{^Is_Numeric_Value=2.000000000000000e+01}', "");
    Expect(1, 126220, '\P{Is_Numeric_Value=2.000000000000000e+01}', "");
    Expect(0, 126220, '\P{^Is_Numeric_Value=2.000000000000000e+01}', "");
    Error('\p{Is_Nv=:=__00_00_00_20}');
    Error('\P{Is_Nv=:=__00_00_00_20}');
    Expect(1, 126219, '\p{Is_Nv:   0_0_0_0_0020}', "");
    Expect(0, 126219, '\p{^Is_Nv:   0_0_0_0_0020}', "");
    Expect(0, 126219, '\P{Is_Nv:   0_0_0_0_0020}', "");
    Expect(1, 126219, '\P{^Is_Nv:   0_0_0_0_0020}', "");
    Expect(0, 126220, '\p{Is_Nv:   0_0_0_0_0020}', "");
    Expect(1, 126220, '\p{^Is_Nv:   0_0_0_0_0020}', "");
    Expect(1, 126220, '\P{Is_Nv:   0_0_0_0_0020}', "");
    Expect(0, 126220, '\P{^Is_Nv:   0_0_0_0_0020}', "");
    Expect(1, 126219, '\p{Is_Nv=2.000000000000000e+01}', "");
    Expect(0, 126219, '\p{^Is_Nv=2.000000000000000e+01}', "");
    Expect(0, 126219, '\P{Is_Nv=2.000000000000000e+01}', "");
    Expect(1, 126219, '\P{^Is_Nv=2.000000000000000e+01}', "");
    Expect(0, 126220, '\p{Is_Nv=2.000000000000000e+01}', "");
    Expect(1, 126220, '\p{^Is_Nv=2.000000000000000e+01}', "");
    Expect(1, 126220, '\P{Is_Nv=2.000000000000000e+01}', "");
    Expect(0, 126220, '\P{^Is_Nv=2.000000000000000e+01}', "");
    Error('\p{Numeric_Value=/a/-_0_0_2_00}');
    Error('\P{Numeric_Value=/a/-_0_0_2_00}');
    Expect(1, 126228, '\p{Numeric_Value=:\A200\z:}', "");;
    Expect(0, 126229, '\p{Numeric_Value=:\A200\z:}', "");;
    Expect(1, 126228, '\p{Numeric_Value=000200}', "");
    Expect(0, 126228, '\p{^Numeric_Value=000200}', "");
    Expect(0, 126228, '\P{Numeric_Value=000200}', "");
    Expect(1, 126228, '\P{^Numeric_Value=000200}', "");
    Expect(0, 126229, '\p{Numeric_Value=000200}', "");
    Expect(1, 126229, '\p{^Numeric_Value=000200}', "");
    Expect(1, 126229, '\P{Numeric_Value=000200}', "");
    Expect(0, 126229, '\P{^Numeric_Value=000200}', "");
    Expect(1, 126228, '\p{Numeric_Value:   2.000000000000000e+02}', "");
    Expect(0, 126228, '\p{^Numeric_Value:   2.000000000000000e+02}', "");
    Expect(0, 126228, '\P{Numeric_Value:   2.000000000000000e+02}', "");
    Expect(1, 126228, '\P{^Numeric_Value:   2.000000000000000e+02}', "");
    Expect(0, 126229, '\p{Numeric_Value:   2.000000000000000e+02}', "");
    Expect(1, 126229, '\p{^Numeric_Value:   2.000000000000000e+02}', "");
    Expect(1, 126229, '\P{Numeric_Value:   2.000000000000000e+02}', "");
    Expect(0, 126229, '\P{^Numeric_Value:   2.000000000000000e+02}', "");
    Error('\p{Nv=/a/	+0020_0}');
    Error('\P{Nv=/a/	+0020_0}');
    Expect(1, 126228, '\p{Nv=:\A200\z:}', "");;
    Expect(0, 126229, '\p{Nv=:\A200\z:}', "");;
    Expect(1, 126228, '\p{Nv=+200}', "");
    Expect(0, 126228, '\p{^Nv=+200}', "");
    Expect(0, 126228, '\P{Nv=+200}', "");
    Expect(1, 126228, '\P{^Nv=+200}', "");
    Expect(0, 126229, '\p{Nv=+200}', "");
    Expect(1, 126229, '\p{^Nv=+200}', "");
    Expect(1, 126229, '\P{Nv=+200}', "");
    Expect(0, 126229, '\P{^Nv=+200}', "");
    Expect(1, 126228, '\p{Nv=2.000000000000000e+02}', "");
    Expect(0, 126228, '\p{^Nv=2.000000000000000e+02}', "");
    Expect(0, 126228, '\P{Nv=2.000000000000000e+02}', "");
    Expect(1, 126228, '\P{^Nv=2.000000000000000e+02}', "");
    Expect(0, 126229, '\p{Nv=2.000000000000000e+02}', "");
    Expect(1, 126229, '\p{^Nv=2.000000000000000e+02}', "");
    Expect(1, 126229, '\P{Nv=2.000000000000000e+02}', "");
    Expect(0, 126229, '\P{^Nv=2.000000000000000e+02}', "");
    Error('\p{Is_Numeric_Value:/a/--00_00_20_0}');
    Error('\P{Is_Numeric_Value:/a/--00_00_20_0}');
    Expect(1, 126228, '\p{Is_Numeric_Value=00_00_00_00_0200}', "");
    Expect(0, 126228, '\p{^Is_Numeric_Value=00_00_00_00_0200}', "");
    Expect(0, 126228, '\P{Is_Numeric_Value=00_00_00_00_0200}', "");
    Expect(1, 126228, '\P{^Is_Numeric_Value=00_00_00_00_0200}', "");
    Expect(0, 126229, '\p{Is_Numeric_Value=00_00_00_00_0200}', "");
    Expect(1, 126229, '\p{^Is_Numeric_Value=00_00_00_00_0200}', "");
    Expect(1, 126229, '\P{Is_Numeric_Value=00_00_00_00_0200}', "");
    Expect(0, 126229, '\P{^Is_Numeric_Value=00_00_00_00_0200}', "");
    Expect(1, 126228, '\p{Is_Numeric_Value=2.000000000000000e+02}', "");
    Expect(0, 126228, '\p{^Is_Numeric_Value=2.000000000000000e+02}', "");
    Expect(0, 126228, '\P{Is_Numeric_Value=2.000000000000000e+02}', "");
    Expect(1, 126228, '\P{^Is_Numeric_Value=2.000000000000000e+02}', "");
    Expect(0, 126229, '\p{Is_Numeric_Value=2.000000000000000e+02}', "");
    Expect(1, 126229, '\p{^Is_Numeric_Value=2.000000000000000e+02}', "");
    Expect(1, 126229, '\P{Is_Numeric_Value=2.000000000000000e+02}', "");
    Expect(0, 126229, '\P{^Is_Numeric_Value=2.000000000000000e+02}', "");
    Error('\p{Is_Nv=-/a/000020_0}');
    Error('\P{Is_Nv=-/a/000020_0}');
    Expect(1, 126228, '\p{Is_Nv=+0000200}', "");
    Expect(0, 126228, '\p{^Is_Nv=+0000200}', "");
    Expect(0, 126228, '\P{Is_Nv=+0000200}', "");
    Expect(1, 126228, '\P{^Is_Nv=+0000200}', "");
    Expect(0, 126229, '\p{Is_Nv=+0000200}', "");
    Expect(1, 126229, '\p{^Is_Nv=+0000200}', "");
    Expect(1, 126229, '\P{Is_Nv=+0000200}', "");
    Expect(0, 126229, '\P{^Is_Nv=+0000200}', "");
    Expect(1, 126228, '\p{Is_Nv=2.000000000000000e+02}', "");
    Expect(0, 126228, '\p{^Is_Nv=2.000000000000000e+02}', "");
    Expect(0, 126228, '\P{Is_Nv=2.000000000000000e+02}', "");
    Expect(1, 126228, '\P{^Is_Nv=2.000000000000000e+02}', "");
    Expect(0, 126229, '\p{Is_Nv=2.000000000000000e+02}', "");
    Expect(1, 126229, '\p{^Is_Nv=2.000000000000000e+02}', "");
    Expect(1, 126229, '\P{Is_Nv=2.000000000000000e+02}', "");
    Expect(0, 126229, '\P{^Is_Nv=2.000000000000000e+02}', "");
    Error('\p{Numeric_Value: /a/	2000}');
    Error('\P{Numeric_Value: /a/	2000}');
    Expect(1, 126266, '\p{Numeric_Value=:\A2000\z:}', "");;
    Expect(0, 126267, '\p{Numeric_Value=:\A2000\z:}', "");;
    Expect(1, 126266, '\p{Numeric_Value=200_0}', "");
    Expect(0, 126266, '\p{^Numeric_Value=200_0}', "");
    Expect(0, 126266, '\P{Numeric_Value=200_0}', "");
    Expect(1, 126266, '\P{^Numeric_Value=200_0}', "");
    Expect(0, 126267, '\p{Numeric_Value=200_0}', "");
    Expect(1, 126267, '\p{^Numeric_Value=200_0}', "");
    Expect(1, 126267, '\P{Numeric_Value=200_0}', "");
    Expect(0, 126267, '\P{^Numeric_Value=200_0}', "");
    Expect(1, 126266, '\p{Numeric_Value=2.000000000000000e+03}', "");
    Expect(0, 126266, '\p{^Numeric_Value=2.000000000000000e+03}', "");
    Expect(0, 126266, '\P{Numeric_Value=2.000000000000000e+03}', "");
    Expect(1, 126266, '\P{^Numeric_Value=2.000000000000000e+03}', "");
    Expect(0, 126267, '\p{Numeric_Value=2.000000000000000e+03}', "");
    Expect(1, 126267, '\p{^Numeric_Value=2.000000000000000e+03}', "");
    Expect(1, 126267, '\P{Numeric_Value=2.000000000000000e+03}', "");
    Expect(0, 126267, '\P{^Numeric_Value=2.000000000000000e+03}', "");
    Error('\p{Nv=	-0_0_0_0_2_0_00:=}');
    Error('\P{Nv=	-0_0_0_0_2_0_00:=}');
    Expect(1, 126266, '\p{Nv=:\A2000\z:}', "");;
    Expect(0, 126267, '\p{Nv=:\A2000\z:}', "");;
    Expect(1, 126266, '\p{Nv:   002000}', "");
    Expect(0, 126266, '\p{^Nv:   002000}', "");
    Expect(0, 126266, '\P{Nv:   002000}', "");
    Expect(1, 126266, '\P{^Nv:   002000}', "");
    Expect(0, 126267, '\p{Nv:   002000}', "");
    Expect(1, 126267, '\p{^Nv:   002000}', "");
    Expect(1, 126267, '\P{Nv:   002000}', "");
    Expect(0, 126267, '\P{^Nv:   002000}', "");
    Expect(1, 126266, '\p{Nv=2.000000000000000e+03}', "");
    Expect(0, 126266, '\p{^Nv=2.000000000000000e+03}', "");
    Expect(0, 126266, '\P{Nv=2.000000000000000e+03}', "");
    Expect(1, 126266, '\P{^Nv=2.000000000000000e+03}', "");
    Expect(0, 126267, '\p{Nv=2.000000000000000e+03}', "");
    Expect(1, 126267, '\p{^Nv=2.000000000000000e+03}', "");
    Expect(1, 126267, '\P{Nv=2.000000000000000e+03}', "");
    Expect(0, 126267, '\P{^Nv=2.000000000000000e+03}', "");
    Error('\p{Is_Numeric_Value=_/a/00002000}');
    Error('\P{Is_Numeric_Value=_/a/00002000}');
    Expect(1, 126266, '\p{Is_Numeric_Value=000000002000}', "");
    Expect(0, 126266, '\p{^Is_Numeric_Value=000000002000}', "");
    Expect(0, 126266, '\P{Is_Numeric_Value=000000002000}', "");
    Expect(1, 126266, '\P{^Is_Numeric_Value=000000002000}', "");
    Expect(0, 126267, '\p{Is_Numeric_Value=000000002000}', "");
    Expect(1, 126267, '\p{^Is_Numeric_Value=000000002000}', "");
    Expect(1, 126267, '\P{Is_Numeric_Value=000000002000}', "");
    Expect(0, 126267, '\P{^Is_Numeric_Value=000000002000}', "");
    Expect(1, 126266, '\p{Is_Numeric_Value=2.000000000000000e+03}', "");
    Expect(0, 126266, '\p{^Is_Numeric_Value=2.000000000000000e+03}', "");
    Expect(0, 126266, '\P{Is_Numeric_Value=2.000000000000000e+03}', "");
    Expect(1, 126266, '\P{^Is_Numeric_Value=2.000000000000000e+03}', "");
    Expect(0, 126267, '\p{Is_Numeric_Value=2.000000000000000e+03}', "");
    Expect(1, 126267, '\p{^Is_Numeric_Value=2.000000000000000e+03}', "");
    Expect(1, 126267, '\P{Is_Numeric_Value=2.000000000000000e+03}', "");
    Expect(0, 126267, '\P{^Is_Numeric_Value=2.000000000000000e+03}', "");
    Error('\p{Is_Nv=:=+00_00_00_00_20_00}');
    Error('\P{Is_Nv=:=+00_00_00_00_20_00}');
    Expect(1, 126266, '\p{Is_Nv=+0000000002000}', "");
    Expect(0, 126266, '\p{^Is_Nv=+0000000002000}', "");
    Expect(0, 126266, '\P{Is_Nv=+0000000002000}', "");
    Expect(1, 126266, '\P{^Is_Nv=+0000000002000}', "");
    Expect(0, 126267, '\p{Is_Nv=+0000000002000}', "");
    Expect(1, 126267, '\p{^Is_Nv=+0000000002000}', "");
    Expect(1, 126267, '\P{Is_Nv=+0000000002000}', "");
    Expect(0, 126267, '\P{^Is_Nv=+0000000002000}', "");
    Expect(1, 126266, '\p{Is_Nv=2.000000000000000e+03}', "");
    Expect(0, 126266, '\p{^Is_Nv=2.000000000000000e+03}', "");
    Expect(0, 126266, '\P{Is_Nv=2.000000000000000e+03}', "");
    Expect(1, 126266, '\P{^Is_Nv=2.000000000000000e+03}', "");
    Expect(0, 126267, '\p{Is_Nv=2.000000000000000e+03}', "");
    Expect(1, 126267, '\p{^Is_Nv=2.000000000000000e+03}', "");
    Expect(1, 126267, '\P{Is_Nv=2.000000000000000e+03}', "");
    Expect(0, 126267, '\P{^Is_Nv=2.000000000000000e+03}', "");
    Error('\p{Numeric_Value:   :=	_+2_0_0_00}');
    Error('\P{Numeric_Value:   :=	_+2_0_0_00}');
    Expect(1, 126246, '\p{Numeric_Value=:\A20000\z:}', "");;
    Expect(0, 126247, '\p{Numeric_Value=:\A20000\z:}', "");;
    Expect(1, 126246, '\p{Numeric_Value=0000_0000_0200_00}', "");
    Expect(0, 126246, '\p{^Numeric_Value=0000_0000_0200_00}', "");
    Expect(0, 126246, '\P{Numeric_Value=0000_0000_0200_00}', "");
    Expect(1, 126246, '\P{^Numeric_Value=0000_0000_0200_00}', "");
    Expect(0, 126247, '\p{Numeric_Value=0000_0000_0200_00}', "");
    Expect(1, 126247, '\p{^Numeric_Value=0000_0000_0200_00}', "");
    Expect(1, 126247, '\P{Numeric_Value=0000_0000_0200_00}', "");
    Expect(0, 126247, '\P{^Numeric_Value=0000_0000_0200_00}', "");
    Expect(1, 126246, '\p{Numeric_Value=2.000000000000000e+04}', "");
    Expect(0, 126246, '\p{^Numeric_Value=2.000000000000000e+04}', "");
    Expect(0, 126246, '\P{Numeric_Value=2.000000000000000e+04}', "");
    Expect(1, 126246, '\P{^Numeric_Value=2.000000000000000e+04}', "");
    Expect(0, 126247, '\p{Numeric_Value=2.000000000000000e+04}', "");
    Expect(1, 126247, '\p{^Numeric_Value=2.000000000000000e+04}', "");
    Expect(1, 126247, '\P{Numeric_Value=2.000000000000000e+04}', "");
    Expect(0, 126247, '\P{^Numeric_Value=2.000000000000000e+04}', "");
    Error('\p{Nv=:= _000020000}');
    Error('\P{Nv=:= _000020000}');
    Expect(1, 126246, '\p{Nv=:\A20000\z:}', "");;
    Expect(0, 126247, '\p{Nv=:\A20000\z:}', "");;
    Expect(1, 126246, '\p{Nv=00000002000_0}', "");
    Expect(0, 126246, '\p{^Nv=00000002000_0}', "");
    Expect(0, 126246, '\P{Nv=00000002000_0}', "");
    Expect(1, 126246, '\P{^Nv=00000002000_0}', "");
    Expect(0, 126247, '\p{Nv=00000002000_0}', "");
    Expect(1, 126247, '\p{^Nv=00000002000_0}', "");
    Expect(1, 126247, '\P{Nv=00000002000_0}', "");
    Expect(0, 126247, '\P{^Nv=00000002000_0}', "");
    Expect(1, 126246, '\p{Nv=2.000000000000000e+04}', "");
    Expect(0, 126246, '\p{^Nv=2.000000000000000e+04}', "");
    Expect(0, 126246, '\P{Nv=2.000000000000000e+04}', "");
    Expect(1, 126246, '\P{^Nv=2.000000000000000e+04}', "");
    Expect(0, 126247, '\p{Nv=2.000000000000000e+04}', "");
    Expect(1, 126247, '\p{^Nv=2.000000000000000e+04}', "");
    Expect(1, 126247, '\P{Nv=2.000000000000000e+04}', "");
    Expect(0, 126247, '\P{^Nv=2.000000000000000e+04}', "");
    Error('\p{Is_Numeric_Value= -0_0_0_0_0_0_0_2_0_0_00/a/}');
    Error('\P{Is_Numeric_Value= -0_0_0_0_0_0_0_2_0_0_00/a/}');
    Expect(1, 126246, '\p{Is_Numeric_Value=+00000000020000}', "");
    Expect(0, 126246, '\p{^Is_Numeric_Value=+00000000020000}', "");
    Expect(0, 126246, '\P{Is_Numeric_Value=+00000000020000}', "");
    Expect(1, 126246, '\P{^Is_Numeric_Value=+00000000020000}', "");
    Expect(0, 126247, '\p{Is_Numeric_Value=+00000000020000}', "");
    Expect(1, 126247, '\p{^Is_Numeric_Value=+00000000020000}', "");
    Expect(1, 126247, '\P{Is_Numeric_Value=+00000000020000}', "");
    Expect(0, 126247, '\P{^Is_Numeric_Value=+00000000020000}', "");
    Expect(1, 126246, '\p{Is_Numeric_Value=2.000000000000000e+04}', "");
    Expect(0, 126246, '\p{^Is_Numeric_Value=2.000000000000000e+04}', "");
    Expect(0, 126246, '\P{Is_Numeric_Value=2.000000000000000e+04}', "");
    Expect(1, 126246, '\P{^Is_Numeric_Value=2.000000000000000e+04}', "");
    Expect(0, 126247, '\p{Is_Numeric_Value=2.000000000000000e+04}', "");
    Expect(1, 126247, '\p{^Is_Numeric_Value=2.000000000000000e+04}', "");
    Expect(1, 126247, '\P{Is_Numeric_Value=2.000000000000000e+04}', "");
    Expect(0, 126247, '\P{^Is_Numeric_Value=2.000000000000000e+04}', "");
    Error('\p{Is_Nv:  /a/020000}');
    Error('\P{Is_Nv:  /a/020000}');
    Expect(1, 126246, '\p{Is_Nv=0000002000_0}', "");
    Expect(0, 126246, '\p{^Is_Nv=0000002000_0}', "");
    Expect(0, 126246, '\P{Is_Nv=0000002000_0}', "");
    Expect(1, 126246, '\P{^Is_Nv=0000002000_0}', "");
    Expect(0, 126247, '\p{Is_Nv=0000002000_0}', "");
    Expect(1, 126247, '\p{^Is_Nv=0000002000_0}', "");
    Expect(1, 126247, '\P{Is_Nv=0000002000_0}', "");
    Expect(0, 126247, '\P{^Is_Nv=0000002000_0}', "");
    Expect(1, 126246, '\p{Is_Nv=2.000000000000000e+04}', "");
    Expect(0, 126246, '\p{^Is_Nv=2.000000000000000e+04}', "");
    Expect(0, 126246, '\P{Is_Nv=2.000000000000000e+04}', "");
    Expect(1, 126246, '\P{^Is_Nv=2.000000000000000e+04}', "");
    Expect(0, 126247, '\p{Is_Nv=2.000000000000000e+04}', "");
    Expect(1, 126247, '\p{^Is_Nv=2.000000000000000e+04}', "");
    Expect(1, 126247, '\P{Is_Nv=2.000000000000000e+04}', "");
    Expect(0, 126247, '\P{^Is_Nv=2.000000000000000e+04}', "");
    Error('\p{Numeric_Value=:= 0_0_0_0_0_0_0_0_0_200000}');
    Error('\P{Numeric_Value=:= 0_0_0_0_0_0_0_0_0_200000}');
    Expect(1, 126111, '\p{Numeric_Value=:\A200000\z:}', "");;
    Expect(0, 126112, '\p{Numeric_Value=:\A200000\z:}', "");;
    Expect(1, 126111, '\p{Numeric_Value=0_0_0_0_2_00000}', "");
    Expect(0, 126111, '\p{^Numeric_Value=0_0_0_0_2_00000}', "");
    Expect(0, 126111, '\P{Numeric_Value=0_0_0_0_2_00000}', "");
    Expect(1, 126111, '\P{^Numeric_Value=0_0_0_0_2_00000}', "");
    Expect(0, 126112, '\p{Numeric_Value=0_0_0_0_2_00000}', "");
    Expect(1, 126112, '\p{^Numeric_Value=0_0_0_0_2_00000}', "");
    Expect(1, 126112, '\P{Numeric_Value=0_0_0_0_2_00000}', "");
    Expect(0, 126112, '\P{^Numeric_Value=0_0_0_0_2_00000}', "");
    Expect(1, 126111, '\p{Numeric_Value=2.000000000000000e+05}', "");
    Expect(0, 126111, '\p{^Numeric_Value=2.000000000000000e+05}', "");
    Expect(0, 126111, '\P{Numeric_Value=2.000000000000000e+05}', "");
    Expect(1, 126111, '\P{^Numeric_Value=2.000000000000000e+05}', "");
    Expect(0, 126112, '\p{Numeric_Value=2.000000000000000e+05}', "");
    Expect(1, 126112, '\p{^Numeric_Value=2.000000000000000e+05}', "");
    Expect(1, 126112, '\P{Numeric_Value=2.000000000000000e+05}', "");
    Expect(0, 126112, '\P{^Numeric_Value=2.000000000000000e+05}', "");
    Error('\p{Nv=/a/ 	00000200000}');
    Error('\P{Nv=/a/ 	00000200000}');
    Expect(1, 126111, '\p{Nv=:\A200000\z:}', "");;
    Expect(0, 126112, '\p{Nv=:\A200000\z:}', "");;
    Expect(1, 126111, '\p{Nv=000200000}', "");
    Expect(0, 126111, '\p{^Nv=000200000}', "");
    Expect(0, 126111, '\P{Nv=000200000}', "");
    Expect(1, 126111, '\P{^Nv=000200000}', "");
    Expect(0, 126112, '\p{Nv=000200000}', "");
    Expect(1, 126112, '\p{^Nv=000200000}', "");
    Expect(1, 126112, '\P{Nv=000200000}', "");
    Expect(0, 126112, '\P{^Nv=000200000}', "");
    Expect(1, 126111, '\p{Nv=2.000000000000000e+05}', "");
    Expect(0, 126111, '\p{^Nv=2.000000000000000e+05}', "");
    Expect(0, 126111, '\P{Nv=2.000000000000000e+05}', "");
    Expect(1, 126111, '\P{^Nv=2.000000000000000e+05}', "");
    Expect(0, 126112, '\p{Nv=2.000000000000000e+05}', "");
    Expect(1, 126112, '\p{^Nv=2.000000000000000e+05}', "");
    Expect(1, 126112, '\P{Nv=2.000000000000000e+05}', "");
    Expect(0, 126112, '\P{^Nv=2.000000000000000e+05}', "");
    Error('\p{Is_Numeric_Value=_/a/+0_0_0_0_0_2_0_0_0_00}');
    Error('\P{Is_Numeric_Value=_/a/+0_0_0_0_0_2_0_0_0_00}');
    Expect(1, 126111, '\p{Is_Numeric_Value=+0000000020000_0}', "");
    Expect(0, 126111, '\p{^Is_Numeric_Value=+0000000020000_0}', "");
    Expect(0, 126111, '\P{Is_Numeric_Value=+0000000020000_0}', "");
    Expect(1, 126111, '\P{^Is_Numeric_Value=+0000000020000_0}', "");
    Expect(0, 126112, '\p{Is_Numeric_Value=+0000000020000_0}', "");
    Expect(1, 126112, '\p{^Is_Numeric_Value=+0000000020000_0}', "");
    Expect(1, 126112, '\P{Is_Numeric_Value=+0000000020000_0}', "");
    Expect(0, 126112, '\P{^Is_Numeric_Value=+0000000020000_0}', "");
    Expect(1, 126111, '\p{Is_Numeric_Value=2.000000000000000e+05}', "");
    Expect(0, 126111, '\p{^Is_Numeric_Value=2.000000000000000e+05}', "");
    Expect(0, 126111, '\P{Is_Numeric_Value=2.000000000000000e+05}', "");
    Expect(1, 126111, '\P{^Is_Numeric_Value=2.000000000000000e+05}', "");
    Expect(0, 126112, '\p{Is_Numeric_Value=2.000000000000000e+05}', "");
    Expect(1, 126112, '\p{^Is_Numeric_Value=2.000000000000000e+05}', "");
    Expect(1, 126112, '\P{Is_Numeric_Value=2.000000000000000e+05}', "");
    Expect(0, 126112, '\P{^Is_Numeric_Value=2.000000000000000e+05}', "");
    Error('\p{Is_Nv=/a/-+0000200000}');
    Error('\P{Is_Nv=/a/-+0000200000}');
    Expect(1, 126111, '\p{Is_Nv:	0020000_0}', "");
    Expect(0, 126111, '\p{^Is_Nv:	0020000_0}', "");
    Expect(0, 126111, '\P{Is_Nv:	0020000_0}', "");
    Expect(1, 126111, '\P{^Is_Nv:	0020000_0}', "");
    Expect(0, 126112, '\p{Is_Nv:	0020000_0}', "");
    Expect(1, 126112, '\p{^Is_Nv:	0020000_0}', "");
    Expect(1, 126112, '\P{Is_Nv:	0020000_0}', "");
    Expect(0, 126112, '\P{^Is_Nv:	0020000_0}', "");
    Expect(1, 126111, '\p{Is_Nv=2.000000000000000e+05}', "");
    Expect(0, 126111, '\p{^Is_Nv=2.000000000000000e+05}', "");
    Expect(0, 126111, '\P{Is_Nv=2.000000000000000e+05}', "");
    Expect(1, 126111, '\P{^Is_Nv=2.000000000000000e+05}', "");
    Expect(0, 126112, '\p{Is_Nv=2.000000000000000e+05}', "");
    Expect(1, 126112, '\p{^Is_Nv=2.000000000000000e+05}', "");
    Expect(1, 126112, '\P{Is_Nv=2.000000000000000e+05}', "");
    Expect(0, 126112, '\P{^Is_Nv=2.000000000000000e+05}', "");
    Error('\p{Numeric_Value=--+00020000000:=}');
    Error('\P{Numeric_Value=--+00020000000:=}');
    Expect(1, 126114, '\p{Numeric_Value=:\A20000000\z:}', "");;
    Expect(0, 126115, '\p{Numeric_Value=:\A20000000\z:}', "");;
    Expect(1, 126114, '\p{Numeric_Value=0_0_0_0_2_0_0_00000}', "");
    Expect(0, 126114, '\p{^Numeric_Value=0_0_0_0_2_0_0_00000}', "");
    Expect(0, 126114, '\P{Numeric_Value=0_0_0_0_2_0_0_00000}', "");
    Expect(1, 126114, '\P{^Numeric_Value=0_0_0_0_2_0_0_00000}', "");
    Expect(0, 126115, '\p{Numeric_Value=0_0_0_0_2_0_0_00000}', "");
    Expect(1, 126115, '\p{^Numeric_Value=0_0_0_0_2_0_0_00000}', "");
    Expect(1, 126115, '\P{Numeric_Value=0_0_0_0_2_0_0_00000}', "");
    Expect(0, 126115, '\P{^Numeric_Value=0_0_0_0_2_0_0_00000}', "");
    Expect(1, 126114, '\p{Numeric_Value=2.000000000000000e+07}', "");
    Expect(0, 126114, '\p{^Numeric_Value=2.000000000000000e+07}', "");
    Expect(0, 126114, '\P{Numeric_Value=2.000000000000000e+07}', "");
    Expect(1, 126114, '\P{^Numeric_Value=2.000000000000000e+07}', "");
    Expect(0, 126115, '\p{Numeric_Value=2.000000000000000e+07}', "");
    Expect(1, 126115, '\p{^Numeric_Value=2.000000000000000e+07}', "");
    Expect(1, 126115, '\P{Numeric_Value=2.000000000000000e+07}', "");
    Expect(0, 126115, '\P{^Numeric_Value=2.000000000000000e+07}', "");
    Error('\p{Nv=:=0_0_0_0_2_0_000000}');
    Error('\P{Nv=:=0_0_0_0_2_0_000000}');
    Expect(1, 126114, '\p{Nv=:\A20000000\z:}', "");;
    Expect(0, 126115, '\p{Nv=:\A20000000\z:}', "");;
    Expect(1, 126114, '\p{Nv=+0000000020000000}', "");
    Expect(0, 126114, '\p{^Nv=+0000000020000000}', "");
    Expect(0, 126114, '\P{Nv=+0000000020000000}', "");
    Expect(1, 126114, '\P{^Nv=+0000000020000000}', "");
    Expect(0, 126115, '\p{Nv=+0000000020000000}', "");
    Expect(1, 126115, '\p{^Nv=+0000000020000000}', "");
    Expect(1, 126115, '\P{Nv=+0000000020000000}', "");
    Expect(0, 126115, '\P{^Nv=+0000000020000000}', "");
    Expect(1, 126114, '\p{Nv=2.000000000000000e+07}', "");
    Expect(0, 126114, '\p{^Nv=2.000000000000000e+07}', "");
    Expect(0, 126114, '\P{Nv=2.000000000000000e+07}', "");
    Expect(1, 126114, '\P{^Nv=2.000000000000000e+07}', "");
    Expect(0, 126115, '\p{Nv=2.000000000000000e+07}', "");
    Expect(1, 126115, '\p{^Nv=2.000000000000000e+07}', "");
    Expect(1, 126115, '\P{Nv=2.000000000000000e+07}', "");
    Expect(0, 126115, '\P{^Nv=2.000000000000000e+07}', "");
    Error('\p{Is_Numeric_Value=__+020000000:=}');
    Error('\P{Is_Numeric_Value=__+020000000:=}');
    Expect(1, 126114, '\p{Is_Numeric_Value=+00000020000000}', "");
    Expect(0, 126114, '\p{^Is_Numeric_Value=+00000020000000}', "");
    Expect(0, 126114, '\P{Is_Numeric_Value=+00000020000000}', "");
    Expect(1, 126114, '\P{^Is_Numeric_Value=+00000020000000}', "");
    Expect(0, 126115, '\p{Is_Numeric_Value=+00000020000000}', "");
    Expect(1, 126115, '\p{^Is_Numeric_Value=+00000020000000}', "");
    Expect(1, 126115, '\P{Is_Numeric_Value=+00000020000000}', "");
    Expect(0, 126115, '\P{^Is_Numeric_Value=+00000020000000}', "");
    Expect(1, 126114, '\p{Is_Numeric_Value=2.000000000000000e+07}', "");
    Expect(0, 126114, '\p{^Is_Numeric_Value=2.000000000000000e+07}', "");
    Expect(0, 126114, '\P{Is_Numeric_Value=2.000000000000000e+07}', "");
    Expect(1, 126114, '\P{^Is_Numeric_Value=2.000000000000000e+07}', "");
    Expect(0, 126115, '\p{Is_Numeric_Value=2.000000000000000e+07}', "");
    Expect(1, 126115, '\p{^Is_Numeric_Value=2.000000000000000e+07}', "");
    Expect(1, 126115, '\P{Is_Numeric_Value=2.000000000000000e+07}', "");
    Expect(0, 126115, '\P{^Is_Numeric_Value=2.000000000000000e+07}', "");
    Error('\p{Is_Nv=-:=020000000}');
    Error('\P{Is_Nv=-:=020000000}');
    Expect(1, 126114, '\p{Is_Nv=000020000000}', "");
    Expect(0, 126114, '\p{^Is_Nv=000020000000}', "");
    Expect(0, 126114, '\P{Is_Nv=000020000000}', "");
    Expect(1, 126114, '\P{^Is_Nv=000020000000}', "");
    Expect(0, 126115, '\p{Is_Nv=000020000000}', "");
    Expect(1, 126115, '\p{^Is_Nv=000020000000}', "");
    Expect(1, 126115, '\P{Is_Nv=000020000000}', "");
    Expect(0, 126115, '\P{^Is_Nv=000020000000}', "");
    Expect(1, 126114, '\p{Is_Nv:	2.000000000000000e+07}', "");
    Expect(0, 126114, '\p{^Is_Nv:	2.000000000000000e+07}', "");
    Expect(0, 126114, '\P{Is_Nv:	2.000000000000000e+07}', "");
    Expect(1, 126114, '\P{^Is_Nv:	2.000000000000000e+07}', "");
    Expect(0, 126115, '\p{Is_Nv:	2.000000000000000e+07}', "");
    Expect(1, 126115, '\p{^Is_Nv:	2.000000000000000e+07}', "");
    Expect(1, 126115, '\P{Is_Nv:	2.000000000000000e+07}', "");
    Expect(0, 126115, '\P{^Is_Nv:	2.000000000000000e+07}', "");
    Error('\p{Numeric_Value=-:=000000021}');
    Error('\P{Numeric_Value=-:=000000021}');
    Expect(1, 12881, '\p{Numeric_Value=:\A21\z:}', "");;
    Expect(0, 12882, '\p{Numeric_Value=:\A21\z:}', "");;
    Expect(1, 12881, '\p{Numeric_Value=000021}', "");
    Expect(0, 12881, '\p{^Numeric_Value=000021}', "");
    Expect(0, 12881, '\P{Numeric_Value=000021}', "");
    Expect(1, 12881, '\P{^Numeric_Value=000021}', "");
    Expect(0, 12882, '\p{Numeric_Value=000021}', "");
    Expect(1, 12882, '\p{^Numeric_Value=000021}', "");
    Expect(1, 12882, '\P{Numeric_Value=000021}', "");
    Expect(0, 12882, '\P{^Numeric_Value=000021}', "");
    Expect(1, 12881, '\p{Numeric_Value=2.100000000000000e+01}', "");
    Expect(0, 12881, '\p{^Numeric_Value=2.100000000000000e+01}', "");
    Expect(0, 12881, '\P{Numeric_Value=2.100000000000000e+01}', "");
    Expect(1, 12881, '\P{^Numeric_Value=2.100000000000000e+01}', "");
    Expect(0, 12882, '\p{Numeric_Value=2.100000000000000e+01}', "");
    Expect(1, 12882, '\p{^Numeric_Value=2.100000000000000e+01}', "");
    Expect(1, 12882, '\P{Numeric_Value=2.100000000000000e+01}', "");
    Expect(0, 12882, '\P{^Numeric_Value=2.100000000000000e+01}', "");
    Error('\p{Nv=-+00000000021/a/}');
    Error('\P{Nv=-+00000000021/a/}');
    Expect(1, 12881, '\p{Nv=:\A21\z:}', "");;
    Expect(0, 12882, '\p{Nv=:\A21\z:}', "");;
    Expect(1, 12881, '\p{Nv=+02_1}', "");
    Expect(0, 12881, '\p{^Nv=+02_1}', "");
    Expect(0, 12881, '\P{Nv=+02_1}', "");
    Expect(1, 12881, '\P{^Nv=+02_1}', "");
    Expect(0, 12882, '\p{Nv=+02_1}', "");
    Expect(1, 12882, '\p{^Nv=+02_1}', "");
    Expect(1, 12882, '\P{Nv=+02_1}', "");
    Expect(0, 12882, '\P{^Nv=+02_1}', "");
    Expect(1, 12881, '\p{Nv=2.100000000000000e+01}', "");
    Expect(0, 12881, '\p{^Nv=2.100000000000000e+01}', "");
    Expect(0, 12881, '\P{Nv=2.100000000000000e+01}', "");
    Expect(1, 12881, '\P{^Nv=2.100000000000000e+01}', "");
    Expect(0, 12882, '\p{Nv=2.100000000000000e+01}', "");
    Expect(1, 12882, '\p{^Nv=2.100000000000000e+01}', "");
    Expect(1, 12882, '\P{Nv=2.100000000000000e+01}', "");
    Expect(0, 12882, '\P{^Nv=2.100000000000000e+01}', "");
    Error('\p{Is_Numeric_Value=		21/a/}');
    Error('\P{Is_Numeric_Value=		21/a/}');
    Expect(1, 12881, '\p{Is_Numeric_Value=+0000000021}', "");
    Expect(0, 12881, '\p{^Is_Numeric_Value=+0000000021}', "");
    Expect(0, 12881, '\P{Is_Numeric_Value=+0000000021}', "");
    Expect(1, 12881, '\P{^Is_Numeric_Value=+0000000021}', "");
    Expect(0, 12882, '\p{Is_Numeric_Value=+0000000021}', "");
    Expect(1, 12882, '\p{^Is_Numeric_Value=+0000000021}', "");
    Expect(1, 12882, '\P{Is_Numeric_Value=+0000000021}', "");
    Expect(0, 12882, '\P{^Is_Numeric_Value=+0000000021}', "");
    Expect(1, 12881, '\p{Is_Numeric_Value=2.100000000000000e+01}', "");
    Expect(0, 12881, '\p{^Is_Numeric_Value=2.100000000000000e+01}', "");
    Expect(0, 12881, '\P{Is_Numeric_Value=2.100000000000000e+01}', "");
    Expect(1, 12881, '\P{^Is_Numeric_Value=2.100000000000000e+01}', "");
    Expect(0, 12882, '\p{Is_Numeric_Value=2.100000000000000e+01}', "");
    Expect(1, 12882, '\p{^Is_Numeric_Value=2.100000000000000e+01}', "");
    Expect(1, 12882, '\P{Is_Numeric_Value=2.100000000000000e+01}', "");
    Expect(0, 12882, '\P{^Is_Numeric_Value=2.100000000000000e+01}', "");
    Error('\p{Is_Nv=/a/ 	+21}');
    Error('\P{Is_Nv=/a/ 	+21}');
    Expect(1, 12881, '\p{Is_Nv=00021}', "");
    Expect(0, 12881, '\p{^Is_Nv=00021}', "");
    Expect(0, 12881, '\P{Is_Nv=00021}', "");
    Expect(1, 12881, '\P{^Is_Nv=00021}', "");
    Expect(0, 12882, '\p{Is_Nv=00021}', "");
    Expect(1, 12882, '\p{^Is_Nv=00021}', "");
    Expect(1, 12882, '\P{Is_Nv=00021}', "");
    Expect(0, 12882, '\P{^Is_Nv=00021}', "");
    Expect(1, 12881, '\p{Is_Nv=2.100000000000000e+01}', "");
    Expect(0, 12881, '\p{^Is_Nv=2.100000000000000e+01}', "");
    Expect(0, 12881, '\P{Is_Nv=2.100000000000000e+01}', "");
    Expect(1, 12881, '\P{^Is_Nv=2.100000000000000e+01}', "");
    Expect(0, 12882, '\p{Is_Nv=2.100000000000000e+01}', "");
    Expect(1, 12882, '\p{^Is_Nv=2.100000000000000e+01}', "");
    Expect(1, 12882, '\P{Is_Nv=2.100000000000000e+01}', "");
    Expect(0, 12882, '\P{^Is_Nv=2.100000000000000e+01}', "");
    Error('\p{Numeric_Value:		+00000_21600_0/a/}');
    Error('\P{Numeric_Value:		+00000_21600_0/a/}');
    Expect(1, 74802, '\p{Numeric_Value=:\A216000\z:}', "");;
    Expect(0, 74803, '\p{Numeric_Value=:\A216000\z:}', "");;
    Expect(1, 74802, '\p{Numeric_Value=0000_2160_00}', "");
    Expect(0, 74802, '\p{^Numeric_Value=0000_2160_00}', "");
    Expect(0, 74802, '\P{Numeric_Value=0000_2160_00}', "");
    Expect(1, 74802, '\P{^Numeric_Value=0000_2160_00}', "");
    Expect(0, 74803, '\p{Numeric_Value=0000_2160_00}', "");
    Expect(1, 74803, '\p{^Numeric_Value=0000_2160_00}', "");
    Expect(1, 74803, '\P{Numeric_Value=0000_2160_00}', "");
    Expect(0, 74803, '\P{^Numeric_Value=0000_2160_00}', "");
    Expect(1, 74802, '\p{Numeric_Value=2.160000000000000e+05}', "");
    Expect(0, 74802, '\p{^Numeric_Value=2.160000000000000e+05}', "");
    Expect(0, 74802, '\P{Numeric_Value=2.160000000000000e+05}', "");
    Expect(1, 74802, '\P{^Numeric_Value=2.160000000000000e+05}', "");
    Expect(0, 74803, '\p{Numeric_Value=2.160000000000000e+05}', "");
    Expect(1, 74803, '\p{^Numeric_Value=2.160000000000000e+05}', "");
    Expect(1, 74803, '\P{Numeric_Value=2.160000000000000e+05}', "");
    Expect(0, 74803, '\P{^Numeric_Value=2.160000000000000e+05}', "");
    Error('\p{Nv=/a/		0_0_0_0_0_2_1_6000}');
    Error('\P{Nv=/a/		0_0_0_0_0_2_1_6000}');
    Expect(1, 74802, '\p{Nv=:\A216000\z:}', "");;
    Expect(0, 74803, '\p{Nv=:\A216000\z:}', "");;
    Expect(1, 74802, '\p{Nv=000000000216000}', "");
    Expect(0, 74802, '\p{^Nv=000000000216000}', "");
    Expect(0, 74802, '\P{Nv=000000000216000}', "");
    Expect(1, 74802, '\P{^Nv=000000000216000}', "");
    Expect(0, 74803, '\p{Nv=000000000216000}', "");
    Expect(1, 74803, '\p{^Nv=000000000216000}', "");
    Expect(1, 74803, '\P{Nv=000000000216000}', "");
    Expect(0, 74803, '\P{^Nv=000000000216000}', "");
    Expect(1, 74802, '\p{Nv:   2.160000000000000e+05}', "");
    Expect(0, 74802, '\p{^Nv:   2.160000000000000e+05}', "");
    Expect(0, 74802, '\P{Nv:   2.160000000000000e+05}', "");
    Expect(1, 74802, '\P{^Nv:   2.160000000000000e+05}', "");
    Expect(0, 74803, '\p{Nv:   2.160000000000000e+05}', "");
    Expect(1, 74803, '\p{^Nv:   2.160000000000000e+05}', "");
    Expect(1, 74803, '\P{Nv:   2.160000000000000e+05}', "");
    Expect(0, 74803, '\P{^Nv:   2.160000000000000e+05}', "");
    Error('\p{Is_Numeric_Value::=_ 0216000}');
    Error('\P{Is_Numeric_Value::=_ 0216000}');
    Expect(1, 74802, '\p{Is_Numeric_Value=+2_1_6_000}', "");
    Expect(0, 74802, '\p{^Is_Numeric_Value=+2_1_6_000}', "");
    Expect(0, 74802, '\P{Is_Numeric_Value=+2_1_6_000}', "");
    Expect(1, 74802, '\P{^Is_Numeric_Value=+2_1_6_000}', "");
    Expect(0, 74803, '\p{Is_Numeric_Value=+2_1_6_000}', "");
    Expect(1, 74803, '\p{^Is_Numeric_Value=+2_1_6_000}', "");
    Expect(1, 74803, '\P{Is_Numeric_Value=+2_1_6_000}', "");
    Expect(0, 74803, '\P{^Is_Numeric_Value=+2_1_6_000}', "");
    Expect(1, 74802, '\p{Is_Numeric_Value=2.160000000000000e+05}', "");
    Expect(0, 74802, '\p{^Is_Numeric_Value=2.160000000000000e+05}', "");
    Expect(0, 74802, '\P{Is_Numeric_Value=2.160000000000000e+05}', "");
    Expect(1, 74802, '\P{^Is_Numeric_Value=2.160000000000000e+05}', "");
    Expect(0, 74803, '\p{Is_Numeric_Value=2.160000000000000e+05}', "");
    Expect(1, 74803, '\p{^Is_Numeric_Value=2.160000000000000e+05}', "");
    Expect(1, 74803, '\P{Is_Numeric_Value=2.160000000000000e+05}', "");
    Expect(0, 74803, '\P{^Is_Numeric_Value=2.160000000000000e+05}', "");
    Error('\p{Is_Nv=/a/	-2_1_6_000}');
    Error('\P{Is_Nv=/a/	-2_1_6_000}');
    Expect(1, 74802, '\p{Is_Nv=+00000000216000}', "");
    Expect(0, 74802, '\p{^Is_Nv=+00000000216000}', "");
    Expect(0, 74802, '\P{Is_Nv=+00000000216000}', "");
    Expect(1, 74802, '\P{^Is_Nv=+00000000216000}', "");
    Expect(0, 74803, '\p{Is_Nv=+00000000216000}', "");
    Expect(1, 74803, '\p{^Is_Nv=+00000000216000}', "");
    Expect(1, 74803, '\P{Is_Nv=+00000000216000}', "");
    Expect(0, 74803, '\P{^Is_Nv=+00000000216000}', "");
    Expect(1, 74802, '\p{Is_Nv=2.160000000000000e+05}', "");
    Expect(0, 74802, '\p{^Is_Nv=2.160000000000000e+05}', "");
    Expect(0, 74802, '\P{Is_Nv=2.160000000000000e+05}', "");
    Expect(1, 74802, '\P{^Is_Nv=2.160000000000000e+05}', "");
    Expect(0, 74803, '\p{Is_Nv=2.160000000000000e+05}', "");
    Expect(1, 74803, '\p{^Is_Nv=2.160000000000000e+05}', "");
    Expect(1, 74803, '\P{Is_Nv=2.160000000000000e+05}', "");
    Expect(0, 74803, '\P{^Is_Nv=2.160000000000000e+05}', "");
    Error('\p{Numeric_Value=/a/	_022}');
    Error('\P{Numeric_Value=/a/	_022}');
    Expect(1, 12882, '\p{Numeric_Value=:\A22\z:}', "");;
    Expect(0, 12883, '\p{Numeric_Value=:\A22\z:}', "");;
    Expect(1, 12882, '\p{Numeric_Value=0_0_0_0_0_0_0022}', "");
    Expect(0, 12882, '\p{^Numeric_Value=0_0_0_0_0_0_0022}', "");
    Expect(0, 12882, '\P{Numeric_Value=0_0_0_0_0_0_0022}', "");
    Expect(1, 12882, '\P{^Numeric_Value=0_0_0_0_0_0_0022}', "");
    Expect(0, 12883, '\p{Numeric_Value=0_0_0_0_0_0_0022}', "");
    Expect(1, 12883, '\p{^Numeric_Value=0_0_0_0_0_0_0022}', "");
    Expect(1, 12883, '\P{Numeric_Value=0_0_0_0_0_0_0022}', "");
    Expect(0, 12883, '\P{^Numeric_Value=0_0_0_0_0_0_0022}', "");
    Expect(1, 12882, '\p{Numeric_Value=2.200000000000000e+01}', "");
    Expect(0, 12882, '\p{^Numeric_Value=2.200000000000000e+01}', "");
    Expect(0, 12882, '\P{Numeric_Value=2.200000000000000e+01}', "");
    Expect(1, 12882, '\P{^Numeric_Value=2.200000000000000e+01}', "");
    Expect(0, 12883, '\p{Numeric_Value=2.200000000000000e+01}', "");
    Expect(1, 12883, '\p{^Numeric_Value=2.200000000000000e+01}', "");
    Expect(1, 12883, '\P{Numeric_Value=2.200000000000000e+01}', "");
    Expect(0, 12883, '\P{^Numeric_Value=2.200000000000000e+01}', "");
    Error('\p{Nv=/a/ 0002_2}');
    Error('\P{Nv=/a/ 0002_2}');
    Expect(1, 12882, '\p{Nv=:\A22\z:}', "");;
    Expect(0, 12883, '\p{Nv=:\A22\z:}', "");;
    Expect(1, 12882, '\p{Nv=00022}', "");
    Expect(0, 12882, '\p{^Nv=00022}', "");
    Expect(0, 12882, '\P{Nv=00022}', "");
    Expect(1, 12882, '\P{^Nv=00022}', "");
    Expect(0, 12883, '\p{Nv=00022}', "");
    Expect(1, 12883, '\p{^Nv=00022}', "");
    Expect(1, 12883, '\P{Nv=00022}', "");
    Expect(0, 12883, '\P{^Nv=00022}', "");
    Expect(1, 12882, '\p{Nv=2.200000000000000e+01}', "");
    Expect(0, 12882, '\p{^Nv=2.200000000000000e+01}', "");
    Expect(0, 12882, '\P{Nv=2.200000000000000e+01}', "");
    Expect(1, 12882, '\P{^Nv=2.200000000000000e+01}', "");
    Expect(0, 12883, '\p{Nv=2.200000000000000e+01}', "");
    Expect(1, 12883, '\p{^Nv=2.200000000000000e+01}', "");
    Expect(1, 12883, '\P{Nv=2.200000000000000e+01}', "");
    Expect(0, 12883, '\P{^Nv=2.200000000000000e+01}', "");
    Error('\p{Is_Numeric_Value= /a/+0_0_0_0_22}');
    Error('\P{Is_Numeric_Value= /a/+0_0_0_0_22}');
    Expect(1, 12882, '\p{Is_Numeric_Value=0_0_0_0_0_022}', "");
    Expect(0, 12882, '\p{^Is_Numeric_Value=0_0_0_0_0_022}', "");
    Expect(0, 12882, '\P{Is_Numeric_Value=0_0_0_0_0_022}', "");
    Expect(1, 12882, '\P{^Is_Numeric_Value=0_0_0_0_0_022}', "");
    Expect(0, 12883, '\p{Is_Numeric_Value=0_0_0_0_0_022}', "");
    Expect(1, 12883, '\p{^Is_Numeric_Value=0_0_0_0_0_022}', "");
    Expect(1, 12883, '\P{Is_Numeric_Value=0_0_0_0_0_022}', "");
    Expect(0, 12883, '\P{^Is_Numeric_Value=0_0_0_0_0_022}', "");
    Expect(1, 12882, '\p{Is_Numeric_Value=2.200000000000000e+01}', "");
    Expect(0, 12882, '\p{^Is_Numeric_Value=2.200000000000000e+01}', "");
    Expect(0, 12882, '\P{Is_Numeric_Value=2.200000000000000e+01}', "");
    Expect(1, 12882, '\P{^Is_Numeric_Value=2.200000000000000e+01}', "");
    Expect(0, 12883, '\p{Is_Numeric_Value=2.200000000000000e+01}', "");
    Expect(1, 12883, '\p{^Is_Numeric_Value=2.200000000000000e+01}', "");
    Expect(1, 12883, '\P{Is_Numeric_Value=2.200000000000000e+01}', "");
    Expect(0, 12883, '\P{^Is_Numeric_Value=2.200000000000000e+01}', "");
    Error('\p{Is_Nv=:= _0000022}');
    Error('\P{Is_Nv=:= _0000022}');
    Expect(1, 12882, '\p{Is_Nv:+0022}', "");
    Expect(0, 12882, '\p{^Is_Nv:+0022}', "");
    Expect(0, 12882, '\P{Is_Nv:+0022}', "");
    Expect(1, 12882, '\P{^Is_Nv:+0022}', "");
    Expect(0, 12883, '\p{Is_Nv:+0022}', "");
    Expect(1, 12883, '\p{^Is_Nv:+0022}', "");
    Expect(1, 12883, '\P{Is_Nv:+0022}', "");
    Expect(0, 12883, '\P{^Is_Nv:+0022}', "");
    Expect(1, 12882, '\p{Is_Nv:   2.200000000000000e+01}', "");
    Expect(0, 12882, '\p{^Is_Nv:   2.200000000000000e+01}', "");
    Expect(0, 12882, '\P{Is_Nv:   2.200000000000000e+01}', "");
    Expect(1, 12882, '\P{^Is_Nv:   2.200000000000000e+01}', "");
    Expect(0, 12883, '\p{Is_Nv:   2.200000000000000e+01}', "");
    Expect(1, 12883, '\p{^Is_Nv:   2.200000000000000e+01}', "");
    Expect(1, 12883, '\P{Is_Nv:   2.200000000000000e+01}', "");
    Expect(0, 12883, '\P{^Is_Nv:   2.200000000000000e+01}', "");
    Error('\p{Numeric_Value=	:=+000000002_3}');
    Error('\P{Numeric_Value=	:=+000000002_3}');
    Expect(1, 12883, '\p{Numeric_Value=:\A23\z:}', "");;
    Expect(0, 12884, '\p{Numeric_Value=:\A23\z:}', "");;
    Expect(1, 12883, '\p{Numeric_Value=0_0_0_0_0_00023}', "");
    Expect(0, 12883, '\p{^Numeric_Value=0_0_0_0_0_00023}', "");
    Expect(0, 12883, '\P{Numeric_Value=0_0_0_0_0_00023}', "");
    Expect(1, 12883, '\P{^Numeric_Value=0_0_0_0_0_00023}', "");
    Expect(0, 12884, '\p{Numeric_Value=0_0_0_0_0_00023}', "");
    Expect(1, 12884, '\p{^Numeric_Value=0_0_0_0_0_00023}', "");
    Expect(1, 12884, '\P{Numeric_Value=0_0_0_0_0_00023}', "");
    Expect(0, 12884, '\P{^Numeric_Value=0_0_0_0_0_00023}', "");
    Expect(1, 12883, '\p{Numeric_Value=2.300000000000000e+01}', "");
    Expect(0, 12883, '\p{^Numeric_Value=2.300000000000000e+01}', "");
    Expect(0, 12883, '\P{Numeric_Value=2.300000000000000e+01}', "");
    Expect(1, 12883, '\P{^Numeric_Value=2.300000000000000e+01}', "");
    Expect(0, 12884, '\p{Numeric_Value=2.300000000000000e+01}', "");
    Expect(1, 12884, '\p{^Numeric_Value=2.300000000000000e+01}', "");
    Expect(1, 12884, '\P{Numeric_Value=2.300000000000000e+01}', "");
    Expect(0, 12884, '\P{^Numeric_Value=2.300000000000000e+01}', "");
    Error('\p{Nv=_/a/000_000_000_23}');
    Error('\P{Nv=_/a/000_000_000_23}');
    Expect(1, 12883, '\p{Nv=:\A23\z:}', "");;
    Expect(0, 12884, '\p{Nv=:\A23\z:}', "");;
    Expect(1, 12883, '\p{Nv=+0023}', "");
    Expect(0, 12883, '\p{^Nv=+0023}', "");
    Expect(0, 12883, '\P{Nv=+0023}', "");
    Expect(1, 12883, '\P{^Nv=+0023}', "");
    Expect(0, 12884, '\p{Nv=+0023}', "");
    Expect(1, 12884, '\p{^Nv=+0023}', "");
    Expect(1, 12884, '\P{Nv=+0023}', "");
    Expect(0, 12884, '\P{^Nv=+0023}', "");
    Expect(1, 12883, '\p{Nv=2.300000000000000e+01}', "");
    Expect(0, 12883, '\p{^Nv=2.300000000000000e+01}', "");
    Expect(0, 12883, '\P{Nv=2.300000000000000e+01}', "");
    Expect(1, 12883, '\P{^Nv=2.300000000000000e+01}', "");
    Expect(0, 12884, '\p{Nv=2.300000000000000e+01}', "");
    Expect(1, 12884, '\p{^Nv=2.300000000000000e+01}', "");
    Expect(1, 12884, '\P{Nv=2.300000000000000e+01}', "");
    Expect(0, 12884, '\P{^Nv=2.300000000000000e+01}', "");
    Error('\p{Is_Numeric_Value=:=	-000023}');
    Error('\P{Is_Numeric_Value=:=	-000023}');
    Expect(1, 12883, '\p{Is_Numeric_Value=0_0_0_0_0_0_0_0_23}', "");
    Expect(0, 12883, '\p{^Is_Numeric_Value=0_0_0_0_0_0_0_0_23}', "");
    Expect(0, 12883, '\P{Is_Numeric_Value=0_0_0_0_0_0_0_0_23}', "");
    Expect(1, 12883, '\P{^Is_Numeric_Value=0_0_0_0_0_0_0_0_23}', "");
    Expect(0, 12884, '\p{Is_Numeric_Value=0_0_0_0_0_0_0_0_23}', "");
    Expect(1, 12884, '\p{^Is_Numeric_Value=0_0_0_0_0_0_0_0_23}', "");
    Expect(1, 12884, '\P{Is_Numeric_Value=0_0_0_0_0_0_0_0_23}', "");
    Expect(0, 12884, '\P{^Is_Numeric_Value=0_0_0_0_0_0_0_0_23}', "");
    Expect(1, 12883, '\p{Is_Numeric_Value=2.300000000000000e+01}', "");
    Expect(0, 12883, '\p{^Is_Numeric_Value=2.300000000000000e+01}', "");
    Expect(0, 12883, '\P{Is_Numeric_Value=2.300000000000000e+01}', "");
    Expect(1, 12883, '\P{^Is_Numeric_Value=2.300000000000000e+01}', "");
    Expect(0, 12884, '\p{Is_Numeric_Value=2.300000000000000e+01}', "");
    Expect(1, 12884, '\p{^Is_Numeric_Value=2.300000000000000e+01}', "");
    Expect(1, 12884, '\P{Is_Numeric_Value=2.300000000000000e+01}', "");
    Expect(0, 12884, '\P{^Is_Numeric_Value=2.300000000000000e+01}', "");
    Error('\p{Is_Nv=:=--00000000023}');
    Error('\P{Is_Nv=:=--00000000023}');
    Expect(1, 12883, '\p{Is_Nv=023}', "");
    Expect(0, 12883, '\p{^Is_Nv=023}', "");
    Expect(0, 12883, '\P{Is_Nv=023}', "");
    Expect(1, 12883, '\P{^Is_Nv=023}', "");
    Expect(0, 12884, '\p{Is_Nv=023}', "");
    Expect(1, 12884, '\p{^Is_Nv=023}', "");
    Expect(1, 12884, '\P{Is_Nv=023}', "");
    Expect(0, 12884, '\P{^Is_Nv=023}', "");
    Expect(1, 12883, '\p{Is_Nv:	2.300000000000000e+01}', "");
    Expect(0, 12883, '\p{^Is_Nv:	2.300000000000000e+01}', "");
    Expect(0, 12883, '\P{Is_Nv:	2.300000000000000e+01}', "");
    Expect(1, 12883, '\P{^Is_Nv:	2.300000000000000e+01}', "");
    Expect(0, 12884, '\p{Is_Nv:	2.300000000000000e+01}', "");
    Expect(1, 12884, '\p{^Is_Nv:	2.300000000000000e+01}', "");
    Expect(1, 12884, '\P{Is_Nv:	2.300000000000000e+01}', "");
    Expect(0, 12884, '\P{^Is_Nv:	2.300000000000000e+01}', "");
    Error('\p{Numeric_Value=/a/ _+00_00_02_4}');
    Error('\P{Numeric_Value=/a/ _+00_00_02_4}');
    Expect(1, 12884, '\p{Numeric_Value=:\A24\z:}', "");;
    Expect(0, 12885, '\p{Numeric_Value=:\A24\z:}', "");;
    Expect(1, 12884, '\p{Numeric_Value=00024}', "");
    Expect(0, 12884, '\p{^Numeric_Value=00024}', "");
    Expect(0, 12884, '\P{Numeric_Value=00024}', "");
    Expect(1, 12884, '\P{^Numeric_Value=00024}', "");
    Expect(0, 12885, '\p{Numeric_Value=00024}', "");
    Expect(1, 12885, '\p{^Numeric_Value=00024}', "");
    Expect(1, 12885, '\P{Numeric_Value=00024}', "");
    Expect(0, 12885, '\P{^Numeric_Value=00024}', "");
    Expect(1, 12884, '\p{Numeric_Value=2.400000000000000e+01}', "");
    Expect(0, 12884, '\p{^Numeric_Value=2.400000000000000e+01}', "");
    Expect(0, 12884, '\P{Numeric_Value=2.400000000000000e+01}', "");
    Expect(1, 12884, '\P{^Numeric_Value=2.400000000000000e+01}', "");
    Expect(0, 12885, '\p{Numeric_Value=2.400000000000000e+01}', "");
    Expect(1, 12885, '\p{^Numeric_Value=2.400000000000000e+01}', "");
    Expect(1, 12885, '\P{Numeric_Value=2.400000000000000e+01}', "");
    Expect(0, 12885, '\P{^Numeric_Value=2.400000000000000e+01}', "");
    Error('\p{Nv=/a/00000_00002_4}');
    Error('\P{Nv=/a/00000_00002_4}');
    Expect(1, 12884, '\p{Nv=:\A24\z:}', "");;
    Expect(0, 12885, '\p{Nv=:\A24\z:}', "");;
    Expect(1, 12884, '\p{Nv:+000000024}', "");
    Expect(0, 12884, '\p{^Nv:+000000024}', "");
    Expect(0, 12884, '\P{Nv:+000000024}', "");
    Expect(1, 12884, '\P{^Nv:+000000024}', "");
    Expect(0, 12885, '\p{Nv:+000000024}', "");
    Expect(1, 12885, '\p{^Nv:+000000024}', "");
    Expect(1, 12885, '\P{Nv:+000000024}', "");
    Expect(0, 12885, '\P{^Nv:+000000024}', "");
    Expect(1, 12884, '\p{Nv=2.400000000000000e+01}', "");
    Expect(0, 12884, '\p{^Nv=2.400000000000000e+01}', "");
    Expect(0, 12884, '\P{Nv=2.400000000000000e+01}', "");
    Expect(1, 12884, '\P{^Nv=2.400000000000000e+01}', "");
    Expect(0, 12885, '\p{Nv=2.400000000000000e+01}', "");
    Expect(1, 12885, '\p{^Nv=2.400000000000000e+01}', "");
    Expect(1, 12885, '\P{Nv=2.400000000000000e+01}', "");
    Expect(0, 12885, '\P{^Nv=2.400000000000000e+01}', "");
    Error('\p{Is_Numeric_Value=/a/+002_4}');
    Error('\P{Is_Numeric_Value=/a/+002_4}');
    Expect(1, 12884, '\p{Is_Numeric_Value=00000024}', "");
    Expect(0, 12884, '\p{^Is_Numeric_Value=00000024}', "");
    Expect(0, 12884, '\P{Is_Numeric_Value=00000024}', "");
    Expect(1, 12884, '\P{^Is_Numeric_Value=00000024}', "");
    Expect(0, 12885, '\p{Is_Numeric_Value=00000024}', "");
    Expect(1, 12885, '\p{^Is_Numeric_Value=00000024}', "");
    Expect(1, 12885, '\P{Is_Numeric_Value=00000024}', "");
    Expect(0, 12885, '\P{^Is_Numeric_Value=00000024}', "");
    Expect(1, 12884, '\p{Is_Numeric_Value=2.400000000000000e+01}', "");
    Expect(0, 12884, '\p{^Is_Numeric_Value=2.400000000000000e+01}', "");
    Expect(0, 12884, '\P{Is_Numeric_Value=2.400000000000000e+01}', "");
    Expect(1, 12884, '\P{^Is_Numeric_Value=2.400000000000000e+01}', "");
    Expect(0, 12885, '\p{Is_Numeric_Value=2.400000000000000e+01}', "");
    Expect(1, 12885, '\p{^Is_Numeric_Value=2.400000000000000e+01}', "");
    Expect(1, 12885, '\P{Is_Numeric_Value=2.400000000000000e+01}', "");
    Expect(0, 12885, '\P{^Is_Numeric_Value=2.400000000000000e+01}', "");
    Error('\p{Is_Nv=-:=0000024}');
    Error('\P{Is_Nv=-:=0000024}');
    Expect(1, 12884, '\p{Is_Nv=00024}', "");
    Expect(0, 12884, '\p{^Is_Nv=00024}', "");
    Expect(0, 12884, '\P{Is_Nv=00024}', "");
    Expect(1, 12884, '\P{^Is_Nv=00024}', "");
    Expect(0, 12885, '\p{Is_Nv=00024}', "");
    Expect(1, 12885, '\p{^Is_Nv=00024}', "");
    Expect(1, 12885, '\P{Is_Nv=00024}', "");
    Expect(0, 12885, '\P{^Is_Nv=00024}', "");
    Expect(1, 12884, '\p{Is_Nv:2.400000000000000e+01}', "");
    Expect(0, 12884, '\p{^Is_Nv:2.400000000000000e+01}', "");
    Expect(0, 12884, '\P{Is_Nv:2.400000000000000e+01}', "");
    Expect(1, 12884, '\P{^Is_Nv:2.400000000000000e+01}', "");
    Expect(0, 12885, '\p{Is_Nv:2.400000000000000e+01}', "");
    Expect(1, 12885, '\p{^Is_Nv:2.400000000000000e+01}', "");
    Expect(1, 12885, '\P{Is_Nv:2.400000000000000e+01}', "");
    Expect(0, 12885, '\P{^Is_Nv:2.400000000000000e+01}', "");
    Error('\p{Numeric_Value=	-0_0_0_0_0025:=}');
    Error('\P{Numeric_Value=	-0_0_0_0_0025:=}');
    Expect(1, 12885, '\p{Numeric_Value=:\A25\z:}', "");;
    Expect(0, 12886, '\p{Numeric_Value=:\A25\z:}', "");;
    Expect(1, 12885, '\p{Numeric_Value=+00_02_5}', "");
    Expect(0, 12885, '\p{^Numeric_Value=+00_02_5}', "");
    Expect(0, 12885, '\P{Numeric_Value=+00_02_5}', "");
    Expect(1, 12885, '\P{^Numeric_Value=+00_02_5}', "");
    Expect(0, 12886, '\p{Numeric_Value=+00_02_5}', "");
    Expect(1, 12886, '\p{^Numeric_Value=+00_02_5}', "");
    Expect(1, 12886, '\P{Numeric_Value=+00_02_5}', "");
    Expect(0, 12886, '\P{^Numeric_Value=+00_02_5}', "");
    Expect(1, 12885, '\p{Numeric_Value=2.500000000000000e+01}', "");
    Expect(0, 12885, '\p{^Numeric_Value=2.500000000000000e+01}', "");
    Expect(0, 12885, '\P{Numeric_Value=2.500000000000000e+01}', "");
    Expect(1, 12885, '\P{^Numeric_Value=2.500000000000000e+01}', "");
    Expect(0, 12886, '\p{Numeric_Value=2.500000000000000e+01}', "");
    Expect(1, 12886, '\p{^Numeric_Value=2.500000000000000e+01}', "");
    Expect(1, 12886, '\P{Numeric_Value=2.500000000000000e+01}', "");
    Expect(0, 12886, '\P{^Numeric_Value=2.500000000000000e+01}', "");
    Error('\p{Nv=-0_0_0_0_0_0_0_25:=}');
    Error('\P{Nv=-0_0_0_0_0_0_0_25:=}');
    Expect(1, 12885, '\p{Nv=:\A25\z:}', "");;
    Expect(0, 12886, '\p{Nv=:\A25\z:}', "");;
    Expect(1, 12885, '\p{Nv=000025}', "");
    Expect(0, 12885, '\p{^Nv=000025}', "");
    Expect(0, 12885, '\P{Nv=000025}', "");
    Expect(1, 12885, '\P{^Nv=000025}', "");
    Expect(0, 12886, '\p{Nv=000025}', "");
    Expect(1, 12886, '\p{^Nv=000025}', "");
    Expect(1, 12886, '\P{Nv=000025}', "");
    Expect(0, 12886, '\P{^Nv=000025}', "");
    Expect(1, 12885, '\p{Nv=2.500000000000000e+01}', "");
    Expect(0, 12885, '\p{^Nv=2.500000000000000e+01}', "");
    Expect(0, 12885, '\P{Nv=2.500000000000000e+01}', "");
    Expect(1, 12885, '\P{^Nv=2.500000000000000e+01}', "");
    Expect(0, 12886, '\p{Nv=2.500000000000000e+01}', "");
    Expect(1, 12886, '\p{^Nv=2.500000000000000e+01}', "");
    Expect(1, 12886, '\P{Nv=2.500000000000000e+01}', "");
    Expect(0, 12886, '\P{^Nv=2.500000000000000e+01}', "");
    Error('\p{Is_Numeric_Value: /a/-0_0_0_0_0_0_00025}');
    Error('\P{Is_Numeric_Value: /a/-0_0_0_0_0_0_00025}');
    Expect(1, 12885, '\p{Is_Numeric_Value=+000_000_25}', "");
    Expect(0, 12885, '\p{^Is_Numeric_Value=+000_000_25}', "");
    Expect(0, 12885, '\P{Is_Numeric_Value=+000_000_25}', "");
    Expect(1, 12885, '\P{^Is_Numeric_Value=+000_000_25}', "");
    Expect(0, 12886, '\p{Is_Numeric_Value=+000_000_25}', "");
    Expect(1, 12886, '\p{^Is_Numeric_Value=+000_000_25}', "");
    Expect(1, 12886, '\P{Is_Numeric_Value=+000_000_25}', "");
    Expect(0, 12886, '\P{^Is_Numeric_Value=+000_000_25}', "");
    Expect(1, 12885, '\p{Is_Numeric_Value: 2.500000000000000e+01}', "");
    Expect(0, 12885, '\p{^Is_Numeric_Value: 2.500000000000000e+01}', "");
    Expect(0, 12885, '\P{Is_Numeric_Value: 2.500000000000000e+01}', "");
    Expect(1, 12885, '\P{^Is_Numeric_Value: 2.500000000000000e+01}', "");
    Expect(0, 12886, '\p{Is_Numeric_Value: 2.500000000000000e+01}', "");
    Expect(1, 12886, '\p{^Is_Numeric_Value: 2.500000000000000e+01}', "");
    Expect(1, 12886, '\P{Is_Numeric_Value: 2.500000000000000e+01}', "");
    Expect(0, 12886, '\P{^Is_Numeric_Value: 2.500000000000000e+01}', "");
    Error('\p{Is_Nv= _02_5/a/}');
    Error('\P{Is_Nv= _02_5/a/}');
    Expect(1, 12885, '\p{Is_Nv=00000002_5}', "");
    Expect(0, 12885, '\p{^Is_Nv=00000002_5}', "");
    Expect(0, 12885, '\P{Is_Nv=00000002_5}', "");
    Expect(1, 12885, '\P{^Is_Nv=00000002_5}', "");
    Expect(0, 12886, '\p{Is_Nv=00000002_5}', "");
    Expect(1, 12886, '\p{^Is_Nv=00000002_5}', "");
    Expect(1, 12886, '\P{Is_Nv=00000002_5}', "");
    Expect(0, 12886, '\P{^Is_Nv=00000002_5}', "");
    Expect(1, 12885, '\p{Is_Nv=2.500000000000000e+01}', "");
    Expect(0, 12885, '\p{^Is_Nv=2.500000000000000e+01}', "");
    Expect(0, 12885, '\P{Is_Nv=2.500000000000000e+01}', "");
    Expect(1, 12885, '\P{^Is_Nv=2.500000000000000e+01}', "");
    Expect(0, 12886, '\p{Is_Nv=2.500000000000000e+01}', "");
    Expect(1, 12886, '\p{^Is_Nv=2.500000000000000e+01}', "");
    Expect(1, 12886, '\P{Is_Nv=2.500000000000000e+01}', "");
    Expect(0, 12886, '\P{^Is_Nv=2.500000000000000e+01}', "");
    Error('\p{Numeric_Value=-_0_0_0_026:=}');
    Error('\P{Numeric_Value=-_0_0_0_026:=}');
    Expect(1, 12886, '\p{Numeric_Value=:\A26\z:}', "");;
    Expect(0, 12887, '\p{Numeric_Value=:\A26\z:}', "");;
    Expect(1, 12886, '\p{Numeric_Value=2_6}', "");
    Expect(0, 12886, '\p{^Numeric_Value=2_6}', "");
    Expect(0, 12886, '\P{Numeric_Value=2_6}', "");
    Expect(1, 12886, '\P{^Numeric_Value=2_6}', "");
    Expect(0, 12887, '\p{Numeric_Value=2_6}', "");
    Expect(1, 12887, '\p{^Numeric_Value=2_6}', "");
    Expect(1, 12887, '\P{Numeric_Value=2_6}', "");
    Expect(0, 12887, '\P{^Numeric_Value=2_6}', "");
    Expect(1, 12886, '\p{Numeric_Value=2.600000000000000e+01}', "");
    Expect(0, 12886, '\p{^Numeric_Value=2.600000000000000e+01}', "");
    Expect(0, 12886, '\P{Numeric_Value=2.600000000000000e+01}', "");
    Expect(1, 12886, '\P{^Numeric_Value=2.600000000000000e+01}', "");
    Expect(0, 12887, '\p{Numeric_Value=2.600000000000000e+01}', "");
    Expect(1, 12887, '\p{^Numeric_Value=2.600000000000000e+01}', "");
    Expect(1, 12887, '\P{Numeric_Value=2.600000000000000e+01}', "");
    Expect(0, 12887, '\P{^Numeric_Value=2.600000000000000e+01}', "");
    Error('\p{Nv=:=_+0_0_0_0_026}');
    Error('\P{Nv=:=_+0_0_0_0_026}');
    Expect(1, 12886, '\p{Nv=:\A26\z:}', "");;
    Expect(0, 12887, '\p{Nv=:\A26\z:}', "");;
    Expect(1, 12886, '\p{Nv=000000026}', "");
    Expect(0, 12886, '\p{^Nv=000000026}', "");
    Expect(0, 12886, '\P{Nv=000000026}', "");
    Expect(1, 12886, '\P{^Nv=000000026}', "");
    Expect(0, 12887, '\p{Nv=000000026}', "");
    Expect(1, 12887, '\p{^Nv=000000026}', "");
    Expect(1, 12887, '\P{Nv=000000026}', "");
    Expect(0, 12887, '\P{^Nv=000000026}', "");
    Expect(1, 12886, '\p{Nv: 2.600000000000000e+01}', "");
    Expect(0, 12886, '\p{^Nv: 2.600000000000000e+01}', "");
    Expect(0, 12886, '\P{Nv: 2.600000000000000e+01}', "");
    Expect(1, 12886, '\P{^Nv: 2.600000000000000e+01}', "");
    Expect(0, 12887, '\p{Nv: 2.600000000000000e+01}', "");
    Expect(1, 12887, '\p{^Nv: 2.600000000000000e+01}', "");
    Expect(1, 12887, '\P{Nv: 2.600000000000000e+01}', "");
    Expect(0, 12887, '\P{^Nv: 2.600000000000000e+01}', "");
    Error('\p{Is_Numeric_Value=_ +00000026:=}');
    Error('\P{Is_Numeric_Value=_ +00000026:=}');
    Expect(1, 12886, '\p{Is_Numeric_Value=+026}', "");
    Expect(0, 12886, '\p{^Is_Numeric_Value=+026}', "");
    Expect(0, 12886, '\P{Is_Numeric_Value=+026}', "");
    Expect(1, 12886, '\P{^Is_Numeric_Value=+026}', "");
    Expect(0, 12887, '\p{Is_Numeric_Value=+026}', "");
    Expect(1, 12887, '\p{^Is_Numeric_Value=+026}', "");
    Expect(1, 12887, '\P{Is_Numeric_Value=+026}', "");
    Expect(0, 12887, '\P{^Is_Numeric_Value=+026}', "");
    Expect(1, 12886, '\p{Is_Numeric_Value=2.600000000000000e+01}', "");
    Expect(0, 12886, '\p{^Is_Numeric_Value=2.600000000000000e+01}', "");
    Expect(0, 12886, '\P{Is_Numeric_Value=2.600000000000000e+01}', "");
    Expect(1, 12886, '\P{^Is_Numeric_Value=2.600000000000000e+01}', "");
    Expect(0, 12887, '\p{Is_Numeric_Value=2.600000000000000e+01}', "");
    Expect(1, 12887, '\p{^Is_Numeric_Value=2.600000000000000e+01}', "");
    Expect(1, 12887, '\P{Is_Numeric_Value=2.600000000000000e+01}', "");
    Expect(0, 12887, '\P{^Is_Numeric_Value=2.600000000000000e+01}', "");
    Error('\p{Is_Nv=_/a/00000000026}');
    Error('\P{Is_Nv=_/a/00000000026}');
    Expect(1, 12886, '\p{Is_Nv=026}', "");
    Expect(0, 12886, '\p{^Is_Nv=026}', "");
    Expect(0, 12886, '\P{Is_Nv=026}', "");
    Expect(1, 12886, '\P{^Is_Nv=026}', "");
    Expect(0, 12887, '\p{Is_Nv=026}', "");
    Expect(1, 12887, '\p{^Is_Nv=026}', "");
    Expect(1, 12887, '\P{Is_Nv=026}', "");
    Expect(0, 12887, '\P{^Is_Nv=026}', "");
    Expect(1, 12886, '\p{Is_Nv=2.600000000000000e+01}', "");
    Expect(0, 12886, '\p{^Is_Nv=2.600000000000000e+01}', "");
    Expect(0, 12886, '\P{Is_Nv=2.600000000000000e+01}', "");
    Expect(1, 12886, '\P{^Is_Nv=2.600000000000000e+01}', "");
    Expect(0, 12887, '\p{Is_Nv=2.600000000000000e+01}', "");
    Expect(1, 12887, '\p{^Is_Nv=2.600000000000000e+01}', "");
    Expect(1, 12887, '\P{Is_Nv=2.600000000000000e+01}', "");
    Expect(0, 12887, '\P{^Is_Nv=2.600000000000000e+01}', "");
    Error('\p{Numeric_Value=__27:=}');
    Error('\P{Numeric_Value=__27:=}');
    Expect(1, 12887, '\p{Numeric_Value=:\A27\z:}', "");;
    Expect(0, 12888, '\p{Numeric_Value=:\A27\z:}', "");;
    Expect(1, 12887, '\p{Numeric_Value:   00_00_00_00_027}', "");
    Expect(0, 12887, '\p{^Numeric_Value:   00_00_00_00_027}', "");
    Expect(0, 12887, '\P{Numeric_Value:   00_00_00_00_027}', "");
    Expect(1, 12887, '\P{^Numeric_Value:   00_00_00_00_027}', "");
    Expect(0, 12888, '\p{Numeric_Value:   00_00_00_00_027}', "");
    Expect(1, 12888, '\p{^Numeric_Value:   00_00_00_00_027}', "");
    Expect(1, 12888, '\P{Numeric_Value:   00_00_00_00_027}', "");
    Expect(0, 12888, '\P{^Numeric_Value:   00_00_00_00_027}', "");
    Expect(1, 12887, '\p{Numeric_Value=2.700000000000000e+01}', "");
    Expect(0, 12887, '\p{^Numeric_Value=2.700000000000000e+01}', "");
    Expect(0, 12887, '\P{Numeric_Value=2.700000000000000e+01}', "");
    Expect(1, 12887, '\P{^Numeric_Value=2.700000000000000e+01}', "");
    Expect(0, 12888, '\p{Numeric_Value=2.700000000000000e+01}', "");
    Expect(1, 12888, '\p{^Numeric_Value=2.700000000000000e+01}', "");
    Expect(1, 12888, '\P{Numeric_Value=2.700000000000000e+01}', "");
    Expect(0, 12888, '\P{^Numeric_Value=2.700000000000000e+01}', "");
    Error('\p{Nv=/a/-+0_0_0_27}');
    Error('\P{Nv=/a/-+0_0_0_27}');
    Expect(1, 12887, '\p{Nv=:\A27\z:}', "");;
    Expect(0, 12888, '\p{Nv=:\A27\z:}', "");;
    Expect(1, 12887, '\p{Nv=000000027}', "");
    Expect(0, 12887, '\p{^Nv=000000027}', "");
    Expect(0, 12887, '\P{Nv=000000027}', "");
    Expect(1, 12887, '\P{^Nv=000000027}', "");
    Expect(0, 12888, '\p{Nv=000000027}', "");
    Expect(1, 12888, '\p{^Nv=000000027}', "");
    Expect(1, 12888, '\P{Nv=000000027}', "");
    Expect(0, 12888, '\P{^Nv=000000027}', "");
    Expect(1, 12887, '\p{Nv:2.700000000000000e+01}', "");
    Expect(0, 12887, '\p{^Nv:2.700000000000000e+01}', "");
    Expect(0, 12887, '\P{Nv:2.700000000000000e+01}', "");
    Expect(1, 12887, '\P{^Nv:2.700000000000000e+01}', "");
    Expect(0, 12888, '\p{Nv:2.700000000000000e+01}', "");
    Expect(1, 12888, '\p{^Nv:2.700000000000000e+01}', "");
    Expect(1, 12888, '\P{Nv:2.700000000000000e+01}', "");
    Expect(0, 12888, '\P{^Nv:2.700000000000000e+01}', "");
    Error('\p{Is_Numeric_Value=	 +00000027/a/}');
    Error('\P{Is_Numeric_Value=	 +00000027/a/}');
    Expect(1, 12887, '\p{Is_Numeric_Value=+00000027}', "");
    Expect(0, 12887, '\p{^Is_Numeric_Value=+00000027}', "");
    Expect(0, 12887, '\P{Is_Numeric_Value=+00000027}', "");
    Expect(1, 12887, '\P{^Is_Numeric_Value=+00000027}', "");
    Expect(0, 12888, '\p{Is_Numeric_Value=+00000027}', "");
    Expect(1, 12888, '\p{^Is_Numeric_Value=+00000027}', "");
    Expect(1, 12888, '\P{Is_Numeric_Value=+00000027}', "");
    Expect(0, 12888, '\P{^Is_Numeric_Value=+00000027}', "");
    Expect(1, 12887, '\p{Is_Numeric_Value=2.700000000000000e+01}', "");
    Expect(0, 12887, '\p{^Is_Numeric_Value=2.700000000000000e+01}', "");
    Expect(0, 12887, '\P{Is_Numeric_Value=2.700000000000000e+01}', "");
    Expect(1, 12887, '\P{^Is_Numeric_Value=2.700000000000000e+01}', "");
    Expect(0, 12888, '\p{Is_Numeric_Value=2.700000000000000e+01}', "");
    Expect(1, 12888, '\p{^Is_Numeric_Value=2.700000000000000e+01}', "");
    Expect(1, 12888, '\P{Is_Numeric_Value=2.700000000000000e+01}', "");
    Expect(0, 12888, '\P{^Is_Numeric_Value=2.700000000000000e+01}', "");
    Error('\p{Is_Nv=:=	-0_0_0_0_0_027}');
    Error('\P{Is_Nv=:=	-0_0_0_0_0_027}');
    Expect(1, 12887, '\p{Is_Nv=2_7}', "");
    Expect(0, 12887, '\p{^Is_Nv=2_7}', "");
    Expect(0, 12887, '\P{Is_Nv=2_7}', "");
    Expect(1, 12887, '\P{^Is_Nv=2_7}', "");
    Expect(0, 12888, '\p{Is_Nv=2_7}', "");
    Expect(1, 12888, '\p{^Is_Nv=2_7}', "");
    Expect(1, 12888, '\P{Is_Nv=2_7}', "");
    Expect(0, 12888, '\P{^Is_Nv=2_7}', "");
    Expect(1, 12887, '\p{Is_Nv=2.700000000000000e+01}', "");
    Expect(0, 12887, '\p{^Is_Nv=2.700000000000000e+01}', "");
    Expect(0, 12887, '\P{Is_Nv=2.700000000000000e+01}', "");
    Expect(1, 12887, '\P{^Is_Nv=2.700000000000000e+01}', "");
    Expect(0, 12888, '\p{Is_Nv=2.700000000000000e+01}', "");
    Expect(1, 12888, '\p{^Is_Nv=2.700000000000000e+01}', "");
    Expect(1, 12888, '\P{Is_Nv=2.700000000000000e+01}', "");
    Expect(0, 12888, '\P{^Is_Nv=2.700000000000000e+01}', "");
    Error('\p{Numeric_Value= _000_000_002_8/a/}');
    Error('\P{Numeric_Value= _000_000_002_8/a/}');
    Expect(1, 12888, '\p{Numeric_Value=:\A28\z:}', "");;
    Expect(0, 12889, '\p{Numeric_Value=:\A28\z:}', "");;
    Expect(1, 12888, '\p{Numeric_Value=028}', "");
    Expect(0, 12888, '\p{^Numeric_Value=028}', "");
    Expect(0, 12888, '\P{Numeric_Value=028}', "");
    Expect(1, 12888, '\P{^Numeric_Value=028}', "");
    Expect(0, 12889, '\p{Numeric_Value=028}', "");
    Expect(1, 12889, '\p{^Numeric_Value=028}', "");
    Expect(1, 12889, '\P{Numeric_Value=028}', "");
    Expect(0, 12889, '\P{^Numeric_Value=028}', "");
    Expect(1, 12888, '\p{Numeric_Value=2.800000000000000e+01}', "");
    Expect(0, 12888, '\p{^Numeric_Value=2.800000000000000e+01}', "");
    Expect(0, 12888, '\P{Numeric_Value=2.800000000000000e+01}', "");
    Expect(1, 12888, '\P{^Numeric_Value=2.800000000000000e+01}', "");
    Expect(0, 12889, '\p{Numeric_Value=2.800000000000000e+01}', "");
    Expect(1, 12889, '\p{^Numeric_Value=2.800000000000000e+01}', "");
    Expect(1, 12889, '\P{Numeric_Value=2.800000000000000e+01}', "");
    Expect(0, 12889, '\P{^Numeric_Value=2.800000000000000e+01}', "");
    Error('\p{Nv=:=_-002_8}');
    Error('\P{Nv=:=_-002_8}');
    Expect(1, 12888, '\p{Nv=:\A28\z:}', "");;
    Expect(0, 12889, '\p{Nv=:\A28\z:}', "");;
    Expect(1, 12888, '\p{Nv=0002_8}', "");
    Expect(0, 12888, '\p{^Nv=0002_8}', "");
    Expect(0, 12888, '\P{Nv=0002_8}', "");
    Expect(1, 12888, '\P{^Nv=0002_8}', "");
    Expect(0, 12889, '\p{Nv=0002_8}', "");
    Expect(1, 12889, '\p{^Nv=0002_8}', "");
    Expect(1, 12889, '\P{Nv=0002_8}', "");
    Expect(0, 12889, '\P{^Nv=0002_8}', "");
    Expect(1, 12888, '\p{Nv=2.800000000000000e+01}', "");
    Expect(0, 12888, '\p{^Nv=2.800000000000000e+01}', "");
    Expect(0, 12888, '\P{Nv=2.800000000000000e+01}', "");
    Expect(1, 12888, '\P{^Nv=2.800000000000000e+01}', "");
    Expect(0, 12889, '\p{Nv=2.800000000000000e+01}', "");
    Expect(1, 12889, '\p{^Nv=2.800000000000000e+01}', "");
    Expect(1, 12889, '\P{Nv=2.800000000000000e+01}', "");
    Expect(0, 12889, '\P{^Nv=2.800000000000000e+01}', "");
    Error('\p{Is_Numeric_Value=-2_8/a/}');
    Error('\P{Is_Numeric_Value=-2_8/a/}');
    Expect(1, 12888, '\p{Is_Numeric_Value=+0_0_0_028}', "");
    Expect(0, 12888, '\p{^Is_Numeric_Value=+0_0_0_028}', "");
    Expect(0, 12888, '\P{Is_Numeric_Value=+0_0_0_028}', "");
    Expect(1, 12888, '\P{^Is_Numeric_Value=+0_0_0_028}', "");
    Expect(0, 12889, '\p{Is_Numeric_Value=+0_0_0_028}', "");
    Expect(1, 12889, '\p{^Is_Numeric_Value=+0_0_0_028}', "");
    Expect(1, 12889, '\P{Is_Numeric_Value=+0_0_0_028}', "");
    Expect(0, 12889, '\P{^Is_Numeric_Value=+0_0_0_028}', "");
    Expect(1, 12888, '\p{Is_Numeric_Value=2.800000000000000e+01}', "");
    Expect(0, 12888, '\p{^Is_Numeric_Value=2.800000000000000e+01}', "");
    Expect(0, 12888, '\P{Is_Numeric_Value=2.800000000000000e+01}', "");
    Expect(1, 12888, '\P{^Is_Numeric_Value=2.800000000000000e+01}', "");
    Expect(0, 12889, '\p{Is_Numeric_Value=2.800000000000000e+01}', "");
    Expect(1, 12889, '\p{^Is_Numeric_Value=2.800000000000000e+01}', "");
    Expect(1, 12889, '\P{Is_Numeric_Value=2.800000000000000e+01}', "");
    Expect(0, 12889, '\P{^Is_Numeric_Value=2.800000000000000e+01}', "");
    Error('\p{Is_Nv=/a/00000028}');
    Error('\P{Is_Nv=/a/00000028}');
    Expect(1, 12888, '\p{Is_Nv=0_0_0_0_028}', "");
    Expect(0, 12888, '\p{^Is_Nv=0_0_0_0_028}', "");
    Expect(0, 12888, '\P{Is_Nv=0_0_0_0_028}', "");
    Expect(1, 12888, '\P{^Is_Nv=0_0_0_0_028}', "");
    Expect(0, 12889, '\p{Is_Nv=0_0_0_0_028}', "");
    Expect(1, 12889, '\p{^Is_Nv=0_0_0_0_028}', "");
    Expect(1, 12889, '\P{Is_Nv=0_0_0_0_028}', "");
    Expect(0, 12889, '\P{^Is_Nv=0_0_0_0_028}', "");
    Expect(1, 12888, '\p{Is_Nv=2.800000000000000e+01}', "");
    Expect(0, 12888, '\p{^Is_Nv=2.800000000000000e+01}', "");
    Expect(0, 12888, '\P{Is_Nv=2.800000000000000e+01}', "");
    Expect(1, 12888, '\P{^Is_Nv=2.800000000000000e+01}', "");
    Expect(0, 12889, '\p{Is_Nv=2.800000000000000e+01}', "");
    Expect(1, 12889, '\p{^Is_Nv=2.800000000000000e+01}', "");
    Expect(1, 12889, '\P{Is_Nv=2.800000000000000e+01}', "");
    Expect(0, 12889, '\P{^Is_Nv=2.800000000000000e+01}', "");
    Error('\p{Numeric_Value=:=_000_002_9}');
    Error('\P{Numeric_Value=:=_000_002_9}');
    Expect(1, 12889, '\p{Numeric_Value=:\A29\z:}', "");;
    Expect(0, 12890, '\p{Numeric_Value=:\A29\z:}', "");;
    Expect(1, 12889, '\p{Numeric_Value=00000000029}', "");
    Expect(0, 12889, '\p{^Numeric_Value=00000000029}', "");
    Expect(0, 12889, '\P{Numeric_Value=00000000029}', "");
    Expect(1, 12889, '\P{^Numeric_Value=00000000029}', "");
    Expect(0, 12890, '\p{Numeric_Value=00000000029}', "");
    Expect(1, 12890, '\p{^Numeric_Value=00000000029}', "");
    Expect(1, 12890, '\P{Numeric_Value=00000000029}', "");
    Expect(0, 12890, '\P{^Numeric_Value=00000000029}', "");
    Expect(1, 12889, '\p{Numeric_Value=2.900000000000000e+01}', "");
    Expect(0, 12889, '\p{^Numeric_Value=2.900000000000000e+01}', "");
    Expect(0, 12889, '\P{Numeric_Value=2.900000000000000e+01}', "");
    Expect(1, 12889, '\P{^Numeric_Value=2.900000000000000e+01}', "");
    Expect(0, 12890, '\p{Numeric_Value=2.900000000000000e+01}', "");
    Expect(1, 12890, '\p{^Numeric_Value=2.900000000000000e+01}', "");
    Expect(1, 12890, '\P{Numeric_Value=2.900000000000000e+01}', "");
    Expect(0, 12890, '\P{^Numeric_Value=2.900000000000000e+01}', "");
    Error('\p{Nv=	:=00000_00002_9}');
    Error('\P{Nv=	:=00000_00002_9}');
    Expect(1, 12889, '\p{Nv=:\A29\z:}', "");;
    Expect(0, 12890, '\p{Nv=:\A29\z:}', "");;
    Expect(1, 12889, '\p{Nv:   00000029}', "");
    Expect(0, 12889, '\p{^Nv:   00000029}', "");
    Expect(0, 12889, '\P{Nv:   00000029}', "");
    Expect(1, 12889, '\P{^Nv:   00000029}', "");
    Expect(0, 12890, '\p{Nv:   00000029}', "");
    Expect(1, 12890, '\p{^Nv:   00000029}', "");
    Expect(1, 12890, '\P{Nv:   00000029}', "");
    Expect(0, 12890, '\P{^Nv:   00000029}', "");
    Expect(1, 12889, '\p{Nv=2.900000000000000e+01}', "");
    Expect(0, 12889, '\p{^Nv=2.900000000000000e+01}', "");
    Expect(0, 12889, '\P{Nv=2.900000000000000e+01}', "");
    Expect(1, 12889, '\P{^Nv=2.900000000000000e+01}', "");
    Expect(0, 12890, '\p{Nv=2.900000000000000e+01}', "");
    Expect(1, 12890, '\p{^Nv=2.900000000000000e+01}', "");
    Expect(1, 12890, '\P{Nv=2.900000000000000e+01}', "");
    Expect(0, 12890, '\P{^Nv=2.900000000000000e+01}', "");
    Error('\p{Is_Numeric_Value=/a/_000000029}');
    Error('\P{Is_Numeric_Value=/a/_000000029}');
    Expect(1, 12889, '\p{Is_Numeric_Value=+0029}', "");
    Expect(0, 12889, '\p{^Is_Numeric_Value=+0029}', "");
    Expect(0, 12889, '\P{Is_Numeric_Value=+0029}', "");
    Expect(1, 12889, '\P{^Is_Numeric_Value=+0029}', "");
    Expect(0, 12890, '\p{Is_Numeric_Value=+0029}', "");
    Expect(1, 12890, '\p{^Is_Numeric_Value=+0029}', "");
    Expect(1, 12890, '\P{Is_Numeric_Value=+0029}', "");
    Expect(0, 12890, '\P{^Is_Numeric_Value=+0029}', "");
    Expect(1, 12889, '\p{Is_Numeric_Value=2.900000000000000e+01}', "");
    Expect(0, 12889, '\p{^Is_Numeric_Value=2.900000000000000e+01}', "");
    Expect(0, 12889, '\P{Is_Numeric_Value=2.900000000000000e+01}', "");
    Expect(1, 12889, '\P{^Is_Numeric_Value=2.900000000000000e+01}', "");
    Expect(0, 12890, '\p{Is_Numeric_Value=2.900000000000000e+01}', "");
    Expect(1, 12890, '\p{^Is_Numeric_Value=2.900000000000000e+01}', "");
    Expect(1, 12890, '\P{Is_Numeric_Value=2.900000000000000e+01}', "");
    Expect(0, 12890, '\P{^Is_Numeric_Value=2.900000000000000e+01}', "");
    Error('\p{Is_Nv= _+29:=}');
    Error('\P{Is_Nv= _+29:=}');
    Expect(1, 12889, '\p{Is_Nv:	+29}', "");
    Expect(0, 12889, '\p{^Is_Nv:	+29}', "");
    Expect(0, 12889, '\P{Is_Nv:	+29}', "");
    Expect(1, 12889, '\P{^Is_Nv:	+29}', "");
    Expect(0, 12890, '\p{Is_Nv:	+29}', "");
    Expect(1, 12890, '\p{^Is_Nv:	+29}', "");
    Expect(1, 12890, '\P{Is_Nv:	+29}', "");
    Expect(0, 12890, '\P{^Is_Nv:	+29}', "");
    Expect(1, 12889, '\p{Is_Nv=2.900000000000000e+01}', "");
    Expect(0, 12889, '\p{^Is_Nv=2.900000000000000e+01}', "");
    Expect(0, 12889, '\P{Is_Nv=2.900000000000000e+01}', "");
    Expect(1, 12889, '\P{^Is_Nv=2.900000000000000e+01}', "");
    Expect(0, 12890, '\p{Is_Nv=2.900000000000000e+01}', "");
    Expect(1, 12890, '\p{^Is_Nv=2.900000000000000e+01}', "");
    Expect(1, 12890, '\P{Is_Nv=2.900000000000000e+01}', "");
    Expect(0, 12890, '\P{^Is_Nv=2.900000000000000e+01}', "");
    Error('\p{Numeric_Value=:=--0_0_0_0_0003}');
    Error('\P{Numeric_Value=:=--0_0_0_0_0003}');
    Expect(1, 146203, '\p{Numeric_Value=:\A3\z:}', "");;
    Expect(0, 146204, '\p{Numeric_Value=:\A3\z:}', "");;
    Expect(1, 146203, '\p{Numeric_Value=00_00_03}', "");
    Expect(0, 146203, '\p{^Numeric_Value=00_00_03}', "");
    Expect(0, 146203, '\P{Numeric_Value=00_00_03}', "");
    Expect(1, 146203, '\P{^Numeric_Value=00_00_03}', "");
    Expect(0, 146204, '\p{Numeric_Value=00_00_03}', "");
    Expect(1, 146204, '\p{^Numeric_Value=00_00_03}', "");
    Expect(1, 146204, '\P{Numeric_Value=00_00_03}', "");
    Expect(0, 146204, '\P{^Numeric_Value=00_00_03}', "");
    Expect(1, 146203, '\p{Numeric_Value:	3.000000000000000e+00}', "");
    Expect(0, 146203, '\p{^Numeric_Value:	3.000000000000000e+00}', "");
    Expect(0, 146203, '\P{Numeric_Value:	3.000000000000000e+00}', "");
    Expect(1, 146203, '\P{^Numeric_Value:	3.000000000000000e+00}', "");
    Expect(0, 146204, '\p{Numeric_Value:	3.000000000000000e+00}', "");
    Expect(1, 146204, '\p{^Numeric_Value:	3.000000000000000e+00}', "");
    Expect(1, 146204, '\P{Numeric_Value:	3.000000000000000e+00}', "");
    Expect(0, 146204, '\P{^Numeric_Value:	3.000000000000000e+00}', "");
    Error('\p{Nv:   /a/3}');
    Error('\P{Nv:   /a/3}');
    Expect(1, 146203, '\p{Nv=:\A3\z:}', "");;
    Expect(0, 146204, '\p{Nv=:\A3\z:}', "");;
    Expect(1, 146203, '\p{Nv=0000000003}', "");
    Expect(0, 146203, '\p{^Nv=0000000003}', "");
    Expect(0, 146203, '\P{Nv=0000000003}', "");
    Expect(1, 146203, '\P{^Nv=0000000003}', "");
    Expect(0, 146204, '\p{Nv=0000000003}', "");
    Expect(1, 146204, '\p{^Nv=0000000003}', "");
    Expect(1, 146204, '\P{Nv=0000000003}', "");
    Expect(0, 146204, '\P{^Nv=0000000003}', "");
    Expect(1, 146203, '\p{Nv=3.000000000000000e+00}', "");
    Expect(0, 146203, '\p{^Nv=3.000000000000000e+00}', "");
    Expect(0, 146203, '\P{Nv=3.000000000000000e+00}', "");
    Expect(1, 146203, '\P{^Nv=3.000000000000000e+00}', "");
    Expect(0, 146204, '\p{Nv=3.000000000000000e+00}', "");
    Expect(1, 146204, '\p{^Nv=3.000000000000000e+00}', "");
    Expect(1, 146204, '\P{Nv=3.000000000000000e+00}', "");
    Expect(0, 146204, '\P{^Nv=3.000000000000000e+00}', "");
    Error('\p{Is_Numeric_Value=	 00000003/a/}');
    Error('\P{Is_Numeric_Value=	 00000003/a/}');
    Expect(1, 146203, '\p{Is_Numeric_Value=+000003}', "");
    Expect(0, 146203, '\p{^Is_Numeric_Value=+000003}', "");
    Expect(0, 146203, '\P{Is_Numeric_Value=+000003}', "");
    Expect(1, 146203, '\P{^Is_Numeric_Value=+000003}', "");
    Expect(0, 146204, '\p{Is_Numeric_Value=+000003}', "");
    Expect(1, 146204, '\p{^Is_Numeric_Value=+000003}', "");
    Expect(1, 146204, '\P{Is_Numeric_Value=+000003}', "");
    Expect(0, 146204, '\P{^Is_Numeric_Value=+000003}', "");
    Expect(1, 146203, '\p{Is_Numeric_Value=3.000000000000000e+00}', "");
    Expect(0, 146203, '\p{^Is_Numeric_Value=3.000000000000000e+00}', "");
    Expect(0, 146203, '\P{Is_Numeric_Value=3.000000000000000e+00}', "");
    Expect(1, 146203, '\P{^Is_Numeric_Value=3.000000000000000e+00}', "");
    Expect(0, 146204, '\p{Is_Numeric_Value=3.000000000000000e+00}', "");
    Expect(1, 146204, '\p{^Is_Numeric_Value=3.000000000000000e+00}', "");
    Expect(1, 146204, '\P{Is_Numeric_Value=3.000000000000000e+00}', "");
    Expect(0, 146204, '\P{^Is_Numeric_Value=3.000000000000000e+00}', "");
    Error('\p{Is_Nv= /a/0_0_03}');
    Error('\P{Is_Nv= /a/0_0_03}');
    Expect(1, 146203, '\p{Is_Nv=000000000_3}', "");
    Expect(0, 146203, '\p{^Is_Nv=000000000_3}', "");
    Expect(0, 146203, '\P{Is_Nv=000000000_3}', "");
    Expect(1, 146203, '\P{^Is_Nv=000000000_3}', "");
    Expect(0, 146204, '\p{Is_Nv=000000000_3}', "");
    Expect(1, 146204, '\p{^Is_Nv=000000000_3}', "");
    Expect(1, 146204, '\P{Is_Nv=000000000_3}', "");
    Expect(0, 146204, '\P{^Is_Nv=000000000_3}', "");
    Expect(1, 146203, '\p{Is_Nv:	3.000000000000000e+00}', "");
    Expect(0, 146203, '\p{^Is_Nv:	3.000000000000000e+00}', "");
    Expect(0, 146203, '\P{Is_Nv:	3.000000000000000e+00}', "");
    Expect(1, 146203, '\P{^Is_Nv:	3.000000000000000e+00}', "");
    Expect(0, 146204, '\p{Is_Nv:	3.000000000000000e+00}', "");
    Expect(1, 146204, '\p{^Is_Nv:	3.000000000000000e+00}', "");
    Expect(1, 146204, '\P{Is_Nv:	3.000000000000000e+00}', "");
    Expect(0, 146204, '\P{^Is_Nv:	3.000000000000000e+00}', "");
    Error('\p{Numeric_Value=:=		000003/00000000016}');
    Error('\P{Numeric_Value=:=		000003/00000000016}');
    Expect(1, 73678, '\p{Numeric_Value=:\A3/16\z:}', "");;
    Expect(0, 73679, '\p{Numeric_Value=:\A3/16\z:}', "");;
    Expect(1, 73678, '\p{Numeric_Value=3/000016}', "");
    Expect(0, 73678, '\p{^Numeric_Value=3/000016}', "");
    Expect(0, 73678, '\P{Numeric_Value=3/000016}', "");
    Expect(1, 73678, '\P{^Numeric_Value=3/000016}', "");
    Expect(0, 73679, '\p{Numeric_Value=3/000016}', "");
    Expect(1, 73679, '\p{^Numeric_Value=3/000016}', "");
    Expect(1, 73679, '\P{Numeric_Value=3/000016}', "");
    Expect(0, 73679, '\P{^Numeric_Value=3/000016}', "");
    Expect(1, 73678, '\p{Numeric_Value=180/960}', "");
    Expect(0, 73678, '\p{^Numeric_Value=180/960}', "");
    Expect(0, 73678, '\P{Numeric_Value=180/960}', "");
    Expect(1, 73678, '\P{^Numeric_Value=180/960}', "");
    Expect(0, 73679, '\p{Numeric_Value=180/960}', "");
    Expect(1, 73679, '\p{^Numeric_Value=180/960}', "");
    Expect(1, 73679, '\P{Numeric_Value=180/960}', "");
    Expect(0, 73679, '\P{^Numeric_Value=180/960}', "");
    Error('\p{Numeric_Value:	1.9e-01}');
    Error('\P{Numeric_Value:	1.9e-01}');
    Error('\p{Numeric_Value=1.88e-01}');
    Error('\P{Numeric_Value=1.88e-01}');
    Error('\p{Numeric_Value=0.19}');
    Error('\P{Numeric_Value=0.19}');
    Expect(1, 73678, '\p{Numeric_Value=1.875e-01}', "");
    Expect(0, 73678, '\p{^Numeric_Value=1.875e-01}', "");
    Expect(0, 73678, '\P{Numeric_Value=1.875e-01}', "");
    Expect(1, 73678, '\P{^Numeric_Value=1.875e-01}', "");
    Expect(0, 73679, '\p{Numeric_Value=1.875e-01}', "");
    Expect(1, 73679, '\p{^Numeric_Value=1.875e-01}', "");
    Expect(1, 73679, '\P{Numeric_Value=1.875e-01}', "");
    Expect(0, 73679, '\P{^Numeric_Value=1.875e-01}', "");
    Error('\p{Numeric_Value=0.188}');
    Error('\P{Numeric_Value=0.188}');
    Expect(1, 73678, '\p{Numeric_Value=1.8750e-01}', "");
    Expect(0, 73678, '\p{^Numeric_Value=1.8750e-01}', "");
    Expect(0, 73678, '\P{Numeric_Value=1.8750e-01}', "");
    Expect(1, 73678, '\P{^Numeric_Value=1.8750e-01}', "");
    Expect(0, 73679, '\p{Numeric_Value=1.8750e-01}', "");
    Expect(1, 73679, '\p{^Numeric_Value=1.8750e-01}', "");
    Expect(1, 73679, '\P{Numeric_Value=1.8750e-01}', "");
    Expect(0, 73679, '\P{^Numeric_Value=1.8750e-01}', "");
    Expect(1, 73678, '\p{Numeric_Value=0.1875}', "");
    Expect(0, 73678, '\p{^Numeric_Value=0.1875}', "");
    Expect(0, 73678, '\P{Numeric_Value=0.1875}', "");
    Expect(1, 73678, '\P{^Numeric_Value=0.1875}', "");
    Expect(0, 73679, '\p{Numeric_Value=0.1875}', "");
    Expect(1, 73679, '\p{^Numeric_Value=0.1875}', "");
    Expect(1, 73679, '\P{Numeric_Value=0.1875}', "");
    Expect(0, 73679, '\P{^Numeric_Value=0.1875}', "");
    Expect(1, 73678, '\p{Numeric_Value:1.87500e-01}', "");
    Expect(0, 73678, '\p{^Numeric_Value:1.87500e-01}', "");
    Expect(0, 73678, '\P{Numeric_Value:1.87500e-01}', "");
    Expect(1, 73678, '\P{^Numeric_Value:1.87500e-01}', "");
    Expect(0, 73679, '\p{Numeric_Value:1.87500e-01}', "");
    Expect(1, 73679, '\p{^Numeric_Value:1.87500e-01}', "");
    Expect(1, 73679, '\P{Numeric_Value:1.87500e-01}', "");
    Expect(0, 73679, '\P{^Numeric_Value:1.87500e-01}', "");
    Expect(1, 73678, '\p{Numeric_Value=0.18750}', "");
    Expect(0, 73678, '\p{^Numeric_Value=0.18750}', "");
    Expect(0, 73678, '\P{Numeric_Value=0.18750}', "");
    Expect(1, 73678, '\P{^Numeric_Value=0.18750}', "");
    Expect(0, 73679, '\p{Numeric_Value=0.18750}', "");
    Expect(1, 73679, '\p{^Numeric_Value=0.18750}', "");
    Expect(1, 73679, '\P{Numeric_Value=0.18750}', "");
    Expect(0, 73679, '\P{^Numeric_Value=0.18750}', "");
    Error('\p{Nv=:=	-000000003/00000000016}');
    Error('\P{Nv=:=	-000000003/00000000016}');
    Expect(1, 73678, '\p{Nv=:\A3/16\z:}', "");;
    Expect(0, 73679, '\p{Nv=:\A3/16\z:}', "");;
    Expect(1, 73678, '\p{Nv=0003/000016}', "");
    Expect(0, 73678, '\p{^Nv=0003/000016}', "");
    Expect(0, 73678, '\P{Nv=0003/000016}', "");
    Expect(1, 73678, '\P{^Nv=0003/000016}', "");
    Expect(0, 73679, '\p{Nv=0003/000016}', "");
    Expect(1, 73679, '\p{^Nv=0003/000016}', "");
    Expect(1, 73679, '\P{Nv=0003/000016}', "");
    Expect(0, 73679, '\P{^Nv=0003/000016}', "");
    Expect(1, 73678, '\p{Nv=180/960}', "");
    Expect(0, 73678, '\p{^Nv=180/960}', "");
    Expect(0, 73678, '\P{Nv=180/960}', "");
    Expect(1, 73678, '\P{^Nv=180/960}', "");
    Expect(0, 73679, '\p{Nv=180/960}', "");
    Expect(1, 73679, '\p{^Nv=180/960}', "");
    Expect(1, 73679, '\P{Nv=180/960}', "");
    Expect(0, 73679, '\P{^Nv=180/960}', "");
    Error('\p{Nv=1.9e-01}');
    Error('\P{Nv=1.9e-01}');
    Error('\p{Nv=1.88e-01}');
    Error('\P{Nv=1.88e-01}');
    Error('\p{Nv=0.19}');
    Error('\P{Nv=0.19}');
    Expect(1, 73678, '\p{Nv=1.875e-01}', "");
    Expect(0, 73678, '\p{^Nv=1.875e-01}', "");
    Expect(0, 73678, '\P{Nv=1.875e-01}', "");
    Expect(1, 73678, '\P{^Nv=1.875e-01}', "");
    Expect(0, 73679, '\p{Nv=1.875e-01}', "");
    Expect(1, 73679, '\p{^Nv=1.875e-01}', "");
    Expect(1, 73679, '\P{Nv=1.875e-01}', "");
    Expect(0, 73679, '\P{^Nv=1.875e-01}', "");
    Error('\p{Nv=0.188}');
    Error('\P{Nv=0.188}');
    Expect(1, 73678, '\p{Nv=1.8750e-01}', "");
    Expect(0, 73678, '\p{^Nv=1.8750e-01}', "");
    Expect(0, 73678, '\P{Nv=1.8750e-01}', "");
    Expect(1, 73678, '\P{^Nv=1.8750e-01}', "");
    Expect(0, 73679, '\p{Nv=1.8750e-01}', "");
    Expect(1, 73679, '\p{^Nv=1.8750e-01}', "");
    Expect(1, 73679, '\P{Nv=1.8750e-01}', "");
    Expect(0, 73679, '\P{^Nv=1.8750e-01}', "");
    Expect(1, 73678, '\p{Nv:	0.1875}', "");
    Expect(0, 73678, '\p{^Nv:	0.1875}', "");
    Expect(0, 73678, '\P{Nv:	0.1875}', "");
    Expect(1, 73678, '\P{^Nv:	0.1875}', "");
    Expect(0, 73679, '\p{Nv:	0.1875}', "");
    Expect(1, 73679, '\p{^Nv:	0.1875}', "");
    Expect(1, 73679, '\P{Nv:	0.1875}', "");
    Expect(0, 73679, '\P{^Nv:	0.1875}', "");
    Expect(1, 73678, '\p{Nv=1.87500e-01}', "");
    Expect(0, 73678, '\p{^Nv=1.87500e-01}', "");
    Expect(0, 73678, '\P{Nv=1.87500e-01}', "");
    Expect(1, 73678, '\P{^Nv=1.87500e-01}', "");
    Expect(0, 73679, '\p{Nv=1.87500e-01}', "");
    Expect(1, 73679, '\p{^Nv=1.87500e-01}', "");
    Expect(1, 73679, '\P{Nv=1.87500e-01}', "");
    Expect(0, 73679, '\P{^Nv=1.87500e-01}', "");
    Expect(1, 73678, '\p{Nv=0.18750}', "");
    Expect(0, 73678, '\p{^Nv=0.18750}', "");
    Expect(0, 73678, '\P{Nv=0.18750}', "");
    Expect(1, 73678, '\P{^Nv=0.18750}', "");
    Expect(0, 73679, '\p{Nv=0.18750}', "");
    Expect(1, 73679, '\p{^Nv=0.18750}', "");
    Expect(1, 73679, '\P{Nv=0.18750}', "");
    Expect(0, 73679, '\P{^Nv=0.18750}', "");
    Error('\p{Is_Numeric_Value=_+03/000000016:=}');
    Error('\P{Is_Numeric_Value=_+03/000000016:=}');
    Expect(1, 73678, '\p{Is_Numeric_Value=03/00000016}', "");
    Expect(0, 73678, '\p{^Is_Numeric_Value=03/00000016}', "");
    Expect(0, 73678, '\P{Is_Numeric_Value=03/00000016}', "");
    Expect(1, 73678, '\P{^Is_Numeric_Value=03/00000016}', "");
    Expect(0, 73679, '\p{Is_Numeric_Value=03/00000016}', "");
    Expect(1, 73679, '\p{^Is_Numeric_Value=03/00000016}', "");
    Expect(1, 73679, '\P{Is_Numeric_Value=03/00000016}', "");
    Expect(0, 73679, '\P{^Is_Numeric_Value=03/00000016}', "");
    Expect(1, 73678, '\p{Is_Numeric_Value=180/960}', "");
    Expect(0, 73678, '\p{^Is_Numeric_Value=180/960}', "");
    Expect(0, 73678, '\P{Is_Numeric_Value=180/960}', "");
    Expect(1, 73678, '\P{^Is_Numeric_Value=180/960}', "");
    Expect(0, 73679, '\p{Is_Numeric_Value=180/960}', "");
    Expect(1, 73679, '\p{^Is_Numeric_Value=180/960}', "");
    Expect(1, 73679, '\P{Is_Numeric_Value=180/960}', "");
    Expect(0, 73679, '\P{^Is_Numeric_Value=180/960}', "");
    Error('\p{Is_Numeric_Value=1.9e-01}');
    Error('\P{Is_Numeric_Value=1.9e-01}');
    Error('\p{Is_Numeric_Value=1.88e-01}');
    Error('\P{Is_Numeric_Value=1.88e-01}');
    Error('\p{Is_Numeric_Value=0.19}');
    Error('\P{Is_Numeric_Value=0.19}');
    Expect(1, 73678, '\p{Is_Numeric_Value=1.875e-01}', "");
    Expect(0, 73678, '\p{^Is_Numeric_Value=1.875e-01}', "");
    Expect(0, 73678, '\P{Is_Numeric_Value=1.875e-01}', "");
    Expect(1, 73678, '\P{^Is_Numeric_Value=1.875e-01}', "");
    Expect(0, 73679, '\p{Is_Numeric_Value=1.875e-01}', "");
    Expect(1, 73679, '\p{^Is_Numeric_Value=1.875e-01}', "");
    Expect(1, 73679, '\P{Is_Numeric_Value=1.875e-01}', "");
    Expect(0, 73679, '\P{^Is_Numeric_Value=1.875e-01}', "");
    Error('\p{Is_Numeric_Value=0.188}');
    Error('\P{Is_Numeric_Value=0.188}');
    Expect(1, 73678, '\p{Is_Numeric_Value=1.8750e-01}', "");
    Expect(0, 73678, '\p{^Is_Numeric_Value=1.8750e-01}', "");
    Expect(0, 73678, '\P{Is_Numeric_Value=1.8750e-01}', "");
    Expect(1, 73678, '\P{^Is_Numeric_Value=1.8750e-01}', "");
    Expect(0, 73679, '\p{Is_Numeric_Value=1.8750e-01}', "");
    Expect(1, 73679, '\p{^Is_Numeric_Value=1.8750e-01}', "");
    Expect(1, 73679, '\P{Is_Numeric_Value=1.8750e-01}', "");
    Expect(0, 73679, '\P{^Is_Numeric_Value=1.8750e-01}', "");
    Expect(1, 73678, '\p{Is_Numeric_Value=0.1875}', "");
    Expect(0, 73678, '\p{^Is_Numeric_Value=0.1875}', "");
    Expect(0, 73678, '\P{Is_Numeric_Value=0.1875}', "");
    Expect(1, 73678, '\P{^Is_Numeric_Value=0.1875}', "");
    Expect(0, 73679, '\p{Is_Numeric_Value=0.1875}', "");
    Expect(1, 73679, '\p{^Is_Numeric_Value=0.1875}', "");
    Expect(1, 73679, '\P{Is_Numeric_Value=0.1875}', "");
    Expect(0, 73679, '\P{^Is_Numeric_Value=0.1875}', "");
    Expect(1, 73678, '\p{Is_Numeric_Value=1.87500e-01}', "");
    Expect(0, 73678, '\p{^Is_Numeric_Value=1.87500e-01}', "");
    Expect(0, 73678, '\P{Is_Numeric_Value=1.87500e-01}', "");
    Expect(1, 73678, '\P{^Is_Numeric_Value=1.87500e-01}', "");
    Expect(0, 73679, '\p{Is_Numeric_Value=1.87500e-01}', "");
    Expect(1, 73679, '\p{^Is_Numeric_Value=1.87500e-01}', "");
    Expect(1, 73679, '\P{Is_Numeric_Value=1.87500e-01}', "");
    Expect(0, 73679, '\P{^Is_Numeric_Value=1.87500e-01}', "");
    Expect(1, 73678, '\p{Is_Numeric_Value=0.18750}', "");
    Expect(0, 73678, '\p{^Is_Numeric_Value=0.18750}', "");
    Expect(0, 73678, '\P{Is_Numeric_Value=0.18750}', "");
    Expect(1, 73678, '\P{^Is_Numeric_Value=0.18750}', "");
    Expect(0, 73679, '\p{Is_Numeric_Value=0.18750}', "");
    Expect(1, 73679, '\p{^Is_Numeric_Value=0.18750}', "");
    Expect(1, 73679, '\P{Is_Numeric_Value=0.18750}', "");
    Expect(0, 73679, '\P{^Is_Numeric_Value=0.18750}', "");
    Error('\p{Is_Nv=-:=003/00000000016}');
    Error('\P{Is_Nv=-:=003/00000000016}');
    Expect(1, 73678, '\p{Is_Nv=0000003/0000000016}', "");
    Expect(0, 73678, '\p{^Is_Nv=0000003/0000000016}', "");
    Expect(0, 73678, '\P{Is_Nv=0000003/0000000016}', "");
    Expect(1, 73678, '\P{^Is_Nv=0000003/0000000016}', "");
    Expect(0, 73679, '\p{Is_Nv=0000003/0000000016}', "");
    Expect(1, 73679, '\p{^Is_Nv=0000003/0000000016}', "");
    Expect(1, 73679, '\P{Is_Nv=0000003/0000000016}', "");
    Expect(0, 73679, '\P{^Is_Nv=0000003/0000000016}', "");
    Expect(1, 73678, '\p{Is_Nv=180/960}', "");
    Expect(0, 73678, '\p{^Is_Nv=180/960}', "");
    Expect(0, 73678, '\P{Is_Nv=180/960}', "");
    Expect(1, 73678, '\P{^Is_Nv=180/960}', "");
    Expect(0, 73679, '\p{Is_Nv=180/960}', "");
    Expect(1, 73679, '\p{^Is_Nv=180/960}', "");
    Expect(1, 73679, '\P{Is_Nv=180/960}', "");
    Expect(0, 73679, '\P{^Is_Nv=180/960}', "");
    Error('\p{Is_Nv=1.9e-01}');
    Error('\P{Is_Nv=1.9e-01}');
    Error('\p{Is_Nv=1.88e-01}');
    Error('\P{Is_Nv=1.88e-01}');
    Error('\p{Is_Nv: 0.19}');
    Error('\P{Is_Nv: 0.19}');
    Expect(1, 73678, '\p{Is_Nv=1.875e-01}', "");
    Expect(0, 73678, '\p{^Is_Nv=1.875e-01}', "");
    Expect(0, 73678, '\P{Is_Nv=1.875e-01}', "");
    Expect(1, 73678, '\P{^Is_Nv=1.875e-01}', "");
    Expect(0, 73679, '\p{Is_Nv=1.875e-01}', "");
    Expect(1, 73679, '\p{^Is_Nv=1.875e-01}', "");
    Expect(1, 73679, '\P{Is_Nv=1.875e-01}', "");
    Expect(0, 73679, '\P{^Is_Nv=1.875e-01}', "");
    Error('\p{Is_Nv=0.188}');
    Error('\P{Is_Nv=0.188}');
    Expect(1, 73678, '\p{Is_Nv=1.8750e-01}', "");
    Expect(0, 73678, '\p{^Is_Nv=1.8750e-01}', "");
    Expect(0, 73678, '\P{Is_Nv=1.8750e-01}', "");
    Expect(1, 73678, '\P{^Is_Nv=1.8750e-01}', "");
    Expect(0, 73679, '\p{Is_Nv=1.8750e-01}', "");
    Expect(1, 73679, '\p{^Is_Nv=1.8750e-01}', "");
    Expect(1, 73679, '\P{Is_Nv=1.8750e-01}', "");
    Expect(0, 73679, '\P{^Is_Nv=1.8750e-01}', "");
    Expect(1, 73678, '\p{Is_Nv=0.1875}', "");
    Expect(0, 73678, '\p{^Is_Nv=0.1875}', "");
    Expect(0, 73678, '\P{Is_Nv=0.1875}', "");
    Expect(1, 73678, '\P{^Is_Nv=0.1875}', "");
    Expect(0, 73679, '\p{Is_Nv=0.1875}', "");
    Expect(1, 73679, '\p{^Is_Nv=0.1875}', "");
    Expect(1, 73679, '\P{Is_Nv=0.1875}', "");
    Expect(0, 73679, '\P{^Is_Nv=0.1875}', "");
    Expect(1, 73678, '\p{Is_Nv=1.87500e-01}', "");
    Expect(0, 73678, '\p{^Is_Nv=1.87500e-01}', "");
    Expect(0, 73678, '\P{Is_Nv=1.87500e-01}', "");
    Expect(1, 73678, '\P{^Is_Nv=1.87500e-01}', "");
    Expect(0, 73679, '\p{Is_Nv=1.87500e-01}', "");
    Expect(1, 73679, '\p{^Is_Nv=1.87500e-01}', "");
    Expect(1, 73679, '\P{Is_Nv=1.87500e-01}', "");
    Expect(0, 73679, '\P{^Is_Nv=1.87500e-01}', "");
    Expect(1, 73678, '\p{Is_Nv=0.18750}', "");
    Expect(0, 73678, '\p{^Is_Nv=0.18750}', "");
    Expect(0, 73678, '\P{Is_Nv=0.18750}', "");
    Expect(1, 73678, '\P{^Is_Nv=0.18750}', "");
    Expect(0, 73679, '\p{Is_Nv=0.18750}', "");
    Expect(1, 73679, '\p{^Is_Nv=0.18750}', "");
    Expect(1, 73679, '\P{Is_Nv=0.18750}', "");
    Expect(0, 73679, '\P{^Is_Nv=0.18750}', "");
    Error('\p{Numeric_Value= /a/03/0000000002}');
    Error('\P{Numeric_Value= /a/03/0000000002}');
    Expect(1, 3883, '\p{Numeric_Value=:\A3/2\z:}', "");;
    Expect(0, 3884, '\p{Numeric_Value=:\A3/2\z:}', "");;
    Expect(1, 3883, '\p{Numeric_Value:	000000003/2}', "");
    Expect(0, 3883, '\p{^Numeric_Value:	000000003/2}', "");
    Expect(0, 3883, '\P{Numeric_Value:	000000003/2}', "");
    Expect(1, 3883, '\P{^Numeric_Value:	000000003/2}', "");
    Expect(0, 3884, '\p{Numeric_Value:	000000003/2}', "");
    Expect(1, 3884, '\p{^Numeric_Value:	000000003/2}', "");
    Expect(1, 3884, '\P{Numeric_Value:	000000003/2}', "");
    Expect(0, 3884, '\P{^Numeric_Value:	000000003/2}', "");
    Expect(1, 3883, '\p{Numeric_Value=180/120}', "");
    Expect(0, 3883, '\p{^Numeric_Value=180/120}', "");
    Expect(0, 3883, '\P{Numeric_Value=180/120}', "");
    Expect(1, 3883, '\P{^Numeric_Value=180/120}', "");
    Expect(0, 3884, '\p{Numeric_Value=180/120}', "");
    Expect(1, 3884, '\p{^Numeric_Value=180/120}', "");
    Expect(1, 3884, '\P{Numeric_Value=180/120}', "");
    Expect(0, 3884, '\P{^Numeric_Value=180/120}', "");
    Expect(1, 3883, '\p{Numeric_Value=1.5e+00}', "");
    Expect(0, 3883, '\p{^Numeric_Value=1.5e+00}', "");
    Expect(0, 3883, '\P{Numeric_Value=1.5e+00}', "");
    Expect(1, 3883, '\P{^Numeric_Value=1.5e+00}', "");
    Expect(0, 3884, '\p{Numeric_Value=1.5e+00}', "");
    Expect(1, 3884, '\p{^Numeric_Value=1.5e+00}', "");
    Expect(1, 3884, '\P{Numeric_Value=1.5e+00}', "");
    Expect(0, 3884, '\P{^Numeric_Value=1.5e+00}', "");
    Expect(1, 3883, '\p{Numeric_Value=1.5}', "");
    Expect(0, 3883, '\p{^Numeric_Value=1.5}', "");
    Expect(0, 3883, '\P{Numeric_Value=1.5}', "");
    Expect(1, 3883, '\P{^Numeric_Value=1.5}', "");
    Expect(0, 3884, '\p{Numeric_Value=1.5}', "");
    Expect(1, 3884, '\p{^Numeric_Value=1.5}', "");
    Expect(1, 3884, '\P{Numeric_Value=1.5}', "");
    Expect(0, 3884, '\P{^Numeric_Value=1.5}', "");
    Expect(1, 3883, '\p{Numeric_Value=1.50e+00}', "");
    Expect(0, 3883, '\p{^Numeric_Value=1.50e+00}', "");
    Expect(0, 3883, '\P{Numeric_Value=1.50e+00}', "");
    Expect(1, 3883, '\P{^Numeric_Value=1.50e+00}', "");
    Expect(0, 3884, '\p{Numeric_Value=1.50e+00}', "");
    Expect(1, 3884, '\p{^Numeric_Value=1.50e+00}', "");
    Expect(1, 3884, '\P{Numeric_Value=1.50e+00}', "");
    Expect(0, 3884, '\P{^Numeric_Value=1.50e+00}', "");
    Expect(1, 3883, '\p{Numeric_Value=1.50}', "");
    Expect(0, 3883, '\p{^Numeric_Value=1.50}', "");
    Expect(0, 3883, '\P{Numeric_Value=1.50}', "");
    Expect(1, 3883, '\P{^Numeric_Value=1.50}', "");
    Expect(0, 3884, '\p{Numeric_Value=1.50}', "");
    Expect(1, 3884, '\p{^Numeric_Value=1.50}', "");
    Expect(1, 3884, '\P{Numeric_Value=1.50}', "");
    Expect(0, 3884, '\P{^Numeric_Value=1.50}', "");
    Error('\p{Nv=/a/_3/0002}');
    Error('\P{Nv=/a/_3/0002}');
    Expect(1, 3883, '\p{Nv=:\A3/2\z:}', "");;
    Expect(0, 3884, '\p{Nv=:\A3/2\z:}', "");;
    Expect(1, 3883, '\p{Nv=000000003/0000002}', "");
    Expect(0, 3883, '\p{^Nv=000000003/0000002}', "");
    Expect(0, 3883, '\P{Nv=000000003/0000002}', "");
    Expect(1, 3883, '\P{^Nv=000000003/0000002}', "");
    Expect(0, 3884, '\p{Nv=000000003/0000002}', "");
    Expect(1, 3884, '\p{^Nv=000000003/0000002}', "");
    Expect(1, 3884, '\P{Nv=000000003/0000002}', "");
    Expect(0, 3884, '\P{^Nv=000000003/0000002}', "");
    Expect(1, 3883, '\p{Nv=180/120}', "");
    Expect(0, 3883, '\p{^Nv=180/120}', "");
    Expect(0, 3883, '\P{Nv=180/120}', "");
    Expect(1, 3883, '\P{^Nv=180/120}', "");
    Expect(0, 3884, '\p{Nv=180/120}', "");
    Expect(1, 3884, '\p{^Nv=180/120}', "");
    Expect(1, 3884, '\P{Nv=180/120}', "");
    Expect(0, 3884, '\P{^Nv=180/120}', "");
    Expect(1, 3883, '\p{Nv: 1.5e+00}', "");
    Expect(0, 3883, '\p{^Nv: 1.5e+00}', "");
    Expect(0, 3883, '\P{Nv: 1.5e+00}', "");
    Expect(1, 3883, '\P{^Nv: 1.5e+00}', "");
    Expect(0, 3884, '\p{Nv: 1.5e+00}', "");
    Expect(1, 3884, '\p{^Nv: 1.5e+00}', "");
    Expect(1, 3884, '\P{Nv: 1.5e+00}', "");
    Expect(0, 3884, '\P{^Nv: 1.5e+00}', "");
    Expect(1, 3883, '\p{Nv:	1.5}', "");
    Expect(0, 3883, '\p{^Nv:	1.5}', "");
    Expect(0, 3883, '\P{Nv:	1.5}', "");
    Expect(1, 3883, '\P{^Nv:	1.5}', "");
    Expect(0, 3884, '\p{Nv:	1.5}', "");
    Expect(1, 3884, '\p{^Nv:	1.5}', "");
    Expect(1, 3884, '\P{Nv:	1.5}', "");
    Expect(0, 3884, '\P{^Nv:	1.5}', "");
    Expect(1, 3883, '\p{Nv=1.50e+00}', "");
    Expect(0, 3883, '\p{^Nv=1.50e+00}', "");
    Expect(0, 3883, '\P{Nv=1.50e+00}', "");
    Expect(1, 3883, '\P{^Nv=1.50e+00}', "");
    Expect(0, 3884, '\p{Nv=1.50e+00}', "");
    Expect(1, 3884, '\p{^Nv=1.50e+00}', "");
    Expect(1, 3884, '\P{Nv=1.50e+00}', "");
    Expect(0, 3884, '\P{^Nv=1.50e+00}', "");
    Expect(1, 3883, '\p{Nv=1.50}', "");
    Expect(0, 3883, '\p{^Nv=1.50}', "");
    Expect(0, 3883, '\P{Nv=1.50}', "");
    Expect(1, 3883, '\P{^Nv=1.50}', "");
    Expect(0, 3884, '\p{Nv=1.50}', "");
    Expect(1, 3884, '\p{^Nv=1.50}', "");
    Expect(1, 3884, '\P{Nv=1.50}', "");
    Expect(0, 3884, '\P{^Nv=1.50}', "");
    Error('\p{Is_Numeric_Value=/a/__+003/002}');
    Error('\P{Is_Numeric_Value=/a/__+003/002}');
    Expect(1, 3883, '\p{Is_Numeric_Value:	003/02}', "");
    Expect(0, 3883, '\p{^Is_Numeric_Value:	003/02}', "");
    Expect(0, 3883, '\P{Is_Numeric_Value:	003/02}', "");
    Expect(1, 3883, '\P{^Is_Numeric_Value:	003/02}', "");
    Expect(0, 3884, '\p{Is_Numeric_Value:	003/02}', "");
    Expect(1, 3884, '\p{^Is_Numeric_Value:	003/02}', "");
    Expect(1, 3884, '\P{Is_Numeric_Value:	003/02}', "");
    Expect(0, 3884, '\P{^Is_Numeric_Value:	003/02}', "");
    Expect(1, 3883, '\p{Is_Numeric_Value=180/120}', "");
    Expect(0, 3883, '\p{^Is_Numeric_Value=180/120}', "");
    Expect(0, 3883, '\P{Is_Numeric_Value=180/120}', "");
    Expect(1, 3883, '\P{^Is_Numeric_Value=180/120}', "");
    Expect(0, 3884, '\p{Is_Numeric_Value=180/120}', "");
    Expect(1, 3884, '\p{^Is_Numeric_Value=180/120}', "");
    Expect(1, 3884, '\P{Is_Numeric_Value=180/120}', "");
    Expect(0, 3884, '\P{^Is_Numeric_Value=180/120}', "");
    Expect(1, 3883, '\p{Is_Numeric_Value:   1.5e+00}', "");
    Expect(0, 3883, '\p{^Is_Numeric_Value:   1.5e+00}', "");
    Expect(0, 3883, '\P{Is_Numeric_Value:   1.5e+00}', "");
    Expect(1, 3883, '\P{^Is_Numeric_Value:   1.5e+00}', "");
    Expect(0, 3884, '\p{Is_Numeric_Value:   1.5e+00}', "");
    Expect(1, 3884, '\p{^Is_Numeric_Value:   1.5e+00}', "");
    Expect(1, 3884, '\P{Is_Numeric_Value:   1.5e+00}', "");
    Expect(0, 3884, '\P{^Is_Numeric_Value:   1.5e+00}', "");
    Expect(1, 3883, '\p{Is_Numeric_Value=1.5}', "");
    Expect(0, 3883, '\p{^Is_Numeric_Value=1.5}', "");
    Expect(0, 3883, '\P{Is_Numeric_Value=1.5}', "");
    Expect(1, 3883, '\P{^Is_Numeric_Value=1.5}', "");
    Expect(0, 3884, '\p{Is_Numeric_Value=1.5}', "");
    Expect(1, 3884, '\p{^Is_Numeric_Value=1.5}', "");
    Expect(1, 3884, '\P{Is_Numeric_Value=1.5}', "");
    Expect(0, 3884, '\P{^Is_Numeric_Value=1.5}', "");
    Expect(1, 3883, '\p{Is_Numeric_Value=1.50e+00}', "");
    Expect(0, 3883, '\p{^Is_Numeric_Value=1.50e+00}', "");
    Expect(0, 3883, '\P{Is_Numeric_Value=1.50e+00}', "");
    Expect(1, 3883, '\P{^Is_Numeric_Value=1.50e+00}', "");
    Expect(0, 3884, '\p{Is_Numeric_Value=1.50e+00}', "");
    Expect(1, 3884, '\p{^Is_Numeric_Value=1.50e+00}', "");
    Expect(1, 3884, '\P{Is_Numeric_Value=1.50e+00}', "");
    Expect(0, 3884, '\P{^Is_Numeric_Value=1.50e+00}', "");
    Expect(1, 3883, '\p{Is_Numeric_Value=1.50}', "");
    Expect(0, 3883, '\p{^Is_Numeric_Value=1.50}', "");
    Expect(0, 3883, '\P{Is_Numeric_Value=1.50}', "");
    Expect(1, 3883, '\P{^Is_Numeric_Value=1.50}', "");
    Expect(0, 3884, '\p{Is_Numeric_Value=1.50}', "");
    Expect(1, 3884, '\p{^Is_Numeric_Value=1.50}', "");
    Expect(1, 3884, '\P{Is_Numeric_Value=1.50}', "");
    Expect(0, 3884, '\P{^Is_Numeric_Value=1.50}', "");
    Error('\p{Is_Nv=:= -003/000002}');
    Error('\P{Is_Nv=:= -003/000002}');
    Expect(1, 3883, '\p{Is_Nv:03/002}', "");
    Expect(0, 3883, '\p{^Is_Nv:03/002}', "");
    Expect(0, 3883, '\P{Is_Nv:03/002}', "");
    Expect(1, 3883, '\P{^Is_Nv:03/002}', "");
    Expect(0, 3884, '\p{Is_Nv:03/002}', "");
    Expect(1, 3884, '\p{^Is_Nv:03/002}', "");
    Expect(1, 3884, '\P{Is_Nv:03/002}', "");
    Expect(0, 3884, '\P{^Is_Nv:03/002}', "");
    Expect(1, 3883, '\p{Is_Nv=180/120}', "");
    Expect(0, 3883, '\p{^Is_Nv=180/120}', "");
    Expect(0, 3883, '\P{Is_Nv=180/120}', "");
    Expect(1, 3883, '\P{^Is_Nv=180/120}', "");
    Expect(0, 3884, '\p{Is_Nv=180/120}', "");
    Expect(1, 3884, '\p{^Is_Nv=180/120}', "");
    Expect(1, 3884, '\P{Is_Nv=180/120}', "");
    Expect(0, 3884, '\P{^Is_Nv=180/120}', "");
    Expect(1, 3883, '\p{Is_Nv=1.5e+00}', "");
    Expect(0, 3883, '\p{^Is_Nv=1.5e+00}', "");
    Expect(0, 3883, '\P{Is_Nv=1.5e+00}', "");
    Expect(1, 3883, '\P{^Is_Nv=1.5e+00}', "");
    Expect(0, 3884, '\p{Is_Nv=1.5e+00}', "");
    Expect(1, 3884, '\p{^Is_Nv=1.5e+00}', "");
    Expect(1, 3884, '\P{Is_Nv=1.5e+00}', "");
    Expect(0, 3884, '\P{^Is_Nv=1.5e+00}', "");
    Expect(1, 3883, '\p{Is_Nv=1.5}', "");
    Expect(0, 3883, '\p{^Is_Nv=1.5}', "");
    Expect(0, 3883, '\P{Is_Nv=1.5}', "");
    Expect(1, 3883, '\P{^Is_Nv=1.5}', "");
    Expect(0, 3884, '\p{Is_Nv=1.5}', "");
    Expect(1, 3884, '\p{^Is_Nv=1.5}', "");
    Expect(1, 3884, '\P{Is_Nv=1.5}', "");
    Expect(0, 3884, '\P{^Is_Nv=1.5}', "");
    Expect(1, 3883, '\p{Is_Nv=1.50e+00}', "");
    Expect(0, 3883, '\p{^Is_Nv=1.50e+00}', "");
    Expect(0, 3883, '\P{Is_Nv=1.50e+00}', "");
    Expect(1, 3883, '\P{^Is_Nv=1.50e+00}', "");
    Expect(0, 3884, '\p{Is_Nv=1.50e+00}', "");
    Expect(1, 3884, '\p{^Is_Nv=1.50e+00}', "");
    Expect(1, 3884, '\P{Is_Nv=1.50e+00}', "");
    Expect(0, 3884, '\P{^Is_Nv=1.50e+00}', "");
    Expect(1, 3883, '\p{Is_Nv: 1.50}', "");
    Expect(0, 3883, '\p{^Is_Nv: 1.50}', "");
    Expect(0, 3883, '\P{Is_Nv: 1.50}', "");
    Expect(1, 3883, '\P{^Is_Nv: 1.50}', "");
    Expect(0, 3884, '\p{Is_Nv: 1.50}', "");
    Expect(1, 3884, '\p{^Is_Nv: 1.50}', "");
    Expect(1, 3884, '\P{Is_Nv: 1.50}', "");
    Expect(0, 3884, '\P{^Is_Nv: 1.50}', "");
    Error('\p{Numeric_Value=	 +00003/0000000020:=}');
    Error('\P{Numeric_Value=	 +00003/0000000020:=}');
    Expect(1, 73677, '\p{Numeric_Value=:\A3/20\z:}', "");;
    Expect(0, 73678, '\p{Numeric_Value=:\A3/20\z:}', "");;
    Expect(1, 73677, '\p{Numeric_Value=0003/00000000020}', "");
    Expect(0, 73677, '\p{^Numeric_Value=0003/00000000020}', "");
    Expect(0, 73677, '\P{Numeric_Value=0003/00000000020}', "");
    Expect(1, 73677, '\P{^Numeric_Value=0003/00000000020}', "");
    Expect(0, 73678, '\p{Numeric_Value=0003/00000000020}', "");
    Expect(1, 73678, '\p{^Numeric_Value=0003/00000000020}', "");
    Expect(1, 73678, '\P{Numeric_Value=0003/00000000020}', "");
    Expect(0, 73678, '\P{^Numeric_Value=0003/00000000020}', "");
    Expect(1, 73677, '\p{Numeric_Value=180/1200}', "");
    Expect(0, 73677, '\p{^Numeric_Value=180/1200}', "");
    Expect(0, 73677, '\P{Numeric_Value=180/1200}', "");
    Expect(1, 73677, '\P{^Numeric_Value=180/1200}', "");
    Expect(0, 73678, '\p{Numeric_Value=180/1200}', "");
    Expect(1, 73678, '\p{^Numeric_Value=180/1200}', "");
    Expect(1, 73678, '\P{Numeric_Value=180/1200}', "");
    Expect(0, 73678, '\P{^Numeric_Value=180/1200}', "");
    Expect(1, 73677, '\p{Numeric_Value=1.5e-01}', "");
    Expect(0, 73677, '\p{^Numeric_Value=1.5e-01}', "");
    Expect(0, 73677, '\P{Numeric_Value=1.5e-01}', "");
    Expect(1, 73677, '\P{^Numeric_Value=1.5e-01}', "");
    Expect(0, 73678, '\p{Numeric_Value=1.5e-01}', "");
    Expect(1, 73678, '\p{^Numeric_Value=1.5e-01}', "");
    Expect(1, 73678, '\P{Numeric_Value=1.5e-01}', "");
    Expect(0, 73678, '\P{^Numeric_Value=1.5e-01}', "");
    Expect(1, 73677, '\p{Numeric_Value=1.50e-01}', "");
    Expect(0, 73677, '\p{^Numeric_Value=1.50e-01}', "");
    Expect(0, 73677, '\P{Numeric_Value=1.50e-01}', "");
    Expect(1, 73677, '\P{^Numeric_Value=1.50e-01}', "");
    Expect(0, 73678, '\p{Numeric_Value=1.50e-01}', "");
    Expect(1, 73678, '\p{^Numeric_Value=1.50e-01}', "");
    Expect(1, 73678, '\P{Numeric_Value=1.50e-01}', "");
    Expect(0, 73678, '\P{^Numeric_Value=1.50e-01}', "");
    Expect(1, 73677, '\p{Numeric_Value=0.15}', "");
    Expect(0, 73677, '\p{^Numeric_Value=0.15}', "");
    Expect(0, 73677, '\P{Numeric_Value=0.15}', "");
    Expect(1, 73677, '\P{^Numeric_Value=0.15}', "");
    Expect(0, 73678, '\p{Numeric_Value=0.15}', "");
    Expect(1, 73678, '\p{^Numeric_Value=0.15}', "");
    Expect(1, 73678, '\P{Numeric_Value=0.15}', "");
    Expect(0, 73678, '\P{^Numeric_Value=0.15}', "");
    Expect(1, 73677, '\p{Numeric_Value=1.500e-01}', "");
    Expect(0, 73677, '\p{^Numeric_Value=1.500e-01}', "");
    Expect(0, 73677, '\P{Numeric_Value=1.500e-01}', "");
    Expect(1, 73677, '\P{^Numeric_Value=1.500e-01}', "");
    Expect(0, 73678, '\p{Numeric_Value=1.500e-01}', "");
    Expect(1, 73678, '\p{^Numeric_Value=1.500e-01}', "");
    Expect(1, 73678, '\P{Numeric_Value=1.500e-01}', "");
    Expect(0, 73678, '\P{^Numeric_Value=1.500e-01}', "");
    Expect(1, 73677, '\p{Numeric_Value=0.150}', "");
    Expect(0, 73677, '\p{^Numeric_Value=0.150}', "");
    Expect(0, 73677, '\P{Numeric_Value=0.150}', "");
    Expect(1, 73677, '\P{^Numeric_Value=0.150}', "");
    Expect(0, 73678, '\p{Numeric_Value=0.150}', "");
    Expect(1, 73678, '\p{^Numeric_Value=0.150}', "");
    Expect(1, 73678, '\P{Numeric_Value=0.150}', "");
    Expect(0, 73678, '\P{^Numeric_Value=0.150}', "");
    Error('\p{Nv: 003/000020/a/}');
    Error('\P{Nv: 003/000020/a/}');
    Expect(1, 73677, '\p{Nv=:\A3/20\z:}', "");;
    Expect(0, 73678, '\p{Nv=:\A3/20\z:}', "");;
    Expect(1, 73677, '\p{Nv=+3/000000020}', "");
    Expect(0, 73677, '\p{^Nv=+3/000000020}', "");
    Expect(0, 73677, '\P{Nv=+3/000000020}', "");
    Expect(1, 73677, '\P{^Nv=+3/000000020}', "");
    Expect(0, 73678, '\p{Nv=+3/000000020}', "");
    Expect(1, 73678, '\p{^Nv=+3/000000020}', "");
    Expect(1, 73678, '\P{Nv=+3/000000020}', "");
    Expect(0, 73678, '\P{^Nv=+3/000000020}', "");
    Expect(1, 73677, '\p{Nv=180/1200}', "");
    Expect(0, 73677, '\p{^Nv=180/1200}', "");
    Expect(0, 73677, '\P{Nv=180/1200}', "");
    Expect(1, 73677, '\P{^Nv=180/1200}', "");
    Expect(0, 73678, '\p{Nv=180/1200}', "");
    Expect(1, 73678, '\p{^Nv=180/1200}', "");
    Expect(1, 73678, '\P{Nv=180/1200}', "");
    Expect(0, 73678, '\P{^Nv=180/1200}', "");
    Expect(1, 73677, '\p{Nv=1.5e-01}', "");
    Expect(0, 73677, '\p{^Nv=1.5e-01}', "");
    Expect(0, 73677, '\P{Nv=1.5e-01}', "");
    Expect(1, 73677, '\P{^Nv=1.5e-01}', "");
    Expect(0, 73678, '\p{Nv=1.5e-01}', "");
    Expect(1, 73678, '\p{^Nv=1.5e-01}', "");
    Expect(1, 73678, '\P{Nv=1.5e-01}', "");
    Expect(0, 73678, '\P{^Nv=1.5e-01}', "");
    Expect(1, 73677, '\p{Nv=1.50e-01}', "");
    Expect(0, 73677, '\p{^Nv=1.50e-01}', "");
    Expect(0, 73677, '\P{Nv=1.50e-01}', "");
    Expect(1, 73677, '\P{^Nv=1.50e-01}', "");
    Expect(0, 73678, '\p{Nv=1.50e-01}', "");
    Expect(1, 73678, '\p{^Nv=1.50e-01}', "");
    Expect(1, 73678, '\P{Nv=1.50e-01}', "");
    Expect(0, 73678, '\P{^Nv=1.50e-01}', "");
    Expect(1, 73677, '\p{Nv: 0.15}', "");
    Expect(0, 73677, '\p{^Nv: 0.15}', "");
    Expect(0, 73677, '\P{Nv: 0.15}', "");
    Expect(1, 73677, '\P{^Nv: 0.15}', "");
    Expect(0, 73678, '\p{Nv: 0.15}', "");
    Expect(1, 73678, '\p{^Nv: 0.15}', "");
    Expect(1, 73678, '\P{Nv: 0.15}', "");
    Expect(0, 73678, '\P{^Nv: 0.15}', "");
    Expect(1, 73677, '\p{Nv=1.500e-01}', "");
    Expect(0, 73677, '\p{^Nv=1.500e-01}', "");
    Expect(0, 73677, '\P{Nv=1.500e-01}', "");
    Expect(1, 73677, '\P{^Nv=1.500e-01}', "");
    Expect(0, 73678, '\p{Nv=1.500e-01}', "");
    Expect(1, 73678, '\p{^Nv=1.500e-01}', "");
    Expect(1, 73678, '\P{Nv=1.500e-01}', "");
    Expect(0, 73678, '\P{^Nv=1.500e-01}', "");
    Expect(1, 73677, '\p{Nv=0.150}', "");
    Expect(0, 73677, '\p{^Nv=0.150}', "");
    Expect(0, 73677, '\P{Nv=0.150}', "");
    Expect(1, 73677, '\P{^Nv=0.150}', "");
    Expect(0, 73678, '\p{Nv=0.150}', "");
    Expect(1, 73678, '\p{^Nv=0.150}', "");
    Expect(1, 73678, '\P{Nv=0.150}', "");
    Expect(0, 73678, '\P{^Nv=0.150}', "");
    Error('\p{Is_Numeric_Value= :=03/000020}');
    Error('\P{Is_Numeric_Value= :=03/000020}');
    Expect(1, 73677, '\p{Is_Numeric_Value:+03/000020}', "");
    Expect(0, 73677, '\p{^Is_Numeric_Value:+03/000020}', "");
    Expect(0, 73677, '\P{Is_Numeric_Value:+03/000020}', "");
    Expect(1, 73677, '\P{^Is_Numeric_Value:+03/000020}', "");
    Expect(0, 73678, '\p{Is_Numeric_Value:+03/000020}', "");
    Expect(1, 73678, '\p{^Is_Numeric_Value:+03/000020}', "");
    Expect(1, 73678, '\P{Is_Numeric_Value:+03/000020}', "");
    Expect(0, 73678, '\P{^Is_Numeric_Value:+03/000020}', "");
    Expect(1, 73677, '\p{Is_Numeric_Value:	180/1200}', "");
    Expect(0, 73677, '\p{^Is_Numeric_Value:	180/1200}', "");
    Expect(0, 73677, '\P{Is_Numeric_Value:	180/1200}', "");
    Expect(1, 73677, '\P{^Is_Numeric_Value:	180/1200}', "");
    Expect(0, 73678, '\p{Is_Numeric_Value:	180/1200}', "");
    Expect(1, 73678, '\p{^Is_Numeric_Value:	180/1200}', "");
    Expect(1, 73678, '\P{Is_Numeric_Value:	180/1200}', "");
    Expect(0, 73678, '\P{^Is_Numeric_Value:	180/1200}', "");
    Expect(1, 73677, '\p{Is_Numeric_Value:   1.5e-01}', "");
    Expect(0, 73677, '\p{^Is_Numeric_Value:   1.5e-01}', "");
    Expect(0, 73677, '\P{Is_Numeric_Value:   1.5e-01}', "");
    Expect(1, 73677, '\P{^Is_Numeric_Value:   1.5e-01}', "");
    Expect(0, 73678, '\p{Is_Numeric_Value:   1.5e-01}', "");
    Expect(1, 73678, '\p{^Is_Numeric_Value:   1.5e-01}', "");
    Expect(1, 73678, '\P{Is_Numeric_Value:   1.5e-01}', "");
    Expect(0, 73678, '\P{^Is_Numeric_Value:   1.5e-01}', "");
    Expect(1, 73677, '\p{Is_Numeric_Value:1.50e-01}', "");
    Expect(0, 73677, '\p{^Is_Numeric_Value:1.50e-01}', "");
    Expect(0, 73677, '\P{Is_Numeric_Value:1.50e-01}', "");
    Expect(1, 73677, '\P{^Is_Numeric_Value:1.50e-01}', "");
    Expect(0, 73678, '\p{Is_Numeric_Value:1.50e-01}', "");
    Expect(1, 73678, '\p{^Is_Numeric_Value:1.50e-01}', "");
    Expect(1, 73678, '\P{Is_Numeric_Value:1.50e-01}', "");
    Expect(0, 73678, '\P{^Is_Numeric_Value:1.50e-01}', "");
    Expect(1, 73677, '\p{Is_Numeric_Value=0.15}', "");
    Expect(0, 73677, '\p{^Is_Numeric_Value=0.15}', "");
    Expect(0, 73677, '\P{Is_Numeric_Value=0.15}', "");
    Expect(1, 73677, '\P{^Is_Numeric_Value=0.15}', "");
    Expect(0, 73678, '\p{Is_Numeric_Value=0.15}', "");
    Expect(1, 73678, '\p{^Is_Numeric_Value=0.15}', "");
    Expect(1, 73678, '\P{Is_Numeric_Value=0.15}', "");
    Expect(0, 73678, '\P{^Is_Numeric_Value=0.15}', "");
    Expect(1, 73677, '\p{Is_Numeric_Value=1.500e-01}', "");
    Expect(0, 73677, '\p{^Is_Numeric_Value=1.500e-01}', "");
    Expect(0, 73677, '\P{Is_Numeric_Value=1.500e-01}', "");
    Expect(1, 73677, '\P{^Is_Numeric_Value=1.500e-01}', "");
    Expect(0, 73678, '\p{Is_Numeric_Value=1.500e-01}', "");
    Expect(1, 73678, '\p{^Is_Numeric_Value=1.500e-01}', "");
    Expect(1, 73678, '\P{Is_Numeric_Value=1.500e-01}', "");
    Expect(0, 73678, '\P{^Is_Numeric_Value=1.500e-01}', "");
    Expect(1, 73677, '\p{Is_Numeric_Value=0.150}', "");
    Expect(0, 73677, '\p{^Is_Numeric_Value=0.150}', "");
    Expect(0, 73677, '\P{Is_Numeric_Value=0.150}', "");
    Expect(1, 73677, '\P{^Is_Numeric_Value=0.150}', "");
    Expect(0, 73678, '\p{Is_Numeric_Value=0.150}', "");
    Expect(1, 73678, '\p{^Is_Numeric_Value=0.150}', "");
    Expect(1, 73678, '\P{Is_Numeric_Value=0.150}', "");
    Expect(0, 73678, '\P{^Is_Numeric_Value=0.150}', "");
    Error('\p{Is_Nv=	 0003/00000000020:=}');
    Error('\P{Is_Nv=	 0003/00000000020:=}');
    Expect(1, 73677, '\p{Is_Nv=00003/000020}', "");
    Expect(0, 73677, '\p{^Is_Nv=00003/000020}', "");
    Expect(0, 73677, '\P{Is_Nv=00003/000020}', "");
    Expect(1, 73677, '\P{^Is_Nv=00003/000020}', "");
    Expect(0, 73678, '\p{Is_Nv=00003/000020}', "");
    Expect(1, 73678, '\p{^Is_Nv=00003/000020}', "");
    Expect(1, 73678, '\P{Is_Nv=00003/000020}', "");
    Expect(0, 73678, '\P{^Is_Nv=00003/000020}', "");
    Expect(1, 73677, '\p{Is_Nv=180/1200}', "");
    Expect(0, 73677, '\p{^Is_Nv=180/1200}', "");
    Expect(0, 73677, '\P{Is_Nv=180/1200}', "");
    Expect(1, 73677, '\P{^Is_Nv=180/1200}', "");
    Expect(0, 73678, '\p{Is_Nv=180/1200}', "");
    Expect(1, 73678, '\p{^Is_Nv=180/1200}', "");
    Expect(1, 73678, '\P{Is_Nv=180/1200}', "");
    Expect(0, 73678, '\P{^Is_Nv=180/1200}', "");
    Expect(1, 73677, '\p{Is_Nv=1.5e-01}', "");
    Expect(0, 73677, '\p{^Is_Nv=1.5e-01}', "");
    Expect(0, 73677, '\P{Is_Nv=1.5e-01}', "");
    Expect(1, 73677, '\P{^Is_Nv=1.5e-01}', "");
    Expect(0, 73678, '\p{Is_Nv=1.5e-01}', "");
    Expect(1, 73678, '\p{^Is_Nv=1.5e-01}', "");
    Expect(1, 73678, '\P{Is_Nv=1.5e-01}', "");
    Expect(0, 73678, '\P{^Is_Nv=1.5e-01}', "");
    Expect(1, 73677, '\p{Is_Nv=1.50e-01}', "");
    Expect(0, 73677, '\p{^Is_Nv=1.50e-01}', "");
    Expect(0, 73677, '\P{Is_Nv=1.50e-01}', "");
    Expect(1, 73677, '\P{^Is_Nv=1.50e-01}', "");
    Expect(0, 73678, '\p{Is_Nv=1.50e-01}', "");
    Expect(1, 73678, '\p{^Is_Nv=1.50e-01}', "");
    Expect(1, 73678, '\P{Is_Nv=1.50e-01}', "");
    Expect(0, 73678, '\P{^Is_Nv=1.50e-01}', "");
    Expect(1, 73677, '\p{Is_Nv=0.15}', "");
    Expect(0, 73677, '\p{^Is_Nv=0.15}', "");
    Expect(0, 73677, '\P{Is_Nv=0.15}', "");
    Expect(1, 73677, '\P{^Is_Nv=0.15}', "");
    Expect(0, 73678, '\p{Is_Nv=0.15}', "");
    Expect(1, 73678, '\p{^Is_Nv=0.15}', "");
    Expect(1, 73678, '\P{Is_Nv=0.15}', "");
    Expect(0, 73678, '\P{^Is_Nv=0.15}', "");
    Expect(1, 73677, '\p{Is_Nv=1.500e-01}', "");
    Expect(0, 73677, '\p{^Is_Nv=1.500e-01}', "");
    Expect(0, 73677, '\P{Is_Nv=1.500e-01}', "");
    Expect(1, 73677, '\P{^Is_Nv=1.500e-01}', "");
    Expect(0, 73678, '\p{Is_Nv=1.500e-01}', "");
    Expect(1, 73678, '\p{^Is_Nv=1.500e-01}', "");
    Expect(1, 73678, '\P{Is_Nv=1.500e-01}', "");
    Expect(0, 73678, '\P{^Is_Nv=1.500e-01}', "");
    Expect(1, 73677, '\p{Is_Nv=0.150}', "");
    Expect(0, 73677, '\p{^Is_Nv=0.150}', "");
    Expect(0, 73677, '\P{Is_Nv=0.150}', "");
    Expect(1, 73677, '\P{^Is_Nv=0.150}', "");
    Expect(0, 73678, '\p{Is_Nv=0.150}', "");
    Expect(1, 73678, '\p{^Is_Nv=0.150}', "");
    Expect(1, 73678, '\P{Is_Nv=0.150}', "");
    Expect(0, 73678, '\P{^Is_Nv=0.150}', "");
    Error('\p{Numeric_Value=_ +0000000003/000000004:=}');
    Error('\P{Numeric_Value=_ +0000000003/000000004:=}');
    Expect(1, 126127, '\p{Numeric_Value=:\A3/4\z:}', "");;
    Expect(0, 126128, '\p{Numeric_Value=:\A3/4\z:}', "");;
    Expect(1, 126127, '\p{Numeric_Value=003/0004}', "");
    Expect(0, 126127, '\p{^Numeric_Value=003/0004}', "");
    Expect(0, 126127, '\P{Numeric_Value=003/0004}', "");
    Expect(1, 126127, '\P{^Numeric_Value=003/0004}', "");
    Expect(0, 126128, '\p{Numeric_Value=003/0004}', "");
    Expect(1, 126128, '\p{^Numeric_Value=003/0004}', "");
    Expect(1, 126128, '\P{Numeric_Value=003/0004}', "");
    Expect(0, 126128, '\P{^Numeric_Value=003/0004}', "");
    Expect(1, 126127, '\p{Numeric_Value=180/240}', "");
    Expect(0, 126127, '\p{^Numeric_Value=180/240}', "");
    Expect(0, 126127, '\P{Numeric_Value=180/240}', "");
    Expect(1, 126127, '\P{^Numeric_Value=180/240}', "");
    Expect(0, 126128, '\p{Numeric_Value=180/240}', "");
    Expect(1, 126128, '\p{^Numeric_Value=180/240}', "");
    Expect(1, 126128, '\P{Numeric_Value=180/240}', "");
    Expect(0, 126128, '\P{^Numeric_Value=180/240}', "");
    Expect(1, 126127, '\p{Numeric_Value=7.5e-01}', "");
    Expect(0, 126127, '\p{^Numeric_Value=7.5e-01}', "");
    Expect(0, 126127, '\P{Numeric_Value=7.5e-01}', "");
    Expect(1, 126127, '\P{^Numeric_Value=7.5e-01}', "");
    Expect(0, 126128, '\p{Numeric_Value=7.5e-01}', "");
    Expect(1, 126128, '\p{^Numeric_Value=7.5e-01}', "");
    Expect(1, 126128, '\P{Numeric_Value=7.5e-01}', "");
    Expect(0, 126128, '\P{^Numeric_Value=7.5e-01}', "");
    Expect(1, 126127, '\p{Numeric_Value=7.50e-01}', "");
    Expect(0, 126127, '\p{^Numeric_Value=7.50e-01}', "");
    Expect(0, 126127, '\P{Numeric_Value=7.50e-01}', "");
    Expect(1, 126127, '\P{^Numeric_Value=7.50e-01}', "");
    Expect(0, 126128, '\p{Numeric_Value=7.50e-01}', "");
    Expect(1, 126128, '\p{^Numeric_Value=7.50e-01}', "");
    Expect(1, 126128, '\P{Numeric_Value=7.50e-01}', "");
    Expect(0, 126128, '\P{^Numeric_Value=7.50e-01}', "");
    Expect(1, 126127, '\p{Numeric_Value=0.75}', "");
    Expect(0, 126127, '\p{^Numeric_Value=0.75}', "");
    Expect(0, 126127, '\P{Numeric_Value=0.75}', "");
    Expect(1, 126127, '\P{^Numeric_Value=0.75}', "");
    Expect(0, 126128, '\p{Numeric_Value=0.75}', "");
    Expect(1, 126128, '\p{^Numeric_Value=0.75}', "");
    Expect(1, 126128, '\P{Numeric_Value=0.75}', "");
    Expect(0, 126128, '\P{^Numeric_Value=0.75}', "");
    Expect(1, 126127, '\p{Numeric_Value=7.500e-01}', "");
    Expect(0, 126127, '\p{^Numeric_Value=7.500e-01}', "");
    Expect(0, 126127, '\P{Numeric_Value=7.500e-01}', "");
    Expect(1, 126127, '\P{^Numeric_Value=7.500e-01}', "");
    Expect(0, 126128, '\p{Numeric_Value=7.500e-01}', "");
    Expect(1, 126128, '\p{^Numeric_Value=7.500e-01}', "");
    Expect(1, 126128, '\P{Numeric_Value=7.500e-01}', "");
    Expect(0, 126128, '\P{^Numeric_Value=7.500e-01}', "");
    Expect(1, 126127, '\p{Numeric_Value=0.750}', "");
    Expect(0, 126127, '\p{^Numeric_Value=0.750}', "");
    Expect(0, 126127, '\P{Numeric_Value=0.750}', "");
    Expect(1, 126127, '\P{^Numeric_Value=0.750}', "");
    Expect(0, 126128, '\p{Numeric_Value=0.750}', "");
    Expect(1, 126128, '\p{^Numeric_Value=0.750}', "");
    Expect(1, 126128, '\P{Numeric_Value=0.750}', "");
    Expect(0, 126128, '\P{^Numeric_Value=0.750}', "");
    Error('\p{Nv:   /a/	03/000004}');
    Error('\P{Nv:   /a/	03/000004}');
    Expect(1, 126127, '\p{Nv=:\A3/4\z:}', "");;
    Expect(0, 126128, '\p{Nv=:\A3/4\z:}', "");;
    Expect(1, 126127, '\p{Nv=03/0000004}', "");
    Expect(0, 126127, '\p{^Nv=03/0000004}', "");
    Expect(0, 126127, '\P{Nv=03/0000004}', "");
    Expect(1, 126127, '\P{^Nv=03/0000004}', "");
    Expect(0, 126128, '\p{Nv=03/0000004}', "");
    Expect(1, 126128, '\p{^Nv=03/0000004}', "");
    Expect(1, 126128, '\P{Nv=03/0000004}', "");
    Expect(0, 126128, '\P{^Nv=03/0000004}', "");
    Expect(1, 126127, '\p{Nv=180/240}', "");
    Expect(0, 126127, '\p{^Nv=180/240}', "");
    Expect(0, 126127, '\P{Nv=180/240}', "");
    Expect(1, 126127, '\P{^Nv=180/240}', "");
    Expect(0, 126128, '\p{Nv=180/240}', "");
    Expect(1, 126128, '\p{^Nv=180/240}', "");
    Expect(1, 126128, '\P{Nv=180/240}', "");
    Expect(0, 126128, '\P{^Nv=180/240}', "");
    Expect(1, 126127, '\p{Nv:	7.5e-01}', "");
    Expect(0, 126127, '\p{^Nv:	7.5e-01}', "");
    Expect(0, 126127, '\P{Nv:	7.5e-01}', "");
    Expect(1, 126127, '\P{^Nv:	7.5e-01}', "");
    Expect(0, 126128, '\p{Nv:	7.5e-01}', "");
    Expect(1, 126128, '\p{^Nv:	7.5e-01}', "");
    Expect(1, 126128, '\P{Nv:	7.5e-01}', "");
    Expect(0, 126128, '\P{^Nv:	7.5e-01}', "");
    Expect(1, 126127, '\p{Nv=7.50e-01}', "");
    Expect(0, 126127, '\p{^Nv=7.50e-01}', "");
    Expect(0, 126127, '\P{Nv=7.50e-01}', "");
    Expect(1, 126127, '\P{^Nv=7.50e-01}', "");
    Expect(0, 126128, '\p{Nv=7.50e-01}', "");
    Expect(1, 126128, '\p{^Nv=7.50e-01}', "");
    Expect(1, 126128, '\P{Nv=7.50e-01}', "");
    Expect(0, 126128, '\P{^Nv=7.50e-01}', "");
    Expect(1, 126127, '\p{Nv=0.75}', "");
    Expect(0, 126127, '\p{^Nv=0.75}', "");
    Expect(0, 126127, '\P{Nv=0.75}', "");
    Expect(1, 126127, '\P{^Nv=0.75}', "");
    Expect(0, 126128, '\p{Nv=0.75}', "");
    Expect(1, 126128, '\p{^Nv=0.75}', "");
    Expect(1, 126128, '\P{Nv=0.75}', "");
    Expect(0, 126128, '\P{^Nv=0.75}', "");
    Expect(1, 126127, '\p{Nv=7.500e-01}', "");
    Expect(0, 126127, '\p{^Nv=7.500e-01}', "");
    Expect(0, 126127, '\P{Nv=7.500e-01}', "");
    Expect(1, 126127, '\P{^Nv=7.500e-01}', "");
    Expect(0, 126128, '\p{Nv=7.500e-01}', "");
    Expect(1, 126128, '\p{^Nv=7.500e-01}', "");
    Expect(1, 126128, '\P{Nv=7.500e-01}', "");
    Expect(0, 126128, '\P{^Nv=7.500e-01}', "");
    Expect(1, 126127, '\p{Nv=0.750}', "");
    Expect(0, 126127, '\p{^Nv=0.750}', "");
    Expect(0, 126127, '\P{Nv=0.750}', "");
    Expect(1, 126127, '\P{^Nv=0.750}', "");
    Expect(0, 126128, '\p{Nv=0.750}', "");
    Expect(1, 126128, '\p{^Nv=0.750}', "");
    Expect(1, 126128, '\P{Nv=0.750}', "");
    Expect(0, 126128, '\P{^Nv=0.750}', "");
    Error('\p{Is_Numeric_Value=- +03/000004:=}');
    Error('\P{Is_Numeric_Value=- +03/000004:=}');
    Expect(1, 126127, '\p{Is_Numeric_Value=+00000003/00000004}', "");
    Expect(0, 126127, '\p{^Is_Numeric_Value=+00000003/00000004}', "");
    Expect(0, 126127, '\P{Is_Numeric_Value=+00000003/00000004}', "");
    Expect(1, 126127, '\P{^Is_Numeric_Value=+00000003/00000004}', "");
    Expect(0, 126128, '\p{Is_Numeric_Value=+00000003/00000004}', "");
    Expect(1, 126128, '\p{^Is_Numeric_Value=+00000003/00000004}', "");
    Expect(1, 126128, '\P{Is_Numeric_Value=+00000003/00000004}', "");
    Expect(0, 126128, '\P{^Is_Numeric_Value=+00000003/00000004}', "");
    Expect(1, 126127, '\p{Is_Numeric_Value=180/240}', "");
    Expect(0, 126127, '\p{^Is_Numeric_Value=180/240}', "");
    Expect(0, 126127, '\P{Is_Numeric_Value=180/240}', "");
    Expect(1, 126127, '\P{^Is_Numeric_Value=180/240}', "");
    Expect(0, 126128, '\p{Is_Numeric_Value=180/240}', "");
    Expect(1, 126128, '\p{^Is_Numeric_Value=180/240}', "");
    Expect(1, 126128, '\P{Is_Numeric_Value=180/240}', "");
    Expect(0, 126128, '\P{^Is_Numeric_Value=180/240}', "");
    Expect(1, 126127, '\p{Is_Numeric_Value=7.5e-01}', "");
    Expect(0, 126127, '\p{^Is_Numeric_Value=7.5e-01}', "");
    Expect(0, 126127, '\P{Is_Numeric_Value=7.5e-01}', "");
    Expect(1, 126127, '\P{^Is_Numeric_Value=7.5e-01}', "");
    Expect(0, 126128, '\p{Is_Numeric_Value=7.5e-01}', "");
    Expect(1, 126128, '\p{^Is_Numeric_Value=7.5e-01}', "");
    Expect(1, 126128, '\P{Is_Numeric_Value=7.5e-01}', "");
    Expect(0, 126128, '\P{^Is_Numeric_Value=7.5e-01}', "");
    Expect(1, 126127, '\p{Is_Numeric_Value=7.50e-01}', "");
    Expect(0, 126127, '\p{^Is_Numeric_Value=7.50e-01}', "");
    Expect(0, 126127, '\P{Is_Numeric_Value=7.50e-01}', "");
    Expect(1, 126127, '\P{^Is_Numeric_Value=7.50e-01}', "");
    Expect(0, 126128, '\p{Is_Numeric_Value=7.50e-01}', "");
    Expect(1, 126128, '\p{^Is_Numeric_Value=7.50e-01}', "");
    Expect(1, 126128, '\P{Is_Numeric_Value=7.50e-01}', "");
    Expect(0, 126128, '\P{^Is_Numeric_Value=7.50e-01}', "");
    Expect(1, 126127, '\p{Is_Numeric_Value=0.75}', "");
    Expect(0, 126127, '\p{^Is_Numeric_Value=0.75}', "");
    Expect(0, 126127, '\P{Is_Numeric_Value=0.75}', "");
    Expect(1, 126127, '\P{^Is_Numeric_Value=0.75}', "");
    Expect(0, 126128, '\p{Is_Numeric_Value=0.75}', "");
    Expect(1, 126128, '\p{^Is_Numeric_Value=0.75}', "");
    Expect(1, 126128, '\P{Is_Numeric_Value=0.75}', "");
    Expect(0, 126128, '\P{^Is_Numeric_Value=0.75}', "");
    Expect(1, 126127, '\p{Is_Numeric_Value=7.500e-01}', "");
    Expect(0, 126127, '\p{^Is_Numeric_Value=7.500e-01}', "");
    Expect(0, 126127, '\P{Is_Numeric_Value=7.500e-01}', "");
    Expect(1, 126127, '\P{^Is_Numeric_Value=7.500e-01}', "");
    Expect(0, 126128, '\p{Is_Numeric_Value=7.500e-01}', "");
    Expect(1, 126128, '\p{^Is_Numeric_Value=7.500e-01}', "");
    Expect(1, 126128, '\P{Is_Numeric_Value=7.500e-01}', "");
    Expect(0, 126128, '\P{^Is_Numeric_Value=7.500e-01}', "");
    Expect(1, 126127, '\p{Is_Numeric_Value=0.750}', "");
    Expect(0, 126127, '\p{^Is_Numeric_Value=0.750}', "");
    Expect(0, 126127, '\P{Is_Numeric_Value=0.750}', "");
    Expect(1, 126127, '\P{^Is_Numeric_Value=0.750}', "");
    Expect(0, 126128, '\p{Is_Numeric_Value=0.750}', "");
    Expect(1, 126128, '\p{^Is_Numeric_Value=0.750}', "");
    Expect(1, 126128, '\P{Is_Numeric_Value=0.750}', "");
    Expect(0, 126128, '\P{^Is_Numeric_Value=0.750}', "");
    Error('\p{Is_Nv=_ +0000000003/000000004:=}');
    Error('\P{Is_Nv=_ +0000000003/000000004:=}');
    Expect(1, 126127, '\p{Is_Nv=00000003/00000004}', "");
    Expect(0, 126127, '\p{^Is_Nv=00000003/00000004}', "");
    Expect(0, 126127, '\P{Is_Nv=00000003/00000004}', "");
    Expect(1, 126127, '\P{^Is_Nv=00000003/00000004}', "");
    Expect(0, 126128, '\p{Is_Nv=00000003/00000004}', "");
    Expect(1, 126128, '\p{^Is_Nv=00000003/00000004}', "");
    Expect(1, 126128, '\P{Is_Nv=00000003/00000004}', "");
    Expect(0, 126128, '\P{^Is_Nv=00000003/00000004}', "");
    Expect(1, 126127, '\p{Is_Nv=180/240}', "");
    Expect(0, 126127, '\p{^Is_Nv=180/240}', "");
    Expect(0, 126127, '\P{Is_Nv=180/240}', "");
    Expect(1, 126127, '\P{^Is_Nv=180/240}', "");
    Expect(0, 126128, '\p{Is_Nv=180/240}', "");
    Expect(1, 126128, '\p{^Is_Nv=180/240}', "");
    Expect(1, 126128, '\P{Is_Nv=180/240}', "");
    Expect(0, 126128, '\P{^Is_Nv=180/240}', "");
    Expect(1, 126127, '\p{Is_Nv=7.5e-01}', "");
    Expect(0, 126127, '\p{^Is_Nv=7.5e-01}', "");
    Expect(0, 126127, '\P{Is_Nv=7.5e-01}', "");
    Expect(1, 126127, '\P{^Is_Nv=7.5e-01}', "");
    Expect(0, 126128, '\p{Is_Nv=7.5e-01}', "");
    Expect(1, 126128, '\p{^Is_Nv=7.5e-01}', "");
    Expect(1, 126128, '\P{Is_Nv=7.5e-01}', "");
    Expect(0, 126128, '\P{^Is_Nv=7.5e-01}', "");
    Expect(1, 126127, '\p{Is_Nv=7.50e-01}', "");
    Expect(0, 126127, '\p{^Is_Nv=7.50e-01}', "");
    Expect(0, 126127, '\P{Is_Nv=7.50e-01}', "");
    Expect(1, 126127, '\P{^Is_Nv=7.50e-01}', "");
    Expect(0, 126128, '\p{Is_Nv=7.50e-01}', "");
    Expect(1, 126128, '\p{^Is_Nv=7.50e-01}', "");
    Expect(1, 126128, '\P{Is_Nv=7.50e-01}', "");
    Expect(0, 126128, '\P{^Is_Nv=7.50e-01}', "");
    Expect(1, 126127, '\p{Is_Nv=0.75}', "");
    Expect(0, 126127, '\p{^Is_Nv=0.75}', "");
    Expect(0, 126127, '\P{Is_Nv=0.75}', "");
    Expect(1, 126127, '\P{^Is_Nv=0.75}', "");
    Expect(0, 126128, '\p{Is_Nv=0.75}', "");
    Expect(1, 126128, '\p{^Is_Nv=0.75}', "");
    Expect(1, 126128, '\P{Is_Nv=0.75}', "");
    Expect(0, 126128, '\P{^Is_Nv=0.75}', "");
    Expect(1, 126127, '\p{Is_Nv=7.500e-01}', "");
    Expect(0, 126127, '\p{^Is_Nv=7.500e-01}', "");
    Expect(0, 126127, '\P{Is_Nv=7.500e-01}', "");
    Expect(1, 126127, '\P{^Is_Nv=7.500e-01}', "");
    Expect(0, 126128, '\p{Is_Nv=7.500e-01}', "");
    Expect(1, 126128, '\p{^Is_Nv=7.500e-01}', "");
    Expect(1, 126128, '\P{Is_Nv=7.500e-01}', "");
    Expect(0, 126128, '\P{^Is_Nv=7.500e-01}', "");
    Expect(1, 126127, '\p{Is_Nv:	0.750}', "");
    Expect(0, 126127, '\p{^Is_Nv:	0.750}', "");
    Expect(0, 126127, '\P{Is_Nv:	0.750}', "");
    Expect(1, 126127, '\P{^Is_Nv:	0.750}', "");
    Expect(0, 126128, '\p{Is_Nv:	0.750}', "");
    Expect(1, 126128, '\p{^Is_Nv:	0.750}', "");
    Expect(1, 126128, '\P{Is_Nv:	0.750}', "");
    Expect(0, 126128, '\P{^Is_Nv:	0.750}', "");
    Error('\p{Numeric_Value=/a/_3/0005}');
    Error('\P{Numeric_Value=/a/_3/0005}');
    Expect(1, 8535, '\p{Numeric_Value=:\A3/5\z:}', "");;
    Expect(0, 8536, '\p{Numeric_Value=:\A3/5\z:}', "");;
    Expect(1, 8535, '\p{Numeric_Value=003/00005}', "");
    Expect(0, 8535, '\p{^Numeric_Value=003/00005}', "");
    Expect(0, 8535, '\P{Numeric_Value=003/00005}', "");
    Expect(1, 8535, '\P{^Numeric_Value=003/00005}', "");
    Expect(0, 8536, '\p{Numeric_Value=003/00005}', "");
    Expect(1, 8536, '\p{^Numeric_Value=003/00005}', "");
    Expect(1, 8536, '\P{Numeric_Value=003/00005}', "");
    Expect(0, 8536, '\P{^Numeric_Value=003/00005}', "");
    Expect(1, 8535, '\p{Numeric_Value=180/300}', "");
    Expect(0, 8535, '\p{^Numeric_Value=180/300}', "");
    Expect(0, 8535, '\P{Numeric_Value=180/300}', "");
    Expect(1, 8535, '\P{^Numeric_Value=180/300}', "");
    Expect(0, 8536, '\p{Numeric_Value=180/300}', "");
    Expect(1, 8536, '\p{^Numeric_Value=180/300}', "");
    Expect(1, 8536, '\P{Numeric_Value=180/300}', "");
    Expect(0, 8536, '\P{^Numeric_Value=180/300}', "");
    Expect(1, 8535, '\p{Numeric_Value=6.0e-01}', "");
    Expect(0, 8535, '\p{^Numeric_Value=6.0e-01}', "");
    Expect(0, 8535, '\P{Numeric_Value=6.0e-01}', "");
    Expect(1, 8535, '\P{^Numeric_Value=6.0e-01}', "");
    Expect(0, 8536, '\p{Numeric_Value=6.0e-01}', "");
    Expect(1, 8536, '\p{^Numeric_Value=6.0e-01}', "");
    Expect(1, 8536, '\P{Numeric_Value=6.0e-01}', "");
    Expect(0, 8536, '\P{^Numeric_Value=6.0e-01}', "");
    Expect(1, 8535, '\p{Numeric_Value:0.6}', "");
    Expect(0, 8535, '\p{^Numeric_Value:0.6}', "");
    Expect(0, 8535, '\P{Numeric_Value:0.6}', "");
    Expect(1, 8535, '\P{^Numeric_Value:0.6}', "");
    Expect(0, 8536, '\p{Numeric_Value:0.6}', "");
    Expect(1, 8536, '\p{^Numeric_Value:0.6}', "");
    Expect(1, 8536, '\P{Numeric_Value:0.6}', "");
    Expect(0, 8536, '\P{^Numeric_Value:0.6}', "");
    Expect(1, 8535, '\p{Numeric_Value=6.00e-01}', "");
    Expect(0, 8535, '\p{^Numeric_Value=6.00e-01}', "");
    Expect(0, 8535, '\P{Numeric_Value=6.00e-01}', "");
    Expect(1, 8535, '\P{^Numeric_Value=6.00e-01}', "");
    Expect(0, 8536, '\p{Numeric_Value=6.00e-01}', "");
    Expect(1, 8536, '\p{^Numeric_Value=6.00e-01}', "");
    Expect(1, 8536, '\P{Numeric_Value=6.00e-01}', "");
    Expect(0, 8536, '\P{^Numeric_Value=6.00e-01}', "");
    Expect(1, 8535, '\p{Numeric_Value=0.60}', "");
    Expect(0, 8535, '\p{^Numeric_Value=0.60}', "");
    Expect(0, 8535, '\P{Numeric_Value=0.60}', "");
    Expect(1, 8535, '\P{^Numeric_Value=0.60}', "");
    Expect(0, 8536, '\p{Numeric_Value=0.60}', "");
    Expect(1, 8536, '\p{^Numeric_Value=0.60}', "");
    Expect(1, 8536, '\P{Numeric_Value=0.60}', "");
    Expect(0, 8536, '\P{^Numeric_Value=0.60}', "");
    Error('\p{Nv=  0000000003/000000005:=}');
    Error('\P{Nv=  0000000003/000000005:=}');
    Expect(1, 8535, '\p{Nv=:\A3/5\z:}', "");;
    Expect(0, 8536, '\p{Nv=:\A3/5\z:}', "");;
    Expect(1, 8535, '\p{Nv=+00003/0000000005}', "");
    Expect(0, 8535, '\p{^Nv=+00003/0000000005}', "");
    Expect(0, 8535, '\P{Nv=+00003/0000000005}', "");
    Expect(1, 8535, '\P{^Nv=+00003/0000000005}', "");
    Expect(0, 8536, '\p{Nv=+00003/0000000005}', "");
    Expect(1, 8536, '\p{^Nv=+00003/0000000005}', "");
    Expect(1, 8536, '\P{Nv=+00003/0000000005}', "");
    Expect(0, 8536, '\P{^Nv=+00003/0000000005}', "");
    Expect(1, 8535, '\p{Nv:	180/300}', "");
    Expect(0, 8535, '\p{^Nv:	180/300}', "");
    Expect(0, 8535, '\P{Nv:	180/300}', "");
    Expect(1, 8535, '\P{^Nv:	180/300}', "");
    Expect(0, 8536, '\p{Nv:	180/300}', "");
    Expect(1, 8536, '\p{^Nv:	180/300}', "");
    Expect(1, 8536, '\P{Nv:	180/300}', "");
    Expect(0, 8536, '\P{^Nv:	180/300}', "");
    Expect(1, 8535, '\p{Nv:6.0e-01}', "");
    Expect(0, 8535, '\p{^Nv:6.0e-01}', "");
    Expect(0, 8535, '\P{Nv:6.0e-01}', "");
    Expect(1, 8535, '\P{^Nv:6.0e-01}', "");
    Expect(0, 8536, '\p{Nv:6.0e-01}', "");
    Expect(1, 8536, '\p{^Nv:6.0e-01}', "");
    Expect(1, 8536, '\P{Nv:6.0e-01}', "");
    Expect(0, 8536, '\P{^Nv:6.0e-01}', "");
    Expect(1, 8535, '\p{Nv=0.6}', "");
    Expect(0, 8535, '\p{^Nv=0.6}', "");
    Expect(0, 8535, '\P{Nv=0.6}', "");
    Expect(1, 8535, '\P{^Nv=0.6}', "");
    Expect(0, 8536, '\p{Nv=0.6}', "");
    Expect(1, 8536, '\p{^Nv=0.6}', "");
    Expect(1, 8536, '\P{Nv=0.6}', "");
    Expect(0, 8536, '\P{^Nv=0.6}', "");
    Expect(1, 8535, '\p{Nv=6.00e-01}', "");
    Expect(0, 8535, '\p{^Nv=6.00e-01}', "");
    Expect(0, 8535, '\P{Nv=6.00e-01}', "");
    Expect(1, 8535, '\P{^Nv=6.00e-01}', "");
    Expect(0, 8536, '\p{Nv=6.00e-01}', "");
    Expect(1, 8536, '\p{^Nv=6.00e-01}', "");
    Expect(1, 8536, '\P{Nv=6.00e-01}', "");
    Expect(0, 8536, '\P{^Nv=6.00e-01}', "");
    Expect(1, 8535, '\p{Nv=0.60}', "");
    Expect(0, 8535, '\p{^Nv=0.60}', "");
    Expect(0, 8535, '\P{Nv=0.60}', "");
    Expect(1, 8535, '\P{^Nv=0.60}', "");
    Expect(0, 8536, '\p{Nv=0.60}', "");
    Expect(1, 8536, '\p{^Nv=0.60}', "");
    Expect(1, 8536, '\P{Nv=0.60}', "");
    Expect(0, 8536, '\P{^Nv=0.60}', "");
    Error('\p{Is_Numeric_Value=/a/--+0000003/00005}');
    Error('\P{Is_Numeric_Value=/a/--+0000003/00005}');
    Expect(1, 8535, '\p{Is_Numeric_Value=+03/5}', "");
    Expect(0, 8535, '\p{^Is_Numeric_Value=+03/5}', "");
    Expect(0, 8535, '\P{Is_Numeric_Value=+03/5}', "");
    Expect(1, 8535, '\P{^Is_Numeric_Value=+03/5}', "");
    Expect(0, 8536, '\p{Is_Numeric_Value=+03/5}', "");
    Expect(1, 8536, '\p{^Is_Numeric_Value=+03/5}', "");
    Expect(1, 8536, '\P{Is_Numeric_Value=+03/5}', "");
    Expect(0, 8536, '\P{^Is_Numeric_Value=+03/5}', "");
    Expect(1, 8535, '\p{Is_Numeric_Value=180/300}', "");
    Expect(0, 8535, '\p{^Is_Numeric_Value=180/300}', "");
    Expect(0, 8535, '\P{Is_Numeric_Value=180/300}', "");
    Expect(1, 8535, '\P{^Is_Numeric_Value=180/300}', "");
    Expect(0, 8536, '\p{Is_Numeric_Value=180/300}', "");
    Expect(1, 8536, '\p{^Is_Numeric_Value=180/300}', "");
    Expect(1, 8536, '\P{Is_Numeric_Value=180/300}', "");
    Expect(0, 8536, '\P{^Is_Numeric_Value=180/300}', "");
    Expect(1, 8535, '\p{Is_Numeric_Value=6.0e-01}', "");
    Expect(0, 8535, '\p{^Is_Numeric_Value=6.0e-01}', "");
    Expect(0, 8535, '\P{Is_Numeric_Value=6.0e-01}', "");
    Expect(1, 8535, '\P{^Is_Numeric_Value=6.0e-01}', "");
    Expect(0, 8536, '\p{Is_Numeric_Value=6.0e-01}', "");
    Expect(1, 8536, '\p{^Is_Numeric_Value=6.0e-01}', "");
    Expect(1, 8536, '\P{Is_Numeric_Value=6.0e-01}', "");
    Expect(0, 8536, '\P{^Is_Numeric_Value=6.0e-01}', "");
    Expect(1, 8535, '\p{Is_Numeric_Value=0.6}', "");
    Expect(0, 8535, '\p{^Is_Numeric_Value=0.6}', "");
    Expect(0, 8535, '\P{Is_Numeric_Value=0.6}', "");
    Expect(1, 8535, '\P{^Is_Numeric_Value=0.6}', "");
    Expect(0, 8536, '\p{Is_Numeric_Value=0.6}', "");
    Expect(1, 8536, '\p{^Is_Numeric_Value=0.6}', "");
    Expect(1, 8536, '\P{Is_Numeric_Value=0.6}', "");
    Expect(0, 8536, '\P{^Is_Numeric_Value=0.6}', "");
    Expect(1, 8535, '\p{Is_Numeric_Value=6.00e-01}', "");
    Expect(0, 8535, '\p{^Is_Numeric_Value=6.00e-01}', "");
    Expect(0, 8535, '\P{Is_Numeric_Value=6.00e-01}', "");
    Expect(1, 8535, '\P{^Is_Numeric_Value=6.00e-01}', "");
    Expect(0, 8536, '\p{Is_Numeric_Value=6.00e-01}', "");
    Expect(1, 8536, '\p{^Is_Numeric_Value=6.00e-01}', "");
    Expect(1, 8536, '\P{Is_Numeric_Value=6.00e-01}', "");
    Expect(0, 8536, '\P{^Is_Numeric_Value=6.00e-01}', "");
    Expect(1, 8535, '\p{Is_Numeric_Value=0.60}', "");
    Expect(0, 8535, '\p{^Is_Numeric_Value=0.60}', "");
    Expect(0, 8535, '\P{Is_Numeric_Value=0.60}', "");
    Expect(1, 8535, '\P{^Is_Numeric_Value=0.60}', "");
    Expect(0, 8536, '\p{Is_Numeric_Value=0.60}', "");
    Expect(1, 8536, '\p{^Is_Numeric_Value=0.60}', "");
    Expect(1, 8536, '\P{Is_Numeric_Value=0.60}', "");
    Expect(0, 8536, '\P{^Is_Numeric_Value=0.60}', "");
    Error('\p{Is_Nv: :=_-0000000003/00005}');
    Error('\P{Is_Nv: :=_-0000000003/00005}');
    Expect(1, 8535, '\p{Is_Nv=+003/00005}', "");
    Expect(0, 8535, '\p{^Is_Nv=+003/00005}', "");
    Expect(0, 8535, '\P{Is_Nv=+003/00005}', "");
    Expect(1, 8535, '\P{^Is_Nv=+003/00005}', "");
    Expect(0, 8536, '\p{Is_Nv=+003/00005}', "");
    Expect(1, 8536, '\p{^Is_Nv=+003/00005}', "");
    Expect(1, 8536, '\P{Is_Nv=+003/00005}', "");
    Expect(0, 8536, '\P{^Is_Nv=+003/00005}', "");
    Expect(1, 8535, '\p{Is_Nv=180/300}', "");
    Expect(0, 8535, '\p{^Is_Nv=180/300}', "");
    Expect(0, 8535, '\P{Is_Nv=180/300}', "");
    Expect(1, 8535, '\P{^Is_Nv=180/300}', "");
    Expect(0, 8536, '\p{Is_Nv=180/300}', "");
    Expect(1, 8536, '\p{^Is_Nv=180/300}', "");
    Expect(1, 8536, '\P{Is_Nv=180/300}', "");
    Expect(0, 8536, '\P{^Is_Nv=180/300}', "");
    Expect(1, 8535, '\p{Is_Nv=6.0e-01}', "");
    Expect(0, 8535, '\p{^Is_Nv=6.0e-01}', "");
    Expect(0, 8535, '\P{Is_Nv=6.0e-01}', "");
    Expect(1, 8535, '\P{^Is_Nv=6.0e-01}', "");
    Expect(0, 8536, '\p{Is_Nv=6.0e-01}', "");
    Expect(1, 8536, '\p{^Is_Nv=6.0e-01}', "");
    Expect(1, 8536, '\P{Is_Nv=6.0e-01}', "");
    Expect(0, 8536, '\P{^Is_Nv=6.0e-01}', "");
    Expect(1, 8535, '\p{Is_Nv=0.6}', "");
    Expect(0, 8535, '\p{^Is_Nv=0.6}', "");
    Expect(0, 8535, '\P{Is_Nv=0.6}', "");
    Expect(1, 8535, '\P{^Is_Nv=0.6}', "");
    Expect(0, 8536, '\p{Is_Nv=0.6}', "");
    Expect(1, 8536, '\p{^Is_Nv=0.6}', "");
    Expect(1, 8536, '\P{Is_Nv=0.6}', "");
    Expect(0, 8536, '\P{^Is_Nv=0.6}', "");
    Expect(1, 8535, '\p{Is_Nv: 6.00e-01}', "");
    Expect(0, 8535, '\p{^Is_Nv: 6.00e-01}', "");
    Expect(0, 8535, '\P{Is_Nv: 6.00e-01}', "");
    Expect(1, 8535, '\P{^Is_Nv: 6.00e-01}', "");
    Expect(0, 8536, '\p{Is_Nv: 6.00e-01}', "");
    Expect(1, 8536, '\p{^Is_Nv: 6.00e-01}', "");
    Expect(1, 8536, '\P{Is_Nv: 6.00e-01}', "");
    Expect(0, 8536, '\P{^Is_Nv: 6.00e-01}', "");
    Expect(1, 8535, '\p{Is_Nv=0.60}', "");
    Expect(0, 8535, '\p{^Is_Nv=0.60}', "");
    Expect(0, 8535, '\P{Is_Nv=0.60}', "");
    Expect(1, 8535, '\P{^Is_Nv=0.60}', "");
    Expect(0, 8536, '\p{Is_Nv=0.60}', "");
    Expect(1, 8536, '\p{^Is_Nv=0.60}', "");
    Expect(1, 8536, '\P{Is_Nv=0.60}', "");
    Expect(0, 8536, '\P{^Is_Nv=0.60}', "");
    Error('\p{Numeric_Value= /a/3/0000064}');
    Error('\P{Numeric_Value= /a/3/0000064}');
    Expect(1, 73671, '\p{Numeric_Value=:\A3/64\z:}', "");;
    Expect(0, 73672, '\p{Numeric_Value=:\A3/64\z:}', "");;
    Expect(1, 73671, '\p{Numeric_Value=03/00000064}', "");
    Expect(0, 73671, '\p{^Numeric_Value=03/00000064}', "");
    Expect(0, 73671, '\P{Numeric_Value=03/00000064}', "");
    Expect(1, 73671, '\P{^Numeric_Value=03/00000064}', "");
    Expect(0, 73672, '\p{Numeric_Value=03/00000064}', "");
    Expect(1, 73672, '\p{^Numeric_Value=03/00000064}', "");
    Expect(1, 73672, '\P{Numeric_Value=03/00000064}', "");
    Expect(0, 73672, '\P{^Numeric_Value=03/00000064}', "");
    Expect(1, 73671, '\p{Numeric_Value:	180/3840}', "");
    Expect(0, 73671, '\p{^Numeric_Value:	180/3840}', "");
    Expect(0, 73671, '\P{Numeric_Value:	180/3840}', "");
    Expect(1, 73671, '\P{^Numeric_Value:	180/3840}', "");
    Expect(0, 73672, '\p{Numeric_Value:	180/3840}', "");
    Expect(1, 73672, '\p{^Numeric_Value:	180/3840}', "");
    Expect(1, 73672, '\P{Numeric_Value:	180/3840}', "");
    Expect(0, 73672, '\P{^Numeric_Value:	180/3840}', "");
    Error('\p{Numeric_Value=4.7e-02}');
    Error('\P{Numeric_Value=4.7e-02}');
    Error('\p{Numeric_Value=4.69e-02}');
    Error('\P{Numeric_Value=4.69e-02}');
    Expect(1, 73671, '\p{Numeric_Value=4.688e-02}', "");
    Expect(0, 73671, '\p{^Numeric_Value=4.688e-02}', "");
    Expect(0, 73671, '\P{Numeric_Value=4.688e-02}', "");
    Expect(1, 73671, '\P{^Numeric_Value=4.688e-02}', "");
    Expect(0, 73672, '\p{Numeric_Value=4.688e-02}', "");
    Expect(1, 73672, '\p{^Numeric_Value=4.688e-02}', "");
    Expect(1, 73672, '\P{Numeric_Value=4.688e-02}', "");
    Expect(0, 73672, '\P{^Numeric_Value=4.688e-02}', "");
    Error('\p{Numeric_Value=0.047}');
    Error('\P{Numeric_Value=0.047}');
    Expect(1, 73671, '\p{Numeric_Value=4.6875e-02}', "");
    Expect(0, 73671, '\p{^Numeric_Value=4.6875e-02}', "");
    Expect(0, 73671, '\P{Numeric_Value=4.6875e-02}', "");
    Expect(1, 73671, '\P{^Numeric_Value=4.6875e-02}', "");
    Expect(0, 73672, '\p{Numeric_Value=4.6875e-02}', "");
    Expect(1, 73672, '\p{^Numeric_Value=4.6875e-02}', "");
    Expect(1, 73672, '\P{Numeric_Value=4.6875e-02}', "");
    Expect(0, 73672, '\P{^Numeric_Value=4.6875e-02}', "");
    Error('\p{Numeric_Value=0.0469}');
    Error('\P{Numeric_Value=0.0469}');
    Expect(1, 73671, '\p{Numeric_Value=4.68750e-02}', "");
    Expect(0, 73671, '\p{^Numeric_Value=4.68750e-02}', "");
    Expect(0, 73671, '\P{Numeric_Value=4.68750e-02}', "");
    Expect(1, 73671, '\P{^Numeric_Value=4.68750e-02}', "");
    Expect(0, 73672, '\p{Numeric_Value=4.68750e-02}', "");
    Expect(1, 73672, '\p{^Numeric_Value=4.68750e-02}', "");
    Expect(1, 73672, '\P{Numeric_Value=4.68750e-02}', "");
    Expect(0, 73672, '\P{^Numeric_Value=4.68750e-02}', "");
    Expect(1, 73671, '\p{Numeric_Value:	0.04688}', "");
    Expect(0, 73671, '\p{^Numeric_Value:	0.04688}', "");
    Expect(0, 73671, '\P{Numeric_Value:	0.04688}', "");
    Expect(1, 73671, '\P{^Numeric_Value:	0.04688}', "");
    Expect(0, 73672, '\p{Numeric_Value:	0.04688}', "");
    Expect(1, 73672, '\p{^Numeric_Value:	0.04688}', "");
    Expect(1, 73672, '\P{Numeric_Value:	0.04688}', "");
    Expect(0, 73672, '\P{^Numeric_Value:	0.04688}', "");
    Expect(1, 73671, '\p{Numeric_Value=4.687500e-02}', "");
    Expect(0, 73671, '\p{^Numeric_Value=4.687500e-02}', "");
    Expect(0, 73671, '\P{Numeric_Value=4.687500e-02}', "");
    Expect(1, 73671, '\P{^Numeric_Value=4.687500e-02}', "");
    Expect(0, 73672, '\p{Numeric_Value=4.687500e-02}', "");
    Expect(1, 73672, '\p{^Numeric_Value=4.687500e-02}', "");
    Expect(1, 73672, '\P{Numeric_Value=4.687500e-02}', "");
    Expect(0, 73672, '\P{^Numeric_Value=4.687500e-02}', "");
    Expect(1, 73671, '\p{Numeric_Value:0.046875}', "");
    Expect(0, 73671, '\p{^Numeric_Value:0.046875}', "");
    Expect(0, 73671, '\P{Numeric_Value:0.046875}', "");
    Expect(1, 73671, '\P{^Numeric_Value:0.046875}', "");
    Expect(0, 73672, '\p{Numeric_Value:0.046875}', "");
    Expect(1, 73672, '\p{^Numeric_Value:0.046875}', "");
    Expect(1, 73672, '\P{Numeric_Value:0.046875}', "");
    Expect(0, 73672, '\P{^Numeric_Value:0.046875}', "");
    Error('\p{Nv=/a/+003/0000064}');
    Error('\P{Nv=/a/+003/0000064}');
    Expect(1, 73671, '\p{Nv=:\A3/64\z:}', "");;
    Expect(0, 73672, '\p{Nv=:\A3/64\z:}', "");;
    Expect(1, 73671, '\p{Nv=0003/00000064}', "");
    Expect(0, 73671, '\p{^Nv=0003/00000064}', "");
    Expect(0, 73671, '\P{Nv=0003/00000064}', "");
    Expect(1, 73671, '\P{^Nv=0003/00000064}', "");
    Expect(0, 73672, '\p{Nv=0003/00000064}', "");
    Expect(1, 73672, '\p{^Nv=0003/00000064}', "");
    Expect(1, 73672, '\P{Nv=0003/00000064}', "");
    Expect(0, 73672, '\P{^Nv=0003/00000064}', "");
    Expect(1, 73671, '\p{Nv=180/3840}', "");
    Expect(0, 73671, '\p{^Nv=180/3840}', "");
    Expect(0, 73671, '\P{Nv=180/3840}', "");
    Expect(1, 73671, '\P{^Nv=180/3840}', "");
    Expect(0, 73672, '\p{Nv=180/3840}', "");
    Expect(1, 73672, '\p{^Nv=180/3840}', "");
    Expect(1, 73672, '\P{Nv=180/3840}', "");
    Expect(0, 73672, '\P{^Nv=180/3840}', "");
    Error('\p{Nv=4.7e-02}');
    Error('\P{Nv=4.7e-02}');
    Error('\p{Nv=4.69e-02}');
    Error('\P{Nv=4.69e-02}');
    Expect(1, 73671, '\p{Nv=4.688e-02}', "");
    Expect(0, 73671, '\p{^Nv=4.688e-02}', "");
    Expect(0, 73671, '\P{Nv=4.688e-02}', "");
    Expect(1, 73671, '\P{^Nv=4.688e-02}', "");
    Expect(0, 73672, '\p{Nv=4.688e-02}', "");
    Expect(1, 73672, '\p{^Nv=4.688e-02}', "");
    Expect(1, 73672, '\P{Nv=4.688e-02}', "");
    Expect(0, 73672, '\P{^Nv=4.688e-02}', "");
    Error('\p{Nv=0.047}');
    Error('\P{Nv=0.047}');
    Expect(1, 73671, '\p{Nv=4.6875e-02}', "");
    Expect(0, 73671, '\p{^Nv=4.6875e-02}', "");
    Expect(0, 73671, '\P{Nv=4.6875e-02}', "");
    Expect(1, 73671, '\P{^Nv=4.6875e-02}', "");
    Expect(0, 73672, '\p{Nv=4.6875e-02}', "");
    Expect(1, 73672, '\p{^Nv=4.6875e-02}', "");
    Expect(1, 73672, '\P{Nv=4.6875e-02}', "");
    Expect(0, 73672, '\P{^Nv=4.6875e-02}', "");
    Error('\p{Nv=0.0469}');
    Error('\P{Nv=0.0469}');
    Expect(1, 73671, '\p{Nv=4.68750e-02}', "");
    Expect(0, 73671, '\p{^Nv=4.68750e-02}', "");
    Expect(0, 73671, '\P{Nv=4.68750e-02}', "");
    Expect(1, 73671, '\P{^Nv=4.68750e-02}', "");
    Expect(0, 73672, '\p{Nv=4.68750e-02}', "");
    Expect(1, 73672, '\p{^Nv=4.68750e-02}', "");
    Expect(1, 73672, '\P{Nv=4.68750e-02}', "");
    Expect(0, 73672, '\P{^Nv=4.68750e-02}', "");
    Expect(1, 73671, '\p{Nv=0.04688}', "");
    Expect(0, 73671, '\p{^Nv=0.04688}', "");
    Expect(0, 73671, '\P{Nv=0.04688}', "");
    Expect(1, 73671, '\P{^Nv=0.04688}', "");
    Expect(0, 73672, '\p{Nv=0.04688}', "");
    Expect(1, 73672, '\p{^Nv=0.04688}', "");
    Expect(1, 73672, '\P{Nv=0.04688}', "");
    Expect(0, 73672, '\P{^Nv=0.04688}', "");
    Expect(1, 73671, '\p{Nv=4.687500e-02}', "");
    Expect(0, 73671, '\p{^Nv=4.687500e-02}', "");
    Expect(0, 73671, '\P{Nv=4.687500e-02}', "");
    Expect(1, 73671, '\P{^Nv=4.687500e-02}', "");
    Expect(0, 73672, '\p{Nv=4.687500e-02}', "");
    Expect(1, 73672, '\p{^Nv=4.687500e-02}', "");
    Expect(1, 73672, '\P{Nv=4.687500e-02}', "");
    Expect(0, 73672, '\P{^Nv=4.687500e-02}', "");
    Expect(1, 73671, '\p{Nv=0.046875}', "");
    Expect(0, 73671, '\p{^Nv=0.046875}', "");
    Expect(0, 73671, '\P{Nv=0.046875}', "");
    Expect(1, 73671, '\P{^Nv=0.046875}', "");
    Expect(0, 73672, '\p{Nv=0.046875}', "");
    Expect(1, 73672, '\p{^Nv=0.046875}', "");
    Expect(1, 73672, '\P{Nv=0.046875}', "");
    Expect(0, 73672, '\P{^Nv=0.046875}', "");
    Error('\p{Is_Numeric_Value=	0000003/64/a/}');
    Error('\P{Is_Numeric_Value=	0000003/64/a/}');
    Expect(1, 73671, '\p{Is_Numeric_Value:	000003/00064}', "");
    Expect(0, 73671, '\p{^Is_Numeric_Value:	000003/00064}', "");
    Expect(0, 73671, '\P{Is_Numeric_Value:	000003/00064}', "");
    Expect(1, 73671, '\P{^Is_Numeric_Value:	000003/00064}', "");
    Expect(0, 73672, '\p{Is_Numeric_Value:	000003/00064}', "");
    Expect(1, 73672, '\p{^Is_Numeric_Value:	000003/00064}', "");
    Expect(1, 73672, '\P{Is_Numeric_Value:	000003/00064}', "");
    Expect(0, 73672, '\P{^Is_Numeric_Value:	000003/00064}', "");
    Expect(1, 73671, '\p{Is_Numeric_Value: 180/3840}', "");
    Expect(0, 73671, '\p{^Is_Numeric_Value: 180/3840}', "");
    Expect(0, 73671, '\P{Is_Numeric_Value: 180/3840}', "");
    Expect(1, 73671, '\P{^Is_Numeric_Value: 180/3840}', "");
    Expect(0, 73672, '\p{Is_Numeric_Value: 180/3840}', "");
    Expect(1, 73672, '\p{^Is_Numeric_Value: 180/3840}', "");
    Expect(1, 73672, '\P{Is_Numeric_Value: 180/3840}', "");
    Expect(0, 73672, '\P{^Is_Numeric_Value: 180/3840}', "");
    Error('\p{Is_Numeric_Value=4.7e-02}');
    Error('\P{Is_Numeric_Value=4.7e-02}');
    Error('\p{Is_Numeric_Value=4.69e-02}');
    Error('\P{Is_Numeric_Value=4.69e-02}');
    Expect(1, 73671, '\p{Is_Numeric_Value=4.688e-02}', "");
    Expect(0, 73671, '\p{^Is_Numeric_Value=4.688e-02}', "");
    Expect(0, 73671, '\P{Is_Numeric_Value=4.688e-02}', "");
    Expect(1, 73671, '\P{^Is_Numeric_Value=4.688e-02}', "");
    Expect(0, 73672, '\p{Is_Numeric_Value=4.688e-02}', "");
    Expect(1, 73672, '\p{^Is_Numeric_Value=4.688e-02}', "");
    Expect(1, 73672, '\P{Is_Numeric_Value=4.688e-02}', "");
    Expect(0, 73672, '\P{^Is_Numeric_Value=4.688e-02}', "");
    Error('\p{Is_Numeric_Value=0.047}');
    Error('\P{Is_Numeric_Value=0.047}');
    Expect(1, 73671, '\p{Is_Numeric_Value=4.6875e-02}', "");
    Expect(0, 73671, '\p{^Is_Numeric_Value=4.6875e-02}', "");
    Expect(0, 73671, '\P{Is_Numeric_Value=4.6875e-02}', "");
    Expect(1, 73671, '\P{^Is_Numeric_Value=4.6875e-02}', "");
    Expect(0, 73672, '\p{Is_Numeric_Value=4.6875e-02}', "");
    Expect(1, 73672, '\p{^Is_Numeric_Value=4.6875e-02}', "");
    Expect(1, 73672, '\P{Is_Numeric_Value=4.6875e-02}', "");
    Expect(0, 73672, '\P{^Is_Numeric_Value=4.6875e-02}', "");
    Error('\p{Is_Numeric_Value=0.0469}');
    Error('\P{Is_Numeric_Value=0.0469}');
    Expect(1, 73671, '\p{Is_Numeric_Value=4.68750e-02}', "");
    Expect(0, 73671, '\p{^Is_Numeric_Value=4.68750e-02}', "");
    Expect(0, 73671, '\P{Is_Numeric_Value=4.68750e-02}', "");
    Expect(1, 73671, '\P{^Is_Numeric_Value=4.68750e-02}', "");
    Expect(0, 73672, '\p{Is_Numeric_Value=4.68750e-02}', "");
    Expect(1, 73672, '\p{^Is_Numeric_Value=4.68750e-02}', "");
    Expect(1, 73672, '\P{Is_Numeric_Value=4.68750e-02}', "");
    Expect(0, 73672, '\P{^Is_Numeric_Value=4.68750e-02}', "");
    Expect(1, 73671, '\p{Is_Numeric_Value=0.04688}', "");
    Expect(0, 73671, '\p{^Is_Numeric_Value=0.04688}', "");
    Expect(0, 73671, '\P{Is_Numeric_Value=0.04688}', "");
    Expect(1, 73671, '\P{^Is_Numeric_Value=0.04688}', "");
    Expect(0, 73672, '\p{Is_Numeric_Value=0.04688}', "");
    Expect(1, 73672, '\p{^Is_Numeric_Value=0.04688}', "");
    Expect(1, 73672, '\P{Is_Numeric_Value=0.04688}', "");
    Expect(0, 73672, '\P{^Is_Numeric_Value=0.04688}', "");
    Expect(1, 73671, '\p{Is_Numeric_Value=4.687500e-02}', "");
    Expect(0, 73671, '\p{^Is_Numeric_Value=4.687500e-02}', "");
    Expect(0, 73671, '\P{Is_Numeric_Value=4.687500e-02}', "");
    Expect(1, 73671, '\P{^Is_Numeric_Value=4.687500e-02}', "");
    Expect(0, 73672, '\p{Is_Numeric_Value=4.687500e-02}', "");
    Expect(1, 73672, '\p{^Is_Numeric_Value=4.687500e-02}', "");
    Expect(1, 73672, '\P{Is_Numeric_Value=4.687500e-02}', "");
    Expect(0, 73672, '\P{^Is_Numeric_Value=4.687500e-02}', "");
    Expect(1, 73671, '\p{Is_Numeric_Value=0.046875}', "");
    Expect(0, 73671, '\p{^Is_Numeric_Value=0.046875}', "");
    Expect(0, 73671, '\P{Is_Numeric_Value=0.046875}', "");
    Expect(1, 73671, '\P{^Is_Numeric_Value=0.046875}', "");
    Expect(0, 73672, '\p{Is_Numeric_Value=0.046875}', "");
    Expect(1, 73672, '\p{^Is_Numeric_Value=0.046875}', "");
    Expect(1, 73672, '\P{Is_Numeric_Value=0.046875}', "");
    Expect(0, 73672, '\P{^Is_Numeric_Value=0.046875}', "");
    Error('\p{Is_Nv=/a/__00003/0000064}');
    Error('\P{Is_Nv=/a/__00003/0000064}');
    Expect(1, 73671, '\p{Is_Nv=+3/00064}', "");
    Expect(0, 73671, '\p{^Is_Nv=+3/00064}', "");
    Expect(0, 73671, '\P{Is_Nv=+3/00064}', "");
    Expect(1, 73671, '\P{^Is_Nv=+3/00064}', "");
    Expect(0, 73672, '\p{Is_Nv=+3/00064}', "");
    Expect(1, 73672, '\p{^Is_Nv=+3/00064}', "");
    Expect(1, 73672, '\P{Is_Nv=+3/00064}', "");
    Expect(0, 73672, '\P{^Is_Nv=+3/00064}', "");
    Expect(1, 73671, '\p{Is_Nv=180/3840}', "");
    Expect(0, 73671, '\p{^Is_Nv=180/3840}', "");
    Expect(0, 73671, '\P{Is_Nv=180/3840}', "");
    Expect(1, 73671, '\P{^Is_Nv=180/3840}', "");
    Expect(0, 73672, '\p{Is_Nv=180/3840}', "");
    Expect(1, 73672, '\p{^Is_Nv=180/3840}', "");
    Expect(1, 73672, '\P{Is_Nv=180/3840}', "");
    Expect(0, 73672, '\P{^Is_Nv=180/3840}', "");
    Error('\p{Is_Nv=4.7e-02}');
    Error('\P{Is_Nv=4.7e-02}');
    Error('\p{Is_Nv=4.69e-02}');
    Error('\P{Is_Nv=4.69e-02}');
    Expect(1, 73671, '\p{Is_Nv=4.688e-02}', "");
    Expect(0, 73671, '\p{^Is_Nv=4.688e-02}', "");
    Expect(0, 73671, '\P{Is_Nv=4.688e-02}', "");
    Expect(1, 73671, '\P{^Is_Nv=4.688e-02}', "");
    Expect(0, 73672, '\p{Is_Nv=4.688e-02}', "");
    Expect(1, 73672, '\p{^Is_Nv=4.688e-02}', "");
    Expect(1, 73672, '\P{Is_Nv=4.688e-02}', "");
    Expect(0, 73672, '\P{^Is_Nv=4.688e-02}', "");
    Error('\p{Is_Nv=0.047}');
    Error('\P{Is_Nv=0.047}');
    Expect(1, 73671, '\p{Is_Nv=4.6875e-02}', "");
    Expect(0, 73671, '\p{^Is_Nv=4.6875e-02}', "");
    Expect(0, 73671, '\P{Is_Nv=4.6875e-02}', "");
    Expect(1, 73671, '\P{^Is_Nv=4.6875e-02}', "");
    Expect(0, 73672, '\p{Is_Nv=4.6875e-02}', "");
    Expect(1, 73672, '\p{^Is_Nv=4.6875e-02}', "");
    Expect(1, 73672, '\P{Is_Nv=4.6875e-02}', "");
    Expect(0, 73672, '\P{^Is_Nv=4.6875e-02}', "");
    Error('\p{Is_Nv=0.0469}');
    Error('\P{Is_Nv=0.0469}');
    Expect(1, 73671, '\p{Is_Nv=4.68750e-02}', "");
    Expect(0, 73671, '\p{^Is_Nv=4.68750e-02}', "");
    Expect(0, 73671, '\P{Is_Nv=4.68750e-02}', "");
    Expect(1, 73671, '\P{^Is_Nv=4.68750e-02}', "");
    Expect(0, 73672, '\p{Is_Nv=4.68750e-02}', "");
    Expect(1, 73672, '\p{^Is_Nv=4.68750e-02}', "");
    Expect(1, 73672, '\P{Is_Nv=4.68750e-02}', "");
    Expect(0, 73672, '\P{^Is_Nv=4.68750e-02}', "");
    Expect(1, 73671, '\p{Is_Nv:0.04688}', "");
    Expect(0, 73671, '\p{^Is_Nv:0.04688}', "");
    Expect(0, 73671, '\P{Is_Nv:0.04688}', "");
    Expect(1, 73671, '\P{^Is_Nv:0.04688}', "");
    Expect(0, 73672, '\p{Is_Nv:0.04688}', "");
    Expect(1, 73672, '\p{^Is_Nv:0.04688}', "");
    Expect(1, 73672, '\P{Is_Nv:0.04688}', "");
    Expect(0, 73672, '\P{^Is_Nv:0.04688}', "");
    Expect(1, 73671, '\p{Is_Nv=4.687500e-02}', "");
    Expect(0, 73671, '\p{^Is_Nv=4.687500e-02}', "");
    Expect(0, 73671, '\P{Is_Nv=4.687500e-02}', "");
    Expect(1, 73671, '\P{^Is_Nv=4.687500e-02}', "");
    Expect(0, 73672, '\p{Is_Nv=4.687500e-02}', "");
    Expect(1, 73672, '\p{^Is_Nv=4.687500e-02}', "");
    Expect(1, 73672, '\P{Is_Nv=4.687500e-02}', "");
    Expect(0, 73672, '\P{^Is_Nv=4.687500e-02}', "");
    Expect(1, 73671, '\p{Is_Nv=0.046875}', "");
    Expect(0, 73671, '\p{^Is_Nv=0.046875}', "");
    Expect(0, 73671, '\P{Is_Nv=0.046875}', "");
    Expect(1, 73671, '\P{^Is_Nv=0.046875}', "");
    Expect(0, 73672, '\p{Is_Nv=0.046875}', "");
    Expect(1, 73672, '\p{^Is_Nv=0.046875}', "");
    Expect(1, 73672, '\P{Is_Nv=0.046875}', "");
    Expect(0, 73672, '\P{^Is_Nv=0.046875}', "");
    Error('\p{Numeric_Value=00000003/000000008:=}');
    Error('\P{Numeric_Value=00000003/000000008:=}');
    Expect(1, 8540, '\p{Numeric_Value=:\A3/8\z:}', "");;
    Expect(0, 8541, '\p{Numeric_Value=:\A3/8\z:}', "");;
    Expect(1, 8540, '\p{Numeric_Value=+00000003/000000008}', "");
    Expect(0, 8540, '\p{^Numeric_Value=+00000003/000000008}', "");
    Expect(0, 8540, '\P{Numeric_Value=+00000003/000000008}', "");
    Expect(1, 8540, '\P{^Numeric_Value=+00000003/000000008}', "");
    Expect(0, 8541, '\p{Numeric_Value=+00000003/000000008}', "");
    Expect(1, 8541, '\p{^Numeric_Value=+00000003/000000008}', "");
    Expect(1, 8541, '\P{Numeric_Value=+00000003/000000008}', "");
    Expect(0, 8541, '\P{^Numeric_Value=+00000003/000000008}', "");
    Expect(1, 8540, '\p{Numeric_Value=180/480}', "");
    Expect(0, 8540, '\p{^Numeric_Value=180/480}', "");
    Expect(0, 8540, '\P{Numeric_Value=180/480}', "");
    Expect(1, 8540, '\P{^Numeric_Value=180/480}', "");
    Expect(0, 8541, '\p{Numeric_Value=180/480}', "");
    Expect(1, 8541, '\p{^Numeric_Value=180/480}', "");
    Expect(1, 8541, '\P{Numeric_Value=180/480}', "");
    Expect(0, 8541, '\P{^Numeric_Value=180/480}', "");
    Error('\p{Numeric_Value=3.8e-01}');
    Error('\P{Numeric_Value=3.8e-01}');
    Expect(1, 8540, '\p{Numeric_Value=3.75e-01}', "");
    Expect(0, 8540, '\p{^Numeric_Value=3.75e-01}', "");
    Expect(0, 8540, '\P{Numeric_Value=3.75e-01}', "");
    Expect(1, 8540, '\P{^Numeric_Value=3.75e-01}', "");
    Expect(0, 8541, '\p{Numeric_Value=3.75e-01}', "");
    Expect(1, 8541, '\p{^Numeric_Value=3.75e-01}', "");
    Expect(1, 8541, '\P{Numeric_Value=3.75e-01}', "");
    Expect(0, 8541, '\P{^Numeric_Value=3.75e-01}', "");
    Error('\p{Numeric_Value=0.38}');
    Error('\P{Numeric_Value=0.38}');
    Expect(1, 8540, '\p{Numeric_Value=3.750e-01}', "");
    Expect(0, 8540, '\p{^Numeric_Value=3.750e-01}', "");
    Expect(0, 8540, '\P{Numeric_Value=3.750e-01}', "");
    Expect(1, 8540, '\P{^Numeric_Value=3.750e-01}', "");
    Expect(0, 8541, '\p{Numeric_Value=3.750e-01}', "");
    Expect(1, 8541, '\p{^Numeric_Value=3.750e-01}', "");
    Expect(1, 8541, '\P{Numeric_Value=3.750e-01}', "");
    Expect(0, 8541, '\P{^Numeric_Value=3.750e-01}', "");
    Expect(1, 8540, '\p{Numeric_Value=0.375}', "");
    Expect(0, 8540, '\p{^Numeric_Value=0.375}', "");
    Expect(0, 8540, '\P{Numeric_Value=0.375}', "");
    Expect(1, 8540, '\P{^Numeric_Value=0.375}', "");
    Expect(0, 8541, '\p{Numeric_Value=0.375}', "");
    Expect(1, 8541, '\p{^Numeric_Value=0.375}', "");
    Expect(1, 8541, '\P{Numeric_Value=0.375}', "");
    Expect(0, 8541, '\P{^Numeric_Value=0.375}', "");
    Expect(1, 8540, '\p{Numeric_Value=3.7500e-01}', "");
    Expect(0, 8540, '\p{^Numeric_Value=3.7500e-01}', "");
    Expect(0, 8540, '\P{Numeric_Value=3.7500e-01}', "");
    Expect(1, 8540, '\P{^Numeric_Value=3.7500e-01}', "");
    Expect(0, 8541, '\p{Numeric_Value=3.7500e-01}', "");
    Expect(1, 8541, '\p{^Numeric_Value=3.7500e-01}', "");
    Expect(1, 8541, '\P{Numeric_Value=3.7500e-01}', "");
    Expect(0, 8541, '\P{^Numeric_Value=3.7500e-01}', "");
    Expect(1, 8540, '\p{Numeric_Value=0.3750}', "");
    Expect(0, 8540, '\p{^Numeric_Value=0.3750}', "");
    Expect(0, 8540, '\P{Numeric_Value=0.3750}', "");
    Expect(1, 8540, '\P{^Numeric_Value=0.3750}', "");
    Expect(0, 8541, '\p{Numeric_Value=0.3750}', "");
    Expect(1, 8541, '\p{^Numeric_Value=0.3750}', "");
    Expect(1, 8541, '\P{Numeric_Value=0.3750}', "");
    Expect(0, 8541, '\P{^Numeric_Value=0.3750}', "");
    Error('\p{Nv=_ 0000003/0008/a/}');
    Error('\P{Nv=_ 0000003/0008/a/}');
    Expect(1, 8540, '\p{Nv=:\A3/8\z:}', "");;
    Expect(0, 8541, '\p{Nv=:\A3/8\z:}', "");;
    Expect(1, 8540, '\p{Nv=00000003/00008}', "");
    Expect(0, 8540, '\p{^Nv=00000003/00008}', "");
    Expect(0, 8540, '\P{Nv=00000003/00008}', "");
    Expect(1, 8540, '\P{^Nv=00000003/00008}', "");
    Expect(0, 8541, '\p{Nv=00000003/00008}', "");
    Expect(1, 8541, '\p{^Nv=00000003/00008}', "");
    Expect(1, 8541, '\P{Nv=00000003/00008}', "");
    Expect(0, 8541, '\P{^Nv=00000003/00008}', "");
    Expect(1, 8540, '\p{Nv=180/480}', "");
    Expect(0, 8540, '\p{^Nv=180/480}', "");
    Expect(0, 8540, '\P{Nv=180/480}', "");
    Expect(1, 8540, '\P{^Nv=180/480}', "");
    Expect(0, 8541, '\p{Nv=180/480}', "");
    Expect(1, 8541, '\p{^Nv=180/480}', "");
    Expect(1, 8541, '\P{Nv=180/480}', "");
    Expect(0, 8541, '\P{^Nv=180/480}', "");
    Error('\p{Nv=3.8e-01}');
    Error('\P{Nv=3.8e-01}');
    Expect(1, 8540, '\p{Nv=3.75e-01}', "");
    Expect(0, 8540, '\p{^Nv=3.75e-01}', "");
    Expect(0, 8540, '\P{Nv=3.75e-01}', "");
    Expect(1, 8540, '\P{^Nv=3.75e-01}', "");
    Expect(0, 8541, '\p{Nv=3.75e-01}', "");
    Expect(1, 8541, '\p{^Nv=3.75e-01}', "");
    Expect(1, 8541, '\P{Nv=3.75e-01}', "");
    Expect(0, 8541, '\P{^Nv=3.75e-01}', "");
    Error('\p{Nv:   0.38}');
    Error('\P{Nv:   0.38}');
    Expect(1, 8540, '\p{Nv=3.750e-01}', "");
    Expect(0, 8540, '\p{^Nv=3.750e-01}', "");
    Expect(0, 8540, '\P{Nv=3.750e-01}', "");
    Expect(1, 8540, '\P{^Nv=3.750e-01}', "");
    Expect(0, 8541, '\p{Nv=3.750e-01}', "");
    Expect(1, 8541, '\p{^Nv=3.750e-01}', "");
    Expect(1, 8541, '\P{Nv=3.750e-01}', "");
    Expect(0, 8541, '\P{^Nv=3.750e-01}', "");
    Expect(1, 8540, '\p{Nv=0.375}', "");
    Expect(0, 8540, '\p{^Nv=0.375}', "");
    Expect(0, 8540, '\P{Nv=0.375}', "");
    Expect(1, 8540, '\P{^Nv=0.375}', "");
    Expect(0, 8541, '\p{Nv=0.375}', "");
    Expect(1, 8541, '\p{^Nv=0.375}', "");
    Expect(1, 8541, '\P{Nv=0.375}', "");
    Expect(0, 8541, '\P{^Nv=0.375}', "");
    Expect(1, 8540, '\p{Nv=3.7500e-01}', "");
    Expect(0, 8540, '\p{^Nv=3.7500e-01}', "");
    Expect(0, 8540, '\P{Nv=3.7500e-01}', "");
    Expect(1, 8540, '\P{^Nv=3.7500e-01}', "");
    Expect(0, 8541, '\p{Nv=3.7500e-01}', "");
    Expect(1, 8541, '\p{^Nv=3.7500e-01}', "");
    Expect(1, 8541, '\P{Nv=3.7500e-01}', "");
    Expect(0, 8541, '\P{^Nv=3.7500e-01}', "");
    Expect(1, 8540, '\p{Nv=0.3750}', "");
    Expect(0, 8540, '\p{^Nv=0.3750}', "");
    Expect(0, 8540, '\P{Nv=0.3750}', "");
    Expect(1, 8540, '\P{^Nv=0.3750}', "");
    Expect(0, 8541, '\p{Nv=0.3750}', "");
    Expect(1, 8541, '\p{^Nv=0.3750}', "");
    Expect(1, 8541, '\P{Nv=0.3750}', "");
    Expect(0, 8541, '\P{^Nv=0.3750}', "");
    Error('\p{Is_Numeric_Value=	+0003/00000008/a/}');
    Error('\P{Is_Numeric_Value=	+0003/00000008/a/}');
    Expect(1, 8540, '\p{Is_Numeric_Value=000000003/08}', "");
    Expect(0, 8540, '\p{^Is_Numeric_Value=000000003/08}', "");
    Expect(0, 8540, '\P{Is_Numeric_Value=000000003/08}', "");
    Expect(1, 8540, '\P{^Is_Numeric_Value=000000003/08}', "");
    Expect(0, 8541, '\p{Is_Numeric_Value=000000003/08}', "");
    Expect(1, 8541, '\p{^Is_Numeric_Value=000000003/08}', "");
    Expect(1, 8541, '\P{Is_Numeric_Value=000000003/08}', "");
    Expect(0, 8541, '\P{^Is_Numeric_Value=000000003/08}', "");
    Expect(1, 8540, '\p{Is_Numeric_Value=180/480}', "");
    Expect(0, 8540, '\p{^Is_Numeric_Value=180/480}', "");
    Expect(0, 8540, '\P{Is_Numeric_Value=180/480}', "");
    Expect(1, 8540, '\P{^Is_Numeric_Value=180/480}', "");
    Expect(0, 8541, '\p{Is_Numeric_Value=180/480}', "");
    Expect(1, 8541, '\p{^Is_Numeric_Value=180/480}', "");
    Expect(1, 8541, '\P{Is_Numeric_Value=180/480}', "");
    Expect(0, 8541, '\P{^Is_Numeric_Value=180/480}', "");
    Error('\p{Is_Numeric_Value=3.8e-01}');
    Error('\P{Is_Numeric_Value=3.8e-01}');
    Expect(1, 8540, '\p{Is_Numeric_Value=3.75e-01}', "");
    Expect(0, 8540, '\p{^Is_Numeric_Value=3.75e-01}', "");
    Expect(0, 8540, '\P{Is_Numeric_Value=3.75e-01}', "");
    Expect(1, 8540, '\P{^Is_Numeric_Value=3.75e-01}', "");
    Expect(0, 8541, '\p{Is_Numeric_Value=3.75e-01}', "");
    Expect(1, 8541, '\p{^Is_Numeric_Value=3.75e-01}', "");
    Expect(1, 8541, '\P{Is_Numeric_Value=3.75e-01}', "");
    Expect(0, 8541, '\P{^Is_Numeric_Value=3.75e-01}', "");
    Error('\p{Is_Numeric_Value=0.38}');
    Error('\P{Is_Numeric_Value=0.38}');
    Expect(1, 8540, '\p{Is_Numeric_Value=3.750e-01}', "");
    Expect(0, 8540, '\p{^Is_Numeric_Value=3.750e-01}', "");
    Expect(0, 8540, '\P{Is_Numeric_Value=3.750e-01}', "");
    Expect(1, 8540, '\P{^Is_Numeric_Value=3.750e-01}', "");
    Expect(0, 8541, '\p{Is_Numeric_Value=3.750e-01}', "");
    Expect(1, 8541, '\p{^Is_Numeric_Value=3.750e-01}', "");
    Expect(1, 8541, '\P{Is_Numeric_Value=3.750e-01}', "");
    Expect(0, 8541, '\P{^Is_Numeric_Value=3.750e-01}', "");
    Expect(1, 8540, '\p{Is_Numeric_Value=0.375}', "");
    Expect(0, 8540, '\p{^Is_Numeric_Value=0.375}', "");
    Expect(0, 8540, '\P{Is_Numeric_Value=0.375}', "");
    Expect(1, 8540, '\P{^Is_Numeric_Value=0.375}', "");
    Expect(0, 8541, '\p{Is_Numeric_Value=0.375}', "");
    Expect(1, 8541, '\p{^Is_Numeric_Value=0.375}', "");
    Expect(1, 8541, '\P{Is_Numeric_Value=0.375}', "");
    Expect(0, 8541, '\P{^Is_Numeric_Value=0.375}', "");
    Expect(1, 8540, '\p{Is_Numeric_Value=3.7500e-01}', "");
    Expect(0, 8540, '\p{^Is_Numeric_Value=3.7500e-01}', "");
    Expect(0, 8540, '\P{Is_Numeric_Value=3.7500e-01}', "");
    Expect(1, 8540, '\P{^Is_Numeric_Value=3.7500e-01}', "");
    Expect(0, 8541, '\p{Is_Numeric_Value=3.7500e-01}', "");
    Expect(1, 8541, '\p{^Is_Numeric_Value=3.7500e-01}', "");
    Expect(1, 8541, '\P{Is_Numeric_Value=3.7500e-01}', "");
    Expect(0, 8541, '\P{^Is_Numeric_Value=3.7500e-01}', "");
    Expect(1, 8540, '\p{Is_Numeric_Value=0.3750}', "");
    Expect(0, 8540, '\p{^Is_Numeric_Value=0.3750}', "");
    Expect(0, 8540, '\P{Is_Numeric_Value=0.3750}', "");
    Expect(1, 8540, '\P{^Is_Numeric_Value=0.3750}', "");
    Expect(0, 8541, '\p{Is_Numeric_Value=0.3750}', "");
    Expect(1, 8541, '\p{^Is_Numeric_Value=0.3750}', "");
    Expect(1, 8541, '\P{Is_Numeric_Value=0.3750}', "");
    Expect(0, 8541, '\P{^Is_Numeric_Value=0.3750}', "");
    Error('\p{Is_Nv= -0003/0000000008:=}');
    Error('\P{Is_Nv= -0003/0000000008:=}');
    Expect(1, 8540, '\p{Is_Nv=00003/0000008}', "");
    Expect(0, 8540, '\p{^Is_Nv=00003/0000008}', "");
    Expect(0, 8540, '\P{Is_Nv=00003/0000008}', "");
    Expect(1, 8540, '\P{^Is_Nv=00003/0000008}', "");
    Expect(0, 8541, '\p{Is_Nv=00003/0000008}', "");
    Expect(1, 8541, '\p{^Is_Nv=00003/0000008}', "");
    Expect(1, 8541, '\P{Is_Nv=00003/0000008}', "");
    Expect(0, 8541, '\P{^Is_Nv=00003/0000008}', "");
    Expect(1, 8540, '\p{Is_Nv=180/480}', "");
    Expect(0, 8540, '\p{^Is_Nv=180/480}', "");
    Expect(0, 8540, '\P{Is_Nv=180/480}', "");
    Expect(1, 8540, '\P{^Is_Nv=180/480}', "");
    Expect(0, 8541, '\p{Is_Nv=180/480}', "");
    Expect(1, 8541, '\p{^Is_Nv=180/480}', "");
    Expect(1, 8541, '\P{Is_Nv=180/480}', "");
    Expect(0, 8541, '\P{^Is_Nv=180/480}', "");
    Error('\p{Is_Nv=3.8e-01}');
    Error('\P{Is_Nv=3.8e-01}');
    Expect(1, 8540, '\p{Is_Nv=3.75e-01}', "");
    Expect(0, 8540, '\p{^Is_Nv=3.75e-01}', "");
    Expect(0, 8540, '\P{Is_Nv=3.75e-01}', "");
    Expect(1, 8540, '\P{^Is_Nv=3.75e-01}', "");
    Expect(0, 8541, '\p{Is_Nv=3.75e-01}', "");
    Expect(1, 8541, '\p{^Is_Nv=3.75e-01}', "");
    Expect(1, 8541, '\P{Is_Nv=3.75e-01}', "");
    Expect(0, 8541, '\P{^Is_Nv=3.75e-01}', "");
    Error('\p{Is_Nv: 0.38}');
    Error('\P{Is_Nv: 0.38}');
    Expect(1, 8540, '\p{Is_Nv=3.750e-01}', "");
    Expect(0, 8540, '\p{^Is_Nv=3.750e-01}', "");
    Expect(0, 8540, '\P{Is_Nv=3.750e-01}', "");
    Expect(1, 8540, '\P{^Is_Nv=3.750e-01}', "");
    Expect(0, 8541, '\p{Is_Nv=3.750e-01}', "");
    Expect(1, 8541, '\p{^Is_Nv=3.750e-01}', "");
    Expect(1, 8541, '\P{Is_Nv=3.750e-01}', "");
    Expect(0, 8541, '\P{^Is_Nv=3.750e-01}', "");
    Expect(1, 8540, '\p{Is_Nv=0.375}', "");
    Expect(0, 8540, '\p{^Is_Nv=0.375}', "");
    Expect(0, 8540, '\P{Is_Nv=0.375}', "");
    Expect(1, 8540, '\P{^Is_Nv=0.375}', "");
    Expect(0, 8541, '\p{Is_Nv=0.375}', "");
    Expect(1, 8541, '\p{^Is_Nv=0.375}', "");
    Expect(1, 8541, '\P{Is_Nv=0.375}', "");
    Expect(0, 8541, '\P{^Is_Nv=0.375}', "");
    Expect(1, 8540, '\p{Is_Nv=3.7500e-01}', "");
    Expect(0, 8540, '\p{^Is_Nv=3.7500e-01}', "");
    Expect(0, 8540, '\P{Is_Nv=3.7500e-01}', "");
    Expect(1, 8540, '\P{^Is_Nv=3.7500e-01}', "");
    Expect(0, 8541, '\p{Is_Nv=3.7500e-01}', "");
    Expect(1, 8541, '\p{^Is_Nv=3.7500e-01}', "");
    Expect(1, 8541, '\P{Is_Nv=3.7500e-01}', "");
    Expect(0, 8541, '\P{^Is_Nv=3.7500e-01}', "");
    Expect(1, 8540, '\p{Is_Nv=0.3750}', "");
    Expect(0, 8540, '\p{^Is_Nv=0.3750}', "");
    Expect(0, 8540, '\P{Is_Nv=0.3750}', "");
    Expect(1, 8540, '\P{^Is_Nv=0.3750}', "");
    Expect(0, 8541, '\p{Is_Nv=0.3750}', "");
    Expect(1, 8541, '\p{^Is_Nv=0.3750}', "");
    Expect(1, 8541, '\P{Is_Nv=0.3750}', "");
    Expect(0, 8541, '\P{^Is_Nv=0.3750}', "");
    Error('\p{Numeric_Value=	_+03/080:=}');
    Error('\P{Numeric_Value=	_+03/080:=}');
    Expect(1, 73670, '\p{Numeric_Value=:\A3/80\z:}', "");;
    Expect(0, 73671, '\p{Numeric_Value=:\A3/80\z:}', "");;
    Expect(1, 73670, '\p{Numeric_Value=+3/0000080}', "");
    Expect(0, 73670, '\p{^Numeric_Value=+3/0000080}', "");
    Expect(0, 73670, '\P{Numeric_Value=+3/0000080}', "");
    Expect(1, 73670, '\P{^Numeric_Value=+3/0000080}', "");
    Expect(0, 73671, '\p{Numeric_Value=+3/0000080}', "");
    Expect(1, 73671, '\p{^Numeric_Value=+3/0000080}', "");
    Expect(1, 73671, '\P{Numeric_Value=+3/0000080}', "");
    Expect(0, 73671, '\P{^Numeric_Value=+3/0000080}', "");
    Expect(1, 73670, '\p{Numeric_Value=180/4800}', "");
    Expect(0, 73670, '\p{^Numeric_Value=180/4800}', "");
    Expect(0, 73670, '\P{Numeric_Value=180/4800}', "");
    Expect(1, 73670, '\P{^Numeric_Value=180/4800}', "");
    Expect(0, 73671, '\p{Numeric_Value=180/4800}', "");
    Expect(1, 73671, '\p{^Numeric_Value=180/4800}', "");
    Expect(1, 73671, '\P{Numeric_Value=180/4800}', "");
    Expect(0, 73671, '\P{^Numeric_Value=180/4800}', "");
    Error('\p{Numeric_Value:   3.7e-02}');
    Error('\P{Numeric_Value:   3.7e-02}');
    Expect(1, 73670, '\p{Numeric_Value=3.75e-02}', "");
    Expect(0, 73670, '\p{^Numeric_Value=3.75e-02}', "");
    Expect(0, 73670, '\P{Numeric_Value=3.75e-02}', "");
    Expect(1, 73670, '\P{^Numeric_Value=3.75e-02}', "");
    Expect(0, 73671, '\p{Numeric_Value=3.75e-02}', "");
    Expect(1, 73671, '\p{^Numeric_Value=3.75e-02}', "");
    Expect(1, 73671, '\P{Numeric_Value=3.75e-02}', "");
    Expect(0, 73671, '\P{^Numeric_Value=3.75e-02}', "");
    Error('\p{Numeric_Value=0.04}');
    Error('\P{Numeric_Value=0.04}');
    Expect(1, 73670, '\p{Numeric_Value=3.750e-02}', "");
    Expect(0, 73670, '\p{^Numeric_Value=3.750e-02}', "");
    Expect(0, 73670, '\P{Numeric_Value=3.750e-02}', "");
    Expect(1, 73670, '\P{^Numeric_Value=3.750e-02}', "");
    Expect(0, 73671, '\p{Numeric_Value=3.750e-02}', "");
    Expect(1, 73671, '\p{^Numeric_Value=3.750e-02}', "");
    Expect(1, 73671, '\P{Numeric_Value=3.750e-02}', "");
    Expect(0, 73671, '\P{^Numeric_Value=3.750e-02}', "");
    Error('\p{Numeric_Value=0.037}');
    Error('\P{Numeric_Value=0.037}');
    Expect(1, 73670, '\p{Numeric_Value=3.7500e-02}', "");
    Expect(0, 73670, '\p{^Numeric_Value=3.7500e-02}', "");
    Expect(0, 73670, '\P{Numeric_Value=3.7500e-02}', "");
    Expect(1, 73670, '\P{^Numeric_Value=3.7500e-02}', "");
    Expect(0, 73671, '\p{Numeric_Value=3.7500e-02}', "");
    Expect(1, 73671, '\p{^Numeric_Value=3.7500e-02}', "");
    Expect(1, 73671, '\P{Numeric_Value=3.7500e-02}', "");
    Expect(0, 73671, '\P{^Numeric_Value=3.7500e-02}', "");
    Expect(1, 73670, '\p{Numeric_Value=0.0375}', "");
    Expect(0, 73670, '\p{^Numeric_Value=0.0375}', "");
    Expect(0, 73670, '\P{Numeric_Value=0.0375}', "");
    Expect(1, 73670, '\P{^Numeric_Value=0.0375}', "");
    Expect(0, 73671, '\p{Numeric_Value=0.0375}', "");
    Expect(1, 73671, '\p{^Numeric_Value=0.0375}', "");
    Expect(1, 73671, '\P{Numeric_Value=0.0375}', "");
    Expect(0, 73671, '\P{^Numeric_Value=0.0375}', "");
    Expect(1, 73670, '\p{Numeric_Value=3.75000e-02}', "");
    Expect(0, 73670, '\p{^Numeric_Value=3.75000e-02}', "");
    Expect(0, 73670, '\P{Numeric_Value=3.75000e-02}', "");
    Expect(1, 73670, '\P{^Numeric_Value=3.75000e-02}', "");
    Expect(0, 73671, '\p{Numeric_Value=3.75000e-02}', "");
    Expect(1, 73671, '\p{^Numeric_Value=3.75000e-02}', "");
    Expect(1, 73671, '\P{Numeric_Value=3.75000e-02}', "");
    Expect(0, 73671, '\P{^Numeric_Value=3.75000e-02}', "");
    Expect(1, 73670, '\p{Numeric_Value=0.03750}', "");
    Expect(0, 73670, '\p{^Numeric_Value=0.03750}', "");
    Expect(0, 73670, '\P{Numeric_Value=0.03750}', "");
    Expect(1, 73670, '\P{^Numeric_Value=0.03750}', "");
    Expect(0, 73671, '\p{Numeric_Value=0.03750}', "");
    Expect(1, 73671, '\p{^Numeric_Value=0.03750}', "");
    Expect(1, 73671, '\P{Numeric_Value=0.03750}', "");
    Expect(0, 73671, '\P{^Numeric_Value=0.03750}', "");
    Error('\p{Nv=/a/ 	+0000000003/000080}');
    Error('\P{Nv=/a/ 	+0000000003/000080}');
    Expect(1, 73670, '\p{Nv=:\A3/80\z:}', "");;
    Expect(0, 73671, '\p{Nv=:\A3/80\z:}', "");;
    Expect(1, 73670, '\p{Nv=0000000003/000080}', "");
    Expect(0, 73670, '\p{^Nv=0000000003/000080}', "");
    Expect(0, 73670, '\P{Nv=0000000003/000080}', "");
    Expect(1, 73670, '\P{^Nv=0000000003/000080}', "");
    Expect(0, 73671, '\p{Nv=0000000003/000080}', "");
    Expect(1, 73671, '\p{^Nv=0000000003/000080}', "");
    Expect(1, 73671, '\P{Nv=0000000003/000080}', "");
    Expect(0, 73671, '\P{^Nv=0000000003/000080}', "");
    Expect(1, 73670, '\p{Nv=180/4800}', "");
    Expect(0, 73670, '\p{^Nv=180/4800}', "");
    Expect(0, 73670, '\P{Nv=180/4800}', "");
    Expect(1, 73670, '\P{^Nv=180/4800}', "");
    Expect(0, 73671, '\p{Nv=180/4800}', "");
    Expect(1, 73671, '\p{^Nv=180/4800}', "");
    Expect(1, 73671, '\P{Nv=180/4800}', "");
    Expect(0, 73671, '\P{^Nv=180/4800}', "");
    Error('\p{Nv=3.7e-02}');
    Error('\P{Nv=3.7e-02}');
    Expect(1, 73670, '\p{Nv=3.75e-02}', "");
    Expect(0, 73670, '\p{^Nv=3.75e-02}', "");
    Expect(0, 73670, '\P{Nv=3.75e-02}', "");
    Expect(1, 73670, '\P{^Nv=3.75e-02}', "");
    Expect(0, 73671, '\p{Nv=3.75e-02}', "");
    Expect(1, 73671, '\p{^Nv=3.75e-02}', "");
    Expect(1, 73671, '\P{Nv=3.75e-02}', "");
    Expect(0, 73671, '\P{^Nv=3.75e-02}', "");
    Error('\p{Nv=0.04}');
    Error('\P{Nv=0.04}');
    Expect(1, 73670, '\p{Nv=3.750e-02}', "");
    Expect(0, 73670, '\p{^Nv=3.750e-02}', "");
    Expect(0, 73670, '\P{Nv=3.750e-02}', "");
    Expect(1, 73670, '\P{^Nv=3.750e-02}', "");
    Expect(0, 73671, '\p{Nv=3.750e-02}', "");
    Expect(1, 73671, '\p{^Nv=3.750e-02}', "");
    Expect(1, 73671, '\P{Nv=3.750e-02}', "");
    Expect(0, 73671, '\P{^Nv=3.750e-02}', "");
    Error('\p{Nv=0.037}');
    Error('\P{Nv=0.037}');
    Expect(1, 73670, '\p{Nv=3.7500e-02}', "");
    Expect(0, 73670, '\p{^Nv=3.7500e-02}', "");
    Expect(0, 73670, '\P{Nv=3.7500e-02}', "");
    Expect(1, 73670, '\P{^Nv=3.7500e-02}', "");
    Expect(0, 73671, '\p{Nv=3.7500e-02}', "");
    Expect(1, 73671, '\p{^Nv=3.7500e-02}', "");
    Expect(1, 73671, '\P{Nv=3.7500e-02}', "");
    Expect(0, 73671, '\P{^Nv=3.7500e-02}', "");
    Expect(1, 73670, '\p{Nv=0.0375}', "");
    Expect(0, 73670, '\p{^Nv=0.0375}', "");
    Expect(0, 73670, '\P{Nv=0.0375}', "");
    Expect(1, 73670, '\P{^Nv=0.0375}', "");
    Expect(0, 73671, '\p{Nv=0.0375}', "");
    Expect(1, 73671, '\p{^Nv=0.0375}', "");
    Expect(1, 73671, '\P{Nv=0.0375}', "");
    Expect(0, 73671, '\P{^Nv=0.0375}', "");
    Expect(1, 73670, '\p{Nv:	3.75000e-02}', "");
    Expect(0, 73670, '\p{^Nv:	3.75000e-02}', "");
    Expect(0, 73670, '\P{Nv:	3.75000e-02}', "");
    Expect(1, 73670, '\P{^Nv:	3.75000e-02}', "");
    Expect(0, 73671, '\p{Nv:	3.75000e-02}', "");
    Expect(1, 73671, '\p{^Nv:	3.75000e-02}', "");
    Expect(1, 73671, '\P{Nv:	3.75000e-02}', "");
    Expect(0, 73671, '\P{^Nv:	3.75000e-02}', "");
    Expect(1, 73670, '\p{Nv=0.03750}', "");
    Expect(0, 73670, '\p{^Nv=0.03750}', "");
    Expect(0, 73670, '\P{Nv=0.03750}', "");
    Expect(1, 73670, '\P{^Nv=0.03750}', "");
    Expect(0, 73671, '\p{Nv=0.03750}', "");
    Expect(1, 73671, '\p{^Nv=0.03750}', "");
    Expect(1, 73671, '\P{Nv=0.03750}', "");
    Expect(0, 73671, '\P{^Nv=0.03750}', "");
    Error('\p{Is_Numeric_Value=	3/0000080:=}');
    Error('\P{Is_Numeric_Value=	3/0000080:=}');
    Expect(1, 73670, '\p{Is_Numeric_Value=000000003/00000000080}', "");
    Expect(0, 73670, '\p{^Is_Numeric_Value=000000003/00000000080}', "");
    Expect(0, 73670, '\P{Is_Numeric_Value=000000003/00000000080}', "");
    Expect(1, 73670, '\P{^Is_Numeric_Value=000000003/00000000080}', "");
    Expect(0, 73671, '\p{Is_Numeric_Value=000000003/00000000080}', "");
    Expect(1, 73671, '\p{^Is_Numeric_Value=000000003/00000000080}', "");
    Expect(1, 73671, '\P{Is_Numeric_Value=000000003/00000000080}', "");
    Expect(0, 73671, '\P{^Is_Numeric_Value=000000003/00000000080}', "");
    Expect(1, 73670, '\p{Is_Numeric_Value=180/4800}', "");
    Expect(0, 73670, '\p{^Is_Numeric_Value=180/4800}', "");
    Expect(0, 73670, '\P{Is_Numeric_Value=180/4800}', "");
    Expect(1, 73670, '\P{^Is_Numeric_Value=180/4800}', "");
    Expect(0, 73671, '\p{Is_Numeric_Value=180/4800}', "");
    Expect(1, 73671, '\p{^Is_Numeric_Value=180/4800}', "");
    Expect(1, 73671, '\P{Is_Numeric_Value=180/4800}', "");
    Expect(0, 73671, '\P{^Is_Numeric_Value=180/4800}', "");
    Error('\p{Is_Numeric_Value=3.7e-02}');
    Error('\P{Is_Numeric_Value=3.7e-02}');
    Expect(1, 73670, '\p{Is_Numeric_Value=3.75e-02}', "");
    Expect(0, 73670, '\p{^Is_Numeric_Value=3.75e-02}', "");
    Expect(0, 73670, '\P{Is_Numeric_Value=3.75e-02}', "");
    Expect(1, 73670, '\P{^Is_Numeric_Value=3.75e-02}', "");
    Expect(0, 73671, '\p{Is_Numeric_Value=3.75e-02}', "");
    Expect(1, 73671, '\p{^Is_Numeric_Value=3.75e-02}', "");
    Expect(1, 73671, '\P{Is_Numeric_Value=3.75e-02}', "");
    Expect(0, 73671, '\P{^Is_Numeric_Value=3.75e-02}', "");
    Error('\p{Is_Numeric_Value=0.04}');
    Error('\P{Is_Numeric_Value=0.04}');
    Expect(1, 73670, '\p{Is_Numeric_Value=3.750e-02}', "");
    Expect(0, 73670, '\p{^Is_Numeric_Value=3.750e-02}', "");
    Expect(0, 73670, '\P{Is_Numeric_Value=3.750e-02}', "");
    Expect(1, 73670, '\P{^Is_Numeric_Value=3.750e-02}', "");
    Expect(0, 73671, '\p{Is_Numeric_Value=3.750e-02}', "");
    Expect(1, 73671, '\p{^Is_Numeric_Value=3.750e-02}', "");
    Expect(1, 73671, '\P{Is_Numeric_Value=3.750e-02}', "");
    Expect(0, 73671, '\P{^Is_Numeric_Value=3.750e-02}', "");
    Error('\p{Is_Numeric_Value=0.037}');
    Error('\P{Is_Numeric_Value=0.037}');
    Expect(1, 73670, '\p{Is_Numeric_Value=3.7500e-02}', "");
    Expect(0, 73670, '\p{^Is_Numeric_Value=3.7500e-02}', "");
    Expect(0, 73670, '\P{Is_Numeric_Value=3.7500e-02}', "");
    Expect(1, 73670, '\P{^Is_Numeric_Value=3.7500e-02}', "");
    Expect(0, 73671, '\p{Is_Numeric_Value=3.7500e-02}', "");
    Expect(1, 73671, '\p{^Is_Numeric_Value=3.7500e-02}', "");
    Expect(1, 73671, '\P{Is_Numeric_Value=3.7500e-02}', "");
    Expect(0, 73671, '\P{^Is_Numeric_Value=3.7500e-02}', "");
    Expect(1, 73670, '\p{Is_Numeric_Value=0.0375}', "");
    Expect(0, 73670, '\p{^Is_Numeric_Value=0.0375}', "");
    Expect(0, 73670, '\P{Is_Numeric_Value=0.0375}', "");
    Expect(1, 73670, '\P{^Is_Numeric_Value=0.0375}', "");
    Expect(0, 73671, '\p{Is_Numeric_Value=0.0375}', "");
    Expect(1, 73671, '\p{^Is_Numeric_Value=0.0375}', "");
    Expect(1, 73671, '\P{Is_Numeric_Value=0.0375}', "");
    Expect(0, 73671, '\P{^Is_Numeric_Value=0.0375}', "");
    Expect(1, 73670, '\p{Is_Numeric_Value:3.75000e-02}', "");
    Expect(0, 73670, '\p{^Is_Numeric_Value:3.75000e-02}', "");
    Expect(0, 73670, '\P{Is_Numeric_Value:3.75000e-02}', "");
    Expect(1, 73670, '\P{^Is_Numeric_Value:3.75000e-02}', "");
    Expect(0, 73671, '\p{Is_Numeric_Value:3.75000e-02}', "");
    Expect(1, 73671, '\p{^Is_Numeric_Value:3.75000e-02}', "");
    Expect(1, 73671, '\P{Is_Numeric_Value:3.75000e-02}', "");
    Expect(0, 73671, '\P{^Is_Numeric_Value:3.75000e-02}', "");
    Expect(1, 73670, '\p{Is_Numeric_Value:	0.03750}', "");
    Expect(0, 73670, '\p{^Is_Numeric_Value:	0.03750}', "");
    Expect(0, 73670, '\P{Is_Numeric_Value:	0.03750}', "");
    Expect(1, 73670, '\P{^Is_Numeric_Value:	0.03750}', "");
    Expect(0, 73671, '\p{Is_Numeric_Value:	0.03750}', "");
    Expect(1, 73671, '\p{^Is_Numeric_Value:	0.03750}', "");
    Expect(1, 73671, '\P{Is_Numeric_Value:	0.03750}', "");
    Expect(0, 73671, '\P{^Is_Numeric_Value:	0.03750}', "");
    Error('\p{Is_Nv:	:=__000003/80}');
    Error('\P{Is_Nv:	:=__000003/80}');
    Expect(1, 73670, '\p{Is_Nv=3/000080}', "");
    Expect(0, 73670, '\p{^Is_Nv=3/000080}', "");
    Expect(0, 73670, '\P{Is_Nv=3/000080}', "");
    Expect(1, 73670, '\P{^Is_Nv=3/000080}', "");
    Expect(0, 73671, '\p{Is_Nv=3/000080}', "");
    Expect(1, 73671, '\p{^Is_Nv=3/000080}', "");
    Expect(1, 73671, '\P{Is_Nv=3/000080}', "");
    Expect(0, 73671, '\P{^Is_Nv=3/000080}', "");
    Expect(1, 73670, '\p{Is_Nv=180/4800}', "");
    Expect(0, 73670, '\p{^Is_Nv=180/4800}', "");
    Expect(0, 73670, '\P{Is_Nv=180/4800}', "");
    Expect(1, 73670, '\P{^Is_Nv=180/4800}', "");
    Expect(0, 73671, '\p{Is_Nv=180/4800}', "");
    Expect(1, 73671, '\p{^Is_Nv=180/4800}', "");
    Expect(1, 73671, '\P{Is_Nv=180/4800}', "");
    Expect(0, 73671, '\P{^Is_Nv=180/4800}', "");
    Error('\p{Is_Nv=3.7e-02}');
    Error('\P{Is_Nv=3.7e-02}');
    Expect(1, 73670, '\p{Is_Nv=3.75e-02}', "");
    Expect(0, 73670, '\p{^Is_Nv=3.75e-02}', "");
    Expect(0, 73670, '\P{Is_Nv=3.75e-02}', "");
    Expect(1, 73670, '\P{^Is_Nv=3.75e-02}', "");
    Expect(0, 73671, '\p{Is_Nv=3.75e-02}', "");
    Expect(1, 73671, '\p{^Is_Nv=3.75e-02}', "");
    Expect(1, 73671, '\P{Is_Nv=3.75e-02}', "");
    Expect(0, 73671, '\P{^Is_Nv=3.75e-02}', "");
    Error('\p{Is_Nv=0.04}');
    Error('\P{Is_Nv=0.04}');
    Expect(1, 73670, '\p{Is_Nv=3.750e-02}', "");
    Expect(0, 73670, '\p{^Is_Nv=3.750e-02}', "");
    Expect(0, 73670, '\P{Is_Nv=3.750e-02}', "");
    Expect(1, 73670, '\P{^Is_Nv=3.750e-02}', "");
    Expect(0, 73671, '\p{Is_Nv=3.750e-02}', "");
    Expect(1, 73671, '\p{^Is_Nv=3.750e-02}', "");
    Expect(1, 73671, '\P{Is_Nv=3.750e-02}', "");
    Expect(0, 73671, '\P{^Is_Nv=3.750e-02}', "");
    Error('\p{Is_Nv=0.037}');
    Error('\P{Is_Nv=0.037}');
    Expect(1, 73670, '\p{Is_Nv=3.7500e-02}', "");
    Expect(0, 73670, '\p{^Is_Nv=3.7500e-02}', "");
    Expect(0, 73670, '\P{Is_Nv=3.7500e-02}', "");
    Expect(1, 73670, '\P{^Is_Nv=3.7500e-02}', "");
    Expect(0, 73671, '\p{Is_Nv=3.7500e-02}', "");
    Expect(1, 73671, '\p{^Is_Nv=3.7500e-02}', "");
    Expect(1, 73671, '\P{Is_Nv=3.7500e-02}', "");
    Expect(0, 73671, '\P{^Is_Nv=3.7500e-02}', "");
    Expect(1, 73670, '\p{Is_Nv:0.0375}', "");
    Expect(0, 73670, '\p{^Is_Nv:0.0375}', "");
    Expect(0, 73670, '\P{Is_Nv:0.0375}', "");
    Expect(1, 73670, '\P{^Is_Nv:0.0375}', "");
    Expect(0, 73671, '\p{Is_Nv:0.0375}', "");
    Expect(1, 73671, '\p{^Is_Nv:0.0375}', "");
    Expect(1, 73671, '\P{Is_Nv:0.0375}', "");
    Expect(0, 73671, '\P{^Is_Nv:0.0375}', "");
    Expect(1, 73670, '\p{Is_Nv=3.75000e-02}', "");
    Expect(0, 73670, '\p{^Is_Nv=3.75000e-02}', "");
    Expect(0, 73670, '\P{Is_Nv=3.75000e-02}', "");
    Expect(1, 73670, '\P{^Is_Nv=3.75000e-02}', "");
    Expect(0, 73671, '\p{Is_Nv=3.75000e-02}', "");
    Expect(1, 73671, '\p{^Is_Nv=3.75000e-02}', "");
    Expect(1, 73671, '\P{Is_Nv=3.75000e-02}', "");
    Expect(0, 73671, '\P{^Is_Nv=3.75000e-02}', "");
    Expect(1, 73670, '\p{Is_Nv=0.03750}', "");
    Expect(0, 73670, '\p{^Is_Nv=0.03750}', "");
    Expect(0, 73670, '\P{Is_Nv=0.03750}', "");
    Expect(1, 73670, '\P{^Is_Nv=0.03750}', "");
    Expect(0, 73671, '\p{Is_Nv=0.03750}', "");
    Expect(1, 73671, '\p{^Is_Nv=0.03750}', "");
    Expect(1, 73671, '\P{Is_Nv=0.03750}', "");
    Expect(0, 73671, '\P{^Is_Nv=0.03750}', "");
    Error('\p{Numeric_Value=_	30/a/}');
    Error('\P{Numeric_Value=_	30/a/}');
    Expect(1, 133507, '\p{Numeric_Value=:\A30\z:}', "");;
    Expect(0, 133508, '\p{Numeric_Value=:\A30\z:}', "");;
    Expect(1, 133507, '\p{Numeric_Value=000030}', "");
    Expect(0, 133507, '\p{^Numeric_Value=000030}', "");
    Expect(0, 133507, '\P{Numeric_Value=000030}', "");
    Expect(1, 133507, '\P{^Numeric_Value=000030}', "");
    Expect(0, 133508, '\p{Numeric_Value=000030}', "");
    Expect(1, 133508, '\p{^Numeric_Value=000030}', "");
    Expect(1, 133508, '\P{Numeric_Value=000030}', "");
    Expect(0, 133508, '\P{^Numeric_Value=000030}', "");
    Expect(1, 133507, '\p{Numeric_Value=3.000000000000000e+01}', "");
    Expect(0, 133507, '\p{^Numeric_Value=3.000000000000000e+01}', "");
    Expect(0, 133507, '\P{Numeric_Value=3.000000000000000e+01}', "");
    Expect(1, 133507, '\P{^Numeric_Value=3.000000000000000e+01}', "");
    Expect(0, 133508, '\p{Numeric_Value=3.000000000000000e+01}', "");
    Expect(1, 133508, '\p{^Numeric_Value=3.000000000000000e+01}', "");
    Expect(1, 133508, '\P{Numeric_Value=3.000000000000000e+01}', "");
    Expect(0, 133508, '\P{^Numeric_Value=3.000000000000000e+01}', "");
    Error('\p{Nv=_-00000000030:=}');
    Error('\P{Nv=_-00000000030:=}');
    Expect(1, 133507, '\p{Nv=:\A30\z:}', "");;
    Expect(0, 133508, '\p{Nv=:\A30\z:}', "");;
    Expect(1, 133507, '\p{Nv=3_0}', "");
    Expect(0, 133507, '\p{^Nv=3_0}', "");
    Expect(0, 133507, '\P{Nv=3_0}', "");
    Expect(1, 133507, '\P{^Nv=3_0}', "");
    Expect(0, 133508, '\p{Nv=3_0}', "");
    Expect(1, 133508, '\p{^Nv=3_0}', "");
    Expect(1, 133508, '\P{Nv=3_0}', "");
    Expect(0, 133508, '\P{^Nv=3_0}', "");
    Expect(1, 133507, '\p{Nv=3.000000000000000e+01}', "");
    Expect(0, 133507, '\p{^Nv=3.000000000000000e+01}', "");
    Expect(0, 133507, '\P{Nv=3.000000000000000e+01}', "");
    Expect(1, 133507, '\P{^Nv=3.000000000000000e+01}', "");
    Expect(0, 133508, '\p{Nv=3.000000000000000e+01}', "");
    Expect(1, 133508, '\p{^Nv=3.000000000000000e+01}', "");
    Expect(1, 133508, '\P{Nv=3.000000000000000e+01}', "");
    Expect(0, 133508, '\P{^Nv=3.000000000000000e+01}', "");
    Error('\p{Is_Numeric_Value=/a/ _0000030}');
    Error('\P{Is_Numeric_Value=/a/ _0000030}');
    Expect(1, 133507, '\p{Is_Numeric_Value=000030}', "");
    Expect(0, 133507, '\p{^Is_Numeric_Value=000030}', "");
    Expect(0, 133507, '\P{Is_Numeric_Value=000030}', "");
    Expect(1, 133507, '\P{^Is_Numeric_Value=000030}', "");
    Expect(0, 133508, '\p{Is_Numeric_Value=000030}', "");
    Expect(1, 133508, '\p{^Is_Numeric_Value=000030}', "");
    Expect(1, 133508, '\P{Is_Numeric_Value=000030}', "");
    Expect(0, 133508, '\P{^Is_Numeric_Value=000030}', "");
    Expect(1, 133507, '\p{Is_Numeric_Value=3.000000000000000e+01}', "");
    Expect(0, 133507, '\p{^Is_Numeric_Value=3.000000000000000e+01}', "");
    Expect(0, 133507, '\P{Is_Numeric_Value=3.000000000000000e+01}', "");
    Expect(1, 133507, '\P{^Is_Numeric_Value=3.000000000000000e+01}', "");
    Expect(0, 133508, '\p{Is_Numeric_Value=3.000000000000000e+01}', "");
    Expect(1, 133508, '\p{^Is_Numeric_Value=3.000000000000000e+01}', "");
    Expect(1, 133508, '\P{Is_Numeric_Value=3.000000000000000e+01}', "");
    Expect(0, 133508, '\P{^Is_Numeric_Value=3.000000000000000e+01}', "");
    Error('\p{Is_Nv=	:=+00_03_0}');
    Error('\P{Is_Nv=	:=+00_03_0}');
    Expect(1, 133507, '\p{Is_Nv=00000003_0}', "");
    Expect(0, 133507, '\p{^Is_Nv=00000003_0}', "");
    Expect(0, 133507, '\P{Is_Nv=00000003_0}', "");
    Expect(1, 133507, '\P{^Is_Nv=00000003_0}', "");
    Expect(0, 133508, '\p{Is_Nv=00000003_0}', "");
    Expect(1, 133508, '\p{^Is_Nv=00000003_0}', "");
    Expect(1, 133508, '\P{Is_Nv=00000003_0}', "");
    Expect(0, 133508, '\P{^Is_Nv=00000003_0}', "");
    Expect(1, 133507, '\p{Is_Nv: 3.000000000000000e+01}', "");
    Expect(0, 133507, '\p{^Is_Nv: 3.000000000000000e+01}', "");
    Expect(0, 133507, '\P{Is_Nv: 3.000000000000000e+01}', "");
    Expect(1, 133507, '\P{^Is_Nv: 3.000000000000000e+01}', "");
    Expect(0, 133508, '\p{Is_Nv: 3.000000000000000e+01}', "");
    Expect(1, 133508, '\p{^Is_Nv: 3.000000000000000e+01}', "");
    Expect(1, 133508, '\P{Is_Nv: 3.000000000000000e+01}', "");
    Expect(0, 133508, '\P{^Is_Nv: 3.000000000000000e+01}', "");
    Error('\p{Numeric_Value=-00000300:=}');
    Error('\P{Numeric_Value=-00000300:=}');
    Expect(1, 126229, '\p{Numeric_Value=:\A300\z:}', "");;
    Expect(0, 126230, '\p{Numeric_Value=:\A300\z:}', "");;
    Expect(1, 126229, '\p{Numeric_Value=00300}', "");
    Expect(0, 126229, '\p{^Numeric_Value=00300}', "");
    Expect(0, 126229, '\P{Numeric_Value=00300}', "");
    Expect(1, 126229, '\P{^Numeric_Value=00300}', "");
    Expect(0, 126230, '\p{Numeric_Value=00300}', "");
    Expect(1, 126230, '\p{^Numeric_Value=00300}', "");
    Expect(1, 126230, '\P{Numeric_Value=00300}', "");
    Expect(0, 126230, '\P{^Numeric_Value=00300}', "");
    Expect(1, 126229, '\p{Numeric_Value=3.000000000000000e+02}', "");
    Expect(0, 126229, '\p{^Numeric_Value=3.000000000000000e+02}', "");
    Expect(0, 126229, '\P{Numeric_Value=3.000000000000000e+02}', "");
    Expect(1, 126229, '\P{^Numeric_Value=3.000000000000000e+02}', "");
    Expect(0, 126230, '\p{Numeric_Value=3.000000000000000e+02}', "");
    Expect(1, 126230, '\p{^Numeric_Value=3.000000000000000e+02}', "");
    Expect(1, 126230, '\P{Numeric_Value=3.000000000000000e+02}', "");
    Expect(0, 126230, '\P{^Numeric_Value=3.000000000000000e+02}', "");
    Error('\p{Nv=:=0_0_0_0_0_0_0_0300}');
    Error('\P{Nv=:=0_0_0_0_0_0_0_0300}');
    Expect(1, 126229, '\p{Nv=:\A300\z:}', "");;
    Expect(0, 126230, '\p{Nv=:\A300\z:}', "");;
    Expect(1, 126229, '\p{Nv=+0000300}', "");
    Expect(0, 126229, '\p{^Nv=+0000300}', "");
    Expect(0, 126229, '\P{Nv=+0000300}', "");
    Expect(1, 126229, '\P{^Nv=+0000300}', "");
    Expect(0, 126230, '\p{Nv=+0000300}', "");
    Expect(1, 126230, '\p{^Nv=+0000300}', "");
    Expect(1, 126230, '\P{Nv=+0000300}', "");
    Expect(0, 126230, '\P{^Nv=+0000300}', "");
    Expect(1, 126229, '\p{Nv=3.000000000000000e+02}', "");
    Expect(0, 126229, '\p{^Nv=3.000000000000000e+02}', "");
    Expect(0, 126229, '\P{Nv=3.000000000000000e+02}', "");
    Expect(1, 126229, '\P{^Nv=3.000000000000000e+02}', "");
    Expect(0, 126230, '\p{Nv=3.000000000000000e+02}', "");
    Expect(1, 126230, '\p{^Nv=3.000000000000000e+02}', "");
    Expect(1, 126230, '\P{Nv=3.000000000000000e+02}', "");
    Expect(0, 126230, '\P{^Nv=3.000000000000000e+02}', "");
    Error('\p{Is_Numeric_Value=	+300:=}');
    Error('\P{Is_Numeric_Value=	+300:=}');
    Expect(1, 126229, '\p{Is_Numeric_Value=+000_000_000_300}', "");
    Expect(0, 126229, '\p{^Is_Numeric_Value=+000_000_000_300}', "");
    Expect(0, 126229, '\P{Is_Numeric_Value=+000_000_000_300}', "");
    Expect(1, 126229, '\P{^Is_Numeric_Value=+000_000_000_300}', "");
    Expect(0, 126230, '\p{Is_Numeric_Value=+000_000_000_300}', "");
    Expect(1, 126230, '\p{^Is_Numeric_Value=+000_000_000_300}', "");
    Expect(1, 126230, '\P{Is_Numeric_Value=+000_000_000_300}', "");
    Expect(0, 126230, '\P{^Is_Numeric_Value=+000_000_000_300}', "");
    Expect(1, 126229, '\p{Is_Numeric_Value=3.000000000000000e+02}', "");
    Expect(0, 126229, '\p{^Is_Numeric_Value=3.000000000000000e+02}', "");
    Expect(0, 126229, '\P{Is_Numeric_Value=3.000000000000000e+02}', "");
    Expect(1, 126229, '\P{^Is_Numeric_Value=3.000000000000000e+02}', "");
    Expect(0, 126230, '\p{Is_Numeric_Value=3.000000000000000e+02}', "");
    Expect(1, 126230, '\p{^Is_Numeric_Value=3.000000000000000e+02}', "");
    Expect(1, 126230, '\P{Is_Numeric_Value=3.000000000000000e+02}', "");
    Expect(0, 126230, '\P{^Is_Numeric_Value=3.000000000000000e+02}', "");
    Error('\p{Is_Nv=/a/- 0_0_0_0_0_0_300}');
    Error('\P{Is_Nv=/a/- 0_0_0_0_0_0_300}');
    Expect(1, 126229, '\p{Is_Nv=+300}', "");
    Expect(0, 126229, '\p{^Is_Nv=+300}', "");
    Expect(0, 126229, '\P{Is_Nv=+300}', "");
    Expect(1, 126229, '\P{^Is_Nv=+300}', "");
    Expect(0, 126230, '\p{Is_Nv=+300}', "");
    Expect(1, 126230, '\p{^Is_Nv=+300}', "");
    Expect(1, 126230, '\P{Is_Nv=+300}', "");
    Expect(0, 126230, '\P{^Is_Nv=+300}', "");
    Expect(1, 126229, '\p{Is_Nv=3.000000000000000e+02}', "");
    Expect(0, 126229, '\p{^Is_Nv=3.000000000000000e+02}', "");
    Expect(0, 126229, '\P{Is_Nv=3.000000000000000e+02}', "");
    Expect(1, 126229, '\P{^Is_Nv=3.000000000000000e+02}', "");
    Expect(0, 126230, '\p{Is_Nv=3.000000000000000e+02}', "");
    Expect(1, 126230, '\p{^Is_Nv=3.000000000000000e+02}', "");
    Expect(1, 126230, '\P{Is_Nv=3.000000000000000e+02}', "");
    Expect(0, 126230, '\P{^Is_Nv=3.000000000000000e+02}', "");
    Error('\p{Numeric_Value=-	3000/a/}');
    Error('\P{Numeric_Value=-	3000/a/}');
    Expect(1, 126238, '\p{Numeric_Value=:\A3000\z:}', "");;
    Expect(0, 126239, '\p{Numeric_Value=:\A3000\z:}', "");;
    Expect(1, 126238, '\p{Numeric_Value=0_0_0_0_3000}', "");
    Expect(0, 126238, '\p{^Numeric_Value=0_0_0_0_3000}', "");
    Expect(0, 126238, '\P{Numeric_Value=0_0_0_0_3000}', "");
    Expect(1, 126238, '\P{^Numeric_Value=0_0_0_0_3000}', "");
    Expect(0, 126239, '\p{Numeric_Value=0_0_0_0_3000}', "");
    Expect(1, 126239, '\p{^Numeric_Value=0_0_0_0_3000}', "");
    Expect(1, 126239, '\P{Numeric_Value=0_0_0_0_3000}', "");
    Expect(0, 126239, '\P{^Numeric_Value=0_0_0_0_3000}', "");
    Expect(1, 126238, '\p{Numeric_Value=3.000000000000000e+03}', "");
    Expect(0, 126238, '\p{^Numeric_Value=3.000000000000000e+03}', "");
    Expect(0, 126238, '\P{Numeric_Value=3.000000000000000e+03}', "");
    Expect(1, 126238, '\P{^Numeric_Value=3.000000000000000e+03}', "");
    Expect(0, 126239, '\p{Numeric_Value=3.000000000000000e+03}', "");
    Expect(1, 126239, '\p{^Numeric_Value=3.000000000000000e+03}', "");
    Expect(1, 126239, '\P{Numeric_Value=3.000000000000000e+03}', "");
    Expect(0, 126239, '\P{^Numeric_Value=3.000000000000000e+03}', "");
    Error('\p{Nv=_-000003000/a/}');
    Error('\P{Nv=_-000003000/a/}');
    Expect(1, 126238, '\p{Nv=:\A3000\z:}', "");;
    Expect(0, 126239, '\p{Nv=:\A3000\z:}', "");;
    Expect(1, 126238, '\p{Nv=+0_3_0_00}', "");
    Expect(0, 126238, '\p{^Nv=+0_3_0_00}', "");
    Expect(0, 126238, '\P{Nv=+0_3_0_00}', "");
    Expect(1, 126238, '\P{^Nv=+0_3_0_00}', "");
    Expect(0, 126239, '\p{Nv=+0_3_0_00}', "");
    Expect(1, 126239, '\p{^Nv=+0_3_0_00}', "");
    Expect(1, 126239, '\P{Nv=+0_3_0_00}', "");
    Expect(0, 126239, '\P{^Nv=+0_3_0_00}', "");
    Expect(1, 126238, '\p{Nv=3.000000000000000e+03}', "");
    Expect(0, 126238, '\p{^Nv=3.000000000000000e+03}', "");
    Expect(0, 126238, '\P{Nv=3.000000000000000e+03}', "");
    Expect(1, 126238, '\P{^Nv=3.000000000000000e+03}', "");
    Expect(0, 126239, '\p{Nv=3.000000000000000e+03}', "");
    Expect(1, 126239, '\p{^Nv=3.000000000000000e+03}', "");
    Expect(1, 126239, '\P{Nv=3.000000000000000e+03}', "");
    Expect(0, 126239, '\P{^Nv=3.000000000000000e+03}', "");
    Error('\p{Is_Numeric_Value=__0000003000/a/}');
    Error('\P{Is_Numeric_Value=__0000003000/a/}');
    Expect(1, 126238, '\p{Is_Numeric_Value=00000003000}', "");
    Expect(0, 126238, '\p{^Is_Numeric_Value=00000003000}', "");
    Expect(0, 126238, '\P{Is_Numeric_Value=00000003000}', "");
    Expect(1, 126238, '\P{^Is_Numeric_Value=00000003000}', "");
    Expect(0, 126239, '\p{Is_Numeric_Value=00000003000}', "");
    Expect(1, 126239, '\p{^Is_Numeric_Value=00000003000}', "");
    Expect(1, 126239, '\P{Is_Numeric_Value=00000003000}', "");
    Expect(0, 126239, '\P{^Is_Numeric_Value=00000003000}', "");
    Expect(1, 126238, '\p{Is_Numeric_Value=3.000000000000000e+03}', "");
    Expect(0, 126238, '\p{^Is_Numeric_Value=3.000000000000000e+03}', "");
    Expect(0, 126238, '\P{Is_Numeric_Value=3.000000000000000e+03}', "");
    Expect(1, 126238, '\P{^Is_Numeric_Value=3.000000000000000e+03}', "");
    Expect(0, 126239, '\p{Is_Numeric_Value=3.000000000000000e+03}', "");
    Expect(1, 126239, '\p{^Is_Numeric_Value=3.000000000000000e+03}', "");
    Expect(1, 126239, '\P{Is_Numeric_Value=3.000000000000000e+03}', "");
    Expect(0, 126239, '\P{^Is_Numeric_Value=3.000000000000000e+03}', "");
    Error('\p{Is_Nv=	:=+00_00_03_000}');
    Error('\P{Is_Nv=	:=+00_00_03_000}');
    Expect(1, 126238, '\p{Is_Nv=003000}', "");
    Expect(0, 126238, '\p{^Is_Nv=003000}', "");
    Expect(0, 126238, '\P{Is_Nv=003000}', "");
    Expect(1, 126238, '\P{^Is_Nv=003000}', "");
    Expect(0, 126239, '\p{Is_Nv=003000}', "");
    Expect(1, 126239, '\p{^Is_Nv=003000}', "");
    Expect(1, 126239, '\P{Is_Nv=003000}', "");
    Expect(0, 126239, '\P{^Is_Nv=003000}', "");
    Expect(1, 126238, '\p{Is_Nv=3.000000000000000e+03}', "");
    Expect(0, 126238, '\p{^Is_Nv=3.000000000000000e+03}', "");
    Expect(0, 126238, '\P{Is_Nv=3.000000000000000e+03}', "");
    Expect(1, 126238, '\P{^Is_Nv=3.000000000000000e+03}', "");
    Expect(0, 126239, '\p{Is_Nv=3.000000000000000e+03}', "");
    Expect(1, 126239, '\p{^Is_Nv=3.000000000000000e+03}', "");
    Expect(1, 126239, '\P{Is_Nv=3.000000000000000e+03}', "");
    Expect(0, 126239, '\P{^Is_Nv=3.000000000000000e+03}', "");
    Error('\p{Numeric_Value:   -_0000030000/a/}');
    Error('\P{Numeric_Value:   -_0000030000/a/}');
    Expect(1, 126247, '\p{Numeric_Value=:\A30000\z:}', "");;
    Expect(0, 126248, '\p{Numeric_Value=:\A30000\z:}', "");;
    Expect(1, 126247, '\p{Numeric_Value:   +00000000030000}', "");
    Expect(0, 126247, '\p{^Numeric_Value:   +00000000030000}', "");
    Expect(0, 126247, '\P{Numeric_Value:   +00000000030000}', "");
    Expect(1, 126247, '\P{^Numeric_Value:   +00000000030000}', "");
    Expect(0, 126248, '\p{Numeric_Value:   +00000000030000}', "");
    Expect(1, 126248, '\p{^Numeric_Value:   +00000000030000}', "");
    Expect(1, 126248, '\P{Numeric_Value:   +00000000030000}', "");
    Expect(0, 126248, '\P{^Numeric_Value:   +00000000030000}', "");
    Expect(1, 126247, '\p{Numeric_Value=3.000000000000000e+04}', "");
    Expect(0, 126247, '\p{^Numeric_Value=3.000000000000000e+04}', "");
    Expect(0, 126247, '\P{Numeric_Value=3.000000000000000e+04}', "");
    Expect(1, 126247, '\P{^Numeric_Value=3.000000000000000e+04}', "");
    Expect(0, 126248, '\p{Numeric_Value=3.000000000000000e+04}', "");
    Expect(1, 126248, '\p{^Numeric_Value=3.000000000000000e+04}', "");
    Expect(1, 126248, '\P{Numeric_Value=3.000000000000000e+04}', "");
    Expect(0, 126248, '\P{^Numeric_Value=3.000000000000000e+04}', "");
    Error('\p{Nv=/a/  0_0_0_0_3_0000}');
    Error('\P{Nv=/a/  0_0_0_0_3_0000}');
    Expect(1, 126247, '\p{Nv=:\A30000\z:}', "");;
    Expect(0, 126248, '\p{Nv=:\A30000\z:}', "");;
    Expect(1, 126247, '\p{Nv=0000000030000}', "");
    Expect(0, 126247, '\p{^Nv=0000000030000}', "");
    Expect(0, 126247, '\P{Nv=0000000030000}', "");
    Expect(1, 126247, '\P{^Nv=0000000030000}', "");
    Expect(0, 126248, '\p{Nv=0000000030000}', "");
    Expect(1, 126248, '\p{^Nv=0000000030000}', "");
    Expect(1, 126248, '\P{Nv=0000000030000}', "");
    Expect(0, 126248, '\P{^Nv=0000000030000}', "");
    Expect(1, 126247, '\p{Nv=3.000000000000000e+04}', "");
    Expect(0, 126247, '\p{^Nv=3.000000000000000e+04}', "");
    Expect(0, 126247, '\P{Nv=3.000000000000000e+04}', "");
    Expect(1, 126247, '\P{^Nv=3.000000000000000e+04}', "");
    Expect(0, 126248, '\p{Nv=3.000000000000000e+04}', "");
    Expect(1, 126248, '\p{^Nv=3.000000000000000e+04}', "");
    Expect(1, 126248, '\P{Nv=3.000000000000000e+04}', "");
    Expect(0, 126248, '\P{^Nv=3.000000000000000e+04}', "");
    Error('\p{Is_Numeric_Value: /a/_-0_0_0_3_0_0_00}');
    Error('\P{Is_Numeric_Value: /a/_-0_0_0_3_0_0_00}');
}
if (!$::TESTCHUNK or $::TESTCHUNK == 3) {
    Expect(1, 126247, '\p{Is_Numeric_Value=00030000}', "");
    Expect(0, 126247, '\p{^Is_Numeric_Value=00030000}', "");
    Expect(0, 126247, '\P{Is_Numeric_Value=00030000}', "");
    Expect(1, 126247, '\P{^Is_Numeric_Value=00030000}', "");
    Expect(0, 126248, '\p{Is_Numeric_Value=00030000}', "");
    Expect(1, 126248, '\p{^Is_Numeric_Value=00030000}', "");
    Expect(1, 126248, '\P{Is_Numeric_Value=00030000}', "");
    Expect(0, 126248, '\P{^Is_Numeric_Value=00030000}', "");
    Expect(1, 126247, '\p{Is_Numeric_Value=3.000000000000000e+04}', "");
    Expect(0, 126247, '\p{^Is_Numeric_Value=3.000000000000000e+04}', "");
    Expect(0, 126247, '\P{Is_Numeric_Value=3.000000000000000e+04}', "");
    Expect(1, 126247, '\P{^Is_Numeric_Value=3.000000000000000e+04}', "");
    Expect(0, 126248, '\p{Is_Numeric_Value=3.000000000000000e+04}', "");
    Expect(1, 126248, '\p{^Is_Numeric_Value=3.000000000000000e+04}', "");
    Expect(1, 126248, '\P{Is_Numeric_Value=3.000000000000000e+04}', "");
    Expect(0, 126248, '\P{^Is_Numeric_Value=3.000000000000000e+04}', "");
    Error('\p{Is_Nv=_:=+30000}');
    Error('\P{Is_Nv=_:=+30000}');
    Expect(1, 126247, '\p{Is_Nv=+0_0_0_0_0_0_3_0000}', "");
    Expect(0, 126247, '\p{^Is_Nv=+0_0_0_0_0_0_3_0000}', "");
    Expect(0, 126247, '\P{Is_Nv=+0_0_0_0_0_0_3_0000}', "");
    Expect(1, 126247, '\P{^Is_Nv=+0_0_0_0_0_0_3_0000}', "");
    Expect(0, 126248, '\p{Is_Nv=+0_0_0_0_0_0_3_0000}', "");
    Expect(1, 126248, '\p{^Is_Nv=+0_0_0_0_0_0_3_0000}', "");
    Expect(1, 126248, '\P{Is_Nv=+0_0_0_0_0_0_3_0000}', "");
    Expect(0, 126248, '\P{^Is_Nv=+0_0_0_0_0_0_3_0000}', "");
    Expect(1, 126247, '\p{Is_Nv=3.000000000000000e+04}', "");
    Expect(0, 126247, '\p{^Is_Nv=3.000000000000000e+04}', "");
    Expect(0, 126247, '\P{Is_Nv=3.000000000000000e+04}', "");
    Expect(1, 126247, '\P{^Is_Nv=3.000000000000000e+04}', "");
    Expect(0, 126248, '\p{Is_Nv=3.000000000000000e+04}', "");
    Expect(1, 126248, '\p{^Is_Nv=3.000000000000000e+04}', "");
    Expect(1, 126248, '\P{Is_Nv=3.000000000000000e+04}', "");
    Expect(0, 126248, '\P{^Is_Nv=3.000000000000000e+04}', "");
    Error('\p{Numeric_Value=/a/ 	000000300000}');
    Error('\P{Numeric_Value=/a/ 	000000300000}');
    Expect(1, 68079, '\p{Numeric_Value=:\A300000\z:}', "");;
    Expect(0, 68080, '\p{Numeric_Value=:\A300000\z:}', "");;
    Expect(1, 68079, '\p{Numeric_Value=0_0_3_0_0_000}', "");
    Expect(0, 68079, '\p{^Numeric_Value=0_0_3_0_0_000}', "");
    Expect(0, 68079, '\P{Numeric_Value=0_0_3_0_0_000}', "");
    Expect(1, 68079, '\P{^Numeric_Value=0_0_3_0_0_000}', "");
    Expect(0, 68080, '\p{Numeric_Value=0_0_3_0_0_000}', "");
    Expect(1, 68080, '\p{^Numeric_Value=0_0_3_0_0_000}', "");
    Expect(1, 68080, '\P{Numeric_Value=0_0_3_0_0_000}', "");
    Expect(0, 68080, '\P{^Numeric_Value=0_0_3_0_0_000}', "");
    Expect(1, 68079, '\p{Numeric_Value=3.000000000000000e+05}', "");
    Expect(0, 68079, '\p{^Numeric_Value=3.000000000000000e+05}', "");
    Expect(0, 68079, '\P{Numeric_Value=3.000000000000000e+05}', "");
    Expect(1, 68079, '\P{^Numeric_Value=3.000000000000000e+05}', "");
    Expect(0, 68080, '\p{Numeric_Value=3.000000000000000e+05}', "");
    Expect(1, 68080, '\p{^Numeric_Value=3.000000000000000e+05}', "");
    Expect(1, 68080, '\P{Numeric_Value=3.000000000000000e+05}', "");
    Expect(0, 68080, '\P{^Numeric_Value=3.000000000000000e+05}', "");
    Error('\p{Nv=:=  +030000_0}');
    Error('\P{Nv=:=  +030000_0}');
    Expect(1, 68079, '\p{Nv=:\A300000\z:}', "");;
    Expect(0, 68080, '\p{Nv=:\A300000\z:}', "");;
    Expect(1, 68079, '\p{Nv=00000300000}', "");
    Expect(0, 68079, '\p{^Nv=00000300000}', "");
    Expect(0, 68079, '\P{Nv=00000300000}', "");
    Expect(1, 68079, '\P{^Nv=00000300000}', "");
    Expect(0, 68080, '\p{Nv=00000300000}', "");
    Expect(1, 68080, '\p{^Nv=00000300000}', "");
    Expect(1, 68080, '\P{Nv=00000300000}', "");
    Expect(0, 68080, '\P{^Nv=00000300000}', "");
    Expect(1, 68079, '\p{Nv=3.000000000000000e+05}', "");
    Expect(0, 68079, '\p{^Nv=3.000000000000000e+05}', "");
    Expect(0, 68079, '\P{Nv=3.000000000000000e+05}', "");
    Expect(1, 68079, '\P{^Nv=3.000000000000000e+05}', "");
    Expect(0, 68080, '\p{Nv=3.000000000000000e+05}', "");
    Expect(1, 68080, '\p{^Nv=3.000000000000000e+05}', "");
    Expect(1, 68080, '\P{Nv=3.000000000000000e+05}', "");
    Expect(0, 68080, '\P{^Nv=3.000000000000000e+05}', "");
    Error('\p{Is_Numeric_Value=	/a/+0300000}');
    Error('\P{Is_Numeric_Value=	/a/+0300000}');
    Expect(1, 68079, '\p{Is_Numeric_Value=000300000}', "");
    Expect(0, 68079, '\p{^Is_Numeric_Value=000300000}', "");
    Expect(0, 68079, '\P{Is_Numeric_Value=000300000}', "");
    Expect(1, 68079, '\P{^Is_Numeric_Value=000300000}', "");
    Expect(0, 68080, '\p{Is_Numeric_Value=000300000}', "");
    Expect(1, 68080, '\p{^Is_Numeric_Value=000300000}', "");
    Expect(1, 68080, '\P{Is_Numeric_Value=000300000}', "");
    Expect(0, 68080, '\P{^Is_Numeric_Value=000300000}', "");
    Expect(1, 68079, '\p{Is_Numeric_Value=3.000000000000000e+05}', "");
    Expect(0, 68079, '\p{^Is_Numeric_Value=3.000000000000000e+05}', "");
    Expect(0, 68079, '\P{Is_Numeric_Value=3.000000000000000e+05}', "");
    Expect(1, 68079, '\P{^Is_Numeric_Value=3.000000000000000e+05}', "");
    Expect(0, 68080, '\p{Is_Numeric_Value=3.000000000000000e+05}', "");
    Expect(1, 68080, '\p{^Is_Numeric_Value=3.000000000000000e+05}', "");
    Expect(1, 68080, '\P{Is_Numeric_Value=3.000000000000000e+05}', "");
    Expect(0, 68080, '\P{^Is_Numeric_Value=3.000000000000000e+05}', "");
    Error('\p{Is_Nv=/a/003_000_00}');
    Error('\P{Is_Nv=/a/003_000_00}');
    Expect(1, 68079, '\p{Is_Nv=0_0_0_0_0_0_0_0_300000}', "");
    Expect(0, 68079, '\p{^Is_Nv=0_0_0_0_0_0_0_0_300000}', "");
    Expect(0, 68079, '\P{Is_Nv=0_0_0_0_0_0_0_0_300000}', "");
    Expect(1, 68079, '\P{^Is_Nv=0_0_0_0_0_0_0_0_300000}', "");
    Expect(0, 68080, '\p{Is_Nv=0_0_0_0_0_0_0_0_300000}', "");
    Expect(1, 68080, '\p{^Is_Nv=0_0_0_0_0_0_0_0_300000}', "");
    Expect(1, 68080, '\P{Is_Nv=0_0_0_0_0_0_0_0_300000}', "");
    Expect(0, 68080, '\P{^Is_Nv=0_0_0_0_0_0_0_0_300000}', "");
    Expect(1, 68079, '\p{Is_Nv=3.000000000000000e+05}', "");
    Expect(0, 68079, '\p{^Is_Nv=3.000000000000000e+05}', "");
    Expect(0, 68079, '\P{Is_Nv=3.000000000000000e+05}', "");
    Expect(1, 68079, '\P{^Is_Nv=3.000000000000000e+05}', "");
    Expect(0, 68080, '\p{Is_Nv=3.000000000000000e+05}', "");
    Expect(1, 68080, '\p{^Is_Nv=3.000000000000000e+05}', "");
    Expect(1, 68080, '\P{Is_Nv=3.000000000000000e+05}', "");
    Expect(0, 68080, '\P{^Is_Nv=3.000000000000000e+05}', "");
    Error('\p{Numeric_Value=-	0_0_0_0_0_00031:=}');
    Error('\P{Numeric_Value=-	0_0_0_0_0_00031:=}');
    Expect(1, 12891, '\p{Numeric_Value=:\A31\z:}', "");;
    Expect(0, 12892, '\p{Numeric_Value=:\A31\z:}', "");;
    Expect(1, 12891, '\p{Numeric_Value=000_003_1}', "");
    Expect(0, 12891, '\p{^Numeric_Value=000_003_1}', "");
    Expect(0, 12891, '\P{Numeric_Value=000_003_1}', "");
    Expect(1, 12891, '\P{^Numeric_Value=000_003_1}', "");
    Expect(0, 12892, '\p{Numeric_Value=000_003_1}', "");
    Expect(1, 12892, '\p{^Numeric_Value=000_003_1}', "");
    Expect(1, 12892, '\P{Numeric_Value=000_003_1}', "");
    Expect(0, 12892, '\P{^Numeric_Value=000_003_1}', "");
    Expect(1, 12891, '\p{Numeric_Value=3.100000000000000e+01}', "");
    Expect(0, 12891, '\p{^Numeric_Value=3.100000000000000e+01}', "");
    Expect(0, 12891, '\P{Numeric_Value=3.100000000000000e+01}', "");
    Expect(1, 12891, '\P{^Numeric_Value=3.100000000000000e+01}', "");
    Expect(0, 12892, '\p{Numeric_Value=3.100000000000000e+01}', "");
    Expect(1, 12892, '\p{^Numeric_Value=3.100000000000000e+01}', "");
    Expect(1, 12892, '\P{Numeric_Value=3.100000000000000e+01}', "");
    Expect(0, 12892, '\P{^Numeric_Value=3.100000000000000e+01}', "");
    Error('\p{Nv=:=_-00_03_1}');
    Error('\P{Nv=:=_-00_03_1}');
    Expect(1, 12891, '\p{Nv=:\A31\z:}', "");;
    Expect(0, 12892, '\p{Nv=:\A31\z:}', "");;
    Expect(1, 12891, '\p{Nv=+0000000031}', "");
    Expect(0, 12891, '\p{^Nv=+0000000031}', "");
    Expect(0, 12891, '\P{Nv=+0000000031}', "");
    Expect(1, 12891, '\P{^Nv=+0000000031}', "");
    Expect(0, 12892, '\p{Nv=+0000000031}', "");
    Expect(1, 12892, '\p{^Nv=+0000000031}', "");
    Expect(1, 12892, '\P{Nv=+0000000031}', "");
    Expect(0, 12892, '\P{^Nv=+0000000031}', "");
    Expect(1, 12891, '\p{Nv: 3.100000000000000e+01}', "");
    Expect(0, 12891, '\p{^Nv: 3.100000000000000e+01}', "");
    Expect(0, 12891, '\P{Nv: 3.100000000000000e+01}', "");
    Expect(1, 12891, '\P{^Nv: 3.100000000000000e+01}', "");
    Expect(0, 12892, '\p{Nv: 3.100000000000000e+01}', "");
    Expect(1, 12892, '\p{^Nv: 3.100000000000000e+01}', "");
    Expect(1, 12892, '\P{Nv: 3.100000000000000e+01}', "");
    Expect(0, 12892, '\P{^Nv: 3.100000000000000e+01}', "");
    Error('\p{Is_Numeric_Value=/a/  +0000031}');
    Error('\P{Is_Numeric_Value=/a/  +0000031}');
    Expect(1, 12891, '\p{Is_Numeric_Value=+0000031}', "");
    Expect(0, 12891, '\p{^Is_Numeric_Value=+0000031}', "");
    Expect(0, 12891, '\P{Is_Numeric_Value=+0000031}', "");
    Expect(1, 12891, '\P{^Is_Numeric_Value=+0000031}', "");
    Expect(0, 12892, '\p{Is_Numeric_Value=+0000031}', "");
    Expect(1, 12892, '\p{^Is_Numeric_Value=+0000031}', "");
    Expect(1, 12892, '\P{Is_Numeric_Value=+0000031}', "");
    Expect(0, 12892, '\P{^Is_Numeric_Value=+0000031}', "");
    Expect(1, 12891, '\p{Is_Numeric_Value=3.100000000000000e+01}', "");
    Expect(0, 12891, '\p{^Is_Numeric_Value=3.100000000000000e+01}', "");
    Expect(0, 12891, '\P{Is_Numeric_Value=3.100000000000000e+01}', "");
    Expect(1, 12891, '\P{^Is_Numeric_Value=3.100000000000000e+01}', "");
    Expect(0, 12892, '\p{Is_Numeric_Value=3.100000000000000e+01}', "");
    Expect(1, 12892, '\p{^Is_Numeric_Value=3.100000000000000e+01}', "");
    Expect(1, 12892, '\P{Is_Numeric_Value=3.100000000000000e+01}', "");
    Expect(0, 12892, '\P{^Is_Numeric_Value=3.100000000000000e+01}', "");
    Error('\p{Is_Nv=	-+31/a/}');
    Error('\P{Is_Nv=	-+31/a/}');
    Expect(1, 12891, '\p{Is_Nv=00_00_00_00_031}', "");
    Expect(0, 12891, '\p{^Is_Nv=00_00_00_00_031}', "");
    Expect(0, 12891, '\P{Is_Nv=00_00_00_00_031}', "");
    Expect(1, 12891, '\P{^Is_Nv=00_00_00_00_031}', "");
    Expect(0, 12892, '\p{Is_Nv=00_00_00_00_031}', "");
    Expect(1, 12892, '\p{^Is_Nv=00_00_00_00_031}', "");
    Expect(1, 12892, '\P{Is_Nv=00_00_00_00_031}', "");
    Expect(0, 12892, '\P{^Is_Nv=00_00_00_00_031}', "");
    Expect(1, 12891, '\p{Is_Nv=3.100000000000000e+01}', "");
    Expect(0, 12891, '\p{^Is_Nv=3.100000000000000e+01}', "");
    Expect(0, 12891, '\P{Is_Nv=3.100000000000000e+01}', "");
    Expect(1, 12891, '\P{^Is_Nv=3.100000000000000e+01}', "");
    Expect(0, 12892, '\p{Is_Nv=3.100000000000000e+01}', "");
    Expect(1, 12892, '\p{^Is_Nv=3.100000000000000e+01}', "");
    Expect(1, 12892, '\P{Is_Nv=3.100000000000000e+01}', "");
    Expect(0, 12892, '\P{^Is_Nv=3.100000000000000e+01}', "");
    Error('\p{Numeric_Value= _0032:=}');
    Error('\P{Numeric_Value= _0032:=}');
    Expect(1, 12892, '\p{Numeric_Value=:\A32\z:}', "");;
    Expect(0, 12893, '\p{Numeric_Value=:\A32\z:}', "");;
    Expect(1, 12892, '\p{Numeric_Value=+0_0_0_032}', "");
    Expect(0, 12892, '\p{^Numeric_Value=+0_0_0_032}', "");
    Expect(0, 12892, '\P{Numeric_Value=+0_0_0_032}', "");
    Expect(1, 12892, '\P{^Numeric_Value=+0_0_0_032}', "");
    Expect(0, 12893, '\p{Numeric_Value=+0_0_0_032}', "");
    Expect(1, 12893, '\p{^Numeric_Value=+0_0_0_032}', "");
    Expect(1, 12893, '\P{Numeric_Value=+0_0_0_032}', "");
    Expect(0, 12893, '\P{^Numeric_Value=+0_0_0_032}', "");
    Expect(1, 12892, '\p{Numeric_Value=3.200000000000000e+01}', "");
    Expect(0, 12892, '\p{^Numeric_Value=3.200000000000000e+01}', "");
    Expect(0, 12892, '\P{Numeric_Value=3.200000000000000e+01}', "");
    Expect(1, 12892, '\P{^Numeric_Value=3.200000000000000e+01}', "");
    Expect(0, 12893, '\p{Numeric_Value=3.200000000000000e+01}', "");
    Expect(1, 12893, '\p{^Numeric_Value=3.200000000000000e+01}', "");
    Expect(1, 12893, '\P{Numeric_Value=3.200000000000000e+01}', "");
    Expect(0, 12893, '\P{^Numeric_Value=3.200000000000000e+01}', "");
    Error('\p{Nv= /a/00_00_00_32}');
    Error('\P{Nv= /a/00_00_00_32}');
    Expect(1, 12892, '\p{Nv=:\A32\z:}', "");;
    Expect(0, 12893, '\p{Nv=:\A32\z:}', "");;
    Expect(1, 12892, '\p{Nv=000032}', "");
    Expect(0, 12892, '\p{^Nv=000032}', "");
    Expect(0, 12892, '\P{Nv=000032}', "");
    Expect(1, 12892, '\P{^Nv=000032}', "");
    Expect(0, 12893, '\p{Nv=000032}', "");
    Expect(1, 12893, '\p{^Nv=000032}', "");
    Expect(1, 12893, '\P{Nv=000032}', "");
    Expect(0, 12893, '\P{^Nv=000032}', "");
    Expect(1, 12892, '\p{Nv=3.200000000000000e+01}', "");
    Expect(0, 12892, '\p{^Nv=3.200000000000000e+01}', "");
    Expect(0, 12892, '\P{Nv=3.200000000000000e+01}', "");
    Expect(1, 12892, '\P{^Nv=3.200000000000000e+01}', "");
    Expect(0, 12893, '\p{Nv=3.200000000000000e+01}', "");
    Expect(1, 12893, '\p{^Nv=3.200000000000000e+01}', "");
    Expect(1, 12893, '\P{Nv=3.200000000000000e+01}', "");
    Expect(0, 12893, '\P{^Nv=3.200000000000000e+01}', "");
    Error('\p{Is_Numeric_Value=:=	_00_03_2}');
    Error('\P{Is_Numeric_Value=:=	_00_03_2}');
    Expect(1, 12892, '\p{Is_Numeric_Value:	000_000_003_2}', "");
    Expect(0, 12892, '\p{^Is_Numeric_Value:	000_000_003_2}', "");
    Expect(0, 12892, '\P{Is_Numeric_Value:	000_000_003_2}', "");
    Expect(1, 12892, '\P{^Is_Numeric_Value:	000_000_003_2}', "");
    Expect(0, 12893, '\p{Is_Numeric_Value:	000_000_003_2}', "");
    Expect(1, 12893, '\p{^Is_Numeric_Value:	000_000_003_2}', "");
    Expect(1, 12893, '\P{Is_Numeric_Value:	000_000_003_2}', "");
    Expect(0, 12893, '\P{^Is_Numeric_Value:	000_000_003_2}', "");
    Expect(1, 12892, '\p{Is_Numeric_Value=3.200000000000000e+01}', "");
    Expect(0, 12892, '\p{^Is_Numeric_Value=3.200000000000000e+01}', "");
    Expect(0, 12892, '\P{Is_Numeric_Value=3.200000000000000e+01}', "");
    Expect(1, 12892, '\P{^Is_Numeric_Value=3.200000000000000e+01}', "");
    Expect(0, 12893, '\p{Is_Numeric_Value=3.200000000000000e+01}', "");
    Expect(1, 12893, '\p{^Is_Numeric_Value=3.200000000000000e+01}', "");
    Expect(1, 12893, '\P{Is_Numeric_Value=3.200000000000000e+01}', "");
    Expect(0, 12893, '\P{^Is_Numeric_Value=3.200000000000000e+01}', "");
    Error('\p{Is_Nv= 	+3_2/a/}');
    Error('\P{Is_Nv= 	+3_2/a/}');
    Expect(1, 12892, '\p{Is_Nv=+000_000_003_2}', "");
    Expect(0, 12892, '\p{^Is_Nv=+000_000_003_2}', "");
    Expect(0, 12892, '\P{Is_Nv=+000_000_003_2}', "");
    Expect(1, 12892, '\P{^Is_Nv=+000_000_003_2}', "");
    Expect(0, 12893, '\p{Is_Nv=+000_000_003_2}', "");
    Expect(1, 12893, '\p{^Is_Nv=+000_000_003_2}', "");
    Expect(1, 12893, '\P{Is_Nv=+000_000_003_2}', "");
    Expect(0, 12893, '\P{^Is_Nv=+000_000_003_2}', "");
    Expect(1, 12892, '\p{Is_Nv=3.200000000000000e+01}', "");
    Expect(0, 12892, '\p{^Is_Nv=3.200000000000000e+01}', "");
    Expect(0, 12892, '\P{Is_Nv=3.200000000000000e+01}', "");
    Expect(1, 12892, '\P{^Is_Nv=3.200000000000000e+01}', "");
    Expect(0, 12893, '\p{Is_Nv=3.200000000000000e+01}', "");
    Expect(1, 12893, '\p{^Is_Nv=3.200000000000000e+01}', "");
    Expect(1, 12893, '\P{Is_Nv=3.200000000000000e+01}', "");
    Expect(0, 12893, '\P{^Is_Nv=3.200000000000000e+01}', "");
    Error('\p{Numeric_Value= 03_3:=}');
    Error('\P{Numeric_Value= 03_3:=}');
    Expect(1, 12893, '\p{Numeric_Value=:\A33\z:}', "");;
    Expect(0, 12894, '\p{Numeric_Value=:\A33\z:}', "");;
    Expect(1, 12893, '\p{Numeric_Value:	+003_3}', "");
    Expect(0, 12893, '\p{^Numeric_Value:	+003_3}', "");
    Expect(0, 12893, '\P{Numeric_Value:	+003_3}', "");
    Expect(1, 12893, '\P{^Numeric_Value:	+003_3}', "");
    Expect(0, 12894, '\p{Numeric_Value:	+003_3}', "");
    Expect(1, 12894, '\p{^Numeric_Value:	+003_3}', "");
    Expect(1, 12894, '\P{Numeric_Value:	+003_3}', "");
    Expect(0, 12894, '\P{^Numeric_Value:	+003_3}', "");
    Expect(1, 12893, '\p{Numeric_Value=3.300000000000000e+01}', "");
    Expect(0, 12893, '\p{^Numeric_Value=3.300000000000000e+01}', "");
    Expect(0, 12893, '\P{Numeric_Value=3.300000000000000e+01}', "");
    Expect(1, 12893, '\P{^Numeric_Value=3.300000000000000e+01}', "");
    Expect(0, 12894, '\p{Numeric_Value=3.300000000000000e+01}', "");
    Expect(1, 12894, '\p{^Numeric_Value=3.300000000000000e+01}', "");
    Expect(1, 12894, '\P{Numeric_Value=3.300000000000000e+01}', "");
    Expect(0, 12894, '\P{^Numeric_Value=3.300000000000000e+01}', "");
    Error('\p{Nv=_:=+00_00_33}');
    Error('\P{Nv=_:=+00_00_33}');
    Expect(1, 12893, '\p{Nv=:\A33\z:}', "");;
    Expect(0, 12894, '\p{Nv=:\A33\z:}', "");;
    Expect(1, 12893, '\p{Nv=000033}', "");
    Expect(0, 12893, '\p{^Nv=000033}', "");
    Expect(0, 12893, '\P{Nv=000033}', "");
    Expect(1, 12893, '\P{^Nv=000033}', "");
    Expect(0, 12894, '\p{Nv=000033}', "");
    Expect(1, 12894, '\p{^Nv=000033}', "");
    Expect(1, 12894, '\P{Nv=000033}', "");
    Expect(0, 12894, '\P{^Nv=000033}', "");
    Expect(1, 12893, '\p{Nv=3.300000000000000e+01}', "");
    Expect(0, 12893, '\p{^Nv=3.300000000000000e+01}', "");
    Expect(0, 12893, '\P{Nv=3.300000000000000e+01}', "");
    Expect(1, 12893, '\P{^Nv=3.300000000000000e+01}', "");
    Expect(0, 12894, '\p{Nv=3.300000000000000e+01}', "");
    Expect(1, 12894, '\p{^Nv=3.300000000000000e+01}', "");
    Expect(1, 12894, '\P{Nv=3.300000000000000e+01}', "");
    Expect(0, 12894, '\P{^Nv=3.300000000000000e+01}', "");
    Error('\p{Is_Numeric_Value=/a/	 0_0_0_0_0_0_0_0_33}');
    Error('\P{Is_Numeric_Value=/a/	 0_0_0_0_0_0_0_0_33}');
    Expect(1, 12893, '\p{Is_Numeric_Value=0033}', "");
    Expect(0, 12893, '\p{^Is_Numeric_Value=0033}', "");
    Expect(0, 12893, '\P{Is_Numeric_Value=0033}', "");
    Expect(1, 12893, '\P{^Is_Numeric_Value=0033}', "");
    Expect(0, 12894, '\p{Is_Numeric_Value=0033}', "");
    Expect(1, 12894, '\p{^Is_Numeric_Value=0033}', "");
    Expect(1, 12894, '\P{Is_Numeric_Value=0033}', "");
    Expect(0, 12894, '\P{^Is_Numeric_Value=0033}', "");
    Expect(1, 12893, '\p{Is_Numeric_Value:3.300000000000000e+01}', "");
    Expect(0, 12893, '\p{^Is_Numeric_Value:3.300000000000000e+01}', "");
    Expect(0, 12893, '\P{Is_Numeric_Value:3.300000000000000e+01}', "");
    Expect(1, 12893, '\P{^Is_Numeric_Value:3.300000000000000e+01}', "");
    Expect(0, 12894, '\p{Is_Numeric_Value:3.300000000000000e+01}', "");
    Expect(1, 12894, '\p{^Is_Numeric_Value:3.300000000000000e+01}', "");
    Expect(1, 12894, '\P{Is_Numeric_Value:3.300000000000000e+01}', "");
    Expect(0, 12894, '\P{^Is_Numeric_Value:3.300000000000000e+01}', "");
    Error('\p{Is_Nv=/a/_00033}');
    Error('\P{Is_Nv=/a/_00033}');
    Expect(1, 12893, '\p{Is_Nv=+0000000033}', "");
    Expect(0, 12893, '\p{^Is_Nv=+0000000033}', "");
    Expect(0, 12893, '\P{Is_Nv=+0000000033}', "");
    Expect(1, 12893, '\P{^Is_Nv=+0000000033}', "");
    Expect(0, 12894, '\p{Is_Nv=+0000000033}', "");
    Expect(1, 12894, '\p{^Is_Nv=+0000000033}', "");
    Expect(1, 12894, '\P{Is_Nv=+0000000033}', "");
    Expect(0, 12894, '\P{^Is_Nv=+0000000033}', "");
    Expect(1, 12893, '\p{Is_Nv=3.300000000000000e+01}', "");
    Expect(0, 12893, '\p{^Is_Nv=3.300000000000000e+01}', "");
    Expect(0, 12893, '\P{Is_Nv=3.300000000000000e+01}', "");
    Expect(1, 12893, '\P{^Is_Nv=3.300000000000000e+01}', "");
    Expect(0, 12894, '\p{Is_Nv=3.300000000000000e+01}', "");
    Expect(1, 12894, '\p{^Is_Nv=3.300000000000000e+01}', "");
    Expect(1, 12894, '\P{Is_Nv=3.300000000000000e+01}', "");
    Expect(0, 12894, '\P{^Is_Nv=3.300000000000000e+01}', "");
    Error('\p{Numeric_Value=:=	_0_0_0_0_0_0_0034}');
    Error('\P{Numeric_Value=:=	_0_0_0_0_0_0_0034}');
    Expect(1, 12894, '\p{Numeric_Value=:\A34\z:}', "");;
    Expect(0, 12895, '\p{Numeric_Value=:\A34\z:}', "");;
    Expect(1, 12894, '\p{Numeric_Value:   00000034}', "");
    Expect(0, 12894, '\p{^Numeric_Value:   00000034}', "");
    Expect(0, 12894, '\P{Numeric_Value:   00000034}', "");
    Expect(1, 12894, '\P{^Numeric_Value:   00000034}', "");
    Expect(0, 12895, '\p{Numeric_Value:   00000034}', "");
    Expect(1, 12895, '\p{^Numeric_Value:   00000034}', "");
    Expect(1, 12895, '\P{Numeric_Value:   00000034}', "");
    Expect(0, 12895, '\P{^Numeric_Value:   00000034}', "");
    Expect(1, 12894, '\p{Numeric_Value=3.400000000000000e+01}', "");
    Expect(0, 12894, '\p{^Numeric_Value=3.400000000000000e+01}', "");
    Expect(0, 12894, '\P{Numeric_Value=3.400000000000000e+01}', "");
    Expect(1, 12894, '\P{^Numeric_Value=3.400000000000000e+01}', "");
    Expect(0, 12895, '\p{Numeric_Value=3.400000000000000e+01}', "");
    Expect(1, 12895, '\p{^Numeric_Value=3.400000000000000e+01}', "");
    Expect(1, 12895, '\P{Numeric_Value=3.400000000000000e+01}', "");
    Expect(0, 12895, '\P{^Numeric_Value=3.400000000000000e+01}', "");
    Error('\p{Nv=:=_-00034}');
    Error('\P{Nv=:=_-00034}');
    Expect(1, 12894, '\p{Nv=:\A34\z:}', "");;
    Expect(0, 12895, '\p{Nv=:\A34\z:}', "");;
    Expect(1, 12894, '\p{Nv=00_00_00_00_034}', "");
    Expect(0, 12894, '\p{^Nv=00_00_00_00_034}', "");
    Expect(0, 12894, '\P{Nv=00_00_00_00_034}', "");
    Expect(1, 12894, '\P{^Nv=00_00_00_00_034}', "");
    Expect(0, 12895, '\p{Nv=00_00_00_00_034}', "");
    Expect(1, 12895, '\p{^Nv=00_00_00_00_034}', "");
    Expect(1, 12895, '\P{Nv=00_00_00_00_034}', "");
    Expect(0, 12895, '\P{^Nv=00_00_00_00_034}', "");
    Expect(1, 12894, '\p{Nv:3.400000000000000e+01}', "");
    Expect(0, 12894, '\p{^Nv:3.400000000000000e+01}', "");
    Expect(0, 12894, '\P{Nv:3.400000000000000e+01}', "");
    Expect(1, 12894, '\P{^Nv:3.400000000000000e+01}', "");
    Expect(0, 12895, '\p{Nv:3.400000000000000e+01}', "");
    Expect(1, 12895, '\p{^Nv:3.400000000000000e+01}', "");
    Expect(1, 12895, '\P{Nv:3.400000000000000e+01}', "");
    Expect(0, 12895, '\P{^Nv:3.400000000000000e+01}', "");
    Error('\p{Is_Numeric_Value=/a/--+3_4}');
    Error('\P{Is_Numeric_Value=/a/--+3_4}');
    Expect(1, 12894, '\p{Is_Numeric_Value=00_03_4}', "");
    Expect(0, 12894, '\p{^Is_Numeric_Value=00_03_4}', "");
    Expect(0, 12894, '\P{Is_Numeric_Value=00_03_4}', "");
    Expect(1, 12894, '\P{^Is_Numeric_Value=00_03_4}', "");
    Expect(0, 12895, '\p{Is_Numeric_Value=00_03_4}', "");
    Expect(1, 12895, '\p{^Is_Numeric_Value=00_03_4}', "");
    Expect(1, 12895, '\P{Is_Numeric_Value=00_03_4}', "");
    Expect(0, 12895, '\P{^Is_Numeric_Value=00_03_4}', "");
    Expect(1, 12894, '\p{Is_Numeric_Value=3.400000000000000e+01}', "");
    Expect(0, 12894, '\p{^Is_Numeric_Value=3.400000000000000e+01}', "");
    Expect(0, 12894, '\P{Is_Numeric_Value=3.400000000000000e+01}', "");
    Expect(1, 12894, '\P{^Is_Numeric_Value=3.400000000000000e+01}', "");
    Expect(0, 12895, '\p{Is_Numeric_Value=3.400000000000000e+01}', "");
    Expect(1, 12895, '\p{^Is_Numeric_Value=3.400000000000000e+01}', "");
    Expect(1, 12895, '\P{Is_Numeric_Value=3.400000000000000e+01}', "");
    Expect(0, 12895, '\P{^Is_Numeric_Value=3.400000000000000e+01}', "");
    Error('\p{Is_Nv=/a/ 0_0_0_34}');
    Error('\P{Is_Nv=/a/ 0_0_0_34}');
    Expect(1, 12894, '\p{Is_Nv=00_00_00_03_4}', "");
    Expect(0, 12894, '\p{^Is_Nv=00_00_00_03_4}', "");
    Expect(0, 12894, '\P{Is_Nv=00_00_00_03_4}', "");
    Expect(1, 12894, '\P{^Is_Nv=00_00_00_03_4}', "");
    Expect(0, 12895, '\p{Is_Nv=00_00_00_03_4}', "");
    Expect(1, 12895, '\p{^Is_Nv=00_00_00_03_4}', "");
    Expect(1, 12895, '\P{Is_Nv=00_00_00_03_4}', "");
    Expect(0, 12895, '\P{^Is_Nv=00_00_00_03_4}', "");
    Expect(1, 12894, '\p{Is_Nv=3.400000000000000e+01}', "");
    Expect(0, 12894, '\p{^Is_Nv=3.400000000000000e+01}', "");
    Expect(0, 12894, '\P{Is_Nv=3.400000000000000e+01}', "");
    Expect(1, 12894, '\P{^Is_Nv=3.400000000000000e+01}', "");
    Expect(0, 12895, '\p{Is_Nv=3.400000000000000e+01}', "");
    Expect(1, 12895, '\p{^Is_Nv=3.400000000000000e+01}', "");
    Expect(1, 12895, '\P{Is_Nv=3.400000000000000e+01}', "");
    Expect(0, 12895, '\P{^Is_Nv=3.400000000000000e+01}', "");
    Error('\p{Numeric_Value=_+000000035/a/}');
    Error('\P{Numeric_Value=_+000000035/a/}');
    Expect(1, 12895, '\p{Numeric_Value=:\A35\z:}', "");;
    Expect(0, 12896, '\p{Numeric_Value=:\A35\z:}', "");;
    Expect(1, 12895, '\p{Numeric_Value=+00003_5}', "");
    Expect(0, 12895, '\p{^Numeric_Value=+00003_5}', "");
    Expect(0, 12895, '\P{Numeric_Value=+00003_5}', "");
    Expect(1, 12895, '\P{^Numeric_Value=+00003_5}', "");
    Expect(0, 12896, '\p{Numeric_Value=+00003_5}', "");
    Expect(1, 12896, '\p{^Numeric_Value=+00003_5}', "");
    Expect(1, 12896, '\P{Numeric_Value=+00003_5}', "");
    Expect(0, 12896, '\P{^Numeric_Value=+00003_5}', "");
    Expect(1, 12895, '\p{Numeric_Value=3.500000000000000e+01}', "");
    Expect(0, 12895, '\p{^Numeric_Value=3.500000000000000e+01}', "");
    Expect(0, 12895, '\P{Numeric_Value=3.500000000000000e+01}', "");
    Expect(1, 12895, '\P{^Numeric_Value=3.500000000000000e+01}', "");
    Expect(0, 12896, '\p{Numeric_Value=3.500000000000000e+01}', "");
    Expect(1, 12896, '\p{^Numeric_Value=3.500000000000000e+01}', "");
    Expect(1, 12896, '\P{Numeric_Value=3.500000000000000e+01}', "");
    Expect(0, 12896, '\P{^Numeric_Value=3.500000000000000e+01}', "");
    Error('\p{Nv=/a/ 000003_5}');
    Error('\P{Nv=/a/ 000003_5}');
    Expect(1, 12895, '\p{Nv=:\A35\z:}', "");;
    Expect(0, 12896, '\p{Nv=:\A35\z:}', "");;
    Expect(1, 12895, '\p{Nv=3_5}', "");
    Expect(0, 12895, '\p{^Nv=3_5}', "");
    Expect(0, 12895, '\P{Nv=3_5}', "");
    Expect(1, 12895, '\P{^Nv=3_5}', "");
    Expect(0, 12896, '\p{Nv=3_5}', "");
    Expect(1, 12896, '\p{^Nv=3_5}', "");
    Expect(1, 12896, '\P{Nv=3_5}', "");
    Expect(0, 12896, '\P{^Nv=3_5}', "");
    Expect(1, 12895, '\p{Nv=3.500000000000000e+01}', "");
    Expect(0, 12895, '\p{^Nv=3.500000000000000e+01}', "");
    Expect(0, 12895, '\P{Nv=3.500000000000000e+01}', "");
    Expect(1, 12895, '\P{^Nv=3.500000000000000e+01}', "");
    Expect(0, 12896, '\p{Nv=3.500000000000000e+01}', "");
    Expect(1, 12896, '\p{^Nv=3.500000000000000e+01}', "");
    Expect(1, 12896, '\P{Nv=3.500000000000000e+01}', "");
    Expect(0, 12896, '\P{^Nv=3.500000000000000e+01}', "");
    Error('\p{Is_Numeric_Value= _+0_0_0_0_0_0_0_0_0_35:=}');
    Error('\P{Is_Numeric_Value= _+0_0_0_0_0_0_0_0_0_35:=}');
    Expect(1, 12895, '\p{Is_Numeric_Value=000000035}', "");
    Expect(0, 12895, '\p{^Is_Numeric_Value=000000035}', "");
    Expect(0, 12895, '\P{Is_Numeric_Value=000000035}', "");
    Expect(1, 12895, '\P{^Is_Numeric_Value=000000035}', "");
    Expect(0, 12896, '\p{Is_Numeric_Value=000000035}', "");
    Expect(1, 12896, '\p{^Is_Numeric_Value=000000035}', "");
    Expect(1, 12896, '\P{Is_Numeric_Value=000000035}', "");
    Expect(0, 12896, '\P{^Is_Numeric_Value=000000035}', "");
    Expect(1, 12895, '\p{Is_Numeric_Value=3.500000000000000e+01}', "");
    Expect(0, 12895, '\p{^Is_Numeric_Value=3.500000000000000e+01}', "");
    Expect(0, 12895, '\P{Is_Numeric_Value=3.500000000000000e+01}', "");
    Expect(1, 12895, '\P{^Is_Numeric_Value=3.500000000000000e+01}', "");
    Expect(0, 12896, '\p{Is_Numeric_Value=3.500000000000000e+01}', "");
    Expect(1, 12896, '\p{^Is_Numeric_Value=3.500000000000000e+01}', "");
    Expect(1, 12896, '\P{Is_Numeric_Value=3.500000000000000e+01}', "");
    Expect(0, 12896, '\P{^Is_Numeric_Value=3.500000000000000e+01}', "");
    Error('\p{Is_Nv= /a/000000035}');
    Error('\P{Is_Nv= /a/000000035}');
    Expect(1, 12895, '\p{Is_Nv=0_0_0_0_0_0035}', "");
    Expect(0, 12895, '\p{^Is_Nv=0_0_0_0_0_0035}', "");
    Expect(0, 12895, '\P{Is_Nv=0_0_0_0_0_0035}', "");
    Expect(1, 12895, '\P{^Is_Nv=0_0_0_0_0_0035}', "");
    Expect(0, 12896, '\p{Is_Nv=0_0_0_0_0_0035}', "");
    Expect(1, 12896, '\p{^Is_Nv=0_0_0_0_0_0035}', "");
    Expect(1, 12896, '\P{Is_Nv=0_0_0_0_0_0035}', "");
    Expect(0, 12896, '\P{^Is_Nv=0_0_0_0_0_0035}', "");
    Expect(1, 12895, '\p{Is_Nv=3.500000000000000e+01}', "");
    Expect(0, 12895, '\p{^Is_Nv=3.500000000000000e+01}', "");
    Expect(0, 12895, '\P{Is_Nv=3.500000000000000e+01}', "");
    Expect(1, 12895, '\P{^Is_Nv=3.500000000000000e+01}', "");
    Expect(0, 12896, '\p{Is_Nv=3.500000000000000e+01}', "");
    Expect(1, 12896, '\p{^Is_Nv=3.500000000000000e+01}', "");
    Expect(1, 12896, '\P{Is_Nv=3.500000000000000e+01}', "");
    Expect(0, 12896, '\P{^Is_Nv=3.500000000000000e+01}', "");
    Error('\p{Numeric_Value=	:=+00036}');
    Error('\P{Numeric_Value=	:=+00036}');
    Expect(1, 12977, '\p{Numeric_Value=:\A36\z:}', "");;
    Expect(0, 12978, '\p{Numeric_Value=:\A36\z:}', "");;
    Expect(1, 12977, '\p{Numeric_Value:   +00036}', "");
    Expect(0, 12977, '\p{^Numeric_Value:   +00036}', "");
    Expect(0, 12977, '\P{Numeric_Value:   +00036}', "");
    Expect(1, 12977, '\P{^Numeric_Value:   +00036}', "");
    Expect(0, 12978, '\p{Numeric_Value:   +00036}', "");
    Expect(1, 12978, '\p{^Numeric_Value:   +00036}', "");
    Expect(1, 12978, '\P{Numeric_Value:   +00036}', "");
    Expect(0, 12978, '\P{^Numeric_Value:   +00036}', "");
    Expect(1, 12977, '\p{Numeric_Value=3.600000000000000e+01}', "");
    Expect(0, 12977, '\p{^Numeric_Value=3.600000000000000e+01}', "");
    Expect(0, 12977, '\P{Numeric_Value=3.600000000000000e+01}', "");
    Expect(1, 12977, '\P{^Numeric_Value=3.600000000000000e+01}', "");
    Expect(0, 12978, '\p{Numeric_Value=3.600000000000000e+01}', "");
    Expect(1, 12978, '\p{^Numeric_Value=3.600000000000000e+01}', "");
    Expect(1, 12978, '\P{Numeric_Value=3.600000000000000e+01}', "");
    Expect(0, 12978, '\P{^Numeric_Value=3.600000000000000e+01}', "");
    Error('\p{Nv=_/a/0000036}');
    Error('\P{Nv=_/a/0000036}');
    Expect(1, 12977, '\p{Nv=:\A36\z:}', "");;
    Expect(0, 12978, '\p{Nv=:\A36\z:}', "");;
    Expect(1, 12977, '\p{Nv=00036}', "");
    Expect(0, 12977, '\p{^Nv=00036}', "");
    Expect(0, 12977, '\P{Nv=00036}', "");
    Expect(1, 12977, '\P{^Nv=00036}', "");
    Expect(0, 12978, '\p{Nv=00036}', "");
    Expect(1, 12978, '\p{^Nv=00036}', "");
    Expect(1, 12978, '\P{Nv=00036}', "");
    Expect(0, 12978, '\P{^Nv=00036}', "");
    Expect(1, 12977, '\p{Nv=3.600000000000000e+01}', "");
    Expect(0, 12977, '\p{^Nv=3.600000000000000e+01}', "");
    Expect(0, 12977, '\P{Nv=3.600000000000000e+01}', "");
    Expect(1, 12977, '\P{^Nv=3.600000000000000e+01}', "");
    Expect(0, 12978, '\p{Nv=3.600000000000000e+01}', "");
    Expect(1, 12978, '\p{^Nv=3.600000000000000e+01}', "");
    Expect(1, 12978, '\P{Nv=3.600000000000000e+01}', "");
    Expect(0, 12978, '\P{^Nv=3.600000000000000e+01}', "");
    Error('\p{Is_Numeric_Value=/a/+0000036}');
    Error('\P{Is_Numeric_Value=/a/+0000036}');
    Expect(1, 12977, '\p{Is_Numeric_Value=3_6}', "");
    Expect(0, 12977, '\p{^Is_Numeric_Value=3_6}', "");
    Expect(0, 12977, '\P{Is_Numeric_Value=3_6}', "");
    Expect(1, 12977, '\P{^Is_Numeric_Value=3_6}', "");
    Expect(0, 12978, '\p{Is_Numeric_Value=3_6}', "");
    Expect(1, 12978, '\p{^Is_Numeric_Value=3_6}', "");
    Expect(1, 12978, '\P{Is_Numeric_Value=3_6}', "");
    Expect(0, 12978, '\P{^Is_Numeric_Value=3_6}', "");
    Expect(1, 12977, '\p{Is_Numeric_Value:   3.600000000000000e+01}', "");
    Expect(0, 12977, '\p{^Is_Numeric_Value:   3.600000000000000e+01}', "");
    Expect(0, 12977, '\P{Is_Numeric_Value:   3.600000000000000e+01}', "");
    Expect(1, 12977, '\P{^Is_Numeric_Value:   3.600000000000000e+01}', "");
    Expect(0, 12978, '\p{Is_Numeric_Value:   3.600000000000000e+01}', "");
    Expect(1, 12978, '\p{^Is_Numeric_Value:   3.600000000000000e+01}', "");
    Expect(1, 12978, '\P{Is_Numeric_Value:   3.600000000000000e+01}', "");
    Expect(0, 12978, '\P{^Is_Numeric_Value:   3.600000000000000e+01}', "");
    Error('\p{Is_Nv=:=	 000036}');
    Error('\P{Is_Nv=:=	 000036}');
    Expect(1, 12977, '\p{Is_Nv=00_00_36}', "");
    Expect(0, 12977, '\p{^Is_Nv=00_00_36}', "");
    Expect(0, 12977, '\P{Is_Nv=00_00_36}', "");
    Expect(1, 12977, '\P{^Is_Nv=00_00_36}', "");
    Expect(0, 12978, '\p{Is_Nv=00_00_36}', "");
    Expect(1, 12978, '\p{^Is_Nv=00_00_36}', "");
    Expect(1, 12978, '\P{Is_Nv=00_00_36}', "");
    Expect(0, 12978, '\P{^Is_Nv=00_00_36}', "");
    Expect(1, 12977, '\p{Is_Nv=3.600000000000000e+01}', "");
    Expect(0, 12977, '\p{^Is_Nv=3.600000000000000e+01}', "");
    Expect(0, 12977, '\P{Is_Nv=3.600000000000000e+01}', "");
    Expect(1, 12977, '\P{^Is_Nv=3.600000000000000e+01}', "");
    Expect(0, 12978, '\p{Is_Nv=3.600000000000000e+01}', "");
    Expect(1, 12978, '\p{^Is_Nv=3.600000000000000e+01}', "");
    Expect(1, 12978, '\P{Is_Nv=3.600000000000000e+01}', "");
    Expect(0, 12978, '\P{^Is_Nv=3.600000000000000e+01}', "");
    Error('\p{Numeric_Value=/a/_	0000000037}');
    Error('\P{Numeric_Value=/a/_	0000000037}');
    Expect(1, 12978, '\p{Numeric_Value=:\A37\z:}', "");;
    Expect(0, 12979, '\p{Numeric_Value=:\A37\z:}', "");;
    Expect(1, 12978, '\p{Numeric_Value=0003_7}', "");
    Expect(0, 12978, '\p{^Numeric_Value=0003_7}', "");
    Expect(0, 12978, '\P{Numeric_Value=0003_7}', "");
    Expect(1, 12978, '\P{^Numeric_Value=0003_7}', "");
    Expect(0, 12979, '\p{Numeric_Value=0003_7}', "");
    Expect(1, 12979, '\p{^Numeric_Value=0003_7}', "");
    Expect(1, 12979, '\P{Numeric_Value=0003_7}', "");
    Expect(0, 12979, '\P{^Numeric_Value=0003_7}', "");
    Expect(1, 12978, '\p{Numeric_Value=3.700000000000000e+01}', "");
    Expect(0, 12978, '\p{^Numeric_Value=3.700000000000000e+01}', "");
    Expect(0, 12978, '\P{Numeric_Value=3.700000000000000e+01}', "");
    Expect(1, 12978, '\P{^Numeric_Value=3.700000000000000e+01}', "");
    Expect(0, 12979, '\p{Numeric_Value=3.700000000000000e+01}', "");
    Expect(1, 12979, '\p{^Numeric_Value=3.700000000000000e+01}', "");
    Expect(1, 12979, '\P{Numeric_Value=3.700000000000000e+01}', "");
    Expect(0, 12979, '\P{^Numeric_Value=3.700000000000000e+01}', "");
    Error('\p{Nv=		00037:=}');
    Error('\P{Nv=		00037:=}');
    Expect(1, 12978, '\p{Nv=:\A37\z:}', "");;
    Expect(0, 12979, '\p{Nv=:\A37\z:}', "");;
    Expect(1, 12978, '\p{Nv=000000037}', "");
    Expect(0, 12978, '\p{^Nv=000000037}', "");
    Expect(0, 12978, '\P{Nv=000000037}', "");
    Expect(1, 12978, '\P{^Nv=000000037}', "");
    Expect(0, 12979, '\p{Nv=000000037}', "");
    Expect(1, 12979, '\p{^Nv=000000037}', "");
    Expect(1, 12979, '\P{Nv=000000037}', "");
    Expect(0, 12979, '\P{^Nv=000000037}', "");
    Expect(1, 12978, '\p{Nv=3.700000000000000e+01}', "");
    Expect(0, 12978, '\p{^Nv=3.700000000000000e+01}', "");
    Expect(0, 12978, '\P{Nv=3.700000000000000e+01}', "");
    Expect(1, 12978, '\P{^Nv=3.700000000000000e+01}', "");
    Expect(0, 12979, '\p{Nv=3.700000000000000e+01}', "");
    Expect(1, 12979, '\p{^Nv=3.700000000000000e+01}', "");
    Expect(1, 12979, '\P{Nv=3.700000000000000e+01}', "");
    Expect(0, 12979, '\P{^Nv=3.700000000000000e+01}', "");
    Error('\p{Is_Numeric_Value=--000000037/a/}');
    Error('\P{Is_Numeric_Value=--000000037/a/}');
    Expect(1, 12978, '\p{Is_Numeric_Value=000037}', "");
    Expect(0, 12978, '\p{^Is_Numeric_Value=000037}', "");
    Expect(0, 12978, '\P{Is_Numeric_Value=000037}', "");
    Expect(1, 12978, '\P{^Is_Numeric_Value=000037}', "");
    Expect(0, 12979, '\p{Is_Numeric_Value=000037}', "");
    Expect(1, 12979, '\p{^Is_Numeric_Value=000037}', "");
    Expect(1, 12979, '\P{Is_Numeric_Value=000037}', "");
    Expect(0, 12979, '\P{^Is_Numeric_Value=000037}', "");
    Expect(1, 12978, '\p{Is_Numeric_Value=3.700000000000000e+01}', "");
    Expect(0, 12978, '\p{^Is_Numeric_Value=3.700000000000000e+01}', "");
    Expect(0, 12978, '\P{Is_Numeric_Value=3.700000000000000e+01}', "");
    Expect(1, 12978, '\P{^Is_Numeric_Value=3.700000000000000e+01}', "");
    Expect(0, 12979, '\p{Is_Numeric_Value=3.700000000000000e+01}', "");
    Expect(1, 12979, '\p{^Is_Numeric_Value=3.700000000000000e+01}', "");
    Expect(1, 12979, '\P{Is_Numeric_Value=3.700000000000000e+01}', "");
    Expect(0, 12979, '\P{^Is_Numeric_Value=3.700000000000000e+01}', "");
    Error('\p{Is_Nv= /a/00000000037}');
    Error('\P{Is_Nv= /a/00000000037}');
    Expect(1, 12978, '\p{Is_Nv=0000000037}', "");
    Expect(0, 12978, '\p{^Is_Nv=0000000037}', "");
    Expect(0, 12978, '\P{Is_Nv=0000000037}', "");
    Expect(1, 12978, '\P{^Is_Nv=0000000037}', "");
    Expect(0, 12979, '\p{Is_Nv=0000000037}', "");
    Expect(1, 12979, '\p{^Is_Nv=0000000037}', "");
    Expect(1, 12979, '\P{Is_Nv=0000000037}', "");
    Expect(0, 12979, '\P{^Is_Nv=0000000037}', "");
    Expect(1, 12978, '\p{Is_Nv:	3.700000000000000e+01}', "");
    Expect(0, 12978, '\p{^Is_Nv:	3.700000000000000e+01}', "");
    Expect(0, 12978, '\P{Is_Nv:	3.700000000000000e+01}', "");
    Expect(1, 12978, '\P{^Is_Nv:	3.700000000000000e+01}', "");
    Expect(0, 12979, '\p{Is_Nv:	3.700000000000000e+01}', "");
    Expect(1, 12979, '\p{^Is_Nv:	3.700000000000000e+01}', "");
    Expect(1, 12979, '\P{Is_Nv:	3.700000000000000e+01}', "");
    Expect(0, 12979, '\P{^Is_Nv:	3.700000000000000e+01}', "");
    Error('\p{Numeric_Value=_	00_00_00_03_8:=}');
    Error('\P{Numeric_Value=_	00_00_00_03_8:=}');
    Expect(1, 12979, '\p{Numeric_Value=:\A38\z:}', "");;
    Expect(0, 12980, '\p{Numeric_Value=:\A38\z:}', "");;
    Expect(1, 12979, '\p{Numeric_Value=+000_003_8}', "");
    Expect(0, 12979, '\p{^Numeric_Value=+000_003_8}', "");
    Expect(0, 12979, '\P{Numeric_Value=+000_003_8}', "");
    Expect(1, 12979, '\P{^Numeric_Value=+000_003_8}', "");
    Expect(0, 12980, '\p{Numeric_Value=+000_003_8}', "");
    Expect(1, 12980, '\p{^Numeric_Value=+000_003_8}', "");
    Expect(1, 12980, '\P{Numeric_Value=+000_003_8}', "");
    Expect(0, 12980, '\P{^Numeric_Value=+000_003_8}', "");
    Expect(1, 12979, '\p{Numeric_Value=3.800000000000000e+01}', "");
    Expect(0, 12979, '\p{^Numeric_Value=3.800000000000000e+01}', "");
    Expect(0, 12979, '\P{Numeric_Value=3.800000000000000e+01}', "");
    Expect(1, 12979, '\P{^Numeric_Value=3.800000000000000e+01}', "");
    Expect(0, 12980, '\p{Numeric_Value=3.800000000000000e+01}', "");
    Expect(1, 12980, '\p{^Numeric_Value=3.800000000000000e+01}', "");
    Expect(1, 12980, '\P{Numeric_Value=3.800000000000000e+01}', "");
    Expect(0, 12980, '\P{^Numeric_Value=3.800000000000000e+01}', "");
    Error('\p{Nv:	/a/+0000_0000_38}');
    Error('\P{Nv:	/a/+0000_0000_38}');
    Expect(1, 12979, '\p{Nv=:\A38\z:}', "");;
    Expect(0, 12980, '\p{Nv=:\A38\z:}', "");;
    Expect(1, 12979, '\p{Nv=0000038}', "");
    Expect(0, 12979, '\p{^Nv=0000038}', "");
    Expect(0, 12979, '\P{Nv=0000038}', "");
    Expect(1, 12979, '\P{^Nv=0000038}', "");
    Expect(0, 12980, '\p{Nv=0000038}', "");
    Expect(1, 12980, '\p{^Nv=0000038}', "");
    Expect(1, 12980, '\P{Nv=0000038}', "");
    Expect(0, 12980, '\P{^Nv=0000038}', "");
    Expect(1, 12979, '\p{Nv=3.800000000000000e+01}', "");
    Expect(0, 12979, '\p{^Nv=3.800000000000000e+01}', "");
    Expect(0, 12979, '\P{Nv=3.800000000000000e+01}', "");
    Expect(1, 12979, '\P{^Nv=3.800000000000000e+01}', "");
    Expect(0, 12980, '\p{Nv=3.800000000000000e+01}', "");
    Expect(1, 12980, '\p{^Nv=3.800000000000000e+01}', "");
    Expect(1, 12980, '\P{Nv=3.800000000000000e+01}', "");
    Expect(0, 12980, '\P{^Nv=3.800000000000000e+01}', "");
    Error('\p{Is_Numeric_Value=/a/ -0_0_0_0_38}');
    Error('\P{Is_Numeric_Value=/a/ -0_0_0_0_38}');
    Expect(1, 12979, '\p{Is_Numeric_Value=+03_8}', "");
    Expect(0, 12979, '\p{^Is_Numeric_Value=+03_8}', "");
    Expect(0, 12979, '\P{Is_Numeric_Value=+03_8}', "");
    Expect(1, 12979, '\P{^Is_Numeric_Value=+03_8}', "");
    Expect(0, 12980, '\p{Is_Numeric_Value=+03_8}', "");
    Expect(1, 12980, '\p{^Is_Numeric_Value=+03_8}', "");
    Expect(1, 12980, '\P{Is_Numeric_Value=+03_8}', "");
    Expect(0, 12980, '\P{^Is_Numeric_Value=+03_8}', "");
    Expect(1, 12979, '\p{Is_Numeric_Value=3.800000000000000e+01}', "");
    Expect(0, 12979, '\p{^Is_Numeric_Value=3.800000000000000e+01}', "");
    Expect(0, 12979, '\P{Is_Numeric_Value=3.800000000000000e+01}', "");
    Expect(1, 12979, '\P{^Is_Numeric_Value=3.800000000000000e+01}', "");
    Expect(0, 12980, '\p{Is_Numeric_Value=3.800000000000000e+01}', "");
    Expect(1, 12980, '\p{^Is_Numeric_Value=3.800000000000000e+01}', "");
    Expect(1, 12980, '\P{Is_Numeric_Value=3.800000000000000e+01}', "");
    Expect(0, 12980, '\P{^Is_Numeric_Value=3.800000000000000e+01}', "");
    Error('\p{Is_Nv=	:=+000003_8}');
    Error('\P{Is_Nv=	:=+000003_8}');
    Expect(1, 12979, '\p{Is_Nv=00000038}', "");
    Expect(0, 12979, '\p{^Is_Nv=00000038}', "");
    Expect(0, 12979, '\P{Is_Nv=00000038}', "");
    Expect(1, 12979, '\P{^Is_Nv=00000038}', "");
    Expect(0, 12980, '\p{Is_Nv=00000038}', "");
    Expect(1, 12980, '\p{^Is_Nv=00000038}', "");
    Expect(1, 12980, '\P{Is_Nv=00000038}', "");
    Expect(0, 12980, '\P{^Is_Nv=00000038}', "");
    Expect(1, 12979, '\p{Is_Nv=3.800000000000000e+01}', "");
    Expect(0, 12979, '\p{^Is_Nv=3.800000000000000e+01}', "");
    Expect(0, 12979, '\P{Is_Nv=3.800000000000000e+01}', "");
    Expect(1, 12979, '\P{^Is_Nv=3.800000000000000e+01}', "");
    Expect(0, 12980, '\p{Is_Nv=3.800000000000000e+01}', "");
    Expect(1, 12980, '\p{^Is_Nv=3.800000000000000e+01}', "");
    Expect(1, 12980, '\P{Is_Nv=3.800000000000000e+01}', "");
    Expect(0, 12980, '\P{^Is_Nv=3.800000000000000e+01}', "");
    Error('\p{Numeric_Value=/a/+0000000039}');
    Error('\P{Numeric_Value=/a/+0000000039}');
    Expect(1, 12980, '\p{Numeric_Value=:\A39\z:}', "");;
    Expect(0, 12981, '\p{Numeric_Value=:\A39\z:}', "");;
    Expect(1, 12980, '\p{Numeric_Value=00_03_9}', "");
    Expect(0, 12980, '\p{^Numeric_Value=00_03_9}', "");
    Expect(0, 12980, '\P{Numeric_Value=00_03_9}', "");
    Expect(1, 12980, '\P{^Numeric_Value=00_03_9}', "");
    Expect(0, 12981, '\p{Numeric_Value=00_03_9}', "");
    Expect(1, 12981, '\p{^Numeric_Value=00_03_9}', "");
    Expect(1, 12981, '\P{Numeric_Value=00_03_9}', "");
    Expect(0, 12981, '\P{^Numeric_Value=00_03_9}', "");
    Expect(1, 12980, '\p{Numeric_Value=3.900000000000000e+01}', "");
    Expect(0, 12980, '\p{^Numeric_Value=3.900000000000000e+01}', "");
    Expect(0, 12980, '\P{Numeric_Value=3.900000000000000e+01}', "");
    Expect(1, 12980, '\P{^Numeric_Value=3.900000000000000e+01}', "");
    Expect(0, 12981, '\p{Numeric_Value=3.900000000000000e+01}', "");
    Expect(1, 12981, '\p{^Numeric_Value=3.900000000000000e+01}', "");
    Expect(1, 12981, '\P{Numeric_Value=3.900000000000000e+01}', "");
    Expect(0, 12981, '\P{^Numeric_Value=3.900000000000000e+01}', "");
    Error('\p{Nv=	/a/03_9}');
    Error('\P{Nv=	/a/03_9}');
    Expect(1, 12980, '\p{Nv=:\A39\z:}', "");;
    Expect(0, 12981, '\p{Nv=:\A39\z:}', "");;
    Expect(1, 12980, '\p{Nv:	0000039}', "");
    Expect(0, 12980, '\p{^Nv:	0000039}', "");
    Expect(0, 12980, '\P{Nv:	0000039}', "");
    Expect(1, 12980, '\P{^Nv:	0000039}', "");
    Expect(0, 12981, '\p{Nv:	0000039}', "");
    Expect(1, 12981, '\p{^Nv:	0000039}', "");
    Expect(1, 12981, '\P{Nv:	0000039}', "");
    Expect(0, 12981, '\P{^Nv:	0000039}', "");
    Expect(1, 12980, '\p{Nv=3.900000000000000e+01}', "");
    Expect(0, 12980, '\p{^Nv=3.900000000000000e+01}', "");
    Expect(0, 12980, '\P{Nv=3.900000000000000e+01}', "");
    Expect(1, 12980, '\P{^Nv=3.900000000000000e+01}', "");
    Expect(0, 12981, '\p{Nv=3.900000000000000e+01}', "");
    Expect(1, 12981, '\p{^Nv=3.900000000000000e+01}', "");
    Expect(1, 12981, '\P{Nv=3.900000000000000e+01}', "");
    Expect(0, 12981, '\P{^Nv=3.900000000000000e+01}', "");
    Error('\p{Is_Numeric_Value=__0000039:=}');
    Error('\P{Is_Numeric_Value=__0000039:=}');
    Expect(1, 12980, '\p{Is_Numeric_Value: 0000000039}', "");
    Expect(0, 12980, '\p{^Is_Numeric_Value: 0000000039}', "");
    Expect(0, 12980, '\P{Is_Numeric_Value: 0000000039}', "");
    Expect(1, 12980, '\P{^Is_Numeric_Value: 0000000039}', "");
    Expect(0, 12981, '\p{Is_Numeric_Value: 0000000039}', "");
    Expect(1, 12981, '\p{^Is_Numeric_Value: 0000000039}', "");
    Expect(1, 12981, '\P{Is_Numeric_Value: 0000000039}', "");
    Expect(0, 12981, '\P{^Is_Numeric_Value: 0000000039}', "");
    Expect(1, 12980, '\p{Is_Numeric_Value=3.900000000000000e+01}', "");
    Expect(0, 12980, '\p{^Is_Numeric_Value=3.900000000000000e+01}', "");
    Expect(0, 12980, '\P{Is_Numeric_Value=3.900000000000000e+01}', "");
    Expect(1, 12980, '\P{^Is_Numeric_Value=3.900000000000000e+01}', "");
    Expect(0, 12981, '\p{Is_Numeric_Value=3.900000000000000e+01}', "");
    Expect(1, 12981, '\p{^Is_Numeric_Value=3.900000000000000e+01}', "");
    Expect(1, 12981, '\P{Is_Numeric_Value=3.900000000000000e+01}', "");
    Expect(0, 12981, '\P{^Is_Numeric_Value=3.900000000000000e+01}', "");
    Error('\p{Is_Nv: :=	0_0_0_0_0_039}');
    Error('\P{Is_Nv: :=	0_0_0_0_0_039}');
    Expect(1, 12980, '\p{Is_Nv=+0039}', "");
    Expect(0, 12980, '\p{^Is_Nv=+0039}', "");
    Expect(0, 12980, '\P{Is_Nv=+0039}', "");
    Expect(1, 12980, '\P{^Is_Nv=+0039}', "");
    Expect(0, 12981, '\p{Is_Nv=+0039}', "");
    Expect(1, 12981, '\p{^Is_Nv=+0039}', "");
    Expect(1, 12981, '\P{Is_Nv=+0039}', "");
    Expect(0, 12981, '\P{^Is_Nv=+0039}', "");
    Expect(1, 12980, '\p{Is_Nv=3.900000000000000e+01}', "");
    Expect(0, 12980, '\p{^Is_Nv=3.900000000000000e+01}', "");
    Expect(0, 12980, '\P{Is_Nv=3.900000000000000e+01}', "");
    Expect(1, 12980, '\P{^Is_Nv=3.900000000000000e+01}', "");
    Expect(0, 12981, '\p{Is_Nv=3.900000000000000e+01}', "");
    Expect(1, 12981, '\p{^Is_Nv=3.900000000000000e+01}', "");
    Expect(1, 12981, '\P{Is_Nv=3.900000000000000e+01}', "");
    Expect(0, 12981, '\P{^Is_Nv=3.900000000000000e+01}', "");
    Error('\p{Numeric_Value: :=	00000004}');
    Error('\P{Numeric_Value: :=	00000004}');
    Expect(1, 156269, '\p{Numeric_Value=:\A4\z:}', "");;
    Expect(0, 156270, '\p{Numeric_Value=:\A4\z:}', "");;
    Expect(1, 156269, '\p{Numeric_Value=000000004}', "");
    Expect(0, 156269, '\p{^Numeric_Value=000000004}', "");
    Expect(0, 156269, '\P{Numeric_Value=000000004}', "");
    Expect(1, 156269, '\P{^Numeric_Value=000000004}', "");
    Expect(0, 156270, '\p{Numeric_Value=000000004}', "");
    Expect(1, 156270, '\p{^Numeric_Value=000000004}', "");
    Expect(1, 156270, '\P{Numeric_Value=000000004}', "");
    Expect(0, 156270, '\P{^Numeric_Value=000000004}', "");
    Expect(1, 156269, '\p{Numeric_Value:   4.000000000000000e+00}', "");
    Expect(0, 156269, '\p{^Numeric_Value:   4.000000000000000e+00}', "");
    Expect(0, 156269, '\P{Numeric_Value:   4.000000000000000e+00}', "");
    Expect(1, 156269, '\P{^Numeric_Value:   4.000000000000000e+00}', "");
    Expect(0, 156270, '\p{Numeric_Value:   4.000000000000000e+00}', "");
    Expect(1, 156270, '\p{^Numeric_Value:   4.000000000000000e+00}', "");
    Expect(1, 156270, '\P{Numeric_Value:   4.000000000000000e+00}', "");
    Expect(0, 156270, '\P{^Numeric_Value:   4.000000000000000e+00}', "");
    Error('\p{Nv=_:=000004}');
    Error('\P{Nv=_:=000004}');
    Expect(1, 156269, '\p{Nv=:\A4\z:}', "");;
    Expect(0, 156270, '\p{Nv=:\A4\z:}', "");;
    Expect(1, 156269, '\p{Nv=00000004}', "");
    Expect(0, 156269, '\p{^Nv=00000004}', "");
    Expect(0, 156269, '\P{Nv=00000004}', "");
    Expect(1, 156269, '\P{^Nv=00000004}', "");
    Expect(0, 156270, '\p{Nv=00000004}', "");
    Expect(1, 156270, '\p{^Nv=00000004}', "");
    Expect(1, 156270, '\P{Nv=00000004}', "");
    Expect(0, 156270, '\P{^Nv=00000004}', "");
    Expect(1, 156269, '\p{Nv=4.000000000000000e+00}', "");
    Expect(0, 156269, '\p{^Nv=4.000000000000000e+00}', "");
    Expect(0, 156269, '\P{Nv=4.000000000000000e+00}', "");
    Expect(1, 156269, '\P{^Nv=4.000000000000000e+00}', "");
    Expect(0, 156270, '\p{Nv=4.000000000000000e+00}', "");
    Expect(1, 156270, '\p{^Nv=4.000000000000000e+00}', "");
    Expect(1, 156270, '\P{Nv=4.000000000000000e+00}', "");
    Expect(0, 156270, '\P{^Nv=4.000000000000000e+00}', "");
    Error('\p{Is_Numeric_Value=--000_4:=}');
    Error('\P{Is_Numeric_Value=--000_4:=}');
    Expect(1, 156269, '\p{Is_Numeric_Value=0004}', "");
    Expect(0, 156269, '\p{^Is_Numeric_Value=0004}', "");
    Expect(0, 156269, '\P{Is_Numeric_Value=0004}', "");
    Expect(1, 156269, '\P{^Is_Numeric_Value=0004}', "");
    Expect(0, 156270, '\p{Is_Numeric_Value=0004}', "");
    Expect(1, 156270, '\p{^Is_Numeric_Value=0004}', "");
    Expect(1, 156270, '\P{Is_Numeric_Value=0004}', "");
    Expect(0, 156270, '\P{^Is_Numeric_Value=0004}', "");
    Expect(1, 156269, '\p{Is_Numeric_Value=4.000000000000000e+00}', "");
    Expect(0, 156269, '\p{^Is_Numeric_Value=4.000000000000000e+00}', "");
    Expect(0, 156269, '\P{Is_Numeric_Value=4.000000000000000e+00}', "");
    Expect(1, 156269, '\P{^Is_Numeric_Value=4.000000000000000e+00}', "");
    Expect(0, 156270, '\p{Is_Numeric_Value=4.000000000000000e+00}', "");
    Expect(1, 156270, '\p{^Is_Numeric_Value=4.000000000000000e+00}', "");
    Expect(1, 156270, '\P{Is_Numeric_Value=4.000000000000000e+00}', "");
    Expect(0, 156270, '\P{^Is_Numeric_Value=4.000000000000000e+00}', "");
    Error('\p{Is_Nv=:=--+0000000004}');
    Error('\P{Is_Nv=:=--+0000000004}');
    Expect(1, 156269, '\p{Is_Nv:   0000000004}', "");
    Expect(0, 156269, '\p{^Is_Nv:   0000000004}', "");
    Expect(0, 156269, '\P{Is_Nv:   0000000004}', "");
    Expect(1, 156269, '\P{^Is_Nv:   0000000004}', "");
    Expect(0, 156270, '\p{Is_Nv:   0000000004}', "");
    Expect(1, 156270, '\p{^Is_Nv:   0000000004}', "");
    Expect(1, 156270, '\P{Is_Nv:   0000000004}', "");
    Expect(0, 156270, '\P{^Is_Nv:   0000000004}', "");
    Expect(1, 156269, '\p{Is_Nv=4.000000000000000e+00}', "");
    Expect(0, 156269, '\p{^Is_Nv=4.000000000000000e+00}', "");
    Expect(0, 156269, '\P{Is_Nv=4.000000000000000e+00}', "");
    Expect(1, 156269, '\P{^Is_Nv=4.000000000000000e+00}', "");
    Expect(0, 156270, '\p{Is_Nv=4.000000000000000e+00}', "");
    Expect(1, 156270, '\p{^Is_Nv=4.000000000000000e+00}', "");
    Expect(1, 156270, '\P{Is_Nv=4.000000000000000e+00}', "");
    Expect(0, 156270, '\P{^Is_Nv=4.000000000000000e+00}', "");
    Error('\p{Numeric_Value=	:=004/0005}');
    Error('\P{Numeric_Value=	:=004/0005}');
    Expect(1, 8536, '\p{Numeric_Value=:\A4/5\z:}', "");;
    Expect(0, 8537, '\p{Numeric_Value=:\A4/5\z:}', "");;
    Expect(1, 8536, '\p{Numeric_Value=00000004/000005}', "");
    Expect(0, 8536, '\p{^Numeric_Value=00000004/000005}', "");
    Expect(0, 8536, '\P{Numeric_Value=00000004/000005}', "");
    Expect(1, 8536, '\P{^Numeric_Value=00000004/000005}', "");
    Expect(0, 8537, '\p{Numeric_Value=00000004/000005}', "");
    Expect(1, 8537, '\p{^Numeric_Value=00000004/000005}', "");
    Expect(1, 8537, '\P{Numeric_Value=00000004/000005}', "");
    Expect(0, 8537, '\P{^Numeric_Value=00000004/000005}', "");
    Expect(1, 8536, '\p{Numeric_Value=240/300}', "");
    Expect(0, 8536, '\p{^Numeric_Value=240/300}', "");
    Expect(0, 8536, '\P{Numeric_Value=240/300}', "");
    Expect(1, 8536, '\P{^Numeric_Value=240/300}', "");
    Expect(0, 8537, '\p{Numeric_Value=240/300}', "");
    Expect(1, 8537, '\p{^Numeric_Value=240/300}', "");
    Expect(1, 8537, '\P{Numeric_Value=240/300}', "");
    Expect(0, 8537, '\P{^Numeric_Value=240/300}', "");
    Expect(1, 8536, '\p{Numeric_Value=8.0e-01}', "");
    Expect(0, 8536, '\p{^Numeric_Value=8.0e-01}', "");
    Expect(0, 8536, '\P{Numeric_Value=8.0e-01}', "");
    Expect(1, 8536, '\P{^Numeric_Value=8.0e-01}', "");
    Expect(0, 8537, '\p{Numeric_Value=8.0e-01}', "");
    Expect(1, 8537, '\p{^Numeric_Value=8.0e-01}', "");
    Expect(1, 8537, '\P{Numeric_Value=8.0e-01}', "");
    Expect(0, 8537, '\P{^Numeric_Value=8.0e-01}', "");
    Expect(1, 8536, '\p{Numeric_Value=0.8}', "");
    Expect(0, 8536, '\p{^Numeric_Value=0.8}', "");
    Expect(0, 8536, '\P{Numeric_Value=0.8}', "");
    Expect(1, 8536, '\P{^Numeric_Value=0.8}', "");
    Expect(0, 8537, '\p{Numeric_Value=0.8}', "");
    Expect(1, 8537, '\p{^Numeric_Value=0.8}', "");
    Expect(1, 8537, '\P{Numeric_Value=0.8}', "");
    Expect(0, 8537, '\P{^Numeric_Value=0.8}', "");
    Expect(1, 8536, '\p{Numeric_Value:   8.00e-01}', "");
    Expect(0, 8536, '\p{^Numeric_Value:   8.00e-01}', "");
    Expect(0, 8536, '\P{Numeric_Value:   8.00e-01}', "");
    Expect(1, 8536, '\P{^Numeric_Value:   8.00e-01}', "");
    Expect(0, 8537, '\p{Numeric_Value:   8.00e-01}', "");
    Expect(1, 8537, '\p{^Numeric_Value:   8.00e-01}', "");
    Expect(1, 8537, '\P{Numeric_Value:   8.00e-01}', "");
    Expect(0, 8537, '\P{^Numeric_Value:   8.00e-01}', "");
    Expect(1, 8536, '\p{Numeric_Value: 0.80}', "");
    Expect(0, 8536, '\p{^Numeric_Value: 0.80}', "");
    Expect(0, 8536, '\P{Numeric_Value: 0.80}', "");
    Expect(1, 8536, '\P{^Numeric_Value: 0.80}', "");
    Expect(0, 8537, '\p{Numeric_Value: 0.80}', "");
    Expect(1, 8537, '\p{^Numeric_Value: 0.80}', "");
    Expect(1, 8537, '\P{Numeric_Value: 0.80}', "");
    Expect(0, 8537, '\P{^Numeric_Value: 0.80}', "");
    Error('\p{Nv:	/a/ 	+004/0000000005}');
    Error('\P{Nv:	/a/ 	+004/0000000005}');
    Expect(1, 8536, '\p{Nv=:\A4/5\z:}', "");;
    Expect(0, 8537, '\p{Nv=:\A4/5\z:}', "");;
    Expect(1, 8536, '\p{Nv=4/5}', "");
    Expect(0, 8536, '\p{^Nv=4/5}', "");
    Expect(0, 8536, '\P{Nv=4/5}', "");
    Expect(1, 8536, '\P{^Nv=4/5}', "");
    Expect(0, 8537, '\p{Nv=4/5}', "");
    Expect(1, 8537, '\p{^Nv=4/5}', "");
    Expect(1, 8537, '\P{Nv=4/5}', "");
    Expect(0, 8537, '\P{^Nv=4/5}', "");
    Expect(1, 8536, '\p{Nv:240/300}', "");
    Expect(0, 8536, '\p{^Nv:240/300}', "");
    Expect(0, 8536, '\P{Nv:240/300}', "");
    Expect(1, 8536, '\P{^Nv:240/300}', "");
    Expect(0, 8537, '\p{Nv:240/300}', "");
    Expect(1, 8537, '\p{^Nv:240/300}', "");
    Expect(1, 8537, '\P{Nv:240/300}', "");
    Expect(0, 8537, '\P{^Nv:240/300}', "");
    Expect(1, 8536, '\p{Nv=8.0e-01}', "");
    Expect(0, 8536, '\p{^Nv=8.0e-01}', "");
    Expect(0, 8536, '\P{Nv=8.0e-01}', "");
    Expect(1, 8536, '\P{^Nv=8.0e-01}', "");
    Expect(0, 8537, '\p{Nv=8.0e-01}', "");
    Expect(1, 8537, '\p{^Nv=8.0e-01}', "");
    Expect(1, 8537, '\P{Nv=8.0e-01}', "");
    Expect(0, 8537, '\P{^Nv=8.0e-01}', "");
    Expect(1, 8536, '\p{Nv=0.8}', "");
    Expect(0, 8536, '\p{^Nv=0.8}', "");
    Expect(0, 8536, '\P{Nv=0.8}', "");
    Expect(1, 8536, '\P{^Nv=0.8}', "");
    Expect(0, 8537, '\p{Nv=0.8}', "");
    Expect(1, 8537, '\p{^Nv=0.8}', "");
    Expect(1, 8537, '\P{Nv=0.8}', "");
    Expect(0, 8537, '\P{^Nv=0.8}', "");
    Expect(1, 8536, '\p{Nv=8.00e-01}', "");
    Expect(0, 8536, '\p{^Nv=8.00e-01}', "");
    Expect(0, 8536, '\P{Nv=8.00e-01}', "");
    Expect(1, 8536, '\P{^Nv=8.00e-01}', "");
    Expect(0, 8537, '\p{Nv=8.00e-01}', "");
    Expect(1, 8537, '\p{^Nv=8.00e-01}', "");
    Expect(1, 8537, '\P{Nv=8.00e-01}', "");
    Expect(0, 8537, '\P{^Nv=8.00e-01}', "");
    Expect(1, 8536, '\p{Nv=0.80}', "");
    Expect(0, 8536, '\p{^Nv=0.80}', "");
    Expect(0, 8536, '\P{Nv=0.80}', "");
    Expect(1, 8536, '\P{^Nv=0.80}', "");
    Expect(0, 8537, '\p{Nv=0.80}', "");
    Expect(1, 8537, '\p{^Nv=0.80}', "");
    Expect(1, 8537, '\P{Nv=0.80}', "");
    Expect(0, 8537, '\P{^Nv=0.80}', "");
    Error('\p{Is_Numeric_Value=- +04/0005:=}');
    Error('\P{Is_Numeric_Value=- +04/0005:=}');
    Expect(1, 8536, '\p{Is_Numeric_Value=4/000000005}', "");
    Expect(0, 8536, '\p{^Is_Numeric_Value=4/000000005}', "");
    Expect(0, 8536, '\P{Is_Numeric_Value=4/000000005}', "");
    Expect(1, 8536, '\P{^Is_Numeric_Value=4/000000005}', "");
    Expect(0, 8537, '\p{Is_Numeric_Value=4/000000005}', "");
    Expect(1, 8537, '\p{^Is_Numeric_Value=4/000000005}', "");
    Expect(1, 8537, '\P{Is_Numeric_Value=4/000000005}', "");
    Expect(0, 8537, '\P{^Is_Numeric_Value=4/000000005}', "");
    Expect(1, 8536, '\p{Is_Numeric_Value=240/300}', "");
    Expect(0, 8536, '\p{^Is_Numeric_Value=240/300}', "");
    Expect(0, 8536, '\P{Is_Numeric_Value=240/300}', "");
    Expect(1, 8536, '\P{^Is_Numeric_Value=240/300}', "");
    Expect(0, 8537, '\p{Is_Numeric_Value=240/300}', "");
    Expect(1, 8537, '\p{^Is_Numeric_Value=240/300}', "");
    Expect(1, 8537, '\P{Is_Numeric_Value=240/300}', "");
    Expect(0, 8537, '\P{^Is_Numeric_Value=240/300}', "");
    Expect(1, 8536, '\p{Is_Numeric_Value=8.0e-01}', "");
    Expect(0, 8536, '\p{^Is_Numeric_Value=8.0e-01}', "");
    Expect(0, 8536, '\P{Is_Numeric_Value=8.0e-01}', "");
    Expect(1, 8536, '\P{^Is_Numeric_Value=8.0e-01}', "");
    Expect(0, 8537, '\p{Is_Numeric_Value=8.0e-01}', "");
    Expect(1, 8537, '\p{^Is_Numeric_Value=8.0e-01}', "");
    Expect(1, 8537, '\P{Is_Numeric_Value=8.0e-01}', "");
    Expect(0, 8537, '\P{^Is_Numeric_Value=8.0e-01}', "");
    Expect(1, 8536, '\p{Is_Numeric_Value=0.8}', "");
    Expect(0, 8536, '\p{^Is_Numeric_Value=0.8}', "");
    Expect(0, 8536, '\P{Is_Numeric_Value=0.8}', "");
    Expect(1, 8536, '\P{^Is_Numeric_Value=0.8}', "");
    Expect(0, 8537, '\p{Is_Numeric_Value=0.8}', "");
    Expect(1, 8537, '\p{^Is_Numeric_Value=0.8}', "");
    Expect(1, 8537, '\P{Is_Numeric_Value=0.8}', "");
    Expect(0, 8537, '\P{^Is_Numeric_Value=0.8}', "");
    Expect(1, 8536, '\p{Is_Numeric_Value=8.00e-01}', "");
    Expect(0, 8536, '\p{^Is_Numeric_Value=8.00e-01}', "");
    Expect(0, 8536, '\P{Is_Numeric_Value=8.00e-01}', "");
    Expect(1, 8536, '\P{^Is_Numeric_Value=8.00e-01}', "");
    Expect(0, 8537, '\p{Is_Numeric_Value=8.00e-01}', "");
    Expect(1, 8537, '\p{^Is_Numeric_Value=8.00e-01}', "");
    Expect(1, 8537, '\P{Is_Numeric_Value=8.00e-01}', "");
    Expect(0, 8537, '\P{^Is_Numeric_Value=8.00e-01}', "");
    Expect(1, 8536, '\p{Is_Numeric_Value=0.80}', "");
    Expect(0, 8536, '\p{^Is_Numeric_Value=0.80}', "");
    Expect(0, 8536, '\P{Is_Numeric_Value=0.80}', "");
    Expect(1, 8536, '\P{^Is_Numeric_Value=0.80}', "");
    Expect(0, 8537, '\p{Is_Numeric_Value=0.80}', "");
    Expect(1, 8537, '\p{^Is_Numeric_Value=0.80}', "");
    Expect(1, 8537, '\P{Is_Numeric_Value=0.80}', "");
    Expect(0, 8537, '\P{^Is_Numeric_Value=0.80}', "");
    Error('\p{Is_Nv=-00000004/00000005:=}');
    Error('\P{Is_Nv=-00000004/00000005:=}');
    Expect(1, 8536, '\p{Is_Nv=004/000000005}', "");
    Expect(0, 8536, '\p{^Is_Nv=004/000000005}', "");
    Expect(0, 8536, '\P{Is_Nv=004/000000005}', "");
    Expect(1, 8536, '\P{^Is_Nv=004/000000005}', "");
    Expect(0, 8537, '\p{Is_Nv=004/000000005}', "");
    Expect(1, 8537, '\p{^Is_Nv=004/000000005}', "");
    Expect(1, 8537, '\P{Is_Nv=004/000000005}', "");
    Expect(0, 8537, '\P{^Is_Nv=004/000000005}', "");
    Expect(1, 8536, '\p{Is_Nv=240/300}', "");
    Expect(0, 8536, '\p{^Is_Nv=240/300}', "");
    Expect(0, 8536, '\P{Is_Nv=240/300}', "");
    Expect(1, 8536, '\P{^Is_Nv=240/300}', "");
    Expect(0, 8537, '\p{Is_Nv=240/300}', "");
    Expect(1, 8537, '\p{^Is_Nv=240/300}', "");
    Expect(1, 8537, '\P{Is_Nv=240/300}', "");
    Expect(0, 8537, '\P{^Is_Nv=240/300}', "");
    Expect(1, 8536, '\p{Is_Nv:8.0e-01}', "");
    Expect(0, 8536, '\p{^Is_Nv:8.0e-01}', "");
    Expect(0, 8536, '\P{Is_Nv:8.0e-01}', "");
    Expect(1, 8536, '\P{^Is_Nv:8.0e-01}', "");
    Expect(0, 8537, '\p{Is_Nv:8.0e-01}', "");
    Expect(1, 8537, '\p{^Is_Nv:8.0e-01}', "");
    Expect(1, 8537, '\P{Is_Nv:8.0e-01}', "");
    Expect(0, 8537, '\P{^Is_Nv:8.0e-01}', "");
    Expect(1, 8536, '\p{Is_Nv=0.8}', "");
    Expect(0, 8536, '\p{^Is_Nv=0.8}', "");
    Expect(0, 8536, '\P{Is_Nv=0.8}', "");
    Expect(1, 8536, '\P{^Is_Nv=0.8}', "");
    Expect(0, 8537, '\p{Is_Nv=0.8}', "");
    Expect(1, 8537, '\p{^Is_Nv=0.8}', "");
    Expect(1, 8537, '\P{Is_Nv=0.8}', "");
    Expect(0, 8537, '\P{^Is_Nv=0.8}', "");
    Expect(1, 8536, '\p{Is_Nv=8.00e-01}', "");
    Expect(0, 8536, '\p{^Is_Nv=8.00e-01}', "");
    Expect(0, 8536, '\P{Is_Nv=8.00e-01}', "");
    Expect(1, 8536, '\P{^Is_Nv=8.00e-01}', "");
    Expect(0, 8537, '\p{Is_Nv=8.00e-01}', "");
    Expect(1, 8537, '\p{^Is_Nv=8.00e-01}', "");
    Expect(1, 8537, '\P{Is_Nv=8.00e-01}', "");
    Expect(0, 8537, '\P{^Is_Nv=8.00e-01}', "");
    Expect(1, 8536, '\p{Is_Nv:0.80}', "");
    Expect(0, 8536, '\p{^Is_Nv:0.80}', "");
    Expect(0, 8536, '\P{Is_Nv:0.80}', "");
    Expect(1, 8536, '\P{^Is_Nv:0.80}', "");
    Expect(0, 8537, '\p{Is_Nv:0.80}', "");
    Expect(1, 8537, '\p{^Is_Nv:0.80}', "");
    Expect(1, 8537, '\P{Is_Nv:0.80}', "");
    Expect(0, 8537, '\P{^Is_Nv:0.80}', "");
    Error('\p{Numeric_Value=:=	0_0_0_0_40}');
    Error('\P{Numeric_Value=:=	0_0_0_0_40}');
    Expect(1, 133532, '\p{Numeric_Value=:\A40\z:}', "");;
    Expect(0, 133533, '\p{Numeric_Value=:\A40\z:}', "");;
    Expect(1, 133532, '\p{Numeric_Value=40}', "");
    Expect(0, 133532, '\p{^Numeric_Value=40}', "");
    Expect(0, 133532, '\P{Numeric_Value=40}', "");
    Expect(1, 133532, '\P{^Numeric_Value=40}', "");
    Expect(0, 133533, '\p{Numeric_Value=40}', "");
    Expect(1, 133533, '\p{^Numeric_Value=40}', "");
    Expect(1, 133533, '\P{Numeric_Value=40}', "");
    Expect(0, 133533, '\P{^Numeric_Value=40}', "");
    Expect(1, 133532, '\p{Numeric_Value=4.000000000000000e+01}', "");
    Expect(0, 133532, '\p{^Numeric_Value=4.000000000000000e+01}', "");
    Expect(0, 133532, '\P{Numeric_Value=4.000000000000000e+01}', "");
    Expect(1, 133532, '\P{^Numeric_Value=4.000000000000000e+01}', "");
    Expect(0, 133533, '\p{Numeric_Value=4.000000000000000e+01}', "");
    Expect(1, 133533, '\p{^Numeric_Value=4.000000000000000e+01}', "");
    Expect(1, 133533, '\P{Numeric_Value=4.000000000000000e+01}', "");
    Expect(0, 133533, '\P{^Numeric_Value=4.000000000000000e+01}', "");
    Error('\p{Nv=_:=000040}');
    Error('\P{Nv=_:=000040}');
    Expect(1, 133532, '\p{Nv=:\A40\z:}', "");;
    Expect(0, 133533, '\p{Nv=:\A40\z:}', "");;
    Expect(1, 133532, '\p{Nv=0_0_0_0_0_0_0040}', "");
    Expect(0, 133532, '\p{^Nv=0_0_0_0_0_0_0040}', "");
    Expect(0, 133532, '\P{Nv=0_0_0_0_0_0_0040}', "");
    Expect(1, 133532, '\P{^Nv=0_0_0_0_0_0_0040}', "");
    Expect(0, 133533, '\p{Nv=0_0_0_0_0_0_0040}', "");
    Expect(1, 133533, '\p{^Nv=0_0_0_0_0_0_0040}', "");
    Expect(1, 133533, '\P{Nv=0_0_0_0_0_0_0040}', "");
    Expect(0, 133533, '\P{^Nv=0_0_0_0_0_0_0040}', "");
    Expect(1, 133532, '\p{Nv=4.000000000000000e+01}', "");
    Expect(0, 133532, '\p{^Nv=4.000000000000000e+01}', "");
    Expect(0, 133532, '\P{Nv=4.000000000000000e+01}', "");
    Expect(1, 133532, '\P{^Nv=4.000000000000000e+01}', "");
    Expect(0, 133533, '\p{Nv=4.000000000000000e+01}', "");
    Expect(1, 133533, '\p{^Nv=4.000000000000000e+01}', "");
    Expect(1, 133533, '\P{Nv=4.000000000000000e+01}', "");
    Expect(0, 133533, '\P{^Nv=4.000000000000000e+01}', "");
    Error('\p{Is_Numeric_Value=	/a/000000040}');
    Error('\P{Is_Numeric_Value=	/a/000000040}');
    Expect(1, 133532, '\p{Is_Numeric_Value=00_00_40}', "");
    Expect(0, 133532, '\p{^Is_Numeric_Value=00_00_40}', "");
    Expect(0, 133532, '\P{Is_Numeric_Value=00_00_40}', "");
    Expect(1, 133532, '\P{^Is_Numeric_Value=00_00_40}', "");
    Expect(0, 133533, '\p{Is_Numeric_Value=00_00_40}', "");
    Expect(1, 133533, '\p{^Is_Numeric_Value=00_00_40}', "");
    Expect(1, 133533, '\P{Is_Numeric_Value=00_00_40}', "");
    Expect(0, 133533, '\P{^Is_Numeric_Value=00_00_40}', "");
    Expect(1, 133532, '\p{Is_Numeric_Value=4.000000000000000e+01}', "");
    Expect(0, 133532, '\p{^Is_Numeric_Value=4.000000000000000e+01}', "");
    Expect(0, 133532, '\P{Is_Numeric_Value=4.000000000000000e+01}', "");
    Expect(1, 133532, '\P{^Is_Numeric_Value=4.000000000000000e+01}', "");
    Expect(0, 133533, '\p{Is_Numeric_Value=4.000000000000000e+01}', "");
    Expect(1, 133533, '\p{^Is_Numeric_Value=4.000000000000000e+01}', "");
    Expect(1, 133533, '\P{Is_Numeric_Value=4.000000000000000e+01}', "");
    Expect(0, 133533, '\P{^Is_Numeric_Value=4.000000000000000e+01}', "");
    Error('\p{Is_Nv=	 +0000040:=}');
    Error('\P{Is_Nv=	 +0000040:=}');
    Expect(1, 133532, '\p{Is_Nv=0040}', "");
    Expect(0, 133532, '\p{^Is_Nv=0040}', "");
    Expect(0, 133532, '\P{Is_Nv=0040}', "");
    Expect(1, 133532, '\P{^Is_Nv=0040}', "");
    Expect(0, 133533, '\p{Is_Nv=0040}', "");
    Expect(1, 133533, '\p{^Is_Nv=0040}', "");
    Expect(1, 133533, '\P{Is_Nv=0040}', "");
    Expect(0, 133533, '\P{^Is_Nv=0040}', "");
    Expect(1, 133532, '\p{Is_Nv=4.000000000000000e+01}', "");
    Expect(0, 133532, '\p{^Is_Nv=4.000000000000000e+01}', "");
    Expect(0, 133532, '\P{Is_Nv=4.000000000000000e+01}', "");
    Expect(1, 133532, '\P{^Is_Nv=4.000000000000000e+01}', "");
    Expect(0, 133533, '\p{Is_Nv=4.000000000000000e+01}', "");
    Expect(1, 133533, '\p{^Is_Nv=4.000000000000000e+01}', "");
    Expect(1, 133533, '\P{Is_Nv=4.000000000000000e+01}', "");
    Expect(0, 133533, '\P{^Is_Nv=4.000000000000000e+01}', "");
    Error('\p{Numeric_Value= /a/000_040_0}');
    Error('\P{Numeric_Value= /a/000_040_0}');
    Expect(1, 126264, '\p{Numeric_Value=:\A400\z:}', "");;
    Expect(0, 126265, '\p{Numeric_Value=:\A400\z:}', "");;
    Expect(1, 126264, '\p{Numeric_Value=00_04_00}', "");
    Expect(0, 126264, '\p{^Numeric_Value=00_04_00}', "");
    Expect(0, 126264, '\P{Numeric_Value=00_04_00}', "");
    Expect(1, 126264, '\P{^Numeric_Value=00_04_00}', "");
    Expect(0, 126265, '\p{Numeric_Value=00_04_00}', "");
    Expect(1, 126265, '\p{^Numeric_Value=00_04_00}', "");
    Expect(1, 126265, '\P{Numeric_Value=00_04_00}', "");
    Expect(0, 126265, '\P{^Numeric_Value=00_04_00}', "");
    Expect(1, 126264, '\p{Numeric_Value=4.000000000000000e+02}', "");
    Expect(0, 126264, '\p{^Numeric_Value=4.000000000000000e+02}', "");
    Expect(0, 126264, '\P{Numeric_Value=4.000000000000000e+02}', "");
    Expect(1, 126264, '\P{^Numeric_Value=4.000000000000000e+02}', "");
    Expect(0, 126265, '\p{Numeric_Value=4.000000000000000e+02}', "");
    Expect(1, 126265, '\p{^Numeric_Value=4.000000000000000e+02}', "");
    Expect(1, 126265, '\P{Numeric_Value=4.000000000000000e+02}', "");
    Expect(0, 126265, '\P{^Numeric_Value=4.000000000000000e+02}', "");
    Error('\p{Nv=- +00_00_00_00_0400/a/}');
    Error('\P{Nv=- +00_00_00_00_0400/a/}');
    Expect(1, 126264, '\p{Nv=:\A400\z:}', "");;
    Expect(0, 126265, '\p{Nv=:\A400\z:}', "");;
    Expect(1, 126264, '\p{Nv=0_0_0_0_0_0_0_0_400}', "");
    Expect(0, 126264, '\p{^Nv=0_0_0_0_0_0_0_0_400}', "");
    Expect(0, 126264, '\P{Nv=0_0_0_0_0_0_0_0_400}', "");
    Expect(1, 126264, '\P{^Nv=0_0_0_0_0_0_0_0_400}', "");
    Expect(0, 126265, '\p{Nv=0_0_0_0_0_0_0_0_400}', "");
    Expect(1, 126265, '\p{^Nv=0_0_0_0_0_0_0_0_400}', "");
    Expect(1, 126265, '\P{Nv=0_0_0_0_0_0_0_0_400}', "");
    Expect(0, 126265, '\P{^Nv=0_0_0_0_0_0_0_0_400}', "");
    Expect(1, 126264, '\p{Nv=4.000000000000000e+02}', "");
    Expect(0, 126264, '\p{^Nv=4.000000000000000e+02}', "");
    Expect(0, 126264, '\P{Nv=4.000000000000000e+02}', "");
    Expect(1, 126264, '\P{^Nv=4.000000000000000e+02}', "");
    Expect(0, 126265, '\p{Nv=4.000000000000000e+02}', "");
    Expect(1, 126265, '\p{^Nv=4.000000000000000e+02}', "");
    Expect(1, 126265, '\P{Nv=4.000000000000000e+02}', "");
    Expect(0, 126265, '\P{^Nv=4.000000000000000e+02}', "");
    Error('\p{Is_Numeric_Value=--00_00_00_00_400/a/}');
    Error('\P{Is_Numeric_Value=--00_00_00_00_400/a/}');
    Expect(1, 126264, '\p{Is_Numeric_Value=0400}', "");
    Expect(0, 126264, '\p{^Is_Numeric_Value=0400}', "");
    Expect(0, 126264, '\P{Is_Numeric_Value=0400}', "");
    Expect(1, 126264, '\P{^Is_Numeric_Value=0400}', "");
    Expect(0, 126265, '\p{Is_Numeric_Value=0400}', "");
    Expect(1, 126265, '\p{^Is_Numeric_Value=0400}', "");
    Expect(1, 126265, '\P{Is_Numeric_Value=0400}', "");
    Expect(0, 126265, '\P{^Is_Numeric_Value=0400}', "");
    Expect(1, 126264, '\p{Is_Numeric_Value=4.000000000000000e+02}', "");
    Expect(0, 126264, '\p{^Is_Numeric_Value=4.000000000000000e+02}', "");
    Expect(0, 126264, '\P{Is_Numeric_Value=4.000000000000000e+02}', "");
    Expect(1, 126264, '\P{^Is_Numeric_Value=4.000000000000000e+02}', "");
    Expect(0, 126265, '\p{Is_Numeric_Value=4.000000000000000e+02}', "");
    Expect(1, 126265, '\p{^Is_Numeric_Value=4.000000000000000e+02}', "");
    Expect(1, 126265, '\P{Is_Numeric_Value=4.000000000000000e+02}', "");
    Expect(0, 126265, '\P{^Is_Numeric_Value=4.000000000000000e+02}', "");
    Error('\p{Is_Nv=/a/	 +0400}');
    Error('\P{Is_Nv=/a/	 +0400}');
    Expect(1, 126264, '\p{Is_Nv=0400}', "");
    Expect(0, 126264, '\p{^Is_Nv=0400}', "");
    Expect(0, 126264, '\P{Is_Nv=0400}', "");
    Expect(1, 126264, '\P{^Is_Nv=0400}', "");
    Expect(0, 126265, '\p{Is_Nv=0400}', "");
    Expect(1, 126265, '\p{^Is_Nv=0400}', "");
    Expect(1, 126265, '\P{Is_Nv=0400}', "");
    Expect(0, 126265, '\P{^Is_Nv=0400}', "");
    Expect(1, 126264, '\p{Is_Nv: 4.000000000000000e+02}', "");
    Expect(0, 126264, '\p{^Is_Nv: 4.000000000000000e+02}', "");
    Expect(0, 126264, '\P{Is_Nv: 4.000000000000000e+02}', "");
    Expect(1, 126264, '\P{^Is_Nv: 4.000000000000000e+02}', "");
    Expect(0, 126265, '\p{Is_Nv: 4.000000000000000e+02}', "");
    Expect(1, 126265, '\p{^Is_Nv: 4.000000000000000e+02}', "");
    Expect(1, 126265, '\P{Is_Nv: 4.000000000000000e+02}', "");
    Expect(0, 126265, '\P{^Is_Nv: 4.000000000000000e+02}', "");
    Error('\p{Numeric_Value=_00004000:=}');
    Error('\P{Numeric_Value=_00004000:=}');
    Expect(1, 126239, '\p{Numeric_Value=:\A4000\z:}', "");;
    Expect(0, 126240, '\p{Numeric_Value=:\A4000\z:}', "");;
    Expect(1, 126239, '\p{Numeric_Value=00000004000}', "");
    Expect(0, 126239, '\p{^Numeric_Value=00000004000}', "");
    Expect(0, 126239, '\P{Numeric_Value=00000004000}', "");
    Expect(1, 126239, '\P{^Numeric_Value=00000004000}', "");
    Expect(0, 126240, '\p{Numeric_Value=00000004000}', "");
    Expect(1, 126240, '\p{^Numeric_Value=00000004000}', "");
    Expect(1, 126240, '\P{Numeric_Value=00000004000}', "");
    Expect(0, 126240, '\P{^Numeric_Value=00000004000}', "");
    Expect(1, 126239, '\p{Numeric_Value:4.000000000000000e+03}', "");
    Expect(0, 126239, '\p{^Numeric_Value:4.000000000000000e+03}', "");
    Expect(0, 126239, '\P{Numeric_Value:4.000000000000000e+03}', "");
    Expect(1, 126239, '\P{^Numeric_Value:4.000000000000000e+03}', "");
    Expect(0, 126240, '\p{Numeric_Value:4.000000000000000e+03}', "");
    Expect(1, 126240, '\p{^Numeric_Value:4.000000000000000e+03}', "");
    Expect(1, 126240, '\P{Numeric_Value:4.000000000000000e+03}', "");
    Expect(0, 126240, '\P{^Numeric_Value:4.000000000000000e+03}', "");
    Error('\p{Nv=_:=0_0_0_4_0_00}');
    Error('\P{Nv=_:=0_0_0_4_0_00}');
    Expect(1, 126239, '\p{Nv=:\A4000\z:}', "");;
    Expect(0, 126240, '\p{Nv=:\A4000\z:}', "");;
    Expect(1, 126239, '\p{Nv=+000004000}', "");
    Expect(0, 126239, '\p{^Nv=+000004000}', "");
    Expect(0, 126239, '\P{Nv=+000004000}', "");
    Expect(1, 126239, '\P{^Nv=+000004000}', "");
    Expect(0, 126240, '\p{Nv=+000004000}', "");
    Expect(1, 126240, '\p{^Nv=+000004000}', "");
    Expect(1, 126240, '\P{Nv=+000004000}', "");
    Expect(0, 126240, '\P{^Nv=+000004000}', "");
    Expect(1, 126239, '\p{Nv=4.000000000000000e+03}', "");
    Expect(0, 126239, '\p{^Nv=4.000000000000000e+03}', "");
    Expect(0, 126239, '\P{Nv=4.000000000000000e+03}', "");
    Expect(1, 126239, '\P{^Nv=4.000000000000000e+03}', "");
    Expect(0, 126240, '\p{Nv=4.000000000000000e+03}', "");
    Expect(1, 126240, '\p{^Nv=4.000000000000000e+03}', "");
    Expect(1, 126240, '\P{Nv=4.000000000000000e+03}', "");
    Expect(0, 126240, '\P{^Nv=4.000000000000000e+03}', "");
    Error('\p{Is_Numeric_Value=--+0_0_0_0_0_0_0_0_0_4000:=}');
    Error('\P{Is_Numeric_Value=--+0_0_0_0_0_0_0_0_0_4000:=}');
    Expect(1, 126239, '\p{Is_Numeric_Value=0_0_0_0_4_0_00}', "");
    Expect(0, 126239, '\p{^Is_Numeric_Value=0_0_0_0_4_0_00}', "");
    Expect(0, 126239, '\P{Is_Numeric_Value=0_0_0_0_4_0_00}', "");
    Expect(1, 126239, '\P{^Is_Numeric_Value=0_0_0_0_4_0_00}', "");
    Expect(0, 126240, '\p{Is_Numeric_Value=0_0_0_0_4_0_00}', "");
    Expect(1, 126240, '\p{^Is_Numeric_Value=0_0_0_0_4_0_00}', "");
    Expect(1, 126240, '\P{Is_Numeric_Value=0_0_0_0_4_0_00}', "");
    Expect(0, 126240, '\P{^Is_Numeric_Value=0_0_0_0_4_0_00}', "");
    Expect(1, 126239, '\p{Is_Numeric_Value=4.000000000000000e+03}', "");
    Expect(0, 126239, '\p{^Is_Numeric_Value=4.000000000000000e+03}', "");
    Expect(0, 126239, '\P{Is_Numeric_Value=4.000000000000000e+03}', "");
    Expect(1, 126239, '\P{^Is_Numeric_Value=4.000000000000000e+03}', "");
    Expect(0, 126240, '\p{Is_Numeric_Value=4.000000000000000e+03}', "");
    Expect(1, 126240, '\p{^Is_Numeric_Value=4.000000000000000e+03}', "");
    Expect(1, 126240, '\P{Is_Numeric_Value=4.000000000000000e+03}', "");
    Expect(0, 126240, '\P{^Is_Numeric_Value=4.000000000000000e+03}', "");
    Error('\p{Is_Nv=/a/ -00000004000}');
    Error('\P{Is_Nv=/a/ -00000004000}');
    Expect(1, 126239, '\p{Is_Nv:	0000000004000}', "");
    Expect(0, 126239, '\p{^Is_Nv:	0000000004000}', "");
    Expect(0, 126239, '\P{Is_Nv:	0000000004000}', "");
    Expect(1, 126239, '\P{^Is_Nv:	0000000004000}', "");
    Expect(0, 126240, '\p{Is_Nv:	0000000004000}', "");
    Expect(1, 126240, '\p{^Is_Nv:	0000000004000}', "");
    Expect(1, 126240, '\P{Is_Nv:	0000000004000}', "");
    Expect(0, 126240, '\P{^Is_Nv:	0000000004000}', "");
    Expect(1, 126239, '\p{Is_Nv: 4.000000000000000e+03}', "");
    Expect(0, 126239, '\p{^Is_Nv: 4.000000000000000e+03}', "");
    Expect(0, 126239, '\P{Is_Nv: 4.000000000000000e+03}', "");
    Expect(1, 126239, '\P{^Is_Nv: 4.000000000000000e+03}', "");
    Expect(0, 126240, '\p{Is_Nv: 4.000000000000000e+03}', "");
    Expect(1, 126240, '\p{^Is_Nv: 4.000000000000000e+03}', "");
    Expect(1, 126240, '\P{Is_Nv: 4.000000000000000e+03}', "");
    Expect(0, 126240, '\P{^Is_Nv: 4.000000000000000e+03}', "");
    Error('\p{Numeric_Value=_	+000_000_004_000_0:=}');
    Error('\P{Numeric_Value=_	+000_000_004_000_0:=}');
    Expect(1, 126248, '\p{Numeric_Value=:\A40000\z:}', "");;
    Expect(0, 126249, '\p{Numeric_Value=:\A40000\z:}', "");;
    Expect(1, 126248, '\p{Numeric_Value=00000000040000}', "");
    Expect(0, 126248, '\p{^Numeric_Value=00000000040000}', "");
    Expect(0, 126248, '\P{Numeric_Value=00000000040000}', "");
    Expect(1, 126248, '\P{^Numeric_Value=00000000040000}', "");
    Expect(0, 126249, '\p{Numeric_Value=00000000040000}', "");
    Expect(1, 126249, '\p{^Numeric_Value=00000000040000}', "");
    Expect(1, 126249, '\P{Numeric_Value=00000000040000}', "");
    Expect(0, 126249, '\P{^Numeric_Value=00000000040000}', "");
    Expect(1, 126248, '\p{Numeric_Value=4.000000000000000e+04}', "");
    Expect(0, 126248, '\p{^Numeric_Value=4.000000000000000e+04}', "");
    Expect(0, 126248, '\P{Numeric_Value=4.000000000000000e+04}', "");
    Expect(1, 126248, '\P{^Numeric_Value=4.000000000000000e+04}', "");
    Expect(0, 126249, '\p{Numeric_Value=4.000000000000000e+04}', "");
    Expect(1, 126249, '\p{^Numeric_Value=4.000000000000000e+04}', "");
    Expect(1, 126249, '\P{Numeric_Value=4.000000000000000e+04}', "");
    Expect(0, 126249, '\P{^Numeric_Value=4.000000000000000e+04}', "");
    Error('\p{Nv=_-0000000040000/a/}');
    Error('\P{Nv=_-0000000040000/a/}');
    Expect(1, 126248, '\p{Nv=:\A40000\z:}', "");;
    Expect(0, 126249, '\p{Nv=:\A40000\z:}', "");;
    Expect(1, 126248, '\p{Nv=+0_0_0_0_0_0_0_0_0_4_0_000}', "");
    Expect(0, 126248, '\p{^Nv=+0_0_0_0_0_0_0_0_0_4_0_000}', "");
    Expect(0, 126248, '\P{Nv=+0_0_0_0_0_0_0_0_0_4_0_000}', "");
    Expect(1, 126248, '\P{^Nv=+0_0_0_0_0_0_0_0_0_4_0_000}', "");
    Expect(0, 126249, '\p{Nv=+0_0_0_0_0_0_0_0_0_4_0_000}', "");
    Expect(1, 126249, '\p{^Nv=+0_0_0_0_0_0_0_0_0_4_0_000}', "");
    Expect(1, 126249, '\P{Nv=+0_0_0_0_0_0_0_0_0_4_0_000}', "");
    Expect(0, 126249, '\P{^Nv=+0_0_0_0_0_0_0_0_0_4_0_000}', "");
    Expect(1, 126248, '\p{Nv=4.000000000000000e+04}', "");
    Expect(0, 126248, '\p{^Nv=4.000000000000000e+04}', "");
    Expect(0, 126248, '\P{Nv=4.000000000000000e+04}', "");
    Expect(1, 126248, '\P{^Nv=4.000000000000000e+04}', "");
    Expect(0, 126249, '\p{Nv=4.000000000000000e+04}', "");
    Expect(1, 126249, '\p{^Nv=4.000000000000000e+04}', "");
    Expect(1, 126249, '\P{Nv=4.000000000000000e+04}', "");
    Expect(0, 126249, '\P{^Nv=4.000000000000000e+04}', "");
    Error('\p{Is_Numeric_Value:  :=004000_0}');
    Error('\P{Is_Numeric_Value:  :=004000_0}');
    Expect(1, 126248, '\p{Is_Numeric_Value=40000}', "");
    Expect(0, 126248, '\p{^Is_Numeric_Value=40000}', "");
    Expect(0, 126248, '\P{Is_Numeric_Value=40000}', "");
    Expect(1, 126248, '\P{^Is_Numeric_Value=40000}', "");
    Expect(0, 126249, '\p{Is_Numeric_Value=40000}', "");
    Expect(1, 126249, '\p{^Is_Numeric_Value=40000}', "");
    Expect(1, 126249, '\P{Is_Numeric_Value=40000}', "");
    Expect(0, 126249, '\P{^Is_Numeric_Value=40000}', "");
    Expect(1, 126248, '\p{Is_Numeric_Value=4.000000000000000e+04}', "");
    Expect(0, 126248, '\p{^Is_Numeric_Value=4.000000000000000e+04}', "");
    Expect(0, 126248, '\P{Is_Numeric_Value=4.000000000000000e+04}', "");
    Expect(1, 126248, '\P{^Is_Numeric_Value=4.000000000000000e+04}', "");
    Expect(0, 126249, '\p{Is_Numeric_Value=4.000000000000000e+04}', "");
    Expect(1, 126249, '\p{^Is_Numeric_Value=4.000000000000000e+04}', "");
    Expect(1, 126249, '\P{Is_Numeric_Value=4.000000000000000e+04}', "");
    Expect(0, 126249, '\P{^Is_Numeric_Value=4.000000000000000e+04}', "");
    Error('\p{Is_Nv=:=	_0_0_0_4_0000}');
    Error('\P{Is_Nv=:=	_0_0_0_4_0000}');
    Expect(1, 126248, '\p{Is_Nv=4000_0}', "");
    Expect(0, 126248, '\p{^Is_Nv=4000_0}', "");
    Expect(0, 126248, '\P{Is_Nv=4000_0}', "");
    Expect(1, 126248, '\P{^Is_Nv=4000_0}', "");
    Expect(0, 126249, '\p{Is_Nv=4000_0}', "");
    Expect(1, 126249, '\p{^Is_Nv=4000_0}', "");
    Expect(1, 126249, '\P{Is_Nv=4000_0}', "");
    Expect(0, 126249, '\P{^Is_Nv=4000_0}', "");
    Expect(1, 126248, '\p{Is_Nv=4.000000000000000e+04}', "");
    Expect(0, 126248, '\p{^Is_Nv=4.000000000000000e+04}', "");
    Expect(0, 126248, '\P{Is_Nv=4.000000000000000e+04}', "");
    Expect(1, 126248, '\P{^Is_Nv=4.000000000000000e+04}', "");
    Expect(0, 126249, '\p{Is_Nv=4.000000000000000e+04}', "");
    Expect(1, 126249, '\p{^Is_Nv=4.000000000000000e+04}', "");
    Expect(1, 126249, '\P{Is_Nv=4.000000000000000e+04}', "");
    Expect(0, 126249, '\P{^Is_Nv=4.000000000000000e+04}', "");
    Error('\p{Numeric_Value=:=	_400000}');
    Error('\P{Numeric_Value=:=	_400000}');
    Expect(1, 68080, '\p{Numeric_Value=:\A400000\z:}', "");;
    Expect(0, 68081, '\p{Numeric_Value=:\A400000\z:}', "");;
    Expect(1, 68080, '\p{Numeric_Value=00_04_00_000}', "");
    Expect(0, 68080, '\p{^Numeric_Value=00_04_00_000}', "");
    Expect(0, 68080, '\P{Numeric_Value=00_04_00_000}', "");
    Expect(1, 68080, '\P{^Numeric_Value=00_04_00_000}', "");
    Expect(0, 68081, '\p{Numeric_Value=00_04_00_000}', "");
    Expect(1, 68081, '\p{^Numeric_Value=00_04_00_000}', "");
    Expect(1, 68081, '\P{Numeric_Value=00_04_00_000}', "");
    Expect(0, 68081, '\P{^Numeric_Value=00_04_00_000}', "");
    Expect(1, 68080, '\p{Numeric_Value=4.000000000000000e+05}', "");
    Expect(0, 68080, '\p{^Numeric_Value=4.000000000000000e+05}', "");
    Expect(0, 68080, '\P{Numeric_Value=4.000000000000000e+05}', "");
    Expect(1, 68080, '\P{^Numeric_Value=4.000000000000000e+05}', "");
    Expect(0, 68081, '\p{Numeric_Value=4.000000000000000e+05}', "");
    Expect(1, 68081, '\p{^Numeric_Value=4.000000000000000e+05}', "");
    Expect(1, 68081, '\P{Numeric_Value=4.000000000000000e+05}', "");
    Expect(0, 68081, '\P{^Numeric_Value=4.000000000000000e+05}', "");
    Error('\p{Nv=/a/_-0_0_4_0_0_000}');
    Error('\P{Nv=/a/_-0_0_4_0_0_000}');
    Expect(1, 68080, '\p{Nv=:\A400000\z:}', "");;
    Expect(0, 68081, '\p{Nv=:\A400000\z:}', "");;
    Expect(1, 68080, '\p{Nv=+0000000400000}', "");
    Expect(0, 68080, '\p{^Nv=+0000000400000}', "");
    Expect(0, 68080, '\P{Nv=+0000000400000}', "");
    Expect(1, 68080, '\P{^Nv=+0000000400000}', "");
    Expect(0, 68081, '\p{Nv=+0000000400000}', "");
    Expect(1, 68081, '\p{^Nv=+0000000400000}', "");
    Expect(1, 68081, '\P{Nv=+0000000400000}', "");
    Expect(0, 68081, '\P{^Nv=+0000000400000}', "");
    Expect(1, 68080, '\p{Nv=4.000000000000000e+05}', "");
    Expect(0, 68080, '\p{^Nv=4.000000000000000e+05}', "");
    Expect(0, 68080, '\P{Nv=4.000000000000000e+05}', "");
    Expect(1, 68080, '\P{^Nv=4.000000000000000e+05}', "");
    Expect(0, 68081, '\p{Nv=4.000000000000000e+05}', "");
    Expect(1, 68081, '\p{^Nv=4.000000000000000e+05}', "");
    Expect(1, 68081, '\P{Nv=4.000000000000000e+05}', "");
    Expect(0, 68081, '\P{^Nv=4.000000000000000e+05}', "");
    Error('\p{Is_Numeric_Value=-/a/00_40_00_00}');
    Error('\P{Is_Numeric_Value=-/a/00_40_00_00}');
    Expect(1, 68080, '\p{Is_Numeric_Value=00000400000}', "");
    Expect(0, 68080, '\p{^Is_Numeric_Value=00000400000}', "");
    Expect(0, 68080, '\P{Is_Numeric_Value=00000400000}', "");
    Expect(1, 68080, '\P{^Is_Numeric_Value=00000400000}', "");
    Expect(0, 68081, '\p{Is_Numeric_Value=00000400000}', "");
    Expect(1, 68081, '\p{^Is_Numeric_Value=00000400000}', "");
    Expect(1, 68081, '\P{Is_Numeric_Value=00000400000}', "");
    Expect(0, 68081, '\P{^Is_Numeric_Value=00000400000}', "");
    Expect(1, 68080, '\p{Is_Numeric_Value:4.000000000000000e+05}', "");
    Expect(0, 68080, '\p{^Is_Numeric_Value:4.000000000000000e+05}', "");
    Expect(0, 68080, '\P{Is_Numeric_Value:4.000000000000000e+05}', "");
    Expect(1, 68080, '\P{^Is_Numeric_Value:4.000000000000000e+05}', "");
    Expect(0, 68081, '\p{Is_Numeric_Value:4.000000000000000e+05}', "");
    Expect(1, 68081, '\p{^Is_Numeric_Value:4.000000000000000e+05}', "");
    Expect(1, 68081, '\P{Is_Numeric_Value:4.000000000000000e+05}', "");
    Expect(0, 68081, '\P{^Is_Numeric_Value:4.000000000000000e+05}', "");
    Error('\p{Is_Nv=:= _0000000400000}');
    Error('\P{Is_Nv=:= _0000000400000}');
    Expect(1, 68080, '\p{Is_Nv=+0000_4000_00}', "");
    Expect(0, 68080, '\p{^Is_Nv=+0000_4000_00}', "");
    Expect(0, 68080, '\P{Is_Nv=+0000_4000_00}', "");
    Expect(1, 68080, '\P{^Is_Nv=+0000_4000_00}', "");
    Expect(0, 68081, '\p{Is_Nv=+0000_4000_00}', "");
    Expect(1, 68081, '\p{^Is_Nv=+0000_4000_00}', "");
    Expect(1, 68081, '\P{Is_Nv=+0000_4000_00}', "");
    Expect(0, 68081, '\P{^Is_Nv=+0000_4000_00}', "");
    Expect(1, 68080, '\p{Is_Nv=4.000000000000000e+05}', "");
    Expect(0, 68080, '\p{^Is_Nv=4.000000000000000e+05}', "");
    Expect(0, 68080, '\P{Is_Nv=4.000000000000000e+05}', "");
    Expect(1, 68080, '\P{^Is_Nv=4.000000000000000e+05}', "");
    Expect(0, 68081, '\p{Is_Nv=4.000000000000000e+05}', "");
    Expect(1, 68081, '\p{^Is_Nv=4.000000000000000e+05}', "");
    Expect(1, 68081, '\P{Is_Nv=4.000000000000000e+05}', "");
    Expect(0, 68081, '\P{^Is_Nv=4.000000000000000e+05}', "");
    Error('\p{Numeric_Value=:=-+4_1}');
    Error('\P{Numeric_Value=:=-+4_1}');
    Expect(1, 12982, '\p{Numeric_Value=:\A41\z:}', "");;
    Expect(0, 12983, '\p{Numeric_Value=:\A41\z:}', "");;
    Expect(1, 12982, '\p{Numeric_Value:   00000041}', "");
    Expect(0, 12982, '\p{^Numeric_Value:   00000041}', "");
    Expect(0, 12982, '\P{Numeric_Value:   00000041}', "");
    Expect(1, 12982, '\P{^Numeric_Value:   00000041}', "");
    Expect(0, 12983, '\p{Numeric_Value:   00000041}', "");
    Expect(1, 12983, '\p{^Numeric_Value:   00000041}', "");
    Expect(1, 12983, '\P{Numeric_Value:   00000041}', "");
    Expect(0, 12983, '\P{^Numeric_Value:   00000041}', "");
    Expect(1, 12982, '\p{Numeric_Value=4.100000000000000e+01}', "");
    Expect(0, 12982, '\p{^Numeric_Value=4.100000000000000e+01}', "");
    Expect(0, 12982, '\P{Numeric_Value=4.100000000000000e+01}', "");
    Expect(1, 12982, '\P{^Numeric_Value=4.100000000000000e+01}', "");
    Expect(0, 12983, '\p{Numeric_Value=4.100000000000000e+01}', "");
    Expect(1, 12983, '\p{^Numeric_Value=4.100000000000000e+01}', "");
    Expect(1, 12983, '\P{Numeric_Value=4.100000000000000e+01}', "");
    Expect(0, 12983, '\P{^Numeric_Value=4.100000000000000e+01}', "");
    Error('\p{Nv=	/a/0_0_41}');
    Error('\P{Nv=	/a/0_0_41}');
    Expect(1, 12982, '\p{Nv=:\A41\z:}', "");;
    Expect(0, 12983, '\p{Nv=:\A41\z:}', "");;
    Expect(1, 12982, '\p{Nv=+00000000041}', "");
    Expect(0, 12982, '\p{^Nv=+00000000041}', "");
    Expect(0, 12982, '\P{Nv=+00000000041}', "");
    Expect(1, 12982, '\P{^Nv=+00000000041}', "");
    Expect(0, 12983, '\p{Nv=+00000000041}', "");
    Expect(1, 12983, '\p{^Nv=+00000000041}', "");
    Expect(1, 12983, '\P{Nv=+00000000041}', "");
    Expect(0, 12983, '\P{^Nv=+00000000041}', "");
    Expect(1, 12982, '\p{Nv=4.100000000000000e+01}', "");
    Expect(0, 12982, '\p{^Nv=4.100000000000000e+01}', "");
    Expect(0, 12982, '\P{Nv=4.100000000000000e+01}', "");
    Expect(1, 12982, '\P{^Nv=4.100000000000000e+01}', "");
    Expect(0, 12983, '\p{Nv=4.100000000000000e+01}', "");
    Expect(1, 12983, '\p{^Nv=4.100000000000000e+01}', "");
    Expect(1, 12983, '\P{Nv=4.100000000000000e+01}', "");
    Expect(0, 12983, '\P{^Nv=4.100000000000000e+01}', "");
    Error('\p{Is_Numeric_Value=/a/_	00000000041}');
    Error('\P{Is_Numeric_Value=/a/_	00000000041}');
    Expect(1, 12982, '\p{Is_Numeric_Value=00041}', "");
    Expect(0, 12982, '\p{^Is_Numeric_Value=00041}', "");
    Expect(0, 12982, '\P{Is_Numeric_Value=00041}', "");
    Expect(1, 12982, '\P{^Is_Numeric_Value=00041}', "");
    Expect(0, 12983, '\p{Is_Numeric_Value=00041}', "");
    Expect(1, 12983, '\p{^Is_Numeric_Value=00041}', "");
    Expect(1, 12983, '\P{Is_Numeric_Value=00041}', "");
    Expect(0, 12983, '\P{^Is_Numeric_Value=00041}', "");
    Expect(1, 12982, '\p{Is_Numeric_Value=4.100000000000000e+01}', "");
    Expect(0, 12982, '\p{^Is_Numeric_Value=4.100000000000000e+01}', "");
    Expect(0, 12982, '\P{Is_Numeric_Value=4.100000000000000e+01}', "");
    Expect(1, 12982, '\P{^Is_Numeric_Value=4.100000000000000e+01}', "");
    Expect(0, 12983, '\p{Is_Numeric_Value=4.100000000000000e+01}', "");
    Expect(1, 12983, '\p{^Is_Numeric_Value=4.100000000000000e+01}', "");
    Expect(1, 12983, '\P{Is_Numeric_Value=4.100000000000000e+01}', "");
    Expect(0, 12983, '\P{^Is_Numeric_Value=4.100000000000000e+01}', "");
    Error('\p{Is_Nv=	_0_0_0_0_041:=}');
    Error('\P{Is_Nv=	_0_0_0_0_041:=}');
    Expect(1, 12982, '\p{Is_Nv=00041}', "");
    Expect(0, 12982, '\p{^Is_Nv=00041}', "");
    Expect(0, 12982, '\P{Is_Nv=00041}', "");
    Expect(1, 12982, '\P{^Is_Nv=00041}', "");
    Expect(0, 12983, '\p{Is_Nv=00041}', "");
    Expect(1, 12983, '\p{^Is_Nv=00041}', "");
    Expect(1, 12983, '\P{Is_Nv=00041}', "");
    Expect(0, 12983, '\P{^Is_Nv=00041}', "");
    Expect(1, 12982, '\p{Is_Nv=4.100000000000000e+01}', "");
    Expect(0, 12982, '\p{^Is_Nv=4.100000000000000e+01}', "");
    Expect(0, 12982, '\P{Is_Nv=4.100000000000000e+01}', "");
    Expect(1, 12982, '\P{^Is_Nv=4.100000000000000e+01}', "");
    Expect(0, 12983, '\p{Is_Nv=4.100000000000000e+01}', "");
    Expect(1, 12983, '\p{^Is_Nv=4.100000000000000e+01}', "");
    Expect(1, 12983, '\P{Is_Nv=4.100000000000000e+01}', "");
    Expect(0, 12983, '\P{^Is_Nv=4.100000000000000e+01}', "");
    Error('\p{Numeric_Value=/a/00000042}');
    Error('\P{Numeric_Value=/a/00000042}');
    Expect(1, 12983, '\p{Numeric_Value=:\A42\z:}', "");;
    Expect(0, 12984, '\p{Numeric_Value=:\A42\z:}', "");;
    Expect(1, 12983, '\p{Numeric_Value=000000042}', "");
    Expect(0, 12983, '\p{^Numeric_Value=000000042}', "");
    Expect(0, 12983, '\P{Numeric_Value=000000042}', "");
    Expect(1, 12983, '\P{^Numeric_Value=000000042}', "");
    Expect(0, 12984, '\p{Numeric_Value=000000042}', "");
    Expect(1, 12984, '\p{^Numeric_Value=000000042}', "");
    Expect(1, 12984, '\P{Numeric_Value=000000042}', "");
    Expect(0, 12984, '\P{^Numeric_Value=000000042}', "");
    Expect(1, 12983, '\p{Numeric_Value=4.200000000000000e+01}', "");
    Expect(0, 12983, '\p{^Numeric_Value=4.200000000000000e+01}', "");
    Expect(0, 12983, '\P{Numeric_Value=4.200000000000000e+01}', "");
    Expect(1, 12983, '\P{^Numeric_Value=4.200000000000000e+01}', "");
    Expect(0, 12984, '\p{Numeric_Value=4.200000000000000e+01}', "");
    Expect(1, 12984, '\p{^Numeric_Value=4.200000000000000e+01}', "");
    Expect(1, 12984, '\P{Numeric_Value=4.200000000000000e+01}', "");
    Expect(0, 12984, '\P{^Numeric_Value=4.200000000000000e+01}', "");
    Error('\p{Nv=/a/- 00_00_00_42}');
    Error('\P{Nv=/a/- 00_00_00_42}');
    Expect(1, 12983, '\p{Nv=:\A42\z:}', "");;
    Expect(0, 12984, '\p{Nv=:\A42\z:}', "");;
    Expect(1, 12983, '\p{Nv=+0000042}', "");
    Expect(0, 12983, '\p{^Nv=+0000042}', "");
    Expect(0, 12983, '\P{Nv=+0000042}', "");
    Expect(1, 12983, '\P{^Nv=+0000042}', "");
    Expect(0, 12984, '\p{Nv=+0000042}', "");
    Expect(1, 12984, '\p{^Nv=+0000042}', "");
    Expect(1, 12984, '\P{Nv=+0000042}', "");
    Expect(0, 12984, '\P{^Nv=+0000042}', "");
    Expect(1, 12983, '\p{Nv=4.200000000000000e+01}', "");
    Expect(0, 12983, '\p{^Nv=4.200000000000000e+01}', "");
    Expect(0, 12983, '\P{Nv=4.200000000000000e+01}', "");
    Expect(1, 12983, '\P{^Nv=4.200000000000000e+01}', "");
    Expect(0, 12984, '\p{Nv=4.200000000000000e+01}', "");
    Expect(1, 12984, '\p{^Nv=4.200000000000000e+01}', "");
    Expect(1, 12984, '\P{Nv=4.200000000000000e+01}', "");
    Expect(0, 12984, '\P{^Nv=4.200000000000000e+01}', "");
    Error('\p{Is_Numeric_Value=/a/-+0000042}');
    Error('\P{Is_Numeric_Value=/a/-+0000042}');
    Expect(1, 12983, '\p{Is_Numeric_Value=00000000042}', "");
    Expect(0, 12983, '\p{^Is_Numeric_Value=00000000042}', "");
    Expect(0, 12983, '\P{Is_Numeric_Value=00000000042}', "");
    Expect(1, 12983, '\P{^Is_Numeric_Value=00000000042}', "");
    Expect(0, 12984, '\p{Is_Numeric_Value=00000000042}', "");
    Expect(1, 12984, '\p{^Is_Numeric_Value=00000000042}', "");
    Expect(1, 12984, '\P{Is_Numeric_Value=00000000042}', "");
    Expect(0, 12984, '\P{^Is_Numeric_Value=00000000042}', "");
    Expect(1, 12983, '\p{Is_Numeric_Value=4.200000000000000e+01}', "");
    Expect(0, 12983, '\p{^Is_Numeric_Value=4.200000000000000e+01}', "");
    Expect(0, 12983, '\P{Is_Numeric_Value=4.200000000000000e+01}', "");
    Expect(1, 12983, '\P{^Is_Numeric_Value=4.200000000000000e+01}', "");
    Expect(0, 12984, '\p{Is_Numeric_Value=4.200000000000000e+01}', "");
    Expect(1, 12984, '\p{^Is_Numeric_Value=4.200000000000000e+01}', "");
    Expect(1, 12984, '\P{Is_Numeric_Value=4.200000000000000e+01}', "");
    Expect(0, 12984, '\P{^Is_Numeric_Value=4.200000000000000e+01}', "");
    Error('\p{Is_Nv=-_042:=}');
    Error('\P{Is_Nv=-_042:=}');
    Expect(1, 12983, '\p{Is_Nv=0_0_0_0_0042}', "");
    Expect(0, 12983, '\p{^Is_Nv=0_0_0_0_0042}', "");
    Expect(0, 12983, '\P{Is_Nv=0_0_0_0_0042}', "");
    Expect(1, 12983, '\P{^Is_Nv=0_0_0_0_0042}', "");
    Expect(0, 12984, '\p{Is_Nv=0_0_0_0_0042}', "");
    Expect(1, 12984, '\p{^Is_Nv=0_0_0_0_0042}', "");
    Expect(1, 12984, '\P{Is_Nv=0_0_0_0_0042}', "");
    Expect(0, 12984, '\P{^Is_Nv=0_0_0_0_0042}', "");
    Expect(1, 12983, '\p{Is_Nv:   4.200000000000000e+01}', "");
    Expect(0, 12983, '\p{^Is_Nv:   4.200000000000000e+01}', "");
    Expect(0, 12983, '\P{Is_Nv:   4.200000000000000e+01}', "");
    Expect(1, 12983, '\P{^Is_Nv:   4.200000000000000e+01}', "");
    Expect(0, 12984, '\p{Is_Nv:   4.200000000000000e+01}', "");
    Expect(1, 12984, '\p{^Is_Nv:   4.200000000000000e+01}', "");
    Expect(1, 12984, '\P{Is_Nv:   4.200000000000000e+01}', "");
    Expect(0, 12984, '\P{^Is_Nv:   4.200000000000000e+01}', "");
    Error('\p{Numeric_Value=_ +00000043/a/}');
    Error('\P{Numeric_Value=_ +00000043/a/}');
    Expect(1, 12984, '\p{Numeric_Value=:\A43\z:}', "");;
    Expect(0, 12985, '\p{Numeric_Value=:\A43\z:}', "");;
    Expect(1, 12984, '\p{Numeric_Value=+00000043}', "");
    Expect(0, 12984, '\p{^Numeric_Value=+00000043}', "");
    Expect(0, 12984, '\P{Numeric_Value=+00000043}', "");
    Expect(1, 12984, '\P{^Numeric_Value=+00000043}', "");
    Expect(0, 12985, '\p{Numeric_Value=+00000043}', "");
    Expect(1, 12985, '\p{^Numeric_Value=+00000043}', "");
    Expect(1, 12985, '\P{Numeric_Value=+00000043}', "");
    Expect(0, 12985, '\P{^Numeric_Value=+00000043}', "");
    Expect(1, 12984, '\p{Numeric_Value=4.300000000000000e+01}', "");
    Expect(0, 12984, '\p{^Numeric_Value=4.300000000000000e+01}', "");
    Expect(0, 12984, '\P{Numeric_Value=4.300000000000000e+01}', "");
    Expect(1, 12984, '\P{^Numeric_Value=4.300000000000000e+01}', "");
    Expect(0, 12985, '\p{Numeric_Value=4.300000000000000e+01}', "");
    Expect(1, 12985, '\p{^Numeric_Value=4.300000000000000e+01}', "");
    Expect(1, 12985, '\P{Numeric_Value=4.300000000000000e+01}', "");
    Expect(0, 12985, '\P{^Numeric_Value=4.300000000000000e+01}', "");
    Error('\p{Nv=:=__000_004_3}');
    Error('\P{Nv=:=__000_004_3}');
    Expect(1, 12984, '\p{Nv=:\A43\z:}', "");;
    Expect(0, 12985, '\p{Nv=:\A43\z:}', "");;
    Expect(1, 12984, '\p{Nv=00000000043}', "");
    Expect(0, 12984, '\p{^Nv=00000000043}', "");
    Expect(0, 12984, '\P{Nv=00000000043}', "");
    Expect(1, 12984, '\P{^Nv=00000000043}', "");
    Expect(0, 12985, '\p{Nv=00000000043}', "");
    Expect(1, 12985, '\p{^Nv=00000000043}', "");
    Expect(1, 12985, '\P{Nv=00000000043}', "");
    Expect(0, 12985, '\P{^Nv=00000000043}', "");
    Expect(1, 12984, '\p{Nv=4.300000000000000e+01}', "");
    Expect(0, 12984, '\p{^Nv=4.300000000000000e+01}', "");
    Expect(0, 12984, '\P{Nv=4.300000000000000e+01}', "");
    Expect(1, 12984, '\P{^Nv=4.300000000000000e+01}', "");
    Expect(0, 12985, '\p{Nv=4.300000000000000e+01}', "");
    Expect(1, 12985, '\p{^Nv=4.300000000000000e+01}', "");
    Expect(1, 12985, '\P{Nv=4.300000000000000e+01}', "");
    Expect(0, 12985, '\P{^Nv=4.300000000000000e+01}', "");
    Error('\p{Is_Numeric_Value:    00000043/a/}');
    Error('\P{Is_Numeric_Value:    00000043/a/}');
    Expect(1, 12984, '\p{Is_Numeric_Value=004_3}', "");
    Expect(0, 12984, '\p{^Is_Numeric_Value=004_3}', "");
    Expect(0, 12984, '\P{Is_Numeric_Value=004_3}', "");
    Expect(1, 12984, '\P{^Is_Numeric_Value=004_3}', "");
    Expect(0, 12985, '\p{Is_Numeric_Value=004_3}', "");
    Expect(1, 12985, '\p{^Is_Numeric_Value=004_3}', "");
    Expect(1, 12985, '\P{Is_Numeric_Value=004_3}', "");
    Expect(0, 12985, '\P{^Is_Numeric_Value=004_3}', "");
    Expect(1, 12984, '\p{Is_Numeric_Value=4.300000000000000e+01}', "");
    Expect(0, 12984, '\p{^Is_Numeric_Value=4.300000000000000e+01}', "");
    Expect(0, 12984, '\P{Is_Numeric_Value=4.300000000000000e+01}', "");
    Expect(1, 12984, '\P{^Is_Numeric_Value=4.300000000000000e+01}', "");
    Expect(0, 12985, '\p{Is_Numeric_Value=4.300000000000000e+01}', "");
    Expect(1, 12985, '\p{^Is_Numeric_Value=4.300000000000000e+01}', "");
    Expect(1, 12985, '\P{Is_Numeric_Value=4.300000000000000e+01}', "");
    Expect(0, 12985, '\P{^Is_Numeric_Value=4.300000000000000e+01}', "");
    Error('\p{Is_Nv=	00_00_00_00_043:=}');
    Error('\P{Is_Nv=	00_00_00_00_043:=}');
    Expect(1, 12984, '\p{Is_Nv=0_0_0_0_0_00043}', "");
    Expect(0, 12984, '\p{^Is_Nv=0_0_0_0_0_00043}', "");
    Expect(0, 12984, '\P{Is_Nv=0_0_0_0_0_00043}', "");
    Expect(1, 12984, '\P{^Is_Nv=0_0_0_0_0_00043}', "");
    Expect(0, 12985, '\p{Is_Nv=0_0_0_0_0_00043}', "");
    Expect(1, 12985, '\p{^Is_Nv=0_0_0_0_0_00043}', "");
    Expect(1, 12985, '\P{Is_Nv=0_0_0_0_0_00043}', "");
    Expect(0, 12985, '\P{^Is_Nv=0_0_0_0_0_00043}', "");
    Expect(1, 12984, '\p{Is_Nv=4.300000000000000e+01}', "");
    Expect(0, 12984, '\p{^Is_Nv=4.300000000000000e+01}', "");
    Expect(0, 12984, '\P{Is_Nv=4.300000000000000e+01}', "");
    Expect(1, 12984, '\P{^Is_Nv=4.300000000000000e+01}', "");
    Expect(0, 12985, '\p{Is_Nv=4.300000000000000e+01}', "");
    Expect(1, 12985, '\p{^Is_Nv=4.300000000000000e+01}', "");
    Expect(1, 12985, '\P{Is_Nv=4.300000000000000e+01}', "");
    Expect(0, 12985, '\P{^Is_Nv=4.300000000000000e+01}', "");
    Error('\p{Numeric_Value=	000432000:=}');
    Error('\P{Numeric_Value=	000432000:=}');
    Expect(1, 74803, '\p{Numeric_Value=:\A432000\z:}', "");;
    Expect(0, 74804, '\p{Numeric_Value=:\A432000\z:}', "");;
    Expect(1, 74803, '\p{Numeric_Value=+000432000}', "");
    Expect(0, 74803, '\p{^Numeric_Value=+000432000}', "");
    Expect(0, 74803, '\P{Numeric_Value=+000432000}', "");
    Expect(1, 74803, '\P{^Numeric_Value=+000432000}', "");
    Expect(0, 74804, '\p{Numeric_Value=+000432000}', "");
    Expect(1, 74804, '\p{^Numeric_Value=+000432000}', "");
    Expect(1, 74804, '\P{Numeric_Value=+000432000}', "");
    Expect(0, 74804, '\P{^Numeric_Value=+000432000}', "");
    Expect(1, 74803, '\p{Numeric_Value=4.320000000000000e+05}', "");
    Expect(0, 74803, '\p{^Numeric_Value=4.320000000000000e+05}', "");
    Expect(0, 74803, '\P{Numeric_Value=4.320000000000000e+05}', "");
    Expect(1, 74803, '\P{^Numeric_Value=4.320000000000000e+05}', "");
    Expect(0, 74804, '\p{Numeric_Value=4.320000000000000e+05}', "");
    Expect(1, 74804, '\p{^Numeric_Value=4.320000000000000e+05}', "");
    Expect(1, 74804, '\P{Numeric_Value=4.320000000000000e+05}', "");
    Expect(0, 74804, '\P{^Numeric_Value=4.320000000000000e+05}', "");
    Error('\p{Nv= -000_043_200_0/a/}');
    Error('\P{Nv= -000_043_200_0/a/}');
    Expect(1, 74803, '\p{Nv=:\A432000\z:}', "");;
    Expect(0, 74804, '\p{Nv=:\A432000\z:}', "");;
    Expect(1, 74803, '\p{Nv:   000432000}', "");
    Expect(0, 74803, '\p{^Nv:   000432000}', "");
    Expect(0, 74803, '\P{Nv:   000432000}', "");
    Expect(1, 74803, '\P{^Nv:   000432000}', "");
    Expect(0, 74804, '\p{Nv:   000432000}', "");
    Expect(1, 74804, '\p{^Nv:   000432000}', "");
    Expect(1, 74804, '\P{Nv:   000432000}', "");
    Expect(0, 74804, '\P{^Nv:   000432000}', "");
    Expect(1, 74803, '\p{Nv=4.320000000000000e+05}', "");
    Expect(0, 74803, '\p{^Nv=4.320000000000000e+05}', "");
    Expect(0, 74803, '\P{Nv=4.320000000000000e+05}', "");
    Expect(1, 74803, '\P{^Nv=4.320000000000000e+05}', "");
    Expect(0, 74804, '\p{Nv=4.320000000000000e+05}', "");
    Expect(1, 74804, '\p{^Nv=4.320000000000000e+05}', "");
    Expect(1, 74804, '\P{Nv=4.320000000000000e+05}', "");
    Expect(0, 74804, '\P{^Nv=4.320000000000000e+05}', "");
    Error('\p{Is_Numeric_Value= 0_0_4_3_2000/a/}');
    Error('\P{Is_Numeric_Value= 0_0_4_3_2000/a/}');
    Expect(1, 74803, '\p{Is_Numeric_Value=00000000432000}', "");
    Expect(0, 74803, '\p{^Is_Numeric_Value=00000000432000}', "");
    Expect(0, 74803, '\P{Is_Numeric_Value=00000000432000}', "");
    Expect(1, 74803, '\P{^Is_Numeric_Value=00000000432000}', "");
    Expect(0, 74804, '\p{Is_Numeric_Value=00000000432000}', "");
    Expect(1, 74804, '\p{^Is_Numeric_Value=00000000432000}', "");
    Expect(1, 74804, '\P{Is_Numeric_Value=00000000432000}', "");
    Expect(0, 74804, '\P{^Is_Numeric_Value=00000000432000}', "");
    Expect(1, 74803, '\p{Is_Numeric_Value=4.320000000000000e+05}', "");
    Expect(0, 74803, '\p{^Is_Numeric_Value=4.320000000000000e+05}', "");
    Expect(0, 74803, '\P{Is_Numeric_Value=4.320000000000000e+05}', "");
    Expect(1, 74803, '\P{^Is_Numeric_Value=4.320000000000000e+05}', "");
    Expect(0, 74804, '\p{Is_Numeric_Value=4.320000000000000e+05}', "");
    Expect(1, 74804, '\p{^Is_Numeric_Value=4.320000000000000e+05}', "");
    Expect(1, 74804, '\P{Is_Numeric_Value=4.320000000000000e+05}', "");
    Expect(0, 74804, '\P{^Is_Numeric_Value=4.320000000000000e+05}', "");
    Error('\p{Is_Nv=_/a/00432000}');
    Error('\P{Is_Nv=_/a/00432000}');
    Expect(1, 74803, '\p{Is_Nv=00_43_20_00}', "");
    Expect(0, 74803, '\p{^Is_Nv=00_43_20_00}', "");
    Expect(0, 74803, '\P{Is_Nv=00_43_20_00}', "");
    Expect(1, 74803, '\P{^Is_Nv=00_43_20_00}', "");
    Expect(0, 74804, '\p{Is_Nv=00_43_20_00}', "");
    Expect(1, 74804, '\p{^Is_Nv=00_43_20_00}', "");
    Expect(1, 74804, '\P{Is_Nv=00_43_20_00}', "");
    Expect(0, 74804, '\P{^Is_Nv=00_43_20_00}', "");
    Expect(1, 74803, '\p{Is_Nv=4.320000000000000e+05}', "");
    Expect(0, 74803, '\p{^Is_Nv=4.320000000000000e+05}', "");
    Expect(0, 74803, '\P{Is_Nv=4.320000000000000e+05}', "");
    Expect(1, 74803, '\P{^Is_Nv=4.320000000000000e+05}', "");
    Expect(0, 74804, '\p{Is_Nv=4.320000000000000e+05}', "");
    Expect(1, 74804, '\p{^Is_Nv=4.320000000000000e+05}', "");
    Expect(1, 74804, '\P{Is_Nv=4.320000000000000e+05}', "");
    Expect(0, 74804, '\P{^Is_Nv=4.320000000000000e+05}', "");
    Error('\p{Numeric_Value: :=  000000044}');
    Error('\P{Numeric_Value: :=  000000044}');
    Expect(1, 12985, '\p{Numeric_Value=:\A44\z:}', "");;
    Expect(0, 12986, '\p{Numeric_Value=:\A44\z:}', "");;
    Expect(1, 12985, '\p{Numeric_Value=00000044}', "");
    Expect(0, 12985, '\p{^Numeric_Value=00000044}', "");
    Expect(0, 12985, '\P{Numeric_Value=00000044}', "");
    Expect(1, 12985, '\P{^Numeric_Value=00000044}', "");
    Expect(0, 12986, '\p{Numeric_Value=00000044}', "");
    Expect(1, 12986, '\p{^Numeric_Value=00000044}', "");
    Expect(1, 12986, '\P{Numeric_Value=00000044}', "");
    Expect(0, 12986, '\P{^Numeric_Value=00000044}', "");
    Expect(1, 12985, '\p{Numeric_Value=4.400000000000000e+01}', "");
    Expect(0, 12985, '\p{^Numeric_Value=4.400000000000000e+01}', "");
    Expect(0, 12985, '\P{Numeric_Value=4.400000000000000e+01}', "");
    Expect(1, 12985, '\P{^Numeric_Value=4.400000000000000e+01}', "");
    Expect(0, 12986, '\p{Numeric_Value=4.400000000000000e+01}', "");
    Expect(1, 12986, '\p{^Numeric_Value=4.400000000000000e+01}', "");
    Expect(1, 12986, '\P{Numeric_Value=4.400000000000000e+01}', "");
    Expect(0, 12986, '\P{^Numeric_Value=4.400000000000000e+01}', "");
    Error('\p{Nv=_00_00_44/a/}');
    Error('\P{Nv=_00_00_44/a/}');
    Expect(1, 12985, '\p{Nv=:\A44\z:}', "");;
    Expect(0, 12986, '\p{Nv=:\A44\z:}', "");;
    Expect(1, 12985, '\p{Nv=0000044}', "");
    Expect(0, 12985, '\p{^Nv=0000044}', "");
    Expect(0, 12985, '\P{Nv=0000044}', "");
    Expect(1, 12985, '\P{^Nv=0000044}', "");
    Expect(0, 12986, '\p{Nv=0000044}', "");
    Expect(1, 12986, '\p{^Nv=0000044}', "");
    Expect(1, 12986, '\P{Nv=0000044}', "");
    Expect(0, 12986, '\P{^Nv=0000044}', "");
    Expect(1, 12985, '\p{Nv=4.400000000000000e+01}', "");
    Expect(0, 12985, '\p{^Nv=4.400000000000000e+01}', "");
    Expect(0, 12985, '\P{Nv=4.400000000000000e+01}', "");
    Expect(1, 12985, '\P{^Nv=4.400000000000000e+01}', "");
    Expect(0, 12986, '\p{Nv=4.400000000000000e+01}', "");
    Expect(1, 12986, '\p{^Nv=4.400000000000000e+01}', "");
    Expect(1, 12986, '\P{Nv=4.400000000000000e+01}', "");
    Expect(0, 12986, '\P{^Nv=4.400000000000000e+01}', "");
    Error('\p{Is_Numeric_Value=-	+00000000044/a/}');
    Error('\P{Is_Numeric_Value=-	+00000000044/a/}');
    Expect(1, 12985, '\p{Is_Numeric_Value=+4_4}', "");
    Expect(0, 12985, '\p{^Is_Numeric_Value=+4_4}', "");
    Expect(0, 12985, '\P{Is_Numeric_Value=+4_4}', "");
    Expect(1, 12985, '\P{^Is_Numeric_Value=+4_4}', "");
    Expect(0, 12986, '\p{Is_Numeric_Value=+4_4}', "");
    Expect(1, 12986, '\p{^Is_Numeric_Value=+4_4}', "");
    Expect(1, 12986, '\P{Is_Numeric_Value=+4_4}', "");
    Expect(0, 12986, '\P{^Is_Numeric_Value=+4_4}', "");
    Expect(1, 12985, '\p{Is_Numeric_Value=4.400000000000000e+01}', "");
    Expect(0, 12985, '\p{^Is_Numeric_Value=4.400000000000000e+01}', "");
    Expect(0, 12985, '\P{Is_Numeric_Value=4.400000000000000e+01}', "");
    Expect(1, 12985, '\P{^Is_Numeric_Value=4.400000000000000e+01}', "");
    Expect(0, 12986, '\p{Is_Numeric_Value=4.400000000000000e+01}', "");
    Expect(1, 12986, '\p{^Is_Numeric_Value=4.400000000000000e+01}', "");
    Expect(1, 12986, '\P{Is_Numeric_Value=4.400000000000000e+01}', "");
    Expect(0, 12986, '\P{^Is_Numeric_Value=4.400000000000000e+01}', "");
    Error('\p{Is_Nv:   := 00000000044}');
    Error('\P{Is_Nv:   := 00000000044}');
    Expect(1, 12985, '\p{Is_Nv=00_00_44}', "");
    Expect(0, 12985, '\p{^Is_Nv=00_00_44}', "");
    Expect(0, 12985, '\P{Is_Nv=00_00_44}', "");
    Expect(1, 12985, '\P{^Is_Nv=00_00_44}', "");
    Expect(0, 12986, '\p{Is_Nv=00_00_44}', "");
    Expect(1, 12986, '\p{^Is_Nv=00_00_44}', "");
    Expect(1, 12986, '\P{Is_Nv=00_00_44}', "");
    Expect(0, 12986, '\P{^Is_Nv=00_00_44}', "");
    Expect(1, 12985, '\p{Is_Nv=4.400000000000000e+01}', "");
    Expect(0, 12985, '\p{^Is_Nv=4.400000000000000e+01}', "");
    Expect(0, 12985, '\P{Is_Nv=4.400000000000000e+01}', "");
    Expect(1, 12985, '\P{^Is_Nv=4.400000000000000e+01}', "");
    Expect(0, 12986, '\p{Is_Nv=4.400000000000000e+01}', "");
    Expect(1, 12986, '\p{^Is_Nv=4.400000000000000e+01}', "");
    Expect(1, 12986, '\P{Is_Nv=4.400000000000000e+01}', "");
    Expect(0, 12986, '\P{^Is_Nv=4.400000000000000e+01}', "");
    Error('\p{Numeric_Value=-:=+0_0_0_0_0_0_045}');
    Error('\P{Numeric_Value=-:=+0_0_0_0_0_0_045}');
    Expect(1, 12986, '\p{Numeric_Value=:\A45\z:}', "");;
    Expect(0, 12987, '\p{Numeric_Value=:\A45\z:}', "");;
    Expect(1, 12986, '\p{Numeric_Value=+00045}', "");
    Expect(0, 12986, '\p{^Numeric_Value=+00045}', "");
    Expect(0, 12986, '\P{Numeric_Value=+00045}', "");
    Expect(1, 12986, '\P{^Numeric_Value=+00045}', "");
    Expect(0, 12987, '\p{Numeric_Value=+00045}', "");
    Expect(1, 12987, '\p{^Numeric_Value=+00045}', "");
    Expect(1, 12987, '\P{Numeric_Value=+00045}', "");
    Expect(0, 12987, '\P{^Numeric_Value=+00045}', "");
    Expect(1, 12986, '\p{Numeric_Value:4.500000000000000e+01}', "");
    Expect(0, 12986, '\p{^Numeric_Value:4.500000000000000e+01}', "");
    Expect(0, 12986, '\P{Numeric_Value:4.500000000000000e+01}', "");
    Expect(1, 12986, '\P{^Numeric_Value:4.500000000000000e+01}', "");
    Expect(0, 12987, '\p{Numeric_Value:4.500000000000000e+01}', "");
    Expect(1, 12987, '\p{^Numeric_Value:4.500000000000000e+01}', "");
    Expect(1, 12987, '\P{Numeric_Value:4.500000000000000e+01}', "");
    Expect(0, 12987, '\P{^Numeric_Value:4.500000000000000e+01}', "");
    Error('\p{Nv=-/a/0000_0000_45}');
    Error('\P{Nv=-/a/0000_0000_45}');
    Expect(1, 12986, '\p{Nv=:\A45\z:}', "");;
    Expect(0, 12987, '\p{Nv=:\A45\z:}', "");;
    Expect(1, 12986, '\p{Nv=0_0_0_0_0_0_045}', "");
    Expect(0, 12986, '\p{^Nv=0_0_0_0_0_0_045}', "");
    Expect(0, 12986, '\P{Nv=0_0_0_0_0_0_045}', "");
    Expect(1, 12986, '\P{^Nv=0_0_0_0_0_0_045}', "");
    Expect(0, 12987, '\p{Nv=0_0_0_0_0_0_045}', "");
    Expect(1, 12987, '\p{^Nv=0_0_0_0_0_0_045}', "");
    Expect(1, 12987, '\P{Nv=0_0_0_0_0_0_045}', "");
    Expect(0, 12987, '\P{^Nv=0_0_0_0_0_0_045}', "");
    Expect(1, 12986, '\p{Nv=4.500000000000000e+01}', "");
    Expect(0, 12986, '\p{^Nv=4.500000000000000e+01}', "");
    Expect(0, 12986, '\P{Nv=4.500000000000000e+01}', "");
    Expect(1, 12986, '\P{^Nv=4.500000000000000e+01}', "");
    Expect(0, 12987, '\p{Nv=4.500000000000000e+01}', "");
    Expect(1, 12987, '\p{^Nv=4.500000000000000e+01}', "");
    Expect(1, 12987, '\P{Nv=4.500000000000000e+01}', "");
    Expect(0, 12987, '\P{^Nv=4.500000000000000e+01}', "");
    Error('\p{Is_Numeric_Value=	/a/00000000045}');
    Error('\P{Is_Numeric_Value=	/a/00000000045}');
    Expect(1, 12986, '\p{Is_Numeric_Value=0000000045}', "");
    Expect(0, 12986, '\p{^Is_Numeric_Value=0000000045}', "");
    Expect(0, 12986, '\P{Is_Numeric_Value=0000000045}', "");
    Expect(1, 12986, '\P{^Is_Numeric_Value=0000000045}', "");
    Expect(0, 12987, '\p{Is_Numeric_Value=0000000045}', "");
    Expect(1, 12987, '\p{^Is_Numeric_Value=0000000045}', "");
    Expect(1, 12987, '\P{Is_Numeric_Value=0000000045}', "");
    Expect(0, 12987, '\P{^Is_Numeric_Value=0000000045}', "");
    Expect(1, 12986, '\p{Is_Numeric_Value=4.500000000000000e+01}', "");
    Expect(0, 12986, '\p{^Is_Numeric_Value=4.500000000000000e+01}', "");
    Expect(0, 12986, '\P{Is_Numeric_Value=4.500000000000000e+01}', "");
    Expect(1, 12986, '\P{^Is_Numeric_Value=4.500000000000000e+01}', "");
    Expect(0, 12987, '\p{Is_Numeric_Value=4.500000000000000e+01}', "");
    Expect(1, 12987, '\p{^Is_Numeric_Value=4.500000000000000e+01}', "");
    Expect(1, 12987, '\P{Is_Numeric_Value=4.500000000000000e+01}', "");
    Expect(0, 12987, '\P{^Is_Numeric_Value=4.500000000000000e+01}', "");
    Error('\p{Is_Nv=/a/-00000000045}');
    Error('\P{Is_Nv=/a/-00000000045}');
    Expect(1, 12986, '\p{Is_Nv=04_5}', "");
    Expect(0, 12986, '\p{^Is_Nv=04_5}', "");
    Expect(0, 12986, '\P{Is_Nv=04_5}', "");
    Expect(1, 12986, '\P{^Is_Nv=04_5}', "");
    Expect(0, 12987, '\p{Is_Nv=04_5}', "");
    Expect(1, 12987, '\p{^Is_Nv=04_5}', "");
    Expect(1, 12987, '\P{Is_Nv=04_5}', "");
    Expect(0, 12987, '\P{^Is_Nv=04_5}', "");
    Expect(1, 12986, '\p{Is_Nv=4.500000000000000e+01}', "");
    Expect(0, 12986, '\p{^Is_Nv=4.500000000000000e+01}', "");
    Expect(0, 12986, '\P{Is_Nv=4.500000000000000e+01}', "");
    Expect(1, 12986, '\P{^Is_Nv=4.500000000000000e+01}', "");
    Expect(0, 12987, '\p{Is_Nv=4.500000000000000e+01}', "");
    Expect(1, 12987, '\p{^Is_Nv=4.500000000000000e+01}', "");
    Expect(1, 12987, '\P{Is_Nv=4.500000000000000e+01}', "");
    Expect(0, 12987, '\P{^Is_Nv=4.500000000000000e+01}', "");
    Error('\p{Numeric_Value=_	00_00_00_46:=}');
    Error('\P{Numeric_Value=_	00_00_00_46:=}');
    Expect(1, 12987, '\p{Numeric_Value=:\A46\z:}', "");;
    Expect(0, 12988, '\p{Numeric_Value=:\A46\z:}', "");;
    Expect(1, 12987, '\p{Numeric_Value=046}', "");
    Expect(0, 12987, '\p{^Numeric_Value=046}', "");
    Expect(0, 12987, '\P{Numeric_Value=046}', "");
    Expect(1, 12987, '\P{^Numeric_Value=046}', "");
    Expect(0, 12988, '\p{Numeric_Value=046}', "");
    Expect(1, 12988, '\p{^Numeric_Value=046}', "");
    Expect(1, 12988, '\P{Numeric_Value=046}', "");
    Expect(0, 12988, '\P{^Numeric_Value=046}', "");
    Expect(1, 12987, '\p{Numeric_Value: 4.600000000000000e+01}', "");
    Expect(0, 12987, '\p{^Numeric_Value: 4.600000000000000e+01}', "");
    Expect(0, 12987, '\P{Numeric_Value: 4.600000000000000e+01}', "");
    Expect(1, 12987, '\P{^Numeric_Value: 4.600000000000000e+01}', "");
    Expect(0, 12988, '\p{Numeric_Value: 4.600000000000000e+01}', "");
    Expect(1, 12988, '\p{^Numeric_Value: 4.600000000000000e+01}', "");
    Expect(1, 12988, '\P{Numeric_Value: 4.600000000000000e+01}', "");
    Expect(0, 12988, '\P{^Numeric_Value: 4.600000000000000e+01}', "");
    Error('\p{Nv= 4_6/a/}');
    Error('\P{Nv= 4_6/a/}');
    Expect(1, 12987, '\p{Nv=:\A46\z:}', "");;
    Expect(0, 12988, '\p{Nv=:\A46\z:}', "");;
    Expect(1, 12987, '\p{Nv=+46}', "");
    Expect(0, 12987, '\p{^Nv=+46}', "");
    Expect(0, 12987, '\P{Nv=+46}', "");
    Expect(1, 12987, '\P{^Nv=+46}', "");
    Expect(0, 12988, '\p{Nv=+46}', "");
    Expect(1, 12988, '\p{^Nv=+46}', "");
    Expect(1, 12988, '\P{Nv=+46}', "");
    Expect(0, 12988, '\P{^Nv=+46}', "");
    Expect(1, 12987, '\p{Nv=4.600000000000000e+01}', "");
    Expect(0, 12987, '\p{^Nv=4.600000000000000e+01}', "");
    Expect(0, 12987, '\P{Nv=4.600000000000000e+01}', "");
    Expect(1, 12987, '\P{^Nv=4.600000000000000e+01}', "");
    Expect(0, 12988, '\p{Nv=4.600000000000000e+01}', "");
    Expect(1, 12988, '\p{^Nv=4.600000000000000e+01}', "");
    Expect(1, 12988, '\P{Nv=4.600000000000000e+01}', "");
    Expect(0, 12988, '\P{^Nv=4.600000000000000e+01}', "");
    Error('\p{Is_Numeric_Value:   	:=+0046}');
    Error('\P{Is_Numeric_Value:   	:=+0046}');
    Expect(1, 12987, '\p{Is_Numeric_Value=+00_04_6}', "");
    Expect(0, 12987, '\p{^Is_Numeric_Value=+00_04_6}', "");
    Expect(0, 12987, '\P{Is_Numeric_Value=+00_04_6}', "");
    Expect(1, 12987, '\P{^Is_Numeric_Value=+00_04_6}', "");
    Expect(0, 12988, '\p{Is_Numeric_Value=+00_04_6}', "");
    Expect(1, 12988, '\p{^Is_Numeric_Value=+00_04_6}', "");
    Expect(1, 12988, '\P{Is_Numeric_Value=+00_04_6}', "");
    Expect(0, 12988, '\P{^Is_Numeric_Value=+00_04_6}', "");
    Expect(1, 12987, '\p{Is_Numeric_Value=4.600000000000000e+01}', "");
    Expect(0, 12987, '\p{^Is_Numeric_Value=4.600000000000000e+01}', "");
    Expect(0, 12987, '\P{Is_Numeric_Value=4.600000000000000e+01}', "");
    Expect(1, 12987, '\P{^Is_Numeric_Value=4.600000000000000e+01}', "");
    Expect(0, 12988, '\p{Is_Numeric_Value=4.600000000000000e+01}', "");
    Expect(1, 12988, '\p{^Is_Numeric_Value=4.600000000000000e+01}', "");
    Expect(1, 12988, '\P{Is_Numeric_Value=4.600000000000000e+01}', "");
    Expect(0, 12988, '\P{^Is_Numeric_Value=4.600000000000000e+01}', "");
    Error('\p{Is_Nv=	 004_6/a/}');
    Error('\P{Is_Nv=	 004_6/a/}');
    Expect(1, 12987, '\p{Is_Nv=0004_6}', "");
    Expect(0, 12987, '\p{^Is_Nv=0004_6}', "");
    Expect(0, 12987, '\P{Is_Nv=0004_6}', "");
    Expect(1, 12987, '\P{^Is_Nv=0004_6}', "");
    Expect(0, 12988, '\p{Is_Nv=0004_6}', "");
    Expect(1, 12988, '\p{^Is_Nv=0004_6}', "");
    Expect(1, 12988, '\P{Is_Nv=0004_6}', "");
    Expect(0, 12988, '\P{^Is_Nv=0004_6}', "");
    Expect(1, 12987, '\p{Is_Nv=4.600000000000000e+01}', "");
    Expect(0, 12987, '\p{^Is_Nv=4.600000000000000e+01}', "");
    Expect(0, 12987, '\P{Is_Nv=4.600000000000000e+01}', "");
    Expect(1, 12987, '\P{^Is_Nv=4.600000000000000e+01}', "");
    Expect(0, 12988, '\p{Is_Nv=4.600000000000000e+01}', "");
    Expect(1, 12988, '\p{^Is_Nv=4.600000000000000e+01}', "");
    Expect(1, 12988, '\P{Is_Nv=4.600000000000000e+01}', "");
    Expect(0, 12988, '\P{^Is_Nv=4.600000000000000e+01}', "");
    Error('\p{Numeric_Value=:=_+000047}');
    Error('\P{Numeric_Value=:=_+000047}');
    Expect(1, 12988, '\p{Numeric_Value=:\A47\z:}', "");;
    Expect(0, 12989, '\p{Numeric_Value=:\A47\z:}', "");;
    Expect(1, 12988, '\p{Numeric_Value=47}', "");
    Expect(0, 12988, '\p{^Numeric_Value=47}', "");
    Expect(0, 12988, '\P{Numeric_Value=47}', "");
    Expect(1, 12988, '\P{^Numeric_Value=47}', "");
    Expect(0, 12989, '\p{Numeric_Value=47}', "");
    Expect(1, 12989, '\p{^Numeric_Value=47}', "");
    Expect(1, 12989, '\P{Numeric_Value=47}', "");
    Expect(0, 12989, '\P{^Numeric_Value=47}', "");
    Expect(1, 12988, '\p{Numeric_Value=4.700000000000000e+01}', "");
    Expect(0, 12988, '\p{^Numeric_Value=4.700000000000000e+01}', "");
    Expect(0, 12988, '\P{Numeric_Value=4.700000000000000e+01}', "");
    Expect(1, 12988, '\P{^Numeric_Value=4.700000000000000e+01}', "");
    Expect(0, 12989, '\p{Numeric_Value=4.700000000000000e+01}', "");
    Expect(1, 12989, '\p{^Numeric_Value=4.700000000000000e+01}', "");
    Expect(1, 12989, '\P{Numeric_Value=4.700000000000000e+01}', "");
    Expect(0, 12989, '\P{^Numeric_Value=4.700000000000000e+01}', "");
    Error('\p{Nv=/a/  000_004_7}');
    Error('\P{Nv=/a/  000_004_7}');
    Expect(1, 12988, '\p{Nv=:\A47\z:}', "");;
    Expect(0, 12989, '\p{Nv=:\A47\z:}', "");;
    Expect(1, 12988, '\p{Nv=00000000047}', "");
    Expect(0, 12988, '\p{^Nv=00000000047}', "");
    Expect(0, 12988, '\P{Nv=00000000047}', "");
    Expect(1, 12988, '\P{^Nv=00000000047}', "");
    Expect(0, 12989, '\p{Nv=00000000047}', "");
    Expect(1, 12989, '\p{^Nv=00000000047}', "");
    Expect(1, 12989, '\P{Nv=00000000047}', "");
    Expect(0, 12989, '\P{^Nv=00000000047}', "");
    Expect(1, 12988, '\p{Nv=4.700000000000000e+01}', "");
    Expect(0, 12988, '\p{^Nv=4.700000000000000e+01}', "");
    Expect(0, 12988, '\P{Nv=4.700000000000000e+01}', "");
    Expect(1, 12988, '\P{^Nv=4.700000000000000e+01}', "");
    Expect(0, 12989, '\p{Nv=4.700000000000000e+01}', "");
    Expect(1, 12989, '\p{^Nv=4.700000000000000e+01}', "");
    Expect(1, 12989, '\P{Nv=4.700000000000000e+01}', "");
    Expect(0, 12989, '\P{^Nv=4.700000000000000e+01}', "");
    Error('\p{Is_Numeric_Value=/a/+00000000047}');
    Error('\P{Is_Numeric_Value=/a/+00000000047}');
    Expect(1, 12988, '\p{Is_Numeric_Value=+000004_7}', "");
    Expect(0, 12988, '\p{^Is_Numeric_Value=+000004_7}', "");
    Expect(0, 12988, '\P{Is_Numeric_Value=+000004_7}', "");
    Expect(1, 12988, '\P{^Is_Numeric_Value=+000004_7}', "");
    Expect(0, 12989, '\p{Is_Numeric_Value=+000004_7}', "");
    Expect(1, 12989, '\p{^Is_Numeric_Value=+000004_7}', "");
    Expect(1, 12989, '\P{Is_Numeric_Value=+000004_7}', "");
    Expect(0, 12989, '\P{^Is_Numeric_Value=+000004_7}', "");
    Expect(1, 12988, '\p{Is_Numeric_Value=4.700000000000000e+01}', "");
    Expect(0, 12988, '\p{^Is_Numeric_Value=4.700000000000000e+01}', "");
    Expect(0, 12988, '\P{Is_Numeric_Value=4.700000000000000e+01}', "");
    Expect(1, 12988, '\P{^Is_Numeric_Value=4.700000000000000e+01}', "");
    Expect(0, 12989, '\p{Is_Numeric_Value=4.700000000000000e+01}', "");
    Expect(1, 12989, '\p{^Is_Numeric_Value=4.700000000000000e+01}', "");
    Expect(1, 12989, '\P{Is_Numeric_Value=4.700000000000000e+01}', "");
    Expect(0, 12989, '\P{^Is_Numeric_Value=4.700000000000000e+01}', "");
    Error('\p{Is_Nv=/a/00047}');
    Error('\P{Is_Nv=/a/00047}');
    Expect(1, 12988, '\p{Is_Nv:	0000000047}', "");
    Expect(0, 12988, '\p{^Is_Nv:	0000000047}', "");
    Expect(0, 12988, '\P{Is_Nv:	0000000047}', "");
    Expect(1, 12988, '\P{^Is_Nv:	0000000047}', "");
    Expect(0, 12989, '\p{Is_Nv:	0000000047}', "");
    Expect(1, 12989, '\p{^Is_Nv:	0000000047}', "");
    Expect(1, 12989, '\P{Is_Nv:	0000000047}', "");
    Expect(0, 12989, '\P{^Is_Nv:	0000000047}', "");
    Expect(1, 12988, '\p{Is_Nv=4.700000000000000e+01}', "");
    Expect(0, 12988, '\p{^Is_Nv=4.700000000000000e+01}', "");
    Expect(0, 12988, '\P{Is_Nv=4.700000000000000e+01}', "");
    Expect(1, 12988, '\P{^Is_Nv=4.700000000000000e+01}', "");
    Expect(0, 12989, '\p{Is_Nv=4.700000000000000e+01}', "");
    Expect(1, 12989, '\p{^Is_Nv=4.700000000000000e+01}', "");
    Expect(1, 12989, '\P{Is_Nv=4.700000000000000e+01}', "");
    Expect(0, 12989, '\P{^Is_Nv=4.700000000000000e+01}', "");
    Error('\p{Numeric_Value=_00048/a/}');
    Error('\P{Numeric_Value=_00048/a/}');
    Expect(1, 12989, '\p{Numeric_Value=:\A48\z:}', "");;
    Expect(0, 12990, '\p{Numeric_Value=:\A48\z:}', "");;
    Expect(1, 12989, '\p{Numeric_Value=048}', "");
    Expect(0, 12989, '\p{^Numeric_Value=048}', "");
    Expect(0, 12989, '\P{Numeric_Value=048}', "");
    Expect(1, 12989, '\P{^Numeric_Value=048}', "");
    Expect(0, 12990, '\p{Numeric_Value=048}', "");
    Expect(1, 12990, '\p{^Numeric_Value=048}', "");
    Expect(1, 12990, '\P{Numeric_Value=048}', "");
    Expect(0, 12990, '\P{^Numeric_Value=048}', "");
    Expect(1, 12989, '\p{Numeric_Value=4.800000000000000e+01}', "");
    Expect(0, 12989, '\p{^Numeric_Value=4.800000000000000e+01}', "");
    Expect(0, 12989, '\P{Numeric_Value=4.800000000000000e+01}', "");
    Expect(1, 12989, '\P{^Numeric_Value=4.800000000000000e+01}', "");
    Expect(0, 12990, '\p{Numeric_Value=4.800000000000000e+01}', "");
    Expect(1, 12990, '\p{^Numeric_Value=4.800000000000000e+01}', "");
    Expect(1, 12990, '\P{Numeric_Value=4.800000000000000e+01}', "");
    Expect(0, 12990, '\P{^Numeric_Value=4.800000000000000e+01}', "");
    Error('\p{Nv=:=_+0000048}');
    Error('\P{Nv=:=_+0000048}');
    Expect(1, 12989, '\p{Nv=:\A48\z:}', "");;
    Expect(0, 12990, '\p{Nv=:\A48\z:}', "");;
    Expect(1, 12989, '\p{Nv:	0_0_0_0_0_48}', "");
    Expect(0, 12989, '\p{^Nv:	0_0_0_0_0_48}', "");
    Expect(0, 12989, '\P{Nv:	0_0_0_0_0_48}', "");
    Expect(1, 12989, '\P{^Nv:	0_0_0_0_0_48}', "");
    Expect(0, 12990, '\p{Nv:	0_0_0_0_0_48}', "");
    Expect(1, 12990, '\p{^Nv:	0_0_0_0_0_48}', "");
    Expect(1, 12990, '\P{Nv:	0_0_0_0_0_48}', "");
    Expect(0, 12990, '\P{^Nv:	0_0_0_0_0_48}', "");
    Expect(1, 12989, '\p{Nv=4.800000000000000e+01}', "");
    Expect(0, 12989, '\p{^Nv=4.800000000000000e+01}', "");
    Expect(0, 12989, '\P{Nv=4.800000000000000e+01}', "");
    Expect(1, 12989, '\P{^Nv=4.800000000000000e+01}', "");
    Expect(0, 12990, '\p{Nv=4.800000000000000e+01}', "");
    Expect(1, 12990, '\p{^Nv=4.800000000000000e+01}', "");
    Expect(1, 12990, '\P{Nv=4.800000000000000e+01}', "");
    Expect(0, 12990, '\P{^Nv=4.800000000000000e+01}', "");
    Error('\p{Is_Numeric_Value=-000004_8:=}');
    Error('\P{Is_Numeric_Value=-000004_8:=}');
    Expect(1, 12989, '\p{Is_Numeric_Value:	0000048}', "");
    Expect(0, 12989, '\p{^Is_Numeric_Value:	0000048}', "");
    Expect(0, 12989, '\P{Is_Numeric_Value:	0000048}', "");
    Expect(1, 12989, '\P{^Is_Numeric_Value:	0000048}', "");
    Expect(0, 12990, '\p{Is_Numeric_Value:	0000048}', "");
    Expect(1, 12990, '\p{^Is_Numeric_Value:	0000048}', "");
    Expect(1, 12990, '\P{Is_Numeric_Value:	0000048}', "");
    Expect(0, 12990, '\P{^Is_Numeric_Value:	0000048}', "");
    Expect(1, 12989, '\p{Is_Numeric_Value: 4.800000000000000e+01}', "");
    Expect(0, 12989, '\p{^Is_Numeric_Value: 4.800000000000000e+01}', "");
    Expect(0, 12989, '\P{Is_Numeric_Value: 4.800000000000000e+01}', "");
    Expect(1, 12989, '\P{^Is_Numeric_Value: 4.800000000000000e+01}', "");
    Expect(0, 12990, '\p{Is_Numeric_Value: 4.800000000000000e+01}', "");
    Expect(1, 12990, '\p{^Is_Numeric_Value: 4.800000000000000e+01}', "");
    Expect(1, 12990, '\P{Is_Numeric_Value: 4.800000000000000e+01}', "");
    Expect(0, 12990, '\P{^Is_Numeric_Value: 4.800000000000000e+01}', "");
    Error('\p{Is_Nv=/a/	0_0_0_0_0_00048}');
    Error('\P{Is_Nv=/a/	0_0_0_0_0_00048}');
    Expect(1, 12989, '\p{Is_Nv=00000048}', "");
    Expect(0, 12989, '\p{^Is_Nv=00000048}', "");
    Expect(0, 12989, '\P{Is_Nv=00000048}', "");
    Expect(1, 12989, '\P{^Is_Nv=00000048}', "");
    Expect(0, 12990, '\p{Is_Nv=00000048}', "");
    Expect(1, 12990, '\p{^Is_Nv=00000048}', "");
    Expect(1, 12990, '\P{Is_Nv=00000048}', "");
    Expect(0, 12990, '\P{^Is_Nv=00000048}', "");
    Expect(1, 12989, '\p{Is_Nv:4.800000000000000e+01}', "");
    Expect(0, 12989, '\p{^Is_Nv:4.800000000000000e+01}', "");
    Expect(0, 12989, '\P{Is_Nv:4.800000000000000e+01}', "");
    Expect(1, 12989, '\P{^Is_Nv:4.800000000000000e+01}', "");
    Expect(0, 12990, '\p{Is_Nv:4.800000000000000e+01}', "");
    Expect(1, 12990, '\p{^Is_Nv:4.800000000000000e+01}', "");
    Expect(1, 12990, '\P{Is_Nv:4.800000000000000e+01}', "");
    Expect(0, 12990, '\P{^Is_Nv:4.800000000000000e+01}', "");
    Error('\p{Numeric_Value=- 00049:=}');
    Error('\P{Numeric_Value=- 00049:=}');
    Expect(1, 12990, '\p{Numeric_Value=:\A49\z:}', "");;
    Expect(0, 12991, '\p{Numeric_Value=:\A49\z:}', "");;
    Expect(1, 12990, '\p{Numeric_Value=049}', "");
    Expect(0, 12990, '\p{^Numeric_Value=049}', "");
    Expect(0, 12990, '\P{Numeric_Value=049}', "");
    Expect(1, 12990, '\P{^Numeric_Value=049}', "");
    Expect(0, 12991, '\p{Numeric_Value=049}', "");
    Expect(1, 12991, '\p{^Numeric_Value=049}', "");
    Expect(1, 12991, '\P{Numeric_Value=049}', "");
    Expect(0, 12991, '\P{^Numeric_Value=049}', "");
    Expect(1, 12990, '\p{Numeric_Value=4.900000000000000e+01}', "");
    Expect(0, 12990, '\p{^Numeric_Value=4.900000000000000e+01}', "");
    Expect(0, 12990, '\P{Numeric_Value=4.900000000000000e+01}', "");
    Expect(1, 12990, '\P{^Numeric_Value=4.900000000000000e+01}', "");
    Expect(0, 12991, '\p{Numeric_Value=4.900000000000000e+01}', "");
    Expect(1, 12991, '\p{^Numeric_Value=4.900000000000000e+01}', "");
    Expect(1, 12991, '\P{Numeric_Value=4.900000000000000e+01}', "");
    Expect(0, 12991, '\P{^Numeric_Value=4.900000000000000e+01}', "");
    Error('\p{Nv= 0049/a/}');
    Error('\P{Nv= 0049/a/}');
    Expect(1, 12990, '\p{Nv=:\A49\z:}', "");;
    Expect(0, 12991, '\p{Nv=:\A49\z:}', "");;
    Expect(1, 12990, '\p{Nv=000049}', "");
    Expect(0, 12990, '\p{^Nv=000049}', "");
    Expect(0, 12990, '\P{Nv=000049}', "");
    Expect(1, 12990, '\P{^Nv=000049}', "");
    Expect(0, 12991, '\p{Nv=000049}', "");
    Expect(1, 12991, '\p{^Nv=000049}', "");
    Expect(1, 12991, '\P{Nv=000049}', "");
    Expect(0, 12991, '\P{^Nv=000049}', "");
    Expect(1, 12990, '\p{Nv=4.900000000000000e+01}', "");
    Expect(0, 12990, '\p{^Nv=4.900000000000000e+01}', "");
    Expect(0, 12990, '\P{Nv=4.900000000000000e+01}', "");
    Expect(1, 12990, '\P{^Nv=4.900000000000000e+01}', "");
    Expect(0, 12991, '\p{Nv=4.900000000000000e+01}', "");
    Expect(1, 12991, '\p{^Nv=4.900000000000000e+01}', "");
    Expect(1, 12991, '\P{Nv=4.900000000000000e+01}', "");
    Expect(0, 12991, '\P{^Nv=4.900000000000000e+01}', "");
    Error('\p{Is_Numeric_Value=-+004_9/a/}');
    Error('\P{Is_Numeric_Value=-+004_9/a/}');
    Expect(1, 12990, '\p{Is_Numeric_Value=00_00_00_00_04_9}', "");
    Expect(0, 12990, '\p{^Is_Numeric_Value=00_00_00_00_04_9}', "");
    Expect(0, 12990, '\P{Is_Numeric_Value=00_00_00_00_04_9}', "");
    Expect(1, 12990, '\P{^Is_Numeric_Value=00_00_00_00_04_9}', "");
    Expect(0, 12991, '\p{Is_Numeric_Value=00_00_00_00_04_9}', "");
    Expect(1, 12991, '\p{^Is_Numeric_Value=00_00_00_00_04_9}', "");
    Expect(1, 12991, '\P{Is_Numeric_Value=00_00_00_00_04_9}', "");
    Expect(0, 12991, '\P{^Is_Numeric_Value=00_00_00_00_04_9}', "");
    Expect(1, 12990, '\p{Is_Numeric_Value=4.900000000000000e+01}', "");
    Expect(0, 12990, '\p{^Is_Numeric_Value=4.900000000000000e+01}', "");
    Expect(0, 12990, '\P{Is_Numeric_Value=4.900000000000000e+01}', "");
    Expect(1, 12990, '\P{^Is_Numeric_Value=4.900000000000000e+01}', "");
    Expect(0, 12991, '\p{Is_Numeric_Value=4.900000000000000e+01}', "");
    Expect(1, 12991, '\p{^Is_Numeric_Value=4.900000000000000e+01}', "");
    Expect(1, 12991, '\P{Is_Numeric_Value=4.900000000000000e+01}', "");
    Expect(0, 12991, '\P{^Is_Numeric_Value=4.900000000000000e+01}', "");
    Error('\p{Is_Nv=/a/ +4_9}');
    Error('\P{Is_Nv=/a/ +4_9}');
    Expect(1, 12990, '\p{Is_Nv:	+0000049}', "");
    Expect(0, 12990, '\p{^Is_Nv:	+0000049}', "");
    Expect(0, 12990, '\P{Is_Nv:	+0000049}', "");
    Expect(1, 12990, '\P{^Is_Nv:	+0000049}', "");
    Expect(0, 12991, '\p{Is_Nv:	+0000049}', "");
    Expect(1, 12991, '\p{^Is_Nv:	+0000049}', "");
    Expect(1, 12991, '\P{Is_Nv:	+0000049}', "");
    Expect(0, 12991, '\P{^Is_Nv:	+0000049}', "");
    Expect(1, 12990, '\p{Is_Nv=4.900000000000000e+01}', "");
    Expect(0, 12990, '\p{^Is_Nv=4.900000000000000e+01}', "");
    Expect(0, 12990, '\P{Is_Nv=4.900000000000000e+01}', "");
    Expect(1, 12990, '\P{^Is_Nv=4.900000000000000e+01}', "");
    Expect(0, 12991, '\p{Is_Nv=4.900000000000000e+01}', "");
    Expect(1, 12991, '\p{^Is_Nv=4.900000000000000e+01}', "");
    Expect(1, 12991, '\P{Is_Nv=4.900000000000000e+01}', "");
    Expect(0, 12991, '\P{^Is_Nv=4.900000000000000e+01}', "");
    Error('\p{Numeric_Value=	-5/a/}');
    Error('\P{Numeric_Value=	-5/a/}');
    Expect(1, 131361, '\p{Numeric_Value=:\A5\z:}', "");;
    Expect(0, 131362, '\p{Numeric_Value=:\A5\z:}', "");;
    Expect(1, 131361, '\p{Numeric_Value=000000005}', "");
    Expect(0, 131361, '\p{^Numeric_Value=000000005}', "");
    Expect(0, 131361, '\P{Numeric_Value=000000005}', "");
    Expect(1, 131361, '\P{^Numeric_Value=000000005}', "");
    Expect(0, 131362, '\p{Numeric_Value=000000005}', "");
    Expect(1, 131362, '\p{^Numeric_Value=000000005}', "");
    Expect(1, 131362, '\P{Numeric_Value=000000005}', "");
    Expect(0, 131362, '\P{^Numeric_Value=000000005}', "");
    Expect(1, 131361, '\p{Numeric_Value=5.000000000000000e+00}', "");
    Expect(0, 131361, '\p{^Numeric_Value=5.000000000000000e+00}', "");
    Expect(0, 131361, '\P{Numeric_Value=5.000000000000000e+00}', "");
    Expect(1, 131361, '\P{^Numeric_Value=5.000000000000000e+00}', "");
    Expect(0, 131362, '\p{Numeric_Value=5.000000000000000e+00}', "");
    Expect(1, 131362, '\p{^Numeric_Value=5.000000000000000e+00}', "");
    Expect(1, 131362, '\P{Numeric_Value=5.000000000000000e+00}', "");
    Expect(0, 131362, '\P{^Numeric_Value=5.000000000000000e+00}', "");
    Error('\p{Nv=:=0000_0000_5}');
    Error('\P{Nv=:=0000_0000_5}');
    Expect(1, 131361, '\p{Nv=:\A5\z:}', "");;
    Expect(0, 131362, '\p{Nv=:\A5\z:}', "");;
    Expect(1, 131361, '\p{Nv=+0005}', "");
    Expect(0, 131361, '\p{^Nv=+0005}', "");
    Expect(0, 131361, '\P{Nv=+0005}', "");
    Expect(1, 131361, '\P{^Nv=+0005}', "");
    Expect(0, 131362, '\p{Nv=+0005}', "");
    Expect(1, 131362, '\p{^Nv=+0005}', "");
    Expect(1, 131362, '\P{Nv=+0005}', "");
    Expect(0, 131362, '\P{^Nv=+0005}', "");
    Expect(1, 131361, '\p{Nv=5.000000000000000e+00}', "");
    Expect(0, 131361, '\p{^Nv=5.000000000000000e+00}', "");
    Expect(0, 131361, '\P{Nv=5.000000000000000e+00}', "");
    Expect(1, 131361, '\P{^Nv=5.000000000000000e+00}', "");
    Expect(0, 131362, '\p{Nv=5.000000000000000e+00}', "");
    Expect(1, 131362, '\p{^Nv=5.000000000000000e+00}', "");
    Expect(1, 131362, '\P{Nv=5.000000000000000e+00}', "");
    Expect(0, 131362, '\P{^Nv=5.000000000000000e+00}', "");
    Error('\p{Is_Numeric_Value=:= 0_5}');
    Error('\P{Is_Numeric_Value=:= 0_5}');
    Expect(1, 131361, '\p{Is_Numeric_Value:0_0_05}', "");
    Expect(0, 131361, '\p{^Is_Numeric_Value:0_0_05}', "");
    Expect(0, 131361, '\P{Is_Numeric_Value:0_0_05}', "");
    Expect(1, 131361, '\P{^Is_Numeric_Value:0_0_05}', "");
    Expect(0, 131362, '\p{Is_Numeric_Value:0_0_05}', "");
    Expect(1, 131362, '\p{^Is_Numeric_Value:0_0_05}', "");
    Expect(1, 131362, '\P{Is_Numeric_Value:0_0_05}', "");
    Expect(0, 131362, '\P{^Is_Numeric_Value:0_0_05}', "");
    Expect(1, 131361, '\p{Is_Numeric_Value=5.000000000000000e+00}', "");
    Expect(0, 131361, '\p{^Is_Numeric_Value=5.000000000000000e+00}', "");
    Expect(0, 131361, '\P{Is_Numeric_Value=5.000000000000000e+00}', "");
    Expect(1, 131361, '\P{^Is_Numeric_Value=5.000000000000000e+00}', "");
    Expect(0, 131362, '\p{Is_Numeric_Value=5.000000000000000e+00}', "");
    Expect(1, 131362, '\p{^Is_Numeric_Value=5.000000000000000e+00}', "");
    Expect(1, 131362, '\P{Is_Numeric_Value=5.000000000000000e+00}', "");
    Expect(0, 131362, '\P{^Is_Numeric_Value=5.000000000000000e+00}', "");
    Error('\p{Is_Nv=:= _00000005}');
    Error('\P{Is_Nv=:= _00000005}');
    Expect(1, 131361, '\p{Is_Nv=000005}', "");
    Expect(0, 131361, '\p{^Is_Nv=000005}', "");
    Expect(0, 131361, '\P{Is_Nv=000005}', "");
    Expect(1, 131361, '\P{^Is_Nv=000005}', "");
    Expect(0, 131362, '\p{Is_Nv=000005}', "");
    Expect(1, 131362, '\p{^Is_Nv=000005}', "");
    Expect(1, 131362, '\P{Is_Nv=000005}', "");
    Expect(0, 131362, '\P{^Is_Nv=000005}', "");
    Expect(1, 131361, '\p{Is_Nv=5.000000000000000e+00}', "");
    Expect(0, 131361, '\p{^Is_Nv=5.000000000000000e+00}', "");
    Expect(0, 131361, '\P{Is_Nv=5.000000000000000e+00}', "");
    Expect(1, 131361, '\P{^Is_Nv=5.000000000000000e+00}', "");
    Expect(0, 131362, '\p{Is_Nv=5.000000000000000e+00}', "");
    Expect(1, 131362, '\p{^Is_Nv=5.000000000000000e+00}', "");
    Expect(1, 131362, '\P{Is_Nv=5.000000000000000e+00}', "");
    Expect(0, 131362, '\P{^Is_Nv=5.000000000000000e+00}', "");
    Error('\p{Numeric_Value=-/a/0000005/00000000012}');
    Error('\P{Numeric_Value=-/a/0000005/00000000012}');
    Expect(1, 68090, '\p{Numeric_Value=:\A5/12\z:}', "");;
    Expect(0, 68091, '\p{Numeric_Value=:\A5/12\z:}', "");;
    Expect(1, 68090, '\p{Numeric_Value=0000005/12}', "");
    Expect(0, 68090, '\p{^Numeric_Value=0000005/12}', "");
    Expect(0, 68090, '\P{Numeric_Value=0000005/12}', "");
    Expect(1, 68090, '\P{^Numeric_Value=0000005/12}', "");
    Expect(0, 68091, '\p{Numeric_Value=0000005/12}', "");
    Expect(1, 68091, '\p{^Numeric_Value=0000005/12}', "");
    Expect(1, 68091, '\P{Numeric_Value=0000005/12}', "");
    Expect(0, 68091, '\P{^Numeric_Value=0000005/12}', "");
    Expect(1, 68090, '\p{Numeric_Value=300/720}', "");
    Expect(0, 68090, '\p{^Numeric_Value=300/720}', "");
    Expect(0, 68090, '\P{Numeric_Value=300/720}', "");
    Expect(1, 68090, '\P{^Numeric_Value=300/720}', "");
    Expect(0, 68091, '\p{Numeric_Value=300/720}', "");
    Expect(1, 68091, '\p{^Numeric_Value=300/720}', "");
    Expect(1, 68091, '\P{Numeric_Value=300/720}', "");
    Expect(0, 68091, '\P{^Numeric_Value=300/720}', "");
    Error('\p{Numeric_Value=4.2e-01}');
    Error('\P{Numeric_Value=4.2e-01}');
    Error('\p{Numeric_Value=4.17e-01}');
    Error('\P{Numeric_Value=4.17e-01}');
    Error('\p{Numeric_Value=0.42}');
    Error('\P{Numeric_Value=0.42}');
    Expect(1, 68090, '\p{Numeric_Value:4.167e-01}', "");
    Expect(0, 68090, '\p{^Numeric_Value:4.167e-01}', "");
    Expect(0, 68090, '\P{Numeric_Value:4.167e-01}', "");
    Expect(1, 68090, '\P{^Numeric_Value:4.167e-01}', "");
    Expect(0, 68091, '\p{Numeric_Value:4.167e-01}', "");
    Expect(1, 68091, '\p{^Numeric_Value:4.167e-01}', "");
    Expect(1, 68091, '\P{Numeric_Value:4.167e-01}', "");
    Expect(0, 68091, '\P{^Numeric_Value:4.167e-01}', "");
    Error('\p{Numeric_Value=0.417}');
    Error('\P{Numeric_Value=0.417}');
    Expect(1, 68090, '\p{Numeric_Value=4.1667e-01}', "");
    Expect(0, 68090, '\p{^Numeric_Value=4.1667e-01}', "");
    Expect(0, 68090, '\P{Numeric_Value=4.1667e-01}', "");
    Expect(1, 68090, '\P{^Numeric_Value=4.1667e-01}', "");
    Expect(0, 68091, '\p{Numeric_Value=4.1667e-01}', "");
    Expect(1, 68091, '\p{^Numeric_Value=4.1667e-01}', "");
    Expect(1, 68091, '\P{Numeric_Value=4.1667e-01}', "");
    Expect(0, 68091, '\P{^Numeric_Value=4.1667e-01}', "");
    Expect(1, 68090, '\p{Numeric_Value=0.4167}', "");
    Expect(0, 68090, '\p{^Numeric_Value=0.4167}', "");
    Expect(0, 68090, '\P{Numeric_Value=0.4167}', "");
    Expect(1, 68090, '\P{^Numeric_Value=0.4167}', "");
    Expect(0, 68091, '\p{Numeric_Value=0.4167}', "");
    Expect(1, 68091, '\p{^Numeric_Value=0.4167}', "");
    Expect(1, 68091, '\P{Numeric_Value=0.4167}', "");
    Expect(0, 68091, '\P{^Numeric_Value=0.4167}', "");
    Expect(1, 68090, '\p{Numeric_Value: 4.16667e-01}', "");
    Expect(0, 68090, '\p{^Numeric_Value: 4.16667e-01}', "");
    Expect(0, 68090, '\P{Numeric_Value: 4.16667e-01}', "");
    Expect(1, 68090, '\P{^Numeric_Value: 4.16667e-01}', "");
    Expect(0, 68091, '\p{Numeric_Value: 4.16667e-01}', "");
    Expect(1, 68091, '\p{^Numeric_Value: 4.16667e-01}', "");
    Expect(1, 68091, '\P{Numeric_Value: 4.16667e-01}', "");
    Expect(0, 68091, '\P{^Numeric_Value: 4.16667e-01}', "");
    Expect(1, 68090, '\p{Numeric_Value=0.41667}', "");
    Expect(0, 68090, '\p{^Numeric_Value=0.41667}', "");
    Expect(0, 68090, '\P{Numeric_Value=0.41667}', "");
    Expect(1, 68090, '\P{^Numeric_Value=0.41667}', "");
    Expect(0, 68091, '\p{Numeric_Value=0.41667}', "");
    Expect(1, 68091, '\p{^Numeric_Value=0.41667}', "");
    Expect(1, 68091, '\P{Numeric_Value=0.41667}', "");
    Expect(0, 68091, '\P{^Numeric_Value=0.41667}', "");
    Error('\p{Nv: 5/00012:=}');
    Error('\P{Nv: 5/00012:=}');
    Expect(1, 68090, '\p{Nv=:\A5/12\z:}', "");;
    Expect(0, 68091, '\p{Nv=:\A5/12\z:}', "");;
    Expect(1, 68090, '\p{Nv=+000005/00000000012}', "");
    Expect(0, 68090, '\p{^Nv=+000005/00000000012}', "");
    Expect(0, 68090, '\P{Nv=+000005/00000000012}', "");
    Expect(1, 68090, '\P{^Nv=+000005/00000000012}', "");
    Expect(0, 68091, '\p{Nv=+000005/00000000012}', "");
    Expect(1, 68091, '\p{^Nv=+000005/00000000012}', "");
    Expect(1, 68091, '\P{Nv=+000005/00000000012}', "");
    Expect(0, 68091, '\P{^Nv=+000005/00000000012}', "");
    Expect(1, 68090, '\p{Nv=300/720}', "");
    Expect(0, 68090, '\p{^Nv=300/720}', "");
    Expect(0, 68090, '\P{Nv=300/720}', "");
    Expect(1, 68090, '\P{^Nv=300/720}', "");
    Expect(0, 68091, '\p{Nv=300/720}', "");
    Expect(1, 68091, '\p{^Nv=300/720}', "");
    Expect(1, 68091, '\P{Nv=300/720}', "");
    Expect(0, 68091, '\P{^Nv=300/720}', "");
    Error('\p{Nv=4.2e-01}');
    Error('\P{Nv=4.2e-01}');
    Error('\p{Nv=4.17e-01}');
    Error('\P{Nv=4.17e-01}');
    Error('\p{Nv=0.42}');
    Error('\P{Nv=0.42}');
    Expect(1, 68090, '\p{Nv=4.167e-01}', "");
    Expect(0, 68090, '\p{^Nv=4.167e-01}', "");
    Expect(0, 68090, '\P{Nv=4.167e-01}', "");
    Expect(1, 68090, '\P{^Nv=4.167e-01}', "");
    Expect(0, 68091, '\p{Nv=4.167e-01}', "");
    Expect(1, 68091, '\p{^Nv=4.167e-01}', "");
    Expect(1, 68091, '\P{Nv=4.167e-01}', "");
    Expect(0, 68091, '\P{^Nv=4.167e-01}', "");
    Error('\p{Nv=0.417}');
    Error('\P{Nv=0.417}');
    Expect(1, 68090, '\p{Nv=4.1667e-01}', "");
    Expect(0, 68090, '\p{^Nv=4.1667e-01}', "");
    Expect(0, 68090, '\P{Nv=4.1667e-01}', "");
    Expect(1, 68090, '\P{^Nv=4.1667e-01}', "");
    Expect(0, 68091, '\p{Nv=4.1667e-01}', "");
    Expect(1, 68091, '\p{^Nv=4.1667e-01}', "");
    Expect(1, 68091, '\P{Nv=4.1667e-01}', "");
    Expect(0, 68091, '\P{^Nv=4.1667e-01}', "");
    Expect(1, 68090, '\p{Nv=0.4167}', "");
    Expect(0, 68090, '\p{^Nv=0.4167}', "");
    Expect(0, 68090, '\P{Nv=0.4167}', "");
    Expect(1, 68090, '\P{^Nv=0.4167}', "");
    Expect(0, 68091, '\p{Nv=0.4167}', "");
    Expect(1, 68091, '\p{^Nv=0.4167}', "");
    Expect(1, 68091, '\P{Nv=0.4167}', "");
    Expect(0, 68091, '\P{^Nv=0.4167}', "");
    Expect(1, 68090, '\p{Nv=4.16667e-01}', "");
    Expect(0, 68090, '\p{^Nv=4.16667e-01}', "");
    Expect(0, 68090, '\P{Nv=4.16667e-01}', "");
    Expect(1, 68090, '\P{^Nv=4.16667e-01}', "");
    Expect(0, 68091, '\p{Nv=4.16667e-01}', "");
    Expect(1, 68091, '\p{^Nv=4.16667e-01}', "");
    Expect(1, 68091, '\P{Nv=4.16667e-01}', "");
    Expect(0, 68091, '\P{^Nv=4.16667e-01}', "");
    Expect(1, 68090, '\p{Nv=0.41667}', "");
    Expect(0, 68090, '\p{^Nv=0.41667}', "");
    Expect(0, 68090, '\P{Nv=0.41667}', "");
    Expect(1, 68090, '\P{^Nv=0.41667}', "");
    Expect(0, 68091, '\p{Nv=0.41667}', "");
    Expect(1, 68091, '\p{^Nv=0.41667}', "");
    Expect(1, 68091, '\P{Nv=0.41667}', "");
    Expect(0, 68091, '\P{^Nv=0.41667}', "");
    Error('\p{Is_Numeric_Value=		000005/0000012/a/}');
    Error('\P{Is_Numeric_Value=		000005/0000012/a/}');
    Expect(1, 68090, '\p{Is_Numeric_Value=+00005/000000012}', "");
    Expect(0, 68090, '\p{^Is_Numeric_Value=+00005/000000012}', "");
    Expect(0, 68090, '\P{Is_Numeric_Value=+00005/000000012}', "");
    Expect(1, 68090, '\P{^Is_Numeric_Value=+00005/000000012}', "");
    Expect(0, 68091, '\p{Is_Numeric_Value=+00005/000000012}', "");
    Expect(1, 68091, '\p{^Is_Numeric_Value=+00005/000000012}', "");
    Expect(1, 68091, '\P{Is_Numeric_Value=+00005/000000012}', "");
    Expect(0, 68091, '\P{^Is_Numeric_Value=+00005/000000012}', "");
    Expect(1, 68090, '\p{Is_Numeric_Value=300/720}', "");
    Expect(0, 68090, '\p{^Is_Numeric_Value=300/720}', "");
    Expect(0, 68090, '\P{Is_Numeric_Value=300/720}', "");
    Expect(1, 68090, '\P{^Is_Numeric_Value=300/720}', "");
    Expect(0, 68091, '\p{Is_Numeric_Value=300/720}', "");
    Expect(1, 68091, '\p{^Is_Numeric_Value=300/720}', "");
    Expect(1, 68091, '\P{Is_Numeric_Value=300/720}', "");
    Expect(0, 68091, '\P{^Is_Numeric_Value=300/720}', "");
    Error('\p{Is_Numeric_Value=4.2e-01}');
    Error('\P{Is_Numeric_Value=4.2e-01}');
    Error('\p{Is_Numeric_Value=4.17e-01}');
    Error('\P{Is_Numeric_Value=4.17e-01}');
    Error('\p{Is_Numeric_Value=0.42}');
    Error('\P{Is_Numeric_Value=0.42}');
    Expect(1, 68090, '\p{Is_Numeric_Value=4.167e-01}', "");
    Expect(0, 68090, '\p{^Is_Numeric_Value=4.167e-01}', "");
    Expect(0, 68090, '\P{Is_Numeric_Value=4.167e-01}', "");
    Expect(1, 68090, '\P{^Is_Numeric_Value=4.167e-01}', "");
    Expect(0, 68091, '\p{Is_Numeric_Value=4.167e-01}', "");
    Expect(1, 68091, '\p{^Is_Numeric_Value=4.167e-01}', "");
    Expect(1, 68091, '\P{Is_Numeric_Value=4.167e-01}', "");
    Expect(0, 68091, '\P{^Is_Numeric_Value=4.167e-01}', "");
    Error('\p{Is_Numeric_Value=0.417}');
    Error('\P{Is_Numeric_Value=0.417}');
    Expect(1, 68090, '\p{Is_Numeric_Value: 4.1667e-01}', "");
    Expect(0, 68090, '\p{^Is_Numeric_Value: 4.1667e-01}', "");
    Expect(0, 68090, '\P{Is_Numeric_Value: 4.1667e-01}', "");
    Expect(1, 68090, '\P{^Is_Numeric_Value: 4.1667e-01}', "");
    Expect(0, 68091, '\p{Is_Numeric_Value: 4.1667e-01}', "");
    Expect(1, 68091, '\p{^Is_Numeric_Value: 4.1667e-01}', "");
    Expect(1, 68091, '\P{Is_Numeric_Value: 4.1667e-01}', "");
    Expect(0, 68091, '\P{^Is_Numeric_Value: 4.1667e-01}', "");
    Expect(1, 68090, '\p{Is_Numeric_Value=0.4167}', "");
    Expect(0, 68090, '\p{^Is_Numeric_Value=0.4167}', "");
    Expect(0, 68090, '\P{Is_Numeric_Value=0.4167}', "");
    Expect(1, 68090, '\P{^Is_Numeric_Value=0.4167}', "");
    Expect(0, 68091, '\p{Is_Numeric_Value=0.4167}', "");
    Expect(1, 68091, '\p{^Is_Numeric_Value=0.4167}', "");
    Expect(1, 68091, '\P{Is_Numeric_Value=0.4167}', "");
    Expect(0, 68091, '\P{^Is_Numeric_Value=0.4167}', "");
    Expect(1, 68090, '\p{Is_Numeric_Value=4.16667e-01}', "");
    Expect(0, 68090, '\p{^Is_Numeric_Value=4.16667e-01}', "");
    Expect(0, 68090, '\P{Is_Numeric_Value=4.16667e-01}', "");
    Expect(1, 68090, '\P{^Is_Numeric_Value=4.16667e-01}', "");
    Expect(0, 68091, '\p{Is_Numeric_Value=4.16667e-01}', "");
    Expect(1, 68091, '\p{^Is_Numeric_Value=4.16667e-01}', "");
    Expect(1, 68091, '\P{Is_Numeric_Value=4.16667e-01}', "");
    Expect(0, 68091, '\P{^Is_Numeric_Value=4.16667e-01}', "");
    Expect(1, 68090, '\p{Is_Numeric_Value=0.41667}', "");
    Expect(0, 68090, '\p{^Is_Numeric_Value=0.41667}', "");
    Expect(0, 68090, '\P{Is_Numeric_Value=0.41667}', "");
    Expect(1, 68090, '\P{^Is_Numeric_Value=0.41667}', "");
    Expect(0, 68091, '\p{Is_Numeric_Value=0.41667}', "");
    Expect(1, 68091, '\p{^Is_Numeric_Value=0.41667}', "");
    Expect(1, 68091, '\P{Is_Numeric_Value=0.41667}', "");
    Expect(0, 68091, '\P{^Is_Numeric_Value=0.41667}', "");
    Error('\p{Is_Nv=	+05/00012/a/}');
    Error('\P{Is_Nv=	+05/00012/a/}');
    Expect(1, 68090, '\p{Is_Nv=+0000000005/00000012}', "");
    Expect(0, 68090, '\p{^Is_Nv=+0000000005/00000012}', "");
    Expect(0, 68090, '\P{Is_Nv=+0000000005/00000012}', "");
    Expect(1, 68090, '\P{^Is_Nv=+0000000005/00000012}', "");
    Expect(0, 68091, '\p{Is_Nv=+0000000005/00000012}', "");
    Expect(1, 68091, '\p{^Is_Nv=+0000000005/00000012}', "");
    Expect(1, 68091, '\P{Is_Nv=+0000000005/00000012}', "");
    Expect(0, 68091, '\P{^Is_Nv=+0000000005/00000012}', "");
    Expect(1, 68090, '\p{Is_Nv:	300/720}', "");
    Expect(0, 68090, '\p{^Is_Nv:	300/720}', "");
    Expect(0, 68090, '\P{Is_Nv:	300/720}', "");
    Expect(1, 68090, '\P{^Is_Nv:	300/720}', "");
    Expect(0, 68091, '\p{Is_Nv:	300/720}', "");
    Expect(1, 68091, '\p{^Is_Nv:	300/720}', "");
    Expect(1, 68091, '\P{Is_Nv:	300/720}', "");
    Expect(0, 68091, '\P{^Is_Nv:	300/720}', "");
    Error('\p{Is_Nv=4.2e-01}');
    Error('\P{Is_Nv=4.2e-01}');
    Error('\p{Is_Nv=4.17e-01}');
    Error('\P{Is_Nv=4.17e-01}');
    Error('\p{Is_Nv=0.42}');
    Error('\P{Is_Nv=0.42}');
    Expect(1, 68090, '\p{Is_Nv:4.167e-01}', "");
    Expect(0, 68090, '\p{^Is_Nv:4.167e-01}', "");
    Expect(0, 68090, '\P{Is_Nv:4.167e-01}', "");
    Expect(1, 68090, '\P{^Is_Nv:4.167e-01}', "");
    Expect(0, 68091, '\p{Is_Nv:4.167e-01}', "");
    Expect(1, 68091, '\p{^Is_Nv:4.167e-01}', "");
    Expect(1, 68091, '\P{Is_Nv:4.167e-01}', "");
    Expect(0, 68091, '\P{^Is_Nv:4.167e-01}', "");
    Error('\p{Is_Nv=0.417}');
    Error('\P{Is_Nv=0.417}');
    Expect(1, 68090, '\p{Is_Nv:	4.1667e-01}', "");
    Expect(0, 68090, '\p{^Is_Nv:	4.1667e-01}', "");
    Expect(0, 68090, '\P{Is_Nv:	4.1667e-01}', "");
    Expect(1, 68090, '\P{^Is_Nv:	4.1667e-01}', "");
    Expect(0, 68091, '\p{Is_Nv:	4.1667e-01}', "");
    Expect(1, 68091, '\p{^Is_Nv:	4.1667e-01}', "");
    Expect(1, 68091, '\P{Is_Nv:	4.1667e-01}', "");
    Expect(0, 68091, '\P{^Is_Nv:	4.1667e-01}', "");
    Expect(1, 68090, '\p{Is_Nv=0.4167}', "");
    Expect(0, 68090, '\p{^Is_Nv=0.4167}', "");
    Expect(0, 68090, '\P{Is_Nv=0.4167}', "");
    Expect(1, 68090, '\P{^Is_Nv=0.4167}', "");
    Expect(0, 68091, '\p{Is_Nv=0.4167}', "");
    Expect(1, 68091, '\p{^Is_Nv=0.4167}', "");
    Expect(1, 68091, '\P{Is_Nv=0.4167}', "");
    Expect(0, 68091, '\P{^Is_Nv=0.4167}', "");
    Expect(1, 68090, '\p{Is_Nv=4.16667e-01}', "");
    Expect(0, 68090, '\p{^Is_Nv=4.16667e-01}', "");
    Expect(0, 68090, '\P{Is_Nv=4.16667e-01}', "");
    Expect(1, 68090, '\P{^Is_Nv=4.16667e-01}', "");
    Expect(0, 68091, '\p{Is_Nv=4.16667e-01}', "");
    Expect(1, 68091, '\p{^Is_Nv=4.16667e-01}', "");
    Expect(1, 68091, '\P{Is_Nv=4.16667e-01}', "");
    Expect(0, 68091, '\P{^Is_Nv=4.16667e-01}', "");
    Expect(1, 68090, '\p{Is_Nv=0.41667}', "");
    Expect(0, 68090, '\p{^Is_Nv=0.41667}', "");
    Expect(0, 68090, '\P{Is_Nv=0.41667}', "");
    Expect(1, 68090, '\P{^Is_Nv=0.41667}', "");
    Expect(0, 68091, '\p{Is_Nv=0.41667}', "");
    Expect(1, 68091, '\p{^Is_Nv=0.41667}', "");
    Expect(1, 68091, '\P{Is_Nv=0.41667}', "");
    Expect(0, 68091, '\P{^Is_Nv=0.41667}', "");
    Error('\p{Numeric_Value=/a/	-05/00002}');
    Error('\P{Numeric_Value=/a/	-05/00002}');
    Expect(1, 3884, '\p{Numeric_Value=:\A5/2\z:}', "");;
    Expect(0, 3885, '\p{Numeric_Value=:\A5/2\z:}', "");;
    Expect(1, 3884, '\p{Numeric_Value=05/000000002}', "");
    Expect(0, 3884, '\p{^Numeric_Value=05/000000002}', "");
    Expect(0, 3884, '\P{Numeric_Value=05/000000002}', "");
    Expect(1, 3884, '\P{^Numeric_Value=05/000000002}', "");
    Expect(0, 3885, '\p{Numeric_Value=05/000000002}', "");
    Expect(1, 3885, '\p{^Numeric_Value=05/000000002}', "");
    Expect(1, 3885, '\P{Numeric_Value=05/000000002}', "");
    Expect(0, 3885, '\P{^Numeric_Value=05/000000002}', "");
    Expect(1, 3884, '\p{Numeric_Value=300/120}', "");
    Expect(0, 3884, '\p{^Numeric_Value=300/120}', "");
    Expect(0, 3884, '\P{Numeric_Value=300/120}', "");
    Expect(1, 3884, '\P{^Numeric_Value=300/120}', "");
    Expect(0, 3885, '\p{Numeric_Value=300/120}', "");
    Expect(1, 3885, '\p{^Numeric_Value=300/120}', "");
    Expect(1, 3885, '\P{Numeric_Value=300/120}', "");
    Expect(0, 3885, '\P{^Numeric_Value=300/120}', "");
    Expect(1, 3884, '\p{Numeric_Value=2.5e+00}', "");
    Expect(0, 3884, '\p{^Numeric_Value=2.5e+00}', "");
    Expect(0, 3884, '\P{Numeric_Value=2.5e+00}', "");
    Expect(1, 3884, '\P{^Numeric_Value=2.5e+00}', "");
    Expect(0, 3885, '\p{Numeric_Value=2.5e+00}', "");
    Expect(1, 3885, '\p{^Numeric_Value=2.5e+00}', "");
    Expect(1, 3885, '\P{Numeric_Value=2.5e+00}', "");
    Expect(0, 3885, '\P{^Numeric_Value=2.5e+00}', "");
    Expect(1, 3884, '\p{Numeric_Value=2.5}', "");
    Expect(0, 3884, '\p{^Numeric_Value=2.5}', "");
    Expect(0, 3884, '\P{Numeric_Value=2.5}', "");
    Expect(1, 3884, '\P{^Numeric_Value=2.5}', "");
    Expect(0, 3885, '\p{Numeric_Value=2.5}', "");
    Expect(1, 3885, '\p{^Numeric_Value=2.5}', "");
    Expect(1, 3885, '\P{Numeric_Value=2.5}', "");
    Expect(0, 3885, '\P{^Numeric_Value=2.5}', "");
    Expect(1, 3884, '\p{Numeric_Value=2.50e+00}', "");
    Expect(0, 3884, '\p{^Numeric_Value=2.50e+00}', "");
    Expect(0, 3884, '\P{Numeric_Value=2.50e+00}', "");
    Expect(1, 3884, '\P{^Numeric_Value=2.50e+00}', "");
    Expect(0, 3885, '\p{Numeric_Value=2.50e+00}', "");
    Expect(1, 3885, '\p{^Numeric_Value=2.50e+00}', "");
    Expect(1, 3885, '\P{Numeric_Value=2.50e+00}', "");
    Expect(0, 3885, '\P{^Numeric_Value=2.50e+00}', "");
    Expect(1, 3884, '\p{Numeric_Value=2.50}', "");
    Expect(0, 3884, '\p{^Numeric_Value=2.50}', "");
    Expect(0, 3884, '\P{Numeric_Value=2.50}', "");
    Expect(1, 3884, '\P{^Numeric_Value=2.50}', "");
    Expect(0, 3885, '\p{Numeric_Value=2.50}', "");
    Expect(1, 3885, '\p{^Numeric_Value=2.50}', "");
    Expect(1, 3885, '\P{Numeric_Value=2.50}', "");
    Expect(0, 3885, '\P{^Numeric_Value=2.50}', "");
    Error('\p{Nv=_:=000005/002}');
    Error('\P{Nv=_:=000005/002}');
    Expect(1, 3884, '\p{Nv=:\A5/2\z:}', "");;
    Expect(0, 3885, '\p{Nv=:\A5/2\z:}', "");;
    Expect(1, 3884, '\p{Nv=0005/000000002}', "");
    Expect(0, 3884, '\p{^Nv=0005/000000002}', "");
    Expect(0, 3884, '\P{Nv=0005/000000002}', "");
    Expect(1, 3884, '\P{^Nv=0005/000000002}', "");
    Expect(0, 3885, '\p{Nv=0005/000000002}', "");
    Expect(1, 3885, '\p{^Nv=0005/000000002}', "");
    Expect(1, 3885, '\P{Nv=0005/000000002}', "");
    Expect(0, 3885, '\P{^Nv=0005/000000002}', "");
    Expect(1, 3884, '\p{Nv=300/120}', "");
    Expect(0, 3884, '\p{^Nv=300/120}', "");
    Expect(0, 3884, '\P{Nv=300/120}', "");
    Expect(1, 3884, '\P{^Nv=300/120}', "");
    Expect(0, 3885, '\p{Nv=300/120}', "");
    Expect(1, 3885, '\p{^Nv=300/120}', "");
    Expect(1, 3885, '\P{Nv=300/120}', "");
    Expect(0, 3885, '\P{^Nv=300/120}', "");
    Expect(1, 3884, '\p{Nv:	2.5e+00}', "");
    Expect(0, 3884, '\p{^Nv:	2.5e+00}', "");
    Expect(0, 3884, '\P{Nv:	2.5e+00}', "");
    Expect(1, 3884, '\P{^Nv:	2.5e+00}', "");
    Expect(0, 3885, '\p{Nv:	2.5e+00}', "");
    Expect(1, 3885, '\p{^Nv:	2.5e+00}', "");
    Expect(1, 3885, '\P{Nv:	2.5e+00}', "");
    Expect(0, 3885, '\P{^Nv:	2.5e+00}', "");
    Expect(1, 3884, '\p{Nv=2.5}', "");
    Expect(0, 3884, '\p{^Nv=2.5}', "");
    Expect(0, 3884, '\P{Nv=2.5}', "");
    Expect(1, 3884, '\P{^Nv=2.5}', "");
    Expect(0, 3885, '\p{Nv=2.5}', "");
    Expect(1, 3885, '\p{^Nv=2.5}', "");
    Expect(1, 3885, '\P{Nv=2.5}', "");
    Expect(0, 3885, '\P{^Nv=2.5}', "");
    Expect(1, 3884, '\p{Nv=2.50e+00}', "");
    Expect(0, 3884, '\p{^Nv=2.50e+00}', "");
    Expect(0, 3884, '\P{Nv=2.50e+00}', "");
    Expect(1, 3884, '\P{^Nv=2.50e+00}', "");
    Expect(0, 3885, '\p{Nv=2.50e+00}', "");
    Expect(1, 3885, '\p{^Nv=2.50e+00}', "");
    Expect(1, 3885, '\P{Nv=2.50e+00}', "");
    Expect(0, 3885, '\P{^Nv=2.50e+00}', "");
    Expect(1, 3884, '\p{Nv=2.50}', "");
    Expect(0, 3884, '\p{^Nv=2.50}', "");
    Expect(0, 3884, '\P{Nv=2.50}', "");
    Expect(1, 3884, '\P{^Nv=2.50}', "");
    Expect(0, 3885, '\p{Nv=2.50}', "");
    Expect(1, 3885, '\p{^Nv=2.50}', "");
    Expect(1, 3885, '\P{Nv=2.50}', "");
    Expect(0, 3885, '\P{^Nv=2.50}', "");
    Error('\p{Is_Numeric_Value::=	-00000005/02}');
    Error('\P{Is_Numeric_Value::=	-00000005/02}');
    Expect(1, 3884, '\p{Is_Numeric_Value:+0000005/02}', "");
    Expect(0, 3884, '\p{^Is_Numeric_Value:+0000005/02}', "");
    Expect(0, 3884, '\P{Is_Numeric_Value:+0000005/02}', "");
    Expect(1, 3884, '\P{^Is_Numeric_Value:+0000005/02}', "");
    Expect(0, 3885, '\p{Is_Numeric_Value:+0000005/02}', "");
    Expect(1, 3885, '\p{^Is_Numeric_Value:+0000005/02}', "");
    Expect(1, 3885, '\P{Is_Numeric_Value:+0000005/02}', "");
    Expect(0, 3885, '\P{^Is_Numeric_Value:+0000005/02}', "");
    Expect(1, 3884, '\p{Is_Numeric_Value=300/120}', "");
    Expect(0, 3884, '\p{^Is_Numeric_Value=300/120}', "");
    Expect(0, 3884, '\P{Is_Numeric_Value=300/120}', "");
    Expect(1, 3884, '\P{^Is_Numeric_Value=300/120}', "");
    Expect(0, 3885, '\p{Is_Numeric_Value=300/120}', "");
    Expect(1, 3885, '\p{^Is_Numeric_Value=300/120}', "");
    Expect(1, 3885, '\P{Is_Numeric_Value=300/120}', "");
    Expect(0, 3885, '\P{^Is_Numeric_Value=300/120}', "");
    Expect(1, 3884, '\p{Is_Numeric_Value=2.5e+00}', "");
    Expect(0, 3884, '\p{^Is_Numeric_Value=2.5e+00}', "");
    Expect(0, 3884, '\P{Is_Numeric_Value=2.5e+00}', "");
    Expect(1, 3884, '\P{^Is_Numeric_Value=2.5e+00}', "");
    Expect(0, 3885, '\p{Is_Numeric_Value=2.5e+00}', "");
    Expect(1, 3885, '\p{^Is_Numeric_Value=2.5e+00}', "");
    Expect(1, 3885, '\P{Is_Numeric_Value=2.5e+00}', "");
    Expect(0, 3885, '\P{^Is_Numeric_Value=2.5e+00}', "");
    Expect(1, 3884, '\p{Is_Numeric_Value=2.5}', "");
    Expect(0, 3884, '\p{^Is_Numeric_Value=2.5}', "");
    Expect(0, 3884, '\P{Is_Numeric_Value=2.5}', "");
    Expect(1, 3884, '\P{^Is_Numeric_Value=2.5}', "");
    Expect(0, 3885, '\p{Is_Numeric_Value=2.5}', "");
    Expect(1, 3885, '\p{^Is_Numeric_Value=2.5}', "");
    Expect(1, 3885, '\P{Is_Numeric_Value=2.5}', "");
    Expect(0, 3885, '\P{^Is_Numeric_Value=2.5}', "");
    Expect(1, 3884, '\p{Is_Numeric_Value=2.50e+00}', "");
    Expect(0, 3884, '\p{^Is_Numeric_Value=2.50e+00}', "");
    Expect(0, 3884, '\P{Is_Numeric_Value=2.50e+00}', "");
    Expect(1, 3884, '\P{^Is_Numeric_Value=2.50e+00}', "");
    Expect(0, 3885, '\p{Is_Numeric_Value=2.50e+00}', "");
    Expect(1, 3885, '\p{^Is_Numeric_Value=2.50e+00}', "");
    Expect(1, 3885, '\P{Is_Numeric_Value=2.50e+00}', "");
    Expect(0, 3885, '\P{^Is_Numeric_Value=2.50e+00}', "");
    Expect(1, 3884, '\p{Is_Numeric_Value=2.50}', "");
    Expect(0, 3884, '\p{^Is_Numeric_Value=2.50}', "");
    Expect(0, 3884, '\P{Is_Numeric_Value=2.50}', "");
    Expect(1, 3884, '\P{^Is_Numeric_Value=2.50}', "");
    Expect(0, 3885, '\p{Is_Numeric_Value=2.50}', "");
    Expect(1, 3885, '\p{^Is_Numeric_Value=2.50}', "");
    Expect(1, 3885, '\P{Is_Numeric_Value=2.50}', "");
    Expect(0, 3885, '\P{^Is_Numeric_Value=2.50}', "");
    Error('\p{Is_Nv= /a/000005/000002}');
    Error('\P{Is_Nv= /a/000005/000002}');
    Expect(1, 3884, '\p{Is_Nv=000000005/00000002}', "");
    Expect(0, 3884, '\p{^Is_Nv=000000005/00000002}', "");
    Expect(0, 3884, '\P{Is_Nv=000000005/00000002}', "");
    Expect(1, 3884, '\P{^Is_Nv=000000005/00000002}', "");
    Expect(0, 3885, '\p{Is_Nv=000000005/00000002}', "");
    Expect(1, 3885, '\p{^Is_Nv=000000005/00000002}', "");
    Expect(1, 3885, '\P{Is_Nv=000000005/00000002}', "");
    Expect(0, 3885, '\P{^Is_Nv=000000005/00000002}', "");
    Expect(1, 3884, '\p{Is_Nv=300/120}', "");
    Expect(0, 3884, '\p{^Is_Nv=300/120}', "");
    Expect(0, 3884, '\P{Is_Nv=300/120}', "");
    Expect(1, 3884, '\P{^Is_Nv=300/120}', "");
    Expect(0, 3885, '\p{Is_Nv=300/120}', "");
    Expect(1, 3885, '\p{^Is_Nv=300/120}', "");
    Expect(1, 3885, '\P{Is_Nv=300/120}', "");
    Expect(0, 3885, '\P{^Is_Nv=300/120}', "");
    Expect(1, 3884, '\p{Is_Nv=2.5e+00}', "");
    Expect(0, 3884, '\p{^Is_Nv=2.5e+00}', "");
    Expect(0, 3884, '\P{Is_Nv=2.5e+00}', "");
    Expect(1, 3884, '\P{^Is_Nv=2.5e+00}', "");
    Expect(0, 3885, '\p{Is_Nv=2.5e+00}', "");
    Expect(1, 3885, '\p{^Is_Nv=2.5e+00}', "");
    Expect(1, 3885, '\P{Is_Nv=2.5e+00}', "");
    Expect(0, 3885, '\P{^Is_Nv=2.5e+00}', "");
    Expect(1, 3884, '\p{Is_Nv=2.5}', "");
    Expect(0, 3884, '\p{^Is_Nv=2.5}', "");
    Expect(0, 3884, '\P{Is_Nv=2.5}', "");
    Expect(1, 3884, '\P{^Is_Nv=2.5}', "");
    Expect(0, 3885, '\p{Is_Nv=2.5}', "");
    Expect(1, 3885, '\p{^Is_Nv=2.5}', "");
    Expect(1, 3885, '\P{Is_Nv=2.5}', "");
    Expect(0, 3885, '\P{^Is_Nv=2.5}', "");
    Expect(1, 3884, '\p{Is_Nv=2.50e+00}', "");
    Expect(0, 3884, '\p{^Is_Nv=2.50e+00}', "");
    Expect(0, 3884, '\P{Is_Nv=2.50e+00}', "");
    Expect(1, 3884, '\P{^Is_Nv=2.50e+00}', "");
    Expect(0, 3885, '\p{Is_Nv=2.50e+00}', "");
    Expect(1, 3885, '\p{^Is_Nv=2.50e+00}', "");
    Expect(1, 3885, '\P{Is_Nv=2.50e+00}', "");
    Expect(0, 3885, '\P{^Is_Nv=2.50e+00}', "");
    Expect(1, 3884, '\p{Is_Nv=2.50}', "");
    Expect(0, 3884, '\p{^Is_Nv=2.50}', "");
    Expect(0, 3884, '\P{Is_Nv=2.50}', "");
    Expect(1, 3884, '\P{^Is_Nv=2.50}', "");
    Expect(0, 3885, '\p{Is_Nv=2.50}', "");
    Expect(1, 3885, '\p{^Is_Nv=2.50}', "");
    Expect(1, 3885, '\P{Is_Nv=2.50}', "");
    Expect(0, 3885, '\P{^Is_Nv=2.50}', "");
    Error('\p{Numeric_Value=-/a/00000005/000006}');
    Error('\P{Numeric_Value=-/a/00000005/000006}');
    Expect(1, 74844, '\p{Numeric_Value=:\A5/6\z:}', "");;
    Expect(0, 74845, '\p{Numeric_Value=:\A5/6\z:}', "");;
    Expect(1, 74844, '\p{Numeric_Value=05/00000006}', "");
    Expect(0, 74844, '\p{^Numeric_Value=05/00000006}', "");
    Expect(0, 74844, '\P{Numeric_Value=05/00000006}', "");
    Expect(1, 74844, '\P{^Numeric_Value=05/00000006}', "");
    Expect(0, 74845, '\p{Numeric_Value=05/00000006}', "");
    Expect(1, 74845, '\p{^Numeric_Value=05/00000006}', "");
    Expect(1, 74845, '\P{Numeric_Value=05/00000006}', "");
    Expect(0, 74845, '\P{^Numeric_Value=05/00000006}', "");
    Expect(1, 74844, '\p{Numeric_Value=300/360}', "");
    Expect(0, 74844, '\p{^Numeric_Value=300/360}', "");
    Expect(0, 74844, '\P{Numeric_Value=300/360}', "");
    Expect(1, 74844, '\P{^Numeric_Value=300/360}', "");
    Expect(0, 74845, '\p{Numeric_Value=300/360}', "");
    Expect(1, 74845, '\p{^Numeric_Value=300/360}', "");
    Expect(1, 74845, '\P{Numeric_Value=300/360}', "");
    Expect(0, 74845, '\P{^Numeric_Value=300/360}', "");
    Error('\p{Numeric_Value=8.3e-01}');
    Error('\P{Numeric_Value=8.3e-01}');
    Error('\p{Numeric_Value=8.33e-01}');
    Error('\P{Numeric_Value=8.33e-01}');
    Error('\p{Numeric_Value=0.83}');
    Error('\P{Numeric_Value=0.83}');
    Expect(1, 74844, '\p{Numeric_Value=8.333e-01}', "");
    Expect(0, 74844, '\p{^Numeric_Value=8.333e-01}', "");
    Expect(0, 74844, '\P{Numeric_Value=8.333e-01}', "");
    Expect(1, 74844, '\P{^Numeric_Value=8.333e-01}', "");
    Expect(0, 74845, '\p{Numeric_Value=8.333e-01}', "");
    Expect(1, 74845, '\p{^Numeric_Value=8.333e-01}', "");
    Expect(1, 74845, '\P{Numeric_Value=8.333e-01}', "");
    Expect(0, 74845, '\P{^Numeric_Value=8.333e-01}', "");
    Error('\p{Numeric_Value=0.833}');
    Error('\P{Numeric_Value=0.833}');
    Expect(1, 74844, '\p{Numeric_Value=8.3333e-01}', "");
    Expect(0, 74844, '\p{^Numeric_Value=8.3333e-01}', "");
    Expect(0, 74844, '\P{Numeric_Value=8.3333e-01}', "");
    Expect(1, 74844, '\P{^Numeric_Value=8.3333e-01}', "");
    Expect(0, 74845, '\p{Numeric_Value=8.3333e-01}', "");
    Expect(1, 74845, '\p{^Numeric_Value=8.3333e-01}', "");
    Expect(1, 74845, '\P{Numeric_Value=8.3333e-01}', "");
    Expect(0, 74845, '\P{^Numeric_Value=8.3333e-01}', "");
    Expect(1, 74844, '\p{Numeric_Value=0.8333}', "");
    Expect(0, 74844, '\p{^Numeric_Value=0.8333}', "");
    Expect(0, 74844, '\P{Numeric_Value=0.8333}', "");
    Expect(1, 74844, '\P{^Numeric_Value=0.8333}', "");
    Expect(0, 74845, '\p{Numeric_Value=0.8333}', "");
    Expect(1, 74845, '\p{^Numeric_Value=0.8333}', "");
    Expect(1, 74845, '\P{Numeric_Value=0.8333}', "");
    Expect(0, 74845, '\P{^Numeric_Value=0.8333}', "");
    Expect(1, 74844, '\p{Numeric_Value=8.33333e-01}', "");
    Expect(0, 74844, '\p{^Numeric_Value=8.33333e-01}', "");
    Expect(0, 74844, '\P{Numeric_Value=8.33333e-01}', "");
    Expect(1, 74844, '\P{^Numeric_Value=8.33333e-01}', "");
    Expect(0, 74845, '\p{Numeric_Value=8.33333e-01}', "");
    Expect(1, 74845, '\p{^Numeric_Value=8.33333e-01}', "");
    Expect(1, 74845, '\P{Numeric_Value=8.33333e-01}', "");
    Expect(0, 74845, '\P{^Numeric_Value=8.33333e-01}', "");
    Expect(1, 74844, '\p{Numeric_Value:   0.83333}', "");
    Expect(0, 74844, '\p{^Numeric_Value:   0.83333}', "");
    Expect(0, 74844, '\P{Numeric_Value:   0.83333}', "");
    Expect(1, 74844, '\P{^Numeric_Value:   0.83333}', "");
    Expect(0, 74845, '\p{Numeric_Value:   0.83333}', "");
    Expect(1, 74845, '\p{^Numeric_Value:   0.83333}', "");
    Expect(1, 74845, '\P{Numeric_Value:   0.83333}', "");
    Expect(0, 74845, '\P{^Numeric_Value:   0.83333}', "");
    Error('\p{Nv:	:=- 00000005/0000006}');
    Error('\P{Nv:	:=- 00000005/0000006}');
    Expect(1, 74844, '\p{Nv=:\A5/6\z:}', "");;
    Expect(0, 74845, '\p{Nv=:\A5/6\z:}', "");;
    Expect(1, 74844, '\p{Nv=+00005/0006}', "");
    Expect(0, 74844, '\p{^Nv=+00005/0006}', "");
    Expect(0, 74844, '\P{Nv=+00005/0006}', "");
    Expect(1, 74844, '\P{^Nv=+00005/0006}', "");
    Expect(0, 74845, '\p{Nv=+00005/0006}', "");
    Expect(1, 74845, '\p{^Nv=+00005/0006}', "");
    Expect(1, 74845, '\P{Nv=+00005/0006}', "");
    Expect(0, 74845, '\P{^Nv=+00005/0006}', "");
    Expect(1, 74844, '\p{Nv:	300/360}', "");
    Expect(0, 74844, '\p{^Nv:	300/360}', "");
    Expect(0, 74844, '\P{Nv:	300/360}', "");
    Expect(1, 74844, '\P{^Nv:	300/360}', "");
    Expect(0, 74845, '\p{Nv:	300/360}', "");
    Expect(1, 74845, '\p{^Nv:	300/360}', "");
    Expect(1, 74845, '\P{Nv:	300/360}', "");
    Expect(0, 74845, '\P{^Nv:	300/360}', "");
    Error('\p{Nv=8.3e-01}');
    Error('\P{Nv=8.3e-01}');
    Error('\p{Nv=8.33e-01}');
    Error('\P{Nv=8.33e-01}');
    Error('\p{Nv=0.83}');
    Error('\P{Nv=0.83}');
    Expect(1, 74844, '\p{Nv=8.333e-01}', "");
    Expect(0, 74844, '\p{^Nv=8.333e-01}', "");
    Expect(0, 74844, '\P{Nv=8.333e-01}', "");
    Expect(1, 74844, '\P{^Nv=8.333e-01}', "");
    Expect(0, 74845, '\p{Nv=8.333e-01}', "");
    Expect(1, 74845, '\p{^Nv=8.333e-01}', "");
    Expect(1, 74845, '\P{Nv=8.333e-01}', "");
    Expect(0, 74845, '\P{^Nv=8.333e-01}', "");
    Error('\p{Nv:	0.833}');
    Error('\P{Nv:	0.833}');
    Expect(1, 74844, '\p{Nv=8.3333e-01}', "");
    Expect(0, 74844, '\p{^Nv=8.3333e-01}', "");
    Expect(0, 74844, '\P{Nv=8.3333e-01}', "");
    Expect(1, 74844, '\P{^Nv=8.3333e-01}', "");
    Expect(0, 74845, '\p{Nv=8.3333e-01}', "");
    Expect(1, 74845, '\p{^Nv=8.3333e-01}', "");
    Expect(1, 74845, '\P{Nv=8.3333e-01}', "");
    Expect(0, 74845, '\P{^Nv=8.3333e-01}', "");
    Expect(1, 74844, '\p{Nv=0.8333}', "");
    Expect(0, 74844, '\p{^Nv=0.8333}', "");
    Expect(0, 74844, '\P{Nv=0.8333}', "");
    Expect(1, 74844, '\P{^Nv=0.8333}', "");
    Expect(0, 74845, '\p{Nv=0.8333}', "");
    Expect(1, 74845, '\p{^Nv=0.8333}', "");
    Expect(1, 74845, '\P{Nv=0.8333}', "");
    Expect(0, 74845, '\P{^Nv=0.8333}', "");
    Expect(1, 74844, '\p{Nv=8.33333e-01}', "");
    Expect(0, 74844, '\p{^Nv=8.33333e-01}', "");
    Expect(0, 74844, '\P{Nv=8.33333e-01}', "");
    Expect(1, 74844, '\P{^Nv=8.33333e-01}', "");
    Expect(0, 74845, '\p{Nv=8.33333e-01}', "");
    Expect(1, 74845, '\p{^Nv=8.33333e-01}', "");
    Expect(1, 74845, '\P{Nv=8.33333e-01}', "");
    Expect(0, 74845, '\P{^Nv=8.33333e-01}', "");
    Expect(1, 74844, '\p{Nv=0.83333}', "");
    Expect(0, 74844, '\p{^Nv=0.83333}', "");
    Expect(0, 74844, '\P{Nv=0.83333}', "");
    Expect(1, 74844, '\P{^Nv=0.83333}', "");
    Expect(0, 74845, '\p{Nv=0.83333}', "");
    Expect(1, 74845, '\p{^Nv=0.83333}', "");
    Expect(1, 74845, '\P{Nv=0.83333}', "");
    Expect(0, 74845, '\P{^Nv=0.83333}', "");
    Error('\p{Is_Numeric_Value= 	005/006/a/}');
    Error('\P{Is_Numeric_Value= 	005/006/a/}');
    Expect(1, 74844, '\p{Is_Numeric_Value: +000005/000006}', "");
    Expect(0, 74844, '\p{^Is_Numeric_Value: +000005/000006}', "");
    Expect(0, 74844, '\P{Is_Numeric_Value: +000005/000006}', "");
    Expect(1, 74844, '\P{^Is_Numeric_Value: +000005/000006}', "");
    Expect(0, 74845, '\p{Is_Numeric_Value: +000005/000006}', "");
    Expect(1, 74845, '\p{^Is_Numeric_Value: +000005/000006}', "");
    Expect(1, 74845, '\P{Is_Numeric_Value: +000005/000006}', "");
    Expect(0, 74845, '\P{^Is_Numeric_Value: +000005/000006}', "");
    Expect(1, 74844, '\p{Is_Numeric_Value=300/360}', "");
    Expect(0, 74844, '\p{^Is_Numeric_Value=300/360}', "");
    Expect(0, 74844, '\P{Is_Numeric_Value=300/360}', "");
    Expect(1, 74844, '\P{^Is_Numeric_Value=300/360}', "");
    Expect(0, 74845, '\p{Is_Numeric_Value=300/360}', "");
    Expect(1, 74845, '\p{^Is_Numeric_Value=300/360}', "");
    Expect(1, 74845, '\P{Is_Numeric_Value=300/360}', "");
    Expect(0, 74845, '\P{^Is_Numeric_Value=300/360}', "");
    Error('\p{Is_Numeric_Value=8.3e-01}');
    Error('\P{Is_Numeric_Value=8.3e-01}');
    Error('\p{Is_Numeric_Value=8.33e-01}');
    Error('\P{Is_Numeric_Value=8.33e-01}');
    Error('\p{Is_Numeric_Value=0.83}');
    Error('\P{Is_Numeric_Value=0.83}');
    Expect(1, 74844, '\p{Is_Numeric_Value=8.333e-01}', "");
    Expect(0, 74844, '\p{^Is_Numeric_Value=8.333e-01}', "");
    Expect(0, 74844, '\P{Is_Numeric_Value=8.333e-01}', "");
    Expect(1, 74844, '\P{^Is_Numeric_Value=8.333e-01}', "");
    Expect(0, 74845, '\p{Is_Numeric_Value=8.333e-01}', "");
    Expect(1, 74845, '\p{^Is_Numeric_Value=8.333e-01}', "");
    Expect(1, 74845, '\P{Is_Numeric_Value=8.333e-01}', "");
    Expect(0, 74845, '\P{^Is_Numeric_Value=8.333e-01}', "");
    Error('\p{Is_Numeric_Value=0.833}');
    Error('\P{Is_Numeric_Value=0.833}');
    Expect(1, 74844, '\p{Is_Numeric_Value: 8.3333e-01}', "");
    Expect(0, 74844, '\p{^Is_Numeric_Value: 8.3333e-01}', "");
    Expect(0, 74844, '\P{Is_Numeric_Value: 8.3333e-01}', "");
    Expect(1, 74844, '\P{^Is_Numeric_Value: 8.3333e-01}', "");
    Expect(0, 74845, '\p{Is_Numeric_Value: 8.3333e-01}', "");
    Expect(1, 74845, '\p{^Is_Numeric_Value: 8.3333e-01}', "");
    Expect(1, 74845, '\P{Is_Numeric_Value: 8.3333e-01}', "");
    Expect(0, 74845, '\P{^Is_Numeric_Value: 8.3333e-01}', "");
    Expect(1, 74844, '\p{Is_Numeric_Value=0.8333}', "");
    Expect(0, 74844, '\p{^Is_Numeric_Value=0.8333}', "");
    Expect(0, 74844, '\P{Is_Numeric_Value=0.8333}', "");
    Expect(1, 74844, '\P{^Is_Numeric_Value=0.8333}', "");
    Expect(0, 74845, '\p{Is_Numeric_Value=0.8333}', "");
    Expect(1, 74845, '\p{^Is_Numeric_Value=0.8333}', "");
    Expect(1, 74845, '\P{Is_Numeric_Value=0.8333}', "");
    Expect(0, 74845, '\P{^Is_Numeric_Value=0.8333}', "");
    Expect(1, 74844, '\p{Is_Numeric_Value=8.33333e-01}', "");
    Expect(0, 74844, '\p{^Is_Numeric_Value=8.33333e-01}', "");
    Expect(0, 74844, '\P{Is_Numeric_Value=8.33333e-01}', "");
    Expect(1, 74844, '\P{^Is_Numeric_Value=8.33333e-01}', "");
    Expect(0, 74845, '\p{Is_Numeric_Value=8.33333e-01}', "");
    Expect(1, 74845, '\p{^Is_Numeric_Value=8.33333e-01}', "");
    Expect(1, 74845, '\P{Is_Numeric_Value=8.33333e-01}', "");
    Expect(0, 74845, '\P{^Is_Numeric_Value=8.33333e-01}', "");
    Expect(1, 74844, '\p{Is_Numeric_Value=0.83333}', "");
    Expect(0, 74844, '\p{^Is_Numeric_Value=0.83333}', "");
    Expect(0, 74844, '\P{Is_Numeric_Value=0.83333}', "");
    Expect(1, 74844, '\P{^Is_Numeric_Value=0.83333}', "");
    Expect(0, 74845, '\p{Is_Numeric_Value=0.83333}', "");
    Expect(1, 74845, '\p{^Is_Numeric_Value=0.83333}', "");
    Expect(1, 74845, '\P{Is_Numeric_Value=0.83333}', "");
    Expect(0, 74845, '\P{^Is_Numeric_Value=0.83333}', "");
    Error('\p{Is_Nv=/a/	05/06}');
    Error('\P{Is_Nv=/a/	05/06}');
    Expect(1, 74844, '\p{Is_Nv=00005/06}', "");
    Expect(0, 74844, '\p{^Is_Nv=00005/06}', "");
    Expect(0, 74844, '\P{Is_Nv=00005/06}', "");
    Expect(1, 74844, '\P{^Is_Nv=00005/06}', "");
    Expect(0, 74845, '\p{Is_Nv=00005/06}', "");
    Expect(1, 74845, '\p{^Is_Nv=00005/06}', "");
    Expect(1, 74845, '\P{Is_Nv=00005/06}', "");
    Expect(0, 74845, '\P{^Is_Nv=00005/06}', "");
    Expect(1, 74844, '\p{Is_Nv=300/360}', "");
    Expect(0, 74844, '\p{^Is_Nv=300/360}', "");
    Expect(0, 74844, '\P{Is_Nv=300/360}', "");
    Expect(1, 74844, '\P{^Is_Nv=300/360}', "");
    Expect(0, 74845, '\p{Is_Nv=300/360}', "");
    Expect(1, 74845, '\p{^Is_Nv=300/360}', "");
    Expect(1, 74845, '\P{Is_Nv=300/360}', "");
    Expect(0, 74845, '\P{^Is_Nv=300/360}', "");
    Error('\p{Is_Nv=8.3e-01}');
    Error('\P{Is_Nv=8.3e-01}');
    Error('\p{Is_Nv=8.33e-01}');
    Error('\P{Is_Nv=8.33e-01}');
    Error('\p{Is_Nv=0.83}');
    Error('\P{Is_Nv=0.83}');
    Expect(1, 74844, '\p{Is_Nv=8.333e-01}', "");
    Expect(0, 74844, '\p{^Is_Nv=8.333e-01}', "");
    Expect(0, 74844, '\P{Is_Nv=8.333e-01}', "");
    Expect(1, 74844, '\P{^Is_Nv=8.333e-01}', "");
    Expect(0, 74845, '\p{Is_Nv=8.333e-01}', "");
    Expect(1, 74845, '\p{^Is_Nv=8.333e-01}', "");
    Expect(1, 74845, '\P{Is_Nv=8.333e-01}', "");
    Expect(0, 74845, '\P{^Is_Nv=8.333e-01}', "");
    Error('\p{Is_Nv=0.833}');
    Error('\P{Is_Nv=0.833}');
    Expect(1, 74844, '\p{Is_Nv=8.3333e-01}', "");
    Expect(0, 74844, '\p{^Is_Nv=8.3333e-01}', "");
    Expect(0, 74844, '\P{Is_Nv=8.3333e-01}', "");
    Expect(1, 74844, '\P{^Is_Nv=8.3333e-01}', "");
    Expect(0, 74845, '\p{Is_Nv=8.3333e-01}', "");
    Expect(1, 74845, '\p{^Is_Nv=8.3333e-01}', "");
    Expect(1, 74845, '\P{Is_Nv=8.3333e-01}', "");
    Expect(0, 74845, '\P{^Is_Nv=8.3333e-01}', "");
    Expect(1, 74844, '\p{Is_Nv=0.8333}', "");
    Expect(0, 74844, '\p{^Is_Nv=0.8333}', "");
    Expect(0, 74844, '\P{Is_Nv=0.8333}', "");
    Expect(1, 74844, '\P{^Is_Nv=0.8333}', "");
    Expect(0, 74845, '\p{Is_Nv=0.8333}', "");
    Expect(1, 74845, '\p{^Is_Nv=0.8333}', "");
    Expect(1, 74845, '\P{Is_Nv=0.8333}', "");
    Expect(0, 74845, '\P{^Is_Nv=0.8333}', "");
    Expect(1, 74844, '\p{Is_Nv=8.33333e-01}', "");
    Expect(0, 74844, '\p{^Is_Nv=8.33333e-01}', "");
    Expect(0, 74844, '\P{Is_Nv=8.33333e-01}', "");
    Expect(1, 74844, '\P{^Is_Nv=8.33333e-01}', "");
    Expect(0, 74845, '\p{Is_Nv=8.33333e-01}', "");
    Expect(1, 74845, '\p{^Is_Nv=8.33333e-01}', "");
    Expect(1, 74845, '\P{Is_Nv=8.33333e-01}', "");
    Expect(0, 74845, '\P{^Is_Nv=8.33333e-01}', "");
    Expect(1, 74844, '\p{Is_Nv=0.83333}', "");
    Expect(0, 74844, '\p{^Is_Nv=0.83333}', "");
    Expect(0, 74844, '\P{Is_Nv=0.83333}', "");
    Expect(1, 74844, '\P{^Is_Nv=0.83333}', "");
    Expect(0, 74845, '\p{Is_Nv=0.83333}', "");
    Expect(1, 74845, '\p{^Is_Nv=0.83333}', "");
    Expect(1, 74845, '\P{Is_Nv=0.83333}', "");
    Expect(0, 74845, '\P{^Is_Nv=0.83333}', "");
    Error('\p{Numeric_Value=__0005/000000008/a/}');
    Error('\P{Numeric_Value=__0005/000000008/a/}');
    Expect(1, 8541, '\p{Numeric_Value=:\A5/8\z:}', "");;
    Expect(0, 8542, '\p{Numeric_Value=:\A5/8\z:}', "");;
    Expect(1, 8541, '\p{Numeric_Value=005/0000008}', "");
    Expect(0, 8541, '\p{^Numeric_Value=005/0000008}', "");
    Expect(0, 8541, '\P{Numeric_Value=005/0000008}', "");
    Expect(1, 8541, '\P{^Numeric_Value=005/0000008}', "");
    Expect(0, 8542, '\p{Numeric_Value=005/0000008}', "");
    Expect(1, 8542, '\p{^Numeric_Value=005/0000008}', "");
    Expect(1, 8542, '\P{Numeric_Value=005/0000008}', "");
    Expect(0, 8542, '\P{^Numeric_Value=005/0000008}', "");
    Expect(1, 8541, '\p{Numeric_Value=300/480}', "");
    Expect(0, 8541, '\p{^Numeric_Value=300/480}', "");
    Expect(0, 8541, '\P{Numeric_Value=300/480}', "");
    Expect(1, 8541, '\P{^Numeric_Value=300/480}', "");
    Expect(0, 8542, '\p{Numeric_Value=300/480}', "");
    Expect(1, 8542, '\p{^Numeric_Value=300/480}', "");
    Expect(1, 8542, '\P{Numeric_Value=300/480}', "");
    Expect(0, 8542, '\P{^Numeric_Value=300/480}', "");
    Error('\p{Numeric_Value=6.2e-01}');
    Error('\P{Numeric_Value=6.2e-01}');
    Expect(1, 8541, '\p{Numeric_Value=6.25e-01}', "");
    Expect(0, 8541, '\p{^Numeric_Value=6.25e-01}', "");
    Expect(0, 8541, '\P{Numeric_Value=6.25e-01}', "");
    Expect(1, 8541, '\P{^Numeric_Value=6.25e-01}', "");
    Expect(0, 8542, '\p{Numeric_Value=6.25e-01}', "");
    Expect(1, 8542, '\p{^Numeric_Value=6.25e-01}', "");
    Expect(1, 8542, '\P{Numeric_Value=6.25e-01}', "");
    Expect(0, 8542, '\P{^Numeric_Value=6.25e-01}', "");
    Error('\p{Numeric_Value=0.62}');
    Error('\P{Numeric_Value=0.62}');
    Expect(1, 8541, '\p{Numeric_Value=6.250e-01}', "");
    Expect(0, 8541, '\p{^Numeric_Value=6.250e-01}', "");
    Expect(0, 8541, '\P{Numeric_Value=6.250e-01}', "");
    Expect(1, 8541, '\P{^Numeric_Value=6.250e-01}', "");
    Expect(0, 8542, '\p{Numeric_Value=6.250e-01}', "");
    Expect(1, 8542, '\p{^Numeric_Value=6.250e-01}', "");
    Expect(1, 8542, '\P{Numeric_Value=6.250e-01}', "");
    Expect(0, 8542, '\P{^Numeric_Value=6.250e-01}', "");
    Expect(1, 8541, '\p{Numeric_Value=0.625}', "");
    Expect(0, 8541, '\p{^Numeric_Value=0.625}', "");
    Expect(0, 8541, '\P{Numeric_Value=0.625}', "");
    Expect(1, 8541, '\P{^Numeric_Value=0.625}', "");
    Expect(0, 8542, '\p{Numeric_Value=0.625}', "");
    Expect(1, 8542, '\p{^Numeric_Value=0.625}', "");
    Expect(1, 8542, '\P{Numeric_Value=0.625}', "");
    Expect(0, 8542, '\P{^Numeric_Value=0.625}', "");
    Expect(1, 8541, '\p{Numeric_Value=6.2500e-01}', "");
    Expect(0, 8541, '\p{^Numeric_Value=6.2500e-01}', "");
    Expect(0, 8541, '\P{Numeric_Value=6.2500e-01}', "");
    Expect(1, 8541, '\P{^Numeric_Value=6.2500e-01}', "");
    Expect(0, 8542, '\p{Numeric_Value=6.2500e-01}', "");
    Expect(1, 8542, '\p{^Numeric_Value=6.2500e-01}', "");
    Expect(1, 8542, '\P{Numeric_Value=6.2500e-01}', "");
    Expect(0, 8542, '\P{^Numeric_Value=6.2500e-01}', "");
    Expect(1, 8541, '\p{Numeric_Value:   0.6250}', "");
    Expect(0, 8541, '\p{^Numeric_Value:   0.6250}', "");
    Expect(0, 8541, '\P{Numeric_Value:   0.6250}', "");
    Expect(1, 8541, '\P{^Numeric_Value:   0.6250}', "");
    Expect(0, 8542, '\p{Numeric_Value:   0.6250}', "");
    Expect(1, 8542, '\p{^Numeric_Value:   0.6250}', "");
    Expect(1, 8542, '\P{Numeric_Value:   0.6250}', "");
    Expect(0, 8542, '\P{^Numeric_Value:   0.6250}', "");
    Error('\p{Nv=/a/--0000000005/000008}');
    Error('\P{Nv=/a/--0000000005/000008}');
    Expect(1, 8541, '\p{Nv=:\A5/8\z:}', "");;
    Expect(0, 8542, '\p{Nv=:\A5/8\z:}', "");;
    Expect(1, 8541, '\p{Nv=000005/0008}', "");
    Expect(0, 8541, '\p{^Nv=000005/0008}', "");
    Expect(0, 8541, '\P{Nv=000005/0008}', "");
    Expect(1, 8541, '\P{^Nv=000005/0008}', "");
    Expect(0, 8542, '\p{Nv=000005/0008}', "");
    Expect(1, 8542, '\p{^Nv=000005/0008}', "");
    Expect(1, 8542, '\P{Nv=000005/0008}', "");
    Expect(0, 8542, '\P{^Nv=000005/0008}', "");
    Expect(1, 8541, '\p{Nv=300/480}', "");
    Expect(0, 8541, '\p{^Nv=300/480}', "");
    Expect(0, 8541, '\P{Nv=300/480}', "");
    Expect(1, 8541, '\P{^Nv=300/480}', "");
    Expect(0, 8542, '\p{Nv=300/480}', "");
    Expect(1, 8542, '\p{^Nv=300/480}', "");
    Expect(1, 8542, '\P{Nv=300/480}', "");
    Expect(0, 8542, '\P{^Nv=300/480}', "");
    Error('\p{Nv=6.2e-01}');
    Error('\P{Nv=6.2e-01}');
    Expect(1, 8541, '\p{Nv=6.25e-01}', "");
    Expect(0, 8541, '\p{^Nv=6.25e-01}', "");
    Expect(0, 8541, '\P{Nv=6.25e-01}', "");
    Expect(1, 8541, '\P{^Nv=6.25e-01}', "");
    Expect(0, 8542, '\p{Nv=6.25e-01}', "");
    Expect(1, 8542, '\p{^Nv=6.25e-01}', "");
    Expect(1, 8542, '\P{Nv=6.25e-01}', "");
    Expect(0, 8542, '\P{^Nv=6.25e-01}', "");
    Error('\p{Nv=0.62}');
    Error('\P{Nv=0.62}');
    Expect(1, 8541, '\p{Nv=6.250e-01}', "");
    Expect(0, 8541, '\p{^Nv=6.250e-01}', "");
    Expect(0, 8541, '\P{Nv=6.250e-01}', "");
    Expect(1, 8541, '\P{^Nv=6.250e-01}', "");
    Expect(0, 8542, '\p{Nv=6.250e-01}', "");
    Expect(1, 8542, '\p{^Nv=6.250e-01}', "");
    Expect(1, 8542, '\P{Nv=6.250e-01}', "");
    Expect(0, 8542, '\P{^Nv=6.250e-01}', "");
    Expect(1, 8541, '\p{Nv=0.625}', "");
    Expect(0, 8541, '\p{^Nv=0.625}', "");
    Expect(0, 8541, '\P{Nv=0.625}', "");
    Expect(1, 8541, '\P{^Nv=0.625}', "");
    Expect(0, 8542, '\p{Nv=0.625}', "");
    Expect(1, 8542, '\p{^Nv=0.625}', "");
    Expect(1, 8542, '\P{Nv=0.625}', "");
    Expect(0, 8542, '\P{^Nv=0.625}', "");
    Expect(1, 8541, '\p{Nv:   6.2500e-01}', "");
    Expect(0, 8541, '\p{^Nv:   6.2500e-01}', "");
    Expect(0, 8541, '\P{Nv:   6.2500e-01}', "");
    Expect(1, 8541, '\P{^Nv:   6.2500e-01}', "");
    Expect(0, 8542, '\p{Nv:   6.2500e-01}', "");
    Expect(1, 8542, '\p{^Nv:   6.2500e-01}', "");
    Expect(1, 8542, '\P{Nv:   6.2500e-01}', "");
    Expect(0, 8542, '\P{^Nv:   6.2500e-01}', "");
    Expect(1, 8541, '\p{Nv=0.6250}', "");
    Expect(0, 8541, '\p{^Nv=0.6250}', "");
    Expect(0, 8541, '\P{Nv=0.6250}', "");
    Expect(1, 8541, '\P{^Nv=0.6250}', "");
    Expect(0, 8542, '\p{Nv=0.6250}', "");
    Expect(1, 8542, '\p{^Nv=0.6250}', "");
    Expect(1, 8542, '\P{Nv=0.6250}', "");
    Expect(0, 8542, '\P{^Nv=0.6250}', "");
    Error('\p{Is_Numeric_Value=-0000005/0000000008:=}');
    Error('\P{Is_Numeric_Value=-0000005/0000000008:=}');
    Expect(1, 8541, '\p{Is_Numeric_Value=0000005/0000008}', "");
    Expect(0, 8541, '\p{^Is_Numeric_Value=0000005/0000008}', "");
    Expect(0, 8541, '\P{Is_Numeric_Value=0000005/0000008}', "");
    Expect(1, 8541, '\P{^Is_Numeric_Value=0000005/0000008}', "");
    Expect(0, 8542, '\p{Is_Numeric_Value=0000005/0000008}', "");
    Expect(1, 8542, '\p{^Is_Numeric_Value=0000005/0000008}', "");
    Expect(1, 8542, '\P{Is_Numeric_Value=0000005/0000008}', "");
    Expect(0, 8542, '\P{^Is_Numeric_Value=0000005/0000008}', "");
    Expect(1, 8541, '\p{Is_Numeric_Value=300/480}', "");
    Expect(0, 8541, '\p{^Is_Numeric_Value=300/480}', "");
    Expect(0, 8541, '\P{Is_Numeric_Value=300/480}', "");
    Expect(1, 8541, '\P{^Is_Numeric_Value=300/480}', "");
    Expect(0, 8542, '\p{Is_Numeric_Value=300/480}', "");
    Expect(1, 8542, '\p{^Is_Numeric_Value=300/480}', "");
    Expect(1, 8542, '\P{Is_Numeric_Value=300/480}', "");
    Expect(0, 8542, '\P{^Is_Numeric_Value=300/480}', "");
    Error('\p{Is_Numeric_Value=6.2e-01}');
    Error('\P{Is_Numeric_Value=6.2e-01}');
    Expect(1, 8541, '\p{Is_Numeric_Value=6.25e-01}', "");
    Expect(0, 8541, '\p{^Is_Numeric_Value=6.25e-01}', "");
    Expect(0, 8541, '\P{Is_Numeric_Value=6.25e-01}', "");
    Expect(1, 8541, '\P{^Is_Numeric_Value=6.25e-01}', "");
    Expect(0, 8542, '\p{Is_Numeric_Value=6.25e-01}', "");
    Expect(1, 8542, '\p{^Is_Numeric_Value=6.25e-01}', "");
    Expect(1, 8542, '\P{Is_Numeric_Value=6.25e-01}', "");
    Expect(0, 8542, '\P{^Is_Numeric_Value=6.25e-01}', "");
    Error('\p{Is_Numeric_Value=0.62}');
    Error('\P{Is_Numeric_Value=0.62}');
    Expect(1, 8541, '\p{Is_Numeric_Value=6.250e-01}', "");
    Expect(0, 8541, '\p{^Is_Numeric_Value=6.250e-01}', "");
    Expect(0, 8541, '\P{Is_Numeric_Value=6.250e-01}', "");
    Expect(1, 8541, '\P{^Is_Numeric_Value=6.250e-01}', "");
    Expect(0, 8542, '\p{Is_Numeric_Value=6.250e-01}', "");
    Expect(1, 8542, '\p{^Is_Numeric_Value=6.250e-01}', "");
    Expect(1, 8542, '\P{Is_Numeric_Value=6.250e-01}', "");
    Expect(0, 8542, '\P{^Is_Numeric_Value=6.250e-01}', "");
    Expect(1, 8541, '\p{Is_Numeric_Value=0.625}', "");
    Expect(0, 8541, '\p{^Is_Numeric_Value=0.625}', "");
    Expect(0, 8541, '\P{Is_Numeric_Value=0.625}', "");
    Expect(1, 8541, '\P{^Is_Numeric_Value=0.625}', "");
    Expect(0, 8542, '\p{Is_Numeric_Value=0.625}', "");
    Expect(1, 8542, '\p{^Is_Numeric_Value=0.625}', "");
    Expect(1, 8542, '\P{Is_Numeric_Value=0.625}', "");
    Expect(0, 8542, '\P{^Is_Numeric_Value=0.625}', "");
    Expect(1, 8541, '\p{Is_Numeric_Value=6.2500e-01}', "");
    Expect(0, 8541, '\p{^Is_Numeric_Value=6.2500e-01}', "");
    Expect(0, 8541, '\P{Is_Numeric_Value=6.2500e-01}', "");
    Expect(1, 8541, '\P{^Is_Numeric_Value=6.2500e-01}', "");
    Expect(0, 8542, '\p{Is_Numeric_Value=6.2500e-01}', "");
    Expect(1, 8542, '\p{^Is_Numeric_Value=6.2500e-01}', "");
    Expect(1, 8542, '\P{Is_Numeric_Value=6.2500e-01}', "");
    Expect(0, 8542, '\P{^Is_Numeric_Value=6.2500e-01}', "");
    Expect(1, 8541, '\p{Is_Numeric_Value=0.6250}', "");
    Expect(0, 8541, '\p{^Is_Numeric_Value=0.6250}', "");
    Expect(0, 8541, '\P{Is_Numeric_Value=0.6250}', "");
    Expect(1, 8541, '\P{^Is_Numeric_Value=0.6250}', "");
    Expect(0, 8542, '\p{Is_Numeric_Value=0.6250}', "");
    Expect(1, 8542, '\p{^Is_Numeric_Value=0.6250}', "");
    Expect(1, 8542, '\P{Is_Numeric_Value=0.6250}', "");
    Expect(0, 8542, '\P{^Is_Numeric_Value=0.6250}', "");
    Error('\p{Is_Nv= :=0005/0000008}');
    Error('\P{Is_Nv= :=0005/0000008}');
    Expect(1, 8541, '\p{Is_Nv=000000005/0000008}', "");
    Expect(0, 8541, '\p{^Is_Nv=000000005/0000008}', "");
    Expect(0, 8541, '\P{Is_Nv=000000005/0000008}', "");
    Expect(1, 8541, '\P{^Is_Nv=000000005/0000008}', "");
    Expect(0, 8542, '\p{Is_Nv=000000005/0000008}', "");
    Expect(1, 8542, '\p{^Is_Nv=000000005/0000008}', "");
    Expect(1, 8542, '\P{Is_Nv=000000005/0000008}', "");
    Expect(0, 8542, '\P{^Is_Nv=000000005/0000008}', "");
    Expect(1, 8541, '\p{Is_Nv=300/480}', "");
    Expect(0, 8541, '\p{^Is_Nv=300/480}', "");
    Expect(0, 8541, '\P{Is_Nv=300/480}', "");
    Expect(1, 8541, '\P{^Is_Nv=300/480}', "");
    Expect(0, 8542, '\p{Is_Nv=300/480}', "");
    Expect(1, 8542, '\p{^Is_Nv=300/480}', "");
    Expect(1, 8542, '\P{Is_Nv=300/480}', "");
    Expect(0, 8542, '\P{^Is_Nv=300/480}', "");
    Error('\p{Is_Nv=6.2e-01}');
    Error('\P{Is_Nv=6.2e-01}');
    Expect(1, 8541, '\p{Is_Nv:	6.25e-01}', "");
    Expect(0, 8541, '\p{^Is_Nv:	6.25e-01}', "");
    Expect(0, 8541, '\P{Is_Nv:	6.25e-01}', "");
    Expect(1, 8541, '\P{^Is_Nv:	6.25e-01}', "");
    Expect(0, 8542, '\p{Is_Nv:	6.25e-01}', "");
    Expect(1, 8542, '\p{^Is_Nv:	6.25e-01}', "");
    Expect(1, 8542, '\P{Is_Nv:	6.25e-01}', "");
    Expect(0, 8542, '\P{^Is_Nv:	6.25e-01}', "");
    Error('\p{Is_Nv=0.62}');
    Error('\P{Is_Nv=0.62}');
    Expect(1, 8541, '\p{Is_Nv=6.250e-01}', "");
    Expect(0, 8541, '\p{^Is_Nv=6.250e-01}', "");
    Expect(0, 8541, '\P{Is_Nv=6.250e-01}', "");
    Expect(1, 8541, '\P{^Is_Nv=6.250e-01}', "");
    Expect(0, 8542, '\p{Is_Nv=6.250e-01}', "");
    Expect(1, 8542, '\p{^Is_Nv=6.250e-01}', "");
    Expect(1, 8542, '\P{Is_Nv=6.250e-01}', "");
    Expect(0, 8542, '\P{^Is_Nv=6.250e-01}', "");
    Expect(1, 8541, '\p{Is_Nv=0.625}', "");
    Expect(0, 8541, '\p{^Is_Nv=0.625}', "");
    Expect(0, 8541, '\P{Is_Nv=0.625}', "");
    Expect(1, 8541, '\P{^Is_Nv=0.625}', "");
    Expect(0, 8542, '\p{Is_Nv=0.625}', "");
    Expect(1, 8542, '\p{^Is_Nv=0.625}', "");
    Expect(1, 8542, '\P{Is_Nv=0.625}', "");
    Expect(0, 8542, '\P{^Is_Nv=0.625}', "");
    Expect(1, 8541, '\p{Is_Nv: 6.2500e-01}', "");
    Expect(0, 8541, '\p{^Is_Nv: 6.2500e-01}', "");
    Expect(0, 8541, '\P{Is_Nv: 6.2500e-01}', "");
    Expect(1, 8541, '\P{^Is_Nv: 6.2500e-01}', "");
    Expect(0, 8542, '\p{Is_Nv: 6.2500e-01}', "");
    Expect(1, 8542, '\p{^Is_Nv: 6.2500e-01}', "");
    Expect(1, 8542, '\P{Is_Nv: 6.2500e-01}', "");
    Expect(0, 8542, '\P{^Is_Nv: 6.2500e-01}', "");
    Expect(1, 8541, '\p{Is_Nv=0.6250}', "");
    Expect(0, 8541, '\p{^Is_Nv=0.6250}', "");
    Expect(0, 8541, '\P{Is_Nv=0.6250}', "");
    Expect(1, 8541, '\P{^Is_Nv=0.6250}', "");
    Expect(0, 8542, '\p{Is_Nv=0.6250}', "");
    Expect(1, 8542, '\p{^Is_Nv=0.6250}', "");
    Expect(1, 8542, '\P{Is_Nv=0.6250}', "");
    Expect(0, 8542, '\P{^Is_Nv=0.6250}', "");
    Error('\p{Numeric_Value= /a/0_0_0_0_0_0_00050}');
    Error('\P{Numeric_Value= /a/0_0_0_0_0_0_00050}');
    Expect(1, 126222, '\p{Numeric_Value=:\A50\z:}', "");;
    Expect(0, 126223, '\p{Numeric_Value=:\A50\z:}', "");;
    Expect(1, 126222, '\p{Numeric_Value=0_0_0_0_0_00050}', "");
    Expect(0, 126222, '\p{^Numeric_Value=0_0_0_0_0_00050}', "");
    Expect(0, 126222, '\P{Numeric_Value=0_0_0_0_0_00050}', "");
    Expect(1, 126222, '\P{^Numeric_Value=0_0_0_0_0_00050}', "");
    Expect(0, 126223, '\p{Numeric_Value=0_0_0_0_0_00050}', "");
    Expect(1, 126223, '\p{^Numeric_Value=0_0_0_0_0_00050}', "");
    Expect(1, 126223, '\P{Numeric_Value=0_0_0_0_0_00050}', "");
    Expect(0, 126223, '\P{^Numeric_Value=0_0_0_0_0_00050}', "");
    Expect(1, 126222, '\p{Numeric_Value: 5.000000000000000e+01}', "");
    Expect(0, 126222, '\p{^Numeric_Value: 5.000000000000000e+01}', "");
    Expect(0, 126222, '\P{Numeric_Value: 5.000000000000000e+01}', "");
    Expect(1, 126222, '\P{^Numeric_Value: 5.000000000000000e+01}', "");
    Expect(0, 126223, '\p{Numeric_Value: 5.000000000000000e+01}', "");
    Expect(1, 126223, '\p{^Numeric_Value: 5.000000000000000e+01}', "");
    Expect(1, 126223, '\P{Numeric_Value: 5.000000000000000e+01}', "");
    Expect(0, 126223, '\P{^Numeric_Value: 5.000000000000000e+01}', "");
    Error('\p{Nv=_50/a/}');
    Error('\P{Nv=_50/a/}');
    Expect(1, 126222, '\p{Nv=:\A50\z:}', "");;
    Expect(0, 126223, '\p{Nv=:\A50\z:}', "");;
    Expect(1, 126222, '\p{Nv=000050}', "");
    Expect(0, 126222, '\p{^Nv=000050}', "");
    Expect(0, 126222, '\P{Nv=000050}', "");
    Expect(1, 126222, '\P{^Nv=000050}', "");
    Expect(0, 126223, '\p{Nv=000050}', "");
    Expect(1, 126223, '\p{^Nv=000050}', "");
    Expect(1, 126223, '\P{Nv=000050}', "");
    Expect(0, 126223, '\P{^Nv=000050}', "");
    Expect(1, 126222, '\p{Nv:5.000000000000000e+01}', "");
    Expect(0, 126222, '\p{^Nv:5.000000000000000e+01}', "");
    Expect(0, 126222, '\P{Nv:5.000000000000000e+01}', "");
    Expect(1, 126222, '\P{^Nv:5.000000000000000e+01}', "");
    Expect(0, 126223, '\p{Nv:5.000000000000000e+01}', "");
    Expect(1, 126223, '\p{^Nv:5.000000000000000e+01}', "");
    Expect(1, 126223, '\P{Nv:5.000000000000000e+01}', "");
    Expect(0, 126223, '\P{^Nv:5.000000000000000e+01}', "");
    Error('\p{Is_Numeric_Value= /a/00_00_00_050}');
    Error('\P{Is_Numeric_Value= /a/00_00_00_050}');
    Expect(1, 126222, '\p{Is_Numeric_Value=+0000050}', "");
    Expect(0, 126222, '\p{^Is_Numeric_Value=+0000050}', "");
    Expect(0, 126222, '\P{Is_Numeric_Value=+0000050}', "");
    Expect(1, 126222, '\P{^Is_Numeric_Value=+0000050}', "");
    Expect(0, 126223, '\p{Is_Numeric_Value=+0000050}', "");
    Expect(1, 126223, '\p{^Is_Numeric_Value=+0000050}', "");
    Expect(1, 126223, '\P{Is_Numeric_Value=+0000050}', "");
    Expect(0, 126223, '\P{^Is_Numeric_Value=+0000050}', "");
    Expect(1, 126222, '\p{Is_Numeric_Value=5.000000000000000e+01}', "");
    Expect(0, 126222, '\p{^Is_Numeric_Value=5.000000000000000e+01}', "");
    Expect(0, 126222, '\P{Is_Numeric_Value=5.000000000000000e+01}', "");
    Expect(1, 126222, '\P{^Is_Numeric_Value=5.000000000000000e+01}', "");
    Expect(0, 126223, '\p{Is_Numeric_Value=5.000000000000000e+01}', "");
    Expect(1, 126223, '\p{^Is_Numeric_Value=5.000000000000000e+01}', "");
    Expect(1, 126223, '\P{Is_Numeric_Value=5.000000000000000e+01}', "");
    Expect(0, 126223, '\P{^Is_Numeric_Value=5.000000000000000e+01}', "");
    Error('\p{Is_Nv=0000050:=}');
    Error('\P{Is_Nv=0000050:=}');
    Expect(1, 126222, '\p{Is_Nv=000000005_0}', "");
    Expect(0, 126222, '\p{^Is_Nv=000000005_0}', "");
    Expect(0, 126222, '\P{Is_Nv=000000005_0}', "");
    Expect(1, 126222, '\P{^Is_Nv=000000005_0}', "");
    Expect(0, 126223, '\p{Is_Nv=000000005_0}', "");
    Expect(1, 126223, '\p{^Is_Nv=000000005_0}', "");
    Expect(1, 126223, '\P{Is_Nv=000000005_0}', "");
    Expect(0, 126223, '\P{^Is_Nv=000000005_0}', "");
    Expect(1, 126222, '\p{Is_Nv=5.000000000000000e+01}', "");
    Expect(0, 126222, '\p{^Is_Nv=5.000000000000000e+01}', "");
    Expect(0, 126222, '\P{Is_Nv=5.000000000000000e+01}', "");
    Expect(1, 126222, '\P{^Is_Nv=5.000000000000000e+01}', "");
    Expect(0, 126223, '\p{Is_Nv=5.000000000000000e+01}', "");
    Expect(1, 126223, '\p{^Is_Nv=5.000000000000000e+01}', "");
    Expect(1, 126223, '\P{Is_Nv=5.000000000000000e+01}', "");
    Expect(0, 126223, '\P{^Is_Nv=5.000000000000000e+01}', "");
    Error('\p{Numeric_Value:	_+00000000500:=}');
    Error('\P{Numeric_Value:	_+00000000500:=}');
    Expect(1, 126231, '\p{Numeric_Value=:\A500\z:}', "");;
    Expect(0, 126232, '\p{Numeric_Value=:\A500\z:}', "");;
    Expect(1, 126231, '\p{Numeric_Value=0_0_0_0_0_0_5_00}', "");
    Expect(0, 126231, '\p{^Numeric_Value=0_0_0_0_0_0_5_00}', "");
    Expect(0, 126231, '\P{Numeric_Value=0_0_0_0_0_0_5_00}', "");
    Expect(1, 126231, '\P{^Numeric_Value=0_0_0_0_0_0_5_00}', "");
    Expect(0, 126232, '\p{Numeric_Value=0_0_0_0_0_0_5_00}', "");
    Expect(1, 126232, '\p{^Numeric_Value=0_0_0_0_0_0_5_00}', "");
    Expect(1, 126232, '\P{Numeric_Value=0_0_0_0_0_0_5_00}', "");
    Expect(0, 126232, '\P{^Numeric_Value=0_0_0_0_0_0_5_00}', "");
    Expect(1, 126231, '\p{Numeric_Value=5.000000000000000e+02}', "");
    Expect(0, 126231, '\p{^Numeric_Value=5.000000000000000e+02}', "");
    Expect(0, 126231, '\P{Numeric_Value=5.000000000000000e+02}', "");
    Expect(1, 126231, '\P{^Numeric_Value=5.000000000000000e+02}', "");
    Expect(0, 126232, '\p{Numeric_Value=5.000000000000000e+02}', "");
    Expect(1, 126232, '\p{^Numeric_Value=5.000000000000000e+02}', "");
    Expect(1, 126232, '\P{Numeric_Value=5.000000000000000e+02}', "");
    Expect(0, 126232, '\P{^Numeric_Value=5.000000000000000e+02}', "");
    Error('\p{Nv=	+500/a/}');
    Error('\P{Nv=	+500/a/}');
    Expect(1, 126231, '\p{Nv=:\A500\z:}', "");;
    Expect(0, 126232, '\p{Nv=:\A500\z:}', "");;
    Expect(1, 126231, '\p{Nv=+0000050_0}', "");
    Expect(0, 126231, '\p{^Nv=+0000050_0}', "");
    Expect(0, 126231, '\P{Nv=+0000050_0}', "");
    Expect(1, 126231, '\P{^Nv=+0000050_0}', "");
    Expect(0, 126232, '\p{Nv=+0000050_0}', "");
    Expect(1, 126232, '\p{^Nv=+0000050_0}', "");
    Expect(1, 126232, '\P{Nv=+0000050_0}', "");
    Expect(0, 126232, '\P{^Nv=+0000050_0}', "");
    Expect(1, 126231, '\p{Nv=5.000000000000000e+02}', "");
    Expect(0, 126231, '\p{^Nv=5.000000000000000e+02}', "");
    Expect(0, 126231, '\P{Nv=5.000000000000000e+02}', "");
    Expect(1, 126231, '\P{^Nv=5.000000000000000e+02}', "");
    Expect(0, 126232, '\p{Nv=5.000000000000000e+02}', "");
    Expect(1, 126232, '\p{^Nv=5.000000000000000e+02}', "");
    Expect(1, 126232, '\P{Nv=5.000000000000000e+02}', "");
    Expect(0, 126232, '\P{^Nv=5.000000000000000e+02}', "");
    Error('\p{Is_Numeric_Value=/a/ 	00_00_05_00}');
    Error('\P{Is_Numeric_Value=/a/ 	00_00_05_00}');
    Expect(1, 126231, '\p{Is_Numeric_Value=00_00_00_05_00}', "");
    Expect(0, 126231, '\p{^Is_Numeric_Value=00_00_00_05_00}', "");
    Expect(0, 126231, '\P{Is_Numeric_Value=00_00_00_05_00}', "");
    Expect(1, 126231, '\P{^Is_Numeric_Value=00_00_00_05_00}', "");
    Expect(0, 126232, '\p{Is_Numeric_Value=00_00_00_05_00}', "");
    Expect(1, 126232, '\p{^Is_Numeric_Value=00_00_00_05_00}', "");
    Expect(1, 126232, '\P{Is_Numeric_Value=00_00_00_05_00}', "");
    Expect(0, 126232, '\P{^Is_Numeric_Value=00_00_00_05_00}', "");
    Expect(1, 126231, '\p{Is_Numeric_Value=5.000000000000000e+02}', "");
    Expect(0, 126231, '\p{^Is_Numeric_Value=5.000000000000000e+02}', "");
    Expect(0, 126231, '\P{Is_Numeric_Value=5.000000000000000e+02}', "");
    Expect(1, 126231, '\P{^Is_Numeric_Value=5.000000000000000e+02}', "");
    Expect(0, 126232, '\p{Is_Numeric_Value=5.000000000000000e+02}', "");
    Expect(1, 126232, '\p{^Is_Numeric_Value=5.000000000000000e+02}', "");
    Expect(1, 126232, '\P{Is_Numeric_Value=5.000000000000000e+02}', "");
    Expect(0, 126232, '\P{^Is_Numeric_Value=5.000000000000000e+02}', "");
    Error('\p{Is_Nv= +500:=}');
    Error('\P{Is_Nv= +500:=}');
    Expect(1, 126231, '\p{Is_Nv: 500}', "");
    Expect(0, 126231, '\p{^Is_Nv: 500}', "");
    Expect(0, 126231, '\P{Is_Nv: 500}', "");
    Expect(1, 126231, '\P{^Is_Nv: 500}', "");
    Expect(0, 126232, '\p{Is_Nv: 500}', "");
    Expect(1, 126232, '\p{^Is_Nv: 500}', "");
    Expect(1, 126232, '\P{Is_Nv: 500}', "");
    Expect(0, 126232, '\P{^Is_Nv: 500}', "");
    Expect(1, 126231, '\p{Is_Nv=5.000000000000000e+02}', "");
    Expect(0, 126231, '\p{^Is_Nv=5.000000000000000e+02}', "");
    Expect(0, 126231, '\P{Is_Nv=5.000000000000000e+02}', "");
    Expect(1, 126231, '\P{^Is_Nv=5.000000000000000e+02}', "");
    Expect(0, 126232, '\p{Is_Nv=5.000000000000000e+02}', "");
    Expect(1, 126232, '\p{^Is_Nv=5.000000000000000e+02}', "");
    Expect(1, 126232, '\P{Is_Nv=5.000000000000000e+02}', "");
    Expect(0, 126232, '\P{^Is_Nv=5.000000000000000e+02}', "");
    Error('\p{Numeric_Value= :=0_0_0_0_0_0_5_0_00}');
    Error('\P{Numeric_Value= :=0_0_0_0_0_0_5_0_00}');
    Expect(1, 126240, '\p{Numeric_Value=:\A5000\z:}', "");;
    Expect(0, 126241, '\p{Numeric_Value=:\A5000\z:}', "");;
    Expect(1, 126240, '\p{Numeric_Value=000005000}', "");
    Expect(0, 126240, '\p{^Numeric_Value=000005000}', "");
    Expect(0, 126240, '\P{Numeric_Value=000005000}', "");
    Expect(1, 126240, '\P{^Numeric_Value=000005000}', "");
    Expect(0, 126241, '\p{Numeric_Value=000005000}', "");
    Expect(1, 126241, '\p{^Numeric_Value=000005000}', "");
    Expect(1, 126241, '\P{Numeric_Value=000005000}', "");
    Expect(0, 126241, '\P{^Numeric_Value=000005000}', "");
    Expect(1, 126240, '\p{Numeric_Value:5.000000000000000e+03}', "");
    Expect(0, 126240, '\p{^Numeric_Value:5.000000000000000e+03}', "");
    Expect(0, 126240, '\P{Numeric_Value:5.000000000000000e+03}', "");
    Expect(1, 126240, '\P{^Numeric_Value:5.000000000000000e+03}', "");
    Expect(0, 126241, '\p{Numeric_Value:5.000000000000000e+03}', "");
    Expect(1, 126241, '\p{^Numeric_Value:5.000000000000000e+03}', "");
    Expect(1, 126241, '\P{Numeric_Value:5.000000000000000e+03}', "");
    Expect(0, 126241, '\P{^Numeric_Value:5.000000000000000e+03}', "");
    Error('\p{Nv: _000_000_000_500_0:=}');
    Error('\P{Nv: _000_000_000_500_0:=}');
    Expect(1, 126240, '\p{Nv=:\A5000\z:}', "");;
    Expect(0, 126241, '\p{Nv=:\A5000\z:}', "");;
    Expect(1, 126240, '\p{Nv=0000500_0}', "");
    Expect(0, 126240, '\p{^Nv=0000500_0}', "");
    Expect(0, 126240, '\P{Nv=0000500_0}', "");
    Expect(1, 126240, '\P{^Nv=0000500_0}', "");
    Expect(0, 126241, '\p{Nv=0000500_0}', "");
    Expect(1, 126241, '\p{^Nv=0000500_0}', "");
    Expect(1, 126241, '\P{Nv=0000500_0}', "");
    Expect(0, 126241, '\P{^Nv=0000500_0}', "");
    Expect(1, 126240, '\p{Nv=5.000000000000000e+03}', "");
    Expect(0, 126240, '\p{^Nv=5.000000000000000e+03}', "");
    Expect(0, 126240, '\P{Nv=5.000000000000000e+03}', "");
    Expect(1, 126240, '\P{^Nv=5.000000000000000e+03}', "");
    Expect(0, 126241, '\p{Nv=5.000000000000000e+03}', "");
    Expect(1, 126241, '\p{^Nv=5.000000000000000e+03}', "");
    Expect(1, 126241, '\P{Nv=5.000000000000000e+03}', "");
    Expect(0, 126241, '\P{^Nv=5.000000000000000e+03}', "");
    Error('\p{Is_Numeric_Value: 	/a/000005000}');
    Error('\P{Is_Numeric_Value: 	/a/000005000}');
    Expect(1, 126240, '\p{Is_Numeric_Value=0000005000}', "");
    Expect(0, 126240, '\p{^Is_Numeric_Value=0000005000}', "");
    Expect(0, 126240, '\P{Is_Numeric_Value=0000005000}', "");
    Expect(1, 126240, '\P{^Is_Numeric_Value=0000005000}', "");
    Expect(0, 126241, '\p{Is_Numeric_Value=0000005000}', "");
    Expect(1, 126241, '\p{^Is_Numeric_Value=0000005000}', "");
    Expect(1, 126241, '\P{Is_Numeric_Value=0000005000}', "");
    Expect(0, 126241, '\P{^Is_Numeric_Value=0000005000}', "");
    Expect(1, 126240, '\p{Is_Numeric_Value=5.000000000000000e+03}', "");
    Expect(0, 126240, '\p{^Is_Numeric_Value=5.000000000000000e+03}', "");
    Expect(0, 126240, '\P{Is_Numeric_Value=5.000000000000000e+03}', "");
    Expect(1, 126240, '\P{^Is_Numeric_Value=5.000000000000000e+03}', "");
    Expect(0, 126241, '\p{Is_Numeric_Value=5.000000000000000e+03}', "");
    Expect(1, 126241, '\p{^Is_Numeric_Value=5.000000000000000e+03}', "");
    Expect(1, 126241, '\P{Is_Numeric_Value=5.000000000000000e+03}', "");
    Expect(0, 126241, '\P{^Is_Numeric_Value=5.000000000000000e+03}', "");
    Error('\p{Is_Nv=/a/ 	0_0_0_0_0_0_0_05000}');
    Error('\P{Is_Nv=/a/ 	0_0_0_0_0_0_0_05000}');
    Expect(1, 126240, '\p{Is_Nv=0000005000}', "");
    Expect(0, 126240, '\p{^Is_Nv=0000005000}', "");
    Expect(0, 126240, '\P{Is_Nv=0000005000}', "");
    Expect(1, 126240, '\P{^Is_Nv=0000005000}', "");
    Expect(0, 126241, '\p{Is_Nv=0000005000}', "");
    Expect(1, 126241, '\p{^Is_Nv=0000005000}', "");
    Expect(1, 126241, '\P{Is_Nv=0000005000}', "");
    Expect(0, 126241, '\P{^Is_Nv=0000005000}', "");
    Expect(1, 126240, '\p{Is_Nv:	5.000000000000000e+03}', "");
    Expect(0, 126240, '\p{^Is_Nv:	5.000000000000000e+03}', "");
    Expect(0, 126240, '\P{Is_Nv:	5.000000000000000e+03}', "");
    Expect(1, 126240, '\P{^Is_Nv:	5.000000000000000e+03}', "");
    Expect(0, 126241, '\p{Is_Nv:	5.000000000000000e+03}', "");
    Expect(1, 126241, '\p{^Is_Nv:	5.000000000000000e+03}', "");
    Expect(1, 126241, '\P{Is_Nv:	5.000000000000000e+03}', "");
    Expect(0, 126241, '\P{^Is_Nv:	5.000000000000000e+03}', "");
    Error('\p{Numeric_Value:   	-0000000050000:=}');
    Error('\P{Numeric_Value:   	-0000000050000:=}');
    Expect(1, 126249, '\p{Numeric_Value=:\A50000\z:}', "");;
    Expect(0, 126250, '\p{Numeric_Value=:\A50000\z:}', "");;
    Expect(1, 126249, '\p{Numeric_Value=050000}', "");
    Expect(0, 126249, '\p{^Numeric_Value=050000}', "");
    Expect(0, 126249, '\P{Numeric_Value=050000}', "");
    Expect(1, 126249, '\P{^Numeric_Value=050000}', "");
    Expect(0, 126250, '\p{Numeric_Value=050000}', "");
    Expect(1, 126250, '\p{^Numeric_Value=050000}', "");
    Expect(1, 126250, '\P{Numeric_Value=050000}', "");
    Expect(0, 126250, '\P{^Numeric_Value=050000}', "");
    Expect(1, 126249, '\p{Numeric_Value=5.000000000000000e+04}', "");
    Expect(0, 126249, '\p{^Numeric_Value=5.000000000000000e+04}', "");
    Expect(0, 126249, '\P{Numeric_Value=5.000000000000000e+04}', "");
    Expect(1, 126249, '\P{^Numeric_Value=5.000000000000000e+04}', "");
    Expect(0, 126250, '\p{Numeric_Value=5.000000000000000e+04}', "");
    Expect(1, 126250, '\p{^Numeric_Value=5.000000000000000e+04}', "");
    Expect(1, 126250, '\P{Numeric_Value=5.000000000000000e+04}', "");
    Expect(0, 126250, '\P{^Numeric_Value=5.000000000000000e+04}', "");
    Error('\p{Nv=/a/- 0050000}');
    Error('\P{Nv=/a/- 0050000}');
    Expect(1, 126249, '\p{Nv=:\A50000\z:}', "");;
    Expect(0, 126250, '\p{Nv=:\A50000\z:}', "");;
    Expect(1, 126249, '\p{Nv=00000_05000_0}', "");
    Expect(0, 126249, '\p{^Nv=00000_05000_0}', "");
    Expect(0, 126249, '\P{Nv=00000_05000_0}', "");
    Expect(1, 126249, '\P{^Nv=00000_05000_0}', "");
    Expect(0, 126250, '\p{Nv=00000_05000_0}', "");
    Expect(1, 126250, '\p{^Nv=00000_05000_0}', "");
    Expect(1, 126250, '\P{Nv=00000_05000_0}', "");
    Expect(0, 126250, '\P{^Nv=00000_05000_0}', "");
    Expect(1, 126249, '\p{Nv=5.000000000000000e+04}', "");
    Expect(0, 126249, '\p{^Nv=5.000000000000000e+04}', "");
    Expect(0, 126249, '\P{Nv=5.000000000000000e+04}', "");
    Expect(1, 126249, '\P{^Nv=5.000000000000000e+04}', "");
    Expect(0, 126250, '\p{Nv=5.000000000000000e+04}', "");
    Expect(1, 126250, '\p{^Nv=5.000000000000000e+04}', "");
    Expect(1, 126250, '\P{Nv=5.000000000000000e+04}', "");
    Expect(0, 126250, '\P{^Nv=5.000000000000000e+04}', "");
    Error('\p{Is_Numeric_Value=/a/-00_00_00_50_00_0}');
    Error('\P{Is_Numeric_Value=/a/-00_00_00_50_00_0}');
    Expect(1, 126249, '\p{Is_Numeric_Value=+005_000_0}', "");
    Expect(0, 126249, '\p{^Is_Numeric_Value=+005_000_0}', "");
    Expect(0, 126249, '\P{Is_Numeric_Value=+005_000_0}', "");
    Expect(1, 126249, '\P{^Is_Numeric_Value=+005_000_0}', "");
    Expect(0, 126250, '\p{Is_Numeric_Value=+005_000_0}', "");
    Expect(1, 126250, '\p{^Is_Numeric_Value=+005_000_0}', "");
    Expect(1, 126250, '\P{Is_Numeric_Value=+005_000_0}', "");
    Expect(0, 126250, '\P{^Is_Numeric_Value=+005_000_0}', "");
    Expect(1, 126249, '\p{Is_Numeric_Value=5.000000000000000e+04}', "");
    Expect(0, 126249, '\p{^Is_Numeric_Value=5.000000000000000e+04}', "");
    Expect(0, 126249, '\P{Is_Numeric_Value=5.000000000000000e+04}', "");
    Expect(1, 126249, '\P{^Is_Numeric_Value=5.000000000000000e+04}', "");
    Expect(0, 126250, '\p{Is_Numeric_Value=5.000000000000000e+04}', "");
    Expect(1, 126250, '\p{^Is_Numeric_Value=5.000000000000000e+04}', "");
    Expect(1, 126250, '\P{Is_Numeric_Value=5.000000000000000e+04}', "");
    Expect(0, 126250, '\P{^Is_Numeric_Value=5.000000000000000e+04}', "");
    Error('\p{Is_Nv=_:=050000}');
    Error('\P{Is_Nv=_:=050000}');
    Expect(1, 126249, '\p{Is_Nv=+005_000_0}', "");
    Expect(0, 126249, '\p{^Is_Nv=+005_000_0}', "");
    Expect(0, 126249, '\P{Is_Nv=+005_000_0}', "");
    Expect(1, 126249, '\P{^Is_Nv=+005_000_0}', "");
    Expect(0, 126250, '\p{Is_Nv=+005_000_0}', "");
    Expect(1, 126250, '\p{^Is_Nv=+005_000_0}', "");
    Expect(1, 126250, '\P{Is_Nv=+005_000_0}', "");
    Expect(0, 126250, '\P{^Is_Nv=+005_000_0}', "");
    Expect(1, 126249, '\p{Is_Nv=5.000000000000000e+04}', "");
    Expect(0, 126249, '\p{^Is_Nv=5.000000000000000e+04}', "");
    Expect(0, 126249, '\P{Is_Nv=5.000000000000000e+04}', "");
    Expect(1, 126249, '\P{^Is_Nv=5.000000000000000e+04}', "");
    Expect(0, 126250, '\p{Is_Nv=5.000000000000000e+04}', "");
    Expect(1, 126250, '\p{^Is_Nv=5.000000000000000e+04}', "");
    Expect(1, 126250, '\P{Is_Nv=5.000000000000000e+04}', "");
    Expect(0, 126250, '\P{^Is_Nv=5.000000000000000e+04}', "");
    Error('\p{Numeric_Value=:=0_0_0_0_0_0_0_5_00000}');
    Error('\P{Numeric_Value=:=0_0_0_0_0_0_0_5_00000}');
    Expect(1, 68081, '\p{Numeric_Value=:\A500000\z:}', "");;
    Expect(0, 68082, '\p{Numeric_Value=:\A500000\z:}', "");;
    Expect(1, 68081, '\p{Numeric_Value=+000000500000}', "");
    Expect(0, 68081, '\p{^Numeric_Value=+000000500000}', "");
    Expect(0, 68081, '\P{Numeric_Value=+000000500000}', "");
    Expect(1, 68081, '\P{^Numeric_Value=+000000500000}', "");
    Expect(0, 68082, '\p{Numeric_Value=+000000500000}', "");
    Expect(1, 68082, '\p{^Numeric_Value=+000000500000}', "");
    Expect(1, 68082, '\P{Numeric_Value=+000000500000}', "");
    Expect(0, 68082, '\P{^Numeric_Value=+000000500000}', "");
    Expect(1, 68081, '\p{Numeric_Value=5.000000000000000e+05}', "");
    Expect(0, 68081, '\p{^Numeric_Value=5.000000000000000e+05}', "");
    Expect(0, 68081, '\P{Numeric_Value=5.000000000000000e+05}', "");
    Expect(1, 68081, '\P{^Numeric_Value=5.000000000000000e+05}', "");
    Expect(0, 68082, '\p{Numeric_Value=5.000000000000000e+05}', "");
    Expect(1, 68082, '\p{^Numeric_Value=5.000000000000000e+05}', "");
    Expect(1, 68082, '\P{Numeric_Value=5.000000000000000e+05}', "");
    Expect(0, 68082, '\P{^Numeric_Value=5.000000000000000e+05}', "");
    Error('\p{Nv=/a/+00500000}');
    Error('\P{Nv=/a/+00500000}');
    Expect(1, 68081, '\p{Nv=:\A500000\z:}', "");;
    Expect(0, 68082, '\p{Nv=:\A500000\z:}', "");;
    Expect(1, 68081, '\p{Nv=000000500000}', "");
    Expect(0, 68081, '\p{^Nv=000000500000}', "");
    Expect(0, 68081, '\P{Nv=000000500000}', "");
    Expect(1, 68081, '\P{^Nv=000000500000}', "");
    Expect(0, 68082, '\p{Nv=000000500000}', "");
    Expect(1, 68082, '\p{^Nv=000000500000}', "");
    Expect(1, 68082, '\P{Nv=000000500000}', "");
    Expect(0, 68082, '\P{^Nv=000000500000}', "");
    Expect(1, 68081, '\p{Nv=5.000000000000000e+05}', "");
    Expect(0, 68081, '\p{^Nv=5.000000000000000e+05}', "");
    Expect(0, 68081, '\P{Nv=5.000000000000000e+05}', "");
    Expect(1, 68081, '\P{^Nv=5.000000000000000e+05}', "");
    Expect(0, 68082, '\p{Nv=5.000000000000000e+05}', "");
    Expect(1, 68082, '\p{^Nv=5.000000000000000e+05}', "");
    Expect(1, 68082, '\P{Nv=5.000000000000000e+05}', "");
    Expect(0, 68082, '\P{^Nv=5.000000000000000e+05}', "");
    Error('\p{Is_Numeric_Value=:=__0500000}');
    Error('\P{Is_Numeric_Value=:=__0500000}');
    Expect(1, 68081, '\p{Is_Numeric_Value:0050000_0}', "");
    Expect(0, 68081, '\p{^Is_Numeric_Value:0050000_0}', "");
    Expect(0, 68081, '\P{Is_Numeric_Value:0050000_0}', "");
    Expect(1, 68081, '\P{^Is_Numeric_Value:0050000_0}', "");
    Expect(0, 68082, '\p{Is_Numeric_Value:0050000_0}', "");
    Expect(1, 68082, '\p{^Is_Numeric_Value:0050000_0}', "");
    Expect(1, 68082, '\P{Is_Numeric_Value:0050000_0}', "");
    Expect(0, 68082, '\P{^Is_Numeric_Value:0050000_0}', "");
    Expect(1, 68081, '\p{Is_Numeric_Value=5.000000000000000e+05}', "");
    Expect(0, 68081, '\p{^Is_Numeric_Value=5.000000000000000e+05}', "");
    Expect(0, 68081, '\P{Is_Numeric_Value=5.000000000000000e+05}', "");
    Expect(1, 68081, '\P{^Is_Numeric_Value=5.000000000000000e+05}', "");
    Expect(0, 68082, '\p{Is_Numeric_Value=5.000000000000000e+05}', "");
    Expect(1, 68082, '\p{^Is_Numeric_Value=5.000000000000000e+05}', "");
    Expect(1, 68082, '\P{Is_Numeric_Value=5.000000000000000e+05}', "");
    Expect(0, 68082, '\P{^Is_Numeric_Value=5.000000000000000e+05}', "");
    Error('\p{Is_Nv=-/a/+0_0_0_5_0_0_0_00}');
    Error('\P{Is_Nv=-/a/+0_0_0_5_0_0_0_00}');
    Expect(1, 68081, '\p{Is_Nv=0_0_0_0_0_0_0_0_500000}', "");
    Expect(0, 68081, '\p{^Is_Nv=0_0_0_0_0_0_0_0_500000}', "");
    Expect(0, 68081, '\P{Is_Nv=0_0_0_0_0_0_0_0_500000}', "");
    Expect(1, 68081, '\P{^Is_Nv=0_0_0_0_0_0_0_0_500000}', "");
    Expect(0, 68082, '\p{Is_Nv=0_0_0_0_0_0_0_0_500000}', "");
    Expect(1, 68082, '\p{^Is_Nv=0_0_0_0_0_0_0_0_500000}', "");
    Expect(1, 68082, '\P{Is_Nv=0_0_0_0_0_0_0_0_500000}', "");
    Expect(0, 68082, '\P{^Is_Nv=0_0_0_0_0_0_0_0_500000}', "");
    Expect(1, 68081, '\p{Is_Nv:	5.000000000000000e+05}', "");
    Expect(0, 68081, '\p{^Is_Nv:	5.000000000000000e+05}', "");
    Expect(0, 68081, '\P{Is_Nv:	5.000000000000000e+05}', "");
    Expect(1, 68081, '\P{^Is_Nv:	5.000000000000000e+05}', "");
    Expect(0, 68082, '\p{Is_Nv:	5.000000000000000e+05}', "");
    Expect(1, 68082, '\p{^Is_Nv:	5.000000000000000e+05}', "");
    Expect(1, 68082, '\P{Is_Nv:	5.000000000000000e+05}', "");
    Expect(0, 68082, '\P{^Is_Nv:	5.000000000000000e+05}', "");
    Error('\p{Numeric_Value=:=-	000_000_000_6}');
    Error('\P{Numeric_Value=:=-	000_000_000_6}');
    Expect(1, 133866, '\p{Numeric_Value=:\A6\z:}', "");;
    Expect(0, 133867, '\p{Numeric_Value=:\A6\z:}', "");;
    Expect(1, 133866, '\p{Numeric_Value=00_00_6}', "");
    Expect(0, 133866, '\p{^Numeric_Value=00_00_6}', "");
    Expect(0, 133866, '\P{Numeric_Value=00_00_6}', "");
    Expect(1, 133866, '\P{^Numeric_Value=00_00_6}', "");
    Expect(0, 133867, '\p{Numeric_Value=00_00_6}', "");
    Expect(1, 133867, '\p{^Numeric_Value=00_00_6}', "");
    Expect(1, 133867, '\P{Numeric_Value=00_00_6}', "");
    Expect(0, 133867, '\P{^Numeric_Value=00_00_6}', "");
    Expect(1, 133866, '\p{Numeric_Value=6.000000000000000e+00}', "");
    Expect(0, 133866, '\p{^Numeric_Value=6.000000000000000e+00}', "");
    Expect(0, 133866, '\P{Numeric_Value=6.000000000000000e+00}', "");
    Expect(1, 133866, '\P{^Numeric_Value=6.000000000000000e+00}', "");
    Expect(0, 133867, '\p{Numeric_Value=6.000000000000000e+00}', "");
    Expect(1, 133867, '\p{^Numeric_Value=6.000000000000000e+00}', "");
    Expect(1, 133867, '\P{Numeric_Value=6.000000000000000e+00}', "");
    Expect(0, 133867, '\P{^Numeric_Value=6.000000000000000e+00}', "");
    Error('\p{Nv=_	+0_0_0_0_0006/a/}');
    Error('\P{Nv=_	+0_0_0_0_0006/a/}');
    Expect(1, 133866, '\p{Nv=:\A6\z:}', "");;
    Expect(0, 133867, '\p{Nv=:\A6\z:}', "");;
    Expect(1, 133866, '\p{Nv:   0_0_06}', "");
    Expect(0, 133866, '\p{^Nv:   0_0_06}', "");
    Expect(0, 133866, '\P{Nv:   0_0_06}', "");
    Expect(1, 133866, '\P{^Nv:   0_0_06}', "");
    Expect(0, 133867, '\p{Nv:   0_0_06}', "");
    Expect(1, 133867, '\p{^Nv:   0_0_06}', "");
    Expect(1, 133867, '\P{Nv:   0_0_06}', "");
    Expect(0, 133867, '\P{^Nv:   0_0_06}', "");
    Expect(1, 133866, '\p{Nv=6.000000000000000e+00}', "");
    Expect(0, 133866, '\p{^Nv=6.000000000000000e+00}', "");
    Expect(0, 133866, '\P{Nv=6.000000000000000e+00}', "");
    Expect(1, 133866, '\P{^Nv=6.000000000000000e+00}', "");
    Expect(0, 133867, '\p{Nv=6.000000000000000e+00}', "");
    Expect(1, 133867, '\p{^Nv=6.000000000000000e+00}', "");
    Expect(1, 133867, '\P{Nv=6.000000000000000e+00}', "");
    Expect(0, 133867, '\P{^Nv=6.000000000000000e+00}', "");
    Error('\p{Is_Numeric_Value:/a/__+000000006}');
    Error('\P{Is_Numeric_Value:/a/__+000000006}');
    Expect(1, 133866, '\p{Is_Numeric_Value=+0000006}', "");
    Expect(0, 133866, '\p{^Is_Numeric_Value=+0000006}', "");
    Expect(0, 133866, '\P{Is_Numeric_Value=+0000006}', "");
    Expect(1, 133866, '\P{^Is_Numeric_Value=+0000006}', "");
    Expect(0, 133867, '\p{Is_Numeric_Value=+0000006}', "");
    Expect(1, 133867, '\p{^Is_Numeric_Value=+0000006}', "");
    Expect(1, 133867, '\P{Is_Numeric_Value=+0000006}', "");
    Expect(0, 133867, '\P{^Is_Numeric_Value=+0000006}', "");
    Expect(1, 133866, '\p{Is_Numeric_Value=6.000000000000000e+00}', "");
    Expect(0, 133866, '\p{^Is_Numeric_Value=6.000000000000000e+00}', "");
    Expect(0, 133866, '\P{Is_Numeric_Value=6.000000000000000e+00}', "");
    Expect(1, 133866, '\P{^Is_Numeric_Value=6.000000000000000e+00}', "");
    Expect(0, 133867, '\p{Is_Numeric_Value=6.000000000000000e+00}', "");
    Expect(1, 133867, '\p{^Is_Numeric_Value=6.000000000000000e+00}', "");
    Expect(1, 133867, '\P{Is_Numeric_Value=6.000000000000000e+00}', "");
    Expect(0, 133867, '\P{^Is_Numeric_Value=6.000000000000000e+00}', "");
    Error('\p{Is_Nv= /a/+0_0_0_0_0_0_006}');
    Error('\P{Is_Nv= /a/+0_0_0_0_0_0_006}');
    Expect(1, 133866, '\p{Is_Nv=+00006}', "");
    Expect(0, 133866, '\p{^Is_Nv=+00006}', "");
    Expect(0, 133866, '\P{Is_Nv=+00006}', "");
    Expect(1, 133866, '\P{^Is_Nv=+00006}', "");
    Expect(0, 133867, '\p{Is_Nv=+00006}', "");
    Expect(1, 133867, '\p{^Is_Nv=+00006}', "");
    Expect(1, 133867, '\P{Is_Nv=+00006}', "");
    Expect(0, 133867, '\P{^Is_Nv=+00006}', "");
    Expect(1, 133866, '\p{Is_Nv=6.000000000000000e+00}', "");
    Expect(0, 133866, '\p{^Is_Nv=6.000000000000000e+00}', "");
    Expect(0, 133866, '\P{Is_Nv=6.000000000000000e+00}', "");
    Expect(1, 133866, '\P{^Is_Nv=6.000000000000000e+00}', "");
    Expect(0, 133867, '\p{Is_Nv=6.000000000000000e+00}', "");
    Expect(1, 133867, '\p{^Is_Nv=6.000000000000000e+00}', "");
    Expect(1, 133867, '\P{Is_Nv=6.000000000000000e+00}', "");
    Expect(0, 133867, '\P{^Is_Nv=6.000000000000000e+00}', "");
    Error('\p{Numeric_Value=/a/0060}');
    Error('\P{Numeric_Value=/a/0060}');
    Expect(1, 126223, '\p{Numeric_Value=:\A60\z:}', "");;
    Expect(0, 126224, '\p{Numeric_Value=:\A60\z:}', "");;
    Expect(1, 126223, '\p{Numeric_Value=+60}', "");
    Expect(0, 126223, '\p{^Numeric_Value=+60}', "");
    Expect(0, 126223, '\P{Numeric_Value=+60}', "");
    Expect(1, 126223, '\P{^Numeric_Value=+60}', "");
    Expect(0, 126224, '\p{Numeric_Value=+60}', "");
    Expect(1, 126224, '\p{^Numeric_Value=+60}', "");
    Expect(1, 126224, '\P{Numeric_Value=+60}', "");
    Expect(0, 126224, '\P{^Numeric_Value=+60}', "");
    Expect(1, 126223, '\p{Numeric_Value=6.000000000000000e+01}', "");
    Expect(0, 126223, '\p{^Numeric_Value=6.000000000000000e+01}', "");
    Expect(0, 126223, '\P{Numeric_Value=6.000000000000000e+01}', "");
    Expect(1, 126223, '\P{^Numeric_Value=6.000000000000000e+01}', "");
    Expect(0, 126224, '\p{Numeric_Value=6.000000000000000e+01}', "");
    Expect(1, 126224, '\p{^Numeric_Value=6.000000000000000e+01}', "");
    Expect(1, 126224, '\P{Numeric_Value=6.000000000000000e+01}', "");
    Expect(0, 126224, '\P{^Numeric_Value=6.000000000000000e+01}', "");
    Error('\p{Nv::=0_0_60}');
    Error('\P{Nv::=0_0_60}');
    Expect(1, 126223, '\p{Nv=:\A60\z:}', "");;
    Expect(0, 126224, '\p{Nv=:\A60\z:}', "");;
    Expect(1, 126223, '\p{Nv:0000060}', "");
    Expect(0, 126223, '\p{^Nv:0000060}', "");
    Expect(0, 126223, '\P{Nv:0000060}', "");
    Expect(1, 126223, '\P{^Nv:0000060}', "");
    Expect(0, 126224, '\p{Nv:0000060}', "");
    Expect(1, 126224, '\p{^Nv:0000060}', "");
    Expect(1, 126224, '\P{Nv:0000060}', "");
    Expect(0, 126224, '\P{^Nv:0000060}', "");
    Expect(1, 126223, '\p{Nv=6.000000000000000e+01}', "");
    Expect(0, 126223, '\p{^Nv=6.000000000000000e+01}', "");
    Expect(0, 126223, '\P{Nv=6.000000000000000e+01}', "");
    Expect(1, 126223, '\P{^Nv=6.000000000000000e+01}', "");
    Expect(0, 126224, '\p{Nv=6.000000000000000e+01}', "");
    Expect(1, 126224, '\p{^Nv=6.000000000000000e+01}', "");
    Expect(1, 126224, '\P{Nv=6.000000000000000e+01}', "");
    Expect(0, 126224, '\P{^Nv=6.000000000000000e+01}', "");
    Error('\p{Is_Numeric_Value=:= 	+060}');
    Error('\P{Is_Numeric_Value=:= 	+060}');
    Expect(1, 126223, '\p{Is_Numeric_Value: 6_0}', "");
    Expect(0, 126223, '\p{^Is_Numeric_Value: 6_0}', "");
    Expect(0, 126223, '\P{Is_Numeric_Value: 6_0}', "");
    Expect(1, 126223, '\P{^Is_Numeric_Value: 6_0}', "");
    Expect(0, 126224, '\p{Is_Numeric_Value: 6_0}', "");
    Expect(1, 126224, '\p{^Is_Numeric_Value: 6_0}', "");
    Expect(1, 126224, '\P{Is_Numeric_Value: 6_0}', "");
    Expect(0, 126224, '\P{^Is_Numeric_Value: 6_0}', "");
    Expect(1, 126223, '\p{Is_Numeric_Value=6.000000000000000e+01}', "");
    Expect(0, 126223, '\p{^Is_Numeric_Value=6.000000000000000e+01}', "");
    Expect(0, 126223, '\P{Is_Numeric_Value=6.000000000000000e+01}', "");
    Expect(1, 126223, '\P{^Is_Numeric_Value=6.000000000000000e+01}', "");
    Expect(0, 126224, '\p{Is_Numeric_Value=6.000000000000000e+01}', "");
    Expect(1, 126224, '\p{^Is_Numeric_Value=6.000000000000000e+01}', "");
    Expect(1, 126224, '\P{Is_Numeric_Value=6.000000000000000e+01}', "");
    Expect(0, 126224, '\P{^Is_Numeric_Value=6.000000000000000e+01}', "");
    Error('\p{Is_Nv=:= _00_00_00_060}');
    Error('\P{Is_Nv=:= _00_00_00_060}');
    Expect(1, 126223, '\p{Is_Nv=060}', "");
    Expect(0, 126223, '\p{^Is_Nv=060}', "");
    Expect(0, 126223, '\P{Is_Nv=060}', "");
    Expect(1, 126223, '\P{^Is_Nv=060}', "");
    Expect(0, 126224, '\p{Is_Nv=060}', "");
    Expect(1, 126224, '\p{^Is_Nv=060}', "");
    Expect(1, 126224, '\P{Is_Nv=060}', "");
    Expect(0, 126224, '\P{^Is_Nv=060}', "");
    Expect(1, 126223, '\p{Is_Nv=6.000000000000000e+01}', "");
    Expect(0, 126223, '\p{^Is_Nv=6.000000000000000e+01}', "");
    Expect(0, 126223, '\P{Is_Nv=6.000000000000000e+01}', "");
    Expect(1, 126223, '\P{^Is_Nv=6.000000000000000e+01}', "");
    Expect(0, 126224, '\p{Is_Nv=6.000000000000000e+01}', "");
    Expect(1, 126224, '\p{^Is_Nv=6.000000000000000e+01}', "");
    Expect(1, 126224, '\P{Is_Nv=6.000000000000000e+01}', "");
    Expect(0, 126224, '\P{^Is_Nv=6.000000000000000e+01}', "");
    Error('\p{Numeric_Value=/a/	000000000600}');
    Error('\P{Numeric_Value=/a/	000000000600}');
    Expect(1, 126265, '\p{Numeric_Value=:\A600\z:}', "");;
    Expect(0, 126266, '\p{Numeric_Value=:\A600\z:}', "");;
    Expect(1, 126265, '\p{Numeric_Value:	000000600}', "");
    Expect(0, 126265, '\p{^Numeric_Value:	000000600}', "");
    Expect(0, 126265, '\P{Numeric_Value:	000000600}', "");
    Expect(1, 126265, '\P{^Numeric_Value:	000000600}', "");
    Expect(0, 126266, '\p{Numeric_Value:	000000600}', "");
    Expect(1, 126266, '\p{^Numeric_Value:	000000600}', "");
    Expect(1, 126266, '\P{Numeric_Value:	000000600}', "");
    Expect(0, 126266, '\P{^Numeric_Value:	000000600}', "");
    Expect(1, 126265, '\p{Numeric_Value=6.000000000000000e+02}', "");
    Expect(0, 126265, '\p{^Numeric_Value=6.000000000000000e+02}', "");
    Expect(0, 126265, '\P{Numeric_Value=6.000000000000000e+02}', "");
    Expect(1, 126265, '\P{^Numeric_Value=6.000000000000000e+02}', "");
    Expect(0, 126266, '\p{Numeric_Value=6.000000000000000e+02}', "");
    Expect(1, 126266, '\p{^Numeric_Value=6.000000000000000e+02}', "");
    Expect(1, 126266, '\P{Numeric_Value=6.000000000000000e+02}', "");
    Expect(0, 126266, '\P{^Numeric_Value=6.000000000000000e+02}', "");
    Error('\p{Nv=		00_06_00/a/}');
    Error('\P{Nv=		00_06_00/a/}');
    Expect(1, 126265, '\p{Nv=:\A600\z:}', "");;
    Expect(0, 126266, '\p{Nv=:\A600\z:}', "");;
    Expect(1, 126265, '\p{Nv=0000000600}', "");
    Expect(0, 126265, '\p{^Nv=0000000600}', "");
    Expect(0, 126265, '\P{Nv=0000000600}', "");
    Expect(1, 126265, '\P{^Nv=0000000600}', "");
    Expect(0, 126266, '\p{Nv=0000000600}', "");
    Expect(1, 126266, '\p{^Nv=0000000600}', "");
    Expect(1, 126266, '\P{Nv=0000000600}', "");
    Expect(0, 126266, '\P{^Nv=0000000600}', "");
    Expect(1, 126265, '\p{Nv=6.000000000000000e+02}', "");
    Expect(0, 126265, '\p{^Nv=6.000000000000000e+02}', "");
    Expect(0, 126265, '\P{Nv=6.000000000000000e+02}', "");
    Expect(1, 126265, '\P{^Nv=6.000000000000000e+02}', "");
    Expect(0, 126266, '\p{Nv=6.000000000000000e+02}', "");
    Expect(1, 126266, '\p{^Nv=6.000000000000000e+02}', "");
    Expect(1, 126266, '\P{Nv=6.000000000000000e+02}', "");
    Expect(0, 126266, '\P{^Nv=6.000000000000000e+02}', "");
    Error('\p{Is_Numeric_Value=:=_000_000_060_0}');
    Error('\P{Is_Numeric_Value=:=_000_000_060_0}');
    Expect(1, 126265, '\p{Is_Numeric_Value=000_006_00}', "");
    Expect(0, 126265, '\p{^Is_Numeric_Value=000_006_00}', "");
    Expect(0, 126265, '\P{Is_Numeric_Value=000_006_00}', "");
    Expect(1, 126265, '\P{^Is_Numeric_Value=000_006_00}', "");
    Expect(0, 126266, '\p{Is_Numeric_Value=000_006_00}', "");
    Expect(1, 126266, '\p{^Is_Numeric_Value=000_006_00}', "");
    Expect(1, 126266, '\P{Is_Numeric_Value=000_006_00}', "");
    Expect(0, 126266, '\P{^Is_Numeric_Value=000_006_00}', "");
    Expect(1, 126265, '\p{Is_Numeric_Value=6.000000000000000e+02}', "");
    Expect(0, 126265, '\p{^Is_Numeric_Value=6.000000000000000e+02}', "");
    Expect(0, 126265, '\P{Is_Numeric_Value=6.000000000000000e+02}', "");
    Expect(1, 126265, '\P{^Is_Numeric_Value=6.000000000000000e+02}', "");
    Expect(0, 126266, '\p{Is_Numeric_Value=6.000000000000000e+02}', "");
    Expect(1, 126266, '\p{^Is_Numeric_Value=6.000000000000000e+02}', "");
    Expect(1, 126266, '\P{Is_Numeric_Value=6.000000000000000e+02}', "");
    Expect(0, 126266, '\P{^Is_Numeric_Value=6.000000000000000e+02}', "");
    Error('\p{Is_Nv=_/a/0600}');
    Error('\P{Is_Nv=_/a/0600}');
    Expect(1, 126265, '\p{Is_Nv=00_00_00_00_60_0}', "");
    Expect(0, 126265, '\p{^Is_Nv=00_00_00_00_60_0}', "");
    Expect(0, 126265, '\P{Is_Nv=00_00_00_00_60_0}', "");
    Expect(1, 126265, '\P{^Is_Nv=00_00_00_00_60_0}', "");
    Expect(0, 126266, '\p{Is_Nv=00_00_00_00_60_0}', "");
    Expect(1, 126266, '\p{^Is_Nv=00_00_00_00_60_0}', "");
    Expect(1, 126266, '\P{Is_Nv=00_00_00_00_60_0}', "");
    Expect(0, 126266, '\P{^Is_Nv=00_00_00_00_60_0}', "");
    Expect(1, 126265, '\p{Is_Nv=6.000000000000000e+02}', "");
    Expect(0, 126265, '\p{^Is_Nv=6.000000000000000e+02}', "");
    Expect(0, 126265, '\P{Is_Nv=6.000000000000000e+02}', "");
    Expect(1, 126265, '\P{^Is_Nv=6.000000000000000e+02}', "");
    Expect(0, 126266, '\p{Is_Nv=6.000000000000000e+02}', "");
    Expect(1, 126266, '\p{^Is_Nv=6.000000000000000e+02}', "");
    Expect(1, 126266, '\P{Is_Nv=6.000000000000000e+02}', "");
    Expect(0, 126266, '\P{^Is_Nv=6.000000000000000e+02}', "");
    Error('\p{Numeric_Value=/a/__6000}');
    Error('\P{Numeric_Value=/a/__6000}');
    Expect(1, 126241, '\p{Numeric_Value=:\A6000\z:}', "");;
    Expect(0, 126242, '\p{Numeric_Value=:\A6000\z:}', "");;
    Expect(1, 126241, '\p{Numeric_Value=+0006000}', "");
    Expect(0, 126241, '\p{^Numeric_Value=+0006000}', "");
    Expect(0, 126241, '\P{Numeric_Value=+0006000}', "");
    Expect(1, 126241, '\P{^Numeric_Value=+0006000}', "");
    Expect(0, 126242, '\p{Numeric_Value=+0006000}', "");
    Expect(1, 126242, '\p{^Numeric_Value=+0006000}', "");
    Expect(1, 126242, '\P{Numeric_Value=+0006000}', "");
    Expect(0, 126242, '\P{^Numeric_Value=+0006000}', "");
    Expect(1, 126241, '\p{Numeric_Value:	6.000000000000000e+03}', "");
    Expect(0, 126241, '\p{^Numeric_Value:	6.000000000000000e+03}', "");
    Expect(0, 126241, '\P{Numeric_Value:	6.000000000000000e+03}', "");
    Expect(1, 126241, '\P{^Numeric_Value:	6.000000000000000e+03}', "");
    Expect(0, 126242, '\p{Numeric_Value:	6.000000000000000e+03}', "");
    Expect(1, 126242, '\p{^Numeric_Value:	6.000000000000000e+03}', "");
    Expect(1, 126242, '\P{Numeric_Value:	6.000000000000000e+03}', "");
    Expect(0, 126242, '\P{^Numeric_Value:	6.000000000000000e+03}', "");
    Error('\p{Nv=	:=00_60_00}');
    Error('\P{Nv=	:=00_60_00}');
    Expect(1, 126241, '\p{Nv=:\A6000\z:}', "");;
    Expect(0, 126242, '\p{Nv=:\A6000\z:}', "");;
    Expect(1, 126241, '\p{Nv=06000}', "");
    Expect(0, 126241, '\p{^Nv=06000}', "");
    Expect(0, 126241, '\P{Nv=06000}', "");
    Expect(1, 126241, '\P{^Nv=06000}', "");
    Expect(0, 126242, '\p{Nv=06000}', "");
    Expect(1, 126242, '\p{^Nv=06000}', "");
    Expect(1, 126242, '\P{Nv=06000}', "");
    Expect(0, 126242, '\P{^Nv=06000}', "");
    Expect(1, 126241, '\p{Nv:6.000000000000000e+03}', "");
    Expect(0, 126241, '\p{^Nv:6.000000000000000e+03}', "");
    Expect(0, 126241, '\P{Nv:6.000000000000000e+03}', "");
    Expect(1, 126241, '\P{^Nv:6.000000000000000e+03}', "");
    Expect(0, 126242, '\p{Nv:6.000000000000000e+03}', "");
    Expect(1, 126242, '\p{^Nv:6.000000000000000e+03}', "");
    Expect(1, 126242, '\P{Nv:6.000000000000000e+03}', "");
    Expect(0, 126242, '\P{^Nv:6.000000000000000e+03}', "");
    Error('\p{Is_Numeric_Value=-0000600_0:=}');
    Error('\P{Is_Numeric_Value=-0000600_0:=}');
    Expect(1, 126241, '\p{Is_Numeric_Value=0_0_0_0_0_6_0_00}', "");
    Expect(0, 126241, '\p{^Is_Numeric_Value=0_0_0_0_0_6_0_00}', "");
    Expect(0, 126241, '\P{Is_Numeric_Value=0_0_0_0_0_6_0_00}', "");
    Expect(1, 126241, '\P{^Is_Numeric_Value=0_0_0_0_0_6_0_00}', "");
    Expect(0, 126242, '\p{Is_Numeric_Value=0_0_0_0_0_6_0_00}', "");
    Expect(1, 126242, '\p{^Is_Numeric_Value=0_0_0_0_0_6_0_00}', "");
    Expect(1, 126242, '\P{Is_Numeric_Value=0_0_0_0_0_6_0_00}', "");
    Expect(0, 126242, '\P{^Is_Numeric_Value=0_0_0_0_0_6_0_00}', "");
    Expect(1, 126241, '\p{Is_Numeric_Value=6.000000000000000e+03}', "");
    Expect(0, 126241, '\p{^Is_Numeric_Value=6.000000000000000e+03}', "");
    Expect(0, 126241, '\P{Is_Numeric_Value=6.000000000000000e+03}', "");
    Expect(1, 126241, '\P{^Is_Numeric_Value=6.000000000000000e+03}', "");
    Expect(0, 126242, '\p{Is_Numeric_Value=6.000000000000000e+03}', "");
    Expect(1, 126242, '\p{^Is_Numeric_Value=6.000000000000000e+03}', "");
    Expect(1, 126242, '\P{Is_Numeric_Value=6.000000000000000e+03}', "");
    Expect(0, 126242, '\P{^Is_Numeric_Value=6.000000000000000e+03}', "");
    Error('\p{Is_Nv:/a/-_0000006000}');
    Error('\P{Is_Nv:/a/-_0000006000}');
    Expect(1, 126241, '\p{Is_Nv=06000}', "");
    Expect(0, 126241, '\p{^Is_Nv=06000}', "");
    Expect(0, 126241, '\P{Is_Nv=06000}', "");
    Expect(1, 126241, '\P{^Is_Nv=06000}', "");
    Expect(0, 126242, '\p{Is_Nv=06000}', "");
    Expect(1, 126242, '\p{^Is_Nv=06000}', "");
    Expect(1, 126242, '\P{Is_Nv=06000}', "");
    Expect(0, 126242, '\P{^Is_Nv=06000}', "");
    Expect(1, 126241, '\p{Is_Nv=6.000000000000000e+03}', "");
    Expect(0, 126241, '\p{^Is_Nv=6.000000000000000e+03}', "");
    Expect(0, 126241, '\P{Is_Nv=6.000000000000000e+03}', "");
    Expect(1, 126241, '\P{^Is_Nv=6.000000000000000e+03}', "");
    Expect(0, 126242, '\p{Is_Nv=6.000000000000000e+03}', "");
    Expect(1, 126242, '\p{^Is_Nv=6.000000000000000e+03}', "");
    Expect(1, 126242, '\P{Is_Nv=6.000000000000000e+03}', "");
    Expect(0, 126242, '\P{^Is_Nv=6.000000000000000e+03}', "");
    Error('\p{Numeric_Value::=- 0_0_0_0_0_0_060000}');
    Error('\P{Numeric_Value::=- 0_0_0_0_0_0_060000}');
    Expect(1, 126250, '\p{Numeric_Value=:\A60000\z:}', "");;
    Expect(0, 126251, '\p{Numeric_Value=:\A60000\z:}', "");;
    Expect(1, 126250, '\p{Numeric_Value=+0_0_0_0_6_0000}', "");
    Expect(0, 126250, '\p{^Numeric_Value=+0_0_0_0_6_0000}', "");
    Expect(0, 126250, '\P{Numeric_Value=+0_0_0_0_6_0000}', "");
    Expect(1, 126250, '\P{^Numeric_Value=+0_0_0_0_6_0000}', "");
    Expect(0, 126251, '\p{Numeric_Value=+0_0_0_0_6_0000}', "");
    Expect(1, 126251, '\p{^Numeric_Value=+0_0_0_0_6_0000}', "");
    Expect(1, 126251, '\P{Numeric_Value=+0_0_0_0_6_0000}', "");
    Expect(0, 126251, '\P{^Numeric_Value=+0_0_0_0_6_0000}', "");
    Expect(1, 126250, '\p{Numeric_Value=6.000000000000000e+04}', "");
    Expect(0, 126250, '\p{^Numeric_Value=6.000000000000000e+04}', "");
    Expect(0, 126250, '\P{Numeric_Value=6.000000000000000e+04}', "");
    Expect(1, 126250, '\P{^Numeric_Value=6.000000000000000e+04}', "");
    Expect(0, 126251, '\p{Numeric_Value=6.000000000000000e+04}', "");
    Expect(1, 126251, '\p{^Numeric_Value=6.000000000000000e+04}', "");
    Expect(1, 126251, '\P{Numeric_Value=6.000000000000000e+04}', "");
    Expect(0, 126251, '\P{^Numeric_Value=6.000000000000000e+04}', "");
    Error('\p{Nv=:=-+060000}');
    Error('\P{Nv=:=-+060000}');
    Expect(1, 126250, '\p{Nv=:\A60000\z:}', "");;
    Expect(0, 126251, '\p{Nv=:\A60000\z:}', "");;
    Expect(1, 126250, '\p{Nv=0000000060000}', "");
    Expect(0, 126250, '\p{^Nv=0000000060000}', "");
    Expect(0, 126250, '\P{Nv=0000000060000}', "");
    Expect(1, 126250, '\P{^Nv=0000000060000}', "");
    Expect(0, 126251, '\p{Nv=0000000060000}', "");
    Expect(1, 126251, '\p{^Nv=0000000060000}', "");
    Expect(1, 126251, '\P{Nv=0000000060000}', "");
    Expect(0, 126251, '\P{^Nv=0000000060000}', "");
    Expect(1, 126250, '\p{Nv=6.000000000000000e+04}', "");
    Expect(0, 126250, '\p{^Nv=6.000000000000000e+04}', "");
    Expect(0, 126250, '\P{Nv=6.000000000000000e+04}', "");
    Expect(1, 126250, '\P{^Nv=6.000000000000000e+04}', "");
    Expect(0, 126251, '\p{Nv=6.000000000000000e+04}', "");
    Expect(1, 126251, '\p{^Nv=6.000000000000000e+04}', "");
    Expect(1, 126251, '\P{Nv=6.000000000000000e+04}', "");
    Expect(0, 126251, '\P{^Nv=6.000000000000000e+04}', "");
    Error('\p{Is_Numeric_Value=/a/0_0_0_0_0_0_0_6_0_0_00}');
    Error('\P{Is_Numeric_Value=/a/0_0_0_0_0_0_0_6_0_0_00}');
    Expect(1, 126250, '\p{Is_Numeric_Value=00_00_00_60_000}', "");
    Expect(0, 126250, '\p{^Is_Numeric_Value=00_00_00_60_000}', "");
    Expect(0, 126250, '\P{Is_Numeric_Value=00_00_00_60_000}', "");
    Expect(1, 126250, '\P{^Is_Numeric_Value=00_00_00_60_000}', "");
    Expect(0, 126251, '\p{Is_Numeric_Value=00_00_00_60_000}', "");
    Expect(1, 126251, '\p{^Is_Numeric_Value=00_00_00_60_000}', "");
    Expect(1, 126251, '\P{Is_Numeric_Value=00_00_00_60_000}', "");
    Expect(0, 126251, '\P{^Is_Numeric_Value=00_00_00_60_000}', "");
    Expect(1, 126250, '\p{Is_Numeric_Value=6.000000000000000e+04}', "");
    Expect(0, 126250, '\p{^Is_Numeric_Value=6.000000000000000e+04}', "");
    Expect(0, 126250, '\P{Is_Numeric_Value=6.000000000000000e+04}', "");
    Expect(1, 126250, '\P{^Is_Numeric_Value=6.000000000000000e+04}', "");
    Expect(0, 126251, '\p{Is_Numeric_Value=6.000000000000000e+04}', "");
    Expect(1, 126251, '\p{^Is_Numeric_Value=6.000000000000000e+04}', "");
    Expect(1, 126251, '\P{Is_Numeric_Value=6.000000000000000e+04}', "");
    Expect(0, 126251, '\P{^Is_Numeric_Value=6.000000000000000e+04}', "");
    Error('\p{Is_Nv:  -+00000000060000/a/}');
    Error('\P{Is_Nv:  -+00000000060000/a/}');
    Expect(1, 126250, '\p{Is_Nv=+00000000060000}', "");
    Expect(0, 126250, '\p{^Is_Nv=+00000000060000}', "");
    Expect(0, 126250, '\P{Is_Nv=+00000000060000}', "");
    Expect(1, 126250, '\P{^Is_Nv=+00000000060000}', "");
    Expect(0, 126251, '\p{Is_Nv=+00000000060000}', "");
    Expect(1, 126251, '\p{^Is_Nv=+00000000060000}', "");
    Expect(1, 126251, '\P{Is_Nv=+00000000060000}', "");
    Expect(0, 126251, '\P{^Is_Nv=+00000000060000}', "");
    Expect(1, 126250, '\p{Is_Nv=6.000000000000000e+04}', "");
    Expect(0, 126250, '\p{^Is_Nv=6.000000000000000e+04}', "");
    Expect(0, 126250, '\P{Is_Nv=6.000000000000000e+04}', "");
    Expect(1, 126250, '\P{^Is_Nv=6.000000000000000e+04}', "");
    Expect(0, 126251, '\p{Is_Nv=6.000000000000000e+04}', "");
    Expect(1, 126251, '\p{^Is_Nv=6.000000000000000e+04}', "");
    Expect(1, 126251, '\P{Is_Nv=6.000000000000000e+04}', "");
    Expect(0, 126251, '\P{^Is_Nv=6.000000000000000e+04}', "");
    Error('\p{Numeric_Value=  00_00_06_00_00_0:=}');
    Error('\P{Numeric_Value=  00_00_06_00_00_0:=}');
    Expect(1, 68082, '\p{Numeric_Value=:\A600000\z:}', "");;
    Expect(0, 68083, '\p{Numeric_Value=:\A600000\z:}', "");;
    Expect(1, 68082, '\p{Numeric_Value=000000000600000}', "");
    Expect(0, 68082, '\p{^Numeric_Value=000000000600000}', "");
    Expect(0, 68082, '\P{Numeric_Value=000000000600000}', "");
    Expect(1, 68082, '\P{^Numeric_Value=000000000600000}', "");
    Expect(0, 68083, '\p{Numeric_Value=000000000600000}', "");
    Expect(1, 68083, '\p{^Numeric_Value=000000000600000}', "");
    Expect(1, 68083, '\P{Numeric_Value=000000000600000}', "");
    Expect(0, 68083, '\P{^Numeric_Value=000000000600000}', "");
    Expect(1, 68082, '\p{Numeric_Value=6.000000000000000e+05}', "");
    Expect(0, 68082, '\p{^Numeric_Value=6.000000000000000e+05}', "");
    Expect(0, 68082, '\P{Numeric_Value=6.000000000000000e+05}', "");
    Expect(1, 68082, '\P{^Numeric_Value=6.000000000000000e+05}', "");
    Expect(0, 68083, '\p{Numeric_Value=6.000000000000000e+05}', "");
    Expect(1, 68083, '\p{^Numeric_Value=6.000000000000000e+05}', "");
    Expect(1, 68083, '\P{Numeric_Value=6.000000000000000e+05}', "");
    Expect(0, 68083, '\P{^Numeric_Value=6.000000000000000e+05}', "");
    Error('\p{Nv:  -+000000000600000:=}');
    Error('\P{Nv:  -+000000000600000:=}');
    Expect(1, 68082, '\p{Nv=:\A600000\z:}', "");;
    Expect(0, 68083, '\p{Nv=:\A600000\z:}', "");;
    Expect(1, 68082, '\p{Nv=00600000}', "");
    Expect(0, 68082, '\p{^Nv=00600000}', "");
    Expect(0, 68082, '\P{Nv=00600000}', "");
    Expect(1, 68082, '\P{^Nv=00600000}', "");
    Expect(0, 68083, '\p{Nv=00600000}', "");
    Expect(1, 68083, '\p{^Nv=00600000}', "");
    Expect(1, 68083, '\P{Nv=00600000}', "");
    Expect(0, 68083, '\P{^Nv=00600000}', "");
    Expect(1, 68082, '\p{Nv=6.000000000000000e+05}', "");
    Expect(0, 68082, '\p{^Nv=6.000000000000000e+05}', "");
    Expect(0, 68082, '\P{Nv=6.000000000000000e+05}', "");
    Expect(1, 68082, '\P{^Nv=6.000000000000000e+05}', "");
    Expect(0, 68083, '\p{Nv=6.000000000000000e+05}', "");
    Expect(1, 68083, '\p{^Nv=6.000000000000000e+05}', "");
    Expect(1, 68083, '\P{Nv=6.000000000000000e+05}', "");
    Expect(0, 68083, '\P{^Nv=6.000000000000000e+05}', "");
    Error('\p{Is_Numeric_Value:	 +00_00_00_06_00_00_0:=}');
    Error('\P{Is_Numeric_Value:	 +00_00_00_06_00_00_0:=}');
    Expect(1, 68082, '\p{Is_Numeric_Value=00_60_00_00}', "");
    Expect(0, 68082, '\p{^Is_Numeric_Value=00_60_00_00}', "");
    Expect(0, 68082, '\P{Is_Numeric_Value=00_60_00_00}', "");
    Expect(1, 68082, '\P{^Is_Numeric_Value=00_60_00_00}', "");
    Expect(0, 68083, '\p{Is_Numeric_Value=00_60_00_00}', "");
    Expect(1, 68083, '\p{^Is_Numeric_Value=00_60_00_00}', "");
    Expect(1, 68083, '\P{Is_Numeric_Value=00_60_00_00}', "");
    Expect(0, 68083, '\P{^Is_Numeric_Value=00_60_00_00}', "");
    Expect(1, 68082, '\p{Is_Numeric_Value:   6.000000000000000e+05}', "");
    Expect(0, 68082, '\p{^Is_Numeric_Value:   6.000000000000000e+05}', "");
    Expect(0, 68082, '\P{Is_Numeric_Value:   6.000000000000000e+05}', "");
    Expect(1, 68082, '\P{^Is_Numeric_Value:   6.000000000000000e+05}', "");
    Expect(0, 68083, '\p{Is_Numeric_Value:   6.000000000000000e+05}', "");
    Expect(1, 68083, '\p{^Is_Numeric_Value:   6.000000000000000e+05}', "");
    Expect(1, 68083, '\P{Is_Numeric_Value:   6.000000000000000e+05}', "");
    Expect(0, 68083, '\P{^Is_Numeric_Value:   6.000000000000000e+05}', "");
    Error('\p{Is_Nv=:= _6_0_0_0_00}');
    Error('\P{Is_Nv=:= _6_0_0_0_00}');
    Expect(1, 68082, '\p{Is_Nv=00_06_00_000}', "");
    Expect(0, 68082, '\p{^Is_Nv=00_06_00_000}', "");
    Expect(0, 68082, '\P{Is_Nv=00_06_00_000}', "");
    Expect(1, 68082, '\P{^Is_Nv=00_06_00_000}', "");
    Expect(0, 68083, '\p{Is_Nv=00_06_00_000}', "");
    Expect(1, 68083, '\p{^Is_Nv=00_06_00_000}', "");
    Expect(1, 68083, '\P{Is_Nv=00_06_00_000}', "");
    Expect(0, 68083, '\P{^Is_Nv=00_06_00_000}', "");
    Expect(1, 68082, '\p{Is_Nv=6.000000000000000e+05}', "");
    Expect(0, 68082, '\p{^Is_Nv=6.000000000000000e+05}', "");
    Expect(0, 68082, '\P{Is_Nv=6.000000000000000e+05}', "");
    Expect(1, 68082, '\P{^Is_Nv=6.000000000000000e+05}', "");
    Expect(0, 68083, '\p{Is_Nv=6.000000000000000e+05}', "");
    Expect(1, 68083, '\p{^Is_Nv=6.000000000000000e+05}', "");
    Expect(1, 68083, '\P{Is_Nv=6.000000000000000e+05}', "");
    Expect(0, 68083, '\P{^Is_Nv=6.000000000000000e+05}', "");
    Error('\p{Numeric_Value:   _:=00000_7}');
    Error('\P{Numeric_Value:   _:=00000_7}');
    Expect(1, 131073, '\p{Numeric_Value=:\A7\z:}', "");;
    Expect(0, 131074, '\p{Numeric_Value=:\A7\z:}', "");;
    Expect(1, 131073, '\p{Numeric_Value=7}', "");
    Expect(0, 131073, '\p{^Numeric_Value=7}', "");
    Expect(0, 131073, '\P{Numeric_Value=7}', "");
    Expect(1, 131073, '\P{^Numeric_Value=7}', "");
    Expect(0, 131074, '\p{Numeric_Value=7}', "");
    Expect(1, 131074, '\p{^Numeric_Value=7}', "");
    Expect(1, 131074, '\P{Numeric_Value=7}', "");
    Expect(0, 131074, '\P{^Numeric_Value=7}', "");
    Expect(1, 131073, '\p{Numeric_Value=7.000000000000000e+00}', "");
    Expect(0, 131073, '\p{^Numeric_Value=7.000000000000000e+00}', "");
    Expect(0, 131073, '\P{Numeric_Value=7.000000000000000e+00}', "");
    Expect(1, 131073, '\P{^Numeric_Value=7.000000000000000e+00}', "");
    Expect(0, 131074, '\p{Numeric_Value=7.000000000000000e+00}', "");
    Expect(1, 131074, '\p{^Numeric_Value=7.000000000000000e+00}', "");
    Expect(1, 131074, '\P{Numeric_Value=7.000000000000000e+00}', "");
    Expect(0, 131074, '\P{^Numeric_Value=7.000000000000000e+00}', "");
    Error('\p{Nv=-:=00007}');
    Error('\P{Nv=-:=00007}');
    Expect(1, 131073, '\p{Nv=:\A7\z:}', "");;
    Expect(0, 131074, '\p{Nv=:\A7\z:}', "");;
    Expect(1, 131073, '\p{Nv=+007}', "");
    Expect(0, 131073, '\p{^Nv=+007}', "");
    Expect(0, 131073, '\P{Nv=+007}', "");
    Expect(1, 131073, '\P{^Nv=+007}', "");
    Expect(0, 131074, '\p{Nv=+007}', "");
    Expect(1, 131074, '\p{^Nv=+007}', "");
    Expect(1, 131074, '\P{Nv=+007}', "");
    Expect(0, 131074, '\P{^Nv=+007}', "");
    Expect(1, 131073, '\p{Nv=7.000000000000000e+00}', "");
    Expect(0, 131073, '\p{^Nv=7.000000000000000e+00}', "");
    Expect(0, 131073, '\P{Nv=7.000000000000000e+00}', "");
    Expect(1, 131073, '\P{^Nv=7.000000000000000e+00}', "");
    Expect(0, 131074, '\p{Nv=7.000000000000000e+00}', "");
    Expect(1, 131074, '\p{^Nv=7.000000000000000e+00}', "");
    Expect(1, 131074, '\P{Nv=7.000000000000000e+00}', "");
    Expect(0, 131074, '\P{^Nv=7.000000000000000e+00}', "");
    Error('\p{Is_Numeric_Value=  0_0_0_0_0_0007:=}');
    Error('\P{Is_Numeric_Value=  0_0_0_0_0_0007:=}');
    Expect(1, 131073, '\p{Is_Numeric_Value=+0000000007}', "");
    Expect(0, 131073, '\p{^Is_Numeric_Value=+0000000007}', "");
    Expect(0, 131073, '\P{Is_Numeric_Value=+0000000007}', "");
    Expect(1, 131073, '\P{^Is_Numeric_Value=+0000000007}', "");
    Expect(0, 131074, '\p{Is_Numeric_Value=+0000000007}', "");
    Expect(1, 131074, '\p{^Is_Numeric_Value=+0000000007}', "");
    Expect(1, 131074, '\P{Is_Numeric_Value=+0000000007}', "");
    Expect(0, 131074, '\P{^Is_Numeric_Value=+0000000007}', "");
    Expect(1, 131073, '\p{Is_Numeric_Value=7.000000000000000e+00}', "");
    Expect(0, 131073, '\p{^Is_Numeric_Value=7.000000000000000e+00}', "");
    Expect(0, 131073, '\P{Is_Numeric_Value=7.000000000000000e+00}', "");
    Expect(1, 131073, '\P{^Is_Numeric_Value=7.000000000000000e+00}', "");
    Expect(0, 131074, '\p{Is_Numeric_Value=7.000000000000000e+00}', "");
    Expect(1, 131074, '\p{^Is_Numeric_Value=7.000000000000000e+00}', "");
    Expect(1, 131074, '\P{Is_Numeric_Value=7.000000000000000e+00}', "");
    Expect(0, 131074, '\P{^Is_Numeric_Value=7.000000000000000e+00}', "");
    Error('\p{Is_Nv=_/a/0000000007}');
    Error('\P{Is_Nv=_/a/0000000007}');
    Expect(1, 131073, '\p{Is_Nv=+07}', "");
    Expect(0, 131073, '\p{^Is_Nv=+07}', "");
    Expect(0, 131073, '\P{Is_Nv=+07}', "");
    Expect(1, 131073, '\P{^Is_Nv=+07}', "");
    Expect(0, 131074, '\p{Is_Nv=+07}', "");
    Expect(1, 131074, '\p{^Is_Nv=+07}', "");
    Expect(1, 131074, '\P{Is_Nv=+07}', "");
    Expect(0, 131074, '\P{^Is_Nv=+07}', "");
    Expect(1, 131073, '\p{Is_Nv:	7.000000000000000e+00}', "");
    Expect(0, 131073, '\p{^Is_Nv:	7.000000000000000e+00}', "");
    Expect(0, 131073, '\P{Is_Nv:	7.000000000000000e+00}', "");
    Expect(1, 131073, '\P{^Is_Nv:	7.000000000000000e+00}', "");
    Expect(0, 131074, '\p{Is_Nv:	7.000000000000000e+00}', "");
    Expect(1, 131074, '\p{^Is_Nv:	7.000000000000000e+00}', "");
    Expect(1, 131074, '\P{Is_Nv:	7.000000000000000e+00}', "");
    Expect(0, 131074, '\P{^Is_Nv:	7.000000000000000e+00}', "");
    Error('\p{Numeric_Value:   _ 0000000007/00000000012:=}');
    Error('\P{Numeric_Value:   _ 0000000007/00000000012:=}');
    Expect(1, 68092, '\p{Numeric_Value=:\A7/12\z:}', "");;
    Expect(0, 68093, '\p{Numeric_Value=:\A7/12\z:}', "");;
    Expect(1, 68092, '\p{Numeric_Value=+0000007/00000012}', "");
    Expect(0, 68092, '\p{^Numeric_Value=+0000007/00000012}', "");
    Expect(0, 68092, '\P{Numeric_Value=+0000007/00000012}', "");
    Expect(1, 68092, '\P{^Numeric_Value=+0000007/00000012}', "");
    Expect(0, 68093, '\p{Numeric_Value=+0000007/00000012}', "");
    Expect(1, 68093, '\p{^Numeric_Value=+0000007/00000012}', "");
    Expect(1, 68093, '\P{Numeric_Value=+0000007/00000012}', "");
    Expect(0, 68093, '\P{^Numeric_Value=+0000007/00000012}', "");
    Expect(1, 68092, '\p{Numeric_Value=420/720}', "");
    Expect(0, 68092, '\p{^Numeric_Value=420/720}', "");
    Expect(0, 68092, '\P{Numeric_Value=420/720}', "");
    Expect(1, 68092, '\P{^Numeric_Value=420/720}', "");
    Expect(0, 68093, '\p{Numeric_Value=420/720}', "");
    Expect(1, 68093, '\p{^Numeric_Value=420/720}', "");
    Expect(1, 68093, '\P{Numeric_Value=420/720}', "");
    Expect(0, 68093, '\P{^Numeric_Value=420/720}', "");
    Error('\p{Numeric_Value=5.8e-01}');
    Error('\P{Numeric_Value=5.8e-01}');
    Error('\p{Numeric_Value=5.83e-01}');
    Error('\P{Numeric_Value=5.83e-01}');
    Error('\p{Numeric_Value=0.58}');
    Error('\P{Numeric_Value=0.58}');
    Expect(1, 68092, '\p{Numeric_Value:	5.833e-01}', "");
    Expect(0, 68092, '\p{^Numeric_Value:	5.833e-01}', "");
    Expect(0, 68092, '\P{Numeric_Value:	5.833e-01}', "");
    Expect(1, 68092, '\P{^Numeric_Value:	5.833e-01}', "");
    Expect(0, 68093, '\p{Numeric_Value:	5.833e-01}', "");
    Expect(1, 68093, '\p{^Numeric_Value:	5.833e-01}', "");
    Expect(1, 68093, '\P{Numeric_Value:	5.833e-01}', "");
    Expect(0, 68093, '\P{^Numeric_Value:	5.833e-01}', "");
    Error('\p{Numeric_Value=0.583}');
    Error('\P{Numeric_Value=0.583}');
    Expect(1, 68092, '\p{Numeric_Value=5.8333e-01}', "");
    Expect(0, 68092, '\p{^Numeric_Value=5.8333e-01}', "");
    Expect(0, 68092, '\P{Numeric_Value=5.8333e-01}', "");
    Expect(1, 68092, '\P{^Numeric_Value=5.8333e-01}', "");
    Expect(0, 68093, '\p{Numeric_Value=5.8333e-01}', "");
    Expect(1, 68093, '\p{^Numeric_Value=5.8333e-01}', "");
    Expect(1, 68093, '\P{Numeric_Value=5.8333e-01}', "");
    Expect(0, 68093, '\P{^Numeric_Value=5.8333e-01}', "");
    Expect(1, 68092, '\p{Numeric_Value=0.5833}', "");
    Expect(0, 68092, '\p{^Numeric_Value=0.5833}', "");
    Expect(0, 68092, '\P{Numeric_Value=0.5833}', "");
    Expect(1, 68092, '\P{^Numeric_Value=0.5833}', "");
    Expect(0, 68093, '\p{Numeric_Value=0.5833}', "");
    Expect(1, 68093, '\p{^Numeric_Value=0.5833}', "");
    Expect(1, 68093, '\P{Numeric_Value=0.5833}', "");
    Expect(0, 68093, '\P{^Numeric_Value=0.5833}', "");
    Expect(1, 68092, '\p{Numeric_Value=5.83333e-01}', "");
    Expect(0, 68092, '\p{^Numeric_Value=5.83333e-01}', "");
    Expect(0, 68092, '\P{Numeric_Value=5.83333e-01}', "");
    Expect(1, 68092, '\P{^Numeric_Value=5.83333e-01}', "");
    Expect(0, 68093, '\p{Numeric_Value=5.83333e-01}', "");
    Expect(1, 68093, '\p{^Numeric_Value=5.83333e-01}', "");
    Expect(1, 68093, '\P{Numeric_Value=5.83333e-01}', "");
    Expect(0, 68093, '\P{^Numeric_Value=5.83333e-01}', "");
    Expect(1, 68092, '\p{Numeric_Value=0.58333}', "");
    Expect(0, 68092, '\p{^Numeric_Value=0.58333}', "");
    Expect(0, 68092, '\P{Numeric_Value=0.58333}', "");
    Expect(1, 68092, '\P{^Numeric_Value=0.58333}', "");
    Expect(0, 68093, '\p{Numeric_Value=0.58333}', "");
    Expect(1, 68093, '\p{^Numeric_Value=0.58333}', "");
    Expect(1, 68093, '\P{Numeric_Value=0.58333}', "");
    Expect(0, 68093, '\P{^Numeric_Value=0.58333}', "");
    Error('\p{Nv:	 _+000000007/12:=}');
    Error('\P{Nv:	 _+000000007/12:=}');
    Expect(1, 68092, '\p{Nv=:\A7/12\z:}', "");;
    Expect(0, 68093, '\p{Nv=:\A7/12\z:}', "");;
    Expect(1, 68092, '\p{Nv=0000007/00000000012}', "");
    Expect(0, 68092, '\p{^Nv=0000007/00000000012}', "");
    Expect(0, 68092, '\P{Nv=0000007/00000000012}', "");
    Expect(1, 68092, '\P{^Nv=0000007/00000000012}', "");
    Expect(0, 68093, '\p{Nv=0000007/00000000012}', "");
    Expect(1, 68093, '\p{^Nv=0000007/00000000012}', "");
    Expect(1, 68093, '\P{Nv=0000007/00000000012}', "");
    Expect(0, 68093, '\P{^Nv=0000007/00000000012}', "");
    Expect(1, 68092, '\p{Nv=420/720}', "");
    Expect(0, 68092, '\p{^Nv=420/720}', "");
    Expect(0, 68092, '\P{Nv=420/720}', "");
    Expect(1, 68092, '\P{^Nv=420/720}', "");
    Expect(0, 68093, '\p{Nv=420/720}', "");
    Expect(1, 68093, '\p{^Nv=420/720}', "");
    Expect(1, 68093, '\P{Nv=420/720}', "");
    Expect(0, 68093, '\P{^Nv=420/720}', "");
    Error('\p{Nv=5.8e-01}');
    Error('\P{Nv=5.8e-01}');
    Error('\p{Nv: 5.83e-01}');
    Error('\P{Nv: 5.83e-01}');
    Error('\p{Nv=0.58}');
    Error('\P{Nv=0.58}');
    Expect(1, 68092, '\p{Nv=5.833e-01}', "");
    Expect(0, 68092, '\p{^Nv=5.833e-01}', "");
    Expect(0, 68092, '\P{Nv=5.833e-01}', "");
    Expect(1, 68092, '\P{^Nv=5.833e-01}', "");
    Expect(0, 68093, '\p{Nv=5.833e-01}', "");
    Expect(1, 68093, '\p{^Nv=5.833e-01}', "");
    Expect(1, 68093, '\P{Nv=5.833e-01}', "");
    Expect(0, 68093, '\P{^Nv=5.833e-01}', "");
    Error('\p{Nv=0.583}');
    Error('\P{Nv=0.583}');
    Expect(1, 68092, '\p{Nv:5.8333e-01}', "");
    Expect(0, 68092, '\p{^Nv:5.8333e-01}', "");
    Expect(0, 68092, '\P{Nv:5.8333e-01}', "");
    Expect(1, 68092, '\P{^Nv:5.8333e-01}', "");
    Expect(0, 68093, '\p{Nv:5.8333e-01}', "");
    Expect(1, 68093, '\p{^Nv:5.8333e-01}', "");
    Expect(1, 68093, '\P{Nv:5.8333e-01}', "");
    Expect(0, 68093, '\P{^Nv:5.8333e-01}', "");
    Expect(1, 68092, '\p{Nv=0.5833}', "");
    Expect(0, 68092, '\p{^Nv=0.5833}', "");
    Expect(0, 68092, '\P{Nv=0.5833}', "");
    Expect(1, 68092, '\P{^Nv=0.5833}', "");
    Expect(0, 68093, '\p{Nv=0.5833}', "");
    Expect(1, 68093, '\p{^Nv=0.5833}', "");
    Expect(1, 68093, '\P{Nv=0.5833}', "");
    Expect(0, 68093, '\P{^Nv=0.5833}', "");
    Expect(1, 68092, '\p{Nv=5.83333e-01}', "");
    Expect(0, 68092, '\p{^Nv=5.83333e-01}', "");
    Expect(0, 68092, '\P{Nv=5.83333e-01}', "");
    Expect(1, 68092, '\P{^Nv=5.83333e-01}', "");
    Expect(0, 68093, '\p{Nv=5.83333e-01}', "");
    Expect(1, 68093, '\p{^Nv=5.83333e-01}', "");
    Expect(1, 68093, '\P{Nv=5.83333e-01}', "");
    Expect(0, 68093, '\P{^Nv=5.83333e-01}', "");
    Expect(1, 68092, '\p{Nv: 0.58333}', "");
    Expect(0, 68092, '\p{^Nv: 0.58333}', "");
    Expect(0, 68092, '\P{Nv: 0.58333}', "");
    Expect(1, 68092, '\P{^Nv: 0.58333}', "");
    Expect(0, 68093, '\p{Nv: 0.58333}', "");
    Expect(1, 68093, '\p{^Nv: 0.58333}', "");
    Expect(1, 68093, '\P{Nv: 0.58333}', "");
    Expect(0, 68093, '\P{^Nv: 0.58333}', "");
    Error('\p{Is_Numeric_Value=	:=00007/0000000012}');
    Error('\P{Is_Numeric_Value=	:=00007/0000000012}');
    Expect(1, 68092, '\p{Is_Numeric_Value=007/000012}', "");
    Expect(0, 68092, '\p{^Is_Numeric_Value=007/000012}', "");
    Expect(0, 68092, '\P{Is_Numeric_Value=007/000012}', "");
    Expect(1, 68092, '\P{^Is_Numeric_Value=007/000012}', "");
    Expect(0, 68093, '\p{Is_Numeric_Value=007/000012}', "");
    Expect(1, 68093, '\p{^Is_Numeric_Value=007/000012}', "");
    Expect(1, 68093, '\P{Is_Numeric_Value=007/000012}', "");
    Expect(0, 68093, '\P{^Is_Numeric_Value=007/000012}', "");
    Expect(1, 68092, '\p{Is_Numeric_Value=420/720}', "");
    Expect(0, 68092, '\p{^Is_Numeric_Value=420/720}', "");
    Expect(0, 68092, '\P{Is_Numeric_Value=420/720}', "");
    Expect(1, 68092, '\P{^Is_Numeric_Value=420/720}', "");
    Expect(0, 68093, '\p{Is_Numeric_Value=420/720}', "");
    Expect(1, 68093, '\p{^Is_Numeric_Value=420/720}', "");
    Expect(1, 68093, '\P{Is_Numeric_Value=420/720}', "");
    Expect(0, 68093, '\P{^Is_Numeric_Value=420/720}', "");
    Error('\p{Is_Numeric_Value=5.8e-01}');
    Error('\P{Is_Numeric_Value=5.8e-01}');
    Error('\p{Is_Numeric_Value=5.83e-01}');
    Error('\P{Is_Numeric_Value=5.83e-01}');
    Error('\p{Is_Numeric_Value=0.58}');
    Error('\P{Is_Numeric_Value=0.58}');
    Expect(1, 68092, '\p{Is_Numeric_Value=5.833e-01}', "");
    Expect(0, 68092, '\p{^Is_Numeric_Value=5.833e-01}', "");
    Expect(0, 68092, '\P{Is_Numeric_Value=5.833e-01}', "");
    Expect(1, 68092, '\P{^Is_Numeric_Value=5.833e-01}', "");
    Expect(0, 68093, '\p{Is_Numeric_Value=5.833e-01}', "");
    Expect(1, 68093, '\p{^Is_Numeric_Value=5.833e-01}', "");
    Expect(1, 68093, '\P{Is_Numeric_Value=5.833e-01}', "");
    Expect(0, 68093, '\P{^Is_Numeric_Value=5.833e-01}', "");
    Error('\p{Is_Numeric_Value=0.583}');
    Error('\P{Is_Numeric_Value=0.583}');
    Expect(1, 68092, '\p{Is_Numeric_Value=5.8333e-01}', "");
    Expect(0, 68092, '\p{^Is_Numeric_Value=5.8333e-01}', "");
    Expect(0, 68092, '\P{Is_Numeric_Value=5.8333e-01}', "");
    Expect(1, 68092, '\P{^Is_Numeric_Value=5.8333e-01}', "");
    Expect(0, 68093, '\p{Is_Numeric_Value=5.8333e-01}', "");
    Expect(1, 68093, '\p{^Is_Numeric_Value=5.8333e-01}', "");
    Expect(1, 68093, '\P{Is_Numeric_Value=5.8333e-01}', "");
    Expect(0, 68093, '\P{^Is_Numeric_Value=5.8333e-01}', "");
    Expect(1, 68092, '\p{Is_Numeric_Value:0.5833}', "");
    Expect(0, 68092, '\p{^Is_Numeric_Value:0.5833}', "");
    Expect(0, 68092, '\P{Is_Numeric_Value:0.5833}', "");
    Expect(1, 68092, '\P{^Is_Numeric_Value:0.5833}', "");
    Expect(0, 68093, '\p{Is_Numeric_Value:0.5833}', "");
    Expect(1, 68093, '\p{^Is_Numeric_Value:0.5833}', "");
    Expect(1, 68093, '\P{Is_Numeric_Value:0.5833}', "");
    Expect(0, 68093, '\P{^Is_Numeric_Value:0.5833}', "");
    Expect(1, 68092, '\p{Is_Numeric_Value:	5.83333e-01}', "");
    Expect(0, 68092, '\p{^Is_Numeric_Value:	5.83333e-01}', "");
    Expect(0, 68092, '\P{Is_Numeric_Value:	5.83333e-01}', "");
    Expect(1, 68092, '\P{^Is_Numeric_Value:	5.83333e-01}', "");
    Expect(0, 68093, '\p{Is_Numeric_Value:	5.83333e-01}', "");
    Expect(1, 68093, '\p{^Is_Numeric_Value:	5.83333e-01}', "");
    Expect(1, 68093, '\P{Is_Numeric_Value:	5.83333e-01}', "");
    Expect(0, 68093, '\P{^Is_Numeric_Value:	5.83333e-01}', "");
    Expect(1, 68092, '\p{Is_Numeric_Value=0.58333}', "");
    Expect(0, 68092, '\p{^Is_Numeric_Value=0.58333}', "");
    Expect(0, 68092, '\P{Is_Numeric_Value=0.58333}', "");
    Expect(1, 68092, '\P{^Is_Numeric_Value=0.58333}', "");
    Expect(0, 68093, '\p{Is_Numeric_Value=0.58333}', "");
    Expect(1, 68093, '\p{^Is_Numeric_Value=0.58333}', "");
    Expect(1, 68093, '\P{Is_Numeric_Value=0.58333}', "");
    Expect(0, 68093, '\P{^Is_Numeric_Value=0.58333}', "");
    Error('\p{Is_Nv=_0000000007/00000012:=}');
    Error('\P{Is_Nv=_0000000007/00000012:=}');
    Expect(1, 68092, '\p{Is_Nv=0000000007/12}', "");
    Expect(0, 68092, '\p{^Is_Nv=0000000007/12}', "");
    Expect(0, 68092, '\P{Is_Nv=0000000007/12}', "");
    Expect(1, 68092, '\P{^Is_Nv=0000000007/12}', "");
    Expect(0, 68093, '\p{Is_Nv=0000000007/12}', "");
    Expect(1, 68093, '\p{^Is_Nv=0000000007/12}', "");
    Expect(1, 68093, '\P{Is_Nv=0000000007/12}', "");
    Expect(0, 68093, '\P{^Is_Nv=0000000007/12}', "");
    Expect(1, 68092, '\p{Is_Nv: 420/720}', "");
    Expect(0, 68092, '\p{^Is_Nv: 420/720}', "");
    Expect(0, 68092, '\P{Is_Nv: 420/720}', "");
    Expect(1, 68092, '\P{^Is_Nv: 420/720}', "");
    Expect(0, 68093, '\p{Is_Nv: 420/720}', "");
    Expect(1, 68093, '\p{^Is_Nv: 420/720}', "");
    Expect(1, 68093, '\P{Is_Nv: 420/720}', "");
    Expect(0, 68093, '\P{^Is_Nv: 420/720}', "");
    Error('\p{Is_Nv=5.8e-01}');
    Error('\P{Is_Nv=5.8e-01}');
    Error('\p{Is_Nv=5.83e-01}');
    Error('\P{Is_Nv=5.83e-01}');
    Error('\p{Is_Nv=0.58}');
    Error('\P{Is_Nv=0.58}');
    Expect(1, 68092, '\p{Is_Nv=5.833e-01}', "");
    Expect(0, 68092, '\p{^Is_Nv=5.833e-01}', "");
    Expect(0, 68092, '\P{Is_Nv=5.833e-01}', "");
    Expect(1, 68092, '\P{^Is_Nv=5.833e-01}', "");
    Expect(0, 68093, '\p{Is_Nv=5.833e-01}', "");
    Expect(1, 68093, '\p{^Is_Nv=5.833e-01}', "");
    Expect(1, 68093, '\P{Is_Nv=5.833e-01}', "");
    Expect(0, 68093, '\P{^Is_Nv=5.833e-01}', "");
    Error('\p{Is_Nv=0.583}');
    Error('\P{Is_Nv=0.583}');
    Expect(1, 68092, '\p{Is_Nv=5.8333e-01}', "");
    Expect(0, 68092, '\p{^Is_Nv=5.8333e-01}', "");
    Expect(0, 68092, '\P{Is_Nv=5.8333e-01}', "");
    Expect(1, 68092, '\P{^Is_Nv=5.8333e-01}', "");
    Expect(0, 68093, '\p{Is_Nv=5.8333e-01}', "");
    Expect(1, 68093, '\p{^Is_Nv=5.8333e-01}', "");
    Expect(1, 68093, '\P{Is_Nv=5.8333e-01}', "");
    Expect(0, 68093, '\P{^Is_Nv=5.8333e-01}', "");
    Expect(1, 68092, '\p{Is_Nv=0.5833}', "");
    Expect(0, 68092, '\p{^Is_Nv=0.5833}', "");
    Expect(0, 68092, '\P{Is_Nv=0.5833}', "");
    Expect(1, 68092, '\P{^Is_Nv=0.5833}', "");
    Expect(0, 68093, '\p{Is_Nv=0.5833}', "");
    Expect(1, 68093, '\p{^Is_Nv=0.5833}', "");
    Expect(1, 68093, '\P{Is_Nv=0.5833}', "");
    Expect(0, 68093, '\P{^Is_Nv=0.5833}', "");
    Expect(1, 68092, '\p{Is_Nv=5.83333e-01}', "");
    Expect(0, 68092, '\p{^Is_Nv=5.83333e-01}', "");
    Expect(0, 68092, '\P{Is_Nv=5.83333e-01}', "");
    Expect(1, 68092, '\P{^Is_Nv=5.83333e-01}', "");
    Expect(0, 68093, '\p{Is_Nv=5.83333e-01}', "");
    Expect(1, 68093, '\p{^Is_Nv=5.83333e-01}', "");
    Expect(1, 68093, '\P{Is_Nv=5.83333e-01}', "");
    Expect(0, 68093, '\P{^Is_Nv=5.83333e-01}', "");
    Expect(1, 68092, '\p{Is_Nv:   0.58333}', "");
    Expect(0, 68092, '\p{^Is_Nv:   0.58333}', "");
    Expect(0, 68092, '\P{Is_Nv:   0.58333}', "");
    Expect(1, 68092, '\P{^Is_Nv:   0.58333}', "");
    Expect(0, 68093, '\p{Is_Nv:   0.58333}', "");
    Expect(1, 68093, '\p{^Is_Nv:   0.58333}', "");
    Expect(1, 68093, '\P{Is_Nv:   0.58333}', "");
    Expect(0, 68093, '\P{^Is_Nv:   0.58333}', "");
    Error('\p{Numeric_Value=- 00007/00002:=}');
    Error('\P{Numeric_Value=- 00007/00002:=}');
    Expect(1, 3885, '\p{Numeric_Value=:\A7/2\z:}', "");;
    Expect(0, 3886, '\p{Numeric_Value=:\A7/2\z:}', "");;
    Expect(1, 3885, '\p{Numeric_Value=+000000007/000002}', "");
    Expect(0, 3885, '\p{^Numeric_Value=+000000007/000002}', "");
    Expect(0, 3885, '\P{Numeric_Value=+000000007/000002}', "");
    Expect(1, 3885, '\P{^Numeric_Value=+000000007/000002}', "");
    Expect(0, 3886, '\p{Numeric_Value=+000000007/000002}', "");
    Expect(1, 3886, '\p{^Numeric_Value=+000000007/000002}', "");
    Expect(1, 3886, '\P{Numeric_Value=+000000007/000002}', "");
    Expect(0, 3886, '\P{^Numeric_Value=+000000007/000002}', "");
    Expect(1, 3885, '\p{Numeric_Value=420/120}', "");
    Expect(0, 3885, '\p{^Numeric_Value=420/120}', "");
    Expect(0, 3885, '\P{Numeric_Value=420/120}', "");
    Expect(1, 3885, '\P{^Numeric_Value=420/120}', "");
    Expect(0, 3886, '\p{Numeric_Value=420/120}', "");
    Expect(1, 3886, '\p{^Numeric_Value=420/120}', "");
    Expect(1, 3886, '\P{Numeric_Value=420/120}', "");
    Expect(0, 3886, '\P{^Numeric_Value=420/120}', "");
    Expect(1, 3885, '\p{Numeric_Value:3.5e+00}', "");
    Expect(0, 3885, '\p{^Numeric_Value:3.5e+00}', "");
    Expect(0, 3885, '\P{Numeric_Value:3.5e+00}', "");
    Expect(1, 3885, '\P{^Numeric_Value:3.5e+00}', "");
    Expect(0, 3886, '\p{Numeric_Value:3.5e+00}', "");
    Expect(1, 3886, '\p{^Numeric_Value:3.5e+00}', "");
    Expect(1, 3886, '\P{Numeric_Value:3.5e+00}', "");
    Expect(0, 3886, '\P{^Numeric_Value:3.5e+00}', "");
    Expect(1, 3885, '\p{Numeric_Value=3.5}', "");
    Expect(0, 3885, '\p{^Numeric_Value=3.5}', "");
    Expect(0, 3885, '\P{Numeric_Value=3.5}', "");
    Expect(1, 3885, '\P{^Numeric_Value=3.5}', "");
    Expect(0, 3886, '\p{Numeric_Value=3.5}', "");
    Expect(1, 3886, '\p{^Numeric_Value=3.5}', "");
    Expect(1, 3886, '\P{Numeric_Value=3.5}', "");
    Expect(0, 3886, '\P{^Numeric_Value=3.5}', "");
    Expect(1, 3885, '\p{Numeric_Value:   3.50e+00}', "");
    Expect(0, 3885, '\p{^Numeric_Value:   3.50e+00}', "");
    Expect(0, 3885, '\P{Numeric_Value:   3.50e+00}', "");
    Expect(1, 3885, '\P{^Numeric_Value:   3.50e+00}', "");
    Expect(0, 3886, '\p{Numeric_Value:   3.50e+00}', "");
    Expect(1, 3886, '\p{^Numeric_Value:   3.50e+00}', "");
    Expect(1, 3886, '\P{Numeric_Value:   3.50e+00}', "");
    Expect(0, 3886, '\P{^Numeric_Value:   3.50e+00}', "");
    Expect(1, 3885, '\p{Numeric_Value=3.50}', "");
    Expect(0, 3885, '\p{^Numeric_Value=3.50}', "");
    Expect(0, 3885, '\P{Numeric_Value=3.50}', "");
    Expect(1, 3885, '\P{^Numeric_Value=3.50}', "");
    Expect(0, 3886, '\p{Numeric_Value=3.50}', "");
    Expect(1, 3886, '\p{^Numeric_Value=3.50}', "");
    Expect(1, 3886, '\P{Numeric_Value=3.50}', "");
    Expect(0, 3886, '\P{^Numeric_Value=3.50}', "");
    Error('\p{Nv=/a/007/0002}');
    Error('\P{Nv=/a/007/0002}');
    Expect(1, 3885, '\p{Nv=:\A7/2\z:}', "");;
    Expect(0, 3886, '\p{Nv=:\A7/2\z:}', "");;
    Expect(1, 3885, '\p{Nv=0000007/00002}', "");
    Expect(0, 3885, '\p{^Nv=0000007/00002}', "");
    Expect(0, 3885, '\P{Nv=0000007/00002}', "");
    Expect(1, 3885, '\P{^Nv=0000007/00002}', "");
    Expect(0, 3886, '\p{Nv=0000007/00002}', "");
    Expect(1, 3886, '\p{^Nv=0000007/00002}', "");
    Expect(1, 3886, '\P{Nv=0000007/00002}', "");
    Expect(0, 3886, '\P{^Nv=0000007/00002}', "");
    Expect(1, 3885, '\p{Nv=420/120}', "");
    Expect(0, 3885, '\p{^Nv=420/120}', "");
    Expect(0, 3885, '\P{Nv=420/120}', "");
    Expect(1, 3885, '\P{^Nv=420/120}', "");
    Expect(0, 3886, '\p{Nv=420/120}', "");
    Expect(1, 3886, '\p{^Nv=420/120}', "");
    Expect(1, 3886, '\P{Nv=420/120}', "");
    Expect(0, 3886, '\P{^Nv=420/120}', "");
    Expect(1, 3885, '\p{Nv=3.5e+00}', "");
    Expect(0, 3885, '\p{^Nv=3.5e+00}', "");
    Expect(0, 3885, '\P{Nv=3.5e+00}', "");
    Expect(1, 3885, '\P{^Nv=3.5e+00}', "");
    Expect(0, 3886, '\p{Nv=3.5e+00}', "");
    Expect(1, 3886, '\p{^Nv=3.5e+00}', "");
    Expect(1, 3886, '\P{Nv=3.5e+00}', "");
    Expect(0, 3886, '\P{^Nv=3.5e+00}', "");
    Expect(1, 3885, '\p{Nv=3.5}', "");
    Expect(0, 3885, '\p{^Nv=3.5}', "");
    Expect(0, 3885, '\P{Nv=3.5}', "");
    Expect(1, 3885, '\P{^Nv=3.5}', "");
    Expect(0, 3886, '\p{Nv=3.5}', "");
    Expect(1, 3886, '\p{^Nv=3.5}', "");
    Expect(1, 3886, '\P{Nv=3.5}', "");
    Expect(0, 3886, '\P{^Nv=3.5}', "");
    Expect(1, 3885, '\p{Nv:	3.50e+00}', "");
    Expect(0, 3885, '\p{^Nv:	3.50e+00}', "");
    Expect(0, 3885, '\P{Nv:	3.50e+00}', "");
    Expect(1, 3885, '\P{^Nv:	3.50e+00}', "");
    Expect(0, 3886, '\p{Nv:	3.50e+00}', "");
    Expect(1, 3886, '\p{^Nv:	3.50e+00}', "");
    Expect(1, 3886, '\P{Nv:	3.50e+00}', "");
    Expect(0, 3886, '\P{^Nv:	3.50e+00}', "");
    Expect(1, 3885, '\p{Nv:	3.50}', "");
    Expect(0, 3885, '\p{^Nv:	3.50}', "");
    Expect(0, 3885, '\P{Nv:	3.50}', "");
    Expect(1, 3885, '\P{^Nv:	3.50}', "");
    Expect(0, 3886, '\p{Nv:	3.50}', "");
    Expect(1, 3886, '\p{^Nv:	3.50}', "");
    Expect(1, 3886, '\P{Nv:	3.50}', "");
    Expect(0, 3886, '\P{^Nv:	3.50}', "");
    Error('\p{Is_Numeric_Value=007/000002:=}');
    Error('\P{Is_Numeric_Value=007/000002:=}');
    Expect(1, 3885, '\p{Is_Numeric_Value=0000000007/000000002}', "");
    Expect(0, 3885, '\p{^Is_Numeric_Value=0000000007/000000002}', "");
    Expect(0, 3885, '\P{Is_Numeric_Value=0000000007/000000002}', "");
    Expect(1, 3885, '\P{^Is_Numeric_Value=0000000007/000000002}', "");
    Expect(0, 3886, '\p{Is_Numeric_Value=0000000007/000000002}', "");
    Expect(1, 3886, '\p{^Is_Numeric_Value=0000000007/000000002}', "");
    Expect(1, 3886, '\P{Is_Numeric_Value=0000000007/000000002}', "");
    Expect(0, 3886, '\P{^Is_Numeric_Value=0000000007/000000002}', "");
    Expect(1, 3885, '\p{Is_Numeric_Value=420/120}', "");
    Expect(0, 3885, '\p{^Is_Numeric_Value=420/120}', "");
    Expect(0, 3885, '\P{Is_Numeric_Value=420/120}', "");
    Expect(1, 3885, '\P{^Is_Numeric_Value=420/120}', "");
    Expect(0, 3886, '\p{Is_Numeric_Value=420/120}', "");
    Expect(1, 3886, '\p{^Is_Numeric_Value=420/120}', "");
    Expect(1, 3886, '\P{Is_Numeric_Value=420/120}', "");
    Expect(0, 3886, '\P{^Is_Numeric_Value=420/120}', "");
    Expect(1, 3885, '\p{Is_Numeric_Value: 3.5e+00}', "");
    Expect(0, 3885, '\p{^Is_Numeric_Value: 3.5e+00}', "");
    Expect(0, 3885, '\P{Is_Numeric_Value: 3.5e+00}', "");
    Expect(1, 3885, '\P{^Is_Numeric_Value: 3.5e+00}', "");
    Expect(0, 3886, '\p{Is_Numeric_Value: 3.5e+00}', "");
    Expect(1, 3886, '\p{^Is_Numeric_Value: 3.5e+00}', "");
    Expect(1, 3886, '\P{Is_Numeric_Value: 3.5e+00}', "");
    Expect(0, 3886, '\P{^Is_Numeric_Value: 3.5e+00}', "");
    Expect(1, 3885, '\p{Is_Numeric_Value=3.5}', "");
    Expect(0, 3885, '\p{^Is_Numeric_Value=3.5}', "");
    Expect(0, 3885, '\P{Is_Numeric_Value=3.5}', "");
    Expect(1, 3885, '\P{^Is_Numeric_Value=3.5}', "");
    Expect(0, 3886, '\p{Is_Numeric_Value=3.5}', "");
    Expect(1, 3886, '\p{^Is_Numeric_Value=3.5}', "");
    Expect(1, 3886, '\P{Is_Numeric_Value=3.5}', "");
    Expect(0, 3886, '\P{^Is_Numeric_Value=3.5}', "");
    Expect(1, 3885, '\p{Is_Numeric_Value=3.50e+00}', "");
    Expect(0, 3885, '\p{^Is_Numeric_Value=3.50e+00}', "");
    Expect(0, 3885, '\P{Is_Numeric_Value=3.50e+00}', "");
    Expect(1, 3885, '\P{^Is_Numeric_Value=3.50e+00}', "");
    Expect(0, 3886, '\p{Is_Numeric_Value=3.50e+00}', "");
    Expect(1, 3886, '\p{^Is_Numeric_Value=3.50e+00}', "");
    Expect(1, 3886, '\P{Is_Numeric_Value=3.50e+00}', "");
    Expect(0, 3886, '\P{^Is_Numeric_Value=3.50e+00}', "");
    Expect(1, 3885, '\p{Is_Numeric_Value=3.50}', "");
    Expect(0, 3885, '\p{^Is_Numeric_Value=3.50}', "");
    Expect(0, 3885, '\P{Is_Numeric_Value=3.50}', "");
    Expect(1, 3885, '\P{^Is_Numeric_Value=3.50}', "");
    Expect(0, 3886, '\p{Is_Numeric_Value=3.50}', "");
    Expect(1, 3886, '\p{^Is_Numeric_Value=3.50}', "");
    Expect(1, 3886, '\P{Is_Numeric_Value=3.50}', "");
    Expect(0, 3886, '\P{^Is_Numeric_Value=3.50}', "");
    Error('\p{Is_Nv:   /a/-0000000007/2}');
    Error('\P{Is_Nv:   /a/-0000000007/2}');
    Expect(1, 3885, '\p{Is_Nv=00000007/000000002}', "");
    Expect(0, 3885, '\p{^Is_Nv=00000007/000000002}', "");
    Expect(0, 3885, '\P{Is_Nv=00000007/000000002}', "");
    Expect(1, 3885, '\P{^Is_Nv=00000007/000000002}', "");
    Expect(0, 3886, '\p{Is_Nv=00000007/000000002}', "");
    Expect(1, 3886, '\p{^Is_Nv=00000007/000000002}', "");
    Expect(1, 3886, '\P{Is_Nv=00000007/000000002}', "");
    Expect(0, 3886, '\P{^Is_Nv=00000007/000000002}', "");
    Expect(1, 3885, '\p{Is_Nv=420/120}', "");
    Expect(0, 3885, '\p{^Is_Nv=420/120}', "");
    Expect(0, 3885, '\P{Is_Nv=420/120}', "");
    Expect(1, 3885, '\P{^Is_Nv=420/120}', "");
    Expect(0, 3886, '\p{Is_Nv=420/120}', "");
    Expect(1, 3886, '\p{^Is_Nv=420/120}', "");
    Expect(1, 3886, '\P{Is_Nv=420/120}', "");
    Expect(0, 3886, '\P{^Is_Nv=420/120}', "");
    Expect(1, 3885, '\p{Is_Nv=3.5e+00}', "");
    Expect(0, 3885, '\p{^Is_Nv=3.5e+00}', "");
    Expect(0, 3885, '\P{Is_Nv=3.5e+00}', "");
    Expect(1, 3885, '\P{^Is_Nv=3.5e+00}', "");
    Expect(0, 3886, '\p{Is_Nv=3.5e+00}', "");
    Expect(1, 3886, '\p{^Is_Nv=3.5e+00}', "");
    Expect(1, 3886, '\P{Is_Nv=3.5e+00}', "");
    Expect(0, 3886, '\P{^Is_Nv=3.5e+00}', "");
    Expect(1, 3885, '\p{Is_Nv=3.5}', "");
    Expect(0, 3885, '\p{^Is_Nv=3.5}', "");
    Expect(0, 3885, '\P{Is_Nv=3.5}', "");
    Expect(1, 3885, '\P{^Is_Nv=3.5}', "");
    Expect(0, 3886, '\p{Is_Nv=3.5}', "");
    Expect(1, 3886, '\p{^Is_Nv=3.5}', "");
    Expect(1, 3886, '\P{Is_Nv=3.5}', "");
    Expect(0, 3886, '\P{^Is_Nv=3.5}', "");
    Expect(1, 3885, '\p{Is_Nv=3.50e+00}', "");
    Expect(0, 3885, '\p{^Is_Nv=3.50e+00}', "");
    Expect(0, 3885, '\P{Is_Nv=3.50e+00}', "");
    Expect(1, 3885, '\P{^Is_Nv=3.50e+00}', "");
    Expect(0, 3886, '\p{Is_Nv=3.50e+00}', "");
    Expect(1, 3886, '\p{^Is_Nv=3.50e+00}', "");
    Expect(1, 3886, '\P{Is_Nv=3.50e+00}', "");
    Expect(0, 3886, '\P{^Is_Nv=3.50e+00}', "");
    Expect(1, 3885, '\p{Is_Nv=3.50}', "");
    Expect(0, 3885, '\p{^Is_Nv=3.50}', "");
    Expect(0, 3885, '\P{Is_Nv=3.50}', "");
    Expect(1, 3885, '\P{^Is_Nv=3.50}', "");
    Expect(0, 3886, '\p{Is_Nv=3.50}', "");
    Expect(1, 3886, '\p{^Is_Nv=3.50}', "");
    Expect(1, 3886, '\P{Is_Nv=3.50}', "");
    Expect(0, 3886, '\P{^Is_Nv=3.50}', "");
    Error('\p{Numeric_Value=:= +0000007/000008}');
    Error('\P{Numeric_Value=:= +0000007/000008}');
    Expect(1, 8542, '\p{Numeric_Value=:\A7/8\z:}', "");;
    Expect(0, 8543, '\p{Numeric_Value=:\A7/8\z:}', "");;
    Expect(1, 8542, '\p{Numeric_Value=000007/0000008}', "");
    Expect(0, 8542, '\p{^Numeric_Value=000007/0000008}', "");
    Expect(0, 8542, '\P{Numeric_Value=000007/0000008}', "");
    Expect(1, 8542, '\P{^Numeric_Value=000007/0000008}', "");
    Expect(0, 8543, '\p{Numeric_Value=000007/0000008}', "");
    Expect(1, 8543, '\p{^Numeric_Value=000007/0000008}', "");
    Expect(1, 8543, '\P{Numeric_Value=000007/0000008}', "");
    Expect(0, 8543, '\P{^Numeric_Value=000007/0000008}', "");
    Expect(1, 8542, '\p{Numeric_Value=420/480}', "");
    Expect(0, 8542, '\p{^Numeric_Value=420/480}', "");
    Expect(0, 8542, '\P{Numeric_Value=420/480}', "");
    Expect(1, 8542, '\P{^Numeric_Value=420/480}', "");
    Expect(0, 8543, '\p{Numeric_Value=420/480}', "");
    Expect(1, 8543, '\p{^Numeric_Value=420/480}', "");
    Expect(1, 8543, '\P{Numeric_Value=420/480}', "");
    Expect(0, 8543, '\P{^Numeric_Value=420/480}', "");
    Error('\p{Numeric_Value=8.8e-01}');
    Error('\P{Numeric_Value=8.8e-01}');
    Error('\p{Numeric_Value=0.9}');
    Error('\P{Numeric_Value=0.9}');
    Expect(1, 8542, '\p{Numeric_Value=8.75e-01}', "");
    Expect(0, 8542, '\p{^Numeric_Value=8.75e-01}', "");
    Expect(0, 8542, '\P{Numeric_Value=8.75e-01}', "");
    Expect(1, 8542, '\P{^Numeric_Value=8.75e-01}', "");
    Expect(0, 8543, '\p{Numeric_Value=8.75e-01}', "");
    Expect(1, 8543, '\p{^Numeric_Value=8.75e-01}', "");
    Expect(1, 8543, '\P{Numeric_Value=8.75e-01}', "");
    Expect(0, 8543, '\P{^Numeric_Value=8.75e-01}', "");
    Error('\p{Numeric_Value=0.88}');
    Error('\P{Numeric_Value=0.88}');
    Expect(1, 8542, '\p{Numeric_Value=8.750e-01}', "");
    Expect(0, 8542, '\p{^Numeric_Value=8.750e-01}', "");
    Expect(0, 8542, '\P{Numeric_Value=8.750e-01}', "");
    Expect(1, 8542, '\P{^Numeric_Value=8.750e-01}', "");
    Expect(0, 8543, '\p{Numeric_Value=8.750e-01}', "");
    Expect(1, 8543, '\p{^Numeric_Value=8.750e-01}', "");
    Expect(1, 8543, '\P{Numeric_Value=8.750e-01}', "");
    Expect(0, 8543, '\P{^Numeric_Value=8.750e-01}', "");
    Expect(1, 8542, '\p{Numeric_Value=0.875}', "");
    Expect(0, 8542, '\p{^Numeric_Value=0.875}', "");
    Expect(0, 8542, '\P{Numeric_Value=0.875}', "");
    Expect(1, 8542, '\P{^Numeric_Value=0.875}', "");
    Expect(0, 8543, '\p{Numeric_Value=0.875}', "");
    Expect(1, 8543, '\p{^Numeric_Value=0.875}', "");
    Expect(1, 8543, '\P{Numeric_Value=0.875}', "");
    Expect(0, 8543, '\P{^Numeric_Value=0.875}', "");
    Expect(1, 8542, '\p{Numeric_Value=8.7500e-01}', "");
    Expect(0, 8542, '\p{^Numeric_Value=8.7500e-01}', "");
    Expect(0, 8542, '\P{Numeric_Value=8.7500e-01}', "");
    Expect(1, 8542, '\P{^Numeric_Value=8.7500e-01}', "");
    Expect(0, 8543, '\p{Numeric_Value=8.7500e-01}', "");
    Expect(1, 8543, '\p{^Numeric_Value=8.7500e-01}', "");
    Expect(1, 8543, '\P{Numeric_Value=8.7500e-01}', "");
    Expect(0, 8543, '\P{^Numeric_Value=8.7500e-01}', "");
    Expect(1, 8542, '\p{Numeric_Value:   0.8750}', "");
    Expect(0, 8542, '\p{^Numeric_Value:   0.8750}', "");
    Expect(0, 8542, '\P{Numeric_Value:   0.8750}', "");
    Expect(1, 8542, '\P{^Numeric_Value:   0.8750}', "");
    Expect(0, 8543, '\p{Numeric_Value:   0.8750}', "");
    Expect(1, 8543, '\p{^Numeric_Value:   0.8750}', "");
    Expect(1, 8543, '\P{Numeric_Value:   0.8750}', "");
    Expect(0, 8543, '\P{^Numeric_Value:   0.8750}', "");
    Error('\p{Nv=	/a/00007/8}');
    Error('\P{Nv=	/a/00007/8}');
    Expect(1, 8542, '\p{Nv=:\A7/8\z:}', "");;
    Expect(0, 8543, '\p{Nv=:\A7/8\z:}', "");;
    Expect(1, 8542, '\p{Nv=00007/0008}', "");
    Expect(0, 8542, '\p{^Nv=00007/0008}', "");
    Expect(0, 8542, '\P{Nv=00007/0008}', "");
    Expect(1, 8542, '\P{^Nv=00007/0008}', "");
    Expect(0, 8543, '\p{Nv=00007/0008}', "");
    Expect(1, 8543, '\p{^Nv=00007/0008}', "");
    Expect(1, 8543, '\P{Nv=00007/0008}', "");
    Expect(0, 8543, '\P{^Nv=00007/0008}', "");
    Expect(1, 8542, '\p{Nv=420/480}', "");
    Expect(0, 8542, '\p{^Nv=420/480}', "");
    Expect(0, 8542, '\P{Nv=420/480}', "");
    Expect(1, 8542, '\P{^Nv=420/480}', "");
    Expect(0, 8543, '\p{Nv=420/480}', "");
    Expect(1, 8543, '\p{^Nv=420/480}', "");
    Expect(1, 8543, '\P{Nv=420/480}', "");
    Expect(0, 8543, '\P{^Nv=420/480}', "");
    Error('\p{Nv:   8.8e-01}');
    Error('\P{Nv:   8.8e-01}');
    Error('\p{Nv=0.9}');
    Error('\P{Nv=0.9}');
    Expect(1, 8542, '\p{Nv=8.75e-01}', "");
    Expect(0, 8542, '\p{^Nv=8.75e-01}', "");
    Expect(0, 8542, '\P{Nv=8.75e-01}', "");
    Expect(1, 8542, '\P{^Nv=8.75e-01}', "");
    Expect(0, 8543, '\p{Nv=8.75e-01}', "");
    Expect(1, 8543, '\p{^Nv=8.75e-01}', "");
    Expect(1, 8543, '\P{Nv=8.75e-01}', "");
    Expect(0, 8543, '\P{^Nv=8.75e-01}', "");
    Error('\p{Nv=0.88}');
    Error('\P{Nv=0.88}');
    Expect(1, 8542, '\p{Nv=8.750e-01}', "");
    Expect(0, 8542, '\p{^Nv=8.750e-01}', "");
    Expect(0, 8542, '\P{Nv=8.750e-01}', "");
    Expect(1, 8542, '\P{^Nv=8.750e-01}', "");
    Expect(0, 8543, '\p{Nv=8.750e-01}', "");
    Expect(1, 8543, '\p{^Nv=8.750e-01}', "");
    Expect(1, 8543, '\P{Nv=8.750e-01}', "");
    Expect(0, 8543, '\P{^Nv=8.750e-01}', "");
    Expect(1, 8542, '\p{Nv=0.875}', "");
    Expect(0, 8542, '\p{^Nv=0.875}', "");
    Expect(0, 8542, '\P{Nv=0.875}', "");
    Expect(1, 8542, '\P{^Nv=0.875}', "");
    Expect(0, 8543, '\p{Nv=0.875}', "");
    Expect(1, 8543, '\p{^Nv=0.875}', "");
    Expect(1, 8543, '\P{Nv=0.875}', "");
    Expect(0, 8543, '\P{^Nv=0.875}', "");
    Expect(1, 8542, '\p{Nv=8.7500e-01}', "");
    Expect(0, 8542, '\p{^Nv=8.7500e-01}', "");
    Expect(0, 8542, '\P{Nv=8.7500e-01}', "");
    Expect(1, 8542, '\P{^Nv=8.7500e-01}', "");
    Expect(0, 8543, '\p{Nv=8.7500e-01}', "");
    Expect(1, 8543, '\p{^Nv=8.7500e-01}', "");
    Expect(1, 8543, '\P{Nv=8.7500e-01}', "");
    Expect(0, 8543, '\P{^Nv=8.7500e-01}', "");
    Expect(1, 8542, '\p{Nv=0.8750}', "");
    Expect(0, 8542, '\p{^Nv=0.8750}', "");
    Expect(0, 8542, '\P{Nv=0.8750}', "");
    Expect(1, 8542, '\P{^Nv=0.8750}', "");
    Expect(0, 8543, '\p{Nv=0.8750}', "");
    Expect(1, 8543, '\p{^Nv=0.8750}', "");
    Expect(1, 8543, '\P{Nv=0.8750}', "");
    Expect(0, 8543, '\P{^Nv=0.8750}', "");
    Error('\p{Is_Numeric_Value=:=	7/0008}');
    Error('\P{Is_Numeric_Value=:=	7/0008}');
    Expect(1, 8542, '\p{Is_Numeric_Value=+0000007/08}', "");
    Expect(0, 8542, '\p{^Is_Numeric_Value=+0000007/08}', "");
    Expect(0, 8542, '\P{Is_Numeric_Value=+0000007/08}', "");
    Expect(1, 8542, '\P{^Is_Numeric_Value=+0000007/08}', "");
    Expect(0, 8543, '\p{Is_Numeric_Value=+0000007/08}', "");
    Expect(1, 8543, '\p{^Is_Numeric_Value=+0000007/08}', "");
    Expect(1, 8543, '\P{Is_Numeric_Value=+0000007/08}', "");
    Expect(0, 8543, '\P{^Is_Numeric_Value=+0000007/08}', "");
    Expect(1, 8542, '\p{Is_Numeric_Value:420/480}', "");
    Expect(0, 8542, '\p{^Is_Numeric_Value:420/480}', "");
    Expect(0, 8542, '\P{Is_Numeric_Value:420/480}', "");
    Expect(1, 8542, '\P{^Is_Numeric_Value:420/480}', "");
    Expect(0, 8543, '\p{Is_Numeric_Value:420/480}', "");
    Expect(1, 8543, '\p{^Is_Numeric_Value:420/480}', "");
    Expect(1, 8543, '\P{Is_Numeric_Value:420/480}', "");
    Expect(0, 8543, '\P{^Is_Numeric_Value:420/480}', "");
    Error('\p{Is_Numeric_Value: 8.8e-01}');
    Error('\P{Is_Numeric_Value: 8.8e-01}');
    Error('\p{Is_Numeric_Value=0.9}');
    Error('\P{Is_Numeric_Value=0.9}');
    Expect(1, 8542, '\p{Is_Numeric_Value=8.75e-01}', "");
    Expect(0, 8542, '\p{^Is_Numeric_Value=8.75e-01}', "");
    Expect(0, 8542, '\P{Is_Numeric_Value=8.75e-01}', "");
    Expect(1, 8542, '\P{^Is_Numeric_Value=8.75e-01}', "");
    Expect(0, 8543, '\p{Is_Numeric_Value=8.75e-01}', "");
    Expect(1, 8543, '\p{^Is_Numeric_Value=8.75e-01}', "");
    Expect(1, 8543, '\P{Is_Numeric_Value=8.75e-01}', "");
    Expect(0, 8543, '\P{^Is_Numeric_Value=8.75e-01}', "");
    Error('\p{Is_Numeric_Value=0.88}');
    Error('\P{Is_Numeric_Value=0.88}');
    Expect(1, 8542, '\p{Is_Numeric_Value=8.750e-01}', "");
    Expect(0, 8542, '\p{^Is_Numeric_Value=8.750e-01}', "");
    Expect(0, 8542, '\P{Is_Numeric_Value=8.750e-01}', "");
    Expect(1, 8542, '\P{^Is_Numeric_Value=8.750e-01}', "");
    Expect(0, 8543, '\p{Is_Numeric_Value=8.750e-01}', "");
    Expect(1, 8543, '\p{^Is_Numeric_Value=8.750e-01}', "");
    Expect(1, 8543, '\P{Is_Numeric_Value=8.750e-01}', "");
    Expect(0, 8543, '\P{^Is_Numeric_Value=8.750e-01}', "");
    Expect(1, 8542, '\p{Is_Numeric_Value=0.875}', "");
    Expect(0, 8542, '\p{^Is_Numeric_Value=0.875}', "");
    Expect(0, 8542, '\P{Is_Numeric_Value=0.875}', "");
    Expect(1, 8542, '\P{^Is_Numeric_Value=0.875}', "");
    Expect(0, 8543, '\p{Is_Numeric_Value=0.875}', "");
    Expect(1, 8543, '\p{^Is_Numeric_Value=0.875}', "");
    Expect(1, 8543, '\P{Is_Numeric_Value=0.875}', "");
    Expect(0, 8543, '\P{^Is_Numeric_Value=0.875}', "");
    Expect(1, 8542, '\p{Is_Numeric_Value=8.7500e-01}', "");
    Expect(0, 8542, '\p{^Is_Numeric_Value=8.7500e-01}', "");
    Expect(0, 8542, '\P{Is_Numeric_Value=8.7500e-01}', "");
    Expect(1, 8542, '\P{^Is_Numeric_Value=8.7500e-01}', "");
    Expect(0, 8543, '\p{Is_Numeric_Value=8.7500e-01}', "");
    Expect(1, 8543, '\p{^Is_Numeric_Value=8.7500e-01}', "");
    Expect(1, 8543, '\P{Is_Numeric_Value=8.7500e-01}', "");
    Expect(0, 8543, '\P{^Is_Numeric_Value=8.7500e-01}', "");
    Expect(1, 8542, '\p{Is_Numeric_Value=0.8750}', "");
    Expect(0, 8542, '\p{^Is_Numeric_Value=0.8750}', "");
    Expect(0, 8542, '\P{Is_Numeric_Value=0.8750}', "");
    Expect(1, 8542, '\P{^Is_Numeric_Value=0.8750}', "");
    Expect(0, 8543, '\p{Is_Numeric_Value=0.8750}', "");
    Expect(1, 8543, '\p{^Is_Numeric_Value=0.8750}', "");
    Expect(1, 8543, '\P{Is_Numeric_Value=0.8750}', "");
    Expect(0, 8543, '\P{^Is_Numeric_Value=0.8750}', "");
    Error('\p{Is_Nv=/a/-_0007/00000008}');
    Error('\P{Is_Nv=/a/-_0007/00000008}');
    Expect(1, 8542, '\p{Is_Nv=0000000007/0000000008}', "");
    Expect(0, 8542, '\p{^Is_Nv=0000000007/0000000008}', "");
    Expect(0, 8542, '\P{Is_Nv=0000000007/0000000008}', "");
    Expect(1, 8542, '\P{^Is_Nv=0000000007/0000000008}', "");
    Expect(0, 8543, '\p{Is_Nv=0000000007/0000000008}', "");
    Expect(1, 8543, '\p{^Is_Nv=0000000007/0000000008}', "");
    Expect(1, 8543, '\P{Is_Nv=0000000007/0000000008}', "");
    Expect(0, 8543, '\P{^Is_Nv=0000000007/0000000008}', "");
    Expect(1, 8542, '\p{Is_Nv=420/480}', "");
    Expect(0, 8542, '\p{^Is_Nv=420/480}', "");
    Expect(0, 8542, '\P{Is_Nv=420/480}', "");
    Expect(1, 8542, '\P{^Is_Nv=420/480}', "");
    Expect(0, 8543, '\p{Is_Nv=420/480}', "");
    Expect(1, 8543, '\p{^Is_Nv=420/480}', "");
    Expect(1, 8543, '\P{Is_Nv=420/480}', "");
    Expect(0, 8543, '\P{^Is_Nv=420/480}', "");
    Error('\p{Is_Nv=8.8e-01}');
    Error('\P{Is_Nv=8.8e-01}');
    Error('\p{Is_Nv=0.9}');
    Error('\P{Is_Nv=0.9}');
    Expect(1, 8542, '\p{Is_Nv=8.75e-01}', "");
    Expect(0, 8542, '\p{^Is_Nv=8.75e-01}', "");
    Expect(0, 8542, '\P{Is_Nv=8.75e-01}', "");
    Expect(1, 8542, '\P{^Is_Nv=8.75e-01}', "");
    Expect(0, 8543, '\p{Is_Nv=8.75e-01}', "");
    Expect(1, 8543, '\p{^Is_Nv=8.75e-01}', "");
    Expect(1, 8543, '\P{Is_Nv=8.75e-01}', "");
    Expect(0, 8543, '\P{^Is_Nv=8.75e-01}', "");
    Error('\p{Is_Nv=0.88}');
    Error('\P{Is_Nv=0.88}');
    Expect(1, 8542, '\p{Is_Nv: 8.750e-01}', "");
    Expect(0, 8542, '\p{^Is_Nv: 8.750e-01}', "");
    Expect(0, 8542, '\P{Is_Nv: 8.750e-01}', "");
    Expect(1, 8542, '\P{^Is_Nv: 8.750e-01}', "");
    Expect(0, 8543, '\p{Is_Nv: 8.750e-01}', "");
    Expect(1, 8543, '\p{^Is_Nv: 8.750e-01}', "");
    Expect(1, 8543, '\P{Is_Nv: 8.750e-01}', "");
    Expect(0, 8543, '\P{^Is_Nv: 8.750e-01}', "");
    Expect(1, 8542, '\p{Is_Nv=0.875}', "");
    Expect(0, 8542, '\p{^Is_Nv=0.875}', "");
    Expect(0, 8542, '\P{Is_Nv=0.875}', "");
    Expect(1, 8542, '\P{^Is_Nv=0.875}', "");
    Expect(0, 8543, '\p{Is_Nv=0.875}', "");
    Expect(1, 8543, '\p{^Is_Nv=0.875}', "");
    Expect(1, 8543, '\P{Is_Nv=0.875}', "");
    Expect(0, 8543, '\P{^Is_Nv=0.875}', "");
    Expect(1, 8542, '\p{Is_Nv=8.7500e-01}', "");
    Expect(0, 8542, '\p{^Is_Nv=8.7500e-01}', "");
    Expect(0, 8542, '\P{Is_Nv=8.7500e-01}', "");
    Expect(1, 8542, '\P{^Is_Nv=8.7500e-01}', "");
    Expect(0, 8543, '\p{Is_Nv=8.7500e-01}', "");
    Expect(1, 8543, '\p{^Is_Nv=8.7500e-01}', "");
    Expect(1, 8543, '\P{Is_Nv=8.7500e-01}', "");
    Expect(0, 8543, '\P{^Is_Nv=8.7500e-01}', "");
    Expect(1, 8542, '\p{Is_Nv=0.8750}', "");
    Expect(0, 8542, '\p{^Is_Nv=0.8750}', "");
    Expect(0, 8542, '\P{Is_Nv=0.8750}', "");
    Expect(1, 8542, '\P{^Is_Nv=0.8750}', "");
    Expect(0, 8543, '\p{Is_Nv=0.8750}', "");
    Expect(1, 8543, '\p{^Is_Nv=0.8750}', "");
    Expect(1, 8543, '\P{Is_Nv=0.8750}', "");
    Expect(0, 8543, '\P{^Is_Nv=0.8750}', "");
    Error('\p{Numeric_Value=/a/7_0}');
    Error('\P{Numeric_Value=/a/7_0}');
    Expect(1, 126224, '\p{Numeric_Value=:\A70\z:}', "");;
    Expect(0, 126225, '\p{Numeric_Value=:\A70\z:}', "");;
    Expect(1, 126224, '\p{Numeric_Value:0000_0007_0}', "");
    Expect(0, 126224, '\p{^Numeric_Value:0000_0007_0}', "");
    Expect(0, 126224, '\P{Numeric_Value:0000_0007_0}', "");
    Expect(1, 126224, '\P{^Numeric_Value:0000_0007_0}', "");
    Expect(0, 126225, '\p{Numeric_Value:0000_0007_0}', "");
    Expect(1, 126225, '\p{^Numeric_Value:0000_0007_0}', "");
    Expect(1, 126225, '\P{Numeric_Value:0000_0007_0}', "");
    Expect(0, 126225, '\P{^Numeric_Value:0000_0007_0}', "");
    Expect(1, 126224, '\p{Numeric_Value=7.000000000000000e+01}', "");
    Expect(0, 126224, '\p{^Numeric_Value=7.000000000000000e+01}', "");
    Expect(0, 126224, '\P{Numeric_Value=7.000000000000000e+01}', "");
    Expect(1, 126224, '\P{^Numeric_Value=7.000000000000000e+01}', "");
    Expect(0, 126225, '\p{Numeric_Value=7.000000000000000e+01}', "");
    Expect(1, 126225, '\p{^Numeric_Value=7.000000000000000e+01}', "");
    Expect(1, 126225, '\P{Numeric_Value=7.000000000000000e+01}', "");
    Expect(0, 126225, '\P{^Numeric_Value=7.000000000000000e+01}', "");
    Error('\p{Nv= :=000000070}');
    Error('\P{Nv= :=000000070}');
    Expect(1, 126224, '\p{Nv=:\A70\z:}', "");;
    Expect(0, 126225, '\p{Nv=:\A70\z:}', "");;
    Expect(1, 126224, '\p{Nv:   +0_0_70}', "");
    Expect(0, 126224, '\p{^Nv:   +0_0_70}', "");
    Expect(0, 126224, '\P{Nv:   +0_0_70}', "");
    Expect(1, 126224, '\P{^Nv:   +0_0_70}', "");
    Expect(0, 126225, '\p{Nv:   +0_0_70}', "");
    Expect(1, 126225, '\p{^Nv:   +0_0_70}', "");
    Expect(1, 126225, '\P{Nv:   +0_0_70}', "");
    Expect(0, 126225, '\P{^Nv:   +0_0_70}', "");
    Expect(1, 126224, '\p{Nv=7.000000000000000e+01}', "");
    Expect(0, 126224, '\p{^Nv=7.000000000000000e+01}', "");
    Expect(0, 126224, '\P{Nv=7.000000000000000e+01}', "");
    Expect(1, 126224, '\P{^Nv=7.000000000000000e+01}', "");
    Expect(0, 126225, '\p{Nv=7.000000000000000e+01}', "");
    Expect(1, 126225, '\p{^Nv=7.000000000000000e+01}', "");
    Expect(1, 126225, '\P{Nv=7.000000000000000e+01}', "");
    Expect(0, 126225, '\P{^Nv=7.000000000000000e+01}', "");
    Error('\p{Is_Numeric_Value= 00000000070/a/}');
    Error('\P{Is_Numeric_Value= 00000000070/a/}');
    Expect(1, 126224, '\p{Is_Numeric_Value:   70}', "");
    Expect(0, 126224, '\p{^Is_Numeric_Value:   70}', "");
    Expect(0, 126224, '\P{Is_Numeric_Value:   70}', "");
    Expect(1, 126224, '\P{^Is_Numeric_Value:   70}', "");
    Expect(0, 126225, '\p{Is_Numeric_Value:   70}', "");
    Expect(1, 126225, '\p{^Is_Numeric_Value:   70}', "");
    Expect(1, 126225, '\P{Is_Numeric_Value:   70}', "");
    Expect(0, 126225, '\P{^Is_Numeric_Value:   70}', "");
    Expect(1, 126224, '\p{Is_Numeric_Value=7.000000000000000e+01}', "");
    Expect(0, 126224, '\p{^Is_Numeric_Value=7.000000000000000e+01}', "");
    Expect(0, 126224, '\P{Is_Numeric_Value=7.000000000000000e+01}', "");
    Expect(1, 126224, '\P{^Is_Numeric_Value=7.000000000000000e+01}', "");
    Expect(0, 126225, '\p{Is_Numeric_Value=7.000000000000000e+01}', "");
    Expect(1, 126225, '\p{^Is_Numeric_Value=7.000000000000000e+01}', "");
    Expect(1, 126225, '\P{Is_Numeric_Value=7.000000000000000e+01}', "");
    Expect(0, 126225, '\P{^Is_Numeric_Value=7.000000000000000e+01}', "");
    Error('\p{Is_Nv=  0070/a/}');
    Error('\P{Is_Nv=  0070/a/}');
    Expect(1, 126224, '\p{Is_Nv=0_0_0_0_0070}', "");
    Expect(0, 126224, '\p{^Is_Nv=0_0_0_0_0070}', "");
    Expect(0, 126224, '\P{Is_Nv=0_0_0_0_0070}', "");
    Expect(1, 126224, '\P{^Is_Nv=0_0_0_0_0070}', "");
    Expect(0, 126225, '\p{Is_Nv=0_0_0_0_0070}', "");
    Expect(1, 126225, '\p{^Is_Nv=0_0_0_0_0070}', "");
    Expect(1, 126225, '\P{Is_Nv=0_0_0_0_0070}', "");
    Expect(0, 126225, '\P{^Is_Nv=0_0_0_0_0070}', "");
    Expect(1, 126224, '\p{Is_Nv:7.000000000000000e+01}', "");
    Expect(0, 126224, '\p{^Is_Nv:7.000000000000000e+01}', "");
    Expect(0, 126224, '\P{Is_Nv:7.000000000000000e+01}', "");
    Expect(1, 126224, '\P{^Is_Nv:7.000000000000000e+01}', "");
    Expect(0, 126225, '\p{Is_Nv:7.000000000000000e+01}', "");
    Expect(1, 126225, '\p{^Is_Nv:7.000000000000000e+01}', "");
    Expect(1, 126225, '\P{Is_Nv:7.000000000000000e+01}', "");
    Expect(0, 126225, '\P{^Is_Nv:7.000000000000000e+01}', "");
    Error('\p{Numeric_Value=/a/  +000000000700}');
    Error('\P{Numeric_Value=/a/  +000000000700}');
    Expect(1, 126233, '\p{Numeric_Value=:\A700\z:}', "");;
    Expect(0, 126234, '\p{Numeric_Value=:\A700\z:}', "");;
    Expect(1, 126233, '\p{Numeric_Value:+00000000700}', "");
    Expect(0, 126233, '\p{^Numeric_Value:+00000000700}', "");
    Expect(0, 126233, '\P{Numeric_Value:+00000000700}', "");
    Expect(1, 126233, '\P{^Numeric_Value:+00000000700}', "");
    Expect(0, 126234, '\p{Numeric_Value:+00000000700}', "");
    Expect(1, 126234, '\p{^Numeric_Value:+00000000700}', "");
    Expect(1, 126234, '\P{Numeric_Value:+00000000700}', "");
    Expect(0, 126234, '\P{^Numeric_Value:+00000000700}', "");
    Expect(1, 126233, '\p{Numeric_Value=7.000000000000000e+02}', "");
    Expect(0, 126233, '\p{^Numeric_Value=7.000000000000000e+02}', "");
    Expect(0, 126233, '\P{Numeric_Value=7.000000000000000e+02}', "");
    Expect(1, 126233, '\P{^Numeric_Value=7.000000000000000e+02}', "");
    Expect(0, 126234, '\p{Numeric_Value=7.000000000000000e+02}', "");
    Expect(1, 126234, '\p{^Numeric_Value=7.000000000000000e+02}', "");
    Expect(1, 126234, '\P{Numeric_Value=7.000000000000000e+02}', "");
    Expect(0, 126234, '\P{^Numeric_Value=7.000000000000000e+02}', "");
    Error('\p{Nv=_-0000700/a/}');
    Error('\P{Nv=_-0000700/a/}');
    Expect(1, 126233, '\p{Nv=:\A700\z:}', "");;
    Expect(0, 126234, '\p{Nv=:\A700\z:}', "");;
    Expect(1, 126233, '\p{Nv=+0700}', "");
    Expect(0, 126233, '\p{^Nv=+0700}', "");
    Expect(0, 126233, '\P{Nv=+0700}', "");
    Expect(1, 126233, '\P{^Nv=+0700}', "");
    Expect(0, 126234, '\p{Nv=+0700}', "");
    Expect(1, 126234, '\p{^Nv=+0700}', "");
    Expect(1, 126234, '\P{Nv=+0700}', "");
    Expect(0, 126234, '\P{^Nv=+0700}', "");
    Expect(1, 126233, '\p{Nv=7.000000000000000e+02}', "");
    Expect(0, 126233, '\p{^Nv=7.000000000000000e+02}', "");
    Expect(0, 126233, '\P{Nv=7.000000000000000e+02}', "");
    Expect(1, 126233, '\P{^Nv=7.000000000000000e+02}', "");
    Expect(0, 126234, '\p{Nv=7.000000000000000e+02}', "");
    Expect(1, 126234, '\p{^Nv=7.000000000000000e+02}', "");
    Expect(1, 126234, '\P{Nv=7.000000000000000e+02}', "");
    Expect(0, 126234, '\P{^Nv=7.000000000000000e+02}', "");
    Error('\p{Is_Numeric_Value=:=	+000700}');
    Error('\P{Is_Numeric_Value=:=	+000700}');
    Expect(1, 126233, '\p{Is_Numeric_Value=0_0_0_0_0_0_0_0_0_7_00}', "");
    Expect(0, 126233, '\p{^Is_Numeric_Value=0_0_0_0_0_0_0_0_0_7_00}', "");
    Expect(0, 126233, '\P{Is_Numeric_Value=0_0_0_0_0_0_0_0_0_7_00}', "");
    Expect(1, 126233, '\P{^Is_Numeric_Value=0_0_0_0_0_0_0_0_0_7_00}', "");
    Expect(0, 126234, '\p{Is_Numeric_Value=0_0_0_0_0_0_0_0_0_7_00}', "");
    Expect(1, 126234, '\p{^Is_Numeric_Value=0_0_0_0_0_0_0_0_0_7_00}', "");
    Expect(1, 126234, '\P{Is_Numeric_Value=0_0_0_0_0_0_0_0_0_7_00}', "");
    Expect(0, 126234, '\P{^Is_Numeric_Value=0_0_0_0_0_0_0_0_0_7_00}', "");
    Expect(1, 126233, '\p{Is_Numeric_Value:	7.000000000000000e+02}', "");
    Expect(0, 126233, '\p{^Is_Numeric_Value:	7.000000000000000e+02}', "");
    Expect(0, 126233, '\P{Is_Numeric_Value:	7.000000000000000e+02}', "");
    Expect(1, 126233, '\P{^Is_Numeric_Value:	7.000000000000000e+02}', "");
    Expect(0, 126234, '\p{Is_Numeric_Value:	7.000000000000000e+02}', "");
    Expect(1, 126234, '\p{^Is_Numeric_Value:	7.000000000000000e+02}', "");
    Expect(1, 126234, '\P{Is_Numeric_Value:	7.000000000000000e+02}', "");
    Expect(0, 126234, '\P{^Is_Numeric_Value:	7.000000000000000e+02}', "");
    Error('\p{Is_Nv=:=	_00000000700}');
    Error('\P{Is_Nv=:=	_00000000700}');
    Expect(1, 126233, '\p{Is_Nv=000700}', "");
    Expect(0, 126233, '\p{^Is_Nv=000700}', "");
    Expect(0, 126233, '\P{Is_Nv=000700}', "");
    Expect(1, 126233, '\P{^Is_Nv=000700}', "");
    Expect(0, 126234, '\p{Is_Nv=000700}', "");
    Expect(1, 126234, '\p{^Is_Nv=000700}', "");
    Expect(1, 126234, '\P{Is_Nv=000700}', "");
    Expect(0, 126234, '\P{^Is_Nv=000700}', "");
    Expect(1, 126233, '\p{Is_Nv:	7.000000000000000e+02}', "");
    Expect(0, 126233, '\p{^Is_Nv:	7.000000000000000e+02}', "");
    Expect(0, 126233, '\P{Is_Nv:	7.000000000000000e+02}', "");
    Expect(1, 126233, '\P{^Is_Nv:	7.000000000000000e+02}', "");
    Expect(0, 126234, '\p{Is_Nv:	7.000000000000000e+02}', "");
    Expect(1, 126234, '\p{^Is_Nv:	7.000000000000000e+02}', "");
    Expect(1, 126234, '\P{Is_Nv:	7.000000000000000e+02}', "");
    Expect(0, 126234, '\P{^Is_Nv:	7.000000000000000e+02}', "");
    Error('\p{Numeric_Value= -+0_0_0_0_0_0_0_0_7000:=}');
    Error('\P{Numeric_Value= -+0_0_0_0_0_0_0_0_7000:=}');
    Expect(1, 126242, '\p{Numeric_Value=:\A7000\z:}', "");;
    Expect(0, 126243, '\p{Numeric_Value=:\A7000\z:}', "");;
    Expect(1, 126242, '\p{Numeric_Value=000_000_700_0}', "");
    Expect(0, 126242, '\p{^Numeric_Value=000_000_700_0}', "");
    Expect(0, 126242, '\P{Numeric_Value=000_000_700_0}', "");
    Expect(1, 126242, '\P{^Numeric_Value=000_000_700_0}', "");
    Expect(0, 126243, '\p{Numeric_Value=000_000_700_0}', "");
    Expect(1, 126243, '\p{^Numeric_Value=000_000_700_0}', "");
    Expect(1, 126243, '\P{Numeric_Value=000_000_700_0}', "");
    Expect(0, 126243, '\P{^Numeric_Value=000_000_700_0}', "");
    Expect(1, 126242, '\p{Numeric_Value=7.000000000000000e+03}', "");
    Expect(0, 126242, '\p{^Numeric_Value=7.000000000000000e+03}', "");
    Expect(0, 126242, '\P{Numeric_Value=7.000000000000000e+03}', "");
    Expect(1, 126242, '\P{^Numeric_Value=7.000000000000000e+03}', "");
    Expect(0, 126243, '\p{Numeric_Value=7.000000000000000e+03}', "");
    Expect(1, 126243, '\p{^Numeric_Value=7.000000000000000e+03}', "");
    Expect(1, 126243, '\P{Numeric_Value=7.000000000000000e+03}', "");
    Expect(0, 126243, '\P{^Numeric_Value=7.000000000000000e+03}', "");
    Error('\p{Nv:	:=_-0_0_0_0_0_0_0_0_7_0_00}');
    Error('\P{Nv:	:=_-0_0_0_0_0_0_0_0_7_0_00}');
    Expect(1, 126242, '\p{Nv=:\A7000\z:}', "");;
    Expect(0, 126243, '\p{Nv=:\A7000\z:}', "");;
    Expect(1, 126242, '\p{Nv=000700_0}', "");
    Expect(0, 126242, '\p{^Nv=000700_0}', "");
    Expect(0, 126242, '\P{Nv=000700_0}', "");
    Expect(1, 126242, '\P{^Nv=000700_0}', "");
    Expect(0, 126243, '\p{Nv=000700_0}', "");
    Expect(1, 126243, '\p{^Nv=000700_0}', "");
    Expect(1, 126243, '\P{Nv=000700_0}', "");
    Expect(0, 126243, '\P{^Nv=000700_0}', "");
    Expect(1, 126242, '\p{Nv=7.000000000000000e+03}', "");
    Expect(0, 126242, '\p{^Nv=7.000000000000000e+03}', "");
    Expect(0, 126242, '\P{Nv=7.000000000000000e+03}', "");
    Expect(1, 126242, '\P{^Nv=7.000000000000000e+03}', "");
    Expect(0, 126243, '\p{Nv=7.000000000000000e+03}', "");
    Expect(1, 126243, '\p{^Nv=7.000000000000000e+03}', "");
    Expect(1, 126243, '\P{Nv=7.000000000000000e+03}', "");
    Expect(0, 126243, '\P{^Nv=7.000000000000000e+03}', "");
    Error('\p{Is_Numeric_Value= :=+000000007000}');
    Error('\P{Is_Numeric_Value= :=+000000007000}');
    Expect(1, 126242, '\p{Is_Numeric_Value=+0_0_0_0_0_0_7000}', "");
    Expect(0, 126242, '\p{^Is_Numeric_Value=+0_0_0_0_0_0_7000}', "");
    Expect(0, 126242, '\P{Is_Numeric_Value=+0_0_0_0_0_0_7000}', "");
    Expect(1, 126242, '\P{^Is_Numeric_Value=+0_0_0_0_0_0_7000}', "");
    Expect(0, 126243, '\p{Is_Numeric_Value=+0_0_0_0_0_0_7000}', "");
    Expect(1, 126243, '\p{^Is_Numeric_Value=+0_0_0_0_0_0_7000}', "");
    Expect(1, 126243, '\P{Is_Numeric_Value=+0_0_0_0_0_0_7000}', "");
    Expect(0, 126243, '\P{^Is_Numeric_Value=+0_0_0_0_0_0_7000}', "");
    Expect(1, 126242, '\p{Is_Numeric_Value:   7.000000000000000e+03}', "");
    Expect(0, 126242, '\p{^Is_Numeric_Value:   7.000000000000000e+03}', "");
    Expect(0, 126242, '\P{Is_Numeric_Value:   7.000000000000000e+03}', "");
    Expect(1, 126242, '\P{^Is_Numeric_Value:   7.000000000000000e+03}', "");
    Expect(0, 126243, '\p{Is_Numeric_Value:   7.000000000000000e+03}', "");
    Expect(1, 126243, '\p{^Is_Numeric_Value:   7.000000000000000e+03}', "");
    Expect(1, 126243, '\P{Is_Numeric_Value:   7.000000000000000e+03}', "");
    Expect(0, 126243, '\P{^Is_Numeric_Value:   7.000000000000000e+03}', "");
    Error('\p{Is_Nv= /a/00_70_00}');
    Error('\P{Is_Nv= /a/00_70_00}');
    Expect(1, 126242, '\p{Is_Nv=+000000007000}', "");
    Expect(0, 126242, '\p{^Is_Nv=+000000007000}', "");
    Expect(0, 126242, '\P{Is_Nv=+000000007000}', "");
    Expect(1, 126242, '\P{^Is_Nv=+000000007000}', "");
    Expect(0, 126243, '\p{Is_Nv=+000000007000}', "");
    Expect(1, 126243, '\p{^Is_Nv=+000000007000}', "");
    Expect(1, 126243, '\P{Is_Nv=+000000007000}', "");
    Expect(0, 126243, '\P{^Is_Nv=+000000007000}', "");
    Expect(1, 126242, '\p{Is_Nv=7.000000000000000e+03}', "");
    Expect(0, 126242, '\p{^Is_Nv=7.000000000000000e+03}', "");
    Expect(0, 126242, '\P{Is_Nv=7.000000000000000e+03}', "");
    Expect(1, 126242, '\P{^Is_Nv=7.000000000000000e+03}', "");
    Expect(0, 126243, '\p{Is_Nv=7.000000000000000e+03}', "");
    Expect(1, 126243, '\p{^Is_Nv=7.000000000000000e+03}', "");
    Expect(1, 126243, '\P{Is_Nv=7.000000000000000e+03}', "");
    Expect(0, 126243, '\P{^Is_Nv=7.000000000000000e+03}', "");
    Error('\p{Numeric_Value=/a/	 +000000007000_0}');
    Error('\P{Numeric_Value=/a/	 +000000007000_0}');
    Expect(1, 126251, '\p{Numeric_Value=:\A70000\z:}', "");;
    Expect(0, 126252, '\p{Numeric_Value=:\A70000\z:}', "");;
    Expect(1, 126251, '\p{Numeric_Value=00_00_70_00_0}', "");
    Expect(0, 126251, '\p{^Numeric_Value=00_00_70_00_0}', "");
    Expect(0, 126251, '\P{Numeric_Value=00_00_70_00_0}', "");
    Expect(1, 126251, '\P{^Numeric_Value=00_00_70_00_0}', "");
    Expect(0, 126252, '\p{Numeric_Value=00_00_70_00_0}', "");
    Expect(1, 126252, '\p{^Numeric_Value=00_00_70_00_0}', "");
    Expect(1, 126252, '\P{Numeric_Value=00_00_70_00_0}', "");
    Expect(0, 126252, '\P{^Numeric_Value=00_00_70_00_0}', "");
    Expect(1, 126251, '\p{Numeric_Value=7.000000000000000e+04}', "");
    Expect(0, 126251, '\p{^Numeric_Value=7.000000000000000e+04}', "");
    Expect(0, 126251, '\P{Numeric_Value=7.000000000000000e+04}', "");
    Expect(1, 126251, '\P{^Numeric_Value=7.000000000000000e+04}', "");
    Expect(0, 126252, '\p{Numeric_Value=7.000000000000000e+04}', "");
    Expect(1, 126252, '\p{^Numeric_Value=7.000000000000000e+04}', "");
    Expect(1, 126252, '\P{Numeric_Value=7.000000000000000e+04}', "");
    Expect(0, 126252, '\P{^Numeric_Value=7.000000000000000e+04}', "");
    Error('\p{Nv=_	0000000070000/a/}');
    Error('\P{Nv=_	0000000070000/a/}');
    Expect(1, 126251, '\p{Nv=:\A70000\z:}', "");;
    Expect(0, 126252, '\p{Nv=:\A70000\z:}', "");;
    Expect(1, 126251, '\p{Nv=+0_0_0_0_7_0000}', "");
    Expect(0, 126251, '\p{^Nv=+0_0_0_0_7_0000}', "");
    Expect(0, 126251, '\P{Nv=+0_0_0_0_7_0000}', "");
    Expect(1, 126251, '\P{^Nv=+0_0_0_0_7_0000}', "");
    Expect(0, 126252, '\p{Nv=+0_0_0_0_7_0000}', "");
    Expect(1, 126252, '\p{^Nv=+0_0_0_0_7_0000}', "");
    Expect(1, 126252, '\P{Nv=+0_0_0_0_7_0000}', "");
    Expect(0, 126252, '\P{^Nv=+0_0_0_0_7_0000}', "");
    Expect(1, 126251, '\p{Nv=7.000000000000000e+04}', "");
    Expect(0, 126251, '\p{^Nv=7.000000000000000e+04}', "");
    Expect(0, 126251, '\P{Nv=7.000000000000000e+04}', "");
    Expect(1, 126251, '\P{^Nv=7.000000000000000e+04}', "");
    Expect(0, 126252, '\p{Nv=7.000000000000000e+04}', "");
    Expect(1, 126252, '\p{^Nv=7.000000000000000e+04}', "");
    Expect(1, 126252, '\P{Nv=7.000000000000000e+04}', "");
    Expect(0, 126252, '\P{^Nv=7.000000000000000e+04}', "");
    Error('\p{Is_Numeric_Value=	-00_70_00_0/a/}');
    Error('\P{Is_Numeric_Value=	-00_70_00_0/a/}');
    Expect(1, 126251, '\p{Is_Numeric_Value:   00000070000}', "");
    Expect(0, 126251, '\p{^Is_Numeric_Value:   00000070000}', "");
    Expect(0, 126251, '\P{Is_Numeric_Value:   00000070000}', "");
    Expect(1, 126251, '\P{^Is_Numeric_Value:   00000070000}', "");
    Expect(0, 126252, '\p{Is_Numeric_Value:   00000070000}', "");
    Expect(1, 126252, '\p{^Is_Numeric_Value:   00000070000}', "");
    Expect(1, 126252, '\P{Is_Numeric_Value:   00000070000}', "");
    Expect(0, 126252, '\P{^Is_Numeric_Value:   00000070000}', "");
    Expect(1, 126251, '\p{Is_Numeric_Value=7.000000000000000e+04}', "");
    Expect(0, 126251, '\p{^Is_Numeric_Value=7.000000000000000e+04}', "");
    Expect(0, 126251, '\P{Is_Numeric_Value=7.000000000000000e+04}', "");
    Expect(1, 126251, '\P{^Is_Numeric_Value=7.000000000000000e+04}', "");
    Expect(0, 126252, '\p{Is_Numeric_Value=7.000000000000000e+04}', "");
    Expect(1, 126252, '\p{^Is_Numeric_Value=7.000000000000000e+04}', "");
    Expect(1, 126252, '\P{Is_Numeric_Value=7.000000000000000e+04}', "");
    Expect(0, 126252, '\P{^Is_Numeric_Value=7.000000000000000e+04}', "");
    Error('\p{Is_Nv=:=_	0_7_0_0_00}');
    Error('\P{Is_Nv=:=_	0_7_0_0_00}');
    Expect(1, 126251, '\p{Is_Nv=+7000_0}', "");
    Expect(0, 126251, '\p{^Is_Nv=+7000_0}', "");
    Expect(0, 126251, '\P{Is_Nv=+7000_0}', "");
    Expect(1, 126251, '\P{^Is_Nv=+7000_0}', "");
    Expect(0, 126252, '\p{Is_Nv=+7000_0}', "");
    Expect(1, 126252, '\p{^Is_Nv=+7000_0}', "");
    Expect(1, 126252, '\P{Is_Nv=+7000_0}', "");
    Expect(0, 126252, '\P{^Is_Nv=+7000_0}', "");
    Expect(1, 126251, '\p{Is_Nv:	7.000000000000000e+04}', "");
    Expect(0, 126251, '\p{^Is_Nv:	7.000000000000000e+04}', "");
    Expect(0, 126251, '\P{Is_Nv:	7.000000000000000e+04}', "");
    Expect(1, 126251, '\P{^Is_Nv:	7.000000000000000e+04}', "");
    Expect(0, 126252, '\p{Is_Nv:	7.000000000000000e+04}', "");
    Expect(1, 126252, '\p{^Is_Nv:	7.000000000000000e+04}', "");
    Expect(1, 126252, '\P{Is_Nv:	7.000000000000000e+04}', "");
    Expect(0, 126252, '\P{^Is_Nv:	7.000000000000000e+04}', "");
    Error('\p{Numeric_Value=/a/	700000}');
    Error('\P{Numeric_Value=/a/	700000}');
    Expect(1, 68083, '\p{Numeric_Value=:\A700000\z:}', "");;
    Expect(0, 68084, '\p{Numeric_Value=:\A700000\z:}', "");;
    Expect(1, 68083, '\p{Numeric_Value=+0_0_0_0_0_0_700000}', "");
    Expect(0, 68083, '\p{^Numeric_Value=+0_0_0_0_0_0_700000}', "");
    Expect(0, 68083, '\P{Numeric_Value=+0_0_0_0_0_0_700000}', "");
    Expect(1, 68083, '\P{^Numeric_Value=+0_0_0_0_0_0_700000}', "");
    Expect(0, 68084, '\p{Numeric_Value=+0_0_0_0_0_0_700000}', "");
    Expect(1, 68084, '\p{^Numeric_Value=+0_0_0_0_0_0_700000}', "");
    Expect(1, 68084, '\P{Numeric_Value=+0_0_0_0_0_0_700000}', "");
    Expect(0, 68084, '\P{^Numeric_Value=+0_0_0_0_0_0_700000}', "");
    Expect(1, 68083, '\p{Numeric_Value=7.000000000000000e+05}', "");
    Expect(0, 68083, '\p{^Numeric_Value=7.000000000000000e+05}', "");
    Expect(0, 68083, '\P{Numeric_Value=7.000000000000000e+05}', "");
    Expect(1, 68083, '\P{^Numeric_Value=7.000000000000000e+05}', "");
    Expect(0, 68084, '\p{Numeric_Value=7.000000000000000e+05}', "");
    Expect(1, 68084, '\p{^Numeric_Value=7.000000000000000e+05}', "");
    Expect(1, 68084, '\P{Numeric_Value=7.000000000000000e+05}', "");
    Expect(0, 68084, '\P{^Numeric_Value=7.000000000000000e+05}', "");
    Error('\p{Nv=  700000/a/}');
    Error('\P{Nv=  700000/a/}');
    Expect(1, 68083, '\p{Nv=:\A700000\z:}', "");;
    Expect(0, 68084, '\p{Nv=:\A700000\z:}', "");;
    Expect(1, 68083, '\p{Nv=000_007_000_00}', "");
    Expect(0, 68083, '\p{^Nv=000_007_000_00}', "");
    Expect(0, 68083, '\P{Nv=000_007_000_00}', "");
    Expect(1, 68083, '\P{^Nv=000_007_000_00}', "");
    Expect(0, 68084, '\p{Nv=000_007_000_00}', "");
    Expect(1, 68084, '\p{^Nv=000_007_000_00}', "");
    Expect(1, 68084, '\P{Nv=000_007_000_00}', "");
    Expect(0, 68084, '\P{^Nv=000_007_000_00}', "");
    Expect(1, 68083, '\p{Nv=7.000000000000000e+05}', "");
    Expect(0, 68083, '\p{^Nv=7.000000000000000e+05}', "");
    Expect(0, 68083, '\P{Nv=7.000000000000000e+05}', "");
    Expect(1, 68083, '\P{^Nv=7.000000000000000e+05}', "");
    Expect(0, 68084, '\p{Nv=7.000000000000000e+05}', "");
    Expect(1, 68084, '\p{^Nv=7.000000000000000e+05}', "");
    Expect(1, 68084, '\P{Nv=7.000000000000000e+05}', "");
    Expect(0, 68084, '\P{^Nv=7.000000000000000e+05}', "");
    Error('\p{Is_Numeric_Value=		+0700000/a/}');
    Error('\P{Is_Numeric_Value=		+0700000/a/}');
    Expect(1, 68083, '\p{Is_Numeric_Value=000700000}', "");
    Expect(0, 68083, '\p{^Is_Numeric_Value=000700000}', "");
    Expect(0, 68083, '\P{Is_Numeric_Value=000700000}', "");
    Expect(1, 68083, '\P{^Is_Numeric_Value=000700000}', "");
    Expect(0, 68084, '\p{Is_Numeric_Value=000700000}', "");
    Expect(1, 68084, '\p{^Is_Numeric_Value=000700000}', "");
    Expect(1, 68084, '\P{Is_Numeric_Value=000700000}', "");
    Expect(0, 68084, '\P{^Is_Numeric_Value=000700000}', "");
    Expect(1, 68083, '\p{Is_Numeric_Value=7.000000000000000e+05}', "");
    Expect(0, 68083, '\p{^Is_Numeric_Value=7.000000000000000e+05}', "");
    Expect(0, 68083, '\P{Is_Numeric_Value=7.000000000000000e+05}', "");
    Expect(1, 68083, '\P{^Is_Numeric_Value=7.000000000000000e+05}', "");
    Expect(0, 68084, '\p{Is_Numeric_Value=7.000000000000000e+05}', "");
    Expect(1, 68084, '\p{^Is_Numeric_Value=7.000000000000000e+05}', "");
    Expect(1, 68084, '\P{Is_Numeric_Value=7.000000000000000e+05}', "");
    Expect(0, 68084, '\P{^Is_Numeric_Value=7.000000000000000e+05}', "");
    Error('\p{Is_Nv=	00700000:=}');
    Error('\P{Is_Nv=	00700000:=}');
    Expect(1, 68083, '\p{Is_Nv=0_0_7_0_0_0_00}', "");
    Expect(0, 68083, '\p{^Is_Nv=0_0_7_0_0_0_00}', "");
    Expect(0, 68083, '\P{Is_Nv=0_0_7_0_0_0_00}', "");
    Expect(1, 68083, '\P{^Is_Nv=0_0_7_0_0_0_00}', "");
    Expect(0, 68084, '\p{Is_Nv=0_0_7_0_0_0_00}', "");
    Expect(1, 68084, '\p{^Is_Nv=0_0_7_0_0_0_00}', "");
    Expect(1, 68084, '\P{Is_Nv=0_0_7_0_0_0_00}', "");
    Expect(0, 68084, '\P{^Is_Nv=0_0_7_0_0_0_00}', "");
    Expect(1, 68083, '\p{Is_Nv:   7.000000000000000e+05}', "");
    Expect(0, 68083, '\p{^Is_Nv:   7.000000000000000e+05}', "");
    Expect(0, 68083, '\P{Is_Nv:   7.000000000000000e+05}', "");
    Expect(1, 68083, '\P{^Is_Nv:   7.000000000000000e+05}', "");
    Expect(0, 68084, '\p{Is_Nv:   7.000000000000000e+05}', "");
    Expect(1, 68084, '\p{^Is_Nv:   7.000000000000000e+05}', "");
    Expect(1, 68084, '\P{Is_Nv:   7.000000000000000e+05}', "");
    Expect(0, 68084, '\P{^Is_Nv:   7.000000000000000e+05}', "");
    Error('\p{Numeric_Value=/a/00_00_00_00_08}');
    Error('\P{Numeric_Value=/a/00_00_00_00_08}');
    Expect(1, 130040, '\p{Numeric_Value=:\A8\z:}', "");;
    Expect(0, 130041, '\p{Numeric_Value=:\A8\z:}', "");;
    Expect(1, 130040, '\p{Numeric_Value=0008}', "");
    Expect(0, 130040, '\p{^Numeric_Value=0008}', "");
    Expect(0, 130040, '\P{Numeric_Value=0008}', "");
    Expect(1, 130040, '\P{^Numeric_Value=0008}', "");
    Expect(0, 130041, '\p{Numeric_Value=0008}', "");
    Expect(1, 130041, '\p{^Numeric_Value=0008}', "");
    Expect(1, 130041, '\P{Numeric_Value=0008}', "");
    Expect(0, 130041, '\P{^Numeric_Value=0008}', "");
    Expect(1, 130040, '\p{Numeric_Value=8.000000000000000e+00}', "");
    Expect(0, 130040, '\p{^Numeric_Value=8.000000000000000e+00}', "");
    Expect(0, 130040, '\P{Numeric_Value=8.000000000000000e+00}', "");
    Expect(1, 130040, '\P{^Numeric_Value=8.000000000000000e+00}', "");
    Expect(0, 130041, '\p{Numeric_Value=8.000000000000000e+00}', "");
    Expect(1, 130041, '\p{^Numeric_Value=8.000000000000000e+00}', "");
    Expect(1, 130041, '\P{Numeric_Value=8.000000000000000e+00}', "");
    Expect(0, 130041, '\P{^Numeric_Value=8.000000000000000e+00}', "");
    Error('\p{Nv=/a/  0_0_0_008}');
    Error('\P{Nv=/a/  0_0_0_008}');
    Expect(1, 130040, '\p{Nv=:\A8\z:}', "");;
    Expect(0, 130041, '\p{Nv=:\A8\z:}', "");;
    Expect(1, 130040, '\p{Nv=+00000008}', "");
    Expect(0, 130040, '\p{^Nv=+00000008}', "");
    Expect(0, 130040, '\P{Nv=+00000008}', "");
    Expect(1, 130040, '\P{^Nv=+00000008}', "");
    Expect(0, 130041, '\p{Nv=+00000008}', "");
    Expect(1, 130041, '\p{^Nv=+00000008}', "");
    Expect(1, 130041, '\P{Nv=+00000008}', "");
    Expect(0, 130041, '\P{^Nv=+00000008}', "");
    Expect(1, 130040, '\p{Nv=8.000000000000000e+00}', "");
    Expect(0, 130040, '\p{^Nv=8.000000000000000e+00}', "");
    Expect(0, 130040, '\P{Nv=8.000000000000000e+00}', "");
    Expect(1, 130040, '\P{^Nv=8.000000000000000e+00}', "");
    Expect(0, 130041, '\p{Nv=8.000000000000000e+00}', "");
    Expect(1, 130041, '\p{^Nv=8.000000000000000e+00}', "");
    Expect(1, 130041, '\P{Nv=8.000000000000000e+00}', "");
    Expect(0, 130041, '\P{^Nv=8.000000000000000e+00}', "");
    Error('\p{Is_Numeric_Value=/a/		+0_0_0_0_008}');
    Error('\P{Is_Numeric_Value=/a/		+0_0_0_0_008}');
    Expect(1, 130040, '\p{Is_Numeric_Value: +000_000_000_8}', "");
    Expect(0, 130040, '\p{^Is_Numeric_Value: +000_000_000_8}', "");
    Expect(0, 130040, '\P{Is_Numeric_Value: +000_000_000_8}', "");
    Expect(1, 130040, '\P{^Is_Numeric_Value: +000_000_000_8}', "");
    Expect(0, 130041, '\p{Is_Numeric_Value: +000_000_000_8}', "");
    Expect(1, 130041, '\p{^Is_Numeric_Value: +000_000_000_8}', "");
    Expect(1, 130041, '\P{Is_Numeric_Value: +000_000_000_8}', "");
    Expect(0, 130041, '\P{^Is_Numeric_Value: +000_000_000_8}', "");
    Expect(1, 130040, '\p{Is_Numeric_Value=8.000000000000000e+00}', "");
    Expect(0, 130040, '\p{^Is_Numeric_Value=8.000000000000000e+00}', "");
    Expect(0, 130040, '\P{Is_Numeric_Value=8.000000000000000e+00}', "");
    Expect(1, 130040, '\P{^Is_Numeric_Value=8.000000000000000e+00}', "");
    Expect(0, 130041, '\p{Is_Numeric_Value=8.000000000000000e+00}', "");
    Expect(1, 130041, '\p{^Is_Numeric_Value=8.000000000000000e+00}', "");
    Expect(1, 130041, '\P{Is_Numeric_Value=8.000000000000000e+00}', "");
    Expect(0, 130041, '\P{^Is_Numeric_Value=8.000000000000000e+00}', "");
    Error('\p{Is_Nv=_-0_8:=}');
    Error('\P{Is_Nv=_-0_8:=}');
    Expect(1, 130040, '\p{Is_Nv=+00_00_08}', "");
    Expect(0, 130040, '\p{^Is_Nv=+00_00_08}', "");
    Expect(0, 130040, '\P{Is_Nv=+00_00_08}', "");
    Expect(1, 130040, '\P{^Is_Nv=+00_00_08}', "");
    Expect(0, 130041, '\p{Is_Nv=+00_00_08}', "");
    Expect(1, 130041, '\p{^Is_Nv=+00_00_08}', "");
    Expect(1, 130041, '\P{Is_Nv=+00_00_08}', "");
    Expect(0, 130041, '\P{^Is_Nv=+00_00_08}', "");
    Expect(1, 130040, '\p{Is_Nv=8.000000000000000e+00}', "");
    Expect(0, 130040, '\p{^Is_Nv=8.000000000000000e+00}', "");
    Expect(0, 130040, '\P{Is_Nv=8.000000000000000e+00}', "");
    Expect(1, 130040, '\P{^Is_Nv=8.000000000000000e+00}', "");
    Expect(0, 130041, '\p{Is_Nv=8.000000000000000e+00}', "");
    Expect(1, 130041, '\p{^Is_Nv=8.000000000000000e+00}', "");
    Expect(1, 130041, '\P{Is_Nv=8.000000000000000e+00}', "");
    Expect(0, 130041, '\P{^Is_Nv=8.000000000000000e+00}', "");
    Error('\p{Numeric_Value=-_+00000000080:=}');
    Error('\P{Numeric_Value=-_+00000000080:=}');
    Expect(1, 126225, '\p{Numeric_Value=:\A80\z:}', "");;
    Expect(0, 126226, '\p{Numeric_Value=:\A80\z:}', "");;
    Expect(1, 126225, '\p{Numeric_Value=+00080}', "");
    Expect(0, 126225, '\p{^Numeric_Value=+00080}', "");
    Expect(0, 126225, '\P{Numeric_Value=+00080}', "");
    Expect(1, 126225, '\P{^Numeric_Value=+00080}', "");
    Expect(0, 126226, '\p{Numeric_Value=+00080}', "");
    Expect(1, 126226, '\p{^Numeric_Value=+00080}', "");
    Expect(1, 126226, '\P{Numeric_Value=+00080}', "");
    Expect(0, 126226, '\P{^Numeric_Value=+00080}', "");
    Expect(1, 126225, '\p{Numeric_Value=8.000000000000000e+01}', "");
    Expect(0, 126225, '\p{^Numeric_Value=8.000000000000000e+01}', "");
    Expect(0, 126225, '\P{Numeric_Value=8.000000000000000e+01}', "");
    Expect(1, 126225, '\P{^Numeric_Value=8.000000000000000e+01}', "");
    Expect(0, 126226, '\p{Numeric_Value=8.000000000000000e+01}', "");
    Expect(1, 126226, '\p{^Numeric_Value=8.000000000000000e+01}', "");
    Expect(1, 126226, '\P{Numeric_Value=8.000000000000000e+01}', "");
    Expect(0, 126226, '\P{^Numeric_Value=8.000000000000000e+01}', "");
    Error('\p{Nv=_-0_0_0_0_0_0_0_0080:=}');
    Error('\P{Nv=_-0_0_0_0_0_0_0_0080:=}');
    Expect(1, 126225, '\p{Nv=:\A80\z:}', "");;
    Expect(0, 126226, '\p{Nv=:\A80\z:}', "");;
    Expect(1, 126225, '\p{Nv=0000000080}', "");
    Expect(0, 126225, '\p{^Nv=0000000080}', "");
    Expect(0, 126225, '\P{Nv=0000000080}', "");
    Expect(1, 126225, '\P{^Nv=0000000080}', "");
    Expect(0, 126226, '\p{Nv=0000000080}', "");
    Expect(1, 126226, '\p{^Nv=0000000080}', "");
    Expect(1, 126226, '\P{Nv=0000000080}', "");
    Expect(0, 126226, '\P{^Nv=0000000080}', "");
    Expect(1, 126225, '\p{Nv=8.000000000000000e+01}', "");
    Expect(0, 126225, '\p{^Nv=8.000000000000000e+01}', "");
    Expect(0, 126225, '\P{Nv=8.000000000000000e+01}', "");
    Expect(1, 126225, '\P{^Nv=8.000000000000000e+01}', "");
    Expect(0, 126226, '\p{Nv=8.000000000000000e+01}', "");
    Expect(1, 126226, '\p{^Nv=8.000000000000000e+01}', "");
    Expect(1, 126226, '\P{Nv=8.000000000000000e+01}', "");
    Expect(0, 126226, '\P{^Nv=8.000000000000000e+01}', "");
    Error('\p{Is_Numeric_Value=_	080:=}');
    Error('\P{Is_Numeric_Value=_	080:=}');
    Expect(1, 126225, '\p{Is_Numeric_Value=000080}', "");
    Expect(0, 126225, '\p{^Is_Numeric_Value=000080}', "");
    Expect(0, 126225, '\P{Is_Numeric_Value=000080}', "");
    Expect(1, 126225, '\P{^Is_Numeric_Value=000080}', "");
    Expect(0, 126226, '\p{Is_Numeric_Value=000080}', "");
    Expect(1, 126226, '\p{^Is_Numeric_Value=000080}', "");
    Expect(1, 126226, '\P{Is_Numeric_Value=000080}', "");
    Expect(0, 126226, '\P{^Is_Numeric_Value=000080}', "");
    Expect(1, 126225, '\p{Is_Numeric_Value=8.000000000000000e+01}', "");
    Expect(0, 126225, '\p{^Is_Numeric_Value=8.000000000000000e+01}', "");
    Expect(0, 126225, '\P{Is_Numeric_Value=8.000000000000000e+01}', "");
    Expect(1, 126225, '\P{^Is_Numeric_Value=8.000000000000000e+01}', "");
    Expect(0, 126226, '\p{Is_Numeric_Value=8.000000000000000e+01}', "");
    Expect(1, 126226, '\p{^Is_Numeric_Value=8.000000000000000e+01}', "");
    Expect(1, 126226, '\P{Is_Numeric_Value=8.000000000000000e+01}', "");
    Expect(0, 126226, '\P{^Is_Numeric_Value=8.000000000000000e+01}', "");
    Error('\p{Is_Nv:-	00080/a/}');
    Error('\P{Is_Nv:-	00080/a/}');
    Expect(1, 126225, '\p{Is_Nv=+00_00_80}', "");
    Expect(0, 126225, '\p{^Is_Nv=+00_00_80}', "");
    Expect(0, 126225, '\P{Is_Nv=+00_00_80}', "");
    Expect(1, 126225, '\P{^Is_Nv=+00_00_80}', "");
    Expect(0, 126226, '\p{Is_Nv=+00_00_80}', "");
    Expect(1, 126226, '\p{^Is_Nv=+00_00_80}', "");
    Expect(1, 126226, '\P{Is_Nv=+00_00_80}', "");
    Expect(0, 126226, '\P{^Is_Nv=+00_00_80}', "");
    Expect(1, 126225, '\p{Is_Nv=8.000000000000000e+01}', "");
    Expect(0, 126225, '\p{^Is_Nv=8.000000000000000e+01}', "");
    Expect(0, 126225, '\P{Is_Nv=8.000000000000000e+01}', "");
    Expect(1, 126225, '\P{^Is_Nv=8.000000000000000e+01}', "");
    Expect(0, 126226, '\p{Is_Nv=8.000000000000000e+01}', "");
    Expect(1, 126226, '\p{^Is_Nv=8.000000000000000e+01}', "");
    Expect(1, 126226, '\P{Is_Nv=8.000000000000000e+01}', "");
    Expect(0, 126226, '\P{^Is_Nv=8.000000000000000e+01}', "");
    Error('\p{Numeric_Value= -0800:=}');
    Error('\P{Numeric_Value= -0800:=}');
    Expect(1, 126234, '\p{Numeric_Value=:\A800\z:}', "");;
    Expect(0, 126235, '\p{Numeric_Value=:\A800\z:}', "");;
    Expect(1, 126234, '\p{Numeric_Value=00_00_00_00_80_0}', "");
    Expect(0, 126234, '\p{^Numeric_Value=00_00_00_00_80_0}', "");
    Expect(0, 126234, '\P{Numeric_Value=00_00_00_00_80_0}', "");
    Expect(1, 126234, '\P{^Numeric_Value=00_00_00_00_80_0}', "");
    Expect(0, 126235, '\p{Numeric_Value=00_00_00_00_80_0}', "");
    Expect(1, 126235, '\p{^Numeric_Value=00_00_00_00_80_0}', "");
    Expect(1, 126235, '\P{Numeric_Value=00_00_00_00_80_0}', "");
    Expect(0, 126235, '\P{^Numeric_Value=00_00_00_00_80_0}', "");
    Expect(1, 126234, '\p{Numeric_Value=8.000000000000000e+02}', "");
    Expect(0, 126234, '\p{^Numeric_Value=8.000000000000000e+02}', "");
    Expect(0, 126234, '\P{Numeric_Value=8.000000000000000e+02}', "");
    Expect(1, 126234, '\P{^Numeric_Value=8.000000000000000e+02}', "");
    Expect(0, 126235, '\p{Numeric_Value=8.000000000000000e+02}', "");
    Expect(1, 126235, '\p{^Numeric_Value=8.000000000000000e+02}', "");
    Expect(1, 126235, '\P{Numeric_Value=8.000000000000000e+02}', "");
    Expect(0, 126235, '\P{^Numeric_Value=8.000000000000000e+02}', "");
    Error('\p{Nv=:=- 00000000800}');
    Error('\P{Nv=:=- 00000000800}');
    Expect(1, 126234, '\p{Nv=:\A800\z:}', "");;
    Expect(0, 126235, '\p{Nv=:\A800\z:}', "");;
    Expect(1, 126234, '\p{Nv=+00800}', "");
    Expect(0, 126234, '\p{^Nv=+00800}', "");
    Expect(0, 126234, '\P{Nv=+00800}', "");
    Expect(1, 126234, '\P{^Nv=+00800}', "");
    Expect(0, 126235, '\p{Nv=+00800}', "");
    Expect(1, 126235, '\p{^Nv=+00800}', "");
    Expect(1, 126235, '\P{Nv=+00800}', "");
    Expect(0, 126235, '\P{^Nv=+00800}', "");
    Expect(1, 126234, '\p{Nv=8.000000000000000e+02}', "");
    Expect(0, 126234, '\p{^Nv=8.000000000000000e+02}', "");
    Expect(0, 126234, '\P{Nv=8.000000000000000e+02}', "");
    Expect(1, 126234, '\P{^Nv=8.000000000000000e+02}', "");
    Expect(0, 126235, '\p{Nv=8.000000000000000e+02}', "");
    Expect(1, 126235, '\p{^Nv=8.000000000000000e+02}', "");
    Expect(1, 126235, '\P{Nv=8.000000000000000e+02}', "");
    Expect(0, 126235, '\P{^Nv=8.000000000000000e+02}', "");
    Error('\p{Is_Numeric_Value=/a/__+000000800}');
    Error('\P{Is_Numeric_Value=/a/__+000000800}');
    Expect(1, 126234, '\p{Is_Numeric_Value=+0_0_8_00}', "");
    Expect(0, 126234, '\p{^Is_Numeric_Value=+0_0_8_00}', "");
    Expect(0, 126234, '\P{Is_Numeric_Value=+0_0_8_00}', "");
    Expect(1, 126234, '\P{^Is_Numeric_Value=+0_0_8_00}', "");
    Expect(0, 126235, '\p{Is_Numeric_Value=+0_0_8_00}', "");
    Expect(1, 126235, '\p{^Is_Numeric_Value=+0_0_8_00}', "");
    Expect(1, 126235, '\P{Is_Numeric_Value=+0_0_8_00}', "");
    Expect(0, 126235, '\P{^Is_Numeric_Value=+0_0_8_00}', "");
    Expect(1, 126234, '\p{Is_Numeric_Value:8.000000000000000e+02}', "");
    Expect(0, 126234, '\p{^Is_Numeric_Value:8.000000000000000e+02}', "");
    Expect(0, 126234, '\P{Is_Numeric_Value:8.000000000000000e+02}', "");
    Expect(1, 126234, '\P{^Is_Numeric_Value:8.000000000000000e+02}', "");
    Expect(0, 126235, '\p{Is_Numeric_Value:8.000000000000000e+02}', "");
    Expect(1, 126235, '\p{^Is_Numeric_Value:8.000000000000000e+02}', "");
    Expect(1, 126235, '\P{Is_Numeric_Value:8.000000000000000e+02}', "");
    Expect(0, 126235, '\P{^Is_Numeric_Value:8.000000000000000e+02}', "");
    Error('\p{Is_Nv=_	000_080_0:=}');
    Error('\P{Is_Nv=_	000_080_0:=}');
    Expect(1, 126234, '\p{Is_Nv=0_0_0_0_0_0_0_0_800}', "");
    Expect(0, 126234, '\p{^Is_Nv=0_0_0_0_0_0_0_0_800}', "");
    Expect(0, 126234, '\P{Is_Nv=0_0_0_0_0_0_0_0_800}', "");
    Expect(1, 126234, '\P{^Is_Nv=0_0_0_0_0_0_0_0_800}', "");
    Expect(0, 126235, '\p{Is_Nv=0_0_0_0_0_0_0_0_800}', "");
    Expect(1, 126235, '\p{^Is_Nv=0_0_0_0_0_0_0_0_800}', "");
    Expect(1, 126235, '\P{Is_Nv=0_0_0_0_0_0_0_0_800}', "");
    Expect(0, 126235, '\P{^Is_Nv=0_0_0_0_0_0_0_0_800}', "");
    Expect(1, 126234, '\p{Is_Nv=8.000000000000000e+02}', "");
    Expect(0, 126234, '\p{^Is_Nv=8.000000000000000e+02}', "");
    Expect(0, 126234, '\P{Is_Nv=8.000000000000000e+02}', "");
    Expect(1, 126234, '\P{^Is_Nv=8.000000000000000e+02}', "");
    Expect(0, 126235, '\p{Is_Nv=8.000000000000000e+02}', "");
    Expect(1, 126235, '\p{^Is_Nv=8.000000000000000e+02}', "");
    Expect(1, 126235, '\P{Is_Nv=8.000000000000000e+02}', "");
    Expect(0, 126235, '\P{^Is_Nv=8.000000000000000e+02}', "");
    Error('\p{Numeric_Value=-0008000:=}');
    Error('\P{Numeric_Value=-0008000:=}');
    Expect(1, 126243, '\p{Numeric_Value=:\A8000\z:}', "");;
    Expect(0, 126244, '\p{Numeric_Value=:\A8000\z:}', "");;
    Expect(1, 126243, '\p{Numeric_Value=00000000800_0}', "");
    Expect(0, 126243, '\p{^Numeric_Value=00000000800_0}', "");
    Expect(0, 126243, '\P{Numeric_Value=00000000800_0}', "");
    Expect(1, 126243, '\P{^Numeric_Value=00000000800_0}', "");
    Expect(0, 126244, '\p{Numeric_Value=00000000800_0}', "");
    Expect(1, 126244, '\p{^Numeric_Value=00000000800_0}', "");
    Expect(1, 126244, '\P{Numeric_Value=00000000800_0}', "");
    Expect(0, 126244, '\P{^Numeric_Value=00000000800_0}', "");
    Expect(1, 126243, '\p{Numeric_Value=8.000000000000000e+03}', "");
    Expect(0, 126243, '\p{^Numeric_Value=8.000000000000000e+03}', "");
    Expect(0, 126243, '\P{Numeric_Value=8.000000000000000e+03}', "");
    Expect(1, 126243, '\P{^Numeric_Value=8.000000000000000e+03}', "");
    Expect(0, 126244, '\p{Numeric_Value=8.000000000000000e+03}', "");
    Expect(1, 126244, '\p{^Numeric_Value=8.000000000000000e+03}', "");
    Expect(1, 126244, '\P{Numeric_Value=8.000000000000000e+03}', "");
    Expect(0, 126244, '\P{^Numeric_Value=8.000000000000000e+03}', "");
    Error('\p{Nv=	-+000008000/a/}');
    Error('\P{Nv=	-+000008000/a/}');
    Expect(1, 126243, '\p{Nv=:\A8000\z:}', "");;
    Expect(0, 126244, '\p{Nv=:\A8000\z:}', "");;
    Expect(1, 126243, '\p{Nv=00_00_00_08_000}', "");
    Expect(0, 126243, '\p{^Nv=00_00_00_08_000}', "");
    Expect(0, 126243, '\P{Nv=00_00_00_08_000}', "");
    Expect(1, 126243, '\P{^Nv=00_00_00_08_000}', "");
    Expect(0, 126244, '\p{Nv=00_00_00_08_000}', "");
    Expect(1, 126244, '\p{^Nv=00_00_00_08_000}', "");
    Expect(1, 126244, '\P{Nv=00_00_00_08_000}', "");
    Expect(0, 126244, '\P{^Nv=00_00_00_08_000}', "");
    Expect(1, 126243, '\p{Nv=8.000000000000000e+03}', "");
    Expect(0, 126243, '\p{^Nv=8.000000000000000e+03}', "");
    Expect(0, 126243, '\P{Nv=8.000000000000000e+03}', "");
    Expect(1, 126243, '\P{^Nv=8.000000000000000e+03}', "");
    Expect(0, 126244, '\p{Nv=8.000000000000000e+03}', "");
    Expect(1, 126244, '\p{^Nv=8.000000000000000e+03}', "");
    Expect(1, 126244, '\P{Nv=8.000000000000000e+03}', "");
    Expect(0, 126244, '\P{^Nv=8.000000000000000e+03}', "");
    Error('\p{Is_Numeric_Value=/a/_-0_0_8_0_00}');
    Error('\P{Is_Numeric_Value=/a/_-0_0_8_0_00}');
    Expect(1, 126243, '\p{Is_Numeric_Value=+00_00_00_80_00}', "");
    Expect(0, 126243, '\p{^Is_Numeric_Value=+00_00_00_80_00}', "");
    Expect(0, 126243, '\P{Is_Numeric_Value=+00_00_00_80_00}', "");
    Expect(1, 126243, '\P{^Is_Numeric_Value=+00_00_00_80_00}', "");
    Expect(0, 126244, '\p{Is_Numeric_Value=+00_00_00_80_00}', "");
    Expect(1, 126244, '\p{^Is_Numeric_Value=+00_00_00_80_00}', "");
    Expect(1, 126244, '\P{Is_Numeric_Value=+00_00_00_80_00}', "");
    Expect(0, 126244, '\P{^Is_Numeric_Value=+00_00_00_80_00}', "");
    Expect(1, 126243, '\p{Is_Numeric_Value=8.000000000000000e+03}', "");
    Expect(0, 126243, '\p{^Is_Numeric_Value=8.000000000000000e+03}', "");
    Expect(0, 126243, '\P{Is_Numeric_Value=8.000000000000000e+03}', "");
    Expect(1, 126243, '\P{^Is_Numeric_Value=8.000000000000000e+03}', "");
    Expect(0, 126244, '\p{Is_Numeric_Value=8.000000000000000e+03}', "");
    Expect(1, 126244, '\p{^Is_Numeric_Value=8.000000000000000e+03}', "");
    Expect(1, 126244, '\P{Is_Numeric_Value=8.000000000000000e+03}', "");
    Expect(0, 126244, '\P{^Is_Numeric_Value=8.000000000000000e+03}', "");
    Error('\p{Is_Nv=/a/0_0_8_000}');
    Error('\P{Is_Nv=/a/0_0_8_000}');
    Expect(1, 126243, '\p{Is_Nv=000_080_00}', "");
    Expect(0, 126243, '\p{^Is_Nv=000_080_00}', "");
    Expect(0, 126243, '\P{Is_Nv=000_080_00}', "");
    Expect(1, 126243, '\P{^Is_Nv=000_080_00}', "");
    Expect(0, 126244, '\p{Is_Nv=000_080_00}', "");
    Expect(1, 126244, '\p{^Is_Nv=000_080_00}', "");
    Expect(1, 126244, '\P{Is_Nv=000_080_00}', "");
    Expect(0, 126244, '\P{^Is_Nv=000_080_00}', "");
    Expect(1, 126243, '\p{Is_Nv=8.000000000000000e+03}', "");
    Expect(0, 126243, '\p{^Is_Nv=8.000000000000000e+03}', "");
    Expect(0, 126243, '\P{Is_Nv=8.000000000000000e+03}', "");
    Expect(1, 126243, '\P{^Is_Nv=8.000000000000000e+03}', "");
    Expect(0, 126244, '\p{Is_Nv=8.000000000000000e+03}', "");
    Expect(1, 126244, '\p{^Is_Nv=8.000000000000000e+03}', "");
    Expect(1, 126244, '\P{Is_Nv=8.000000000000000e+03}', "");
    Expect(0, 126244, '\P{^Is_Nv=8.000000000000000e+03}', "");
    Error('\p{Numeric_Value= 0_0_0_0_0_0_0_0080000:=}');
    Error('\P{Numeric_Value= 0_0_0_0_0_0_0_0080000:=}');
    Expect(1, 126252, '\p{Numeric_Value=:\A80000\z:}', "");;
    Expect(0, 126253, '\p{Numeric_Value=:\A80000\z:}', "");;
    Expect(1, 126252, '\p{Numeric_Value=0000080000}', "");
    Expect(0, 126252, '\p{^Numeric_Value=0000080000}', "");
    Expect(0, 126252, '\P{Numeric_Value=0000080000}', "");
    Expect(1, 126252, '\P{^Numeric_Value=0000080000}', "");
    Expect(0, 126253, '\p{Numeric_Value=0000080000}', "");
    Expect(1, 126253, '\p{^Numeric_Value=0000080000}', "");
    Expect(1, 126253, '\P{Numeric_Value=0000080000}', "");
    Expect(0, 126253, '\P{^Numeric_Value=0000080000}', "");
    Expect(1, 126252, '\p{Numeric_Value=8.000000000000000e+04}', "");
    Expect(0, 126252, '\p{^Numeric_Value=8.000000000000000e+04}', "");
    Expect(0, 126252, '\P{Numeric_Value=8.000000000000000e+04}', "");
    Expect(1, 126252, '\P{^Numeric_Value=8.000000000000000e+04}', "");
    Expect(0, 126253, '\p{Numeric_Value=8.000000000000000e+04}', "");
    Expect(1, 126253, '\p{^Numeric_Value=8.000000000000000e+04}', "");
    Expect(1, 126253, '\P{Numeric_Value=8.000000000000000e+04}', "");
    Expect(0, 126253, '\P{^Numeric_Value=8.000000000000000e+04}', "");
    Error('\p{Nv=_	0_0_0_8_0_000/a/}');
    Error('\P{Nv=_	0_0_0_8_0_000/a/}');
    Expect(1, 126252, '\p{Nv=:\A80000\z:}', "");;
    Expect(0, 126253, '\p{Nv=:\A80000\z:}', "");;
    Expect(1, 126252, '\p{Nv=0_0_0_0_0_0_0_0_8_0_000}', "");
    Expect(0, 126252, '\p{^Nv=0_0_0_0_0_0_0_0_8_0_000}', "");
    Expect(0, 126252, '\P{Nv=0_0_0_0_0_0_0_0_8_0_000}', "");
    Expect(1, 126252, '\P{^Nv=0_0_0_0_0_0_0_0_8_0_000}', "");
    Expect(0, 126253, '\p{Nv=0_0_0_0_0_0_0_0_8_0_000}', "");
    Expect(1, 126253, '\p{^Nv=0_0_0_0_0_0_0_0_8_0_000}', "");
    Expect(1, 126253, '\P{Nv=0_0_0_0_0_0_0_0_8_0_000}', "");
    Expect(0, 126253, '\P{^Nv=0_0_0_0_0_0_0_0_8_0_000}', "");
    Expect(1, 126252, '\p{Nv=8.000000000000000e+04}', "");
    Expect(0, 126252, '\p{^Nv=8.000000000000000e+04}', "");
    Expect(0, 126252, '\P{Nv=8.000000000000000e+04}', "");
    Expect(1, 126252, '\P{^Nv=8.000000000000000e+04}', "");
    Expect(0, 126253, '\p{Nv=8.000000000000000e+04}', "");
    Expect(1, 126253, '\p{^Nv=8.000000000000000e+04}', "");
    Expect(1, 126253, '\P{Nv=8.000000000000000e+04}', "");
    Expect(0, 126253, '\P{^Nv=8.000000000000000e+04}', "");
    Error('\p{Is_Numeric_Value=_:=+0_0_0_0_0_0_0_0_8_0_000}');
    Error('\P{Is_Numeric_Value=_:=+0_0_0_0_0_0_0_0_8_0_000}');
    Expect(1, 126252, '\p{Is_Numeric_Value=080000}', "");
    Expect(0, 126252, '\p{^Is_Numeric_Value=080000}', "");
    Expect(0, 126252, '\P{Is_Numeric_Value=080000}', "");
    Expect(1, 126252, '\P{^Is_Numeric_Value=080000}', "");
    Expect(0, 126253, '\p{Is_Numeric_Value=080000}', "");
    Expect(1, 126253, '\p{^Is_Numeric_Value=080000}', "");
    Expect(1, 126253, '\P{Is_Numeric_Value=080000}', "");
    Expect(0, 126253, '\P{^Is_Numeric_Value=080000}', "");
    Expect(1, 126252, '\p{Is_Numeric_Value=8.000000000000000e+04}', "");
    Expect(0, 126252, '\p{^Is_Numeric_Value=8.000000000000000e+04}', "");
    Expect(0, 126252, '\P{Is_Numeric_Value=8.000000000000000e+04}', "");
    Expect(1, 126252, '\P{^Is_Numeric_Value=8.000000000000000e+04}', "");
    Expect(0, 126253, '\p{Is_Numeric_Value=8.000000000000000e+04}', "");
    Expect(1, 126253, '\p{^Is_Numeric_Value=8.000000000000000e+04}', "");
    Expect(1, 126253, '\P{Is_Numeric_Value=8.000000000000000e+04}', "");
    Expect(0, 126253, '\P{^Is_Numeric_Value=8.000000000000000e+04}', "");
    Error('\p{Is_Nv: --0_0_0_0_0_0_0_0_080000/a/}');
    Error('\P{Is_Nv: --0_0_0_0_0_0_0_0_080000/a/}');
    Expect(1, 126252, '\p{Is_Nv=+00_00_00_00_80_00_0}', "");
    Expect(0, 126252, '\p{^Is_Nv=+00_00_00_00_80_00_0}', "");
    Expect(0, 126252, '\P{Is_Nv=+00_00_00_00_80_00_0}', "");
    Expect(1, 126252, '\P{^Is_Nv=+00_00_00_00_80_00_0}', "");
    Expect(0, 126253, '\p{Is_Nv=+00_00_00_00_80_00_0}', "");
    Expect(1, 126253, '\p{^Is_Nv=+00_00_00_00_80_00_0}', "");
    Expect(1, 126253, '\P{Is_Nv=+00_00_00_00_80_00_0}', "");
    Expect(0, 126253, '\P{^Is_Nv=+00_00_00_00_80_00_0}', "");
    Expect(1, 126252, '\p{Is_Nv=8.000000000000000e+04}', "");
    Expect(0, 126252, '\p{^Is_Nv=8.000000000000000e+04}', "");
    Expect(0, 126252, '\P{Is_Nv=8.000000000000000e+04}', "");
    Expect(1, 126252, '\P{^Is_Nv=8.000000000000000e+04}', "");
    Expect(0, 126253, '\p{Is_Nv=8.000000000000000e+04}', "");
    Expect(1, 126253, '\p{^Is_Nv=8.000000000000000e+04}', "");
    Expect(1, 126253, '\P{Is_Nv=8.000000000000000e+04}', "");
    Expect(0, 126253, '\P{^Is_Nv=8.000000000000000e+04}', "");
    Error('\p{Numeric_Value=/a/0800000}');
    Error('\P{Numeric_Value=/a/0800000}');
    Expect(1, 68084, '\p{Numeric_Value=:\A800000\z:}', "");;
    Expect(0, 68085, '\p{Numeric_Value=:\A800000\z:}', "");;
    Expect(1, 68084, '\p{Numeric_Value=00800000}', "");
    Expect(0, 68084, '\p{^Numeric_Value=00800000}', "");
    Expect(0, 68084, '\P{Numeric_Value=00800000}', "");
    Expect(1, 68084, '\P{^Numeric_Value=00800000}', "");
    Expect(0, 68085, '\p{Numeric_Value=00800000}', "");
    Expect(1, 68085, '\p{^Numeric_Value=00800000}', "");
    Expect(1, 68085, '\P{Numeric_Value=00800000}', "");
    Expect(0, 68085, '\P{^Numeric_Value=00800000}', "");
    Expect(1, 68084, '\p{Numeric_Value=8.000000000000000e+05}', "");
    Expect(0, 68084, '\p{^Numeric_Value=8.000000000000000e+05}', "");
    Expect(0, 68084, '\P{Numeric_Value=8.000000000000000e+05}', "");
    Expect(1, 68084, '\P{^Numeric_Value=8.000000000000000e+05}', "");
    Expect(0, 68085, '\p{Numeric_Value=8.000000000000000e+05}', "");
    Expect(1, 68085, '\p{^Numeric_Value=8.000000000000000e+05}', "");
    Expect(1, 68085, '\P{Numeric_Value=8.000000000000000e+05}', "");
    Expect(0, 68085, '\P{^Numeric_Value=8.000000000000000e+05}', "");
    Error('\p{Nv: :=+0800000}');
    Error('\P{Nv: :=+0800000}');
    Expect(1, 68084, '\p{Nv=:\A800000\z:}', "");;
    Expect(0, 68085, '\p{Nv=:\A800000\z:}', "");;
    Expect(1, 68084, '\p{Nv=+00800000}', "");
    Expect(0, 68084, '\p{^Nv=+00800000}', "");
    Expect(0, 68084, '\P{Nv=+00800000}', "");
    Expect(1, 68084, '\P{^Nv=+00800000}', "");
    Expect(0, 68085, '\p{Nv=+00800000}', "");
    Expect(1, 68085, '\p{^Nv=+00800000}', "");
    Expect(1, 68085, '\P{Nv=+00800000}', "");
    Expect(0, 68085, '\P{^Nv=+00800000}', "");
    Expect(1, 68084, '\p{Nv:   8.000000000000000e+05}', "");
    Expect(0, 68084, '\p{^Nv:   8.000000000000000e+05}', "");
    Expect(0, 68084, '\P{Nv:   8.000000000000000e+05}', "");
    Expect(1, 68084, '\P{^Nv:   8.000000000000000e+05}', "");
    Expect(0, 68085, '\p{Nv:   8.000000000000000e+05}', "");
    Expect(1, 68085, '\p{^Nv:   8.000000000000000e+05}', "");
    Expect(1, 68085, '\P{Nv:   8.000000000000000e+05}', "");
    Expect(0, 68085, '\P{^Nv:   8.000000000000000e+05}', "");
    Error('\p{Is_Numeric_Value=_-00_80_00_00/a/}');
    Error('\P{Is_Numeric_Value=_-00_80_00_00/a/}');
    Expect(1, 68084, '\p{Is_Numeric_Value=0000800000}', "");
    Expect(0, 68084, '\p{^Is_Numeric_Value=0000800000}', "");
    Expect(0, 68084, '\P{Is_Numeric_Value=0000800000}', "");
    Expect(1, 68084, '\P{^Is_Numeric_Value=0000800000}', "");
    Expect(0, 68085, '\p{Is_Numeric_Value=0000800000}', "");
    Expect(1, 68085, '\p{^Is_Numeric_Value=0000800000}', "");
    Expect(1, 68085, '\P{Is_Numeric_Value=0000800000}', "");
    Expect(0, 68085, '\P{^Is_Numeric_Value=0000800000}', "");
    Expect(1, 68084, '\p{Is_Numeric_Value=8.000000000000000e+05}', "");
    Expect(0, 68084, '\p{^Is_Numeric_Value=8.000000000000000e+05}', "");
    Expect(0, 68084, '\P{Is_Numeric_Value=8.000000000000000e+05}', "");
    Expect(1, 68084, '\P{^Is_Numeric_Value=8.000000000000000e+05}', "");
    Expect(0, 68085, '\p{Is_Numeric_Value=8.000000000000000e+05}', "");
    Expect(1, 68085, '\p{^Is_Numeric_Value=8.000000000000000e+05}', "");
    Expect(1, 68085, '\P{Is_Numeric_Value=8.000000000000000e+05}', "");
    Expect(0, 68085, '\P{^Is_Numeric_Value=8.000000000000000e+05}', "");
    Error('\p{Is_Nv= +0800000:=}');
    Error('\P{Is_Nv= +0800000:=}');
    Expect(1, 68084, '\p{Is_Nv:   +00000000800000}', "");
    Expect(0, 68084, '\p{^Is_Nv:   +00000000800000}', "");
    Expect(0, 68084, '\P{Is_Nv:   +00000000800000}', "");
    Expect(1, 68084, '\P{^Is_Nv:   +00000000800000}', "");
    Expect(0, 68085, '\p{Is_Nv:   +00000000800000}', "");
    Expect(1, 68085, '\p{^Is_Nv:   +00000000800000}', "");
    Expect(1, 68085, '\P{Is_Nv:   +00000000800000}', "");
    Expect(0, 68085, '\P{^Is_Nv:   +00000000800000}', "");
    Expect(1, 68084, '\p{Is_Nv=8.000000000000000e+05}', "");
    Expect(0, 68084, '\p{^Is_Nv=8.000000000000000e+05}', "");
    Expect(0, 68084, '\P{Is_Nv=8.000000000000000e+05}', "");
    Expect(1, 68084, '\P{^Is_Nv=8.000000000000000e+05}', "");
    Expect(0, 68085, '\p{Is_Nv=8.000000000000000e+05}', "");
    Expect(1, 68085, '\p{^Is_Nv=8.000000000000000e+05}', "");
    Expect(1, 68085, '\P{Is_Nv=8.000000000000000e+05}', "");
    Expect(0, 68085, '\P{^Is_Nv=8.000000000000000e+05}', "");
    Error('\p{Numeric_Value=- +0009/a/}');
    Error('\P{Numeric_Value=- +0009/a/}');
    Expect(1, 194704, '\p{Numeric_Value=:\A9\z:}', "");;
    Expect(0, 194705, '\p{Numeric_Value=:\A9\z:}', "");;
    Expect(1, 194704, '\p{Numeric_Value=+009}', "");
    Expect(0, 194704, '\p{^Numeric_Value=+009}', "");
    Expect(0, 194704, '\P{Numeric_Value=+009}', "");
    Expect(1, 194704, '\P{^Numeric_Value=+009}', "");
    Expect(0, 194705, '\p{Numeric_Value=+009}', "");
    Expect(1, 194705, '\p{^Numeric_Value=+009}', "");
    Expect(1, 194705, '\P{Numeric_Value=+009}', "");
    Expect(0, 194705, '\P{^Numeric_Value=+009}', "");
    Expect(1, 194704, '\p{Numeric_Value=9.000000000000000e+00}', "");
    Expect(0, 194704, '\p{^Numeric_Value=9.000000000000000e+00}', "");
    Expect(0, 194704, '\P{Numeric_Value=9.000000000000000e+00}', "");
    Expect(1, 194704, '\P{^Numeric_Value=9.000000000000000e+00}', "");
    Expect(0, 194705, '\p{Numeric_Value=9.000000000000000e+00}', "");
    Expect(1, 194705, '\p{^Numeric_Value=9.000000000000000e+00}', "");
    Expect(1, 194705, '\P{Numeric_Value=9.000000000000000e+00}', "");
    Expect(0, 194705, '\P{^Numeric_Value=9.000000000000000e+00}', "");
    Error('\p{Nv=:= 	+9}');
    Error('\P{Nv=:= 	+9}');
    Expect(1, 194704, '\p{Nv=:\A9\z:}', "");;
    Expect(0, 194705, '\p{Nv=:\A9\z:}', "");;
    Expect(1, 194704, '\p{Nv=09}', "");
    Expect(0, 194704, '\p{^Nv=09}', "");
    Expect(0, 194704, '\P{Nv=09}', "");
    Expect(1, 194704, '\P{^Nv=09}', "");
    Expect(0, 194705, '\p{Nv=09}', "");
    Expect(1, 194705, '\p{^Nv=09}', "");
    Expect(1, 194705, '\P{Nv=09}', "");
    Expect(0, 194705, '\P{^Nv=09}', "");
    Expect(1, 194704, '\p{Nv=9.000000000000000e+00}', "");
    Expect(0, 194704, '\p{^Nv=9.000000000000000e+00}', "");
    Expect(0, 194704, '\P{Nv=9.000000000000000e+00}', "");
    Expect(1, 194704, '\P{^Nv=9.000000000000000e+00}', "");
    Expect(0, 194705, '\p{Nv=9.000000000000000e+00}', "");
    Expect(1, 194705, '\p{^Nv=9.000000000000000e+00}', "");
    Expect(1, 194705, '\P{Nv=9.000000000000000e+00}', "");
    Expect(0, 194705, '\P{^Nv=9.000000000000000e+00}', "");
    Error('\p{Is_Numeric_Value: :=- 00000009}');
    Error('\P{Is_Numeric_Value: :=- 00000009}');
    Expect(1, 194704, '\p{Is_Numeric_Value=0_0_0_0_0_0_0_009}', "");
    Expect(0, 194704, '\p{^Is_Numeric_Value=0_0_0_0_0_0_0_009}', "");
    Expect(0, 194704, '\P{Is_Numeric_Value=0_0_0_0_0_0_0_009}', "");
    Expect(1, 194704, '\P{^Is_Numeric_Value=0_0_0_0_0_0_0_009}', "");
    Expect(0, 194705, '\p{Is_Numeric_Value=0_0_0_0_0_0_0_009}', "");
    Expect(1, 194705, '\p{^Is_Numeric_Value=0_0_0_0_0_0_0_009}', "");
    Expect(1, 194705, '\P{Is_Numeric_Value=0_0_0_0_0_0_0_009}', "");
    Expect(0, 194705, '\P{^Is_Numeric_Value=0_0_0_0_0_0_0_009}', "");
    Expect(1, 194704, '\p{Is_Numeric_Value=9.000000000000000e+00}', "");
    Expect(0, 194704, '\p{^Is_Numeric_Value=9.000000000000000e+00}', "");
    Expect(0, 194704, '\P{Is_Numeric_Value=9.000000000000000e+00}', "");
    Expect(1, 194704, '\P{^Is_Numeric_Value=9.000000000000000e+00}', "");
    Expect(0, 194705, '\p{Is_Numeric_Value=9.000000000000000e+00}', "");
    Expect(1, 194705, '\p{^Is_Numeric_Value=9.000000000000000e+00}', "");
    Expect(1, 194705, '\P{Is_Numeric_Value=9.000000000000000e+00}', "");
    Expect(0, 194705, '\P{^Is_Numeric_Value=9.000000000000000e+00}', "");
    Error('\p{Is_Nv=00009/a/}');
    Error('\P{Is_Nv=00009/a/}');
    Expect(1, 194704, '\p{Is_Nv=0_9}', "");
    Expect(0, 194704, '\p{^Is_Nv=0_9}', "");
    Expect(0, 194704, '\P{Is_Nv=0_9}', "");
    Expect(1, 194704, '\P{^Is_Nv=0_9}', "");
    Expect(0, 194705, '\p{Is_Nv=0_9}', "");
    Expect(1, 194705, '\p{^Is_Nv=0_9}', "");
    Expect(1, 194705, '\P{Is_Nv=0_9}', "");
    Expect(0, 194705, '\P{^Is_Nv=0_9}', "");
    Expect(1, 194704, '\p{Is_Nv=9.000000000000000e+00}', "");
    Expect(0, 194704, '\p{^Is_Nv=9.000000000000000e+00}', "");
    Expect(0, 194704, '\P{Is_Nv=9.000000000000000e+00}', "");
    Expect(1, 194704, '\P{^Is_Nv=9.000000000000000e+00}', "");
    Expect(0, 194705, '\p{Is_Nv=9.000000000000000e+00}', "");
    Expect(1, 194705, '\p{^Is_Nv=9.000000000000000e+00}', "");
    Expect(1, 194705, '\P{Is_Nv=9.000000000000000e+00}', "");
    Expect(0, 194705, '\P{^Is_Nv=9.000000000000000e+00}', "");
    Error('\p{Numeric_Value=/a/+9/0000002}');
    Error('\P{Numeric_Value=/a/+9/0000002}');
    Expect(1, 3886, '\p{Numeric_Value=:\A9/2\z:}', "");;
    Expect(0, 3887, '\p{Numeric_Value=:\A9/2\z:}', "");;
    Expect(1, 3886, '\p{Numeric_Value=+009/0000002}', "");
    Expect(0, 3886, '\p{^Numeric_Value=+009/0000002}', "");
    Expect(0, 3886, '\P{Numeric_Value=+009/0000002}', "");
    Expect(1, 3886, '\P{^Numeric_Value=+009/0000002}', "");
    Expect(0, 3887, '\p{Numeric_Value=+009/0000002}', "");
    Expect(1, 3887, '\p{^Numeric_Value=+009/0000002}', "");
    Expect(1, 3887, '\P{Numeric_Value=+009/0000002}', "");
    Expect(0, 3887, '\P{^Numeric_Value=+009/0000002}', "");
    Expect(1, 3886, '\p{Numeric_Value=540/120}', "");
    Expect(0, 3886, '\p{^Numeric_Value=540/120}', "");
    Expect(0, 3886, '\P{Numeric_Value=540/120}', "");
    Expect(1, 3886, '\P{^Numeric_Value=540/120}', "");
    Expect(0, 3887, '\p{Numeric_Value=540/120}', "");
    Expect(1, 3887, '\p{^Numeric_Value=540/120}', "");
    Expect(1, 3887, '\P{Numeric_Value=540/120}', "");
    Expect(0, 3887, '\P{^Numeric_Value=540/120}', "");
    Expect(1, 3886, '\p{Numeric_Value=4.5e+00}', "");
    Expect(0, 3886, '\p{^Numeric_Value=4.5e+00}', "");
    Expect(0, 3886, '\P{Numeric_Value=4.5e+00}', "");
    Expect(1, 3886, '\P{^Numeric_Value=4.5e+00}', "");
    Expect(0, 3887, '\p{Numeric_Value=4.5e+00}', "");
    Expect(1, 3887, '\p{^Numeric_Value=4.5e+00}', "");
    Expect(1, 3887, '\P{Numeric_Value=4.5e+00}', "");
    Expect(0, 3887, '\P{^Numeric_Value=4.5e+00}', "");
    Expect(1, 3886, '\p{Numeric_Value=4.5}', "");
    Expect(0, 3886, '\p{^Numeric_Value=4.5}', "");
    Expect(0, 3886, '\P{Numeric_Value=4.5}', "");
    Expect(1, 3886, '\P{^Numeric_Value=4.5}', "");
    Expect(0, 3887, '\p{Numeric_Value=4.5}', "");
    Expect(1, 3887, '\p{^Numeric_Value=4.5}', "");
    Expect(1, 3887, '\P{Numeric_Value=4.5}', "");
    Expect(0, 3887, '\P{^Numeric_Value=4.5}', "");
    Expect(1, 3886, '\p{Numeric_Value=4.50e+00}', "");
    Expect(0, 3886, '\p{^Numeric_Value=4.50e+00}', "");
    Expect(0, 3886, '\P{Numeric_Value=4.50e+00}', "");
    Expect(1, 3886, '\P{^Numeric_Value=4.50e+00}', "");
    Expect(0, 3887, '\p{Numeric_Value=4.50e+00}', "");
    Expect(1, 3887, '\p{^Numeric_Value=4.50e+00}', "");
    Expect(1, 3887, '\P{Numeric_Value=4.50e+00}', "");
    Expect(0, 3887, '\P{^Numeric_Value=4.50e+00}', "");
    Expect(1, 3886, '\p{Numeric_Value=4.50}', "");
    Expect(0, 3886, '\p{^Numeric_Value=4.50}', "");
    Expect(0, 3886, '\P{Numeric_Value=4.50}', "");
    Expect(1, 3886, '\P{^Numeric_Value=4.50}', "");
    Expect(0, 3887, '\p{Numeric_Value=4.50}', "");
    Expect(1, 3887, '\p{^Numeric_Value=4.50}', "");
    Expect(1, 3887, '\P{Numeric_Value=4.50}', "");
    Expect(0, 3887, '\P{^Numeric_Value=4.50}', "");
    Error('\p{Nv=-_+0009/002/a/}');
    Error('\P{Nv=-_+0009/002/a/}');
    Expect(1, 3886, '\p{Nv=:\A9/2\z:}', "");;
    Expect(0, 3887, '\p{Nv=:\A9/2\z:}', "");;
    Expect(1, 3886, '\p{Nv=+9/00002}', "");
    Expect(0, 3886, '\p{^Nv=+9/00002}', "");
    Expect(0, 3886, '\P{Nv=+9/00002}', "");
    Expect(1, 3886, '\P{^Nv=+9/00002}', "");
    Expect(0, 3887, '\p{Nv=+9/00002}', "");
    Expect(1, 3887, '\p{^Nv=+9/00002}', "");
    Expect(1, 3887, '\P{Nv=+9/00002}', "");
    Expect(0, 3887, '\P{^Nv=+9/00002}', "");
    Expect(1, 3886, '\p{Nv: 540/120}', "");
    Expect(0, 3886, '\p{^Nv: 540/120}', "");
    Expect(0, 3886, '\P{Nv: 540/120}', "");
    Expect(1, 3886, '\P{^Nv: 540/120}', "");
    Expect(0, 3887, '\p{Nv: 540/120}', "");
    Expect(1, 3887, '\p{^Nv: 540/120}', "");
    Expect(1, 3887, '\P{Nv: 540/120}', "");
    Expect(0, 3887, '\P{^Nv: 540/120}', "");
    Expect(1, 3886, '\p{Nv: 4.5e+00}', "");
    Expect(0, 3886, '\p{^Nv: 4.5e+00}', "");
    Expect(0, 3886, '\P{Nv: 4.5e+00}', "");
    Expect(1, 3886, '\P{^Nv: 4.5e+00}', "");
    Expect(0, 3887, '\p{Nv: 4.5e+00}', "");
    Expect(1, 3887, '\p{^Nv: 4.5e+00}', "");
    Expect(1, 3887, '\P{Nv: 4.5e+00}', "");
    Expect(0, 3887, '\P{^Nv: 4.5e+00}', "");
    Expect(1, 3886, '\p{Nv:	4.5}', "");
    Expect(0, 3886, '\p{^Nv:	4.5}', "");
    Expect(0, 3886, '\P{Nv:	4.5}', "");
    Expect(1, 3886, '\P{^Nv:	4.5}', "");
    Expect(0, 3887, '\p{Nv:	4.5}', "");
    Expect(1, 3887, '\p{^Nv:	4.5}', "");
    Expect(1, 3887, '\P{Nv:	4.5}', "");
    Expect(0, 3887, '\P{^Nv:	4.5}', "");
    Expect(1, 3886, '\p{Nv=4.50e+00}', "");
    Expect(0, 3886, '\p{^Nv=4.50e+00}', "");
    Expect(0, 3886, '\P{Nv=4.50e+00}', "");
    Expect(1, 3886, '\P{^Nv=4.50e+00}', "");
    Expect(0, 3887, '\p{Nv=4.50e+00}', "");
    Expect(1, 3887, '\p{^Nv=4.50e+00}', "");
    Expect(1, 3887, '\P{Nv=4.50e+00}', "");
    Expect(0, 3887, '\P{^Nv=4.50e+00}', "");
    Expect(1, 3886, '\p{Nv=4.50}', "");
    Expect(0, 3886, '\p{^Nv=4.50}', "");
    Expect(0, 3886, '\P{Nv=4.50}', "");
    Expect(1, 3886, '\P{^Nv=4.50}', "");
    Expect(0, 3887, '\p{Nv=4.50}', "");
    Expect(1, 3887, '\p{^Nv=4.50}', "");
    Expect(1, 3887, '\P{Nv=4.50}', "");
    Expect(0, 3887, '\P{^Nv=4.50}', "");
    Error('\p{Is_Numeric_Value=:=_	009/0002}');
    Error('\P{Is_Numeric_Value=:=_	009/0002}');
    Expect(1, 3886, '\p{Is_Numeric_Value=00009/002}', "");
    Expect(0, 3886, '\p{^Is_Numeric_Value=00009/002}', "");
    Expect(0, 3886, '\P{Is_Numeric_Value=00009/002}', "");
    Expect(1, 3886, '\P{^Is_Numeric_Value=00009/002}', "");
    Expect(0, 3887, '\p{Is_Numeric_Value=00009/002}', "");
    Expect(1, 3887, '\p{^Is_Numeric_Value=00009/002}', "");
    Expect(1, 3887, '\P{Is_Numeric_Value=00009/002}', "");
    Expect(0, 3887, '\P{^Is_Numeric_Value=00009/002}', "");
    Expect(1, 3886, '\p{Is_Numeric_Value=540/120}', "");
    Expect(0, 3886, '\p{^Is_Numeric_Value=540/120}', "");
    Expect(0, 3886, '\P{Is_Numeric_Value=540/120}', "");
    Expect(1, 3886, '\P{^Is_Numeric_Value=540/120}', "");
    Expect(0, 3887, '\p{Is_Numeric_Value=540/120}', "");
    Expect(1, 3887, '\p{^Is_Numeric_Value=540/120}', "");
    Expect(1, 3887, '\P{Is_Numeric_Value=540/120}', "");
    Expect(0, 3887, '\P{^Is_Numeric_Value=540/120}', "");
    Expect(1, 3886, '\p{Is_Numeric_Value=4.5e+00}', "");
    Expect(0, 3886, '\p{^Is_Numeric_Value=4.5e+00}', "");
    Expect(0, 3886, '\P{Is_Numeric_Value=4.5e+00}', "");
    Expect(1, 3886, '\P{^Is_Numeric_Value=4.5e+00}', "");
    Expect(0, 3887, '\p{Is_Numeric_Value=4.5e+00}', "");
    Expect(1, 3887, '\p{^Is_Numeric_Value=4.5e+00}', "");
    Expect(1, 3887, '\P{Is_Numeric_Value=4.5e+00}', "");
    Expect(0, 3887, '\P{^Is_Numeric_Value=4.5e+00}', "");
    Expect(1, 3886, '\p{Is_Numeric_Value=4.5}', "");
    Expect(0, 3886, '\p{^Is_Numeric_Value=4.5}', "");
    Expect(0, 3886, '\P{Is_Numeric_Value=4.5}', "");
    Expect(1, 3886, '\P{^Is_Numeric_Value=4.5}', "");
    Expect(0, 3887, '\p{Is_Numeric_Value=4.5}', "");
    Expect(1, 3887, '\p{^Is_Numeric_Value=4.5}', "");
    Expect(1, 3887, '\P{Is_Numeric_Value=4.5}', "");
    Expect(0, 3887, '\P{^Is_Numeric_Value=4.5}', "");
    Expect(1, 3886, '\p{Is_Numeric_Value=4.50e+00}', "");
    Expect(0, 3886, '\p{^Is_Numeric_Value=4.50e+00}', "");
    Expect(0, 3886, '\P{Is_Numeric_Value=4.50e+00}', "");
    Expect(1, 3886, '\P{^Is_Numeric_Value=4.50e+00}', "");
    Expect(0, 3887, '\p{Is_Numeric_Value=4.50e+00}', "");
    Expect(1, 3887, '\p{^Is_Numeric_Value=4.50e+00}', "");
    Expect(1, 3887, '\P{Is_Numeric_Value=4.50e+00}', "");
    Expect(0, 3887, '\P{^Is_Numeric_Value=4.50e+00}', "");
    Expect(1, 3886, '\p{Is_Numeric_Value=4.50}', "");
    Expect(0, 3886, '\p{^Is_Numeric_Value=4.50}', "");
    Expect(0, 3886, '\P{Is_Numeric_Value=4.50}', "");
    Expect(1, 3886, '\P{^Is_Numeric_Value=4.50}', "");
    Expect(0, 3887, '\p{Is_Numeric_Value=4.50}', "");
    Expect(1, 3887, '\p{^Is_Numeric_Value=4.50}', "");
    Expect(1, 3887, '\P{Is_Numeric_Value=4.50}', "");
    Expect(0, 3887, '\P{^Is_Numeric_Value=4.50}', "");
    Error('\p{Is_Nv=_	+0000009/000000002:=}');
    Error('\P{Is_Nv=_	+0000009/000000002:=}');
    Expect(1, 3886, '\p{Is_Nv=+0009/0000002}', "");
    Expect(0, 3886, '\p{^Is_Nv=+0009/0000002}', "");
    Expect(0, 3886, '\P{Is_Nv=+0009/0000002}', "");
    Expect(1, 3886, '\P{^Is_Nv=+0009/0000002}', "");
    Expect(0, 3887, '\p{Is_Nv=+0009/0000002}', "");
    Expect(1, 3887, '\p{^Is_Nv=+0009/0000002}', "");
    Expect(1, 3887, '\P{Is_Nv=+0009/0000002}', "");
    Expect(0, 3887, '\P{^Is_Nv=+0009/0000002}', "");
    Expect(1, 3886, '\p{Is_Nv=540/120}', "");
    Expect(0, 3886, '\p{^Is_Nv=540/120}', "");
    Expect(0, 3886, '\P{Is_Nv=540/120}', "");
    Expect(1, 3886, '\P{^Is_Nv=540/120}', "");
    Expect(0, 3887, '\p{Is_Nv=540/120}', "");
    Expect(1, 3887, '\p{^Is_Nv=540/120}', "");
    Expect(1, 3887, '\P{Is_Nv=540/120}', "");
    Expect(0, 3887, '\P{^Is_Nv=540/120}', "");
    Expect(1, 3886, '\p{Is_Nv=4.5e+00}', "");
    Expect(0, 3886, '\p{^Is_Nv=4.5e+00}', "");
    Expect(0, 3886, '\P{Is_Nv=4.5e+00}', "");
    Expect(1, 3886, '\P{^Is_Nv=4.5e+00}', "");
    Expect(0, 3887, '\p{Is_Nv=4.5e+00}', "");
    Expect(1, 3887, '\p{^Is_Nv=4.5e+00}', "");
    Expect(1, 3887, '\P{Is_Nv=4.5e+00}', "");
    Expect(0, 3887, '\P{^Is_Nv=4.5e+00}', "");
    Expect(1, 3886, '\p{Is_Nv=4.5}', "");
    Expect(0, 3886, '\p{^Is_Nv=4.5}', "");
    Expect(0, 3886, '\P{Is_Nv=4.5}', "");
    Expect(1, 3886, '\P{^Is_Nv=4.5}', "");
    Expect(0, 3887, '\p{Is_Nv=4.5}', "");
    Expect(1, 3887, '\p{^Is_Nv=4.5}', "");
    Expect(1, 3887, '\P{Is_Nv=4.5}', "");
    Expect(0, 3887, '\P{^Is_Nv=4.5}', "");
    Expect(1, 3886, '\p{Is_Nv=4.50e+00}', "");
    Expect(0, 3886, '\p{^Is_Nv=4.50e+00}', "");
    Expect(0, 3886, '\P{Is_Nv=4.50e+00}', "");
    Expect(1, 3886, '\P{^Is_Nv=4.50e+00}', "");
    Expect(0, 3887, '\p{Is_Nv=4.50e+00}', "");
    Expect(1, 3887, '\p{^Is_Nv=4.50e+00}', "");
    Expect(1, 3887, '\P{Is_Nv=4.50e+00}', "");
    Expect(0, 3887, '\P{^Is_Nv=4.50e+00}', "");
    Expect(1, 3886, '\p{Is_Nv=4.50}', "");
    Expect(0, 3886, '\p{^Is_Nv=4.50}', "");
    Expect(0, 3886, '\P{Is_Nv=4.50}', "");
    Expect(1, 3886, '\P{^Is_Nv=4.50}', "");
    Expect(0, 3887, '\p{Is_Nv=4.50}', "");
    Expect(1, 3887, '\p{^Is_Nv=4.50}', "");
    Expect(1, 3887, '\P{Is_Nv=4.50}', "");
    Expect(0, 3887, '\P{^Is_Nv=4.50}', "");
    Error('\p{Numeric_Value=	:=+0000000090}');
    Error('\P{Numeric_Value=	:=+0000000090}');
    Expect(1, 126226, '\p{Numeric_Value=:\A90\z:}', "");;
    Expect(0, 126227, '\p{Numeric_Value=:\A90\z:}', "");;
    Expect(1, 126226, '\p{Numeric_Value=90}', "");
    Expect(0, 126226, '\p{^Numeric_Value=90}', "");
    Expect(0, 126226, '\P{Numeric_Value=90}', "");
    Expect(1, 126226, '\P{^Numeric_Value=90}', "");
    Expect(0, 126227, '\p{Numeric_Value=90}', "");
    Expect(1, 126227, '\p{^Numeric_Value=90}', "");
    Expect(1, 126227, '\P{Numeric_Value=90}', "");
    Expect(0, 126227, '\P{^Numeric_Value=90}', "");
    Expect(1, 126226, '\p{Numeric_Value=9.000000000000000e+01}', "");
    Expect(0, 126226, '\p{^Numeric_Value=9.000000000000000e+01}', "");
    Expect(0, 126226, '\P{Numeric_Value=9.000000000000000e+01}', "");
    Expect(1, 126226, '\P{^Numeric_Value=9.000000000000000e+01}', "");
    Expect(0, 126227, '\p{Numeric_Value=9.000000000000000e+01}', "");
    Expect(1, 126227, '\p{^Numeric_Value=9.000000000000000e+01}', "");
    Expect(1, 126227, '\P{Numeric_Value=9.000000000000000e+01}', "");
    Expect(0, 126227, '\P{^Numeric_Value=9.000000000000000e+01}', "");
    Error('\p{Nv=:=000090}');
    Error('\P{Nv=:=000090}');
    Expect(1, 126226, '\p{Nv=:\A90\z:}', "");;
    Expect(0, 126227, '\p{Nv=:\A90\z:}', "");;
    Expect(1, 126226, '\p{Nv=09_0}', "");
    Expect(0, 126226, '\p{^Nv=09_0}', "");
    Expect(0, 126226, '\P{Nv=09_0}', "");
    Expect(1, 126226, '\P{^Nv=09_0}', "");
    Expect(0, 126227, '\p{Nv=09_0}', "");
    Expect(1, 126227, '\p{^Nv=09_0}', "");
    Expect(1, 126227, '\P{Nv=09_0}', "");
    Expect(0, 126227, '\P{^Nv=09_0}', "");
    Expect(1, 126226, '\p{Nv=9.000000000000000e+01}', "");
    Expect(0, 126226, '\p{^Nv=9.000000000000000e+01}', "");
    Expect(0, 126226, '\P{Nv=9.000000000000000e+01}', "");
    Expect(1, 126226, '\P{^Nv=9.000000000000000e+01}', "");
    Expect(0, 126227, '\p{Nv=9.000000000000000e+01}', "");
    Expect(1, 126227, '\p{^Nv=9.000000000000000e+01}', "");
    Expect(1, 126227, '\P{Nv=9.000000000000000e+01}', "");
    Expect(0, 126227, '\P{^Nv=9.000000000000000e+01}', "");
    Error('\p{Is_Numeric_Value=	 90:=}');
    Error('\P{Is_Numeric_Value=	 90:=}');
    Expect(1, 126226, '\p{Is_Numeric_Value=00090}', "");
    Expect(0, 126226, '\p{^Is_Numeric_Value=00090}', "");
    Expect(0, 126226, '\P{Is_Numeric_Value=00090}', "");
    Expect(1, 126226, '\P{^Is_Numeric_Value=00090}', "");
    Expect(0, 126227, '\p{Is_Numeric_Value=00090}', "");
    Expect(1, 126227, '\p{^Is_Numeric_Value=00090}', "");
    Expect(1, 126227, '\P{Is_Numeric_Value=00090}', "");
    Expect(0, 126227, '\P{^Is_Numeric_Value=00090}', "");
    Expect(1, 126226, '\p{Is_Numeric_Value=9.000000000000000e+01}', "");
    Expect(0, 126226, '\p{^Is_Numeric_Value=9.000000000000000e+01}', "");
    Expect(0, 126226, '\P{Is_Numeric_Value=9.000000000000000e+01}', "");
    Expect(1, 126226, '\P{^Is_Numeric_Value=9.000000000000000e+01}', "");
    Expect(0, 126227, '\p{Is_Numeric_Value=9.000000000000000e+01}', "");
    Expect(1, 126227, '\p{^Is_Numeric_Value=9.000000000000000e+01}', "");
    Expect(1, 126227, '\P{Is_Numeric_Value=9.000000000000000e+01}', "");
    Expect(0, 126227, '\P{^Is_Numeric_Value=9.000000000000000e+01}', "");
    Error('\p{Is_Nv=		+90/a/}');
    Error('\P{Is_Nv=		+90/a/}');
    Expect(1, 126226, '\p{Is_Nv=0009_0}', "");
    Expect(0, 126226, '\p{^Is_Nv=0009_0}', "");
    Expect(0, 126226, '\P{Is_Nv=0009_0}', "");
    Expect(1, 126226, '\P{^Is_Nv=0009_0}', "");
    Expect(0, 126227, '\p{Is_Nv=0009_0}', "");
    Expect(1, 126227, '\p{^Is_Nv=0009_0}', "");
    Expect(1, 126227, '\P{Is_Nv=0009_0}', "");
    Expect(0, 126227, '\P{^Is_Nv=0009_0}', "");
    Expect(1, 126226, '\p{Is_Nv=9.000000000000000e+01}', "");
    Expect(0, 126226, '\p{^Is_Nv=9.000000000000000e+01}', "");
    Expect(0, 126226, '\P{Is_Nv=9.000000000000000e+01}', "");
    Expect(1, 126226, '\P{^Is_Nv=9.000000000000000e+01}', "");
    Expect(0, 126227, '\p{Is_Nv=9.000000000000000e+01}', "");
    Expect(1, 126227, '\p{^Is_Nv=9.000000000000000e+01}', "");
    Expect(1, 126227, '\P{Is_Nv=9.000000000000000e+01}', "");
    Expect(0, 126227, '\P{^Is_Nv=9.000000000000000e+01}', "");
    Error('\p{Numeric_Value=:=00_00_00_90_0}');
    Error('\P{Numeric_Value=:=00_00_00_90_0}');
    Expect(1, 126235, '\p{Numeric_Value=:\A900\z:}', "");;
    Expect(0, 126236, '\p{Numeric_Value=:\A900\z:}', "");;
    Expect(1, 126235, '\p{Numeric_Value=090_0}', "");
    Expect(0, 126235, '\p{^Numeric_Value=090_0}', "");
    Expect(0, 126235, '\P{Numeric_Value=090_0}', "");
    Expect(1, 126235, '\P{^Numeric_Value=090_0}', "");
    Expect(0, 126236, '\p{Numeric_Value=090_0}', "");
    Expect(1, 126236, '\p{^Numeric_Value=090_0}', "");
    Expect(1, 126236, '\P{Numeric_Value=090_0}', "");
    Expect(0, 126236, '\P{^Numeric_Value=090_0}', "");
    Expect(1, 126235, '\p{Numeric_Value=9.000000000000000e+02}', "");
    Expect(0, 126235, '\p{^Numeric_Value=9.000000000000000e+02}', "");
    Expect(0, 126235, '\P{Numeric_Value=9.000000000000000e+02}', "");
    Expect(1, 126235, '\P{^Numeric_Value=9.000000000000000e+02}', "");
    Expect(0, 126236, '\p{Numeric_Value=9.000000000000000e+02}', "");
    Expect(1, 126236, '\p{^Numeric_Value=9.000000000000000e+02}', "");
    Expect(1, 126236, '\P{Numeric_Value=9.000000000000000e+02}', "");
    Expect(0, 126236, '\P{^Numeric_Value=9.000000000000000e+02}', "");
    Error('\p{Nv=-:=0_0_0_0_0_0_0900}');
    Error('\P{Nv=-:=0_0_0_0_0_0_0900}');
    Expect(1, 126235, '\p{Nv=:\A900\z:}', "");;
    Expect(0, 126236, '\p{Nv=:\A900\z:}', "");;
    Expect(1, 126235, '\p{Nv=0900}', "");
    Expect(0, 126235, '\p{^Nv=0900}', "");
    Expect(0, 126235, '\P{Nv=0900}', "");
    Expect(1, 126235, '\P{^Nv=0900}', "");
    Expect(0, 126236, '\p{Nv=0900}', "");
    Expect(1, 126236, '\p{^Nv=0900}', "");
    Expect(1, 126236, '\P{Nv=0900}', "");
    Expect(0, 126236, '\P{^Nv=0900}', "");
    Expect(1, 126235, '\p{Nv=9.000000000000000e+02}', "");
    Expect(0, 126235, '\p{^Nv=9.000000000000000e+02}', "");
    Expect(0, 126235, '\P{Nv=9.000000000000000e+02}', "");
    Expect(1, 126235, '\P{^Nv=9.000000000000000e+02}', "");
    Expect(0, 126236, '\p{Nv=9.000000000000000e+02}', "");
    Expect(1, 126236, '\p{^Nv=9.000000000000000e+02}', "");
    Expect(1, 126236, '\P{Nv=9.000000000000000e+02}', "");
    Expect(0, 126236, '\P{^Nv=9.000000000000000e+02}', "");
    Error('\p{Is_Numeric_Value:   :=__0000000900}');
    Error('\P{Is_Numeric_Value:   :=__0000000900}');
    Expect(1, 126235, '\p{Is_Numeric_Value=0000900}', "");
    Expect(0, 126235, '\p{^Is_Numeric_Value=0000900}', "");
    Expect(0, 126235, '\P{Is_Numeric_Value=0000900}', "");
    Expect(1, 126235, '\P{^Is_Numeric_Value=0000900}', "");
    Expect(0, 126236, '\p{Is_Numeric_Value=0000900}', "");
    Expect(1, 126236, '\p{^Is_Numeric_Value=0000900}', "");
    Expect(1, 126236, '\P{Is_Numeric_Value=0000900}', "");
    Expect(0, 126236, '\P{^Is_Numeric_Value=0000900}', "");
    Expect(1, 126235, '\p{Is_Numeric_Value=9.000000000000000e+02}', "");
    Expect(0, 126235, '\p{^Is_Numeric_Value=9.000000000000000e+02}', "");
    Expect(0, 126235, '\P{Is_Numeric_Value=9.000000000000000e+02}', "");
    Expect(1, 126235, '\P{^Is_Numeric_Value=9.000000000000000e+02}', "");
    Expect(0, 126236, '\p{Is_Numeric_Value=9.000000000000000e+02}', "");
    Expect(1, 126236, '\p{^Is_Numeric_Value=9.000000000000000e+02}', "");
    Expect(1, 126236, '\P{Is_Numeric_Value=9.000000000000000e+02}', "");
    Expect(0, 126236, '\P{^Is_Numeric_Value=9.000000000000000e+02}', "");
    Error('\p{Is_Nv=-_00000000900:=}');
    Error('\P{Is_Nv=-_00000000900:=}');
    Expect(1, 126235, '\p{Is_Nv=+0000000090_0}', "");
    Expect(0, 126235, '\p{^Is_Nv=+0000000090_0}', "");
    Expect(0, 126235, '\P{Is_Nv=+0000000090_0}', "");
    Expect(1, 126235, '\P{^Is_Nv=+0000000090_0}', "");
    Expect(0, 126236, '\p{Is_Nv=+0000000090_0}', "");
    Expect(1, 126236, '\p{^Is_Nv=+0000000090_0}', "");
    Expect(1, 126236, '\P{Is_Nv=+0000000090_0}', "");
    Expect(0, 126236, '\P{^Is_Nv=+0000000090_0}', "");
    Expect(1, 126235, '\p{Is_Nv:9.000000000000000e+02}', "");
    Expect(0, 126235, '\p{^Is_Nv:9.000000000000000e+02}', "");
    Expect(0, 126235, '\P{Is_Nv:9.000000000000000e+02}', "");
    Expect(1, 126235, '\P{^Is_Nv:9.000000000000000e+02}', "");
    Expect(0, 126236, '\p{Is_Nv:9.000000000000000e+02}', "");
    Expect(1, 126236, '\p{^Is_Nv:9.000000000000000e+02}', "");
    Expect(1, 126236, '\P{Is_Nv:9.000000000000000e+02}', "");
    Expect(0, 126236, '\P{^Is_Nv:9.000000000000000e+02}', "");
    Error('\p{Numeric_Value=:=+0000009000}');
    Error('\P{Numeric_Value=:=+0000009000}');
    Expect(1, 126244, '\p{Numeric_Value=:\A9000\z:}', "");;
    Expect(0, 126245, '\p{Numeric_Value=:\A9000\z:}', "");;
    Expect(1, 126244, '\p{Numeric_Value: 0000000009000}', "");
    Expect(0, 126244, '\p{^Numeric_Value: 0000000009000}', "");
    Expect(0, 126244, '\P{Numeric_Value: 0000000009000}', "");
    Expect(1, 126244, '\P{^Numeric_Value: 0000000009000}', "");
    Expect(0, 126245, '\p{Numeric_Value: 0000000009000}', "");
    Expect(1, 126245, '\p{^Numeric_Value: 0000000009000}', "");
    Expect(1, 126245, '\P{Numeric_Value: 0000000009000}', "");
    Expect(0, 126245, '\P{^Numeric_Value: 0000000009000}', "");
    Expect(1, 126244, '\p{Numeric_Value=9.000000000000000e+03}', "");
    Expect(0, 126244, '\p{^Numeric_Value=9.000000000000000e+03}', "");
    Expect(0, 126244, '\P{Numeric_Value=9.000000000000000e+03}', "");
    Expect(1, 126244, '\P{^Numeric_Value=9.000000000000000e+03}', "");
    Expect(0, 126245, '\p{Numeric_Value=9.000000000000000e+03}', "");
    Expect(1, 126245, '\p{^Numeric_Value=9.000000000000000e+03}', "");
    Expect(1, 126245, '\P{Numeric_Value=9.000000000000000e+03}', "");
    Expect(0, 126245, '\P{^Numeric_Value=9.000000000000000e+03}', "");
    Error('\p{Nv=/a/__00000009000}');
    Error('\P{Nv=/a/__00000009000}');
    Expect(1, 126244, '\p{Nv=:\A9000\z:}', "");;
    Expect(0, 126245, '\p{Nv=:\A9000\z:}', "");;
    Expect(1, 126244, '\p{Nv=0_0_0_0_0_0_9000}', "");
    Expect(0, 126244, '\p{^Nv=0_0_0_0_0_0_9000}', "");
    Expect(0, 126244, '\P{Nv=0_0_0_0_0_0_9000}', "");
    Expect(1, 126244, '\P{^Nv=0_0_0_0_0_0_9000}', "");
    Expect(0, 126245, '\p{Nv=0_0_0_0_0_0_9000}', "");
    Expect(1, 126245, '\p{^Nv=0_0_0_0_0_0_9000}', "");
    Expect(1, 126245, '\P{Nv=0_0_0_0_0_0_9000}', "");
    Expect(0, 126245, '\P{^Nv=0_0_0_0_0_0_9000}', "");
    Expect(1, 126244, '\p{Nv=9.000000000000000e+03}', "");
    Expect(0, 126244, '\p{^Nv=9.000000000000000e+03}', "");
    Expect(0, 126244, '\P{Nv=9.000000000000000e+03}', "");
    Expect(1, 126244, '\P{^Nv=9.000000000000000e+03}', "");
    Expect(0, 126245, '\p{Nv=9.000000000000000e+03}', "");
    Expect(1, 126245, '\p{^Nv=9.000000000000000e+03}', "");
    Expect(1, 126245, '\P{Nv=9.000000000000000e+03}', "");
    Expect(0, 126245, '\P{^Nv=9.000000000000000e+03}', "");
    Error('\p{Is_Numeric_Value=-/a/000000_000900_0}');
    Error('\P{Is_Numeric_Value=-/a/000000_000900_0}');
    Expect(1, 126244, '\p{Is_Numeric_Value=000000009000}', "");
    Expect(0, 126244, '\p{^Is_Numeric_Value=000000009000}', "");
    Expect(0, 126244, '\P{Is_Numeric_Value=000000009000}', "");
    Expect(1, 126244, '\P{^Is_Numeric_Value=000000009000}', "");
    Expect(0, 126245, '\p{Is_Numeric_Value=000000009000}', "");
    Expect(1, 126245, '\p{^Is_Numeric_Value=000000009000}', "");
    Expect(1, 126245, '\P{Is_Numeric_Value=000000009000}', "");
    Expect(0, 126245, '\P{^Is_Numeric_Value=000000009000}', "");
    Expect(1, 126244, '\p{Is_Numeric_Value=9.000000000000000e+03}', "");
    Expect(0, 126244, '\p{^Is_Numeric_Value=9.000000000000000e+03}', "");
    Expect(0, 126244, '\P{Is_Numeric_Value=9.000000000000000e+03}', "");
    Expect(1, 126244, '\P{^Is_Numeric_Value=9.000000000000000e+03}', "");
    Expect(0, 126245, '\p{Is_Numeric_Value=9.000000000000000e+03}', "");
    Expect(1, 126245, '\p{^Is_Numeric_Value=9.000000000000000e+03}', "");
    Expect(1, 126245, '\P{Is_Numeric_Value=9.000000000000000e+03}', "");
    Expect(0, 126245, '\P{^Is_Numeric_Value=9.000000000000000e+03}', "");
    Error('\p{Is_Nv=	09_00_0:=}');
    Error('\P{Is_Nv=	09_00_0:=}');
    Expect(1, 126244, '\p{Is_Nv=000009000}', "");
    Expect(0, 126244, '\p{^Is_Nv=000009000}', "");
    Expect(0, 126244, '\P{Is_Nv=000009000}', "");
    Expect(1, 126244, '\P{^Is_Nv=000009000}', "");
    Expect(0, 126245, '\p{Is_Nv=000009000}', "");
    Expect(1, 126245, '\p{^Is_Nv=000009000}', "");
    Expect(1, 126245, '\P{Is_Nv=000009000}', "");
    Expect(0, 126245, '\P{^Is_Nv=000009000}', "");
    Expect(1, 126244, '\p{Is_Nv=9.000000000000000e+03}', "");
    Expect(0, 126244, '\p{^Is_Nv=9.000000000000000e+03}', "");
    Expect(0, 126244, '\P{Is_Nv=9.000000000000000e+03}', "");
    Expect(1, 126244, '\P{^Is_Nv=9.000000000000000e+03}', "");
    Expect(0, 126245, '\p{Is_Nv=9.000000000000000e+03}', "");
    Expect(1, 126245, '\p{^Is_Nv=9.000000000000000e+03}', "");
    Expect(1, 126245, '\P{Is_Nv=9.000000000000000e+03}', "");
    Expect(0, 126245, '\P{^Is_Nv=9.000000000000000e+03}', "");
    Error('\p{Numeric_Value=/a/_ 00000090000}');
    Error('\P{Numeric_Value=/a/_ 00000090000}');
    Expect(1, 126253, '\p{Numeric_Value=:\A90000\z:}', "");;
    Expect(0, 126254, '\p{Numeric_Value=:\A90000\z:}', "");;
    Expect(1, 126253, '\p{Numeric_Value=+0_0_0_0_0_0_0_0_0_9_0_000}', "");
    Expect(0, 126253, '\p{^Numeric_Value=+0_0_0_0_0_0_0_0_0_9_0_000}', "");
    Expect(0, 126253, '\P{Numeric_Value=+0_0_0_0_0_0_0_0_0_9_0_000}', "");
    Expect(1, 126253, '\P{^Numeric_Value=+0_0_0_0_0_0_0_0_0_9_0_000}', "");
    Expect(0, 126254, '\p{Numeric_Value=+0_0_0_0_0_0_0_0_0_9_0_000}', "");
    Expect(1, 126254, '\p{^Numeric_Value=+0_0_0_0_0_0_0_0_0_9_0_000}', "");
    Expect(1, 126254, '\P{Numeric_Value=+0_0_0_0_0_0_0_0_0_9_0_000}', "");
    Expect(0, 126254, '\P{^Numeric_Value=+0_0_0_0_0_0_0_0_0_9_0_000}', "");
    Expect(1, 126253, '\p{Numeric_Value=9.000000000000000e+04}', "");
    Expect(0, 126253, '\p{^Numeric_Value=9.000000000000000e+04}', "");
    Expect(0, 126253, '\P{Numeric_Value=9.000000000000000e+04}', "");
    Expect(1, 126253, '\P{^Numeric_Value=9.000000000000000e+04}', "");
    Expect(0, 126254, '\p{Numeric_Value=9.000000000000000e+04}', "");
    Expect(1, 126254, '\p{^Numeric_Value=9.000000000000000e+04}', "");
    Expect(1, 126254, '\P{Numeric_Value=9.000000000000000e+04}', "");
    Expect(0, 126254, '\P{^Numeric_Value=9.000000000000000e+04}', "");
    Error('\p{Nv=	/a/+000090000}');
    Error('\P{Nv=	/a/+000090000}');
    Expect(1, 126253, '\p{Nv=:\A90000\z:}', "");;
    Expect(0, 126254, '\p{Nv=:\A90000\z:}', "");;
    Expect(1, 126253, '\p{Nv:   0_0_0_0_0_0_0_0_0_9_0000}', "");
    Expect(0, 126253, '\p{^Nv:   0_0_0_0_0_0_0_0_0_9_0000}', "");
    Expect(0, 126253, '\P{Nv:   0_0_0_0_0_0_0_0_0_9_0000}', "");
    Expect(1, 126253, '\P{^Nv:   0_0_0_0_0_0_0_0_0_9_0000}', "");
    Expect(0, 126254, '\p{Nv:   0_0_0_0_0_0_0_0_0_9_0000}', "");
    Expect(1, 126254, '\p{^Nv:   0_0_0_0_0_0_0_0_0_9_0000}', "");
    Expect(1, 126254, '\P{Nv:   0_0_0_0_0_0_0_0_0_9_0000}', "");
    Expect(0, 126254, '\P{^Nv:   0_0_0_0_0_0_0_0_0_9_0000}', "");
    Expect(1, 126253, '\p{Nv=9.000000000000000e+04}', "");
    Expect(0, 126253, '\p{^Nv=9.000000000000000e+04}', "");
    Expect(0, 126253, '\P{Nv=9.000000000000000e+04}', "");
    Expect(1, 126253, '\P{^Nv=9.000000000000000e+04}', "");
    Expect(0, 126254, '\p{Nv=9.000000000000000e+04}', "");
    Expect(1, 126254, '\p{^Nv=9.000000000000000e+04}', "");
    Expect(1, 126254, '\P{Nv=9.000000000000000e+04}', "");
    Expect(0, 126254, '\P{^Nv=9.000000000000000e+04}', "");
    Error('\p{Is_Numeric_Value=:=	00000090000}');
    Error('\P{Is_Numeric_Value=:=	00000090000}');
    Expect(1, 126253, '\p{Is_Numeric_Value=0_0_0_9_0000}', "");
    Expect(0, 126253, '\p{^Is_Numeric_Value=0_0_0_9_0000}', "");
    Expect(0, 126253, '\P{Is_Numeric_Value=0_0_0_9_0000}', "");
    Expect(1, 126253, '\P{^Is_Numeric_Value=0_0_0_9_0000}', "");
    Expect(0, 126254, '\p{Is_Numeric_Value=0_0_0_9_0000}', "");
    Expect(1, 126254, '\p{^Is_Numeric_Value=0_0_0_9_0000}', "");
    Expect(1, 126254, '\P{Is_Numeric_Value=0_0_0_9_0000}', "");
    Expect(0, 126254, '\P{^Is_Numeric_Value=0_0_0_9_0000}', "");
    Expect(1, 126253, '\p{Is_Numeric_Value=9.000000000000000e+04}', "");
    Expect(0, 126253, '\p{^Is_Numeric_Value=9.000000000000000e+04}', "");
    Expect(0, 126253, '\P{Is_Numeric_Value=9.000000000000000e+04}', "");
    Expect(1, 126253, '\P{^Is_Numeric_Value=9.000000000000000e+04}', "");
    Expect(0, 126254, '\p{Is_Numeric_Value=9.000000000000000e+04}', "");
    Expect(1, 126254, '\p{^Is_Numeric_Value=9.000000000000000e+04}', "");
    Expect(1, 126254, '\P{Is_Numeric_Value=9.000000000000000e+04}', "");
    Expect(0, 126254, '\P{^Is_Numeric_Value=9.000000000000000e+04}', "");
    Error('\p{Is_Nv= _+90000/a/}');
    Error('\P{Is_Nv= _+90000/a/}');
    Expect(1, 126253, '\p{Is_Nv=0090000}', "");
    Expect(0, 126253, '\p{^Is_Nv=0090000}', "");
    Expect(0, 126253, '\P{Is_Nv=0090000}', "");
    Expect(1, 126253, '\P{^Is_Nv=0090000}', "");
    Expect(0, 126254, '\p{Is_Nv=0090000}', "");
    Expect(1, 126254, '\p{^Is_Nv=0090000}', "");
    Expect(1, 126254, '\P{Is_Nv=0090000}', "");
    Expect(0, 126254, '\P{^Is_Nv=0090000}', "");
    Expect(1, 126253, '\p{Is_Nv=9.000000000000000e+04}', "");
    Expect(0, 126253, '\p{^Is_Nv=9.000000000000000e+04}', "");
    Expect(0, 126253, '\P{Is_Nv=9.000000000000000e+04}', "");
    Expect(1, 126253, '\P{^Is_Nv=9.000000000000000e+04}', "");
    Expect(0, 126254, '\p{Is_Nv=9.000000000000000e+04}', "");
    Expect(1, 126254, '\p{^Is_Nv=9.000000000000000e+04}', "");
    Expect(1, 126254, '\P{Is_Nv=9.000000000000000e+04}', "");
    Expect(0, 126254, '\P{^Is_Nv=9.000000000000000e+04}', "");
    Error('\p{Numeric_Value=__+9_0_0_000/a/}');
    Error('\P{Numeric_Value=__+9_0_0_000/a/}');
    Expect(1, 68085, '\p{Numeric_Value=:\A900000\z:}', "");;
    Expect(0, 68086, '\p{Numeric_Value=:\A900000\z:}', "");;
    Expect(1, 68085, '\p{Numeric_Value=00_09_00_00_0}', "");
    Expect(0, 68085, '\p{^Numeric_Value=00_09_00_00_0}', "");
    Expect(0, 68085, '\P{Numeric_Value=00_09_00_00_0}', "");
    Expect(1, 68085, '\P{^Numeric_Value=00_09_00_00_0}', "");
    Expect(0, 68086, '\p{Numeric_Value=00_09_00_00_0}', "");
    Expect(1, 68086, '\p{^Numeric_Value=00_09_00_00_0}', "");
    Expect(1, 68086, '\P{Numeric_Value=00_09_00_00_0}', "");
    Expect(0, 68086, '\P{^Numeric_Value=00_09_00_00_0}', "");
    Expect(1, 68085, '\p{Numeric_Value=9.000000000000000e+05}', "");
    Expect(0, 68085, '\p{^Numeric_Value=9.000000000000000e+05}', "");
    Expect(0, 68085, '\P{Numeric_Value=9.000000000000000e+05}', "");
    Expect(1, 68085, '\P{^Numeric_Value=9.000000000000000e+05}', "");
    Expect(0, 68086, '\p{Numeric_Value=9.000000000000000e+05}', "");
    Expect(1, 68086, '\p{^Numeric_Value=9.000000000000000e+05}', "");
    Expect(1, 68086, '\P{Numeric_Value=9.000000000000000e+05}', "");
    Expect(0, 68086, '\P{^Numeric_Value=9.000000000000000e+05}', "");
    Error('\p{Nv=-900000/a/}');
    Error('\P{Nv=-900000/a/}');
    Expect(1, 68085, '\p{Nv=:\A900000\z:}', "");;
    Expect(0, 68086, '\p{Nv=:\A900000\z:}', "");;
    Expect(1, 68085, '\p{Nv=00000000900000}', "");
    Expect(0, 68085, '\p{^Nv=00000000900000}', "");
    Expect(0, 68085, '\P{Nv=00000000900000}', "");
    Expect(1, 68085, '\P{^Nv=00000000900000}', "");
    Expect(0, 68086, '\p{Nv=00000000900000}', "");
    Expect(1, 68086, '\p{^Nv=00000000900000}', "");
    Expect(1, 68086, '\P{Nv=00000000900000}', "");
    Expect(0, 68086, '\P{^Nv=00000000900000}', "");
    Expect(1, 68085, '\p{Nv=9.000000000000000e+05}', "");
    Expect(0, 68085, '\p{^Nv=9.000000000000000e+05}', "");
    Expect(0, 68085, '\P{Nv=9.000000000000000e+05}', "");
    Expect(1, 68085, '\P{^Nv=9.000000000000000e+05}', "");
    Expect(0, 68086, '\p{Nv=9.000000000000000e+05}', "");
    Expect(1, 68086, '\p{^Nv=9.000000000000000e+05}', "");
    Expect(1, 68086, '\P{Nv=9.000000000000000e+05}', "");
    Expect(0, 68086, '\P{^Nv=9.000000000000000e+05}', "");
    Error('\p{Is_Numeric_Value=/a/ 00000000900000}');
    Error('\P{Is_Numeric_Value=/a/ 00000000900000}');
    Expect(1, 68085, '\p{Is_Numeric_Value=00900000}', "");
    Expect(0, 68085, '\p{^Is_Numeric_Value=00900000}', "");
    Expect(0, 68085, '\P{Is_Numeric_Value=00900000}', "");
    Expect(1, 68085, '\P{^Is_Numeric_Value=00900000}', "");
    Expect(0, 68086, '\p{Is_Numeric_Value=00900000}', "");
    Expect(1, 68086, '\p{^Is_Numeric_Value=00900000}', "");
    Expect(1, 68086, '\P{Is_Numeric_Value=00900000}', "");
    Expect(0, 68086, '\P{^Is_Numeric_Value=00900000}', "");
    Expect(1, 68085, '\p{Is_Numeric_Value=9.000000000000000e+05}', "");
    Expect(0, 68085, '\p{^Is_Numeric_Value=9.000000000000000e+05}', "");
    Expect(0, 68085, '\P{Is_Numeric_Value=9.000000000000000e+05}', "");
    Expect(1, 68085, '\P{^Is_Numeric_Value=9.000000000000000e+05}', "");
    Expect(0, 68086, '\p{Is_Numeric_Value=9.000000000000000e+05}', "");
    Expect(1, 68086, '\p{^Is_Numeric_Value=9.000000000000000e+05}', "");
    Expect(1, 68086, '\P{Is_Numeric_Value=9.000000000000000e+05}', "");
    Expect(0, 68086, '\P{^Is_Numeric_Value=9.000000000000000e+05}', "");
    Error('\p{Is_Nv=:=_	0900000}');
    Error('\P{Is_Nv=:=_	0900000}');
    Expect(1, 68085, '\p{Is_Nv=00000000900000}', "");
    Expect(0, 68085, '\p{^Is_Nv=00000000900000}', "");
    Expect(0, 68085, '\P{Is_Nv=00000000900000}', "");
    Expect(1, 68085, '\P{^Is_Nv=00000000900000}', "");
    Expect(0, 68086, '\p{Is_Nv=00000000900000}', "");
    Expect(1, 68086, '\p{^Is_Nv=00000000900000}', "");
    Expect(1, 68086, '\P{Is_Nv=00000000900000}', "");
    Expect(0, 68086, '\P{^Is_Nv=00000000900000}', "");
    Expect(1, 68085, '\p{Is_Nv=9.000000000000000e+05}', "");
    Expect(0, 68085, '\p{^Is_Nv=9.000000000000000e+05}', "");
    Expect(0, 68085, '\P{Is_Nv=9.000000000000000e+05}', "");
    Expect(1, 68085, '\P{^Is_Nv=9.000000000000000e+05}', "");
    Expect(0, 68086, '\p{Is_Nv=9.000000000000000e+05}', "");
    Expect(1, 68086, '\p{^Is_Nv=9.000000000000000e+05}', "");
    Expect(1, 68086, '\P{Is_Nv=9.000000000000000e+05}', "");
    Expect(0, 68086, '\P{^Is_Nv=9.000000000000000e+05}', "");
    Error('\p{Numeric_Value=-/a/NaN}');
    Error('\P{Numeric_Value=-/a/NaN}');
    Expect(1, 194705, '\p{Numeric_Value=:\ANaN\z:}', "");;
    Expect(0, 194704, '\p{Numeric_Value=:\ANaN\z:}', "");;
    Expect(1, 194705, '\p{Numeric_Value=nan}', "");
    Expect(0, 194705, '\p{^Numeric_Value=nan}', "");
    Expect(0, 194705, '\P{Numeric_Value=nan}', "");
    Expect(1, 194705, '\P{^Numeric_Value=nan}', "");
    Expect(0, 194704, '\p{Numeric_Value=nan}', "");
    Expect(1, 194704, '\p{^Numeric_Value=nan}', "");
    Expect(1, 194704, '\P{Numeric_Value=nan}', "");
    Expect(0, 194704, '\P{^Numeric_Value=nan}', "");
    Expect(1, 194705, '\p{Numeric_Value=:\Anan\z:}', "");;
    Expect(0, 194704, '\p{Numeric_Value=:\Anan\z:}', "");;
    Expect(1, 194705, '\p{Numeric_Value= nan}', "");
    Expect(0, 194705, '\p{^Numeric_Value= nan}', "");
    Expect(0, 194705, '\P{Numeric_Value= nan}', "");
    Expect(1, 194705, '\P{^Numeric_Value= nan}', "");
    Expect(0, 194704, '\p{Numeric_Value= nan}', "");
    Expect(1, 194704, '\p{^Numeric_Value= nan}', "");
    Expect(1, 194704, '\P{Numeric_Value= nan}', "");
    Expect(0, 194704, '\P{^Numeric_Value= nan}', "");
    Expect(1, 194705, '\p{Numeric_Value=NaN}', "");
    Expect(0, 194705, '\p{^Numeric_Value=NaN}', "");
    Expect(0, 194705, '\P{Numeric_Value=NaN}', "");
    Expect(1, 194705, '\P{^Numeric_Value=NaN}', "");
    Expect(0, 194704, '\p{Numeric_Value=NaN}', "");
    Expect(1, 194704, '\p{^Numeric_Value=NaN}', "");
    Expect(1, 194704, '\P{Numeric_Value=NaN}', "");
    Expect(0, 194704, '\P{^Numeric_Value=NaN}', "");
    Error('\p{Nv=/a/_nan}');
    Error('\P{Nv=/a/_nan}');
    Expect(1, 194705, '\p{Nv=:\ANaN\z:}', "");;
    Expect(0, 194704, '\p{Nv=:\ANaN\z:}', "");;
    Expect(1, 194705, '\p{Nv=nan}', "");
    Expect(0, 194705, '\p{^Nv=nan}', "");
    Expect(0, 194705, '\P{Nv=nan}', "");
    Expect(1, 194705, '\P{^Nv=nan}', "");
    Expect(0, 194704, '\p{Nv=nan}', "");
    Expect(1, 194704, '\p{^Nv=nan}', "");
    Expect(1, 194704, '\P{Nv=nan}', "");
    Expect(0, 194704, '\P{^Nv=nan}', "");
    Expect(1, 194705, '\p{Nv=:\Anan\z:}', "");;
    Expect(0, 194704, '\p{Nv=:\Anan\z:}', "");;
    Expect(1, 194705, '\p{Nv= -NaN}', "");
    Expect(0, 194705, '\p{^Nv= -NaN}', "");
    Expect(0, 194705, '\P{Nv= -NaN}', "");
    Expect(1, 194705, '\P{^Nv= -NaN}', "");
    Expect(0, 194704, '\p{Nv= -NaN}', "");
    Expect(1, 194704, '\p{^Nv= -NaN}', "");
    Expect(1, 194704, '\P{Nv= -NaN}', "");
    Expect(0, 194704, '\P{^Nv= -NaN}', "");
    Expect(1, 194705, '\p{Nv=NaN}', "");
    Expect(0, 194705, '\p{^Nv=NaN}', "");
    Expect(0, 194705, '\P{Nv=NaN}', "");
    Expect(1, 194705, '\P{^Nv=NaN}', "");
    Expect(0, 194704, '\p{Nv=NaN}', "");
    Expect(1, 194704, '\p{^Nv=NaN}', "");
    Expect(1, 194704, '\P{Nv=NaN}', "");
    Expect(0, 194704, '\P{^Nv=NaN}', "");
    Error('\p{Is_Numeric_Value= 	NaN:=}');
    Error('\P{Is_Numeric_Value= 	NaN:=}');
    Expect(1, 194705, '\p{Is_Numeric_Value=nan}', "");
    Expect(0, 194705, '\p{^Is_Numeric_Value=nan}', "");
    Expect(0, 194705, '\P{Is_Numeric_Value=nan}', "");
    Expect(1, 194705, '\P{^Is_Numeric_Value=nan}', "");
    Expect(0, 194704, '\p{Is_Numeric_Value=nan}', "");
    Expect(1, 194704, '\p{^Is_Numeric_Value=nan}', "");
    Expect(1, 194704, '\P{Is_Numeric_Value=nan}', "");
    Expect(0, 194704, '\P{^Is_Numeric_Value=nan}', "");
    Expect(1, 194705, '\p{Is_Numeric_Value= -NaN}', "");
    Expect(0, 194705, '\p{^Is_Numeric_Value= -NaN}', "");
    Expect(0, 194705, '\P{Is_Numeric_Value= -NaN}', "");
    Expect(1, 194705, '\P{^Is_Numeric_Value= -NaN}', "");
    Expect(0, 194704, '\p{Is_Numeric_Value= -NaN}', "");
    Expect(1, 194704, '\p{^Is_Numeric_Value= -NaN}', "");
    Expect(1, 194704, '\P{Is_Numeric_Value= -NaN}', "");
    Expect(0, 194704, '\P{^Is_Numeric_Value= -NaN}', "");
    Expect(1, 194705, '\p{Is_Numeric_Value=NaN}', "");
    Expect(0, 194705, '\p{^Is_Numeric_Value=NaN}', "");
    Expect(0, 194705, '\P{Is_Numeric_Value=NaN}', "");
    Expect(1, 194705, '\P{^Is_Numeric_Value=NaN}', "");
    Expect(0, 194704, '\p{Is_Numeric_Value=NaN}', "");
    Expect(1, 194704, '\p{^Is_Numeric_Value=NaN}', "");
    Expect(1, 194704, '\P{Is_Numeric_Value=NaN}', "");
    Expect(0, 194704, '\P{^Is_Numeric_Value=NaN}', "");
    Error('\p{Is_Nv=	NaN/a/}');
    Error('\P{Is_Nv=	NaN/a/}');
    Expect(1, 194705, '\p{Is_Nv=nan}', "");
    Expect(0, 194705, '\p{^Is_Nv=nan}', "");
    Expect(0, 194705, '\P{Is_Nv=nan}', "");
    Expect(1, 194705, '\P{^Is_Nv=nan}', "");
    Expect(0, 194704, '\p{Is_Nv=nan}', "");
    Expect(1, 194704, '\p{^Is_Nv=nan}', "");
    Expect(1, 194704, '\P{Is_Nv=nan}', "");
    Expect(0, 194704, '\P{^Is_Nv=nan}', "");
    Expect(1, 194705, '\p{Is_Nv= 	NaN}', "");
    Expect(0, 194705, '\p{^Is_Nv= 	NaN}', "");
    Expect(0, 194705, '\P{Is_Nv= 	NaN}', "");
    Expect(1, 194705, '\P{^Is_Nv= 	NaN}', "");
    Expect(0, 194704, '\p{Is_Nv= 	NaN}', "");
    Expect(1, 194704, '\p{^Is_Nv= 	NaN}', "");
    Expect(1, 194704, '\P{Is_Nv= 	NaN}', "");
    Expect(0, 194704, '\P{^Is_Nv= 	NaN}', "");
    Expect(1, 194705, '\p{Is_Nv=NaN}', "");
    Expect(0, 194705, '\p{^Is_Nv=NaN}', "");
    Expect(0, 194705, '\P{Is_Nv=NaN}', "");
    Expect(1, 194705, '\P{^Is_Nv=NaN}', "");
    Expect(0, 194704, '\p{Is_Nv=NaN}', "");
    Expect(1, 194704, '\p{^Is_Nv=NaN}', "");
    Expect(1, 194704, '\P{Is_Nv=NaN}', "");
    Expect(0, 194704, '\P{^Is_Nv=NaN}', "");
    Error('\p{Other_Alphabetic:No}');
    Error('\P{Other_Alphabetic:No}');
    Error('\p{OAlpha=N}');
    Error('\P{OAlpha=N}');
    Error('\p{Is_Other_Alphabetic=F}');
    Error('\P{Is_Other_Alphabetic=F}');
    Error('\p{Is_OAlpha:	False}');
    Error('\P{Is_OAlpha:	False}');
    Error('\p{Other_Alphabetic=Yes}');
    Error('\P{Other_Alphabetic=Yes}');
    Error('\p{OAlpha=Y}');
    Error('\P{OAlpha=Y}');
    Error('\p{Is_Other_Alphabetic=T}');
    Error('\P{Is_Other_Alphabetic=T}');
    Error('\p{Is_OAlpha=True}');
    Error('\P{Is_OAlpha=True}');
    Error('\p{Other_Default_Ignorable_Code_Point=No}');
    Error('\P{Other_Default_Ignorable_Code_Point=No}');
    Error('\p{ODI=N}');
    Error('\P{ODI=N}');
    Error('\p{Is_Other_Default_Ignorable_Code_Point:   F}');
    Error('\P{Is_Other_Default_Ignorable_Code_Point:   F}');
    Error('\p{Is_ODI=False}');
    Error('\P{Is_ODI=False}');
    Error('\p{Other_Default_Ignorable_Code_Point: Yes}');
    Error('\P{Other_Default_Ignorable_Code_Point: Yes}');
    Error('\p{ODI=Y}');
    Error('\P{ODI=Y}');
    Error('\p{Is_Other_Default_Ignorable_Code_Point=T}');
    Error('\P{Is_Other_Default_Ignorable_Code_Point=T}');
    Error('\p{Is_ODI=True}');
    Error('\P{Is_ODI=True}');
    Error('\p{Other_Grapheme_Extend=No}');
    Error('\P{Other_Grapheme_Extend=No}');
    Error('\p{OGr_Ext=N}');
    Error('\P{OGr_Ext=N}');
    Error('\p{Is_Other_Grapheme_Extend=F}');
    Error('\P{Is_Other_Grapheme_Extend=F}');
    Error('\p{Is_OGr_Ext=False}');
    Error('\P{Is_OGr_Ext=False}');
    Error('\p{Other_Grapheme_Extend:	Yes}');
    Error('\P{Other_Grapheme_Extend:	Yes}');
    Error('\p{OGr_Ext=Y}');
    Error('\P{OGr_Ext=Y}');
    Error('\p{Is_Other_Grapheme_Extend=T}');
    Error('\P{Is_Other_Grapheme_Extend=T}');
    Error('\p{Is_OGr_Ext=True}');
    Error('\P{Is_OGr_Ext=True}');
    Error('\p{Other_ID_Continue:	No}');
    Error('\P{Other_ID_Continue:	No}');
    Error('\p{OIDC=N}');
    Error('\P{OIDC=N}');
    Error('\p{Is_Other_ID_Continue:   F}');
    Error('\P{Is_Other_ID_Continue:   F}');
    Error('\p{Is_OIDC=False}');
    Error('\P{Is_OIDC=False}');
    Error('\p{Other_ID_Continue: Yes}');
    Error('\P{Other_ID_Continue: Yes}');
    Error('\p{OIDC=Y}');
    Error('\P{OIDC=Y}');
    Error('\p{Is_Other_ID_Continue=T}');
    Error('\P{Is_Other_ID_Continue=T}');
    Error('\p{Is_OIDC=True}');
    Error('\P{Is_OIDC=True}');
    Error('\p{Other_ID_Start=No}');
    Error('\P{Other_ID_Start=No}');
    Error('\p{OIDS=N}');
    Error('\P{OIDS=N}');
    Error('\p{Is_Other_ID_Start=F}');
    Error('\P{Is_Other_ID_Start=F}');
    Error('\p{Is_OIDS:   False}');
    Error('\P{Is_OIDS:   False}');
    Error('\p{Other_ID_Start=Yes}');
    Error('\P{Other_ID_Start=Yes}');
    Error('\p{OIDS=Y}');
    Error('\P{OIDS=Y}');
    Error('\p{Is_Other_ID_Start=T}');
    Error('\P{Is_Other_ID_Start=T}');
    Error('\p{Is_OIDS=True}');
    Error('\P{Is_OIDS=True}');
    Error('\p{Other_Lowercase=No}');
    Error('\P{Other_Lowercase=No}');
    Error('\p{OLower=N}');
    Error('\P{OLower=N}');
    Error('\p{Is_Other_Lowercase=F}');
    Error('\P{Is_Other_Lowercase=F}');
    Error('\p{Is_OLower=False}');
    Error('\P{Is_OLower=False}');
    Error('\p{Other_Lowercase=Yes}');
    Error('\P{Other_Lowercase=Yes}');
    Error('\p{OLower=Y}');
    Error('\P{OLower=Y}');
    Error('\p{Is_Other_Lowercase=T}');
    Error('\P{Is_Other_Lowercase=T}');
    Error('\p{Is_OLower=True}');
    Error('\P{Is_OLower=True}');
    Error('\p{Other_Math=No}');
    Error('\P{Other_Math=No}');
    Error('\p{OMath:   N}');
    Error('\P{OMath:   N}');
    Error('\p{Is_Other_Math=F}');
    Error('\P{Is_Other_Math=F}');
    Error('\p{Is_OMath=False}');
    Error('\P{Is_OMath=False}');
    Error('\p{Other_Math=Yes}');
    Error('\P{Other_Math=Yes}');
    Error('\p{OMath=Y}');
    Error('\P{OMath=Y}');
    Error('\p{Is_Other_Math=T}');
    Error('\P{Is_Other_Math=T}');
    Error('\p{Is_OMath=True}');
    Error('\P{Is_OMath=True}');
    Error('\p{Other_Uppercase=No}');
    Error('\P{Other_Uppercase=No}');
    Error('\p{OUpper=N}');
    Error('\P{OUpper=N}');
    Error('\p{Is_Other_Uppercase=F}');
    Error('\P{Is_Other_Uppercase=F}');
    Error('\p{Is_OUpper:   False}');
    Error('\P{Is_OUpper:   False}');
    Error('\p{Other_Uppercase=Yes}');
    Error('\P{Other_Uppercase=Yes}');
    Error('\p{OUpper=Y}');
    Error('\P{OUpper=Y}');
    Error('\p{Is_Other_Uppercase=T}');
    Error('\P{Is_Other_Uppercase=T}');
    Error('\p{Is_OUpper=True}');
    Error('\P{Is_OUpper=True}');
    Error('\p{Pattern_Syntax= /a/No}');
    Error('\P{Pattern_Syntax= /a/No}');
    Expect(1, 65095, '\p{Pattern_Syntax=:\ANo\z:}', "");;
    Expect(0, 65094, '\p{Pattern_Syntax=:\ANo\z:}', "");;
    Expect(1, 65095, '\p{Pattern_Syntax=no}', "");
    Expect(0, 65095, '\p{^Pattern_Syntax=no}', "");
    Expect(0, 65095, '\P{Pattern_Syntax=no}', "");
    Expect(1, 65095, '\P{^Pattern_Syntax=no}', "");
    Expect(0, 65094, '\p{Pattern_Syntax=no}', "");
    Expect(1, 65094, '\p{^Pattern_Syntax=no}', "");
    Expect(1, 65094, '\P{Pattern_Syntax=no}', "");
    Expect(0, 65094, '\P{^Pattern_Syntax=no}', "");
    Expect(1, 65095, '\p{Pattern_Syntax=:\Ano\z:}', "");;
    Expect(0, 65094, '\p{Pattern_Syntax=:\Ano\z:}', "");;
    Expect(1, 65095, '\p{Pattern_Syntax=	_No}', "");
    Expect(0, 65095, '\p{^Pattern_Syntax=	_No}', "");
    Expect(0, 65095, '\P{Pattern_Syntax=	_No}', "");
    Expect(1, 65095, '\P{^Pattern_Syntax=	_No}', "");
    Expect(0, 65094, '\p{Pattern_Syntax=	_No}', "");
    Expect(1, 65094, '\p{^Pattern_Syntax=	_No}', "");
    Expect(1, 65094, '\P{Pattern_Syntax=	_No}', "");
    Expect(0, 65094, '\P{^Pattern_Syntax=	_No}', "");
    Error('\p{Pat_Syn=	/a/N}');
    Error('\P{Pat_Syn=	/a/N}');
    Expect(1, 65095, '\p{Pat_Syn=:\AN\z:}', "");;
    Expect(0, 65094, '\p{Pat_Syn=:\AN\z:}', "");;
    Expect(1, 65095, '\p{Pat_Syn:   n}', "");
    Expect(0, 65095, '\p{^Pat_Syn:   n}', "");
    Expect(0, 65095, '\P{Pat_Syn:   n}', "");
    Expect(1, 65095, '\P{^Pat_Syn:   n}', "");
    Expect(0, 65094, '\p{Pat_Syn:   n}', "");
    Expect(1, 65094, '\p{^Pat_Syn:   n}', "");
    Expect(1, 65094, '\P{Pat_Syn:   n}', "");
    Expect(0, 65094, '\P{^Pat_Syn:   n}', "");
    Expect(1, 65095, '\p{Pat_Syn=:\An\z:}', "");;
    Expect(0, 65094, '\p{Pat_Syn=:\An\z:}', "");;
    Expect(1, 65095, '\p{Pat_Syn=--N}', "");
    Expect(0, 65095, '\p{^Pat_Syn=--N}', "");
    Expect(0, 65095, '\P{Pat_Syn=--N}', "");
    Expect(1, 65095, '\P{^Pat_Syn=--N}', "");
    Expect(0, 65094, '\p{Pat_Syn=--N}', "");
    Expect(1, 65094, '\p{^Pat_Syn=--N}', "");
    Expect(1, 65094, '\P{Pat_Syn=--N}', "");
    Expect(0, 65094, '\P{^Pat_Syn=--N}', "");
    Error('\p{Is_Pattern_Syntax=/a/__F}');
    Error('\P{Is_Pattern_Syntax=/a/__F}');
    Expect(1, 65095, '\p{Is_Pattern_Syntax:	f}', "");
    Expect(0, 65095, '\p{^Is_Pattern_Syntax:	f}', "");
    Expect(0, 65095, '\P{Is_Pattern_Syntax:	f}', "");
    Expect(1, 65095, '\P{^Is_Pattern_Syntax:	f}', "");
    Expect(0, 65094, '\p{Is_Pattern_Syntax:	f}', "");
    Expect(1, 65094, '\p{^Is_Pattern_Syntax:	f}', "");
    Expect(1, 65094, '\P{Is_Pattern_Syntax:	f}', "");
    Expect(0, 65094, '\P{^Is_Pattern_Syntax:	f}', "");
    Expect(1, 65095, '\p{Is_Pattern_Syntax=	F}', "");
    Expect(0, 65095, '\p{^Is_Pattern_Syntax=	F}', "");
    Expect(0, 65095, '\P{Is_Pattern_Syntax=	F}', "");
    Expect(1, 65095, '\P{^Is_Pattern_Syntax=	F}', "");
    Expect(0, 65094, '\p{Is_Pattern_Syntax=	F}', "");
    Expect(1, 65094, '\p{^Is_Pattern_Syntax=	F}', "");
    Expect(1, 65094, '\P{Is_Pattern_Syntax=	F}', "");
    Expect(0, 65094, '\P{^Is_Pattern_Syntax=	F}', "");
    Error('\p{Is_Pat_Syn= /a/FALSE}');
    Error('\P{Is_Pat_Syn= /a/FALSE}');
    Expect(1, 65095, '\p{Is_Pat_Syn=false}', "");
    Expect(0, 65095, '\p{^Is_Pat_Syn=false}', "");
    Expect(0, 65095, '\P{Is_Pat_Syn=false}', "");
    Expect(1, 65095, '\P{^Is_Pat_Syn=false}', "");
    Expect(0, 65094, '\p{Is_Pat_Syn=false}', "");
    Expect(1, 65094, '\p{^Is_Pat_Syn=false}', "");
    Expect(1, 65094, '\P{Is_Pat_Syn=false}', "");
    Expect(0, 65094, '\P{^Is_Pat_Syn=false}', "");
    Expect(1, 65095, '\p{Is_Pat_Syn= 	false}', "");
    Expect(0, 65095, '\p{^Is_Pat_Syn= 	false}', "");
    Expect(0, 65095, '\P{Is_Pat_Syn= 	false}', "");
    Expect(1, 65095, '\P{^Is_Pat_Syn= 	false}', "");
    Expect(0, 65094, '\p{Is_Pat_Syn= 	false}', "");
    Expect(1, 65094, '\p{^Is_Pat_Syn= 	false}', "");
    Expect(1, 65094, '\P{Is_Pat_Syn= 	false}', "");
    Expect(0, 65094, '\P{^Is_Pat_Syn= 	false}', "");
    Error('\p{Pattern_Syntax=-:=yes}');
    Error('\P{Pattern_Syntax=-:=yes}');
    Expect(1, 65094, '\p{Pattern_Syntax=:\AYes\z:}', "");;
    Expect(0, 65095, '\p{Pattern_Syntax=:\AYes\z:}', "");;
    Expect(1, 65094, '\p{Pattern_Syntax=yes}', "");
    Expect(0, 65094, '\p{^Pattern_Syntax=yes}', "");
    Expect(0, 65094, '\P{Pattern_Syntax=yes}', "");
    Expect(1, 65094, '\P{^Pattern_Syntax=yes}', "");
    Expect(0, 65095, '\p{Pattern_Syntax=yes}', "");
    Expect(1, 65095, '\p{^Pattern_Syntax=yes}', "");
    Expect(1, 65095, '\P{Pattern_Syntax=yes}', "");
    Expect(0, 65095, '\P{^Pattern_Syntax=yes}', "");
    Expect(1, 65094, '\p{Pattern_Syntax=:\Ayes\z:}', "");;
    Expect(0, 65095, '\p{Pattern_Syntax=:\Ayes\z:}', "");;
    Expect(1, 65094, '\p{Pattern_Syntax=-YES}', "");
    Expect(0, 65094, '\p{^Pattern_Syntax=-YES}', "");
    Expect(0, 65094, '\P{Pattern_Syntax=-YES}', "");
    Expect(1, 65094, '\P{^Pattern_Syntax=-YES}', "");
    Expect(0, 65095, '\p{Pattern_Syntax=-YES}', "");
    Expect(1, 65095, '\p{^Pattern_Syntax=-YES}', "");
    Expect(1, 65095, '\P{Pattern_Syntax=-YES}', "");
    Expect(0, 65095, '\P{^Pattern_Syntax=-YES}', "");
    Error('\p{Pat_Syn=_Y/a/}');
    Error('\P{Pat_Syn=_Y/a/}');
    Expect(1, 65094, '\p{Pat_Syn=:\AY\z:}', "");;
    Expect(0, 65095, '\p{Pat_Syn=:\AY\z:}', "");;
    Expect(1, 65094, '\p{Pat_Syn=y}', "");
    Expect(0, 65094, '\p{^Pat_Syn=y}', "");
    Expect(0, 65094, '\P{Pat_Syn=y}', "");
    Expect(1, 65094, '\P{^Pat_Syn=y}', "");
    Expect(0, 65095, '\p{Pat_Syn=y}', "");
    Expect(1, 65095, '\p{^Pat_Syn=y}', "");
    Expect(1, 65095, '\P{Pat_Syn=y}', "");
    Expect(0, 65095, '\P{^Pat_Syn=y}', "");
    Expect(1, 65094, '\p{Pat_Syn=:\Ay\z:}', "");;
    Expect(0, 65095, '\p{Pat_Syn=:\Ay\z:}', "");;
    Expect(1, 65094, '\p{Pat_Syn=	Y}', "");
    Expect(0, 65094, '\p{^Pat_Syn=	Y}', "");
    Expect(0, 65094, '\P{Pat_Syn=	Y}', "");
    Expect(1, 65094, '\P{^Pat_Syn=	Y}', "");
    Expect(0, 65095, '\p{Pat_Syn=	Y}', "");
    Expect(1, 65095, '\p{^Pat_Syn=	Y}', "");
    Expect(1, 65095, '\P{Pat_Syn=	Y}', "");
    Expect(0, 65095, '\P{^Pat_Syn=	Y}', "");
    Error('\p{Is_Pattern_Syntax=:=_T}');
    Error('\P{Is_Pattern_Syntax=:=_T}');
    Expect(1, 65094, '\p{Is_Pattern_Syntax=t}', "");
    Expect(0, 65094, '\p{^Is_Pattern_Syntax=t}', "");
    Expect(0, 65094, '\P{Is_Pattern_Syntax=t}', "");
    Expect(1, 65094, '\P{^Is_Pattern_Syntax=t}', "");
    Expect(0, 65095, '\p{Is_Pattern_Syntax=t}', "");
    Expect(1, 65095, '\p{^Is_Pattern_Syntax=t}', "");
    Expect(1, 65095, '\P{Is_Pattern_Syntax=t}', "");
    Expect(0, 65095, '\P{^Is_Pattern_Syntax=t}', "");
    Expect(1, 65094, '\p{Is_Pattern_Syntax=-T}', "");
    Expect(0, 65094, '\p{^Is_Pattern_Syntax=-T}', "");
    Expect(0, 65094, '\P{Is_Pattern_Syntax=-T}', "");
    Expect(1, 65094, '\P{^Is_Pattern_Syntax=-T}', "");
    Expect(0, 65095, '\p{Is_Pattern_Syntax=-T}', "");
    Expect(1, 65095, '\p{^Is_Pattern_Syntax=-T}', "");
    Expect(1, 65095, '\P{Is_Pattern_Syntax=-T}', "");
    Expect(0, 65095, '\P{^Is_Pattern_Syntax=-T}', "");
    Error('\p{Is_Pat_Syn=:=	TRUE}');
    Error('\P{Is_Pat_Syn=:=	TRUE}');
    Expect(1, 65094, '\p{Is_Pat_Syn=true}', "");
    Expect(0, 65094, '\p{^Is_Pat_Syn=true}', "");
    Expect(0, 65094, '\P{Is_Pat_Syn=true}', "");
    Expect(1, 65094, '\P{^Is_Pat_Syn=true}', "");
    Expect(0, 65095, '\p{Is_Pat_Syn=true}', "");
    Expect(1, 65095, '\p{^Is_Pat_Syn=true}', "");
    Expect(1, 65095, '\P{Is_Pat_Syn=true}', "");
    Expect(0, 65095, '\P{^Is_Pat_Syn=true}', "");
    Expect(1, 65094, '\p{Is_Pat_Syn=--True}', "");
    Expect(0, 65094, '\p{^Is_Pat_Syn=--True}', "");
    Expect(0, 65094, '\P{Is_Pat_Syn=--True}', "");
    Expect(1, 65094, '\P{^Is_Pat_Syn=--True}', "");
    Expect(0, 65095, '\p{Is_Pat_Syn=--True}', "");
    Expect(1, 65095, '\p{^Is_Pat_Syn=--True}', "");
    Expect(1, 65095, '\P{Is_Pat_Syn=--True}', "");
    Expect(0, 65095, '\P{^Is_Pat_Syn=--True}', "");
    Error('\p{Pattern_White_Space=_:=No}');
    Error('\P{Pattern_White_Space=_:=No}');
    Expect(1, 8234, '\p{Pattern_White_Space=:\ANo\z:}', "");;
    Expect(0, 8233, '\p{Pattern_White_Space=:\ANo\z:}', "");;
    Expect(1, 8234, '\p{Pattern_White_Space=no}', "");
    Expect(0, 8234, '\p{^Pattern_White_Space=no}', "");
    Expect(0, 8234, '\P{Pattern_White_Space=no}', "");
    Expect(1, 8234, '\P{^Pattern_White_Space=no}', "");
    Expect(0, 8233, '\p{Pattern_White_Space=no}', "");
    Expect(1, 8233, '\p{^Pattern_White_Space=no}', "");
    Expect(1, 8233, '\P{Pattern_White_Space=no}', "");
    Expect(0, 8233, '\P{^Pattern_White_Space=no}', "");
    Expect(1, 8234, '\p{Pattern_White_Space=:\Ano\z:}', "");;
    Expect(0, 8233, '\p{Pattern_White_Space=:\Ano\z:}', "");;
    Expect(1, 8234, '\p{Pattern_White_Space:_-NO}', "");
    Expect(0, 8234, '\p{^Pattern_White_Space:_-NO}', "");
    Expect(0, 8234, '\P{Pattern_White_Space:_-NO}', "");
    Expect(1, 8234, '\P{^Pattern_White_Space:_-NO}', "");
    Expect(0, 8233, '\p{Pattern_White_Space:_-NO}', "");
    Expect(1, 8233, '\p{^Pattern_White_Space:_-NO}', "");
    Expect(1, 8233, '\P{Pattern_White_Space:_-NO}', "");
    Expect(0, 8233, '\P{^Pattern_White_Space:_-NO}', "");
    Error('\p{Pat_WS=:=	 N}');
    Error('\P{Pat_WS=:=	 N}');
    Expect(1, 8234, '\p{Pat_WS=:\AN\z:}', "");;
    Expect(0, 8233, '\p{Pat_WS=:\AN\z:}', "");;
    Expect(1, 8234, '\p{Pat_WS=n}', "");
    Expect(0, 8234, '\p{^Pat_WS=n}', "");
    Expect(0, 8234, '\P{Pat_WS=n}', "");
    Expect(1, 8234, '\P{^Pat_WS=n}', "");
    Expect(0, 8233, '\p{Pat_WS=n}', "");
    Expect(1, 8233, '\p{^Pat_WS=n}', "");
    Expect(1, 8233, '\P{Pat_WS=n}', "");
    Expect(0, 8233, '\P{^Pat_WS=n}', "");
    Expect(1, 8234, '\p{Pat_WS=:\An\z:}', "");;
    Expect(0, 8233, '\p{Pat_WS=:\An\z:}', "");;
    Expect(1, 8234, '\p{Pat_WS=_	N}', "");
    Expect(0, 8234, '\p{^Pat_WS=_	N}', "");
    Expect(0, 8234, '\P{Pat_WS=_	N}', "");
    Expect(1, 8234, '\P{^Pat_WS=_	N}', "");
    Expect(0, 8233, '\p{Pat_WS=_	N}', "");
    Expect(1, 8233, '\p{^Pat_WS=_	N}', "");
    Expect(1, 8233, '\P{Pat_WS=_	N}', "");
    Expect(0, 8233, '\P{^Pat_WS=_	N}', "");
    Error('\p{Is_Pattern_White_Space= /a/F}');
    Error('\P{Is_Pattern_White_Space= /a/F}');
    Expect(1, 8234, '\p{Is_Pattern_White_Space=f}', "");
    Expect(0, 8234, '\p{^Is_Pattern_White_Space=f}', "");
    Expect(0, 8234, '\P{Is_Pattern_White_Space=f}', "");
    Expect(1, 8234, '\P{^Is_Pattern_White_Space=f}', "");
    Expect(0, 8233, '\p{Is_Pattern_White_Space=f}', "");
    Expect(1, 8233, '\p{^Is_Pattern_White_Space=f}', "");
    Expect(1, 8233, '\P{Is_Pattern_White_Space=f}', "");
    Expect(0, 8233, '\P{^Is_Pattern_White_Space=f}', "");
    Expect(1, 8234, '\p{Is_Pattern_White_Space=-F}', "");
    Expect(0, 8234, '\p{^Is_Pattern_White_Space=-F}', "");
    Expect(0, 8234, '\P{Is_Pattern_White_Space=-F}', "");
    Expect(1, 8234, '\P{^Is_Pattern_White_Space=-F}', "");
    Expect(0, 8233, '\p{Is_Pattern_White_Space=-F}', "");
    Expect(1, 8233, '\p{^Is_Pattern_White_Space=-F}', "");
    Expect(1, 8233, '\P{Is_Pattern_White_Space=-F}', "");
    Expect(0, 8233, '\P{^Is_Pattern_White_Space=-F}', "");
    Error('\p{Is_Pat_WS=:= _false}');
    Error('\P{Is_Pat_WS=:= _false}');
    Expect(1, 8234, '\p{Is_Pat_WS=false}', "");
    Expect(0, 8234, '\p{^Is_Pat_WS=false}', "");
    Expect(0, 8234, '\P{Is_Pat_WS=false}', "");
    Expect(1, 8234, '\P{^Is_Pat_WS=false}', "");
    Expect(0, 8233, '\p{Is_Pat_WS=false}', "");
    Expect(1, 8233, '\p{^Is_Pat_WS=false}', "");
    Expect(1, 8233, '\P{Is_Pat_WS=false}', "");
    Expect(0, 8233, '\P{^Is_Pat_WS=false}', "");
    Expect(1, 8234, '\p{Is_Pat_WS: 	false}', "");
    Expect(0, 8234, '\p{^Is_Pat_WS: 	false}', "");
    Expect(0, 8234, '\P{Is_Pat_WS: 	false}', "");
    Expect(1, 8234, '\P{^Is_Pat_WS: 	false}', "");
    Expect(0, 8233, '\p{Is_Pat_WS: 	false}', "");
    Expect(1, 8233, '\p{^Is_Pat_WS: 	false}', "");
    Expect(1, 8233, '\P{Is_Pat_WS: 	false}', "");
    Expect(0, 8233, '\P{^Is_Pat_WS: 	false}', "");
    Error('\p{Pattern_White_Space= _yes/a/}');
    Error('\P{Pattern_White_Space= _yes/a/}');
    Expect(1, 8233, '\p{Pattern_White_Space=:\AYes\z:}', "");;
    Expect(0, 8234, '\p{Pattern_White_Space=:\AYes\z:}', "");;
    Expect(1, 8233, '\p{Pattern_White_Space=yes}', "");
    Expect(0, 8233, '\p{^Pattern_White_Space=yes}', "");
    Expect(0, 8233, '\P{Pattern_White_Space=yes}', "");
    Expect(1, 8233, '\P{^Pattern_White_Space=yes}', "");
    Expect(0, 8234, '\p{Pattern_White_Space=yes}', "");
    Expect(1, 8234, '\p{^Pattern_White_Space=yes}', "");
    Expect(1, 8234, '\P{Pattern_White_Space=yes}', "");
    Expect(0, 8234, '\P{^Pattern_White_Space=yes}', "");
    Expect(1, 8233, '\p{Pattern_White_Space=:\Ayes\z:}', "");;
    Expect(0, 8234, '\p{Pattern_White_Space=:\Ayes\z:}', "");;
    Expect(1, 8233, '\p{Pattern_White_Space:		yes}', "");
    Expect(0, 8233, '\p{^Pattern_White_Space:		yes}', "");
    Expect(0, 8233, '\P{Pattern_White_Space:		yes}', "");
    Expect(1, 8233, '\P{^Pattern_White_Space:		yes}', "");
    Expect(0, 8234, '\p{Pattern_White_Space:		yes}', "");
    Expect(1, 8234, '\p{^Pattern_White_Space:		yes}', "");
    Expect(1, 8234, '\P{Pattern_White_Space:		yes}', "");
    Expect(0, 8234, '\P{^Pattern_White_Space:		yes}', "");
    Error('\p{Pat_WS:	  Y/a/}');
    Error('\P{Pat_WS:	  Y/a/}');
    Expect(1, 8233, '\p{Pat_WS=:\AY\z:}', "");;
    Expect(0, 8234, '\p{Pat_WS=:\AY\z:}', "");;
    Expect(1, 8233, '\p{Pat_WS=y}', "");
    Expect(0, 8233, '\p{^Pat_WS=y}', "");
    Expect(0, 8233, '\P{Pat_WS=y}', "");
    Expect(1, 8233, '\P{^Pat_WS=y}', "");
    Expect(0, 8234, '\p{Pat_WS=y}', "");
    Expect(1, 8234, '\p{^Pat_WS=y}', "");
    Expect(1, 8234, '\P{Pat_WS=y}', "");
    Expect(0, 8234, '\P{^Pat_WS=y}', "");
    Expect(1, 8233, '\p{Pat_WS=:\Ay\z:}', "");;
    Expect(0, 8234, '\p{Pat_WS=:\Ay\z:}', "");;
    Expect(1, 8233, '\p{Pat_WS=-_Y}', "");
    Expect(0, 8233, '\p{^Pat_WS=-_Y}', "");
    Expect(0, 8233, '\P{Pat_WS=-_Y}', "");
    Expect(1, 8233, '\P{^Pat_WS=-_Y}', "");
    Expect(0, 8234, '\p{Pat_WS=-_Y}', "");
    Expect(1, 8234, '\p{^Pat_WS=-_Y}', "");
    Expect(1, 8234, '\P{Pat_WS=-_Y}', "");
    Expect(0, 8234, '\P{^Pat_WS=-_Y}', "");
    Error('\p{Is_Pattern_White_Space=/a/_-t}');
    Error('\P{Is_Pattern_White_Space=/a/_-t}');
    Expect(1, 8233, '\p{Is_Pattern_White_Space=t}', "");
    Expect(0, 8233, '\p{^Is_Pattern_White_Space=t}', "");
    Expect(0, 8233, '\P{Is_Pattern_White_Space=t}', "");
    Expect(1, 8233, '\P{^Is_Pattern_White_Space=t}', "");
    Expect(0, 8234, '\p{Is_Pattern_White_Space=t}', "");
    Expect(1, 8234, '\p{^Is_Pattern_White_Space=t}', "");
    Expect(1, 8234, '\P{Is_Pattern_White_Space=t}', "");
    Expect(0, 8234, '\P{^Is_Pattern_White_Space=t}', "");
    Expect(1, 8233, '\p{Is_Pattern_White_Space:	-T}', "");
    Expect(0, 8233, '\p{^Is_Pattern_White_Space:	-T}', "");
    Expect(0, 8233, '\P{Is_Pattern_White_Space:	-T}', "");
    Expect(1, 8233, '\P{^Is_Pattern_White_Space:	-T}', "");
    Expect(0, 8234, '\p{Is_Pattern_White_Space:	-T}', "");
    Expect(1, 8234, '\p{^Is_Pattern_White_Space:	-T}', "");
    Expect(1, 8234, '\P{Is_Pattern_White_Space:	-T}', "");
    Expect(0, 8234, '\P{^Is_Pattern_White_Space:	-T}', "");
    Error('\p{Is_Pat_WS=:=_-TRUE}');
    Error('\P{Is_Pat_WS=:=_-TRUE}');
    Expect(1, 8233, '\p{Is_Pat_WS=true}', "");
    Expect(0, 8233, '\p{^Is_Pat_WS=true}', "");
    Expect(0, 8233, '\P{Is_Pat_WS=true}', "");
    Expect(1, 8233, '\P{^Is_Pat_WS=true}', "");
    Expect(0, 8234, '\p{Is_Pat_WS=true}', "");
    Expect(1, 8234, '\p{^Is_Pat_WS=true}', "");
    Expect(1, 8234, '\P{Is_Pat_WS=true}', "");
    Expect(0, 8234, '\P{^Is_Pat_WS=true}', "");
    Expect(1, 8233, '\p{Is_Pat_WS=-True}', "");
    Expect(0, 8233, '\p{^Is_Pat_WS=-True}', "");
    Expect(0, 8233, '\P{Is_Pat_WS=-True}', "");
    Expect(1, 8233, '\P{^Is_Pat_WS=-True}', "");
    Expect(0, 8234, '\p{Is_Pat_WS=-True}', "");
    Expect(1, 8234, '\p{^Is_Pat_WS=-True}', "");
    Expect(1, 8234, '\P{Is_Pat_WS=-True}', "");
    Expect(0, 8234, '\P{^Is_Pat_WS=-True}', "");
    Error('\p{Prepended_Concatenation_Mark=_:=no}');
    Error('\P{Prepended_Concatenation_Mark=_:=no}');
    Expect(1, 69838, '\p{Prepended_Concatenation_Mark=:\ANo\z:}', "");;
    Expect(0, 69837, '\p{Prepended_Concatenation_Mark=:\ANo\z:}', "");;
    Expect(1, 69838, '\p{Prepended_Concatenation_Mark=no}', "");
    Expect(0, 69838, '\p{^Prepended_Concatenation_Mark=no}', "");
    Expect(0, 69838, '\P{Prepended_Concatenation_Mark=no}', "");
    Expect(1, 69838, '\P{^Prepended_Concatenation_Mark=no}', "");
    Expect(0, 69837, '\p{Prepended_Concatenation_Mark=no}', "");
    Expect(1, 69837, '\p{^Prepended_Concatenation_Mark=no}', "");
    Expect(1, 69837, '\P{Prepended_Concatenation_Mark=no}', "");
    Expect(0, 69837, '\P{^Prepended_Concatenation_Mark=no}', "");
    Expect(1, 69838, '\p{Prepended_Concatenation_Mark=:\Ano\z:}', "");;
    Expect(0, 69837, '\p{Prepended_Concatenation_Mark=:\Ano\z:}', "");;
    Expect(1, 69838, '\p{Prepended_Concatenation_Mark=--No}', "");
    Expect(0, 69838, '\p{^Prepended_Concatenation_Mark=--No}', "");
    Expect(0, 69838, '\P{Prepended_Concatenation_Mark=--No}', "");
    Expect(1, 69838, '\P{^Prepended_Concatenation_Mark=--No}', "");
    Expect(0, 69837, '\p{Prepended_Concatenation_Mark=--No}', "");
    Expect(1, 69837, '\p{^Prepended_Concatenation_Mark=--No}', "");
    Expect(1, 69837, '\P{Prepended_Concatenation_Mark=--No}', "");
    Expect(0, 69837, '\P{^Prepended_Concatenation_Mark=--No}', "");
    Error('\p{PCM=/a/_-N}');
    Error('\P{PCM=/a/_-N}');
    Expect(1, 69838, '\p{PCM=:\AN\z:}', "");;
    Expect(0, 69837, '\p{PCM=:\AN\z:}', "");;
    Expect(1, 69838, '\p{PCM=n}', "");
    Expect(0, 69838, '\p{^PCM=n}', "");
    Expect(0, 69838, '\P{PCM=n}', "");
    Expect(1, 69838, '\P{^PCM=n}', "");
    Expect(0, 69837, '\p{PCM=n}', "");
    Expect(1, 69837, '\p{^PCM=n}', "");
    Expect(1, 69837, '\P{PCM=n}', "");
    Expect(0, 69837, '\P{^PCM=n}', "");
    Expect(1, 69838, '\p{PCM=:\An\z:}', "");;
    Expect(0, 69837, '\p{PCM=:\An\z:}', "");;
    Expect(1, 69838, '\p{PCM=-	N}', "");
    Expect(0, 69838, '\p{^PCM=-	N}', "");
    Expect(0, 69838, '\P{PCM=-	N}', "");
    Expect(1, 69838, '\P{^PCM=-	N}', "");
    Expect(0, 69837, '\p{PCM=-	N}', "");
    Expect(1, 69837, '\p{^PCM=-	N}', "");
    Expect(1, 69837, '\P{PCM=-	N}', "");
    Expect(0, 69837, '\P{^PCM=-	N}', "");
    Error('\p{Is_Prepended_Concatenation_Mark=:=	F}');
    Error('\P{Is_Prepended_Concatenation_Mark=:=	F}');
    Expect(1, 69838, '\p{Is_Prepended_Concatenation_Mark=f}', "");
    Expect(0, 69838, '\p{^Is_Prepended_Concatenation_Mark=f}', "");
    Expect(0, 69838, '\P{Is_Prepended_Concatenation_Mark=f}', "");
    Expect(1, 69838, '\P{^Is_Prepended_Concatenation_Mark=f}', "");
    Expect(0, 69837, '\p{Is_Prepended_Concatenation_Mark=f}', "");
    Expect(1, 69837, '\p{^Is_Prepended_Concatenation_Mark=f}', "");
    Expect(1, 69837, '\P{Is_Prepended_Concatenation_Mark=f}', "");
    Expect(0, 69837, '\P{^Is_Prepended_Concatenation_Mark=f}', "");
    Expect(1, 69838, '\p{Is_Prepended_Concatenation_Mark=	F}', "");
    Expect(0, 69838, '\p{^Is_Prepended_Concatenation_Mark=	F}', "");
    Expect(0, 69838, '\P{Is_Prepended_Concatenation_Mark=	F}', "");
    Expect(1, 69838, '\P{^Is_Prepended_Concatenation_Mark=	F}', "");
    Expect(0, 69837, '\p{Is_Prepended_Concatenation_Mark=	F}', "");
    Expect(1, 69837, '\p{^Is_Prepended_Concatenation_Mark=	F}', "");
    Expect(1, 69837, '\P{Is_Prepended_Concatenation_Mark=	F}', "");
    Expect(0, 69837, '\P{^Is_Prepended_Concatenation_Mark=	F}', "");
    Error('\p{Is_PCM=-_False:=}');
    Error('\P{Is_PCM=-_False:=}');
    Expect(1, 69838, '\p{Is_PCM: false}', "");
    Expect(0, 69838, '\p{^Is_PCM: false}', "");
    Expect(0, 69838, '\P{Is_PCM: false}', "");
    Expect(1, 69838, '\P{^Is_PCM: false}', "");
    Expect(0, 69837, '\p{Is_PCM: false}', "");
    Expect(1, 69837, '\p{^Is_PCM: false}', "");
    Expect(1, 69837, '\P{Is_PCM: false}', "");
    Expect(0, 69837, '\P{^Is_PCM: false}', "");
    Expect(1, 69838, '\p{Is_PCM=	False}', "");
    Expect(0, 69838, '\p{^Is_PCM=	False}', "");
    Expect(0, 69838, '\P{Is_PCM=	False}', "");
    Expect(1, 69838, '\P{^Is_PCM=	False}', "");
    Expect(0, 69837, '\p{Is_PCM=	False}', "");
    Expect(1, 69837, '\p{^Is_PCM=	False}', "");
    Expect(1, 69837, '\P{Is_PCM=	False}', "");
    Expect(0, 69837, '\P{^Is_PCM=	False}', "");
    Error('\p{Prepended_Concatenation_Mark=:=-	YES}');
    Error('\P{Prepended_Concatenation_Mark=:=-	YES}');
    Expect(1, 69837, '\p{Prepended_Concatenation_Mark=:\AYes\z:}', "");;
    Expect(0, 69838, '\p{Prepended_Concatenation_Mark=:\AYes\z:}', "");;
    Expect(1, 69837, '\p{Prepended_Concatenation_Mark=yes}', "");
    Expect(0, 69837, '\p{^Prepended_Concatenation_Mark=yes}', "");
    Expect(0, 69837, '\P{Prepended_Concatenation_Mark=yes}', "");
    Expect(1, 69837, '\P{^Prepended_Concatenation_Mark=yes}', "");
    Expect(0, 69838, '\p{Prepended_Concatenation_Mark=yes}', "");
    Expect(1, 69838, '\p{^Prepended_Concatenation_Mark=yes}', "");
    Expect(1, 69838, '\P{Prepended_Concatenation_Mark=yes}', "");
    Expect(0, 69838, '\P{^Prepended_Concatenation_Mark=yes}', "");
    Expect(1, 69837, '\p{Prepended_Concatenation_Mark=:\Ayes\z:}', "");;
    Expect(0, 69838, '\p{Prepended_Concatenation_Mark=:\Ayes\z:}', "");;
    Expect(1, 69837, '\p{Prepended_Concatenation_Mark= yes}', "");
    Expect(0, 69837, '\p{^Prepended_Concatenation_Mark= yes}', "");
    Expect(0, 69837, '\P{Prepended_Concatenation_Mark= yes}', "");
    Expect(1, 69837, '\P{^Prepended_Concatenation_Mark= yes}', "");
    Expect(0, 69838, '\p{Prepended_Concatenation_Mark= yes}', "");
    Expect(1, 69838, '\p{^Prepended_Concatenation_Mark= yes}', "");
    Expect(1, 69838, '\P{Prepended_Concatenation_Mark= yes}', "");
    Expect(0, 69838, '\P{^Prepended_Concatenation_Mark= yes}', "");
    Error('\p{PCM=_	y:=}');
    Error('\P{PCM=_	y:=}');
    Expect(1, 69837, '\p{PCM=:\AY\z:}', "");;
    Expect(0, 69838, '\p{PCM=:\AY\z:}', "");;
    Expect(1, 69837, '\p{PCM=y}', "");
    Expect(0, 69837, '\p{^PCM=y}', "");
    Expect(0, 69837, '\P{PCM=y}', "");
    Expect(1, 69837, '\P{^PCM=y}', "");
    Expect(0, 69838, '\p{PCM=y}', "");
    Expect(1, 69838, '\p{^PCM=y}', "");
    Expect(1, 69838, '\P{PCM=y}', "");
    Expect(0, 69838, '\P{^PCM=y}', "");
    Expect(1, 69837, '\p{PCM=:\Ay\z:}', "");;
    Expect(0, 69838, '\p{PCM=:\Ay\z:}', "");;
    Expect(1, 69837, '\p{PCM=-y}', "");
    Expect(0, 69837, '\p{^PCM=-y}', "");
    Expect(0, 69837, '\P{PCM=-y}', "");
    Expect(1, 69837, '\P{^PCM=-y}', "");
    Expect(0, 69838, '\p{PCM=-y}', "");
    Expect(1, 69838, '\p{^PCM=-y}', "");
    Expect(1, 69838, '\P{PCM=-y}', "");
    Expect(0, 69838, '\P{^PCM=-y}', "");
    Error('\p{Is_Prepended_Concatenation_Mark=_:=T}');
    Error('\P{Is_Prepended_Concatenation_Mark=_:=T}');
    Expect(1, 69837, '\p{Is_Prepended_Concatenation_Mark=t}', "");
    Expect(0, 69837, '\p{^Is_Prepended_Concatenation_Mark=t}', "");
    Expect(0, 69837, '\P{Is_Prepended_Concatenation_Mark=t}', "");
    Expect(1, 69837, '\P{^Is_Prepended_Concatenation_Mark=t}', "");
    Expect(0, 69838, '\p{Is_Prepended_Concatenation_Mark=t}', "");
    Expect(1, 69838, '\p{^Is_Prepended_Concatenation_Mark=t}', "");
    Expect(1, 69838, '\P{Is_Prepended_Concatenation_Mark=t}', "");
    Expect(0, 69838, '\P{^Is_Prepended_Concatenation_Mark=t}', "");
    Expect(1, 69837, '\p{Is_Prepended_Concatenation_Mark=	 T}', "");
    Expect(0, 69837, '\p{^Is_Prepended_Concatenation_Mark=	 T}', "");
    Expect(0, 69837, '\P{Is_Prepended_Concatenation_Mark=	 T}', "");
    Expect(1, 69837, '\P{^Is_Prepended_Concatenation_Mark=	 T}', "");
    Expect(0, 69838, '\p{Is_Prepended_Concatenation_Mark=	 T}', "");
    Expect(1, 69838, '\p{^Is_Prepended_Concatenation_Mark=	 T}', "");
    Expect(1, 69838, '\P{Is_Prepended_Concatenation_Mark=	 T}', "");
    Expect(0, 69838, '\P{^Is_Prepended_Concatenation_Mark=	 T}', "");
    Error('\p{Is_PCM=:=TRUE}');
    Error('\P{Is_PCM=:=TRUE}');
    Expect(1, 69837, '\p{Is_PCM=true}', "");
    Expect(0, 69837, '\p{^Is_PCM=true}', "");
    Expect(0, 69837, '\P{Is_PCM=true}', "");
    Expect(1, 69837, '\P{^Is_PCM=true}', "");
    Expect(0, 69838, '\p{Is_PCM=true}', "");
    Expect(1, 69838, '\p{^Is_PCM=true}', "");
    Expect(1, 69838, '\P{Is_PCM=true}', "");
    Expect(0, 69838, '\P{^Is_PCM=true}', "");
    Expect(1, 69837, '\p{Is_PCM=-	true}', "");
    Expect(0, 69837, '\p{^Is_PCM=-	true}', "");
    Expect(0, 69837, '\P{Is_PCM=-	true}', "");
    Expect(1, 69837, '\P{^Is_PCM=-	true}', "");
    Expect(0, 69838, '\p{Is_PCM=-	true}', "");
    Expect(1, 69838, '\p{^Is_PCM=-	true}', "");
    Expect(1, 69838, '\P{Is_PCM=-	true}', "");
    Expect(0, 69838, '\P{^Is_PCM=-	true}', "");
    Error('\p{perl}');
    Error('\P{perl}');
    Error('\p{  Adlam/a/}');
    Error('\P{  Adlam/a/}');
    Expect(1, 125279, '\p{adlam}', "");
    Expect(0, 125279, '\p{^adlam}', "");
    Expect(0, 125279, '\P{adlam}', "");
    Expect(1, 125279, '\P{^adlam}', "");
    Expect(0, 125280, '\p{adlam}', "");
    Expect(1, 125280, '\p{^adlam}', "");
    Expect(1, 125280, '\P{adlam}', "");
    Expect(0, 125280, '\P{^adlam}', "");
    Expect(1, 125279, '\p{	-ADLAM}', "");
    Expect(0, 125279, '\p{^	-ADLAM}', "");
    Expect(0, 125279, '\P{	-ADLAM}', "");
    Expect(1, 125279, '\P{^	-ADLAM}', "");
    Expect(0, 125280, '\p{	-ADLAM}', "");
    Expect(1, 125280, '\p{^	-ADLAM}', "");
    Expect(1, 125280, '\P{	-ADLAM}', "");
    Expect(0, 125280, '\P{^	-ADLAM}', "");
    Error('\p{_Is_ADLAM/a/}');
    Error('\P{_Is_ADLAM/a/}');
    Expect(1, 125279, '\p{isadlam}', "");
    Expect(0, 125279, '\p{^isadlam}', "");
    Expect(0, 125279, '\P{isadlam}', "");
    Expect(1, 125279, '\P{^isadlam}', "");
    Expect(0, 125280, '\p{isadlam}', "");
    Expect(1, 125280, '\p{^isadlam}', "");
    Expect(1, 125280, '\P{isadlam}', "");
    Expect(0, 125280, '\P{^isadlam}', "");
    Expect(1, 125279, '\p{_	is_Adlam}', "");
    Expect(0, 125279, '\p{^_	is_Adlam}', "");
    Expect(0, 125279, '\P{_	is_Adlam}', "");
    Expect(1, 125279, '\P{^_	is_Adlam}', "");
    Expect(0, 125280, '\p{_	is_Adlam}', "");
    Expect(1, 125280, '\p{^_	is_Adlam}', "");
    Expect(1, 125280, '\P{_	is_Adlam}', "");
    Expect(0, 125280, '\P{^_	is_Adlam}', "");
    Error('\p{_/a/Adlm}');
    Error('\P{_/a/Adlm}');
    Expect(1, 125279, '\p{adlm}', "");
    Expect(0, 125279, '\p{^adlm}', "");
    Expect(0, 125279, '\P{adlm}', "");
    Expect(1, 125279, '\P{^adlm}', "");
    Expect(0, 125280, '\p{adlm}', "");
    Expect(1, 125280, '\p{^adlm}', "");
    Expect(1, 125280, '\P{adlm}', "");
    Expect(0, 125280, '\P{^adlm}', "");
    Expect(1, 125279, '\p{-	ADLM}', "");
    Expect(0, 125279, '\p{^-	ADLM}', "");
    Expect(0, 125279, '\P{-	ADLM}', "");
    Expect(1, 125279, '\P{^-	ADLM}', "");
    Expect(0, 125280, '\p{-	ADLM}', "");
    Expect(1, 125280, '\p{^-	ADLM}', "");
    Expect(1, 125280, '\P{-	ADLM}', "");
    Expect(0, 125280, '\P{^-	ADLM}', "");
    Error('\p{-_IS_adlm/a/}');
    Error('\P{-_IS_adlm/a/}');
    Expect(1, 125279, '\p{isadlm}', "");
    Expect(0, 125279, '\p{^isadlm}', "");
    Expect(0, 125279, '\P{isadlm}', "");
    Expect(1, 125279, '\P{^isadlm}', "");
    Expect(0, 125280, '\p{isadlm}', "");
    Expect(1, 125280, '\p{^isadlm}', "");
    Expect(1, 125280, '\P{isadlm}', "");
    Expect(0, 125280, '\P{^isadlm}', "");
    Expect(1, 125279, '\p{	 is_adlm}', "");
    Expect(0, 125279, '\p{^	 is_adlm}', "");
    Expect(0, 125279, '\P{	 is_adlm}', "");
    Expect(1, 125279, '\P{^	 is_adlm}', "");
    Expect(0, 125280, '\p{	 is_adlm}', "");
    Expect(1, 125280, '\p{^	 is_adlm}', "");
    Expect(1, 125280, '\P{	 is_adlm}', "");
    Expect(0, 125280, '\P{^	 is_adlm}', "");
    Error('\p{	Aegean_Numbers/a/}');
    Error('\P{	Aegean_Numbers/a/}');
    Expect(1, 65855, '\p{aegeannumbers}', "");
    Expect(0, 65855, '\p{^aegeannumbers}', "");
    Expect(0, 65855, '\P{aegeannumbers}', "");
    Expect(1, 65855, '\P{^aegeannumbers}', "");
    Expect(0, 65856, '\p{aegeannumbers}', "");
    Expect(1, 65856, '\p{^aegeannumbers}', "");
    Expect(1, 65856, '\P{aegeannumbers}', "");
    Expect(0, 65856, '\P{^aegeannumbers}', "");
    Expect(1, 65855, '\p{--Aegean_NUMBERS}', "");
    Expect(0, 65855, '\p{^--Aegean_NUMBERS}', "");
    Expect(0, 65855, '\P{--Aegean_NUMBERS}', "");
    Expect(1, 65855, '\P{^--Aegean_NUMBERS}', "");
    Expect(0, 65856, '\p{--Aegean_NUMBERS}', "");
    Expect(1, 65856, '\p{^--Aegean_NUMBERS}', "");
    Expect(1, 65856, '\P{--Aegean_NUMBERS}', "");
    Expect(0, 65856, '\P{^--Aegean_NUMBERS}', "");
    Error('\p{_IS_Aegean_Numbers:=}');
    Error('\P{_IS_Aegean_Numbers:=}');
    Expect(1, 65855, '\p{isaegeannumbers}', "");
    Expect(0, 65855, '\p{^isaegeannumbers}', "");
    Expect(0, 65855, '\P{isaegeannumbers}', "");
    Expect(1, 65855, '\P{^isaegeannumbers}', "");
    Expect(0, 65856, '\p{isaegeannumbers}', "");
    Expect(1, 65856, '\p{^isaegeannumbers}', "");
    Expect(1, 65856, '\P{isaegeannumbers}', "");
    Expect(0, 65856, '\P{^isaegeannumbers}', "");
    Expect(1, 65855, '\p{--Is_Aegean_Numbers}', "");
    Expect(0, 65855, '\p{^--Is_Aegean_Numbers}', "");
    Expect(0, 65855, '\P{--Is_Aegean_Numbers}', "");
    Expect(1, 65855, '\P{^--Is_Aegean_Numbers}', "");
    Expect(0, 65856, '\p{--Is_Aegean_Numbers}', "");
    Expect(1, 65856, '\p{^--Is_Aegean_Numbers}', "");
    Expect(1, 65856, '\P{--Is_Aegean_Numbers}', "");
    Expect(0, 65856, '\P{^--Is_Aegean_Numbers}', "");
    Error('\p{/a/--In_Aegean_numbers}');
    Error('\P{/a/--In_Aegean_numbers}');
    Expect(1, 65855, '\p{inaegeannumbers}', "");
    Expect(0, 65855, '\p{^inaegeannumbers}', "");
    Expect(0, 65855, '\P{inaegeannumbers}', "");
    Expect(1, 65855, '\P{^inaegeannumbers}', "");
    Expect(0, 65856, '\p{inaegeannumbers}', "");
    Expect(1, 65856, '\p{^inaegeannumbers}', "");
    Expect(1, 65856, '\P{inaegeannumbers}', "");
    Expect(0, 65856, '\P{^inaegeannumbers}', "");
    Expect(1, 65855, '\p{_	in_Aegean_numbers}', "");
    Expect(0, 65855, '\p{^_	in_Aegean_numbers}', "");
    Expect(0, 65855, '\P{_	in_Aegean_numbers}', "");
    Expect(1, 65855, '\P{^_	in_Aegean_numbers}', "");
    Expect(0, 65856, '\p{_	in_Aegean_numbers}', "");
    Expect(1, 65856, '\p{^_	in_Aegean_numbers}', "");
    Expect(1, 65856, '\P{_	in_Aegean_numbers}', "");
    Expect(0, 65856, '\P{^_	in_Aegean_numbers}', "");
    Error('\p{/a/_-AHOM}');
    Error('\P{/a/_-AHOM}');
    Expect(1, 71494, '\p{ahom}', "");
    Expect(0, 71494, '\p{^ahom}', "");
    Expect(0, 71494, '\P{ahom}', "");
    Expect(1, 71494, '\P{^ahom}', "");
    Expect(0, 71495, '\p{ahom}', "");
    Expect(1, 71495, '\p{^ahom}', "");
    Expect(1, 71495, '\P{ahom}', "");
    Expect(0, 71495, '\P{^ahom}', "");
    Expect(1, 71494, '\p{	 Ahom}', "");
    Expect(0, 71494, '\p{^	 Ahom}', "");
    Expect(0, 71494, '\P{	 Ahom}', "");
    Expect(1, 71494, '\P{^	 Ahom}', "");
    Expect(0, 71495, '\p{	 Ahom}', "");
    Expect(1, 71495, '\p{^	 Ahom}', "");
    Expect(1, 71495, '\P{	 Ahom}', "");
    Expect(0, 71495, '\P{^	 Ahom}', "");
    Error('\p{_:=Is_AHOM}');
    Error('\P{_:=Is_AHOM}');
    Expect(1, 71494, '\p{isahom}', "");
    Expect(0, 71494, '\p{^isahom}', "");
    Expect(0, 71494, '\P{isahom}', "");
    Expect(1, 71494, '\P{^isahom}', "");
    Expect(0, 71495, '\p{isahom}', "");
    Expect(1, 71495, '\p{^isahom}', "");
    Expect(1, 71495, '\P{isahom}', "");
    Expect(0, 71495, '\P{^isahom}', "");
    Expect(1, 71494, '\p{_ Is_ahom}', "");
    Expect(0, 71494, '\p{^_ Is_ahom}', "");
    Expect(0, 71494, '\P{_ Is_ahom}', "");
    Expect(1, 71494, '\P{^_ Is_ahom}', "");
    Expect(0, 71495, '\p{_ Is_ahom}', "");
    Expect(1, 71495, '\p{^_ Is_ahom}', "");
    Expect(1, 71495, '\P{_ Is_ahom}', "");
    Expect(0, 71495, '\P{^_ Is_ahom}', "");
    Error('\p{:= 	Alchemical_Symbols}');
    Error('\P{:= 	Alchemical_Symbols}');
    Expect(1, 128895, '\p{alchemicalsymbols}', "");
    Expect(0, 128895, '\p{^alchemicalsymbols}', "");
    Expect(0, 128895, '\P{alchemicalsymbols}', "");
    Expect(1, 128895, '\P{^alchemicalsymbols}', "");
    Expect(0, 128896, '\p{alchemicalsymbols}', "");
    Expect(1, 128896, '\p{^alchemicalsymbols}', "");
    Expect(1, 128896, '\P{alchemicalsymbols}', "");
    Expect(0, 128896, '\P{^alchemicalsymbols}', "");
    Expect(1, 128895, '\p{__ALCHEMICAL_Symbols}', "");
    Expect(0, 128895, '\p{^__ALCHEMICAL_Symbols}', "");
    Expect(0, 128895, '\P{__ALCHEMICAL_Symbols}', "");
    Expect(1, 128895, '\P{^__ALCHEMICAL_Symbols}', "");
    Expect(0, 128896, '\p{__ALCHEMICAL_Symbols}', "");
    Expect(1, 128896, '\p{^__ALCHEMICAL_Symbols}', "");
    Expect(1, 128896, '\P{__ALCHEMICAL_Symbols}', "");
    Expect(0, 128896, '\P{^__ALCHEMICAL_Symbols}', "");
    Error('\p{ /a/IS_Alchemical_SYMBOLS}');
    Error('\P{ /a/IS_Alchemical_SYMBOLS}');
    Expect(1, 128895, '\p{isalchemicalsymbols}', "");
    Expect(0, 128895, '\p{^isalchemicalsymbols}', "");
    Expect(0, 128895, '\P{isalchemicalsymbols}', "");
    Expect(1, 128895, '\P{^isalchemicalsymbols}', "");
    Expect(0, 128896, '\p{isalchemicalsymbols}', "");
    Expect(1, 128896, '\p{^isalchemicalsymbols}', "");
    Expect(1, 128896, '\P{isalchemicalsymbols}', "");
    Expect(0, 128896, '\P{^isalchemicalsymbols}', "");
    Expect(1, 128895, '\p{_ Is_Alchemical_Symbols}', "");
    Expect(0, 128895, '\p{^_ Is_Alchemical_Symbols}', "");
    Expect(0, 128895, '\P{_ Is_Alchemical_Symbols}', "");
    Expect(1, 128895, '\P{^_ Is_Alchemical_Symbols}', "");
    Expect(0, 128896, '\p{_ Is_Alchemical_Symbols}', "");
    Expect(1, 128896, '\p{^_ Is_Alchemical_Symbols}', "");
    Expect(1, 128896, '\P{_ Is_Alchemical_Symbols}', "");
    Expect(0, 128896, '\P{^_ Is_Alchemical_Symbols}', "");
    Error('\p{	:=IN_Alchemical_Symbols}');
    Error('\P{	:=IN_Alchemical_Symbols}');
    Expect(1, 128895, '\p{inalchemicalsymbols}', "");
    Expect(0, 128895, '\p{^inalchemicalsymbols}', "");
    Expect(0, 128895, '\P{inalchemicalsymbols}', "");
    Expect(1, 128895, '\P{^inalchemicalsymbols}', "");
    Expect(0, 128896, '\p{inalchemicalsymbols}', "");
    Expect(1, 128896, '\p{^inalchemicalsymbols}', "");
    Expect(1, 128896, '\P{inalchemicalsymbols}', "");
    Expect(0, 128896, '\P{^inalchemicalsymbols}', "");
    Expect(1, 128895, '\p{ in_ALCHEMICAL_Symbols}', "");
    Expect(0, 128895, '\p{^ in_ALCHEMICAL_Symbols}', "");
    Expect(0, 128895, '\P{ in_ALCHEMICAL_Symbols}', "");
    Expect(1, 128895, '\P{^ in_ALCHEMICAL_Symbols}', "");
    Expect(0, 128896, '\p{ in_ALCHEMICAL_Symbols}', "");
    Expect(1, 128896, '\p{^ in_ALCHEMICAL_Symbols}', "");
    Expect(1, 128896, '\P{ in_ALCHEMICAL_Symbols}', "");
    Expect(0, 128896, '\P{^ in_ALCHEMICAL_Symbols}', "");
    Error('\p{:=alchemical}');
    Error('\P{:=alchemical}');
    Expect(1, 128895, '\p{alchemical}', "");
    Expect(0, 128895, '\p{^alchemical}', "");
    Expect(0, 128895, '\P{alchemical}', "");
    Expect(1, 128895, '\P{^alchemical}', "");
    Expect(0, 128896, '\p{alchemical}', "");
    Expect(1, 128896, '\p{^alchemical}', "");
    Expect(1, 128896, '\P{alchemical}', "");
    Expect(0, 128896, '\P{^alchemical}', "");
    Expect(1, 128895, '\p{_Alchemical}', "");
    Expect(0, 128895, '\p{^_Alchemical}', "");
    Expect(0, 128895, '\P{_Alchemical}', "");
    Expect(1, 128895, '\P{^_Alchemical}', "");
    Expect(0, 128896, '\p{_Alchemical}', "");
    Expect(1, 128896, '\p{^_Alchemical}', "");
    Expect(1, 128896, '\P{_Alchemical}', "");
    Expect(0, 128896, '\P{^_Alchemical}', "");
    Error('\p{:=-IS_Alchemical}');
    Error('\P{:=-IS_Alchemical}');
    Expect(1, 128895, '\p{isalchemical}', "");
    Expect(0, 128895, '\p{^isalchemical}', "");
    Expect(0, 128895, '\P{isalchemical}', "");
    Expect(1, 128895, '\P{^isalchemical}', "");
    Expect(0, 128896, '\p{isalchemical}', "");
    Expect(1, 128896, '\p{^isalchemical}', "");
    Expect(1, 128896, '\P{isalchemical}', "");
    Expect(0, 128896, '\P{^isalchemical}', "");
    Expect(1, 128895, '\p{-Is_Alchemical}', "");
    Expect(0, 128895, '\p{^-Is_Alchemical}', "");
    Expect(0, 128895, '\P{-Is_Alchemical}', "");
    Expect(1, 128895, '\P{^-Is_Alchemical}', "");
    Expect(0, 128896, '\p{-Is_Alchemical}', "");
    Expect(1, 128896, '\p{^-Is_Alchemical}', "");
    Expect(1, 128896, '\P{-Is_Alchemical}', "");
    Expect(0, 128896, '\P{^-Is_Alchemical}', "");
    Error('\p{:=		IN_alchemical}');
    Error('\P{:=		IN_alchemical}');
    Expect(1, 128895, '\p{inalchemical}', "");
    Expect(0, 128895, '\p{^inalchemical}', "");
    Expect(0, 128895, '\P{inalchemical}', "");
    Expect(1, 128895, '\P{^inalchemical}', "");
    Expect(0, 128896, '\p{inalchemical}', "");
    Expect(1, 128896, '\p{^inalchemical}', "");
    Expect(1, 128896, '\P{inalchemical}', "");
    Expect(0, 128896, '\P{^inalchemical}', "");
    Expect(1, 128895, '\p{	_in_Alchemical}', "");
    Expect(0, 128895, '\p{^	_in_Alchemical}', "");
    Expect(0, 128895, '\P{	_in_Alchemical}', "");
    Expect(1, 128895, '\P{^	_in_Alchemical}', "");
    Expect(0, 128896, '\p{	_in_Alchemical}', "");
    Expect(1, 128896, '\p{^	_in_Alchemical}', "");
    Expect(1, 128896, '\P{	_in_Alchemical}', "");
    Expect(0, 128896, '\P{^	_in_Alchemical}', "");
    Error('\p{:=_-all}');
    Error('\P{:=_-all}');
    Expect(1, 1, '\p{all}', "");
    Expect(0, 1, '\p{^all}', "");
    Expect(0, 1, '\P{all}', "");
    Expect(1, 1, '\P{^all}', "");
    Expect(1, 1, '\p{  all}', "");
    Expect(0, 1, '\p{^  all}', "");
    Expect(0, 1, '\P{  all}', "");
    Expect(1, 1, '\P{^  all}', "");
    Error('\p{ _IS_all:=}');
    Error('\P{ _IS_all:=}');
    Expect(1, 1, '\p{isall}', "");
    Expect(0, 1, '\p{^isall}', "");
    Expect(0, 1, '\P{isall}', "");
    Expect(1, 1, '\P{^isall}', "");
    Expect(1, 1, '\p{- IS_All}', "");
    Expect(0, 1, '\p{^- IS_All}', "");
    Expect(0, 1, '\P{- IS_All}', "");
    Expect(1, 1, '\P{^- IS_All}', "");
    Error('\p{/a/-_XPOSIXALNUM}');
    Error('\P{/a/-_XPOSIXALNUM}');
    Expect(1, 205743, '\p{xposixalnum}', "");
    Expect(0, 205743, '\p{^xposixalnum}', "");
    Expect(0, 205743, '\P{xposixalnum}', "");
    Expect(1, 205743, '\P{^xposixalnum}', "");
    Expect(0, 205744, '\p{xposixalnum}', "");
    Expect(1, 205744, '\p{^xposixalnum}', "");
    Expect(1, 205744, '\P{xposixalnum}', "");
    Expect(0, 205744, '\P{^xposixalnum}', "");
    Expect(1, 205743, '\p{	XPosixAlnum}', "");
    Expect(0, 205743, '\p{^	XPosixAlnum}', "");
    Expect(0, 205743, '\P{	XPosixAlnum}', "");
    Expect(1, 205743, '\P{^	XPosixAlnum}', "");
    Expect(0, 205744, '\p{	XPosixAlnum}', "");
    Expect(1, 205744, '\p{^	XPosixAlnum}', "");
    Expect(1, 205744, '\P{	XPosixAlnum}', "");
    Expect(0, 205744, '\P{^	XPosixAlnum}', "");
    Error('\p{:=	alnum}');
    Error('\P{:=	alnum}');
    Expect(1, 205743, '\p{alnum}', "");
    Expect(0, 205743, '\p{^alnum}', "");
    Expect(0, 205743, '\P{alnum}', "");
    Expect(1, 205743, '\P{^alnum}', "");
    Expect(0, 205744, '\p{alnum}', "");
    Expect(1, 205744, '\p{^alnum}', "");
    Expect(1, 205744, '\P{alnum}', "");
    Expect(0, 205744, '\P{^alnum}', "");
    Expect(1, 205743, '\p{_	ALNUM}', "");
    Expect(0, 205743, '\p{^_	ALNUM}', "");
    Expect(0, 205743, '\P{_	ALNUM}', "");
    Expect(1, 205743, '\P{^_	ALNUM}', "");
    Expect(0, 205744, '\p{_	ALNUM}', "");
    Expect(1, 205744, '\p{^_	ALNUM}', "");
    Expect(1, 205744, '\P{_	ALNUM}', "");
    Expect(0, 205744, '\P{^_	ALNUM}', "");
    Error('\p{ 	Is_xposixalnum:=}');
    Error('\P{ 	Is_xposixalnum:=}');
    Expect(1, 205743, '\p{isxposixalnum}', "");
    Expect(0, 205743, '\p{^isxposixalnum}', "");
    Expect(0, 205743, '\P{isxposixalnum}', "");
    Expect(1, 205743, '\P{^isxposixalnum}', "");
    Expect(0, 205744, '\p{isxposixalnum}', "");
    Expect(1, 205744, '\p{^isxposixalnum}', "");
    Expect(1, 205744, '\P{isxposixalnum}', "");
    Expect(0, 205744, '\P{^isxposixalnum}', "");
    Expect(1, 205743, '\p{-Is_XPosixAlnum}', "");
    Expect(0, 205743, '\p{^-Is_XPosixAlnum}', "");
    Expect(0, 205743, '\P{-Is_XPosixAlnum}', "");
    Expect(1, 205743, '\P{^-Is_XPosixAlnum}', "");
    Expect(0, 205744, '\p{-Is_XPosixAlnum}', "");
    Expect(1, 205744, '\p{^-Is_XPosixAlnum}', "");
    Expect(1, 205744, '\P{-Is_XPosixAlnum}', "");
    Expect(0, 205744, '\P{^-Is_XPosixAlnum}', "");
    Error('\p{ IS_Alnum/a/}');
    Error('\P{ IS_Alnum/a/}');
    Expect(1, 205743, '\p{isalnum}', "");
    Expect(0, 205743, '\p{^isalnum}', "");
    Expect(0, 205743, '\P{isalnum}', "");
    Expect(1, 205743, '\P{^isalnum}', "");
    Expect(0, 205744, '\p{isalnum}', "");
    Expect(1, 205744, '\p{^isalnum}', "");
    Expect(1, 205744, '\P{isalnum}', "");
    Expect(0, 205744, '\P{^isalnum}', "");
    Expect(1, 205743, '\p{-_Is_Alnum}', "");
    Expect(0, 205743, '\p{^-_Is_Alnum}', "");
    Expect(0, 205743, '\P{-_Is_Alnum}', "");
    Expect(1, 205743, '\P{^-_Is_Alnum}', "");
    Expect(0, 205744, '\p{-_Is_Alnum}', "");
    Expect(1, 205744, '\p{^-_Is_Alnum}', "");
    Expect(1, 205744, '\P{-_Is_Alnum}', "");
    Expect(0, 205744, '\P{^-_Is_Alnum}', "");
    Error('\p{ alphabetic_Presentation_forms/a/}');
    Error('\P{ alphabetic_Presentation_forms/a/}');
    Expect(1, 64335, '\p{alphabeticpresentationforms}', "");
    Expect(0, 64335, '\p{^alphabeticpresentationforms}', "");
    Expect(0, 64335, '\P{alphabeticpresentationforms}', "");
    Expect(1, 64335, '\P{^alphabeticpresentationforms}', "");
    Expect(0, 64336, '\p{alphabeticpresentationforms}', "");
    Expect(1, 64336, '\p{^alphabeticpresentationforms}', "");
    Expect(1, 64336, '\P{alphabeticpresentationforms}', "");
    Expect(0, 64336, '\P{^alphabeticpresentationforms}', "");
    Expect(1, 64335, '\p{	Alphabetic_Presentation_forms}', "");
    Expect(0, 64335, '\p{^	Alphabetic_Presentation_forms}', "");
    Expect(0, 64335, '\P{	Alphabetic_Presentation_forms}', "");
    Expect(1, 64335, '\P{^	Alphabetic_Presentation_forms}', "");
    Expect(0, 64336, '\p{	Alphabetic_Presentation_forms}', "");
    Expect(1, 64336, '\p{^	Alphabetic_Presentation_forms}', "");
    Expect(1, 64336, '\P{	Alphabetic_Presentation_forms}', "");
    Expect(0, 64336, '\P{^	Alphabetic_Presentation_forms}', "");
    Error('\p{-_IS_Alphabetic_Presentation_Forms:=}');
    Error('\P{-_IS_Alphabetic_Presentation_Forms:=}');
    Expect(1, 64335, '\p{isalphabeticpresentationforms}', "");
    Expect(0, 64335, '\p{^isalphabeticpresentationforms}', "");
    Expect(0, 64335, '\P{isalphabeticpresentationforms}', "");
    Expect(1, 64335, '\P{^isalphabeticpresentationforms}', "");
    Expect(0, 64336, '\p{isalphabeticpresentationforms}', "");
    Expect(1, 64336, '\p{^isalphabeticpresentationforms}', "");
    Expect(1, 64336, '\P{isalphabeticpresentationforms}', "");
    Expect(0, 64336, '\P{^isalphabeticpresentationforms}', "");
    Expect(1, 64335, '\p{	Is_Alphabetic_PRESENTATION_Forms}', "");
    Expect(0, 64335, '\p{^	Is_Alphabetic_PRESENTATION_Forms}', "");
    Expect(0, 64335, '\P{	Is_Alphabetic_PRESENTATION_Forms}', "");
    Expect(1, 64335, '\P{^	Is_Alphabetic_PRESENTATION_Forms}', "");
    Expect(0, 64336, '\p{	Is_Alphabetic_PRESENTATION_Forms}', "");
    Expect(1, 64336, '\p{^	Is_Alphabetic_PRESENTATION_Forms}', "");
    Expect(1, 64336, '\P{	Is_Alphabetic_PRESENTATION_Forms}', "");
    Expect(0, 64336, '\P{^	Is_Alphabetic_PRESENTATION_Forms}', "");
    Error('\p{ :=In_ALPHABETIC_PRESENTATION_forms}');
    Error('\P{ :=In_ALPHABETIC_PRESENTATION_forms}');
    Expect(1, 64335, '\p{inalphabeticpresentationforms}', "");
    Expect(0, 64335, '\p{^inalphabeticpresentationforms}', "");
    Expect(0, 64335, '\P{inalphabeticpresentationforms}', "");
    Expect(1, 64335, '\P{^inalphabeticpresentationforms}', "");
    Expect(0, 64336, '\p{inalphabeticpresentationforms}', "");
    Expect(1, 64336, '\p{^inalphabeticpresentationforms}', "");
    Expect(1, 64336, '\P{inalphabeticpresentationforms}', "");
    Expect(0, 64336, '\P{^inalphabeticpresentationforms}', "");
    Expect(1, 64335, '\p{ 	IN_alphabetic_Presentation_FORMS}', "");
    Expect(0, 64335, '\p{^ 	IN_alphabetic_Presentation_FORMS}', "");
    Expect(0, 64335, '\P{ 	IN_alphabetic_Presentation_FORMS}', "");
    Expect(1, 64335, '\P{^ 	IN_alphabetic_Presentation_FORMS}', "");
    Expect(0, 64336, '\p{ 	IN_alphabetic_Presentation_FORMS}', "");
    Expect(1, 64336, '\p{^ 	IN_alphabetic_Presentation_FORMS}', "");
    Expect(1, 64336, '\P{ 	IN_alphabetic_Presentation_FORMS}', "");
    Expect(0, 64336, '\P{^ 	IN_alphabetic_Presentation_FORMS}', "");
    Error('\p{/a/-Alphabetic_PF}');
    Error('\P{/a/-Alphabetic_PF}');
    Expect(1, 64335, '\p{alphabeticpf}', "");
    Expect(0, 64335, '\p{^alphabeticpf}', "");
    Expect(0, 64335, '\P{alphabeticpf}', "");
    Expect(1, 64335, '\P{^alphabeticpf}', "");
    Expect(0, 64336, '\p{alphabeticpf}', "");
    Expect(1, 64336, '\p{^alphabeticpf}', "");
    Expect(1, 64336, '\P{alphabeticpf}', "");
    Expect(0, 64336, '\P{^alphabeticpf}', "");
    Expect(1, 64335, '\p{_	Alphabetic_PF}', "");
    Expect(0, 64335, '\p{^_	Alphabetic_PF}', "");
    Expect(0, 64335, '\P{_	Alphabetic_PF}', "");
    Expect(1, 64335, '\P{^_	Alphabetic_PF}', "");
    Expect(0, 64336, '\p{_	Alphabetic_PF}', "");
    Expect(1, 64336, '\p{^_	Alphabetic_PF}', "");
    Expect(1, 64336, '\P{_	Alphabetic_PF}', "");
    Expect(0, 64336, '\P{^_	Alphabetic_PF}', "");
    Error('\p{ _is_Alphabetic_PF:=}');
    Error('\P{ _is_Alphabetic_PF:=}');
    Expect(1, 64335, '\p{isalphabeticpf}', "");
    Expect(0, 64335, '\p{^isalphabeticpf}', "");
    Expect(0, 64335, '\P{isalphabeticpf}', "");
    Expect(1, 64335, '\P{^isalphabeticpf}', "");
    Expect(0, 64336, '\p{isalphabeticpf}', "");
    Expect(1, 64336, '\p{^isalphabeticpf}', "");
    Expect(1, 64336, '\P{isalphabeticpf}', "");
    Expect(0, 64336, '\P{^isalphabeticpf}', "");
    Expect(1, 64335, '\p{_Is_Alphabetic_PF}', "");
    Expect(0, 64335, '\p{^_Is_Alphabetic_PF}', "");
    Expect(0, 64335, '\P{_Is_Alphabetic_PF}', "");
    Expect(1, 64335, '\P{^_Is_Alphabetic_PF}', "");
    Expect(0, 64336, '\p{_Is_Alphabetic_PF}', "");
    Expect(1, 64336, '\p{^_Is_Alphabetic_PF}', "");
    Expect(1, 64336, '\P{_Is_Alphabetic_PF}', "");
    Expect(0, 64336, '\P{^_Is_Alphabetic_PF}', "");
    Error('\p{_/a/in_Alphabetic_PF}');
    Error('\P{_/a/in_Alphabetic_PF}');
    Expect(1, 64335, '\p{inalphabeticpf}', "");
    Expect(0, 64335, '\p{^inalphabeticpf}', "");
    Expect(0, 64335, '\P{inalphabeticpf}', "");
    Expect(1, 64335, '\P{^inalphabeticpf}', "");
    Expect(0, 64336, '\p{inalphabeticpf}', "");
    Expect(1, 64336, '\p{^inalphabeticpf}', "");
    Expect(1, 64336, '\P{inalphabeticpf}', "");
    Expect(0, 64336, '\P{^inalphabeticpf}', "");
    Expect(1, 64335, '\p{  IN_alphabetic_PF}', "");
    Expect(0, 64335, '\p{^  IN_alphabetic_PF}', "");
    Expect(0, 64335, '\P{  IN_alphabetic_PF}', "");
    Expect(1, 64335, '\P{^  IN_alphabetic_PF}', "");
    Expect(0, 64336, '\p{  IN_alphabetic_PF}', "");
    Expect(1, 64336, '\p{^  IN_alphabetic_PF}', "");
    Expect(1, 64336, '\P{  IN_alphabetic_PF}', "");
    Expect(0, 64336, '\P{^  IN_alphabetic_PF}', "");
    Error('\p{	:=ANATOLIAN_Hieroglyphs}');
    Error('\P{	:=ANATOLIAN_Hieroglyphs}');
    Expect(1, 83526, '\p{anatolianhieroglyphs}', "");
    Expect(0, 83526, '\p{^anatolianhieroglyphs}', "");
    Expect(0, 83526, '\P{anatolianhieroglyphs}', "");
    Expect(1, 83526, '\P{^anatolianhieroglyphs}', "");
    Expect(0, 83527, '\p{anatolianhieroglyphs}', "");
    Expect(1, 83527, '\p{^anatolianhieroglyphs}', "");
    Expect(1, 83527, '\P{anatolianhieroglyphs}', "");
    Expect(0, 83527, '\P{^anatolianhieroglyphs}', "");
    Expect(1, 83526, '\p{	Anatolian_Hieroglyphs}', "");
    Expect(0, 83526, '\p{^	Anatolian_Hieroglyphs}', "");
    Expect(0, 83526, '\P{	Anatolian_Hieroglyphs}', "");
    Expect(1, 83526, '\P{^	Anatolian_Hieroglyphs}', "");
    Expect(0, 83527, '\p{	Anatolian_Hieroglyphs}', "");
    Expect(1, 83527, '\p{^	Anatolian_Hieroglyphs}', "");
    Expect(1, 83527, '\P{	Anatolian_Hieroglyphs}', "");
    Expect(0, 83527, '\P{^	Anatolian_Hieroglyphs}', "");
    Error('\p{:=		IS_ANATOLIAN_Hieroglyphs}');
    Error('\P{:=		IS_ANATOLIAN_Hieroglyphs}');
    Expect(1, 83526, '\p{isanatolianhieroglyphs}', "");
    Expect(0, 83526, '\p{^isanatolianhieroglyphs}', "");
    Expect(0, 83526, '\P{isanatolianhieroglyphs}', "");
    Expect(1, 83526, '\P{^isanatolianhieroglyphs}', "");
    Expect(0, 83527, '\p{isanatolianhieroglyphs}', "");
    Expect(1, 83527, '\p{^isanatolianhieroglyphs}', "");
    Expect(1, 83527, '\P{isanatolianhieroglyphs}', "");
    Expect(0, 83527, '\P{^isanatolianhieroglyphs}', "");
    Expect(1, 83526, '\p{-IS_anatolian_Hieroglyphs}', "");
    Expect(0, 83526, '\p{^-IS_anatolian_Hieroglyphs}', "");
    Expect(0, 83526, '\P{-IS_anatolian_Hieroglyphs}', "");
    Expect(1, 83526, '\P{^-IS_anatolian_Hieroglyphs}', "");
    Expect(0, 83527, '\p{-IS_anatolian_Hieroglyphs}', "");
    Expect(1, 83527, '\p{^-IS_anatolian_Hieroglyphs}', "");
    Expect(1, 83527, '\P{-IS_anatolian_Hieroglyphs}', "");
    Expect(0, 83527, '\P{^-IS_anatolian_Hieroglyphs}', "");
    Error('\p{- hluw:=}');
    Error('\P{- hluw:=}');
    Expect(1, 83526, '\p{hluw}', "");
    Expect(0, 83526, '\p{^hluw}', "");
    Expect(0, 83526, '\P{hluw}', "");
    Expect(1, 83526, '\P{^hluw}', "");
    Expect(0, 83527, '\p{hluw}', "");
    Expect(1, 83527, '\p{^hluw}', "");
    Expect(1, 83527, '\P{hluw}', "");
    Expect(0, 83527, '\P{^hluw}', "");
    Expect(1, 83526, '\p{	_Hluw}', "");
    Expect(0, 83526, '\p{^	_Hluw}', "");
    Expect(0, 83526, '\P{	_Hluw}', "");
    Expect(1, 83526, '\P{^	_Hluw}', "");
    Expect(0, 83527, '\p{	_Hluw}', "");
    Expect(1, 83527, '\p{^	_Hluw}', "");
    Expect(1, 83527, '\P{	_Hluw}', "");
    Expect(0, 83527, '\P{^	_Hluw}', "");
    Error('\p{_:=Is_Hluw}');
    Error('\P{_:=Is_Hluw}');
    Expect(1, 83526, '\p{ishluw}', "");
    Expect(0, 83526, '\p{^ishluw}', "");
    Expect(0, 83526, '\P{ishluw}', "");
    Expect(1, 83526, '\P{^ishluw}', "");
    Expect(0, 83527, '\p{ishluw}', "");
    Expect(1, 83527, '\p{^ishluw}', "");
    Expect(1, 83527, '\P{ishluw}', "");
    Expect(0, 83527, '\P{^ishluw}', "");
    Expect(1, 83526, '\p{ -IS_HLUW}', "");
    Expect(0, 83526, '\p{^ -IS_HLUW}', "");
    Expect(0, 83526, '\P{ -IS_HLUW}', "");
    Expect(1, 83526, '\P{^ -IS_HLUW}', "");
    Expect(0, 83527, '\p{ -IS_HLUW}', "");
    Expect(1, 83527, '\p{^ -IS_HLUW}', "");
    Expect(1, 83527, '\P{ -IS_HLUW}', "");
    Expect(0, 83527, '\P{^ -IS_HLUW}', "");
    Error('\p{_/a/ancient_Greek_Musical_NOTATION}');
    Error('\P{_/a/ancient_Greek_Musical_NOTATION}');
    Expect(1, 119375, '\p{ancientgreekmusicalnotation}', "");
    Expect(0, 119375, '\p{^ancientgreekmusicalnotation}', "");
    Expect(0, 119375, '\P{ancientgreekmusicalnotation}', "");
    Expect(1, 119375, '\P{^ancientgreekmusicalnotation}', "");
    Expect(0, 119376, '\p{ancientgreekmusicalnotation}', "");
    Expect(1, 119376, '\p{^ancientgreekmusicalnotation}', "");
    Expect(1, 119376, '\P{ancientgreekmusicalnotation}', "");
    Expect(0, 119376, '\P{^ancientgreekmusicalnotation}', "");
    Expect(1, 119375, '\p{	 ancient_greek_Musical_Notation}', "");
    Expect(0, 119375, '\p{^	 ancient_greek_Musical_Notation}', "");
    Expect(0, 119375, '\P{	 ancient_greek_Musical_Notation}', "");
    Expect(1, 119375, '\P{^	 ancient_greek_Musical_Notation}', "");
    Expect(0, 119376, '\p{	 ancient_greek_Musical_Notation}', "");
    Expect(1, 119376, '\p{^	 ancient_greek_Musical_Notation}', "");
    Expect(1, 119376, '\P{	 ancient_greek_Musical_Notation}', "");
    Expect(0, 119376, '\P{^	 ancient_greek_Musical_Notation}', "");
    Error('\p{-IS_Ancient_GREEK_musical_Notation:=}');
    Error('\P{-IS_Ancient_GREEK_musical_Notation:=}');
    Expect(1, 119375, '\p{isancientgreekmusicalnotation}', "");
    Expect(0, 119375, '\p{^isancientgreekmusicalnotation}', "");
    Expect(0, 119375, '\P{isancientgreekmusicalnotation}', "");
    Expect(1, 119375, '\P{^isancientgreekmusicalnotation}', "");
    Expect(0, 119376, '\p{isancientgreekmusicalnotation}', "");
    Expect(1, 119376, '\p{^isancientgreekmusicalnotation}', "");
    Expect(1, 119376, '\P{isancientgreekmusicalnotation}', "");
    Expect(0, 119376, '\P{^isancientgreekmusicalnotation}', "");
    Expect(1, 119375, '\p{ 	Is_ancient_GREEK_Musical_Notation}', "");
    Expect(0, 119375, '\p{^ 	Is_ancient_GREEK_Musical_Notation}', "");
    Expect(0, 119375, '\P{ 	Is_ancient_GREEK_Musical_Notation}', "");
    Expect(1, 119375, '\P{^ 	Is_ancient_GREEK_Musical_Notation}', "");
    Expect(0, 119376, '\p{ 	Is_ancient_GREEK_Musical_Notation}', "");
    Expect(1, 119376, '\p{^ 	Is_ancient_GREEK_Musical_Notation}', "");
    Expect(1, 119376, '\P{ 	Is_ancient_GREEK_Musical_Notation}', "");
    Expect(0, 119376, '\P{^ 	Is_ancient_GREEK_Musical_Notation}', "");
    Error('\p{:= 	In_ancient_Greek_Musical_Notation}');
    Error('\P{:= 	In_ancient_Greek_Musical_Notation}');
    Expect(1, 119375, '\p{inancientgreekmusicalnotation}', "");
    Expect(0, 119375, '\p{^inancientgreekmusicalnotation}', "");
    Expect(0, 119375, '\P{inancientgreekmusicalnotation}', "");
    Expect(1, 119375, '\P{^inancientgreekmusicalnotation}', "");
    Expect(0, 119376, '\p{inancientgreekmusicalnotation}', "");
    Expect(1, 119376, '\p{^inancientgreekmusicalnotation}', "");
    Expect(1, 119376, '\P{inancientgreekmusicalnotation}', "");
    Expect(0, 119376, '\P{^inancientgreekmusicalnotation}', "");
    Expect(1, 119375, '\p{--IN_ANCIENT_greek_musical_Notation}', "");
    Expect(0, 119375, '\p{^--IN_ANCIENT_greek_musical_Notation}', "");
    Expect(0, 119375, '\P{--IN_ANCIENT_greek_musical_Notation}', "");
    Expect(1, 119375, '\P{^--IN_ANCIENT_greek_musical_Notation}', "");
    Expect(0, 119376, '\p{--IN_ANCIENT_greek_musical_Notation}', "");
    Expect(1, 119376, '\p{^--IN_ANCIENT_greek_musical_Notation}', "");
    Expect(1, 119376, '\P{--IN_ANCIENT_greek_musical_Notation}', "");
    Expect(0, 119376, '\P{^--IN_ANCIENT_greek_musical_Notation}', "");
    Error('\p{	_Ancient_Greek_Music:=}');
    Error('\P{	_Ancient_Greek_Music:=}');
    Expect(1, 119375, '\p{ancientgreekmusic}', "");
    Expect(0, 119375, '\p{^ancientgreekmusic}', "");
    Expect(0, 119375, '\P{ancientgreekmusic}', "");
    Expect(1, 119375, '\P{^ancientgreekmusic}', "");
    Expect(0, 119376, '\p{ancientgreekmusic}', "");
    Expect(1, 119376, '\p{^ancientgreekmusic}', "");
    Expect(1, 119376, '\P{ancientgreekmusic}', "");
    Expect(0, 119376, '\P{^ancientgreekmusic}', "");
    Expect(1, 119375, '\p{	Ancient_greek_MUSIC}', "");
    Expect(0, 119375, '\p{^	Ancient_greek_MUSIC}', "");
    Expect(0, 119375, '\P{	Ancient_greek_MUSIC}', "");
    Expect(1, 119375, '\P{^	Ancient_greek_MUSIC}', "");
    Expect(0, 119376, '\p{	Ancient_greek_MUSIC}', "");
    Expect(1, 119376, '\p{^	Ancient_greek_MUSIC}', "");
    Expect(1, 119376, '\P{	Ancient_greek_MUSIC}', "");
    Expect(0, 119376, '\P{^	Ancient_greek_MUSIC}', "");
    Error('\p{ 	is_ANCIENT_GREEK_music/a/}');
    Error('\P{ 	is_ANCIENT_GREEK_music/a/}');
    Expect(1, 119375, '\p{isancientgreekmusic}', "");
    Expect(0, 119375, '\p{^isancientgreekmusic}', "");
    Expect(0, 119375, '\P{isancientgreekmusic}', "");
    Expect(1, 119375, '\P{^isancientgreekmusic}', "");
    Expect(0, 119376, '\p{isancientgreekmusic}', "");
    Expect(1, 119376, '\p{^isancientgreekmusic}', "");
    Expect(1, 119376, '\P{isancientgreekmusic}', "");
    Expect(0, 119376, '\P{^isancientgreekmusic}', "");
    Expect(1, 119375, '\p{__Is_Ancient_Greek_Music}', "");
    Expect(0, 119375, '\p{^__Is_Ancient_Greek_Music}', "");
    Expect(0, 119375, '\P{__Is_Ancient_Greek_Music}', "");
    Expect(1, 119375, '\P{^__Is_Ancient_Greek_Music}', "");
    Expect(0, 119376, '\p{__Is_Ancient_Greek_Music}', "");
    Expect(1, 119376, '\p{^__Is_Ancient_Greek_Music}', "");
    Expect(1, 119376, '\P{__Is_Ancient_Greek_Music}', "");
    Expect(0, 119376, '\P{^__Is_Ancient_Greek_Music}', "");
    Error('\p{/a/ -In_ANCIENT_Greek_music}');
    Error('\P{/a/ -In_ANCIENT_Greek_music}');
    Expect(1, 119375, '\p{inancientgreekmusic}', "");
    Expect(0, 119375, '\p{^inancientgreekmusic}', "");
    Expect(0, 119375, '\P{inancientgreekmusic}', "");
    Expect(1, 119375, '\P{^inancientgreekmusic}', "");
    Expect(0, 119376, '\p{inancientgreekmusic}', "");
    Expect(1, 119376, '\p{^inancientgreekmusic}', "");
    Expect(1, 119376, '\P{inancientgreekmusic}', "");
    Expect(0, 119376, '\P{^inancientgreekmusic}', "");
    Expect(1, 119375, '\p{_ In_ancient_GREEK_Music}', "");
    Expect(0, 119375, '\p{^_ In_ancient_GREEK_Music}', "");
    Expect(0, 119375, '\P{_ In_ancient_GREEK_Music}', "");
    Expect(1, 119375, '\P{^_ In_ancient_GREEK_Music}', "");
    Expect(0, 119376, '\p{_ In_ancient_GREEK_Music}', "");
    Expect(1, 119376, '\p{^_ In_ancient_GREEK_Music}', "");
    Expect(1, 119376, '\P{_ In_ancient_GREEK_Music}', "");
    Expect(0, 119376, '\P{^_ In_ancient_GREEK_Music}', "");
    Error('\p{  ancient_greek_numbers:=}');
    Error('\P{  ancient_greek_numbers:=}');
    Expect(1, 65935, '\p{ancientgreeknumbers}', "");
    Expect(0, 65935, '\p{^ancientgreeknumbers}', "");
    Expect(0, 65935, '\P{ancientgreeknumbers}', "");
    Expect(1, 65935, '\P{^ancientgreeknumbers}', "");
    Expect(0, 65936, '\p{ancientgreeknumbers}', "");
    Expect(1, 65936, '\p{^ancientgreeknumbers}', "");
    Expect(1, 65936, '\P{ancientgreeknumbers}', "");
    Expect(0, 65936, '\P{^ancientgreeknumbers}', "");
    Expect(1, 65935, '\p{ 	ancient_greek_numbers}', "");
    Expect(0, 65935, '\p{^ 	ancient_greek_numbers}', "");
    Expect(0, 65935, '\P{ 	ancient_greek_numbers}', "");
    Expect(1, 65935, '\P{^ 	ancient_greek_numbers}', "");
    Expect(0, 65936, '\p{ 	ancient_greek_numbers}', "");
    Expect(1, 65936, '\p{^ 	ancient_greek_numbers}', "");
    Expect(1, 65936, '\P{ 	ancient_greek_numbers}', "");
    Expect(0, 65936, '\P{^ 	ancient_greek_numbers}', "");
    Error('\p{		Is_Ancient_GREEK_numbers/a/}');
    Error('\P{		Is_Ancient_GREEK_numbers/a/}');
    Expect(1, 65935, '\p{isancientgreeknumbers}', "");
    Expect(0, 65935, '\p{^isancientgreeknumbers}', "");
    Expect(0, 65935, '\P{isancientgreeknumbers}', "");
    Expect(1, 65935, '\P{^isancientgreeknumbers}', "");
    Expect(0, 65936, '\p{isancientgreeknumbers}', "");
    Expect(1, 65936, '\p{^isancientgreeknumbers}', "");
    Expect(1, 65936, '\P{isancientgreeknumbers}', "");
    Expect(0, 65936, '\P{^isancientgreeknumbers}', "");
    Expect(1, 65935, '\p{	_IS_ANCIENT_GREEK_Numbers}', "");
    Expect(0, 65935, '\p{^	_IS_ANCIENT_GREEK_Numbers}', "");
    Expect(0, 65935, '\P{	_IS_ANCIENT_GREEK_Numbers}', "");
    Expect(1, 65935, '\P{^	_IS_ANCIENT_GREEK_Numbers}', "");
    Expect(0, 65936, '\p{	_IS_ANCIENT_GREEK_Numbers}', "");
    Expect(1, 65936, '\p{^	_IS_ANCIENT_GREEK_Numbers}', "");
    Expect(1, 65936, '\P{	_IS_ANCIENT_GREEK_Numbers}', "");
    Expect(0, 65936, '\P{^	_IS_ANCIENT_GREEK_Numbers}', "");
    Error('\p{/a/-In_ancient_Greek_numbers}');
    Error('\P{/a/-In_ancient_Greek_numbers}');
    Expect(1, 65935, '\p{inancientgreeknumbers}', "");
    Expect(0, 65935, '\p{^inancientgreeknumbers}', "");
    Expect(0, 65935, '\P{inancientgreeknumbers}', "");
    Expect(1, 65935, '\P{^inancientgreeknumbers}', "");
    Expect(0, 65936, '\p{inancientgreeknumbers}', "");
    Expect(1, 65936, '\p{^inancientgreeknumbers}', "");
    Expect(1, 65936, '\P{inancientgreeknumbers}', "");
    Expect(0, 65936, '\P{^inancientgreeknumbers}', "");
    Expect(1, 65935, '\p{-_IN_ANCIENT_Greek_Numbers}', "");
    Expect(0, 65935, '\p{^-_IN_ANCIENT_Greek_Numbers}', "");
    Expect(0, 65935, '\P{-_IN_ANCIENT_Greek_Numbers}', "");
    Expect(1, 65935, '\P{^-_IN_ANCIENT_Greek_Numbers}', "");
    Expect(0, 65936, '\p{-_IN_ANCIENT_Greek_Numbers}', "");
    Expect(1, 65936, '\p{^-_IN_ANCIENT_Greek_Numbers}', "");
    Expect(1, 65936, '\P{-_IN_ANCIENT_Greek_Numbers}', "");
    Expect(0, 65936, '\P{^-_IN_ANCIENT_Greek_Numbers}', "");
    Error('\p{:=	-ANCIENT_Symbols}');
    Error('\P{:=	-ANCIENT_Symbols}');
    Expect(1, 65999, '\p{ancientsymbols}', "");
    Expect(0, 65999, '\p{^ancientsymbols}', "");
    Expect(0, 65999, '\P{ancientsymbols}', "");
    Expect(1, 65999, '\P{^ancientsymbols}', "");
    Expect(0, 66000, '\p{ancientsymbols}', "");
    Expect(1, 66000, '\p{^ancientsymbols}', "");
    Expect(1, 66000, '\P{ancientsymbols}', "");
    Expect(0, 66000, '\P{^ancientsymbols}', "");
    Expect(1, 65999, '\p{_ Ancient_symbols}', "");
    Expect(0, 65999, '\p{^_ Ancient_symbols}', "");
    Expect(0, 65999, '\P{_ Ancient_symbols}', "");
    Expect(1, 65999, '\P{^_ Ancient_symbols}', "");
    Expect(0, 66000, '\p{_ Ancient_symbols}', "");
    Expect(1, 66000, '\p{^_ Ancient_symbols}', "");
    Expect(1, 66000, '\P{_ Ancient_symbols}', "");
    Expect(0, 66000, '\P{^_ Ancient_symbols}', "");
    Error('\p{  Is_ancient_Symbols/a/}');
    Error('\P{  Is_ancient_Symbols/a/}');
    Expect(1, 65999, '\p{isancientsymbols}', "");
    Expect(0, 65999, '\p{^isancientsymbols}', "");
    Expect(0, 65999, '\P{isancientsymbols}', "");
    Expect(1, 65999, '\P{^isancientsymbols}', "");
    Expect(0, 66000, '\p{isancientsymbols}', "");
    Expect(1, 66000, '\p{^isancientsymbols}', "");
    Expect(1, 66000, '\P{isancientsymbols}', "");
    Expect(0, 66000, '\P{^isancientsymbols}', "");
    Expect(1, 65999, '\p{ 	IS_Ancient_SYMBOLS}', "");
    Expect(0, 65999, '\p{^ 	IS_Ancient_SYMBOLS}', "");
    Expect(0, 65999, '\P{ 	IS_Ancient_SYMBOLS}', "");
    Expect(1, 65999, '\P{^ 	IS_Ancient_SYMBOLS}', "");
    Expect(0, 66000, '\p{ 	IS_Ancient_SYMBOLS}', "");
    Expect(1, 66000, '\p{^ 	IS_Ancient_SYMBOLS}', "");
    Expect(1, 66000, '\P{ 	IS_Ancient_SYMBOLS}', "");
    Expect(0, 66000, '\P{^ 	IS_Ancient_SYMBOLS}', "");
    Error('\p{:=	-IN_Ancient_Symbols}');
    Error('\P{:=	-IN_Ancient_Symbols}');
    Expect(1, 65999, '\p{inancientsymbols}', "");
    Expect(0, 65999, '\p{^inancientsymbols}', "");
    Expect(0, 65999, '\P{inancientsymbols}', "");
    Expect(1, 65999, '\P{^inancientsymbols}', "");
    Expect(0, 66000, '\p{inancientsymbols}', "");
    Expect(1, 66000, '\p{^inancientsymbols}', "");
    Expect(1, 66000, '\P{inancientsymbols}', "");
    Expect(0, 66000, '\P{^inancientsymbols}', "");
    Expect(1, 65999, '\p{- in_Ancient_Symbols}', "");
    Expect(0, 65999, '\p{^- in_Ancient_Symbols}', "");
    Expect(0, 65999, '\P{- in_Ancient_Symbols}', "");
    Expect(1, 65999, '\P{^- in_Ancient_Symbols}', "");
    Expect(0, 66000, '\p{- in_Ancient_Symbols}', "");
    Expect(1, 66000, '\p{^- in_Ancient_Symbols}', "");
    Expect(1, 66000, '\P{- in_Ancient_Symbols}', "");
    Expect(0, 66000, '\P{^- in_Ancient_Symbols}', "");
    Error('\p{:=Any}');
    Error('\P{:=Any}');
    Expect(1, 1, '\p{any}', "");
    Expect(0, 1, '\p{^any}', "");
    Expect(0, 1, '\P{any}', "");
    Expect(1, 1, '\P{^any}', "");
    Expect(0, 8912887, '\p{any}', "");
    Expect(1, 8912887, '\p{^any}', "");
    Expect(1, 8912887, '\P{any}', "");
    Expect(0, 8912887, '\P{^any}', "");
    Expect(1, 1, '\p{--ANY}', "");
    Expect(0, 1, '\p{^--ANY}', "");
    Expect(0, 1, '\P{--ANY}', "");
    Expect(1, 1, '\P{^--ANY}', "");
    Expect(0, 8912887, '\p{--ANY}', "");
    Expect(1, 8912887, '\p{^--ANY}', "");
    Expect(1, 8912887, '\P{--ANY}', "");
    Expect(0, 8912887, '\P{^--ANY}', "");
    Error('\p{_unicode:=}');
    Error('\P{_unicode:=}');
    Expect(1, 1, '\p{unicode}', "");
    Expect(0, 1, '\p{^unicode}', "");
    Expect(0, 1, '\P{unicode}', "");
    Expect(1, 1, '\P{^unicode}', "");
    Expect(0, 8912887, '\p{unicode}', "");
    Expect(1, 8912887, '\p{^unicode}', "");
    Expect(1, 8912887, '\P{unicode}', "");
    Expect(0, 8912887, '\P{^unicode}', "");
    Expect(1, 1, '\p{	_unicode}', "");
    Expect(0, 1, '\p{^	_unicode}', "");
    Expect(0, 1, '\P{	_unicode}', "");
    Expect(1, 1, '\P{^	_unicode}', "");
    Expect(0, 8912887, '\p{	_unicode}', "");
    Expect(1, 8912887, '\p{^	_unicode}', "");
    Expect(1, 8912887, '\P{	_unicode}', "");
    Expect(0, 8912887, '\P{^	_unicode}', "");
    Error('\p{_Is_ANY/a/}');
    Error('\P{_Is_ANY/a/}');
    Expect(1, 1, '\p{isany}', "");
    Expect(0, 1, '\p{^isany}', "");
    Expect(0, 1, '\P{isany}', "");
    Expect(1, 1, '\P{^isany}', "");
    Expect(0, 8912887, '\p{isany}', "");
    Expect(1, 8912887, '\p{^isany}', "");
    Expect(1, 8912887, '\P{isany}', "");
    Expect(0, 8912887, '\P{^isany}', "");
    Expect(1, 1, '\p{--Is_Any}', "");
    Expect(0, 1, '\p{^--Is_Any}', "");
    Expect(0, 1, '\P{--Is_Any}', "");
    Expect(1, 1, '\P{^--Is_Any}', "");
    Expect(0, 8912887, '\p{--Is_Any}', "");
    Expect(1, 8912887, '\p{^--Is_Any}', "");
    Expect(1, 8912887, '\P{--Is_Any}', "");
    Expect(0, 8912887, '\P{^--Is_Any}', "");
    Error('\p{	-Is_UNICODE:=}');
    Error('\P{	-Is_UNICODE:=}');
    Expect(1, 1, '\p{isunicode}', "");
    Expect(0, 1, '\p{^isunicode}', "");
    Expect(0, 1, '\P{isunicode}', "");
    Expect(1, 1, '\P{^isunicode}', "");
    Expect(0, 8912887, '\p{isunicode}', "");
    Expect(1, 8912887, '\p{^isunicode}', "");
    Expect(1, 8912887, '\P{isunicode}', "");
    Expect(0, 8912887, '\P{^isunicode}', "");
    Expect(1, 1, '\p{--is_UNICODE}', "");
    Expect(0, 1, '\p{^--is_UNICODE}', "");
    Expect(0, 1, '\P{--is_UNICODE}', "");
    Expect(1, 1, '\P{^--is_UNICODE}', "");
    Expect(0, 8912887, '\p{--is_UNICODE}', "");
    Expect(1, 8912887, '\p{^--is_UNICODE}', "");
    Expect(1, 8912887, '\P{--is_UNICODE}', "");
    Expect(0, 8912887, '\P{^--is_UNICODE}', "");
    Error('\p{	Arabic:=}');
    Error('\P{	Arabic:=}');
    Expect(1, 126705, '\p{arabic}', "");
    Expect(0, 126705, '\p{^arabic}', "");
    Expect(0, 126705, '\P{arabic}', "");
    Expect(1, 126705, '\P{^arabic}', "");
    Expect(0, 126706, '\p{arabic}', "");
    Expect(1, 126706, '\p{^arabic}', "");
    Expect(1, 126706, '\P{arabic}', "");
    Expect(0, 126706, '\P{^arabic}', "");
    Expect(1, 126705, '\p{ _ARABIC}', "");
    Expect(0, 126705, '\p{^ _ARABIC}', "");
    Expect(0, 126705, '\P{ _ARABIC}', "");
    Expect(1, 126705, '\P{^ _ARABIC}', "");
    Expect(0, 126706, '\p{ _ARABIC}', "");
    Expect(1, 126706, '\p{^ _ARABIC}', "");
    Expect(1, 126706, '\P{ _ARABIC}', "");
    Expect(0, 126706, '\P{^ _ARABIC}', "");
    Error('\p{:=__Is_Arabic}');
    Error('\P{:=__Is_Arabic}');
    Expect(1, 126705, '\p{isarabic}', "");
    Expect(0, 126705, '\p{^isarabic}', "");
    Expect(0, 126705, '\P{isarabic}', "");
    Expect(1, 126705, '\P{^isarabic}', "");
    Expect(0, 126706, '\p{isarabic}', "");
    Expect(1, 126706, '\p{^isarabic}', "");
    Expect(1, 126706, '\P{isarabic}', "");
    Expect(0, 126706, '\P{^isarabic}', "");
    Expect(1, 126705, '\p{	-Is_ARABIC}', "");
    Expect(0, 126705, '\p{^	-Is_ARABIC}', "");
    Expect(0, 126705, '\P{	-Is_ARABIC}', "");
    Expect(1, 126705, '\P{^	-Is_ARABIC}', "");
    Expect(0, 126706, '\p{	-Is_ARABIC}', "");
    Expect(1, 126706, '\p{^	-Is_ARABIC}', "");
    Expect(1, 126706, '\P{	-Is_ARABIC}', "");
    Expect(0, 126706, '\P{^	-Is_ARABIC}', "");
    Error('\p{Arab:=}');
    Error('\P{Arab:=}');
    Expect(1, 126705, '\p{arab}', "");
    Expect(0, 126705, '\p{^arab}', "");
    Expect(0, 126705, '\P{arab}', "");
    Expect(1, 126705, '\P{^arab}', "");
    Expect(0, 126706, '\p{arab}', "");
    Expect(1, 126706, '\p{^arab}', "");
    Expect(1, 126706, '\P{arab}', "");
    Expect(0, 126706, '\P{^arab}', "");
    Expect(1, 126705, '\p{_arab}', "");
    Expect(0, 126705, '\p{^_arab}', "");
    Expect(0, 126705, '\P{_arab}', "");
    Expect(1, 126705, '\P{^_arab}', "");
    Expect(0, 126706, '\p{_arab}', "");
    Expect(1, 126706, '\p{^_arab}', "");
    Expect(1, 126706, '\P{_arab}', "");
    Expect(0, 126706, '\P{^_arab}', "");
    Error('\p{ -IS_ARAB:=}');
    Error('\P{ -IS_ARAB:=}');
    Expect(1, 126705, '\p{isarab}', "");
    Expect(0, 126705, '\p{^isarab}', "");
    Expect(0, 126705, '\P{isarab}', "");
    Expect(1, 126705, '\P{^isarab}', "");
    Expect(0, 126706, '\p{isarab}', "");
    Expect(1, 126706, '\p{^isarab}', "");
    Expect(1, 126706, '\P{isarab}', "");
    Expect(0, 126706, '\P{^isarab}', "");
    Expect(1, 126705, '\p{		IS_Arab}', "");
    Expect(0, 126705, '\p{^		IS_Arab}', "");
    Expect(0, 126705, '\P{		IS_Arab}', "");
    Expect(1, 126705, '\P{^		IS_Arab}', "");
    Expect(0, 126706, '\p{		IS_Arab}', "");
    Expect(1, 126706, '\p{^		IS_Arab}', "");
    Expect(1, 126706, '\P{		IS_Arab}', "");
    Expect(0, 126706, '\P{^		IS_Arab}', "");
    Error('\p{/a/ Arabic_Extended_A}');
    Error('\P{/a/ Arabic_Extended_A}');
    Expect(1, 2303, '\p{arabicextendeda}', "");
    Expect(0, 2303, '\p{^arabicextendeda}', "");
    Expect(0, 2303, '\P{arabicextendeda}', "");
    Expect(1, 2303, '\P{^arabicextendeda}', "");
    Expect(0, 2304, '\p{arabicextendeda}', "");
    Expect(1, 2304, '\p{^arabicextendeda}', "");
    Expect(1, 2304, '\P{arabicextendeda}', "");
    Expect(0, 2304, '\P{^arabicextendeda}', "");
    Expect(1, 2303, '\p{	 Arabic_Extended_A}', "");
    Expect(0, 2303, '\p{^	 Arabic_Extended_A}', "");
    Expect(0, 2303, '\P{	 Arabic_Extended_A}', "");
    Expect(1, 2303, '\P{^	 Arabic_Extended_A}', "");
    Expect(0, 2304, '\p{	 Arabic_Extended_A}', "");
    Expect(1, 2304, '\p{^	 Arabic_Extended_A}', "");
    Expect(1, 2304, '\P{	 Arabic_Extended_A}', "");
    Expect(0, 2304, '\P{^	 Arabic_Extended_A}', "");
    Error('\p{/a/	is_Arabic_Extended_A}');
    Error('\P{/a/	is_Arabic_Extended_A}');
    Expect(1, 2303, '\p{isarabicextendeda}', "");
    Expect(0, 2303, '\p{^isarabicextendeda}', "");
    Expect(0, 2303, '\P{isarabicextendeda}', "");
    Expect(1, 2303, '\P{^isarabicextendeda}', "");
    Expect(0, 2304, '\p{isarabicextendeda}', "");
    Expect(1, 2304, '\p{^isarabicextendeda}', "");
    Expect(1, 2304, '\P{isarabicextendeda}', "");
    Expect(0, 2304, '\P{^isarabicextendeda}', "");
    Expect(1, 2303, '\p{		is_Arabic_Extended_A}', "");
    Expect(0, 2303, '\p{^		is_Arabic_Extended_A}', "");
    Expect(0, 2303, '\P{		is_Arabic_Extended_A}', "");
    Expect(1, 2303, '\P{^		is_Arabic_Extended_A}', "");
    Expect(0, 2304, '\p{		is_Arabic_Extended_A}', "");
    Expect(1, 2304, '\p{^		is_Arabic_Extended_A}', "");
    Expect(1, 2304, '\P{		is_Arabic_Extended_A}', "");
    Expect(0, 2304, '\P{^		is_Arabic_Extended_A}', "");
    Error('\p{ _In_Arabic_EXTENDED_A:=}');
    Error('\P{ _In_Arabic_EXTENDED_A:=}');
    Expect(1, 2303, '\p{inarabicextendeda}', "");
    Expect(0, 2303, '\p{^inarabicextendeda}', "");
    Expect(0, 2303, '\P{inarabicextendeda}', "");
    Expect(1, 2303, '\P{^inarabicextendeda}', "");
    Expect(0, 2304, '\p{inarabicextendeda}', "");
    Expect(1, 2304, '\p{^inarabicextendeda}', "");
    Expect(1, 2304, '\P{inarabicextendeda}', "");
    Expect(0, 2304, '\P{^inarabicextendeda}', "");
    Expect(1, 2303, '\p{		In_arabic_EXTENDED_A}', "");
    Expect(0, 2303, '\p{^		In_arabic_EXTENDED_A}', "");
    Expect(0, 2303, '\P{		In_arabic_EXTENDED_A}', "");
    Expect(1, 2303, '\P{^		In_arabic_EXTENDED_A}', "");
    Expect(0, 2304, '\p{		In_arabic_EXTENDED_A}', "");
    Expect(1, 2304, '\p{^		In_arabic_EXTENDED_A}', "");
    Expect(1, 2304, '\P{		In_arabic_EXTENDED_A}', "");
    Expect(0, 2304, '\P{^		In_arabic_EXTENDED_A}', "");
    Error('\p{ :=ARABIC_ext_A}');
    Error('\P{ :=ARABIC_ext_A}');
    Expect(1, 2303, '\p{arabicexta}', "");
    Expect(0, 2303, '\p{^arabicexta}', "");
    Expect(0, 2303, '\P{arabicexta}', "");
    Expect(1, 2303, '\P{^arabicexta}', "");
    Expect(0, 2304, '\p{arabicexta}', "");
    Expect(1, 2304, '\p{^arabicexta}', "");
    Expect(1, 2304, '\P{arabicexta}', "");
    Expect(0, 2304, '\P{^arabicexta}', "");
    Expect(1, 2303, '\p{_ARABIC_ext_a}', "");
    Expect(0, 2303, '\p{^_ARABIC_ext_a}', "");
    Expect(0, 2303, '\P{_ARABIC_ext_a}', "");
    Expect(1, 2303, '\P{^_ARABIC_ext_a}', "");
    Expect(0, 2304, '\p{_ARABIC_ext_a}', "");
    Expect(1, 2304, '\p{^_ARABIC_ext_a}', "");
    Expect(1, 2304, '\P{_ARABIC_ext_a}', "");
    Expect(0, 2304, '\P{^_ARABIC_ext_a}', "");
    Error('\p{/a/IS_ARABIC_Ext_a}');
    Error('\P{/a/IS_ARABIC_Ext_a}');
    Expect(1, 2303, '\p{isarabicexta}', "");
    Expect(0, 2303, '\p{^isarabicexta}', "");
    Expect(0, 2303, '\P{isarabicexta}', "");
    Expect(1, 2303, '\P{^isarabicexta}', "");
    Expect(0, 2304, '\p{isarabicexta}', "");
    Expect(1, 2304, '\p{^isarabicexta}', "");
    Expect(1, 2304, '\P{isarabicexta}', "");
    Expect(0, 2304, '\P{^isarabicexta}', "");
    Expect(1, 2303, '\p{--IS_Arabic_EXT_A}', "");
    Expect(0, 2303, '\p{^--IS_Arabic_EXT_A}', "");
    Expect(0, 2303, '\P{--IS_Arabic_EXT_A}', "");
    Expect(1, 2303, '\P{^--IS_Arabic_EXT_A}', "");
    Expect(0, 2304, '\p{--IS_Arabic_EXT_A}', "");
    Expect(1, 2304, '\p{^--IS_Arabic_EXT_A}', "");
    Expect(1, 2304, '\P{--IS_Arabic_EXT_A}', "");
    Expect(0, 2304, '\P{^--IS_Arabic_EXT_A}', "");
    Error('\p{	_IN_arabic_Ext_A:=}');
    Error('\P{	_IN_arabic_Ext_A:=}');
    Expect(1, 2303, '\p{inarabicexta}', "");
    Expect(0, 2303, '\p{^inarabicexta}', "");
    Expect(0, 2303, '\P{inarabicexta}', "");
    Expect(1, 2303, '\P{^inarabicexta}', "");
    Expect(0, 2304, '\p{inarabicexta}', "");
    Expect(1, 2304, '\p{^inarabicexta}', "");
    Expect(1, 2304, '\P{inarabicexta}', "");
    Expect(0, 2304, '\P{^inarabicexta}', "");
    Expect(1, 2303, '\p{-In_Arabic_ext_A}', "");
    Expect(0, 2303, '\p{^-In_Arabic_ext_A}', "");
    Expect(0, 2303, '\P{-In_Arabic_ext_A}', "");
    Expect(1, 2303, '\P{^-In_Arabic_ext_A}', "");
    Expect(0, 2304, '\p{-In_Arabic_ext_A}', "");
    Expect(1, 2304, '\p{^-In_Arabic_ext_A}', "");
    Expect(1, 2304, '\P{-In_Arabic_ext_A}', "");
    Expect(0, 2304, '\P{^-In_Arabic_ext_A}', "");
    Error('\p{_/a/Arabic_Extended_B}');
    Error('\P{_/a/Arabic_Extended_B}');
    Expect(1, 2207, '\p{arabicextendedb}', "");
    Expect(0, 2207, '\p{^arabicextendedb}', "");
    Expect(0, 2207, '\P{arabicextendedb}', "");
    Expect(1, 2207, '\P{^arabicextendedb}', "");
    Expect(0, 2208, '\p{arabicextendedb}', "");
    Expect(1, 2208, '\p{^arabicextendedb}', "");
    Expect(1, 2208, '\P{arabicextendedb}', "");
    Expect(0, 2208, '\P{^arabicextendedb}', "");
    Expect(1, 2207, '\p{	-Arabic_Extended_B}', "");
    Expect(0, 2207, '\p{^	-Arabic_Extended_B}', "");
    Expect(0, 2207, '\P{	-Arabic_Extended_B}', "");
    Expect(1, 2207, '\P{^	-Arabic_Extended_B}', "");
    Expect(0, 2208, '\p{	-Arabic_Extended_B}', "");
    Expect(1, 2208, '\p{^	-Arabic_Extended_B}', "");
    Expect(1, 2208, '\P{	-Arabic_Extended_B}', "");
    Expect(0, 2208, '\P{^	-Arabic_Extended_B}', "");
    Error('\p{_/a/Is_Arabic_Extended_B}');
    Error('\P{_/a/Is_Arabic_Extended_B}');
    Expect(1, 2207, '\p{isarabicextendedb}', "");
    Expect(0, 2207, '\p{^isarabicextendedb}', "");
    Expect(0, 2207, '\P{isarabicextendedb}', "");
    Expect(1, 2207, '\P{^isarabicextendedb}', "");
    Expect(0, 2208, '\p{isarabicextendedb}', "");
    Expect(1, 2208, '\p{^isarabicextendedb}', "");
    Expect(1, 2208, '\P{isarabicextendedb}', "");
    Expect(0, 2208, '\P{^isarabicextendedb}', "");
    Expect(1, 2207, '\p{ Is_Arabic_EXTENDED_B}', "");
    Expect(0, 2207, '\p{^ Is_Arabic_EXTENDED_B}', "");
    Expect(0, 2207, '\P{ Is_Arabic_EXTENDED_B}', "");
    Expect(1, 2207, '\P{^ Is_Arabic_EXTENDED_B}', "");
    Expect(0, 2208, '\p{ Is_Arabic_EXTENDED_B}', "");
    Expect(1, 2208, '\p{^ Is_Arabic_EXTENDED_B}', "");
    Expect(1, 2208, '\P{ Is_Arabic_EXTENDED_B}', "");
    Expect(0, 2208, '\P{^ Is_Arabic_EXTENDED_B}', "");
    Error('\p{_/a/in_Arabic_Extended_b}');
    Error('\P{_/a/in_Arabic_Extended_b}');
    Expect(1, 2207, '\p{inarabicextendedb}', "");
    Expect(0, 2207, '\p{^inarabicextendedb}', "");
    Expect(0, 2207, '\P{inarabicextendedb}', "");
    Expect(1, 2207, '\P{^inarabicextendedb}', "");
    Expect(0, 2208, '\p{inarabicextendedb}', "");
    Expect(1, 2208, '\p{^inarabicextendedb}', "");
    Expect(1, 2208, '\P{inarabicextendedb}', "");
    Expect(0, 2208, '\P{^inarabicextendedb}', "");
    Expect(1, 2207, '\p{ _IN_arabic_Extended_B}', "");
    Expect(0, 2207, '\p{^ _IN_arabic_Extended_B}', "");
    Expect(0, 2207, '\P{ _IN_arabic_Extended_B}', "");
    Expect(1, 2207, '\P{^ _IN_arabic_Extended_B}', "");
    Expect(0, 2208, '\p{ _IN_arabic_Extended_B}', "");
    Expect(1, 2208, '\p{^ _IN_arabic_Extended_B}', "");
    Expect(1, 2208, '\P{ _IN_arabic_Extended_B}', "");
    Expect(0, 2208, '\P{^ _IN_arabic_Extended_B}', "");
    Error('\p{/a/	ARABIC_ext_B}');
    Error('\P{/a/	ARABIC_ext_B}');
    Expect(1, 2207, '\p{arabicextb}', "");
    Expect(0, 2207, '\p{^arabicextb}', "");
    Expect(0, 2207, '\P{arabicextb}', "");
    Expect(1, 2207, '\P{^arabicextb}', "");
    Expect(0, 2208, '\p{arabicextb}', "");
    Expect(1, 2208, '\p{^arabicextb}', "");
    Expect(1, 2208, '\P{arabicextb}', "");
    Expect(0, 2208, '\P{^arabicextb}', "");
    Expect(1, 2207, '\p{-_Arabic_EXT_B}', "");
    Expect(0, 2207, '\p{^-_Arabic_EXT_B}', "");
    Expect(0, 2207, '\P{-_Arabic_EXT_B}', "");
    Expect(1, 2207, '\P{^-_Arabic_EXT_B}', "");
    Expect(0, 2208, '\p{-_Arabic_EXT_B}', "");
    Expect(1, 2208, '\p{^-_Arabic_EXT_B}', "");
    Expect(1, 2208, '\P{-_Arabic_EXT_B}', "");
    Expect(0, 2208, '\P{^-_Arabic_EXT_B}', "");
    Error('\p{:=is_ARABIC_Ext_B}');
    Error('\P{:=is_ARABIC_Ext_B}');
    Expect(1, 2207, '\p{isarabicextb}', "");
    Expect(0, 2207, '\p{^isarabicextb}', "");
    Expect(0, 2207, '\P{isarabicextb}', "");
    Expect(1, 2207, '\P{^isarabicextb}', "");
    Expect(0, 2208, '\p{isarabicextb}', "");
    Expect(1, 2208, '\p{^isarabicextb}', "");
    Expect(1, 2208, '\P{isarabicextb}', "");
    Expect(0, 2208, '\P{^isarabicextb}', "");
    Expect(1, 2207, '\p{	is_Arabic_Ext_B}', "");
    Expect(0, 2207, '\p{^	is_Arabic_Ext_B}', "");
    Expect(0, 2207, '\P{	is_Arabic_Ext_B}', "");
    Expect(1, 2207, '\P{^	is_Arabic_Ext_B}', "");
    Expect(0, 2208, '\p{	is_Arabic_Ext_B}', "");
    Expect(1, 2208, '\p{^	is_Arabic_Ext_B}', "");
    Expect(1, 2208, '\P{	is_Arabic_Ext_B}', "");
    Expect(0, 2208, '\P{^	is_Arabic_Ext_B}', "");
    Error('\p{/a/-_In_ARABIC_Ext_B}');
    Error('\P{/a/-_In_ARABIC_Ext_B}');
    Expect(1, 2207, '\p{inarabicextb}', "");
    Expect(0, 2207, '\p{^inarabicextb}', "");
    Expect(0, 2207, '\P{inarabicextb}', "");
    Expect(1, 2207, '\P{^inarabicextb}', "");
    Expect(0, 2208, '\p{inarabicextb}', "");
    Expect(1, 2208, '\p{^inarabicextb}', "");
    Expect(1, 2208, '\P{inarabicextb}', "");
    Expect(0, 2208, '\P{^inarabicextb}', "");
    Expect(1, 2207, '\p{_ In_Arabic_Ext_B}', "");
    Expect(0, 2207, '\p{^_ In_Arabic_Ext_B}', "");
    Expect(0, 2207, '\P{_ In_Arabic_Ext_B}', "");
    Expect(1, 2207, '\P{^_ In_Arabic_Ext_B}', "");
    Expect(0, 2208, '\p{_ In_Arabic_Ext_B}', "");
    Expect(1, 2208, '\p{^_ In_Arabic_Ext_B}', "");
    Expect(1, 2208, '\P{_ In_Arabic_Ext_B}', "");
    Expect(0, 2208, '\P{^_ In_Arabic_Ext_B}', "");
    Error('\p{/a/Arabic_EXTENDED_c}');
    Error('\P{/a/Arabic_EXTENDED_c}');
    Expect(1, 69375, '\p{arabicextendedc}', "");
    Expect(0, 69375, '\p{^arabicextendedc}', "");
    Expect(0, 69375, '\P{arabicextendedc}', "");
    Expect(1, 69375, '\P{^arabicextendedc}', "");
    Expect(0, 69376, '\p{arabicextendedc}', "");
    Expect(1, 69376, '\p{^arabicextendedc}', "");
    Expect(1, 69376, '\P{arabicextendedc}', "");
    Expect(0, 69376, '\P{^arabicextendedc}', "");
    Expect(1, 69375, '\p{_arabic_extended_C}', "");
    Expect(0, 69375, '\p{^_arabic_extended_C}', "");
    Expect(0, 69375, '\P{_arabic_extended_C}', "");
    Expect(1, 69375, '\P{^_arabic_extended_C}', "");
    Expect(0, 69376, '\p{_arabic_extended_C}', "");
    Expect(1, 69376, '\p{^_arabic_extended_C}', "");
    Expect(1, 69376, '\P{_arabic_extended_C}', "");
    Expect(0, 69376, '\P{^_arabic_extended_C}', "");
    Error('\p{/a/_	Is_arabic_Extended_C}');
    Error('\P{/a/_	Is_arabic_Extended_C}');
    Expect(1, 69375, '\p{isarabicextendedc}', "");
    Expect(0, 69375, '\p{^isarabicextendedc}', "");
    Expect(0, 69375, '\P{isarabicextendedc}', "");
    Expect(1, 69375, '\P{^isarabicextendedc}', "");
    Expect(0, 69376, '\p{isarabicextendedc}', "");
    Expect(1, 69376, '\p{^isarabicextendedc}', "");
    Expect(1, 69376, '\P{isarabicextendedc}', "");
    Expect(0, 69376, '\P{^isarabicextendedc}', "");
    Expect(1, 69375, '\p{ _Is_ARABIC_extended_C}', "");
    Expect(0, 69375, '\p{^ _Is_ARABIC_extended_C}', "");
    Expect(0, 69375, '\P{ _Is_ARABIC_extended_C}', "");
    Expect(1, 69375, '\P{^ _Is_ARABIC_extended_C}', "");
    Expect(0, 69376, '\p{ _Is_ARABIC_extended_C}', "");
    Expect(1, 69376, '\p{^ _Is_ARABIC_extended_C}', "");
    Expect(1, 69376, '\P{ _Is_ARABIC_extended_C}', "");
    Expect(0, 69376, '\P{^ _Is_ARABIC_extended_C}', "");
    Error('\p{-IN_arabic_Extended_C/a/}');
    Error('\P{-IN_arabic_Extended_C/a/}');
    Expect(1, 69375, '\p{inarabicextendedc}', "");
    Expect(0, 69375, '\p{^inarabicextendedc}', "");
    Expect(0, 69375, '\P{inarabicextendedc}', "");
    Expect(1, 69375, '\P{^inarabicextendedc}', "");
    Expect(0, 69376, '\p{inarabicextendedc}', "");
    Expect(1, 69376, '\p{^inarabicextendedc}', "");
    Expect(1, 69376, '\P{inarabicextendedc}', "");
    Expect(0, 69376, '\P{^inarabicextendedc}', "");
    Expect(1, 69375, '\p{ In_Arabic_Extended_c}', "");
    Expect(0, 69375, '\p{^ In_Arabic_Extended_c}', "");
    Expect(0, 69375, '\P{ In_Arabic_Extended_c}', "");
    Expect(1, 69375, '\P{^ In_Arabic_Extended_c}', "");
    Expect(0, 69376, '\p{ In_Arabic_Extended_c}', "");
    Expect(1, 69376, '\p{^ In_Arabic_Extended_c}', "");
    Expect(1, 69376, '\P{ In_Arabic_Extended_c}', "");
    Expect(0, 69376, '\P{^ In_Arabic_Extended_c}', "");
    Error('\p{	_Arabic_Ext_c/a/}');
    Error('\P{	_Arabic_Ext_c/a/}');
    Expect(1, 69375, '\p{arabicextc}', "");
    Expect(0, 69375, '\p{^arabicextc}', "");
    Expect(0, 69375, '\P{arabicextc}', "");
    Expect(1, 69375, '\P{^arabicextc}', "");
    Expect(0, 69376, '\p{arabicextc}', "");
    Expect(1, 69376, '\p{^arabicextc}', "");
    Expect(1, 69376, '\P{arabicextc}', "");
    Expect(0, 69376, '\P{^arabicextc}', "");
    Expect(1, 69375, '\p{ _Arabic_ext_C}', "");
    Expect(0, 69375, '\p{^ _Arabic_ext_C}', "");
    Expect(0, 69375, '\P{ _Arabic_ext_C}', "");
    Expect(1, 69375, '\P{^ _Arabic_ext_C}', "");
    Expect(0, 69376, '\p{ _Arabic_ext_C}', "");
    Expect(1, 69376, '\p{^ _Arabic_ext_C}', "");
    Expect(1, 69376, '\P{ _Arabic_ext_C}', "");
    Expect(0, 69376, '\P{^ _Arabic_ext_C}', "");
    Error('\p{_ IS_Arabic_Ext_C:=}');
    Error('\P{_ IS_Arabic_Ext_C:=}');
    Expect(1, 69375, '\p{isarabicextc}', "");
    Expect(0, 69375, '\p{^isarabicextc}', "");
    Expect(0, 69375, '\P{isarabicextc}', "");
    Expect(1, 69375, '\P{^isarabicextc}', "");
    Expect(0, 69376, '\p{isarabicextc}', "");
    Expect(1, 69376, '\p{^isarabicextc}', "");
    Expect(1, 69376, '\P{isarabicextc}', "");
    Expect(0, 69376, '\P{^isarabicextc}', "");
    Expect(1, 69375, '\p{- is_arabic_Ext_C}', "");
    Expect(0, 69375, '\p{^- is_arabic_Ext_C}', "");
    Expect(0, 69375, '\P{- is_arabic_Ext_C}', "");
    Expect(1, 69375, '\P{^- is_arabic_Ext_C}', "");
    Expect(0, 69376, '\p{- is_arabic_Ext_C}', "");
    Expect(1, 69376, '\p{^- is_arabic_Ext_C}', "");
    Expect(1, 69376, '\P{- is_arabic_Ext_C}', "");
    Expect(0, 69376, '\P{^- is_arabic_Ext_C}', "");
    Error('\p{-:=In_Arabic_EXT_c}');
    Error('\P{-:=In_Arabic_EXT_c}');
    Expect(1, 69375, '\p{inarabicextc}', "");
    Expect(0, 69375, '\p{^inarabicextc}', "");
    Expect(0, 69375, '\P{inarabicextc}', "");
    Expect(1, 69375, '\P{^inarabicextc}', "");
    Expect(0, 69376, '\p{inarabicextc}', "");
    Expect(1, 69376, '\p{^inarabicextc}', "");
    Expect(1, 69376, '\P{inarabicextc}', "");
    Expect(0, 69376, '\P{^inarabicextc}', "");
    Expect(1, 69375, '\p{_In_Arabic_Ext_C}', "");
    Expect(0, 69375, '\p{^_In_Arabic_Ext_C}', "");
    Expect(0, 69375, '\P{_In_Arabic_Ext_C}', "");
    Expect(1, 69375, '\P{^_In_Arabic_Ext_C}', "");
    Expect(0, 69376, '\p{_In_Arabic_Ext_C}', "");
    Expect(1, 69376, '\p{^_In_Arabic_Ext_C}', "");
    Expect(1, 69376, '\P{_In_Arabic_Ext_C}', "");
    Expect(0, 69376, '\P{^_In_Arabic_Ext_C}', "");
    Error('\p{:= _Arabic_Mathematical_alphabetic_symbols}');
    Error('\P{:= _Arabic_Mathematical_alphabetic_symbols}');
    Expect(1, 126719, '\p{arabicmathematicalalphabeticsymbols}', "");
    Expect(0, 126719, '\p{^arabicmathematicalalphabeticsymbols}', "");
    Expect(0, 126719, '\P{arabicmathematicalalphabeticsymbols}', "");
    Expect(1, 126719, '\P{^arabicmathematicalalphabeticsymbols}', "");
    Expect(0, 126720, '\p{arabicmathematicalalphabeticsymbols}', "");
    Expect(1, 126720, '\p{^arabicmathematicalalphabeticsymbols}', "");
    Expect(1, 126720, '\P{arabicmathematicalalphabeticsymbols}', "");
    Expect(0, 126720, '\P{^arabicmathematicalalphabeticsymbols}', "");
    Expect(1, 126719, '\p{-_Arabic_mathematical_alphabetic_SYMBOLS}', "");
    Expect(0, 126719, '\p{^-_Arabic_mathematical_alphabetic_SYMBOLS}', "");
    Expect(0, 126719, '\P{-_Arabic_mathematical_alphabetic_SYMBOLS}', "");
    Expect(1, 126719, '\P{^-_Arabic_mathematical_alphabetic_SYMBOLS}', "");
    Expect(0, 126720, '\p{-_Arabic_mathematical_alphabetic_SYMBOLS}', "");
    Expect(1, 126720, '\p{^-_Arabic_mathematical_alphabetic_SYMBOLS}', "");
    Expect(1, 126720, '\P{-_Arabic_mathematical_alphabetic_SYMBOLS}', "");
    Expect(0, 126720, '\P{^-_Arabic_mathematical_alphabetic_SYMBOLS}', "");
    Error('\p{ :=IS_ARABIC_MATHEMATICAL_alphabetic_Symbols}');
    Error('\P{ :=IS_ARABIC_MATHEMATICAL_alphabetic_Symbols}');
    Expect(1, 126719, '\p{isarabicmathematicalalphabeticsymbols}', "");
    Expect(0, 126719, '\p{^isarabicmathematicalalphabeticsymbols}', "");
    Expect(0, 126719, '\P{isarabicmathematicalalphabeticsymbols}', "");
    Expect(1, 126719, '\P{^isarabicmathematicalalphabeticsymbols}', "");
    Expect(0, 126720, '\p{isarabicmathematicalalphabeticsymbols}', "");
    Expect(1, 126720, '\p{^isarabicmathematicalalphabeticsymbols}', "");
    Expect(1, 126720, '\P{isarabicmathematicalalphabeticsymbols}', "");
    Expect(0, 126720, '\P{^isarabicmathematicalalphabeticsymbols}', "");
    Expect(1, 126719, '\p{_	Is_Arabic_Mathematical_Alphabetic_symbols}', "");
    Expect(0, 126719, '\p{^_	Is_Arabic_Mathematical_Alphabetic_symbols}', "");
    Expect(0, 126719, '\P{_	Is_Arabic_Mathematical_Alphabetic_symbols}', "");
    Expect(1, 126719, '\P{^_	Is_Arabic_Mathematical_Alphabetic_symbols}', "");
    Expect(0, 126720, '\p{_	Is_Arabic_Mathematical_Alphabetic_symbols}', "");
    Expect(1, 126720, '\p{^_	Is_Arabic_Mathematical_Alphabetic_symbols}', "");
    Expect(1, 126720, '\P{_	Is_Arabic_Mathematical_Alphabetic_symbols}', "");
    Expect(0, 126720, '\P{^_	Is_Arabic_Mathematical_Alphabetic_symbols}', "");
    Error('\p{	:=IN_Arabic_mathematical_Alphabetic_SYMBOLS}');
    Error('\P{	:=IN_Arabic_mathematical_Alphabetic_SYMBOLS}');
    Expect(1, 126719, '\p{inarabicmathematicalalphabeticsymbols}', "");
    Expect(0, 126719, '\p{^inarabicmathematicalalphabeticsymbols}', "");
    Expect(0, 126719, '\P{inarabicmathematicalalphabeticsymbols}', "");
    Expect(1, 126719, '\P{^inarabicmathematicalalphabeticsymbols}', "");
    Expect(0, 126720, '\p{inarabicmathematicalalphabeticsymbols}', "");
    Expect(1, 126720, '\p{^inarabicmathematicalalphabeticsymbols}', "");
    Expect(1, 126720, '\P{inarabicmathematicalalphabeticsymbols}', "");
    Expect(0, 126720, '\P{^inarabicmathematicalalphabeticsymbols}', "");
    Expect(1, 126719, '\p{ _In_ARABIC_Mathematical_Alphabetic_Symbols}', "");
    Expect(0, 126719, '\p{^ _In_ARABIC_Mathematical_Alphabetic_Symbols}', "");
    Expect(0, 126719, '\P{ _In_ARABIC_Mathematical_Alphabetic_Symbols}', "");
    Expect(1, 126719, '\P{^ _In_ARABIC_Mathematical_Alphabetic_Symbols}', "");
    Expect(0, 126720, '\p{ _In_ARABIC_Mathematical_Alphabetic_Symbols}', "");
    Expect(1, 126720, '\p{^ _In_ARABIC_Mathematical_Alphabetic_Symbols}', "");
    Expect(1, 126720, '\P{ _In_ARABIC_Mathematical_Alphabetic_Symbols}', "");
    Expect(0, 126720, '\P{^ _In_ARABIC_Mathematical_Alphabetic_Symbols}', "");
    Error('\p{_:=Arabic_Math}');
    Error('\P{_:=Arabic_Math}');
    Expect(1, 126719, '\p{arabicmath}', "");
    Expect(0, 126719, '\p{^arabicmath}', "");
    Expect(0, 126719, '\P{arabicmath}', "");
    Expect(1, 126719, '\P{^arabicmath}', "");
    Expect(0, 126720, '\p{arabicmath}', "");
    Expect(1, 126720, '\p{^arabicmath}', "");
    Expect(1, 126720, '\P{arabicmath}', "");
    Expect(0, 126720, '\P{^arabicmath}', "");
    Expect(1, 126719, '\p{_Arabic_MATH}', "");
    Expect(0, 126719, '\p{^_Arabic_MATH}', "");
    Expect(0, 126719, '\P{_Arabic_MATH}', "");
    Expect(1, 126719, '\P{^_Arabic_MATH}', "");
    Expect(0, 126720, '\p{_Arabic_MATH}', "");
    Expect(1, 126720, '\p{^_Arabic_MATH}', "");
    Expect(1, 126720, '\P{_Arabic_MATH}', "");
    Expect(0, 126720, '\P{^_Arabic_MATH}', "");
    Error('\p{:= IS_Arabic_Math}');
    Error('\P{:= IS_Arabic_Math}');
    Expect(1, 126719, '\p{isarabicmath}', "");
    Expect(0, 126719, '\p{^isarabicmath}', "");
    Expect(0, 126719, '\P{isarabicmath}', "");
    Expect(1, 126719, '\P{^isarabicmath}', "");
    Expect(0, 126720, '\p{isarabicmath}', "");
    Expect(1, 126720, '\p{^isarabicmath}', "");
    Expect(1, 126720, '\P{isarabicmath}', "");
    Expect(0, 126720, '\P{^isarabicmath}', "");
    Expect(1, 126719, '\p{	is_ARABIC_Math}', "");
    Expect(0, 126719, '\p{^	is_ARABIC_Math}', "");
    Expect(0, 126719, '\P{	is_ARABIC_Math}', "");
    Expect(1, 126719, '\P{^	is_ARABIC_Math}', "");
    Expect(0, 126720, '\p{	is_ARABIC_Math}', "");
    Expect(1, 126720, '\p{^	is_ARABIC_Math}', "");
    Expect(1, 126720, '\P{	is_ARABIC_Math}', "");
    Expect(0, 126720, '\P{^	is_ARABIC_Math}', "");
    Error('\p{-in_Arabic_math/a/}');
    Error('\P{-in_Arabic_math/a/}');
    Expect(1, 126719, '\p{inarabicmath}', "");
    Expect(0, 126719, '\p{^inarabicmath}', "");
    Expect(0, 126719, '\P{inarabicmath}', "");
    Expect(1, 126719, '\P{^inarabicmath}', "");
    Expect(0, 126720, '\p{inarabicmath}', "");
    Expect(1, 126720, '\p{^inarabicmath}', "");
    Expect(1, 126720, '\P{inarabicmath}', "");
    Expect(0, 126720, '\P{^inarabicmath}', "");
    Expect(1, 126719, '\p{ 	IN_Arabic_Math}', "");
    Expect(0, 126719, '\p{^ 	IN_Arabic_Math}', "");
    Expect(0, 126719, '\P{ 	IN_Arabic_Math}', "");
    Expect(1, 126719, '\P{^ 	IN_Arabic_Math}', "");
    Expect(0, 126720, '\p{ 	IN_Arabic_Math}', "");
    Expect(1, 126720, '\p{^ 	IN_Arabic_Math}', "");
    Expect(1, 126720, '\P{ 	IN_Arabic_Math}', "");
    Expect(0, 126720, '\P{^ 	IN_Arabic_Math}', "");
    Error('\p{	:=arabic_Presentation_Forms_a}');
    Error('\P{	:=arabic_Presentation_Forms_a}');
    Expect(1, 65023, '\p{arabicpresentationformsa}', "");
    Expect(0, 65023, '\p{^arabicpresentationformsa}', "");
    Expect(0, 65023, '\P{arabicpresentationformsa}', "");
    Expect(1, 65023, '\P{^arabicpresentationformsa}', "");
    Expect(0, 65024, '\p{arabicpresentationformsa}', "");
    Expect(1, 65024, '\p{^arabicpresentationformsa}', "");
    Expect(1, 65024, '\P{arabicpresentationformsa}', "");
    Expect(0, 65024, '\P{^arabicpresentationformsa}', "");
    Expect(1, 65023, '\p{-	Arabic_Presentation_Forms_A}', "");
    Expect(0, 65023, '\p{^-	Arabic_Presentation_Forms_A}', "");
    Expect(0, 65023, '\P{-	Arabic_Presentation_Forms_A}', "");
    Expect(1, 65023, '\P{^-	Arabic_Presentation_Forms_A}', "");
    Expect(0, 65024, '\p{-	Arabic_Presentation_Forms_A}', "");
    Expect(1, 65024, '\p{^-	Arabic_Presentation_Forms_A}', "");
    Expect(1, 65024, '\P{-	Arabic_Presentation_Forms_A}', "");
    Expect(0, 65024, '\P{^-	Arabic_Presentation_Forms_A}', "");
    Error('\p{	-Is_Arabic_Presentation_Forms_a/a/}');
    Error('\P{	-Is_Arabic_Presentation_Forms_a/a/}');
    Expect(1, 65023, '\p{isarabicpresentationformsa}', "");
    Expect(0, 65023, '\p{^isarabicpresentationformsa}', "");
    Expect(0, 65023, '\P{isarabicpresentationformsa}', "");
    Expect(1, 65023, '\P{^isarabicpresentationformsa}', "");
    Expect(0, 65024, '\p{isarabicpresentationformsa}', "");
    Expect(1, 65024, '\p{^isarabicpresentationformsa}', "");
    Expect(1, 65024, '\P{isarabicpresentationformsa}', "");
    Expect(0, 65024, '\P{^isarabicpresentationformsa}', "");
    Expect(1, 65023, '\p{ _IS_arabic_presentation_FORMS_a}', "");
    Expect(0, 65023, '\p{^ _IS_arabic_presentation_FORMS_a}', "");
    Expect(0, 65023, '\P{ _IS_arabic_presentation_FORMS_a}', "");
    Expect(1, 65023, '\P{^ _IS_arabic_presentation_FORMS_a}', "");
    Expect(0, 65024, '\p{ _IS_arabic_presentation_FORMS_a}', "");
    Expect(1, 65024, '\p{^ _IS_arabic_presentation_FORMS_a}', "");
    Expect(1, 65024, '\P{ _IS_arabic_presentation_FORMS_a}', "");
    Expect(0, 65024, '\P{^ _IS_arabic_presentation_FORMS_a}', "");
    Error('\p{-In_arabic_Presentation_FORMS_a/a/}');
    Error('\P{-In_arabic_Presentation_FORMS_a/a/}');
    Expect(1, 65023, '\p{inarabicpresentationformsa}', "");
    Expect(0, 65023, '\p{^inarabicpresentationformsa}', "");
    Expect(0, 65023, '\P{inarabicpresentationformsa}', "");
    Expect(1, 65023, '\P{^inarabicpresentationformsa}', "");
    Expect(0, 65024, '\p{inarabicpresentationformsa}', "");
    Expect(1, 65024, '\p{^inarabicpresentationformsa}', "");
    Expect(1, 65024, '\P{inarabicpresentationformsa}', "");
    Expect(0, 65024, '\P{^inarabicpresentationformsa}', "");
    Expect(1, 65023, '\p{  in_Arabic_Presentation_FORMS_A}', "");
    Expect(0, 65023, '\p{^  in_Arabic_Presentation_FORMS_A}', "");
    Expect(0, 65023, '\P{  in_Arabic_Presentation_FORMS_A}', "");
    Expect(1, 65023, '\P{^  in_Arabic_Presentation_FORMS_A}', "");
    Expect(0, 65024, '\p{  in_Arabic_Presentation_FORMS_A}', "");
    Expect(1, 65024, '\p{^  in_Arabic_Presentation_FORMS_A}', "");
    Expect(1, 65024, '\P{  in_Arabic_Presentation_FORMS_A}', "");
    Expect(0, 65024, '\P{^  in_Arabic_Presentation_FORMS_A}', "");
    Error('\p{	ARABIC_pf_A:=}');
    Error('\P{	ARABIC_pf_A:=}');
    Expect(1, 65023, '\p{arabicpfa}', "");
    Expect(0, 65023, '\p{^arabicpfa}', "");
    Expect(0, 65023, '\P{arabicpfa}', "");
    Expect(1, 65023, '\P{^arabicpfa}', "");
    Expect(0, 65024, '\p{arabicpfa}', "");
    Expect(1, 65024, '\p{^arabicpfa}', "");
    Expect(1, 65024, '\P{arabicpfa}', "");
    Expect(0, 65024, '\P{^arabicpfa}', "");
    Expect(1, 65023, '\p{arabic_PF_A}', "");
    Expect(0, 65023, '\p{^arabic_PF_A}', "");
    Expect(0, 65023, '\P{arabic_PF_A}', "");
    Expect(1, 65023, '\P{^arabic_PF_A}', "");
    Expect(0, 65024, '\p{arabic_PF_A}', "");
    Expect(1, 65024, '\p{^arabic_PF_A}', "");
    Expect(1, 65024, '\P{arabic_PF_A}', "");
    Expect(0, 65024, '\P{^arabic_PF_A}', "");
    Error('\p{/a/--Is_ARABIC_PF_A}');
    Error('\P{/a/--Is_ARABIC_PF_A}');
    Expect(1, 65023, '\p{isarabicpfa}', "");
    Expect(0, 65023, '\p{^isarabicpfa}', "");
    Expect(0, 65023, '\P{isarabicpfa}', "");
    Expect(1, 65023, '\P{^isarabicpfa}', "");
    Expect(0, 65024, '\p{isarabicpfa}', "");
    Expect(1, 65024, '\p{^isarabicpfa}', "");
    Expect(1, 65024, '\P{isarabicpfa}', "");
    Expect(0, 65024, '\P{^isarabicpfa}', "");
    Expect(1, 65023, '\p{ 	Is_ARABIC_PF_A}', "");
    Expect(0, 65023, '\p{^ 	Is_ARABIC_PF_A}', "");
    Expect(0, 65023, '\P{ 	Is_ARABIC_PF_A}', "");
    Expect(1, 65023, '\P{^ 	Is_ARABIC_PF_A}', "");
    Expect(0, 65024, '\p{ 	Is_ARABIC_PF_A}', "");
    Expect(1, 65024, '\p{^ 	Is_ARABIC_PF_A}', "");
    Expect(1, 65024, '\P{ 	Is_ARABIC_PF_A}', "");
    Expect(0, 65024, '\P{^ 	Is_ARABIC_PF_A}', "");
    Error('\p{/a/  IN_arabic_PF_A}');
    Error('\P{/a/  IN_arabic_PF_A}');
    Expect(1, 65023, '\p{inarabicpfa}', "");
    Expect(0, 65023, '\p{^inarabicpfa}', "");
    Expect(0, 65023, '\P{inarabicpfa}', "");
    Expect(1, 65023, '\P{^inarabicpfa}', "");
    Expect(0, 65024, '\p{inarabicpfa}', "");
    Expect(1, 65024, '\p{^inarabicpfa}', "");
    Expect(1, 65024, '\P{inarabicpfa}', "");
    Expect(0, 65024, '\P{^inarabicpfa}', "");
    Expect(1, 65023, '\p{__in_Arabic_PF_A}', "");
    Expect(0, 65023, '\p{^__in_Arabic_PF_A}', "");
    Expect(0, 65023, '\P{__in_Arabic_PF_A}', "");
    Expect(1, 65023, '\P{^__in_Arabic_PF_A}', "");
    Expect(0, 65024, '\p{__in_Arabic_PF_A}', "");
    Expect(1, 65024, '\p{^__in_Arabic_PF_A}', "");
    Expect(1, 65024, '\P{__in_Arabic_PF_A}', "");
    Expect(0, 65024, '\P{^__in_Arabic_PF_A}', "");
    Error('\p{ arabic_Presentation_Forms_B/a/}');
    Error('\P{ arabic_Presentation_Forms_B/a/}');
    Expect(1, 65279, '\p{arabicpresentationformsb}', "");
    Expect(0, 65279, '\p{^arabicpresentationformsb}', "");
    Expect(0, 65279, '\P{arabicpresentationformsb}', "");
    Expect(1, 65279, '\P{^arabicpresentationformsb}', "");
    Expect(0, 65280, '\p{arabicpresentationformsb}', "");
    Expect(1, 65280, '\p{^arabicpresentationformsb}', "");
    Expect(1, 65280, '\P{arabicpresentationformsb}', "");
    Expect(0, 65280, '\P{^arabicpresentationformsb}', "");
    Expect(1, 65279, '\p{_ Arabic_PRESENTATION_forms_b}', "");
    Expect(0, 65279, '\p{^_ Arabic_PRESENTATION_forms_b}', "");
    Expect(0, 65279, '\P{_ Arabic_PRESENTATION_forms_b}', "");
    Expect(1, 65279, '\P{^_ Arabic_PRESENTATION_forms_b}', "");
    Expect(0, 65280, '\p{_ Arabic_PRESENTATION_forms_b}', "");
    Expect(1, 65280, '\p{^_ Arabic_PRESENTATION_forms_b}', "");
    Expect(1, 65280, '\P{_ Arabic_PRESENTATION_forms_b}', "");
    Expect(0, 65280, '\P{^_ Arabic_PRESENTATION_forms_b}', "");
    Error('\p{-/a/Is_ARABIC_Presentation_Forms_B}');
    Error('\P{-/a/Is_ARABIC_Presentation_Forms_B}');
    Expect(1, 65279, '\p{isarabicpresentationformsb}', "");
    Expect(0, 65279, '\p{^isarabicpresentationformsb}', "");
    Expect(0, 65279, '\P{isarabicpresentationformsb}', "");
    Expect(1, 65279, '\P{^isarabicpresentationformsb}', "");
    Expect(0, 65280, '\p{isarabicpresentationformsb}', "");
    Expect(1, 65280, '\p{^isarabicpresentationformsb}', "");
    Expect(1, 65280, '\P{isarabicpresentationformsb}', "");
    Expect(0, 65280, '\P{^isarabicpresentationformsb}', "");
    Expect(1, 65279, '\p{_ Is_arabic_Presentation_Forms_B}', "");
    Expect(0, 65279, '\p{^_ Is_arabic_Presentation_Forms_B}', "");
    Expect(0, 65279, '\P{_ Is_arabic_Presentation_Forms_B}', "");
    Expect(1, 65279, '\P{^_ Is_arabic_Presentation_Forms_B}', "");
    Expect(0, 65280, '\p{_ Is_arabic_Presentation_Forms_B}', "");
    Expect(1, 65280, '\p{^_ Is_arabic_Presentation_Forms_B}', "");
    Expect(1, 65280, '\P{_ Is_arabic_Presentation_Forms_B}', "");
    Expect(0, 65280, '\P{^_ Is_arabic_Presentation_Forms_B}', "");
    Error('\p{ :=IN_arabic_presentation_Forms_B}');
    Error('\P{ :=IN_arabic_presentation_Forms_B}');
    Expect(1, 65279, '\p{inarabicpresentationformsb}', "");
    Expect(0, 65279, '\p{^inarabicpresentationformsb}', "");
    Expect(0, 65279, '\P{inarabicpresentationformsb}', "");
    Expect(1, 65279, '\P{^inarabicpresentationformsb}', "");
    Expect(0, 65280, '\p{inarabicpresentationformsb}', "");
    Expect(1, 65280, '\p{^inarabicpresentationformsb}', "");
    Expect(1, 65280, '\P{inarabicpresentationformsb}', "");
    Expect(0, 65280, '\P{^inarabicpresentationformsb}', "");
    Expect(1, 65279, '\p{	In_Arabic_PRESENTATION_FORMS_B}', "");
    Expect(0, 65279, '\p{^	In_Arabic_PRESENTATION_FORMS_B}', "");
    Expect(0, 65279, '\P{	In_Arabic_PRESENTATION_FORMS_B}', "");
    Expect(1, 65279, '\P{^	In_Arabic_PRESENTATION_FORMS_B}', "");
    Expect(0, 65280, '\p{	In_Arabic_PRESENTATION_FORMS_B}', "");
    Expect(1, 65280, '\p{^	In_Arabic_PRESENTATION_FORMS_B}', "");
    Expect(1, 65280, '\P{	In_Arabic_PRESENTATION_FORMS_B}', "");
    Expect(0, 65280, '\P{^	In_Arabic_PRESENTATION_FORMS_B}', "");
    Error('\p{	:=Arabic_PF_B}');
    Error('\P{	:=Arabic_PF_B}');
    Expect(1, 65279, '\p{arabicpfb}', "");
    Expect(0, 65279, '\p{^arabicpfb}', "");
    Expect(0, 65279, '\P{arabicpfb}', "");
    Expect(1, 65279, '\P{^arabicpfb}', "");
    Expect(0, 65280, '\p{arabicpfb}', "");
    Expect(1, 65280, '\p{^arabicpfb}', "");
    Expect(1, 65280, '\P{arabicpfb}', "");
    Expect(0, 65280, '\P{^arabicpfb}', "");
    Expect(1, 65279, '\p{	ARABIC_pf_b}', "");
    Expect(0, 65279, '\p{^	ARABIC_pf_b}', "");
    Expect(0, 65279, '\P{	ARABIC_pf_b}', "");
    Expect(1, 65279, '\P{^	ARABIC_pf_b}', "");
    Expect(0, 65280, '\p{	ARABIC_pf_b}', "");
    Expect(1, 65280, '\p{^	ARABIC_pf_b}', "");
    Expect(1, 65280, '\P{	ARABIC_pf_b}', "");
    Expect(0, 65280, '\P{^	ARABIC_pf_b}', "");
    Error('\p{:=-_Is_Arabic_PF_B}');
    Error('\P{:=-_Is_Arabic_PF_B}');
    Expect(1, 65279, '\p{isarabicpfb}', "");
    Expect(0, 65279, '\p{^isarabicpfb}', "");
    Expect(0, 65279, '\P{isarabicpfb}', "");
    Expect(1, 65279, '\P{^isarabicpfb}', "");
    Expect(0, 65280, '\p{isarabicpfb}', "");
    Expect(1, 65280, '\p{^isarabicpfb}', "");
    Expect(1, 65280, '\P{isarabicpfb}', "");
    Expect(0, 65280, '\P{^isarabicpfb}', "");
    Expect(1, 65279, '\p{- Is_ARABIC_PF_B}', "");
    Expect(0, 65279, '\p{^- Is_ARABIC_PF_B}', "");
    Expect(0, 65279, '\P{- Is_ARABIC_PF_B}', "");
    Expect(1, 65279, '\P{^- Is_ARABIC_PF_B}', "");
    Expect(0, 65280, '\p{- Is_ARABIC_PF_B}', "");
    Expect(1, 65280, '\p{^- Is_ARABIC_PF_B}', "");
    Expect(1, 65280, '\P{- Is_ARABIC_PF_B}', "");
    Expect(0, 65280, '\P{^- Is_ARABIC_PF_B}', "");
    Error('\p{:=_ In_Arabic_PF_b}');
    Error('\P{:=_ In_Arabic_PF_b}');
    Expect(1, 65279, '\p{inarabicpfb}', "");
    Expect(0, 65279, '\p{^inarabicpfb}', "");
    Expect(0, 65279, '\P{inarabicpfb}', "");
    Expect(1, 65279, '\P{^inarabicpfb}', "");
    Expect(0, 65280, '\p{inarabicpfb}', "");
    Expect(1, 65280, '\p{^inarabicpfb}', "");
    Expect(1, 65280, '\P{inarabicpfb}', "");
    Expect(0, 65280, '\P{^inarabicpfb}', "");
    Expect(1, 65279, '\p{ In_Arabic_PF_b}', "");
    Expect(0, 65279, '\p{^ In_Arabic_PF_b}', "");
    Expect(0, 65279, '\P{ In_Arabic_PF_b}', "");
    Expect(1, 65279, '\P{^ In_Arabic_PF_b}', "");
    Expect(0, 65280, '\p{ In_Arabic_PF_b}', "");
    Expect(1, 65280, '\p{^ In_Arabic_PF_b}', "");
    Expect(1, 65280, '\P{ In_Arabic_PF_b}', "");
    Expect(0, 65280, '\P{^ In_Arabic_PF_b}', "");
    Error('\p{- arabic_SUPPLEMENT:=}');
    Error('\P{- arabic_SUPPLEMENT:=}');
    Expect(1, 1919, '\p{arabicsupplement}', "");
    Expect(0, 1919, '\p{^arabicsupplement}', "");
    Expect(0, 1919, '\P{arabicsupplement}', "");
    Expect(1, 1919, '\P{^arabicsupplement}', "");
    Expect(0, 1920, '\p{arabicsupplement}', "");
    Expect(1, 1920, '\p{^arabicsupplement}', "");
    Expect(1, 1920, '\P{arabicsupplement}', "");
    Expect(0, 1920, '\P{^arabicsupplement}', "");
    Expect(1, 1919, '\p{_-ARABIC_Supplement}', "");
    Expect(0, 1919, '\p{^_-ARABIC_Supplement}', "");
    Expect(0, 1919, '\P{_-ARABIC_Supplement}', "");
    Expect(1, 1919, '\P{^_-ARABIC_Supplement}', "");
    Expect(0, 1920, '\p{_-ARABIC_Supplement}', "");
    Expect(1, 1920, '\p{^_-ARABIC_Supplement}', "");
    Expect(1, 1920, '\P{_-ARABIC_Supplement}', "");
    Expect(0, 1920, '\P{^_-ARABIC_Supplement}', "");
    Error('\p{/a/- Is_Arabic_supplement}');
    Error('\P{/a/- Is_Arabic_supplement}');
    Expect(1, 1919, '\p{isarabicsupplement}', "");
    Expect(0, 1919, '\p{^isarabicsupplement}', "");
    Expect(0, 1919, '\P{isarabicsupplement}', "");
    Expect(1, 1919, '\P{^isarabicsupplement}', "");
    Expect(0, 1920, '\p{isarabicsupplement}', "");
    Expect(1, 1920, '\p{^isarabicsupplement}', "");
    Expect(1, 1920, '\P{isarabicsupplement}', "");
    Expect(0, 1920, '\P{^isarabicsupplement}', "");
    Expect(1, 1919, '\p{	-is_Arabic_Supplement}', "");
    Expect(0, 1919, '\p{^	-is_Arabic_Supplement}', "");
    Expect(0, 1919, '\P{	-is_Arabic_Supplement}', "");
    Expect(1, 1919, '\P{^	-is_Arabic_Supplement}', "");
    Expect(0, 1920, '\p{	-is_Arabic_Supplement}', "");
    Expect(1, 1920, '\p{^	-is_Arabic_Supplement}', "");
    Expect(1, 1920, '\P{	-is_Arabic_Supplement}', "");
    Expect(0, 1920, '\P{^	-is_Arabic_Supplement}', "");
    Error('\p{ :=In_Arabic_Supplement}');
    Error('\P{ :=In_Arabic_Supplement}');
    Expect(1, 1919, '\p{inarabicsupplement}', "");
    Expect(0, 1919, '\p{^inarabicsupplement}', "");
    Expect(0, 1919, '\P{inarabicsupplement}', "");
    Expect(1, 1919, '\P{^inarabicsupplement}', "");
    Expect(0, 1920, '\p{inarabicsupplement}', "");
    Expect(1, 1920, '\p{^inarabicsupplement}', "");
    Expect(1, 1920, '\P{inarabicsupplement}', "");
    Expect(0, 1920, '\P{^inarabicsupplement}', "");
    Expect(1, 1919, '\p{ In_arabic_Supplement}', "");
    Expect(0, 1919, '\p{^ In_arabic_Supplement}', "");
    Expect(0, 1919, '\P{ In_arabic_Supplement}', "");
    Expect(1, 1919, '\P{^ In_arabic_Supplement}', "");
    Expect(0, 1920, '\p{ In_arabic_Supplement}', "");
    Expect(1, 1920, '\p{^ In_arabic_Supplement}', "");
    Expect(1, 1920, '\P{ In_arabic_Supplement}', "");
    Expect(0, 1920, '\P{^ In_arabic_Supplement}', "");
    Error('\p{_/a/Arabic_SUP}');
    Error('\P{_/a/Arabic_SUP}');
    Expect(1, 1919, '\p{arabicsup}', "");
    Expect(0, 1919, '\p{^arabicsup}', "");
    Expect(0, 1919, '\P{arabicsup}', "");
    Expect(1, 1919, '\P{^arabicsup}', "");
    Expect(0, 1920, '\p{arabicsup}', "");
    Expect(1, 1920, '\p{^arabicsup}', "");
    Expect(1, 1920, '\P{arabicsup}', "");
    Expect(0, 1920, '\P{^arabicsup}', "");
    Expect(1, 1919, '\p{_ARABIC_sup}', "");
    Expect(0, 1919, '\p{^_ARABIC_sup}', "");
    Expect(0, 1919, '\P{_ARABIC_sup}', "");
    Expect(1, 1919, '\P{^_ARABIC_sup}', "");
    Expect(0, 1920, '\p{_ARABIC_sup}', "");
    Expect(1, 1920, '\p{^_ARABIC_sup}', "");
    Expect(1, 1920, '\P{_ARABIC_sup}', "");
    Expect(0, 1920, '\P{^_ARABIC_sup}', "");
    Error('\p{/a/_	IS_Arabic_SUP}');
    Error('\P{/a/_	IS_Arabic_SUP}');
    Expect(1, 1919, '\p{isarabicsup}', "");
    Expect(0, 1919, '\p{^isarabicsup}', "");
    Expect(0, 1919, '\P{isarabicsup}', "");
    Expect(1, 1919, '\P{^isarabicsup}', "");
    Expect(0, 1920, '\p{isarabicsup}', "");
    Expect(1, 1920, '\p{^isarabicsup}', "");
    Expect(1, 1920, '\P{isarabicsup}', "");
    Expect(0, 1920, '\P{^isarabicsup}', "");
    Expect(1, 1919, '\p{	IS_Arabic_SUP}', "");
    Expect(0, 1919, '\p{^	IS_Arabic_SUP}', "");
    Expect(0, 1919, '\P{	IS_Arabic_SUP}', "");
    Expect(1, 1919, '\P{^	IS_Arabic_SUP}', "");
    Expect(0, 1920, '\p{	IS_Arabic_SUP}', "");
    Expect(1, 1920, '\p{^	IS_Arabic_SUP}', "");
    Expect(1, 1920, '\P{	IS_Arabic_SUP}', "");
    Expect(0, 1920, '\P{^	IS_Arabic_SUP}', "");
    Error('\p{_/a/IN_arabic_SUP}');
    Error('\P{_/a/IN_arabic_SUP}');
    Expect(1, 1919, '\p{inarabicsup}', "");
    Expect(0, 1919, '\p{^inarabicsup}', "");
    Expect(0, 1919, '\P{inarabicsup}', "");
    Expect(1, 1919, '\P{^inarabicsup}', "");
    Expect(0, 1920, '\p{inarabicsup}', "");
    Expect(1, 1920, '\p{^inarabicsup}', "");
    Expect(1, 1920, '\P{inarabicsup}', "");
    Expect(0, 1920, '\P{^inarabicsup}', "");
    Expect(1, 1919, '\p{_-In_arabic_Sup}', "");
    Expect(0, 1919, '\p{^_-In_arabic_Sup}', "");
    Expect(0, 1919, '\P{_-In_arabic_Sup}', "");
    Expect(1, 1919, '\P{^_-In_arabic_Sup}', "");
    Expect(0, 1920, '\p{_-In_arabic_Sup}', "");
    Expect(1, 1920, '\p{^_-In_arabic_Sup}', "");
    Expect(1, 1920, '\P{_-In_arabic_Sup}', "");
    Expect(0, 1920, '\P{^_-In_arabic_Sup}', "");
    Error('\p{	Armenian/a/}');
    Error('\P{	Armenian/a/}');
    Expect(1, 64279, '\p{armenian}', "");
    Expect(0, 64279, '\p{^armenian}', "");
    Expect(0, 64279, '\P{armenian}', "");
    Expect(1, 64279, '\P{^armenian}', "");
    Expect(0, 64280, '\p{armenian}', "");
    Expect(1, 64280, '\p{^armenian}', "");
    Expect(1, 64280, '\P{armenian}', "");
    Expect(0, 64280, '\P{^armenian}', "");
    Expect(1, 64279, '\p{ Armenian}', "");
    Expect(0, 64279, '\p{^ Armenian}', "");
    Expect(0, 64279, '\P{ Armenian}', "");
    Expect(1, 64279, '\P{^ Armenian}', "");
    Expect(0, 64280, '\p{ Armenian}', "");
    Expect(1, 64280, '\p{^ Armenian}', "");
    Expect(1, 64280, '\P{ Armenian}', "");
    Expect(0, 64280, '\P{^ Armenian}', "");
    Error('\p{--Is_Armenian:=}');
    Error('\P{--Is_Armenian:=}');
    Expect(1, 64279, '\p{isarmenian}', "");
    Expect(0, 64279, '\p{^isarmenian}', "");
    Expect(0, 64279, '\P{isarmenian}', "");
    Expect(1, 64279, '\P{^isarmenian}', "");
    Expect(0, 64280, '\p{isarmenian}', "");
    Expect(1, 64280, '\p{^isarmenian}', "");
    Expect(1, 64280, '\P{isarmenian}', "");
    Expect(0, 64280, '\P{^isarmenian}', "");
    Expect(1, 64279, '\p{-_Is_Armenian}', "");
    Expect(0, 64279, '\p{^-_Is_Armenian}', "");
    Expect(0, 64279, '\P{-_Is_Armenian}', "");
    Expect(1, 64279, '\P{^-_Is_Armenian}', "");
    Expect(0, 64280, '\p{-_Is_Armenian}', "");
    Expect(1, 64280, '\p{^-_Is_Armenian}', "");
    Expect(1, 64280, '\P{-_Is_Armenian}', "");
    Expect(0, 64280, '\P{^-_Is_Armenian}', "");
    Error('\p{-Armn/a/}');
    Error('\P{-Armn/a/}');
    Expect(1, 64279, '\p{armn}', "");
    Expect(0, 64279, '\p{^armn}', "");
    Expect(0, 64279, '\P{armn}', "");
    Expect(1, 64279, '\P{^armn}', "");
    Expect(0, 64280, '\p{armn}', "");
    Expect(1, 64280, '\p{^armn}', "");
    Expect(1, 64280, '\P{armn}', "");
    Expect(0, 64280, '\P{^armn}', "");
    Expect(1, 64279, '\p{ armn}', "");
    Expect(0, 64279, '\p{^ armn}', "");
    Expect(0, 64279, '\P{ armn}', "");
    Expect(1, 64279, '\P{^ armn}', "");
    Expect(0, 64280, '\p{ armn}', "");
    Expect(1, 64280, '\p{^ armn}', "");
    Expect(1, 64280, '\P{ armn}', "");
    Expect(0, 64280, '\P{^ armn}', "");
    Error('\p{-is_Armn:=}');
    Error('\P{-is_Armn:=}');
    Expect(1, 64279, '\p{isarmn}', "");
    Expect(0, 64279, '\p{^isarmn}', "");
    Expect(0, 64279, '\P{isarmn}', "");
    Expect(1, 64279, '\P{^isarmn}', "");
    Expect(0, 64280, '\p{isarmn}', "");
    Expect(1, 64280, '\p{^isarmn}', "");
    Expect(1, 64280, '\P{isarmn}', "");
    Expect(0, 64280, '\P{^isarmn}', "");
    Expect(1, 64279, '\p{	 is_Armn}', "");
    Expect(0, 64279, '\p{^	 is_Armn}', "");
    Expect(0, 64279, '\P{	 is_Armn}', "");
    Expect(1, 64279, '\P{^	 is_Armn}', "");
    Expect(0, 64280, '\p{	 is_Armn}', "");
    Expect(1, 64280, '\p{^	 is_Armn}', "");
    Expect(1, 64280, '\P{	 is_Armn}', "");
    Expect(0, 64280, '\P{^	 is_Armn}', "");
    Error('\p{	:=ARROWS}');
    Error('\P{	:=ARROWS}');
    Expect(1, 8703, '\p{arrows}', "");
    Expect(0, 8703, '\p{^arrows}', "");
    Expect(0, 8703, '\P{arrows}', "");
    Expect(1, 8703, '\P{^arrows}', "");
    Expect(0, 8704, '\p{arrows}', "");
    Expect(1, 8704, '\p{^arrows}', "");
    Expect(1, 8704, '\P{arrows}', "");
    Expect(0, 8704, '\P{^arrows}', "");
    Expect(1, 8703, '\p{	 Arrows}', "");
    Expect(0, 8703, '\p{^	 Arrows}', "");
    Expect(0, 8703, '\P{	 Arrows}', "");
    Expect(1, 8703, '\P{^	 Arrows}', "");
    Expect(0, 8704, '\p{	 Arrows}', "");
    Expect(1, 8704, '\p{^	 Arrows}', "");
    Expect(1, 8704, '\P{	 Arrows}', "");
    Expect(0, 8704, '\P{^	 Arrows}', "");
    Error('\p{--Is_ARROWS:=}');
    Error('\P{--Is_ARROWS:=}');
    Expect(1, 8703, '\p{isarrows}', "");
    Expect(0, 8703, '\p{^isarrows}', "");
    Expect(0, 8703, '\P{isarrows}', "");
    Expect(1, 8703, '\P{^isarrows}', "");
    Expect(0, 8704, '\p{isarrows}', "");
    Expect(1, 8704, '\p{^isarrows}', "");
    Expect(1, 8704, '\P{isarrows}', "");
    Expect(0, 8704, '\P{^isarrows}', "");
    Expect(1, 8703, '\p{	-Is_arrows}', "");
    Expect(0, 8703, '\p{^	-Is_arrows}', "");
    Expect(0, 8703, '\P{	-Is_arrows}', "");
    Expect(1, 8703, '\P{^	-Is_arrows}', "");
    Expect(0, 8704, '\p{	-Is_arrows}', "");
    Expect(1, 8704, '\p{^	-Is_arrows}', "");
    Expect(1, 8704, '\P{	-Is_arrows}', "");
    Expect(0, 8704, '\P{^	-Is_arrows}', "");
    Error('\p{	/a/In_ARROWS}');
    Error('\P{	/a/In_ARROWS}');
    Expect(1, 8703, '\p{inarrows}', "");
    Expect(0, 8703, '\p{^inarrows}', "");
    Expect(0, 8703, '\P{inarrows}', "");
    Expect(1, 8703, '\P{^inarrows}', "");
    Expect(0, 8704, '\p{inarrows}', "");
    Expect(1, 8704, '\p{^inarrows}', "");
    Expect(1, 8704, '\P{inarrows}', "");
    Expect(0, 8704, '\P{^inarrows}', "");
    Expect(1, 8703, '\p{- IN_arrows}', "");
    Expect(0, 8703, '\p{^- IN_arrows}', "");
    Expect(0, 8703, '\P{- IN_arrows}', "");
    Expect(1, 8703, '\P{^- IN_arrows}', "");
    Expect(0, 8704, '\p{- IN_arrows}', "");
    Expect(1, 8704, '\p{^- IN_arrows}', "");
    Expect(1, 8704, '\P{- IN_arrows}', "");
    Expect(0, 8704, '\P{^- IN_arrows}', "");
    Error('\p{-_ASCII:=}');
    Error('\P{-_ASCII:=}');
    Expect(1, 127, '\p{ascii}', "");
    Expect(0, 127, '\p{^ascii}', "");
    Expect(0, 127, '\P{ascii}', "");
    Expect(1, 127, '\P{^ascii}', "");
    Expect(0, 128, '\p{ascii}', "");
    Expect(1, 128, '\p{^ascii}', "");
    Expect(1, 128, '\P{ascii}', "");
    Expect(0, 128, '\P{^ascii}', "");
    Expect(1, 127, '\p{_ascii}', "");
    Expect(0, 127, '\p{^_ascii}', "");
    Expect(0, 127, '\P{_ascii}', "");
    Expect(1, 127, '\P{^_ascii}', "");
    Expect(0, 128, '\p{_ascii}', "");
    Expect(1, 128, '\p{^_ascii}', "");
    Expect(1, 128, '\P{_ascii}', "");
    Expect(0, 128, '\P{^_ascii}', "");
    Error('\p{:= _is_ASCII}');
    Error('\P{:= _is_ASCII}');
    Expect(1, 127, '\p{isascii}', "");
    Expect(0, 127, '\p{^isascii}', "");
    Expect(0, 127, '\P{isascii}', "");
    Expect(1, 127, '\P{^isascii}', "");
    Expect(0, 128, '\p{isascii}', "");
    Expect(1, 128, '\p{^isascii}', "");
    Expect(1, 128, '\P{isascii}', "");
    Expect(0, 128, '\P{^isascii}', "");
    Expect(1, 127, '\p{_Is_ASCII}', "");
    Expect(0, 127, '\p{^_Is_ASCII}', "");
    Expect(0, 127, '\P{_Is_ASCII}', "");
    Expect(1, 127, '\P{^_Is_ASCII}', "");
    Expect(0, 128, '\p{_Is_ASCII}', "");
    Expect(1, 128, '\p{^_Is_ASCII}', "");
    Expect(1, 128, '\P{_Is_ASCII}', "");
    Expect(0, 128, '\P{^_Is_ASCII}', "");
    Error('\p{	:=Basic_latin}');
    Error('\P{	:=Basic_latin}');
    Expect(1, 127, '\p{basiclatin}', "");
    Expect(0, 127, '\p{^basiclatin}', "");
    Expect(0, 127, '\P{basiclatin}', "");
    Expect(1, 127, '\P{^basiclatin}', "");
    Expect(0, 128, '\p{basiclatin}', "");
    Expect(1, 128, '\p{^basiclatin}', "");
    Expect(1, 128, '\P{basiclatin}', "");
    Expect(0, 128, '\P{^basiclatin}', "");
    Expect(1, 127, '\p{_-Basic_Latin}', "");
    Expect(0, 127, '\p{^_-Basic_Latin}', "");
    Expect(0, 127, '\P{_-Basic_Latin}', "");
    Expect(1, 127, '\P{^_-Basic_Latin}', "");
    Expect(0, 128, '\p{_-Basic_Latin}', "");
    Expect(1, 128, '\p{^_-Basic_Latin}', "");
    Expect(1, 128, '\P{_-Basic_Latin}', "");
    Expect(0, 128, '\P{^_-Basic_Latin}', "");
    Error('\p{:=	 Is_basic_Latin}');
    Error('\P{:=	 Is_basic_Latin}');
    Expect(1, 127, '\p{isbasiclatin}', "");
    Expect(0, 127, '\p{^isbasiclatin}', "");
    Expect(0, 127, '\P{isbasiclatin}', "");
    Expect(1, 127, '\P{^isbasiclatin}', "");
    Expect(0, 128, '\p{isbasiclatin}', "");
    Expect(1, 128, '\p{^isbasiclatin}', "");
    Expect(1, 128, '\P{isbasiclatin}', "");
    Expect(0, 128, '\P{^isbasiclatin}', "");
    Expect(1, 127, '\p{ -Is_BASIC_Latin}', "");
    Expect(0, 127, '\p{^ -Is_BASIC_Latin}', "");
    Expect(0, 127, '\P{ -Is_BASIC_Latin}', "");
    Expect(1, 127, '\P{^ -Is_BASIC_Latin}', "");
    Expect(0, 128, '\p{ -Is_BASIC_Latin}', "");
    Expect(1, 128, '\p{^ -Is_BASIC_Latin}', "");
    Expect(1, 128, '\P{ -Is_BASIC_Latin}', "");
    Expect(0, 128, '\P{^ -Is_BASIC_Latin}', "");
    Error('\p{	_in_BASIC_Latin/a/}');
    Error('\P{	_in_BASIC_Latin/a/}');
    Expect(1, 127, '\p{inbasiclatin}', "");
    Expect(0, 127, '\p{^inbasiclatin}', "");
    Expect(0, 127, '\P{inbasiclatin}', "");
    Expect(1, 127, '\P{^inbasiclatin}', "");
    Expect(0, 128, '\p{inbasiclatin}', "");
    Expect(1, 128, '\p{^inbasiclatin}', "");
    Expect(1, 128, '\P{inbasiclatin}', "");
    Expect(0, 128, '\P{^inbasiclatin}', "");
    Expect(1, 127, '\p{ 	IN_basic_Latin}', "");
    Expect(0, 127, '\p{^ 	IN_basic_Latin}', "");
    Expect(0, 127, '\P{ 	IN_basic_Latin}', "");
    Expect(1, 127, '\P{^ 	IN_basic_Latin}', "");
    Expect(0, 128, '\p{ 	IN_basic_Latin}', "");
    Expect(1, 128, '\p{^ 	IN_basic_Latin}', "");
    Expect(1, 128, '\P{ 	IN_basic_Latin}', "");
    Expect(0, 128, '\P{^ 	IN_basic_Latin}', "");
    Error('\p{:=_	In_ASCII}');
    Error('\P{:=_	In_ASCII}');
    Expect(1, 127, '\p{inascii}', "");
    Expect(0, 127, '\p{^inascii}', "");
    Expect(0, 127, '\P{inascii}', "");
    Expect(1, 127, '\P{^inascii}', "");
    Expect(0, 128, '\p{inascii}', "");
    Expect(1, 128, '\p{^inascii}', "");
    Expect(1, 128, '\P{inascii}', "");
    Expect(0, 128, '\P{^inascii}', "");
    Expect(1, 127, '\p{- IN_ASCII}', "");
    Expect(0, 127, '\p{^- IN_ASCII}', "");
    Expect(0, 127, '\P{- IN_ASCII}', "");
    Expect(1, 127, '\P{^- IN_ASCII}', "");
    Expect(0, 128, '\p{- IN_ASCII}', "");
    Expect(1, 128, '\p{^- IN_ASCII}', "");
    Expect(1, 128, '\P{- IN_ASCII}', "");
    Expect(0, 128, '\P{^- IN_ASCII}', "");
    Error('\p{	/a/assigned}');
    Error('\P{	/a/assigned}');
    Expect(1, 1114109, '\p{assigned}', "");
    Expect(0, 1114109, '\p{^assigned}', "");
    Expect(0, 1114109, '\P{assigned}', "");
    Expect(1, 1114109, '\P{^assigned}', "");
    Expect(0, 918000, '\p{assigned}', "");
    Expect(1, 918000, '\p{^assigned}', "");
    Expect(1, 918000, '\P{assigned}', "");
    Expect(0, 918000, '\P{^assigned}', "");
    Expect(1, 1114109, '\p{	Assigned}', "");
    Expect(0, 1114109, '\p{^	Assigned}', "");
    Expect(0, 1114109, '\P{	Assigned}', "");
    Expect(1, 1114109, '\P{^	Assigned}', "");
    Expect(0, 918000, '\p{	Assigned}', "");
    Expect(1, 918000, '\p{^	Assigned}', "");
    Expect(1, 918000, '\P{	Assigned}', "");
    Expect(0, 918000, '\P{^	Assigned}', "");
    Error('\p{_:=is_assigned}');
    Error('\P{_:=is_assigned}');
    Expect(1, 1114109, '\p{isassigned}', "");
    Expect(0, 1114109, '\p{^isassigned}', "");
    Expect(0, 1114109, '\P{isassigned}', "");
    Expect(1, 1114109, '\P{^isassigned}', "");
    Expect(0, 918000, '\p{isassigned}', "");
    Expect(1, 918000, '\p{^isassigned}', "");
    Expect(1, 918000, '\P{isassigned}', "");
    Expect(0, 918000, '\P{^isassigned}', "");
    Expect(1, 1114109, '\p{ _IS_Assigned}', "");
    Expect(0, 1114109, '\p{^ _IS_Assigned}', "");
    Expect(0, 1114109, '\P{ _IS_Assigned}', "");
    Expect(1, 1114109, '\P{^ _IS_Assigned}', "");
    Expect(0, 918000, '\p{ _IS_Assigned}', "");
    Expect(1, 918000, '\p{^ _IS_Assigned}', "");
    Expect(1, 918000, '\P{ _IS_Assigned}', "");
    Expect(0, 918000, '\P{^ _IS_Assigned}', "");
    Error('\p{__Avestan:=}');
    Error('\P{__Avestan:=}');
    Expect(1, 68415, '\p{avestan}', "");
    Expect(0, 68415, '\p{^avestan}', "");
    Expect(0, 68415, '\P{avestan}', "");
    Expect(1, 68415, '\P{^avestan}', "");
    Expect(0, 68416, '\p{avestan}', "");
    Expect(1, 68416, '\p{^avestan}', "");
    Expect(1, 68416, '\P{avestan}', "");
    Expect(0, 68416, '\P{^avestan}', "");
    Expect(1, 68415, '\p{ Avestan}', "");
    Expect(0, 68415, '\p{^ Avestan}', "");
    Expect(0, 68415, '\P{ Avestan}', "");
    Expect(1, 68415, '\P{^ Avestan}', "");
    Expect(0, 68416, '\p{ Avestan}', "");
    Expect(1, 68416, '\p{^ Avestan}', "");
    Expect(1, 68416, '\P{ Avestan}', "");
    Expect(0, 68416, '\P{^ Avestan}', "");
    Error('\p{_/a/Is_AVESTAN}');
    Error('\P{_/a/Is_AVESTAN}');
    Expect(1, 68415, '\p{isavestan}', "");
    Expect(0, 68415, '\p{^isavestan}', "");
    Expect(0, 68415, '\P{isavestan}', "");
    Expect(1, 68415, '\P{^isavestan}', "");
    Expect(0, 68416, '\p{isavestan}', "");
    Expect(1, 68416, '\p{^isavestan}', "");
    Expect(1, 68416, '\P{isavestan}', "");
    Expect(0, 68416, '\P{^isavestan}', "");
    Expect(1, 68415, '\p{-IS_avestan}', "");
    Expect(0, 68415, '\p{^-IS_avestan}', "");
    Expect(0, 68415, '\P{-IS_avestan}', "");
    Expect(1, 68415, '\P{^-IS_avestan}', "");
    Expect(0, 68416, '\p{-IS_avestan}', "");
    Expect(1, 68416, '\p{^-IS_avestan}', "");
    Expect(1, 68416, '\P{-IS_avestan}', "");
    Expect(0, 68416, '\P{^-IS_avestan}', "");
    Error('\p{	/a/avst}');
    Error('\P{	/a/avst}');
    Expect(1, 68415, '\p{avst}', "");
    Expect(0, 68415, '\p{^avst}', "");
    Expect(0, 68415, '\P{avst}', "");
    Expect(1, 68415, '\P{^avst}', "");
    Expect(0, 68416, '\p{avst}', "");
    Expect(1, 68416, '\p{^avst}', "");
    Expect(1, 68416, '\P{avst}', "");
    Expect(0, 68416, '\P{^avst}', "");
    Expect(1, 68415, '\p{_ Avst}', "");
    Expect(0, 68415, '\p{^_ Avst}', "");
    Expect(0, 68415, '\P{_ Avst}', "");
    Expect(1, 68415, '\P{^_ Avst}', "");
    Expect(0, 68416, '\p{_ Avst}', "");
    Expect(1, 68416, '\p{^_ Avst}', "");
    Expect(1, 68416, '\P{_ Avst}', "");
    Expect(0, 68416, '\P{^_ Avst}', "");
    Error('\p{:=Is_avst}');
    Error('\P{:=Is_avst}');
    Expect(1, 68415, '\p{isavst}', "");
    Expect(0, 68415, '\p{^isavst}', "");
    Expect(0, 68415, '\P{isavst}', "");
    Expect(1, 68415, '\P{^isavst}', "");
    Expect(0, 68416, '\p{isavst}', "");
    Expect(1, 68416, '\p{^isavst}', "");
    Expect(1, 68416, '\P{isavst}', "");
    Expect(0, 68416, '\P{^isavst}', "");
    Expect(1, 68415, '\p{-	is_AVST}', "");
    Expect(0, 68415, '\p{^-	is_AVST}', "");
    Expect(0, 68415, '\P{-	is_AVST}', "");
    Expect(1, 68415, '\P{^-	is_AVST}', "");
    Expect(0, 68416, '\p{-	is_AVST}', "");
    Expect(1, 68416, '\p{^-	is_AVST}', "");
    Expect(1, 68416, '\P{-	is_AVST}', "");
    Expect(0, 68416, '\P{^-	is_AVST}', "");
    Error('\p{:=  balinese}');
    Error('\P{:=  balinese}');
    Expect(1, 7038, '\p{balinese}', "");
    Expect(0, 7038, '\p{^balinese}', "");
    Expect(0, 7038, '\P{balinese}', "");
    Expect(1, 7038, '\P{^balinese}', "");
    Expect(0, 7039, '\p{balinese}', "");
    Expect(1, 7039, '\p{^balinese}', "");
    Expect(1, 7039, '\P{balinese}', "");
    Expect(0, 7039, '\P{^balinese}', "");
    Expect(1, 7038, '\p{	Balinese}', "");
    Expect(0, 7038, '\p{^	Balinese}', "");
    Expect(0, 7038, '\P{	Balinese}', "");
    Expect(1, 7038, '\P{^	Balinese}', "");
    Expect(0, 7039, '\p{	Balinese}', "");
    Expect(1, 7039, '\p{^	Balinese}', "");
    Expect(1, 7039, '\P{	Balinese}', "");
    Expect(0, 7039, '\P{^	Balinese}', "");
    Error('\p{ :=Is_Balinese}');
    Error('\P{ :=Is_Balinese}');
    Expect(1, 7038, '\p{isbalinese}', "");
    Expect(0, 7038, '\p{^isbalinese}', "");
    Expect(0, 7038, '\P{isbalinese}', "");
    Expect(1, 7038, '\P{^isbalinese}', "");
    Expect(0, 7039, '\p{isbalinese}', "");
    Expect(1, 7039, '\p{^isbalinese}', "");
    Expect(1, 7039, '\P{isbalinese}', "");
    Expect(0, 7039, '\P{^isbalinese}', "");
    Expect(1, 7038, '\p{-_Is_balinese}', "");
    Expect(0, 7038, '\p{^-_Is_balinese}', "");
    Expect(0, 7038, '\P{-_Is_balinese}', "");
    Expect(1, 7038, '\P{^-_Is_balinese}', "");
    Expect(0, 7039, '\p{-_Is_balinese}', "");
    Expect(1, 7039, '\p{^-_Is_balinese}', "");
    Expect(1, 7039, '\P{-_Is_balinese}', "");
    Expect(0, 7039, '\P{^-_Is_balinese}', "");
    Error('\p{/a/bali}');
    Error('\P{/a/bali}');
    Expect(1, 7038, '\p{bali}', "");
    Expect(0, 7038, '\p{^bali}', "");
    Expect(0, 7038, '\P{bali}', "");
    Expect(1, 7038, '\P{^bali}', "");
    Expect(0, 7039, '\p{bali}', "");
    Expect(1, 7039, '\p{^bali}', "");
    Expect(1, 7039, '\P{bali}', "");
    Expect(0, 7039, '\P{^bali}', "");
    Expect(1, 7038, '\p{-BALI}', "");
    Expect(0, 7038, '\p{^-BALI}', "");
    Expect(0, 7038, '\P{-BALI}', "");
    Expect(1, 7038, '\P{^-BALI}', "");
    Expect(0, 7039, '\p{-BALI}', "");
    Expect(1, 7039, '\p{^-BALI}', "");
    Expect(1, 7039, '\P{-BALI}', "");
    Expect(0, 7039, '\P{^-BALI}', "");
    Error('\p{/a/- IS_bali}');
    Error('\P{/a/- IS_bali}');
    Expect(1, 7038, '\p{isbali}', "");
    Expect(0, 7038, '\p{^isbali}', "");
    Expect(0, 7038, '\P{isbali}', "");
    Expect(1, 7038, '\P{^isbali}', "");
    Expect(0, 7039, '\p{isbali}', "");
    Expect(1, 7039, '\p{^isbali}', "");
    Expect(1, 7039, '\P{isbali}', "");
    Expect(0, 7039, '\P{^isbali}', "");
    Expect(1, 7038, '\p{- is_Bali}', "");
    Expect(0, 7038, '\p{^- is_Bali}', "");
    Expect(0, 7038, '\P{- is_Bali}', "");
    Expect(1, 7038, '\P{^- is_Bali}', "");
    Expect(0, 7039, '\p{- is_Bali}', "");
    Expect(1, 7039, '\p{^- is_Bali}', "");
    Expect(1, 7039, '\P{- is_Bali}', "");
    Expect(0, 7039, '\P{^- is_Bali}', "");
    Error('\p{:= Bamum}');
    Error('\P{:= Bamum}');
    Expect(1, 92728, '\p{bamum}', "");
    Expect(0, 92728, '\p{^bamum}', "");
    Expect(0, 92728, '\P{bamum}', "");
    Expect(1, 92728, '\P{^bamum}', "");
    Expect(0, 92729, '\p{bamum}', "");
    Expect(1, 92729, '\p{^bamum}', "");
    Expect(1, 92729, '\P{bamum}', "");
    Expect(0, 92729, '\P{^bamum}', "");
    Expect(1, 92728, '\p{	Bamum}', "");
    Expect(0, 92728, '\p{^	Bamum}', "");
    Expect(0, 92728, '\P{	Bamum}', "");
    Expect(1, 92728, '\P{^	Bamum}', "");
    Expect(0, 92729, '\p{	Bamum}', "");
    Expect(1, 92729, '\p{^	Bamum}', "");
    Expect(1, 92729, '\P{	Bamum}', "");
    Expect(0, 92729, '\P{^	Bamum}', "");
    Error('\p{ :=Is_bamum}');
    Error('\P{ :=Is_bamum}');
    Expect(1, 92728, '\p{isbamum}', "");
    Expect(0, 92728, '\p{^isbamum}', "");
    Expect(0, 92728, '\P{isbamum}', "");
    Expect(1, 92728, '\P{^isbamum}', "");
    Expect(0, 92729, '\p{isbamum}', "");
    Expect(1, 92729, '\p{^isbamum}', "");
    Expect(1, 92729, '\P{isbamum}', "");
    Expect(0, 92729, '\P{^isbamum}', "");
    Expect(1, 92728, '\p{Is_Bamum}', "");
    Expect(0, 92728, '\p{^Is_Bamum}', "");
    Expect(0, 92728, '\P{Is_Bamum}', "");
    Expect(1, 92728, '\P{^Is_Bamum}', "");
    Expect(0, 92729, '\p{Is_Bamum}', "");
    Expect(1, 92729, '\p{^Is_Bamum}', "");
    Expect(1, 92729, '\P{Is_Bamum}', "");
    Expect(0, 92729, '\P{^Is_Bamum}', "");
    Error('\p{_ Bamu:=}');
    Error('\P{_ Bamu:=}');
    Expect(1, 92728, '\p{bamu}', "");
    Expect(0, 92728, '\p{^bamu}', "");
    Expect(0, 92728, '\P{bamu}', "");
    Expect(1, 92728, '\P{^bamu}', "");
    Expect(0, 92729, '\p{bamu}', "");
    Expect(1, 92729, '\p{^bamu}', "");
    Expect(1, 92729, '\P{bamu}', "");
    Expect(0, 92729, '\P{^bamu}', "");
    Expect(1, 92728, '\p{-bamu}', "");
    Expect(0, 92728, '\p{^-bamu}', "");
    Expect(0, 92728, '\P{-bamu}', "");
    Expect(1, 92728, '\P{^-bamu}', "");
    Expect(0, 92729, '\p{-bamu}', "");
    Expect(1, 92729, '\p{^-bamu}', "");
    Expect(1, 92729, '\P{-bamu}', "");
    Expect(0, 92729, '\P{^-bamu}', "");
    Error('\p{	:=Is_Bamu}');
    Error('\P{	:=Is_Bamu}');
    Expect(1, 92728, '\p{isbamu}', "");
    Expect(0, 92728, '\p{^isbamu}', "");
    Expect(0, 92728, '\P{isbamu}', "");
    Expect(1, 92728, '\P{^isbamu}', "");
    Expect(0, 92729, '\p{isbamu}', "");
    Expect(1, 92729, '\p{^isbamu}', "");
    Expect(1, 92729, '\P{isbamu}', "");
    Expect(0, 92729, '\P{^isbamu}', "");
    Expect(1, 92728, '\p{- is_BAMU}', "");
    Expect(0, 92728, '\p{^- is_BAMU}', "");
    Expect(0, 92728, '\P{- is_BAMU}', "");
    Expect(1, 92728, '\P{^- is_BAMU}', "");
    Expect(0, 92729, '\p{- is_BAMU}', "");
    Expect(1, 92729, '\p{^- is_BAMU}', "");
    Expect(1, 92729, '\P{- is_BAMU}', "");
    Expect(0, 92729, '\P{^- is_BAMU}', "");
    Error('\p{-:=bamum_Supplement}');
    Error('\P{-:=bamum_Supplement}');
    Expect(1, 92735, '\p{bamumsupplement}', "");
    Expect(0, 92735, '\p{^bamumsupplement}', "");
    Expect(0, 92735, '\P{bamumsupplement}', "");
    Expect(1, 92735, '\P{^bamumsupplement}', "");
    Expect(0, 92736, '\p{bamumsupplement}', "");
    Expect(1, 92736, '\p{^bamumsupplement}', "");
    Expect(1, 92736, '\P{bamumsupplement}', "");
    Expect(0, 92736, '\P{^bamumsupplement}', "");
    Expect(1, 92735, '\p{	 Bamum_Supplement}', "");
    Expect(0, 92735, '\p{^	 Bamum_Supplement}', "");
    Expect(0, 92735, '\P{	 Bamum_Supplement}', "");
    Expect(1, 92735, '\P{^	 Bamum_Supplement}', "");
    Expect(0, 92736, '\p{	 Bamum_Supplement}', "");
    Expect(1, 92736, '\p{^	 Bamum_Supplement}', "");
    Expect(1, 92736, '\P{	 Bamum_Supplement}', "");
    Expect(0, 92736, '\P{^	 Bamum_Supplement}', "");
    Error('\p{/a/__IS_Bamum_SUPPLEMENT}');
    Error('\P{/a/__IS_Bamum_SUPPLEMENT}');
    Expect(1, 92735, '\p{isbamumsupplement}', "");
    Expect(0, 92735, '\p{^isbamumsupplement}', "");
    Expect(0, 92735, '\P{isbamumsupplement}', "");
    Expect(1, 92735, '\P{^isbamumsupplement}', "");
    Expect(0, 92736, '\p{isbamumsupplement}', "");
    Expect(1, 92736, '\p{^isbamumsupplement}', "");
    Expect(1, 92736, '\P{isbamumsupplement}', "");
    Expect(0, 92736, '\P{^isbamumsupplement}', "");
    Expect(1, 92735, '\p{ Is_Bamum_supplement}', "");
    Expect(0, 92735, '\p{^ Is_Bamum_supplement}', "");
    Expect(0, 92735, '\P{ Is_Bamum_supplement}', "");
    Expect(1, 92735, '\P{^ Is_Bamum_supplement}', "");
    Expect(0, 92736, '\p{ Is_Bamum_supplement}', "");
    Expect(1, 92736, '\p{^ Is_Bamum_supplement}', "");
    Expect(1, 92736, '\P{ Is_Bamum_supplement}', "");
    Expect(0, 92736, '\P{^ Is_Bamum_supplement}', "");
    Error('\p{	:=IN_Bamum_Supplement}');
    Error('\P{	:=IN_Bamum_Supplement}');
    Expect(1, 92735, '\p{inbamumsupplement}', "");
    Expect(0, 92735, '\p{^inbamumsupplement}', "");
    Expect(0, 92735, '\P{inbamumsupplement}', "");
    Expect(1, 92735, '\P{^inbamumsupplement}', "");
    Expect(0, 92736, '\p{inbamumsupplement}', "");
    Expect(1, 92736, '\p{^inbamumsupplement}', "");
    Expect(1, 92736, '\P{inbamumsupplement}', "");
    Expect(0, 92736, '\P{^inbamumsupplement}', "");
    Expect(1, 92735, '\p{	in_Bamum_Supplement}', "");
    Expect(0, 92735, '\p{^	in_Bamum_Supplement}', "");
    Expect(0, 92735, '\P{	in_Bamum_Supplement}', "");
    Expect(1, 92735, '\P{^	in_Bamum_Supplement}', "");
    Expect(0, 92736, '\p{	in_Bamum_Supplement}', "");
    Expect(1, 92736, '\p{^	in_Bamum_Supplement}', "");
    Expect(1, 92736, '\P{	in_Bamum_Supplement}', "");
    Expect(0, 92736, '\P{^	in_Bamum_Supplement}', "");
    Error('\p{:=bamum_sup}');
    Error('\P{:=bamum_sup}');
    Expect(1, 92735, '\p{bamumsup}', "");
    Expect(0, 92735, '\p{^bamumsup}', "");
    Expect(0, 92735, '\P{bamumsup}', "");
    Expect(1, 92735, '\P{^bamumsup}', "");
    Expect(0, 92736, '\p{bamumsup}', "");
    Expect(1, 92736, '\p{^bamumsup}', "");
    Expect(1, 92736, '\P{bamumsup}', "");
    Expect(0, 92736, '\P{^bamumsup}', "");
    Expect(1, 92735, '\p{Bamum_Sup}', "");
    Expect(0, 92735, '\p{^Bamum_Sup}', "");
    Expect(0, 92735, '\P{Bamum_Sup}', "");
    Expect(1, 92735, '\P{^Bamum_Sup}', "");
    Expect(0, 92736, '\p{Bamum_Sup}', "");
    Expect(1, 92736, '\p{^Bamum_Sup}', "");
    Expect(1, 92736, '\P{Bamum_Sup}', "");
    Expect(0, 92736, '\P{^Bamum_Sup}', "");
    Error('\p{ /a/Is_Bamum_SUP}');
    Error('\P{ /a/Is_Bamum_SUP}');
    Expect(1, 92735, '\p{isbamumsup}', "");
    Expect(0, 92735, '\p{^isbamumsup}', "");
    Expect(0, 92735, '\P{isbamumsup}', "");
    Expect(1, 92735, '\P{^isbamumsup}', "");
    Expect(0, 92736, '\p{isbamumsup}', "");
    Expect(1, 92736, '\p{^isbamumsup}', "");
    Expect(1, 92736, '\P{isbamumsup}', "");
    Expect(0, 92736, '\P{^isbamumsup}', "");
    Expect(1, 92735, '\p{ _Is_bamum_Sup}', "");
    Expect(0, 92735, '\p{^ _Is_bamum_Sup}', "");
    Expect(0, 92735, '\P{ _Is_bamum_Sup}', "");
    Expect(1, 92735, '\P{^ _Is_bamum_Sup}', "");
    Expect(0, 92736, '\p{ _Is_bamum_Sup}', "");
    Expect(1, 92736, '\p{^ _Is_bamum_Sup}', "");
    Expect(1, 92736, '\P{ _Is_bamum_Sup}', "");
    Expect(0, 92736, '\P{^ _Is_bamum_Sup}', "");
    Error('\p{/a/_in_BAMUM_SUP}');
    Error('\P{/a/_in_BAMUM_SUP}');
    Expect(1, 92735, '\p{inbamumsup}', "");
    Expect(0, 92735, '\p{^inbamumsup}', "");
    Expect(0, 92735, '\P{inbamumsup}', "");
    Expect(1, 92735, '\P{^inbamumsup}', "");
    Expect(0, 92736, '\p{inbamumsup}', "");
    Expect(1, 92736, '\p{^inbamumsup}', "");
    Expect(1, 92736, '\P{inbamumsup}', "");
    Expect(0, 92736, '\P{^inbamumsup}', "");
    Expect(1, 92735, '\p{_ in_Bamum_SUP}', "");
    Expect(0, 92735, '\p{^_ in_Bamum_SUP}', "");
    Expect(0, 92735, '\P{_ in_Bamum_SUP}', "");
    Expect(1, 92735, '\P{^_ in_Bamum_SUP}', "");
    Expect(0, 92736, '\p{_ in_Bamum_SUP}', "");
    Expect(1, 92736, '\p{^_ in_Bamum_SUP}', "");
    Expect(1, 92736, '\P{_ in_Bamum_SUP}', "");
    Expect(0, 92736, '\P{^_ in_Bamum_SUP}', "");
    Error('\p{:=-Bassa_vah}');
    Error('\P{:=-Bassa_vah}');
    Expect(1, 92917, '\p{bassavah}', "");
    Expect(0, 92917, '\p{^bassavah}', "");
    Expect(0, 92917, '\P{bassavah}', "");
    Expect(1, 92917, '\P{^bassavah}', "");
    Expect(0, 92918, '\p{bassavah}', "");
    Expect(1, 92918, '\p{^bassavah}', "");
    Expect(1, 92918, '\P{bassavah}', "");
    Expect(0, 92918, '\P{^bassavah}', "");
    Expect(1, 92917, '\p{_-bassa_Vah}', "");
    Expect(0, 92917, '\p{^_-bassa_Vah}', "");
    Expect(0, 92917, '\P{_-bassa_Vah}', "");
    Expect(1, 92917, '\P{^_-bassa_Vah}', "");
    Expect(0, 92918, '\p{_-bassa_Vah}', "");
    Expect(1, 92918, '\p{^_-bassa_Vah}', "");
    Expect(1, 92918, '\P{_-bassa_Vah}', "");
    Expect(0, 92918, '\P{^_-bassa_Vah}', "");
    Error('\p{_:=is_Bassa_VAH}');
    Error('\P{_:=is_Bassa_VAH}');
    Expect(1, 92917, '\p{isbassavah}', "");
    Expect(0, 92917, '\p{^isbassavah}', "");
    Expect(0, 92917, '\P{isbassavah}', "");
    Expect(1, 92917, '\P{^isbassavah}', "");
    Expect(0, 92918, '\p{isbassavah}', "");
    Expect(1, 92918, '\p{^isbassavah}', "");
    Expect(1, 92918, '\P{isbassavah}', "");
    Expect(0, 92918, '\P{^isbassavah}', "");
    Expect(1, 92917, '\p{_is_Bassa_Vah}', "");
    Expect(0, 92917, '\p{^_is_Bassa_Vah}', "");
    Expect(0, 92917, '\P{_is_Bassa_Vah}', "");
    Expect(1, 92917, '\P{^_is_Bassa_Vah}', "");
    Expect(0, 92918, '\p{_is_Bassa_Vah}', "");
    Expect(1, 92918, '\p{^_is_Bassa_Vah}', "");
    Expect(1, 92918, '\P{_is_Bassa_Vah}', "");
    Expect(0, 92918, '\P{^_is_Bassa_Vah}', "");
    Error('\p{/a/-	Bass}');
    Error('\P{/a/-	Bass}');
    Expect(1, 92917, '\p{bass}', "");
    Expect(0, 92917, '\p{^bass}', "");
    Expect(0, 92917, '\P{bass}', "");
    Expect(1, 92917, '\P{^bass}', "");
    Expect(0, 92918, '\p{bass}', "");
    Expect(1, 92918, '\p{^bass}', "");
    Expect(1, 92918, '\P{bass}', "");
    Expect(0, 92918, '\P{^bass}', "");
    Expect(1, 92917, '\p{_-BASS}', "");
    Expect(0, 92917, '\p{^_-BASS}', "");
    Expect(0, 92917, '\P{_-BASS}', "");
    Expect(1, 92917, '\P{^_-BASS}', "");
    Expect(0, 92918, '\p{_-BASS}', "");
    Expect(1, 92918, '\p{^_-BASS}', "");
    Expect(1, 92918, '\P{_-BASS}', "");
    Expect(0, 92918, '\P{^_-BASS}', "");
    Error('\p{_:=Is_BASS}');
    Error('\P{_:=Is_BASS}');
    Expect(1, 92917, '\p{isbass}', "");
    Expect(0, 92917, '\p{^isbass}', "");
    Expect(0, 92917, '\P{isbass}', "");
    Expect(1, 92917, '\P{^isbass}', "");
    Expect(0, 92918, '\p{isbass}', "");
    Expect(1, 92918, '\p{^isbass}', "");
    Expect(1, 92918, '\P{isbass}', "");
    Expect(0, 92918, '\P{^isbass}', "");
    Expect(1, 92917, '\p{_ Is_Bass}', "");
    Expect(0, 92917, '\p{^_ Is_Bass}', "");
    Expect(0, 92917, '\P{_ Is_Bass}', "");
    Expect(1, 92917, '\P{^_ Is_Bass}', "");
    Expect(0, 92918, '\p{_ Is_Bass}', "");
    Expect(1, 92918, '\p{^_ Is_Bass}', "");
    Expect(1, 92918, '\P{_ Is_Bass}', "");
    Expect(0, 92918, '\P{^_ Is_Bass}', "");
    Error('\p{/a/Batak}');
    Error('\P{/a/Batak}');
    Expect(1, 7167, '\p{batak}', "");
    Expect(0, 7167, '\p{^batak}', "");
    Expect(0, 7167, '\P{batak}', "");
    Expect(1, 7167, '\P{^batak}', "");
    Expect(0, 7168, '\p{batak}', "");
    Expect(1, 7168, '\p{^batak}', "");
    Expect(1, 7168, '\P{batak}', "");
    Expect(0, 7168, '\P{^batak}', "");
    Expect(1, 7167, '\p{_-Batak}', "");
    Expect(0, 7167, '\p{^_-Batak}', "");
    Expect(0, 7167, '\P{_-Batak}', "");
    Expect(1, 7167, '\P{^_-Batak}', "");
    Expect(0, 7168, '\p{_-Batak}', "");
    Expect(1, 7168, '\p{^_-Batak}', "");
    Expect(1, 7168, '\P{_-Batak}', "");
    Expect(0, 7168, '\P{^_-Batak}', "");
    Error('\p{--Is_Batak/a/}');
    Error('\P{--Is_Batak/a/}');
    Expect(1, 7167, '\p{isbatak}', "");
    Expect(0, 7167, '\p{^isbatak}', "");
    Expect(0, 7167, '\P{isbatak}', "");
    Expect(1, 7167, '\P{^isbatak}', "");
    Expect(0, 7168, '\p{isbatak}', "");
    Expect(1, 7168, '\p{^isbatak}', "");
    Expect(1, 7168, '\P{isbatak}', "");
    Expect(0, 7168, '\P{^isbatak}', "");
    Expect(1, 7167, '\p{_is_Batak}', "");
    Expect(0, 7167, '\p{^_is_Batak}', "");
    Expect(0, 7167, '\P{_is_Batak}', "");
    Expect(1, 7167, '\P{^_is_Batak}', "");
    Expect(0, 7168, '\p{_is_Batak}', "");
    Expect(1, 7168, '\p{^_is_Batak}', "");
    Expect(1, 7168, '\P{_is_Batak}', "");
    Expect(0, 7168, '\P{^_is_Batak}', "");
    Error('\p{:=	 Batk}');
    Error('\P{:=	 Batk}');
    Expect(1, 7167, '\p{batk}', "");
    Expect(0, 7167, '\p{^batk}', "");
    Expect(0, 7167, '\P{batk}', "");
    Expect(1, 7167, '\P{^batk}', "");
    Expect(0, 7168, '\p{batk}', "");
    Expect(1, 7168, '\p{^batk}', "");
    Expect(1, 7168, '\P{batk}', "");
    Expect(0, 7168, '\P{^batk}', "");
    Expect(1, 7167, '\p{-Batk}', "");
    Expect(0, 7167, '\p{^-Batk}', "");
    Expect(0, 7167, '\P{-Batk}', "");
    Expect(1, 7167, '\P{^-Batk}', "");
    Expect(0, 7168, '\p{-Batk}', "");
    Expect(1, 7168, '\p{^-Batk}', "");
    Expect(1, 7168, '\P{-Batk}', "");
    Expect(0, 7168, '\P{^-Batk}', "");
    Error('\p{ -IS_batk/a/}');
    Error('\P{ -IS_batk/a/}');
    Expect(1, 7167, '\p{isbatk}', "");
    Expect(0, 7167, '\p{^isbatk}', "");
    Expect(0, 7167, '\P{isbatk}', "");
    Expect(1, 7167, '\P{^isbatk}', "");
    Expect(0, 7168, '\p{isbatk}', "");
    Expect(1, 7168, '\p{^isbatk}', "");
    Expect(1, 7168, '\P{isbatk}', "");
    Expect(0, 7168, '\P{^isbatk}', "");
    Expect(1, 7167, '\p{ IS_batk}', "");
    Expect(0, 7167, '\p{^ IS_batk}', "");
    Expect(0, 7167, '\P{ IS_batk}', "");
    Expect(1, 7167, '\P{^ IS_batk}', "");
    Expect(0, 7168, '\p{ IS_batk}', "");
    Expect(1, 7168, '\p{^ IS_batk}', "");
    Expect(1, 7168, '\P{ IS_batk}', "");
    Expect(0, 7168, '\P{^ IS_batk}', "");
    Error('\p{__BENGALI/a/}');
    Error('\P{__BENGALI/a/}');
    Expect(1, 43249, '\p{bengali}', "");
    Expect(0, 43249, '\p{^bengali}', "");
    Expect(0, 43249, '\P{bengali}', "");
    Expect(1, 43249, '\P{^bengali}', "");
    Expect(0, 43250, '\p{bengali}', "");
    Expect(1, 43250, '\p{^bengali}', "");
    Expect(1, 43250, '\P{bengali}', "");
    Expect(0, 43250, '\P{^bengali}', "");
    Expect(1, 43249, '\p{	 Bengali}', "");
    Expect(0, 43249, '\p{^	 Bengali}', "");
    Expect(0, 43249, '\P{	 Bengali}', "");
    Expect(1, 43249, '\P{^	 Bengali}', "");
    Expect(0, 43250, '\p{	 Bengali}', "");
    Expect(1, 43250, '\p{^	 Bengali}', "");
    Expect(1, 43250, '\P{	 Bengali}', "");
    Expect(0, 43250, '\P{^	 Bengali}', "");
    Error('\p{	Is_BENGALI:=}');
    Error('\P{	Is_BENGALI:=}');
    Expect(1, 43249, '\p{isbengali}', "");
    Expect(0, 43249, '\p{^isbengali}', "");
    Expect(0, 43249, '\P{isbengali}', "");
    Expect(1, 43249, '\P{^isbengali}', "");
    Expect(0, 43250, '\p{isbengali}', "");
    Expect(1, 43250, '\p{^isbengali}', "");
    Expect(1, 43250, '\P{isbengali}', "");
    Expect(0, 43250, '\P{^isbengali}', "");
    Expect(1, 43249, '\p{	Is_Bengali}', "");
    Expect(0, 43249, '\p{^	Is_Bengali}', "");
    Expect(0, 43249, '\P{	Is_Bengali}', "");
    Expect(1, 43249, '\P{^	Is_Bengali}', "");
    Expect(0, 43250, '\p{	Is_Bengali}', "");
    Expect(1, 43250, '\p{^	Is_Bengali}', "");
    Expect(1, 43250, '\P{	Is_Bengali}', "");
    Expect(0, 43250, '\P{^	Is_Bengali}', "");
    Error('\p{ Beng/a/}');
    Error('\P{ Beng/a/}');
    Expect(1, 43249, '\p{beng}', "");
    Expect(0, 43249, '\p{^beng}', "");
    Expect(0, 43249, '\P{beng}', "");
    Expect(1, 43249, '\P{^beng}', "");
    Expect(0, 43250, '\p{beng}', "");
    Expect(1, 43250, '\p{^beng}', "");
    Expect(1, 43250, '\P{beng}', "");
    Expect(0, 43250, '\P{^beng}', "");
    Expect(1, 43249, '\p{--BENG}', "");
    Expect(0, 43249, '\p{^--BENG}', "");
    Expect(0, 43249, '\P{--BENG}', "");
    Expect(1, 43249, '\P{^--BENG}', "");
    Expect(0, 43250, '\p{--BENG}', "");
    Expect(1, 43250, '\p{^--BENG}', "");
    Expect(1, 43250, '\P{--BENG}', "");
    Expect(0, 43250, '\P{^--BENG}', "");
    Error('\p{ _is_Beng:=}');
    Error('\P{ _is_Beng:=}');
    Expect(1, 43249, '\p{isbeng}', "");
    Expect(0, 43249, '\p{^isbeng}', "");
    Expect(0, 43249, '\P{isbeng}', "");
    Expect(1, 43249, '\P{^isbeng}', "");
    Expect(0, 43250, '\p{isbeng}', "");
    Expect(1, 43250, '\p{^isbeng}', "");
    Expect(1, 43250, '\P{isbeng}', "");
    Expect(0, 43250, '\P{^isbeng}', "");
    Expect(1, 43249, '\p{-Is_Beng}', "");
    Expect(0, 43249, '\p{^-Is_Beng}', "");
    Expect(0, 43249, '\P{-Is_Beng}', "");
    Expect(1, 43249, '\P{^-Is_Beng}', "");
    Expect(0, 43250, '\p{-Is_Beng}', "");
    Expect(1, 43250, '\p{^-Is_Beng}', "");
    Expect(1, 43250, '\P{-Is_Beng}', "");
    Expect(0, 43250, '\P{^-Is_Beng}', "");
    Error('\p{:=_Bhaiksuki}');
    Error('\P{:=_Bhaiksuki}');
    Expect(1, 72812, '\p{bhaiksuki}', "");
    Expect(0, 72812, '\p{^bhaiksuki}', "");
    Expect(0, 72812, '\P{bhaiksuki}', "");
    Expect(1, 72812, '\P{^bhaiksuki}', "");
    Expect(0, 72813, '\p{bhaiksuki}', "");
    Expect(1, 72813, '\p{^bhaiksuki}', "");
    Expect(1, 72813, '\P{bhaiksuki}', "");
    Expect(0, 72813, '\P{^bhaiksuki}', "");
    Expect(1, 72812, '\p{_	BHAIKSUKI}', "");
    Expect(0, 72812, '\p{^_	BHAIKSUKI}', "");
    Expect(0, 72812, '\P{_	BHAIKSUKI}', "");
    Expect(1, 72812, '\P{^_	BHAIKSUKI}', "");
    Expect(0, 72813, '\p{_	BHAIKSUKI}', "");
    Expect(1, 72813, '\p{^_	BHAIKSUKI}', "");
    Expect(1, 72813, '\P{_	BHAIKSUKI}', "");
    Expect(0, 72813, '\P{^_	BHAIKSUKI}', "");
    Error('\p{:=_-IS_Bhaiksuki}');
    Error('\P{:=_-IS_Bhaiksuki}');
    Expect(1, 72812, '\p{isbhaiksuki}', "");
    Expect(0, 72812, '\p{^isbhaiksuki}', "");
    Expect(0, 72812, '\P{isbhaiksuki}', "");
    Expect(1, 72812, '\P{^isbhaiksuki}', "");
    Expect(0, 72813, '\p{isbhaiksuki}', "");
    Expect(1, 72813, '\p{^isbhaiksuki}', "");
    Expect(1, 72813, '\P{isbhaiksuki}', "");
    Expect(0, 72813, '\P{^isbhaiksuki}', "");
    Expect(1, 72812, '\p{--Is_bhaiksuki}', "");
    Expect(0, 72812, '\p{^--Is_bhaiksuki}', "");
    Expect(0, 72812, '\P{--Is_bhaiksuki}', "");
    Expect(1, 72812, '\P{^--Is_bhaiksuki}', "");
    Expect(0, 72813, '\p{--Is_bhaiksuki}', "");
    Expect(1, 72813, '\p{^--Is_bhaiksuki}', "");
    Expect(1, 72813, '\P{--Is_bhaiksuki}', "");
    Expect(0, 72813, '\P{^--Is_bhaiksuki}', "");
    Error('\p{_/a/bhks}');
    Error('\P{_/a/bhks}');
    Expect(1, 72812, '\p{bhks}', "");
    Expect(0, 72812, '\p{^bhks}', "");
    Expect(0, 72812, '\P{bhks}', "");
    Expect(1, 72812, '\P{^bhks}', "");
    Expect(0, 72813, '\p{bhks}', "");
    Expect(1, 72813, '\p{^bhks}', "");
    Expect(1, 72813, '\P{bhks}', "");
    Expect(0, 72813, '\P{^bhks}', "");
    Expect(1, 72812, '\p{-_Bhks}', "");
    Expect(0, 72812, '\p{^-_Bhks}', "");
    Expect(0, 72812, '\P{-_Bhks}', "");
    Expect(1, 72812, '\P{^-_Bhks}', "");
    Expect(0, 72813, '\p{-_Bhks}', "");
    Expect(1, 72813, '\p{^-_Bhks}', "");
    Expect(1, 72813, '\P{-_Bhks}', "");
    Expect(0, 72813, '\P{^-_Bhks}', "");
    Error('\p{/a/	_Is_Bhks}');
    Error('\P{/a/	_Is_Bhks}');
    Expect(1, 72812, '\p{isbhks}', "");
    Expect(0, 72812, '\p{^isbhks}', "");
    Expect(0, 72812, '\P{isbhks}', "");
    Expect(1, 72812, '\P{^isbhks}', "");
    Expect(0, 72813, '\p{isbhks}', "");
    Expect(1, 72813, '\p{^isbhks}', "");
    Expect(1, 72813, '\P{isbhks}', "");
    Expect(0, 72813, '\P{^isbhks}', "");
    Expect(1, 72812, '\p{_ Is_Bhks}', "");
    Expect(0, 72812, '\p{^_ Is_Bhks}', "");
    Expect(0, 72812, '\P{_ Is_Bhks}', "");
    Expect(1, 72812, '\P{^_ Is_Bhks}', "");
    Expect(0, 72813, '\p{_ Is_Bhks}', "");
    Expect(1, 72813, '\p{^_ Is_Bhks}', "");
    Expect(1, 72813, '\P{_ Is_Bhks}', "");
    Expect(0, 72813, '\P{^_ Is_Bhks}', "");
    Error('\p{		BIDI_Control:=}');
    Error('\P{		BIDI_Control:=}');
    Expect(1, 8297, '\p{bidicontrol}', "");
    Expect(0, 8297, '\p{^bidicontrol}', "");
    Expect(0, 8297, '\P{bidicontrol}', "");
    Expect(1, 8297, '\P{^bidicontrol}', "");
    Expect(0, 8298, '\p{bidicontrol}', "");
    Expect(1, 8298, '\p{^bidicontrol}', "");
    Expect(1, 8298, '\P{bidicontrol}', "");
    Expect(0, 8298, '\P{^bidicontrol}', "");
    Expect(1, 8297, '\p{-_BIDI_CONTROL}', "");
    Expect(0, 8297, '\p{^-_BIDI_CONTROL}', "");
    Expect(0, 8297, '\P{-_BIDI_CONTROL}', "");
    Expect(1, 8297, '\P{^-_BIDI_CONTROL}', "");
    Expect(0, 8298, '\p{-_BIDI_CONTROL}', "");
    Expect(1, 8298, '\p{^-_BIDI_CONTROL}', "");
    Expect(1, 8298, '\P{-_BIDI_CONTROL}', "");
    Expect(0, 8298, '\P{^-_BIDI_CONTROL}', "");
    Error('\p{ /a/Is_Bidi_Control}');
    Error('\P{ /a/Is_Bidi_Control}');
    Expect(1, 8297, '\p{isbidicontrol}', "");
    Expect(0, 8297, '\p{^isbidicontrol}', "");
    Expect(0, 8297, '\P{isbidicontrol}', "");
    Expect(1, 8297, '\P{^isbidicontrol}', "");
    Expect(0, 8298, '\p{isbidicontrol}', "");
    Expect(1, 8298, '\p{^isbidicontrol}', "");
    Expect(1, 8298, '\P{isbidicontrol}', "");
    Expect(0, 8298, '\P{^isbidicontrol}', "");
    Expect(1, 8297, '\p{--Is_bidi_Control}', "");
    Expect(0, 8297, '\p{^--Is_bidi_Control}', "");
    Expect(0, 8297, '\P{--Is_bidi_Control}', "");
    Expect(1, 8297, '\P{^--Is_bidi_Control}', "");
    Expect(0, 8298, '\p{--Is_bidi_Control}', "");
    Expect(1, 8298, '\p{^--Is_bidi_Control}', "");
    Expect(1, 8298, '\P{--Is_bidi_Control}', "");
    Expect(0, 8298, '\P{^--Is_bidi_Control}', "");
    Error('\p{ :=bidi_c}');
    Error('\P{ :=bidi_c}');
    Expect(1, 8297, '\p{bidic}', "");
    Expect(0, 8297, '\p{^bidic}', "");
    Expect(0, 8297, '\P{bidic}', "");
    Expect(1, 8297, '\P{^bidic}', "");
    Expect(0, 8298, '\p{bidic}', "");
    Expect(1, 8298, '\p{^bidic}', "");
    Expect(1, 8298, '\P{bidic}', "");
    Expect(0, 8298, '\P{^bidic}', "");
    Expect(1, 8297, '\p{_bidi_C}', "");
    Expect(0, 8297, '\p{^_bidi_C}', "");
    Expect(0, 8297, '\P{_bidi_C}', "");
    Expect(1, 8297, '\P{^_bidi_C}', "");
    Expect(0, 8298, '\p{_bidi_C}', "");
    Expect(1, 8298, '\p{^_bidi_C}', "");
    Expect(1, 8298, '\P{_bidi_C}', "");
    Expect(0, 8298, '\P{^_bidi_C}', "");
    Error('\p{-/a/IS_BIDI_C}');
    Error('\P{-/a/IS_BIDI_C}');
    Expect(1, 8297, '\p{isbidic}', "");
    Expect(0, 8297, '\p{^isbidic}', "");
    Expect(0, 8297, '\P{isbidic}', "");
    Expect(1, 8297, '\P{^isbidic}', "");
    Expect(0, 8298, '\p{isbidic}', "");
    Expect(1, 8298, '\p{^isbidic}', "");
    Expect(1, 8298, '\P{isbidic}', "");
    Expect(0, 8298, '\P{^isbidic}', "");
    Expect(1, 8297, '\p{_-is_Bidi_C}', "");
    Expect(0, 8297, '\p{^_-is_Bidi_C}', "");
    Expect(0, 8297, '\P{_-is_Bidi_C}', "");
    Expect(1, 8297, '\P{^_-is_Bidi_C}', "");
    Expect(0, 8298, '\p{_-is_Bidi_C}', "");
    Expect(1, 8298, '\p{^_-is_Bidi_C}', "");
    Expect(1, 8298, '\P{_-is_Bidi_C}', "");
    Expect(0, 8298, '\P{^_-is_Bidi_C}', "");
    Error('\p{:=-bidi_MIRRORED}');
    Error('\P{:=-bidi_MIRRORED}');
    Expect(1, 120771, '\p{bidimirrored}', "");
    Expect(0, 120771, '\p{^bidimirrored}', "");
    Expect(0, 120771, '\P{bidimirrored}', "");
    Expect(1, 120771, '\P{^bidimirrored}', "");
    Expect(0, 120772, '\p{bidimirrored}', "");
    Expect(1, 120772, '\p{^bidimirrored}', "");
    Expect(1, 120772, '\P{bidimirrored}', "");
    Expect(0, 120772, '\P{^bidimirrored}', "");
    Expect(1, 120771, '\p{ Bidi_mirrored}', "");
    Expect(0, 120771, '\p{^ Bidi_mirrored}', "");
    Expect(0, 120771, '\P{ Bidi_mirrored}', "");
    Expect(1, 120771, '\P{^ Bidi_mirrored}', "");
    Expect(0, 120772, '\p{ Bidi_mirrored}', "");
    Expect(1, 120772, '\p{^ Bidi_mirrored}', "");
    Expect(1, 120772, '\P{ Bidi_mirrored}', "");
    Expect(0, 120772, '\P{^ Bidi_mirrored}', "");
    Error('\p{ /a/is_Bidi_Mirrored}');
    Error('\P{ /a/is_Bidi_Mirrored}');
    Expect(1, 120771, '\p{isbidimirrored}', "");
    Expect(0, 120771, '\p{^isbidimirrored}', "");
    Expect(0, 120771, '\P{isbidimirrored}', "");
    Expect(1, 120771, '\P{^isbidimirrored}', "");
    Expect(0, 120772, '\p{isbidimirrored}', "");
    Expect(1, 120772, '\p{^isbidimirrored}', "");
    Expect(1, 120772, '\P{isbidimirrored}', "");
    Expect(0, 120772, '\P{^isbidimirrored}', "");
    Expect(1, 120771, '\p{-is_bidi_MIRRORED}', "");
    Expect(0, 120771, '\p{^-is_bidi_MIRRORED}', "");
    Expect(0, 120771, '\P{-is_bidi_MIRRORED}', "");
    Expect(1, 120771, '\P{^-is_bidi_MIRRORED}', "");
    Expect(0, 120772, '\p{-is_bidi_MIRRORED}', "");
    Expect(1, 120772, '\p{^-is_bidi_MIRRORED}', "");
    Expect(1, 120772, '\P{-is_bidi_MIRRORED}', "");
    Expect(0, 120772, '\P{^-is_bidi_MIRRORED}', "");
    Error('\p{:=-BIDI_M}');
    Error('\P{:=-BIDI_M}');
    Expect(1, 120771, '\p{bidim}', "");
    Expect(0, 120771, '\p{^bidim}', "");
    Expect(0, 120771, '\P{bidim}', "");
    Expect(1, 120771, '\P{^bidim}', "");
    Expect(0, 120772, '\p{bidim}', "");
    Expect(1, 120772, '\p{^bidim}', "");
    Expect(1, 120772, '\P{bidim}', "");
    Expect(0, 120772, '\P{^bidim}', "");
    Expect(1, 120771, '\p{	bidi_M}', "");
    Expect(0, 120771, '\p{^	bidi_M}', "");
    Expect(0, 120771, '\P{	bidi_M}', "");
    Expect(1, 120771, '\P{^	bidi_M}', "");
    Expect(0, 120772, '\p{	bidi_M}', "");
    Expect(1, 120772, '\p{^	bidi_M}', "");
    Expect(1, 120772, '\P{	bidi_M}', "");
    Expect(0, 120772, '\P{^	bidi_M}', "");
    Error('\p{_	IS_BIDI_M:=}');
    Error('\P{_	IS_BIDI_M:=}');
    Expect(1, 120771, '\p{isbidim}', "");
    Expect(0, 120771, '\p{^isbidim}', "");
    Expect(0, 120771, '\P{isbidim}', "");
    Expect(1, 120771, '\P{^isbidim}', "");
    Expect(0, 120772, '\p{isbidim}', "");
    Expect(1, 120772, '\p{^isbidim}', "");
    Expect(1, 120772, '\P{isbidim}', "");
    Expect(0, 120772, '\P{^isbidim}', "");
    Expect(1, 120771, '\p{-IS_Bidi_m}', "");
    Expect(0, 120771, '\p{^-IS_Bidi_m}', "");
    Expect(0, 120771, '\P{-IS_Bidi_m}', "");
    Expect(1, 120771, '\P{^-IS_Bidi_m}', "");
    Expect(0, 120772, '\p{-IS_Bidi_m}', "");
    Expect(1, 120772, '\p{^-IS_Bidi_m}', "");
    Expect(1, 120772, '\P{-IS_Bidi_m}', "");
    Expect(0, 120772, '\P{^-IS_Bidi_m}', "");
    Error('\p{ /a/XPOSIXBLANK}');
    Error('\P{ /a/XPOSIXBLANK}');
    Expect(1, 12288, '\p{xposixblank}', "");
    Expect(0, 12288, '\p{^xposixblank}', "");
    Expect(0, 12288, '\P{xposixblank}', "");
    Expect(1, 12288, '\P{^xposixblank}', "");
    Expect(0, 12289, '\p{xposixblank}', "");
    Expect(1, 12289, '\p{^xposixblank}', "");
    Expect(1, 12289, '\P{xposixblank}', "");
    Expect(0, 12289, '\P{^xposixblank}', "");
    Expect(1, 12288, '\p{_ xposixblank}', "");
    Expect(0, 12288, '\p{^_ xposixblank}', "");
    Expect(0, 12288, '\P{_ xposixblank}', "");
    Expect(1, 12288, '\P{^_ xposixblank}', "");
    Expect(0, 12289, '\p{_ xposixblank}', "");
    Expect(1, 12289, '\p{^_ xposixblank}', "");
    Expect(1, 12289, '\P{_ xposixblank}', "");
    Expect(0, 12289, '\P{^_ xposixblank}', "");
    Error('\p{:=	blank}');
    Error('\P{:=	blank}');
    Expect(1, 12288, '\p{blank}', "");
    Expect(0, 12288, '\p{^blank}', "");
    Expect(0, 12288, '\P{blank}', "");
    Expect(1, 12288, '\P{^blank}', "");
    Expect(0, 12289, '\p{blank}', "");
    Expect(1, 12289, '\p{^blank}', "");
    Expect(1, 12289, '\P{blank}', "");
    Expect(0, 12289, '\P{^blank}', "");
    Expect(1, 12288, '\p{ BLANK}', "");
    Expect(0, 12288, '\p{^ BLANK}', "");
    Expect(0, 12288, '\P{ BLANK}', "");
    Expect(1, 12288, '\P{^ BLANK}', "");
    Expect(0, 12289, '\p{ BLANK}', "");
    Expect(1, 12289, '\p{^ BLANK}', "");
    Expect(1, 12289, '\P{ BLANK}', "");
    Expect(0, 12289, '\P{^ BLANK}', "");
    Error('\p{:=- HORIZSPACE}');
    Error('\P{:=- HORIZSPACE}');
    Expect(1, 12288, '\p{horizspace}', "");
    Expect(0, 12288, '\p{^horizspace}', "");
    Expect(0, 12288, '\P{horizspace}', "");
    Expect(1, 12288, '\P{^horizspace}', "");
    Expect(0, 12289, '\p{horizspace}', "");
    Expect(1, 12289, '\p{^horizspace}', "");
    Expect(1, 12289, '\P{horizspace}', "");
    Expect(0, 12289, '\P{^horizspace}', "");
    Expect(1, 12288, '\p{_ HorizSpace}', "");
    Expect(0, 12288, '\p{^_ HorizSpace}', "");
    Expect(0, 12288, '\P{_ HorizSpace}', "");
    Expect(1, 12288, '\P{^_ HorizSpace}', "");
    Expect(0, 12289, '\p{_ HorizSpace}', "");
    Expect(1, 12289, '\p{^_ HorizSpace}', "");
    Expect(1, 12289, '\P{_ HorizSpace}', "");
    Expect(0, 12289, '\P{^_ HorizSpace}', "");
    Error('\p{:=_Is_XPosixBlank}');
    Error('\P{:=_Is_XPosixBlank}');
    Expect(1, 12288, '\p{isxposixblank}', "");
    Expect(0, 12288, '\p{^isxposixblank}', "");
    Expect(0, 12288, '\P{isxposixblank}', "");
    Expect(1, 12288, '\P{^isxposixblank}', "");
    Expect(0, 12289, '\p{isxposixblank}', "");
    Expect(1, 12289, '\p{^isxposixblank}', "");
    Expect(1, 12289, '\P{isxposixblank}', "");
    Expect(0, 12289, '\P{^isxposixblank}', "");
    Expect(1, 12288, '\p{-Is_xposixblank}', "");
    Expect(0, 12288, '\p{^-Is_xposixblank}', "");
    Expect(0, 12288, '\P{-Is_xposixblank}', "");
    Expect(1, 12288, '\P{^-Is_xposixblank}', "");
    Expect(0, 12289, '\p{-Is_xposixblank}', "");
    Expect(1, 12289, '\p{^-Is_xposixblank}', "");
    Expect(1, 12289, '\P{-Is_xposixblank}', "");
    Expect(0, 12289, '\P{^-Is_xposixblank}', "");
    Error('\p{	 IS_Blank/a/}');
    Error('\P{	 IS_Blank/a/}');
    Expect(1, 12288, '\p{isblank}', "");
    Expect(0, 12288, '\p{^isblank}', "");
    Expect(0, 12288, '\P{isblank}', "");
    Expect(1, 12288, '\P{^isblank}', "");
    Expect(0, 12289, '\p{isblank}', "");
    Expect(1, 12289, '\p{^isblank}', "");
    Expect(1, 12289, '\P{isblank}', "");
    Expect(0, 12289, '\P{^isblank}', "");
    Expect(1, 12288, '\p{	_is_Blank}', "");
    Expect(0, 12288, '\p{^	_is_Blank}', "");
    Expect(0, 12288, '\P{	_is_Blank}', "");
    Expect(1, 12288, '\P{^	_is_Blank}', "");
    Expect(0, 12289, '\p{	_is_Blank}', "");
    Expect(1, 12289, '\p{^	_is_Blank}', "");
    Expect(1, 12289, '\P{	_is_Blank}', "");
    Expect(0, 12289, '\P{^	_is_Blank}', "");
    Error('\p{:=--Is_HorizSpace}');
    Error('\P{:=--Is_HorizSpace}');
    Expect(1, 12288, '\p{ishorizspace}', "");
    Expect(0, 12288, '\p{^ishorizspace}', "");
    Expect(0, 12288, '\P{ishorizspace}', "");
    Expect(1, 12288, '\P{^ishorizspace}', "");
    Expect(0, 12289, '\p{ishorizspace}', "");
    Expect(1, 12289, '\p{^ishorizspace}', "");
    Expect(1, 12289, '\P{ishorizspace}', "");
    Expect(0, 12289, '\P{^ishorizspace}', "");
    Expect(1, 12288, '\p{	_Is_horizspace}', "");
    Expect(0, 12288, '\p{^	_Is_horizspace}', "");
    Expect(0, 12288, '\P{	_Is_horizspace}', "");
    Expect(1, 12288, '\P{^	_Is_horizspace}', "");
    Expect(0, 12289, '\p{	_Is_horizspace}', "");
    Expect(1, 12289, '\p{^	_Is_horizspace}', "");
    Expect(1, 12289, '\P{	_Is_horizspace}', "");
    Expect(0, 12289, '\P{^	_Is_horizspace}', "");
    Error('\p{/a/_BLOCK_elements}');
    Error('\P{/a/_BLOCK_elements}');
    Expect(1, 9631, '\p{blockelements}', "");
    Expect(0, 9631, '\p{^blockelements}', "");
    Expect(0, 9631, '\P{blockelements}', "");
    Expect(1, 9631, '\P{^blockelements}', "");
    Expect(0, 9632, '\p{blockelements}', "");
    Expect(1, 9632, '\p{^blockelements}', "");
    Expect(1, 9632, '\P{blockelements}', "");
    Expect(0, 9632, '\P{^blockelements}', "");
    Expect(1, 9631, '\p{- block_Elements}', "");
    Expect(0, 9631, '\p{^- block_Elements}', "");
    Expect(0, 9631, '\P{- block_Elements}', "");
    Expect(1, 9631, '\P{^- block_Elements}', "");
    Expect(0, 9632, '\p{- block_Elements}', "");
    Expect(1, 9632, '\p{^- block_Elements}', "");
    Expect(1, 9632, '\P{- block_Elements}', "");
    Expect(0, 9632, '\P{^- block_Elements}', "");
    Error('\p{:=	Is_Block_Elements}');
    Error('\P{:=	Is_Block_Elements}');
    Expect(1, 9631, '\p{isblockelements}', "");
    Expect(0, 9631, '\p{^isblockelements}', "");
    Expect(0, 9631, '\P{isblockelements}', "");
    Expect(1, 9631, '\P{^isblockelements}', "");
    Expect(0, 9632, '\p{isblockelements}', "");
    Expect(1, 9632, '\p{^isblockelements}', "");
    Expect(1, 9632, '\P{isblockelements}', "");
    Expect(0, 9632, '\P{^isblockelements}', "");
    Expect(1, 9631, '\p{_-IS_BLOCK_Elements}', "");
    Expect(0, 9631, '\p{^_-IS_BLOCK_Elements}', "");
    Expect(0, 9631, '\P{_-IS_BLOCK_Elements}', "");
    Expect(1, 9631, '\P{^_-IS_BLOCK_Elements}', "");
    Expect(0, 9632, '\p{_-IS_BLOCK_Elements}', "");
    Expect(1, 9632, '\p{^_-IS_BLOCK_Elements}', "");
    Expect(1, 9632, '\P{_-IS_BLOCK_Elements}', "");
    Expect(0, 9632, '\P{^_-IS_BLOCK_Elements}', "");
    Error('\p{/a/ in_block_elements}');
    Error('\P{/a/ in_block_elements}');
    Expect(1, 9631, '\p{inblockelements}', "");
    Expect(0, 9631, '\p{^inblockelements}', "");
    Expect(0, 9631, '\P{inblockelements}', "");
    Expect(1, 9631, '\P{^inblockelements}', "");
    Expect(0, 9632, '\p{inblockelements}', "");
    Expect(1, 9632, '\p{^inblockelements}', "");
    Expect(1, 9632, '\P{inblockelements}', "");
    Expect(0, 9632, '\P{^inblockelements}', "");
    Expect(1, 9631, '\p{  In_Block_elements}', "");
    Expect(0, 9631, '\p{^  In_Block_elements}', "");
    Expect(0, 9631, '\P{  In_Block_elements}', "");
    Expect(1, 9631, '\P{^  In_Block_elements}', "");
    Expect(0, 9632, '\p{  In_Block_elements}', "");
    Expect(1, 9632, '\p{^  In_Block_elements}', "");
    Expect(1, 9632, '\P{  In_Block_elements}', "");
    Expect(0, 9632, '\P{^  In_Block_elements}', "");
    Error('\p{-:=bopomofo}');
    Error('\P{-:=bopomofo}');
    Expect(1, 65381, '\p{bopomofo}', "");
    Expect(0, 65381, '\p{^bopomofo}', "");
    Expect(0, 65381, '\P{bopomofo}', "");
    Expect(1, 65381, '\P{^bopomofo}', "");
    Expect(0, 65382, '\p{bopomofo}', "");
    Expect(1, 65382, '\p{^bopomofo}', "");
    Expect(1, 65382, '\P{bopomofo}', "");
    Expect(0, 65382, '\P{^bopomofo}', "");
    Expect(1, 65381, '\p{-Bopomofo}', "");
    Expect(0, 65381, '\p{^-Bopomofo}', "");
    Expect(0, 65381, '\P{-Bopomofo}', "");
    Expect(1, 65381, '\P{^-Bopomofo}', "");
    Expect(0, 65382, '\p{-Bopomofo}', "");
    Expect(1, 65382, '\p{^-Bopomofo}', "");
    Expect(1, 65382, '\P{-Bopomofo}', "");
    Expect(0, 65382, '\P{^-Bopomofo}', "");
    Error('\p{	:=is_Bopomofo}');
    Error('\P{	:=is_Bopomofo}');
    Expect(1, 65381, '\p{isbopomofo}', "");
    Expect(0, 65381, '\p{^isbopomofo}', "");
    Expect(0, 65381, '\P{isbopomofo}', "");
    Expect(1, 65381, '\P{^isbopomofo}', "");
    Expect(0, 65382, '\p{isbopomofo}', "");
    Expect(1, 65382, '\p{^isbopomofo}', "");
    Expect(1, 65382, '\P{isbopomofo}', "");
    Expect(0, 65382, '\P{^isbopomofo}', "");
    Expect(1, 65381, '\p{__Is_bopomofo}', "");
    Expect(0, 65381, '\p{^__Is_bopomofo}', "");
    Expect(0, 65381, '\P{__Is_bopomofo}', "");
    Expect(1, 65381, '\P{^__Is_bopomofo}', "");
    Expect(0, 65382, '\p{__Is_bopomofo}', "");
    Expect(1, 65382, '\p{^__Is_bopomofo}', "");
    Expect(1, 65382, '\P{__Is_bopomofo}', "");
    Expect(0, 65382, '\P{^__Is_bopomofo}', "");
    Error('\p{ :=Bopo}');
    Error('\P{ :=Bopo}');
    Expect(1, 65381, '\p{bopo}', "");
    Expect(0, 65381, '\p{^bopo}', "");
    Expect(0, 65381, '\P{bopo}', "");
    Expect(1, 65381, '\P{^bopo}', "");
    Expect(0, 65382, '\p{bopo}', "");
    Expect(1, 65382, '\p{^bopo}', "");
    Expect(1, 65382, '\P{bopo}', "");
    Expect(0, 65382, '\P{^bopo}', "");
    Expect(1, 65381, '\p{	_BOPO}', "");
    Expect(0, 65381, '\p{^	_BOPO}', "");
    Expect(0, 65381, '\P{	_BOPO}', "");
    Expect(1, 65381, '\P{^	_BOPO}', "");
    Expect(0, 65382, '\p{	_BOPO}', "");
    Expect(1, 65382, '\p{^	_BOPO}', "");
    Expect(1, 65382, '\P{	_BOPO}', "");
    Expect(0, 65382, '\P{^	_BOPO}', "");
    Error('\p{IS_bopo:=}');
    Error('\P{IS_bopo:=}');
    Expect(1, 65381, '\p{isbopo}', "");
    Expect(0, 65381, '\p{^isbopo}', "");
    Expect(0, 65381, '\P{isbopo}', "");
    Expect(1, 65381, '\P{^isbopo}', "");
    Expect(0, 65382, '\p{isbopo}', "");
    Expect(1, 65382, '\p{^isbopo}', "");
    Expect(1, 65382, '\P{isbopo}', "");
    Expect(0, 65382, '\P{^isbopo}', "");
    Expect(1, 65381, '\p{	-Is_Bopo}', "");
    Expect(0, 65381, '\p{^	-Is_Bopo}', "");
    Expect(0, 65381, '\P{	-Is_Bopo}', "");
    Expect(1, 65381, '\P{^	-Is_Bopo}', "");
    Expect(0, 65382, '\p{	-Is_Bopo}', "");
    Expect(1, 65382, '\p{^	-Is_Bopo}', "");
    Expect(1, 65382, '\P{	-Is_Bopo}', "");
    Expect(0, 65382, '\P{^	-Is_Bopo}', "");
    Error('\p{-/a/Bopomofo_Extended}');
    Error('\P{-/a/Bopomofo_Extended}');
    Expect(1, 12735, '\p{bopomofoextended}', "");
    Expect(0, 12735, '\p{^bopomofoextended}', "");
    Expect(0, 12735, '\P{bopomofoextended}', "");
    Expect(1, 12735, '\P{^bopomofoextended}', "");
    Expect(0, 12736, '\p{bopomofoextended}', "");
    Expect(1, 12736, '\p{^bopomofoextended}', "");
    Expect(1, 12736, '\P{bopomofoextended}', "");
    Expect(0, 12736, '\P{^bopomofoextended}', "");
    Expect(1, 12735, '\p{BOPOMOFO_Extended}', "");
    Expect(0, 12735, '\p{^BOPOMOFO_Extended}', "");
    Expect(0, 12735, '\P{BOPOMOFO_Extended}', "");
    Expect(1, 12735, '\P{^BOPOMOFO_Extended}', "");
    Expect(0, 12736, '\p{BOPOMOFO_Extended}', "");
    Expect(1, 12736, '\p{^BOPOMOFO_Extended}', "");
    Expect(1, 12736, '\P{BOPOMOFO_Extended}', "");
    Expect(0, 12736, '\P{^BOPOMOFO_Extended}', "");
    Error('\p{/a/-IS_Bopomofo_Extended}');
    Error('\P{/a/-IS_Bopomofo_Extended}');
    Expect(1, 12735, '\p{isbopomofoextended}', "");
    Expect(0, 12735, '\p{^isbopomofoextended}', "");
    Expect(0, 12735, '\P{isbopomofoextended}', "");
    Expect(1, 12735, '\P{^isbopomofoextended}', "");
    Expect(0, 12736, '\p{isbopomofoextended}', "");
    Expect(1, 12736, '\p{^isbopomofoextended}', "");
    Expect(1, 12736, '\P{isbopomofoextended}', "");
    Expect(0, 12736, '\P{^isbopomofoextended}', "");
    Expect(1, 12735, '\p{ _is_Bopomofo_Extended}', "");
    Expect(0, 12735, '\p{^ _is_Bopomofo_Extended}', "");
    Expect(0, 12735, '\P{ _is_Bopomofo_Extended}', "");
    Expect(1, 12735, '\P{^ _is_Bopomofo_Extended}', "");
    Expect(0, 12736, '\p{ _is_Bopomofo_Extended}', "");
    Expect(1, 12736, '\p{^ _is_Bopomofo_Extended}', "");
    Expect(1, 12736, '\P{ _is_Bopomofo_Extended}', "");
    Expect(0, 12736, '\P{^ _is_Bopomofo_Extended}', "");
    Error('\p{/a/IN_BOPOMOFO_EXTENDED}');
    Error('\P{/a/IN_BOPOMOFO_EXTENDED}');
    Expect(1, 12735, '\p{inbopomofoextended}', "");
    Expect(0, 12735, '\p{^inbopomofoextended}', "");
    Expect(0, 12735, '\P{inbopomofoextended}', "");
    Expect(1, 12735, '\P{^inbopomofoextended}', "");
    Expect(0, 12736, '\p{inbopomofoextended}', "");
    Expect(1, 12736, '\p{^inbopomofoextended}', "");
    Expect(1, 12736, '\P{inbopomofoextended}', "");
    Expect(0, 12736, '\P{^inbopomofoextended}', "");
    Expect(1, 12735, '\p{  In_Bopomofo_Extended}', "");
    Expect(0, 12735, '\p{^  In_Bopomofo_Extended}', "");
    Expect(0, 12735, '\P{  In_Bopomofo_Extended}', "");
    Expect(1, 12735, '\P{^  In_Bopomofo_Extended}', "");
    Expect(0, 12736, '\p{  In_Bopomofo_Extended}', "");
    Expect(1, 12736, '\p{^  In_Bopomofo_Extended}', "");
    Expect(1, 12736, '\P{  In_Bopomofo_Extended}', "");
    Expect(0, 12736, '\P{^  In_Bopomofo_Extended}', "");
    Error('\p{ :=Bopomofo_Ext}');
    Error('\P{ :=Bopomofo_Ext}');
    Expect(1, 12735, '\p{bopomofoext}', "");
    Expect(0, 12735, '\p{^bopomofoext}', "");
    Expect(0, 12735, '\P{bopomofoext}', "");
    Expect(1, 12735, '\P{^bopomofoext}', "");
    Expect(0, 12736, '\p{bopomofoext}', "");
    Expect(1, 12736, '\p{^bopomofoext}', "");
    Expect(1, 12736, '\P{bopomofoext}', "");
    Expect(0, 12736, '\P{^bopomofoext}', "");
    Expect(1, 12735, '\p{__bopomofo_Ext}', "");
    Expect(0, 12735, '\p{^__bopomofo_Ext}', "");
    Expect(0, 12735, '\P{__bopomofo_Ext}', "");
    Expect(1, 12735, '\P{^__bopomofo_Ext}', "");
    Expect(0, 12736, '\p{__bopomofo_Ext}', "");
    Expect(1, 12736, '\p{^__bopomofo_Ext}', "");
    Expect(1, 12736, '\P{__bopomofo_Ext}', "");
    Expect(0, 12736, '\P{^__bopomofo_Ext}', "");
    Error('\p{:=-_is_BOPOMOFO_Ext}');
    Error('\P{:=-_is_BOPOMOFO_Ext}');
    Expect(1, 12735, '\p{isbopomofoext}', "");
    Expect(0, 12735, '\p{^isbopomofoext}', "");
    Expect(0, 12735, '\P{isbopomofoext}', "");
    Expect(1, 12735, '\P{^isbopomofoext}', "");
    Expect(0, 12736, '\p{isbopomofoext}', "");
    Expect(1, 12736, '\p{^isbopomofoext}', "");
    Expect(1, 12736, '\P{isbopomofoext}', "");
    Expect(0, 12736, '\P{^isbopomofoext}', "");
    Expect(1, 12735, '\p{	-IS_BOPOMOFO_EXT}', "");
    Expect(0, 12735, '\p{^	-IS_BOPOMOFO_EXT}', "");
    Expect(0, 12735, '\P{	-IS_BOPOMOFO_EXT}', "");
    Expect(1, 12735, '\P{^	-IS_BOPOMOFO_EXT}', "");
    Expect(0, 12736, '\p{	-IS_BOPOMOFO_EXT}', "");
    Expect(1, 12736, '\p{^	-IS_BOPOMOFO_EXT}', "");
    Expect(1, 12736, '\P{	-IS_BOPOMOFO_EXT}', "");
    Expect(0, 12736, '\P{^	-IS_BOPOMOFO_EXT}', "");
    Error('\p{	:=IN_bopomofo_EXT}');
    Error('\P{	:=IN_bopomofo_EXT}');
    Expect(1, 12735, '\p{inbopomofoext}', "");
    Expect(0, 12735, '\p{^inbopomofoext}', "");
    Expect(0, 12735, '\P{inbopomofoext}', "");
    Expect(1, 12735, '\P{^inbopomofoext}', "");
    Expect(0, 12736, '\p{inbopomofoext}', "");
    Expect(1, 12736, '\p{^inbopomofoext}', "");
    Expect(1, 12736, '\P{inbopomofoext}', "");
    Expect(0, 12736, '\P{^inbopomofoext}', "");
    Expect(1, 12735, '\p{_	In_bopomofo_ext}', "");
    Expect(0, 12735, '\p{^_	In_bopomofo_ext}', "");
    Expect(0, 12735, '\P{_	In_bopomofo_ext}', "");
    Expect(1, 12735, '\P{^_	In_bopomofo_ext}', "");
    Expect(0, 12736, '\p{_	In_bopomofo_ext}', "");
    Expect(1, 12736, '\p{^_	In_bopomofo_ext}', "");
    Expect(1, 12736, '\P{_	In_bopomofo_ext}', "");
    Expect(0, 12736, '\P{^_	In_bopomofo_ext}', "");
    Error('\p{ :=BOX_Drawing}');
    Error('\P{ :=BOX_Drawing}');
    Expect(1, 9599, '\p{boxdrawing}', "");
    Expect(0, 9599, '\p{^boxdrawing}', "");
    Expect(0, 9599, '\P{boxdrawing}', "");
    Expect(1, 9599, '\P{^boxdrawing}', "");
    Expect(0, 9600, '\p{boxdrawing}', "");
    Expect(1, 9600, '\p{^boxdrawing}', "");
    Expect(1, 9600, '\P{boxdrawing}', "");
    Expect(0, 9600, '\P{^boxdrawing}', "");
    Expect(1, 9599, '\p{_BOX_DRAWING}', "");
    Expect(0, 9599, '\p{^_BOX_DRAWING}', "");
    Expect(0, 9599, '\P{_BOX_DRAWING}', "");
    Expect(1, 9599, '\P{^_BOX_DRAWING}', "");
    Expect(0, 9600, '\p{_BOX_DRAWING}', "");
    Expect(1, 9600, '\p{^_BOX_DRAWING}', "");
    Expect(1, 9600, '\P{_BOX_DRAWING}', "");
    Expect(0, 9600, '\P{^_BOX_DRAWING}', "");
    Error('\p{:= is_BOX_DRAWING}');
    Error('\P{:= is_BOX_DRAWING}');
    Expect(1, 9599, '\p{isboxdrawing}', "");
    Expect(0, 9599, '\p{^isboxdrawing}', "");
    Expect(0, 9599, '\P{isboxdrawing}', "");
    Expect(1, 9599, '\P{^isboxdrawing}', "");
    Expect(0, 9600, '\p{isboxdrawing}', "");
    Expect(1, 9600, '\p{^isboxdrawing}', "");
    Expect(1, 9600, '\P{isboxdrawing}', "");
    Expect(0, 9600, '\P{^isboxdrawing}', "");
    Expect(1, 9599, '\p{-IS_Box_DRAWING}', "");
    Expect(0, 9599, '\p{^-IS_Box_DRAWING}', "");
    Expect(0, 9599, '\P{-IS_Box_DRAWING}', "");
    Expect(1, 9599, '\P{^-IS_Box_DRAWING}', "");
    Expect(0, 9600, '\p{-IS_Box_DRAWING}', "");
    Expect(1, 9600, '\p{^-IS_Box_DRAWING}', "");
    Expect(1, 9600, '\P{-IS_Box_DRAWING}', "");
    Expect(0, 9600, '\P{^-IS_Box_DRAWING}', "");
    Error('\p{-In_box_Drawing:=}');
    Error('\P{-In_box_Drawing:=}');
    Expect(1, 9599, '\p{inboxdrawing}', "");
    Expect(0, 9599, '\p{^inboxdrawing}', "");
    Expect(0, 9599, '\P{inboxdrawing}', "");
    Expect(1, 9599, '\P{^inboxdrawing}', "");
    Expect(0, 9600, '\p{inboxdrawing}', "");
    Expect(1, 9600, '\p{^inboxdrawing}', "");
    Expect(1, 9600, '\P{inboxdrawing}', "");
    Expect(0, 9600, '\P{^inboxdrawing}', "");
    Expect(1, 9599, '\p{-_IN_BOX_DRAWING}', "");
    Expect(0, 9599, '\p{^-_IN_BOX_DRAWING}', "");
    Expect(0, 9599, '\P{-_IN_BOX_DRAWING}', "");
    Expect(1, 9599, '\P{^-_IN_BOX_DRAWING}', "");
    Expect(0, 9600, '\p{-_IN_BOX_DRAWING}', "");
    Expect(1, 9600, '\p{^-_IN_BOX_DRAWING}', "");
    Expect(1, 9600, '\P{-_IN_BOX_DRAWING}', "");
    Expect(0, 9600, '\P{^-_IN_BOX_DRAWING}', "");
    Error('\p{_/a/Brahmi}');
    Error('\P{_/a/Brahmi}');
    Expect(1, 69759, '\p{brahmi}', "");
    Expect(0, 69759, '\p{^brahmi}', "");
    Expect(0, 69759, '\P{brahmi}', "");
    Expect(1, 69759, '\P{^brahmi}', "");
    Expect(0, 69760, '\p{brahmi}', "");
    Expect(1, 69760, '\p{^brahmi}', "");
    Expect(1, 69760, '\P{brahmi}', "");
    Expect(0, 69760, '\P{^brahmi}', "");
    Expect(1, 69759, '\p{-Brahmi}', "");
    Expect(0, 69759, '\p{^-Brahmi}', "");
    Expect(0, 69759, '\P{-Brahmi}', "");
    Expect(1, 69759, '\P{^-Brahmi}', "");
    Expect(0, 69760, '\p{-Brahmi}', "");
    Expect(1, 69760, '\p{^-Brahmi}', "");
    Expect(1, 69760, '\P{-Brahmi}', "");
    Expect(0, 69760, '\P{^-Brahmi}', "");
    Error('\p{:=	_Is_Brahmi}');
    Error('\P{:=	_Is_Brahmi}');
    Expect(1, 69759, '\p{isbrahmi}', "");
    Expect(0, 69759, '\p{^isbrahmi}', "");
    Expect(0, 69759, '\P{isbrahmi}', "");
    Expect(1, 69759, '\P{^isbrahmi}', "");
    Expect(0, 69760, '\p{isbrahmi}', "");
    Expect(1, 69760, '\p{^isbrahmi}', "");
    Expect(1, 69760, '\P{isbrahmi}', "");
    Expect(0, 69760, '\P{^isbrahmi}', "");
    Expect(1, 69759, '\p{	 Is_brahmi}', "");
    Expect(0, 69759, '\p{^	 Is_brahmi}', "");
    Expect(0, 69759, '\P{	 Is_brahmi}', "");
    Expect(1, 69759, '\P{^	 Is_brahmi}', "");
    Expect(0, 69760, '\p{	 Is_brahmi}', "");
    Expect(1, 69760, '\p{^	 Is_brahmi}', "");
    Expect(1, 69760, '\P{	 Is_brahmi}', "");
    Expect(0, 69760, '\P{^	 Is_brahmi}', "");
    Error('\p{:=brah}');
    Error('\P{:=brah}');
    Expect(1, 69759, '\p{brah}', "");
    Expect(0, 69759, '\p{^brah}', "");
    Expect(0, 69759, '\P{brah}', "");
    Expect(1, 69759, '\P{^brah}', "");
    Expect(0, 69760, '\p{brah}', "");
    Expect(1, 69760, '\p{^brah}', "");
    Expect(1, 69760, '\P{brah}', "");
    Expect(0, 69760, '\P{^brah}', "");
    Expect(1, 69759, '\p{--Brah}', "");
    Expect(0, 69759, '\p{^--Brah}', "");
    Expect(0, 69759, '\P{--Brah}', "");
    Expect(1, 69759, '\P{^--Brah}', "");
    Expect(0, 69760, '\p{--Brah}', "");
    Expect(1, 69760, '\p{^--Brah}', "");
    Expect(1, 69760, '\P{--Brah}', "");
    Expect(0, 69760, '\P{^--Brah}', "");
    Error('\p{/a/Is_BRAH}');
    Error('\P{/a/Is_BRAH}');
    Expect(1, 69759, '\p{isbrah}', "");
    Expect(0, 69759, '\p{^isbrah}', "");
    Expect(0, 69759, '\P{isbrah}', "");
    Expect(1, 69759, '\P{^isbrah}', "");
    Expect(0, 69760, '\p{isbrah}', "");
    Expect(1, 69760, '\p{^isbrah}', "");
    Expect(1, 69760, '\P{isbrah}', "");
    Expect(0, 69760, '\P{^isbrah}', "");
    Expect(1, 69759, '\p{ is_BRAH}', "");
    Expect(0, 69759, '\p{^ is_BRAH}', "");
    Expect(0, 69759, '\P{ is_BRAH}', "");
    Expect(1, 69759, '\P{^ is_BRAH}', "");
    Expect(0, 69760, '\p{ is_BRAH}', "");
    Expect(1, 69760, '\p{^ is_BRAH}', "");
    Expect(1, 69760, '\P{ is_BRAH}', "");
    Expect(0, 69760, '\P{^ is_BRAH}', "");
    Error('\p{:=Braille}');
    Error('\P{:=Braille}');
    Expect(1, 10495, '\p{braille}', "");
    Expect(0, 10495, '\p{^braille}', "");
    Expect(0, 10495, '\P{braille}', "");
    Expect(1, 10495, '\P{^braille}', "");
    Expect(0, 10496, '\p{braille}', "");
    Expect(1, 10496, '\p{^braille}', "");
    Expect(1, 10496, '\P{braille}', "");
    Expect(0, 10496, '\P{^braille}', "");
    Expect(1, 10495, '\p{ -BRAILLE}', "");
    Expect(0, 10495, '\p{^ -BRAILLE}', "");
    Expect(0, 10495, '\P{ -BRAILLE}', "");
    Expect(1, 10495, '\P{^ -BRAILLE}', "");
    Expect(0, 10496, '\p{ -BRAILLE}', "");
    Expect(1, 10496, '\p{^ -BRAILLE}', "");
    Expect(1, 10496, '\P{ -BRAILLE}', "");
    Expect(0, 10496, '\P{^ -BRAILLE}', "");
    Error('\p{-is_Braille/a/}');
    Error('\P{-is_Braille/a/}');
    Expect(1, 10495, '\p{isbraille}', "");
    Expect(0, 10495, '\p{^isbraille}', "");
    Expect(0, 10495, '\P{isbraille}', "");
    Expect(1, 10495, '\P{^isbraille}', "");
    Expect(0, 10496, '\p{isbraille}', "");
    Expect(1, 10496, '\p{^isbraille}', "");
    Expect(1, 10496, '\P{isbraille}', "");
    Expect(0, 10496, '\P{^isbraille}', "");
    Expect(1, 10495, '\p{_-Is_braille}', "");
    Expect(0, 10495, '\p{^_-Is_braille}', "");
    Expect(0, 10495, '\P{_-Is_braille}', "");
    Expect(1, 10495, '\P{^_-Is_braille}', "");
    Expect(0, 10496, '\p{_-Is_braille}', "");
    Expect(1, 10496, '\p{^_-Is_braille}', "");
    Expect(1, 10496, '\P{_-Is_braille}', "");
    Expect(0, 10496, '\P{^_-Is_braille}', "");
    Error('\p{	:=BRAI}');
    Error('\P{	:=BRAI}');
    Expect(1, 10495, '\p{brai}', "");
    Expect(0, 10495, '\p{^brai}', "");
    Expect(0, 10495, '\P{brai}', "");
    Expect(1, 10495, '\P{^brai}', "");
    Expect(0, 10496, '\p{brai}', "");
    Expect(1, 10496, '\p{^brai}', "");
    Expect(1, 10496, '\P{brai}', "");
    Expect(0, 10496, '\P{^brai}', "");
    Expect(1, 10495, '\p{		Brai}', "");
    Expect(0, 10495, '\p{^		Brai}', "");
    Expect(0, 10495, '\P{		Brai}', "");
    Expect(1, 10495, '\P{^		Brai}', "");
    Expect(0, 10496, '\p{		Brai}', "");
    Expect(1, 10496, '\p{^		Brai}', "");
    Expect(1, 10496, '\P{		Brai}', "");
    Expect(0, 10496, '\P{^		Brai}', "");
    Error('\p{	:=Is_BRAI}');
    Error('\P{	:=Is_BRAI}');
    Expect(1, 10495, '\p{isbrai}', "");
    Expect(0, 10495, '\p{^isbrai}', "");
    Expect(0, 10495, '\P{isbrai}', "");
    Expect(1, 10495, '\P{^isbrai}', "");
    Expect(0, 10496, '\p{isbrai}', "");
    Expect(1, 10496, '\p{^isbrai}', "");
    Expect(1, 10496, '\P{isbrai}', "");
    Expect(0, 10496, '\P{^isbrai}', "");
    Expect(1, 10495, '\p{	Is_Brai}', "");
    Expect(0, 10495, '\p{^	Is_Brai}', "");
    Expect(0, 10495, '\P{	Is_Brai}', "");
    Expect(1, 10495, '\P{^	Is_Brai}', "");
    Expect(0, 10496, '\p{	Is_Brai}', "");
    Expect(1, 10496, '\p{^	Is_Brai}', "");
    Expect(1, 10496, '\P{	Is_Brai}', "");
    Expect(0, 10496, '\P{^	Is_Brai}', "");
    Error('\p{:= Braille_patterns}');
    Error('\P{:= Braille_patterns}');
    Expect(1, 10495, '\p{braillepatterns}', "");
    Expect(0, 10495, '\p{^braillepatterns}', "");
    Expect(0, 10495, '\P{braillepatterns}', "");
    Expect(1, 10495, '\P{^braillepatterns}', "");
    Expect(0, 10496, '\p{braillepatterns}', "");
    Expect(1, 10496, '\p{^braillepatterns}', "");
    Expect(1, 10496, '\P{braillepatterns}', "");
    Expect(0, 10496, '\P{^braillepatterns}', "");
    Expect(1, 10495, '\p{__braille_PATTERNS}', "");
    Expect(0, 10495, '\p{^__braille_PATTERNS}', "");
    Expect(0, 10495, '\P{__braille_PATTERNS}', "");
    Expect(1, 10495, '\P{^__braille_PATTERNS}', "");
    Expect(0, 10496, '\p{__braille_PATTERNS}', "");
    Expect(1, 10496, '\p{^__braille_PATTERNS}', "");
    Expect(1, 10496, '\P{__braille_PATTERNS}', "");
    Expect(0, 10496, '\P{^__braille_PATTERNS}', "");
    Error('\p{_/a/is_Braille_patterns}');
    Error('\P{_/a/is_Braille_patterns}');
    Expect(1, 10495, '\p{isbraillepatterns}', "");
    Expect(0, 10495, '\p{^isbraillepatterns}', "");
    Expect(0, 10495, '\P{isbraillepatterns}', "");
    Expect(1, 10495, '\P{^isbraillepatterns}', "");
    Expect(0, 10496, '\p{isbraillepatterns}', "");
    Expect(1, 10496, '\p{^isbraillepatterns}', "");
    Expect(1, 10496, '\P{isbraillepatterns}', "");
    Expect(0, 10496, '\P{^isbraillepatterns}', "");
    Expect(1, 10495, '\p{ _Is_Braille_Patterns}', "");
    Expect(0, 10495, '\p{^ _Is_Braille_Patterns}', "");
    Expect(0, 10495, '\P{ _Is_Braille_Patterns}', "");
    Expect(1, 10495, '\P{^ _Is_Braille_Patterns}', "");
    Expect(0, 10496, '\p{ _Is_Braille_Patterns}', "");
    Expect(1, 10496, '\p{^ _Is_Braille_Patterns}', "");
    Expect(1, 10496, '\P{ _Is_Braille_Patterns}', "");
    Expect(0, 10496, '\P{^ _Is_Braille_Patterns}', "");
    Error('\p{/a/ 	In_braille_patterns}');
    Error('\P{/a/ 	In_braille_patterns}');
    Expect(1, 10495, '\p{inbraillepatterns}', "");
    Expect(0, 10495, '\p{^inbraillepatterns}', "");
    Expect(0, 10495, '\P{inbraillepatterns}', "");
    Expect(1, 10495, '\P{^inbraillepatterns}', "");
    Expect(0, 10496, '\p{inbraillepatterns}', "");
    Expect(1, 10496, '\p{^inbraillepatterns}', "");
    Expect(1, 10496, '\P{inbraillepatterns}', "");
    Expect(0, 10496, '\P{^inbraillepatterns}', "");
    Expect(1, 10495, '\p{  In_Braille_PATTERNS}', "");
    Expect(0, 10495, '\p{^  In_Braille_PATTERNS}', "");
    Expect(0, 10495, '\P{  In_Braille_PATTERNS}', "");
    Expect(1, 10495, '\P{^  In_Braille_PATTERNS}', "");
    Expect(0, 10496, '\p{  In_Braille_PATTERNS}', "");
    Expect(1, 10496, '\p{^  In_Braille_PATTERNS}', "");
    Expect(1, 10496, '\P{  In_Braille_PATTERNS}', "");
    Expect(0, 10496, '\P{^  In_Braille_PATTERNS}', "");
    Error('\p{/a/In_BRAILLE}');
    Error('\P{/a/In_BRAILLE}');
    Expect(1, 10495, '\p{inbraille}', "");
    Expect(0, 10495, '\p{^inbraille}', "");
    Expect(0, 10495, '\P{inbraille}', "");
    Expect(1, 10495, '\P{^inbraille}', "");
    Expect(0, 10496, '\p{inbraille}', "");
    Expect(1, 10496, '\p{^inbraille}', "");
    Expect(1, 10496, '\P{inbraille}', "");
    Expect(0, 10496, '\P{^inbraille}', "");
    Expect(1, 10495, '\p{		in_BRAILLE}', "");
    Expect(0, 10495, '\p{^		in_BRAILLE}', "");
    Expect(0, 10495, '\P{		in_BRAILLE}', "");
    Expect(1, 10495, '\P{^		in_BRAILLE}', "");
    Expect(0, 10496, '\p{		in_BRAILLE}', "");
    Expect(1, 10496, '\p{^		in_BRAILLE}', "");
    Expect(1, 10496, '\P{		in_BRAILLE}', "");
    Expect(0, 10496, '\P{^		in_BRAILLE}', "");
    Error('\p{/a/	Buginese}');
    Error('\P{/a/	Buginese}');
    Expect(1, 43471, '\p{buginese}', "");
    Expect(0, 43471, '\p{^buginese}', "");
    Expect(0, 43471, '\P{buginese}', "");
    Expect(1, 43471, '\P{^buginese}', "");
    Expect(0, 43472, '\p{buginese}', "");
    Expect(1, 43472, '\p{^buginese}', "");
    Expect(1, 43472, '\P{buginese}', "");
    Expect(0, 43472, '\P{^buginese}', "");
    Expect(1, 43471, '\p{- Buginese}', "");
    Expect(0, 43471, '\p{^- Buginese}', "");
    Expect(0, 43471, '\P{- Buginese}', "");
    Expect(1, 43471, '\P{^- Buginese}', "");
    Expect(0, 43472, '\p{- Buginese}', "");
    Expect(1, 43472, '\p{^- Buginese}', "");
    Expect(1, 43472, '\P{- Buginese}', "");
    Expect(0, 43472, '\P{^- Buginese}', "");
    Error('\p{/a/ Is_BUGINESE}');
    Error('\P{/a/ Is_BUGINESE}');
    Expect(1, 43471, '\p{isbuginese}', "");
    Expect(0, 43471, '\p{^isbuginese}', "");
    Expect(0, 43471, '\P{isbuginese}', "");
    Expect(1, 43471, '\P{^isbuginese}', "");
    Expect(0, 43472, '\p{isbuginese}', "");
    Expect(1, 43472, '\p{^isbuginese}', "");
    Expect(1, 43472, '\P{isbuginese}', "");
    Expect(0, 43472, '\P{^isbuginese}', "");
    Expect(1, 43471, '\p{_	Is_Buginese}', "");
    Expect(0, 43471, '\p{^_	Is_Buginese}', "");
    Expect(0, 43471, '\P{_	Is_Buginese}', "");
    Expect(1, 43471, '\P{^_	Is_Buginese}', "");
    Expect(0, 43472, '\p{_	Is_Buginese}', "");
    Expect(1, 43472, '\p{^_	Is_Buginese}', "");
    Expect(1, 43472, '\P{_	Is_Buginese}', "");
    Expect(0, 43472, '\P{^_	Is_Buginese}', "");
    Error('\p{/a/	_Bugi}');
    Error('\P{/a/	_Bugi}');
    Expect(1, 43471, '\p{bugi}', "");
    Expect(0, 43471, '\p{^bugi}', "");
    Expect(0, 43471, '\P{bugi}', "");
    Expect(1, 43471, '\P{^bugi}', "");
    Expect(0, 43472, '\p{bugi}', "");
    Expect(1, 43472, '\p{^bugi}', "");
    Expect(1, 43472, '\P{bugi}', "");
    Expect(0, 43472, '\P{^bugi}', "");
    Expect(1, 43471, '\p{-	Bugi}', "");
    Expect(0, 43471, '\p{^-	Bugi}', "");
    Expect(0, 43471, '\P{-	Bugi}', "");
    Expect(1, 43471, '\P{^-	Bugi}', "");
    Expect(0, 43472, '\p{-	Bugi}', "");
    Expect(1, 43472, '\p{^-	Bugi}', "");
    Expect(1, 43472, '\P{-	Bugi}', "");
    Expect(0, 43472, '\P{^-	Bugi}', "");
    Error('\p{ :=Is_bugi}');
    Error('\P{ :=Is_bugi}');
    Expect(1, 43471, '\p{isbugi}', "");
    Expect(0, 43471, '\p{^isbugi}', "");
    Expect(0, 43471, '\P{isbugi}', "");
    Expect(1, 43471, '\P{^isbugi}', "");
    Expect(0, 43472, '\p{isbugi}', "");
    Expect(1, 43472, '\p{^isbugi}', "");
    Expect(1, 43472, '\P{isbugi}', "");
    Expect(0, 43472, '\P{^isbugi}', "");
    Expect(1, 43471, '\p{_is_bugi}', "");
    Expect(0, 43471, '\p{^_is_bugi}', "");
    Expect(0, 43471, '\P{_is_bugi}', "");
    Expect(1, 43471, '\P{^_is_bugi}', "");
    Expect(0, 43472, '\p{_is_bugi}', "");
    Expect(1, 43472, '\p{^_is_bugi}', "");
    Expect(1, 43472, '\P{_is_bugi}', "");
    Expect(0, 43472, '\P{^_is_bugi}', "");
    Error('\p{	_Buhid/a/}');
    Error('\P{	_Buhid/a/}');
    Expect(1, 5971, '\p{buhid}', "");
    Expect(0, 5971, '\p{^buhid}', "");
    Expect(0, 5971, '\P{buhid}', "");
    Expect(1, 5971, '\P{^buhid}', "");
    Expect(0, 5972, '\p{buhid}', "");
    Expect(1, 5972, '\p{^buhid}', "");
    Expect(1, 5972, '\P{buhid}', "");
    Expect(0, 5972, '\P{^buhid}', "");
    Expect(1, 5971, '\p{-Buhid}', "");
    Expect(0, 5971, '\p{^-Buhid}', "");
    Expect(0, 5971, '\P{-Buhid}', "");
    Expect(1, 5971, '\P{^-Buhid}', "");
    Expect(0, 5972, '\p{-Buhid}', "");
    Expect(1, 5972, '\p{^-Buhid}', "");
    Expect(1, 5972, '\P{-Buhid}', "");
    Expect(0, 5972, '\P{^-Buhid}', "");
    Error('\p{__IS_Buhid/a/}');
    Error('\P{__IS_Buhid/a/}');
    Expect(1, 5971, '\p{isbuhid}', "");
    Expect(0, 5971, '\p{^isbuhid}', "");
    Expect(0, 5971, '\P{isbuhid}', "");
    Expect(1, 5971, '\P{^isbuhid}', "");
    Expect(0, 5972, '\p{isbuhid}', "");
    Expect(1, 5972, '\p{^isbuhid}', "");
    Expect(1, 5972, '\P{isbuhid}', "");
    Expect(0, 5972, '\P{^isbuhid}', "");
    Expect(1, 5971, '\p{_Is_BUHID}', "");
    Expect(0, 5971, '\p{^_Is_BUHID}', "");
    Expect(0, 5971, '\P{_Is_BUHID}', "");
    Expect(1, 5971, '\P{^_Is_BUHID}', "");
    Expect(0, 5972, '\p{_Is_BUHID}', "");
    Expect(1, 5972, '\p{^_Is_BUHID}', "");
    Expect(1, 5972, '\P{_Is_BUHID}', "");
    Expect(0, 5972, '\P{^_Is_BUHID}', "");
    Error('\p{_BUHD/a/}');
    Error('\P{_BUHD/a/}');
    Expect(1, 5971, '\p{buhd}', "");
    Expect(0, 5971, '\p{^buhd}', "");
    Expect(0, 5971, '\P{buhd}', "");
    Expect(1, 5971, '\P{^buhd}', "");
    Expect(0, 5972, '\p{buhd}', "");
    Expect(1, 5972, '\p{^buhd}', "");
    Expect(1, 5972, '\P{buhd}', "");
    Expect(0, 5972, '\P{^buhd}', "");
    Expect(1, 5971, '\p{__Buhd}', "");
    Expect(0, 5971, '\p{^__Buhd}', "");
    Expect(0, 5971, '\P{__Buhd}', "");
    Expect(1, 5971, '\P{^__Buhd}', "");
    Expect(0, 5972, '\p{__Buhd}', "");
    Expect(1, 5972, '\p{^__Buhd}', "");
    Expect(1, 5972, '\P{__Buhd}', "");
    Expect(0, 5972, '\P{^__Buhd}', "");
    Error('\p{__IS_Buhd/a/}');
    Error('\P{__IS_Buhd/a/}');
    Expect(1, 5971, '\p{isbuhd}', "");
    Expect(0, 5971, '\p{^isbuhd}', "");
    Expect(0, 5971, '\P{isbuhd}', "");
    Expect(1, 5971, '\P{^isbuhd}', "");
    Expect(0, 5972, '\p{isbuhd}', "");
    Expect(1, 5972, '\p{^isbuhd}', "");
    Expect(1, 5972, '\P{isbuhd}', "");
    Expect(0, 5972, '\P{^isbuhd}', "");
    Expect(1, 5971, '\p{		Is_BUHD}', "");
    Expect(0, 5971, '\p{^		Is_BUHD}', "");
    Expect(0, 5971, '\P{		Is_BUHD}', "");
    Expect(1, 5971, '\P{^		Is_BUHD}', "");
    Expect(0, 5972, '\p{		Is_BUHD}', "");
    Expect(1, 5972, '\p{^		Is_BUHD}', "");
    Expect(1, 5972, '\P{		Is_BUHD}', "");
    Expect(0, 5972, '\P{^		Is_BUHD}', "");
    Error('\p{	byzantine_Musical_Symbols:=}');
    Error('\P{	byzantine_Musical_Symbols:=}');
    Expect(1, 119039, '\p{byzantinemusicalsymbols}', "");
    Expect(0, 119039, '\p{^byzantinemusicalsymbols}', "");
    Expect(0, 119039, '\P{byzantinemusicalsymbols}', "");
    Expect(1, 119039, '\P{^byzantinemusicalsymbols}', "");
    Expect(0, 119040, '\p{byzantinemusicalsymbols}', "");
    Expect(1, 119040, '\p{^byzantinemusicalsymbols}', "");
    Expect(1, 119040, '\P{byzantinemusicalsymbols}', "");
    Expect(0, 119040, '\P{^byzantinemusicalsymbols}', "");
    Expect(1, 119039, '\p{ 	Byzantine_Musical_Symbols}', "");
    Expect(0, 119039, '\p{^ 	Byzantine_Musical_Symbols}', "");
    Expect(0, 119039, '\P{ 	Byzantine_Musical_Symbols}', "");
    Expect(1, 119039, '\P{^ 	Byzantine_Musical_Symbols}', "");
    Expect(0, 119040, '\p{ 	Byzantine_Musical_Symbols}', "");
    Expect(1, 119040, '\p{^ 	Byzantine_Musical_Symbols}', "");
    Expect(1, 119040, '\P{ 	Byzantine_Musical_Symbols}', "");
    Expect(0, 119040, '\P{^ 	Byzantine_Musical_Symbols}', "");
    Error('\p{/a/	-Is_byzantine_Musical_symbols}');
    Error('\P{/a/	-Is_byzantine_Musical_symbols}');
    Expect(1, 119039, '\p{isbyzantinemusicalsymbols}', "");
    Expect(0, 119039, '\p{^isbyzantinemusicalsymbols}', "");
    Expect(0, 119039, '\P{isbyzantinemusicalsymbols}', "");
    Expect(1, 119039, '\P{^isbyzantinemusicalsymbols}', "");
    Expect(0, 119040, '\p{isbyzantinemusicalsymbols}', "");
    Expect(1, 119040, '\p{^isbyzantinemusicalsymbols}', "");
    Expect(1, 119040, '\P{isbyzantinemusicalsymbols}', "");
    Expect(0, 119040, '\P{^isbyzantinemusicalsymbols}', "");
    Expect(1, 119039, '\p{	IS_BYZANTINE_musical_Symbols}', "");
    Expect(0, 119039, '\p{^	IS_BYZANTINE_musical_Symbols}', "");
    Expect(0, 119039, '\P{	IS_BYZANTINE_musical_Symbols}', "");
    Expect(1, 119039, '\P{^	IS_BYZANTINE_musical_Symbols}', "");
    Expect(0, 119040, '\p{	IS_BYZANTINE_musical_Symbols}', "");
    Expect(1, 119040, '\p{^	IS_BYZANTINE_musical_Symbols}', "");
    Expect(1, 119040, '\P{	IS_BYZANTINE_musical_Symbols}', "");
    Expect(0, 119040, '\P{^	IS_BYZANTINE_musical_Symbols}', "");
    Error('\p{		In_Byzantine_musical_Symbols/a/}');
    Error('\P{		In_Byzantine_musical_Symbols/a/}');
    Expect(1, 119039, '\p{inbyzantinemusicalsymbols}', "");
    Expect(0, 119039, '\p{^inbyzantinemusicalsymbols}', "");
    Expect(0, 119039, '\P{inbyzantinemusicalsymbols}', "");
    Expect(1, 119039, '\P{^inbyzantinemusicalsymbols}', "");
    Expect(0, 119040, '\p{inbyzantinemusicalsymbols}', "");
    Expect(1, 119040, '\p{^inbyzantinemusicalsymbols}', "");
    Expect(1, 119040, '\P{inbyzantinemusicalsymbols}', "");
    Expect(0, 119040, '\P{^inbyzantinemusicalsymbols}', "");
    Expect(1, 119039, '\p{ -In_Byzantine_Musical_SYMBOLS}', "");
    Expect(0, 119039, '\p{^ -In_Byzantine_Musical_SYMBOLS}', "");
    Expect(0, 119039, '\P{ -In_Byzantine_Musical_SYMBOLS}', "");
    Expect(1, 119039, '\P{^ -In_Byzantine_Musical_SYMBOLS}', "");
    Expect(0, 119040, '\p{ -In_Byzantine_Musical_SYMBOLS}', "");
    Expect(1, 119040, '\p{^ -In_Byzantine_Musical_SYMBOLS}', "");
    Expect(1, 119040, '\P{ -In_Byzantine_Musical_SYMBOLS}', "");
    Expect(0, 119040, '\P{^ -In_Byzantine_Musical_SYMBOLS}', "");
    Error('\p{ _Byzantine_Music/a/}');
    Error('\P{ _Byzantine_Music/a/}');
    Expect(1, 119039, '\p{byzantinemusic}', "");
    Expect(0, 119039, '\p{^byzantinemusic}', "");
    Expect(0, 119039, '\P{byzantinemusic}', "");
    Expect(1, 119039, '\P{^byzantinemusic}', "");
    Expect(0, 119040, '\p{byzantinemusic}', "");
    Expect(1, 119040, '\p{^byzantinemusic}', "");
    Expect(1, 119040, '\P{byzantinemusic}', "");
    Expect(0, 119040, '\P{^byzantinemusic}', "");
    Expect(1, 119039, '\p{		Byzantine_music}', "");
    Expect(0, 119039, '\p{^		Byzantine_music}', "");
    Expect(0, 119039, '\P{		Byzantine_music}', "");
    Expect(1, 119039, '\P{^		Byzantine_music}', "");
    Expect(0, 119040, '\p{		Byzantine_music}', "");
    Expect(1, 119040, '\p{^		Byzantine_music}', "");
    Expect(1, 119040, '\P{		Byzantine_music}', "");
    Expect(0, 119040, '\P{^		Byzantine_music}', "");
    Error('\p{ Is_byzantine_MUSIC/a/}');
    Error('\P{ Is_byzantine_MUSIC/a/}');
    Expect(1, 119039, '\p{isbyzantinemusic}', "");
    Expect(0, 119039, '\p{^isbyzantinemusic}', "");
    Expect(0, 119039, '\P{isbyzantinemusic}', "");
    Expect(1, 119039, '\P{^isbyzantinemusic}', "");
    Expect(0, 119040, '\p{isbyzantinemusic}', "");
    Expect(1, 119040, '\p{^isbyzantinemusic}', "");
    Expect(1, 119040, '\P{isbyzantinemusic}', "");
    Expect(0, 119040, '\P{^isbyzantinemusic}', "");
    Expect(1, 119039, '\p{	-Is_BYZANTINE_MUSIC}', "");
    Expect(0, 119039, '\p{^	-Is_BYZANTINE_MUSIC}', "");
    Expect(0, 119039, '\P{	-Is_BYZANTINE_MUSIC}', "");
    Expect(1, 119039, '\P{^	-Is_BYZANTINE_MUSIC}', "");
    Expect(0, 119040, '\p{	-Is_BYZANTINE_MUSIC}', "");
    Expect(1, 119040, '\p{^	-Is_BYZANTINE_MUSIC}', "");
    Expect(1, 119040, '\P{	-Is_BYZANTINE_MUSIC}', "");
    Expect(0, 119040, '\P{^	-Is_BYZANTINE_MUSIC}', "");
    Error('\p{_-In_BYZANTINE_Music:=}');
    Error('\P{_-In_BYZANTINE_Music:=}');
    Expect(1, 119039, '\p{inbyzantinemusic}', "");
    Expect(0, 119039, '\p{^inbyzantinemusic}', "");
    Expect(0, 119039, '\P{inbyzantinemusic}', "");
    Expect(1, 119039, '\P{^inbyzantinemusic}', "");
    Expect(0, 119040, '\p{inbyzantinemusic}', "");
    Expect(1, 119040, '\p{^inbyzantinemusic}', "");
    Expect(1, 119040, '\P{inbyzantinemusic}', "");
    Expect(0, 119040, '\P{^inbyzantinemusic}', "");
    Expect(1, 119039, '\p{_In_byzantine_Music}', "");
    Expect(0, 119039, '\p{^_In_byzantine_Music}', "");
    Expect(0, 119039, '\P{_In_byzantine_Music}', "");
    Expect(1, 119039, '\P{^_In_byzantine_Music}', "");
    Expect(0, 119040, '\p{_In_byzantine_Music}', "");
    Expect(1, 119040, '\p{^_In_byzantine_Music}', "");
    Expect(1, 119040, '\P{_In_byzantine_Music}', "");
    Expect(0, 119040, '\P{^_In_byzantine_Music}', "");
    Error('\p{_ CANADIAN_Aboriginal/a/}');
    Error('\P{_ CANADIAN_Aboriginal/a/}');
    Expect(1, 72383, '\p{canadianaboriginal}', "");
    Expect(0, 72383, '\p{^canadianaboriginal}', "");
    Expect(0, 72383, '\P{canadianaboriginal}', "");
    Expect(1, 72383, '\P{^canadianaboriginal}', "");
    Expect(0, 72384, '\p{canadianaboriginal}', "");
    Expect(1, 72384, '\p{^canadianaboriginal}', "");
    Expect(1, 72384, '\P{canadianaboriginal}', "");
    Expect(0, 72384, '\P{^canadianaboriginal}', "");
    Expect(1, 72383, '\p{_	Canadian_Aboriginal}', "");
    Expect(0, 72383, '\p{^_	Canadian_Aboriginal}', "");
    Expect(0, 72383, '\P{_	Canadian_Aboriginal}', "");
    Expect(1, 72383, '\P{^_	Canadian_Aboriginal}', "");
    Expect(0, 72384, '\p{_	Canadian_Aboriginal}', "");
    Expect(1, 72384, '\p{^_	Canadian_Aboriginal}', "");
    Expect(1, 72384, '\P{_	Canadian_Aboriginal}', "");
    Expect(0, 72384, '\P{^_	Canadian_Aboriginal}', "");
    Error('\p{/a/Is_Canadian_Aboriginal}');
    Error('\P{/a/Is_Canadian_Aboriginal}');
    Expect(1, 72383, '\p{iscanadianaboriginal}', "");
    Expect(0, 72383, '\p{^iscanadianaboriginal}', "");
    Expect(0, 72383, '\P{iscanadianaboriginal}', "");
    Expect(1, 72383, '\P{^iscanadianaboriginal}', "");
    Expect(0, 72384, '\p{iscanadianaboriginal}', "");
    Expect(1, 72384, '\p{^iscanadianaboriginal}', "");
    Expect(1, 72384, '\P{iscanadianaboriginal}', "");
    Expect(0, 72384, '\P{^iscanadianaboriginal}', "");
    Expect(1, 72383, '\p{- Is_canadian_ABORIGINAL}', "");
    Expect(0, 72383, '\p{^- Is_canadian_ABORIGINAL}', "");
    Expect(0, 72383, '\P{- Is_canadian_ABORIGINAL}', "");
    Expect(1, 72383, '\P{^- Is_canadian_ABORIGINAL}', "");
    Expect(0, 72384, '\p{- Is_canadian_ABORIGINAL}', "");
    Expect(1, 72384, '\p{^- Is_canadian_ABORIGINAL}', "");
    Expect(1, 72384, '\P{- Is_canadian_ABORIGINAL}', "");
    Expect(0, 72384, '\P{^- Is_canadian_ABORIGINAL}', "");
    Error('\p{_ Cans/a/}');
    Error('\P{_ Cans/a/}');
    Expect(1, 72383, '\p{cans}', "");
    Expect(0, 72383, '\p{^cans}', "");
    Expect(0, 72383, '\P{cans}', "");
    Expect(1, 72383, '\P{^cans}', "");
    Expect(0, 72384, '\p{cans}', "");
    Expect(1, 72384, '\p{^cans}', "");
    Expect(1, 72384, '\P{cans}', "");
    Expect(0, 72384, '\P{^cans}', "");
    Expect(1, 72383, '\p{ 	CANS}', "");
    Expect(0, 72383, '\p{^ 	CANS}', "");
    Expect(0, 72383, '\P{ 	CANS}', "");
    Expect(1, 72383, '\P{^ 	CANS}', "");
    Expect(0, 72384, '\p{ 	CANS}', "");
    Expect(1, 72384, '\p{^ 	CANS}', "");
    Expect(1, 72384, '\P{ 	CANS}', "");
    Expect(0, 72384, '\P{^ 	CANS}', "");
    Error('\p{_:=is_CANS}');
    Error('\P{_:=is_CANS}');
    Expect(1, 72383, '\p{iscans}', "");
    Expect(0, 72383, '\p{^iscans}', "");
    Expect(0, 72383, '\P{iscans}', "");
    Expect(1, 72383, '\P{^iscans}', "");
    Expect(0, 72384, '\p{iscans}', "");
    Expect(1, 72384, '\p{^iscans}', "");
    Expect(1, 72384, '\P{iscans}', "");
    Expect(0, 72384, '\P{^iscans}', "");
    Expect(1, 72383, '\p{	 is_CANS}', "");
    Expect(0, 72383, '\p{^	 is_CANS}', "");
    Expect(0, 72383, '\P{	 is_CANS}', "");
    Expect(1, 72383, '\P{^	 is_CANS}', "");
    Expect(0, 72384, '\p{	 is_CANS}', "");
    Expect(1, 72384, '\p{^	 is_CANS}', "");
    Expect(1, 72384, '\P{	 is_CANS}', "");
    Expect(0, 72384, '\P{^	 is_CANS}', "");
    Error('\p{_Carian/a/}');
    Error('\P{_Carian/a/}');
    Expect(1, 66256, '\p{carian}', "");
    Expect(0, 66256, '\p{^carian}', "");
    Expect(0, 66256, '\P{carian}', "");
    Expect(1, 66256, '\P{^carian}', "");
    Expect(0, 66257, '\p{carian}', "");
    Expect(1, 66257, '\p{^carian}', "");
    Expect(1, 66257, '\P{carian}', "");
    Expect(0, 66257, '\P{^carian}', "");
    Expect(1, 66256, '\p{-_carian}', "");
    Expect(0, 66256, '\p{^-_carian}', "");
    Expect(0, 66256, '\P{-_carian}', "");
    Expect(1, 66256, '\P{^-_carian}', "");
    Expect(0, 66257, '\p{-_carian}', "");
    Expect(1, 66257, '\p{^-_carian}', "");
    Expect(1, 66257, '\P{-_carian}', "");
    Expect(0, 66257, '\P{^-_carian}', "");
    Error('\p{_ Is_Carian:=}');
    Error('\P{_ Is_Carian:=}');
    Expect(1, 66256, '\p{iscarian}', "");
    Expect(0, 66256, '\p{^iscarian}', "");
    Expect(0, 66256, '\P{iscarian}', "");
    Expect(1, 66256, '\P{^iscarian}', "");
    Expect(0, 66257, '\p{iscarian}', "");
    Expect(1, 66257, '\p{^iscarian}', "");
    Expect(1, 66257, '\P{iscarian}', "");
    Expect(0, 66257, '\P{^iscarian}', "");
    Expect(1, 66256, '\p{- Is_CARIAN}', "");
    Expect(0, 66256, '\p{^- Is_CARIAN}', "");
    Expect(0, 66256, '\P{- Is_CARIAN}', "");
    Expect(1, 66256, '\P{^- Is_CARIAN}', "");
    Expect(0, 66257, '\p{- Is_CARIAN}', "");
    Expect(1, 66257, '\p{^- Is_CARIAN}', "");
    Expect(1, 66257, '\P{- Is_CARIAN}', "");
    Expect(0, 66257, '\P{^- Is_CARIAN}', "");
    Error('\p{:=Cari}');
    Error('\P{:=Cari}');
    Expect(1, 66256, '\p{cari}', "");
    Expect(0, 66256, '\p{^cari}', "");
    Expect(0, 66256, '\P{cari}', "");
    Expect(1, 66256, '\P{^cari}', "");
    Expect(0, 66257, '\p{cari}', "");
    Expect(1, 66257, '\p{^cari}', "");
    Expect(1, 66257, '\P{cari}', "");
    Expect(0, 66257, '\P{^cari}', "");
    Expect(1, 66256, '\p{--cari}', "");
    Expect(0, 66256, '\p{^--cari}', "");
    Expect(0, 66256, '\P{--cari}', "");
    Expect(1, 66256, '\P{^--cari}', "");
    Expect(0, 66257, '\p{--cari}', "");
    Expect(1, 66257, '\p{^--cari}', "");
    Expect(1, 66257, '\P{--cari}', "");
    Expect(0, 66257, '\P{^--cari}', "");
    Error('\p{_Is_cari:=}');
    Error('\P{_Is_cari:=}');
    Expect(1, 66256, '\p{iscari}', "");
    Expect(0, 66256, '\p{^iscari}', "");
    Expect(0, 66256, '\P{iscari}', "");
    Expect(1, 66256, '\P{^iscari}', "");
    Expect(0, 66257, '\p{iscari}', "");
    Expect(1, 66257, '\p{^iscari}', "");
    Expect(1, 66257, '\P{iscari}', "");
    Expect(0, 66257, '\P{^iscari}', "");
    Expect(1, 66256, '\p{ Is_CARI}', "");
    Expect(0, 66256, '\p{^ Is_CARI}', "");
    Expect(0, 66256, '\P{ Is_CARI}', "");
    Expect(1, 66256, '\P{^ Is_CARI}', "");
    Expect(0, 66257, '\p{ Is_CARI}', "");
    Expect(1, 66257, '\p{^ Is_CARI}', "");
    Expect(1, 66257, '\P{ Is_CARI}', "");
    Expect(0, 66257, '\P{^ Is_CARI}', "");
    Error('\p{ :=Case_Ignorable}');
    Error('\P{ :=Case_Ignorable}');
    Expect(1, 917999, '\p{caseignorable}', "");
    Expect(0, 917999, '\p{^caseignorable}', "");
    Expect(0, 917999, '\P{caseignorable}', "");
    Expect(1, 917999, '\P{^caseignorable}', "");
    Expect(0, 918000, '\p{caseignorable}', "");
    Expect(1, 918000, '\p{^caseignorable}', "");
    Expect(1, 918000, '\P{caseignorable}', "");
    Expect(0, 918000, '\P{^caseignorable}', "");
    Expect(1, 917999, '\p{_ CASE_ignorable}', "");
    Expect(0, 917999, '\p{^_ CASE_ignorable}', "");
    Expect(0, 917999, '\P{_ CASE_ignorable}', "");
    Expect(1, 917999, '\P{^_ CASE_ignorable}', "");
    Expect(0, 918000, '\p{_ CASE_ignorable}', "");
    Expect(1, 918000, '\p{^_ CASE_ignorable}', "");
    Expect(1, 918000, '\P{_ CASE_ignorable}', "");
    Expect(0, 918000, '\P{^_ CASE_ignorable}', "");
    Error('\p{_is_CASE_ignorable:=}');
    Error('\P{_is_CASE_ignorable:=}');
    Expect(1, 917999, '\p{iscaseignorable}', "");
    Expect(0, 917999, '\p{^iscaseignorable}', "");
    Expect(0, 917999, '\P{iscaseignorable}', "");
    Expect(1, 917999, '\P{^iscaseignorable}', "");
    Expect(0, 918000, '\p{iscaseignorable}', "");
    Expect(1, 918000, '\p{^iscaseignorable}', "");
    Expect(1, 918000, '\P{iscaseignorable}', "");
    Expect(0, 918000, '\P{^iscaseignorable}', "");
    Expect(1, 917999, '\p{-_Is_CASE_Ignorable}', "");
    Expect(0, 917999, '\p{^-_Is_CASE_Ignorable}', "");
    Expect(0, 917999, '\P{-_Is_CASE_Ignorable}', "");
    Expect(1, 917999, '\P{^-_Is_CASE_Ignorable}', "");
    Expect(0, 918000, '\p{-_Is_CASE_Ignorable}', "");
    Expect(1, 918000, '\p{^-_Is_CASE_Ignorable}', "");
    Expect(1, 918000, '\P{-_Is_CASE_Ignorable}', "");
    Expect(0, 918000, '\P{^-_Is_CASE_Ignorable}', "");
    Error('\p{-	CI:=}');
    Error('\P{-	CI:=}');
    Expect(1, 917999, '\p{ci}', "");
    Expect(0, 917999, '\p{^ci}', "");
    Expect(0, 917999, '\P{ci}', "");
    Expect(1, 917999, '\P{^ci}', "");
    Expect(0, 918000, '\p{ci}', "");
    Expect(1, 918000, '\p{^ci}', "");
    Expect(1, 918000, '\P{ci}', "");
    Expect(0, 918000, '\P{^ci}', "");
    Expect(1, 917999, '\p{-	ci}', "");
    Expect(0, 917999, '\p{^-	ci}', "");
    Expect(0, 917999, '\P{-	ci}', "");
    Expect(1, 917999, '\P{^-	ci}', "");
    Expect(0, 918000, '\p{-	ci}', "");
    Expect(1, 918000, '\p{^-	ci}', "");
    Expect(1, 918000, '\P{-	ci}', "");
    Expect(0, 918000, '\P{^-	ci}', "");
    Error('\p{:=_ IS_CI}');
    Error('\P{:=_ IS_CI}');
    Expect(1, 917999, '\p{isci}', "");
    Expect(0, 917999, '\p{^isci}', "");
    Expect(0, 917999, '\P{isci}', "");
    Expect(1, 917999, '\P{^isci}', "");
    Expect(0, 918000, '\p{isci}', "");
    Expect(1, 918000, '\p{^isci}', "");
    Expect(1, 918000, '\P{isci}', "");
    Expect(0, 918000, '\P{^isci}', "");
    Expect(1, 917999, '\p{  is_CI}', "");
    Expect(0, 917999, '\p{^  is_CI}', "");
    Expect(0, 917999, '\P{  is_CI}', "");
    Expect(1, 917999, '\P{^  is_CI}', "");
    Expect(0, 918000, '\p{  is_CI}', "");
    Expect(1, 918000, '\p{^  is_CI}', "");
    Expect(1, 918000, '\P{  is_CI}', "");
    Expect(0, 918000, '\P{^  is_CI}', "");
    Error('\p{/a/ CASED}');
    Error('\P{/a/ CASED}');
    Expect(1, 127369, '\p{cased}', "");
    Expect(0, 127369, '\p{^cased}', "");
    Expect(0, 127369, '\P{cased}', "");
    Expect(1, 127369, '\P{^cased}', "");
    Expect(0, 127370, '\p{cased}', "");
    Expect(1, 127370, '\p{^cased}', "");
    Expect(1, 127370, '\P{cased}', "");
    Expect(0, 127370, '\P{^cased}', "");
    Expect(1, 127369, '\p{ -CASED}', "");
    Expect(0, 127369, '\p{^ -CASED}', "");
    Expect(0, 127369, '\P{ -CASED}', "");
    Expect(1, 127369, '\P{^ -CASED}', "");
    Expect(0, 127370, '\p{ -CASED}', "");
    Expect(1, 127370, '\p{^ -CASED}', "");
    Expect(1, 127370, '\P{ -CASED}', "");
    Expect(0, 127370, '\P{^ -CASED}', "");
    Error('\p{/a/ _is_Cased}');
    Error('\P{/a/ _is_Cased}');
    Expect(1, 127369, '\p{iscased}', "");
    Expect(0, 127369, '\p{^iscased}', "");
    Expect(0, 127369, '\P{iscased}', "");
    Expect(1, 127369, '\P{^iscased}', "");
    Expect(0, 127370, '\p{iscased}', "");
    Expect(1, 127370, '\p{^iscased}', "");
    Expect(1, 127370, '\P{iscased}', "");
    Expect(0, 127370, '\P{^iscased}', "");
    Expect(1, 127369, '\p{ Is_Cased}', "");
    Expect(0, 127369, '\p{^ Is_Cased}', "");
    Expect(0, 127369, '\P{ Is_Cased}', "");
    Expect(1, 127369, '\P{^ Is_Cased}', "");
    Expect(0, 127370, '\p{ Is_Cased}', "");
    Expect(1, 127370, '\p{^ Is_Cased}', "");
    Expect(1, 127370, '\P{ Is_Cased}', "");
    Expect(0, 127370, '\P{^ Is_Cased}', "");
    Error('\p{:= cased_letter}');
    Error('\P{:= cased_letter}');
    Expect(1, 125251, '\p{casedletter}', "");
    Expect(0, 125251, '\p{^casedletter}', "");
    Expect(0, 125251, '\P{casedletter}', "");
    Expect(1, 125251, '\P{^casedletter}', "");
    Expect(0, 125252, '\p{casedletter}', "");
    Expect(1, 125252, '\p{^casedletter}', "");
    Expect(1, 125252, '\P{casedletter}', "");
    Expect(0, 125252, '\P{^casedletter}', "");
    Expect(1, 125251, '\p{-cased_Letter}', "");
    Expect(0, 125251, '\p{^-cased_Letter}', "");
    Expect(0, 125251, '\P{-cased_Letter}', "");
    Expect(1, 125251, '\P{^-cased_Letter}', "");
    Expect(0, 125252, '\p{-cased_Letter}', "");
    Expect(1, 125252, '\p{^-cased_Letter}', "");
    Expect(1, 125252, '\P{-cased_Letter}', "");
    Expect(0, 125252, '\P{^-cased_Letter}', "");
    Error('\p{-	Is_CASED_LETTER:=}');
    Error('\P{-	Is_CASED_LETTER:=}');
    Expect(1, 125251, '\p{iscasedletter}', "");
    Expect(0, 125251, '\p{^iscasedletter}', "");
    Expect(0, 125251, '\P{iscasedletter}', "");
    Expect(1, 125251, '\P{^iscasedletter}', "");
    Expect(0, 125252, '\p{iscasedletter}', "");
    Expect(1, 125252, '\p{^iscasedletter}', "");
    Expect(1, 125252, '\P{iscasedletter}', "");
    Expect(0, 125252, '\P{^iscasedletter}', "");
    Expect(1, 125251, '\p{ is_CASED_Letter}', "");
    Expect(0, 125251, '\p{^ is_CASED_Letter}', "");
    Expect(0, 125251, '\P{ is_CASED_Letter}', "");
    Expect(1, 125251, '\P{^ is_CASED_Letter}', "");
    Expect(0, 125252, '\p{ is_CASED_Letter}', "");
    Expect(1, 125252, '\p{^ is_CASED_Letter}', "");
    Expect(1, 125252, '\P{ is_CASED_Letter}', "");
    Expect(0, 125252, '\P{^ is_CASED_Letter}', "");
    Error('\p{	lc:=}');
    Error('\P{	lc:=}');
    Expect(1, 125251, '\p{lc}', "");
    Expect(0, 125251, '\p{^lc}', "");
    Expect(0, 125251, '\P{lc}', "");
    Expect(1, 125251, '\P{^lc}', "");
    Expect(0, 125252, '\p{lc}', "");
    Expect(1, 125252, '\p{^lc}', "");
    Expect(1, 125252, '\P{lc}', "");
    Expect(0, 125252, '\P{^lc}', "");
    Expect(1, 125251, '\p{_	lc}', "");
    Expect(0, 125251, '\p{^_	lc}', "");
    Expect(0, 125251, '\P{_	lc}', "");
    Expect(1, 125251, '\P{^_	lc}', "");
    Expect(0, 125252, '\p{_	lc}', "");
    Expect(1, 125252, '\p{^_	lc}', "");
    Expect(1, 125252, '\P{_	lc}', "");
    Expect(0, 125252, '\P{^_	lc}', "");
    Error('\p{/a/is_LC}');
    Error('\P{/a/is_LC}');
    Expect(1, 125251, '\p{islc}', "");
    Expect(0, 125251, '\p{^islc}', "");
    Expect(0, 125251, '\P{islc}', "");
    Expect(1, 125251, '\P{^islc}', "");
    Expect(0, 125252, '\p{islc}', "");
    Expect(1, 125252, '\p{^islc}', "");
    Expect(1, 125252, '\P{islc}', "");
    Expect(0, 125252, '\P{^islc}', "");
    Expect(1, 125251, '\p{  Is_LC}', "");
    Expect(0, 125251, '\p{^  Is_LC}', "");
    Expect(0, 125251, '\P{  Is_LC}', "");
    Expect(1, 125251, '\P{^  Is_LC}', "");
    Expect(0, 125252, '\p{  Is_LC}', "");
    Expect(1, 125252, '\p{^  Is_LC}', "");
    Expect(1, 125252, '\P{  Is_LC}', "");
    Expect(0, 125252, '\P{^  Is_LC}', "");
    Error('\p{_ L_/a/}');
    Error('\P{_ L_/a/}');
    Expect(1, 125251, '\p{l_}', "");
    Expect(0, 125251, '\p{^l_}', "");
    Expect(0, 125251, '\P{l_}', "");
    Expect(1, 125251, '\P{^l_}', "");
    Expect(0, 125252, '\p{l_}', "");
    Expect(1, 125252, '\p{^l_}', "");
    Expect(1, 125252, '\P{l_}', "");
    Expect(0, 125252, '\P{^l_}', "");
    Expect(1, 125251, '\p{_-l_}', "");
    Expect(0, 125251, '\p{^_-l_}', "");
    Expect(0, 125251, '\P{_-l_}', "");
    Expect(1, 125251, '\P{^_-l_}', "");
    Expect(0, 125252, '\p{_-l_}', "");
    Expect(1, 125252, '\p{^_-l_}', "");
    Expect(1, 125252, '\P{_-l_}', "");
    Expect(0, 125252, '\P{^_-l_}', "");
    Error('\p{- Is_l_/a/}');
    Error('\P{- Is_l_/a/}');
    Expect(1, 125251, '\p{isl_}', "");
    Expect(0, 125251, '\p{^isl_}', "");
    Expect(0, 125251, '\P{isl_}', "");
    Expect(1, 125251, '\P{^isl_}', "");
    Expect(0, 125252, '\p{isl_}', "");
    Expect(1, 125252, '\p{^isl_}', "");
    Expect(1, 125252, '\P{isl_}', "");
    Expect(0, 125252, '\P{^isl_}', "");
    Expect(1, 125251, '\p{--IS_l_}', "");
    Expect(0, 125251, '\p{^--IS_l_}', "");
    Expect(0, 125251, '\P{--IS_l_}', "");
    Expect(1, 125251, '\P{^--IS_l_}', "");
    Expect(0, 125252, '\p{--IS_l_}', "");
    Expect(1, 125252, '\p{^--IS_l_}', "");
    Expect(1, 125252, '\P{--IS_l_}', "");
    Expect(0, 125252, '\P{^--IS_l_}', "");
    Error('\p{	 L&:=}');
    Error('\P{	 L&:=}');
    Expect(1, 125251, '\p{l&}', "");
    Expect(0, 125251, '\p{^l&}', "");
    Expect(0, 125251, '\P{l&}', "");
    Expect(1, 125251, '\P{^l&}', "");
    Expect(0, 125252, '\p{l&}', "");
    Expect(1, 125252, '\p{^l&}', "");
    Expect(1, 125252, '\P{l&}', "");
    Expect(0, 125252, '\P{^l&}', "");
    Expect(1, 125251, '\p{ 	L&}', "");
    Expect(0, 125251, '\p{^ 	L&}', "");
    Expect(0, 125251, '\P{ 	L&}', "");
    Expect(1, 125251, '\P{^ 	L&}', "");
    Expect(0, 125252, '\p{ 	L&}', "");
    Expect(1, 125252, '\p{^ 	L&}', "");
    Expect(1, 125252, '\P{ 	L&}', "");
    Expect(0, 125252, '\P{^ 	L&}', "");
    Error('\p{:=_-Is_L&}');
    Error('\P{:=_-Is_L&}');
    Expect(1, 125251, '\p{isl&}', "");
    Expect(0, 125251, '\p{^isl&}', "");
    Expect(0, 125251, '\P{isl&}', "");
    Expect(1, 125251, '\P{^isl&}', "");
    Expect(0, 125252, '\p{isl&}', "");
    Expect(1, 125252, '\p{^isl&}', "");
    Expect(1, 125252, '\P{isl&}', "");
    Expect(0, 125252, '\P{^isl&}', "");
    Expect(1, 125251, '\p{ -IS_l&}', "");
    Expect(0, 125251, '\p{^ -IS_l&}', "");
    Expect(0, 125251, '\P{ -IS_l&}', "");
    Expect(1, 125251, '\P{^ -IS_l&}', "");
    Expect(0, 125252, '\p{ -IS_l&}', "");
    Expect(1, 125252, '\p{^ -IS_l&}', "");
    Expect(1, 125252, '\P{ -IS_l&}', "");
    Expect(0, 125252, '\P{^ -IS_l&}', "");
    Error('\p{-caucasian_Albanian:=}');
    Error('\P{-caucasian_Albanian:=}');
    Expect(1, 66927, '\p{caucasianalbanian}', "");
    Expect(0, 66927, '\p{^caucasianalbanian}', "");
    Expect(0, 66927, '\P{caucasianalbanian}', "");
    Expect(1, 66927, '\P{^caucasianalbanian}', "");
    Expect(0, 66928, '\p{caucasianalbanian}', "");
    Expect(1, 66928, '\p{^caucasianalbanian}', "");
    Expect(1, 66928, '\P{caucasianalbanian}', "");
    Expect(0, 66928, '\P{^caucasianalbanian}', "");
    Expect(1, 66927, '\p{_ Caucasian_Albanian}', "");
    Expect(0, 66927, '\p{^_ Caucasian_Albanian}', "");
    Expect(0, 66927, '\P{_ Caucasian_Albanian}', "");
    Expect(1, 66927, '\P{^_ Caucasian_Albanian}', "");
    Expect(0, 66928, '\p{_ Caucasian_Albanian}', "");
    Expect(1, 66928, '\p{^_ Caucasian_Albanian}', "");
    Expect(1, 66928, '\P{_ Caucasian_Albanian}', "");
    Expect(0, 66928, '\P{^_ Caucasian_Albanian}', "");
    Error('\p{/a/- is_caucasian_Albanian}');
    Error('\P{/a/- is_caucasian_Albanian}');
    Expect(1, 66927, '\p{iscaucasianalbanian}', "");
    Expect(0, 66927, '\p{^iscaucasianalbanian}', "");
    Expect(0, 66927, '\P{iscaucasianalbanian}', "");
    Expect(1, 66927, '\P{^iscaucasianalbanian}', "");
    Expect(0, 66928, '\p{iscaucasianalbanian}', "");
    Expect(1, 66928, '\p{^iscaucasianalbanian}', "");
    Expect(1, 66928, '\P{iscaucasianalbanian}', "");
    Expect(0, 66928, '\P{^iscaucasianalbanian}', "");
    Expect(1, 66927, '\p{-is_CAUCASIAN_Albanian}', "");
    Expect(0, 66927, '\p{^-is_CAUCASIAN_Albanian}', "");
    Expect(0, 66927, '\P{-is_CAUCASIAN_Albanian}', "");
    Expect(1, 66927, '\P{^-is_CAUCASIAN_Albanian}', "");
    Expect(0, 66928, '\p{-is_CAUCASIAN_Albanian}', "");
    Expect(1, 66928, '\p{^-is_CAUCASIAN_Albanian}', "");
    Expect(1, 66928, '\P{-is_CAUCASIAN_Albanian}', "");
    Expect(0, 66928, '\P{^-is_CAUCASIAN_Albanian}', "");
    Error('\p{_Aghb:=}');
    Error('\P{_Aghb:=}');
    Expect(1, 66927, '\p{aghb}', "");
    Expect(0, 66927, '\p{^aghb}', "");
    Expect(0, 66927, '\P{aghb}', "");
    Expect(1, 66927, '\P{^aghb}', "");
    Expect(0, 66928, '\p{aghb}', "");
    Expect(1, 66928, '\p{^aghb}', "");
    Expect(1, 66928, '\P{aghb}', "");
    Expect(0, 66928, '\P{^aghb}', "");
    Expect(1, 66927, '\p{-aghb}', "");
    Expect(0, 66927, '\p{^-aghb}', "");
    Expect(0, 66927, '\P{-aghb}', "");
    Expect(1, 66927, '\P{^-aghb}', "");
    Expect(0, 66928, '\p{-aghb}', "");
    Expect(1, 66928, '\p{^-aghb}', "");
    Expect(1, 66928, '\P{-aghb}', "");
    Expect(0, 66928, '\P{^-aghb}', "");
    Error('\p{/a/--IS_AGHB}');
    Error('\P{/a/--IS_AGHB}');
    Expect(1, 66927, '\p{isaghb}', "");
    Expect(0, 66927, '\p{^isaghb}', "");
    Expect(0, 66927, '\P{isaghb}', "");
    Expect(1, 66927, '\P{^isaghb}', "");
    Expect(0, 66928, '\p{isaghb}', "");
    Expect(1, 66928, '\p{^isaghb}', "");
    Expect(1, 66928, '\P{isaghb}', "");
    Expect(0, 66928, '\P{^isaghb}', "");
    Expect(1, 66927, '\p{_Is_AGHB}', "");
    Expect(0, 66927, '\p{^_Is_AGHB}', "");
    Expect(0, 66927, '\P{_Is_AGHB}', "");
    Expect(1, 66927, '\P{^_Is_AGHB}', "");
    Expect(0, 66928, '\p{_Is_AGHB}', "");
    Expect(1, 66928, '\p{^_Is_AGHB}', "");
    Expect(1, 66928, '\P{_Is_AGHB}', "");
    Expect(0, 66928, '\P{^_Is_AGHB}', "");
    Error('\p{:=__chakma}');
    Error('\P{:=__chakma}');
    Expect(1, 69959, '\p{chakma}', "");
    Expect(0, 69959, '\p{^chakma}', "");
    Expect(0, 69959, '\P{chakma}', "");
    Expect(1, 69959, '\P{^chakma}', "");
    Expect(0, 69960, '\p{chakma}', "");
    Expect(1, 69960, '\p{^chakma}', "");
    Expect(1, 69960, '\P{chakma}', "");
    Expect(0, 69960, '\P{^chakma}', "");
    Expect(1, 69959, '\p{ 	Chakma}', "");
    Expect(0, 69959, '\p{^ 	Chakma}', "");
    Expect(0, 69959, '\P{ 	Chakma}', "");
    Expect(1, 69959, '\P{^ 	Chakma}', "");
    Expect(0, 69960, '\p{ 	Chakma}', "");
    Expect(1, 69960, '\p{^ 	Chakma}', "");
    Expect(1, 69960, '\P{ 	Chakma}', "");
    Expect(0, 69960, '\P{^ 	Chakma}', "");
    Error('\p{- is_Chakma/a/}');
    Error('\P{- is_Chakma/a/}');
    Expect(1, 69959, '\p{ischakma}', "");
    Expect(0, 69959, '\p{^ischakma}', "");
    Expect(0, 69959, '\P{ischakma}', "");
    Expect(1, 69959, '\P{^ischakma}', "");
    Expect(0, 69960, '\p{ischakma}', "");
    Expect(1, 69960, '\p{^ischakma}', "");
    Expect(1, 69960, '\P{ischakma}', "");
    Expect(0, 69960, '\P{^ischakma}', "");
    Expect(1, 69959, '\p{ 	Is_Chakma}', "");
    Expect(0, 69959, '\p{^ 	Is_Chakma}', "");
    Expect(0, 69959, '\P{ 	Is_Chakma}', "");
    Expect(1, 69959, '\P{^ 	Is_Chakma}', "");
    Expect(0, 69960, '\p{ 	Is_Chakma}', "");
    Expect(1, 69960, '\p{^ 	Is_Chakma}', "");
    Expect(1, 69960, '\P{ 	Is_Chakma}', "");
    Expect(0, 69960, '\P{^ 	Is_Chakma}', "");
    Error('\p{/a/--cakm}');
    Error('\P{/a/--cakm}');
    Expect(1, 69959, '\p{cakm}', "");
    Expect(0, 69959, '\p{^cakm}', "");
    Expect(0, 69959, '\P{cakm}', "");
    Expect(1, 69959, '\P{^cakm}', "");
    Expect(0, 69960, '\p{cakm}', "");
    Expect(1, 69960, '\p{^cakm}', "");
    Expect(1, 69960, '\P{cakm}', "");
    Expect(0, 69960, '\P{^cakm}', "");
    Expect(1, 69959, '\p{	Cakm}', "");
    Expect(0, 69959, '\p{^	Cakm}', "");
    Expect(0, 69959, '\P{	Cakm}', "");
    Expect(1, 69959, '\P{^	Cakm}', "");
    Expect(0, 69960, '\p{	Cakm}', "");
    Expect(1, 69960, '\p{^	Cakm}', "");
    Expect(1, 69960, '\P{	Cakm}', "");
    Expect(0, 69960, '\P{^	Cakm}', "");
    Error('\p{-/a/Is_Cakm}');
    Error('\P{-/a/Is_Cakm}');
    Expect(1, 69959, '\p{iscakm}', "");
    Expect(0, 69959, '\p{^iscakm}', "");
    Expect(0, 69959, '\P{iscakm}', "");
    Expect(1, 69959, '\P{^iscakm}', "");
    Expect(0, 69960, '\p{iscakm}', "");
    Expect(1, 69960, '\p{^iscakm}', "");
    Expect(1, 69960, '\P{iscakm}', "");
    Expect(0, 69960, '\P{^iscakm}', "");
    Expect(1, 69959, '\p{  Is_cakm}', "");
    Expect(0, 69959, '\p{^  Is_cakm}', "");
    Expect(0, 69959, '\P{  Is_cakm}', "");
    Expect(1, 69959, '\P{^  Is_cakm}', "");
    Expect(0, 69960, '\p{  Is_cakm}', "");
    Expect(1, 69960, '\p{^  Is_cakm}', "");
    Expect(1, 69960, '\P{  Is_cakm}', "");
    Expect(0, 69960, '\P{^  Is_cakm}', "");
    Error('\p{ Cham/a/}');
    Error('\P{ Cham/a/}');
    Expect(1, 43615, '\p{cham}', "");
    Expect(0, 43615, '\p{^cham}', "");
    Expect(0, 43615, '\P{cham}', "");
    Expect(1, 43615, '\P{^cham}', "");
    Expect(0, 43616, '\p{cham}', "");
    Expect(1, 43616, '\p{^cham}', "");
    Expect(1, 43616, '\P{cham}', "");
    Expect(0, 43616, '\P{^cham}', "");
    Expect(1, 43615, '\p{  Cham}', "");
    Expect(0, 43615, '\p{^  Cham}', "");
    Expect(0, 43615, '\P{  Cham}', "");
    Expect(1, 43615, '\P{^  Cham}', "");
    Expect(0, 43616, '\p{  Cham}', "");
    Expect(1, 43616, '\p{^  Cham}', "");
    Expect(1, 43616, '\P{  Cham}', "");
    Expect(0, 43616, '\P{^  Cham}', "");
    Error('\p{-Is_cham:=}');
    Error('\P{-Is_cham:=}');
    Expect(1, 43615, '\p{ischam}', "");
    Expect(0, 43615, '\p{^ischam}', "");
    Expect(0, 43615, '\P{ischam}', "");
    Expect(1, 43615, '\P{^ischam}', "");
    Expect(0, 43616, '\p{ischam}', "");
    Expect(1, 43616, '\p{^ischam}', "");
    Expect(1, 43616, '\P{ischam}', "");
    Expect(0, 43616, '\P{^ischam}', "");
    Expect(1, 43615, '\p{_is_CHAM}', "");
    Expect(0, 43615, '\p{^_is_CHAM}', "");
    Expect(0, 43615, '\P{_is_CHAM}', "");
    Expect(1, 43615, '\P{^_is_CHAM}', "");
    Expect(0, 43616, '\p{_is_CHAM}', "");
    Expect(1, 43616, '\p{^_is_CHAM}', "");
    Expect(1, 43616, '\P{_is_CHAM}', "");
    Expect(0, 43616, '\P{^_is_CHAM}', "");
    Error('\p{:= 	CHANGES_When_Casefolded}');
    Error('\P{:= 	CHANGES_When_Casefolded}');
    Expect(1, 125217, '\p{changeswhencasefolded}', "");
    Expect(0, 125217, '\p{^changeswhencasefolded}', "");
    Expect(0, 125217, '\P{changeswhencasefolded}', "");
    Expect(1, 125217, '\P{^changeswhencasefolded}', "");
    Expect(0, 125218, '\p{changeswhencasefolded}', "");
    Expect(1, 125218, '\p{^changeswhencasefolded}', "");
    Expect(1, 125218, '\P{changeswhencasefolded}', "");
    Expect(0, 125218, '\P{^changeswhencasefolded}', "");
    Expect(1, 125217, '\p{- CHANGES_When_casefolded}', "");
    Expect(0, 125217, '\p{^- CHANGES_When_casefolded}', "");
    Expect(0, 125217, '\P{- CHANGES_When_casefolded}', "");
    Expect(1, 125217, '\P{^- CHANGES_When_casefolded}', "");
    Expect(0, 125218, '\p{- CHANGES_When_casefolded}', "");
    Expect(1, 125218, '\p{^- CHANGES_When_casefolded}', "");
    Expect(1, 125218, '\P{- CHANGES_When_casefolded}', "");
    Expect(0, 125218, '\P{^- CHANGES_When_casefolded}', "");
    Error('\p{--Is_Changes_when_CASEFOLDED:=}');
    Error('\P{--Is_Changes_when_CASEFOLDED:=}');
    Expect(1, 125217, '\p{ischangeswhencasefolded}', "");
    Expect(0, 125217, '\p{^ischangeswhencasefolded}', "");
    Expect(0, 125217, '\P{ischangeswhencasefolded}', "");
    Expect(1, 125217, '\P{^ischangeswhencasefolded}', "");
    Expect(0, 125218, '\p{ischangeswhencasefolded}', "");
    Expect(1, 125218, '\p{^ischangeswhencasefolded}', "");
    Expect(1, 125218, '\P{ischangeswhencasefolded}', "");
    Expect(0, 125218, '\P{^ischangeswhencasefolded}', "");
    Expect(1, 125217, '\p{ Is_CHANGES_when_casefolded}', "");
    Expect(0, 125217, '\p{^ Is_CHANGES_when_casefolded}', "");
    Expect(0, 125217, '\P{ Is_CHANGES_when_casefolded}', "");
    Expect(1, 125217, '\P{^ Is_CHANGES_when_casefolded}', "");
    Expect(0, 125218, '\p{ Is_CHANGES_when_casefolded}', "");
    Expect(1, 125218, '\p{^ Is_CHANGES_when_casefolded}', "");
    Expect(1, 125218, '\P{ Is_CHANGES_when_casefolded}', "");
    Expect(0, 125218, '\P{^ Is_CHANGES_when_casefolded}', "");
    Error('\p{/a/CWCF}');
    Error('\P{/a/CWCF}');
    Expect(1, 125217, '\p{cwcf}', "");
    Expect(0, 125217, '\p{^cwcf}', "");
    Expect(0, 125217, '\P{cwcf}', "");
    Expect(1, 125217, '\P{^cwcf}', "");
    Expect(0, 125218, '\p{cwcf}', "");
    Expect(1, 125218, '\p{^cwcf}', "");
    Expect(1, 125218, '\P{cwcf}', "");
    Expect(0, 125218, '\P{^cwcf}', "");
    Expect(1, 125217, '\p{ CWCF}', "");
    Expect(0, 125217, '\p{^ CWCF}', "");
    Expect(0, 125217, '\P{ CWCF}', "");
    Expect(1, 125217, '\P{^ CWCF}', "");
    Expect(0, 125218, '\p{ CWCF}', "");
    Expect(1, 125218, '\p{^ CWCF}', "");
    Expect(1, 125218, '\P{ CWCF}', "");
    Expect(0, 125218, '\P{^ CWCF}', "");
    Error('\p{_	Is_CWCF/a/}');
    Error('\P{_	Is_CWCF/a/}');
    Expect(1, 125217, '\p{iscwcf}', "");
    Expect(0, 125217, '\p{^iscwcf}', "");
    Expect(0, 125217, '\P{iscwcf}', "");
    Expect(1, 125217, '\P{^iscwcf}', "");
    Expect(0, 125218, '\p{iscwcf}', "");
    Expect(1, 125218, '\p{^iscwcf}', "");
    Expect(1, 125218, '\P{iscwcf}', "");
    Expect(0, 125218, '\P{^iscwcf}', "");
    Expect(1, 125217, '\p{__Is_CWCF}', "");
    Expect(0, 125217, '\p{^__Is_CWCF}', "");
    Expect(0, 125217, '\P{__Is_CWCF}', "");
    Expect(1, 125217, '\P{^__Is_CWCF}', "");
    Expect(0, 125218, '\p{__Is_CWCF}', "");
    Expect(1, 125218, '\p{^__Is_CWCF}', "");
    Expect(1, 125218, '\P{__Is_CWCF}', "");
    Expect(0, 125218, '\P{^__Is_CWCF}', "");
    Error('\p{	:=Changes_WHEN_Casemapped}');
    Error('\P{	:=Changes_WHEN_Casemapped}');
    Expect(1, 125251, '\p{changeswhencasemapped}', "");
    Expect(0, 125251, '\p{^changeswhencasemapped}', "");
    Expect(0, 125251, '\P{changeswhencasemapped}', "");
    Expect(1, 125251, '\P{^changeswhencasemapped}', "");
    Expect(0, 125252, '\p{changeswhencasemapped}', "");
    Expect(1, 125252, '\p{^changeswhencasemapped}', "");
    Expect(1, 125252, '\P{changeswhencasemapped}', "");
    Expect(0, 125252, '\P{^changeswhencasemapped}', "");
    Expect(1, 125251, '\p{	Changes_when_casemapped}', "");
    Expect(0, 125251, '\p{^	Changes_when_casemapped}', "");
    Expect(0, 125251, '\P{	Changes_when_casemapped}', "");
    Expect(1, 125251, '\P{^	Changes_when_casemapped}', "");
    Expect(0, 125252, '\p{	Changes_when_casemapped}', "");
    Expect(1, 125252, '\p{^	Changes_when_casemapped}', "");
    Expect(1, 125252, '\P{	Changes_when_casemapped}', "");
    Expect(0, 125252, '\P{^	Changes_when_casemapped}', "");
    Error('\p{/a/_-Is_CHANGES_WHEN_Casemapped}');
    Error('\P{/a/_-Is_CHANGES_WHEN_Casemapped}');
    Expect(1, 125251, '\p{ischangeswhencasemapped}', "");
    Expect(0, 125251, '\p{^ischangeswhencasemapped}', "");
    Expect(0, 125251, '\P{ischangeswhencasemapped}', "");
    Expect(1, 125251, '\P{^ischangeswhencasemapped}', "");
    Expect(0, 125252, '\p{ischangeswhencasemapped}', "");
    Expect(1, 125252, '\p{^ischangeswhencasemapped}', "");
    Expect(1, 125252, '\P{ischangeswhencasemapped}', "");
    Expect(0, 125252, '\P{^ischangeswhencasemapped}', "");
    Expect(1, 125251, '\p{  Is_Changes_WHEN_casemapped}', "");
    Expect(0, 125251, '\p{^  Is_Changes_WHEN_casemapped}', "");
    Expect(0, 125251, '\P{  Is_Changes_WHEN_casemapped}', "");
    Expect(1, 125251, '\P{^  Is_Changes_WHEN_casemapped}', "");
    Expect(0, 125252, '\p{  Is_Changes_WHEN_casemapped}', "");
    Expect(1, 125252, '\p{^  Is_Changes_WHEN_casemapped}', "");
    Expect(1, 125252, '\P{  Is_Changes_WHEN_casemapped}', "");
    Expect(0, 125252, '\P{^  Is_Changes_WHEN_casemapped}', "");
    Error('\p{-/a/CWCM}');
    Error('\P{-/a/CWCM}');
    Expect(1, 125251, '\p{cwcm}', "");
    Expect(0, 125251, '\p{^cwcm}', "");
    Expect(0, 125251, '\P{cwcm}', "");
    Expect(1, 125251, '\P{^cwcm}', "");
    Expect(0, 125252, '\p{cwcm}', "");
    Expect(1, 125252, '\p{^cwcm}', "");
    Expect(1, 125252, '\P{cwcm}', "");
    Expect(0, 125252, '\P{^cwcm}', "");
    Expect(1, 125251, '\p{CWCM}', "");
    Expect(0, 125251, '\p{^CWCM}', "");
    Expect(0, 125251, '\P{CWCM}', "");
    Expect(1, 125251, '\P{^CWCM}', "");
    Expect(0, 125252, '\p{CWCM}', "");
    Expect(1, 125252, '\p{^CWCM}', "");
    Expect(1, 125252, '\P{CWCM}', "");
    Expect(0, 125252, '\P{^CWCM}', "");
    Error('\p{-	IS_CWCM/a/}');
    Error('\P{-	IS_CWCM/a/}');
    Expect(1, 125251, '\p{iscwcm}', "");
    Expect(0, 125251, '\p{^iscwcm}', "");
    Expect(0, 125251, '\P{iscwcm}', "");
    Expect(1, 125251, '\P{^iscwcm}', "");
    Expect(0, 125252, '\p{iscwcm}', "");
    Expect(1, 125252, '\p{^iscwcm}', "");
    Expect(1, 125252, '\P{iscwcm}', "");
    Expect(0, 125252, '\P{^iscwcm}', "");
    Expect(1, 125251, '\p{	_Is_CWCM}', "");
    Expect(0, 125251, '\p{^	_Is_CWCM}', "");
    Expect(0, 125251, '\P{	_Is_CWCM}', "");
    Expect(1, 125251, '\P{^	_Is_CWCM}', "");
    Expect(0, 125252, '\p{	_Is_CWCM}', "");
    Expect(1, 125252, '\p{^	_Is_CWCM}', "");
    Expect(1, 125252, '\P{	_Is_CWCM}', "");
    Expect(0, 125252, '\P{^	_Is_CWCM}', "");
    Error('\p{/a/-CHANGES_When_Lowercased}');
    Error('\P{/a/-CHANGES_When_Lowercased}');
    Expect(1, 125217, '\p{changeswhenlowercased}', "");
    Expect(0, 125217, '\p{^changeswhenlowercased}', "");
    Expect(0, 125217, '\P{changeswhenlowercased}', "");
    Expect(1, 125217, '\P{^changeswhenlowercased}', "");
    Expect(0, 125218, '\p{changeswhenlowercased}', "");
    Expect(1, 125218, '\p{^changeswhenlowercased}', "");
    Expect(1, 125218, '\P{changeswhenlowercased}', "");
    Expect(0, 125218, '\P{^changeswhenlowercased}', "");
    Expect(1, 125217, '\p{__Changes_WHEN_lowercased}', "");
    Expect(0, 125217, '\p{^__Changes_WHEN_lowercased}', "");
    Expect(0, 125217, '\P{__Changes_WHEN_lowercased}', "");
    Expect(1, 125217, '\P{^__Changes_WHEN_lowercased}', "");
    Expect(0, 125218, '\p{__Changes_WHEN_lowercased}', "");
    Expect(1, 125218, '\p{^__Changes_WHEN_lowercased}', "");
    Expect(1, 125218, '\P{__Changes_WHEN_lowercased}', "");
    Expect(0, 125218, '\P{^__Changes_WHEN_lowercased}', "");
    Error('\p{/a/-_Is_Changes_When_lowercased}');
    Error('\P{/a/-_Is_Changes_When_lowercased}');
    Expect(1, 125217, '\p{ischangeswhenlowercased}', "");
    Expect(0, 125217, '\p{^ischangeswhenlowercased}', "");
    Expect(0, 125217, '\P{ischangeswhenlowercased}', "");
    Expect(1, 125217, '\P{^ischangeswhenlowercased}', "");
    Expect(0, 125218, '\p{ischangeswhenlowercased}', "");
    Expect(1, 125218, '\p{^ischangeswhenlowercased}', "");
    Expect(1, 125218, '\P{ischangeswhenlowercased}', "");
    Expect(0, 125218, '\P{^ischangeswhenlowercased}', "");
    Expect(1, 125217, '\p{- IS_Changes_when_Lowercased}', "");
    Expect(0, 125217, '\p{^- IS_Changes_when_Lowercased}', "");
    Expect(0, 125217, '\P{- IS_Changes_when_Lowercased}', "");
    Expect(1, 125217, '\P{^- IS_Changes_when_Lowercased}', "");
    Expect(0, 125218, '\p{- IS_Changes_when_Lowercased}', "");
    Expect(1, 125218, '\p{^- IS_Changes_when_Lowercased}', "");
    Expect(1, 125218, '\P{- IS_Changes_when_Lowercased}', "");
    Expect(0, 125218, '\P{^- IS_Changes_when_Lowercased}', "");
    Error('\p{/a/__cwl}');
    Error('\P{/a/__cwl}');
    Expect(1, 125217, '\p{cwl}', "");
    Expect(0, 125217, '\p{^cwl}', "");
    Expect(0, 125217, '\P{cwl}', "");
    Expect(1, 125217, '\P{^cwl}', "");
    Expect(0, 125218, '\p{cwl}', "");
    Expect(1, 125218, '\p{^cwl}', "");
    Expect(1, 125218, '\P{cwl}', "");
    Expect(0, 125218, '\P{^cwl}', "");
    Expect(1, 125217, '\p{-_CWL}', "");
    Expect(0, 125217, '\p{^-_CWL}', "");
    Expect(0, 125217, '\P{-_CWL}', "");
    Expect(1, 125217, '\P{^-_CWL}', "");
    Expect(0, 125218, '\p{-_CWL}', "");
    Expect(1, 125218, '\p{^-_CWL}', "");
    Expect(1, 125218, '\P{-_CWL}', "");
    Expect(0, 125218, '\P{^-_CWL}', "");
    Error('\p{/a/ _is_cwl}');
    Error('\P{/a/ _is_cwl}');
    Expect(1, 125217, '\p{iscwl}', "");
    Expect(0, 125217, '\p{^iscwl}', "");
    Expect(0, 125217, '\P{iscwl}', "");
    Expect(1, 125217, '\P{^iscwl}', "");
    Expect(0, 125218, '\p{iscwl}', "");
    Expect(1, 125218, '\p{^iscwl}', "");
    Expect(1, 125218, '\P{iscwl}', "");
    Expect(0, 125218, '\P{^iscwl}', "");
    Expect(1, 125217, '\p{-is_CWL}', "");
    Expect(0, 125217, '\p{^-is_CWL}', "");
    Expect(0, 125217, '\P{-is_CWL}', "");
    Expect(1, 125217, '\P{^-is_CWL}', "");
    Expect(0, 125218, '\p{-is_CWL}', "");
    Expect(1, 125218, '\p{^-is_CWL}', "");
    Expect(1, 125218, '\P{-is_CWL}', "");
    Expect(0, 125218, '\P{^-is_CWL}', "");
    Error('\p{/a/ -Changes_When_nfkc_Casefolded}');
    Error('\P{/a/ -Changes_When_nfkc_Casefolded}');
    Expect(1, 921599, '\p{changeswhennfkccasefolded}', "");
    Expect(0, 921599, '\p{^changeswhennfkccasefolded}', "");
    Expect(0, 921599, '\P{changeswhennfkccasefolded}', "");
    Expect(1, 921599, '\P{^changeswhennfkccasefolded}', "");
    Expect(0, 921600, '\p{changeswhennfkccasefolded}', "");
    Expect(1, 921600, '\p{^changeswhennfkccasefolded}', "");
    Expect(1, 921600, '\P{changeswhennfkccasefolded}', "");
    Expect(0, 921600, '\P{^changeswhennfkccasefolded}', "");
    Expect(1, 921599, '\p{-changes_WHEN_nfkc_Casefolded}', "");
    Expect(0, 921599, '\p{^-changes_WHEN_nfkc_Casefolded}', "");
    Expect(0, 921599, '\P{-changes_WHEN_nfkc_Casefolded}', "");
    Expect(1, 921599, '\P{^-changes_WHEN_nfkc_Casefolded}', "");
    Expect(0, 921600, '\p{-changes_WHEN_nfkc_Casefolded}', "");
    Expect(1, 921600, '\p{^-changes_WHEN_nfkc_Casefolded}', "");
    Expect(1, 921600, '\P{-changes_WHEN_nfkc_Casefolded}', "");
    Expect(0, 921600, '\P{^-changes_WHEN_nfkc_Casefolded}', "");
    Error('\p{_/a/Is_Changes_when_NFKC_Casefolded}');
    Error('\P{_/a/Is_Changes_when_NFKC_Casefolded}');
    Expect(1, 921599, '\p{ischangeswhennfkccasefolded}', "");
    Expect(0, 921599, '\p{^ischangeswhennfkccasefolded}', "");
    Expect(0, 921599, '\P{ischangeswhennfkccasefolded}', "");
    Expect(1, 921599, '\P{^ischangeswhennfkccasefolded}', "");
    Expect(0, 921600, '\p{ischangeswhennfkccasefolded}', "");
    Expect(1, 921600, '\p{^ischangeswhennfkccasefolded}', "");
    Expect(1, 921600, '\P{ischangeswhennfkccasefolded}', "");
    Expect(0, 921600, '\P{^ischangeswhennfkccasefolded}', "");
    Expect(1, 921599, '\p{ 	IS_Changes_When_NFKC_Casefolded}', "");
    Expect(0, 921599, '\p{^ 	IS_Changes_When_NFKC_Casefolded}', "");
    Expect(0, 921599, '\P{ 	IS_Changes_When_NFKC_Casefolded}', "");
    Expect(1, 921599, '\P{^ 	IS_Changes_When_NFKC_Casefolded}', "");
    Expect(0, 921600, '\p{ 	IS_Changes_When_NFKC_Casefolded}', "");
    Expect(1, 921600, '\p{^ 	IS_Changes_When_NFKC_Casefolded}', "");
    Expect(1, 921600, '\P{ 	IS_Changes_When_NFKC_Casefolded}', "");
    Expect(0, 921600, '\P{^ 	IS_Changes_When_NFKC_Casefolded}', "");
    Error('\p{	 CWKCF/a/}');
    Error('\P{	 CWKCF/a/}');
    Expect(1, 921599, '\p{cwkcf}', "");
    Expect(0, 921599, '\p{^cwkcf}', "");
    Expect(0, 921599, '\P{cwkcf}', "");
    Expect(1, 921599, '\P{^cwkcf}', "");
    Expect(0, 921600, '\p{cwkcf}', "");
    Expect(1, 921600, '\p{^cwkcf}', "");
    Expect(1, 921600, '\P{cwkcf}', "");
    Expect(0, 921600, '\P{^cwkcf}', "");
    Expect(1, 921599, '\p{ -CWKCF}', "");
    Expect(0, 921599, '\p{^ -CWKCF}', "");
    Expect(0, 921599, '\P{ -CWKCF}', "");
    Expect(1, 921599, '\P{^ -CWKCF}', "");
    Expect(0, 921600, '\p{ -CWKCF}', "");
    Expect(1, 921600, '\p{^ -CWKCF}', "");
    Expect(1, 921600, '\P{ -CWKCF}', "");
    Expect(0, 921600, '\P{^ -CWKCF}', "");
    Error('\p{/a/ IS_cwkcf}');
    Error('\P{/a/ IS_cwkcf}');
    Expect(1, 921599, '\p{iscwkcf}', "");
    Expect(0, 921599, '\p{^iscwkcf}', "");
    Expect(0, 921599, '\P{iscwkcf}', "");
    Expect(1, 921599, '\P{^iscwkcf}', "");
    Expect(0, 921600, '\p{iscwkcf}', "");
    Expect(1, 921600, '\p{^iscwkcf}', "");
    Expect(1, 921600, '\P{iscwkcf}', "");
    Expect(0, 921600, '\P{^iscwkcf}', "");
    Expect(1, 921599, '\p{  Is_CWKCF}', "");
    Expect(0, 921599, '\p{^  Is_CWKCF}', "");
    Expect(0, 921599, '\P{  Is_CWKCF}', "");
    Expect(1, 921599, '\P{^  Is_CWKCF}', "");
    Expect(0, 921600, '\p{  Is_CWKCF}', "");
    Expect(1, 921600, '\p{^  Is_CWKCF}', "");
    Expect(1, 921600, '\P{  Is_CWKCF}', "");
    Expect(0, 921600, '\P{^  Is_CWKCF}', "");
    Error('\p{/a/_CHANGES_When_titlecased}');
    Error('\P{/a/_CHANGES_When_titlecased}');
    Expect(1, 125251, '\p{changeswhentitlecased}', "");
    Expect(0, 125251, '\p{^changeswhentitlecased}', "");
    Expect(0, 125251, '\P{changeswhentitlecased}', "");
    Expect(1, 125251, '\P{^changeswhentitlecased}', "");
    Expect(0, 125252, '\p{changeswhentitlecased}', "");
    Expect(1, 125252, '\p{^changeswhentitlecased}', "");
    Expect(1, 125252, '\P{changeswhentitlecased}', "");
    Expect(0, 125252, '\P{^changeswhentitlecased}', "");
    Expect(1, 125251, '\p{_	changes_WHEN_titlecased}', "");
    Expect(0, 125251, '\p{^_	changes_WHEN_titlecased}', "");
    Expect(0, 125251, '\P{_	changes_WHEN_titlecased}', "");
    Expect(1, 125251, '\P{^_	changes_WHEN_titlecased}', "");
    Expect(0, 125252, '\p{_	changes_WHEN_titlecased}', "");
    Expect(1, 125252, '\p{^_	changes_WHEN_titlecased}', "");
    Expect(1, 125252, '\P{_	changes_WHEN_titlecased}', "");
    Expect(0, 125252, '\P{^_	changes_WHEN_titlecased}', "");
    Error('\p{:= 	Is_CHANGES_When_TITLECASED}');
    Error('\P{:= 	Is_CHANGES_When_TITLECASED}');
    Expect(1, 125251, '\p{ischangeswhentitlecased}', "");
    Expect(0, 125251, '\p{^ischangeswhentitlecased}', "");
    Expect(0, 125251, '\P{ischangeswhentitlecased}', "");
    Expect(1, 125251, '\P{^ischangeswhentitlecased}', "");
    Expect(0, 125252, '\p{ischangeswhentitlecased}', "");
    Expect(1, 125252, '\p{^ischangeswhentitlecased}', "");
    Expect(1, 125252, '\P{ischangeswhentitlecased}', "");
    Expect(0, 125252, '\P{^ischangeswhentitlecased}', "");
    Expect(1, 125251, '\p{-is_Changes_When_titlecased}', "");
    Expect(0, 125251, '\p{^-is_Changes_When_titlecased}', "");
    Expect(0, 125251, '\P{-is_Changes_When_titlecased}', "");
    Expect(1, 125251, '\P{^-is_Changes_When_titlecased}', "");
    Expect(0, 125252, '\p{-is_Changes_When_titlecased}', "");
    Expect(1, 125252, '\p{^-is_Changes_When_titlecased}', "");
    Expect(1, 125252, '\P{-is_Changes_When_titlecased}', "");
    Expect(0, 125252, '\P{^-is_Changes_When_titlecased}', "");
    Error('\p{--cwt:=}');
    Error('\P{--cwt:=}');
    Expect(1, 125251, '\p{cwt}', "");
    Expect(0, 125251, '\p{^cwt}', "");
    Expect(0, 125251, '\P{cwt}', "");
    Expect(1, 125251, '\P{^cwt}', "");
    Expect(0, 125252, '\p{cwt}', "");
    Expect(1, 125252, '\p{^cwt}', "");
    Expect(1, 125252, '\P{cwt}', "");
    Expect(0, 125252, '\P{^cwt}', "");
    Expect(1, 125251, '\p{_CWT}', "");
    Expect(0, 125251, '\p{^_CWT}', "");
    Expect(0, 125251, '\P{_CWT}', "");
    Expect(1, 125251, '\P{^_CWT}', "");
    Expect(0, 125252, '\p{_CWT}', "");
    Expect(1, 125252, '\p{^_CWT}', "");
    Expect(1, 125252, '\P{_CWT}', "");
    Expect(0, 125252, '\P{^_CWT}', "");
    Error('\p{/a/ _Is_cwt}');
    Error('\P{/a/ _Is_cwt}');
    Expect(1, 125251, '\p{iscwt}', "");
    Expect(0, 125251, '\p{^iscwt}', "");
    Expect(0, 125251, '\P{iscwt}', "");
    Expect(1, 125251, '\P{^iscwt}', "");
    Expect(0, 125252, '\p{iscwt}', "");
    Expect(1, 125252, '\p{^iscwt}', "");
    Expect(1, 125252, '\P{iscwt}', "");
    Expect(0, 125252, '\P{^iscwt}', "");
    Expect(1, 125251, '\p{		Is_cwt}', "");
    Expect(0, 125251, '\p{^		Is_cwt}', "");
    Expect(0, 125251, '\P{		Is_cwt}', "");
    Expect(1, 125251, '\P{^		Is_cwt}', "");
    Expect(0, 125252, '\p{		Is_cwt}', "");
    Expect(1, 125252, '\p{^		Is_cwt}', "");
    Expect(1, 125252, '\P{		Is_cwt}', "");
    Expect(0, 125252, '\P{^		Is_cwt}', "");
    Error('\p{:=-	Changes_When_Uppercased}');
    Error('\P{:=-	Changes_When_Uppercased}');
    Expect(1, 125251, '\p{changeswhenuppercased}', "");
    Expect(0, 125251, '\p{^changeswhenuppercased}', "");
    Expect(0, 125251, '\P{changeswhenuppercased}', "");
    Expect(1, 125251, '\P{^changeswhenuppercased}', "");
    Expect(0, 125252, '\p{changeswhenuppercased}', "");
    Expect(1, 125252, '\p{^changeswhenuppercased}', "");
    Expect(1, 125252, '\P{changeswhenuppercased}', "");
    Expect(0, 125252, '\P{^changeswhenuppercased}', "");
    Expect(1, 125251, '\p{-	Changes_When_Uppercased}', "");
    Expect(0, 125251, '\p{^-	Changes_When_Uppercased}', "");
    Expect(0, 125251, '\P{-	Changes_When_Uppercased}', "");
    Expect(1, 125251, '\P{^-	Changes_When_Uppercased}', "");
    Expect(0, 125252, '\p{-	Changes_When_Uppercased}', "");
    Expect(1, 125252, '\p{^-	Changes_When_Uppercased}', "");
    Expect(1, 125252, '\P{-	Changes_When_Uppercased}', "");
    Expect(0, 125252, '\P{^-	Changes_When_Uppercased}', "");
    Error('\p{/a/IS_changes_when_uppercased}');
    Error('\P{/a/IS_changes_when_uppercased}');
    Expect(1, 125251, '\p{ischangeswhenuppercased}', "");
    Expect(0, 125251, '\p{^ischangeswhenuppercased}', "");
    Expect(0, 125251, '\P{ischangeswhenuppercased}', "");
    Expect(1, 125251, '\P{^ischangeswhenuppercased}', "");
    Expect(0, 125252, '\p{ischangeswhenuppercased}', "");
    Expect(1, 125252, '\p{^ischangeswhenuppercased}', "");
    Expect(1, 125252, '\P{ischangeswhenuppercased}', "");
    Expect(0, 125252, '\P{^ischangeswhenuppercased}', "");
    Expect(1, 125251, '\p{	 is_Changes_When_UPPERCASED}', "");
    Expect(0, 125251, '\p{^	 is_Changes_When_UPPERCASED}', "");
    Expect(0, 125251, '\P{	 is_Changes_When_UPPERCASED}', "");
    Expect(1, 125251, '\P{^	 is_Changes_When_UPPERCASED}', "");
    Expect(0, 125252, '\p{	 is_Changes_When_UPPERCASED}', "");
    Expect(1, 125252, '\p{^	 is_Changes_When_UPPERCASED}', "");
    Expect(1, 125252, '\P{	 is_Changes_When_UPPERCASED}', "");
    Expect(0, 125252, '\P{^	 is_Changes_When_UPPERCASED}', "");
    Error('\p{/a/cwu}');
    Error('\P{/a/cwu}');
    Expect(1, 125251, '\p{cwu}', "");
    Expect(0, 125251, '\p{^cwu}', "");
    Expect(0, 125251, '\P{cwu}', "");
    Expect(1, 125251, '\P{^cwu}', "");
    Expect(0, 125252, '\p{cwu}', "");
    Expect(1, 125252, '\p{^cwu}', "");
    Expect(1, 125252, '\P{cwu}', "");
    Expect(0, 125252, '\P{^cwu}', "");
    Expect(1, 125251, '\p{	-CWU}', "");
    Expect(0, 125251, '\p{^	-CWU}', "");
    Expect(0, 125251, '\P{	-CWU}', "");
    Expect(1, 125251, '\P{^	-CWU}', "");
    Expect(0, 125252, '\p{	-CWU}', "");
    Expect(1, 125252, '\p{^	-CWU}', "");
    Expect(1, 125252, '\P{	-CWU}', "");
    Expect(0, 125252, '\P{^	-CWU}', "");
    Error('\p{:=is_CWU}');
    Error('\P{:=is_CWU}');
    Expect(1, 125251, '\p{iscwu}', "");
    Expect(0, 125251, '\p{^iscwu}', "");
    Expect(0, 125251, '\P{iscwu}', "");
    Expect(1, 125251, '\P{^iscwu}', "");
    Expect(0, 125252, '\p{iscwu}', "");
    Expect(1, 125252, '\p{^iscwu}', "");
    Expect(1, 125252, '\P{iscwu}', "");
    Expect(0, 125252, '\P{^iscwu}', "");
    Expect(1, 125251, '\p{_ is_CWU}', "");
    Expect(0, 125251, '\p{^_ is_CWU}', "");
    Expect(0, 125251, '\P{_ is_CWU}', "");
    Expect(1, 125251, '\P{^_ is_CWU}', "");
    Expect(0, 125252, '\p{_ is_CWU}', "");
    Expect(1, 125252, '\p{^_ is_CWU}', "");
    Expect(1, 125252, '\P{_ is_CWU}', "");
    Expect(0, 125252, '\P{^_ is_CWU}', "");
    Error('\p{	 CHEROKEE/a/}');
    Error('\P{	 CHEROKEE/a/}');
    Expect(1, 43967, '\p{cherokee}', "");
    Expect(0, 43967, '\p{^cherokee}', "");
    Expect(0, 43967, '\P{cherokee}', "");
    Expect(1, 43967, '\P{^cherokee}', "");
    Expect(0, 43968, '\p{cherokee}', "");
    Expect(1, 43968, '\p{^cherokee}', "");
    Expect(1, 43968, '\P{cherokee}', "");
    Expect(0, 43968, '\P{^cherokee}', "");
    Expect(1, 43967, '\p{_ Cherokee}', "");
    Expect(0, 43967, '\p{^_ Cherokee}', "");
    Expect(0, 43967, '\P{_ Cherokee}', "");
    Expect(1, 43967, '\P{^_ Cherokee}', "");
    Expect(0, 43968, '\p{_ Cherokee}', "");
    Expect(1, 43968, '\p{^_ Cherokee}', "");
    Expect(1, 43968, '\P{_ Cherokee}', "");
    Expect(0, 43968, '\P{^_ Cherokee}', "");
    Error('\p{/a/- Is_Cherokee}');
    Error('\P{/a/- Is_Cherokee}');
    Expect(1, 43967, '\p{ischerokee}', "");
    Expect(0, 43967, '\p{^ischerokee}', "");
    Expect(0, 43967, '\P{ischerokee}', "");
    Expect(1, 43967, '\P{^ischerokee}', "");
    Expect(0, 43968, '\p{ischerokee}', "");
    Expect(1, 43968, '\p{^ischerokee}', "");
    Expect(1, 43968, '\P{ischerokee}', "");
    Expect(0, 43968, '\P{^ischerokee}', "");
    Expect(1, 43967, '\p{_Is_cherokee}', "");
    Expect(0, 43967, '\p{^_Is_cherokee}', "");
    Expect(0, 43967, '\P{_Is_cherokee}', "");
    Expect(1, 43967, '\P{^_Is_cherokee}', "");
    Expect(0, 43968, '\p{_Is_cherokee}', "");
    Expect(1, 43968, '\p{^_Is_cherokee}', "");
    Expect(1, 43968, '\P{_Is_cherokee}', "");
    Expect(0, 43968, '\P{^_Is_cherokee}', "");
    Error('\p{/a/CHER}');
    Error('\P{/a/CHER}');
    Expect(1, 43967, '\p{cher}', "");
    Expect(0, 43967, '\p{^cher}', "");
    Expect(0, 43967, '\P{cher}', "");
    Expect(1, 43967, '\P{^cher}', "");
    Expect(0, 43968, '\p{cher}', "");
    Expect(1, 43968, '\p{^cher}', "");
    Expect(1, 43968, '\P{cher}', "");
    Expect(0, 43968, '\P{^cher}', "");
    Expect(1, 43967, '\p{_cher}', "");
    Expect(0, 43967, '\p{^_cher}', "");
    Expect(0, 43967, '\P{_cher}', "");
    Expect(1, 43967, '\P{^_cher}', "");
    Expect(0, 43968, '\p{_cher}', "");
    Expect(1, 43968, '\p{^_cher}', "");
    Expect(1, 43968, '\P{_cher}', "");
    Expect(0, 43968, '\P{^_cher}', "");
    Error('\p{/a/_ Is_CHER}');
    Error('\P{/a/_ Is_CHER}');
    Expect(1, 43967, '\p{ischer}', "");
    Expect(0, 43967, '\p{^ischer}', "");
    Expect(0, 43967, '\P{ischer}', "");
    Expect(1, 43967, '\P{^ischer}', "");
    Expect(0, 43968, '\p{ischer}', "");
    Expect(1, 43968, '\p{^ischer}', "");
    Expect(1, 43968, '\P{ischer}', "");
    Expect(0, 43968, '\P{^ischer}', "");
    Expect(1, 43967, '\p{Is_CHER}', "");
    Expect(0, 43967, '\p{^Is_CHER}', "");
    Expect(0, 43967, '\P{Is_CHER}', "");
    Expect(1, 43967, '\P{^Is_CHER}', "");
    Expect(0, 43968, '\p{Is_CHER}', "");
    Expect(1, 43968, '\p{^Is_CHER}', "");
    Expect(1, 43968, '\P{Is_CHER}', "");
    Expect(0, 43968, '\P{^Is_CHER}', "");
    Error('\p{-/a/Cherokee_Supplement}');
    Error('\P{-/a/Cherokee_Supplement}');
    Expect(1, 43967, '\p{cherokeesupplement}', "");
    Expect(0, 43967, '\p{^cherokeesupplement}', "");
    Expect(0, 43967, '\P{cherokeesupplement}', "");
    Expect(1, 43967, '\P{^cherokeesupplement}', "");
    Expect(0, 43968, '\p{cherokeesupplement}', "");
    Expect(1, 43968, '\p{^cherokeesupplement}', "");
    Expect(1, 43968, '\P{cherokeesupplement}', "");
    Expect(0, 43968, '\P{^cherokeesupplement}', "");
    Expect(1, 43967, '\p{	-cherokee_supplement}', "");
    Expect(0, 43967, '\p{^	-cherokee_supplement}', "");
    Expect(0, 43967, '\P{	-cherokee_supplement}', "");
    Expect(1, 43967, '\P{^	-cherokee_supplement}', "");
    Expect(0, 43968, '\p{	-cherokee_supplement}', "");
    Expect(1, 43968, '\p{^	-cherokee_supplement}', "");
    Expect(1, 43968, '\P{	-cherokee_supplement}', "");
    Expect(0, 43968, '\P{^	-cherokee_supplement}', "");
    Error('\p{:=IS_Cherokee_Supplement}');
    Error('\P{:=IS_Cherokee_Supplement}');
    Expect(1, 43967, '\p{ischerokeesupplement}', "");
    Expect(0, 43967, '\p{^ischerokeesupplement}', "");
    Expect(0, 43967, '\P{ischerokeesupplement}', "");
    Expect(1, 43967, '\P{^ischerokeesupplement}', "");
    Expect(0, 43968, '\p{ischerokeesupplement}', "");
    Expect(1, 43968, '\p{^ischerokeesupplement}', "");
    Expect(1, 43968, '\P{ischerokeesupplement}', "");
    Expect(0, 43968, '\P{^ischerokeesupplement}', "");
    Expect(1, 43967, '\p{ _Is_Cherokee_Supplement}', "");
    Expect(0, 43967, '\p{^ _Is_Cherokee_Supplement}', "");
    Expect(0, 43967, '\P{ _Is_Cherokee_Supplement}', "");
    Expect(1, 43967, '\P{^ _Is_Cherokee_Supplement}', "");
    Expect(0, 43968, '\p{ _Is_Cherokee_Supplement}', "");
    Expect(1, 43968, '\p{^ _Is_Cherokee_Supplement}', "");
    Expect(1, 43968, '\P{ _Is_Cherokee_Supplement}', "");
    Expect(0, 43968, '\P{^ _Is_Cherokee_Supplement}', "");
    Error('\p{_In_CHEROKEE_Supplement:=}');
    Error('\P{_In_CHEROKEE_Supplement:=}');
    Expect(1, 43967, '\p{incherokeesupplement}', "");
    Expect(0, 43967, '\p{^incherokeesupplement}', "");
    Expect(0, 43967, '\P{incherokeesupplement}', "");
    Expect(1, 43967, '\P{^incherokeesupplement}', "");
    Expect(0, 43968, '\p{incherokeesupplement}', "");
    Expect(1, 43968, '\p{^incherokeesupplement}', "");
    Expect(1, 43968, '\P{incherokeesupplement}', "");
    Expect(0, 43968, '\P{^incherokeesupplement}', "");
    Expect(1, 43967, '\p{	In_Cherokee_Supplement}', "");
    Expect(0, 43967, '\p{^	In_Cherokee_Supplement}', "");
    Expect(0, 43967, '\P{	In_Cherokee_Supplement}', "");
    Expect(1, 43967, '\P{^	In_Cherokee_Supplement}', "");
    Expect(0, 43968, '\p{	In_Cherokee_Supplement}', "");
    Expect(1, 43968, '\p{^	In_Cherokee_Supplement}', "");
    Expect(1, 43968, '\P{	In_Cherokee_Supplement}', "");
    Expect(0, 43968, '\P{^	In_Cherokee_Supplement}', "");
    Error('\p{:=cherokee_sup}');
    Error('\P{:=cherokee_sup}');
    Expect(1, 43967, '\p{cherokeesup}', "");
    Expect(0, 43967, '\p{^cherokeesup}', "");
    Expect(0, 43967, '\P{cherokeesup}', "");
    Expect(1, 43967, '\P{^cherokeesup}', "");
    Expect(0, 43968, '\p{cherokeesup}', "");
    Expect(1, 43968, '\p{^cherokeesup}', "");
    Expect(1, 43968, '\P{cherokeesup}', "");
    Expect(0, 43968, '\P{^cherokeesup}', "");
    Expect(1, 43967, '\p{ -cherokee_Sup}', "");
    Expect(0, 43967, '\p{^ -cherokee_Sup}', "");
    Expect(0, 43967, '\P{ -cherokee_Sup}', "");
    Expect(1, 43967, '\P{^ -cherokee_Sup}', "");
    Expect(0, 43968, '\p{ -cherokee_Sup}', "");
    Expect(1, 43968, '\p{^ -cherokee_Sup}', "");
    Expect(1, 43968, '\P{ -cherokee_Sup}', "");
    Expect(0, 43968, '\P{^ -cherokee_Sup}', "");
    Error('\p{/a/--is_CHEROKEE_SUP}');
    Error('\P{/a/--is_CHEROKEE_SUP}');
    Expect(1, 43967, '\p{ischerokeesup}', "");
    Expect(0, 43967, '\p{^ischerokeesup}', "");
    Expect(0, 43967, '\P{ischerokeesup}', "");
    Expect(1, 43967, '\P{^ischerokeesup}', "");
    Expect(0, 43968, '\p{ischerokeesup}', "");
    Expect(1, 43968, '\p{^ischerokeesup}', "");
    Expect(1, 43968, '\P{ischerokeesup}', "");
    Expect(0, 43968, '\P{^ischerokeesup}', "");
    Expect(1, 43967, '\p{_Is_cherokee_Sup}', "");
    Expect(0, 43967, '\p{^_Is_cherokee_Sup}', "");
    Expect(0, 43967, '\P{_Is_cherokee_Sup}', "");
    Expect(1, 43967, '\P{^_Is_cherokee_Sup}', "");
    Expect(0, 43968, '\p{_Is_cherokee_Sup}', "");
    Expect(1, 43968, '\p{^_Is_cherokee_Sup}', "");
    Expect(1, 43968, '\P{_Is_cherokee_Sup}', "");
    Expect(0, 43968, '\P{^_Is_cherokee_Sup}', "");
    Error('\p{In_Cherokee_Sup:=}');
    Error('\P{In_Cherokee_Sup:=}');
    Expect(1, 43967, '\p{incherokeesup}', "");
    Expect(0, 43967, '\p{^incherokeesup}', "");
    Expect(0, 43967, '\P{incherokeesup}', "");
    Expect(1, 43967, '\P{^incherokeesup}', "");
    Expect(0, 43968, '\p{incherokeesup}', "");
    Expect(1, 43968, '\p{^incherokeesup}', "");
    Expect(1, 43968, '\P{incherokeesup}', "");
    Expect(0, 43968, '\P{^incherokeesup}', "");
    Expect(1, 43967, '\p{	_in_CHEROKEE_Sup}', "");
    Expect(0, 43967, '\p{^	_in_CHEROKEE_Sup}', "");
    Expect(0, 43967, '\P{	_in_CHEROKEE_Sup}', "");
    Expect(1, 43967, '\P{^	_in_CHEROKEE_Sup}', "");
    Expect(0, 43968, '\p{	_in_CHEROKEE_Sup}', "");
    Expect(1, 43968, '\p{^	_in_CHEROKEE_Sup}', "");
    Expect(1, 43968, '\P{	_in_CHEROKEE_Sup}', "");
    Expect(0, 43968, '\P{^	_in_CHEROKEE_Sup}', "");
    Error('\p{:=  Chess_Symbols}');
    Error('\P{:=  Chess_Symbols}');
    Expect(1, 129647, '\p{chesssymbols}', "");
    Expect(0, 129647, '\p{^chesssymbols}', "");
    Expect(0, 129647, '\P{chesssymbols}', "");
    Expect(1, 129647, '\P{^chesssymbols}', "");
    Expect(0, 129648, '\p{chesssymbols}', "");
    Expect(1, 129648, '\p{^chesssymbols}', "");
    Expect(1, 129648, '\P{chesssymbols}', "");
    Expect(0, 129648, '\P{^chesssymbols}', "");
    Expect(1, 129647, '\p{	_CHESS_Symbols}', "");
    Expect(0, 129647, '\p{^	_CHESS_Symbols}', "");
    Expect(0, 129647, '\P{	_CHESS_Symbols}', "");
    Expect(1, 129647, '\P{^	_CHESS_Symbols}', "");
    Expect(0, 129648, '\p{	_CHESS_Symbols}', "");
    Expect(1, 129648, '\p{^	_CHESS_Symbols}', "");
    Expect(1, 129648, '\P{	_CHESS_Symbols}', "");
    Expect(0, 129648, '\P{^	_CHESS_Symbols}', "");
    Error('\p{:=_IS_Chess_symbols}');
    Error('\P{:=_IS_Chess_symbols}');
    Expect(1, 129647, '\p{ischesssymbols}', "");
    Expect(0, 129647, '\p{^ischesssymbols}', "");
    Expect(0, 129647, '\P{ischesssymbols}', "");
    Expect(1, 129647, '\P{^ischesssymbols}', "");
    Expect(0, 129648, '\p{ischesssymbols}', "");
    Expect(1, 129648, '\p{^ischesssymbols}', "");
    Expect(1, 129648, '\P{ischesssymbols}', "");
    Expect(0, 129648, '\P{^ischesssymbols}', "");
    Expect(1, 129647, '\p{_Is_Chess_Symbols}', "");
    Expect(0, 129647, '\p{^_Is_Chess_Symbols}', "");
    Expect(0, 129647, '\P{_Is_Chess_Symbols}', "");
    Expect(1, 129647, '\P{^_Is_Chess_Symbols}', "");
    Expect(0, 129648, '\p{_Is_Chess_Symbols}', "");
    Expect(1, 129648, '\p{^_Is_Chess_Symbols}', "");
    Expect(1, 129648, '\P{_Is_Chess_Symbols}', "");
    Expect(0, 129648, '\P{^_Is_Chess_Symbols}', "");
    Error('\p{	_In_Chess_Symbols:=}');
    Error('\P{	_In_Chess_Symbols:=}');
    Expect(1, 129647, '\p{inchesssymbols}', "");
    Expect(0, 129647, '\p{^inchesssymbols}', "");
    Expect(0, 129647, '\P{inchesssymbols}', "");
    Expect(1, 129647, '\P{^inchesssymbols}', "");
    Expect(0, 129648, '\p{inchesssymbols}', "");
    Expect(1, 129648, '\p{^inchesssymbols}', "");
    Expect(1, 129648, '\P{inchesssymbols}', "");
    Expect(0, 129648, '\P{^inchesssymbols}', "");
    Expect(1, 129647, '\p{	-In_Chess_Symbols}', "");
    Expect(0, 129647, '\p{^	-In_Chess_Symbols}', "");
    Expect(0, 129647, '\P{	-In_Chess_Symbols}', "");
    Expect(1, 129647, '\P{^	-In_Chess_Symbols}', "");
    Expect(0, 129648, '\p{	-In_Chess_Symbols}', "");
    Expect(1, 129648, '\p{^	-In_Chess_Symbols}', "");
    Expect(1, 129648, '\P{	-In_Chess_Symbols}', "");
    Expect(0, 129648, '\P{^	-In_Chess_Symbols}', "");
    Error('\p{-_chorasmian/a/}');
    Error('\P{-_chorasmian/a/}');
    Expect(1, 69579, '\p{chorasmian}', "");
    Expect(0, 69579, '\p{^chorasmian}', "");
    Expect(0, 69579, '\P{chorasmian}', "");
    Expect(1, 69579, '\P{^chorasmian}', "");
    Expect(0, 69580, '\p{chorasmian}', "");
    Expect(1, 69580, '\p{^chorasmian}', "");
    Expect(1, 69580, '\P{chorasmian}', "");
    Expect(0, 69580, '\P{^chorasmian}', "");
    Expect(1, 69579, '\p{	 CHORASMIAN}', "");
    Expect(0, 69579, '\p{^	 CHORASMIAN}', "");
    Expect(0, 69579, '\P{	 CHORASMIAN}', "");
    Expect(1, 69579, '\P{^	 CHORASMIAN}', "");
    Expect(0, 69580, '\p{	 CHORASMIAN}', "");
    Expect(1, 69580, '\p{^	 CHORASMIAN}', "");
    Expect(1, 69580, '\P{	 CHORASMIAN}', "");
    Expect(0, 69580, '\P{^	 CHORASMIAN}', "");
    Error('\p{	Is_Chorasmian:=}');
    Error('\P{	Is_Chorasmian:=}');
    Expect(1, 69579, '\p{ischorasmian}', "");
    Expect(0, 69579, '\p{^ischorasmian}', "");
    Expect(0, 69579, '\P{ischorasmian}', "");
    Expect(1, 69579, '\P{^ischorasmian}', "");
    Expect(0, 69580, '\p{ischorasmian}', "");
    Expect(1, 69580, '\p{^ischorasmian}', "");
    Expect(1, 69580, '\P{ischorasmian}', "");
    Expect(0, 69580, '\P{^ischorasmian}', "");
    Expect(1, 69579, '\p{  IS_Chorasmian}', "");
    Expect(0, 69579, '\p{^  IS_Chorasmian}', "");
    Expect(0, 69579, '\P{  IS_Chorasmian}', "");
    Expect(1, 69579, '\P{^  IS_Chorasmian}', "");
    Expect(0, 69580, '\p{  IS_Chorasmian}', "");
    Expect(1, 69580, '\p{^  IS_Chorasmian}', "");
    Expect(1, 69580, '\P{  IS_Chorasmian}', "");
    Expect(0, 69580, '\P{^  IS_Chorasmian}', "");
    Error('\p{:=Chrs}');
    Error('\P{:=Chrs}');
    Expect(1, 69579, '\p{chrs}', "");
    Expect(0, 69579, '\p{^chrs}', "");
    Expect(0, 69579, '\P{chrs}', "");
    Expect(1, 69579, '\P{^chrs}', "");
    Expect(0, 69580, '\p{chrs}', "");
    Expect(1, 69580, '\p{^chrs}', "");
    Expect(1, 69580, '\P{chrs}', "");
    Expect(0, 69580, '\P{^chrs}', "");
    Expect(1, 69579, '\p{	CHRS}', "");
    Expect(0, 69579, '\p{^	CHRS}', "");
    Expect(0, 69579, '\P{	CHRS}', "");
    Expect(1, 69579, '\P{^	CHRS}', "");
    Expect(0, 69580, '\p{	CHRS}', "");
    Expect(1, 69580, '\p{^	CHRS}', "");
    Expect(1, 69580, '\P{	CHRS}', "");
    Expect(0, 69580, '\P{^	CHRS}', "");
    Error('\p{/a/--is_CHRS}');
    Error('\P{/a/--is_CHRS}');
    Expect(1, 69579, '\p{ischrs}', "");
    Expect(0, 69579, '\p{^ischrs}', "");
    Expect(0, 69579, '\P{ischrs}', "");
    Expect(1, 69579, '\P{^ischrs}', "");
    Expect(0, 69580, '\p{ischrs}', "");
    Expect(1, 69580, '\p{^ischrs}', "");
    Expect(1, 69580, '\P{ischrs}', "");
    Expect(0, 69580, '\P{^ischrs}', "");
    Expect(1, 69579, '\p{  Is_CHRS}', "");
    Expect(0, 69579, '\p{^  Is_CHRS}', "");
    Expect(0, 69579, '\P{  Is_CHRS}', "");
    Expect(1, 69579, '\P{^  Is_CHRS}', "");
    Expect(0, 69580, '\p{  Is_CHRS}', "");
    Expect(1, 69580, '\p{^  Is_CHRS}', "");
    Expect(1, 69580, '\P{  Is_CHRS}', "");
    Expect(0, 69580, '\P{^  Is_CHRS}', "");
    Error('\p{:=-	CJK_compatibility}');
    Error('\P{:=-	CJK_compatibility}');
    Expect(1, 13311, '\p{cjkcompatibility}', "");
    Expect(0, 13311, '\p{^cjkcompatibility}', "");
    Expect(0, 13311, '\P{cjkcompatibility}', "");
    Expect(1, 13311, '\P{^cjkcompatibility}', "");
    Expect(0, 13312, '\p{cjkcompatibility}', "");
    Expect(1, 13312, '\p{^cjkcompatibility}', "");
    Expect(1, 13312, '\P{cjkcompatibility}', "");
    Expect(0, 13312, '\P{^cjkcompatibility}', "");
    Expect(1, 13311, '\p{-_CJK_compatibility}', "");
    Expect(0, 13311, '\p{^-_CJK_compatibility}', "");
    Expect(0, 13311, '\P{-_CJK_compatibility}', "");
    Expect(1, 13311, '\P{^-_CJK_compatibility}', "");
    Expect(0, 13312, '\p{-_CJK_compatibility}', "");
    Expect(1, 13312, '\p{^-_CJK_compatibility}', "");
    Expect(1, 13312, '\P{-_CJK_compatibility}', "");
    Expect(0, 13312, '\P{^-_CJK_compatibility}', "");
    Error('\p{:=	_Is_cjk_Compatibility}');
    Error('\P{:=	_Is_cjk_Compatibility}');
    Expect(1, 13311, '\p{iscjkcompatibility}', "");
    Expect(0, 13311, '\p{^iscjkcompatibility}', "");
    Expect(0, 13311, '\P{iscjkcompatibility}', "");
    Expect(1, 13311, '\P{^iscjkcompatibility}', "");
    Expect(0, 13312, '\p{iscjkcompatibility}', "");
    Expect(1, 13312, '\p{^iscjkcompatibility}', "");
    Expect(1, 13312, '\P{iscjkcompatibility}', "");
    Expect(0, 13312, '\P{^iscjkcompatibility}', "");
    Expect(1, 13311, '\p{ is_CJK_Compatibility}', "");
    Expect(0, 13311, '\p{^ is_CJK_Compatibility}', "");
    Expect(0, 13311, '\P{ is_CJK_Compatibility}', "");
    Expect(1, 13311, '\P{^ is_CJK_Compatibility}', "");
    Expect(0, 13312, '\p{ is_CJK_Compatibility}', "");
    Expect(1, 13312, '\p{^ is_CJK_Compatibility}', "");
    Expect(1, 13312, '\P{ is_CJK_Compatibility}', "");
    Expect(0, 13312, '\P{^ is_CJK_Compatibility}', "");
    Error('\p{- In_CJK_compatibility:=}');
    Error('\P{- In_CJK_compatibility:=}');
    Expect(1, 13311, '\p{incjkcompatibility}', "");
    Expect(0, 13311, '\p{^incjkcompatibility}', "");
    Expect(0, 13311, '\P{incjkcompatibility}', "");
    Expect(1, 13311, '\P{^incjkcompatibility}', "");
    Expect(0, 13312, '\p{incjkcompatibility}', "");
    Expect(1, 13312, '\p{^incjkcompatibility}', "");
    Expect(1, 13312, '\P{incjkcompatibility}', "");
    Expect(0, 13312, '\P{^incjkcompatibility}', "");
    Expect(1, 13311, '\p{ _In_cjk_Compatibility}', "");
    Expect(0, 13311, '\p{^ _In_cjk_Compatibility}', "");
    Expect(0, 13311, '\P{ _In_cjk_Compatibility}', "");
    Expect(1, 13311, '\P{^ _In_cjk_Compatibility}', "");
    Expect(0, 13312, '\p{ _In_cjk_Compatibility}', "");
    Expect(1, 13312, '\p{^ _In_cjk_Compatibility}', "");
    Expect(1, 13312, '\P{ _In_cjk_Compatibility}', "");
    Expect(0, 13312, '\P{^ _In_cjk_Compatibility}', "");
    Error('\p{ -CJK_Compat/a/}');
    Error('\P{ -CJK_Compat/a/}');
    Expect(1, 13311, '\p{cjkcompat}', "");
    Expect(0, 13311, '\p{^cjkcompat}', "");
    Expect(0, 13311, '\P{cjkcompat}', "");
    Expect(1, 13311, '\P{^cjkcompat}', "");
    Expect(0, 13312, '\p{cjkcompat}', "");
    Expect(1, 13312, '\p{^cjkcompat}', "");
    Expect(1, 13312, '\P{cjkcompat}', "");
    Expect(0, 13312, '\P{^cjkcompat}', "");
    Expect(1, 13311, '\p{_CJK_Compat}', "");
    Expect(0, 13311, '\p{^_CJK_Compat}', "");
    Expect(0, 13311, '\P{_CJK_Compat}', "");
    Expect(1, 13311, '\P{^_CJK_Compat}', "");
    Expect(0, 13312, '\p{_CJK_Compat}', "");
    Expect(1, 13312, '\p{^_CJK_Compat}', "");
    Expect(1, 13312, '\P{_CJK_Compat}', "");
    Expect(0, 13312, '\P{^_CJK_Compat}', "");
    Error('\p{:=_Is_CJK_Compat}');
    Error('\P{:=_Is_CJK_Compat}');
    Expect(1, 13311, '\p{iscjkcompat}', "");
    Expect(0, 13311, '\p{^iscjkcompat}', "");
    Expect(0, 13311, '\P{iscjkcompat}', "");
    Expect(1, 13311, '\P{^iscjkcompat}', "");
    Expect(0, 13312, '\p{iscjkcompat}', "");
    Expect(1, 13312, '\p{^iscjkcompat}', "");
    Expect(1, 13312, '\P{iscjkcompat}', "");
    Expect(0, 13312, '\P{^iscjkcompat}', "");
    Expect(1, 13311, '\p{__IS_CJK_Compat}', "");
    Expect(0, 13311, '\p{^__IS_CJK_Compat}', "");
    Expect(0, 13311, '\P{__IS_CJK_Compat}', "");
    Expect(1, 13311, '\P{^__IS_CJK_Compat}', "");
    Expect(0, 13312, '\p{__IS_CJK_Compat}', "");
    Expect(1, 13312, '\p{^__IS_CJK_Compat}', "");
    Expect(1, 13312, '\P{__IS_CJK_Compat}', "");
    Expect(0, 13312, '\P{^__IS_CJK_Compat}', "");
    Error('\p{/a/	in_CJK_Compat}');
    Error('\P{/a/	in_CJK_Compat}');
    Expect(1, 13311, '\p{incjkcompat}', "");
    Expect(0, 13311, '\p{^incjkcompat}', "");
    Expect(0, 13311, '\P{incjkcompat}', "");
    Expect(1, 13311, '\P{^incjkcompat}', "");
    Expect(0, 13312, '\p{incjkcompat}', "");
    Expect(1, 13312, '\p{^incjkcompat}', "");
    Expect(1, 13312, '\P{incjkcompat}', "");
    Expect(0, 13312, '\P{^incjkcompat}', "");
    Expect(1, 13311, '\p{-_In_CJK_COMPAT}', "");
    Expect(0, 13311, '\p{^-_In_CJK_COMPAT}', "");
    Expect(0, 13311, '\P{-_In_CJK_COMPAT}', "");
    Expect(1, 13311, '\P{^-_In_CJK_COMPAT}', "");
    Expect(0, 13312, '\p{-_In_CJK_COMPAT}', "");
    Expect(1, 13312, '\p{^-_In_CJK_COMPAT}', "");
    Expect(1, 13312, '\P{-_In_CJK_COMPAT}', "");
    Expect(0, 13312, '\P{^-_In_CJK_COMPAT}', "");
    Error('\p{-cjk_COMPATIBILITY_FORMS/a/}');
    Error('\P{-cjk_COMPATIBILITY_FORMS/a/}');
    Expect(1, 65103, '\p{cjkcompatibilityforms}', "");
    Expect(0, 65103, '\p{^cjkcompatibilityforms}', "");
    Expect(0, 65103, '\P{cjkcompatibilityforms}', "");
    Expect(1, 65103, '\P{^cjkcompatibilityforms}', "");
    Expect(0, 65104, '\p{cjkcompatibilityforms}', "");
    Expect(1, 65104, '\p{^cjkcompatibilityforms}', "");
    Expect(1, 65104, '\P{cjkcompatibilityforms}', "");
    Expect(0, 65104, '\P{^cjkcompatibilityforms}', "");
    Expect(1, 65103, '\p{_-CJK_Compatibility_forms}', "");
    Expect(0, 65103, '\p{^_-CJK_Compatibility_forms}', "");
    Expect(0, 65103, '\P{_-CJK_Compatibility_forms}', "");
    Expect(1, 65103, '\P{^_-CJK_Compatibility_forms}', "");
    Expect(0, 65104, '\p{_-CJK_Compatibility_forms}', "");
    Expect(1, 65104, '\p{^_-CJK_Compatibility_forms}', "");
    Expect(1, 65104, '\P{_-CJK_Compatibility_forms}', "");
    Expect(0, 65104, '\P{^_-CJK_Compatibility_forms}', "");
    Error('\p{	_is_CJK_Compatibility_FORMS/a/}');
    Error('\P{	_is_CJK_Compatibility_FORMS/a/}');
    Expect(1, 65103, '\p{iscjkcompatibilityforms}', "");
    Expect(0, 65103, '\p{^iscjkcompatibilityforms}', "");
    Expect(0, 65103, '\P{iscjkcompatibilityforms}', "");
    Expect(1, 65103, '\P{^iscjkcompatibilityforms}', "");
    Expect(0, 65104, '\p{iscjkcompatibilityforms}', "");
    Expect(1, 65104, '\p{^iscjkcompatibilityforms}', "");
    Expect(1, 65104, '\P{iscjkcompatibilityforms}', "");
    Expect(0, 65104, '\P{^iscjkcompatibilityforms}', "");
    Expect(1, 65103, '\p{-_Is_CJK_COMPATIBILITY_forms}', "");
    Expect(0, 65103, '\p{^-_Is_CJK_COMPATIBILITY_forms}', "");
    Expect(0, 65103, '\P{-_Is_CJK_COMPATIBILITY_forms}', "");
    Expect(1, 65103, '\P{^-_Is_CJK_COMPATIBILITY_forms}', "");
    Expect(0, 65104, '\p{-_Is_CJK_COMPATIBILITY_forms}', "");
    Expect(1, 65104, '\p{^-_Is_CJK_COMPATIBILITY_forms}', "");
    Expect(1, 65104, '\P{-_Is_CJK_COMPATIBILITY_forms}', "");
    Expect(0, 65104, '\P{^-_Is_CJK_COMPATIBILITY_forms}', "");
    Error('\p{:=_	In_cjk_Compatibility_Forms}');
    Error('\P{:=_	In_cjk_Compatibility_Forms}');
    Expect(1, 65103, '\p{incjkcompatibilityforms}', "");
    Expect(0, 65103, '\p{^incjkcompatibilityforms}', "");
    Expect(0, 65103, '\P{incjkcompatibilityforms}', "");
    Expect(1, 65103, '\P{^incjkcompatibilityforms}', "");
    Expect(0, 65104, '\p{incjkcompatibilityforms}', "");
    Expect(1, 65104, '\p{^incjkcompatibilityforms}', "");
    Expect(1, 65104, '\P{incjkcompatibilityforms}', "");
    Expect(0, 65104, '\P{^incjkcompatibilityforms}', "");
    Expect(1, 65103, '\p{ 	In_CJK_compatibility_Forms}', "");
    Expect(0, 65103, '\p{^ 	In_CJK_compatibility_Forms}', "");
    Expect(0, 65103, '\P{ 	In_CJK_compatibility_Forms}', "");
    Expect(1, 65103, '\P{^ 	In_CJK_compatibility_Forms}', "");
    Expect(0, 65104, '\p{ 	In_CJK_compatibility_Forms}', "");
    Expect(1, 65104, '\p{^ 	In_CJK_compatibility_Forms}', "");
    Expect(1, 65104, '\P{ 	In_CJK_compatibility_Forms}', "");
    Expect(0, 65104, '\P{^ 	In_CJK_compatibility_Forms}', "");
    Error('\p{	cjk_compat_FORMS/a/}');
    Error('\P{	cjk_compat_FORMS/a/}');
    Expect(1, 65103, '\p{cjkcompatforms}', "");
    Expect(0, 65103, '\p{^cjkcompatforms}', "");
    Expect(0, 65103, '\P{cjkcompatforms}', "");
    Expect(1, 65103, '\P{^cjkcompatforms}', "");
    Expect(0, 65104, '\p{cjkcompatforms}', "");
    Expect(1, 65104, '\p{^cjkcompatforms}', "");
    Expect(1, 65104, '\P{cjkcompatforms}', "");
    Expect(0, 65104, '\P{^cjkcompatforms}', "");
    Expect(1, 65103, '\p{-CJK_Compat_Forms}', "");
    Expect(0, 65103, '\p{^-CJK_Compat_Forms}', "");
    Expect(0, 65103, '\P{-CJK_Compat_Forms}', "");
    Expect(1, 65103, '\P{^-CJK_Compat_Forms}', "");
    Expect(0, 65104, '\p{-CJK_Compat_Forms}', "");
    Expect(1, 65104, '\p{^-CJK_Compat_Forms}', "");
    Expect(1, 65104, '\P{-CJK_Compat_Forms}', "");
    Expect(0, 65104, '\P{^-CJK_Compat_Forms}', "");
    Error('\p{ /a/is_CJK_compat_Forms}');
    Error('\P{ /a/is_CJK_compat_Forms}');
    Expect(1, 65103, '\p{iscjkcompatforms}', "");
    Expect(0, 65103, '\p{^iscjkcompatforms}', "");
    Expect(0, 65103, '\P{iscjkcompatforms}', "");
    Expect(1, 65103, '\P{^iscjkcompatforms}', "");
    Expect(0, 65104, '\p{iscjkcompatforms}', "");
    Expect(1, 65104, '\p{^iscjkcompatforms}', "");
    Expect(1, 65104, '\P{iscjkcompatforms}', "");
    Expect(0, 65104, '\P{^iscjkcompatforms}', "");
    Expect(1, 65103, '\p{-Is_cjk_Compat_forms}', "");
    Expect(0, 65103, '\p{^-Is_cjk_Compat_forms}', "");
    Expect(0, 65103, '\P{-Is_cjk_Compat_forms}', "");
    Expect(1, 65103, '\P{^-Is_cjk_Compat_forms}', "");
    Expect(0, 65104, '\p{-Is_cjk_Compat_forms}', "");
    Expect(1, 65104, '\p{^-Is_cjk_Compat_forms}', "");
    Expect(1, 65104, '\P{-Is_cjk_Compat_forms}', "");
    Expect(0, 65104, '\P{^-Is_cjk_Compat_forms}', "");
    Error('\p{	/a/in_CJK_Compat_forms}');
    Error('\P{	/a/in_CJK_Compat_forms}');
    Expect(1, 65103, '\p{incjkcompatforms}', "");
    Expect(0, 65103, '\p{^incjkcompatforms}', "");
    Expect(0, 65103, '\P{incjkcompatforms}', "");
    Expect(1, 65103, '\P{^incjkcompatforms}', "");
    Expect(0, 65104, '\p{incjkcompatforms}', "");
    Expect(1, 65104, '\p{^incjkcompatforms}', "");
    Expect(1, 65104, '\P{incjkcompatforms}', "");
    Expect(0, 65104, '\P{^incjkcompatforms}', "");
    Expect(1, 65103, '\p{_	IN_cjk_compat_Forms}', "");
    Expect(0, 65103, '\p{^_	IN_cjk_compat_Forms}', "");
    Expect(0, 65103, '\P{_	IN_cjk_compat_Forms}', "");
    Expect(1, 65103, '\P{^_	IN_cjk_compat_Forms}', "");
    Expect(0, 65104, '\p{_	IN_cjk_compat_Forms}', "");
    Expect(1, 65104, '\p{^_	IN_cjk_compat_Forms}', "");
    Expect(1, 65104, '\P{_	IN_cjk_compat_Forms}', "");
    Expect(0, 65104, '\P{^_	IN_cjk_compat_Forms}', "");
    Error('\p{	-CJK_COMPATIBILITY_IDEOGRAPHS:=}');
    Error('\P{	-CJK_COMPATIBILITY_IDEOGRAPHS:=}');
    Expect(1, 64255, '\p{cjkcompatibilityideographs}', "");
    Expect(0, 64255, '\p{^cjkcompatibilityideographs}', "");
    Expect(0, 64255, '\P{cjkcompatibilityideographs}', "");
    Expect(1, 64255, '\P{^cjkcompatibilityideographs}', "");
    Expect(0, 64256, '\p{cjkcompatibilityideographs}', "");
    Expect(1, 64256, '\p{^cjkcompatibilityideographs}', "");
    Expect(1, 64256, '\P{cjkcompatibilityideographs}', "");
    Expect(0, 64256, '\P{^cjkcompatibilityideographs}', "");
    Expect(1, 64255, '\p{_CJK_COMPATIBILITY_IDEOGRAPHS}', "");
    Expect(0, 64255, '\p{^_CJK_COMPATIBILITY_IDEOGRAPHS}', "");
    Expect(0, 64255, '\P{_CJK_COMPATIBILITY_IDEOGRAPHS}', "");
    Expect(1, 64255, '\P{^_CJK_COMPATIBILITY_IDEOGRAPHS}', "");
    Expect(0, 64256, '\p{_CJK_COMPATIBILITY_IDEOGRAPHS}', "");
    Expect(1, 64256, '\p{^_CJK_COMPATIBILITY_IDEOGRAPHS}', "");
    Expect(1, 64256, '\P{_CJK_COMPATIBILITY_IDEOGRAPHS}', "");
    Expect(0, 64256, '\P{^_CJK_COMPATIBILITY_IDEOGRAPHS}', "");
    Error('\p{/a/ -Is_CJK_compatibility_IDEOGRAPHS}');
    Error('\P{/a/ -Is_CJK_compatibility_IDEOGRAPHS}');
    Expect(1, 64255, '\p{iscjkcompatibilityideographs}', "");
    Expect(0, 64255, '\p{^iscjkcompatibilityideographs}', "");
    Expect(0, 64255, '\P{iscjkcompatibilityideographs}', "");
    Expect(1, 64255, '\P{^iscjkcompatibilityideographs}', "");
    Expect(0, 64256, '\p{iscjkcompatibilityideographs}', "");
    Expect(1, 64256, '\p{^iscjkcompatibilityideographs}', "");
    Expect(1, 64256, '\P{iscjkcompatibilityideographs}', "");
    Expect(0, 64256, '\P{^iscjkcompatibilityideographs}', "");
    Expect(1, 64255, '\p{-Is_CJK_Compatibility_Ideographs}', "");
    Expect(0, 64255, '\p{^-Is_CJK_Compatibility_Ideographs}', "");
    Expect(0, 64255, '\P{-Is_CJK_Compatibility_Ideographs}', "");
    Expect(1, 64255, '\P{^-Is_CJK_Compatibility_Ideographs}', "");
    Expect(0, 64256, '\p{-Is_CJK_Compatibility_Ideographs}', "");
    Expect(1, 64256, '\p{^-Is_CJK_Compatibility_Ideographs}', "");
    Expect(1, 64256, '\P{-Is_CJK_Compatibility_Ideographs}', "");
    Expect(0, 64256, '\P{^-Is_CJK_Compatibility_Ideographs}', "");
    Error('\p{_:=in_cjk_Compatibility_IDEOGRAPHS}');
    Error('\P{_:=in_cjk_Compatibility_IDEOGRAPHS}');
    Expect(1, 64255, '\p{incjkcompatibilityideographs}', "");
    Expect(0, 64255, '\p{^incjkcompatibilityideographs}', "");
    Expect(0, 64255, '\P{incjkcompatibilityideographs}', "");
    Expect(1, 64255, '\P{^incjkcompatibilityideographs}', "");
    Expect(0, 64256, '\p{incjkcompatibilityideographs}', "");
    Expect(1, 64256, '\p{^incjkcompatibilityideographs}', "");
    Expect(1, 64256, '\P{incjkcompatibilityideographs}', "");
    Expect(0, 64256, '\P{^incjkcompatibilityideographs}', "");
    Expect(1, 64255, '\p{	 In_CJK_COMPATIBILITY_IDEOGRAPHS}', "");
    Expect(0, 64255, '\p{^	 In_CJK_COMPATIBILITY_IDEOGRAPHS}', "");
    Expect(0, 64255, '\P{	 In_CJK_COMPATIBILITY_IDEOGRAPHS}', "");
    Expect(1, 64255, '\P{^	 In_CJK_COMPATIBILITY_IDEOGRAPHS}', "");
    Expect(0, 64256, '\p{	 In_CJK_COMPATIBILITY_IDEOGRAPHS}', "");
    Expect(1, 64256, '\p{^	 In_CJK_COMPATIBILITY_IDEOGRAPHS}', "");
    Expect(1, 64256, '\P{	 In_CJK_COMPATIBILITY_IDEOGRAPHS}', "");
    Expect(0, 64256, '\P{^	 In_CJK_COMPATIBILITY_IDEOGRAPHS}', "");
    Error('\p{_/a/cjk_Compat_ideographs}');
    Error('\P{_/a/cjk_Compat_ideographs}');
    Expect(1, 64255, '\p{cjkcompatideographs}', "");
    Expect(0, 64255, '\p{^cjkcompatideographs}', "");
    Expect(0, 64255, '\P{cjkcompatideographs}', "");
    Expect(1, 64255, '\P{^cjkcompatideographs}', "");
    Expect(0, 64256, '\p{cjkcompatideographs}', "");
    Expect(1, 64256, '\p{^cjkcompatideographs}', "");
    Expect(1, 64256, '\P{cjkcompatideographs}', "");
    Expect(0, 64256, '\P{^cjkcompatideographs}', "");
    Expect(1, 64255, '\p{ _CJK_Compat_ideographs}', "");
    Expect(0, 64255, '\p{^ _CJK_Compat_ideographs}', "");
    Expect(0, 64255, '\P{ _CJK_Compat_ideographs}', "");
    Expect(1, 64255, '\P{^ _CJK_Compat_ideographs}', "");
    Expect(0, 64256, '\p{ _CJK_Compat_ideographs}', "");
    Expect(1, 64256, '\p{^ _CJK_Compat_ideographs}', "");
    Expect(1, 64256, '\P{ _CJK_Compat_ideographs}', "");
    Expect(0, 64256, '\P{^ _CJK_Compat_ideographs}', "");
    Error('\p{-Is_CJK_Compat_Ideographs:=}');
    Error('\P{-Is_CJK_Compat_Ideographs:=}');
    Expect(1, 64255, '\p{iscjkcompatideographs}', "");
    Expect(0, 64255, '\p{^iscjkcompatideographs}', "");
    Expect(0, 64255, '\P{iscjkcompatideographs}', "");
    Expect(1, 64255, '\P{^iscjkcompatideographs}', "");
    Expect(0, 64256, '\p{iscjkcompatideographs}', "");
    Expect(1, 64256, '\p{^iscjkcompatideographs}', "");
    Expect(1, 64256, '\P{iscjkcompatideographs}', "");
    Expect(0, 64256, '\P{^iscjkcompatideographs}', "");
    Expect(1, 64255, '\p{	Is_cjk_COMPAT_Ideographs}', "");
    Expect(0, 64255, '\p{^	Is_cjk_COMPAT_Ideographs}', "");
    Expect(0, 64255, '\P{	Is_cjk_COMPAT_Ideographs}', "");
    Expect(1, 64255, '\P{^	Is_cjk_COMPAT_Ideographs}', "");
    Expect(0, 64256, '\p{	Is_cjk_COMPAT_Ideographs}', "");
    Expect(1, 64256, '\p{^	Is_cjk_COMPAT_Ideographs}', "");
    Expect(1, 64256, '\P{	Is_cjk_COMPAT_Ideographs}', "");
    Expect(0, 64256, '\P{^	Is_cjk_COMPAT_Ideographs}', "");
    Error('\p{	:=In_cjk_Compat_Ideographs}');
    Error('\P{	:=In_cjk_Compat_Ideographs}');
    Expect(1, 64255, '\p{incjkcompatideographs}', "");
    Expect(0, 64255, '\p{^incjkcompatideographs}', "");
    Expect(0, 64255, '\P{incjkcompatideographs}', "");
    Expect(1, 64255, '\P{^incjkcompatideographs}', "");
    Expect(0, 64256, '\p{incjkcompatideographs}', "");
    Expect(1, 64256, '\p{^incjkcompatideographs}', "");
    Expect(1, 64256, '\P{incjkcompatideographs}', "");
    Expect(0, 64256, '\P{^incjkcompatideographs}', "");
    Expect(1, 64255, '\p{ 	In_CJK_Compat_Ideographs}', "");
    Expect(0, 64255, '\p{^ 	In_CJK_Compat_Ideographs}', "");
    Expect(0, 64255, '\P{ 	In_CJK_Compat_Ideographs}', "");
    Expect(1, 64255, '\P{^ 	In_CJK_Compat_Ideographs}', "");
    Expect(0, 64256, '\p{ 	In_CJK_Compat_Ideographs}', "");
    Expect(1, 64256, '\p{^ 	In_CJK_Compat_Ideographs}', "");
    Expect(1, 64256, '\P{ 	In_CJK_Compat_Ideographs}', "");
    Expect(0, 64256, '\P{^ 	In_CJK_Compat_Ideographs}', "");
    Error('\p{:= _cjk_Compatibility_IDEOGRAPHS_Supplement}');
    Error('\P{:= _cjk_Compatibility_IDEOGRAPHS_Supplement}');
    Expect(1, 195103, '\p{cjkcompatibilityideographssupplement}', "");
    Expect(0, 195103, '\p{^cjkcompatibilityideographssupplement}', "");
    Expect(0, 195103, '\P{cjkcompatibilityideographssupplement}', "");
    Expect(1, 195103, '\P{^cjkcompatibilityideographssupplement}', "");
    Expect(0, 195104, '\p{cjkcompatibilityideographssupplement}', "");
    Expect(1, 195104, '\p{^cjkcompatibilityideographssupplement}', "");
    Expect(1, 195104, '\P{cjkcompatibilityideographssupplement}', "");
    Expect(0, 195104, '\P{^cjkcompatibilityideographssupplement}', "");
    Expect(1, 195103, '\p{__CJK_Compatibility_IDEOGRAPHS_Supplement}', "");
    Expect(0, 195103, '\p{^__CJK_Compatibility_IDEOGRAPHS_Supplement}', "");
    Expect(0, 195103, '\P{__CJK_Compatibility_IDEOGRAPHS_Supplement}', "");
    Expect(1, 195103, '\P{^__CJK_Compatibility_IDEOGRAPHS_Supplement}', "");
    Expect(0, 195104, '\p{__CJK_Compatibility_IDEOGRAPHS_Supplement}', "");
    Expect(1, 195104, '\p{^__CJK_Compatibility_IDEOGRAPHS_Supplement}', "");
    Expect(1, 195104, '\P{__CJK_Compatibility_IDEOGRAPHS_Supplement}', "");
    Expect(0, 195104, '\P{^__CJK_Compatibility_IDEOGRAPHS_Supplement}', "");
    Error('\p{_ Is_CJK_Compatibility_ideographs_supplement:=}');
    Error('\P{_ Is_CJK_Compatibility_ideographs_supplement:=}');
    Expect(1, 195103, '\p{iscjkcompatibilityideographssupplement}', "");
    Expect(0, 195103, '\p{^iscjkcompatibilityideographssupplement}', "");
    Expect(0, 195103, '\P{iscjkcompatibilityideographssupplement}', "");
    Expect(1, 195103, '\P{^iscjkcompatibilityideographssupplement}', "");
    Expect(0, 195104, '\p{iscjkcompatibilityideographssupplement}', "");
    Expect(1, 195104, '\p{^iscjkcompatibilityideographssupplement}', "");
    Expect(1, 195104, '\P{iscjkcompatibilityideographssupplement}', "");
    Expect(0, 195104, '\P{^iscjkcompatibilityideographssupplement}', "");
    Expect(1, 195103, '\p{-is_CJK_compatibility_IDEOGRAPHS_supplement}', "");
    Expect(0, 195103, '\p{^-is_CJK_compatibility_IDEOGRAPHS_supplement}', "");
    Expect(0, 195103, '\P{-is_CJK_compatibility_IDEOGRAPHS_supplement}', "");
    Expect(1, 195103, '\P{^-is_CJK_compatibility_IDEOGRAPHS_supplement}', "");
    Expect(0, 195104, '\p{-is_CJK_compatibility_IDEOGRAPHS_supplement}', "");
    Expect(1, 195104, '\p{^-is_CJK_compatibility_IDEOGRAPHS_supplement}', "");
    Expect(1, 195104, '\P{-is_CJK_compatibility_IDEOGRAPHS_supplement}', "");
    Expect(0, 195104, '\P{^-is_CJK_compatibility_IDEOGRAPHS_supplement}', "");
    Error('\p{ /a/In_CJK_compatibility_Ideographs_Supplement}');
    Error('\P{ /a/In_CJK_compatibility_Ideographs_Supplement}');
    Expect(1, 195103, '\p{incjkcompatibilityideographssupplement}', "");
    Expect(0, 195103, '\p{^incjkcompatibilityideographssupplement}', "");
    Expect(0, 195103, '\P{incjkcompatibilityideographssupplement}', "");
    Expect(1, 195103, '\P{^incjkcompatibilityideographssupplement}', "");
    Expect(0, 195104, '\p{incjkcompatibilityideographssupplement}', "");
    Expect(1, 195104, '\p{^incjkcompatibilityideographssupplement}', "");
    Expect(1, 195104, '\P{incjkcompatibilityideographssupplement}', "");
    Expect(0, 195104, '\P{^incjkcompatibilityideographssupplement}', "");
    Expect(1, 195103, '\p{-	IN_CJK_COMPATIBILITY_IDEOGRAPHS_supplement}', "");
    Expect(0, 195103, '\p{^-	IN_CJK_COMPATIBILITY_IDEOGRAPHS_supplement}', "");
    Expect(0, 195103, '\P{-	IN_CJK_COMPATIBILITY_IDEOGRAPHS_supplement}', "");
    Expect(1, 195103, '\P{^-	IN_CJK_COMPATIBILITY_IDEOGRAPHS_supplement}', "");
    Expect(0, 195104, '\p{-	IN_CJK_COMPATIBILITY_IDEOGRAPHS_supplement}', "");
    Expect(1, 195104, '\p{^-	IN_CJK_COMPATIBILITY_IDEOGRAPHS_supplement}', "");
    Expect(1, 195104, '\P{-	IN_CJK_COMPATIBILITY_IDEOGRAPHS_supplement}', "");
    Expect(0, 195104, '\P{^-	IN_CJK_COMPATIBILITY_IDEOGRAPHS_supplement}', "");
    Error('\p{	-cjk_Compat_ideographs_sup:=}');
    Error('\P{	-cjk_Compat_ideographs_sup:=}');
    Expect(1, 195103, '\p{cjkcompatideographssup}', "");
    Expect(0, 195103, '\p{^cjkcompatideographssup}', "");
    Expect(0, 195103, '\P{cjkcompatideographssup}', "");
    Expect(1, 195103, '\P{^cjkcompatideographssup}', "");
    Expect(0, 195104, '\p{cjkcompatideographssup}', "");
    Expect(1, 195104, '\p{^cjkcompatideographssup}', "");
    Expect(1, 195104, '\P{cjkcompatideographssup}', "");
    Expect(0, 195104, '\P{^cjkcompatideographssup}', "");
    Expect(1, 195103, '\p{_-CJK_COMPAT_Ideographs_Sup}', "");
    Expect(0, 195103, '\p{^_-CJK_COMPAT_Ideographs_Sup}', "");
    Expect(0, 195103, '\P{_-CJK_COMPAT_Ideographs_Sup}', "");
    Expect(1, 195103, '\P{^_-CJK_COMPAT_Ideographs_Sup}', "");
    Expect(0, 195104, '\p{_-CJK_COMPAT_Ideographs_Sup}', "");
    Expect(1, 195104, '\p{^_-CJK_COMPAT_Ideographs_Sup}', "");
    Expect(1, 195104, '\P{_-CJK_COMPAT_Ideographs_Sup}', "");
    Expect(0, 195104, '\P{^_-CJK_COMPAT_Ideographs_Sup}', "");
    Error('\p{-:=Is_CJK_COMPAT_Ideographs_Sup}');
    Error('\P{-:=Is_CJK_COMPAT_Ideographs_Sup}');
    Expect(1, 195103, '\p{iscjkcompatideographssup}', "");
    Expect(0, 195103, '\p{^iscjkcompatideographssup}', "");
    Expect(0, 195103, '\P{iscjkcompatideographssup}', "");
    Expect(1, 195103, '\P{^iscjkcompatideographssup}', "");
    Expect(0, 195104, '\p{iscjkcompatideographssup}', "");
    Expect(1, 195104, '\p{^iscjkcompatideographssup}', "");
    Expect(1, 195104, '\P{iscjkcompatideographssup}', "");
    Expect(0, 195104, '\P{^iscjkcompatideographssup}', "");
    Expect(1, 195103, '\p{- Is_CJK_Compat_Ideographs_sup}', "");
    Expect(0, 195103, '\p{^- Is_CJK_Compat_Ideographs_sup}', "");
    Expect(0, 195103, '\P{- Is_CJK_Compat_Ideographs_sup}', "");
    Expect(1, 195103, '\P{^- Is_CJK_Compat_Ideographs_sup}', "");
    Expect(0, 195104, '\p{- Is_CJK_Compat_Ideographs_sup}', "");
    Expect(1, 195104, '\p{^- Is_CJK_Compat_Ideographs_sup}', "");
    Expect(1, 195104, '\P{- Is_CJK_Compat_Ideographs_sup}', "");
    Expect(0, 195104, '\P{^- Is_CJK_Compat_Ideographs_sup}', "");
    Error('\p{ :=In_cjk_Compat_ideographs_SUP}');
    Error('\P{ :=In_cjk_Compat_ideographs_SUP}');
    Expect(1, 195103, '\p{incjkcompatideographssup}', "");
    Expect(0, 195103, '\p{^incjkcompatideographssup}', "");
    Expect(0, 195103, '\P{incjkcompatideographssup}', "");
    Expect(1, 195103, '\P{^incjkcompatideographssup}', "");
    Expect(0, 195104, '\p{incjkcompatideographssup}', "");
    Expect(1, 195104, '\p{^incjkcompatideographssup}', "");
    Expect(1, 195104, '\P{incjkcompatideographssup}', "");
    Expect(0, 195104, '\P{^incjkcompatideographssup}', "");
    Expect(1, 195103, '\p{__IN_CJK_COMPAT_IDEOGRAPHS_SUP}', "");
    Expect(0, 195103, '\p{^__IN_CJK_COMPAT_IDEOGRAPHS_SUP}', "");
    Expect(0, 195103, '\P{__IN_CJK_COMPAT_IDEOGRAPHS_SUP}', "");
    Expect(1, 195103, '\P{^__IN_CJK_COMPAT_IDEOGRAPHS_SUP}', "");
    Expect(0, 195104, '\p{__IN_CJK_COMPAT_IDEOGRAPHS_SUP}', "");
    Expect(1, 195104, '\p{^__IN_CJK_COMPAT_IDEOGRAPHS_SUP}', "");
    Expect(1, 195104, '\P{__IN_CJK_COMPAT_IDEOGRAPHS_SUP}', "");
    Expect(0, 195104, '\P{^__IN_CJK_COMPAT_IDEOGRAPHS_SUP}', "");
    Error('\p{:=	 CJK_Radicals_SUPPLEMENT}');
    Error('\P{:=	 CJK_Radicals_SUPPLEMENT}');
    Expect(1, 12031, '\p{cjkradicalssupplement}', "");
    Expect(0, 12031, '\p{^cjkradicalssupplement}', "");
    Expect(0, 12031, '\P{cjkradicalssupplement}', "");
    Expect(1, 12031, '\P{^cjkradicalssupplement}', "");
    Expect(0, 12032, '\p{cjkradicalssupplement}', "");
    Expect(1, 12032, '\p{^cjkradicalssupplement}', "");
    Expect(1, 12032, '\P{cjkradicalssupplement}', "");
    Expect(0, 12032, '\P{^cjkradicalssupplement}', "");
    Expect(1, 12031, '\p{ 	CJK_Radicals_Supplement}', "");
    Expect(0, 12031, '\p{^ 	CJK_Radicals_Supplement}', "");
    Expect(0, 12031, '\P{ 	CJK_Radicals_Supplement}', "");
    Expect(1, 12031, '\P{^ 	CJK_Radicals_Supplement}', "");
    Expect(0, 12032, '\p{ 	CJK_Radicals_Supplement}', "");
    Expect(1, 12032, '\p{^ 	CJK_Radicals_Supplement}', "");
    Expect(1, 12032, '\P{ 	CJK_Radicals_Supplement}', "");
    Expect(0, 12032, '\P{^ 	CJK_Radicals_Supplement}', "");
    Error('\p{/a/Is_CJK_Radicals_Supplement}');
    Error('\P{/a/Is_CJK_Radicals_Supplement}');
    Expect(1, 12031, '\p{iscjkradicalssupplement}', "");
    Expect(0, 12031, '\p{^iscjkradicalssupplement}', "");
    Expect(0, 12031, '\P{iscjkradicalssupplement}', "");
    Expect(1, 12031, '\P{^iscjkradicalssupplement}', "");
    Expect(0, 12032, '\p{iscjkradicalssupplement}', "");
    Expect(1, 12032, '\p{^iscjkradicalssupplement}', "");
    Expect(1, 12032, '\P{iscjkradicalssupplement}', "");
    Expect(0, 12032, '\P{^iscjkradicalssupplement}', "");
    Expect(1, 12031, '\p{ IS_CJK_RADICALS_Supplement}', "");
    Expect(0, 12031, '\p{^ IS_CJK_RADICALS_Supplement}', "");
    Expect(0, 12031, '\P{ IS_CJK_RADICALS_Supplement}', "");
    Expect(1, 12031, '\P{^ IS_CJK_RADICALS_Supplement}', "");
    Expect(0, 12032, '\p{ IS_CJK_RADICALS_Supplement}', "");
    Expect(1, 12032, '\p{^ IS_CJK_RADICALS_Supplement}', "");
    Expect(1, 12032, '\P{ IS_CJK_RADICALS_Supplement}', "");
    Expect(0, 12032, '\P{^ IS_CJK_RADICALS_Supplement}', "");
    Error('\p{_IN_cjk_radicals_Supplement:=}');
    Error('\P{_IN_cjk_radicals_Supplement:=}');
    Expect(1, 12031, '\p{incjkradicalssupplement}', "");
    Expect(0, 12031, '\p{^incjkradicalssupplement}', "");
    Expect(0, 12031, '\P{incjkradicalssupplement}', "");
    Expect(1, 12031, '\P{^incjkradicalssupplement}', "");
    Expect(0, 12032, '\p{incjkradicalssupplement}', "");
    Expect(1, 12032, '\p{^incjkradicalssupplement}', "");
    Expect(1, 12032, '\P{incjkradicalssupplement}', "");
    Expect(0, 12032, '\P{^incjkradicalssupplement}', "");
    Expect(1, 12031, '\p{ _In_CJK_Radicals_Supplement}', "");
    Expect(0, 12031, '\p{^ _In_CJK_Radicals_Supplement}', "");
    Expect(0, 12031, '\P{ _In_CJK_Radicals_Supplement}', "");
    Expect(1, 12031, '\P{^ _In_CJK_Radicals_Supplement}', "");
    Expect(0, 12032, '\p{ _In_CJK_Radicals_Supplement}', "");
    Expect(1, 12032, '\p{^ _In_CJK_Radicals_Supplement}', "");
    Expect(1, 12032, '\P{ _In_CJK_Radicals_Supplement}', "");
    Expect(0, 12032, '\P{^ _In_CJK_Radicals_Supplement}', "");
    Error('\p{/a/-cjk_RADICALS_SUP}');
    Error('\P{/a/-cjk_RADICALS_SUP}');
    Expect(1, 12031, '\p{cjkradicalssup}', "");
    Expect(0, 12031, '\p{^cjkradicalssup}', "");
    Expect(0, 12031, '\P{cjkradicalssup}', "");
    Expect(1, 12031, '\P{^cjkradicalssup}', "");
    Expect(0, 12032, '\p{cjkradicalssup}', "");
    Expect(1, 12032, '\p{^cjkradicalssup}', "");
    Expect(1, 12032, '\P{cjkradicalssup}', "");
    Expect(0, 12032, '\P{^cjkradicalssup}', "");
    Expect(1, 12031, '\p{- CJK_RADICALS_SUP}', "");
    Expect(0, 12031, '\p{^- CJK_RADICALS_SUP}', "");
    Expect(0, 12031, '\P{- CJK_RADICALS_SUP}', "");
    Expect(1, 12031, '\P{^- CJK_RADICALS_SUP}', "");
    Expect(0, 12032, '\p{- CJK_RADICALS_SUP}', "");
    Expect(1, 12032, '\p{^- CJK_RADICALS_SUP}', "");
    Expect(1, 12032, '\P{- CJK_RADICALS_SUP}', "");
    Expect(0, 12032, '\P{^- CJK_RADICALS_SUP}', "");
    Error('\p{:=-	IS_CJK_Radicals_Sup}');
    Error('\P{:=-	IS_CJK_Radicals_Sup}');
    Expect(1, 12031, '\p{iscjkradicalssup}', "");
    Expect(0, 12031, '\p{^iscjkradicalssup}', "");
    Expect(0, 12031, '\P{iscjkradicalssup}', "");
    Expect(1, 12031, '\P{^iscjkradicalssup}', "");
    Expect(0, 12032, '\p{iscjkradicalssup}', "");
    Expect(1, 12032, '\p{^iscjkradicalssup}', "");
    Expect(1, 12032, '\P{iscjkradicalssup}', "");
    Expect(0, 12032, '\P{^iscjkradicalssup}', "");
    Expect(1, 12031, '\p{	Is_CJK_RADICALS_Sup}', "");
    Expect(0, 12031, '\p{^	Is_CJK_RADICALS_Sup}', "");
    Expect(0, 12031, '\P{	Is_CJK_RADICALS_Sup}', "");
    Expect(1, 12031, '\P{^	Is_CJK_RADICALS_Sup}', "");
    Expect(0, 12032, '\p{	Is_CJK_RADICALS_Sup}', "");
    Expect(1, 12032, '\p{^	Is_CJK_RADICALS_Sup}', "");
    Expect(1, 12032, '\P{	Is_CJK_RADICALS_Sup}', "");
    Expect(0, 12032, '\P{^	Is_CJK_RADICALS_Sup}', "");
    Error('\p{_ in_CJK_RADICALS_SUP/a/}');
    Error('\P{_ in_CJK_RADICALS_SUP/a/}');
    Expect(1, 12031, '\p{incjkradicalssup}', "");
    Expect(0, 12031, '\p{^incjkradicalssup}', "");
    Expect(0, 12031, '\P{incjkradicalssup}', "");
    Expect(1, 12031, '\P{^incjkradicalssup}', "");
    Expect(0, 12032, '\p{incjkradicalssup}', "");
    Expect(1, 12032, '\p{^incjkradicalssup}', "");
    Expect(1, 12032, '\P{incjkradicalssup}', "");
    Expect(0, 12032, '\P{^incjkradicalssup}', "");
    Expect(1, 12031, '\p{_ IN_cjk_radicals_SUP}', "");
    Expect(0, 12031, '\p{^_ IN_cjk_radicals_SUP}', "");
    Expect(0, 12031, '\P{_ IN_cjk_radicals_SUP}', "");
    Expect(1, 12031, '\P{^_ IN_cjk_radicals_SUP}', "");
    Expect(0, 12032, '\p{_ IN_cjk_radicals_SUP}', "");
    Expect(1, 12032, '\p{^_ IN_cjk_radicals_SUP}', "");
    Expect(1, 12032, '\P{_ IN_cjk_radicals_SUP}', "");
    Expect(0, 12032, '\P{^_ IN_cjk_radicals_SUP}', "");
    Error('\p{/a/	cjk_STROKES}');
    Error('\P{/a/	cjk_STROKES}');
    Expect(1, 12783, '\p{cjkstrokes}', "");
    Expect(0, 12783, '\p{^cjkstrokes}', "");
    Expect(0, 12783, '\P{cjkstrokes}', "");
    Expect(1, 12783, '\P{^cjkstrokes}', "");
    Expect(0, 12784, '\p{cjkstrokes}', "");
    Expect(1, 12784, '\p{^cjkstrokes}', "");
    Expect(1, 12784, '\P{cjkstrokes}', "");
    Expect(0, 12784, '\P{^cjkstrokes}', "");
    Expect(1, 12783, '\p{_-CJK_strokes}', "");
    Expect(0, 12783, '\p{^_-CJK_strokes}', "");
    Expect(0, 12783, '\P{_-CJK_strokes}', "");
    Expect(1, 12783, '\P{^_-CJK_strokes}', "");
    Expect(0, 12784, '\p{_-CJK_strokes}', "");
    Expect(1, 12784, '\p{^_-CJK_strokes}', "");
    Expect(1, 12784, '\P{_-CJK_strokes}', "");
    Expect(0, 12784, '\P{^_-CJK_strokes}', "");
    Error('\p{ :=Is_CJK_Strokes}');
    Error('\P{ :=Is_CJK_Strokes}');
    Expect(1, 12783, '\p{iscjkstrokes}', "");
    Expect(0, 12783, '\p{^iscjkstrokes}', "");
    Expect(0, 12783, '\P{iscjkstrokes}', "");
    Expect(1, 12783, '\P{^iscjkstrokes}', "");
    Expect(0, 12784, '\p{iscjkstrokes}', "");
    Expect(1, 12784, '\p{^iscjkstrokes}', "");
    Expect(1, 12784, '\P{iscjkstrokes}', "");
    Expect(0, 12784, '\P{^iscjkstrokes}', "");
    Expect(1, 12783, '\p{__Is_cjk_Strokes}', "");
    Expect(0, 12783, '\p{^__Is_cjk_Strokes}', "");
    Expect(0, 12783, '\P{__Is_cjk_Strokes}', "");
    Expect(1, 12783, '\P{^__Is_cjk_Strokes}', "");
    Expect(0, 12784, '\p{__Is_cjk_Strokes}', "");
    Expect(1, 12784, '\p{^__Is_cjk_Strokes}', "");
    Expect(1, 12784, '\P{__Is_cjk_Strokes}', "");
    Expect(0, 12784, '\P{^__Is_cjk_Strokes}', "");
    Error('\p{_/a/IN_CJK_Strokes}');
    Error('\P{_/a/IN_CJK_Strokes}');
    Expect(1, 12783, '\p{incjkstrokes}', "");
    Expect(0, 12783, '\p{^incjkstrokes}', "");
    Expect(0, 12783, '\P{incjkstrokes}', "");
    Expect(1, 12783, '\P{^incjkstrokes}', "");
    Expect(0, 12784, '\p{incjkstrokes}', "");
    Expect(1, 12784, '\p{^incjkstrokes}', "");
    Expect(1, 12784, '\P{incjkstrokes}', "");
    Expect(0, 12784, '\P{^incjkstrokes}', "");
    Expect(1, 12783, '\p{--In_CJK_Strokes}', "");
    Expect(0, 12783, '\p{^--In_CJK_Strokes}', "");
    Expect(0, 12783, '\P{--In_CJK_Strokes}', "");
    Expect(1, 12783, '\P{^--In_CJK_Strokes}', "");
    Expect(0, 12784, '\p{--In_CJK_Strokes}', "");
    Expect(1, 12784, '\p{^--In_CJK_Strokes}', "");
    Expect(1, 12784, '\P{--In_CJK_Strokes}', "");
    Expect(0, 12784, '\P{^--In_CJK_Strokes}', "");
    Error('\p{-:=cjk_symbols_And_Punctuation}');
    Error('\P{-:=cjk_symbols_And_Punctuation}');
    Expect(1, 12351, '\p{cjksymbolsandpunctuation}', "");
    Expect(0, 12351, '\p{^cjksymbolsandpunctuation}', "");
    Expect(0, 12351, '\P{cjksymbolsandpunctuation}', "");
    Expect(1, 12351, '\P{^cjksymbolsandpunctuation}', "");
    Expect(0, 12352, '\p{cjksymbolsandpunctuation}', "");
    Expect(1, 12352, '\p{^cjksymbolsandpunctuation}', "");
    Expect(1, 12352, '\P{cjksymbolsandpunctuation}', "");
    Expect(0, 12352, '\P{^cjksymbolsandpunctuation}', "");
    Expect(1, 12351, '\p{-	CJK_Symbols_and_Punctuation}', "");
    Expect(0, 12351, '\p{^-	CJK_Symbols_and_Punctuation}', "");
    Expect(0, 12351, '\P{-	CJK_Symbols_and_Punctuation}', "");
    Expect(1, 12351, '\P{^-	CJK_Symbols_and_Punctuation}', "");
    Expect(0, 12352, '\p{-	CJK_Symbols_and_Punctuation}', "");
    Expect(1, 12352, '\p{^-	CJK_Symbols_and_Punctuation}', "");
    Expect(1, 12352, '\P{-	CJK_Symbols_and_Punctuation}', "");
    Expect(0, 12352, '\P{^-	CJK_Symbols_and_Punctuation}', "");
    Error('\p{:=_IS_cjk_Symbols_AND_punctuation}');
    Error('\P{:=_IS_cjk_Symbols_AND_punctuation}');
    Expect(1, 12351, '\p{iscjksymbolsandpunctuation}', "");
    Expect(0, 12351, '\p{^iscjksymbolsandpunctuation}', "");
    Expect(0, 12351, '\P{iscjksymbolsandpunctuation}', "");
    Expect(1, 12351, '\P{^iscjksymbolsandpunctuation}', "");
    Expect(0, 12352, '\p{iscjksymbolsandpunctuation}', "");
    Expect(1, 12352, '\p{^iscjksymbolsandpunctuation}', "");
    Expect(1, 12352, '\P{iscjksymbolsandpunctuation}', "");
    Expect(0, 12352, '\P{^iscjksymbolsandpunctuation}', "");
    Expect(1, 12351, '\p{- Is_CJK_Symbols_and_Punctuation}', "");
    Expect(0, 12351, '\p{^- Is_CJK_Symbols_and_Punctuation}', "");
    Expect(0, 12351, '\P{- Is_CJK_Symbols_and_Punctuation}', "");
    Expect(1, 12351, '\P{^- Is_CJK_Symbols_and_Punctuation}', "");
    Expect(0, 12352, '\p{- Is_CJK_Symbols_and_Punctuation}', "");
    Expect(1, 12352, '\p{^- Is_CJK_Symbols_and_Punctuation}', "");
    Expect(1, 12352, '\P{- Is_CJK_Symbols_and_Punctuation}', "");
    Expect(0, 12352, '\P{^- Is_CJK_Symbols_and_Punctuation}', "");
    Error('\p{:=_In_CJK_symbols_And_PUNCTUATION}');
    Error('\P{:=_In_CJK_symbols_And_PUNCTUATION}');
    Expect(1, 12351, '\p{incjksymbolsandpunctuation}', "");
    Expect(0, 12351, '\p{^incjksymbolsandpunctuation}', "");
    Expect(0, 12351, '\P{incjksymbolsandpunctuation}', "");
    Expect(1, 12351, '\P{^incjksymbolsandpunctuation}', "");
    Expect(0, 12352, '\p{incjksymbolsandpunctuation}', "");
    Expect(1, 12352, '\p{^incjksymbolsandpunctuation}', "");
    Expect(1, 12352, '\P{incjksymbolsandpunctuation}', "");
    Expect(0, 12352, '\P{^incjksymbolsandpunctuation}', "");
    Expect(1, 12351, '\p{ 	In_cjk_symbols_and_Punctuation}', "");
    Expect(0, 12351, '\p{^ 	In_cjk_symbols_and_Punctuation}', "");
    Expect(0, 12351, '\P{ 	In_cjk_symbols_and_Punctuation}', "");
    Expect(1, 12351, '\P{^ 	In_cjk_symbols_and_Punctuation}', "");
    Expect(0, 12352, '\p{ 	In_cjk_symbols_and_Punctuation}', "");
    Expect(1, 12352, '\p{^ 	In_cjk_symbols_and_Punctuation}', "");
    Expect(1, 12352, '\P{ 	In_cjk_symbols_and_Punctuation}', "");
    Expect(0, 12352, '\P{^ 	In_cjk_symbols_and_Punctuation}', "");
    Error('\p{/a/ _CJK_symbols}');
    Error('\P{/a/ _CJK_symbols}');
    Expect(1, 12351, '\p{cjksymbols}', "");
    Expect(0, 12351, '\p{^cjksymbols}', "");
    Expect(0, 12351, '\P{cjksymbols}', "");
    Expect(1, 12351, '\P{^cjksymbols}', "");
    Expect(0, 12352, '\p{cjksymbols}', "");
    Expect(1, 12352, '\p{^cjksymbols}', "");
    Expect(1, 12352, '\P{cjksymbols}', "");
    Expect(0, 12352, '\P{^cjksymbols}', "");
    Expect(1, 12351, '\p{ -cjk_symbols}', "");
    Expect(0, 12351, '\p{^ -cjk_symbols}', "");
    Expect(0, 12351, '\P{ -cjk_symbols}', "");
    Expect(1, 12351, '\P{^ -cjk_symbols}', "");
    Expect(0, 12352, '\p{ -cjk_symbols}', "");
    Expect(1, 12352, '\p{^ -cjk_symbols}', "");
    Expect(1, 12352, '\P{ -cjk_symbols}', "");
    Expect(0, 12352, '\P{^ -cjk_symbols}', "");
    Error('\p{	-IS_CJK_Symbols:=}');
    Error('\P{	-IS_CJK_Symbols:=}');
    Expect(1, 12351, '\p{iscjksymbols}', "");
    Expect(0, 12351, '\p{^iscjksymbols}', "");
    Expect(0, 12351, '\P{iscjksymbols}', "");
    Expect(1, 12351, '\P{^iscjksymbols}', "");
    Expect(0, 12352, '\p{iscjksymbols}', "");
    Expect(1, 12352, '\p{^iscjksymbols}', "");
    Expect(1, 12352, '\P{iscjksymbols}', "");
    Expect(0, 12352, '\P{^iscjksymbols}', "");
    Expect(1, 12351, '\p{ 	Is_CJK_Symbols}', "");
    Expect(0, 12351, '\p{^ 	Is_CJK_Symbols}', "");
    Expect(0, 12351, '\P{ 	Is_CJK_Symbols}', "");
    Expect(1, 12351, '\P{^ 	Is_CJK_Symbols}', "");
    Expect(0, 12352, '\p{ 	Is_CJK_Symbols}', "");
    Expect(1, 12352, '\p{^ 	Is_CJK_Symbols}', "");
    Expect(1, 12352, '\P{ 	Is_CJK_Symbols}', "");
    Expect(0, 12352, '\P{^ 	Is_CJK_Symbols}', "");
    Error('\p{	:=in_CJK_symbols}');
    Error('\P{	:=in_CJK_symbols}');
    Expect(1, 12351, '\p{incjksymbols}', "");
    Expect(0, 12351, '\p{^incjksymbols}', "");
    Expect(0, 12351, '\P{incjksymbols}', "");
    Expect(1, 12351, '\P{^incjksymbols}', "");
    Expect(0, 12352, '\p{incjksymbols}', "");
    Expect(1, 12352, '\p{^incjksymbols}', "");
    Expect(1, 12352, '\P{incjksymbols}', "");
    Expect(0, 12352, '\P{^incjksymbols}', "");
    Expect(1, 12351, '\p{-In_cjk_Symbols}', "");
    Expect(0, 12351, '\p{^-In_cjk_Symbols}', "");
    Expect(0, 12351, '\P{-In_cjk_Symbols}', "");
    Expect(1, 12351, '\P{^-In_cjk_Symbols}', "");
    Expect(0, 12352, '\p{-In_cjk_Symbols}', "");
    Expect(1, 12352, '\p{^-In_cjk_Symbols}', "");
    Expect(1, 12352, '\P{-In_cjk_Symbols}', "");
    Expect(0, 12352, '\P{^-In_cjk_Symbols}', "");
    Error('\p{/a/		cjk_unified_IDEOGRAPHS}');
    Error('\P{/a/		cjk_unified_IDEOGRAPHS}');
    Expect(1, 40959, '\p{cjkunifiedideographs}', "");
    Expect(0, 40959, '\p{^cjkunifiedideographs}', "");
    Expect(0, 40959, '\P{cjkunifiedideographs}', "");
    Expect(1, 40959, '\P{^cjkunifiedideographs}', "");
    Expect(0, 40960, '\p{cjkunifiedideographs}', "");
    Expect(1, 40960, '\p{^cjkunifiedideographs}', "");
    Expect(1, 40960, '\P{cjkunifiedideographs}', "");
    Expect(0, 40960, '\P{^cjkunifiedideographs}', "");
    Expect(1, 40959, '\p{- CJK_Unified_ideographs}', "");
    Expect(0, 40959, '\p{^- CJK_Unified_ideographs}', "");
    Expect(0, 40959, '\P{- CJK_Unified_ideographs}', "");
    Expect(1, 40959, '\P{^- CJK_Unified_ideographs}', "");
    Expect(0, 40960, '\p{- CJK_Unified_ideographs}', "");
    Expect(1, 40960, '\p{^- CJK_Unified_ideographs}', "");
    Expect(1, 40960, '\P{- CJK_Unified_ideographs}', "");
    Expect(0, 40960, '\P{^- CJK_Unified_ideographs}', "");
    Error('\p{-	Is_CJK_Unified_Ideographs:=}');
    Error('\P{-	Is_CJK_Unified_Ideographs:=}');
    Expect(1, 40959, '\p{iscjkunifiedideographs}', "");
    Expect(0, 40959, '\p{^iscjkunifiedideographs}', "");
    Expect(0, 40959, '\P{iscjkunifiedideographs}', "");
    Expect(1, 40959, '\P{^iscjkunifiedideographs}', "");
    Expect(0, 40960, '\p{iscjkunifiedideographs}', "");
    Expect(1, 40960, '\p{^iscjkunifiedideographs}', "");
    Expect(1, 40960, '\P{iscjkunifiedideographs}', "");
    Expect(0, 40960, '\P{^iscjkunifiedideographs}', "");
    Expect(1, 40959, '\p{ is_CJK_Unified_Ideographs}', "");
    Expect(0, 40959, '\p{^ is_CJK_Unified_Ideographs}', "");
    Expect(0, 40959, '\P{ is_CJK_Unified_Ideographs}', "");
    Expect(1, 40959, '\P{^ is_CJK_Unified_Ideographs}', "");
    Expect(0, 40960, '\p{ is_CJK_Unified_Ideographs}', "");
    Expect(1, 40960, '\p{^ is_CJK_Unified_Ideographs}', "");
    Expect(1, 40960, '\P{ is_CJK_Unified_Ideographs}', "");
    Expect(0, 40960, '\P{^ is_CJK_Unified_Ideographs}', "");
    Error('\p{_-IN_CJK_unified_ideographs/a/}');
    Error('\P{_-IN_CJK_unified_ideographs/a/}');
    Expect(1, 40959, '\p{incjkunifiedideographs}', "");
    Expect(0, 40959, '\p{^incjkunifiedideographs}', "");
    Expect(0, 40959, '\P{incjkunifiedideographs}', "");
    Expect(1, 40959, '\P{^incjkunifiedideographs}', "");
    Expect(0, 40960, '\p{incjkunifiedideographs}', "");
    Expect(1, 40960, '\p{^incjkunifiedideographs}', "");
    Expect(1, 40960, '\P{incjkunifiedideographs}', "");
    Expect(0, 40960, '\P{^incjkunifiedideographs}', "");
    Expect(1, 40959, '\p{- In_CJK_Unified_ideographs}', "");
    Expect(0, 40959, '\p{^- In_CJK_Unified_ideographs}', "");
    Expect(0, 40959, '\P{- In_CJK_Unified_ideographs}', "");
    Expect(1, 40959, '\P{^- In_CJK_Unified_ideographs}', "");
    Expect(0, 40960, '\p{- In_CJK_Unified_ideographs}', "");
    Expect(1, 40960, '\p{^- In_CJK_Unified_ideographs}', "");
    Expect(1, 40960, '\P{- In_CJK_Unified_ideographs}', "");
    Expect(0, 40960, '\P{^- In_CJK_Unified_ideographs}', "");
    Error('\p{:=		CJK}');
    Error('\P{:=		CJK}');
    Expect(1, 40959, '\p{cjk}', "");
    Expect(0, 40959, '\p{^cjk}', "");
    Expect(0, 40959, '\P{cjk}', "");
    Expect(1, 40959, '\P{^cjk}', "");
    Expect(0, 40960, '\p{cjk}', "");
    Expect(1, 40960, '\p{^cjk}', "");
    Expect(1, 40960, '\P{cjk}', "");
    Expect(0, 40960, '\P{^cjk}', "");
    Expect(1, 40959, '\p{-CJK}', "");
    Expect(0, 40959, '\p{^-CJK}', "");
    Expect(0, 40959, '\P{-CJK}', "");
    Expect(1, 40959, '\P{^-CJK}', "");
    Expect(0, 40960, '\p{-CJK}', "");
    Expect(1, 40960, '\p{^-CJK}', "");
    Expect(1, 40960, '\P{-CJK}', "");
    Expect(0, 40960, '\P{^-CJK}', "");
    Error('\p{-Is_cjk:=}');
    Error('\P{-Is_cjk:=}');
    Expect(1, 40959, '\p{iscjk}', "");
    Expect(0, 40959, '\p{^iscjk}', "");
    Expect(0, 40959, '\P{iscjk}', "");
    Expect(1, 40959, '\P{^iscjk}', "");
    Expect(0, 40960, '\p{iscjk}', "");
    Expect(1, 40960, '\p{^iscjk}', "");
    Expect(1, 40960, '\P{iscjk}', "");
    Expect(0, 40960, '\P{^iscjk}', "");
    Expect(1, 40959, '\p{IS_cjk}', "");
    Expect(0, 40959, '\p{^IS_cjk}', "");
    Expect(0, 40959, '\P{IS_cjk}', "");
    Expect(1, 40959, '\P{^IS_cjk}', "");
    Expect(0, 40960, '\p{IS_cjk}', "");
    Expect(1, 40960, '\p{^IS_cjk}', "");
    Expect(1, 40960, '\P{IS_cjk}', "");
    Expect(0, 40960, '\P{^IS_cjk}', "");
    Error('\p{	:=In_cjk}');
    Error('\P{	:=In_cjk}');
    Expect(1, 40959, '\p{incjk}', "");
    Expect(0, 40959, '\p{^incjk}', "");
    Expect(0, 40959, '\P{incjk}', "");
    Expect(1, 40959, '\P{^incjk}', "");
    Expect(0, 40960, '\p{incjk}', "");
    Expect(1, 40960, '\p{^incjk}', "");
    Expect(1, 40960, '\P{incjk}', "");
    Expect(0, 40960, '\P{^incjk}', "");
    Expect(1, 40959, '\p{-In_CJK}', "");
    Expect(0, 40959, '\p{^-In_CJK}', "");
    Expect(0, 40959, '\P{-In_CJK}', "");
    Expect(1, 40959, '\P{^-In_CJK}', "");
    Expect(0, 40960, '\p{-In_CJK}', "");
    Expect(1, 40960, '\p{^-In_CJK}', "");
    Expect(1, 40960, '\P{-In_CJK}', "");
    Expect(0, 40960, '\P{^-In_CJK}', "");
    Error('\p{_/a/CJK_unified_Ideographs_extension_a}');
    Error('\P{_/a/CJK_unified_Ideographs_extension_a}');
    Expect(1, 19903, '\p{cjkunifiedideographsextensiona}', "");
    Expect(0, 19903, '\p{^cjkunifiedideographsextensiona}', "");
    Expect(0, 19903, '\P{cjkunifiedideographsextensiona}', "");
    Expect(1, 19903, '\P{^cjkunifiedideographsextensiona}', "");
    Expect(0, 19904, '\p{cjkunifiedideographsextensiona}', "");
    Expect(1, 19904, '\p{^cjkunifiedideographsextensiona}', "");
    Expect(1, 19904, '\P{cjkunifiedideographsextensiona}', "");
    Expect(0, 19904, '\P{^cjkunifiedideographsextensiona}', "");
    Expect(1, 19903, '\p{_-CJK_Unified_Ideographs_EXTENSION_A}', "");
    Expect(0, 19903, '\p{^_-CJK_Unified_Ideographs_EXTENSION_A}', "");
    Expect(0, 19903, '\P{_-CJK_Unified_Ideographs_EXTENSION_A}', "");
    Expect(1, 19903, '\P{^_-CJK_Unified_Ideographs_EXTENSION_A}', "");
    Expect(0, 19904, '\p{_-CJK_Unified_Ideographs_EXTENSION_A}', "");
    Expect(1, 19904, '\p{^_-CJK_Unified_Ideographs_EXTENSION_A}', "");
    Expect(1, 19904, '\P{_-CJK_Unified_Ideographs_EXTENSION_A}', "");
    Expect(0, 19904, '\P{^_-CJK_Unified_Ideographs_EXTENSION_A}', "");
    Error('\p{_	IS_CJK_unified_ideographs_extension_A/a/}');
    Error('\P{_	IS_CJK_unified_ideographs_extension_A/a/}');
    Expect(1, 19903, '\p{iscjkunifiedideographsextensiona}', "");
    Expect(0, 19903, '\p{^iscjkunifiedideographsextensiona}', "");
    Expect(0, 19903, '\P{iscjkunifiedideographsextensiona}', "");
    Expect(1, 19903, '\P{^iscjkunifiedideographsextensiona}', "");
    Expect(0, 19904, '\p{iscjkunifiedideographsextensiona}', "");
    Expect(1, 19904, '\p{^iscjkunifiedideographsextensiona}', "");
    Expect(1, 19904, '\P{iscjkunifiedideographsextensiona}', "");
    Expect(0, 19904, '\P{^iscjkunifiedideographsextensiona}', "");
    Expect(1, 19903, '\p{_Is_cjk_UNIFIED_Ideographs_extension_A}', "");
    Expect(0, 19903, '\p{^_Is_cjk_UNIFIED_Ideographs_extension_A}', "");
    Expect(0, 19903, '\P{_Is_cjk_UNIFIED_Ideographs_extension_A}', "");
    Expect(1, 19903, '\P{^_Is_cjk_UNIFIED_Ideographs_extension_A}', "");
    Expect(0, 19904, '\p{_Is_cjk_UNIFIED_Ideographs_extension_A}', "");
    Expect(1, 19904, '\p{^_Is_cjk_UNIFIED_Ideographs_extension_A}', "");
    Expect(1, 19904, '\P{_Is_cjk_UNIFIED_Ideographs_extension_A}', "");
    Expect(0, 19904, '\P{^_Is_cjk_UNIFIED_Ideographs_extension_A}', "");
    Error('\p{_/a/In_CJK_unified_ideographs_Extension_A}');
    Error('\P{_/a/In_CJK_unified_ideographs_Extension_A}');
    Expect(1, 19903, '\p{incjkunifiedideographsextensiona}', "");
    Expect(0, 19903, '\p{^incjkunifiedideographsextensiona}', "");
    Expect(0, 19903, '\P{incjkunifiedideographsextensiona}', "");
    Expect(1, 19903, '\P{^incjkunifiedideographsextensiona}', "");
    Expect(0, 19904, '\p{incjkunifiedideographsextensiona}', "");
    Expect(1, 19904, '\p{^incjkunifiedideographsextensiona}', "");
    Expect(1, 19904, '\P{incjkunifiedideographsextensiona}', "");
    Expect(0, 19904, '\P{^incjkunifiedideographsextensiona}', "");
    Expect(1, 19903, '\p{		in_cjk_Unified_IDEOGRAPHS_extension_A}', "");
    Expect(0, 19903, '\p{^		in_cjk_Unified_IDEOGRAPHS_extension_A}', "");
    Expect(0, 19903, '\P{		in_cjk_Unified_IDEOGRAPHS_extension_A}', "");
    Expect(1, 19903, '\P{^		in_cjk_Unified_IDEOGRAPHS_extension_A}', "");
    Expect(0, 19904, '\p{		in_cjk_Unified_IDEOGRAPHS_extension_A}', "");
    Expect(1, 19904, '\p{^		in_cjk_Unified_IDEOGRAPHS_extension_A}', "");
    Expect(1, 19904, '\P{		in_cjk_Unified_IDEOGRAPHS_extension_A}', "");
    Expect(0, 19904, '\P{^		in_cjk_Unified_IDEOGRAPHS_extension_A}', "");
    Error('\p{	:=CJK_EXT_a}');
    Error('\P{	:=CJK_EXT_a}');
    Expect(1, 19903, '\p{cjkexta}', "");
    Expect(0, 19903, '\p{^cjkexta}', "");
    Expect(0, 19903, '\P{cjkexta}', "");
    Expect(1, 19903, '\P{^cjkexta}', "");
    Expect(0, 19904, '\p{cjkexta}', "");
    Expect(1, 19904, '\p{^cjkexta}', "");
    Expect(1, 19904, '\P{cjkexta}', "");
    Expect(0, 19904, '\P{^cjkexta}', "");
    Expect(1, 19903, '\p{	_CJK_EXT_A}', "");
    Expect(0, 19903, '\p{^	_CJK_EXT_A}', "");
    Expect(0, 19903, '\P{	_CJK_EXT_A}', "");
    Expect(1, 19903, '\P{^	_CJK_EXT_A}', "");
    Expect(0, 19904, '\p{	_CJK_EXT_A}', "");
    Expect(1, 19904, '\p{^	_CJK_EXT_A}', "");
    Expect(1, 19904, '\P{	_CJK_EXT_A}', "");
    Expect(0, 19904, '\P{^	_CJK_EXT_A}', "");
    Error('\p{_ Is_CJK_Ext_A/a/}');
    Error('\P{_ Is_CJK_Ext_A/a/}');
    Expect(1, 19903, '\p{iscjkexta}', "");
    Expect(0, 19903, '\p{^iscjkexta}', "");
    Expect(0, 19903, '\P{iscjkexta}', "");
    Expect(1, 19903, '\P{^iscjkexta}', "");
    Expect(0, 19904, '\p{iscjkexta}', "");
    Expect(1, 19904, '\p{^iscjkexta}', "");
    Expect(1, 19904, '\P{iscjkexta}', "");
    Expect(0, 19904, '\P{^iscjkexta}', "");
    Expect(1, 19903, '\p{	Is_CJK_Ext_a}', "");
    Expect(0, 19903, '\p{^	Is_CJK_Ext_a}', "");
    Expect(0, 19903, '\P{	Is_CJK_Ext_a}', "");
    Expect(1, 19903, '\P{^	Is_CJK_Ext_a}', "");
    Expect(0, 19904, '\p{	Is_CJK_Ext_a}', "");
    Expect(1, 19904, '\p{^	Is_CJK_Ext_a}', "");
    Expect(1, 19904, '\P{	Is_CJK_Ext_a}', "");
    Expect(0, 19904, '\P{^	Is_CJK_Ext_a}', "");
    Error('\p{	 In_cjk_EXT_a/a/}');
    Error('\P{	 In_cjk_EXT_a/a/}');
    Expect(1, 19903, '\p{incjkexta}', "");
    Expect(0, 19903, '\p{^incjkexta}', "");
    Expect(0, 19903, '\P{incjkexta}', "");
    Expect(1, 19903, '\P{^incjkexta}', "");
    Expect(0, 19904, '\p{incjkexta}', "");
    Expect(1, 19904, '\p{^incjkexta}', "");
    Expect(1, 19904, '\P{incjkexta}', "");
    Expect(0, 19904, '\P{^incjkexta}', "");
    Expect(1, 19903, '\p{	in_cjk_EXT_A}', "");
    Expect(0, 19903, '\p{^	in_cjk_EXT_A}', "");
    Expect(0, 19903, '\P{	in_cjk_EXT_A}', "");
    Expect(1, 19903, '\P{^	in_cjk_EXT_A}', "");
    Expect(0, 19904, '\p{	in_cjk_EXT_A}', "");
    Expect(1, 19904, '\p{^	in_cjk_EXT_A}', "");
    Expect(1, 19904, '\P{	in_cjk_EXT_A}', "");
    Expect(0, 19904, '\P{^	in_cjk_EXT_A}', "");
    Error('\p{:=	-CJK_unified_ideographs_extension_B}');
    Error('\P{:=	-CJK_unified_ideographs_extension_B}');
    Expect(1, 173791, '\p{cjkunifiedideographsextensionb}', "");
    Expect(0, 173791, '\p{^cjkunifiedideographsextensionb}', "");
    Expect(0, 173791, '\P{cjkunifiedideographsextensionb}', "");
    Expect(1, 173791, '\P{^cjkunifiedideographsextensionb}', "");
    Expect(0, 173792, '\p{cjkunifiedideographsextensionb}', "");
    Expect(1, 173792, '\p{^cjkunifiedideographsextensionb}', "");
    Expect(1, 173792, '\P{cjkunifiedideographsextensionb}', "");
    Expect(0, 173792, '\P{^cjkunifiedideographsextensionb}', "");
    Expect(1, 173791, '\p{_CJK_UNIFIED_ideographs_Extension_b}', "");
    Expect(0, 173791, '\p{^_CJK_UNIFIED_ideographs_Extension_b}', "");
    Expect(0, 173791, '\P{_CJK_UNIFIED_ideographs_Extension_b}', "");
    Expect(1, 173791, '\P{^_CJK_UNIFIED_ideographs_Extension_b}', "");
    Expect(0, 173792, '\p{_CJK_UNIFIED_ideographs_Extension_b}', "");
    Expect(1, 173792, '\p{^_CJK_UNIFIED_ideographs_Extension_b}', "");
    Expect(1, 173792, '\P{_CJK_UNIFIED_ideographs_Extension_b}', "");
    Expect(0, 173792, '\P{^_CJK_UNIFIED_ideographs_Extension_b}', "");
    Error('\p{:=_Is_CJK_Unified_ideographs_Extension_B}');
    Error('\P{:=_Is_CJK_Unified_ideographs_Extension_B}');
    Expect(1, 173791, '\p{iscjkunifiedideographsextensionb}', "");
    Expect(0, 173791, '\p{^iscjkunifiedideographsextensionb}', "");
    Expect(0, 173791, '\P{iscjkunifiedideographsextensionb}', "");
    Expect(1, 173791, '\P{^iscjkunifiedideographsextensionb}', "");
    Expect(0, 173792, '\p{iscjkunifiedideographsextensionb}', "");
    Expect(1, 173792, '\p{^iscjkunifiedideographsextensionb}', "");
    Expect(1, 173792, '\P{iscjkunifiedideographsextensionb}', "");
    Expect(0, 173792, '\P{^iscjkunifiedideographsextensionb}', "");
    Expect(1, 173791, '\p{Is_CJK_Unified_Ideographs_Extension_B}', "");
    Expect(0, 173791, '\p{^Is_CJK_Unified_Ideographs_Extension_B}', "");
    Expect(0, 173791, '\P{Is_CJK_Unified_Ideographs_Extension_B}', "");
    Expect(1, 173791, '\P{^Is_CJK_Unified_Ideographs_Extension_B}', "");
    Expect(0, 173792, '\p{Is_CJK_Unified_Ideographs_Extension_B}', "");
    Expect(1, 173792, '\p{^Is_CJK_Unified_Ideographs_Extension_B}', "");
    Expect(1, 173792, '\P{Is_CJK_Unified_Ideographs_Extension_B}', "");
    Expect(0, 173792, '\P{^Is_CJK_Unified_Ideographs_Extension_B}', "");
    Error('\p{ :=In_CJK_Unified_IDEOGRAPHS_Extension_B}');
    Error('\P{ :=In_CJK_Unified_IDEOGRAPHS_Extension_B}');
    Expect(1, 173791, '\p{incjkunifiedideographsextensionb}', "");
    Expect(0, 173791, '\p{^incjkunifiedideographsextensionb}', "");
    Expect(0, 173791, '\P{incjkunifiedideographsextensionb}', "");
    Expect(1, 173791, '\P{^incjkunifiedideographsextensionb}', "");
    Expect(0, 173792, '\p{incjkunifiedideographsextensionb}', "");
    Expect(1, 173792, '\p{^incjkunifiedideographsextensionb}', "");
    Expect(1, 173792, '\P{incjkunifiedideographsextensionb}', "");
    Expect(0, 173792, '\P{^incjkunifiedideographsextensionb}', "");
    Expect(1, 173791, '\p{  In_CJK_Unified_Ideographs_Extension_B}', "");
    Expect(0, 173791, '\p{^  In_CJK_Unified_Ideographs_Extension_B}', "");
    Expect(0, 173791, '\P{  In_CJK_Unified_Ideographs_Extension_B}', "");
    Expect(1, 173791, '\P{^  In_CJK_Unified_Ideographs_Extension_B}', "");
    Expect(0, 173792, '\p{  In_CJK_Unified_Ideographs_Extension_B}', "");
    Expect(1, 173792, '\p{^  In_CJK_Unified_Ideographs_Extension_B}', "");
    Expect(1, 173792, '\P{  In_CJK_Unified_Ideographs_Extension_B}', "");
    Expect(0, 173792, '\P{^  In_CJK_Unified_Ideographs_Extension_B}', "");
    Error('\p{/a/CJK_Ext_B}');
    Error('\P{/a/CJK_Ext_B}');
    Expect(1, 173791, '\p{cjkextb}', "");
    Expect(0, 173791, '\p{^cjkextb}', "");
    Expect(0, 173791, '\P{cjkextb}', "");
    Expect(1, 173791, '\P{^cjkextb}', "");
    Expect(0, 173792, '\p{cjkextb}', "");
    Expect(1, 173792, '\p{^cjkextb}', "");
    Expect(1, 173792, '\P{cjkextb}', "");
    Expect(0, 173792, '\P{^cjkextb}', "");
    Expect(1, 173791, '\p{	CJK_EXT_B}', "");
    Expect(0, 173791, '\p{^	CJK_EXT_B}', "");
    Expect(0, 173791, '\P{	CJK_EXT_B}', "");
    Expect(1, 173791, '\P{^	CJK_EXT_B}', "");
    Expect(0, 173792, '\p{	CJK_EXT_B}', "");
    Expect(1, 173792, '\p{^	CJK_EXT_B}', "");
    Expect(1, 173792, '\P{	CJK_EXT_B}', "");
    Expect(0, 173792, '\P{^	CJK_EXT_B}', "");
    Error('\p{	:=is_CJK_EXT_B}');
    Error('\P{	:=is_CJK_EXT_B}');
    Expect(1, 173791, '\p{iscjkextb}', "");
    Expect(0, 173791, '\p{^iscjkextb}', "");
    Expect(0, 173791, '\P{iscjkextb}', "");
    Expect(1, 173791, '\P{^iscjkextb}', "");
    Expect(0, 173792, '\p{iscjkextb}', "");
    Expect(1, 173792, '\p{^iscjkextb}', "");
    Expect(1, 173792, '\P{iscjkextb}', "");
    Expect(0, 173792, '\P{^iscjkextb}', "");
    Expect(1, 173791, '\p{Is_CJK_Ext_B}', "");
    Expect(0, 173791, '\p{^Is_CJK_Ext_B}', "");
    Expect(0, 173791, '\P{Is_CJK_Ext_B}', "");
    Expect(1, 173791, '\P{^Is_CJK_Ext_B}', "");
    Expect(0, 173792, '\p{Is_CJK_Ext_B}', "");
    Expect(1, 173792, '\p{^Is_CJK_Ext_B}', "");
    Expect(1, 173792, '\P{Is_CJK_Ext_B}', "");
    Expect(0, 173792, '\P{^Is_CJK_Ext_B}', "");
    Error('\p{-	IN_CJK_Ext_B:=}');
    Error('\P{-	IN_CJK_Ext_B:=}');
    Expect(1, 173791, '\p{incjkextb}', "");
    Expect(0, 173791, '\p{^incjkextb}', "");
    Expect(0, 173791, '\P{incjkextb}', "");
    Expect(1, 173791, '\P{^incjkextb}', "");
    Expect(0, 173792, '\p{incjkextb}', "");
    Expect(1, 173792, '\p{^incjkextb}', "");
    Expect(1, 173792, '\P{incjkextb}', "");
    Expect(0, 173792, '\P{^incjkextb}', "");
    Expect(1, 173791, '\p{-_in_cjk_Ext_B}', "");
    Expect(0, 173791, '\p{^-_in_cjk_Ext_B}', "");
    Expect(0, 173791, '\P{-_in_cjk_Ext_B}', "");
    Expect(1, 173791, '\P{^-_in_cjk_Ext_B}', "");
    Expect(0, 173792, '\p{-_in_cjk_Ext_B}', "");
    Expect(1, 173792, '\p{^-_in_cjk_Ext_B}', "");
    Expect(1, 173792, '\P{-_in_cjk_Ext_B}', "");
    Expect(0, 173792, '\P{^-_in_cjk_Ext_B}', "");
    Error('\p{/a/-	CJK_Unified_ideographs_extension_C}');
    Error('\P{/a/-	CJK_Unified_ideographs_extension_C}');
    Expect(1, 177983, '\p{cjkunifiedideographsextensionc}', "");
    Expect(0, 177983, '\p{^cjkunifiedideographsextensionc}', "");
    Expect(0, 177983, '\P{cjkunifiedideographsextensionc}', "");
    Expect(1, 177983, '\P{^cjkunifiedideographsextensionc}', "");
    Expect(0, 177984, '\p{cjkunifiedideographsextensionc}', "");
    Expect(1, 177984, '\p{^cjkunifiedideographsextensionc}', "");
    Expect(1, 177984, '\P{cjkunifiedideographsextensionc}', "");
    Expect(0, 177984, '\P{^cjkunifiedideographsextensionc}', "");
    Expect(1, 177983, '\p{-CJK_UNIFIED_Ideographs_Extension_C}', "");
    Expect(0, 177983, '\p{^-CJK_UNIFIED_Ideographs_Extension_C}', "");
    Expect(0, 177983, '\P{-CJK_UNIFIED_Ideographs_Extension_C}', "");
    Expect(1, 177983, '\P{^-CJK_UNIFIED_Ideographs_Extension_C}', "");
    Expect(0, 177984, '\p{-CJK_UNIFIED_Ideographs_Extension_C}', "");
    Expect(1, 177984, '\p{^-CJK_UNIFIED_Ideographs_Extension_C}', "");
    Expect(1, 177984, '\P{-CJK_UNIFIED_Ideographs_Extension_C}', "");
    Expect(0, 177984, '\P{^-CJK_UNIFIED_Ideographs_Extension_C}', "");
    Error('\p{_/a/is_CJK_unified_IDEOGRAPHS_extension_C}');
    Error('\P{_/a/is_CJK_unified_IDEOGRAPHS_extension_C}');
    Expect(1, 177983, '\p{iscjkunifiedideographsextensionc}', "");
    Expect(0, 177983, '\p{^iscjkunifiedideographsextensionc}', "");
    Expect(0, 177983, '\P{iscjkunifiedideographsextensionc}', "");
    Expect(1, 177983, '\P{^iscjkunifiedideographsextensionc}', "");
    Expect(0, 177984, '\p{iscjkunifiedideographsextensionc}', "");
    Expect(1, 177984, '\p{^iscjkunifiedideographsextensionc}', "");
    Expect(1, 177984, '\P{iscjkunifiedideographsextensionc}', "");
    Expect(0, 177984, '\P{^iscjkunifiedideographsextensionc}', "");
    Expect(1, 177983, '\p{--Is_CJK_Unified_IDEOGRAPHS_EXTENSION_C}', "");
    Expect(0, 177983, '\p{^--Is_CJK_Unified_IDEOGRAPHS_EXTENSION_C}', "");
    Expect(0, 177983, '\P{--Is_CJK_Unified_IDEOGRAPHS_EXTENSION_C}', "");
    Expect(1, 177983, '\P{^--Is_CJK_Unified_IDEOGRAPHS_EXTENSION_C}', "");
    Expect(0, 177984, '\p{--Is_CJK_Unified_IDEOGRAPHS_EXTENSION_C}', "");
    Expect(1, 177984, '\p{^--Is_CJK_Unified_IDEOGRAPHS_EXTENSION_C}', "");
    Expect(1, 177984, '\P{--Is_CJK_Unified_IDEOGRAPHS_EXTENSION_C}', "");
    Expect(0, 177984, '\P{^--Is_CJK_Unified_IDEOGRAPHS_EXTENSION_C}', "");
    Error('\p{-_in_CJK_UNIFIED_IDEOGRAPHS_Extension_C/a/}');
    Error('\P{-_in_CJK_UNIFIED_IDEOGRAPHS_Extension_C/a/}');
    Expect(1, 177983, '\p{incjkunifiedideographsextensionc}', "");
    Expect(0, 177983, '\p{^incjkunifiedideographsextensionc}', "");
    Expect(0, 177983, '\P{incjkunifiedideographsextensionc}', "");
    Expect(1, 177983, '\P{^incjkunifiedideographsextensionc}', "");
    Expect(0, 177984, '\p{incjkunifiedideographsextensionc}', "");
    Expect(1, 177984, '\p{^incjkunifiedideographsextensionc}', "");
    Expect(1, 177984, '\P{incjkunifiedideographsextensionc}', "");
    Expect(0, 177984, '\P{^incjkunifiedideographsextensionc}', "");
    Expect(1, 177983, '\p{	-in_cjk_Unified_Ideographs_EXTENSION_C}', "");
    Expect(0, 177983, '\p{^	-in_cjk_Unified_Ideographs_EXTENSION_C}', "");
    Expect(0, 177983, '\P{	-in_cjk_Unified_Ideographs_EXTENSION_C}', "");
    Expect(1, 177983, '\P{^	-in_cjk_Unified_Ideographs_EXTENSION_C}', "");
    Expect(0, 177984, '\p{	-in_cjk_Unified_Ideographs_EXTENSION_C}', "");
    Expect(1, 177984, '\p{^	-in_cjk_Unified_Ideographs_EXTENSION_C}', "");
    Expect(1, 177984, '\P{	-in_cjk_Unified_Ideographs_EXTENSION_C}', "");
    Expect(0, 177984, '\P{^	-in_cjk_Unified_Ideographs_EXTENSION_C}', "");
    Error('\p{ /a/cjk_ext_C}');
    Error('\P{ /a/cjk_ext_C}');
    Expect(1, 177983, '\p{cjkextc}', "");
    Expect(0, 177983, '\p{^cjkextc}', "");
    Expect(0, 177983, '\P{cjkextc}', "");
    Expect(1, 177983, '\P{^cjkextc}', "");
    Expect(0, 177984, '\p{cjkextc}', "");
    Expect(1, 177984, '\p{^cjkextc}', "");
    Expect(1, 177984, '\P{cjkextc}', "");
    Expect(0, 177984, '\P{^cjkextc}', "");
    Expect(1, 177983, '\p{ 	cjk_Ext_c}', "");
    Expect(0, 177983, '\p{^ 	cjk_Ext_c}', "");
    Expect(0, 177983, '\P{ 	cjk_Ext_c}', "");
    Expect(1, 177983, '\P{^ 	cjk_Ext_c}', "");
    Expect(0, 177984, '\p{ 	cjk_Ext_c}', "");
    Expect(1, 177984, '\p{^ 	cjk_Ext_c}', "");
    Expect(1, 177984, '\P{ 	cjk_Ext_c}', "");
    Expect(0, 177984, '\P{^ 	cjk_Ext_c}', "");
    Error('\p{	is_CJK_EXT_C/a/}');
    Error('\P{	is_CJK_EXT_C/a/}');
    Expect(1, 177983, '\p{iscjkextc}', "");
    Expect(0, 177983, '\p{^iscjkextc}', "");
    Expect(0, 177983, '\P{iscjkextc}', "");
    Expect(1, 177983, '\P{^iscjkextc}', "");
    Expect(0, 177984, '\p{iscjkextc}', "");
    Expect(1, 177984, '\p{^iscjkextc}', "");
    Expect(1, 177984, '\P{iscjkextc}', "");
    Expect(0, 177984, '\P{^iscjkextc}', "");
    Expect(1, 177983, '\p{	Is_CJK_Ext_C}', "");
    Expect(0, 177983, '\p{^	Is_CJK_Ext_C}', "");
    Expect(0, 177983, '\P{	Is_CJK_Ext_C}', "");
    Expect(1, 177983, '\P{^	Is_CJK_Ext_C}', "");
    Expect(0, 177984, '\p{	Is_CJK_Ext_C}', "");
    Expect(1, 177984, '\p{^	Is_CJK_Ext_C}', "");
    Expect(1, 177984, '\P{	Is_CJK_Ext_C}', "");
    Expect(0, 177984, '\P{^	Is_CJK_Ext_C}', "");
    Error('\p{ 	in_cjk_ext_C/a/}');
    Error('\P{ 	in_cjk_ext_C/a/}');
    Expect(1, 177983, '\p{incjkextc}', "");
    Expect(0, 177983, '\p{^incjkextc}', "");
    Expect(0, 177983, '\P{incjkextc}', "");
    Expect(1, 177983, '\P{^incjkextc}', "");
    Expect(0, 177984, '\p{incjkextc}', "");
    Expect(1, 177984, '\p{^incjkextc}', "");
    Expect(1, 177984, '\P{incjkextc}', "");
    Expect(0, 177984, '\P{^incjkextc}', "");
    Expect(1, 177983, '\p{-in_CJK_Ext_c}', "");
    Expect(0, 177983, '\p{^-in_CJK_Ext_c}', "");
    Expect(0, 177983, '\P{-in_CJK_Ext_c}', "");
    Expect(1, 177983, '\P{^-in_CJK_Ext_c}', "");
    Expect(0, 177984, '\p{-in_CJK_Ext_c}', "");
    Expect(1, 177984, '\p{^-in_CJK_Ext_c}', "");
    Expect(1, 177984, '\P{-in_CJK_Ext_c}', "");
    Expect(0, 177984, '\P{^-in_CJK_Ext_c}', "");
    Error('\p{/a/	 CJK_unified_ideographs_Extension_D}');
    Error('\P{/a/	 CJK_unified_ideographs_Extension_D}');
    Expect(1, 178207, '\p{cjkunifiedideographsextensiond}', "");
    Expect(0, 178207, '\p{^cjkunifiedideographsextensiond}', "");
    Expect(0, 178207, '\P{cjkunifiedideographsextensiond}', "");
    Expect(1, 178207, '\P{^cjkunifiedideographsextensiond}', "");
    Expect(0, 178208, '\p{cjkunifiedideographsextensiond}', "");
    Expect(1, 178208, '\p{^cjkunifiedideographsextensiond}', "");
    Expect(1, 178208, '\P{cjkunifiedideographsextensiond}', "");
    Expect(0, 178208, '\P{^cjkunifiedideographsextensiond}', "");
    Expect(1, 178207, '\p{_CJK_Unified_ideographs_extension_D}', "");
    Expect(0, 178207, '\p{^_CJK_Unified_ideographs_extension_D}', "");
    Expect(0, 178207, '\P{_CJK_Unified_ideographs_extension_D}', "");
    Expect(1, 178207, '\P{^_CJK_Unified_ideographs_extension_D}', "");
    Expect(0, 178208, '\p{_CJK_Unified_ideographs_extension_D}', "");
    Expect(1, 178208, '\p{^_CJK_Unified_ideographs_extension_D}', "");
    Expect(1, 178208, '\P{_CJK_Unified_ideographs_extension_D}', "");
    Expect(0, 178208, '\P{^_CJK_Unified_ideographs_extension_D}', "");
    Error('\p{:= 	Is_cjk_Unified_Ideographs_Extension_D}');
    Error('\P{:= 	Is_cjk_Unified_Ideographs_Extension_D}');
    Expect(1, 178207, '\p{iscjkunifiedideographsextensiond}', "");
    Expect(0, 178207, '\p{^iscjkunifiedideographsextensiond}', "");
    Expect(0, 178207, '\P{iscjkunifiedideographsextensiond}', "");
    Expect(1, 178207, '\P{^iscjkunifiedideographsextensiond}', "");
    Expect(0, 178208, '\p{iscjkunifiedideographsextensiond}', "");
    Expect(1, 178208, '\p{^iscjkunifiedideographsextensiond}', "");
    Expect(1, 178208, '\P{iscjkunifiedideographsextensiond}', "");
    Expect(0, 178208, '\P{^iscjkunifiedideographsextensiond}', "");
    Expect(1, 178207, '\p{_is_CJK_Unified_IDEOGRAPHS_EXTENSION_D}', "");
    Expect(0, 178207, '\p{^_is_CJK_Unified_IDEOGRAPHS_EXTENSION_D}', "");
    Expect(0, 178207, '\P{_is_CJK_Unified_IDEOGRAPHS_EXTENSION_D}', "");
    Expect(1, 178207, '\P{^_is_CJK_Unified_IDEOGRAPHS_EXTENSION_D}', "");
    Expect(0, 178208, '\p{_is_CJK_Unified_IDEOGRAPHS_EXTENSION_D}', "");
    Expect(1, 178208, '\p{^_is_CJK_Unified_IDEOGRAPHS_EXTENSION_D}', "");
    Expect(1, 178208, '\P{_is_CJK_Unified_IDEOGRAPHS_EXTENSION_D}', "");
    Expect(0, 178208, '\P{^_is_CJK_Unified_IDEOGRAPHS_EXTENSION_D}', "");
    Error('\p{ _in_CJK_Unified_ideographs_extension_d/a/}');
    Error('\P{ _in_CJK_Unified_ideographs_extension_d/a/}');
    Expect(1, 178207, '\p{incjkunifiedideographsextensiond}', "");
    Expect(0, 178207, '\p{^incjkunifiedideographsextensiond}', "");
    Expect(0, 178207, '\P{incjkunifiedideographsextensiond}', "");
    Expect(1, 178207, '\P{^incjkunifiedideographsextensiond}', "");
    Expect(0, 178208, '\p{incjkunifiedideographsextensiond}', "");
    Expect(1, 178208, '\p{^incjkunifiedideographsextensiond}', "");
    Expect(1, 178208, '\P{incjkunifiedideographsextensiond}', "");
    Expect(0, 178208, '\P{^incjkunifiedideographsextensiond}', "");
    Expect(1, 178207, '\p{_In_CJK_unified_ideographs_Extension_D}', "");
    Expect(0, 178207, '\p{^_In_CJK_unified_ideographs_Extension_D}', "");
    Expect(0, 178207, '\P{_In_CJK_unified_ideographs_Extension_D}', "");
    Expect(1, 178207, '\P{^_In_CJK_unified_ideographs_Extension_D}', "");
    Expect(0, 178208, '\p{_In_CJK_unified_ideographs_Extension_D}', "");
    Expect(1, 178208, '\p{^_In_CJK_unified_ideographs_Extension_D}', "");
    Expect(1, 178208, '\P{_In_CJK_unified_ideographs_Extension_D}', "");
    Expect(0, 178208, '\P{^_In_CJK_unified_ideographs_Extension_D}', "");
    Error('\p{/a/	CJK_Ext_D}');
    Error('\P{/a/	CJK_Ext_D}');
    Expect(1, 178207, '\p{cjkextd}', "");
    Expect(0, 178207, '\p{^cjkextd}', "");
    Expect(0, 178207, '\P{cjkextd}', "");
    Expect(1, 178207, '\P{^cjkextd}', "");
    Expect(0, 178208, '\p{cjkextd}', "");
    Expect(1, 178208, '\p{^cjkextd}', "");
    Expect(1, 178208, '\P{cjkextd}', "");
    Expect(0, 178208, '\P{^cjkextd}', "");
    Expect(1, 178207, '\p{--cjk_EXT_D}', "");
    Expect(0, 178207, '\p{^--cjk_EXT_D}', "");
    Expect(0, 178207, '\P{--cjk_EXT_D}', "");
    Expect(1, 178207, '\P{^--cjk_EXT_D}', "");
    Expect(0, 178208, '\p{--cjk_EXT_D}', "");
    Expect(1, 178208, '\p{^--cjk_EXT_D}', "");
    Expect(1, 178208, '\P{--cjk_EXT_D}', "");
    Expect(0, 178208, '\P{^--cjk_EXT_D}', "");
    Error('\p{/a/ 	Is_CJK_ext_D}');
    Error('\P{/a/ 	Is_CJK_ext_D}');
    Expect(1, 178207, '\p{iscjkextd}', "");
    Expect(0, 178207, '\p{^iscjkextd}', "");
    Expect(0, 178207, '\P{iscjkextd}', "");
    Expect(1, 178207, '\P{^iscjkextd}', "");
    Expect(0, 178208, '\p{iscjkextd}', "");
    Expect(1, 178208, '\p{^iscjkextd}', "");
    Expect(1, 178208, '\P{iscjkextd}', "");
    Expect(0, 178208, '\P{^iscjkextd}', "");
    Expect(1, 178207, '\p{- is_CJK_ext_d}', "");
    Expect(0, 178207, '\p{^- is_CJK_ext_d}', "");
    Expect(0, 178207, '\P{- is_CJK_ext_d}', "");
    Expect(1, 178207, '\P{^- is_CJK_ext_d}', "");
    Expect(0, 178208, '\p{- is_CJK_ext_d}', "");
    Expect(1, 178208, '\p{^- is_CJK_ext_d}', "");
    Expect(1, 178208, '\P{- is_CJK_ext_d}', "");
    Expect(0, 178208, '\P{^- is_CJK_ext_d}', "");
    Error('\p{	:=In_CJK_EXT_D}');
    Error('\P{	:=In_CJK_EXT_D}');
    Expect(1, 178207, '\p{incjkextd}', "");
    Expect(0, 178207, '\p{^incjkextd}', "");
    Expect(0, 178207, '\P{incjkextd}', "");
    Expect(1, 178207, '\P{^incjkextd}', "");
    Expect(0, 178208, '\p{incjkextd}', "");
    Expect(1, 178208, '\p{^incjkextd}', "");
    Expect(1, 178208, '\P{incjkextd}', "");
    Expect(0, 178208, '\P{^incjkextd}', "");
    Expect(1, 178207, '\p{_In_CJK_Ext_D}', "");
    Expect(0, 178207, '\p{^_In_CJK_Ext_D}', "");
    Expect(0, 178207, '\P{_In_CJK_Ext_D}', "");
    Expect(1, 178207, '\P{^_In_CJK_Ext_D}', "");
    Expect(0, 178208, '\p{_In_CJK_Ext_D}', "");
    Expect(1, 178208, '\p{^_In_CJK_Ext_D}', "");
    Expect(1, 178208, '\P{_In_CJK_Ext_D}', "");
    Expect(0, 178208, '\P{^_In_CJK_Ext_D}', "");
    Error('\p{-_cjk_Unified_Ideographs_extension_E/a/}');
    Error('\P{-_cjk_Unified_Ideographs_extension_E/a/}');
    Expect(1, 183983, '\p{cjkunifiedideographsextensione}', "");
    Expect(0, 183983, '\p{^cjkunifiedideographsextensione}', "");
    Expect(0, 183983, '\P{cjkunifiedideographsextensione}', "");
    Expect(1, 183983, '\P{^cjkunifiedideographsextensione}', "");
    Expect(0, 183984, '\p{cjkunifiedideographsextensione}', "");
    Expect(1, 183984, '\p{^cjkunifiedideographsextensione}', "");
    Expect(1, 183984, '\P{cjkunifiedideographsextensione}', "");
    Expect(0, 183984, '\P{^cjkunifiedideographsextensione}', "");
    Expect(1, 183983, '\p{_ CJK_Unified_ideographs_extension_E}', "");
    Expect(0, 183983, '\p{^_ CJK_Unified_ideographs_extension_E}', "");
    Expect(0, 183983, '\P{_ CJK_Unified_ideographs_extension_E}', "");
    Expect(1, 183983, '\P{^_ CJK_Unified_ideographs_extension_E}', "");
    Expect(0, 183984, '\p{_ CJK_Unified_ideographs_extension_E}', "");
    Expect(1, 183984, '\p{^_ CJK_Unified_ideographs_extension_E}', "");
    Expect(1, 183984, '\P{_ CJK_Unified_ideographs_extension_E}', "");
    Expect(0, 183984, '\P{^_ CJK_Unified_ideographs_extension_E}', "");
    Error('\p{/a/_is_CJK_Unified_IDEOGRAPHS_EXTENSION_e}');
    Error('\P{/a/_is_CJK_Unified_IDEOGRAPHS_EXTENSION_e}');
    Expect(1, 183983, '\p{iscjkunifiedideographsextensione}', "");
    Expect(0, 183983, '\p{^iscjkunifiedideographsextensione}', "");
    Expect(0, 183983, '\P{iscjkunifiedideographsextensione}', "");
    Expect(1, 183983, '\P{^iscjkunifiedideographsextensione}', "");
    Expect(0, 183984, '\p{iscjkunifiedideographsextensione}', "");
    Expect(1, 183984, '\p{^iscjkunifiedideographsextensione}', "");
    Expect(1, 183984, '\P{iscjkunifiedideographsextensione}', "");
    Expect(0, 183984, '\P{^iscjkunifiedideographsextensione}', "");
    Expect(1, 183983, '\p{__IS_CJK_Unified_Ideographs_extension_E}', "");
    Expect(0, 183983, '\p{^__IS_CJK_Unified_Ideographs_extension_E}', "");
    Expect(0, 183983, '\P{__IS_CJK_Unified_Ideographs_extension_E}', "");
    Expect(1, 183983, '\P{^__IS_CJK_Unified_Ideographs_extension_E}', "");
    Expect(0, 183984, '\p{__IS_CJK_Unified_Ideographs_extension_E}', "");
    Expect(1, 183984, '\p{^__IS_CJK_Unified_Ideographs_extension_E}', "");
    Expect(1, 183984, '\P{__IS_CJK_Unified_Ideographs_extension_E}', "");
    Expect(0, 183984, '\P{^__IS_CJK_Unified_Ideographs_extension_E}', "");
    Error('\p{/a/-In_CJK_UNIFIED_IDEOGRAPHS_Extension_E}');
    Error('\P{/a/-In_CJK_UNIFIED_IDEOGRAPHS_Extension_E}');
    Expect(1, 183983, '\p{incjkunifiedideographsextensione}', "");
    Expect(0, 183983, '\p{^incjkunifiedideographsextensione}', "");
    Expect(0, 183983, '\P{incjkunifiedideographsextensione}', "");
    Expect(1, 183983, '\P{^incjkunifiedideographsextensione}', "");
    Expect(0, 183984, '\p{incjkunifiedideographsextensione}', "");
    Expect(1, 183984, '\p{^incjkunifiedideographsextensione}', "");
    Expect(1, 183984, '\P{incjkunifiedideographsextensione}', "");
    Expect(0, 183984, '\P{^incjkunifiedideographsextensione}', "");
    Expect(1, 183983, '\p{ IN_cjk_UNIFIED_ideographs_extension_E}', "");
    Expect(0, 183983, '\p{^ IN_cjk_UNIFIED_ideographs_extension_E}', "");
    Expect(0, 183983, '\P{ IN_cjk_UNIFIED_ideographs_extension_E}', "");
    Expect(1, 183983, '\P{^ IN_cjk_UNIFIED_ideographs_extension_E}', "");
    Expect(0, 183984, '\p{ IN_cjk_UNIFIED_ideographs_extension_E}', "");
    Expect(1, 183984, '\p{^ IN_cjk_UNIFIED_ideographs_extension_E}', "");
    Expect(1, 183984, '\P{ IN_cjk_UNIFIED_ideographs_extension_E}', "");
    Expect(0, 183984, '\P{^ IN_cjk_UNIFIED_ideographs_extension_E}', "");
    Error('\p{ CJK_ext_E:=}');
    Error('\P{ CJK_ext_E:=}');
    Expect(1, 183983, '\p{cjkexte}', "");
    Expect(0, 183983, '\p{^cjkexte}', "");
    Expect(0, 183983, '\P{cjkexte}', "");
    Expect(1, 183983, '\P{^cjkexte}', "");
    Expect(0, 183984, '\p{cjkexte}', "");
    Expect(1, 183984, '\p{^cjkexte}', "");
    Expect(1, 183984, '\P{cjkexte}', "");
    Expect(0, 183984, '\P{^cjkexte}', "");
    Expect(1, 183983, '\p{ -cjk_Ext_E}', "");
    Expect(0, 183983, '\p{^ -cjk_Ext_E}', "");
    Expect(0, 183983, '\P{ -cjk_Ext_E}', "");
    Expect(1, 183983, '\P{^ -cjk_Ext_E}', "");
    Expect(0, 183984, '\p{ -cjk_Ext_E}', "");
    Expect(1, 183984, '\p{^ -cjk_Ext_E}', "");
    Expect(1, 183984, '\P{ -cjk_Ext_E}', "");
    Expect(0, 183984, '\P{^ -cjk_Ext_E}', "");
    Error('\p{ :=Is_CJK_ext_E}');
    Error('\P{ :=Is_CJK_ext_E}');
    Expect(1, 183983, '\p{iscjkexte}', "");
    Expect(0, 183983, '\p{^iscjkexte}', "");
    Expect(0, 183983, '\P{iscjkexte}', "");
    Expect(1, 183983, '\P{^iscjkexte}', "");
    Expect(0, 183984, '\p{iscjkexte}', "");
    Expect(1, 183984, '\p{^iscjkexte}', "");
    Expect(1, 183984, '\P{iscjkexte}', "");
    Expect(0, 183984, '\P{^iscjkexte}', "");
    Expect(1, 183983, '\p{__IS_CJK_ext_E}', "");
    Expect(0, 183983, '\p{^__IS_CJK_ext_E}', "");
    Expect(0, 183983, '\P{__IS_CJK_ext_E}', "");
    Expect(1, 183983, '\P{^__IS_CJK_ext_E}', "");
    Expect(0, 183984, '\p{__IS_CJK_ext_E}', "");
    Expect(1, 183984, '\p{^__IS_CJK_ext_E}', "");
    Expect(1, 183984, '\P{__IS_CJK_ext_E}', "");
    Expect(0, 183984, '\P{^__IS_CJK_ext_E}', "");
    Error('\p{:=_-In_CJK_ext_E}');
    Error('\P{:=_-In_CJK_ext_E}');
    Expect(1, 183983, '\p{incjkexte}', "");
    Expect(0, 183983, '\p{^incjkexte}', "");
    Expect(0, 183983, '\P{incjkexte}', "");
    Expect(1, 183983, '\P{^incjkexte}', "");
    Expect(0, 183984, '\p{incjkexte}', "");
    Expect(1, 183984, '\p{^incjkexte}', "");
    Expect(1, 183984, '\P{incjkexte}', "");
    Expect(0, 183984, '\P{^incjkexte}', "");
    Expect(1, 183983, '\p{ -IN_CJK_ext_e}', "");
    Expect(0, 183983, '\p{^ -IN_CJK_ext_e}', "");
    Expect(0, 183983, '\P{ -IN_CJK_ext_e}', "");
    Expect(1, 183983, '\P{^ -IN_CJK_ext_e}', "");
    Expect(0, 183984, '\p{ -IN_CJK_ext_e}', "");
    Expect(1, 183984, '\p{^ -IN_CJK_ext_e}', "");
    Expect(1, 183984, '\P{ -IN_CJK_ext_e}', "");
    Expect(0, 183984, '\P{^ -IN_CJK_ext_e}', "");
    Error('\p{:= CJK_Unified_Ideographs_Extension_F}');
    Error('\P{:= CJK_Unified_Ideographs_Extension_F}');
    Expect(1, 191471, '\p{cjkunifiedideographsextensionf}', "");
    Expect(0, 191471, '\p{^cjkunifiedideographsextensionf}', "");
    Expect(0, 191471, '\P{cjkunifiedideographsextensionf}', "");
    Expect(1, 191471, '\P{^cjkunifiedideographsextensionf}', "");
    Expect(0, 191472, '\p{cjkunifiedideographsextensionf}', "");
    Expect(1, 191472, '\p{^cjkunifiedideographsextensionf}', "");
    Expect(1, 191472, '\P{cjkunifiedideographsextensionf}', "");
    Expect(0, 191472, '\P{^cjkunifiedideographsextensionf}', "");
    Expect(1, 191471, '\p{  CJK_UNIFIED_ideographs_Extension_f}', "");
    Expect(0, 191471, '\p{^  CJK_UNIFIED_ideographs_Extension_f}', "");
    Expect(0, 191471, '\P{  CJK_UNIFIED_ideographs_Extension_f}', "");
    Expect(1, 191471, '\P{^  CJK_UNIFIED_ideographs_Extension_f}', "");
    Expect(0, 191472, '\p{  CJK_UNIFIED_ideographs_Extension_f}', "");
    Expect(1, 191472, '\p{^  CJK_UNIFIED_ideographs_Extension_f}', "");
    Expect(1, 191472, '\P{  CJK_UNIFIED_ideographs_Extension_f}', "");
    Expect(0, 191472, '\P{^  CJK_UNIFIED_ideographs_Extension_f}', "");
    Error('\p{/a/	Is_CJK_Unified_Ideographs_EXTENSION_f}');
    Error('\P{/a/	Is_CJK_Unified_Ideographs_EXTENSION_f}');
    Expect(1, 191471, '\p{iscjkunifiedideographsextensionf}', "");
    Expect(0, 191471, '\p{^iscjkunifiedideographsextensionf}', "");
    Expect(0, 191471, '\P{iscjkunifiedideographsextensionf}', "");
    Expect(1, 191471, '\P{^iscjkunifiedideographsextensionf}', "");
    Expect(0, 191472, '\p{iscjkunifiedideographsextensionf}', "");
    Expect(1, 191472, '\p{^iscjkunifiedideographsextensionf}', "");
    Expect(1, 191472, '\P{iscjkunifiedideographsextensionf}', "");
    Expect(0, 191472, '\P{^iscjkunifiedideographsextensionf}', "");
    Expect(1, 191471, '\p{ -IS_cjk_Unified_Ideographs_extension_F}', "");
    Expect(0, 191471, '\p{^ -IS_cjk_Unified_Ideographs_extension_F}', "");
    Expect(0, 191471, '\P{ -IS_cjk_Unified_Ideographs_extension_F}', "");
    Expect(1, 191471, '\P{^ -IS_cjk_Unified_Ideographs_extension_F}', "");
    Expect(0, 191472, '\p{ -IS_cjk_Unified_Ideographs_extension_F}', "");
    Expect(1, 191472, '\p{^ -IS_cjk_Unified_Ideographs_extension_F}', "");
    Expect(1, 191472, '\P{ -IS_cjk_Unified_Ideographs_extension_F}', "");
    Expect(0, 191472, '\P{^ -IS_cjk_Unified_Ideographs_extension_F}', "");
    Error('\p{In_CJK_Unified_Ideographs_Extension_F:=}');
    Error('\P{In_CJK_Unified_Ideographs_Extension_F:=}');
    Expect(1, 191471, '\p{incjkunifiedideographsextensionf}', "");
    Expect(0, 191471, '\p{^incjkunifiedideographsextensionf}', "");
    Expect(0, 191471, '\P{incjkunifiedideographsextensionf}', "");
    Expect(1, 191471, '\P{^incjkunifiedideographsextensionf}', "");
    Expect(0, 191472, '\p{incjkunifiedideographsextensionf}', "");
    Expect(1, 191472, '\p{^incjkunifiedideographsextensionf}', "");
    Expect(1, 191472, '\P{incjkunifiedideographsextensionf}', "");
    Expect(0, 191472, '\P{^incjkunifiedideographsextensionf}', "");
    Expect(1, 191471, '\p{--In_CJK_Unified_Ideographs_extension_f}', "");
    Expect(0, 191471, '\p{^--In_CJK_Unified_Ideographs_extension_f}', "");
    Expect(0, 191471, '\P{--In_CJK_Unified_Ideographs_extension_f}', "");
    Expect(1, 191471, '\P{^--In_CJK_Unified_Ideographs_extension_f}', "");
    Expect(0, 191472, '\p{--In_CJK_Unified_Ideographs_extension_f}', "");
    Expect(1, 191472, '\p{^--In_CJK_Unified_Ideographs_extension_f}', "");
    Expect(1, 191472, '\P{--In_CJK_Unified_Ideographs_extension_f}', "");
    Expect(0, 191472, '\P{^--In_CJK_Unified_Ideographs_extension_f}', "");
    Error('\p{_:=cjk_Ext_f}');
    Error('\P{_:=cjk_Ext_f}');
    Expect(1, 191471, '\p{cjkextf}', "");
    Expect(0, 191471, '\p{^cjkextf}', "");
    Expect(0, 191471, '\P{cjkextf}', "");
    Expect(1, 191471, '\P{^cjkextf}', "");
    Expect(0, 191472, '\p{cjkextf}', "");
    Expect(1, 191472, '\p{^cjkextf}', "");
    Expect(1, 191472, '\P{cjkextf}', "");
    Expect(0, 191472, '\P{^cjkextf}', "");
    Expect(1, 191471, '\p{__CJK_ext_F}', "");
    Expect(0, 191471, '\p{^__CJK_ext_F}', "");
    Expect(0, 191471, '\P{__CJK_ext_F}', "");
    Expect(1, 191471, '\P{^__CJK_ext_F}', "");
    Expect(0, 191472, '\p{__CJK_ext_F}', "");
    Expect(1, 191472, '\p{^__CJK_ext_F}', "");
    Expect(1, 191472, '\P{__CJK_ext_F}', "");
    Expect(0, 191472, '\P{^__CJK_ext_F}', "");
    Error('\p{/a/	IS_cjk_Ext_F}');
    Error('\P{/a/	IS_cjk_Ext_F}');
    Expect(1, 191471, '\p{iscjkextf}', "");
    Expect(0, 191471, '\p{^iscjkextf}', "");
    Expect(0, 191471, '\P{iscjkextf}', "");
    Expect(1, 191471, '\P{^iscjkextf}', "");
    Expect(0, 191472, '\p{iscjkextf}', "");
    Expect(1, 191472, '\p{^iscjkextf}', "");
    Expect(1, 191472, '\P{iscjkextf}', "");
    Expect(0, 191472, '\P{^iscjkextf}', "");
    Expect(1, 191471, '\p{ Is_CJK_ext_F}', "");
    Expect(0, 191471, '\p{^ Is_CJK_ext_F}', "");
    Expect(0, 191471, '\P{ Is_CJK_ext_F}', "");
    Expect(1, 191471, '\P{^ Is_CJK_ext_F}', "");
    Expect(0, 191472, '\p{ Is_CJK_ext_F}', "");
    Expect(1, 191472, '\p{^ Is_CJK_ext_F}', "");
    Expect(1, 191472, '\P{ Is_CJK_ext_F}', "");
    Expect(0, 191472, '\P{^ Is_CJK_ext_F}', "");
    Error('\p{		In_cjk_Ext_F:=}');
    Error('\P{		In_cjk_Ext_F:=}');
    Expect(1, 191471, '\p{incjkextf}', "");
    Expect(0, 191471, '\p{^incjkextf}', "");
    Expect(0, 191471, '\P{incjkextf}', "");
    Expect(1, 191471, '\P{^incjkextf}', "");
    Expect(0, 191472, '\p{incjkextf}', "");
    Expect(1, 191472, '\p{^incjkextf}', "");
    Expect(1, 191472, '\P{incjkextf}', "");
    Expect(0, 191472, '\P{^incjkextf}', "");
    Expect(1, 191471, '\p{	in_CJK_Ext_F}', "");
    Expect(0, 191471, '\p{^	in_CJK_Ext_F}', "");
    Expect(0, 191471, '\P{	in_CJK_Ext_F}', "");
    Expect(1, 191471, '\P{^	in_CJK_Ext_F}', "");
    Expect(0, 191472, '\p{	in_CJK_Ext_F}', "");
    Expect(1, 191472, '\p{^	in_CJK_Ext_F}', "");
    Expect(1, 191472, '\P{	in_CJK_Ext_F}', "");
    Expect(0, 191472, '\P{^	in_CJK_Ext_F}', "");
    Error('\p{	/a/CJK_unified_Ideographs_Extension_g}');
    Error('\P{	/a/CJK_unified_Ideographs_Extension_g}');
    Expect(1, 201551, '\p{cjkunifiedideographsextensiong}', "");
    Expect(0, 201551, '\p{^cjkunifiedideographsextensiong}', "");
    Expect(0, 201551, '\P{cjkunifiedideographsextensiong}', "");
    Expect(1, 201551, '\P{^cjkunifiedideographsextensiong}', "");
    Expect(0, 201552, '\p{cjkunifiedideographsextensiong}', "");
    Expect(1, 201552, '\p{^cjkunifiedideographsextensiong}', "");
    Expect(1, 201552, '\P{cjkunifiedideographsextensiong}', "");
    Expect(0, 201552, '\P{^cjkunifiedideographsextensiong}', "");
    Expect(1, 201551, '\p{ CJK_Unified_IDEOGRAPHS_extension_G}', "");
    Expect(0, 201551, '\p{^ CJK_Unified_IDEOGRAPHS_extension_G}', "");
    Expect(0, 201551, '\P{ CJK_Unified_IDEOGRAPHS_extension_G}', "");
    Expect(1, 201551, '\P{^ CJK_Unified_IDEOGRAPHS_extension_G}', "");
    Expect(0, 201552, '\p{ CJK_Unified_IDEOGRAPHS_extension_G}', "");
    Expect(1, 201552, '\p{^ CJK_Unified_IDEOGRAPHS_extension_G}', "");
    Expect(1, 201552, '\P{ CJK_Unified_IDEOGRAPHS_extension_G}', "");
    Expect(0, 201552, '\P{^ CJK_Unified_IDEOGRAPHS_extension_G}', "");
    Error('\p{/a/-	Is_CJK_Unified_ideographs_Extension_G}');
    Error('\P{/a/-	Is_CJK_Unified_ideographs_Extension_G}');
    Expect(1, 201551, '\p{iscjkunifiedideographsextensiong}', "");
    Expect(0, 201551, '\p{^iscjkunifiedideographsextensiong}', "");
    Expect(0, 201551, '\P{iscjkunifiedideographsextensiong}', "");
    Expect(1, 201551, '\P{^iscjkunifiedideographsextensiong}', "");
    Expect(0, 201552, '\p{iscjkunifiedideographsextensiong}', "");
    Expect(1, 201552, '\p{^iscjkunifiedideographsextensiong}', "");
    Expect(1, 201552, '\P{iscjkunifiedideographsextensiong}', "");
    Expect(0, 201552, '\P{^iscjkunifiedideographsextensiong}', "");
    Expect(1, 201551, '\p{-_is_CJK_unified_Ideographs_extension_G}', "");
    Expect(0, 201551, '\p{^-_is_CJK_unified_Ideographs_extension_G}', "");
    Expect(0, 201551, '\P{-_is_CJK_unified_Ideographs_extension_G}', "");
    Expect(1, 201551, '\P{^-_is_CJK_unified_Ideographs_extension_G}', "");
    Expect(0, 201552, '\p{-_is_CJK_unified_Ideographs_extension_G}', "");
    Expect(1, 201552, '\p{^-_is_CJK_unified_Ideographs_extension_G}', "");
    Expect(1, 201552, '\P{-_is_CJK_unified_Ideographs_extension_G}', "");
    Expect(0, 201552, '\P{^-_is_CJK_unified_Ideographs_extension_G}', "");
    Error('\p{ -in_CJK_Unified_IDEOGRAPHS_extension_g:=}');
    Error('\P{ -in_CJK_Unified_IDEOGRAPHS_extension_g:=}');
    Expect(1, 201551, '\p{incjkunifiedideographsextensiong}', "");
    Expect(0, 201551, '\p{^incjkunifiedideographsextensiong}', "");
    Expect(0, 201551, '\P{incjkunifiedideographsextensiong}', "");
    Expect(1, 201551, '\P{^incjkunifiedideographsextensiong}', "");
    Expect(0, 201552, '\p{incjkunifiedideographsextensiong}', "");
    Expect(1, 201552, '\p{^incjkunifiedideographsextensiong}', "");
    Expect(1, 201552, '\P{incjkunifiedideographsextensiong}', "");
    Expect(0, 201552, '\P{^incjkunifiedideographsextensiong}', "");
    Expect(1, 201551, '\p{_-IN_cjk_unified_Ideographs_Extension_G}', "");
    Expect(0, 201551, '\p{^_-IN_cjk_unified_Ideographs_Extension_G}', "");
    Expect(0, 201551, '\P{_-IN_cjk_unified_Ideographs_Extension_G}', "");
    Expect(1, 201551, '\P{^_-IN_cjk_unified_Ideographs_Extension_G}', "");
    Expect(0, 201552, '\p{_-IN_cjk_unified_Ideographs_Extension_G}', "");
    Expect(1, 201552, '\p{^_-IN_cjk_unified_Ideographs_Extension_G}', "");
    Expect(1, 201552, '\P{_-IN_cjk_unified_Ideographs_Extension_G}', "");
    Expect(0, 201552, '\P{^_-IN_cjk_unified_Ideographs_Extension_G}', "");
    Error('\p{/a/	 cjk_Ext_G}');
    Error('\P{/a/	 cjk_Ext_G}');
    Expect(1, 201551, '\p{cjkextg}', "");
    Expect(0, 201551, '\p{^cjkextg}', "");
    Expect(0, 201551, '\P{cjkextg}', "");
    Expect(1, 201551, '\P{^cjkextg}', "");
    Expect(0, 201552, '\p{cjkextg}', "");
    Expect(1, 201552, '\p{^cjkextg}', "");
    Expect(1, 201552, '\P{cjkextg}', "");
    Expect(0, 201552, '\P{^cjkextg}', "");
    Expect(1, 201551, '\p{	 CJK_EXT_G}', "");
    Expect(0, 201551, '\p{^	 CJK_EXT_G}', "");
    Expect(0, 201551, '\P{	 CJK_EXT_G}', "");
    Expect(1, 201551, '\P{^	 CJK_EXT_G}', "");
    Expect(0, 201552, '\p{	 CJK_EXT_G}', "");
    Expect(1, 201552, '\p{^	 CJK_EXT_G}', "");
    Expect(1, 201552, '\P{	 CJK_EXT_G}', "");
    Expect(0, 201552, '\P{^	 CJK_EXT_G}', "");
    Error('\p{ _is_CJK_EXT_g:=}');
    Error('\P{ _is_CJK_EXT_g:=}');
    Expect(1, 201551, '\p{iscjkextg}', "");
    Expect(0, 201551, '\p{^iscjkextg}', "");
    Expect(0, 201551, '\P{iscjkextg}', "");
    Expect(1, 201551, '\P{^iscjkextg}', "");
    Expect(0, 201552, '\p{iscjkextg}', "");
    Expect(1, 201552, '\p{^iscjkextg}', "");
    Expect(1, 201552, '\P{iscjkextg}', "");
    Expect(0, 201552, '\P{^iscjkextg}', "");
    Expect(1, 201551, '\p{_Is_CJK_Ext_g}', "");
    Expect(0, 201551, '\p{^_Is_CJK_Ext_g}', "");
    Expect(0, 201551, '\P{_Is_CJK_Ext_g}', "");
    Expect(1, 201551, '\P{^_Is_CJK_Ext_g}', "");
    Expect(0, 201552, '\p{_Is_CJK_Ext_g}', "");
    Expect(1, 201552, '\p{^_Is_CJK_Ext_g}', "");
    Expect(1, 201552, '\P{_Is_CJK_Ext_g}', "");
    Expect(0, 201552, '\P{^_Is_CJK_Ext_g}', "");
    Error('\p{_in_CJK_Ext_G/a/}');
    Error('\P{_in_CJK_Ext_G/a/}');
    Expect(1, 201551, '\p{incjkextg}', "");
    Expect(0, 201551, '\p{^incjkextg}', "");
    Expect(0, 201551, '\P{incjkextg}', "");
    Expect(1, 201551, '\P{^incjkextg}', "");
    Expect(0, 201552, '\p{incjkextg}', "");
    Expect(1, 201552, '\p{^incjkextg}', "");
    Expect(1, 201552, '\P{incjkextg}', "");
    Expect(0, 201552, '\P{^incjkextg}', "");
    Expect(1, 201551, '\p{-	In_CJK_Ext_G}', "");
    Expect(0, 201551, '\p{^-	In_CJK_Ext_G}', "");
    Expect(0, 201551, '\P{-	In_CJK_Ext_G}', "");
    Expect(1, 201551, '\P{^-	In_CJK_Ext_G}', "");
    Expect(0, 201552, '\p{-	In_CJK_Ext_G}', "");
    Expect(1, 201552, '\p{^-	In_CJK_Ext_G}', "");
    Expect(1, 201552, '\P{-	In_CJK_Ext_G}', "");
    Expect(0, 201552, '\P{^-	In_CJK_Ext_G}', "");
    Error('\p{ 	CJK_UNIFIED_Ideographs_extension_H/a/}');
    Error('\P{ 	CJK_UNIFIED_Ideographs_extension_H/a/}');
    Expect(1, 205743, '\p{cjkunifiedideographsextensionh}', "");
    Expect(0, 205743, '\p{^cjkunifiedideographsextensionh}', "");
    Expect(0, 205743, '\P{cjkunifiedideographsextensionh}', "");
    Expect(1, 205743, '\P{^cjkunifiedideographsextensionh}', "");
    Expect(0, 205744, '\p{cjkunifiedideographsextensionh}', "");
    Expect(1, 205744, '\p{^cjkunifiedideographsextensionh}', "");
    Expect(1, 205744, '\P{cjkunifiedideographsextensionh}', "");
    Expect(0, 205744, '\P{^cjkunifiedideographsextensionh}', "");
    Expect(1, 205743, '\p{	 CJK_Unified_Ideographs_extension_H}', "");
    Expect(0, 205743, '\p{^	 CJK_Unified_Ideographs_extension_H}', "");
    Expect(0, 205743, '\P{	 CJK_Unified_Ideographs_extension_H}', "");
    Expect(1, 205743, '\P{^	 CJK_Unified_Ideographs_extension_H}', "");
    Expect(0, 205744, '\p{	 CJK_Unified_Ideographs_extension_H}', "");
    Expect(1, 205744, '\p{^	 CJK_Unified_Ideographs_extension_H}', "");
    Expect(1, 205744, '\P{	 CJK_Unified_Ideographs_extension_H}', "");
    Expect(0, 205744, '\P{^	 CJK_Unified_Ideographs_extension_H}', "");
    Error('\p{ 	is_CJK_Unified_ideographs_Extension_H:=}');
    Error('\P{ 	is_CJK_Unified_ideographs_Extension_H:=}');
    Expect(1, 205743, '\p{iscjkunifiedideographsextensionh}', "");
    Expect(0, 205743, '\p{^iscjkunifiedideographsextensionh}', "");
    Expect(0, 205743, '\P{iscjkunifiedideographsextensionh}', "");
    Expect(1, 205743, '\P{^iscjkunifiedideographsextensionh}', "");
    Expect(0, 205744, '\p{iscjkunifiedideographsextensionh}', "");
    Expect(1, 205744, '\p{^iscjkunifiedideographsextensionh}', "");
    Expect(1, 205744, '\P{iscjkunifiedideographsextensionh}', "");
    Expect(0, 205744, '\P{^iscjkunifiedideographsextensionh}', "");
    Expect(1, 205743, '\p{- Is_cjk_Unified_Ideographs_EXTENSION_H}', "");
    Expect(0, 205743, '\p{^- Is_cjk_Unified_Ideographs_EXTENSION_H}', "");
    Expect(0, 205743, '\P{- Is_cjk_Unified_Ideographs_EXTENSION_H}', "");
    Expect(1, 205743, '\P{^- Is_cjk_Unified_Ideographs_EXTENSION_H}', "");
    Expect(0, 205744, '\p{- Is_cjk_Unified_Ideographs_EXTENSION_H}', "");
    Expect(1, 205744, '\p{^- Is_cjk_Unified_Ideographs_EXTENSION_H}', "");
    Expect(1, 205744, '\P{- Is_cjk_Unified_Ideographs_EXTENSION_H}', "");
    Expect(0, 205744, '\P{^- Is_cjk_Unified_Ideographs_EXTENSION_H}', "");
    Error('\p{:=	In_CJK_UNIFIED_ideographs_Extension_h}');
    Error('\P{:=	In_CJK_UNIFIED_ideographs_Extension_h}');
    Expect(1, 205743, '\p{incjkunifiedideographsextensionh}', "");
    Expect(0, 205743, '\p{^incjkunifiedideographsextensionh}', "");
    Expect(0, 205743, '\P{incjkunifiedideographsextensionh}', "");
    Expect(1, 205743, '\P{^incjkunifiedideographsextensionh}', "");
    Expect(0, 205744, '\p{incjkunifiedideographsextensionh}', "");
    Expect(1, 205744, '\p{^incjkunifiedideographsextensionh}', "");
    Expect(1, 205744, '\P{incjkunifiedideographsextensionh}', "");
    Expect(0, 205744, '\P{^incjkunifiedideographsextensionh}', "");
    Expect(1, 205743, '\p{ In_CJK_Unified_Ideographs_extension_H}', "");
    Expect(0, 205743, '\p{^ In_CJK_Unified_Ideographs_extension_H}', "");
    Expect(0, 205743, '\P{ In_CJK_Unified_Ideographs_extension_H}', "");
    Expect(1, 205743, '\P{^ In_CJK_Unified_Ideographs_extension_H}', "");
    Expect(0, 205744, '\p{ In_CJK_Unified_Ideographs_extension_H}', "");
    Expect(1, 205744, '\p{^ In_CJK_Unified_Ideographs_extension_H}', "");
    Expect(1, 205744, '\P{ In_CJK_Unified_Ideographs_extension_H}', "");
    Expect(0, 205744, '\P{^ In_CJK_Unified_Ideographs_extension_H}', "");
    Error('\p{-/a/cjk_Ext_H}');
    Error('\P{-/a/cjk_Ext_H}');
    Expect(1, 205743, '\p{cjkexth}', "");
    Expect(0, 205743, '\p{^cjkexth}', "");
    Expect(0, 205743, '\P{cjkexth}', "");
    Expect(1, 205743, '\P{^cjkexth}', "");
    Expect(0, 205744, '\p{cjkexth}', "");
    Expect(1, 205744, '\p{^cjkexth}', "");
    Expect(1, 205744, '\P{cjkexth}', "");
    Expect(0, 205744, '\P{^cjkexth}', "");
    Expect(1, 205743, '\p{ 	CJK_Ext_H}', "");
    Expect(0, 205743, '\p{^ 	CJK_Ext_H}', "");
    Expect(0, 205743, '\P{ 	CJK_Ext_H}', "");
    Expect(1, 205743, '\P{^ 	CJK_Ext_H}', "");
    Expect(0, 205744, '\p{ 	CJK_Ext_H}', "");
    Expect(1, 205744, '\p{^ 	CJK_Ext_H}', "");
    Expect(1, 205744, '\P{ 	CJK_Ext_H}', "");
    Expect(0, 205744, '\P{^ 	CJK_Ext_H}', "");
    Error('\p{/a/-is_CJK_EXT_H}');
    Error('\P{/a/-is_CJK_EXT_H}');
    Expect(1, 205743, '\p{iscjkexth}', "");
    Expect(0, 205743, '\p{^iscjkexth}', "");
    Expect(0, 205743, '\P{iscjkexth}', "");
    Expect(1, 205743, '\P{^iscjkexth}', "");
    Expect(0, 205744, '\p{iscjkexth}', "");
    Expect(1, 205744, '\p{^iscjkexth}', "");
    Expect(1, 205744, '\P{iscjkexth}', "");
    Expect(0, 205744, '\P{^iscjkexth}', "");
    Expect(1, 205743, '\p{ 	is_CJK_ext_H}', "");
    Expect(0, 205743, '\p{^ 	is_CJK_ext_H}', "");
    Expect(0, 205743, '\P{ 	is_CJK_ext_H}', "");
    Expect(1, 205743, '\P{^ 	is_CJK_ext_H}', "");
    Expect(0, 205744, '\p{ 	is_CJK_ext_H}', "");
    Expect(1, 205744, '\p{^ 	is_CJK_ext_H}', "");
    Expect(1, 205744, '\P{ 	is_CJK_ext_H}', "");
    Expect(0, 205744, '\P{^ 	is_CJK_ext_H}', "");
    Error('\p{	/a/In_CJK_EXT_H}');
    Error('\P{	/a/In_CJK_EXT_H}');
    Expect(1, 205743, '\p{incjkexth}', "");
    Expect(0, 205743, '\p{^incjkexth}', "");
    Expect(0, 205743, '\P{incjkexth}', "");
    Expect(1, 205743, '\P{^incjkexth}', "");
    Expect(0, 205744, '\p{incjkexth}', "");
    Expect(1, 205744, '\p{^incjkexth}', "");
    Expect(1, 205744, '\P{incjkexth}', "");
    Expect(0, 205744, '\P{^incjkexth}', "");
    Expect(1, 205743, '\p{	In_CJK_Ext_H}', "");
    Expect(0, 205743, '\p{^	In_CJK_Ext_H}', "");
    Expect(0, 205743, '\P{	In_CJK_Ext_H}', "");
    Expect(1, 205743, '\P{^	In_CJK_Ext_H}', "");
    Expect(0, 205744, '\p{	In_CJK_Ext_H}', "");
    Expect(1, 205744, '\p{^	In_CJK_Ext_H}', "");
    Expect(1, 205744, '\P{	In_CJK_Ext_H}', "");
    Expect(0, 205744, '\P{^	In_CJK_Ext_H}', "");
    Error('\p{:= -Close_PUNCTUATION}');
    Error('\P{:= -Close_PUNCTUATION}');
    Expect(1, 65379, '\p{closepunctuation}', "");
    Expect(0, 65379, '\p{^closepunctuation}', "");
    Expect(0, 65379, '\P{closepunctuation}', "");
    Expect(1, 65379, '\P{^closepunctuation}', "");
    Expect(0, 65380, '\p{closepunctuation}', "");
    Expect(1, 65380, '\p{^closepunctuation}', "");
    Expect(1, 65380, '\P{closepunctuation}', "");
    Expect(0, 65380, '\P{^closepunctuation}', "");
    Expect(1, 65379, '\p{-_Close_punctuation}', "");
    Expect(0, 65379, '\p{^-_Close_punctuation}', "");
    Expect(0, 65379, '\P{-_Close_punctuation}', "");
    Expect(1, 65379, '\P{^-_Close_punctuation}', "");
    Expect(0, 65380, '\p{-_Close_punctuation}', "");
    Expect(1, 65380, '\p{^-_Close_punctuation}', "");
    Expect(1, 65380, '\P{-_Close_punctuation}', "");
    Expect(0, 65380, '\P{^-_Close_punctuation}', "");
    Error('\p{:=  IS_Close_PUNCTUATION}');
    Error('\P{:=  IS_Close_PUNCTUATION}');
    Expect(1, 65379, '\p{isclosepunctuation}', "");
    Expect(0, 65379, '\p{^isclosepunctuation}', "");
    Expect(0, 65379, '\P{isclosepunctuation}', "");
    Expect(1, 65379, '\P{^isclosepunctuation}', "");
    Expect(0, 65380, '\p{isclosepunctuation}', "");
    Expect(1, 65380, '\p{^isclosepunctuation}', "");
    Expect(1, 65380, '\P{isclosepunctuation}', "");
    Expect(0, 65380, '\P{^isclosepunctuation}', "");
    Expect(1, 65379, '\p{  Is_Close_PUNCTUATION}', "");
    Expect(0, 65379, '\p{^  Is_Close_PUNCTUATION}', "");
    Expect(0, 65379, '\P{  Is_Close_PUNCTUATION}', "");
    Expect(1, 65379, '\P{^  Is_Close_PUNCTUATION}', "");
    Expect(0, 65380, '\p{  Is_Close_PUNCTUATION}', "");
    Expect(1, 65380, '\p{^  Is_Close_PUNCTUATION}', "");
    Expect(1, 65380, '\P{  Is_Close_PUNCTUATION}', "");
    Expect(0, 65380, '\P{^  Is_Close_PUNCTUATION}', "");
    Error('\p{:=	_Pe}');
    Error('\P{:=	_Pe}');
    Expect(1, 65379, '\p{pe}', "");
    Expect(0, 65379, '\p{^pe}', "");
    Expect(0, 65379, '\P{pe}', "");
    Expect(1, 65379, '\P{^pe}', "");
    Expect(0, 65380, '\p{pe}', "");
    Expect(1, 65380, '\p{^pe}', "");
    Expect(1, 65380, '\P{pe}', "");
    Expect(0, 65380, '\P{^pe}', "");
    Expect(1, 65379, '\p{	-Pe}', "");
    Expect(0, 65379, '\p{^	-Pe}', "");
    Expect(0, 65379, '\P{	-Pe}', "");
    Expect(1, 65379, '\P{^	-Pe}', "");
    Expect(0, 65380, '\p{	-Pe}', "");
    Expect(1, 65380, '\p{^	-Pe}', "");
    Expect(1, 65380, '\P{	-Pe}', "");
    Expect(0, 65380, '\P{^	-Pe}', "");
    Error('\p{ is_pe:=}');
    Error('\P{ is_pe:=}');
    Expect(1, 65379, '\p{ispe}', "");
    Expect(0, 65379, '\p{^ispe}', "");
    Expect(0, 65379, '\P{ispe}', "");
    Expect(1, 65379, '\P{^ispe}', "");
    Expect(0, 65380, '\p{ispe}', "");
    Expect(1, 65380, '\p{^ispe}', "");
    Expect(1, 65380, '\P{ispe}', "");
    Expect(0, 65380, '\P{^ispe}', "");
    Expect(1, 65379, '\p{IS_pe}', "");
    Expect(0, 65379, '\p{^IS_pe}', "");
    Expect(0, 65379, '\P{IS_pe}', "");
    Expect(1, 65379, '\P{^IS_pe}', "");
    Expect(0, 65380, '\p{IS_pe}', "");
    Expect(1, 65380, '\p{^IS_pe}', "");
    Expect(1, 65380, '\P{IS_pe}', "");
    Expect(0, 65380, '\P{^IS_pe}', "");
    Error('\p{/a/_ XPosixCntrl}');
    Error('\P{/a/_ XPosixCntrl}');
    Expect(1, 159, '\p{xposixcntrl}', "");
    Expect(0, 159, '\p{^xposixcntrl}', "");
    Expect(0, 159, '\P{xposixcntrl}', "");
    Expect(1, 159, '\P{^xposixcntrl}', "");
    Expect(0, 160, '\p{xposixcntrl}', "");
    Expect(1, 160, '\p{^xposixcntrl}', "");
    Expect(1, 160, '\P{xposixcntrl}', "");
    Expect(0, 160, '\P{^xposixcntrl}', "");
    Expect(1, 159, '\p{__XPOSIXCNTRL}', "");
    Expect(0, 159, '\p{^__XPOSIXCNTRL}', "");
    Expect(0, 159, '\P{__XPOSIXCNTRL}', "");
    Expect(1, 159, '\P{^__XPOSIXCNTRL}', "");
    Expect(0, 160, '\p{__XPOSIXCNTRL}', "");
    Expect(1, 160, '\p{^__XPOSIXCNTRL}', "");
    Expect(1, 160, '\P{__XPOSIXCNTRL}', "");
    Expect(0, 160, '\P{^__XPOSIXCNTRL}', "");
    Error('\p{ :=CNTRL}');
    Error('\P{ :=CNTRL}');
    Expect(1, 159, '\p{cntrl}', "");
    Expect(0, 159, '\p{^cntrl}', "");
    Expect(0, 159, '\P{cntrl}', "");
    Expect(1, 159, '\P{^cntrl}', "");
    Expect(0, 160, '\p{cntrl}', "");
    Expect(1, 160, '\p{^cntrl}', "");
    Expect(1, 160, '\P{cntrl}', "");
    Expect(0, 160, '\P{^cntrl}', "");
    Expect(1, 159, '\p{	cntrl}', "");
    Expect(0, 159, '\p{^	cntrl}', "");
    Expect(0, 159, '\P{	cntrl}', "");
    Expect(1, 159, '\P{^	cntrl}', "");
    Expect(0, 160, '\p{	cntrl}', "");
    Expect(1, 160, '\p{^	cntrl}', "");
    Expect(1, 160, '\P{	cntrl}', "");
    Expect(0, 160, '\P{^	cntrl}', "");
    Error('\p{/a/-_Is_XPOSIXCNTRL}');
    Error('\P{/a/-_Is_XPOSIXCNTRL}');
    Expect(1, 159, '\p{isxposixcntrl}', "");
    Expect(0, 159, '\p{^isxposixcntrl}', "");
    Expect(0, 159, '\P{isxposixcntrl}', "");
    Expect(1, 159, '\P{^isxposixcntrl}', "");
    Expect(0, 160, '\p{isxposixcntrl}', "");
    Expect(1, 160, '\p{^isxposixcntrl}', "");
    Expect(1, 160, '\P{isxposixcntrl}', "");
    Expect(0, 160, '\P{^isxposixcntrl}', "");
    Expect(1, 159, '\p{	 Is_XPosixCntrl}', "");
    Expect(0, 159, '\p{^	 Is_XPosixCntrl}', "");
    Expect(0, 159, '\P{	 Is_XPosixCntrl}', "");
    Expect(1, 159, '\P{^	 Is_XPosixCntrl}', "");
    Expect(0, 160, '\p{	 Is_XPosixCntrl}', "");
    Expect(1, 160, '\p{^	 Is_XPosixCntrl}', "");
    Expect(1, 160, '\P{	 Is_XPosixCntrl}', "");
    Expect(0, 160, '\P{^	 Is_XPosixCntrl}', "");
    Error('\p{_ Is_Cntrl/a/}');
    Error('\P{_ Is_Cntrl/a/}');
    Expect(1, 159, '\p{iscntrl}', "");
    Expect(0, 159, '\p{^iscntrl}', "");
    Expect(0, 159, '\P{iscntrl}', "");
    Expect(1, 159, '\P{^iscntrl}', "");
    Expect(0, 160, '\p{iscntrl}', "");
    Expect(1, 160, '\p{^iscntrl}', "");
    Expect(1, 160, '\P{iscntrl}', "");
    Expect(0, 160, '\P{^iscntrl}', "");
    Expect(1, 159, '\p{ 	IS_cntrl}', "");
    Expect(0, 159, '\p{^ 	IS_cntrl}', "");
    Expect(0, 159, '\P{ 	IS_cntrl}', "");
    Expect(1, 159, '\P{^ 	IS_cntrl}', "");
    Expect(0, 160, '\p{ 	IS_cntrl}', "");
    Expect(1, 160, '\p{^ 	IS_cntrl}', "");
    Expect(1, 160, '\P{ 	IS_cntrl}', "");
    Expect(0, 160, '\P{^ 	IS_cntrl}', "");
    Error('\p{	:=CONTROL}');
    Error('\P{	:=CONTROL}');
    Expect(1, 159, '\p{control}', "");
    Expect(0, 159, '\p{^control}', "");
    Expect(0, 159, '\P{control}', "");
    Expect(1, 159, '\P{^control}', "");
    Expect(0, 160, '\p{control}', "");
    Expect(1, 160, '\p{^control}', "");
    Expect(1, 160, '\P{control}', "");
    Expect(0, 160, '\P{^control}', "");
    Expect(1, 159, '\p{_-CONTROL}', "");
    Expect(0, 159, '\p{^_-CONTROL}', "");
    Expect(0, 159, '\P{_-CONTROL}', "");
    Expect(1, 159, '\P{^_-CONTROL}', "");
    Expect(0, 160, '\p{_-CONTROL}', "");
    Expect(1, 160, '\p{^_-CONTROL}', "");
    Expect(1, 160, '\P{_-CONTROL}', "");
    Expect(0, 160, '\P{^_-CONTROL}', "");
    Error('\p{	Is_Control/a/}');
    Error('\P{	Is_Control/a/}');
    Expect(1, 159, '\p{iscontrol}', "");
    Expect(0, 159, '\p{^iscontrol}', "");
    Expect(0, 159, '\P{iscontrol}', "");
    Expect(1, 159, '\P{^iscontrol}', "");
    Expect(0, 160, '\p{iscontrol}', "");
    Expect(1, 160, '\p{^iscontrol}', "");
    Expect(1, 160, '\P{iscontrol}', "");
    Expect(0, 160, '\P{^iscontrol}', "");
    Expect(1, 159, '\p{- is_control}', "");
    Expect(0, 159, '\p{^- is_control}', "");
    Expect(0, 159, '\P{- is_control}', "");
    Expect(1, 159, '\P{^- is_control}', "");
    Expect(0, 160, '\p{- is_control}', "");
    Expect(1, 160, '\p{^- is_control}', "");
    Expect(1, 160, '\P{- is_control}', "");
    Expect(0, 160, '\P{^- is_control}', "");
    Error('\p{-_Cc/a/}');
    Error('\P{-_Cc/a/}');
    Expect(1, 159, '\p{cc}', "");
    Expect(0, 159, '\p{^cc}', "");
    Expect(0, 159, '\P{cc}', "");
    Expect(1, 159, '\P{^cc}', "");
    Expect(0, 160, '\p{cc}', "");
    Expect(1, 160, '\p{^cc}', "");
    Expect(1, 160, '\P{cc}', "");
    Expect(0, 160, '\P{^cc}', "");
    Expect(1, 159, '\p{- CC}', "");
    Expect(0, 159, '\p{^- CC}', "");
    Expect(0, 159, '\P{- CC}', "");
    Expect(1, 159, '\P{^- CC}', "");
    Expect(0, 160, '\p{- CC}', "");
    Expect(1, 160, '\p{^- CC}', "");
    Expect(1, 160, '\P{- CC}', "");
    Expect(0, 160, '\P{^- CC}', "");
    Error('\p{_:=Is_Cc}');
    Error('\P{_:=Is_Cc}');
    Expect(1, 159, '\p{iscc}', "");
    Expect(0, 159, '\p{^iscc}', "");
    Expect(0, 159, '\P{iscc}', "");
    Expect(1, 159, '\P{^iscc}', "");
    Expect(0, 160, '\p{iscc}', "");
    Expect(1, 160, '\p{^iscc}', "");
    Expect(1, 160, '\P{iscc}', "");
    Expect(0, 160, '\P{^iscc}', "");
    Expect(1, 159, '\p{_Is_CC}', "");
    Expect(0, 159, '\p{^_Is_CC}', "");
    Expect(0, 159, '\P{_Is_CC}', "");
    Expect(1, 159, '\P{^_Is_CC}', "");
    Expect(0, 160, '\p{_Is_CC}', "");
    Expect(1, 160, '\p{^_Is_CC}', "");
    Expect(1, 160, '\P{_Is_CC}', "");
    Expect(0, 160, '\P{^_Is_CC}', "");
    Error('\p{--COMBINING_Diacritical_MARKS:=}');
    Error('\P{--COMBINING_Diacritical_MARKS:=}');
    Expect(1, 879, '\p{combiningdiacriticalmarks}', "");
    Expect(0, 879, '\p{^combiningdiacriticalmarks}', "");
    Expect(0, 879, '\P{combiningdiacriticalmarks}', "");
    Expect(1, 879, '\P{^combiningdiacriticalmarks}', "");
    Expect(0, 880, '\p{combiningdiacriticalmarks}', "");
    Expect(1, 880, '\p{^combiningdiacriticalmarks}', "");
    Expect(1, 880, '\P{combiningdiacriticalmarks}', "");
    Expect(0, 880, '\P{^combiningdiacriticalmarks}', "");
    Expect(1, 879, '\p{-	Combining_Diacritical_marks}', "");
    Expect(0, 879, '\p{^-	Combining_Diacritical_marks}', "");
    Expect(0, 879, '\P{-	Combining_Diacritical_marks}', "");
    Expect(1, 879, '\P{^-	Combining_Diacritical_marks}', "");
    Expect(0, 880, '\p{-	Combining_Diacritical_marks}', "");
    Expect(1, 880, '\p{^-	Combining_Diacritical_marks}', "");
    Expect(1, 880, '\P{-	Combining_Diacritical_marks}', "");
    Expect(0, 880, '\P{^-	Combining_Diacritical_marks}', "");
    Error('\p{-IS_Combining_DIACRITICAL_Marks/a/}');
    Error('\P{-IS_Combining_DIACRITICAL_Marks/a/}');
    Expect(1, 879, '\p{iscombiningdiacriticalmarks}', "");
    Expect(0, 879, '\p{^iscombiningdiacriticalmarks}', "");
    Expect(0, 879, '\P{iscombiningdiacriticalmarks}', "");
    Expect(1, 879, '\P{^iscombiningdiacriticalmarks}', "");
    Expect(0, 880, '\p{iscombiningdiacriticalmarks}', "");
    Expect(1, 880, '\p{^iscombiningdiacriticalmarks}', "");
    Expect(1, 880, '\P{iscombiningdiacriticalmarks}', "");
    Expect(0, 880, '\P{^iscombiningdiacriticalmarks}', "");
    Expect(1, 879, '\p{ is_Combining_Diacritical_marks}', "");
    Expect(0, 879, '\p{^ is_Combining_Diacritical_marks}', "");
    Expect(0, 879, '\P{ is_Combining_Diacritical_marks}', "");
    Expect(1, 879, '\P{^ is_Combining_Diacritical_marks}', "");
    Expect(0, 880, '\p{ is_Combining_Diacritical_marks}', "");
    Expect(1, 880, '\p{^ is_Combining_Diacritical_marks}', "");
    Expect(1, 880, '\P{ is_Combining_Diacritical_marks}', "");
    Expect(0, 880, '\P{^ is_Combining_Diacritical_marks}', "");
    Error('\p{	:=In_COMBINING_Diacritical_Marks}');
    Error('\P{	:=In_COMBINING_Diacritical_Marks}');
    Expect(1, 879, '\p{incombiningdiacriticalmarks}', "");
    Expect(0, 879, '\p{^incombiningdiacriticalmarks}', "");
    Expect(0, 879, '\P{incombiningdiacriticalmarks}', "");
    Expect(1, 879, '\P{^incombiningdiacriticalmarks}', "");
    Expect(0, 880, '\p{incombiningdiacriticalmarks}', "");
    Expect(1, 880, '\p{^incombiningdiacriticalmarks}', "");
    Expect(1, 880, '\P{incombiningdiacriticalmarks}', "");
    Expect(0, 880, '\P{^incombiningdiacriticalmarks}', "");
    Expect(1, 879, '\p{	-In_COMBINING_DIACRITICAL_Marks}', "");
    Expect(0, 879, '\p{^	-In_COMBINING_DIACRITICAL_Marks}', "");
    Expect(0, 879, '\P{	-In_COMBINING_DIACRITICAL_Marks}', "");
    Expect(1, 879, '\P{^	-In_COMBINING_DIACRITICAL_Marks}', "");
    Expect(0, 880, '\p{	-In_COMBINING_DIACRITICAL_Marks}', "");
    Expect(1, 880, '\p{^	-In_COMBINING_DIACRITICAL_Marks}', "");
    Expect(1, 880, '\P{	-In_COMBINING_DIACRITICAL_Marks}', "");
    Expect(0, 880, '\P{^	-In_COMBINING_DIACRITICAL_Marks}', "");
    Error('\p{ 	Diacriticals/a/}');
    Error('\P{ 	Diacriticals/a/}');
    Expect(1, 879, '\p{diacriticals}', "");
    Expect(0, 879, '\p{^diacriticals}', "");
    Expect(0, 879, '\P{diacriticals}', "");
    Expect(1, 879, '\P{^diacriticals}', "");
    Expect(0, 880, '\p{diacriticals}', "");
    Expect(1, 880, '\p{^diacriticals}', "");
    Expect(1, 880, '\P{diacriticals}', "");
    Expect(0, 880, '\P{^diacriticals}', "");
    Expect(1, 879, '\p{	diacriticals}', "");
    Expect(0, 879, '\p{^	diacriticals}', "");
    Expect(0, 879, '\P{	diacriticals}', "");
    Expect(1, 879, '\P{^	diacriticals}', "");
    Expect(0, 880, '\p{	diacriticals}', "");
    Expect(1, 880, '\p{^	diacriticals}', "");
    Expect(1, 880, '\P{	diacriticals}', "");
    Expect(0, 880, '\P{^	diacriticals}', "");
    Error('\p{/a/IS_diacriticals}');
    Error('\P{/a/IS_diacriticals}');
    Expect(1, 879, '\p{isdiacriticals}', "");
    Expect(0, 879, '\p{^isdiacriticals}', "");
    Expect(0, 879, '\P{isdiacriticals}', "");
    Expect(1, 879, '\P{^isdiacriticals}', "");
    Expect(0, 880, '\p{isdiacriticals}', "");
    Expect(1, 880, '\p{^isdiacriticals}', "");
    Expect(1, 880, '\P{isdiacriticals}', "");
    Expect(0, 880, '\P{^isdiacriticals}', "");
    Expect(1, 879, '\p{ 	Is_diacriticals}', "");
    Expect(0, 879, '\p{^ 	Is_diacriticals}', "");
    Expect(0, 879, '\P{ 	Is_diacriticals}', "");
    Expect(1, 879, '\P{^ 	Is_diacriticals}', "");
    Expect(0, 880, '\p{ 	Is_diacriticals}', "");
    Expect(1, 880, '\p{^ 	Is_diacriticals}', "");
    Expect(1, 880, '\P{ 	Is_diacriticals}', "");
    Expect(0, 880, '\P{^ 	Is_diacriticals}', "");
    Error('\p{:= IN_Diacriticals}');
    Error('\P{:= IN_Diacriticals}');
    Expect(1, 879, '\p{indiacriticals}', "");
    Expect(0, 879, '\p{^indiacriticals}', "");
    Expect(0, 879, '\P{indiacriticals}', "");
    Expect(1, 879, '\P{^indiacriticals}', "");
    Expect(0, 880, '\p{indiacriticals}', "");
    Expect(1, 880, '\p{^indiacriticals}', "");
    Expect(1, 880, '\P{indiacriticals}', "");
    Expect(0, 880, '\P{^indiacriticals}', "");
    Expect(1, 879, '\p{ In_DIACRITICALS}', "");
    Expect(0, 879, '\p{^ In_DIACRITICALS}', "");
    Expect(0, 879, '\P{ In_DIACRITICALS}', "");
    Expect(1, 879, '\P{^ In_DIACRITICALS}', "");
    Expect(0, 880, '\p{ In_DIACRITICALS}', "");
    Expect(1, 880, '\p{^ In_DIACRITICALS}', "");
    Expect(1, 880, '\P{ In_DIACRITICALS}', "");
    Expect(0, 880, '\P{^ In_DIACRITICALS}', "");
    Error('\p{/a/ _combining_Diacritical_Marks_extended}');
    Error('\P{/a/ _combining_Diacritical_Marks_extended}');
    Expect(1, 6911, '\p{combiningdiacriticalmarksextended}', "");
    Expect(0, 6911, '\p{^combiningdiacriticalmarksextended}', "");
    Expect(0, 6911, '\P{combiningdiacriticalmarksextended}', "");
    Expect(1, 6911, '\P{^combiningdiacriticalmarksextended}', "");
    Expect(0, 6912, '\p{combiningdiacriticalmarksextended}', "");
    Expect(1, 6912, '\p{^combiningdiacriticalmarksextended}', "");
    Expect(1, 6912, '\P{combiningdiacriticalmarksextended}', "");
    Expect(0, 6912, '\P{^combiningdiacriticalmarksextended}', "");
    Expect(1, 6911, '\p{--COMBINING_DIACRITICAL_Marks_extended}', "");
    Expect(0, 6911, '\p{^--COMBINING_DIACRITICAL_Marks_extended}', "");
    Expect(0, 6911, '\P{--COMBINING_DIACRITICAL_Marks_extended}', "");
    Expect(1, 6911, '\P{^--COMBINING_DIACRITICAL_Marks_extended}', "");
    Expect(0, 6912, '\p{--COMBINING_DIACRITICAL_Marks_extended}', "");
    Expect(1, 6912, '\p{^--COMBINING_DIACRITICAL_Marks_extended}', "");
    Expect(1, 6912, '\P{--COMBINING_DIACRITICAL_Marks_extended}', "");
    Expect(0, 6912, '\P{^--COMBINING_DIACRITICAL_Marks_extended}', "");
    Error('\p{	/a/Is_COMBINING_DIACRITICAL_Marks_Extended}');
    Error('\P{	/a/Is_COMBINING_DIACRITICAL_Marks_Extended}');
    Expect(1, 6911, '\p{iscombiningdiacriticalmarksextended}', "");
    Expect(0, 6911, '\p{^iscombiningdiacriticalmarksextended}', "");
    Expect(0, 6911, '\P{iscombiningdiacriticalmarksextended}', "");
    Expect(1, 6911, '\P{^iscombiningdiacriticalmarksextended}', "");
    Expect(0, 6912, '\p{iscombiningdiacriticalmarksextended}', "");
    Expect(1, 6912, '\p{^iscombiningdiacriticalmarksextended}', "");
    Expect(1, 6912, '\P{iscombiningdiacriticalmarksextended}', "");
    Expect(0, 6912, '\P{^iscombiningdiacriticalmarksextended}', "");
    Expect(1, 6911, '\p{-_Is_Combining_Diacritical_MARKS_Extended}', "");
    Expect(0, 6911, '\p{^-_Is_Combining_Diacritical_MARKS_Extended}', "");
    Expect(0, 6911, '\P{-_Is_Combining_Diacritical_MARKS_Extended}', "");
    Expect(1, 6911, '\P{^-_Is_Combining_Diacritical_MARKS_Extended}', "");
    Expect(0, 6912, '\p{-_Is_Combining_Diacritical_MARKS_Extended}', "");
    Expect(1, 6912, '\p{^-_Is_Combining_Diacritical_MARKS_Extended}', "");
    Expect(1, 6912, '\P{-_Is_Combining_Diacritical_MARKS_Extended}', "");
    Expect(0, 6912, '\P{^-_Is_Combining_Diacritical_MARKS_Extended}', "");
    Error('\p{	IN_combining_Diacritical_Marks_extended/a/}');
    Error('\P{	IN_combining_Diacritical_Marks_extended/a/}');
    Expect(1, 6911, '\p{incombiningdiacriticalmarksextended}', "");
    Expect(0, 6911, '\p{^incombiningdiacriticalmarksextended}', "");
    Expect(0, 6911, '\P{incombiningdiacriticalmarksextended}', "");
    Expect(1, 6911, '\P{^incombiningdiacriticalmarksextended}', "");
    Expect(0, 6912, '\p{incombiningdiacriticalmarksextended}', "");
    Expect(1, 6912, '\p{^incombiningdiacriticalmarksextended}', "");
    Expect(1, 6912, '\P{incombiningdiacriticalmarksextended}', "");
    Expect(0, 6912, '\P{^incombiningdiacriticalmarksextended}', "");
    Expect(1, 6911, '\p{_IN_Combining_DIACRITICAL_MARKS_EXTENDED}', "");
    Expect(0, 6911, '\p{^_IN_Combining_DIACRITICAL_MARKS_EXTENDED}', "");
    Expect(0, 6911, '\P{_IN_Combining_DIACRITICAL_MARKS_EXTENDED}', "");
    Expect(1, 6911, '\P{^_IN_Combining_DIACRITICAL_MARKS_EXTENDED}', "");
    Expect(0, 6912, '\p{_IN_Combining_DIACRITICAL_MARKS_EXTENDED}', "");
    Expect(1, 6912, '\p{^_IN_Combining_DIACRITICAL_MARKS_EXTENDED}', "");
    Expect(1, 6912, '\P{_IN_Combining_DIACRITICAL_MARKS_EXTENDED}', "");
    Expect(0, 6912, '\P{^_IN_Combining_DIACRITICAL_MARKS_EXTENDED}', "");
    Error('\p{	 Diacriticals_Ext/a/}');
    Error('\P{	 Diacriticals_Ext/a/}');
    Expect(1, 6911, '\p{diacriticalsext}', "");
    Expect(0, 6911, '\p{^diacriticalsext}', "");
    Expect(0, 6911, '\P{diacriticalsext}', "");
    Expect(1, 6911, '\P{^diacriticalsext}', "");
    Expect(0, 6912, '\p{diacriticalsext}', "");
    Expect(1, 6912, '\p{^diacriticalsext}', "");
    Expect(1, 6912, '\P{diacriticalsext}', "");
    Expect(0, 6912, '\P{^diacriticalsext}', "");
    Expect(1, 6911, '\p{ 	diacriticals_EXT}', "");
    Expect(0, 6911, '\p{^ 	diacriticals_EXT}', "");
    Expect(0, 6911, '\P{ 	diacriticals_EXT}', "");
    Expect(1, 6911, '\P{^ 	diacriticals_EXT}', "");
    Expect(0, 6912, '\p{ 	diacriticals_EXT}', "");
    Expect(1, 6912, '\p{^ 	diacriticals_EXT}', "");
    Expect(1, 6912, '\P{ 	diacriticals_EXT}', "");
    Expect(0, 6912, '\P{^ 	diacriticals_EXT}', "");
    Error('\p{	:=Is_DIACRITICALS_ext}');
    Error('\P{	:=Is_DIACRITICALS_ext}');
    Expect(1, 6911, '\p{isdiacriticalsext}', "");
    Expect(0, 6911, '\p{^isdiacriticalsext}', "");
    Expect(0, 6911, '\P{isdiacriticalsext}', "");
    Expect(1, 6911, '\P{^isdiacriticalsext}', "");
    Expect(0, 6912, '\p{isdiacriticalsext}', "");
    Expect(1, 6912, '\p{^isdiacriticalsext}', "");
    Expect(1, 6912, '\P{isdiacriticalsext}', "");
    Expect(0, 6912, '\P{^isdiacriticalsext}', "");
    Expect(1, 6911, '\p{_	IS_Diacriticals_ext}', "");
    Expect(0, 6911, '\p{^_	IS_Diacriticals_ext}', "");
    Expect(0, 6911, '\P{_	IS_Diacriticals_ext}', "");
    Expect(1, 6911, '\P{^_	IS_Diacriticals_ext}', "");
    Expect(0, 6912, '\p{_	IS_Diacriticals_ext}', "");
    Expect(1, 6912, '\p{^_	IS_Diacriticals_ext}', "");
    Expect(1, 6912, '\P{_	IS_Diacriticals_ext}', "");
    Expect(0, 6912, '\P{^_	IS_Diacriticals_ext}', "");
    Error('\p{:=	 In_Diacriticals_Ext}');
    Error('\P{:=	 In_Diacriticals_Ext}');
    Expect(1, 6911, '\p{indiacriticalsext}', "");
    Expect(0, 6911, '\p{^indiacriticalsext}', "");
    Expect(0, 6911, '\P{indiacriticalsext}', "");
    Expect(1, 6911, '\P{^indiacriticalsext}', "");
    Expect(0, 6912, '\p{indiacriticalsext}', "");
    Expect(1, 6912, '\p{^indiacriticalsext}', "");
    Expect(1, 6912, '\P{indiacriticalsext}', "");
    Expect(0, 6912, '\P{^indiacriticalsext}', "");
    Expect(1, 6911, '\p{__In_DIACRITICALS_Ext}', "");
    Expect(0, 6911, '\p{^__In_DIACRITICALS_Ext}', "");
    Expect(0, 6911, '\P{__In_DIACRITICALS_Ext}', "");
    Expect(1, 6911, '\P{^__In_DIACRITICALS_Ext}', "");
    Expect(0, 6912, '\p{__In_DIACRITICALS_Ext}', "");
    Expect(1, 6912, '\p{^__In_DIACRITICALS_Ext}', "");
    Expect(1, 6912, '\P{__In_DIACRITICALS_Ext}', "");
    Expect(0, 6912, '\P{^__In_DIACRITICALS_Ext}', "");
    Error('\p{/a/Combining_Diacritical_marks_FOR_SYMBOLS}');
    Error('\P{/a/Combining_Diacritical_marks_FOR_SYMBOLS}');
    Expect(1, 8447, '\p{combiningdiacriticalmarksforsymbols}', "");
    Expect(0, 8447, '\p{^combiningdiacriticalmarksforsymbols}', "");
    Expect(0, 8447, '\P{combiningdiacriticalmarksforsymbols}', "");
    Expect(1, 8447, '\P{^combiningdiacriticalmarksforsymbols}', "");
    Expect(0, 8448, '\p{combiningdiacriticalmarksforsymbols}', "");
    Expect(1, 8448, '\p{^combiningdiacriticalmarksforsymbols}', "");
    Expect(1, 8448, '\P{combiningdiacriticalmarksforsymbols}', "");
    Expect(0, 8448, '\P{^combiningdiacriticalmarksforsymbols}', "");
    Expect(1, 8447, '\p{_ Combining_DIACRITICAL_MARKS_FOR_symbols}', "");
    Expect(0, 8447, '\p{^_ Combining_DIACRITICAL_MARKS_FOR_symbols}', "");
    Expect(0, 8447, '\P{_ Combining_DIACRITICAL_MARKS_FOR_symbols}', "");
    Expect(1, 8447, '\P{^_ Combining_DIACRITICAL_MARKS_FOR_symbols}', "");
    Expect(0, 8448, '\p{_ Combining_DIACRITICAL_MARKS_FOR_symbols}', "");
    Expect(1, 8448, '\p{^_ Combining_DIACRITICAL_MARKS_FOR_symbols}', "");
    Expect(1, 8448, '\P{_ Combining_DIACRITICAL_MARKS_FOR_symbols}', "");
    Expect(0, 8448, '\P{^_ Combining_DIACRITICAL_MARKS_FOR_symbols}', "");
    Error('\p{:=Is_COMBINING_Diacritical_Marks_For_Symbols}');
    Error('\P{:=Is_COMBINING_Diacritical_Marks_For_Symbols}');
    Expect(1, 8447, '\p{iscombiningdiacriticalmarksforsymbols}', "");
    Expect(0, 8447, '\p{^iscombiningdiacriticalmarksforsymbols}', "");
    Expect(0, 8447, '\P{iscombiningdiacriticalmarksforsymbols}', "");
    Expect(1, 8447, '\P{^iscombiningdiacriticalmarksforsymbols}', "");
    Expect(0, 8448, '\p{iscombiningdiacriticalmarksforsymbols}', "");
    Expect(1, 8448, '\p{^iscombiningdiacriticalmarksforsymbols}', "");
    Expect(1, 8448, '\P{iscombiningdiacriticalmarksforsymbols}', "");
    Expect(0, 8448, '\P{^iscombiningdiacriticalmarksforsymbols}', "");
    Expect(1, 8447, '\p{_Is_Combining_DIACRITICAL_Marks_FOR_symbols}', "");
    Expect(0, 8447, '\p{^_Is_Combining_DIACRITICAL_Marks_FOR_symbols}', "");
    Expect(0, 8447, '\P{_Is_Combining_DIACRITICAL_Marks_FOR_symbols}', "");
    Expect(1, 8447, '\P{^_Is_Combining_DIACRITICAL_Marks_FOR_symbols}', "");
    Expect(0, 8448, '\p{_Is_Combining_DIACRITICAL_Marks_FOR_symbols}', "");
    Expect(1, 8448, '\p{^_Is_Combining_DIACRITICAL_Marks_FOR_symbols}', "");
    Expect(1, 8448, '\P{_Is_Combining_DIACRITICAL_Marks_FOR_symbols}', "");
    Expect(0, 8448, '\P{^_Is_Combining_DIACRITICAL_Marks_FOR_symbols}', "");
    Error('\p{/a/	 in_Combining_Diacritical_MARKS_For_Symbols}');
    Error('\P{/a/	 in_Combining_Diacritical_MARKS_For_Symbols}');
    Expect(1, 8447, '\p{incombiningdiacriticalmarksforsymbols}', "");
    Expect(0, 8447, '\p{^incombiningdiacriticalmarksforsymbols}', "");
    Expect(0, 8447, '\P{incombiningdiacriticalmarksforsymbols}', "");
    Expect(1, 8447, '\P{^incombiningdiacriticalmarksforsymbols}', "");
    Expect(0, 8448, '\p{incombiningdiacriticalmarksforsymbols}', "");
    Expect(1, 8448, '\p{^incombiningdiacriticalmarksforsymbols}', "");
    Expect(1, 8448, '\P{incombiningdiacriticalmarksforsymbols}', "");
    Expect(0, 8448, '\P{^incombiningdiacriticalmarksforsymbols}', "");
    Expect(1, 8447, '\p{	-IN_Combining_DIACRITICAL_marks_For_Symbols}', "");
    Expect(0, 8447, '\p{^	-IN_Combining_DIACRITICAL_marks_For_Symbols}', "");
    Expect(0, 8447, '\P{	-IN_Combining_DIACRITICAL_marks_For_Symbols}', "");
    Expect(1, 8447, '\P{^	-IN_Combining_DIACRITICAL_marks_For_Symbols}', "");
    Expect(0, 8448, '\p{	-IN_Combining_DIACRITICAL_marks_For_Symbols}', "");
    Expect(1, 8448, '\p{^	-IN_Combining_DIACRITICAL_marks_For_Symbols}', "");
    Expect(1, 8448, '\P{	-IN_Combining_DIACRITICAL_marks_For_Symbols}', "");
    Expect(0, 8448, '\P{^	-IN_Combining_DIACRITICAL_marks_For_Symbols}', "");
    Error('\p{:=_ Diacriticals_for_symbols}');
    Error('\P{:=_ Diacriticals_for_symbols}');
    Expect(1, 8447, '\p{diacriticalsforsymbols}', "");
    Expect(0, 8447, '\p{^diacriticalsforsymbols}', "");
    Expect(0, 8447, '\P{diacriticalsforsymbols}', "");
    Expect(1, 8447, '\P{^diacriticalsforsymbols}', "");
    Expect(0, 8448, '\p{diacriticalsforsymbols}', "");
    Expect(1, 8448, '\p{^diacriticalsforsymbols}', "");
    Expect(1, 8448, '\P{diacriticalsforsymbols}', "");
    Expect(0, 8448, '\P{^diacriticalsforsymbols}', "");
    Expect(1, 8447, '\p{ diacriticals_FOR_Symbols}', "");
    Expect(0, 8447, '\p{^ diacriticals_FOR_Symbols}', "");
    Expect(0, 8447, '\P{ diacriticals_FOR_Symbols}', "");
    Expect(1, 8447, '\P{^ diacriticals_FOR_Symbols}', "");
    Expect(0, 8448, '\p{ diacriticals_FOR_Symbols}', "");
    Expect(1, 8448, '\p{^ diacriticals_FOR_Symbols}', "");
    Expect(1, 8448, '\P{ diacriticals_FOR_Symbols}', "");
    Expect(0, 8448, '\P{^ diacriticals_FOR_Symbols}', "");
    Error('\p{IS_DIACRITICALS_for_Symbols:=}');
    Error('\P{IS_DIACRITICALS_for_Symbols:=}');
    Expect(1, 8447, '\p{isdiacriticalsforsymbols}', "");
    Expect(0, 8447, '\p{^isdiacriticalsforsymbols}', "");
    Expect(0, 8447, '\P{isdiacriticalsforsymbols}', "");
    Expect(1, 8447, '\P{^isdiacriticalsforsymbols}', "");
    Expect(0, 8448, '\p{isdiacriticalsforsymbols}', "");
    Expect(1, 8448, '\p{^isdiacriticalsforsymbols}', "");
    Expect(1, 8448, '\P{isdiacriticalsforsymbols}', "");
    Expect(0, 8448, '\P{^isdiacriticalsforsymbols}', "");
    Expect(1, 8447, '\p{	is_diacriticals_for_Symbols}', "");
    Expect(0, 8447, '\p{^	is_diacriticals_for_Symbols}', "");
    Expect(0, 8447, '\P{	is_diacriticals_for_Symbols}', "");
    Expect(1, 8447, '\P{^	is_diacriticals_for_Symbols}', "");
    Expect(0, 8448, '\p{	is_diacriticals_for_Symbols}', "");
    Expect(1, 8448, '\p{^	is_diacriticals_for_Symbols}', "");
    Expect(1, 8448, '\P{	is_diacriticals_for_Symbols}', "");
    Expect(0, 8448, '\P{^	is_diacriticals_for_Symbols}', "");
    Error('\p{	-In_diacriticals_for_Symbols:=}');
    Error('\P{	-In_diacriticals_for_Symbols:=}');
    Expect(1, 8447, '\p{indiacriticalsforsymbols}', "");
    Expect(0, 8447, '\p{^indiacriticalsforsymbols}', "");
    Expect(0, 8447, '\P{indiacriticalsforsymbols}', "");
    Expect(1, 8447, '\P{^indiacriticalsforsymbols}', "");
    Expect(0, 8448, '\p{indiacriticalsforsymbols}', "");
    Expect(1, 8448, '\p{^indiacriticalsforsymbols}', "");
    Expect(1, 8448, '\P{indiacriticalsforsymbols}', "");
    Expect(0, 8448, '\P{^indiacriticalsforsymbols}', "");
    Expect(1, 8447, '\p{__In_diacriticals_FOR_SYMBOLS}', "");
    Expect(0, 8447, '\p{^__In_diacriticals_FOR_SYMBOLS}', "");
    Expect(0, 8447, '\P{__In_diacriticals_FOR_SYMBOLS}', "");
    Expect(1, 8447, '\P{^__In_diacriticals_FOR_SYMBOLS}', "");
    Expect(0, 8448, '\p{__In_diacriticals_FOR_SYMBOLS}', "");
    Expect(1, 8448, '\p{^__In_diacriticals_FOR_SYMBOLS}', "");
    Expect(1, 8448, '\P{__In_diacriticals_FOR_SYMBOLS}', "");
    Expect(0, 8448, '\P{^__In_diacriticals_FOR_SYMBOLS}', "");
    Error('\p{__Combining_Marks_For_SYMBOLS/a/}');
    Error('\P{__Combining_Marks_For_SYMBOLS/a/}');
    Expect(1, 8447, '\p{combiningmarksforsymbols}', "");
    Expect(0, 8447, '\p{^combiningmarksforsymbols}', "");
    Expect(0, 8447, '\P{combiningmarksforsymbols}', "");
    Expect(1, 8447, '\P{^combiningmarksforsymbols}', "");
    Expect(0, 8448, '\p{combiningmarksforsymbols}', "");
    Expect(1, 8448, '\p{^combiningmarksforsymbols}', "");
    Expect(1, 8448, '\P{combiningmarksforsymbols}', "");
    Expect(0, 8448, '\P{^combiningmarksforsymbols}', "");
    Expect(1, 8447, '\p{	_Combining_marks_FOR_Symbols}', "");
    Expect(0, 8447, '\p{^	_Combining_marks_FOR_Symbols}', "");
    Expect(0, 8447, '\P{	_Combining_marks_FOR_Symbols}', "");
    Expect(1, 8447, '\P{^	_Combining_marks_FOR_Symbols}', "");
    Expect(0, 8448, '\p{	_Combining_marks_FOR_Symbols}', "");
    Expect(1, 8448, '\p{^	_Combining_marks_FOR_Symbols}', "");
    Expect(1, 8448, '\P{	_Combining_marks_FOR_Symbols}', "");
    Expect(0, 8448, '\P{^	_Combining_marks_FOR_Symbols}', "");
    Error('\p{ /a/IS_COMBINING_Marks_for_Symbols}');
    Error('\P{ /a/IS_COMBINING_Marks_for_Symbols}');
    Expect(1, 8447, '\p{iscombiningmarksforsymbols}', "");
    Expect(0, 8447, '\p{^iscombiningmarksforsymbols}', "");
    Expect(0, 8447, '\P{iscombiningmarksforsymbols}', "");
    Expect(1, 8447, '\P{^iscombiningmarksforsymbols}', "");
    Expect(0, 8448, '\p{iscombiningmarksforsymbols}', "");
    Expect(1, 8448, '\p{^iscombiningmarksforsymbols}', "");
    Expect(1, 8448, '\P{iscombiningmarksforsymbols}', "");
    Expect(0, 8448, '\P{^iscombiningmarksforsymbols}', "");
    Expect(1, 8447, '\p{	 is_combining_Marks_FOR_SYMBOLS}', "");
    Expect(0, 8447, '\p{^	 is_combining_Marks_FOR_SYMBOLS}', "");
    Expect(0, 8447, '\P{	 is_combining_Marks_FOR_SYMBOLS}', "");
    Expect(1, 8447, '\P{^	 is_combining_Marks_FOR_SYMBOLS}', "");
    Expect(0, 8448, '\p{	 is_combining_Marks_FOR_SYMBOLS}', "");
    Expect(1, 8448, '\p{^	 is_combining_Marks_FOR_SYMBOLS}', "");
    Expect(1, 8448, '\P{	 is_combining_Marks_FOR_SYMBOLS}', "");
    Expect(0, 8448, '\P{^	 is_combining_Marks_FOR_SYMBOLS}', "");
    Error('\p{ :=IN_Combining_marks_for_symbols}');
    Error('\P{ :=IN_Combining_marks_for_symbols}');
    Expect(1, 8447, '\p{incombiningmarksforsymbols}', "");
    Expect(0, 8447, '\p{^incombiningmarksforsymbols}', "");
    Expect(0, 8447, '\P{incombiningmarksforsymbols}', "");
    Expect(1, 8447, '\P{^incombiningmarksforsymbols}', "");
    Expect(0, 8448, '\p{incombiningmarksforsymbols}', "");
    Expect(1, 8448, '\p{^incombiningmarksforsymbols}', "");
    Expect(1, 8448, '\P{incombiningmarksforsymbols}', "");
    Expect(0, 8448, '\P{^incombiningmarksforsymbols}', "");
    Expect(1, 8447, '\p{-In_Combining_Marks_For_Symbols}', "");
    Expect(0, 8447, '\p{^-In_Combining_Marks_For_Symbols}', "");
    Expect(0, 8447, '\P{-In_Combining_Marks_For_Symbols}', "");
    Expect(1, 8447, '\P{^-In_Combining_Marks_For_Symbols}', "");
    Expect(0, 8448, '\p{-In_Combining_Marks_For_Symbols}', "");
    Expect(1, 8448, '\p{^-In_Combining_Marks_For_Symbols}', "");
    Expect(1, 8448, '\P{-In_Combining_Marks_For_Symbols}', "");
    Expect(0, 8448, '\P{^-In_Combining_Marks_For_Symbols}', "");
    Error('\p{-:=Combining_Diacritical_MARKS_Supplement}');
    Error('\P{-:=Combining_Diacritical_MARKS_Supplement}');
    Expect(1, 7679, '\p{combiningdiacriticalmarkssupplement}', "");
    Expect(0, 7679, '\p{^combiningdiacriticalmarkssupplement}', "");
    Expect(0, 7679, '\P{combiningdiacriticalmarkssupplement}', "");
    Expect(1, 7679, '\P{^combiningdiacriticalmarkssupplement}', "");
    Expect(0, 7680, '\p{combiningdiacriticalmarkssupplement}', "");
    Expect(1, 7680, '\p{^combiningdiacriticalmarkssupplement}', "");
    Expect(1, 7680, '\P{combiningdiacriticalmarkssupplement}', "");
    Expect(0, 7680, '\P{^combiningdiacriticalmarkssupplement}', "");
    Expect(1, 7679, '\p{-_Combining_Diacritical_marks_supplement}', "");
    Expect(0, 7679, '\p{^-_Combining_Diacritical_marks_supplement}', "");
    Expect(0, 7679, '\P{-_Combining_Diacritical_marks_supplement}', "");
    Expect(1, 7679, '\P{^-_Combining_Diacritical_marks_supplement}', "");
    Expect(0, 7680, '\p{-_Combining_Diacritical_marks_supplement}', "");
    Expect(1, 7680, '\p{^-_Combining_Diacritical_marks_supplement}', "");
    Expect(1, 7680, '\P{-_Combining_Diacritical_marks_supplement}', "");
    Expect(0, 7680, '\P{^-_Combining_Diacritical_marks_supplement}', "");
    Error('\p{_-IS_Combining_DIACRITICAL_Marks_supplement:=}');
    Error('\P{_-IS_Combining_DIACRITICAL_Marks_supplement:=}');
    Expect(1, 7679, '\p{iscombiningdiacriticalmarkssupplement}', "");
    Expect(0, 7679, '\p{^iscombiningdiacriticalmarkssupplement}', "");
    Expect(0, 7679, '\P{iscombiningdiacriticalmarkssupplement}', "");
    Expect(1, 7679, '\P{^iscombiningdiacriticalmarkssupplement}', "");
    Expect(0, 7680, '\p{iscombiningdiacriticalmarkssupplement}', "");
    Expect(1, 7680, '\p{^iscombiningdiacriticalmarkssupplement}', "");
    Expect(1, 7680, '\P{iscombiningdiacriticalmarkssupplement}', "");
    Expect(0, 7680, '\P{^iscombiningdiacriticalmarkssupplement}', "");
    Expect(1, 7679, '\p{ 	is_Combining_Diacritical_marks_supplement}', "");
    Expect(0, 7679, '\p{^ 	is_Combining_Diacritical_marks_supplement}', "");
    Expect(0, 7679, '\P{ 	is_Combining_Diacritical_marks_supplement}', "");
    Expect(1, 7679, '\P{^ 	is_Combining_Diacritical_marks_supplement}', "");
    Expect(0, 7680, '\p{ 	is_Combining_Diacritical_marks_supplement}', "");
    Expect(1, 7680, '\p{^ 	is_Combining_Diacritical_marks_supplement}', "");
    Expect(1, 7680, '\P{ 	is_Combining_Diacritical_marks_supplement}', "");
    Expect(0, 7680, '\P{^ 	is_Combining_Diacritical_marks_supplement}', "");
    Error('\p{:= _IN_combining_Diacritical_Marks_supplement}');
    Error('\P{:= _IN_combining_Diacritical_Marks_supplement}');
    Expect(1, 7679, '\p{incombiningdiacriticalmarkssupplement}', "");
    Expect(0, 7679, '\p{^incombiningdiacriticalmarkssupplement}', "");
    Expect(0, 7679, '\P{incombiningdiacriticalmarkssupplement}', "");
    Expect(1, 7679, '\P{^incombiningdiacriticalmarkssupplement}', "");
    Expect(0, 7680, '\p{incombiningdiacriticalmarkssupplement}', "");
    Expect(1, 7680, '\p{^incombiningdiacriticalmarkssupplement}', "");
    Expect(1, 7680, '\P{incombiningdiacriticalmarkssupplement}', "");
    Expect(0, 7680, '\P{^incombiningdiacriticalmarkssupplement}', "");
    Expect(1, 7679, '\p{- in_Combining_Diacritical_Marks_Supplement}', "");
    Expect(0, 7679, '\p{^- in_Combining_Diacritical_Marks_Supplement}', "");
    Expect(0, 7679, '\P{- in_Combining_Diacritical_Marks_Supplement}', "");
    Expect(1, 7679, '\P{^- in_Combining_Diacritical_Marks_Supplement}', "");
    Expect(0, 7680, '\p{- in_Combining_Diacritical_Marks_Supplement}', "");
    Expect(1, 7680, '\p{^- in_Combining_Diacritical_Marks_Supplement}', "");
    Expect(1, 7680, '\P{- in_Combining_Diacritical_Marks_Supplement}', "");
    Expect(0, 7680, '\P{^- in_Combining_Diacritical_Marks_Supplement}', "");
    Error('\p{ Diacriticals_Sup/a/}');
    Error('\P{ Diacriticals_Sup/a/}');
    Expect(1, 7679, '\p{diacriticalssup}', "");
    Expect(0, 7679, '\p{^diacriticalssup}', "");
    Expect(0, 7679, '\P{diacriticalssup}', "");
    Expect(1, 7679, '\P{^diacriticalssup}', "");
    Expect(0, 7680, '\p{diacriticalssup}', "");
    Expect(1, 7680, '\p{^diacriticalssup}', "");
    Expect(1, 7680, '\P{diacriticalssup}', "");
    Expect(0, 7680, '\P{^diacriticalssup}', "");
    Expect(1, 7679, '\p{DIACRITICALS_Sup}', "");
    Expect(0, 7679, '\p{^DIACRITICALS_Sup}', "");
    Expect(0, 7679, '\P{DIACRITICALS_Sup}', "");
    Expect(1, 7679, '\P{^DIACRITICALS_Sup}', "");
    Expect(0, 7680, '\p{DIACRITICALS_Sup}', "");
    Expect(1, 7680, '\p{^DIACRITICALS_Sup}', "");
    Expect(1, 7680, '\P{DIACRITICALS_Sup}', "");
    Expect(0, 7680, '\P{^DIACRITICALS_Sup}', "");
    Error('\p{_/a/IS_diacriticals_Sup}');
    Error('\P{_/a/IS_diacriticals_Sup}');
    Expect(1, 7679, '\p{isdiacriticalssup}', "");
    Expect(0, 7679, '\p{^isdiacriticalssup}', "");
    Expect(0, 7679, '\P{isdiacriticalssup}', "");
    Expect(1, 7679, '\P{^isdiacriticalssup}', "");
    Expect(0, 7680, '\p{isdiacriticalssup}', "");
    Expect(1, 7680, '\p{^isdiacriticalssup}', "");
    Expect(1, 7680, '\P{isdiacriticalssup}', "");
    Expect(0, 7680, '\P{^isdiacriticalssup}', "");
    Expect(1, 7679, '\p{_	IS_Diacriticals_sup}', "");
    Expect(0, 7679, '\p{^_	IS_Diacriticals_sup}', "");
    Expect(0, 7679, '\P{_	IS_Diacriticals_sup}', "");
    Expect(1, 7679, '\P{^_	IS_Diacriticals_sup}', "");
    Expect(0, 7680, '\p{_	IS_Diacriticals_sup}', "");
    Expect(1, 7680, '\p{^_	IS_Diacriticals_sup}', "");
    Expect(1, 7680, '\P{_	IS_Diacriticals_sup}', "");
    Expect(0, 7680, '\P{^_	IS_Diacriticals_sup}', "");
    Error('\p{/a/	_In_diacriticals_Sup}');
    Error('\P{/a/	_In_diacriticals_Sup}');
    Expect(1, 7679, '\p{indiacriticalssup}', "");
    Expect(0, 7679, '\p{^indiacriticalssup}', "");
    Expect(0, 7679, '\P{indiacriticalssup}', "");
    Expect(1, 7679, '\P{^indiacriticalssup}', "");
    Expect(0, 7680, '\p{indiacriticalssup}', "");
    Expect(1, 7680, '\p{^indiacriticalssup}', "");
    Expect(1, 7680, '\P{indiacriticalssup}', "");
    Expect(0, 7680, '\P{^indiacriticalssup}', "");
    Expect(1, 7679, '\p{_-IN_diacriticals_SUP}', "");
    Expect(0, 7679, '\p{^_-IN_diacriticals_SUP}', "");
    Expect(0, 7679, '\P{_-IN_diacriticals_SUP}', "");
    Expect(1, 7679, '\P{^_-IN_diacriticals_SUP}', "");
    Expect(0, 7680, '\p{_-IN_diacriticals_SUP}', "");
    Expect(1, 7680, '\p{^_-IN_diacriticals_SUP}', "");
    Expect(1, 7680, '\P{_-IN_diacriticals_SUP}', "");
    Expect(0, 7680, '\P{^_-IN_diacriticals_SUP}', "");
    Error('\p{/a/_ combining_HALF_Marks}');
    Error('\P{/a/_ combining_HALF_Marks}');
    Expect(1, 65071, '\p{combininghalfmarks}', "");
    Expect(0, 65071, '\p{^combininghalfmarks}', "");
    Expect(0, 65071, '\P{combininghalfmarks}', "");
    Expect(1, 65071, '\P{^combininghalfmarks}', "");
    Expect(0, 65072, '\p{combininghalfmarks}', "");
    Expect(1, 65072, '\p{^combininghalfmarks}', "");
    Expect(1, 65072, '\P{combininghalfmarks}', "");
    Expect(0, 65072, '\P{^combininghalfmarks}', "");
    Expect(1, 65071, '\p{- Combining_Half_marks}', "");
    Expect(0, 65071, '\p{^- Combining_Half_marks}', "");
    Expect(0, 65071, '\P{- Combining_Half_marks}', "");
    Expect(1, 65071, '\P{^- Combining_Half_marks}', "");
    Expect(0, 65072, '\p{- Combining_Half_marks}', "");
    Expect(1, 65072, '\p{^- Combining_Half_marks}', "");
    Expect(1, 65072, '\P{- Combining_Half_marks}', "");
    Expect(0, 65072, '\P{^- Combining_Half_marks}', "");
    Error('\p{ /a/Is_combining_HALF_Marks}');
    Error('\P{ /a/Is_combining_HALF_Marks}');
    Expect(1, 65071, '\p{iscombininghalfmarks}', "");
    Expect(0, 65071, '\p{^iscombininghalfmarks}', "");
    Expect(0, 65071, '\P{iscombininghalfmarks}', "");
    Expect(1, 65071, '\P{^iscombininghalfmarks}', "");
    Expect(0, 65072, '\p{iscombininghalfmarks}', "");
    Expect(1, 65072, '\p{^iscombininghalfmarks}', "");
    Expect(1, 65072, '\P{iscombininghalfmarks}', "");
    Expect(0, 65072, '\P{^iscombininghalfmarks}', "");
    Expect(1, 65071, '\p{_	is_combining_Half_Marks}', "");
    Expect(0, 65071, '\p{^_	is_combining_Half_Marks}', "");
    Expect(0, 65071, '\P{_	is_combining_Half_Marks}', "");
    Expect(1, 65071, '\P{^_	is_combining_Half_Marks}', "");
    Expect(0, 65072, '\p{_	is_combining_Half_Marks}', "");
    Expect(1, 65072, '\p{^_	is_combining_Half_Marks}', "");
    Expect(1, 65072, '\P{_	is_combining_Half_Marks}', "");
    Expect(0, 65072, '\P{^_	is_combining_Half_Marks}', "");
    Error('\p{_In_COMBINING_half_Marks:=}');
    Error('\P{_In_COMBINING_half_Marks:=}');
    Expect(1, 65071, '\p{incombininghalfmarks}', "");
    Expect(0, 65071, '\p{^incombininghalfmarks}', "");
    Expect(0, 65071, '\P{incombininghalfmarks}', "");
    Expect(1, 65071, '\P{^incombininghalfmarks}', "");
    Expect(0, 65072, '\p{incombininghalfmarks}', "");
    Expect(1, 65072, '\p{^incombininghalfmarks}', "");
    Expect(1, 65072, '\P{incombininghalfmarks}', "");
    Expect(0, 65072, '\P{^incombininghalfmarks}', "");
    Expect(1, 65071, '\p{--in_combining_Half_marks}', "");
    Expect(0, 65071, '\p{^--in_combining_Half_marks}', "");
    Expect(0, 65071, '\P{--in_combining_Half_marks}', "");
    Expect(1, 65071, '\P{^--in_combining_Half_marks}', "");
    Expect(0, 65072, '\p{--in_combining_Half_marks}', "");
    Expect(1, 65072, '\p{^--in_combining_Half_marks}', "");
    Expect(1, 65072, '\P{--in_combining_Half_marks}', "");
    Expect(0, 65072, '\P{^--in_combining_Half_marks}', "");
    Error('\p{ Half_Marks/a/}');
    Error('\P{ Half_Marks/a/}');
    Expect(1, 65071, '\p{halfmarks}', "");
    Expect(0, 65071, '\p{^halfmarks}', "");
    Expect(0, 65071, '\P{halfmarks}', "");
    Expect(1, 65071, '\P{^halfmarks}', "");
    Expect(0, 65072, '\p{halfmarks}', "");
    Expect(1, 65072, '\p{^halfmarks}', "");
    Expect(1, 65072, '\P{halfmarks}', "");
    Expect(0, 65072, '\P{^halfmarks}', "");
    Expect(1, 65071, '\p{ -Half_marks}', "");
    Expect(0, 65071, '\p{^ -Half_marks}', "");
    Expect(0, 65071, '\P{ -Half_marks}', "");
    Expect(1, 65071, '\P{^ -Half_marks}', "");
    Expect(0, 65072, '\p{ -Half_marks}', "");
    Expect(1, 65072, '\p{^ -Half_marks}', "");
    Expect(1, 65072, '\P{ -Half_marks}', "");
    Expect(0, 65072, '\P{^ -Half_marks}', "");
    Error('\p{:=	Is_Half_marks}');
    Error('\P{:=	Is_Half_marks}');
    Expect(1, 65071, '\p{ishalfmarks}', "");
    Expect(0, 65071, '\p{^ishalfmarks}', "");
    Expect(0, 65071, '\P{ishalfmarks}', "");
    Expect(1, 65071, '\P{^ishalfmarks}', "");
    Expect(0, 65072, '\p{ishalfmarks}', "");
    Expect(1, 65072, '\p{^ishalfmarks}', "");
    Expect(1, 65072, '\P{ishalfmarks}', "");
    Expect(0, 65072, '\P{^ishalfmarks}', "");
    Expect(1, 65071, '\p{_ Is_half_marks}', "");
    Expect(0, 65071, '\p{^_ Is_half_marks}', "");
    Expect(0, 65071, '\P{_ Is_half_marks}', "");
    Expect(1, 65071, '\P{^_ Is_half_marks}', "");
    Expect(0, 65072, '\p{_ Is_half_marks}', "");
    Expect(1, 65072, '\p{^_ Is_half_marks}', "");
    Expect(1, 65072, '\P{_ Is_half_marks}', "");
    Expect(0, 65072, '\P{^_ Is_half_marks}', "");
    Error('\p{ /a/In_Half_marks}');
    Error('\P{ /a/In_Half_marks}');
    Expect(1, 65071, '\p{inhalfmarks}', "");
    Expect(0, 65071, '\p{^inhalfmarks}', "");
    Expect(0, 65071, '\P{inhalfmarks}', "");
    Expect(1, 65071, '\P{^inhalfmarks}', "");
    Expect(0, 65072, '\p{inhalfmarks}', "");
    Expect(1, 65072, '\p{^inhalfmarks}', "");
    Expect(1, 65072, '\P{inhalfmarks}', "");
    Expect(0, 65072, '\P{^inhalfmarks}', "");
    Expect(1, 65071, '\p{In_HALF_marks}', "");
    Expect(0, 65071, '\p{^In_HALF_marks}', "");
    Expect(0, 65071, '\P{In_HALF_marks}', "");
    Expect(1, 65071, '\P{^In_HALF_marks}', "");
    Expect(0, 65072, '\p{In_HALF_marks}', "");
    Expect(1, 65072, '\p{^In_HALF_marks}', "");
    Expect(1, 65072, '\P{In_HALF_marks}', "");
    Expect(0, 65072, '\P{^In_HALF_marks}', "");
    Error('\p{_ Common/a/}');
    Error('\P{_ Common/a/}');
    Expect(1, 917631, '\p{common}', "");
    Expect(0, 917631, '\p{^common}', "");
    Expect(0, 917631, '\P{common}', "");
    Expect(1, 917631, '\P{^common}', "");
    Expect(0, 917632, '\p{common}', "");
    Expect(1, 917632, '\p{^common}', "");
    Expect(1, 917632, '\P{common}', "");
    Expect(0, 917632, '\P{^common}', "");
    Expect(1, 917631, '\p{_-Common}', "");
    Expect(0, 917631, '\p{^_-Common}', "");
    Expect(0, 917631, '\P{_-Common}', "");
    Expect(1, 917631, '\P{^_-Common}', "");
    Expect(0, 917632, '\p{_-Common}', "");
    Expect(1, 917632, '\p{^_-Common}', "");
    Expect(1, 917632, '\P{_-Common}', "");
    Expect(0, 917632, '\P{^_-Common}', "");
    Error('\p{_ Is_Common:=}');
    Error('\P{_ Is_Common:=}');
    Expect(1, 917631, '\p{iscommon}', "");
    Expect(0, 917631, '\p{^iscommon}', "");
    Expect(0, 917631, '\P{iscommon}', "");
    Expect(1, 917631, '\P{^iscommon}', "");
    Expect(0, 917632, '\p{iscommon}', "");
    Expect(1, 917632, '\p{^iscommon}', "");
    Expect(1, 917632, '\P{iscommon}', "");
    Expect(0, 917632, '\P{^iscommon}', "");
    Expect(1, 917631, '\p{_	Is_Common}', "");
    Expect(0, 917631, '\p{^_	Is_Common}', "");
    Expect(0, 917631, '\P{_	Is_Common}', "");
    Expect(1, 917631, '\P{^_	Is_Common}', "");
    Expect(0, 917632, '\p{_	Is_Common}', "");
    Expect(1, 917632, '\p{^_	Is_Common}', "");
    Expect(1, 917632, '\P{_	Is_Common}', "");
    Expect(0, 917632, '\P{^_	Is_Common}', "");
    Error('\p{ /a/ZYYY}');
    Error('\P{ /a/ZYYY}');
    Expect(1, 917631, '\p{zyyy}', "");
    Expect(0, 917631, '\p{^zyyy}', "");
    Expect(0, 917631, '\P{zyyy}', "");
    Expect(1, 917631, '\P{^zyyy}', "");
    Expect(0, 917632, '\p{zyyy}', "");
    Expect(1, 917632, '\p{^zyyy}', "");
    Expect(1, 917632, '\P{zyyy}', "");
    Expect(0, 917632, '\P{^zyyy}', "");
    Expect(1, 917631, '\p{_	Zyyy}', "");
    Expect(0, 917631, '\p{^_	Zyyy}', "");
    Expect(0, 917631, '\P{_	Zyyy}', "");
    Expect(1, 917631, '\P{^_	Zyyy}', "");
    Expect(0, 917632, '\p{_	Zyyy}', "");
    Expect(1, 917632, '\p{^_	Zyyy}', "");
    Expect(1, 917632, '\P{_	Zyyy}', "");
    Expect(0, 917632, '\P{^_	Zyyy}', "");
    Error('\p{	:=Is_Zyyy}');
    Error('\P{	:=Is_Zyyy}');
    Expect(1, 917631, '\p{iszyyy}', "");
    Expect(0, 917631, '\p{^iszyyy}', "");
    Expect(0, 917631, '\P{iszyyy}', "");
    Expect(1, 917631, '\P{^iszyyy}', "");
    Expect(0, 917632, '\p{iszyyy}', "");
    Expect(1, 917632, '\p{^iszyyy}', "");
    Expect(1, 917632, '\P{iszyyy}', "");
    Expect(0, 917632, '\P{^iszyyy}', "");
    Expect(1, 917631, '\p{__Is_zyyy}', "");
    Expect(0, 917631, '\p{^__Is_zyyy}', "");
    Expect(0, 917631, '\P{__Is_zyyy}', "");
    Expect(1, 917631, '\P{^__Is_zyyy}', "");
    Expect(0, 917632, '\p{__Is_zyyy}', "");
    Expect(1, 917632, '\p{^__Is_zyyy}', "");
    Expect(1, 917632, '\P{__Is_zyyy}', "");
    Expect(0, 917632, '\P{^__Is_zyyy}', "");
    Error('\p{_Common_INDIC_NUMBER_Forms/a/}');
    Error('\P{_Common_INDIC_NUMBER_Forms/a/}');
    Expect(1, 43071, '\p{commonindicnumberforms}', "");
    Expect(0, 43071, '\p{^commonindicnumberforms}', "");
    Expect(0, 43071, '\P{commonindicnumberforms}', "");
    Expect(1, 43071, '\P{^commonindicnumberforms}', "");
    Expect(0, 43072, '\p{commonindicnumberforms}', "");
    Expect(1, 43072, '\p{^commonindicnumberforms}', "");
    Expect(1, 43072, '\P{commonindicnumberforms}', "");
    Expect(0, 43072, '\P{^commonindicnumberforms}', "");
    Expect(1, 43071, '\p{__common_indic_Number_Forms}', "");
    Expect(0, 43071, '\p{^__common_indic_Number_Forms}', "");
    Expect(0, 43071, '\P{__common_indic_Number_Forms}', "");
    Expect(1, 43071, '\P{^__common_indic_Number_Forms}', "");
    Expect(0, 43072, '\p{__common_indic_Number_Forms}', "");
    Expect(1, 43072, '\p{^__common_indic_Number_Forms}', "");
    Expect(1, 43072, '\P{__common_indic_Number_Forms}', "");
    Expect(0, 43072, '\P{^__common_indic_Number_Forms}', "");
    Error('\p{	:=IS_common_Indic_number_forms}');
    Error('\P{	:=IS_common_Indic_number_forms}');
    Expect(1, 43071, '\p{iscommonindicnumberforms}', "");
    Expect(0, 43071, '\p{^iscommonindicnumberforms}', "");
    Expect(0, 43071, '\P{iscommonindicnumberforms}', "");
    Expect(1, 43071, '\P{^iscommonindicnumberforms}', "");
    Expect(0, 43072, '\p{iscommonindicnumberforms}', "");
    Expect(1, 43072, '\p{^iscommonindicnumberforms}', "");
    Expect(1, 43072, '\P{iscommonindicnumberforms}', "");
    Expect(0, 43072, '\P{^iscommonindicnumberforms}', "");
    Expect(1, 43071, '\p{		IS_COMMON_Indic_Number_FORMS}', "");
    Expect(0, 43071, '\p{^		IS_COMMON_Indic_Number_FORMS}', "");
    Expect(0, 43071, '\P{		IS_COMMON_Indic_Number_FORMS}', "");
    Expect(1, 43071, '\P{^		IS_COMMON_Indic_Number_FORMS}', "");
    Expect(0, 43072, '\p{		IS_COMMON_Indic_Number_FORMS}', "");
    Expect(1, 43072, '\p{^		IS_COMMON_Indic_Number_FORMS}', "");
    Expect(1, 43072, '\P{		IS_COMMON_Indic_Number_FORMS}', "");
    Expect(0, 43072, '\P{^		IS_COMMON_Indic_Number_FORMS}', "");
    Error('\p{ In_COMMON_Indic_Number_forms/a/}');
    Error('\P{ In_COMMON_Indic_Number_forms/a/}');
    Expect(1, 43071, '\p{incommonindicnumberforms}', "");
    Expect(0, 43071, '\p{^incommonindicnumberforms}', "");
    Expect(0, 43071, '\P{incommonindicnumberforms}', "");
    Expect(1, 43071, '\P{^incommonindicnumberforms}', "");
    Expect(0, 43072, '\p{incommonindicnumberforms}', "");
    Expect(1, 43072, '\p{^incommonindicnumberforms}', "");
    Expect(1, 43072, '\P{incommonindicnumberforms}', "");
    Expect(0, 43072, '\P{^incommonindicnumberforms}', "");
    Expect(1, 43071, '\p{		In_Common_Indic_NUMBER_Forms}', "");
    Expect(0, 43071, '\p{^		In_Common_Indic_NUMBER_Forms}', "");
    Expect(0, 43071, '\P{		In_Common_Indic_NUMBER_Forms}', "");
    Expect(1, 43071, '\P{^		In_Common_Indic_NUMBER_Forms}', "");
    Expect(0, 43072, '\p{		In_Common_Indic_NUMBER_Forms}', "");
    Expect(1, 43072, '\p{^		In_Common_Indic_NUMBER_Forms}', "");
    Expect(1, 43072, '\P{		In_Common_Indic_NUMBER_Forms}', "");
    Expect(0, 43072, '\P{^		In_Common_Indic_NUMBER_Forms}', "");
    Error('\p{/a/__INDIC_Number_Forms}');
    Error('\P{/a/__INDIC_Number_Forms}');
    Expect(1, 43071, '\p{indicnumberforms}', "");
    Expect(0, 43071, '\p{^indicnumberforms}', "");
    Expect(0, 43071, '\P{indicnumberforms}', "");
    Expect(1, 43071, '\P{^indicnumberforms}', "");
    Expect(0, 43072, '\p{indicnumberforms}', "");
    Expect(1, 43072, '\p{^indicnumberforms}', "");
    Expect(1, 43072, '\P{indicnumberforms}', "");
    Expect(0, 43072, '\P{^indicnumberforms}', "");
    Expect(1, 43071, '\p{ _Indic_number_Forms}', "");
    Expect(0, 43071, '\p{^ _Indic_number_Forms}', "");
    Expect(0, 43071, '\P{ _Indic_number_Forms}', "");
    Expect(1, 43071, '\P{^ _Indic_number_Forms}', "");
    Expect(0, 43072, '\p{ _Indic_number_Forms}', "");
    Expect(1, 43072, '\p{^ _Indic_number_Forms}', "");
    Expect(1, 43072, '\P{ _Indic_number_Forms}', "");
    Expect(0, 43072, '\P{^ _Indic_number_Forms}', "");
    Error('\p{-:=IS_Indic_Number_Forms}');
    Error('\P{-:=IS_Indic_Number_Forms}');
    Expect(1, 43071, '\p{isindicnumberforms}', "");
    Expect(0, 43071, '\p{^isindicnumberforms}', "");
    Expect(0, 43071, '\P{isindicnumberforms}', "");
    Expect(1, 43071, '\P{^isindicnumberforms}', "");
    Expect(0, 43072, '\p{isindicnumberforms}', "");
    Expect(1, 43072, '\p{^isindicnumberforms}', "");
    Expect(1, 43072, '\P{isindicnumberforms}', "");
    Expect(0, 43072, '\P{^isindicnumberforms}', "");
    Expect(1, 43071, '\p{		Is_INDIC_number_FORMS}', "");
    Expect(0, 43071, '\p{^		Is_INDIC_number_FORMS}', "");
    Expect(0, 43071, '\P{		Is_INDIC_number_FORMS}', "");
    Expect(1, 43071, '\P{^		Is_INDIC_number_FORMS}', "");
    Expect(0, 43072, '\p{		Is_INDIC_number_FORMS}', "");
    Expect(1, 43072, '\p{^		Is_INDIC_number_FORMS}', "");
    Expect(1, 43072, '\P{		Is_INDIC_number_FORMS}', "");
    Expect(0, 43072, '\P{^		Is_INDIC_number_FORMS}', "");
    Error('\p{:= In_indic_Number_FORMS}');
    Error('\P{:= In_indic_Number_FORMS}');
    Expect(1, 43071, '\p{inindicnumberforms}', "");
    Expect(0, 43071, '\p{^inindicnumberforms}', "");
    Expect(0, 43071, '\P{inindicnumberforms}', "");
    Expect(1, 43071, '\P{^inindicnumberforms}', "");
    Expect(0, 43072, '\p{inindicnumberforms}', "");
    Expect(1, 43072, '\p{^inindicnumberforms}', "");
    Expect(1, 43072, '\P{inindicnumberforms}', "");
    Expect(0, 43072, '\P{^inindicnumberforms}', "");
    Expect(1, 43071, '\p{	_in_Indic_Number_FORMS}', "");
    Expect(0, 43071, '\p{^	_in_Indic_Number_FORMS}', "");
    Expect(0, 43071, '\P{	_in_Indic_Number_FORMS}', "");
    Expect(1, 43071, '\P{^	_in_Indic_Number_FORMS}', "");
    Expect(0, 43072, '\p{	_in_Indic_Number_FORMS}', "");
    Expect(1, 43072, '\p{^	_in_Indic_Number_FORMS}', "");
    Expect(1, 43072, '\P{	_in_Indic_Number_FORMS}', "");
    Expect(0, 43072, '\P{^	_in_Indic_Number_FORMS}', "");
    Error('\p{:=composition_Exclusion}');
    Error('\P{:=composition_Exclusion}');
    Expect(1, 119232, '\p{compositionexclusion}', "");
    Expect(0, 119232, '\p{^compositionexclusion}', "");
    Expect(0, 119232, '\P{compositionexclusion}', "");
    Expect(1, 119232, '\P{^compositionexclusion}', "");
    Expect(0, 119233, '\p{compositionexclusion}', "");
    Expect(1, 119233, '\p{^compositionexclusion}', "");
    Expect(1, 119233, '\P{compositionexclusion}', "");
    Expect(0, 119233, '\P{^compositionexclusion}', "");
    Expect(1, 119232, '\p{  composition_Exclusion}', "");
    Expect(0, 119232, '\p{^  composition_Exclusion}', "");
    Expect(0, 119232, '\P{  composition_Exclusion}', "");
    Expect(1, 119232, '\P{^  composition_Exclusion}', "");
    Expect(0, 119233, '\p{  composition_Exclusion}', "");
    Expect(1, 119233, '\p{^  composition_Exclusion}', "");
    Expect(1, 119233, '\P{  composition_Exclusion}', "");
    Expect(0, 119233, '\P{^  composition_Exclusion}', "");
    Error('\p{/a/		IS_composition_Exclusion}');
    Error('\P{/a/		IS_composition_Exclusion}');
    Expect(1, 119232, '\p{iscompositionexclusion}', "");
    Expect(0, 119232, '\p{^iscompositionexclusion}', "");
    Expect(0, 119232, '\P{iscompositionexclusion}', "");
    Expect(1, 119232, '\P{^iscompositionexclusion}', "");
    Expect(0, 119233, '\p{iscompositionexclusion}', "");
    Expect(1, 119233, '\p{^iscompositionexclusion}', "");
    Expect(1, 119233, '\P{iscompositionexclusion}', "");
    Expect(0, 119233, '\P{^iscompositionexclusion}', "");
    Expect(1, 119232, '\p{	IS_composition_EXCLUSION}', "");
    Expect(0, 119232, '\p{^	IS_composition_EXCLUSION}', "");
    Expect(0, 119232, '\P{	IS_composition_EXCLUSION}', "");
    Expect(1, 119232, '\P{^	IS_composition_EXCLUSION}', "");
    Expect(0, 119233, '\p{	IS_composition_EXCLUSION}', "");
    Expect(1, 119233, '\p{^	IS_composition_EXCLUSION}', "");
    Expect(1, 119233, '\P{	IS_composition_EXCLUSION}', "");
    Expect(0, 119233, '\P{^	IS_composition_EXCLUSION}', "");
    Error('\p{ :=CE}');
    Error('\P{ :=CE}');
    Expect(1, 119232, '\p{ce}', "");
    Expect(0, 119232, '\p{^ce}', "");
    Expect(0, 119232, '\P{ce}', "");
    Expect(1, 119232, '\P{^ce}', "");
    Expect(0, 119233, '\p{ce}', "");
    Expect(1, 119233, '\p{^ce}', "");
    Expect(1, 119233, '\P{ce}', "");
    Expect(0, 119233, '\P{^ce}', "");
    Expect(1, 119232, '\p{	_CE}', "");
    Expect(0, 119232, '\p{^	_CE}', "");
    Expect(0, 119232, '\P{	_CE}', "");
    Expect(1, 119232, '\P{^	_CE}', "");
    Expect(0, 119233, '\p{	_CE}', "");
    Expect(1, 119233, '\p{^	_CE}', "");
    Expect(1, 119233, '\P{	_CE}', "");
    Expect(0, 119233, '\P{^	_CE}', "");
    Error('\p{:=	Is_CE}');
    Error('\P{:=	Is_CE}');
    Expect(1, 119232, '\p{isce}', "");
    Expect(0, 119232, '\p{^isce}', "");
    Expect(0, 119232, '\P{isce}', "");
    Expect(1, 119232, '\P{^isce}', "");
    Expect(0, 119233, '\p{isce}', "");
    Expect(1, 119233, '\p{^isce}', "");
    Expect(1, 119233, '\P{isce}', "");
    Expect(0, 119233, '\P{^isce}', "");
    Expect(1, 119232, '\p{Is_CE}', "");
    Expect(0, 119232, '\p{^Is_CE}', "");
    Expect(0, 119232, '\P{Is_CE}', "");
    Expect(1, 119232, '\P{^Is_CE}', "");
    Expect(0, 119233, '\p{Is_CE}', "");
    Expect(1, 119233, '\p{^Is_CE}', "");
    Expect(1, 119233, '\P{Is_CE}', "");
    Expect(0, 119233, '\P{^Is_CE}', "");
    Error('\p{- connector_PUNCTUATION:=}');
    Error('\P{- connector_PUNCTUATION:=}');
    Expect(1, 65343, '\p{connectorpunctuation}', "");
    Expect(0, 65343, '\p{^connectorpunctuation}', "");
    Expect(0, 65343, '\P{connectorpunctuation}', "");
    Expect(1, 65343, '\P{^connectorpunctuation}', "");
    Expect(0, 65344, '\p{connectorpunctuation}', "");
    Expect(1, 65344, '\p{^connectorpunctuation}', "");
    Expect(1, 65344, '\P{connectorpunctuation}', "");
    Expect(0, 65344, '\P{^connectorpunctuation}', "");
    Expect(1, 65343, '\p{_CONNECTOR_PUNCTUATION}', "");
    Expect(0, 65343, '\p{^_CONNECTOR_PUNCTUATION}', "");
    Expect(0, 65343, '\P{_CONNECTOR_PUNCTUATION}', "");
    Expect(1, 65343, '\P{^_CONNECTOR_PUNCTUATION}', "");
    Expect(0, 65344, '\p{_CONNECTOR_PUNCTUATION}', "");
    Expect(1, 65344, '\p{^_CONNECTOR_PUNCTUATION}', "");
    Expect(1, 65344, '\P{_CONNECTOR_PUNCTUATION}', "");
    Expect(0, 65344, '\P{^_CONNECTOR_PUNCTUATION}', "");
    Error('\p{:=-	is_Connector_punctuation}');
    Error('\P{:=-	is_Connector_punctuation}');
    Expect(1, 65343, '\p{isconnectorpunctuation}', "");
    Expect(0, 65343, '\p{^isconnectorpunctuation}', "");
    Expect(0, 65343, '\P{isconnectorpunctuation}', "");
    Expect(1, 65343, '\P{^isconnectorpunctuation}', "");
    Expect(0, 65344, '\p{isconnectorpunctuation}', "");
    Expect(1, 65344, '\p{^isconnectorpunctuation}', "");
    Expect(1, 65344, '\P{isconnectorpunctuation}', "");
    Expect(0, 65344, '\P{^isconnectorpunctuation}', "");
    Expect(1, 65343, '\p{ Is_Connector_punctuation}', "");
    Expect(0, 65343, '\p{^ Is_Connector_punctuation}', "");
    Expect(0, 65343, '\P{ Is_Connector_punctuation}', "");
    Expect(1, 65343, '\P{^ Is_Connector_punctuation}', "");
    Expect(0, 65344, '\p{ Is_Connector_punctuation}', "");
    Expect(1, 65344, '\p{^ Is_Connector_punctuation}', "");
    Expect(1, 65344, '\P{ Is_Connector_punctuation}', "");
    Expect(0, 65344, '\P{^ Is_Connector_punctuation}', "");
    Error('\p{	:=pc}');
    Error('\P{	:=pc}');
    Expect(1, 65343, '\p{pc}', "");
    Expect(0, 65343, '\p{^pc}', "");
    Expect(0, 65343, '\P{pc}', "");
    Expect(1, 65343, '\P{^pc}', "");
    Expect(0, 65344, '\p{pc}', "");
    Expect(1, 65344, '\p{^pc}', "");
    Expect(1, 65344, '\P{pc}', "");
    Expect(0, 65344, '\P{^pc}', "");
    Expect(1, 65343, '\p{	pc}', "");
    Expect(0, 65343, '\p{^	pc}', "");
    Expect(0, 65343, '\P{	pc}', "");
    Expect(1, 65343, '\P{^	pc}', "");
    Expect(0, 65344, '\p{	pc}', "");
    Expect(1, 65344, '\p{^	pc}', "");
    Expect(1, 65344, '\P{	pc}', "");
    Expect(0, 65344, '\P{^	pc}', "");
    Error('\p{	Is_PC/a/}');
    Error('\P{	Is_PC/a/}');
    Expect(1, 65343, '\p{ispc}', "");
    Expect(0, 65343, '\p{^ispc}', "");
    Expect(0, 65343, '\P{ispc}', "");
    Expect(1, 65343, '\P{^ispc}', "");
    Expect(0, 65344, '\p{ispc}', "");
    Expect(1, 65344, '\p{^ispc}', "");
    Expect(1, 65344, '\P{ispc}', "");
    Expect(0, 65344, '\P{^ispc}', "");
    Expect(1, 65343, '\p{ -Is_Pc}', "");
    Expect(0, 65343, '\p{^ -Is_Pc}', "");
    Expect(0, 65343, '\P{ -Is_Pc}', "");
    Expect(1, 65343, '\P{^ -Is_Pc}', "");
    Expect(0, 65344, '\p{ -Is_Pc}', "");
    Expect(1, 65344, '\p{^ -Is_Pc}', "");
    Expect(1, 65344, '\P{ -Is_Pc}', "");
    Expect(0, 65344, '\P{^ -Is_Pc}', "");
    Error('\p{	control_PICTURES:=}');
    Error('\P{	control_PICTURES:=}');
    Expect(1, 9279, '\p{controlpictures}', "");
    Expect(0, 9279, '\p{^controlpictures}', "");
    Expect(0, 9279, '\P{controlpictures}', "");
    Expect(1, 9279, '\P{^controlpictures}', "");
    Expect(0, 9280, '\p{controlpictures}', "");
    Expect(1, 9280, '\p{^controlpictures}', "");
    Expect(1, 9280, '\P{controlpictures}', "");
    Expect(0, 9280, '\P{^controlpictures}', "");
    Expect(1, 9279, '\p{  Control_Pictures}', "");
    Expect(0, 9279, '\p{^  Control_Pictures}', "");
    Expect(0, 9279, '\P{  Control_Pictures}', "");
    Expect(1, 9279, '\P{^  Control_Pictures}', "");
    Expect(0, 9280, '\p{  Control_Pictures}', "");
    Expect(1, 9280, '\p{^  Control_Pictures}', "");
    Expect(1, 9280, '\P{  Control_Pictures}', "");
    Expect(0, 9280, '\P{^  Control_Pictures}', "");
    Error('\p{:=	 is_control_PICTURES}');
    Error('\P{:=	 is_control_PICTURES}');
    Expect(1, 9279, '\p{iscontrolpictures}', "");
    Expect(0, 9279, '\p{^iscontrolpictures}', "");
    Expect(0, 9279, '\P{iscontrolpictures}', "");
    Expect(1, 9279, '\P{^iscontrolpictures}', "");
    Expect(0, 9280, '\p{iscontrolpictures}', "");
    Expect(1, 9280, '\p{^iscontrolpictures}', "");
    Expect(1, 9280, '\P{iscontrolpictures}', "");
    Expect(0, 9280, '\P{^iscontrolpictures}', "");
    Expect(1, 9279, '\p{-_Is_control_Pictures}', "");
    Expect(0, 9279, '\p{^-_Is_control_Pictures}', "");
    Expect(0, 9279, '\P{-_Is_control_Pictures}', "");
    Expect(1, 9279, '\P{^-_Is_control_Pictures}', "");
    Expect(0, 9280, '\p{-_Is_control_Pictures}', "");
    Expect(1, 9280, '\p{^-_Is_control_Pictures}', "");
    Expect(1, 9280, '\P{-_Is_control_Pictures}', "");
    Expect(0, 9280, '\P{^-_Is_control_Pictures}', "");
    Error('\p{	/a/In_control_PICTURES}');
    Error('\P{	/a/In_control_PICTURES}');
    Expect(1, 9279, '\p{incontrolpictures}', "");
    Expect(0, 9279, '\p{^incontrolpictures}', "");
    Expect(0, 9279, '\P{incontrolpictures}', "");
    Expect(1, 9279, '\P{^incontrolpictures}', "");
    Expect(0, 9280, '\p{incontrolpictures}', "");
    Expect(1, 9280, '\p{^incontrolpictures}', "");
    Expect(1, 9280, '\P{incontrolpictures}', "");
    Expect(0, 9280, '\P{^incontrolpictures}', "");
    Expect(1, 9279, '\p{ in_Control_pictures}', "");
    Expect(0, 9279, '\p{^ in_Control_pictures}', "");
    Expect(0, 9279, '\P{ in_Control_pictures}', "");
    Expect(1, 9279, '\P{^ in_Control_pictures}', "");
    Expect(0, 9280, '\p{ in_Control_pictures}', "");
    Expect(1, 9280, '\p{^ in_Control_pictures}', "");
    Expect(1, 9280, '\P{ in_Control_pictures}', "");
    Expect(0, 9280, '\P{^ in_Control_pictures}', "");
    Error('\p{:= _COPTIC}');
    Error('\P{:= _COPTIC}');
    Expect(1, 66299, '\p{coptic}', "");
    Expect(0, 66299, '\p{^coptic}', "");
    Expect(0, 66299, '\P{coptic}', "");
    Expect(1, 66299, '\P{^coptic}', "");
    Expect(0, 66300, '\p{coptic}', "");
    Expect(1, 66300, '\p{^coptic}', "");
    Expect(1, 66300, '\P{coptic}', "");
    Expect(0, 66300, '\P{^coptic}', "");
    Expect(1, 66299, '\p{	Coptic}', "");
    Expect(0, 66299, '\p{^	Coptic}', "");
    Expect(0, 66299, '\P{	Coptic}', "");
    Expect(1, 66299, '\P{^	Coptic}', "");
    Expect(0, 66300, '\p{	Coptic}', "");
    Expect(1, 66300, '\p{^	Coptic}', "");
    Expect(1, 66300, '\P{	Coptic}', "");
    Expect(0, 66300, '\P{^	Coptic}', "");
    Error('\p{/a/ Is_COPTIC}');
    Error('\P{/a/ Is_COPTIC}');
    Expect(1, 66299, '\p{iscoptic}', "");
    Expect(0, 66299, '\p{^iscoptic}', "");
    Expect(0, 66299, '\P{iscoptic}', "");
    Expect(1, 66299, '\P{^iscoptic}', "");
    Expect(0, 66300, '\p{iscoptic}', "");
    Expect(1, 66300, '\p{^iscoptic}', "");
    Expect(1, 66300, '\P{iscoptic}', "");
    Expect(0, 66300, '\P{^iscoptic}', "");
    Expect(1, 66299, '\p{-	IS_coptic}', "");
    Expect(0, 66299, '\p{^-	IS_coptic}', "");
    Expect(0, 66299, '\P{-	IS_coptic}', "");
    Expect(1, 66299, '\P{^-	IS_coptic}', "");
    Expect(0, 66300, '\p{-	IS_coptic}', "");
    Expect(1, 66300, '\p{^-	IS_coptic}', "");
    Expect(1, 66300, '\P{-	IS_coptic}', "");
    Expect(0, 66300, '\P{^-	IS_coptic}', "");
    Error('\p{/a/ 	Copt}');
    Error('\P{/a/ 	Copt}');
    Expect(1, 66299, '\p{copt}', "");
    Expect(0, 66299, '\p{^copt}', "");
    Expect(0, 66299, '\P{copt}', "");
    Expect(1, 66299, '\P{^copt}', "");
    Expect(0, 66300, '\p{copt}', "");
    Expect(1, 66300, '\p{^copt}', "");
    Expect(1, 66300, '\P{copt}', "");
    Expect(0, 66300, '\P{^copt}', "");
    Expect(1, 66299, '\p{  Copt}', "");
    Expect(0, 66299, '\p{^  Copt}', "");
    Expect(0, 66299, '\P{  Copt}', "");
    Expect(1, 66299, '\P{^  Copt}', "");
    Expect(0, 66300, '\p{  Copt}', "");
    Expect(1, 66300, '\p{^  Copt}', "");
    Expect(1, 66300, '\P{  Copt}', "");
    Expect(0, 66300, '\P{^  Copt}', "");
    Error('\p{	 IS_COPT:=}');
    Error('\P{	 IS_COPT:=}');
    Expect(1, 66299, '\p{iscopt}', "");
    Expect(0, 66299, '\p{^iscopt}', "");
    Expect(0, 66299, '\P{iscopt}', "");
    Expect(1, 66299, '\P{^iscopt}', "");
    Expect(0, 66300, '\p{iscopt}', "");
    Expect(1, 66300, '\p{^iscopt}', "");
    Expect(1, 66300, '\P{iscopt}', "");
    Expect(0, 66300, '\P{^iscopt}', "");
    Expect(1, 66299, '\p{_IS_COPT}', "");
    Expect(0, 66299, '\p{^_IS_COPT}', "");
    Expect(0, 66299, '\P{_IS_COPT}', "");
    Expect(1, 66299, '\P{^_IS_COPT}', "");
    Expect(0, 66300, '\p{_IS_COPT}', "");
    Expect(1, 66300, '\p{^_IS_COPT}', "");
    Expect(1, 66300, '\P{_IS_COPT}', "");
    Expect(0, 66300, '\P{^_IS_COPT}', "");
    Error('\p{  qaac:=}');
    Error('\P{  qaac:=}');
    Expect(1, 66299, '\p{qaac}', "");
    Expect(0, 66299, '\p{^qaac}', "");
    Expect(0, 66299, '\P{qaac}', "");
    Expect(1, 66299, '\P{^qaac}', "");
    Expect(0, 66300, '\p{qaac}', "");
    Expect(1, 66300, '\p{^qaac}', "");
    Expect(1, 66300, '\P{qaac}', "");
    Expect(0, 66300, '\P{^qaac}', "");
    Expect(1, 66299, '\p{	_Qaac}', "");
    Expect(0, 66299, '\p{^	_Qaac}', "");
    Expect(0, 66299, '\P{	_Qaac}', "");
    Expect(1, 66299, '\P{^	_Qaac}', "");
    Expect(0, 66300, '\p{	_Qaac}', "");
    Expect(1, 66300, '\p{^	_Qaac}', "");
    Expect(1, 66300, '\P{	_Qaac}', "");
    Expect(0, 66300, '\P{^	_Qaac}', "");
    Error('\p{	-Is_QAAC/a/}');
    Error('\P{	-Is_QAAC/a/}');
    Expect(1, 66299, '\p{isqaac}', "");
    Expect(0, 66299, '\p{^isqaac}', "");
    Expect(0, 66299, '\P{isqaac}', "");
    Expect(1, 66299, '\P{^isqaac}', "");
    Expect(0, 66300, '\p{isqaac}', "");
    Expect(1, 66300, '\p{^isqaac}', "");
    Expect(1, 66300, '\P{isqaac}', "");
    Expect(0, 66300, '\P{^isqaac}', "");
    Expect(1, 66299, '\p{_-Is_Qaac}', "");
    Expect(0, 66299, '\p{^_-Is_Qaac}', "");
    Expect(0, 66299, '\P{_-Is_Qaac}', "");
    Expect(1, 66299, '\P{^_-Is_Qaac}', "");
    Expect(0, 66300, '\p{_-Is_Qaac}', "");
    Expect(1, 66300, '\p{^_-Is_Qaac}', "");
    Expect(1, 66300, '\P{_-Is_Qaac}', "");
    Expect(0, 66300, '\P{^_-Is_Qaac}', "");
    Error('\p{_ Coptic_epact_NUMBERS/a/}');
    Error('\P{_ Coptic_epact_NUMBERS/a/}');
    Expect(1, 66303, '\p{copticepactnumbers}', "");
    Expect(0, 66303, '\p{^copticepactnumbers}', "");
    Expect(0, 66303, '\P{copticepactnumbers}', "");
    Expect(1, 66303, '\P{^copticepactnumbers}', "");
    Expect(0, 66304, '\p{copticepactnumbers}', "");
    Expect(1, 66304, '\p{^copticepactnumbers}', "");
    Expect(1, 66304, '\P{copticepactnumbers}', "");
    Expect(0, 66304, '\P{^copticepactnumbers}', "");
    Expect(1, 66303, '\p{		COPTIC_epact_numbers}', "");
    Expect(0, 66303, '\p{^		COPTIC_epact_numbers}', "");
    Expect(0, 66303, '\P{		COPTIC_epact_numbers}', "");
    Expect(1, 66303, '\P{^		COPTIC_epact_numbers}', "");
    Expect(0, 66304, '\p{		COPTIC_epact_numbers}', "");
    Expect(1, 66304, '\p{^		COPTIC_epact_numbers}', "");
    Expect(1, 66304, '\P{		COPTIC_epact_numbers}', "");
    Expect(0, 66304, '\P{^		COPTIC_epact_numbers}', "");
    Error('\p{	IS_coptic_EPACT_NUMBERS:=}');
    Error('\P{	IS_coptic_EPACT_NUMBERS:=}');
    Expect(1, 66303, '\p{iscopticepactnumbers}', "");
    Expect(0, 66303, '\p{^iscopticepactnumbers}', "");
    Expect(0, 66303, '\P{iscopticepactnumbers}', "");
    Expect(1, 66303, '\P{^iscopticepactnumbers}', "");
    Expect(0, 66304, '\p{iscopticepactnumbers}', "");
    Expect(1, 66304, '\p{^iscopticepactnumbers}', "");
    Expect(1, 66304, '\P{iscopticepactnumbers}', "");
    Expect(0, 66304, '\P{^iscopticepactnumbers}', "");
    Expect(1, 66303, '\p{  is_coptic_EPACT_Numbers}', "");
    Expect(0, 66303, '\p{^  is_coptic_EPACT_Numbers}', "");
    Expect(0, 66303, '\P{  is_coptic_EPACT_Numbers}', "");
    Expect(1, 66303, '\P{^  is_coptic_EPACT_Numbers}', "");
    Expect(0, 66304, '\p{  is_coptic_EPACT_Numbers}', "");
    Expect(1, 66304, '\p{^  is_coptic_EPACT_Numbers}', "");
    Expect(1, 66304, '\P{  is_coptic_EPACT_Numbers}', "");
    Expect(0, 66304, '\P{^  is_coptic_EPACT_Numbers}', "");
    Error('\p{:= 	In_COPTIC_epact_Numbers}');
    Error('\P{:= 	In_COPTIC_epact_Numbers}');
    Expect(1, 66303, '\p{incopticepactnumbers}', "");
    Expect(0, 66303, '\p{^incopticepactnumbers}', "");
    Expect(0, 66303, '\P{incopticepactnumbers}', "");
    Expect(1, 66303, '\P{^incopticepactnumbers}', "");
    Expect(0, 66304, '\p{incopticepactnumbers}', "");
    Expect(1, 66304, '\p{^incopticepactnumbers}', "");
    Expect(1, 66304, '\P{incopticepactnumbers}', "");
    Expect(0, 66304, '\P{^incopticepactnumbers}', "");
    Expect(1, 66303, '\p{	 In_Coptic_Epact_NUMBERS}', "");
    Expect(0, 66303, '\p{^	 In_Coptic_Epact_NUMBERS}', "");
    Expect(0, 66303, '\P{	 In_Coptic_Epact_NUMBERS}', "");
    Expect(1, 66303, '\P{^	 In_Coptic_Epact_NUMBERS}', "");
    Expect(0, 66304, '\p{	 In_Coptic_Epact_NUMBERS}', "");
    Expect(1, 66304, '\p{^	 In_Coptic_Epact_NUMBERS}', "");
    Expect(1, 66304, '\P{	 In_Coptic_Epact_NUMBERS}', "");
    Expect(0, 66304, '\P{^	 In_Coptic_Epact_NUMBERS}', "");
    Error('\p{:=_counting_rod_NUMERALS}');
    Error('\P{:=_counting_rod_NUMERALS}');
    Expect(1, 119679, '\p{countingrodnumerals}', "");
    Expect(0, 119679, '\p{^countingrodnumerals}', "");
    Expect(0, 119679, '\P{countingrodnumerals}', "");
    Expect(1, 119679, '\P{^countingrodnumerals}', "");
    Expect(0, 119680, '\p{countingrodnumerals}', "");
    Expect(1, 119680, '\p{^countingrodnumerals}', "");
    Expect(1, 119680, '\P{countingrodnumerals}', "");
    Expect(0, 119680, '\P{^countingrodnumerals}', "");
    Expect(1, 119679, '\p{- COUNTING_rod_numerals}', "");
    Expect(0, 119679, '\p{^- COUNTING_rod_numerals}', "");
    Expect(0, 119679, '\P{- COUNTING_rod_numerals}', "");
    Expect(1, 119679, '\P{^- COUNTING_rod_numerals}', "");
    Expect(0, 119680, '\p{- COUNTING_rod_numerals}', "");
    Expect(1, 119680, '\p{^- COUNTING_rod_numerals}', "");
    Expect(1, 119680, '\P{- COUNTING_rod_numerals}', "");
    Expect(0, 119680, '\P{^- COUNTING_rod_numerals}', "");
    Error('\p{  is_counting_rod_Numerals:=}');
    Error('\P{  is_counting_rod_Numerals:=}');
    Expect(1, 119679, '\p{iscountingrodnumerals}', "");
    Expect(0, 119679, '\p{^iscountingrodnumerals}', "");
    Expect(0, 119679, '\P{iscountingrodnumerals}', "");
    Expect(1, 119679, '\P{^iscountingrodnumerals}', "");
    Expect(0, 119680, '\p{iscountingrodnumerals}', "");
    Expect(1, 119680, '\p{^iscountingrodnumerals}', "");
    Expect(1, 119680, '\P{iscountingrodnumerals}', "");
    Expect(0, 119680, '\P{^iscountingrodnumerals}', "");
    Expect(1, 119679, '\p{_is_Counting_rod_Numerals}', "");
    Expect(0, 119679, '\p{^_is_Counting_rod_Numerals}', "");
    Expect(0, 119679, '\P{_is_Counting_rod_Numerals}', "");
    Expect(1, 119679, '\P{^_is_Counting_rod_Numerals}', "");
    Expect(0, 119680, '\p{_is_Counting_rod_Numerals}', "");
    Expect(1, 119680, '\p{^_is_Counting_rod_Numerals}', "");
    Expect(1, 119680, '\P{_is_Counting_rod_Numerals}', "");
    Expect(0, 119680, '\P{^_is_Counting_rod_Numerals}', "");
    Error('\p{/a/-In_COUNTING_ROD_Numerals}');
    Error('\P{/a/-In_COUNTING_ROD_Numerals}');
    Expect(1, 119679, '\p{incountingrodnumerals}', "");
    Expect(0, 119679, '\p{^incountingrodnumerals}', "");
    Expect(0, 119679, '\P{incountingrodnumerals}', "");
    Expect(1, 119679, '\P{^incountingrodnumerals}', "");
    Expect(0, 119680, '\p{incountingrodnumerals}', "");
    Expect(1, 119680, '\p{^incountingrodnumerals}', "");
    Expect(1, 119680, '\P{incountingrodnumerals}', "");
    Expect(0, 119680, '\P{^incountingrodnumerals}', "");
    Expect(1, 119679, '\p{-	In_Counting_ROD_NUMERALS}', "");
    Expect(0, 119679, '\p{^-	In_Counting_ROD_NUMERALS}', "");
    Expect(0, 119679, '\P{-	In_Counting_ROD_NUMERALS}', "");
    Expect(1, 119679, '\P{^-	In_Counting_ROD_NUMERALS}', "");
    Expect(0, 119680, '\p{-	In_Counting_ROD_NUMERALS}', "");
    Expect(1, 119680, '\p{^-	In_Counting_ROD_NUMERALS}', "");
    Expect(1, 119680, '\P{-	In_Counting_ROD_NUMERALS}', "");
    Expect(0, 119680, '\P{^-	In_Counting_ROD_NUMERALS}', "");
    Error('\p{-	counting_Rod/a/}');
    Error('\P{-	counting_Rod/a/}');
    Expect(1, 119679, '\p{countingrod}', "");
    Expect(0, 119679, '\p{^countingrod}', "");
    Expect(0, 119679, '\P{countingrod}', "");
    Expect(1, 119679, '\P{^countingrod}', "");
    Expect(0, 119680, '\p{countingrod}', "");
    Expect(1, 119680, '\p{^countingrod}', "");
    Expect(1, 119680, '\P{countingrod}', "");
    Expect(0, 119680, '\P{^countingrod}', "");
    Expect(1, 119679, '\p{_-Counting_Rod}', "");
    Expect(0, 119679, '\p{^_-Counting_Rod}', "");
    Expect(0, 119679, '\P{_-Counting_Rod}', "");
    Expect(1, 119679, '\P{^_-Counting_Rod}', "");
    Expect(0, 119680, '\p{_-Counting_Rod}', "");
    Expect(1, 119680, '\p{^_-Counting_Rod}', "");
    Expect(1, 119680, '\P{_-Counting_Rod}', "");
    Expect(0, 119680, '\P{^_-Counting_Rod}', "");
    Error('\p{/a/	_IS_Counting_rod}');
    Error('\P{/a/	_IS_Counting_rod}');
    Expect(1, 119679, '\p{iscountingrod}', "");
    Expect(0, 119679, '\p{^iscountingrod}', "");
    Expect(0, 119679, '\P{iscountingrod}', "");
    Expect(1, 119679, '\P{^iscountingrod}', "");
    Expect(0, 119680, '\p{iscountingrod}', "");
    Expect(1, 119680, '\p{^iscountingrod}', "");
    Expect(1, 119680, '\P{iscountingrod}', "");
    Expect(0, 119680, '\P{^iscountingrod}', "");
    Expect(1, 119679, '\p{		IS_Counting_rod}', "");
    Expect(0, 119679, '\p{^		IS_Counting_rod}', "");
    Expect(0, 119679, '\P{		IS_Counting_rod}', "");
    Expect(1, 119679, '\P{^		IS_Counting_rod}', "");
    Expect(0, 119680, '\p{		IS_Counting_rod}', "");
    Expect(1, 119680, '\p{^		IS_Counting_rod}', "");
    Expect(1, 119680, '\P{		IS_Counting_rod}', "");
    Expect(0, 119680, '\P{^		IS_Counting_rod}', "");
    Error('\p{	in_counting_rod:=}');
    Error('\P{	in_counting_rod:=}');
    Expect(1, 119679, '\p{incountingrod}', "");
    Expect(0, 119679, '\p{^incountingrod}', "");
    Expect(0, 119679, '\P{incountingrod}', "");
    Expect(1, 119679, '\P{^incountingrod}', "");
    Expect(0, 119680, '\p{incountingrod}', "");
    Expect(1, 119680, '\p{^incountingrod}', "");
    Expect(1, 119680, '\P{incountingrod}', "");
    Expect(0, 119680, '\P{^incountingrod}', "");
    Expect(1, 119679, '\p{	 In_Counting_ROD}', "");
    Expect(0, 119679, '\p{^	 In_Counting_ROD}', "");
    Expect(0, 119679, '\P{	 In_Counting_ROD}', "");
    Expect(1, 119679, '\P{^	 In_Counting_ROD}', "");
    Expect(0, 119680, '\p{	 In_Counting_ROD}', "");
    Expect(1, 119680, '\p{^	 In_Counting_ROD}', "");
    Expect(1, 119680, '\P{	 In_Counting_ROD}', "");
    Expect(0, 119680, '\P{^	 In_Counting_ROD}', "");
    Error('\p{/a/__CUNEIFORM}');
    Error('\P{/a/__CUNEIFORM}');
    Expect(1, 75075, '\p{cuneiform}', "");
    Expect(0, 75075, '\p{^cuneiform}', "");
    Expect(0, 75075, '\P{cuneiform}', "");
    Expect(1, 75075, '\P{^cuneiform}', "");
    Expect(0, 75076, '\p{cuneiform}', "");
    Expect(1, 75076, '\p{^cuneiform}', "");
    Expect(1, 75076, '\P{cuneiform}', "");
    Expect(0, 75076, '\P{^cuneiform}', "");
    Expect(1, 75075, '\p{	cuneiform}', "");
    Expect(0, 75075, '\p{^	cuneiform}', "");
    Expect(0, 75075, '\P{	cuneiform}', "");
    Expect(1, 75075, '\P{^	cuneiform}', "");
    Expect(0, 75076, '\p{	cuneiform}', "");
    Expect(1, 75076, '\p{^	cuneiform}', "");
    Expect(1, 75076, '\P{	cuneiform}', "");
    Expect(0, 75076, '\P{^	cuneiform}', "");
    Error('\p{ _Is_cuneiform/a/}');
    Error('\P{ _Is_cuneiform/a/}');
    Expect(1, 75075, '\p{iscuneiform}', "");
    Expect(0, 75075, '\p{^iscuneiform}', "");
    Expect(0, 75075, '\P{iscuneiform}', "");
    Expect(1, 75075, '\P{^iscuneiform}', "");
    Expect(0, 75076, '\p{iscuneiform}', "");
    Expect(1, 75076, '\p{^iscuneiform}', "");
    Expect(1, 75076, '\P{iscuneiform}', "");
    Expect(0, 75076, '\P{^iscuneiform}', "");
    Expect(1, 75075, '\p{ _IS_cuneiform}', "");
    Expect(0, 75075, '\p{^ _IS_cuneiform}', "");
    Expect(0, 75075, '\P{ _IS_cuneiform}', "");
    Expect(1, 75075, '\P{^ _IS_cuneiform}', "");
    Expect(0, 75076, '\p{ _IS_cuneiform}', "");
    Expect(1, 75076, '\p{^ _IS_cuneiform}', "");
    Expect(1, 75076, '\P{ _IS_cuneiform}', "");
    Expect(0, 75076, '\P{^ _IS_cuneiform}', "");
    Error('\p{:=- Xsux}');
    Error('\P{:=- Xsux}');
    Expect(1, 75075, '\p{xsux}', "");
    Expect(0, 75075, '\p{^xsux}', "");
    Expect(0, 75075, '\P{xsux}', "");
    Expect(1, 75075, '\P{^xsux}', "");
    Expect(0, 75076, '\p{xsux}', "");
    Expect(1, 75076, '\p{^xsux}', "");
    Expect(1, 75076, '\P{xsux}', "");
    Expect(0, 75076, '\P{^xsux}', "");
    Expect(1, 75075, '\p{ xsux}', "");
    Expect(0, 75075, '\p{^ xsux}', "");
    Expect(0, 75075, '\P{ xsux}', "");
    Expect(1, 75075, '\P{^ xsux}', "");
    Expect(0, 75076, '\p{ xsux}', "");
    Expect(1, 75076, '\p{^ xsux}', "");
    Expect(1, 75076, '\P{ xsux}', "");
    Expect(0, 75076, '\P{^ xsux}', "");
    Error('\p{/a/-Is_XSUX}');
    Error('\P{/a/-Is_XSUX}');
    Expect(1, 75075, '\p{isxsux}', "");
    Expect(0, 75075, '\p{^isxsux}', "");
    Expect(0, 75075, '\P{isxsux}', "");
    Expect(1, 75075, '\P{^isxsux}', "");
    Expect(0, 75076, '\p{isxsux}', "");
    Expect(1, 75076, '\p{^isxsux}', "");
    Expect(1, 75076, '\P{isxsux}', "");
    Expect(0, 75076, '\P{^isxsux}', "");
    Expect(1, 75075, '\p{_ Is_Xsux}', "");
    Expect(0, 75075, '\p{^_ Is_Xsux}', "");
    Expect(0, 75075, '\P{_ Is_Xsux}', "");
    Expect(1, 75075, '\P{^_ Is_Xsux}', "");
    Expect(0, 75076, '\p{_ Is_Xsux}', "");
    Expect(1, 75076, '\p{^_ Is_Xsux}', "");
    Expect(1, 75076, '\P{_ Is_Xsux}', "");
    Expect(0, 75076, '\P{^_ Is_Xsux}', "");
    Error('\p{_ CUNEIFORM_numbers_AND_Punctuation/a/}');
    Error('\P{_ CUNEIFORM_numbers_AND_Punctuation/a/}');
    Expect(1, 74879, '\p{cuneiformnumbersandpunctuation}', "");
    Expect(0, 74879, '\p{^cuneiformnumbersandpunctuation}', "");
    Expect(0, 74879, '\P{cuneiformnumbersandpunctuation}', "");
    Expect(1, 74879, '\P{^cuneiformnumbersandpunctuation}', "");
    Expect(0, 74880, '\p{cuneiformnumbersandpunctuation}', "");
    Expect(1, 74880, '\p{^cuneiformnumbersandpunctuation}', "");
    Expect(1, 74880, '\P{cuneiformnumbersandpunctuation}', "");
    Expect(0, 74880, '\P{^cuneiformnumbersandpunctuation}', "");
    Expect(1, 74879, '\p{	CUNEIFORM_numbers_And_Punctuation}', "");
    Expect(0, 74879, '\p{^	CUNEIFORM_numbers_And_Punctuation}', "");
    Expect(0, 74879, '\P{	CUNEIFORM_numbers_And_Punctuation}', "");
    Expect(1, 74879, '\P{^	CUNEIFORM_numbers_And_Punctuation}', "");
    Expect(0, 74880, '\p{	CUNEIFORM_numbers_And_Punctuation}', "");
    Expect(1, 74880, '\p{^	CUNEIFORM_numbers_And_Punctuation}', "");
    Expect(1, 74880, '\P{	CUNEIFORM_numbers_And_Punctuation}', "");
    Expect(0, 74880, '\P{^	CUNEIFORM_numbers_And_Punctuation}', "");
    Error('\p{_/a/Is_Cuneiform_Numbers_AND_PUNCTUATION}');
    Error('\P{_/a/Is_Cuneiform_Numbers_AND_PUNCTUATION}');
    Expect(1, 74879, '\p{iscuneiformnumbersandpunctuation}', "");
    Expect(0, 74879, '\p{^iscuneiformnumbersandpunctuation}', "");
    Expect(0, 74879, '\P{iscuneiformnumbersandpunctuation}', "");
    Expect(1, 74879, '\P{^iscuneiformnumbersandpunctuation}', "");
    Expect(0, 74880, '\p{iscuneiformnumbersandpunctuation}', "");
    Expect(1, 74880, '\p{^iscuneiformnumbersandpunctuation}', "");
    Expect(1, 74880, '\P{iscuneiformnumbersandpunctuation}', "");
    Expect(0, 74880, '\P{^iscuneiformnumbersandpunctuation}', "");
    Expect(1, 74879, '\p{ Is_Cuneiform_numbers_AND_PUNCTUATION}', "");
    Expect(0, 74879, '\p{^ Is_Cuneiform_numbers_AND_PUNCTUATION}', "");
    Expect(0, 74879, '\P{ Is_Cuneiform_numbers_AND_PUNCTUATION}', "");
    Expect(1, 74879, '\P{^ Is_Cuneiform_numbers_AND_PUNCTUATION}', "");
    Expect(0, 74880, '\p{ Is_Cuneiform_numbers_AND_PUNCTUATION}', "");
    Expect(1, 74880, '\p{^ Is_Cuneiform_numbers_AND_PUNCTUATION}', "");
    Expect(1, 74880, '\P{ Is_Cuneiform_numbers_AND_PUNCTUATION}', "");
    Expect(0, 74880, '\P{^ Is_Cuneiform_numbers_AND_PUNCTUATION}', "");
    Error('\p{_/a/in_Cuneiform_numbers_And_Punctuation}');
    Error('\P{_/a/in_Cuneiform_numbers_And_Punctuation}');
    Expect(1, 74879, '\p{incuneiformnumbersandpunctuation}', "");
    Expect(0, 74879, '\p{^incuneiformnumbersandpunctuation}', "");
    Expect(0, 74879, '\P{incuneiformnumbersandpunctuation}', "");
    Expect(1, 74879, '\P{^incuneiformnumbersandpunctuation}', "");
    Expect(0, 74880, '\p{incuneiformnumbersandpunctuation}', "");
    Expect(1, 74880, '\p{^incuneiformnumbersandpunctuation}', "");
    Expect(1, 74880, '\P{incuneiformnumbersandpunctuation}', "");
    Expect(0, 74880, '\P{^incuneiformnumbersandpunctuation}', "");
    Expect(1, 74879, '\p{ 	IN_CUNEIFORM_numbers_And_Punctuation}', "");
    Expect(0, 74879, '\p{^ 	IN_CUNEIFORM_numbers_And_Punctuation}', "");
    Expect(0, 74879, '\P{ 	IN_CUNEIFORM_numbers_And_Punctuation}', "");
    Expect(1, 74879, '\P{^ 	IN_CUNEIFORM_numbers_And_Punctuation}', "");
    Expect(0, 74880, '\p{ 	IN_CUNEIFORM_numbers_And_Punctuation}', "");
    Expect(1, 74880, '\p{^ 	IN_CUNEIFORM_numbers_And_Punctuation}', "");
    Expect(1, 74880, '\P{ 	IN_CUNEIFORM_numbers_And_Punctuation}', "");
    Expect(0, 74880, '\P{^ 	IN_CUNEIFORM_numbers_And_Punctuation}', "");
    Error('\p{ Cuneiform_NUMBERS/a/}');
    Error('\P{ Cuneiform_NUMBERS/a/}');
    Expect(1, 74879, '\p{cuneiformnumbers}', "");
    Expect(0, 74879, '\p{^cuneiformnumbers}', "");
    Expect(0, 74879, '\P{cuneiformnumbers}', "");
    Expect(1, 74879, '\P{^cuneiformnumbers}', "");
    Expect(0, 74880, '\p{cuneiformnumbers}', "");
    Expect(1, 74880, '\p{^cuneiformnumbers}', "");
    Expect(1, 74880, '\P{cuneiformnumbers}', "");
    Expect(0, 74880, '\P{^cuneiformnumbers}', "");
    Expect(1, 74879, '\p{-cuneiform_NUMBERS}', "");
    Expect(0, 74879, '\p{^-cuneiform_NUMBERS}', "");
    Expect(0, 74879, '\P{-cuneiform_NUMBERS}', "");
    Expect(1, 74879, '\P{^-cuneiform_NUMBERS}', "");
    Expect(0, 74880, '\p{-cuneiform_NUMBERS}', "");
    Expect(1, 74880, '\p{^-cuneiform_NUMBERS}', "");
    Expect(1, 74880, '\P{-cuneiform_NUMBERS}', "");
    Expect(0, 74880, '\P{^-cuneiform_NUMBERS}', "");
    Error('\p{:=-_Is_Cuneiform_Numbers}');
    Error('\P{:=-_Is_Cuneiform_Numbers}');
    Expect(1, 74879, '\p{iscuneiformnumbers}', "");
    Expect(0, 74879, '\p{^iscuneiformnumbers}', "");
    Expect(0, 74879, '\P{iscuneiformnumbers}', "");
    Expect(1, 74879, '\P{^iscuneiformnumbers}', "");
    Expect(0, 74880, '\p{iscuneiformnumbers}', "");
    Expect(1, 74880, '\p{^iscuneiformnumbers}', "");
    Expect(1, 74880, '\P{iscuneiformnumbers}', "");
    Expect(0, 74880, '\P{^iscuneiformnumbers}', "");
    Expect(1, 74879, '\p{is_Cuneiform_numbers}', "");
    Expect(0, 74879, '\p{^is_Cuneiform_numbers}', "");
    Expect(0, 74879, '\P{is_Cuneiform_numbers}', "");
    Expect(1, 74879, '\P{^is_Cuneiform_numbers}', "");
    Expect(0, 74880, '\p{is_Cuneiform_numbers}', "");
    Expect(1, 74880, '\p{^is_Cuneiform_numbers}', "");
    Expect(1, 74880, '\P{is_Cuneiform_numbers}', "");
    Expect(0, 74880, '\P{^is_Cuneiform_numbers}', "");
    Error('\p{:=_-In_Cuneiform_numbers}');
    Error('\P{:=_-In_Cuneiform_numbers}');
    Expect(1, 74879, '\p{incuneiformnumbers}', "");
    Expect(0, 74879, '\p{^incuneiformnumbers}', "");
    Expect(0, 74879, '\P{incuneiformnumbers}', "");
    Expect(1, 74879, '\P{^incuneiformnumbers}', "");
    Expect(0, 74880, '\p{incuneiformnumbers}', "");
    Expect(1, 74880, '\p{^incuneiformnumbers}', "");
    Expect(1, 74880, '\P{incuneiformnumbers}', "");
    Expect(0, 74880, '\P{^incuneiformnumbers}', "");
    Expect(1, 74879, '\p{ _IN_cuneiform_numbers}', "");
    Expect(0, 74879, '\p{^ _IN_cuneiform_numbers}', "");
    Expect(0, 74879, '\P{ _IN_cuneiform_numbers}', "");
    Expect(1, 74879, '\P{^ _IN_cuneiform_numbers}', "");
    Expect(0, 74880, '\p{ _IN_cuneiform_numbers}', "");
    Expect(1, 74880, '\p{^ _IN_cuneiform_numbers}', "");
    Expect(1, 74880, '\P{ _IN_cuneiform_numbers}', "");
    Expect(0, 74880, '\P{^ _IN_cuneiform_numbers}', "");
    Error('\p{/a/	 Currency_symbol}');
    Error('\P{/a/	 Currency_symbol}');
    Expect(1, 126128, '\p{currencysymbol}', "");
    Expect(0, 126128, '\p{^currencysymbol}', "");
    Expect(0, 126128, '\P{currencysymbol}', "");
    Expect(1, 126128, '\P{^currencysymbol}', "");
    Expect(0, 126129, '\p{currencysymbol}', "");
    Expect(1, 126129, '\p{^currencysymbol}', "");
    Expect(1, 126129, '\P{currencysymbol}', "");
    Expect(0, 126129, '\P{^currencysymbol}', "");
    Expect(1, 126128, '\p{CURRENCY_Symbol}', "");
    Expect(0, 126128, '\p{^CURRENCY_Symbol}', "");
    Expect(0, 126128, '\P{CURRENCY_Symbol}', "");
    Expect(1, 126128, '\P{^CURRENCY_Symbol}', "");
    Expect(0, 126129, '\p{CURRENCY_Symbol}', "");
    Expect(1, 126129, '\p{^CURRENCY_Symbol}', "");
    Expect(1, 126129, '\P{CURRENCY_Symbol}', "");
    Expect(0, 126129, '\P{^CURRENCY_Symbol}', "");
    Error('\p{Is_CURRENCY_symbol/a/}');
    Error('\P{Is_CURRENCY_symbol/a/}');
    Expect(1, 126128, '\p{iscurrencysymbol}', "");
    Expect(0, 126128, '\p{^iscurrencysymbol}', "");
    Expect(0, 126128, '\P{iscurrencysymbol}', "");
    Expect(1, 126128, '\P{^iscurrencysymbol}', "");
    Expect(0, 126129, '\p{iscurrencysymbol}', "");
    Expect(1, 126129, '\p{^iscurrencysymbol}', "");
    Expect(1, 126129, '\P{iscurrencysymbol}', "");
    Expect(0, 126129, '\P{^iscurrencysymbol}', "");
    Expect(1, 126128, '\p{__Is_currency_SYMBOL}', "");
    Expect(0, 126128, '\p{^__Is_currency_SYMBOL}', "");
    Expect(0, 126128, '\P{__Is_currency_SYMBOL}', "");
    Expect(1, 126128, '\P{^__Is_currency_SYMBOL}', "");
    Expect(0, 126129, '\p{__Is_currency_SYMBOL}', "");
    Expect(1, 126129, '\p{^__Is_currency_SYMBOL}', "");
    Expect(1, 126129, '\P{__Is_currency_SYMBOL}', "");
    Expect(0, 126129, '\P{^__Is_currency_SYMBOL}', "");
    Error('\p{:=-Sc}');
    Error('\P{:=-Sc}');
    Expect(1, 126128, '\p{sc}', "");
    Expect(0, 126128, '\p{^sc}', "");
    Expect(0, 126128, '\P{sc}', "");
    Expect(1, 126128, '\P{^sc}', "");
    Expect(0, 126129, '\p{sc}', "");
    Expect(1, 126129, '\p{^sc}', "");
    Expect(1, 126129, '\P{sc}', "");
    Expect(0, 126129, '\P{^sc}', "");
    Expect(1, 126128, '\p{	 Sc}', "");
    Expect(0, 126128, '\p{^	 Sc}', "");
    Expect(0, 126128, '\P{	 Sc}', "");
    Expect(1, 126128, '\P{^	 Sc}', "");
    Expect(0, 126129, '\p{	 Sc}', "");
    Expect(1, 126129, '\p{^	 Sc}', "");
    Expect(1, 126129, '\P{	 Sc}', "");
    Expect(0, 126129, '\P{^	 Sc}', "");
    Error('\p{ _IS_Sc:=}');
    Error('\P{ _IS_Sc:=}');
    Expect(1, 126128, '\p{issc}', "");
    Expect(0, 126128, '\p{^issc}', "");
    Expect(0, 126128, '\P{issc}', "");
    Expect(1, 126128, '\P{^issc}', "");
    Expect(0, 126129, '\p{issc}', "");
    Expect(1, 126129, '\p{^issc}', "");
    Expect(1, 126129, '\P{issc}', "");
    Expect(0, 126129, '\P{^issc}', "");
    Expect(1, 126128, '\p{_	IS_SC}', "");
    Expect(0, 126128, '\p{^_	IS_SC}', "");
    Expect(0, 126128, '\P{_	IS_SC}', "");
    Expect(1, 126128, '\P{^_	IS_SC}', "");
    Expect(0, 126129, '\p{_	IS_SC}', "");
    Expect(1, 126129, '\p{^_	IS_SC}', "");
    Expect(1, 126129, '\P{_	IS_SC}', "");
    Expect(0, 126129, '\P{^_	IS_SC}', "");
    Error('\p{	Currency_SYMBOLS/a/}');
    Error('\P{	Currency_SYMBOLS/a/}');
    Expect(1, 8399, '\p{currencysymbols}', "");
    Expect(0, 8399, '\p{^currencysymbols}', "");
    Expect(0, 8399, '\P{currencysymbols}', "");
    Expect(1, 8399, '\P{^currencysymbols}', "");
    Expect(0, 8400, '\p{currencysymbols}', "");
    Expect(1, 8400, '\p{^currencysymbols}', "");
    Expect(1, 8400, '\P{currencysymbols}', "");
    Expect(0, 8400, '\P{^currencysymbols}', "");
    Expect(1, 8399, '\p{ _Currency_Symbols}', "");
    Expect(0, 8399, '\p{^ _Currency_Symbols}', "");
    Expect(0, 8399, '\P{ _Currency_Symbols}', "");
    Expect(1, 8399, '\P{^ _Currency_Symbols}', "");
    Expect(0, 8400, '\p{ _Currency_Symbols}', "");
    Expect(1, 8400, '\p{^ _Currency_Symbols}', "");
    Expect(1, 8400, '\P{ _Currency_Symbols}', "");
    Expect(0, 8400, '\P{^ _Currency_Symbols}', "");
    Error('\p{:=- Is_Currency_symbols}');
    Error('\P{:=- Is_Currency_symbols}');
    Expect(1, 8399, '\p{iscurrencysymbols}', "");
    Expect(0, 8399, '\p{^iscurrencysymbols}', "");
    Expect(0, 8399, '\P{iscurrencysymbols}', "");
    Expect(1, 8399, '\P{^iscurrencysymbols}', "");
    Expect(0, 8400, '\p{iscurrencysymbols}', "");
    Expect(1, 8400, '\p{^iscurrencysymbols}', "");
    Expect(1, 8400, '\P{iscurrencysymbols}', "");
    Expect(0, 8400, '\P{^iscurrencysymbols}', "");
    Expect(1, 8399, '\p{_ Is_currency_Symbols}', "");
    Expect(0, 8399, '\p{^_ Is_currency_Symbols}', "");
    Expect(0, 8399, '\P{_ Is_currency_Symbols}', "");
    Expect(1, 8399, '\P{^_ Is_currency_Symbols}', "");
    Expect(0, 8400, '\p{_ Is_currency_Symbols}', "");
    Expect(1, 8400, '\p{^_ Is_currency_Symbols}', "");
    Expect(1, 8400, '\P{_ Is_currency_Symbols}', "");
    Expect(0, 8400, '\P{^_ Is_currency_Symbols}', "");
    Error('\p{:=_IN_CURRENCY_SYMBOLS}');
    Error('\P{:=_IN_CURRENCY_SYMBOLS}');
    Expect(1, 8399, '\p{incurrencysymbols}', "");
    Expect(0, 8399, '\p{^incurrencysymbols}', "");
    Expect(0, 8399, '\P{incurrencysymbols}', "");
    Expect(1, 8399, '\P{^incurrencysymbols}', "");
    Expect(0, 8400, '\p{incurrencysymbols}', "");
    Expect(1, 8400, '\p{^incurrencysymbols}', "");
    Expect(1, 8400, '\P{incurrencysymbols}', "");
    Expect(0, 8400, '\P{^incurrencysymbols}', "");
    Expect(1, 8399, '\p{		IN_currency_symbols}', "");
    Expect(0, 8399, '\p{^		IN_currency_symbols}', "");
    Expect(0, 8399, '\P{		IN_currency_symbols}', "");
    Expect(1, 8399, '\P{^		IN_currency_symbols}', "");
    Expect(0, 8400, '\p{		IN_currency_symbols}', "");
    Expect(1, 8400, '\p{^		IN_currency_symbols}', "");
    Expect(1, 8400, '\P{		IN_currency_symbols}', "");
    Expect(0, 8400, '\P{^		IN_currency_symbols}', "");
    Error('\p{_:=cypriot}');
    Error('\P{_:=cypriot}');
    Expect(1, 67647, '\p{cypriot}', "");
    Expect(0, 67647, '\p{^cypriot}', "");
    Expect(0, 67647, '\P{cypriot}', "");
    Expect(1, 67647, '\P{^cypriot}', "");
    Expect(0, 67648, '\p{cypriot}', "");
    Expect(1, 67648, '\p{^cypriot}', "");
    Expect(1, 67648, '\P{cypriot}', "");
    Expect(0, 67648, '\P{^cypriot}', "");
    Expect(1, 67647, '\p{CYPRIOT}', "");
    Expect(0, 67647, '\p{^CYPRIOT}', "");
    Expect(0, 67647, '\P{CYPRIOT}', "");
    Expect(1, 67647, '\P{^CYPRIOT}', "");
    Expect(0, 67648, '\p{CYPRIOT}', "");
    Expect(1, 67648, '\p{^CYPRIOT}', "");
    Expect(1, 67648, '\P{CYPRIOT}', "");
    Expect(0, 67648, '\P{^CYPRIOT}', "");
    Error('\p{ :=Is_cypriot}');
    Error('\P{ :=Is_cypriot}');
    Expect(1, 67647, '\p{iscypriot}', "");
    Expect(0, 67647, '\p{^iscypriot}', "");
    Expect(0, 67647, '\P{iscypriot}', "");
    Expect(1, 67647, '\P{^iscypriot}', "");
    Expect(0, 67648, '\p{iscypriot}', "");
    Expect(1, 67648, '\p{^iscypriot}', "");
    Expect(1, 67648, '\P{iscypriot}', "");
    Expect(0, 67648, '\P{^iscypriot}', "");
    Expect(1, 67647, '\p{	IS_CYPRIOT}', "");
    Expect(0, 67647, '\p{^	IS_CYPRIOT}', "");
    Expect(0, 67647, '\P{	IS_CYPRIOT}', "");
    Expect(1, 67647, '\P{^	IS_CYPRIOT}', "");
    Expect(0, 67648, '\p{	IS_CYPRIOT}', "");
    Expect(1, 67648, '\p{^	IS_CYPRIOT}', "");
    Expect(1, 67648, '\P{	IS_CYPRIOT}', "");
    Expect(0, 67648, '\P{^	IS_CYPRIOT}', "");
    Error('\p{_Cprt:=}');
    Error('\P{_Cprt:=}');
    Expect(1, 67647, '\p{cprt}', "");
    Expect(0, 67647, '\p{^cprt}', "");
    Expect(0, 67647, '\P{cprt}', "");
    Expect(1, 67647, '\P{^cprt}', "");
    Expect(0, 67648, '\p{cprt}', "");
    Expect(1, 67648, '\p{^cprt}', "");
    Expect(1, 67648, '\P{cprt}', "");
    Expect(0, 67648, '\P{^cprt}', "");
    Expect(1, 67647, '\p{__CPRT}', "");
    Expect(0, 67647, '\p{^__CPRT}', "");
    Expect(0, 67647, '\P{__CPRT}', "");
    Expect(1, 67647, '\P{^__CPRT}', "");
    Expect(0, 67648, '\p{__CPRT}', "");
    Expect(1, 67648, '\p{^__CPRT}', "");
    Expect(1, 67648, '\P{__CPRT}', "");
    Expect(0, 67648, '\P{^__CPRT}', "");
    Error('\p{:=-	is_CPRT}');
    Error('\P{:=-	is_CPRT}');
    Expect(1, 67647, '\p{iscprt}', "");
    Expect(0, 67647, '\p{^iscprt}', "");
    Expect(0, 67647, '\P{iscprt}', "");
    Expect(1, 67647, '\P{^iscprt}', "");
    Expect(0, 67648, '\p{iscprt}', "");
    Expect(1, 67648, '\p{^iscprt}', "");
    Expect(1, 67648, '\P{iscprt}', "");
    Expect(0, 67648, '\P{^iscprt}', "");
    Expect(1, 67647, '\p{_ IS_Cprt}', "");
    Expect(0, 67647, '\p{^_ IS_Cprt}', "");
    Expect(0, 67647, '\P{_ IS_Cprt}', "");
    Expect(1, 67647, '\P{^_ IS_Cprt}', "");
    Expect(0, 67648, '\p{_ IS_Cprt}', "");
    Expect(1, 67648, '\p{^_ IS_Cprt}', "");
    Expect(1, 67648, '\P{_ IS_Cprt}', "");
    Expect(0, 67648, '\P{^_ IS_Cprt}', "");
    Error('\p{ /a/cypriot_Syllabary}');
    Error('\P{ /a/cypriot_Syllabary}');
    Expect(1, 67647, '\p{cypriotsyllabary}', "");
    Expect(0, 67647, '\p{^cypriotsyllabary}', "");
    Expect(0, 67647, '\P{cypriotsyllabary}', "");
    Expect(1, 67647, '\P{^cypriotsyllabary}', "");
    Expect(0, 67648, '\p{cypriotsyllabary}', "");
    Expect(1, 67648, '\p{^cypriotsyllabary}', "");
    Expect(1, 67648, '\P{cypriotsyllabary}', "");
    Expect(0, 67648, '\P{^cypriotsyllabary}', "");
    Expect(1, 67647, '\p{-	Cypriot_Syllabary}', "");
    Expect(0, 67647, '\p{^-	Cypriot_Syllabary}', "");
    Expect(0, 67647, '\P{-	Cypriot_Syllabary}', "");
    Expect(1, 67647, '\P{^-	Cypriot_Syllabary}', "");
    Expect(0, 67648, '\p{-	Cypriot_Syllabary}', "");
    Expect(1, 67648, '\p{^-	Cypriot_Syllabary}', "");
    Expect(1, 67648, '\P{-	Cypriot_Syllabary}', "");
    Expect(0, 67648, '\P{^-	Cypriot_Syllabary}', "");
    Error('\p{ :=IS_Cypriot_Syllabary}');
    Error('\P{ :=IS_Cypriot_Syllabary}');
    Expect(1, 67647, '\p{iscypriotsyllabary}', "");
    Expect(0, 67647, '\p{^iscypriotsyllabary}', "");
    Expect(0, 67647, '\P{iscypriotsyllabary}', "");
    Expect(1, 67647, '\P{^iscypriotsyllabary}', "");
    Expect(0, 67648, '\p{iscypriotsyllabary}', "");
    Expect(1, 67648, '\p{^iscypriotsyllabary}', "");
    Expect(1, 67648, '\P{iscypriotsyllabary}', "");
    Expect(0, 67648, '\P{^iscypriotsyllabary}', "");
    Expect(1, 67647, '\p{-_Is_CYPRIOT_SYLLABARY}', "");
    Expect(0, 67647, '\p{^-_Is_CYPRIOT_SYLLABARY}', "");
    Expect(0, 67647, '\P{-_Is_CYPRIOT_SYLLABARY}', "");
    Expect(1, 67647, '\P{^-_Is_CYPRIOT_SYLLABARY}', "");
    Expect(0, 67648, '\p{-_Is_CYPRIOT_SYLLABARY}', "");
    Expect(1, 67648, '\p{^-_Is_CYPRIOT_SYLLABARY}', "");
    Expect(1, 67648, '\P{-_Is_CYPRIOT_SYLLABARY}', "");
    Expect(0, 67648, '\P{^-_Is_CYPRIOT_SYLLABARY}', "");
    Error('\p{-In_CYPRIOT_Syllabary:=}');
    Error('\P{-In_CYPRIOT_Syllabary:=}');
    Expect(1, 67647, '\p{incypriotsyllabary}', "");
    Expect(0, 67647, '\p{^incypriotsyllabary}', "");
    Expect(0, 67647, '\P{incypriotsyllabary}', "");
    Expect(1, 67647, '\P{^incypriotsyllabary}', "");
    Expect(0, 67648, '\p{incypriotsyllabary}', "");
    Expect(1, 67648, '\p{^incypriotsyllabary}', "");
    Expect(1, 67648, '\P{incypriotsyllabary}', "");
    Expect(0, 67648, '\P{^incypriotsyllabary}', "");
    Expect(1, 67647, '\p{-in_CYPRIOT_Syllabary}', "");
    Expect(0, 67647, '\p{^-in_CYPRIOT_Syllabary}', "");
    Expect(0, 67647, '\P{-in_CYPRIOT_Syllabary}', "");
    Expect(1, 67647, '\P{^-in_CYPRIOT_Syllabary}', "");
    Expect(0, 67648, '\p{-in_CYPRIOT_Syllabary}', "");
    Expect(1, 67648, '\p{^-in_CYPRIOT_Syllabary}', "");
    Expect(1, 67648, '\P{-in_CYPRIOT_Syllabary}', "");
    Expect(0, 67648, '\P{^-in_CYPRIOT_Syllabary}', "");
    Error('\p{/a/--Cypro_Minoan}');
    Error('\P{/a/--Cypro_Minoan}');
    Expect(1, 77810, '\p{cyprominoan}', "");
    Expect(0, 77810, '\p{^cyprominoan}', "");
    Expect(0, 77810, '\P{cyprominoan}', "");
    Expect(1, 77810, '\P{^cyprominoan}', "");
    Expect(0, 77811, '\p{cyprominoan}', "");
    Expect(1, 77811, '\p{^cyprominoan}', "");
    Expect(1, 77811, '\P{cyprominoan}', "");
    Expect(0, 77811, '\P{^cyprominoan}', "");
    Expect(1, 77810, '\p{ _CYPRO_Minoan}', "");
    Expect(0, 77810, '\p{^ _CYPRO_Minoan}', "");
    Expect(0, 77810, '\P{ _CYPRO_Minoan}', "");
    Expect(1, 77810, '\P{^ _CYPRO_Minoan}', "");
    Expect(0, 77811, '\p{ _CYPRO_Minoan}', "");
    Expect(1, 77811, '\p{^ _CYPRO_Minoan}', "");
    Expect(1, 77811, '\P{ _CYPRO_Minoan}', "");
    Expect(0, 77811, '\P{^ _CYPRO_Minoan}', "");
    Error('\p{-	Is_Cypro_minoan:=}');
    Error('\P{-	Is_Cypro_minoan:=}');
    Expect(1, 77810, '\p{iscyprominoan}', "");
    Expect(0, 77810, '\p{^iscyprominoan}', "");
    Expect(0, 77810, '\P{iscyprominoan}', "");
    Expect(1, 77810, '\P{^iscyprominoan}', "");
    Expect(0, 77811, '\p{iscyprominoan}', "");
    Expect(1, 77811, '\p{^iscyprominoan}', "");
    Expect(1, 77811, '\P{iscyprominoan}', "");
    Expect(0, 77811, '\P{^iscyprominoan}', "");
    Expect(1, 77810, '\p{ Is_CYPRO_Minoan}', "");
    Expect(0, 77810, '\p{^ Is_CYPRO_Minoan}', "");
    Expect(0, 77810, '\P{ Is_CYPRO_Minoan}', "");
    Expect(1, 77810, '\P{^ Is_CYPRO_Minoan}', "");
    Expect(0, 77811, '\p{ Is_CYPRO_Minoan}', "");
    Expect(1, 77811, '\p{^ Is_CYPRO_Minoan}', "");
    Expect(1, 77811, '\P{ Is_CYPRO_Minoan}', "");
    Expect(0, 77811, '\P{^ Is_CYPRO_Minoan}', "");
    Error('\p{/a/ cpmn}');
    Error('\P{/a/ cpmn}');
    Expect(1, 77810, '\p{cpmn}', "");
    Expect(0, 77810, '\p{^cpmn}', "");
    Expect(0, 77810, '\P{cpmn}', "");
    Expect(1, 77810, '\P{^cpmn}', "");
    Expect(0, 77811, '\p{cpmn}', "");
    Expect(1, 77811, '\p{^cpmn}', "");
    Expect(1, 77811, '\P{cpmn}', "");
    Expect(0, 77811, '\P{^cpmn}', "");
    Error('\p{-/a/is_CPMN}');
    Error('\P{-/a/is_CPMN}');
    Expect(1, 77810, '\p{iscpmn}', "");
    Expect(0, 77810, '\p{^iscpmn}', "");
    Expect(0, 77810, '\P{iscpmn}', "");
    Expect(1, 77810, '\P{^iscpmn}', "");
    Expect(0, 77811, '\p{iscpmn}', "");
    Expect(1, 77811, '\p{^iscpmn}', "");
    Expect(1, 77811, '\P{iscpmn}', "");
    Expect(0, 77811, '\P{^iscpmn}', "");
    Expect(1, 77810, '\p{	IS_cpmn}', "");
    Expect(0, 77810, '\p{^	IS_cpmn}', "");
    Expect(0, 77810, '\P{	IS_cpmn}', "");
    Expect(1, 77810, '\P{^	IS_cpmn}', "");
    Expect(0, 77811, '\p{	IS_cpmn}', "");
    Expect(1, 77811, '\p{^	IS_cpmn}', "");
    Expect(1, 77811, '\P{	IS_cpmn}', "");
    Expect(0, 77811, '\P{^	IS_cpmn}', "");
    Error('\p{/a/	Cyrillic}');
    Error('\P{/a/	Cyrillic}');
    Expect(1, 123023, '\p{cyrillic}', "");
    Expect(0, 123023, '\p{^cyrillic}', "");
    Expect(0, 123023, '\P{cyrillic}', "");
    Expect(1, 123023, '\P{^cyrillic}', "");
    Expect(0, 123024, '\p{cyrillic}', "");
    Expect(1, 123024, '\p{^cyrillic}', "");
    Expect(1, 123024, '\P{cyrillic}', "");
    Expect(0, 123024, '\P{^cyrillic}', "");
    Expect(1, 123023, '\p{_-Cyrillic}', "");
    Expect(0, 123023, '\p{^_-Cyrillic}', "");
    Expect(0, 123023, '\P{_-Cyrillic}', "");
    Expect(1, 123023, '\P{^_-Cyrillic}', "");
    Expect(0, 123024, '\p{_-Cyrillic}', "");
    Expect(1, 123024, '\p{^_-Cyrillic}', "");
    Expect(1, 123024, '\P{_-Cyrillic}', "");
    Expect(0, 123024, '\P{^_-Cyrillic}', "");
    Error('\p{	_IS_Cyrillic/a/}');
    Error('\P{	_IS_Cyrillic/a/}');
    Expect(1, 123023, '\p{iscyrillic}', "");
    Expect(0, 123023, '\p{^iscyrillic}', "");
    Expect(0, 123023, '\P{iscyrillic}', "");
    Expect(1, 123023, '\P{^iscyrillic}', "");
    Expect(0, 123024, '\p{iscyrillic}', "");
    Expect(1, 123024, '\p{^iscyrillic}', "");
    Expect(1, 123024, '\P{iscyrillic}', "");
    Expect(0, 123024, '\P{^iscyrillic}', "");
    Expect(1, 123023, '\p{_ IS_cyrillic}', "");
    Expect(0, 123023, '\p{^_ IS_cyrillic}', "");
    Expect(0, 123023, '\P{_ IS_cyrillic}', "");
    Expect(1, 123023, '\P{^_ IS_cyrillic}', "");
    Expect(0, 123024, '\p{_ IS_cyrillic}', "");
    Expect(1, 123024, '\p{^_ IS_cyrillic}', "");
    Expect(1, 123024, '\P{_ IS_cyrillic}', "");
    Expect(0, 123024, '\P{^_ IS_cyrillic}', "");
    Error('\p{Cyrl:=}');
    Error('\P{Cyrl:=}');
    Expect(1, 123023, '\p{cyrl}', "");
    Expect(0, 123023, '\p{^cyrl}', "");
    Expect(0, 123023, '\P{cyrl}', "");
    Expect(1, 123023, '\P{^cyrl}', "");
    Expect(0, 123024, '\p{cyrl}', "");
    Expect(1, 123024, '\p{^cyrl}', "");
    Expect(1, 123024, '\P{cyrl}', "");
    Expect(0, 123024, '\P{^cyrl}', "");
    Expect(1, 123023, '\p{	Cyrl}', "");
    Expect(0, 123023, '\p{^	Cyrl}', "");
    Expect(0, 123023, '\P{	Cyrl}', "");
    Expect(1, 123023, '\P{^	Cyrl}', "");
    Expect(0, 123024, '\p{	Cyrl}', "");
    Expect(1, 123024, '\p{^	Cyrl}', "");
    Expect(1, 123024, '\P{	Cyrl}', "");
    Expect(0, 123024, '\P{^	Cyrl}', "");
    Error('\p{:=Is_Cyrl}');
    Error('\P{:=Is_Cyrl}');
    Expect(1, 123023, '\p{iscyrl}', "");
    Expect(0, 123023, '\p{^iscyrl}', "");
    Expect(0, 123023, '\P{iscyrl}', "");
    Expect(1, 123023, '\P{^iscyrl}', "");
    Expect(0, 123024, '\p{iscyrl}', "");
    Expect(1, 123024, '\p{^iscyrl}', "");
    Expect(1, 123024, '\P{iscyrl}', "");
    Expect(0, 123024, '\P{^iscyrl}', "");
    Expect(1, 123023, '\p{--Is_Cyrl}', "");
    Expect(0, 123023, '\p{^--Is_Cyrl}', "");
    Expect(0, 123023, '\P{--Is_Cyrl}', "");
    Expect(1, 123023, '\P{^--Is_Cyrl}', "");
    Expect(0, 123024, '\p{--Is_Cyrl}', "");
    Expect(1, 123024, '\p{^--Is_Cyrl}', "");
    Expect(1, 123024, '\P{--Is_Cyrl}', "");
    Expect(0, 123024, '\P{^--Is_Cyrl}', "");
    Error('\p{:=	cyrillic_EXTENDED_a}');
    Error('\P{:=	cyrillic_EXTENDED_a}');
    Expect(1, 11775, '\p{cyrillicextendeda}', "");
    Expect(0, 11775, '\p{^cyrillicextendeda}', "");
    Expect(0, 11775, '\P{cyrillicextendeda}', "");
    Expect(1, 11775, '\P{^cyrillicextendeda}', "");
    Expect(0, 11776, '\p{cyrillicextendeda}', "");
    Expect(1, 11776, '\p{^cyrillicextendeda}', "");
    Expect(1, 11776, '\P{cyrillicextendeda}', "");
    Expect(0, 11776, '\P{^cyrillicextendeda}', "");
    Expect(1, 11775, '\p{	_Cyrillic_EXTENDED_a}', "");
    Expect(0, 11775, '\p{^	_Cyrillic_EXTENDED_a}', "");
    Expect(0, 11775, '\P{	_Cyrillic_EXTENDED_a}', "");
    Expect(1, 11775, '\P{^	_Cyrillic_EXTENDED_a}', "");
    Expect(0, 11776, '\p{	_Cyrillic_EXTENDED_a}', "");
    Expect(1, 11776, '\p{^	_Cyrillic_EXTENDED_a}', "");
    Expect(1, 11776, '\P{	_Cyrillic_EXTENDED_a}', "");
    Expect(0, 11776, '\P{^	_Cyrillic_EXTENDED_a}', "");
    Error('\p{ /a/IS_cyrillic_EXTENDED_A}');
    Error('\P{ /a/IS_cyrillic_EXTENDED_A}');
    Expect(1, 11775, '\p{iscyrillicextendeda}', "");
    Expect(0, 11775, '\p{^iscyrillicextendeda}', "");
    Expect(0, 11775, '\P{iscyrillicextendeda}', "");
    Expect(1, 11775, '\P{^iscyrillicextendeda}', "");
    Expect(0, 11776, '\p{iscyrillicextendeda}', "");
    Expect(1, 11776, '\p{^iscyrillicextendeda}', "");
    Expect(1, 11776, '\P{iscyrillicextendeda}', "");
    Expect(0, 11776, '\P{^iscyrillicextendeda}', "");
    Expect(1, 11775, '\p{	-Is_CYRILLIC_EXTENDED_A}', "");
    Expect(0, 11775, '\p{^	-Is_CYRILLIC_EXTENDED_A}', "");
    Expect(0, 11775, '\P{	-Is_CYRILLIC_EXTENDED_A}', "");
    Expect(1, 11775, '\P{^	-Is_CYRILLIC_EXTENDED_A}', "");
    Expect(0, 11776, '\p{	-Is_CYRILLIC_EXTENDED_A}', "");
    Expect(1, 11776, '\p{^	-Is_CYRILLIC_EXTENDED_A}', "");
    Expect(1, 11776, '\P{	-Is_CYRILLIC_EXTENDED_A}', "");
    Expect(0, 11776, '\P{^	-Is_CYRILLIC_EXTENDED_A}', "");
    Error('\p{	 IN_CYRILLIC_extended_A/a/}');
    Error('\P{	 IN_CYRILLIC_extended_A/a/}');
    Expect(1, 11775, '\p{incyrillicextendeda}', "");
    Expect(0, 11775, '\p{^incyrillicextendeda}', "");
    Expect(0, 11775, '\P{incyrillicextendeda}', "");
    Expect(1, 11775, '\P{^incyrillicextendeda}', "");
    Expect(0, 11776, '\p{incyrillicextendeda}', "");
    Expect(1, 11776, '\p{^incyrillicextendeda}', "");
    Expect(1, 11776, '\P{incyrillicextendeda}', "");
    Expect(0, 11776, '\P{^incyrillicextendeda}', "");
    Expect(1, 11775, '\p{	in_Cyrillic_EXTENDED_A}', "");
    Expect(0, 11775, '\p{^	in_Cyrillic_EXTENDED_A}', "");
    Expect(0, 11775, '\P{	in_Cyrillic_EXTENDED_A}', "");
    Expect(1, 11775, '\P{^	in_Cyrillic_EXTENDED_A}', "");
    Expect(0, 11776, '\p{	in_Cyrillic_EXTENDED_A}', "");
    Expect(1, 11776, '\p{^	in_Cyrillic_EXTENDED_A}', "");
    Expect(1, 11776, '\P{	in_Cyrillic_EXTENDED_A}', "");
    Expect(0, 11776, '\P{^	in_Cyrillic_EXTENDED_A}', "");
    Error('\p{_/a/Cyrillic_EXT_a}');
    Error('\P{_/a/Cyrillic_EXT_a}');
    Expect(1, 11775, '\p{cyrillicexta}', "");
    Expect(0, 11775, '\p{^cyrillicexta}', "");
    Expect(0, 11775, '\P{cyrillicexta}', "");
    Expect(1, 11775, '\P{^cyrillicexta}', "");
    Expect(0, 11776, '\p{cyrillicexta}', "");
    Expect(1, 11776, '\p{^cyrillicexta}', "");
    Expect(1, 11776, '\P{cyrillicexta}', "");
    Expect(0, 11776, '\P{^cyrillicexta}', "");
    Expect(1, 11775, '\p{  Cyrillic_EXT_A}', "");
    Expect(0, 11775, '\p{^  Cyrillic_EXT_A}', "");
    Expect(0, 11775, '\P{  Cyrillic_EXT_A}', "");
    Expect(1, 11775, '\P{^  Cyrillic_EXT_A}', "");
    Expect(0, 11776, '\p{  Cyrillic_EXT_A}', "");
    Expect(1, 11776, '\p{^  Cyrillic_EXT_A}', "");
    Expect(1, 11776, '\P{  Cyrillic_EXT_A}', "");
    Expect(0, 11776, '\P{^  Cyrillic_EXT_A}', "");
    Error('\p{-:=IS_CYRILLIC_Ext_a}');
    Error('\P{-:=IS_CYRILLIC_Ext_a}');
    Expect(1, 11775, '\p{iscyrillicexta}', "");
    Expect(0, 11775, '\p{^iscyrillicexta}', "");
    Expect(0, 11775, '\P{iscyrillicexta}', "");
    Expect(1, 11775, '\P{^iscyrillicexta}', "");
    Expect(0, 11776, '\p{iscyrillicexta}', "");
    Expect(1, 11776, '\p{^iscyrillicexta}', "");
    Expect(1, 11776, '\P{iscyrillicexta}', "");
    Expect(0, 11776, '\P{^iscyrillicexta}', "");
    Expect(1, 11775, '\p{-Is_Cyrillic_ext_A}', "");
    Expect(0, 11775, '\p{^-Is_Cyrillic_ext_A}', "");
    Expect(0, 11775, '\P{-Is_Cyrillic_ext_A}', "");
    Expect(1, 11775, '\P{^-Is_Cyrillic_ext_A}', "");
    Expect(0, 11776, '\p{-Is_Cyrillic_ext_A}', "");
    Expect(1, 11776, '\p{^-Is_Cyrillic_ext_A}', "");
    Expect(1, 11776, '\P{-Is_Cyrillic_ext_A}', "");
    Expect(0, 11776, '\P{^-Is_Cyrillic_ext_A}', "");
    Error('\p{/a/_ In_CYRILLIC_Ext_A}');
    Error('\P{/a/_ In_CYRILLIC_Ext_A}');
    Expect(1, 11775, '\p{incyrillicexta}', "");
    Expect(0, 11775, '\p{^incyrillicexta}', "");
    Expect(0, 11775, '\P{incyrillicexta}', "");
    Expect(1, 11775, '\P{^incyrillicexta}', "");
    Expect(0, 11776, '\p{incyrillicexta}', "");
    Expect(1, 11776, '\p{^incyrillicexta}', "");
    Expect(1, 11776, '\P{incyrillicexta}', "");
    Expect(0, 11776, '\P{^incyrillicexta}', "");
    Expect(1, 11775, '\p{_	In_Cyrillic_Ext_A}', "");
    Expect(0, 11775, '\p{^_	In_Cyrillic_Ext_A}', "");
    Expect(0, 11775, '\P{_	In_Cyrillic_Ext_A}', "");
    Expect(1, 11775, '\P{^_	In_Cyrillic_Ext_A}', "");
    Expect(0, 11776, '\p{_	In_Cyrillic_Ext_A}', "");
    Expect(1, 11776, '\p{^_	In_Cyrillic_Ext_A}', "");
    Expect(1, 11776, '\P{_	In_Cyrillic_Ext_A}', "");
    Expect(0, 11776, '\P{^_	In_Cyrillic_Ext_A}', "");
    Error('\p{/a/_Cyrillic_EXTENDED_B}');
    Error('\P{/a/_Cyrillic_EXTENDED_B}');
    Expect(1, 42655, '\p{cyrillicextendedb}', "");
    Expect(0, 42655, '\p{^cyrillicextendedb}', "");
    Expect(0, 42655, '\P{cyrillicextendedb}', "");
    Expect(1, 42655, '\P{^cyrillicextendedb}', "");
    Expect(0, 42656, '\p{cyrillicextendedb}', "");
    Expect(1, 42656, '\p{^cyrillicextendedb}', "");
    Expect(1, 42656, '\P{cyrillicextendedb}', "");
    Expect(0, 42656, '\P{^cyrillicextendedb}', "");
    Expect(1, 42655, '\p{	Cyrillic_Extended_B}', "");
    Expect(0, 42655, '\p{^	Cyrillic_Extended_B}', "");
    Expect(0, 42655, '\P{	Cyrillic_Extended_B}', "");
    Expect(1, 42655, '\P{^	Cyrillic_Extended_B}', "");
    Expect(0, 42656, '\p{	Cyrillic_Extended_B}', "");
    Expect(1, 42656, '\p{^	Cyrillic_Extended_B}', "");
    Expect(1, 42656, '\P{	Cyrillic_Extended_B}', "");
    Expect(0, 42656, '\P{^	Cyrillic_Extended_B}', "");
    Error('\p{_:=IS_cyrillic_Extended_B}');
    Error('\P{_:=IS_cyrillic_Extended_B}');
    Expect(1, 42655, '\p{iscyrillicextendedb}', "");
    Expect(0, 42655, '\p{^iscyrillicextendedb}', "");
    Expect(0, 42655, '\P{iscyrillicextendedb}', "");
    Expect(1, 42655, '\P{^iscyrillicextendedb}', "");
    Expect(0, 42656, '\p{iscyrillicextendedb}', "");
    Expect(1, 42656, '\p{^iscyrillicextendedb}', "");
    Expect(1, 42656, '\P{iscyrillicextendedb}', "");
    Expect(0, 42656, '\P{^iscyrillicextendedb}', "");
    Expect(1, 42655, '\p{- Is_Cyrillic_Extended_b}', "");
    Expect(0, 42655, '\p{^- Is_Cyrillic_Extended_b}', "");
    Expect(0, 42655, '\P{- Is_Cyrillic_Extended_b}', "");
    Expect(1, 42655, '\P{^- Is_Cyrillic_Extended_b}', "");
    Expect(0, 42656, '\p{- Is_Cyrillic_Extended_b}', "");
    Expect(1, 42656, '\p{^- Is_Cyrillic_Extended_b}', "");
    Expect(1, 42656, '\P{- Is_Cyrillic_Extended_b}', "");
    Expect(0, 42656, '\P{^- Is_Cyrillic_Extended_b}', "");
    Error('\p{_-IN_cyrillic_EXTENDED_B:=}');
    Error('\P{_-IN_cyrillic_EXTENDED_B:=}');
    Expect(1, 42655, '\p{incyrillicextendedb}', "");
    Expect(0, 42655, '\p{^incyrillicextendedb}', "");
    Expect(0, 42655, '\P{incyrillicextendedb}', "");
    Expect(1, 42655, '\P{^incyrillicextendedb}', "");
    Expect(0, 42656, '\p{incyrillicextendedb}', "");
    Expect(1, 42656, '\p{^incyrillicextendedb}', "");
    Expect(1, 42656, '\P{incyrillicextendedb}', "");
    Expect(0, 42656, '\P{^incyrillicextendedb}', "");
    Expect(1, 42655, '\p{_	In_CYRILLIC_Extended_B}', "");
    Expect(0, 42655, '\p{^_	In_CYRILLIC_Extended_B}', "");
    Expect(0, 42655, '\P{_	In_CYRILLIC_Extended_B}', "");
    Expect(1, 42655, '\P{^_	In_CYRILLIC_Extended_B}', "");
    Expect(0, 42656, '\p{_	In_CYRILLIC_Extended_B}', "");
    Expect(1, 42656, '\p{^_	In_CYRILLIC_Extended_B}', "");
    Expect(1, 42656, '\P{_	In_CYRILLIC_Extended_B}', "");
    Expect(0, 42656, '\P{^_	In_CYRILLIC_Extended_B}', "");
    Error('\p{:=Cyrillic_Ext_B}');
    Error('\P{:=Cyrillic_Ext_B}');
    Expect(1, 42655, '\p{cyrillicextb}', "");
    Expect(0, 42655, '\p{^cyrillicextb}', "");
    Expect(0, 42655, '\P{cyrillicextb}', "");
    Expect(1, 42655, '\P{^cyrillicextb}', "");
    Expect(0, 42656, '\p{cyrillicextb}', "");
    Expect(1, 42656, '\p{^cyrillicextb}', "");
    Expect(1, 42656, '\P{cyrillicextb}', "");
    Expect(0, 42656, '\P{^cyrillicextb}', "");
    Expect(1, 42655, '\p{-	CYRILLIC_Ext_b}', "");
    Expect(0, 42655, '\p{^-	CYRILLIC_Ext_b}', "");
    Expect(0, 42655, '\P{-	CYRILLIC_Ext_b}', "");
    Expect(1, 42655, '\P{^-	CYRILLIC_Ext_b}', "");
    Expect(0, 42656, '\p{-	CYRILLIC_Ext_b}', "");
    Expect(1, 42656, '\p{^-	CYRILLIC_Ext_b}', "");
    Expect(1, 42656, '\P{-	CYRILLIC_Ext_b}', "");
    Expect(0, 42656, '\P{^-	CYRILLIC_Ext_b}', "");
    Error('\p{- Is_CYRILLIC_Ext_B/a/}');
    Error('\P{- Is_CYRILLIC_Ext_B/a/}');
    Expect(1, 42655, '\p{iscyrillicextb}', "");
    Expect(0, 42655, '\p{^iscyrillicextb}', "");
    Expect(0, 42655, '\P{iscyrillicextb}', "");
    Expect(1, 42655, '\P{^iscyrillicextb}', "");
    Expect(0, 42656, '\p{iscyrillicextb}', "");
    Expect(1, 42656, '\p{^iscyrillicextb}', "");
    Expect(1, 42656, '\P{iscyrillicextb}', "");
    Expect(0, 42656, '\P{^iscyrillicextb}', "");
    Expect(1, 42655, '\p{-Is_Cyrillic_EXT_B}', "");
    Expect(0, 42655, '\p{^-Is_Cyrillic_EXT_B}', "");
    Expect(0, 42655, '\P{-Is_Cyrillic_EXT_B}', "");
    Expect(1, 42655, '\P{^-Is_Cyrillic_EXT_B}', "");
    Expect(0, 42656, '\p{-Is_Cyrillic_EXT_B}', "");
    Expect(1, 42656, '\p{^-Is_Cyrillic_EXT_B}', "");
    Expect(1, 42656, '\P{-Is_Cyrillic_EXT_B}', "");
    Expect(0, 42656, '\P{^-Is_Cyrillic_EXT_B}', "");
    Error('\p{_:=In_CYRILLIC_ext_B}');
    Error('\P{_:=In_CYRILLIC_ext_B}');
    Expect(1, 42655, '\p{incyrillicextb}', "");
    Expect(0, 42655, '\p{^incyrillicextb}', "");
    Expect(0, 42655, '\P{incyrillicextb}', "");
    Expect(1, 42655, '\P{^incyrillicextb}', "");
    Expect(0, 42656, '\p{incyrillicextb}', "");
    Expect(1, 42656, '\p{^incyrillicextb}', "");
    Expect(1, 42656, '\P{incyrillicextb}', "");
    Expect(0, 42656, '\P{^incyrillicextb}', "");
    Expect(1, 42655, '\p{ _IN_Cyrillic_Ext_B}', "");
    Expect(0, 42655, '\p{^ _IN_Cyrillic_Ext_B}', "");
    Expect(0, 42655, '\P{ _IN_Cyrillic_Ext_B}', "");
    Expect(1, 42655, '\P{^ _IN_Cyrillic_Ext_B}', "");
    Expect(0, 42656, '\p{ _IN_Cyrillic_Ext_B}', "");
    Expect(1, 42656, '\p{^ _IN_Cyrillic_Ext_B}', "");
    Expect(1, 42656, '\P{ _IN_Cyrillic_Ext_B}', "");
    Expect(0, 42656, '\P{^ _IN_Cyrillic_Ext_B}', "");
    Error('\p{_ cyrillic_Extended_c:=}');
    Error('\P{_ cyrillic_Extended_c:=}');
    Expect(1, 7311, '\p{cyrillicextendedc}', "");
    Expect(0, 7311, '\p{^cyrillicextendedc}', "");
    Expect(0, 7311, '\P{cyrillicextendedc}', "");
    Expect(1, 7311, '\P{^cyrillicextendedc}', "");
    Expect(0, 7312, '\p{cyrillicextendedc}', "");
    Expect(1, 7312, '\p{^cyrillicextendedc}', "");
    Expect(1, 7312, '\P{cyrillicextendedc}', "");
    Expect(0, 7312, '\P{^cyrillicextendedc}', "");
    Expect(1, 7311, '\p{	CYRILLIC_extended_C}', "");
    Expect(0, 7311, '\p{^	CYRILLIC_extended_C}', "");
    Expect(0, 7311, '\P{	CYRILLIC_extended_C}', "");
    Expect(1, 7311, '\P{^	CYRILLIC_extended_C}', "");
    Expect(0, 7312, '\p{	CYRILLIC_extended_C}', "");
    Expect(1, 7312, '\p{^	CYRILLIC_extended_C}', "");
    Expect(1, 7312, '\P{	CYRILLIC_extended_C}', "");
    Expect(0, 7312, '\P{^	CYRILLIC_extended_C}', "");
    Error('\p{-Is_cyrillic_EXTENDED_C/a/}');
    Error('\P{-Is_cyrillic_EXTENDED_C/a/}');
    Expect(1, 7311, '\p{iscyrillicextendedc}', "");
    Expect(0, 7311, '\p{^iscyrillicextendedc}', "");
    Expect(0, 7311, '\P{iscyrillicextendedc}', "");
    Expect(1, 7311, '\P{^iscyrillicextendedc}', "");
    Expect(0, 7312, '\p{iscyrillicextendedc}', "");
    Expect(1, 7312, '\p{^iscyrillicextendedc}', "");
    Expect(1, 7312, '\P{iscyrillicextendedc}', "");
    Expect(0, 7312, '\P{^iscyrillicextendedc}', "");
    Expect(1, 7311, '\p{	Is_CYRILLIC_EXTENDED_c}', "");
    Expect(0, 7311, '\p{^	Is_CYRILLIC_EXTENDED_c}', "");
    Expect(0, 7311, '\P{	Is_CYRILLIC_EXTENDED_c}', "");
    Expect(1, 7311, '\P{^	Is_CYRILLIC_EXTENDED_c}', "");
    Expect(0, 7312, '\p{	Is_CYRILLIC_EXTENDED_c}', "");
    Expect(1, 7312, '\p{^	Is_CYRILLIC_EXTENDED_c}', "");
    Expect(1, 7312, '\P{	Is_CYRILLIC_EXTENDED_c}', "");
    Expect(0, 7312, '\P{^	Is_CYRILLIC_EXTENDED_c}', "");
    Error('\p{/a/_ IN_cyrillic_Extended_c}');
    Error('\P{/a/_ IN_cyrillic_Extended_c}');
    Expect(1, 7311, '\p{incyrillicextendedc}', "");
    Expect(0, 7311, '\p{^incyrillicextendedc}', "");
    Expect(0, 7311, '\P{incyrillicextendedc}', "");
    Expect(1, 7311, '\P{^incyrillicextendedc}', "");
    Expect(0, 7312, '\p{incyrillicextendedc}', "");
    Expect(1, 7312, '\p{^incyrillicextendedc}', "");
    Expect(1, 7312, '\P{incyrillicextendedc}', "");
    Expect(0, 7312, '\P{^incyrillicextendedc}', "");
    Expect(1, 7311, '\p{	-In_Cyrillic_extended_c}', "");
    Expect(0, 7311, '\p{^	-In_Cyrillic_extended_c}', "");
    Expect(0, 7311, '\P{	-In_Cyrillic_extended_c}', "");
    Expect(1, 7311, '\P{^	-In_Cyrillic_extended_c}', "");
    Expect(0, 7312, '\p{	-In_Cyrillic_extended_c}', "");
    Expect(1, 7312, '\p{^	-In_Cyrillic_extended_c}', "");
    Expect(1, 7312, '\P{	-In_Cyrillic_extended_c}', "");
    Expect(0, 7312, '\P{^	-In_Cyrillic_extended_c}', "");
    Error('\p{Cyrillic_ext_C:=}');
    Error('\P{Cyrillic_ext_C:=}');
    Expect(1, 7311, '\p{cyrillicextc}', "");
    Expect(0, 7311, '\p{^cyrillicextc}', "");
    Expect(0, 7311, '\P{cyrillicextc}', "");
    Expect(1, 7311, '\P{^cyrillicextc}', "");
    Expect(0, 7312, '\p{cyrillicextc}', "");
    Expect(1, 7312, '\p{^cyrillicextc}', "");
    Expect(1, 7312, '\P{cyrillicextc}', "");
    Expect(0, 7312, '\P{^cyrillicextc}', "");
    Expect(1, 7311, '\p{	Cyrillic_EXT_C}', "");
    Expect(0, 7311, '\p{^	Cyrillic_EXT_C}', "");
    Expect(0, 7311, '\P{	Cyrillic_EXT_C}', "");
    Expect(1, 7311, '\P{^	Cyrillic_EXT_C}', "");
    Expect(0, 7312, '\p{	Cyrillic_EXT_C}', "");
    Expect(1, 7312, '\p{^	Cyrillic_EXT_C}', "");
    Expect(1, 7312, '\P{	Cyrillic_EXT_C}', "");
    Expect(0, 7312, '\P{^	Cyrillic_EXT_C}', "");
    Error('\p{ /a/Is_Cyrillic_ext_C}');
    Error('\P{ /a/Is_Cyrillic_ext_C}');
    Expect(1, 7311, '\p{iscyrillicextc}', "");
    Expect(0, 7311, '\p{^iscyrillicextc}', "");
    Expect(0, 7311, '\P{iscyrillicextc}', "");
    Expect(1, 7311, '\P{^iscyrillicextc}', "");
    Expect(0, 7312, '\p{iscyrillicextc}', "");
    Expect(1, 7312, '\p{^iscyrillicextc}', "");
    Expect(1, 7312, '\P{iscyrillicextc}', "");
    Expect(0, 7312, '\P{^iscyrillicextc}', "");
    Expect(1, 7311, '\p{_-IS_CYRILLIC_Ext_C}', "");
    Expect(0, 7311, '\p{^_-IS_CYRILLIC_Ext_C}', "");
    Expect(0, 7311, '\P{_-IS_CYRILLIC_Ext_C}', "");
    Expect(1, 7311, '\P{^_-IS_CYRILLIC_Ext_C}', "");
    Expect(0, 7312, '\p{_-IS_CYRILLIC_Ext_C}', "");
    Expect(1, 7312, '\p{^_-IS_CYRILLIC_Ext_C}', "");
    Expect(1, 7312, '\P{_-IS_CYRILLIC_Ext_C}', "");
    Expect(0, 7312, '\P{^_-IS_CYRILLIC_Ext_C}', "");
    Error('\p{-/a/In_Cyrillic_Ext_C}');
    Error('\P{-/a/In_Cyrillic_Ext_C}');
    Expect(1, 7311, '\p{incyrillicextc}', "");
    Expect(0, 7311, '\p{^incyrillicextc}', "");
    Expect(0, 7311, '\P{incyrillicextc}', "");
    Expect(1, 7311, '\P{^incyrillicextc}', "");
    Expect(0, 7312, '\p{incyrillicextc}', "");
    Expect(1, 7312, '\p{^incyrillicextc}', "");
    Expect(1, 7312, '\P{incyrillicextc}', "");
    Expect(0, 7312, '\P{^incyrillicextc}', "");
    Expect(1, 7311, '\p{_In_cyrillic_Ext_C}', "");
    Expect(0, 7311, '\p{^_In_cyrillic_Ext_C}', "");
    Expect(0, 7311, '\P{_In_cyrillic_Ext_C}', "");
    Expect(1, 7311, '\P{^_In_cyrillic_Ext_C}', "");
    Expect(0, 7312, '\p{_In_cyrillic_Ext_C}', "");
    Expect(1, 7312, '\p{^_In_cyrillic_Ext_C}', "");
    Expect(1, 7312, '\P{_In_cyrillic_Ext_C}', "");
    Expect(0, 7312, '\P{^_In_cyrillic_Ext_C}', "");
    Error('\p{_Cyrillic_Extended_D/a/}');
    Error('\P{_Cyrillic_Extended_D/a/}');
    Expect(1, 123023, '\p{cyrillicextendedd}', "");
    Expect(0, 123023, '\p{^cyrillicextendedd}', "");
    Expect(0, 123023, '\P{cyrillicextendedd}', "");
    Expect(1, 123023, '\P{^cyrillicextendedd}', "");
    Expect(0, 123024, '\p{cyrillicextendedd}', "");
    Expect(1, 123024, '\p{^cyrillicextendedd}', "");
    Expect(1, 123024, '\P{cyrillicextendedd}', "");
    Expect(0, 123024, '\P{^cyrillicextendedd}', "");
    Expect(1, 123023, '\p{ -CYRILLIC_extended_D}', "");
    Expect(0, 123023, '\p{^ -CYRILLIC_extended_D}', "");
    Expect(0, 123023, '\P{ -CYRILLIC_extended_D}', "");
    Expect(1, 123023, '\P{^ -CYRILLIC_extended_D}', "");
    Expect(0, 123024, '\p{ -CYRILLIC_extended_D}', "");
    Expect(1, 123024, '\p{^ -CYRILLIC_extended_D}', "");
    Expect(1, 123024, '\P{ -CYRILLIC_extended_D}', "");
    Expect(0, 123024, '\P{^ -CYRILLIC_extended_D}', "");
    Error('\p{/a/Is_Cyrillic_Extended_D}');
    Error('\P{/a/Is_Cyrillic_Extended_D}');
    Expect(1, 123023, '\p{iscyrillicextendedd}', "");
    Expect(0, 123023, '\p{^iscyrillicextendedd}', "");
    Expect(0, 123023, '\P{iscyrillicextendedd}', "");
    Expect(1, 123023, '\P{^iscyrillicextendedd}', "");
    Expect(0, 123024, '\p{iscyrillicextendedd}', "");
    Expect(1, 123024, '\p{^iscyrillicextendedd}', "");
    Expect(1, 123024, '\P{iscyrillicextendedd}', "");
    Expect(0, 123024, '\P{^iscyrillicextendedd}', "");
    Expect(1, 123023, '\p{--Is_cyrillic_extended_D}', "");
    Expect(0, 123023, '\p{^--Is_cyrillic_extended_D}', "");
    Expect(0, 123023, '\P{--Is_cyrillic_extended_D}', "");
    Expect(1, 123023, '\P{^--Is_cyrillic_extended_D}', "");
    Expect(0, 123024, '\p{--Is_cyrillic_extended_D}', "");
    Expect(1, 123024, '\p{^--Is_cyrillic_extended_D}', "");
    Expect(1, 123024, '\P{--Is_cyrillic_extended_D}', "");
    Expect(0, 123024, '\P{^--Is_cyrillic_extended_D}', "");
    Error('\p{/a/	 IN_Cyrillic_extended_D}');
    Error('\P{/a/	 IN_Cyrillic_extended_D}');
    Expect(1, 123023, '\p{incyrillicextendedd}', "");
    Expect(0, 123023, '\p{^incyrillicextendedd}', "");
    Expect(0, 123023, '\P{incyrillicextendedd}', "");
    Expect(1, 123023, '\P{^incyrillicextendedd}', "");
    Expect(0, 123024, '\p{incyrillicextendedd}', "");
    Expect(1, 123024, '\p{^incyrillicextendedd}', "");
    Expect(1, 123024, '\P{incyrillicextendedd}', "");
    Expect(0, 123024, '\P{^incyrillicextendedd}', "");
    Expect(1, 123023, '\p{_	IN_CYRILLIC_EXTENDED_d}', "");
    Expect(0, 123023, '\p{^_	IN_CYRILLIC_EXTENDED_d}', "");
    Expect(0, 123023, '\P{_	IN_CYRILLIC_EXTENDED_d}', "");
    Expect(1, 123023, '\P{^_	IN_CYRILLIC_EXTENDED_d}', "");
    Expect(0, 123024, '\p{_	IN_CYRILLIC_EXTENDED_d}', "");
    Expect(1, 123024, '\p{^_	IN_CYRILLIC_EXTENDED_d}', "");
    Expect(1, 123024, '\P{_	IN_CYRILLIC_EXTENDED_d}', "");
    Expect(0, 123024, '\P{^_	IN_CYRILLIC_EXTENDED_d}', "");
    Error('\p{--Cyrillic_ext_d:=}');
    Error('\P{--Cyrillic_ext_d:=}');
    Expect(1, 123023, '\p{cyrillicextd}', "");
    Expect(0, 123023, '\p{^cyrillicextd}', "");
    Expect(0, 123023, '\P{cyrillicextd}', "");
    Expect(1, 123023, '\P{^cyrillicextd}', "");
    Expect(0, 123024, '\p{cyrillicextd}', "");
    Expect(1, 123024, '\p{^cyrillicextd}', "");
    Expect(1, 123024, '\P{cyrillicextd}', "");
    Expect(0, 123024, '\P{^cyrillicextd}', "");
    Expect(1, 123023, '\p{ Cyrillic_Ext_D}', "");
    Expect(0, 123023, '\p{^ Cyrillic_Ext_D}', "");
    Expect(0, 123023, '\P{ Cyrillic_Ext_D}', "");
    Expect(1, 123023, '\P{^ Cyrillic_Ext_D}', "");
    Expect(0, 123024, '\p{ Cyrillic_Ext_D}', "");
    Expect(1, 123024, '\p{^ Cyrillic_Ext_D}', "");
    Expect(1, 123024, '\P{ Cyrillic_Ext_D}', "");
    Expect(0, 123024, '\P{^ Cyrillic_Ext_D}', "");
    Error('\p{- Is_Cyrillic_EXT_D/a/}');
    Error('\P{- Is_Cyrillic_EXT_D/a/}');
    Expect(1, 123023, '\p{iscyrillicextd}', "");
    Expect(0, 123023, '\p{^iscyrillicextd}', "");
    Expect(0, 123023, '\P{iscyrillicextd}', "");
    Expect(1, 123023, '\P{^iscyrillicextd}', "");
    Expect(0, 123024, '\p{iscyrillicextd}', "");
    Expect(1, 123024, '\p{^iscyrillicextd}', "");
    Expect(1, 123024, '\P{iscyrillicextd}', "");
    Expect(0, 123024, '\P{^iscyrillicextd}', "");
    Expect(1, 123023, '\p{	_is_Cyrillic_EXT_D}', "");
    Expect(0, 123023, '\p{^	_is_Cyrillic_EXT_D}', "");
    Expect(0, 123023, '\P{	_is_Cyrillic_EXT_D}', "");
    Expect(1, 123023, '\P{^	_is_Cyrillic_EXT_D}', "");
    Expect(0, 123024, '\p{	_is_Cyrillic_EXT_D}', "");
    Expect(1, 123024, '\p{^	_is_Cyrillic_EXT_D}', "");
    Expect(1, 123024, '\P{	_is_Cyrillic_EXT_D}', "");
    Expect(0, 123024, '\P{^	_is_Cyrillic_EXT_D}', "");
    Error('\p{/a/__in_CYRILLIC_ext_D}');
    Error('\P{/a/__in_CYRILLIC_ext_D}');
    Expect(1, 123023, '\p{incyrillicextd}', "");
    Expect(0, 123023, '\p{^incyrillicextd}', "");
    Expect(0, 123023, '\P{incyrillicextd}', "");
    Expect(1, 123023, '\P{^incyrillicextd}', "");
    Expect(0, 123024, '\p{incyrillicextd}', "");
    Expect(1, 123024, '\p{^incyrillicextd}', "");
    Expect(1, 123024, '\P{incyrillicextd}', "");
    Expect(0, 123024, '\P{^incyrillicextd}', "");
    Expect(1, 123023, '\p{-_In_Cyrillic_ext_D}', "");
    Expect(0, 123023, '\p{^-_In_Cyrillic_ext_D}', "");
    Expect(0, 123023, '\P{-_In_Cyrillic_ext_D}', "");
    Expect(1, 123023, '\P{^-_In_Cyrillic_ext_D}', "");
    Expect(0, 123024, '\p{-_In_Cyrillic_ext_D}', "");
    Expect(1, 123024, '\p{^-_In_Cyrillic_ext_D}', "");
    Expect(1, 123024, '\P{-_In_Cyrillic_ext_D}', "");
    Expect(0, 123024, '\P{^-_In_Cyrillic_ext_D}', "");
    Error('\p{ CYRILLIC_SUPPLEMENT/a/}');
    Error('\P{ CYRILLIC_SUPPLEMENT/a/}');
    Expect(1, 1327, '\p{cyrillicsupplement}', "");
    Expect(0, 1327, '\p{^cyrillicsupplement}', "");
    Expect(0, 1327, '\P{cyrillicsupplement}', "");
    Expect(1, 1327, '\P{^cyrillicsupplement}', "");
    Expect(0, 1328, '\p{cyrillicsupplement}', "");
    Expect(1, 1328, '\p{^cyrillicsupplement}', "");
    Expect(1, 1328, '\P{cyrillicsupplement}', "");
    Expect(0, 1328, '\P{^cyrillicsupplement}', "");
    Expect(1, 1327, '\p{ -Cyrillic_SUPPLEMENT}', "");
    Expect(0, 1327, '\p{^ -Cyrillic_SUPPLEMENT}', "");
    Expect(0, 1327, '\P{ -Cyrillic_SUPPLEMENT}', "");
    Expect(1, 1327, '\P{^ -Cyrillic_SUPPLEMENT}', "");
    Expect(0, 1328, '\p{ -Cyrillic_SUPPLEMENT}', "");
    Expect(1, 1328, '\p{^ -Cyrillic_SUPPLEMENT}', "");
    Expect(1, 1328, '\P{ -Cyrillic_SUPPLEMENT}', "");
    Expect(0, 1328, '\P{^ -Cyrillic_SUPPLEMENT}', "");
    Error('\p{	-Is_Cyrillic_Supplement/a/}');
    Error('\P{	-Is_Cyrillic_Supplement/a/}');
    Expect(1, 1327, '\p{iscyrillicsupplement}', "");
    Expect(0, 1327, '\p{^iscyrillicsupplement}', "");
    Expect(0, 1327, '\P{iscyrillicsupplement}', "");
    Expect(1, 1327, '\P{^iscyrillicsupplement}', "");
    Expect(0, 1328, '\p{iscyrillicsupplement}', "");
    Expect(1, 1328, '\p{^iscyrillicsupplement}', "");
    Expect(1, 1328, '\P{iscyrillicsupplement}', "");
    Expect(0, 1328, '\P{^iscyrillicsupplement}', "");
    Expect(1, 1327, '\p{	is_Cyrillic_SUPPLEMENT}', "");
    Expect(0, 1327, '\p{^	is_Cyrillic_SUPPLEMENT}', "");
    Expect(0, 1327, '\P{	is_Cyrillic_SUPPLEMENT}', "");
    Expect(1, 1327, '\P{^	is_Cyrillic_SUPPLEMENT}', "");
    Expect(0, 1328, '\p{	is_Cyrillic_SUPPLEMENT}', "");
    Expect(1, 1328, '\p{^	is_Cyrillic_SUPPLEMENT}', "");
    Expect(1, 1328, '\P{	is_Cyrillic_SUPPLEMENT}', "");
    Expect(0, 1328, '\P{^	is_Cyrillic_SUPPLEMENT}', "");
    Error('\p{:=__IN_CYRILLIC_SUPPLEMENT}');
    Error('\P{:=__IN_CYRILLIC_SUPPLEMENT}');
    Expect(1, 1327, '\p{incyrillicsupplement}', "");
    Expect(0, 1327, '\p{^incyrillicsupplement}', "");
    Expect(0, 1327, '\P{incyrillicsupplement}', "");
    Expect(1, 1327, '\P{^incyrillicsupplement}', "");
    Expect(0, 1328, '\p{incyrillicsupplement}', "");
    Expect(1, 1328, '\p{^incyrillicsupplement}', "");
    Expect(1, 1328, '\P{incyrillicsupplement}', "");
    Expect(0, 1328, '\P{^incyrillicsupplement}', "");
    Expect(1, 1327, '\p{		in_cyrillic_Supplement}', "");
    Expect(0, 1327, '\p{^		in_cyrillic_Supplement}', "");
    Expect(0, 1327, '\P{		in_cyrillic_Supplement}', "");
    Expect(1, 1327, '\P{^		in_cyrillic_Supplement}', "");
    Expect(0, 1328, '\p{		in_cyrillic_Supplement}', "");
    Expect(1, 1328, '\p{^		in_cyrillic_Supplement}', "");
    Expect(1, 1328, '\P{		in_cyrillic_Supplement}', "");
    Expect(0, 1328, '\P{^		in_cyrillic_Supplement}', "");
    Error('\p{ -CYRILLIC_Sup/a/}');
    Error('\P{ -CYRILLIC_Sup/a/}');
    Expect(1, 1327, '\p{cyrillicsup}', "");
    Expect(0, 1327, '\p{^cyrillicsup}', "");
    Expect(0, 1327, '\P{cyrillicsup}', "");
    Expect(1, 1327, '\P{^cyrillicsup}', "");
    Expect(0, 1328, '\p{cyrillicsup}', "");
    Expect(1, 1328, '\p{^cyrillicsup}', "");
    Expect(1, 1328, '\P{cyrillicsup}', "");
    Expect(0, 1328, '\P{^cyrillicsup}', "");
    Expect(1, 1327, '\p{-	Cyrillic_Sup}', "");
    Expect(0, 1327, '\p{^-	Cyrillic_Sup}', "");
    Expect(0, 1327, '\P{-	Cyrillic_Sup}', "");
    Expect(1, 1327, '\P{^-	Cyrillic_Sup}', "");
    Expect(0, 1328, '\p{-	Cyrillic_Sup}', "");
    Expect(1, 1328, '\p{^-	Cyrillic_Sup}', "");
    Expect(1, 1328, '\P{-	Cyrillic_Sup}', "");
    Expect(0, 1328, '\P{^-	Cyrillic_Sup}', "");
    Error('\p{	Is_cyrillic_Sup/a/}');
    Error('\P{	Is_cyrillic_Sup/a/}');
    Expect(1, 1327, '\p{iscyrillicsup}', "");
    Expect(0, 1327, '\p{^iscyrillicsup}', "");
    Expect(0, 1327, '\P{iscyrillicsup}', "");
    Expect(1, 1327, '\P{^iscyrillicsup}', "");
    Expect(0, 1328, '\p{iscyrillicsup}', "");
    Expect(1, 1328, '\p{^iscyrillicsup}', "");
    Expect(1, 1328, '\P{iscyrillicsup}', "");
    Expect(0, 1328, '\P{^iscyrillicsup}', "");
    Expect(1, 1327, '\p{-Is_Cyrillic_SUP}', "");
    Expect(0, 1327, '\p{^-Is_Cyrillic_SUP}', "");
    Expect(0, 1327, '\P{-Is_Cyrillic_SUP}', "");
    Expect(1, 1327, '\P{^-Is_Cyrillic_SUP}', "");
    Expect(0, 1328, '\p{-Is_Cyrillic_SUP}', "");
    Expect(1, 1328, '\p{^-Is_Cyrillic_SUP}', "");
    Expect(1, 1328, '\P{-Is_Cyrillic_SUP}', "");
    Expect(0, 1328, '\P{^-Is_Cyrillic_SUP}', "");
    Error('\p{	/a/In_cyrillic_Sup}');
    Error('\P{	/a/In_cyrillic_Sup}');
    Expect(1, 1327, '\p{incyrillicsup}', "");
    Expect(0, 1327, '\p{^incyrillicsup}', "");
    Expect(0, 1327, '\P{incyrillicsup}', "");
    Expect(1, 1327, '\P{^incyrillicsup}', "");
    Expect(0, 1328, '\p{incyrillicsup}', "");
    Expect(1, 1328, '\p{^incyrillicsup}', "");
    Expect(1, 1328, '\P{incyrillicsup}', "");
    Expect(0, 1328, '\P{^incyrillicsup}', "");
    Expect(1, 1327, '\p{	_In_CYRILLIC_Sup}', "");
    Expect(0, 1327, '\p{^	_In_CYRILLIC_Sup}', "");
    Expect(0, 1327, '\P{	_In_CYRILLIC_Sup}', "");
    Expect(1, 1327, '\P{^	_In_CYRILLIC_Sup}', "");
    Expect(0, 1328, '\p{	_In_CYRILLIC_Sup}', "");
    Expect(1, 1328, '\p{^	_In_CYRILLIC_Sup}', "");
    Expect(1, 1328, '\P{	_In_CYRILLIC_Sup}', "");
    Expect(0, 1328, '\P{^	_In_CYRILLIC_Sup}', "");
    Error('\p{/a/- cyrillic_Supplementary}');
    Error('\P{/a/- cyrillic_Supplementary}');
    Expect(1, 1327, '\p{cyrillicsupplementary}', "");
    Expect(0, 1327, '\p{^cyrillicsupplementary}', "");
    Expect(0, 1327, '\P{cyrillicsupplementary}', "");
    Expect(1, 1327, '\P{^cyrillicsupplementary}', "");
    Expect(0, 1328, '\p{cyrillicsupplementary}', "");
    Expect(1, 1328, '\p{^cyrillicsupplementary}', "");
    Expect(1, 1328, '\P{cyrillicsupplementary}', "");
    Expect(0, 1328, '\P{^cyrillicsupplementary}', "");
    Expect(1, 1327, '\p{__Cyrillic_SUPPLEMENTARY}', "");
    Expect(0, 1327, '\p{^__Cyrillic_SUPPLEMENTARY}', "");
    Expect(0, 1327, '\P{__Cyrillic_SUPPLEMENTARY}', "");
    Expect(1, 1327, '\P{^__Cyrillic_SUPPLEMENTARY}', "");
    Expect(0, 1328, '\p{__Cyrillic_SUPPLEMENTARY}', "");
    Expect(1, 1328, '\p{^__Cyrillic_SUPPLEMENTARY}', "");
    Expect(1, 1328, '\P{__Cyrillic_SUPPLEMENTARY}', "");
    Expect(0, 1328, '\P{^__Cyrillic_SUPPLEMENTARY}', "");
    Error('\p{:=-IS_Cyrillic_Supplementary}');
    Error('\P{:=-IS_Cyrillic_Supplementary}');
    Expect(1, 1327, '\p{iscyrillicsupplementary}', "");
    Expect(0, 1327, '\p{^iscyrillicsupplementary}', "");
    Expect(0, 1327, '\P{iscyrillicsupplementary}', "");
    Expect(1, 1327, '\P{^iscyrillicsupplementary}', "");
    Expect(0, 1328, '\p{iscyrillicsupplementary}', "");
    Expect(1, 1328, '\p{^iscyrillicsupplementary}', "");
    Expect(1, 1328, '\P{iscyrillicsupplementary}', "");
    Expect(0, 1328, '\P{^iscyrillicsupplementary}', "");
    Expect(1, 1327, '\p{ _is_Cyrillic_SUPPLEMENTARY}', "");
    Expect(0, 1327, '\p{^ _is_Cyrillic_SUPPLEMENTARY}', "");
    Expect(0, 1327, '\P{ _is_Cyrillic_SUPPLEMENTARY}', "");
    Expect(1, 1327, '\P{^ _is_Cyrillic_SUPPLEMENTARY}', "");
    Expect(0, 1328, '\p{ _is_Cyrillic_SUPPLEMENTARY}', "");
    Expect(1, 1328, '\p{^ _is_Cyrillic_SUPPLEMENTARY}', "");
    Expect(1, 1328, '\P{ _is_Cyrillic_SUPPLEMENTARY}', "");
    Expect(0, 1328, '\P{^ _is_Cyrillic_SUPPLEMENTARY}', "");
    Error('\p{	In_CYRILLIC_supplementary:=}');
    Error('\P{	In_CYRILLIC_supplementary:=}');
    Expect(1, 1327, '\p{incyrillicsupplementary}', "");
    Expect(0, 1327, '\p{^incyrillicsupplementary}', "");
    Expect(0, 1327, '\P{incyrillicsupplementary}', "");
    Expect(1, 1327, '\P{^incyrillicsupplementary}', "");
    Expect(0, 1328, '\p{incyrillicsupplementary}', "");
    Expect(1, 1328, '\p{^incyrillicsupplementary}', "");
    Expect(1, 1328, '\P{incyrillicsupplementary}', "");
    Expect(0, 1328, '\P{^incyrillicsupplementary}', "");
    Expect(1, 1327, '\p{-In_Cyrillic_Supplementary}', "");
    Expect(0, 1327, '\p{^-In_Cyrillic_Supplementary}', "");
    Expect(0, 1327, '\P{-In_Cyrillic_Supplementary}', "");
    Expect(1, 1327, '\P{^-In_Cyrillic_Supplementary}', "");
    Expect(0, 1328, '\p{-In_Cyrillic_Supplementary}', "");
    Expect(1, 1328, '\p{^-In_Cyrillic_Supplementary}', "");
    Expect(1, 1328, '\P{-In_Cyrillic_Supplementary}', "");
    Expect(0, 1328, '\P{^-In_Cyrillic_Supplementary}', "");
    Error('\p{	:=Dash}');
    Error('\P{	:=Dash}');
    Expect(1, 69293, '\p{dash}', "");
    Expect(0, 69293, '\p{^dash}', "");
    Expect(0, 69293, '\P{dash}', "");
    Expect(1, 69293, '\P{^dash}', "");
    Expect(0, 69294, '\p{dash}', "");
    Expect(1, 69294, '\p{^dash}', "");
    Expect(1, 69294, '\P{dash}', "");
    Expect(0, 69294, '\P{^dash}', "");
    Expect(1, 69293, '\p{	 DASH}', "");
    Expect(0, 69293, '\p{^	 DASH}', "");
    Expect(0, 69293, '\P{	 DASH}', "");
    Expect(1, 69293, '\P{^	 DASH}', "");
    Expect(0, 69294, '\p{	 DASH}', "");
    Expect(1, 69294, '\p{^	 DASH}', "");
    Expect(1, 69294, '\P{	 DASH}', "");
    Expect(0, 69294, '\P{^	 DASH}', "");
    Error('\p{  is_Dash/a/}');
    Error('\P{  is_Dash/a/}');
    Expect(1, 69293, '\p{isdash}', "");
    Expect(0, 69293, '\p{^isdash}', "");
    Expect(0, 69293, '\P{isdash}', "");
    Expect(1, 69293, '\P{^isdash}', "");
    Expect(0, 69294, '\p{isdash}', "");
    Expect(1, 69294, '\p{^isdash}', "");
    Expect(1, 69294, '\P{isdash}', "");
    Expect(0, 69294, '\P{^isdash}', "");
    Expect(1, 69293, '\p{ -Is_dash}', "");
    Expect(0, 69293, '\p{^ -Is_dash}', "");
    Expect(0, 69293, '\P{ -Is_dash}', "");
    Expect(1, 69293, '\P{^ -Is_dash}', "");
    Expect(0, 69294, '\p{ -Is_dash}', "");
    Expect(1, 69294, '\p{^ -Is_dash}', "");
    Expect(1, 69294, '\P{ -Is_dash}', "");
    Expect(0, 69294, '\P{^ -Is_dash}', "");
    Error('\p{_/a/dash_Punctuation}');
    Error('\P{_/a/dash_Punctuation}');
    Expect(1, 69293, '\p{dashpunctuation}', "");
    Expect(0, 69293, '\p{^dashpunctuation}', "");
    Expect(0, 69293, '\P{dashpunctuation}', "");
    Expect(1, 69293, '\P{^dashpunctuation}', "");
    Expect(0, 69294, '\p{dashpunctuation}', "");
    Expect(1, 69294, '\p{^dashpunctuation}', "");
    Expect(1, 69294, '\P{dashpunctuation}', "");
    Expect(0, 69294, '\P{^dashpunctuation}', "");
    Expect(1, 69293, '\p{- dash_PUNCTUATION}', "");
    Expect(0, 69293, '\p{^- dash_PUNCTUATION}', "");
    Expect(0, 69293, '\P{- dash_PUNCTUATION}', "");
    Expect(1, 69293, '\P{^- dash_PUNCTUATION}', "");
    Expect(0, 69294, '\p{- dash_PUNCTUATION}', "");
    Expect(1, 69294, '\p{^- dash_PUNCTUATION}', "");
    Expect(1, 69294, '\P{- dash_PUNCTUATION}', "");
    Expect(0, 69294, '\P{^- dash_PUNCTUATION}', "");
    Error('\p{		is_Dash_Punctuation/a/}');
    Error('\P{		is_Dash_Punctuation/a/}');
    Expect(1, 69293, '\p{isdashpunctuation}', "");
    Expect(0, 69293, '\p{^isdashpunctuation}', "");
    Expect(0, 69293, '\P{isdashpunctuation}', "");
    Expect(1, 69293, '\P{^isdashpunctuation}', "");
    Expect(0, 69294, '\p{isdashpunctuation}', "");
    Expect(1, 69294, '\p{^isdashpunctuation}', "");
    Expect(1, 69294, '\P{isdashpunctuation}', "");
    Expect(0, 69294, '\P{^isdashpunctuation}', "");
    Expect(1, 69293, '\p{		is_Dash_punctuation}', "");
    Expect(0, 69293, '\p{^		is_Dash_punctuation}', "");
    Expect(0, 69293, '\P{		is_Dash_punctuation}', "");
    Expect(1, 69293, '\P{^		is_Dash_punctuation}', "");
    Expect(0, 69294, '\p{		is_Dash_punctuation}', "");
    Expect(1, 69294, '\p{^		is_Dash_punctuation}', "");
    Expect(1, 69294, '\P{		is_Dash_punctuation}', "");
    Expect(0, 69294, '\P{^		is_Dash_punctuation}', "");
    Error('\p{/a/-PD}');
    Error('\P{/a/-PD}');
    Expect(1, 69293, '\p{pd}', "");
    Expect(0, 69293, '\p{^pd}', "");
    Expect(0, 69293, '\P{pd}', "");
    Expect(1, 69293, '\P{^pd}', "");
    Expect(0, 69294, '\p{pd}', "");
    Expect(1, 69294, '\p{^pd}', "");
    Expect(1, 69294, '\P{pd}', "");
    Expect(0, 69294, '\P{^pd}', "");
    Expect(1, 69293, '\p{_ PD}', "");
    Expect(0, 69293, '\p{^_ PD}', "");
    Expect(0, 69293, '\P{_ PD}', "");
    Expect(1, 69293, '\P{^_ PD}', "");
    Expect(0, 69294, '\p{_ PD}', "");
    Expect(1, 69294, '\p{^_ PD}', "");
    Expect(1, 69294, '\P{_ PD}', "");
    Expect(0, 69294, '\P{^_ PD}', "");
    Error('\p{:=_is_Pd}');
    Error('\P{:=_is_Pd}');
    Expect(1, 69293, '\p{ispd}', "");
    Expect(0, 69293, '\p{^ispd}', "");
    Expect(0, 69293, '\P{ispd}', "");
    Expect(1, 69293, '\P{^ispd}', "");
    Expect(0, 69294, '\p{ispd}', "");
    Expect(1, 69294, '\p{^ispd}', "");
    Expect(1, 69294, '\P{ispd}', "");
    Expect(0, 69294, '\P{^ispd}', "");
    Expect(1, 69293, '\p{-	Is_pd}', "");
    Expect(0, 69293, '\p{^-	Is_pd}', "");
    Expect(0, 69293, '\P{-	Is_pd}', "");
    Expect(1, 69293, '\P{^-	Is_pd}', "");
    Expect(0, 69294, '\p{-	Is_pd}', "");
    Expect(1, 69294, '\p{^-	Is_pd}', "");
    Expect(1, 69294, '\P{-	Is_pd}', "");
    Expect(0, 69294, '\P{^-	Is_pd}', "");
    Error('\p{:=-DEFAULT_IGNORABLE_Code_Point}');
    Error('\P{:=-DEFAULT_IGNORABLE_Code_Point}');
    Expect(1, 921599, '\p{defaultignorablecodepoint}', "");
    Expect(0, 921599, '\p{^defaultignorablecodepoint}', "");
    Expect(0, 921599, '\P{defaultignorablecodepoint}', "");
    Expect(1, 921599, '\P{^defaultignorablecodepoint}', "");
    Expect(0, 921600, '\p{defaultignorablecodepoint}', "");
    Expect(1, 921600, '\p{^defaultignorablecodepoint}', "");
    Expect(1, 921600, '\P{defaultignorablecodepoint}', "");
    Expect(0, 921600, '\P{^defaultignorablecodepoint}', "");
    Expect(1, 921599, '\p{  Default_Ignorable_Code_POINT}', "");
    Expect(0, 921599, '\p{^  Default_Ignorable_Code_POINT}', "");
    Expect(0, 921599, '\P{  Default_Ignorable_Code_POINT}', "");
    Expect(1, 921599, '\P{^  Default_Ignorable_Code_POINT}', "");
    Expect(0, 921600, '\p{  Default_Ignorable_Code_POINT}', "");
    Expect(1, 921600, '\p{^  Default_Ignorable_Code_POINT}', "");
    Expect(1, 921600, '\P{  Default_Ignorable_Code_POINT}', "");
    Expect(0, 921600, '\P{^  Default_Ignorable_Code_POINT}', "");
    Error('\p{ Is_Default_Ignorable_code_point:=}');
    Error('\P{ Is_Default_Ignorable_code_point:=}');
    Expect(1, 921599, '\p{isdefaultignorablecodepoint}', "");
    Expect(0, 921599, '\p{^isdefaultignorablecodepoint}', "");
    Expect(0, 921599, '\P{isdefaultignorablecodepoint}', "");
    Expect(1, 921599, '\P{^isdefaultignorablecodepoint}', "");
    Expect(0, 921600, '\p{isdefaultignorablecodepoint}', "");
    Expect(1, 921600, '\p{^isdefaultignorablecodepoint}', "");
    Expect(1, 921600, '\P{isdefaultignorablecodepoint}', "");
    Expect(0, 921600, '\P{^isdefaultignorablecodepoint}', "");
    Expect(1, 921599, '\p{		Is_DEFAULT_Ignorable_CODE_Point}', "");
    Expect(0, 921599, '\p{^		Is_DEFAULT_Ignorable_CODE_Point}', "");
    Expect(0, 921599, '\P{		Is_DEFAULT_Ignorable_CODE_Point}', "");
    Expect(1, 921599, '\P{^		Is_DEFAULT_Ignorable_CODE_Point}', "");
    Expect(0, 921600, '\p{		Is_DEFAULT_Ignorable_CODE_Point}', "");
    Expect(1, 921600, '\p{^		Is_DEFAULT_Ignorable_CODE_Point}', "");
    Expect(1, 921600, '\P{		Is_DEFAULT_Ignorable_CODE_Point}', "");
    Expect(0, 921600, '\P{^		Is_DEFAULT_Ignorable_CODE_Point}', "");
    Error('\p{:= -DI}');
    Error('\P{:= -DI}');
    Expect(1, 921599, '\p{di}', "");
    Expect(0, 921599, '\p{^di}', "");
    Expect(0, 921599, '\P{di}', "");
    Expect(1, 921599, '\P{^di}', "");
    Expect(0, 921600, '\p{di}', "");
    Expect(1, 921600, '\p{^di}', "");
    Expect(1, 921600, '\P{di}', "");
    Expect(0, 921600, '\P{^di}', "");
    Expect(1, 921599, '\p{-	DI}', "");
    Expect(0, 921599, '\p{^-	DI}', "");
    Expect(0, 921599, '\P{-	DI}', "");
    Expect(1, 921599, '\P{^-	DI}', "");
    Expect(0, 921600, '\p{-	DI}', "");
    Expect(1, 921600, '\p{^-	DI}', "");
    Expect(1, 921600, '\P{-	DI}', "");
    Expect(0, 921600, '\P{^-	DI}', "");
    Error('\p{ :=IS_DI}');
    Error('\P{ :=IS_DI}');
    Expect(1, 921599, '\p{isdi}', "");
    Expect(0, 921599, '\p{^isdi}', "");
    Expect(0, 921599, '\P{isdi}', "");
    Expect(1, 921599, '\P{^isdi}', "");
    Expect(0, 921600, '\p{isdi}', "");
    Expect(1, 921600, '\p{^isdi}', "");
    Expect(1, 921600, '\P{isdi}', "");
    Expect(0, 921600, '\P{^isdi}', "");
    Expect(1, 921599, '\p{  IS_di}', "");
    Expect(0, 921599, '\p{^  IS_di}', "");
    Expect(0, 921599, '\P{  IS_di}', "");
    Expect(1, 921599, '\P{^  IS_di}', "");
    Expect(0, 921600, '\p{  IS_di}', "");
    Expect(1, 921600, '\p{^  IS_di}', "");
    Expect(1, 921600, '\P{  IS_di}', "");
    Expect(0, 921600, '\P{^  IS_di}', "");
    Error('\p{_/a/Deprecated}');
    Error('\P{_/a/Deprecated}');
    Expect(1, 917505, '\p{deprecated}', "");
    Expect(0, 917505, '\p{^deprecated}', "");
    Expect(0, 917505, '\P{deprecated}', "");
    Expect(1, 917505, '\P{^deprecated}', "");
    Expect(0, 917506, '\p{deprecated}', "");
    Expect(1, 917506, '\p{^deprecated}', "");
    Expect(1, 917506, '\P{deprecated}', "");
    Expect(0, 917506, '\P{^deprecated}', "");
    Expect(1, 917505, '\p{ DEPRECATED}', "");
    Expect(0, 917505, '\p{^ DEPRECATED}', "");
    Expect(0, 917505, '\P{ DEPRECATED}', "");
    Expect(1, 917505, '\P{^ DEPRECATED}', "");
    Expect(0, 917506, '\p{ DEPRECATED}', "");
    Expect(1, 917506, '\p{^ DEPRECATED}', "");
    Expect(1, 917506, '\P{ DEPRECATED}', "");
    Expect(0, 917506, '\P{^ DEPRECATED}', "");
    Error('\p{:=_-Is_deprecated}');
    Error('\P{:=_-Is_deprecated}');
    Expect(1, 917505, '\p{isdeprecated}', "");
    Expect(0, 917505, '\p{^isdeprecated}', "");
    Expect(0, 917505, '\P{isdeprecated}', "");
    Expect(1, 917505, '\P{^isdeprecated}', "");
    Expect(0, 917506, '\p{isdeprecated}', "");
    Expect(1, 917506, '\p{^isdeprecated}', "");
    Expect(1, 917506, '\P{isdeprecated}', "");
    Expect(0, 917506, '\P{^isdeprecated}', "");
    Expect(1, 917505, '\p{-	is_deprecated}', "");
    Expect(0, 917505, '\p{^-	is_deprecated}', "");
    Expect(0, 917505, '\P{-	is_deprecated}', "");
    Expect(1, 917505, '\P{^-	is_deprecated}', "");
    Expect(0, 917506, '\p{-	is_deprecated}', "");
    Expect(1, 917506, '\p{^-	is_deprecated}', "");
    Expect(1, 917506, '\P{-	is_deprecated}', "");
    Expect(0, 917506, '\P{^-	is_deprecated}', "");
    Error('\p{/a/ Dep}');
    Error('\P{/a/ Dep}');
    Expect(1, 917505, '\p{dep}', "");
    Expect(0, 917505, '\p{^dep}', "");
    Expect(0, 917505, '\P{dep}', "");
    Expect(1, 917505, '\P{^dep}', "");
    Expect(0, 917506, '\p{dep}', "");
    Expect(1, 917506, '\p{^dep}', "");
    Expect(1, 917506, '\P{dep}', "");
    Expect(0, 917506, '\P{^dep}', "");
    Expect(1, 917505, '\p{	_DEP}', "");
    Expect(0, 917505, '\p{^	_DEP}', "");
    Expect(0, 917505, '\P{	_DEP}', "");
    Expect(1, 917505, '\P{^	_DEP}', "");
    Expect(0, 917506, '\p{	_DEP}', "");
    Expect(1, 917506, '\p{^	_DEP}', "");
    Expect(1, 917506, '\P{	_DEP}', "");
    Expect(0, 917506, '\P{^	_DEP}', "");
    Error('\p{_is_Dep/a/}');
    Error('\P{_is_Dep/a/}');
    Expect(1, 917505, '\p{isdep}', "");
    Expect(0, 917505, '\p{^isdep}', "");
    Expect(0, 917505, '\P{isdep}', "");
    Expect(1, 917505, '\P{^isdep}', "");
    Expect(0, 917506, '\p{isdep}', "");
    Expect(1, 917506, '\p{^isdep}', "");
    Expect(1, 917506, '\P{isdep}', "");
    Expect(0, 917506, '\P{^isdep}', "");
    Expect(1, 917505, '\p{		is_dep}', "");
    Expect(0, 917505, '\p{^		is_dep}', "");
    Expect(0, 917505, '\P{		is_dep}', "");
    Expect(1, 917505, '\P{^		is_dep}', "");
    Expect(0, 917506, '\p{		is_dep}', "");
    Expect(1, 917506, '\p{^		is_dep}', "");
    Expect(1, 917506, '\P{		is_dep}', "");
    Expect(0, 917506, '\P{^		is_dep}', "");
    Error('\p{	DESERET:=}');
    Error('\P{	DESERET:=}');
    Expect(1, 66639, '\p{deseret}', "");
    Expect(0, 66639, '\p{^deseret}', "");
    Expect(0, 66639, '\P{deseret}', "");
    Expect(1, 66639, '\P{^deseret}', "");
    Expect(0, 66640, '\p{deseret}', "");
    Expect(1, 66640, '\p{^deseret}', "");
    Expect(1, 66640, '\P{deseret}', "");
    Expect(0, 66640, '\P{^deseret}', "");
    Expect(1, 66639, '\p{_	deseret}', "");
    Expect(0, 66639, '\p{^_	deseret}', "");
    Expect(0, 66639, '\P{_	deseret}', "");
    Expect(1, 66639, '\P{^_	deseret}', "");
    Expect(0, 66640, '\p{_	deseret}', "");
    Expect(1, 66640, '\p{^_	deseret}', "");
    Expect(1, 66640, '\P{_	deseret}', "");
    Expect(0, 66640, '\P{^_	deseret}', "");
    Error('\p{-_Is_DESERET/a/}');
    Error('\P{-_Is_DESERET/a/}');
    Expect(1, 66639, '\p{isdeseret}', "");
    Expect(0, 66639, '\p{^isdeseret}', "");
    Expect(0, 66639, '\P{isdeseret}', "");
    Expect(1, 66639, '\P{^isdeseret}', "");
    Expect(0, 66640, '\p{isdeseret}', "");
    Expect(1, 66640, '\p{^isdeseret}', "");
    Expect(1, 66640, '\P{isdeseret}', "");
    Expect(0, 66640, '\P{^isdeseret}', "");
    Expect(1, 66639, '\p{ 	Is_Deseret}', "");
    Expect(0, 66639, '\p{^ 	Is_Deseret}', "");
    Expect(0, 66639, '\P{ 	Is_Deseret}', "");
    Expect(1, 66639, '\P{^ 	Is_Deseret}', "");
    Expect(0, 66640, '\p{ 	Is_Deseret}', "");
    Expect(1, 66640, '\p{^ 	Is_Deseret}', "");
    Expect(1, 66640, '\P{ 	Is_Deseret}', "");
    Expect(0, 66640, '\P{^ 	Is_Deseret}', "");
    Error('\p{:=_	DSRT}');
    Error('\P{:=_	DSRT}');
    Expect(1, 66639, '\p{dsrt}', "");
    Expect(0, 66639, '\p{^dsrt}', "");
    Expect(0, 66639, '\P{dsrt}', "");
    Expect(1, 66639, '\P{^dsrt}', "");
    Expect(0, 66640, '\p{dsrt}', "");
    Expect(1, 66640, '\p{^dsrt}', "");
    Expect(1, 66640, '\P{dsrt}', "");
    Expect(0, 66640, '\P{^dsrt}', "");
    Expect(1, 66639, '\p{	_Dsrt}', "");
    Expect(0, 66639, '\p{^	_Dsrt}', "");
    Expect(0, 66639, '\P{	_Dsrt}', "");
    Expect(1, 66639, '\P{^	_Dsrt}', "");
    Expect(0, 66640, '\p{	_Dsrt}', "");
    Expect(1, 66640, '\p{^	_Dsrt}', "");
    Expect(1, 66640, '\P{	_Dsrt}', "");
    Expect(0, 66640, '\P{^	_Dsrt}', "");
    Error('\p{:=is_DSRT}');
    Error('\P{:=is_DSRT}');
    Expect(1, 66639, '\p{isdsrt}', "");
    Expect(0, 66639, '\p{^isdsrt}', "");
    Expect(0, 66639, '\P{isdsrt}', "");
    Expect(1, 66639, '\P{^isdsrt}', "");
    Expect(0, 66640, '\p{isdsrt}', "");
    Expect(1, 66640, '\p{^isdsrt}', "");
    Expect(1, 66640, '\P{isdsrt}', "");
    Expect(0, 66640, '\P{^isdsrt}', "");
    Expect(1, 66639, '\p{	_Is_Dsrt}', "");
    Expect(0, 66639, '\p{^	_Is_Dsrt}', "");
    Expect(0, 66639, '\P{	_Is_Dsrt}', "");
    Expect(1, 66639, '\P{^	_Is_Dsrt}', "");
    Expect(0, 66640, '\p{	_Is_Dsrt}', "");
    Expect(1, 66640, '\p{^	_Is_Dsrt}', "");
    Expect(1, 66640, '\P{	_Is_Dsrt}', "");
    Expect(0, 66640, '\P{^	_Is_Dsrt}', "");
    Error('\p{:=_ devanagari}');
    Error('\P{:=_ devanagari}');
    Expect(1, 72457, '\p{devanagari}', "");
    Expect(0, 72457, '\p{^devanagari}', "");
    Expect(0, 72457, '\P{devanagari}', "");
    Expect(1, 72457, '\P{^devanagari}', "");
    Expect(0, 72458, '\p{devanagari}', "");
    Expect(1, 72458, '\p{^devanagari}', "");
    Expect(1, 72458, '\P{devanagari}', "");
    Expect(0, 72458, '\P{^devanagari}', "");
    Expect(1, 72457, '\p{_ Devanagari}', "");
    Expect(0, 72457, '\p{^_ Devanagari}', "");
    Expect(0, 72457, '\P{_ Devanagari}', "");
    Expect(1, 72457, '\P{^_ Devanagari}', "");
    Expect(0, 72458, '\p{_ Devanagari}', "");
    Expect(1, 72458, '\p{^_ Devanagari}', "");
    Expect(1, 72458, '\P{_ Devanagari}', "");
    Expect(0, 72458, '\P{^_ Devanagari}', "");
    Error('\p{:= Is_DEVANAGARI}');
    Error('\P{:= Is_DEVANAGARI}');
    Expect(1, 72457, '\p{isdevanagari}', "");
    Expect(0, 72457, '\p{^isdevanagari}', "");
    Expect(0, 72457, '\P{isdevanagari}', "");
    Expect(1, 72457, '\P{^isdevanagari}', "");
    Expect(0, 72458, '\p{isdevanagari}', "");
    Expect(1, 72458, '\p{^isdevanagari}', "");
    Expect(1, 72458, '\P{isdevanagari}', "");
    Expect(0, 72458, '\P{^isdevanagari}', "");
    Expect(1, 72457, '\p{	Is_Devanagari}', "");
    Expect(0, 72457, '\p{^	Is_Devanagari}', "");
    Expect(0, 72457, '\P{	Is_Devanagari}', "");
    Expect(1, 72457, '\P{^	Is_Devanagari}', "");
    Expect(0, 72458, '\p{	Is_Devanagari}', "");
    Expect(1, 72458, '\p{^	Is_Devanagari}', "");
    Expect(1, 72458, '\P{	Is_Devanagari}', "");
    Expect(0, 72458, '\P{^	Is_Devanagari}', "");
    Error('\p{:=-deva}');
    Error('\P{:=-deva}');
    Expect(1, 72457, '\p{deva}', "");
    Expect(0, 72457, '\p{^deva}', "");
    Expect(0, 72457, '\P{deva}', "");
    Expect(1, 72457, '\P{^deva}', "");
    Expect(0, 72458, '\p{deva}', "");
    Expect(1, 72458, '\p{^deva}', "");
    Expect(1, 72458, '\P{deva}', "");
    Expect(0, 72458, '\P{^deva}', "");
    Expect(1, 72457, '\p{__DEVA}', "");
    Expect(0, 72457, '\p{^__DEVA}', "");
    Expect(0, 72457, '\P{__DEVA}', "");
    Expect(1, 72457, '\P{^__DEVA}', "");
    Expect(0, 72458, '\p{__DEVA}', "");
    Expect(1, 72458, '\p{^__DEVA}', "");
    Expect(1, 72458, '\P{__DEVA}', "");
    Expect(0, 72458, '\P{^__DEVA}', "");
    Error('\p{_	Is_Deva:=}');
    Error('\P{_	Is_Deva:=}');
    Expect(1, 72457, '\p{isdeva}', "");
    Expect(0, 72457, '\p{^isdeva}', "");
    Expect(0, 72457, '\P{isdeva}', "");
    Expect(1, 72457, '\P{^isdeva}', "");
    Expect(0, 72458, '\p{isdeva}', "");
    Expect(1, 72458, '\p{^isdeva}', "");
    Expect(1, 72458, '\P{isdeva}', "");
    Expect(0, 72458, '\P{^isdeva}', "");
    Expect(1, 72457, '\p{	IS_deva}', "");
    Expect(0, 72457, '\p{^	IS_deva}', "");
    Expect(0, 72457, '\P{	IS_deva}', "");
    Expect(1, 72457, '\P{^	IS_deva}', "");
    Expect(0, 72458, '\p{	IS_deva}', "");
    Expect(1, 72458, '\p{^	IS_deva}', "");
    Expect(1, 72458, '\P{	IS_deva}', "");
    Expect(0, 72458, '\P{^	IS_deva}', "");
    Error('\p{:=Devanagari_extended}');
    Error('\P{:=Devanagari_extended}');
    Expect(1, 43263, '\p{devanagariextended}', "");
    Expect(0, 43263, '\p{^devanagariextended}', "");
    Expect(0, 43263, '\P{devanagariextended}', "");
    Expect(1, 43263, '\P{^devanagariextended}', "");
    Expect(0, 43264, '\p{devanagariextended}', "");
    Expect(1, 43264, '\p{^devanagariextended}', "");
    Expect(1, 43264, '\P{devanagariextended}', "");
    Expect(0, 43264, '\P{^devanagariextended}', "");
    Expect(1, 43263, '\p{_ Devanagari_extended}', "");
    Expect(0, 43263, '\p{^_ Devanagari_extended}', "");
    Expect(0, 43263, '\P{_ Devanagari_extended}', "");
    Expect(1, 43263, '\P{^_ Devanagari_extended}', "");
    Expect(0, 43264, '\p{_ Devanagari_extended}', "");
    Expect(1, 43264, '\p{^_ Devanagari_extended}', "");
    Expect(1, 43264, '\P{_ Devanagari_extended}', "");
    Expect(0, 43264, '\P{^_ Devanagari_extended}', "");
    Error('\p{/a/--Is_devanagari_EXTENDED}');
    Error('\P{/a/--Is_devanagari_EXTENDED}');
    Expect(1, 43263, '\p{isdevanagariextended}', "");
    Expect(0, 43263, '\p{^isdevanagariextended}', "");
    Expect(0, 43263, '\P{isdevanagariextended}', "");
    Expect(1, 43263, '\P{^isdevanagariextended}', "");
    Expect(0, 43264, '\p{isdevanagariextended}', "");
    Expect(1, 43264, '\p{^isdevanagariextended}', "");
    Expect(1, 43264, '\P{isdevanagariextended}', "");
    Expect(0, 43264, '\P{^isdevanagariextended}', "");
    Expect(1, 43263, '\p{-Is_DEVANAGARI_Extended}', "");
    Expect(0, 43263, '\p{^-Is_DEVANAGARI_Extended}', "");
    Expect(0, 43263, '\P{-Is_DEVANAGARI_Extended}', "");
    Expect(1, 43263, '\P{^-Is_DEVANAGARI_Extended}', "");
    Expect(0, 43264, '\p{-Is_DEVANAGARI_Extended}', "");
    Expect(1, 43264, '\p{^-Is_DEVANAGARI_Extended}', "");
    Expect(1, 43264, '\P{-Is_DEVANAGARI_Extended}', "");
    Expect(0, 43264, '\P{^-Is_DEVANAGARI_Extended}', "");
    Error('\p{/a/-in_Devanagari_extended}');
    Error('\P{/a/-in_Devanagari_extended}');
    Expect(1, 43263, '\p{indevanagariextended}', "");
    Expect(0, 43263, '\p{^indevanagariextended}', "");
    Expect(0, 43263, '\P{indevanagariextended}', "");
    Expect(1, 43263, '\P{^indevanagariextended}', "");
    Expect(0, 43264, '\p{indevanagariextended}', "");
    Expect(1, 43264, '\p{^indevanagariextended}', "");
    Expect(1, 43264, '\P{indevanagariextended}', "");
    Expect(0, 43264, '\P{^indevanagariextended}', "");
    Expect(1, 43263, '\p{ -IN_DEVANAGARI_extended}', "");
    Expect(0, 43263, '\p{^ -IN_DEVANAGARI_extended}', "");
    Expect(0, 43263, '\P{ -IN_DEVANAGARI_extended}', "");
    Expect(1, 43263, '\P{^ -IN_DEVANAGARI_extended}', "");
    Expect(0, 43264, '\p{ -IN_DEVANAGARI_extended}', "");
    Expect(1, 43264, '\p{^ -IN_DEVANAGARI_extended}', "");
    Expect(1, 43264, '\P{ -IN_DEVANAGARI_extended}', "");
    Expect(0, 43264, '\P{^ -IN_DEVANAGARI_extended}', "");
    Error('\p{_:=Devanagari_Ext}');
    Error('\P{_:=Devanagari_Ext}');
    Expect(1, 43263, '\p{devanagariext}', "");
    Expect(0, 43263, '\p{^devanagariext}', "");
    Expect(0, 43263, '\P{devanagariext}', "");
    Expect(1, 43263, '\P{^devanagariext}', "");
    Expect(0, 43264, '\p{devanagariext}', "");
    Expect(1, 43264, '\p{^devanagariext}', "");
    Expect(1, 43264, '\P{devanagariext}', "");
    Expect(0, 43264, '\P{^devanagariext}', "");
    Expect(1, 43263, '\p{-DEVANAGARI_Ext}', "");
    Expect(0, 43263, '\p{^-DEVANAGARI_Ext}', "");
    Expect(0, 43263, '\P{-DEVANAGARI_Ext}', "");
    Expect(1, 43263, '\P{^-DEVANAGARI_Ext}', "");
    Expect(0, 43264, '\p{-DEVANAGARI_Ext}', "");
    Expect(1, 43264, '\p{^-DEVANAGARI_Ext}', "");
    Expect(1, 43264, '\P{-DEVANAGARI_Ext}', "");
    Expect(0, 43264, '\P{^-DEVANAGARI_Ext}', "");
    Error('\p{/a/ 	Is_Devanagari_ext}');
    Error('\P{/a/ 	Is_Devanagari_ext}');
    Expect(1, 43263, '\p{isdevanagariext}', "");
    Expect(0, 43263, '\p{^isdevanagariext}', "");
    Expect(0, 43263, '\P{isdevanagariext}', "");
    Expect(1, 43263, '\P{^isdevanagariext}', "");
    Expect(0, 43264, '\p{isdevanagariext}', "");
    Expect(1, 43264, '\p{^isdevanagariext}', "");
    Expect(1, 43264, '\P{isdevanagariext}', "");
    Expect(0, 43264, '\P{^isdevanagariext}', "");
    Expect(1, 43263, '\p{- Is_Devanagari_Ext}', "");
    Expect(0, 43263, '\p{^- Is_Devanagari_Ext}', "");
    Expect(0, 43263, '\P{- Is_Devanagari_Ext}', "");
    Expect(1, 43263, '\P{^- Is_Devanagari_Ext}', "");
    Expect(0, 43264, '\p{- Is_Devanagari_Ext}', "");
    Expect(1, 43264, '\p{^- Is_Devanagari_Ext}', "");
    Expect(1, 43264, '\P{- Is_Devanagari_Ext}', "");
    Expect(0, 43264, '\P{^- Is_Devanagari_Ext}', "");
    Error('\p{	/a/In_DEVANAGARI_EXT}');
    Error('\P{	/a/In_DEVANAGARI_EXT}');
    Expect(1, 43263, '\p{indevanagariext}', "");
    Expect(0, 43263, '\p{^indevanagariext}', "");
    Expect(0, 43263, '\P{indevanagariext}', "");
    Expect(1, 43263, '\P{^indevanagariext}', "");
    Expect(0, 43264, '\p{indevanagariext}', "");
    Expect(1, 43264, '\p{^indevanagariext}', "");
    Expect(1, 43264, '\P{indevanagariext}', "");
    Expect(0, 43264, '\P{^indevanagariext}', "");
    Expect(1, 43263, '\p{		in_Devanagari_EXT}', "");
    Expect(0, 43263, '\p{^		in_Devanagari_EXT}', "");
    Expect(0, 43263, '\P{		in_Devanagari_EXT}', "");
    Expect(1, 43263, '\P{^		in_Devanagari_EXT}', "");
    Expect(0, 43264, '\p{		in_Devanagari_EXT}', "");
    Expect(1, 43264, '\p{^		in_Devanagari_EXT}', "");
    Expect(1, 43264, '\P{		in_Devanagari_EXT}', "");
    Expect(0, 43264, '\P{^		in_Devanagari_EXT}', "");
    Error('\p{		DEVANAGARI_EXTENDED_A:=}');
    Error('\P{		DEVANAGARI_EXTENDED_A:=}');
    Expect(1, 72543, '\p{devanagariextendeda}', "");
    Expect(0, 72543, '\p{^devanagariextendeda}', "");
    Expect(0, 72543, '\P{devanagariextendeda}', "");
    Expect(1, 72543, '\P{^devanagariextendeda}', "");
    Expect(0, 72544, '\p{devanagariextendeda}', "");
    Expect(1, 72544, '\p{^devanagariextendeda}', "");
    Expect(1, 72544, '\P{devanagariextendeda}', "");
    Expect(0, 72544, '\P{^devanagariextendeda}', "");
    Expect(1, 72543, '\p{ 	Devanagari_Extended_A}', "");
    Expect(0, 72543, '\p{^ 	Devanagari_Extended_A}', "");
    Expect(0, 72543, '\P{ 	Devanagari_Extended_A}', "");
    Expect(1, 72543, '\P{^ 	Devanagari_Extended_A}', "");
    Expect(0, 72544, '\p{ 	Devanagari_Extended_A}', "");
    Expect(1, 72544, '\p{^ 	Devanagari_Extended_A}', "");
    Expect(1, 72544, '\P{ 	Devanagari_Extended_A}', "");
    Expect(0, 72544, '\P{^ 	Devanagari_Extended_A}', "");
    Error('\p{:=is_devanagari_Extended_A}');
    Error('\P{:=is_devanagari_Extended_A}');
    Expect(1, 72543, '\p{isdevanagariextendeda}', "");
    Expect(0, 72543, '\p{^isdevanagariextendeda}', "");
    Expect(0, 72543, '\P{isdevanagariextendeda}', "");
    Expect(1, 72543, '\P{^isdevanagariextendeda}', "");
    Expect(0, 72544, '\p{isdevanagariextendeda}', "");
    Expect(1, 72544, '\p{^isdevanagariextendeda}', "");
    Expect(1, 72544, '\P{isdevanagariextendeda}', "");
    Expect(0, 72544, '\P{^isdevanagariextendeda}', "");
    Expect(1, 72543, '\p{	_IS_Devanagari_Extended_A}', "");
    Expect(0, 72543, '\p{^	_IS_Devanagari_Extended_A}', "");
    Expect(0, 72543, '\P{	_IS_Devanagari_Extended_A}', "");
    Expect(1, 72543, '\P{^	_IS_Devanagari_Extended_A}', "");
    Expect(0, 72544, '\p{	_IS_Devanagari_Extended_A}', "");
    Expect(1, 72544, '\p{^	_IS_Devanagari_Extended_A}', "");
    Expect(1, 72544, '\P{	_IS_Devanagari_Extended_A}', "");
    Expect(0, 72544, '\P{^	_IS_Devanagari_Extended_A}', "");
    Error('\p{/a/  In_Devanagari_extended_A}');
    Error('\P{/a/  In_Devanagari_extended_A}');
    Expect(1, 72543, '\p{indevanagariextendeda}', "");
    Expect(0, 72543, '\p{^indevanagariextendeda}', "");
    Expect(0, 72543, '\P{indevanagariextendeda}', "");
    Expect(1, 72543, '\P{^indevanagariextendeda}', "");
    Expect(0, 72544, '\p{indevanagariextendeda}', "");
    Expect(1, 72544, '\p{^indevanagariextendeda}', "");
    Expect(1, 72544, '\P{indevanagariextendeda}', "");
    Expect(0, 72544, '\P{^indevanagariextendeda}', "");
    Expect(1, 72543, '\p{in_devanagari_extended_A}', "");
    Expect(0, 72543, '\p{^in_devanagari_extended_A}', "");
    Expect(0, 72543, '\P{in_devanagari_extended_A}', "");
    Expect(1, 72543, '\P{^in_devanagari_extended_A}', "");
    Expect(0, 72544, '\p{in_devanagari_extended_A}', "");
    Expect(1, 72544, '\p{^in_devanagari_extended_A}', "");
    Expect(1, 72544, '\P{in_devanagari_extended_A}', "");
    Expect(0, 72544, '\P{^in_devanagari_extended_A}', "");
    Error('\p{/a/		devanagari_Ext_A}');
    Error('\P{/a/		devanagari_Ext_A}');
    Expect(1, 72543, '\p{devanagariexta}', "");
    Expect(0, 72543, '\p{^devanagariexta}', "");
    Expect(0, 72543, '\P{devanagariexta}', "");
    Expect(1, 72543, '\P{^devanagariexta}', "");
    Expect(0, 72544, '\p{devanagariexta}', "");
    Expect(1, 72544, '\p{^devanagariexta}', "");
    Expect(1, 72544, '\P{devanagariexta}', "");
    Expect(0, 72544, '\P{^devanagariexta}', "");
    Expect(1, 72543, '\p{_devanagari_ext_A}', "");
    Expect(0, 72543, '\p{^_devanagari_ext_A}', "");
    Expect(0, 72543, '\P{_devanagari_ext_A}', "");
    Expect(1, 72543, '\P{^_devanagari_ext_A}', "");
    Expect(0, 72544, '\p{_devanagari_ext_A}', "");
    Expect(1, 72544, '\p{^_devanagari_ext_A}', "");
    Expect(1, 72544, '\P{_devanagari_ext_A}', "");
    Expect(0, 72544, '\P{^_devanagari_ext_A}', "");
    Error('\p{/a/	is_DEVANAGARI_Ext_A}');
    Error('\P{/a/	is_DEVANAGARI_Ext_A}');
    Expect(1, 72543, '\p{isdevanagariexta}', "");
    Expect(0, 72543, '\p{^isdevanagariexta}', "");
    Expect(0, 72543, '\P{isdevanagariexta}', "");
    Expect(1, 72543, '\P{^isdevanagariexta}', "");
    Expect(0, 72544, '\p{isdevanagariexta}', "");
    Expect(1, 72544, '\p{^isdevanagariexta}', "");
    Expect(1, 72544, '\P{isdevanagariexta}', "");
    Expect(0, 72544, '\P{^isdevanagariexta}', "");
    Expect(1, 72543, '\p{	is_Devanagari_EXT_A}', "");
    Expect(0, 72543, '\p{^	is_Devanagari_EXT_A}', "");
    Expect(0, 72543, '\P{	is_Devanagari_EXT_A}', "");
    Expect(1, 72543, '\P{^	is_Devanagari_EXT_A}', "");
    Expect(0, 72544, '\p{	is_Devanagari_EXT_A}', "");
    Expect(1, 72544, '\p{^	is_Devanagari_EXT_A}', "");
    Expect(1, 72544, '\P{	is_Devanagari_EXT_A}', "");
    Expect(0, 72544, '\P{^	is_Devanagari_EXT_A}', "");
    Error('\p{	-in_Devanagari_Ext_A/a/}');
    Error('\P{	-in_Devanagari_Ext_A/a/}');
    Expect(1, 72543, '\p{indevanagariexta}', "");
    Expect(0, 72543, '\p{^indevanagariexta}', "");
    Expect(0, 72543, '\P{indevanagariexta}', "");
    Expect(1, 72543, '\P{^indevanagariexta}', "");
    Expect(0, 72544, '\p{indevanagariexta}', "");
    Expect(1, 72544, '\p{^indevanagariexta}', "");
    Expect(1, 72544, '\P{indevanagariexta}', "");
    Expect(0, 72544, '\P{^indevanagariexta}', "");
    Expect(1, 72543, '\p{in_DEVANAGARI_Ext_a}', "");
    Expect(0, 72543, '\p{^in_DEVANAGARI_Ext_a}', "");
    Expect(0, 72543, '\P{in_DEVANAGARI_Ext_a}', "");
    Expect(1, 72543, '\P{^in_DEVANAGARI_Ext_a}', "");
    Expect(0, 72544, '\p{in_DEVANAGARI_Ext_a}', "");
    Expect(1, 72544, '\p{^in_DEVANAGARI_Ext_a}', "");
    Expect(1, 72544, '\P{in_DEVANAGARI_Ext_a}', "");
    Expect(0, 72544, '\P{^in_DEVANAGARI_Ext_a}', "");
    Error('\p{:=_	diacritic}');
    Error('\P{:=_	diacritic}');
    Expect(1, 125258, '\p{diacritic}', "");
    Expect(0, 125258, '\p{^diacritic}', "");
    Expect(0, 125258, '\P{diacritic}', "");
    Expect(1, 125258, '\P{^diacritic}', "");
    Expect(0, 125259, '\p{diacritic}', "");
    Expect(1, 125259, '\p{^diacritic}', "");
    Expect(1, 125259, '\P{diacritic}', "");
    Expect(0, 125259, '\P{^diacritic}', "");
    Expect(1, 125258, '\p{- DIACRITIC}', "");
    Expect(0, 125258, '\p{^- DIACRITIC}', "");
    Expect(0, 125258, '\P{- DIACRITIC}', "");
    Expect(1, 125258, '\P{^- DIACRITIC}', "");
    Expect(0, 125259, '\p{- DIACRITIC}', "");
    Expect(1, 125259, '\p{^- DIACRITIC}', "");
    Expect(1, 125259, '\P{- DIACRITIC}', "");
    Expect(0, 125259, '\P{^- DIACRITIC}', "");
    Error('\p{ /a/Is_diacritic}');
    Error('\P{ /a/Is_diacritic}');
    Expect(1, 125258, '\p{isdiacritic}', "");
    Expect(0, 125258, '\p{^isdiacritic}', "");
    Expect(0, 125258, '\P{isdiacritic}', "");
    Expect(1, 125258, '\P{^isdiacritic}', "");
    Expect(0, 125259, '\p{isdiacritic}', "");
    Expect(1, 125259, '\p{^isdiacritic}', "");
    Expect(1, 125259, '\P{isdiacritic}', "");
    Expect(0, 125259, '\P{^isdiacritic}', "");
    Expect(1, 125258, '\p{IS_DIACRITIC}', "");
    Expect(0, 125258, '\p{^IS_DIACRITIC}', "");
    Expect(0, 125258, '\P{IS_DIACRITIC}', "");
    Expect(1, 125258, '\P{^IS_DIACRITIC}', "");
    Expect(0, 125259, '\p{IS_DIACRITIC}', "");
    Expect(1, 125259, '\p{^IS_DIACRITIC}', "");
    Expect(1, 125259, '\P{IS_DIACRITIC}', "");
    Expect(0, 125259, '\P{^IS_DIACRITIC}', "");
    Error('\p{ -DIA:=}');
    Error('\P{ -DIA:=}');
    Expect(1, 125258, '\p{dia}', "");
    Expect(0, 125258, '\p{^dia}', "");
    Expect(0, 125258, '\P{dia}', "");
    Expect(1, 125258, '\P{^dia}', "");
    Expect(0, 125259, '\p{dia}', "");
    Expect(1, 125259, '\p{^dia}', "");
    Expect(1, 125259, '\P{dia}', "");
    Expect(0, 125259, '\P{^dia}', "");
    Expect(1, 125258, '\p{- dia}', "");
    Expect(0, 125258, '\p{^- dia}', "");
    Expect(0, 125258, '\P{- dia}', "");
    Expect(1, 125258, '\P{^- dia}', "");
    Expect(0, 125259, '\p{- dia}', "");
    Expect(1, 125259, '\p{^- dia}', "");
    Expect(1, 125259, '\P{- dia}', "");
    Expect(0, 125259, '\P{^- dia}', "");
    Error('\p{_/a/Is_dia}');
    Error('\P{_/a/Is_dia}');
    Expect(1, 125258, '\p{isdia}', "");
    Expect(0, 125258, '\p{^isdia}', "");
    Expect(0, 125258, '\P{isdia}', "");
    Expect(1, 125258, '\P{^isdia}', "");
    Expect(0, 125259, '\p{isdia}', "");
    Expect(1, 125259, '\p{^isdia}', "");
    Expect(1, 125259, '\P{isdia}', "");
    Expect(0, 125259, '\P{^isdia}', "");
    Expect(1, 125258, '\p{  Is_DIA}', "");
    Expect(0, 125258, '\p{^  Is_DIA}', "");
    Expect(0, 125258, '\P{  Is_DIA}', "");
    Expect(1, 125258, '\P{^  Is_DIA}', "");
    Expect(0, 125259, '\p{  Is_DIA}', "");
    Expect(1, 125259, '\p{^  Is_DIA}', "");
    Expect(1, 125259, '\P{  Is_DIA}', "");
    Expect(0, 125259, '\P{^  Is_DIA}', "");
    Error('\p{-/a/XPosixDigit}');
    Error('\P{-/a/XPosixDigit}');
    Expect(1, 130041, '\p{xposixdigit}', "");
    Expect(0, 130041, '\p{^xposixdigit}', "");
    Expect(0, 130041, '\P{xposixdigit}', "");
    Expect(1, 130041, '\P{^xposixdigit}', "");
    Expect(0, 130042, '\p{xposixdigit}', "");
    Expect(1, 130042, '\p{^xposixdigit}', "");
    Expect(1, 130042, '\P{xposixdigit}', "");
    Expect(0, 130042, '\P{^xposixdigit}', "");
    Expect(1, 130041, '\p{__XPosixDigit}', "");
    Expect(0, 130041, '\p{^__XPosixDigit}', "");
    Expect(0, 130041, '\P{__XPosixDigit}', "");
    Expect(1, 130041, '\P{^__XPosixDigit}', "");
    Expect(0, 130042, '\p{__XPosixDigit}', "");
    Expect(1, 130042, '\p{^__XPosixDigit}', "");
    Expect(1, 130042, '\P{__XPosixDigit}', "");
    Expect(0, 130042, '\P{^__XPosixDigit}', "");
    Error('\p{  digit:=}');
    Error('\P{  digit:=}');
    Expect(1, 130041, '\p{digit}', "");
    Expect(0, 130041, '\p{^digit}', "");
    Expect(0, 130041, '\P{digit}', "");
    Expect(1, 130041, '\P{^digit}', "");
    Expect(0, 130042, '\p{digit}', "");
    Expect(1, 130042, '\p{^digit}', "");
    Expect(1, 130042, '\P{digit}', "");
    Expect(0, 130042, '\P{^digit}', "");
    Expect(1, 130041, '\p{--Digit}', "");
    Expect(0, 130041, '\p{^--Digit}', "");
    Expect(0, 130041, '\P{--Digit}', "");
    Expect(1, 130041, '\P{^--Digit}', "");
    Expect(0, 130042, '\p{--Digit}', "");
    Expect(1, 130042, '\p{^--Digit}', "");
    Expect(1, 130042, '\P{--Digit}', "");
    Expect(0, 130042, '\P{^--Digit}', "");
    Error('\p{ Is_XPosixDigit/a/}');
    Error('\P{ Is_XPosixDigit/a/}');
    Expect(1, 130041, '\p{isxposixdigit}', "");
    Expect(0, 130041, '\p{^isxposixdigit}', "");
    Expect(0, 130041, '\P{isxposixdigit}', "");
    Expect(1, 130041, '\P{^isxposixdigit}', "");
    Expect(0, 130042, '\p{isxposixdigit}', "");
    Expect(1, 130042, '\p{^isxposixdigit}', "");
    Expect(1, 130042, '\P{isxposixdigit}', "");
    Expect(0, 130042, '\P{^isxposixdigit}', "");
    Expect(1, 130041, '\p{__is_XPOSIXDIGIT}', "");
    Expect(0, 130041, '\p{^__is_XPOSIXDIGIT}', "");
    Expect(0, 130041, '\P{__is_XPOSIXDIGIT}', "");
    Expect(1, 130041, '\P{^__is_XPOSIXDIGIT}', "");
    Expect(0, 130042, '\p{__is_XPOSIXDIGIT}', "");
    Expect(1, 130042, '\p{^__is_XPOSIXDIGIT}', "");
    Expect(1, 130042, '\P{__is_XPOSIXDIGIT}', "");
    Expect(0, 130042, '\P{^__is_XPOSIXDIGIT}', "");
    Error('\p{/a/IS_DIGIT}');
    Error('\P{/a/IS_DIGIT}');
    Expect(1, 130041, '\p{isdigit}', "");
    Expect(0, 130041, '\p{^isdigit}', "");
    Expect(0, 130041, '\P{isdigit}', "");
    Expect(1, 130041, '\P{^isdigit}', "");
    Expect(0, 130042, '\p{isdigit}', "");
    Expect(1, 130042, '\p{^isdigit}', "");
    Expect(1, 130042, '\P{isdigit}', "");
    Expect(0, 130042, '\P{^isdigit}', "");
    Expect(1, 130041, '\p{_-is_Digit}', "");
    Expect(0, 130041, '\p{^_-is_Digit}', "");
    Expect(0, 130041, '\P{_-is_Digit}', "");
    Expect(1, 130041, '\P{^_-is_Digit}', "");
    Expect(0, 130042, '\p{_-is_Digit}', "");
    Expect(1, 130042, '\p{^_-is_Digit}', "");
    Expect(1, 130042, '\P{_-is_Digit}', "");
    Expect(0, 130042, '\P{^_-is_Digit}', "");
    Error('\p{ -decimal_NUMBER:=}');
    Error('\P{ -decimal_NUMBER:=}');
    Expect(1, 130041, '\p{decimalnumber}', "");
    Expect(0, 130041, '\p{^decimalnumber}', "");
    Expect(0, 130041, '\P{decimalnumber}', "");
    Expect(1, 130041, '\P{^decimalnumber}', "");
    Expect(0, 130042, '\p{decimalnumber}', "");
    Expect(1, 130042, '\p{^decimalnumber}', "");
    Expect(1, 130042, '\P{decimalnumber}', "");
    Expect(0, 130042, '\P{^decimalnumber}', "");
    Expect(1, 130041, '\p{-	DECIMAL_Number}', "");
    Expect(0, 130041, '\p{^-	DECIMAL_Number}', "");
    Expect(0, 130041, '\P{-	DECIMAL_Number}', "");
    Expect(1, 130041, '\P{^-	DECIMAL_Number}', "");
    Expect(0, 130042, '\p{-	DECIMAL_Number}', "");
    Expect(1, 130042, '\p{^-	DECIMAL_Number}', "");
    Expect(1, 130042, '\P{-	DECIMAL_Number}', "");
    Expect(0, 130042, '\P{^-	DECIMAL_Number}', "");
    Error('\p{--IS_decimal_NUMBER:=}');
    Error('\P{--IS_decimal_NUMBER:=}');
    Expect(1, 130041, '\p{isdecimalnumber}', "");
    Expect(0, 130041, '\p{^isdecimalnumber}', "");
    Expect(0, 130041, '\P{isdecimalnumber}', "");
    Expect(1, 130041, '\P{^isdecimalnumber}', "");
    Expect(0, 130042, '\p{isdecimalnumber}', "");
    Expect(1, 130042, '\p{^isdecimalnumber}', "");
    Expect(1, 130042, '\P{isdecimalnumber}', "");
    Expect(0, 130042, '\P{^isdecimalnumber}', "");
    Expect(1, 130041, '\p{_-Is_Decimal_NUMBER}', "");
    Expect(0, 130041, '\p{^_-Is_Decimal_NUMBER}', "");
    Expect(0, 130041, '\P{_-Is_Decimal_NUMBER}', "");
    Expect(1, 130041, '\P{^_-Is_Decimal_NUMBER}', "");
    Expect(0, 130042, '\p{_-Is_Decimal_NUMBER}', "");
    Expect(1, 130042, '\p{^_-Is_Decimal_NUMBER}', "");
    Expect(1, 130042, '\P{_-Is_Decimal_NUMBER}', "");
    Expect(0, 130042, '\P{^_-Is_Decimal_NUMBER}', "");
    Error('\p{ _Nd:=}');
    Error('\P{ _Nd:=}');
    Expect(1, 130041, '\p{nd}', "");
    Expect(0, 130041, '\p{^nd}', "");
    Expect(0, 130041, '\P{nd}', "");
    Expect(1, 130041, '\P{^nd}', "");
    Expect(0, 130042, '\p{nd}', "");
    Expect(1, 130042, '\p{^nd}', "");
    Expect(1, 130042, '\P{nd}', "");
    Expect(0, 130042, '\P{^nd}', "");
    Expect(1, 130041, '\p{	 ND}', "");
    Expect(0, 130041, '\p{^	 ND}', "");
    Expect(0, 130041, '\P{	 ND}', "");
    Expect(1, 130041, '\P{^	 ND}', "");
    Expect(0, 130042, '\p{	 ND}', "");
    Expect(1, 130042, '\p{^	 ND}', "");
    Expect(1, 130042, '\P{	 ND}', "");
    Expect(0, 130042, '\P{^	 ND}', "");
    Error('\p{__is_Nd:=}');
    Error('\P{__is_Nd:=}');
    Expect(1, 130041, '\p{isnd}', "");
    Expect(0, 130041, '\p{^isnd}', "");
    Expect(0, 130041, '\P{isnd}', "");
    Expect(1, 130041, '\P{^isnd}', "");
    Expect(0, 130042, '\p{isnd}', "");
    Expect(1, 130042, '\p{^isnd}', "");
    Expect(1, 130042, '\P{isnd}', "");
    Expect(0, 130042, '\P{^isnd}', "");
    Expect(1, 130041, '\p{--Is_Nd}', "");
    Expect(0, 130041, '\p{^--Is_Nd}', "");
    Expect(0, 130041, '\P{--Is_Nd}', "");
    Expect(1, 130041, '\P{^--Is_Nd}', "");
    Expect(0, 130042, '\p{--Is_Nd}', "");
    Expect(1, 130042, '\p{^--Is_Nd}', "");
    Expect(1, 130042, '\P{--Is_Nd}', "");
    Expect(0, 130042, '\P{^--Is_Nd}', "");
    Error('\p{-	dingbats/a/}');
    Error('\P{-	dingbats/a/}');
    Expect(1, 10175, '\p{dingbats}', "");
    Expect(0, 10175, '\p{^dingbats}', "");
    Expect(0, 10175, '\P{dingbats}', "");
    Expect(1, 10175, '\P{^dingbats}', "");
    Expect(0, 10176, '\p{dingbats}', "");
    Expect(1, 10176, '\p{^dingbats}', "");
    Expect(1, 10176, '\P{dingbats}', "");
    Expect(0, 10176, '\P{^dingbats}', "");
    Expect(1, 10175, '\p{ -Dingbats}', "");
    Expect(0, 10175, '\p{^ -Dingbats}', "");
    Expect(0, 10175, '\P{ -Dingbats}', "");
    Expect(1, 10175, '\P{^ -Dingbats}', "");
    Expect(0, 10176, '\p{ -Dingbats}', "");
    Expect(1, 10176, '\p{^ -Dingbats}', "");
    Expect(1, 10176, '\P{ -Dingbats}', "");
    Expect(0, 10176, '\P{^ -Dingbats}', "");
    Error('\p{:= Is_DINGBATS}');
    Error('\P{:= Is_DINGBATS}');
    Expect(1, 10175, '\p{isdingbats}', "");
    Expect(0, 10175, '\p{^isdingbats}', "");
    Expect(0, 10175, '\P{isdingbats}', "");
    Expect(1, 10175, '\P{^isdingbats}', "");
    Expect(0, 10176, '\p{isdingbats}', "");
    Expect(1, 10176, '\p{^isdingbats}', "");
    Expect(1, 10176, '\P{isdingbats}', "");
    Expect(0, 10176, '\P{^isdingbats}', "");
    Expect(1, 10175, '\p{-_Is_Dingbats}', "");
    Expect(0, 10175, '\p{^-_Is_Dingbats}', "");
    Expect(0, 10175, '\P{-_Is_Dingbats}', "");
    Expect(1, 10175, '\P{^-_Is_Dingbats}', "");
    Expect(0, 10176, '\p{-_Is_Dingbats}', "");
    Expect(1, 10176, '\p{^-_Is_Dingbats}', "");
    Expect(1, 10176, '\P{-_Is_Dingbats}', "");
    Expect(0, 10176, '\P{^-_Is_Dingbats}', "");
    Error('\p{		In_DINGBATS:=}');
    Error('\P{		In_DINGBATS:=}');
    Expect(1, 10175, '\p{indingbats}', "");
    Expect(0, 10175, '\p{^indingbats}', "");
    Expect(0, 10175, '\P{indingbats}', "");
    Expect(1, 10175, '\P{^indingbats}', "");
    Expect(0, 10176, '\p{indingbats}', "");
    Expect(1, 10176, '\p{^indingbats}', "");
    Expect(1, 10176, '\P{indingbats}', "");
    Expect(0, 10176, '\P{^indingbats}', "");
    Expect(1, 10175, '\p{ In_Dingbats}', "");
    Expect(0, 10175, '\p{^ In_Dingbats}', "");
    Expect(0, 10175, '\P{ In_Dingbats}', "");
    Expect(1, 10175, '\P{^ In_Dingbats}', "");
    Expect(0, 10176, '\p{ In_Dingbats}', "");
    Expect(1, 10176, '\p{^ In_Dingbats}', "");
    Expect(1, 10176, '\P{ In_Dingbats}', "");
    Expect(0, 10176, '\P{^ In_Dingbats}', "");
    Error('\p{-	dives_akuru/a/}');
    Error('\P{-	dives_akuru/a/}');
    Expect(1, 72025, '\p{divesakuru}', "");
    Expect(0, 72025, '\p{^divesakuru}', "");
    Expect(0, 72025, '\P{divesakuru}', "");
    Expect(1, 72025, '\P{^divesakuru}', "");
    Expect(0, 72026, '\p{divesakuru}', "");
    Expect(1, 72026, '\p{^divesakuru}', "");
    Expect(1, 72026, '\P{divesakuru}', "");
    Expect(0, 72026, '\P{^divesakuru}', "");
    Expect(1, 72025, '\p{	DIVES_Akuru}', "");
    Expect(0, 72025, '\p{^	DIVES_Akuru}', "");
    Expect(0, 72025, '\P{	DIVES_Akuru}', "");
    Expect(1, 72025, '\P{^	DIVES_Akuru}', "");
    Expect(0, 72026, '\p{	DIVES_Akuru}', "");
    Expect(1, 72026, '\p{^	DIVES_Akuru}', "");
    Expect(1, 72026, '\P{	DIVES_Akuru}', "");
    Expect(0, 72026, '\P{^	DIVES_Akuru}', "");
    Error('\p{-IS_dives_akuru/a/}');
    Error('\P{-IS_dives_akuru/a/}');
    Expect(1, 72025, '\p{isdivesakuru}', "");
    Expect(0, 72025, '\p{^isdivesakuru}', "");
    Expect(0, 72025, '\P{isdivesakuru}', "");
    Expect(1, 72025, '\P{^isdivesakuru}', "");
    Expect(0, 72026, '\p{isdivesakuru}', "");
    Expect(1, 72026, '\p{^isdivesakuru}', "");
    Expect(1, 72026, '\P{isdivesakuru}', "");
    Expect(0, 72026, '\P{^isdivesakuru}', "");
    Expect(1, 72025, '\p{__IS_Dives_Akuru}', "");
    Expect(0, 72025, '\p{^__IS_Dives_Akuru}', "");
    Expect(0, 72025, '\P{__IS_Dives_Akuru}', "");
    Expect(1, 72025, '\P{^__IS_Dives_Akuru}', "");
    Expect(0, 72026, '\p{__IS_Dives_Akuru}', "");
    Expect(1, 72026, '\p{^__IS_Dives_Akuru}', "");
    Expect(1, 72026, '\P{__IS_Dives_Akuru}', "");
    Expect(0, 72026, '\P{^__IS_Dives_Akuru}', "");
    Error('\p{:=DIAK}');
    Error('\P{:=DIAK}');
    Expect(1, 72025, '\p{diak}', "");
    Expect(0, 72025, '\p{^diak}', "");
    Expect(0, 72025, '\P{diak}', "");
    Expect(1, 72025, '\P{^diak}', "");
    Expect(0, 72026, '\p{diak}', "");
    Expect(1, 72026, '\p{^diak}', "");
    Expect(1, 72026, '\P{diak}', "");
    Expect(0, 72026, '\P{^diak}', "");
    Expect(1, 72025, '\p{-	Diak}', "");
    Expect(0, 72025, '\p{^-	Diak}', "");
    Expect(0, 72025, '\P{-	Diak}', "");
    Expect(1, 72025, '\P{^-	Diak}', "");
    Expect(0, 72026, '\p{-	Diak}', "");
    Expect(1, 72026, '\p{^-	Diak}', "");
    Expect(1, 72026, '\P{-	Diak}', "");
    Expect(0, 72026, '\P{^-	Diak}', "");
    Error('\p{	:=IS_Diak}');
    Error('\P{	:=IS_Diak}');
    Expect(1, 72025, '\p{isdiak}', "");
    Expect(0, 72025, '\p{^isdiak}', "");
    Expect(0, 72025, '\P{isdiak}', "");
    Expect(1, 72025, '\P{^isdiak}', "");
    Expect(0, 72026, '\p{isdiak}', "");
    Expect(1, 72026, '\p{^isdiak}', "");
    Expect(1, 72026, '\P{isdiak}', "");
    Expect(0, 72026, '\P{^isdiak}', "");
    Expect(1, 72025, '\p{_ Is_diak}', "");
    Expect(0, 72025, '\p{^_ Is_diak}', "");
    Expect(0, 72025, '\P{_ Is_diak}', "");
    Expect(1, 72025, '\P{^_ Is_diak}', "");
    Expect(0, 72026, '\p{_ Is_diak}', "");
    Expect(1, 72026, '\p{^_ Is_diak}', "");
    Expect(1, 72026, '\P{_ Is_diak}', "");
    Expect(0, 72026, '\P{^_ Is_diak}', "");
    Error('\p{/a/Dogra}');
    Error('\P{/a/Dogra}');
    Expect(1, 71739, '\p{dogra}', "");
    Expect(0, 71739, '\p{^dogra}', "");
    Expect(0, 71739, '\P{dogra}', "");
    Expect(1, 71739, '\P{^dogra}', "");
    Expect(0, 71740, '\p{dogra}', "");
    Expect(1, 71740, '\p{^dogra}', "");
    Expect(1, 71740, '\P{dogra}', "");
    Expect(0, 71740, '\P{^dogra}', "");
    Expect(1, 71739, '\p{	 Dogra}', "");
    Expect(0, 71739, '\p{^	 Dogra}', "");
    Expect(0, 71739, '\P{	 Dogra}', "");
    Expect(1, 71739, '\P{^	 Dogra}', "");
    Expect(0, 71740, '\p{	 Dogra}', "");
    Expect(1, 71740, '\p{^	 Dogra}', "");
    Expect(1, 71740, '\P{	 Dogra}', "");
    Expect(0, 71740, '\P{^	 Dogra}', "");
    Error('\p{:=		IS_Dogra}');
    Error('\P{:=		IS_Dogra}');
    Expect(1, 71739, '\p{isdogra}', "");
    Expect(0, 71739, '\p{^isdogra}', "");
    Expect(0, 71739, '\P{isdogra}', "");
    Expect(1, 71739, '\P{^isdogra}', "");
    Expect(0, 71740, '\p{isdogra}', "");
    Expect(1, 71740, '\p{^isdogra}', "");
    Expect(1, 71740, '\P{isdogra}', "");
    Expect(0, 71740, '\P{^isdogra}', "");
    Expect(1, 71739, '\p{ 	Is_DOGRA}', "");
    Expect(0, 71739, '\p{^ 	Is_DOGRA}', "");
    Expect(0, 71739, '\P{ 	Is_DOGRA}', "");
    Expect(1, 71739, '\P{^ 	Is_DOGRA}', "");
    Expect(0, 71740, '\p{ 	Is_DOGRA}', "");
    Expect(1, 71740, '\p{^ 	Is_DOGRA}', "");
    Expect(1, 71740, '\P{ 	Is_DOGRA}', "");
    Expect(0, 71740, '\P{^ 	Is_DOGRA}', "");
    Error('\p{-DOGR/a/}');
    Error('\P{-DOGR/a/}');
    Expect(1, 71739, '\p{dogr}', "");
    Expect(0, 71739, '\p{^dogr}', "");
    Expect(0, 71739, '\P{dogr}', "");
    Expect(1, 71739, '\P{^dogr}', "");
    Expect(0, 71740, '\p{dogr}', "");
    Expect(1, 71740, '\p{^dogr}', "");
    Expect(1, 71740, '\P{dogr}', "");
    Expect(0, 71740, '\P{^dogr}', "");
    Expect(1, 71739, '\p{ _Dogr}', "");
    Expect(0, 71739, '\p{^ _Dogr}', "");
    Expect(0, 71739, '\P{ _Dogr}', "");
    Expect(1, 71739, '\P{^ _Dogr}', "");
    Expect(0, 71740, '\p{ _Dogr}', "");
    Expect(1, 71740, '\p{^ _Dogr}', "");
    Expect(1, 71740, '\P{ _Dogr}', "");
    Expect(0, 71740, '\P{^ _Dogr}', "");
    Error('\p{--Is_dogr:=}');
    Error('\P{--Is_dogr:=}');
    Expect(1, 71739, '\p{isdogr}', "");
    Expect(0, 71739, '\p{^isdogr}', "");
    Expect(0, 71739, '\P{isdogr}', "");
    Expect(1, 71739, '\P{^isdogr}', "");
    Expect(0, 71740, '\p{isdogr}', "");
    Expect(1, 71740, '\p{^isdogr}', "");
    Expect(1, 71740, '\P{isdogr}', "");
    Expect(0, 71740, '\P{^isdogr}', "");
    Expect(1, 71739, '\p{	-Is_DOGR}', "");
    Expect(0, 71739, '\p{^	-Is_DOGR}', "");
    Expect(0, 71739, '\P{	-Is_DOGR}', "");
    Expect(1, 71739, '\P{^	-Is_DOGR}', "");
    Expect(0, 71740, '\p{	-Is_DOGR}', "");
    Expect(1, 71740, '\p{^	-Is_DOGR}', "");
    Expect(1, 71740, '\P{	-Is_DOGR}', "");
    Expect(0, 71740, '\P{^	-Is_DOGR}', "");
    Error('\p{/a/	 domino_tiles}');
    Error('\P{/a/	 domino_tiles}');
    Expect(1, 127135, '\p{dominotiles}', "");
    Expect(0, 127135, '\p{^dominotiles}', "");
    Expect(0, 127135, '\P{dominotiles}', "");
    Expect(1, 127135, '\P{^dominotiles}', "");
    Expect(0, 127136, '\p{dominotiles}', "");
    Expect(1, 127136, '\p{^dominotiles}', "");
    Expect(1, 127136, '\P{dominotiles}', "");
    Expect(0, 127136, '\P{^dominotiles}', "");
    Expect(1, 127135, '\p{	-DOMINO_tiles}', "");
    Expect(0, 127135, '\p{^	-DOMINO_tiles}', "");
    Expect(0, 127135, '\P{	-DOMINO_tiles}', "");
    Expect(1, 127135, '\P{^	-DOMINO_tiles}', "");
    Expect(0, 127136, '\p{	-DOMINO_tiles}', "");
    Expect(1, 127136, '\p{^	-DOMINO_tiles}', "");
    Expect(1, 127136, '\P{	-DOMINO_tiles}', "");
    Expect(0, 127136, '\P{^	-DOMINO_tiles}', "");
    Error('\p{:=_is_domino_Tiles}');
    Error('\P{:=_is_domino_Tiles}');
    Expect(1, 127135, '\p{isdominotiles}', "");
    Expect(0, 127135, '\p{^isdominotiles}', "");
    Expect(0, 127135, '\P{isdominotiles}', "");
    Expect(1, 127135, '\P{^isdominotiles}', "");
    Expect(0, 127136, '\p{isdominotiles}', "");
    Expect(1, 127136, '\p{^isdominotiles}', "");
    Expect(1, 127136, '\P{isdominotiles}', "");
    Expect(0, 127136, '\P{^isdominotiles}', "");
    Expect(1, 127135, '\p{	_is_domino_tiles}', "");
    Expect(0, 127135, '\p{^	_is_domino_tiles}', "");
    Expect(0, 127135, '\P{	_is_domino_tiles}', "");
    Expect(1, 127135, '\P{^	_is_domino_tiles}', "");
    Expect(0, 127136, '\p{	_is_domino_tiles}', "");
    Expect(1, 127136, '\p{^	_is_domino_tiles}', "");
    Expect(1, 127136, '\P{	_is_domino_tiles}', "");
    Expect(0, 127136, '\P{^	_is_domino_tiles}', "");
    Error('\p{	_In_Domino_Tiles:=}');
    Error('\P{	_In_Domino_Tiles:=}');
    Expect(1, 127135, '\p{indominotiles}', "");
    Expect(0, 127135, '\p{^indominotiles}', "");
    Expect(0, 127135, '\P{indominotiles}', "");
    Expect(1, 127135, '\P{^indominotiles}', "");
    Expect(0, 127136, '\p{indominotiles}', "");
    Expect(1, 127136, '\p{^indominotiles}', "");
    Expect(1, 127136, '\P{indominotiles}', "");
    Expect(0, 127136, '\P{^indominotiles}', "");
    Expect(1, 127135, '\p{	 In_Domino_TILES}', "");
    Expect(0, 127135, '\p{^	 In_Domino_TILES}', "");
    Expect(0, 127135, '\P{	 In_Domino_TILES}', "");
    Expect(1, 127135, '\P{^	 In_Domino_TILES}', "");
    Expect(0, 127136, '\p{	 In_Domino_TILES}', "");
    Expect(1, 127136, '\p{^	 In_Domino_TILES}', "");
    Expect(1, 127136, '\P{	 In_Domino_TILES}', "");
    Expect(0, 127136, '\P{^	 In_Domino_TILES}', "");
    Error('\p{	_Domino:=}');
    Error('\P{	_Domino:=}');
    Expect(1, 127135, '\p{domino}', "");
    Expect(0, 127135, '\p{^domino}', "");
    Expect(0, 127135, '\P{domino}', "");
    Expect(1, 127135, '\P{^domino}', "");
    Expect(0, 127136, '\p{domino}', "");
    Expect(1, 127136, '\p{^domino}', "");
    Expect(1, 127136, '\P{domino}', "");
    Expect(0, 127136, '\P{^domino}', "");
    Expect(1, 127135, '\p{-	Domino}', "");
    Expect(0, 127135, '\p{^-	Domino}', "");
    Expect(0, 127135, '\P{-	Domino}', "");
    Expect(1, 127135, '\P{^-	Domino}', "");
    Expect(0, 127136, '\p{-	Domino}', "");
    Expect(1, 127136, '\p{^-	Domino}', "");
    Expect(1, 127136, '\P{-	Domino}', "");
    Expect(0, 127136, '\P{^-	Domino}', "");
    Error('\p{:=-IS_DOMINO}');
    Error('\P{:=-IS_DOMINO}');
    Expect(1, 127135, '\p{isdomino}', "");
    Expect(0, 127135, '\p{^isdomino}', "");
    Expect(0, 127135, '\P{isdomino}', "");
    Expect(1, 127135, '\P{^isdomino}', "");
    Expect(0, 127136, '\p{isdomino}', "");
    Expect(1, 127136, '\p{^isdomino}', "");
    Expect(1, 127136, '\P{isdomino}', "");
    Expect(0, 127136, '\P{^isdomino}', "");
    Expect(1, 127135, '\p{- Is_domino}', "");
    Expect(0, 127135, '\p{^- Is_domino}', "");
    Expect(0, 127135, '\P{- Is_domino}', "");
    Expect(1, 127135, '\P{^- Is_domino}', "");
    Expect(0, 127136, '\p{- Is_domino}', "");
    Expect(1, 127136, '\p{^- Is_domino}', "");
    Expect(1, 127136, '\P{- Is_domino}', "");
    Expect(0, 127136, '\P{^- Is_domino}', "");
    Error('\p{:=--In_Domino}');
    Error('\P{:=--In_Domino}');
    Expect(1, 127135, '\p{indomino}', "");
    Expect(0, 127135, '\p{^indomino}', "");
    Expect(0, 127135, '\P{indomino}', "");
    Expect(1, 127135, '\P{^indomino}', "");
    Expect(0, 127136, '\p{indomino}', "");
    Expect(1, 127136, '\p{^indomino}', "");
    Expect(1, 127136, '\P{indomino}', "");
    Expect(0, 127136, '\P{^indomino}', "");
    Expect(1, 127135, '\p{-in_Domino}', "");
    Expect(0, 127135, '\p{^-in_Domino}', "");
    Expect(0, 127135, '\P{-in_Domino}', "");
    Expect(1, 127135, '\P{^-in_Domino}', "");
    Expect(0, 127136, '\p{-in_Domino}', "");
    Expect(1, 127136, '\p{^-in_Domino}', "");
    Expect(1, 127136, '\P{-in_Domino}', "");
    Expect(0, 127136, '\P{^-in_Domino}', "");
    Error('\p{ 	Duployan:=}');
    Error('\P{ 	Duployan:=}');
    Expect(1, 113827, '\p{duployan}', "");
    Expect(0, 113827, '\p{^duployan}', "");
    Expect(0, 113827, '\P{duployan}', "");
    Expect(1, 113827, '\P{^duployan}', "");
    Expect(0, 113828, '\p{duployan}', "");
    Expect(1, 113828, '\p{^duployan}', "");
    Expect(1, 113828, '\P{duployan}', "");
    Expect(0, 113828, '\P{^duployan}', "");
    Expect(1, 113827, '\p{  Duployan}', "");
    Expect(0, 113827, '\p{^  Duployan}', "");
    Expect(0, 113827, '\P{  Duployan}', "");
    Expect(1, 113827, '\P{^  Duployan}', "");
    Expect(0, 113828, '\p{  Duployan}', "");
    Expect(1, 113828, '\p{^  Duployan}', "");
    Expect(1, 113828, '\P{  Duployan}', "");
    Expect(0, 113828, '\P{^  Duployan}', "");
    Error('\p{/a/is_duployan}');
    Error('\P{/a/is_duployan}');
    Expect(1, 113827, '\p{isduployan}', "");
    Expect(0, 113827, '\p{^isduployan}', "");
    Expect(0, 113827, '\P{isduployan}', "");
    Expect(1, 113827, '\P{^isduployan}', "");
    Expect(0, 113828, '\p{isduployan}', "");
    Expect(1, 113828, '\p{^isduployan}', "");
    Expect(1, 113828, '\P{isduployan}', "");
    Expect(0, 113828, '\P{^isduployan}', "");
    Expect(1, 113827, '\p{_-Is_Duployan}', "");
    Expect(0, 113827, '\p{^_-Is_Duployan}', "");
    Expect(0, 113827, '\P{_-Is_Duployan}', "");
    Expect(1, 113827, '\P{^_-Is_Duployan}', "");
    Expect(0, 113828, '\p{_-Is_Duployan}', "");
    Expect(1, 113828, '\p{^_-Is_Duployan}', "");
    Expect(1, 113828, '\P{_-Is_Duployan}', "");
    Expect(0, 113828, '\P{^_-Is_Duployan}', "");
    Error('\p{:=--dupl}');
    Error('\P{:=--dupl}');
    Expect(1, 113827, '\p{dupl}', "");
    Expect(0, 113827, '\p{^dupl}', "");
    Expect(0, 113827, '\P{dupl}', "");
    Expect(1, 113827, '\P{^dupl}', "");
    Expect(0, 113828, '\p{dupl}', "");
    Expect(1, 113828, '\p{^dupl}', "");
    Expect(1, 113828, '\P{dupl}', "");
    Expect(0, 113828, '\P{^dupl}', "");
    Expect(1, 113827, '\p{_	DUPL}', "");
    Expect(0, 113827, '\p{^_	DUPL}', "");
    Expect(0, 113827, '\P{_	DUPL}', "");
    Expect(1, 113827, '\P{^_	DUPL}', "");
    Expect(0, 113828, '\p{_	DUPL}', "");
    Expect(1, 113828, '\p{^_	DUPL}', "");
    Expect(1, 113828, '\P{_	DUPL}', "");
    Expect(0, 113828, '\P{^_	DUPL}', "");
    Error('\p{__Is_Dupl/a/}');
    Error('\P{__Is_Dupl/a/}');
    Expect(1, 113827, '\p{isdupl}', "");
    Expect(0, 113827, '\p{^isdupl}', "");
    Expect(0, 113827, '\P{isdupl}', "");
    Expect(1, 113827, '\P{^isdupl}', "");
    Expect(0, 113828, '\p{isdupl}', "");
    Expect(1, 113828, '\p{^isdupl}', "");
    Expect(1, 113828, '\P{isdupl}', "");
    Expect(0, 113828, '\P{^isdupl}', "");
    Expect(1, 113827, '\p{ _Is_Dupl}', "");
    Expect(0, 113827, '\p{^ _Is_Dupl}', "");
    Expect(0, 113827, '\P{ _Is_Dupl}', "");
    Expect(1, 113827, '\P{^ _Is_Dupl}', "");
    Expect(0, 113828, '\p{ _Is_Dupl}', "");
    Expect(1, 113828, '\p{^ _Is_Dupl}', "");
    Expect(1, 113828, '\P{ _Is_Dupl}', "");
    Expect(0, 113828, '\P{^ _Is_Dupl}', "");
    Error('\p{-/a/Early_Dynastic_Cuneiform}');
    Error('\P{-/a/Early_Dynastic_Cuneiform}');
    Expect(1, 75087, '\p{earlydynasticcuneiform}', "");
    Expect(0, 75087, '\p{^earlydynasticcuneiform}', "");
    Expect(0, 75087, '\P{earlydynasticcuneiform}', "");
    Expect(1, 75087, '\P{^earlydynasticcuneiform}', "");
    Expect(0, 75088, '\p{earlydynasticcuneiform}', "");
    Expect(1, 75088, '\p{^earlydynasticcuneiform}', "");
    Expect(1, 75088, '\P{earlydynasticcuneiform}', "");
    Expect(0, 75088, '\P{^earlydynasticcuneiform}', "");
    Expect(1, 75087, '\p{	early_Dynastic_Cuneiform}', "");
    Expect(0, 75087, '\p{^	early_Dynastic_Cuneiform}', "");
    Expect(0, 75087, '\P{	early_Dynastic_Cuneiform}', "");
    Expect(1, 75087, '\P{^	early_Dynastic_Cuneiform}', "");
    Expect(0, 75088, '\p{	early_Dynastic_Cuneiform}', "");
    Expect(1, 75088, '\p{^	early_Dynastic_Cuneiform}', "");
    Expect(1, 75088, '\P{	early_Dynastic_Cuneiform}', "");
    Expect(0, 75088, '\P{^	early_Dynastic_Cuneiform}', "");
    Error('\p{/a/Is_early_DYNASTIC_Cuneiform}');
    Error('\P{/a/Is_early_DYNASTIC_Cuneiform}');
    Expect(1, 75087, '\p{isearlydynasticcuneiform}', "");
    Expect(0, 75087, '\p{^isearlydynasticcuneiform}', "");
    Expect(0, 75087, '\P{isearlydynasticcuneiform}', "");
    Expect(1, 75087, '\P{^isearlydynasticcuneiform}', "");
    Expect(0, 75088, '\p{isearlydynasticcuneiform}', "");
    Expect(1, 75088, '\p{^isearlydynasticcuneiform}', "");
    Expect(1, 75088, '\P{isearlydynasticcuneiform}', "");
    Expect(0, 75088, '\P{^isearlydynasticcuneiform}', "");
    Expect(1, 75087, '\p{	-Is_EARLY_Dynastic_cuneiform}', "");
    Expect(0, 75087, '\p{^	-Is_EARLY_Dynastic_cuneiform}', "");
    Expect(0, 75087, '\P{	-Is_EARLY_Dynastic_cuneiform}', "");
    Expect(1, 75087, '\P{^	-Is_EARLY_Dynastic_cuneiform}', "");
    Expect(0, 75088, '\p{	-Is_EARLY_Dynastic_cuneiform}', "");
    Expect(1, 75088, '\p{^	-Is_EARLY_Dynastic_cuneiform}', "");
    Expect(1, 75088, '\P{	-Is_EARLY_Dynastic_cuneiform}', "");
    Expect(0, 75088, '\P{^	-Is_EARLY_Dynastic_cuneiform}', "");
    Error('\p{-_in_early_Dynastic_Cuneiform:=}');
    Error('\P{-_in_early_Dynastic_Cuneiform:=}');
    Expect(1, 75087, '\p{inearlydynasticcuneiform}', "");
    Expect(0, 75087, '\p{^inearlydynasticcuneiform}', "");
    Expect(0, 75087, '\P{inearlydynasticcuneiform}', "");
    Expect(1, 75087, '\P{^inearlydynasticcuneiform}', "");
    Expect(0, 75088, '\p{inearlydynasticcuneiform}', "");
    Expect(1, 75088, '\p{^inearlydynasticcuneiform}', "");
    Expect(1, 75088, '\P{inearlydynasticcuneiform}', "");
    Expect(0, 75088, '\P{^inearlydynasticcuneiform}', "");
    Expect(1, 75087, '\p{  In_EARLY_Dynastic_CUNEIFORM}', "");
    Expect(0, 75087, '\p{^  In_EARLY_Dynastic_CUNEIFORM}', "");
    Expect(0, 75087, '\P{  In_EARLY_Dynastic_CUNEIFORM}', "");
    Expect(1, 75087, '\P{^  In_EARLY_Dynastic_CUNEIFORM}', "");
    Expect(0, 75088, '\p{  In_EARLY_Dynastic_CUNEIFORM}', "");
    Expect(1, 75088, '\p{^  In_EARLY_Dynastic_CUNEIFORM}', "");
    Expect(1, 75088, '\P{  In_EARLY_Dynastic_CUNEIFORM}', "");
    Expect(0, 75088, '\P{^  In_EARLY_Dynastic_CUNEIFORM}', "");
    Error('\p{:=EGYPTIAN_HIEROGLYPH_FORMAT_controls}');
    Error('\P{:=EGYPTIAN_HIEROGLYPH_FORMAT_controls}');
    Expect(1, 78943, '\p{egyptianhieroglyphformatcontrols}', "");
    Expect(0, 78943, '\p{^egyptianhieroglyphformatcontrols}', "");
    Expect(0, 78943, '\P{egyptianhieroglyphformatcontrols}', "");
    Expect(1, 78943, '\P{^egyptianhieroglyphformatcontrols}', "");
    Expect(0, 78944, '\p{egyptianhieroglyphformatcontrols}', "");
    Expect(1, 78944, '\p{^egyptianhieroglyphformatcontrols}', "");
    Expect(1, 78944, '\P{egyptianhieroglyphformatcontrols}', "");
    Expect(0, 78944, '\P{^egyptianhieroglyphformatcontrols}', "");
    Expect(1, 78943, '\p{	-Egyptian_hieroglyph_FORMAT_Controls}', "");
    Expect(0, 78943, '\p{^	-Egyptian_hieroglyph_FORMAT_Controls}', "");
    Expect(0, 78943, '\P{	-Egyptian_hieroglyph_FORMAT_Controls}', "");
    Expect(1, 78943, '\P{^	-Egyptian_hieroglyph_FORMAT_Controls}', "");
    Expect(0, 78944, '\p{	-Egyptian_hieroglyph_FORMAT_Controls}', "");
    Expect(1, 78944, '\p{^	-Egyptian_hieroglyph_FORMAT_Controls}', "");
    Expect(1, 78944, '\P{	-Egyptian_hieroglyph_FORMAT_Controls}', "");
    Expect(0, 78944, '\P{^	-Egyptian_hieroglyph_FORMAT_Controls}', "");
    Error('\p{:=	Is_EGYPTIAN_Hieroglyph_format_controls}');
    Error('\P{:=	Is_EGYPTIAN_Hieroglyph_format_controls}');
    Expect(1, 78943, '\p{isegyptianhieroglyphformatcontrols}', "");
    Expect(0, 78943, '\p{^isegyptianhieroglyphformatcontrols}', "");
    Expect(0, 78943, '\P{isegyptianhieroglyphformatcontrols}', "");
    Expect(1, 78943, '\P{^isegyptianhieroglyphformatcontrols}', "");
    Expect(0, 78944, '\p{isegyptianhieroglyphformatcontrols}', "");
    Expect(1, 78944, '\p{^isegyptianhieroglyphformatcontrols}', "");
    Expect(1, 78944, '\P{isegyptianhieroglyphformatcontrols}', "");
    Expect(0, 78944, '\P{^isegyptianhieroglyphformatcontrols}', "");
    Expect(1, 78943, '\p{	_IS_egyptian_Hieroglyph_format_controls}', "");
    Expect(0, 78943, '\p{^	_IS_egyptian_Hieroglyph_format_controls}', "");
    Expect(0, 78943, '\P{	_IS_egyptian_Hieroglyph_format_controls}', "");
    Expect(1, 78943, '\P{^	_IS_egyptian_Hieroglyph_format_controls}', "");
    Expect(0, 78944, '\p{	_IS_egyptian_Hieroglyph_format_controls}', "");
    Expect(1, 78944, '\p{^	_IS_egyptian_Hieroglyph_format_controls}', "");
    Expect(1, 78944, '\P{	_IS_egyptian_Hieroglyph_format_controls}', "");
    Expect(0, 78944, '\P{^	_IS_egyptian_Hieroglyph_format_controls}', "");
    Error('\p{/a/- In_EGYPTIAN_hieroglyph_Format_CONTROLS}');
    Error('\P{/a/- In_EGYPTIAN_hieroglyph_Format_CONTROLS}');
    Expect(1, 78943, '\p{inegyptianhieroglyphformatcontrols}', "");
    Expect(0, 78943, '\p{^inegyptianhieroglyphformatcontrols}', "");
    Expect(0, 78943, '\P{inegyptianhieroglyphformatcontrols}', "");
    Expect(1, 78943, '\P{^inegyptianhieroglyphformatcontrols}', "");
    Expect(0, 78944, '\p{inegyptianhieroglyphformatcontrols}', "");
    Expect(1, 78944, '\p{^inegyptianhieroglyphformatcontrols}', "");
    Expect(1, 78944, '\P{inegyptianhieroglyphformatcontrols}', "");
    Expect(0, 78944, '\P{^inegyptianhieroglyphformatcontrols}', "");
    Expect(1, 78943, '\p{_In_Egyptian_Hieroglyph_Format_Controls}', "");
    Expect(0, 78943, '\p{^_In_Egyptian_Hieroglyph_Format_Controls}', "");
    Expect(0, 78943, '\P{_In_Egyptian_Hieroglyph_Format_Controls}', "");
    Expect(1, 78943, '\P{^_In_Egyptian_Hieroglyph_Format_Controls}', "");
    Expect(0, 78944, '\p{_In_Egyptian_Hieroglyph_Format_Controls}', "");
    Expect(1, 78944, '\p{^_In_Egyptian_Hieroglyph_Format_Controls}', "");
    Expect(1, 78944, '\P{_In_Egyptian_Hieroglyph_Format_Controls}', "");
    Expect(0, 78944, '\P{^_In_Egyptian_Hieroglyph_Format_Controls}', "");
    Error('\p{/a/Egyptian_hieroglyphs}');
    Error('\P{/a/Egyptian_hieroglyphs}');
    Expect(1, 78933, '\p{egyptianhieroglyphs}', "");
    Expect(0, 78933, '\p{^egyptianhieroglyphs}', "");
    Expect(0, 78933, '\P{egyptianhieroglyphs}', "");
    Expect(1, 78933, '\P{^egyptianhieroglyphs}', "");
    Expect(0, 78934, '\p{egyptianhieroglyphs}', "");
    Expect(1, 78934, '\p{^egyptianhieroglyphs}', "");
    Expect(1, 78934, '\P{egyptianhieroglyphs}', "");
    Expect(0, 78934, '\P{^egyptianhieroglyphs}', "");
    Expect(1, 78933, '\p{ Egyptian_hieroglyphs}', "");
    Expect(0, 78933, '\p{^ Egyptian_hieroglyphs}', "");
    Expect(0, 78933, '\P{ Egyptian_hieroglyphs}', "");
    Expect(1, 78933, '\P{^ Egyptian_hieroglyphs}', "");
    Expect(0, 78934, '\p{ Egyptian_hieroglyphs}', "");
    Expect(1, 78934, '\p{^ Egyptian_hieroglyphs}', "");
    Expect(1, 78934, '\P{ Egyptian_hieroglyphs}', "");
    Expect(0, 78934, '\P{^ Egyptian_hieroglyphs}', "");
    Error('\p{:= -Is_EGYPTIAN_hieroglyphs}');
    Error('\P{:= -Is_EGYPTIAN_hieroglyphs}');
    Expect(1, 78933, '\p{isegyptianhieroglyphs}', "");
    Expect(0, 78933, '\p{^isegyptianhieroglyphs}', "");
    Expect(0, 78933, '\P{isegyptianhieroglyphs}', "");
    Expect(1, 78933, '\P{^isegyptianhieroglyphs}', "");
    Expect(0, 78934, '\p{isegyptianhieroglyphs}', "");
    Expect(1, 78934, '\p{^isegyptianhieroglyphs}', "");
    Expect(1, 78934, '\P{isegyptianhieroglyphs}', "");
    Expect(0, 78934, '\P{^isegyptianhieroglyphs}', "");
    Expect(1, 78933, '\p{__Is_Egyptian_Hieroglyphs}', "");
    Expect(0, 78933, '\p{^__Is_Egyptian_Hieroglyphs}', "");
    Expect(0, 78933, '\P{__Is_Egyptian_Hieroglyphs}', "");
    Expect(1, 78933, '\P{^__Is_Egyptian_Hieroglyphs}', "");
    Expect(0, 78934, '\p{__Is_Egyptian_Hieroglyphs}', "");
    Expect(1, 78934, '\p{^__Is_Egyptian_Hieroglyphs}', "");
    Expect(1, 78934, '\P{__Is_Egyptian_Hieroglyphs}', "");
    Expect(0, 78934, '\P{^__Is_Egyptian_Hieroglyphs}', "");
    Error('\p{		Egyp:=}');
    Error('\P{		Egyp:=}');
    Expect(1, 78933, '\p{egyp}', "");
    Expect(0, 78933, '\p{^egyp}', "");
    Expect(0, 78933, '\P{egyp}', "");
    Expect(1, 78933, '\P{^egyp}', "");
    Expect(0, 78934, '\p{egyp}', "");
    Expect(1, 78934, '\p{^egyp}', "");
    Expect(1, 78934, '\P{egyp}', "");
    Expect(0, 78934, '\P{^egyp}', "");
    Expect(1, 78933, '\p{	-egyp}', "");
    Expect(0, 78933, '\p{^	-egyp}', "");
    Expect(0, 78933, '\P{	-egyp}', "");
    Expect(1, 78933, '\P{^	-egyp}', "");
    Expect(0, 78934, '\p{	-egyp}', "");
    Expect(1, 78934, '\p{^	-egyp}', "");
    Expect(1, 78934, '\P{	-egyp}', "");
    Expect(0, 78934, '\P{^	-egyp}', "");
    Error('\p{/a/	 Is_Egyp}');
    Error('\P{/a/	 Is_Egyp}');
    Expect(1, 78933, '\p{isegyp}', "");
    Expect(0, 78933, '\p{^isegyp}', "");
    Expect(0, 78933, '\P{isegyp}', "");
    Expect(1, 78933, '\P{^isegyp}', "");
    Expect(0, 78934, '\p{isegyp}', "");
    Expect(1, 78934, '\p{^isegyp}', "");
    Expect(1, 78934, '\P{isegyp}', "");
    Expect(0, 78934, '\P{^isegyp}', "");
    Expect(1, 78933, '\p{-	IS_egyp}', "");
    Expect(0, 78933, '\p{^-	IS_egyp}', "");
    Expect(0, 78933, '\P{-	IS_egyp}', "");
    Expect(1, 78933, '\P{^-	IS_egyp}', "");
    Expect(0, 78934, '\p{-	IS_egyp}', "");
    Expect(1, 78934, '\p{^-	IS_egyp}', "");
    Expect(1, 78934, '\P{-	IS_egyp}', "");
    Expect(0, 78934, '\P{^-	IS_egyp}', "");
    Error('\p{-:=ELBASAN}');
    Error('\P{-:=ELBASAN}');
    Expect(1, 66855, '\p{elbasan}', "");
    Expect(0, 66855, '\p{^elbasan}', "");
    Expect(0, 66855, '\P{elbasan}', "");
    Expect(1, 66855, '\P{^elbasan}', "");
    Expect(0, 66856, '\p{elbasan}', "");
    Expect(1, 66856, '\p{^elbasan}', "");
    Expect(1, 66856, '\P{elbasan}', "");
    Expect(0, 66856, '\P{^elbasan}', "");
    Expect(1, 66855, '\p{_elbasan}', "");
    Expect(0, 66855, '\p{^_elbasan}', "");
    Expect(0, 66855, '\P{_elbasan}', "");
    Expect(1, 66855, '\P{^_elbasan}', "");
    Expect(0, 66856, '\p{_elbasan}', "");
    Expect(1, 66856, '\p{^_elbasan}', "");
    Expect(1, 66856, '\P{_elbasan}', "");
    Expect(0, 66856, '\P{^_elbasan}', "");
    Error('\p{_IS_ELBASAN/a/}');
    Error('\P{_IS_ELBASAN/a/}');
    Expect(1, 66855, '\p{iselbasan}', "");
    Expect(0, 66855, '\p{^iselbasan}', "");
    Expect(0, 66855, '\P{iselbasan}', "");
    Expect(1, 66855, '\P{^iselbasan}', "");
    Expect(0, 66856, '\p{iselbasan}', "");
    Expect(1, 66856, '\p{^iselbasan}', "");
    Expect(1, 66856, '\P{iselbasan}', "");
    Expect(0, 66856, '\P{^iselbasan}', "");
    Expect(1, 66855, '\p{-Is_Elbasan}', "");
    Expect(0, 66855, '\p{^-Is_Elbasan}', "");
    Expect(0, 66855, '\P{-Is_Elbasan}', "");
    Expect(1, 66855, '\P{^-Is_Elbasan}', "");
    Expect(0, 66856, '\p{-Is_Elbasan}', "");
    Expect(1, 66856, '\p{^-Is_Elbasan}', "");
    Expect(1, 66856, '\P{-Is_Elbasan}', "");
    Expect(0, 66856, '\P{^-Is_Elbasan}', "");
    Error('\p{/a/-_ELBA}');
    Error('\P{/a/-_ELBA}');
    Expect(1, 66855, '\p{elba}', "");
    Expect(0, 66855, '\p{^elba}', "");
    Expect(0, 66855, '\P{elba}', "");
    Expect(1, 66855, '\P{^elba}', "");
    Expect(0, 66856, '\p{elba}', "");
    Expect(1, 66856, '\p{^elba}', "");
    Expect(1, 66856, '\P{elba}', "");
    Expect(0, 66856, '\P{^elba}', "");
    Expect(1, 66855, '\p{_elba}', "");
    Expect(0, 66855, '\p{^_elba}', "");
    Expect(0, 66855, '\P{_elba}', "");
    Expect(1, 66855, '\P{^_elba}', "");
    Expect(0, 66856, '\p{_elba}', "");
    Expect(1, 66856, '\p{^_elba}', "");
    Expect(1, 66856, '\P{_elba}', "");
    Expect(0, 66856, '\P{^_elba}', "");
    Error('\p{:=IS_ELBA}');
    Error('\P{:=IS_ELBA}');
    Expect(1, 66855, '\p{iselba}', "");
    Expect(0, 66855, '\p{^iselba}', "");
    Expect(0, 66855, '\P{iselba}', "");
    Expect(1, 66855, '\P{^iselba}', "");
    Expect(0, 66856, '\p{iselba}', "");
    Expect(1, 66856, '\p{^iselba}', "");
    Expect(1, 66856, '\P{iselba}', "");
    Expect(0, 66856, '\P{^iselba}', "");
    Expect(1, 66855, '\p{ Is_ELBA}', "");
    Expect(0, 66855, '\p{^ Is_ELBA}', "");
    Expect(0, 66855, '\P{ Is_ELBA}', "");
    Expect(1, 66855, '\P{^ Is_ELBA}', "");
    Expect(0, 66856, '\p{ Is_ELBA}', "");
    Expect(1, 66856, '\p{^ Is_ELBA}', "");
    Expect(1, 66856, '\P{ Is_ELBA}', "");
    Expect(0, 66856, '\P{^ Is_ELBA}', "");
    Error('\p{-	Elymaic:=}');
    Error('\P{-	Elymaic:=}');
    Expect(1, 69622, '\p{elymaic}', "");
    Expect(0, 69622, '\p{^elymaic}', "");
    Expect(0, 69622, '\P{elymaic}', "");
    Expect(1, 69622, '\P{^elymaic}', "");
    Expect(0, 69623, '\p{elymaic}', "");
    Expect(1, 69623, '\p{^elymaic}', "");
    Expect(1, 69623, '\P{elymaic}', "");
    Expect(0, 69623, '\P{^elymaic}', "");
    Expect(1, 69622, '\p{		elymaic}', "");
    Expect(0, 69622, '\p{^		elymaic}', "");
    Expect(0, 69622, '\P{		elymaic}', "");
    Expect(1, 69622, '\P{^		elymaic}', "");
    Expect(0, 69623, '\p{		elymaic}', "");
    Expect(1, 69623, '\p{^		elymaic}', "");
    Expect(1, 69623, '\P{		elymaic}', "");
    Expect(0, 69623, '\P{^		elymaic}', "");
    Error('\p{ :=is_Elymaic}');
    Error('\P{ :=is_Elymaic}');
    Expect(1, 69622, '\p{iselymaic}', "");
    Expect(0, 69622, '\p{^iselymaic}', "");
    Expect(0, 69622, '\P{iselymaic}', "");
    Expect(1, 69622, '\P{^iselymaic}', "");
    Expect(0, 69623, '\p{iselymaic}', "");
    Expect(1, 69623, '\p{^iselymaic}', "");
    Expect(1, 69623, '\P{iselymaic}', "");
    Expect(0, 69623, '\P{^iselymaic}', "");
    Expect(1, 69622, '\p{	_is_elymaic}', "");
    Expect(0, 69622, '\p{^	_is_elymaic}', "");
    Expect(0, 69622, '\P{	_is_elymaic}', "");
    Expect(1, 69622, '\P{^	_is_elymaic}', "");
    Expect(0, 69623, '\p{	_is_elymaic}', "");
    Expect(1, 69623, '\p{^	_is_elymaic}', "");
    Expect(1, 69623, '\P{	_is_elymaic}', "");
    Expect(0, 69623, '\P{^	_is_elymaic}', "");
    Error('\p{_-ELYM/a/}');
    Error('\P{_-ELYM/a/}');
    Expect(1, 69622, '\p{elym}', "");
    Expect(0, 69622, '\p{^elym}', "");
    Expect(0, 69622, '\P{elym}', "");
    Expect(1, 69622, '\P{^elym}', "");
    Expect(0, 69623, '\p{elym}', "");
    Expect(1, 69623, '\p{^elym}', "");
    Expect(1, 69623, '\P{elym}', "");
    Expect(0, 69623, '\P{^elym}', "");
    Expect(1, 69622, '\p{--ELYM}', "");
    Expect(0, 69622, '\p{^--ELYM}', "");
    Expect(0, 69622, '\P{--ELYM}', "");
    Expect(1, 69622, '\P{^--ELYM}', "");
    Expect(0, 69623, '\p{--ELYM}', "");
    Expect(1, 69623, '\p{^--ELYM}', "");
    Expect(1, 69623, '\P{--ELYM}', "");
    Expect(0, 69623, '\P{^--ELYM}', "");
    Error('\p{:=is_ELYM}');
    Error('\P{:=is_ELYM}');
    Expect(1, 69622, '\p{iselym}', "");
    Expect(0, 69622, '\p{^iselym}', "");
    Expect(0, 69622, '\P{iselym}', "");
    Expect(1, 69622, '\P{^iselym}', "");
    Expect(0, 69623, '\p{iselym}', "");
    Expect(1, 69623, '\p{^iselym}', "");
    Expect(1, 69623, '\P{iselym}', "");
    Expect(0, 69623, '\P{^iselym}', "");
    Expect(1, 69622, '\p{	 Is_elym}', "");
    Expect(0, 69622, '\p{^	 Is_elym}', "");
    Expect(0, 69622, '\P{	 Is_elym}', "");
    Expect(1, 69622, '\P{^	 Is_elym}', "");
    Expect(0, 69623, '\p{	 Is_elym}', "");
    Expect(1, 69623, '\p{^	 Is_elym}', "");
    Expect(1, 69623, '\P{	 Is_elym}', "");
    Expect(0, 69623, '\P{^	 Is_elym}', "");
    Error('\p{	/a/Emoji}');
    Error('\P{	/a/Emoji}');
    Expect(1, 129784, '\p{emoji}', "");
    Expect(0, 129784, '\p{^emoji}', "");
    Expect(0, 129784, '\P{emoji}', "");
    Expect(1, 129784, '\P{^emoji}', "");
    Expect(0, 129785, '\p{emoji}', "");
    Expect(1, 129785, '\p{^emoji}', "");
    Expect(1, 129785, '\P{emoji}', "");
    Expect(0, 129785, '\P{^emoji}', "");
    Expect(1, 129784, '\p{ EMOJI}', "");
    Expect(0, 129784, '\p{^ EMOJI}', "");
    Expect(0, 129784, '\P{ EMOJI}', "");
    Expect(1, 129784, '\P{^ EMOJI}', "");
    Expect(0, 129785, '\p{ EMOJI}', "");
    Expect(1, 129785, '\p{^ EMOJI}', "");
    Expect(1, 129785, '\P{ EMOJI}', "");
    Expect(0, 129785, '\P{^ EMOJI}', "");
    Error('\p{ _is_emoji/a/}');
    Error('\P{ _is_emoji/a/}');
    Expect(1, 129784, '\p{isemoji}', "");
    Expect(0, 129784, '\p{^isemoji}', "");
    Expect(0, 129784, '\P{isemoji}', "");
    Expect(1, 129784, '\P{^isemoji}', "");
    Expect(0, 129785, '\p{isemoji}', "");
    Expect(1, 129785, '\p{^isemoji}', "");
    Expect(1, 129785, '\P{isemoji}', "");
    Expect(0, 129785, '\P{^isemoji}', "");
    Expect(1, 129784, '\p{	 IS_Emoji}', "");
    Expect(0, 129784, '\p{^	 IS_Emoji}', "");
    Expect(0, 129784, '\P{	 IS_Emoji}', "");
    Expect(1, 129784, '\P{^	 IS_Emoji}', "");
    Expect(0, 129785, '\p{	 IS_Emoji}', "");
    Expect(1, 129785, '\p{^	 IS_Emoji}', "");
    Expect(1, 129785, '\P{	 IS_Emoji}', "");
    Expect(0, 129785, '\P{^	 IS_Emoji}', "");
    Error('\p{_emoji_Component:=}');
    Error('\P{_emoji_Component:=}');
    Expect(1, 917631, '\p{emojicomponent}', "");
    Expect(0, 917631, '\p{^emojicomponent}', "");
    Expect(0, 917631, '\P{emojicomponent}', "");
    Expect(1, 917631, '\P{^emojicomponent}', "");
    Expect(0, 917632, '\p{emojicomponent}', "");
    Expect(1, 917632, '\p{^emojicomponent}', "");
    Expect(1, 917632, '\P{emojicomponent}', "");
    Expect(0, 917632, '\P{^emojicomponent}', "");
    Expect(1, 917631, '\p{_Emoji_Component}', "");
    Expect(0, 917631, '\p{^_Emoji_Component}', "");
    Expect(0, 917631, '\P{_Emoji_Component}', "");
    Expect(1, 917631, '\P{^_Emoji_Component}', "");
    Expect(0, 917632, '\p{_Emoji_Component}', "");
    Expect(1, 917632, '\p{^_Emoji_Component}', "");
    Expect(1, 917632, '\P{_Emoji_Component}', "");
    Expect(0, 917632, '\P{^_Emoji_Component}', "");
    Error('\p{ /a/Is_emoji_component}');
    Error('\P{ /a/Is_emoji_component}');
    Expect(1, 917631, '\p{isemojicomponent}', "");
    Expect(0, 917631, '\p{^isemojicomponent}', "");
    Expect(0, 917631, '\P{isemojicomponent}', "");
    Expect(1, 917631, '\P{^isemojicomponent}', "");
    Expect(0, 917632, '\p{isemojicomponent}', "");
    Expect(1, 917632, '\p{^isemojicomponent}', "");
    Expect(1, 917632, '\P{isemojicomponent}', "");
    Expect(0, 917632, '\P{^isemojicomponent}', "");
    Expect(1, 917631, '\p{ 	Is_Emoji_Component}', "");
    Expect(0, 917631, '\p{^ 	Is_Emoji_Component}', "");
    Expect(0, 917631, '\P{ 	Is_Emoji_Component}', "");
    Expect(1, 917631, '\P{^ 	Is_Emoji_Component}', "");
    Expect(0, 917632, '\p{ 	Is_Emoji_Component}', "");
    Expect(1, 917632, '\p{^ 	Is_Emoji_Component}', "");
    Expect(1, 917632, '\P{ 	Is_Emoji_Component}', "");
    Expect(0, 917632, '\P{^ 	Is_Emoji_Component}', "");
    Error('\p{/a/ECOMP}');
    Error('\P{/a/ECOMP}');
    Expect(1, 917631, '\p{ecomp}', "");
    Expect(0, 917631, '\p{^ecomp}', "");
    Expect(0, 917631, '\P{ecomp}', "");
    Expect(1, 917631, '\P{^ecomp}', "");
    Expect(0, 917632, '\p{ecomp}', "");
    Expect(1, 917632, '\p{^ecomp}', "");
    Expect(1, 917632, '\P{ecomp}', "");
    Expect(0, 917632, '\P{^ecomp}', "");
    Expect(1, 917631, '\p{_EComp}', "");
    Expect(0, 917631, '\p{^_EComp}', "");
    Expect(0, 917631, '\P{_EComp}', "");
    Expect(1, 917631, '\P{^_EComp}', "");
    Expect(0, 917632, '\p{_EComp}', "");
    Expect(1, 917632, '\p{^_EComp}', "");
    Expect(1, 917632, '\P{_EComp}', "");
    Expect(0, 917632, '\P{^_EComp}', "");
    Error('\p{/a/-Is_EComp}');
    Error('\P{/a/-Is_EComp}');
    Expect(1, 917631, '\p{isecomp}', "");
    Expect(0, 917631, '\p{^isecomp}', "");
    Expect(0, 917631, '\P{isecomp}', "");
    Expect(1, 917631, '\P{^isecomp}', "");
    Expect(0, 917632, '\p{isecomp}', "");
    Expect(1, 917632, '\p{^isecomp}', "");
    Expect(1, 917632, '\P{isecomp}', "");
    Expect(0, 917632, '\P{^isecomp}', "");
    Expect(1, 917631, '\p{-	Is_ECOMP}', "");
    Expect(0, 917631, '\p{^-	Is_ECOMP}', "");
    Expect(0, 917631, '\P{-	Is_ECOMP}', "");
    Expect(1, 917631, '\P{^-	Is_ECOMP}', "");
    Expect(0, 917632, '\p{-	Is_ECOMP}', "");
    Expect(1, 917632, '\p{^-	Is_ECOMP}', "");
    Expect(1, 917632, '\P{-	Is_ECOMP}', "");
    Expect(0, 917632, '\P{^-	Is_ECOMP}', "");
    Error('\p{-Emoji_modifier/a/}');
    Error('\P{-Emoji_modifier/a/}');
    Expect(1, 127999, '\p{emojimodifier}', "");
    Expect(0, 127999, '\p{^emojimodifier}', "");
    Expect(0, 127999, '\P{emojimodifier}', "");
    Expect(1, 127999, '\P{^emojimodifier}', "");
    Expect(0, 128000, '\p{emojimodifier}', "");
    Expect(1, 128000, '\p{^emojimodifier}', "");
    Expect(1, 128000, '\P{emojimodifier}', "");
    Expect(0, 128000, '\P{^emojimodifier}', "");
    Expect(1, 127999, '\p{_Emoji_Modifier}', "");
    Expect(0, 127999, '\p{^_Emoji_Modifier}', "");
    Expect(0, 127999, '\P{_Emoji_Modifier}', "");
    Expect(1, 127999, '\P{^_Emoji_Modifier}', "");
    Expect(0, 128000, '\p{_Emoji_Modifier}', "");
    Expect(1, 128000, '\p{^_Emoji_Modifier}', "");
    Expect(1, 128000, '\P{_Emoji_Modifier}', "");
    Expect(0, 128000, '\P{^_Emoji_Modifier}', "");
    Error('\p{	Is_EMOJI_MODIFIER:=}');
    Error('\P{	Is_EMOJI_MODIFIER:=}');
    Expect(1, 127999, '\p{isemojimodifier}', "");
    Expect(0, 127999, '\p{^isemojimodifier}', "");
    Expect(0, 127999, '\P{isemojimodifier}', "");
    Expect(1, 127999, '\P{^isemojimodifier}', "");
    Expect(0, 128000, '\p{isemojimodifier}', "");
    Expect(1, 128000, '\p{^isemojimodifier}', "");
    Expect(1, 128000, '\P{isemojimodifier}', "");
    Expect(0, 128000, '\P{^isemojimodifier}', "");
    Expect(1, 127999, '\p{_IS_emoji_modifier}', "");
    Expect(0, 127999, '\p{^_IS_emoji_modifier}', "");
    Expect(0, 127999, '\P{_IS_emoji_modifier}', "");
    Expect(1, 127999, '\P{^_IS_emoji_modifier}', "");
    Expect(0, 128000, '\p{_IS_emoji_modifier}', "");
    Expect(1, 128000, '\p{^_IS_emoji_modifier}', "");
    Expect(1, 128000, '\P{_IS_emoji_modifier}', "");
    Expect(0, 128000, '\P{^_IS_emoji_modifier}', "");
    Error('\p{ /a/EMod}');
    Error('\P{ /a/EMod}');
    Expect(1, 127999, '\p{emod}', "");
    Expect(0, 127999, '\p{^emod}', "");
    Expect(0, 127999, '\P{emod}', "");
    Expect(1, 127999, '\P{^emod}', "");
    Expect(0, 128000, '\p{emod}', "");
    Expect(1, 128000, '\p{^emod}', "");
    Expect(1, 128000, '\P{emod}', "");
    Expect(0, 128000, '\P{^emod}', "");
    Expect(1, 127999, '\p{ 	EMOD}', "");
    Expect(0, 127999, '\p{^ 	EMOD}', "");
    Expect(0, 127999, '\P{ 	EMOD}', "");
    Expect(1, 127999, '\P{^ 	EMOD}', "");
    Expect(0, 128000, '\p{ 	EMOD}', "");
    Expect(1, 128000, '\p{^ 	EMOD}', "");
    Expect(1, 128000, '\P{ 	EMOD}', "");
    Expect(0, 128000, '\P{^ 	EMOD}', "");
    Error('\p{:=- IS_EMOD}');
    Error('\P{:=- IS_EMOD}');
    Expect(1, 127999, '\p{isemod}', "");
    Expect(0, 127999, '\p{^isemod}', "");
    Expect(0, 127999, '\P{isemod}', "");
    Expect(1, 127999, '\P{^isemod}', "");
    Expect(0, 128000, '\p{isemod}', "");
    Expect(1, 128000, '\p{^isemod}', "");
    Expect(1, 128000, '\P{isemod}', "");
    Expect(0, 128000, '\P{^isemod}', "");
    Expect(1, 127999, '\p{-	is_EMod}', "");
    Expect(0, 127999, '\p{^-	is_EMod}', "");
    Expect(0, 127999, '\P{-	is_EMod}', "");
    Expect(1, 127999, '\P{^-	is_EMod}', "");
    Expect(0, 128000, '\p{-	is_EMod}', "");
    Expect(1, 128000, '\p{^-	is_EMod}', "");
    Expect(1, 128000, '\P{-	is_EMod}', "");
    Expect(0, 128000, '\P{^-	is_EMod}', "");
    Error('\p{ :=Emoji_MODIFIER_Base}');
    Error('\P{ :=Emoji_MODIFIER_Base}');
    Expect(1, 129784, '\p{emojimodifierbase}', "");
    Expect(0, 129784, '\p{^emojimodifierbase}', "");
    Expect(0, 129784, '\P{emojimodifierbase}', "");
    Expect(1, 129784, '\P{^emojimodifierbase}', "");
    Expect(0, 129785, '\p{emojimodifierbase}', "");
    Expect(1, 129785, '\p{^emojimodifierbase}', "");
    Expect(1, 129785, '\P{emojimodifierbase}', "");
    Expect(0, 129785, '\P{^emojimodifierbase}', "");
    Expect(1, 129784, '\p{ _Emoji_MODIFIER_BASE}', "");
    Expect(0, 129784, '\p{^ _Emoji_MODIFIER_BASE}', "");
    Expect(0, 129784, '\P{ _Emoji_MODIFIER_BASE}', "");
    Expect(1, 129784, '\P{^ _Emoji_MODIFIER_BASE}', "");
    Expect(0, 129785, '\p{ _Emoji_MODIFIER_BASE}', "");
    Expect(1, 129785, '\p{^ _Emoji_MODIFIER_BASE}', "");
    Expect(1, 129785, '\P{ _Emoji_MODIFIER_BASE}', "");
    Expect(0, 129785, '\P{^ _Emoji_MODIFIER_BASE}', "");
    Error('\p{ is_Emoji_Modifier_BASE/a/}');
    Error('\P{ is_Emoji_Modifier_BASE/a/}');
    Expect(1, 129784, '\p{isemojimodifierbase}', "");
    Expect(0, 129784, '\p{^isemojimodifierbase}', "");
    Expect(0, 129784, '\P{isemojimodifierbase}', "");
    Expect(1, 129784, '\P{^isemojimodifierbase}', "");
    Expect(0, 129785, '\p{isemojimodifierbase}', "");
    Expect(1, 129785, '\p{^isemojimodifierbase}', "");
    Expect(1, 129785, '\P{isemojimodifierbase}', "");
    Expect(0, 129785, '\P{^isemojimodifierbase}', "");
    Expect(1, 129784, '\p{	-is_EMOJI_modifier_BASE}', "");
    Expect(0, 129784, '\p{^	-is_EMOJI_modifier_BASE}', "");
    Expect(0, 129784, '\P{	-is_EMOJI_modifier_BASE}', "");
    Expect(1, 129784, '\P{^	-is_EMOJI_modifier_BASE}', "");
    Expect(0, 129785, '\p{	-is_EMOJI_modifier_BASE}', "");
    Expect(1, 129785, '\p{^	-is_EMOJI_modifier_BASE}', "");
    Expect(1, 129785, '\P{	-is_EMOJI_modifier_BASE}', "");
    Expect(0, 129785, '\P{^	-is_EMOJI_modifier_BASE}', "");
    Error('\p{ /a/ebase}');
    Error('\P{ /a/ebase}');
    Expect(1, 129784, '\p{ebase}', "");
    Expect(0, 129784, '\p{^ebase}', "");
    Expect(0, 129784, '\P{ebase}', "");
    Expect(1, 129784, '\P{^ebase}', "");
    Expect(0, 129785, '\p{ebase}', "");
    Expect(1, 129785, '\p{^ebase}', "");
    Expect(1, 129785, '\P{ebase}', "");
    Expect(0, 129785, '\P{^ebase}', "");
    Expect(1, 129784, '\p{_	ebase}', "");
    Expect(0, 129784, '\p{^_	ebase}', "");
    Expect(0, 129784, '\P{_	ebase}', "");
    Expect(1, 129784, '\P{^_	ebase}', "");
    Expect(0, 129785, '\p{_	ebase}', "");
    Expect(1, 129785, '\p{^_	ebase}', "");
    Expect(1, 129785, '\P{_	ebase}', "");
    Expect(0, 129785, '\P{^_	ebase}', "");
    Error('\p{ :=Is_EBase}');
    Error('\P{ :=Is_EBase}');
    Expect(1, 129784, '\p{isebase}', "");
    Expect(0, 129784, '\p{^isebase}', "");
    Expect(0, 129784, '\P{isebase}', "");
    Expect(1, 129784, '\P{^isebase}', "");
    Expect(0, 129785, '\p{isebase}', "");
    Expect(1, 129785, '\p{^isebase}', "");
    Expect(1, 129785, '\P{isebase}', "");
    Expect(0, 129785, '\P{^isebase}', "");
    Expect(1, 129784, '\p{  IS_EBASE}', "");
    Expect(0, 129784, '\p{^  IS_EBASE}', "");
    Expect(0, 129784, '\P{  IS_EBASE}', "");
    Expect(1, 129784, '\P{^  IS_EBASE}', "");
    Expect(0, 129785, '\p{  IS_EBASE}', "");
    Expect(1, 129785, '\p{^  IS_EBASE}', "");
    Expect(1, 129785, '\P{  IS_EBASE}', "");
    Expect(0, 129785, '\P{^  IS_EBASE}', "");
    Error('\p{/a/-emoji_PRESENTATION}');
    Error('\P{/a/-emoji_PRESENTATION}');
    Expect(1, 129784, '\p{emojipresentation}', "");
    Expect(0, 129784, '\p{^emojipresentation}', "");
    Expect(0, 129784, '\P{emojipresentation}', "");
    Expect(1, 129784, '\P{^emojipresentation}', "");
    Expect(0, 129785, '\p{emojipresentation}', "");
    Expect(1, 129785, '\p{^emojipresentation}', "");
    Expect(1, 129785, '\P{emojipresentation}', "");
    Expect(0, 129785, '\P{^emojipresentation}', "");
    Expect(1, 129784, '\p{-Emoji_Presentation}', "");
    Expect(0, 129784, '\p{^-Emoji_Presentation}', "");
    Expect(0, 129784, '\P{-Emoji_Presentation}', "");
    Expect(1, 129784, '\P{^-Emoji_Presentation}', "");
    Expect(0, 129785, '\p{-Emoji_Presentation}', "");
    Expect(1, 129785, '\p{^-Emoji_Presentation}', "");
    Expect(1, 129785, '\P{-Emoji_Presentation}', "");
    Expect(0, 129785, '\P{^-Emoji_Presentation}', "");
    Error('\p{:=_	Is_emoji_Presentation}');
    Error('\P{:=_	Is_emoji_Presentation}');
    Expect(1, 129784, '\p{isemojipresentation}', "");
    Expect(0, 129784, '\p{^isemojipresentation}', "");
    Expect(0, 129784, '\P{isemojipresentation}', "");
    Expect(1, 129784, '\P{^isemojipresentation}', "");
    Expect(0, 129785, '\p{isemojipresentation}', "");
    Expect(1, 129785, '\p{^isemojipresentation}', "");
    Expect(1, 129785, '\P{isemojipresentation}', "");
    Expect(0, 129785, '\P{^isemojipresentation}', "");
    Expect(1, 129784, '\p{--IS_emoji_presentation}', "");
    Expect(0, 129784, '\p{^--IS_emoji_presentation}', "");
    Expect(0, 129784, '\P{--IS_emoji_presentation}', "");
    Expect(1, 129784, '\P{^--IS_emoji_presentation}', "");
    Expect(0, 129785, '\p{--IS_emoji_presentation}', "");
    Expect(1, 129785, '\p{^--IS_emoji_presentation}', "");
    Expect(1, 129785, '\P{--IS_emoji_presentation}', "");
    Expect(0, 129785, '\P{^--IS_emoji_presentation}', "");
    Error('\p{--epres/a/}');
    Error('\P{--epres/a/}');
    Expect(1, 129784, '\p{epres}', "");
    Expect(0, 129784, '\p{^epres}', "");
    Expect(0, 129784, '\P{epres}', "");
    Expect(1, 129784, '\P{^epres}', "");
    Expect(0, 129785, '\p{epres}', "");
    Expect(1, 129785, '\p{^epres}', "");
    Expect(1, 129785, '\P{epres}', "");
    Expect(0, 129785, '\P{^epres}', "");
    Expect(1, 129784, '\p{	EPres}', "");
    Expect(0, 129784, '\p{^	EPres}', "");
    Expect(0, 129784, '\P{	EPres}', "");
    Expect(1, 129784, '\P{^	EPres}', "");
    Expect(0, 129785, '\p{	EPres}', "");
    Expect(1, 129785, '\p{^	EPres}', "");
    Expect(1, 129785, '\P{	EPres}', "");
    Expect(0, 129785, '\P{^	EPres}', "");
    Error('\p{/a/-_is_epres}');
    Error('\P{/a/-_is_epres}');
    Expect(1, 129784, '\p{isepres}', "");
    Expect(0, 129784, '\p{^isepres}', "");
    Expect(0, 129784, '\P{isepres}', "");
    Expect(1, 129784, '\P{^isepres}', "");
    Expect(0, 129785, '\p{isepres}', "");
    Expect(1, 129785, '\p{^isepres}', "");
    Expect(1, 129785, '\P{isepres}', "");
    Expect(0, 129785, '\P{^isepres}', "");
    Expect(1, 129784, '\p{Is_EPres}', "");
    Expect(0, 129784, '\p{^Is_EPres}', "");
    Expect(0, 129784, '\P{Is_EPres}', "");
    Expect(1, 129784, '\P{^Is_EPres}', "");
    Expect(0, 129785, '\p{Is_EPres}', "");
    Expect(1, 129785, '\p{^Is_EPres}', "");
    Expect(1, 129785, '\P{Is_EPres}', "");
    Expect(0, 129785, '\P{^Is_EPres}', "");
    Error('\p{/a/--Emoticons}');
    Error('\P{/a/--Emoticons}');
    Expect(1, 128591, '\p{emoticons}', "");
    Expect(0, 128591, '\p{^emoticons}', "");
    Expect(0, 128591, '\P{emoticons}', "");
    Expect(1, 128591, '\P{^emoticons}', "");
    Expect(0, 128592, '\p{emoticons}', "");
    Expect(1, 128592, '\p{^emoticons}', "");
    Expect(1, 128592, '\P{emoticons}', "");
    Expect(0, 128592, '\P{^emoticons}', "");
    Expect(1, 128591, '\p{-emoticons}', "");
    Expect(0, 128591, '\p{^-emoticons}', "");
    Expect(0, 128591, '\P{-emoticons}', "");
    Expect(1, 128591, '\P{^-emoticons}', "");
    Expect(0, 128592, '\p{-emoticons}', "");
    Expect(1, 128592, '\p{^-emoticons}', "");
    Expect(1, 128592, '\P{-emoticons}', "");
    Expect(0, 128592, '\P{^-emoticons}', "");
    Error('\p{- Is_EMOTICONS/a/}');
    Error('\P{- Is_EMOTICONS/a/}');
    Expect(1, 128591, '\p{isemoticons}', "");
    Expect(0, 128591, '\p{^isemoticons}', "");
    Expect(0, 128591, '\P{isemoticons}', "");
    Expect(1, 128591, '\P{^isemoticons}', "");
    Expect(0, 128592, '\p{isemoticons}', "");
    Expect(1, 128592, '\p{^isemoticons}', "");
    Expect(1, 128592, '\P{isemoticons}', "");
    Expect(0, 128592, '\P{^isemoticons}', "");
    Expect(1, 128591, '\p{--is_Emoticons}', "");
    Expect(0, 128591, '\p{^--is_Emoticons}', "");
    Expect(0, 128591, '\P{--is_Emoticons}', "");
    Expect(1, 128591, '\P{^--is_Emoticons}', "");
    Expect(0, 128592, '\p{--is_Emoticons}', "");
    Expect(1, 128592, '\p{^--is_Emoticons}', "");
    Expect(1, 128592, '\P{--is_Emoticons}', "");
    Expect(0, 128592, '\P{^--is_Emoticons}', "");
    Error('\p{:=_	In_EMOTICONS}');
    Error('\P{:=_	In_EMOTICONS}');
    Expect(1, 128591, '\p{inemoticons}', "");
    Expect(0, 128591, '\p{^inemoticons}', "");
    Expect(0, 128591, '\P{inemoticons}', "");
    Expect(1, 128591, '\P{^inemoticons}', "");
    Expect(0, 128592, '\p{inemoticons}', "");
    Expect(1, 128592, '\p{^inemoticons}', "");
    Expect(1, 128592, '\P{inemoticons}', "");
    Expect(0, 128592, '\P{^inemoticons}', "");
    Expect(1, 128591, '\p{	in_EMOTICONS}', "");
    Expect(0, 128591, '\p{^	in_EMOTICONS}', "");
    Expect(0, 128591, '\P{	in_EMOTICONS}', "");
    Expect(1, 128591, '\P{^	in_EMOTICONS}', "");
    Expect(0, 128592, '\p{	in_EMOTICONS}', "");
    Expect(1, 128592, '\p{^	in_EMOTICONS}', "");
    Expect(1, 128592, '\P{	in_EMOTICONS}', "");
    Expect(0, 128592, '\P{^	in_EMOTICONS}', "");
    Error('\p{_	Enclosed_Alphanumeric_Supplement:=}');
    Error('\P{_	Enclosed_Alphanumeric_Supplement:=}');
    Expect(1, 127487, '\p{enclosedalphanumericsupplement}', "");
    Expect(0, 127487, '\p{^enclosedalphanumericsupplement}', "");
    Expect(0, 127487, '\P{enclosedalphanumericsupplement}', "");
    Expect(1, 127487, '\P{^enclosedalphanumericsupplement}', "");
    Expect(0, 127488, '\p{enclosedalphanumericsupplement}', "");
    Expect(1, 127488, '\p{^enclosedalphanumericsupplement}', "");
    Expect(1, 127488, '\P{enclosedalphanumericsupplement}', "");
    Expect(0, 127488, '\P{^enclosedalphanumericsupplement}', "");
    Expect(1, 127487, '\p{-_Enclosed_Alphanumeric_Supplement}', "");
    Expect(0, 127487, '\p{^-_Enclosed_Alphanumeric_Supplement}', "");
    Expect(0, 127487, '\P{-_Enclosed_Alphanumeric_Supplement}', "");
    Expect(1, 127487, '\P{^-_Enclosed_Alphanumeric_Supplement}', "");
    Expect(0, 127488, '\p{-_Enclosed_Alphanumeric_Supplement}', "");
    Expect(1, 127488, '\p{^-_Enclosed_Alphanumeric_Supplement}', "");
    Expect(1, 127488, '\P{-_Enclosed_Alphanumeric_Supplement}', "");
    Expect(0, 127488, '\P{^-_Enclosed_Alphanumeric_Supplement}', "");
    Error('\p{:=_is_enclosed_Alphanumeric_SUPPLEMENT}');
    Error('\P{:=_is_enclosed_Alphanumeric_SUPPLEMENT}');
    Expect(1, 127487, '\p{isenclosedalphanumericsupplement}', "");
    Expect(0, 127487, '\p{^isenclosedalphanumericsupplement}', "");
    Expect(0, 127487, '\P{isenclosedalphanumericsupplement}', "");
    Expect(1, 127487, '\P{^isenclosedalphanumericsupplement}', "");
    Expect(0, 127488, '\p{isenclosedalphanumericsupplement}', "");
    Expect(1, 127488, '\p{^isenclosedalphanumericsupplement}', "");
    Expect(1, 127488, '\P{isenclosedalphanumericsupplement}', "");
    Expect(0, 127488, '\P{^isenclosedalphanumericsupplement}', "");
    Expect(1, 127487, '\p{ 	IS_Enclosed_Alphanumeric_SUPPLEMENT}', "");
    Expect(0, 127487, '\p{^ 	IS_Enclosed_Alphanumeric_SUPPLEMENT}', "");
    Expect(0, 127487, '\P{ 	IS_Enclosed_Alphanumeric_SUPPLEMENT}', "");
    Expect(1, 127487, '\P{^ 	IS_Enclosed_Alphanumeric_SUPPLEMENT}', "");
    Expect(0, 127488, '\p{ 	IS_Enclosed_Alphanumeric_SUPPLEMENT}', "");
    Expect(1, 127488, '\p{^ 	IS_Enclosed_Alphanumeric_SUPPLEMENT}', "");
    Expect(1, 127488, '\P{ 	IS_Enclosed_Alphanumeric_SUPPLEMENT}', "");
    Expect(0, 127488, '\P{^ 	IS_Enclosed_Alphanumeric_SUPPLEMENT}', "");
    Error('\p{:= 	IN_Enclosed_alphanumeric_Supplement}');
    Error('\P{:= 	IN_Enclosed_alphanumeric_Supplement}');
    Expect(1, 127487, '\p{inenclosedalphanumericsupplement}', "");
    Expect(0, 127487, '\p{^inenclosedalphanumericsupplement}', "");
    Expect(0, 127487, '\P{inenclosedalphanumericsupplement}', "");
    Expect(1, 127487, '\P{^inenclosedalphanumericsupplement}', "");
    Expect(0, 127488, '\p{inenclosedalphanumericsupplement}', "");
    Expect(1, 127488, '\p{^inenclosedalphanumericsupplement}', "");
    Expect(1, 127488, '\P{inenclosedalphanumericsupplement}', "");
    Expect(0, 127488, '\P{^inenclosedalphanumericsupplement}', "");
    Expect(1, 127487, '\p{_in_ENCLOSED_Alphanumeric_Supplement}', "");
    Expect(0, 127487, '\p{^_in_ENCLOSED_Alphanumeric_Supplement}', "");
    Expect(0, 127487, '\P{_in_ENCLOSED_Alphanumeric_Supplement}', "");
    Expect(1, 127487, '\P{^_in_ENCLOSED_Alphanumeric_Supplement}', "");
    Expect(0, 127488, '\p{_in_ENCLOSED_Alphanumeric_Supplement}', "");
    Expect(1, 127488, '\p{^_in_ENCLOSED_Alphanumeric_Supplement}', "");
    Expect(1, 127488, '\P{_in_ENCLOSED_Alphanumeric_Supplement}', "");
    Expect(0, 127488, '\P{^_in_ENCLOSED_Alphanumeric_Supplement}', "");
    Error('\p{-/a/Enclosed_ALPHANUM_SUP}');
    Error('\P{-/a/Enclosed_ALPHANUM_SUP}');
    Expect(1, 127487, '\p{enclosedalphanumsup}', "");
    Expect(0, 127487, '\p{^enclosedalphanumsup}', "");
    Expect(0, 127487, '\P{enclosedalphanumsup}', "");
    Expect(1, 127487, '\P{^enclosedalphanumsup}', "");
    Expect(0, 127488, '\p{enclosedalphanumsup}', "");
    Expect(1, 127488, '\p{^enclosedalphanumsup}', "");
    Expect(1, 127488, '\P{enclosedalphanumsup}', "");
    Expect(0, 127488, '\P{^enclosedalphanumsup}', "");
    Expect(1, 127487, '\p{ -enclosed_Alphanum_sup}', "");
    Expect(0, 127487, '\p{^ -enclosed_Alphanum_sup}', "");
    Expect(0, 127487, '\P{ -enclosed_Alphanum_sup}', "");
    Expect(1, 127487, '\P{^ -enclosed_Alphanum_sup}', "");
    Expect(0, 127488, '\p{ -enclosed_Alphanum_sup}', "");
    Expect(1, 127488, '\p{^ -enclosed_Alphanum_sup}', "");
    Expect(1, 127488, '\P{ -enclosed_Alphanum_sup}', "");
    Expect(0, 127488, '\P{^ -enclosed_Alphanum_sup}', "");
    Error('\p{ :=IS_Enclosed_Alphanum_SUP}');
    Error('\P{ :=IS_Enclosed_Alphanum_SUP}');
    Expect(1, 127487, '\p{isenclosedalphanumsup}', "");
    Expect(0, 127487, '\p{^isenclosedalphanumsup}', "");
    Expect(0, 127487, '\P{isenclosedalphanumsup}', "");
    Expect(1, 127487, '\P{^isenclosedalphanumsup}', "");
    Expect(0, 127488, '\p{isenclosedalphanumsup}', "");
    Expect(1, 127488, '\p{^isenclosedalphanumsup}', "");
    Expect(1, 127488, '\P{isenclosedalphanumsup}', "");
    Expect(0, 127488, '\P{^isenclosedalphanumsup}', "");
    Expect(1, 127487, '\p{Is_enclosed_ALPHANUM_Sup}', "");
    Expect(0, 127487, '\p{^Is_enclosed_ALPHANUM_Sup}', "");
    Expect(0, 127487, '\P{Is_enclosed_ALPHANUM_Sup}', "");
    Expect(1, 127487, '\P{^Is_enclosed_ALPHANUM_Sup}', "");
    Expect(0, 127488, '\p{Is_enclosed_ALPHANUM_Sup}', "");
    Expect(1, 127488, '\p{^Is_enclosed_ALPHANUM_Sup}', "");
    Expect(1, 127488, '\P{Is_enclosed_ALPHANUM_Sup}', "");
    Expect(0, 127488, '\P{^Is_enclosed_ALPHANUM_Sup}', "");
    Error('\p{:=In_ENCLOSED_Alphanum_sup}');
    Error('\P{:=In_ENCLOSED_Alphanum_sup}');
    Expect(1, 127487, '\p{inenclosedalphanumsup}', "");
    Expect(0, 127487, '\p{^inenclosedalphanumsup}', "");
    Expect(0, 127487, '\P{inenclosedalphanumsup}', "");
    Expect(1, 127487, '\P{^inenclosedalphanumsup}', "");
    Expect(0, 127488, '\p{inenclosedalphanumsup}', "");
    Expect(1, 127488, '\p{^inenclosedalphanumsup}', "");
    Expect(1, 127488, '\P{inenclosedalphanumsup}', "");
    Expect(0, 127488, '\P{^inenclosedalphanumsup}', "");
    Expect(1, 127487, '\p{-In_Enclosed_Alphanum_Sup}', "");
    Expect(0, 127487, '\p{^-In_Enclosed_Alphanum_Sup}', "");
    Expect(0, 127487, '\P{-In_Enclosed_Alphanum_Sup}', "");
    Expect(1, 127487, '\P{^-In_Enclosed_Alphanum_Sup}', "");
    Expect(0, 127488, '\p{-In_Enclosed_Alphanum_Sup}', "");
    Expect(1, 127488, '\p{^-In_Enclosed_Alphanum_Sup}', "");
    Expect(1, 127488, '\P{-In_Enclosed_Alphanum_Sup}', "");
    Expect(0, 127488, '\P{^-In_Enclosed_Alphanum_Sup}', "");
    Error('\p{	/a/enclosed_Alphanumerics}');
    Error('\P{	/a/enclosed_Alphanumerics}');
    Expect(1, 9471, '\p{enclosedalphanumerics}', "");
    Expect(0, 9471, '\p{^enclosedalphanumerics}', "");
    Expect(0, 9471, '\P{enclosedalphanumerics}', "");
    Expect(1, 9471, '\P{^enclosedalphanumerics}', "");
    Expect(0, 9472, '\p{enclosedalphanumerics}', "");
    Expect(1, 9472, '\p{^enclosedalphanumerics}', "");
    Expect(1, 9472, '\P{enclosedalphanumerics}', "");
    Expect(0, 9472, '\P{^enclosedalphanumerics}', "");
    Expect(1, 9471, '\p{-_ENCLOSED_alphanumerics}', "");
    Expect(0, 9471, '\p{^-_ENCLOSED_alphanumerics}', "");
    Expect(0, 9471, '\P{-_ENCLOSED_alphanumerics}', "");
    Expect(1, 9471, '\P{^-_ENCLOSED_alphanumerics}', "");
    Expect(0, 9472, '\p{-_ENCLOSED_alphanumerics}', "");
    Expect(1, 9472, '\p{^-_ENCLOSED_alphanumerics}', "");
    Expect(1, 9472, '\P{-_ENCLOSED_alphanumerics}', "");
    Expect(0, 9472, '\P{^-_ENCLOSED_alphanumerics}', "");
    Error('\p{_Is_Enclosed_Alphanumerics:=}');
    Error('\P{_Is_Enclosed_Alphanumerics:=}');
    Expect(1, 9471, '\p{isenclosedalphanumerics}', "");
    Expect(0, 9471, '\p{^isenclosedalphanumerics}', "");
    Expect(0, 9471, '\P{isenclosedalphanumerics}', "");
    Expect(1, 9471, '\P{^isenclosedalphanumerics}', "");
    Expect(0, 9472, '\p{isenclosedalphanumerics}', "");
    Expect(1, 9472, '\p{^isenclosedalphanumerics}', "");
    Expect(1, 9472, '\P{isenclosedalphanumerics}', "");
    Expect(0, 9472, '\P{^isenclosedalphanumerics}', "");
    Expect(1, 9471, '\p{-_Is_Enclosed_ALPHANUMERICS}', "");
    Expect(0, 9471, '\p{^-_Is_Enclosed_ALPHANUMERICS}', "");
    Expect(0, 9471, '\P{-_Is_Enclosed_ALPHANUMERICS}', "");
    Expect(1, 9471, '\P{^-_Is_Enclosed_ALPHANUMERICS}', "");
    Expect(0, 9472, '\p{-_Is_Enclosed_ALPHANUMERICS}', "");
    Expect(1, 9472, '\p{^-_Is_Enclosed_ALPHANUMERICS}', "");
    Expect(1, 9472, '\P{-_Is_Enclosed_ALPHANUMERICS}', "");
    Expect(0, 9472, '\P{^-_Is_Enclosed_ALPHANUMERICS}', "");
    Error('\p{/a/_In_ENCLOSED_Alphanumerics}');
    Error('\P{/a/_In_ENCLOSED_Alphanumerics}');
    Expect(1, 9471, '\p{inenclosedalphanumerics}', "");
    Expect(0, 9471, '\p{^inenclosedalphanumerics}', "");
    Expect(0, 9471, '\P{inenclosedalphanumerics}', "");
    Expect(1, 9471, '\P{^inenclosedalphanumerics}', "");
    Expect(0, 9472, '\p{inenclosedalphanumerics}', "");
    Expect(1, 9472, '\p{^inenclosedalphanumerics}', "");
    Expect(1, 9472, '\P{inenclosedalphanumerics}', "");
    Expect(0, 9472, '\P{^inenclosedalphanumerics}', "");
    Expect(1, 9471, '\p{ 	In_Enclosed_ALPHANUMERICS}', "");
    Expect(0, 9471, '\p{^ 	In_Enclosed_ALPHANUMERICS}', "");
    Expect(0, 9471, '\P{ 	In_Enclosed_ALPHANUMERICS}', "");
    Expect(1, 9471, '\P{^ 	In_Enclosed_ALPHANUMERICS}', "");
    Expect(0, 9472, '\p{ 	In_Enclosed_ALPHANUMERICS}', "");
    Expect(1, 9472, '\p{^ 	In_Enclosed_ALPHANUMERICS}', "");
    Expect(1, 9472, '\P{ 	In_Enclosed_ALPHANUMERICS}', "");
    Expect(0, 9472, '\P{^ 	In_Enclosed_ALPHANUMERICS}', "");
    Error('\p{_-enclosed_ALPHANUM:=}');
    Error('\P{_-enclosed_ALPHANUM:=}');
    Expect(1, 9471, '\p{enclosedalphanum}', "");
    Expect(0, 9471, '\p{^enclosedalphanum}', "");
    Expect(0, 9471, '\P{enclosedalphanum}', "");
    Expect(1, 9471, '\P{^enclosedalphanum}', "");
    Expect(0, 9472, '\p{enclosedalphanum}', "");
    Expect(1, 9472, '\p{^enclosedalphanum}', "");
    Expect(1, 9472, '\P{enclosedalphanum}', "");
    Expect(0, 9472, '\P{^enclosedalphanum}', "");
    Expect(1, 9471, '\p{_-enclosed_alphanum}', "");
    Expect(0, 9471, '\p{^_-enclosed_alphanum}', "");
    Expect(0, 9471, '\P{_-enclosed_alphanum}', "");
    Expect(1, 9471, '\P{^_-enclosed_alphanum}', "");
    Expect(0, 9472, '\p{_-enclosed_alphanum}', "");
    Expect(1, 9472, '\p{^_-enclosed_alphanum}', "");
    Expect(1, 9472, '\P{_-enclosed_alphanum}', "");
    Expect(0, 9472, '\P{^_-enclosed_alphanum}', "");
    Error('\p{:=	Is_enclosed_Alphanum}');
    Error('\P{:=	Is_enclosed_Alphanum}');
    Expect(1, 9471, '\p{isenclosedalphanum}', "");
    Expect(0, 9471, '\p{^isenclosedalphanum}', "");
    Expect(0, 9471, '\P{isenclosedalphanum}', "");
    Expect(1, 9471, '\P{^isenclosedalphanum}', "");
    Expect(0, 9472, '\p{isenclosedalphanum}', "");
    Expect(1, 9472, '\p{^isenclosedalphanum}', "");
    Expect(1, 9472, '\P{isenclosedalphanum}', "");
    Expect(0, 9472, '\P{^isenclosedalphanum}', "");
    Expect(1, 9471, '\p{Is_ENCLOSED_Alphanum}', "");
    Expect(0, 9471, '\p{^Is_ENCLOSED_Alphanum}', "");
    Expect(0, 9471, '\P{Is_ENCLOSED_Alphanum}', "");
    Expect(1, 9471, '\P{^Is_ENCLOSED_Alphanum}', "");
    Expect(0, 9472, '\p{Is_ENCLOSED_Alphanum}', "");
    Expect(1, 9472, '\p{^Is_ENCLOSED_Alphanum}', "");
    Expect(1, 9472, '\P{Is_ENCLOSED_Alphanum}', "");
    Expect(0, 9472, '\P{^Is_ENCLOSED_Alphanum}', "");
    Error('\p{-:=IN_Enclosed_alphanum}');
    Error('\P{-:=IN_Enclosed_alphanum}');
    Expect(1, 9471, '\p{inenclosedalphanum}', "");
    Expect(0, 9471, '\p{^inenclosedalphanum}', "");
    Expect(0, 9471, '\P{inenclosedalphanum}', "");
    Expect(1, 9471, '\P{^inenclosedalphanum}', "");
    Expect(0, 9472, '\p{inenclosedalphanum}', "");
    Expect(1, 9472, '\p{^inenclosedalphanum}', "");
    Expect(1, 9472, '\P{inenclosedalphanum}', "");
    Expect(0, 9472, '\P{^inenclosedalphanum}', "");
    Expect(1, 9471, '\p{	In_enclosed_ALPHANUM}', "");
    Expect(0, 9471, '\p{^	In_enclosed_ALPHANUM}', "");
    Expect(0, 9471, '\P{	In_enclosed_ALPHANUM}', "");
    Expect(1, 9471, '\P{^	In_enclosed_ALPHANUM}', "");
    Expect(0, 9472, '\p{	In_enclosed_ALPHANUM}', "");
    Expect(1, 9472, '\p{^	In_enclosed_ALPHANUM}', "");
    Expect(1, 9472, '\P{	In_enclosed_ALPHANUM}', "");
    Expect(0, 9472, '\P{^	In_enclosed_ALPHANUM}', "");
    Error('\p{/a/Enclosed_CJK_Letters_and_months}');
    Error('\P{/a/Enclosed_CJK_Letters_and_months}');
    Expect(1, 13055, '\p{enclosedcjklettersandmonths}', "");
    Expect(0, 13055, '\p{^enclosedcjklettersandmonths}', "");
    Expect(0, 13055, '\P{enclosedcjklettersandmonths}', "");
    Expect(1, 13055, '\P{^enclosedcjklettersandmonths}', "");
    Expect(0, 13056, '\p{enclosedcjklettersandmonths}', "");
    Expect(1, 13056, '\p{^enclosedcjklettersandmonths}', "");
    Expect(1, 13056, '\P{enclosedcjklettersandmonths}', "");
    Expect(0, 13056, '\P{^enclosedcjklettersandmonths}', "");
    Expect(1, 13055, '\p{__Enclosed_CJK_Letters_And_Months}', "");
    Expect(0, 13055, '\p{^__Enclosed_CJK_Letters_And_Months}', "");
    Expect(0, 13055, '\P{__Enclosed_CJK_Letters_And_Months}', "");
    Expect(1, 13055, '\P{^__Enclosed_CJK_Letters_And_Months}', "");
    Expect(0, 13056, '\p{__Enclosed_CJK_Letters_And_Months}', "");
    Expect(1, 13056, '\p{^__Enclosed_CJK_Letters_And_Months}', "");
    Expect(1, 13056, '\P{__Enclosed_CJK_Letters_And_Months}', "");
    Expect(0, 13056, '\P{^__Enclosed_CJK_Letters_And_Months}', "");
    Error('\p{	Is_Enclosed_cjk_Letters_AND_Months/a/}');
    Error('\P{	Is_Enclosed_cjk_Letters_AND_Months/a/}');
    Expect(1, 13055, '\p{isenclosedcjklettersandmonths}', "");
    Expect(0, 13055, '\p{^isenclosedcjklettersandmonths}', "");
    Expect(0, 13055, '\P{isenclosedcjklettersandmonths}', "");
    Expect(1, 13055, '\P{^isenclosedcjklettersandmonths}', "");
    Expect(0, 13056, '\p{isenclosedcjklettersandmonths}', "");
    Expect(1, 13056, '\p{^isenclosedcjklettersandmonths}', "");
    Expect(1, 13056, '\P{isenclosedcjklettersandmonths}', "");
    Expect(0, 13056, '\P{^isenclosedcjklettersandmonths}', "");
    Expect(1, 13055, '\p{__IS_enclosed_CJK_Letters_and_MONTHS}', "");
    Expect(0, 13055, '\p{^__IS_enclosed_CJK_Letters_and_MONTHS}', "");
    Expect(0, 13055, '\P{__IS_enclosed_CJK_Letters_and_MONTHS}', "");
    Expect(1, 13055, '\P{^__IS_enclosed_CJK_Letters_and_MONTHS}', "");
    Expect(0, 13056, '\p{__IS_enclosed_CJK_Letters_and_MONTHS}', "");
    Expect(1, 13056, '\p{^__IS_enclosed_CJK_Letters_and_MONTHS}', "");
    Expect(1, 13056, '\P{__IS_enclosed_CJK_Letters_and_MONTHS}', "");
    Expect(0, 13056, '\P{^__IS_enclosed_CJK_Letters_and_MONTHS}', "");
    Error('\p{	:=In_ENCLOSED_CJK_Letters_And_MONTHS}');
    Error('\P{	:=In_ENCLOSED_CJK_Letters_And_MONTHS}');
    Expect(1, 13055, '\p{inenclosedcjklettersandmonths}', "");
    Expect(0, 13055, '\p{^inenclosedcjklettersandmonths}', "");
    Expect(0, 13055, '\P{inenclosedcjklettersandmonths}', "");
    Expect(1, 13055, '\P{^inenclosedcjklettersandmonths}', "");
    Expect(0, 13056, '\p{inenclosedcjklettersandmonths}', "");
    Expect(1, 13056, '\p{^inenclosedcjklettersandmonths}', "");
    Expect(1, 13056, '\P{inenclosedcjklettersandmonths}', "");
    Expect(0, 13056, '\P{^inenclosedcjklettersandmonths}', "");
    Expect(1, 13055, '\p{_In_enclosed_cjk_Letters_AND_Months}', "");
    Expect(0, 13055, '\p{^_In_enclosed_cjk_Letters_AND_Months}', "");
    Expect(0, 13055, '\P{_In_enclosed_cjk_Letters_AND_Months}', "");
    Expect(1, 13055, '\P{^_In_enclosed_cjk_Letters_AND_Months}', "");
    Expect(0, 13056, '\p{_In_enclosed_cjk_Letters_AND_Months}', "");
    Expect(1, 13056, '\p{^_In_enclosed_cjk_Letters_AND_Months}', "");
    Expect(1, 13056, '\P{_In_enclosed_cjk_Letters_AND_Months}', "");
    Expect(0, 13056, '\P{^_In_enclosed_cjk_Letters_AND_Months}', "");
    Error('\p{:=Enclosed_CJK}');
    Error('\P{:=Enclosed_CJK}');
    Expect(1, 13055, '\p{enclosedcjk}', "");
    Expect(0, 13055, '\p{^enclosedcjk}', "");
    Expect(0, 13055, '\P{enclosedcjk}', "");
    Expect(1, 13055, '\P{^enclosedcjk}', "");
    Expect(0, 13056, '\p{enclosedcjk}', "");
    Expect(1, 13056, '\p{^enclosedcjk}', "");
    Expect(1, 13056, '\P{enclosedcjk}', "");
    Expect(0, 13056, '\P{^enclosedcjk}', "");
    Expect(1, 13055, '\p{ Enclosed_cjk}', "");
    Expect(0, 13055, '\p{^ Enclosed_cjk}', "");
    Expect(0, 13055, '\P{ Enclosed_cjk}', "");
    Expect(1, 13055, '\P{^ Enclosed_cjk}', "");
    Expect(0, 13056, '\p{ Enclosed_cjk}', "");
    Expect(1, 13056, '\p{^ Enclosed_cjk}', "");
    Expect(1, 13056, '\P{ Enclosed_cjk}', "");
    Expect(0, 13056, '\P{^ Enclosed_cjk}', "");
    Error('\p{/a/Is_Enclosed_CJK}');
    Error('\P{/a/Is_Enclosed_CJK}');
    Expect(1, 13055, '\p{isenclosedcjk}', "");
    Expect(0, 13055, '\p{^isenclosedcjk}', "");
    Expect(0, 13055, '\P{isenclosedcjk}', "");
    Expect(1, 13055, '\P{^isenclosedcjk}', "");
    Expect(0, 13056, '\p{isenclosedcjk}', "");
    Expect(1, 13056, '\p{^isenclosedcjk}', "");
    Expect(1, 13056, '\P{isenclosedcjk}', "");
    Expect(0, 13056, '\P{^isenclosedcjk}', "");
    Expect(1, 13055, '\p{	 IS_ENCLOSED_CJK}', "");
    Expect(0, 13055, '\p{^	 IS_ENCLOSED_CJK}', "");
    Expect(0, 13055, '\P{	 IS_ENCLOSED_CJK}', "");
    Expect(1, 13055, '\P{^	 IS_ENCLOSED_CJK}', "");
    Expect(0, 13056, '\p{	 IS_ENCLOSED_CJK}', "");
    Expect(1, 13056, '\p{^	 IS_ENCLOSED_CJK}', "");
    Expect(1, 13056, '\P{	 IS_ENCLOSED_CJK}', "");
    Expect(0, 13056, '\P{^	 IS_ENCLOSED_CJK}', "");
    Error('\p{	:=In_Enclosed_CJK}');
    Error('\P{	:=In_Enclosed_CJK}');
    Expect(1, 13055, '\p{inenclosedcjk}', "");
    Expect(0, 13055, '\p{^inenclosedcjk}', "");
    Expect(0, 13055, '\P{inenclosedcjk}', "");
    Expect(1, 13055, '\P{^inenclosedcjk}', "");
    Expect(0, 13056, '\p{inenclosedcjk}', "");
    Expect(1, 13056, '\p{^inenclosedcjk}', "");
    Expect(1, 13056, '\P{inenclosedcjk}', "");
    Expect(0, 13056, '\P{^inenclosedcjk}', "");
    Expect(1, 13055, '\p{-In_Enclosed_CJK}', "");
    Expect(0, 13055, '\p{^-In_Enclosed_CJK}', "");
    Expect(0, 13055, '\P{-In_Enclosed_CJK}', "");
    Expect(1, 13055, '\P{^-In_Enclosed_CJK}', "");
    Expect(0, 13056, '\p{-In_Enclosed_CJK}', "");
    Expect(1, 13056, '\p{^-In_Enclosed_CJK}', "");
    Expect(1, 13056, '\P{-In_Enclosed_CJK}', "");
    Expect(0, 13056, '\P{^-In_Enclosed_CJK}', "");
    Error('\p{:=_ Enclosed_IDEOGRAPHIC_supplement}');
    Error('\P{:=_ Enclosed_IDEOGRAPHIC_supplement}');
    Expect(1, 127743, '\p{enclosedideographicsupplement}', "");
    Expect(0, 127743, '\p{^enclosedideographicsupplement}', "");
    Expect(0, 127743, '\P{enclosedideographicsupplement}', "");
    Expect(1, 127743, '\P{^enclosedideographicsupplement}', "");
    Expect(0, 127744, '\p{enclosedideographicsupplement}', "");
    Expect(1, 127744, '\p{^enclosedideographicsupplement}', "");
    Expect(1, 127744, '\P{enclosedideographicsupplement}', "");
    Expect(0, 127744, '\P{^enclosedideographicsupplement}', "");
    Expect(1, 127743, '\p{ 	Enclosed_Ideographic_Supplement}', "");
    Expect(0, 127743, '\p{^ 	Enclosed_Ideographic_Supplement}', "");
    Expect(0, 127743, '\P{ 	Enclosed_Ideographic_Supplement}', "");
    Expect(1, 127743, '\P{^ 	Enclosed_Ideographic_Supplement}', "");
    Expect(0, 127744, '\p{ 	Enclosed_Ideographic_Supplement}', "");
    Expect(1, 127744, '\p{^ 	Enclosed_Ideographic_Supplement}', "");
    Expect(1, 127744, '\P{ 	Enclosed_Ideographic_Supplement}', "");
    Expect(0, 127744, '\P{^ 	Enclosed_Ideographic_Supplement}', "");
    Error('\p{-/a/Is_enclosed_ideographic_supplement}');
    Error('\P{-/a/Is_enclosed_ideographic_supplement}');
    Expect(1, 127743, '\p{isenclosedideographicsupplement}', "");
    Expect(0, 127743, '\p{^isenclosedideographicsupplement}', "");
    Expect(0, 127743, '\P{isenclosedideographicsupplement}', "");
    Expect(1, 127743, '\P{^isenclosedideographicsupplement}', "");
    Expect(0, 127744, '\p{isenclosedideographicsupplement}', "");
    Expect(1, 127744, '\p{^isenclosedideographicsupplement}', "");
    Expect(1, 127744, '\P{isenclosedideographicsupplement}', "");
    Expect(0, 127744, '\P{^isenclosedideographicsupplement}', "");
    Expect(1, 127743, '\p{__IS_Enclosed_Ideographic_SUPPLEMENT}', "");
    Expect(0, 127743, '\p{^__IS_Enclosed_Ideographic_SUPPLEMENT}', "");
    Expect(0, 127743, '\P{__IS_Enclosed_Ideographic_SUPPLEMENT}', "");
    Expect(1, 127743, '\P{^__IS_Enclosed_Ideographic_SUPPLEMENT}', "");
    Expect(0, 127744, '\p{__IS_Enclosed_Ideographic_SUPPLEMENT}', "");
    Expect(1, 127744, '\p{^__IS_Enclosed_Ideographic_SUPPLEMENT}', "");
    Expect(1, 127744, '\P{__IS_Enclosed_Ideographic_SUPPLEMENT}', "");
    Expect(0, 127744, '\P{^__IS_Enclosed_Ideographic_SUPPLEMENT}', "");
    Error('\p{	-In_enclosed_ideographic_Supplement/a/}');
    Error('\P{	-In_enclosed_ideographic_Supplement/a/}');
    Expect(1, 127743, '\p{inenclosedideographicsupplement}', "");
    Expect(0, 127743, '\p{^inenclosedideographicsupplement}', "");
    Expect(0, 127743, '\P{inenclosedideographicsupplement}', "");
    Expect(1, 127743, '\P{^inenclosedideographicsupplement}', "");
    Expect(0, 127744, '\p{inenclosedideographicsupplement}', "");
    Expect(1, 127744, '\p{^inenclosedideographicsupplement}', "");
    Expect(1, 127744, '\P{inenclosedideographicsupplement}', "");
    Expect(0, 127744, '\P{^inenclosedideographicsupplement}', "");
    Expect(1, 127743, '\p{	in_Enclosed_Ideographic_Supplement}', "");
    Expect(0, 127743, '\p{^	in_Enclosed_Ideographic_Supplement}', "");
    Expect(0, 127743, '\P{	in_Enclosed_Ideographic_Supplement}', "");
    Expect(1, 127743, '\P{^	in_Enclosed_Ideographic_Supplement}', "");
    Expect(0, 127744, '\p{	in_Enclosed_Ideographic_Supplement}', "");
    Expect(1, 127744, '\p{^	in_Enclosed_Ideographic_Supplement}', "");
    Expect(1, 127744, '\P{	in_Enclosed_Ideographic_Supplement}', "");
    Expect(0, 127744, '\P{^	in_Enclosed_Ideographic_Supplement}', "");
    Error('\p{/a/_-Enclosed_Ideographic_Sup}');
    Error('\P{/a/_-Enclosed_Ideographic_Sup}');
    Expect(1, 127743, '\p{enclosedideographicsup}', "");
    Expect(0, 127743, '\p{^enclosedideographicsup}', "");
    Expect(0, 127743, '\P{enclosedideographicsup}', "");
    Expect(1, 127743, '\P{^enclosedideographicsup}', "");
    Expect(0, 127744, '\p{enclosedideographicsup}', "");
    Expect(1, 127744, '\p{^enclosedideographicsup}', "");
    Expect(1, 127744, '\P{enclosedideographicsup}', "");
    Expect(0, 127744, '\P{^enclosedideographicsup}', "");
    Expect(1, 127743, '\p{- enclosed_Ideographic_Sup}', "");
    Expect(0, 127743, '\p{^- enclosed_Ideographic_Sup}', "");
    Expect(0, 127743, '\P{- enclosed_Ideographic_Sup}', "");
    Expect(1, 127743, '\P{^- enclosed_Ideographic_Sup}', "");
    Expect(0, 127744, '\p{- enclosed_Ideographic_Sup}', "");
    Expect(1, 127744, '\p{^- enclosed_Ideographic_Sup}', "");
    Expect(1, 127744, '\P{- enclosed_Ideographic_Sup}', "");
    Expect(0, 127744, '\P{^- enclosed_Ideographic_Sup}', "");
    Error('\p{:=	_Is_Enclosed_Ideographic_sup}');
    Error('\P{:=	_Is_Enclosed_Ideographic_sup}');
    Expect(1, 127743, '\p{isenclosedideographicsup}', "");
    Expect(0, 127743, '\p{^isenclosedideographicsup}', "");
    Expect(0, 127743, '\P{isenclosedideographicsup}', "");
    Expect(1, 127743, '\P{^isenclosedideographicsup}', "");
    Expect(0, 127744, '\p{isenclosedideographicsup}', "");
    Expect(1, 127744, '\p{^isenclosedideographicsup}', "");
    Expect(1, 127744, '\P{isenclosedideographicsup}', "");
    Expect(0, 127744, '\P{^isenclosedideographicsup}', "");
    Expect(1, 127743, '\p{		Is_Enclosed_ideographic_SUP}', "");
    Expect(0, 127743, '\p{^		Is_Enclosed_ideographic_SUP}', "");
    Expect(0, 127743, '\P{		Is_Enclosed_ideographic_SUP}', "");
    Expect(1, 127743, '\P{^		Is_Enclosed_ideographic_SUP}', "");
    Expect(0, 127744, '\p{		Is_Enclosed_ideographic_SUP}', "");
    Expect(1, 127744, '\p{^		Is_Enclosed_ideographic_SUP}', "");
    Expect(1, 127744, '\P{		Is_Enclosed_ideographic_SUP}', "");
    Expect(0, 127744, '\P{^		Is_Enclosed_ideographic_SUP}', "");
    Error('\p{:=  In_ENCLOSED_IDEOGRAPHIC_Sup}');
    Error('\P{:=  In_ENCLOSED_IDEOGRAPHIC_Sup}');
    Expect(1, 127743, '\p{inenclosedideographicsup}', "");
    Expect(0, 127743, '\p{^inenclosedideographicsup}', "");
    Expect(0, 127743, '\P{inenclosedideographicsup}', "");
    Expect(1, 127743, '\P{^inenclosedideographicsup}', "");
    Expect(0, 127744, '\p{inenclosedideographicsup}', "");
    Expect(1, 127744, '\p{^inenclosedideographicsup}', "");
    Expect(1, 127744, '\P{inenclosedideographicsup}', "");
    Expect(0, 127744, '\P{^inenclosedideographicsup}', "");
    Expect(1, 127743, '\p{ in_enclosed_IDEOGRAPHIC_SUP}', "");
    Expect(0, 127743, '\p{^ in_enclosed_IDEOGRAPHIC_SUP}', "");
    Expect(0, 127743, '\P{ in_enclosed_IDEOGRAPHIC_SUP}', "");
    Expect(1, 127743, '\P{^ in_enclosed_IDEOGRAPHIC_SUP}', "");
    Expect(0, 127744, '\p{ in_enclosed_IDEOGRAPHIC_SUP}', "");
    Expect(1, 127744, '\p{^ in_enclosed_IDEOGRAPHIC_SUP}', "");
    Expect(1, 127744, '\P{ in_enclosed_IDEOGRAPHIC_SUP}', "");
    Expect(0, 127744, '\P{^ in_enclosed_IDEOGRAPHIC_SUP}', "");
    Error('\p{ Enclosing_MARK/a/}');
    Error('\P{ Enclosing_MARK/a/}');
    Expect(1, 42610, '\p{enclosingmark}', "");
    Expect(0, 42610, '\p{^enclosingmark}', "");
    Expect(0, 42610, '\P{enclosingmark}', "");
    Expect(1, 42610, '\P{^enclosingmark}', "");
    Expect(0, 42611, '\p{enclosingmark}', "");
    Expect(1, 42611, '\p{^enclosingmark}', "");
    Expect(1, 42611, '\P{enclosingmark}', "");
    Expect(0, 42611, '\P{^enclosingmark}', "");
    Expect(1, 42610, '\p{	_Enclosing_MARK}', "");
    Expect(0, 42610, '\p{^	_Enclosing_MARK}', "");
    Expect(0, 42610, '\P{	_Enclosing_MARK}', "");
    Expect(1, 42610, '\P{^	_Enclosing_MARK}', "");
    Expect(0, 42611, '\p{	_Enclosing_MARK}', "");
    Expect(1, 42611, '\p{^	_Enclosing_MARK}', "");
    Expect(1, 42611, '\P{	_Enclosing_MARK}', "");
    Expect(0, 42611, '\P{^	_Enclosing_MARK}', "");
    Error('\p{-	Is_Enclosing_MARK/a/}');
    Error('\P{-	Is_Enclosing_MARK/a/}');
    Expect(1, 42610, '\p{isenclosingmark}', "");
    Expect(0, 42610, '\p{^isenclosingmark}', "");
    Expect(0, 42610, '\P{isenclosingmark}', "");
    Expect(1, 42610, '\P{^isenclosingmark}', "");
    Expect(0, 42611, '\p{isenclosingmark}', "");
    Expect(1, 42611, '\p{^isenclosingmark}', "");
    Expect(1, 42611, '\P{isenclosingmark}', "");
    Expect(0, 42611, '\P{^isenclosingmark}', "");
    Expect(1, 42610, '\p{_Is_Enclosing_Mark}', "");
    Expect(0, 42610, '\p{^_Is_Enclosing_Mark}', "");
    Expect(0, 42610, '\P{_Is_Enclosing_Mark}', "");
    Expect(1, 42610, '\P{^_Is_Enclosing_Mark}', "");
    Expect(0, 42611, '\p{_Is_Enclosing_Mark}', "");
    Expect(1, 42611, '\p{^_Is_Enclosing_Mark}', "");
    Expect(1, 42611, '\P{_Is_Enclosing_Mark}', "");
    Expect(0, 42611, '\P{^_Is_Enclosing_Mark}', "");
    Error('\p{:=__Me}');
    Error('\P{:=__Me}');
    Expect(1, 42610, '\p{me}', "");
    Expect(0, 42610, '\p{^me}', "");
    Expect(0, 42610, '\P{me}', "");
    Expect(1, 42610, '\P{^me}', "");
    Expect(0, 42611, '\p{me}', "");
    Expect(1, 42611, '\p{^me}', "");
    Expect(1, 42611, '\P{me}', "");
    Expect(0, 42611, '\P{^me}', "");
    Expect(1, 42610, '\p{_-Me}', "");
    Expect(0, 42610, '\p{^_-Me}', "");
    Expect(0, 42610, '\P{_-Me}', "");
    Expect(1, 42610, '\P{^_-Me}', "");
    Expect(0, 42611, '\p{_-Me}', "");
    Expect(1, 42611, '\p{^_-Me}', "");
    Expect(1, 42611, '\P{_-Me}', "");
    Expect(0, 42611, '\P{^_-Me}', "");
    Error('\p{/a/_ Is_ME}');
    Error('\P{/a/_ Is_ME}');
    Expect(1, 42610, '\p{isme}', "");
    Expect(0, 42610, '\p{^isme}', "");
    Expect(0, 42610, '\P{isme}', "");
    Expect(1, 42610, '\P{^isme}', "");
    Expect(0, 42611, '\p{isme}', "");
    Expect(1, 42611, '\p{^isme}', "");
    Expect(1, 42611, '\P{isme}', "");
    Expect(0, 42611, '\P{^isme}', "");
    Expect(1, 42610, '\p{_-IS_me}', "");
    Expect(0, 42610, '\p{^_-IS_me}', "");
    Expect(0, 42610, '\P{_-IS_me}', "");
    Expect(1, 42610, '\P{^_-IS_me}', "");
    Expect(0, 42611, '\p{_-IS_me}', "");
    Expect(1, 42611, '\p{^_-IS_me}', "");
    Expect(1, 42611, '\P{_-IS_me}', "");
    Expect(0, 42611, '\P{^_-IS_me}', "");
    Error('\p{ /a/ETHIOPIC}');
    Error('\P{ /a/ETHIOPIC}');
    Expect(1, 124926, '\p{ethiopic}', "");
    Expect(0, 124926, '\p{^ethiopic}', "");
    Expect(0, 124926, '\P{ethiopic}', "");
    Expect(1, 124926, '\P{^ethiopic}', "");
    Expect(0, 124927, '\p{ethiopic}', "");
    Expect(1, 124927, '\p{^ethiopic}', "");
    Expect(1, 124927, '\P{ethiopic}', "");
    Expect(0, 124927, '\P{^ethiopic}', "");
    Expect(1, 124926, '\p{- ethiopic}', "");
    Expect(0, 124926, '\p{^- ethiopic}', "");
    Expect(0, 124926, '\P{- ethiopic}', "");
    Expect(1, 124926, '\P{^- ethiopic}', "");
    Expect(0, 124927, '\p{- ethiopic}', "");
    Expect(1, 124927, '\p{^- ethiopic}', "");
    Expect(1, 124927, '\P{- ethiopic}', "");
    Expect(0, 124927, '\P{^- ethiopic}', "");
    Error('\p{ is_Ethiopic/a/}');
    Error('\P{ is_Ethiopic/a/}');
    Expect(1, 124926, '\p{isethiopic}', "");
    Expect(0, 124926, '\p{^isethiopic}', "");
    Expect(0, 124926, '\P{isethiopic}', "");
    Expect(1, 124926, '\P{^isethiopic}', "");
    Expect(0, 124927, '\p{isethiopic}', "");
    Expect(1, 124927, '\p{^isethiopic}', "");
    Expect(1, 124927, '\P{isethiopic}', "");
    Expect(0, 124927, '\P{^isethiopic}', "");
    Expect(1, 124926, '\p{	Is_Ethiopic}', "");
    Expect(0, 124926, '\p{^	Is_Ethiopic}', "");
    Expect(0, 124926, '\P{	Is_Ethiopic}', "");
    Expect(1, 124926, '\P{^	Is_Ethiopic}', "");
    Expect(0, 124927, '\p{	Is_Ethiopic}', "");
    Expect(1, 124927, '\p{^	Is_Ethiopic}', "");
    Expect(1, 124927, '\P{	Is_Ethiopic}', "");
    Expect(0, 124927, '\P{^	Is_Ethiopic}', "");
    Error('\p{ ETHI/a/}');
    Error('\P{ ETHI/a/}');
    Expect(1, 124926, '\p{ethi}', "");
    Expect(0, 124926, '\p{^ethi}', "");
    Expect(0, 124926, '\P{ethi}', "");
    Expect(1, 124926, '\P{^ethi}', "");
    Expect(0, 124927, '\p{ethi}', "");
    Expect(1, 124927, '\p{^ethi}', "");
    Expect(1, 124927, '\P{ethi}', "");
    Expect(0, 124927, '\P{^ethi}', "");
    Expect(1, 124926, '\p{ 	ethi}', "");
    Expect(0, 124926, '\p{^ 	ethi}', "");
    Expect(0, 124926, '\P{ 	ethi}', "");
    Expect(1, 124926, '\P{^ 	ethi}', "");
    Expect(0, 124927, '\p{ 	ethi}', "");
    Expect(1, 124927, '\p{^ 	ethi}', "");
    Expect(1, 124927, '\P{ 	ethi}', "");
    Expect(0, 124927, '\P{^ 	ethi}', "");
    Error('\p{/a/	Is_Ethi}');
    Error('\P{/a/	Is_Ethi}');
    Expect(1, 124926, '\p{isethi}', "");
    Expect(0, 124926, '\p{^isethi}', "");
    Expect(0, 124926, '\P{isethi}', "");
    Expect(1, 124926, '\P{^isethi}', "");
    Expect(0, 124927, '\p{isethi}', "");
    Expect(1, 124927, '\p{^isethi}', "");
    Expect(1, 124927, '\P{isethi}', "");
    Expect(0, 124927, '\P{^isethi}', "");
    Expect(1, 124926, '\p{	IS_Ethi}', "");
    Expect(0, 124926, '\p{^	IS_Ethi}', "");
    Expect(0, 124926, '\P{	IS_Ethi}', "");
    Expect(1, 124926, '\P{^	IS_Ethi}', "");
    Expect(0, 124927, '\p{	IS_Ethi}', "");
    Expect(1, 124927, '\p{^	IS_Ethi}', "");
    Expect(1, 124927, '\P{	IS_Ethi}', "");
    Expect(0, 124927, '\P{^	IS_Ethi}', "");
    Error('\p{_ ETHIOPIC_extended:=}');
    Error('\P{_ ETHIOPIC_extended:=}');
    Expect(1, 11743, '\p{ethiopicextended}', "");
    Expect(0, 11743, '\p{^ethiopicextended}', "");
    Expect(0, 11743, '\P{ethiopicextended}', "");
    Expect(1, 11743, '\P{^ethiopicextended}', "");
    Expect(0, 11744, '\p{ethiopicextended}', "");
    Expect(1, 11744, '\p{^ethiopicextended}', "");
    Expect(1, 11744, '\P{ethiopicextended}', "");
    Expect(0, 11744, '\P{^ethiopicextended}', "");
    Expect(1, 11743, '\p{ -ETHIOPIC_EXTENDED}', "");
    Expect(0, 11743, '\p{^ -ETHIOPIC_EXTENDED}', "");
    Expect(0, 11743, '\P{ -ETHIOPIC_EXTENDED}', "");
    Expect(1, 11743, '\P{^ -ETHIOPIC_EXTENDED}', "");
    Expect(0, 11744, '\p{ -ETHIOPIC_EXTENDED}', "");
    Expect(1, 11744, '\p{^ -ETHIOPIC_EXTENDED}', "");
    Expect(1, 11744, '\P{ -ETHIOPIC_EXTENDED}', "");
    Expect(0, 11744, '\P{^ -ETHIOPIC_EXTENDED}', "");
    Error('\p{_ Is_Ethiopic_EXTENDED:=}');
    Error('\P{_ Is_Ethiopic_EXTENDED:=}');
    Expect(1, 11743, '\p{isethiopicextended}', "");
    Expect(0, 11743, '\p{^isethiopicextended}', "");
    Expect(0, 11743, '\P{isethiopicextended}', "");
    Expect(1, 11743, '\P{^isethiopicextended}', "");
    Expect(0, 11744, '\p{isethiopicextended}', "");
    Expect(1, 11744, '\p{^isethiopicextended}', "");
    Expect(1, 11744, '\P{isethiopicextended}', "");
    Expect(0, 11744, '\P{^isethiopicextended}', "");
    Expect(1, 11743, '\p{ _IS_Ethiopic_extended}', "");
    Expect(0, 11743, '\p{^ _IS_Ethiopic_extended}', "");
    Expect(0, 11743, '\P{ _IS_Ethiopic_extended}', "");
    Expect(1, 11743, '\P{^ _IS_Ethiopic_extended}', "");
    Expect(0, 11744, '\p{ _IS_Ethiopic_extended}', "");
    Expect(1, 11744, '\p{^ _IS_Ethiopic_extended}', "");
    Expect(1, 11744, '\P{ _IS_Ethiopic_extended}', "");
    Expect(0, 11744, '\P{^ _IS_Ethiopic_extended}', "");
    Error('\p{--In_Ethiopic_extended:=}');
    Error('\P{--In_Ethiopic_extended:=}');
    Expect(1, 11743, '\p{inethiopicextended}', "");
    Expect(0, 11743, '\p{^inethiopicextended}', "");
    Expect(0, 11743, '\P{inethiopicextended}', "");
    Expect(1, 11743, '\P{^inethiopicextended}', "");
    Expect(0, 11744, '\p{inethiopicextended}', "");
    Expect(1, 11744, '\p{^inethiopicextended}', "");
    Expect(1, 11744, '\P{inethiopicextended}', "");
    Expect(0, 11744, '\P{^inethiopicextended}', "");
    Expect(1, 11743, '\p{In_Ethiopic_Extended}', "");
    Expect(0, 11743, '\p{^In_Ethiopic_Extended}', "");
    Expect(0, 11743, '\P{In_Ethiopic_Extended}', "");
    Expect(1, 11743, '\P{^In_Ethiopic_Extended}', "");
    Expect(0, 11744, '\p{In_Ethiopic_Extended}', "");
    Expect(1, 11744, '\p{^In_Ethiopic_Extended}', "");
    Expect(1, 11744, '\P{In_Ethiopic_Extended}', "");
    Expect(0, 11744, '\P{^In_Ethiopic_Extended}', "");
    Error('\p{ 	Ethiopic_Ext:=}');
    Error('\P{ 	Ethiopic_Ext:=}');
    Expect(1, 11743, '\p{ethiopicext}', "");
    Expect(0, 11743, '\p{^ethiopicext}', "");
    Expect(0, 11743, '\P{ethiopicext}', "");
    Expect(1, 11743, '\P{^ethiopicext}', "");
    Expect(0, 11744, '\p{ethiopicext}', "");
    Expect(1, 11744, '\p{^ethiopicext}', "");
    Expect(1, 11744, '\P{ethiopicext}', "");
    Expect(0, 11744, '\P{^ethiopicext}', "");
    Expect(1, 11743, '\p{Ethiopic_EXT}', "");
    Expect(0, 11743, '\p{^Ethiopic_EXT}', "");
    Expect(0, 11743, '\P{Ethiopic_EXT}', "");
    Expect(1, 11743, '\P{^Ethiopic_EXT}', "");
    Expect(0, 11744, '\p{Ethiopic_EXT}', "");
    Expect(1, 11744, '\p{^Ethiopic_EXT}', "");
    Expect(1, 11744, '\P{Ethiopic_EXT}', "");
    Expect(0, 11744, '\P{^Ethiopic_EXT}', "");
    Error('\p{/a/_-Is_ethiopic_ext}');
    Error('\P{/a/_-Is_ethiopic_ext}');
    Expect(1, 11743, '\p{isethiopicext}', "");
    Expect(0, 11743, '\p{^isethiopicext}', "");
    Expect(0, 11743, '\P{isethiopicext}', "");
    Expect(1, 11743, '\P{^isethiopicext}', "");
    Expect(0, 11744, '\p{isethiopicext}', "");
    Expect(1, 11744, '\p{^isethiopicext}', "");
    Expect(1, 11744, '\P{isethiopicext}', "");
    Expect(0, 11744, '\P{^isethiopicext}', "");
    Expect(1, 11743, '\p{  Is_Ethiopic_ext}', "");
    Expect(0, 11743, '\p{^  Is_Ethiopic_ext}', "");
    Expect(0, 11743, '\P{  Is_Ethiopic_ext}', "");
    Expect(1, 11743, '\P{^  Is_Ethiopic_ext}', "");
    Expect(0, 11744, '\p{  Is_Ethiopic_ext}', "");
    Expect(1, 11744, '\p{^  Is_Ethiopic_ext}', "");
    Expect(1, 11744, '\P{  Is_Ethiopic_ext}', "");
    Expect(0, 11744, '\P{^  Is_Ethiopic_ext}', "");
    Error('\p{/a/ -In_Ethiopic_Ext}');
    Error('\P{/a/ -In_Ethiopic_Ext}');
    Expect(1, 11743, '\p{inethiopicext}', "");
    Expect(0, 11743, '\p{^inethiopicext}', "");
    Expect(0, 11743, '\P{inethiopicext}', "");
    Expect(1, 11743, '\P{^inethiopicext}', "");
    Expect(0, 11744, '\p{inethiopicext}', "");
    Expect(1, 11744, '\p{^inethiopicext}', "");
    Expect(1, 11744, '\P{inethiopicext}', "");
    Expect(0, 11744, '\P{^inethiopicext}', "");
    Expect(1, 11743, '\p{__In_Ethiopic_ext}', "");
    Expect(0, 11743, '\p{^__In_Ethiopic_ext}', "");
    Expect(0, 11743, '\P{__In_Ethiopic_ext}', "");
    Expect(1, 11743, '\P{^__In_Ethiopic_ext}', "");
    Expect(0, 11744, '\p{__In_Ethiopic_ext}', "");
    Expect(1, 11744, '\p{^__In_Ethiopic_ext}', "");
    Expect(1, 11744, '\P{__In_Ethiopic_ext}', "");
    Expect(0, 11744, '\P{^__In_Ethiopic_ext}', "");
    Error('\p{__ETHIOPIC_Extended_A:=}');
    Error('\P{__ETHIOPIC_Extended_A:=}');
    Expect(1, 43823, '\p{ethiopicextendeda}', "");
    Expect(0, 43823, '\p{^ethiopicextendeda}', "");
    Expect(0, 43823, '\P{ethiopicextendeda}', "");
    Expect(1, 43823, '\P{^ethiopicextendeda}', "");
    Expect(0, 43824, '\p{ethiopicextendeda}', "");
    Expect(1, 43824, '\p{^ethiopicextendeda}', "");
    Expect(1, 43824, '\P{ethiopicextendeda}', "");
    Expect(0, 43824, '\P{^ethiopicextendeda}', "");
    Expect(1, 43823, '\p{ ETHIOPIC_extended_A}', "");
    Expect(0, 43823, '\p{^ ETHIOPIC_extended_A}', "");
    Expect(0, 43823, '\P{ ETHIOPIC_extended_A}', "");
    Expect(1, 43823, '\P{^ ETHIOPIC_extended_A}', "");
    Expect(0, 43824, '\p{ ETHIOPIC_extended_A}', "");
    Expect(1, 43824, '\p{^ ETHIOPIC_extended_A}', "");
    Expect(1, 43824, '\P{ ETHIOPIC_extended_A}', "");
    Expect(0, 43824, '\P{^ ETHIOPIC_extended_A}', "");
    Error('\p{:=-Is_Ethiopic_Extended_A}');
    Error('\P{:=-Is_Ethiopic_Extended_A}');
    Expect(1, 43823, '\p{isethiopicextendeda}', "");
    Expect(0, 43823, '\p{^isethiopicextendeda}', "");
    Expect(0, 43823, '\P{isethiopicextendeda}', "");
    Expect(1, 43823, '\P{^isethiopicextendeda}', "");
    Expect(0, 43824, '\p{isethiopicextendeda}', "");
    Expect(1, 43824, '\p{^isethiopicextendeda}', "");
    Expect(1, 43824, '\P{isethiopicextendeda}', "");
    Expect(0, 43824, '\P{^isethiopicextendeda}', "");
    Expect(1, 43823, '\p{ _IS_ethiopic_Extended_A}', "");
    Expect(0, 43823, '\p{^ _IS_ethiopic_Extended_A}', "");
    Expect(0, 43823, '\P{ _IS_ethiopic_Extended_A}', "");
    Expect(1, 43823, '\P{^ _IS_ethiopic_Extended_A}', "");
    Expect(0, 43824, '\p{ _IS_ethiopic_Extended_A}', "");
    Expect(1, 43824, '\p{^ _IS_ethiopic_Extended_A}', "");
    Expect(1, 43824, '\P{ _IS_ethiopic_Extended_A}', "");
    Expect(0, 43824, '\P{^ _IS_ethiopic_Extended_A}', "");
    Error('\p{_	In_Ethiopic_extended_A:=}');
    Error('\P{_	In_Ethiopic_extended_A:=}');
    Expect(1, 43823, '\p{inethiopicextendeda}', "");
    Expect(0, 43823, '\p{^inethiopicextendeda}', "");
    Expect(0, 43823, '\P{inethiopicextendeda}', "");
    Expect(1, 43823, '\P{^inethiopicextendeda}', "");
    Expect(0, 43824, '\p{inethiopicextendeda}', "");
    Expect(1, 43824, '\p{^inethiopicextendeda}', "");
    Expect(1, 43824, '\P{inethiopicextendeda}', "");
    Expect(0, 43824, '\P{^inethiopicextendeda}', "");
    Expect(1, 43823, '\p{-_IN_ethiopic_Extended_A}', "");
    Expect(0, 43823, '\p{^-_IN_ethiopic_Extended_A}', "");
    Expect(0, 43823, '\P{-_IN_ethiopic_Extended_A}', "");
    Expect(1, 43823, '\P{^-_IN_ethiopic_Extended_A}', "");
    Expect(0, 43824, '\p{-_IN_ethiopic_Extended_A}', "");
    Expect(1, 43824, '\p{^-_IN_ethiopic_Extended_A}', "");
    Expect(1, 43824, '\P{-_IN_ethiopic_Extended_A}', "");
    Expect(0, 43824, '\P{^-_IN_ethiopic_Extended_A}', "");
    Error('\p{/a/	 ethiopic_Ext_a}');
    Error('\P{/a/	 ethiopic_Ext_a}');
    Expect(1, 43823, '\p{ethiopicexta}', "");
    Expect(0, 43823, '\p{^ethiopicexta}', "");
    Expect(0, 43823, '\P{ethiopicexta}', "");
    Expect(1, 43823, '\P{^ethiopicexta}', "");
    Expect(0, 43824, '\p{ethiopicexta}', "");
    Expect(1, 43824, '\p{^ethiopicexta}', "");
    Expect(1, 43824, '\P{ethiopicexta}', "");
    Expect(0, 43824, '\P{^ethiopicexta}', "");
    Expect(1, 43823, '\p{-Ethiopic_Ext_a}', "");
    Expect(0, 43823, '\p{^-Ethiopic_Ext_a}', "");
    Expect(0, 43823, '\P{-Ethiopic_Ext_a}', "");
    Expect(1, 43823, '\P{^-Ethiopic_Ext_a}', "");
    Expect(0, 43824, '\p{-Ethiopic_Ext_a}', "");
    Expect(1, 43824, '\p{^-Ethiopic_Ext_a}', "");
    Expect(1, 43824, '\P{-Ethiopic_Ext_a}', "");
    Expect(0, 43824, '\P{^-Ethiopic_Ext_a}', "");
    Error('\p{	/a/IS_ethiopic_ext_a}');
    Error('\P{	/a/IS_ethiopic_ext_a}');
    Expect(1, 43823, '\p{isethiopicexta}', "");
    Expect(0, 43823, '\p{^isethiopicexta}', "");
    Expect(0, 43823, '\P{isethiopicexta}', "");
    Expect(1, 43823, '\P{^isethiopicexta}', "");
    Expect(0, 43824, '\p{isethiopicexta}', "");
    Expect(1, 43824, '\p{^isethiopicexta}', "");
    Expect(1, 43824, '\P{isethiopicexta}', "");
    Expect(0, 43824, '\P{^isethiopicexta}', "");
    Expect(1, 43823, '\p{- Is_Ethiopic_EXT_A}', "");
    Expect(0, 43823, '\p{^- Is_Ethiopic_EXT_A}', "");
    Expect(0, 43823, '\P{- Is_Ethiopic_EXT_A}', "");
    Expect(1, 43823, '\P{^- Is_Ethiopic_EXT_A}', "");
    Expect(0, 43824, '\p{- Is_Ethiopic_EXT_A}', "");
    Expect(1, 43824, '\p{^- Is_Ethiopic_EXT_A}', "");
    Expect(1, 43824, '\P{- Is_Ethiopic_EXT_A}', "");
    Expect(0, 43824, '\P{^- Is_Ethiopic_EXT_A}', "");
    Error('\p{-/a/in_ETHIOPIC_Ext_A}');
    Error('\P{-/a/in_ETHIOPIC_Ext_A}');
    Expect(1, 43823, '\p{inethiopicexta}', "");
    Expect(0, 43823, '\p{^inethiopicexta}', "");
    Expect(0, 43823, '\P{inethiopicexta}', "");
    Expect(1, 43823, '\P{^inethiopicexta}', "");
    Expect(0, 43824, '\p{inethiopicexta}', "");
    Expect(1, 43824, '\p{^inethiopicexta}', "");
    Expect(1, 43824, '\P{inethiopicexta}', "");
    Expect(0, 43824, '\P{^inethiopicexta}', "");
    Expect(1, 43823, '\p{-_In_ETHIOPIC_Ext_A}', "");
    Expect(0, 43823, '\p{^-_In_ETHIOPIC_Ext_A}', "");
    Expect(0, 43823, '\P{-_In_ETHIOPIC_Ext_A}', "");
    Expect(1, 43823, '\P{^-_In_ETHIOPIC_Ext_A}', "");
    Expect(0, 43824, '\p{-_In_ETHIOPIC_Ext_A}', "");
    Expect(1, 43824, '\p{^-_In_ETHIOPIC_Ext_A}', "");
    Expect(1, 43824, '\P{-_In_ETHIOPIC_Ext_A}', "");
    Expect(0, 43824, '\P{^-_In_ETHIOPIC_Ext_A}', "");
    Error('\p{_	ethiopic_Extended_B:=}');
    Error('\P{_	ethiopic_Extended_B:=}');
    Expect(1, 124927, '\p{ethiopicextendedb}', "");
    Expect(0, 124927, '\p{^ethiopicextendedb}', "");
    Expect(0, 124927, '\P{ethiopicextendedb}', "");
    Expect(1, 124927, '\P{^ethiopicextendedb}', "");
    Expect(0, 124928, '\p{ethiopicextendedb}', "");
    Expect(1, 124928, '\p{^ethiopicextendedb}', "");
    Expect(1, 124928, '\P{ethiopicextendedb}', "");
    Expect(0, 124928, '\P{^ethiopicextendedb}', "");
    Expect(1, 124927, '\p{_-Ethiopic_Extended_B}', "");
    Expect(0, 124927, '\p{^_-Ethiopic_Extended_B}', "");
    Expect(0, 124927, '\P{_-Ethiopic_Extended_B}', "");
    Expect(1, 124927, '\P{^_-Ethiopic_Extended_B}', "");
    Expect(0, 124928, '\p{_-Ethiopic_Extended_B}', "");
    Expect(1, 124928, '\p{^_-Ethiopic_Extended_B}', "");
    Expect(1, 124928, '\P{_-Ethiopic_Extended_B}', "");
    Expect(0, 124928, '\P{^_-Ethiopic_Extended_B}', "");
    Error('\p{:= _IS_ETHIOPIC_Extended_B}');
    Error('\P{:= _IS_ETHIOPIC_Extended_B}');
    Expect(1, 124927, '\p{isethiopicextendedb}', "");
    Expect(0, 124927, '\p{^isethiopicextendedb}', "");
    Expect(0, 124927, '\P{isethiopicextendedb}', "");
    Expect(1, 124927, '\P{^isethiopicextendedb}', "");
    Expect(0, 124928, '\p{isethiopicextendedb}', "");
    Expect(1, 124928, '\p{^isethiopicextendedb}', "");
    Expect(1, 124928, '\P{isethiopicextendedb}', "");
    Expect(0, 124928, '\P{^isethiopicextendedb}', "");
    Expect(1, 124927, '\p{		IS_Ethiopic_EXTENDED_B}', "");
    Expect(0, 124927, '\p{^		IS_Ethiopic_EXTENDED_B}', "");
    Expect(0, 124927, '\P{		IS_Ethiopic_EXTENDED_B}', "");
    Expect(1, 124927, '\P{^		IS_Ethiopic_EXTENDED_B}', "");
    Expect(0, 124928, '\p{		IS_Ethiopic_EXTENDED_B}', "");
    Expect(1, 124928, '\p{^		IS_Ethiopic_EXTENDED_B}', "");
    Expect(1, 124928, '\P{		IS_Ethiopic_EXTENDED_B}', "");
    Expect(0, 124928, '\P{^		IS_Ethiopic_EXTENDED_B}', "");
    Error('\p{  in_ETHIOPIC_EXTENDED_b:=}');
    Error('\P{  in_ETHIOPIC_EXTENDED_b:=}');
    Expect(1, 124927, '\p{inethiopicextendedb}', "");
    Expect(0, 124927, '\p{^inethiopicextendedb}', "");
    Expect(0, 124927, '\P{inethiopicextendedb}', "");
    Expect(1, 124927, '\P{^inethiopicextendedb}', "");
    Expect(0, 124928, '\p{inethiopicextendedb}', "");
    Expect(1, 124928, '\p{^inethiopicextendedb}', "");
    Expect(1, 124928, '\P{inethiopicextendedb}', "");
    Expect(0, 124928, '\P{^inethiopicextendedb}', "");
    Expect(1, 124927, '\p{_	In_Ethiopic_EXTENDED_B}', "");
    Expect(0, 124927, '\p{^_	In_Ethiopic_EXTENDED_B}', "");
    Expect(0, 124927, '\P{_	In_Ethiopic_EXTENDED_B}', "");
    Expect(1, 124927, '\P{^_	In_Ethiopic_EXTENDED_B}', "");
    Expect(0, 124928, '\p{_	In_Ethiopic_EXTENDED_B}', "");
    Expect(1, 124928, '\p{^_	In_Ethiopic_EXTENDED_B}', "");
    Expect(1, 124928, '\P{_	In_Ethiopic_EXTENDED_B}', "");
    Expect(0, 124928, '\P{^_	In_Ethiopic_EXTENDED_B}', "");
    Error('\p{:=		ethiopic_EXT_b}');
    Error('\P{:=		ethiopic_EXT_b}');
    Expect(1, 124927, '\p{ethiopicextb}', "");
    Expect(0, 124927, '\p{^ethiopicextb}', "");
    Expect(0, 124927, '\P{ethiopicextb}', "");
    Expect(1, 124927, '\P{^ethiopicextb}', "");
    Expect(0, 124928, '\p{ethiopicextb}', "");
    Expect(1, 124928, '\p{^ethiopicextb}', "");
    Expect(1, 124928, '\P{ethiopicextb}', "");
    Expect(0, 124928, '\P{^ethiopicextb}', "");
    Expect(1, 124927, '\p{-_Ethiopic_ext_B}', "");
    Expect(0, 124927, '\p{^-_Ethiopic_ext_B}', "");
    Expect(0, 124927, '\P{-_Ethiopic_ext_B}', "");
    Expect(1, 124927, '\P{^-_Ethiopic_ext_B}', "");
    Expect(0, 124928, '\p{-_Ethiopic_ext_B}', "");
    Expect(1, 124928, '\p{^-_Ethiopic_ext_B}', "");
    Expect(1, 124928, '\P{-_Ethiopic_ext_B}', "");
    Expect(0, 124928, '\P{^-_Ethiopic_ext_B}', "");
    Error('\p{:=- Is_Ethiopic_Ext_B}');
    Error('\P{:=- Is_Ethiopic_Ext_B}');
    Expect(1, 124927, '\p{isethiopicextb}', "");
    Expect(0, 124927, '\p{^isethiopicextb}', "");
    Expect(0, 124927, '\P{isethiopicextb}', "");
    Expect(1, 124927, '\P{^isethiopicextb}', "");
    Expect(0, 124928, '\p{isethiopicextb}', "");
    Expect(1, 124928, '\p{^isethiopicextb}', "");
    Expect(1, 124928, '\P{isethiopicextb}', "");
    Expect(0, 124928, '\P{^isethiopicextb}', "");
    Expect(1, 124927, '\p{	-Is_Ethiopic_Ext_B}', "");
    Expect(0, 124927, '\p{^	-Is_Ethiopic_Ext_B}', "");
    Expect(0, 124927, '\P{	-Is_Ethiopic_Ext_B}', "");
    Expect(1, 124927, '\P{^	-Is_Ethiopic_Ext_B}', "");
    Expect(0, 124928, '\p{	-Is_Ethiopic_Ext_B}', "");
    Expect(1, 124928, '\p{^	-Is_Ethiopic_Ext_B}', "");
    Expect(1, 124928, '\P{	-Is_Ethiopic_Ext_B}', "");
    Expect(0, 124928, '\P{^	-Is_Ethiopic_Ext_B}', "");
    Error('\p{/a/__IN_Ethiopic_Ext_B}');
    Error('\P{/a/__IN_Ethiopic_Ext_B}');
    Expect(1, 124927, '\p{inethiopicextb}', "");
    Expect(0, 124927, '\p{^inethiopicextb}', "");
    Expect(0, 124927, '\P{inethiopicextb}', "");
    Expect(1, 124927, '\P{^inethiopicextb}', "");
    Expect(0, 124928, '\p{inethiopicextb}', "");
    Expect(1, 124928, '\p{^inethiopicextb}', "");
    Expect(1, 124928, '\P{inethiopicextb}', "");
    Expect(0, 124928, '\P{^inethiopicextb}', "");
    Expect(1, 124927, '\p{  In_Ethiopic_EXT_B}', "");
    Expect(0, 124927, '\p{^  In_Ethiopic_EXT_B}', "");
    Expect(0, 124927, '\P{  In_Ethiopic_EXT_B}', "");
    Expect(1, 124927, '\P{^  In_Ethiopic_EXT_B}', "");
    Expect(0, 124928, '\p{  In_Ethiopic_EXT_B}', "");
    Expect(1, 124928, '\p{^  In_Ethiopic_EXT_B}', "");
    Expect(1, 124928, '\P{  In_Ethiopic_EXT_B}', "");
    Expect(0, 124928, '\P{^  In_Ethiopic_EXT_B}', "");
    Error('\p{_ ETHIOPIC_supplement/a/}');
    Error('\P{_ ETHIOPIC_supplement/a/}');
    Expect(1, 5023, '\p{ethiopicsupplement}', "");
    Expect(0, 5023, '\p{^ethiopicsupplement}', "");
    Expect(0, 5023, '\P{ethiopicsupplement}', "");
    Expect(1, 5023, '\P{^ethiopicsupplement}', "");
    Expect(0, 5024, '\p{ethiopicsupplement}', "");
    Expect(1, 5024, '\p{^ethiopicsupplement}', "");
    Expect(1, 5024, '\P{ethiopicsupplement}', "");
    Expect(0, 5024, '\P{^ethiopicsupplement}', "");
    Expect(1, 5023, '\p{Ethiopic_Supplement}', "");
    Expect(0, 5023, '\p{^Ethiopic_Supplement}', "");
    Expect(0, 5023, '\P{Ethiopic_Supplement}', "");
    Expect(1, 5023, '\P{^Ethiopic_Supplement}', "");
    Expect(0, 5024, '\p{Ethiopic_Supplement}', "");
    Expect(1, 5024, '\p{^Ethiopic_Supplement}', "");
    Expect(1, 5024, '\P{Ethiopic_Supplement}', "");
    Expect(0, 5024, '\P{^Ethiopic_Supplement}', "");
    Error('\p{-/a/is_Ethiopic_supplement}');
    Error('\P{-/a/is_Ethiopic_supplement}');
    Expect(1, 5023, '\p{isethiopicsupplement}', "");
    Expect(0, 5023, '\p{^isethiopicsupplement}', "");
    Expect(0, 5023, '\P{isethiopicsupplement}', "");
    Expect(1, 5023, '\P{^isethiopicsupplement}', "");
    Expect(0, 5024, '\p{isethiopicsupplement}', "");
    Expect(1, 5024, '\p{^isethiopicsupplement}', "");
    Expect(1, 5024, '\P{isethiopicsupplement}', "");
    Expect(0, 5024, '\P{^isethiopicsupplement}', "");
    Expect(1, 5023, '\p{- is_ethiopic_supplement}', "");
    Expect(0, 5023, '\p{^- is_ethiopic_supplement}', "");
    Expect(0, 5023, '\P{- is_ethiopic_supplement}', "");
    Expect(1, 5023, '\P{^- is_ethiopic_supplement}', "");
    Expect(0, 5024, '\p{- is_ethiopic_supplement}', "");
    Expect(1, 5024, '\p{^- is_ethiopic_supplement}', "");
    Expect(1, 5024, '\P{- is_ethiopic_supplement}', "");
    Expect(0, 5024, '\P{^- is_ethiopic_supplement}', "");
    Error('\p{	In_Ethiopic_supplement:=}');
    Error('\P{	In_Ethiopic_supplement:=}');
    Expect(1, 5023, '\p{inethiopicsupplement}', "");
    Expect(0, 5023, '\p{^inethiopicsupplement}', "");
    Expect(0, 5023, '\P{inethiopicsupplement}', "");
    Expect(1, 5023, '\P{^inethiopicsupplement}', "");
    Expect(0, 5024, '\p{inethiopicsupplement}', "");
    Expect(1, 5024, '\p{^inethiopicsupplement}', "");
    Expect(1, 5024, '\P{inethiopicsupplement}', "");
    Expect(0, 5024, '\P{^inethiopicsupplement}', "");
    Expect(1, 5023, '\p{IN_Ethiopic_Supplement}', "");
    Expect(0, 5023, '\p{^IN_Ethiopic_Supplement}', "");
    Expect(0, 5023, '\P{IN_Ethiopic_Supplement}', "");
    Expect(1, 5023, '\P{^IN_Ethiopic_Supplement}', "");
    Expect(0, 5024, '\p{IN_Ethiopic_Supplement}', "");
    Expect(1, 5024, '\p{^IN_Ethiopic_Supplement}', "");
    Expect(1, 5024, '\P{IN_Ethiopic_Supplement}', "");
    Expect(0, 5024, '\P{^IN_Ethiopic_Supplement}', "");
    Error('\p{/a/ETHIOPIC_Sup}');
    Error('\P{/a/ETHIOPIC_Sup}');
    Expect(1, 5023, '\p{ethiopicsup}', "");
    Expect(0, 5023, '\p{^ethiopicsup}', "");
    Expect(0, 5023, '\P{ethiopicsup}', "");
    Expect(1, 5023, '\P{^ethiopicsup}', "");
    Expect(0, 5024, '\p{ethiopicsup}', "");
    Expect(1, 5024, '\p{^ethiopicsup}', "");
    Expect(1, 5024, '\P{ethiopicsup}', "");
    Expect(0, 5024, '\P{^ethiopicsup}', "");
    Expect(1, 5023, '\p{	_Ethiopic_SUP}', "");
    Expect(0, 5023, '\p{^	_Ethiopic_SUP}', "");
    Expect(0, 5023, '\P{	_Ethiopic_SUP}', "");
    Expect(1, 5023, '\P{^	_Ethiopic_SUP}', "");
    Expect(0, 5024, '\p{	_Ethiopic_SUP}', "");
    Expect(1, 5024, '\p{^	_Ethiopic_SUP}', "");
    Expect(1, 5024, '\P{	_Ethiopic_SUP}', "");
    Expect(0, 5024, '\P{^	_Ethiopic_SUP}', "");
    Error('\p{	Is_Ethiopic_Sup/a/}');
    Error('\P{	Is_Ethiopic_Sup/a/}');
    Expect(1, 5023, '\p{isethiopicsup}', "");
    Expect(0, 5023, '\p{^isethiopicsup}', "");
    Expect(0, 5023, '\P{isethiopicsup}', "");
    Expect(1, 5023, '\P{^isethiopicsup}', "");
    Expect(0, 5024, '\p{isethiopicsup}', "");
    Expect(1, 5024, '\p{^isethiopicsup}', "");
    Expect(1, 5024, '\P{isethiopicsup}', "");
    Expect(0, 5024, '\P{^isethiopicsup}', "");
    Expect(1, 5023, '\p{ -IS_Ethiopic_SUP}', "");
    Expect(0, 5023, '\p{^ -IS_Ethiopic_SUP}', "");
    Expect(0, 5023, '\P{ -IS_Ethiopic_SUP}', "");
    Expect(1, 5023, '\P{^ -IS_Ethiopic_SUP}', "");
    Expect(0, 5024, '\p{ -IS_Ethiopic_SUP}', "");
    Expect(1, 5024, '\p{^ -IS_Ethiopic_SUP}', "");
    Expect(1, 5024, '\P{ -IS_Ethiopic_SUP}', "");
    Expect(0, 5024, '\P{^ -IS_Ethiopic_SUP}', "");
    Error('\p{:=-In_Ethiopic_SUP}');
    Error('\P{:=-In_Ethiopic_SUP}');
    Expect(1, 5023, '\p{inethiopicsup}', "");
    Expect(0, 5023, '\p{^inethiopicsup}', "");
    Expect(0, 5023, '\P{inethiopicsup}', "");
    Expect(1, 5023, '\P{^inethiopicsup}', "");
    Expect(0, 5024, '\p{inethiopicsup}', "");
    Expect(1, 5024, '\p{^inethiopicsup}', "");
    Expect(1, 5024, '\P{inethiopicsup}', "");
    Expect(0, 5024, '\P{^inethiopicsup}', "");
    Expect(1, 5023, '\p{_-in_ETHIOPIC_sup}', "");
    Expect(0, 5023, '\p{^_-in_ETHIOPIC_sup}', "");
    Expect(0, 5023, '\P{_-in_ETHIOPIC_sup}', "");
    Expect(1, 5023, '\P{^_-in_ETHIOPIC_sup}', "");
    Expect(0, 5024, '\p{_-in_ETHIOPIC_sup}', "");
    Expect(1, 5024, '\p{^_-in_ETHIOPIC_sup}', "");
    Expect(1, 5024, '\P{_-in_ETHIOPIC_sup}', "");
    Expect(0, 5024, '\P{^_-in_ETHIOPIC_sup}', "");
    Error('\p{Expands_On_NFC}');
    Error('\P{Expands_On_NFC}');
    Error('\p{XO_NFC}');
    Error('\P{XO_NFC}');
    Error('\p{Expands_On_NFD}');
    Error('\P{Expands_On_NFD}');
    Error('\p{XO_NFD}');
    Error('\P{XO_NFD}');
    Error('\p{Expands_On_NFKC}');
    Error('\P{Expands_On_NFKC}');
    Error('\p{XO_NFKC}');
    Error('\P{XO_NFKC}');
    Error('\p{Expands_On_NFKD}');
    Error('\P{Expands_On_NFKD}');
    Error('\p{XO_NFKD}');
    Error('\P{XO_NFKD}');
    Error('\p{	:=Extended_Pictographic}');
    Error('\P{	:=Extended_Pictographic}');
    Expect(1, 131069, '\p{extendedpictographic}', "");
    Expect(0, 131069, '\p{^extendedpictographic}', "");
    Expect(0, 131069, '\P{extendedpictographic}', "");
    Expect(1, 131069, '\P{^extendedpictographic}', "");
    Expect(0, 131072, '\p{extendedpictographic}', "");
    Expect(1, 131072, '\p{^extendedpictographic}', "");
    Expect(1, 131072, '\P{extendedpictographic}', "");
    Expect(0, 131072, '\P{^extendedpictographic}', "");
    Expect(1, 131069, '\p{		EXTENDED_Pictographic}', "");
    Expect(0, 131069, '\p{^		EXTENDED_Pictographic}', "");
    Expect(0, 131069, '\P{		EXTENDED_Pictographic}', "");
    Expect(1, 131069, '\P{^		EXTENDED_Pictographic}', "");
    Expect(0, 131072, '\p{		EXTENDED_Pictographic}', "");
    Expect(1, 131072, '\p{^		EXTENDED_Pictographic}', "");
    Expect(1, 131072, '\P{		EXTENDED_Pictographic}', "");
    Expect(0, 131072, '\P{^		EXTENDED_Pictographic}', "");
    Error('\p{/a/_ Is_Extended_PICTOGRAPHIC}');
    Error('\P{/a/_ Is_Extended_PICTOGRAPHIC}');
    Expect(1, 131069, '\p{isextendedpictographic}', "");
    Expect(0, 131069, '\p{^isextendedpictographic}', "");
    Expect(0, 131069, '\P{isextendedpictographic}', "");
    Expect(1, 131069, '\P{^isextendedpictographic}', "");
    Expect(0, 131072, '\p{isextendedpictographic}', "");
    Expect(1, 131072, '\p{^isextendedpictographic}', "");
    Expect(1, 131072, '\P{isextendedpictographic}', "");
    Expect(0, 131072, '\P{^isextendedpictographic}', "");
    Expect(1, 131069, '\p{_Is_Extended_PICTOGRAPHIC}', "");
    Expect(0, 131069, '\p{^_Is_Extended_PICTOGRAPHIC}', "");
    Expect(0, 131069, '\P{_Is_Extended_PICTOGRAPHIC}', "");
    Expect(1, 131069, '\P{^_Is_Extended_PICTOGRAPHIC}', "");
    Expect(0, 131072, '\p{_Is_Extended_PICTOGRAPHIC}', "");
    Expect(1, 131072, '\p{^_Is_Extended_PICTOGRAPHIC}', "");
    Expect(1, 131072, '\P{_Is_Extended_PICTOGRAPHIC}', "");
    Expect(0, 131072, '\P{^_Is_Extended_PICTOGRAPHIC}', "");
    Error('\p{-:=ExtPict}');
    Error('\P{-:=ExtPict}');
    Expect(1, 131069, '\p{extpict}', "");
    Expect(0, 131069, '\p{^extpict}', "");
    Expect(0, 131069, '\P{extpict}', "");
    Expect(1, 131069, '\P{^extpict}', "");
    Expect(0, 131072, '\p{extpict}', "");
    Expect(1, 131072, '\p{^extpict}', "");
    Expect(1, 131072, '\P{extpict}', "");
    Expect(0, 131072, '\P{^extpict}', "");
    Expect(1, 131069, '\p{  extpict}', "");
    Expect(0, 131069, '\p{^  extpict}', "");
    Expect(0, 131069, '\P{  extpict}', "");
    Expect(1, 131069, '\P{^  extpict}', "");
    Expect(0, 131072, '\p{  extpict}', "");
    Expect(1, 131072, '\p{^  extpict}', "");
    Expect(1, 131072, '\P{  extpict}', "");
    Expect(0, 131072, '\P{^  extpict}', "");
    Error('\p{--Is_EXTPICT/a/}');
    Error('\P{--Is_EXTPICT/a/}');
    Expect(1, 131069, '\p{isextpict}', "");
    Expect(0, 131069, '\p{^isextpict}', "");
    Expect(0, 131069, '\P{isextpict}', "");
    Expect(1, 131069, '\P{^isextpict}', "");
    Expect(0, 131072, '\p{isextpict}', "");
    Expect(1, 131072, '\p{^isextpict}', "");
    Expect(1, 131072, '\P{isextpict}', "");
    Expect(0, 131072, '\P{^isextpict}', "");
    Expect(1, 131069, '\p{ _Is_extpict}', "");
    Expect(0, 131069, '\p{^ _Is_extpict}', "");
    Expect(0, 131069, '\P{ _Is_extpict}', "");
    Expect(1, 131069, '\P{^ _Is_extpict}', "");
    Expect(0, 131072, '\p{ _Is_extpict}', "");
    Expect(1, 131072, '\p{^ _Is_extpict}', "");
    Expect(1, 131072, '\P{ _Is_extpict}', "");
    Expect(0, 131072, '\P{^ _Is_extpict}', "");
    Error('\p{:= extender}');
    Error('\P{:= extender}');
    Expect(1, 125254, '\p{extender}', "");
    Expect(0, 125254, '\p{^extender}', "");
    Expect(0, 125254, '\P{extender}', "");
    Expect(1, 125254, '\P{^extender}', "");
    Expect(0, 125255, '\p{extender}', "");
    Expect(1, 125255, '\p{^extender}', "");
    Expect(1, 125255, '\P{extender}', "");
    Expect(0, 125255, '\P{^extender}', "");
    Expect(1, 125254, '\p{ _Extender}', "");
    Expect(0, 125254, '\p{^ _Extender}', "");
    Expect(0, 125254, '\P{ _Extender}', "");
    Expect(1, 125254, '\P{^ _Extender}', "");
    Expect(0, 125255, '\p{ _Extender}', "");
    Expect(1, 125255, '\p{^ _Extender}', "");
    Expect(1, 125255, '\P{ _Extender}', "");
    Expect(0, 125255, '\P{^ _Extender}', "");
    Error('\p{_ IS_Extender/a/}');
    Error('\P{_ IS_Extender/a/}');
    Expect(1, 125254, '\p{isextender}', "");
    Expect(0, 125254, '\p{^isextender}', "");
    Expect(0, 125254, '\P{isextender}', "");
    Expect(1, 125254, '\P{^isextender}', "");
    Expect(0, 125255, '\p{isextender}', "");
    Expect(1, 125255, '\p{^isextender}', "");
    Expect(1, 125255, '\P{isextender}', "");
    Expect(0, 125255, '\P{^isextender}', "");
    Expect(1, 125254, '\p{ is_EXTENDER}', "");
    Expect(0, 125254, '\p{^ is_EXTENDER}', "");
    Expect(0, 125254, '\P{ is_EXTENDER}', "");
    Expect(1, 125254, '\P{^ is_EXTENDER}', "");
    Expect(0, 125255, '\p{ is_EXTENDER}', "");
    Expect(1, 125255, '\p{^ is_EXTENDER}', "");
    Expect(1, 125255, '\P{ is_EXTENDER}', "");
    Expect(0, 125255, '\P{^ is_EXTENDER}', "");
    Error('\p{__Ext/a/}');
    Error('\P{__Ext/a/}');
    Expect(1, 125254, '\p{ext}', "");
    Expect(0, 125254, '\p{^ext}', "");
    Expect(0, 125254, '\P{ext}', "");
    Expect(1, 125254, '\P{^ext}', "");
    Expect(0, 125255, '\p{ext}', "");
    Expect(1, 125255, '\p{^ext}', "");
    Expect(1, 125255, '\P{ext}', "");
    Expect(0, 125255, '\P{^ext}', "");
    Expect(1, 125254, '\p{ 	Ext}', "");
    Expect(0, 125254, '\p{^ 	Ext}', "");
    Expect(0, 125254, '\P{ 	Ext}', "");
    Expect(1, 125254, '\P{^ 	Ext}', "");
    Expect(0, 125255, '\p{ 	Ext}', "");
    Expect(1, 125255, '\p{^ 	Ext}', "");
    Expect(1, 125255, '\P{ 	Ext}', "");
    Expect(0, 125255, '\P{^ 	Ext}', "");
    Error('\p{/a/_IS_EXT}');
    Error('\P{/a/_IS_EXT}');
    Expect(1, 125254, '\p{isext}', "");
    Expect(0, 125254, '\p{^isext}', "");
    Expect(0, 125254, '\P{isext}', "");
    Expect(1, 125254, '\P{^isext}', "");
    Expect(0, 125255, '\p{isext}', "");
    Expect(1, 125255, '\p{^isext}', "");
    Expect(1, 125255, '\P{isext}', "");
    Expect(0, 125255, '\P{^isext}', "");
    Expect(1, 125254, '\p{_	IS_Ext}', "");
    Expect(0, 125254, '\p{^_	IS_Ext}', "");
    Expect(0, 125254, '\P{_	IS_Ext}', "");
    Expect(1, 125254, '\P{^_	IS_Ext}', "");
    Expect(0, 125255, '\p{_	IS_Ext}', "");
    Expect(1, 125255, '\p{^_	IS_Ext}', "");
    Expect(1, 125255, '\P{_	IS_Ext}', "");
    Expect(0, 125255, '\P{^_	IS_Ext}', "");
    Error('\p{:=  Final_Punctuation}');
    Error('\P{:=  Final_Punctuation}');
    Expect(1, 11809, '\p{finalpunctuation}', "");
    Expect(0, 11809, '\p{^finalpunctuation}', "");
    Expect(0, 11809, '\P{finalpunctuation}', "");
    Expect(1, 11809, '\P{^finalpunctuation}', "");
    Expect(0, 11810, '\p{finalpunctuation}', "");
    Expect(1, 11810, '\p{^finalpunctuation}', "");
    Expect(1, 11810, '\P{finalpunctuation}', "");
    Expect(0, 11810, '\P{^finalpunctuation}', "");
    Expect(1, 11809, '\p{-_Final_punctuation}', "");
    Expect(0, 11809, '\p{^-_Final_punctuation}', "");
    Expect(0, 11809, '\P{-_Final_punctuation}', "");
    Expect(1, 11809, '\P{^-_Final_punctuation}', "");
    Expect(0, 11810, '\p{-_Final_punctuation}', "");
    Expect(1, 11810, '\p{^-_Final_punctuation}', "");
    Expect(1, 11810, '\P{-_Final_punctuation}', "");
    Expect(0, 11810, '\P{^-_Final_punctuation}', "");
    Error('\p{_is_final_Punctuation/a/}');
    Error('\P{_is_final_Punctuation/a/}');
    Expect(1, 11809, '\p{isfinalpunctuation}', "");
    Expect(0, 11809, '\p{^isfinalpunctuation}', "");
    Expect(0, 11809, '\P{isfinalpunctuation}', "");
    Expect(1, 11809, '\P{^isfinalpunctuation}', "");
    Expect(0, 11810, '\p{isfinalpunctuation}', "");
    Expect(1, 11810, '\p{^isfinalpunctuation}', "");
    Expect(1, 11810, '\P{isfinalpunctuation}', "");
    Expect(0, 11810, '\P{^isfinalpunctuation}', "");
    Expect(1, 11809, '\p{ 	Is_FINAL_Punctuation}', "");
    Expect(0, 11809, '\p{^ 	Is_FINAL_Punctuation}', "");
    Expect(0, 11809, '\P{ 	Is_FINAL_Punctuation}', "");
    Expect(1, 11809, '\P{^ 	Is_FINAL_Punctuation}', "");
    Expect(0, 11810, '\p{ 	Is_FINAL_Punctuation}', "");
    Expect(1, 11810, '\p{^ 	Is_FINAL_Punctuation}', "");
    Expect(1, 11810, '\P{ 	Is_FINAL_Punctuation}', "");
    Expect(0, 11810, '\P{^ 	Is_FINAL_Punctuation}', "");
    Error('\p{:= 	Pf}');
    Error('\P{:= 	Pf}');
    Expect(1, 11809, '\p{pf}', "");
    Expect(0, 11809, '\p{^pf}', "");
    Expect(0, 11809, '\P{pf}', "");
    Expect(1, 11809, '\P{^pf}', "");
    Expect(0, 11810, '\p{pf}', "");
    Expect(1, 11810, '\p{^pf}', "");
    Expect(1, 11810, '\P{pf}', "");
    Expect(0, 11810, '\P{^pf}', "");
    Expect(1, 11809, '\p{-_Pf}', "");
    Expect(0, 11809, '\p{^-_Pf}', "");
    Expect(0, 11809, '\P{-_Pf}', "");
    Expect(1, 11809, '\P{^-_Pf}', "");
    Expect(0, 11810, '\p{-_Pf}', "");
    Expect(1, 11810, '\p{^-_Pf}', "");
    Expect(1, 11810, '\P{-_Pf}', "");
    Expect(0, 11810, '\P{^-_Pf}', "");
    Error('\p{ is_PF:=}');
    Error('\P{ is_PF:=}');
    Expect(1, 11809, '\p{ispf}', "");
    Expect(0, 11809, '\p{^ispf}', "");
    Expect(0, 11809, '\P{ispf}', "");
    Expect(1, 11809, '\P{^ispf}', "");
    Expect(0, 11810, '\p{ispf}', "");
    Expect(1, 11810, '\p{^ispf}', "");
    Expect(1, 11810, '\P{ispf}', "");
    Expect(0, 11810, '\P{^ispf}', "");
    Expect(1, 11809, '\p{-is_Pf}', "");
    Expect(0, 11809, '\p{^-is_Pf}', "");
    Expect(0, 11809, '\P{-is_Pf}', "");
    Expect(1, 11809, '\P{^-is_Pf}', "");
    Expect(0, 11810, '\p{-is_Pf}', "");
    Expect(1, 11810, '\p{^-is_Pf}', "");
    Expect(1, 11810, '\P{-is_Pf}', "");
    Expect(0, 11810, '\P{^-is_Pf}', "");
    Error('\p{	:=FORMAT}');
    Error('\P{	:=FORMAT}');
    Expect(1, 917631, '\p{format}', "");
    Expect(0, 917631, '\p{^format}', "");
    Expect(0, 917631, '\P{format}', "");
    Expect(1, 917631, '\P{^format}', "");
    Expect(0, 917632, '\p{format}', "");
    Expect(1, 917632, '\p{^format}', "");
    Expect(1, 917632, '\P{format}', "");
    Expect(0, 917632, '\P{^format}', "");
    Expect(1, 917631, '\p{  FORMAT}', "");
    Expect(0, 917631, '\p{^  FORMAT}', "");
    Expect(0, 917631, '\P{  FORMAT}', "");
    Expect(1, 917631, '\P{^  FORMAT}', "");
    Expect(0, 917632, '\p{  FORMAT}', "");
    Expect(1, 917632, '\p{^  FORMAT}', "");
    Expect(1, 917632, '\P{  FORMAT}', "");
    Expect(0, 917632, '\P{^  FORMAT}', "");
    Error('\p{	-Is_FORMAT/a/}');
    Error('\P{	-Is_FORMAT/a/}');
    Expect(1, 917631, '\p{isformat}', "");
    Expect(0, 917631, '\p{^isformat}', "");
    Expect(0, 917631, '\P{isformat}', "");
    Expect(1, 917631, '\P{^isformat}', "");
    Expect(0, 917632, '\p{isformat}', "");
    Expect(1, 917632, '\p{^isformat}', "");
    Expect(1, 917632, '\P{isformat}', "");
    Expect(0, 917632, '\P{^isformat}', "");
    Expect(1, 917631, '\p{		Is_format}', "");
    Expect(0, 917631, '\p{^		Is_format}', "");
    Expect(0, 917631, '\P{		Is_format}', "");
    Expect(1, 917631, '\P{^		Is_format}', "");
    Expect(0, 917632, '\p{		Is_format}', "");
    Expect(1, 917632, '\p{^		Is_format}', "");
    Expect(1, 917632, '\P{		Is_format}', "");
    Expect(0, 917632, '\P{^		Is_format}', "");
    Error('\p{/a/Cf}');
    Error('\P{/a/Cf}');
    Expect(1, 917631, '\p{cf}', "");
    Expect(0, 917631, '\p{^cf}', "");
    Expect(0, 917631, '\P{cf}', "");
    Expect(1, 917631, '\P{^cf}', "");
    Expect(0, 917632, '\p{cf}', "");
    Expect(1, 917632, '\p{^cf}', "");
    Expect(1, 917632, '\P{cf}', "");
    Expect(0, 917632, '\P{^cf}', "");
    Expect(1, 917631, '\p{-_CF}', "");
    Expect(0, 917631, '\p{^-_CF}', "");
    Expect(0, 917631, '\P{-_CF}', "");
    Expect(1, 917631, '\P{^-_CF}', "");
    Expect(0, 917632, '\p{-_CF}', "");
    Expect(1, 917632, '\p{^-_CF}', "");
    Expect(1, 917632, '\P{-_CF}', "");
    Expect(0, 917632, '\P{^-_CF}', "");
    Error('\p{:=Is_CF}');
    Error('\P{:=Is_CF}');
    Expect(1, 917631, '\p{iscf}', "");
    Expect(0, 917631, '\p{^iscf}', "");
    Expect(0, 917631, '\P{iscf}', "");
    Expect(1, 917631, '\P{^iscf}', "");
    Expect(0, 917632, '\p{iscf}', "");
    Expect(1, 917632, '\p{^iscf}', "");
    Expect(1, 917632, '\P{iscf}', "");
    Expect(0, 917632, '\P{^iscf}', "");
    Expect(1, 917631, '\p{		IS_cf}', "");
    Expect(0, 917631, '\p{^		IS_cf}', "");
    Expect(0, 917631, '\P{		IS_cf}', "");
    Expect(1, 917631, '\P{^		IS_cf}', "");
    Expect(0, 917632, '\p{		IS_cf}', "");
    Expect(1, 917632, '\p{^		IS_cf}', "");
    Expect(1, 917632, '\P{		IS_cf}', "");
    Expect(0, 917632, '\P{^		IS_cf}', "");
    Error('\p{-_Full_Composition_Exclusion:=}');
    Error('\P{-_Full_Composition_Exclusion:=}');
    Expect(1, 195101, '\p{fullcompositionexclusion}', "");
    Expect(0, 195101, '\p{^fullcompositionexclusion}', "");
    Expect(0, 195101, '\P{fullcompositionexclusion}', "");
    Expect(1, 195101, '\P{^fullcompositionexclusion}', "");
    Expect(0, 195102, '\p{fullcompositionexclusion}', "");
    Expect(1, 195102, '\p{^fullcompositionexclusion}', "");
    Expect(1, 195102, '\P{fullcompositionexclusion}', "");
    Expect(0, 195102, '\P{^fullcompositionexclusion}', "");
    Expect(1, 195101, '\p{ Full_COMPOSITION_EXCLUSION}', "");
    Expect(0, 195101, '\p{^ Full_COMPOSITION_EXCLUSION}', "");
    Expect(0, 195101, '\P{ Full_COMPOSITION_EXCLUSION}', "");
    Expect(1, 195101, '\P{^ Full_COMPOSITION_EXCLUSION}', "");
    Expect(0, 195102, '\p{ Full_COMPOSITION_EXCLUSION}', "");
    Expect(1, 195102, '\p{^ Full_COMPOSITION_EXCLUSION}', "");
    Expect(1, 195102, '\P{ Full_COMPOSITION_EXCLUSION}', "");
    Expect(0, 195102, '\P{^ Full_COMPOSITION_EXCLUSION}', "");
    Error('\p{	:=Is_full_composition_Exclusion}');
    Error('\P{	:=Is_full_composition_Exclusion}');
    Expect(1, 195101, '\p{isfullcompositionexclusion}', "");
    Expect(0, 195101, '\p{^isfullcompositionexclusion}', "");
    Expect(0, 195101, '\P{isfullcompositionexclusion}', "");
    Expect(1, 195101, '\P{^isfullcompositionexclusion}', "");
    Expect(0, 195102, '\p{isfullcompositionexclusion}', "");
    Expect(1, 195102, '\p{^isfullcompositionexclusion}', "");
    Expect(1, 195102, '\P{isfullcompositionexclusion}', "");
    Expect(0, 195102, '\P{^isfullcompositionexclusion}', "");
    Expect(1, 195101, '\p{ -Is_full_COMPOSITION_exclusion}', "");
    Expect(0, 195101, '\p{^ -Is_full_COMPOSITION_exclusion}', "");
    Expect(0, 195101, '\P{ -Is_full_COMPOSITION_exclusion}', "");
    Expect(1, 195101, '\P{^ -Is_full_COMPOSITION_exclusion}', "");
    Expect(0, 195102, '\p{ -Is_full_COMPOSITION_exclusion}', "");
    Expect(1, 195102, '\p{^ -Is_full_COMPOSITION_exclusion}', "");
    Expect(1, 195102, '\P{ -Is_full_COMPOSITION_exclusion}', "");
    Expect(0, 195102, '\P{^ -Is_full_COMPOSITION_exclusion}', "");
    Error('\p{__comp_EX/a/}');
    Error('\P{__comp_EX/a/}');
    Expect(1, 195101, '\p{compex}', "");
    Expect(0, 195101, '\p{^compex}', "");
    Expect(0, 195101, '\P{compex}', "");
    Expect(1, 195101, '\P{^compex}', "");
    Expect(0, 195102, '\p{compex}', "");
    Expect(1, 195102, '\p{^compex}', "");
    Expect(1, 195102, '\P{compex}', "");
    Expect(0, 195102, '\P{^compex}', "");
    Expect(1, 195101, '\p{--Comp_ex}', "");
    Expect(0, 195101, '\p{^--Comp_ex}', "");
    Expect(0, 195101, '\P{--Comp_ex}', "");
    Expect(1, 195101, '\P{^--Comp_ex}', "");
    Expect(0, 195102, '\p{--Comp_ex}', "");
    Expect(1, 195102, '\p{^--Comp_ex}', "");
    Expect(1, 195102, '\P{--Comp_ex}', "");
    Expect(0, 195102, '\P{^--Comp_ex}', "");
    Error('\p{/a/ _is_Comp_Ex}');
    Error('\P{/a/ _is_Comp_Ex}');
    Expect(1, 195101, '\p{iscompex}', "");
    Expect(0, 195101, '\p{^iscompex}', "");
    Expect(0, 195101, '\P{iscompex}', "");
    Expect(1, 195101, '\P{^iscompex}', "");
    Expect(0, 195102, '\p{iscompex}', "");
    Expect(1, 195102, '\p{^iscompex}', "");
    Expect(1, 195102, '\P{iscompex}', "");
    Expect(0, 195102, '\P{^iscompex}', "");
    Expect(1, 195101, '\p{_IS_comp_Ex}', "");
    Expect(0, 195101, '\p{^_IS_comp_Ex}', "");
    Expect(0, 195101, '\P{_IS_comp_Ex}', "");
    Expect(1, 195101, '\P{^_IS_comp_Ex}', "");
    Expect(0, 195102, '\p{_IS_comp_Ex}', "");
    Expect(1, 195102, '\p{^_IS_comp_Ex}', "");
    Expect(1, 195102, '\P{_IS_comp_Ex}', "");
    Expect(0, 195102, '\P{^_IS_comp_Ex}', "");
    Error('\p{_	general_Punctuation:=}');
    Error('\P{_	general_Punctuation:=}');
    Expect(1, 8303, '\p{generalpunctuation}', "");
    Expect(0, 8303, '\p{^generalpunctuation}', "");
    Expect(0, 8303, '\P{generalpunctuation}', "");
    Expect(1, 8303, '\P{^generalpunctuation}', "");
    Expect(0, 8304, '\p{generalpunctuation}', "");
    Expect(1, 8304, '\p{^generalpunctuation}', "");
    Expect(1, 8304, '\P{generalpunctuation}', "");
    Expect(0, 8304, '\P{^generalpunctuation}', "");
    Expect(1, 8303, '\p{_-General_Punctuation}', "");
    Expect(0, 8303, '\p{^_-General_Punctuation}', "");
    Expect(0, 8303, '\P{_-General_Punctuation}', "");
    Expect(1, 8303, '\P{^_-General_Punctuation}', "");
    Expect(0, 8304, '\p{_-General_Punctuation}', "");
    Expect(1, 8304, '\p{^_-General_Punctuation}', "");
    Expect(1, 8304, '\P{_-General_Punctuation}', "");
    Expect(0, 8304, '\P{^_-General_Punctuation}', "");
    Error('\p{:=- IS_GENERAL_punctuation}');
    Error('\P{:=- IS_GENERAL_punctuation}');
    Expect(1, 8303, '\p{isgeneralpunctuation}', "");
    Expect(0, 8303, '\p{^isgeneralpunctuation}', "");
    Expect(0, 8303, '\P{isgeneralpunctuation}', "");
    Expect(1, 8303, '\P{^isgeneralpunctuation}', "");
    Expect(0, 8304, '\p{isgeneralpunctuation}', "");
    Expect(1, 8304, '\p{^isgeneralpunctuation}', "");
    Expect(1, 8304, '\P{isgeneralpunctuation}', "");
    Expect(0, 8304, '\P{^isgeneralpunctuation}', "");
    Expect(1, 8303, '\p{ -Is_GENERAL_Punctuation}', "");
    Expect(0, 8303, '\p{^ -Is_GENERAL_Punctuation}', "");
    Expect(0, 8303, '\P{ -Is_GENERAL_Punctuation}', "");
    Expect(1, 8303, '\P{^ -Is_GENERAL_Punctuation}', "");
    Expect(0, 8304, '\p{ -Is_GENERAL_Punctuation}', "");
    Expect(1, 8304, '\p{^ -Is_GENERAL_Punctuation}', "");
    Expect(1, 8304, '\P{ -Is_GENERAL_Punctuation}', "");
    Expect(0, 8304, '\P{^ -Is_GENERAL_Punctuation}', "");
    Error('\p{:=__In_GENERAL_Punctuation}');
    Error('\P{:=__In_GENERAL_Punctuation}');
    Expect(1, 8303, '\p{ingeneralpunctuation}', "");
    Expect(0, 8303, '\p{^ingeneralpunctuation}', "");
    Expect(0, 8303, '\P{ingeneralpunctuation}', "");
    Expect(1, 8303, '\P{^ingeneralpunctuation}', "");
    Expect(0, 8304, '\p{ingeneralpunctuation}', "");
    Expect(1, 8304, '\p{^ingeneralpunctuation}', "");
    Expect(1, 8304, '\P{ingeneralpunctuation}', "");
    Expect(0, 8304, '\P{^ingeneralpunctuation}', "");
    Expect(1, 8303, '\p{-In_GENERAL_Punctuation}', "");
    Expect(0, 8303, '\p{^-In_GENERAL_Punctuation}', "");
    Expect(0, 8303, '\P{-In_GENERAL_Punctuation}', "");
    Expect(1, 8303, '\P{^-In_GENERAL_Punctuation}', "");
    Expect(0, 8304, '\p{-In_GENERAL_Punctuation}', "");
    Expect(1, 8304, '\p{^-In_GENERAL_Punctuation}', "");
    Expect(1, 8304, '\P{-In_GENERAL_Punctuation}', "");
    Expect(0, 8304, '\P{^-In_GENERAL_Punctuation}', "");
    Error('\p{-	IN_PUNCTUATION/a/}');
    Error('\P{-	IN_PUNCTUATION/a/}');
    Expect(1, 8303, '\p{inpunctuation}', "");
    Expect(0, 8303, '\p{^inpunctuation}', "");
    Expect(0, 8303, '\P{inpunctuation}', "");
    Expect(1, 8303, '\P{^inpunctuation}', "");
    Expect(0, 8304, '\p{inpunctuation}', "");
    Expect(1, 8304, '\p{^inpunctuation}', "");
    Expect(1, 8304, '\P{inpunctuation}', "");
    Expect(0, 8304, '\P{^inpunctuation}', "");
    Expect(1, 8303, '\p{	-in_PUNCTUATION}', "");
    Expect(0, 8303, '\p{^	-in_PUNCTUATION}', "");
    Expect(0, 8303, '\P{	-in_PUNCTUATION}', "");
    Expect(1, 8303, '\P{^	-in_PUNCTUATION}', "");
    Expect(0, 8304, '\p{	-in_PUNCTUATION}', "");
    Expect(1, 8304, '\p{^	-in_PUNCTUATION}', "");
    Expect(1, 8304, '\P{	-in_PUNCTUATION}', "");
    Expect(0, 8304, '\P{^	-in_PUNCTUATION}', "");
    Error('\p{/a/		Geometric_SHAPES}');
    Error('\P{/a/		Geometric_SHAPES}');
    Expect(1, 9727, '\p{geometricshapes}', "");
    Expect(0, 9727, '\p{^geometricshapes}', "");
    Expect(0, 9727, '\P{geometricshapes}', "");
    Expect(1, 9727, '\P{^geometricshapes}', "");
    Expect(0, 9728, '\p{geometricshapes}', "");
    Expect(1, 9728, '\p{^geometricshapes}', "");
    Expect(1, 9728, '\P{geometricshapes}', "");
    Expect(0, 9728, '\P{^geometricshapes}', "");
    Expect(1, 9727, '\p{_	Geometric_Shapes}', "");
    Expect(0, 9727, '\p{^_	Geometric_Shapes}', "");
    Expect(0, 9727, '\P{_	Geometric_Shapes}', "");
    Expect(1, 9727, '\P{^_	Geometric_Shapes}', "");
    Expect(0, 9728, '\p{_	Geometric_Shapes}', "");
    Expect(1, 9728, '\p{^_	Geometric_Shapes}', "");
    Expect(1, 9728, '\P{_	Geometric_Shapes}', "");
    Expect(0, 9728, '\P{^_	Geometric_Shapes}', "");
    Error('\p{ -Is_GEOMETRIC_Shapes/a/}');
    Error('\P{ -Is_GEOMETRIC_Shapes/a/}');
    Expect(1, 9727, '\p{isgeometricshapes}', "");
    Expect(0, 9727, '\p{^isgeometricshapes}', "");
    Expect(0, 9727, '\P{isgeometricshapes}', "");
    Expect(1, 9727, '\P{^isgeometricshapes}', "");
    Expect(0, 9728, '\p{isgeometricshapes}', "");
    Expect(1, 9728, '\p{^isgeometricshapes}', "");
    Expect(1, 9728, '\P{isgeometricshapes}', "");
    Expect(0, 9728, '\P{^isgeometricshapes}', "");
    Expect(1, 9727, '\p{	-Is_geometric_Shapes}', "");
    Expect(0, 9727, '\p{^	-Is_geometric_Shapes}', "");
    Expect(0, 9727, '\P{	-Is_geometric_Shapes}', "");
    Expect(1, 9727, '\P{^	-Is_geometric_Shapes}', "");
    Expect(0, 9728, '\p{	-Is_geometric_Shapes}', "");
    Expect(1, 9728, '\p{^	-Is_geometric_Shapes}', "");
    Expect(1, 9728, '\P{	-Is_geometric_Shapes}', "");
    Expect(0, 9728, '\P{^	-Is_geometric_Shapes}', "");
    Error('\p{-In_Geometric_shapes/a/}');
    Error('\P{-In_Geometric_shapes/a/}');
    Expect(1, 9727, '\p{ingeometricshapes}', "");
    Expect(0, 9727, '\p{^ingeometricshapes}', "");
    Expect(0, 9727, '\P{ingeometricshapes}', "");
    Expect(1, 9727, '\P{^ingeometricshapes}', "");
    Expect(0, 9728, '\p{ingeometricshapes}', "");
    Expect(1, 9728, '\p{^ingeometricshapes}', "");
    Expect(1, 9728, '\P{ingeometricshapes}', "");
    Expect(0, 9728, '\P{^ingeometricshapes}', "");
    Expect(1, 9727, '\p{_-In_Geometric_shapes}', "");
    Expect(0, 9727, '\p{^_-In_Geometric_shapes}', "");
    Expect(0, 9727, '\P{_-In_Geometric_shapes}', "");
    Expect(1, 9727, '\P{^_-In_Geometric_shapes}', "");
    Expect(0, 9728, '\p{_-In_Geometric_shapes}', "");
    Expect(1, 9728, '\p{^_-In_Geometric_shapes}', "");
    Expect(1, 9728, '\P{_-In_Geometric_shapes}', "");
    Expect(0, 9728, '\P{^_-In_Geometric_shapes}', "");
    Error('\p{_	Geometric_Shapes_Extended/a/}');
    Error('\P{_	Geometric_Shapes_Extended/a/}');
    Expect(1, 129023, '\p{geometricshapesextended}', "");
    Expect(0, 129023, '\p{^geometricshapesextended}', "");
    Expect(0, 129023, '\P{geometricshapesextended}', "");
    Expect(1, 129023, '\P{^geometricshapesextended}', "");
    Expect(0, 129024, '\p{geometricshapesextended}', "");
    Expect(1, 129024, '\p{^geometricshapesextended}', "");
    Expect(1, 129024, '\P{geometricshapesextended}', "");
    Expect(0, 129024, '\P{^geometricshapesextended}', "");
    Expect(1, 129023, '\p{-_Geometric_Shapes_Extended}', "");
    Expect(0, 129023, '\p{^-_Geometric_Shapes_Extended}', "");
    Expect(0, 129023, '\P{-_Geometric_Shapes_Extended}', "");
    Expect(1, 129023, '\P{^-_Geometric_Shapes_Extended}', "");
    Expect(0, 129024, '\p{-_Geometric_Shapes_Extended}', "");
    Expect(1, 129024, '\p{^-_Geometric_Shapes_Extended}', "");
    Expect(1, 129024, '\P{-_Geometric_Shapes_Extended}', "");
    Expect(0, 129024, '\P{^-_Geometric_Shapes_Extended}', "");
    Error('\p{_	is_Geometric_SHAPES_extended/a/}');
    Error('\P{_	is_Geometric_SHAPES_extended/a/}');
    Expect(1, 129023, '\p{isgeometricshapesextended}', "");
    Expect(0, 129023, '\p{^isgeometricshapesextended}', "");
    Expect(0, 129023, '\P{isgeometricshapesextended}', "");
    Expect(1, 129023, '\P{^isgeometricshapesextended}', "");
    Expect(0, 129024, '\p{isgeometricshapesextended}', "");
    Expect(1, 129024, '\p{^isgeometricshapesextended}', "");
    Expect(1, 129024, '\P{isgeometricshapesextended}', "");
    Expect(0, 129024, '\P{^isgeometricshapesextended}', "");
    Expect(1, 129023, '\p{	is_GEOMETRIC_shapes_extended}', "");
    Expect(0, 129023, '\p{^	is_GEOMETRIC_shapes_extended}', "");
    Expect(0, 129023, '\P{	is_GEOMETRIC_shapes_extended}', "");
    Expect(1, 129023, '\P{^	is_GEOMETRIC_shapes_extended}', "");
    Expect(0, 129024, '\p{	is_GEOMETRIC_shapes_extended}', "");
    Expect(1, 129024, '\p{^	is_GEOMETRIC_shapes_extended}', "");
    Expect(1, 129024, '\P{	is_GEOMETRIC_shapes_extended}', "");
    Expect(0, 129024, '\P{^	is_GEOMETRIC_shapes_extended}', "");
    Error('\p{/a/ _In_Geometric_shapes_extended}');
    Error('\P{/a/ _In_Geometric_shapes_extended}');
    Expect(1, 129023, '\p{ingeometricshapesextended}', "");
    Expect(0, 129023, '\p{^ingeometricshapesextended}', "");
    Expect(0, 129023, '\P{ingeometricshapesextended}', "");
    Expect(1, 129023, '\P{^ingeometricshapesextended}', "");
    Expect(0, 129024, '\p{ingeometricshapesextended}', "");
    Expect(1, 129024, '\p{^ingeometricshapesextended}', "");
    Expect(1, 129024, '\P{ingeometricshapesextended}', "");
    Expect(0, 129024, '\P{^ingeometricshapesextended}', "");
    Expect(1, 129023, '\p{	_In_geometric_Shapes_EXTENDED}', "");
    Expect(0, 129023, '\p{^	_In_geometric_Shapes_EXTENDED}', "");
    Expect(0, 129023, '\P{	_In_geometric_Shapes_EXTENDED}', "");
    Expect(1, 129023, '\P{^	_In_geometric_Shapes_EXTENDED}', "");
    Expect(0, 129024, '\p{	_In_geometric_Shapes_EXTENDED}', "");
    Expect(1, 129024, '\p{^	_In_geometric_Shapes_EXTENDED}', "");
    Expect(1, 129024, '\P{	_In_geometric_Shapes_EXTENDED}', "");
    Expect(0, 129024, '\P{^	_In_geometric_Shapes_EXTENDED}', "");
    Error('\p{_:=geometric_Shapes_Ext}');
    Error('\P{_:=geometric_Shapes_Ext}');
    Expect(1, 129023, '\p{geometricshapesext}', "");
    Expect(0, 129023, '\p{^geometricshapesext}', "");
    Expect(0, 129023, '\P{geometricshapesext}', "");
    Expect(1, 129023, '\P{^geometricshapesext}', "");
    Expect(0, 129024, '\p{geometricshapesext}', "");
    Expect(1, 129024, '\p{^geometricshapesext}', "");
    Expect(1, 129024, '\P{geometricshapesext}', "");
    Expect(0, 129024, '\P{^geometricshapesext}', "");
    Expect(1, 129023, '\p{-Geometric_Shapes_EXT}', "");
    Expect(0, 129023, '\p{^-Geometric_Shapes_EXT}', "");
    Expect(0, 129023, '\P{-Geometric_Shapes_EXT}', "");
    Expect(1, 129023, '\P{^-Geometric_Shapes_EXT}', "");
    Expect(0, 129024, '\p{-Geometric_Shapes_EXT}', "");
    Expect(1, 129024, '\p{^-Geometric_Shapes_EXT}', "");
    Expect(1, 129024, '\P{-Geometric_Shapes_EXT}', "");
    Expect(0, 129024, '\P{^-Geometric_Shapes_EXT}', "");
    Error('\p{ IS_GEOMETRIC_Shapes_EXT/a/}');
    Error('\P{ IS_GEOMETRIC_Shapes_EXT/a/}');
    Expect(1, 129023, '\p{isgeometricshapesext}', "");
    Expect(0, 129023, '\p{^isgeometricshapesext}', "");
    Expect(0, 129023, '\P{isgeometricshapesext}', "");
    Expect(1, 129023, '\P{^isgeometricshapesext}', "");
    Expect(0, 129024, '\p{isgeometricshapesext}', "");
    Expect(1, 129024, '\p{^isgeometricshapesext}', "");
    Expect(1, 129024, '\P{isgeometricshapesext}', "");
    Expect(0, 129024, '\P{^isgeometricshapesext}', "");
    Expect(1, 129023, '\p{_-IS_Geometric_Shapes_Ext}', "");
    Expect(0, 129023, '\p{^_-IS_Geometric_Shapes_Ext}', "");
    Expect(0, 129023, '\P{_-IS_Geometric_Shapes_Ext}', "");
    Expect(1, 129023, '\P{^_-IS_Geometric_Shapes_Ext}', "");
    Expect(0, 129024, '\p{_-IS_Geometric_Shapes_Ext}', "");
    Expect(1, 129024, '\p{^_-IS_Geometric_Shapes_Ext}', "");
    Expect(1, 129024, '\P{_-IS_Geometric_Shapes_Ext}', "");
    Expect(0, 129024, '\P{^_-IS_Geometric_Shapes_Ext}', "");
    Error('\p{/a/_-In_Geometric_SHAPES_EXT}');
    Error('\P{/a/_-In_Geometric_SHAPES_EXT}');
    Expect(1, 129023, '\p{ingeometricshapesext}', "");
    Expect(0, 129023, '\p{^ingeometricshapesext}', "");
    Expect(0, 129023, '\P{ingeometricshapesext}', "");
    Expect(1, 129023, '\P{^ingeometricshapesext}', "");
    Expect(0, 129024, '\p{ingeometricshapesext}', "");
    Expect(1, 129024, '\p{^ingeometricshapesext}', "");
    Expect(1, 129024, '\P{ingeometricshapesext}', "");
    Expect(0, 129024, '\P{^ingeometricshapesext}', "");
    Expect(1, 129023, '\p{-_IN_geometric_Shapes_EXT}', "");
    Expect(0, 129023, '\p{^-_IN_geometric_Shapes_EXT}', "");
    Expect(0, 129023, '\P{-_IN_geometric_Shapes_EXT}', "");
    Expect(1, 129023, '\P{^-_IN_geometric_Shapes_EXT}', "");
    Expect(0, 129024, '\p{-_IN_geometric_Shapes_EXT}', "");
    Expect(1, 129024, '\p{^-_IN_geometric_Shapes_EXT}', "");
    Expect(1, 129024, '\P{-_IN_geometric_Shapes_EXT}', "");
    Expect(0, 129024, '\P{^-_IN_geometric_Shapes_EXT}', "");
    Error('\p{ _georgian:=}');
    Error('\P{ _georgian:=}');
    Expect(1, 11565, '\p{georgian}', "");
    Expect(0, 11565, '\p{^georgian}', "");
    Expect(0, 11565, '\P{georgian}', "");
    Expect(1, 11565, '\P{^georgian}', "");
    Expect(0, 11566, '\p{georgian}', "");
    Expect(1, 11566, '\p{^georgian}', "");
    Expect(1, 11566, '\P{georgian}', "");
    Expect(0, 11566, '\P{^georgian}', "");
    Expect(1, 11565, '\p{-	georgian}', "");
    Expect(0, 11565, '\p{^-	georgian}', "");
    Expect(0, 11565, '\P{-	georgian}', "");
    Expect(1, 11565, '\P{^-	georgian}', "");
    Expect(0, 11566, '\p{-	georgian}', "");
    Expect(1, 11566, '\p{^-	georgian}', "");
    Expect(1, 11566, '\P{-	georgian}', "");
    Expect(0, 11566, '\P{^-	georgian}', "");
    Error('\p{	Is_Georgian:=}');
    Error('\P{	Is_Georgian:=}');
    Expect(1, 11565, '\p{isgeorgian}', "");
    Expect(0, 11565, '\p{^isgeorgian}', "");
    Expect(0, 11565, '\P{isgeorgian}', "");
    Expect(1, 11565, '\P{^isgeorgian}', "");
    Expect(0, 11566, '\p{isgeorgian}', "");
    Expect(1, 11566, '\p{^isgeorgian}', "");
    Expect(1, 11566, '\P{isgeorgian}', "");
    Expect(0, 11566, '\P{^isgeorgian}', "");
    Expect(1, 11565, '\p{-Is_GEORGIAN}', "");
    Expect(0, 11565, '\p{^-Is_GEORGIAN}', "");
    Expect(0, 11565, '\P{-Is_GEORGIAN}', "");
    Expect(1, 11565, '\P{^-Is_GEORGIAN}', "");
    Expect(0, 11566, '\p{-Is_GEORGIAN}', "");
    Expect(1, 11566, '\p{^-Is_GEORGIAN}', "");
    Expect(1, 11566, '\P{-Is_GEORGIAN}', "");
    Expect(0, 11566, '\P{^-Is_GEORGIAN}', "");
    Error('\p{/a/	Geor}');
    Error('\P{/a/	Geor}');
    Expect(1, 11565, '\p{geor}', "");
    Expect(0, 11565, '\p{^geor}', "");
    Expect(0, 11565, '\P{geor}', "");
    Expect(1, 11565, '\P{^geor}', "");
    Expect(0, 11566, '\p{geor}', "");
    Expect(1, 11566, '\p{^geor}', "");
    Expect(1, 11566, '\P{geor}', "");
    Expect(0, 11566, '\P{^geor}', "");
    Expect(1, 11565, '\p{-	geor}', "");
    Expect(0, 11565, '\p{^-	geor}', "");
    Expect(0, 11565, '\P{-	geor}', "");
    Expect(1, 11565, '\P{^-	geor}', "");
    Expect(0, 11566, '\p{-	geor}', "");
    Expect(1, 11566, '\p{^-	geor}', "");
    Expect(1, 11566, '\P{-	geor}', "");
    Expect(0, 11566, '\P{^-	geor}', "");
    Error('\p{	/a/IS_Geor}');
    Error('\P{	/a/IS_Geor}');
    Expect(1, 11565, '\p{isgeor}', "");
    Expect(0, 11565, '\p{^isgeor}', "");
    Expect(0, 11565, '\P{isgeor}', "");
    Expect(1, 11565, '\P{^isgeor}', "");
    Expect(0, 11566, '\p{isgeor}', "");
    Expect(1, 11566, '\p{^isgeor}', "");
    Expect(1, 11566, '\P{isgeor}', "");
    Expect(0, 11566, '\P{^isgeor}', "");
    Expect(1, 11565, '\p{	IS_Geor}', "");
    Expect(0, 11565, '\p{^	IS_Geor}', "");
    Expect(0, 11565, '\P{	IS_Geor}', "");
    Expect(1, 11565, '\P{^	IS_Geor}', "");
    Expect(0, 11566, '\p{	IS_Geor}', "");
    Expect(1, 11566, '\p{^	IS_Geor}', "");
    Expect(1, 11566, '\P{	IS_Geor}', "");
    Expect(0, 11566, '\P{^	IS_Geor}', "");
    Error('\p{/a/	-georgian_Extended}');
    Error('\P{/a/	-georgian_Extended}');
    Expect(1, 7359, '\p{georgianextended}', "");
    Expect(0, 7359, '\p{^georgianextended}', "");
    Expect(0, 7359, '\P{georgianextended}', "");
    Expect(1, 7359, '\P{^georgianextended}', "");
    Expect(0, 7360, '\p{georgianextended}', "");
    Expect(1, 7360, '\p{^georgianextended}', "");
    Expect(1, 7360, '\P{georgianextended}', "");
    Expect(0, 7360, '\P{^georgianextended}', "");
    Expect(1, 7359, '\p{_-Georgian_EXTENDED}', "");
    Expect(0, 7359, '\p{^_-Georgian_EXTENDED}', "");
    Expect(0, 7359, '\P{_-Georgian_EXTENDED}', "");
    Expect(1, 7359, '\P{^_-Georgian_EXTENDED}', "");
    Expect(0, 7360, '\p{_-Georgian_EXTENDED}', "");
    Expect(1, 7360, '\p{^_-Georgian_EXTENDED}', "");
    Expect(1, 7360, '\P{_-Georgian_EXTENDED}', "");
    Expect(0, 7360, '\P{^_-Georgian_EXTENDED}', "");
    Error('\p{/a/ -is_Georgian_Extended}');
    Error('\P{/a/ -is_Georgian_Extended}');
    Expect(1, 7359, '\p{isgeorgianextended}', "");
    Expect(0, 7359, '\p{^isgeorgianextended}', "");
    Expect(0, 7359, '\P{isgeorgianextended}', "");
    Expect(1, 7359, '\P{^isgeorgianextended}', "");
    Expect(0, 7360, '\p{isgeorgianextended}', "");
    Expect(1, 7360, '\p{^isgeorgianextended}', "");
    Expect(1, 7360, '\P{isgeorgianextended}', "");
    Expect(0, 7360, '\P{^isgeorgianextended}', "");
    Expect(1, 7359, '\p{ _Is_georgian_extended}', "");
    Expect(0, 7359, '\p{^ _Is_georgian_extended}', "");
    Expect(0, 7359, '\P{ _Is_georgian_extended}', "");
    Expect(1, 7359, '\P{^ _Is_georgian_extended}', "");
    Expect(0, 7360, '\p{ _Is_georgian_extended}', "");
    Expect(1, 7360, '\p{^ _Is_georgian_extended}', "");
    Expect(1, 7360, '\P{ _Is_georgian_extended}', "");
    Expect(0, 7360, '\P{^ _Is_georgian_extended}', "");
    Error('\p{-:=in_Georgian_extended}');
    Error('\P{-:=in_Georgian_extended}');
    Expect(1, 7359, '\p{ingeorgianextended}', "");
    Expect(0, 7359, '\p{^ingeorgianextended}', "");
    Expect(0, 7359, '\P{ingeorgianextended}', "");
    Expect(1, 7359, '\P{^ingeorgianextended}', "");
    Expect(0, 7360, '\p{ingeorgianextended}', "");
    Expect(1, 7360, '\p{^ingeorgianextended}', "");
    Expect(1, 7360, '\P{ingeorgianextended}', "");
    Expect(0, 7360, '\P{^ingeorgianextended}', "");
    Expect(1, 7359, '\p{	 In_Georgian_Extended}', "");
    Expect(0, 7359, '\p{^	 In_Georgian_Extended}', "");
    Expect(0, 7359, '\P{	 In_Georgian_Extended}', "");
    Expect(1, 7359, '\P{^	 In_Georgian_Extended}', "");
    Expect(0, 7360, '\p{	 In_Georgian_Extended}', "");
    Expect(1, 7360, '\p{^	 In_Georgian_Extended}', "");
    Expect(1, 7360, '\P{	 In_Georgian_Extended}', "");
    Expect(0, 7360, '\P{^	 In_Georgian_Extended}', "");
    Error('\p{:=Georgian_EXT}');
    Error('\P{:=Georgian_EXT}');
    Expect(1, 7359, '\p{georgianext}', "");
    Expect(0, 7359, '\p{^georgianext}', "");
    Expect(0, 7359, '\P{georgianext}', "");
    Expect(1, 7359, '\P{^georgianext}', "");
    Expect(0, 7360, '\p{georgianext}', "");
    Expect(1, 7360, '\p{^georgianext}', "");
    Expect(1, 7360, '\P{georgianext}', "");
    Expect(0, 7360, '\P{^georgianext}', "");
    Expect(1, 7359, '\p{		Georgian_ext}', "");
    Expect(0, 7359, '\p{^		Georgian_ext}', "");
    Expect(0, 7359, '\P{		Georgian_ext}', "");
    Expect(1, 7359, '\P{^		Georgian_ext}', "");
    Expect(0, 7360, '\p{		Georgian_ext}', "");
    Expect(1, 7360, '\p{^		Georgian_ext}', "");
    Expect(1, 7360, '\P{		Georgian_ext}', "");
    Expect(0, 7360, '\P{^		Georgian_ext}', "");
    Error('\p{/a/ Is_Georgian_EXT}');
    Error('\P{/a/ Is_Georgian_EXT}');
    Expect(1, 7359, '\p{isgeorgianext}', "");
    Expect(0, 7359, '\p{^isgeorgianext}', "");
    Expect(0, 7359, '\P{isgeorgianext}', "");
    Expect(1, 7359, '\P{^isgeorgianext}', "");
    Expect(0, 7360, '\p{isgeorgianext}', "");
    Expect(1, 7360, '\p{^isgeorgianext}', "");
    Expect(1, 7360, '\P{isgeorgianext}', "");
    Expect(0, 7360, '\P{^isgeorgianext}', "");
    Expect(1, 7359, '\p{-Is_Georgian_EXT}', "");
    Expect(0, 7359, '\p{^-Is_Georgian_EXT}', "");
    Expect(0, 7359, '\P{-Is_Georgian_EXT}', "");
    Expect(1, 7359, '\P{^-Is_Georgian_EXT}', "");
    Expect(0, 7360, '\p{-Is_Georgian_EXT}', "");
    Expect(1, 7360, '\p{^-Is_Georgian_EXT}', "");
    Expect(1, 7360, '\P{-Is_Georgian_EXT}', "");
    Expect(0, 7360, '\P{^-Is_Georgian_EXT}', "");
    Error('\p{-IN_Georgian_Ext/a/}');
    Error('\P{-IN_Georgian_Ext/a/}');
    Expect(1, 7359, '\p{ingeorgianext}', "");
    Expect(0, 7359, '\p{^ingeorgianext}', "");
    Expect(0, 7359, '\P{ingeorgianext}', "");
    Expect(1, 7359, '\P{^ingeorgianext}', "");
    Expect(0, 7360, '\p{ingeorgianext}', "");
    Expect(1, 7360, '\p{^ingeorgianext}', "");
    Expect(1, 7360, '\P{ingeorgianext}', "");
    Expect(0, 7360, '\P{^ingeorgianext}', "");
    Expect(1, 7359, '\p{_ in_Georgian_EXT}', "");
    Expect(0, 7359, '\p{^_ in_Georgian_EXT}', "");
    Expect(0, 7359, '\P{_ in_Georgian_EXT}', "");
    Expect(1, 7359, '\P{^_ in_Georgian_EXT}', "");
    Expect(0, 7360, '\p{_ in_Georgian_EXT}', "");
    Expect(1, 7360, '\p{^_ in_Georgian_EXT}', "");
    Expect(1, 7360, '\P{_ in_Georgian_EXT}', "");
    Expect(0, 7360, '\P{^_ in_Georgian_EXT}', "");
    Error('\p{_/a/Georgian_supplement}');
    Error('\P{_/a/Georgian_supplement}');
    Expect(1, 11567, '\p{georgiansupplement}', "");
    Expect(0, 11567, '\p{^georgiansupplement}', "");
    Expect(0, 11567, '\P{georgiansupplement}', "");
    Expect(1, 11567, '\P{^georgiansupplement}', "");
    Expect(0, 11568, '\p{georgiansupplement}', "");
    Expect(1, 11568, '\p{^georgiansupplement}', "");
    Expect(1, 11568, '\P{georgiansupplement}', "");
    Expect(0, 11568, '\P{^georgiansupplement}', "");
    Expect(1, 11567, '\p{ 	GEORGIAN_Supplement}', "");
    Expect(0, 11567, '\p{^ 	GEORGIAN_Supplement}', "");
    Expect(0, 11567, '\P{ 	GEORGIAN_Supplement}', "");
    Expect(1, 11567, '\P{^ 	GEORGIAN_Supplement}', "");
    Expect(0, 11568, '\p{ 	GEORGIAN_Supplement}', "");
    Expect(1, 11568, '\p{^ 	GEORGIAN_Supplement}', "");
    Expect(1, 11568, '\P{ 	GEORGIAN_Supplement}', "");
    Expect(0, 11568, '\P{^ 	GEORGIAN_Supplement}', "");
    Error('\p{/a/ -is_Georgian_supplement}');
    Error('\P{/a/ -is_Georgian_supplement}');
    Expect(1, 11567, '\p{isgeorgiansupplement}', "");
    Expect(0, 11567, '\p{^isgeorgiansupplement}', "");
    Expect(0, 11567, '\P{isgeorgiansupplement}', "");
    Expect(1, 11567, '\P{^isgeorgiansupplement}', "");
    Expect(0, 11568, '\p{isgeorgiansupplement}', "");
    Expect(1, 11568, '\p{^isgeorgiansupplement}', "");
    Expect(1, 11568, '\P{isgeorgiansupplement}', "");
    Expect(0, 11568, '\P{^isgeorgiansupplement}', "");
    Expect(1, 11567, '\p{-_is_Georgian_Supplement}', "");
    Expect(0, 11567, '\p{^-_is_Georgian_Supplement}', "");
    Expect(0, 11567, '\P{-_is_Georgian_Supplement}', "");
    Expect(1, 11567, '\P{^-_is_Georgian_Supplement}', "");
    Expect(0, 11568, '\p{-_is_Georgian_Supplement}', "");
    Expect(1, 11568, '\p{^-_is_Georgian_Supplement}', "");
    Expect(1, 11568, '\P{-_is_Georgian_Supplement}', "");
    Expect(0, 11568, '\P{^-_is_Georgian_Supplement}', "");
    Error('\p{ In_GEORGIAN_supplement/a/}');
    Error('\P{ In_GEORGIAN_supplement/a/}');
    Expect(1, 11567, '\p{ingeorgiansupplement}', "");
    Expect(0, 11567, '\p{^ingeorgiansupplement}', "");
    Expect(0, 11567, '\P{ingeorgiansupplement}', "");
    Expect(1, 11567, '\P{^ingeorgiansupplement}', "");
    Expect(0, 11568, '\p{ingeorgiansupplement}', "");
    Expect(1, 11568, '\p{^ingeorgiansupplement}', "");
    Expect(1, 11568, '\P{ingeorgiansupplement}', "");
    Expect(0, 11568, '\P{^ingeorgiansupplement}', "");
    Expect(1, 11567, '\p{ In_Georgian_SUPPLEMENT}', "");
    Expect(0, 11567, '\p{^ In_Georgian_SUPPLEMENT}', "");
    Expect(0, 11567, '\P{ In_Georgian_SUPPLEMENT}', "");
    Expect(1, 11567, '\P{^ In_Georgian_SUPPLEMENT}', "");
    Expect(0, 11568, '\p{ In_Georgian_SUPPLEMENT}', "");
    Expect(1, 11568, '\p{^ In_Georgian_SUPPLEMENT}', "");
    Expect(1, 11568, '\P{ In_Georgian_SUPPLEMENT}', "");
    Expect(0, 11568, '\P{^ In_Georgian_SUPPLEMENT}', "");
    Error('\p{/a/	Georgian_sup}');
    Error('\P{/a/	Georgian_sup}');
    Expect(1, 11567, '\p{georgiansup}', "");
    Expect(0, 11567, '\p{^georgiansup}', "");
    Expect(0, 11567, '\P{georgiansup}', "");
    Expect(1, 11567, '\P{^georgiansup}', "");
    Expect(0, 11568, '\p{georgiansup}', "");
    Expect(1, 11568, '\p{^georgiansup}', "");
    Expect(1, 11568, '\P{georgiansup}', "");
    Expect(0, 11568, '\P{^georgiansup}', "");
    Expect(1, 11567, '\p{	GEORGIAN_Sup}', "");
    Expect(0, 11567, '\p{^	GEORGIAN_Sup}', "");
    Expect(0, 11567, '\P{	GEORGIAN_Sup}', "");
    Expect(1, 11567, '\P{^	GEORGIAN_Sup}', "");
    Expect(0, 11568, '\p{	GEORGIAN_Sup}', "");
    Expect(1, 11568, '\p{^	GEORGIAN_Sup}', "");
    Expect(1, 11568, '\P{	GEORGIAN_Sup}', "");
    Expect(0, 11568, '\P{^	GEORGIAN_Sup}', "");
    Error('\p{/a/_-Is_georgian_Sup}');
    Error('\P{/a/_-Is_georgian_Sup}');
    Expect(1, 11567, '\p{isgeorgiansup}', "");
    Expect(0, 11567, '\p{^isgeorgiansup}', "");
    Expect(0, 11567, '\P{isgeorgiansup}', "");
    Expect(1, 11567, '\P{^isgeorgiansup}', "");
    Expect(0, 11568, '\p{isgeorgiansup}', "");
    Expect(1, 11568, '\p{^isgeorgiansup}', "");
    Expect(1, 11568, '\P{isgeorgiansup}', "");
    Expect(0, 11568, '\P{^isgeorgiansup}', "");
    Expect(1, 11567, '\p{_-Is_Georgian_Sup}', "");
    Expect(0, 11567, '\p{^_-Is_Georgian_Sup}', "");
    Expect(0, 11567, '\P{_-Is_Georgian_Sup}', "");
    Expect(1, 11567, '\P{^_-Is_Georgian_Sup}', "");
    Expect(0, 11568, '\p{_-Is_Georgian_Sup}', "");
    Expect(1, 11568, '\p{^_-Is_Georgian_Sup}', "");
    Expect(1, 11568, '\P{_-Is_Georgian_Sup}', "");
    Expect(0, 11568, '\P{^_-Is_Georgian_Sup}', "");
    Error('\p{ /a/In_GEORGIAN_sup}');
    Error('\P{ /a/In_GEORGIAN_sup}');
    Expect(1, 11567, '\p{ingeorgiansup}', "");
    Expect(0, 11567, '\p{^ingeorgiansup}', "");
    Expect(0, 11567, '\P{ingeorgiansup}', "");
    Expect(1, 11567, '\P{^ingeorgiansup}', "");
    Expect(0, 11568, '\p{ingeorgiansup}', "");
    Expect(1, 11568, '\p{^ingeorgiansup}', "");
    Expect(1, 11568, '\P{ingeorgiansup}', "");
    Expect(0, 11568, '\P{^ingeorgiansup}', "");
    Expect(1, 11567, '\p{ _in_Georgian_Sup}', "");
    Expect(0, 11567, '\p{^ _in_Georgian_Sup}', "");
    Expect(0, 11567, '\P{ _in_Georgian_Sup}', "");
    Expect(1, 11567, '\P{^ _in_Georgian_Sup}', "");
    Expect(0, 11568, '\p{ _in_Georgian_Sup}', "");
    Expect(1, 11568, '\p{^ _in_Georgian_Sup}', "");
    Expect(1, 11568, '\P{ _in_Georgian_Sup}', "");
    Expect(0, 11568, '\P{^ _in_Georgian_Sup}', "");
    Error('\p{:=_Glagolitic}');
    Error('\P{:=_Glagolitic}');
    Expect(1, 122922, '\p{glagolitic}', "");
    Expect(0, 122922, '\p{^glagolitic}', "");
    Expect(0, 122922, '\P{glagolitic}', "");
    Expect(1, 122922, '\P{^glagolitic}', "");
    Expect(0, 122923, '\p{glagolitic}', "");
    Expect(1, 122923, '\p{^glagolitic}', "");
    Expect(1, 122923, '\P{glagolitic}', "");
    Expect(0, 122923, '\P{^glagolitic}', "");
    Expect(1, 122922, '\p{-glagolitic}', "");
    Expect(0, 122922, '\p{^-glagolitic}', "");
    Expect(0, 122922, '\P{-glagolitic}', "");
    Expect(1, 122922, '\P{^-glagolitic}', "");
    Expect(0, 122923, '\p{-glagolitic}', "");
    Expect(1, 122923, '\p{^-glagolitic}', "");
    Expect(1, 122923, '\P{-glagolitic}', "");
    Expect(0, 122923, '\P{^-glagolitic}', "");
    Error('\p{/a/  is_Glagolitic}');
    Error('\P{/a/  is_Glagolitic}');
    Expect(1, 122922, '\p{isglagolitic}', "");
    Expect(0, 122922, '\p{^isglagolitic}', "");
    Expect(0, 122922, '\P{isglagolitic}', "");
    Expect(1, 122922, '\P{^isglagolitic}', "");
    Expect(0, 122923, '\p{isglagolitic}', "");
    Expect(1, 122923, '\p{^isglagolitic}', "");
    Expect(1, 122923, '\P{isglagolitic}', "");
    Expect(0, 122923, '\P{^isglagolitic}', "");
    Expect(1, 122922, '\p{ 	Is_glagolitic}', "");
    Expect(0, 122922, '\p{^ 	Is_glagolitic}', "");
    Expect(0, 122922, '\P{ 	Is_glagolitic}', "");
    Expect(1, 122922, '\P{^ 	Is_glagolitic}', "");
    Expect(0, 122923, '\p{ 	Is_glagolitic}', "");
    Expect(1, 122923, '\p{^ 	Is_glagolitic}', "");
    Expect(1, 122923, '\P{ 	Is_glagolitic}', "");
    Expect(0, 122923, '\P{^ 	Is_glagolitic}', "");
    Error('\p{-GLAG:=}');
    Error('\P{-GLAG:=}');
    Expect(1, 122922, '\p{glag}', "");
    Expect(0, 122922, '\p{^glag}', "");
    Expect(0, 122922, '\P{glag}', "");
    Expect(1, 122922, '\P{^glag}', "");
    Expect(0, 122923, '\p{glag}', "");
    Expect(1, 122923, '\p{^glag}', "");
    Expect(1, 122923, '\P{glag}', "");
    Expect(0, 122923, '\P{^glag}', "");
    Expect(1, 122922, '\p{ glag}', "");
    Expect(0, 122922, '\p{^ glag}', "");
    Expect(0, 122922, '\P{ glag}', "");
    Expect(1, 122922, '\P{^ glag}', "");
    Expect(0, 122923, '\p{ glag}', "");
    Expect(1, 122923, '\p{^ glag}', "");
    Expect(1, 122923, '\P{ glag}', "");
    Expect(0, 122923, '\P{^ glag}', "");
    Error('\p{_	is_Glag:=}');
    Error('\P{_	is_Glag:=}');
    Expect(1, 122922, '\p{isglag}', "");
    Expect(0, 122922, '\p{^isglag}', "");
    Expect(0, 122922, '\P{isglag}', "");
    Expect(1, 122922, '\P{^isglag}', "");
    Expect(0, 122923, '\p{isglag}', "");
    Expect(1, 122923, '\p{^isglag}', "");
    Expect(1, 122923, '\P{isglag}', "");
    Expect(0, 122923, '\P{^isglag}', "");
    Expect(1, 122922, '\p{-Is_glag}', "");
    Expect(0, 122922, '\p{^-Is_glag}', "");
    Expect(0, 122922, '\P{-Is_glag}', "");
    Expect(1, 122922, '\P{^-Is_glag}', "");
    Expect(0, 122923, '\p{-Is_glag}', "");
    Expect(1, 122923, '\p{^-Is_glag}', "");
    Expect(1, 122923, '\P{-Is_glag}', "");
    Expect(0, 122923, '\P{^-Is_glag}', "");
    Error('\p{/a/ _Glagolitic_supplement}');
    Error('\P{/a/ _Glagolitic_supplement}');
    Expect(1, 122927, '\p{glagoliticsupplement}', "");
    Expect(0, 122927, '\p{^glagoliticsupplement}', "");
    Expect(0, 122927, '\P{glagoliticsupplement}', "");
    Expect(1, 122927, '\P{^glagoliticsupplement}', "");
    Expect(0, 122928, '\p{glagoliticsupplement}', "");
    Expect(1, 122928, '\p{^glagoliticsupplement}', "");
    Expect(1, 122928, '\P{glagoliticsupplement}', "");
    Expect(0, 122928, '\P{^glagoliticsupplement}', "");
    Expect(1, 122927, '\p{ glagolitic_Supplement}', "");
    Expect(0, 122927, '\p{^ glagolitic_Supplement}', "");
    Expect(0, 122927, '\P{ glagolitic_Supplement}', "");
    Expect(1, 122927, '\P{^ glagolitic_Supplement}', "");
    Expect(0, 122928, '\p{ glagolitic_Supplement}', "");
    Expect(1, 122928, '\p{^ glagolitic_Supplement}', "");
    Expect(1, 122928, '\P{ glagolitic_Supplement}', "");
    Expect(0, 122928, '\P{^ glagolitic_Supplement}', "");
    Error('\p{:=_	is_Glagolitic_Supplement}');
    Error('\P{:=_	is_Glagolitic_Supplement}');
    Expect(1, 122927, '\p{isglagoliticsupplement}', "");
    Expect(0, 122927, '\p{^isglagoliticsupplement}', "");
    Expect(0, 122927, '\P{isglagoliticsupplement}', "");
    Expect(1, 122927, '\P{^isglagoliticsupplement}', "");
    Expect(0, 122928, '\p{isglagoliticsupplement}', "");
    Expect(1, 122928, '\p{^isglagoliticsupplement}', "");
    Expect(1, 122928, '\P{isglagoliticsupplement}', "");
    Expect(0, 122928, '\P{^isglagoliticsupplement}', "");
    Expect(1, 122927, '\p{	 Is_GLAGOLITIC_supplement}', "");
    Expect(0, 122927, '\p{^	 Is_GLAGOLITIC_supplement}', "");
    Expect(0, 122927, '\P{	 Is_GLAGOLITIC_supplement}', "");
    Expect(1, 122927, '\P{^	 Is_GLAGOLITIC_supplement}', "");
    Expect(0, 122928, '\p{	 Is_GLAGOLITIC_supplement}', "");
    Expect(1, 122928, '\p{^	 Is_GLAGOLITIC_supplement}', "");
    Expect(1, 122928, '\P{	 Is_GLAGOLITIC_supplement}', "");
    Expect(0, 122928, '\P{^	 Is_GLAGOLITIC_supplement}', "");
    Error('\p{  In_GLAGOLITIC_Supplement:=}');
    Error('\P{  In_GLAGOLITIC_Supplement:=}');
    Expect(1, 122927, '\p{inglagoliticsupplement}', "");
    Expect(0, 122927, '\p{^inglagoliticsupplement}', "");
    Expect(0, 122927, '\P{inglagoliticsupplement}', "");
    Expect(1, 122927, '\P{^inglagoliticsupplement}', "");
    Expect(0, 122928, '\p{inglagoliticsupplement}', "");
    Expect(1, 122928, '\p{^inglagoliticsupplement}', "");
    Expect(1, 122928, '\P{inglagoliticsupplement}', "");
    Expect(0, 122928, '\P{^inglagoliticsupplement}', "");
    Expect(1, 122927, '\p{- In_Glagolitic_supplement}', "");
    Expect(0, 122927, '\p{^- In_Glagolitic_supplement}', "");
    Expect(0, 122927, '\P{- In_Glagolitic_supplement}', "");
    Expect(1, 122927, '\P{^- In_Glagolitic_supplement}', "");
    Expect(0, 122928, '\p{- In_Glagolitic_supplement}', "");
    Expect(1, 122928, '\p{^- In_Glagolitic_supplement}', "");
    Expect(1, 122928, '\P{- In_Glagolitic_supplement}', "");
    Expect(0, 122928, '\P{^- In_Glagolitic_supplement}', "");
    Error('\p{ :=Glagolitic_Sup}');
    Error('\P{ :=Glagolitic_Sup}');
    Expect(1, 122927, '\p{glagoliticsup}', "");
    Expect(0, 122927, '\p{^glagoliticsup}', "");
    Expect(0, 122927, '\P{glagoliticsup}', "");
    Expect(1, 122927, '\P{^glagoliticsup}', "");
    Expect(0, 122928, '\p{glagoliticsup}', "");
    Expect(1, 122928, '\p{^glagoliticsup}', "");
    Expect(1, 122928, '\P{glagoliticsup}', "");
    Expect(0, 122928, '\P{^glagoliticsup}', "");
    Expect(1, 122927, '\p{-_Glagolitic_sup}', "");
    Expect(0, 122927, '\p{^-_Glagolitic_sup}', "");
    Expect(0, 122927, '\P{-_Glagolitic_sup}', "");
    Expect(1, 122927, '\P{^-_Glagolitic_sup}', "");
    Expect(0, 122928, '\p{-_Glagolitic_sup}', "");
    Expect(1, 122928, '\p{^-_Glagolitic_sup}', "");
    Expect(1, 122928, '\P{-_Glagolitic_sup}', "");
    Expect(0, 122928, '\P{^-_Glagolitic_sup}', "");
    Error('\p{:=	Is_glagolitic_SUP}');
    Error('\P{:=	Is_glagolitic_SUP}');
    Expect(1, 122927, '\p{isglagoliticsup}', "");
    Expect(0, 122927, '\p{^isglagoliticsup}', "");
    Expect(0, 122927, '\P{isglagoliticsup}', "");
    Expect(1, 122927, '\P{^isglagoliticsup}', "");
    Expect(0, 122928, '\p{isglagoliticsup}', "");
    Expect(1, 122928, '\p{^isglagoliticsup}', "");
    Expect(1, 122928, '\P{isglagoliticsup}', "");
    Expect(0, 122928, '\P{^isglagoliticsup}', "");
    Expect(1, 122927, '\p{-IS_glagolitic_Sup}', "");
    Expect(0, 122927, '\p{^-IS_glagolitic_Sup}', "");
    Expect(0, 122927, '\P{-IS_glagolitic_Sup}', "");
    Expect(1, 122927, '\P{^-IS_glagolitic_Sup}', "");
    Expect(0, 122928, '\p{-IS_glagolitic_Sup}', "");
    Expect(1, 122928, '\p{^-IS_glagolitic_Sup}', "");
    Expect(1, 122928, '\P{-IS_glagolitic_Sup}', "");
    Expect(0, 122928, '\P{^-IS_glagolitic_Sup}', "");
    Error('\p{:=IN_GLAGOLITIC_SUP}');
    Error('\P{:=IN_GLAGOLITIC_SUP}');
    Expect(1, 122927, '\p{inglagoliticsup}', "");
    Expect(0, 122927, '\p{^inglagoliticsup}', "");
    Expect(0, 122927, '\P{inglagoliticsup}', "");
    Expect(1, 122927, '\P{^inglagoliticsup}', "");
    Expect(0, 122928, '\p{inglagoliticsup}', "");
    Expect(1, 122928, '\p{^inglagoliticsup}', "");
    Expect(1, 122928, '\P{inglagoliticsup}', "");
    Expect(0, 122928, '\P{^inglagoliticsup}', "");
    Expect(1, 122927, '\p{	 In_glagolitic_Sup}', "");
    Expect(0, 122927, '\p{^	 In_glagolitic_Sup}', "");
    Expect(0, 122927, '\P{	 In_glagolitic_Sup}', "");
    Expect(1, 122927, '\P{^	 In_glagolitic_Sup}', "");
    Expect(0, 122928, '\p{	 In_glagolitic_Sup}', "");
    Expect(1, 122928, '\p{^	 In_glagolitic_Sup}', "");
    Expect(1, 122928, '\P{	 In_glagolitic_Sup}', "");
    Expect(0, 122928, '\P{^	 In_glagolitic_Sup}', "");
    Error('\p{ 	Gothic:=}');
    Error('\P{ 	Gothic:=}');
    Expect(1, 66378, '\p{gothic}', "");
    Expect(0, 66378, '\p{^gothic}', "");
    Expect(0, 66378, '\P{gothic}', "");
    Expect(1, 66378, '\P{^gothic}', "");
    Expect(0, 66379, '\p{gothic}', "");
    Expect(1, 66379, '\p{^gothic}', "");
    Expect(1, 66379, '\P{gothic}', "");
    Expect(0, 66379, '\P{^gothic}', "");
    Expect(1, 66378, '\p{Gothic}', "");
    Expect(0, 66378, '\p{^Gothic}', "");
    Expect(0, 66378, '\P{Gothic}', "");
    Expect(1, 66378, '\P{^Gothic}', "");
    Expect(0, 66379, '\p{Gothic}', "");
    Expect(1, 66379, '\p{^Gothic}', "");
    Expect(1, 66379, '\P{Gothic}', "");
    Expect(0, 66379, '\P{^Gothic}', "");
    Error('\p{/a/	-is_Gothic}');
    Error('\P{/a/	-is_Gothic}');
    Expect(1, 66378, '\p{isgothic}', "");
    Expect(0, 66378, '\p{^isgothic}', "");
    Expect(0, 66378, '\P{isgothic}', "");
    Expect(1, 66378, '\P{^isgothic}', "");
    Expect(0, 66379, '\p{isgothic}', "");
    Expect(1, 66379, '\p{^isgothic}', "");
    Expect(1, 66379, '\P{isgothic}', "");
    Expect(0, 66379, '\P{^isgothic}', "");
    Expect(1, 66378, '\p{	IS_Gothic}', "");
    Expect(0, 66378, '\p{^	IS_Gothic}', "");
    Expect(0, 66378, '\P{	IS_Gothic}', "");
    Expect(1, 66378, '\P{^	IS_Gothic}', "");
    Expect(0, 66379, '\p{	IS_Gothic}', "");
    Expect(1, 66379, '\p{^	IS_Gothic}', "");
    Expect(1, 66379, '\P{	IS_Gothic}', "");
    Expect(0, 66379, '\P{^	IS_Gothic}', "");
    Error('\p{-:=Goth}');
    Error('\P{-:=Goth}');
    Expect(1, 66378, '\p{goth}', "");
    Expect(0, 66378, '\p{^goth}', "");
    Expect(0, 66378, '\P{goth}', "");
    Expect(1, 66378, '\P{^goth}', "");
    Expect(0, 66379, '\p{goth}', "");
    Expect(1, 66379, '\p{^goth}', "");
    Expect(1, 66379, '\P{goth}', "");
    Expect(0, 66379, '\P{^goth}', "");
    Expect(1, 66378, '\p{_GOTH}', "");
    Expect(0, 66378, '\p{^_GOTH}', "");
    Expect(0, 66378, '\P{_GOTH}', "");
    Expect(1, 66378, '\P{^_GOTH}', "");
    Expect(0, 66379, '\p{_GOTH}', "");
    Expect(1, 66379, '\p{^_GOTH}', "");
    Expect(1, 66379, '\P{_GOTH}', "");
    Expect(0, 66379, '\P{^_GOTH}', "");
    Error('\p{:=_Is_Goth}');
    Error('\P{:=_Is_Goth}');
    Expect(1, 66378, '\p{isgoth}', "");
    Expect(0, 66378, '\p{^isgoth}', "");
    Expect(0, 66378, '\P{isgoth}', "");
    Expect(1, 66378, '\P{^isgoth}', "");
    Expect(0, 66379, '\p{isgoth}', "");
    Expect(1, 66379, '\p{^isgoth}', "");
    Expect(1, 66379, '\P{isgoth}', "");
    Expect(0, 66379, '\P{^isgoth}', "");
    Expect(1, 66378, '\p{_Is_goth}', "");
    Expect(0, 66378, '\p{^_Is_goth}', "");
    Expect(0, 66378, '\P{_Is_goth}', "");
    Expect(1, 66378, '\P{^_Is_goth}', "");
    Expect(0, 66379, '\p{_Is_goth}', "");
    Expect(1, 66379, '\p{^_Is_goth}', "");
    Expect(1, 66379, '\P{_Is_goth}', "");
    Expect(0, 66379, '\P{^_Is_goth}', "");
    Error('\p{/a/grantha}');
    Error('\P{/a/grantha}');
    Expect(1, 73683, '\p{grantha}', "");
    Expect(0, 73683, '\p{^grantha}', "");
    Expect(0, 73683, '\P{grantha}', "");
    Expect(1, 73683, '\P{^grantha}', "");
    Expect(0, 73684, '\p{grantha}', "");
    Expect(1, 73684, '\p{^grantha}', "");
    Expect(1, 73684, '\P{grantha}', "");
    Expect(0, 73684, '\P{^grantha}', "");
    Expect(1, 73683, '\p{  Grantha}', "");
    Expect(0, 73683, '\p{^  Grantha}', "");
    Expect(0, 73683, '\P{  Grantha}', "");
    Expect(1, 73683, '\P{^  Grantha}', "");
    Expect(0, 73684, '\p{  Grantha}', "");
    Expect(1, 73684, '\p{^  Grantha}', "");
    Expect(1, 73684, '\P{  Grantha}', "");
    Expect(0, 73684, '\P{^  Grantha}', "");
    Error('\p{-_is_Grantha:=}');
    Error('\P{-_is_Grantha:=}');
    Expect(1, 73683, '\p{isgrantha}', "");
    Expect(0, 73683, '\p{^isgrantha}', "");
    Expect(0, 73683, '\P{isgrantha}', "");
    Expect(1, 73683, '\P{^isgrantha}', "");
    Expect(0, 73684, '\p{isgrantha}', "");
    Expect(1, 73684, '\p{^isgrantha}', "");
    Expect(1, 73684, '\P{isgrantha}', "");
    Expect(0, 73684, '\P{^isgrantha}', "");
    Expect(1, 73683, '\p{-is_Grantha}', "");
    Expect(0, 73683, '\p{^-is_Grantha}', "");
    Expect(0, 73683, '\P{-is_Grantha}', "");
    Expect(1, 73683, '\P{^-is_Grantha}', "");
    Expect(0, 73684, '\p{-is_Grantha}', "");
    Expect(1, 73684, '\p{^-is_Grantha}', "");
    Expect(1, 73684, '\P{-is_Grantha}', "");
    Expect(0, 73684, '\P{^-is_Grantha}', "");
    Error('\p{	/a/GRAN}');
    Error('\P{	/a/GRAN}');
    Expect(1, 73683, '\p{gran}', "");
    Expect(0, 73683, '\p{^gran}', "");
    Expect(0, 73683, '\P{gran}', "");
    Expect(1, 73683, '\P{^gran}', "");
    Expect(0, 73684, '\p{gran}', "");
    Expect(1, 73684, '\p{^gran}', "");
    Expect(1, 73684, '\P{gran}', "");
    Expect(0, 73684, '\P{^gran}', "");
    Expect(1, 73683, '\p{ gran}', "");
    Expect(0, 73683, '\p{^ gran}', "");
    Expect(0, 73683, '\P{ gran}', "");
    Expect(1, 73683, '\P{^ gran}', "");
    Expect(0, 73684, '\p{ gran}', "");
    Expect(1, 73684, '\p{^ gran}', "");
    Expect(1, 73684, '\P{ gran}', "");
    Expect(0, 73684, '\P{^ gran}', "");
    Error('\p{/a/IS_gran}');
    Error('\P{/a/IS_gran}');
    Expect(1, 73683, '\p{isgran}', "");
    Expect(0, 73683, '\p{^isgran}', "");
    Expect(0, 73683, '\P{isgran}', "");
    Expect(1, 73683, '\P{^isgran}', "");
    Expect(0, 73684, '\p{isgran}', "");
    Expect(1, 73684, '\p{^isgran}', "");
    Expect(1, 73684, '\P{isgran}', "");
    Expect(0, 73684, '\P{^isgran}', "");
    Expect(1, 73683, '\p{_IS_GRAN}', "");
    Expect(0, 73683, '\p{^_IS_GRAN}', "");
    Expect(0, 73683, '\P{_IS_GRAN}', "");
    Expect(1, 73683, '\P{^_IS_GRAN}', "");
    Expect(0, 73684, '\p{_IS_GRAN}', "");
    Expect(1, 73684, '\p{^_IS_GRAN}', "");
    Expect(1, 73684, '\P{_IS_GRAN}', "");
    Expect(0, 73684, '\P{^_IS_GRAN}', "");
    Error('\p{:=_ XPosixGraph}');
    Error('\P{:=_ XPosixGraph}');
    Expect(1, 1114109, '\p{xposixgraph}', "");
    Expect(0, 1114109, '\p{^xposixgraph}', "");
    Expect(0, 1114109, '\P{xposixgraph}', "");
    Expect(1, 1114109, '\P{^xposixgraph}', "");
    Expect(0, 918000, '\p{xposixgraph}', "");
    Expect(1, 918000, '\p{^xposixgraph}', "");
    Expect(1, 918000, '\P{xposixgraph}', "");
    Expect(0, 918000, '\P{^xposixgraph}', "");
    Expect(1, 1114109, '\p{-	XPosixGraph}', "");
    Expect(0, 1114109, '\p{^-	XPosixGraph}', "");
    Expect(0, 1114109, '\P{-	XPosixGraph}', "");
    Expect(1, 1114109, '\P{^-	XPosixGraph}', "");
    Expect(0, 918000, '\p{-	XPosixGraph}', "");
    Expect(1, 918000, '\p{^-	XPosixGraph}', "");
    Expect(1, 918000, '\P{-	XPosixGraph}', "");
    Expect(0, 918000, '\P{^-	XPosixGraph}', "");
    Error('\p{:=_graph}');
    Error('\P{:=_graph}');
    Expect(1, 1114109, '\p{graph}', "");
    Expect(0, 1114109, '\p{^graph}', "");
    Expect(0, 1114109, '\P{graph}', "");
    Expect(1, 1114109, '\P{^graph}', "");
    Expect(0, 918000, '\p{graph}', "");
    Expect(1, 918000, '\p{^graph}', "");
    Expect(1, 918000, '\P{graph}', "");
    Expect(0, 918000, '\P{^graph}', "");
    Expect(1, 1114109, '\p{--graph}', "");
    Expect(0, 1114109, '\p{^--graph}', "");
    Expect(0, 1114109, '\P{--graph}', "");
    Expect(1, 1114109, '\P{^--graph}', "");
    Expect(0, 918000, '\p{--graph}', "");
    Expect(1, 918000, '\p{^--graph}', "");
    Expect(1, 918000, '\P{--graph}', "");
    Expect(0, 918000, '\P{^--graph}', "");
    Error('\p{-/a/Is_XPOSIXGRAPH}');
    Error('\P{-/a/Is_XPOSIXGRAPH}');
    Expect(1, 1114109, '\p{isxposixgraph}', "");
    Expect(0, 1114109, '\p{^isxposixgraph}', "");
    Expect(0, 1114109, '\P{isxposixgraph}', "");
    Expect(1, 1114109, '\P{^isxposixgraph}', "");
    Expect(0, 918000, '\p{isxposixgraph}', "");
    Expect(1, 918000, '\p{^isxposixgraph}', "");
    Expect(1, 918000, '\P{isxposixgraph}', "");
    Expect(0, 918000, '\P{^isxposixgraph}', "");
    Expect(1, 1114109, '\p{-_Is_XPosixGraph}', "");
    Expect(0, 1114109, '\p{^-_Is_XPosixGraph}', "");
    Expect(0, 1114109, '\P{-_Is_XPosixGraph}', "");
    Expect(1, 1114109, '\P{^-_Is_XPosixGraph}', "");
    Expect(0, 918000, '\p{-_Is_XPosixGraph}', "");
    Expect(1, 918000, '\p{^-_Is_XPosixGraph}', "");
    Expect(1, 918000, '\P{-_Is_XPosixGraph}', "");
    Expect(0, 918000, '\P{^-_Is_XPosixGraph}', "");
    Error('\p{--Is_graph:=}');
    Error('\P{--Is_graph:=}');
    Expect(1, 1114109, '\p{isgraph}', "");
    Expect(0, 1114109, '\p{^isgraph}', "");
    Expect(0, 1114109, '\P{isgraph}', "");
    Expect(1, 1114109, '\P{^isgraph}', "");
    Expect(0, 918000, '\p{isgraph}', "");
    Expect(1, 918000, '\p{^isgraph}', "");
    Expect(1, 918000, '\P{isgraph}', "");
    Expect(0, 918000, '\P{^isgraph}', "");
    Expect(1, 1114109, '\p{_-is_Graph}', "");
    Expect(0, 1114109, '\p{^_-is_Graph}', "");
    Expect(0, 1114109, '\P{_-is_Graph}', "");
    Expect(1, 1114109, '\P{^_-is_Graph}', "");
    Expect(0, 918000, '\p{_-is_Graph}', "");
    Expect(1, 918000, '\p{^_-is_Graph}', "");
    Expect(1, 918000, '\P{_-is_Graph}', "");
    Expect(0, 918000, '\P{^_-is_Graph}', "");
    Error('\p{ /a/Grapheme_base}');
    Error('\P{ /a/Grapheme_base}');
    Expect(1, 205743, '\p{graphemebase}', "");
    Expect(0, 205743, '\p{^graphemebase}', "");
    Expect(0, 205743, '\P{graphemebase}', "");
    Expect(1, 205743, '\P{^graphemebase}', "");
    Expect(0, 205744, '\p{graphemebase}', "");
    Expect(1, 205744, '\p{^graphemebase}', "");
    Expect(1, 205744, '\P{graphemebase}', "");
    Expect(0, 205744, '\P{^graphemebase}', "");
    Expect(1, 205743, '\p{	-Grapheme_Base}', "");
    Expect(0, 205743, '\p{^	-Grapheme_Base}', "");
    Expect(0, 205743, '\P{	-Grapheme_Base}', "");
    Expect(1, 205743, '\P{^	-Grapheme_Base}', "");
    Expect(0, 205744, '\p{	-Grapheme_Base}', "");
    Expect(1, 205744, '\p{^	-Grapheme_Base}', "");
    Expect(1, 205744, '\P{	-Grapheme_Base}', "");
    Expect(0, 205744, '\P{^	-Grapheme_Base}', "");
    Error('\p{/a/	Is_Grapheme_Base}');
    Error('\P{/a/	Is_Grapheme_Base}');
    Expect(1, 205743, '\p{isgraphemebase}', "");
    Expect(0, 205743, '\p{^isgraphemebase}', "");
    Expect(0, 205743, '\P{isgraphemebase}', "");
    Expect(1, 205743, '\P{^isgraphemebase}', "");
    Expect(0, 205744, '\p{isgraphemebase}', "");
    Expect(1, 205744, '\p{^isgraphemebase}', "");
    Expect(1, 205744, '\P{isgraphemebase}', "");
    Expect(0, 205744, '\P{^isgraphemebase}', "");
    Expect(1, 205743, '\p{ -Is_GRAPHEME_Base}', "");
    Expect(0, 205743, '\p{^ -Is_GRAPHEME_Base}', "");
    Expect(0, 205743, '\P{ -Is_GRAPHEME_Base}', "");
    Expect(1, 205743, '\P{^ -Is_GRAPHEME_Base}', "");
    Expect(0, 205744, '\p{ -Is_GRAPHEME_Base}', "");
    Expect(1, 205744, '\p{^ -Is_GRAPHEME_Base}', "");
    Expect(1, 205744, '\P{ -Is_GRAPHEME_Base}', "");
    Expect(0, 205744, '\P{^ -Is_GRAPHEME_Base}', "");
    Error('\p{	 Gr_base/a/}');
    Error('\P{	 Gr_base/a/}');
    Expect(1, 205743, '\p{grbase}', "");
    Expect(0, 205743, '\p{^grbase}', "");
    Expect(0, 205743, '\P{grbase}', "");
    Expect(1, 205743, '\P{^grbase}', "");
    Expect(0, 205744, '\p{grbase}', "");
    Expect(1, 205744, '\p{^grbase}', "");
    Expect(1, 205744, '\P{grbase}', "");
    Expect(0, 205744, '\P{^grbase}', "");
    Expect(1, 205743, '\p{	_Gr_Base}', "");
    Expect(0, 205743, '\p{^	_Gr_Base}', "");
    Expect(0, 205743, '\P{	_Gr_Base}', "");
    Expect(1, 205743, '\P{^	_Gr_Base}', "");
    Expect(0, 205744, '\p{	_Gr_Base}', "");
    Expect(1, 205744, '\p{^	_Gr_Base}', "");
    Expect(1, 205744, '\P{	_Gr_Base}', "");
    Expect(0, 205744, '\P{^	_Gr_Base}', "");
    Error('\p{	:=Is_gr_BASE}');
    Error('\P{	:=Is_gr_BASE}');
    Expect(1, 205743, '\p{isgrbase}', "");
    Expect(0, 205743, '\p{^isgrbase}', "");
    Expect(0, 205743, '\P{isgrbase}', "");
    Expect(1, 205743, '\P{^isgrbase}', "");
    Expect(0, 205744, '\p{isgrbase}', "");
    Expect(1, 205744, '\p{^isgrbase}', "");
    Expect(1, 205744, '\P{isgrbase}', "");
    Expect(0, 205744, '\P{^isgrbase}', "");
    Expect(1, 205743, '\p{  Is_GR_base}', "");
    Expect(0, 205743, '\p{^  Is_GR_base}', "");
    Expect(0, 205743, '\P{  Is_GR_base}', "");
    Expect(1, 205743, '\P{^  Is_GR_base}', "");
    Expect(0, 205744, '\p{  Is_GR_base}', "");
    Expect(1, 205744, '\p{^  Is_GR_base}', "");
    Expect(1, 205744, '\P{  Is_GR_base}', "");
    Expect(0, 205744, '\P{^  Is_GR_base}', "");
    Error('\p{:= 	Grapheme_EXTEND}');
    Error('\P{:= 	Grapheme_EXTEND}');
    Expect(1, 917999, '\p{graphemeextend}', "");
    Expect(0, 917999, '\p{^graphemeextend}', "");
    Expect(0, 917999, '\P{graphemeextend}', "");
    Expect(1, 917999, '\P{^graphemeextend}', "");
    Expect(0, 918000, '\p{graphemeextend}', "");
    Expect(1, 918000, '\p{^graphemeextend}', "");
    Expect(1, 918000, '\P{graphemeextend}', "");
    Expect(0, 918000, '\P{^graphemeextend}', "");
    Expect(1, 917999, '\p{ 	GRAPHEME_Extend}', "");
    Expect(0, 917999, '\p{^ 	GRAPHEME_Extend}', "");
    Expect(0, 917999, '\P{ 	GRAPHEME_Extend}', "");
    Expect(1, 917999, '\P{^ 	GRAPHEME_Extend}', "");
    Expect(0, 918000, '\p{ 	GRAPHEME_Extend}', "");
    Expect(1, 918000, '\p{^ 	GRAPHEME_Extend}', "");
    Expect(1, 918000, '\P{ 	GRAPHEME_Extend}', "");
    Expect(0, 918000, '\P{^ 	GRAPHEME_Extend}', "");
    Error('\p{/a/_	Is_GRAPHEME_Extend}');
    Error('\P{/a/_	Is_GRAPHEME_Extend}');
    Expect(1, 917999, '\p{isgraphemeextend}', "");
    Expect(0, 917999, '\p{^isgraphemeextend}', "");
    Expect(0, 917999, '\P{isgraphemeextend}', "");
    Expect(1, 917999, '\P{^isgraphemeextend}', "");
    Expect(0, 918000, '\p{isgraphemeextend}', "");
    Expect(1, 918000, '\p{^isgraphemeextend}', "");
    Expect(1, 918000, '\P{isgraphemeextend}', "");
    Expect(0, 918000, '\P{^isgraphemeextend}', "");
    Expect(1, 917999, '\p{	is_GRAPHEME_Extend}', "");
    Expect(0, 917999, '\p{^	is_GRAPHEME_Extend}', "");
    Expect(0, 917999, '\P{	is_GRAPHEME_Extend}', "");
    Expect(1, 917999, '\P{^	is_GRAPHEME_Extend}', "");
    Expect(0, 918000, '\p{	is_GRAPHEME_Extend}', "");
    Expect(1, 918000, '\p{^	is_GRAPHEME_Extend}', "");
    Expect(1, 918000, '\P{	is_GRAPHEME_Extend}', "");
    Expect(0, 918000, '\P{^	is_GRAPHEME_Extend}', "");
    Error('\p{gr_Ext:=}');
    Error('\P{gr_Ext:=}');
    Expect(1, 917999, '\p{grext}', "");
    Expect(0, 917999, '\p{^grext}', "");
    Expect(0, 917999, '\P{grext}', "");
    Expect(1, 917999, '\P{^grext}', "");
    Expect(0, 918000, '\p{grext}', "");
    Expect(1, 918000, '\p{^grext}', "");
    Expect(1, 918000, '\P{grext}', "");
    Expect(0, 918000, '\P{^grext}', "");
    Expect(1, 917999, '\p{-GR_Ext}', "");
    Expect(0, 917999, '\p{^-GR_Ext}', "");
    Expect(0, 917999, '\P{-GR_Ext}', "");
    Expect(1, 917999, '\P{^-GR_Ext}', "");
    Expect(0, 918000, '\p{-GR_Ext}', "");
    Expect(1, 918000, '\p{^-GR_Ext}', "");
    Expect(1, 918000, '\P{-GR_Ext}', "");
    Expect(0, 918000, '\P{^-GR_Ext}', "");
    Error('\p{:= Is_Gr_EXT}');
    Error('\P{:= Is_Gr_EXT}');
    Expect(1, 917999, '\p{isgrext}', "");
    Expect(0, 917999, '\p{^isgrext}', "");
    Expect(0, 917999, '\P{isgrext}', "");
    Expect(1, 917999, '\P{^isgrext}', "");
    Expect(0, 918000, '\p{isgrext}', "");
    Expect(1, 918000, '\p{^isgrext}', "");
    Expect(1, 918000, '\P{isgrext}', "");
    Expect(0, 918000, '\P{^isgrext}', "");
    Expect(1, 917999, '\p{-Is_Gr_Ext}', "");
    Expect(0, 917999, '\p{^-Is_Gr_Ext}', "");
    Expect(0, 917999, '\P{-Is_Gr_Ext}', "");
    Expect(1, 917999, '\P{^-Is_Gr_Ext}', "");
    Expect(0, 918000, '\p{-Is_Gr_Ext}', "");
    Expect(1, 918000, '\p{^-Is_Gr_Ext}', "");
    Expect(1, 918000, '\P{-Is_Gr_Ext}', "");
    Expect(0, 918000, '\P{^-Is_Gr_Ext}', "");
    Error('\p{Grapheme_Link}');
    Error('\P{Grapheme_Link}');
    Error('\p{Gr_Link}');
    Error('\P{Gr_Link}');
    Error('\p{-GREEK/a/}');
    Error('\P{-GREEK/a/}');
    Expect(1, 119365, '\p{greek}', "");
    Expect(0, 119365, '\p{^greek}', "");
    Expect(0, 119365, '\P{greek}', "");
    Expect(1, 119365, '\P{^greek}', "");
    Expect(0, 119366, '\p{greek}', "");
    Expect(1, 119366, '\p{^greek}', "");
    Expect(1, 119366, '\P{greek}', "");
    Expect(0, 119366, '\P{^greek}', "");
    Expect(1, 119365, '\p{-Greek}', "");
    Expect(0, 119365, '\p{^-Greek}', "");
    Expect(0, 119365, '\P{-Greek}', "");
    Expect(1, 119365, '\P{^-Greek}', "");
    Expect(0, 119366, '\p{-Greek}', "");
    Expect(1, 119366, '\p{^-Greek}', "");
    Expect(1, 119366, '\P{-Greek}', "");
    Expect(0, 119366, '\P{^-Greek}', "");
    Error('\p{	_Is_greek:=}');
    Error('\P{	_Is_greek:=}');
    Expect(1, 119365, '\p{isgreek}', "");
    Expect(0, 119365, '\p{^isgreek}', "");
    Expect(0, 119365, '\P{isgreek}', "");
    Expect(1, 119365, '\P{^isgreek}', "");
    Expect(0, 119366, '\p{isgreek}', "");
    Expect(1, 119366, '\p{^isgreek}', "");
    Expect(1, 119366, '\P{isgreek}', "");
    Expect(0, 119366, '\P{^isgreek}', "");
    Expect(1, 119365, '\p{	IS_Greek}', "");
    Expect(0, 119365, '\p{^	IS_Greek}', "");
    Expect(0, 119365, '\P{	IS_Greek}', "");
    Expect(1, 119365, '\P{^	IS_Greek}', "");
    Expect(0, 119366, '\p{	IS_Greek}', "");
    Expect(1, 119366, '\p{^	IS_Greek}', "");
    Expect(1, 119366, '\P{	IS_Greek}', "");
    Expect(0, 119366, '\P{^	IS_Greek}', "");
    Error('\p{_/a/Grek}');
    Error('\P{_/a/Grek}');
    Expect(1, 119365, '\p{grek}', "");
    Expect(0, 119365, '\p{^grek}', "");
    Expect(0, 119365, '\P{grek}', "");
    Expect(1, 119365, '\P{^grek}', "");
    Expect(0, 119366, '\p{grek}', "");
    Expect(1, 119366, '\p{^grek}', "");
    Expect(1, 119366, '\P{grek}', "");
    Expect(0, 119366, '\P{^grek}', "");
    Expect(1, 119365, '\p{_	Grek}', "");
    Expect(0, 119365, '\p{^_	Grek}', "");
    Expect(0, 119365, '\P{_	Grek}', "");
    Expect(1, 119365, '\P{^_	Grek}', "");
    Expect(0, 119366, '\p{_	Grek}', "");
    Expect(1, 119366, '\p{^_	Grek}', "");
    Expect(1, 119366, '\P{_	Grek}', "");
    Expect(0, 119366, '\P{^_	Grek}', "");
    Error('\p{ 	Is_grek:=}');
    Error('\P{ 	Is_grek:=}');
    Expect(1, 119365, '\p{isgrek}', "");
    Expect(0, 119365, '\p{^isgrek}', "");
    Expect(0, 119365, '\P{isgrek}', "");
    Expect(1, 119365, '\P{^isgrek}', "");
    Expect(0, 119366, '\p{isgrek}', "");
    Expect(1, 119366, '\p{^isgrek}', "");
    Expect(1, 119366, '\P{isgrek}', "");
    Expect(0, 119366, '\P{^isgrek}', "");
    Expect(1, 119365, '\p{	_IS_grek}', "");
    Expect(0, 119365, '\p{^	_IS_grek}', "");
    Expect(0, 119365, '\P{	_IS_grek}', "");
    Expect(1, 119365, '\P{^	_IS_grek}', "");
    Expect(0, 119366, '\p{	_IS_grek}', "");
    Expect(1, 119366, '\p{^	_IS_grek}', "");
    Expect(1, 119366, '\P{	_IS_grek}', "");
    Expect(0, 119366, '\P{^	_IS_grek}', "");
    Error('\p{/a/Greek_And_Coptic}');
    Error('\P{/a/Greek_And_Coptic}');
    Expect(1, 1023, '\p{greekandcoptic}', "");
    Expect(0, 1023, '\p{^greekandcoptic}', "");
    Expect(0, 1023, '\P{greekandcoptic}', "");
    Expect(1, 1023, '\P{^greekandcoptic}', "");
    Expect(0, 1024, '\p{greekandcoptic}', "");
    Expect(1, 1024, '\p{^greekandcoptic}', "");
    Expect(1, 1024, '\P{greekandcoptic}', "");
    Expect(0, 1024, '\P{^greekandcoptic}', "");
    Expect(1, 1023, '\p{-Greek_and_COPTIC}', "");
    Expect(0, 1023, '\p{^-Greek_and_COPTIC}', "");
    Expect(0, 1023, '\P{-Greek_and_COPTIC}', "");
    Expect(1, 1023, '\P{^-Greek_and_COPTIC}', "");
    Expect(0, 1024, '\p{-Greek_and_COPTIC}', "");
    Expect(1, 1024, '\p{^-Greek_and_COPTIC}', "");
    Expect(1, 1024, '\P{-Greek_and_COPTIC}', "");
    Expect(0, 1024, '\P{^-Greek_and_COPTIC}', "");
    Error('\p{ /a/IS_GREEK_and_coptic}');
    Error('\P{ /a/IS_GREEK_and_coptic}');
    Expect(1, 1023, '\p{isgreekandcoptic}', "");
    Expect(0, 1023, '\p{^isgreekandcoptic}', "");
    Expect(0, 1023, '\P{isgreekandcoptic}', "");
    Expect(1, 1023, '\P{^isgreekandcoptic}', "");
    Expect(0, 1024, '\p{isgreekandcoptic}', "");
    Expect(1, 1024, '\p{^isgreekandcoptic}', "");
    Expect(1, 1024, '\P{isgreekandcoptic}', "");
    Expect(0, 1024, '\P{^isgreekandcoptic}', "");
    Expect(1, 1023, '\p{is_greek_AND_Coptic}', "");
    Expect(0, 1023, '\p{^is_greek_AND_Coptic}', "");
    Expect(0, 1023, '\P{is_greek_AND_Coptic}', "");
    Expect(1, 1023, '\P{^is_greek_AND_Coptic}', "");
    Expect(0, 1024, '\p{is_greek_AND_Coptic}', "");
    Expect(1, 1024, '\p{^is_greek_AND_Coptic}', "");
    Expect(1, 1024, '\P{is_greek_AND_Coptic}', "");
    Expect(0, 1024, '\P{^is_greek_AND_Coptic}', "");
    Error('\p{  In_greek_And_Coptic:=}');
    Error('\P{  In_greek_And_Coptic:=}');
    Expect(1, 1023, '\p{ingreekandcoptic}', "");
    Expect(0, 1023, '\p{^ingreekandcoptic}', "");
    Expect(0, 1023, '\P{ingreekandcoptic}', "");
    Expect(1, 1023, '\P{^ingreekandcoptic}', "");
    Expect(0, 1024, '\p{ingreekandcoptic}', "");
    Expect(1, 1024, '\p{^ingreekandcoptic}', "");
    Expect(1, 1024, '\P{ingreekandcoptic}', "");
    Expect(0, 1024, '\P{^ingreekandcoptic}', "");
    Expect(1, 1023, '\p{-In_Greek_And_coptic}', "");
    Expect(0, 1023, '\p{^-In_Greek_And_coptic}', "");
    Expect(0, 1023, '\P{-In_Greek_And_coptic}', "");
    Expect(1, 1023, '\P{^-In_Greek_And_coptic}', "");
    Expect(0, 1024, '\p{-In_Greek_And_coptic}', "");
    Expect(1, 1024, '\p{^-In_Greek_And_coptic}', "");
    Expect(1, 1024, '\P{-In_Greek_And_coptic}', "");
    Expect(0, 1024, '\P{^-In_Greek_And_coptic}', "");
    Error('\p{IN_GREEK:=}');
    Error('\P{IN_GREEK:=}');
    Expect(1, 1023, '\p{ingreek}', "");
    Expect(0, 1023, '\p{^ingreek}', "");
    Expect(0, 1023, '\P{ingreek}', "");
    Expect(1, 1023, '\P{^ingreek}', "");
    Expect(0, 1024, '\p{ingreek}', "");
    Expect(1, 1024, '\p{^ingreek}', "");
    Expect(1, 1024, '\P{ingreek}', "");
    Expect(0, 1024, '\P{^ingreek}', "");
    Expect(1, 1023, '\p{  IN_greek}', "");
    Expect(0, 1023, '\p{^  IN_greek}', "");
    Expect(0, 1023, '\P{  IN_greek}', "");
    Expect(1, 1023, '\P{^  IN_greek}', "");
    Expect(0, 1024, '\p{  IN_greek}', "");
    Expect(1, 1024, '\p{^  IN_greek}', "");
    Expect(1, 1024, '\P{  IN_greek}', "");
    Expect(0, 1024, '\P{^  IN_greek}', "");
    Error('\p{/a/_ greek_extended}');
    Error('\P{/a/_ greek_extended}');
    Expect(1, 8191, '\p{greekextended}', "");
    Expect(0, 8191, '\p{^greekextended}', "");
    Expect(0, 8191, '\P{greekextended}', "");
    Expect(1, 8191, '\P{^greekextended}', "");
    Expect(0, 8192, '\p{greekextended}', "");
    Expect(1, 8192, '\p{^greekextended}', "");
    Expect(1, 8192, '\P{greekextended}', "");
    Expect(0, 8192, '\P{^greekextended}', "");
    Expect(1, 8191, '\p{Greek_EXTENDED}', "");
    Expect(0, 8191, '\p{^Greek_EXTENDED}', "");
    Expect(0, 8191, '\P{Greek_EXTENDED}', "");
    Expect(1, 8191, '\P{^Greek_EXTENDED}', "");
    Expect(0, 8192, '\p{Greek_EXTENDED}', "");
    Expect(1, 8192, '\p{^Greek_EXTENDED}', "");
    Expect(1, 8192, '\P{Greek_EXTENDED}', "");
    Expect(0, 8192, '\P{^Greek_EXTENDED}', "");
    Error('\p{  is_Greek_EXTENDED:=}');
    Error('\P{  is_Greek_EXTENDED:=}');
    Expect(1, 8191, '\p{isgreekextended}', "");
    Expect(0, 8191, '\p{^isgreekextended}', "");
    Expect(0, 8191, '\P{isgreekextended}', "");
    Expect(1, 8191, '\P{^isgreekextended}', "");
    Expect(0, 8192, '\p{isgreekextended}', "");
    Expect(1, 8192, '\p{^isgreekextended}', "");
    Expect(1, 8192, '\P{isgreekextended}', "");
    Expect(0, 8192, '\P{^isgreekextended}', "");
    Expect(1, 8191, '\p{ -is_greek_extended}', "");
    Expect(0, 8191, '\p{^ -is_greek_extended}', "");
    Expect(0, 8191, '\P{ -is_greek_extended}', "");
    Expect(1, 8191, '\P{^ -is_greek_extended}', "");
    Expect(0, 8192, '\p{ -is_greek_extended}', "");
    Expect(1, 8192, '\p{^ -is_greek_extended}', "");
    Expect(1, 8192, '\P{ -is_greek_extended}', "");
    Expect(0, 8192, '\P{^ -is_greek_extended}', "");
    Error('\p{	IN_Greek_Extended/a/}');
    Error('\P{	IN_Greek_Extended/a/}');
    Expect(1, 8191, '\p{ingreekextended}', "");
    Expect(0, 8191, '\p{^ingreekextended}', "");
    Expect(0, 8191, '\P{ingreekextended}', "");
    Expect(1, 8191, '\P{^ingreekextended}', "");
    Expect(0, 8192, '\p{ingreekextended}', "");
    Expect(1, 8192, '\p{^ingreekextended}', "");
    Expect(1, 8192, '\P{ingreekextended}', "");
    Expect(0, 8192, '\P{^ingreekextended}', "");
    Expect(1, 8191, '\p{ _In_greek_Extended}', "");
    Expect(0, 8191, '\p{^ _In_greek_Extended}', "");
    Expect(0, 8191, '\P{ _In_greek_Extended}', "");
    Expect(1, 8191, '\P{^ _In_greek_Extended}', "");
    Expect(0, 8192, '\p{ _In_greek_Extended}', "");
    Expect(1, 8192, '\p{^ _In_greek_Extended}', "");
    Expect(1, 8192, '\P{ _In_greek_Extended}', "");
    Expect(0, 8192, '\P{^ _In_greek_Extended}', "");
    Error('\p{:=_Greek_Ext}');
    Error('\P{:=_Greek_Ext}');
    Expect(1, 8191, '\p{greekext}', "");
    Expect(0, 8191, '\p{^greekext}', "");
    Expect(0, 8191, '\P{greekext}', "");
    Expect(1, 8191, '\P{^greekext}', "");
    Expect(0, 8192, '\p{greekext}', "");
    Expect(1, 8192, '\p{^greekext}', "");
    Expect(1, 8192, '\P{greekext}', "");
    Expect(0, 8192, '\P{^greekext}', "");
    Expect(1, 8191, '\p{ GREEK_Ext}', "");
    Expect(0, 8191, '\p{^ GREEK_Ext}', "");
    Expect(0, 8191, '\P{ GREEK_Ext}', "");
    Expect(1, 8191, '\P{^ GREEK_Ext}', "");
    Expect(0, 8192, '\p{ GREEK_Ext}', "");
    Expect(1, 8192, '\p{^ GREEK_Ext}', "");
    Expect(1, 8192, '\P{ GREEK_Ext}', "");
    Expect(0, 8192, '\P{^ GREEK_Ext}', "");
    Error('\p{-is_greek_Ext/a/}');
    Error('\P{-is_greek_Ext/a/}');
    Expect(1, 8191, '\p{isgreekext}', "");
    Expect(0, 8191, '\p{^isgreekext}', "");
    Expect(0, 8191, '\P{isgreekext}', "");
    Expect(1, 8191, '\P{^isgreekext}', "");
    Expect(0, 8192, '\p{isgreekext}', "");
    Expect(1, 8192, '\p{^isgreekext}', "");
    Expect(1, 8192, '\P{isgreekext}', "");
    Expect(0, 8192, '\P{^isgreekext}', "");
    Expect(1, 8191, '\p{_is_Greek_ext}', "");
    Expect(0, 8191, '\p{^_is_Greek_ext}', "");
    Expect(0, 8191, '\P{_is_Greek_ext}', "");
    Expect(1, 8191, '\P{^_is_Greek_ext}', "");
    Expect(0, 8192, '\p{_is_Greek_ext}', "");
    Expect(1, 8192, '\p{^_is_Greek_ext}', "");
    Expect(1, 8192, '\P{_is_Greek_ext}', "");
    Expect(0, 8192, '\P{^_is_Greek_ext}', "");
    Error('\p{/a/- In_GREEK_ext}');
    Error('\P{/a/- In_GREEK_ext}');
    Expect(1, 8191, '\p{ingreekext}', "");
    Expect(0, 8191, '\p{^ingreekext}', "");
    Expect(0, 8191, '\P{ingreekext}', "");
    Expect(1, 8191, '\P{^ingreekext}', "");
    Expect(0, 8192, '\p{ingreekext}', "");
    Expect(1, 8192, '\p{^ingreekext}', "");
    Expect(1, 8192, '\P{ingreekext}', "");
    Expect(0, 8192, '\P{^ingreekext}', "");
    Expect(1, 8191, '\p{  In_greek_EXT}', "");
    Expect(0, 8191, '\p{^  In_greek_EXT}', "");
    Expect(0, 8191, '\P{  In_greek_EXT}', "");
    Expect(1, 8191, '\P{^  In_greek_EXT}', "");
    Expect(0, 8192, '\p{  In_greek_EXT}', "");
    Expect(1, 8192, '\p{^  In_greek_EXT}', "");
    Expect(1, 8192, '\P{  In_greek_EXT}', "");
    Expect(0, 8192, '\P{^  In_greek_EXT}', "");
    Error('\p{/a/Gujarati}');
    Error('\P{/a/Gujarati}');
    Expect(1, 43065, '\p{gujarati}', "");
    Expect(0, 43065, '\p{^gujarati}', "");
    Expect(0, 43065, '\P{gujarati}', "");
    Expect(1, 43065, '\P{^gujarati}', "");
    Expect(0, 43066, '\p{gujarati}', "");
    Expect(1, 43066, '\p{^gujarati}', "");
    Expect(1, 43066, '\P{gujarati}', "");
    Expect(0, 43066, '\P{^gujarati}', "");
    Expect(1, 43065, '\p{	-Gujarati}', "");
    Expect(0, 43065, '\p{^	-Gujarati}', "");
    Expect(0, 43065, '\P{	-Gujarati}', "");
    Expect(1, 43065, '\P{^	-Gujarati}', "");
    Expect(0, 43066, '\p{	-Gujarati}', "");
    Expect(1, 43066, '\p{^	-Gujarati}', "");
    Expect(1, 43066, '\P{	-Gujarati}', "");
    Expect(0, 43066, '\P{^	-Gujarati}', "");
    Error('\p{/a/_-Is_GUJARATI}');
    Error('\P{/a/_-Is_GUJARATI}');
    Expect(1, 43065, '\p{isgujarati}', "");
    Expect(0, 43065, '\p{^isgujarati}', "");
    Expect(0, 43065, '\P{isgujarati}', "");
    Expect(1, 43065, '\P{^isgujarati}', "");
    Expect(0, 43066, '\p{isgujarati}', "");
    Expect(1, 43066, '\p{^isgujarati}', "");
    Expect(1, 43066, '\P{isgujarati}', "");
    Expect(0, 43066, '\P{^isgujarati}', "");
    Expect(1, 43065, '\p{	 Is_Gujarati}', "");
    Expect(0, 43065, '\p{^	 Is_Gujarati}', "");
    Expect(0, 43065, '\P{	 Is_Gujarati}', "");
    Expect(1, 43065, '\P{^	 Is_Gujarati}', "");
    Expect(0, 43066, '\p{	 Is_Gujarati}', "");
    Expect(1, 43066, '\p{^	 Is_Gujarati}', "");
    Expect(1, 43066, '\P{	 Is_Gujarati}', "");
    Expect(0, 43066, '\P{^	 Is_Gujarati}', "");
    Error('\p{:= GUJR}');
    Error('\P{:= GUJR}');
    Expect(1, 43065, '\p{gujr}', "");
    Expect(0, 43065, '\p{^gujr}', "");
    Expect(0, 43065, '\P{gujr}', "");
    Expect(1, 43065, '\P{^gujr}', "");
    Expect(0, 43066, '\p{gujr}', "");
    Expect(1, 43066, '\p{^gujr}', "");
    Expect(1, 43066, '\P{gujr}', "");
    Expect(0, 43066, '\P{^gujr}', "");
    Expect(1, 43065, '\p{Gujr}', "");
    Expect(0, 43065, '\p{^Gujr}', "");
    Expect(0, 43065, '\P{Gujr}', "");
    Expect(1, 43065, '\P{^Gujr}', "");
    Expect(0, 43066, '\p{Gujr}', "");
    Expect(1, 43066, '\p{^Gujr}', "");
    Expect(1, 43066, '\P{Gujr}', "");
    Expect(0, 43066, '\P{^Gujr}', "");
    Error('\p{_-Is_Gujr/a/}');
    Error('\P{_-Is_Gujr/a/}');
    Expect(1, 43065, '\p{isgujr}', "");
    Expect(0, 43065, '\p{^isgujr}', "");
    Expect(0, 43065, '\P{isgujr}', "");
    Expect(1, 43065, '\P{^isgujr}', "");
    Expect(0, 43066, '\p{isgujr}', "");
    Expect(1, 43066, '\p{^isgujr}', "");
    Expect(1, 43066, '\P{isgujr}', "");
    Expect(0, 43066, '\P{^isgujr}', "");
    Expect(1, 43065, '\p{_is_GUJR}', "");
    Expect(0, 43065, '\p{^_is_GUJR}', "");
    Expect(0, 43065, '\P{_is_GUJR}', "");
    Expect(1, 43065, '\P{^_is_GUJR}', "");
    Expect(0, 43066, '\p{_is_GUJR}', "");
    Expect(1, 43066, '\p{^_is_GUJR}', "");
    Expect(1, 43066, '\P{_is_GUJR}', "");
    Expect(0, 43066, '\P{^_is_GUJR}', "");
    Error('\p{/a/ Gunjala_Gondi}');
    Error('\P{/a/ Gunjala_Gondi}');
    Expect(1, 73129, '\p{gunjalagondi}', "");
    Expect(0, 73129, '\p{^gunjalagondi}', "");
    Expect(0, 73129, '\P{gunjalagondi}', "");
    Expect(1, 73129, '\P{^gunjalagondi}', "");
    Expect(0, 73130, '\p{gunjalagondi}', "");
    Expect(1, 73130, '\p{^gunjalagondi}', "");
    Expect(1, 73130, '\P{gunjalagondi}', "");
    Expect(0, 73130, '\P{^gunjalagondi}', "");
    Expect(1, 73129, '\p{ gunjala_GONDI}', "");
    Expect(0, 73129, '\p{^ gunjala_GONDI}', "");
    Expect(0, 73129, '\P{ gunjala_GONDI}', "");
    Expect(1, 73129, '\P{^ gunjala_GONDI}', "");
    Expect(0, 73130, '\p{ gunjala_GONDI}', "");
    Expect(1, 73130, '\p{^ gunjala_GONDI}', "");
    Expect(1, 73130, '\P{ gunjala_GONDI}', "");
    Expect(0, 73130, '\P{^ gunjala_GONDI}', "");
    Error('\p{/a/__IS_gunjala_gondi}');
    Error('\P{/a/__IS_gunjala_gondi}');
    Expect(1, 73129, '\p{isgunjalagondi}', "");
    Expect(0, 73129, '\p{^isgunjalagondi}', "");
    Expect(0, 73129, '\P{isgunjalagondi}', "");
    Expect(1, 73129, '\P{^isgunjalagondi}', "");
    Expect(0, 73130, '\p{isgunjalagondi}', "");
    Expect(1, 73130, '\p{^isgunjalagondi}', "");
    Expect(1, 73130, '\P{isgunjalagondi}', "");
    Expect(0, 73130, '\P{^isgunjalagondi}', "");
    Expect(1, 73129, '\p{	-Is_GUNJALA_GONDI}', "");
    Expect(0, 73129, '\p{^	-Is_GUNJALA_GONDI}', "");
    Expect(0, 73129, '\P{	-Is_GUNJALA_GONDI}', "");
    Expect(1, 73129, '\P{^	-Is_GUNJALA_GONDI}', "");
    Expect(0, 73130, '\p{	-Is_GUNJALA_GONDI}', "");
    Expect(1, 73130, '\p{^	-Is_GUNJALA_GONDI}', "");
    Expect(1, 73130, '\P{	-Is_GUNJALA_GONDI}', "");
    Expect(0, 73130, '\P{^	-Is_GUNJALA_GONDI}', "");
    Error('\p{-/a/Gong}');
    Error('\P{-/a/Gong}');
    Expect(1, 73129, '\p{gong}', "");
    Expect(0, 73129, '\p{^gong}', "");
    Expect(0, 73129, '\P{gong}', "");
    Expect(1, 73129, '\P{^gong}', "");
    Expect(0, 73130, '\p{gong}', "");
    Expect(1, 73130, '\p{^gong}', "");
    Expect(1, 73130, '\P{gong}', "");
    Expect(0, 73130, '\P{^gong}', "");
    Error('\p{:=  is_GONG}');
    Error('\P{:=  is_GONG}');
    Expect(1, 73129, '\p{isgong}', "");
    Expect(0, 73129, '\p{^isgong}', "");
    Expect(0, 73129, '\P{isgong}', "");
    Expect(1, 73129, '\P{^isgong}', "");
    Expect(0, 73130, '\p{isgong}', "");
    Expect(1, 73130, '\p{^isgong}', "");
    Expect(1, 73130, '\P{isgong}', "");
    Expect(0, 73130, '\P{^isgong}', "");
    Expect(1, 73129, '\p{--IS_Gong}', "");
    Expect(0, 73129, '\p{^--IS_Gong}', "");
    Expect(0, 73129, '\P{--IS_Gong}', "");
    Expect(1, 73129, '\P{^--IS_Gong}', "");
    Expect(0, 73130, '\p{--IS_Gong}', "");
    Expect(1, 73130, '\p{^--IS_Gong}', "");
    Expect(1, 73130, '\P{--IS_Gong}', "");
    Expect(0, 73130, '\P{^--IS_Gong}', "");
    Error('\p{		gurmukhi:=}');
    Error('\P{		gurmukhi:=}');
    Expect(1, 43065, '\p{gurmukhi}', "");
    Expect(0, 43065, '\p{^gurmukhi}', "");
    Expect(0, 43065, '\P{gurmukhi}', "");
    Expect(1, 43065, '\P{^gurmukhi}', "");
    Expect(0, 43066, '\p{gurmukhi}', "");
    Expect(1, 43066, '\p{^gurmukhi}', "");
    Expect(1, 43066, '\P{gurmukhi}', "");
    Expect(0, 43066, '\P{^gurmukhi}', "");
    Expect(1, 43065, '\p{_GURMUKHI}', "");
    Expect(0, 43065, '\p{^_GURMUKHI}', "");
    Expect(0, 43065, '\P{_GURMUKHI}', "");
    Expect(1, 43065, '\P{^_GURMUKHI}', "");
    Expect(0, 43066, '\p{_GURMUKHI}', "");
    Expect(1, 43066, '\p{^_GURMUKHI}', "");
    Expect(1, 43066, '\P{_GURMUKHI}', "");
    Expect(0, 43066, '\P{^_GURMUKHI}', "");
    Error('\p{/a/Is_Gurmukhi}');
    Error('\P{/a/Is_Gurmukhi}');
    Expect(1, 43065, '\p{isgurmukhi}', "");
    Expect(0, 43065, '\p{^isgurmukhi}', "");
    Expect(0, 43065, '\P{isgurmukhi}', "");
    Expect(1, 43065, '\P{^isgurmukhi}', "");
    Expect(0, 43066, '\p{isgurmukhi}', "");
    Expect(1, 43066, '\p{^isgurmukhi}', "");
    Expect(1, 43066, '\P{isgurmukhi}', "");
    Expect(0, 43066, '\P{^isgurmukhi}', "");
    Expect(1, 43065, '\p{_Is_gurmukhi}', "");
    Expect(0, 43065, '\p{^_Is_gurmukhi}', "");
    Expect(0, 43065, '\P{_Is_gurmukhi}', "");
    Expect(1, 43065, '\P{^_Is_gurmukhi}', "");
    Expect(0, 43066, '\p{_Is_gurmukhi}', "");
    Expect(1, 43066, '\p{^_Is_gurmukhi}', "");
    Expect(1, 43066, '\P{_Is_gurmukhi}', "");
    Expect(0, 43066, '\P{^_Is_gurmukhi}', "");
    Error('\p{_ Guru:=}');
    Error('\P{_ Guru:=}');
    Expect(1, 43065, '\p{guru}', "");
    Expect(0, 43065, '\p{^guru}', "");
    Expect(0, 43065, '\P{guru}', "");
    Expect(1, 43065, '\P{^guru}', "");
    Expect(0, 43066, '\p{guru}', "");
    Expect(1, 43066, '\p{^guru}', "");
    Expect(1, 43066, '\P{guru}', "");
    Expect(0, 43066, '\P{^guru}', "");
    Expect(1, 43065, '\p{_Guru}', "");
    Expect(0, 43065, '\p{^_Guru}', "");
    Expect(0, 43065, '\P{_Guru}', "");
    Expect(1, 43065, '\P{^_Guru}', "");
    Expect(0, 43066, '\p{_Guru}', "");
    Expect(1, 43066, '\p{^_Guru}', "");
    Expect(1, 43066, '\P{_Guru}', "");
    Expect(0, 43066, '\P{^_Guru}', "");
    Error('\p{/a/ is_guru}');
    Error('\P{/a/ is_guru}');
    Expect(1, 43065, '\p{isguru}', "");
    Expect(0, 43065, '\p{^isguru}', "");
    Expect(0, 43065, '\P{isguru}', "");
    Expect(1, 43065, '\P{^isguru}', "");
    Expect(0, 43066, '\p{isguru}', "");
    Expect(1, 43066, '\p{^isguru}', "");
    Expect(1, 43066, '\P{isguru}', "");
    Expect(0, 43066, '\P{^isguru}', "");
    Expect(1, 43065, '\p{- is_guru}', "");
    Expect(0, 43065, '\p{^- is_guru}', "");
    Expect(0, 43065, '\P{- is_guru}', "");
    Expect(1, 43065, '\P{^- is_guru}', "");
    Expect(0, 43066, '\p{- is_guru}', "");
    Expect(1, 43066, '\p{^- is_guru}', "");
    Expect(1, 43066, '\P{- is_guru}', "");
    Expect(0, 43066, '\P{^- is_guru}', "");
    Error('\p{:=-_HALFWIDTH_And_fullwidth_FORMS}');
    Error('\P{:=-_HALFWIDTH_And_fullwidth_FORMS}');
    Expect(1, 65519, '\p{halfwidthandfullwidthforms}', "");
    Expect(0, 65519, '\p{^halfwidthandfullwidthforms}', "");
    Expect(0, 65519, '\P{halfwidthandfullwidthforms}', "");
    Expect(1, 65519, '\P{^halfwidthandfullwidthforms}', "");
    Expect(0, 65520, '\p{halfwidthandfullwidthforms}', "");
    Expect(1, 65520, '\p{^halfwidthandfullwidthforms}', "");
    Expect(1, 65520, '\P{halfwidthandfullwidthforms}', "");
    Expect(0, 65520, '\P{^halfwidthandfullwidthforms}', "");
    Expect(1, 65519, '\p{ -Halfwidth_and_Fullwidth_FORMS}', "");
    Expect(0, 65519, '\p{^ -Halfwidth_and_Fullwidth_FORMS}', "");
    Expect(0, 65519, '\P{ -Halfwidth_and_Fullwidth_FORMS}', "");
    Expect(1, 65519, '\P{^ -Halfwidth_and_Fullwidth_FORMS}', "");
    Expect(0, 65520, '\p{ -Halfwidth_and_Fullwidth_FORMS}', "");
    Expect(1, 65520, '\p{^ -Halfwidth_and_Fullwidth_FORMS}', "");
    Expect(1, 65520, '\P{ -Halfwidth_and_Fullwidth_FORMS}', "");
    Expect(0, 65520, '\P{^ -Halfwidth_and_Fullwidth_FORMS}', "");
    Error('\p{ is_HALFWIDTH_and_Fullwidth_forms/a/}');
    Error('\P{ is_HALFWIDTH_and_Fullwidth_forms/a/}');
    Expect(1, 65519, '\p{ishalfwidthandfullwidthforms}', "");
    Expect(0, 65519, '\p{^ishalfwidthandfullwidthforms}', "");
    Expect(0, 65519, '\P{ishalfwidthandfullwidthforms}', "");
    Expect(1, 65519, '\P{^ishalfwidthandfullwidthforms}', "");
    Expect(0, 65520, '\p{ishalfwidthandfullwidthforms}', "");
    Expect(1, 65520, '\p{^ishalfwidthandfullwidthforms}', "");
    Expect(1, 65520, '\P{ishalfwidthandfullwidthforms}', "");
    Expect(0, 65520, '\P{^ishalfwidthandfullwidthforms}', "");
    Expect(1, 65519, '\p{_Is_Halfwidth_AND_FULLWIDTH_Forms}', "");
    Expect(0, 65519, '\p{^_Is_Halfwidth_AND_FULLWIDTH_Forms}', "");
    Expect(0, 65519, '\P{_Is_Halfwidth_AND_FULLWIDTH_Forms}', "");
    Expect(1, 65519, '\P{^_Is_Halfwidth_AND_FULLWIDTH_Forms}', "");
    Expect(0, 65520, '\p{_Is_Halfwidth_AND_FULLWIDTH_Forms}', "");
    Expect(1, 65520, '\p{^_Is_Halfwidth_AND_FULLWIDTH_Forms}', "");
    Expect(1, 65520, '\P{_Is_Halfwidth_AND_FULLWIDTH_Forms}', "");
    Expect(0, 65520, '\P{^_Is_Halfwidth_AND_FULLWIDTH_Forms}', "");
    Error('\p{:=_In_Halfwidth_AND_fullwidth_Forms}');
    Error('\P{:=_In_Halfwidth_AND_fullwidth_Forms}');
    Expect(1, 65519, '\p{inhalfwidthandfullwidthforms}', "");
    Expect(0, 65519, '\p{^inhalfwidthandfullwidthforms}', "");
    Expect(0, 65519, '\P{inhalfwidthandfullwidthforms}', "");
    Expect(1, 65519, '\P{^inhalfwidthandfullwidthforms}', "");
    Expect(0, 65520, '\p{inhalfwidthandfullwidthforms}', "");
    Expect(1, 65520, '\p{^inhalfwidthandfullwidthforms}', "");
    Expect(1, 65520, '\P{inhalfwidthandfullwidthforms}', "");
    Expect(0, 65520, '\P{^inhalfwidthandfullwidthforms}', "");
    Expect(1, 65519, '\p{		In_halfwidth_AND_Fullwidth_FORMS}', "");
    Expect(0, 65519, '\p{^		In_halfwidth_AND_Fullwidth_FORMS}', "");
    Expect(0, 65519, '\P{		In_halfwidth_AND_Fullwidth_FORMS}', "");
    Expect(1, 65519, '\P{^		In_halfwidth_AND_Fullwidth_FORMS}', "");
    Expect(0, 65520, '\p{		In_halfwidth_AND_Fullwidth_FORMS}', "");
    Expect(1, 65520, '\p{^		In_halfwidth_AND_Fullwidth_FORMS}', "");
    Expect(1, 65520, '\P{		In_halfwidth_AND_Fullwidth_FORMS}', "");
    Expect(0, 65520, '\P{^		In_halfwidth_AND_Fullwidth_FORMS}', "");
    Error('\p{/a/-	half_AND_FULL_FORMS}');
    Error('\P{/a/-	half_AND_FULL_FORMS}');
    Expect(1, 65519, '\p{halfandfullforms}', "");
    Expect(0, 65519, '\p{^halfandfullforms}', "");
    Expect(0, 65519, '\P{halfandfullforms}', "");
    Expect(1, 65519, '\P{^halfandfullforms}', "");
    Expect(0, 65520, '\p{halfandfullforms}', "");
    Expect(1, 65520, '\p{^halfandfullforms}', "");
    Expect(1, 65520, '\P{halfandfullforms}', "");
    Expect(0, 65520, '\P{^halfandfullforms}', "");
    Expect(1, 65519, '\p{_ HALF_AND_Full_Forms}', "");
    Expect(0, 65519, '\p{^_ HALF_AND_Full_Forms}', "");
    Expect(0, 65519, '\P{_ HALF_AND_Full_Forms}', "");
    Expect(1, 65519, '\P{^_ HALF_AND_Full_Forms}', "");
    Expect(0, 65520, '\p{_ HALF_AND_Full_Forms}', "");
    Expect(1, 65520, '\p{^_ HALF_AND_Full_Forms}', "");
    Expect(1, 65520, '\P{_ HALF_AND_Full_Forms}', "");
    Expect(0, 65520, '\P{^_ HALF_AND_Full_Forms}', "");
    Error('\p{__Is_HALF_And_FULL_forms:=}');
    Error('\P{__Is_HALF_And_FULL_forms:=}');
    Expect(1, 65519, '\p{ishalfandfullforms}', "");
    Expect(0, 65519, '\p{^ishalfandfullforms}', "");
    Expect(0, 65519, '\P{ishalfandfullforms}', "");
    Expect(1, 65519, '\P{^ishalfandfullforms}', "");
    Expect(0, 65520, '\p{ishalfandfullforms}', "");
    Expect(1, 65520, '\p{^ishalfandfullforms}', "");
    Expect(1, 65520, '\P{ishalfandfullforms}', "");
    Expect(0, 65520, '\P{^ishalfandfullforms}', "");
    Expect(1, 65519, '\p{- IS_Half_And_Full_Forms}', "");
    Expect(0, 65519, '\p{^- IS_Half_And_Full_Forms}', "");
    Expect(0, 65519, '\P{- IS_Half_And_Full_Forms}', "");
    Expect(1, 65519, '\P{^- IS_Half_And_Full_Forms}', "");
    Expect(0, 65520, '\p{- IS_Half_And_Full_Forms}', "");
    Expect(1, 65520, '\p{^- IS_Half_And_Full_Forms}', "");
    Expect(1, 65520, '\P{- IS_Half_And_Full_Forms}', "");
    Expect(0, 65520, '\P{^- IS_Half_And_Full_Forms}', "");
    Error('\p{-in_half_and_Full_Forms/a/}');
    Error('\P{-in_half_and_Full_Forms/a/}');
    Expect(1, 65519, '\p{inhalfandfullforms}', "");
    Expect(0, 65519, '\p{^inhalfandfullforms}', "");
    Expect(0, 65519, '\P{inhalfandfullforms}', "");
    Expect(1, 65519, '\P{^inhalfandfullforms}', "");
    Expect(0, 65520, '\p{inhalfandfullforms}', "");
    Expect(1, 65520, '\p{^inhalfandfullforms}', "");
    Expect(1, 65520, '\P{inhalfandfullforms}', "");
    Expect(0, 65520, '\P{^inhalfandfullforms}', "");
    Expect(1, 65519, '\p{	-In_HALF_And_Full_forms}', "");
    Expect(0, 65519, '\p{^	-In_HALF_And_Full_forms}', "");
    Expect(0, 65519, '\P{	-In_HALF_And_Full_forms}', "");
    Expect(1, 65519, '\P{^	-In_HALF_And_Full_forms}', "");
    Expect(0, 65520, '\p{	-In_HALF_And_Full_forms}', "");
    Expect(1, 65520, '\p{^	-In_HALF_And_Full_forms}', "");
    Expect(1, 65520, '\P{	-In_HALF_And_Full_forms}', "");
    Expect(0, 65520, '\P{^	-In_HALF_And_Full_forms}', "");
    Error('\p{-:=HAN}');
    Error('\P{-:=HAN}');
    Expect(1, 205743, '\p{han}', "");
    Expect(0, 205743, '\p{^han}', "");
    Expect(0, 205743, '\P{han}', "");
    Expect(1, 205743, '\P{^han}', "");
    Expect(0, 205744, '\p{han}', "");
    Expect(1, 205744, '\p{^han}', "");
    Expect(1, 205744, '\P{han}', "");
    Expect(0, 205744, '\P{^han}', "");
    Expect(1, 205743, '\p{ han}', "");
    Expect(0, 205743, '\p{^ han}', "");
    Expect(0, 205743, '\P{ han}', "");
    Expect(1, 205743, '\P{^ han}', "");
    Expect(0, 205744, '\p{ han}', "");
    Expect(1, 205744, '\p{^ han}', "");
    Expect(1, 205744, '\P{ han}', "");
    Expect(0, 205744, '\P{^ han}', "");
    Error('\p{-_Is_han/a/}');
    Error('\P{-_Is_han/a/}');
    Expect(1, 205743, '\p{ishan}', "");
    Expect(0, 205743, '\p{^ishan}', "");
    Expect(0, 205743, '\P{ishan}', "");
    Expect(1, 205743, '\P{^ishan}', "");
    Expect(0, 205744, '\p{ishan}', "");
    Expect(1, 205744, '\p{^ishan}', "");
    Expect(1, 205744, '\P{ishan}', "");
    Expect(0, 205744, '\P{^ishan}', "");
    Expect(1, 205743, '\p{ _Is_han}', "");
    Expect(0, 205743, '\p{^ _Is_han}', "");
    Expect(0, 205743, '\P{ _Is_han}', "");
    Expect(1, 205743, '\P{^ _Is_han}', "");
    Expect(0, 205744, '\p{ _Is_han}', "");
    Expect(1, 205744, '\p{^ _Is_han}', "");
    Expect(1, 205744, '\P{ _Is_han}', "");
    Expect(0, 205744, '\P{^ _Is_han}', "");
    Error('\p{	:=hani}');
    Error('\P{	:=hani}');
    Expect(1, 205743, '\p{hani}', "");
    Expect(0, 205743, '\p{^hani}', "");
    Expect(0, 205743, '\P{hani}', "");
    Expect(1, 205743, '\P{^hani}', "");
    Expect(0, 205744, '\p{hani}', "");
    Expect(1, 205744, '\p{^hani}', "");
    Expect(1, 205744, '\P{hani}', "");
    Expect(0, 205744, '\P{^hani}', "");
    Error('\p{		is_Hani/a/}');
    Error('\P{		is_Hani/a/}');
    Expect(1, 205743, '\p{ishani}', "");
    Expect(0, 205743, '\p{^ishani}', "");
    Expect(0, 205743, '\P{ishani}', "");
    Expect(1, 205743, '\P{^ishani}', "");
    Expect(0, 205744, '\p{ishani}', "");
    Expect(1, 205744, '\p{^ishani}', "");
    Expect(1, 205744, '\P{ishani}', "");
    Expect(0, 205744, '\P{^ishani}', "");
    Expect(1, 205743, '\p{--is_hani}', "");
    Expect(0, 205743, '\p{^--is_hani}', "");
    Expect(0, 205743, '\P{--is_hani}', "");
    Expect(1, 205743, '\P{^--is_hani}', "");
    Expect(0, 205744, '\p{--is_hani}', "");
    Expect(1, 205744, '\p{^--is_hani}', "");
    Expect(1, 205744, '\P{--is_hani}', "");
    Expect(0, 205744, '\P{^--is_hani}', "");
    Error('\p{	-Hangul:=}');
    Error('\P{	-Hangul:=}');
    Expect(1, 65500, '\p{hangul}', "");
    Expect(0, 65500, '\p{^hangul}', "");
    Expect(0, 65500, '\P{hangul}', "");
    Expect(1, 65500, '\P{^hangul}', "");
    Expect(0, 65501, '\p{hangul}', "");
    Expect(1, 65501, '\p{^hangul}', "");
    Expect(1, 65501, '\P{hangul}', "");
    Expect(0, 65501, '\P{^hangul}', "");
    Expect(1, 65500, '\p{		Hangul}', "");
    Expect(0, 65500, '\p{^		Hangul}', "");
    Expect(0, 65500, '\P{		Hangul}', "");
    Expect(1, 65500, '\P{^		Hangul}', "");
    Expect(0, 65501, '\p{		Hangul}', "");
    Expect(1, 65501, '\p{^		Hangul}', "");
    Expect(1, 65501, '\P{		Hangul}', "");
    Expect(0, 65501, '\P{^		Hangul}', "");
    Error('\p{	:=Is_HANGUL}');
    Error('\P{	:=Is_HANGUL}');
    Expect(1, 65500, '\p{ishangul}', "");
    Expect(0, 65500, '\p{^ishangul}', "");
    Expect(0, 65500, '\P{ishangul}', "");
    Expect(1, 65500, '\P{^ishangul}', "");
    Expect(0, 65501, '\p{ishangul}', "");
    Expect(1, 65501, '\p{^ishangul}', "");
    Expect(1, 65501, '\P{ishangul}', "");
    Expect(0, 65501, '\P{^ishangul}', "");
    Expect(1, 65500, '\p{ -Is_Hangul}', "");
    Expect(0, 65500, '\p{^ -Is_Hangul}', "");
    Expect(0, 65500, '\P{ -Is_Hangul}', "");
    Expect(1, 65500, '\P{^ -Is_Hangul}', "");
    Expect(0, 65501, '\p{ -Is_Hangul}', "");
    Expect(1, 65501, '\p{^ -Is_Hangul}', "");
    Expect(1, 65501, '\P{ -Is_Hangul}', "");
    Expect(0, 65501, '\P{^ -Is_Hangul}', "");
    Error('\p{_-hang:=}');
    Error('\P{_-hang:=}');
    Expect(1, 65500, '\p{hang}', "");
    Expect(0, 65500, '\p{^hang}', "");
    Expect(0, 65500, '\P{hang}', "");
    Expect(1, 65500, '\P{^hang}', "");
    Expect(0, 65501, '\p{hang}', "");
    Expect(1, 65501, '\p{^hang}', "");
    Expect(1, 65501, '\P{hang}', "");
    Expect(0, 65501, '\P{^hang}', "");
    Expect(1, 65500, '\p{_Hang}', "");
    Expect(0, 65500, '\p{^_Hang}', "");
    Expect(0, 65500, '\P{_Hang}', "");
    Expect(1, 65500, '\P{^_Hang}', "");
    Expect(0, 65501, '\p{_Hang}', "");
    Expect(1, 65501, '\p{^_Hang}', "");
    Expect(1, 65501, '\P{_Hang}', "");
    Expect(0, 65501, '\P{^_Hang}', "");
    Error('\p{/a/ -IS_hang}');
    Error('\P{/a/ -IS_hang}');
    Expect(1, 65500, '\p{ishang}', "");
    Expect(0, 65500, '\p{^ishang}', "");
    Expect(0, 65500, '\P{ishang}', "");
    Expect(1, 65500, '\P{^ishang}', "");
    Expect(0, 65501, '\p{ishang}', "");
    Expect(1, 65501, '\p{^ishang}', "");
    Expect(1, 65501, '\P{ishang}', "");
    Expect(0, 65501, '\P{^ishang}', "");
    Expect(1, 65500, '\p{	is_Hang}', "");
    Expect(0, 65500, '\p{^	is_Hang}', "");
    Expect(0, 65500, '\P{	is_Hang}', "");
    Expect(1, 65500, '\P{^	is_Hang}', "");
    Expect(0, 65501, '\p{	is_Hang}', "");
    Expect(1, 65501, '\p{^	is_Hang}', "");
    Expect(1, 65501, '\P{	is_Hang}', "");
    Expect(0, 65501, '\P{^	is_Hang}', "");
    Error('\p{	:=hangul_Compatibility_jamo}');
    Error('\P{	:=hangul_Compatibility_jamo}');
    Expect(1, 12687, '\p{hangulcompatibilityjamo}', "");
    Expect(0, 12687, '\p{^hangulcompatibilityjamo}', "");
    Expect(0, 12687, '\P{hangulcompatibilityjamo}', "");
    Expect(1, 12687, '\P{^hangulcompatibilityjamo}', "");
    Expect(0, 12688, '\p{hangulcompatibilityjamo}', "");
    Expect(1, 12688, '\p{^hangulcompatibilityjamo}', "");
    Expect(1, 12688, '\P{hangulcompatibilityjamo}', "");
    Expect(0, 12688, '\P{^hangulcompatibilityjamo}', "");
    Expect(1, 12687, '\p{ -Hangul_Compatibility_Jamo}', "");
    Expect(0, 12687, '\p{^ -Hangul_Compatibility_Jamo}', "");
    Expect(0, 12687, '\P{ -Hangul_Compatibility_Jamo}', "");
    Expect(1, 12687, '\P{^ -Hangul_Compatibility_Jamo}', "");
    Expect(0, 12688, '\p{ -Hangul_Compatibility_Jamo}', "");
    Expect(1, 12688, '\p{^ -Hangul_Compatibility_Jamo}', "");
    Expect(1, 12688, '\P{ -Hangul_Compatibility_Jamo}', "");
    Expect(0, 12688, '\P{^ -Hangul_Compatibility_Jamo}', "");
    Error('\p{/a/--IS_Hangul_Compatibility_Jamo}');
    Error('\P{/a/--IS_Hangul_Compatibility_Jamo}');
    Expect(1, 12687, '\p{ishangulcompatibilityjamo}', "");
    Expect(0, 12687, '\p{^ishangulcompatibilityjamo}', "");
    Expect(0, 12687, '\P{ishangulcompatibilityjamo}', "");
    Expect(1, 12687, '\P{^ishangulcompatibilityjamo}', "");
    Expect(0, 12688, '\p{ishangulcompatibilityjamo}', "");
    Expect(1, 12688, '\p{^ishangulcompatibilityjamo}', "");
    Expect(1, 12688, '\P{ishangulcompatibilityjamo}', "");
    Expect(0, 12688, '\P{^ishangulcompatibilityjamo}', "");
    Expect(1, 12687, '\p{	_IS_hangul_compatibility_Jamo}', "");
    Expect(0, 12687, '\p{^	_IS_hangul_compatibility_Jamo}', "");
    Expect(0, 12687, '\P{	_IS_hangul_compatibility_Jamo}', "");
    Expect(1, 12687, '\P{^	_IS_hangul_compatibility_Jamo}', "");
    Expect(0, 12688, '\p{	_IS_hangul_compatibility_Jamo}', "");
    Expect(1, 12688, '\p{^	_IS_hangul_compatibility_Jamo}', "");
    Expect(1, 12688, '\P{	_IS_hangul_compatibility_Jamo}', "");
    Expect(0, 12688, '\P{^	_IS_hangul_compatibility_Jamo}', "");
    Error('\p{:=- in_Hangul_Compatibility_Jamo}');
    Error('\P{:=- in_Hangul_Compatibility_Jamo}');
    Expect(1, 12687, '\p{inhangulcompatibilityjamo}', "");
    Expect(0, 12687, '\p{^inhangulcompatibilityjamo}', "");
    Expect(0, 12687, '\P{inhangulcompatibilityjamo}', "");
    Expect(1, 12687, '\P{^inhangulcompatibilityjamo}', "");
    Expect(0, 12688, '\p{inhangulcompatibilityjamo}', "");
    Expect(1, 12688, '\p{^inhangulcompatibilityjamo}', "");
    Expect(1, 12688, '\P{inhangulcompatibilityjamo}', "");
    Expect(0, 12688, '\P{^inhangulcompatibilityjamo}', "");
    Expect(1, 12687, '\p{-	IN_hangul_Compatibility_Jamo}', "");
    Expect(0, 12687, '\p{^-	IN_hangul_Compatibility_Jamo}', "");
    Expect(0, 12687, '\P{-	IN_hangul_Compatibility_Jamo}', "");
    Expect(1, 12687, '\P{^-	IN_hangul_Compatibility_Jamo}', "");
    Expect(0, 12688, '\p{-	IN_hangul_Compatibility_Jamo}', "");
    Expect(1, 12688, '\p{^-	IN_hangul_Compatibility_Jamo}', "");
    Expect(1, 12688, '\P{-	IN_hangul_Compatibility_Jamo}', "");
    Expect(0, 12688, '\P{^-	IN_hangul_Compatibility_Jamo}', "");
    Error('\p{ /a/Compat_Jamo}');
    Error('\P{ /a/Compat_Jamo}');
    Expect(1, 12687, '\p{compatjamo}', "");
    Expect(0, 12687, '\p{^compatjamo}', "");
    Expect(0, 12687, '\P{compatjamo}', "");
    Expect(1, 12687, '\P{^compatjamo}', "");
    Expect(0, 12688, '\p{compatjamo}', "");
    Expect(1, 12688, '\p{^compatjamo}', "");
    Expect(1, 12688, '\P{compatjamo}', "");
    Expect(0, 12688, '\P{^compatjamo}', "");
    Expect(1, 12687, '\p{	compat_Jamo}', "");
    Expect(0, 12687, '\p{^	compat_Jamo}', "");
    Expect(0, 12687, '\P{	compat_Jamo}', "");
    Expect(1, 12687, '\P{^	compat_Jamo}', "");
    Expect(0, 12688, '\p{	compat_Jamo}', "");
    Expect(1, 12688, '\p{^	compat_Jamo}', "");
    Expect(1, 12688, '\P{	compat_Jamo}', "");
    Expect(0, 12688, '\P{^	compat_Jamo}', "");
    Error('\p{	_IS_Compat_jamo:=}');
    Error('\P{	_IS_Compat_jamo:=}');
    Expect(1, 12687, '\p{iscompatjamo}', "");
    Expect(0, 12687, '\p{^iscompatjamo}', "");
    Expect(0, 12687, '\P{iscompatjamo}', "");
    Expect(1, 12687, '\P{^iscompatjamo}', "");
    Expect(0, 12688, '\p{iscompatjamo}', "");
    Expect(1, 12688, '\p{^iscompatjamo}', "");
    Expect(1, 12688, '\P{iscompatjamo}', "");
    Expect(0, 12688, '\P{^iscompatjamo}', "");
    Expect(1, 12687, '\p{_ IS_Compat_Jamo}', "");
    Expect(0, 12687, '\p{^_ IS_Compat_Jamo}', "");
    Expect(0, 12687, '\P{_ IS_Compat_Jamo}', "");
    Expect(1, 12687, '\P{^_ IS_Compat_Jamo}', "");
    Expect(0, 12688, '\p{_ IS_Compat_Jamo}', "");
    Expect(1, 12688, '\p{^_ IS_Compat_Jamo}', "");
    Expect(1, 12688, '\P{_ IS_Compat_Jamo}', "");
    Expect(0, 12688, '\P{^_ IS_Compat_Jamo}', "");
    Error('\p{_in_Compat_jamo/a/}');
    Error('\P{_in_Compat_jamo/a/}');
    Expect(1, 12687, '\p{incompatjamo}', "");
    Expect(0, 12687, '\p{^incompatjamo}', "");
    Expect(0, 12687, '\P{incompatjamo}', "");
    Expect(1, 12687, '\P{^incompatjamo}', "");
    Expect(0, 12688, '\p{incompatjamo}', "");
    Expect(1, 12688, '\p{^incompatjamo}', "");
    Expect(1, 12688, '\P{incompatjamo}', "");
    Expect(0, 12688, '\P{^incompatjamo}', "");
    Expect(1, 12687, '\p{	In_COMPAT_jamo}', "");
    Expect(0, 12687, '\p{^	In_COMPAT_jamo}', "");
    Expect(0, 12687, '\P{	In_COMPAT_jamo}', "");
    Expect(1, 12687, '\P{^	In_COMPAT_jamo}', "");
    Expect(0, 12688, '\p{	In_COMPAT_jamo}', "");
    Expect(1, 12688, '\p{^	In_COMPAT_jamo}', "");
    Expect(1, 12688, '\P{	In_COMPAT_jamo}', "");
    Expect(0, 12688, '\P{^	In_COMPAT_jamo}', "");
    Error('\p{/a/ -hangul_JAMO}');
    Error('\P{/a/ -hangul_JAMO}');
    Expect(1, 4607, '\p{hanguljamo}', "");
    Expect(0, 4607, '\p{^hanguljamo}', "");
    Expect(0, 4607, '\P{hanguljamo}', "");
    Expect(1, 4607, '\P{^hanguljamo}', "");
    Expect(0, 4608, '\p{hanguljamo}', "");
    Expect(1, 4608, '\p{^hanguljamo}', "");
    Expect(1, 4608, '\P{hanguljamo}', "");
    Expect(0, 4608, '\P{^hanguljamo}', "");
    Expect(1, 4607, '\p{  Hangul_JAMO}', "");
    Expect(0, 4607, '\p{^  Hangul_JAMO}', "");
    Expect(0, 4607, '\P{  Hangul_JAMO}', "");
    Expect(1, 4607, '\P{^  Hangul_JAMO}', "");
    Expect(0, 4608, '\p{  Hangul_JAMO}', "");
    Expect(1, 4608, '\p{^  Hangul_JAMO}', "");
    Expect(1, 4608, '\P{  Hangul_JAMO}', "");
    Expect(0, 4608, '\P{^  Hangul_JAMO}', "");
    Error('\p{:=Is_HANGUL_Jamo}');
    Error('\P{:=Is_HANGUL_Jamo}');
    Expect(1, 4607, '\p{ishanguljamo}', "");
    Expect(0, 4607, '\p{^ishanguljamo}', "");
    Expect(0, 4607, '\P{ishanguljamo}', "");
    Expect(1, 4607, '\P{^ishanguljamo}', "");
    Expect(0, 4608, '\p{ishanguljamo}', "");
    Expect(1, 4608, '\p{^ishanguljamo}', "");
    Expect(1, 4608, '\P{ishanguljamo}', "");
    Expect(0, 4608, '\P{^ishanguljamo}', "");
    Expect(1, 4607, '\p{_ Is_hangul_Jamo}', "");
    Expect(0, 4607, '\p{^_ Is_hangul_Jamo}', "");
    Expect(0, 4607, '\P{_ Is_hangul_Jamo}', "");
    Expect(1, 4607, '\P{^_ Is_hangul_Jamo}', "");
    Expect(0, 4608, '\p{_ Is_hangul_Jamo}', "");
    Expect(1, 4608, '\p{^_ Is_hangul_Jamo}', "");
    Expect(1, 4608, '\P{_ Is_hangul_Jamo}', "");
    Expect(0, 4608, '\P{^_ Is_hangul_Jamo}', "");
    Error('\p{/a/IN_HANGUL_Jamo}');
    Error('\P{/a/IN_HANGUL_Jamo}');
    Expect(1, 4607, '\p{inhanguljamo}', "");
    Expect(0, 4607, '\p{^inhanguljamo}', "");
    Expect(0, 4607, '\P{inhanguljamo}', "");
    Expect(1, 4607, '\P{^inhanguljamo}', "");
    Expect(0, 4608, '\p{inhanguljamo}', "");
    Expect(1, 4608, '\p{^inhanguljamo}', "");
    Expect(1, 4608, '\P{inhanguljamo}', "");
    Expect(0, 4608, '\P{^inhanguljamo}', "");
    Expect(1, 4607, '\p{__IN_hangul_JAMO}', "");
    Expect(0, 4607, '\p{^__IN_hangul_JAMO}', "");
    Expect(0, 4607, '\P{__IN_hangul_JAMO}', "");
    Expect(1, 4607, '\P{^__IN_hangul_JAMO}', "");
    Expect(0, 4608, '\p{__IN_hangul_JAMO}', "");
    Expect(1, 4608, '\p{^__IN_hangul_JAMO}', "");
    Expect(1, 4608, '\P{__IN_hangul_JAMO}', "");
    Expect(0, 4608, '\P{^__IN_hangul_JAMO}', "");
    Error('\p{/a/_ Jamo}');
    Error('\P{/a/_ Jamo}');
    Expect(1, 4607, '\p{jamo}', "");
    Expect(0, 4607, '\p{^jamo}', "");
    Expect(0, 4607, '\P{jamo}', "");
    Expect(1, 4607, '\P{^jamo}', "");
    Expect(0, 4608, '\p{jamo}', "");
    Expect(1, 4608, '\p{^jamo}', "");
    Expect(1, 4608, '\P{jamo}', "");
    Expect(0, 4608, '\P{^jamo}', "");
    Expect(1, 4607, '\p{- Jamo}', "");
    Expect(0, 4607, '\p{^- Jamo}', "");
    Expect(0, 4607, '\P{- Jamo}', "");
    Expect(1, 4607, '\P{^- Jamo}', "");
    Expect(0, 4608, '\p{- Jamo}', "");
    Expect(1, 4608, '\p{^- Jamo}', "");
    Expect(1, 4608, '\P{- Jamo}', "");
    Expect(0, 4608, '\P{^- Jamo}', "");
    Error('\p{-/a/is_jamo}');
    Error('\P{-/a/is_jamo}');
    Expect(1, 4607, '\p{isjamo}', "");
    Expect(0, 4607, '\p{^isjamo}', "");
    Expect(0, 4607, '\P{isjamo}', "");
    Expect(1, 4607, '\P{^isjamo}', "");
    Expect(0, 4608, '\p{isjamo}', "");
    Expect(1, 4608, '\p{^isjamo}', "");
    Expect(1, 4608, '\P{isjamo}', "");
    Expect(0, 4608, '\P{^isjamo}', "");
    Expect(1, 4607, '\p{_Is_Jamo}', "");
    Expect(0, 4607, '\p{^_Is_Jamo}', "");
    Expect(0, 4607, '\P{_Is_Jamo}', "");
    Expect(1, 4607, '\P{^_Is_Jamo}', "");
    Expect(0, 4608, '\p{_Is_Jamo}', "");
    Expect(1, 4608, '\p{^_Is_Jamo}', "");
    Expect(1, 4608, '\P{_Is_Jamo}', "");
    Expect(0, 4608, '\P{^_Is_Jamo}', "");
    Error('\p{:=  IN_JAMO}');
    Error('\P{:=  IN_JAMO}');
    Expect(1, 4607, '\p{injamo}', "");
    Expect(0, 4607, '\p{^injamo}', "");
    Expect(0, 4607, '\P{injamo}', "");
    Expect(1, 4607, '\P{^injamo}', "");
    Expect(0, 4608, '\p{injamo}', "");
    Expect(1, 4608, '\p{^injamo}', "");
    Expect(1, 4608, '\P{injamo}', "");
    Expect(0, 4608, '\P{^injamo}', "");
    Expect(1, 4607, '\p{_	In_Jamo}', "");
    Expect(0, 4607, '\p{^_	In_Jamo}', "");
    Expect(0, 4607, '\P{_	In_Jamo}', "");
    Expect(1, 4607, '\P{^_	In_Jamo}', "");
    Expect(0, 4608, '\p{_	In_Jamo}', "");
    Expect(1, 4608, '\p{^_	In_Jamo}', "");
    Expect(1, 4608, '\P{_	In_Jamo}', "");
    Expect(0, 4608, '\P{^_	In_Jamo}', "");
    Error('\p{ /a/HANGUL_Jamo_Extended_A}');
    Error('\P{ /a/HANGUL_Jamo_Extended_A}');
    Expect(1, 43391, '\p{hanguljamoextendeda}', "");
    Expect(0, 43391, '\p{^hanguljamoextendeda}', "");
    Expect(0, 43391, '\P{hanguljamoextendeda}', "");
    Expect(1, 43391, '\P{^hanguljamoextendeda}', "");
    Expect(0, 43392, '\p{hanguljamoextendeda}', "");
    Expect(1, 43392, '\p{^hanguljamoextendeda}', "");
    Expect(1, 43392, '\P{hanguljamoextendeda}', "");
    Expect(0, 43392, '\P{^hanguljamoextendeda}', "");
    Expect(1, 43391, '\p{		Hangul_JAMO_EXTENDED_A}', "");
    Expect(0, 43391, '\p{^		Hangul_JAMO_EXTENDED_A}', "");
    Expect(0, 43391, '\P{		Hangul_JAMO_EXTENDED_A}', "");
    Expect(1, 43391, '\P{^		Hangul_JAMO_EXTENDED_A}', "");
    Expect(0, 43392, '\p{		Hangul_JAMO_EXTENDED_A}', "");
    Expect(1, 43392, '\p{^		Hangul_JAMO_EXTENDED_A}', "");
    Expect(1, 43392, '\P{		Hangul_JAMO_EXTENDED_A}', "");
    Expect(0, 43392, '\P{^		Hangul_JAMO_EXTENDED_A}', "");
    Error('\p{ :=Is_HANGUL_Jamo_Extended_A}');
    Error('\P{ :=Is_HANGUL_Jamo_Extended_A}');
    Expect(1, 43391, '\p{ishanguljamoextendeda}', "");
    Expect(0, 43391, '\p{^ishanguljamoextendeda}', "");
    Expect(0, 43391, '\P{ishanguljamoextendeda}', "");
    Expect(1, 43391, '\P{^ishanguljamoextendeda}', "");
    Expect(0, 43392, '\p{ishanguljamoextendeda}', "");
    Expect(1, 43392, '\p{^ishanguljamoextendeda}', "");
    Expect(1, 43392, '\P{ishanguljamoextendeda}', "");
    Expect(0, 43392, '\P{^ishanguljamoextendeda}', "");
    Expect(1, 43391, '\p{IS_HANGUL_Jamo_Extended_a}', "");
    Expect(0, 43391, '\p{^IS_HANGUL_Jamo_Extended_a}', "");
    Expect(0, 43391, '\P{IS_HANGUL_Jamo_Extended_a}', "");
    Expect(1, 43391, '\P{^IS_HANGUL_Jamo_Extended_a}', "");
    Expect(0, 43392, '\p{IS_HANGUL_Jamo_Extended_a}', "");
    Expect(1, 43392, '\p{^IS_HANGUL_Jamo_Extended_a}', "");
    Expect(1, 43392, '\P{IS_HANGUL_Jamo_Extended_a}', "");
    Expect(0, 43392, '\P{^IS_HANGUL_Jamo_Extended_a}', "");
    Error('\p{_/a/In_Hangul_Jamo_extended_A}');
    Error('\P{_/a/In_Hangul_Jamo_extended_A}');
    Expect(1, 43391, '\p{inhanguljamoextendeda}', "");
    Expect(0, 43391, '\p{^inhanguljamoextendeda}', "");
    Expect(0, 43391, '\P{inhanguljamoextendeda}', "");
    Expect(1, 43391, '\P{^inhanguljamoextendeda}', "");
    Expect(0, 43392, '\p{inhanguljamoextendeda}', "");
    Expect(1, 43392, '\p{^inhanguljamoextendeda}', "");
    Expect(1, 43392, '\P{inhanguljamoextendeda}', "");
    Expect(0, 43392, '\P{^inhanguljamoextendeda}', "");
    Expect(1, 43391, '\p{ -In_HANGUL_Jamo_Extended_a}', "");
    Expect(0, 43391, '\p{^ -In_HANGUL_Jamo_Extended_a}', "");
    Expect(0, 43391, '\P{ -In_HANGUL_Jamo_Extended_a}', "");
    Expect(1, 43391, '\P{^ -In_HANGUL_Jamo_Extended_a}', "");
    Expect(0, 43392, '\p{ -In_HANGUL_Jamo_Extended_a}', "");
    Expect(1, 43392, '\p{^ -In_HANGUL_Jamo_Extended_a}', "");
    Expect(1, 43392, '\P{ -In_HANGUL_Jamo_Extended_a}', "");
    Expect(0, 43392, '\P{^ -In_HANGUL_Jamo_Extended_a}', "");
    Error('\p{/a/	-Jamo_ext_A}');
    Error('\P{/a/	-Jamo_ext_A}');
    Expect(1, 43391, '\p{jamoexta}', "");
    Expect(0, 43391, '\p{^jamoexta}', "");
    Expect(0, 43391, '\P{jamoexta}', "");
    Expect(1, 43391, '\P{^jamoexta}', "");
    Expect(0, 43392, '\p{jamoexta}', "");
    Expect(1, 43392, '\p{^jamoexta}', "");
    Expect(1, 43392, '\P{jamoexta}', "");
    Expect(0, 43392, '\P{^jamoexta}', "");
    Expect(1, 43391, '\p{  Jamo_EXT_A}', "");
    Expect(0, 43391, '\p{^  Jamo_EXT_A}', "");
    Expect(0, 43391, '\P{  Jamo_EXT_A}', "");
    Expect(1, 43391, '\P{^  Jamo_EXT_A}', "");
    Expect(0, 43392, '\p{  Jamo_EXT_A}', "");
    Expect(1, 43392, '\p{^  Jamo_EXT_A}', "");
    Expect(1, 43392, '\P{  Jamo_EXT_A}', "");
    Expect(0, 43392, '\P{^  Jamo_EXT_A}', "");
    Error('\p{:= IS_Jamo_Ext_A}');
    Error('\P{:= IS_Jamo_Ext_A}');
    Expect(1, 43391, '\p{isjamoexta}', "");
    Expect(0, 43391, '\p{^isjamoexta}', "");
    Expect(0, 43391, '\P{isjamoexta}', "");
    Expect(1, 43391, '\P{^isjamoexta}', "");
    Expect(0, 43392, '\p{isjamoexta}', "");
    Expect(1, 43392, '\p{^isjamoexta}', "");
    Expect(1, 43392, '\P{isjamoexta}', "");
    Expect(0, 43392, '\P{^isjamoexta}', "");
    Expect(1, 43391, '\p{_is_JAMO_ext_a}', "");
    Expect(0, 43391, '\p{^_is_JAMO_ext_a}', "");
    Expect(0, 43391, '\P{_is_JAMO_ext_a}', "");
    Expect(1, 43391, '\P{^_is_JAMO_ext_a}', "");
    Expect(0, 43392, '\p{_is_JAMO_ext_a}', "");
    Expect(1, 43392, '\p{^_is_JAMO_ext_a}', "");
    Expect(1, 43392, '\P{_is_JAMO_ext_a}', "");
    Expect(0, 43392, '\P{^_is_JAMO_ext_a}', "");
    Error('\p{	In_Jamo_EXT_A/a/}');
    Error('\P{	In_Jamo_EXT_A/a/}');
    Expect(1, 43391, '\p{injamoexta}', "");
    Expect(0, 43391, '\p{^injamoexta}', "");
    Expect(0, 43391, '\P{injamoexta}', "");
    Expect(1, 43391, '\P{^injamoexta}', "");
    Expect(0, 43392, '\p{injamoexta}', "");
    Expect(1, 43392, '\p{^injamoexta}', "");
    Expect(1, 43392, '\P{injamoexta}', "");
    Expect(0, 43392, '\P{^injamoexta}', "");
    Expect(1, 43391, '\p{--IN_JAMO_Ext_A}', "");
    Expect(0, 43391, '\p{^--IN_JAMO_Ext_A}', "");
    Expect(0, 43391, '\P{--IN_JAMO_Ext_A}', "");
    Expect(1, 43391, '\P{^--IN_JAMO_Ext_A}', "");
    Expect(0, 43392, '\p{--IN_JAMO_Ext_A}', "");
    Expect(1, 43392, '\p{^--IN_JAMO_Ext_A}', "");
    Expect(1, 43392, '\P{--IN_JAMO_Ext_A}', "");
    Expect(0, 43392, '\P{^--IN_JAMO_Ext_A}', "");
    Error('\p{:= _Hangul_JAMO_extended_B}');
    Error('\P{:= _Hangul_JAMO_extended_B}');
    Expect(1, 55295, '\p{hanguljamoextendedb}', "");
    Expect(0, 55295, '\p{^hanguljamoextendedb}', "");
    Expect(0, 55295, '\P{hanguljamoextendedb}', "");
    Expect(1, 55295, '\P{^hanguljamoextendedb}', "");
    Expect(0, 57344, '\p{hanguljamoextendedb}', "");
    Expect(1, 57344, '\p{^hanguljamoextendedb}', "");
    Expect(1, 57344, '\P{hanguljamoextendedb}', "");
    Expect(0, 57344, '\P{^hanguljamoextendedb}', "");
    Expect(1, 55295, '\p{	_Hangul_JAMO_extended_B}', "");
    Expect(0, 55295, '\p{^	_Hangul_JAMO_extended_B}', "");
    Expect(0, 55295, '\P{	_Hangul_JAMO_extended_B}', "");
    Expect(1, 55295, '\P{^	_Hangul_JAMO_extended_B}', "");
    Expect(0, 57344, '\p{	_Hangul_JAMO_extended_B}', "");
    Expect(1, 57344, '\p{^	_Hangul_JAMO_extended_B}', "");
    Expect(1, 57344, '\P{	_Hangul_JAMO_extended_B}', "");
    Expect(0, 57344, '\P{^	_Hangul_JAMO_extended_B}', "");
    Error('\p{	:=Is_Hangul_Jamo_EXTENDED_B}');
    Error('\P{	:=Is_Hangul_Jamo_EXTENDED_B}');
    Expect(1, 55295, '\p{ishanguljamoextendedb}', "");
    Expect(0, 55295, '\p{^ishanguljamoextendedb}', "");
    Expect(0, 55295, '\P{ishanguljamoextendedb}', "");
    Expect(1, 55295, '\P{^ishanguljamoextendedb}', "");
    Expect(0, 57344, '\p{ishanguljamoextendedb}', "");
    Expect(1, 57344, '\p{^ishanguljamoextendedb}', "");
    Expect(1, 57344, '\P{ishanguljamoextendedb}', "");
    Expect(0, 57344, '\P{^ishanguljamoextendedb}', "");
    Expect(1, 55295, '\p{_	IS_Hangul_JAMO_Extended_B}', "");
    Expect(0, 55295, '\p{^_	IS_Hangul_JAMO_Extended_B}', "");
    Expect(0, 55295, '\P{_	IS_Hangul_JAMO_Extended_B}', "");
    Expect(1, 55295, '\P{^_	IS_Hangul_JAMO_Extended_B}', "");
    Expect(0, 57344, '\p{_	IS_Hangul_JAMO_Extended_B}', "");
    Expect(1, 57344, '\p{^_	IS_Hangul_JAMO_Extended_B}', "");
    Expect(1, 57344, '\P{_	IS_Hangul_JAMO_Extended_B}', "");
    Expect(0, 57344, '\P{^_	IS_Hangul_JAMO_Extended_B}', "");
    Error('\p{-	IN_Hangul_Jamo_Extended_B/a/}');
    Error('\P{-	IN_Hangul_Jamo_Extended_B/a/}');
    Expect(1, 55295, '\p{inhanguljamoextendedb}', "");
    Expect(0, 55295, '\p{^inhanguljamoextendedb}', "");
    Expect(0, 55295, '\P{inhanguljamoextendedb}', "");
    Expect(1, 55295, '\P{^inhanguljamoextendedb}', "");
    Expect(0, 57344, '\p{inhanguljamoextendedb}', "");
    Expect(1, 57344, '\p{^inhanguljamoextendedb}', "");
    Expect(1, 57344, '\P{inhanguljamoextendedb}', "");
    Expect(0, 57344, '\P{^inhanguljamoextendedb}', "");
    Expect(1, 55295, '\p{_In_Hangul_Jamo_Extended_B}', "");
    Expect(0, 55295, '\p{^_In_Hangul_Jamo_Extended_B}', "");
    Expect(0, 55295, '\P{_In_Hangul_Jamo_Extended_B}', "");
    Expect(1, 55295, '\P{^_In_Hangul_Jamo_Extended_B}', "");
    Expect(0, 57344, '\p{_In_Hangul_Jamo_Extended_B}', "");
    Expect(1, 57344, '\p{^_In_Hangul_Jamo_Extended_B}', "");
    Expect(1, 57344, '\P{_In_Hangul_Jamo_Extended_B}', "");
    Expect(0, 57344, '\P{^_In_Hangul_Jamo_Extended_B}', "");
    Error('\p{/a/	_Jamo_Ext_B}');
    Error('\P{/a/	_Jamo_Ext_B}');
    Expect(1, 55295, '\p{jamoextb}', "");
    Expect(0, 55295, '\p{^jamoextb}', "");
    Expect(0, 55295, '\P{jamoextb}', "");
    Expect(1, 55295, '\P{^jamoextb}', "");
    Expect(0, 57344, '\p{jamoextb}', "");
    Expect(1, 57344, '\p{^jamoextb}', "");
    Expect(1, 57344, '\P{jamoextb}', "");
    Expect(0, 57344, '\P{^jamoextb}', "");
    Expect(1, 55295, '\p{ JAMO_Ext_B}', "");
    Expect(0, 55295, '\p{^ JAMO_Ext_B}', "");
    Expect(0, 55295, '\P{ JAMO_Ext_B}', "");
    Expect(1, 55295, '\P{^ JAMO_Ext_B}', "");
    Expect(0, 57344, '\p{ JAMO_Ext_B}', "");
    Expect(1, 57344, '\p{^ JAMO_Ext_B}', "");
    Expect(1, 57344, '\P{ JAMO_Ext_B}', "");
    Expect(0, 57344, '\P{^ JAMO_Ext_B}', "");
    Error('\p{:=	 Is_Jamo_EXT_B}');
    Error('\P{:=	 Is_Jamo_EXT_B}');
    Expect(1, 55295, '\p{isjamoextb}', "");
    Expect(0, 55295, '\p{^isjamoextb}', "");
    Expect(0, 55295, '\P{isjamoextb}', "");
    Expect(1, 55295, '\P{^isjamoextb}', "");
    Expect(0, 57344, '\p{isjamoextb}', "");
    Expect(1, 57344, '\p{^isjamoextb}', "");
    Expect(1, 57344, '\P{isjamoextb}', "");
    Expect(0, 57344, '\P{^isjamoextb}', "");
    Expect(1, 55295, '\p{-_is_JAMO_ext_B}', "");
    Expect(0, 55295, '\p{^-_is_JAMO_ext_B}', "");
    Expect(0, 55295, '\P{-_is_JAMO_ext_B}', "");
    Expect(1, 55295, '\P{^-_is_JAMO_ext_B}', "");
    Expect(0, 57344, '\p{-_is_JAMO_ext_B}', "");
    Expect(1, 57344, '\p{^-_is_JAMO_ext_B}', "");
    Expect(1, 57344, '\P{-_is_JAMO_ext_B}', "");
    Expect(0, 57344, '\P{^-_is_JAMO_ext_B}', "");
    Error('\p{ /a/In_Jamo_EXT_B}');
    Error('\P{ /a/In_Jamo_EXT_B}');
    Expect(1, 55295, '\p{injamoextb}', "");
    Expect(0, 55295, '\p{^injamoextb}', "");
    Expect(0, 55295, '\P{injamoextb}', "");
    Expect(1, 55295, '\P{^injamoextb}', "");
    Expect(0, 57344, '\p{injamoextb}', "");
    Expect(1, 57344, '\p{^injamoextb}', "");
    Expect(1, 57344, '\P{injamoextb}', "");
    Expect(0, 57344, '\P{^injamoextb}', "");
    Expect(1, 55295, '\p{in_Jamo_ext_B}', "");
    Expect(0, 55295, '\p{^in_Jamo_ext_B}', "");
    Expect(0, 55295, '\P{in_Jamo_ext_B}', "");
    Expect(1, 55295, '\P{^in_Jamo_ext_B}', "");
    Expect(0, 57344, '\p{in_Jamo_ext_B}', "");
    Expect(1, 57344, '\p{^in_Jamo_ext_B}', "");
    Expect(1, 57344, '\P{in_Jamo_ext_B}', "");
    Expect(0, 57344, '\P{^in_Jamo_ext_B}', "");
    Error('\p{:= Hangul_syllables}');
    Error('\P{:= Hangul_syllables}');
    Expect(1, 55215, '\p{hangulsyllables}', "");
    Expect(0, 55215, '\p{^hangulsyllables}', "");
    Expect(0, 55215, '\P{hangulsyllables}', "");
    Expect(1, 55215, '\P{^hangulsyllables}', "");
    Expect(0, 55216, '\p{hangulsyllables}', "");
    Expect(1, 55216, '\p{^hangulsyllables}', "");
    Expect(1, 55216, '\P{hangulsyllables}', "");
    Expect(0, 55216, '\P{^hangulsyllables}', "");
    Expect(1, 55215, '\p{ Hangul_Syllables}', "");
    Expect(0, 55215, '\p{^ Hangul_Syllables}', "");
    Expect(0, 55215, '\P{ Hangul_Syllables}', "");
    Expect(1, 55215, '\P{^ Hangul_Syllables}', "");
    Expect(0, 55216, '\p{ Hangul_Syllables}', "");
    Expect(1, 55216, '\p{^ Hangul_Syllables}', "");
    Expect(1, 55216, '\P{ Hangul_Syllables}', "");
    Expect(0, 55216, '\P{^ Hangul_Syllables}', "");
    Error('\p{:=-	Is_Hangul_syllables}');
    Error('\P{:=-	Is_Hangul_syllables}');
    Expect(1, 55215, '\p{ishangulsyllables}', "");
    Expect(0, 55215, '\p{^ishangulsyllables}', "");
    Expect(0, 55215, '\P{ishangulsyllables}', "");
    Expect(1, 55215, '\P{^ishangulsyllables}', "");
    Expect(0, 55216, '\p{ishangulsyllables}', "");
    Expect(1, 55216, '\p{^ishangulsyllables}', "");
    Expect(1, 55216, '\P{ishangulsyllables}', "");
    Expect(0, 55216, '\P{^ishangulsyllables}', "");
    Expect(1, 55215, '\p{_-Is_Hangul_Syllables}', "");
    Expect(0, 55215, '\p{^_-Is_Hangul_Syllables}', "");
    Expect(0, 55215, '\P{_-Is_Hangul_Syllables}', "");
    Expect(1, 55215, '\P{^_-Is_Hangul_Syllables}', "");
    Expect(0, 55216, '\p{_-Is_Hangul_Syllables}', "");
    Expect(1, 55216, '\p{^_-Is_Hangul_Syllables}', "");
    Expect(1, 55216, '\P{_-Is_Hangul_Syllables}', "");
    Expect(0, 55216, '\P{^_-Is_Hangul_Syllables}', "");
    Error('\p{:=in_Hangul_syllables}');
    Error('\P{:=in_Hangul_syllables}');
    Expect(1, 55215, '\p{inhangulsyllables}', "");
    Expect(0, 55215, '\p{^inhangulsyllables}', "");
    Expect(0, 55215, '\P{inhangulsyllables}', "");
    Expect(1, 55215, '\P{^inhangulsyllables}', "");
    Expect(0, 55216, '\p{inhangulsyllables}', "");
    Expect(1, 55216, '\p{^inhangulsyllables}', "");
    Expect(1, 55216, '\P{inhangulsyllables}', "");
    Expect(0, 55216, '\P{^inhangulsyllables}', "");
    Expect(1, 55215, '\p{ IN_Hangul_syllables}', "");
    Expect(0, 55215, '\p{^ IN_Hangul_syllables}', "");
    Expect(0, 55215, '\P{ IN_Hangul_syllables}', "");
    Expect(1, 55215, '\P{^ IN_Hangul_syllables}', "");
    Expect(0, 55216, '\p{ IN_Hangul_syllables}', "");
    Expect(1, 55216, '\p{^ IN_Hangul_syllables}', "");
    Expect(1, 55216, '\P{ IN_Hangul_syllables}', "");
    Expect(0, 55216, '\P{^ IN_Hangul_syllables}', "");
    Error('\p{	/a/In_Hangul}');
    Error('\P{	/a/In_Hangul}');
    Expect(1, 55215, '\p{inhangul}', "");
    Expect(0, 55215, '\p{^inhangul}', "");
    Expect(0, 55215, '\P{inhangul}', "");
    Expect(1, 55215, '\P{^inhangul}', "");
    Expect(0, 55216, '\p{inhangul}', "");
    Expect(1, 55216, '\p{^inhangul}', "");
    Expect(1, 55216, '\P{inhangul}', "");
    Expect(0, 55216, '\P{^inhangul}', "");
    Expect(1, 55215, '\p{_In_Hangul}', "");
    Expect(0, 55215, '\p{^_In_Hangul}', "");
    Expect(0, 55215, '\P{_In_Hangul}', "");
    Expect(1, 55215, '\P{^_In_Hangul}', "");
    Expect(0, 55216, '\p{_In_Hangul}', "");
    Expect(1, 55216, '\p{^_In_Hangul}', "");
    Expect(1, 55216, '\P{_In_Hangul}', "");
    Expect(0, 55216, '\P{^_In_Hangul}', "");
    Error('\p{-/a/Hanifi_Rohingya}');
    Error('\P{-/a/Hanifi_Rohingya}');
    Expect(1, 68921, '\p{hanifirohingya}', "");
    Expect(0, 68921, '\p{^hanifirohingya}', "");
    Expect(0, 68921, '\P{hanifirohingya}', "");
    Expect(1, 68921, '\P{^hanifirohingya}', "");
    Expect(0, 68922, '\p{hanifirohingya}', "");
    Expect(1, 68922, '\p{^hanifirohingya}', "");
    Expect(1, 68922, '\P{hanifirohingya}', "");
    Expect(0, 68922, '\P{^hanifirohingya}', "");
    Expect(1, 68921, '\p{ hanifi_ROHINGYA}', "");
    Expect(0, 68921, '\p{^ hanifi_ROHINGYA}', "");
    Expect(0, 68921, '\P{ hanifi_ROHINGYA}', "");
    Expect(1, 68921, '\P{^ hanifi_ROHINGYA}', "");
    Expect(0, 68922, '\p{ hanifi_ROHINGYA}', "");
    Expect(1, 68922, '\p{^ hanifi_ROHINGYA}', "");
    Expect(1, 68922, '\P{ hanifi_ROHINGYA}', "");
    Expect(0, 68922, '\P{^ hanifi_ROHINGYA}', "");
    Error('\p{:=_-Is_HANIFI_Rohingya}');
    Error('\P{:=_-Is_HANIFI_Rohingya}');
    Expect(1, 68921, '\p{ishanifirohingya}', "");
    Expect(0, 68921, '\p{^ishanifirohingya}', "");
    Expect(0, 68921, '\P{ishanifirohingya}', "");
    Expect(1, 68921, '\P{^ishanifirohingya}', "");
    Expect(0, 68922, '\p{ishanifirohingya}', "");
    Expect(1, 68922, '\p{^ishanifirohingya}', "");
    Expect(1, 68922, '\P{ishanifirohingya}', "");
    Expect(0, 68922, '\P{^ishanifirohingya}', "");
    Expect(1, 68921, '\p{Is_Hanifi_ROHINGYA}', "");
    Expect(0, 68921, '\p{^Is_Hanifi_ROHINGYA}', "");
    Expect(0, 68921, '\P{Is_Hanifi_ROHINGYA}', "");
    Expect(1, 68921, '\P{^Is_Hanifi_ROHINGYA}', "");
    Expect(0, 68922, '\p{Is_Hanifi_ROHINGYA}', "");
    Expect(1, 68922, '\p{^Is_Hanifi_ROHINGYA}', "");
    Expect(1, 68922, '\P{Is_Hanifi_ROHINGYA}', "");
    Expect(0, 68922, '\P{^Is_Hanifi_ROHINGYA}', "");
    Error('\p{:=	 rohg}');
    Error('\P{:=	 rohg}');
    Expect(1, 68921, '\p{rohg}', "");
    Expect(0, 68921, '\p{^rohg}', "");
    Expect(0, 68921, '\P{rohg}', "");
    Expect(1, 68921, '\P{^rohg}', "");
    Expect(0, 68922, '\p{rohg}', "");
    Expect(1, 68922, '\p{^rohg}', "");
    Expect(1, 68922, '\P{rohg}', "");
    Expect(0, 68922, '\P{^rohg}', "");
    Expect(1, 68921, '\p{		rohg}', "");
    Expect(0, 68921, '\p{^		rohg}', "");
    Expect(0, 68921, '\P{		rohg}', "");
    Expect(1, 68921, '\P{^		rohg}', "");
    Expect(0, 68922, '\p{		rohg}', "");
    Expect(1, 68922, '\p{^		rohg}', "");
    Expect(1, 68922, '\P{		rohg}', "");
    Expect(0, 68922, '\P{^		rohg}', "");
    Error('\p{Is_Rohg:=}');
    Error('\P{Is_Rohg:=}');
    Expect(1, 68921, '\p{isrohg}', "");
    Expect(0, 68921, '\p{^isrohg}', "");
    Expect(0, 68921, '\P{isrohg}', "");
    Expect(1, 68921, '\P{^isrohg}', "");
    Expect(0, 68922, '\p{isrohg}', "");
    Expect(1, 68922, '\p{^isrohg}', "");
    Expect(1, 68922, '\P{isrohg}', "");
    Expect(0, 68922, '\P{^isrohg}', "");
    Expect(1, 68921, '\p{	 Is_rohg}', "");
    Expect(0, 68921, '\p{^	 Is_rohg}', "");
    Expect(0, 68921, '\P{	 Is_rohg}', "");
    Expect(1, 68921, '\P{^	 Is_rohg}', "");
    Expect(0, 68922, '\p{	 Is_rohg}', "");
    Expect(1, 68922, '\p{^	 Is_rohg}', "");
    Expect(1, 68922, '\P{	 Is_rohg}', "");
    Expect(0, 68922, '\P{^	 Is_rohg}', "");
    Error('\p{/a/Hanunoo}');
    Error('\P{/a/Hanunoo}');
    Expect(1, 5942, '\p{hanunoo}', "");
    Expect(0, 5942, '\p{^hanunoo}', "");
    Expect(0, 5942, '\P{hanunoo}', "");
    Expect(1, 5942, '\P{^hanunoo}', "");
    Expect(0, 5943, '\p{hanunoo}', "");
    Expect(1, 5943, '\p{^hanunoo}', "");
    Expect(1, 5943, '\P{hanunoo}', "");
    Expect(0, 5943, '\P{^hanunoo}', "");
    Expect(1, 5942, '\p{-_Hanunoo}', "");
    Expect(0, 5942, '\p{^-_Hanunoo}', "");
    Expect(0, 5942, '\P{-_Hanunoo}', "");
    Expect(1, 5942, '\P{^-_Hanunoo}', "");
    Expect(0, 5943, '\p{-_Hanunoo}', "");
    Expect(1, 5943, '\p{^-_Hanunoo}', "");
    Expect(1, 5943, '\P{-_Hanunoo}', "");
    Expect(0, 5943, '\P{^-_Hanunoo}', "");
    Error('\p{	IS_Hanunoo:=}');
    Error('\P{	IS_Hanunoo:=}');
    Expect(1, 5942, '\p{ishanunoo}', "");
    Expect(0, 5942, '\p{^ishanunoo}', "");
    Expect(0, 5942, '\P{ishanunoo}', "");
    Expect(1, 5942, '\P{^ishanunoo}', "");
    Expect(0, 5943, '\p{ishanunoo}', "");
    Expect(1, 5943, '\p{^ishanunoo}', "");
    Expect(1, 5943, '\P{ishanunoo}', "");
    Expect(0, 5943, '\P{^ishanunoo}', "");
    Expect(1, 5942, '\p{-_Is_Hanunoo}', "");
    Expect(0, 5942, '\p{^-_Is_Hanunoo}', "");
    Expect(0, 5942, '\P{-_Is_Hanunoo}', "");
    Expect(1, 5942, '\P{^-_Is_Hanunoo}', "");
    Expect(0, 5943, '\p{-_Is_Hanunoo}', "");
    Expect(1, 5943, '\p{^-_Is_Hanunoo}', "");
    Expect(1, 5943, '\P{-_Is_Hanunoo}', "");
    Expect(0, 5943, '\P{^-_Is_Hanunoo}', "");
    Error('\p{:=	 HANO}');
    Error('\P{:=	 HANO}');
    Expect(1, 5942, '\p{hano}', "");
    Expect(0, 5942, '\p{^hano}', "");
    Expect(0, 5942, '\P{hano}', "");
    Expect(1, 5942, '\P{^hano}', "");
    Expect(0, 5943, '\p{hano}', "");
    Expect(1, 5943, '\p{^hano}', "");
    Expect(1, 5943, '\P{hano}', "");
    Expect(0, 5943, '\P{^hano}', "");
    Expect(1, 5942, '\p{--HANO}', "");
    Expect(0, 5942, '\p{^--HANO}', "");
    Expect(0, 5942, '\P{--HANO}', "");
    Expect(1, 5942, '\P{^--HANO}', "");
    Expect(0, 5943, '\p{--HANO}', "");
    Expect(1, 5943, '\p{^--HANO}', "");
    Expect(1, 5943, '\P{--HANO}', "");
    Expect(0, 5943, '\P{^--HANO}', "");
    Error('\p{ -Is_Hano/a/}');
    Error('\P{ -Is_Hano/a/}');
    Expect(1, 5942, '\p{ishano}', "");
    Expect(0, 5942, '\p{^ishano}', "");
    Expect(0, 5942, '\P{ishano}', "");
    Expect(1, 5942, '\P{^ishano}', "");
    Expect(0, 5943, '\p{ishano}', "");
    Expect(1, 5943, '\p{^ishano}', "");
    Expect(1, 5943, '\P{ishano}', "");
    Expect(0, 5943, '\P{^ishano}', "");
    Expect(1, 5942, '\p{_is_HANO}', "");
    Expect(0, 5942, '\p{^_is_HANO}', "");
    Expect(0, 5942, '\P{_is_HANO}', "");
    Expect(1, 5942, '\P{^_is_HANO}', "");
    Expect(0, 5943, '\p{_is_HANO}', "");
    Expect(1, 5943, '\p{^_is_HANO}', "");
    Expect(1, 5943, '\P{_is_HANO}', "");
    Expect(0, 5943, '\P{^_is_HANO}', "");
    Error('\p{/a/hatran}');
    Error('\P{/a/hatran}');
    Expect(1, 67839, '\p{hatran}', "");
    Expect(0, 67839, '\p{^hatran}', "");
    Expect(0, 67839, '\P{hatran}', "");
    Expect(1, 67839, '\P{^hatran}', "");
    Expect(0, 67840, '\p{hatran}', "");
    Expect(1, 67840, '\p{^hatran}', "");
    Expect(1, 67840, '\P{hatran}', "");
    Expect(0, 67840, '\P{^hatran}', "");
    Expect(1, 67839, '\p{	Hatran}', "");
    Expect(0, 67839, '\p{^	Hatran}', "");
    Expect(0, 67839, '\P{	Hatran}', "");
    Expect(1, 67839, '\P{^	Hatran}', "");
    Expect(0, 67840, '\p{	Hatran}', "");
    Expect(1, 67840, '\p{^	Hatran}', "");
    Expect(1, 67840, '\P{	Hatran}', "");
    Expect(0, 67840, '\P{^	Hatran}', "");
    Error('\p{:=_is_hatran}');
    Error('\P{:=_is_hatran}');
    Expect(1, 67839, '\p{ishatran}', "");
    Expect(0, 67839, '\p{^ishatran}', "");
    Expect(0, 67839, '\P{ishatran}', "");
    Expect(1, 67839, '\P{^ishatran}', "");
    Expect(0, 67840, '\p{ishatran}', "");
    Expect(1, 67840, '\p{^ishatran}', "");
    Expect(1, 67840, '\P{ishatran}', "");
    Expect(0, 67840, '\P{^ishatran}', "");
    Expect(1, 67839, '\p{_Is_hatran}', "");
    Expect(0, 67839, '\p{^_Is_hatran}', "");
    Expect(0, 67839, '\P{_Is_hatran}', "");
    Expect(1, 67839, '\P{^_Is_hatran}', "");
    Expect(0, 67840, '\p{_Is_hatran}', "");
    Expect(1, 67840, '\p{^_Is_hatran}', "");
    Expect(1, 67840, '\P{_Is_hatran}', "");
    Expect(0, 67840, '\P{^_Is_hatran}', "");
    Error('\p{-	hatr:=}');
    Error('\P{-	hatr:=}');
    Expect(1, 67839, '\p{hatr}', "");
    Expect(0, 67839, '\p{^hatr}', "");
    Expect(0, 67839, '\P{hatr}', "");
    Expect(1, 67839, '\P{^hatr}', "");
    Expect(0, 67840, '\p{hatr}', "");
    Expect(1, 67840, '\p{^hatr}', "");
    Expect(1, 67840, '\P{hatr}', "");
    Expect(0, 67840, '\P{^hatr}', "");
    Expect(1, 67839, '\p{ Hatr}', "");
    Expect(0, 67839, '\p{^ Hatr}', "");
    Expect(0, 67839, '\P{ Hatr}', "");
    Expect(1, 67839, '\P{^ Hatr}', "");
    Expect(0, 67840, '\p{ Hatr}', "");
    Expect(1, 67840, '\p{^ Hatr}', "");
    Expect(1, 67840, '\P{ Hatr}', "");
    Expect(0, 67840, '\P{^ Hatr}', "");
    Error('\p{ /a/Is_hatr}');
    Error('\P{ /a/Is_hatr}');
    Expect(1, 67839, '\p{ishatr}', "");
    Expect(0, 67839, '\p{^ishatr}', "");
    Expect(0, 67839, '\P{ishatr}', "");
    Expect(1, 67839, '\P{^ishatr}', "");
    Expect(0, 67840, '\p{ishatr}', "");
    Expect(1, 67840, '\p{^ishatr}', "");
    Expect(1, 67840, '\P{ishatr}', "");
    Expect(0, 67840, '\P{^ishatr}', "");
    Expect(1, 67839, '\p{-IS_Hatr}', "");
    Expect(0, 67839, '\p{^-IS_Hatr}', "");
    Expect(0, 67839, '\P{-IS_Hatr}', "");
    Expect(1, 67839, '\P{^-IS_Hatr}', "");
    Expect(0, 67840, '\p{-IS_Hatr}', "");
    Expect(1, 67840, '\p{^-IS_Hatr}', "");
    Expect(1, 67840, '\P{-IS_Hatr}', "");
    Expect(0, 67840, '\P{^-IS_Hatr}', "");
    Error('\p{ /a/Hebrew}');
    Error('\P{ /a/Hebrew}');
    Expect(1, 64335, '\p{hebrew}', "");
    Expect(0, 64335, '\p{^hebrew}', "");
    Expect(0, 64335, '\P{hebrew}', "");
    Expect(1, 64335, '\P{^hebrew}', "");
    Expect(0, 64336, '\p{hebrew}', "");
    Expect(1, 64336, '\p{^hebrew}', "");
    Expect(1, 64336, '\P{hebrew}', "");
    Expect(0, 64336, '\P{^hebrew}', "");
    Expect(1, 64335, '\p{	_HEBREW}', "");
    Expect(0, 64335, '\p{^	_HEBREW}', "");
    Expect(0, 64335, '\P{	_HEBREW}', "");
    Expect(1, 64335, '\P{^	_HEBREW}', "");
    Expect(0, 64336, '\p{	_HEBREW}', "");
    Expect(1, 64336, '\p{^	_HEBREW}', "");
    Expect(1, 64336, '\P{	_HEBREW}', "");
    Expect(0, 64336, '\P{^	_HEBREW}', "");
    Error('\p{:=	-Is_HEBREW}');
    Error('\P{:=	-Is_HEBREW}');
    Expect(1, 64335, '\p{ishebrew}', "");
    Expect(0, 64335, '\p{^ishebrew}', "");
    Expect(0, 64335, '\P{ishebrew}', "");
    Expect(1, 64335, '\P{^ishebrew}', "");
    Expect(0, 64336, '\p{ishebrew}', "");
    Expect(1, 64336, '\p{^ishebrew}', "");
    Expect(1, 64336, '\P{ishebrew}', "");
    Expect(0, 64336, '\P{^ishebrew}', "");
    Expect(1, 64335, '\p{	_Is_HEBREW}', "");
    Expect(0, 64335, '\p{^	_Is_HEBREW}', "");
    Expect(0, 64335, '\P{	_Is_HEBREW}', "");
    Expect(1, 64335, '\P{^	_Is_HEBREW}', "");
    Expect(0, 64336, '\p{	_Is_HEBREW}', "");
    Expect(1, 64336, '\p{^	_Is_HEBREW}', "");
    Expect(1, 64336, '\P{	_Is_HEBREW}', "");
    Expect(0, 64336, '\P{^	_Is_HEBREW}', "");
    Error('\p{- Hebr/a/}');
    Error('\P{- Hebr/a/}');
    Expect(1, 64335, '\p{hebr}', "");
    Expect(0, 64335, '\p{^hebr}', "");
    Expect(0, 64335, '\P{hebr}', "");
    Expect(1, 64335, '\P{^hebr}', "");
    Expect(0, 64336, '\p{hebr}', "");
    Expect(1, 64336, '\p{^hebr}', "");
    Expect(1, 64336, '\P{hebr}', "");
    Expect(0, 64336, '\P{^hebr}', "");
    Expect(1, 64335, '\p{Hebr}', "");
    Expect(0, 64335, '\p{^Hebr}', "");
    Expect(0, 64335, '\P{Hebr}', "");
    Expect(1, 64335, '\P{^Hebr}', "");
    Expect(0, 64336, '\p{Hebr}', "");
    Expect(1, 64336, '\p{^Hebr}', "");
    Expect(1, 64336, '\P{Hebr}', "");
    Expect(0, 64336, '\P{^Hebr}', "");
    Error('\p{	:=Is_hebr}');
    Error('\P{	:=Is_hebr}');
    Expect(1, 64335, '\p{ishebr}', "");
    Expect(0, 64335, '\p{^ishebr}', "");
    Expect(0, 64335, '\P{ishebr}', "");
    Expect(1, 64335, '\P{^ishebr}', "");
    Expect(0, 64336, '\p{ishebr}', "");
    Expect(1, 64336, '\p{^ishebr}', "");
    Expect(1, 64336, '\P{ishebr}', "");
    Expect(0, 64336, '\P{^ishebr}', "");
    Expect(1, 64335, '\p{_-Is_HEBR}', "");
    Expect(0, 64335, '\p{^_-Is_HEBR}', "");
    Expect(0, 64335, '\P{_-Is_HEBR}', "");
    Expect(1, 64335, '\P{^_-Is_HEBR}', "");
    Expect(0, 64336, '\p{_-Is_HEBR}', "");
    Expect(1, 64336, '\p{^_-Is_HEBR}', "");
    Expect(1, 64336, '\P{_-Is_HEBR}', "");
    Expect(0, 64336, '\P{^_-Is_HEBR}', "");
    Error('\p{/a/_high_PRIVATE_Use_SURROGATES}');
    Error('\P{/a/_high_PRIVATE_Use_SURROGATES}');
    Expect(1, 56319, '\p{highprivateusesurrogates}', "");
    Expect(0, 56319, '\p{^highprivateusesurrogates}', "");
    Expect(0, 56319, '\P{highprivateusesurrogates}', "");
    Expect(1, 56319, '\P{^highprivateusesurrogates}', "");
    Expect(0, 57344, '\p{highprivateusesurrogates}', "");
    Expect(1, 57344, '\p{^highprivateusesurrogates}', "");
    Expect(1, 57344, '\P{highprivateusesurrogates}', "");
    Expect(0, 57344, '\P{^highprivateusesurrogates}', "");
    Expect(1, 56319, '\p{ -High_Private_Use_Surrogates}', "");
    Expect(0, 56319, '\p{^ -High_Private_Use_Surrogates}', "");
    Expect(0, 56319, '\P{ -High_Private_Use_Surrogates}', "");
    Expect(1, 56319, '\P{^ -High_Private_Use_Surrogates}', "");
    Expect(0, 57344, '\p{ -High_Private_Use_Surrogates}', "");
    Expect(1, 57344, '\p{^ -High_Private_Use_Surrogates}', "");
    Expect(1, 57344, '\P{ -High_Private_Use_Surrogates}', "");
    Expect(0, 57344, '\P{^ -High_Private_Use_Surrogates}', "");
    Error('\p{ :=IS_HIGH_private_USE_Surrogates}');
    Error('\P{ :=IS_HIGH_private_USE_Surrogates}');
    Expect(1, 56319, '\p{ishighprivateusesurrogates}', "");
    Expect(0, 56319, '\p{^ishighprivateusesurrogates}', "");
    Expect(0, 56319, '\P{ishighprivateusesurrogates}', "");
    Expect(1, 56319, '\P{^ishighprivateusesurrogates}', "");
    Expect(0, 57344, '\p{ishighprivateusesurrogates}', "");
    Expect(1, 57344, '\p{^ishighprivateusesurrogates}', "");
    Expect(1, 57344, '\P{ishighprivateusesurrogates}', "");
    Expect(0, 57344, '\P{^ishighprivateusesurrogates}', "");
    Expect(1, 56319, '\p{_-Is_High_Private_USE_surrogates}', "");
    Expect(0, 56319, '\p{^_-Is_High_Private_USE_surrogates}', "");
    Expect(0, 56319, '\P{_-Is_High_Private_USE_surrogates}', "");
    Expect(1, 56319, '\P{^_-Is_High_Private_USE_surrogates}', "");
    Expect(0, 57344, '\p{_-Is_High_Private_USE_surrogates}', "");
    Expect(1, 57344, '\p{^_-Is_High_Private_USE_surrogates}', "");
    Expect(1, 57344, '\P{_-Is_High_Private_USE_surrogates}', "");
    Expect(0, 57344, '\P{^_-Is_High_Private_USE_surrogates}', "");
    Error('\p{/a/	in_HIGH_Private_USE_Surrogates}');
    Error('\P{/a/	in_HIGH_Private_USE_Surrogates}');
    Expect(1, 56319, '\p{inhighprivateusesurrogates}', "");
    Expect(0, 56319, '\p{^inhighprivateusesurrogates}', "");
    Expect(0, 56319, '\P{inhighprivateusesurrogates}', "");
    Expect(1, 56319, '\P{^inhighprivateusesurrogates}', "");
    Expect(0, 57344, '\p{inhighprivateusesurrogates}', "");
    Expect(1, 57344, '\p{^inhighprivateusesurrogates}', "");
    Expect(1, 57344, '\P{inhighprivateusesurrogates}', "");
    Expect(0, 57344, '\P{^inhighprivateusesurrogates}', "");
    Expect(1, 56319, '\p{_-IN_HIGH_private_use_Surrogates}', "");
    Expect(0, 56319, '\p{^_-IN_HIGH_private_use_Surrogates}', "");
    Expect(0, 56319, '\P{_-IN_HIGH_private_use_Surrogates}', "");
    Expect(1, 56319, '\P{^_-IN_HIGH_private_use_Surrogates}', "");
    Expect(0, 57344, '\p{_-IN_HIGH_private_use_Surrogates}', "");
    Expect(1, 57344, '\p{^_-IN_HIGH_private_use_Surrogates}', "");
    Expect(1, 57344, '\P{_-IN_HIGH_private_use_Surrogates}', "");
    Expect(0, 57344, '\P{^_-IN_HIGH_private_use_Surrogates}', "");
    Error('\p{:=_ HIGH_PU_surrogates}');
    Error('\P{:=_ HIGH_PU_surrogates}');
    Expect(1, 56319, '\p{highpusurrogates}', "");
    Expect(0, 56319, '\p{^highpusurrogates}', "");
    Expect(0, 56319, '\P{highpusurrogates}', "");
    Expect(1, 56319, '\P{^highpusurrogates}', "");
    Expect(0, 57344, '\p{highpusurrogates}', "");
    Expect(1, 57344, '\p{^highpusurrogates}', "");
    Expect(1, 57344, '\P{highpusurrogates}', "");
    Expect(0, 57344, '\P{^highpusurrogates}', "");
    Expect(1, 56319, '\p{ High_PU_Surrogates}', "");
    Expect(0, 56319, '\p{^ High_PU_Surrogates}', "");
    Expect(0, 56319, '\P{ High_PU_Surrogates}', "");
    Expect(1, 56319, '\P{^ High_PU_Surrogates}', "");
    Expect(0, 57344, '\p{ High_PU_Surrogates}', "");
    Expect(1, 57344, '\p{^ High_PU_Surrogates}', "");
    Expect(1, 57344, '\P{ High_PU_Surrogates}', "");
    Expect(0, 57344, '\P{^ High_PU_Surrogates}', "");
    Error('\p{_:=Is_High_PU_surrogates}');
    Error('\P{_:=Is_High_PU_surrogates}');
    Expect(1, 56319, '\p{ishighpusurrogates}', "");
    Expect(0, 56319, '\p{^ishighpusurrogates}', "");
    Expect(0, 56319, '\P{ishighpusurrogates}', "");
    Expect(1, 56319, '\P{^ishighpusurrogates}', "");
    Expect(0, 57344, '\p{ishighpusurrogates}', "");
    Expect(1, 57344, '\p{^ishighpusurrogates}', "");
    Expect(1, 57344, '\P{ishighpusurrogates}', "");
    Expect(0, 57344, '\P{^ishighpusurrogates}', "");
    Expect(1, 56319, '\p{		Is_high_pu_surrogates}', "");
    Expect(0, 56319, '\p{^		Is_high_pu_surrogates}', "");
    Expect(0, 56319, '\P{		Is_high_pu_surrogates}', "");
    Expect(1, 56319, '\P{^		Is_high_pu_surrogates}', "");
    Expect(0, 57344, '\p{		Is_high_pu_surrogates}', "");
    Expect(1, 57344, '\p{^		Is_high_pu_surrogates}', "");
    Expect(1, 57344, '\P{		Is_high_pu_surrogates}', "");
    Expect(0, 57344, '\P{^		Is_high_pu_surrogates}', "");
    Error('\p{:= In_High_PU_Surrogates}');
    Error('\P{:= In_High_PU_Surrogates}');
    Expect(1, 56319, '\p{inhighpusurrogates}', "");
    Expect(0, 56319, '\p{^inhighpusurrogates}', "");
    Expect(0, 56319, '\P{inhighpusurrogates}', "");
    Expect(1, 56319, '\P{^inhighpusurrogates}', "");
    Expect(0, 57344, '\p{inhighpusurrogates}', "");
    Expect(1, 57344, '\p{^inhighpusurrogates}', "");
    Expect(1, 57344, '\P{inhighpusurrogates}', "");
    Expect(0, 57344, '\P{^inhighpusurrogates}', "");
    Expect(1, 56319, '\p{	In_high_PU_Surrogates}', "");
    Expect(0, 56319, '\p{^	In_high_PU_Surrogates}', "");
    Expect(0, 56319, '\P{	In_high_PU_Surrogates}', "");
    Expect(1, 56319, '\P{^	In_high_PU_Surrogates}', "");
    Expect(0, 57344, '\p{	In_high_PU_Surrogates}', "");
    Expect(1, 57344, '\p{^	In_high_PU_Surrogates}', "");
    Expect(1, 57344, '\P{	In_high_PU_Surrogates}', "");
    Expect(0, 57344, '\P{^	In_high_PU_Surrogates}', "");
    Error('\p{	:=high_surrogates}');
    Error('\P{	:=high_surrogates}');
    Expect(1, 56191, '\p{highsurrogates}', "");
    Expect(0, 56191, '\p{^highsurrogates}', "");
    Expect(0, 56191, '\P{highsurrogates}', "");
    Expect(1, 56191, '\P{^highsurrogates}', "");
    Expect(0, 57344, '\p{highsurrogates}', "");
    Expect(1, 57344, '\p{^highsurrogates}', "");
    Expect(1, 57344, '\P{highsurrogates}', "");
    Expect(0, 57344, '\P{^highsurrogates}', "");
    Expect(1, 56191, '\p{-	high_SURROGATES}', "");
    Expect(0, 56191, '\p{^-	high_SURROGATES}', "");
    Expect(0, 56191, '\P{-	high_SURROGATES}', "");
    Expect(1, 56191, '\P{^-	high_SURROGATES}', "");
    Expect(0, 57344, '\p{-	high_SURROGATES}', "");
    Expect(1, 57344, '\p{^-	high_SURROGATES}', "");
    Expect(1, 57344, '\P{-	high_SURROGATES}', "");
    Expect(0, 57344, '\P{^-	high_SURROGATES}', "");
    Error('\p{-_IS_HIGH_Surrogates:=}');
    Error('\P{-_IS_HIGH_Surrogates:=}');
    Expect(1, 56191, '\p{ishighsurrogates}', "");
    Expect(0, 56191, '\p{^ishighsurrogates}', "");
    Expect(0, 56191, '\P{ishighsurrogates}', "");
    Expect(1, 56191, '\P{^ishighsurrogates}', "");
    Expect(0, 57344, '\p{ishighsurrogates}', "");
    Expect(1, 57344, '\p{^ishighsurrogates}', "");
    Expect(1, 57344, '\P{ishighsurrogates}', "");
    Expect(0, 57344, '\P{^ishighsurrogates}', "");
    Expect(1, 56191, '\p{--is_High_Surrogates}', "");
    Expect(0, 56191, '\p{^--is_High_Surrogates}', "");
    Expect(0, 56191, '\P{--is_High_Surrogates}', "");
    Expect(1, 56191, '\P{^--is_High_Surrogates}', "");
    Expect(0, 57344, '\p{--is_High_Surrogates}', "");
    Expect(1, 57344, '\p{^--is_High_Surrogates}', "");
    Expect(1, 57344, '\P{--is_High_Surrogates}', "");
    Expect(0, 57344, '\P{^--is_High_Surrogates}', "");
    Error('\p{/a/In_HIGH_Surrogates}');
    Error('\P{/a/In_HIGH_Surrogates}');
    Expect(1, 56191, '\p{inhighsurrogates}', "");
    Expect(0, 56191, '\p{^inhighsurrogates}', "");
    Expect(0, 56191, '\P{inhighsurrogates}', "");
    Expect(1, 56191, '\P{^inhighsurrogates}', "");
    Expect(0, 57344, '\p{inhighsurrogates}', "");
    Expect(1, 57344, '\p{^inhighsurrogates}', "");
    Expect(1, 57344, '\P{inhighsurrogates}', "");
    Expect(0, 57344, '\P{^inhighsurrogates}', "");
    Expect(1, 56191, '\p{-_in_high_Surrogates}', "");
    Expect(0, 56191, '\p{^-_in_high_Surrogates}', "");
    Expect(0, 56191, '\P{-_in_high_Surrogates}', "");
    Expect(1, 56191, '\P{^-_in_high_Surrogates}', "");
    Expect(0, 57344, '\p{-_in_high_Surrogates}', "");
    Expect(1, 57344, '\p{^-_in_high_Surrogates}', "");
    Expect(1, 57344, '\P{-_in_high_Surrogates}', "");
    Expect(0, 57344, '\P{^-_in_high_Surrogates}', "");
    Error('\p{	 Hiragana:=}');
    Error('\P{	 Hiragana:=}');
    Expect(1, 127488, '\p{hiragana}', "");
    Expect(0, 127488, '\p{^hiragana}', "");
    Expect(0, 127488, '\P{hiragana}', "");
    Expect(1, 127488, '\P{^hiragana}', "");
    Expect(0, 127489, '\p{hiragana}', "");
    Expect(1, 127489, '\p{^hiragana}', "");
    Expect(1, 127489, '\P{hiragana}', "");
    Expect(0, 127489, '\P{^hiragana}', "");
    Expect(1, 127488, '\p{ 	HIRAGANA}', "");
    Expect(0, 127488, '\p{^ 	HIRAGANA}', "");
    Expect(0, 127488, '\P{ 	HIRAGANA}', "");
    Expect(1, 127488, '\P{^ 	HIRAGANA}', "");
    Expect(0, 127489, '\p{ 	HIRAGANA}', "");
    Expect(1, 127489, '\p{^ 	HIRAGANA}', "");
    Expect(1, 127489, '\P{ 	HIRAGANA}', "");
    Expect(0, 127489, '\P{^ 	HIRAGANA}', "");
    Error('\p{ :=is_HIRAGANA}');
    Error('\P{ :=is_HIRAGANA}');
    Expect(1, 127488, '\p{ishiragana}', "");
    Expect(0, 127488, '\p{^ishiragana}', "");
    Expect(0, 127488, '\P{ishiragana}', "");
    Expect(1, 127488, '\P{^ishiragana}', "");
    Expect(0, 127489, '\p{ishiragana}', "");
    Expect(1, 127489, '\p{^ishiragana}', "");
    Expect(1, 127489, '\P{ishiragana}', "");
    Expect(0, 127489, '\P{^ishiragana}', "");
    Expect(1, 127488, '\p{Is_Hiragana}', "");
    Expect(0, 127488, '\p{^Is_Hiragana}', "");
    Expect(0, 127488, '\P{Is_Hiragana}', "");
    Expect(1, 127488, '\P{^Is_Hiragana}', "");
    Expect(0, 127489, '\p{Is_Hiragana}', "");
    Expect(1, 127489, '\p{^Is_Hiragana}', "");
    Expect(1, 127489, '\P{Is_Hiragana}', "");
    Expect(0, 127489, '\P{^Is_Hiragana}', "");
    Error('\p{:=_	hira}');
    Error('\P{:=_	hira}');
    Expect(1, 127488, '\p{hira}', "");
    Expect(0, 127488, '\p{^hira}', "");
    Expect(0, 127488, '\P{hira}', "");
    Expect(1, 127488, '\P{^hira}', "");
    Expect(0, 127489, '\p{hira}', "");
    Expect(1, 127489, '\p{^hira}', "");
    Expect(1, 127489, '\P{hira}', "");
    Expect(0, 127489, '\P{^hira}', "");
    Expect(1, 127488, '\p{	Hira}', "");
    Expect(0, 127488, '\p{^	Hira}', "");
    Expect(0, 127488, '\P{	Hira}', "");
    Expect(1, 127488, '\P{^	Hira}', "");
    Expect(0, 127489, '\p{	Hira}', "");
    Expect(1, 127489, '\p{^	Hira}', "");
    Expect(1, 127489, '\P{	Hira}', "");
    Expect(0, 127489, '\P{^	Hira}', "");
    Error('\p{- is_Hira:=}');
    Error('\P{- is_Hira:=}');
    Expect(1, 127488, '\p{ishira}', "");
    Expect(0, 127488, '\p{^ishira}', "");
    Expect(0, 127488, '\P{ishira}', "");
    Expect(1, 127488, '\P{^ishira}', "");
    Expect(0, 127489, '\p{ishira}', "");
    Expect(1, 127489, '\p{^ishira}', "");
    Expect(1, 127489, '\P{ishira}', "");
    Expect(0, 127489, '\P{^ishira}', "");
    Expect(1, 127488, '\p{_Is_Hira}', "");
    Expect(0, 127488, '\p{^_Is_Hira}', "");
    Expect(0, 127488, '\P{_Is_Hira}', "");
    Expect(1, 127488, '\P{^_Is_Hira}', "");
    Expect(0, 127489, '\p{_Is_Hira}', "");
    Expect(1, 127489, '\p{^_Is_Hira}', "");
    Expect(1, 127489, '\P{_Is_Hira}', "");
    Expect(0, 127489, '\P{^_Is_Hira}', "");
    Error('\p{	/a/HYPHEN}');
    Error('\P{	/a/HYPHEN}');
    Expect(1, 65381, '\p{hyphen}', 'deprecated');
    Expect(0, 65381, '\p{^hyphen}', 'deprecated');
    Expect(0, 65381, '\P{hyphen}', 'deprecated');
    Expect(1, 65381, '\P{^hyphen}', 'deprecated');
    Expect(0, 65382, '\p{hyphen}', 'deprecated');
    Expect(1, 65382, '\p{^hyphen}', 'deprecated');
    Expect(1, 65382, '\P{hyphen}', 'deprecated');
    Expect(0, 65382, '\P{^hyphen}', 'deprecated');
    Expect(1, 65381, '\p{_ Hyphen}', 'deprecated');
    Expect(0, 65381, '\p{^_ Hyphen}', 'deprecated');
    Expect(0, 65381, '\P{_ Hyphen}', 'deprecated');
    Expect(1, 65381, '\P{^_ Hyphen}', 'deprecated');
    Expect(0, 65382, '\p{_ Hyphen}', 'deprecated');
    Expect(1, 65382, '\p{^_ Hyphen}', 'deprecated');
    Expect(1, 65382, '\P{_ Hyphen}', 'deprecated');
    Expect(0, 65382, '\P{^_ Hyphen}', 'deprecated');
    Error('\p{:=IS_hyphen}');
    Error('\P{:=IS_hyphen}');
    Expect(1, 65381, '\p{ishyphen}', 'deprecated');
    Expect(0, 65381, '\p{^ishyphen}', 'deprecated');
    Expect(0, 65381, '\P{ishyphen}', 'deprecated');
    Expect(1, 65381, '\P{^ishyphen}', 'deprecated');
    Expect(0, 65382, '\p{ishyphen}', 'deprecated');
    Expect(1, 65382, '\p{^ishyphen}', 'deprecated');
    Expect(1, 65382, '\P{ishyphen}', 'deprecated');
    Expect(0, 65382, '\P{^ishyphen}', 'deprecated');
    Expect(1, 65381, '\p{	_IS_Hyphen}', 'deprecated');
    Expect(0, 65381, '\p{^	_IS_Hyphen}', 'deprecated');
    Expect(0, 65381, '\P{	_IS_Hyphen}', 'deprecated');
    Expect(1, 65381, '\P{^	_IS_Hyphen}', 'deprecated');
    Expect(0, 65382, '\p{	_IS_Hyphen}', 'deprecated');
    Expect(1, 65382, '\p{^	_IS_Hyphen}', 'deprecated');
    Expect(1, 65382, '\P{	_IS_Hyphen}', 'deprecated');
    Expect(0, 65382, '\P{^	_IS_Hyphen}', 'deprecated');
    Error('\p{	:=ID_Continue}');
    Error('\P{	:=ID_Continue}');
    Expect(1, 917999, '\p{idcontinue}', "");
    Expect(0, 917999, '\p{^idcontinue}', "");
    Expect(0, 917999, '\P{idcontinue}', "");
    Expect(1, 917999, '\P{^idcontinue}', "");
    Expect(0, 918000, '\p{idcontinue}', "");
    Expect(1, 918000, '\p{^idcontinue}', "");
    Expect(1, 918000, '\P{idcontinue}', "");
    Expect(0, 918000, '\P{^idcontinue}', "");
    Expect(1, 917999, '\p{	-ID_CONTINUE}', "");
    Expect(0, 917999, '\p{^	-ID_CONTINUE}', "");
    Expect(0, 917999, '\P{	-ID_CONTINUE}', "");
    Expect(1, 917999, '\P{^	-ID_CONTINUE}', "");
    Expect(0, 918000, '\p{	-ID_CONTINUE}', "");
    Expect(1, 918000, '\p{^	-ID_CONTINUE}', "");
    Expect(1, 918000, '\P{	-ID_CONTINUE}', "");
    Expect(0, 918000, '\P{^	-ID_CONTINUE}', "");
    Error('\p{ /a/Is_ID_Continue}');
    Error('\P{ /a/Is_ID_Continue}');
    Expect(1, 917999, '\p{isidcontinue}', "");
    Expect(0, 917999, '\p{^isidcontinue}', "");
    Expect(0, 917999, '\P{isidcontinue}', "");
    Expect(1, 917999, '\P{^isidcontinue}', "");
    Expect(0, 918000, '\p{isidcontinue}', "");
    Expect(1, 918000, '\p{^isidcontinue}', "");
    Expect(1, 918000, '\P{isidcontinue}', "");
    Expect(0, 918000, '\P{^isidcontinue}', "");
    Expect(1, 917999, '\p{	 Is_ID_Continue}', "");
    Expect(0, 917999, '\p{^	 Is_ID_Continue}', "");
    Expect(0, 917999, '\P{	 Is_ID_Continue}', "");
    Expect(1, 917999, '\P{^	 Is_ID_Continue}', "");
    Expect(0, 918000, '\p{	 Is_ID_Continue}', "");
    Expect(1, 918000, '\p{^	 Is_ID_Continue}', "");
    Expect(1, 918000, '\P{	 Is_ID_Continue}', "");
    Expect(0, 918000, '\P{^	 Is_ID_Continue}', "");
    Error('\p{/a/ _idc}');
    Error('\P{/a/ _idc}');
    Expect(1, 917999, '\p{idc}', "");
    Expect(0, 917999, '\p{^idc}', "");
    Expect(0, 917999, '\P{idc}', "");
    Expect(1, 917999, '\P{^idc}', "");
    Expect(0, 918000, '\p{idc}', "");
    Expect(1, 918000, '\p{^idc}', "");
    Expect(1, 918000, '\P{idc}', "");
    Expect(0, 918000, '\P{^idc}', "");
    Expect(1, 917999, '\p{ IDC}', "");
    Expect(0, 917999, '\p{^ IDC}', "");
    Expect(0, 917999, '\P{ IDC}', "");
    Expect(1, 917999, '\P{^ IDC}', "");
    Expect(0, 918000, '\p{ IDC}', "");
    Expect(1, 918000, '\p{^ IDC}', "");
    Expect(1, 918000, '\P{ IDC}', "");
    Expect(0, 918000, '\P{^ IDC}', "");
    Error('\p{:=- is_IDC}');
    Error('\P{:=- is_IDC}');
    Expect(1, 917999, '\p{isidc}', "");
    Expect(0, 917999, '\p{^isidc}', "");
    Expect(0, 917999, '\P{isidc}', "");
    Expect(1, 917999, '\P{^isidc}', "");
    Expect(0, 918000, '\p{isidc}', "");
    Expect(1, 918000, '\p{^isidc}', "");
    Expect(1, 918000, '\P{isidc}', "");
    Expect(0, 918000, '\P{^isidc}', "");
    Expect(1, 917999, '\p{		Is_IDC}', "");
    Expect(0, 917999, '\p{^		Is_IDC}', "");
    Expect(0, 917999, '\P{		Is_IDC}', "");
    Expect(1, 917999, '\P{^		Is_IDC}', "");
    Expect(0, 918000, '\p{		Is_IDC}', "");
    Expect(1, 918000, '\p{^		Is_IDC}', "");
    Expect(1, 918000, '\P{		Is_IDC}', "");
    Expect(0, 918000, '\P{^		Is_IDC}', "");
    Error('\p{	_ID_START:=}');
    Error('\P{	_ID_START:=}');
    Expect(1, 205743, '\p{idstart}', "");
    Expect(0, 205743, '\p{^idstart}', "");
    Expect(0, 205743, '\P{idstart}', "");
    Expect(1, 205743, '\P{^idstart}', "");
    Expect(0, 205744, '\p{idstart}', "");
    Expect(1, 205744, '\p{^idstart}', "");
    Expect(1, 205744, '\P{idstart}', "");
    Expect(0, 205744, '\P{^idstart}', "");
    Expect(1, 205743, '\p{ID_Start}', "");
    Expect(0, 205743, '\p{^ID_Start}', "");
    Expect(0, 205743, '\P{ID_Start}', "");
    Expect(1, 205743, '\P{^ID_Start}', "");
    Expect(0, 205744, '\p{ID_Start}', "");
    Expect(1, 205744, '\p{^ID_Start}', "");
    Expect(1, 205744, '\P{ID_Start}', "");
    Expect(0, 205744, '\P{^ID_Start}', "");
    Error('\p{	-is_ID_Start/a/}');
    Error('\P{	-is_ID_Start/a/}');
    Expect(1, 205743, '\p{isidstart}', "");
    Expect(0, 205743, '\p{^isidstart}', "");
    Expect(0, 205743, '\P{isidstart}', "");
    Expect(1, 205743, '\P{^isidstart}', "");
    Expect(0, 205744, '\p{isidstart}', "");
    Expect(1, 205744, '\p{^isidstart}', "");
    Expect(1, 205744, '\P{isidstart}', "");
    Expect(0, 205744, '\P{^isidstart}', "");
    Expect(1, 205743, '\p{_	IS_ID_start}', "");
    Expect(0, 205743, '\p{^_	IS_ID_start}', "");
    Expect(0, 205743, '\P{_	IS_ID_start}', "");
    Expect(1, 205743, '\P{^_	IS_ID_start}', "");
    Expect(0, 205744, '\p{_	IS_ID_start}', "");
    Expect(1, 205744, '\p{^_	IS_ID_start}', "");
    Expect(1, 205744, '\P{_	IS_ID_start}', "");
    Expect(0, 205744, '\P{^_	IS_ID_start}', "");
    Error('\p{/a/ 	IDS}');
    Error('\P{/a/ 	IDS}');
    Expect(1, 205743, '\p{ids}', "");
    Expect(0, 205743, '\p{^ids}', "");
    Expect(0, 205743, '\P{ids}', "");
    Expect(1, 205743, '\P{^ids}', "");
    Expect(0, 205744, '\p{ids}', "");
    Expect(1, 205744, '\p{^ids}', "");
    Expect(1, 205744, '\P{ids}', "");
    Expect(0, 205744, '\P{^ids}', "");
    Expect(1, 205743, '\p{- IDS}', "");
    Expect(0, 205743, '\p{^- IDS}', "");
    Expect(0, 205743, '\P{- IDS}', "");
    Expect(1, 205743, '\P{^- IDS}', "");
    Expect(0, 205744, '\p{- IDS}', "");
    Expect(1, 205744, '\p{^- IDS}', "");
    Expect(1, 205744, '\P{- IDS}', "");
    Expect(0, 205744, '\P{^- IDS}', "");
    Error('\p{ -is_ids:=}');
    Error('\P{ -is_ids:=}');
    Expect(1, 205743, '\p{isids}', "");
    Expect(0, 205743, '\p{^isids}', "");
    Expect(0, 205743, '\P{isids}', "");
    Expect(1, 205743, '\P{^isids}', "");
    Expect(0, 205744, '\p{isids}', "");
    Expect(1, 205744, '\p{^isids}', "");
    Expect(1, 205744, '\P{isids}', "");
    Expect(0, 205744, '\P{^isids}', "");
    Expect(1, 205743, '\p{ _is_IDS}', "");
    Expect(0, 205743, '\p{^ _is_IDS}', "");
    Expect(0, 205743, '\P{ _is_IDS}', "");
    Expect(1, 205743, '\P{^ _is_IDS}', "");
    Expect(0, 205744, '\p{ _is_IDS}', "");
    Expect(1, 205744, '\p{^ _is_IDS}', "");
    Expect(1, 205744, '\P{ _is_IDS}', "");
    Expect(0, 205744, '\P{^ _is_IDS}', "");
    Error('\p{_	Ideographic:=}');
    Error('\P{_	Ideographic:=}');
    Expect(1, 205743, '\p{ideographic}', "");
    Expect(0, 205743, '\p{^ideographic}', "");
    Expect(0, 205743, '\P{ideographic}', "");
    Expect(1, 205743, '\P{^ideographic}', "");
    Expect(0, 205744, '\p{ideographic}', "");
    Expect(1, 205744, '\p{^ideographic}', "");
    Expect(1, 205744, '\P{ideographic}', "");
    Expect(0, 205744, '\P{^ideographic}', "");
    Expect(1, 205743, '\p{IDEOGRAPHIC}', "");
    Expect(0, 205743, '\p{^IDEOGRAPHIC}', "");
    Expect(0, 205743, '\P{IDEOGRAPHIC}', "");
    Expect(1, 205743, '\P{^IDEOGRAPHIC}', "");
    Expect(0, 205744, '\p{IDEOGRAPHIC}', "");
    Expect(1, 205744, '\p{^IDEOGRAPHIC}', "");
    Expect(1, 205744, '\P{IDEOGRAPHIC}', "");
    Expect(0, 205744, '\P{^IDEOGRAPHIC}', "");
    Error('\p{_	Is_Ideographic/a/}');
    Error('\P{_	Is_Ideographic/a/}');
    Expect(1, 205743, '\p{isideographic}', "");
    Expect(0, 205743, '\p{^isideographic}', "");
    Expect(0, 205743, '\P{isideographic}', "");
    Expect(1, 205743, '\P{^isideographic}', "");
    Expect(0, 205744, '\p{isideographic}', "");
    Expect(1, 205744, '\p{^isideographic}', "");
    Expect(1, 205744, '\P{isideographic}', "");
    Expect(0, 205744, '\P{^isideographic}', "");
    Expect(1, 205743, '\p{	IS_IDEOGRAPHIC}', "");
    Expect(0, 205743, '\p{^	IS_IDEOGRAPHIC}', "");
    Expect(0, 205743, '\P{	IS_IDEOGRAPHIC}', "");
    Expect(1, 205743, '\P{^	IS_IDEOGRAPHIC}', "");
    Expect(0, 205744, '\p{	IS_IDEOGRAPHIC}', "");
    Expect(1, 205744, '\p{^	IS_IDEOGRAPHIC}', "");
    Expect(1, 205744, '\P{	IS_IDEOGRAPHIC}', "");
    Expect(0, 205744, '\P{^	IS_IDEOGRAPHIC}', "");
    Error('\p{/a/IDEO}');
    Error('\P{/a/IDEO}');
    Expect(1, 205743, '\p{ideo}', "");
    Expect(0, 205743, '\p{^ideo}', "");
    Expect(0, 205743, '\P{ideo}', "");
    Expect(1, 205743, '\P{^ideo}', "");
    Expect(0, 205744, '\p{ideo}', "");
    Expect(1, 205744, '\p{^ideo}', "");
    Expect(1, 205744, '\P{ideo}', "");
    Expect(0, 205744, '\P{^ideo}', "");
    Expect(1, 205743, '\p{		Ideo}', "");
    Expect(0, 205743, '\p{^		Ideo}', "");
    Expect(0, 205743, '\P{		Ideo}', "");
    Expect(1, 205743, '\P{^		Ideo}', "");
    Expect(0, 205744, '\p{		Ideo}', "");
    Expect(1, 205744, '\p{^		Ideo}', "");
    Expect(1, 205744, '\P{		Ideo}', "");
    Expect(0, 205744, '\P{^		Ideo}', "");
    Error('\p{-/a/Is_IDEO}');
    Error('\P{-/a/Is_IDEO}');
    Expect(1, 205743, '\p{isideo}', "");
    Expect(0, 205743, '\p{^isideo}', "");
    Expect(0, 205743, '\P{isideo}', "");
    Expect(1, 205743, '\P{^isideo}', "");
    Expect(0, 205744, '\p{isideo}', "");
    Expect(1, 205744, '\p{^isideo}', "");
    Expect(1, 205744, '\P{isideo}', "");
    Expect(0, 205744, '\P{^isideo}', "");
    Expect(1, 205743, '\p{ 	IS_Ideo}', "");
    Expect(0, 205743, '\p{^ 	IS_Ideo}', "");
    Expect(0, 205743, '\P{ 	IS_Ideo}', "");
    Expect(1, 205743, '\P{^ 	IS_Ideo}', "");
    Expect(0, 205744, '\p{ 	IS_Ideo}', "");
    Expect(1, 205744, '\p{^ 	IS_Ideo}', "");
    Expect(1, 205744, '\P{ 	IS_Ideo}', "");
    Expect(0, 205744, '\P{^ 	IS_Ideo}', "");
    Error('\p{ _Ideographic_Description_characters:=}');
    Error('\P{ _Ideographic_Description_characters:=}');
    Expect(1, 12287, '\p{ideographicdescriptioncharacters}', "");
    Expect(0, 12287, '\p{^ideographicdescriptioncharacters}', "");
    Expect(0, 12287, '\P{ideographicdescriptioncharacters}', "");
    Expect(1, 12287, '\P{^ideographicdescriptioncharacters}', "");
    Expect(0, 12288, '\p{ideographicdescriptioncharacters}', "");
    Expect(1, 12288, '\p{^ideographicdescriptioncharacters}', "");
    Expect(1, 12288, '\P{ideographicdescriptioncharacters}', "");
    Expect(0, 12288, '\P{^ideographicdescriptioncharacters}', "");
    Expect(1, 12287, '\p{	Ideographic_Description_Characters}', "");
    Expect(0, 12287, '\p{^	Ideographic_Description_Characters}', "");
    Expect(0, 12287, '\P{	Ideographic_Description_Characters}', "");
    Expect(1, 12287, '\P{^	Ideographic_Description_Characters}', "");
    Expect(0, 12288, '\p{	Ideographic_Description_Characters}', "");
    Expect(1, 12288, '\p{^	Ideographic_Description_Characters}', "");
    Expect(1, 12288, '\P{	Ideographic_Description_Characters}', "");
    Expect(0, 12288, '\P{^	Ideographic_Description_Characters}', "");
    Error('\p{-:=IS_Ideographic_Description_characters}');
    Error('\P{-:=IS_Ideographic_Description_characters}');
    Expect(1, 12287, '\p{isideographicdescriptioncharacters}', "");
    Expect(0, 12287, '\p{^isideographicdescriptioncharacters}', "");
    Expect(0, 12287, '\P{isideographicdescriptioncharacters}', "");
    Expect(1, 12287, '\P{^isideographicdescriptioncharacters}', "");
    Expect(0, 12288, '\p{isideographicdescriptioncharacters}', "");
    Expect(1, 12288, '\p{^isideographicdescriptioncharacters}', "");
    Expect(1, 12288, '\P{isideographicdescriptioncharacters}', "");
    Expect(0, 12288, '\P{^isideographicdescriptioncharacters}', "");
    Expect(1, 12287, '\p{	 IS_Ideographic_description_CHARACTERS}', "");
    Expect(0, 12287, '\p{^	 IS_Ideographic_description_CHARACTERS}', "");
    Expect(0, 12287, '\P{	 IS_Ideographic_description_CHARACTERS}', "");
    Expect(1, 12287, '\P{^	 IS_Ideographic_description_CHARACTERS}', "");
    Expect(0, 12288, '\p{	 IS_Ideographic_description_CHARACTERS}', "");
    Expect(1, 12288, '\p{^	 IS_Ideographic_description_CHARACTERS}', "");
    Expect(1, 12288, '\P{	 IS_Ideographic_description_CHARACTERS}', "");
    Expect(0, 12288, '\P{^	 IS_Ideographic_description_CHARACTERS}', "");
    Error('\p{	:=IN_Ideographic_Description_characters}');
    Error('\P{	:=IN_Ideographic_Description_characters}');
    Expect(1, 12287, '\p{inideographicdescriptioncharacters}', "");
    Expect(0, 12287, '\p{^inideographicdescriptioncharacters}', "");
    Expect(0, 12287, '\P{inideographicdescriptioncharacters}', "");
    Expect(1, 12287, '\P{^inideographicdescriptioncharacters}', "");
    Expect(0, 12288, '\p{inideographicdescriptioncharacters}', "");
    Expect(1, 12288, '\p{^inideographicdescriptioncharacters}', "");
    Expect(1, 12288, '\P{inideographicdescriptioncharacters}', "");
    Expect(0, 12288, '\P{^inideographicdescriptioncharacters}', "");
    Expect(1, 12287, '\p{_-In_ideographic_Description_characters}', "");
    Expect(0, 12287, '\p{^_-In_ideographic_Description_characters}', "");
    Expect(0, 12287, '\P{_-In_ideographic_Description_characters}', "");
    Expect(1, 12287, '\P{^_-In_ideographic_Description_characters}', "");
    Expect(0, 12288, '\p{_-In_ideographic_Description_characters}', "");
    Expect(1, 12288, '\p{^_-In_ideographic_Description_characters}', "");
    Expect(1, 12288, '\P{_-In_ideographic_Description_characters}', "");
    Expect(0, 12288, '\P{^_-In_ideographic_Description_characters}', "");
    Error('\p{_-in_idc:=}');
    Error('\P{_-in_idc:=}');
    Expect(1, 12287, '\p{inidc}', "");
    Expect(0, 12287, '\p{^inidc}', "");
    Expect(0, 12287, '\P{inidc}', "");
    Expect(1, 12287, '\P{^inidc}', "");
    Expect(0, 12288, '\p{inidc}', "");
    Expect(1, 12288, '\p{^inidc}', "");
    Expect(1, 12288, '\P{inidc}', "");
    Expect(0, 12288, '\P{^inidc}', "");
    Expect(1, 12287, '\p{_ In_idc}', "");
    Expect(0, 12287, '\p{^_ In_idc}', "");
    Expect(0, 12287, '\P{_ In_idc}', "");
    Expect(1, 12287, '\P{^_ In_idc}', "");
    Expect(0, 12288, '\p{_ In_idc}', "");
    Expect(1, 12288, '\p{^_ In_idc}', "");
    Expect(1, 12288, '\P{_ In_idc}', "");
    Expect(0, 12288, '\P{^_ In_idc}', "");
    Error('\p{:=IDEOGRAPHIC_SYMBOLS_and_Punctuation}');
    Error('\P{:=IDEOGRAPHIC_SYMBOLS_and_Punctuation}');
    Expect(1, 94207, '\p{ideographicsymbolsandpunctuation}', "");
    Expect(0, 94207, '\p{^ideographicsymbolsandpunctuation}', "");
    Expect(0, 94207, '\P{ideographicsymbolsandpunctuation}', "");
    Expect(1, 94207, '\P{^ideographicsymbolsandpunctuation}', "");
    Expect(0, 94208, '\p{ideographicsymbolsandpunctuation}', "");
    Expect(1, 94208, '\p{^ideographicsymbolsandpunctuation}', "");
    Expect(1, 94208, '\P{ideographicsymbolsandpunctuation}', "");
    Expect(0, 94208, '\P{^ideographicsymbolsandpunctuation}', "");
    Expect(1, 94207, '\p{ ideographic_Symbols_And_Punctuation}', "");
    Expect(0, 94207, '\p{^ ideographic_Symbols_And_Punctuation}', "");
    Expect(0, 94207, '\P{ ideographic_Symbols_And_Punctuation}', "");
    Expect(1, 94207, '\P{^ ideographic_Symbols_And_Punctuation}', "");
    Expect(0, 94208, '\p{ ideographic_Symbols_And_Punctuation}', "");
    Expect(1, 94208, '\p{^ ideographic_Symbols_And_Punctuation}', "");
    Expect(1, 94208, '\P{ ideographic_Symbols_And_Punctuation}', "");
    Expect(0, 94208, '\P{^ ideographic_Symbols_And_Punctuation}', "");
    Error('\p{_IS_ideographic_Symbols_And_Punctuation:=}');
    Error('\P{_IS_ideographic_Symbols_And_Punctuation:=}');
    Expect(1, 94207, '\p{isideographicsymbolsandpunctuation}', "");
    Expect(0, 94207, '\p{^isideographicsymbolsandpunctuation}', "");
    Expect(0, 94207, '\P{isideographicsymbolsandpunctuation}', "");
    Expect(1, 94207, '\P{^isideographicsymbolsandpunctuation}', "");
    Expect(0, 94208, '\p{isideographicsymbolsandpunctuation}', "");
    Expect(1, 94208, '\p{^isideographicsymbolsandpunctuation}', "");
    Expect(1, 94208, '\P{isideographicsymbolsandpunctuation}', "");
    Expect(0, 94208, '\P{^isideographicsymbolsandpunctuation}', "");
    Expect(1, 94207, '\p{ is_Ideographic_SYMBOLS_And_punctuation}', "");
    Expect(0, 94207, '\p{^ is_Ideographic_SYMBOLS_And_punctuation}', "");
    Expect(0, 94207, '\P{ is_Ideographic_SYMBOLS_And_punctuation}', "");
    Expect(1, 94207, '\P{^ is_Ideographic_SYMBOLS_And_punctuation}', "");
    Expect(0, 94208, '\p{ is_Ideographic_SYMBOLS_And_punctuation}', "");
    Expect(1, 94208, '\p{^ is_Ideographic_SYMBOLS_And_punctuation}', "");
    Expect(1, 94208, '\P{ is_Ideographic_SYMBOLS_And_punctuation}', "");
    Expect(0, 94208, '\P{^ is_Ideographic_SYMBOLS_And_punctuation}', "");
    Error('\p{:= IN_Ideographic_SYMBOLS_AND_PUNCTUATION}');
    Error('\P{:= IN_Ideographic_SYMBOLS_AND_PUNCTUATION}');
    Expect(1, 94207, '\p{inideographicsymbolsandpunctuation}', "");
    Expect(0, 94207, '\p{^inideographicsymbolsandpunctuation}', "");
    Expect(0, 94207, '\P{inideographicsymbolsandpunctuation}', "");
    Expect(1, 94207, '\P{^inideographicsymbolsandpunctuation}', "");
    Expect(0, 94208, '\p{inideographicsymbolsandpunctuation}', "");
    Expect(1, 94208, '\p{^inideographicsymbolsandpunctuation}', "");
    Expect(1, 94208, '\P{inideographicsymbolsandpunctuation}', "");
    Expect(0, 94208, '\P{^inideographicsymbolsandpunctuation}', "");
    Expect(1, 94207, '\p{-	In_ideographic_Symbols_And_PUNCTUATION}', "");
    Expect(0, 94207, '\p{^-	In_ideographic_Symbols_And_PUNCTUATION}', "");
    Expect(0, 94207, '\P{-	In_ideographic_Symbols_And_PUNCTUATION}', "");
    Expect(1, 94207, '\P{^-	In_ideographic_Symbols_And_PUNCTUATION}', "");
    Expect(0, 94208, '\p{-	In_ideographic_Symbols_And_PUNCTUATION}', "");
    Expect(1, 94208, '\p{^-	In_ideographic_Symbols_And_PUNCTUATION}', "");
    Expect(1, 94208, '\P{-	In_ideographic_Symbols_And_PUNCTUATION}', "");
    Expect(0, 94208, '\P{^-	In_ideographic_Symbols_And_PUNCTUATION}', "");
    Error('\p{__Ideographic_Symbols:=}');
    Error('\P{__Ideographic_Symbols:=}');
    Expect(1, 94207, '\p{ideographicsymbols}', "");
    Expect(0, 94207, '\p{^ideographicsymbols}', "");
    Expect(0, 94207, '\P{ideographicsymbols}', "");
    Expect(1, 94207, '\P{^ideographicsymbols}', "");
    Expect(0, 94208, '\p{ideographicsymbols}', "");
    Expect(1, 94208, '\p{^ideographicsymbols}', "");
    Expect(1, 94208, '\P{ideographicsymbols}', "");
    Expect(0, 94208, '\P{^ideographicsymbols}', "");
    Expect(1, 94207, '\p{ 	Ideographic_SYMBOLS}', "");
    Expect(0, 94207, '\p{^ 	Ideographic_SYMBOLS}', "");
    Expect(0, 94207, '\P{ 	Ideographic_SYMBOLS}', "");
    Expect(1, 94207, '\P{^ 	Ideographic_SYMBOLS}', "");
    Expect(0, 94208, '\p{ 	Ideographic_SYMBOLS}', "");
    Expect(1, 94208, '\p{^ 	Ideographic_SYMBOLS}', "");
    Expect(1, 94208, '\P{ 	Ideographic_SYMBOLS}', "");
    Expect(0, 94208, '\P{^ 	Ideographic_SYMBOLS}', "");
    Error('\p{ _Is_ideographic_symbols:=}');
    Error('\P{ _Is_ideographic_symbols:=}');
    Expect(1, 94207, '\p{isideographicsymbols}', "");
    Expect(0, 94207, '\p{^isideographicsymbols}', "");
    Expect(0, 94207, '\P{isideographicsymbols}', "");
    Expect(1, 94207, '\P{^isideographicsymbols}', "");
    Expect(0, 94208, '\p{isideographicsymbols}', "");
    Expect(1, 94208, '\p{^isideographicsymbols}', "");
    Expect(1, 94208, '\P{isideographicsymbols}', "");
    Expect(0, 94208, '\P{^isideographicsymbols}', "");
    Expect(1, 94207, '\p{_	Is_Ideographic_Symbols}', "");
    Expect(0, 94207, '\p{^_	Is_Ideographic_Symbols}', "");
    Expect(0, 94207, '\P{_	Is_Ideographic_Symbols}', "");
    Expect(1, 94207, '\P{^_	Is_Ideographic_Symbols}', "");
    Expect(0, 94208, '\p{_	Is_Ideographic_Symbols}', "");
    Expect(1, 94208, '\p{^_	Is_Ideographic_Symbols}', "");
    Expect(1, 94208, '\P{_	Is_Ideographic_Symbols}', "");
    Expect(0, 94208, '\P{^_	Is_Ideographic_Symbols}', "");
    Error('\p{:=_ IN_Ideographic_Symbols}');
    Error('\P{:=_ IN_Ideographic_Symbols}');
    Expect(1, 94207, '\p{inideographicsymbols}', "");
    Expect(0, 94207, '\p{^inideographicsymbols}', "");
    Expect(0, 94207, '\P{inideographicsymbols}', "");
    Expect(1, 94207, '\P{^inideographicsymbols}', "");
    Expect(0, 94208, '\p{inideographicsymbols}', "");
    Expect(1, 94208, '\p{^inideographicsymbols}', "");
    Expect(1, 94208, '\P{inideographicsymbols}', "");
    Expect(0, 94208, '\P{^inideographicsymbols}', "");
    Expect(1, 94207, '\p{	in_ideographic_SYMBOLS}', "");
    Expect(0, 94207, '\p{^	in_ideographic_SYMBOLS}', "");
    Expect(0, 94207, '\P{	in_ideographic_SYMBOLS}', "");
    Expect(1, 94207, '\P{^	in_ideographic_SYMBOLS}', "");
    Expect(0, 94208, '\p{	in_ideographic_SYMBOLS}', "");
    Expect(1, 94208, '\p{^	in_ideographic_SYMBOLS}', "");
    Expect(1, 94208, '\P{	in_ideographic_SYMBOLS}', "");
    Expect(0, 94208, '\P{^	in_ideographic_SYMBOLS}', "");
    Error('\p{		IDS_Binary_Operator:=}');
    Error('\P{		IDS_Binary_Operator:=}');
    Expect(1, 12283, '\p{idsbinaryoperator}', "");
    Expect(0, 12283, '\p{^idsbinaryoperator}', "");
    Expect(0, 12283, '\P{idsbinaryoperator}', "");
    Expect(1, 12283, '\P{^idsbinaryoperator}', "");
    Expect(0, 12284, '\p{idsbinaryoperator}', "");
    Expect(1, 12284, '\p{^idsbinaryoperator}', "");
    Expect(1, 12284, '\P{idsbinaryoperator}', "");
    Expect(0, 12284, '\P{^idsbinaryoperator}', "");
    Expect(1, 12283, '\p{_IDS_Binary_OPERATOR}', "");
    Expect(0, 12283, '\p{^_IDS_Binary_OPERATOR}', "");
    Expect(0, 12283, '\P{_IDS_Binary_OPERATOR}', "");
    Expect(1, 12283, '\P{^_IDS_Binary_OPERATOR}', "");
    Expect(0, 12284, '\p{_IDS_Binary_OPERATOR}', "");
    Expect(1, 12284, '\p{^_IDS_Binary_OPERATOR}', "");
    Expect(1, 12284, '\P{_IDS_Binary_OPERATOR}', "");
    Expect(0, 12284, '\P{^_IDS_Binary_OPERATOR}', "");
    Error('\p{ -Is_IDS_Binary_operator/a/}');
    Error('\P{ -Is_IDS_Binary_operator/a/}');
    Expect(1, 12283, '\p{isidsbinaryoperator}', "");
    Expect(0, 12283, '\p{^isidsbinaryoperator}', "");
    Expect(0, 12283, '\P{isidsbinaryoperator}', "");
    Expect(1, 12283, '\P{^isidsbinaryoperator}', "");
    Expect(0, 12284, '\p{isidsbinaryoperator}', "");
    Expect(1, 12284, '\p{^isidsbinaryoperator}', "");
    Expect(1, 12284, '\P{isidsbinaryoperator}', "");
    Expect(0, 12284, '\P{^isidsbinaryoperator}', "");
    Expect(1, 12283, '\p{_ Is_IDS_Binary_Operator}', "");
    Expect(0, 12283, '\p{^_ Is_IDS_Binary_Operator}', "");
    Expect(0, 12283, '\P{_ Is_IDS_Binary_Operator}', "");
    Expect(1, 12283, '\P{^_ Is_IDS_Binary_Operator}', "");
    Expect(0, 12284, '\p{_ Is_IDS_Binary_Operator}', "");
    Expect(1, 12284, '\p{^_ Is_IDS_Binary_Operator}', "");
    Expect(1, 12284, '\P{_ Is_IDS_Binary_Operator}', "");
    Expect(0, 12284, '\P{^_ Is_IDS_Binary_Operator}', "");
    Error('\p{ /a/IDSB}');
    Error('\P{ /a/IDSB}');
    Expect(1, 12283, '\p{idsb}', "");
    Expect(0, 12283, '\p{^idsb}', "");
    Expect(0, 12283, '\P{idsb}', "");
    Expect(1, 12283, '\P{^idsb}', "");
    Expect(0, 12284, '\p{idsb}', "");
    Expect(1, 12284, '\p{^idsb}', "");
    Expect(1, 12284, '\P{idsb}', "");
    Expect(0, 12284, '\P{^idsb}', "");
    Expect(1, 12283, '\p{_IDSB}', "");
    Expect(0, 12283, '\p{^_IDSB}', "");
    Expect(0, 12283, '\P{_IDSB}', "");
    Expect(1, 12283, '\P{^_IDSB}', "");
    Expect(0, 12284, '\p{_IDSB}', "");
    Expect(1, 12284, '\p{^_IDSB}', "");
    Expect(1, 12284, '\P{_IDSB}', "");
    Expect(0, 12284, '\P{^_IDSB}', "");
    Error('\p{:=_	IS_idsb}');
    Error('\P{:=_	IS_idsb}');
    Expect(1, 12283, '\p{isidsb}', "");
    Expect(0, 12283, '\p{^isidsb}', "");
    Expect(0, 12283, '\P{isidsb}', "");
    Expect(1, 12283, '\P{^isidsb}', "");
    Expect(0, 12284, '\p{isidsb}', "");
    Expect(1, 12284, '\p{^isidsb}', "");
    Expect(1, 12284, '\P{isidsb}', "");
    Expect(0, 12284, '\P{^isidsb}', "");
    Expect(1, 12283, '\p{ _Is_IDSB}', "");
    Expect(0, 12283, '\p{^ _Is_IDSB}', "");
    Expect(0, 12283, '\P{ _Is_IDSB}', "");
    Expect(1, 12283, '\P{^ _Is_IDSB}', "");
    Expect(0, 12284, '\p{ _Is_IDSB}', "");
    Expect(1, 12284, '\p{^ _Is_IDSB}', "");
    Expect(1, 12284, '\P{ _Is_IDSB}', "");
    Expect(0, 12284, '\P{^ _Is_IDSB}', "");
    Error('\p{:=	_IDS_TRINARY_Operator}');
    Error('\P{:=	_IDS_TRINARY_Operator}');
    Expect(1, 12275, '\p{idstrinaryoperator}', "");
    Expect(0, 12275, '\p{^idstrinaryoperator}', "");
    Expect(0, 12275, '\P{idstrinaryoperator}', "");
    Expect(1, 12275, '\P{^idstrinaryoperator}', "");
    Expect(0, 12276, '\p{idstrinaryoperator}', "");
    Expect(1, 12276, '\p{^idstrinaryoperator}', "");
    Expect(1, 12276, '\P{idstrinaryoperator}', "");
    Expect(0, 12276, '\P{^idstrinaryoperator}', "");
    Expect(1, 12275, '\p{ 	IDS_trinary_OPERATOR}', "");
    Expect(0, 12275, '\p{^ 	IDS_trinary_OPERATOR}', "");
    Expect(0, 12275, '\P{ 	IDS_trinary_OPERATOR}', "");
    Expect(1, 12275, '\P{^ 	IDS_trinary_OPERATOR}', "");
    Expect(0, 12276, '\p{ 	IDS_trinary_OPERATOR}', "");
    Expect(1, 12276, '\p{^ 	IDS_trinary_OPERATOR}', "");
    Expect(1, 12276, '\P{ 	IDS_trinary_OPERATOR}', "");
    Expect(0, 12276, '\P{^ 	IDS_trinary_OPERATOR}', "");
    Error('\p{-/a/Is_ids_TRINARY_Operator}');
    Error('\P{-/a/Is_ids_TRINARY_Operator}');
    Expect(1, 12275, '\p{isidstrinaryoperator}', "");
    Expect(0, 12275, '\p{^isidstrinaryoperator}', "");
    Expect(0, 12275, '\P{isidstrinaryoperator}', "");
    Expect(1, 12275, '\P{^isidstrinaryoperator}', "");
    Expect(0, 12276, '\p{isidstrinaryoperator}', "");
    Expect(1, 12276, '\p{^isidstrinaryoperator}', "");
    Expect(1, 12276, '\P{isidstrinaryoperator}', "");
    Expect(0, 12276, '\P{^isidstrinaryoperator}', "");
    Expect(1, 12275, '\p{Is_IDS_Trinary_Operator}', "");
    Expect(0, 12275, '\p{^Is_IDS_Trinary_Operator}', "");
    Expect(0, 12275, '\P{Is_IDS_Trinary_Operator}', "");
    Expect(1, 12275, '\P{^Is_IDS_Trinary_Operator}', "");
    Expect(0, 12276, '\p{Is_IDS_Trinary_Operator}', "");
    Expect(1, 12276, '\p{^Is_IDS_Trinary_Operator}', "");
    Expect(1, 12276, '\P{Is_IDS_Trinary_Operator}', "");
    Expect(0, 12276, '\P{^Is_IDS_Trinary_Operator}', "");
    Error('\p{-_IDST:=}');
    Error('\P{-_IDST:=}');
    Expect(1, 12275, '\p{idst}', "");
    Expect(0, 12275, '\p{^idst}', "");
    Expect(0, 12275, '\P{idst}', "");
    Expect(1, 12275, '\P{^idst}', "");
    Expect(0, 12276, '\p{idst}', "");
    Expect(1, 12276, '\p{^idst}', "");
    Expect(1, 12276, '\P{idst}', "");
    Expect(0, 12276, '\P{^idst}', "");
    Expect(1, 12275, '\p{	IDST}', "");
    Expect(0, 12275, '\p{^	IDST}', "");
    Expect(0, 12275, '\P{	IDST}', "");
    Expect(1, 12275, '\P{^	IDST}', "");
    Expect(0, 12276, '\p{	IDST}', "");
    Expect(1, 12276, '\p{^	IDST}', "");
    Expect(1, 12276, '\P{	IDST}', "");
    Expect(0, 12276, '\P{^	IDST}', "");
    Error('\p{/a/-IS_IDST}');
    Error('\P{/a/-IS_IDST}');
    Expect(1, 12275, '\p{isidst}', "");
    Expect(0, 12275, '\p{^isidst}', "");
    Expect(0, 12275, '\P{isidst}', "");
    Expect(1, 12275, '\P{^isidst}', "");
    Expect(0, 12276, '\p{isidst}', "");
    Expect(1, 12276, '\p{^isidst}', "");
    Expect(1, 12276, '\P{isidst}', "");
    Expect(0, 12276, '\P{^isidst}', "");
    Expect(1, 12275, '\p{_ Is_IDST}', "");
    Expect(0, 12275, '\p{^_ Is_IDST}', "");
    Expect(0, 12275, '\P{_ Is_IDST}', "");
    Expect(1, 12275, '\P{^_ Is_IDST}', "");
    Expect(0, 12276, '\p{_ Is_IDST}', "");
    Expect(1, 12276, '\p{^_ Is_IDST}', "");
    Expect(1, 12276, '\P{_ Is_IDST}', "");
    Expect(0, 12276, '\P{^_ Is_IDST}', "");
    Error('\p{ -IMPERIAL_Aramaic/a/}');
    Error('\P{ -IMPERIAL_Aramaic/a/}');
    Expect(1, 67679, '\p{imperialaramaic}', "");
    Expect(0, 67679, '\p{^imperialaramaic}', "");
    Expect(0, 67679, '\P{imperialaramaic}', "");
    Expect(1, 67679, '\P{^imperialaramaic}', "");
    Expect(0, 67680, '\p{imperialaramaic}', "");
    Expect(1, 67680, '\p{^imperialaramaic}', "");
    Expect(1, 67680, '\P{imperialaramaic}', "");
    Expect(0, 67680, '\P{^imperialaramaic}', "");
    Expect(1, 67679, '\p{_IMPERIAL_Aramaic}', "");
    Expect(0, 67679, '\p{^_IMPERIAL_Aramaic}', "");
    Expect(0, 67679, '\P{_IMPERIAL_Aramaic}', "");
    Expect(1, 67679, '\P{^_IMPERIAL_Aramaic}', "");
    Expect(0, 67680, '\p{_IMPERIAL_Aramaic}', "");
    Expect(1, 67680, '\p{^_IMPERIAL_Aramaic}', "");
    Expect(1, 67680, '\P{_IMPERIAL_Aramaic}', "");
    Expect(0, 67680, '\P{^_IMPERIAL_Aramaic}', "");
    Error('\p{:=_Is_Imperial_aramaic}');
    Error('\P{:=_Is_Imperial_aramaic}');
    Expect(1, 67679, '\p{isimperialaramaic}', "");
    Expect(0, 67679, '\p{^isimperialaramaic}', "");
    Expect(0, 67679, '\P{isimperialaramaic}', "");
    Expect(1, 67679, '\P{^isimperialaramaic}', "");
    Expect(0, 67680, '\p{isimperialaramaic}', "");
    Expect(1, 67680, '\p{^isimperialaramaic}', "");
    Expect(1, 67680, '\P{isimperialaramaic}', "");
    Expect(0, 67680, '\P{^isimperialaramaic}', "");
    Expect(1, 67679, '\p{-Is_Imperial_ARAMAIC}', "");
    Expect(0, 67679, '\p{^-Is_Imperial_ARAMAIC}', "");
    Expect(0, 67679, '\P{-Is_Imperial_ARAMAIC}', "");
    Expect(1, 67679, '\P{^-Is_Imperial_ARAMAIC}', "");
    Expect(0, 67680, '\p{-Is_Imperial_ARAMAIC}', "");
    Expect(1, 67680, '\p{^-Is_Imperial_ARAMAIC}', "");
    Expect(1, 67680, '\P{-Is_Imperial_ARAMAIC}', "");
    Expect(0, 67680, '\P{^-Is_Imperial_ARAMAIC}', "");
    Error('\p{	-Armi/a/}');
    Error('\P{	-Armi/a/}');
    Expect(1, 67679, '\p{armi}', "");
    Expect(0, 67679, '\p{^armi}', "");
    Expect(0, 67679, '\P{armi}', "");
    Expect(1, 67679, '\P{^armi}', "");
    Expect(0, 67680, '\p{armi}', "");
    Expect(1, 67680, '\p{^armi}', "");
    Expect(1, 67680, '\P{armi}', "");
    Expect(0, 67680, '\P{^armi}', "");
    Expect(1, 67679, '\p{_Armi}', "");
    Expect(0, 67679, '\p{^_Armi}', "");
    Expect(0, 67679, '\P{_Armi}', "");
    Expect(1, 67679, '\P{^_Armi}', "");
    Expect(0, 67680, '\p{_Armi}', "");
    Expect(1, 67680, '\p{^_Armi}', "");
    Expect(1, 67680, '\P{_Armi}', "");
    Expect(0, 67680, '\P{^_Armi}', "");
    Error('\p{	:=IS_ARMI}');
    Error('\P{	:=IS_ARMI}');
    Expect(1, 67679, '\p{isarmi}', "");
    Expect(0, 67679, '\p{^isarmi}', "");
    Expect(0, 67679, '\P{isarmi}', "");
    Expect(1, 67679, '\P{^isarmi}', "");
    Expect(0, 67680, '\p{isarmi}', "");
    Expect(1, 67680, '\p{^isarmi}', "");
    Expect(1, 67680, '\P{isarmi}', "");
    Expect(0, 67680, '\P{^isarmi}', "");
    Expect(1, 67679, '\p{-_Is_ARMI}', "");
    Expect(0, 67679, '\p{^-_Is_ARMI}', "");
    Expect(0, 67679, '\P{-_Is_ARMI}', "");
    Expect(1, 67679, '\P{^-_Is_ARMI}', "");
    Expect(0, 67680, '\p{-_Is_ARMI}', "");
    Expect(1, 67680, '\p{^-_Is_ARMI}', "");
    Expect(1, 67680, '\P{-_Is_ARMI}', "");
    Expect(0, 67680, '\P{^-_Is_ARMI}', "");
    Error('\p{__In_Adlam:=}');
    Error('\P{__In_Adlam:=}');
    Expect(1, 125279, '\p{inadlam}', "");
    Expect(0, 125279, '\p{^inadlam}', "");
    Expect(0, 125279, '\P{inadlam}', "");
    Expect(1, 125279, '\P{^inadlam}', "");
    Expect(0, 125280, '\p{inadlam}', "");
    Expect(1, 125280, '\p{^inadlam}', "");
    Expect(1, 125280, '\P{inadlam}', "");
    Expect(0, 125280, '\P{^inadlam}', "");
    Expect(1, 125279, '\p{_	in_ADLAM}', "");
    Expect(0, 125279, '\p{^_	in_ADLAM}', "");
    Expect(0, 125279, '\P{_	in_ADLAM}', "");
    Expect(1, 125279, '\P{^_	in_ADLAM}', "");
    Expect(0, 125280, '\p{_	in_ADLAM}', "");
    Expect(1, 125280, '\p{^_	in_ADLAM}', "");
    Expect(1, 125280, '\P{_	in_ADLAM}', "");
    Expect(0, 125280, '\P{^_	in_ADLAM}', "");
    Error('\p{ 	In_adlam:=}');
    Error('\P{ 	In_adlam:=}');
    Expect(1, 125279, '\p{ _in_Adlam}', "");
    Expect(0, 125279, '\p{^ _in_Adlam}', "");
    Expect(0, 125279, '\P{ _in_Adlam}', "");
    Expect(1, 125279, '\P{^ _in_Adlam}', "");
    Expect(0, 125280, '\p{ _in_Adlam}', "");
    Expect(1, 125280, '\p{^ _in_Adlam}', "");
    Expect(1, 125280, '\P{ _in_Adlam}', "");
    Expect(0, 125280, '\P{^ _in_Adlam}', "");
    Error('\p{	In_AHOM:=}');
    Error('\P{	In_AHOM:=}');
    Expect(1, 71503, '\p{inahom}', "");
    Expect(0, 71503, '\p{^inahom}', "");
    Expect(0, 71503, '\P{inahom}', "");
    Expect(1, 71503, '\P{^inahom}', "");
    Expect(0, 71504, '\p{inahom}', "");
    Expect(1, 71504, '\p{^inahom}', "");
    Expect(1, 71504, '\P{inahom}', "");
    Expect(0, 71504, '\P{^inahom}', "");
    Expect(1, 71503, '\p{_ IN_Ahom}', "");
    Expect(0, 71503, '\p{^_ IN_Ahom}', "");
    Expect(0, 71503, '\P{_ IN_Ahom}', "");
    Expect(1, 71503, '\P{^_ IN_Ahom}', "");
    Expect(0, 71504, '\p{_ IN_Ahom}', "");
    Expect(1, 71504, '\p{^_ IN_Ahom}', "");
    Expect(1, 71504, '\P{_ IN_Ahom}', "");
    Expect(0, 71504, '\P{^_ IN_Ahom}', "");
    Error('\p{_:=IN_Ahom}');
    Error('\P{_:=IN_Ahom}');
    Expect(1, 71503, '\p{	in_AHOM}', "");
    Expect(0, 71503, '\p{^	in_AHOM}', "");
    Expect(0, 71503, '\P{	in_AHOM}', "");
    Expect(1, 71503, '\P{^	in_AHOM}', "");
    Expect(0, 71504, '\p{	in_AHOM}', "");
    Expect(1, 71504, '\p{^	in_AHOM}', "");
    Expect(1, 71504, '\P{	in_AHOM}', "");
    Expect(0, 71504, '\P{^	in_AHOM}', "");
    Error('\p{:=-_in_ANATOLIAN_Hieroglyphs}');
    Error('\P{:=-_in_ANATOLIAN_Hieroglyphs}');
    Expect(1, 83583, '\p{inanatolianhieroglyphs}', "");
    Expect(0, 83583, '\p{^inanatolianhieroglyphs}', "");
    Expect(0, 83583, '\P{inanatolianhieroglyphs}', "");
    Expect(1, 83583, '\P{^inanatolianhieroglyphs}', "");
    Expect(0, 83584, '\p{inanatolianhieroglyphs}', "");
    Expect(1, 83584, '\p{^inanatolianhieroglyphs}', "");
    Expect(1, 83584, '\P{inanatolianhieroglyphs}', "");
    Expect(0, 83584, '\P{^inanatolianhieroglyphs}', "");
    Expect(1, 83583, '\p{In_anatolian_hieroglyphs}', "");
    Expect(0, 83583, '\p{^In_anatolian_hieroglyphs}', "");
    Expect(0, 83583, '\P{In_anatolian_hieroglyphs}', "");
    Expect(1, 83583, '\P{^In_anatolian_hieroglyphs}', "");
    Expect(0, 83584, '\p{In_anatolian_hieroglyphs}', "");
    Expect(1, 83584, '\p{^In_anatolian_hieroglyphs}', "");
    Expect(1, 83584, '\P{In_anatolian_hieroglyphs}', "");
    Expect(0, 83584, '\P{^In_anatolian_hieroglyphs}', "");
    Error('\p{:= _In_Anatolian_Hieroglyphs}');
    Error('\P{:= _In_Anatolian_Hieroglyphs}');
    Expect(1, 83583, '\p{		In_Anatolian_HIEROGLYPHS}', "");
    Expect(0, 83583, '\p{^		In_Anatolian_HIEROGLYPHS}', "");
    Expect(0, 83583, '\P{		In_Anatolian_HIEROGLYPHS}', "");
    Expect(1, 83583, '\P{^		In_Anatolian_HIEROGLYPHS}', "");
    Expect(0, 83584, '\p{		In_Anatolian_HIEROGLYPHS}', "");
    Expect(1, 83584, '\p{^		In_Anatolian_HIEROGLYPHS}', "");
    Expect(1, 83584, '\P{		In_Anatolian_HIEROGLYPHS}', "");
    Expect(0, 83584, '\P{^		In_Anatolian_HIEROGLYPHS}', "");
    Error('\p{-:=In_Arabic}');
    Error('\P{-:=In_Arabic}');
    Expect(1, 1791, '\p{inarabic}', "");
    Expect(0, 1791, '\p{^inarabic}', "");
    Expect(0, 1791, '\P{inarabic}', "");
    Expect(1, 1791, '\P{^inarabic}', "");
    Expect(0, 1792, '\p{inarabic}', "");
    Expect(1, 1792, '\p{^inarabic}', "");
    Expect(1, 1792, '\P{inarabic}', "");
    Expect(0, 1792, '\P{^inarabic}', "");
    Expect(1, 1791, '\p{	IN_Arabic}', "");
    Expect(0, 1791, '\p{^	IN_Arabic}', "");
    Expect(0, 1791, '\P{	IN_Arabic}', "");
    Expect(1, 1791, '\P{^	IN_Arabic}', "");
    Expect(0, 1792, '\p{	IN_Arabic}', "");
    Expect(1, 1792, '\p{^	IN_Arabic}', "");
    Expect(1, 1792, '\P{	IN_Arabic}', "");
    Expect(0, 1792, '\P{^	IN_Arabic}', "");
    Error('\p{:=In_Arabic}');
    Error('\P{:=In_Arabic}');
    Expect(1, 1791, '\p{- In_Arabic}', "");
    Expect(0, 1791, '\p{^- In_Arabic}', "");
    Expect(0, 1791, '\P{- In_Arabic}', "");
    Expect(1, 1791, '\P{^- In_Arabic}', "");
    Expect(0, 1792, '\p{- In_Arabic}', "");
    Expect(1, 1792, '\p{^- In_Arabic}', "");
    Expect(1, 1792, '\P{- In_Arabic}', "");
    Expect(0, 1792, '\P{^- In_Arabic}', "");
    Error('\p{_in_ARMENIAN:=}');
    Error('\P{_in_ARMENIAN:=}');
    Expect(1, 1423, '\p{inarmenian}', "");
    Expect(0, 1423, '\p{^inarmenian}', "");
    Expect(0, 1423, '\P{inarmenian}', "");
    Expect(1, 1423, '\P{^inarmenian}', "");
    Expect(0, 1424, '\p{inarmenian}', "");
    Expect(1, 1424, '\p{^inarmenian}', "");
    Expect(1, 1424, '\P{inarmenian}', "");
    Expect(0, 1424, '\P{^inarmenian}', "");
    Expect(1, 1423, '\p{_-IN_Armenian}', "");
    Expect(0, 1423, '\p{^_-IN_Armenian}', "");
    Expect(0, 1423, '\P{_-IN_Armenian}', "");
    Expect(1, 1423, '\P{^_-IN_Armenian}', "");
    Expect(0, 1424, '\p{_-IN_Armenian}', "");
    Expect(1, 1424, '\p{^_-IN_Armenian}', "");
    Expect(1, 1424, '\P{_-IN_Armenian}', "");
    Expect(0, 1424, '\P{^_-IN_Armenian}', "");
    Error('\p{/a/_ In_Armenian}');
    Error('\P{/a/_ In_Armenian}');
    Expect(1, 1423, '\p{_In_Armenian}', "");
    Expect(0, 1423, '\p{^_In_Armenian}', "");
    Expect(0, 1423, '\P{_In_Armenian}', "");
    Expect(1, 1423, '\P{^_In_Armenian}', "");
    Expect(0, 1424, '\p{_In_Armenian}', "");
    Expect(1, 1424, '\p{^_In_Armenian}', "");
    Expect(1, 1424, '\P{_In_Armenian}', "");
    Expect(0, 1424, '\P{^_In_Armenian}', "");
    Error('\p{-In_AVESTAN:=}');
    Error('\P{-In_AVESTAN:=}');
    Expect(1, 68415, '\p{inavestan}', "");
    Expect(0, 68415, '\p{^inavestan}', "");
    Expect(0, 68415, '\P{inavestan}', "");
    Expect(1, 68415, '\P{^inavestan}', "");
    Expect(0, 68416, '\p{inavestan}', "");
    Expect(1, 68416, '\p{^inavestan}', "");
    Expect(1, 68416, '\P{inavestan}', "");
    Expect(0, 68416, '\P{^inavestan}', "");
    Expect(1, 68415, '\p{_-in_Avestan}', "");
    Expect(0, 68415, '\p{^_-in_Avestan}', "");
    Expect(0, 68415, '\P{_-in_Avestan}', "");
    Expect(1, 68415, '\P{^_-in_Avestan}', "");
    Expect(0, 68416, '\p{_-in_Avestan}', "");
    Expect(1, 68416, '\p{^_-in_Avestan}', "");
    Expect(1, 68416, '\P{_-in_Avestan}', "");
    Expect(0, 68416, '\P{^_-in_Avestan}', "");
    Error('\p{-	In_Avestan:=}');
    Error('\P{-	In_Avestan:=}');
    Expect(1, 68415, '\p{	In_avestan}', "");
    Expect(0, 68415, '\p{^	In_avestan}', "");
    Expect(0, 68415, '\P{	In_avestan}', "");
    Expect(1, 68415, '\P{^	In_avestan}', "");
    Expect(0, 68416, '\p{	In_avestan}', "");
    Expect(1, 68416, '\p{^	In_avestan}', "");
    Expect(1, 68416, '\P{	In_avestan}', "");
    Expect(0, 68416, '\P{^	In_avestan}', "");
    Error('\p{ /a/In_Balinese}');
    Error('\P{ /a/In_Balinese}');
    Expect(1, 7039, '\p{inbalinese}', "");
    Expect(0, 7039, '\p{^inbalinese}', "");
    Expect(0, 7039, '\P{inbalinese}', "");
    Expect(1, 7039, '\P{^inbalinese}', "");
    Expect(0, 7040, '\p{inbalinese}', "");
    Expect(1, 7040, '\p{^inbalinese}', "");
    Expect(1, 7040, '\P{inbalinese}', "");
    Expect(0, 7040, '\P{^inbalinese}', "");
    Expect(1, 7039, '\p{ -IN_BALINESE}', "");
    Expect(0, 7039, '\p{^ -IN_BALINESE}', "");
    Expect(0, 7039, '\P{ -IN_BALINESE}', "");
    Expect(1, 7039, '\P{^ -IN_BALINESE}', "");
    Expect(0, 7040, '\p{ -IN_BALINESE}', "");
    Expect(1, 7040, '\p{^ -IN_BALINESE}', "");
    Expect(1, 7040, '\P{ -IN_BALINESE}', "");
    Expect(0, 7040, '\P{^ -IN_BALINESE}', "");
    Error('\p{_:=in_BALINESE}');
    Error('\P{_:=in_BALINESE}');
    Expect(1, 7039, '\p{ in_balinese}', "");
    Expect(0, 7039, '\p{^ in_balinese}', "");
    Expect(0, 7039, '\P{ in_balinese}', "");
    Expect(1, 7039, '\P{^ in_balinese}', "");
    Expect(0, 7040, '\p{ in_balinese}', "");
    Expect(1, 7040, '\p{^ in_balinese}', "");
    Expect(1, 7040, '\P{ in_balinese}', "");
    Expect(0, 7040, '\P{^ in_balinese}', "");
    Error('\p{	In_BAMUM/a/}');
    Error('\P{	In_BAMUM/a/}');
    Expect(1, 42751, '\p{inbamum}', "");
    Expect(0, 42751, '\p{^inbamum}', "");
    Expect(0, 42751, '\P{inbamum}', "");
    Expect(1, 42751, '\P{^inbamum}', "");
    Expect(0, 42752, '\p{inbamum}', "");
    Expect(1, 42752, '\p{^inbamum}', "");
    Expect(1, 42752, '\P{inbamum}', "");
    Expect(0, 42752, '\P{^inbamum}', "");
    Expect(1, 42751, '\p{- in_BAMUM}', "");
    Expect(0, 42751, '\p{^- in_BAMUM}', "");
    Expect(0, 42751, '\P{- in_BAMUM}', "");
    Expect(1, 42751, '\P{^- in_BAMUM}', "");
    Expect(0, 42752, '\p{- in_BAMUM}', "");
    Expect(1, 42752, '\p{^- in_BAMUM}', "");
    Expect(1, 42752, '\P{- in_BAMUM}', "");
    Expect(0, 42752, '\P{^- in_BAMUM}', "");
    Error('\p{ In_bamum/a/}');
    Error('\P{ In_bamum/a/}');
    Expect(1, 42751, '\p{_IN_bamum}', "");
    Expect(0, 42751, '\p{^_IN_bamum}', "");
    Expect(0, 42751, '\P{_IN_bamum}', "");
    Expect(1, 42751, '\P{^_IN_bamum}', "");
    Expect(0, 42752, '\p{_IN_bamum}', "");
    Expect(1, 42752, '\p{^_IN_bamum}', "");
    Expect(1, 42752, '\P{_IN_bamum}', "");
    Expect(0, 42752, '\P{^_IN_bamum}', "");
    Error('\p{	IN_Bassa_Vah/a/}');
    Error('\P{	IN_Bassa_Vah/a/}');
    Expect(1, 92927, '\p{inbassavah}', "");
    Expect(0, 92927, '\p{^inbassavah}', "");
    Expect(0, 92927, '\P{inbassavah}', "");
    Expect(1, 92927, '\P{^inbassavah}', "");
    Expect(0, 92928, '\p{inbassavah}', "");
    Expect(1, 92928, '\p{^inbassavah}', "");
    Expect(1, 92928, '\P{inbassavah}', "");
    Expect(0, 92928, '\P{^inbassavah}', "");
    Expect(1, 92927, '\p{ _In_bassa_Vah}', "");
    Expect(0, 92927, '\p{^ _In_bassa_Vah}', "");
    Expect(0, 92927, '\P{ _In_bassa_Vah}', "");
    Expect(1, 92927, '\P{^ _In_bassa_Vah}', "");
    Expect(0, 92928, '\p{ _In_bassa_Vah}', "");
    Expect(1, 92928, '\p{^ _In_bassa_Vah}', "");
    Expect(1, 92928, '\P{ _In_bassa_Vah}', "");
    Expect(0, 92928, '\P{^ _In_bassa_Vah}', "");
    Error('\p{:=IN_bassa_vah}');
    Error('\P{:=IN_bassa_vah}');
    Expect(1, 92927, '\p{_	IN_Bassa_Vah}', "");
    Expect(0, 92927, '\p{^_	IN_Bassa_Vah}', "");
    Expect(0, 92927, '\P{_	IN_Bassa_Vah}', "");
    Expect(1, 92927, '\P{^_	IN_Bassa_Vah}', "");
    Expect(0, 92928, '\p{_	IN_Bassa_Vah}', "");
    Expect(1, 92928, '\p{^_	IN_Bassa_Vah}', "");
    Expect(1, 92928, '\P{_	IN_Bassa_Vah}', "");
    Expect(0, 92928, '\P{^_	IN_Bassa_Vah}', "");
    Error('\p{/a/_-in_batak}');
    Error('\P{/a/_-in_batak}');
    Expect(1, 7167, '\p{inbatak}', "");
    Expect(0, 7167, '\p{^inbatak}', "");
    Expect(0, 7167, '\P{inbatak}', "");
    Expect(1, 7167, '\P{^inbatak}', "");
    Expect(0, 7168, '\p{inbatak}', "");
    Expect(1, 7168, '\p{^inbatak}', "");
    Expect(1, 7168, '\P{inbatak}', "");
    Expect(0, 7168, '\P{^inbatak}', "");
    Expect(1, 7167, '\p{_	in_BATAK}', "");
    Expect(0, 7167, '\p{^_	in_BATAK}', "");
    Expect(0, 7167, '\P{_	in_BATAK}', "");
    Expect(1, 7167, '\P{^_	in_BATAK}', "");
    Expect(0, 7168, '\p{_	in_BATAK}', "");
    Expect(1, 7168, '\p{^_	in_BATAK}', "");
    Expect(1, 7168, '\P{_	in_BATAK}', "");
    Expect(0, 7168, '\P{^_	in_BATAK}', "");
    Error('\p{	In_BATAK:=}');
    Error('\P{	In_BATAK:=}');
    Expect(1, 7167, '\p{-_IN_Batak}', "");
    Expect(0, 7167, '\p{^-_IN_Batak}', "");
    Expect(0, 7167, '\P{-_IN_Batak}', "");
    Expect(1, 7167, '\P{^-_IN_Batak}', "");
    Expect(0, 7168, '\p{-_IN_Batak}', "");
    Expect(1, 7168, '\p{^-_IN_Batak}', "");
    Expect(1, 7168, '\P{-_IN_Batak}', "");
    Expect(0, 7168, '\P{^-_IN_Batak}', "");
    Error('\p{-:=in_Bengali}');
    Error('\P{-:=in_Bengali}');
    Expect(1, 2559, '\p{inbengali}', "");
    Expect(0, 2559, '\p{^inbengali}', "");
    Expect(0, 2559, '\P{inbengali}', "");
    Expect(1, 2559, '\P{^inbengali}', "");
    Expect(0, 2560, '\p{inbengali}', "");
    Expect(1, 2560, '\p{^inbengali}', "");
    Expect(1, 2560, '\P{inbengali}', "");
    Expect(0, 2560, '\P{^inbengali}', "");
    Expect(1, 2559, '\p{	_In_Bengali}', "");
    Expect(0, 2559, '\p{^	_In_Bengali}', "");
    Expect(0, 2559, '\P{	_In_Bengali}', "");
    Expect(1, 2559, '\P{^	_In_Bengali}', "");
    Expect(0, 2560, '\p{	_In_Bengali}', "");
    Expect(1, 2560, '\p{^	_In_Bengali}', "");
    Expect(1, 2560, '\P{	_In_Bengali}', "");
    Expect(0, 2560, '\P{^	_In_Bengali}', "");
    Error('\p{-	In_Bengali/a/}');
    Error('\P{-	In_Bengali/a/}');
    Expect(1, 2559, '\p{--In_BENGALI}', "");
    Expect(0, 2559, '\p{^--In_BENGALI}', "");
    Expect(0, 2559, '\P{--In_BENGALI}', "");
    Expect(1, 2559, '\P{^--In_BENGALI}', "");
    Expect(0, 2560, '\p{--In_BENGALI}', "");
    Expect(1, 2560, '\p{^--In_BENGALI}', "");
    Expect(1, 2560, '\P{--In_BENGALI}', "");
    Expect(0, 2560, '\P{^--In_BENGALI}', "");
    Error('\p{:=	-in_Bhaiksuki}');
    Error('\P{:=	-in_Bhaiksuki}');
    Expect(1, 72815, '\p{inbhaiksuki}', "");
    Expect(0, 72815, '\p{^inbhaiksuki}', "");
    Expect(0, 72815, '\P{inbhaiksuki}', "");
    Expect(1, 72815, '\P{^inbhaiksuki}', "");
    Expect(0, 72816, '\p{inbhaiksuki}', "");
    Expect(1, 72816, '\p{^inbhaiksuki}', "");
    Expect(1, 72816, '\P{inbhaiksuki}', "");
    Expect(0, 72816, '\P{^inbhaiksuki}', "");
    Expect(1, 72815, '\p{_-in_Bhaiksuki}', "");
    Expect(0, 72815, '\p{^_-in_Bhaiksuki}', "");
    Expect(0, 72815, '\P{_-in_Bhaiksuki}', "");
    Expect(1, 72815, '\P{^_-in_Bhaiksuki}', "");
    Expect(0, 72816, '\p{_-in_Bhaiksuki}', "");
    Expect(1, 72816, '\p{^_-in_Bhaiksuki}', "");
    Expect(1, 72816, '\P{_-in_Bhaiksuki}', "");
    Expect(0, 72816, '\P{^_-in_Bhaiksuki}', "");
    Error('\p{/a/	_In_Bhaiksuki}');
    Error('\P{/a/	_In_Bhaiksuki}');
    Expect(1, 72815, '\p{		IN_BHAIKSUKI}', "");
    Expect(0, 72815, '\p{^		IN_BHAIKSUKI}', "");
    Expect(0, 72815, '\P{		IN_BHAIKSUKI}', "");
    Expect(1, 72815, '\P{^		IN_BHAIKSUKI}', "");
    Expect(0, 72816, '\p{		IN_BHAIKSUKI}', "");
    Expect(1, 72816, '\p{^		IN_BHAIKSUKI}', "");
    Expect(1, 72816, '\P{		IN_BHAIKSUKI}', "");
    Expect(0, 72816, '\P{^		IN_BHAIKSUKI}', "");
    Error('\p{/a/_-In_bopomofo}');
    Error('\P{/a/_-In_bopomofo}');
    Expect(1, 12591, '\p{inbopomofo}', "");
    Expect(0, 12591, '\p{^inbopomofo}', "");
    Expect(0, 12591, '\P{inbopomofo}', "");
    Expect(1, 12591, '\P{^inbopomofo}', "");
    Expect(0, 12592, '\p{inbopomofo}', "");
    Expect(1, 12592, '\p{^inbopomofo}', "");
    Expect(1, 12592, '\P{inbopomofo}', "");
    Expect(0, 12592, '\P{^inbopomofo}', "");
    Expect(1, 12591, '\p{ IN_Bopomofo}', "");
    Expect(0, 12591, '\p{^ IN_Bopomofo}', "");
    Expect(0, 12591, '\P{ IN_Bopomofo}', "");
    Expect(1, 12591, '\P{^ IN_Bopomofo}', "");
    Expect(0, 12592, '\p{ IN_Bopomofo}', "");
    Expect(1, 12592, '\p{^ IN_Bopomofo}', "");
    Expect(1, 12592, '\P{ IN_Bopomofo}', "");
    Expect(0, 12592, '\P{^ IN_Bopomofo}', "");
    Error('\p{:=  In_bopomofo}');
    Error('\P{:=  In_bopomofo}');
    Expect(1, 12591, '\p{	in_BOPOMOFO}', "");
    Expect(0, 12591, '\p{^	in_BOPOMOFO}', "");
    Expect(0, 12591, '\P{	in_BOPOMOFO}', "");
    Expect(1, 12591, '\P{^	in_BOPOMOFO}', "");
    Expect(0, 12592, '\p{	in_BOPOMOFO}', "");
    Expect(1, 12592, '\p{^	in_BOPOMOFO}', "");
    Expect(1, 12592, '\P{	in_BOPOMOFO}', "");
    Expect(0, 12592, '\P{^	in_BOPOMOFO}', "");
    Error('\p{ /a/IN_brahmi}');
    Error('\P{ /a/IN_brahmi}');
    Expect(1, 69759, '\p{inbrahmi}', "");
    Expect(0, 69759, '\p{^inbrahmi}', "");
    Expect(0, 69759, '\P{inbrahmi}', "");
    Expect(1, 69759, '\P{^inbrahmi}', "");
    Expect(0, 69760, '\p{inbrahmi}', "");
    Expect(1, 69760, '\p{^inbrahmi}', "");
    Expect(1, 69760, '\P{inbrahmi}', "");
    Expect(0, 69760, '\P{^inbrahmi}', "");
    Expect(1, 69759, '\p{	In_BRAHMI}', "");
    Expect(0, 69759, '\p{^	In_BRAHMI}', "");
    Expect(0, 69759, '\P{	In_BRAHMI}', "");
    Expect(1, 69759, '\P{^	In_BRAHMI}', "");
    Expect(0, 69760, '\p{	In_BRAHMI}', "");
    Expect(1, 69760, '\p{^	In_BRAHMI}', "");
    Expect(1, 69760, '\P{	In_BRAHMI}', "");
    Expect(0, 69760, '\P{^	In_BRAHMI}', "");
    Error('\p{- In_Brahmi:=}');
    Error('\P{- In_Brahmi:=}');
    Expect(1, 69759, '\p{ In_Brahmi}', "");
    Expect(0, 69759, '\p{^ In_Brahmi}', "");
    Expect(0, 69759, '\P{ In_Brahmi}', "");
    Expect(1, 69759, '\P{^ In_Brahmi}', "");
    Expect(0, 69760, '\p{ In_Brahmi}', "");
    Expect(1, 69760, '\p{^ In_Brahmi}', "");
    Expect(1, 69760, '\P{ In_Brahmi}', "");
    Expect(0, 69760, '\P{^ In_Brahmi}', "");
    Error('\p{:=	-In_Buginese}');
    Error('\P{:=	-In_Buginese}');
    Expect(1, 6687, '\p{inbuginese}', "");
    Expect(0, 6687, '\p{^inbuginese}', "");
    Expect(0, 6687, '\P{inbuginese}', "");
    Expect(1, 6687, '\P{^inbuginese}', "");
    Expect(0, 6688, '\p{inbuginese}', "");
    Expect(1, 6688, '\p{^inbuginese}', "");
    Expect(1, 6688, '\P{inbuginese}', "");
    Expect(0, 6688, '\P{^inbuginese}', "");
    Expect(1, 6687, '\p{  IN_BUGINESE}', "");
    Expect(0, 6687, '\p{^  IN_BUGINESE}', "");
    Expect(0, 6687, '\P{  IN_BUGINESE}', "");
    Expect(1, 6687, '\P{^  IN_BUGINESE}', "");
    Expect(0, 6688, '\p{  IN_BUGINESE}', "");
    Expect(1, 6688, '\p{^  IN_BUGINESE}', "");
    Expect(1, 6688, '\P{  IN_BUGINESE}', "");
    Expect(0, 6688, '\P{^  IN_BUGINESE}', "");
    Error('\p{-In_Buginese/a/}');
    Error('\P{-In_Buginese/a/}');
    Expect(1, 6687, '\p{	 In_BUGINESE}', "");
    Expect(0, 6687, '\p{^	 In_BUGINESE}', "");
    Expect(0, 6687, '\P{	 In_BUGINESE}', "");
    Expect(1, 6687, '\P{^	 In_BUGINESE}', "");
    Expect(0, 6688, '\p{	 In_BUGINESE}', "");
    Expect(1, 6688, '\p{^	 In_BUGINESE}', "");
    Expect(1, 6688, '\P{	 In_BUGINESE}', "");
    Expect(0, 6688, '\P{^	 In_BUGINESE}', "");
    Error('\p{ 	In_Buhid:=}');
    Error('\P{ 	In_Buhid:=}');
    Expect(1, 5983, '\p{inbuhid}', "");
    Expect(0, 5983, '\p{^inbuhid}', "");
    Expect(0, 5983, '\P{inbuhid}', "");
    Expect(1, 5983, '\P{^inbuhid}', "");
    Expect(0, 5984, '\p{inbuhid}', "");
    Expect(1, 5984, '\p{^inbuhid}', "");
    Expect(1, 5984, '\P{inbuhid}', "");
    Expect(0, 5984, '\P{^inbuhid}', "");
    Expect(1, 5983, '\p{_in_Buhid}', "");
    Expect(0, 5983, '\p{^_in_Buhid}', "");
    Expect(0, 5983, '\P{_in_Buhid}', "");
    Expect(1, 5983, '\P{^_in_Buhid}', "");
    Expect(0, 5984, '\p{_in_Buhid}', "");
    Expect(1, 5984, '\p{^_in_Buhid}', "");
    Expect(1, 5984, '\P{_in_Buhid}', "");
    Expect(0, 5984, '\P{^_in_Buhid}', "");
    Error('\p{ 	In_buhid:=}');
    Error('\P{ 	In_buhid:=}');
    Expect(1, 5983, '\p{- IN_BUHID}', "");
    Expect(0, 5983, '\p{^- IN_BUHID}', "");
    Expect(0, 5983, '\P{- IN_BUHID}', "");
    Expect(1, 5983, '\P{^- IN_BUHID}', "");
    Expect(0, 5984, '\p{- IN_BUHID}', "");
    Expect(1, 5984, '\p{^- IN_BUHID}', "");
    Expect(1, 5984, '\P{- IN_BUHID}', "");
    Expect(0, 5984, '\P{^- IN_BUHID}', "");
    Error('\p{/a/	-In_CARIAN}');
    Error('\P{/a/	-In_CARIAN}');
    Expect(1, 66271, '\p{incarian}', "");
    Expect(0, 66271, '\p{^incarian}', "");
    Expect(0, 66271, '\P{incarian}', "");
    Expect(1, 66271, '\P{^incarian}', "");
    Expect(0, 66272, '\p{incarian}', "");
    Expect(1, 66272, '\p{^incarian}', "");
    Expect(1, 66272, '\P{incarian}', "");
    Expect(0, 66272, '\P{^incarian}', "");
    Expect(1, 66271, '\p{		in_carian}', "");
    Expect(0, 66271, '\p{^		in_carian}', "");
    Expect(0, 66271, '\P{		in_carian}', "");
    Expect(1, 66271, '\P{^		in_carian}', "");
    Expect(0, 66272, '\p{		in_carian}', "");
    Expect(1, 66272, '\p{^		in_carian}', "");
    Expect(1, 66272, '\P{		in_carian}', "");
    Expect(0, 66272, '\P{^		in_carian}', "");
    Error('\p{	 In_carian:=}');
    Error('\P{	 In_carian:=}');
    Expect(1, 66271, '\p{	_IN_Carian}', "");
    Expect(0, 66271, '\p{^	_IN_Carian}', "");
    Expect(0, 66271, '\P{	_IN_Carian}', "");
    Expect(1, 66271, '\P{^	_IN_Carian}', "");
    Expect(0, 66272, '\p{	_IN_Carian}', "");
    Expect(1, 66272, '\p{^	_IN_Carian}', "");
    Expect(1, 66272, '\P{	_IN_Carian}', "");
    Expect(0, 66272, '\P{^	_IN_Carian}', "");
    Error('\p{- IN_caucasian_Albanian:=}');
    Error('\P{- IN_caucasian_Albanian:=}');
    Expect(1, 66927, '\p{incaucasianalbanian}', "");
    Expect(0, 66927, '\p{^incaucasianalbanian}', "");
    Expect(0, 66927, '\P{incaucasianalbanian}', "");
    Expect(1, 66927, '\P{^incaucasianalbanian}', "");
    Expect(0, 66928, '\p{incaucasianalbanian}', "");
    Expect(1, 66928, '\p{^incaucasianalbanian}', "");
    Expect(1, 66928, '\P{incaucasianalbanian}', "");
    Expect(0, 66928, '\P{^incaucasianalbanian}', "");
    Expect(1, 66927, '\p{-In_Caucasian_Albanian}', "");
    Expect(0, 66927, '\p{^-In_Caucasian_Albanian}', "");
    Expect(0, 66927, '\P{-In_Caucasian_Albanian}', "");
    Expect(1, 66927, '\P{^-In_Caucasian_Albanian}', "");
    Expect(0, 66928, '\p{-In_Caucasian_Albanian}', "");
    Expect(1, 66928, '\p{^-In_Caucasian_Albanian}', "");
    Expect(1, 66928, '\P{-In_Caucasian_Albanian}', "");
    Expect(0, 66928, '\P{^-In_Caucasian_Albanian}', "");
    Error('\p{/a/_	in_Caucasian_Albanian}');
    Error('\P{/a/_	in_Caucasian_Albanian}');
    Expect(1, 66927, '\p{-_In_caucasian_albanian}', "");
    Expect(0, 66927, '\p{^-_In_caucasian_albanian}', "");
    Expect(0, 66927, '\P{-_In_caucasian_albanian}', "");
    Expect(1, 66927, '\P{^-_In_caucasian_albanian}', "");
    Expect(0, 66928, '\p{-_In_caucasian_albanian}', "");
    Expect(1, 66928, '\p{^-_In_caucasian_albanian}', "");
    Expect(1, 66928, '\P{-_In_caucasian_albanian}', "");
    Expect(0, 66928, '\P{^-_In_caucasian_albanian}', "");
    Error('\p{:= -IN_chakma}');
    Error('\P{:= -IN_chakma}');
    Expect(1, 69967, '\p{inchakma}', "");
    Expect(0, 69967, '\p{^inchakma}', "");
    Expect(0, 69967, '\P{inchakma}', "");
    Expect(1, 69967, '\P{^inchakma}', "");
    Expect(0, 69968, '\p{inchakma}', "");
    Expect(1, 69968, '\p{^inchakma}', "");
    Expect(1, 69968, '\P{inchakma}', "");
    Expect(0, 69968, '\P{^inchakma}', "");
    Expect(1, 69967, '\p{_ IN_CHAKMA}', "");
    Expect(0, 69967, '\p{^_ IN_CHAKMA}', "");
    Expect(0, 69967, '\P{_ IN_CHAKMA}', "");
    Expect(1, 69967, '\P{^_ IN_CHAKMA}', "");
    Expect(0, 69968, '\p{_ IN_CHAKMA}', "");
    Expect(1, 69968, '\p{^_ IN_CHAKMA}', "");
    Expect(1, 69968, '\P{_ IN_CHAKMA}', "");
    Expect(0, 69968, '\P{^_ IN_CHAKMA}', "");
    Error('\p{/a/in_CHAKMA}');
    Error('\P{/a/in_CHAKMA}');
    Expect(1, 69967, '\p{ In_CHAKMA}', "");
    Expect(0, 69967, '\p{^ In_CHAKMA}', "");
    Expect(0, 69967, '\P{ In_CHAKMA}', "");
    Expect(1, 69967, '\P{^ In_CHAKMA}', "");
    Expect(0, 69968, '\p{ In_CHAKMA}', "");
    Expect(1, 69968, '\p{^ In_CHAKMA}', "");
    Expect(1, 69968, '\P{ In_CHAKMA}', "");
    Expect(0, 69968, '\P{^ In_CHAKMA}', "");
    Error('\p{_	In_cham/a/}');
    Error('\P{_	In_cham/a/}');
    Expect(1, 43615, '\p{incham}', "");
    Expect(0, 43615, '\p{^incham}', "");
    Expect(0, 43615, '\P{incham}', "");
    Expect(1, 43615, '\P{^incham}', "");
    Expect(0, 43616, '\p{incham}', "");
    Expect(1, 43616, '\p{^incham}', "");
    Expect(1, 43616, '\P{incham}', "");
    Expect(0, 43616, '\P{^incham}', "");
    Expect(1, 43615, '\p{-in_Cham}', "");
    Expect(0, 43615, '\p{^-in_Cham}', "");
    Expect(0, 43615, '\P{-in_Cham}', "");
    Expect(1, 43615, '\P{^-in_Cham}', "");
    Expect(0, 43616, '\p{-in_Cham}', "");
    Expect(1, 43616, '\p{^-in_Cham}', "");
    Expect(1, 43616, '\P{-in_Cham}', "");
    Expect(0, 43616, '\P{^-in_Cham}', "");
    Error('\p{-in_cham:=}');
    Error('\P{-in_cham:=}');
    Expect(1, 43615, '\p{-In_cham}', "");
    Expect(0, 43615, '\p{^-In_cham}', "");
    Expect(0, 43615, '\P{-In_cham}', "");
    Expect(1, 43615, '\P{^-In_cham}', "");
    Expect(0, 43616, '\p{-In_cham}', "");
    Expect(1, 43616, '\p{^-In_cham}', "");
    Expect(1, 43616, '\P{-In_cham}', "");
    Expect(0, 43616, '\P{^-In_cham}', "");
    Error('\p{	:=In_Cherokee}');
    Error('\P{	:=In_Cherokee}');
    Expect(1, 5119, '\p{incherokee}', "");
    Expect(0, 5119, '\p{^incherokee}', "");
    Expect(0, 5119, '\P{incherokee}', "");
    Expect(1, 5119, '\P{^incherokee}', "");
    Expect(0, 5120, '\p{incherokee}', "");
    Expect(1, 5120, '\p{^incherokee}', "");
    Expect(1, 5120, '\P{incherokee}', "");
    Expect(0, 5120, '\P{^incherokee}', "");
    Expect(1, 5119, '\p{	in_cherokee}', "");
    Expect(0, 5119, '\p{^	in_cherokee}', "");
    Expect(0, 5119, '\P{	in_cherokee}', "");
    Expect(1, 5119, '\P{^	in_cherokee}', "");
    Expect(0, 5120, '\p{	in_cherokee}', "");
    Expect(1, 5120, '\p{^	in_cherokee}', "");
    Expect(1, 5120, '\P{	in_cherokee}', "");
    Expect(0, 5120, '\P{^	in_cherokee}', "");
    Error('\p{ -In_Cherokee/a/}');
    Error('\P{ -In_Cherokee/a/}');
    Expect(1, 5119, '\p{ _In_Cherokee}', "");
    Expect(0, 5119, '\p{^ _In_Cherokee}', "");
    Expect(0, 5119, '\P{ _In_Cherokee}', "");
    Expect(1, 5119, '\P{^ _In_Cherokee}', "");
    Expect(0, 5120, '\p{ _In_Cherokee}', "");
    Expect(1, 5120, '\p{^ _In_Cherokee}', "");
    Expect(1, 5120, '\P{ _In_Cherokee}', "");
    Expect(0, 5120, '\P{^ _In_Cherokee}', "");
    Error('\p{		In_CHORASMIAN:=}');
    Error('\P{		In_CHORASMIAN:=}');
    Expect(1, 69599, '\p{inchorasmian}', "");
    Expect(0, 69599, '\p{^inchorasmian}', "");
    Expect(0, 69599, '\P{inchorasmian}', "");
    Expect(1, 69599, '\P{^inchorasmian}', "");
    Expect(0, 69600, '\p{inchorasmian}', "");
    Expect(1, 69600, '\p{^inchorasmian}', "");
    Expect(1, 69600, '\P{inchorasmian}', "");
    Expect(0, 69600, '\P{^inchorasmian}', "");
    Expect(1, 69599, '\p{-IN_Chorasmian}', "");
    Expect(0, 69599, '\p{^-IN_Chorasmian}', "");
    Expect(0, 69599, '\P{-IN_Chorasmian}', "");
    Expect(1, 69599, '\P{^-IN_Chorasmian}', "");
    Expect(0, 69600, '\p{-IN_Chorasmian}', "");
    Expect(1, 69600, '\p{^-IN_Chorasmian}', "");
    Expect(1, 69600, '\P{-IN_Chorasmian}', "");
    Expect(0, 69600, '\P{^-IN_Chorasmian}', "");
    Error('\p{	_In_Chorasmian:=}');
    Error('\P{	_In_Chorasmian:=}');
    Expect(1, 69599, '\p{ In_Chorasmian}', "");
    Expect(0, 69599, '\p{^ In_Chorasmian}', "");
    Expect(0, 69599, '\P{ In_Chorasmian}', "");
    Expect(1, 69599, '\P{^ In_Chorasmian}', "");
    Expect(0, 69600, '\p{ In_Chorasmian}', "");
    Expect(1, 69600, '\p{^ In_Chorasmian}', "");
    Expect(1, 69600, '\P{ In_Chorasmian}', "");
    Expect(0, 69600, '\P{^ In_Chorasmian}', "");
    Error('\p{_In_coptic/a/}');
    Error('\P{_In_coptic/a/}');
    Expect(1, 11519, '\p{incoptic}', "");
    Expect(0, 11519, '\p{^incoptic}', "");
    Expect(0, 11519, '\P{incoptic}', "");
    Expect(1, 11519, '\P{^incoptic}', "");
    Expect(0, 11520, '\p{incoptic}', "");
    Expect(1, 11520, '\p{^incoptic}', "");
    Expect(1, 11520, '\P{incoptic}', "");
    Expect(0, 11520, '\P{^incoptic}', "");
    Expect(1, 11519, '\p{ _IN_COPTIC}', "");
    Expect(0, 11519, '\p{^ _IN_COPTIC}', "");
    Expect(0, 11519, '\P{ _IN_COPTIC}', "");
    Expect(1, 11519, '\P{^ _IN_COPTIC}', "");
    Expect(0, 11520, '\p{ _IN_COPTIC}', "");
    Expect(1, 11520, '\p{^ _IN_COPTIC}', "");
    Expect(1, 11520, '\P{ _IN_COPTIC}', "");
    Expect(0, 11520, '\P{^ _IN_COPTIC}', "");
    Error('\p{-:=in_Coptic}');
    Error('\P{-:=in_Coptic}');
    Expect(1, 11519, '\p{-_IN_Coptic}', "");
    Expect(0, 11519, '\p{^-_IN_Coptic}', "");
    Expect(0, 11519, '\P{-_IN_Coptic}', "");
    Expect(1, 11519, '\P{^-_IN_Coptic}', "");
    Expect(0, 11520, '\p{-_IN_Coptic}', "");
    Expect(1, 11520, '\p{^-_IN_Coptic}', "");
    Expect(1, 11520, '\P{-_IN_Coptic}', "");
    Expect(0, 11520, '\P{^-_IN_Coptic}', "");
    Error('\p{:=_In_Cuneiform}');
    Error('\P{:=_In_Cuneiform}');
    Expect(1, 74751, '\p{incuneiform}', "");
    Expect(0, 74751, '\p{^incuneiform}', "");
    Expect(0, 74751, '\P{incuneiform}', "");
    Expect(1, 74751, '\P{^incuneiform}', "");
    Expect(0, 74752, '\p{incuneiform}', "");
    Expect(1, 74752, '\p{^incuneiform}', "");
    Expect(1, 74752, '\P{incuneiform}', "");
    Expect(0, 74752, '\P{^incuneiform}', "");
    Expect(1, 74751, '\p{_-In_Cuneiform}', "");
    Expect(0, 74751, '\p{^_-In_Cuneiform}', "");
    Expect(0, 74751, '\P{_-In_Cuneiform}', "");
    Expect(1, 74751, '\P{^_-In_Cuneiform}', "");
    Expect(0, 74752, '\p{_-In_Cuneiform}', "");
    Expect(1, 74752, '\p{^_-In_Cuneiform}', "");
    Expect(1, 74752, '\P{_-In_Cuneiform}', "");
    Expect(0, 74752, '\P{^_-In_Cuneiform}', "");
    Error('\p{:=__In_Cuneiform}');
    Error('\P{:=__In_Cuneiform}');
    Expect(1, 74751, '\p{	In_cuneiform}', "");
    Expect(0, 74751, '\p{^	In_cuneiform}', "");
    Expect(0, 74751, '\P{	In_cuneiform}', "");
    Expect(1, 74751, '\P{^	In_cuneiform}', "");
    Expect(0, 74752, '\p{	In_cuneiform}', "");
    Expect(1, 74752, '\p{^	In_cuneiform}', "");
    Expect(1, 74752, '\P{	In_cuneiform}', "");
    Expect(0, 74752, '\P{^	In_cuneiform}', "");
    Error('\p{--In_Cypro_Minoan/a/}');
    Error('\P{--In_Cypro_Minoan/a/}');
    Expect(1, 77823, '\p{incyprominoan}', "");
    Expect(0, 77823, '\p{^incyprominoan}', "");
    Expect(0, 77823, '\P{incyprominoan}', "");
    Expect(1, 77823, '\P{^incyprominoan}', "");
    Expect(0, 77824, '\p{incyprominoan}', "");
    Expect(1, 77824, '\p{^incyprominoan}', "");
    Expect(1, 77824, '\P{incyprominoan}', "");
    Expect(0, 77824, '\P{^incyprominoan}', "");
    Expect(1, 77823, '\p{ 	IN_CYPRO_Minoan}', "");
    Expect(0, 77823, '\p{^ 	IN_CYPRO_Minoan}', "");
    Expect(0, 77823, '\P{ 	IN_CYPRO_Minoan}', "");
    Expect(1, 77823, '\P{^ 	IN_CYPRO_Minoan}', "");
    Expect(0, 77824, '\p{ 	IN_CYPRO_Minoan}', "");
    Expect(1, 77824, '\p{^ 	IN_CYPRO_Minoan}', "");
    Expect(1, 77824, '\P{ 	IN_CYPRO_Minoan}', "");
    Expect(0, 77824, '\P{^ 	IN_CYPRO_Minoan}', "");
    Error('\p{/a/--IN_cypro_MINOAN}');
    Error('\P{/a/--IN_cypro_MINOAN}');
    Expect(1, 77823, '\p{_	In_CYPRO_MINOAN}', "");
    Expect(0, 77823, '\p{^_	In_CYPRO_MINOAN}', "");
    Expect(0, 77823, '\P{_	In_CYPRO_MINOAN}', "");
    Expect(1, 77823, '\P{^_	In_CYPRO_MINOAN}', "");
    Expect(0, 77824, '\p{_	In_CYPRO_MINOAN}', "");
    Expect(1, 77824, '\p{^_	In_CYPRO_MINOAN}', "");
    Expect(1, 77824, '\P{_	In_CYPRO_MINOAN}', "");
    Expect(0, 77824, '\P{^_	In_CYPRO_MINOAN}', "");
    Error('\p{/a/In_cyrillic}');
    Error('\P{/a/In_cyrillic}');
    Expect(1, 1279, '\p{incyrillic}', "");
    Expect(0, 1279, '\p{^incyrillic}', "");
    Expect(0, 1279, '\P{incyrillic}', "");
    Expect(1, 1279, '\P{^incyrillic}', "");
    Expect(0, 1280, '\p{incyrillic}', "");
    Expect(1, 1280, '\p{^incyrillic}', "");
    Expect(1, 1280, '\P{incyrillic}', "");
    Expect(0, 1280, '\P{^incyrillic}', "");
    Expect(1, 1279, '\p{-	in_CYRILLIC}', "");
    Expect(0, 1279, '\p{^-	in_CYRILLIC}', "");
    Expect(0, 1279, '\P{-	in_CYRILLIC}', "");
    Expect(1, 1279, '\P{^-	in_CYRILLIC}', "");
    Expect(0, 1280, '\p{-	in_CYRILLIC}', "");
    Expect(1, 1280, '\p{^-	in_CYRILLIC}', "");
    Expect(1, 1280, '\P{-	in_CYRILLIC}', "");
    Expect(0, 1280, '\P{^-	in_CYRILLIC}', "");
    Error('\p{:=IN_CYRILLIC}');
    Error('\P{:=IN_CYRILLIC}');
    Expect(1, 1279, '\p{_-In_cyrillic}', "");
    Expect(0, 1279, '\p{^_-In_cyrillic}', "");
    Expect(0, 1279, '\P{_-In_cyrillic}', "");
    Expect(1, 1279, '\P{^_-In_cyrillic}', "");
    Expect(0, 1280, '\p{_-In_cyrillic}', "");
    Expect(1, 1280, '\p{^_-In_cyrillic}', "");
    Expect(1, 1280, '\P{_-In_cyrillic}', "");
    Expect(0, 1280, '\P{^_-In_cyrillic}', "");
    Error('\p{/a/	IN_Deseret}');
    Error('\P{/a/	IN_Deseret}');
    Expect(1, 66639, '\p{indeseret}', "");
    Expect(0, 66639, '\p{^indeseret}', "");
    Expect(0, 66639, '\P{indeseret}', "");
    Expect(1, 66639, '\P{^indeseret}', "");
    Expect(0, 66640, '\p{indeseret}', "");
    Expect(1, 66640, '\p{^indeseret}', "");
    Expect(1, 66640, '\P{indeseret}', "");
    Expect(0, 66640, '\P{^indeseret}', "");
    Expect(1, 66639, '\p{ 	IN_Deseret}', "");
    Expect(0, 66639, '\p{^ 	IN_Deseret}', "");
    Expect(0, 66639, '\P{ 	IN_Deseret}', "");
    Expect(1, 66639, '\P{^ 	IN_Deseret}', "");
    Expect(0, 66640, '\p{ 	IN_Deseret}', "");
    Expect(1, 66640, '\p{^ 	IN_Deseret}', "");
    Expect(1, 66640, '\P{ 	IN_Deseret}', "");
    Expect(0, 66640, '\P{^ 	IN_Deseret}', "");
    Error('\p{	 In_Deseret/a/}');
    Error('\P{	 In_Deseret/a/}');
    Expect(1, 66639, '\p{--IN_DESERET}', "");
    Expect(0, 66639, '\p{^--IN_DESERET}', "");
    Expect(0, 66639, '\P{--IN_DESERET}', "");
    Expect(1, 66639, '\P{^--IN_DESERET}', "");
    Expect(0, 66640, '\p{--IN_DESERET}', "");
    Expect(1, 66640, '\p{^--IN_DESERET}', "");
    Expect(1, 66640, '\P{--IN_DESERET}', "");
    Expect(0, 66640, '\P{^--IN_DESERET}', "");
    Error('\p{-/a/IN_Devanagari}');
    Error('\P{-/a/IN_Devanagari}');
    Expect(1, 2431, '\p{indevanagari}', "");
    Expect(0, 2431, '\p{^indevanagari}', "");
    Expect(0, 2431, '\P{indevanagari}', "");
    Expect(1, 2431, '\P{^indevanagari}', "");
    Expect(0, 2432, '\p{indevanagari}', "");
    Expect(1, 2432, '\p{^indevanagari}', "");
    Expect(1, 2432, '\P{indevanagari}', "");
    Expect(0, 2432, '\P{^indevanagari}', "");
    Expect(1, 2431, '\p{_In_DEVANAGARI}', "");
    Expect(0, 2431, '\p{^_In_DEVANAGARI}', "");
    Expect(0, 2431, '\P{_In_DEVANAGARI}', "");
    Expect(1, 2431, '\P{^_In_DEVANAGARI}', "");
    Expect(0, 2432, '\p{_In_DEVANAGARI}', "");
    Expect(1, 2432, '\p{^_In_DEVANAGARI}', "");
    Expect(1, 2432, '\P{_In_DEVANAGARI}', "");
    Expect(0, 2432, '\P{^_In_DEVANAGARI}', "");
    Error('\p{/a/ In_Devanagari}');
    Error('\P{/a/ In_Devanagari}');
    Expect(1, 2431, '\p{	-in_devanagari}', "");
    Expect(0, 2431, '\p{^	-in_devanagari}', "");
    Expect(0, 2431, '\P{	-in_devanagari}', "");
    Expect(1, 2431, '\P{^	-in_devanagari}', "");
    Expect(0, 2432, '\p{	-in_devanagari}', "");
    Expect(1, 2432, '\p{^	-in_devanagari}', "");
    Expect(1, 2432, '\P{	-in_devanagari}', "");
    Expect(0, 2432, '\P{^	-in_devanagari}', "");
    Error('\p{- In_DIVES_Akuru/a/}');
    Error('\P{- In_DIVES_Akuru/a/}');
    Expect(1, 72031, '\p{indivesakuru}', "");
    Expect(0, 72031, '\p{^indivesakuru}', "");
    Expect(0, 72031, '\P{indivesakuru}', "");
    Expect(1, 72031, '\P{^indivesakuru}', "");
    Expect(0, 72032, '\p{indivesakuru}', "");
    Expect(1, 72032, '\p{^indivesakuru}', "");
    Expect(1, 72032, '\P{indivesakuru}', "");
    Expect(0, 72032, '\P{^indivesakuru}', "");
    Expect(1, 72031, '\p{ -In_Dives_akuru}', "");
    Expect(0, 72031, '\p{^ -In_Dives_akuru}', "");
    Expect(0, 72031, '\P{ -In_Dives_akuru}', "");
    Expect(1, 72031, '\P{^ -In_Dives_akuru}', "");
    Expect(0, 72032, '\p{ -In_Dives_akuru}', "");
    Expect(1, 72032, '\p{^ -In_Dives_akuru}', "");
    Expect(1, 72032, '\P{ -In_Dives_akuru}', "");
    Expect(0, 72032, '\P{^ -In_Dives_akuru}', "");
    Error('\p{ _IN_dives_Akuru/a/}');
    Error('\P{ _IN_dives_Akuru/a/}');
    Expect(1, 72031, '\p{- In_Dives_Akuru}', "");
    Expect(0, 72031, '\p{^- In_Dives_Akuru}', "");
    Expect(0, 72031, '\P{- In_Dives_Akuru}', "");
    Expect(1, 72031, '\P{^- In_Dives_Akuru}', "");
    Expect(0, 72032, '\p{- In_Dives_Akuru}', "");
    Expect(1, 72032, '\p{^- In_Dives_Akuru}', "");
    Expect(1, 72032, '\P{- In_Dives_Akuru}', "");
    Expect(0, 72032, '\P{^- In_Dives_Akuru}', "");
    Error('\p{:=_in_dogra}');
    Error('\P{:=_in_dogra}');
    Expect(1, 71759, '\p{indogra}', "");
    Expect(0, 71759, '\p{^indogra}', "");
    Expect(0, 71759, '\P{indogra}', "");
    Expect(1, 71759, '\P{^indogra}', "");
    Expect(0, 71760, '\p{indogra}', "");
    Expect(1, 71760, '\p{^indogra}', "");
    Expect(1, 71760, '\P{indogra}', "");
    Expect(0, 71760, '\P{^indogra}', "");
    Expect(1, 71759, '\p{In_dogra}', "");
    Expect(0, 71759, '\p{^In_dogra}', "");
    Expect(0, 71759, '\P{In_dogra}', "");
    Expect(1, 71759, '\P{^In_dogra}', "");
    Expect(0, 71760, '\p{In_dogra}', "");
    Expect(1, 71760, '\p{^In_dogra}', "");
    Expect(1, 71760, '\P{In_dogra}', "");
    Expect(0, 71760, '\P{^In_dogra}', "");
    Error('\p{ 	In_DOGRA:=}');
    Error('\P{ 	In_DOGRA:=}');
    Expect(1, 71759, '\p{-in_DOGRA}', "");
    Expect(0, 71759, '\p{^-in_DOGRA}', "");
    Expect(0, 71759, '\P{-in_DOGRA}', "");
    Expect(1, 71759, '\P{^-in_DOGRA}', "");
    Expect(0, 71760, '\p{-in_DOGRA}', "");
    Expect(1, 71760, '\p{^-in_DOGRA}', "");
    Expect(1, 71760, '\P{-in_DOGRA}', "");
    Expect(0, 71760, '\P{^-in_DOGRA}', "");
    Error('\p{/a/In_duployan}');
    Error('\P{/a/In_duployan}');
    Expect(1, 113823, '\p{induployan}', "");
    Expect(0, 113823, '\p{^induployan}', "");
    Expect(0, 113823, '\P{induployan}', "");
    Expect(1, 113823, '\P{^induployan}', "");
    Expect(0, 113824, '\p{induployan}', "");
    Expect(1, 113824, '\p{^induployan}', "");
    Expect(1, 113824, '\P{induployan}', "");
    Expect(0, 113824, '\P{^induployan}', "");
    Expect(1, 113823, '\p{_ In_Duployan}', "");
    Expect(0, 113823, '\p{^_ In_Duployan}', "");
    Expect(0, 113823, '\P{_ In_Duployan}', "");
    Expect(1, 113823, '\P{^_ In_Duployan}', "");
    Expect(0, 113824, '\p{_ In_Duployan}', "");
    Expect(1, 113824, '\p{^_ In_Duployan}', "");
    Expect(1, 113824, '\P{_ In_Duployan}', "");
    Expect(0, 113824, '\P{^_ In_Duployan}', "");
    Error('\p{:=	In_Duployan}');
    Error('\P{:=	In_Duployan}');
    Expect(1, 113823, '\p{_-In_DUPLOYAN}', "");
    Expect(0, 113823, '\p{^_-In_DUPLOYAN}', "");
    Expect(0, 113823, '\P{_-In_DUPLOYAN}', "");
    Expect(1, 113823, '\P{^_-In_DUPLOYAN}', "");
    Expect(0, 113824, '\p{_-In_DUPLOYAN}', "");
    Expect(1, 113824, '\p{^_-In_DUPLOYAN}', "");
    Expect(1, 113824, '\P{_-In_DUPLOYAN}', "");
    Expect(0, 113824, '\P{^_-In_DUPLOYAN}', "");
    Error('\p{/a/		IN_egyptian_Hieroglyphs}');
    Error('\P{/a/		IN_egyptian_Hieroglyphs}');
    Expect(1, 78895, '\p{inegyptianhieroglyphs}', "");
    Expect(0, 78895, '\p{^inegyptianhieroglyphs}', "");
    Expect(0, 78895, '\P{inegyptianhieroglyphs}', "");
    Expect(1, 78895, '\P{^inegyptianhieroglyphs}', "");
    Expect(0, 78896, '\p{inegyptianhieroglyphs}', "");
    Expect(1, 78896, '\p{^inegyptianhieroglyphs}', "");
    Expect(1, 78896, '\P{inegyptianhieroglyphs}', "");
    Expect(0, 78896, '\P{^inegyptianhieroglyphs}', "");
    Expect(1, 78895, '\p{ 	In_Egyptian_Hieroglyphs}', "");
    Expect(0, 78895, '\p{^ 	In_Egyptian_Hieroglyphs}', "");
    Expect(0, 78895, '\P{ 	In_Egyptian_Hieroglyphs}', "");
    Expect(1, 78895, '\P{^ 	In_Egyptian_Hieroglyphs}', "");
    Expect(0, 78896, '\p{ 	In_Egyptian_Hieroglyphs}', "");
    Expect(1, 78896, '\p{^ 	In_Egyptian_Hieroglyphs}', "");
    Expect(1, 78896, '\P{ 	In_Egyptian_Hieroglyphs}', "");
    Expect(0, 78896, '\P{^ 	In_Egyptian_Hieroglyphs}', "");
    Error('\p{/a/-_In_egyptian_Hieroglyphs}');
    Error('\P{/a/-_In_egyptian_Hieroglyphs}');
    Expect(1, 78895, '\p{	In_Egyptian_Hieroglyphs}', "");
    Expect(0, 78895, '\p{^	In_Egyptian_Hieroglyphs}', "");
    Expect(0, 78895, '\P{	In_Egyptian_Hieroglyphs}', "");
    Expect(1, 78895, '\P{^	In_Egyptian_Hieroglyphs}', "");
    Expect(0, 78896, '\p{	In_Egyptian_Hieroglyphs}', "");
    Expect(1, 78896, '\p{^	In_Egyptian_Hieroglyphs}', "");
    Expect(1, 78896, '\P{	In_Egyptian_Hieroglyphs}', "");
    Expect(0, 78896, '\P{^	In_Egyptian_Hieroglyphs}', "");
    Error('\p{:=_-in_Elbasan}');
    Error('\P{:=_-in_Elbasan}');
    Expect(1, 66863, '\p{inelbasan}', "");
    Expect(0, 66863, '\p{^inelbasan}', "");
    Expect(0, 66863, '\P{inelbasan}', "");
    Expect(1, 66863, '\P{^inelbasan}', "");
    Expect(0, 66864, '\p{inelbasan}', "");
    Expect(1, 66864, '\p{^inelbasan}', "");
    Expect(1, 66864, '\P{inelbasan}', "");
    Expect(0, 66864, '\P{^inelbasan}', "");
    Expect(1, 66863, '\p{	 In_elbasan}', "");
    Expect(0, 66863, '\p{^	 In_elbasan}', "");
    Expect(0, 66863, '\P{	 In_elbasan}', "");
    Expect(1, 66863, '\P{^	 In_elbasan}', "");
    Expect(0, 66864, '\p{	 In_elbasan}', "");
    Expect(1, 66864, '\p{^	 In_elbasan}', "");
    Expect(1, 66864, '\P{	 In_elbasan}', "");
    Expect(0, 66864, '\P{^	 In_elbasan}', "");
    Error('\p{/a/_	IN_Elbasan}');
    Error('\P{/a/_	IN_Elbasan}');
    Expect(1, 66863, '\p{	In_Elbasan}', "");
    Expect(0, 66863, '\p{^	In_Elbasan}', "");
    Expect(0, 66863, '\P{	In_Elbasan}', "");
    Expect(1, 66863, '\P{^	In_Elbasan}', "");
    Expect(0, 66864, '\p{	In_Elbasan}', "");
    Expect(1, 66864, '\p{^	In_Elbasan}', "");
    Expect(1, 66864, '\P{	In_Elbasan}', "");
    Expect(0, 66864, '\P{^	In_Elbasan}', "");
    Error('\p{- In_elymaic/a/}');
    Error('\P{- In_elymaic/a/}');
    Expect(1, 69631, '\p{inelymaic}', "");
    Expect(0, 69631, '\p{^inelymaic}', "");
    Expect(0, 69631, '\P{inelymaic}', "");
    Expect(1, 69631, '\P{^inelymaic}', "");
    Expect(0, 69632, '\p{inelymaic}', "");
    Expect(1, 69632, '\p{^inelymaic}', "");
    Expect(1, 69632, '\P{inelymaic}', "");
    Expect(0, 69632, '\P{^inelymaic}', "");
    Expect(1, 69631, '\p{	-IN_Elymaic}', "");
    Expect(0, 69631, '\p{^	-IN_Elymaic}', "");
    Expect(0, 69631, '\P{	-IN_Elymaic}', "");
    Expect(1, 69631, '\P{^	-IN_Elymaic}', "");
    Expect(0, 69632, '\p{	-IN_Elymaic}', "");
    Expect(1, 69632, '\p{^	-IN_Elymaic}', "");
    Expect(1, 69632, '\P{	-IN_Elymaic}', "");
    Expect(0, 69632, '\P{^	-IN_Elymaic}', "");
    Error('\p{	 In_elymaic:=}');
    Error('\P{	 In_elymaic:=}');
    Expect(1, 69631, '\p{-In_elymaic}', "");
    Expect(0, 69631, '\p{^-In_elymaic}', "");
    Expect(0, 69631, '\P{-In_elymaic}', "");
    Expect(1, 69631, '\P{^-In_elymaic}', "");
    Expect(0, 69632, '\p{-In_elymaic}', "");
    Expect(1, 69632, '\p{^-In_elymaic}', "");
    Expect(1, 69632, '\P{-In_elymaic}', "");
    Expect(0, 69632, '\P{^-In_elymaic}', "");
    Error('\p{:=-_In_ethiopic}');
    Error('\P{:=-_In_ethiopic}');
    Expect(1, 4991, '\p{inethiopic}', "");
    Expect(0, 4991, '\p{^inethiopic}', "");
    Expect(0, 4991, '\P{inethiopic}', "");
    Expect(1, 4991, '\P{^inethiopic}', "");
    Expect(0, 4992, '\p{inethiopic}', "");
    Expect(1, 4992, '\p{^inethiopic}', "");
    Expect(1, 4992, '\P{inethiopic}', "");
    Expect(0, 4992, '\P{^inethiopic}', "");
    Expect(1, 4991, '\p{  IN_Ethiopic}', "");
    Expect(0, 4991, '\p{^  IN_Ethiopic}', "");
    Expect(0, 4991, '\P{  IN_Ethiopic}', "");
    Expect(1, 4991, '\P{^  IN_Ethiopic}', "");
    Expect(0, 4992, '\p{  IN_Ethiopic}', "");
    Expect(1, 4992, '\p{^  IN_Ethiopic}', "");
    Expect(1, 4992, '\P{  IN_Ethiopic}', "");
    Expect(0, 4992, '\P{^  IN_Ethiopic}', "");
    Error('\p{-/a/In_Ethiopic}');
    Error('\P{-/a/In_Ethiopic}');
    Expect(1, 4991, '\p{ _IN_Ethiopic}', "");
    Expect(0, 4991, '\p{^ _IN_Ethiopic}', "");
    Expect(0, 4991, '\P{ _IN_Ethiopic}', "");
    Expect(1, 4991, '\P{^ _IN_Ethiopic}', "");
    Expect(0, 4992, '\p{ _IN_Ethiopic}', "");
    Expect(1, 4992, '\p{^ _IN_Ethiopic}', "");
    Expect(1, 4992, '\P{ _IN_Ethiopic}', "");
    Expect(0, 4992, '\P{^ _IN_Ethiopic}', "");
    Error('\p{ :=in_Georgian}');
    Error('\P{ :=in_Georgian}');
    Expect(1, 4351, '\p{ingeorgian}', "");
    Expect(0, 4351, '\p{^ingeorgian}', "");
    Expect(0, 4351, '\P{ingeorgian}', "");
    Expect(1, 4351, '\P{^ingeorgian}', "");
    Expect(0, 4352, '\p{ingeorgian}', "");
    Expect(1, 4352, '\p{^ingeorgian}', "");
    Expect(1, 4352, '\P{ingeorgian}', "");
    Expect(0, 4352, '\P{^ingeorgian}', "");
    Expect(1, 4351, '\p{_in_Georgian}', "");
    Expect(0, 4351, '\p{^_in_Georgian}', "");
    Expect(0, 4351, '\P{_in_Georgian}', "");
    Expect(1, 4351, '\P{^_in_Georgian}', "");
    Expect(0, 4352, '\p{_in_Georgian}', "");
    Expect(1, 4352, '\p{^_in_Georgian}', "");
    Expect(1, 4352, '\P{_in_Georgian}', "");
    Expect(0, 4352, '\P{^_in_Georgian}', "");
    Error('\p{:=_IN_GEORGIAN}');
    Error('\P{:=_IN_GEORGIAN}');
    Expect(1, 4351, '\p{_In_Georgian}', "");
    Expect(0, 4351, '\p{^_In_Georgian}', "");
    Expect(0, 4351, '\P{_In_Georgian}', "");
    Expect(1, 4351, '\P{^_In_Georgian}', "");
    Expect(0, 4352, '\p{_In_Georgian}', "");
    Expect(1, 4352, '\p{^_In_Georgian}', "");
    Expect(1, 4352, '\P{_In_Georgian}', "");
    Expect(0, 4352, '\P{^_In_Georgian}', "");
    Error('\p{- in_Glagolitic:=}');
    Error('\P{- in_Glagolitic:=}');
    Expect(1, 11359, '\p{inglagolitic}', "");
    Expect(0, 11359, '\p{^inglagolitic}', "");
    Expect(0, 11359, '\P{inglagolitic}', "");
    Expect(1, 11359, '\P{^inglagolitic}', "");
    Expect(0, 11360, '\p{inglagolitic}', "");
    Expect(1, 11360, '\p{^inglagolitic}', "");
    Expect(1, 11360, '\P{inglagolitic}', "");
    Expect(0, 11360, '\P{^inglagolitic}', "");
    Expect(1, 11359, '\p{	In_Glagolitic}', "");
    Expect(0, 11359, '\p{^	In_Glagolitic}', "");
    Expect(0, 11359, '\P{	In_Glagolitic}', "");
    Expect(1, 11359, '\P{^	In_Glagolitic}', "");
    Expect(0, 11360, '\p{	In_Glagolitic}', "");
    Expect(1, 11360, '\p{^	In_Glagolitic}', "");
    Expect(1, 11360, '\P{	In_Glagolitic}', "");
    Expect(0, 11360, '\P{^	In_Glagolitic}', "");
    Error('\p{:=_in_Glagolitic}');
    Error('\P{:=_in_Glagolitic}');
    Expect(1, 11359, '\p{ In_Glagolitic}', "");
    Expect(0, 11359, '\p{^ In_Glagolitic}', "");
    Expect(0, 11359, '\P{ In_Glagolitic}', "");
    Expect(1, 11359, '\P{^ In_Glagolitic}', "");
    Expect(0, 11360, '\p{ In_Glagolitic}', "");
    Expect(1, 11360, '\p{^ In_Glagolitic}', "");
    Expect(1, 11360, '\P{ In_Glagolitic}', "");
    Expect(0, 11360, '\P{^ In_Glagolitic}', "");
    Error('\p{_/a/In_gothic}');
    Error('\P{_/a/In_gothic}');
    Expect(1, 66383, '\p{ingothic}', "");
    Expect(0, 66383, '\p{^ingothic}', "");
    Expect(0, 66383, '\P{ingothic}', "");
    Expect(1, 66383, '\P{^ingothic}', "");
    Expect(0, 66384, '\p{ingothic}', "");
    Expect(1, 66384, '\p{^ingothic}', "");
    Expect(1, 66384, '\P{ingothic}', "");
    Expect(0, 66384, '\P{^ingothic}', "");
    Expect(1, 66383, '\p{	IN_Gothic}', "");
    Expect(0, 66383, '\p{^	IN_Gothic}', "");
    Expect(0, 66383, '\P{	IN_Gothic}', "");
    Expect(1, 66383, '\P{^	IN_Gothic}', "");
    Expect(0, 66384, '\p{	IN_Gothic}', "");
    Expect(1, 66384, '\p{^	IN_Gothic}', "");
    Expect(1, 66384, '\P{	IN_Gothic}', "");
    Expect(0, 66384, '\P{^	IN_Gothic}', "");
    Error('\p{	-in_Gothic/a/}');
    Error('\P{	-in_Gothic/a/}');
    Expect(1, 66383, '\p{ _IN_Gothic}', "");
    Expect(0, 66383, '\p{^ _IN_Gothic}', "");
    Expect(0, 66383, '\P{ _IN_Gothic}', "");
    Expect(1, 66383, '\P{^ _IN_Gothic}', "");
    Expect(0, 66384, '\p{ _IN_Gothic}', "");
    Expect(1, 66384, '\p{^ _IN_Gothic}', "");
    Expect(1, 66384, '\P{ _IN_Gothic}', "");
    Expect(0, 66384, '\P{^ _IN_Gothic}', "");
    Error('\p{/a/_	In_grantha}');
    Error('\P{/a/_	In_grantha}');
    Expect(1, 70527, '\p{ingrantha}', "");
    Expect(0, 70527, '\p{^ingrantha}', "");
    Expect(0, 70527, '\P{ingrantha}', "");
    Expect(1, 70527, '\P{^ingrantha}', "");
    Expect(0, 70528, '\p{ingrantha}', "");
    Expect(1, 70528, '\p{^ingrantha}', "");
    Expect(1, 70528, '\P{ingrantha}', "");
    Expect(0, 70528, '\P{^ingrantha}', "");
    Expect(1, 70527, '\p{-_IN_grantha}', "");
    Expect(0, 70527, '\p{^-_IN_grantha}', "");
    Expect(0, 70527, '\P{-_IN_grantha}', "");
    Expect(1, 70527, '\P{^-_IN_grantha}', "");
    Expect(0, 70528, '\p{-_IN_grantha}', "");
    Expect(1, 70528, '\p{^-_IN_grantha}', "");
    Expect(1, 70528, '\P{-_IN_grantha}', "");
    Expect(0, 70528, '\P{^-_IN_grantha}', "");
    Error('\p{_	IN_Grantha:=}');
    Error('\P{_	IN_Grantha:=}');
    Expect(1, 70527, '\p{	-In_grantha}', "");
    Expect(0, 70527, '\p{^	-In_grantha}', "");
    Expect(0, 70527, '\P{	-In_grantha}', "");
    Expect(1, 70527, '\P{^	-In_grantha}', "");
    Expect(0, 70528, '\p{	-In_grantha}', "");
    Expect(1, 70528, '\p{^	-In_grantha}', "");
    Expect(1, 70528, '\P{	-In_grantha}', "");
    Expect(0, 70528, '\P{^	-In_grantha}', "");
    Error('\p{-	IN_GUJARATI:=}');
    Error('\P{-	IN_GUJARATI:=}');
    Expect(1, 2815, '\p{ingujarati}', "");
    Expect(0, 2815, '\p{^ingujarati}', "");
    Expect(0, 2815, '\P{ingujarati}', "");
    Expect(1, 2815, '\P{^ingujarati}', "");
    Expect(0, 2816, '\p{ingujarati}', "");
    Expect(1, 2816, '\p{^ingujarati}', "");
    Expect(1, 2816, '\P{ingujarati}', "");
    Expect(0, 2816, '\P{^ingujarati}', "");
    Expect(1, 2815, '\p{	_In_Gujarati}', "");
    Expect(0, 2815, '\p{^	_In_Gujarati}', "");
    Expect(0, 2815, '\P{	_In_Gujarati}', "");
    Expect(1, 2815, '\P{^	_In_Gujarati}', "");
    Expect(0, 2816, '\p{	_In_Gujarati}', "");
    Expect(1, 2816, '\p{^	_In_Gujarati}', "");
    Expect(1, 2816, '\P{	_In_Gujarati}', "");
    Expect(0, 2816, '\P{^	_In_Gujarati}', "");
    Error('\p{_in_GUJARATI/a/}');
    Error('\P{_in_GUJARATI/a/}');
    Expect(1, 2815, '\p{In_Gujarati}', "");
    Expect(0, 2815, '\p{^In_Gujarati}', "");
    Expect(0, 2815, '\P{In_Gujarati}', "");
    Expect(1, 2815, '\P{^In_Gujarati}', "");
    Expect(0, 2816, '\p{In_Gujarati}', "");
    Expect(1, 2816, '\p{^In_Gujarati}', "");
    Expect(1, 2816, '\P{In_Gujarati}', "");
    Expect(0, 2816, '\P{^In_Gujarati}', "");
    Error('\p{	/a/In_GUNJALA_GONDI}');
    Error('\P{	/a/In_GUNJALA_GONDI}');
    Expect(1, 73135, '\p{ingunjalagondi}', "");
    Expect(0, 73135, '\p{^ingunjalagondi}', "");
    Expect(0, 73135, '\P{ingunjalagondi}', "");
    Expect(1, 73135, '\P{^ingunjalagondi}', "");
    Expect(0, 73136, '\p{ingunjalagondi}', "");
    Expect(1, 73136, '\p{^ingunjalagondi}', "");
    Expect(1, 73136, '\P{ingunjalagondi}', "");
    Expect(0, 73136, '\P{^ingunjalagondi}', "");
    Expect(1, 73135, '\p{ _In_GUNJALA_gondi}', "");
    Expect(0, 73135, '\p{^ _In_GUNJALA_gondi}', "");
    Expect(0, 73135, '\P{ _In_GUNJALA_gondi}', "");
    Expect(1, 73135, '\P{^ _In_GUNJALA_gondi}', "");
    Expect(0, 73136, '\p{ _In_GUNJALA_gondi}', "");
    Expect(1, 73136, '\p{^ _In_GUNJALA_gondi}', "");
    Expect(1, 73136, '\P{ _In_GUNJALA_gondi}', "");
    Expect(0, 73136, '\P{^ _In_GUNJALA_gondi}', "");
    Error('\p{:=_-IN_Gunjala_GONDI}');
    Error('\P{:=_-IN_Gunjala_GONDI}');
    Expect(1, 73135, '\p{	 in_Gunjala_Gondi}', "");
    Expect(0, 73135, '\p{^	 in_Gunjala_Gondi}', "");
    Expect(0, 73135, '\P{	 in_Gunjala_Gondi}', "");
    Expect(1, 73135, '\P{^	 in_Gunjala_Gondi}', "");
    Expect(0, 73136, '\p{	 in_Gunjala_Gondi}', "");
    Expect(1, 73136, '\p{^	 in_Gunjala_Gondi}', "");
    Expect(1, 73136, '\P{	 in_Gunjala_Gondi}', "");
    Expect(0, 73136, '\P{^	 in_Gunjala_Gondi}', "");
    Error('\p{  in_GURMUKHI/a/}');
    Error('\P{  in_GURMUKHI/a/}');
    Expect(1, 2687, '\p{ingurmukhi}', "");
    Expect(0, 2687, '\p{^ingurmukhi}', "");
    Expect(0, 2687, '\P{ingurmukhi}', "");
    Expect(1, 2687, '\P{^ingurmukhi}', "");
    Expect(0, 2688, '\p{ingurmukhi}', "");
    Expect(1, 2688, '\p{^ingurmukhi}', "");
    Expect(1, 2688, '\P{ingurmukhi}', "");
    Expect(0, 2688, '\P{^ingurmukhi}', "");
    Expect(1, 2687, '\p{-	in_Gurmukhi}', "");
    Expect(0, 2687, '\p{^-	in_Gurmukhi}', "");
    Expect(0, 2687, '\P{-	in_Gurmukhi}', "");
    Expect(1, 2687, '\P{^-	in_Gurmukhi}', "");
    Expect(0, 2688, '\p{-	in_Gurmukhi}', "");
    Expect(1, 2688, '\p{^-	in_Gurmukhi}', "");
    Expect(1, 2688, '\P{-	in_Gurmukhi}', "");
    Expect(0, 2688, '\P{^-	in_Gurmukhi}', "");
    Error('\p{:=	 IN_gurmukhi}');
    Error('\P{:=	 IN_gurmukhi}');
    Expect(1, 2687, '\p{In_Gurmukhi}', "");
    Expect(0, 2687, '\p{^In_Gurmukhi}', "");
    Expect(0, 2687, '\P{In_Gurmukhi}', "");
    Expect(1, 2687, '\P{^In_Gurmukhi}', "");
    Expect(0, 2688, '\p{In_Gurmukhi}', "");
    Expect(1, 2688, '\p{^In_Gurmukhi}', "");
    Expect(1, 2688, '\P{In_Gurmukhi}', "");
    Expect(0, 2688, '\P{^In_Gurmukhi}', "");
    Error('\p{/a/_ IN_Hanifi_ROHINGYA}');
    Error('\P{/a/_ IN_Hanifi_ROHINGYA}');
    Expect(1, 68927, '\p{inhanifirohingya}', "");
    Expect(0, 68927, '\p{^inhanifirohingya}', "");
    Expect(0, 68927, '\P{inhanifirohingya}', "");
    Expect(1, 68927, '\P{^inhanifirohingya}', "");
    Expect(0, 68928, '\p{inhanifirohingya}', "");
    Expect(1, 68928, '\p{^inhanifirohingya}', "");
    Expect(1, 68928, '\P{inhanifirohingya}', "");
    Expect(0, 68928, '\P{^inhanifirohingya}', "");
    Expect(1, 68927, '\p{__in_hanifi_rohingya}', "");
    Expect(0, 68927, '\p{^__in_hanifi_rohingya}', "");
    Expect(0, 68927, '\P{__in_hanifi_rohingya}', "");
    Expect(1, 68927, '\P{^__in_hanifi_rohingya}', "");
    Expect(0, 68928, '\p{__in_hanifi_rohingya}', "");
    Expect(1, 68928, '\p{^__in_hanifi_rohingya}', "");
    Expect(1, 68928, '\P{__in_hanifi_rohingya}', "");
    Expect(0, 68928, '\P{^__in_hanifi_rohingya}', "");
    Error('\p{/a/- IN_Hanifi_ROHINGYA}');
    Error('\P{/a/- IN_Hanifi_ROHINGYA}');
    Expect(1, 68927, '\p{ 	IN_Hanifi_rohingya}', "");
    Expect(0, 68927, '\p{^ 	IN_Hanifi_rohingya}', "");
    Expect(0, 68927, '\P{ 	IN_Hanifi_rohingya}', "");
    Expect(1, 68927, '\P{^ 	IN_Hanifi_rohingya}', "");
    Expect(0, 68928, '\p{ 	IN_Hanifi_rohingya}', "");
    Expect(1, 68928, '\p{^ 	IN_Hanifi_rohingya}', "");
    Expect(1, 68928, '\P{ 	IN_Hanifi_rohingya}', "");
    Expect(0, 68928, '\P{^ 	IN_Hanifi_rohingya}', "");
    Error('\p{:=		in_hanunoo}');
    Error('\P{:=		in_hanunoo}');
    Expect(1, 5951, '\p{inhanunoo}', "");
    Expect(0, 5951, '\p{^inhanunoo}', "");
    Expect(0, 5951, '\P{inhanunoo}', "");
    Expect(1, 5951, '\P{^inhanunoo}', "");
    Expect(0, 5952, '\p{inhanunoo}', "");
    Expect(1, 5952, '\p{^inhanunoo}', "");
    Expect(1, 5952, '\P{inhanunoo}', "");
    Expect(0, 5952, '\P{^inhanunoo}', "");
    Expect(1, 5951, '\p{_IN_hanunoo}', "");
    Expect(0, 5951, '\p{^_IN_hanunoo}', "");
    Expect(0, 5951, '\P{_IN_hanunoo}', "");
    Expect(1, 5951, '\P{^_IN_hanunoo}', "");
    Expect(0, 5952, '\p{_IN_hanunoo}', "");
    Expect(1, 5952, '\p{^_IN_hanunoo}', "");
    Expect(1, 5952, '\P{_IN_hanunoo}', "");
    Expect(0, 5952, '\P{^_IN_hanunoo}', "");
    Error('\p{/a/ in_HANUNOO}');
    Error('\P{/a/ in_HANUNOO}');
    Expect(1, 5951, '\p{ -In_Hanunoo}', "");
    Expect(0, 5951, '\p{^ -In_Hanunoo}', "");
    Expect(0, 5951, '\P{ -In_Hanunoo}', "");
    Expect(1, 5951, '\P{^ -In_Hanunoo}', "");
    Expect(0, 5952, '\p{ -In_Hanunoo}', "");
    Expect(1, 5952, '\p{^ -In_Hanunoo}', "");
    Expect(1, 5952, '\P{ -In_Hanunoo}', "");
    Expect(0, 5952, '\P{^ -In_Hanunoo}', "");
    Error('\p{:= In_Hatran}');
    Error('\P{:= In_Hatran}');
    Expect(1, 67839, '\p{inhatran}', "");
    Expect(0, 67839, '\p{^inhatran}', "");
    Expect(0, 67839, '\P{inhatran}', "");
    Expect(1, 67839, '\P{^inhatran}', "");
    Expect(0, 67840, '\p{inhatran}', "");
    Expect(1, 67840, '\p{^inhatran}', "");
    Expect(1, 67840, '\P{inhatran}', "");
    Expect(0, 67840, '\P{^inhatran}', "");
    Expect(1, 67839, '\p{--In_hatran}', "");
    Expect(0, 67839, '\p{^--In_hatran}', "");
    Expect(0, 67839, '\P{--In_hatran}', "");
    Expect(1, 67839, '\P{^--In_hatran}', "");
    Expect(0, 67840, '\p{--In_hatran}', "");
    Expect(1, 67840, '\p{^--In_hatran}', "");
    Expect(1, 67840, '\P{--In_hatran}', "");
    Expect(0, 67840, '\P{^--In_hatran}', "");
    Error('\p{ 	in_Hatran:=}');
    Error('\P{ 	in_Hatran:=}');
    Expect(1, 67839, '\p{ -In_Hatran}', "");
    Expect(0, 67839, '\p{^ -In_Hatran}', "");
    Expect(0, 67839, '\P{ -In_Hatran}', "");
    Expect(1, 67839, '\P{^ -In_Hatran}', "");
    Expect(0, 67840, '\p{ -In_Hatran}', "");
    Expect(1, 67840, '\p{^ -In_Hatran}', "");
    Expect(1, 67840, '\P{ -In_Hatran}', "");
    Expect(0, 67840, '\P{^ -In_Hatran}', "");
    Error('\p{	/a/In_hebrew}');
    Error('\P{	/a/In_hebrew}');
    Expect(1, 1535, '\p{inhebrew}', "");
    Expect(0, 1535, '\p{^inhebrew}', "");
    Expect(0, 1535, '\P{inhebrew}', "");
    Expect(1, 1535, '\P{^inhebrew}', "");
    Expect(0, 1536, '\p{inhebrew}', "");
    Expect(1, 1536, '\p{^inhebrew}', "");
    Expect(1, 1536, '\P{inhebrew}', "");
    Expect(0, 1536, '\P{^inhebrew}', "");
    Expect(1, 1535, '\p{  IN_Hebrew}', "");
    Expect(0, 1535, '\p{^  IN_Hebrew}', "");
    Expect(0, 1535, '\P{  IN_Hebrew}', "");
    Expect(1, 1535, '\P{^  IN_Hebrew}', "");
    Expect(0, 1536, '\p{  IN_Hebrew}', "");
    Expect(1, 1536, '\p{^  IN_Hebrew}', "");
    Expect(1, 1536, '\P{  IN_Hebrew}', "");
    Expect(0, 1536, '\P{^  IN_Hebrew}', "");
    Error('\p{	_in_Hebrew/a/}');
    Error('\P{	_in_Hebrew/a/}');
    Expect(1, 1535, '\p{	in_HEBREW}', "");
    Expect(0, 1535, '\p{^	in_HEBREW}', "");
    Expect(0, 1535, '\P{	in_HEBREW}', "");
    Expect(1, 1535, '\P{^	in_HEBREW}', "");
    Expect(0, 1536, '\p{	in_HEBREW}', "");
    Expect(1, 1536, '\p{^	in_HEBREW}', "");
    Expect(1, 1536, '\P{	in_HEBREW}', "");
    Expect(0, 1536, '\P{^	in_HEBREW}', "");
    Error('\p{-IN_HIRAGANA/a/}');
    Error('\P{-IN_HIRAGANA/a/}');
    Expect(1, 12447, '\p{inhiragana}', "");
    Expect(0, 12447, '\p{^inhiragana}', "");
    Expect(0, 12447, '\P{inhiragana}', "");
    Expect(1, 12447, '\P{^inhiragana}', "");
    Expect(0, 12448, '\p{inhiragana}', "");
    Expect(1, 12448, '\p{^inhiragana}', "");
    Expect(1, 12448, '\P{inhiragana}', "");
    Expect(0, 12448, '\P{^inhiragana}', "");
    Expect(1, 12447, '\p{-In_HIRAGANA}', "");
    Expect(0, 12447, '\p{^-In_HIRAGANA}', "");
    Expect(0, 12447, '\P{-In_HIRAGANA}', "");
    Expect(1, 12447, '\P{^-In_HIRAGANA}', "");
    Expect(0, 12448, '\p{-In_HIRAGANA}', "");
    Expect(1, 12448, '\p{^-In_HIRAGANA}', "");
    Expect(1, 12448, '\P{-In_HIRAGANA}', "");
    Expect(0, 12448, '\P{^-In_HIRAGANA}', "");
    Error('\p{/a/_ in_Hiragana}');
    Error('\P{/a/_ in_Hiragana}');
    Expect(1, 12447, '\p{_ IN_Hiragana}', "");
    Expect(0, 12447, '\p{^_ IN_Hiragana}', "");
    Expect(0, 12447, '\P{_ IN_Hiragana}', "");
    Expect(1, 12447, '\P{^_ IN_Hiragana}', "");
    Expect(0, 12448, '\p{_ IN_Hiragana}', "");
    Expect(1, 12448, '\p{^_ IN_Hiragana}', "");
    Expect(1, 12448, '\P{_ IN_Hiragana}', "");
    Expect(0, 12448, '\P{^_ IN_Hiragana}', "");
    Error('\p{:=		in_IMPERIAL_Aramaic}');
    Error('\P{:=		in_IMPERIAL_Aramaic}');
    Expect(1, 67679, '\p{inimperialaramaic}', "");
    Expect(0, 67679, '\p{^inimperialaramaic}', "");
    Expect(0, 67679, '\P{inimperialaramaic}', "");
    Expect(1, 67679, '\P{^inimperialaramaic}', "");
    Expect(0, 67680, '\p{inimperialaramaic}', "");
    Expect(1, 67680, '\p{^inimperialaramaic}', "");
    Expect(1, 67680, '\P{inimperialaramaic}', "");
    Expect(0, 67680, '\P{^inimperialaramaic}', "");
    Expect(1, 67679, '\p{_In_imperial_Aramaic}', "");
    Expect(0, 67679, '\p{^_In_imperial_Aramaic}', "");
    Expect(0, 67679, '\P{_In_imperial_Aramaic}', "");
    Expect(1, 67679, '\P{^_In_imperial_Aramaic}', "");
    Expect(0, 67680, '\p{_In_imperial_Aramaic}', "");
    Expect(1, 67680, '\p{^_In_imperial_Aramaic}', "");
    Expect(1, 67680, '\P{_In_imperial_Aramaic}', "");
    Expect(0, 67680, '\P{^_In_imperial_Aramaic}', "");
    Error('\p{	_In_imperial_ARAMAIC:=}');
    Error('\P{	_In_imperial_ARAMAIC:=}');
    Expect(1, 67679, '\p{	in_Imperial_aramaic}', "");
    Expect(0, 67679, '\p{^	in_Imperial_aramaic}', "");
    Expect(0, 67679, '\P{	in_Imperial_aramaic}', "");
    Expect(1, 67679, '\P{^	in_Imperial_aramaic}', "");
    Expect(0, 67680, '\p{	in_Imperial_aramaic}', "");
    Expect(1, 67680, '\p{^	in_Imperial_aramaic}', "");
    Expect(1, 67680, '\P{	in_Imperial_aramaic}', "");
    Expect(0, 67680, '\P{^	in_Imperial_aramaic}', "");
    Error('\p{/a/	-in_Inscriptional_Pahlavi}');
    Error('\P{/a/	-in_Inscriptional_Pahlavi}');
    Expect(1, 68479, '\p{ininscriptionalpahlavi}', "");
    Expect(0, 68479, '\p{^ininscriptionalpahlavi}', "");
    Expect(0, 68479, '\P{ininscriptionalpahlavi}', "");
    Expect(1, 68479, '\P{^ininscriptionalpahlavi}', "");
    Expect(0, 68480, '\p{ininscriptionalpahlavi}', "");
    Expect(1, 68480, '\p{^ininscriptionalpahlavi}', "");
    Expect(1, 68480, '\P{ininscriptionalpahlavi}', "");
    Expect(0, 68480, '\P{^ininscriptionalpahlavi}', "");
    Expect(1, 68479, '\p{ _In_INSCRIPTIONAL_pahlavi}', "");
    Expect(0, 68479, '\p{^ _In_INSCRIPTIONAL_pahlavi}', "");
    Expect(0, 68479, '\P{ _In_INSCRIPTIONAL_pahlavi}', "");
    Expect(1, 68479, '\P{^ _In_INSCRIPTIONAL_pahlavi}', "");
    Expect(0, 68480, '\p{ _In_INSCRIPTIONAL_pahlavi}', "");
    Expect(1, 68480, '\p{^ _In_INSCRIPTIONAL_pahlavi}', "");
    Expect(1, 68480, '\P{ _In_INSCRIPTIONAL_pahlavi}', "");
    Expect(0, 68480, '\P{^ _In_INSCRIPTIONAL_pahlavi}', "");
    Error('\p{/a/__In_inscriptional_Pahlavi}');
    Error('\P{/a/__In_inscriptional_Pahlavi}');
    Expect(1, 68479, '\p{	In_Inscriptional_Pahlavi}', "");
    Expect(0, 68479, '\p{^	In_Inscriptional_Pahlavi}', "");
    Expect(0, 68479, '\P{	In_Inscriptional_Pahlavi}', "");
    Expect(1, 68479, '\P{^	In_Inscriptional_Pahlavi}', "");
    Expect(0, 68480, '\p{	In_Inscriptional_Pahlavi}', "");
    Expect(1, 68480, '\p{^	In_Inscriptional_Pahlavi}', "");
    Expect(1, 68480, '\P{	In_Inscriptional_Pahlavi}', "");
    Expect(0, 68480, '\P{^	In_Inscriptional_Pahlavi}', "");
    Error('\p{/a/ IN_inscriptional_Parthian}');
    Error('\P{/a/ IN_inscriptional_Parthian}');
    Expect(1, 68447, '\p{ininscriptionalparthian}', "");
    Expect(0, 68447, '\p{^ininscriptionalparthian}', "");
    Expect(0, 68447, '\P{ininscriptionalparthian}', "");
    Expect(1, 68447, '\P{^ininscriptionalparthian}', "");
    Expect(0, 68448, '\p{ininscriptionalparthian}', "");
    Expect(1, 68448, '\p{^ininscriptionalparthian}', "");
    Expect(1, 68448, '\P{ininscriptionalparthian}', "");
    Expect(0, 68448, '\P{^ininscriptionalparthian}', "");
    Expect(1, 68447, '\p{ _In_Inscriptional_PARTHIAN}', "");
    Expect(0, 68447, '\p{^ _In_Inscriptional_PARTHIAN}', "");
    Expect(0, 68447, '\P{ _In_Inscriptional_PARTHIAN}', "");
    Expect(1, 68447, '\P{^ _In_Inscriptional_PARTHIAN}', "");
    Expect(0, 68448, '\p{ _In_Inscriptional_PARTHIAN}', "");
    Expect(1, 68448, '\p{^ _In_Inscriptional_PARTHIAN}', "");
    Expect(1, 68448, '\P{ _In_Inscriptional_PARTHIAN}', "");
    Expect(0, 68448, '\P{^ _In_Inscriptional_PARTHIAN}', "");
    Error('\p{ /a/In_INSCRIPTIONAL_Parthian}');
    Error('\P{ /a/In_INSCRIPTIONAL_Parthian}');
    Expect(1, 68447, '\p{_in_inscriptional_parthian}', "");
    Expect(0, 68447, '\p{^_in_inscriptional_parthian}', "");
    Expect(0, 68447, '\P{_in_inscriptional_parthian}', "");
    Expect(1, 68447, '\P{^_in_inscriptional_parthian}', "");
    Expect(0, 68448, '\p{_in_inscriptional_parthian}', "");
    Expect(1, 68448, '\p{^_in_inscriptional_parthian}', "");
    Expect(1, 68448, '\P{_in_inscriptional_parthian}', "");
    Expect(0, 68448, '\P{^_in_inscriptional_parthian}', "");
    Error('\p{_/a/IN_JAVANESE}');
    Error('\P{_/a/IN_JAVANESE}');
    Expect(1, 43487, '\p{injavanese}', "");
    Expect(0, 43487, '\p{^injavanese}', "");
    Expect(0, 43487, '\P{injavanese}', "");
    Expect(1, 43487, '\P{^injavanese}', "");
    Expect(0, 43488, '\p{injavanese}', "");
    Expect(1, 43488, '\p{^injavanese}', "");
    Expect(1, 43488, '\P{injavanese}', "");
    Expect(0, 43488, '\P{^injavanese}', "");
    Expect(1, 43487, '\p{		In_javanese}', "");
    Expect(0, 43487, '\p{^		In_javanese}', "");
    Expect(0, 43487, '\P{		In_javanese}', "");
    Expect(1, 43487, '\P{^		In_javanese}', "");
    Expect(0, 43488, '\p{		In_javanese}', "");
    Expect(1, 43488, '\p{^		In_javanese}', "");
    Expect(1, 43488, '\P{		In_javanese}', "");
    Expect(0, 43488, '\P{^		In_javanese}', "");
    Error('\p{	:=In_Javanese}');
    Error('\P{	:=In_Javanese}');
    Expect(1, 43487, '\p{_in_javanese}', "");
    Expect(0, 43487, '\p{^_in_javanese}', "");
    Expect(0, 43487, '\P{_in_javanese}', "");
    Expect(1, 43487, '\P{^_in_javanese}', "");
    Expect(0, 43488, '\p{_in_javanese}', "");
    Expect(1, 43488, '\p{^_in_javanese}', "");
    Expect(1, 43488, '\P{_in_javanese}', "");
    Expect(0, 43488, '\P{^_in_javanese}', "");
    Error('\p{		IN_KAITHI:=}');
    Error('\P{		IN_KAITHI:=}');
    Expect(1, 69839, '\p{inkaithi}', "");
    Expect(0, 69839, '\p{^inkaithi}', "");
    Expect(0, 69839, '\P{inkaithi}', "");
    Expect(1, 69839, '\P{^inkaithi}', "");
    Expect(0, 69840, '\p{inkaithi}', "");
    Expect(1, 69840, '\p{^inkaithi}', "");
    Expect(1, 69840, '\P{inkaithi}', "");
    Expect(0, 69840, '\P{^inkaithi}', "");
    Expect(1, 69839, '\p{	 in_kaithi}', "");
    Expect(0, 69839, '\p{^	 in_kaithi}', "");
    Expect(0, 69839, '\P{	 in_kaithi}', "");
    Expect(1, 69839, '\P{^	 in_kaithi}', "");
    Expect(0, 69840, '\p{	 in_kaithi}', "");
    Expect(1, 69840, '\p{^	 in_kaithi}', "");
    Expect(1, 69840, '\P{	 in_kaithi}', "");
    Expect(0, 69840, '\P{^	 in_kaithi}', "");
    Error('\p{ In_Kaithi:=}');
    Error('\P{ In_Kaithi:=}');
    Expect(1, 69839, '\p{ 	IN_Kaithi}', "");
    Expect(0, 69839, '\p{^ 	IN_Kaithi}', "");
    Expect(0, 69839, '\P{ 	IN_Kaithi}', "");
    Expect(1, 69839, '\P{^ 	IN_Kaithi}', "");
    Expect(0, 69840, '\p{ 	IN_Kaithi}', "");
    Expect(1, 69840, '\p{^ 	IN_Kaithi}', "");
    Expect(1, 69840, '\P{ 	IN_Kaithi}', "");
    Expect(0, 69840, '\P{^ 	IN_Kaithi}', "");
    Error('\p{_ In_Kannada:=}');
    Error('\P{_ In_Kannada:=}');
    Expect(1, 3327, '\p{inkannada}', "");
    Expect(0, 3327, '\p{^inkannada}', "");
    Expect(0, 3327, '\P{inkannada}', "");
    Expect(1, 3327, '\P{^inkannada}', "");
    Expect(0, 3328, '\p{inkannada}', "");
    Expect(1, 3328, '\p{^inkannada}', "");
    Expect(1, 3328, '\P{inkannada}', "");
    Expect(0, 3328, '\P{^inkannada}', "");
    Expect(1, 3327, '\p{ 	In_Kannada}', "");
    Expect(0, 3327, '\p{^ 	In_Kannada}', "");
    Expect(0, 3327, '\P{ 	In_Kannada}', "");
    Expect(1, 3327, '\P{^ 	In_Kannada}', "");
    Expect(0, 3328, '\p{ 	In_Kannada}', "");
    Expect(1, 3328, '\p{^ 	In_Kannada}', "");
    Expect(1, 3328, '\P{ 	In_Kannada}', "");
    Expect(0, 3328, '\P{^ 	In_Kannada}', "");
    Error('\p{_in_Kannada:=}');
    Error('\P{_in_Kannada:=}');
    Expect(1, 3327, '\p{ _In_Kannada}', "");
    Expect(0, 3327, '\p{^ _In_Kannada}', "");
    Expect(0, 3327, '\P{ _In_Kannada}', "");
    Expect(1, 3327, '\P{^ _In_Kannada}', "");
    Expect(0, 3328, '\p{ _In_Kannada}', "");
    Expect(1, 3328, '\p{^ _In_Kannada}', "");
    Expect(1, 3328, '\P{ _In_Kannada}', "");
    Expect(0, 3328, '\P{^ _In_Kannada}', "");
    Error('\p{/a/  In_Katakana}');
    Error('\P{/a/  In_Katakana}');
    Expect(1, 12543, '\p{inkatakana}', "");
    Expect(0, 12543, '\p{^inkatakana}', "");
    Expect(0, 12543, '\P{inkatakana}', "");
    Expect(1, 12543, '\P{^inkatakana}', "");
    Expect(0, 12544, '\p{inkatakana}', "");
    Expect(1, 12544, '\p{^inkatakana}', "");
    Expect(1, 12544, '\P{inkatakana}', "");
    Expect(0, 12544, '\P{^inkatakana}', "");
    Expect(1, 12543, '\p{	_in_Katakana}', "");
    Expect(0, 12543, '\p{^	_in_Katakana}', "");
    Expect(0, 12543, '\P{	_in_Katakana}', "");
    Expect(1, 12543, '\P{^	_in_Katakana}', "");
    Expect(0, 12544, '\p{	_in_Katakana}', "");
    Expect(1, 12544, '\p{^	_in_Katakana}', "");
    Expect(1, 12544, '\P{	_in_Katakana}', "");
    Expect(0, 12544, '\P{^	_in_Katakana}', "");
    Error('\p{_	IN_Katakana:=}');
    Error('\P{_	IN_Katakana:=}');
    Expect(1, 12543, '\p{in_katakana}', "");
    Expect(0, 12543, '\p{^in_katakana}', "");
    Expect(0, 12543, '\P{in_katakana}', "");
    Expect(1, 12543, '\P{^in_katakana}', "");
    Expect(0, 12544, '\p{in_katakana}', "");
    Expect(1, 12544, '\p{^in_katakana}', "");
    Expect(1, 12544, '\P{in_katakana}', "");
    Expect(0, 12544, '\P{^in_katakana}', "");
    Error('\p{:=_ In_KAWI}');
    Error('\P{:=_ In_KAWI}');
    Expect(1, 73567, '\p{inkawi}', "");
    Expect(0, 73567, '\p{^inkawi}', "");
    Expect(0, 73567, '\P{inkawi}', "");
    Expect(1, 73567, '\P{^inkawi}', "");
    Expect(0, 73568, '\p{inkawi}', "");
    Expect(1, 73568, '\p{^inkawi}', "");
    Expect(1, 73568, '\P{inkawi}', "");
    Expect(0, 73568, '\P{^inkawi}', "");
    Expect(1, 73567, '\p{-IN_KAWI}', "");
    Expect(0, 73567, '\p{^-IN_KAWI}', "");
    Expect(0, 73567, '\P{-IN_KAWI}', "");
    Expect(1, 73567, '\P{^-IN_KAWI}', "");
    Expect(0, 73568, '\p{-IN_KAWI}', "");
    Expect(1, 73568, '\p{^-IN_KAWI}', "");
    Expect(1, 73568, '\P{-IN_KAWI}', "");
    Expect(0, 73568, '\P{^-IN_KAWI}', "");
    Error('\p{:=-_In_KAWI}');
    Error('\P{:=-_In_KAWI}');
    Expect(1, 73567, '\p{- in_KAWI}', "");
    Expect(0, 73567, '\p{^- in_KAWI}', "");
    Expect(0, 73567, '\P{- in_KAWI}', "");
    Expect(1, 73567, '\P{^- in_KAWI}', "");
    Expect(0, 73568, '\p{- in_KAWI}', "");
    Expect(1, 73568, '\p{^- in_KAWI}', "");
    Expect(1, 73568, '\P{- in_KAWI}', "");
    Expect(0, 73568, '\P{^- in_KAWI}', "");
    Error('\p{--In_Kayah_li:=}');
    Error('\P{--In_Kayah_li:=}');
    Expect(1, 43311, '\p{inkayahli}', "");
    Expect(0, 43311, '\p{^inkayahli}', "");
    Expect(0, 43311, '\P{inkayahli}', "");
    Expect(1, 43311, '\P{^inkayahli}', "");
    Expect(0, 43312, '\p{inkayahli}', "");
    Expect(1, 43312, '\p{^inkayahli}', "");
    Expect(1, 43312, '\P{inkayahli}', "");
    Expect(0, 43312, '\P{^inkayahli}', "");
    Expect(1, 43311, '\p{-In_KAYAH_Li}', "");
    Expect(0, 43311, '\p{^-In_KAYAH_Li}', "");
    Expect(0, 43311, '\P{-In_KAYAH_Li}', "");
    Expect(1, 43311, '\P{^-In_KAYAH_Li}', "");
    Expect(0, 43312, '\p{-In_KAYAH_Li}', "");
    Expect(1, 43312, '\p{^-In_KAYAH_Li}', "");
    Expect(1, 43312, '\P{-In_KAYAH_Li}', "");
    Expect(0, 43312, '\P{^-In_KAYAH_Li}', "");
    Error('\p{ :=in_KAYAH_Li}');
    Error('\P{ :=in_KAYAH_Li}');
    Expect(1, 43311, '\p{-_In_kayah_Li}', "");
    Expect(0, 43311, '\p{^-_In_kayah_Li}', "");
    Expect(0, 43311, '\P{-_In_kayah_Li}', "");
    Expect(1, 43311, '\P{^-_In_kayah_Li}', "");
    Expect(0, 43312, '\p{-_In_kayah_Li}', "");
    Expect(1, 43312, '\p{^-_In_kayah_Li}', "");
    Expect(1, 43312, '\P{-_In_kayah_Li}', "");
    Expect(0, 43312, '\P{^-_In_kayah_Li}', "");
    Error('\p{	in_Kharoshthi/a/}');
    Error('\P{	in_Kharoshthi/a/}');
    Expect(1, 68191, '\p{inkharoshthi}', "");
    Expect(0, 68191, '\p{^inkharoshthi}', "");
    Expect(0, 68191, '\P{inkharoshthi}', "");
    Expect(1, 68191, '\P{^inkharoshthi}', "");
    Expect(0, 68192, '\p{inkharoshthi}', "");
    Expect(1, 68192, '\p{^inkharoshthi}', "");
    Expect(1, 68192, '\P{inkharoshthi}', "");
    Expect(0, 68192, '\P{^inkharoshthi}', "");
    Expect(1, 68191, '\p{_ in_Kharoshthi}', "");
    Expect(0, 68191, '\p{^_ in_Kharoshthi}', "");
    Expect(0, 68191, '\P{_ in_Kharoshthi}', "");
    Expect(1, 68191, '\P{^_ in_Kharoshthi}', "");
    Expect(0, 68192, '\p{_ in_Kharoshthi}', "");
    Expect(1, 68192, '\p{^_ in_Kharoshthi}', "");
    Expect(1, 68192, '\P{_ in_Kharoshthi}', "");
    Expect(0, 68192, '\P{^_ in_Kharoshthi}', "");
    Error('\p{:=_	In_KHAROSHTHI}');
    Error('\P{:=_	In_KHAROSHTHI}');
    Expect(1, 68191, '\p{ 	IN_Kharoshthi}', "");
    Expect(0, 68191, '\p{^ 	IN_Kharoshthi}', "");
    Expect(0, 68191, '\P{ 	IN_Kharoshthi}', "");
    Expect(1, 68191, '\P{^ 	IN_Kharoshthi}', "");
    Expect(0, 68192, '\p{ 	IN_Kharoshthi}', "");
    Expect(1, 68192, '\p{^ 	IN_Kharoshthi}', "");
    Expect(1, 68192, '\P{ 	IN_Kharoshthi}', "");
    Expect(0, 68192, '\P{^ 	IN_Kharoshthi}', "");
    Error('\p{:=	-In_Khitan_small_Script}');
    Error('\P{:=	-In_Khitan_small_Script}');
    Expect(1, 101631, '\p{inkhitansmallscript}', "");
    Expect(0, 101631, '\p{^inkhitansmallscript}', "");
    Expect(0, 101631, '\P{inkhitansmallscript}', "");
    Expect(1, 101631, '\P{^inkhitansmallscript}', "");
    Expect(0, 101632, '\p{inkhitansmallscript}', "");
    Expect(1, 101632, '\p{^inkhitansmallscript}', "");
    Expect(1, 101632, '\P{inkhitansmallscript}', "");
    Expect(0, 101632, '\P{^inkhitansmallscript}', "");
    Expect(1, 101631, '\p{_In_khitan_small_script}', "");
    Expect(0, 101631, '\p{^_In_khitan_small_script}', "");
    Expect(0, 101631, '\P{_In_khitan_small_script}', "");
    Expect(1, 101631, '\P{^_In_khitan_small_script}', "");
    Expect(0, 101632, '\p{_In_khitan_small_script}', "");
    Expect(1, 101632, '\p{^_In_khitan_small_script}', "");
    Expect(1, 101632, '\P{_In_khitan_small_script}', "");
    Expect(0, 101632, '\P{^_In_khitan_small_script}', "");
    Error('\p{_/a/IN_Khitan_Small_Script}');
    Error('\P{_/a/IN_Khitan_Small_Script}');
    Expect(1, 101631, '\p{_IN_Khitan_Small_Script}', "");
    Expect(0, 101631, '\p{^_IN_Khitan_Small_Script}', "");
    Expect(0, 101631, '\P{_IN_Khitan_Small_Script}', "");
    Expect(1, 101631, '\P{^_IN_Khitan_Small_Script}', "");
    Expect(0, 101632, '\p{_IN_Khitan_Small_Script}', "");
    Expect(1, 101632, '\p{^_IN_Khitan_Small_Script}', "");
    Expect(1, 101632, '\P{_IN_Khitan_Small_Script}', "");
    Expect(0, 101632, '\P{^_IN_Khitan_Small_Script}', "");
    Error('\p{ /a/in_KHMER}');
    Error('\P{ /a/in_KHMER}');
    Expect(1, 6143, '\p{inkhmer}', "");
    Expect(0, 6143, '\p{^inkhmer}', "");
    Expect(0, 6143, '\P{inkhmer}', "");
    Expect(1, 6143, '\P{^inkhmer}', "");
    Expect(0, 6144, '\p{inkhmer}', "");
    Expect(1, 6144, '\p{^inkhmer}', "");
    Expect(1, 6144, '\P{inkhmer}', "");
    Expect(0, 6144, '\P{^inkhmer}', "");
    Expect(1, 6143, '\p{		In_KHMER}', "");
    Expect(0, 6143, '\p{^		In_KHMER}', "");
    Expect(0, 6143, '\P{		In_KHMER}', "");
    Expect(1, 6143, '\P{^		In_KHMER}', "");
    Expect(0, 6144, '\p{		In_KHMER}', "");
    Expect(1, 6144, '\p{^		In_KHMER}', "");
    Expect(1, 6144, '\P{		In_KHMER}', "");
    Expect(0, 6144, '\P{^		In_KHMER}', "");
    Error('\p{ _In_Khmer/a/}');
    Error('\P{ _In_Khmer/a/}');
    Expect(1, 6143, '\p{	-In_Khmer}', "");
    Expect(0, 6143, '\p{^	-In_Khmer}', "");
    Expect(0, 6143, '\P{	-In_Khmer}', "");
    Expect(1, 6143, '\P{^	-In_Khmer}', "");
    Expect(0, 6144, '\p{	-In_Khmer}', "");
    Expect(1, 6144, '\p{^	-In_Khmer}', "");
    Expect(1, 6144, '\P{	-In_Khmer}', "");
    Expect(0, 6144, '\P{^	-In_Khmer}', "");
    Error('\p{_	In_KHOJKI:=}');
    Error('\P{_	In_KHOJKI:=}');
    Expect(1, 70223, '\p{inkhojki}', "");
    Expect(0, 70223, '\p{^inkhojki}', "");
    Expect(0, 70223, '\P{inkhojki}', "");
    Expect(1, 70223, '\P{^inkhojki}', "");
    Expect(0, 70224, '\p{inkhojki}', "");
    Expect(1, 70224, '\p{^inkhojki}', "");
    Expect(1, 70224, '\P{inkhojki}', "");
    Expect(0, 70224, '\P{^inkhojki}', "");
    Expect(1, 70223, '\p{_	In_KHOJKI}', "");
    Expect(0, 70223, '\p{^_	In_KHOJKI}', "");
    Expect(0, 70223, '\P{_	In_KHOJKI}', "");
    Expect(1, 70223, '\P{^_	In_KHOJKI}', "");
    Expect(0, 70224, '\p{_	In_KHOJKI}', "");
    Expect(1, 70224, '\p{^_	In_KHOJKI}', "");
    Expect(1, 70224, '\P{_	In_KHOJKI}', "");
    Expect(0, 70224, '\P{^_	In_KHOJKI}', "");
    Error('\p{:=In_Khojki}');
    Error('\P{:=In_Khojki}');
    Expect(1, 70223, '\p{- IN_Khojki}', "");
    Expect(0, 70223, '\p{^- IN_Khojki}', "");
    Expect(0, 70223, '\P{- IN_Khojki}', "");
    Expect(1, 70223, '\P{^- IN_Khojki}', "");
    Expect(0, 70224, '\p{- IN_Khojki}', "");
    Expect(1, 70224, '\p{^- IN_Khojki}', "");
    Expect(1, 70224, '\P{- IN_Khojki}', "");
    Expect(0, 70224, '\P{^- IN_Khojki}', "");
    Error('\p{/a/_In_KHUDAWADI}');
    Error('\P{/a/_In_KHUDAWADI}');
    Expect(1, 70399, '\p{inkhudawadi}', "");
    Expect(0, 70399, '\p{^inkhudawadi}', "");
    Expect(0, 70399, '\P{inkhudawadi}', "");
    Expect(1, 70399, '\P{^inkhudawadi}', "");
    Expect(0, 70400, '\p{inkhudawadi}', "");
    Expect(1, 70400, '\p{^inkhudawadi}', "");
    Expect(1, 70400, '\P{inkhudawadi}', "");
    Expect(0, 70400, '\P{^inkhudawadi}', "");
    Expect(1, 70399, '\p{	_In_Khudawadi}', "");
    Expect(0, 70399, '\p{^	_In_Khudawadi}', "");
    Expect(0, 70399, '\P{	_In_Khudawadi}', "");
    Expect(1, 70399, '\P{^	_In_Khudawadi}', "");
    Expect(0, 70400, '\p{	_In_Khudawadi}', "");
    Expect(1, 70400, '\p{^	_In_Khudawadi}', "");
    Expect(1, 70400, '\P{	_In_Khudawadi}', "");
    Expect(0, 70400, '\P{^	_In_Khudawadi}', "");
    Error('\p{_-in_Khudawadi:=}');
    Error('\P{_-in_Khudawadi:=}');
    Expect(1, 70399, '\p{__in_Khudawadi}', "");
    Expect(0, 70399, '\p{^__in_Khudawadi}', "");
    Expect(0, 70399, '\P{__in_Khudawadi}', "");
    Expect(1, 70399, '\P{^__in_Khudawadi}', "");
    Expect(0, 70400, '\p{__in_Khudawadi}', "");
    Expect(1, 70400, '\p{^__in_Khudawadi}', "");
    Expect(1, 70400, '\P{__in_Khudawadi}', "");
    Expect(0, 70400, '\P{^__in_Khudawadi}', "");
    Error('\p{/a/ _In_lao}');
    Error('\P{/a/ _In_lao}');
    Expect(1, 3839, '\p{inlao}', "");
    Expect(0, 3839, '\p{^inlao}', "");
    Expect(0, 3839, '\P{inlao}', "");
    Expect(1, 3839, '\P{^inlao}', "");
    Expect(0, 3840, '\p{inlao}', "");
    Expect(1, 3840, '\p{^inlao}', "");
    Expect(1, 3840, '\P{inlao}', "");
    Expect(0, 3840, '\P{^inlao}', "");
    Expect(1, 3839, '\p{ in_lao}', "");
    Expect(0, 3839, '\p{^ in_lao}', "");
    Expect(0, 3839, '\P{ in_lao}', "");
    Expect(1, 3839, '\P{^ in_lao}', "");
    Expect(0, 3840, '\p{ in_lao}', "");
    Expect(1, 3840, '\p{^ in_lao}', "");
    Expect(1, 3840, '\P{ in_lao}', "");
    Expect(0, 3840, '\P{^ in_lao}', "");
    Error('\p{/a/	in_Lao}');
    Error('\P{/a/	in_Lao}');
    Expect(1, 3839, '\p{- in_Lao}', "");
    Expect(0, 3839, '\p{^- in_Lao}', "");
    Expect(0, 3839, '\P{- in_Lao}', "");
    Expect(1, 3839, '\P{^- in_Lao}', "");
    Expect(0, 3840, '\p{- in_Lao}', "");
    Expect(1, 3840, '\p{^- in_Lao}', "");
    Expect(1, 3840, '\P{- in_Lao}', "");
    Expect(0, 3840, '\P{^- in_Lao}', "");
    Error('\p{		in_Lepcha/a/}');
    Error('\P{		in_Lepcha/a/}');
    Expect(1, 7247, '\p{inlepcha}', "");
    Expect(0, 7247, '\p{^inlepcha}', "");
    Expect(0, 7247, '\P{inlepcha}', "");
    Expect(1, 7247, '\P{^inlepcha}', "");
    Expect(0, 7248, '\p{inlepcha}', "");
    Expect(1, 7248, '\p{^inlepcha}', "");
    Expect(1, 7248, '\P{inlepcha}', "");
    Expect(0, 7248, '\P{^inlepcha}', "");
    Expect(1, 7247, '\p{__in_Lepcha}', "");
    Expect(0, 7247, '\p{^__in_Lepcha}', "");
    Expect(0, 7247, '\P{__in_Lepcha}', "");
    Expect(1, 7247, '\P{^__in_Lepcha}', "");
    Expect(0, 7248, '\p{__in_Lepcha}', "");
    Expect(1, 7248, '\p{^__in_Lepcha}', "");
    Expect(1, 7248, '\P{__in_Lepcha}', "");
    Expect(0, 7248, '\P{^__in_Lepcha}', "");
    Error('\p{	:=In_LEPCHA}');
    Error('\P{	:=In_LEPCHA}');
    Expect(1, 7247, '\p{-IN_Lepcha}', "");
    Expect(0, 7247, '\p{^-IN_Lepcha}', "");
    Expect(0, 7247, '\P{-IN_Lepcha}', "");
    Expect(1, 7247, '\P{^-IN_Lepcha}', "");
    Expect(0, 7248, '\p{-IN_Lepcha}', "");
    Expect(1, 7248, '\p{^-IN_Lepcha}', "");
    Expect(1, 7248, '\P{-IN_Lepcha}', "");
    Expect(0, 7248, '\P{^-IN_Lepcha}', "");
    Error('\p{:= 	In_limbu}');
    Error('\P{:= 	In_limbu}');
    Expect(1, 6479, '\p{inlimbu}', "");
    Expect(0, 6479, '\p{^inlimbu}', "");
    Expect(0, 6479, '\P{inlimbu}', "");
    Expect(1, 6479, '\P{^inlimbu}', "");
    Expect(0, 6480, '\p{inlimbu}', "");
    Expect(1, 6480, '\p{^inlimbu}', "");
    Expect(1, 6480, '\P{inlimbu}', "");
    Expect(0, 6480, '\P{^inlimbu}', "");
    Expect(1, 6479, '\p{-IN_Limbu}', "");
    Expect(0, 6479, '\p{^-IN_Limbu}', "");
    Expect(0, 6479, '\P{-IN_Limbu}', "");
    Expect(1, 6479, '\P{^-IN_Limbu}', "");
    Expect(0, 6480, '\p{-IN_Limbu}', "");
    Expect(1, 6480, '\p{^-IN_Limbu}', "");
    Expect(1, 6480, '\P{-IN_Limbu}', "");
    Expect(0, 6480, '\P{^-IN_Limbu}', "");
    Error('\p{-In_Limbu/a/}');
    Error('\P{-In_Limbu/a/}');
    Expect(1, 6479, '\p{_In_Limbu}', "");
    Expect(0, 6479, '\p{^_In_Limbu}', "");
    Expect(0, 6479, '\P{_In_Limbu}', "");
    Expect(1, 6479, '\P{^_In_Limbu}', "");
    Expect(0, 6480, '\p{_In_Limbu}', "");
    Expect(1, 6480, '\p{^_In_Limbu}', "");
    Expect(1, 6480, '\P{_In_Limbu}', "");
    Expect(0, 6480, '\P{^_In_Limbu}', "");
    Error('\p{-/a/in_Linear_a}');
    Error('\P{-/a/in_Linear_a}');
    Expect(1, 67455, '\p{inlineara}', "");
    Expect(0, 67455, '\p{^inlineara}', "");
    Expect(0, 67455, '\P{inlineara}', "");
    Expect(1, 67455, '\P{^inlineara}', "");
    Expect(0, 67456, '\p{inlineara}', "");
    Expect(1, 67456, '\p{^inlineara}', "");
    Expect(1, 67456, '\P{inlineara}', "");
    Expect(0, 67456, '\P{^inlineara}', "");
    Expect(1, 67455, '\p{_In_linear_A}', "");
    Expect(0, 67455, '\p{^_In_linear_A}', "");
    Expect(0, 67455, '\P{_In_linear_A}', "");
    Expect(1, 67455, '\P{^_In_linear_A}', "");
    Expect(0, 67456, '\p{_In_linear_A}', "");
    Expect(1, 67456, '\p{^_In_linear_A}', "");
    Expect(1, 67456, '\P{_In_linear_A}', "");
    Expect(0, 67456, '\P{^_In_linear_A}', "");
    Error('\p{- In_Linear_a/a/}');
    Error('\P{- In_Linear_a/a/}');
    Expect(1, 67455, '\p{--In_linear_A}', "");
    Expect(0, 67455, '\p{^--In_linear_A}', "");
    Expect(0, 67455, '\P{--In_linear_A}', "");
    Expect(1, 67455, '\P{^--In_linear_A}', "");
    Expect(0, 67456, '\p{--In_linear_A}', "");
    Expect(1, 67456, '\p{^--In_linear_A}', "");
    Expect(1, 67456, '\P{--In_linear_A}', "");
    Expect(0, 67456, '\P{^--In_linear_A}', "");
    Error('\p{-:=In_lisu}');
    Error('\P{-:=In_lisu}');
    Expect(1, 42239, '\p{inlisu}', "");
    Expect(0, 42239, '\p{^inlisu}', "");
    Expect(0, 42239, '\P{inlisu}', "");
    Expect(1, 42239, '\P{^inlisu}', "");
    Expect(0, 42240, '\p{inlisu}', "");
    Expect(1, 42240, '\p{^inlisu}', "");
    Expect(1, 42240, '\P{inlisu}', "");
    Expect(0, 42240, '\P{^inlisu}', "");
    Expect(1, 42239, '\p{-	In_lisu}', "");
    Expect(0, 42239, '\p{^-	In_lisu}', "");
    Expect(0, 42239, '\P{-	In_lisu}', "");
    Expect(1, 42239, '\P{^-	In_lisu}', "");
    Expect(0, 42240, '\p{-	In_lisu}', "");
    Expect(1, 42240, '\p{^-	In_lisu}', "");
    Expect(1, 42240, '\P{-	In_lisu}', "");
    Expect(0, 42240, '\P{^-	In_lisu}', "");
    Error('\p{-/a/in_LISU}');
    Error('\P{-/a/in_LISU}');
    Expect(1, 42239, '\p{- IN_Lisu}', "");
    Expect(0, 42239, '\p{^- IN_Lisu}', "");
    Expect(0, 42239, '\P{- IN_Lisu}', "");
    Expect(1, 42239, '\P{^- IN_Lisu}', "");
    Expect(0, 42240, '\p{- IN_Lisu}', "");
    Expect(1, 42240, '\p{^- IN_Lisu}', "");
    Expect(1, 42240, '\P{- IN_Lisu}', "");
    Expect(0, 42240, '\P{^- IN_Lisu}', "");
    Error('\p{/a/--In_lycian}');
    Error('\P{/a/--In_lycian}');
    Expect(1, 66207, '\p{inlycian}', "");
    Expect(0, 66207, '\p{^inlycian}', "");
    Expect(0, 66207, '\P{inlycian}', "");
    Expect(1, 66207, '\P{^inlycian}', "");
    Expect(0, 66208, '\p{inlycian}', "");
    Expect(1, 66208, '\p{^inlycian}', "");
    Expect(1, 66208, '\P{inlycian}', "");
    Expect(0, 66208, '\P{^inlycian}', "");
    Expect(1, 66207, '\p{	In_lycian}', "");
    Expect(0, 66207, '\p{^	In_lycian}', "");
    Expect(0, 66207, '\P{	In_lycian}', "");
    Expect(1, 66207, '\P{^	In_lycian}', "");
    Expect(0, 66208, '\p{	In_lycian}', "");
    Expect(1, 66208, '\p{^	In_lycian}', "");
    Expect(1, 66208, '\P{	In_lycian}', "");
    Expect(0, 66208, '\P{^	In_lycian}', "");
    Error('\p{-/a/in_Lycian}');
    Error('\P{-/a/in_Lycian}');
    Expect(1, 66207, '\p{	_In_Lycian}', "");
    Expect(0, 66207, '\p{^	_In_Lycian}', "");
    Expect(0, 66207, '\P{	_In_Lycian}', "");
    Expect(1, 66207, '\P{^	_In_Lycian}', "");
    Expect(0, 66208, '\p{	_In_Lycian}', "");
    Expect(1, 66208, '\p{^	_In_Lycian}', "");
    Expect(1, 66208, '\P{	_In_Lycian}', "");
    Expect(0, 66208, '\P{^	_In_Lycian}', "");
    Error('\p{/a/In_lydian}');
    Error('\P{/a/In_lydian}');
    Expect(1, 67903, '\p{inlydian}', "");
    Expect(0, 67903, '\p{^inlydian}', "");
    Expect(0, 67903, '\P{inlydian}', "");
    Expect(1, 67903, '\P{^inlydian}', "");
    Expect(0, 67904, '\p{inlydian}', "");
    Expect(1, 67904, '\p{^inlydian}', "");
    Expect(1, 67904, '\P{inlydian}', "");
    Expect(0, 67904, '\P{^inlydian}', "");
    Expect(1, 67903, '\p{_IN_lydian}', "");
    Expect(0, 67903, '\p{^_IN_lydian}', "");
    Expect(0, 67903, '\P{_IN_lydian}', "");
    Expect(1, 67903, '\P{^_IN_lydian}', "");
    Expect(0, 67904, '\p{_IN_lydian}', "");
    Expect(1, 67904, '\p{^_IN_lydian}', "");
    Expect(1, 67904, '\P{_IN_lydian}', "");
    Expect(0, 67904, '\P{^_IN_lydian}', "");
    Error('\p{/a/_	in_LYDIAN}');
    Error('\P{/a/_	in_LYDIAN}');
    Expect(1, 67903, '\p{_ In_Lydian}', "");
    Expect(0, 67903, '\p{^_ In_Lydian}', "");
    Expect(0, 67903, '\P{_ In_Lydian}', "");
    Expect(1, 67903, '\P{^_ In_Lydian}', "");
    Expect(0, 67904, '\p{_ In_Lydian}', "");
    Expect(1, 67904, '\p{^_ In_Lydian}', "");
    Expect(1, 67904, '\P{_ In_Lydian}', "");
    Expect(0, 67904, '\P{^_ In_Lydian}', "");
    Error('\p{/a/	_In_Mahajani}');
    Error('\P{/a/	_In_Mahajani}');
    Expect(1, 70015, '\p{inmahajani}', "");
    Expect(0, 70015, '\p{^inmahajani}', "");
    Expect(0, 70015, '\P{inmahajani}', "");
    Expect(1, 70015, '\P{^inmahajani}', "");
    Expect(0, 70016, '\p{inmahajani}', "");
    Expect(1, 70016, '\p{^inmahajani}', "");
    Expect(1, 70016, '\P{inmahajani}', "");
    Expect(0, 70016, '\P{^inmahajani}', "");
    Expect(1, 70015, '\p{-	in_MAHAJANI}', "");
    Expect(0, 70015, '\p{^-	in_MAHAJANI}', "");
    Expect(0, 70015, '\P{-	in_MAHAJANI}', "");
    Expect(1, 70015, '\P{^-	in_MAHAJANI}', "");
    Expect(0, 70016, '\p{-	in_MAHAJANI}', "");
    Expect(1, 70016, '\p{^-	in_MAHAJANI}', "");
    Expect(1, 70016, '\P{-	in_MAHAJANI}', "");
    Expect(0, 70016, '\P{^-	in_MAHAJANI}', "");
    Error('\p{/a/IN_MAHAJANI}');
    Error('\P{/a/IN_MAHAJANI}');
    Expect(1, 70015, '\p{_In_MAHAJANI}', "");
    Expect(0, 70015, '\p{^_In_MAHAJANI}', "");
    Expect(0, 70015, '\P{_In_MAHAJANI}', "");
    Expect(1, 70015, '\P{^_In_MAHAJANI}', "");
    Expect(0, 70016, '\p{_In_MAHAJANI}', "");
    Expect(1, 70016, '\p{^_In_MAHAJANI}', "");
    Expect(1, 70016, '\P{_In_MAHAJANI}', "");
    Expect(0, 70016, '\P{^_In_MAHAJANI}', "");
    Error('\p{/a/_In_MAKASAR}');
    Error('\P{/a/_In_MAKASAR}');
    Expect(1, 73471, '\p{inmakasar}', "");
    Expect(0, 73471, '\p{^inmakasar}', "");
    Expect(0, 73471, '\P{inmakasar}', "");
    Expect(1, 73471, '\P{^inmakasar}', "");
    Expect(0, 73472, '\p{inmakasar}', "");
    Expect(1, 73472, '\p{^inmakasar}', "");
    Expect(1, 73472, '\P{inmakasar}', "");
    Expect(0, 73472, '\P{^inmakasar}', "");
    Expect(1, 73471, '\p{ _In_MAKASAR}', "");
    Expect(0, 73471, '\p{^ _In_MAKASAR}', "");
    Expect(0, 73471, '\P{ _In_MAKASAR}', "");
    Expect(1, 73471, '\P{^ _In_MAKASAR}', "");
    Expect(0, 73472, '\p{ _In_MAKASAR}', "");
    Expect(1, 73472, '\p{^ _In_MAKASAR}', "");
    Expect(1, 73472, '\P{ _In_MAKASAR}', "");
    Expect(0, 73472, '\P{^ _In_MAKASAR}', "");
    Error('\p{:= IN_Makasar}');
    Error('\P{:= IN_Makasar}');
    Expect(1, 73471, '\p{In_MAKASAR}', "");
    Expect(0, 73471, '\p{^In_MAKASAR}', "");
    Expect(0, 73471, '\P{In_MAKASAR}', "");
    Expect(1, 73471, '\P{^In_MAKASAR}', "");
    Expect(0, 73472, '\p{In_MAKASAR}', "");
    Expect(1, 73472, '\p{^In_MAKASAR}', "");
    Expect(1, 73472, '\P{In_MAKASAR}', "");
    Expect(0, 73472, '\P{^In_MAKASAR}', "");
    Error('\p{_ in_malayalam:=}');
    Error('\P{_ in_malayalam:=}');
    Expect(1, 3455, '\p{inmalayalam}', "");
    Expect(0, 3455, '\p{^inmalayalam}', "");
    Expect(0, 3455, '\P{inmalayalam}', "");
    Expect(1, 3455, '\P{^inmalayalam}', "");
    Expect(0, 3456, '\p{inmalayalam}', "");
    Expect(1, 3456, '\p{^inmalayalam}', "");
    Expect(1, 3456, '\P{inmalayalam}', "");
    Expect(0, 3456, '\P{^inmalayalam}', "");
    Expect(1, 3455, '\p{-In_MALAYALAM}', "");
    Expect(0, 3455, '\p{^-In_MALAYALAM}', "");
    Expect(0, 3455, '\P{-In_MALAYALAM}', "");
    Expect(1, 3455, '\P{^-In_MALAYALAM}', "");
    Expect(0, 3456, '\p{-In_MALAYALAM}', "");
    Expect(1, 3456, '\p{^-In_MALAYALAM}', "");
    Expect(1, 3456, '\P{-In_MALAYALAM}', "");
    Expect(0, 3456, '\P{^-In_MALAYALAM}', "");
    Error('\p{/a/- in_Malayalam}');
    Error('\P{/a/- in_Malayalam}');
    Expect(1, 3455, '\p{--in_Malayalam}', "");
    Expect(0, 3455, '\p{^--in_Malayalam}', "");
    Expect(0, 3455, '\P{--in_Malayalam}', "");
    Expect(1, 3455, '\P{^--in_Malayalam}', "");
    Expect(0, 3456, '\p{--in_Malayalam}', "");
    Expect(1, 3456, '\p{^--in_Malayalam}', "");
    Expect(1, 3456, '\P{--in_Malayalam}', "");
    Expect(0, 3456, '\P{^--in_Malayalam}', "");
    Error('\p{:=- In_Mandaic}');
    Error('\P{:=- In_Mandaic}');
    Expect(1, 2143, '\p{inmandaic}', "");
    Expect(0, 2143, '\p{^inmandaic}', "");
    Expect(0, 2143, '\P{inmandaic}', "");
    Expect(1, 2143, '\P{^inmandaic}', "");
    Expect(0, 2144, '\p{inmandaic}', "");
    Expect(1, 2144, '\p{^inmandaic}', "");
    Expect(1, 2144, '\P{inmandaic}', "");
    Expect(0, 2144, '\P{^inmandaic}', "");
    Expect(1, 2143, '\p{-	IN_Mandaic}', "");
    Expect(0, 2143, '\p{^-	IN_Mandaic}', "");
    Expect(0, 2143, '\P{-	IN_Mandaic}', "");
    Expect(1, 2143, '\P{^-	IN_Mandaic}', "");
    Expect(0, 2144, '\p{-	IN_Mandaic}', "");
    Expect(1, 2144, '\p{^-	IN_Mandaic}', "");
    Expect(1, 2144, '\P{-	IN_Mandaic}', "");
    Expect(0, 2144, '\P{^-	IN_Mandaic}', "");
    Error('\p{ In_Mandaic:=}');
    Error('\P{ In_Mandaic:=}');
    Expect(1, 2143, '\p{ _in_MANDAIC}', "");
    Expect(0, 2143, '\p{^ _in_MANDAIC}', "");
    Expect(0, 2143, '\P{ _in_MANDAIC}', "");
    Expect(1, 2143, '\P{^ _in_MANDAIC}', "");
    Expect(0, 2144, '\p{ _in_MANDAIC}', "");
    Expect(1, 2144, '\p{^ _in_MANDAIC}', "");
    Expect(1, 2144, '\P{ _in_MANDAIC}', "");
    Expect(0, 2144, '\P{^ _in_MANDAIC}', "");
    Error('\p{:=In_MANICHAEAN}');
    Error('\P{:=In_MANICHAEAN}');
    Expect(1, 68351, '\p{inmanichaean}', "");
    Expect(0, 68351, '\p{^inmanichaean}', "");
    Expect(0, 68351, '\P{inmanichaean}', "");
    Expect(1, 68351, '\P{^inmanichaean}', "");
    Expect(0, 68352, '\p{inmanichaean}', "");
    Expect(1, 68352, '\p{^inmanichaean}', "");
    Expect(1, 68352, '\P{inmanichaean}', "");
    Expect(0, 68352, '\P{^inmanichaean}', "");
    Expect(1, 68351, '\p{ IN_Manichaean}', "");
    Expect(0, 68351, '\p{^ IN_Manichaean}', "");
    Expect(0, 68351, '\P{ IN_Manichaean}', "");
    Expect(1, 68351, '\P{^ IN_Manichaean}', "");
    Expect(0, 68352, '\p{ IN_Manichaean}', "");
    Expect(1, 68352, '\p{^ IN_Manichaean}', "");
    Expect(1, 68352, '\P{ IN_Manichaean}', "");
    Expect(0, 68352, '\P{^ IN_Manichaean}', "");
    Error('\p{ :=in_Manichaean}');
    Error('\P{ :=in_Manichaean}');
    Expect(1, 68351, '\p{ 	IN_Manichaean}', "");
    Expect(0, 68351, '\p{^ 	IN_Manichaean}', "");
    Expect(0, 68351, '\P{ 	IN_Manichaean}', "");
    Expect(1, 68351, '\P{^ 	IN_Manichaean}', "");
    Expect(0, 68352, '\p{ 	IN_Manichaean}', "");
    Expect(1, 68352, '\p{^ 	IN_Manichaean}', "");
    Expect(1, 68352, '\P{ 	IN_Manichaean}', "");
    Expect(0, 68352, '\P{^ 	IN_Manichaean}', "");
    Error('\p{	/a/in_MARCHEN}');
    Error('\P{	/a/in_MARCHEN}');
    Expect(1, 72895, '\p{inmarchen}', "");
    Expect(0, 72895, '\p{^inmarchen}', "");
    Expect(0, 72895, '\P{inmarchen}', "");
    Expect(1, 72895, '\P{^inmarchen}', "");
    Expect(0, 72896, '\p{inmarchen}', "");
    Expect(1, 72896, '\p{^inmarchen}', "");
    Expect(1, 72896, '\P{inmarchen}', "");
    Expect(0, 72896, '\P{^inmarchen}', "");
    Expect(1, 72895, '\p{ IN_Marchen}', "");
    Expect(0, 72895, '\p{^ IN_Marchen}', "");
    Expect(0, 72895, '\P{ IN_Marchen}', "");
    Expect(1, 72895, '\P{^ IN_Marchen}', "");
    Expect(0, 72896, '\p{ IN_Marchen}', "");
    Expect(1, 72896, '\p{^ IN_Marchen}', "");
    Expect(1, 72896, '\P{ IN_Marchen}', "");
    Expect(0, 72896, '\P{^ IN_Marchen}', "");
    Error('\p{/a/in_marchen}');
    Error('\P{/a/in_marchen}');
    Expect(1, 72895, '\p{_ in_Marchen}', "");
    Expect(0, 72895, '\p{^_ in_Marchen}', "");
    Expect(0, 72895, '\P{_ in_Marchen}', "");
    Expect(1, 72895, '\P{^_ in_Marchen}', "");
    Expect(0, 72896, '\p{_ in_Marchen}', "");
    Expect(1, 72896, '\p{^_ in_Marchen}', "");
    Expect(1, 72896, '\P{_ in_Marchen}', "");
    Expect(0, 72896, '\P{^_ in_Marchen}', "");
    Error('\p{:=	-IN_masaram_Gondi}');
    Error('\P{:=	-IN_masaram_Gondi}');
    Expect(1, 73055, '\p{inmasaramgondi}', "");
    Expect(0, 73055, '\p{^inmasaramgondi}', "");
    Expect(0, 73055, '\P{inmasaramgondi}', "");
    Expect(1, 73055, '\P{^inmasaramgondi}', "");
    Expect(0, 73056, '\p{inmasaramgondi}', "");
    Expect(1, 73056, '\p{^inmasaramgondi}', "");
    Expect(1, 73056, '\P{inmasaramgondi}', "");
    Expect(0, 73056, '\P{^inmasaramgondi}', "");
    Expect(1, 73055, '\p{IN_MASARAM_GONDI}', "");
    Expect(0, 73055, '\p{^IN_MASARAM_GONDI}', "");
    Expect(0, 73055, '\P{IN_MASARAM_GONDI}', "");
    Expect(1, 73055, '\P{^IN_MASARAM_GONDI}', "");
    Expect(0, 73056, '\p{IN_MASARAM_GONDI}', "");
    Expect(1, 73056, '\p{^IN_MASARAM_GONDI}', "");
    Expect(1, 73056, '\P{IN_MASARAM_GONDI}', "");
    Expect(0, 73056, '\P{^IN_MASARAM_GONDI}', "");
    Error('\p{_	In_MASARAM_Gondi:=}');
    Error('\P{_	In_MASARAM_Gondi:=}');
    Expect(1, 73055, '\p{_ in_Masaram_GONDI}', "");
    Expect(0, 73055, '\p{^_ in_Masaram_GONDI}', "");
    Expect(0, 73055, '\P{_ in_Masaram_GONDI}', "");
    Expect(1, 73055, '\P{^_ in_Masaram_GONDI}', "");
    Expect(0, 73056, '\p{_ in_Masaram_GONDI}', "");
    Expect(1, 73056, '\p{^_ in_Masaram_GONDI}', "");
    Expect(1, 73056, '\P{_ in_Masaram_GONDI}', "");
    Expect(0, 73056, '\P{^_ in_Masaram_GONDI}', "");
    Error('\p{_	In_Medefaidrin:=}');
    Error('\P{_	In_Medefaidrin:=}');
    Expect(1, 93855, '\p{inmedefaidrin}', "");
    Expect(0, 93855, '\p{^inmedefaidrin}', "");
    Expect(0, 93855, '\P{inmedefaidrin}', "");
    Expect(1, 93855, '\P{^inmedefaidrin}', "");
    Expect(0, 93856, '\p{inmedefaidrin}', "");
    Expect(1, 93856, '\p{^inmedefaidrin}', "");
    Expect(1, 93856, '\P{inmedefaidrin}', "");
    Expect(0, 93856, '\P{^inmedefaidrin}', "");
    Expect(1, 93855, '\p{-in_Medefaidrin}', "");
    Expect(0, 93855, '\p{^-in_Medefaidrin}', "");
    Expect(0, 93855, '\P{-in_Medefaidrin}', "");
    Expect(1, 93855, '\P{^-in_Medefaidrin}', "");
    Expect(0, 93856, '\p{-in_Medefaidrin}', "");
    Expect(1, 93856, '\p{^-in_Medefaidrin}', "");
    Expect(1, 93856, '\P{-in_Medefaidrin}', "");
    Expect(0, 93856, '\P{^-in_Medefaidrin}', "");
    Error('\p{ In_medefaidrin/a/}');
    Error('\P{ In_medefaidrin/a/}');
    Expect(1, 93855, '\p{__IN_medefaidrin}', "");
    Expect(0, 93855, '\p{^__IN_medefaidrin}', "");
    Expect(0, 93855, '\P{__IN_medefaidrin}', "");
    Expect(1, 93855, '\P{^__IN_medefaidrin}', "");
    Expect(0, 93856, '\p{__IN_medefaidrin}', "");
    Expect(1, 93856, '\p{^__IN_medefaidrin}', "");
    Expect(1, 93856, '\P{__IN_medefaidrin}', "");
    Expect(0, 93856, '\P{^__IN_medefaidrin}', "");
    Error('\p{/a/_In_MEETEI_Mayek}');
    Error('\P{/a/_In_MEETEI_Mayek}');
    Expect(1, 44031, '\p{inmeeteimayek}', "");
    Expect(0, 44031, '\p{^inmeeteimayek}', "");
    Expect(0, 44031, '\P{inmeeteimayek}', "");
    Expect(1, 44031, '\P{^inmeeteimayek}', "");
    Expect(0, 44032, '\p{inmeeteimayek}', "");
    Expect(1, 44032, '\p{^inmeeteimayek}', "");
    Expect(1, 44032, '\P{inmeeteimayek}', "");
    Expect(0, 44032, '\P{^inmeeteimayek}', "");
    Expect(1, 44031, '\p{	_In_Meetei_MAYEK}', "");
    Expect(0, 44031, '\p{^	_In_Meetei_MAYEK}', "");
    Expect(0, 44031, '\P{	_In_Meetei_MAYEK}', "");
    Expect(1, 44031, '\P{^	_In_Meetei_MAYEK}', "");
    Expect(0, 44032, '\p{	_In_Meetei_MAYEK}', "");
    Expect(1, 44032, '\p{^	_In_Meetei_MAYEK}', "");
    Expect(1, 44032, '\P{	_In_Meetei_MAYEK}', "");
    Expect(0, 44032, '\P{^	_In_Meetei_MAYEK}', "");
    Error('\p{_:=In_Meetei_Mayek}');
    Error('\P{_:=In_Meetei_Mayek}');
    Expect(1, 44031, '\p{_ In_meetei_Mayek}', "");
    Expect(0, 44031, '\p{^_ In_meetei_Mayek}', "");
    Expect(0, 44031, '\P{_ In_meetei_Mayek}', "");
    Expect(1, 44031, '\P{^_ In_meetei_Mayek}', "");
    Expect(0, 44032, '\p{_ In_meetei_Mayek}', "");
    Expect(1, 44032, '\p{^_ In_meetei_Mayek}', "");
    Expect(1, 44032, '\P{_ In_meetei_Mayek}', "");
    Expect(0, 44032, '\P{^_ In_meetei_Mayek}', "");
    Error('\p{-_IN_Mende_kikakui:=}');
    Error('\P{-_IN_Mende_kikakui:=}');
    Expect(1, 125151, '\p{inmendekikakui}', "");
    Expect(0, 125151, '\p{^inmendekikakui}', "");
    Expect(0, 125151, '\P{inmendekikakui}', "");
    Expect(1, 125151, '\P{^inmendekikakui}', "");
    Expect(0, 125152, '\p{inmendekikakui}', "");
    Expect(1, 125152, '\p{^inmendekikakui}', "");
    Expect(1, 125152, '\P{inmendekikakui}', "");
    Expect(0, 125152, '\P{^inmendekikakui}', "");
    Expect(1, 125151, '\p{ -In_mende_KIKAKUI}', "");
    Expect(0, 125151, '\p{^ -In_mende_KIKAKUI}', "");
    Expect(0, 125151, '\P{ -In_mende_KIKAKUI}', "");
    Expect(1, 125151, '\P{^ -In_mende_KIKAKUI}', "");
    Expect(0, 125152, '\p{ -In_mende_KIKAKUI}', "");
    Expect(1, 125152, '\p{^ -In_mende_KIKAKUI}', "");
    Expect(1, 125152, '\P{ -In_mende_KIKAKUI}', "");
    Expect(0, 125152, '\P{^ -In_mende_KIKAKUI}', "");
    Error('\p{	/a/in_Mende_Kikakui}');
    Error('\P{	/a/in_Mende_Kikakui}');
    Expect(1, 125151, '\p{-In_Mende_Kikakui}', "");
    Expect(0, 125151, '\p{^-In_Mende_Kikakui}', "");
    Expect(0, 125151, '\P{-In_Mende_Kikakui}', "");
    Expect(1, 125151, '\P{^-In_Mende_Kikakui}', "");
    Expect(0, 125152, '\p{-In_Mende_Kikakui}', "");
    Expect(1, 125152, '\p{^-In_Mende_Kikakui}', "");
    Expect(1, 125152, '\P{-In_Mende_Kikakui}', "");
    Expect(0, 125152, '\P{^-In_Mende_Kikakui}', "");
    Error('\p{:= -in_Meroitic_CURSIVE}');
    Error('\P{:= -in_Meroitic_CURSIVE}');
    Expect(1, 68095, '\p{inmeroiticcursive}', "");
    Expect(0, 68095, '\p{^inmeroiticcursive}', "");
    Expect(0, 68095, '\P{inmeroiticcursive}', "");
    Expect(1, 68095, '\P{^inmeroiticcursive}', "");
    Expect(0, 68096, '\p{inmeroiticcursive}', "");
    Expect(1, 68096, '\p{^inmeroiticcursive}', "");
    Expect(1, 68096, '\P{inmeroiticcursive}', "");
    Expect(0, 68096, '\P{^inmeroiticcursive}', "");
    Expect(1, 68095, '\p{ _In_Meroitic_Cursive}', "");
    Expect(0, 68095, '\p{^ _In_Meroitic_Cursive}', "");
    Expect(0, 68095, '\P{ _In_Meroitic_Cursive}', "");
    Expect(1, 68095, '\P{^ _In_Meroitic_Cursive}', "");
    Expect(0, 68096, '\p{ _In_Meroitic_Cursive}', "");
    Expect(1, 68096, '\p{^ _In_Meroitic_Cursive}', "");
    Expect(1, 68096, '\P{ _In_Meroitic_Cursive}', "");
    Expect(0, 68096, '\P{^ _In_Meroitic_Cursive}', "");
    Error('\p{:= In_Meroitic_Cursive}');
    Error('\P{:= In_Meroitic_Cursive}');
    Expect(1, 68095, '\p{	 In_Meroitic_CURSIVE}', "");
    Expect(0, 68095, '\p{^	 In_Meroitic_CURSIVE}', "");
    Expect(0, 68095, '\P{	 In_Meroitic_CURSIVE}', "");
    Expect(1, 68095, '\P{^	 In_Meroitic_CURSIVE}', "");
    Expect(0, 68096, '\p{	 In_Meroitic_CURSIVE}', "");
    Expect(1, 68096, '\p{^	 In_Meroitic_CURSIVE}', "");
    Expect(1, 68096, '\P{	 In_Meroitic_CURSIVE}', "");
    Expect(0, 68096, '\P{^	 In_Meroitic_CURSIVE}', "");
    Error('\p{--in_Meroitic_HIEROGLYPHS:=}');
    Error('\P{--in_Meroitic_HIEROGLYPHS:=}');
    Expect(1, 67999, '\p{inmeroitichieroglyphs}', "");
    Expect(0, 67999, '\p{^inmeroitichieroglyphs}', "");
    Expect(0, 67999, '\P{inmeroitichieroglyphs}', "");
    Expect(1, 67999, '\P{^inmeroitichieroglyphs}', "");
    Expect(0, 68000, '\p{inmeroitichieroglyphs}', "");
    Expect(1, 68000, '\p{^inmeroitichieroglyphs}', "");
    Expect(1, 68000, '\P{inmeroitichieroglyphs}', "");
    Expect(0, 68000, '\P{^inmeroitichieroglyphs}', "");
    Expect(1, 67999, '\p{ 	In_Meroitic_Hieroglyphs}', "");
    Expect(0, 67999, '\p{^ 	In_Meroitic_Hieroglyphs}', "");
    Expect(0, 67999, '\P{ 	In_Meroitic_Hieroglyphs}', "");
    Expect(1, 67999, '\P{^ 	In_Meroitic_Hieroglyphs}', "");
    Expect(0, 68000, '\p{ 	In_Meroitic_Hieroglyphs}', "");
    Expect(1, 68000, '\p{^ 	In_Meroitic_Hieroglyphs}', "");
    Expect(1, 68000, '\P{ 	In_Meroitic_Hieroglyphs}', "");
    Expect(0, 68000, '\P{^ 	In_Meroitic_Hieroglyphs}', "");
    Error('\p{:=--IN_meroitic_Hieroglyphs}');
    Error('\P{:=--IN_meroitic_Hieroglyphs}');
    Expect(1, 67999, '\p{_-in_meroitic_hieroglyphs}', "");
    Expect(0, 67999, '\p{^_-in_meroitic_hieroglyphs}', "");
    Expect(0, 67999, '\P{_-in_meroitic_hieroglyphs}', "");
    Expect(1, 67999, '\P{^_-in_meroitic_hieroglyphs}', "");
    Expect(0, 68000, '\p{_-in_meroitic_hieroglyphs}', "");
    Expect(1, 68000, '\p{^_-in_meroitic_hieroglyphs}', "");
    Expect(1, 68000, '\P{_-in_meroitic_hieroglyphs}', "");
    Expect(0, 68000, '\P{^_-in_meroitic_hieroglyphs}', "");
    Error('\p{/a/IN_miao}');
    Error('\P{/a/IN_miao}');
    Expect(1, 94111, '\p{inmiao}', "");
    Expect(0, 94111, '\p{^inmiao}', "");
    Expect(0, 94111, '\P{inmiao}', "");
    Expect(1, 94111, '\P{^inmiao}', "");
    Expect(0, 94112, '\p{inmiao}', "");
    Expect(1, 94112, '\p{^inmiao}', "");
    Expect(1, 94112, '\P{inmiao}', "");
    Expect(0, 94112, '\P{^inmiao}', "");
    Expect(1, 94111, '\p{	 in_MIAO}', "");
    Expect(0, 94111, '\p{^	 in_MIAO}', "");
    Expect(0, 94111, '\P{	 in_MIAO}', "");
    Expect(1, 94111, '\P{^	 in_MIAO}', "");
    Expect(0, 94112, '\p{	 in_MIAO}', "");
    Expect(1, 94112, '\p{^	 in_MIAO}', "");
    Expect(1, 94112, '\P{	 in_MIAO}', "");
    Expect(0, 94112, '\P{^	 in_MIAO}', "");
    Error('\p{-IN_Miao:=}');
    Error('\P{-IN_Miao:=}');
    Expect(1, 94111, '\p{-in_miao}', "");
    Expect(0, 94111, '\p{^-in_miao}', "");
    Expect(0, 94111, '\P{-in_miao}', "");
    Expect(1, 94111, '\P{^-in_miao}', "");
    Expect(0, 94112, '\p{-in_miao}', "");
    Expect(1, 94112, '\p{^-in_miao}', "");
    Expect(1, 94112, '\P{-in_miao}', "");
    Expect(0, 94112, '\P{^-in_miao}', "");
    Error('\p{In_Modi/a/}');
    Error('\P{In_Modi/a/}');
    Expect(1, 71263, '\p{inmodi}', "");
    Expect(0, 71263, '\p{^inmodi}', "");
    Expect(0, 71263, '\P{inmodi}', "");
    Expect(1, 71263, '\P{^inmodi}', "");
    Expect(0, 71264, '\p{inmodi}', "");
    Expect(1, 71264, '\p{^inmodi}', "");
    Expect(1, 71264, '\P{inmodi}', "");
    Expect(0, 71264, '\P{^inmodi}', "");
    Expect(1, 71263, '\p{	_In_Modi}', "");
    Expect(0, 71263, '\p{^	_In_Modi}', "");
    Expect(0, 71263, '\P{	_In_Modi}', "");
    Expect(1, 71263, '\P{^	_In_Modi}', "");
    Expect(0, 71264, '\p{	_In_Modi}', "");
    Expect(1, 71264, '\p{^	_In_Modi}', "");
    Expect(1, 71264, '\P{	_In_Modi}', "");
    Expect(0, 71264, '\P{^	_In_Modi}', "");
    Error('\p{-/a/In_Modi}');
    Error('\P{-/a/In_Modi}');
    Expect(1, 71263, '\p{	In_MODI}', "");
    Expect(0, 71263, '\p{^	In_MODI}', "");
    Expect(0, 71263, '\P{	In_MODI}', "");
    Expect(1, 71263, '\P{^	In_MODI}', "");
    Expect(0, 71264, '\p{	In_MODI}', "");
    Expect(1, 71264, '\p{^	In_MODI}', "");
    Expect(1, 71264, '\P{	In_MODI}', "");
    Expect(0, 71264, '\P{^	In_MODI}', "");
    Error('\p{- In_Mongolian:=}');
    Error('\P{- In_Mongolian:=}');
    Expect(1, 6319, '\p{inmongolian}', "");
    Expect(0, 6319, '\p{^inmongolian}', "");
    Expect(0, 6319, '\P{inmongolian}', "");
    Expect(1, 6319, '\P{^inmongolian}', "");
    Expect(0, 6320, '\p{inmongolian}', "");
    Expect(1, 6320, '\p{^inmongolian}', "");
    Expect(1, 6320, '\P{inmongolian}', "");
    Expect(0, 6320, '\P{^inmongolian}', "");
    Expect(1, 6319, '\p{ _in_Mongolian}', "");
    Expect(0, 6319, '\p{^ _in_Mongolian}', "");
    Expect(0, 6319, '\P{ _in_Mongolian}', "");
    Expect(1, 6319, '\P{^ _in_Mongolian}', "");
    Expect(0, 6320, '\p{ _in_Mongolian}', "");
    Expect(1, 6320, '\p{^ _in_Mongolian}', "");
    Expect(1, 6320, '\P{ _in_Mongolian}', "");
    Expect(0, 6320, '\P{^ _in_Mongolian}', "");
    Error('\p{/a/_-IN_MONGOLIAN}');
    Error('\P{/a/_-IN_MONGOLIAN}');
    Expect(1, 6319, '\p{_	IN_mongolian}', "");
    Expect(0, 6319, '\p{^_	IN_mongolian}', "");
    Expect(0, 6319, '\P{_	IN_mongolian}', "");
    Expect(1, 6319, '\P{^_	IN_mongolian}', "");
    Expect(0, 6320, '\p{_	IN_mongolian}', "");
    Expect(1, 6320, '\p{^_	IN_mongolian}', "");
    Expect(1, 6320, '\P{_	IN_mongolian}', "");
    Expect(0, 6320, '\P{^_	IN_mongolian}', "");
    Error('\p{/a/IN_Mro}');
    Error('\P{/a/IN_Mro}');
    Expect(1, 92783, '\p{inmro}', "");
    Expect(0, 92783, '\p{^inmro}', "");
    Expect(0, 92783, '\P{inmro}', "");
    Expect(1, 92783, '\P{^inmro}', "");
    Expect(0, 92784, '\p{inmro}', "");
    Expect(1, 92784, '\p{^inmro}', "");
    Expect(1, 92784, '\P{inmro}', "");
    Expect(0, 92784, '\P{^inmro}', "");
    Expect(1, 92783, '\p{ in_Mro}', "");
    Expect(0, 92783, '\p{^ in_Mro}', "");
    Expect(0, 92783, '\P{ in_Mro}', "");
    Expect(1, 92783, '\P{^ in_Mro}', "");
    Expect(0, 92784, '\p{ in_Mro}', "");
    Expect(1, 92784, '\p{^ in_Mro}', "");
    Expect(1, 92784, '\P{ in_Mro}', "");
    Expect(0, 92784, '\P{^ in_Mro}', "");
    Error('\p{ 	In_MRO/a/}');
    Error('\P{ 	In_MRO/a/}');
    Expect(1, 92783, '\p{_ In_Mro}', "");
    Expect(0, 92783, '\p{^_ In_Mro}', "");
    Expect(0, 92783, '\P{_ In_Mro}', "");
    Expect(1, 92783, '\P{^_ In_Mro}', "");
    Expect(0, 92784, '\p{_ In_Mro}', "");
    Expect(1, 92784, '\p{^_ In_Mro}', "");
    Expect(1, 92784, '\P{_ In_Mro}', "");
    Expect(0, 92784, '\P{^_ In_Mro}', "");
    Error('\p{--in_multani:=}');
    Error('\P{--in_multani:=}');
    Expect(1, 70319, '\p{inmultani}', "");
    Expect(0, 70319, '\p{^inmultani}', "");
    Expect(0, 70319, '\P{inmultani}', "");
    Expect(1, 70319, '\P{^inmultani}', "");
    Expect(0, 70320, '\p{inmultani}', "");
    Expect(1, 70320, '\p{^inmultani}', "");
    Expect(1, 70320, '\P{inmultani}', "");
    Expect(0, 70320, '\P{^inmultani}', "");
    Expect(1, 70319, '\p{--IN_multani}', "");
    Expect(0, 70319, '\p{^--IN_multani}', "");
    Expect(0, 70319, '\P{--IN_multani}', "");
    Expect(1, 70319, '\P{^--IN_multani}', "");
    Expect(0, 70320, '\p{--IN_multani}', "");
    Expect(1, 70320, '\p{^--IN_multani}', "");
    Expect(1, 70320, '\P{--IN_multani}', "");
    Expect(0, 70320, '\P{^--IN_multani}', "");
    Error('\p{:=-In_Multani}');
    Error('\P{:=-In_Multani}');
    Expect(1, 70319, '\p{ -In_Multani}', "");
    Expect(0, 70319, '\p{^ -In_Multani}', "");
    Expect(0, 70319, '\P{ -In_Multani}', "");
    Expect(1, 70319, '\P{^ -In_Multani}', "");
    Expect(0, 70320, '\p{ -In_Multani}', "");
    Expect(1, 70320, '\p{^ -In_Multani}', "");
    Expect(1, 70320, '\P{ -In_Multani}', "");
    Expect(0, 70320, '\P{^ -In_Multani}', "");
    Error('\p{ 	In_Myanmar:=}');
    Error('\P{ 	In_Myanmar:=}');
    Expect(1, 4255, '\p{inmyanmar}', "");
    Expect(0, 4255, '\p{^inmyanmar}', "");
    Expect(0, 4255, '\P{inmyanmar}', "");
    Expect(1, 4255, '\P{^inmyanmar}', "");
    Expect(0, 4256, '\p{inmyanmar}', "");
    Expect(1, 4256, '\p{^inmyanmar}', "");
    Expect(1, 4256, '\P{inmyanmar}', "");
    Expect(0, 4256, '\P{^inmyanmar}', "");
    Expect(1, 4255, '\p{_-IN_myanmar}', "");
    Expect(0, 4255, '\p{^_-IN_myanmar}', "");
    Expect(0, 4255, '\P{_-IN_myanmar}', "");
    Expect(1, 4255, '\P{^_-IN_myanmar}', "");
    Expect(0, 4256, '\p{_-IN_myanmar}', "");
    Expect(1, 4256, '\p{^_-IN_myanmar}', "");
    Expect(1, 4256, '\P{_-IN_myanmar}', "");
    Expect(0, 4256, '\P{^_-IN_myanmar}', "");
    Error('\p{:=	In_Myanmar}');
    Error('\P{:=	In_Myanmar}');
    Expect(1, 4255, '\p{ In_Myanmar}', "");
    Expect(0, 4255, '\p{^ In_Myanmar}', "");
    Expect(0, 4255, '\P{ In_Myanmar}', "");
    Expect(1, 4255, '\P{^ In_Myanmar}', "");
    Expect(0, 4256, '\p{ In_Myanmar}', "");
    Expect(1, 4256, '\p{^ In_Myanmar}', "");
    Expect(1, 4256, '\P{ In_Myanmar}', "");
    Expect(0, 4256, '\P{^ In_Myanmar}', "");
    Error('\p{	/a/in_nabataean}');
    Error('\P{	/a/in_nabataean}');
    Expect(1, 67759, '\p{innabataean}', "");
    Expect(0, 67759, '\p{^innabataean}', "");
    Expect(0, 67759, '\P{innabataean}', "");
    Expect(1, 67759, '\P{^innabataean}', "");
    Expect(0, 67760, '\p{innabataean}', "");
    Expect(1, 67760, '\p{^innabataean}', "");
    Expect(1, 67760, '\P{innabataean}', "");
    Expect(0, 67760, '\P{^innabataean}', "");
    Expect(1, 67759, '\p{	_In_nabataean}', "");
    Expect(0, 67759, '\p{^	_In_nabataean}', "");
    Expect(0, 67759, '\P{	_In_nabataean}', "");
    Expect(1, 67759, '\P{^	_In_nabataean}', "");
    Expect(0, 67760, '\p{	_In_nabataean}', "");
    Expect(1, 67760, '\p{^	_In_nabataean}', "");
    Expect(1, 67760, '\P{	_In_nabataean}', "");
    Expect(0, 67760, '\P{^	_In_nabataean}', "");
    Error('\p{:=In_NABATAEAN}');
    Error('\P{:=In_NABATAEAN}');
    Expect(1, 67759, '\p{__In_Nabataean}', "");
    Expect(0, 67759, '\p{^__In_Nabataean}', "");
    Expect(0, 67759, '\P{__In_Nabataean}', "");
    Expect(1, 67759, '\P{^__In_Nabataean}', "");
    Expect(0, 67760, '\p{__In_Nabataean}', "");
    Expect(1, 67760, '\p{^__In_Nabataean}', "");
    Expect(1, 67760, '\P{__In_Nabataean}', "");
    Expect(0, 67760, '\P{^__In_Nabataean}', "");
    Error('\p{_In_nag_Mundari:=}');
    Error('\P{_In_nag_Mundari:=}');
    Expect(1, 124159, '\p{innagmundari}', "");
    Expect(0, 124159, '\p{^innagmundari}', "");
    Expect(0, 124159, '\P{innagmundari}', "");
    Expect(1, 124159, '\P{^innagmundari}', "");
    Expect(0, 124160, '\p{innagmundari}', "");
    Expect(1, 124160, '\p{^innagmundari}', "");
    Expect(1, 124160, '\P{innagmundari}', "");
    Expect(0, 124160, '\P{^innagmundari}', "");
    Expect(1, 124159, '\p{_	IN_Nag_MUNDARI}', "");
    Expect(0, 124159, '\p{^_	IN_Nag_MUNDARI}', "");
    Expect(0, 124159, '\P{_	IN_Nag_MUNDARI}', "");
    Expect(1, 124159, '\P{^_	IN_Nag_MUNDARI}', "");
    Expect(0, 124160, '\p{_	IN_Nag_MUNDARI}', "");
    Expect(1, 124160, '\p{^_	IN_Nag_MUNDARI}', "");
    Expect(1, 124160, '\P{_	IN_Nag_MUNDARI}', "");
    Expect(0, 124160, '\P{^_	IN_Nag_MUNDARI}', "");
    Error('\p{/a/In_nag_Mundari}');
    Error('\P{/a/In_nag_Mundari}');
    Expect(1, 124159, '\p{		in_nag_Mundari}', "");
    Expect(0, 124159, '\p{^		in_nag_Mundari}', "");
    Expect(0, 124159, '\P{		in_nag_Mundari}', "");
    Expect(1, 124159, '\P{^		in_nag_Mundari}', "");
    Expect(0, 124160, '\p{		in_nag_Mundari}', "");
    Expect(1, 124160, '\p{^		in_nag_Mundari}', "");
    Expect(1, 124160, '\P{		in_nag_Mundari}', "");
    Expect(0, 124160, '\P{^		in_nag_Mundari}', "");
    Error('\p{	IN_nandinagari/a/}');
    Error('\P{	IN_nandinagari/a/}');
    Expect(1, 72191, '\p{innandinagari}', "");
    Expect(0, 72191, '\p{^innandinagari}', "");
    Expect(0, 72191, '\P{innandinagari}', "");
    Expect(1, 72191, '\P{^innandinagari}', "");
    Expect(0, 72192, '\p{innandinagari}', "");
    Expect(1, 72192, '\p{^innandinagari}', "");
    Expect(1, 72192, '\P{innandinagari}', "");
    Expect(0, 72192, '\P{^innandinagari}', "");
    Expect(1, 72191, '\p{ IN_NANDINAGARI}', "");
    Expect(0, 72191, '\p{^ IN_NANDINAGARI}', "");
    Expect(0, 72191, '\P{ IN_NANDINAGARI}', "");
    Expect(1, 72191, '\P{^ IN_NANDINAGARI}', "");
    Expect(0, 72192, '\p{ IN_NANDINAGARI}', "");
    Expect(1, 72192, '\p{^ IN_NANDINAGARI}', "");
    Expect(1, 72192, '\P{ IN_NANDINAGARI}', "");
    Expect(0, 72192, '\P{^ IN_NANDINAGARI}', "");
    Error('\p{		In_Nandinagari:=}');
    Error('\P{		In_Nandinagari:=}');
    Expect(1, 72191, '\p{_	IN_Nandinagari}', "");
    Expect(0, 72191, '\p{^_	IN_Nandinagari}', "");
    Expect(0, 72191, '\P{_	IN_Nandinagari}', "");
    Expect(1, 72191, '\P{^_	IN_Nandinagari}', "");
    Expect(0, 72192, '\p{_	IN_Nandinagari}', "");
    Expect(1, 72192, '\p{^_	IN_Nandinagari}', "");
    Expect(1, 72192, '\P{_	IN_Nandinagari}', "");
    Expect(0, 72192, '\P{^_	IN_Nandinagari}', "");
    Error('\p{:=-_IN_NEW_TAI_LUE}');
    Error('\P{:=-_IN_NEW_TAI_LUE}');
    Expect(1, 6623, '\p{innewtailue}', "");
    Expect(0, 6623, '\p{^innewtailue}', "");
    Expect(0, 6623, '\P{innewtailue}', "");
    Expect(1, 6623, '\P{^innewtailue}', "");
    Expect(0, 6624, '\p{innewtailue}', "");
    Expect(1, 6624, '\p{^innewtailue}', "");
    Expect(1, 6624, '\P{innewtailue}', "");
    Expect(0, 6624, '\P{^innewtailue}', "");
    Expect(1, 6623, '\p{ _IN_New_TAI_LUE}', "");
    Expect(0, 6623, '\p{^ _IN_New_TAI_LUE}', "");
    Expect(0, 6623, '\P{ _IN_New_TAI_LUE}', "");
    Expect(1, 6623, '\P{^ _IN_New_TAI_LUE}', "");
    Expect(0, 6624, '\p{ _IN_New_TAI_LUE}', "");
    Expect(1, 6624, '\p{^ _IN_New_TAI_LUE}', "");
    Expect(1, 6624, '\P{ _IN_New_TAI_LUE}', "");
    Expect(0, 6624, '\P{^ _IN_New_TAI_LUE}', "");
    Error('\p{:=_IN_new_TAI_Lue}');
    Error('\P{:=_IN_new_TAI_Lue}');
    Expect(1, 6623, '\p{__In_New_Tai_lue}', "");
    Expect(0, 6623, '\p{^__In_New_Tai_lue}', "");
    Expect(0, 6623, '\P{__In_New_Tai_lue}', "");
    Expect(1, 6623, '\P{^__In_New_Tai_lue}', "");
    Expect(0, 6624, '\p{__In_New_Tai_lue}', "");
    Expect(1, 6624, '\p{^__In_New_Tai_lue}', "");
    Expect(1, 6624, '\P{__In_New_Tai_lue}', "");
    Expect(0, 6624, '\P{^__In_New_Tai_lue}', "");
    Error('\p{		IN_newa/a/}');
    Error('\P{		IN_newa/a/}');
    Expect(1, 70783, '\p{innewa}', "");
    Expect(0, 70783, '\p{^innewa}', "");
    Expect(0, 70783, '\P{innewa}', "");
    Expect(1, 70783, '\P{^innewa}', "");
    Expect(0, 70784, '\p{innewa}', "");
    Expect(1, 70784, '\p{^innewa}', "");
    Expect(1, 70784, '\P{innewa}', "");
    Expect(0, 70784, '\P{^innewa}', "");
    Expect(1, 70783, '\p{_IN_NEWA}', "");
    Expect(0, 70783, '\p{^_IN_NEWA}', "");
    Expect(0, 70783, '\P{_IN_NEWA}', "");
    Expect(1, 70783, '\P{^_IN_NEWA}', "");
    Expect(0, 70784, '\p{_IN_NEWA}', "");
    Expect(1, 70784, '\p{^_IN_NEWA}', "");
    Expect(1, 70784, '\P{_IN_NEWA}', "");
    Expect(0, 70784, '\P{^_IN_NEWA}', "");
    Error('\p{/a/_	In_NEWA}');
    Error('\P{/a/_	In_NEWA}');
    Expect(1, 70783, '\p{ IN_Newa}', "");
    Expect(0, 70783, '\p{^ IN_Newa}', "");
    Expect(0, 70783, '\P{ IN_Newa}', "");
    Expect(1, 70783, '\P{^ IN_Newa}', "");
    Expect(0, 70784, '\p{ IN_Newa}', "");
    Expect(1, 70784, '\p{^ IN_Newa}', "");
    Expect(1, 70784, '\P{ IN_Newa}', "");
    Expect(0, 70784, '\P{^ IN_Newa}', "");
    Error('\p{/a/IN_NKO}');
    Error('\P{/a/IN_NKO}');
    Expect(1, 2047, '\p{innko}', "");
    Expect(0, 2047, '\p{^innko}', "");
    Expect(0, 2047, '\P{innko}', "");
    Expect(1, 2047, '\P{^innko}', "");
    Expect(0, 2048, '\p{innko}', "");
    Expect(1, 2048, '\p{^innko}', "");
    Expect(1, 2048, '\P{innko}', "");
    Expect(0, 2048, '\P{^innko}', "");
    Expect(1, 2047, '\p{ IN_nko}', "");
    Expect(0, 2047, '\p{^ IN_nko}', "");
    Expect(0, 2047, '\P{ IN_nko}', "");
    Expect(1, 2047, '\P{^ IN_nko}', "");
    Expect(0, 2048, '\p{ IN_nko}', "");
    Expect(1, 2048, '\p{^ IN_nko}', "");
    Expect(1, 2048, '\P{ IN_nko}', "");
    Expect(0, 2048, '\P{^ IN_nko}', "");
    Error('\p{:= In_NKo}');
    Error('\P{:= In_NKo}');
    Expect(1, 2047, '\p{ 	In_nko}', "");
    Expect(0, 2047, '\p{^ 	In_nko}', "");
    Expect(0, 2047, '\P{ 	In_nko}', "");
    Expect(1, 2047, '\P{^ 	In_nko}', "");
    Expect(0, 2048, '\p{ 	In_nko}', "");
    Expect(1, 2048, '\p{^ 	In_nko}', "");
    Expect(1, 2048, '\P{ 	In_nko}', "");
    Expect(0, 2048, '\P{^ 	In_nko}', "");
    Error('\p{/a/	IN_nushu}');
    Error('\P{/a/	IN_nushu}');
    Expect(1, 111359, '\p{innushu}', "");
    Expect(0, 111359, '\p{^innushu}', "");
    Expect(0, 111359, '\P{innushu}', "");
    Expect(1, 111359, '\P{^innushu}', "");
    Expect(0, 111360, '\p{innushu}', "");
    Expect(1, 111360, '\p{^innushu}', "");
    Expect(1, 111360, '\P{innushu}', "");
    Expect(0, 111360, '\P{^innushu}', "");
    Expect(1, 111359, '\p{ In_Nushu}', "");
    Expect(0, 111359, '\p{^ In_Nushu}', "");
    Expect(0, 111359, '\P{ In_Nushu}', "");
    Expect(1, 111359, '\P{^ In_Nushu}', "");
    Expect(0, 111360, '\p{ In_Nushu}', "");
    Expect(1, 111360, '\p{^ In_Nushu}', "");
    Expect(1, 111360, '\P{ In_Nushu}', "");
    Expect(0, 111360, '\P{^ In_Nushu}', "");
    Error('\p{/a/_In_NUSHU}');
    Error('\P{/a/_In_NUSHU}');
    Expect(1, 111359, '\p{ _IN_NUSHU}', "");
    Expect(0, 111359, '\p{^ _IN_NUSHU}', "");
    Expect(0, 111359, '\P{ _IN_NUSHU}', "");
    Expect(1, 111359, '\P{^ _IN_NUSHU}', "");
    Expect(0, 111360, '\p{ _IN_NUSHU}', "");
    Expect(1, 111360, '\p{^ _IN_NUSHU}', "");
    Expect(1, 111360, '\P{ _IN_NUSHU}', "");
    Expect(0, 111360, '\P{^ _IN_NUSHU}', "");
    Error('\p{/a/-	in_Nyiakeng_Puachue_HMONG}');
    Error('\P{/a/-	in_Nyiakeng_Puachue_HMONG}');
    Expect(1, 123215, '\p{innyiakengpuachuehmong}', "");
    Expect(0, 123215, '\p{^innyiakengpuachuehmong}', "");
    Expect(0, 123215, '\P{innyiakengpuachuehmong}', "");
    Expect(1, 123215, '\P{^innyiakengpuachuehmong}', "");
    Expect(0, 123216, '\p{innyiakengpuachuehmong}', "");
    Expect(1, 123216, '\p{^innyiakengpuachuehmong}', "");
    Expect(1, 123216, '\P{innyiakengpuachuehmong}', "");
    Expect(0, 123216, '\P{^innyiakengpuachuehmong}', "");
    Expect(1, 123215, '\p{_	In_nyiakeng_Puachue_HMONG}', "");
    Expect(0, 123215, '\p{^_	In_nyiakeng_Puachue_HMONG}', "");
    Expect(0, 123215, '\P{_	In_nyiakeng_Puachue_HMONG}', "");
    Expect(1, 123215, '\P{^_	In_nyiakeng_Puachue_HMONG}', "");
    Expect(0, 123216, '\p{_	In_nyiakeng_Puachue_HMONG}', "");
    Expect(1, 123216, '\p{^_	In_nyiakeng_Puachue_HMONG}', "");
    Expect(1, 123216, '\P{_	In_nyiakeng_Puachue_HMONG}', "");
    Expect(0, 123216, '\P{^_	In_nyiakeng_Puachue_HMONG}', "");
    Error('\p{	-In_NYIAKENG_Puachue_hmong/a/}');
    Error('\P{	-In_NYIAKENG_Puachue_hmong/a/}');
    Expect(1, 123215, '\p{__in_NYIAKENG_Puachue_hmong}', "");
    Expect(0, 123215, '\p{^__in_NYIAKENG_Puachue_hmong}', "");
    Expect(0, 123215, '\P{__in_NYIAKENG_Puachue_hmong}', "");
    Expect(1, 123215, '\P{^__in_NYIAKENG_Puachue_hmong}', "");
    Expect(0, 123216, '\p{__in_NYIAKENG_Puachue_hmong}', "");
    Expect(1, 123216, '\p{^__in_NYIAKENG_Puachue_hmong}', "");
    Expect(1, 123216, '\P{__in_NYIAKENG_Puachue_hmong}', "");
    Expect(0, 123216, '\P{^__in_NYIAKENG_Puachue_hmong}', "");
    Error('\p{--in_Ogham:=}');
    Error('\P{--in_Ogham:=}');
    Expect(1, 5791, '\p{inogham}', "");
    Expect(0, 5791, '\p{^inogham}', "");
    Expect(0, 5791, '\P{inogham}', "");
    Expect(1, 5791, '\P{^inogham}', "");
    Expect(0, 5792, '\p{inogham}', "");
    Expect(1, 5792, '\p{^inogham}', "");
    Expect(1, 5792, '\P{inogham}', "");
    Expect(0, 5792, '\P{^inogham}', "");
    Expect(1, 5791, '\p{	in_Ogham}', "");
    Expect(0, 5791, '\p{^	in_Ogham}', "");
    Expect(0, 5791, '\P{	in_Ogham}', "");
    Expect(1, 5791, '\P{^	in_Ogham}', "");
    Expect(0, 5792, '\p{	in_Ogham}', "");
    Expect(1, 5792, '\p{^	in_Ogham}', "");
    Expect(1, 5792, '\P{	in_Ogham}', "");
    Expect(0, 5792, '\P{^	in_Ogham}', "");
    Error('\p{/a/	-IN_Ogham}');
    Error('\P{/a/	-IN_Ogham}');
    Expect(1, 5791, '\p{_In_Ogham}', "");
    Expect(0, 5791, '\p{^_In_Ogham}', "");
    Expect(0, 5791, '\P{_In_Ogham}', "");
    Expect(1, 5791, '\P{^_In_Ogham}', "");
    Expect(0, 5792, '\p{_In_Ogham}', "");
    Expect(1, 5792, '\p{^_In_Ogham}', "");
    Expect(1, 5792, '\P{_In_Ogham}', "");
    Expect(0, 5792, '\P{^_In_Ogham}', "");
    Error('\p{ -IN_Ol_chiki:=}');
    Error('\P{ -IN_Ol_chiki:=}');
    Expect(1, 7295, '\p{inolchiki}', "");
    Expect(0, 7295, '\p{^inolchiki}', "");
    Expect(0, 7295, '\P{inolchiki}', "");
    Expect(1, 7295, '\P{^inolchiki}', "");
    Expect(0, 7296, '\p{inolchiki}', "");
    Expect(1, 7296, '\p{^inolchiki}', "");
    Expect(1, 7296, '\P{inolchiki}', "");
    Expect(0, 7296, '\P{^inolchiki}', "");
    Expect(1, 7295, '\p{ In_Ol_Chiki}', "");
    Expect(0, 7295, '\p{^ In_Ol_Chiki}', "");
    Expect(0, 7295, '\P{ In_Ol_Chiki}', "");
    Expect(1, 7295, '\P{^ In_Ol_Chiki}', "");
    Expect(0, 7296, '\p{ In_Ol_Chiki}', "");
    Expect(1, 7296, '\p{^ In_Ol_Chiki}', "");
    Expect(1, 7296, '\P{ In_Ol_Chiki}', "");
    Expect(0, 7296, '\P{^ In_Ol_Chiki}', "");
    Error('\p{	IN_Ol_CHIKI:=}');
    Error('\P{	IN_Ol_CHIKI:=}');
    Expect(1, 7295, '\p{	In_ol_Chiki}', "");
    Expect(0, 7295, '\p{^	In_ol_Chiki}', "");
    Expect(0, 7295, '\P{	In_ol_Chiki}', "");
    Expect(1, 7295, '\P{^	In_ol_Chiki}', "");
    Expect(0, 7296, '\p{	In_ol_Chiki}', "");
    Expect(1, 7296, '\p{^	In_ol_Chiki}', "");
    Expect(1, 7296, '\P{	In_ol_Chiki}', "");
    Expect(0, 7296, '\P{^	In_ol_Chiki}', "");
    Error('\p{:=-_IN_Old_Hungarian}');
    Error('\P{:=-_IN_Old_Hungarian}');
    Expect(1, 68863, '\p{inoldhungarian}', "");
    Expect(0, 68863, '\p{^inoldhungarian}', "");
    Expect(0, 68863, '\P{inoldhungarian}', "");
    Expect(1, 68863, '\P{^inoldhungarian}', "");
    Expect(0, 68864, '\p{inoldhungarian}', "");
    Expect(1, 68864, '\p{^inoldhungarian}', "");
    Expect(1, 68864, '\P{inoldhungarian}', "");
    Expect(0, 68864, '\P{^inoldhungarian}', "");
    Expect(1, 68863, '\p{-In_OLD_Hungarian}', "");
    Expect(0, 68863, '\p{^-In_OLD_Hungarian}', "");
    Expect(0, 68863, '\P{-In_OLD_Hungarian}', "");
    Expect(1, 68863, '\P{^-In_OLD_Hungarian}', "");
    Expect(0, 68864, '\p{-In_OLD_Hungarian}', "");
    Expect(1, 68864, '\p{^-In_OLD_Hungarian}', "");
    Expect(1, 68864, '\P{-In_OLD_Hungarian}', "");
    Expect(0, 68864, '\P{^-In_OLD_Hungarian}', "");
    Error('\p{	/a/IN_Old_hungarian}');
    Error('\P{	/a/IN_Old_hungarian}');
    Expect(1, 68863, '\p{	_In_Old_Hungarian}', "");
    Expect(0, 68863, '\p{^	_In_Old_Hungarian}', "");
    Expect(0, 68863, '\P{	_In_Old_Hungarian}', "");
    Expect(1, 68863, '\P{^	_In_Old_Hungarian}', "");
    Expect(0, 68864, '\p{	_In_Old_Hungarian}', "");
    Expect(1, 68864, '\p{^	_In_Old_Hungarian}', "");
    Expect(1, 68864, '\P{	_In_Old_Hungarian}', "");
    Expect(0, 68864, '\P{^	_In_Old_Hungarian}', "");
    Error('\p{ IN_Old_italic/a/}');
    Error('\P{ IN_Old_italic/a/}');
    Expect(1, 66351, '\p{inolditalic}', "");
    Expect(0, 66351, '\p{^inolditalic}', "");
    Expect(0, 66351, '\P{inolditalic}', "");
    Expect(1, 66351, '\P{^inolditalic}', "");
    Expect(0, 66352, '\p{inolditalic}', "");
    Expect(1, 66352, '\p{^inolditalic}', "");
    Expect(1, 66352, '\P{inolditalic}', "");
    Expect(0, 66352, '\P{^inolditalic}', "");
    Expect(1, 66351, '\p{		in_OLD_italic}', "");
    Expect(0, 66351, '\p{^		in_OLD_italic}', "");
    Expect(0, 66351, '\P{		in_OLD_italic}', "");
    Expect(1, 66351, '\P{^		in_OLD_italic}', "");
    Expect(0, 66352, '\p{		in_OLD_italic}', "");
    Expect(1, 66352, '\p{^		in_OLD_italic}', "");
    Expect(1, 66352, '\P{		in_OLD_italic}', "");
    Expect(0, 66352, '\P{^		in_OLD_italic}', "");
    Error('\p{/a/- IN_old_italic}');
    Error('\P{/a/- IN_old_italic}');
    Expect(1, 66351, '\p{-_in_OLD_Italic}', "");
    Expect(0, 66351, '\p{^-_in_OLD_Italic}', "");
    Expect(0, 66351, '\P{-_in_OLD_Italic}', "");
    Expect(1, 66351, '\P{^-_in_OLD_Italic}', "");
    Expect(0, 66352, '\p{-_in_OLD_Italic}', "");
    Expect(1, 66352, '\p{^-_in_OLD_Italic}', "");
    Expect(1, 66352, '\P{-_in_OLD_Italic}', "");
    Expect(0, 66352, '\P{^-_in_OLD_Italic}', "");
    Error('\p{-/a/In_Old_North_Arabian}');
    Error('\P{-/a/In_Old_North_Arabian}');
    Expect(1, 68255, '\p{inoldnortharabian}', "");
    Expect(0, 68255, '\p{^inoldnortharabian}', "");
    Expect(0, 68255, '\P{inoldnortharabian}', "");
    Expect(1, 68255, '\P{^inoldnortharabian}', "");
    Expect(0, 68256, '\p{inoldnortharabian}', "");
    Expect(1, 68256, '\p{^inoldnortharabian}', "");
    Expect(1, 68256, '\P{inoldnortharabian}', "");
    Expect(0, 68256, '\P{^inoldnortharabian}', "");
    Expect(1, 68255, '\p{ In_Old_North_Arabian}', "");
    Expect(0, 68255, '\p{^ In_Old_North_Arabian}', "");
    Expect(0, 68255, '\P{ In_Old_North_Arabian}', "");
    Expect(1, 68255, '\P{^ In_Old_North_Arabian}', "");
    Expect(0, 68256, '\p{ In_Old_North_Arabian}', "");
    Expect(1, 68256, '\p{^ In_Old_North_Arabian}', "");
    Expect(1, 68256, '\P{ In_Old_North_Arabian}', "");
    Expect(0, 68256, '\P{^ In_Old_North_Arabian}', "");
    Error('\p{_In_OLD_North_Arabian:=}');
    Error('\P{_In_OLD_North_Arabian:=}');
    Expect(1, 68255, '\p{	-In_old_North_Arabian}', "");
    Expect(0, 68255, '\p{^	-In_old_North_Arabian}', "");
    Expect(0, 68255, '\P{	-In_old_North_Arabian}', "");
    Expect(1, 68255, '\P{^	-In_old_North_Arabian}', "");
    Expect(0, 68256, '\p{	-In_old_North_Arabian}', "");
    Expect(1, 68256, '\p{^	-In_old_North_Arabian}', "");
    Expect(1, 68256, '\P{	-In_old_North_Arabian}', "");
    Expect(0, 68256, '\P{^	-In_old_North_Arabian}', "");
    Error('\p{-	in_Old_Permic:=}');
    Error('\P{-	in_Old_Permic:=}');
    Expect(1, 66431, '\p{inoldpermic}', "");
    Expect(0, 66431, '\p{^inoldpermic}', "");
    Expect(0, 66431, '\P{inoldpermic}', "");
    Expect(1, 66431, '\P{^inoldpermic}', "");
    Expect(0, 66432, '\p{inoldpermic}', "");
    Expect(1, 66432, '\p{^inoldpermic}', "");
    Expect(1, 66432, '\P{inoldpermic}', "");
    Expect(0, 66432, '\P{^inoldpermic}', "");
    Expect(1, 66431, '\p{__In_OLD_Permic}', "");
    Expect(0, 66431, '\p{^__In_OLD_Permic}', "");
    Expect(0, 66431, '\P{__In_OLD_Permic}', "");
    Expect(1, 66431, '\P{^__In_OLD_Permic}', "");
    Expect(0, 66432, '\p{__In_OLD_Permic}', "");
    Expect(1, 66432, '\p{^__In_OLD_Permic}', "");
    Expect(1, 66432, '\P{__In_OLD_Permic}', "");
    Expect(0, 66432, '\P{^__In_OLD_Permic}', "");
    Error('\p{-	in_Old_PERMIC/a/}');
    Error('\P{-	in_Old_PERMIC/a/}');
    Expect(1, 66431, '\p{In_OLD_PERMIC}', "");
    Expect(0, 66431, '\p{^In_OLD_PERMIC}', "");
    Expect(0, 66431, '\P{In_OLD_PERMIC}', "");
    Expect(1, 66431, '\P{^In_OLD_PERMIC}', "");
    Expect(0, 66432, '\p{In_OLD_PERMIC}', "");
    Expect(1, 66432, '\p{^In_OLD_PERMIC}', "");
    Expect(1, 66432, '\P{In_OLD_PERMIC}', "");
    Expect(0, 66432, '\P{^In_OLD_PERMIC}', "");
    Error('\p{_/a/in_Old_PERSIAN}');
    Error('\P{_/a/in_Old_PERSIAN}');
    Expect(1, 66527, '\p{inoldpersian}', "");
    Expect(0, 66527, '\p{^inoldpersian}', "");
    Expect(0, 66527, '\P{inoldpersian}', "");
    Expect(1, 66527, '\P{^inoldpersian}', "");
    Expect(0, 66528, '\p{inoldpersian}', "");
    Expect(1, 66528, '\p{^inoldpersian}', "");
    Expect(1, 66528, '\P{inoldpersian}', "");
    Expect(0, 66528, '\P{^inoldpersian}', "");
    Expect(1, 66527, '\p{	IN_OLD_persian}', "");
    Expect(0, 66527, '\p{^	IN_OLD_persian}', "");
    Expect(0, 66527, '\P{	IN_OLD_persian}', "");
    Expect(1, 66527, '\P{^	IN_OLD_persian}', "");
    Expect(0, 66528, '\p{	IN_OLD_persian}', "");
    Expect(1, 66528, '\p{^	IN_OLD_persian}', "");
    Expect(1, 66528, '\P{	IN_OLD_persian}', "");
    Expect(0, 66528, '\P{^	IN_OLD_persian}', "");
    Error('\p{:=-In_old_PERSIAN}');
    Error('\P{:=-In_old_PERSIAN}');
    Expect(1, 66527, '\p{-	In_OLD_Persian}', "");
    Expect(0, 66527, '\p{^-	In_OLD_Persian}', "");
    Expect(0, 66527, '\P{-	In_OLD_Persian}', "");
    Expect(1, 66527, '\P{^-	In_OLD_Persian}', "");
    Expect(0, 66528, '\p{-	In_OLD_Persian}', "");
    Expect(1, 66528, '\p{^-	In_OLD_Persian}', "");
    Expect(1, 66528, '\P{-	In_OLD_Persian}', "");
    Expect(0, 66528, '\P{^-	In_OLD_Persian}', "");
    Error('\p{:= _IN_old_Sogdian}');
    Error('\P{:= _IN_old_Sogdian}');
    Expect(1, 69423, '\p{inoldsogdian}', "");
    Expect(0, 69423, '\p{^inoldsogdian}', "");
    Expect(0, 69423, '\P{inoldsogdian}', "");
    Expect(1, 69423, '\P{^inoldsogdian}', "");
    Expect(0, 69424, '\p{inoldsogdian}', "");
    Expect(1, 69424, '\p{^inoldsogdian}', "");
    Expect(1, 69424, '\P{inoldsogdian}', "");
    Expect(0, 69424, '\P{^inoldsogdian}', "");
    Expect(1, 69423, '\p{_-In_Old_sogdian}', "");
    Expect(0, 69423, '\p{^_-In_Old_sogdian}', "");
    Expect(0, 69423, '\P{_-In_Old_sogdian}', "");
    Expect(1, 69423, '\P{^_-In_Old_sogdian}', "");
    Expect(0, 69424, '\p{_-In_Old_sogdian}', "");
    Expect(1, 69424, '\p{^_-In_Old_sogdian}', "");
    Expect(1, 69424, '\P{_-In_Old_sogdian}', "");
    Expect(0, 69424, '\P{^_-In_Old_sogdian}', "");
    Error('\p{:=in_Old_sogdian}');
    Error('\P{:=in_Old_sogdian}');
    Expect(1, 69423, '\p{__In_old_sogdian}', "");
    Expect(0, 69423, '\p{^__In_old_sogdian}', "");
    Expect(0, 69423, '\P{__In_old_sogdian}', "");
    Expect(1, 69423, '\P{^__In_old_sogdian}', "");
    Expect(0, 69424, '\p{__In_old_sogdian}', "");
    Expect(1, 69424, '\p{^__In_old_sogdian}', "");
    Expect(1, 69424, '\P{__In_old_sogdian}', "");
    Expect(0, 69424, '\P{^__In_old_sogdian}', "");
    Error('\p{-In_Old_south_Arabian:=}');
    Error('\P{-In_Old_south_Arabian:=}');
    Expect(1, 68223, '\p{inoldsoutharabian}', "");
    Expect(0, 68223, '\p{^inoldsoutharabian}', "");
    Expect(0, 68223, '\P{inoldsoutharabian}', "");
    Expect(1, 68223, '\P{^inoldsoutharabian}', "");
    Expect(0, 68224, '\p{inoldsoutharabian}', "");
    Expect(1, 68224, '\p{^inoldsoutharabian}', "");
    Expect(1, 68224, '\P{inoldsoutharabian}', "");
    Expect(0, 68224, '\P{^inoldsoutharabian}', "");
    Expect(1, 68223, '\p{_-in_Old_South_Arabian}', "");
    Expect(0, 68223, '\p{^_-in_Old_South_Arabian}', "");
    Expect(0, 68223, '\P{_-in_Old_South_Arabian}', "");
    Expect(1, 68223, '\P{^_-in_Old_South_Arabian}', "");
    Expect(0, 68224, '\p{_-in_Old_South_Arabian}', "");
    Expect(1, 68224, '\p{^_-in_Old_South_Arabian}', "");
    Expect(1, 68224, '\P{_-in_Old_South_Arabian}', "");
    Expect(0, 68224, '\P{^_-in_Old_South_Arabian}', "");
    Error('\p{/a/	 In_old_South_Arabian}');
    Error('\P{/a/	 In_old_South_Arabian}');
    Expect(1, 68223, '\p{-In_Old_South_arabian}', "");
    Expect(0, 68223, '\p{^-In_Old_South_arabian}', "");
    Expect(0, 68223, '\P{-In_Old_South_arabian}', "");
    Expect(1, 68223, '\P{^-In_Old_South_arabian}', "");
    Expect(0, 68224, '\p{-In_Old_South_arabian}', "");
    Expect(1, 68224, '\p{^-In_Old_South_arabian}', "");
    Expect(1, 68224, '\P{-In_Old_South_arabian}', "");
    Expect(0, 68224, '\P{^-In_Old_South_arabian}', "");
    Error('\p{ 	in_old_turkic/a/}');
    Error('\P{ 	in_old_turkic/a/}');
    Expect(1, 68687, '\p{inoldturkic}', "");
    Expect(0, 68687, '\p{^inoldturkic}', "");
    Expect(0, 68687, '\P{inoldturkic}', "");
    Expect(1, 68687, '\P{^inoldturkic}', "");
    Expect(0, 68688, '\p{inoldturkic}', "");
    Expect(1, 68688, '\p{^inoldturkic}', "");
    Expect(1, 68688, '\P{inoldturkic}', "");
    Expect(0, 68688, '\P{^inoldturkic}', "");
    Expect(1, 68687, '\p{-	IN_Old_Turkic}', "");
    Expect(0, 68687, '\p{^-	IN_Old_Turkic}', "");
    Expect(0, 68687, '\P{-	IN_Old_Turkic}', "");
    Expect(1, 68687, '\P{^-	IN_Old_Turkic}', "");
    Expect(0, 68688, '\p{-	IN_Old_Turkic}', "");
    Expect(1, 68688, '\p{^-	IN_Old_Turkic}', "");
    Expect(1, 68688, '\P{-	IN_Old_Turkic}', "");
    Expect(0, 68688, '\P{^-	IN_Old_Turkic}', "");
    Error('\p{ in_OLD_Turkic:=}');
    Error('\P{ in_OLD_Turkic:=}');
    Expect(1, 68687, '\p{-in_old_TURKIC}', "");
    Expect(0, 68687, '\p{^-in_old_TURKIC}', "");
    Expect(0, 68687, '\P{-in_old_TURKIC}', "");
    Expect(1, 68687, '\P{^-in_old_TURKIC}', "");
    Expect(0, 68688, '\p{-in_old_TURKIC}', "");
    Expect(1, 68688, '\p{^-in_old_TURKIC}', "");
    Expect(1, 68688, '\P{-in_old_TURKIC}', "");
    Expect(0, 68688, '\P{^-in_old_TURKIC}', "");
    Error('\p{-:=IN_Old_uyghur}');
    Error('\P{-:=IN_Old_uyghur}');
    Expect(1, 69551, '\p{inolduyghur}', "");
    Expect(0, 69551, '\p{^inolduyghur}', "");
    Expect(0, 69551, '\P{inolduyghur}', "");
    Expect(1, 69551, '\P{^inolduyghur}', "");
    Expect(0, 69552, '\p{inolduyghur}', "");
    Expect(1, 69552, '\p{^inolduyghur}', "");
    Expect(1, 69552, '\P{inolduyghur}', "");
    Expect(0, 69552, '\P{^inolduyghur}', "");
    Expect(1, 69551, '\p{ _In_Old_uyghur}', "");
    Expect(0, 69551, '\p{^ _In_Old_uyghur}', "");
    Expect(0, 69551, '\P{ _In_Old_uyghur}', "");
    Expect(1, 69551, '\P{^ _In_Old_uyghur}', "");
    Expect(0, 69552, '\p{ _In_Old_uyghur}', "");
    Expect(1, 69552, '\p{^ _In_Old_uyghur}', "");
    Expect(1, 69552, '\P{ _In_Old_uyghur}', "");
    Expect(0, 69552, '\P{^ _In_Old_uyghur}', "");
    Error('\p{	 in_old_uyghur:=}');
    Error('\P{	 in_old_uyghur:=}');
    Expect(1, 69551, '\p{-_In_Old_uyghur}', "");
    Expect(0, 69551, '\p{^-_In_Old_uyghur}', "");
    Expect(0, 69551, '\P{-_In_Old_uyghur}', "");
    Expect(1, 69551, '\P{^-_In_Old_uyghur}', "");
    Expect(0, 69552, '\p{-_In_Old_uyghur}', "");
    Expect(1, 69552, '\p{^-_In_Old_uyghur}', "");
    Expect(1, 69552, '\P{-_In_Old_uyghur}', "");
    Expect(0, 69552, '\P{^-_In_Old_uyghur}', "");
    Error('\p{:=	_In_Oriya}');
    Error('\P{:=	_In_Oriya}');
    Expect(1, 2943, '\p{inoriya}', "");
    Expect(0, 2943, '\p{^inoriya}', "");
    Expect(0, 2943, '\P{inoriya}', "");
    Expect(1, 2943, '\P{^inoriya}', "");
    Expect(0, 2944, '\p{inoriya}', "");
    Expect(1, 2944, '\p{^inoriya}', "");
    Expect(1, 2944, '\P{inoriya}', "");
    Expect(0, 2944, '\P{^inoriya}', "");
    Expect(1, 2943, '\p{ in_Oriya}', "");
    Expect(0, 2943, '\p{^ in_Oriya}', "");
    Expect(0, 2943, '\P{ in_Oriya}', "");
    Expect(1, 2943, '\P{^ in_Oriya}', "");
    Expect(0, 2944, '\p{ in_Oriya}', "");
    Expect(1, 2944, '\p{^ in_Oriya}', "");
    Expect(1, 2944, '\P{ in_Oriya}', "");
    Expect(0, 2944, '\P{^ in_Oriya}', "");
    Error('\p{/a/ IN_oriya}');
    Error('\P{/a/ IN_oriya}');
    Error('\p{_ In_OSAGE/a/}');
    Error('\P{_ In_OSAGE/a/}');
    Expect(1, 66815, '\p{inosage}', "");
    Expect(0, 66815, '\p{^inosage}', "");
    Expect(0, 66815, '\P{inosage}', "");
    Expect(1, 66815, '\P{^inosage}', "");
    Expect(0, 66816, '\p{inosage}', "");
    Expect(1, 66816, '\p{^inosage}', "");
    Expect(1, 66816, '\P{inosage}', "");
    Expect(0, 66816, '\P{^inosage}', "");
    Expect(1, 66815, '\p{_ in_OSAGE}', "");
    Expect(0, 66815, '\p{^_ in_OSAGE}', "");
    Expect(0, 66815, '\P{_ in_OSAGE}', "");
    Expect(1, 66815, '\P{^_ in_OSAGE}', "");
    Expect(0, 66816, '\p{_ in_OSAGE}', "");
    Expect(1, 66816, '\p{^_ in_OSAGE}', "");
    Expect(1, 66816, '\P{_ in_OSAGE}', "");
    Expect(0, 66816, '\P{^_ in_OSAGE}', "");
    Error('\p{:=	-IN_osage}');
    Error('\P{:=	-IN_osage}');
    Expect(1, 66815, '\p{--IN_osage}', "");
    Expect(0, 66815, '\p{^--IN_osage}', "");
    Expect(0, 66815, '\P{--IN_osage}', "");
    Expect(1, 66815, '\P{^--IN_osage}', "");
    Expect(0, 66816, '\p{--IN_osage}', "");
    Expect(1, 66816, '\p{^--IN_osage}', "");
    Expect(1, 66816, '\P{--IN_osage}', "");
    Expect(0, 66816, '\P{^--IN_osage}', "");
    Error('\p{-:=In_OSMANYA}');
    Error('\P{-:=In_OSMANYA}');
    Expect(1, 66735, '\p{inosmanya}', "");
    Expect(0, 66735, '\p{^inosmanya}', "");
    Expect(0, 66735, '\P{inosmanya}', "");
    Expect(1, 66735, '\P{^inosmanya}', "");
    Expect(0, 66736, '\p{inosmanya}', "");
    Expect(1, 66736, '\p{^inosmanya}', "");
    Expect(1, 66736, '\P{inosmanya}', "");
    Expect(0, 66736, '\P{^inosmanya}', "");
    Expect(1, 66735, '\p{-In_Osmanya}', "");
    Expect(0, 66735, '\p{^-In_Osmanya}', "");
    Expect(0, 66735, '\P{-In_Osmanya}', "");
    Expect(1, 66735, '\P{^-In_Osmanya}', "");
    Expect(0, 66736, '\p{-In_Osmanya}', "");
    Expect(1, 66736, '\p{^-In_Osmanya}', "");
    Expect(1, 66736, '\P{-In_Osmanya}', "");
    Expect(0, 66736, '\P{^-In_Osmanya}', "");
    Error('\p{	:=In_Osmanya}');
    Error('\P{	:=In_Osmanya}');
    Expect(1, 66735, '\p{ in_osmanya}', "");
    Expect(0, 66735, '\p{^ in_osmanya}', "");
    Expect(0, 66735, '\P{ in_osmanya}', "");
    Expect(1, 66735, '\P{^ in_osmanya}', "");
    Expect(0, 66736, '\p{ in_osmanya}', "");
    Expect(1, 66736, '\p{^ in_osmanya}', "");
    Expect(1, 66736, '\P{ in_osmanya}', "");
    Expect(0, 66736, '\P{^ in_osmanya}', "");
    Error('\p{ _IN_PAHAWH_hmong/a/}');
    Error('\P{ _IN_PAHAWH_hmong/a/}');
    Expect(1, 93071, '\p{inpahawhhmong}', "");
    Expect(0, 93071, '\p{^inpahawhhmong}', "");
    Expect(0, 93071, '\P{inpahawhhmong}', "");
    Expect(1, 93071, '\P{^inpahawhhmong}', "");
    Expect(0, 93072, '\p{inpahawhhmong}', "");
    Expect(1, 93072, '\p{^inpahawhhmong}', "");
    Expect(1, 93072, '\P{inpahawhhmong}', "");
    Expect(0, 93072, '\P{^inpahawhhmong}', "");
    Expect(1, 93071, '\p{ In_Pahawh_hmong}', "");
    Expect(0, 93071, '\p{^ In_Pahawh_hmong}', "");
    Expect(0, 93071, '\P{ In_Pahawh_hmong}', "");
    Expect(1, 93071, '\P{^ In_Pahawh_hmong}', "");
    Expect(0, 93072, '\p{ In_Pahawh_hmong}', "");
    Expect(1, 93072, '\p{^ In_Pahawh_hmong}', "");
    Expect(1, 93072, '\P{ In_Pahawh_hmong}', "");
    Expect(0, 93072, '\P{^ In_Pahawh_hmong}', "");
    Error('\p{_:=IN_Pahawh_Hmong}');
    Error('\P{_:=IN_Pahawh_Hmong}');
    Expect(1, 93071, '\p{	 in_pahawh_HMONG}', "");
    Expect(0, 93071, '\p{^	 in_pahawh_HMONG}', "");
    Expect(0, 93071, '\P{	 in_pahawh_HMONG}', "");
    Expect(1, 93071, '\P{^	 in_pahawh_HMONG}', "");
    Expect(0, 93072, '\p{	 in_pahawh_HMONG}', "");
    Expect(1, 93072, '\p{^	 in_pahawh_HMONG}', "");
    Expect(1, 93072, '\P{	 in_pahawh_HMONG}', "");
    Expect(0, 93072, '\P{^	 in_pahawh_HMONG}', "");
    Error('\p{ :=In_Palmyrene}');
    Error('\P{ :=In_Palmyrene}');
    Expect(1, 67711, '\p{inpalmyrene}', "");
    Expect(0, 67711, '\p{^inpalmyrene}', "");
    Expect(0, 67711, '\P{inpalmyrene}', "");
    Expect(1, 67711, '\P{^inpalmyrene}', "");
    Expect(0, 67712, '\p{inpalmyrene}', "");
    Expect(1, 67712, '\p{^inpalmyrene}', "");
    Expect(1, 67712, '\P{inpalmyrene}', "");
    Expect(0, 67712, '\P{^inpalmyrene}', "");
    Expect(1, 67711, '\p{_in_PALMYRENE}', "");
    Expect(0, 67711, '\p{^_in_PALMYRENE}', "");
    Expect(0, 67711, '\P{_in_PALMYRENE}', "");
    Expect(1, 67711, '\P{^_in_PALMYRENE}', "");
    Expect(0, 67712, '\p{_in_PALMYRENE}', "");
    Expect(1, 67712, '\p{^_in_PALMYRENE}', "");
    Expect(1, 67712, '\P{_in_PALMYRENE}', "");
    Expect(0, 67712, '\P{^_in_PALMYRENE}', "");
    Error('\p{	_In_Palmyrene/a/}');
    Error('\P{	_In_Palmyrene/a/}');
    Expect(1, 67711, '\p{  IN_PALMYRENE}', "");
    Expect(0, 67711, '\p{^  IN_PALMYRENE}', "");
    Expect(0, 67711, '\P{  IN_PALMYRENE}', "");
    Expect(1, 67711, '\P{^  IN_PALMYRENE}', "");
    Expect(0, 67712, '\p{  IN_PALMYRENE}', "");
    Expect(1, 67712, '\p{^  IN_PALMYRENE}', "");
    Expect(1, 67712, '\P{  IN_PALMYRENE}', "");
    Expect(0, 67712, '\P{^  IN_PALMYRENE}', "");
    Error('\p{/a/	-IN_pau_Cin_Hau}');
    Error('\P{/a/	-IN_pau_Cin_Hau}');
    Expect(1, 72447, '\p{inpaucinhau}', "");
    Expect(0, 72447, '\p{^inpaucinhau}', "");
    Expect(0, 72447, '\P{inpaucinhau}', "");
    Expect(1, 72447, '\P{^inpaucinhau}', "");
    Expect(0, 72448, '\p{inpaucinhau}', "");
    Expect(1, 72448, '\p{^inpaucinhau}', "");
    Expect(1, 72448, '\P{inpaucinhau}', "");
    Expect(0, 72448, '\P{^inpaucinhau}', "");
    Expect(1, 72447, '\p{ in_PAU_Cin_hau}', "");
    Expect(0, 72447, '\p{^ in_PAU_Cin_hau}', "");
    Expect(0, 72447, '\P{ in_PAU_Cin_hau}', "");
    Expect(1, 72447, '\P{^ in_PAU_Cin_hau}', "");
    Expect(0, 72448, '\p{ in_PAU_Cin_hau}', "");
    Expect(1, 72448, '\p{^ in_PAU_Cin_hau}', "");
    Expect(1, 72448, '\P{ in_PAU_Cin_hau}', "");
    Expect(0, 72448, '\P{^ in_PAU_Cin_hau}', "");
    Error('\p{:=-	In_Pau_Cin_Hau}');
    Error('\P{:=-	In_Pau_Cin_Hau}');
    Expect(1, 72447, '\p{	IN_PAU_cin_HAU}', "");
    Expect(0, 72447, '\p{^	IN_PAU_cin_HAU}', "");
    Expect(0, 72447, '\P{	IN_PAU_cin_HAU}', "");
    Expect(1, 72447, '\P{^	IN_PAU_cin_HAU}', "");
    Expect(0, 72448, '\p{	IN_PAU_cin_HAU}', "");
    Expect(1, 72448, '\p{^	IN_PAU_cin_HAU}', "");
    Expect(1, 72448, '\P{	IN_PAU_cin_HAU}', "");
    Expect(0, 72448, '\P{^	IN_PAU_cin_HAU}', "");
    Error('\p{:=_ IN_PHAGS_pa}');
    Error('\P{:=_ IN_PHAGS_pa}');
    Expect(1, 43135, '\p{inphagspa}', "");
    Expect(0, 43135, '\p{^inphagspa}', "");
    Expect(0, 43135, '\P{inphagspa}', "");
    Expect(1, 43135, '\P{^inphagspa}', "");
    Expect(0, 43136, '\p{inphagspa}', "");
    Expect(1, 43136, '\p{^inphagspa}', "");
    Expect(1, 43136, '\P{inphagspa}', "");
    Expect(0, 43136, '\P{^inphagspa}', "");
    Expect(1, 43135, '\p{ In_PHAGS_Pa}', "");
    Expect(0, 43135, '\p{^ In_PHAGS_Pa}', "");
    Expect(0, 43135, '\P{ In_PHAGS_Pa}', "");
    Expect(1, 43135, '\P{^ In_PHAGS_Pa}', "");
    Expect(0, 43136, '\p{ In_PHAGS_Pa}', "");
    Expect(1, 43136, '\p{^ In_PHAGS_Pa}', "");
    Expect(1, 43136, '\P{ In_PHAGS_Pa}', "");
    Expect(0, 43136, '\P{^ In_PHAGS_Pa}', "");
    Error('\p{/a/_-in_phags_Pa}');
    Error('\P{/a/_-in_phags_Pa}');
    Expect(1, 43135, '\p{-In_Phags_Pa}', "");
    Expect(0, 43135, '\p{^-In_Phags_Pa}', "");
    Expect(0, 43135, '\P{-In_Phags_Pa}', "");
    Expect(1, 43135, '\P{^-In_Phags_Pa}', "");
    Expect(0, 43136, '\p{-In_Phags_Pa}', "");
    Expect(1, 43136, '\p{^-In_Phags_Pa}', "");
    Expect(1, 43136, '\P{-In_Phags_Pa}', "");
    Expect(0, 43136, '\P{^-In_Phags_Pa}', "");
    Error('\p{	_in_Phoenician:=}');
    Error('\P{	_in_Phoenician:=}');
    Expect(1, 67871, '\p{inphoenician}', "");
    Expect(0, 67871, '\p{^inphoenician}', "");
    Expect(0, 67871, '\P{inphoenician}', "");
    Expect(1, 67871, '\P{^inphoenician}', "");
    Expect(0, 67872, '\p{inphoenician}', "");
    Expect(1, 67872, '\p{^inphoenician}', "");
    Expect(1, 67872, '\P{inphoenician}', "");
    Expect(0, 67872, '\P{^inphoenician}', "");
    Expect(1, 67871, '\p{	 in_Phoenician}', "");
    Expect(0, 67871, '\p{^	 in_Phoenician}', "");
    Expect(0, 67871, '\P{	 in_Phoenician}', "");
    Expect(1, 67871, '\P{^	 in_Phoenician}', "");
    Expect(0, 67872, '\p{	 in_Phoenician}', "");
    Expect(1, 67872, '\p{^	 in_Phoenician}', "");
    Expect(1, 67872, '\P{	 in_Phoenician}', "");
    Expect(0, 67872, '\P{^	 in_Phoenician}', "");
    Error('\p{:=__In_phoenician}');
    Error('\P{:=__In_phoenician}');
    Expect(1, 67871, '\p{ 	In_PHOENICIAN}', "");
    Expect(0, 67871, '\p{^ 	In_PHOENICIAN}', "");
    Expect(0, 67871, '\P{ 	In_PHOENICIAN}', "");
    Expect(1, 67871, '\P{^ 	In_PHOENICIAN}', "");
    Expect(0, 67872, '\p{ 	In_PHOENICIAN}', "");
    Expect(1, 67872, '\p{^ 	In_PHOENICIAN}', "");
    Expect(1, 67872, '\P{ 	In_PHOENICIAN}', "");
    Expect(0, 67872, '\P{^ 	In_PHOENICIAN}', "");
    Error('\p{	/a/in_Psalter_Pahlavi}');
    Error('\P{	/a/in_Psalter_Pahlavi}');
    Expect(1, 68527, '\p{inpsalterpahlavi}', "");
    Expect(0, 68527, '\p{^inpsalterpahlavi}', "");
    Expect(0, 68527, '\P{inpsalterpahlavi}', "");
    Expect(1, 68527, '\P{^inpsalterpahlavi}', "");
    Expect(0, 68528, '\p{inpsalterpahlavi}', "");
    Expect(1, 68528, '\p{^inpsalterpahlavi}', "");
    Expect(1, 68528, '\P{inpsalterpahlavi}', "");
    Expect(0, 68528, '\P{^inpsalterpahlavi}', "");
    Expect(1, 68527, '\p{ in_Psalter_pahlavi}', "");
    Expect(0, 68527, '\p{^ in_Psalter_pahlavi}', "");
    Expect(0, 68527, '\P{ in_Psalter_pahlavi}', "");
    Expect(1, 68527, '\P{^ in_Psalter_pahlavi}', "");
    Expect(0, 68528, '\p{ in_Psalter_pahlavi}', "");
    Expect(1, 68528, '\p{^ in_Psalter_pahlavi}', "");
    Expect(1, 68528, '\P{ in_Psalter_pahlavi}', "");
    Expect(0, 68528, '\P{^ in_Psalter_pahlavi}', "");
    Error('\p{/a/ In_Psalter_Pahlavi}');
    Error('\P{/a/ In_Psalter_Pahlavi}');
    Expect(1, 68527, '\p{_ In_Psalter_PAHLAVI}', "");
    Expect(0, 68527, '\p{^_ In_Psalter_PAHLAVI}', "");
    Expect(0, 68527, '\P{_ In_Psalter_PAHLAVI}', "");
    Expect(1, 68527, '\P{^_ In_Psalter_PAHLAVI}', "");
    Expect(0, 68528, '\p{_ In_Psalter_PAHLAVI}', "");
    Expect(1, 68528, '\p{^_ In_Psalter_PAHLAVI}', "");
    Expect(1, 68528, '\P{_ In_Psalter_PAHLAVI}', "");
    Expect(0, 68528, '\P{^_ In_Psalter_PAHLAVI}', "");
    Error('\p{/a/	In_rejang}');
    Error('\P{/a/	In_rejang}');
    Expect(1, 43359, '\p{inrejang}', "");
    Expect(0, 43359, '\p{^inrejang}', "");
    Expect(0, 43359, '\P{inrejang}', "");
    Expect(1, 43359, '\P{^inrejang}', "");
    Expect(0, 43360, '\p{inrejang}', "");
    Expect(1, 43360, '\p{^inrejang}', "");
    Expect(1, 43360, '\P{inrejang}', "");
    Expect(0, 43360, '\P{^inrejang}', "");
    Expect(1, 43359, '\p{-	in_Rejang}', "");
    Expect(0, 43359, '\p{^-	in_Rejang}', "");
    Expect(0, 43359, '\P{-	in_Rejang}', "");
    Expect(1, 43359, '\P{^-	in_Rejang}', "");
    Expect(0, 43360, '\p{-	in_Rejang}', "");
    Expect(1, 43360, '\p{^-	in_Rejang}', "");
    Expect(1, 43360, '\P{-	in_Rejang}', "");
    Expect(0, 43360, '\P{^-	in_Rejang}', "");
    Error('\p{:=--In_Rejang}');
    Error('\P{:=--In_Rejang}');
    Expect(1, 43359, '\p{  In_Rejang}', "");
    Expect(0, 43359, '\p{^  In_Rejang}', "");
    Expect(0, 43359, '\P{  In_Rejang}', "");
    Expect(1, 43359, '\P{^  In_Rejang}', "");
    Expect(0, 43360, '\p{  In_Rejang}', "");
    Expect(1, 43360, '\p{^  In_Rejang}', "");
    Expect(1, 43360, '\P{  In_Rejang}', "");
    Expect(0, 43360, '\P{^  In_Rejang}', "");
    Error('\p{	IN_Runic:=}');
    Error('\P{	IN_Runic:=}');
    Expect(1, 5887, '\p{inrunic}', "");
    Expect(0, 5887, '\p{^inrunic}', "");
    Expect(0, 5887, '\P{inrunic}', "");
    Expect(1, 5887, '\P{^inrunic}', "");
    Expect(0, 5888, '\p{inrunic}', "");
    Expect(1, 5888, '\p{^inrunic}', "");
    Expect(1, 5888, '\P{inrunic}', "");
    Expect(0, 5888, '\P{^inrunic}', "");
    Expect(1, 5887, '\p{	_In_Runic}', "");
    Expect(0, 5887, '\p{^	_In_Runic}', "");
    Expect(0, 5887, '\P{	_In_Runic}', "");
    Expect(1, 5887, '\P{^	_In_Runic}', "");
    Expect(0, 5888, '\p{	_In_Runic}', "");
    Expect(1, 5888, '\p{^	_In_Runic}', "");
    Expect(1, 5888, '\P{	_In_Runic}', "");
    Expect(0, 5888, '\P{^	_In_Runic}', "");
    Error('\p{-:=In_RUNIC}');
    Error('\P{-:=In_RUNIC}');
    Expect(1, 5887, '\p{_	In_Runic}', "");
    Expect(0, 5887, '\p{^_	In_Runic}', "");
    Expect(0, 5887, '\P{_	In_Runic}', "");
    Expect(1, 5887, '\P{^_	In_Runic}', "");
    Expect(0, 5888, '\p{_	In_Runic}', "");
    Expect(1, 5888, '\p{^_	In_Runic}', "");
    Expect(1, 5888, '\P{_	In_Runic}', "");
    Expect(0, 5888, '\P{^_	In_Runic}', "");
    Error('\p{	IN_Samaritan:=}');
    Error('\P{	IN_Samaritan:=}');
    Expect(1, 2111, '\p{insamaritan}', "");
    Expect(0, 2111, '\p{^insamaritan}', "");
    Expect(0, 2111, '\P{insamaritan}', "");
    Expect(1, 2111, '\P{^insamaritan}', "");
    Expect(0, 2112, '\p{insamaritan}', "");
    Expect(1, 2112, '\p{^insamaritan}', "");
    Expect(1, 2112, '\P{insamaritan}', "");
    Expect(0, 2112, '\P{^insamaritan}', "");
    Expect(1, 2111, '\p{-IN_Samaritan}', "");
    Expect(0, 2111, '\p{^-IN_Samaritan}', "");
    Expect(0, 2111, '\P{-IN_Samaritan}', "");
    Expect(1, 2111, '\P{^-IN_Samaritan}', "");
    Expect(0, 2112, '\p{-IN_Samaritan}', "");
    Expect(1, 2112, '\p{^-IN_Samaritan}', "");
    Expect(1, 2112, '\P{-IN_Samaritan}', "");
    Expect(0, 2112, '\P{^-IN_Samaritan}', "");
    Error('\p{/a/-IN_Samaritan}');
    Error('\P{/a/-IN_Samaritan}');
    Expect(1, 2111, '\p{-_In_SAMARITAN}', "");
    Expect(0, 2111, '\p{^-_In_SAMARITAN}', "");
    Expect(0, 2111, '\P{-_In_SAMARITAN}', "");
    Expect(1, 2111, '\P{^-_In_SAMARITAN}', "");
    Expect(0, 2112, '\p{-_In_SAMARITAN}', "");
    Expect(1, 2112, '\p{^-_In_SAMARITAN}', "");
    Expect(1, 2112, '\P{-_In_SAMARITAN}', "");
    Expect(0, 2112, '\P{^-_In_SAMARITAN}', "");
    Error('\p{_:=In_Saurashtra}');
    Error('\P{_:=In_Saurashtra}');
    Expect(1, 43231, '\p{insaurashtra}', "");
    Expect(0, 43231, '\p{^insaurashtra}', "");
    Expect(0, 43231, '\P{insaurashtra}', "");
    Expect(1, 43231, '\P{^insaurashtra}', "");
    Expect(0, 43232, '\p{insaurashtra}', "");
    Expect(1, 43232, '\p{^insaurashtra}', "");
    Expect(1, 43232, '\P{insaurashtra}', "");
    Expect(0, 43232, '\P{^insaurashtra}', "");
    Expect(1, 43231, '\p{-In_saurashtra}', "");
    Expect(0, 43231, '\p{^-In_saurashtra}', "");
    Expect(0, 43231, '\P{-In_saurashtra}', "");
    Expect(1, 43231, '\P{^-In_saurashtra}', "");
    Expect(0, 43232, '\p{-In_saurashtra}', "");
    Expect(1, 43232, '\p{^-In_saurashtra}', "");
    Expect(1, 43232, '\P{-In_saurashtra}', "");
    Expect(0, 43232, '\P{^-In_saurashtra}', "");
    Error('\p{/a/-_In_SAURASHTRA}');
    Error('\P{/a/-_In_SAURASHTRA}');
    Error('\p{:=-	in_sharada}');
    Error('\P{:=-	in_sharada}');
    Expect(1, 70111, '\p{insharada}', "");
    Expect(0, 70111, '\p{^insharada}', "");
    Expect(0, 70111, '\P{insharada}', "");
    Expect(1, 70111, '\P{^insharada}', "");
    Expect(0, 70112, '\p{insharada}', "");
    Expect(1, 70112, '\p{^insharada}', "");
    Expect(1, 70112, '\P{insharada}', "");
    Expect(0, 70112, '\P{^insharada}', "");
    Expect(1, 70111, '\p{__In_SHARADA}', "");
    Expect(0, 70111, '\p{^__In_SHARADA}', "");
    Expect(0, 70111, '\P{__In_SHARADA}', "");
    Expect(1, 70111, '\P{^__In_SHARADA}', "");
    Expect(0, 70112, '\p{__In_SHARADA}', "");
    Expect(1, 70112, '\p{^__In_SHARADA}', "");
    Expect(1, 70112, '\P{__In_SHARADA}', "");
    Expect(0, 70112, '\P{^__In_SHARADA}', "");
    Error('\p{:=-	In_sharada}');
    Error('\P{:=-	In_sharada}');
    Expect(1, 70111, '\p{-In_SHARADA}', "");
    Expect(0, 70111, '\p{^-In_SHARADA}', "");
    Expect(0, 70111, '\P{-In_SHARADA}', "");
    Expect(1, 70111, '\P{^-In_SHARADA}', "");
    Expect(0, 70112, '\p{-In_SHARADA}', "");
    Expect(1, 70112, '\p{^-In_SHARADA}', "");
    Expect(1, 70112, '\P{-In_SHARADA}', "");
    Expect(0, 70112, '\P{^-In_SHARADA}', "");
    Error('\p{_In_Shavian:=}');
    Error('\P{_In_Shavian:=}');
    Expect(1, 66687, '\p{inshavian}', "");
    Expect(0, 66687, '\p{^inshavian}', "");
    Expect(0, 66687, '\P{inshavian}', "");
    Expect(1, 66687, '\P{^inshavian}', "");
    Expect(0, 66688, '\p{inshavian}', "");
    Expect(1, 66688, '\p{^inshavian}', "");
    Expect(1, 66688, '\P{inshavian}', "");
    Expect(0, 66688, '\P{^inshavian}', "");
    Expect(1, 66687, '\p{	in_shavian}', "");
    Expect(0, 66687, '\p{^	in_shavian}', "");
    Expect(0, 66687, '\P{	in_shavian}', "");
    Expect(1, 66687, '\P{^	in_shavian}', "");
    Expect(0, 66688, '\p{	in_shavian}', "");
    Expect(1, 66688, '\p{^	in_shavian}', "");
    Expect(1, 66688, '\P{	in_shavian}', "");
    Expect(0, 66688, '\P{^	in_shavian}', "");
    Error('\p{:=	In_Shavian}');
    Error('\P{:=	In_Shavian}');
    Expect(1, 66687, '\p{-in_Shavian}', "");
    Expect(0, 66687, '\p{^-in_Shavian}', "");
    Expect(0, 66687, '\P{-in_Shavian}', "");
    Expect(1, 66687, '\P{^-in_Shavian}', "");
    Expect(0, 66688, '\p{-in_Shavian}', "");
    Expect(1, 66688, '\p{^-in_Shavian}', "");
    Expect(1, 66688, '\P{-in_Shavian}', "");
    Expect(0, 66688, '\P{^-in_Shavian}', "");
    Error('\p{ /a/IN_siddham}');
    Error('\P{ /a/IN_siddham}');
    Expect(1, 71167, '\p{insiddham}', "");
    Expect(0, 71167, '\p{^insiddham}', "");
    Expect(0, 71167, '\P{insiddham}', "");
    Expect(1, 71167, '\P{^insiddham}', "");
    Expect(0, 71168, '\p{insiddham}', "");
    Expect(1, 71168, '\p{^insiddham}', "");
    Expect(1, 71168, '\P{insiddham}', "");
    Expect(0, 71168, '\P{^insiddham}', "");
    Expect(1, 71167, '\p{	 in_siddham}', "");
    Expect(0, 71167, '\p{^	 in_siddham}', "");
    Expect(0, 71167, '\P{	 in_siddham}', "");
    Expect(1, 71167, '\P{^	 in_siddham}', "");
    Expect(0, 71168, '\p{	 in_siddham}', "");
    Expect(1, 71168, '\p{^	 in_siddham}', "");
    Expect(1, 71168, '\P{	 in_siddham}', "");
    Expect(0, 71168, '\P{^	 in_siddham}', "");
    Error('\p{-:=In_Siddham}');
    Error('\P{-:=In_Siddham}');
    Expect(1, 71167, '\p{	 in_SIDDHAM}', "");
    Expect(0, 71167, '\p{^	 in_SIDDHAM}', "");
    Expect(0, 71167, '\P{	 in_SIDDHAM}', "");
    Expect(1, 71167, '\P{^	 in_SIDDHAM}', "");
    Expect(0, 71168, '\p{	 in_SIDDHAM}', "");
    Expect(1, 71168, '\p{^	 in_SIDDHAM}', "");
    Expect(1, 71168, '\P{	 in_SIDDHAM}', "");
    Expect(0, 71168, '\P{^	 in_SIDDHAM}', "");
    Error('\p{:=		In_SINHALA}');
    Error('\P{:=		In_SINHALA}');
    Expect(1, 3583, '\p{insinhala}', "");
    Expect(0, 3583, '\p{^insinhala}', "");
    Expect(0, 3583, '\P{insinhala}', "");
    Expect(1, 3583, '\P{^insinhala}', "");
    Expect(0, 3584, '\p{insinhala}', "");
    Expect(1, 3584, '\p{^insinhala}', "");
    Expect(1, 3584, '\P{insinhala}', "");
    Expect(0, 3584, '\P{^insinhala}', "");
    Expect(1, 3583, '\p{_-In_Sinhala}', "");
    Expect(0, 3583, '\p{^_-In_Sinhala}', "");
    Expect(0, 3583, '\P{_-In_Sinhala}', "");
    Expect(1, 3583, '\P{^_-In_Sinhala}', "");
    Expect(0, 3584, '\p{_-In_Sinhala}', "");
    Expect(1, 3584, '\p{^_-In_Sinhala}', "");
    Expect(1, 3584, '\P{_-In_Sinhala}', "");
    Expect(0, 3584, '\P{^_-In_Sinhala}', "");
    Error('\p{	:=In_sinhala}');
    Error('\P{	:=In_sinhala}');
    Expect(1, 3583, '\p{ -in_sinhala}', "");
    Expect(0, 3583, '\p{^ -in_sinhala}', "");
    Expect(0, 3583, '\P{ -in_sinhala}', "");
    Expect(1, 3583, '\P{^ -in_sinhala}', "");
    Expect(0, 3584, '\p{ -in_sinhala}', "");
    Expect(1, 3584, '\p{^ -in_sinhala}', "");
    Expect(1, 3584, '\P{ -in_sinhala}', "");
    Expect(0, 3584, '\P{^ -in_sinhala}', "");
    Error('\p{/a/__IN_Sogdian}');
    Error('\P{/a/__IN_Sogdian}');
    Expect(1, 69487, '\p{insogdian}', "");
    Expect(0, 69487, '\p{^insogdian}', "");
    Expect(0, 69487, '\P{insogdian}', "");
    Expect(1, 69487, '\P{^insogdian}', "");
    Expect(0, 69488, '\p{insogdian}', "");
    Expect(1, 69488, '\p{^insogdian}', "");
    Expect(1, 69488, '\P{insogdian}', "");
    Expect(0, 69488, '\P{^insogdian}', "");
    Expect(1, 69487, '\p{-_in_Sogdian}', "");
    Expect(0, 69487, '\p{^-_in_Sogdian}', "");
    Expect(0, 69487, '\P{-_in_Sogdian}', "");
    Expect(1, 69487, '\P{^-_in_Sogdian}', "");
    Expect(0, 69488, '\p{-_in_Sogdian}', "");
    Expect(1, 69488, '\p{^-_in_Sogdian}', "");
    Expect(1, 69488, '\P{-_in_Sogdian}', "");
    Expect(0, 69488, '\P{^-_in_Sogdian}', "");
    Error('\p{_/a/In_Sogdian}');
    Error('\P{_/a/In_Sogdian}');
    Expect(1, 69487, '\p{_IN_SOGDIAN}', "");
    Expect(0, 69487, '\p{^_IN_SOGDIAN}', "");
    Expect(0, 69487, '\P{_IN_SOGDIAN}', "");
    Expect(1, 69487, '\P{^_IN_SOGDIAN}', "");
    Expect(0, 69488, '\p{_IN_SOGDIAN}', "");
    Expect(1, 69488, '\p{^_IN_SOGDIAN}', "");
    Expect(1, 69488, '\P{_IN_SOGDIAN}', "");
    Expect(0, 69488, '\P{^_IN_SOGDIAN}', "");
    Error('\p{/a/	-in_SORA_SOMPENG}');
    Error('\P{/a/	-in_SORA_SOMPENG}');
    Expect(1, 69887, '\p{insorasompeng}', "");
    Expect(0, 69887, '\p{^insorasompeng}', "");
    Expect(0, 69887, '\P{insorasompeng}', "");
    Expect(1, 69887, '\P{^insorasompeng}', "");
    Expect(0, 69888, '\p{insorasompeng}', "");
    Expect(1, 69888, '\p{^insorasompeng}', "");
    Expect(1, 69888, '\P{insorasompeng}', "");
    Expect(0, 69888, '\P{^insorasompeng}', "");
    Expect(1, 69887, '\p{_IN_SORA_SOMPENG}', "");
    Expect(0, 69887, '\p{^_IN_SORA_SOMPENG}', "");
    Expect(0, 69887, '\P{_IN_SORA_SOMPENG}', "");
    Expect(1, 69887, '\P{^_IN_SORA_SOMPENG}', "");
    Expect(0, 69888, '\p{_IN_SORA_SOMPENG}', "");
    Expect(1, 69888, '\p{^_IN_SORA_SOMPENG}', "");
    Expect(1, 69888, '\P{_IN_SORA_SOMPENG}', "");
    Expect(0, 69888, '\P{^_IN_SORA_SOMPENG}', "");
    Error('\p{:=  In_Sora_Sompeng}');
    Error('\P{:=  In_Sora_Sompeng}');
    Expect(1, 69887, '\p{ -IN_SORA_Sompeng}', "");
    Expect(0, 69887, '\p{^ -IN_SORA_Sompeng}', "");
    Expect(0, 69887, '\P{ -IN_SORA_Sompeng}', "");
    Expect(1, 69887, '\P{^ -IN_SORA_Sompeng}', "");
    Expect(0, 69888, '\p{ -IN_SORA_Sompeng}', "");
    Expect(1, 69888, '\p{^ -IN_SORA_Sompeng}', "");
    Expect(1, 69888, '\P{ -IN_SORA_Sompeng}', "");
    Expect(0, 69888, '\P{^ -IN_SORA_Sompeng}', "");
    Error('\p{/a/ -IN_Soyombo}');
    Error('\P{/a/ -IN_Soyombo}');
    Expect(1, 72367, '\p{insoyombo}', "");
    Expect(0, 72367, '\p{^insoyombo}', "");
    Expect(0, 72367, '\P{insoyombo}', "");
    Expect(1, 72367, '\P{^insoyombo}', "");
    Expect(0, 72368, '\p{insoyombo}', "");
    Expect(1, 72368, '\p{^insoyombo}', "");
    Expect(1, 72368, '\P{insoyombo}', "");
    Expect(0, 72368, '\P{^insoyombo}', "");
    Expect(1, 72367, '\p{_ in_Soyombo}', "");
    Expect(0, 72367, '\p{^_ in_Soyombo}', "");
    Expect(0, 72367, '\P{_ in_Soyombo}', "");
    Expect(1, 72367, '\P{^_ in_Soyombo}', "");
    Expect(0, 72368, '\p{_ in_Soyombo}', "");
    Expect(1, 72368, '\p{^_ in_Soyombo}', "");
    Expect(1, 72368, '\P{_ in_Soyombo}', "");
    Expect(0, 72368, '\P{^_ in_Soyombo}', "");
    Error('\p{/a/in_soyombo}');
    Error('\P{/a/in_soyombo}');
    Expect(1, 72367, '\p{	 In_soyombo}', "");
    Expect(0, 72367, '\p{^	 In_soyombo}', "");
    Expect(0, 72367, '\P{	 In_soyombo}', "");
    Expect(1, 72367, '\P{^	 In_soyombo}', "");
    Expect(0, 72368, '\p{	 In_soyombo}', "");
    Expect(1, 72368, '\p{^	 In_soyombo}', "");
    Expect(1, 72368, '\P{	 In_soyombo}', "");
    Expect(0, 72368, '\P{^	 In_soyombo}', "");
    Error('\p{:=_	IN_Sundanese}');
    Error('\P{:=_	IN_Sundanese}');
    Expect(1, 7103, '\p{insundanese}', "");
    Expect(0, 7103, '\p{^insundanese}', "");
    Expect(0, 7103, '\P{insundanese}', "");
    Expect(1, 7103, '\P{^insundanese}', "");
    Expect(0, 7104, '\p{insundanese}', "");
    Expect(1, 7104, '\p{^insundanese}', "");
    Expect(1, 7104, '\P{insundanese}', "");
    Expect(0, 7104, '\P{^insundanese}', "");
    Expect(1, 7103, '\p{--in_sundanese}', "");
    Expect(0, 7103, '\p{^--in_sundanese}', "");
    Expect(0, 7103, '\P{--in_sundanese}', "");
    Expect(1, 7103, '\P{^--in_sundanese}', "");
    Expect(0, 7104, '\p{--in_sundanese}', "");
    Expect(1, 7104, '\p{^--in_sundanese}', "");
    Expect(1, 7104, '\P{--in_sundanese}', "");
    Expect(0, 7104, '\P{^--in_sundanese}', "");
    Error('\p{ 	In_Sundanese:=}');
    Error('\P{ 	In_Sundanese:=}');
    Expect(1, 7103, '\p{_-in_SUNDANESE}', "");
    Expect(0, 7103, '\p{^_-in_SUNDANESE}', "");
    Expect(0, 7103, '\P{_-in_SUNDANESE}', "");
    Expect(1, 7103, '\P{^_-in_SUNDANESE}', "");
    Expect(0, 7104, '\p{_-in_SUNDANESE}', "");
    Expect(1, 7104, '\p{^_-in_SUNDANESE}', "");
    Expect(1, 7104, '\P{_-in_SUNDANESE}', "");
    Expect(0, 7104, '\P{^_-in_SUNDANESE}', "");
    Error('\p{:=	IN_Syloti_nagri}');
    Error('\P{:=	IN_Syloti_nagri}');
    Expect(1, 43055, '\p{insylotinagri}', "");
    Expect(0, 43055, '\p{^insylotinagri}', "");
    Expect(0, 43055, '\P{insylotinagri}', "");
    Expect(1, 43055, '\P{^insylotinagri}', "");
    Expect(0, 43056, '\p{insylotinagri}', "");
    Expect(1, 43056, '\p{^insylotinagri}', "");
    Expect(1, 43056, '\P{insylotinagri}', "");
    Expect(0, 43056, '\P{^insylotinagri}', "");
    Expect(1, 43055, '\p{	In_syloti_NAGRI}', "");
    Expect(0, 43055, '\p{^	In_syloti_NAGRI}', "");
    Expect(0, 43055, '\P{	In_syloti_NAGRI}', "");
    Expect(1, 43055, '\P{^	In_syloti_NAGRI}', "");
    Expect(0, 43056, '\p{	In_syloti_NAGRI}', "");
    Expect(1, 43056, '\p{^	In_syloti_NAGRI}', "");
    Expect(1, 43056, '\P{	In_syloti_NAGRI}', "");
    Expect(0, 43056, '\P{^	In_syloti_NAGRI}', "");
    Error('\p{/a/	In_syloti_Nagri}');
    Error('\P{/a/	In_syloti_Nagri}');
    Expect(1, 43055, '\p{	_in_SYLOTI_nagri}', "");
    Expect(0, 43055, '\p{^	_in_SYLOTI_nagri}', "");
    Expect(0, 43055, '\P{	_in_SYLOTI_nagri}', "");
    Expect(1, 43055, '\P{^	_in_SYLOTI_nagri}', "");
    Expect(0, 43056, '\p{	_in_SYLOTI_nagri}', "");
    Expect(1, 43056, '\p{^	_in_SYLOTI_nagri}', "");
    Expect(1, 43056, '\P{	_in_SYLOTI_nagri}', "");
    Expect(0, 43056, '\P{^	_in_SYLOTI_nagri}', "");
    Error('\p{- IN_Syriac:=}');
    Error('\P{- IN_Syriac:=}');
    Expect(1, 1871, '\p{insyriac}', "");
    Expect(0, 1871, '\p{^insyriac}', "");
    Expect(0, 1871, '\P{insyriac}', "");
    Expect(1, 1871, '\P{^insyriac}', "");
    Expect(0, 1872, '\p{insyriac}', "");
    Expect(1, 1872, '\p{^insyriac}', "");
    Expect(1, 1872, '\P{insyriac}', "");
    Expect(0, 1872, '\P{^insyriac}', "");
    Expect(1, 1871, '\p{	_in_syriac}', "");
    Expect(0, 1871, '\p{^	_in_syriac}', "");
    Expect(0, 1871, '\P{	_in_syriac}', "");
    Expect(1, 1871, '\P{^	_in_syriac}', "");
    Expect(0, 1872, '\p{	_in_syriac}', "");
    Expect(1, 1872, '\p{^	_in_syriac}', "");
    Expect(1, 1872, '\P{	_in_syriac}', "");
    Expect(0, 1872, '\P{^	_in_syriac}', "");
    Error('\p{ :=in_Syriac}');
    Error('\P{ :=in_Syriac}');
    Expect(1, 1871, '\p{ IN_syriac}', "");
    Expect(0, 1871, '\p{^ IN_syriac}', "");
    Expect(0, 1871, '\P{ IN_syriac}', "");
    Expect(1, 1871, '\P{^ IN_syriac}', "");
    Expect(0, 1872, '\p{ IN_syriac}', "");
    Expect(1, 1872, '\p{^ IN_syriac}', "");
    Expect(1, 1872, '\P{ IN_syriac}', "");
    Expect(0, 1872, '\P{^ IN_syriac}', "");
    Error('\p{-_In_TAGALOG:=}');
    Error('\P{-_In_TAGALOG:=}');
    Expect(1, 5919, '\p{intagalog}', "");
    Expect(0, 5919, '\p{^intagalog}', "");
    Expect(0, 5919, '\P{intagalog}', "");
    Expect(1, 5919, '\P{^intagalog}', "");
    Expect(0, 5920, '\p{intagalog}', "");
    Expect(1, 5920, '\p{^intagalog}', "");
    Expect(1, 5920, '\P{intagalog}', "");
    Expect(0, 5920, '\P{^intagalog}', "");
    Expect(1, 5919, '\p{		In_Tagalog}', "");
    Expect(0, 5919, '\p{^		In_Tagalog}', "");
    Expect(0, 5919, '\P{		In_Tagalog}', "");
    Expect(1, 5919, '\P{^		In_Tagalog}', "");
    Expect(0, 5920, '\p{		In_Tagalog}', "");
    Expect(1, 5920, '\p{^		In_Tagalog}', "");
    Expect(1, 5920, '\P{		In_Tagalog}', "");
    Expect(0, 5920, '\P{^		In_Tagalog}', "");
    Error('\p{/a/	-IN_Tagalog}');
    Error('\P{/a/	-IN_Tagalog}');
    Expect(1, 5919, '\p{-	IN_Tagalog}', "");
    Expect(0, 5919, '\p{^-	IN_Tagalog}', "");
    Expect(0, 5919, '\P{-	IN_Tagalog}', "");
    Expect(1, 5919, '\P{^-	IN_Tagalog}', "");
    Expect(0, 5920, '\p{-	IN_Tagalog}', "");
    Expect(1, 5920, '\p{^-	IN_Tagalog}', "");
    Expect(1, 5920, '\P{-	IN_Tagalog}', "");
    Expect(0, 5920, '\P{^-	IN_Tagalog}', "");
    Error('\p{-/a/In_TAGBANWA}');
    Error('\P{-/a/In_TAGBANWA}');
    Expect(1, 6015, '\p{intagbanwa}', "");
    Expect(0, 6015, '\p{^intagbanwa}', "");
    Expect(0, 6015, '\P{intagbanwa}', "");
    Expect(1, 6015, '\P{^intagbanwa}', "");
    Expect(0, 6016, '\p{intagbanwa}', "");
    Expect(1, 6016, '\p{^intagbanwa}', "");
    Expect(1, 6016, '\P{intagbanwa}', "");
    Expect(0, 6016, '\P{^intagbanwa}', "");
    Expect(1, 6015, '\p{- In_Tagbanwa}', "");
    Expect(0, 6015, '\p{^- In_Tagbanwa}', "");
    Expect(0, 6015, '\P{- In_Tagbanwa}', "");
    Expect(1, 6015, '\P{^- In_Tagbanwa}', "");
    Expect(0, 6016, '\p{- In_Tagbanwa}', "");
    Expect(1, 6016, '\p{^- In_Tagbanwa}', "");
    Expect(1, 6016, '\P{- In_Tagbanwa}', "");
    Expect(0, 6016, '\P{^- In_Tagbanwa}', "");
    Error('\p{_	IN_TAGBANWA/a/}');
    Error('\P{_	IN_TAGBANWA/a/}');
    Expect(1, 6015, '\p{_	IN_Tagbanwa}', "");
    Expect(0, 6015, '\p{^_	IN_Tagbanwa}', "");
    Expect(0, 6015, '\P{_	IN_Tagbanwa}', "");
    Expect(1, 6015, '\P{^_	IN_Tagbanwa}', "");
    Expect(0, 6016, '\p{_	IN_Tagbanwa}', "");
    Expect(1, 6016, '\p{^_	IN_Tagbanwa}', "");
    Expect(1, 6016, '\P{_	IN_Tagbanwa}', "");
    Expect(0, 6016, '\P{^_	IN_Tagbanwa}', "");
    Error('\p{_ IN_tai_Le:=}');
    Error('\P{_ IN_tai_Le:=}');
    Expect(1, 6527, '\p{intaile}', "");
    Expect(0, 6527, '\p{^intaile}', "");
    Expect(0, 6527, '\P{intaile}', "");
    Expect(1, 6527, '\P{^intaile}', "");
    Expect(0, 6528, '\p{intaile}', "");
    Expect(1, 6528, '\p{^intaile}', "");
    Expect(1, 6528, '\P{intaile}', "");
    Expect(0, 6528, '\P{^intaile}', "");
    Expect(1, 6527, '\p{ -IN_TAI_Le}', "");
    Expect(0, 6527, '\p{^ -IN_TAI_Le}', "");
    Expect(0, 6527, '\P{ -IN_TAI_Le}', "");
    Expect(1, 6527, '\P{^ -IN_TAI_Le}', "");
    Expect(0, 6528, '\p{ -IN_TAI_Le}', "");
    Expect(1, 6528, '\p{^ -IN_TAI_Le}', "");
    Expect(1, 6528, '\P{ -IN_TAI_Le}', "");
    Expect(0, 6528, '\P{^ -IN_TAI_Le}', "");
    Error('\p{:= -IN_Tai_LE}');
    Error('\P{:= -IN_Tai_LE}');
    Expect(1, 6527, '\p{	 IN_tai_Le}', "");
    Expect(0, 6527, '\p{^	 IN_tai_Le}', "");
    Expect(0, 6527, '\P{	 IN_tai_Le}', "");
    Expect(1, 6527, '\P{^	 IN_tai_Le}', "");
    Expect(0, 6528, '\p{	 IN_tai_Le}', "");
    Expect(1, 6528, '\p{^	 IN_tai_Le}', "");
    Expect(1, 6528, '\P{	 IN_tai_Le}', "");
    Expect(0, 6528, '\P{^	 IN_tai_Le}', "");
    Error('\p{/a/_In_TAI_THAM}');
    Error('\P{/a/_In_TAI_THAM}');
    Expect(1, 6831, '\p{intaitham}', "");
    Expect(0, 6831, '\p{^intaitham}', "");
    Expect(0, 6831, '\P{intaitham}', "");
    Expect(1, 6831, '\P{^intaitham}', "");
    Expect(0, 6832, '\p{intaitham}', "");
    Expect(1, 6832, '\p{^intaitham}', "");
    Expect(1, 6832, '\P{intaitham}', "");
    Expect(0, 6832, '\P{^intaitham}', "");
    Expect(1, 6831, '\p{_	In_Tai_tham}', "");
    Expect(0, 6831, '\p{^_	In_Tai_tham}', "");
    Expect(0, 6831, '\P{_	In_Tai_tham}', "");
    Expect(1, 6831, '\P{^_	In_Tai_tham}', "");
    Expect(0, 6832, '\p{_	In_Tai_tham}', "");
    Expect(1, 6832, '\p{^_	In_Tai_tham}', "");
    Expect(1, 6832, '\P{_	In_Tai_tham}', "");
    Expect(0, 6832, '\P{^_	In_Tai_tham}', "");
    Error('\p{ :=in_tai_Tham}');
    Error('\P{ :=in_tai_Tham}');
    Expect(1, 6831, '\p{-in_Tai_THAM}', "");
    Expect(0, 6831, '\p{^-in_Tai_THAM}', "");
    Expect(0, 6831, '\P{-in_Tai_THAM}', "");
    Expect(1, 6831, '\P{^-in_Tai_THAM}', "");
    Expect(0, 6832, '\p{-in_Tai_THAM}', "");
    Expect(1, 6832, '\p{^-in_Tai_THAM}', "");
    Expect(1, 6832, '\P{-in_Tai_THAM}', "");
    Expect(0, 6832, '\P{^-in_Tai_THAM}', "");
    Error('\p{/a/IN_tai_viet}');
    Error('\P{/a/IN_tai_viet}');
    Expect(1, 43743, '\p{intaiviet}', "");
    Expect(0, 43743, '\p{^intaiviet}', "");
    Expect(0, 43743, '\P{intaiviet}', "");
    Expect(1, 43743, '\P{^intaiviet}', "");
    Expect(0, 43744, '\p{intaiviet}', "");
    Expect(1, 43744, '\p{^intaiviet}', "");
    Expect(1, 43744, '\P{intaiviet}', "");
    Expect(0, 43744, '\P{^intaiviet}', "");
    Expect(1, 43743, '\p{__In_Tai_viet}', "");
    Expect(0, 43743, '\p{^__In_Tai_viet}', "");
    Expect(0, 43743, '\P{__In_Tai_viet}', "");
    Expect(1, 43743, '\P{^__In_Tai_viet}', "");
    Expect(0, 43744, '\p{__In_Tai_viet}', "");
    Expect(1, 43744, '\p{^__In_Tai_viet}', "");
    Expect(1, 43744, '\P{__In_Tai_viet}', "");
    Expect(0, 43744, '\P{^__In_Tai_viet}', "");
    Error('\p{:=_-In_Tai_VIET}');
    Error('\P{:=_-In_Tai_VIET}');
    Expect(1, 43743, '\p{- IN_TAI_Viet}', "");
    Expect(0, 43743, '\p{^- IN_TAI_Viet}', "");
    Expect(0, 43743, '\P{- IN_TAI_Viet}', "");
    Expect(1, 43743, '\P{^- IN_TAI_Viet}', "");
    Expect(0, 43744, '\p{- IN_TAI_Viet}', "");
    Expect(1, 43744, '\p{^- IN_TAI_Viet}', "");
    Expect(1, 43744, '\P{- IN_TAI_Viet}', "");
    Expect(0, 43744, '\P{^- IN_TAI_Viet}', "");
    Error('\p{/a/_In_Takri}');
    Error('\P{/a/_In_Takri}');
    Expect(1, 71375, '\p{intakri}', "");
    Expect(0, 71375, '\p{^intakri}', "");
    Expect(0, 71375, '\P{intakri}', "");
    Expect(1, 71375, '\P{^intakri}', "");
    Expect(0, 71376, '\p{intakri}', "");
    Expect(1, 71376, '\p{^intakri}', "");
    Expect(1, 71376, '\P{intakri}', "");
    Expect(0, 71376, '\P{^intakri}', "");
    Expect(1, 71375, '\p{ 	in_takri}', "");
    Expect(0, 71375, '\p{^ 	in_takri}', "");
    Expect(0, 71375, '\P{ 	in_takri}', "");
    Expect(1, 71375, '\P{^ 	in_takri}', "");
    Expect(0, 71376, '\p{ 	in_takri}', "");
    Expect(1, 71376, '\p{^ 	in_takri}', "");
    Expect(1, 71376, '\P{ 	in_takri}', "");
    Expect(0, 71376, '\P{^ 	in_takri}', "");
    Error('\p{/a/		IN_Takri}');
    Error('\P{/a/		IN_Takri}');
    Expect(1, 71375, '\p{	In_Takri}', "");
    Expect(0, 71375, '\p{^	In_Takri}', "");
    Expect(0, 71375, '\P{	In_Takri}', "");
    Expect(1, 71375, '\P{^	In_Takri}', "");
    Expect(0, 71376, '\p{	In_Takri}', "");
    Expect(1, 71376, '\p{^	In_Takri}', "");
    Expect(1, 71376, '\P{	In_Takri}', "");
    Expect(0, 71376, '\P{^	In_Takri}', "");
    Error('\p{_	in_tamil:=}');
    Error('\P{_	in_tamil:=}');
    Expect(1, 3071, '\p{intamil}', "");
    Expect(0, 3071, '\p{^intamil}', "");
    Expect(0, 3071, '\P{intamil}', "");
    Expect(1, 3071, '\P{^intamil}', "");
    Expect(0, 3072, '\p{intamil}', "");
    Expect(1, 3072, '\p{^intamil}', "");
    Expect(1, 3072, '\P{intamil}', "");
    Expect(0, 3072, '\P{^intamil}', "");
    Expect(1, 3071, '\p{__IN_tamil}', "");
    Expect(0, 3071, '\p{^__IN_tamil}', "");
    Expect(0, 3071, '\P{__IN_tamil}', "");
    Expect(1, 3071, '\P{^__IN_tamil}', "");
    Expect(0, 3072, '\p{__IN_tamil}', "");
    Expect(1, 3072, '\p{^__IN_tamil}', "");
    Expect(1, 3072, '\P{__IN_tamil}', "");
    Expect(0, 3072, '\P{^__IN_tamil}', "");
    Error('\p{/a/-	in_TAMIL}');
    Error('\P{/a/-	in_TAMIL}');
    Expect(1, 3071, '\p{	in_tamil}', "");
    Expect(0, 3071, '\p{^	in_tamil}', "");
    Expect(0, 3071, '\P{	in_tamil}', "");
    Expect(1, 3071, '\P{^	in_tamil}', "");
    Expect(0, 3072, '\p{	in_tamil}', "");
    Expect(1, 3072, '\p{^	in_tamil}', "");
    Expect(1, 3072, '\P{	in_tamil}', "");
    Expect(0, 3072, '\P{^	in_tamil}', "");
    Error('\p{:=	In_TANGSA}');
    Error('\P{:=	In_TANGSA}');
    Expect(1, 92879, '\p{intangsa}', "");
    Expect(0, 92879, '\p{^intangsa}', "");
    Expect(0, 92879, '\P{intangsa}', "");
    Expect(1, 92879, '\P{^intangsa}', "");
    Expect(0, 92880, '\p{intangsa}', "");
    Expect(1, 92880, '\p{^intangsa}', "");
    Expect(1, 92880, '\P{intangsa}', "");
    Expect(0, 92880, '\P{^intangsa}', "");
    Expect(1, 92879, '\p{	_in_Tangsa}', "");
    Expect(0, 92879, '\p{^	_in_Tangsa}', "");
    Expect(0, 92879, '\P{	_in_Tangsa}', "");
    Expect(1, 92879, '\P{^	_in_Tangsa}', "");
    Expect(0, 92880, '\p{	_in_Tangsa}', "");
    Expect(1, 92880, '\p{^	_in_Tangsa}', "");
    Expect(1, 92880, '\P{	_in_Tangsa}', "");
    Expect(0, 92880, '\P{^	_in_Tangsa}', "");
    Error('\p{ /a/IN_tangsa}');
    Error('\P{ /a/IN_tangsa}');
    Expect(1, 92879, '\p{_IN_tangsa}', "");
    Expect(0, 92879, '\p{^_IN_tangsa}', "");
    Expect(0, 92879, '\P{_IN_tangsa}', "");
    Expect(1, 92879, '\P{^_IN_tangsa}', "");
    Expect(0, 92880, '\p{_IN_tangsa}', "");
    Expect(1, 92880, '\p{^_IN_tangsa}', "");
    Expect(1, 92880, '\P{_IN_tangsa}', "");
    Expect(0, 92880, '\P{^_IN_tangsa}', "");
    Error('\p{_/a/IN_TANGUT}');
    Error('\P{_/a/IN_TANGUT}');
    Expect(1, 100351, '\p{intangut}', "");
    Expect(0, 100351, '\p{^intangut}', "");
    Expect(0, 100351, '\P{intangut}', "");
    Expect(1, 100351, '\P{^intangut}', "");
    Expect(0, 100352, '\p{intangut}', "");
    Expect(1, 100352, '\p{^intangut}', "");
    Expect(1, 100352, '\P{intangut}', "");
    Expect(0, 100352, '\P{^intangut}', "");
    Expect(1, 100351, '\p{	-In_tangut}', "");
    Expect(0, 100351, '\p{^	-In_tangut}', "");
    Expect(0, 100351, '\P{	-In_tangut}', "");
    Expect(1, 100351, '\P{^	-In_tangut}', "");
    Expect(0, 100352, '\p{	-In_tangut}', "");
    Expect(1, 100352, '\p{^	-In_tangut}', "");
    Expect(1, 100352, '\P{	-In_tangut}', "");
    Expect(0, 100352, '\P{^	-In_tangut}', "");
    Error('\p{/a/-	In_tangut}');
    Error('\P{/a/-	In_tangut}');
    Expect(1, 100351, '\p{	In_Tangut}', "");
    Expect(0, 100351, '\p{^	In_Tangut}', "");
    Expect(0, 100351, '\P{	In_Tangut}', "");
    Expect(1, 100351, '\P{^	In_Tangut}', "");
    Expect(0, 100352, '\p{	In_Tangut}', "");
    Expect(1, 100352, '\p{^	In_Tangut}', "");
    Expect(1, 100352, '\P{	In_Tangut}', "");
    Expect(0, 100352, '\P{^	In_Tangut}', "");
    Error('\p{:= -In_TELUGU}');
    Error('\P{:= -In_TELUGU}');
    Expect(1, 3199, '\p{intelugu}', "");
    Expect(0, 3199, '\p{^intelugu}', "");
    Expect(0, 3199, '\P{intelugu}', "");
    Expect(1, 3199, '\P{^intelugu}', "");
    Expect(0, 3200, '\p{intelugu}', "");
    Expect(1, 3200, '\p{^intelugu}', "");
    Expect(1, 3200, '\P{intelugu}', "");
    Expect(0, 3200, '\P{^intelugu}', "");
    Expect(1, 3199, '\p{_ In_TELUGU}', "");
    Expect(0, 3199, '\p{^_ In_TELUGU}', "");
    Expect(0, 3199, '\P{_ In_TELUGU}', "");
    Expect(1, 3199, '\P{^_ In_TELUGU}', "");
    Expect(0, 3200, '\p{_ In_TELUGU}', "");
    Expect(1, 3200, '\p{^_ In_TELUGU}', "");
    Expect(1, 3200, '\P{_ In_TELUGU}', "");
    Expect(0, 3200, '\P{^_ In_TELUGU}', "");
    Error('\p{/a/-IN_telugu}');
    Error('\P{/a/-IN_telugu}');
    Expect(1, 3199, '\p{	IN_Telugu}', "");
    Expect(0, 3199, '\p{^	IN_Telugu}', "");
    Expect(0, 3199, '\P{	IN_Telugu}', "");
    Expect(1, 3199, '\P{^	IN_Telugu}', "");
    Expect(0, 3200, '\p{	IN_Telugu}', "");
    Expect(1, 3200, '\p{^	IN_Telugu}', "");
    Expect(1, 3200, '\P{	IN_Telugu}', "");
    Expect(0, 3200, '\P{^	IN_Telugu}', "");
    Error('\p{/a/ -In_Thaana}');
    Error('\P{/a/ -In_Thaana}');
    Expect(1, 1983, '\p{inthaana}', "");
    Expect(0, 1983, '\p{^inthaana}', "");
    Expect(0, 1983, '\P{inthaana}', "");
    Expect(1, 1983, '\P{^inthaana}', "");
    Expect(0, 1984, '\p{inthaana}', "");
    Expect(1, 1984, '\p{^inthaana}', "");
    Expect(1, 1984, '\P{inthaana}', "");
    Expect(0, 1984, '\P{^inthaana}', "");
    Expect(1, 1983, '\p{__In_Thaana}', "");
    Expect(0, 1983, '\p{^__In_Thaana}', "");
    Expect(0, 1983, '\P{__In_Thaana}', "");
    Expect(1, 1983, '\P{^__In_Thaana}', "");
    Expect(0, 1984, '\p{__In_Thaana}', "");
    Expect(1, 1984, '\p{^__In_Thaana}', "");
    Expect(1, 1984, '\P{__In_Thaana}', "");
    Expect(0, 1984, '\P{^__In_Thaana}', "");
    Error('\p{ IN_Thaana/a/}');
    Error('\P{ IN_Thaana/a/}');
    Expect(1, 1983, '\p{		In_thaana}', "");
    Expect(0, 1983, '\p{^		In_thaana}', "");
    Expect(0, 1983, '\P{		In_thaana}', "");
    Expect(1, 1983, '\P{^		In_thaana}', "");
    Expect(0, 1984, '\p{		In_thaana}', "");
    Expect(1, 1984, '\p{^		In_thaana}', "");
    Expect(1, 1984, '\P{		In_thaana}', "");
    Expect(0, 1984, '\P{^		In_thaana}', "");
    Error('\p{_In_THAI/a/}');
    Error('\P{_In_THAI/a/}');
    Expect(1, 3711, '\p{inthai}', "");
    Expect(0, 3711, '\p{^inthai}', "");
    Expect(0, 3711, '\P{inthai}', "");
    Expect(1, 3711, '\P{^inthai}', "");
    Expect(0, 3712, '\p{inthai}', "");
    Expect(1, 3712, '\p{^inthai}', "");
    Expect(1, 3712, '\P{inthai}', "");
    Expect(0, 3712, '\P{^inthai}', "");
    Expect(1, 3711, '\p{ In_Thai}', "");
    Expect(0, 3711, '\p{^ In_Thai}', "");
    Expect(0, 3711, '\P{ In_Thai}', "");
    Expect(1, 3711, '\P{^ In_Thai}', "");
    Expect(0, 3712, '\p{ In_Thai}', "");
    Expect(1, 3712, '\p{^ In_Thai}', "");
    Expect(1, 3712, '\P{ In_Thai}', "");
    Expect(0, 3712, '\P{^ In_Thai}', "");
    Error('\p{	in_THAI/a/}');
    Error('\P{	in_THAI/a/}');
    Expect(1, 3711, '\p{_In_THAI}', "");
    Expect(0, 3711, '\p{^_In_THAI}', "");
    Expect(0, 3711, '\P{_In_THAI}', "");
    Expect(1, 3711, '\P{^_In_THAI}', "");
    Expect(0, 3712, '\p{_In_THAI}', "");
    Expect(1, 3712, '\p{^_In_THAI}', "");
    Expect(1, 3712, '\P{_In_THAI}', "");
    Expect(0, 3712, '\P{^_In_THAI}', "");
    Error('\p{		in_TIBETAN/a/}');
    Error('\P{		in_TIBETAN/a/}');
    Expect(1, 4095, '\p{intibetan}', "");
    Expect(0, 4095, '\p{^intibetan}', "");
    Expect(0, 4095, '\P{intibetan}', "");
    Expect(1, 4095, '\P{^intibetan}', "");
    Expect(0, 4096, '\p{intibetan}', "");
    Expect(1, 4096, '\p{^intibetan}', "");
    Expect(1, 4096, '\P{intibetan}', "");
    Expect(0, 4096, '\P{^intibetan}', "");
    Expect(1, 4095, '\p{--In_tibetan}', "");
    Expect(0, 4095, '\p{^--In_tibetan}', "");
    Expect(0, 4095, '\P{--In_tibetan}', "");
    Expect(1, 4095, '\P{^--In_tibetan}', "");
    Expect(0, 4096, '\p{--In_tibetan}', "");
    Expect(1, 4096, '\p{^--In_tibetan}', "");
    Expect(1, 4096, '\P{--In_tibetan}', "");
    Expect(0, 4096, '\P{^--In_tibetan}', "");
    Error('\p{-/a/IN_TIBETAN}');
    Error('\P{-/a/IN_TIBETAN}');
    Expect(1, 4095, '\p{-IN_Tibetan}', "");
    Expect(0, 4095, '\p{^-IN_Tibetan}', "");
    Expect(0, 4095, '\P{-IN_Tibetan}', "");
    Expect(1, 4095, '\P{^-IN_Tibetan}', "");
    Expect(0, 4096, '\p{-IN_Tibetan}', "");
    Expect(1, 4096, '\p{^-IN_Tibetan}', "");
    Expect(1, 4096, '\P{-IN_Tibetan}', "");
    Expect(0, 4096, '\P{^-IN_Tibetan}', "");
    Error('\p{_In_Tifinagh/a/}');
    Error('\P{_In_Tifinagh/a/}');
    Expect(1, 11647, '\p{intifinagh}', "");
    Expect(0, 11647, '\p{^intifinagh}', "");
    Expect(0, 11647, '\P{intifinagh}', "");
    Expect(1, 11647, '\P{^intifinagh}', "");
    Expect(0, 11648, '\p{intifinagh}', "");
    Expect(1, 11648, '\p{^intifinagh}', "");
    Expect(1, 11648, '\P{intifinagh}', "");
    Expect(0, 11648, '\P{^intifinagh}', "");
    Expect(1, 11647, '\p{_-In_tifinagh}', "");
    Expect(0, 11647, '\p{^_-In_tifinagh}', "");
    Expect(0, 11647, '\P{_-In_tifinagh}', "");
    Expect(1, 11647, '\P{^_-In_tifinagh}', "");
    Expect(0, 11648, '\p{_-In_tifinagh}', "");
    Expect(1, 11648, '\p{^_-In_tifinagh}', "");
    Expect(1, 11648, '\P{_-In_tifinagh}', "");
    Expect(0, 11648, '\P{^_-In_tifinagh}', "");
    Error('\p{_/a/In_TIFINAGH}');
    Error('\P{_/a/In_TIFINAGH}');
    Expect(1, 11647, '\p{	In_Tifinagh}', "");
    Expect(0, 11647, '\p{^	In_Tifinagh}', "");
    Expect(0, 11647, '\P{	In_Tifinagh}', "");
    Expect(1, 11647, '\P{^	In_Tifinagh}', "");
    Expect(0, 11648, '\p{	In_Tifinagh}', "");
    Expect(1, 11648, '\p{^	In_Tifinagh}', "");
    Expect(1, 11648, '\P{	In_Tifinagh}', "");
    Expect(0, 11648, '\P{^	In_Tifinagh}', "");
    Error('\p{_IN_Tirhuta/a/}');
    Error('\P{_IN_Tirhuta/a/}');
    Expect(1, 70879, '\p{intirhuta}', "");
    Expect(0, 70879, '\p{^intirhuta}', "");
    Expect(0, 70879, '\P{intirhuta}', "");
    Expect(1, 70879, '\P{^intirhuta}', "");
    Expect(0, 70880, '\p{intirhuta}', "");
    Expect(1, 70880, '\p{^intirhuta}', "");
    Expect(1, 70880, '\P{intirhuta}', "");
    Expect(0, 70880, '\P{^intirhuta}', "");
    Expect(1, 70879, '\p{ _IN_Tirhuta}', "");
    Expect(0, 70879, '\p{^ _IN_Tirhuta}', "");
    Expect(0, 70879, '\P{ _IN_Tirhuta}', "");
    Expect(1, 70879, '\P{^ _IN_Tirhuta}', "");
    Expect(0, 70880, '\p{ _IN_Tirhuta}', "");
    Expect(1, 70880, '\p{^ _IN_Tirhuta}', "");
    Expect(1, 70880, '\P{ _IN_Tirhuta}', "");
    Expect(0, 70880, '\P{^ _IN_Tirhuta}', "");
    Error('\p{/a/_In_Tirhuta}');
    Error('\P{/a/_In_Tirhuta}');
    Expect(1, 70879, '\p{ 	IN_Tirhuta}', "");
    Expect(0, 70879, '\p{^ 	IN_Tirhuta}', "");
    Expect(0, 70879, '\P{ 	IN_Tirhuta}', "");
    Expect(1, 70879, '\P{^ 	IN_Tirhuta}', "");
    Expect(0, 70880, '\p{ 	IN_Tirhuta}', "");
    Expect(1, 70880, '\p{^ 	IN_Tirhuta}', "");
    Expect(1, 70880, '\P{ 	IN_Tirhuta}', "");
    Expect(0, 70880, '\P{^ 	IN_Tirhuta}', "");
    Error('\p{/a/		In_TOTO}');
    Error('\P{/a/		In_TOTO}');
    Expect(1, 123583, '\p{intoto}', "");
    Expect(0, 123583, '\p{^intoto}', "");
    Expect(0, 123583, '\P{intoto}', "");
    Expect(1, 123583, '\P{^intoto}', "");
    Expect(0, 123584, '\p{intoto}', "");
    Expect(1, 123584, '\p{^intoto}', "");
    Expect(1, 123584, '\P{intoto}', "");
    Expect(0, 123584, '\P{^intoto}', "");
    Expect(1, 123583, '\p{_-In_TOTO}', "");
    Expect(0, 123583, '\p{^_-In_TOTO}', "");
    Expect(0, 123583, '\P{_-In_TOTO}', "");
    Expect(1, 123583, '\P{^_-In_TOTO}', "");
    Expect(0, 123584, '\p{_-In_TOTO}', "");
    Expect(1, 123584, '\p{^_-In_TOTO}', "");
    Expect(1, 123584, '\P{_-In_TOTO}', "");
    Expect(0, 123584, '\P{^_-In_TOTO}', "");
    Error('\p{/a/- in_toto}');
    Error('\P{/a/- in_toto}');
    Expect(1, 123583, '\p{-IN_toto}', "");
    Expect(0, 123583, '\p{^-IN_toto}', "");
    Expect(0, 123583, '\P{-IN_toto}', "");
    Expect(1, 123583, '\P{^-IN_toto}', "");
    Expect(0, 123584, '\p{-IN_toto}', "");
    Expect(1, 123584, '\p{^-IN_toto}', "");
    Expect(1, 123584, '\P{-IN_toto}', "");
    Expect(0, 123584, '\P{^-IN_toto}', "");
    Error('\p{:=_	In_Ugaritic}');
    Error('\P{:=_	In_Ugaritic}');
    Expect(1, 66463, '\p{inugaritic}', "");
    Expect(0, 66463, '\p{^inugaritic}', "");
    Expect(0, 66463, '\P{inugaritic}', "");
    Expect(1, 66463, '\P{^inugaritic}', "");
    Expect(0, 66464, '\p{inugaritic}', "");
    Expect(1, 66464, '\p{^inugaritic}', "");
    Expect(1, 66464, '\P{inugaritic}', "");
    Expect(0, 66464, '\P{^inugaritic}', "");
    Expect(1, 66463, '\p{- In_Ugaritic}', "");
    Expect(0, 66463, '\p{^- In_Ugaritic}', "");
    Expect(0, 66463, '\P{- In_Ugaritic}', "");
    Expect(1, 66463, '\P{^- In_Ugaritic}', "");
    Expect(0, 66464, '\p{- In_Ugaritic}', "");
    Expect(1, 66464, '\p{^- In_Ugaritic}', "");
    Expect(1, 66464, '\P{- In_Ugaritic}', "");
    Expect(0, 66464, '\P{^- In_Ugaritic}', "");
    Error('\p{_	IN_Ugaritic:=}');
    Error('\P{_	IN_Ugaritic:=}');
    Expect(1, 66463, '\p{	In_Ugaritic}', "");
    Expect(0, 66463, '\p{^	In_Ugaritic}', "");
    Expect(0, 66463, '\P{	In_Ugaritic}', "");
    Expect(1, 66463, '\P{^	In_Ugaritic}', "");
    Expect(0, 66464, '\p{	In_Ugaritic}', "");
    Expect(1, 66464, '\p{^	In_Ugaritic}', "");
    Expect(1, 66464, '\P{	In_Ugaritic}', "");
    Expect(0, 66464, '\P{^	In_Ugaritic}', "");
    Error('\p{/a/		IN_vai}');
    Error('\P{/a/		IN_vai}');
    Expect(1, 42559, '\p{invai}', "");
    Expect(0, 42559, '\p{^invai}', "");
    Expect(0, 42559, '\P{invai}', "");
    Expect(1, 42559, '\P{^invai}', "");
    Expect(0, 42560, '\p{invai}', "");
    Expect(1, 42560, '\p{^invai}', "");
    Expect(1, 42560, '\P{invai}', "");
    Expect(0, 42560, '\P{^invai}', "");
    Expect(1, 42559, '\p{		in_vai}', "");
    Expect(0, 42559, '\p{^		in_vai}', "");
    Expect(0, 42559, '\P{		in_vai}', "");
    Expect(1, 42559, '\P{^		in_vai}', "");
    Expect(0, 42560, '\p{		in_vai}', "");
    Expect(1, 42560, '\p{^		in_vai}', "");
    Expect(1, 42560, '\P{		in_vai}', "");
    Expect(0, 42560, '\P{^		in_vai}', "");
    Error('\p{in_VAI:=}');
    Error('\P{in_VAI:=}');
    Expect(1, 42559, '\p{In_Vai}', "");
    Expect(0, 42559, '\p{^In_Vai}', "");
    Expect(0, 42559, '\P{In_Vai}', "");
    Expect(1, 42559, '\P{^In_Vai}', "");
    Expect(0, 42560, '\p{In_Vai}', "");
    Expect(1, 42560, '\p{^In_Vai}', "");
    Expect(1, 42560, '\P{In_Vai}', "");
    Expect(0, 42560, '\P{^In_Vai}', "");
    Error('\p{	In_Vithkuqi/a/}');
    Error('\P{	In_Vithkuqi/a/}');
    Expect(1, 67007, '\p{invithkuqi}', "");
    Expect(0, 67007, '\p{^invithkuqi}', "");
    Expect(0, 67007, '\P{invithkuqi}', "");
    Expect(1, 67007, '\P{^invithkuqi}', "");
    Expect(0, 67008, '\p{invithkuqi}', "");
    Expect(1, 67008, '\p{^invithkuqi}', "");
    Expect(1, 67008, '\P{invithkuqi}', "");
    Expect(0, 67008, '\P{^invithkuqi}', "");
    Expect(1, 67007, '\p{_-in_vithkuqi}', "");
    Expect(0, 67007, '\p{^_-in_vithkuqi}', "");
    Expect(0, 67007, '\P{_-in_vithkuqi}', "");
    Expect(1, 67007, '\P{^_-in_vithkuqi}', "");
    Expect(0, 67008, '\p{_-in_vithkuqi}', "");
    Expect(1, 67008, '\p{^_-in_vithkuqi}', "");
    Expect(1, 67008, '\P{_-in_vithkuqi}', "");
    Expect(0, 67008, '\P{^_-in_vithkuqi}', "");
    Error('\p{_In_VITHKUQI/a/}');
    Error('\P{_In_VITHKUQI/a/}');
    Expect(1, 67007, '\p{ 	In_Vithkuqi}', "");
    Expect(0, 67007, '\p{^ 	In_Vithkuqi}', "");
    Expect(0, 67007, '\P{ 	In_Vithkuqi}', "");
    Expect(1, 67007, '\P{^ 	In_Vithkuqi}', "");
    Expect(0, 67008, '\p{ 	In_Vithkuqi}', "");
    Expect(1, 67008, '\p{^ 	In_Vithkuqi}', "");
    Expect(1, 67008, '\P{ 	In_Vithkuqi}', "");
    Expect(0, 67008, '\P{^ 	In_Vithkuqi}', "");
    Error('\p{:=IN_WANCHO}');
    Error('\P{:=IN_WANCHO}');
    Expect(1, 123647, '\p{inwancho}', "");
    Expect(0, 123647, '\p{^inwancho}', "");
    Expect(0, 123647, '\P{inwancho}', "");
    Expect(1, 123647, '\P{^inwancho}', "");
    Expect(0, 123648, '\p{inwancho}', "");
    Expect(1, 123648, '\p{^inwancho}', "");
    Expect(1, 123648, '\P{inwancho}', "");
    Expect(0, 123648, '\P{^inwancho}', "");
    Expect(1, 123647, '\p{-In_Wancho}', "");
    Expect(0, 123647, '\p{^-In_Wancho}', "");
    Expect(0, 123647, '\P{-In_Wancho}', "");
    Expect(1, 123647, '\P{^-In_Wancho}', "");
    Expect(0, 123648, '\p{-In_Wancho}', "");
    Expect(1, 123648, '\p{^-In_Wancho}', "");
    Expect(1, 123648, '\P{-In_Wancho}', "");
    Expect(0, 123648, '\P{^-In_Wancho}', "");
    Error('\p{ In_wancho/a/}');
    Error('\P{ In_wancho/a/}');
    Expect(1, 123647, '\p{-	In_Wancho}', "");
    Expect(0, 123647, '\p{^-	In_Wancho}', "");
    Expect(0, 123647, '\P{-	In_Wancho}', "");
    Expect(1, 123647, '\P{^-	In_Wancho}', "");
    Expect(0, 123648, '\p{-	In_Wancho}', "");
    Expect(1, 123648, '\p{^-	In_Wancho}', "");
    Expect(1, 123648, '\P{-	In_Wancho}', "");
    Expect(0, 123648, '\P{^-	In_Wancho}', "");
    Error('\p{:=In_Warang_citi}');
    Error('\P{:=In_Warang_citi}');
    Expect(1, 71935, '\p{inwarangciti}', "");
    Expect(0, 71935, '\p{^inwarangciti}', "");
    Expect(0, 71935, '\P{inwarangciti}', "");
    Expect(1, 71935, '\P{^inwarangciti}', "");
    Expect(0, 71936, '\p{inwarangciti}', "");
    Expect(1, 71936, '\p{^inwarangciti}', "");
    Expect(1, 71936, '\P{inwarangciti}', "");
    Expect(0, 71936, '\P{^inwarangciti}', "");
    Expect(1, 71935, '\p{_ in_Warang_citi}', "");
    Expect(0, 71935, '\p{^_ in_Warang_citi}', "");
    Expect(0, 71935, '\P{_ in_Warang_citi}', "");
    Expect(1, 71935, '\P{^_ in_Warang_citi}', "");
    Expect(0, 71936, '\p{_ in_Warang_citi}', "");
    Expect(1, 71936, '\p{^_ in_Warang_citi}', "");
    Expect(1, 71936, '\P{_ in_Warang_citi}', "");
    Expect(0, 71936, '\P{^_ in_Warang_citi}', "");
    Error('\p{ :=IN_WARANG_Citi}');
    Error('\P{ :=IN_WARANG_Citi}');
    Expect(1, 71935, '\p{	 in_warang_CITI}', "");
    Expect(0, 71935, '\p{^	 in_warang_CITI}', "");
    Expect(0, 71935, '\P{	 in_warang_CITI}', "");
    Expect(1, 71935, '\P{^	 in_warang_CITI}', "");
    Expect(0, 71936, '\p{	 in_warang_CITI}', "");
    Expect(1, 71936, '\p{^	 in_warang_CITI}', "");
    Expect(1, 71936, '\P{	 in_warang_CITI}', "");
    Expect(0, 71936, '\P{^	 in_warang_CITI}', "");
    Error('\p{__In_yezidi:=}');
    Error('\P{__In_yezidi:=}');
    Expect(1, 69311, '\p{inyezidi}', "");
    Expect(0, 69311, '\p{^inyezidi}', "");
    Expect(0, 69311, '\P{inyezidi}', "");
    Expect(1, 69311, '\P{^inyezidi}', "");
    Expect(0, 69312, '\p{inyezidi}', "");
    Expect(1, 69312, '\p{^inyezidi}', "");
    Expect(1, 69312, '\P{inyezidi}', "");
    Expect(0, 69312, '\P{^inyezidi}', "");
    Expect(1, 69311, '\p{ IN_YEZIDI}', "");
    Expect(0, 69311, '\p{^ IN_YEZIDI}', "");
    Expect(0, 69311, '\P{ IN_YEZIDI}', "");
    Expect(1, 69311, '\P{^ IN_YEZIDI}', "");
    Expect(0, 69312, '\p{ IN_YEZIDI}', "");
    Expect(1, 69312, '\p{^ IN_YEZIDI}', "");
    Expect(1, 69312, '\P{ IN_YEZIDI}', "");
    Expect(0, 69312, '\P{^ IN_YEZIDI}', "");
    Error('\p{- In_YEZIDI:=}');
    Error('\P{- In_YEZIDI:=}');
    Expect(1, 69311, '\p{	in_YEZIDI}', "");
    Expect(0, 69311, '\p{^	in_YEZIDI}', "");
    Expect(0, 69311, '\P{	in_YEZIDI}', "");
    Expect(1, 69311, '\P{^	in_YEZIDI}', "");
    Expect(0, 69312, '\p{	in_YEZIDI}', "");
    Expect(1, 69312, '\p{^	in_YEZIDI}', "");
    Expect(1, 69312, '\P{	in_YEZIDI}', "");
    Expect(0, 69312, '\P{^	in_YEZIDI}', "");
    Error('\p{:=_In_Zanabazar_SQUARE}');
    Error('\P{:=_In_Zanabazar_SQUARE}');
    Expect(1, 72271, '\p{inzanabazarsquare}', "");
    Expect(0, 72271, '\p{^inzanabazarsquare}', "");
    Expect(0, 72271, '\P{inzanabazarsquare}', "");
    Expect(1, 72271, '\P{^inzanabazarsquare}', "");
    Expect(0, 72272, '\p{inzanabazarsquare}', "");
    Expect(1, 72272, '\p{^inzanabazarsquare}', "");
    Expect(1, 72272, '\P{inzanabazarsquare}', "");
    Expect(0, 72272, '\P{^inzanabazarsquare}', "");
    Expect(1, 72271, '\p{	 in_Zanabazar_square}', "");
    Expect(0, 72271, '\p{^	 in_Zanabazar_square}', "");
    Expect(0, 72271, '\P{	 in_Zanabazar_square}', "");
    Expect(1, 72271, '\P{^	 in_Zanabazar_square}', "");
    Expect(0, 72272, '\p{	 in_Zanabazar_square}', "");
    Expect(1, 72272, '\p{^	 in_Zanabazar_square}', "");
    Expect(1, 72272, '\P{	 in_Zanabazar_square}', "");
    Expect(0, 72272, '\P{^	 in_Zanabazar_square}', "");
    Error('\p{ IN_zanabazar_Square/a/}');
    Error('\P{ IN_zanabazar_Square/a/}');
    Expect(1, 72271, '\p{	_in_Zanabazar_square}', "");
    Expect(0, 72271, '\p{^	_in_Zanabazar_square}', "");
    Expect(0, 72271, '\P{	_in_Zanabazar_square}', "");
    Expect(1, 72271, '\P{^	_in_Zanabazar_square}', "");
    Expect(0, 72272, '\p{	_in_Zanabazar_square}', "");
    Expect(1, 72272, '\p{^	_in_Zanabazar_square}', "");
    Expect(1, 72272, '\P{	_in_Zanabazar_square}', "");
    Expect(0, 72272, '\P{^	_in_Zanabazar_square}', "");
    Error('\p{__Indic_Siyaq_Numbers/a/}');
    Error('\P{__Indic_Siyaq_Numbers/a/}');
    Expect(1, 126143, '\p{indicsiyaqnumbers}', "");
    Expect(0, 126143, '\p{^indicsiyaqnumbers}', "");
    Expect(0, 126143, '\P{indicsiyaqnumbers}', "");
    Expect(1, 126143, '\P{^indicsiyaqnumbers}', "");
    Expect(0, 126144, '\p{indicsiyaqnumbers}', "");
    Expect(1, 126144, '\p{^indicsiyaqnumbers}', "");
    Expect(1, 126144, '\P{indicsiyaqnumbers}', "");
    Expect(0, 126144, '\P{^indicsiyaqnumbers}', "");
    Expect(1, 126143, '\p{--INDIC_Siyaq_NUMBERS}', "");
    Expect(0, 126143, '\p{^--INDIC_Siyaq_NUMBERS}', "");
    Expect(0, 126143, '\P{--INDIC_Siyaq_NUMBERS}', "");
    Expect(1, 126143, '\P{^--INDIC_Siyaq_NUMBERS}', "");
    Expect(0, 126144, '\p{--INDIC_Siyaq_NUMBERS}', "");
    Expect(1, 126144, '\p{^--INDIC_Siyaq_NUMBERS}', "");
    Expect(1, 126144, '\P{--INDIC_Siyaq_NUMBERS}', "");
    Expect(0, 126144, '\P{^--INDIC_Siyaq_NUMBERS}', "");
    Error('\p{_Is_Indic_SIYAQ_numbers/a/}');
    Error('\P{_Is_Indic_SIYAQ_numbers/a/}');
    Expect(1, 126143, '\p{isindicsiyaqnumbers}', "");
    Expect(0, 126143, '\p{^isindicsiyaqnumbers}', "");
    Expect(0, 126143, '\P{isindicsiyaqnumbers}', "");
    Expect(1, 126143, '\P{^isindicsiyaqnumbers}', "");
    Expect(0, 126144, '\p{isindicsiyaqnumbers}', "");
    Expect(1, 126144, '\p{^isindicsiyaqnumbers}', "");
    Expect(1, 126144, '\P{isindicsiyaqnumbers}', "");
    Expect(0, 126144, '\P{^isindicsiyaqnumbers}', "");
    Expect(1, 126143, '\p{-	IS_indic_Siyaq_Numbers}', "");
    Expect(0, 126143, '\p{^-	IS_indic_Siyaq_Numbers}', "");
    Expect(0, 126143, '\P{-	IS_indic_Siyaq_Numbers}', "");
    Expect(1, 126143, '\P{^-	IS_indic_Siyaq_Numbers}', "");
    Expect(0, 126144, '\p{-	IS_indic_Siyaq_Numbers}', "");
    Expect(1, 126144, '\p{^-	IS_indic_Siyaq_Numbers}', "");
    Expect(1, 126144, '\P{-	IS_indic_Siyaq_Numbers}', "");
    Expect(0, 126144, '\P{^-	IS_indic_Siyaq_Numbers}', "");
    Error('\p{In_Indic_siyaq_numbers/a/}');
    Error('\P{In_Indic_siyaq_numbers/a/}');
    Expect(1, 126143, '\p{inindicsiyaqnumbers}', "");
    Expect(0, 126143, '\p{^inindicsiyaqnumbers}', "");
    Expect(0, 126143, '\P{inindicsiyaqnumbers}', "");
    Expect(1, 126143, '\P{^inindicsiyaqnumbers}', "");
    Expect(0, 126144, '\p{inindicsiyaqnumbers}', "");
    Expect(1, 126144, '\p{^inindicsiyaqnumbers}', "");
    Expect(1, 126144, '\P{inindicsiyaqnumbers}', "");
    Expect(0, 126144, '\P{^inindicsiyaqnumbers}', "");
    Expect(1, 126143, '\p{_In_Indic_SIYAQ_Numbers}', "");
    Expect(0, 126143, '\p{^_In_Indic_SIYAQ_Numbers}', "");
    Expect(0, 126143, '\P{_In_Indic_SIYAQ_Numbers}', "");
    Expect(1, 126143, '\P{^_In_Indic_SIYAQ_Numbers}', "");
    Expect(0, 126144, '\p{_In_Indic_SIYAQ_Numbers}', "");
    Expect(1, 126144, '\p{^_In_Indic_SIYAQ_Numbers}', "");
    Expect(1, 126144, '\P{_In_Indic_SIYAQ_Numbers}', "");
    Expect(0, 126144, '\P{^_In_Indic_SIYAQ_Numbers}', "");
    Error('\p{:=-	Inherited}');
    Error('\P{:=-	Inherited}');
    Expect(1, 917999, '\p{inherited}', "");
    Expect(0, 917999, '\p{^inherited}', "");
    Expect(0, 917999, '\P{inherited}', "");
    Expect(1, 917999, '\P{^inherited}', "");
    Expect(0, 918000, '\p{inherited}', "");
    Expect(1, 918000, '\p{^inherited}', "");
    Expect(1, 918000, '\P{inherited}', "");
    Expect(0, 918000, '\P{^inherited}', "");
    Expect(1, 917999, '\p{_ inherited}', "");
    Expect(0, 917999, '\p{^_ inherited}', "");
    Expect(0, 917999, '\P{_ inherited}', "");
    Expect(1, 917999, '\P{^_ inherited}', "");
    Expect(0, 918000, '\p{_ inherited}', "");
    Expect(1, 918000, '\p{^_ inherited}', "");
    Expect(1, 918000, '\P{_ inherited}', "");
    Expect(0, 918000, '\P{^_ inherited}', "");
    Error('\p{:=-_is_INHERITED}');
    Error('\P{:=-_is_INHERITED}');
    Expect(1, 917999, '\p{isinherited}', "");
    Expect(0, 917999, '\p{^isinherited}', "");
    Expect(0, 917999, '\P{isinherited}', "");
    Expect(1, 917999, '\P{^isinherited}', "");
    Expect(0, 918000, '\p{isinherited}', "");
    Expect(1, 918000, '\p{^isinherited}', "");
    Expect(1, 918000, '\P{isinherited}', "");
    Expect(0, 918000, '\P{^isinherited}', "");
    Expect(1, 917999, '\p{ 	Is_INHERITED}', "");
    Expect(0, 917999, '\p{^ 	Is_INHERITED}', "");
    Expect(0, 917999, '\P{ 	Is_INHERITED}', "");
    Expect(1, 917999, '\P{^ 	Is_INHERITED}', "");
    Expect(0, 918000, '\p{ 	Is_INHERITED}', "");
    Expect(1, 918000, '\p{^ 	Is_INHERITED}', "");
    Expect(1, 918000, '\P{ 	Is_INHERITED}', "");
    Expect(0, 918000, '\P{^ 	Is_INHERITED}', "");
    Error('\p{-Zinh/a/}');
    Error('\P{-Zinh/a/}');
    Expect(1, 917999, '\p{zinh}', "");
    Expect(0, 917999, '\p{^zinh}', "");
    Expect(0, 917999, '\P{zinh}', "");
    Expect(1, 917999, '\P{^zinh}', "");
    Expect(0, 918000, '\p{zinh}', "");
    Expect(1, 918000, '\p{^zinh}', "");
    Expect(1, 918000, '\P{zinh}', "");
    Expect(0, 918000, '\P{^zinh}', "");
    Expect(1, 917999, '\p{_-ZINH}', "");
    Expect(0, 917999, '\p{^_-ZINH}', "");
    Expect(0, 917999, '\P{_-ZINH}', "");
    Expect(1, 917999, '\P{^_-ZINH}', "");
    Expect(0, 918000, '\p{_-ZINH}', "");
    Expect(1, 918000, '\p{^_-ZINH}', "");
    Expect(1, 918000, '\P{_-ZINH}', "");
    Expect(0, 918000, '\P{^_-ZINH}', "");
    Error('\p{:=		IS_Zinh}');
    Error('\P{:=		IS_Zinh}');
    Expect(1, 917999, '\p{iszinh}', "");
    Expect(0, 917999, '\p{^iszinh}', "");
    Expect(0, 917999, '\P{iszinh}', "");
    Expect(1, 917999, '\P{^iszinh}', "");
    Expect(0, 918000, '\p{iszinh}', "");
    Expect(1, 918000, '\p{^iszinh}', "");
    Expect(1, 918000, '\P{iszinh}', "");
    Expect(0, 918000, '\P{^iszinh}', "");
    Expect(1, 917999, '\p{_Is_Zinh}', "");
    Expect(0, 917999, '\p{^_Is_Zinh}', "");
    Expect(0, 917999, '\P{_Is_Zinh}', "");
    Expect(1, 917999, '\P{^_Is_Zinh}', "");
    Expect(0, 918000, '\p{_Is_Zinh}', "");
    Expect(1, 918000, '\p{^_Is_Zinh}', "");
    Expect(1, 918000, '\P{_Is_Zinh}', "");
    Expect(0, 918000, '\P{^_Is_Zinh}', "");
    Error('\p{		qaai/a/}');
    Error('\P{		qaai/a/}');
    Expect(1, 917999, '\p{qaai}', "");
    Expect(0, 917999, '\p{^qaai}', "");
    Expect(0, 917999, '\P{qaai}', "");
    Expect(1, 917999, '\P{^qaai}', "");
    Expect(0, 918000, '\p{qaai}', "");
    Expect(1, 918000, '\p{^qaai}', "");
    Expect(1, 918000, '\P{qaai}', "");
    Expect(0, 918000, '\P{^qaai}', "");
    Expect(1, 917999, '\p{  QAAI}', "");
    Expect(0, 917999, '\p{^  QAAI}', "");
    Expect(0, 917999, '\P{  QAAI}', "");
    Expect(1, 917999, '\P{^  QAAI}', "");
    Expect(0, 918000, '\p{  QAAI}', "");
    Expect(1, 918000, '\p{^  QAAI}', "");
    Expect(1, 918000, '\P{  QAAI}', "");
    Expect(0, 918000, '\P{^  QAAI}', "");
    Error('\p{__IS_Qaai:=}');
    Error('\P{__IS_Qaai:=}');
    Expect(1, 917999, '\p{isqaai}', "");
    Expect(0, 917999, '\p{^isqaai}', "");
    Expect(0, 917999, '\P{isqaai}', "");
    Expect(1, 917999, '\P{^isqaai}', "");
    Expect(0, 918000, '\p{isqaai}', "");
    Expect(1, 918000, '\p{^isqaai}', "");
    Expect(1, 918000, '\P{isqaai}', "");
    Expect(0, 918000, '\P{^isqaai}', "");
    Expect(1, 917999, '\p{Is_Qaai}', "");
    Expect(0, 917999, '\p{^Is_Qaai}', "");
    Expect(0, 917999, '\P{Is_Qaai}', "");
    Expect(1, 917999, '\P{^Is_Qaai}', "");
    Expect(0, 918000, '\p{Is_Qaai}', "");
    Expect(1, 918000, '\p{^Is_Qaai}', "");
    Expect(1, 918000, '\P{Is_Qaai}', "");
    Expect(0, 918000, '\P{^Is_Qaai}', "");
    Error('\p{/a/	Initial_punctuation}');
    Error('\P{/a/	Initial_punctuation}');
    Expect(1, 11808, '\p{initialpunctuation}', "");
    Expect(0, 11808, '\p{^initialpunctuation}', "");
    Expect(0, 11808, '\P{initialpunctuation}', "");
    Expect(1, 11808, '\P{^initialpunctuation}', "");
    Expect(0, 11809, '\p{initialpunctuation}', "");
    Expect(1, 11809, '\p{^initialpunctuation}', "");
    Expect(1, 11809, '\P{initialpunctuation}', "");
    Expect(0, 11809, '\P{^initialpunctuation}', "");
    Expect(1, 11808, '\p{	 initial_punctuation}', "");
    Expect(0, 11808, '\p{^	 initial_punctuation}', "");
    Expect(0, 11808, '\P{	 initial_punctuation}', "");
    Expect(1, 11808, '\P{^	 initial_punctuation}', "");
    Expect(0, 11809, '\p{	 initial_punctuation}', "");
    Expect(1, 11809, '\p{^	 initial_punctuation}', "");
    Expect(1, 11809, '\P{	 initial_punctuation}', "");
    Expect(0, 11809, '\P{^	 initial_punctuation}', "");
    Error('\p{:=-Is_Initial_punctuation}');
    Error('\P{:=-Is_Initial_punctuation}');
    Expect(1, 11808, '\p{isinitialpunctuation}', "");
    Expect(0, 11808, '\p{^isinitialpunctuation}', "");
    Expect(0, 11808, '\P{isinitialpunctuation}', "");
    Expect(1, 11808, '\P{^isinitialpunctuation}', "");
    Expect(0, 11809, '\p{isinitialpunctuation}', "");
    Expect(1, 11809, '\p{^isinitialpunctuation}', "");
    Expect(1, 11809, '\P{isinitialpunctuation}', "");
    Expect(0, 11809, '\P{^isinitialpunctuation}', "");
    Expect(1, 11808, '\p{ IS_Initial_Punctuation}', "");
    Expect(0, 11808, '\p{^ IS_Initial_Punctuation}', "");
    Expect(0, 11808, '\P{ IS_Initial_Punctuation}', "");
    Expect(1, 11808, '\P{^ IS_Initial_Punctuation}', "");
    Expect(0, 11809, '\p{ IS_Initial_Punctuation}', "");
    Expect(1, 11809, '\p{^ IS_Initial_Punctuation}', "");
    Expect(1, 11809, '\P{ IS_Initial_Punctuation}', "");
    Expect(0, 11809, '\P{^ IS_Initial_Punctuation}', "");
    Error('\p{:=__PI}');
    Error('\P{:=__PI}');
    Expect(1, 11808, '\p{pi}', "");
    Expect(0, 11808, '\p{^pi}', "");
    Expect(0, 11808, '\P{pi}', "");
    Expect(1, 11808, '\P{^pi}', "");
    Expect(0, 11809, '\p{pi}', "");
    Expect(1, 11809, '\p{^pi}', "");
    Expect(1, 11809, '\P{pi}', "");
    Expect(0, 11809, '\P{^pi}', "");
    Expect(1, 11808, '\p{  Pi}', "");
    Expect(0, 11808, '\p{^  Pi}', "");
    Expect(0, 11808, '\P{  Pi}', "");
    Expect(1, 11808, '\P{^  Pi}', "");
    Expect(0, 11809, '\p{  Pi}', "");
    Expect(1, 11809, '\p{^  Pi}', "");
    Expect(1, 11809, '\P{  Pi}', "");
    Expect(0, 11809, '\P{^  Pi}', "");
    Error('\p{/a/__Is_PI}');
    Error('\P{/a/__Is_PI}');
    Expect(1, 11808, '\p{ispi}', "");
    Expect(0, 11808, '\p{^ispi}', "");
    Expect(0, 11808, '\P{ispi}', "");
    Expect(1, 11808, '\P{^ispi}', "");
    Expect(0, 11809, '\p{ispi}', "");
    Expect(1, 11809, '\p{^ispi}', "");
    Expect(1, 11809, '\P{ispi}', "");
    Expect(0, 11809, '\P{^ispi}', "");
    Expect(1, 11808, '\p{	Is_pi}', "");
    Expect(0, 11808, '\p{^	Is_pi}', "");
    Expect(0, 11808, '\P{	Is_pi}', "");
    Expect(1, 11808, '\P{^	Is_pi}', "");
    Expect(0, 11809, '\p{	Is_pi}', "");
    Expect(1, 11809, '\p{^	Is_pi}', "");
    Expect(1, 11809, '\P{	Is_pi}', "");
    Expect(0, 11809, '\P{^	Is_pi}', "");
    Error('\p{:= inscriptional_PAHLAVI}');
    Error('\P{:= inscriptional_PAHLAVI}');
    Expect(1, 68479, '\p{inscriptionalpahlavi}', "");
    Expect(0, 68479, '\p{^inscriptionalpahlavi}', "");
    Expect(0, 68479, '\P{inscriptionalpahlavi}', "");
    Expect(1, 68479, '\P{^inscriptionalpahlavi}', "");
    Expect(0, 68480, '\p{inscriptionalpahlavi}', "");
    Expect(1, 68480, '\p{^inscriptionalpahlavi}', "");
    Expect(1, 68480, '\P{inscriptionalpahlavi}', "");
    Expect(0, 68480, '\P{^inscriptionalpahlavi}', "");
    Expect(1, 68479, '\p{_Inscriptional_pahlavi}', "");
    Expect(0, 68479, '\p{^_Inscriptional_pahlavi}', "");
    Expect(0, 68479, '\P{_Inscriptional_pahlavi}', "");
    Expect(1, 68479, '\P{^_Inscriptional_pahlavi}', "");
    Expect(0, 68480, '\p{_Inscriptional_pahlavi}', "");
    Expect(1, 68480, '\p{^_Inscriptional_pahlavi}', "");
    Expect(1, 68480, '\P{_Inscriptional_pahlavi}', "");
    Expect(0, 68480, '\P{^_Inscriptional_pahlavi}', "");
    Error('\p{:=	-Is_inscriptional_PAHLAVI}');
    Error('\P{:=	-Is_inscriptional_PAHLAVI}');
    Expect(1, 68479, '\p{isinscriptionalpahlavi}', "");
    Expect(0, 68479, '\p{^isinscriptionalpahlavi}', "");
    Expect(0, 68479, '\P{isinscriptionalpahlavi}', "");
    Expect(1, 68479, '\P{^isinscriptionalpahlavi}', "");
    Expect(0, 68480, '\p{isinscriptionalpahlavi}', "");
    Expect(1, 68480, '\p{^isinscriptionalpahlavi}', "");
    Expect(1, 68480, '\P{isinscriptionalpahlavi}', "");
    Expect(0, 68480, '\P{^isinscriptionalpahlavi}', "");
    Expect(1, 68479, '\p{_ is_Inscriptional_Pahlavi}', "");
    Expect(0, 68479, '\p{^_ is_Inscriptional_Pahlavi}', "");
    Expect(0, 68479, '\P{_ is_Inscriptional_Pahlavi}', "");
    Expect(1, 68479, '\P{^_ is_Inscriptional_Pahlavi}', "");
    Expect(0, 68480, '\p{_ is_Inscriptional_Pahlavi}', "");
    Expect(1, 68480, '\p{^_ is_Inscriptional_Pahlavi}', "");
    Expect(1, 68480, '\P{_ is_Inscriptional_Pahlavi}', "");
    Expect(0, 68480, '\P{^_ is_Inscriptional_Pahlavi}', "");
    Error('\p{:= _PHLI}');
    Error('\P{:= _PHLI}');
    Expect(1, 68479, '\p{phli}', "");
    Expect(0, 68479, '\p{^phli}', "");
    Expect(0, 68479, '\P{phli}', "");
    Expect(1, 68479, '\P{^phli}', "");
    Expect(0, 68480, '\p{phli}', "");
    Expect(1, 68480, '\p{^phli}', "");
    Expect(1, 68480, '\P{phli}', "");
    Expect(0, 68480, '\P{^phli}', "");
    Expect(1, 68479, '\p{	Phli}', "");
    Expect(0, 68479, '\p{^	Phli}', "");
    Expect(0, 68479, '\P{	Phli}', "");
    Expect(1, 68479, '\P{^	Phli}', "");
    Expect(0, 68480, '\p{	Phli}', "");
    Expect(1, 68480, '\p{^	Phli}', "");
    Expect(1, 68480, '\P{	Phli}', "");
    Expect(0, 68480, '\P{^	Phli}', "");
    Error('\p{_:=Is_PHLI}');
    Error('\P{_:=Is_PHLI}');
    Expect(1, 68479, '\p{isphli}', "");
    Expect(0, 68479, '\p{^isphli}', "");
    Expect(0, 68479, '\P{isphli}', "");
    Expect(1, 68479, '\P{^isphli}', "");
    Expect(0, 68480, '\p{isphli}', "");
    Expect(1, 68480, '\p{^isphli}', "");
    Expect(1, 68480, '\P{isphli}', "");
    Expect(0, 68480, '\P{^isphli}', "");
    Expect(1, 68479, '\p{	is_PHLI}', "");
    Expect(0, 68479, '\p{^	is_PHLI}', "");
    Expect(0, 68479, '\P{	is_PHLI}', "");
    Expect(1, 68479, '\P{^	is_PHLI}', "");
    Expect(0, 68480, '\p{	is_PHLI}', "");
    Expect(1, 68480, '\p{^	is_PHLI}', "");
    Expect(1, 68480, '\P{	is_PHLI}', "");
    Expect(0, 68480, '\P{^	is_PHLI}', "");
    Error('\p{-Inscriptional_Parthian/a/}');
    Error('\P{-Inscriptional_Parthian/a/}');
    Expect(1, 68447, '\p{inscriptionalparthian}', "");
    Expect(0, 68447, '\p{^inscriptionalparthian}', "");
    Expect(0, 68447, '\P{inscriptionalparthian}', "");
    Expect(1, 68447, '\P{^inscriptionalparthian}', "");
    Expect(0, 68448, '\p{inscriptionalparthian}', "");
    Expect(1, 68448, '\p{^inscriptionalparthian}', "");
    Expect(1, 68448, '\P{inscriptionalparthian}', "");
    Expect(0, 68448, '\P{^inscriptionalparthian}', "");
    Expect(1, 68447, '\p{ inscriptional_Parthian}', "");
    Expect(0, 68447, '\p{^ inscriptional_Parthian}', "");
    Expect(0, 68447, '\P{ inscriptional_Parthian}', "");
    Expect(1, 68447, '\P{^ inscriptional_Parthian}', "");
    Expect(0, 68448, '\p{ inscriptional_Parthian}', "");
    Expect(1, 68448, '\p{^ inscriptional_Parthian}', "");
    Expect(1, 68448, '\P{ inscriptional_Parthian}', "");
    Expect(0, 68448, '\P{^ inscriptional_Parthian}', "");
    Error('\p{	/a/IS_Inscriptional_Parthian}');
    Error('\P{	/a/IS_Inscriptional_Parthian}');
    Expect(1, 68447, '\p{isinscriptionalparthian}', "");
    Expect(0, 68447, '\p{^isinscriptionalparthian}', "");
    Expect(0, 68447, '\P{isinscriptionalparthian}', "");
    Expect(1, 68447, '\P{^isinscriptionalparthian}', "");
    Expect(0, 68448, '\p{isinscriptionalparthian}', "");
    Expect(1, 68448, '\p{^isinscriptionalparthian}', "");
    Expect(1, 68448, '\P{isinscriptionalparthian}', "");
    Expect(0, 68448, '\P{^isinscriptionalparthian}', "");
    Expect(1, 68447, '\p{ IS_Inscriptional_Parthian}', "");
    Expect(0, 68447, '\p{^ IS_Inscriptional_Parthian}', "");
    Expect(0, 68447, '\P{ IS_Inscriptional_Parthian}', "");
    Expect(1, 68447, '\P{^ IS_Inscriptional_Parthian}', "");
    Expect(0, 68448, '\p{ IS_Inscriptional_Parthian}', "");
    Expect(1, 68448, '\p{^ IS_Inscriptional_Parthian}', "");
    Expect(1, 68448, '\P{ IS_Inscriptional_Parthian}', "");
    Expect(0, 68448, '\P{^ IS_Inscriptional_Parthian}', "");
    Error('\p{ _PRTI:=}');
    Error('\P{ _PRTI:=}');
    Expect(1, 68447, '\p{prti}', "");
    Expect(0, 68447, '\p{^prti}', "");
    Expect(0, 68447, '\P{prti}', "");
    Expect(1, 68447, '\P{^prti}', "");
    Expect(0, 68448, '\p{prti}', "");
    Expect(1, 68448, '\p{^prti}', "");
    Expect(1, 68448, '\P{prti}', "");
    Expect(0, 68448, '\P{^prti}', "");
    Expect(1, 68447, '\p{-_Prti}', "");
    Expect(0, 68447, '\p{^-_Prti}', "");
    Expect(0, 68447, '\P{-_Prti}', "");
    Expect(1, 68447, '\P{^-_Prti}', "");
    Expect(0, 68448, '\p{-_Prti}', "");
    Expect(1, 68448, '\p{^-_Prti}', "");
    Expect(1, 68448, '\P{-_Prti}', "");
    Expect(0, 68448, '\P{^-_Prti}', "");
    Error('\p{/a/__is_Prti}');
    Error('\P{/a/__is_Prti}');
    Expect(1, 68447, '\p{isprti}', "");
    Expect(0, 68447, '\p{^isprti}', "");
    Expect(0, 68447, '\P{isprti}', "");
    Expect(1, 68447, '\P{^isprti}', "");
    Expect(0, 68448, '\p{isprti}', "");
    Expect(1, 68448, '\p{^isprti}', "");
    Expect(1, 68448, '\P{isprti}', "");
    Expect(0, 68448, '\P{^isprti}', "");
    Expect(1, 68447, '\p{_IS_Prti}', "");
    Expect(0, 68447, '\p{^_IS_Prti}', "");
    Expect(0, 68447, '\P{_IS_Prti}', "");
    Expect(1, 68447, '\P{^_IS_Prti}', "");
    Expect(0, 68448, '\p{_IS_Prti}', "");
    Expect(1, 68448, '\p{^_IS_Prti}', "");
    Expect(1, 68448, '\P{_IS_Prti}', "");
    Expect(0, 68448, '\P{^_IS_Prti}', "");
    Error('\p{ -IPA_Extensions:=}');
    Error('\P{ -IPA_Extensions:=}');
    Expect(1, 687, '\p{ipaextensions}', "");
    Expect(0, 687, '\p{^ipaextensions}', "");
    Expect(0, 687, '\P{ipaextensions}', "");
    Expect(1, 687, '\P{^ipaextensions}', "");
    Expect(0, 688, '\p{ipaextensions}', "");
    Expect(1, 688, '\p{^ipaextensions}', "");
    Expect(1, 688, '\P{ipaextensions}', "");
    Expect(0, 688, '\P{^ipaextensions}', "");
    Expect(1, 687, '\p{	IPA_extensions}', "");
    Expect(0, 687, '\p{^	IPA_extensions}', "");
    Expect(0, 687, '\P{	IPA_extensions}', "");
    Expect(1, 687, '\P{^	IPA_extensions}', "");
    Expect(0, 688, '\p{	IPA_extensions}', "");
    Expect(1, 688, '\p{^	IPA_extensions}', "");
    Expect(1, 688, '\P{	IPA_extensions}', "");
    Expect(0, 688, '\P{^	IPA_extensions}', "");
    Error('\p{ -is_IPA_EXTENSIONS:=}');
    Error('\P{ -is_IPA_EXTENSIONS:=}');
    Expect(1, 687, '\p{isipaextensions}', "");
    Expect(0, 687, '\p{^isipaextensions}', "");
    Expect(0, 687, '\P{isipaextensions}', "");
    Expect(1, 687, '\P{^isipaextensions}', "");
    Expect(0, 688, '\p{isipaextensions}', "");
    Expect(1, 688, '\p{^isipaextensions}', "");
    Expect(1, 688, '\P{isipaextensions}', "");
    Expect(0, 688, '\P{^isipaextensions}', "");
    Expect(1, 687, '\p{-_is_IPA_Extensions}', "");
    Expect(0, 687, '\p{^-_is_IPA_Extensions}', "");
    Expect(0, 687, '\P{-_is_IPA_Extensions}', "");
    Expect(1, 687, '\P{^-_is_IPA_Extensions}', "");
    Expect(0, 688, '\p{-_is_IPA_Extensions}', "");
    Expect(1, 688, '\p{^-_is_IPA_Extensions}', "");
    Expect(1, 688, '\P{-_is_IPA_Extensions}', "");
    Expect(0, 688, '\P{^-_is_IPA_Extensions}', "");
    Error('\p{/a/ _In_IPA_Extensions}');
    Error('\P{/a/ _In_IPA_Extensions}');
    Expect(1, 687, '\p{inipaextensions}', "");
    Expect(0, 687, '\p{^inipaextensions}', "");
    Expect(0, 687, '\P{inipaextensions}', "");
    Expect(1, 687, '\P{^inipaextensions}', "");
    Expect(0, 688, '\p{inipaextensions}', "");
    Expect(1, 688, '\p{^inipaextensions}', "");
    Expect(1, 688, '\P{inipaextensions}', "");
    Expect(0, 688, '\P{^inipaextensions}', "");
    Expect(1, 687, '\p{-in_IPA_EXTENSIONS}', "");
    Expect(0, 687, '\p{^-in_IPA_EXTENSIONS}', "");
    Expect(0, 687, '\P{-in_IPA_EXTENSIONS}', "");
    Expect(1, 687, '\P{^-in_IPA_EXTENSIONS}', "");
    Expect(0, 688, '\p{-in_IPA_EXTENSIONS}', "");
    Expect(1, 688, '\p{^-in_IPA_EXTENSIONS}', "");
    Expect(1, 688, '\P{-in_IPA_EXTENSIONS}', "");
    Expect(0, 688, '\P{^-in_IPA_EXTENSIONS}', "");
    Error('\p{/a/__IPA_Ext}');
    Error('\P{/a/__IPA_Ext}');
    Expect(1, 687, '\p{ipaext}', "");
    Expect(0, 687, '\p{^ipaext}', "");
    Expect(0, 687, '\P{ipaext}', "");
    Expect(1, 687, '\P{^ipaext}', "");
    Expect(0, 688, '\p{ipaext}', "");
    Expect(1, 688, '\p{^ipaext}', "");
    Expect(1, 688, '\P{ipaext}', "");
    Expect(0, 688, '\P{^ipaext}', "");
    Expect(1, 687, '\p{-ipa_ext}', "");
    Expect(0, 687, '\p{^-ipa_ext}', "");
    Expect(0, 687, '\P{-ipa_ext}', "");
    Expect(1, 687, '\P{^-ipa_ext}', "");
    Expect(0, 688, '\p{-ipa_ext}', "");
    Expect(1, 688, '\p{^-ipa_ext}', "");
    Expect(1, 688, '\P{-ipa_ext}', "");
    Expect(0, 688, '\P{^-ipa_ext}', "");
    Error('\p{	-Is_ipa_Ext/a/}');
    Error('\P{	-Is_ipa_Ext/a/}');
    Expect(1, 687, '\p{isipaext}', "");
    Expect(0, 687, '\p{^isipaext}', "");
    Expect(0, 687, '\P{isipaext}', "");
    Expect(1, 687, '\P{^isipaext}', "");
    Expect(0, 688, '\p{isipaext}', "");
    Expect(1, 688, '\p{^isipaext}', "");
    Expect(1, 688, '\P{isipaext}', "");
    Expect(0, 688, '\P{^isipaext}', "");
    Expect(1, 687, '\p{ Is_IPA_ext}', "");
    Expect(0, 687, '\p{^ Is_IPA_ext}', "");
    Expect(0, 687, '\P{ Is_IPA_ext}', "");
    Expect(1, 687, '\P{^ Is_IPA_ext}', "");
    Expect(0, 688, '\p{ Is_IPA_ext}', "");
    Expect(1, 688, '\p{^ Is_IPA_ext}', "");
    Expect(1, 688, '\P{ Is_IPA_ext}', "");
    Expect(0, 688, '\P{^ Is_IPA_ext}', "");
    Error('\p{/a/	 In_IPA_ext}');
    Error('\P{/a/	 In_IPA_ext}');
    Expect(1, 687, '\p{inipaext}', "");
    Expect(0, 687, '\p{^inipaext}', "");
    Expect(0, 687, '\P{inipaext}', "");
    Expect(1, 687, '\P{^inipaext}', "");
    Expect(0, 688, '\p{inipaext}', "");
    Expect(1, 688, '\p{^inipaext}', "");
    Expect(1, 688, '\P{inipaext}', "");
    Expect(0, 688, '\P{^inipaext}', "");
    Expect(1, 687, '\p{	_In_IPA_ext}', "");
    Expect(0, 687, '\p{^	_In_IPA_ext}', "");
    Expect(0, 687, '\P{	_In_IPA_ext}', "");
    Expect(1, 687, '\P{^	_In_IPA_ext}', "");
    Expect(0, 688, '\p{	_In_IPA_ext}', "");
    Expect(1, 688, '\p{^	_In_IPA_ext}', "");
    Expect(1, 688, '\P{	_In_IPA_ext}', "");
    Expect(0, 688, '\P{^	_In_IPA_ext}', "");
    Error('\p{	javanese/a/}');
    Error('\P{	javanese/a/}');
    Expect(1, 43487, '\p{javanese}', "");
    Expect(0, 43487, '\p{^javanese}', "");
    Expect(0, 43487, '\P{javanese}', "");
    Expect(1, 43487, '\P{^javanese}', "");
    Expect(0, 43488, '\p{javanese}', "");
    Expect(1, 43488, '\p{^javanese}', "");
    Expect(1, 43488, '\P{javanese}', "");
    Expect(0, 43488, '\P{^javanese}', "");
    Expect(1, 43487, '\p{	JAVANESE}', "");
    Expect(0, 43487, '\p{^	JAVANESE}', "");
    Expect(0, 43487, '\P{	JAVANESE}', "");
    Expect(1, 43487, '\P{^	JAVANESE}', "");
    Expect(0, 43488, '\p{	JAVANESE}', "");
    Expect(1, 43488, '\p{^	JAVANESE}', "");
    Expect(1, 43488, '\P{	JAVANESE}', "");
    Expect(0, 43488, '\P{^	JAVANESE}', "");
    Error('\p{	IS_javanese:=}');
    Error('\P{	IS_javanese:=}');
    Expect(1, 43487, '\p{isjavanese}', "");
    Expect(0, 43487, '\p{^isjavanese}', "");
    Expect(0, 43487, '\P{isjavanese}', "");
    Expect(1, 43487, '\P{^isjavanese}', "");
    Expect(0, 43488, '\p{isjavanese}', "");
    Expect(1, 43488, '\p{^isjavanese}', "");
    Expect(1, 43488, '\P{isjavanese}', "");
    Expect(0, 43488, '\P{^isjavanese}', "");
    Expect(1, 43487, '\p{	is_Javanese}', "");
    Expect(0, 43487, '\p{^	is_Javanese}', "");
    Expect(0, 43487, '\P{	is_Javanese}', "");
    Expect(1, 43487, '\P{^	is_Javanese}', "");
    Expect(0, 43488, '\p{	is_Javanese}', "");
    Expect(1, 43488, '\p{^	is_Javanese}', "");
    Expect(1, 43488, '\P{	is_Javanese}', "");
    Expect(0, 43488, '\P{^	is_Javanese}', "");
    Error('\p{/a/ _Java}');
    Error('\P{/a/ _Java}');
    Expect(1, 43487, '\p{java}', "");
    Expect(0, 43487, '\p{^java}', "");
    Expect(0, 43487, '\P{java}', "");
    Expect(1, 43487, '\P{^java}', "");
    Expect(0, 43488, '\p{java}', "");
    Expect(1, 43488, '\p{^java}', "");
    Expect(1, 43488, '\P{java}', "");
    Expect(0, 43488, '\P{^java}', "");
    Expect(1, 43487, '\p{	-java}', "");
    Expect(0, 43487, '\p{^	-java}', "");
    Expect(0, 43487, '\P{	-java}', "");
    Expect(1, 43487, '\P{^	-java}', "");
    Expect(0, 43488, '\p{	-java}', "");
    Expect(1, 43488, '\p{^	-java}', "");
    Expect(1, 43488, '\P{	-java}', "");
    Expect(0, 43488, '\P{^	-java}', "");
    Error('\p{		Is_java/a/}');
    Error('\P{		Is_java/a/}');
    Expect(1, 43487, '\p{isjava}', "");
    Expect(0, 43487, '\p{^isjava}', "");
    Expect(0, 43487, '\P{isjava}', "");
    Expect(1, 43487, '\P{^isjava}', "");
    Expect(0, 43488, '\p{isjava}', "");
    Expect(1, 43488, '\p{^isjava}', "");
    Expect(1, 43488, '\P{isjava}', "");
    Expect(0, 43488, '\P{^isjava}', "");
    Expect(1, 43487, '\p{		Is_Java}', "");
    Expect(0, 43487, '\p{^		Is_Java}', "");
    Expect(0, 43487, '\P{		Is_Java}', "");
    Expect(1, 43487, '\P{^		Is_Java}', "");
    Expect(0, 43488, '\p{		Is_Java}', "");
    Expect(1, 43488, '\p{^		Is_Java}', "");
    Expect(1, 43488, '\P{		Is_Java}', "");
    Expect(0, 43488, '\P{^		Is_Java}', "");
    Error('\p{_join_CONTROL:=}');
    Error('\P{_join_CONTROL:=}');
    Expect(1, 8205, '\p{joincontrol}', "");
    Expect(0, 8205, '\p{^joincontrol}', "");
    Expect(0, 8205, '\P{joincontrol}', "");
    Expect(1, 8205, '\P{^joincontrol}', "");
    Expect(0, 8206, '\p{joincontrol}', "");
    Expect(1, 8206, '\p{^joincontrol}', "");
    Expect(1, 8206, '\P{joincontrol}', "");
    Expect(0, 8206, '\P{^joincontrol}', "");
    Expect(1, 8205, '\p{-join_control}', "");
    Expect(0, 8205, '\p{^-join_control}', "");
    Expect(0, 8205, '\P{-join_control}', "");
    Expect(1, 8205, '\P{^-join_control}', "");
    Expect(0, 8206, '\p{-join_control}', "");
    Expect(1, 8206, '\p{^-join_control}', "");
    Expect(1, 8206, '\P{-join_control}', "");
    Expect(0, 8206, '\P{^-join_control}', "");
    Error('\p{	IS_JOIN_CONTROL/a/}');
    Error('\P{	IS_JOIN_CONTROL/a/}');
    Expect(1, 8205, '\p{isjoincontrol}', "");
    Expect(0, 8205, '\p{^isjoincontrol}', "");
    Expect(0, 8205, '\P{isjoincontrol}', "");
    Expect(1, 8205, '\P{^isjoincontrol}', "");
    Expect(0, 8206, '\p{isjoincontrol}', "");
    Expect(1, 8206, '\p{^isjoincontrol}', "");
    Expect(1, 8206, '\P{isjoincontrol}', "");
    Expect(0, 8206, '\P{^isjoincontrol}', "");
    Expect(1, 8205, '\p{_is_join_CONTROL}', "");
    Expect(0, 8205, '\p{^_is_join_CONTROL}', "");
    Expect(0, 8205, '\P{_is_join_CONTROL}', "");
    Expect(1, 8205, '\P{^_is_join_CONTROL}', "");
    Expect(0, 8206, '\p{_is_join_CONTROL}', "");
    Expect(1, 8206, '\p{^_is_join_CONTROL}', "");
    Expect(1, 8206, '\P{_is_join_CONTROL}', "");
    Expect(0, 8206, '\P{^_is_join_CONTROL}', "");
    Error('\p{ :=Join_c}');
    Error('\P{ :=Join_c}');
    Expect(1, 8205, '\p{joinc}', "");
    Expect(0, 8205, '\p{^joinc}', "");
    Expect(0, 8205, '\P{joinc}', "");
    Expect(1, 8205, '\P{^joinc}', "");
    Expect(0, 8206, '\p{joinc}', "");
    Expect(1, 8206, '\p{^joinc}', "");
    Expect(1, 8206, '\P{joinc}', "");
    Expect(0, 8206, '\P{^joinc}', "");
    Expect(1, 8205, '\p{ Join_C}', "");
    Expect(0, 8205, '\p{^ Join_C}', "");
    Expect(0, 8205, '\P{ Join_C}', "");
    Expect(1, 8205, '\P{^ Join_C}', "");
    Expect(0, 8206, '\p{ Join_C}', "");
    Expect(1, 8206, '\p{^ Join_C}', "");
    Expect(1, 8206, '\P{ Join_C}', "");
    Expect(0, 8206, '\P{^ Join_C}', "");
    Error('\p{/a/	_IS_join_C}');
    Error('\P{/a/	_IS_join_C}');
    Expect(1, 8205, '\p{isjoinc}', "");
    Expect(0, 8205, '\p{^isjoinc}', "");
    Expect(0, 8205, '\P{isjoinc}', "");
    Expect(1, 8205, '\P{^isjoinc}', "");
    Expect(0, 8206, '\p{isjoinc}', "");
    Expect(1, 8206, '\p{^isjoinc}', "");
    Expect(1, 8206, '\P{isjoinc}', "");
    Expect(0, 8206, '\P{^isjoinc}', "");
    Expect(1, 8205, '\p{		is_Join_C}', "");
    Expect(0, 8205, '\p{^		is_Join_C}', "");
    Expect(0, 8205, '\P{		is_Join_C}', "");
    Expect(1, 8205, '\P{^		is_Join_C}', "");
    Expect(0, 8206, '\p{		is_Join_C}', "");
    Expect(1, 8206, '\p{^		is_Join_C}', "");
    Expect(1, 8206, '\P{		is_Join_C}', "");
    Expect(0, 8206, '\P{^		is_Join_C}', "");
    Error('\p{/a/ KAITHI}');
    Error('\P{/a/ KAITHI}');
    Expect(1, 69837, '\p{kaithi}', "");
    Expect(0, 69837, '\p{^kaithi}', "");
    Expect(0, 69837, '\P{kaithi}', "");
    Expect(1, 69837, '\P{^kaithi}', "");
    Expect(0, 69838, '\p{kaithi}', "");
    Expect(1, 69838, '\p{^kaithi}', "");
    Expect(1, 69838, '\P{kaithi}', "");
    Expect(0, 69838, '\P{^kaithi}', "");
    Expect(1, 69837, '\p{__Kaithi}', "");
    Expect(0, 69837, '\p{^__Kaithi}', "");
    Expect(0, 69837, '\P{__Kaithi}', "");
    Expect(1, 69837, '\P{^__Kaithi}', "");
    Expect(0, 69838, '\p{__Kaithi}', "");
    Expect(1, 69838, '\p{^__Kaithi}', "");
    Expect(1, 69838, '\P{__Kaithi}', "");
    Expect(0, 69838, '\P{^__Kaithi}', "");
    Error('\p{ 	is_KAITHI/a/}');
    Error('\P{ 	is_KAITHI/a/}');
    Expect(1, 69837, '\p{iskaithi}', "");
    Expect(0, 69837, '\p{^iskaithi}', "");
    Expect(0, 69837, '\P{iskaithi}', "");
    Expect(1, 69837, '\P{^iskaithi}', "");
    Expect(0, 69838, '\p{iskaithi}', "");
    Expect(1, 69838, '\p{^iskaithi}', "");
    Expect(1, 69838, '\P{iskaithi}', "");
    Expect(0, 69838, '\P{^iskaithi}', "");
    Expect(1, 69837, '\p{ -is_Kaithi}', "");
    Expect(0, 69837, '\p{^ -is_Kaithi}', "");
    Expect(0, 69837, '\P{ -is_Kaithi}', "");
    Expect(1, 69837, '\P{^ -is_Kaithi}', "");
    Expect(0, 69838, '\p{ -is_Kaithi}', "");
    Expect(1, 69838, '\p{^ -is_Kaithi}', "");
    Expect(1, 69838, '\P{ -is_Kaithi}', "");
    Expect(0, 69838, '\P{^ -is_Kaithi}', "");
    Error('\p{:=-KTHI}');
    Error('\P{:=-KTHI}');
    Expect(1, 69837, '\p{kthi}', "");
    Expect(0, 69837, '\p{^kthi}', "");
    Expect(0, 69837, '\P{kthi}', "");
    Expect(1, 69837, '\P{^kthi}', "");
    Expect(0, 69838, '\p{kthi}', "");
    Expect(1, 69838, '\p{^kthi}', "");
    Expect(1, 69838, '\P{kthi}', "");
    Expect(0, 69838, '\P{^kthi}', "");
    Expect(1, 69837, '\p{__Kthi}', "");
    Expect(0, 69837, '\p{^__Kthi}', "");
    Expect(0, 69837, '\P{__Kthi}', "");
    Expect(1, 69837, '\P{^__Kthi}', "");
    Expect(0, 69838, '\p{__Kthi}', "");
    Expect(1, 69838, '\p{^__Kthi}', "");
    Expect(1, 69838, '\P{__Kthi}', "");
    Expect(0, 69838, '\P{^__Kthi}', "");
    Error('\p{  Is_KTHI/a/}');
    Error('\P{  Is_KTHI/a/}');
    Expect(1, 69837, '\p{iskthi}', "");
    Expect(0, 69837, '\p{^iskthi}', "");
    Expect(0, 69837, '\P{iskthi}', "");
    Expect(1, 69837, '\P{^iskthi}', "");
    Expect(0, 69838, '\p{iskthi}', "");
    Expect(1, 69838, '\p{^iskthi}', "");
    Expect(1, 69838, '\P{iskthi}', "");
    Expect(0, 69838, '\P{^iskthi}', "");
    Expect(1, 69837, '\p{	_is_Kthi}', "");
    Expect(0, 69837, '\p{^	_is_Kthi}', "");
    Expect(0, 69837, '\P{	_is_Kthi}', "");
    Expect(1, 69837, '\P{^	_is_Kthi}', "");
    Expect(0, 69838, '\p{	_is_Kthi}', "");
    Expect(1, 69838, '\p{^	_is_Kthi}', "");
    Expect(1, 69838, '\P{	_is_Kthi}', "");
    Expect(0, 69838, '\P{^	_is_Kthi}', "");
    Error('\p{_/a/kaktovik_Numerals}');
    Error('\P{_/a/kaktovik_Numerals}');
    Expect(1, 119519, '\p{kaktoviknumerals}', "");
    Expect(0, 119519, '\p{^kaktoviknumerals}', "");
    Expect(0, 119519, '\P{kaktoviknumerals}', "");
    Expect(1, 119519, '\P{^kaktoviknumerals}', "");
    Expect(0, 119520, '\p{kaktoviknumerals}', "");
    Expect(1, 119520, '\p{^kaktoviknumerals}', "");
    Expect(1, 119520, '\P{kaktoviknumerals}', "");
    Expect(0, 119520, '\P{^kaktoviknumerals}', "");
    Expect(1, 119519, '\p{_Kaktovik_Numerals}', "");
    Expect(0, 119519, '\p{^_Kaktovik_Numerals}', "");
    Expect(0, 119519, '\P{_Kaktovik_Numerals}', "");
    Expect(1, 119519, '\P{^_Kaktovik_Numerals}', "");
    Expect(0, 119520, '\p{_Kaktovik_Numerals}', "");
    Expect(1, 119520, '\p{^_Kaktovik_Numerals}', "");
    Expect(1, 119520, '\P{_Kaktovik_Numerals}', "");
    Expect(0, 119520, '\P{^_Kaktovik_Numerals}', "");
    Error('\p{	 IS_kaktovik_Numerals/a/}');
    Error('\P{	 IS_kaktovik_Numerals/a/}');
    Expect(1, 119519, '\p{iskaktoviknumerals}', "");
    Expect(0, 119519, '\p{^iskaktoviknumerals}', "");
    Expect(0, 119519, '\P{iskaktoviknumerals}', "");
    Expect(1, 119519, '\P{^iskaktoviknumerals}', "");
    Expect(0, 119520, '\p{iskaktoviknumerals}', "");
    Expect(1, 119520, '\p{^iskaktoviknumerals}', "");
    Expect(1, 119520, '\P{iskaktoviknumerals}', "");
    Expect(0, 119520, '\P{^iskaktoviknumerals}', "");
    Expect(1, 119519, '\p{_Is_KAKTOVIK_Numerals}', "");
    Expect(0, 119519, '\p{^_Is_KAKTOVIK_Numerals}', "");
    Expect(0, 119519, '\P{_Is_KAKTOVIK_Numerals}', "");
    Expect(1, 119519, '\P{^_Is_KAKTOVIK_Numerals}', "");
    Expect(0, 119520, '\p{_Is_KAKTOVIK_Numerals}', "");
    Expect(1, 119520, '\p{^_Is_KAKTOVIK_Numerals}', "");
    Expect(1, 119520, '\P{_Is_KAKTOVIK_Numerals}', "");
    Expect(0, 119520, '\P{^_Is_KAKTOVIK_Numerals}', "");
    Error('\p{/a/in_Kaktovik_Numerals}');
    Error('\P{/a/in_Kaktovik_Numerals}');
    Expect(1, 119519, '\p{inkaktoviknumerals}', "");
    Expect(0, 119519, '\p{^inkaktoviknumerals}', "");
    Expect(0, 119519, '\P{inkaktoviknumerals}', "");
    Expect(1, 119519, '\P{^inkaktoviknumerals}', "");
    Expect(0, 119520, '\p{inkaktoviknumerals}', "");
    Expect(1, 119520, '\p{^inkaktoviknumerals}', "");
    Expect(1, 119520, '\P{inkaktoviknumerals}', "");
    Expect(0, 119520, '\P{^inkaktoviknumerals}', "");
    Expect(1, 119519, '\p{  In_kaktovik_Numerals}', "");
    Expect(0, 119519, '\p{^  In_kaktovik_Numerals}', "");
    Expect(0, 119519, '\P{  In_kaktovik_Numerals}', "");
    Expect(1, 119519, '\P{^  In_kaktovik_Numerals}', "");
    Expect(0, 119520, '\p{  In_kaktovik_Numerals}', "");
    Expect(1, 119520, '\p{^  In_kaktovik_Numerals}', "");
    Expect(1, 119520, '\P{  In_kaktovik_Numerals}', "");
    Expect(0, 119520, '\P{^  In_kaktovik_Numerals}', "");
    Error('\p{_-kana_extended_a:=}');
    Error('\P{_-kana_extended_a:=}');
    Expect(1, 110895, '\p{kanaextendeda}', "");
    Expect(0, 110895, '\p{^kanaextendeda}', "");
    Expect(0, 110895, '\P{kanaextendeda}', "");
    Expect(1, 110895, '\P{^kanaextendeda}', "");
    Expect(0, 110896, '\p{kanaextendeda}', "");
    Expect(1, 110896, '\p{^kanaextendeda}', "");
    Expect(1, 110896, '\P{kanaextendeda}', "");
    Expect(0, 110896, '\P{^kanaextendeda}', "");
    Expect(1, 110895, '\p{-Kana_Extended_a}', "");
    Expect(0, 110895, '\p{^-Kana_Extended_a}', "");
    Expect(0, 110895, '\P{-Kana_Extended_a}', "");
    Expect(1, 110895, '\P{^-Kana_Extended_a}', "");
    Expect(0, 110896, '\p{-Kana_Extended_a}', "");
    Expect(1, 110896, '\p{^-Kana_Extended_a}', "");
    Expect(1, 110896, '\P{-Kana_Extended_a}', "");
    Expect(0, 110896, '\P{^-Kana_Extended_a}', "");
    Error('\p{_:=IS_Kana_Extended_A}');
    Error('\P{_:=IS_Kana_Extended_A}');
    Expect(1, 110895, '\p{iskanaextendeda}', "");
    Expect(0, 110895, '\p{^iskanaextendeda}', "");
    Expect(0, 110895, '\P{iskanaextendeda}', "");
    Expect(1, 110895, '\P{^iskanaextendeda}', "");
    Expect(0, 110896, '\p{iskanaextendeda}', "");
    Expect(1, 110896, '\p{^iskanaextendeda}', "");
    Expect(1, 110896, '\P{iskanaextendeda}', "");
    Expect(0, 110896, '\P{^iskanaextendeda}', "");
    Expect(1, 110895, '\p{ is_kana_EXTENDED_A}', "");
    Expect(0, 110895, '\p{^ is_kana_EXTENDED_A}', "");
    Expect(0, 110895, '\P{ is_kana_EXTENDED_A}', "");
    Expect(1, 110895, '\P{^ is_kana_EXTENDED_A}', "");
    Expect(0, 110896, '\p{ is_kana_EXTENDED_A}', "");
    Expect(1, 110896, '\p{^ is_kana_EXTENDED_A}', "");
    Expect(1, 110896, '\P{ is_kana_EXTENDED_A}', "");
    Expect(0, 110896, '\P{^ is_kana_EXTENDED_A}', "");
    Error('\p{/a/- In_Kana_EXTENDED_A}');
    Error('\P{/a/- In_Kana_EXTENDED_A}');
    Expect(1, 110895, '\p{inkanaextendeda}', "");
    Expect(0, 110895, '\p{^inkanaextendeda}', "");
    Expect(0, 110895, '\P{inkanaextendeda}', "");
    Expect(1, 110895, '\P{^inkanaextendeda}', "");
    Expect(0, 110896, '\p{inkanaextendeda}', "");
    Expect(1, 110896, '\p{^inkanaextendeda}', "");
    Expect(1, 110896, '\P{inkanaextendeda}', "");
    Expect(0, 110896, '\P{^inkanaextendeda}', "");
    Expect(1, 110895, '\p{_ IN_Kana_Extended_A}', "");
    Expect(0, 110895, '\p{^_ IN_Kana_Extended_A}', "");
    Expect(0, 110895, '\P{_ IN_Kana_Extended_A}', "");
    Expect(1, 110895, '\P{^_ IN_Kana_Extended_A}', "");
    Expect(0, 110896, '\p{_ IN_Kana_Extended_A}', "");
    Expect(1, 110896, '\p{^_ IN_Kana_Extended_A}', "");
    Expect(1, 110896, '\P{_ IN_Kana_Extended_A}', "");
    Expect(0, 110896, '\P{^_ IN_Kana_Extended_A}', "");
    Error('\p{:= 	kana_Ext_A}');
    Error('\P{:= 	kana_Ext_A}');
    Expect(1, 110895, '\p{kanaexta}', "");
    Expect(0, 110895, '\p{^kanaexta}', "");
    Expect(0, 110895, '\P{kanaexta}', "");
    Expect(1, 110895, '\P{^kanaexta}', "");
    Expect(0, 110896, '\p{kanaexta}', "");
    Expect(1, 110896, '\p{^kanaexta}', "");
    Expect(1, 110896, '\P{kanaexta}', "");
    Expect(0, 110896, '\P{^kanaexta}', "");
    Expect(1, 110895, '\p{		kana_EXT_a}', "");
    Expect(0, 110895, '\p{^		kana_EXT_a}', "");
    Expect(0, 110895, '\P{		kana_EXT_a}', "");
    Expect(1, 110895, '\P{^		kana_EXT_a}', "");
    Expect(0, 110896, '\p{		kana_EXT_a}', "");
    Expect(1, 110896, '\p{^		kana_EXT_a}', "");
    Expect(1, 110896, '\P{		kana_EXT_a}', "");
    Expect(0, 110896, '\P{^		kana_EXT_a}', "");
    Error('\p{-:=Is_kana_ext_A}');
    Error('\P{-:=Is_kana_ext_A}');
    Expect(1, 110895, '\p{iskanaexta}', "");
    Expect(0, 110895, '\p{^iskanaexta}', "");
    Expect(0, 110895, '\P{iskanaexta}', "");
    Expect(1, 110895, '\P{^iskanaexta}', "");
    Expect(0, 110896, '\p{iskanaexta}', "");
    Expect(1, 110896, '\p{^iskanaexta}', "");
    Expect(1, 110896, '\P{iskanaexta}', "");
    Expect(0, 110896, '\P{^iskanaexta}', "");
    Expect(1, 110895, '\p{Is_KANA_EXT_A}', "");
    Expect(0, 110895, '\p{^Is_KANA_EXT_A}', "");
    Expect(0, 110895, '\P{Is_KANA_EXT_A}', "");
    Expect(1, 110895, '\P{^Is_KANA_EXT_A}', "");
    Expect(0, 110896, '\p{Is_KANA_EXT_A}', "");
    Expect(1, 110896, '\p{^Is_KANA_EXT_A}', "");
    Expect(1, 110896, '\P{Is_KANA_EXT_A}', "");
    Expect(0, 110896, '\P{^Is_KANA_EXT_A}', "");
    Error('\p{  In_KANA_EXT_a/a/}');
    Error('\P{  In_KANA_EXT_a/a/}');
    Expect(1, 110895, '\p{inkanaexta}', "");
    Expect(0, 110895, '\p{^inkanaexta}', "");
    Expect(0, 110895, '\P{inkanaexta}', "");
    Expect(1, 110895, '\P{^inkanaexta}', "");
    Expect(0, 110896, '\p{inkanaexta}', "");
    Expect(1, 110896, '\p{^inkanaexta}', "");
    Expect(1, 110896, '\P{inkanaexta}', "");
    Expect(0, 110896, '\P{^inkanaexta}', "");
    Expect(1, 110895, '\p{	-in_Kana_ext_A}', "");
    Expect(0, 110895, '\p{^	-in_Kana_ext_A}', "");
    Expect(0, 110895, '\P{	-in_Kana_ext_A}', "");
    Expect(1, 110895, '\P{^	-in_Kana_ext_A}', "");
    Expect(0, 110896, '\p{	-in_Kana_ext_A}', "");
    Expect(1, 110896, '\p{^	-in_Kana_ext_A}', "");
    Expect(1, 110896, '\P{	-in_Kana_ext_A}', "");
    Expect(0, 110896, '\P{^	-in_Kana_ext_A}', "");
    Error('\p{:= Kana_Extended_B}');
    Error('\P{:= Kana_Extended_B}');
    Expect(1, 110591, '\p{kanaextendedb}', "");
    Expect(0, 110591, '\p{^kanaextendedb}', "");
    Expect(0, 110591, '\P{kanaextendedb}', "");
    Expect(1, 110591, '\P{^kanaextendedb}', "");
    Expect(0, 110592, '\p{kanaextendedb}', "");
    Expect(1, 110592, '\p{^kanaextendedb}', "");
    Expect(1, 110592, '\P{kanaextendedb}', "");
    Expect(0, 110592, '\P{^kanaextendedb}', "");
    Expect(1, 110591, '\p{- Kana_extended_b}', "");
    Expect(0, 110591, '\p{^- Kana_extended_b}', "");
    Expect(0, 110591, '\P{- Kana_extended_b}', "");
    Expect(1, 110591, '\P{^- Kana_extended_b}', "");
    Expect(0, 110592, '\p{- Kana_extended_b}', "");
    Expect(1, 110592, '\p{^- Kana_extended_b}', "");
    Expect(1, 110592, '\P{- Kana_extended_b}', "");
    Expect(0, 110592, '\P{^- Kana_extended_b}', "");
    Error('\p{		Is_kana_Extended_B:=}');
    Error('\P{		Is_kana_Extended_B:=}');
    Expect(1, 110591, '\p{iskanaextendedb}', "");
    Expect(0, 110591, '\p{^iskanaextendedb}', "");
    Expect(0, 110591, '\P{iskanaextendedb}', "");
    Expect(1, 110591, '\P{^iskanaextendedb}', "");
    Expect(0, 110592, '\p{iskanaextendedb}', "");
    Expect(1, 110592, '\p{^iskanaextendedb}', "");
    Expect(1, 110592, '\P{iskanaextendedb}', "");
    Expect(0, 110592, '\P{^iskanaextendedb}', "");
    Expect(1, 110591, '\p{_ Is_kana_Extended_b}', "");
    Expect(0, 110591, '\p{^_ Is_kana_Extended_b}', "");
    Expect(0, 110591, '\P{_ Is_kana_Extended_b}', "");
    Expect(1, 110591, '\P{^_ Is_kana_Extended_b}', "");
    Expect(0, 110592, '\p{_ Is_kana_Extended_b}', "");
    Expect(1, 110592, '\p{^_ Is_kana_Extended_b}', "");
    Expect(1, 110592, '\P{_ Is_kana_Extended_b}', "");
    Expect(0, 110592, '\P{^_ Is_kana_Extended_b}', "");
    Error('\p{_/a/IN_KANA_Extended_B}');
    Error('\P{_/a/IN_KANA_Extended_B}');
    Expect(1, 110591, '\p{inkanaextendedb}', "");
    Expect(0, 110591, '\p{^inkanaextendedb}', "");
    Expect(0, 110591, '\P{inkanaextendedb}', "");
    Expect(1, 110591, '\P{^inkanaextendedb}', "");
    Expect(0, 110592, '\p{inkanaextendedb}', "");
    Expect(1, 110592, '\p{^inkanaextendedb}', "");
    Expect(1, 110592, '\P{inkanaextendedb}', "");
    Expect(0, 110592, '\P{^inkanaextendedb}', "");
    Expect(1, 110591, '\p{_	In_Kana_EXTENDED_b}', "");
    Expect(0, 110591, '\p{^_	In_Kana_EXTENDED_b}', "");
    Expect(0, 110591, '\P{_	In_Kana_EXTENDED_b}', "");
    Expect(1, 110591, '\P{^_	In_Kana_EXTENDED_b}', "");
    Expect(0, 110592, '\p{_	In_Kana_EXTENDED_b}', "");
    Expect(1, 110592, '\p{^_	In_Kana_EXTENDED_b}', "");
    Expect(1, 110592, '\P{_	In_Kana_EXTENDED_b}', "");
    Expect(0, 110592, '\P{^_	In_Kana_EXTENDED_b}', "");
    Error('\p{:=	_KANA_Ext_b}');
    Error('\P{:=	_KANA_Ext_b}');
    Expect(1, 110591, '\p{kanaextb}', "");
    Expect(0, 110591, '\p{^kanaextb}', "");
    Expect(0, 110591, '\P{kanaextb}', "");
    Expect(1, 110591, '\P{^kanaextb}', "");
    Expect(0, 110592, '\p{kanaextb}', "");
    Expect(1, 110592, '\p{^kanaextb}', "");
    Expect(1, 110592, '\P{kanaextb}', "");
    Expect(0, 110592, '\P{^kanaextb}', "");
    Expect(1, 110591, '\p{_-kana_ext_b}', "");
    Expect(0, 110591, '\p{^_-kana_ext_b}', "");
    Expect(0, 110591, '\P{_-kana_ext_b}', "");
    Expect(1, 110591, '\P{^_-kana_ext_b}', "");
    Expect(0, 110592, '\p{_-kana_ext_b}', "");
    Expect(1, 110592, '\p{^_-kana_ext_b}', "");
    Expect(1, 110592, '\P{_-kana_ext_b}', "");
    Expect(0, 110592, '\P{^_-kana_ext_b}', "");
    Error('\p{-:=Is_Kana_EXT_B}');
    Error('\P{-:=Is_Kana_EXT_B}');
    Expect(1, 110591, '\p{iskanaextb}', "");
    Expect(0, 110591, '\p{^iskanaextb}', "");
    Expect(0, 110591, '\P{iskanaextb}', "");
    Expect(1, 110591, '\P{^iskanaextb}', "");
    Expect(0, 110592, '\p{iskanaextb}', "");
    Expect(1, 110592, '\p{^iskanaextb}', "");
    Expect(1, 110592, '\P{iskanaextb}', "");
    Expect(0, 110592, '\P{^iskanaextb}', "");
    Expect(1, 110591, '\p{	_IS_kana_ext_b}', "");
    Expect(0, 110591, '\p{^	_IS_kana_ext_b}', "");
    Expect(0, 110591, '\P{	_IS_kana_ext_b}', "");
    Expect(1, 110591, '\P{^	_IS_kana_ext_b}', "");
    Expect(0, 110592, '\p{	_IS_kana_ext_b}', "");
    Expect(1, 110592, '\p{^	_IS_kana_ext_b}', "");
    Expect(1, 110592, '\P{	_IS_kana_ext_b}', "");
    Expect(0, 110592, '\P{^	_IS_kana_ext_b}', "");
    Error('\p{:= -In_KANA_ext_B}');
    Error('\P{:= -In_KANA_ext_B}');
    Expect(1, 110591, '\p{inkanaextb}', "");
    Expect(0, 110591, '\p{^inkanaextb}', "");
    Expect(0, 110591, '\P{inkanaextb}', "");
    Expect(1, 110591, '\P{^inkanaextb}', "");
    Expect(0, 110592, '\p{inkanaextb}', "");
    Expect(1, 110592, '\p{^inkanaextb}', "");
    Expect(1, 110592, '\P{inkanaextb}', "");
    Expect(0, 110592, '\P{^inkanaextb}', "");
    Expect(1, 110591, '\p{IN_Kana_ext_B}', "");
    Expect(0, 110591, '\p{^IN_Kana_ext_B}', "");
    Expect(0, 110591, '\P{IN_Kana_ext_B}', "");
    Expect(1, 110591, '\P{^IN_Kana_ext_B}', "");
    Expect(0, 110592, '\p{IN_Kana_ext_B}', "");
    Expect(1, 110592, '\p{^IN_Kana_ext_B}', "");
    Expect(1, 110592, '\P{IN_Kana_ext_B}', "");
    Expect(0, 110592, '\P{^IN_Kana_ext_B}', "");
    Error('\p{:=kana_SUPPLEMENT}');
    Error('\P{:=kana_SUPPLEMENT}');
    Expect(1, 110847, '\p{kanasupplement}', "");
    Expect(0, 110847, '\p{^kanasupplement}', "");
    Expect(0, 110847, '\P{kanasupplement}', "");
    Expect(1, 110847, '\P{^kanasupplement}', "");
    Expect(0, 110848, '\p{kanasupplement}', "");
    Expect(1, 110848, '\p{^kanasupplement}', "");
    Expect(1, 110848, '\P{kanasupplement}', "");
    Expect(0, 110848, '\P{^kanasupplement}', "");
    Expect(1, 110847, '\p{  kana_supplement}', "");
    Expect(0, 110847, '\p{^  kana_supplement}', "");
    Expect(0, 110847, '\P{  kana_supplement}', "");
    Expect(1, 110847, '\P{^  kana_supplement}', "");
    Expect(0, 110848, '\p{  kana_supplement}', "");
    Expect(1, 110848, '\p{^  kana_supplement}', "");
    Expect(1, 110848, '\P{  kana_supplement}', "");
    Expect(0, 110848, '\P{^  kana_supplement}', "");
    Error('\p{:= 	IS_kana_SUPPLEMENT}');
    Error('\P{:= 	IS_kana_SUPPLEMENT}');
    Expect(1, 110847, '\p{iskanasupplement}', "");
    Expect(0, 110847, '\p{^iskanasupplement}', "");
    Expect(0, 110847, '\P{iskanasupplement}', "");
    Expect(1, 110847, '\P{^iskanasupplement}', "");
    Expect(0, 110848, '\p{iskanasupplement}', "");
    Expect(1, 110848, '\p{^iskanasupplement}', "");
    Expect(1, 110848, '\P{iskanasupplement}', "");
    Expect(0, 110848, '\P{^iskanasupplement}', "");
    Expect(1, 110847, '\p{	Is_Kana_SUPPLEMENT}', "");
    Expect(0, 110847, '\p{^	Is_Kana_SUPPLEMENT}', "");
    Expect(0, 110847, '\P{	Is_Kana_SUPPLEMENT}', "");
    Expect(1, 110847, '\P{^	Is_Kana_SUPPLEMENT}', "");
    Expect(0, 110848, '\p{	Is_Kana_SUPPLEMENT}', "");
    Expect(1, 110848, '\p{^	Is_Kana_SUPPLEMENT}', "");
    Expect(1, 110848, '\P{	Is_Kana_SUPPLEMENT}', "");
    Expect(0, 110848, '\P{^	Is_Kana_SUPPLEMENT}', "");
    Error('\p{		in_Kana_Supplement/a/}');
    Error('\P{		in_Kana_Supplement/a/}');
    Expect(1, 110847, '\p{inkanasupplement}', "");
    Expect(0, 110847, '\p{^inkanasupplement}', "");
    Expect(0, 110847, '\P{inkanasupplement}', "");
    Expect(1, 110847, '\P{^inkanasupplement}', "");
    Expect(0, 110848, '\p{inkanasupplement}', "");
    Expect(1, 110848, '\p{^inkanasupplement}', "");
    Expect(1, 110848, '\P{inkanasupplement}', "");
    Expect(0, 110848, '\P{^inkanasupplement}', "");
    Expect(1, 110847, '\p{-	IN_Kana_supplement}', "");
    Expect(0, 110847, '\p{^-	IN_Kana_supplement}', "");
    Expect(0, 110847, '\P{-	IN_Kana_supplement}', "");
    Expect(1, 110847, '\P{^-	IN_Kana_supplement}', "");
    Expect(0, 110848, '\p{-	IN_Kana_supplement}', "");
    Expect(1, 110848, '\p{^-	IN_Kana_supplement}', "");
    Expect(1, 110848, '\P{-	IN_Kana_supplement}', "");
    Expect(0, 110848, '\P{^-	IN_Kana_supplement}', "");
    Error('\p{_/a/Kana_sup}');
    Error('\P{_/a/Kana_sup}');
    Expect(1, 110847, '\p{kanasup}', "");
    Expect(0, 110847, '\p{^kanasup}', "");
    Expect(0, 110847, '\P{kanasup}', "");
    Expect(1, 110847, '\P{^kanasup}', "");
    Expect(0, 110848, '\p{kanasup}', "");
    Expect(1, 110848, '\p{^kanasup}', "");
    Expect(1, 110848, '\P{kanasup}', "");
    Expect(0, 110848, '\P{^kanasup}', "");
    Expect(1, 110847, '\p{ -Kana_Sup}', "");
    Expect(0, 110847, '\p{^ -Kana_Sup}', "");
    Expect(0, 110847, '\P{ -Kana_Sup}', "");
    Expect(1, 110847, '\P{^ -Kana_Sup}', "");
    Expect(0, 110848, '\p{ -Kana_Sup}', "");
    Expect(1, 110848, '\p{^ -Kana_Sup}', "");
    Expect(1, 110848, '\P{ -Kana_Sup}', "");
    Expect(0, 110848, '\P{^ -Kana_Sup}', "");
    Error('\p{:= 	IS_kana_Sup}');
    Error('\P{:= 	IS_kana_Sup}');
    Expect(1, 110847, '\p{iskanasup}', "");
    Expect(0, 110847, '\p{^iskanasup}', "");
    Expect(0, 110847, '\P{iskanasup}', "");
    Expect(1, 110847, '\P{^iskanasup}', "");
    Expect(0, 110848, '\p{iskanasup}', "");
    Expect(1, 110848, '\p{^iskanasup}', "");
    Expect(1, 110848, '\P{iskanasup}', "");
    Expect(0, 110848, '\P{^iskanasup}', "");
    Expect(1, 110847, '\p{Is_Kana_Sup}', "");
    Expect(0, 110847, '\p{^Is_Kana_Sup}', "");
    Expect(0, 110847, '\P{Is_Kana_Sup}', "");
    Expect(1, 110847, '\P{^Is_Kana_Sup}', "");
    Expect(0, 110848, '\p{Is_Kana_Sup}', "");
    Expect(1, 110848, '\p{^Is_Kana_Sup}', "");
    Expect(1, 110848, '\P{Is_Kana_Sup}', "");
    Expect(0, 110848, '\P{^Is_Kana_Sup}', "");
    Error('\p{:=	In_kana_sup}');
    Error('\P{:=	In_kana_sup}');
    Expect(1, 110847, '\p{inkanasup}', "");
    Expect(0, 110847, '\p{^inkanasup}', "");
    Expect(0, 110847, '\P{inkanasup}', "");
    Expect(1, 110847, '\P{^inkanasup}', "");
    Expect(0, 110848, '\p{inkanasup}', "");
    Expect(1, 110848, '\p{^inkanasup}', "");
    Expect(1, 110848, '\P{inkanasup}', "");
    Expect(0, 110848, '\P{^inkanasup}', "");
    Expect(1, 110847, '\p{ In_KANA_Sup}', "");
    Expect(0, 110847, '\p{^ In_KANA_Sup}', "");
    Expect(0, 110847, '\P{ In_KANA_Sup}', "");
    Expect(1, 110847, '\P{^ In_KANA_Sup}', "");
    Expect(0, 110848, '\p{ In_KANA_Sup}', "");
    Expect(1, 110848, '\p{^ In_KANA_Sup}', "");
    Expect(1, 110848, '\P{ In_KANA_Sup}', "");
    Expect(0, 110848, '\P{^ In_KANA_Sup}', "");
    Error('\p{/a/ Kanbun}');
    Error('\P{/a/ Kanbun}');
    Expect(1, 12703, '\p{kanbun}', "");
    Expect(0, 12703, '\p{^kanbun}', "");
    Expect(0, 12703, '\P{kanbun}', "");
    Expect(1, 12703, '\P{^kanbun}', "");
    Expect(0, 12704, '\p{kanbun}', "");
    Expect(1, 12704, '\p{^kanbun}', "");
    Expect(1, 12704, '\P{kanbun}', "");
    Expect(0, 12704, '\P{^kanbun}', "");
    Expect(1, 12703, '\p{	kanbun}', "");
    Expect(0, 12703, '\p{^	kanbun}', "");
    Expect(0, 12703, '\P{	kanbun}', "");
    Expect(1, 12703, '\P{^	kanbun}', "");
    Expect(0, 12704, '\p{	kanbun}', "");
    Expect(1, 12704, '\p{^	kanbun}', "");
    Expect(1, 12704, '\P{	kanbun}', "");
    Expect(0, 12704, '\P{^	kanbun}', "");
    Error('\p{:=_Is_kanbun}');
    Error('\P{:=_Is_kanbun}');
    Expect(1, 12703, '\p{iskanbun}', "");
    Expect(0, 12703, '\p{^iskanbun}', "");
    Expect(0, 12703, '\P{iskanbun}', "");
    Expect(1, 12703, '\P{^iskanbun}', "");
    Expect(0, 12704, '\p{iskanbun}', "");
    Expect(1, 12704, '\p{^iskanbun}', "");
    Expect(1, 12704, '\P{iskanbun}', "");
    Expect(0, 12704, '\P{^iskanbun}', "");
    Expect(1, 12703, '\p{__Is_Kanbun}', "");
    Expect(0, 12703, '\p{^__Is_Kanbun}', "");
    Expect(0, 12703, '\P{__Is_Kanbun}', "");
    Expect(1, 12703, '\P{^__Is_Kanbun}', "");
    Expect(0, 12704, '\p{__Is_Kanbun}', "");
    Expect(1, 12704, '\p{^__Is_Kanbun}', "");
    Expect(1, 12704, '\P{__Is_Kanbun}', "");
    Expect(0, 12704, '\P{^__Is_Kanbun}', "");
    Error('\p{-/a/In_KANBUN}');
    Error('\P{-/a/In_KANBUN}');
    Expect(1, 12703, '\p{inkanbun}', "");
    Expect(0, 12703, '\p{^inkanbun}', "");
    Expect(0, 12703, '\P{inkanbun}', "");
    Expect(1, 12703, '\P{^inkanbun}', "");
    Expect(0, 12704, '\p{inkanbun}', "");
    Expect(1, 12704, '\p{^inkanbun}', "");
    Expect(1, 12704, '\P{inkanbun}', "");
    Expect(0, 12704, '\P{^inkanbun}', "");
    Expect(1, 12703, '\p{	IN_kanbun}', "");
    Expect(0, 12703, '\p{^	IN_kanbun}', "");
    Expect(0, 12703, '\P{	IN_kanbun}', "");
    Expect(1, 12703, '\P{^	IN_kanbun}', "");
    Expect(0, 12704, '\p{	IN_kanbun}', "");
    Expect(1, 12704, '\p{^	IN_kanbun}', "");
    Expect(1, 12704, '\P{	IN_kanbun}', "");
    Expect(0, 12704, '\P{^	IN_kanbun}', "");
    Error('\p{:=_kangxi_RADICALS}');
    Error('\P{:=_kangxi_RADICALS}');
    Expect(1, 12255, '\p{kangxiradicals}', "");
    Expect(0, 12255, '\p{^kangxiradicals}', "");
    Expect(0, 12255, '\P{kangxiradicals}', "");
    Expect(1, 12255, '\P{^kangxiradicals}', "");
    Expect(0, 12256, '\p{kangxiradicals}', "");
    Expect(1, 12256, '\p{^kangxiradicals}', "");
    Expect(1, 12256, '\P{kangxiradicals}', "");
    Expect(0, 12256, '\P{^kangxiradicals}', "");
    Expect(1, 12255, '\p{Kangxi_radicals}', "");
    Expect(0, 12255, '\p{^Kangxi_radicals}', "");
    Expect(0, 12255, '\P{Kangxi_radicals}', "");
    Expect(1, 12255, '\P{^Kangxi_radicals}', "");
    Expect(0, 12256, '\p{Kangxi_radicals}', "");
    Expect(1, 12256, '\p{^Kangxi_radicals}', "");
    Expect(1, 12256, '\P{Kangxi_radicals}', "");
    Expect(0, 12256, '\P{^Kangxi_radicals}', "");
    Error('\p{/a/Is_Kangxi_Radicals}');
    Error('\P{/a/Is_Kangxi_Radicals}');
    Expect(1, 12255, '\p{iskangxiradicals}', "");
    Expect(0, 12255, '\p{^iskangxiradicals}', "");
    Expect(0, 12255, '\P{iskangxiradicals}', "");
    Expect(1, 12255, '\P{^iskangxiradicals}', "");
    Expect(0, 12256, '\p{iskangxiradicals}', "");
    Expect(1, 12256, '\p{^iskangxiradicals}', "");
    Expect(1, 12256, '\P{iskangxiradicals}', "");
    Expect(0, 12256, '\P{^iskangxiradicals}', "");
    Expect(1, 12255, '\p{_is_Kangxi_Radicals}', "");
    Expect(0, 12255, '\p{^_is_Kangxi_Radicals}', "");
    Expect(0, 12255, '\P{_is_Kangxi_Radicals}', "");
    Expect(1, 12255, '\P{^_is_Kangxi_Radicals}', "");
    Expect(0, 12256, '\p{_is_Kangxi_Radicals}', "");
    Expect(1, 12256, '\p{^_is_Kangxi_Radicals}', "");
    Expect(1, 12256, '\P{_is_Kangxi_Radicals}', "");
    Expect(0, 12256, '\P{^_is_Kangxi_Radicals}', "");
    Error('\p{:=-_In_Kangxi_Radicals}');
    Error('\P{:=-_In_Kangxi_Radicals}');
    Expect(1, 12255, '\p{inkangxiradicals}', "");
    Expect(0, 12255, '\p{^inkangxiradicals}', "");
    Expect(0, 12255, '\P{inkangxiradicals}', "");
    Expect(1, 12255, '\P{^inkangxiradicals}', "");
    Expect(0, 12256, '\p{inkangxiradicals}', "");
    Expect(1, 12256, '\p{^inkangxiradicals}', "");
    Expect(1, 12256, '\P{inkangxiradicals}', "");
    Expect(0, 12256, '\P{^inkangxiradicals}', "");
    Expect(1, 12255, '\p{_ In_KANGXI_Radicals}', "");
    Expect(0, 12255, '\p{^_ In_KANGXI_Radicals}', "");
    Expect(0, 12255, '\P{_ In_KANGXI_Radicals}', "");
    Expect(1, 12255, '\P{^_ In_KANGXI_Radicals}', "");
    Expect(0, 12256, '\p{_ In_KANGXI_Radicals}', "");
    Expect(1, 12256, '\p{^_ In_KANGXI_Radicals}', "");
    Expect(1, 12256, '\P{_ In_KANGXI_Radicals}', "");
    Expect(0, 12256, '\P{^_ In_KANGXI_Radicals}', "");
    Error('\p{:=_-Kangxi}');
    Error('\P{:=_-Kangxi}');
    Expect(1, 12255, '\p{kangxi}', "");
    Expect(0, 12255, '\p{^kangxi}', "");
    Expect(0, 12255, '\P{kangxi}', "");
    Expect(1, 12255, '\P{^kangxi}', "");
    Expect(0, 12256, '\p{kangxi}', "");
    Expect(1, 12256, '\p{^kangxi}', "");
    Expect(1, 12256, '\P{kangxi}', "");
    Expect(0, 12256, '\P{^kangxi}', "");
    Expect(1, 12255, '\p{-Kangxi}', "");
    Expect(0, 12255, '\p{^-Kangxi}', "");
    Expect(0, 12255, '\P{-Kangxi}', "");
    Expect(1, 12255, '\P{^-Kangxi}', "");
    Expect(0, 12256, '\p{-Kangxi}', "");
    Expect(1, 12256, '\p{^-Kangxi}', "");
    Expect(1, 12256, '\P{-Kangxi}', "");
    Expect(0, 12256, '\P{^-Kangxi}', "");
    Error('\p{:=-_Is_KANGXI}');
    Error('\P{:=-_Is_KANGXI}');
    Expect(1, 12255, '\p{iskangxi}', "");
    Expect(0, 12255, '\p{^iskangxi}', "");
    Expect(0, 12255, '\P{iskangxi}', "");
    Expect(1, 12255, '\P{^iskangxi}', "");
    Expect(0, 12256, '\p{iskangxi}', "");
    Expect(1, 12256, '\p{^iskangxi}', "");
    Expect(1, 12256, '\P{iskangxi}', "");
    Expect(0, 12256, '\P{^iskangxi}', "");
    Expect(1, 12255, '\p{_Is_Kangxi}', "");
    Expect(0, 12255, '\p{^_Is_Kangxi}', "");
    Expect(0, 12255, '\P{_Is_Kangxi}', "");
    Expect(1, 12255, '\P{^_Is_Kangxi}', "");
    Expect(0, 12256, '\p{_Is_Kangxi}', "");
    Expect(1, 12256, '\p{^_Is_Kangxi}', "");
    Expect(1, 12256, '\P{_Is_Kangxi}', "");
    Expect(0, 12256, '\P{^_Is_Kangxi}', "");
    Error('\p{-/a/In_kangxi}');
    Error('\P{-/a/In_kangxi}');
    Expect(1, 12255, '\p{inkangxi}', "");
    Expect(0, 12255, '\p{^inkangxi}', "");
    Expect(0, 12255, '\P{inkangxi}', "");
    Expect(1, 12255, '\P{^inkangxi}', "");
    Expect(0, 12256, '\p{inkangxi}', "");
    Expect(1, 12256, '\p{^inkangxi}', "");
    Expect(1, 12256, '\P{inkangxi}', "");
    Expect(0, 12256, '\P{^inkangxi}', "");
    Expect(1, 12255, '\p{- IN_Kangxi}', "");
    Expect(0, 12255, '\p{^- IN_Kangxi}', "");
    Expect(0, 12255, '\P{- IN_Kangxi}', "");
    Expect(1, 12255, '\P{^- IN_Kangxi}', "");
    Expect(0, 12256, '\p{- IN_Kangxi}', "");
    Expect(1, 12256, '\p{^- IN_Kangxi}', "");
    Expect(1, 12256, '\P{- IN_Kangxi}', "");
    Expect(0, 12256, '\P{^- IN_Kangxi}', "");
    Error('\p{/a/Kannada}');
    Error('\P{/a/Kannada}');
    Expect(1, 43061, '\p{kannada}', "");
    Expect(0, 43061, '\p{^kannada}', "");
    Expect(0, 43061, '\P{kannada}', "");
    Expect(1, 43061, '\P{^kannada}', "");
    Expect(0, 43062, '\p{kannada}', "");
    Expect(1, 43062, '\p{^kannada}', "");
    Expect(1, 43062, '\P{kannada}', "");
    Expect(0, 43062, '\P{^kannada}', "");
    Expect(1, 43061, '\p{  Kannada}', "");
    Expect(0, 43061, '\p{^  Kannada}', "");
    Expect(0, 43061, '\P{  Kannada}', "");
    Expect(1, 43061, '\P{^  Kannada}', "");
    Expect(0, 43062, '\p{  Kannada}', "");
    Expect(1, 43062, '\p{^  Kannada}', "");
    Expect(1, 43062, '\P{  Kannada}', "");
    Expect(0, 43062, '\P{^  Kannada}', "");
    Error('\p{ -Is_Kannada/a/}');
    Error('\P{ -Is_Kannada/a/}');
    Expect(1, 43061, '\p{iskannada}', "");
    Expect(0, 43061, '\p{^iskannada}', "");
    Expect(0, 43061, '\P{iskannada}', "");
    Expect(1, 43061, '\P{^iskannada}', "");
    Expect(0, 43062, '\p{iskannada}', "");
    Expect(1, 43062, '\p{^iskannada}', "");
    Expect(1, 43062, '\P{iskannada}', "");
    Expect(0, 43062, '\P{^iskannada}', "");
    Expect(1, 43061, '\p{- Is_Kannada}', "");
    Expect(0, 43061, '\p{^- Is_Kannada}', "");
    Expect(0, 43061, '\P{- Is_Kannada}', "");
    Expect(1, 43061, '\P{^- Is_Kannada}', "");
    Expect(0, 43062, '\p{- Is_Kannada}', "");
    Expect(1, 43062, '\p{^- Is_Kannada}', "");
    Expect(1, 43062, '\P{- Is_Kannada}', "");
    Expect(0, 43062, '\P{^- Is_Kannada}', "");
    Error('\p{/a/__Knda}');
    Error('\P{/a/__Knda}');
    Expect(1, 43061, '\p{knda}', "");
    Expect(0, 43061, '\p{^knda}', "");
    Expect(0, 43061, '\P{knda}', "");
    Expect(1, 43061, '\P{^knda}', "");
    Expect(0, 43062, '\p{knda}', "");
    Expect(1, 43062, '\p{^knda}', "");
    Expect(1, 43062, '\P{knda}', "");
    Expect(0, 43062, '\P{^knda}', "");
    Expect(1, 43061, '\p{	KNDA}', "");
    Expect(0, 43061, '\p{^	KNDA}', "");
    Expect(0, 43061, '\P{	KNDA}', "");
    Expect(1, 43061, '\P{^	KNDA}', "");
    Expect(0, 43062, '\p{	KNDA}', "");
    Expect(1, 43062, '\p{^	KNDA}', "");
    Expect(1, 43062, '\P{	KNDA}', "");
    Expect(0, 43062, '\P{^	KNDA}', "");
    Error('\p{ Is_knda/a/}');
    Error('\P{ Is_knda/a/}');
    Expect(1, 43061, '\p{isknda}', "");
    Expect(0, 43061, '\p{^isknda}', "");
    Expect(0, 43061, '\P{isknda}', "");
    Expect(1, 43061, '\P{^isknda}', "");
    Expect(0, 43062, '\p{isknda}', "");
    Expect(1, 43062, '\p{^isknda}', "");
    Expect(1, 43062, '\P{isknda}', "");
    Expect(0, 43062, '\P{^isknda}', "");
    Expect(1, 43061, '\p{_ Is_Knda}', "");
    Expect(0, 43061, '\p{^_ Is_Knda}', "");
    Expect(0, 43061, '\P{_ Is_Knda}', "");
    Expect(1, 43061, '\P{^_ Is_Knda}', "");
    Expect(0, 43062, '\p{_ Is_Knda}', "");
    Expect(1, 43062, '\p{^_ Is_Knda}', "");
    Expect(1, 43062, '\P{_ Is_Knda}', "");
    Expect(0, 43062, '\P{^_ Is_Knda}', "");
    Error('\p{/a/	 katakana}');
    Error('\P{/a/	 katakana}');
    Expect(1, 110951, '\p{katakana}', "");
    Expect(0, 110951, '\p{^katakana}', "");
    Expect(0, 110951, '\P{katakana}', "");
    Expect(1, 110951, '\P{^katakana}', "");
    Expect(0, 110952, '\p{katakana}', "");
    Expect(1, 110952, '\p{^katakana}', "");
    Expect(1, 110952, '\P{katakana}', "");
    Expect(0, 110952, '\P{^katakana}', "");
    Expect(1, 110951, '\p{-katakana}', "");
    Expect(0, 110951, '\p{^-katakana}', "");
    Expect(0, 110951, '\P{-katakana}', "");
    Expect(1, 110951, '\P{^-katakana}', "");
    Expect(0, 110952, '\p{-katakana}', "");
    Expect(1, 110952, '\p{^-katakana}', "");
    Expect(1, 110952, '\P{-katakana}', "");
    Expect(0, 110952, '\P{^-katakana}', "");
    Error('\p{ :=IS_Katakana}');
    Error('\P{ :=IS_Katakana}');
    Expect(1, 110951, '\p{iskatakana}', "");
    Expect(0, 110951, '\p{^iskatakana}', "");
    Expect(0, 110951, '\P{iskatakana}', "");
    Expect(1, 110951, '\P{^iskatakana}', "");
    Expect(0, 110952, '\p{iskatakana}', "");
    Expect(1, 110952, '\p{^iskatakana}', "");
    Expect(1, 110952, '\P{iskatakana}', "");
    Expect(0, 110952, '\P{^iskatakana}', "");
    Expect(1, 110951, '\p{ 	Is_Katakana}', "");
    Expect(0, 110951, '\p{^ 	Is_Katakana}', "");
    Expect(0, 110951, '\P{ 	Is_Katakana}', "");
    Expect(1, 110951, '\P{^ 	Is_Katakana}', "");
    Expect(0, 110952, '\p{ 	Is_Katakana}', "");
    Expect(1, 110952, '\p{^ 	Is_Katakana}', "");
    Expect(1, 110952, '\P{ 	Is_Katakana}', "");
    Expect(0, 110952, '\P{^ 	Is_Katakana}', "");
    Error('\p{:=- Kana}');
    Error('\P{:=- Kana}');
    Expect(1, 110951, '\p{kana}', "");
    Expect(0, 110951, '\p{^kana}', "");
    Expect(0, 110951, '\P{kana}', "");
    Expect(1, 110951, '\P{^kana}', "");
    Expect(0, 110952, '\p{kana}', "");
    Expect(1, 110952, '\p{^kana}', "");
    Expect(1, 110952, '\P{kana}', "");
    Expect(0, 110952, '\P{^kana}', "");
    Error('\p{:=--is_Kana}');
    Error('\P{:=--is_Kana}');
    Expect(1, 110951, '\p{iskana}', "");
    Expect(0, 110951, '\p{^iskana}', "");
    Expect(0, 110951, '\P{iskana}', "");
    Expect(1, 110951, '\P{^iskana}', "");
    Expect(0, 110952, '\p{iskana}', "");
    Expect(1, 110952, '\p{^iskana}', "");
    Expect(1, 110952, '\P{iskana}', "");
    Expect(0, 110952, '\P{^iskana}', "");
    Expect(1, 110951, '\p{  Is_kana}', "");
    Expect(0, 110951, '\p{^  Is_kana}', "");
    Expect(0, 110951, '\P{  Is_kana}', "");
    Expect(1, 110951, '\P{^  Is_kana}', "");
    Expect(0, 110952, '\p{  Is_kana}', "");
    Expect(1, 110952, '\p{^  Is_kana}', "");
    Expect(1, 110952, '\P{  Is_kana}', "");
    Expect(0, 110952, '\P{^  Is_kana}', "");
    Error('\p{Katakana_Or_Hiragana}');
    Error('\P{Katakana_Or_Hiragana}');
    Error('\p{Hrkt}');
    Error('\P{Hrkt}');
    Error('\p{	/a/Katakana_Phonetic_Extensions}');
    Error('\P{	/a/Katakana_Phonetic_Extensions}');
    Expect(1, 12799, '\p{katakanaphoneticextensions}', "");
    Expect(0, 12799, '\p{^katakanaphoneticextensions}', "");
    Expect(0, 12799, '\P{katakanaphoneticextensions}', "");
    Expect(1, 12799, '\P{^katakanaphoneticextensions}', "");
    Expect(0, 12800, '\p{katakanaphoneticextensions}', "");
    Expect(1, 12800, '\p{^katakanaphoneticextensions}', "");
    Expect(1, 12800, '\P{katakanaphoneticextensions}', "");
    Expect(0, 12800, '\P{^katakanaphoneticextensions}', "");
    Expect(1, 12799, '\p{__KATAKANA_PHONETIC_extensions}', "");
    Expect(0, 12799, '\p{^__KATAKANA_PHONETIC_extensions}', "");
    Expect(0, 12799, '\P{__KATAKANA_PHONETIC_extensions}', "");
    Expect(1, 12799, '\P{^__KATAKANA_PHONETIC_extensions}', "");
    Expect(0, 12800, '\p{__KATAKANA_PHONETIC_extensions}', "");
    Expect(1, 12800, '\p{^__KATAKANA_PHONETIC_extensions}', "");
    Expect(1, 12800, '\P{__KATAKANA_PHONETIC_extensions}', "");
    Expect(0, 12800, '\P{^__KATAKANA_PHONETIC_extensions}', "");
    Error('\p{_:=is_Katakana_PHONETIC_EXTENSIONS}');
    Error('\P{_:=is_Katakana_PHONETIC_EXTENSIONS}');
    Expect(1, 12799, '\p{iskatakanaphoneticextensions}', "");
    Expect(0, 12799, '\p{^iskatakanaphoneticextensions}', "");
    Expect(0, 12799, '\P{iskatakanaphoneticextensions}', "");
    Expect(1, 12799, '\P{^iskatakanaphoneticextensions}', "");
    Expect(0, 12800, '\p{iskatakanaphoneticextensions}', "");
    Expect(1, 12800, '\p{^iskatakanaphoneticextensions}', "");
    Expect(1, 12800, '\P{iskatakanaphoneticextensions}', "");
    Expect(0, 12800, '\P{^iskatakanaphoneticextensions}', "");
    Expect(1, 12799, '\p{  IS_katakana_Phonetic_EXTENSIONS}', "");
    Expect(0, 12799, '\p{^  IS_katakana_Phonetic_EXTENSIONS}', "");
    Expect(0, 12799, '\P{  IS_katakana_Phonetic_EXTENSIONS}', "");
    Expect(1, 12799, '\P{^  IS_katakana_Phonetic_EXTENSIONS}', "");
    Expect(0, 12800, '\p{  IS_katakana_Phonetic_EXTENSIONS}', "");
    Expect(1, 12800, '\p{^  IS_katakana_Phonetic_EXTENSIONS}', "");
    Expect(1, 12800, '\P{  IS_katakana_Phonetic_EXTENSIONS}', "");
    Expect(0, 12800, '\P{^  IS_katakana_Phonetic_EXTENSIONS}', "");
    Error('\p{-/a/IN_Katakana_Phonetic_Extensions}');
    Error('\P{-/a/IN_Katakana_Phonetic_Extensions}');
    Expect(1, 12799, '\p{inkatakanaphoneticextensions}', "");
    Expect(0, 12799, '\p{^inkatakanaphoneticextensions}', "");
    Expect(0, 12799, '\P{inkatakanaphoneticextensions}', "");
    Expect(1, 12799, '\P{^inkatakanaphoneticextensions}', "");
    Expect(0, 12800, '\p{inkatakanaphoneticextensions}', "");
    Expect(1, 12800, '\p{^inkatakanaphoneticextensions}', "");
    Expect(1, 12800, '\P{inkatakanaphoneticextensions}', "");
    Expect(0, 12800, '\P{^inkatakanaphoneticextensions}', "");
    Expect(1, 12799, '\p{ in_KATAKANA_Phonetic_EXTENSIONS}', "");
    Expect(0, 12799, '\p{^ in_KATAKANA_Phonetic_EXTENSIONS}', "");
    Expect(0, 12799, '\P{ in_KATAKANA_Phonetic_EXTENSIONS}', "");
    Expect(1, 12799, '\P{^ in_KATAKANA_Phonetic_EXTENSIONS}', "");
    Expect(0, 12800, '\p{ in_KATAKANA_Phonetic_EXTENSIONS}', "");
    Expect(1, 12800, '\p{^ in_KATAKANA_Phonetic_EXTENSIONS}', "");
    Expect(1, 12800, '\P{ in_KATAKANA_Phonetic_EXTENSIONS}', "");
    Expect(0, 12800, '\P{^ in_KATAKANA_Phonetic_EXTENSIONS}', "");
    Error('\p{_/a/Katakana_Ext}');
    Error('\P{_/a/Katakana_Ext}');
    Expect(1, 12799, '\p{katakanaext}', "");
    Expect(0, 12799, '\p{^katakanaext}', "");
    Expect(0, 12799, '\P{katakanaext}', "");
    Expect(1, 12799, '\P{^katakanaext}', "");
    Expect(0, 12800, '\p{katakanaext}', "");
    Expect(1, 12800, '\p{^katakanaext}', "");
    Expect(1, 12800, '\P{katakanaext}', "");
    Expect(0, 12800, '\P{^katakanaext}', "");
    Expect(1, 12799, '\p{_	KATAKANA_Ext}', "");
    Expect(0, 12799, '\p{^_	KATAKANA_Ext}', "");
    Expect(0, 12799, '\P{_	KATAKANA_Ext}', "");
    Expect(1, 12799, '\P{^_	KATAKANA_Ext}', "");
    Expect(0, 12800, '\p{_	KATAKANA_Ext}', "");
    Expect(1, 12800, '\p{^_	KATAKANA_Ext}', "");
    Expect(1, 12800, '\P{_	KATAKANA_Ext}', "");
    Expect(0, 12800, '\P{^_	KATAKANA_Ext}', "");
    Error('\p{	Is_KATAKANA_ext/a/}');
    Error('\P{	Is_KATAKANA_ext/a/}');
    Expect(1, 12799, '\p{iskatakanaext}', "");
    Expect(0, 12799, '\p{^iskatakanaext}', "");
    Expect(0, 12799, '\P{iskatakanaext}', "");
    Expect(1, 12799, '\P{^iskatakanaext}', "");
    Expect(0, 12800, '\p{iskatakanaext}', "");
    Expect(1, 12800, '\p{^iskatakanaext}', "");
    Expect(1, 12800, '\P{iskatakanaext}', "");
    Expect(0, 12800, '\P{^iskatakanaext}', "");
    Expect(1, 12799, '\p{	is_katakana_EXT}', "");
    Expect(0, 12799, '\p{^	is_katakana_EXT}', "");
    Expect(0, 12799, '\P{	is_katakana_EXT}', "");
    Expect(1, 12799, '\P{^	is_katakana_EXT}', "");
    Expect(0, 12800, '\p{	is_katakana_EXT}', "");
    Expect(1, 12800, '\p{^	is_katakana_EXT}', "");
    Expect(1, 12800, '\P{	is_katakana_EXT}', "");
    Expect(0, 12800, '\P{^	is_katakana_EXT}', "");
    Error('\p{:=--IN_katakana_Ext}');
    Error('\P{:=--IN_katakana_Ext}');
    Expect(1, 12799, '\p{inkatakanaext}', "");
    Expect(0, 12799, '\p{^inkatakanaext}', "");
    Expect(0, 12799, '\P{inkatakanaext}', "");
    Expect(1, 12799, '\P{^inkatakanaext}', "");
    Expect(0, 12800, '\p{inkatakanaext}', "");
    Expect(1, 12800, '\p{^inkatakanaext}', "");
    Expect(1, 12800, '\P{inkatakanaext}', "");
    Expect(0, 12800, '\P{^inkatakanaext}', "");
    Expect(1, 12799, '\p{--In_Katakana_EXT}', "");
    Expect(0, 12799, '\p{^--In_Katakana_EXT}', "");
    Expect(0, 12799, '\P{--In_Katakana_EXT}', "");
    Expect(1, 12799, '\P{^--In_Katakana_EXT}', "");
    Expect(0, 12800, '\p{--In_Katakana_EXT}', "");
    Expect(1, 12800, '\p{^--In_Katakana_EXT}', "");
    Expect(1, 12800, '\P{--In_Katakana_EXT}', "");
    Expect(0, 12800, '\P{^--In_Katakana_EXT}', "");
    Error('\p{/a/-kawi}');
    Error('\P{/a/-kawi}');
    Expect(1, 73561, '\p{kawi}', "");
    Expect(0, 73561, '\p{^kawi}', "");
    Expect(0, 73561, '\P{kawi}', "");
    Expect(1, 73561, '\P{^kawi}', "");
    Expect(0, 73562, '\p{kawi}', "");
    Expect(1, 73562, '\p{^kawi}', "");
    Expect(1, 73562, '\P{kawi}', "");
    Expect(0, 73562, '\P{^kawi}', "");
    Expect(1, 73561, '\p{	-KAWI}', "");
    Expect(0, 73561, '\p{^	-KAWI}', "");
    Expect(0, 73561, '\P{	-KAWI}', "");
    Expect(1, 73561, '\P{^	-KAWI}', "");
    Expect(0, 73562, '\p{	-KAWI}', "");
    Expect(1, 73562, '\p{^	-KAWI}', "");
    Expect(1, 73562, '\P{	-KAWI}', "");
    Expect(0, 73562, '\P{^	-KAWI}', "");
    Error('\p{_Is_Kawi/a/}');
    Error('\P{_Is_Kawi/a/}');
    Expect(1, 73561, '\p{iskawi}', "");
    Expect(0, 73561, '\p{^iskawi}', "");
    Expect(0, 73561, '\P{iskawi}', "");
    Expect(1, 73561, '\P{^iskawi}', "");
    Expect(0, 73562, '\p{iskawi}', "");
    Expect(1, 73562, '\p{^iskawi}', "");
    Expect(1, 73562, '\P{iskawi}', "");
    Expect(0, 73562, '\P{^iskawi}', "");
    Expect(1, 73561, '\p{- is_KAWI}', "");
    Expect(0, 73561, '\p{^- is_KAWI}', "");
    Expect(0, 73561, '\P{- is_KAWI}', "");
    Expect(1, 73561, '\P{^- is_KAWI}', "");
    Expect(0, 73562, '\p{- is_KAWI}', "");
    Expect(1, 73562, '\p{^- is_KAWI}', "");
    Expect(1, 73562, '\P{- is_KAWI}', "");
    Expect(0, 73562, '\P{^- is_KAWI}', "");
    Error('\p{/a/	-Kayah_Li}');
    Error('\P{/a/	-Kayah_Li}');
    Expect(1, 43311, '\p{kayahli}', "");
    Expect(0, 43311, '\p{^kayahli}', "");
    Expect(0, 43311, '\P{kayahli}', "");
    Expect(1, 43311, '\P{^kayahli}', "");
    Expect(0, 43312, '\p{kayahli}', "");
    Expect(1, 43312, '\p{^kayahli}', "");
    Expect(1, 43312, '\P{kayahli}', "");
    Expect(0, 43312, '\P{^kayahli}', "");
    Expect(1, 43311, '\p{_Kayah_li}', "");
    Expect(0, 43311, '\p{^_Kayah_li}', "");
    Expect(0, 43311, '\P{_Kayah_li}', "");
    Expect(1, 43311, '\P{^_Kayah_li}', "");
    Expect(0, 43312, '\p{_Kayah_li}', "");
    Expect(1, 43312, '\p{^_Kayah_li}', "");
    Expect(1, 43312, '\P{_Kayah_li}', "");
    Expect(0, 43312, '\P{^_Kayah_li}', "");
    Error('\p{:=Is_Kayah_Li}');
    Error('\P{:=Is_Kayah_Li}');
    Expect(1, 43311, '\p{iskayahli}', "");
    Expect(0, 43311, '\p{^iskayahli}', "");
    Expect(0, 43311, '\P{iskayahli}', "");
    Expect(1, 43311, '\P{^iskayahli}', "");
    Expect(0, 43312, '\p{iskayahli}', "");
    Expect(1, 43312, '\p{^iskayahli}', "");
    Expect(1, 43312, '\P{iskayahli}', "");
    Expect(0, 43312, '\P{^iskayahli}', "");
    Expect(1, 43311, '\p{-	is_Kayah_Li}', "");
    Expect(0, 43311, '\p{^-	is_Kayah_Li}', "");
    Expect(0, 43311, '\P{-	is_Kayah_Li}', "");
    Expect(1, 43311, '\P{^-	is_Kayah_Li}', "");
    Expect(0, 43312, '\p{-	is_Kayah_Li}', "");
    Expect(1, 43312, '\p{^-	is_Kayah_Li}', "");
    Expect(1, 43312, '\P{-	is_Kayah_Li}', "");
    Expect(0, 43312, '\P{^-	is_Kayah_Li}', "");
    Error('\p{/a/	-KALI}');
    Error('\P{/a/	-KALI}');
    Expect(1, 43311, '\p{kali}', "");
    Expect(0, 43311, '\p{^kali}', "");
    Expect(0, 43311, '\P{kali}', "");
    Expect(1, 43311, '\P{^kali}', "");
    Expect(0, 43312, '\p{kali}', "");
    Expect(1, 43312, '\p{^kali}', "");
    Expect(1, 43312, '\P{kali}', "");
    Expect(0, 43312, '\P{^kali}', "");
    Expect(1, 43311, '\p{_	kali}', "");
    Expect(0, 43311, '\p{^_	kali}', "");
    Expect(0, 43311, '\P{_	kali}', "");
    Expect(1, 43311, '\P{^_	kali}', "");
    Expect(0, 43312, '\p{_	kali}', "");
    Expect(1, 43312, '\p{^_	kali}', "");
    Expect(1, 43312, '\P{_	kali}', "");
    Expect(0, 43312, '\P{^_	kali}', "");
    Error('\p{/a/_is_kali}');
    Error('\P{/a/_is_kali}');
    Expect(1, 43311, '\p{iskali}', "");
    Expect(0, 43311, '\p{^iskali}', "");
    Expect(0, 43311, '\P{iskali}', "");
    Expect(1, 43311, '\P{^iskali}', "");
    Expect(0, 43312, '\p{iskali}', "");
    Expect(1, 43312, '\p{^iskali}', "");
    Expect(1, 43312, '\P{iskali}', "");
    Expect(0, 43312, '\P{^iskali}', "");
    Expect(1, 43311, '\p{is_Kali}', "");
    Expect(0, 43311, '\p{^is_Kali}', "");
    Expect(0, 43311, '\P{is_Kali}', "");
    Expect(1, 43311, '\P{^is_Kali}', "");
    Expect(0, 43312, '\p{is_Kali}', "");
    Expect(1, 43312, '\p{^is_Kali}', "");
    Expect(1, 43312, '\P{is_Kali}', "");
    Expect(0, 43312, '\P{^is_Kali}', "");
    Error('\p{-	KHAROSHTHI:=}');
    Error('\P{-	KHAROSHTHI:=}');
    Expect(1, 68184, '\p{kharoshthi}', "");
    Expect(0, 68184, '\p{^kharoshthi}', "");
    Expect(0, 68184, '\P{kharoshthi}', "");
    Expect(1, 68184, '\P{^kharoshthi}', "");
    Expect(0, 68185, '\p{kharoshthi}', "");
    Expect(1, 68185, '\p{^kharoshthi}', "");
    Expect(1, 68185, '\P{kharoshthi}', "");
    Expect(0, 68185, '\P{^kharoshthi}', "");
    Expect(1, 68184, '\p{--kharoshthi}', "");
    Expect(0, 68184, '\p{^--kharoshthi}', "");
    Expect(0, 68184, '\P{--kharoshthi}', "");
    Expect(1, 68184, '\P{^--kharoshthi}', "");
    Expect(0, 68185, '\p{--kharoshthi}', "");
    Expect(1, 68185, '\p{^--kharoshthi}', "");
    Expect(1, 68185, '\P{--kharoshthi}', "");
    Expect(0, 68185, '\P{^--kharoshthi}', "");
    Error('\p{ /a/Is_KHAROSHTHI}');
    Error('\P{ /a/Is_KHAROSHTHI}');
    Expect(1, 68184, '\p{iskharoshthi}', "");
    Expect(0, 68184, '\p{^iskharoshthi}', "");
    Expect(0, 68184, '\P{iskharoshthi}', "");
    Expect(1, 68184, '\P{^iskharoshthi}', "");
    Expect(0, 68185, '\p{iskharoshthi}', "");
    Expect(1, 68185, '\p{^iskharoshthi}', "");
    Expect(1, 68185, '\P{iskharoshthi}', "");
    Expect(0, 68185, '\P{^iskharoshthi}', "");
    Expect(1, 68184, '\p{	 Is_kharoshthi}', "");
    Expect(0, 68184, '\p{^	 Is_kharoshthi}', "");
    Expect(0, 68184, '\P{	 Is_kharoshthi}', "");
    Expect(1, 68184, '\P{^	 Is_kharoshthi}', "");
    Expect(0, 68185, '\p{	 Is_kharoshthi}', "");
    Expect(1, 68185, '\p{^	 Is_kharoshthi}', "");
    Expect(1, 68185, '\P{	 Is_kharoshthi}', "");
    Expect(0, 68185, '\P{^	 Is_kharoshthi}', "");
    Error('\p{:=	khar}');
    Error('\P{:=	khar}');
    Expect(1, 68184, '\p{khar}', "");
    Expect(0, 68184, '\p{^khar}', "");
    Expect(0, 68184, '\P{khar}', "");
    Expect(1, 68184, '\P{^khar}', "");
    Expect(0, 68185, '\p{khar}', "");
    Expect(1, 68185, '\p{^khar}', "");
    Expect(1, 68185, '\P{khar}', "");
    Expect(0, 68185, '\P{^khar}', "");
    Expect(1, 68184, '\p{- khar}', "");
    Expect(0, 68184, '\p{^- khar}', "");
    Expect(0, 68184, '\P{- khar}', "");
    Expect(1, 68184, '\P{^- khar}', "");
    Expect(0, 68185, '\p{- khar}', "");
    Expect(1, 68185, '\p{^- khar}', "");
    Expect(1, 68185, '\P{- khar}', "");
    Expect(0, 68185, '\P{^- khar}', "");
    Error('\p{:=IS_khar}');
    Error('\P{:=IS_khar}');
    Expect(1, 68184, '\p{iskhar}', "");
    Expect(0, 68184, '\p{^iskhar}', "");
    Expect(0, 68184, '\P{iskhar}', "");
    Expect(1, 68184, '\P{^iskhar}', "");
    Expect(0, 68185, '\p{iskhar}', "");
    Expect(1, 68185, '\p{^iskhar}', "");
    Expect(1, 68185, '\P{iskhar}', "");
    Expect(0, 68185, '\P{^iskhar}', "");
    Expect(1, 68184, '\p{ 	Is_Khar}', "");
    Expect(0, 68184, '\p{^ 	Is_Khar}', "");
    Expect(0, 68184, '\P{ 	Is_Khar}', "");
    Expect(1, 68184, '\P{^ 	Is_Khar}', "");
    Expect(0, 68185, '\p{ 	Is_Khar}', "");
    Expect(1, 68185, '\p{^ 	Is_Khar}', "");
    Expect(1, 68185, '\P{ 	Is_Khar}', "");
    Expect(0, 68185, '\P{^ 	Is_Khar}', "");
    Error('\p{:= Khitan_Small_Script}');
    Error('\P{:= Khitan_Small_Script}');
    Expect(1, 101589, '\p{khitansmallscript}', "");
    Expect(0, 101589, '\p{^khitansmallscript}', "");
    Expect(0, 101589, '\P{khitansmallscript}', "");
    Expect(1, 101589, '\P{^khitansmallscript}', "");
    Expect(0, 101590, '\p{khitansmallscript}', "");
    Expect(1, 101590, '\p{^khitansmallscript}', "");
    Expect(1, 101590, '\P{khitansmallscript}', "");
    Expect(0, 101590, '\P{^khitansmallscript}', "");
    Expect(1, 101589, '\p{-Khitan_small_Script}', "");
    Expect(0, 101589, '\p{^-Khitan_small_Script}', "");
    Expect(0, 101589, '\P{-Khitan_small_Script}', "");
    Expect(1, 101589, '\P{^-Khitan_small_Script}', "");
    Expect(0, 101590, '\p{-Khitan_small_Script}', "");
    Expect(1, 101590, '\p{^-Khitan_small_Script}', "");
    Expect(1, 101590, '\P{-Khitan_small_Script}', "");
    Expect(0, 101590, '\P{^-Khitan_small_Script}', "");
    Error('\p{:= is_Khitan_small_Script}');
    Error('\P{:= is_Khitan_small_Script}');
    Expect(1, 101589, '\p{iskhitansmallscript}', "");
    Expect(0, 101589, '\p{^iskhitansmallscript}', "");
    Expect(0, 101589, '\P{iskhitansmallscript}', "");
    Expect(1, 101589, '\P{^iskhitansmallscript}', "");
    Expect(0, 101590, '\p{iskhitansmallscript}', "");
    Expect(1, 101590, '\p{^iskhitansmallscript}', "");
    Expect(1, 101590, '\P{iskhitansmallscript}', "");
    Expect(0, 101590, '\P{^iskhitansmallscript}', "");
    Expect(1, 101589, '\p{__is_khitan_Small_Script}', "");
    Expect(0, 101589, '\p{^__is_khitan_Small_Script}', "");
    Expect(0, 101589, '\P{__is_khitan_Small_Script}', "");
    Expect(1, 101589, '\P{^__is_khitan_Small_Script}', "");
    Expect(0, 101590, '\p{__is_khitan_Small_Script}', "");
    Expect(1, 101590, '\p{^__is_khitan_Small_Script}', "");
    Expect(1, 101590, '\P{__is_khitan_Small_Script}', "");
    Expect(0, 101590, '\P{^__is_khitan_Small_Script}', "");
    Error('\p{/a/-kits}');
    Error('\P{/a/-kits}');
    Expect(1, 101589, '\p{kits}', "");
    Expect(0, 101589, '\p{^kits}', "");
    Expect(0, 101589, '\P{kits}', "");
    Expect(1, 101589, '\P{^kits}', "");
    Expect(0, 101590, '\p{kits}', "");
    Expect(1, 101590, '\p{^kits}', "");
    Expect(1, 101590, '\P{kits}', "");
    Expect(0, 101590, '\P{^kits}', "");
    Expect(1, 101589, '\p{_-KITS}', "");
    Expect(0, 101589, '\p{^_-KITS}', "");
    Expect(0, 101589, '\P{_-KITS}', "");
    Expect(1, 101589, '\P{^_-KITS}', "");
    Expect(0, 101590, '\p{_-KITS}', "");
    Expect(1, 101590, '\p{^_-KITS}', "");
    Expect(1, 101590, '\P{_-KITS}', "");
    Expect(0, 101590, '\P{^_-KITS}', "");
    Error('\p{-:=Is_Kits}');
    Error('\P{-:=Is_Kits}');
    Expect(1, 101589, '\p{iskits}', "");
    Expect(0, 101589, '\p{^iskits}', "");
    Expect(0, 101589, '\P{iskits}', "");
    Expect(1, 101589, '\P{^iskits}', "");
    Expect(0, 101590, '\p{iskits}', "");
    Expect(1, 101590, '\p{^iskits}', "");
    Expect(1, 101590, '\P{iskits}', "");
    Expect(0, 101590, '\P{^iskits}', "");
    Expect(1, 101589, '\p{-_IS_Kits}', "");
    Expect(0, 101589, '\p{^-_IS_Kits}', "");
    Expect(0, 101589, '\P{-_IS_Kits}', "");
    Expect(1, 101589, '\P{^-_IS_Kits}', "");
    Expect(0, 101590, '\p{-_IS_Kits}', "");
    Expect(1, 101590, '\p{^-_IS_Kits}', "");
    Expect(1, 101590, '\P{-_IS_Kits}', "");
    Expect(0, 101590, '\P{^-_IS_Kits}', "");
    Error('\p{/a/  Khmer}');
    Error('\P{/a/  Khmer}');
    Expect(1, 6655, '\p{khmer}', "");
    Expect(0, 6655, '\p{^khmer}', "");
    Expect(0, 6655, '\P{khmer}', "");
    Expect(1, 6655, '\P{^khmer}', "");
    Expect(0, 6656, '\p{khmer}', "");
    Expect(1, 6656, '\p{^khmer}', "");
    Expect(1, 6656, '\P{khmer}', "");
    Expect(0, 6656, '\P{^khmer}', "");
    Expect(1, 6655, '\p{-	KHMER}', "");
    Expect(0, 6655, '\p{^-	KHMER}', "");
    Expect(0, 6655, '\P{-	KHMER}', "");
    Expect(1, 6655, '\P{^-	KHMER}', "");
    Expect(0, 6656, '\p{-	KHMER}', "");
    Expect(1, 6656, '\p{^-	KHMER}', "");
    Expect(1, 6656, '\P{-	KHMER}', "");
    Expect(0, 6656, '\P{^-	KHMER}', "");
    Error('\p{_ IS_Khmer:=}');
    Error('\P{_ IS_Khmer:=}');
    Expect(1, 6655, '\p{iskhmer}', "");
    Expect(0, 6655, '\p{^iskhmer}', "");
    Expect(0, 6655, '\P{iskhmer}', "");
    Expect(1, 6655, '\P{^iskhmer}', "");
    Expect(0, 6656, '\p{iskhmer}', "");
    Expect(1, 6656, '\p{^iskhmer}', "");
    Expect(1, 6656, '\P{iskhmer}', "");
    Expect(0, 6656, '\P{^iskhmer}', "");
    Expect(1, 6655, '\p{	_Is_khmer}', "");
    Expect(0, 6655, '\p{^	_Is_khmer}', "");
    Expect(0, 6655, '\P{	_Is_khmer}', "");
    Expect(1, 6655, '\P{^	_Is_khmer}', "");
    Expect(0, 6656, '\p{	_Is_khmer}', "");
    Expect(1, 6656, '\p{^	_Is_khmer}', "");
    Expect(1, 6656, '\P{	_Is_khmer}', "");
    Expect(0, 6656, '\P{^	_Is_khmer}', "");
    Error('\p{	KHMR/a/}');
    Error('\P{	KHMR/a/}');
    Expect(1, 6655, '\p{khmr}', "");
    Expect(0, 6655, '\p{^khmr}', "");
    Expect(0, 6655, '\P{khmr}', "");
    Expect(1, 6655, '\P{^khmr}', "");
    Expect(0, 6656, '\p{khmr}', "");
    Expect(1, 6656, '\p{^khmr}', "");
    Expect(1, 6656, '\P{khmr}', "");
    Expect(0, 6656, '\P{^khmr}', "");
    Expect(1, 6655, '\p{ KHMR}', "");
    Expect(0, 6655, '\p{^ KHMR}', "");
    Expect(0, 6655, '\P{ KHMR}', "");
    Expect(1, 6655, '\P{^ KHMR}', "");
    Expect(0, 6656, '\p{ KHMR}', "");
    Expect(1, 6656, '\p{^ KHMR}', "");
    Expect(1, 6656, '\P{ KHMR}', "");
    Expect(0, 6656, '\P{^ KHMR}', "");
    Error('\p{-:=is_Khmr}');
    Error('\P{-:=is_Khmr}');
    Expect(1, 6655, '\p{iskhmr}', "");
    Expect(0, 6655, '\p{^iskhmr}', "");
    Expect(0, 6655, '\P{iskhmr}', "");
    Expect(1, 6655, '\P{^iskhmr}', "");
    Expect(0, 6656, '\p{iskhmr}', "");
    Expect(1, 6656, '\p{^iskhmr}', "");
    Expect(1, 6656, '\P{iskhmr}', "");
    Expect(0, 6656, '\P{^iskhmr}', "");
    Expect(1, 6655, '\p{_IS_khmr}', "");
    Expect(0, 6655, '\p{^_IS_khmr}', "");
    Expect(0, 6655, '\P{_IS_khmr}', "");
    Expect(1, 6655, '\P{^_IS_khmr}', "");
    Expect(0, 6656, '\p{_IS_khmr}', "");
    Expect(1, 6656, '\p{^_IS_khmr}', "");
    Expect(1, 6656, '\P{_IS_khmr}', "");
    Expect(0, 6656, '\P{^_IS_khmr}', "");
    Error('\p{/a/_Khmer_Symbols}');
    Error('\P{/a/_Khmer_Symbols}');
    Expect(1, 6655, '\p{khmersymbols}', "");
    Expect(0, 6655, '\p{^khmersymbols}', "");
    Expect(0, 6655, '\P{khmersymbols}', "");
    Expect(1, 6655, '\P{^khmersymbols}', "");
    Expect(0, 6656, '\p{khmersymbols}', "");
    Expect(1, 6656, '\p{^khmersymbols}', "");
    Expect(1, 6656, '\P{khmersymbols}', "");
    Expect(0, 6656, '\P{^khmersymbols}', "");
    Expect(1, 6655, '\p{	khmer_symbols}', "");
    Expect(0, 6655, '\p{^	khmer_symbols}', "");
    Expect(0, 6655, '\P{	khmer_symbols}', "");
    Expect(1, 6655, '\P{^	khmer_symbols}', "");
    Expect(0, 6656, '\p{	khmer_symbols}', "");
    Expect(1, 6656, '\p{^	khmer_symbols}', "");
    Expect(1, 6656, '\P{	khmer_symbols}', "");
    Expect(0, 6656, '\P{^	khmer_symbols}', "");
    Error('\p{ _is_Khmer_Symbols:=}');
    Error('\P{ _is_Khmer_Symbols:=}');
    Expect(1, 6655, '\p{iskhmersymbols}', "");
    Expect(0, 6655, '\p{^iskhmersymbols}', "");
    Expect(0, 6655, '\P{iskhmersymbols}', "");
    Expect(1, 6655, '\P{^iskhmersymbols}', "");
    Expect(0, 6656, '\p{iskhmersymbols}', "");
    Expect(1, 6656, '\p{^iskhmersymbols}', "");
    Expect(1, 6656, '\P{iskhmersymbols}', "");
    Expect(0, 6656, '\P{^iskhmersymbols}', "");
    Expect(1, 6655, '\p{_-is_Khmer_SYMBOLS}', "");
    Expect(0, 6655, '\p{^_-is_Khmer_SYMBOLS}', "");
    Expect(0, 6655, '\P{_-is_Khmer_SYMBOLS}', "");
    Expect(1, 6655, '\P{^_-is_Khmer_SYMBOLS}', "");
    Expect(0, 6656, '\p{_-is_Khmer_SYMBOLS}', "");
    Expect(1, 6656, '\p{^_-is_Khmer_SYMBOLS}', "");
    Expect(1, 6656, '\P{_-is_Khmer_SYMBOLS}', "");
    Expect(0, 6656, '\P{^_-is_Khmer_SYMBOLS}', "");
    Error('\p{_In_KHMER_SYMBOLS/a/}');
    Error('\P{_In_KHMER_SYMBOLS/a/}');
    Expect(1, 6655, '\p{inkhmersymbols}', "");
    Expect(0, 6655, '\p{^inkhmersymbols}', "");
    Expect(0, 6655, '\P{inkhmersymbols}', "");
    Expect(1, 6655, '\P{^inkhmersymbols}', "");
    Expect(0, 6656, '\p{inkhmersymbols}', "");
    Expect(1, 6656, '\p{^inkhmersymbols}', "");
    Expect(1, 6656, '\P{inkhmersymbols}', "");
    Expect(0, 6656, '\P{^inkhmersymbols}', "");
    Expect(1, 6655, '\p{	In_khmer_Symbols}', "");
    Expect(0, 6655, '\p{^	In_khmer_Symbols}', "");
    Expect(0, 6655, '\P{	In_khmer_Symbols}', "");
    Expect(1, 6655, '\P{^	In_khmer_Symbols}', "");
    Expect(0, 6656, '\p{	In_khmer_Symbols}', "");
    Expect(1, 6656, '\p{^	In_khmer_Symbols}', "");
    Expect(1, 6656, '\P{	In_khmer_Symbols}', "");
    Expect(0, 6656, '\P{^	In_khmer_Symbols}', "");
    Error('\p{_:=KHOJKI}');
    Error('\P{_:=KHOJKI}');
    Expect(1, 70209, '\p{khojki}', "");
    Expect(0, 70209, '\p{^khojki}', "");
    Expect(0, 70209, '\P{khojki}', "");
    Expect(1, 70209, '\P{^khojki}', "");
    Expect(0, 70210, '\p{khojki}', "");
    Expect(1, 70210, '\p{^khojki}', "");
    Expect(1, 70210, '\P{khojki}', "");
    Expect(0, 70210, '\P{^khojki}', "");
    Expect(1, 70209, '\p{ KHOJKI}', "");
    Expect(0, 70209, '\p{^ KHOJKI}', "");
    Expect(0, 70209, '\P{ KHOJKI}', "");
    Expect(1, 70209, '\P{^ KHOJKI}', "");
    Expect(0, 70210, '\p{ KHOJKI}', "");
    Expect(1, 70210, '\p{^ KHOJKI}', "");
    Expect(1, 70210, '\P{ KHOJKI}', "");
    Expect(0, 70210, '\P{^ KHOJKI}', "");
    Error('\p{ Is_KHOJKI:=}');
    Error('\P{ Is_KHOJKI:=}');
    Expect(1, 70209, '\p{iskhojki}', "");
    Expect(0, 70209, '\p{^iskhojki}', "");
    Expect(0, 70209, '\P{iskhojki}', "");
    Expect(1, 70209, '\P{^iskhojki}', "");
    Expect(0, 70210, '\p{iskhojki}', "");
    Expect(1, 70210, '\p{^iskhojki}', "");
    Expect(1, 70210, '\P{iskhojki}', "");
    Expect(0, 70210, '\P{^iskhojki}', "");
    Expect(1, 70209, '\p{-	IS_Khojki}', "");
    Expect(0, 70209, '\p{^-	IS_Khojki}', "");
    Expect(0, 70209, '\P{-	IS_Khojki}', "");
    Expect(1, 70209, '\P{^-	IS_Khojki}', "");
    Expect(0, 70210, '\p{-	IS_Khojki}', "");
    Expect(1, 70210, '\p{^-	IS_Khojki}', "");
    Expect(1, 70210, '\P{-	IS_Khojki}', "");
    Expect(0, 70210, '\P{^-	IS_Khojki}', "");
    Error('\p{- Khoj/a/}');
    Error('\P{- Khoj/a/}');
    Expect(1, 70209, '\p{khoj}', "");
    Expect(0, 70209, '\p{^khoj}', "");
    Expect(0, 70209, '\P{khoj}', "");
    Expect(1, 70209, '\P{^khoj}', "");
    Expect(0, 70210, '\p{khoj}', "");
    Expect(1, 70210, '\p{^khoj}', "");
    Expect(1, 70210, '\P{khoj}', "");
    Expect(0, 70210, '\P{^khoj}', "");
    Expect(1, 70209, '\p{  khoj}', "");
    Expect(0, 70209, '\p{^  khoj}', "");
    Expect(0, 70209, '\P{  khoj}', "");
    Expect(1, 70209, '\P{^  khoj}', "");
    Expect(0, 70210, '\p{  khoj}', "");
    Expect(1, 70210, '\p{^  khoj}', "");
    Expect(1, 70210, '\P{  khoj}', "");
    Expect(0, 70210, '\P{^  khoj}', "");
    Error('\p{	Is_Khoj/a/}');
    Error('\P{	Is_Khoj/a/}');
    Expect(1, 70209, '\p{iskhoj}', "");
    Expect(0, 70209, '\p{^iskhoj}', "");
    Expect(0, 70209, '\P{iskhoj}', "");
    Expect(1, 70209, '\P{^iskhoj}', "");
    Expect(0, 70210, '\p{iskhoj}', "");
    Expect(1, 70210, '\p{^iskhoj}', "");
    Expect(1, 70210, '\P{iskhoj}', "");
    Expect(0, 70210, '\P{^iskhoj}', "");
    Expect(1, 70209, '\p{-_IS_Khoj}', "");
    Expect(0, 70209, '\p{^-_IS_Khoj}', "");
    Expect(0, 70209, '\P{-_IS_Khoj}', "");
    Expect(1, 70209, '\P{^-_IS_Khoj}', "");
    Expect(0, 70210, '\p{-_IS_Khoj}', "");
    Expect(1, 70210, '\p{^-_IS_Khoj}', "");
    Expect(1, 70210, '\P{-_IS_Khoj}', "");
    Expect(0, 70210, '\P{^-_IS_Khoj}', "");
    Error('\p{ :=Khudawadi}');
    Error('\P{ :=Khudawadi}');
    Expect(1, 70393, '\p{khudawadi}', "");
    Expect(0, 70393, '\p{^khudawadi}', "");
    Expect(0, 70393, '\P{khudawadi}', "");
    Expect(1, 70393, '\P{^khudawadi}', "");
    Expect(0, 70394, '\p{khudawadi}', "");
    Expect(1, 70394, '\p{^khudawadi}', "");
    Expect(1, 70394, '\P{khudawadi}', "");
    Expect(0, 70394, '\P{^khudawadi}', "");
    Expect(1, 70393, '\p{  Khudawadi}', "");
    Expect(0, 70393, '\p{^  Khudawadi}', "");
    Expect(0, 70393, '\P{  Khudawadi}', "");
    Expect(1, 70393, '\P{^  Khudawadi}', "");
    Expect(0, 70394, '\p{  Khudawadi}', "");
    Expect(1, 70394, '\p{^  Khudawadi}', "");
    Expect(1, 70394, '\P{  Khudawadi}', "");
    Expect(0, 70394, '\P{^  Khudawadi}', "");
    Error('\p{-Is_khudawadi/a/}');
    Error('\P{-Is_khudawadi/a/}');
    Expect(1, 70393, '\p{iskhudawadi}', "");
    Expect(0, 70393, '\p{^iskhudawadi}', "");
    Expect(0, 70393, '\P{iskhudawadi}', "");
    Expect(1, 70393, '\P{^iskhudawadi}', "");
    Expect(0, 70394, '\p{iskhudawadi}', "");
    Expect(1, 70394, '\p{^iskhudawadi}', "");
    Expect(1, 70394, '\P{iskhudawadi}', "");
    Expect(0, 70394, '\P{^iskhudawadi}', "");
    Expect(1, 70393, '\p{	 is_khudawadi}', "");
    Expect(0, 70393, '\p{^	 is_khudawadi}', "");
    Expect(0, 70393, '\P{	 is_khudawadi}', "");
    Expect(1, 70393, '\P{^	 is_khudawadi}', "");
    Expect(0, 70394, '\p{	 is_khudawadi}', "");
    Expect(1, 70394, '\p{^	 is_khudawadi}', "");
    Expect(1, 70394, '\P{	 is_khudawadi}', "");
    Expect(0, 70394, '\P{^	 is_khudawadi}', "");
    Error('\p{:= sind}');
    Error('\P{:= sind}');
    Expect(1, 70393, '\p{sind}', "");
    Expect(0, 70393, '\p{^sind}', "");
    Expect(0, 70393, '\P{sind}', "");
    Expect(1, 70393, '\P{^sind}', "");
    Expect(0, 70394, '\p{sind}', "");
    Expect(1, 70394, '\p{^sind}', "");
    Expect(1, 70394, '\P{sind}', "");
    Expect(0, 70394, '\P{^sind}', "");
    Error('\p{		IS_Sind:=}');
    Error('\P{		IS_Sind:=}');
    Expect(1, 70393, '\p{issind}', "");
    Expect(0, 70393, '\p{^issind}', "");
    Expect(0, 70393, '\P{issind}', "");
    Expect(1, 70393, '\P{^issind}', "");
    Expect(0, 70394, '\p{issind}', "");
    Expect(1, 70394, '\p{^issind}', "");
    Expect(1, 70394, '\P{issind}', "");
    Expect(0, 70394, '\P{^issind}', "");
    Expect(1, 70393, '\p{-Is_Sind}', "");
    Expect(0, 70393, '\p{^-Is_Sind}', "");
    Expect(0, 70393, '\P{-Is_Sind}', "");
    Expect(1, 70393, '\P{^-Is_Sind}', "");
    Expect(0, 70394, '\p{-Is_Sind}', "");
    Expect(1, 70394, '\p{^-Is_Sind}', "");
    Expect(1, 70394, '\P{-Is_Sind}', "");
    Expect(0, 70394, '\P{^-Is_Sind}', "");
    Error('\p{:= -Lao}');
    Error('\P{:= -Lao}');
    Expect(1, 3807, '\p{lao}', "");
    Expect(0, 3807, '\p{^lao}', "");
    Expect(0, 3807, '\P{lao}', "");
    Expect(1, 3807, '\P{^lao}', "");
    Expect(0, 3808, '\p{lao}', "");
    Expect(1, 3808, '\p{^lao}', "");
    Expect(1, 3808, '\P{lao}', "");
    Expect(0, 3808, '\P{^lao}', "");
    Expect(1, 3807, '\p{Lao}', "");
    Expect(0, 3807, '\p{^Lao}', "");
    Expect(0, 3807, '\P{Lao}', "");
    Expect(1, 3807, '\P{^Lao}', "");
    Expect(0, 3808, '\p{Lao}', "");
    Expect(1, 3808, '\p{^Lao}', "");
    Expect(1, 3808, '\P{Lao}', "");
    Expect(0, 3808, '\P{^Lao}', "");
    Error('\p{ :=IS_Lao}');
    Error('\P{ :=IS_Lao}');
    Expect(1, 3807, '\p{islao}', "");
    Expect(0, 3807, '\p{^islao}', "");
    Expect(0, 3807, '\P{islao}', "");
    Expect(1, 3807, '\P{^islao}', "");
    Expect(0, 3808, '\p{islao}', "");
    Expect(1, 3808, '\p{^islao}', "");
    Expect(1, 3808, '\P{islao}', "");
    Expect(0, 3808, '\P{^islao}', "");
    Expect(1, 3807, '\p{	IS_LAO}', "");
    Expect(0, 3807, '\p{^	IS_LAO}', "");
    Expect(0, 3807, '\P{	IS_LAO}', "");
    Expect(1, 3807, '\P{^	IS_LAO}', "");
    Expect(0, 3808, '\p{	IS_LAO}', "");
    Expect(1, 3808, '\p{^	IS_LAO}', "");
    Expect(1, 3808, '\P{	IS_LAO}', "");
    Expect(0, 3808, '\P{^	IS_LAO}', "");
    Error('\p{-LAOO/a/}');
    Error('\P{-LAOO/a/}');
    Expect(1, 3807, '\p{laoo}', "");
    Expect(0, 3807, '\p{^laoo}', "");
    Expect(0, 3807, '\P{laoo}', "");
    Expect(1, 3807, '\P{^laoo}', "");
    Expect(0, 3808, '\p{laoo}', "");
    Expect(1, 3808, '\p{^laoo}', "");
    Expect(1, 3808, '\P{laoo}', "");
    Expect(0, 3808, '\P{^laoo}', "");
    Expect(1, 3807, '\p{ -LAOO}', "");
    Expect(0, 3807, '\p{^ -LAOO}', "");
    Expect(0, 3807, '\P{ -LAOO}', "");
    Expect(1, 3807, '\P{^ -LAOO}', "");
    Expect(0, 3808, '\p{ -LAOO}', "");
    Expect(1, 3808, '\p{^ -LAOO}', "");
    Expect(1, 3808, '\P{ -LAOO}', "");
    Expect(0, 3808, '\P{^ -LAOO}', "");
    Error('\p{/a/--IS_LAOO}');
    Error('\P{/a/--IS_LAOO}');
    Expect(1, 3807, '\p{islaoo}', "");
    Expect(0, 3807, '\p{^islaoo}', "");
    Expect(0, 3807, '\P{islaoo}', "");
    Expect(1, 3807, '\P{^islaoo}', "");
    Expect(0, 3808, '\p{islaoo}', "");
    Expect(1, 3808, '\p{^islaoo}', "");
    Expect(1, 3808, '\P{islaoo}', "");
    Expect(0, 3808, '\P{^islaoo}', "");
    Expect(1, 3807, '\p{	_IS_laoo}', "");
    Expect(0, 3807, '\p{^	_IS_laoo}', "");
    Expect(0, 3807, '\P{	_IS_laoo}', "");
    Expect(1, 3807, '\P{^	_IS_laoo}', "");
    Expect(0, 3808, '\p{	_IS_laoo}', "");
    Expect(1, 3808, '\p{^	_IS_laoo}', "");
    Expect(1, 3808, '\P{	_IS_laoo}', "");
    Expect(0, 3808, '\P{^	_IS_laoo}', "");
    Error('\p{_	Latin:=}');
    Error('\P{_	Latin:=}');
    Expect(1, 122666, '\p{latin}', "");
    Expect(0, 122666, '\p{^latin}', "");
    Expect(0, 122666, '\P{latin}', "");
    Expect(1, 122666, '\P{^latin}', "");
    Expect(0, 122667, '\p{latin}', "");
    Expect(1, 122667, '\p{^latin}', "");
    Expect(1, 122667, '\P{latin}', "");
    Expect(0, 122667, '\P{^latin}', "");
    Expect(1, 122666, '\p{ Latin}', "");
    Expect(0, 122666, '\p{^ Latin}', "");
    Expect(0, 122666, '\P{ Latin}', "");
    Expect(1, 122666, '\P{^ Latin}', "");
    Expect(0, 122667, '\p{ Latin}', "");
    Expect(1, 122667, '\p{^ Latin}', "");
    Expect(1, 122667, '\P{ Latin}', "");
    Expect(0, 122667, '\P{^ Latin}', "");
    Error('\p{ IS_Latin/a/}');
    Error('\P{ IS_Latin/a/}');
    Expect(1, 122666, '\p{islatin}', "");
    Expect(0, 122666, '\p{^islatin}', "");
    Expect(0, 122666, '\P{islatin}', "");
    Expect(1, 122666, '\P{^islatin}', "");
    Expect(0, 122667, '\p{islatin}', "");
    Expect(1, 122667, '\p{^islatin}', "");
    Expect(1, 122667, '\P{islatin}', "");
    Expect(0, 122667, '\P{^islatin}', "");
    Expect(1, 122666, '\p{--IS_latin}', "");
    Expect(0, 122666, '\p{^--IS_latin}', "");
    Expect(0, 122666, '\P{--IS_latin}', "");
    Expect(1, 122666, '\P{^--IS_latin}', "");
    Expect(0, 122667, '\p{--IS_latin}', "");
    Expect(1, 122667, '\p{^--IS_latin}', "");
    Expect(1, 122667, '\P{--IS_latin}', "");
    Expect(0, 122667, '\P{^--IS_latin}', "");
    Error('\p{	_Latn/a/}');
    Error('\P{	_Latn/a/}');
    Expect(1, 122666, '\p{latn}', "");
    Expect(0, 122666, '\p{^latn}', "");
    Expect(0, 122666, '\P{latn}', "");
    Expect(1, 122666, '\P{^latn}', "");
    Expect(0, 122667, '\p{latn}', "");
    Expect(1, 122667, '\p{^latn}', "");
    Expect(1, 122667, '\P{latn}', "");
    Expect(0, 122667, '\P{^latn}', "");
    Expect(1, 122666, '\p{-_LATN}', "");
    Expect(0, 122666, '\p{^-_LATN}', "");
    Expect(0, 122666, '\P{-_LATN}', "");
    Expect(1, 122666, '\P{^-_LATN}', "");
    Expect(0, 122667, '\p{-_LATN}', "");
    Expect(1, 122667, '\p{^-_LATN}', "");
    Expect(1, 122667, '\P{-_LATN}', "");
    Expect(0, 122667, '\P{^-_LATN}', "");
    Error('\p{_ Is_Latn/a/}');
    Error('\P{_ Is_Latn/a/}');
    Expect(1, 122666, '\p{islatn}', "");
    Expect(0, 122666, '\p{^islatn}', "");
    Expect(0, 122666, '\P{islatn}', "");
    Expect(1, 122666, '\P{^islatn}', "");
    Expect(0, 122667, '\p{islatn}', "");
    Expect(1, 122667, '\p{^islatn}', "");
    Expect(1, 122667, '\P{islatn}', "");
    Expect(0, 122667, '\P{^islatn}', "");
    Expect(1, 122666, '\p{ _Is_Latn}', "");
    Expect(0, 122666, '\p{^ _Is_Latn}', "");
    Expect(0, 122666, '\P{ _Is_Latn}', "");
    Expect(1, 122666, '\P{^ _Is_Latn}', "");
    Expect(0, 122667, '\p{ _Is_Latn}', "");
    Expect(1, 122667, '\p{^ _Is_Latn}', "");
    Expect(1, 122667, '\P{ _Is_Latn}', "");
    Expect(0, 122667, '\P{^ _Is_Latn}', "");
    Error('\p{ 	Latin_1_Supplement/a/}');
    Error('\P{ 	Latin_1_Supplement/a/}');
    Expect(1, 255, '\p{latin1supplement}', "");
    Expect(0, 255, '\p{^latin1supplement}', "");
    Expect(0, 255, '\P{latin1supplement}', "");
    Expect(1, 255, '\P{^latin1supplement}', "");
    Expect(0, 256, '\p{latin1supplement}', "");
    Expect(1, 256, '\p{^latin1supplement}', "");
    Expect(1, 256, '\P{latin1supplement}', "");
    Expect(0, 256, '\P{^latin1supplement}', "");
    Expect(1, 255, '\p{_-LATIN_1_Supplement}', "");
    Expect(0, 255, '\p{^_-LATIN_1_Supplement}', "");
    Expect(0, 255, '\P{_-LATIN_1_Supplement}', "");
    Expect(1, 255, '\P{^_-LATIN_1_Supplement}', "");
    Expect(0, 256, '\p{_-LATIN_1_Supplement}', "");
    Expect(1, 256, '\p{^_-LATIN_1_Supplement}', "");
    Expect(1, 256, '\P{_-LATIN_1_Supplement}', "");
    Expect(0, 256, '\P{^_-LATIN_1_Supplement}', "");
    Error('\p{-	is_Latin_1_supplement/a/}');
    Error('\P{-	is_Latin_1_supplement/a/}');
    Expect(1, 255, '\p{islatin1supplement}', "");
    Expect(0, 255, '\p{^islatin1supplement}', "");
    Expect(0, 255, '\P{islatin1supplement}', "");
    Expect(1, 255, '\P{^islatin1supplement}', "");
    Expect(0, 256, '\p{islatin1supplement}', "");
    Expect(1, 256, '\p{^islatin1supplement}', "");
    Expect(1, 256, '\P{islatin1supplement}', "");
    Expect(0, 256, '\P{^islatin1supplement}', "");
    Expect(1, 255, '\p{ _IS_Latin_1_SUPPLEMENT}', "");
    Expect(0, 255, '\p{^ _IS_Latin_1_SUPPLEMENT}', "");
    Expect(0, 255, '\P{ _IS_Latin_1_SUPPLEMENT}', "");
    Expect(1, 255, '\P{^ _IS_Latin_1_SUPPLEMENT}', "");
    Expect(0, 256, '\p{ _IS_Latin_1_SUPPLEMENT}', "");
    Expect(1, 256, '\p{^ _IS_Latin_1_SUPPLEMENT}', "");
    Expect(1, 256, '\P{ _IS_Latin_1_SUPPLEMENT}', "");
    Expect(0, 256, '\P{^ _IS_Latin_1_SUPPLEMENT}', "");
    Error('\p{:=	 In_LATIN_1_SUPPLEMENT}');
    Error('\P{:=	 In_LATIN_1_SUPPLEMENT}');
    Expect(1, 255, '\p{inlatin1supplement}', "");
    Expect(0, 255, '\p{^inlatin1supplement}', "");
    Expect(0, 255, '\P{inlatin1supplement}', "");
    Expect(1, 255, '\P{^inlatin1supplement}', "");
    Expect(0, 256, '\p{inlatin1supplement}', "");
    Expect(1, 256, '\p{^inlatin1supplement}', "");
    Expect(1, 256, '\P{inlatin1supplement}', "");
    Expect(0, 256, '\P{^inlatin1supplement}', "");
    Expect(1, 255, '\p{-	in_Latin_1_supplement}', "");
    Expect(0, 255, '\p{^-	in_Latin_1_supplement}', "");
    Expect(0, 255, '\P{-	in_Latin_1_supplement}', "");
    Expect(1, 255, '\P{^-	in_Latin_1_supplement}', "");
    Expect(0, 256, '\p{-	in_Latin_1_supplement}', "");
    Expect(1, 256, '\p{^-	in_Latin_1_supplement}', "");
    Expect(1, 256, '\P{-	in_Latin_1_supplement}', "");
    Expect(0, 256, '\P{^-	in_Latin_1_supplement}', "");
    Error('\p{ Latin_1_Sup:=}');
    Error('\P{ Latin_1_Sup:=}');
    Expect(1, 255, '\p{latin1sup}', "");
    Expect(0, 255, '\p{^latin1sup}', "");
    Expect(0, 255, '\P{latin1sup}', "");
    Expect(1, 255, '\P{^latin1sup}', "");
    Expect(0, 256, '\p{latin1sup}', "");
    Expect(1, 256, '\p{^latin1sup}', "");
    Expect(1, 256, '\P{latin1sup}', "");
    Expect(0, 256, '\P{^latin1sup}', "");
    Expect(1, 255, '\p{_ LATIN_1_SUP}', "");
    Expect(0, 255, '\p{^_ LATIN_1_SUP}', "");
    Expect(0, 255, '\P{_ LATIN_1_SUP}', "");
    Expect(1, 255, '\P{^_ LATIN_1_SUP}', "");
    Expect(0, 256, '\p{_ LATIN_1_SUP}', "");
    Expect(1, 256, '\p{^_ LATIN_1_SUP}', "");
    Expect(1, 256, '\P{_ LATIN_1_SUP}', "");
    Expect(0, 256, '\P{^_ LATIN_1_SUP}', "");
    Error('\p{/a/	 is_Latin_1_sup}');
    Error('\P{/a/	 is_Latin_1_sup}');
    Expect(1, 255, '\p{islatin1sup}', "");
    Expect(0, 255, '\p{^islatin1sup}', "");
    Expect(0, 255, '\P{islatin1sup}', "");
    Expect(1, 255, '\P{^islatin1sup}', "");
    Expect(0, 256, '\p{islatin1sup}', "");
    Expect(1, 256, '\p{^islatin1sup}', "");
    Expect(1, 256, '\P{islatin1sup}', "");
    Expect(0, 256, '\P{^islatin1sup}', "");
    Expect(1, 255, '\p{Is_Latin_1_Sup}', "");
    Expect(0, 255, '\p{^Is_Latin_1_Sup}', "");
    Expect(0, 255, '\P{Is_Latin_1_Sup}', "");
    Expect(1, 255, '\P{^Is_Latin_1_Sup}', "");
    Expect(0, 256, '\p{Is_Latin_1_Sup}', "");
    Expect(1, 256, '\p{^Is_Latin_1_Sup}', "");
    Expect(1, 256, '\P{Is_Latin_1_Sup}', "");
    Expect(0, 256, '\P{^Is_Latin_1_Sup}', "");
    Error('\p{/a/	IN_latin_1_SUP}');
    Error('\P{/a/	IN_latin_1_SUP}');
    Expect(1, 255, '\p{inlatin1sup}', "");
    Expect(0, 255, '\p{^inlatin1sup}', "");
    Expect(0, 255, '\P{inlatin1sup}', "");
    Expect(1, 255, '\P{^inlatin1sup}', "");
    Expect(0, 256, '\p{inlatin1sup}', "");
    Expect(1, 256, '\p{^inlatin1sup}', "");
    Expect(1, 256, '\P{inlatin1sup}', "");
    Expect(0, 256, '\P{^inlatin1sup}', "");
    Expect(1, 255, '\p{In_Latin_1_SUP}', "");
    Expect(0, 255, '\p{^In_Latin_1_SUP}', "");
    Expect(0, 255, '\P{In_Latin_1_SUP}', "");
    Expect(1, 255, '\P{^In_Latin_1_SUP}', "");
    Expect(0, 256, '\p{In_Latin_1_SUP}', "");
    Expect(1, 256, '\p{^In_Latin_1_SUP}', "");
    Expect(1, 256, '\P{In_Latin_1_SUP}', "");
    Expect(0, 256, '\P{^In_Latin_1_SUP}', "");
    Error('\p{:=Latin_1}');
    Error('\P{:=Latin_1}');
    Expect(1, 255, '\p{latin1}', "");
    Expect(0, 255, '\p{^latin1}', "");
    Expect(0, 255, '\P{latin1}', "");
    Expect(1, 255, '\P{^latin1}', "");
    Expect(0, 256, '\p{latin1}', "");
    Expect(1, 256, '\p{^latin1}', "");
    Expect(1, 256, '\P{latin1}', "");
    Expect(0, 256, '\P{^latin1}', "");
    Expect(1, 255, '\p{_ Latin_1}', "");
    Expect(0, 255, '\p{^_ Latin_1}', "");
    Expect(0, 255, '\P{_ Latin_1}', "");
    Expect(1, 255, '\P{^_ Latin_1}', "");
    Expect(0, 256, '\p{_ Latin_1}', "");
    Expect(1, 256, '\p{^_ Latin_1}', "");
    Expect(1, 256, '\P{_ Latin_1}', "");
    Expect(0, 256, '\P{^_ Latin_1}', "");
    Error('\p{ 	is_LATIN_1/a/}');
    Error('\P{ 	is_LATIN_1/a/}');
    Expect(1, 255, '\p{islatin1}', "");
    Expect(0, 255, '\p{^islatin1}', "");
    Expect(0, 255, '\P{islatin1}', "");
    Expect(1, 255, '\P{^islatin1}', "");
    Expect(0, 256, '\p{islatin1}', "");
    Expect(1, 256, '\p{^islatin1}', "");
    Expect(1, 256, '\P{islatin1}', "");
    Expect(0, 256, '\P{^islatin1}', "");
    Expect(1, 255, '\p{_	Is_latin_1}', "");
    Expect(0, 255, '\p{^_	Is_latin_1}', "");
    Expect(0, 255, '\P{_	Is_latin_1}', "");
    Expect(1, 255, '\P{^_	Is_latin_1}', "");
    Expect(0, 256, '\p{_	Is_latin_1}', "");
    Expect(1, 256, '\p{^_	Is_latin_1}', "");
    Expect(1, 256, '\P{_	Is_latin_1}', "");
    Expect(0, 256, '\P{^_	Is_latin_1}', "");
    Error('\p{:=In_Latin_1}');
    Error('\P{:=In_Latin_1}');
    Expect(1, 255, '\p{inlatin1}', "");
    Expect(0, 255, '\p{^inlatin1}', "");
    Expect(0, 255, '\P{inlatin1}', "");
    Expect(1, 255, '\P{^inlatin1}', "");
    Expect(0, 256, '\p{inlatin1}', "");
    Expect(1, 256, '\p{^inlatin1}', "");
    Expect(1, 256, '\P{inlatin1}', "");
    Expect(0, 256, '\P{^inlatin1}', "");
    Expect(1, 255, '\p{	In_latin_1}', "");
    Expect(0, 255, '\p{^	In_latin_1}', "");
    Expect(0, 255, '\P{	In_latin_1}', "");
    Expect(1, 255, '\P{^	In_latin_1}', "");
    Expect(0, 256, '\p{	In_latin_1}', "");
    Expect(1, 256, '\p{^	In_latin_1}', "");
    Expect(1, 256, '\P{	In_latin_1}', "");
    Expect(0, 256, '\P{^	In_latin_1}', "");
    Error('\p{__Latin_Extended_A:=}');
    Error('\P{__Latin_Extended_A:=}');
    Expect(1, 383, '\p{latinextendeda}', "");
    Expect(0, 383, '\p{^latinextendeda}', "");
    Expect(0, 383, '\P{latinextendeda}', "");
    Expect(1, 383, '\P{^latinextendeda}', "");
    Expect(0, 384, '\p{latinextendeda}', "");
    Expect(1, 384, '\p{^latinextendeda}', "");
    Expect(1, 384, '\P{latinextendeda}', "");
    Expect(0, 384, '\P{^latinextendeda}', "");
    Expect(1, 383, '\p{-	Latin_extended_A}', "");
    Expect(0, 383, '\p{^-	Latin_extended_A}', "");
    Expect(0, 383, '\P{-	Latin_extended_A}', "");
    Expect(1, 383, '\P{^-	Latin_extended_A}', "");
    Expect(0, 384, '\p{-	Latin_extended_A}', "");
    Expect(1, 384, '\p{^-	Latin_extended_A}', "");
    Expect(1, 384, '\P{-	Latin_extended_A}', "");
    Expect(0, 384, '\P{^-	Latin_extended_A}', "");
    Error('\p{- Is_Latin_extended_A/a/}');
    Error('\P{- Is_Latin_extended_A/a/}');
    Expect(1, 383, '\p{islatinextendeda}', "");
    Expect(0, 383, '\p{^islatinextendeda}', "");
    Expect(0, 383, '\P{islatinextendeda}', "");
    Expect(1, 383, '\P{^islatinextendeda}', "");
    Expect(0, 384, '\p{islatinextendeda}', "");
    Expect(1, 384, '\p{^islatinextendeda}', "");
    Expect(1, 384, '\P{islatinextendeda}', "");
    Expect(0, 384, '\P{^islatinextendeda}', "");
    Expect(1, 383, '\p{ -is_LATIN_Extended_A}', "");
    Expect(0, 383, '\p{^ -is_LATIN_Extended_A}', "");
    Expect(0, 383, '\P{ -is_LATIN_Extended_A}', "");
    Expect(1, 383, '\P{^ -is_LATIN_Extended_A}', "");
    Expect(0, 384, '\p{ -is_LATIN_Extended_A}', "");
    Expect(1, 384, '\p{^ -is_LATIN_Extended_A}', "");
    Expect(1, 384, '\P{ -is_LATIN_Extended_A}', "");
    Expect(0, 384, '\P{^ -is_LATIN_Extended_A}', "");
    Error('\p{ in_Latin_Extended_A/a/}');
    Error('\P{ in_Latin_Extended_A/a/}');
    Expect(1, 383, '\p{inlatinextendeda}', "");
    Expect(0, 383, '\p{^inlatinextendeda}', "");
    Expect(0, 383, '\P{inlatinextendeda}', "");
    Expect(1, 383, '\P{^inlatinextendeda}', "");
    Expect(0, 384, '\p{inlatinextendeda}', "");
    Expect(1, 384, '\p{^inlatinextendeda}', "");
    Expect(1, 384, '\P{inlatinextendeda}', "");
    Expect(0, 384, '\P{^inlatinextendeda}', "");
    Expect(1, 383, '\p{ 	In_latin_Extended_A}', "");
    Expect(0, 383, '\p{^ 	In_latin_Extended_A}', "");
    Expect(0, 383, '\P{ 	In_latin_Extended_A}', "");
    Expect(1, 383, '\P{^ 	In_latin_Extended_A}', "");
    Expect(0, 384, '\p{ 	In_latin_Extended_A}', "");
    Expect(1, 384, '\p{^ 	In_latin_Extended_A}', "");
    Expect(1, 384, '\P{ 	In_latin_Extended_A}', "");
    Expect(0, 384, '\P{^ 	In_latin_Extended_A}', "");
    Error('\p{/a/ 	latin_Ext_a}');
    Error('\P{/a/ 	latin_Ext_a}');
    Expect(1, 383, '\p{latinexta}', "");
    Expect(0, 383, '\p{^latinexta}', "");
    Expect(0, 383, '\P{latinexta}', "");
    Expect(1, 383, '\P{^latinexta}', "");
    Expect(0, 384, '\p{latinexta}', "");
    Expect(1, 384, '\p{^latinexta}', "");
    Expect(1, 384, '\P{latinexta}', "");
    Expect(0, 384, '\P{^latinexta}', "");
    Expect(1, 383, '\p{--Latin_Ext_a}', "");
    Expect(0, 383, '\p{^--Latin_Ext_a}', "");
    Expect(0, 383, '\P{--Latin_Ext_a}', "");
    Expect(1, 383, '\P{^--Latin_Ext_a}', "");
    Expect(0, 384, '\p{--Latin_Ext_a}', "");
    Expect(1, 384, '\p{^--Latin_Ext_a}', "");
    Expect(1, 384, '\P{--Latin_Ext_a}', "");
    Expect(0, 384, '\P{^--Latin_Ext_a}', "");
    Error('\p{/a/__Is_latin_Ext_A}');
    Error('\P{/a/__Is_latin_Ext_A}');
    Expect(1, 383, '\p{islatinexta}', "");
    Expect(0, 383, '\p{^islatinexta}', "");
    Expect(0, 383, '\P{islatinexta}', "");
    Expect(1, 383, '\P{^islatinexta}', "");
    Expect(0, 384, '\p{islatinexta}', "");
    Expect(1, 384, '\p{^islatinexta}', "");
    Expect(1, 384, '\P{islatinexta}', "");
    Expect(0, 384, '\P{^islatinexta}', "");
    Expect(1, 383, '\p{_ IS_latin_EXT_A}', "");
    Expect(0, 383, '\p{^_ IS_latin_EXT_A}', "");
    Expect(0, 383, '\P{_ IS_latin_EXT_A}', "");
    Expect(1, 383, '\P{^_ IS_latin_EXT_A}', "");
    Expect(0, 384, '\p{_ IS_latin_EXT_A}', "");
    Expect(1, 384, '\p{^_ IS_latin_EXT_A}', "");
    Expect(1, 384, '\P{_ IS_latin_EXT_A}', "");
    Expect(0, 384, '\P{^_ IS_latin_EXT_A}', "");
    Error('\p{:= IN_Latin_Ext_A}');
    Error('\P{:= IN_Latin_Ext_A}');
    Expect(1, 383, '\p{inlatinexta}', "");
    Expect(0, 383, '\p{^inlatinexta}', "");
    Expect(0, 383, '\P{inlatinexta}', "");
    Expect(1, 383, '\P{^inlatinexta}', "");
    Expect(0, 384, '\p{inlatinexta}', "");
    Expect(1, 384, '\p{^inlatinexta}', "");
    Expect(1, 384, '\P{inlatinexta}', "");
    Expect(0, 384, '\P{^inlatinexta}', "");
    Expect(1, 383, '\p{		in_Latin_Ext_A}', "");
    Expect(0, 383, '\p{^		in_Latin_Ext_A}', "");
    Expect(0, 383, '\P{		in_Latin_Ext_A}', "");
    Expect(1, 383, '\P{^		in_Latin_Ext_A}', "");
    Expect(0, 384, '\p{		in_Latin_Ext_A}', "");
    Expect(1, 384, '\p{^		in_Latin_Ext_A}', "");
    Expect(1, 384, '\P{		in_Latin_Ext_A}', "");
    Expect(0, 384, '\P{^		in_Latin_Ext_A}', "");
    Error('\p{	/a/Latin_Extended_ADDITIONAL}');
    Error('\P{	/a/Latin_Extended_ADDITIONAL}');
    Expect(1, 7935, '\p{latinextendedadditional}', "");
    Expect(0, 7935, '\p{^latinextendedadditional}', "");
    Expect(0, 7935, '\P{latinextendedadditional}', "");
    Expect(1, 7935, '\P{^latinextendedadditional}', "");
    Expect(0, 7936, '\p{latinextendedadditional}', "");
    Expect(1, 7936, '\p{^latinextendedadditional}', "");
    Expect(1, 7936, '\P{latinextendedadditional}', "");
    Expect(0, 7936, '\P{^latinextendedadditional}', "");
    Expect(1, 7935, '\p{ Latin_Extended_additional}', "");
    Expect(0, 7935, '\p{^ Latin_Extended_additional}', "");
    Expect(0, 7935, '\P{ Latin_Extended_additional}', "");
    Expect(1, 7935, '\P{^ Latin_Extended_additional}', "");
    Expect(0, 7936, '\p{ Latin_Extended_additional}', "");
    Expect(1, 7936, '\p{^ Latin_Extended_additional}', "");
    Expect(1, 7936, '\P{ Latin_Extended_additional}', "");
    Expect(0, 7936, '\P{^ Latin_Extended_additional}', "");
    Error('\p{-	is_Latin_Extended_Additional:=}');
    Error('\P{-	is_Latin_Extended_Additional:=}');
    Expect(1, 7935, '\p{islatinextendedadditional}', "");
    Expect(0, 7935, '\p{^islatinextendedadditional}', "");
    Expect(0, 7935, '\P{islatinextendedadditional}', "");
    Expect(1, 7935, '\P{^islatinextendedadditional}', "");
    Expect(0, 7936, '\p{islatinextendedadditional}', "");
    Expect(1, 7936, '\p{^islatinextendedadditional}', "");
    Expect(1, 7936, '\P{islatinextendedadditional}', "");
    Expect(0, 7936, '\P{^islatinextendedadditional}', "");
    Expect(1, 7935, '\p{-Is_LATIN_extended_Additional}', "");
    Expect(0, 7935, '\p{^-Is_LATIN_extended_Additional}', "");
    Expect(0, 7935, '\P{-Is_LATIN_extended_Additional}', "");
    Expect(1, 7935, '\P{^-Is_LATIN_extended_Additional}', "");
    Expect(0, 7936, '\p{-Is_LATIN_extended_Additional}', "");
    Expect(1, 7936, '\p{^-Is_LATIN_extended_Additional}', "");
    Expect(1, 7936, '\P{-Is_LATIN_extended_Additional}', "");
    Expect(0, 7936, '\P{^-Is_LATIN_extended_Additional}', "");
    Error('\p{/a/--In_Latin_Extended_additional}');
    Error('\P{/a/--In_Latin_Extended_additional}');
    Expect(1, 7935, '\p{inlatinextendedadditional}', "");
    Expect(0, 7935, '\p{^inlatinextendedadditional}', "");
    Expect(0, 7935, '\P{inlatinextendedadditional}', "");
    Expect(1, 7935, '\P{^inlatinextendedadditional}', "");
    Expect(0, 7936, '\p{inlatinextendedadditional}', "");
    Expect(1, 7936, '\p{^inlatinextendedadditional}', "");
    Expect(1, 7936, '\P{inlatinextendedadditional}', "");
    Expect(0, 7936, '\P{^inlatinextendedadditional}', "");
    Expect(1, 7935, '\p{__IN_Latin_Extended_Additional}', "");
    Expect(0, 7935, '\p{^__IN_Latin_Extended_Additional}', "");
    Expect(0, 7935, '\P{__IN_Latin_Extended_Additional}', "");
    Expect(1, 7935, '\P{^__IN_Latin_Extended_Additional}', "");
    Expect(0, 7936, '\p{__IN_Latin_Extended_Additional}', "");
    Expect(1, 7936, '\p{^__IN_Latin_Extended_Additional}', "");
    Expect(1, 7936, '\P{__IN_Latin_Extended_Additional}', "");
    Expect(0, 7936, '\P{^__IN_Latin_Extended_Additional}', "");
    Error('\p{		LATIN_Ext_Additional/a/}');
    Error('\P{		LATIN_Ext_Additional/a/}');
    Expect(1, 7935, '\p{latinextadditional}', "");
    Expect(0, 7935, '\p{^latinextadditional}', "");
    Expect(0, 7935, '\P{latinextadditional}', "");
    Expect(1, 7935, '\P{^latinextadditional}', "");
    Expect(0, 7936, '\p{latinextadditional}', "");
    Expect(1, 7936, '\p{^latinextadditional}', "");
    Expect(1, 7936, '\P{latinextadditional}', "");
    Expect(0, 7936, '\P{^latinextadditional}', "");
    Expect(1, 7935, '\p{	LATIN_ext_additional}', "");
    Expect(0, 7935, '\p{^	LATIN_ext_additional}', "");
    Expect(0, 7935, '\P{	LATIN_ext_additional}', "");
    Expect(1, 7935, '\P{^	LATIN_ext_additional}', "");
    Expect(0, 7936, '\p{	LATIN_ext_additional}', "");
    Expect(1, 7936, '\p{^	LATIN_ext_additional}', "");
    Expect(1, 7936, '\P{	LATIN_ext_additional}', "");
    Expect(0, 7936, '\P{^	LATIN_ext_additional}', "");
    Error('\p{/a/		Is_LATIN_EXT_Additional}');
    Error('\P{/a/		Is_LATIN_EXT_Additional}');
    Expect(1, 7935, '\p{islatinextadditional}', "");
    Expect(0, 7935, '\p{^islatinextadditional}', "");
    Expect(0, 7935, '\P{islatinextadditional}', "");
    Expect(1, 7935, '\P{^islatinextadditional}', "");
    Expect(0, 7936, '\p{islatinextadditional}', "");
    Expect(1, 7936, '\p{^islatinextadditional}', "");
    Expect(1, 7936, '\P{islatinextadditional}', "");
    Expect(0, 7936, '\P{^islatinextadditional}', "");
    Expect(1, 7935, '\p{  Is_Latin_EXT_Additional}', "");
    Expect(0, 7935, '\p{^  Is_Latin_EXT_Additional}', "");
    Expect(0, 7935, '\P{  Is_Latin_EXT_Additional}', "");
    Expect(1, 7935, '\P{^  Is_Latin_EXT_Additional}', "");
    Expect(0, 7936, '\p{  Is_Latin_EXT_Additional}', "");
    Expect(1, 7936, '\p{^  Is_Latin_EXT_Additional}', "");
    Expect(1, 7936, '\P{  Is_Latin_EXT_Additional}', "");
    Expect(0, 7936, '\P{^  Is_Latin_EXT_Additional}', "");
    Error('\p{  in_LATIN_Ext_additional:=}');
    Error('\P{  in_LATIN_Ext_additional:=}');
    Expect(1, 7935, '\p{inlatinextadditional}', "");
    Expect(0, 7935, '\p{^inlatinextadditional}', "");
    Expect(0, 7935, '\P{inlatinextadditional}', "");
    Expect(1, 7935, '\P{^inlatinextadditional}', "");
    Expect(0, 7936, '\p{inlatinextadditional}', "");
    Expect(1, 7936, '\p{^inlatinextadditional}', "");
    Expect(1, 7936, '\P{inlatinextadditional}', "");
    Expect(0, 7936, '\P{^inlatinextadditional}', "");
    Expect(1, 7935, '\p{_In_latin_Ext_Additional}', "");
    Expect(0, 7935, '\p{^_In_latin_Ext_Additional}', "");
    Expect(0, 7935, '\P{_In_latin_Ext_Additional}', "");
    Expect(1, 7935, '\P{^_In_latin_Ext_Additional}', "");
    Expect(0, 7936, '\p{_In_latin_Ext_Additional}', "");
    Expect(1, 7936, '\p{^_In_latin_Ext_Additional}', "");
    Expect(1, 7936, '\P{_In_latin_Ext_Additional}', "");
    Expect(0, 7936, '\P{^_In_latin_Ext_Additional}', "");
    Error('\p{ 	latin_Extended_B:=}');
    Error('\P{ 	latin_Extended_B:=}');
    Expect(1, 591, '\p{latinextendedb}', "");
    Expect(0, 591, '\p{^latinextendedb}', "");
    Expect(0, 591, '\P{latinextendedb}', "");
    Expect(1, 591, '\P{^latinextendedb}', "");
    Expect(0, 592, '\p{latinextendedb}', "");
    Expect(1, 592, '\p{^latinextendedb}', "");
    Expect(1, 592, '\P{latinextendedb}', "");
    Expect(0, 592, '\P{^latinextendedb}', "");
    Expect(1, 591, '\p{	_Latin_Extended_b}', "");
    Expect(0, 591, '\p{^	_Latin_Extended_b}', "");
    Expect(0, 591, '\P{	_Latin_Extended_b}', "");
    Expect(1, 591, '\P{^	_Latin_Extended_b}', "");
    Expect(0, 592, '\p{	_Latin_Extended_b}', "");
    Expect(1, 592, '\p{^	_Latin_Extended_b}', "");
    Expect(1, 592, '\P{	_Latin_Extended_b}', "");
    Expect(0, 592, '\P{^	_Latin_Extended_b}', "");
    Error('\p{:=		is_Latin_extended_b}');
    Error('\P{:=		is_Latin_extended_b}');
    Expect(1, 591, '\p{islatinextendedb}', "");
    Expect(0, 591, '\p{^islatinextendedb}', "");
    Expect(0, 591, '\P{islatinextendedb}', "");
    Expect(1, 591, '\P{^islatinextendedb}', "");
    Expect(0, 592, '\p{islatinextendedb}', "");
    Expect(1, 592, '\p{^islatinextendedb}', "");
    Expect(1, 592, '\P{islatinextendedb}', "");
    Expect(0, 592, '\P{^islatinextendedb}', "");
    Expect(1, 591, '\p{	Is_Latin_EXTENDED_B}', "");
    Expect(0, 591, '\p{^	Is_Latin_EXTENDED_B}', "");
    Expect(0, 591, '\P{	Is_Latin_EXTENDED_B}', "");
    Expect(1, 591, '\P{^	Is_Latin_EXTENDED_B}', "");
    Expect(0, 592, '\p{	Is_Latin_EXTENDED_B}', "");
    Expect(1, 592, '\p{^	Is_Latin_EXTENDED_B}', "");
    Expect(1, 592, '\P{	Is_Latin_EXTENDED_B}', "");
    Expect(0, 592, '\P{^	Is_Latin_EXTENDED_B}', "");
    Error('\p{-/a/in_Latin_EXTENDED_B}');
    Error('\P{-/a/in_Latin_EXTENDED_B}');
    Expect(1, 591, '\p{inlatinextendedb}', "");
    Expect(0, 591, '\p{^inlatinextendedb}', "");
    Expect(0, 591, '\P{inlatinextendedb}', "");
    Expect(1, 591, '\P{^inlatinextendedb}', "");
    Expect(0, 592, '\p{inlatinextendedb}', "");
    Expect(1, 592, '\p{^inlatinextendedb}', "");
    Expect(1, 592, '\P{inlatinextendedb}', "");
    Expect(0, 592, '\P{^inlatinextendedb}', "");
    Expect(1, 591, '\p{-_In_LATIN_EXTENDED_B}', "");
    Expect(0, 591, '\p{^-_In_LATIN_EXTENDED_B}', "");
    Expect(0, 591, '\P{-_In_LATIN_EXTENDED_B}', "");
    Expect(1, 591, '\P{^-_In_LATIN_EXTENDED_B}', "");
    Expect(0, 592, '\p{-_In_LATIN_EXTENDED_B}', "");
    Expect(1, 592, '\p{^-_In_LATIN_EXTENDED_B}', "");
    Expect(1, 592, '\P{-_In_LATIN_EXTENDED_B}', "");
    Expect(0, 592, '\P{^-_In_LATIN_EXTENDED_B}', "");
    Error('\p{/a/	_LATIN_EXT_b}');
    Error('\P{/a/	_LATIN_EXT_b}');
    Expect(1, 591, '\p{latinextb}', "");
    Expect(0, 591, '\p{^latinextb}', "");
    Expect(0, 591, '\P{latinextb}', "");
    Expect(1, 591, '\P{^latinextb}', "");
    Expect(0, 592, '\p{latinextb}', "");
    Expect(1, 592, '\p{^latinextb}', "");
    Expect(1, 592, '\P{latinextb}', "");
    Expect(0, 592, '\P{^latinextb}', "");
    Expect(1, 591, '\p{ 	Latin_ext_B}', "");
    Expect(0, 591, '\p{^ 	Latin_ext_B}', "");
    Expect(0, 591, '\P{ 	Latin_ext_B}', "");
    Expect(1, 591, '\P{^ 	Latin_ext_B}', "");
    Expect(0, 592, '\p{ 	Latin_ext_B}', "");
    Expect(1, 592, '\p{^ 	Latin_ext_B}', "");
    Expect(1, 592, '\P{ 	Latin_ext_B}', "");
    Expect(0, 592, '\P{^ 	Latin_ext_B}', "");
    Error('\p{-	IS_latin_Ext_B:=}');
    Error('\P{-	IS_latin_Ext_B:=}');
    Expect(1, 591, '\p{islatinextb}', "");
    Expect(0, 591, '\p{^islatinextb}', "");
    Expect(0, 591, '\P{islatinextb}', "");
    Expect(1, 591, '\P{^islatinextb}', "");
    Expect(0, 592, '\p{islatinextb}', "");
    Expect(1, 592, '\p{^islatinextb}', "");
    Expect(1, 592, '\P{islatinextb}', "");
    Expect(0, 592, '\P{^islatinextb}', "");
    Expect(1, 591, '\p{	-Is_Latin_Ext_b}', "");
    Expect(0, 591, '\p{^	-Is_Latin_Ext_b}', "");
    Expect(0, 591, '\P{	-Is_Latin_Ext_b}', "");
    Expect(1, 591, '\P{^	-Is_Latin_Ext_b}', "");
    Expect(0, 592, '\p{	-Is_Latin_Ext_b}', "");
    Expect(1, 592, '\p{^	-Is_Latin_Ext_b}', "");
    Expect(1, 592, '\P{	-Is_Latin_Ext_b}', "");
    Expect(0, 592, '\P{^	-Is_Latin_Ext_b}', "");
    Error('\p{/a/  In_latin_ext_B}');
    Error('\P{/a/  In_latin_ext_B}');
    Expect(1, 591, '\p{inlatinextb}', "");
    Expect(0, 591, '\p{^inlatinextb}', "");
    Expect(0, 591, '\P{inlatinextb}', "");
    Expect(1, 591, '\P{^inlatinextb}', "");
    Expect(0, 592, '\p{inlatinextb}', "");
    Expect(1, 592, '\p{^inlatinextb}', "");
    Expect(1, 592, '\P{inlatinextb}', "");
    Expect(0, 592, '\P{^inlatinextb}', "");
    Expect(1, 591, '\p{-in_LATIN_Ext_B}', "");
    Expect(0, 591, '\p{^-in_LATIN_Ext_B}', "");
    Expect(0, 591, '\P{-in_LATIN_Ext_B}', "");
    Expect(1, 591, '\P{^-in_LATIN_Ext_B}', "");
    Expect(0, 592, '\p{-in_LATIN_Ext_B}', "");
    Expect(1, 592, '\p{^-in_LATIN_Ext_B}', "");
    Expect(1, 592, '\P{-in_LATIN_Ext_B}', "");
    Expect(0, 592, '\P{^-in_LATIN_Ext_B}', "");
    Error('\p{-:=Latin_Extended_c}');
    Error('\P{-:=Latin_Extended_c}');
    Expect(1, 11391, '\p{latinextendedc}', "");
    Expect(0, 11391, '\p{^latinextendedc}', "");
    Expect(0, 11391, '\P{latinextendedc}', "");
    Expect(1, 11391, '\P{^latinextendedc}', "");
    Expect(0, 11392, '\p{latinextendedc}', "");
    Expect(1, 11392, '\p{^latinextendedc}', "");
    Expect(1, 11392, '\P{latinextendedc}', "");
    Expect(0, 11392, '\P{^latinextendedc}', "");
    Expect(1, 11391, '\p{-latin_Extended_C}', "");
    Expect(0, 11391, '\p{^-latin_Extended_C}', "");
    Expect(0, 11391, '\P{-latin_Extended_C}', "");
    Expect(1, 11391, '\P{^-latin_Extended_C}', "");
    Expect(0, 11392, '\p{-latin_Extended_C}', "");
    Expect(1, 11392, '\p{^-latin_Extended_C}', "");
    Expect(1, 11392, '\P{-latin_Extended_C}', "");
    Expect(0, 11392, '\P{^-latin_Extended_C}', "");
    Error('\p{/a/  is_latin_Extended_C}');
    Error('\P{/a/  is_latin_Extended_C}');
    Expect(1, 11391, '\p{islatinextendedc}', "");
    Expect(0, 11391, '\p{^islatinextendedc}', "");
    Expect(0, 11391, '\P{islatinextendedc}', "");
    Expect(1, 11391, '\P{^islatinextendedc}', "");
    Expect(0, 11392, '\p{islatinextendedc}', "");
    Expect(1, 11392, '\p{^islatinextendedc}', "");
    Expect(1, 11392, '\P{islatinextendedc}', "");
    Expect(0, 11392, '\P{^islatinextendedc}', "");
    Expect(1, 11391, '\p{ -IS_Latin_extended_C}', "");
    Expect(0, 11391, '\p{^ -IS_Latin_extended_C}', "");
    Expect(0, 11391, '\P{ -IS_Latin_extended_C}', "");
    Expect(1, 11391, '\P{^ -IS_Latin_extended_C}', "");
    Expect(0, 11392, '\p{ -IS_Latin_extended_C}', "");
    Expect(1, 11392, '\p{^ -IS_Latin_extended_C}', "");
    Expect(1, 11392, '\P{ -IS_Latin_extended_C}', "");
    Expect(0, 11392, '\P{^ -IS_Latin_extended_C}', "");
    Error('\p{/a/	_IN_LATIN_EXTENDED_C}');
    Error('\P{/a/	_IN_LATIN_EXTENDED_C}');
    Expect(1, 11391, '\p{inlatinextendedc}', "");
    Expect(0, 11391, '\p{^inlatinextendedc}', "");
    Expect(0, 11391, '\P{inlatinextendedc}', "");
    Expect(1, 11391, '\P{^inlatinextendedc}', "");
    Expect(0, 11392, '\p{inlatinextendedc}', "");
    Expect(1, 11392, '\p{^inlatinextendedc}', "");
    Expect(1, 11392, '\P{inlatinextendedc}', "");
    Expect(0, 11392, '\P{^inlatinextendedc}', "");
    Expect(1, 11391, '\p{-In_latin_extended_c}', "");
    Expect(0, 11391, '\p{^-In_latin_extended_c}', "");
    Expect(0, 11391, '\P{-In_latin_extended_c}', "");
    Expect(1, 11391, '\P{^-In_latin_extended_c}', "");
    Expect(0, 11392, '\p{-In_latin_extended_c}', "");
    Expect(1, 11392, '\p{^-In_latin_extended_c}', "");
    Expect(1, 11392, '\P{-In_latin_extended_c}', "");
    Expect(0, 11392, '\P{^-In_latin_extended_c}', "");
    Error('\p{ -Latin_Ext_c/a/}');
    Error('\P{ -Latin_Ext_c/a/}');
    Expect(1, 11391, '\p{latinextc}', "");
    Expect(0, 11391, '\p{^latinextc}', "");
    Expect(0, 11391, '\P{latinextc}', "");
    Expect(1, 11391, '\P{^latinextc}', "");
    Expect(0, 11392, '\p{latinextc}', "");
    Expect(1, 11392, '\p{^latinextc}', "");
    Expect(1, 11392, '\P{latinextc}', "");
    Expect(0, 11392, '\P{^latinextc}', "");
    Expect(1, 11391, '\p{ _LATIN_EXT_c}', "");
    Expect(0, 11391, '\p{^ _LATIN_EXT_c}', "");
    Expect(0, 11391, '\P{ _LATIN_EXT_c}', "");
    Expect(1, 11391, '\P{^ _LATIN_EXT_c}', "");
    Expect(0, 11392, '\p{ _LATIN_EXT_c}', "");
    Expect(1, 11392, '\p{^ _LATIN_EXT_c}', "");
    Expect(1, 11392, '\P{ _LATIN_EXT_c}', "");
    Expect(0, 11392, '\P{^ _LATIN_EXT_c}', "");
    Error('\p{:= Is_Latin_ext_C}');
    Error('\P{:= Is_Latin_ext_C}');
    Expect(1, 11391, '\p{islatinextc}', "");
    Expect(0, 11391, '\p{^islatinextc}', "");
    Expect(0, 11391, '\P{islatinextc}', "");
    Expect(1, 11391, '\P{^islatinextc}', "");
    Expect(0, 11392, '\p{islatinextc}', "");
    Expect(1, 11392, '\p{^islatinextc}', "");
    Expect(1, 11392, '\P{islatinextc}', "");
    Expect(0, 11392, '\P{^islatinextc}', "");
    Expect(1, 11391, '\p{_	Is_latin_EXT_C}', "");
    Expect(0, 11391, '\p{^_	Is_latin_EXT_C}', "");
    Expect(0, 11391, '\P{_	Is_latin_EXT_C}', "");
    Expect(1, 11391, '\P{^_	Is_latin_EXT_C}', "");
    Expect(0, 11392, '\p{_	Is_latin_EXT_C}', "");
    Expect(1, 11392, '\p{^_	Is_latin_EXT_C}', "");
    Expect(1, 11392, '\P{_	Is_latin_EXT_C}', "");
    Expect(0, 11392, '\P{^_	Is_latin_EXT_C}', "");
    Error('\p{__In_Latin_Ext_C/a/}');
    Error('\P{__In_Latin_Ext_C/a/}');
    Expect(1, 11391, '\p{inlatinextc}', "");
    Expect(0, 11391, '\p{^inlatinextc}', "");
    Expect(0, 11391, '\P{inlatinextc}', "");
    Expect(1, 11391, '\P{^inlatinextc}', "");
    Expect(0, 11392, '\p{inlatinextc}', "");
    Expect(1, 11392, '\p{^inlatinextc}', "");
    Expect(1, 11392, '\P{inlatinextc}', "");
    Expect(0, 11392, '\P{^inlatinextc}', "");
    Expect(1, 11391, '\p{ In_LATIN_ext_C}', "");
    Expect(0, 11391, '\p{^ In_LATIN_ext_C}', "");
    Expect(0, 11391, '\P{ In_LATIN_ext_C}', "");
    Expect(1, 11391, '\P{^ In_LATIN_ext_C}', "");
    Expect(0, 11392, '\p{ In_LATIN_ext_C}', "");
    Expect(1, 11392, '\p{^ In_LATIN_ext_C}', "");
    Expect(1, 11392, '\P{ In_LATIN_ext_C}', "");
    Expect(0, 11392, '\P{^ In_LATIN_ext_C}', "");
    Error('\p{	/a/latin_EXTENDED_D}');
    Error('\P{	/a/latin_EXTENDED_D}');
    Expect(1, 43007, '\p{latinextendedd}', "");
    Expect(0, 43007, '\p{^latinextendedd}', "");
    Expect(0, 43007, '\P{latinextendedd}', "");
    Expect(1, 43007, '\P{^latinextendedd}', "");
    Expect(0, 43008, '\p{latinextendedd}', "");
    Expect(1, 43008, '\p{^latinextendedd}', "");
    Expect(1, 43008, '\P{latinextendedd}', "");
    Expect(0, 43008, '\P{^latinextendedd}', "");
    Expect(1, 43007, '\p{ -latin_Extended_d}', "");
    Expect(0, 43007, '\p{^ -latin_Extended_d}', "");
    Expect(0, 43007, '\P{ -latin_Extended_d}', "");
    Expect(1, 43007, '\P{^ -latin_Extended_d}', "");
    Expect(0, 43008, '\p{ -latin_Extended_d}', "");
    Expect(1, 43008, '\p{^ -latin_Extended_d}', "");
    Expect(1, 43008, '\P{ -latin_Extended_d}', "");
    Expect(0, 43008, '\P{^ -latin_Extended_d}', "");
    Error('\p{/a/-_Is_Latin_EXTENDED_d}');
    Error('\P{/a/-_Is_Latin_EXTENDED_d}');
    Expect(1, 43007, '\p{islatinextendedd}', "");
    Expect(0, 43007, '\p{^islatinextendedd}', "");
    Expect(0, 43007, '\P{islatinextendedd}', "");
    Expect(1, 43007, '\P{^islatinextendedd}', "");
    Expect(0, 43008, '\p{islatinextendedd}', "");
    Expect(1, 43008, '\p{^islatinextendedd}', "");
    Expect(1, 43008, '\P{islatinextendedd}', "");
    Expect(0, 43008, '\P{^islatinextendedd}', "");
    Expect(1, 43007, '\p{	_Is_latin_EXTENDED_D}', "");
    Expect(0, 43007, '\p{^	_Is_latin_EXTENDED_D}', "");
    Expect(0, 43007, '\P{	_Is_latin_EXTENDED_D}', "");
    Expect(1, 43007, '\P{^	_Is_latin_EXTENDED_D}', "");
    Expect(0, 43008, '\p{	_Is_latin_EXTENDED_D}', "");
    Expect(1, 43008, '\p{^	_Is_latin_EXTENDED_D}', "");
    Expect(1, 43008, '\P{	_Is_latin_EXTENDED_D}', "");
    Expect(0, 43008, '\P{^	_Is_latin_EXTENDED_D}', "");
    Error('\p{		In_LATIN_extended_D/a/}');
    Error('\P{		In_LATIN_extended_D/a/}');
    Expect(1, 43007, '\p{inlatinextendedd}', "");
    Expect(0, 43007, '\p{^inlatinextendedd}', "");
    Expect(0, 43007, '\P{inlatinextendedd}', "");
    Expect(1, 43007, '\P{^inlatinextendedd}', "");
    Expect(0, 43008, '\p{inlatinextendedd}', "");
    Expect(1, 43008, '\p{^inlatinextendedd}', "");
    Expect(1, 43008, '\P{inlatinextendedd}', "");
    Expect(0, 43008, '\P{^inlatinextendedd}', "");
    Expect(1, 43007, '\p{_-In_Latin_Extended_D}', "");
    Expect(0, 43007, '\p{^_-In_Latin_Extended_D}', "");
    Expect(0, 43007, '\P{_-In_Latin_Extended_D}', "");
    Expect(1, 43007, '\P{^_-In_Latin_Extended_D}', "");
    Expect(0, 43008, '\p{_-In_Latin_Extended_D}', "");
    Expect(1, 43008, '\p{^_-In_Latin_Extended_D}', "");
    Expect(1, 43008, '\P{_-In_Latin_Extended_D}', "");
    Expect(0, 43008, '\P{^_-In_Latin_Extended_D}', "");
    Error('\p{:=- Latin_ext_D}');
    Error('\P{:=- Latin_ext_D}');
    Expect(1, 43007, '\p{latinextd}', "");
    Expect(0, 43007, '\p{^latinextd}', "");
    Expect(0, 43007, '\P{latinextd}', "");
    Expect(1, 43007, '\P{^latinextd}', "");
    Expect(0, 43008, '\p{latinextd}', "");
    Expect(1, 43008, '\p{^latinextd}', "");
    Expect(1, 43008, '\P{latinextd}', "");
    Expect(0, 43008, '\P{^latinextd}', "");
    Expect(1, 43007, '\p{-LATIN_EXT_D}', "");
    Expect(0, 43007, '\p{^-LATIN_EXT_D}', "");
    Expect(0, 43007, '\P{-LATIN_EXT_D}', "");
    Expect(1, 43007, '\P{^-LATIN_EXT_D}', "");
    Expect(0, 43008, '\p{-LATIN_EXT_D}', "");
    Expect(1, 43008, '\p{^-LATIN_EXT_D}', "");
    Expect(1, 43008, '\P{-LATIN_EXT_D}', "");
    Expect(0, 43008, '\P{^-LATIN_EXT_D}', "");
    Error('\p{-/a/Is_Latin_Ext_D}');
    Error('\P{-/a/Is_Latin_Ext_D}');
    Expect(1, 43007, '\p{islatinextd}', "");
    Expect(0, 43007, '\p{^islatinextd}', "");
    Expect(0, 43007, '\P{islatinextd}', "");
    Expect(1, 43007, '\P{^islatinextd}', "");
    Expect(0, 43008, '\p{islatinextd}', "");
    Expect(1, 43008, '\p{^islatinextd}', "");
    Expect(1, 43008, '\P{islatinextd}', "");
    Expect(0, 43008, '\P{^islatinextd}', "");
    Expect(1, 43007, '\p{_	Is_Latin_Ext_D}', "");
    Expect(0, 43007, '\p{^_	Is_Latin_Ext_D}', "");
    Expect(0, 43007, '\P{_	Is_Latin_Ext_D}', "");
    Expect(1, 43007, '\P{^_	Is_Latin_Ext_D}', "");
    Expect(0, 43008, '\p{_	Is_Latin_Ext_D}', "");
    Expect(1, 43008, '\p{^_	Is_Latin_Ext_D}', "");
    Expect(1, 43008, '\P{_	Is_Latin_Ext_D}', "");
    Expect(0, 43008, '\P{^_	Is_Latin_Ext_D}', "");
    Error('\p{ :=In_latin_ext_D}');
    Error('\P{ :=In_latin_ext_D}');
    Expect(1, 43007, '\p{inlatinextd}', "");
    Expect(0, 43007, '\p{^inlatinextd}', "");
    Expect(0, 43007, '\P{inlatinextd}', "");
    Expect(1, 43007, '\P{^inlatinextd}', "");
    Expect(0, 43008, '\p{inlatinextd}', "");
    Expect(1, 43008, '\p{^inlatinextd}', "");
    Expect(1, 43008, '\P{inlatinextd}', "");
    Expect(0, 43008, '\P{^inlatinextd}', "");
    Expect(1, 43007, '\p{__In_Latin_ext_d}', "");
    Expect(0, 43007, '\p{^__In_Latin_ext_d}', "");
    Expect(0, 43007, '\P{__In_Latin_ext_d}', "");
    Expect(1, 43007, '\P{^__In_Latin_ext_d}', "");
    Expect(0, 43008, '\p{__In_Latin_ext_d}', "");
    Expect(1, 43008, '\p{^__In_Latin_ext_d}', "");
    Expect(1, 43008, '\P{__In_Latin_ext_d}', "");
    Expect(0, 43008, '\P{^__In_Latin_ext_d}', "");
    Error('\p{:=_	LATIN_extended_E}');
    Error('\P{:=_	LATIN_extended_E}');
    Expect(1, 43887, '\p{latinextendede}', "");
    Expect(0, 43887, '\p{^latinextendede}', "");
    Expect(0, 43887, '\P{latinextendede}', "");
    Expect(1, 43887, '\P{^latinextendede}', "");
    Expect(0, 43888, '\p{latinextendede}', "");
    Expect(1, 43888, '\p{^latinextendede}', "");
    Expect(1, 43888, '\P{latinextendede}', "");
    Expect(0, 43888, '\P{^latinextendede}', "");
    Expect(1, 43887, '\p{_ Latin_EXTENDED_E}', "");
    Expect(0, 43887, '\p{^_ Latin_EXTENDED_E}', "");
    Expect(0, 43887, '\P{_ Latin_EXTENDED_E}', "");
    Expect(1, 43887, '\P{^_ Latin_EXTENDED_E}', "");
    Expect(0, 43888, '\p{_ Latin_EXTENDED_E}', "");
    Expect(1, 43888, '\p{^_ Latin_EXTENDED_E}', "");
    Expect(1, 43888, '\P{_ Latin_EXTENDED_E}', "");
    Expect(0, 43888, '\P{^_ Latin_EXTENDED_E}', "");
    Error('\p{ IS_LATIN_EXTENDED_e:=}');
    Error('\P{ IS_LATIN_EXTENDED_e:=}');
    Expect(1, 43887, '\p{islatinextendede}', "");
    Expect(0, 43887, '\p{^islatinextendede}', "");
    Expect(0, 43887, '\P{islatinextendede}', "");
    Expect(1, 43887, '\P{^islatinextendede}', "");
    Expect(0, 43888, '\p{islatinextendede}', "");
    Expect(1, 43888, '\p{^islatinextendede}', "");
    Expect(1, 43888, '\P{islatinextendede}', "");
    Expect(0, 43888, '\P{^islatinextendede}', "");
    Expect(1, 43887, '\p{  is_Latin_Extended_E}', "");
    Expect(0, 43887, '\p{^  is_Latin_Extended_E}', "");
    Expect(0, 43887, '\P{  is_Latin_Extended_E}', "");
    Expect(1, 43887, '\P{^  is_Latin_Extended_E}', "");
    Expect(0, 43888, '\p{  is_Latin_Extended_E}', "");
    Expect(1, 43888, '\p{^  is_Latin_Extended_E}', "");
    Expect(1, 43888, '\P{  is_Latin_Extended_E}', "");
    Expect(0, 43888, '\P{^  is_Latin_Extended_E}', "");
    Error('\p{		In_LATIN_Extended_e/a/}');
    Error('\P{		In_LATIN_Extended_e/a/}');
    Expect(1, 43887, '\p{inlatinextendede}', "");
    Expect(0, 43887, '\p{^inlatinextendede}', "");
    Expect(0, 43887, '\P{inlatinextendede}', "");
    Expect(1, 43887, '\P{^inlatinextendede}', "");
    Expect(0, 43888, '\p{inlatinextendede}', "");
    Expect(1, 43888, '\p{^inlatinextendede}', "");
    Expect(1, 43888, '\P{inlatinextendede}', "");
    Expect(0, 43888, '\P{^inlatinextendede}', "");
    Expect(1, 43887, '\p{_-in_Latin_extended_E}', "");
    Expect(0, 43887, '\p{^_-in_Latin_extended_E}', "");
    Expect(0, 43887, '\P{_-in_Latin_extended_E}', "");
    Expect(1, 43887, '\P{^_-in_Latin_extended_E}', "");
    Expect(0, 43888, '\p{_-in_Latin_extended_E}', "");
    Expect(1, 43888, '\p{^_-in_Latin_extended_E}', "");
    Expect(1, 43888, '\P{_-in_Latin_extended_E}', "");
    Expect(0, 43888, '\P{^_-in_Latin_extended_E}', "");
    Error('\p{:=-_Latin_Ext_E}');
    Error('\P{:=-_Latin_Ext_E}');
    Expect(1, 43887, '\p{latinexte}', "");
    Expect(0, 43887, '\p{^latinexte}', "");
    Expect(0, 43887, '\P{latinexte}', "");
    Expect(1, 43887, '\P{^latinexte}', "");
    Expect(0, 43888, '\p{latinexte}', "");
    Expect(1, 43888, '\p{^latinexte}', "");
    Expect(1, 43888, '\P{latinexte}', "");
    Expect(0, 43888, '\P{^latinexte}', "");
    Expect(1, 43887, '\p{-latin_ext_E}', "");
    Expect(0, 43887, '\p{^-latin_ext_E}', "");
    Expect(0, 43887, '\P{-latin_ext_E}', "");
    Expect(1, 43887, '\P{^-latin_ext_E}', "");
    Expect(0, 43888, '\p{-latin_ext_E}', "");
    Expect(1, 43888, '\p{^-latin_ext_E}', "");
    Expect(1, 43888, '\P{-latin_ext_E}', "");
    Expect(0, 43888, '\P{^-latin_ext_E}', "");
    Error('\p{	_Is_LATIN_EXT_E:=}');
    Error('\P{	_Is_LATIN_EXT_E:=}');
    Expect(1, 43887, '\p{islatinexte}', "");
    Expect(0, 43887, '\p{^islatinexte}', "");
    Expect(0, 43887, '\P{islatinexte}', "");
    Expect(1, 43887, '\P{^islatinexte}', "");
    Expect(0, 43888, '\p{islatinexte}', "");
    Expect(1, 43888, '\p{^islatinexte}', "");
    Expect(1, 43888, '\P{islatinexte}', "");
    Expect(0, 43888, '\P{^islatinexte}', "");
    Expect(1, 43887, '\p{ 	IS_Latin_EXT_E}', "");
    Expect(0, 43887, '\p{^ 	IS_Latin_EXT_E}', "");
    Expect(0, 43887, '\P{ 	IS_Latin_EXT_E}', "");
    Expect(1, 43887, '\P{^ 	IS_Latin_EXT_E}', "");
    Expect(0, 43888, '\p{ 	IS_Latin_EXT_E}', "");
    Expect(1, 43888, '\p{^ 	IS_Latin_EXT_E}', "");
    Expect(1, 43888, '\P{ 	IS_Latin_EXT_E}', "");
    Expect(0, 43888, '\P{^ 	IS_Latin_EXT_E}', "");
    Error('\p{ -in_Latin_Ext_e:=}');
    Error('\P{ -in_Latin_Ext_e:=}');
    Expect(1, 43887, '\p{inlatinexte}', "");
    Expect(0, 43887, '\p{^inlatinexte}', "");
    Expect(0, 43887, '\P{inlatinexte}', "");
    Expect(1, 43887, '\P{^inlatinexte}', "");
    Expect(0, 43888, '\p{inlatinexte}', "");
    Expect(1, 43888, '\p{^inlatinexte}', "");
    Expect(1, 43888, '\P{inlatinexte}', "");
    Expect(0, 43888, '\P{^inlatinexte}', "");
    Expect(1, 43887, '\p{-in_Latin_EXT_E}', "");
    Expect(0, 43887, '\p{^-in_Latin_EXT_E}', "");
    Expect(0, 43887, '\P{-in_Latin_EXT_E}', "");
    Expect(1, 43887, '\P{^-in_Latin_EXT_E}', "");
    Expect(0, 43888, '\p{-in_Latin_EXT_E}', "");
    Expect(1, 43888, '\p{^-in_Latin_EXT_E}', "");
    Expect(1, 43888, '\P{-in_Latin_EXT_E}', "");
    Expect(0, 43888, '\P{^-in_Latin_EXT_E}', "");
    Error('\p{:=-_LATIN_Extended_f}');
    Error('\P{:=-_LATIN_Extended_f}');
    Expect(1, 67519, '\p{latinextendedf}', "");
    Expect(0, 67519, '\p{^latinextendedf}', "");
    Expect(0, 67519, '\P{latinextendedf}', "");
    Expect(1, 67519, '\P{^latinextendedf}', "");
    Expect(0, 67520, '\p{latinextendedf}', "");
    Expect(1, 67520, '\p{^latinextendedf}', "");
    Expect(1, 67520, '\P{latinextendedf}', "");
    Expect(0, 67520, '\P{^latinextendedf}', "");
    Expect(1, 67519, '\p{--LATIN_Extended_F}', "");
    Expect(0, 67519, '\p{^--LATIN_Extended_F}', "");
    Expect(0, 67519, '\P{--LATIN_Extended_F}', "");
    Expect(1, 67519, '\P{^--LATIN_Extended_F}', "");
    Expect(0, 67520, '\p{--LATIN_Extended_F}', "");
    Expect(1, 67520, '\p{^--LATIN_Extended_F}', "");
    Expect(1, 67520, '\P{--LATIN_Extended_F}', "");
    Expect(0, 67520, '\P{^--LATIN_Extended_F}', "");
    Error('\p{/a/	 Is_LATIN_Extended_F}');
    Error('\P{/a/	 Is_LATIN_Extended_F}');
    Expect(1, 67519, '\p{islatinextendedf}', "");
    Expect(0, 67519, '\p{^islatinextendedf}', "");
    Expect(0, 67519, '\P{islatinextendedf}', "");
    Expect(1, 67519, '\P{^islatinextendedf}', "");
    Expect(0, 67520, '\p{islatinextendedf}', "");
    Expect(1, 67520, '\p{^islatinextendedf}', "");
    Expect(1, 67520, '\P{islatinextendedf}', "");
    Expect(0, 67520, '\P{^islatinextendedf}', "");
    Expect(1, 67519, '\p{	-is_latin_Extended_F}', "");
    Expect(0, 67519, '\p{^	-is_latin_Extended_F}', "");
    Expect(0, 67519, '\P{	-is_latin_Extended_F}', "");
    Expect(1, 67519, '\P{^	-is_latin_Extended_F}', "");
    Expect(0, 67520, '\p{	-is_latin_Extended_F}', "");
    Expect(1, 67520, '\p{^	-is_latin_Extended_F}', "");
    Expect(1, 67520, '\P{	-is_latin_Extended_F}', "");
    Expect(0, 67520, '\P{^	-is_latin_Extended_F}', "");
    Error('\p{	_in_latin_extended_F:=}');
    Error('\P{	_in_latin_extended_F:=}');
    Expect(1, 67519, '\p{inlatinextendedf}', "");
    Expect(0, 67519, '\p{^inlatinextendedf}', "");
    Expect(0, 67519, '\P{inlatinextendedf}', "");
    Expect(1, 67519, '\P{^inlatinextendedf}', "");
    Expect(0, 67520, '\p{inlatinextendedf}', "");
    Expect(1, 67520, '\p{^inlatinextendedf}', "");
    Expect(1, 67520, '\P{inlatinextendedf}', "");
    Expect(0, 67520, '\P{^inlatinextendedf}', "");
    Expect(1, 67519, '\p{ In_latin_Extended_F}', "");
    Expect(0, 67519, '\p{^ In_latin_Extended_F}', "");
    Expect(0, 67519, '\P{ In_latin_Extended_F}', "");
    Expect(1, 67519, '\P{^ In_latin_Extended_F}', "");
    Expect(0, 67520, '\p{ In_latin_Extended_F}', "");
    Expect(1, 67520, '\p{^ In_latin_Extended_F}', "");
    Expect(1, 67520, '\P{ In_latin_Extended_F}', "");
    Expect(0, 67520, '\P{^ In_latin_Extended_F}', "");
    Error('\p{	LATIN_Ext_F:=}');
    Error('\P{	LATIN_Ext_F:=}');
    Expect(1, 67519, '\p{latinextf}', "");
    Expect(0, 67519, '\p{^latinextf}', "");
    Expect(0, 67519, '\P{latinextf}', "");
    Expect(1, 67519, '\P{^latinextf}', "");
    Expect(0, 67520, '\p{latinextf}', "");
    Expect(1, 67520, '\p{^latinextf}', "");
    Expect(1, 67520, '\P{latinextf}', "");
    Expect(0, 67520, '\P{^latinextf}', "");
    Expect(1, 67519, '\p{_ LATIN_ext_F}', "");
    Expect(0, 67519, '\p{^_ LATIN_ext_F}', "");
    Expect(0, 67519, '\P{_ LATIN_ext_F}', "");
    Expect(1, 67519, '\P{^_ LATIN_ext_F}', "");
    Expect(0, 67520, '\p{_ LATIN_ext_F}', "");
    Expect(1, 67520, '\p{^_ LATIN_ext_F}', "");
    Expect(1, 67520, '\P{_ LATIN_ext_F}', "");
    Expect(0, 67520, '\P{^_ LATIN_ext_F}', "");
    Error('\p{/a/Is_LATIN_ext_F}');
    Error('\P{/a/Is_LATIN_ext_F}');
    Expect(1, 67519, '\p{islatinextf}', "");
    Expect(0, 67519, '\p{^islatinextf}', "");
    Expect(0, 67519, '\P{islatinextf}', "");
    Expect(1, 67519, '\P{^islatinextf}', "");
    Expect(0, 67520, '\p{islatinextf}', "");
    Expect(1, 67520, '\p{^islatinextf}', "");
    Expect(1, 67520, '\P{islatinextf}', "");
    Expect(0, 67520, '\P{^islatinextf}', "");
    Expect(1, 67519, '\p{-_is_Latin_EXT_F}', "");
    Expect(0, 67519, '\p{^-_is_Latin_EXT_F}', "");
    Expect(0, 67519, '\P{-_is_Latin_EXT_F}', "");
    Expect(1, 67519, '\P{^-_is_Latin_EXT_F}', "");
    Expect(0, 67520, '\p{-_is_Latin_EXT_F}', "");
    Expect(1, 67520, '\p{^-_is_Latin_EXT_F}', "");
    Expect(1, 67520, '\P{-_is_Latin_EXT_F}', "");
    Expect(0, 67520, '\P{^-_is_Latin_EXT_F}', "");
    Error('\p{/a/	-In_LATIN_Ext_F}');
    Error('\P{/a/	-In_LATIN_Ext_F}');
    Expect(1, 67519, '\p{inlatinextf}', "");
    Expect(0, 67519, '\p{^inlatinextf}', "");
    Expect(0, 67519, '\P{inlatinextf}', "");
    Expect(1, 67519, '\P{^inlatinextf}', "");
    Expect(0, 67520, '\p{inlatinextf}', "");
    Expect(1, 67520, '\p{^inlatinextf}', "");
    Expect(1, 67520, '\P{inlatinextf}', "");
    Expect(0, 67520, '\P{^inlatinextf}', "");
    Expect(1, 67519, '\p{ -in_latin_Ext_F}', "");
    Expect(0, 67519, '\p{^ -in_latin_Ext_F}', "");
    Expect(0, 67519, '\P{ -in_latin_Ext_F}', "");
    Expect(1, 67519, '\P{^ -in_latin_Ext_F}', "");
    Expect(0, 67520, '\p{ -in_latin_Ext_F}', "");
    Expect(1, 67520, '\p{^ -in_latin_Ext_F}', "");
    Expect(1, 67520, '\P{ -in_latin_Ext_F}', "");
    Expect(0, 67520, '\P{^ -in_latin_Ext_F}', "");
    Error('\p{_latin_Extended_G:=}');
    Error('\P{_latin_Extended_G:=}');
    Expect(1, 122879, '\p{latinextendedg}', "");
    Expect(0, 122879, '\p{^latinextendedg}', "");
    Expect(0, 122879, '\P{latinextendedg}', "");
    Expect(1, 122879, '\P{^latinextendedg}', "");
    Expect(0, 122880, '\p{latinextendedg}', "");
    Expect(1, 122880, '\p{^latinextendedg}', "");
    Expect(1, 122880, '\P{latinextendedg}', "");
    Expect(0, 122880, '\P{^latinextendedg}', "");
    Expect(1, 122879, '\p{		LATIN_EXTENDED_g}', "");
    Expect(0, 122879, '\p{^		LATIN_EXTENDED_g}', "");
    Expect(0, 122879, '\P{		LATIN_EXTENDED_g}', "");
    Expect(1, 122879, '\P{^		LATIN_EXTENDED_g}', "");
    Expect(0, 122880, '\p{		LATIN_EXTENDED_g}', "");
    Expect(1, 122880, '\p{^		LATIN_EXTENDED_g}', "");
    Expect(1, 122880, '\P{		LATIN_EXTENDED_g}', "");
    Expect(0, 122880, '\P{^		LATIN_EXTENDED_g}', "");
    Error('\p{-Is_latin_EXTENDED_G/a/}');
    Error('\P{-Is_latin_EXTENDED_G/a/}');
    Expect(1, 122879, '\p{islatinextendedg}', "");
    Expect(0, 122879, '\p{^islatinextendedg}', "");
    Expect(0, 122879, '\P{islatinextendedg}', "");
    Expect(1, 122879, '\P{^islatinextendedg}', "");
    Expect(0, 122880, '\p{islatinextendedg}', "");
    Expect(1, 122880, '\p{^islatinextendedg}', "");
    Expect(1, 122880, '\P{islatinextendedg}', "");
    Expect(0, 122880, '\P{^islatinextendedg}', "");
    Expect(1, 122879, '\p{ Is_LATIN_extended_G}', "");
    Expect(0, 122879, '\p{^ Is_LATIN_extended_G}', "");
    Expect(0, 122879, '\P{ Is_LATIN_extended_G}', "");
    Expect(1, 122879, '\P{^ Is_LATIN_extended_G}', "");
    Expect(0, 122880, '\p{ Is_LATIN_extended_G}', "");
    Expect(1, 122880, '\p{^ Is_LATIN_extended_G}', "");
    Expect(1, 122880, '\P{ Is_LATIN_extended_G}', "");
    Expect(0, 122880, '\P{^ Is_LATIN_extended_G}', "");
    Error('\p{:=In_LATIN_extended_g}');
    Error('\P{:=In_LATIN_extended_g}');
    Expect(1, 122879, '\p{inlatinextendedg}', "");
    Expect(0, 122879, '\p{^inlatinextendedg}', "");
    Expect(0, 122879, '\P{inlatinextendedg}', "");
    Expect(1, 122879, '\P{^inlatinextendedg}', "");
    Expect(0, 122880, '\p{inlatinextendedg}', "");
    Expect(1, 122880, '\p{^inlatinextendedg}', "");
    Expect(1, 122880, '\P{inlatinextendedg}', "");
    Expect(0, 122880, '\P{^inlatinextendedg}', "");
    Expect(1, 122879, '\p{-	In_Latin_extended_g}', "");
    Expect(0, 122879, '\p{^-	In_Latin_extended_g}', "");
    Expect(0, 122879, '\P{-	In_Latin_extended_g}', "");
    Expect(1, 122879, '\P{^-	In_Latin_extended_g}', "");
    Expect(0, 122880, '\p{-	In_Latin_extended_g}', "");
    Expect(1, 122880, '\p{^-	In_Latin_extended_g}', "");
    Expect(1, 122880, '\P{-	In_Latin_extended_g}', "");
    Expect(0, 122880, '\P{^-	In_Latin_extended_g}', "");
    Error('\p{	Latin_Ext_G:=}');
    Error('\P{	Latin_Ext_G:=}');
    Expect(1, 122879, '\p{latinextg}', "");
    Expect(0, 122879, '\p{^latinextg}', "");
    Expect(0, 122879, '\P{latinextg}', "");
    Expect(1, 122879, '\P{^latinextg}', "");
    Expect(0, 122880, '\p{latinextg}', "");
    Expect(1, 122880, '\p{^latinextg}', "");
    Expect(1, 122880, '\P{latinextg}', "");
    Expect(0, 122880, '\P{^latinextg}', "");
    Expect(1, 122879, '\p{	-Latin_Ext_g}', "");
    Expect(0, 122879, '\p{^	-Latin_Ext_g}', "");
    Expect(0, 122879, '\P{	-Latin_Ext_g}', "");
    Expect(1, 122879, '\P{^	-Latin_Ext_g}', "");
    Expect(0, 122880, '\p{	-Latin_Ext_g}', "");
    Expect(1, 122880, '\p{^	-Latin_Ext_g}', "");
    Expect(1, 122880, '\P{	-Latin_Ext_g}', "");
    Expect(0, 122880, '\P{^	-Latin_Ext_g}', "");
    Error('\p{-	is_LATIN_Ext_G:=}');
    Error('\P{-	is_LATIN_Ext_G:=}');
    Expect(1, 122879, '\p{islatinextg}', "");
    Expect(0, 122879, '\p{^islatinextg}', "");
    Expect(0, 122879, '\P{islatinextg}', "");
    Expect(1, 122879, '\P{^islatinextg}', "");
    Expect(0, 122880, '\p{islatinextg}', "");
    Expect(1, 122880, '\p{^islatinextg}', "");
    Expect(1, 122880, '\P{islatinextg}', "");
    Expect(0, 122880, '\P{^islatinextg}', "");
    Expect(1, 122879, '\p{ _Is_Latin_ext_g}', "");
    Expect(0, 122879, '\p{^ _Is_Latin_ext_g}', "");
    Expect(0, 122879, '\P{ _Is_Latin_ext_g}', "");
    Expect(1, 122879, '\P{^ _Is_Latin_ext_g}', "");
    Expect(0, 122880, '\p{ _Is_Latin_ext_g}', "");
    Expect(1, 122880, '\p{^ _Is_Latin_ext_g}', "");
    Expect(1, 122880, '\P{ _Is_Latin_ext_g}', "");
    Expect(0, 122880, '\P{^ _Is_Latin_ext_g}', "");
    Error('\p{/a/ -in_Latin_ext_g}');
    Error('\P{/a/ -in_Latin_ext_g}');
    Expect(1, 122879, '\p{inlatinextg}', "");
    Expect(0, 122879, '\p{^inlatinextg}', "");
    Expect(0, 122879, '\P{inlatinextg}', "");
    Expect(1, 122879, '\P{^inlatinextg}', "");
    Expect(0, 122880, '\p{inlatinextg}', "");
    Expect(1, 122880, '\p{^inlatinextg}', "");
    Expect(1, 122880, '\P{inlatinextg}', "");
    Expect(0, 122880, '\P{^inlatinextg}', "");
    Expect(1, 122879, '\p{_IN_Latin_ext_G}', "");
    Expect(0, 122879, '\p{^_IN_Latin_ext_G}', "");
    Expect(0, 122879, '\P{_IN_Latin_ext_G}', "");
    Expect(1, 122879, '\P{^_IN_Latin_ext_G}', "");
    Expect(0, 122880, '\p{_IN_Latin_ext_G}', "");
    Expect(1, 122880, '\p{^_IN_Latin_ext_G}', "");
    Expect(1, 122880, '\P{_IN_Latin_ext_G}', "");
    Expect(0, 122880, '\P{^_IN_Latin_ext_G}', "");
    Error('\p{	Lepcha:=}');
    Error('\P{	Lepcha:=}');
    Expect(1, 7247, '\p{lepcha}', "");
    Expect(0, 7247, '\p{^lepcha}', "");
    Expect(0, 7247, '\P{lepcha}', "");
    Expect(1, 7247, '\P{^lepcha}', "");
    Expect(0, 7248, '\p{lepcha}', "");
    Expect(1, 7248, '\p{^lepcha}', "");
    Expect(1, 7248, '\P{lepcha}', "");
    Expect(0, 7248, '\P{^lepcha}', "");
    Expect(1, 7247, '\p{-LEPCHA}', "");
    Expect(0, 7247, '\p{^-LEPCHA}', "");
    Expect(0, 7247, '\P{-LEPCHA}', "");
    Expect(1, 7247, '\P{^-LEPCHA}', "");
    Expect(0, 7248, '\p{-LEPCHA}', "");
    Expect(1, 7248, '\p{^-LEPCHA}', "");
    Expect(1, 7248, '\P{-LEPCHA}', "");
    Expect(0, 7248, '\P{^-LEPCHA}', "");
    Error('\p{:=--is_Lepcha}');
    Error('\P{:=--is_Lepcha}');
    Expect(1, 7247, '\p{islepcha}', "");
    Expect(0, 7247, '\p{^islepcha}', "");
    Expect(0, 7247, '\P{islepcha}', "");
    Expect(1, 7247, '\P{^islepcha}', "");
    Expect(0, 7248, '\p{islepcha}', "");
    Expect(1, 7248, '\p{^islepcha}', "");
    Expect(1, 7248, '\P{islepcha}', "");
    Expect(0, 7248, '\P{^islepcha}', "");
    Expect(1, 7247, '\p{		IS_Lepcha}', "");
    Expect(0, 7247, '\p{^		IS_Lepcha}', "");
    Expect(0, 7247, '\P{		IS_Lepcha}', "");
    Expect(1, 7247, '\P{^		IS_Lepcha}', "");
    Expect(0, 7248, '\p{		IS_Lepcha}', "");
    Expect(1, 7248, '\p{^		IS_Lepcha}', "");
    Expect(1, 7248, '\P{		IS_Lepcha}', "");
    Expect(0, 7248, '\P{^		IS_Lepcha}', "");
    Error('\p{/a/__Lepc}');
    Error('\P{/a/__Lepc}');
    Expect(1, 7247, '\p{lepc}', "");
    Expect(0, 7247, '\p{^lepc}', "");
    Expect(0, 7247, '\P{lepc}', "");
    Expect(1, 7247, '\P{^lepc}', "");
    Expect(0, 7248, '\p{lepc}', "");
    Expect(1, 7248, '\p{^lepc}', "");
    Expect(1, 7248, '\P{lepc}', "");
    Expect(0, 7248, '\P{^lepc}', "");
    Expect(1, 7247, '\p{  lepc}', "");
    Expect(0, 7247, '\p{^  lepc}', "");
    Expect(0, 7247, '\P{  lepc}', "");
    Expect(1, 7247, '\P{^  lepc}', "");
    Expect(0, 7248, '\p{  lepc}', "");
    Expect(1, 7248, '\p{^  lepc}', "");
    Expect(1, 7248, '\P{  lepc}', "");
    Expect(0, 7248, '\P{^  lepc}', "");
    Error('\p{/a/-	Is_lepc}');
    Error('\P{/a/-	Is_lepc}');
    Expect(1, 7247, '\p{islepc}', "");
    Expect(0, 7247, '\p{^islepc}', "");
    Expect(0, 7247, '\P{islepc}', "");
    Expect(1, 7247, '\P{^islepc}', "");
    Expect(0, 7248, '\p{islepc}', "");
    Expect(1, 7248, '\p{^islepc}', "");
    Expect(1, 7248, '\P{islepc}', "");
    Expect(0, 7248, '\P{^islepc}', "");
    Expect(1, 7247, '\p{	-is_Lepc}', "");
    Expect(0, 7247, '\p{^	-is_Lepc}', "");
    Expect(0, 7247, '\P{	-is_Lepc}', "");
    Expect(1, 7247, '\P{^	-is_Lepc}', "");
    Expect(0, 7248, '\p{	-is_Lepc}', "");
    Expect(1, 7248, '\p{^	-is_Lepc}', "");
    Expect(1, 7248, '\P{	-is_Lepc}', "");
    Expect(0, 7248, '\P{^	-is_Lepc}', "");
    Error('\p{-/a/letter}');
    Error('\P{-/a/letter}');
    Expect(1, 205743, '\p{letter}', "");
    Expect(0, 205743, '\p{^letter}', "");
    Expect(0, 205743, '\P{letter}', "");
    Expect(1, 205743, '\P{^letter}', "");
    Expect(0, 205744, '\p{letter}', "");
    Expect(1, 205744, '\p{^letter}', "");
    Expect(1, 205744, '\P{letter}', "");
    Expect(0, 205744, '\P{^letter}', "");
    Expect(1, 205743, '\p{ -Letter}', "");
    Expect(0, 205743, '\p{^ -Letter}', "");
    Expect(0, 205743, '\P{ -Letter}', "");
    Expect(1, 205743, '\P{^ -Letter}', "");
    Expect(0, 205744, '\p{ -Letter}', "");
    Expect(1, 205744, '\p{^ -Letter}', "");
    Expect(1, 205744, '\P{ -Letter}', "");
    Expect(0, 205744, '\P{^ -Letter}', "");
    Error('\p{/a/	is_letter}');
    Error('\P{/a/	is_letter}');
    Expect(1, 205743, '\p{isletter}', "");
    Expect(0, 205743, '\p{^isletter}', "");
    Expect(0, 205743, '\P{isletter}', "");
    Expect(1, 205743, '\P{^isletter}', "");
    Expect(0, 205744, '\p{isletter}', "");
    Expect(1, 205744, '\p{^isletter}', "");
    Expect(1, 205744, '\P{isletter}', "");
    Expect(0, 205744, '\P{^isletter}', "");
    Expect(1, 205743, '\p{ IS_LETTER}', "");
    Expect(0, 205743, '\p{^ IS_LETTER}', "");
    Expect(0, 205743, '\P{ IS_LETTER}', "");
    Expect(1, 205743, '\P{^ IS_LETTER}', "");
    Expect(0, 205744, '\p{ IS_LETTER}', "");
    Expect(1, 205744, '\p{^ IS_LETTER}', "");
    Expect(1, 205744, '\P{ IS_LETTER}', "");
    Expect(0, 205744, '\P{^ IS_LETTER}', "");
    Error('\p{_/a/L}');
    Error('\P{_/a/L}');
    Expect(1, 205743, '\p{l}', "");
    Expect(0, 205743, '\p{^l}', "");
    Expect(0, 205743, '\P{l}', "");
    Expect(1, 205743, '\P{^l}', "");
    Expect(0, 205744, '\p{l}', "");
    Expect(1, 205744, '\p{^l}', "");
    Expect(1, 205744, '\P{l}', "");
    Expect(0, 205744, '\P{^l}', "");
    Expect(1, 205743, '\p{_ L}', "");
    Expect(0, 205743, '\p{^_ L}', "");
    Expect(0, 205743, '\P{_ L}', "");
    Expect(1, 205743, '\P{^_ L}', "");
    Expect(0, 205744, '\p{_ L}', "");
    Expect(1, 205744, '\p{^_ L}', "");
    Expect(1, 205744, '\P{_ L}', "");
    Expect(0, 205744, '\P{^_ L}', "");
    Error('\p{-Is_L/a/}');
    Error('\P{-Is_L/a/}');
    Expect(1, 205743, '\p{isl}', "");
    Expect(0, 205743, '\p{^isl}', "");
    Expect(0, 205743, '\P{isl}', "");
    Expect(1, 205743, '\P{^isl}', "");
    Expect(0, 205744, '\p{isl}', "");
    Expect(1, 205744, '\p{^isl}', "");
    Expect(1, 205744, '\P{isl}', "");
    Expect(0, 205744, '\P{^isl}', "");
    Expect(1, 205743, '\p{	Is_L}', "");
    Expect(0, 205743, '\p{^	Is_L}', "");
    Expect(0, 205743, '\P{	Is_L}', "");
    Expect(1, 205743, '\P{^	Is_L}', "");
    Expect(0, 205744, '\p{	Is_L}', "");
    Expect(1, 205744, '\p{^	Is_L}', "");
    Expect(1, 205744, '\P{	Is_L}', "");
    Expect(0, 205744, '\P{^	Is_L}', "");
    Error('\p{:= -LETTER_number}');
    Error('\P{:= -LETTER_number}');
    Expect(1, 74862, '\p{letternumber}', "");
    Expect(0, 74862, '\p{^letternumber}', "");
    Expect(0, 74862, '\P{letternumber}', "");
    Expect(1, 74862, '\P{^letternumber}', "");
    Expect(0, 74863, '\p{letternumber}', "");
    Expect(1, 74863, '\p{^letternumber}', "");
    Expect(1, 74863, '\P{letternumber}', "");
    Expect(0, 74863, '\P{^letternumber}', "");
    Expect(1, 74862, '\p{  letter_Number}', "");
    Expect(0, 74862, '\p{^  letter_Number}', "");
    Expect(0, 74862, '\P{  letter_Number}', "");
    Expect(1, 74862, '\P{^  letter_Number}', "");
    Expect(0, 74863, '\p{  letter_Number}', "");
    Expect(1, 74863, '\p{^  letter_Number}', "");
    Expect(1, 74863, '\P{  letter_Number}', "");
    Expect(0, 74863, '\P{^  letter_Number}', "");
    Error('\p{_	Is_letter_Number/a/}');
    Error('\P{_	Is_letter_Number/a/}');
    Expect(1, 74862, '\p{isletternumber}', "");
    Expect(0, 74862, '\p{^isletternumber}', "");
    Expect(0, 74862, '\P{isletternumber}', "");
    Expect(1, 74862, '\P{^isletternumber}', "");
    Expect(0, 74863, '\p{isletternumber}', "");
    Expect(1, 74863, '\p{^isletternumber}', "");
    Expect(1, 74863, '\P{isletternumber}', "");
    Expect(0, 74863, '\P{^isletternumber}', "");
    Expect(1, 74862, '\p{ IS_LETTER_number}', "");
    Expect(0, 74862, '\p{^ IS_LETTER_number}', "");
    Expect(0, 74862, '\P{ IS_LETTER_number}', "");
    Expect(1, 74862, '\P{^ IS_LETTER_number}', "");
    Expect(0, 74863, '\p{ IS_LETTER_number}', "");
    Expect(1, 74863, '\p{^ IS_LETTER_number}', "");
    Expect(1, 74863, '\P{ IS_LETTER_number}', "");
    Expect(0, 74863, '\P{^ IS_LETTER_number}', "");
    Error('\p{-	NL/a/}');
    Error('\P{-	NL/a/}');
    Expect(1, 74862, '\p{nl}', "");
    Expect(0, 74862, '\p{^nl}', "");
    Expect(0, 74862, '\P{nl}', "");
    Expect(1, 74862, '\P{^nl}', "");
    Expect(0, 74863, '\p{nl}', "");
    Expect(1, 74863, '\p{^nl}', "");
    Expect(1, 74863, '\P{nl}', "");
    Expect(0, 74863, '\P{^nl}', "");
    Expect(1, 74862, '\p{_	Nl}', "");
    Expect(0, 74862, '\p{^_	Nl}', "");
    Expect(0, 74862, '\P{_	Nl}', "");
    Expect(1, 74862, '\P{^_	Nl}', "");
    Expect(0, 74863, '\p{_	Nl}', "");
    Expect(1, 74863, '\p{^_	Nl}', "");
    Expect(1, 74863, '\P{_	Nl}', "");
    Expect(0, 74863, '\P{^_	Nl}', "");
    Error('\p{-IS_nl:=}');
    Error('\P{-IS_nl:=}');
    Expect(1, 74862, '\p{isnl}', "");
    Expect(0, 74862, '\p{^isnl}', "");
    Expect(0, 74862, '\P{isnl}', "");
    Expect(1, 74862, '\P{^isnl}', "");
    Expect(0, 74863, '\p{isnl}', "");
    Expect(1, 74863, '\p{^isnl}', "");
    Expect(1, 74863, '\P{isnl}', "");
    Expect(0, 74863, '\P{^isnl}', "");
    Expect(1, 74862, '\p{	is_Nl}', "");
    Expect(0, 74862, '\p{^	is_Nl}', "");
    Expect(0, 74862, '\P{	is_Nl}', "");
    Expect(1, 74862, '\P{^	is_Nl}', "");
    Expect(0, 74863, '\p{	is_Nl}', "");
    Expect(1, 74863, '\p{^	is_Nl}', "");
    Expect(1, 74863, '\P{	is_Nl}', "");
    Expect(0, 74863, '\P{^	is_Nl}', "");
    Error('\p{_ LETTERLIKE_SYMBOLS:=}');
    Error('\P{_ LETTERLIKE_SYMBOLS:=}');
    Expect(1, 8527, '\p{letterlikesymbols}', "");
    Expect(0, 8527, '\p{^letterlikesymbols}', "");
    Expect(0, 8527, '\P{letterlikesymbols}', "");
    Expect(1, 8527, '\P{^letterlikesymbols}', "");
    Expect(0, 8528, '\p{letterlikesymbols}', "");
    Expect(1, 8528, '\p{^letterlikesymbols}', "");
    Expect(1, 8528, '\P{letterlikesymbols}', "");
    Expect(0, 8528, '\P{^letterlikesymbols}', "");
    Expect(1, 8527, '\p{- letterlike_Symbols}', "");
    Expect(0, 8527, '\p{^- letterlike_Symbols}', "");
    Expect(0, 8527, '\P{- letterlike_Symbols}', "");
    Expect(1, 8527, '\P{^- letterlike_Symbols}', "");
    Expect(0, 8528, '\p{- letterlike_Symbols}', "");
    Expect(1, 8528, '\p{^- letterlike_Symbols}', "");
    Expect(1, 8528, '\P{- letterlike_Symbols}', "");
    Expect(0, 8528, '\P{^- letterlike_Symbols}', "");
    Error('\p{_/a/IS_LETTERLIKE_SYMBOLS}');
    Error('\P{_/a/IS_LETTERLIKE_SYMBOLS}');
    Expect(1, 8527, '\p{isletterlikesymbols}', "");
    Expect(0, 8527, '\p{^isletterlikesymbols}', "");
    Expect(0, 8527, '\P{isletterlikesymbols}', "");
    Expect(1, 8527, '\P{^isletterlikesymbols}', "");
    Expect(0, 8528, '\p{isletterlikesymbols}', "");
    Expect(1, 8528, '\p{^isletterlikesymbols}', "");
    Expect(1, 8528, '\P{isletterlikesymbols}', "");
    Expect(0, 8528, '\P{^isletterlikesymbols}', "");
    Expect(1, 8527, '\p{	 Is_letterlike_SYMBOLS}', "");
    Expect(0, 8527, '\p{^	 Is_letterlike_SYMBOLS}', "");
    Expect(0, 8527, '\P{	 Is_letterlike_SYMBOLS}', "");
    Expect(1, 8527, '\P{^	 Is_letterlike_SYMBOLS}', "");
    Expect(0, 8528, '\p{	 Is_letterlike_SYMBOLS}', "");
    Expect(1, 8528, '\p{^	 Is_letterlike_SYMBOLS}', "");
    Expect(1, 8528, '\P{	 Is_letterlike_SYMBOLS}', "");
    Expect(0, 8528, '\P{^	 Is_letterlike_SYMBOLS}', "");
    Error('\p{		In_Letterlike_SYMBOLS:=}');
    Error('\P{		In_Letterlike_SYMBOLS:=}');
    Expect(1, 8527, '\p{inletterlikesymbols}', "");
    Expect(0, 8527, '\p{^inletterlikesymbols}', "");
    Expect(0, 8527, '\P{inletterlikesymbols}', "");
    Expect(1, 8527, '\P{^inletterlikesymbols}', "");
    Expect(0, 8528, '\p{inletterlikesymbols}', "");
    Expect(1, 8528, '\p{^inletterlikesymbols}', "");
    Expect(1, 8528, '\P{inletterlikesymbols}', "");
    Expect(0, 8528, '\P{^inletterlikesymbols}', "");
    Expect(1, 8527, '\p{ 	In_Letterlike_Symbols}', "");
    Expect(0, 8527, '\p{^ 	In_Letterlike_Symbols}', "");
    Expect(0, 8527, '\P{ 	In_Letterlike_Symbols}', "");
    Expect(1, 8527, '\P{^ 	In_Letterlike_Symbols}', "");
    Expect(0, 8528, '\p{ 	In_Letterlike_Symbols}', "");
    Expect(1, 8528, '\p{^ 	In_Letterlike_Symbols}', "");
    Expect(1, 8528, '\P{ 	In_Letterlike_Symbols}', "");
    Expect(0, 8528, '\P{^ 	In_Letterlike_Symbols}', "");
    Error('\p{ /a/limbu}');
    Error('\P{ /a/limbu}');
    Expect(1, 6479, '\p{limbu}', "");
    Expect(0, 6479, '\p{^limbu}', "");
    Expect(0, 6479, '\P{limbu}', "");
    Expect(1, 6479, '\P{^limbu}', "");
    Expect(0, 6480, '\p{limbu}', "");
    Expect(1, 6480, '\p{^limbu}', "");
    Expect(1, 6480, '\P{limbu}', "");
    Expect(0, 6480, '\P{^limbu}', "");
    Expect(1, 6479, '\p{-limbu}', "");
    Expect(0, 6479, '\p{^-limbu}', "");
    Expect(0, 6479, '\P{-limbu}', "");
    Expect(1, 6479, '\P{^-limbu}', "");
    Expect(0, 6480, '\p{-limbu}', "");
    Expect(1, 6480, '\p{^-limbu}', "");
    Expect(1, 6480, '\P{-limbu}', "");
    Expect(0, 6480, '\P{^-limbu}', "");
    Error('\p{_/a/IS_limbu}');
    Error('\P{_/a/IS_limbu}');
    Expect(1, 6479, '\p{islimbu}', "");
    Expect(0, 6479, '\p{^islimbu}', "");
    Expect(0, 6479, '\P{islimbu}', "");
    Expect(1, 6479, '\P{^islimbu}', "");
    Expect(0, 6480, '\p{islimbu}', "");
    Expect(1, 6480, '\p{^islimbu}', "");
    Expect(1, 6480, '\P{islimbu}', "");
    Expect(0, 6480, '\P{^islimbu}', "");
    Expect(1, 6479, '\p{	-Is_LIMBU}', "");
    Expect(0, 6479, '\p{^	-Is_LIMBU}', "");
    Expect(0, 6479, '\P{	-Is_LIMBU}', "");
    Expect(1, 6479, '\P{^	-Is_LIMBU}', "");
    Expect(0, 6480, '\p{	-Is_LIMBU}', "");
    Expect(1, 6480, '\p{^	-Is_LIMBU}', "");
    Expect(1, 6480, '\P{	-Is_LIMBU}', "");
    Expect(0, 6480, '\P{^	-Is_LIMBU}', "");
    Error('\p{-/a/limb}');
    Error('\P{-/a/limb}');
    Expect(1, 6479, '\p{limb}', "");
    Expect(0, 6479, '\p{^limb}', "");
    Expect(0, 6479, '\P{limb}', "");
    Expect(1, 6479, '\P{^limb}', "");
    Expect(0, 6480, '\p{limb}', "");
    Expect(1, 6480, '\p{^limb}', "");
    Expect(1, 6480, '\P{limb}', "");
    Expect(0, 6480, '\P{^limb}', "");
    Expect(1, 6479, '\p{		Limb}', "");
    Expect(0, 6479, '\p{^		Limb}', "");
    Expect(0, 6479, '\P{		Limb}', "");
    Expect(1, 6479, '\P{^		Limb}', "");
    Expect(0, 6480, '\p{		Limb}', "");
    Expect(1, 6480, '\p{^		Limb}', "");
    Expect(1, 6480, '\P{		Limb}', "");
    Expect(0, 6480, '\P{^		Limb}', "");
    Error('\p{	Is_Limb/a/}');
    Error('\P{	Is_Limb/a/}');
    Expect(1, 6479, '\p{islimb}', "");
    Expect(0, 6479, '\p{^islimb}', "");
    Expect(0, 6479, '\P{islimb}', "");
    Expect(1, 6479, '\P{^islimb}', "");
    Expect(0, 6480, '\p{islimb}', "");
    Expect(1, 6480, '\p{^islimb}', "");
    Expect(1, 6480, '\P{islimb}', "");
    Expect(0, 6480, '\P{^islimb}', "");
    Expect(1, 6479, '\p{_	is_Limb}', "");
    Expect(0, 6479, '\p{^_	is_Limb}', "");
    Expect(0, 6479, '\P{_	is_Limb}', "");
    Expect(1, 6479, '\P{^_	is_Limb}', "");
    Expect(0, 6480, '\p{_	is_Limb}', "");
    Expect(1, 6480, '\p{^_	is_Limb}', "");
    Expect(1, 6480, '\P{_	is_Limb}', "");
    Expect(0, 6480, '\P{^_	is_Limb}', "");
    Error('\p{ :=LINE_Separator}');
    Error('\P{ :=LINE_Separator}');
    Expect(1, 8232, '\p{lineseparator}', "");
    Expect(0, 8232, '\p{^lineseparator}', "");
    Expect(0, 8232, '\P{lineseparator}', "");
    Expect(1, 8232, '\P{^lineseparator}', "");
    Expect(0, 8233, '\p{lineseparator}', "");
    Expect(1, 8233, '\p{^lineseparator}', "");
    Expect(1, 8233, '\P{lineseparator}', "");
    Expect(0, 8233, '\P{^lineseparator}', "");
    Expect(1, 8232, '\p{_	Line_Separator}', "");
    Expect(0, 8232, '\p{^_	Line_Separator}', "");
    Expect(0, 8232, '\P{_	Line_Separator}', "");
    Expect(1, 8232, '\P{^_	Line_Separator}', "");
    Expect(0, 8233, '\p{_	Line_Separator}', "");
    Expect(1, 8233, '\p{^_	Line_Separator}', "");
    Expect(1, 8233, '\P{_	Line_Separator}', "");
    Expect(0, 8233, '\P{^_	Line_Separator}', "");
    Error('\p{/a/- Is_Line_Separator}');
    Error('\P{/a/- Is_Line_Separator}');
    Expect(1, 8232, '\p{islineseparator}', "");
    Expect(0, 8232, '\p{^islineseparator}', "");
    Expect(0, 8232, '\P{islineseparator}', "");
    Expect(1, 8232, '\P{^islineseparator}', "");
    Expect(0, 8233, '\p{islineseparator}', "");
    Expect(1, 8233, '\p{^islineseparator}', "");
    Expect(1, 8233, '\P{islineseparator}', "");
    Expect(0, 8233, '\P{^islineseparator}', "");
    Expect(1, 8232, '\p{ -Is_Line_Separator}', "");
    Expect(0, 8232, '\p{^ -Is_Line_Separator}', "");
    Expect(0, 8232, '\P{ -Is_Line_Separator}', "");
    Expect(1, 8232, '\P{^ -Is_Line_Separator}', "");
    Expect(0, 8233, '\p{ -Is_Line_Separator}', "");
    Expect(1, 8233, '\p{^ -Is_Line_Separator}', "");
    Expect(1, 8233, '\P{ -Is_Line_Separator}', "");
    Expect(0, 8233, '\P{^ -Is_Line_Separator}', "");
    Error('\p{-/a/Zl}');
    Error('\P{-/a/Zl}');
    Expect(1, 8232, '\p{zl}', "");
    Expect(0, 8232, '\p{^zl}', "");
    Expect(0, 8232, '\P{zl}', "");
    Expect(1, 8232, '\P{^zl}', "");
    Expect(0, 8233, '\p{zl}', "");
    Expect(1, 8233, '\p{^zl}', "");
    Expect(1, 8233, '\P{zl}', "");
    Expect(0, 8233, '\P{^zl}', "");
    Expect(1, 8232, '\p{ Zl}', "");
    Expect(0, 8232, '\p{^ Zl}', "");
    Expect(0, 8232, '\P{ Zl}', "");
    Expect(1, 8232, '\P{^ Zl}', "");
    Expect(0, 8233, '\p{ Zl}', "");
    Expect(1, 8233, '\p{^ Zl}', "");
    Expect(1, 8233, '\P{ Zl}', "");
    Expect(0, 8233, '\P{^ Zl}', "");
    Error('\p{/a/ is_Zl}');
    Error('\P{/a/ is_Zl}');
    Expect(1, 8232, '\p{iszl}', "");
    Expect(0, 8232, '\p{^iszl}', "");
    Expect(0, 8232, '\P{iszl}', "");
    Expect(1, 8232, '\P{^iszl}', "");
    Expect(0, 8233, '\p{iszl}', "");
    Expect(1, 8233, '\p{^iszl}', "");
    Expect(1, 8233, '\P{iszl}', "");
    Expect(0, 8233, '\P{^iszl}', "");
    Expect(1, 8232, '\p{		Is_Zl}', "");
    Expect(0, 8232, '\p{^		Is_Zl}', "");
    Expect(0, 8232, '\P{		Is_Zl}', "");
    Expect(1, 8232, '\P{^		Is_Zl}', "");
    Expect(0, 8233, '\p{		Is_Zl}', "");
    Expect(1, 8233, '\p{^		Is_Zl}', "");
    Expect(1, 8233, '\P{		Is_Zl}', "");
    Expect(0, 8233, '\P{^		Is_Zl}', "");
    Error('\p{ /a/Linear_A}');
    Error('\P{ /a/Linear_A}');
    Expect(1, 67431, '\p{lineara}', "");
    Expect(0, 67431, '\p{^lineara}', "");
    Expect(0, 67431, '\P{lineara}', "");
    Expect(1, 67431, '\P{^lineara}', "");
    Expect(0, 67432, '\p{lineara}', "");
    Expect(1, 67432, '\p{^lineara}', "");
    Expect(1, 67432, '\P{lineara}', "");
    Expect(0, 67432, '\P{^lineara}', "");
    Expect(1, 67431, '\p{		linear_A}', "");
    Expect(0, 67431, '\p{^		linear_A}', "");
    Expect(0, 67431, '\P{		linear_A}', "");
    Expect(1, 67431, '\P{^		linear_A}', "");
    Expect(0, 67432, '\p{		linear_A}', "");
    Expect(1, 67432, '\p{^		linear_A}', "");
    Expect(1, 67432, '\P{		linear_A}', "");
    Expect(0, 67432, '\P{^		linear_A}', "");
    Error('\p{:=--is_Linear_A}');
    Error('\P{:=--is_Linear_A}');
    Expect(1, 67431, '\p{islineara}', "");
    Expect(0, 67431, '\p{^islineara}', "");
    Expect(0, 67431, '\P{islineara}', "");
    Expect(1, 67431, '\P{^islineara}', "");
    Expect(0, 67432, '\p{islineara}', "");
    Expect(1, 67432, '\p{^islineara}', "");
    Expect(1, 67432, '\P{islineara}', "");
    Expect(0, 67432, '\P{^islineara}', "");
    Expect(1, 67431, '\p{_-is_Linear_a}', "");
    Expect(0, 67431, '\p{^_-is_Linear_a}', "");
    Expect(0, 67431, '\P{_-is_Linear_a}', "");
    Expect(1, 67431, '\P{^_-is_Linear_a}', "");
    Expect(0, 67432, '\p{_-is_Linear_a}', "");
    Expect(1, 67432, '\p{^_-is_Linear_a}', "");
    Expect(1, 67432, '\P{_-is_Linear_a}', "");
    Expect(0, 67432, '\P{^_-is_Linear_a}', "");
    Error('\p{-:=Lina}');
    Error('\P{-:=Lina}');
    Expect(1, 67431, '\p{lina}', "");
    Expect(0, 67431, '\p{^lina}', "");
    Expect(0, 67431, '\P{lina}', "");
    Expect(1, 67431, '\P{^lina}', "");
    Expect(0, 67432, '\p{lina}', "");
    Expect(1, 67432, '\p{^lina}', "");
    Expect(1, 67432, '\P{lina}', "");
    Expect(0, 67432, '\P{^lina}', "");
    Expect(1, 67431, '\p{  Lina}', "");
    Expect(0, 67431, '\p{^  Lina}', "");
    Expect(0, 67431, '\P{  Lina}', "");
    Expect(1, 67431, '\P{^  Lina}', "");
    Expect(0, 67432, '\p{  Lina}', "");
    Expect(1, 67432, '\p{^  Lina}', "");
    Expect(1, 67432, '\P{  Lina}', "");
    Expect(0, 67432, '\P{^  Lina}', "");
    Error('\p{	 Is_lina:=}');
    Error('\P{	 Is_lina:=}');
    Expect(1, 67431, '\p{islina}', "");
    Expect(0, 67431, '\p{^islina}', "");
    Expect(0, 67431, '\P{islina}', "");
    Expect(1, 67431, '\P{^islina}', "");
    Expect(0, 67432, '\p{islina}', "");
    Expect(1, 67432, '\p{^islina}', "");
    Expect(1, 67432, '\P{islina}', "");
    Expect(0, 67432, '\P{^islina}', "");
    Expect(1, 67431, '\p{- is_LINA}', "");
    Expect(0, 67431, '\p{^- is_LINA}', "");
    Expect(0, 67431, '\P{- is_LINA}', "");
    Expect(1, 67431, '\P{^- is_LINA}', "");
    Expect(0, 67432, '\p{- is_LINA}', "");
    Expect(1, 67432, '\p{^- is_LINA}', "");
    Expect(1, 67432, '\P{- is_LINA}', "");
    Expect(0, 67432, '\P{^- is_LINA}', "");
    Error('\p{:=	 Linear_B}');
    Error('\P{:=	 Linear_B}');
    Expect(1, 65855, '\p{linearb}', "");
    Expect(0, 65855, '\p{^linearb}', "");
    Expect(0, 65855, '\P{linearb}', "");
    Expect(1, 65855, '\P{^linearb}', "");
    Expect(0, 65856, '\p{linearb}', "");
    Expect(1, 65856, '\p{^linearb}', "");
    Expect(1, 65856, '\P{linearb}', "");
    Expect(0, 65856, '\P{^linearb}', "");
    Expect(1, 65855, '\p{-_Linear_B}', "");
    Expect(0, 65855, '\p{^-_Linear_B}', "");
    Expect(0, 65855, '\P{-_Linear_B}', "");
    Expect(1, 65855, '\P{^-_Linear_B}', "");
    Expect(0, 65856, '\p{-_Linear_B}', "");
    Expect(1, 65856, '\p{^-_Linear_B}', "");
    Expect(1, 65856, '\P{-_Linear_B}', "");
    Expect(0, 65856, '\P{^-_Linear_B}', "");
    Error('\p{:=	Is_Linear_B}');
    Error('\P{:=	Is_Linear_B}');
    Expect(1, 65855, '\p{islinearb}', "");
    Expect(0, 65855, '\p{^islinearb}', "");
    Expect(0, 65855, '\P{islinearb}', "");
    Expect(1, 65855, '\P{^islinearb}', "");
    Expect(0, 65856, '\p{islinearb}', "");
    Expect(1, 65856, '\p{^islinearb}', "");
    Expect(1, 65856, '\P{islinearb}', "");
    Expect(0, 65856, '\P{^islinearb}', "");
    Expect(1, 65855, '\p{_IS_LINEAR_B}', "");
    Expect(0, 65855, '\p{^_IS_LINEAR_B}', "");
    Expect(0, 65855, '\P{_IS_LINEAR_B}', "");
    Expect(1, 65855, '\P{^_IS_LINEAR_B}', "");
    Expect(0, 65856, '\p{_IS_LINEAR_B}', "");
    Expect(1, 65856, '\p{^_IS_LINEAR_B}', "");
    Expect(1, 65856, '\P{_IS_LINEAR_B}', "");
    Expect(0, 65856, '\P{^_IS_LINEAR_B}', "");
    Error('\p{-LINB/a/}');
    Error('\P{-LINB/a/}');
    Expect(1, 65855, '\p{linb}', "");
    Expect(0, 65855, '\p{^linb}', "");
    Expect(0, 65855, '\P{linb}', "");
    Expect(1, 65855, '\P{^linb}', "");
    Expect(0, 65856, '\p{linb}', "");
    Expect(1, 65856, '\p{^linb}', "");
    Expect(1, 65856, '\P{linb}', "");
    Expect(0, 65856, '\P{^linb}', "");
    Expect(1, 65855, '\p{__linb}', "");
    Expect(0, 65855, '\p{^__linb}', "");
    Expect(0, 65855, '\P{__linb}', "");
    Expect(1, 65855, '\P{^__linb}', "");
    Expect(0, 65856, '\p{__linb}', "");
    Expect(1, 65856, '\p{^__linb}', "");
    Expect(1, 65856, '\P{__linb}', "");
    Expect(0, 65856, '\P{^__linb}', "");
    Error('\p{ :=IS_Linb}');
    Error('\P{ :=IS_Linb}');
    Expect(1, 65855, '\p{islinb}', "");
    Expect(0, 65855, '\p{^islinb}', "");
    Expect(0, 65855, '\P{islinb}', "");
    Expect(1, 65855, '\P{^islinb}', "");
    Expect(0, 65856, '\p{islinb}', "");
    Expect(1, 65856, '\p{^islinb}', "");
    Expect(1, 65856, '\P{islinb}', "");
    Expect(0, 65856, '\P{^islinb}', "");
    Expect(1, 65855, '\p{	IS_Linb}', "");
    Expect(0, 65855, '\p{^	IS_Linb}', "");
    Expect(0, 65855, '\P{	IS_Linb}', "");
    Expect(1, 65855, '\P{^	IS_Linb}', "");
    Expect(0, 65856, '\p{	IS_Linb}', "");
    Expect(1, 65856, '\p{^	IS_Linb}', "");
    Expect(1, 65856, '\P{	IS_Linb}', "");
    Expect(0, 65856, '\P{^	IS_Linb}', "");
    Error('\p{	 linear_B_ideograms:=}');
    Error('\P{	 linear_B_ideograms:=}');
    Expect(1, 65791, '\p{linearbideograms}', "");
    Expect(0, 65791, '\p{^linearbideograms}', "");
    Expect(0, 65791, '\P{linearbideograms}', "");
    Expect(1, 65791, '\P{^linearbideograms}', "");
    Expect(0, 65792, '\p{linearbideograms}', "");
    Expect(1, 65792, '\p{^linearbideograms}', "");
    Expect(1, 65792, '\P{linearbideograms}', "");
    Expect(0, 65792, '\P{^linearbideograms}', "");
    Expect(1, 65791, '\p{-_linear_B_IDEOGRAMS}', "");
    Expect(0, 65791, '\p{^-_linear_B_IDEOGRAMS}', "");
    Expect(0, 65791, '\P{-_linear_B_IDEOGRAMS}', "");
    Expect(1, 65791, '\P{^-_linear_B_IDEOGRAMS}', "");
    Expect(0, 65792, '\p{-_linear_B_IDEOGRAMS}', "");
    Expect(1, 65792, '\p{^-_linear_B_IDEOGRAMS}', "");
    Expect(1, 65792, '\P{-_linear_B_IDEOGRAMS}', "");
    Expect(0, 65792, '\P{^-_linear_B_IDEOGRAMS}', "");
    Error('\p{--is_LINEAR_B_ideograms:=}');
    Error('\P{--is_LINEAR_B_ideograms:=}');
    Expect(1, 65791, '\p{islinearbideograms}', "");
    Expect(0, 65791, '\p{^islinearbideograms}', "");
    Expect(0, 65791, '\P{islinearbideograms}', "");
    Expect(1, 65791, '\P{^islinearbideograms}', "");
    Expect(0, 65792, '\p{islinearbideograms}', "");
    Expect(1, 65792, '\p{^islinearbideograms}', "");
    Expect(1, 65792, '\P{islinearbideograms}', "");
    Expect(0, 65792, '\P{^islinearbideograms}', "");
    Expect(1, 65791, '\p{ IS_LINEAR_b_ideograms}', "");
    Expect(0, 65791, '\p{^ IS_LINEAR_b_ideograms}', "");
    Expect(0, 65791, '\P{ IS_LINEAR_b_ideograms}', "");
    Expect(1, 65791, '\P{^ IS_LINEAR_b_ideograms}', "");
    Expect(0, 65792, '\p{ IS_LINEAR_b_ideograms}', "");
    Expect(1, 65792, '\p{^ IS_LINEAR_b_ideograms}', "");
    Expect(1, 65792, '\P{ IS_LINEAR_b_ideograms}', "");
    Expect(0, 65792, '\P{^ IS_LINEAR_b_ideograms}', "");
    Error('\p{_-In_LINEAR_b_ideograms/a/}');
    Error('\P{_-In_LINEAR_b_ideograms/a/}');
    Expect(1, 65791, '\p{inlinearbideograms}', "");
    Expect(0, 65791, '\p{^inlinearbideograms}', "");
    Expect(0, 65791, '\P{inlinearbideograms}', "");
    Expect(1, 65791, '\P{^inlinearbideograms}', "");
    Expect(0, 65792, '\p{inlinearbideograms}', "");
    Expect(1, 65792, '\p{^inlinearbideograms}', "");
    Expect(1, 65792, '\P{inlinearbideograms}', "");
    Expect(0, 65792, '\P{^inlinearbideograms}', "");
    Expect(1, 65791, '\p{	In_LINEAR_b_Ideograms}', "");
    Expect(0, 65791, '\p{^	In_LINEAR_b_Ideograms}', "");
    Expect(0, 65791, '\P{	In_LINEAR_b_Ideograms}', "");
    Expect(1, 65791, '\P{^	In_LINEAR_b_Ideograms}', "");
    Expect(0, 65792, '\p{	In_LINEAR_b_Ideograms}', "");
    Expect(1, 65792, '\p{^	In_LINEAR_b_Ideograms}', "");
    Expect(1, 65792, '\P{	In_LINEAR_b_Ideograms}', "");
    Expect(0, 65792, '\P{^	In_LINEAR_b_Ideograms}', "");
    Error('\p{:=-Linear_B_Syllabary}');
    Error('\P{:=-Linear_B_Syllabary}');
    Expect(1, 65663, '\p{linearbsyllabary}', "");
    Expect(0, 65663, '\p{^linearbsyllabary}', "");
    Expect(0, 65663, '\P{linearbsyllabary}', "");
    Expect(1, 65663, '\P{^linearbsyllabary}', "");
    Expect(0, 65664, '\p{linearbsyllabary}', "");
    Expect(1, 65664, '\p{^linearbsyllabary}', "");
    Expect(1, 65664, '\P{linearbsyllabary}', "");
    Expect(0, 65664, '\P{^linearbsyllabary}', "");
    Expect(1, 65663, '\p{__Linear_b_syllabary}', "");
    Expect(0, 65663, '\p{^__Linear_b_syllabary}', "");
    Expect(0, 65663, '\P{__Linear_b_syllabary}', "");
    Expect(1, 65663, '\P{^__Linear_b_syllabary}', "");
    Expect(0, 65664, '\p{__Linear_b_syllabary}', "");
    Expect(1, 65664, '\p{^__Linear_b_syllabary}', "");
    Expect(1, 65664, '\P{__Linear_b_syllabary}', "");
    Expect(0, 65664, '\P{^__Linear_b_syllabary}', "");
    Error('\p{/a/		Is_Linear_B_Syllabary}');
    Error('\P{/a/		Is_Linear_B_Syllabary}');
    Expect(1, 65663, '\p{islinearbsyllabary}', "");
    Expect(0, 65663, '\p{^islinearbsyllabary}', "");
    Expect(0, 65663, '\P{islinearbsyllabary}', "");
    Expect(1, 65663, '\P{^islinearbsyllabary}', "");
    Expect(0, 65664, '\p{islinearbsyllabary}', "");
    Expect(1, 65664, '\p{^islinearbsyllabary}', "");
    Expect(1, 65664, '\P{islinearbsyllabary}', "");
    Expect(0, 65664, '\P{^islinearbsyllabary}', "");
    Expect(1, 65663, '\p{is_Linear_B_syllabary}', "");
    Expect(0, 65663, '\p{^is_Linear_B_syllabary}', "");
    Expect(0, 65663, '\P{is_Linear_B_syllabary}', "");
    Expect(1, 65663, '\P{^is_Linear_B_syllabary}', "");
    Expect(0, 65664, '\p{is_Linear_B_syllabary}', "");
    Expect(1, 65664, '\p{^is_Linear_B_syllabary}', "");
    Expect(1, 65664, '\P{is_Linear_B_syllabary}', "");
    Expect(0, 65664, '\P{^is_Linear_B_syllabary}', "");
    Error('\p{	/a/IN_linear_B_SYLLABARY}');
    Error('\P{	/a/IN_linear_B_SYLLABARY}');
    Expect(1, 65663, '\p{inlinearbsyllabary}', "");
    Expect(0, 65663, '\p{^inlinearbsyllabary}', "");
    Expect(0, 65663, '\P{inlinearbsyllabary}', "");
    Expect(1, 65663, '\P{^inlinearbsyllabary}', "");
    Expect(0, 65664, '\p{inlinearbsyllabary}', "");
    Expect(1, 65664, '\p{^inlinearbsyllabary}', "");
    Expect(1, 65664, '\P{inlinearbsyllabary}', "");
    Expect(0, 65664, '\P{^inlinearbsyllabary}', "");
    Expect(1, 65663, '\p{-	IN_Linear_b_Syllabary}', "");
    Expect(0, 65663, '\p{^-	IN_Linear_b_Syllabary}', "");
    Expect(0, 65663, '\P{-	IN_Linear_b_Syllabary}', "");
    Expect(1, 65663, '\P{^-	IN_Linear_b_Syllabary}', "");
    Expect(0, 65664, '\p{-	IN_Linear_b_Syllabary}', "");
    Expect(1, 65664, '\p{^-	IN_Linear_b_Syllabary}', "");
    Expect(1, 65664, '\P{-	IN_Linear_b_Syllabary}', "");
    Expect(0, 65664, '\P{^-	IN_Linear_b_Syllabary}', "");
    Error('\p{/a/-lisu}');
    Error('\P{/a/-lisu}');
    Expect(1, 73648, '\p{lisu}', "");
    Expect(0, 73648, '\p{^lisu}', "");
    Expect(0, 73648, '\P{lisu}', "");
    Expect(1, 73648, '\P{^lisu}', "");
    Expect(0, 73649, '\p{lisu}', "");
    Expect(1, 73649, '\p{^lisu}', "");
    Expect(1, 73649, '\P{lisu}', "");
    Expect(0, 73649, '\P{^lisu}', "");
    Expect(1, 73648, '\p{	-LISU}', "");
    Expect(0, 73648, '\p{^	-LISU}', "");
    Expect(0, 73648, '\P{	-LISU}', "");
    Expect(1, 73648, '\P{^	-LISU}', "");
    Expect(0, 73649, '\p{	-LISU}', "");
    Expect(1, 73649, '\p{^	-LISU}', "");
    Expect(1, 73649, '\P{	-LISU}', "");
    Expect(0, 73649, '\P{^	-LISU}', "");
    Error('\p{:=is_Lisu}');
    Error('\P{:=is_Lisu}');
    Expect(1, 73648, '\p{islisu}', "");
    Expect(0, 73648, '\p{^islisu}', "");
    Expect(0, 73648, '\P{islisu}', "");
    Expect(1, 73648, '\P{^islisu}', "");
    Expect(0, 73649, '\p{islisu}', "");
    Expect(1, 73649, '\p{^islisu}', "");
    Expect(1, 73649, '\P{islisu}', "");
    Expect(0, 73649, '\P{^islisu}', "");
    Expect(1, 73648, '\p{__Is_Lisu}', "");
    Expect(0, 73648, '\p{^__Is_Lisu}', "");
    Expect(0, 73648, '\P{__Is_Lisu}', "");
    Expect(1, 73648, '\P{^__Is_Lisu}', "");
    Expect(0, 73649, '\p{__Is_Lisu}', "");
    Expect(1, 73649, '\p{^__Is_Lisu}', "");
    Expect(1, 73649, '\P{__Is_Lisu}', "");
    Expect(0, 73649, '\P{^__Is_Lisu}', "");
    Error('\p{:=	_Lisu_SUPPLEMENT}');
    Error('\P{:=	_Lisu_SUPPLEMENT}');
    Expect(1, 73663, '\p{lisusupplement}', "");
    Expect(0, 73663, '\p{^lisusupplement}', "");
    Expect(0, 73663, '\P{lisusupplement}', "");
    Expect(1, 73663, '\P{^lisusupplement}', "");
    Expect(0, 73664, '\p{lisusupplement}', "");
    Expect(1, 73664, '\p{^lisusupplement}', "");
    Expect(1, 73664, '\P{lisusupplement}', "");
    Expect(0, 73664, '\P{^lisusupplement}', "");
    Expect(1, 73663, '\p{ 	LISU_SUPPLEMENT}', "");
    Expect(0, 73663, '\p{^ 	LISU_SUPPLEMENT}', "");
    Expect(0, 73663, '\P{ 	LISU_SUPPLEMENT}', "");
    Expect(1, 73663, '\P{^ 	LISU_SUPPLEMENT}', "");
    Expect(0, 73664, '\p{ 	LISU_SUPPLEMENT}', "");
    Expect(1, 73664, '\p{^ 	LISU_SUPPLEMENT}', "");
    Expect(1, 73664, '\P{ 	LISU_SUPPLEMENT}', "");
    Expect(0, 73664, '\P{^ 	LISU_SUPPLEMENT}', "");
    Error('\p{/a/_Is_Lisu_Supplement}');
    Error('\P{/a/_Is_Lisu_Supplement}');
    Expect(1, 73663, '\p{islisusupplement}', "");
    Expect(0, 73663, '\p{^islisusupplement}', "");
    Expect(0, 73663, '\P{islisusupplement}', "");
    Expect(1, 73663, '\P{^islisusupplement}', "");
    Expect(0, 73664, '\p{islisusupplement}', "");
    Expect(1, 73664, '\p{^islisusupplement}', "");
    Expect(1, 73664, '\P{islisusupplement}', "");
    Expect(0, 73664, '\P{^islisusupplement}', "");
    Expect(1, 73663, '\p{-	Is_lisu_Supplement}', "");
    Expect(0, 73663, '\p{^-	Is_lisu_Supplement}', "");
    Expect(0, 73663, '\P{-	Is_lisu_Supplement}', "");
    Expect(1, 73663, '\P{^-	Is_lisu_Supplement}', "");
    Expect(0, 73664, '\p{-	Is_lisu_Supplement}', "");
    Expect(1, 73664, '\p{^-	Is_lisu_Supplement}', "");
    Expect(1, 73664, '\P{-	Is_lisu_Supplement}', "");
    Expect(0, 73664, '\P{^-	Is_lisu_Supplement}', "");
    Error('\p{_In_Lisu_SUPPLEMENT:=}');
    Error('\P{_In_Lisu_SUPPLEMENT:=}');
    Expect(1, 73663, '\p{inlisusupplement}', "");
    Expect(0, 73663, '\p{^inlisusupplement}', "");
    Expect(0, 73663, '\P{inlisusupplement}', "");
    Expect(1, 73663, '\P{^inlisusupplement}', "");
    Expect(0, 73664, '\p{inlisusupplement}', "");
    Expect(1, 73664, '\p{^inlisusupplement}', "");
    Expect(1, 73664, '\P{inlisusupplement}', "");
    Expect(0, 73664, '\P{^inlisusupplement}', "");
    Expect(1, 73663, '\p{_In_LISU_Supplement}', "");
    Expect(0, 73663, '\p{^_In_LISU_Supplement}', "");
    Expect(0, 73663, '\P{_In_LISU_Supplement}', "");
    Expect(1, 73663, '\P{^_In_LISU_Supplement}', "");
    Expect(0, 73664, '\p{_In_LISU_Supplement}', "");
    Expect(1, 73664, '\p{^_In_LISU_Supplement}', "");
    Expect(1, 73664, '\P{_In_LISU_Supplement}', "");
    Expect(0, 73664, '\P{^_In_LISU_Supplement}', "");
    Error('\p{:=  LISU_Sup}');
    Error('\P{:=  LISU_Sup}');
    Expect(1, 73663, '\p{lisusup}', "");
    Expect(0, 73663, '\p{^lisusup}', "");
    Expect(0, 73663, '\P{lisusup}', "");
    Expect(1, 73663, '\P{^lisusup}', "");
    Expect(0, 73664, '\p{lisusup}', "");
    Expect(1, 73664, '\p{^lisusup}', "");
    Expect(1, 73664, '\P{lisusup}', "");
    Expect(0, 73664, '\P{^lisusup}', "");
    Expect(1, 73663, '\p{_ lisu_SUP}', "");
    Expect(0, 73663, '\p{^_ lisu_SUP}', "");
    Expect(0, 73663, '\P{_ lisu_SUP}', "");
    Expect(1, 73663, '\P{^_ lisu_SUP}', "");
    Expect(0, 73664, '\p{_ lisu_SUP}', "");
    Expect(1, 73664, '\p{^_ lisu_SUP}', "");
    Expect(1, 73664, '\P{_ lisu_SUP}', "");
    Expect(0, 73664, '\P{^_ lisu_SUP}', "");
    Error('\p{ Is_LISU_SUP:=}');
    Error('\P{ Is_LISU_SUP:=}');
    Expect(1, 73663, '\p{islisusup}', "");
    Expect(0, 73663, '\p{^islisusup}', "");
    Expect(0, 73663, '\P{islisusup}', "");
    Expect(1, 73663, '\P{^islisusup}', "");
    Expect(0, 73664, '\p{islisusup}', "");
    Expect(1, 73664, '\p{^islisusup}', "");
    Expect(1, 73664, '\P{islisusup}', "");
    Expect(0, 73664, '\P{^islisusup}', "");
    Expect(1, 73663, '\p{__Is_lisu_Sup}', "");
    Expect(0, 73663, '\p{^__Is_lisu_Sup}', "");
    Expect(0, 73663, '\P{__Is_lisu_Sup}', "");
    Expect(1, 73663, '\P{^__Is_lisu_Sup}', "");
    Expect(0, 73664, '\p{__Is_lisu_Sup}', "");
    Expect(1, 73664, '\p{^__Is_lisu_Sup}', "");
    Expect(1, 73664, '\P{__Is_lisu_Sup}', "");
    Expect(0, 73664, '\P{^__Is_lisu_Sup}', "");
    Error('\p{-:=In_LISU_Sup}');
    Error('\P{-:=In_LISU_Sup}');
    Expect(1, 73663, '\p{inlisusup}', "");
    Expect(0, 73663, '\p{^inlisusup}', "");
    Expect(0, 73663, '\P{inlisusup}', "");
    Expect(1, 73663, '\P{^inlisusup}', "");
    Expect(0, 73664, '\p{inlisusup}', "");
    Expect(1, 73664, '\p{^inlisusup}', "");
    Expect(1, 73664, '\P{inlisusup}', "");
    Expect(0, 73664, '\P{^inlisusup}', "");
    Expect(1, 73663, '\p{ IN_Lisu_Sup}', "");
    Expect(0, 73663, '\p{^ IN_Lisu_Sup}', "");
    Expect(0, 73663, '\P{ IN_Lisu_Sup}', "");
    Expect(1, 73663, '\P{^ IN_Lisu_Sup}', "");
    Expect(0, 73664, '\p{ IN_Lisu_Sup}', "");
    Expect(1, 73664, '\p{^ IN_Lisu_Sup}', "");
    Expect(1, 73664, '\P{ IN_Lisu_Sup}', "");
    Expect(0, 73664, '\P{^ IN_Lisu_Sup}', "");
    Error('\p{	-Logical_Order_exception:=}');
    Error('\P{	-Logical_Order_exception:=}');
    Expect(1, 43708, '\p{logicalorderexception}', "");
    Expect(0, 43708, '\p{^logicalorderexception}', "");
    Expect(0, 43708, '\P{logicalorderexception}', "");
    Expect(1, 43708, '\P{^logicalorderexception}', "");
    Expect(0, 43709, '\p{logicalorderexception}', "");
    Expect(1, 43709, '\p{^logicalorderexception}', "");
    Expect(1, 43709, '\P{logicalorderexception}', "");
    Expect(0, 43709, '\P{^logicalorderexception}', "");
    Expect(1, 43708, '\p{Logical_Order_EXCEPTION}', "");
    Expect(0, 43708, '\p{^Logical_Order_EXCEPTION}', "");
    Expect(0, 43708, '\P{Logical_Order_EXCEPTION}', "");
    Expect(1, 43708, '\P{^Logical_Order_EXCEPTION}', "");
    Expect(0, 43709, '\p{Logical_Order_EXCEPTION}', "");
    Expect(1, 43709, '\p{^Logical_Order_EXCEPTION}', "");
    Expect(1, 43709, '\P{Logical_Order_EXCEPTION}', "");
    Expect(0, 43709, '\P{^Logical_Order_EXCEPTION}', "");
    Error('\p{		Is_LOGICAL_order_Exception/a/}');
    Error('\P{		Is_LOGICAL_order_Exception/a/}');
    Expect(1, 43708, '\p{islogicalorderexception}', "");
    Expect(0, 43708, '\p{^islogicalorderexception}', "");
    Expect(0, 43708, '\P{islogicalorderexception}', "");
    Expect(1, 43708, '\P{^islogicalorderexception}', "");
    Expect(0, 43709, '\p{islogicalorderexception}', "");
    Expect(1, 43709, '\p{^islogicalorderexception}', "");
    Expect(1, 43709, '\P{islogicalorderexception}', "");
    Expect(0, 43709, '\P{^islogicalorderexception}', "");
    Expect(1, 43708, '\p{-IS_Logical_order_exception}', "");
    Expect(0, 43708, '\p{^-IS_Logical_order_exception}', "");
    Expect(0, 43708, '\P{-IS_Logical_order_exception}', "");
    Expect(1, 43708, '\P{^-IS_Logical_order_exception}', "");
    Expect(0, 43709, '\p{-IS_Logical_order_exception}', "");
    Expect(1, 43709, '\p{^-IS_Logical_order_exception}', "");
    Expect(1, 43709, '\P{-IS_Logical_order_exception}', "");
    Expect(0, 43709, '\P{^-IS_Logical_order_exception}', "");
    Error('\p{_:=loe}');
    Error('\P{_:=loe}');
    Expect(1, 43708, '\p{loe}', "");
    Expect(0, 43708, '\p{^loe}', "");
    Expect(0, 43708, '\P{loe}', "");
    Expect(1, 43708, '\P{^loe}', "");
    Expect(0, 43709, '\p{loe}', "");
    Expect(1, 43709, '\p{^loe}', "");
    Expect(1, 43709, '\P{loe}', "");
    Expect(0, 43709, '\P{^loe}', "");
    Expect(1, 43708, '\p{	-LOE}', "");
    Expect(0, 43708, '\p{^	-LOE}', "");
    Expect(0, 43708, '\P{	-LOE}', "");
    Expect(1, 43708, '\P{^	-LOE}', "");
    Expect(0, 43709, '\p{	-LOE}', "");
    Expect(1, 43709, '\p{^	-LOE}', "");
    Expect(1, 43709, '\P{	-LOE}', "");
    Expect(0, 43709, '\P{^	-LOE}', "");
    Error('\p{ -Is_LOE:=}');
    Error('\P{ -Is_LOE:=}');
    Expect(1, 43708, '\p{isloe}', "");
    Expect(0, 43708, '\p{^isloe}', "");
    Expect(0, 43708, '\P{isloe}', "");
    Expect(1, 43708, '\P{^isloe}', "");
    Expect(0, 43709, '\p{isloe}', "");
    Expect(1, 43709, '\p{^isloe}', "");
    Expect(1, 43709, '\P{isloe}', "");
    Expect(0, 43709, '\P{^isloe}', "");
    Expect(1, 43708, '\p{	is_LOE}', "");
    Expect(0, 43708, '\p{^	is_LOE}', "");
    Expect(0, 43708, '\P{	is_LOE}', "");
    Expect(1, 43708, '\P{^	is_LOE}', "");
    Expect(0, 43709, '\p{	is_LOE}', "");
    Expect(1, 43709, '\p{^	is_LOE}', "");
    Expect(1, 43709, '\P{	is_LOE}', "");
    Expect(0, 43709, '\P{^	is_LOE}', "");
    Error('\p{- Low_Surrogates:=}');
    Error('\P{- Low_Surrogates:=}');
    Expect(1, 57343, '\p{lowsurrogates}', "");
    Expect(0, 57343, '\p{^lowsurrogates}', "");
    Expect(0, 57343, '\P{lowsurrogates}', "");
    Expect(1, 57343, '\P{^lowsurrogates}', "");
    Expect(0, 57344, '\p{lowsurrogates}', "");
    Expect(1, 57344, '\p{^lowsurrogates}', "");
    Expect(1, 57344, '\P{lowsurrogates}', "");
    Expect(0, 57344, '\P{^lowsurrogates}', "");
    Expect(1, 57343, '\p{		Low_surrogates}', "");
    Expect(0, 57343, '\p{^		Low_surrogates}', "");
    Expect(0, 57343, '\P{		Low_surrogates}', "");
    Expect(1, 57343, '\P{^		Low_surrogates}', "");
    Expect(0, 57344, '\p{		Low_surrogates}', "");
    Expect(1, 57344, '\p{^		Low_surrogates}', "");
    Expect(1, 57344, '\P{		Low_surrogates}', "");
    Expect(0, 57344, '\P{^		Low_surrogates}', "");
    Error('\p{_:=Is_Low_Surrogates}');
    Error('\P{_:=Is_Low_Surrogates}');
    Expect(1, 57343, '\p{islowsurrogates}', "");
    Expect(0, 57343, '\p{^islowsurrogates}', "");
    Expect(0, 57343, '\P{islowsurrogates}', "");
    Expect(1, 57343, '\P{^islowsurrogates}', "");
    Expect(0, 57344, '\p{islowsurrogates}', "");
    Expect(1, 57344, '\p{^islowsurrogates}', "");
    Expect(1, 57344, '\P{islowsurrogates}', "");
    Expect(0, 57344, '\P{^islowsurrogates}', "");
    Expect(1, 57343, '\p{		is_low_Surrogates}', "");
    Expect(0, 57343, '\p{^		is_low_Surrogates}', "");
    Expect(0, 57343, '\P{		is_low_Surrogates}', "");
    Expect(1, 57343, '\P{^		is_low_Surrogates}', "");
    Expect(0, 57344, '\p{		is_low_Surrogates}', "");
    Expect(1, 57344, '\p{^		is_low_Surrogates}', "");
    Expect(1, 57344, '\P{		is_low_Surrogates}', "");
    Expect(0, 57344, '\P{^		is_low_Surrogates}', "");
    Error('\p{/a/  In_Low_surrogates}');
    Error('\P{/a/  In_Low_surrogates}');
    Expect(1, 57343, '\p{inlowsurrogates}', "");
    Expect(0, 57343, '\p{^inlowsurrogates}', "");
    Expect(0, 57343, '\P{inlowsurrogates}', "");
    Expect(1, 57343, '\P{^inlowsurrogates}', "");
    Expect(0, 57344, '\p{inlowsurrogates}', "");
    Expect(1, 57344, '\p{^inlowsurrogates}', "");
    Expect(1, 57344, '\P{inlowsurrogates}', "");
    Expect(0, 57344, '\P{^inlowsurrogates}', "");
    Expect(1, 57343, '\p{		In_Low_Surrogates}', "");
    Expect(0, 57343, '\p{^		In_Low_Surrogates}', "");
    Expect(0, 57343, '\P{		In_Low_Surrogates}', "");
    Expect(1, 57343, '\P{^		In_Low_Surrogates}', "");
    Expect(0, 57344, '\p{		In_Low_Surrogates}', "");
    Expect(1, 57344, '\p{^		In_Low_Surrogates}', "");
    Expect(1, 57344, '\P{		In_Low_Surrogates}', "");
    Expect(0, 57344, '\P{^		In_Low_Surrogates}', "");
    Error('\p{-:=Lowercase_Letter}');
    Error('\P{-:=Lowercase_Letter}');
    Expect(1, 125251, '\p{lowercaseletter}', "");
    Expect(0, 125251, '\p{^lowercaseletter}', "");
    Expect(0, 125251, '\P{lowercaseletter}', "");
    Expect(1, 125251, '\P{^lowercaseletter}', "");
    Expect(0, 125252, '\p{lowercaseletter}', "");
    Expect(1, 125252, '\p{^lowercaseletter}', "");
    Expect(1, 125252, '\P{lowercaseletter}', "");
    Expect(0, 125252, '\P{^lowercaseletter}', "");
    Expect(1, 125251, '\p{ -Lowercase_Letter}', "");
    Expect(0, 125251, '\p{^ -Lowercase_Letter}', "");
    Expect(0, 125251, '\P{ -Lowercase_Letter}', "");
    Expect(1, 125251, '\P{^ -Lowercase_Letter}', "");
    Expect(0, 125252, '\p{ -Lowercase_Letter}', "");
    Expect(1, 125252, '\p{^ -Lowercase_Letter}', "");
    Expect(1, 125252, '\P{ -Lowercase_Letter}', "");
    Expect(0, 125252, '\P{^ -Lowercase_Letter}', "");
    Error('\p{/a/		Is_Lowercase_Letter}');
    Error('\P{/a/		Is_Lowercase_Letter}');
    Expect(1, 125251, '\p{islowercaseletter}', "");
    Expect(0, 125251, '\p{^islowercaseletter}', "");
    Expect(0, 125251, '\P{islowercaseletter}', "");
    Expect(1, 125251, '\P{^islowercaseletter}', "");
    Expect(0, 125252, '\p{islowercaseletter}', "");
    Expect(1, 125252, '\p{^islowercaseletter}', "");
    Expect(1, 125252, '\P{islowercaseletter}', "");
    Expect(0, 125252, '\P{^islowercaseletter}', "");
    Expect(1, 125251, '\p{ 	Is_LOWERCASE_LETTER}', "");
    Expect(0, 125251, '\p{^ 	Is_LOWERCASE_LETTER}', "");
    Expect(0, 125251, '\P{ 	Is_LOWERCASE_LETTER}', "");
    Expect(1, 125251, '\P{^ 	Is_LOWERCASE_LETTER}', "");
    Expect(0, 125252, '\p{ 	Is_LOWERCASE_LETTER}', "");
    Expect(1, 125252, '\p{^ 	Is_LOWERCASE_LETTER}', "");
    Expect(1, 125252, '\P{ 	Is_LOWERCASE_LETTER}', "");
    Expect(0, 125252, '\P{^ 	Is_LOWERCASE_LETTER}', "");
    Error('\p{	_Ll/a/}');
    Error('\P{	_Ll/a/}');
    Expect(1, 125251, '\p{ll}', "");
    Expect(0, 125251, '\p{^ll}', "");
    Expect(0, 125251, '\P{ll}', "");
    Expect(1, 125251, '\P{^ll}', "");
    Expect(0, 125252, '\p{ll}', "");
    Expect(1, 125252, '\p{^ll}', "");
    Expect(1, 125252, '\P{ll}', "");
    Expect(0, 125252, '\P{^ll}', "");
    Expect(1, 125251, '\p{_Ll}', "");
    Expect(0, 125251, '\p{^_Ll}', "");
    Expect(0, 125251, '\P{_Ll}', "");
    Expect(1, 125251, '\P{^_Ll}', "");
    Expect(0, 125252, '\p{_Ll}', "");
    Expect(1, 125252, '\p{^_Ll}', "");
    Expect(1, 125252, '\P{_Ll}', "");
    Expect(0, 125252, '\P{^_Ll}', "");
    Error('\p{_-is_ll:=}');
    Error('\P{_-is_ll:=}');
    Expect(1, 125251, '\p{isll}', "");
    Expect(0, 125251, '\p{^isll}', "");
    Expect(0, 125251, '\P{isll}', "");
    Expect(1, 125251, '\P{^isll}', "");
    Expect(0, 125252, '\p{isll}', "");
    Expect(1, 125252, '\p{^isll}', "");
    Expect(1, 125252, '\P{isll}', "");
    Expect(0, 125252, '\P{^isll}', "");
    Expect(1, 125251, '\p{_ IS_Ll}', "");
    Expect(0, 125251, '\p{^_ IS_Ll}', "");
    Expect(0, 125251, '\P{_ IS_Ll}', "");
    Expect(1, 125251, '\P{^_ IS_Ll}', "");
    Expect(0, 125252, '\p{_ IS_Ll}', "");
    Expect(1, 125252, '\p{^_ IS_Ll}', "");
    Expect(1, 125252, '\P{_ IS_Ll}', "");
    Expect(0, 125252, '\P{^_ IS_Ll}', "");
    Error('\p{ -LYCIAN:=}');
    Error('\P{ -LYCIAN:=}');
    Expect(1, 66204, '\p{lycian}', "");
    Expect(0, 66204, '\p{^lycian}', "");
    Expect(0, 66204, '\P{lycian}', "");
    Expect(1, 66204, '\P{^lycian}', "");
    Expect(0, 66205, '\p{lycian}', "");
    Expect(1, 66205, '\p{^lycian}', "");
    Expect(1, 66205, '\P{lycian}', "");
    Expect(0, 66205, '\P{^lycian}', "");
    Expect(1, 66204, '\p{ _Lycian}', "");
    Expect(0, 66204, '\p{^ _Lycian}', "");
    Expect(0, 66204, '\P{ _Lycian}', "");
    Expect(1, 66204, '\P{^ _Lycian}', "");
    Expect(0, 66205, '\p{ _Lycian}', "");
    Expect(1, 66205, '\p{^ _Lycian}', "");
    Expect(1, 66205, '\P{ _Lycian}', "");
    Expect(0, 66205, '\P{^ _Lycian}', "");
    Error('\p{	_Is_LYCIAN/a/}');
    Error('\P{	_Is_LYCIAN/a/}');
    Expect(1, 66204, '\p{islycian}', "");
    Expect(0, 66204, '\p{^islycian}', "");
    Expect(0, 66204, '\P{islycian}', "");
    Expect(1, 66204, '\P{^islycian}', "");
    Expect(0, 66205, '\p{islycian}', "");
    Expect(1, 66205, '\p{^islycian}', "");
    Expect(1, 66205, '\P{islycian}', "");
    Expect(0, 66205, '\P{^islycian}', "");
    Expect(1, 66204, '\p{ -Is_Lycian}', "");
    Expect(0, 66204, '\p{^ -Is_Lycian}', "");
    Expect(0, 66204, '\P{ -Is_Lycian}', "");
    Expect(1, 66204, '\P{^ -Is_Lycian}', "");
    Expect(0, 66205, '\p{ -Is_Lycian}', "");
    Expect(1, 66205, '\p{^ -Is_Lycian}', "");
    Expect(1, 66205, '\P{ -Is_Lycian}', "");
    Expect(0, 66205, '\P{^ -Is_Lycian}', "");
    Error('\p{:=_-Lyci}');
    Error('\P{:=_-Lyci}');
    Expect(1, 66204, '\p{lyci}', "");
    Expect(0, 66204, '\p{^lyci}', "");
    Expect(0, 66204, '\P{lyci}', "");
    Expect(1, 66204, '\P{^lyci}', "");
    Expect(0, 66205, '\p{lyci}', "");
    Expect(1, 66205, '\p{^lyci}', "");
    Expect(1, 66205, '\P{lyci}', "");
    Expect(0, 66205, '\P{^lyci}', "");
    Expect(1, 66204, '\p{ -Lyci}', "");
    Expect(0, 66204, '\p{^ -Lyci}', "");
    Expect(0, 66204, '\P{ -Lyci}', "");
    Expect(1, 66204, '\P{^ -Lyci}', "");
    Expect(0, 66205, '\p{ -Lyci}', "");
    Expect(1, 66205, '\p{^ -Lyci}', "");
    Expect(1, 66205, '\P{ -Lyci}', "");
    Expect(0, 66205, '\P{^ -Lyci}', "");
    Error('\p{_	Is_Lyci:=}');
    Error('\P{_	Is_Lyci:=}');
    Expect(1, 66204, '\p{islyci}', "");
    Expect(0, 66204, '\p{^islyci}', "");
    Expect(0, 66204, '\P{islyci}', "");
    Expect(1, 66204, '\P{^islyci}', "");
    Expect(0, 66205, '\p{islyci}', "");
    Expect(1, 66205, '\p{^islyci}', "");
    Expect(1, 66205, '\P{islyci}', "");
    Expect(0, 66205, '\P{^islyci}', "");
    Expect(1, 66204, '\p{-	is_lyci}', "");
    Expect(0, 66204, '\p{^-	is_lyci}', "");
    Expect(0, 66204, '\P{-	is_lyci}', "");
    Expect(1, 66204, '\P{^-	is_lyci}', "");
    Expect(0, 66205, '\p{-	is_lyci}', "");
    Expect(1, 66205, '\p{^-	is_lyci}', "");
    Expect(1, 66205, '\P{-	is_lyci}', "");
    Expect(0, 66205, '\P{^-	is_lyci}', "");
    Error('\p{:=	_LYDIAN}');
    Error('\P{:=	_LYDIAN}');
    Expect(1, 67903, '\p{lydian}', "");
    Expect(0, 67903, '\p{^lydian}', "");
    Expect(0, 67903, '\P{lydian}', "");
    Expect(1, 67903, '\P{^lydian}', "");
    Expect(0, 67904, '\p{lydian}', "");
    Expect(1, 67904, '\p{^lydian}', "");
    Expect(1, 67904, '\P{lydian}', "");
    Expect(0, 67904, '\P{^lydian}', "");
    Expect(1, 67903, '\p{-lydian}', "");
    Expect(0, 67903, '\p{^-lydian}', "");
    Expect(0, 67903, '\P{-lydian}', "");
    Expect(1, 67903, '\P{^-lydian}', "");
    Expect(0, 67904, '\p{-lydian}', "");
    Expect(1, 67904, '\p{^-lydian}', "");
    Expect(1, 67904, '\P{-lydian}', "");
    Expect(0, 67904, '\P{^-lydian}', "");
    Error('\p{:=  Is_Lydian}');
    Error('\P{:=  Is_Lydian}');
    Expect(1, 67903, '\p{islydian}', "");
    Expect(0, 67903, '\p{^islydian}', "");
    Expect(0, 67903, '\P{islydian}', "");
    Expect(1, 67903, '\P{^islydian}', "");
    Expect(0, 67904, '\p{islydian}', "");
    Expect(1, 67904, '\p{^islydian}', "");
    Expect(1, 67904, '\P{islydian}', "");
    Expect(0, 67904, '\P{^islydian}', "");
    Expect(1, 67903, '\p{-Is_lydian}', "");
    Expect(0, 67903, '\p{^-Is_lydian}', "");
    Expect(0, 67903, '\P{-Is_lydian}', "");
    Expect(1, 67903, '\P{^-Is_lydian}', "");
    Expect(0, 67904, '\p{-Is_lydian}', "");
    Expect(1, 67904, '\p{^-Is_lydian}', "");
    Expect(1, 67904, '\P{-Is_lydian}', "");
    Expect(0, 67904, '\P{^-Is_lydian}', "");
    Error('\p{ /a/Lydi}');
    Error('\P{ /a/Lydi}');
    Expect(1, 67903, '\p{lydi}', "");
    Expect(0, 67903, '\p{^lydi}', "");
    Expect(0, 67903, '\P{lydi}', "");
    Expect(1, 67903, '\P{^lydi}', "");
    Expect(0, 67904, '\p{lydi}', "");
    Expect(1, 67904, '\p{^lydi}', "");
    Expect(1, 67904, '\P{lydi}', "");
    Expect(0, 67904, '\P{^lydi}', "");
    Expect(1, 67903, '\p{ -Lydi}', "");
    Expect(0, 67903, '\p{^ -Lydi}', "");
    Expect(0, 67903, '\P{ -Lydi}', "");
    Expect(1, 67903, '\P{^ -Lydi}', "");
    Expect(0, 67904, '\p{ -Lydi}', "");
    Expect(1, 67904, '\p{^ -Lydi}', "");
    Expect(1, 67904, '\P{ -Lydi}', "");
    Expect(0, 67904, '\P{^ -Lydi}', "");
    Error('\p{-_Is_lydi:=}');
    Error('\P{-_Is_lydi:=}');
    Expect(1, 67903, '\p{islydi}', "");
    Expect(0, 67903, '\p{^islydi}', "");
    Expect(0, 67903, '\P{islydi}', "");
    Expect(1, 67903, '\P{^islydi}', "");
    Expect(0, 67904, '\p{islydi}', "");
    Expect(1, 67904, '\p{^islydi}', "");
    Expect(1, 67904, '\P{islydi}', "");
    Expect(0, 67904, '\P{^islydi}', "");
    Expect(1, 67903, '\p{--is_Lydi}', "");
    Expect(0, 67903, '\p{^--is_Lydi}', "");
    Expect(0, 67903, '\P{--is_Lydi}', "");
    Expect(1, 67903, '\P{^--is_Lydi}', "");
    Expect(0, 67904, '\p{--is_Lydi}', "");
    Expect(1, 67904, '\p{^--is_Lydi}', "");
    Expect(1, 67904, '\P{--is_Lydi}', "");
    Expect(0, 67904, '\P{^--is_Lydi}', "");
    Error('\p{Mahajani:=}');
    Error('\P{Mahajani:=}');
    Expect(1, 70006, '\p{mahajani}', "");
    Expect(0, 70006, '\p{^mahajani}', "");
    Expect(0, 70006, '\P{mahajani}', "");
    Expect(1, 70006, '\P{^mahajani}', "");
    Expect(0, 70007, '\p{mahajani}', "");
    Expect(1, 70007, '\p{^mahajani}', "");
    Expect(1, 70007, '\P{mahajani}', "");
    Expect(0, 70007, '\P{^mahajani}', "");
    Expect(1, 70006, '\p{	_Mahajani}', "");
    Expect(0, 70006, '\p{^	_Mahajani}', "");
    Expect(0, 70006, '\P{	_Mahajani}', "");
    Expect(1, 70006, '\P{^	_Mahajani}', "");
    Expect(0, 70007, '\p{	_Mahajani}', "");
    Expect(1, 70007, '\p{^	_Mahajani}', "");
    Expect(1, 70007, '\P{	_Mahajani}', "");
    Expect(0, 70007, '\P{^	_Mahajani}', "");
    Error('\p{_-is_Mahajani:=}');
    Error('\P{_-is_Mahajani:=}');
    Expect(1, 70006, '\p{ismahajani}', "");
    Expect(0, 70006, '\p{^ismahajani}', "");
    Expect(0, 70006, '\P{ismahajani}', "");
    Expect(1, 70006, '\P{^ismahajani}', "");
    Expect(0, 70007, '\p{ismahajani}', "");
    Expect(1, 70007, '\p{^ismahajani}', "");
    Expect(1, 70007, '\P{ismahajani}', "");
    Expect(0, 70007, '\P{^ismahajani}', "");
    Expect(1, 70006, '\p{_is_Mahajani}', "");
    Expect(0, 70006, '\p{^_is_Mahajani}', "");
    Expect(0, 70006, '\P{_is_Mahajani}', "");
    Expect(1, 70006, '\P{^_is_Mahajani}', "");
    Expect(0, 70007, '\p{_is_Mahajani}', "");
    Expect(1, 70007, '\p{^_is_Mahajani}', "");
    Expect(1, 70007, '\P{_is_Mahajani}', "");
    Expect(0, 70007, '\P{^_is_Mahajani}', "");
    Error('\p{-_Mahj:=}');
    Error('\P{-_Mahj:=}');
    Expect(1, 70006, '\p{mahj}', "");
    Expect(0, 70006, '\p{^mahj}', "");
    Expect(0, 70006, '\P{mahj}', "");
    Expect(1, 70006, '\P{^mahj}', "");
    Expect(0, 70007, '\p{mahj}', "");
    Expect(1, 70007, '\p{^mahj}', "");
    Expect(1, 70007, '\P{mahj}', "");
    Expect(0, 70007, '\P{^mahj}', "");
    Expect(1, 70006, '\p{  MAHJ}', "");
    Expect(0, 70006, '\p{^  MAHJ}', "");
    Expect(0, 70006, '\P{  MAHJ}', "");
    Expect(1, 70006, '\P{^  MAHJ}', "");
    Expect(0, 70007, '\p{  MAHJ}', "");
    Expect(1, 70007, '\p{^  MAHJ}', "");
    Expect(1, 70007, '\P{  MAHJ}', "");
    Expect(0, 70007, '\P{^  MAHJ}', "");
    Error('\p{_/a/IS_Mahj}');
    Error('\P{_/a/IS_Mahj}');
    Expect(1, 70006, '\p{ismahj}', "");
    Expect(0, 70006, '\p{^ismahj}', "");
    Expect(0, 70006, '\P{ismahj}', "");
    Expect(1, 70006, '\P{^ismahj}', "");
    Expect(0, 70007, '\p{ismahj}', "");
    Expect(1, 70007, '\p{^ismahj}', "");
    Expect(1, 70007, '\P{ismahj}', "");
    Expect(0, 70007, '\P{^ismahj}', "");
    Expect(1, 70006, '\p{	_Is_MAHJ}', "");
    Expect(0, 70006, '\p{^	_Is_MAHJ}', "");
    Expect(0, 70006, '\P{	_Is_MAHJ}', "");
    Expect(1, 70006, '\P{^	_Is_MAHJ}', "");
    Expect(0, 70007, '\p{	_Is_MAHJ}', "");
    Expect(1, 70007, '\p{^	_Is_MAHJ}', "");
    Expect(1, 70007, '\P{	_Is_MAHJ}', "");
    Expect(0, 70007, '\P{^	_Is_MAHJ}', "");
    Error('\p{/a/-	Mahjong_Tiles}');
    Error('\P{/a/-	Mahjong_Tiles}');
    Expect(1, 127023, '\p{mahjongtiles}', "");
    Expect(0, 127023, '\p{^mahjongtiles}', "");
    Expect(0, 127023, '\P{mahjongtiles}', "");
    Expect(1, 127023, '\P{^mahjongtiles}', "");
    Expect(0, 127024, '\p{mahjongtiles}', "");
    Expect(1, 127024, '\p{^mahjongtiles}', "");
    Expect(1, 127024, '\P{mahjongtiles}', "");
    Expect(0, 127024, '\P{^mahjongtiles}', "");
    Expect(1, 127023, '\p{		Mahjong_TILES}', "");
    Expect(0, 127023, '\p{^		Mahjong_TILES}', "");
    Expect(0, 127023, '\P{		Mahjong_TILES}', "");
    Expect(1, 127023, '\P{^		Mahjong_TILES}', "");
    Expect(0, 127024, '\p{		Mahjong_TILES}', "");
    Expect(1, 127024, '\p{^		Mahjong_TILES}', "");
    Expect(1, 127024, '\P{		Mahjong_TILES}', "");
    Expect(0, 127024, '\P{^		Mahjong_TILES}', "");
    Error('\p{_ Is_Mahjong_Tiles/a/}');
    Error('\P{_ Is_Mahjong_Tiles/a/}');
    Expect(1, 127023, '\p{ismahjongtiles}', "");
    Expect(0, 127023, '\p{^ismahjongtiles}', "");
    Expect(0, 127023, '\P{ismahjongtiles}', "");
    Expect(1, 127023, '\P{^ismahjongtiles}', "");
    Expect(0, 127024, '\p{ismahjongtiles}', "");
    Expect(1, 127024, '\p{^ismahjongtiles}', "");
    Expect(1, 127024, '\P{ismahjongtiles}', "");
    Expect(0, 127024, '\P{^ismahjongtiles}', "");
    Expect(1, 127023, '\p{_	IS_MAHJONG_Tiles}', "");
    Expect(0, 127023, '\p{^_	IS_MAHJONG_Tiles}', "");
    Expect(0, 127023, '\P{_	IS_MAHJONG_Tiles}', "");
    Expect(1, 127023, '\P{^_	IS_MAHJONG_Tiles}', "");
    Expect(0, 127024, '\p{_	IS_MAHJONG_Tiles}', "");
    Expect(1, 127024, '\p{^_	IS_MAHJONG_Tiles}', "");
    Expect(1, 127024, '\P{_	IS_MAHJONG_Tiles}', "");
    Expect(0, 127024, '\P{^_	IS_MAHJONG_Tiles}', "");
    Error('\p{/a/-_in_Mahjong_tiles}');
    Error('\P{/a/-_in_Mahjong_tiles}');
    Expect(1, 127023, '\p{inmahjongtiles}', "");
    Expect(0, 127023, '\p{^inmahjongtiles}', "");
    Expect(0, 127023, '\P{inmahjongtiles}', "");
    Expect(1, 127023, '\P{^inmahjongtiles}', "");
    Expect(0, 127024, '\p{inmahjongtiles}', "");
    Expect(1, 127024, '\p{^inmahjongtiles}', "");
    Expect(1, 127024, '\P{inmahjongtiles}', "");
    Expect(0, 127024, '\P{^inmahjongtiles}', "");
    Expect(1, 127023, '\p{_In_Mahjong_tiles}', "");
    Expect(0, 127023, '\p{^_In_Mahjong_tiles}', "");
    Expect(0, 127023, '\P{_In_Mahjong_tiles}', "");
    Expect(1, 127023, '\P{^_In_Mahjong_tiles}', "");
    Expect(0, 127024, '\p{_In_Mahjong_tiles}', "");
    Expect(1, 127024, '\p{^_In_Mahjong_tiles}', "");
    Expect(1, 127024, '\P{_In_Mahjong_tiles}', "");
    Expect(0, 127024, '\P{^_In_Mahjong_tiles}', "");
    Error('\p{/a/	MAHJONG}');
    Error('\P{/a/	MAHJONG}');
    Expect(1, 127023, '\p{mahjong}', "");
    Expect(0, 127023, '\p{^mahjong}', "");
    Expect(0, 127023, '\P{mahjong}', "");
    Expect(1, 127023, '\P{^mahjong}', "");
    Expect(0, 127024, '\p{mahjong}', "");
    Expect(1, 127024, '\p{^mahjong}', "");
    Expect(1, 127024, '\P{mahjong}', "");
    Expect(0, 127024, '\P{^mahjong}', "");
    Expect(1, 127023, '\p{--Mahjong}', "");
    Expect(0, 127023, '\p{^--Mahjong}', "");
    Expect(0, 127023, '\P{--Mahjong}', "");
    Expect(1, 127023, '\P{^--Mahjong}', "");
    Expect(0, 127024, '\p{--Mahjong}', "");
    Expect(1, 127024, '\p{^--Mahjong}', "");
    Expect(1, 127024, '\P{--Mahjong}', "");
    Expect(0, 127024, '\P{^--Mahjong}', "");
    Error('\p{_/a/Is_MAHJONG}');
    Error('\P{_/a/Is_MAHJONG}');
    Expect(1, 127023, '\p{ismahjong}', "");
    Expect(0, 127023, '\p{^ismahjong}', "");
    Expect(0, 127023, '\P{ismahjong}', "");
    Expect(1, 127023, '\P{^ismahjong}', "");
    Expect(0, 127024, '\p{ismahjong}', "");
    Expect(1, 127024, '\p{^ismahjong}', "");
    Expect(1, 127024, '\P{ismahjong}', "");
    Expect(0, 127024, '\P{^ismahjong}', "");
    Expect(1, 127023, '\p{	 IS_MAHJONG}', "");
    Expect(0, 127023, '\p{^	 IS_MAHJONG}', "");
    Expect(0, 127023, '\P{	 IS_MAHJONG}', "");
    Expect(1, 127023, '\P{^	 IS_MAHJONG}', "");
    Expect(0, 127024, '\p{	 IS_MAHJONG}', "");
    Expect(1, 127024, '\p{^	 IS_MAHJONG}', "");
    Expect(1, 127024, '\P{	 IS_MAHJONG}', "");
    Expect(0, 127024, '\P{^	 IS_MAHJONG}', "");
    Error('\p{:=- in_MAHJONG}');
    Error('\P{:=- in_MAHJONG}');
    Expect(1, 127023, '\p{inmahjong}', "");
    Expect(0, 127023, '\p{^inmahjong}', "");
    Expect(0, 127023, '\P{inmahjong}', "");
    Expect(1, 127023, '\P{^inmahjong}', "");
    Expect(0, 127024, '\p{inmahjong}', "");
    Expect(1, 127024, '\p{^inmahjong}', "");
    Expect(1, 127024, '\P{inmahjong}', "");
    Expect(0, 127024, '\P{^inmahjong}', "");
    Expect(1, 127023, '\p{-IN_mahjong}', "");
    Expect(0, 127023, '\p{^-IN_mahjong}', "");
    Expect(0, 127023, '\P{-IN_mahjong}', "");
    Expect(1, 127023, '\P{^-IN_mahjong}', "");
    Expect(0, 127024, '\p{-IN_mahjong}', "");
    Expect(1, 127024, '\p{^-IN_mahjong}', "");
    Expect(1, 127024, '\P{-IN_mahjong}', "");
    Expect(0, 127024, '\P{^-IN_mahjong}', "");
    Error('\p{-	Makasar/a/}');
    Error('\P{-	Makasar/a/}');
    Expect(1, 73464, '\p{makasar}', "");
    Expect(0, 73464, '\p{^makasar}', "");
    Expect(0, 73464, '\P{makasar}', "");
    Expect(1, 73464, '\P{^makasar}', "");
    Expect(0, 73465, '\p{makasar}', "");
    Expect(1, 73465, '\p{^makasar}', "");
    Expect(1, 73465, '\P{makasar}', "");
    Expect(0, 73465, '\P{^makasar}', "");
    Expect(1, 73464, '\p{	_MAKASAR}', "");
    Expect(0, 73464, '\p{^	_MAKASAR}', "");
    Expect(0, 73464, '\P{	_MAKASAR}', "");
    Expect(1, 73464, '\P{^	_MAKASAR}', "");
    Expect(0, 73465, '\p{	_MAKASAR}', "");
    Expect(1, 73465, '\p{^	_MAKASAR}', "");
    Expect(1, 73465, '\P{	_MAKASAR}', "");
    Expect(0, 73465, '\P{^	_MAKASAR}', "");
    Error('\p{:=is_Makasar}');
    Error('\P{:=is_Makasar}');
    Expect(1, 73464, '\p{ismakasar}', "");
    Expect(0, 73464, '\p{^ismakasar}', "");
    Expect(0, 73464, '\P{ismakasar}', "");
    Expect(1, 73464, '\P{^ismakasar}', "");
    Expect(0, 73465, '\p{ismakasar}', "");
    Expect(1, 73465, '\p{^ismakasar}', "");
    Expect(1, 73465, '\P{ismakasar}', "");
    Expect(0, 73465, '\P{^ismakasar}', "");
    Expect(1, 73464, '\p{--Is_MAKASAR}', "");
    Expect(0, 73464, '\p{^--Is_MAKASAR}', "");
    Expect(0, 73464, '\P{--Is_MAKASAR}', "");
    Expect(1, 73464, '\P{^--Is_MAKASAR}', "");
    Expect(0, 73465, '\p{--Is_MAKASAR}', "");
    Expect(1, 73465, '\p{^--Is_MAKASAR}', "");
    Expect(1, 73465, '\P{--Is_MAKASAR}', "");
    Expect(0, 73465, '\P{^--Is_MAKASAR}', "");
    Error('\p{ :=MAKA}');
    Error('\P{ :=MAKA}');
    Expect(1, 73464, '\p{maka}', "");
    Expect(0, 73464, '\p{^maka}', "");
    Expect(0, 73464, '\P{maka}', "");
    Expect(1, 73464, '\P{^maka}', "");
    Expect(0, 73465, '\p{maka}', "");
    Expect(1, 73465, '\p{^maka}', "");
    Expect(1, 73465, '\P{maka}', "");
    Expect(0, 73465, '\P{^maka}', "");
    Expect(1, 73464, '\p{ _MAKA}', "");
    Expect(0, 73464, '\p{^ _MAKA}', "");
    Expect(0, 73464, '\P{ _MAKA}', "");
    Expect(1, 73464, '\P{^ _MAKA}', "");
    Expect(0, 73465, '\p{ _MAKA}', "");
    Expect(1, 73465, '\p{^ _MAKA}', "");
    Expect(1, 73465, '\P{ _MAKA}', "");
    Expect(0, 73465, '\P{^ _MAKA}', "");
    Error('\p{/a/ _Is_MAKA}');
    Error('\P{/a/ _Is_MAKA}');
    Expect(1, 73464, '\p{ismaka}', "");
    Expect(0, 73464, '\p{^ismaka}', "");
    Expect(0, 73464, '\P{ismaka}', "");
    Expect(1, 73464, '\P{^ismaka}', "");
    Expect(0, 73465, '\p{ismaka}', "");
    Expect(1, 73465, '\p{^ismaka}', "");
    Expect(1, 73465, '\P{ismaka}', "");
    Expect(0, 73465, '\P{^ismaka}', "");
    Expect(1, 73464, '\p{_-Is_Maka}', "");
    Expect(0, 73464, '\p{^_-Is_Maka}', "");
    Expect(0, 73464, '\P{_-Is_Maka}', "");
    Expect(1, 73464, '\P{^_-Is_Maka}', "");
    Expect(0, 73465, '\p{_-Is_Maka}', "");
    Expect(1, 73465, '\p{^_-Is_Maka}', "");
    Expect(1, 73465, '\P{_-Is_Maka}', "");
    Expect(0, 73465, '\P{^_-Is_Maka}', "");
    Error('\p{:=- Malayalam}');
    Error('\P{:=- Malayalam}');
    Expect(1, 43058, '\p{malayalam}', "");
    Expect(0, 43058, '\p{^malayalam}', "");
    Expect(0, 43058, '\P{malayalam}', "");
    Expect(1, 43058, '\P{^malayalam}', "");
    Expect(0, 43059, '\p{malayalam}', "");
    Expect(1, 43059, '\p{^malayalam}', "");
    Expect(1, 43059, '\P{malayalam}', "");
    Expect(0, 43059, '\P{^malayalam}', "");
    Expect(1, 43058, '\p{	 Malayalam}', "");
    Expect(0, 43058, '\p{^	 Malayalam}', "");
    Expect(0, 43058, '\P{	 Malayalam}', "");
    Expect(1, 43058, '\P{^	 Malayalam}', "");
    Expect(0, 43059, '\p{	 Malayalam}', "");
    Expect(1, 43059, '\p{^	 Malayalam}', "");
    Expect(1, 43059, '\P{	 Malayalam}', "");
    Expect(0, 43059, '\P{^	 Malayalam}', "");
    Error('\p{	:=IS_malayalam}');
    Error('\P{	:=IS_malayalam}');
    Expect(1, 43058, '\p{ismalayalam}', "");
    Expect(0, 43058, '\p{^ismalayalam}', "");
    Expect(0, 43058, '\P{ismalayalam}', "");
    Expect(1, 43058, '\P{^ismalayalam}', "");
    Expect(0, 43059, '\p{ismalayalam}', "");
    Expect(1, 43059, '\p{^ismalayalam}', "");
    Expect(1, 43059, '\P{ismalayalam}', "");
    Expect(0, 43059, '\P{^ismalayalam}', "");
    Expect(1, 43058, '\p{  is_Malayalam}', "");
    Expect(0, 43058, '\p{^  is_Malayalam}', "");
    Expect(0, 43058, '\P{  is_Malayalam}', "");
    Expect(1, 43058, '\P{^  is_Malayalam}', "");
    Expect(0, 43059, '\p{  is_Malayalam}', "");
    Expect(1, 43059, '\p{^  is_Malayalam}', "");
    Expect(1, 43059, '\P{  is_Malayalam}', "");
    Expect(0, 43059, '\P{^  is_Malayalam}', "");
    Error('\p{--mlym/a/}');
    Error('\P{--mlym/a/}');
    Expect(1, 43058, '\p{mlym}', "");
    Expect(0, 43058, '\p{^mlym}', "");
    Expect(0, 43058, '\P{mlym}', "");
    Expect(1, 43058, '\P{^mlym}', "");
    Expect(0, 43059, '\p{mlym}', "");
    Expect(1, 43059, '\p{^mlym}', "");
    Expect(1, 43059, '\P{mlym}', "");
    Expect(0, 43059, '\P{^mlym}', "");
    Expect(1, 43058, '\p{- mlym}', "");
    Expect(0, 43058, '\p{^- mlym}', "");
    Expect(0, 43058, '\P{- mlym}', "");
    Expect(1, 43058, '\P{^- mlym}', "");
    Expect(0, 43059, '\p{- mlym}', "");
    Expect(1, 43059, '\p{^- mlym}', "");
    Expect(1, 43059, '\P{- mlym}', "");
    Expect(0, 43059, '\P{^- mlym}', "");
    Error('\p{:=-	IS_Mlym}');
    Error('\P{:=-	IS_Mlym}');
    Expect(1, 43058, '\p{ismlym}', "");
    Expect(0, 43058, '\p{^ismlym}', "");
    Expect(0, 43058, '\P{ismlym}', "");
    Expect(1, 43058, '\P{^ismlym}', "");
    Expect(0, 43059, '\p{ismlym}', "");
    Expect(1, 43059, '\p{^ismlym}', "");
    Expect(1, 43059, '\P{ismlym}', "");
    Expect(0, 43059, '\P{^ismlym}', "");
    Expect(1, 43058, '\p{_IS_Mlym}', "");
    Expect(0, 43058, '\p{^_IS_Mlym}', "");
    Expect(0, 43058, '\P{_IS_Mlym}', "");
    Expect(1, 43058, '\P{^_IS_Mlym}', "");
    Expect(0, 43059, '\p{_IS_Mlym}', "");
    Expect(1, 43059, '\p{^_IS_Mlym}', "");
    Expect(1, 43059, '\P{_IS_Mlym}', "");
    Expect(0, 43059, '\P{^_IS_Mlym}', "");
    Error('\p{-:=Mandaic}');
    Error('\P{-:=Mandaic}');
    Expect(1, 2142, '\p{mandaic}', "");
    Expect(0, 2142, '\p{^mandaic}', "");
    Expect(0, 2142, '\P{mandaic}', "");
    Expect(1, 2142, '\P{^mandaic}', "");
    Expect(0, 2143, '\p{mandaic}', "");
    Expect(1, 2143, '\p{^mandaic}', "");
    Expect(1, 2143, '\P{mandaic}', "");
    Expect(0, 2143, '\P{^mandaic}', "");
    Expect(1, 2142, '\p{ Mandaic}', "");
    Expect(0, 2142, '\p{^ Mandaic}', "");
    Expect(0, 2142, '\P{ Mandaic}', "");
    Expect(1, 2142, '\P{^ Mandaic}', "");
    Expect(0, 2143, '\p{ Mandaic}', "");
    Expect(1, 2143, '\p{^ Mandaic}', "");
    Expect(1, 2143, '\P{ Mandaic}', "");
    Expect(0, 2143, '\P{^ Mandaic}', "");
    Error('\p{_:=IS_mandaic}');
    Error('\P{_:=IS_mandaic}');
    Expect(1, 2142, '\p{ismandaic}', "");
    Expect(0, 2142, '\p{^ismandaic}', "");
    Expect(0, 2142, '\P{ismandaic}', "");
    Expect(1, 2142, '\P{^ismandaic}', "");
    Expect(0, 2143, '\p{ismandaic}', "");
    Expect(1, 2143, '\p{^ismandaic}', "");
    Expect(1, 2143, '\P{ismandaic}', "");
    Expect(0, 2143, '\P{^ismandaic}', "");
    Expect(1, 2142, '\p{-IS_mandaic}', "");
    Expect(0, 2142, '\p{^-IS_mandaic}', "");
    Expect(0, 2142, '\P{-IS_mandaic}', "");
    Expect(1, 2142, '\P{^-IS_mandaic}', "");
    Expect(0, 2143, '\p{-IS_mandaic}', "");
    Expect(1, 2143, '\p{^-IS_mandaic}', "");
    Expect(1, 2143, '\P{-IS_mandaic}', "");
    Expect(0, 2143, '\P{^-IS_mandaic}', "");
    Error('\p{/a/_ mand}');
    Error('\P{/a/_ mand}');
    Expect(1, 2142, '\p{mand}', "");
    Expect(0, 2142, '\p{^mand}', "");
    Expect(0, 2142, '\P{mand}', "");
    Expect(1, 2142, '\P{^mand}', "");
    Expect(0, 2143, '\p{mand}', "");
    Expect(1, 2143, '\p{^mand}', "");
    Expect(1, 2143, '\P{mand}', "");
    Expect(0, 2143, '\P{^mand}', "");
    Expect(1, 2142, '\p{	_mand}', "");
    Expect(0, 2142, '\p{^	_mand}', "");
    Expect(0, 2142, '\P{	_mand}', "");
    Expect(1, 2142, '\P{^	_mand}', "");
    Expect(0, 2143, '\p{	_mand}', "");
    Expect(1, 2143, '\p{^	_mand}', "");
    Expect(1, 2143, '\P{	_mand}', "");
    Expect(0, 2143, '\P{^	_mand}', "");
    Error('\p{_is_MAND/a/}');
    Error('\P{_is_MAND/a/}');
    Expect(1, 2142, '\p{ismand}', "");
    Expect(0, 2142, '\p{^ismand}', "");
    Expect(0, 2142, '\P{ismand}', "");
    Expect(1, 2142, '\P{^ismand}', "");
    Expect(0, 2143, '\p{ismand}', "");
    Expect(1, 2143, '\p{^ismand}', "");
    Expect(1, 2143, '\P{ismand}', "");
    Expect(0, 2143, '\P{^ismand}', "");
    Expect(1, 2142, '\p{  is_Mand}', "");
    Expect(0, 2142, '\p{^  is_Mand}', "");
    Expect(0, 2142, '\P{  is_Mand}', "");
    Expect(1, 2142, '\P{^  is_Mand}', "");
    Expect(0, 2143, '\p{  is_Mand}', "");
    Expect(1, 2143, '\p{^  is_Mand}', "");
    Expect(1, 2143, '\P{  is_Mand}', "");
    Expect(0, 2143, '\P{^  is_Mand}', "");
    Error('\p{:=_ Manichaean}');
    Error('\P{:=_ Manichaean}');
    Expect(1, 68342, '\p{manichaean}', "");
    Expect(0, 68342, '\p{^manichaean}', "");
    Expect(0, 68342, '\P{manichaean}', "");
    Expect(1, 68342, '\P{^manichaean}', "");
    Expect(0, 68343, '\p{manichaean}', "");
    Expect(1, 68343, '\p{^manichaean}', "");
    Expect(1, 68343, '\P{manichaean}', "");
    Expect(0, 68343, '\P{^manichaean}', "");
    Expect(1, 68342, '\p{	_Manichaean}', "");
    Expect(0, 68342, '\p{^	_Manichaean}', "");
    Expect(0, 68342, '\P{	_Manichaean}', "");
    Expect(1, 68342, '\P{^	_Manichaean}', "");
    Expect(0, 68343, '\p{	_Manichaean}', "");
    Expect(1, 68343, '\p{^	_Manichaean}', "");
    Expect(1, 68343, '\P{	_Manichaean}', "");
    Expect(0, 68343, '\P{^	_Manichaean}', "");
    Error('\p{	:=Is_manichaean}');
    Error('\P{	:=Is_manichaean}');
    Expect(1, 68342, '\p{ismanichaean}', "");
    Expect(0, 68342, '\p{^ismanichaean}', "");
    Expect(0, 68342, '\P{ismanichaean}', "");
    Expect(1, 68342, '\P{^ismanichaean}', "");
    Expect(0, 68343, '\p{ismanichaean}', "");
    Expect(1, 68343, '\p{^ismanichaean}', "");
    Expect(1, 68343, '\P{ismanichaean}', "");
    Expect(0, 68343, '\P{^ismanichaean}', "");
    Expect(1, 68342, '\p{ 	Is_manichaean}', "");
    Expect(0, 68342, '\p{^ 	Is_manichaean}', "");
    Expect(0, 68342, '\P{ 	Is_manichaean}', "");
    Expect(1, 68342, '\P{^ 	Is_manichaean}', "");
    Expect(0, 68343, '\p{ 	Is_manichaean}', "");
    Expect(1, 68343, '\p{^ 	Is_manichaean}', "");
    Expect(1, 68343, '\P{ 	Is_manichaean}', "");
    Expect(0, 68343, '\P{^ 	Is_manichaean}', "");
    Error('\p{	mani:=}');
    Error('\P{	mani:=}');
    Expect(1, 68342, '\p{mani}', "");
    Expect(0, 68342, '\p{^mani}', "");
    Expect(0, 68342, '\P{mani}', "");
    Expect(1, 68342, '\P{^mani}', "");
    Expect(0, 68343, '\p{mani}', "");
    Expect(1, 68343, '\p{^mani}', "");
    Expect(1, 68343, '\P{mani}', "");
    Expect(0, 68343, '\P{^mani}', "");
    Expect(1, 68342, '\p{_	MANI}', "");
    Expect(0, 68342, '\p{^_	MANI}', "");
    Expect(0, 68342, '\P{_	MANI}', "");
    Expect(1, 68342, '\P{^_	MANI}', "");
    Expect(0, 68343, '\p{_	MANI}', "");
    Expect(1, 68343, '\p{^_	MANI}', "");
    Expect(1, 68343, '\P{_	MANI}', "");
    Expect(0, 68343, '\P{^_	MANI}', "");
    Error('\p{-Is_Mani/a/}');
    Error('\P{-Is_Mani/a/}');
    Expect(1, 68342, '\p{ismani}', "");
    Expect(0, 68342, '\p{^ismani}', "");
    Expect(0, 68342, '\P{ismani}', "");
    Expect(1, 68342, '\P{^ismani}', "");
    Expect(0, 68343, '\p{ismani}', "");
    Expect(1, 68343, '\p{^ismani}', "");
    Expect(1, 68343, '\P{ismani}', "");
    Expect(0, 68343, '\P{^ismani}', "");
    Expect(1, 68342, '\p{-	is_Mani}', "");
    Expect(0, 68342, '\p{^-	is_Mani}', "");
    Expect(0, 68342, '\P{-	is_Mani}', "");
    Expect(1, 68342, '\P{^-	is_Mani}', "");
    Expect(0, 68343, '\p{-	is_Mani}', "");
    Expect(1, 68343, '\p{^-	is_Mani}', "");
    Expect(1, 68343, '\P{-	is_Mani}', "");
    Expect(0, 68343, '\P{^-	is_Mani}', "");
    Error('\p{/a/_marchen}');
    Error('\P{/a/_marchen}');
    Expect(1, 72886, '\p{marchen}', "");
    Expect(0, 72886, '\p{^marchen}', "");
    Expect(0, 72886, '\P{marchen}', "");
    Expect(1, 72886, '\P{^marchen}', "");
    Expect(0, 72887, '\p{marchen}', "");
    Expect(1, 72887, '\p{^marchen}', "");
    Expect(1, 72887, '\P{marchen}', "");
    Expect(0, 72887, '\P{^marchen}', "");
    Expect(1, 72886, '\p{ -Marchen}', "");
    Expect(0, 72886, '\p{^ -Marchen}', "");
    Expect(0, 72886, '\P{ -Marchen}', "");
    Expect(1, 72886, '\P{^ -Marchen}', "");
    Expect(0, 72887, '\p{ -Marchen}', "");
    Expect(1, 72887, '\p{^ -Marchen}', "");
    Expect(1, 72887, '\P{ -Marchen}', "");
    Expect(0, 72887, '\P{^ -Marchen}', "");
    Error('\p{--Is_Marchen:=}');
    Error('\P{--Is_Marchen:=}');
    Expect(1, 72886, '\p{ismarchen}', "");
    Expect(0, 72886, '\p{^ismarchen}', "");
    Expect(0, 72886, '\P{ismarchen}', "");
    Expect(1, 72886, '\P{^ismarchen}', "");
    Expect(0, 72887, '\p{ismarchen}', "");
    Expect(1, 72887, '\p{^ismarchen}', "");
    Expect(1, 72887, '\P{ismarchen}', "");
    Expect(0, 72887, '\P{^ismarchen}', "");
    Expect(1, 72886, '\p{-_is_Marchen}', "");
    Expect(0, 72886, '\p{^-_is_Marchen}', "");
    Expect(0, 72886, '\P{-_is_Marchen}', "");
    Expect(1, 72886, '\P{^-_is_Marchen}', "");
    Expect(0, 72887, '\p{-_is_Marchen}', "");
    Expect(1, 72887, '\p{^-_is_Marchen}', "");
    Expect(1, 72887, '\P{-_is_Marchen}', "");
    Expect(0, 72887, '\P{^-_is_Marchen}', "");
    Error('\p{:=  MARC}');
    Error('\P{:=  MARC}');
    Expect(1, 72886, '\p{marc}', "");
    Expect(0, 72886, '\p{^marc}', "");
    Expect(0, 72886, '\P{marc}', "");
    Expect(1, 72886, '\P{^marc}', "");
    Expect(0, 72887, '\p{marc}', "");
    Expect(1, 72887, '\p{^marc}', "");
    Expect(1, 72887, '\P{marc}', "");
    Expect(0, 72887, '\P{^marc}', "");
    Expect(1, 72886, '\p{-_Marc}', "");
    Expect(0, 72886, '\p{^-_Marc}', "");
    Expect(0, 72886, '\P{-_Marc}', "");
    Expect(1, 72886, '\P{^-_Marc}', "");
    Expect(0, 72887, '\p{-_Marc}', "");
    Expect(1, 72887, '\p{^-_Marc}', "");
    Expect(1, 72887, '\P{-_Marc}', "");
    Expect(0, 72887, '\P{^-_Marc}', "");
    Error('\p{:= -is_marc}');
    Error('\P{:= -is_marc}');
    Expect(1, 72886, '\p{ismarc}', "");
    Expect(0, 72886, '\p{^ismarc}', "");
    Expect(0, 72886, '\P{ismarc}', "");
    Expect(1, 72886, '\P{^ismarc}', "");
    Expect(0, 72887, '\p{ismarc}', "");
    Expect(1, 72887, '\p{^ismarc}', "");
    Expect(1, 72887, '\P{ismarc}', "");
    Expect(0, 72887, '\P{^ismarc}', "");
    Expect(1, 72886, '\p{__Is_marc}', "");
    Expect(0, 72886, '\p{^__Is_marc}', "");
    Expect(0, 72886, '\P{__Is_marc}', "");
    Expect(1, 72886, '\P{^__Is_marc}', "");
    Expect(0, 72887, '\p{__Is_marc}', "");
    Expect(1, 72887, '\p{^__Is_marc}', "");
    Expect(1, 72887, '\P{__Is_marc}', "");
    Expect(0, 72887, '\P{^__Is_marc}', "");
    Error('\p{/a/	mark}');
    Error('\P{/a/	mark}');
    Expect(1, 917999, '\p{mark}', "");
    Expect(0, 917999, '\p{^mark}', "");
    Expect(0, 917999, '\P{mark}', "");
    Expect(1, 917999, '\P{^mark}', "");
    Expect(0, 918000, '\p{mark}', "");
    Expect(1, 918000, '\p{^mark}', "");
    Expect(1, 918000, '\P{mark}', "");
    Expect(0, 918000, '\P{^mark}', "");
    Expect(1, 917999, '\p{	Mark}', "");
    Expect(0, 917999, '\p{^	Mark}', "");
    Expect(0, 917999, '\P{	Mark}', "");
    Expect(1, 917999, '\P{^	Mark}', "");
    Expect(0, 918000, '\p{	Mark}', "");
    Expect(1, 918000, '\p{^	Mark}', "");
    Expect(1, 918000, '\P{	Mark}', "");
    Expect(0, 918000, '\P{^	Mark}', "");
    Error('\p{/a/	Is_MARK}');
    Error('\P{/a/	Is_MARK}');
    Expect(1, 917999, '\p{ismark}', "");
    Expect(0, 917999, '\p{^ismark}', "");
    Expect(0, 917999, '\P{ismark}', "");
    Expect(1, 917999, '\P{^ismark}', "");
    Expect(0, 918000, '\p{ismark}', "");
    Expect(1, 918000, '\p{^ismark}', "");
    Expect(1, 918000, '\P{ismark}', "");
    Expect(0, 918000, '\P{^ismark}', "");
    Expect(1, 917999, '\p{_Is_mark}', "");
    Expect(0, 917999, '\p{^_Is_mark}', "");
    Expect(0, 917999, '\P{_Is_mark}', "");
    Expect(1, 917999, '\P{^_Is_mark}', "");
    Expect(0, 918000, '\p{_Is_mark}', "");
    Expect(1, 918000, '\p{^_Is_mark}', "");
    Expect(1, 918000, '\P{_Is_mark}', "");
    Expect(0, 918000, '\P{^_Is_mark}', "");
    Error('\p{:=- M}');
    Error('\P{:=- M}');
    Expect(1, 917999, '\p{m}', "");
    Expect(0, 917999, '\p{^m}', "");
    Expect(0, 917999, '\P{m}', "");
    Expect(1, 917999, '\P{^m}', "");
    Expect(0, 918000, '\p{m}', "");
    Expect(1, 918000, '\p{^m}', "");
    Expect(1, 918000, '\P{m}', "");
    Expect(0, 918000, '\P{^m}', "");
    Expect(1, 917999, '\p{	_m}', "");
    Expect(0, 917999, '\p{^	_m}', "");
    Expect(0, 917999, '\P{	_m}', "");
    Expect(1, 917999, '\P{^	_m}', "");
    Expect(0, 918000, '\p{	_m}', "");
    Expect(1, 918000, '\p{^	_m}', "");
    Expect(1, 918000, '\P{	_m}', "");
    Expect(0, 918000, '\P{^	_m}', "");
    Error('\p{-:=is_M}');
    Error('\P{-:=is_M}');
    Expect(1, 917999, '\p{ism}', "");
    Expect(0, 917999, '\p{^ism}', "");
    Expect(0, 917999, '\P{ism}', "");
    Expect(1, 917999, '\P{^ism}', "");
    Expect(0, 918000, '\p{ism}', "");
    Expect(1, 918000, '\p{^ism}', "");
    Expect(1, 918000, '\P{ism}', "");
    Expect(0, 918000, '\P{^ism}', "");
    Expect(1, 917999, '\p{-_is_M}', "");
    Expect(0, 917999, '\p{^-_is_M}', "");
    Expect(0, 917999, '\P{-_is_M}', "");
    Expect(1, 917999, '\P{^-_is_M}', "");
    Expect(0, 918000, '\p{-_is_M}', "");
    Expect(1, 918000, '\p{^-_is_M}', "");
    Expect(1, 918000, '\P{-_is_M}', "");
    Expect(0, 918000, '\P{^-_is_M}', "");
    Error('\p{:=__Combining_MARK}');
    Error('\P{:=__Combining_MARK}');
    Expect(1, 917999, '\p{combiningmark}', "");
    Expect(0, 917999, '\p{^combiningmark}', "");
    Expect(0, 917999, '\P{combiningmark}', "");
    Expect(1, 917999, '\P{^combiningmark}', "");
    Expect(0, 918000, '\p{combiningmark}', "");
    Expect(1, 918000, '\p{^combiningmark}', "");
    Expect(1, 918000, '\P{combiningmark}', "");
    Expect(0, 918000, '\P{^combiningmark}', "");
    Expect(1, 917999, '\p{	COMBINING_Mark}', "");
    Expect(0, 917999, '\p{^	COMBINING_Mark}', "");
    Expect(0, 917999, '\P{	COMBINING_Mark}', "");
    Expect(1, 917999, '\P{^	COMBINING_Mark}', "");
    Expect(0, 918000, '\p{	COMBINING_Mark}', "");
    Expect(1, 918000, '\p{^	COMBINING_Mark}', "");
    Expect(1, 918000, '\P{	COMBINING_Mark}', "");
    Expect(0, 918000, '\P{^	COMBINING_Mark}', "");
    Error('\p{ /a/IS_Combining_Mark}');
    Error('\P{ /a/IS_Combining_Mark}');
    Expect(1, 917999, '\p{iscombiningmark}', "");
    Expect(0, 917999, '\p{^iscombiningmark}', "");
    Expect(0, 917999, '\P{iscombiningmark}', "");
    Expect(1, 917999, '\P{^iscombiningmark}', "");
    Expect(0, 918000, '\p{iscombiningmark}', "");
    Expect(1, 918000, '\p{^iscombiningmark}', "");
    Expect(1, 918000, '\P{iscombiningmark}', "");
    Expect(0, 918000, '\P{^iscombiningmark}', "");
    Expect(1, 917999, '\p{-Is_Combining_mark}', "");
    Expect(0, 917999, '\p{^-Is_Combining_mark}', "");
    Expect(0, 917999, '\P{-Is_Combining_mark}', "");
    Expect(1, 917999, '\P{^-Is_Combining_mark}', "");
    Expect(0, 918000, '\p{-Is_Combining_mark}', "");
    Expect(1, 918000, '\p{^-Is_Combining_mark}', "");
    Expect(1, 918000, '\P{-Is_Combining_mark}', "");
    Expect(0, 918000, '\P{^-Is_Combining_mark}', "");
    Error('\p{:=	Masaram_Gondi}');
    Error('\P{:=	Masaram_Gondi}');
    Expect(1, 73049, '\p{masaramgondi}', "");
    Expect(0, 73049, '\p{^masaramgondi}', "");
    Expect(0, 73049, '\P{masaramgondi}', "");
    Expect(1, 73049, '\P{^masaramgondi}', "");
    Expect(0, 73050, '\p{masaramgondi}', "");
    Expect(1, 73050, '\p{^masaramgondi}', "");
    Expect(1, 73050, '\P{masaramgondi}', "");
    Expect(0, 73050, '\P{^masaramgondi}', "");
    Expect(1, 73049, '\p{-Masaram_gondi}', "");
    Expect(0, 73049, '\p{^-Masaram_gondi}', "");
    Expect(0, 73049, '\P{-Masaram_gondi}', "");
    Expect(1, 73049, '\P{^-Masaram_gondi}', "");
    Expect(0, 73050, '\p{-Masaram_gondi}', "");
    Expect(1, 73050, '\p{^-Masaram_gondi}', "");
    Expect(1, 73050, '\P{-Masaram_gondi}', "");
    Expect(0, 73050, '\P{^-Masaram_gondi}', "");
    Error('\p{:=	 Is_Masaram_gondi}');
    Error('\P{:=	 Is_Masaram_gondi}');
    Expect(1, 73049, '\p{ismasaramgondi}', "");
    Expect(0, 73049, '\p{^ismasaramgondi}', "");
    Expect(0, 73049, '\P{ismasaramgondi}', "");
    Expect(1, 73049, '\P{^ismasaramgondi}', "");
    Expect(0, 73050, '\p{ismasaramgondi}', "");
    Expect(1, 73050, '\p{^ismasaramgondi}', "");
    Expect(1, 73050, '\P{ismasaramgondi}', "");
    Expect(0, 73050, '\P{^ismasaramgondi}', "");
    Expect(1, 73049, '\p{-	Is_Masaram_GONDI}', "");
    Expect(0, 73049, '\p{^-	Is_Masaram_GONDI}', "");
    Expect(0, 73049, '\P{-	Is_Masaram_GONDI}', "");
    Expect(1, 73049, '\P{^-	Is_Masaram_GONDI}', "");
    Expect(0, 73050, '\p{-	Is_Masaram_GONDI}', "");
    Expect(1, 73050, '\p{^-	Is_Masaram_GONDI}', "");
    Expect(1, 73050, '\P{-	Is_Masaram_GONDI}', "");
    Expect(0, 73050, '\P{^-	Is_Masaram_GONDI}', "");
    Error('\p{:=		gonm}');
    Error('\P{:=		gonm}');
    Expect(1, 73049, '\p{gonm}', "");
    Expect(0, 73049, '\p{^gonm}', "");
    Expect(0, 73049, '\P{gonm}', "");
    Expect(1, 73049, '\P{^gonm}', "");
    Expect(0, 73050, '\p{gonm}', "");
    Expect(1, 73050, '\p{^gonm}', "");
    Expect(1, 73050, '\P{gonm}', "");
    Expect(0, 73050, '\P{^gonm}', "");
    Expect(1, 73049, '\p{		Gonm}', "");
    Expect(0, 73049, '\p{^		Gonm}', "");
    Expect(0, 73049, '\P{		Gonm}', "");
    Expect(1, 73049, '\P{^		Gonm}', "");
    Expect(0, 73050, '\p{		Gonm}', "");
    Expect(1, 73050, '\p{^		Gonm}', "");
    Expect(1, 73050, '\P{		Gonm}', "");
    Expect(0, 73050, '\P{^		Gonm}', "");
    Error('\p{  is_Gonm/a/}');
    Error('\P{  is_Gonm/a/}');
    Expect(1, 73049, '\p{isgonm}', "");
    Expect(0, 73049, '\p{^isgonm}', "");
    Expect(0, 73049, '\P{isgonm}', "");
    Expect(1, 73049, '\P{^isgonm}', "");
    Expect(0, 73050, '\p{isgonm}', "");
    Expect(1, 73050, '\p{^isgonm}', "");
    Expect(1, 73050, '\P{isgonm}', "");
    Expect(0, 73050, '\P{^isgonm}', "");
    Expect(1, 73049, '\p{-Is_Gonm}', "");
    Expect(0, 73049, '\p{^-Is_Gonm}', "");
    Expect(0, 73049, '\P{-Is_Gonm}', "");
    Expect(1, 73049, '\P{^-Is_Gonm}', "");
    Expect(0, 73050, '\p{-Is_Gonm}', "");
    Expect(1, 73050, '\p{^-Is_Gonm}', "");
    Expect(1, 73050, '\P{-Is_Gonm}', "");
    Expect(0, 73050, '\P{^-Is_Gonm}', "");
    Error('\p{ Math/a/}');
    Error('\P{ Math/a/}');
    Expect(1, 126705, '\p{math}', "");
    Expect(0, 126705, '\p{^math}', "");
    Expect(0, 126705, '\P{math}', "");
    Expect(1, 126705, '\P{^math}', "");
    Expect(0, 126706, '\p{math}', "");
    Expect(1, 126706, '\p{^math}', "");
    Expect(1, 126706, '\P{math}', "");
    Expect(0, 126706, '\P{^math}', "");
    Expect(1, 126705, '\p{--math}', "");
    Expect(0, 126705, '\p{^--math}', "");
    Expect(0, 126705, '\P{--math}', "");
    Expect(1, 126705, '\P{^--math}', "");
    Expect(0, 126706, '\p{--math}', "");
    Expect(1, 126706, '\p{^--math}', "");
    Expect(1, 126706, '\P{--math}', "");
    Expect(0, 126706, '\P{^--math}', "");
    Error('\p{/a/is_Math}');
    Error('\P{/a/is_Math}');
    Expect(1, 126705, '\p{ismath}', "");
    Expect(0, 126705, '\p{^ismath}', "");
    Expect(0, 126705, '\P{ismath}', "");
    Expect(1, 126705, '\P{^ismath}', "");
    Expect(0, 126706, '\p{ismath}', "");
    Expect(1, 126706, '\p{^ismath}', "");
    Expect(1, 126706, '\P{ismath}', "");
    Expect(0, 126706, '\P{^ismath}', "");
    Expect(1, 126705, '\p{-_Is_Math}', "");
    Expect(0, 126705, '\p{^-_Is_Math}', "");
    Expect(0, 126705, '\P{-_Is_Math}', "");
    Expect(1, 126705, '\P{^-_Is_Math}', "");
    Expect(0, 126706, '\p{-_Is_Math}', "");
    Expect(1, 126706, '\p{^-_Is_Math}', "");
    Expect(1, 126706, '\P{-_Is_Math}', "");
    Expect(0, 126706, '\P{^-_Is_Math}', "");
    Error('\p{-/a/Math_symbol}');
    Error('\P{-/a/Math_symbol}');
    Expect(1, 126705, '\p{mathsymbol}', "");
    Expect(0, 126705, '\p{^mathsymbol}', "");
    Expect(0, 126705, '\P{mathsymbol}', "");
    Expect(1, 126705, '\P{^mathsymbol}', "");
    Expect(0, 126706, '\p{mathsymbol}', "");
    Expect(1, 126706, '\p{^mathsymbol}', "");
    Expect(1, 126706, '\P{mathsymbol}', "");
    Expect(0, 126706, '\P{^mathsymbol}', "");
    Expect(1, 126705, '\p{  Math_Symbol}', "");
    Expect(0, 126705, '\p{^  Math_Symbol}', "");
    Expect(0, 126705, '\P{  Math_Symbol}', "");
    Expect(1, 126705, '\P{^  Math_Symbol}', "");
    Expect(0, 126706, '\p{  Math_Symbol}', "");
    Expect(1, 126706, '\p{^  Math_Symbol}', "");
    Expect(1, 126706, '\P{  Math_Symbol}', "");
    Expect(0, 126706, '\P{^  Math_Symbol}', "");
    Error('\p{:=Is_MATH_symbol}');
    Error('\P{:=Is_MATH_symbol}');
    Expect(1, 126705, '\p{ismathsymbol}', "");
    Expect(0, 126705, '\p{^ismathsymbol}', "");
    Expect(0, 126705, '\P{ismathsymbol}', "");
    Expect(1, 126705, '\P{^ismathsymbol}', "");
    Expect(0, 126706, '\p{ismathsymbol}', "");
    Expect(1, 126706, '\p{^ismathsymbol}', "");
    Expect(1, 126706, '\P{ismathsymbol}', "");
    Expect(0, 126706, '\P{^ismathsymbol}', "");
    Expect(1, 126705, '\p{_-is_Math_Symbol}', "");
    Expect(0, 126705, '\p{^_-is_Math_Symbol}', "");
    Expect(0, 126705, '\P{_-is_Math_Symbol}', "");
    Expect(1, 126705, '\P{^_-is_Math_Symbol}', "");
    Expect(0, 126706, '\p{_-is_Math_Symbol}', "");
    Expect(1, 126706, '\p{^_-is_Math_Symbol}', "");
    Expect(1, 126706, '\P{_-is_Math_Symbol}', "");
    Expect(0, 126706, '\P{^_-is_Math_Symbol}', "");
    Error('\p{-SM:=}');
    Error('\P{-SM:=}');
    Expect(1, 126705, '\p{sm}', "");
    Expect(0, 126705, '\p{^sm}', "");
    Expect(0, 126705, '\P{sm}', "");
    Expect(1, 126705, '\P{^sm}', "");
    Expect(0, 126706, '\p{sm}', "");
    Expect(1, 126706, '\p{^sm}', "");
    Expect(1, 126706, '\P{sm}', "");
    Expect(0, 126706, '\P{^sm}', "");
    Expect(1, 126705, '\p{_	Sm}', "");
    Expect(0, 126705, '\p{^_	Sm}', "");
    Expect(0, 126705, '\P{_	Sm}', "");
    Expect(1, 126705, '\P{^_	Sm}', "");
    Expect(0, 126706, '\p{_	Sm}', "");
    Expect(1, 126706, '\p{^_	Sm}', "");
    Expect(1, 126706, '\P{_	Sm}', "");
    Expect(0, 126706, '\P{^_	Sm}', "");
    Error('\p{:=_	is_SM}');
    Error('\P{:=_	is_SM}');
    Expect(1, 126705, '\p{issm}', "");
    Expect(0, 126705, '\p{^issm}', "");
    Expect(0, 126705, '\P{issm}', "");
    Expect(1, 126705, '\P{^issm}', "");
    Expect(0, 126706, '\p{issm}', "");
    Expect(1, 126706, '\p{^issm}', "");
    Expect(1, 126706, '\P{issm}', "");
    Expect(0, 126706, '\P{^issm}', "");
    Expect(1, 126705, '\p{ _IS_sm}', "");
    Expect(0, 126705, '\p{^ _IS_sm}', "");
    Expect(0, 126705, '\P{ _IS_sm}', "");
    Expect(1, 126705, '\P{^ _IS_sm}', "");
    Expect(0, 126706, '\p{ _IS_sm}', "");
    Expect(1, 126706, '\p{^ _IS_sm}', "");
    Expect(1, 126706, '\P{ _IS_sm}', "");
    Expect(0, 126706, '\P{^ _IS_sm}', "");
    Error('\p{:=-	Mathematical_Alphanumeric_Symbols}');
    Error('\P{:=-	Mathematical_Alphanumeric_Symbols}');
    Expect(1, 120831, '\p{mathematicalalphanumericsymbols}', "");
    Expect(0, 120831, '\p{^mathematicalalphanumericsymbols}', "");
    Expect(0, 120831, '\P{mathematicalalphanumericsymbols}', "");
    Expect(1, 120831, '\P{^mathematicalalphanumericsymbols}', "");
    Expect(0, 120832, '\p{mathematicalalphanumericsymbols}', "");
    Expect(1, 120832, '\p{^mathematicalalphanumericsymbols}', "");
    Expect(1, 120832, '\P{mathematicalalphanumericsymbols}', "");
    Expect(0, 120832, '\P{^mathematicalalphanumericsymbols}', "");
    Expect(1, 120831, '\p{Mathematical_Alphanumeric_symbols}', "");
    Expect(0, 120831, '\p{^Mathematical_Alphanumeric_symbols}', "");
    Expect(0, 120831, '\P{Mathematical_Alphanumeric_symbols}', "");
    Expect(1, 120831, '\P{^Mathematical_Alphanumeric_symbols}', "");
    Expect(0, 120832, '\p{Mathematical_Alphanumeric_symbols}', "");
    Expect(1, 120832, '\p{^Mathematical_Alphanumeric_symbols}', "");
    Expect(1, 120832, '\P{Mathematical_Alphanumeric_symbols}', "");
    Expect(0, 120832, '\P{^Mathematical_Alphanumeric_symbols}', "");
    Error('\p{ IS_mathematical_ALPHANUMERIC_Symbols/a/}');
    Error('\P{ IS_mathematical_ALPHANUMERIC_Symbols/a/}');
    Expect(1, 120831, '\p{ismathematicalalphanumericsymbols}', "");
    Expect(0, 120831, '\p{^ismathematicalalphanumericsymbols}', "");
    Expect(0, 120831, '\P{ismathematicalalphanumericsymbols}', "");
    Expect(1, 120831, '\P{^ismathematicalalphanumericsymbols}', "");
    Expect(0, 120832, '\p{ismathematicalalphanumericsymbols}', "");
    Expect(1, 120832, '\p{^ismathematicalalphanumericsymbols}', "");
    Expect(1, 120832, '\P{ismathematicalalphanumericsymbols}', "");
    Expect(0, 120832, '\P{^ismathematicalalphanumericsymbols}', "");
    Expect(1, 120831, '\p{is_Mathematical_alphanumeric_symbols}', "");
    Expect(0, 120831, '\p{^is_Mathematical_alphanumeric_symbols}', "");
    Expect(0, 120831, '\P{is_Mathematical_alphanumeric_symbols}', "");
    Expect(1, 120831, '\P{^is_Mathematical_alphanumeric_symbols}', "");
    Expect(0, 120832, '\p{is_Mathematical_alphanumeric_symbols}', "");
    Expect(1, 120832, '\p{^is_Mathematical_alphanumeric_symbols}', "");
    Expect(1, 120832, '\P{is_Mathematical_alphanumeric_symbols}', "");
    Expect(0, 120832, '\P{^is_Mathematical_alphanumeric_symbols}', "");
    Error('\p{  In_Mathematical_Alphanumeric_Symbols/a/}');
    Error('\P{  In_Mathematical_Alphanumeric_Symbols/a/}');
    Expect(1, 120831, '\p{inmathematicalalphanumericsymbols}', "");
    Expect(0, 120831, '\p{^inmathematicalalphanumericsymbols}', "");
    Expect(0, 120831, '\P{inmathematicalalphanumericsymbols}', "");
    Expect(1, 120831, '\P{^inmathematicalalphanumericsymbols}', "");
    Expect(0, 120832, '\p{inmathematicalalphanumericsymbols}', "");
    Expect(1, 120832, '\p{^inmathematicalalphanumericsymbols}', "");
    Expect(1, 120832, '\P{inmathematicalalphanumericsymbols}', "");
    Expect(0, 120832, '\P{^inmathematicalalphanumericsymbols}', "");
    Expect(1, 120831, '\p{	in_Mathematical_ALPHANUMERIC_Symbols}', "");
    Expect(0, 120831, '\p{^	in_Mathematical_ALPHANUMERIC_Symbols}', "");
    Expect(0, 120831, '\P{	in_Mathematical_ALPHANUMERIC_Symbols}', "");
    Expect(1, 120831, '\P{^	in_Mathematical_ALPHANUMERIC_Symbols}', "");
    Expect(0, 120832, '\p{	in_Mathematical_ALPHANUMERIC_Symbols}', "");
    Expect(1, 120832, '\p{^	in_Mathematical_ALPHANUMERIC_Symbols}', "");
    Expect(1, 120832, '\P{	in_Mathematical_ALPHANUMERIC_Symbols}', "");
    Expect(0, 120832, '\P{^	in_Mathematical_ALPHANUMERIC_Symbols}', "");
    Error('\p{ -math_alphanum:=}');
    Error('\P{ -math_alphanum:=}');
    Expect(1, 120831, '\p{mathalphanum}', "");
    Expect(0, 120831, '\p{^mathalphanum}', "");
    Expect(0, 120831, '\P{mathalphanum}', "");
    Expect(1, 120831, '\P{^mathalphanum}', "");
    Expect(0, 120832, '\p{mathalphanum}', "");
    Expect(1, 120832, '\p{^mathalphanum}', "");
    Expect(1, 120832, '\P{mathalphanum}', "");
    Expect(0, 120832, '\P{^mathalphanum}', "");
    Expect(1, 120831, '\p{ Math_alphanum}', "");
    Expect(0, 120831, '\p{^ Math_alphanum}', "");
    Expect(0, 120831, '\P{ Math_alphanum}', "");
    Expect(1, 120831, '\P{^ Math_alphanum}', "");
    Expect(0, 120832, '\p{ Math_alphanum}', "");
    Expect(1, 120832, '\p{^ Math_alphanum}', "");
    Expect(1, 120832, '\P{ Math_alphanum}', "");
    Expect(0, 120832, '\P{^ Math_alphanum}', "");
    Error('\p{/a/-is_MATH_alphanum}');
    Error('\P{/a/-is_MATH_alphanum}');
    Expect(1, 120831, '\p{ismathalphanum}', "");
    Expect(0, 120831, '\p{^ismathalphanum}', "");
    Expect(0, 120831, '\P{ismathalphanum}', "");
    Expect(1, 120831, '\P{^ismathalphanum}', "");
    Expect(0, 120832, '\p{ismathalphanum}', "");
    Expect(1, 120832, '\p{^ismathalphanum}', "");
    Expect(1, 120832, '\P{ismathalphanum}', "");
    Expect(0, 120832, '\P{^ismathalphanum}', "");
    Expect(1, 120831, '\p{_Is_Math_alphanum}', "");
    Expect(0, 120831, '\p{^_Is_Math_alphanum}', "");
    Expect(0, 120831, '\P{_Is_Math_alphanum}', "");
    Expect(1, 120831, '\P{^_Is_Math_alphanum}', "");
    Expect(0, 120832, '\p{_Is_Math_alphanum}', "");
    Expect(1, 120832, '\p{^_Is_Math_alphanum}', "");
    Expect(1, 120832, '\P{_Is_Math_alphanum}', "");
    Expect(0, 120832, '\P{^_Is_Math_alphanum}', "");
    Error('\p{:=_	in_Math_ALPHANUM}');
    Error('\P{:=_	in_Math_ALPHANUM}');
    Expect(1, 120831, '\p{inmathalphanum}', "");
    Expect(0, 120831, '\p{^inmathalphanum}', "");
    Expect(0, 120831, '\P{inmathalphanum}', "");
    Expect(1, 120831, '\P{^inmathalphanum}', "");
    Expect(0, 120832, '\p{inmathalphanum}', "");
    Expect(1, 120832, '\p{^inmathalphanum}', "");
    Expect(1, 120832, '\P{inmathalphanum}', "");
    Expect(0, 120832, '\P{^inmathalphanum}', "");
    Expect(1, 120831, '\p{ 	In_math_ALPHANUM}', "");
    Expect(0, 120831, '\p{^ 	In_math_ALPHANUM}', "");
    Expect(0, 120831, '\P{ 	In_math_ALPHANUM}', "");
    Expect(1, 120831, '\P{^ 	In_math_ALPHANUM}', "");
    Expect(0, 120832, '\p{ 	In_math_ALPHANUM}', "");
    Expect(1, 120832, '\p{^ 	In_math_ALPHANUM}', "");
    Expect(1, 120832, '\P{ 	In_math_ALPHANUM}', "");
    Expect(0, 120832, '\P{^ 	In_math_ALPHANUM}', "");
    Error('\p{:= Mathematical_Operators}');
    Error('\P{:= Mathematical_Operators}');
    Expect(1, 8959, '\p{mathematicaloperators}', "");
    Expect(0, 8959, '\p{^mathematicaloperators}', "");
    Expect(0, 8959, '\P{mathematicaloperators}', "");
    Expect(1, 8959, '\P{^mathematicaloperators}', "");
    Expect(0, 8960, '\p{mathematicaloperators}', "");
    Expect(1, 8960, '\p{^mathematicaloperators}', "");
    Expect(1, 8960, '\P{mathematicaloperators}', "");
    Expect(0, 8960, '\P{^mathematicaloperators}', "");
    Expect(1, 8959, '\p{-	Mathematical_OPERATORS}', "");
    Expect(0, 8959, '\p{^-	Mathematical_OPERATORS}', "");
    Expect(0, 8959, '\P{-	Mathematical_OPERATORS}', "");
    Expect(1, 8959, '\P{^-	Mathematical_OPERATORS}', "");
    Expect(0, 8960, '\p{-	Mathematical_OPERATORS}', "");
    Expect(1, 8960, '\p{^-	Mathematical_OPERATORS}', "");
    Expect(1, 8960, '\P{-	Mathematical_OPERATORS}', "");
    Expect(0, 8960, '\P{^-	Mathematical_OPERATORS}', "");
    Error('\p{/a/__is_MATHEMATICAL_operators}');
    Error('\P{/a/__is_MATHEMATICAL_operators}');
    Expect(1, 8959, '\p{ismathematicaloperators}', "");
    Expect(0, 8959, '\p{^ismathematicaloperators}', "");
    Expect(0, 8959, '\P{ismathematicaloperators}', "");
    Expect(1, 8959, '\P{^ismathematicaloperators}', "");
    Expect(0, 8960, '\p{ismathematicaloperators}', "");
    Expect(1, 8960, '\p{^ismathematicaloperators}', "");
    Expect(1, 8960, '\P{ismathematicaloperators}', "");
    Expect(0, 8960, '\P{^ismathematicaloperators}', "");
    Expect(1, 8959, '\p{-Is_Mathematical_Operators}', "");
    Expect(0, 8959, '\p{^-Is_Mathematical_Operators}', "");
    Expect(0, 8959, '\P{-Is_Mathematical_Operators}', "");
    Expect(1, 8959, '\P{^-Is_Mathematical_Operators}', "");
    Expect(0, 8960, '\p{-Is_Mathematical_Operators}', "");
    Expect(1, 8960, '\p{^-Is_Mathematical_Operators}', "");
    Expect(1, 8960, '\P{-Is_Mathematical_Operators}', "");
    Expect(0, 8960, '\P{^-Is_Mathematical_Operators}', "");
    Error('\p{-_In_Mathematical_Operators:=}');
    Error('\P{-_In_Mathematical_Operators:=}');
    Expect(1, 8959, '\p{inmathematicaloperators}', "");
    Expect(0, 8959, '\p{^inmathematicaloperators}', "");
    Expect(0, 8959, '\P{inmathematicaloperators}', "");
    Expect(1, 8959, '\P{^inmathematicaloperators}', "");
    Expect(0, 8960, '\p{inmathematicaloperators}', "");
    Expect(1, 8960, '\p{^inmathematicaloperators}', "");
    Expect(1, 8960, '\P{inmathematicaloperators}', "");
    Expect(0, 8960, '\P{^inmathematicaloperators}', "");
    Expect(1, 8959, '\p{- In_MATHEMATICAL_Operators}', "");
    Expect(0, 8959, '\p{^- In_MATHEMATICAL_Operators}', "");
    Expect(0, 8959, '\P{- In_MATHEMATICAL_Operators}', "");
    Expect(1, 8959, '\P{^- In_MATHEMATICAL_Operators}', "");
    Expect(0, 8960, '\p{- In_MATHEMATICAL_Operators}', "");
    Expect(1, 8960, '\p{^- In_MATHEMATICAL_Operators}', "");
    Expect(1, 8960, '\P{- In_MATHEMATICAL_Operators}', "");
    Expect(0, 8960, '\P{^- In_MATHEMATICAL_Operators}', "");
    Error('\p{/a/ _MATH_Operators}');
    Error('\P{/a/ _MATH_Operators}');
    Expect(1, 8959, '\p{mathoperators}', "");
    Expect(0, 8959, '\p{^mathoperators}', "");
    Expect(0, 8959, '\P{mathoperators}', "");
    Expect(1, 8959, '\P{^mathoperators}', "");
    Expect(0, 8960, '\p{mathoperators}', "");
    Expect(1, 8960, '\p{^mathoperators}', "");
    Expect(1, 8960, '\P{mathoperators}', "");
    Expect(0, 8960, '\P{^mathoperators}', "");
    Expect(1, 8959, '\p{-Math_Operators}', "");
    Expect(0, 8959, '\p{^-Math_Operators}', "");
    Expect(0, 8959, '\P{-Math_Operators}', "");
    Expect(1, 8959, '\P{^-Math_Operators}', "");
    Expect(0, 8960, '\p{-Math_Operators}', "");
    Expect(1, 8960, '\p{^-Math_Operators}', "");
    Expect(1, 8960, '\P{-Math_Operators}', "");
    Expect(0, 8960, '\P{^-Math_Operators}', "");
    Error('\p{ Is_MATH_Operators/a/}');
    Error('\P{ Is_MATH_Operators/a/}');
    Expect(1, 8959, '\p{ismathoperators}', "");
    Expect(0, 8959, '\p{^ismathoperators}', "");
    Expect(0, 8959, '\P{ismathoperators}', "");
    Expect(1, 8959, '\P{^ismathoperators}', "");
    Expect(0, 8960, '\p{ismathoperators}', "");
    Expect(1, 8960, '\p{^ismathoperators}', "");
    Expect(1, 8960, '\P{ismathoperators}', "");
    Expect(0, 8960, '\P{^ismathoperators}', "");
    Expect(1, 8959, '\p{ is_Math_operators}', "");
    Expect(0, 8959, '\p{^ is_Math_operators}', "");
    Expect(0, 8959, '\P{ is_Math_operators}', "");
    Expect(1, 8959, '\P{^ is_Math_operators}', "");
    Expect(0, 8960, '\p{ is_Math_operators}', "");
    Expect(1, 8960, '\p{^ is_Math_operators}', "");
    Expect(1, 8960, '\P{ is_Math_operators}', "");
    Expect(0, 8960, '\P{^ is_Math_operators}', "");
    Error('\p{-/a/In_Math_Operators}');
    Error('\P{-/a/In_Math_Operators}');
    Expect(1, 8959, '\p{inmathoperators}', "");
    Expect(0, 8959, '\p{^inmathoperators}', "");
    Expect(0, 8959, '\P{inmathoperators}', "");
    Expect(1, 8959, '\P{^inmathoperators}', "");
    Expect(0, 8960, '\p{inmathoperators}', "");
    Expect(1, 8960, '\p{^inmathoperators}', "");
    Expect(1, 8960, '\P{inmathoperators}', "");
    Expect(0, 8960, '\P{^inmathoperators}', "");
    Expect(1, 8959, '\p{	-in_math_Operators}', "");
    Expect(0, 8959, '\p{^	-in_math_Operators}', "");
    Expect(0, 8959, '\P{	-in_math_Operators}', "");
    Expect(1, 8959, '\P{^	-in_math_Operators}', "");
    Expect(0, 8960, '\p{	-in_math_Operators}', "");
    Expect(1, 8960, '\p{^	-in_math_Operators}', "");
    Expect(1, 8960, '\P{	-in_math_Operators}', "");
    Expect(0, 8960, '\P{^	-in_math_Operators}', "");
    Error('\p{/a/-_Mayan_NUMERALS}');
    Error('\P{/a/-_Mayan_NUMERALS}');
    Expect(1, 119551, '\p{mayannumerals}', "");
    Expect(0, 119551, '\p{^mayannumerals}', "");
    Expect(0, 119551, '\P{mayannumerals}', "");
    Expect(1, 119551, '\P{^mayannumerals}', "");
    Expect(0, 119552, '\p{mayannumerals}', "");
    Expect(1, 119552, '\p{^mayannumerals}', "");
    Expect(1, 119552, '\P{mayannumerals}', "");
    Expect(0, 119552, '\P{^mayannumerals}', "");
    Expect(1, 119551, '\p{	_Mayan_Numerals}', "");
    Expect(0, 119551, '\p{^	_Mayan_Numerals}', "");
    Expect(0, 119551, '\P{	_Mayan_Numerals}', "");
    Expect(1, 119551, '\P{^	_Mayan_Numerals}', "");
    Expect(0, 119552, '\p{	_Mayan_Numerals}', "");
    Expect(1, 119552, '\p{^	_Mayan_Numerals}', "");
    Expect(1, 119552, '\P{	_Mayan_Numerals}', "");
    Expect(0, 119552, '\P{^	_Mayan_Numerals}', "");
    Error('\p{	-is_mayan_NUMERALS:=}');
    Error('\P{	-is_mayan_NUMERALS:=}');
    Expect(1, 119551, '\p{ismayannumerals}', "");
    Expect(0, 119551, '\p{^ismayannumerals}', "");
    Expect(0, 119551, '\P{ismayannumerals}', "");
    Expect(1, 119551, '\P{^ismayannumerals}', "");
    Expect(0, 119552, '\p{ismayannumerals}', "");
    Expect(1, 119552, '\p{^ismayannumerals}', "");
    Expect(1, 119552, '\P{ismayannumerals}', "");
    Expect(0, 119552, '\P{^ismayannumerals}', "");
    Expect(1, 119551, '\p{ _IS_Mayan_Numerals}', "");
    Expect(0, 119551, '\p{^ _IS_Mayan_Numerals}', "");
    Expect(0, 119551, '\P{ _IS_Mayan_Numerals}', "");
    Expect(1, 119551, '\P{^ _IS_Mayan_Numerals}', "");
    Expect(0, 119552, '\p{ _IS_Mayan_Numerals}', "");
    Expect(1, 119552, '\p{^ _IS_Mayan_Numerals}', "");
    Expect(1, 119552, '\P{ _IS_Mayan_Numerals}', "");
    Expect(0, 119552, '\P{^ _IS_Mayan_Numerals}', "");
    Error('\p{/a/ _IN_Mayan_Numerals}');
    Error('\P{/a/ _IN_Mayan_Numerals}');
    Expect(1, 119551, '\p{inmayannumerals}', "");
    Expect(0, 119551, '\p{^inmayannumerals}', "");
    Expect(0, 119551, '\P{inmayannumerals}', "");
    Expect(1, 119551, '\P{^inmayannumerals}', "");
    Expect(0, 119552, '\p{inmayannumerals}', "");
    Expect(1, 119552, '\p{^inmayannumerals}', "");
    Expect(1, 119552, '\P{inmayannumerals}', "");
    Expect(0, 119552, '\P{^inmayannumerals}', "");
    Expect(1, 119551, '\p{ IN_Mayan_NUMERALS}', "");
    Expect(0, 119551, '\p{^ IN_Mayan_NUMERALS}', "");
    Expect(0, 119551, '\P{ IN_Mayan_NUMERALS}', "");
    Expect(1, 119551, '\P{^ IN_Mayan_NUMERALS}', "");
    Expect(0, 119552, '\p{ IN_Mayan_NUMERALS}', "");
    Expect(1, 119552, '\p{^ IN_Mayan_NUMERALS}', "");
    Expect(1, 119552, '\P{ IN_Mayan_NUMERALS}', "");
    Expect(0, 119552, '\P{^ IN_Mayan_NUMERALS}', "");
    Error('\p{ :=MEDEFAIDRIN}');
    Error('\P{ :=MEDEFAIDRIN}');
    Expect(1, 93850, '\p{medefaidrin}', "");
    Expect(0, 93850, '\p{^medefaidrin}', "");
    Expect(0, 93850, '\P{medefaidrin}', "");
    Expect(1, 93850, '\P{^medefaidrin}', "");
    Expect(0, 93851, '\p{medefaidrin}', "");
    Expect(1, 93851, '\p{^medefaidrin}', "");
    Expect(1, 93851, '\P{medefaidrin}', "");
    Expect(0, 93851, '\P{^medefaidrin}', "");
    Expect(1, 93850, '\p{ _medefaidrin}', "");
    Expect(0, 93850, '\p{^ _medefaidrin}', "");
    Expect(0, 93850, '\P{ _medefaidrin}', "");
    Expect(1, 93850, '\P{^ _medefaidrin}', "");
    Expect(0, 93851, '\p{ _medefaidrin}', "");
    Expect(1, 93851, '\p{^ _medefaidrin}', "");
    Expect(1, 93851, '\P{ _medefaidrin}', "");
    Expect(0, 93851, '\P{^ _medefaidrin}', "");
    Error('\p{Is_Medefaidrin:=}');
    Error('\P{Is_Medefaidrin:=}');
    Expect(1, 93850, '\p{ismedefaidrin}', "");
    Expect(0, 93850, '\p{^ismedefaidrin}', "");
    Expect(0, 93850, '\P{ismedefaidrin}', "");
    Expect(1, 93850, '\P{^ismedefaidrin}', "");
    Expect(0, 93851, '\p{ismedefaidrin}', "");
    Expect(1, 93851, '\p{^ismedefaidrin}', "");
    Expect(1, 93851, '\P{ismedefaidrin}', "");
    Expect(0, 93851, '\P{^ismedefaidrin}', "");
    Expect(1, 93850, '\p{-_IS_Medefaidrin}', "");
    Expect(0, 93850, '\p{^-_IS_Medefaidrin}', "");
    Expect(0, 93850, '\P{-_IS_Medefaidrin}', "");
    Expect(1, 93850, '\P{^-_IS_Medefaidrin}', "");
    Expect(0, 93851, '\p{-_IS_Medefaidrin}', "");
    Expect(1, 93851, '\p{^-_IS_Medefaidrin}', "");
    Expect(1, 93851, '\P{-_IS_Medefaidrin}', "");
    Expect(0, 93851, '\P{^-_IS_Medefaidrin}', "");
    Error('\p{:=__medf}');
    Error('\P{:=__medf}');
    Expect(1, 93850, '\p{medf}', "");
    Expect(0, 93850, '\p{^medf}', "");
    Expect(0, 93850, '\P{medf}', "");
    Expect(1, 93850, '\P{^medf}', "");
    Expect(0, 93851, '\p{medf}', "");
    Expect(1, 93851, '\p{^medf}', "");
    Expect(1, 93851, '\P{medf}', "");
    Expect(0, 93851, '\P{^medf}', "");
    Expect(1, 93850, '\p{ _medf}', "");
    Expect(0, 93850, '\p{^ _medf}', "");
    Expect(0, 93850, '\P{ _medf}', "");
    Expect(1, 93850, '\P{^ _medf}', "");
    Expect(0, 93851, '\p{ _medf}', "");
    Expect(1, 93851, '\p{^ _medf}', "");
    Expect(1, 93851, '\P{ _medf}', "");
    Expect(0, 93851, '\P{^ _medf}', "");
    Error('\p{:= -is_MEDF}');
    Error('\P{:= -is_MEDF}');
    Expect(1, 93850, '\p{ismedf}', "");
    Expect(0, 93850, '\p{^ismedf}', "");
    Expect(0, 93850, '\P{ismedf}', "");
    Expect(1, 93850, '\P{^ismedf}', "");
    Expect(0, 93851, '\p{ismedf}', "");
    Expect(1, 93851, '\p{^ismedf}', "");
    Expect(1, 93851, '\P{ismedf}', "");
    Expect(0, 93851, '\P{^ismedf}', "");
    Expect(1, 93850, '\p{_	Is_Medf}', "");
    Expect(0, 93850, '\p{^_	Is_Medf}', "");
    Expect(0, 93850, '\P{_	Is_Medf}', "");
    Expect(1, 93850, '\P{^_	Is_Medf}', "");
    Expect(0, 93851, '\p{_	Is_Medf}', "");
    Expect(1, 93851, '\p{^_	Is_Medf}', "");
    Expect(1, 93851, '\P{_	Is_Medf}', "");
    Expect(0, 93851, '\P{^_	Is_Medf}', "");
    Error('\p{:=MEETEI_Mayek}');
    Error('\P{:=MEETEI_Mayek}');
    Expect(1, 44025, '\p{meeteimayek}', "");
    Expect(0, 44025, '\p{^meeteimayek}', "");
    Expect(0, 44025, '\P{meeteimayek}', "");
    Expect(1, 44025, '\P{^meeteimayek}', "");
    Expect(0, 44026, '\p{meeteimayek}', "");
    Expect(1, 44026, '\p{^meeteimayek}', "");
    Expect(1, 44026, '\P{meeteimayek}', "");
    Expect(0, 44026, '\P{^meeteimayek}', "");
    Expect(1, 44025, '\p{	_MEETEI_Mayek}', "");
    Expect(0, 44025, '\p{^	_MEETEI_Mayek}', "");
    Expect(0, 44025, '\P{	_MEETEI_Mayek}', "");
    Expect(1, 44025, '\P{^	_MEETEI_Mayek}', "");
    Expect(0, 44026, '\p{	_MEETEI_Mayek}', "");
    Expect(1, 44026, '\p{^	_MEETEI_Mayek}', "");
    Expect(1, 44026, '\P{	_MEETEI_Mayek}', "");
    Expect(0, 44026, '\P{^	_MEETEI_Mayek}', "");
    Error('\p{:= 	IS_meetei_Mayek}');
    Error('\P{:= 	IS_meetei_Mayek}');
    Expect(1, 44025, '\p{ismeeteimayek}', "");
    Expect(0, 44025, '\p{^ismeeteimayek}', "");
    Expect(0, 44025, '\P{ismeeteimayek}', "");
    Expect(1, 44025, '\P{^ismeeteimayek}', "");
    Expect(0, 44026, '\p{ismeeteimayek}', "");
    Expect(1, 44026, '\p{^ismeeteimayek}', "");
    Expect(1, 44026, '\P{ismeeteimayek}', "");
    Expect(0, 44026, '\P{^ismeeteimayek}', "");
    Expect(1, 44025, '\p{_	IS_Meetei_Mayek}', "");
    Expect(0, 44025, '\p{^_	IS_Meetei_Mayek}', "");
    Expect(0, 44025, '\P{_	IS_Meetei_Mayek}', "");
    Expect(1, 44025, '\P{^_	IS_Meetei_Mayek}', "");
    Expect(0, 44026, '\p{_	IS_Meetei_Mayek}', "");
    Expect(1, 44026, '\p{^_	IS_Meetei_Mayek}', "");
    Expect(1, 44026, '\P{_	IS_Meetei_Mayek}', "");
    Expect(0, 44026, '\P{^_	IS_Meetei_Mayek}', "");
    Error('\p{	MTEI/a/}');
    Error('\P{	MTEI/a/}');
    Expect(1, 44025, '\p{mtei}', "");
    Expect(0, 44025, '\p{^mtei}', "");
    Expect(0, 44025, '\P{mtei}', "");
    Expect(1, 44025, '\P{^mtei}', "");
    Expect(0, 44026, '\p{mtei}', "");
    Expect(1, 44026, '\p{^mtei}', "");
    Expect(1, 44026, '\P{mtei}', "");
    Expect(0, 44026, '\P{^mtei}', "");
    Expect(1, 44025, '\p{	MTEI}', "");
    Expect(0, 44025, '\p{^	MTEI}', "");
    Expect(0, 44025, '\P{	MTEI}', "");
    Expect(1, 44025, '\P{^	MTEI}', "");
    Expect(0, 44026, '\p{	MTEI}', "");
    Expect(1, 44026, '\p{^	MTEI}', "");
    Expect(1, 44026, '\P{	MTEI}', "");
    Expect(0, 44026, '\P{^	MTEI}', "");
    Error('\p{_:=Is_MTEI}');
    Error('\P{_:=Is_MTEI}');
    Expect(1, 44025, '\p{ismtei}', "");
    Expect(0, 44025, '\p{^ismtei}', "");
    Expect(0, 44025, '\P{ismtei}', "");
    Expect(1, 44025, '\P{^ismtei}', "");
    Expect(0, 44026, '\p{ismtei}', "");
    Expect(1, 44026, '\p{^ismtei}', "");
    Expect(1, 44026, '\P{ismtei}', "");
    Expect(0, 44026, '\P{^ismtei}', "");
    Expect(1, 44025, '\p{_	Is_MTEI}', "");
    Expect(0, 44025, '\p{^_	Is_MTEI}', "");
    Expect(0, 44025, '\P{_	Is_MTEI}', "");
    Expect(1, 44025, '\P{^_	Is_MTEI}', "");
    Expect(0, 44026, '\p{_	Is_MTEI}', "");
    Expect(1, 44026, '\p{^_	Is_MTEI}', "");
    Expect(1, 44026, '\P{_	Is_MTEI}', "");
    Expect(0, 44026, '\P{^_	Is_MTEI}', "");
    Error('\p{__Meetei_Mayek_Extensions/a/}');
    Error('\P{__Meetei_Mayek_Extensions/a/}');
    Expect(1, 43775, '\p{meeteimayekextensions}', "");
    Expect(0, 43775, '\p{^meeteimayekextensions}', "");
    Expect(0, 43775, '\P{meeteimayekextensions}', "");
    Expect(1, 43775, '\P{^meeteimayekextensions}', "");
    Expect(0, 43776, '\p{meeteimayekextensions}', "");
    Expect(1, 43776, '\p{^meeteimayekextensions}', "");
    Expect(1, 43776, '\P{meeteimayekextensions}', "");
    Expect(0, 43776, '\P{^meeteimayekextensions}', "");
    Expect(1, 43775, '\p{	-Meetei_Mayek_Extensions}', "");
    Expect(0, 43775, '\p{^	-Meetei_Mayek_Extensions}', "");
    Expect(0, 43775, '\P{	-Meetei_Mayek_Extensions}', "");
    Expect(1, 43775, '\P{^	-Meetei_Mayek_Extensions}', "");
    Expect(0, 43776, '\p{	-Meetei_Mayek_Extensions}', "");
    Expect(1, 43776, '\p{^	-Meetei_Mayek_Extensions}', "");
    Expect(1, 43776, '\P{	-Meetei_Mayek_Extensions}', "");
    Expect(0, 43776, '\P{^	-Meetei_Mayek_Extensions}', "");
    Error('\p{	 is_Meetei_MAYEK_Extensions:=}');
    Error('\P{	 is_Meetei_MAYEK_Extensions:=}');
    Expect(1, 43775, '\p{ismeeteimayekextensions}', "");
    Expect(0, 43775, '\p{^ismeeteimayekextensions}', "");
    Expect(0, 43775, '\P{ismeeteimayekextensions}', "");
    Expect(1, 43775, '\P{^ismeeteimayekextensions}', "");
    Expect(0, 43776, '\p{ismeeteimayekextensions}', "");
    Expect(1, 43776, '\p{^ismeeteimayekextensions}', "");
    Expect(1, 43776, '\P{ismeeteimayekextensions}', "");
    Expect(0, 43776, '\P{^ismeeteimayekextensions}', "");
    Expect(1, 43775, '\p{ -Is_MEETEI_Mayek_Extensions}', "");
    Expect(0, 43775, '\p{^ -Is_MEETEI_Mayek_Extensions}', "");
    Expect(0, 43775, '\P{ -Is_MEETEI_Mayek_Extensions}', "");
    Expect(1, 43775, '\P{^ -Is_MEETEI_Mayek_Extensions}', "");
    Expect(0, 43776, '\p{ -Is_MEETEI_Mayek_Extensions}', "");
    Expect(1, 43776, '\p{^ -Is_MEETEI_Mayek_Extensions}', "");
    Expect(1, 43776, '\P{ -Is_MEETEI_Mayek_Extensions}', "");
    Expect(0, 43776, '\P{^ -Is_MEETEI_Mayek_Extensions}', "");
    Error('\p{ /a/IN_MEETEI_Mayek_EXTENSIONS}');
    Error('\P{ /a/IN_MEETEI_Mayek_EXTENSIONS}');
    Expect(1, 43775, '\p{inmeeteimayekextensions}', "");
    Expect(0, 43775, '\p{^inmeeteimayekextensions}', "");
    Expect(0, 43775, '\P{inmeeteimayekextensions}', "");
    Expect(1, 43775, '\P{^inmeeteimayekextensions}', "");
    Expect(0, 43776, '\p{inmeeteimayekextensions}', "");
    Expect(1, 43776, '\p{^inmeeteimayekextensions}', "");
    Expect(1, 43776, '\P{inmeeteimayekextensions}', "");
    Expect(0, 43776, '\P{^inmeeteimayekextensions}', "");
    Expect(1, 43775, '\p{ 	in_Meetei_Mayek_EXTENSIONS}', "");
    Expect(0, 43775, '\p{^ 	in_Meetei_Mayek_EXTENSIONS}', "");
    Expect(0, 43775, '\P{ 	in_Meetei_Mayek_EXTENSIONS}', "");
    Expect(1, 43775, '\P{^ 	in_Meetei_Mayek_EXTENSIONS}', "");
    Expect(0, 43776, '\p{ 	in_Meetei_Mayek_EXTENSIONS}', "");
    Expect(1, 43776, '\p{^ 	in_Meetei_Mayek_EXTENSIONS}', "");
    Expect(1, 43776, '\P{ 	in_Meetei_Mayek_EXTENSIONS}', "");
    Expect(0, 43776, '\P{^ 	in_Meetei_Mayek_EXTENSIONS}', "");
    Error('\p{_meetei_mayek_ext/a/}');
    Error('\P{_meetei_mayek_ext/a/}');
    Expect(1, 43775, '\p{meeteimayekext}', "");
    Expect(0, 43775, '\p{^meeteimayekext}', "");
    Expect(0, 43775, '\P{meeteimayekext}', "");
    Expect(1, 43775, '\P{^meeteimayekext}', "");
    Expect(0, 43776, '\p{meeteimayekext}', "");
    Expect(1, 43776, '\p{^meeteimayekext}', "");
    Expect(1, 43776, '\P{meeteimayekext}', "");
    Expect(0, 43776, '\P{^meeteimayekext}', "");
    Expect(1, 43775, '\p{ Meetei_Mayek_EXT}', "");
    Expect(0, 43775, '\p{^ Meetei_Mayek_EXT}', "");
    Expect(0, 43775, '\P{ Meetei_Mayek_EXT}', "");
    Expect(1, 43775, '\P{^ Meetei_Mayek_EXT}', "");
    Expect(0, 43776, '\p{ Meetei_Mayek_EXT}', "");
    Expect(1, 43776, '\p{^ Meetei_Mayek_EXT}', "");
    Expect(1, 43776, '\P{ Meetei_Mayek_EXT}', "");
    Expect(0, 43776, '\P{^ Meetei_Mayek_EXT}', "");
    Error('\p{		IS_Meetei_MAYEK_Ext/a/}');
    Error('\P{		IS_Meetei_MAYEK_Ext/a/}');
    Expect(1, 43775, '\p{ismeeteimayekext}', "");
    Expect(0, 43775, '\p{^ismeeteimayekext}', "");
    Expect(0, 43775, '\P{ismeeteimayekext}', "");
    Expect(1, 43775, '\P{^ismeeteimayekext}', "");
    Expect(0, 43776, '\p{ismeeteimayekext}', "");
    Expect(1, 43776, '\p{^ismeeteimayekext}', "");
    Expect(1, 43776, '\P{ismeeteimayekext}', "");
    Expect(0, 43776, '\P{^ismeeteimayekext}', "");
    Expect(1, 43775, '\p{ _Is_meetei_MAYEK_Ext}', "");
    Expect(0, 43775, '\p{^ _Is_meetei_MAYEK_Ext}', "");
    Expect(0, 43775, '\P{ _Is_meetei_MAYEK_Ext}', "");
    Expect(1, 43775, '\P{^ _Is_meetei_MAYEK_Ext}', "");
    Expect(0, 43776, '\p{ _Is_meetei_MAYEK_Ext}', "");
    Expect(1, 43776, '\p{^ _Is_meetei_MAYEK_Ext}', "");
    Expect(1, 43776, '\P{ _Is_meetei_MAYEK_Ext}', "");
    Expect(0, 43776, '\P{^ _Is_meetei_MAYEK_Ext}', "");
    Error('\p{ IN_meetei_mayek_Ext/a/}');
    Error('\P{ IN_meetei_mayek_Ext/a/}');
    Expect(1, 43775, '\p{inmeeteimayekext}', "");
    Expect(0, 43775, '\p{^inmeeteimayekext}', "");
    Expect(0, 43775, '\P{inmeeteimayekext}', "");
    Expect(1, 43775, '\P{^inmeeteimayekext}', "");
    Expect(0, 43776, '\p{inmeeteimayekext}', "");
    Expect(1, 43776, '\p{^inmeeteimayekext}', "");
    Expect(1, 43776, '\P{inmeeteimayekext}', "");
    Expect(0, 43776, '\P{^inmeeteimayekext}', "");
    Expect(1, 43775, '\p{_	in_Meetei_MAYEK_EXT}', "");
    Expect(0, 43775, '\p{^_	in_Meetei_MAYEK_EXT}', "");
    Expect(0, 43775, '\P{_	in_Meetei_MAYEK_EXT}', "");
    Expect(1, 43775, '\P{^_	in_Meetei_MAYEK_EXT}', "");
    Expect(0, 43776, '\p{_	in_Meetei_MAYEK_EXT}', "");
    Expect(1, 43776, '\p{^_	in_Meetei_MAYEK_EXT}', "");
    Expect(1, 43776, '\P{_	in_Meetei_MAYEK_EXT}', "");
    Expect(0, 43776, '\P{^_	in_Meetei_MAYEK_EXT}', "");
    Error('\p{/a/	_Mende_KIKAKUI}');
    Error('\P{/a/	_Mende_KIKAKUI}');
    Expect(1, 125142, '\p{mendekikakui}', "");
    Expect(0, 125142, '\p{^mendekikakui}', "");
    Expect(0, 125142, '\P{mendekikakui}', "");
    Expect(1, 125142, '\P{^mendekikakui}', "");
    Expect(0, 125143, '\p{mendekikakui}', "");
    Expect(1, 125143, '\p{^mendekikakui}', "");
    Expect(1, 125143, '\P{mendekikakui}', "");
    Expect(0, 125143, '\P{^mendekikakui}', "");
    Expect(1, 125142, '\p{ Mende_KIKAKUI}', "");
    Expect(0, 125142, '\p{^ Mende_KIKAKUI}', "");
    Expect(0, 125142, '\P{ Mende_KIKAKUI}', "");
    Expect(1, 125142, '\P{^ Mende_KIKAKUI}', "");
    Expect(0, 125143, '\p{ Mende_KIKAKUI}', "");
    Expect(1, 125143, '\p{^ Mende_KIKAKUI}', "");
    Expect(1, 125143, '\P{ Mende_KIKAKUI}', "");
    Expect(0, 125143, '\P{^ Mende_KIKAKUI}', "");
    Error('\p{-_Is_MENDE_Kikakui/a/}');
    Error('\P{-_Is_MENDE_Kikakui/a/}');
    Expect(1, 125142, '\p{ismendekikakui}', "");
    Expect(0, 125142, '\p{^ismendekikakui}', "");
    Expect(0, 125142, '\P{ismendekikakui}', "");
    Expect(1, 125142, '\P{^ismendekikakui}', "");
    Expect(0, 125143, '\p{ismendekikakui}', "");
    Expect(1, 125143, '\p{^ismendekikakui}', "");
    Expect(1, 125143, '\P{ismendekikakui}', "");
    Expect(0, 125143, '\P{^ismendekikakui}', "");
    Expect(1, 125142, '\p{ Is_MENDE_Kikakui}', "");
    Expect(0, 125142, '\p{^ Is_MENDE_Kikakui}', "");
    Expect(0, 125142, '\P{ Is_MENDE_Kikakui}', "");
    Expect(1, 125142, '\P{^ Is_MENDE_Kikakui}', "");
    Expect(0, 125143, '\p{ Is_MENDE_Kikakui}', "");
    Expect(1, 125143, '\p{^ Is_MENDE_Kikakui}', "");
    Expect(1, 125143, '\P{ Is_MENDE_Kikakui}', "");
    Expect(0, 125143, '\P{^ Is_MENDE_Kikakui}', "");
    Error('\p{	 Mend/a/}');
    Error('\P{	 Mend/a/}');
    Expect(1, 125142, '\p{mend}', "");
    Expect(0, 125142, '\p{^mend}', "");
    Expect(0, 125142, '\P{mend}', "");
    Expect(1, 125142, '\P{^mend}', "");
    Expect(0, 125143, '\p{mend}', "");
    Expect(1, 125143, '\p{^mend}', "");
    Expect(1, 125143, '\P{mend}', "");
    Expect(0, 125143, '\P{^mend}', "");
    Expect(1, 125142, '\p{ mend}', "");
    Expect(0, 125142, '\p{^ mend}', "");
    Expect(0, 125142, '\P{ mend}', "");
    Expect(1, 125142, '\P{^ mend}', "");
    Expect(0, 125143, '\p{ mend}', "");
    Expect(1, 125143, '\p{^ mend}', "");
    Expect(1, 125143, '\P{ mend}', "");
    Expect(0, 125143, '\P{^ mend}', "");
    Error('\p{ :=is_Mend}');
    Error('\P{ :=is_Mend}');
    Expect(1, 125142, '\p{ismend}', "");
    Expect(0, 125142, '\p{^ismend}', "");
    Expect(0, 125142, '\P{ismend}', "");
    Expect(1, 125142, '\P{^ismend}', "");
    Expect(0, 125143, '\p{ismend}', "");
    Expect(1, 125143, '\p{^ismend}', "");
    Expect(1, 125143, '\P{ismend}', "");
    Expect(0, 125143, '\P{^ismend}', "");
    Expect(1, 125142, '\p{_IS_Mend}', "");
    Expect(0, 125142, '\p{^_IS_Mend}', "");
    Expect(0, 125142, '\P{_IS_Mend}', "");
    Expect(1, 125142, '\P{^_IS_Mend}', "");
    Expect(0, 125143, '\p{_IS_Mend}', "");
    Expect(1, 125143, '\p{^_IS_Mend}', "");
    Expect(1, 125143, '\P{_IS_Mend}', "");
    Expect(0, 125143, '\P{^_IS_Mend}', "");
    Error('\p{	/a/MEROITIC_cursive}');
    Error('\P{	/a/MEROITIC_cursive}');
    Expect(1, 68095, '\p{meroiticcursive}', "");
    Expect(0, 68095, '\p{^meroiticcursive}', "");
    Expect(0, 68095, '\P{meroiticcursive}', "");
    Expect(1, 68095, '\P{^meroiticcursive}', "");
    Expect(0, 68096, '\p{meroiticcursive}', "");
    Expect(1, 68096, '\p{^meroiticcursive}', "");
    Expect(1, 68096, '\P{meroiticcursive}', "");
    Expect(0, 68096, '\P{^meroiticcursive}', "");
    Expect(1, 68095, '\p{meroitic_Cursive}', "");
    Expect(0, 68095, '\p{^meroitic_Cursive}', "");
    Expect(0, 68095, '\P{meroitic_Cursive}', "");
    Expect(1, 68095, '\P{^meroitic_Cursive}', "");
    Expect(0, 68096, '\p{meroitic_Cursive}', "");
    Expect(1, 68096, '\p{^meroitic_Cursive}', "");
    Expect(1, 68096, '\P{meroitic_Cursive}', "");
    Expect(0, 68096, '\P{^meroitic_Cursive}', "");
    Error('\p{/a/	 Is_meroitic_Cursive}');
    Error('\P{/a/	 Is_meroitic_Cursive}');
    Expect(1, 68095, '\p{ismeroiticcursive}', "");
    Expect(0, 68095, '\p{^ismeroiticcursive}', "");
    Expect(0, 68095, '\P{ismeroiticcursive}', "");
    Expect(1, 68095, '\P{^ismeroiticcursive}', "");
    Expect(0, 68096, '\p{ismeroiticcursive}', "");
    Expect(1, 68096, '\p{^ismeroiticcursive}', "");
    Expect(1, 68096, '\P{ismeroiticcursive}', "");
    Expect(0, 68096, '\P{^ismeroiticcursive}', "");
    Expect(1, 68095, '\p{ is_Meroitic_Cursive}', "");
    Expect(0, 68095, '\p{^ is_Meroitic_Cursive}', "");
    Expect(0, 68095, '\P{ is_Meroitic_Cursive}', "");
    Expect(1, 68095, '\P{^ is_Meroitic_Cursive}', "");
    Expect(0, 68096, '\p{ is_Meroitic_Cursive}', "");
    Expect(1, 68096, '\p{^ is_Meroitic_Cursive}', "");
    Expect(1, 68096, '\P{ is_Meroitic_Cursive}', "");
    Expect(0, 68096, '\P{^ is_Meroitic_Cursive}', "");
    Error('\p{/a/		MERC}');
    Error('\P{/a/		MERC}');
    Expect(1, 68095, '\p{merc}', "");
    Expect(0, 68095, '\p{^merc}', "");
    Expect(0, 68095, '\P{merc}', "");
    Expect(1, 68095, '\P{^merc}', "");
    Expect(0, 68096, '\p{merc}', "");
    Expect(1, 68096, '\p{^merc}', "");
    Expect(1, 68096, '\P{merc}', "");
    Expect(0, 68096, '\P{^merc}', "");
    Expect(1, 68095, '\p{ Merc}', "");
    Expect(0, 68095, '\p{^ Merc}', "");
    Expect(0, 68095, '\P{ Merc}', "");
    Expect(1, 68095, '\P{^ Merc}', "");
    Expect(0, 68096, '\p{ Merc}', "");
    Expect(1, 68096, '\p{^ Merc}', "");
    Expect(1, 68096, '\P{ Merc}', "");
    Expect(0, 68096, '\P{^ Merc}', "");
    Error('\p{_:=Is_MERC}');
    Error('\P{_:=Is_MERC}');
    Expect(1, 68095, '\p{ismerc}', "");
    Expect(0, 68095, '\p{^ismerc}', "");
    Expect(0, 68095, '\P{ismerc}', "");
    Expect(1, 68095, '\P{^ismerc}', "");
    Expect(0, 68096, '\p{ismerc}', "");
    Expect(1, 68096, '\p{^ismerc}', "");
    Expect(1, 68096, '\P{ismerc}', "");
    Expect(0, 68096, '\P{^ismerc}', "");
    Expect(1, 68095, '\p{ _IS_merc}', "");
    Expect(0, 68095, '\p{^ _IS_merc}', "");
    Expect(0, 68095, '\P{ _IS_merc}', "");
    Expect(1, 68095, '\P{^ _IS_merc}', "");
    Expect(0, 68096, '\p{ _IS_merc}', "");
    Expect(1, 68096, '\p{^ _IS_merc}', "");
    Expect(1, 68096, '\P{ _IS_merc}', "");
    Expect(0, 68096, '\P{^ _IS_merc}', "");
    Error('\p{-/a/Meroitic_hieroglyphs}');
    Error('\P{-/a/Meroitic_hieroglyphs}');
    Expect(1, 67999, '\p{meroitichieroglyphs}', "");
    Expect(0, 67999, '\p{^meroitichieroglyphs}', "");
    Expect(0, 67999, '\P{meroitichieroglyphs}', "");
    Expect(1, 67999, '\P{^meroitichieroglyphs}', "");
    Expect(0, 68000, '\p{meroitichieroglyphs}', "");
    Expect(1, 68000, '\p{^meroitichieroglyphs}', "");
    Expect(1, 68000, '\P{meroitichieroglyphs}', "");
    Expect(0, 68000, '\P{^meroitichieroglyphs}', "");
    Expect(1, 67999, '\p{- meroitic_hieroglyphs}', "");
    Expect(0, 67999, '\p{^- meroitic_hieroglyphs}', "");
    Expect(0, 67999, '\P{- meroitic_hieroglyphs}', "");
    Expect(1, 67999, '\P{^- meroitic_hieroglyphs}', "");
    Expect(0, 68000, '\p{- meroitic_hieroglyphs}', "");
    Expect(1, 68000, '\p{^- meroitic_hieroglyphs}', "");
    Expect(1, 68000, '\P{- meroitic_hieroglyphs}', "");
    Expect(0, 68000, '\P{^- meroitic_hieroglyphs}', "");
    Error('\p{_:=Is_Meroitic_Hieroglyphs}');
    Error('\P{_:=Is_Meroitic_Hieroglyphs}');
    Expect(1, 67999, '\p{ismeroitichieroglyphs}', "");
    Expect(0, 67999, '\p{^ismeroitichieroglyphs}', "");
    Expect(0, 67999, '\P{ismeroitichieroglyphs}', "");
    Expect(1, 67999, '\P{^ismeroitichieroglyphs}', "");
    Expect(0, 68000, '\p{ismeroitichieroglyphs}', "");
    Expect(1, 68000, '\p{^ismeroitichieroglyphs}', "");
    Expect(1, 68000, '\P{ismeroitichieroglyphs}', "");
    Expect(0, 68000, '\P{^ismeroitichieroglyphs}', "");
    Expect(1, 67999, '\p{__Is_Meroitic_hieroglyphs}', "");
    Expect(0, 67999, '\p{^__Is_Meroitic_hieroglyphs}', "");
    Expect(0, 67999, '\P{__Is_Meroitic_hieroglyphs}', "");
    Expect(1, 67999, '\P{^__Is_Meroitic_hieroglyphs}', "");
    Expect(0, 68000, '\p{__Is_Meroitic_hieroglyphs}', "");
    Expect(1, 68000, '\p{^__Is_Meroitic_hieroglyphs}', "");
    Expect(1, 68000, '\P{__Is_Meroitic_hieroglyphs}', "");
    Expect(0, 68000, '\P{^__Is_Meroitic_hieroglyphs}', "");
    Error('\p{:=	-mero}');
    Error('\P{:=	-mero}');
    Expect(1, 67999, '\p{mero}', "");
    Expect(0, 67999, '\p{^mero}', "");
    Expect(0, 67999, '\P{mero}', "");
    Expect(1, 67999, '\P{^mero}', "");
    Expect(0, 68000, '\p{mero}', "");
    Expect(1, 68000, '\p{^mero}', "");
    Expect(1, 68000, '\P{mero}', "");
    Expect(0, 68000, '\P{^mero}', "");
    Expect(1, 67999, '\p{__mero}', "");
    Expect(0, 67999, '\p{^__mero}', "");
    Expect(0, 67999, '\P{__mero}', "");
    Expect(1, 67999, '\P{^__mero}', "");
    Expect(0, 68000, '\p{__mero}', "");
    Expect(1, 68000, '\p{^__mero}', "");
    Expect(1, 68000, '\P{__mero}', "");
    Expect(0, 68000, '\P{^__mero}', "");
    Error('\p{	IS_MERO:=}');
    Error('\P{	IS_MERO:=}');
    Expect(1, 67999, '\p{ismero}', "");
    Expect(0, 67999, '\p{^ismero}', "");
    Expect(0, 67999, '\P{ismero}', "");
    Expect(1, 67999, '\P{^ismero}', "");
    Expect(0, 68000, '\p{ismero}', "");
    Expect(1, 68000, '\p{^ismero}', "");
    Expect(1, 68000, '\P{ismero}', "");
    Expect(0, 68000, '\P{^ismero}', "");
    Expect(1, 67999, '\p{-is_mero}', "");
    Expect(0, 67999, '\p{^-is_mero}', "");
    Expect(0, 67999, '\P{-is_mero}', "");
    Expect(1, 67999, '\P{^-is_mero}', "");
    Expect(0, 68000, '\p{-is_mero}', "");
    Expect(1, 68000, '\p{^-is_mero}', "");
    Expect(1, 68000, '\P{-is_mero}', "");
    Expect(0, 68000, '\P{^-is_mero}', "");
    Error('\p{ /a/Miao}');
    Error('\P{ /a/Miao}');
    Expect(1, 94111, '\p{miao}', "");
    Expect(0, 94111, '\p{^miao}', "");
    Expect(0, 94111, '\P{miao}', "");
    Expect(1, 94111, '\P{^miao}', "");
    Expect(0, 94112, '\p{miao}', "");
    Expect(1, 94112, '\p{^miao}', "");
    Expect(1, 94112, '\P{miao}', "");
    Expect(0, 94112, '\P{^miao}', "");
    Expect(1, 94111, '\p{ -Miao}', "");
    Expect(0, 94111, '\p{^ -Miao}', "");
    Expect(0, 94111, '\P{ -Miao}', "");
    Expect(1, 94111, '\P{^ -Miao}', "");
    Expect(0, 94112, '\p{ -Miao}', "");
    Expect(1, 94112, '\p{^ -Miao}', "");
    Expect(1, 94112, '\P{ -Miao}', "");
    Expect(0, 94112, '\P{^ -Miao}', "");
    Error('\p{ :=Is_miao}');
    Error('\P{ :=Is_miao}');
    Expect(1, 94111, '\p{ismiao}', "");
    Expect(0, 94111, '\p{^ismiao}', "");
    Expect(0, 94111, '\P{ismiao}', "");
    Expect(1, 94111, '\P{^ismiao}', "");
    Expect(0, 94112, '\p{ismiao}', "");
    Expect(1, 94112, '\p{^ismiao}', "");
    Expect(1, 94112, '\P{ismiao}', "");
    Expect(0, 94112, '\P{^ismiao}', "");
    Expect(1, 94111, '\p{_-Is_MIAO}', "");
    Expect(0, 94111, '\p{^_-Is_MIAO}', "");
    Expect(0, 94111, '\P{_-Is_MIAO}', "");
    Expect(1, 94111, '\P{^_-Is_MIAO}', "");
    Expect(0, 94112, '\p{_-Is_MIAO}', "");
    Expect(1, 94112, '\p{^_-Is_MIAO}', "");
    Expect(1, 94112, '\P{_-Is_MIAO}', "");
    Expect(0, 94112, '\P{^_-Is_MIAO}', "");
    Error('\p{	/a/Plrd}');
    Error('\P{	/a/Plrd}');
    Expect(1, 94111, '\p{plrd}', "");
    Expect(0, 94111, '\p{^plrd}', "");
    Expect(0, 94111, '\P{plrd}', "");
    Expect(1, 94111, '\P{^plrd}', "");
    Expect(0, 94112, '\p{plrd}', "");
    Expect(1, 94112, '\p{^plrd}', "");
    Expect(1, 94112, '\P{plrd}', "");
    Expect(0, 94112, '\P{^plrd}', "");
    Expect(1, 94111, '\p{ Plrd}', "");
    Expect(0, 94111, '\p{^ Plrd}', "");
    Expect(0, 94111, '\P{ Plrd}', "");
    Expect(1, 94111, '\P{^ Plrd}', "");
    Expect(0, 94112, '\p{ Plrd}', "");
    Expect(1, 94112, '\p{^ Plrd}', "");
    Expect(1, 94112, '\P{ Plrd}', "");
    Expect(0, 94112, '\P{^ Plrd}', "");
    Error('\p{/a/_-is_Plrd}');
    Error('\P{/a/_-is_Plrd}');
    Expect(1, 94111, '\p{isplrd}', "");
    Expect(0, 94111, '\p{^isplrd}', "");
    Expect(0, 94111, '\P{isplrd}', "");
    Expect(1, 94111, '\P{^isplrd}', "");
    Expect(0, 94112, '\p{isplrd}', "");
    Expect(1, 94112, '\p{^isplrd}', "");
    Expect(1, 94112, '\P{isplrd}', "");
    Expect(0, 94112, '\P{^isplrd}', "");
    Expect(1, 94111, '\p{__is_Plrd}', "");
    Expect(0, 94111, '\p{^__is_Plrd}', "");
    Expect(0, 94111, '\P{__is_Plrd}', "");
    Expect(1, 94111, '\P{^__is_Plrd}', "");
    Expect(0, 94112, '\p{__is_Plrd}', "");
    Expect(1, 94112, '\p{^__is_Plrd}', "");
    Expect(1, 94112, '\P{__is_Plrd}', "");
    Expect(0, 94112, '\P{^__is_Plrd}', "");
    Error('\p{:=Miscellaneous_MATHEMATICAL_Symbols_A}');
    Error('\P{:=Miscellaneous_MATHEMATICAL_Symbols_A}');
    Expect(1, 10223, '\p{miscellaneousmathematicalsymbolsa}', "");
    Expect(0, 10223, '\p{^miscellaneousmathematicalsymbolsa}', "");
    Expect(0, 10223, '\P{miscellaneousmathematicalsymbolsa}', "");
    Expect(1, 10223, '\P{^miscellaneousmathematicalsymbolsa}', "");
    Expect(0, 10224, '\p{miscellaneousmathematicalsymbolsa}', "");
    Expect(1, 10224, '\p{^miscellaneousmathematicalsymbolsa}', "");
    Expect(1, 10224, '\P{miscellaneousmathematicalsymbolsa}', "");
    Expect(0, 10224, '\P{^miscellaneousmathematicalsymbolsa}', "");
    Expect(1, 10223, '\p{_-Miscellaneous_Mathematical_symbols_a}', "");
    Expect(0, 10223, '\p{^_-Miscellaneous_Mathematical_symbols_a}', "");
    Expect(0, 10223, '\P{_-Miscellaneous_Mathematical_symbols_a}', "");
    Expect(1, 10223, '\P{^_-Miscellaneous_Mathematical_symbols_a}', "");
    Expect(0, 10224, '\p{_-Miscellaneous_Mathematical_symbols_a}', "");
    Expect(1, 10224, '\p{^_-Miscellaneous_Mathematical_symbols_a}', "");
    Expect(1, 10224, '\P{_-Miscellaneous_Mathematical_symbols_a}', "");
    Expect(0, 10224, '\P{^_-Miscellaneous_Mathematical_symbols_a}', "");
    Error('\p{:=-IS_MISCELLANEOUS_Mathematical_symbols_a}');
    Error('\P{:=-IS_MISCELLANEOUS_Mathematical_symbols_a}');
    Expect(1, 10223, '\p{ismiscellaneousmathematicalsymbolsa}', "");
    Expect(0, 10223, '\p{^ismiscellaneousmathematicalsymbolsa}', "");
    Expect(0, 10223, '\P{ismiscellaneousmathematicalsymbolsa}', "");
    Expect(1, 10223, '\P{^ismiscellaneousmathematicalsymbolsa}', "");
    Expect(0, 10224, '\p{ismiscellaneousmathematicalsymbolsa}', "");
    Expect(1, 10224, '\p{^ismiscellaneousmathematicalsymbolsa}', "");
    Expect(1, 10224, '\P{ismiscellaneousmathematicalsymbolsa}', "");
    Expect(0, 10224, '\P{^ismiscellaneousmathematicalsymbolsa}', "");
    Expect(1, 10223, '\p{__is_Miscellaneous_Mathematical_Symbols_A}', "");
    Expect(0, 10223, '\p{^__is_Miscellaneous_Mathematical_Symbols_A}', "");
    Expect(0, 10223, '\P{__is_Miscellaneous_Mathematical_Symbols_A}', "");
    Expect(1, 10223, '\P{^__is_Miscellaneous_Mathematical_Symbols_A}', "");
    Expect(0, 10224, '\p{__is_Miscellaneous_Mathematical_Symbols_A}', "");
    Expect(1, 10224, '\p{^__is_Miscellaneous_Mathematical_Symbols_A}', "");
    Expect(1, 10224, '\P{__is_Miscellaneous_Mathematical_Symbols_A}', "");
    Expect(0, 10224, '\P{^__is_Miscellaneous_Mathematical_Symbols_A}', "");
    Error('\p{	/a/In_Miscellaneous_MATHEMATICAL_Symbols_A}');
    Error('\P{	/a/In_Miscellaneous_MATHEMATICAL_Symbols_A}');
    Expect(1, 10223, '\p{inmiscellaneousmathematicalsymbolsa}', "");
    Expect(0, 10223, '\p{^inmiscellaneousmathematicalsymbolsa}', "");
    Expect(0, 10223, '\P{inmiscellaneousmathematicalsymbolsa}', "");
    Expect(1, 10223, '\P{^inmiscellaneousmathematicalsymbolsa}', "");
    Expect(0, 10224, '\p{inmiscellaneousmathematicalsymbolsa}', "");
    Expect(1, 10224, '\p{^inmiscellaneousmathematicalsymbolsa}', "");
    Expect(1, 10224, '\P{inmiscellaneousmathematicalsymbolsa}', "");
    Expect(0, 10224, '\P{^inmiscellaneousmathematicalsymbolsa}', "");
    Expect(1, 10223, '\p{--In_Miscellaneous_Mathematical_Symbols_a}', "");
    Expect(0, 10223, '\p{^--In_Miscellaneous_Mathematical_Symbols_a}', "");
    Expect(0, 10223, '\P{--In_Miscellaneous_Mathematical_Symbols_a}', "");
    Expect(1, 10223, '\P{^--In_Miscellaneous_Mathematical_Symbols_a}', "");
    Expect(0, 10224, '\p{--In_Miscellaneous_Mathematical_Symbols_a}', "");
    Expect(1, 10224, '\p{^--In_Miscellaneous_Mathematical_Symbols_a}', "");
    Expect(1, 10224, '\P{--In_Miscellaneous_Mathematical_Symbols_a}', "");
    Expect(0, 10224, '\P{^--In_Miscellaneous_Mathematical_Symbols_a}', "");
    Error('\p{  Misc_math_Symbols_A/a/}');
    Error('\P{  Misc_math_Symbols_A/a/}');
    Expect(1, 10223, '\p{miscmathsymbolsa}', "");
    Expect(0, 10223, '\p{^miscmathsymbolsa}', "");
    Expect(0, 10223, '\P{miscmathsymbolsa}', "");
    Expect(1, 10223, '\P{^miscmathsymbolsa}', "");
    Expect(0, 10224, '\p{miscmathsymbolsa}', "");
    Expect(1, 10224, '\p{^miscmathsymbolsa}', "");
    Expect(1, 10224, '\P{miscmathsymbolsa}', "");
    Expect(0, 10224, '\P{^miscmathsymbolsa}', "");
    Expect(1, 10223, '\p{MISC_MATH_Symbols_A}', "");
    Expect(0, 10223, '\p{^MISC_MATH_Symbols_A}', "");
    Expect(0, 10223, '\P{MISC_MATH_Symbols_A}', "");
    Expect(1, 10223, '\P{^MISC_MATH_Symbols_A}', "");
    Expect(0, 10224, '\p{MISC_MATH_Symbols_A}', "");
    Expect(1, 10224, '\p{^MISC_MATH_Symbols_A}', "");
    Expect(1, 10224, '\P{MISC_MATH_Symbols_A}', "");
    Expect(0, 10224, '\P{^MISC_MATH_Symbols_A}', "");
    Error('\p{/a/-_is_misc_Math_Symbols_A}');
    Error('\P{/a/-_is_misc_Math_Symbols_A}');
    Expect(1, 10223, '\p{ismiscmathsymbolsa}', "");
    Expect(0, 10223, '\p{^ismiscmathsymbolsa}', "");
    Expect(0, 10223, '\P{ismiscmathsymbolsa}', "");
    Expect(1, 10223, '\P{^ismiscmathsymbolsa}', "");
    Expect(0, 10224, '\p{ismiscmathsymbolsa}', "");
    Expect(1, 10224, '\p{^ismiscmathsymbolsa}', "");
    Expect(1, 10224, '\P{ismiscmathsymbolsa}', "");
    Expect(0, 10224, '\P{^ismiscmathsymbolsa}', "");
    Expect(1, 10223, '\p{ IS_MISC_MATH_SYMBOLS_A}', "");
    Expect(0, 10223, '\p{^ IS_MISC_MATH_SYMBOLS_A}', "");
    Expect(0, 10223, '\P{ IS_MISC_MATH_SYMBOLS_A}', "");
    Expect(1, 10223, '\P{^ IS_MISC_MATH_SYMBOLS_A}', "");
    Expect(0, 10224, '\p{ IS_MISC_MATH_SYMBOLS_A}', "");
    Expect(1, 10224, '\p{^ IS_MISC_MATH_SYMBOLS_A}', "");
    Expect(1, 10224, '\P{ IS_MISC_MATH_SYMBOLS_A}', "");
    Expect(0, 10224, '\P{^ IS_MISC_MATH_SYMBOLS_A}', "");
    Error('\p{- In_misc_math_symbols_A:=}');
    Error('\P{- In_misc_math_symbols_A:=}');
    Expect(1, 10223, '\p{inmiscmathsymbolsa}', "");
    Expect(0, 10223, '\p{^inmiscmathsymbolsa}', "");
    Expect(0, 10223, '\P{inmiscmathsymbolsa}', "");
    Expect(1, 10223, '\P{^inmiscmathsymbolsa}', "");
    Expect(0, 10224, '\p{inmiscmathsymbolsa}', "");
    Expect(1, 10224, '\p{^inmiscmathsymbolsa}', "");
    Expect(1, 10224, '\P{inmiscmathsymbolsa}', "");
    Expect(0, 10224, '\P{^inmiscmathsymbolsa}', "");
    Expect(1, 10223, '\p{ -IN_Misc_Math_symbols_A}', "");
    Expect(0, 10223, '\p{^ -IN_Misc_Math_symbols_A}', "");
    Expect(0, 10223, '\P{ -IN_Misc_Math_symbols_A}', "");
    Expect(1, 10223, '\P{^ -IN_Misc_Math_symbols_A}', "");
    Expect(0, 10224, '\p{ -IN_Misc_Math_symbols_A}', "");
    Expect(1, 10224, '\p{^ -IN_Misc_Math_symbols_A}', "");
    Expect(1, 10224, '\P{ -IN_Misc_Math_symbols_A}', "");
    Expect(0, 10224, '\P{^ -IN_Misc_Math_symbols_A}', "");
    Error('\p{/a/ -miscellaneous_MATHEMATICAL_Symbols_b}');
    Error('\P{/a/ -miscellaneous_MATHEMATICAL_Symbols_b}');
    Expect(1, 10751, '\p{miscellaneousmathematicalsymbolsb}', "");
    Expect(0, 10751, '\p{^miscellaneousmathematicalsymbolsb}', "");
    Expect(0, 10751, '\P{miscellaneousmathematicalsymbolsb}', "");
    Expect(1, 10751, '\P{^miscellaneousmathematicalsymbolsb}', "");
    Expect(0, 10752, '\p{miscellaneousmathematicalsymbolsb}', "");
    Expect(1, 10752, '\p{^miscellaneousmathematicalsymbolsb}', "");
    Expect(1, 10752, '\P{miscellaneousmathematicalsymbolsb}', "");
    Expect(0, 10752, '\P{^miscellaneousmathematicalsymbolsb}', "");
    Expect(1, 10751, '\p{	-Miscellaneous_mathematical_symbols_B}', "");
    Expect(0, 10751, '\p{^	-Miscellaneous_mathematical_symbols_B}', "");
    Expect(0, 10751, '\P{	-Miscellaneous_mathematical_symbols_B}', "");
    Expect(1, 10751, '\P{^	-Miscellaneous_mathematical_symbols_B}', "");
    Expect(0, 10752, '\p{	-Miscellaneous_mathematical_symbols_B}', "");
    Expect(1, 10752, '\p{^	-Miscellaneous_mathematical_symbols_B}', "");
    Expect(1, 10752, '\P{	-Miscellaneous_mathematical_symbols_B}', "");
    Expect(0, 10752, '\P{^	-Miscellaneous_mathematical_symbols_B}', "");
    Error('\p{/a/-Is_miscellaneous_MATHEMATICAL_Symbols_B}');
    Error('\P{/a/-Is_miscellaneous_MATHEMATICAL_Symbols_B}');
    Expect(1, 10751, '\p{ismiscellaneousmathematicalsymbolsb}', "");
    Expect(0, 10751, '\p{^ismiscellaneousmathematicalsymbolsb}', "");
    Expect(0, 10751, '\P{ismiscellaneousmathematicalsymbolsb}', "");
    Expect(1, 10751, '\P{^ismiscellaneousmathematicalsymbolsb}', "");
    Expect(0, 10752, '\p{ismiscellaneousmathematicalsymbolsb}', "");
    Expect(1, 10752, '\p{^ismiscellaneousmathematicalsymbolsb}', "");
    Expect(1, 10752, '\P{ismiscellaneousmathematicalsymbolsb}', "");
    Expect(0, 10752, '\P{^ismiscellaneousmathematicalsymbolsb}', "");
    Expect(1, 10751, '\p{ _Is_MISCELLANEOUS_Mathematical_Symbols_B}', "");
    Expect(0, 10751, '\p{^ _Is_MISCELLANEOUS_Mathematical_Symbols_B}', "");
    Expect(0, 10751, '\P{ _Is_MISCELLANEOUS_Mathematical_Symbols_B}', "");
    Expect(1, 10751, '\P{^ _Is_MISCELLANEOUS_Mathematical_Symbols_B}', "");
    Expect(0, 10752, '\p{ _Is_MISCELLANEOUS_Mathematical_Symbols_B}', "");
    Expect(1, 10752, '\p{^ _Is_MISCELLANEOUS_Mathematical_Symbols_B}', "");
    Expect(1, 10752, '\P{ _Is_MISCELLANEOUS_Mathematical_Symbols_B}', "");
    Expect(0, 10752, '\P{^ _Is_MISCELLANEOUS_Mathematical_Symbols_B}', "");
    Error('\p{-:=IN_Miscellaneous_Mathematical_Symbols_B}');
    Error('\P{-:=IN_Miscellaneous_Mathematical_Symbols_B}');
    Expect(1, 10751, '\p{inmiscellaneousmathematicalsymbolsb}', "");
    Expect(0, 10751, '\p{^inmiscellaneousmathematicalsymbolsb}', "");
    Expect(0, 10751, '\P{inmiscellaneousmathematicalsymbolsb}', "");
    Expect(1, 10751, '\P{^inmiscellaneousmathematicalsymbolsb}', "");
    Expect(0, 10752, '\p{inmiscellaneousmathematicalsymbolsb}', "");
    Expect(1, 10752, '\p{^inmiscellaneousmathematicalsymbolsb}', "");
    Expect(1, 10752, '\P{inmiscellaneousmathematicalsymbolsb}', "");
    Expect(0, 10752, '\P{^inmiscellaneousmathematicalsymbolsb}', "");
    Expect(1, 10751, '\p{-In_miscellaneous_Mathematical_SYMBOLS_b}', "");
    Expect(0, 10751, '\p{^-In_miscellaneous_Mathematical_SYMBOLS_b}', "");
    Expect(0, 10751, '\P{-In_miscellaneous_Mathematical_SYMBOLS_b}', "");
    Expect(1, 10751, '\P{^-In_miscellaneous_Mathematical_SYMBOLS_b}', "");
    Expect(0, 10752, '\p{-In_miscellaneous_Mathematical_SYMBOLS_b}', "");
    Expect(1, 10752, '\p{^-In_miscellaneous_Mathematical_SYMBOLS_b}', "");
    Expect(1, 10752, '\P{-In_miscellaneous_Mathematical_SYMBOLS_b}', "");
    Expect(0, 10752, '\P{^-In_miscellaneous_Mathematical_SYMBOLS_b}', "");
    Error('\p{ -Misc_math_Symbols_B/a/}');
    Error('\P{ -Misc_math_Symbols_B/a/}');
    Expect(1, 10751, '\p{miscmathsymbolsb}', "");
    Expect(0, 10751, '\p{^miscmathsymbolsb}', "");
    Expect(0, 10751, '\P{miscmathsymbolsb}', "");
    Expect(1, 10751, '\P{^miscmathsymbolsb}', "");
    Expect(0, 10752, '\p{miscmathsymbolsb}', "");
    Expect(1, 10752, '\p{^miscmathsymbolsb}', "");
    Expect(1, 10752, '\P{miscmathsymbolsb}', "");
    Expect(0, 10752, '\P{^miscmathsymbolsb}', "");
    Expect(1, 10751, '\p{- Misc_Math_Symbols_B}', "");
    Expect(0, 10751, '\p{^- Misc_Math_Symbols_B}', "");
    Expect(0, 10751, '\P{- Misc_Math_Symbols_B}', "");
    Expect(1, 10751, '\P{^- Misc_Math_Symbols_B}', "");
    Expect(0, 10752, '\p{- Misc_Math_Symbols_B}', "");
    Expect(1, 10752, '\p{^- Misc_Math_Symbols_B}', "");
    Expect(1, 10752, '\P{- Misc_Math_Symbols_B}', "");
    Expect(0, 10752, '\P{^- Misc_Math_Symbols_B}', "");
    Error('\p{:=	Is_MISC_MATH_Symbols_B}');
    Error('\P{:=	Is_MISC_MATH_Symbols_B}');
    Expect(1, 10751, '\p{ismiscmathsymbolsb}', "");
    Expect(0, 10751, '\p{^ismiscmathsymbolsb}', "");
    Expect(0, 10751, '\P{ismiscmathsymbolsb}', "");
    Expect(1, 10751, '\P{^ismiscmathsymbolsb}', "");
    Expect(0, 10752, '\p{ismiscmathsymbolsb}', "");
    Expect(1, 10752, '\p{^ismiscmathsymbolsb}', "");
    Expect(1, 10752, '\P{ismiscmathsymbolsb}', "");
    Expect(0, 10752, '\P{^ismiscmathsymbolsb}', "");
    Expect(1, 10751, '\p{ 	IS_misc_MATH_Symbols_B}', "");
    Expect(0, 10751, '\p{^ 	IS_misc_MATH_Symbols_B}', "");
    Expect(0, 10751, '\P{ 	IS_misc_MATH_Symbols_B}', "");
    Expect(1, 10751, '\P{^ 	IS_misc_MATH_Symbols_B}', "");
    Expect(0, 10752, '\p{ 	IS_misc_MATH_Symbols_B}', "");
    Expect(1, 10752, '\p{^ 	IS_misc_MATH_Symbols_B}', "");
    Expect(1, 10752, '\P{ 	IS_misc_MATH_Symbols_B}', "");
    Expect(0, 10752, '\P{^ 	IS_misc_MATH_Symbols_B}', "");
    Error('\p{/a/-	In_Misc_Math_symbols_B}');
    Error('\P{/a/-	In_Misc_Math_symbols_B}');
    Expect(1, 10751, '\p{inmiscmathsymbolsb}', "");
    Expect(0, 10751, '\p{^inmiscmathsymbolsb}', "");
    Expect(0, 10751, '\P{inmiscmathsymbolsb}', "");
    Expect(1, 10751, '\P{^inmiscmathsymbolsb}', "");
    Expect(0, 10752, '\p{inmiscmathsymbolsb}', "");
    Expect(1, 10752, '\p{^inmiscmathsymbolsb}', "");
    Expect(1, 10752, '\P{inmiscmathsymbolsb}', "");
    Expect(0, 10752, '\P{^inmiscmathsymbolsb}', "");
    Expect(1, 10751, '\p{  In_MISC_Math_Symbols_B}', "");
    Expect(0, 10751, '\p{^  In_MISC_Math_Symbols_B}', "");
    Expect(0, 10751, '\P{  In_MISC_Math_Symbols_B}', "");
    Expect(1, 10751, '\P{^  In_MISC_Math_Symbols_B}', "");
    Expect(0, 10752, '\p{  In_MISC_Math_Symbols_B}', "");
    Expect(1, 10752, '\p{^  In_MISC_Math_Symbols_B}', "");
    Expect(1, 10752, '\P{  In_MISC_Math_Symbols_B}', "");
    Expect(0, 10752, '\P{^  In_MISC_Math_Symbols_B}', "");
    Error('\p{ 	Miscellaneous_symbols/a/}');
    Error('\P{ 	Miscellaneous_symbols/a/}');
    Expect(1, 9983, '\p{miscellaneoussymbols}', "");
    Expect(0, 9983, '\p{^miscellaneoussymbols}', "");
    Expect(0, 9983, '\P{miscellaneoussymbols}', "");
    Expect(1, 9983, '\P{^miscellaneoussymbols}', "");
    Expect(0, 9984, '\p{miscellaneoussymbols}', "");
    Expect(1, 9984, '\p{^miscellaneoussymbols}', "");
    Expect(1, 9984, '\P{miscellaneoussymbols}', "");
    Expect(0, 9984, '\P{^miscellaneoussymbols}', "");
    Expect(1, 9983, '\p{_Miscellaneous_Symbols}', "");
    Expect(0, 9983, '\p{^_Miscellaneous_Symbols}', "");
    Expect(0, 9983, '\P{_Miscellaneous_Symbols}', "");
    Expect(1, 9983, '\P{^_Miscellaneous_Symbols}', "");
    Expect(0, 9984, '\p{_Miscellaneous_Symbols}', "");
    Expect(1, 9984, '\p{^_Miscellaneous_Symbols}', "");
    Expect(1, 9984, '\P{_Miscellaneous_Symbols}', "");
    Expect(0, 9984, '\P{^_Miscellaneous_Symbols}', "");
    Error('\p{/a/  IS_miscellaneous_symbols}');
    Error('\P{/a/  IS_miscellaneous_symbols}');
    Expect(1, 9983, '\p{ismiscellaneoussymbols}', "");
    Expect(0, 9983, '\p{^ismiscellaneoussymbols}', "");
    Expect(0, 9983, '\P{ismiscellaneoussymbols}', "");
    Expect(1, 9983, '\P{^ismiscellaneoussymbols}', "");
    Expect(0, 9984, '\p{ismiscellaneoussymbols}', "");
    Expect(1, 9984, '\p{^ismiscellaneoussymbols}', "");
    Expect(1, 9984, '\P{ismiscellaneoussymbols}', "");
    Expect(0, 9984, '\P{^ismiscellaneoussymbols}', "");
    Expect(1, 9983, '\p{__IS_Miscellaneous_symbols}', "");
    Expect(0, 9983, '\p{^__IS_Miscellaneous_symbols}', "");
    Expect(0, 9983, '\P{__IS_Miscellaneous_symbols}', "");
    Expect(1, 9983, '\P{^__IS_Miscellaneous_symbols}', "");
    Expect(0, 9984, '\p{__IS_Miscellaneous_symbols}', "");
    Expect(1, 9984, '\p{^__IS_Miscellaneous_symbols}', "");
    Expect(1, 9984, '\P{__IS_Miscellaneous_symbols}', "");
    Expect(0, 9984, '\P{^__IS_Miscellaneous_symbols}', "");
    Error('\p{:=  IN_miscellaneous_Symbols}');
    Error('\P{:=  IN_miscellaneous_Symbols}');
    Expect(1, 9983, '\p{inmiscellaneoussymbols}', "");
    Expect(0, 9983, '\p{^inmiscellaneoussymbols}', "");
    Expect(0, 9983, '\P{inmiscellaneoussymbols}', "");
    Expect(1, 9983, '\P{^inmiscellaneoussymbols}', "");
    Expect(0, 9984, '\p{inmiscellaneoussymbols}', "");
    Expect(1, 9984, '\p{^inmiscellaneoussymbols}', "");
    Expect(1, 9984, '\P{inmiscellaneoussymbols}', "");
    Expect(0, 9984, '\P{^inmiscellaneoussymbols}', "");
    Expect(1, 9983, '\p{_-IN_Miscellaneous_symbols}', "");
    Expect(0, 9983, '\p{^_-IN_Miscellaneous_symbols}', "");
    Expect(0, 9983, '\P{_-IN_Miscellaneous_symbols}', "");
    Expect(1, 9983, '\P{^_-IN_Miscellaneous_symbols}', "");
    Expect(0, 9984, '\p{_-IN_Miscellaneous_symbols}', "");
    Expect(1, 9984, '\p{^_-IN_Miscellaneous_symbols}', "");
    Expect(1, 9984, '\P{_-IN_Miscellaneous_symbols}', "");
    Expect(0, 9984, '\P{^_-IN_Miscellaneous_symbols}', "");
    Error('\p{:= _MISC_Symbols}');
    Error('\P{:= _MISC_Symbols}');
    Expect(1, 9983, '\p{miscsymbols}', "");
    Expect(0, 9983, '\p{^miscsymbols}', "");
    Expect(0, 9983, '\P{miscsymbols}', "");
    Expect(1, 9983, '\P{^miscsymbols}', "");
    Expect(0, 9984, '\p{miscsymbols}', "");
    Expect(1, 9984, '\p{^miscsymbols}', "");
    Expect(1, 9984, '\P{miscsymbols}', "");
    Expect(0, 9984, '\P{^miscsymbols}', "");
    Expect(1, 9983, '\p{_ Misc_SYMBOLS}', "");
    Expect(0, 9983, '\p{^_ Misc_SYMBOLS}', "");
    Expect(0, 9983, '\P{_ Misc_SYMBOLS}', "");
    Expect(1, 9983, '\P{^_ Misc_SYMBOLS}', "");
    Expect(0, 9984, '\p{_ Misc_SYMBOLS}', "");
    Expect(1, 9984, '\p{^_ Misc_SYMBOLS}', "");
    Expect(1, 9984, '\P{_ Misc_SYMBOLS}', "");
    Expect(0, 9984, '\P{^_ Misc_SYMBOLS}', "");
    Error('\p{:=	IS_Misc_SYMBOLS}');
    Error('\P{:=	IS_Misc_SYMBOLS}');
    Expect(1, 9983, '\p{ismiscsymbols}', "");
    Expect(0, 9983, '\p{^ismiscsymbols}', "");
    Expect(0, 9983, '\P{ismiscsymbols}', "");
    Expect(1, 9983, '\P{^ismiscsymbols}', "");
    Expect(0, 9984, '\p{ismiscsymbols}', "");
    Expect(1, 9984, '\p{^ismiscsymbols}', "");
    Expect(1, 9984, '\P{ismiscsymbols}', "");
    Expect(0, 9984, '\P{^ismiscsymbols}', "");
    Expect(1, 9983, '\p{-_is_misc_Symbols}', "");
    Expect(0, 9983, '\p{^-_is_misc_Symbols}', "");
    Expect(0, 9983, '\P{-_is_misc_Symbols}', "");
    Expect(1, 9983, '\P{^-_is_misc_Symbols}', "");
    Expect(0, 9984, '\p{-_is_misc_Symbols}', "");
    Expect(1, 9984, '\p{^-_is_misc_Symbols}', "");
    Expect(1, 9984, '\P{-_is_misc_Symbols}', "");
    Expect(0, 9984, '\P{^-_is_misc_Symbols}', "");
    Error('\p{/a/-_In_misc_symbols}');
    Error('\P{/a/-_In_misc_symbols}');
    Expect(1, 9983, '\p{inmiscsymbols}', "");
    Expect(0, 9983, '\p{^inmiscsymbols}', "");
    Expect(0, 9983, '\P{inmiscsymbols}', "");
    Expect(1, 9983, '\P{^inmiscsymbols}', "");
    Expect(0, 9984, '\p{inmiscsymbols}', "");
    Expect(1, 9984, '\p{^inmiscsymbols}', "");
    Expect(1, 9984, '\P{inmiscsymbols}', "");
    Expect(0, 9984, '\P{^inmiscsymbols}', "");
    Expect(1, 9983, '\p{	 In_MISC_Symbols}', "");
    Expect(0, 9983, '\p{^	 In_MISC_Symbols}', "");
    Expect(0, 9983, '\P{	 In_MISC_Symbols}', "");
    Expect(1, 9983, '\P{^	 In_MISC_Symbols}', "");
    Expect(0, 9984, '\p{	 In_MISC_Symbols}', "");
    Expect(1, 9984, '\p{^	 In_MISC_Symbols}', "");
    Expect(1, 9984, '\P{	 In_MISC_Symbols}', "");
    Expect(0, 9984, '\P{^	 In_MISC_Symbols}', "");
    Error('\p{/a/ -Miscellaneous_Symbols_And_Arrows}');
    Error('\P{/a/ -Miscellaneous_Symbols_And_Arrows}');
    Expect(1, 11263, '\p{miscellaneoussymbolsandarrows}', "");
    Expect(0, 11263, '\p{^miscellaneoussymbolsandarrows}', "");
    Expect(0, 11263, '\P{miscellaneoussymbolsandarrows}', "");
    Expect(1, 11263, '\P{^miscellaneoussymbolsandarrows}', "");
    Expect(0, 11264, '\p{miscellaneoussymbolsandarrows}', "");
    Expect(1, 11264, '\p{^miscellaneoussymbolsandarrows}', "");
    Expect(1, 11264, '\P{miscellaneoussymbolsandarrows}', "");
    Expect(0, 11264, '\P{^miscellaneoussymbolsandarrows}', "");
    Expect(1, 11263, '\p{	Miscellaneous_symbols_And_ARROWS}', "");
    Expect(0, 11263, '\p{^	Miscellaneous_symbols_And_ARROWS}', "");
    Expect(0, 11263, '\P{	Miscellaneous_symbols_And_ARROWS}', "");
    Expect(1, 11263, '\P{^	Miscellaneous_symbols_And_ARROWS}', "");
    Expect(0, 11264, '\p{	Miscellaneous_symbols_And_ARROWS}', "");
    Expect(1, 11264, '\p{^	Miscellaneous_symbols_And_ARROWS}', "");
    Expect(1, 11264, '\P{	Miscellaneous_symbols_And_ARROWS}', "");
    Expect(0, 11264, '\P{^	Miscellaneous_symbols_And_ARROWS}', "");
    Error('\p{/a/-Is_Miscellaneous_symbols_And_Arrows}');
    Error('\P{/a/-Is_Miscellaneous_symbols_And_Arrows}');
    Expect(1, 11263, '\p{ismiscellaneoussymbolsandarrows}', "");
    Expect(0, 11263, '\p{^ismiscellaneoussymbolsandarrows}', "");
    Expect(0, 11263, '\P{ismiscellaneoussymbolsandarrows}', "");
    Expect(1, 11263, '\P{^ismiscellaneoussymbolsandarrows}', "");
    Expect(0, 11264, '\p{ismiscellaneoussymbolsandarrows}', "");
    Expect(1, 11264, '\p{^ismiscellaneoussymbolsandarrows}', "");
    Expect(1, 11264, '\P{ismiscellaneoussymbolsandarrows}', "");
    Expect(0, 11264, '\P{^ismiscellaneoussymbolsandarrows}', "");
    Expect(1, 11263, '\p{	-Is_Miscellaneous_SYMBOLS_And_arrows}', "");
    Expect(0, 11263, '\p{^	-Is_Miscellaneous_SYMBOLS_And_arrows}', "");
    Expect(0, 11263, '\P{	-Is_Miscellaneous_SYMBOLS_And_arrows}', "");
    Expect(1, 11263, '\P{^	-Is_Miscellaneous_SYMBOLS_And_arrows}', "");
    Expect(0, 11264, '\p{	-Is_Miscellaneous_SYMBOLS_And_arrows}', "");
    Expect(1, 11264, '\p{^	-Is_Miscellaneous_SYMBOLS_And_arrows}', "");
    Expect(1, 11264, '\P{	-Is_Miscellaneous_SYMBOLS_And_arrows}', "");
    Expect(0, 11264, '\P{^	-Is_Miscellaneous_SYMBOLS_And_arrows}', "");
    Error('\p{/a/in_miscellaneous_Symbols_AND_Arrows}');
    Error('\P{/a/in_miscellaneous_Symbols_AND_Arrows}');
    Expect(1, 11263, '\p{inmiscellaneoussymbolsandarrows}', "");
    Expect(0, 11263, '\p{^inmiscellaneoussymbolsandarrows}', "");
    Expect(0, 11263, '\P{inmiscellaneoussymbolsandarrows}', "");
    Expect(1, 11263, '\P{^inmiscellaneoussymbolsandarrows}', "");
    Expect(0, 11264, '\p{inmiscellaneoussymbolsandarrows}', "");
    Expect(1, 11264, '\p{^inmiscellaneoussymbolsandarrows}', "");
    Expect(1, 11264, '\P{inmiscellaneoussymbolsandarrows}', "");
    Expect(0, 11264, '\P{^inmiscellaneoussymbolsandarrows}', "");
    Expect(1, 11263, '\p{	In_miscellaneous_symbols_And_ARROWS}', "");
    Expect(0, 11263, '\p{^	In_miscellaneous_symbols_And_ARROWS}', "");
    Expect(0, 11263, '\P{	In_miscellaneous_symbols_And_ARROWS}', "");
    Expect(1, 11263, '\P{^	In_miscellaneous_symbols_And_ARROWS}', "");
    Expect(0, 11264, '\p{	In_miscellaneous_symbols_And_ARROWS}', "");
    Expect(1, 11264, '\p{^	In_miscellaneous_symbols_And_ARROWS}', "");
    Expect(1, 11264, '\P{	In_miscellaneous_symbols_And_ARROWS}', "");
    Expect(0, 11264, '\P{^	In_miscellaneous_symbols_And_ARROWS}', "");
    Error('\p{	-MISC_Arrows/a/}');
    Error('\P{	-MISC_Arrows/a/}');
    Expect(1, 11263, '\p{miscarrows}', "");
    Expect(0, 11263, '\p{^miscarrows}', "");
    Expect(0, 11263, '\P{miscarrows}', "");
    Expect(1, 11263, '\P{^miscarrows}', "");
    Expect(0, 11264, '\p{miscarrows}', "");
    Expect(1, 11264, '\p{^miscarrows}', "");
    Expect(1, 11264, '\P{miscarrows}', "");
    Expect(0, 11264, '\P{^miscarrows}', "");
    Expect(1, 11263, '\p{-	Misc_Arrows}', "");
    Expect(0, 11263, '\p{^-	Misc_Arrows}', "");
    Expect(0, 11263, '\P{-	Misc_Arrows}', "");
    Expect(1, 11263, '\P{^-	Misc_Arrows}', "");
    Expect(0, 11264, '\p{-	Misc_Arrows}', "");
    Expect(1, 11264, '\p{^-	Misc_Arrows}', "");
    Expect(1, 11264, '\P{-	Misc_Arrows}', "");
    Expect(0, 11264, '\P{^-	Misc_Arrows}', "");
    Error('\p{:=IS_MISC_Arrows}');
    Error('\P{:=IS_MISC_Arrows}');
    Expect(1, 11263, '\p{ismiscarrows}', "");
    Expect(0, 11263, '\p{^ismiscarrows}', "");
    Expect(0, 11263, '\P{ismiscarrows}', "");
    Expect(1, 11263, '\P{^ismiscarrows}', "");
    Expect(0, 11264, '\p{ismiscarrows}', "");
    Expect(1, 11264, '\p{^ismiscarrows}', "");
    Expect(1, 11264, '\P{ismiscarrows}', "");
    Expect(0, 11264, '\P{^ismiscarrows}', "");
    Expect(1, 11263, '\p{	_is_misc_ARROWS}', "");
    Expect(0, 11263, '\p{^	_is_misc_ARROWS}', "");
    Expect(0, 11263, '\P{	_is_misc_ARROWS}', "");
    Expect(1, 11263, '\P{^	_is_misc_ARROWS}', "");
    Expect(0, 11264, '\p{	_is_misc_ARROWS}', "");
    Expect(1, 11264, '\p{^	_is_misc_ARROWS}', "");
    Expect(1, 11264, '\P{	_is_misc_ARROWS}', "");
    Expect(0, 11264, '\P{^	_is_misc_ARROWS}', "");
    Error('\p{	in_Misc_ARROWS:=}');
    Error('\P{	in_Misc_ARROWS:=}');
    Expect(1, 11263, '\p{inmiscarrows}', "");
    Expect(0, 11263, '\p{^inmiscarrows}', "");
    Expect(0, 11263, '\P{inmiscarrows}', "");
    Expect(1, 11263, '\P{^inmiscarrows}', "");
    Expect(0, 11264, '\p{inmiscarrows}', "");
    Expect(1, 11264, '\p{^inmiscarrows}', "");
    Expect(1, 11264, '\P{inmiscarrows}', "");
    Expect(0, 11264, '\P{^inmiscarrows}', "");
    Expect(1, 11263, '\p{-In_Misc_Arrows}', "");
    Expect(0, 11263, '\p{^-In_Misc_Arrows}', "");
    Expect(0, 11263, '\P{-In_Misc_Arrows}', "");
    Expect(1, 11263, '\P{^-In_Misc_Arrows}', "");
    Expect(0, 11264, '\p{-In_Misc_Arrows}', "");
    Expect(1, 11264, '\p{^-In_Misc_Arrows}', "");
    Expect(1, 11264, '\P{-In_Misc_Arrows}', "");
    Expect(0, 11264, '\P{^-In_Misc_Arrows}', "");
    Error('\p{--Miscellaneous_SYMBOLS_and_pictographs:=}');
    Error('\P{--Miscellaneous_SYMBOLS_and_pictographs:=}');
    Expect(1, 128511, '\p{miscellaneoussymbolsandpictographs}', "");
    Expect(0, 128511, '\p{^miscellaneoussymbolsandpictographs}', "");
    Expect(0, 128511, '\P{miscellaneoussymbolsandpictographs}', "");
    Expect(1, 128511, '\P{^miscellaneoussymbolsandpictographs}', "");
    Expect(0, 128512, '\p{miscellaneoussymbolsandpictographs}', "");
    Expect(1, 128512, '\p{^miscellaneoussymbolsandpictographs}', "");
    Expect(1, 128512, '\P{miscellaneoussymbolsandpictographs}', "");
    Expect(0, 128512, '\P{^miscellaneoussymbolsandpictographs}', "");
    Expect(1, 128511, '\p{_MISCELLANEOUS_Symbols_and_Pictographs}', "");
    Expect(0, 128511, '\p{^_MISCELLANEOUS_Symbols_and_Pictographs}', "");
    Expect(0, 128511, '\P{_MISCELLANEOUS_Symbols_and_Pictographs}', "");
    Expect(1, 128511, '\P{^_MISCELLANEOUS_Symbols_and_Pictographs}', "");
    Expect(0, 128512, '\p{_MISCELLANEOUS_Symbols_and_Pictographs}', "");
    Expect(1, 128512, '\p{^_MISCELLANEOUS_Symbols_and_Pictographs}', "");
    Expect(1, 128512, '\P{_MISCELLANEOUS_Symbols_and_Pictographs}', "");
    Expect(0, 128512, '\P{^_MISCELLANEOUS_Symbols_and_Pictographs}', "");
    Error('\p{/a/_-IS_Miscellaneous_Symbols_AND_pictographs}');
    Error('\P{/a/_-IS_Miscellaneous_Symbols_AND_pictographs}');
    Expect(1, 128511, '\p{ismiscellaneoussymbolsandpictographs}', "");
    Expect(0, 128511, '\p{^ismiscellaneoussymbolsandpictographs}', "");
    Expect(0, 128511, '\P{ismiscellaneoussymbolsandpictographs}', "");
    Expect(1, 128511, '\P{^ismiscellaneoussymbolsandpictographs}', "");
    Expect(0, 128512, '\p{ismiscellaneoussymbolsandpictographs}', "");
    Expect(1, 128512, '\p{^ismiscellaneoussymbolsandpictographs}', "");
    Expect(1, 128512, '\P{ismiscellaneoussymbolsandpictographs}', "");
    Expect(0, 128512, '\P{^ismiscellaneoussymbolsandpictographs}', "");
    Expect(1, 128511, '\p{- is_miscellaneous_Symbols_And_pictographs}', "");
    Expect(0, 128511, '\p{^- is_miscellaneous_Symbols_And_pictographs}', "");
    Expect(0, 128511, '\P{- is_miscellaneous_Symbols_And_pictographs}', "");
    Expect(1, 128511, '\P{^- is_miscellaneous_Symbols_And_pictographs}', "");
    Expect(0, 128512, '\p{- is_miscellaneous_Symbols_And_pictographs}', "");
    Expect(1, 128512, '\p{^- is_miscellaneous_Symbols_And_pictographs}', "");
    Expect(1, 128512, '\P{- is_miscellaneous_Symbols_And_pictographs}', "");
    Expect(0, 128512, '\P{^- is_miscellaneous_Symbols_And_pictographs}', "");
    Error('\p{:= -IN_miscellaneous_Symbols_and_PICTOGRAPHS}');
    Error('\P{:= -IN_miscellaneous_Symbols_and_PICTOGRAPHS}');
    Expect(1, 128511, '\p{inmiscellaneoussymbolsandpictographs}', "");
    Expect(0, 128511, '\p{^inmiscellaneoussymbolsandpictographs}', "");
    Expect(0, 128511, '\P{inmiscellaneoussymbolsandpictographs}', "");
    Expect(1, 128511, '\P{^inmiscellaneoussymbolsandpictographs}', "");
    Expect(0, 128512, '\p{inmiscellaneoussymbolsandpictographs}', "");
    Expect(1, 128512, '\p{^inmiscellaneoussymbolsandpictographs}', "");
    Expect(1, 128512, '\P{inmiscellaneoussymbolsandpictographs}', "");
    Expect(0, 128512, '\P{^inmiscellaneoussymbolsandpictographs}', "");
    Expect(1, 128511, '\p{ -In_miscellaneous_Symbols_And_PICTOGRAPHS}', "");
    Expect(0, 128511, '\p{^ -In_miscellaneous_Symbols_And_PICTOGRAPHS}', "");
    Expect(0, 128511, '\P{ -In_miscellaneous_Symbols_And_PICTOGRAPHS}', "");
    Expect(1, 128511, '\P{^ -In_miscellaneous_Symbols_And_PICTOGRAPHS}', "");
    Expect(0, 128512, '\p{ -In_miscellaneous_Symbols_And_PICTOGRAPHS}', "");
    Expect(1, 128512, '\p{^ -In_miscellaneous_Symbols_And_PICTOGRAPHS}', "");
    Expect(1, 128512, '\P{ -In_miscellaneous_Symbols_And_PICTOGRAPHS}', "");
    Expect(0, 128512, '\P{^ -In_miscellaneous_Symbols_And_PICTOGRAPHS}', "");
    Error('\p{:=-Misc_Pictographs}');
    Error('\P{:=-Misc_Pictographs}');
    Expect(1, 128511, '\p{miscpictographs}', "");
    Expect(0, 128511, '\p{^miscpictographs}', "");
    Expect(0, 128511, '\P{miscpictographs}', "");
    Expect(1, 128511, '\P{^miscpictographs}', "");
    Expect(0, 128512, '\p{miscpictographs}', "");
    Expect(1, 128512, '\p{^miscpictographs}', "");
    Expect(1, 128512, '\P{miscpictographs}', "");
    Expect(0, 128512, '\P{^miscpictographs}', "");
    Expect(1, 128511, '\p{Misc_pictographs}', "");
    Expect(0, 128511, '\p{^Misc_pictographs}', "");
    Expect(0, 128511, '\P{Misc_pictographs}', "");
    Expect(1, 128511, '\P{^Misc_pictographs}', "");
    Expect(0, 128512, '\p{Misc_pictographs}', "");
    Expect(1, 128512, '\p{^Misc_pictographs}', "");
    Expect(1, 128512, '\P{Misc_pictographs}', "");
    Expect(0, 128512, '\P{^Misc_pictographs}', "");
    Error('\p{_-is_Misc_Pictographs/a/}');
    Error('\P{_-is_Misc_Pictographs/a/}');
    Expect(1, 128511, '\p{ismiscpictographs}', "");
    Expect(0, 128511, '\p{^ismiscpictographs}', "");
    Expect(0, 128511, '\P{ismiscpictographs}', "");
    Expect(1, 128511, '\P{^ismiscpictographs}', "");
    Expect(0, 128512, '\p{ismiscpictographs}', "");
    Expect(1, 128512, '\p{^ismiscpictographs}', "");
    Expect(1, 128512, '\P{ismiscpictographs}', "");
    Expect(0, 128512, '\P{^ismiscpictographs}', "");
    Expect(1, 128511, '\p{		is_Misc_PICTOGRAPHS}', "");
    Expect(0, 128511, '\p{^		is_Misc_PICTOGRAPHS}', "");
    Expect(0, 128511, '\P{		is_Misc_PICTOGRAPHS}', "");
    Expect(1, 128511, '\P{^		is_Misc_PICTOGRAPHS}', "");
    Expect(0, 128512, '\p{		is_Misc_PICTOGRAPHS}', "");
    Expect(1, 128512, '\p{^		is_Misc_PICTOGRAPHS}', "");
    Expect(1, 128512, '\P{		is_Misc_PICTOGRAPHS}', "");
    Expect(0, 128512, '\P{^		is_Misc_PICTOGRAPHS}', "");
    Error('\p{:=	IN_misc_Pictographs}');
    Error('\P{:=	IN_misc_Pictographs}');
    Expect(1, 128511, '\p{inmiscpictographs}', "");
    Expect(0, 128511, '\p{^inmiscpictographs}', "");
    Expect(0, 128511, '\P{inmiscpictographs}', "");
    Expect(1, 128511, '\P{^inmiscpictographs}', "");
    Expect(0, 128512, '\p{inmiscpictographs}', "");
    Expect(1, 128512, '\p{^inmiscpictographs}', "");
    Expect(1, 128512, '\P{inmiscpictographs}', "");
    Expect(0, 128512, '\P{^inmiscpictographs}', "");
    Expect(1, 128511, '\p{_ In_Misc_Pictographs}', "");
    Expect(0, 128511, '\p{^_ In_Misc_Pictographs}', "");
    Expect(0, 128511, '\P{_ In_Misc_Pictographs}', "");
    Expect(1, 128511, '\P{^_ In_Misc_Pictographs}', "");
    Expect(0, 128512, '\p{_ In_Misc_Pictographs}', "");
    Expect(1, 128512, '\p{^_ In_Misc_Pictographs}', "");
    Expect(1, 128512, '\P{_ In_Misc_Pictographs}', "");
    Expect(0, 128512, '\P{^_ In_Misc_Pictographs}', "");
    Error('\p{:=  Miscellaneous_Technical}');
    Error('\P{:=  Miscellaneous_Technical}');
    Expect(1, 9215, '\p{miscellaneoustechnical}', "");
    Expect(0, 9215, '\p{^miscellaneoustechnical}', "");
    Expect(0, 9215, '\P{miscellaneoustechnical}', "");
    Expect(1, 9215, '\P{^miscellaneoustechnical}', "");
    Expect(0, 9216, '\p{miscellaneoustechnical}', "");
    Expect(1, 9216, '\p{^miscellaneoustechnical}', "");
    Expect(1, 9216, '\P{miscellaneoustechnical}', "");
    Expect(0, 9216, '\P{^miscellaneoustechnical}', "");
    Expect(1, 9215, '\p{--Miscellaneous_TECHNICAL}', "");
    Expect(0, 9215, '\p{^--Miscellaneous_TECHNICAL}', "");
    Expect(0, 9215, '\P{--Miscellaneous_TECHNICAL}', "");
    Expect(1, 9215, '\P{^--Miscellaneous_TECHNICAL}', "");
    Expect(0, 9216, '\p{--Miscellaneous_TECHNICAL}', "");
    Expect(1, 9216, '\p{^--Miscellaneous_TECHNICAL}', "");
    Expect(1, 9216, '\P{--Miscellaneous_TECHNICAL}', "");
    Expect(0, 9216, '\P{^--Miscellaneous_TECHNICAL}', "");
    Error('\p{/a/is_Miscellaneous_Technical}');
    Error('\P{/a/is_Miscellaneous_Technical}');
    Expect(1, 9215, '\p{ismiscellaneoustechnical}', "");
    Expect(0, 9215, '\p{^ismiscellaneoustechnical}', "");
    Expect(0, 9215, '\P{ismiscellaneoustechnical}', "");
    Expect(1, 9215, '\P{^ismiscellaneoustechnical}', "");
    Expect(0, 9216, '\p{ismiscellaneoustechnical}', "");
    Expect(1, 9216, '\p{^ismiscellaneoustechnical}', "");
    Expect(1, 9216, '\P{ismiscellaneoustechnical}', "");
    Expect(0, 9216, '\P{^ismiscellaneoustechnical}', "");
    Expect(1, 9215, '\p{ Is_Miscellaneous_TECHNICAL}', "");
    Expect(0, 9215, '\p{^ Is_Miscellaneous_TECHNICAL}', "");
    Expect(0, 9215, '\P{ Is_Miscellaneous_TECHNICAL}', "");
    Expect(1, 9215, '\P{^ Is_Miscellaneous_TECHNICAL}', "");
    Expect(0, 9216, '\p{ Is_Miscellaneous_TECHNICAL}', "");
    Expect(1, 9216, '\p{^ Is_Miscellaneous_TECHNICAL}', "");
    Expect(1, 9216, '\P{ Is_Miscellaneous_TECHNICAL}', "");
    Expect(0, 9216, '\P{^ Is_Miscellaneous_TECHNICAL}', "");
    Error('\p{-/a/IN_Miscellaneous_TECHNICAL}');
    Error('\P{-/a/IN_Miscellaneous_TECHNICAL}');
    Expect(1, 9215, '\p{inmiscellaneoustechnical}', "");
    Expect(0, 9215, '\p{^inmiscellaneoustechnical}', "");
    Expect(0, 9215, '\P{inmiscellaneoustechnical}', "");
    Expect(1, 9215, '\P{^inmiscellaneoustechnical}', "");
    Expect(0, 9216, '\p{inmiscellaneoustechnical}', "");
    Expect(1, 9216, '\p{^inmiscellaneoustechnical}', "");
    Expect(1, 9216, '\P{inmiscellaneoustechnical}', "");
    Expect(0, 9216, '\P{^inmiscellaneoustechnical}', "");
    Expect(1, 9215, '\p{	In_Miscellaneous_TECHNICAL}', "");
    Expect(0, 9215, '\p{^	In_Miscellaneous_TECHNICAL}', "");
    Expect(0, 9215, '\P{	In_Miscellaneous_TECHNICAL}', "");
    Expect(1, 9215, '\P{^	In_Miscellaneous_TECHNICAL}', "");
    Expect(0, 9216, '\p{	In_Miscellaneous_TECHNICAL}', "");
    Expect(1, 9216, '\p{^	In_Miscellaneous_TECHNICAL}', "");
    Expect(1, 9216, '\P{	In_Miscellaneous_TECHNICAL}', "");
    Expect(0, 9216, '\P{^	In_Miscellaneous_TECHNICAL}', "");
    Error('\p{	/a/Misc_technical}');
    Error('\P{	/a/Misc_technical}');
    Expect(1, 9215, '\p{misctechnical}', "");
    Expect(0, 9215, '\p{^misctechnical}', "");
    Expect(0, 9215, '\P{misctechnical}', "");
    Expect(1, 9215, '\P{^misctechnical}', "");
    Expect(0, 9216, '\p{misctechnical}', "");
    Expect(1, 9216, '\p{^misctechnical}', "");
    Expect(1, 9216, '\P{misctechnical}', "");
    Expect(0, 9216, '\P{^misctechnical}', "");
    Expect(1, 9215, '\p{-Misc_Technical}', "");
    Expect(0, 9215, '\p{^-Misc_Technical}', "");
    Expect(0, 9215, '\P{-Misc_Technical}', "");
    Expect(1, 9215, '\P{^-Misc_Technical}', "");
    Expect(0, 9216, '\p{-Misc_Technical}', "");
    Expect(1, 9216, '\p{^-Misc_Technical}', "");
    Expect(1, 9216, '\P{-Misc_Technical}', "");
    Expect(0, 9216, '\P{^-Misc_Technical}', "");
    Error('\p{-	IS_MISC_TECHNICAL/a/}');
    Error('\P{-	IS_MISC_TECHNICAL/a/}');
    Expect(1, 9215, '\p{ismisctechnical}', "");
    Expect(0, 9215, '\p{^ismisctechnical}', "");
    Expect(0, 9215, '\P{ismisctechnical}', "");
    Expect(1, 9215, '\P{^ismisctechnical}', "");
    Expect(0, 9216, '\p{ismisctechnical}', "");
    Expect(1, 9216, '\p{^ismisctechnical}', "");
    Expect(1, 9216, '\P{ismisctechnical}', "");
    Expect(0, 9216, '\P{^ismisctechnical}', "");
    Expect(1, 9215, '\p{is_Misc_TECHNICAL}', "");
    Expect(0, 9215, '\p{^is_Misc_TECHNICAL}', "");
    Expect(0, 9215, '\P{is_Misc_TECHNICAL}', "");
    Expect(1, 9215, '\P{^is_Misc_TECHNICAL}', "");
    Expect(0, 9216, '\p{is_Misc_TECHNICAL}', "");
    Expect(1, 9216, '\p{^is_Misc_TECHNICAL}', "");
    Expect(1, 9216, '\P{is_Misc_TECHNICAL}', "");
    Expect(0, 9216, '\P{^is_Misc_TECHNICAL}', "");
    Error('\p{_/a/in_MISC_TECHNICAL}');
    Error('\P{_/a/in_MISC_TECHNICAL}');
    Expect(1, 9215, '\p{inmisctechnical}', "");
    Expect(0, 9215, '\p{^inmisctechnical}', "");
    Expect(0, 9215, '\P{inmisctechnical}', "");
    Expect(1, 9215, '\P{^inmisctechnical}', "");
    Expect(0, 9216, '\p{inmisctechnical}', "");
    Expect(1, 9216, '\p{^inmisctechnical}', "");
    Expect(1, 9216, '\P{inmisctechnical}', "");
    Expect(0, 9216, '\P{^inmisctechnical}', "");
    Expect(1, 9215, '\p{  in_Misc_Technical}', "");
    Expect(0, 9215, '\p{^  in_Misc_Technical}', "");
    Expect(0, 9215, '\P{  in_Misc_Technical}', "");
    Expect(1, 9215, '\P{^  in_Misc_Technical}', "");
    Expect(0, 9216, '\p{  in_Misc_Technical}', "");
    Expect(1, 9216, '\p{^  in_Misc_Technical}', "");
    Expect(1, 9216, '\P{  in_Misc_Technical}', "");
    Expect(0, 9216, '\P{^  in_Misc_Technical}', "");
    Error('\p{	/a/modi}');
    Error('\P{	/a/modi}');
    Expect(1, 71257, '\p{modi}', "");
    Expect(0, 71257, '\p{^modi}', "");
    Expect(0, 71257, '\P{modi}', "");
    Expect(1, 71257, '\P{^modi}', "");
    Expect(0, 71258, '\p{modi}', "");
    Expect(1, 71258, '\p{^modi}', "");
    Expect(1, 71258, '\P{modi}', "");
    Expect(0, 71258, '\P{^modi}', "");
    Expect(1, 71257, '\p{-Modi}', "");
    Expect(0, 71257, '\p{^-Modi}', "");
    Expect(0, 71257, '\P{-Modi}', "");
    Expect(1, 71257, '\P{^-Modi}', "");
    Expect(0, 71258, '\p{-Modi}', "");
    Expect(1, 71258, '\p{^-Modi}', "");
    Expect(1, 71258, '\P{-Modi}', "");
    Expect(0, 71258, '\P{^-Modi}', "");
    Error('\p{	/a/Is_modi}');
    Error('\P{	/a/Is_modi}');
    Expect(1, 71257, '\p{ismodi}', "");
    Expect(0, 71257, '\p{^ismodi}', "");
    Expect(0, 71257, '\P{ismodi}', "");
    Expect(1, 71257, '\P{^ismodi}', "");
    Expect(0, 71258, '\p{ismodi}', "");
    Expect(1, 71258, '\p{^ismodi}', "");
    Expect(1, 71258, '\P{ismodi}', "");
    Expect(0, 71258, '\P{^ismodi}', "");
    Expect(1, 71257, '\p{_-is_Modi}', "");
    Expect(0, 71257, '\p{^_-is_Modi}', "");
    Expect(0, 71257, '\P{_-is_Modi}', "");
    Expect(1, 71257, '\P{^_-is_Modi}', "");
    Expect(0, 71258, '\p{_-is_Modi}', "");
    Expect(1, 71258, '\p{^_-is_Modi}', "");
    Expect(1, 71258, '\P{_-is_Modi}', "");
    Expect(0, 71258, '\P{^_-is_Modi}', "");
    Error('\p{_modifier_Letter:=}');
    Error('\P{_modifier_Letter:=}');
    Expect(1, 125259, '\p{modifierletter}', "");
    Expect(0, 125259, '\p{^modifierletter}', "");
    Expect(0, 125259, '\P{modifierletter}', "");
    Expect(1, 125259, '\P{^modifierletter}', "");
    Expect(0, 125260, '\p{modifierletter}', "");
    Expect(1, 125260, '\p{^modifierletter}', "");
    Expect(1, 125260, '\P{modifierletter}', "");
    Expect(0, 125260, '\P{^modifierletter}', "");
    Expect(1, 125259, '\p{_	modifier_LETTER}', "");
    Expect(0, 125259, '\p{^_	modifier_LETTER}', "");
    Expect(0, 125259, '\P{_	modifier_LETTER}', "");
    Expect(1, 125259, '\P{^_	modifier_LETTER}', "");
    Expect(0, 125260, '\p{_	modifier_LETTER}', "");
    Expect(1, 125260, '\p{^_	modifier_LETTER}', "");
    Expect(1, 125260, '\P{_	modifier_LETTER}', "");
    Expect(0, 125260, '\P{^_	modifier_LETTER}', "");
    Error('\p{:=	_Is_modifier_Letter}');
    Error('\P{:=	_Is_modifier_Letter}');
    Expect(1, 125259, '\p{ismodifierletter}', "");
    Expect(0, 125259, '\p{^ismodifierletter}', "");
    Expect(0, 125259, '\P{ismodifierletter}', "");
    Expect(1, 125259, '\P{^ismodifierletter}', "");
    Expect(0, 125260, '\p{ismodifierletter}', "");
    Expect(1, 125260, '\p{^ismodifierletter}', "");
    Expect(1, 125260, '\P{ismodifierletter}', "");
    Expect(0, 125260, '\P{^ismodifierletter}', "");
    Expect(1, 125259, '\p{Is_Modifier_letter}', "");
    Expect(0, 125259, '\p{^Is_Modifier_letter}', "");
    Expect(0, 125259, '\P{Is_Modifier_letter}', "");
    Expect(1, 125259, '\P{^Is_Modifier_letter}', "");
    Expect(0, 125260, '\p{Is_Modifier_letter}', "");
    Expect(1, 125260, '\p{^Is_Modifier_letter}', "");
    Expect(1, 125260, '\P{Is_Modifier_letter}', "");
    Expect(0, 125260, '\P{^Is_Modifier_letter}', "");
    Error('\p{- Lm/a/}');
    Error('\P{- Lm/a/}');
    Expect(1, 125259, '\p{lm}', "");
    Expect(0, 125259, '\p{^lm}', "");
    Expect(0, 125259, '\P{lm}', "");
    Expect(1, 125259, '\P{^lm}', "");
    Expect(0, 125260, '\p{lm}', "");
    Expect(1, 125260, '\p{^lm}', "");
    Expect(1, 125260, '\P{lm}', "");
    Expect(0, 125260, '\P{^lm}', "");
    Expect(1, 125259, '\p{	LM}', "");
    Expect(0, 125259, '\p{^	LM}', "");
    Expect(0, 125259, '\P{	LM}', "");
    Expect(1, 125259, '\P{^	LM}', "");
    Expect(0, 125260, '\p{	LM}', "");
    Expect(1, 125260, '\p{^	LM}', "");
    Expect(1, 125260, '\P{	LM}', "");
    Expect(0, 125260, '\P{^	LM}', "");
    Error('\p{/a/__Is_LM}');
    Error('\P{/a/__Is_LM}');
    Expect(1, 125259, '\p{islm}', "");
    Expect(0, 125259, '\p{^islm}', "");
    Expect(0, 125259, '\P{islm}', "");
    Expect(1, 125259, '\P{^islm}', "");
    Expect(0, 125260, '\p{islm}', "");
    Expect(1, 125260, '\p{^islm}', "");
    Expect(1, 125260, '\P{islm}', "");
    Expect(0, 125260, '\P{^islm}', "");
    Expect(1, 125259, '\p{	-Is_Lm}', "");
    Expect(0, 125259, '\p{^	-Is_Lm}', "");
    Expect(0, 125259, '\P{	-Is_Lm}', "");
    Expect(1, 125259, '\P{^	-Is_Lm}', "");
    Expect(0, 125260, '\p{	-Is_Lm}', "");
    Expect(1, 125260, '\p{^	-Is_Lm}', "");
    Expect(1, 125260, '\P{	-Is_Lm}', "");
    Expect(0, 125260, '\P{^	-Is_Lm}', "");
    Error('\p{:=- Modifier_SYMBOL}');
    Error('\P{:=- Modifier_SYMBOL}');
    Expect(1, 127999, '\p{modifiersymbol}', "");
    Expect(0, 127999, '\p{^modifiersymbol}', "");
    Expect(0, 127999, '\P{modifiersymbol}', "");
    Expect(1, 127999, '\P{^modifiersymbol}', "");
    Expect(0, 128000, '\p{modifiersymbol}', "");
    Expect(1, 128000, '\p{^modifiersymbol}', "");
    Expect(1, 128000, '\P{modifiersymbol}', "");
    Expect(0, 128000, '\P{^modifiersymbol}', "");
    Expect(1, 127999, '\p{-modifier_symbol}', "");
    Expect(0, 127999, '\p{^-modifier_symbol}', "");
    Expect(0, 127999, '\P{-modifier_symbol}', "");
    Expect(1, 127999, '\P{^-modifier_symbol}', "");
    Expect(0, 128000, '\p{-modifier_symbol}', "");
    Expect(1, 128000, '\p{^-modifier_symbol}', "");
    Expect(1, 128000, '\P{-modifier_symbol}', "");
    Expect(0, 128000, '\P{^-modifier_symbol}', "");
    Error('\p{		IS_modifier_Symbol/a/}');
    Error('\P{		IS_modifier_Symbol/a/}');
    Expect(1, 127999, '\p{ismodifiersymbol}', "");
    Expect(0, 127999, '\p{^ismodifiersymbol}', "");
    Expect(0, 127999, '\P{ismodifiersymbol}', "");
    Expect(1, 127999, '\P{^ismodifiersymbol}', "");
    Expect(0, 128000, '\p{ismodifiersymbol}', "");
    Expect(1, 128000, '\p{^ismodifiersymbol}', "");
    Expect(1, 128000, '\P{ismodifiersymbol}', "");
    Expect(0, 128000, '\P{^ismodifiersymbol}', "");
    Expect(1, 127999, '\p{_	Is_Modifier_Symbol}', "");
    Expect(0, 127999, '\p{^_	Is_Modifier_Symbol}', "");
    Expect(0, 127999, '\P{_	Is_Modifier_Symbol}', "");
    Expect(1, 127999, '\P{^_	Is_Modifier_Symbol}', "");
    Expect(0, 128000, '\p{_	Is_Modifier_Symbol}', "");
    Expect(1, 128000, '\p{^_	Is_Modifier_Symbol}', "");
    Expect(1, 128000, '\P{_	Is_Modifier_Symbol}', "");
    Expect(0, 128000, '\P{^_	Is_Modifier_Symbol}', "");
    Error('\p{	 sk/a/}');
    Error('\P{	 sk/a/}');
    Expect(1, 127999, '\p{sk}', "");
    Expect(0, 127999, '\p{^sk}', "");
    Expect(0, 127999, '\P{sk}', "");
    Expect(1, 127999, '\P{^sk}', "");
    Expect(0, 128000, '\p{sk}', "");
    Expect(1, 128000, '\p{^sk}', "");
    Expect(1, 128000, '\P{sk}', "");
    Expect(0, 128000, '\P{^sk}', "");
    Expect(1, 127999, '\p{	sk}', "");
    Expect(0, 127999, '\p{^	sk}', "");
    Expect(0, 127999, '\P{	sk}', "");
    Expect(1, 127999, '\P{^	sk}', "");
    Expect(0, 128000, '\p{	sk}', "");
    Expect(1, 128000, '\p{^	sk}', "");
    Expect(1, 128000, '\P{	sk}', "");
    Expect(0, 128000, '\P{^	sk}', "");
    Error('\p{ IS_Sk:=}');
    Error('\P{ IS_Sk:=}');
    Expect(1, 127999, '\p{issk}', "");
    Expect(0, 127999, '\p{^issk}', "");
    Expect(0, 127999, '\P{issk}', "");
    Expect(1, 127999, '\P{^issk}', "");
    Expect(0, 128000, '\p{issk}', "");
    Expect(1, 128000, '\p{^issk}', "");
    Expect(1, 128000, '\P{issk}', "");
    Expect(0, 128000, '\P{^issk}', "");
    Expect(1, 127999, '\p{		is_Sk}', "");
    Expect(0, 127999, '\p{^		is_Sk}', "");
    Expect(0, 127999, '\P{		is_Sk}', "");
    Expect(1, 127999, '\P{^		is_Sk}', "");
    Expect(0, 128000, '\p{		is_Sk}', "");
    Expect(1, 128000, '\p{^		is_Sk}', "");
    Expect(1, 128000, '\P{		is_Sk}', "");
    Expect(0, 128000, '\P{^		is_Sk}', "");
    Error('\p{/a/ _Modifier_TONE_LETTERS}');
    Error('\P{/a/ _Modifier_TONE_LETTERS}');
    Expect(1, 42783, '\p{modifiertoneletters}', "");
    Expect(0, 42783, '\p{^modifiertoneletters}', "");
    Expect(0, 42783, '\P{modifiertoneletters}', "");
    Expect(1, 42783, '\P{^modifiertoneletters}', "");
    Expect(0, 42784, '\p{modifiertoneletters}', "");
    Expect(1, 42784, '\p{^modifiertoneletters}', "");
    Expect(1, 42784, '\P{modifiertoneletters}', "");
    Expect(0, 42784, '\P{^modifiertoneletters}', "");
    Expect(1, 42783, '\p{_-Modifier_Tone_letters}', "");
    Expect(0, 42783, '\p{^_-Modifier_Tone_letters}', "");
    Expect(0, 42783, '\P{_-Modifier_Tone_letters}', "");
    Expect(1, 42783, '\P{^_-Modifier_Tone_letters}', "");
    Expect(0, 42784, '\p{_-Modifier_Tone_letters}', "");
    Expect(1, 42784, '\p{^_-Modifier_Tone_letters}', "");
    Expect(1, 42784, '\P{_-Modifier_Tone_letters}', "");
    Expect(0, 42784, '\P{^_-Modifier_Tone_letters}', "");
    Error('\p{:=		Is_Modifier_TONE_letters}');
    Error('\P{:=		Is_Modifier_TONE_letters}');
    Expect(1, 42783, '\p{ismodifiertoneletters}', "");
    Expect(0, 42783, '\p{^ismodifiertoneletters}', "");
    Expect(0, 42783, '\P{ismodifiertoneletters}', "");
    Expect(1, 42783, '\P{^ismodifiertoneletters}', "");
    Expect(0, 42784, '\p{ismodifiertoneletters}', "");
    Expect(1, 42784, '\p{^ismodifiertoneletters}', "");
    Expect(1, 42784, '\P{ismodifiertoneletters}', "");
    Expect(0, 42784, '\P{^ismodifiertoneletters}', "");
    Expect(1, 42783, '\p{-is_Modifier_Tone_Letters}', "");
    Expect(0, 42783, '\p{^-is_Modifier_Tone_Letters}', "");
    Expect(0, 42783, '\P{-is_Modifier_Tone_Letters}', "");
    Expect(1, 42783, '\P{^-is_Modifier_Tone_Letters}', "");
    Expect(0, 42784, '\p{-is_Modifier_Tone_Letters}', "");
    Expect(1, 42784, '\p{^-is_Modifier_Tone_Letters}', "");
    Expect(1, 42784, '\P{-is_Modifier_Tone_Letters}', "");
    Expect(0, 42784, '\P{^-is_Modifier_Tone_Letters}', "");
    Error('\p{:=__In_modifier_Tone_letters}');
    Error('\P{:=__In_modifier_Tone_letters}');
    Expect(1, 42783, '\p{inmodifiertoneletters}', "");
    Expect(0, 42783, '\p{^inmodifiertoneletters}', "");
    Expect(0, 42783, '\P{inmodifiertoneletters}', "");
    Expect(1, 42783, '\P{^inmodifiertoneletters}', "");
    Expect(0, 42784, '\p{inmodifiertoneletters}', "");
    Expect(1, 42784, '\p{^inmodifiertoneletters}', "");
    Expect(1, 42784, '\P{inmodifiertoneletters}', "");
    Expect(0, 42784, '\P{^inmodifiertoneletters}', "");
    Expect(1, 42783, '\p{  In_modifier_TONE_Letters}', "");
    Expect(0, 42783, '\p{^  In_modifier_TONE_Letters}', "");
    Expect(0, 42783, '\P{  In_modifier_TONE_Letters}', "");
    Expect(1, 42783, '\P{^  In_modifier_TONE_Letters}', "");
    Expect(0, 42784, '\p{  In_modifier_TONE_Letters}', "");
    Expect(1, 42784, '\p{^  In_modifier_TONE_Letters}', "");
    Expect(1, 42784, '\P{  In_modifier_TONE_Letters}', "");
    Expect(0, 42784, '\P{^  In_modifier_TONE_Letters}', "");
    Error('\p{	/a/Mongolian}');
    Error('\P{	/a/Mongolian}');
    Expect(1, 71276, '\p{mongolian}', "");
    Expect(0, 71276, '\p{^mongolian}', "");
    Expect(0, 71276, '\P{mongolian}', "");
    Expect(1, 71276, '\P{^mongolian}', "");
    Expect(0, 71277, '\p{mongolian}', "");
    Expect(1, 71277, '\p{^mongolian}', "");
    Expect(1, 71277, '\P{mongolian}', "");
    Expect(0, 71277, '\P{^mongolian}', "");
    Expect(1, 71276, '\p{_ mongolian}', "");
    Expect(0, 71276, '\p{^_ mongolian}', "");
    Expect(0, 71276, '\P{_ mongolian}', "");
    Expect(1, 71276, '\P{^_ mongolian}', "");
    Expect(0, 71277, '\p{_ mongolian}', "");
    Expect(1, 71277, '\p{^_ mongolian}', "");
    Expect(1, 71277, '\P{_ mongolian}', "");
    Expect(0, 71277, '\P{^_ mongolian}', "");
    Error('\p{ Is_Mongolian/a/}');
    Error('\P{ Is_Mongolian/a/}');
    Expect(1, 71276, '\p{ismongolian}', "");
    Expect(0, 71276, '\p{^ismongolian}', "");
    Expect(0, 71276, '\P{ismongolian}', "");
    Expect(1, 71276, '\P{^ismongolian}', "");
    Expect(0, 71277, '\p{ismongolian}', "");
    Expect(1, 71277, '\p{^ismongolian}', "");
    Expect(1, 71277, '\P{ismongolian}', "");
    Expect(0, 71277, '\P{^ismongolian}', "");
    Expect(1, 71276, '\p{	Is_Mongolian}', "");
    Expect(0, 71276, '\p{^	Is_Mongolian}', "");
    Expect(0, 71276, '\P{	Is_Mongolian}', "");
    Expect(1, 71276, '\P{^	Is_Mongolian}', "");
    Expect(0, 71277, '\p{	Is_Mongolian}', "");
    Expect(1, 71277, '\p{^	Is_Mongolian}', "");
    Expect(1, 71277, '\P{	Is_Mongolian}', "");
    Expect(0, 71277, '\P{^	Is_Mongolian}', "");
    Error('\p{_/a/mong}');
    Error('\P{_/a/mong}');
    Expect(1, 71276, '\p{mong}', "");
    Expect(0, 71276, '\p{^mong}', "");
    Expect(0, 71276, '\P{mong}', "");
    Expect(1, 71276, '\P{^mong}', "");
    Expect(0, 71277, '\p{mong}', "");
    Expect(1, 71277, '\p{^mong}', "");
    Expect(1, 71277, '\P{mong}', "");
    Expect(0, 71277, '\P{^mong}', "");
    Expect(1, 71276, '\p{ mong}', "");
    Expect(0, 71276, '\p{^ mong}', "");
    Expect(0, 71276, '\P{ mong}', "");
    Expect(1, 71276, '\P{^ mong}', "");
    Expect(0, 71277, '\p{ mong}', "");
    Expect(1, 71277, '\p{^ mong}', "");
    Expect(1, 71277, '\P{ mong}', "");
    Expect(0, 71277, '\P{^ mong}', "");
    Error('\p{-	Is_MONG:=}');
    Error('\P{-	Is_MONG:=}');
    Expect(1, 71276, '\p{ismong}', "");
    Expect(0, 71276, '\p{^ismong}', "");
    Expect(0, 71276, '\P{ismong}', "");
    Expect(1, 71276, '\P{^ismong}', "");
    Expect(0, 71277, '\p{ismong}', "");
    Expect(1, 71277, '\p{^ismong}', "");
    Expect(1, 71277, '\P{ismong}', "");
    Expect(0, 71277, '\P{^ismong}', "");
    Expect(1, 71276, '\p{ -Is_Mong}', "");
    Expect(0, 71276, '\p{^ -Is_Mong}', "");
    Expect(0, 71276, '\P{ -Is_Mong}', "");
    Expect(1, 71276, '\P{^ -Is_Mong}', "");
    Expect(0, 71277, '\p{ -Is_Mong}', "");
    Expect(1, 71277, '\p{^ -Is_Mong}', "");
    Expect(1, 71277, '\P{ -Is_Mong}', "");
    Expect(0, 71277, '\P{^ -Is_Mong}', "");
    Error('\p{:=	MONGOLIAN_Supplement}');
    Error('\P{:=	MONGOLIAN_Supplement}');
    Expect(1, 71295, '\p{mongoliansupplement}', "");
    Expect(0, 71295, '\p{^mongoliansupplement}', "");
    Expect(0, 71295, '\P{mongoliansupplement}', "");
    Expect(1, 71295, '\P{^mongoliansupplement}', "");
    Expect(0, 71296, '\p{mongoliansupplement}', "");
    Expect(1, 71296, '\p{^mongoliansupplement}', "");
    Expect(1, 71296, '\P{mongoliansupplement}', "");
    Expect(0, 71296, '\P{^mongoliansupplement}', "");
    Expect(1, 71295, '\p{	-Mongolian_Supplement}', "");
    Expect(0, 71295, '\p{^	-Mongolian_Supplement}', "");
    Expect(0, 71295, '\P{	-Mongolian_Supplement}', "");
    Expect(1, 71295, '\P{^	-Mongolian_Supplement}', "");
    Expect(0, 71296, '\p{	-Mongolian_Supplement}', "");
    Expect(1, 71296, '\p{^	-Mongolian_Supplement}', "");
    Expect(1, 71296, '\P{	-Mongolian_Supplement}', "");
    Expect(0, 71296, '\P{^	-Mongolian_Supplement}', "");
    Error('\p{_Is_MONGOLIAN_Supplement/a/}');
    Error('\P{_Is_MONGOLIAN_Supplement/a/}');
    Expect(1, 71295, '\p{ismongoliansupplement}', "");
    Expect(0, 71295, '\p{^ismongoliansupplement}', "");
    Expect(0, 71295, '\P{ismongoliansupplement}', "");
    Expect(1, 71295, '\P{^ismongoliansupplement}', "");
    Expect(0, 71296, '\p{ismongoliansupplement}', "");
    Expect(1, 71296, '\p{^ismongoliansupplement}', "");
    Expect(1, 71296, '\P{ismongoliansupplement}', "");
    Expect(0, 71296, '\P{^ismongoliansupplement}', "");
    Expect(1, 71295, '\p{	_IS_Mongolian_SUPPLEMENT}', "");
    Expect(0, 71295, '\p{^	_IS_Mongolian_SUPPLEMENT}', "");
    Expect(0, 71295, '\P{	_IS_Mongolian_SUPPLEMENT}', "");
    Expect(1, 71295, '\P{^	_IS_Mongolian_SUPPLEMENT}', "");
    Expect(0, 71296, '\p{	_IS_Mongolian_SUPPLEMENT}', "");
    Expect(1, 71296, '\p{^	_IS_Mongolian_SUPPLEMENT}', "");
    Expect(1, 71296, '\P{	_IS_Mongolian_SUPPLEMENT}', "");
    Expect(0, 71296, '\P{^	_IS_Mongolian_SUPPLEMENT}', "");
    Error('\p{	in_Mongolian_Supplement/a/}');
    Error('\P{	in_Mongolian_Supplement/a/}');
    Expect(1, 71295, '\p{inmongoliansupplement}', "");
    Expect(0, 71295, '\p{^inmongoliansupplement}', "");
    Expect(0, 71295, '\P{inmongoliansupplement}', "");
    Expect(1, 71295, '\P{^inmongoliansupplement}', "");
    Expect(0, 71296, '\p{inmongoliansupplement}', "");
    Expect(1, 71296, '\p{^inmongoliansupplement}', "");
    Expect(1, 71296, '\P{inmongoliansupplement}', "");
    Expect(0, 71296, '\P{^inmongoliansupplement}', "");
    Expect(1, 71295, '\p{	-IN_MONGOLIAN_Supplement}', "");
    Expect(0, 71295, '\p{^	-IN_MONGOLIAN_Supplement}', "");
    Expect(0, 71295, '\P{	-IN_MONGOLIAN_Supplement}', "");
    Expect(1, 71295, '\P{^	-IN_MONGOLIAN_Supplement}', "");
    Expect(0, 71296, '\p{	-IN_MONGOLIAN_Supplement}', "");
    Expect(1, 71296, '\p{^	-IN_MONGOLIAN_Supplement}', "");
    Expect(1, 71296, '\P{	-IN_MONGOLIAN_Supplement}', "");
    Expect(0, 71296, '\P{^	-IN_MONGOLIAN_Supplement}', "");
    Error('\p{_Mongolian_Sup:=}');
    Error('\P{_Mongolian_Sup:=}');
    Expect(1, 71295, '\p{mongoliansup}', "");
    Expect(0, 71295, '\p{^mongoliansup}', "");
    Expect(0, 71295, '\P{mongoliansup}', "");
    Expect(1, 71295, '\P{^mongoliansup}', "");
    Expect(0, 71296, '\p{mongoliansup}', "");
    Expect(1, 71296, '\p{^mongoliansup}', "");
    Expect(1, 71296, '\P{mongoliansup}', "");
    Expect(0, 71296, '\P{^mongoliansup}', "");
    Expect(1, 71295, '\p{-MONGOLIAN_SUP}', "");
    Expect(0, 71295, '\p{^-MONGOLIAN_SUP}', "");
    Expect(0, 71295, '\P{-MONGOLIAN_SUP}', "");
    Expect(1, 71295, '\P{^-MONGOLIAN_SUP}', "");
    Expect(0, 71296, '\p{-MONGOLIAN_SUP}', "");
    Expect(1, 71296, '\p{^-MONGOLIAN_SUP}', "");
    Expect(1, 71296, '\P{-MONGOLIAN_SUP}', "");
    Expect(0, 71296, '\P{^-MONGOLIAN_SUP}', "");
    Error('\p{--IS_MONGOLIAN_Sup/a/}');
    Error('\P{--IS_MONGOLIAN_Sup/a/}');
    Expect(1, 71295, '\p{ismongoliansup}', "");
    Expect(0, 71295, '\p{^ismongoliansup}', "");
    Expect(0, 71295, '\P{ismongoliansup}', "");
    Expect(1, 71295, '\P{^ismongoliansup}', "");
    Expect(0, 71296, '\p{ismongoliansup}', "");
    Expect(1, 71296, '\p{^ismongoliansup}', "");
    Expect(1, 71296, '\P{ismongoliansup}', "");
    Expect(0, 71296, '\P{^ismongoliansup}', "");
    Expect(1, 71295, '\p{	is_mongolian_SUP}', "");
    Expect(0, 71295, '\p{^	is_mongolian_SUP}', "");
    Expect(0, 71295, '\P{	is_mongolian_SUP}', "");
    Expect(1, 71295, '\P{^	is_mongolian_SUP}', "");
    Expect(0, 71296, '\p{	is_mongolian_SUP}', "");
    Expect(1, 71296, '\p{^	is_mongolian_SUP}', "");
    Expect(1, 71296, '\P{	is_mongolian_SUP}', "");
    Expect(0, 71296, '\P{^	is_mongolian_SUP}', "");
    Error('\p{--IN_MONGOLIAN_Sup/a/}');
    Error('\P{--IN_MONGOLIAN_Sup/a/}');
    Expect(1, 71295, '\p{inmongoliansup}', "");
    Expect(0, 71295, '\p{^inmongoliansup}', "");
    Expect(0, 71295, '\P{inmongoliansup}', "");
    Expect(1, 71295, '\P{^inmongoliansup}', "");
    Expect(0, 71296, '\p{inmongoliansup}', "");
    Expect(1, 71296, '\p{^inmongoliansup}', "");
    Expect(1, 71296, '\P{inmongoliansup}', "");
    Expect(0, 71296, '\P{^inmongoliansup}', "");
    Expect(1, 71295, '\p{	-In_Mongolian_sup}', "");
    Expect(0, 71295, '\p{^	-In_Mongolian_sup}', "");
    Expect(0, 71295, '\P{	-In_Mongolian_sup}', "");
    Expect(1, 71295, '\P{^	-In_Mongolian_sup}', "");
    Expect(0, 71296, '\p{	-In_Mongolian_sup}', "");
    Expect(1, 71296, '\p{^	-In_Mongolian_sup}', "");
    Expect(1, 71296, '\P{	-In_Mongolian_sup}', "");
    Expect(0, 71296, '\P{^	-In_Mongolian_sup}', "");
    Error('\p{ -mro/a/}');
    Error('\P{ -mro/a/}');
    Expect(1, 92783, '\p{mro}', "");
    Expect(0, 92783, '\p{^mro}', "");
    Expect(0, 92783, '\P{mro}', "");
    Expect(1, 92783, '\P{^mro}', "");
    Expect(0, 92784, '\p{mro}', "");
    Expect(1, 92784, '\p{^mro}', "");
    Expect(1, 92784, '\P{mro}', "");
    Expect(0, 92784, '\P{^mro}', "");
    Expect(1, 92783, '\p{  MRO}', "");
    Expect(0, 92783, '\p{^  MRO}', "");
    Expect(0, 92783, '\P{  MRO}', "");
    Expect(1, 92783, '\P{^  MRO}', "");
    Expect(0, 92784, '\p{  MRO}', "");
    Expect(1, 92784, '\p{^  MRO}', "");
    Expect(1, 92784, '\P{  MRO}', "");
    Expect(0, 92784, '\P{^  MRO}', "");
    Error('\p{	_is_Mro:=}');
    Error('\P{	_is_Mro:=}');
    Expect(1, 92783, '\p{ismro}', "");
    Expect(0, 92783, '\p{^ismro}', "");
    Expect(0, 92783, '\P{ismro}', "");
    Expect(1, 92783, '\P{^ismro}', "");
    Expect(0, 92784, '\p{ismro}', "");
    Expect(1, 92784, '\p{^ismro}', "");
    Expect(1, 92784, '\P{ismro}', "");
    Expect(0, 92784, '\P{^ismro}', "");
    Expect(1, 92783, '\p{_Is_mro}', "");
    Expect(0, 92783, '\p{^_Is_mro}', "");
    Expect(0, 92783, '\P{_Is_mro}', "");
    Expect(1, 92783, '\P{^_Is_mro}', "");
    Expect(0, 92784, '\p{_Is_mro}', "");
    Expect(1, 92784, '\p{^_Is_mro}', "");
    Expect(1, 92784, '\P{_Is_mro}', "");
    Expect(0, 92784, '\P{^_Is_mro}', "");
    Error('\p{	/a/MROO}');
    Error('\P{	/a/MROO}');
    Expect(1, 92783, '\p{mroo}', "");
    Expect(0, 92783, '\p{^mroo}', "");
    Expect(0, 92783, '\P{mroo}', "");
    Expect(1, 92783, '\P{^mroo}', "");
    Expect(0, 92784, '\p{mroo}', "");
    Expect(1, 92784, '\p{^mroo}', "");
    Expect(1, 92784, '\P{mroo}', "");
    Expect(0, 92784, '\P{^mroo}', "");
    Expect(1, 92783, '\p{-Mroo}', "");
    Expect(0, 92783, '\p{^-Mroo}', "");
    Expect(0, 92783, '\P{-Mroo}', "");
    Expect(1, 92783, '\P{^-Mroo}', "");
    Expect(0, 92784, '\p{-Mroo}', "");
    Expect(1, 92784, '\p{^-Mroo}', "");
    Expect(1, 92784, '\P{-Mroo}', "");
    Expect(0, 92784, '\P{^-Mroo}', "");
    Error('\p{/a/-is_Mroo}');
    Error('\P{/a/-is_Mroo}');
    Expect(1, 92783, '\p{ismroo}', "");
    Expect(0, 92783, '\p{^ismroo}', "");
    Expect(0, 92783, '\P{ismroo}', "");
    Expect(1, 92783, '\P{^ismroo}', "");
    Expect(0, 92784, '\p{ismroo}', "");
    Expect(1, 92784, '\p{^ismroo}', "");
    Expect(1, 92784, '\P{ismroo}', "");
    Expect(0, 92784, '\P{^ismroo}', "");
    Expect(1, 92783, '\p{_ Is_Mroo}', "");
    Expect(0, 92783, '\p{^_ Is_Mroo}', "");
    Expect(0, 92783, '\P{_ Is_Mroo}', "");
    Expect(1, 92783, '\P{^_ Is_Mroo}', "");
    Expect(0, 92784, '\p{_ Is_Mroo}', "");
    Expect(1, 92784, '\p{^_ Is_Mroo}', "");
    Expect(1, 92784, '\P{_ Is_Mroo}', "");
    Expect(0, 92784, '\P{^_ Is_Mroo}', "");
    Error('\p{	multani:=}');
    Error('\P{	multani:=}');
    Expect(1, 70313, '\p{multani}', "");
    Expect(0, 70313, '\p{^multani}', "");
    Expect(0, 70313, '\P{multani}', "");
    Expect(1, 70313, '\P{^multani}', "");
    Expect(0, 70314, '\p{multani}', "");
    Expect(1, 70314, '\p{^multani}', "");
    Expect(1, 70314, '\P{multani}', "");
    Expect(0, 70314, '\P{^multani}', "");
    Expect(1, 70313, '\p{ MULTANI}', "");
    Expect(0, 70313, '\p{^ MULTANI}', "");
    Expect(0, 70313, '\P{ MULTANI}', "");
    Expect(1, 70313, '\P{^ MULTANI}', "");
    Expect(0, 70314, '\p{ MULTANI}', "");
    Expect(1, 70314, '\p{^ MULTANI}', "");
    Expect(1, 70314, '\P{ MULTANI}', "");
    Expect(0, 70314, '\P{^ MULTANI}', "");
    Error('\p{/a/Is_Multani}');
    Error('\P{/a/Is_Multani}');
    Expect(1, 70313, '\p{ismultani}', "");
    Expect(0, 70313, '\p{^ismultani}', "");
    Expect(0, 70313, '\P{ismultani}', "");
    Expect(1, 70313, '\P{^ismultani}', "");
    Expect(0, 70314, '\p{ismultani}', "");
    Expect(1, 70314, '\p{^ismultani}', "");
    Expect(1, 70314, '\P{ismultani}', "");
    Expect(0, 70314, '\P{^ismultani}', "");
    Expect(1, 70313, '\p{  Is_MULTANI}', "");
    Expect(0, 70313, '\p{^  Is_MULTANI}', "");
    Expect(0, 70313, '\P{  Is_MULTANI}', "");
    Expect(1, 70313, '\P{^  Is_MULTANI}', "");
    Expect(0, 70314, '\p{  Is_MULTANI}', "");
    Expect(1, 70314, '\p{^  Is_MULTANI}', "");
    Expect(1, 70314, '\P{  Is_MULTANI}', "");
    Expect(0, 70314, '\P{^  Is_MULTANI}', "");
    Error('\p{--MULT:=}');
    Error('\P{--MULT:=}');
    Expect(1, 70313, '\p{mult}', "");
    Expect(0, 70313, '\p{^mult}', "");
    Expect(0, 70313, '\P{mult}', "");
    Expect(1, 70313, '\P{^mult}', "");
    Expect(0, 70314, '\p{mult}', "");
    Expect(1, 70314, '\p{^mult}', "");
    Expect(1, 70314, '\P{mult}', "");
    Expect(0, 70314, '\P{^mult}', "");
    Expect(1, 70313, '\p{	-Mult}', "");
    Expect(0, 70313, '\p{^	-Mult}', "");
    Expect(0, 70313, '\P{	-Mult}', "");
    Expect(1, 70313, '\P{^	-Mult}', "");
    Expect(0, 70314, '\p{	-Mult}', "");
    Expect(1, 70314, '\p{^	-Mult}', "");
    Expect(1, 70314, '\P{	-Mult}', "");
    Expect(0, 70314, '\P{^	-Mult}', "");
    Error('\p{_	Is_mult/a/}');
    Error('\P{_	Is_mult/a/}');
    Expect(1, 70313, '\p{ismult}', "");
    Expect(0, 70313, '\p{^ismult}', "");
    Expect(0, 70313, '\P{ismult}', "");
    Expect(1, 70313, '\P{^ismult}', "");
    Expect(0, 70314, '\p{ismult}', "");
    Expect(1, 70314, '\p{^ismult}', "");
    Expect(1, 70314, '\P{ismult}', "");
    Expect(0, 70314, '\P{^ismult}', "");
    Expect(1, 70313, '\p{_is_Mult}', "");
    Expect(0, 70313, '\p{^_is_Mult}', "");
    Expect(0, 70313, '\P{_is_Mult}', "");
    Expect(1, 70313, '\P{^_is_Mult}', "");
    Expect(0, 70314, '\p{_is_Mult}', "");
    Expect(1, 70314, '\p{^_is_Mult}', "");
    Expect(1, 70314, '\P{_is_Mult}', "");
    Expect(0, 70314, '\P{^_is_Mult}', "");
    Error('\p{/a/	-musical_symbols}');
    Error('\P{/a/	-musical_symbols}');
    Expect(1, 119295, '\p{musicalsymbols}', "");
    Expect(0, 119295, '\p{^musicalsymbols}', "");
    Expect(0, 119295, '\P{musicalsymbols}', "");
    Expect(1, 119295, '\P{^musicalsymbols}', "");
    Expect(0, 119296, '\p{musicalsymbols}', "");
    Expect(1, 119296, '\p{^musicalsymbols}', "");
    Expect(1, 119296, '\P{musicalsymbols}', "");
    Expect(0, 119296, '\P{^musicalsymbols}', "");
    Expect(1, 119295, '\p{ Musical_Symbols}', "");
    Expect(0, 119295, '\p{^ Musical_Symbols}', "");
    Expect(0, 119295, '\P{ Musical_Symbols}', "");
    Expect(1, 119295, '\P{^ Musical_Symbols}', "");
    Expect(0, 119296, '\p{ Musical_Symbols}', "");
    Expect(1, 119296, '\p{^ Musical_Symbols}', "");
    Expect(1, 119296, '\P{ Musical_Symbols}', "");
    Expect(0, 119296, '\P{^ Musical_Symbols}', "");
    Error('\p{/a/Is_Musical_Symbols}');
    Error('\P{/a/Is_Musical_Symbols}');
    Expect(1, 119295, '\p{ismusicalsymbols}', "");
    Expect(0, 119295, '\p{^ismusicalsymbols}', "");
    Expect(0, 119295, '\P{ismusicalsymbols}', "");
    Expect(1, 119295, '\P{^ismusicalsymbols}', "");
    Expect(0, 119296, '\p{ismusicalsymbols}', "");
    Expect(1, 119296, '\p{^ismusicalsymbols}', "");
    Expect(1, 119296, '\P{ismusicalsymbols}', "");
    Expect(0, 119296, '\P{^ismusicalsymbols}', "");
    Expect(1, 119295, '\p{	 Is_Musical_Symbols}', "");
    Expect(0, 119295, '\p{^	 Is_Musical_Symbols}', "");
    Expect(0, 119295, '\P{	 Is_Musical_Symbols}', "");
    Expect(1, 119295, '\P{^	 Is_Musical_Symbols}', "");
    Expect(0, 119296, '\p{	 Is_Musical_Symbols}', "");
    Expect(1, 119296, '\p{^	 Is_Musical_Symbols}', "");
    Expect(1, 119296, '\P{	 Is_Musical_Symbols}', "");
    Expect(0, 119296, '\P{^	 Is_Musical_Symbols}', "");
    Error('\p{/a/In_musical_Symbols}');
    Error('\P{/a/In_musical_Symbols}');
    Expect(1, 119295, '\p{inmusicalsymbols}', "");
    Expect(0, 119295, '\p{^inmusicalsymbols}', "");
    Expect(0, 119295, '\P{inmusicalsymbols}', "");
    Expect(1, 119295, '\P{^inmusicalsymbols}', "");
    Expect(0, 119296, '\p{inmusicalsymbols}', "");
    Expect(1, 119296, '\p{^inmusicalsymbols}', "");
    Expect(1, 119296, '\P{inmusicalsymbols}', "");
    Expect(0, 119296, '\P{^inmusicalsymbols}', "");
    Expect(1, 119295, '\p{ 	In_MUSICAL_symbols}', "");
    Expect(0, 119295, '\p{^ 	In_MUSICAL_symbols}', "");
    Expect(0, 119295, '\P{ 	In_MUSICAL_symbols}', "");
    Expect(1, 119295, '\P{^ 	In_MUSICAL_symbols}', "");
    Expect(0, 119296, '\p{ 	In_MUSICAL_symbols}', "");
    Expect(1, 119296, '\p{^ 	In_MUSICAL_symbols}', "");
    Expect(1, 119296, '\P{ 	In_MUSICAL_symbols}', "");
    Expect(0, 119296, '\P{^ 	In_MUSICAL_symbols}', "");
    Error('\p{:=_Music}');
    Error('\P{:=_Music}');
    Expect(1, 119295, '\p{music}', "");
    Expect(0, 119295, '\p{^music}', "");
    Expect(0, 119295, '\P{music}', "");
    Expect(1, 119295, '\P{^music}', "");
    Expect(0, 119296, '\p{music}', "");
    Expect(1, 119296, '\p{^music}', "");
    Expect(1, 119296, '\P{music}', "");
    Expect(0, 119296, '\P{^music}', "");
    Expect(1, 119295, '\p{		Music}', "");
    Expect(0, 119295, '\p{^		Music}', "");
    Expect(0, 119295, '\P{		Music}', "");
    Expect(1, 119295, '\P{^		Music}', "");
    Expect(0, 119296, '\p{		Music}', "");
    Expect(1, 119296, '\p{^		Music}', "");
    Expect(1, 119296, '\P{		Music}', "");
    Expect(0, 119296, '\P{^		Music}', "");
    Error('\p{-IS_Music/a/}');
    Error('\P{-IS_Music/a/}');
    Expect(1, 119295, '\p{ismusic}', "");
    Expect(0, 119295, '\p{^ismusic}', "");
    Expect(0, 119295, '\P{ismusic}', "");
    Expect(1, 119295, '\P{^ismusic}', "");
    Expect(0, 119296, '\p{ismusic}', "");
    Expect(1, 119296, '\p{^ismusic}', "");
    Expect(1, 119296, '\P{ismusic}', "");
    Expect(0, 119296, '\P{^ismusic}', "");
    Expect(1, 119295, '\p{		IS_Music}', "");
    Expect(0, 119295, '\p{^		IS_Music}', "");
    Expect(0, 119295, '\P{		IS_Music}', "");
    Expect(1, 119295, '\P{^		IS_Music}', "");
    Expect(0, 119296, '\p{		IS_Music}', "");
    Expect(1, 119296, '\p{^		IS_Music}', "");
    Expect(1, 119296, '\P{		IS_Music}', "");
    Expect(0, 119296, '\P{^		IS_Music}', "");
    Error('\p{_:=IN_MUSIC}');
    Error('\P{_:=IN_MUSIC}');
    Expect(1, 119295, '\p{inmusic}', "");
    Expect(0, 119295, '\p{^inmusic}', "");
    Expect(0, 119295, '\P{inmusic}', "");
    Expect(1, 119295, '\P{^inmusic}', "");
    Expect(0, 119296, '\p{inmusic}', "");
    Expect(1, 119296, '\p{^inmusic}', "");
    Expect(1, 119296, '\P{inmusic}', "");
    Expect(0, 119296, '\P{^inmusic}', "");
    Expect(1, 119295, '\p{-	In_MUSIC}', "");
    Expect(0, 119295, '\p{^-	In_MUSIC}', "");
    Expect(0, 119295, '\P{-	In_MUSIC}', "");
    Expect(1, 119295, '\P{^-	In_MUSIC}', "");
    Expect(0, 119296, '\p{-	In_MUSIC}', "");
    Expect(1, 119296, '\p{^-	In_MUSIC}', "");
    Expect(1, 119296, '\P{-	In_MUSIC}', "");
    Expect(0, 119296, '\P{^-	In_MUSIC}', "");
    Error('\p{ -MYANMAR:=}');
    Error('\P{ -MYANMAR:=}');
    Expect(1, 43647, '\p{myanmar}', "");
    Expect(0, 43647, '\p{^myanmar}', "");
    Expect(0, 43647, '\P{myanmar}', "");
    Expect(1, 43647, '\P{^myanmar}', "");
    Expect(0, 43648, '\p{myanmar}', "");
    Expect(1, 43648, '\p{^myanmar}', "");
    Expect(1, 43648, '\P{myanmar}', "");
    Expect(0, 43648, '\P{^myanmar}', "");
    Expect(1, 43647, '\p{	Myanmar}', "");
    Expect(0, 43647, '\p{^	Myanmar}', "");
    Expect(0, 43647, '\P{	Myanmar}', "");
    Expect(1, 43647, '\P{^	Myanmar}', "");
    Expect(0, 43648, '\p{	Myanmar}', "");
    Expect(1, 43648, '\p{^	Myanmar}', "");
    Expect(1, 43648, '\P{	Myanmar}', "");
    Expect(0, 43648, '\P{^	Myanmar}', "");
    Error('\p{/a/_IS_Myanmar}');
    Error('\P{/a/_IS_Myanmar}');
    Expect(1, 43647, '\p{ismyanmar}', "");
    Expect(0, 43647, '\p{^ismyanmar}', "");
    Expect(0, 43647, '\P{ismyanmar}', "");
    Expect(1, 43647, '\P{^ismyanmar}', "");
    Expect(0, 43648, '\p{ismyanmar}', "");
    Expect(1, 43648, '\p{^ismyanmar}', "");
    Expect(1, 43648, '\P{ismyanmar}', "");
    Expect(0, 43648, '\P{^ismyanmar}', "");
    Expect(1, 43647, '\p{_ IS_Myanmar}', "");
    Expect(0, 43647, '\p{^_ IS_Myanmar}', "");
    Expect(0, 43647, '\P{_ IS_Myanmar}', "");
    Expect(1, 43647, '\P{^_ IS_Myanmar}', "");
    Expect(0, 43648, '\p{_ IS_Myanmar}', "");
    Expect(1, 43648, '\p{^_ IS_Myanmar}', "");
    Expect(1, 43648, '\P{_ IS_Myanmar}', "");
    Expect(0, 43648, '\P{^_ IS_Myanmar}', "");
    Error('\p{_:=MYMR}');
    Error('\P{_:=MYMR}');
    Expect(1, 43647, '\p{mymr}', "");
    Expect(0, 43647, '\p{^mymr}', "");
    Expect(0, 43647, '\P{mymr}', "");
    Expect(1, 43647, '\P{^mymr}', "");
    Expect(0, 43648, '\p{mymr}', "");
    Expect(1, 43648, '\p{^mymr}', "");
    Expect(1, 43648, '\P{mymr}', "");
    Expect(0, 43648, '\P{^mymr}', "");
    Expect(1, 43647, '\p{_-MYMR}', "");
    Expect(0, 43647, '\p{^_-MYMR}', "");
    Expect(0, 43647, '\P{_-MYMR}', "");
    Expect(1, 43647, '\P{^_-MYMR}', "");
    Expect(0, 43648, '\p{_-MYMR}', "");
    Expect(1, 43648, '\p{^_-MYMR}', "");
    Expect(1, 43648, '\P{_-MYMR}', "");
    Expect(0, 43648, '\P{^_-MYMR}', "");
    Error('\p{:=-Is_Mymr}');
    Error('\P{:=-Is_Mymr}');
    Expect(1, 43647, '\p{ismymr}', "");
    Expect(0, 43647, '\p{^ismymr}', "");
    Expect(0, 43647, '\P{ismymr}', "");
    Expect(1, 43647, '\P{^ismymr}', "");
    Expect(0, 43648, '\p{ismymr}', "");
    Expect(1, 43648, '\p{^ismymr}', "");
    Expect(1, 43648, '\P{ismymr}', "");
    Expect(0, 43648, '\P{^ismymr}', "");
    Expect(1, 43647, '\p{Is_Mymr}', "");
    Expect(0, 43647, '\p{^Is_Mymr}', "");
    Expect(0, 43647, '\P{Is_Mymr}', "");
    Expect(1, 43647, '\P{^Is_Mymr}', "");
    Expect(0, 43648, '\p{Is_Mymr}', "");
    Expect(1, 43648, '\p{^Is_Mymr}', "");
    Expect(1, 43648, '\P{Is_Mymr}', "");
    Expect(0, 43648, '\P{^Is_Mymr}', "");
    Error('\p{-:=Myanmar_Extended_A}');
    Error('\P{-:=Myanmar_Extended_A}');
    Expect(1, 43647, '\p{myanmarextendeda}', "");
    Expect(0, 43647, '\p{^myanmarextendeda}', "");
    Expect(0, 43647, '\P{myanmarextendeda}', "");
    Expect(1, 43647, '\P{^myanmarextendeda}', "");
    Expect(0, 43648, '\p{myanmarextendeda}', "");
    Expect(1, 43648, '\p{^myanmarextendeda}', "");
    Expect(1, 43648, '\P{myanmarextendeda}', "");
    Expect(0, 43648, '\P{^myanmarextendeda}', "");
    Expect(1, 43647, '\p{_ Myanmar_extended_a}', "");
    Expect(0, 43647, '\p{^_ Myanmar_extended_a}', "");
    Expect(0, 43647, '\P{_ Myanmar_extended_a}', "");
    Expect(1, 43647, '\P{^_ Myanmar_extended_a}', "");
    Expect(0, 43648, '\p{_ Myanmar_extended_a}', "");
    Expect(1, 43648, '\p{^_ Myanmar_extended_a}', "");
    Expect(1, 43648, '\P{_ Myanmar_extended_a}', "");
    Expect(0, 43648, '\P{^_ Myanmar_extended_a}', "");
    Error('\p{:=-Is_Myanmar_EXTENDED_A}');
    Error('\P{:=-Is_Myanmar_EXTENDED_A}');
    Expect(1, 43647, '\p{ismyanmarextendeda}', "");
    Expect(0, 43647, '\p{^ismyanmarextendeda}', "");
    Expect(0, 43647, '\P{ismyanmarextendeda}', "");
    Expect(1, 43647, '\P{^ismyanmarextendeda}', "");
    Expect(0, 43648, '\p{ismyanmarextendeda}', "");
    Expect(1, 43648, '\p{^ismyanmarextendeda}', "");
    Expect(1, 43648, '\P{ismyanmarextendeda}', "");
    Expect(0, 43648, '\P{^ismyanmarextendeda}', "");
    Expect(1, 43647, '\p{_ is_Myanmar_Extended_A}', "");
    Expect(0, 43647, '\p{^_ is_Myanmar_Extended_A}', "");
    Expect(0, 43647, '\P{_ is_Myanmar_Extended_A}', "");
    Expect(1, 43647, '\P{^_ is_Myanmar_Extended_A}', "");
    Expect(0, 43648, '\p{_ is_Myanmar_Extended_A}', "");
    Expect(1, 43648, '\p{^_ is_Myanmar_Extended_A}', "");
    Expect(1, 43648, '\P{_ is_Myanmar_Extended_A}', "");
    Expect(0, 43648, '\P{^_ is_Myanmar_Extended_A}', "");
    Error('\p{-:=IN_myanmar_extended_A}');
    Error('\P{-:=IN_myanmar_extended_A}');
    Expect(1, 43647, '\p{inmyanmarextendeda}', "");
    Expect(0, 43647, '\p{^inmyanmarextendeda}', "");
    Expect(0, 43647, '\P{inmyanmarextendeda}', "");
    Expect(1, 43647, '\P{^inmyanmarextendeda}', "");
    Expect(0, 43648, '\p{inmyanmarextendeda}', "");
    Expect(1, 43648, '\p{^inmyanmarextendeda}', "");
    Expect(1, 43648, '\P{inmyanmarextendeda}', "");
    Expect(0, 43648, '\P{^inmyanmarextendeda}', "");
    Expect(1, 43647, '\p{-	in_MYANMAR_Extended_a}', "");
    Expect(0, 43647, '\p{^-	in_MYANMAR_Extended_a}', "");
    Expect(0, 43647, '\P{-	in_MYANMAR_Extended_a}', "");
    Expect(1, 43647, '\P{^-	in_MYANMAR_Extended_a}', "");
    Expect(0, 43648, '\p{-	in_MYANMAR_Extended_a}', "");
    Expect(1, 43648, '\p{^-	in_MYANMAR_Extended_a}', "");
    Expect(1, 43648, '\P{-	in_MYANMAR_Extended_a}', "");
    Expect(0, 43648, '\P{^-	in_MYANMAR_Extended_a}', "");
    Error('\p{:=__Myanmar_Ext_A}');
    Error('\P{:=__Myanmar_Ext_A}');
    Expect(1, 43647, '\p{myanmarexta}', "");
    Expect(0, 43647, '\p{^myanmarexta}', "");
    Expect(0, 43647, '\P{myanmarexta}', "");
    Expect(1, 43647, '\P{^myanmarexta}', "");
    Expect(0, 43648, '\p{myanmarexta}', "");
    Expect(1, 43648, '\p{^myanmarexta}', "");
    Expect(1, 43648, '\P{myanmarexta}', "");
    Expect(0, 43648, '\P{^myanmarexta}', "");
    Expect(1, 43647, '\p{- Myanmar_Ext_A}', "");
    Expect(0, 43647, '\p{^- Myanmar_Ext_A}', "");
    Expect(0, 43647, '\P{- Myanmar_Ext_A}', "");
    Expect(1, 43647, '\P{^- Myanmar_Ext_A}', "");
    Expect(0, 43648, '\p{- Myanmar_Ext_A}', "");
    Expect(1, 43648, '\p{^- Myanmar_Ext_A}', "");
    Expect(1, 43648, '\P{- Myanmar_Ext_A}', "");
    Expect(0, 43648, '\P{^- Myanmar_Ext_A}', "");
    Error('\p{-_Is_MYANMAR_ext_A:=}');
    Error('\P{-_Is_MYANMAR_ext_A:=}');
    Expect(1, 43647, '\p{ismyanmarexta}', "");
    Expect(0, 43647, '\p{^ismyanmarexta}', "");
    Expect(0, 43647, '\P{ismyanmarexta}', "");
    Expect(1, 43647, '\P{^ismyanmarexta}', "");
    Expect(0, 43648, '\p{ismyanmarexta}', "");
    Expect(1, 43648, '\p{^ismyanmarexta}', "");
    Expect(1, 43648, '\P{ismyanmarexta}', "");
    Expect(0, 43648, '\P{^ismyanmarexta}', "");
    Expect(1, 43647, '\p{ Is_Myanmar_ext_a}', "");
    Expect(0, 43647, '\p{^ Is_Myanmar_ext_a}', "");
    Expect(0, 43647, '\P{ Is_Myanmar_ext_a}', "");
    Expect(1, 43647, '\P{^ Is_Myanmar_ext_a}', "");
    Expect(0, 43648, '\p{ Is_Myanmar_ext_a}', "");
    Expect(1, 43648, '\p{^ Is_Myanmar_ext_a}', "");
    Expect(1, 43648, '\P{ Is_Myanmar_ext_a}', "");
    Expect(0, 43648, '\P{^ Is_Myanmar_ext_a}', "");
    Error('\p{:= -In_Myanmar_Ext_A}');
    Error('\P{:= -In_Myanmar_Ext_A}');
    Expect(1, 43647, '\p{inmyanmarexta}', "");
    Expect(0, 43647, '\p{^inmyanmarexta}', "");
    Expect(0, 43647, '\P{inmyanmarexta}', "");
    Expect(1, 43647, '\P{^inmyanmarexta}', "");
    Expect(0, 43648, '\p{inmyanmarexta}', "");
    Expect(1, 43648, '\p{^inmyanmarexta}', "");
    Expect(1, 43648, '\P{inmyanmarexta}', "");
    Expect(0, 43648, '\P{^inmyanmarexta}', "");
    Expect(1, 43647, '\p{	-IN_myanmar_Ext_A}', "");
    Expect(0, 43647, '\p{^	-IN_myanmar_Ext_A}', "");
    Expect(0, 43647, '\P{	-IN_myanmar_Ext_A}', "");
    Expect(1, 43647, '\P{^	-IN_myanmar_Ext_A}', "");
    Expect(0, 43648, '\p{	-IN_myanmar_Ext_A}', "");
    Expect(1, 43648, '\p{^	-IN_myanmar_Ext_A}', "");
    Expect(1, 43648, '\P{	-IN_myanmar_Ext_A}', "");
    Expect(0, 43648, '\P{^	-IN_myanmar_Ext_A}', "");
    Error('\p{		MYANMAR_Extended_B:=}');
    Error('\P{		MYANMAR_Extended_B:=}');
    Expect(1, 43519, '\p{myanmarextendedb}', "");
    Expect(0, 43519, '\p{^myanmarextendedb}', "");
    Expect(0, 43519, '\P{myanmarextendedb}', "");
    Expect(1, 43519, '\P{^myanmarextendedb}', "");
    Expect(0, 43520, '\p{myanmarextendedb}', "");
    Expect(1, 43520, '\p{^myanmarextendedb}', "");
    Expect(1, 43520, '\P{myanmarextendedb}', "");
    Expect(0, 43520, '\P{^myanmarextendedb}', "");
    Expect(1, 43519, '\p{	myanmar_Extended_B}', "");
    Expect(0, 43519, '\p{^	myanmar_Extended_B}', "");
    Expect(0, 43519, '\P{	myanmar_Extended_B}', "");
    Expect(1, 43519, '\P{^	myanmar_Extended_B}', "");
    Expect(0, 43520, '\p{	myanmar_Extended_B}', "");
    Expect(1, 43520, '\p{^	myanmar_Extended_B}', "");
    Expect(1, 43520, '\P{	myanmar_Extended_B}', "");
    Expect(0, 43520, '\P{^	myanmar_Extended_B}', "");
    Error('\p{/a/-Is_Myanmar_EXTENDED_b}');
    Error('\P{/a/-Is_Myanmar_EXTENDED_b}');
    Expect(1, 43519, '\p{ismyanmarextendedb}', "");
    Expect(0, 43519, '\p{^ismyanmarextendedb}', "");
    Expect(0, 43519, '\P{ismyanmarextendedb}', "");
    Expect(1, 43519, '\P{^ismyanmarextendedb}', "");
    Expect(0, 43520, '\p{ismyanmarextendedb}', "");
    Expect(1, 43520, '\p{^ismyanmarextendedb}', "");
    Expect(1, 43520, '\P{ismyanmarextendedb}', "");
    Expect(0, 43520, '\P{^ismyanmarextendedb}', "");
    Expect(1, 43519, '\p{-_Is_myanmar_EXTENDED_b}', "");
    Expect(0, 43519, '\p{^-_Is_myanmar_EXTENDED_b}', "");
    Expect(0, 43519, '\P{-_Is_myanmar_EXTENDED_b}', "");
    Expect(1, 43519, '\P{^-_Is_myanmar_EXTENDED_b}', "");
    Expect(0, 43520, '\p{-_Is_myanmar_EXTENDED_b}', "");
    Expect(1, 43520, '\p{^-_Is_myanmar_EXTENDED_b}', "");
    Expect(1, 43520, '\P{-_Is_myanmar_EXTENDED_b}', "");
    Expect(0, 43520, '\P{^-_Is_myanmar_EXTENDED_b}', "");
    Error('\p{--in_myanmar_Extended_B/a/}');
    Error('\P{--in_myanmar_Extended_B/a/}');
    Expect(1, 43519, '\p{inmyanmarextendedb}', "");
    Expect(0, 43519, '\p{^inmyanmarextendedb}', "");
    Expect(0, 43519, '\P{inmyanmarextendedb}', "");
    Expect(1, 43519, '\P{^inmyanmarextendedb}', "");
    Expect(0, 43520, '\p{inmyanmarextendedb}', "");
    Expect(1, 43520, '\p{^inmyanmarextendedb}', "");
    Expect(1, 43520, '\P{inmyanmarextendedb}', "");
    Expect(0, 43520, '\P{^inmyanmarextendedb}', "");
    Expect(1, 43519, '\p{_ In_Myanmar_extended_b}', "");
    Expect(0, 43519, '\p{^_ In_Myanmar_extended_b}', "");
    Expect(0, 43519, '\P{_ In_Myanmar_extended_b}', "");
    Expect(1, 43519, '\P{^_ In_Myanmar_extended_b}', "");
    Expect(0, 43520, '\p{_ In_Myanmar_extended_b}', "");
    Expect(1, 43520, '\p{^_ In_Myanmar_extended_b}', "");
    Expect(1, 43520, '\P{_ In_Myanmar_extended_b}', "");
    Expect(0, 43520, '\P{^_ In_Myanmar_extended_b}', "");
    Error('\p{:=MYANMAR_Ext_B}');
    Error('\P{:=MYANMAR_Ext_B}');
    Expect(1, 43519, '\p{myanmarextb}', "");
    Expect(0, 43519, '\p{^myanmarextb}', "");
    Expect(0, 43519, '\P{myanmarextb}', "");
    Expect(1, 43519, '\P{^myanmarextb}', "");
    Expect(0, 43520, '\p{myanmarextb}', "");
    Expect(1, 43520, '\p{^myanmarextb}', "");
    Expect(1, 43520, '\P{myanmarextb}', "");
    Expect(0, 43520, '\P{^myanmarextb}', "");
    Expect(1, 43519, '\p{	 Myanmar_Ext_B}', "");
    Expect(0, 43519, '\p{^	 Myanmar_Ext_B}', "");
    Expect(0, 43519, '\P{	 Myanmar_Ext_B}', "");
    Expect(1, 43519, '\P{^	 Myanmar_Ext_B}', "");
    Expect(0, 43520, '\p{	 Myanmar_Ext_B}', "");
    Expect(1, 43520, '\p{^	 Myanmar_Ext_B}', "");
    Expect(1, 43520, '\P{	 Myanmar_Ext_B}', "");
    Expect(0, 43520, '\P{^	 Myanmar_Ext_B}', "");
    Error('\p{		Is_myanmar_EXT_B/a/}');
    Error('\P{		Is_myanmar_EXT_B/a/}');
    Expect(1, 43519, '\p{ismyanmarextb}', "");
    Expect(0, 43519, '\p{^ismyanmarextb}', "");
    Expect(0, 43519, '\P{ismyanmarextb}', "");
    Expect(1, 43519, '\P{^ismyanmarextb}', "");
    Expect(0, 43520, '\p{ismyanmarextb}', "");
    Expect(1, 43520, '\p{^ismyanmarextb}', "");
    Expect(1, 43520, '\P{ismyanmarextb}', "");
    Expect(0, 43520, '\P{^ismyanmarextb}', "");
    Expect(1, 43519, '\p{	Is_Myanmar_EXT_B}', "");
    Expect(0, 43519, '\p{^	Is_Myanmar_EXT_B}', "");
    Expect(0, 43519, '\P{	Is_Myanmar_EXT_B}', "");
    Expect(1, 43519, '\P{^	Is_Myanmar_EXT_B}', "");
    Expect(0, 43520, '\p{	Is_Myanmar_EXT_B}', "");
    Expect(1, 43520, '\p{^	Is_Myanmar_EXT_B}', "");
    Expect(1, 43520, '\P{	Is_Myanmar_EXT_B}', "");
    Expect(0, 43520, '\P{^	Is_Myanmar_EXT_B}', "");
    Error('\p{/a/In_Myanmar_ext_b}');
    Error('\P{/a/In_Myanmar_ext_b}');
    Expect(1, 43519, '\p{inmyanmarextb}', "");
    Expect(0, 43519, '\p{^inmyanmarextb}', "");
    Expect(0, 43519, '\P{inmyanmarextb}', "");
    Expect(1, 43519, '\P{^inmyanmarextb}', "");
    Expect(0, 43520, '\p{inmyanmarextb}', "");
    Expect(1, 43520, '\p{^inmyanmarextb}', "");
    Expect(1, 43520, '\P{inmyanmarextb}', "");
    Expect(0, 43520, '\P{^inmyanmarextb}', "");
    Expect(1, 43519, '\p{_	in_MYANMAR_ext_B}', "");
    Expect(0, 43519, '\p{^_	in_MYANMAR_ext_B}', "");
    Expect(0, 43519, '\P{_	in_MYANMAR_ext_B}', "");
    Expect(1, 43519, '\P{^_	in_MYANMAR_ext_B}', "");
    Expect(0, 43520, '\p{_	in_MYANMAR_ext_B}', "");
    Expect(1, 43520, '\p{^_	in_MYANMAR_ext_B}', "");
    Expect(1, 43520, '\P{_	in_MYANMAR_ext_B}', "");
    Expect(0, 43520, '\P{^_	in_MYANMAR_ext_B}', "");
    Error('\p{_/a/Nabataean}');
    Error('\P{_/a/Nabataean}');
    Expect(1, 67759, '\p{nabataean}', "");
    Expect(0, 67759, '\p{^nabataean}', "");
    Expect(0, 67759, '\P{nabataean}', "");
    Expect(1, 67759, '\P{^nabataean}', "");
    Expect(0, 67760, '\p{nabataean}', "");
    Expect(1, 67760, '\p{^nabataean}', "");
    Expect(1, 67760, '\P{nabataean}', "");
    Expect(0, 67760, '\P{^nabataean}', "");
    Expect(1, 67759, '\p{_Nabataean}', "");
    Expect(0, 67759, '\p{^_Nabataean}', "");
    Expect(0, 67759, '\P{_Nabataean}', "");
    Expect(1, 67759, '\P{^_Nabataean}', "");
    Expect(0, 67760, '\p{_Nabataean}', "");
    Expect(1, 67760, '\p{^_Nabataean}', "");
    Expect(1, 67760, '\P{_Nabataean}', "");
    Expect(0, 67760, '\P{^_Nabataean}', "");
    Error('\p{/a/	Is_NABATAEAN}');
    Error('\P{/a/	Is_NABATAEAN}');
    Expect(1, 67759, '\p{isnabataean}', "");
    Expect(0, 67759, '\p{^isnabataean}', "");
    Expect(0, 67759, '\P{isnabataean}', "");
    Expect(1, 67759, '\P{^isnabataean}', "");
    Expect(0, 67760, '\p{isnabataean}', "");
    Expect(1, 67760, '\p{^isnabataean}', "");
    Expect(1, 67760, '\P{isnabataean}', "");
    Expect(0, 67760, '\P{^isnabataean}', "");
    Expect(1, 67759, '\p{_	Is_Nabataean}', "");
    Expect(0, 67759, '\p{^_	Is_Nabataean}', "");
    Expect(0, 67759, '\P{_	Is_Nabataean}', "");
    Expect(1, 67759, '\P{^_	Is_Nabataean}', "");
    Expect(0, 67760, '\p{_	Is_Nabataean}', "");
    Expect(1, 67760, '\p{^_	Is_Nabataean}', "");
    Expect(1, 67760, '\P{_	Is_Nabataean}', "");
    Expect(0, 67760, '\P{^_	Is_Nabataean}', "");
    Error('\p{:= _NBAT}');
    Error('\P{:= _NBAT}');
    Expect(1, 67759, '\p{nbat}', "");
    Expect(0, 67759, '\p{^nbat}', "");
    Expect(0, 67759, '\P{nbat}', "");
    Expect(1, 67759, '\P{^nbat}', "");
    Expect(0, 67760, '\p{nbat}', "");
    Expect(1, 67760, '\p{^nbat}', "");
    Expect(1, 67760, '\P{nbat}', "");
    Expect(0, 67760, '\P{^nbat}', "");
    Expect(1, 67759, '\p{ -nbat}', "");
    Expect(0, 67759, '\p{^ -nbat}', "");
    Expect(0, 67759, '\P{ -nbat}', "");
    Expect(1, 67759, '\P{^ -nbat}', "");
    Expect(0, 67760, '\p{ -nbat}', "");
    Expect(1, 67760, '\p{^ -nbat}', "");
    Expect(1, 67760, '\P{ -nbat}', "");
    Expect(0, 67760, '\P{^ -nbat}', "");
    Error('\p{:=-	Is_nbat}');
    Error('\P{:=-	Is_nbat}');
    Expect(1, 67759, '\p{isnbat}', "");
    Expect(0, 67759, '\p{^isnbat}', "");
    Expect(0, 67759, '\P{isnbat}', "");
    Expect(1, 67759, '\P{^isnbat}', "");
    Expect(0, 67760, '\p{isnbat}', "");
    Expect(1, 67760, '\p{^isnbat}', "");
    Expect(1, 67760, '\P{isnbat}', "");
    Expect(0, 67760, '\P{^isnbat}', "");
    Expect(1, 67759, '\p{-Is_nbat}', "");
    Expect(0, 67759, '\p{^-Is_nbat}', "");
    Expect(0, 67759, '\P{-Is_nbat}', "");
    Expect(1, 67759, '\P{^-Is_nbat}', "");
    Expect(0, 67760, '\p{-Is_nbat}', "");
    Expect(1, 67760, '\p{^-Is_nbat}', "");
    Expect(1, 67760, '\P{-Is_nbat}', "");
    Expect(0, 67760, '\P{^-Is_nbat}', "");
    Error('\p{_:=NAG_Mundari}');
    Error('\P{_:=NAG_Mundari}');
    Expect(1, 124153, '\p{nagmundari}', "");
    Expect(0, 124153, '\p{^nagmundari}', "");
    Expect(0, 124153, '\P{nagmundari}', "");
    Expect(1, 124153, '\P{^nagmundari}', "");
    Expect(0, 124154, '\p{nagmundari}', "");
    Expect(1, 124154, '\p{^nagmundari}', "");
    Expect(1, 124154, '\P{nagmundari}', "");
    Expect(0, 124154, '\P{^nagmundari}', "");
    Expect(1, 124153, '\p{ _Nag_mundari}', "");
    Expect(0, 124153, '\p{^ _Nag_mundari}', "");
    Expect(0, 124153, '\P{ _Nag_mundari}', "");
    Expect(1, 124153, '\P{^ _Nag_mundari}', "");
    Expect(0, 124154, '\p{ _Nag_mundari}', "");
    Expect(1, 124154, '\p{^ _Nag_mundari}', "");
    Expect(1, 124154, '\P{ _Nag_mundari}', "");
    Expect(0, 124154, '\P{^ _Nag_mundari}', "");
    Error('\p{__Is_Nag_MUNDARI:=}');
    Error('\P{__Is_Nag_MUNDARI:=}');
    Expect(1, 124153, '\p{isnagmundari}', "");
    Expect(0, 124153, '\p{^isnagmundari}', "");
    Expect(0, 124153, '\P{isnagmundari}', "");
    Expect(1, 124153, '\P{^isnagmundari}', "");
    Expect(0, 124154, '\p{isnagmundari}', "");
    Expect(1, 124154, '\p{^isnagmundari}', "");
    Expect(1, 124154, '\P{isnagmundari}', "");
    Expect(0, 124154, '\P{^isnagmundari}', "");
    Expect(1, 124153, '\p{  IS_Nag_MUNDARI}', "");
    Expect(0, 124153, '\p{^  IS_Nag_MUNDARI}', "");
    Expect(0, 124153, '\P{  IS_Nag_MUNDARI}', "");
    Expect(1, 124153, '\P{^  IS_Nag_MUNDARI}', "");
    Expect(0, 124154, '\p{  IS_Nag_MUNDARI}', "");
    Expect(1, 124154, '\p{^  IS_Nag_MUNDARI}', "");
    Expect(1, 124154, '\P{  IS_Nag_MUNDARI}', "");
    Expect(0, 124154, '\P{^  IS_Nag_MUNDARI}', "");
    Error('\p{:=_	Nagm}');
    Error('\P{:=_	Nagm}');
    Expect(1, 124153, '\p{nagm}', "");
    Expect(0, 124153, '\p{^nagm}', "");
    Expect(0, 124153, '\P{nagm}', "");
    Expect(1, 124153, '\P{^nagm}', "");
    Expect(0, 124154, '\p{nagm}', "");
    Expect(1, 124154, '\p{^nagm}', "");
    Expect(1, 124154, '\P{nagm}', "");
    Expect(0, 124154, '\P{^nagm}', "");
    Expect(1, 124153, '\p{ Nagm}', "");
    Expect(0, 124153, '\p{^ Nagm}', "");
    Expect(0, 124153, '\P{ Nagm}', "");
    Expect(1, 124153, '\P{^ Nagm}', "");
    Expect(0, 124154, '\p{ Nagm}', "");
    Expect(1, 124154, '\p{^ Nagm}', "");
    Expect(1, 124154, '\P{ Nagm}', "");
    Expect(0, 124154, '\P{^ Nagm}', "");
    Error('\p{:=_Is_NAGM}');
    Error('\P{:=_Is_NAGM}');
    Expect(1, 124153, '\p{isnagm}', "");
    Expect(0, 124153, '\p{^isnagm}', "");
    Expect(0, 124153, '\P{isnagm}', "");
    Expect(1, 124153, '\P{^isnagm}', "");
    Expect(0, 124154, '\p{isnagm}', "");
    Expect(1, 124154, '\p{^isnagm}', "");
    Expect(1, 124154, '\P{isnagm}', "");
    Expect(0, 124154, '\P{^isnagm}', "");
    Expect(1, 124153, '\p{- Is_Nagm}', "");
    Expect(0, 124153, '\p{^- Is_Nagm}', "");
    Expect(0, 124153, '\P{- Is_Nagm}', "");
    Expect(1, 124153, '\P{^- Is_Nagm}', "");
    Expect(0, 124154, '\p{- Is_Nagm}', "");
    Expect(1, 124154, '\p{^- Is_Nagm}', "");
    Expect(1, 124154, '\P{- Is_Nagm}', "");
    Expect(0, 124154, '\P{^- Is_Nagm}', "");
    Error('\p{	:=Nandinagari}');
    Error('\P{	:=Nandinagari}');
    Expect(1, 72164, '\p{nandinagari}', "");
    Expect(0, 72164, '\p{^nandinagari}', "");
    Expect(0, 72164, '\P{nandinagari}', "");
    Expect(1, 72164, '\P{^nandinagari}', "");
    Expect(0, 72165, '\p{nandinagari}', "");
    Expect(1, 72165, '\p{^nandinagari}', "");
    Expect(1, 72165, '\P{nandinagari}', "");
    Expect(0, 72165, '\P{^nandinagari}', "");
    Expect(1, 72164, '\p{ NANDINAGARI}', "");
    Expect(0, 72164, '\p{^ NANDINAGARI}', "");
    Expect(0, 72164, '\P{ NANDINAGARI}', "");
    Expect(1, 72164, '\P{^ NANDINAGARI}', "");
    Expect(0, 72165, '\p{ NANDINAGARI}', "");
    Expect(1, 72165, '\p{^ NANDINAGARI}', "");
    Expect(1, 72165, '\P{ NANDINAGARI}', "");
    Expect(0, 72165, '\P{^ NANDINAGARI}', "");
    Error('\p{-_is_Nandinagari/a/}');
    Error('\P{-_is_Nandinagari/a/}');
    Expect(1, 72164, '\p{isnandinagari}', "");
    Expect(0, 72164, '\p{^isnandinagari}', "");
    Expect(0, 72164, '\P{isnandinagari}', "");
    Expect(1, 72164, '\P{^isnandinagari}', "");
    Expect(0, 72165, '\p{isnandinagari}', "");
    Expect(1, 72165, '\p{^isnandinagari}', "");
    Expect(1, 72165, '\P{isnandinagari}', "");
    Expect(0, 72165, '\P{^isnandinagari}', "");
    Expect(1, 72164, '\p{  IS_Nandinagari}', "");
    Expect(0, 72164, '\p{^  IS_Nandinagari}', "");
    Expect(0, 72164, '\P{  IS_Nandinagari}', "");
    Expect(1, 72164, '\P{^  IS_Nandinagari}', "");
    Expect(0, 72165, '\p{  IS_Nandinagari}', "");
    Expect(1, 72165, '\p{^  IS_Nandinagari}', "");
    Expect(1, 72165, '\P{  IS_Nandinagari}', "");
    Expect(0, 72165, '\P{^  IS_Nandinagari}', "");
    Error('\p{:=NAND}');
    Error('\P{:=NAND}');
    Expect(1, 72164, '\p{nand}', "");
    Expect(0, 72164, '\p{^nand}', "");
    Expect(0, 72164, '\P{nand}', "");
    Expect(1, 72164, '\P{^nand}', "");
    Expect(0, 72165, '\p{nand}', "");
    Expect(1, 72165, '\p{^nand}', "");
    Expect(1, 72165, '\P{nand}', "");
    Expect(0, 72165, '\P{^nand}', "");
    Expect(1, 72164, '\p{--Nand}', "");
    Expect(0, 72164, '\p{^--Nand}', "");
    Expect(0, 72164, '\P{--Nand}', "");
    Expect(1, 72164, '\P{^--Nand}', "");
    Expect(0, 72165, '\p{--Nand}', "");
    Expect(1, 72165, '\p{^--Nand}', "");
    Expect(1, 72165, '\P{--Nand}', "");
    Expect(0, 72165, '\P{^--Nand}', "");
    Error('\p{/a/	 Is_Nand}');
    Error('\P{/a/	 Is_Nand}');
    Expect(1, 72164, '\p{isnand}', "");
    Expect(0, 72164, '\p{^isnand}', "");
    Expect(0, 72164, '\P{isnand}', "");
    Expect(1, 72164, '\P{^isnand}', "");
    Expect(0, 72165, '\p{isnand}', "");
    Expect(1, 72165, '\p{^isnand}', "");
    Expect(1, 72165, '\P{isnand}', "");
    Expect(0, 72165, '\P{^isnand}', "");
    Expect(1, 72164, '\p{		Is_Nand}', "");
    Expect(0, 72164, '\p{^		Is_Nand}', "");
    Expect(0, 72164, '\P{		Is_Nand}', "");
    Expect(1, 72164, '\P{^		Is_Nand}', "");
    Expect(0, 72165, '\p{		Is_Nand}', "");
    Expect(1, 72165, '\p{^		Is_Nand}', "");
    Expect(1, 72165, '\P{		Is_Nand}', "");
    Expect(0, 72165, '\P{^		Is_Nand}', "");
    Error('\p{:=New_Tai_Lue}');
    Error('\P{:=New_Tai_Lue}');
    Expect(1, 6623, '\p{newtailue}', "");
    Expect(0, 6623, '\p{^newtailue}', "");
    Expect(0, 6623, '\P{newtailue}', "");
    Expect(1, 6623, '\P{^newtailue}', "");
    Expect(0, 6624, '\p{newtailue}', "");
    Expect(1, 6624, '\p{^newtailue}', "");
    Expect(1, 6624, '\P{newtailue}', "");
    Expect(0, 6624, '\P{^newtailue}', "");
    Expect(1, 6623, '\p{_New_TAI_Lue}', "");
    Expect(0, 6623, '\p{^_New_TAI_Lue}', "");
    Expect(0, 6623, '\P{_New_TAI_Lue}', "");
    Expect(1, 6623, '\P{^_New_TAI_Lue}', "");
    Expect(0, 6624, '\p{_New_TAI_Lue}', "");
    Expect(1, 6624, '\p{^_New_TAI_Lue}', "");
    Expect(1, 6624, '\P{_New_TAI_Lue}', "");
    Expect(0, 6624, '\P{^_New_TAI_Lue}', "");
    Error('\p{/a/IS_new_Tai_Lue}');
    Error('\P{/a/IS_new_Tai_Lue}');
    Expect(1, 6623, '\p{isnewtailue}', "");
    Expect(0, 6623, '\p{^isnewtailue}', "");
    Expect(0, 6623, '\P{isnewtailue}', "");
    Expect(1, 6623, '\P{^isnewtailue}', "");
    Expect(0, 6624, '\p{isnewtailue}', "");
    Expect(1, 6624, '\p{^isnewtailue}', "");
    Expect(1, 6624, '\P{isnewtailue}', "");
    Expect(0, 6624, '\P{^isnewtailue}', "");
    Expect(1, 6623, '\p{_-Is_NEW_TAI_lue}', "");
    Expect(0, 6623, '\p{^_-Is_NEW_TAI_lue}', "");
    Expect(0, 6623, '\P{_-Is_NEW_TAI_lue}', "");
    Expect(1, 6623, '\P{^_-Is_NEW_TAI_lue}', "");
    Expect(0, 6624, '\p{_-Is_NEW_TAI_lue}', "");
    Expect(1, 6624, '\p{^_-Is_NEW_TAI_lue}', "");
    Expect(1, 6624, '\P{_-Is_NEW_TAI_lue}', "");
    Expect(0, 6624, '\P{^_-Is_NEW_TAI_lue}', "");
    Error('\p{/a/__talu}');
    Error('\P{/a/__talu}');
    Expect(1, 6623, '\p{talu}', "");
    Expect(0, 6623, '\p{^talu}', "");
    Expect(0, 6623, '\P{talu}', "");
    Expect(1, 6623, '\P{^talu}', "");
    Expect(0, 6624, '\p{talu}', "");
    Expect(1, 6624, '\p{^talu}', "");
    Expect(1, 6624, '\P{talu}', "");
    Expect(0, 6624, '\P{^talu}', "");
    Expect(1, 6623, '\p{_-Talu}', "");
    Expect(0, 6623, '\p{^_-Talu}', "");
    Expect(0, 6623, '\P{_-Talu}', "");
    Expect(1, 6623, '\P{^_-Talu}', "");
    Expect(0, 6624, '\p{_-Talu}', "");
    Expect(1, 6624, '\p{^_-Talu}', "");
    Expect(1, 6624, '\P{_-Talu}', "");
    Expect(0, 6624, '\P{^_-Talu}', "");
    Error('\p{	Is_Talu/a/}');
    Error('\P{	Is_Talu/a/}');
    Expect(1, 6623, '\p{istalu}', "");
    Expect(0, 6623, '\p{^istalu}', "");
    Expect(0, 6623, '\P{istalu}', "");
    Expect(1, 6623, '\P{^istalu}', "");
    Expect(0, 6624, '\p{istalu}', "");
    Expect(1, 6624, '\p{^istalu}', "");
    Expect(1, 6624, '\P{istalu}', "");
    Expect(0, 6624, '\P{^istalu}', "");
    Expect(1, 6623, '\p{	-is_Talu}', "");
    Expect(0, 6623, '\p{^	-is_Talu}', "");
    Expect(0, 6623, '\P{	-is_Talu}', "");
    Expect(1, 6623, '\P{^	-is_Talu}', "");
    Expect(0, 6624, '\p{	-is_Talu}', "");
    Expect(1, 6624, '\p{^	-is_Talu}', "");
    Expect(1, 6624, '\P{	-is_Talu}', "");
    Expect(0, 6624, '\P{^	-is_Talu}', "");
    Error('\p{-:=newa}');
    Error('\P{-:=newa}');
    Expect(1, 70753, '\p{newa}', "");
    Expect(0, 70753, '\p{^newa}', "");
    Expect(0, 70753, '\P{newa}', "");
    Expect(1, 70753, '\P{^newa}', "");
    Expect(0, 70754, '\p{newa}', "");
    Expect(1, 70754, '\p{^newa}', "");
    Expect(1, 70754, '\P{newa}', "");
    Expect(0, 70754, '\P{^newa}', "");
    Expect(1, 70753, '\p{  Newa}', "");
    Expect(0, 70753, '\p{^  Newa}', "");
    Expect(0, 70753, '\P{  Newa}', "");
    Expect(1, 70753, '\P{^  Newa}', "");
    Expect(0, 70754, '\p{  Newa}', "");
    Expect(1, 70754, '\p{^  Newa}', "");
    Expect(1, 70754, '\P{  Newa}', "");
    Expect(0, 70754, '\P{^  Newa}', "");
    Error('\p{_	Is_Newa/a/}');
    Error('\P{_	Is_Newa/a/}');
    Expect(1, 70753, '\p{isnewa}', "");
    Expect(0, 70753, '\p{^isnewa}', "");
    Expect(0, 70753, '\P{isnewa}', "");
    Expect(1, 70753, '\P{^isnewa}', "");
    Expect(0, 70754, '\p{isnewa}', "");
    Expect(1, 70754, '\p{^isnewa}', "");
    Expect(1, 70754, '\P{isnewa}', "");
    Expect(0, 70754, '\P{^isnewa}', "");
    Expect(1, 70753, '\p{_ IS_NEWA}', "");
    Expect(0, 70753, '\p{^_ IS_NEWA}', "");
    Expect(0, 70753, '\P{_ IS_NEWA}', "");
    Expect(1, 70753, '\P{^_ IS_NEWA}', "");
    Expect(0, 70754, '\p{_ IS_NEWA}', "");
    Expect(1, 70754, '\p{^_ IS_NEWA}', "");
    Expect(1, 70754, '\P{_ IS_NEWA}', "");
    Expect(0, 70754, '\P{^_ IS_NEWA}', "");
    Error('\p{_:=Nko}');
    Error('\P{_:=Nko}');
    Expect(1, 64831, '\p{nko}', "");
    Expect(0, 64831, '\p{^nko}', "");
    Expect(0, 64831, '\P{nko}', "");
    Expect(1, 64831, '\P{^nko}', "");
    Expect(0, 64832, '\p{nko}', "");
    Expect(1, 64832, '\p{^nko}', "");
    Expect(1, 64832, '\P{nko}', "");
    Expect(0, 64832, '\P{^nko}', "");
    Expect(1, 64831, '\p{-nko}', "");
    Expect(0, 64831, '\p{^-nko}', "");
    Expect(0, 64831, '\P{-nko}', "");
    Expect(1, 64831, '\P{^-nko}', "");
    Expect(0, 64832, '\p{-nko}', "");
    Expect(1, 64832, '\p{^-nko}', "");
    Expect(1, 64832, '\P{-nko}', "");
    Expect(0, 64832, '\P{^-nko}', "");
    Error('\p{/a/_	Is_Nko}');
    Error('\P{/a/_	Is_Nko}');
    Expect(1, 64831, '\p{isnko}', "");
    Expect(0, 64831, '\p{^isnko}', "");
    Expect(0, 64831, '\P{isnko}', "");
    Expect(1, 64831, '\P{^isnko}', "");
    Expect(0, 64832, '\p{isnko}', "");
    Expect(1, 64832, '\p{^isnko}', "");
    Expect(1, 64832, '\P{isnko}', "");
    Expect(0, 64832, '\P{^isnko}', "");
    Expect(1, 64831, '\p{--is_NKO}', "");
    Expect(0, 64831, '\p{^--is_NKO}', "");
    Expect(0, 64831, '\P{--is_NKO}', "");
    Expect(1, 64831, '\P{^--is_NKO}', "");
    Expect(0, 64832, '\p{--is_NKO}', "");
    Expect(1, 64832, '\p{^--is_NKO}', "");
    Expect(1, 64832, '\P{--is_NKO}', "");
    Expect(0, 64832, '\P{^--is_NKO}', "");
    Error('\p{:= _Nkoo}');
    Error('\P{:= _Nkoo}');
    Expect(1, 64831, '\p{nkoo}', "");
    Expect(0, 64831, '\p{^nkoo}', "");
    Expect(0, 64831, '\P{nkoo}', "");
    Expect(1, 64831, '\P{^nkoo}', "");
    Expect(0, 64832, '\p{nkoo}', "");
    Expect(1, 64832, '\p{^nkoo}', "");
    Expect(1, 64832, '\P{nkoo}', "");
    Expect(0, 64832, '\P{^nkoo}', "");
    Expect(1, 64831, '\p{-Nkoo}', "");
    Expect(0, 64831, '\p{^-Nkoo}', "");
    Expect(0, 64831, '\P{-Nkoo}', "");
    Expect(1, 64831, '\P{^-Nkoo}', "");
    Expect(0, 64832, '\p{-Nkoo}', "");
    Expect(1, 64832, '\p{^-Nkoo}', "");
    Expect(1, 64832, '\P{-Nkoo}', "");
    Expect(0, 64832, '\P{^-Nkoo}', "");
    Error('\p{- IS_Nkoo/a/}');
    Error('\P{- IS_Nkoo/a/}');
    Expect(1, 64831, '\p{isnkoo}', "");
    Expect(0, 64831, '\p{^isnkoo}', "");
    Expect(0, 64831, '\P{isnkoo}', "");
    Expect(1, 64831, '\P{^isnkoo}', "");
    Expect(0, 64832, '\p{isnkoo}', "");
    Expect(1, 64832, '\p{^isnkoo}', "");
    Expect(1, 64832, '\P{isnkoo}', "");
    Expect(0, 64832, '\P{^isnkoo}', "");
    Expect(1, 64831, '\p{ -Is_Nkoo}', "");
    Expect(0, 64831, '\p{^ -Is_Nkoo}', "");
    Expect(0, 64831, '\P{ -Is_Nkoo}', "");
    Expect(1, 64831, '\P{^ -Is_Nkoo}', "");
    Expect(0, 64832, '\p{ -Is_Nkoo}', "");
    Expect(1, 64832, '\p{^ -Is_Nkoo}', "");
    Expect(1, 64832, '\P{ -Is_Nkoo}', "");
    Expect(0, 64832, '\P{^ -Is_Nkoo}', "");
    Error('\p{:=  NO_Block}');
    Error('\P{:=  NO_Block}');
    Expect(1, 918000, '\p{noblock}', "");
    Expect(0, 918000, '\p{^noblock}', "");
    Expect(0, 918000, '\P{noblock}', "");
    Expect(1, 918000, '\P{^noblock}', "");
    Expect(0, 983040, '\p{noblock}', "");
    Expect(1, 983040, '\p{^noblock}', "");
    Expect(1, 983040, '\P{noblock}', "");
    Expect(0, 983040, '\P{^noblock}', "");
    Expect(1, 918000, '\p{_no_Block}', "");
    Expect(0, 918000, '\p{^_no_Block}', "");
    Expect(0, 918000, '\P{_no_Block}', "");
    Expect(1, 918000, '\P{^_no_Block}', "");
    Expect(0, 983040, '\p{_no_Block}', "");
    Expect(1, 983040, '\p{^_no_Block}', "");
    Expect(1, 983040, '\P{_no_Block}', "");
    Expect(0, 983040, '\P{^_no_Block}', "");
    Error('\p{_is_NO_block/a/}');
    Error('\P{_is_NO_block/a/}');
    Expect(1, 918000, '\p{isnoblock}', "");
    Expect(0, 918000, '\p{^isnoblock}', "");
    Expect(0, 918000, '\P{isnoblock}', "");
    Expect(1, 918000, '\P{^isnoblock}', "");
    Expect(0, 983040, '\p{isnoblock}', "");
    Expect(1, 983040, '\p{^isnoblock}', "");
    Expect(1, 983040, '\P{isnoblock}', "");
    Expect(0, 983040, '\P{^isnoblock}', "");
    Expect(1, 918000, '\p{	-Is_No_BLOCK}', "");
    Expect(0, 918000, '\p{^	-Is_No_BLOCK}', "");
    Expect(0, 918000, '\P{	-Is_No_BLOCK}', "");
    Expect(1, 918000, '\P{^	-Is_No_BLOCK}', "");
    Expect(0, 983040, '\p{	-Is_No_BLOCK}', "");
    Expect(1, 983040, '\p{^	-Is_No_BLOCK}', "");
    Expect(1, 983040, '\P{	-Is_No_BLOCK}', "");
    Expect(0, 983040, '\P{^	-Is_No_BLOCK}', "");
    Error('\p{:=	in_NO_block}');
    Error('\P{:=	in_NO_block}');
    Expect(1, 918000, '\p{innoblock}', "");
    Expect(0, 918000, '\p{^innoblock}', "");
    Expect(0, 918000, '\P{innoblock}', "");
    Expect(1, 918000, '\P{^innoblock}', "");
    Expect(0, 983040, '\p{innoblock}', "");
    Expect(1, 983040, '\p{^innoblock}', "");
    Expect(1, 983040, '\P{innoblock}', "");
    Expect(0, 983040, '\P{^innoblock}', "");
    Expect(1, 918000, '\p{ In_no_Block}', "");
    Expect(0, 918000, '\p{^ In_no_Block}', "");
    Expect(0, 918000, '\P{ In_no_Block}', "");
    Expect(1, 918000, '\P{^ In_no_Block}', "");
    Expect(0, 983040, '\p{ In_no_Block}', "");
    Expect(1, 983040, '\p{^ In_no_Block}', "");
    Expect(1, 983040, '\P{ In_no_Block}', "");
    Expect(0, 983040, '\P{^ In_no_Block}', "");
    Error('\p{:=_NB}');
    Error('\P{:=_NB}');
    Expect(1, 918000, '\p{nb}', "");
    Expect(0, 918000, '\p{^nb}', "");
    Expect(0, 918000, '\P{nb}', "");
    Expect(1, 918000, '\P{^nb}', "");
    Expect(0, 983040, '\p{nb}', "");
    Expect(1, 983040, '\p{^nb}', "");
    Expect(1, 983040, '\P{nb}', "");
    Expect(0, 983040, '\P{^nb}', "");
    Expect(1, 918000, '\p{  NB}', "");
    Expect(0, 918000, '\p{^  NB}', "");
    Expect(0, 918000, '\P{  NB}', "");
    Expect(1, 918000, '\P{^  NB}', "");
    Expect(0, 983040, '\p{  NB}', "");
    Expect(1, 983040, '\p{^  NB}', "");
    Expect(1, 983040, '\P{  NB}', "");
    Expect(0, 983040, '\P{^  NB}', "");
    Error('\p{_-is_NB:=}');
    Error('\P{_-is_NB:=}');
    Expect(1, 918000, '\p{isnb}', "");
    Expect(0, 918000, '\p{^isnb}', "");
    Expect(0, 918000, '\P{isnb}', "");
    Expect(1, 918000, '\P{^isnb}', "");
    Expect(0, 983040, '\p{isnb}', "");
    Expect(1, 983040, '\p{^isnb}', "");
    Expect(1, 983040, '\P{isnb}', "");
    Expect(0, 983040, '\P{^isnb}', "");
    Expect(1, 918000, '\p{-IS_nb}', "");
    Expect(0, 918000, '\p{^-IS_nb}', "");
    Expect(0, 918000, '\P{-IS_nb}', "");
    Expect(1, 918000, '\P{^-IS_nb}', "");
    Expect(0, 983040, '\p{-IS_nb}', "");
    Expect(1, 983040, '\p{^-IS_nb}', "");
    Expect(1, 983040, '\P{-IS_nb}', "");
    Expect(0, 983040, '\P{^-IS_nb}', "");
    Error('\p{-	In_NB/a/}');
    Error('\P{-	In_NB/a/}');
    Expect(1, 918000, '\p{innb}', "");
    Expect(0, 918000, '\p{^innb}', "");
    Expect(0, 918000, '\P{innb}', "");
    Expect(1, 918000, '\P{^innb}', "");
    Expect(0, 983040, '\p{innb}', "");
    Expect(1, 983040, '\p{^innb}', "");
    Expect(1, 983040, '\P{innb}', "");
    Expect(0, 983040, '\P{^innb}', "");
    Expect(1, 918000, '\p{-_in_NB}', "");
    Expect(0, 918000, '\p{^-_in_NB}', "");
    Expect(0, 918000, '\P{-_in_NB}', "");
    Expect(1, 918000, '\P{^-_in_NB}', "");
    Expect(0, 983040, '\p{-_in_NB}', "");
    Expect(1, 983040, '\p{^-_in_NB}', "");
    Expect(1, 983040, '\P{-_in_NB}', "");
    Expect(0, 983040, '\P{^-_in_NB}', "");
    Error('\p{-Noncharacter_Code_Point:=}');
    Error('\P{-Noncharacter_Code_Point:=}');
    Expect(1, 1114111, '\p{noncharactercodepoint}', "");
    Expect(0, 1114111, '\p{^noncharactercodepoint}', "");
    Expect(0, 1114111, '\P{noncharactercodepoint}', "");
    Expect(1, 1114111, '\P{^noncharactercodepoint}', "");
    Expect(0, 1114109, '\p{noncharactercodepoint}', "");
    Expect(1, 1114109, '\p{^noncharactercodepoint}', "");
    Expect(1, 1114109, '\P{noncharactercodepoint}', "");
    Expect(0, 1114109, '\P{^noncharactercodepoint}', "");
    Expect(1, 1114111, '\p{-NONCHARACTER_Code_Point}', "");
    Expect(0, 1114111, '\p{^-NONCHARACTER_Code_Point}', "");
    Expect(0, 1114111, '\P{-NONCHARACTER_Code_Point}', "");
    Expect(1, 1114111, '\P{^-NONCHARACTER_Code_Point}', "");
    Expect(0, 1114109, '\p{-NONCHARACTER_Code_Point}', "");
    Expect(1, 1114109, '\p{^-NONCHARACTER_Code_Point}', "");
    Expect(1, 1114109, '\P{-NONCHARACTER_Code_Point}', "");
    Expect(0, 1114109, '\P{^-NONCHARACTER_Code_Point}', "");
    Error('\p{_-IS_Noncharacter_Code_POINT:=}');
    Error('\P{_-IS_Noncharacter_Code_POINT:=}');
    Expect(1, 1114111, '\p{isnoncharactercodepoint}', "");
    Expect(0, 1114111, '\p{^isnoncharactercodepoint}', "");
    Expect(0, 1114111, '\P{isnoncharactercodepoint}', "");
    Expect(1, 1114111, '\P{^isnoncharactercodepoint}', "");
    Expect(0, 1114109, '\p{isnoncharactercodepoint}', "");
    Expect(1, 1114109, '\p{^isnoncharactercodepoint}', "");
    Expect(1, 1114109, '\P{isnoncharactercodepoint}', "");
    Expect(0, 1114109, '\P{^isnoncharactercodepoint}', "");
    Expect(1, 1114111, '\p{-_IS_Noncharacter_Code_Point}', "");
    Expect(0, 1114111, '\p{^-_IS_Noncharacter_Code_Point}', "");
    Expect(0, 1114111, '\P{-_IS_Noncharacter_Code_Point}', "");
    Expect(1, 1114111, '\P{^-_IS_Noncharacter_Code_Point}', "");
    Expect(0, 1114109, '\p{-_IS_Noncharacter_Code_Point}', "");
    Expect(1, 1114109, '\p{^-_IS_Noncharacter_Code_Point}', "");
    Expect(1, 1114109, '\P{-_IS_Noncharacter_Code_Point}', "");
    Expect(0, 1114109, '\P{^-_IS_Noncharacter_Code_Point}', "");
    Error('\p{_NChar:=}');
    Error('\P{_NChar:=}');
    Expect(1, 1114111, '\p{nchar}', "");
    Expect(0, 1114111, '\p{^nchar}', "");
    Expect(0, 1114111, '\P{nchar}', "");
    Expect(1, 1114111, '\P{^nchar}', "");
    Expect(0, 1114109, '\p{nchar}', "");
    Expect(1, 1114109, '\p{^nchar}', "");
    Expect(1, 1114109, '\P{nchar}', "");
    Expect(0, 1114109, '\P{^nchar}', "");
    Expect(1, 1114111, '\p{_nchar}', "");
    Expect(0, 1114111, '\p{^_nchar}', "");
    Expect(0, 1114111, '\P{_nchar}', "");
    Expect(1, 1114111, '\P{^_nchar}', "");
    Expect(0, 1114109, '\p{_nchar}', "");
    Expect(1, 1114109, '\p{^_nchar}', "");
    Expect(1, 1114109, '\P{_nchar}', "");
    Expect(0, 1114109, '\P{^_nchar}', "");
    Error('\p{-/a/Is_nchar}');
    Error('\P{-/a/Is_nchar}');
    Expect(1, 1114111, '\p{isnchar}', "");
    Expect(0, 1114111, '\p{^isnchar}', "");
    Expect(0, 1114111, '\P{isnchar}', "");
    Expect(1, 1114111, '\P{^isnchar}', "");
    Expect(0, 1114109, '\p{isnchar}', "");
    Expect(1, 1114109, '\p{^isnchar}', "");
    Expect(1, 1114109, '\P{isnchar}', "");
    Expect(0, 1114109, '\P{^isnchar}', "");
    Expect(1, 1114111, '\p{__IS_NChar}', "");
    Expect(0, 1114111, '\p{^__IS_NChar}', "");
    Expect(0, 1114111, '\P{__IS_NChar}', "");
    Expect(1, 1114111, '\P{^__IS_NChar}', "");
    Expect(0, 1114109, '\p{__IS_NChar}', "");
    Expect(1, 1114109, '\p{^__IS_NChar}', "");
    Expect(1, 1114109, '\P{__IS_NChar}', "");
    Expect(0, 1114109, '\P{^__IS_NChar}', "");
    Error('\p{ :=nonspacing_Mark}');
    Error('\P{ :=nonspacing_Mark}');
    Expect(1, 917999, '\p{nonspacingmark}', "");
    Expect(0, 917999, '\p{^nonspacingmark}', "");
    Expect(0, 917999, '\P{nonspacingmark}', "");
    Expect(1, 917999, '\P{^nonspacingmark}', "");
    Expect(0, 918000, '\p{nonspacingmark}', "");
    Expect(1, 918000, '\p{^nonspacingmark}', "");
    Expect(1, 918000, '\P{nonspacingmark}', "");
    Expect(0, 918000, '\P{^nonspacingmark}', "");
    Expect(1, 917999, '\p{- NONSPACING_Mark}', "");
    Expect(0, 917999, '\p{^- NONSPACING_Mark}', "");
    Expect(0, 917999, '\P{- NONSPACING_Mark}', "");
    Expect(1, 917999, '\P{^- NONSPACING_Mark}', "");
    Expect(0, 918000, '\p{- NONSPACING_Mark}', "");
    Expect(1, 918000, '\p{^- NONSPACING_Mark}', "");
    Expect(1, 918000, '\P{- NONSPACING_Mark}', "");
    Expect(0, 918000, '\P{^- NONSPACING_Mark}', "");
    Error('\p{--IS_Nonspacing_MARK/a/}');
    Error('\P{--IS_Nonspacing_MARK/a/}');
    Expect(1, 917999, '\p{isnonspacingmark}', "");
    Expect(0, 917999, '\p{^isnonspacingmark}', "");
    Expect(0, 917999, '\P{isnonspacingmark}', "");
    Expect(1, 917999, '\P{^isnonspacingmark}', "");
    Expect(0, 918000, '\p{isnonspacingmark}', "");
    Expect(1, 918000, '\p{^isnonspacingmark}', "");
    Expect(1, 918000, '\P{isnonspacingmark}', "");
    Expect(0, 918000, '\P{^isnonspacingmark}', "");
    Expect(1, 917999, '\p{ Is_NONSPACING_mark}', "");
    Expect(0, 917999, '\p{^ Is_NONSPACING_mark}', "");
    Expect(0, 917999, '\P{ Is_NONSPACING_mark}', "");
    Expect(1, 917999, '\P{^ Is_NONSPACING_mark}', "");
    Expect(0, 918000, '\p{ Is_NONSPACING_mark}', "");
    Expect(1, 918000, '\p{^ Is_NONSPACING_mark}', "");
    Expect(1, 918000, '\P{ Is_NONSPACING_mark}', "");
    Expect(0, 918000, '\P{^ Is_NONSPACING_mark}', "");
    Error('\p{	_Mn/a/}');
    Error('\P{	_Mn/a/}');
    Expect(1, 917999, '\p{mn}', "");
    Expect(0, 917999, '\p{^mn}', "");
    Expect(0, 917999, '\P{mn}', "");
    Expect(1, 917999, '\P{^mn}', "");
    Expect(0, 918000, '\p{mn}', "");
    Expect(1, 918000, '\p{^mn}', "");
    Expect(1, 918000, '\P{mn}', "");
    Expect(0, 918000, '\P{^mn}', "");
    Expect(1, 917999, '\p{	-mn}', "");
    Expect(0, 917999, '\p{^	-mn}', "");
    Expect(0, 917999, '\P{	-mn}', "");
    Expect(1, 917999, '\P{^	-mn}', "");
    Expect(0, 918000, '\p{	-mn}', "");
    Expect(1, 918000, '\p{^	-mn}', "");
    Expect(1, 918000, '\P{	-mn}', "");
    Expect(0, 918000, '\P{^	-mn}', "");
    Error('\p{/a/IS_Mn}');
    Error('\P{/a/IS_Mn}');
    Expect(1, 917999, '\p{ismn}', "");
    Expect(0, 917999, '\p{^ismn}', "");
    Expect(0, 917999, '\P{ismn}', "");
    Expect(1, 917999, '\P{^ismn}', "");
    Expect(0, 918000, '\p{ismn}', "");
    Expect(1, 918000, '\p{^ismn}', "");
    Expect(1, 918000, '\P{ismn}', "");
    Expect(0, 918000, '\P{^ismn}', "");
    Expect(1, 917999, '\p{ is_mn}', "");
    Expect(0, 917999, '\p{^ is_mn}', "");
    Expect(0, 917999, '\P{ is_mn}', "");
    Expect(1, 917999, '\P{^ is_mn}', "");
    Expect(0, 918000, '\p{ is_mn}', "");
    Expect(1, 918000, '\p{^ is_mn}', "");
    Expect(1, 918000, '\P{ is_mn}', "");
    Expect(0, 918000, '\P{^ is_mn}', "");
    Error('\p{ /a/number}');
    Error('\P{ /a/number}');
    Expect(1, 130041, '\p{number}', "");
    Expect(0, 130041, '\p{^number}', "");
    Expect(0, 130041, '\P{number}', "");
    Expect(1, 130041, '\P{^number}', "");
    Expect(0, 130042, '\p{number}', "");
    Expect(1, 130042, '\p{^number}', "");
    Expect(1, 130042, '\P{number}', "");
    Expect(0, 130042, '\P{^number}', "");
    Expect(1, 130041, '\p{_Number}', "");
    Expect(0, 130041, '\p{^_Number}', "");
    Expect(0, 130041, '\P{_Number}', "");
    Expect(1, 130041, '\P{^_Number}', "");
    Expect(0, 130042, '\p{_Number}', "");
    Expect(1, 130042, '\p{^_Number}', "");
    Expect(1, 130042, '\P{_Number}', "");
    Expect(0, 130042, '\P{^_Number}', "");
    Error('\p{/a/	-is_Number}');
    Error('\P{/a/	-is_Number}');
    Expect(1, 130041, '\p{isnumber}', "");
    Expect(0, 130041, '\p{^isnumber}', "");
    Expect(0, 130041, '\P{isnumber}', "");
    Expect(1, 130041, '\P{^isnumber}', "");
    Expect(0, 130042, '\p{isnumber}', "");
    Expect(1, 130042, '\p{^isnumber}', "");
    Expect(1, 130042, '\P{isnumber}', "");
    Expect(0, 130042, '\P{^isnumber}', "");
    Expect(1, 130041, '\p{_	IS_NUMBER}', "");
    Expect(0, 130041, '\p{^_	IS_NUMBER}', "");
    Expect(0, 130041, '\P{_	IS_NUMBER}', "");
    Expect(1, 130041, '\P{^_	IS_NUMBER}', "");
    Expect(0, 130042, '\p{_	IS_NUMBER}', "");
    Expect(1, 130042, '\p{^_	IS_NUMBER}', "");
    Expect(1, 130042, '\P{_	IS_NUMBER}', "");
    Expect(0, 130042, '\P{^_	IS_NUMBER}', "");
    Error('\p{:=_-N}');
    Error('\P{:=_-N}');
    Expect(1, 130041, '\p{n}', "");
    Expect(0, 130041, '\p{^n}', "");
    Expect(0, 130041, '\P{n}', "");
    Expect(1, 130041, '\P{^n}', "");
    Expect(0, 130042, '\p{n}', "");
    Expect(1, 130042, '\p{^n}', "");
    Expect(1, 130042, '\P{n}', "");
    Expect(0, 130042, '\P{^n}', "");
    Expect(1, 130041, '\p{ 	N}', "");
    Expect(0, 130041, '\p{^ 	N}', "");
    Expect(0, 130041, '\P{ 	N}', "");
    Expect(1, 130041, '\P{^ 	N}', "");
    Expect(0, 130042, '\p{ 	N}', "");
    Expect(1, 130042, '\p{^ 	N}', "");
    Expect(1, 130042, '\P{ 	N}', "");
    Expect(0, 130042, '\P{^ 	N}', "");
    Error('\p{/a/__IS_n}');
    Error('\P{/a/__IS_n}');
    Expect(1, 130041, '\p{isn}', "");
    Expect(0, 130041, '\p{^isn}', "");
    Expect(0, 130041, '\P{isn}', "");
    Expect(1, 130041, '\P{^isn}', "");
    Expect(0, 130042, '\p{isn}', "");
    Expect(1, 130042, '\p{^isn}', "");
    Expect(1, 130042, '\P{isn}', "");
    Expect(0, 130042, '\P{^isn}', "");
    Expect(1, 130041, '\p{Is_n}', "");
    Expect(0, 130041, '\p{^Is_n}', "");
    Expect(0, 130041, '\P{Is_n}', "");
    Expect(1, 130041, '\P{^Is_n}', "");
    Expect(0, 130042, '\p{Is_n}', "");
    Expect(1, 130042, '\p{^Is_n}', "");
    Expect(1, 130042, '\P{Is_n}', "");
    Expect(0, 130042, '\P{^Is_n}', "");
    Error('\p{-NUMBER_forms/a/}');
    Error('\P{-NUMBER_forms/a/}');
    Expect(1, 8591, '\p{numberforms}', "");
    Expect(0, 8591, '\p{^numberforms}', "");
    Expect(0, 8591, '\P{numberforms}', "");
    Expect(1, 8591, '\P{^numberforms}', "");
    Expect(0, 8592, '\p{numberforms}', "");
    Expect(1, 8592, '\p{^numberforms}', "");
    Expect(1, 8592, '\P{numberforms}', "");
    Expect(0, 8592, '\P{^numberforms}', "");
    Expect(1, 8591, '\p{-	number_FORMS}', "");
    Expect(0, 8591, '\p{^-	number_FORMS}', "");
    Expect(0, 8591, '\P{-	number_FORMS}', "");
    Expect(1, 8591, '\P{^-	number_FORMS}', "");
    Expect(0, 8592, '\p{-	number_FORMS}', "");
    Expect(1, 8592, '\p{^-	number_FORMS}', "");
    Expect(1, 8592, '\P{-	number_FORMS}', "");
    Expect(0, 8592, '\P{^-	number_FORMS}', "");
    Error('\p{-	Is_Number_Forms/a/}');
    Error('\P{-	Is_Number_Forms/a/}');
    Expect(1, 8591, '\p{isnumberforms}', "");
    Expect(0, 8591, '\p{^isnumberforms}', "");
    Expect(0, 8591, '\P{isnumberforms}', "");
    Expect(1, 8591, '\P{^isnumberforms}', "");
    Expect(0, 8592, '\p{isnumberforms}', "");
    Expect(1, 8592, '\p{^isnumberforms}', "");
    Expect(1, 8592, '\P{isnumberforms}', "");
    Expect(0, 8592, '\P{^isnumberforms}', "");
    Expect(1, 8591, '\p{-_Is_Number_FORMS}', "");
    Expect(0, 8591, '\p{^-_Is_Number_FORMS}', "");
    Expect(0, 8591, '\P{-_Is_Number_FORMS}', "");
    Expect(1, 8591, '\P{^-_Is_Number_FORMS}', "");
    Expect(0, 8592, '\p{-_Is_Number_FORMS}', "");
    Expect(1, 8592, '\p{^-_Is_Number_FORMS}', "");
    Expect(1, 8592, '\P{-_Is_Number_FORMS}', "");
    Expect(0, 8592, '\P{^-_Is_Number_FORMS}', "");
    Error('\p{_/a/IN_number_Forms}');
    Error('\P{_/a/IN_number_Forms}');
    Expect(1, 8591, '\p{innumberforms}', "");
    Expect(0, 8591, '\p{^innumberforms}', "");
    Expect(0, 8591, '\P{innumberforms}', "");
    Expect(1, 8591, '\P{^innumberforms}', "");
    Expect(0, 8592, '\p{innumberforms}', "");
    Expect(1, 8592, '\p{^innumberforms}', "");
    Expect(1, 8592, '\P{innumberforms}', "");
    Expect(0, 8592, '\P{^innumberforms}', "");
    Expect(1, 8591, '\p{ 	In_Number_Forms}', "");
    Expect(0, 8591, '\p{^ 	In_Number_Forms}', "");
    Expect(0, 8591, '\P{ 	In_Number_Forms}', "");
    Expect(1, 8591, '\P{^ 	In_Number_Forms}', "");
    Expect(0, 8592, '\p{ 	In_Number_Forms}', "");
    Expect(1, 8592, '\p{^ 	In_Number_Forms}', "");
    Expect(1, 8592, '\P{ 	In_Number_Forms}', "");
    Expect(0, 8592, '\P{^ 	In_Number_Forms}', "");
    Error('\p{/a/ 	Nushu}');
    Error('\P{/a/ 	Nushu}');
    Expect(1, 111355, '\p{nushu}', "");
    Expect(0, 111355, '\p{^nushu}', "");
    Expect(0, 111355, '\P{nushu}', "");
    Expect(1, 111355, '\P{^nushu}', "");
    Expect(0, 111356, '\p{nushu}', "");
    Expect(1, 111356, '\p{^nushu}', "");
    Expect(1, 111356, '\P{nushu}', "");
    Expect(0, 111356, '\P{^nushu}', "");
    Expect(1, 111355, '\p{-Nushu}', "");
    Expect(0, 111355, '\p{^-Nushu}', "");
    Expect(0, 111355, '\P{-Nushu}', "");
    Expect(1, 111355, '\P{^-Nushu}', "");
    Expect(0, 111356, '\p{-Nushu}', "");
    Expect(1, 111356, '\p{^-Nushu}', "");
    Expect(1, 111356, '\P{-Nushu}', "");
    Expect(0, 111356, '\P{^-Nushu}', "");
    Error('\p{_is_nushu:=}');
    Error('\P{_is_nushu:=}');
    Expect(1, 111355, '\p{isnushu}', "");
    Expect(0, 111355, '\p{^isnushu}', "");
    Expect(0, 111355, '\P{isnushu}', "");
    Expect(1, 111355, '\P{^isnushu}', "");
    Expect(0, 111356, '\p{isnushu}', "");
    Expect(1, 111356, '\p{^isnushu}', "");
    Expect(1, 111356, '\P{isnushu}', "");
    Expect(0, 111356, '\P{^isnushu}', "");
    Expect(1, 111355, '\p{	 is_Nushu}', "");
    Expect(0, 111355, '\p{^	 is_Nushu}', "");
    Expect(0, 111355, '\P{	 is_Nushu}', "");
    Expect(1, 111355, '\P{^	 is_Nushu}', "");
    Expect(0, 111356, '\p{	 is_Nushu}', "");
    Expect(1, 111356, '\p{^	 is_Nushu}', "");
    Expect(1, 111356, '\P{	 is_Nushu}', "");
    Expect(0, 111356, '\P{^	 is_Nushu}', "");
    Error('\p{:=Nshu}');
    Error('\P{:=Nshu}');
    Expect(1, 111355, '\p{nshu}', "");
    Expect(0, 111355, '\p{^nshu}', "");
    Expect(0, 111355, '\P{nshu}', "");
    Expect(1, 111355, '\P{^nshu}', "");
    Expect(0, 111356, '\p{nshu}', "");
    Expect(1, 111356, '\p{^nshu}', "");
    Expect(1, 111356, '\P{nshu}', "");
    Expect(0, 111356, '\P{^nshu}', "");
    Expect(1, 111355, '\p{	_Nshu}', "");
    Expect(0, 111355, '\p{^	_Nshu}', "");
    Expect(0, 111355, '\P{	_Nshu}', "");
    Expect(1, 111355, '\P{^	_Nshu}', "");
    Expect(0, 111356, '\p{	_Nshu}', "");
    Expect(1, 111356, '\p{^	_Nshu}', "");
    Expect(1, 111356, '\P{	_Nshu}', "");
    Expect(0, 111356, '\P{^	_Nshu}', "");
    Error('\p{_:=IS_Nshu}');
    Error('\P{_:=IS_Nshu}');
    Expect(1, 111355, '\p{isnshu}', "");
    Expect(0, 111355, '\p{^isnshu}', "");
    Expect(0, 111355, '\P{isnshu}', "");
    Expect(1, 111355, '\P{^isnshu}', "");
    Expect(0, 111356, '\p{isnshu}', "");
    Expect(1, 111356, '\p{^isnshu}', "");
    Expect(1, 111356, '\P{isnshu}', "");
    Expect(0, 111356, '\P{^isnshu}', "");
    Expect(1, 111355, '\p{ IS_nshu}', "");
    Expect(0, 111355, '\p{^ IS_nshu}', "");
    Expect(0, 111355, '\P{ IS_nshu}', "");
    Expect(1, 111355, '\P{^ IS_nshu}', "");
    Expect(0, 111356, '\p{ IS_nshu}', "");
    Expect(1, 111356, '\p{^ IS_nshu}', "");
    Expect(1, 111356, '\P{ IS_nshu}', "");
    Expect(0, 111356, '\P{^ IS_nshu}', "");
    Error('\p{-:=NYIAKENG_puachue_Hmong}');
    Error('\P{-:=NYIAKENG_puachue_Hmong}');
    Expect(1, 123215, '\p{nyiakengpuachuehmong}', "");
    Expect(0, 123215, '\p{^nyiakengpuachuehmong}', "");
    Expect(0, 123215, '\P{nyiakengpuachuehmong}', "");
    Expect(1, 123215, '\P{^nyiakengpuachuehmong}', "");
    Expect(0, 123216, '\p{nyiakengpuachuehmong}', "");
    Expect(1, 123216, '\p{^nyiakengpuachuehmong}', "");
    Expect(1, 123216, '\P{nyiakengpuachuehmong}', "");
    Expect(0, 123216, '\P{^nyiakengpuachuehmong}', "");
    Expect(1, 123215, '\p{  nyiakeng_Puachue_HMONG}', "");
    Expect(0, 123215, '\p{^  nyiakeng_Puachue_HMONG}', "");
    Expect(0, 123215, '\P{  nyiakeng_Puachue_HMONG}', "");
    Expect(1, 123215, '\P{^  nyiakeng_Puachue_HMONG}', "");
    Expect(0, 123216, '\p{  nyiakeng_Puachue_HMONG}', "");
    Expect(1, 123216, '\p{^  nyiakeng_Puachue_HMONG}', "");
    Expect(1, 123216, '\P{  nyiakeng_Puachue_HMONG}', "");
    Expect(0, 123216, '\P{^  nyiakeng_Puachue_HMONG}', "");
    Error('\p{:= _is_nyiakeng_puachue_hmong}');
    Error('\P{:= _is_nyiakeng_puachue_hmong}');
    Expect(1, 123215, '\p{isnyiakengpuachuehmong}', "");
    Expect(0, 123215, '\p{^isnyiakengpuachuehmong}', "");
    Expect(0, 123215, '\P{isnyiakengpuachuehmong}', "");
    Expect(1, 123215, '\P{^isnyiakengpuachuehmong}', "");
    Expect(0, 123216, '\p{isnyiakengpuachuehmong}', "");
    Expect(1, 123216, '\p{^isnyiakengpuachuehmong}', "");
    Expect(1, 123216, '\P{isnyiakengpuachuehmong}', "");
    Expect(0, 123216, '\P{^isnyiakengpuachuehmong}', "");
    Expect(1, 123215, '\p{	 is_NYIAKENG_Puachue_hmong}', "");
    Expect(0, 123215, '\p{^	 is_NYIAKENG_Puachue_hmong}', "");
    Expect(0, 123215, '\P{	 is_NYIAKENG_Puachue_hmong}', "");
    Expect(1, 123215, '\P{^	 is_NYIAKENG_Puachue_hmong}', "");
    Expect(0, 123216, '\p{	 is_NYIAKENG_Puachue_hmong}', "");
    Expect(1, 123216, '\p{^	 is_NYIAKENG_Puachue_hmong}', "");
    Expect(1, 123216, '\P{	 is_NYIAKENG_Puachue_hmong}', "");
    Expect(0, 123216, '\P{^	 is_NYIAKENG_Puachue_hmong}', "");
    Error('\p{ -hmnp:=}');
    Error('\P{ -hmnp:=}');
    Expect(1, 123215, '\p{hmnp}', "");
    Expect(0, 123215, '\p{^hmnp}', "");
    Expect(0, 123215, '\P{hmnp}', "");
    Expect(1, 123215, '\P{^hmnp}', "");
    Expect(0, 123216, '\p{hmnp}', "");
    Expect(1, 123216, '\p{^hmnp}', "");
    Expect(1, 123216, '\P{hmnp}', "");
    Expect(0, 123216, '\P{^hmnp}', "");
    Expect(1, 123215, '\p{ 	Hmnp}', "");
    Expect(0, 123215, '\p{^ 	Hmnp}', "");
    Expect(0, 123215, '\P{ 	Hmnp}', "");
    Expect(1, 123215, '\P{^ 	Hmnp}', "");
    Expect(0, 123216, '\p{ 	Hmnp}', "");
    Expect(1, 123216, '\p{^ 	Hmnp}', "");
    Expect(1, 123216, '\P{ 	Hmnp}', "");
    Expect(0, 123216, '\P{^ 	Hmnp}', "");
    Error('\p{  Is_HMNP/a/}');
    Error('\P{  Is_HMNP/a/}');
    Expect(1, 123215, '\p{ishmnp}', "");
    Expect(0, 123215, '\p{^ishmnp}', "");
    Expect(0, 123215, '\P{ishmnp}', "");
    Expect(1, 123215, '\P{^ishmnp}', "");
    Expect(0, 123216, '\p{ishmnp}', "");
    Expect(1, 123216, '\p{^ishmnp}', "");
    Expect(1, 123216, '\P{ishmnp}', "");
    Expect(0, 123216, '\P{^ishmnp}', "");
    Expect(1, 123215, '\p{  Is_HMNP}', "");
    Expect(0, 123215, '\p{^  Is_HMNP}', "");
    Expect(0, 123215, '\P{  Is_HMNP}', "");
    Expect(1, 123215, '\P{^  Is_HMNP}', "");
    Expect(0, 123216, '\p{  Is_HMNP}', "");
    Expect(1, 123216, '\p{^  Is_HMNP}', "");
    Expect(1, 123216, '\P{  Is_HMNP}', "");
    Expect(0, 123216, '\P{^  Is_HMNP}', "");
    Error('\p{ :=ogham}');
    Error('\P{ :=ogham}');
    Expect(1, 5788, '\p{ogham}', "");
    Expect(0, 5788, '\p{^ogham}', "");
    Expect(0, 5788, '\P{ogham}', "");
    Expect(1, 5788, '\P{^ogham}', "");
    Expect(0, 5789, '\p{ogham}', "");
    Expect(1, 5789, '\p{^ogham}', "");
    Expect(1, 5789, '\P{ogham}', "");
    Expect(0, 5789, '\P{^ogham}', "");
    Expect(1, 5788, '\p{ Ogham}', "");
    Expect(0, 5788, '\p{^ Ogham}', "");
    Expect(0, 5788, '\P{ Ogham}', "");
    Expect(1, 5788, '\P{^ Ogham}', "");
    Expect(0, 5789, '\p{ Ogham}', "");
    Expect(1, 5789, '\p{^ Ogham}', "");
    Expect(1, 5789, '\P{ Ogham}', "");
    Expect(0, 5789, '\P{^ Ogham}', "");
    Error('\p{_:=Is_Ogham}');
    Error('\P{_:=Is_Ogham}');
    Expect(1, 5788, '\p{isogham}', "");
    Expect(0, 5788, '\p{^isogham}', "");
    Expect(0, 5788, '\P{isogham}', "");
    Expect(1, 5788, '\P{^isogham}', "");
    Expect(0, 5789, '\p{isogham}', "");
    Expect(1, 5789, '\p{^isogham}', "");
    Expect(1, 5789, '\P{isogham}', "");
    Expect(0, 5789, '\P{^isogham}', "");
    Expect(1, 5788, '\p{ 	is_ogham}', "");
    Expect(0, 5788, '\p{^ 	is_ogham}', "");
    Expect(0, 5788, '\P{ 	is_ogham}', "");
    Expect(1, 5788, '\P{^ 	is_ogham}', "");
    Expect(0, 5789, '\p{ 	is_ogham}', "");
    Expect(1, 5789, '\p{^ 	is_ogham}', "");
    Expect(1, 5789, '\P{ 	is_ogham}', "");
    Expect(0, 5789, '\P{^ 	is_ogham}', "");
    Error('\p{ /a/Ogam}');
    Error('\P{ /a/Ogam}');
    Expect(1, 5788, '\p{ogam}', "");
    Expect(0, 5788, '\p{^ogam}', "");
    Expect(0, 5788, '\P{ogam}', "");
    Expect(1, 5788, '\P{^ogam}', "");
    Expect(0, 5789, '\p{ogam}', "");
    Expect(1, 5789, '\p{^ogam}', "");
    Expect(1, 5789, '\P{ogam}', "");
    Expect(0, 5789, '\P{^ogam}', "");
    Expect(1, 5788, '\p{_ogam}', "");
    Expect(0, 5788, '\p{^_ogam}', "");
    Expect(0, 5788, '\P{_ogam}', "");
    Expect(1, 5788, '\P{^_ogam}', "");
    Expect(0, 5789, '\p{_ogam}', "");
    Expect(1, 5789, '\p{^_ogam}', "");
    Expect(1, 5789, '\P{_ogam}', "");
    Expect(0, 5789, '\P{^_ogam}', "");
    Error('\p{ Is_Ogam:=}');
    Error('\P{ Is_Ogam:=}');
    Expect(1, 5788, '\p{isogam}', "");
    Expect(0, 5788, '\p{^isogam}', "");
    Expect(0, 5788, '\P{isogam}', "");
    Expect(1, 5788, '\P{^isogam}', "");
    Expect(0, 5789, '\p{isogam}', "");
    Expect(1, 5789, '\p{^isogam}', "");
    Expect(1, 5789, '\P{isogam}', "");
    Expect(0, 5789, '\P{^isogam}', "");
    Expect(1, 5788, '\p{Is_Ogam}', "");
    Expect(0, 5788, '\p{^Is_Ogam}', "");
    Expect(0, 5788, '\P{Is_Ogam}', "");
    Expect(1, 5788, '\P{^Is_Ogam}', "");
    Expect(0, 5789, '\p{Is_Ogam}', "");
    Expect(1, 5789, '\p{^Is_Ogam}', "");
    Expect(1, 5789, '\P{Is_Ogam}', "");
    Expect(0, 5789, '\P{^Is_Ogam}', "");
    Error('\p{/a/	 Ol_Chiki}');
    Error('\P{/a/	 Ol_Chiki}');
    Expect(1, 7295, '\p{olchiki}', "");
    Expect(0, 7295, '\p{^olchiki}', "");
    Expect(0, 7295, '\P{olchiki}', "");
    Expect(1, 7295, '\P{^olchiki}', "");
    Expect(0, 7296, '\p{olchiki}', "");
    Expect(1, 7296, '\p{^olchiki}', "");
    Expect(1, 7296, '\P{olchiki}', "");
    Expect(0, 7296, '\P{^olchiki}', "");
    Expect(1, 7295, '\p{		OL_chiki}', "");
    Expect(0, 7295, '\p{^		OL_chiki}', "");
    Expect(0, 7295, '\P{		OL_chiki}', "");
    Expect(1, 7295, '\P{^		OL_chiki}', "");
    Expect(0, 7296, '\p{		OL_chiki}', "");
    Expect(1, 7296, '\p{^		OL_chiki}', "");
    Expect(1, 7296, '\P{		OL_chiki}', "");
    Expect(0, 7296, '\P{^		OL_chiki}', "");
    Error('\p{/a/ _Is_Ol_CHIKI}');
    Error('\P{/a/ _Is_Ol_CHIKI}');
    Expect(1, 7295, '\p{isolchiki}', "");
    Expect(0, 7295, '\p{^isolchiki}', "");
    Expect(0, 7295, '\P{isolchiki}', "");
    Expect(1, 7295, '\P{^isolchiki}', "");
    Expect(0, 7296, '\p{isolchiki}', "");
    Expect(1, 7296, '\p{^isolchiki}', "");
    Expect(1, 7296, '\P{isolchiki}', "");
    Expect(0, 7296, '\P{^isolchiki}', "");
    Expect(1, 7295, '\p{ IS_ol_Chiki}', "");
    Expect(0, 7295, '\p{^ IS_ol_Chiki}', "");
    Expect(0, 7295, '\P{ IS_ol_Chiki}', "");
    Expect(1, 7295, '\P{^ IS_ol_Chiki}', "");
    Expect(0, 7296, '\p{ IS_ol_Chiki}', "");
    Expect(1, 7296, '\p{^ IS_ol_Chiki}', "");
    Expect(1, 7296, '\P{ IS_ol_Chiki}', "");
    Expect(0, 7296, '\P{^ IS_ol_Chiki}', "");
    Error('\p{_ Olck:=}');
    Error('\P{_ Olck:=}');
    Expect(1, 7295, '\p{olck}', "");
    Expect(0, 7295, '\p{^olck}', "");
    Expect(0, 7295, '\P{olck}', "");
    Expect(1, 7295, '\P{^olck}', "");
    Expect(0, 7296, '\p{olck}', "");
    Expect(1, 7296, '\p{^olck}', "");
    Expect(1, 7296, '\P{olck}', "");
    Expect(0, 7296, '\P{^olck}', "");
    Expect(1, 7295, '\p{	_OLCK}', "");
    Expect(0, 7295, '\p{^	_OLCK}', "");
    Expect(0, 7295, '\P{	_OLCK}', "");
    Expect(1, 7295, '\P{^	_OLCK}', "");
    Expect(0, 7296, '\p{	_OLCK}', "");
    Expect(1, 7296, '\p{^	_OLCK}', "");
    Expect(1, 7296, '\P{	_OLCK}', "");
    Expect(0, 7296, '\P{^	_OLCK}', "");
    Error('\p{/a/	Is_Olck}');
    Error('\P{/a/	Is_Olck}');
    Expect(1, 7295, '\p{isolck}', "");
    Expect(0, 7295, '\p{^isolck}', "");
    Expect(0, 7295, '\P{isolck}', "");
    Expect(1, 7295, '\P{^isolck}', "");
    Expect(0, 7296, '\p{isolck}', "");
    Expect(1, 7296, '\p{^isolck}', "");
    Expect(1, 7296, '\P{isolck}', "");
    Expect(0, 7296, '\P{^isolck}', "");
    Expect(1, 7295, '\p{	_Is_OLCK}', "");
    Expect(0, 7295, '\p{^	_Is_OLCK}', "");
    Expect(0, 7295, '\P{	_Is_OLCK}', "");
    Expect(1, 7295, '\P{^	_Is_OLCK}', "");
    Expect(0, 7296, '\p{	_Is_OLCK}', "");
    Expect(1, 7296, '\p{^	_Is_OLCK}', "");
    Expect(1, 7296, '\P{	_Is_OLCK}', "");
    Expect(0, 7296, '\P{^	_Is_OLCK}', "");
    Error('\p{_/a/old_Hungarian}');
    Error('\P{_/a/old_Hungarian}');
    Expect(1, 68863, '\p{oldhungarian}', "");
    Expect(0, 68863, '\p{^oldhungarian}', "");
    Expect(0, 68863, '\P{oldhungarian}', "");
    Expect(1, 68863, '\P{^oldhungarian}', "");
    Expect(0, 68864, '\p{oldhungarian}', "");
    Expect(1, 68864, '\p{^oldhungarian}', "");
    Expect(1, 68864, '\P{oldhungarian}', "");
    Expect(0, 68864, '\P{^oldhungarian}', "");
    Expect(1, 68863, '\p{-old_HUNGARIAN}', "");
    Expect(0, 68863, '\p{^-old_HUNGARIAN}', "");
    Expect(0, 68863, '\P{-old_HUNGARIAN}', "");
    Expect(1, 68863, '\P{^-old_HUNGARIAN}', "");
    Expect(0, 68864, '\p{-old_HUNGARIAN}', "");
    Expect(1, 68864, '\p{^-old_HUNGARIAN}', "");
    Expect(1, 68864, '\P{-old_HUNGARIAN}', "");
    Expect(0, 68864, '\P{^-old_HUNGARIAN}', "");
    Error('\p{/a/_ is_OLD_Hungarian}');
    Error('\P{/a/_ is_OLD_Hungarian}');
    Expect(1, 68863, '\p{isoldhungarian}', "");
    Expect(0, 68863, '\p{^isoldhungarian}', "");
    Expect(0, 68863, '\P{isoldhungarian}', "");
    Expect(1, 68863, '\P{^isoldhungarian}', "");
    Expect(0, 68864, '\p{isoldhungarian}', "");
    Expect(1, 68864, '\p{^isoldhungarian}', "");
    Expect(1, 68864, '\P{isoldhungarian}', "");
    Expect(0, 68864, '\P{^isoldhungarian}', "");
    Expect(1, 68863, '\p{_is_OLD_Hungarian}', "");
    Expect(0, 68863, '\p{^_is_OLD_Hungarian}', "");
    Expect(0, 68863, '\P{_is_OLD_Hungarian}', "");
    Expect(1, 68863, '\P{^_is_OLD_Hungarian}', "");
    Expect(0, 68864, '\p{_is_OLD_Hungarian}', "");
    Expect(1, 68864, '\p{^_is_OLD_Hungarian}', "");
    Expect(1, 68864, '\P{_is_OLD_Hungarian}', "");
    Expect(0, 68864, '\P{^_is_OLD_Hungarian}', "");
    Error('\p{ -Hung:=}');
    Error('\P{ -Hung:=}');
    Expect(1, 68863, '\p{hung}', "");
    Expect(0, 68863, '\p{^hung}', "");
    Expect(0, 68863, '\P{hung}', "");
    Expect(1, 68863, '\P{^hung}', "");
    Expect(0, 68864, '\p{hung}', "");
    Expect(1, 68864, '\p{^hung}', "");
    Expect(1, 68864, '\P{hung}', "");
    Expect(0, 68864, '\P{^hung}', "");
    Expect(1, 68863, '\p{	HUNG}', "");
    Expect(0, 68863, '\p{^	HUNG}', "");
    Expect(0, 68863, '\P{	HUNG}', "");
    Expect(1, 68863, '\P{^	HUNG}', "");
    Expect(0, 68864, '\p{	HUNG}', "");
    Expect(1, 68864, '\p{^	HUNG}', "");
    Expect(1, 68864, '\P{	HUNG}', "");
    Expect(0, 68864, '\P{^	HUNG}', "");
    Error('\p{/a/ IS_Hung}');
    Error('\P{/a/ IS_Hung}');
    Expect(1, 68863, '\p{ishung}', "");
    Expect(0, 68863, '\p{^ishung}', "");
    Expect(0, 68863, '\P{ishung}', "");
    Expect(1, 68863, '\P{^ishung}', "");
    Expect(0, 68864, '\p{ishung}', "");
    Expect(1, 68864, '\p{^ishung}', "");
    Expect(1, 68864, '\P{ishung}', "");
    Expect(0, 68864, '\P{^ishung}', "");
    Expect(1, 68863, '\p{_-Is_hung}', "");
    Expect(0, 68863, '\p{^_-Is_hung}', "");
    Expect(0, 68863, '\P{_-Is_hung}', "");
    Expect(1, 68863, '\P{^_-Is_hung}', "");
    Expect(0, 68864, '\p{_-Is_hung}', "");
    Expect(1, 68864, '\p{^_-Is_hung}', "");
    Expect(1, 68864, '\P{_-Is_hung}', "");
    Expect(0, 68864, '\P{^_-Is_hung}', "");
    Error('\p{:=	old_Italic}');
    Error('\P{:=	old_Italic}');
    Expect(1, 66351, '\p{olditalic}', "");
    Expect(0, 66351, '\p{^olditalic}', "");
    Expect(0, 66351, '\P{olditalic}', "");
    Expect(1, 66351, '\P{^olditalic}', "");
    Expect(0, 66352, '\p{olditalic}', "");
    Expect(1, 66352, '\p{^olditalic}', "");
    Expect(1, 66352, '\P{olditalic}', "");
    Expect(0, 66352, '\P{^olditalic}', "");
    Expect(1, 66351, '\p{		OLD_ITALIC}', "");
    Expect(0, 66351, '\p{^		OLD_ITALIC}', "");
    Expect(0, 66351, '\P{		OLD_ITALIC}', "");
    Expect(1, 66351, '\P{^		OLD_ITALIC}', "");
    Expect(0, 66352, '\p{		OLD_ITALIC}', "");
    Expect(1, 66352, '\p{^		OLD_ITALIC}', "");
    Expect(1, 66352, '\P{		OLD_ITALIC}', "");
    Expect(0, 66352, '\P{^		OLD_ITALIC}', "");
    Error('\p{ :=Is_old_Italic}');
    Error('\P{ :=Is_old_Italic}');
    Expect(1, 66351, '\p{isolditalic}', "");
    Expect(0, 66351, '\p{^isolditalic}', "");
    Expect(0, 66351, '\P{isolditalic}', "");
    Expect(1, 66351, '\P{^isolditalic}', "");
    Expect(0, 66352, '\p{isolditalic}', "");
    Expect(1, 66352, '\p{^isolditalic}', "");
    Expect(1, 66352, '\P{isolditalic}', "");
    Expect(0, 66352, '\P{^isolditalic}', "");
    Expect(1, 66351, '\p{-is_Old_Italic}', "");
    Expect(0, 66351, '\p{^-is_Old_Italic}', "");
    Expect(0, 66351, '\P{-is_Old_Italic}', "");
    Expect(1, 66351, '\P{^-is_Old_Italic}', "");
    Expect(0, 66352, '\p{-is_Old_Italic}', "");
    Expect(1, 66352, '\p{^-is_Old_Italic}', "");
    Expect(1, 66352, '\P{-is_Old_Italic}', "");
    Expect(0, 66352, '\P{^-is_Old_Italic}', "");
    Error('\p{/a/Ital}');
    Error('\P{/a/Ital}');
    Expect(1, 66351, '\p{ital}', "");
    Expect(0, 66351, '\p{^ital}', "");
    Expect(0, 66351, '\P{ital}', "");
    Expect(1, 66351, '\P{^ital}', "");
    Expect(0, 66352, '\p{ital}', "");
    Expect(1, 66352, '\p{^ital}', "");
    Expect(1, 66352, '\P{ital}', "");
    Expect(0, 66352, '\P{^ital}', "");
    Expect(1, 66351, '\p{_ital}', "");
    Expect(0, 66351, '\p{^_ital}', "");
    Expect(0, 66351, '\P{_ital}', "");
    Expect(1, 66351, '\P{^_ital}', "");
    Expect(0, 66352, '\p{_ital}', "");
    Expect(1, 66352, '\p{^_ital}', "");
    Expect(1, 66352, '\P{_ital}', "");
    Expect(0, 66352, '\P{^_ital}', "");
    Error('\p{_:=Is_Ital}');
    Error('\P{_:=Is_Ital}');
    Expect(1, 66351, '\p{isital}', "");
    Expect(0, 66351, '\p{^isital}', "");
    Expect(0, 66351, '\P{isital}', "");
    Expect(1, 66351, '\P{^isital}', "");
    Expect(0, 66352, '\p{isital}', "");
    Expect(1, 66352, '\p{^isital}', "");
    Expect(1, 66352, '\P{isital}', "");
    Expect(0, 66352, '\P{^isital}', "");
    Expect(1, 66351, '\p{-_Is_ital}', "");
    Expect(0, 66351, '\p{^-_Is_ital}', "");
    Expect(0, 66351, '\P{-_Is_ital}', "");
    Expect(1, 66351, '\P{^-_Is_ital}', "");
    Expect(0, 66352, '\p{-_Is_ital}', "");
    Expect(1, 66352, '\p{^-_Is_ital}', "");
    Expect(1, 66352, '\P{-_Is_ital}', "");
    Expect(0, 66352, '\P{^-_Is_ital}', "");
    Error('\p{:=OLD_North_ARABIAN}');
    Error('\P{:=OLD_North_ARABIAN}');
    Expect(1, 68255, '\p{oldnortharabian}', "");
    Expect(0, 68255, '\p{^oldnortharabian}', "");
    Expect(0, 68255, '\P{oldnortharabian}', "");
    Expect(1, 68255, '\P{^oldnortharabian}', "");
    Expect(0, 68256, '\p{oldnortharabian}', "");
    Expect(1, 68256, '\p{^oldnortharabian}', "");
    Expect(1, 68256, '\P{oldnortharabian}', "");
    Expect(0, 68256, '\P{^oldnortharabian}', "");
    Expect(1, 68255, '\p{  Old_North_Arabian}', "");
    Expect(0, 68255, '\p{^  Old_North_Arabian}', "");
    Expect(0, 68255, '\P{  Old_North_Arabian}', "");
    Expect(1, 68255, '\P{^  Old_North_Arabian}', "");
    Expect(0, 68256, '\p{  Old_North_Arabian}', "");
    Expect(1, 68256, '\p{^  Old_North_Arabian}', "");
    Expect(1, 68256, '\P{  Old_North_Arabian}', "");
    Expect(0, 68256, '\P{^  Old_North_Arabian}', "");
    Error('\p{_	is_Old_north_Arabian/a/}');
    Error('\P{_	is_Old_north_Arabian/a/}');
    Expect(1, 68255, '\p{isoldnortharabian}', "");
    Expect(0, 68255, '\p{^isoldnortharabian}', "");
    Expect(0, 68255, '\P{isoldnortharabian}', "");
    Expect(1, 68255, '\P{^isoldnortharabian}', "");
    Expect(0, 68256, '\p{isoldnortharabian}', "");
    Expect(1, 68256, '\p{^isoldnortharabian}', "");
    Expect(1, 68256, '\P{isoldnortharabian}', "");
    Expect(0, 68256, '\P{^isoldnortharabian}', "");
    Expect(1, 68255, '\p{ -is_old_north_Arabian}', "");
    Expect(0, 68255, '\p{^ -is_old_north_Arabian}', "");
    Expect(0, 68255, '\P{ -is_old_north_Arabian}', "");
    Expect(1, 68255, '\P{^ -is_old_north_Arabian}', "");
    Expect(0, 68256, '\p{ -is_old_north_Arabian}', "");
    Expect(1, 68256, '\p{^ -is_old_north_Arabian}', "");
    Expect(1, 68256, '\P{ -is_old_north_Arabian}', "");
    Expect(0, 68256, '\P{^ -is_old_north_Arabian}', "");
    Error('\p{	 narb/a/}');
    Error('\P{	 narb/a/}');
    Expect(1, 68255, '\p{narb}', "");
    Expect(0, 68255, '\p{^narb}', "");
    Expect(0, 68255, '\P{narb}', "");
    Expect(1, 68255, '\P{^narb}', "");
    Expect(0, 68256, '\p{narb}', "");
    Expect(1, 68256, '\p{^narb}', "");
    Expect(1, 68256, '\P{narb}', "");
    Expect(0, 68256, '\P{^narb}', "");
    Expect(1, 68255, '\p{_-Narb}', "");
    Expect(0, 68255, '\p{^_-Narb}', "");
    Expect(0, 68255, '\P{_-Narb}', "");
    Expect(1, 68255, '\P{^_-Narb}', "");
    Expect(0, 68256, '\p{_-Narb}', "");
    Expect(1, 68256, '\p{^_-Narb}', "");
    Expect(1, 68256, '\P{_-Narb}', "");
    Expect(0, 68256, '\P{^_-Narb}', "");
    Error('\p{_	Is_Narb/a/}');
    Error('\P{_	Is_Narb/a/}');
    Expect(1, 68255, '\p{isnarb}', "");
    Expect(0, 68255, '\p{^isnarb}', "");
    Expect(0, 68255, '\P{isnarb}', "");
    Expect(1, 68255, '\P{^isnarb}', "");
    Expect(0, 68256, '\p{isnarb}', "");
    Expect(1, 68256, '\p{^isnarb}', "");
    Expect(1, 68256, '\P{isnarb}', "");
    Expect(0, 68256, '\P{^isnarb}', "");
    Expect(1, 68255, '\p{_Is_NARB}', "");
    Expect(0, 68255, '\p{^_Is_NARB}', "");
    Expect(0, 68255, '\P{_Is_NARB}', "");
    Expect(1, 68255, '\P{^_Is_NARB}', "");
    Expect(0, 68256, '\p{_Is_NARB}', "");
    Expect(1, 68256, '\p{^_Is_NARB}', "");
    Expect(1, 68256, '\P{_Is_NARB}', "");
    Expect(0, 68256, '\P{^_Is_NARB}', "");
    Error('\p{_old_Permic:=}');
    Error('\P{_old_Permic:=}');
    Expect(1, 66426, '\p{oldpermic}', "");
    Expect(0, 66426, '\p{^oldpermic}', "");
    Expect(0, 66426, '\P{oldpermic}', "");
    Expect(1, 66426, '\P{^oldpermic}', "");
    Expect(0, 66427, '\p{oldpermic}', "");
    Expect(1, 66427, '\p{^oldpermic}', "");
    Expect(1, 66427, '\P{oldpermic}', "");
    Expect(0, 66427, '\P{^oldpermic}', "");
    Expect(1, 66426, '\p{		old_PERMIC}', "");
    Expect(0, 66426, '\p{^		old_PERMIC}', "");
    Expect(0, 66426, '\P{		old_PERMIC}', "");
    Expect(1, 66426, '\P{^		old_PERMIC}', "");
    Expect(0, 66427, '\p{		old_PERMIC}', "");
    Expect(1, 66427, '\p{^		old_PERMIC}', "");
    Expect(1, 66427, '\P{		old_PERMIC}', "");
    Expect(0, 66427, '\P{^		old_PERMIC}', "");
    Error('\p{/a/-	IS_Old_Permic}');
    Error('\P{/a/-	IS_Old_Permic}');
    Expect(1, 66426, '\p{isoldpermic}', "");
    Expect(0, 66426, '\p{^isoldpermic}', "");
    Expect(0, 66426, '\P{isoldpermic}', "");
    Expect(1, 66426, '\P{^isoldpermic}', "");
    Expect(0, 66427, '\p{isoldpermic}', "");
    Expect(1, 66427, '\p{^isoldpermic}', "");
    Expect(1, 66427, '\P{isoldpermic}', "");
    Expect(0, 66427, '\P{^isoldpermic}', "");
    Expect(1, 66426, '\p{	_is_Old_Permic}', "");
    Expect(0, 66426, '\p{^	_is_Old_Permic}', "");
    Expect(0, 66426, '\P{	_is_Old_Permic}', "");
    Expect(1, 66426, '\P{^	_is_Old_Permic}', "");
    Expect(0, 66427, '\p{	_is_Old_Permic}', "");
    Expect(1, 66427, '\p{^	_is_Old_Permic}', "");
    Expect(1, 66427, '\P{	_is_Old_Permic}', "");
    Expect(0, 66427, '\P{^	_is_Old_Permic}', "");
    Error('\p{	:=Perm}');
    Error('\P{	:=Perm}');
    Expect(1, 66426, '\p{perm}', "");
    Expect(0, 66426, '\p{^perm}', "");
    Expect(0, 66426, '\P{perm}', "");
    Expect(1, 66426, '\P{^perm}', "");
    Expect(0, 66427, '\p{perm}', "");
    Expect(1, 66427, '\p{^perm}', "");
    Expect(1, 66427, '\P{perm}', "");
    Expect(0, 66427, '\P{^perm}', "");
    Expect(1, 66426, '\p{	-perm}', "");
    Expect(0, 66426, '\p{^	-perm}', "");
    Expect(0, 66426, '\P{	-perm}', "");
    Expect(1, 66426, '\P{^	-perm}', "");
    Expect(0, 66427, '\p{	-perm}', "");
    Expect(1, 66427, '\p{^	-perm}', "");
    Expect(1, 66427, '\P{	-perm}', "");
    Expect(0, 66427, '\P{^	-perm}', "");
    Error('\p{	/a/IS_PERM}');
    Error('\P{	/a/IS_PERM}');
    Expect(1, 66426, '\p{isperm}', "");
    Expect(0, 66426, '\p{^isperm}', "");
    Expect(0, 66426, '\P{isperm}', "");
    Expect(1, 66426, '\P{^isperm}', "");
    Expect(0, 66427, '\p{isperm}', "");
    Expect(1, 66427, '\p{^isperm}', "");
    Expect(1, 66427, '\P{isperm}', "");
    Expect(0, 66427, '\P{^isperm}', "");
    Expect(1, 66426, '\p{__is_Perm}', "");
    Expect(0, 66426, '\p{^__is_Perm}', "");
    Expect(0, 66426, '\P{__is_Perm}', "");
    Expect(1, 66426, '\P{^__is_Perm}', "");
    Expect(0, 66427, '\p{__is_Perm}', "");
    Expect(1, 66427, '\p{^__is_Perm}', "");
    Expect(1, 66427, '\P{__is_Perm}', "");
    Expect(0, 66427, '\P{^__is_Perm}', "");
    Error('\p{--Old_persian/a/}');
    Error('\P{--Old_persian/a/}');
    Expect(1, 66517, '\p{oldpersian}', "");
    Expect(0, 66517, '\p{^oldpersian}', "");
    Expect(0, 66517, '\P{oldpersian}', "");
    Expect(1, 66517, '\P{^oldpersian}', "");
    Expect(0, 66518, '\p{oldpersian}', "");
    Expect(1, 66518, '\p{^oldpersian}', "");
    Expect(1, 66518, '\P{oldpersian}', "");
    Expect(0, 66518, '\P{^oldpersian}', "");
    Expect(1, 66517, '\p{		Old_PERSIAN}', "");
    Expect(0, 66517, '\p{^		Old_PERSIAN}', "");
    Expect(0, 66517, '\P{		Old_PERSIAN}', "");
    Expect(1, 66517, '\P{^		Old_PERSIAN}', "");
    Expect(0, 66518, '\p{		Old_PERSIAN}', "");
    Expect(1, 66518, '\p{^		Old_PERSIAN}', "");
    Expect(1, 66518, '\P{		Old_PERSIAN}', "");
    Expect(0, 66518, '\P{^		Old_PERSIAN}', "");
    Error('\p{:=_IS_OLD_Persian}');
    Error('\P{:=_IS_OLD_Persian}');
    Expect(1, 66517, '\p{isoldpersian}', "");
    Expect(0, 66517, '\p{^isoldpersian}', "");
    Expect(0, 66517, '\P{isoldpersian}', "");
    Expect(1, 66517, '\P{^isoldpersian}', "");
    Expect(0, 66518, '\p{isoldpersian}', "");
    Expect(1, 66518, '\p{^isoldpersian}', "");
    Expect(1, 66518, '\P{isoldpersian}', "");
    Expect(0, 66518, '\P{^isoldpersian}', "");
    Expect(1, 66517, '\p{-IS_Old_persian}', "");
    Expect(0, 66517, '\p{^-IS_Old_persian}', "");
    Expect(0, 66517, '\P{-IS_Old_persian}', "");
    Expect(1, 66517, '\P{^-IS_Old_persian}', "");
    Expect(0, 66518, '\p{-IS_Old_persian}', "");
    Expect(1, 66518, '\p{^-IS_Old_persian}', "");
    Expect(1, 66518, '\P{-IS_Old_persian}', "");
    Expect(0, 66518, '\P{^-IS_Old_persian}', "");
    Error('\p{/a/-	Xpeo}');
    Error('\P{/a/-	Xpeo}');
    Expect(1, 66517, '\p{xpeo}', "");
    Expect(0, 66517, '\p{^xpeo}', "");
    Expect(0, 66517, '\P{xpeo}', "");
    Expect(1, 66517, '\P{^xpeo}', "");
    Expect(0, 66518, '\p{xpeo}', "");
    Expect(1, 66518, '\p{^xpeo}', "");
    Expect(1, 66518, '\P{xpeo}', "");
    Expect(0, 66518, '\P{^xpeo}', "");
    Expect(1, 66517, '\p{ 	Xpeo}', "");
    Expect(0, 66517, '\p{^ 	Xpeo}', "");
    Expect(0, 66517, '\P{ 	Xpeo}', "");
    Expect(1, 66517, '\P{^ 	Xpeo}', "");
    Expect(0, 66518, '\p{ 	Xpeo}', "");
    Expect(1, 66518, '\p{^ 	Xpeo}', "");
    Expect(1, 66518, '\P{ 	Xpeo}', "");
    Expect(0, 66518, '\P{^ 	Xpeo}', "");
    Error('\p{_is_Xpeo:=}');
    Error('\P{_is_Xpeo:=}');
    Expect(1, 66517, '\p{isxpeo}', "");
    Expect(0, 66517, '\p{^isxpeo}', "");
    Expect(0, 66517, '\P{isxpeo}', "");
    Expect(1, 66517, '\P{^isxpeo}', "");
    Expect(0, 66518, '\p{isxpeo}', "");
    Expect(1, 66518, '\p{^isxpeo}', "");
    Expect(1, 66518, '\P{isxpeo}', "");
    Expect(0, 66518, '\P{^isxpeo}', "");
    Expect(1, 66517, '\p{	 IS_XPEO}', "");
    Expect(0, 66517, '\p{^	 IS_XPEO}', "");
    Expect(0, 66517, '\P{	 IS_XPEO}', "");
    Expect(1, 66517, '\P{^	 IS_XPEO}', "");
    Expect(0, 66518, '\p{	 IS_XPEO}', "");
    Expect(1, 66518, '\p{^	 IS_XPEO}', "");
    Expect(1, 66518, '\P{	 IS_XPEO}', "");
    Expect(0, 66518, '\P{^	 IS_XPEO}', "");
    Error('\p{--OLD_Sogdian:=}');
    Error('\P{--OLD_Sogdian:=}');
    Expect(1, 69415, '\p{oldsogdian}', "");
    Expect(0, 69415, '\p{^oldsogdian}', "");
    Expect(0, 69415, '\P{oldsogdian}', "");
    Expect(1, 69415, '\P{^oldsogdian}', "");
    Expect(0, 69416, '\p{oldsogdian}', "");
    Expect(1, 69416, '\p{^oldsogdian}', "");
    Expect(1, 69416, '\P{oldsogdian}', "");
    Expect(0, 69416, '\P{^oldsogdian}', "");
    Expect(1, 69415, '\p{-	Old_sogdian}', "");
    Expect(0, 69415, '\p{^-	Old_sogdian}', "");
    Expect(0, 69415, '\P{-	Old_sogdian}', "");
    Expect(1, 69415, '\P{^-	Old_sogdian}', "");
    Expect(0, 69416, '\p{-	Old_sogdian}', "");
    Expect(1, 69416, '\p{^-	Old_sogdian}', "");
    Expect(1, 69416, '\P{-	Old_sogdian}', "");
    Expect(0, 69416, '\P{^-	Old_sogdian}', "");
    Error('\p{:=is_Old_Sogdian}');
    Error('\P{:=is_Old_Sogdian}');
    Expect(1, 69415, '\p{isoldsogdian}', "");
    Expect(0, 69415, '\p{^isoldsogdian}', "");
    Expect(0, 69415, '\P{isoldsogdian}', "");
    Expect(1, 69415, '\P{^isoldsogdian}', "");
    Expect(0, 69416, '\p{isoldsogdian}', "");
    Expect(1, 69416, '\p{^isoldsogdian}', "");
    Expect(1, 69416, '\P{isoldsogdian}', "");
    Expect(0, 69416, '\P{^isoldsogdian}', "");
    Expect(1, 69415, '\p{ Is_Old_Sogdian}', "");
    Expect(0, 69415, '\p{^ Is_Old_Sogdian}', "");
    Expect(0, 69415, '\P{ Is_Old_Sogdian}', "");
    Expect(1, 69415, '\P{^ Is_Old_Sogdian}', "");
    Expect(0, 69416, '\p{ Is_Old_Sogdian}', "");
    Expect(1, 69416, '\p{^ Is_Old_Sogdian}', "");
    Expect(1, 69416, '\P{ Is_Old_Sogdian}', "");
    Expect(0, 69416, '\P{^ Is_Old_Sogdian}', "");
    Error('\p{-/a/SOGO}');
    Error('\P{-/a/SOGO}');
    Expect(1, 69415, '\p{sogo}', "");
    Expect(0, 69415, '\p{^sogo}', "");
    Expect(0, 69415, '\P{sogo}', "");
    Expect(1, 69415, '\P{^sogo}', "");
    Expect(0, 69416, '\p{sogo}', "");
    Expect(1, 69416, '\p{^sogo}', "");
    Expect(1, 69416, '\P{sogo}', "");
    Expect(0, 69416, '\P{^sogo}', "");
    Expect(1, 69415, '\p{ SOGO}', "");
    Expect(0, 69415, '\p{^ SOGO}', "");
    Expect(0, 69415, '\P{ SOGO}', "");
    Expect(1, 69415, '\P{^ SOGO}', "");
    Expect(0, 69416, '\p{ SOGO}', "");
    Expect(1, 69416, '\p{^ SOGO}', "");
    Expect(1, 69416, '\P{ SOGO}', "");
    Expect(0, 69416, '\P{^ SOGO}', "");
    Error('\p{:= -is_Sogo}');
    Error('\P{:= -is_Sogo}');
    Expect(1, 69415, '\p{issogo}', "");
    Expect(0, 69415, '\p{^issogo}', "");
    Expect(0, 69415, '\P{issogo}', "");
    Expect(1, 69415, '\P{^issogo}', "");
    Expect(0, 69416, '\p{issogo}', "");
    Expect(1, 69416, '\p{^issogo}', "");
    Expect(1, 69416, '\P{issogo}', "");
    Expect(0, 69416, '\P{^issogo}', "");
    Expect(1, 69415, '\p{_is_Sogo}', "");
    Expect(0, 69415, '\p{^_is_Sogo}', "");
    Expect(0, 69415, '\P{_is_Sogo}', "");
    Expect(1, 69415, '\P{^_is_Sogo}', "");
    Expect(0, 69416, '\p{_is_Sogo}', "");
    Expect(1, 69416, '\p{^_is_Sogo}', "");
    Expect(1, 69416, '\P{_is_Sogo}', "");
    Expect(0, 69416, '\P{^_is_Sogo}', "");
    Error('\p{--old_SOUTH_arabian/a/}');
    Error('\P{--old_SOUTH_arabian/a/}');
    Expect(1, 68223, '\p{oldsoutharabian}', "");
    Expect(0, 68223, '\p{^oldsoutharabian}', "");
    Expect(0, 68223, '\P{oldsoutharabian}', "");
    Expect(1, 68223, '\P{^oldsoutharabian}', "");
    Expect(0, 68224, '\p{oldsoutharabian}', "");
    Expect(1, 68224, '\p{^oldsoutharabian}', "");
    Expect(1, 68224, '\P{oldsoutharabian}', "");
    Expect(0, 68224, '\P{^oldsoutharabian}', "");
    Expect(1, 68223, '\p{ Old_South_arabian}', "");
    Expect(0, 68223, '\p{^ Old_South_arabian}', "");
    Expect(0, 68223, '\P{ Old_South_arabian}', "");
    Expect(1, 68223, '\P{^ Old_South_arabian}', "");
    Expect(0, 68224, '\p{ Old_South_arabian}', "");
    Expect(1, 68224, '\p{^ Old_South_arabian}', "");
    Expect(1, 68224, '\P{ Old_South_arabian}', "");
    Expect(0, 68224, '\P{^ Old_South_arabian}', "");
    Error('\p{	Is_old_South_ARABIAN/a/}');
    Error('\P{	Is_old_South_ARABIAN/a/}');
    Expect(1, 68223, '\p{isoldsoutharabian}', "");
    Expect(0, 68223, '\p{^isoldsoutharabian}', "");
    Expect(0, 68223, '\P{isoldsoutharabian}', "");
    Expect(1, 68223, '\P{^isoldsoutharabian}', "");
    Expect(0, 68224, '\p{isoldsoutharabian}', "");
    Expect(1, 68224, '\p{^isoldsoutharabian}', "");
    Expect(1, 68224, '\P{isoldsoutharabian}', "");
    Expect(0, 68224, '\P{^isoldsoutharabian}', "");
    Expect(1, 68223, '\p{-Is_OLD_South_arabian}', "");
    Expect(0, 68223, '\p{^-Is_OLD_South_arabian}', "");
    Expect(0, 68223, '\P{-Is_OLD_South_arabian}', "");
    Expect(1, 68223, '\P{^-Is_OLD_South_arabian}', "");
    Expect(0, 68224, '\p{-Is_OLD_South_arabian}', "");
    Expect(1, 68224, '\p{^-Is_OLD_South_arabian}', "");
    Expect(1, 68224, '\P{-Is_OLD_South_arabian}', "");
    Expect(0, 68224, '\P{^-Is_OLD_South_arabian}', "");
    Error('\p{/a/-Sarb}');
    Error('\P{/a/-Sarb}');
    Expect(1, 68223, '\p{sarb}', "");
    Expect(0, 68223, '\p{^sarb}', "");
    Expect(0, 68223, '\P{sarb}', "");
    Expect(1, 68223, '\P{^sarb}', "");
    Expect(0, 68224, '\p{sarb}', "");
    Expect(1, 68224, '\p{^sarb}', "");
    Expect(1, 68224, '\P{sarb}', "");
    Expect(0, 68224, '\P{^sarb}', "");
    Expect(1, 68223, '\p{	Sarb}', "");
    Expect(0, 68223, '\p{^	Sarb}', "");
    Expect(0, 68223, '\P{	Sarb}', "");
    Expect(1, 68223, '\P{^	Sarb}', "");
    Expect(0, 68224, '\p{	Sarb}', "");
    Expect(1, 68224, '\p{^	Sarb}', "");
    Expect(1, 68224, '\P{	Sarb}', "");
    Expect(0, 68224, '\P{^	Sarb}', "");
    Error('\p{/a/ 	is_Sarb}');
    Error('\P{/a/ 	is_Sarb}');
    Expect(1, 68223, '\p{issarb}', "");
    Expect(0, 68223, '\p{^issarb}', "");
    Expect(0, 68223, '\P{issarb}', "");
    Expect(1, 68223, '\P{^issarb}', "");
    Expect(0, 68224, '\p{issarb}', "");
    Expect(1, 68224, '\p{^issarb}', "");
    Expect(1, 68224, '\P{issarb}', "");
    Expect(0, 68224, '\P{^issarb}', "");
    Expect(1, 68223, '\p{		is_Sarb}', "");
    Expect(0, 68223, '\p{^		is_Sarb}', "");
    Expect(0, 68223, '\P{		is_Sarb}', "");
    Expect(1, 68223, '\P{^		is_Sarb}', "");
    Expect(0, 68224, '\p{		is_Sarb}', "");
    Expect(1, 68224, '\p{^		is_Sarb}', "");
    Expect(1, 68224, '\P{		is_Sarb}', "");
    Expect(0, 68224, '\P{^		is_Sarb}', "");
    Error('\p{- Old_TURKIC:=}');
    Error('\P{- Old_TURKIC:=}');
    Expect(1, 68680, '\p{oldturkic}', "");
    Expect(0, 68680, '\p{^oldturkic}', "");
    Expect(0, 68680, '\P{oldturkic}', "");
    Expect(1, 68680, '\P{^oldturkic}', "");
    Expect(0, 68681, '\p{oldturkic}', "");
    Expect(1, 68681, '\p{^oldturkic}', "");
    Expect(1, 68681, '\P{oldturkic}', "");
    Expect(0, 68681, '\P{^oldturkic}', "");
    Expect(1, 68680, '\p{_	Old_Turkic}', "");
    Expect(0, 68680, '\p{^_	Old_Turkic}', "");
    Expect(0, 68680, '\P{_	Old_Turkic}', "");
    Expect(1, 68680, '\P{^_	Old_Turkic}', "");
    Expect(0, 68681, '\p{_	Old_Turkic}', "");
    Expect(1, 68681, '\p{^_	Old_Turkic}', "");
    Expect(1, 68681, '\P{_	Old_Turkic}', "");
    Expect(0, 68681, '\P{^_	Old_Turkic}', "");
    Error('\p{/a/_ Is_OLD_Turkic}');
    Error('\P{/a/_ Is_OLD_Turkic}');
    Expect(1, 68680, '\p{isoldturkic}', "");
    Expect(0, 68680, '\p{^isoldturkic}', "");
    Expect(0, 68680, '\P{isoldturkic}', "");
    Expect(1, 68680, '\P{^isoldturkic}', "");
    Expect(0, 68681, '\p{isoldturkic}', "");
    Expect(1, 68681, '\p{^isoldturkic}', "");
    Expect(1, 68681, '\P{isoldturkic}', "");
    Expect(0, 68681, '\P{^isoldturkic}', "");
    Expect(1, 68680, '\p{	 is_Old_Turkic}', "");
    Expect(0, 68680, '\p{^	 is_Old_Turkic}', "");
    Expect(0, 68680, '\P{	 is_Old_Turkic}', "");
    Expect(1, 68680, '\P{^	 is_Old_Turkic}', "");
    Expect(0, 68681, '\p{	 is_Old_Turkic}', "");
    Expect(1, 68681, '\p{^	 is_Old_Turkic}', "");
    Expect(1, 68681, '\P{	 is_Old_Turkic}', "");
    Expect(0, 68681, '\P{^	 is_Old_Turkic}', "");
    Error('\p{ _Orkh/a/}');
    Error('\P{ _Orkh/a/}');
    Expect(1, 68680, '\p{orkh}', "");
    Expect(0, 68680, '\p{^orkh}', "");
    Expect(0, 68680, '\P{orkh}', "");
    Expect(1, 68680, '\P{^orkh}', "");
    Expect(0, 68681, '\p{orkh}', "");
    Expect(1, 68681, '\p{^orkh}', "");
    Expect(1, 68681, '\P{orkh}', "");
    Expect(0, 68681, '\P{^orkh}', "");
    Expect(1, 68680, '\p{-_orkh}', "");
    Expect(0, 68680, '\p{^-_orkh}', "");
    Expect(0, 68680, '\P{-_orkh}', "");
    Expect(1, 68680, '\P{^-_orkh}', "");
    Expect(0, 68681, '\p{-_orkh}', "");
    Expect(1, 68681, '\p{^-_orkh}', "");
    Expect(1, 68681, '\P{-_orkh}', "");
    Expect(0, 68681, '\P{^-_orkh}', "");
    Error('\p{/a/__is_Orkh}');
    Error('\P{/a/__is_Orkh}');
    Expect(1, 68680, '\p{isorkh}', "");
    Expect(0, 68680, '\p{^isorkh}', "");
    Expect(0, 68680, '\P{isorkh}', "");
    Expect(1, 68680, '\P{^isorkh}', "");
    Expect(0, 68681, '\p{isorkh}', "");
    Expect(1, 68681, '\p{^isorkh}', "");
    Expect(1, 68681, '\P{isorkh}', "");
    Expect(0, 68681, '\P{^isorkh}', "");
    Expect(1, 68680, '\p{ -IS_Orkh}', "");
    Expect(0, 68680, '\p{^ -IS_Orkh}', "");
    Expect(0, 68680, '\P{ -IS_Orkh}', "");
    Expect(1, 68680, '\P{^ -IS_Orkh}', "");
    Expect(0, 68681, '\p{ -IS_Orkh}', "");
    Expect(1, 68681, '\p{^ -IS_Orkh}', "");
    Expect(1, 68681, '\P{ -IS_Orkh}', "");
    Expect(0, 68681, '\P{^ -IS_Orkh}', "");
    Error('\p{:=- Old_Uyghur}');
    Error('\P{:=- Old_Uyghur}');
    Expect(1, 69513, '\p{olduyghur}', "");
    Expect(0, 69513, '\p{^olduyghur}', "");
    Expect(0, 69513, '\P{olduyghur}', "");
    Expect(1, 69513, '\P{^olduyghur}', "");
    Expect(0, 69514, '\p{olduyghur}', "");
    Expect(1, 69514, '\p{^olduyghur}', "");
    Expect(1, 69514, '\P{olduyghur}', "");
    Expect(0, 69514, '\P{^olduyghur}', "");
    Expect(1, 69513, '\p{__OLD_UYGHUR}', "");
    Expect(0, 69513, '\p{^__OLD_UYGHUR}', "");
    Expect(0, 69513, '\P{__OLD_UYGHUR}', "");
    Expect(1, 69513, '\P{^__OLD_UYGHUR}', "");
    Expect(0, 69514, '\p{__OLD_UYGHUR}', "");
    Expect(1, 69514, '\p{^__OLD_UYGHUR}', "");
    Expect(1, 69514, '\P{__OLD_UYGHUR}', "");
    Expect(0, 69514, '\P{^__OLD_UYGHUR}', "");
    Error('\p{:=_	Is_Old_UYGHUR}');
    Error('\P{:=_	Is_Old_UYGHUR}');
    Expect(1, 69513, '\p{isolduyghur}', "");
    Expect(0, 69513, '\p{^isolduyghur}', "");
    Expect(0, 69513, '\P{isolduyghur}', "");
    Expect(1, 69513, '\P{^isolduyghur}', "");
    Expect(0, 69514, '\p{isolduyghur}', "");
    Expect(1, 69514, '\p{^isolduyghur}', "");
    Expect(1, 69514, '\P{isolduyghur}', "");
    Expect(0, 69514, '\P{^isolduyghur}', "");
    Expect(1, 69513, '\p{	_Is_Old_UYGHUR}', "");
    Expect(0, 69513, '\p{^	_Is_Old_UYGHUR}', "");
    Expect(0, 69513, '\P{	_Is_Old_UYGHUR}', "");
    Expect(1, 69513, '\P{^	_Is_Old_UYGHUR}', "");
    Expect(0, 69514, '\p{	_Is_Old_UYGHUR}', "");
    Expect(1, 69514, '\p{^	_Is_Old_UYGHUR}', "");
    Expect(1, 69514, '\P{	_Is_Old_UYGHUR}', "");
    Expect(0, 69514, '\P{^	_Is_Old_UYGHUR}', "");
    Error('\p{OUGR/a/}');
    Error('\P{OUGR/a/}');
    Expect(1, 69513, '\p{ougr}', "");
    Expect(0, 69513, '\p{^ougr}', "");
    Expect(0, 69513, '\P{ougr}', "");
    Expect(1, 69513, '\P{^ougr}', "");
    Expect(0, 69514, '\p{ougr}', "");
    Expect(1, 69514, '\p{^ougr}', "");
    Expect(1, 69514, '\P{ougr}', "");
    Expect(0, 69514, '\P{^ougr}', "");
    Expect(1, 69513, '\p{_ougr}', "");
    Expect(0, 69513, '\p{^_ougr}', "");
    Expect(0, 69513, '\P{_ougr}', "");
    Expect(1, 69513, '\P{^_ougr}', "");
    Expect(0, 69514, '\p{_ougr}', "");
    Expect(1, 69514, '\p{^_ougr}', "");
    Expect(1, 69514, '\P{_ougr}', "");
    Expect(0, 69514, '\P{^_ougr}', "");
    Error('\p{-is_OUGR/a/}');
    Error('\P{-is_OUGR/a/}');
    Expect(1, 69513, '\p{isougr}', "");
    Expect(0, 69513, '\p{^isougr}', "");
    Expect(0, 69513, '\P{isougr}', "");
    Expect(1, 69513, '\P{^isougr}', "");
    Expect(0, 69514, '\p{isougr}', "");
    Expect(1, 69514, '\p{^isougr}', "");
    Expect(1, 69514, '\P{isougr}', "");
    Expect(0, 69514, '\P{^isougr}', "");
    Expect(1, 69513, '\p{_ Is_ougr}', "");
    Expect(0, 69513, '\p{^_ Is_ougr}', "");
    Expect(0, 69513, '\P{_ Is_ougr}', "");
    Expect(1, 69513, '\P{^_ Is_ougr}', "");
    Expect(0, 69514, '\p{_ Is_ougr}', "");
    Expect(1, 69514, '\p{^_ Is_ougr}', "");
    Expect(1, 69514, '\P{_ Is_ougr}', "");
    Expect(0, 69514, '\P{^_ Is_ougr}', "");
    Error('\p{ /a/Open_Punctuation}');
    Error('\P{ /a/Open_Punctuation}');
    Expect(1, 65378, '\p{openpunctuation}', "");
    Expect(0, 65378, '\p{^openpunctuation}', "");
    Expect(0, 65378, '\P{openpunctuation}', "");
    Expect(1, 65378, '\P{^openpunctuation}', "");
    Expect(0, 65379, '\p{openpunctuation}', "");
    Expect(1, 65379, '\p{^openpunctuation}', "");
    Expect(1, 65379, '\P{openpunctuation}', "");
    Expect(0, 65379, '\P{^openpunctuation}', "");
    Expect(1, 65378, '\p{- Open_Punctuation}', "");
    Expect(0, 65378, '\p{^- Open_Punctuation}', "");
    Expect(0, 65378, '\P{- Open_Punctuation}', "");
    Expect(1, 65378, '\P{^- Open_Punctuation}', "");
    Expect(0, 65379, '\p{- Open_Punctuation}', "");
    Expect(1, 65379, '\p{^- Open_Punctuation}', "");
    Expect(1, 65379, '\P{- Open_Punctuation}', "");
    Expect(0, 65379, '\P{^- Open_Punctuation}', "");
    Error('\p{	:=Is_Open_PUNCTUATION}');
    Error('\P{	:=Is_Open_PUNCTUATION}');
    Expect(1, 65378, '\p{isopenpunctuation}', "");
    Expect(0, 65378, '\p{^isopenpunctuation}', "");
    Expect(0, 65378, '\P{isopenpunctuation}', "");
    Expect(1, 65378, '\P{^isopenpunctuation}', "");
    Expect(0, 65379, '\p{isopenpunctuation}', "");
    Expect(1, 65379, '\p{^isopenpunctuation}', "");
    Expect(1, 65379, '\P{isopenpunctuation}', "");
    Expect(0, 65379, '\P{^isopenpunctuation}', "");
    Expect(1, 65378, '\p{ -is_OPEN_punctuation}', "");
    Expect(0, 65378, '\p{^ -is_OPEN_punctuation}', "");
    Expect(0, 65378, '\P{ -is_OPEN_punctuation}', "");
    Expect(1, 65378, '\P{^ -is_OPEN_punctuation}', "");
    Expect(0, 65379, '\p{ -is_OPEN_punctuation}', "");
    Expect(1, 65379, '\p{^ -is_OPEN_punctuation}', "");
    Expect(1, 65379, '\P{ -is_OPEN_punctuation}', "");
    Expect(0, 65379, '\P{^ -is_OPEN_punctuation}', "");
    Error('\p{--Ps:=}');
    Error('\P{--Ps:=}');
    Expect(1, 65378, '\p{ps}', "");
    Expect(0, 65378, '\p{^ps}', "");
    Expect(0, 65378, '\P{ps}', "");
    Expect(1, 65378, '\P{^ps}', "");
    Expect(0, 65379, '\p{ps}', "");
    Expect(1, 65379, '\p{^ps}', "");
    Expect(1, 65379, '\P{ps}', "");
    Expect(0, 65379, '\P{^ps}', "");
    Expect(1, 65378, '\p{_ Ps}', "");
    Expect(0, 65378, '\p{^_ Ps}', "");
    Expect(0, 65378, '\P{_ Ps}', "");
    Expect(1, 65378, '\P{^_ Ps}', "");
    Expect(0, 65379, '\p{_ Ps}', "");
    Expect(1, 65379, '\p{^_ Ps}', "");
    Expect(1, 65379, '\P{_ Ps}', "");
    Expect(0, 65379, '\P{^_ Ps}', "");
    Error('\p{__Is_PS/a/}');
    Error('\P{__Is_PS/a/}');
    Expect(1, 65378, '\p{isps}', "");
    Expect(0, 65378, '\p{^isps}', "");
    Expect(0, 65378, '\P{isps}', "");
    Expect(1, 65378, '\P{^isps}', "");
    Expect(0, 65379, '\p{isps}', "");
    Expect(1, 65379, '\p{^isps}', "");
    Expect(1, 65379, '\P{isps}', "");
    Expect(0, 65379, '\P{^isps}', "");
    Expect(1, 65378, '\p{--IS_ps}', "");
    Expect(0, 65378, '\p{^--IS_ps}', "");
    Expect(0, 65378, '\P{--IS_ps}', "");
    Expect(1, 65378, '\P{^--IS_ps}', "");
    Expect(0, 65379, '\p{--IS_ps}', "");
    Expect(1, 65379, '\p{^--IS_ps}', "");
    Expect(1, 65379, '\P{--IS_ps}', "");
    Expect(0, 65379, '\P{^--IS_ps}', "");
    Error('\p{/a/-_Optical_Character_RECOGNITION}');
    Error('\P{/a/-_Optical_Character_RECOGNITION}');
    Expect(1, 9311, '\p{opticalcharacterrecognition}', "");
    Expect(0, 9311, '\p{^opticalcharacterrecognition}', "");
    Expect(0, 9311, '\P{opticalcharacterrecognition}', "");
    Expect(1, 9311, '\P{^opticalcharacterrecognition}', "");
    Expect(0, 9312, '\p{opticalcharacterrecognition}', "");
    Expect(1, 9312, '\p{^opticalcharacterrecognition}', "");
    Expect(1, 9312, '\P{opticalcharacterrecognition}', "");
    Expect(0, 9312, '\P{^opticalcharacterrecognition}', "");
    Expect(1, 9311, '\p{- Optical_Character_RECOGNITION}', "");
    Expect(0, 9311, '\p{^- Optical_Character_RECOGNITION}', "");
    Expect(0, 9311, '\P{- Optical_Character_RECOGNITION}', "");
    Expect(1, 9311, '\P{^- Optical_Character_RECOGNITION}', "");
    Expect(0, 9312, '\p{- Optical_Character_RECOGNITION}', "");
    Expect(1, 9312, '\p{^- Optical_Character_RECOGNITION}', "");
    Expect(1, 9312, '\P{- Optical_Character_RECOGNITION}', "");
    Expect(0, 9312, '\P{^- Optical_Character_RECOGNITION}', "");
    Error('\p{/a/_is_optical_Character_RECOGNITION}');
    Error('\P{/a/_is_optical_Character_RECOGNITION}');
    Expect(1, 9311, '\p{isopticalcharacterrecognition}', "");
    Expect(0, 9311, '\p{^isopticalcharacterrecognition}', "");
    Expect(0, 9311, '\P{isopticalcharacterrecognition}', "");
    Expect(1, 9311, '\P{^isopticalcharacterrecognition}', "");
    Expect(0, 9312, '\p{isopticalcharacterrecognition}', "");
    Expect(1, 9312, '\p{^isopticalcharacterrecognition}', "");
    Expect(1, 9312, '\P{isopticalcharacterrecognition}', "");
    Expect(0, 9312, '\P{^isopticalcharacterrecognition}', "");
    Expect(1, 9311, '\p{ 	Is_Optical_Character_recognition}', "");
    Expect(0, 9311, '\p{^ 	Is_Optical_Character_recognition}', "");
    Expect(0, 9311, '\P{ 	Is_Optical_Character_recognition}', "");
    Expect(1, 9311, '\P{^ 	Is_Optical_Character_recognition}', "");
    Expect(0, 9312, '\p{ 	Is_Optical_Character_recognition}', "");
    Expect(1, 9312, '\p{^ 	Is_Optical_Character_recognition}', "");
    Expect(1, 9312, '\P{ 	Is_Optical_Character_recognition}', "");
    Expect(0, 9312, '\P{^ 	Is_Optical_Character_recognition}', "");
    Error('\p{		in_Optical_CHARACTER_recognition/a/}');
    Error('\P{		in_Optical_CHARACTER_recognition/a/}');
    Expect(1, 9311, '\p{inopticalcharacterrecognition}', "");
    Expect(0, 9311, '\p{^inopticalcharacterrecognition}', "");
    Expect(0, 9311, '\P{inopticalcharacterrecognition}', "");
    Expect(1, 9311, '\P{^inopticalcharacterrecognition}', "");
    Expect(0, 9312, '\p{inopticalcharacterrecognition}', "");
    Expect(1, 9312, '\p{^inopticalcharacterrecognition}', "");
    Expect(1, 9312, '\P{inopticalcharacterrecognition}', "");
    Expect(0, 9312, '\P{^inopticalcharacterrecognition}', "");
    Expect(1, 9311, '\p{-	In_Optical_character_recognition}', "");
    Expect(0, 9311, '\p{^-	In_Optical_character_recognition}', "");
    Expect(0, 9311, '\P{-	In_Optical_character_recognition}', "");
    Expect(1, 9311, '\P{^-	In_Optical_character_recognition}', "");
    Expect(0, 9312, '\p{-	In_Optical_character_recognition}', "");
    Expect(1, 9312, '\p{^-	In_Optical_character_recognition}', "");
    Expect(1, 9312, '\P{-	In_Optical_character_recognition}', "");
    Expect(0, 9312, '\P{^-	In_Optical_character_recognition}', "");
    Error('\p{ :=OCR}');
    Error('\P{ :=OCR}');
    Expect(1, 9311, '\p{ocr}', "");
    Expect(0, 9311, '\p{^ocr}', "");
    Expect(0, 9311, '\P{ocr}', "");
    Expect(1, 9311, '\P{^ocr}', "");
    Expect(0, 9312, '\p{ocr}', "");
    Expect(1, 9312, '\p{^ocr}', "");
    Expect(1, 9312, '\P{ocr}', "");
    Expect(0, 9312, '\P{^ocr}', "");
    Expect(1, 9311, '\p{--OCR}', "");
    Expect(0, 9311, '\p{^--OCR}', "");
    Expect(0, 9311, '\P{--OCR}', "");
    Expect(1, 9311, '\P{^--OCR}', "");
    Expect(0, 9312, '\p{--OCR}', "");
    Expect(1, 9312, '\p{^--OCR}', "");
    Expect(1, 9312, '\P{--OCR}', "");
    Expect(0, 9312, '\P{^--OCR}', "");
    Error('\p{	IS_OCR/a/}');
    Error('\P{	IS_OCR/a/}');
    Expect(1, 9311, '\p{isocr}', "");
    Expect(0, 9311, '\p{^isocr}', "");
    Expect(0, 9311, '\P{isocr}', "");
    Expect(1, 9311, '\P{^isocr}', "");
    Expect(0, 9312, '\p{isocr}', "");
    Expect(1, 9312, '\p{^isocr}', "");
    Expect(1, 9312, '\P{isocr}', "");
    Expect(0, 9312, '\P{^isocr}', "");
    Expect(1, 9311, '\p{	-Is_OCR}', "");
    Expect(0, 9311, '\p{^	-Is_OCR}', "");
    Expect(0, 9311, '\P{	-Is_OCR}', "");
    Expect(1, 9311, '\P{^	-Is_OCR}', "");
    Expect(0, 9312, '\p{	-Is_OCR}', "");
    Expect(1, 9312, '\p{^	-Is_OCR}', "");
    Expect(1, 9312, '\P{	-Is_OCR}', "");
    Expect(0, 9312, '\P{^	-Is_OCR}', "");
    Error('\p{ :=IN_ocr}');
    Error('\P{ :=IN_ocr}');
    Expect(1, 9311, '\p{inocr}', "");
    Expect(0, 9311, '\p{^inocr}', "");
    Expect(0, 9311, '\P{inocr}', "");
    Expect(1, 9311, '\P{^inocr}', "");
    Expect(0, 9312, '\p{inocr}', "");
    Expect(1, 9312, '\p{^inocr}', "");
    Expect(1, 9312, '\P{inocr}', "");
    Expect(0, 9312, '\P{^inocr}', "");
    Expect(1, 9311, '\p{	 in_ocr}', "");
    Expect(0, 9311, '\p{^	 in_ocr}', "");
    Expect(0, 9311, '\P{	 in_ocr}', "");
    Expect(1, 9311, '\P{^	 in_ocr}', "");
    Expect(0, 9312, '\p{	 in_ocr}', "");
    Expect(1, 9312, '\p{^	 in_ocr}', "");
    Expect(1, 9312, '\P{	 in_ocr}', "");
    Expect(0, 9312, '\P{^	 in_ocr}', "");
    Error('\p{-:=oriya}');
    Error('\P{-:=oriya}');
    Expect(1, 7410, '\p{oriya}', "");
    Expect(0, 7410, '\p{^oriya}', "");
    Expect(0, 7410, '\P{oriya}', "");
    Expect(1, 7410, '\P{^oriya}', "");
    Expect(0, 7411, '\p{oriya}', "");
    Expect(1, 7411, '\p{^oriya}', "");
    Expect(1, 7411, '\P{oriya}', "");
    Expect(0, 7411, '\P{^oriya}', "");
    Expect(1, 7410, '\p{__Oriya}', "");
    Expect(0, 7410, '\p{^__Oriya}', "");
    Expect(0, 7410, '\P{__Oriya}', "");
    Expect(1, 7410, '\P{^__Oriya}', "");
    Expect(0, 7411, '\p{__Oriya}', "");
    Expect(1, 7411, '\p{^__Oriya}', "");
    Expect(1, 7411, '\P{__Oriya}', "");
    Expect(0, 7411, '\P{^__Oriya}', "");
    Error('\p{/a/	-Is_ORIYA}');
    Error('\P{/a/	-Is_ORIYA}');
    Expect(1, 7410, '\p{isoriya}', "");
    Expect(0, 7410, '\p{^isoriya}', "");
    Expect(0, 7410, '\P{isoriya}', "");
    Expect(1, 7410, '\P{^isoriya}', "");
    Expect(0, 7411, '\p{isoriya}', "");
    Expect(1, 7411, '\p{^isoriya}', "");
    Expect(1, 7411, '\P{isoriya}', "");
    Expect(0, 7411, '\P{^isoriya}', "");
    Expect(1, 7410, '\p{_Is_Oriya}', "");
    Expect(0, 7410, '\p{^_Is_Oriya}', "");
    Expect(0, 7410, '\P{_Is_Oriya}', "");
    Expect(1, 7410, '\P{^_Is_Oriya}', "");
    Expect(0, 7411, '\p{_Is_Oriya}', "");
    Expect(1, 7411, '\p{^_Is_Oriya}', "");
    Expect(1, 7411, '\P{_Is_Oriya}', "");
    Expect(0, 7411, '\P{^_Is_Oriya}', "");
    Error('\p{/a/	orya}');
    Error('\P{/a/	orya}');
    Expect(1, 7410, '\p{orya}', "");
    Expect(0, 7410, '\p{^orya}', "");
    Expect(0, 7410, '\P{orya}', "");
    Expect(1, 7410, '\P{^orya}', "");
    Expect(0, 7411, '\p{orya}', "");
    Expect(1, 7411, '\p{^orya}', "");
    Expect(1, 7411, '\P{orya}', "");
    Expect(0, 7411, '\P{^orya}', "");
    Expect(1, 7410, '\p{_ Orya}', "");
    Expect(0, 7410, '\p{^_ Orya}', "");
    Expect(0, 7410, '\P{_ Orya}', "");
    Expect(1, 7410, '\P{^_ Orya}', "");
    Expect(0, 7411, '\p{_ Orya}', "");
    Expect(1, 7411, '\p{^_ Orya}', "");
    Expect(1, 7411, '\P{_ Orya}', "");
    Expect(0, 7411, '\P{^_ Orya}', "");
    Error('\p{		is_Orya/a/}');
    Error('\P{		is_Orya/a/}');
    Expect(1, 7410, '\p{isorya}', "");
    Expect(0, 7410, '\p{^isorya}', "");
    Expect(0, 7410, '\P{isorya}', "");
    Expect(1, 7410, '\P{^isorya}', "");
    Expect(0, 7411, '\p{isorya}', "");
    Expect(1, 7411, '\p{^isorya}', "");
    Expect(1, 7411, '\P{isorya}', "");
    Expect(0, 7411, '\P{^isorya}', "");
    Expect(1, 7410, '\p{	-Is_Orya}', "");
    Expect(0, 7410, '\p{^	-Is_Orya}', "");
    Expect(0, 7410, '\P{	-Is_Orya}', "");
    Expect(1, 7410, '\P{^	-Is_Orya}', "");
    Expect(0, 7411, '\p{	-Is_Orya}', "");
    Expect(1, 7411, '\p{^	-Is_Orya}', "");
    Expect(1, 7411, '\P{	-Is_Orya}', "");
    Expect(0, 7411, '\P{^	-Is_Orya}', "");
    Error('\p{-_Ornamental_dingbats/a/}');
    Error('\P{-_Ornamental_dingbats/a/}');
    Expect(1, 128639, '\p{ornamentaldingbats}', "");
    Expect(0, 128639, '\p{^ornamentaldingbats}', "");
    Expect(0, 128639, '\P{ornamentaldingbats}', "");
    Expect(1, 128639, '\P{^ornamentaldingbats}', "");
    Expect(0, 128640, '\p{ornamentaldingbats}', "");
    Expect(1, 128640, '\p{^ornamentaldingbats}', "");
    Expect(1, 128640, '\P{ornamentaldingbats}', "");
    Expect(0, 128640, '\P{^ornamentaldingbats}', "");
    Expect(1, 128639, '\p{-ornamental_DINGBATS}', "");
    Expect(0, 128639, '\p{^-ornamental_DINGBATS}', "");
    Expect(0, 128639, '\P{-ornamental_DINGBATS}', "");
    Expect(1, 128639, '\P{^-ornamental_DINGBATS}', "");
    Expect(0, 128640, '\p{-ornamental_DINGBATS}', "");
    Expect(1, 128640, '\p{^-ornamental_DINGBATS}', "");
    Expect(1, 128640, '\P{-ornamental_DINGBATS}', "");
    Expect(0, 128640, '\P{^-ornamental_DINGBATS}', "");
    Error('\p{:= _Is_ornamental_Dingbats}');
    Error('\P{:= _Is_ornamental_Dingbats}');
    Expect(1, 128639, '\p{isornamentaldingbats}', "");
    Expect(0, 128639, '\p{^isornamentaldingbats}', "");
    Expect(0, 128639, '\P{isornamentaldingbats}', "");
    Expect(1, 128639, '\P{^isornamentaldingbats}', "");
    Expect(0, 128640, '\p{isornamentaldingbats}', "");
    Expect(1, 128640, '\p{^isornamentaldingbats}', "");
    Expect(1, 128640, '\P{isornamentaldingbats}', "");
    Expect(0, 128640, '\P{^isornamentaldingbats}', "");
    Expect(1, 128639, '\p{__Is_Ornamental_DINGBATS}', "");
    Expect(0, 128639, '\p{^__Is_Ornamental_DINGBATS}', "");
    Expect(0, 128639, '\P{__Is_Ornamental_DINGBATS}', "");
    Expect(1, 128639, '\P{^__Is_Ornamental_DINGBATS}', "");
    Expect(0, 128640, '\p{__Is_Ornamental_DINGBATS}', "");
    Expect(1, 128640, '\p{^__Is_Ornamental_DINGBATS}', "");
    Expect(1, 128640, '\P{__Is_Ornamental_DINGBATS}', "");
    Expect(0, 128640, '\P{^__Is_Ornamental_DINGBATS}', "");
    Error('\p{In_ORNAMENTAL_DINGBATS:=}');
    Error('\P{In_ORNAMENTAL_DINGBATS:=}');
    Expect(1, 128639, '\p{inornamentaldingbats}', "");
    Expect(0, 128639, '\p{^inornamentaldingbats}', "");
    Expect(0, 128639, '\P{inornamentaldingbats}', "");
    Expect(1, 128639, '\P{^inornamentaldingbats}', "");
    Expect(0, 128640, '\p{inornamentaldingbats}', "");
    Expect(1, 128640, '\p{^inornamentaldingbats}', "");
    Expect(1, 128640, '\P{inornamentaldingbats}', "");
    Expect(0, 128640, '\P{^inornamentaldingbats}', "");
    Expect(1, 128639, '\p{-In_ORNAMENTAL_DINGBATS}', "");
    Expect(0, 128639, '\p{^-In_ORNAMENTAL_DINGBATS}', "");
    Expect(0, 128639, '\P{-In_ORNAMENTAL_DINGBATS}', "");
    Expect(1, 128639, '\P{^-In_ORNAMENTAL_DINGBATS}', "");
    Expect(0, 128640, '\p{-In_ORNAMENTAL_DINGBATS}', "");
    Expect(1, 128640, '\p{^-In_ORNAMENTAL_DINGBATS}', "");
    Expect(1, 128640, '\P{-In_ORNAMENTAL_DINGBATS}', "");
    Expect(0, 128640, '\P{^-In_ORNAMENTAL_DINGBATS}', "");
    Error('\p{/a/ -OSAGE}');
    Error('\P{/a/ -OSAGE}');
    Expect(1, 66811, '\p{osage}', "");
    Expect(0, 66811, '\p{^osage}', "");
    Expect(0, 66811, '\P{osage}', "");
    Expect(1, 66811, '\P{^osage}', "");
    Expect(0, 66812, '\p{osage}', "");
    Expect(1, 66812, '\p{^osage}', "");
    Expect(1, 66812, '\P{osage}', "");
    Expect(0, 66812, '\P{^osage}', "");
    Expect(1, 66811, '\p{_osage}', "");
    Expect(0, 66811, '\p{^_osage}', "");
    Expect(0, 66811, '\P{_osage}', "");
    Expect(1, 66811, '\P{^_osage}', "");
    Expect(0, 66812, '\p{_osage}', "");
    Expect(1, 66812, '\p{^_osage}', "");
    Expect(1, 66812, '\P{_osage}', "");
    Expect(0, 66812, '\P{^_osage}', "");
    Error('\p{	:=Is_Osage}');
    Error('\P{	:=Is_Osage}');
    Expect(1, 66811, '\p{isosage}', "");
    Expect(0, 66811, '\p{^isosage}', "");
    Expect(0, 66811, '\P{isosage}', "");
    Expect(1, 66811, '\P{^isosage}', "");
    Expect(0, 66812, '\p{isosage}', "");
    Expect(1, 66812, '\p{^isosage}', "");
    Expect(1, 66812, '\P{isosage}', "");
    Expect(0, 66812, '\P{^isosage}', "");
    Expect(1, 66811, '\p{__Is_OSAGE}', "");
    Expect(0, 66811, '\p{^__Is_OSAGE}', "");
    Expect(0, 66811, '\P{__Is_OSAGE}', "");
    Expect(1, 66811, '\P{^__Is_OSAGE}', "");
    Expect(0, 66812, '\p{__Is_OSAGE}', "");
    Expect(1, 66812, '\p{^__Is_OSAGE}', "");
    Expect(1, 66812, '\P{__Is_OSAGE}', "");
    Expect(0, 66812, '\P{^__Is_OSAGE}', "");
    Error('\p{:=Osge}');
    Error('\P{:=Osge}');
    Expect(1, 66811, '\p{osge}', "");
    Expect(0, 66811, '\p{^osge}', "");
    Expect(0, 66811, '\P{osge}', "");
    Expect(1, 66811, '\P{^osge}', "");
    Expect(0, 66812, '\p{osge}', "");
    Expect(1, 66812, '\p{^osge}', "");
    Expect(1, 66812, '\P{osge}', "");
    Expect(0, 66812, '\P{^osge}', "");
    Expect(1, 66811, '\p{ OSGE}', "");
    Expect(0, 66811, '\p{^ OSGE}', "");
    Expect(0, 66811, '\P{ OSGE}', "");
    Expect(1, 66811, '\P{^ OSGE}', "");
    Expect(0, 66812, '\p{ OSGE}', "");
    Expect(1, 66812, '\p{^ OSGE}', "");
    Expect(1, 66812, '\P{ OSGE}', "");
    Expect(0, 66812, '\P{^ OSGE}', "");
    Error('\p{:=	is_osge}');
    Error('\P{:=	is_osge}');
    Expect(1, 66811, '\p{isosge}', "");
    Expect(0, 66811, '\p{^isosge}', "");
    Expect(0, 66811, '\P{isosge}', "");
    Expect(1, 66811, '\P{^isosge}', "");
    Expect(0, 66812, '\p{isosge}', "");
    Expect(1, 66812, '\p{^isosge}', "");
    Expect(1, 66812, '\P{isosge}', "");
    Expect(0, 66812, '\P{^isosge}', "");
    Expect(1, 66811, '\p{ 	Is_osge}', "");
    Expect(0, 66811, '\p{^ 	Is_osge}', "");
    Expect(0, 66811, '\P{ 	Is_osge}', "");
    Expect(1, 66811, '\P{^ 	Is_osge}', "");
    Expect(0, 66812, '\p{ 	Is_osge}', "");
    Expect(1, 66812, '\p{^ 	Is_osge}', "");
    Expect(1, 66812, '\P{ 	Is_osge}', "");
    Expect(0, 66812, '\P{^ 	Is_osge}', "");
    Error('\p{:=Osmanya}');
    Error('\P{:=Osmanya}');
    Expect(1, 66729, '\p{osmanya}', "");
    Expect(0, 66729, '\p{^osmanya}', "");
    Expect(0, 66729, '\P{osmanya}', "");
    Expect(1, 66729, '\P{^osmanya}', "");
    Expect(0, 66730, '\p{osmanya}', "");
    Expect(1, 66730, '\p{^osmanya}', "");
    Expect(1, 66730, '\P{osmanya}', "");
    Expect(0, 66730, '\P{^osmanya}', "");
    Expect(1, 66729, '\p{  osmanya}', "");
    Expect(0, 66729, '\p{^  osmanya}', "");
    Expect(0, 66729, '\P{  osmanya}', "");
    Expect(1, 66729, '\P{^  osmanya}', "");
    Expect(0, 66730, '\p{  osmanya}', "");
    Expect(1, 66730, '\p{^  osmanya}', "");
    Expect(1, 66730, '\P{  osmanya}', "");
    Expect(0, 66730, '\P{^  osmanya}', "");
    Error('\p{_-IS_OSMANYA/a/}');
    Error('\P{_-IS_OSMANYA/a/}');
    Expect(1, 66729, '\p{isosmanya}', "");
    Expect(0, 66729, '\p{^isosmanya}', "");
    Expect(0, 66729, '\P{isosmanya}', "");
    Expect(1, 66729, '\P{^isosmanya}', "");
    Expect(0, 66730, '\p{isosmanya}', "");
    Expect(1, 66730, '\p{^isosmanya}', "");
    Expect(1, 66730, '\P{isosmanya}', "");
    Expect(0, 66730, '\P{^isosmanya}', "");
    Expect(1, 66729, '\p{-IS_Osmanya}', "");
    Expect(0, 66729, '\p{^-IS_Osmanya}', "");
    Expect(0, 66729, '\P{-IS_Osmanya}', "");
    Expect(1, 66729, '\P{^-IS_Osmanya}', "");
    Expect(0, 66730, '\p{-IS_Osmanya}', "");
    Expect(1, 66730, '\p{^-IS_Osmanya}', "");
    Expect(1, 66730, '\P{-IS_Osmanya}', "");
    Expect(0, 66730, '\P{^-IS_Osmanya}', "");
    Error('\p{-Osma:=}');
    Error('\P{-Osma:=}');
    Expect(1, 66729, '\p{osma}', "");
    Expect(0, 66729, '\p{^osma}', "");
    Expect(0, 66729, '\P{osma}', "");
    Expect(1, 66729, '\P{^osma}', "");
    Expect(0, 66730, '\p{osma}', "");
    Expect(1, 66730, '\p{^osma}', "");
    Expect(1, 66730, '\P{osma}', "");
    Expect(0, 66730, '\P{^osma}', "");
    Expect(1, 66729, '\p{		Osma}', "");
    Expect(0, 66729, '\p{^		Osma}', "");
    Expect(0, 66729, '\P{		Osma}', "");
    Expect(1, 66729, '\P{^		Osma}', "");
    Expect(0, 66730, '\p{		Osma}', "");
    Expect(1, 66730, '\p{^		Osma}', "");
    Expect(1, 66730, '\P{		Osma}', "");
    Expect(0, 66730, '\P{^		Osma}', "");
    Error('\p{:=	_is_OSMA}');
    Error('\P{:=	_is_OSMA}');
    Expect(1, 66729, '\p{isosma}', "");
    Expect(0, 66729, '\p{^isosma}', "");
    Expect(0, 66729, '\P{isosma}', "");
    Expect(1, 66729, '\P{^isosma}', "");
    Expect(0, 66730, '\p{isosma}', "");
    Expect(1, 66730, '\p{^isosma}', "");
    Expect(1, 66730, '\P{isosma}', "");
    Expect(0, 66730, '\P{^isosma}', "");
    Expect(1, 66729, '\p{_	Is_Osma}', "");
    Expect(0, 66729, '\p{^_	Is_Osma}', "");
    Expect(0, 66729, '\P{_	Is_Osma}', "");
    Expect(1, 66729, '\P{^_	Is_Osma}', "");
    Expect(0, 66730, '\p{_	Is_Osma}', "");
    Expect(1, 66730, '\p{^_	Is_Osma}', "");
    Expect(1, 66730, '\P{_	Is_Osma}', "");
    Expect(0, 66730, '\P{^_	Is_Osma}', "");
    Error('\p{	/a/other}');
    Error('\P{	/a/other}');
    Expect(1, 918000, '\p{other}', "");
    Expect(0, 918000, '\p{^other}', "");
    Expect(0, 918000, '\P{other}', "");
    Expect(1, 918000, '\P{^other}', "");
    Expect(0, 917999, '\p{other}', "");
    Expect(1, 917999, '\p{^other}', "");
    Expect(1, 917999, '\P{other}', "");
    Expect(0, 917999, '\P{^other}', "");
    Expect(1, 918000, '\p{	-Other}', "");
    Expect(0, 918000, '\p{^	-Other}', "");
    Expect(0, 918000, '\P{	-Other}', "");
    Expect(1, 918000, '\P{^	-Other}', "");
    Expect(0, 917999, '\p{	-Other}', "");
    Expect(1, 917999, '\p{^	-Other}', "");
    Expect(1, 917999, '\P{	-Other}', "");
    Expect(0, 917999, '\P{^	-Other}', "");
    Error('\p{_:=Is_OTHER}');
    Error('\P{_:=Is_OTHER}');
    Expect(1, 918000, '\p{isother}', "");
    Expect(0, 918000, '\p{^isother}', "");
    Expect(0, 918000, '\P{isother}', "");
    Expect(1, 918000, '\P{^isother}', "");
    Expect(0, 917999, '\p{isother}', "");
    Expect(1, 917999, '\p{^isother}', "");
    Expect(1, 917999, '\P{isother}', "");
    Expect(0, 917999, '\P{^isother}', "");
    Expect(1, 918000, '\p{ 	Is_Other}', "");
    Expect(0, 918000, '\p{^ 	Is_Other}', "");
    Expect(0, 918000, '\P{ 	Is_Other}', "");
    Expect(1, 918000, '\P{^ 	Is_Other}', "");
    Expect(0, 917999, '\p{ 	Is_Other}', "");
    Expect(1, 917999, '\p{^ 	Is_Other}', "");
    Expect(1, 917999, '\P{ 	Is_Other}', "");
    Expect(0, 917999, '\P{^ 	Is_Other}', "");
    Error('\p{:=--C}');
    Error('\P{:=--C}');
    Expect(1, 918000, '\p{c}', "");
    Expect(0, 918000, '\p{^c}', "");
    Expect(0, 918000, '\P{c}', "");
    Expect(1, 918000, '\P{^c}', "");
    Expect(0, 917999, '\p{c}', "");
    Expect(1, 917999, '\p{^c}', "");
    Expect(1, 917999, '\P{c}', "");
    Expect(0, 917999, '\P{^c}', "");
    Expect(1, 918000, '\p{		c}', "");
    Expect(0, 918000, '\p{^		c}', "");
    Expect(0, 918000, '\P{		c}', "");
    Expect(1, 918000, '\P{^		c}', "");
    Expect(0, 917999, '\p{		c}', "");
    Expect(1, 917999, '\p{^		c}', "");
    Expect(1, 917999, '\P{		c}', "");
    Expect(0, 917999, '\P{^		c}', "");
    Error('\p{--is_C:=}');
    Error('\P{--is_C:=}');
    Expect(1, 918000, '\p{isc}', "");
    Expect(0, 918000, '\p{^isc}', "");
    Expect(0, 918000, '\P{isc}', "");
    Expect(1, 918000, '\P{^isc}', "");
    Expect(0, 917999, '\p{isc}', "");
    Expect(1, 917999, '\p{^isc}', "");
    Expect(1, 917999, '\P{isc}', "");
    Expect(0, 917999, '\P{^isc}', "");
    Expect(1, 918000, '\p{- Is_C}', "");
    Expect(0, 918000, '\p{^- Is_C}', "");
    Expect(0, 918000, '\P{- Is_C}', "");
    Expect(1, 918000, '\P{^- Is_C}', "");
    Expect(0, 917999, '\p{- Is_C}', "");
    Expect(1, 917999, '\p{^- Is_C}', "");
    Expect(1, 917999, '\P{- Is_C}', "");
    Expect(0, 917999, '\P{^- Is_C}', "");
    Error('\p{Other_Alphabetic}');
    Error('\P{Other_Alphabetic}');
    Error('\p{OAlpha}');
    Error('\P{OAlpha}');
    Error('\p{Other_Default_Ignorable_Code_Point}');
    Error('\P{Other_Default_Ignorable_Code_Point}');
    Error('\p{ODI}');
    Error('\P{ODI}');
    Error('\p{Other_Grapheme_Extend}');
    Error('\P{Other_Grapheme_Extend}');
    Error('\p{OGr_Ext}');
    Error('\P{OGr_Ext}');
    Error('\p{Other_ID_Continue}');
    Error('\P{Other_ID_Continue}');
    Error('\p{OIDC}');
    Error('\P{OIDC}');
    Error('\p{Other_ID_Start}');
    Error('\P{Other_ID_Start}');
    Error('\p{OIDS}');
    Error('\P{OIDS}');
    Error('\p{	/a/OTHER_LETTER}');
    Error('\P{	/a/OTHER_LETTER}');
    Expect(1, 205743, '\p{otherletter}', "");
    Expect(0, 205743, '\p{^otherletter}', "");
    Expect(0, 205743, '\P{otherletter}', "");
    Expect(1, 205743, '\P{^otherletter}', "");
    Expect(0, 205744, '\p{otherletter}', "");
    Expect(1, 205744, '\p{^otherletter}', "");
    Expect(1, 205744, '\P{otherletter}', "");
    Expect(0, 205744, '\P{^otherletter}', "");
    Expect(1, 205743, '\p{ -OTHER_LETTER}', "");
    Expect(0, 205743, '\p{^ -OTHER_LETTER}', "");
    Expect(0, 205743, '\P{ -OTHER_LETTER}', "");
    Expect(1, 205743, '\P{^ -OTHER_LETTER}', "");
    Expect(0, 205744, '\p{ -OTHER_LETTER}', "");
    Expect(1, 205744, '\p{^ -OTHER_LETTER}', "");
    Expect(1, 205744, '\P{ -OTHER_LETTER}', "");
    Expect(0, 205744, '\P{^ -OTHER_LETTER}', "");
    Error('\p{/a/is_OTHER_Letter}');
    Error('\P{/a/is_OTHER_Letter}');
    Expect(1, 205743, '\p{isotherletter}', "");
    Expect(0, 205743, '\p{^isotherletter}', "");
    Expect(0, 205743, '\P{isotherletter}', "");
    Expect(1, 205743, '\P{^isotherletter}', "");
    Expect(0, 205744, '\p{isotherletter}', "");
    Expect(1, 205744, '\p{^isotherletter}', "");
    Expect(1, 205744, '\P{isotherletter}', "");
    Expect(0, 205744, '\P{^isotherletter}', "");
    Expect(1, 205743, '\p{ _Is_Other_Letter}', "");
    Expect(0, 205743, '\p{^ _Is_Other_Letter}', "");
    Expect(0, 205743, '\P{ _Is_Other_Letter}', "");
    Expect(1, 205743, '\P{^ _Is_Other_Letter}', "");
    Expect(0, 205744, '\p{ _Is_Other_Letter}', "");
    Expect(1, 205744, '\p{^ _Is_Other_Letter}', "");
    Expect(1, 205744, '\P{ _Is_Other_Letter}', "");
    Expect(0, 205744, '\P{^ _Is_Other_Letter}', "");
    Error('\p{:=	-lo}');
    Error('\P{:=	-lo}');
    Expect(1, 205743, '\p{lo}', "");
    Expect(0, 205743, '\p{^lo}', "");
    Expect(0, 205743, '\P{lo}', "");
    Expect(1, 205743, '\P{^lo}', "");
    Expect(0, 205744, '\p{lo}', "");
    Expect(1, 205744, '\p{^lo}', "");
    Expect(1, 205744, '\P{lo}', "");
    Expect(0, 205744, '\P{^lo}', "");
    Expect(1, 205743, '\p{ lo}', "");
    Expect(0, 205743, '\p{^ lo}', "");
    Expect(0, 205743, '\P{ lo}', "");
    Expect(1, 205743, '\P{^ lo}', "");
    Expect(0, 205744, '\p{ lo}', "");
    Expect(1, 205744, '\p{^ lo}', "");
    Expect(1, 205744, '\P{ lo}', "");
    Expect(0, 205744, '\P{^ lo}', "");
    Error('\p{ _IS_LO:=}');
    Error('\P{ _IS_LO:=}');
    Expect(1, 205743, '\p{islo}', "");
    Expect(0, 205743, '\p{^islo}', "");
    Expect(0, 205743, '\P{islo}', "");
    Expect(1, 205743, '\P{^islo}', "");
    Expect(0, 205744, '\p{islo}', "");
    Expect(1, 205744, '\p{^islo}', "");
    Expect(1, 205744, '\P{islo}', "");
    Expect(0, 205744, '\P{^islo}', "");
    Expect(1, 205743, '\p{	-IS_lo}', "");
    Expect(0, 205743, '\p{^	-IS_lo}', "");
    Expect(0, 205743, '\P{	-IS_lo}', "");
    Expect(1, 205743, '\P{^	-IS_lo}', "");
    Expect(0, 205744, '\p{	-IS_lo}', "");
    Expect(1, 205744, '\p{^	-IS_lo}', "");
    Expect(1, 205744, '\P{	-IS_lo}', "");
    Expect(0, 205744, '\P{^	-IS_lo}', "");
    Error('\p{Other_Lowercase}');
    Error('\P{Other_Lowercase}');
    Error('\p{OLower}');
    Error('\P{OLower}');
    Error('\p{Other_Math}');
    Error('\P{Other_Math}');
    Error('\p{OMath}');
    Error('\P{OMath}');
    Error('\p{_Other_number:=}');
    Error('\P{_Other_number:=}');
    Expect(1, 127244, '\p{othernumber}', "");
    Expect(0, 127244, '\p{^othernumber}', "");
    Expect(0, 127244, '\P{othernumber}', "");
    Expect(1, 127244, '\P{^othernumber}', "");
    Expect(0, 127245, '\p{othernumber}', "");
    Expect(1, 127245, '\p{^othernumber}', "");
    Expect(1, 127245, '\P{othernumber}', "");
    Expect(0, 127245, '\P{^othernumber}', "");
    Expect(1, 127244, '\p{	-Other_Number}', "");
    Expect(0, 127244, '\p{^	-Other_Number}', "");
    Expect(0, 127244, '\P{	-Other_Number}', "");
    Expect(1, 127244, '\P{^	-Other_Number}', "");
    Expect(0, 127245, '\p{	-Other_Number}', "");
    Expect(1, 127245, '\p{^	-Other_Number}', "");
    Expect(1, 127245, '\P{	-Other_Number}', "");
    Expect(0, 127245, '\P{^	-Other_Number}', "");
    Error('\p{_Is_other_Number:=}');
    Error('\P{_Is_other_Number:=}');
    Expect(1, 127244, '\p{isothernumber}', "");
    Expect(0, 127244, '\p{^isothernumber}', "");
    Expect(0, 127244, '\P{isothernumber}', "");
    Expect(1, 127244, '\P{^isothernumber}', "");
    Expect(0, 127245, '\p{isothernumber}', "");
    Expect(1, 127245, '\p{^isothernumber}', "");
    Expect(1, 127245, '\P{isothernumber}', "");
    Expect(0, 127245, '\P{^isothernumber}', "");
    Expect(1, 127244, '\p{	 is_Other_NUMBER}', "");
    Expect(0, 127244, '\p{^	 is_Other_NUMBER}', "");
    Expect(0, 127244, '\P{	 is_Other_NUMBER}', "");
    Expect(1, 127244, '\P{^	 is_Other_NUMBER}', "");
    Expect(0, 127245, '\p{	 is_Other_NUMBER}', "");
    Expect(1, 127245, '\p{^	 is_Other_NUMBER}', "");
    Expect(1, 127245, '\P{	 is_Other_NUMBER}', "");
    Expect(0, 127245, '\P{^	 is_Other_NUMBER}', "");
    Error('\p{ _NO/a/}');
    Error('\P{ _NO/a/}');
    Expect(1, 127244, '\p{no}', "");
    Expect(0, 127244, '\p{^no}', "");
    Expect(0, 127244, '\P{no}', "");
    Expect(1, 127244, '\P{^no}', "");
    Expect(0, 127245, '\p{no}', "");
    Expect(1, 127245, '\p{^no}', "");
    Expect(1, 127245, '\P{no}', "");
    Expect(0, 127245, '\P{^no}', "");
    Expect(1, 127244, '\p{-No}', "");
    Expect(0, 127244, '\p{^-No}', "");
    Expect(0, 127244, '\P{-No}', "");
    Expect(1, 127244, '\P{^-No}', "");
    Expect(0, 127245, '\p{-No}', "");
    Expect(1, 127245, '\p{^-No}', "");
    Expect(1, 127245, '\P{-No}', "");
    Expect(0, 127245, '\P{^-No}', "");
    Error('\p{/a/ _IS_No}');
    Error('\P{/a/ _IS_No}');
    Expect(1, 127244, '\p{isno}', "");
    Expect(0, 127244, '\p{^isno}', "");
    Expect(0, 127244, '\P{isno}', "");
    Expect(1, 127244, '\P{^isno}', "");
    Expect(0, 127245, '\p{isno}', "");
    Expect(1, 127245, '\p{^isno}', "");
    Expect(1, 127245, '\P{isno}', "");
    Expect(0, 127245, '\P{^isno}', "");
    Expect(1, 127244, '\p{- is_NO}', "");
    Expect(0, 127244, '\p{^- is_NO}', "");
    Expect(0, 127244, '\P{- is_NO}', "");
    Expect(1, 127244, '\P{^- is_NO}', "");
    Expect(0, 127245, '\p{- is_NO}', "");
    Expect(1, 127245, '\p{^- is_NO}', "");
    Expect(1, 127245, '\P{- is_NO}', "");
    Expect(0, 127245, '\P{^- is_NO}', "");
    Error('\p{	:=Other_punctuation}');
    Error('\P{	:=Other_punctuation}');
    Expect(1, 125279, '\p{otherpunctuation}', "");
    Expect(0, 125279, '\p{^otherpunctuation}', "");
    Expect(0, 125279, '\P{otherpunctuation}', "");
    Expect(1, 125279, '\P{^otherpunctuation}', "");
    Expect(0, 125280, '\p{otherpunctuation}', "");
    Expect(1, 125280, '\p{^otherpunctuation}', "");
    Expect(1, 125280, '\P{otherpunctuation}', "");
    Expect(0, 125280, '\P{^otherpunctuation}', "");
    Expect(1, 125279, '\p{  OTHER_punctuation}', "");
    Expect(0, 125279, '\p{^  OTHER_punctuation}', "");
    Expect(0, 125279, '\P{  OTHER_punctuation}', "");
    Expect(1, 125279, '\P{^  OTHER_punctuation}', "");
    Expect(0, 125280, '\p{  OTHER_punctuation}', "");
    Expect(1, 125280, '\p{^  OTHER_punctuation}', "");
    Expect(1, 125280, '\P{  OTHER_punctuation}', "");
    Expect(0, 125280, '\P{^  OTHER_punctuation}', "");
    Error('\p{/a/-is_OTHER_PUNCTUATION}');
    Error('\P{/a/-is_OTHER_PUNCTUATION}');
    Expect(1, 125279, '\p{isotherpunctuation}', "");
    Expect(0, 125279, '\p{^isotherpunctuation}', "");
    Expect(0, 125279, '\P{isotherpunctuation}', "");
    Expect(1, 125279, '\P{^isotherpunctuation}', "");
    Expect(0, 125280, '\p{isotherpunctuation}', "");
    Expect(1, 125280, '\p{^isotherpunctuation}', "");
    Expect(1, 125280, '\P{isotherpunctuation}', "");
    Expect(0, 125280, '\P{^isotherpunctuation}', "");
    Expect(1, 125279, '\p{ _Is_Other_punctuation}', "");
    Expect(0, 125279, '\p{^ _Is_Other_punctuation}', "");
    Expect(0, 125279, '\P{ _Is_Other_punctuation}', "");
    Expect(1, 125279, '\P{^ _Is_Other_punctuation}', "");
    Expect(0, 125280, '\p{ _Is_Other_punctuation}', "");
    Expect(1, 125280, '\p{^ _Is_Other_punctuation}', "");
    Expect(1, 125280, '\P{ _Is_Other_punctuation}', "");
    Expect(0, 125280, '\P{^ _Is_Other_punctuation}', "");
    Error('\p{/a/-po}');
    Error('\P{/a/-po}');
    Expect(1, 125279, '\p{po}', "");
    Expect(0, 125279, '\p{^po}', "");
    Expect(0, 125279, '\P{po}', "");
    Expect(1, 125279, '\P{^po}', "");
    Expect(0, 125280, '\p{po}', "");
    Expect(1, 125280, '\p{^po}', "");
    Expect(1, 125280, '\P{po}', "");
    Expect(0, 125280, '\P{^po}', "");
    Expect(1, 125279, '\p{_-po}', "");
    Expect(0, 125279, '\p{^_-po}', "");
    Expect(0, 125279, '\P{_-po}', "");
    Expect(1, 125279, '\P{^_-po}', "");
    Expect(0, 125280, '\p{_-po}', "");
    Expect(1, 125280, '\p{^_-po}', "");
    Expect(1, 125280, '\P{_-po}', "");
    Expect(0, 125280, '\P{^_-po}', "");
    Error('\p{  IS_po:=}');
    Error('\P{  IS_po:=}');
    Expect(1, 125279, '\p{ispo}', "");
    Expect(0, 125279, '\p{^ispo}', "");
    Expect(0, 125279, '\P{ispo}', "");
    Expect(1, 125279, '\P{^ispo}', "");
    Expect(0, 125280, '\p{ispo}', "");
    Expect(1, 125280, '\p{^ispo}', "");
    Expect(1, 125280, '\P{ispo}', "");
    Expect(0, 125280, '\P{^ispo}', "");
    Expect(1, 125279, '\p{		Is_PO}', "");
    Expect(0, 125279, '\p{^		Is_PO}', "");
    Expect(0, 125279, '\P{		Is_PO}', "");
    Expect(1, 125279, '\P{^		Is_PO}', "");
    Expect(0, 125280, '\p{		Is_PO}', "");
    Expect(1, 125280, '\p{^		Is_PO}', "");
    Expect(1, 125280, '\P{		Is_PO}', "");
    Expect(0, 125280, '\P{^		Is_PO}', "");
    Error('\p{:=	OTHER_symbol}');
    Error('\P{:=	OTHER_symbol}');
    Expect(1, 129994, '\p{othersymbol}', "");
    Expect(0, 129994, '\p{^othersymbol}', "");
    Expect(0, 129994, '\P{othersymbol}', "");
    Expect(1, 129994, '\P{^othersymbol}', "");
    Expect(0, 129995, '\p{othersymbol}', "");
    Expect(1, 129995, '\p{^othersymbol}', "");
    Expect(1, 129995, '\P{othersymbol}', "");
    Expect(0, 129995, '\P{^othersymbol}', "");
    Expect(1, 129994, '\p{_	OTHER_Symbol}', "");
    Expect(0, 129994, '\p{^_	OTHER_Symbol}', "");
    Expect(0, 129994, '\P{_	OTHER_Symbol}', "");
    Expect(1, 129994, '\P{^_	OTHER_Symbol}', "");
    Expect(0, 129995, '\p{_	OTHER_Symbol}', "");
    Expect(1, 129995, '\p{^_	OTHER_Symbol}', "");
    Expect(1, 129995, '\P{_	OTHER_Symbol}', "");
    Expect(0, 129995, '\P{^_	OTHER_Symbol}', "");
    Error('\p{__IS_OTHER_Symbol:=}');
    Error('\P{__IS_OTHER_Symbol:=}');
    Expect(1, 129994, '\p{isothersymbol}', "");
    Expect(0, 129994, '\p{^isothersymbol}', "");
    Expect(0, 129994, '\P{isothersymbol}', "");
    Expect(1, 129994, '\P{^isothersymbol}', "");
    Expect(0, 129995, '\p{isothersymbol}', "");
    Expect(1, 129995, '\p{^isothersymbol}', "");
    Expect(1, 129995, '\P{isothersymbol}', "");
    Expect(0, 129995, '\P{^isothersymbol}', "");
    Expect(1, 129994, '\p{_IS_other_SYMBOL}', "");
    Expect(0, 129994, '\p{^_IS_other_SYMBOL}', "");
    Expect(0, 129994, '\P{_IS_other_SYMBOL}', "");
    Expect(1, 129994, '\P{^_IS_other_SYMBOL}', "");
    Expect(0, 129995, '\p{_IS_other_SYMBOL}', "");
    Expect(1, 129995, '\p{^_IS_other_SYMBOL}', "");
    Expect(1, 129995, '\P{_IS_other_SYMBOL}', "");
    Expect(0, 129995, '\P{^_IS_other_SYMBOL}', "");
    Error('\p{	 SO:=}');
    Error('\P{	 SO:=}');
    Expect(1, 129994, '\p{so}', "");
    Expect(0, 129994, '\p{^so}', "");
    Expect(0, 129994, '\P{so}', "");
    Expect(1, 129994, '\P{^so}', "");
    Expect(0, 129995, '\p{so}', "");
    Expect(1, 129995, '\p{^so}', "");
    Expect(1, 129995, '\P{so}', "");
    Expect(0, 129995, '\P{^so}', "");
    Expect(1, 129994, '\p{-So}', "");
    Expect(0, 129994, '\p{^-So}', "");
    Expect(0, 129994, '\P{-So}', "");
    Expect(1, 129994, '\P{^-So}', "");
    Expect(0, 129995, '\p{-So}', "");
    Expect(1, 129995, '\p{^-So}', "");
    Expect(1, 129995, '\P{-So}', "");
    Expect(0, 129995, '\P{^-So}', "");
    Error('\p{	:=Is_So}');
    Error('\P{	:=Is_So}');
    Expect(1, 129994, '\p{isso}', "");
    Expect(0, 129994, '\p{^isso}', "");
    Expect(0, 129994, '\P{isso}', "");
    Expect(1, 129994, '\P{^isso}', "");
    Expect(0, 129995, '\p{isso}', "");
    Expect(1, 129995, '\p{^isso}', "");
    Expect(1, 129995, '\P{isso}', "");
    Expect(0, 129995, '\P{^isso}', "");
    Expect(1, 129994, '\p{ -Is_So}', "");
    Expect(0, 129994, '\p{^ -Is_So}', "");
    Expect(0, 129994, '\P{ -Is_So}', "");
    Expect(1, 129994, '\P{^ -Is_So}', "");
    Expect(0, 129995, '\p{ -Is_So}', "");
    Expect(1, 129995, '\p{^ -Is_So}', "");
    Expect(1, 129995, '\P{ -Is_So}', "");
    Expect(0, 129995, '\P{^ -Is_So}', "");
    Error('\p{Other_Uppercase}');
    Error('\P{Other_Uppercase}');
    Error('\p{OUpper}');
    Error('\P{OUpper}');
    Error('\p{/a/- Ottoman_Siyaq_Numbers}');
    Error('\P{/a/- Ottoman_Siyaq_Numbers}');
    Expect(1, 126287, '\p{ottomansiyaqnumbers}', "");
    Expect(0, 126287, '\p{^ottomansiyaqnumbers}', "");
    Expect(0, 126287, '\P{ottomansiyaqnumbers}', "");
    Expect(1, 126287, '\P{^ottomansiyaqnumbers}', "");
    Expect(0, 126288, '\p{ottomansiyaqnumbers}', "");
    Expect(1, 126288, '\p{^ottomansiyaqnumbers}', "");
    Expect(1, 126288, '\P{ottomansiyaqnumbers}', "");
    Expect(0, 126288, '\P{^ottomansiyaqnumbers}', "");
    Expect(1, 126287, '\p{_	ottoman_Siyaq_Numbers}', "");
    Expect(0, 126287, '\p{^_	ottoman_Siyaq_Numbers}', "");
    Expect(0, 126287, '\P{_	ottoman_Siyaq_Numbers}', "");
    Expect(1, 126287, '\P{^_	ottoman_Siyaq_Numbers}', "");
    Expect(0, 126288, '\p{_	ottoman_Siyaq_Numbers}', "");
    Expect(1, 126288, '\p{^_	ottoman_Siyaq_Numbers}', "");
    Expect(1, 126288, '\P{_	ottoman_Siyaq_Numbers}', "");
    Expect(0, 126288, '\P{^_	ottoman_Siyaq_Numbers}', "");
    Error('\p{/a/is_ottoman_SIYAQ_Numbers}');
    Error('\P{/a/is_ottoman_SIYAQ_Numbers}');
    Expect(1, 126287, '\p{isottomansiyaqnumbers}', "");
    Expect(0, 126287, '\p{^isottomansiyaqnumbers}', "");
    Expect(0, 126287, '\P{isottomansiyaqnumbers}', "");
    Expect(1, 126287, '\P{^isottomansiyaqnumbers}', "");
    Expect(0, 126288, '\p{isottomansiyaqnumbers}', "");
    Expect(1, 126288, '\p{^isottomansiyaqnumbers}', "");
    Expect(1, 126288, '\P{isottomansiyaqnumbers}', "");
    Expect(0, 126288, '\P{^isottomansiyaqnumbers}', "");
    Expect(1, 126287, '\p{	Is_ottoman_siyaq_numbers}', "");
    Expect(0, 126287, '\p{^	Is_ottoman_siyaq_numbers}', "");
    Expect(0, 126287, '\P{	Is_ottoman_siyaq_numbers}', "");
    Expect(1, 126287, '\P{^	Is_ottoman_siyaq_numbers}', "");
    Expect(0, 126288, '\p{	Is_ottoman_siyaq_numbers}', "");
    Expect(1, 126288, '\p{^	Is_ottoman_siyaq_numbers}', "");
    Expect(1, 126288, '\P{	Is_ottoman_siyaq_numbers}', "");
    Expect(0, 126288, '\P{^	Is_ottoman_siyaq_numbers}', "");
    Error('\p{ -In_OTTOMAN_siyaq_NUMBERS/a/}');
    Error('\P{ -In_OTTOMAN_siyaq_NUMBERS/a/}');
    Expect(1, 126287, '\p{inottomansiyaqnumbers}', "");
    Expect(0, 126287, '\p{^inottomansiyaqnumbers}', "");
    Expect(0, 126287, '\P{inottomansiyaqnumbers}', "");
    Expect(1, 126287, '\P{^inottomansiyaqnumbers}', "");
    Expect(0, 126288, '\p{inottomansiyaqnumbers}', "");
    Expect(1, 126288, '\p{^inottomansiyaqnumbers}', "");
    Expect(1, 126288, '\P{inottomansiyaqnumbers}', "");
    Expect(0, 126288, '\P{^inottomansiyaqnumbers}', "");
    Expect(1, 126287, '\p{_-In_Ottoman_Siyaq_Numbers}', "");
    Expect(0, 126287, '\p{^_-In_Ottoman_Siyaq_Numbers}', "");
    Expect(0, 126287, '\P{_-In_Ottoman_Siyaq_Numbers}', "");
    Expect(1, 126287, '\P{^_-In_Ottoman_Siyaq_Numbers}', "");
    Expect(0, 126288, '\p{_-In_Ottoman_Siyaq_Numbers}', "");
    Expect(1, 126288, '\p{^_-In_Ottoman_Siyaq_Numbers}', "");
    Expect(1, 126288, '\P{_-In_Ottoman_Siyaq_Numbers}', "");
    Expect(0, 126288, '\P{^_-In_Ottoman_Siyaq_Numbers}', "");
    Error('\p{-	Pahawh_hmong:=}');
    Error('\P{-	Pahawh_hmong:=}');
    Expect(1, 93071, '\p{pahawhhmong}', "");
    Expect(0, 93071, '\p{^pahawhhmong}', "");
    Expect(0, 93071, '\P{pahawhhmong}', "");
    Expect(1, 93071, '\P{^pahawhhmong}', "");
    Expect(0, 93072, '\p{pahawhhmong}', "");
    Expect(1, 93072, '\p{^pahawhhmong}', "");
    Expect(1, 93072, '\P{pahawhhmong}', "");
    Expect(0, 93072, '\P{^pahawhhmong}', "");
    Expect(1, 93071, '\p{ pahawh_Hmong}', "");
    Expect(0, 93071, '\p{^ pahawh_Hmong}', "");
    Expect(0, 93071, '\P{ pahawh_Hmong}', "");
    Expect(1, 93071, '\P{^ pahawh_Hmong}', "");
    Expect(0, 93072, '\p{ pahawh_Hmong}', "");
    Expect(1, 93072, '\p{^ pahawh_Hmong}', "");
    Expect(1, 93072, '\P{ pahawh_Hmong}', "");
    Expect(0, 93072, '\P{^ pahawh_Hmong}', "");
    Error('\p{/a/-	is_Pahawh_HMONG}');
    Error('\P{/a/-	is_Pahawh_HMONG}');
    Expect(1, 93071, '\p{ispahawhhmong}', "");
    Expect(0, 93071, '\p{^ispahawhhmong}', "");
    Expect(0, 93071, '\P{ispahawhhmong}', "");
    Expect(1, 93071, '\P{^ispahawhhmong}', "");
    Expect(0, 93072, '\p{ispahawhhmong}', "");
    Expect(1, 93072, '\p{^ispahawhhmong}', "");
    Expect(1, 93072, '\P{ispahawhhmong}', "");
    Expect(0, 93072, '\P{^ispahawhhmong}', "");
    Expect(1, 93071, '\p{		Is_pahawh_Hmong}', "");
    Expect(0, 93071, '\p{^		Is_pahawh_Hmong}', "");
    Expect(0, 93071, '\P{		Is_pahawh_Hmong}', "");
    Expect(1, 93071, '\P{^		Is_pahawh_Hmong}', "");
    Expect(0, 93072, '\p{		Is_pahawh_Hmong}', "");
    Expect(1, 93072, '\p{^		Is_pahawh_Hmong}', "");
    Expect(1, 93072, '\P{		Is_pahawh_Hmong}', "");
    Expect(0, 93072, '\P{^		Is_pahawh_Hmong}', "");
    Error('\p{-:=HMNG}');
    Error('\P{-:=HMNG}');
    Expect(1, 93071, '\p{hmng}', "");
    Expect(0, 93071, '\p{^hmng}', "");
    Expect(0, 93071, '\P{hmng}', "");
    Expect(1, 93071, '\P{^hmng}', "");
    Expect(0, 93072, '\p{hmng}', "");
    Expect(1, 93072, '\p{^hmng}', "");
    Expect(1, 93072, '\P{hmng}', "");
    Expect(0, 93072, '\P{^hmng}', "");
    Expect(1, 93071, '\p{ HMNG}', "");
    Expect(0, 93071, '\p{^ HMNG}', "");
    Expect(0, 93071, '\P{ HMNG}', "");
    Expect(1, 93071, '\P{^ HMNG}', "");
    Expect(0, 93072, '\p{ HMNG}', "");
    Expect(1, 93072, '\p{^ HMNG}', "");
    Expect(1, 93072, '\P{ HMNG}', "");
    Expect(0, 93072, '\P{^ HMNG}', "");
    Error('\p{:=  Is_Hmng}');
    Error('\P{:=  Is_Hmng}');
    Expect(1, 93071, '\p{ishmng}', "");
    Expect(0, 93071, '\p{^ishmng}', "");
    Expect(0, 93071, '\P{ishmng}', "");
    Expect(1, 93071, '\P{^ishmng}', "");
    Expect(0, 93072, '\p{ishmng}', "");
    Expect(1, 93072, '\p{^ishmng}', "");
    Expect(1, 93072, '\P{ishmng}', "");
    Expect(0, 93072, '\P{^ishmng}', "");
    Expect(1, 93071, '\p{	is_hmng}', "");
    Expect(0, 93071, '\p{^	is_hmng}', "");
    Expect(0, 93071, '\P{	is_hmng}', "");
    Expect(1, 93071, '\P{^	is_hmng}', "");
    Expect(0, 93072, '\p{	is_hmng}', "");
    Expect(1, 93072, '\p{^	is_hmng}', "");
    Expect(1, 93072, '\P{	is_hmng}', "");
    Expect(0, 93072, '\P{^	is_hmng}', "");
    Error('\p{/a/__PALMYRENE}');
    Error('\P{/a/__PALMYRENE}');
    Expect(1, 67711, '\p{palmyrene}', "");
    Expect(0, 67711, '\p{^palmyrene}', "");
    Expect(0, 67711, '\P{palmyrene}', "");
    Expect(1, 67711, '\P{^palmyrene}', "");
    Expect(0, 67712, '\p{palmyrene}', "");
    Expect(1, 67712, '\p{^palmyrene}', "");
    Expect(1, 67712, '\P{palmyrene}', "");
    Expect(0, 67712, '\P{^palmyrene}', "");
    Expect(1, 67711, '\p{_-PALMYRENE}', "");
    Expect(0, 67711, '\p{^_-PALMYRENE}', "");
    Expect(0, 67711, '\P{_-PALMYRENE}', "");
    Expect(1, 67711, '\P{^_-PALMYRENE}', "");
    Expect(0, 67712, '\p{_-PALMYRENE}', "");
    Expect(1, 67712, '\p{^_-PALMYRENE}', "");
    Expect(1, 67712, '\P{_-PALMYRENE}', "");
    Expect(0, 67712, '\P{^_-PALMYRENE}', "");
    Error('\p{:=	Is_Palmyrene}');
    Error('\P{:=	Is_Palmyrene}');
    Expect(1, 67711, '\p{ispalmyrene}', "");
    Expect(0, 67711, '\p{^ispalmyrene}', "");
    Expect(0, 67711, '\P{ispalmyrene}', "");
    Expect(1, 67711, '\P{^ispalmyrene}', "");
    Expect(0, 67712, '\p{ispalmyrene}', "");
    Expect(1, 67712, '\p{^ispalmyrene}', "");
    Expect(1, 67712, '\P{ispalmyrene}', "");
    Expect(0, 67712, '\P{^ispalmyrene}', "");
    Expect(1, 67711, '\p{_IS_PALMYRENE}', "");
    Expect(0, 67711, '\p{^_IS_PALMYRENE}', "");
    Expect(0, 67711, '\P{_IS_PALMYRENE}', "");
    Expect(1, 67711, '\P{^_IS_PALMYRENE}', "");
    Expect(0, 67712, '\p{_IS_PALMYRENE}', "");
    Expect(1, 67712, '\p{^_IS_PALMYRENE}', "");
    Expect(1, 67712, '\P{_IS_PALMYRENE}', "");
    Expect(0, 67712, '\P{^_IS_PALMYRENE}', "");
    Error('\p{:= palm}');
    Error('\P{:= palm}');
    Expect(1, 67711, '\p{palm}', "");
    Expect(0, 67711, '\p{^palm}', "");
    Expect(0, 67711, '\P{palm}', "");
    Expect(1, 67711, '\P{^palm}', "");
    Expect(0, 67712, '\p{palm}', "");
    Expect(1, 67712, '\p{^palm}', "");
    Expect(1, 67712, '\P{palm}', "");
    Expect(0, 67712, '\P{^palm}', "");
    Expect(1, 67711, '\p{__palm}', "");
    Expect(0, 67711, '\p{^__palm}', "");
    Expect(0, 67711, '\P{__palm}', "");
    Expect(1, 67711, '\P{^__palm}', "");
    Expect(0, 67712, '\p{__palm}', "");
    Expect(1, 67712, '\p{^__palm}', "");
    Expect(1, 67712, '\P{__palm}', "");
    Expect(0, 67712, '\P{^__palm}', "");
    Error('\p{/a/_IS_Palm}');
    Error('\P{/a/_IS_Palm}');
    Expect(1, 67711, '\p{ispalm}', "");
    Expect(0, 67711, '\p{^ispalm}', "");
    Expect(0, 67711, '\P{ispalm}', "");
    Expect(1, 67711, '\P{^ispalm}', "");
    Expect(0, 67712, '\p{ispalm}', "");
    Expect(1, 67712, '\p{^ispalm}', "");
    Expect(1, 67712, '\P{ispalm}', "");
    Expect(0, 67712, '\P{^ispalm}', "");
    Expect(1, 67711, '\p{_-Is_palm}', "");
    Expect(0, 67711, '\p{^_-Is_palm}', "");
    Expect(0, 67711, '\P{_-Is_palm}', "");
    Expect(1, 67711, '\P{^_-Is_palm}', "");
    Expect(0, 67712, '\p{_-Is_palm}', "");
    Expect(1, 67712, '\p{^_-Is_palm}', "");
    Expect(1, 67712, '\P{_-Is_palm}', "");
    Expect(0, 67712, '\P{^_-Is_palm}', "");
    Error('\p{_/a/Paragraph_SEPARATOR}');
    Error('\P{_/a/Paragraph_SEPARATOR}');
    Expect(1, 8233, '\p{paragraphseparator}', "");
    Expect(0, 8233, '\p{^paragraphseparator}', "");
    Expect(0, 8233, '\P{paragraphseparator}', "");
    Expect(1, 8233, '\P{^paragraphseparator}', "");
    Expect(0, 8234, '\p{paragraphseparator}', "");
    Expect(1, 8234, '\p{^paragraphseparator}', "");
    Expect(1, 8234, '\P{paragraphseparator}', "");
    Expect(0, 8234, '\P{^paragraphseparator}', "");
    Expect(1, 8233, '\p{_PARAGRAPH_Separator}', "");
    Expect(0, 8233, '\p{^_PARAGRAPH_Separator}', "");
    Expect(0, 8233, '\P{_PARAGRAPH_Separator}', "");
    Expect(1, 8233, '\P{^_PARAGRAPH_Separator}', "");
    Expect(0, 8234, '\p{_PARAGRAPH_Separator}', "");
    Expect(1, 8234, '\p{^_PARAGRAPH_Separator}', "");
    Expect(1, 8234, '\P{_PARAGRAPH_Separator}', "");
    Expect(0, 8234, '\P{^_PARAGRAPH_Separator}', "");
    Error('\p{:=	-IS_Paragraph_separator}');
    Error('\P{:=	-IS_Paragraph_separator}');
    Expect(1, 8233, '\p{isparagraphseparator}', "");
    Expect(0, 8233, '\p{^isparagraphseparator}', "");
    Expect(0, 8233, '\P{isparagraphseparator}', "");
    Expect(1, 8233, '\P{^isparagraphseparator}', "");
    Expect(0, 8234, '\p{isparagraphseparator}', "");
    Expect(1, 8234, '\p{^isparagraphseparator}', "");
    Expect(1, 8234, '\P{isparagraphseparator}', "");
    Expect(0, 8234, '\P{^isparagraphseparator}', "");
    Expect(1, 8233, '\p{  Is_Paragraph_separator}', "");
    Expect(0, 8233, '\p{^  Is_Paragraph_separator}', "");
    Expect(0, 8233, '\P{  Is_Paragraph_separator}', "");
    Expect(1, 8233, '\P{^  Is_Paragraph_separator}', "");
    Expect(0, 8234, '\p{  Is_Paragraph_separator}', "");
    Expect(1, 8234, '\p{^  Is_Paragraph_separator}', "");
    Expect(1, 8234, '\P{  Is_Paragraph_separator}', "");
    Expect(0, 8234, '\P{^  Is_Paragraph_separator}', "");
    Error('\p{-	Zp:=}');
    Error('\P{-	Zp:=}');
    Expect(1, 8233, '\p{zp}', "");
    Expect(0, 8233, '\p{^zp}', "");
    Expect(0, 8233, '\P{zp}', "");
    Expect(1, 8233, '\P{^zp}', "");
    Expect(0, 8234, '\p{zp}', "");
    Expect(1, 8234, '\p{^zp}', "");
    Expect(1, 8234, '\P{zp}', "");
    Expect(0, 8234, '\P{^zp}', "");
    Expect(1, 8233, '\p{_ZP}', "");
    Expect(0, 8233, '\p{^_ZP}', "");
    Expect(0, 8233, '\P{_ZP}', "");
    Expect(1, 8233, '\P{^_ZP}', "");
    Expect(0, 8234, '\p{_ZP}', "");
    Expect(1, 8234, '\p{^_ZP}', "");
    Expect(1, 8234, '\P{_ZP}', "");
    Expect(0, 8234, '\P{^_ZP}', "");
    Error('\p{ Is_Zp/a/}');
    Error('\P{ Is_Zp/a/}');
    Expect(1, 8233, '\p{iszp}', "");
    Expect(0, 8233, '\p{^iszp}', "");
    Expect(0, 8233, '\P{iszp}', "");
    Expect(1, 8233, '\P{^iszp}', "");
    Expect(0, 8234, '\p{iszp}', "");
    Expect(1, 8234, '\p{^iszp}', "");
    Expect(1, 8234, '\P{iszp}', "");
    Expect(0, 8234, '\P{^iszp}', "");
    Expect(1, 8233, '\p{- is_zp}', "");
    Expect(0, 8233, '\p{^- is_zp}', "");
    Expect(0, 8233, '\P{- is_zp}', "");
    Expect(1, 8233, '\P{^- is_zp}', "");
    Expect(0, 8234, '\p{- is_zp}', "");
    Expect(1, 8234, '\p{^- is_zp}', "");
    Expect(1, 8234, '\P{- is_zp}', "");
    Expect(0, 8234, '\P{^- is_zp}', "");
    Error('\p{/a/ Pattern_syntax}');
    Error('\P{/a/ Pattern_syntax}');
    Expect(1, 65094, '\p{patternsyntax}', "");
    Expect(0, 65094, '\p{^patternsyntax}', "");
    Expect(0, 65094, '\P{patternsyntax}', "");
    Expect(1, 65094, '\P{^patternsyntax}', "");
    Expect(0, 65095, '\p{patternsyntax}', "");
    Expect(1, 65095, '\p{^patternsyntax}', "");
    Expect(1, 65095, '\P{patternsyntax}', "");
    Expect(0, 65095, '\P{^patternsyntax}', "");
    Expect(1, 65094, '\p{ -pattern_Syntax}', "");
    Expect(0, 65094, '\p{^ -pattern_Syntax}', "");
    Expect(0, 65094, '\P{ -pattern_Syntax}', "");
    Expect(1, 65094, '\P{^ -pattern_Syntax}', "");
    Expect(0, 65095, '\p{ -pattern_Syntax}', "");
    Expect(1, 65095, '\p{^ -pattern_Syntax}', "");
    Expect(1, 65095, '\P{ -pattern_Syntax}', "");
    Expect(0, 65095, '\P{^ -pattern_Syntax}', "");
    Error('\p{/a/-IS_PATTERN_SYNTAX}');
    Error('\P{/a/-IS_PATTERN_SYNTAX}');
    Expect(1, 65094, '\p{ispatternsyntax}', "");
    Expect(0, 65094, '\p{^ispatternsyntax}', "");
    Expect(0, 65094, '\P{ispatternsyntax}', "");
    Expect(1, 65094, '\P{^ispatternsyntax}', "");
    Expect(0, 65095, '\p{ispatternsyntax}', "");
    Expect(1, 65095, '\p{^ispatternsyntax}', "");
    Expect(1, 65095, '\P{ispatternsyntax}', "");
    Expect(0, 65095, '\P{^ispatternsyntax}', "");
    Expect(1, 65094, '\p{-_IS_pattern_Syntax}', "");
    Expect(0, 65094, '\p{^-_IS_pattern_Syntax}', "");
    Expect(0, 65094, '\P{-_IS_pattern_Syntax}', "");
    Expect(1, 65094, '\P{^-_IS_pattern_Syntax}', "");
    Expect(0, 65095, '\p{-_IS_pattern_Syntax}', "");
    Expect(1, 65095, '\p{^-_IS_pattern_Syntax}', "");
    Expect(1, 65095, '\P{-_IS_pattern_Syntax}', "");
    Expect(0, 65095, '\P{^-_IS_pattern_Syntax}', "");
    Error('\p{:= _pat_SYN}');
    Error('\P{:= _pat_SYN}');
    Expect(1, 65094, '\p{patsyn}', "");
    Expect(0, 65094, '\p{^patsyn}', "");
    Expect(0, 65094, '\P{patsyn}', "");
    Expect(1, 65094, '\P{^patsyn}', "");
    Expect(0, 65095, '\p{patsyn}', "");
    Expect(1, 65095, '\p{^patsyn}', "");
    Expect(1, 65095, '\P{patsyn}', "");
    Expect(0, 65095, '\P{^patsyn}', "");
    Expect(1, 65094, '\p{		pat_Syn}', "");
    Expect(0, 65094, '\p{^		pat_Syn}', "");
    Expect(0, 65094, '\P{		pat_Syn}', "");
    Expect(1, 65094, '\P{^		pat_Syn}', "");
    Expect(0, 65095, '\p{		pat_Syn}', "");
    Expect(1, 65095, '\p{^		pat_Syn}', "");
    Expect(1, 65095, '\P{		pat_Syn}', "");
    Expect(0, 65095, '\P{^		pat_Syn}', "");
    Error('\p{ IS_Pat_Syn:=}');
    Error('\P{ IS_Pat_Syn:=}');
    Expect(1, 65094, '\p{ispatsyn}', "");
    Expect(0, 65094, '\p{^ispatsyn}', "");
    Expect(0, 65094, '\P{ispatsyn}', "");
    Expect(1, 65094, '\P{^ispatsyn}', "");
    Expect(0, 65095, '\p{ispatsyn}', "");
    Expect(1, 65095, '\p{^ispatsyn}', "");
    Expect(1, 65095, '\P{ispatsyn}', "");
    Expect(0, 65095, '\P{^ispatsyn}', "");
    Expect(1, 65094, '\p{	 Is_Pat_syn}', "");
    Expect(0, 65094, '\p{^	 Is_Pat_syn}', "");
    Expect(0, 65094, '\P{	 Is_Pat_syn}', "");
    Expect(1, 65094, '\P{^	 Is_Pat_syn}', "");
    Expect(0, 65095, '\p{	 Is_Pat_syn}', "");
    Expect(1, 65095, '\p{^	 Is_Pat_syn}', "");
    Expect(1, 65095, '\P{	 Is_Pat_syn}', "");
    Expect(0, 65095, '\P{^	 Is_Pat_syn}', "");
    Error('\p{_:=Pattern_White_SPACE}');
    Error('\P{_:=Pattern_White_SPACE}');
    Expect(1, 8233, '\p{patternwhitespace}', "");
    Expect(0, 8233, '\p{^patternwhitespace}', "");
    Expect(0, 8233, '\P{patternwhitespace}', "");
    Expect(1, 8233, '\P{^patternwhitespace}', "");
    Expect(0, 8234, '\p{patternwhitespace}', "");
    Expect(1, 8234, '\p{^patternwhitespace}', "");
    Expect(1, 8234, '\P{patternwhitespace}', "");
    Expect(0, 8234, '\P{^patternwhitespace}', "");
    Expect(1, 8233, '\p{	pattern_White_Space}', "");
    Expect(0, 8233, '\p{^	pattern_White_Space}', "");
    Expect(0, 8233, '\P{	pattern_White_Space}', "");
    Expect(1, 8233, '\P{^	pattern_White_Space}', "");
    Expect(0, 8234, '\p{	pattern_White_Space}', "");
    Expect(1, 8234, '\p{^	pattern_White_Space}', "");
    Expect(1, 8234, '\P{	pattern_White_Space}', "");
    Expect(0, 8234, '\P{^	pattern_White_Space}', "");
    Error('\p{_is_Pattern_White_Space:=}');
    Error('\P{_is_Pattern_White_Space:=}');
    Expect(1, 8233, '\p{ispatternwhitespace}', "");
    Expect(0, 8233, '\p{^ispatternwhitespace}', "");
    Expect(0, 8233, '\P{ispatternwhitespace}', "");
    Expect(1, 8233, '\P{^ispatternwhitespace}', "");
    Expect(0, 8234, '\p{ispatternwhitespace}', "");
    Expect(1, 8234, '\p{^ispatternwhitespace}', "");
    Expect(1, 8234, '\P{ispatternwhitespace}', "");
    Expect(0, 8234, '\P{^ispatternwhitespace}', "");
    Expect(1, 8233, '\p{	Is_PATTERN_White_Space}', "");
    Expect(0, 8233, '\p{^	Is_PATTERN_White_Space}', "");
    Expect(0, 8233, '\P{	Is_PATTERN_White_Space}', "");
    Expect(1, 8233, '\P{^	Is_PATTERN_White_Space}', "");
    Expect(0, 8234, '\p{	Is_PATTERN_White_Space}', "");
    Expect(1, 8234, '\p{^	Is_PATTERN_White_Space}', "");
    Expect(1, 8234, '\P{	Is_PATTERN_White_Space}', "");
    Expect(0, 8234, '\P{^	Is_PATTERN_White_Space}', "");
    Error('\p{-Pat_ws:=}');
    Error('\P{-Pat_ws:=}');
    Expect(1, 8233, '\p{patws}', "");
    Expect(0, 8233, '\p{^patws}', "");
    Expect(0, 8233, '\P{patws}', "");
    Expect(1, 8233, '\P{^patws}', "");
    Expect(0, 8234, '\p{patws}', "");
    Expect(1, 8234, '\p{^patws}', "");
    Expect(1, 8234, '\P{patws}', "");
    Expect(0, 8234, '\P{^patws}', "");
    Expect(1, 8233, '\p{--Pat_WS}', "");
    Expect(0, 8233, '\p{^--Pat_WS}', "");
    Expect(0, 8233, '\P{--Pat_WS}', "");
    Expect(1, 8233, '\P{^--Pat_WS}', "");
    Expect(0, 8234, '\p{--Pat_WS}', "");
    Expect(1, 8234, '\p{^--Pat_WS}', "");
    Expect(1, 8234, '\P{--Pat_WS}', "");
    Expect(0, 8234, '\P{^--Pat_WS}', "");
    Error('\p{	/a/IS_pat_WS}');
    Error('\P{	/a/IS_pat_WS}');
    Expect(1, 8233, '\p{ispatws}', "");
    Expect(0, 8233, '\p{^ispatws}', "");
    Expect(0, 8233, '\P{ispatws}', "");
    Expect(1, 8233, '\P{^ispatws}', "");
    Expect(0, 8234, '\p{ispatws}', "");
    Expect(1, 8234, '\p{^ispatws}', "");
    Expect(1, 8234, '\P{ispatws}', "");
    Expect(0, 8234, '\P{^ispatws}', "");
    Expect(1, 8233, '\p{--Is_Pat_WS}', "");
    Expect(0, 8233, '\p{^--Is_Pat_WS}', "");
    Expect(0, 8233, '\P{--Is_Pat_WS}', "");
    Expect(1, 8233, '\P{^--Is_Pat_WS}', "");
    Expect(0, 8234, '\p{--Is_Pat_WS}', "");
    Expect(1, 8234, '\p{^--Is_Pat_WS}', "");
    Expect(1, 8234, '\P{--Is_Pat_WS}', "");
    Expect(0, 8234, '\P{^--Is_Pat_WS}', "");
    Error('\p{ :=Pau_cin_HAU}');
    Error('\P{ :=Pau_cin_HAU}');
    Expect(1, 72440, '\p{paucinhau}', "");
    Expect(0, 72440, '\p{^paucinhau}', "");
    Expect(0, 72440, '\P{paucinhau}', "");
    Expect(1, 72440, '\P{^paucinhau}', "");
    Expect(0, 72441, '\p{paucinhau}', "");
    Expect(1, 72441, '\p{^paucinhau}', "");
    Expect(1, 72441, '\P{paucinhau}', "");
    Expect(0, 72441, '\P{^paucinhau}', "");
    Expect(1, 72440, '\p{ -Pau_Cin_Hau}', "");
    Expect(0, 72440, '\p{^ -Pau_Cin_Hau}', "");
    Expect(0, 72440, '\P{ -Pau_Cin_Hau}', "");
    Expect(1, 72440, '\P{^ -Pau_Cin_Hau}', "");
    Expect(0, 72441, '\p{ -Pau_Cin_Hau}', "");
    Expect(1, 72441, '\p{^ -Pau_Cin_Hau}', "");
    Expect(1, 72441, '\P{ -Pau_Cin_Hau}', "");
    Expect(0, 72441, '\P{^ -Pau_Cin_Hau}', "");
    Error('\p{-:=Is_Pau_cin_Hau}');
    Error('\P{-:=Is_Pau_cin_Hau}');
    Expect(1, 72440, '\p{ispaucinhau}', "");
    Expect(0, 72440, '\p{^ispaucinhau}', "");
    Expect(0, 72440, '\P{ispaucinhau}', "");
    Expect(1, 72440, '\P{^ispaucinhau}', "");
    Expect(0, 72441, '\p{ispaucinhau}', "");
    Expect(1, 72441, '\p{^ispaucinhau}', "");
    Expect(1, 72441, '\P{ispaucinhau}', "");
    Expect(0, 72441, '\P{^ispaucinhau}', "");
    Expect(1, 72440, '\p{is_Pau_cin_HAU}', "");
    Expect(0, 72440, '\p{^is_Pau_cin_HAU}', "");
    Expect(0, 72440, '\P{is_Pau_cin_HAU}', "");
    Expect(1, 72440, '\P{^is_Pau_cin_HAU}', "");
    Expect(0, 72441, '\p{is_Pau_cin_HAU}', "");
    Expect(1, 72441, '\p{^is_Pau_cin_HAU}', "");
    Expect(1, 72441, '\P{is_Pau_cin_HAU}', "");
    Expect(0, 72441, '\P{^is_Pau_cin_HAU}', "");
    Error('\p{_ Pauc/a/}');
    Error('\P{_ Pauc/a/}');
    Expect(1, 72440, '\p{pauc}', "");
    Expect(0, 72440, '\p{^pauc}', "");
    Expect(0, 72440, '\P{pauc}', "");
    Expect(1, 72440, '\P{^pauc}', "");
    Expect(0, 72441, '\p{pauc}', "");
    Expect(1, 72441, '\p{^pauc}', "");
    Expect(1, 72441, '\P{pauc}', "");
    Expect(0, 72441, '\P{^pauc}', "");
    Expect(1, 72440, '\p{- Pauc}', "");
    Expect(0, 72440, '\p{^- Pauc}', "");
    Expect(0, 72440, '\P{- Pauc}', "");
    Expect(1, 72440, '\P{^- Pauc}', "");
    Expect(0, 72441, '\p{- Pauc}', "");
    Expect(1, 72441, '\p{^- Pauc}', "");
    Expect(1, 72441, '\P{- Pauc}', "");
    Expect(0, 72441, '\P{^- Pauc}', "");
    Error('\p{_:=Is_Pauc}');
    Error('\P{_:=Is_Pauc}');
    Expect(1, 72440, '\p{ispauc}', "");
    Expect(0, 72440, '\p{^ispauc}', "");
    Expect(0, 72440, '\P{ispauc}', "");
    Expect(1, 72440, '\P{^ispauc}', "");
    Expect(0, 72441, '\p{ispauc}', "");
    Expect(1, 72441, '\p{^ispauc}', "");
    Expect(1, 72441, '\P{ispauc}', "");
    Expect(0, 72441, '\P{^ispauc}', "");
    Expect(1, 72440, '\p{_IS_pauc}', "");
    Expect(0, 72440, '\p{^_IS_pauc}', "");
    Expect(0, 72440, '\P{_IS_pauc}', "");
    Expect(1, 72440, '\P{^_IS_pauc}', "");
    Expect(0, 72441, '\p{_IS_pauc}', "");
    Expect(1, 72441, '\p{^_IS_pauc}', "");
    Expect(1, 72441, '\P{_IS_pauc}', "");
    Expect(0, 72441, '\P{^_IS_pauc}', "");
    Error('\p{_:=Phags_pa}');
    Error('\P{_:=Phags_pa}');
    Expect(1, 43127, '\p{phagspa}', "");
    Expect(0, 43127, '\p{^phagspa}', "");
    Expect(0, 43127, '\P{phagspa}', "");
    Expect(1, 43127, '\P{^phagspa}', "");
    Expect(0, 43128, '\p{phagspa}', "");
    Expect(1, 43128, '\p{^phagspa}', "");
    Expect(1, 43128, '\P{phagspa}', "");
    Expect(0, 43128, '\P{^phagspa}', "");
    Expect(1, 43127, '\p{PHAGS_PA}', "");
    Expect(0, 43127, '\p{^PHAGS_PA}', "");
    Expect(0, 43127, '\P{PHAGS_PA}', "");
    Expect(1, 43127, '\P{^PHAGS_PA}', "");
    Expect(0, 43128, '\p{PHAGS_PA}', "");
    Expect(1, 43128, '\p{^PHAGS_PA}', "");
    Expect(1, 43128, '\P{PHAGS_PA}', "");
    Expect(0, 43128, '\P{^PHAGS_PA}', "");
    Error('\p{_Is_Phags_pa/a/}');
    Error('\P{_Is_Phags_pa/a/}');
    Expect(1, 43127, '\p{isphagspa}', "");
    Expect(0, 43127, '\p{^isphagspa}', "");
    Expect(0, 43127, '\P{isphagspa}', "");
    Expect(1, 43127, '\P{^isphagspa}', "");
    Expect(0, 43128, '\p{isphagspa}', "");
    Expect(1, 43128, '\p{^isphagspa}', "");
    Expect(1, 43128, '\P{isphagspa}', "");
    Expect(0, 43128, '\P{^isphagspa}', "");
    Expect(1, 43127, '\p{- Is_Phags_Pa}', "");
    Expect(0, 43127, '\p{^- Is_Phags_Pa}', "");
    Expect(0, 43127, '\P{- Is_Phags_Pa}', "");
    Expect(1, 43127, '\P{^- Is_Phags_Pa}', "");
    Expect(0, 43128, '\p{- Is_Phags_Pa}', "");
    Expect(1, 43128, '\p{^- Is_Phags_Pa}', "");
    Expect(1, 43128, '\P{- Is_Phags_Pa}', "");
    Expect(0, 43128, '\P{^- Is_Phags_Pa}', "");
    Error('\p{ /a/phag}');
    Error('\P{ /a/phag}');
    Expect(1, 43127, '\p{phag}', "");
    Expect(0, 43127, '\p{^phag}', "");
    Expect(0, 43127, '\P{phag}', "");
    Expect(1, 43127, '\P{^phag}', "");
    Expect(0, 43128, '\p{phag}', "");
    Expect(1, 43128, '\p{^phag}', "");
    Expect(1, 43128, '\P{phag}', "");
    Expect(0, 43128, '\P{^phag}', "");
    Expect(1, 43127, '\p{--PHAG}', "");
    Expect(0, 43127, '\p{^--PHAG}', "");
    Expect(0, 43127, '\P{--PHAG}', "");
    Expect(1, 43127, '\P{^--PHAG}', "");
    Expect(0, 43128, '\p{--PHAG}', "");
    Expect(1, 43128, '\p{^--PHAG}', "");
    Expect(1, 43128, '\P{--PHAG}', "");
    Expect(0, 43128, '\P{^--PHAG}', "");
    Error('\p{:=_ Is_Phag}');
    Error('\P{:=_ Is_Phag}');
    Expect(1, 43127, '\p{isphag}', "");
    Expect(0, 43127, '\p{^isphag}', "");
    Expect(0, 43127, '\P{isphag}', "");
    Expect(1, 43127, '\P{^isphag}', "");
    Expect(0, 43128, '\p{isphag}', "");
    Expect(1, 43128, '\p{^isphag}', "");
    Expect(1, 43128, '\P{isphag}', "");
    Expect(0, 43128, '\P{^isphag}', "");
    Expect(1, 43127, '\p{	is_phag}', "");
    Expect(0, 43127, '\p{^	is_phag}', "");
    Expect(0, 43127, '\P{	is_phag}', "");
    Expect(1, 43127, '\P{^	is_phag}', "");
    Expect(0, 43128, '\p{	is_phag}', "");
    Expect(1, 43128, '\p{^	is_phag}', "");
    Expect(1, 43128, '\P{	is_phag}', "");
    Expect(0, 43128, '\P{^	is_phag}', "");
    Error('\p{/a/- Phaistos_Disc}');
    Error('\P{/a/- Phaistos_Disc}');
    Expect(1, 66047, '\p{phaistosdisc}', "");
    Expect(0, 66047, '\p{^phaistosdisc}', "");
    Expect(0, 66047, '\P{phaistosdisc}', "");
    Expect(1, 66047, '\P{^phaistosdisc}', "");
    Expect(0, 66048, '\p{phaistosdisc}', "");
    Expect(1, 66048, '\p{^phaistosdisc}', "");
    Expect(1, 66048, '\P{phaistosdisc}', "");
    Expect(0, 66048, '\P{^phaistosdisc}', "");
    Expect(1, 66047, '\p{ phaistos_DISC}', "");
    Expect(0, 66047, '\p{^ phaistos_DISC}', "");
    Expect(0, 66047, '\P{ phaistos_DISC}', "");
    Expect(1, 66047, '\P{^ phaistos_DISC}', "");
    Expect(0, 66048, '\p{ phaistos_DISC}', "");
    Expect(1, 66048, '\p{^ phaistos_DISC}', "");
    Expect(1, 66048, '\P{ phaistos_DISC}', "");
    Expect(0, 66048, '\P{^ phaistos_DISC}', "");
    Error('\p{is_PHAISTOS_disc:=}');
    Error('\P{is_PHAISTOS_disc:=}');
    Expect(1, 66047, '\p{isphaistosdisc}', "");
    Expect(0, 66047, '\p{^isphaistosdisc}', "");
    Expect(0, 66047, '\P{isphaistosdisc}', "");
    Expect(1, 66047, '\P{^isphaistosdisc}', "");
    Expect(0, 66048, '\p{isphaistosdisc}', "");
    Expect(1, 66048, '\p{^isphaistosdisc}', "");
    Expect(1, 66048, '\P{isphaistosdisc}', "");
    Expect(0, 66048, '\P{^isphaistosdisc}', "");
    Expect(1, 66047, '\p{	IS_PHAISTOS_Disc}', "");
    Expect(0, 66047, '\p{^	IS_PHAISTOS_Disc}', "");
    Expect(0, 66047, '\P{	IS_PHAISTOS_Disc}', "");
    Expect(1, 66047, '\P{^	IS_PHAISTOS_Disc}', "");
    Expect(0, 66048, '\p{	IS_PHAISTOS_Disc}', "");
    Expect(1, 66048, '\p{^	IS_PHAISTOS_Disc}', "");
    Expect(1, 66048, '\P{	IS_PHAISTOS_Disc}', "");
    Expect(0, 66048, '\P{^	IS_PHAISTOS_Disc}', "");
    Error('\p{- In_Phaistos_Disc/a/}');
    Error('\P{- In_Phaistos_Disc/a/}');
    Expect(1, 66047, '\p{inphaistosdisc}', "");
    Expect(0, 66047, '\p{^inphaistosdisc}', "");
    Expect(0, 66047, '\P{inphaistosdisc}', "");
    Expect(1, 66047, '\P{^inphaistosdisc}', "");
    Expect(0, 66048, '\p{inphaistosdisc}', "");
    Expect(1, 66048, '\p{^inphaistosdisc}', "");
    Expect(1, 66048, '\P{inphaistosdisc}', "");
    Expect(0, 66048, '\P{^inphaistosdisc}', "");
    Expect(1, 66047, '\p{  in_PHAISTOS_DISC}', "");
    Expect(0, 66047, '\p{^  in_PHAISTOS_DISC}', "");
    Expect(0, 66047, '\P{  in_PHAISTOS_DISC}', "");
    Expect(1, 66047, '\P{^  in_PHAISTOS_DISC}', "");
    Expect(0, 66048, '\p{  in_PHAISTOS_DISC}', "");
    Expect(1, 66048, '\p{^  in_PHAISTOS_DISC}', "");
    Expect(1, 66048, '\P{  in_PHAISTOS_DISC}', "");
    Expect(0, 66048, '\P{^  in_PHAISTOS_DISC}', "");
    Error('\p{:=	 PHAISTOS}');
    Error('\P{:=	 PHAISTOS}');
    Expect(1, 66047, '\p{phaistos}', "");
    Expect(0, 66047, '\p{^phaistos}', "");
    Expect(0, 66047, '\P{phaistos}', "");
    Expect(1, 66047, '\P{^phaistos}', "");
    Expect(0, 66048, '\p{phaistos}', "");
    Expect(1, 66048, '\p{^phaistos}', "");
    Expect(1, 66048, '\P{phaistos}', "");
    Expect(0, 66048, '\P{^phaistos}', "");
    Expect(1, 66047, '\p{- Phaistos}', "");
    Expect(0, 66047, '\p{^- Phaistos}', "");
    Expect(0, 66047, '\P{- Phaistos}', "");
    Expect(1, 66047, '\P{^- Phaistos}', "");
    Expect(0, 66048, '\p{- Phaistos}', "");
    Expect(1, 66048, '\p{^- Phaistos}', "");
    Expect(1, 66048, '\P{- Phaistos}', "");
    Expect(0, 66048, '\P{^- Phaistos}', "");
    Error('\p{/a/is_PHAISTOS}');
    Error('\P{/a/is_PHAISTOS}');
    Expect(1, 66047, '\p{isphaistos}', "");
    Expect(0, 66047, '\p{^isphaistos}', "");
    Expect(0, 66047, '\P{isphaistos}', "");
    Expect(1, 66047, '\P{^isphaistos}', "");
    Expect(0, 66048, '\p{isphaistos}', "");
    Expect(1, 66048, '\p{^isphaistos}', "");
    Expect(1, 66048, '\P{isphaistos}', "");
    Expect(0, 66048, '\P{^isphaistos}', "");
    Expect(1, 66047, '\p{- IS_phaistos}', "");
    Expect(0, 66047, '\p{^- IS_phaistos}', "");
    Expect(0, 66047, '\P{- IS_phaistos}', "");
    Expect(1, 66047, '\P{^- IS_phaistos}', "");
    Expect(0, 66048, '\p{- IS_phaistos}', "");
    Expect(1, 66048, '\p{^- IS_phaistos}', "");
    Expect(1, 66048, '\P{- IS_phaistos}', "");
    Expect(0, 66048, '\P{^- IS_phaistos}', "");
    Error('\p{/a/	_In_PHAISTOS}');
    Error('\P{/a/	_In_PHAISTOS}');
    Expect(1, 66047, '\p{inphaistos}', "");
    Expect(0, 66047, '\p{^inphaistos}', "");
    Expect(0, 66047, '\P{inphaistos}', "");
    Expect(1, 66047, '\P{^inphaistos}', "");
    Expect(0, 66048, '\p{inphaistos}', "");
    Expect(1, 66048, '\p{^inphaistos}', "");
    Expect(1, 66048, '\P{inphaistos}', "");
    Expect(0, 66048, '\P{^inphaistos}', "");
    Expect(1, 66047, '\p{_ In_Phaistos}', "");
    Expect(0, 66047, '\p{^_ In_Phaistos}', "");
    Expect(0, 66047, '\P{_ In_Phaistos}', "");
    Expect(1, 66047, '\P{^_ In_Phaistos}', "");
    Expect(0, 66048, '\p{_ In_Phaistos}', "");
    Expect(1, 66048, '\p{^_ In_Phaistos}', "");
    Expect(1, 66048, '\P{_ In_Phaistos}', "");
    Expect(0, 66048, '\P{^_ In_Phaistos}', "");
    Error('\p{	Phoenician/a/}');
    Error('\P{	Phoenician/a/}');
    Expect(1, 67871, '\p{phoenician}', "");
    Expect(0, 67871, '\p{^phoenician}', "");
    Expect(0, 67871, '\P{phoenician}', "");
    Expect(1, 67871, '\P{^phoenician}', "");
    Expect(0, 67872, '\p{phoenician}', "");
    Expect(1, 67872, '\p{^phoenician}', "");
    Expect(1, 67872, '\P{phoenician}', "");
    Expect(0, 67872, '\P{^phoenician}', "");
    Expect(1, 67871, '\p{_Phoenician}', "");
    Expect(0, 67871, '\p{^_Phoenician}', "");
    Expect(0, 67871, '\P{_Phoenician}', "");
    Expect(1, 67871, '\P{^_Phoenician}', "");
    Expect(0, 67872, '\p{_Phoenician}', "");
    Expect(1, 67872, '\p{^_Phoenician}', "");
    Expect(1, 67872, '\P{_Phoenician}', "");
    Expect(0, 67872, '\P{^_Phoenician}', "");
    Error('\p{-_Is_phoenician/a/}');
    Error('\P{-_Is_phoenician/a/}');
    Expect(1, 67871, '\p{isphoenician}', "");
    Expect(0, 67871, '\p{^isphoenician}', "");
    Expect(0, 67871, '\P{isphoenician}', "");
    Expect(1, 67871, '\P{^isphoenician}', "");
    Expect(0, 67872, '\p{isphoenician}', "");
    Expect(1, 67872, '\p{^isphoenician}', "");
    Expect(1, 67872, '\P{isphoenician}', "");
    Expect(0, 67872, '\P{^isphoenician}', "");
    Expect(1, 67871, '\p{	_Is_PHOENICIAN}', "");
    Expect(0, 67871, '\p{^	_Is_PHOENICIAN}', "");
    Expect(0, 67871, '\P{	_Is_PHOENICIAN}', "");
    Expect(1, 67871, '\P{^	_Is_PHOENICIAN}', "");
    Expect(0, 67872, '\p{	_Is_PHOENICIAN}', "");
    Expect(1, 67872, '\p{^	_Is_PHOENICIAN}', "");
    Expect(1, 67872, '\P{	_Is_PHOENICIAN}', "");
    Expect(0, 67872, '\P{^	_Is_PHOENICIAN}', "");
    Error('\p{:=- PHNX}');
    Error('\P{:=- PHNX}');
    Expect(1, 67871, '\p{phnx}', "");
    Expect(0, 67871, '\p{^phnx}', "");
    Expect(0, 67871, '\P{phnx}', "");
    Expect(1, 67871, '\P{^phnx}', "");
    Expect(0, 67872, '\p{phnx}', "");
    Expect(1, 67872, '\p{^phnx}', "");
    Expect(1, 67872, '\P{phnx}', "");
    Expect(0, 67872, '\P{^phnx}', "");
    Expect(1, 67871, '\p{_	Phnx}', "");
    Expect(0, 67871, '\p{^_	Phnx}', "");
    Expect(0, 67871, '\P{_	Phnx}', "");
    Expect(1, 67871, '\P{^_	Phnx}', "");
    Expect(0, 67872, '\p{_	Phnx}', "");
    Expect(1, 67872, '\p{^_	Phnx}', "");
    Expect(1, 67872, '\P{_	Phnx}', "");
    Expect(0, 67872, '\P{^_	Phnx}', "");
    Error('\p{ :=Is_phnx}');
    Error('\P{ :=Is_phnx}');
    Expect(1, 67871, '\p{isphnx}', "");
    Expect(0, 67871, '\p{^isphnx}', "");
    Expect(0, 67871, '\P{isphnx}', "");
    Expect(1, 67871, '\P{^isphnx}', "");
    Expect(0, 67872, '\p{isphnx}', "");
    Expect(1, 67872, '\p{^isphnx}', "");
    Expect(1, 67872, '\P{isphnx}', "");
    Expect(0, 67872, '\P{^isphnx}', "");
    Expect(1, 67871, '\p{_-IS_PHNX}', "");
    Expect(0, 67871, '\p{^_-IS_PHNX}', "");
    Expect(0, 67871, '\P{_-IS_PHNX}', "");
    Expect(1, 67871, '\P{^_-IS_PHNX}', "");
    Expect(0, 67872, '\p{_-IS_PHNX}', "");
    Expect(1, 67872, '\p{^_-IS_PHNX}', "");
    Expect(1, 67872, '\P{_-IS_PHNX}', "");
    Expect(0, 67872, '\P{^_-IS_PHNX}', "");
    Error('\p{/a/PHONETIC_Extensions}');
    Error('\P{/a/PHONETIC_Extensions}');
    Expect(1, 7551, '\p{phoneticextensions}', "");
    Expect(0, 7551, '\p{^phoneticextensions}', "");
    Expect(0, 7551, '\P{phoneticextensions}', "");
    Expect(1, 7551, '\P{^phoneticextensions}', "");
    Expect(0, 7552, '\p{phoneticextensions}', "");
    Expect(1, 7552, '\p{^phoneticextensions}', "");
    Expect(1, 7552, '\P{phoneticextensions}', "");
    Expect(0, 7552, '\P{^phoneticextensions}', "");
    Expect(1, 7551, '\p{ -Phonetic_Extensions}', "");
    Expect(0, 7551, '\p{^ -Phonetic_Extensions}', "");
    Expect(0, 7551, '\P{ -Phonetic_Extensions}', "");
    Expect(1, 7551, '\P{^ -Phonetic_Extensions}', "");
    Expect(0, 7552, '\p{ -Phonetic_Extensions}', "");
    Expect(1, 7552, '\p{^ -Phonetic_Extensions}', "");
    Expect(1, 7552, '\P{ -Phonetic_Extensions}', "");
    Expect(0, 7552, '\P{^ -Phonetic_Extensions}', "");
    Error('\p{-/a/is_Phonetic_extensions}');
    Error('\P{-/a/is_Phonetic_extensions}');
    Expect(1, 7551, '\p{isphoneticextensions}', "");
    Expect(0, 7551, '\p{^isphoneticextensions}', "");
    Expect(0, 7551, '\P{isphoneticextensions}', "");
    Expect(1, 7551, '\P{^isphoneticextensions}', "");
    Expect(0, 7552, '\p{isphoneticextensions}', "");
    Expect(1, 7552, '\p{^isphoneticextensions}', "");
    Expect(1, 7552, '\P{isphoneticextensions}', "");
    Expect(0, 7552, '\P{^isphoneticextensions}', "");
    Expect(1, 7551, '\p{	Is_Phonetic_Extensions}', "");
    Expect(0, 7551, '\p{^	Is_Phonetic_Extensions}', "");
    Expect(0, 7551, '\P{	Is_Phonetic_Extensions}', "");
    Expect(1, 7551, '\P{^	Is_Phonetic_Extensions}', "");
    Expect(0, 7552, '\p{	Is_Phonetic_Extensions}', "");
    Expect(1, 7552, '\p{^	Is_Phonetic_Extensions}', "");
    Expect(1, 7552, '\P{	Is_Phonetic_Extensions}', "");
    Expect(0, 7552, '\P{^	Is_Phonetic_Extensions}', "");
    Error('\p{/a/- IN_Phonetic_Extensions}');
    Error('\P{/a/- IN_Phonetic_Extensions}');
    Expect(1, 7551, '\p{inphoneticextensions}', "");
    Expect(0, 7551, '\p{^inphoneticextensions}', "");
    Expect(0, 7551, '\P{inphoneticextensions}', "");
    Expect(1, 7551, '\P{^inphoneticextensions}', "");
    Expect(0, 7552, '\p{inphoneticextensions}', "");
    Expect(1, 7552, '\p{^inphoneticextensions}', "");
    Expect(1, 7552, '\P{inphoneticextensions}', "");
    Expect(0, 7552, '\P{^inphoneticextensions}', "");
    Expect(1, 7551, '\p{_In_PHONETIC_EXTENSIONS}', "");
    Expect(0, 7551, '\p{^_In_PHONETIC_EXTENSIONS}', "");
    Expect(0, 7551, '\P{_In_PHONETIC_EXTENSIONS}', "");
    Expect(1, 7551, '\P{^_In_PHONETIC_EXTENSIONS}', "");
    Expect(0, 7552, '\p{_In_PHONETIC_EXTENSIONS}', "");
    Expect(1, 7552, '\p{^_In_PHONETIC_EXTENSIONS}', "");
    Expect(1, 7552, '\P{_In_PHONETIC_EXTENSIONS}', "");
    Expect(0, 7552, '\P{^_In_PHONETIC_EXTENSIONS}', "");
    Error('\p{	/a/Phonetic_Ext}');
    Error('\P{	/a/Phonetic_Ext}');
    Expect(1, 7551, '\p{phoneticext}', "");
    Expect(0, 7551, '\p{^phoneticext}', "");
    Expect(0, 7551, '\P{phoneticext}', "");
    Expect(1, 7551, '\P{^phoneticext}', "");
    Expect(0, 7552, '\p{phoneticext}', "");
    Expect(1, 7552, '\p{^phoneticext}', "");
    Expect(1, 7552, '\P{phoneticext}', "");
    Expect(0, 7552, '\P{^phoneticext}', "");
    Expect(1, 7551, '\p{  Phonetic_EXT}', "");
    Expect(0, 7551, '\p{^  Phonetic_EXT}', "");
    Expect(0, 7551, '\P{  Phonetic_EXT}', "");
    Expect(1, 7551, '\P{^  Phonetic_EXT}', "");
    Expect(0, 7552, '\p{  Phonetic_EXT}', "");
    Expect(1, 7552, '\p{^  Phonetic_EXT}', "");
    Expect(1, 7552, '\P{  Phonetic_EXT}', "");
    Expect(0, 7552, '\P{^  Phonetic_EXT}', "");
    Error('\p{/a/	Is_PHONETIC_Ext}');
    Error('\P{/a/	Is_PHONETIC_Ext}');
    Expect(1, 7551, '\p{isphoneticext}', "");
    Expect(0, 7551, '\p{^isphoneticext}', "");
    Expect(0, 7551, '\P{isphoneticext}', "");
    Expect(1, 7551, '\P{^isphoneticext}', "");
    Expect(0, 7552, '\p{isphoneticext}', "");
    Expect(1, 7552, '\p{^isphoneticext}', "");
    Expect(1, 7552, '\P{isphoneticext}', "");
    Expect(0, 7552, '\P{^isphoneticext}', "");
    Expect(1, 7551, '\p{--is_Phonetic_Ext}', "");
    Expect(0, 7551, '\p{^--is_Phonetic_Ext}', "");
    Expect(0, 7551, '\P{--is_Phonetic_Ext}', "");
    Expect(1, 7551, '\P{^--is_Phonetic_Ext}', "");
    Expect(0, 7552, '\p{--is_Phonetic_Ext}', "");
    Expect(1, 7552, '\p{^--is_Phonetic_Ext}', "");
    Expect(1, 7552, '\P{--is_Phonetic_Ext}', "");
    Expect(0, 7552, '\P{^--is_Phonetic_Ext}', "");
    Error('\p{ :=IN_phonetic_EXT}');
    Error('\P{ :=IN_phonetic_EXT}');
    Expect(1, 7551, '\p{inphoneticext}', "");
    Expect(0, 7551, '\p{^inphoneticext}', "");
    Expect(0, 7551, '\P{inphoneticext}', "");
    Expect(1, 7551, '\P{^inphoneticext}', "");
    Expect(0, 7552, '\p{inphoneticext}', "");
    Expect(1, 7552, '\p{^inphoneticext}', "");
    Expect(1, 7552, '\P{inphoneticext}', "");
    Expect(0, 7552, '\P{^inphoneticext}', "");
    Expect(1, 7551, '\p{_ IN_phonetic_Ext}', "");
    Expect(0, 7551, '\p{^_ IN_phonetic_Ext}', "");
    Expect(0, 7551, '\P{_ IN_phonetic_Ext}', "");
    Expect(1, 7551, '\P{^_ IN_phonetic_Ext}', "");
    Expect(0, 7552, '\p{_ IN_phonetic_Ext}', "");
    Expect(1, 7552, '\p{^_ IN_phonetic_Ext}', "");
    Expect(1, 7552, '\P{_ IN_phonetic_Ext}', "");
    Expect(0, 7552, '\P{^_ IN_phonetic_Ext}', "");
    Error('\p{/a/_	Phonetic_EXTENSIONS_Supplement}');
    Error('\P{/a/_	Phonetic_EXTENSIONS_Supplement}');
    Expect(1, 7615, '\p{phoneticextensionssupplement}', "");
    Expect(0, 7615, '\p{^phoneticextensionssupplement}', "");
    Expect(0, 7615, '\P{phoneticextensionssupplement}', "");
    Expect(1, 7615, '\P{^phoneticextensionssupplement}', "");
    Expect(0, 7616, '\p{phoneticextensionssupplement}', "");
    Expect(1, 7616, '\p{^phoneticextensionssupplement}', "");
    Expect(1, 7616, '\P{phoneticextensionssupplement}', "");
    Expect(0, 7616, '\P{^phoneticextensionssupplement}', "");
    Expect(1, 7615, '\p{	_PHONETIC_extensions_SUPPLEMENT}', "");
    Expect(0, 7615, '\p{^	_PHONETIC_extensions_SUPPLEMENT}', "");
    Expect(0, 7615, '\P{	_PHONETIC_extensions_SUPPLEMENT}', "");
    Expect(1, 7615, '\P{^	_PHONETIC_extensions_SUPPLEMENT}', "");
    Expect(0, 7616, '\p{	_PHONETIC_extensions_SUPPLEMENT}', "");
    Expect(1, 7616, '\p{^	_PHONETIC_extensions_SUPPLEMENT}', "");
    Expect(1, 7616, '\P{	_PHONETIC_extensions_SUPPLEMENT}', "");
    Expect(0, 7616, '\P{^	_PHONETIC_extensions_SUPPLEMENT}', "");
    Error('\p{_-IS_Phonetic_Extensions_Supplement/a/}');
    Error('\P{_-IS_Phonetic_Extensions_Supplement/a/}');
    Expect(1, 7615, '\p{isphoneticextensionssupplement}', "");
    Expect(0, 7615, '\p{^isphoneticextensionssupplement}', "");
    Expect(0, 7615, '\P{isphoneticextensionssupplement}', "");
    Expect(1, 7615, '\P{^isphoneticextensionssupplement}', "");
    Expect(0, 7616, '\p{isphoneticextensionssupplement}', "");
    Expect(1, 7616, '\p{^isphoneticextensionssupplement}', "");
    Expect(1, 7616, '\P{isphoneticextensionssupplement}', "");
    Expect(0, 7616, '\P{^isphoneticextensionssupplement}', "");
    Expect(1, 7615, '\p{_-is_Phonetic_Extensions_Supplement}', "");
    Expect(0, 7615, '\p{^_-is_Phonetic_Extensions_Supplement}', "");
    Expect(0, 7615, '\P{_-is_Phonetic_Extensions_Supplement}', "");
    Expect(1, 7615, '\P{^_-is_Phonetic_Extensions_Supplement}', "");
    Expect(0, 7616, '\p{_-is_Phonetic_Extensions_Supplement}', "");
    Expect(1, 7616, '\p{^_-is_Phonetic_Extensions_Supplement}', "");
    Expect(1, 7616, '\P{_-is_Phonetic_Extensions_Supplement}', "");
    Expect(0, 7616, '\P{^_-is_Phonetic_Extensions_Supplement}', "");
    Error('\p{_	In_Phonetic_extensions_Supplement:=}');
    Error('\P{_	In_Phonetic_extensions_Supplement:=}');
    Expect(1, 7615, '\p{inphoneticextensionssupplement}', "");
    Expect(0, 7615, '\p{^inphoneticextensionssupplement}', "");
    Expect(0, 7615, '\P{inphoneticextensionssupplement}', "");
    Expect(1, 7615, '\P{^inphoneticextensionssupplement}', "");
    Expect(0, 7616, '\p{inphoneticextensionssupplement}', "");
    Expect(1, 7616, '\p{^inphoneticextensionssupplement}', "");
    Expect(1, 7616, '\P{inphoneticextensionssupplement}', "");
    Expect(0, 7616, '\P{^inphoneticextensionssupplement}', "");
    Expect(1, 7615, '\p{ -in_phonetic_EXTENSIONS_supplement}', "");
    Expect(0, 7615, '\p{^ -in_phonetic_EXTENSIONS_supplement}', "");
    Expect(0, 7615, '\P{ -in_phonetic_EXTENSIONS_supplement}', "");
    Expect(1, 7615, '\P{^ -in_phonetic_EXTENSIONS_supplement}', "");
    Expect(0, 7616, '\p{ -in_phonetic_EXTENSIONS_supplement}', "");
    Expect(1, 7616, '\p{^ -in_phonetic_EXTENSIONS_supplement}', "");
    Expect(1, 7616, '\P{ -in_phonetic_EXTENSIONS_supplement}', "");
    Expect(0, 7616, '\P{^ -in_phonetic_EXTENSIONS_supplement}', "");
    Error('\p{	/a/PHONETIC_Ext_Sup}');
    Error('\P{	/a/PHONETIC_Ext_Sup}');
    Expect(1, 7615, '\p{phoneticextsup}', "");
    Expect(0, 7615, '\p{^phoneticextsup}', "");
    Expect(0, 7615, '\P{phoneticextsup}', "");
    Expect(1, 7615, '\P{^phoneticextsup}', "");
    Expect(0, 7616, '\p{phoneticextsup}', "");
    Expect(1, 7616, '\p{^phoneticextsup}', "");
    Expect(1, 7616, '\P{phoneticextsup}', "");
    Expect(0, 7616, '\P{^phoneticextsup}', "");
    Expect(1, 7615, '\p{	phonetic_EXT_SUP}', "");
    Expect(0, 7615, '\p{^	phonetic_EXT_SUP}', "");
    Expect(0, 7615, '\P{	phonetic_EXT_SUP}', "");
    Expect(1, 7615, '\P{^	phonetic_EXT_SUP}', "");
    Expect(0, 7616, '\p{	phonetic_EXT_SUP}', "");
    Expect(1, 7616, '\p{^	phonetic_EXT_SUP}', "");
    Expect(1, 7616, '\P{	phonetic_EXT_SUP}', "");
    Expect(0, 7616, '\P{^	phonetic_EXT_SUP}', "");
    Error('\p{_:=Is_PHONETIC_Ext_SUP}');
    Error('\P{_:=Is_PHONETIC_Ext_SUP}');
    Expect(1, 7615, '\p{isphoneticextsup}', "");
    Expect(0, 7615, '\p{^isphoneticextsup}', "");
    Expect(0, 7615, '\P{isphoneticextsup}', "");
    Expect(1, 7615, '\P{^isphoneticextsup}', "");
    Expect(0, 7616, '\p{isphoneticextsup}', "");
    Expect(1, 7616, '\p{^isphoneticextsup}', "");
    Expect(1, 7616, '\P{isphoneticextsup}', "");
    Expect(0, 7616, '\P{^isphoneticextsup}', "");
    Expect(1, 7615, '\p{ -IS_phonetic_Ext_sup}', "");
    Expect(0, 7615, '\p{^ -IS_phonetic_Ext_sup}', "");
    Expect(0, 7615, '\P{ -IS_phonetic_Ext_sup}', "");
    Expect(1, 7615, '\P{^ -IS_phonetic_Ext_sup}', "");
    Expect(0, 7616, '\p{ -IS_phonetic_Ext_sup}', "");
    Expect(1, 7616, '\p{^ -IS_phonetic_Ext_sup}', "");
    Expect(1, 7616, '\P{ -IS_phonetic_Ext_sup}', "");
    Expect(0, 7616, '\P{^ -IS_phonetic_Ext_sup}', "");
    Error('\p{ In_Phonetic_ext_SUP:=}');
    Error('\P{ In_Phonetic_ext_SUP:=}');
    Expect(1, 7615, '\p{inphoneticextsup}', "");
    Expect(0, 7615, '\p{^inphoneticextsup}', "");
    Expect(0, 7615, '\P{inphoneticextsup}', "");
    Expect(1, 7615, '\P{^inphoneticextsup}', "");
    Expect(0, 7616, '\p{inphoneticextsup}', "");
    Expect(1, 7616, '\p{^inphoneticextsup}', "");
    Expect(1, 7616, '\P{inphoneticextsup}', "");
    Expect(0, 7616, '\P{^inphoneticextsup}', "");
    Expect(1, 7615, '\p{-_IN_Phonetic_EXT_SUP}', "");
    Expect(0, 7615, '\p{^-_IN_Phonetic_EXT_SUP}', "");
    Expect(0, 7615, '\P{-_IN_Phonetic_EXT_SUP}', "");
    Expect(1, 7615, '\P{^-_IN_Phonetic_EXT_SUP}', "");
    Expect(0, 7616, '\p{-_IN_Phonetic_EXT_SUP}', "");
    Expect(1, 7616, '\p{^-_IN_Phonetic_EXT_SUP}', "");
    Expect(1, 7616, '\P{-_IN_Phonetic_EXT_SUP}', "");
    Expect(0, 7616, '\P{^-_IN_Phonetic_EXT_SUP}', "");
    Error('\p{_Playing_CARDS:=}');
    Error('\P{_Playing_CARDS:=}');
    Expect(1, 127231, '\p{playingcards}', "");
    Expect(0, 127231, '\p{^playingcards}', "");
    Expect(0, 127231, '\P{playingcards}', "");
    Expect(1, 127231, '\P{^playingcards}', "");
    Expect(0, 127232, '\p{playingcards}', "");
    Expect(1, 127232, '\p{^playingcards}', "");
    Expect(1, 127232, '\P{playingcards}', "");
    Expect(0, 127232, '\P{^playingcards}', "");
    Expect(1, 127231, '\p{- Playing_Cards}', "");
    Expect(0, 127231, '\p{^- Playing_Cards}', "");
    Expect(0, 127231, '\P{- Playing_Cards}', "");
    Expect(1, 127231, '\P{^- Playing_Cards}', "");
    Expect(0, 127232, '\p{- Playing_Cards}', "");
    Expect(1, 127232, '\p{^- Playing_Cards}', "");
    Expect(1, 127232, '\P{- Playing_Cards}', "");
    Expect(0, 127232, '\P{^- Playing_Cards}', "");
    Error('\p{_/a/is_playing_CARDS}');
    Error('\P{_/a/is_playing_CARDS}');
    Expect(1, 127231, '\p{isplayingcards}', "");
    Expect(0, 127231, '\p{^isplayingcards}', "");
    Expect(0, 127231, '\P{isplayingcards}', "");
    Expect(1, 127231, '\P{^isplayingcards}', "");
    Expect(0, 127232, '\p{isplayingcards}', "");
    Expect(1, 127232, '\p{^isplayingcards}', "");
    Expect(1, 127232, '\P{isplayingcards}', "");
    Expect(0, 127232, '\P{^isplayingcards}', "");
    Expect(1, 127231, '\p{-	IS_playing_Cards}', "");
    Expect(0, 127231, '\p{^-	IS_playing_Cards}', "");
    Expect(0, 127231, '\P{-	IS_playing_Cards}', "");
    Expect(1, 127231, '\P{^-	IS_playing_Cards}', "");
    Expect(0, 127232, '\p{-	IS_playing_Cards}', "");
    Expect(1, 127232, '\p{^-	IS_playing_Cards}', "");
    Expect(1, 127232, '\P{-	IS_playing_Cards}', "");
    Expect(0, 127232, '\P{^-	IS_playing_Cards}', "");
    Error('\p{ _IN_playing_Cards/a/}');
    Error('\P{ _IN_playing_Cards/a/}');
    Expect(1, 127231, '\p{inplayingcards}', "");
    Expect(0, 127231, '\p{^inplayingcards}', "");
    Expect(0, 127231, '\P{inplayingcards}', "");
    Expect(1, 127231, '\P{^inplayingcards}', "");
    Expect(0, 127232, '\p{inplayingcards}', "");
    Expect(1, 127232, '\p{^inplayingcards}', "");
    Expect(1, 127232, '\P{inplayingcards}', "");
    Expect(0, 127232, '\P{^inplayingcards}', "");
    Expect(1, 127231, '\p{	_In_Playing_cards}', "");
    Expect(0, 127231, '\p{^	_In_Playing_cards}', "");
    Expect(0, 127231, '\P{	_In_Playing_cards}', "");
    Expect(1, 127231, '\P{^	_In_Playing_cards}', "");
    Expect(0, 127232, '\p{	_In_Playing_cards}', "");
    Expect(1, 127232, '\p{^	_In_Playing_cards}', "");
    Expect(1, 127232, '\P{	_In_Playing_cards}', "");
    Expect(0, 127232, '\P{^	_In_Playing_cards}', "");
    Error('\p{/a/	-POSIXALNUM}');
    Error('\P{/a/	-POSIXALNUM}');
    Expect(1, 122, '\p{posixalnum}', "");
    Expect(0, 122, '\p{^posixalnum}', "");
    Expect(0, 122, '\P{posixalnum}', "");
    Expect(1, 122, '\P{^posixalnum}', "");
    Expect(0, 123, '\p{posixalnum}', "");
    Expect(1, 123, '\p{^posixalnum}', "");
    Expect(1, 123, '\P{posixalnum}', "");
    Expect(0, 123, '\P{^posixalnum}', "");
    Expect(1, 122, '\p{	PosixAlnum}', "");
    Expect(0, 122, '\p{^	PosixAlnum}', "");
    Expect(0, 122, '\P{	PosixAlnum}', "");
    Expect(1, 122, '\P{^	PosixAlnum}', "");
    Expect(0, 123, '\p{	PosixAlnum}', "");
    Expect(1, 123, '\p{^	PosixAlnum}', "");
    Expect(1, 123, '\P{	PosixAlnum}', "");
    Expect(0, 123, '\P{^	PosixAlnum}', "");
    Error('\p{-IS_posixalnum:=}');
    Error('\P{-IS_posixalnum:=}');
    Expect(1, 122, '\p{isposixalnum}', "");
    Expect(0, 122, '\p{^isposixalnum}', "");
    Expect(0, 122, '\P{isposixalnum}', "");
    Expect(1, 122, '\P{^isposixalnum}', "");
    Expect(0, 123, '\p{isposixalnum}', "");
    Expect(1, 123, '\p{^isposixalnum}', "");
    Expect(1, 123, '\P{isposixalnum}', "");
    Expect(0, 123, '\P{^isposixalnum}', "");
    Expect(1, 122, '\p{		Is_POSIXALNUM}', "");
    Expect(0, 122, '\p{^		Is_POSIXALNUM}', "");
    Expect(0, 122, '\P{		Is_POSIXALNUM}', "");
    Expect(1, 122, '\P{^		Is_POSIXALNUM}', "");
    Expect(0, 123, '\p{		Is_POSIXALNUM}', "");
    Expect(1, 123, '\p{^		Is_POSIXALNUM}', "");
    Expect(1, 123, '\P{		Is_POSIXALNUM}', "");
    Expect(0, 123, '\P{^		Is_POSIXALNUM}', "");
    Error('\p{__posixalpha:=}');
    Error('\P{__posixalpha:=}');
    Expect(1, 122, '\p{posixalpha}', "");
    Expect(0, 122, '\p{^posixalpha}', "");
    Expect(0, 122, '\P{posixalpha}', "");
    Expect(1, 122, '\P{^posixalpha}', "");
    Expect(0, 123, '\p{posixalpha}', "");
    Expect(1, 123, '\p{^posixalpha}', "");
    Expect(1, 123, '\P{posixalpha}', "");
    Expect(0, 123, '\P{^posixalpha}', "");
    Expect(1, 122, '\p{__posixalpha}', "");
    Expect(0, 122, '\p{^__posixalpha}', "");
    Expect(0, 122, '\P{__posixalpha}', "");
    Expect(1, 122, '\P{^__posixalpha}', "");
    Expect(0, 123, '\p{__posixalpha}', "");
    Expect(1, 123, '\p{^__posixalpha}', "");
    Expect(1, 123, '\P{__posixalpha}', "");
    Expect(0, 123, '\P{^__posixalpha}', "");
    Error('\p{	/a/IS_PosixAlpha}');
    Error('\P{	/a/IS_PosixAlpha}');
    Expect(1, 122, '\p{isposixalpha}', "");
    Expect(0, 122, '\p{^isposixalpha}', "");
    Expect(0, 122, '\P{isposixalpha}', "");
    Expect(1, 122, '\P{^isposixalpha}', "");
    Expect(0, 123, '\p{isposixalpha}', "");
    Expect(1, 123, '\p{^isposixalpha}', "");
    Expect(1, 123, '\P{isposixalpha}', "");
    Expect(0, 123, '\P{^isposixalpha}', "");
    Expect(1, 122, '\p{-	IS_POSIXALPHA}', "");
    Expect(0, 122, '\p{^-	IS_POSIXALPHA}', "");
    Expect(0, 122, '\P{-	IS_POSIXALPHA}', "");
    Expect(1, 122, '\P{^-	IS_POSIXALPHA}', "");
    Expect(0, 123, '\p{-	IS_POSIXALPHA}', "");
    Expect(1, 123, '\p{^-	IS_POSIXALPHA}', "");
    Expect(1, 123, '\P{-	IS_POSIXALPHA}', "");
    Expect(0, 123, '\P{^-	IS_POSIXALPHA}', "");
    Error('\p{	:=posixblank}');
    Error('\P{	:=posixblank}');
    Expect(1, 32, '\p{posixblank}', "");
    Expect(0, 32, '\p{^posixblank}', "");
    Expect(0, 32, '\P{posixblank}', "");
    Expect(1, 32, '\P{^posixblank}', "");
    Expect(0, 33, '\p{posixblank}', "");
    Expect(1, 33, '\p{^posixblank}', "");
    Expect(1, 33, '\P{posixblank}', "");
    Expect(0, 33, '\P{^posixblank}', "");
    Expect(1, 32, '\p{	 posixblank}', "");
    Expect(0, 32, '\p{^	 posixblank}', "");
    Expect(0, 32, '\P{	 posixblank}', "");
    Expect(1, 32, '\P{^	 posixblank}', "");
    Expect(0, 33, '\p{	 posixblank}', "");
    Expect(1, 33, '\p{^	 posixblank}', "");
    Expect(1, 33, '\P{	 posixblank}', "");
    Expect(0, 33, '\P{^	 posixblank}', "");
    Error('\p{-_Is_posixblank/a/}');
    Error('\P{-_Is_posixblank/a/}');
    Expect(1, 32, '\p{isposixblank}', "");
    Expect(0, 32, '\p{^isposixblank}', "");
    Expect(0, 32, '\P{isposixblank}', "");
    Expect(1, 32, '\P{^isposixblank}', "");
    Expect(0, 33, '\p{isposixblank}', "");
    Expect(1, 33, '\p{^isposixblank}', "");
    Expect(1, 33, '\P{isposixblank}', "");
    Expect(0, 33, '\P{^isposixblank}', "");
    Expect(1, 32, '\p{	 IS_POSIXBLANK}', "");
    Expect(0, 32, '\p{^	 IS_POSIXBLANK}', "");
    Expect(0, 32, '\P{	 IS_POSIXBLANK}', "");
    Expect(1, 32, '\P{^	 IS_POSIXBLANK}', "");
    Expect(0, 33, '\p{	 IS_POSIXBLANK}', "");
    Expect(1, 33, '\p{^	 IS_POSIXBLANK}', "");
    Expect(1, 33, '\P{	 IS_POSIXBLANK}', "");
    Expect(0, 33, '\P{^	 IS_POSIXBLANK}', "");
    Error('\p{-PosixCntrl:=}');
    Error('\P{-PosixCntrl:=}');
    Expect(1, 127, '\p{posixcntrl}', "");
    Expect(0, 127, '\p{^posixcntrl}', "");
    Expect(0, 127, '\P{posixcntrl}', "");
    Expect(1, 127, '\P{^posixcntrl}', "");
    Expect(0, 128, '\p{posixcntrl}', "");
    Expect(1, 128, '\p{^posixcntrl}', "");
    Expect(1, 128, '\P{posixcntrl}', "");
    Expect(0, 128, '\P{^posixcntrl}', "");
    Expect(1, 127, '\p{_	POSIXCNTRL}', "");
    Expect(0, 127, '\p{^_	POSIXCNTRL}', "");
    Expect(0, 127, '\P{_	POSIXCNTRL}', "");
    Expect(1, 127, '\P{^_	POSIXCNTRL}', "");
    Expect(0, 128, '\p{_	POSIXCNTRL}', "");
    Expect(1, 128, '\p{^_	POSIXCNTRL}', "");
    Expect(1, 128, '\P{_	POSIXCNTRL}', "");
    Expect(0, 128, '\P{^_	POSIXCNTRL}', "");
    Error('\p{ -IS_POSIXCNTRL:=}');
    Error('\P{ -IS_POSIXCNTRL:=}');
    Expect(1, 127, '\p{isposixcntrl}', "");
    Expect(0, 127, '\p{^isposixcntrl}', "");
    Expect(0, 127, '\P{isposixcntrl}', "");
    Expect(1, 127, '\P{^isposixcntrl}', "");
    Expect(0, 128, '\p{isposixcntrl}', "");
    Expect(1, 128, '\p{^isposixcntrl}', "");
    Expect(1, 128, '\P{isposixcntrl}', "");
    Expect(0, 128, '\P{^isposixcntrl}', "");
    Expect(1, 127, '\p{--is_POSIXCNTRL}', "");
    Expect(0, 127, '\p{^--is_POSIXCNTRL}', "");
    Expect(0, 127, '\P{--is_POSIXCNTRL}', "");
    Expect(1, 127, '\P{^--is_POSIXCNTRL}', "");
    Expect(0, 128, '\p{--is_POSIXCNTRL}', "");
    Expect(1, 128, '\p{^--is_POSIXCNTRL}', "");
    Expect(1, 128, '\P{--is_POSIXCNTRL}', "");
    Expect(0, 128, '\P{^--is_POSIXCNTRL}', "");
    Error('\p{--PosixDigit/a/}');
    Error('\P{--PosixDigit/a/}');
    Expect(1, 57, '\p{posixdigit}', "");
    Expect(0, 57, '\p{^posixdigit}', "");
    Expect(0, 57, '\P{posixdigit}', "");
    Expect(1, 57, '\P{^posixdigit}', "");
    Expect(0, 58, '\p{posixdigit}', "");
    Expect(1, 58, '\p{^posixdigit}', "");
    Expect(1, 58, '\P{posixdigit}', "");
    Expect(0, 58, '\P{^posixdigit}', "");
    Expect(1, 57, '\p{	posixdigit}', "");
    Expect(0, 57, '\p{^	posixdigit}', "");
    Expect(0, 57, '\P{	posixdigit}', "");
    Expect(1, 57, '\P{^	posixdigit}', "");
    Expect(0, 58, '\p{	posixdigit}', "");
    Expect(1, 58, '\p{^	posixdigit}', "");
    Expect(1, 58, '\P{	posixdigit}', "");
    Expect(0, 58, '\P{^	posixdigit}', "");
    Error('\p{:=	Is_POSIXDIGIT}');
    Error('\P{:=	Is_POSIXDIGIT}');
    Expect(1, 57, '\p{isposixdigit}', "");
    Expect(0, 57, '\p{^isposixdigit}', "");
    Expect(0, 57, '\P{isposixdigit}', "");
    Expect(1, 57, '\P{^isposixdigit}', "");
    Expect(0, 58, '\p{isposixdigit}', "");
    Expect(1, 58, '\p{^isposixdigit}', "");
    Expect(1, 58, '\P{isposixdigit}', "");
    Expect(0, 58, '\P{^isposixdigit}', "");
    Expect(1, 57, '\p{	Is_PosixDigit}', "");
    Expect(0, 57, '\p{^	Is_PosixDigit}', "");
    Expect(0, 57, '\P{	Is_PosixDigit}', "");
    Expect(1, 57, '\P{^	Is_PosixDigit}', "");
    Expect(0, 58, '\p{	Is_PosixDigit}', "");
    Expect(1, 58, '\p{^	Is_PosixDigit}', "");
    Expect(1, 58, '\P{	Is_PosixDigit}', "");
    Expect(0, 58, '\P{^	Is_PosixDigit}', "");
    Error('\p{ /a/posixgraph}');
    Error('\P{ /a/posixgraph}');
    Expect(1, 126, '\p{posixgraph}', "");
    Expect(0, 126, '\p{^posixgraph}', "");
    Expect(0, 126, '\P{posixgraph}', "");
    Expect(1, 126, '\P{^posixgraph}', "");
    Expect(0, 127, '\p{posixgraph}', "");
    Expect(1, 127, '\p{^posixgraph}', "");
    Expect(1, 127, '\P{posixgraph}', "");
    Expect(0, 127, '\P{^posixgraph}', "");
    Expect(1, 126, '\p{  PosixGraph}', "");
    Expect(0, 126, '\p{^  PosixGraph}', "");
    Expect(0, 126, '\P{  PosixGraph}', "");
    Expect(1, 126, '\P{^  PosixGraph}', "");
    Expect(0, 127, '\p{  PosixGraph}', "");
    Expect(1, 127, '\p{^  PosixGraph}', "");
    Expect(1, 127, '\P{  PosixGraph}', "");
    Expect(0, 127, '\P{^  PosixGraph}', "");
    Error('\p{/a/is_posixgraph}');
    Error('\P{/a/is_posixgraph}');
    Expect(1, 126, '\p{isposixgraph}', "");
    Expect(0, 126, '\p{^isposixgraph}', "");
    Expect(0, 126, '\P{isposixgraph}', "");
    Expect(1, 126, '\P{^isposixgraph}', "");
    Expect(0, 127, '\p{isposixgraph}', "");
    Expect(1, 127, '\p{^isposixgraph}', "");
    Expect(1, 127, '\P{isposixgraph}', "");
    Expect(0, 127, '\P{^isposixgraph}', "");
    Expect(1, 126, '\p{_	IS_posixgraph}', "");
    Expect(0, 126, '\p{^_	IS_posixgraph}', "");
    Expect(0, 126, '\P{_	IS_posixgraph}', "");
    Expect(1, 126, '\P{^_	IS_posixgraph}', "");
    Expect(0, 127, '\p{_	IS_posixgraph}', "");
    Expect(1, 127, '\p{^_	IS_posixgraph}', "");
    Expect(1, 127, '\P{_	IS_posixgraph}', "");
    Expect(0, 127, '\P{^_	IS_posixgraph}', "");
    Error('\p{:= -PosixLower}');
    Error('\P{:= -PosixLower}');
    Expect(1, 122, '\p{posixlower}', "");
    Expect(0, 122, '\p{^posixlower}', "");
    Expect(0, 122, '\P{posixlower}', "");
    Expect(1, 122, '\P{^posixlower}', "");
    Expect(0, 123, '\p{posixlower}', "");
    Expect(1, 123, '\p{^posixlower}', "");
    Expect(1, 123, '\P{posixlower}', "");
    Expect(0, 123, '\P{^posixlower}', "");
    Expect(1, 122, '\p{ posixlower}', "");
    Expect(0, 122, '\p{^ posixlower}', "");
    Expect(0, 122, '\P{ posixlower}', "");
    Expect(1, 122, '\P{^ posixlower}', "");
    Expect(0, 123, '\p{ posixlower}', "");
    Expect(1, 123, '\p{^ posixlower}', "");
    Expect(1, 123, '\P{ posixlower}', "");
    Expect(0, 123, '\P{^ posixlower}', "");
    Error('\p{ :=Is_POSIXLOWER}');
    Error('\P{ :=Is_POSIXLOWER}');
    Expect(1, 122, '\p{isposixlower}', "");
    Expect(0, 122, '\p{^isposixlower}', "");
    Expect(0, 122, '\P{isposixlower}', "");
    Expect(1, 122, '\P{^isposixlower}', "");
    Expect(0, 123, '\p{isposixlower}', "");
    Expect(1, 123, '\p{^isposixlower}', "");
    Expect(1, 123, '\P{isposixlower}', "");
    Expect(0, 123, '\P{^isposixlower}', "");
    Expect(1, 122, '\p{	IS_POSIXLOWER}', "");
    Expect(0, 122, '\p{^	IS_POSIXLOWER}', "");
    Expect(0, 122, '\P{	IS_POSIXLOWER}', "");
    Expect(1, 122, '\P{^	IS_POSIXLOWER}', "");
    Expect(0, 123, '\p{	IS_POSIXLOWER}', "");
    Expect(1, 123, '\p{^	IS_POSIXLOWER}', "");
    Expect(1, 123, '\P{	IS_POSIXLOWER}', "");
    Expect(0, 123, '\P{^	IS_POSIXLOWER}', "");
    Error('\p{-POSIXPRINT/a/}');
    Error('\P{-POSIXPRINT/a/}');
    Expect(1, 126, '\p{posixprint}', "");
    Expect(0, 126, '\p{^posixprint}', "");
    Expect(0, 126, '\P{posixprint}', "");
    Expect(1, 126, '\P{^posixprint}', "");
    Expect(0, 127, '\p{posixprint}', "");
    Expect(1, 127, '\p{^posixprint}', "");
    Expect(1, 127, '\P{posixprint}', "");
    Expect(0, 127, '\P{^posixprint}', "");
    Expect(1, 126, '\p{	 PosixPrint}', "");
    Expect(0, 126, '\p{^	 PosixPrint}', "");
    Expect(0, 126, '\P{	 PosixPrint}', "");
    Expect(1, 126, '\P{^	 PosixPrint}', "");
    Expect(0, 127, '\p{	 PosixPrint}', "");
    Expect(1, 127, '\p{^	 PosixPrint}', "");
    Expect(1, 127, '\P{	 PosixPrint}', "");
    Expect(0, 127, '\P{^	 PosixPrint}', "");
    Error('\p{	is_PosixPrint:=}');
    Error('\P{	is_PosixPrint:=}');
    Expect(1, 126, '\p{isposixprint}', "");
    Expect(0, 126, '\p{^isposixprint}', "");
    Expect(0, 126, '\P{isposixprint}', "");
    Expect(1, 126, '\P{^isposixprint}', "");
    Expect(0, 127, '\p{isposixprint}', "");
    Expect(1, 127, '\p{^isposixprint}', "");
    Expect(1, 127, '\P{isposixprint}', "");
    Expect(0, 127, '\P{^isposixprint}', "");
    Expect(1, 126, '\p{ Is_posixprint}', "");
    Expect(0, 126, '\p{^ Is_posixprint}', "");
    Expect(0, 126, '\P{ Is_posixprint}', "");
    Expect(1, 126, '\P{^ Is_posixprint}', "");
    Expect(0, 127, '\p{ Is_posixprint}', "");
    Expect(1, 127, '\p{^ Is_posixprint}', "");
    Expect(1, 127, '\P{ Is_posixprint}', "");
    Expect(0, 127, '\P{^ Is_posixprint}', "");
    Error('\p{-	posixpunct:=}');
    Error('\P{-	posixpunct:=}');
    Expect(1, 126, '\p{posixpunct}', "");
    Expect(0, 126, '\p{^posixpunct}', "");
    Expect(0, 126, '\P{posixpunct}', "");
    Expect(1, 126, '\P{^posixpunct}', "");
    Expect(0, 127, '\p{posixpunct}', "");
    Expect(1, 127, '\p{^posixpunct}', "");
    Expect(1, 127, '\P{posixpunct}', "");
    Expect(0, 127, '\P{^posixpunct}', "");
    Expect(1, 126, '\p{	PosixPunct}', "");
    Expect(0, 126, '\p{^	PosixPunct}', "");
    Expect(0, 126, '\P{	PosixPunct}', "");
    Expect(1, 126, '\P{^	PosixPunct}', "");
    Expect(0, 127, '\p{	PosixPunct}', "");
    Expect(1, 127, '\p{^	PosixPunct}', "");
    Expect(1, 127, '\P{	PosixPunct}', "");
    Expect(0, 127, '\P{^	PosixPunct}', "");
    Error('\p{/a/	_IS_posixpunct}');
    Error('\P{/a/	_IS_posixpunct}');
    Expect(1, 126, '\p{isposixpunct}', "");
    Expect(0, 126, '\p{^isposixpunct}', "");
    Expect(0, 126, '\P{isposixpunct}', "");
    Expect(1, 126, '\P{^isposixpunct}', "");
    Expect(0, 127, '\p{isposixpunct}', "");
    Expect(1, 127, '\p{^isposixpunct}', "");
    Expect(1, 127, '\P{isposixpunct}', "");
    Expect(0, 127, '\P{^isposixpunct}', "");
    Expect(1, 126, '\p{- Is_POSIXPUNCT}', "");
    Expect(0, 126, '\p{^- Is_POSIXPUNCT}', "");
    Expect(0, 126, '\P{- Is_POSIXPUNCT}', "");
    Expect(1, 126, '\P{^- Is_POSIXPUNCT}', "");
    Expect(0, 127, '\p{- Is_POSIXPUNCT}', "");
    Expect(1, 127, '\p{^- Is_POSIXPUNCT}', "");
    Expect(1, 127, '\P{- Is_POSIXPUNCT}', "");
    Expect(0, 127, '\P{^- Is_POSIXPUNCT}', "");
    Error('\p{/a/ _posixspace}');
    Error('\P{/a/ _posixspace}');
    Expect(1, 32, '\p{posixspace}', "");
    Expect(0, 32, '\p{^posixspace}', "");
    Expect(0, 32, '\P{posixspace}', "");
    Expect(1, 32, '\P{^posixspace}', "");
    Expect(0, 33, '\p{posixspace}', "");
    Expect(1, 33, '\p{^posixspace}', "");
    Expect(1, 33, '\P{posixspace}', "");
    Expect(0, 33, '\P{^posixspace}', "");
    Expect(1, 32, '\p{_	PosixSpace}', "");
    Expect(0, 32, '\p{^_	PosixSpace}', "");
    Expect(0, 32, '\P{_	PosixSpace}', "");
    Expect(1, 32, '\P{^_	PosixSpace}', "");
    Expect(0, 33, '\p{_	PosixSpace}', "");
    Expect(1, 33, '\p{^_	PosixSpace}', "");
    Expect(1, 33, '\P{_	PosixSpace}', "");
    Expect(0, 33, '\P{^_	PosixSpace}', "");
    Error('\p{:= _PERLSPACE}');
    Error('\P{:= _PERLSPACE}');
    Expect(1, 32, '\p{perlspace}', "");
    Expect(0, 32, '\p{^perlspace}', "");
    Expect(0, 32, '\P{perlspace}', "");
    Expect(1, 32, '\P{^perlspace}', "");
    Expect(0, 33, '\p{perlspace}', "");
    Expect(1, 33, '\p{^perlspace}', "");
    Expect(1, 33, '\P{perlspace}', "");
    Expect(0, 33, '\P{^perlspace}', "");
    Expect(1, 32, '\p{	 PerlSpace}', "");
    Expect(0, 32, '\p{^	 PerlSpace}', "");
    Expect(0, 32, '\P{	 PerlSpace}', "");
    Expect(1, 32, '\P{^	 PerlSpace}', "");
    Expect(0, 33, '\p{	 PerlSpace}', "");
    Expect(1, 33, '\p{^	 PerlSpace}', "");
    Expect(1, 33, '\P{	 PerlSpace}', "");
    Expect(0, 33, '\P{^	 PerlSpace}', "");
    Error('\p{	IS_PosixSpace/a/}');
    Error('\P{	IS_PosixSpace/a/}');
    Expect(1, 32, '\p{isposixspace}', "");
    Expect(0, 32, '\p{^isposixspace}', "");
    Expect(0, 32, '\P{isposixspace}', "");
    Expect(1, 32, '\P{^isposixspace}', "");
    Expect(0, 33, '\p{isposixspace}', "");
    Expect(1, 33, '\p{^isposixspace}', "");
    Expect(1, 33, '\P{isposixspace}', "");
    Expect(0, 33, '\P{^isposixspace}', "");
    Expect(1, 32, '\p{	is_PosixSpace}', "");
    Expect(0, 32, '\p{^	is_PosixSpace}', "");
    Expect(0, 32, '\P{	is_PosixSpace}', "");
    Expect(1, 32, '\P{^	is_PosixSpace}', "");
    Expect(0, 33, '\p{	is_PosixSpace}', "");
    Expect(1, 33, '\p{^	is_PosixSpace}', "");
    Expect(1, 33, '\P{	is_PosixSpace}', "");
    Expect(0, 33, '\P{^	is_PosixSpace}', "");
    Error('\p{/a/		Is_PERLSPACE}');
    Error('\P{/a/		Is_PERLSPACE}');
    Expect(1, 32, '\p{isperlspace}', "");
    Expect(0, 32, '\p{^isperlspace}', "");
    Expect(0, 32, '\P{isperlspace}', "");
    Expect(1, 32, '\P{^isperlspace}', "");
    Expect(0, 33, '\p{isperlspace}', "");
    Expect(1, 33, '\p{^isperlspace}', "");
    Expect(1, 33, '\P{isperlspace}', "");
    Expect(0, 33, '\P{^isperlspace}', "");
    Expect(1, 32, '\p{  Is_PerlSpace}', "");
    Expect(0, 32, '\p{^  Is_PerlSpace}', "");
    Expect(0, 32, '\P{  Is_PerlSpace}', "");
    Expect(1, 32, '\P{^  Is_PerlSpace}', "");
    Expect(0, 33, '\p{  Is_PerlSpace}', "");
    Expect(1, 33, '\p{^  Is_PerlSpace}', "");
    Expect(1, 33, '\P{  Is_PerlSpace}', "");
    Expect(0, 33, '\P{^  Is_PerlSpace}', "");
    Error('\p{-/a/PosixUpper}');
    Error('\P{-/a/PosixUpper}');
    Expect(1, 90, '\p{posixupper}', "");
    Expect(0, 90, '\p{^posixupper}', "");
    Expect(0, 90, '\P{posixupper}', "");
    Expect(1, 90, '\P{^posixupper}', "");
    Expect(0, 91, '\p{posixupper}', "");
    Expect(1, 91, '\p{^posixupper}', "");
    Expect(1, 91, '\P{posixupper}', "");
    Expect(0, 91, '\P{^posixupper}', "");
    Expect(1, 90, '\p{	PosixUpper}', "");
    Expect(0, 90, '\p{^	PosixUpper}', "");
    Expect(0, 90, '\P{	PosixUpper}', "");
    Expect(1, 90, '\P{^	PosixUpper}', "");
    Expect(0, 91, '\p{	PosixUpper}', "");
    Expect(1, 91, '\p{^	PosixUpper}', "");
    Expect(1, 91, '\P{	PosixUpper}', "");
    Expect(0, 91, '\P{^	PosixUpper}', "");
    Error('\p{:=is_POSIXUPPER}');
    Error('\P{:=is_POSIXUPPER}');
    Expect(1, 90, '\p{isposixupper}', "");
    Expect(0, 90, '\p{^isposixupper}', "");
    Expect(0, 90, '\P{isposixupper}', "");
    Expect(1, 90, '\P{^isposixupper}', "");
    Expect(0, 91, '\p{isposixupper}', "");
    Expect(1, 91, '\p{^isposixupper}', "");
    Expect(1, 91, '\P{isposixupper}', "");
    Expect(0, 91, '\P{^isposixupper}', "");
    Expect(1, 90, '\p{_Is_PosixUpper}', "");
    Expect(0, 90, '\p{^_Is_PosixUpper}', "");
    Expect(0, 90, '\P{_Is_PosixUpper}', "");
    Expect(1, 90, '\P{^_Is_PosixUpper}', "");
    Expect(0, 91, '\p{_Is_PosixUpper}', "");
    Expect(1, 91, '\p{^_Is_PosixUpper}', "");
    Expect(1, 91, '\P{_Is_PosixUpper}', "");
    Expect(0, 91, '\P{^_Is_PosixUpper}', "");
    Error('\p{PosixWord:=}');
    Error('\P{PosixWord:=}');
    Expect(1, 122, '\p{posixword}', "");
    Expect(0, 122, '\p{^posixword}', "");
    Expect(0, 122, '\P{posixword}', "");
    Expect(1, 122, '\P{^posixword}', "");
    Expect(0, 123, '\p{posixword}', "");
    Expect(1, 123, '\p{^posixword}', "");
    Expect(1, 123, '\P{posixword}', "");
    Expect(0, 123, '\P{^posixword}', "");
    Expect(1, 122, '\p{PosixWord}', "");
    Expect(0, 122, '\p{^PosixWord}', "");
    Expect(0, 122, '\P{PosixWord}', "");
    Expect(1, 122, '\P{^PosixWord}', "");
    Expect(0, 123, '\p{PosixWord}', "");
    Expect(1, 123, '\p{^PosixWord}', "");
    Expect(1, 123, '\P{PosixWord}', "");
    Expect(0, 123, '\P{^PosixWord}', "");
    Error('\p{	PerlWord/a/}');
    Error('\P{	PerlWord/a/}');
    Expect(1, 122, '\p{perlword}', "");
    Expect(0, 122, '\p{^perlword}', "");
    Expect(0, 122, '\P{perlword}', "");
    Expect(1, 122, '\P{^perlword}', "");
    Expect(0, 123, '\p{perlword}', "");
    Expect(1, 123, '\p{^perlword}', "");
    Expect(1, 123, '\P{perlword}', "");
    Expect(0, 123, '\P{^perlword}', "");
    Expect(1, 122, '\p{	 perlword}', "");
    Expect(0, 122, '\p{^	 perlword}', "");
    Expect(0, 122, '\P{	 perlword}', "");
    Expect(1, 122, '\P{^	 perlword}', "");
    Expect(0, 123, '\p{	 perlword}', "");
    Expect(1, 123, '\p{^	 perlword}', "");
    Expect(1, 123, '\P{	 perlword}', "");
    Expect(0, 123, '\P{^	 perlword}', "");
    Error('\p{/a/	IS_POSIXWORD}');
    Error('\P{/a/	IS_POSIXWORD}');
    Expect(1, 122, '\p{isposixword}', "");
    Expect(0, 122, '\p{^isposixword}', "");
    Expect(0, 122, '\P{isposixword}', "");
    Expect(1, 122, '\P{^isposixword}', "");
    Expect(0, 123, '\p{isposixword}', "");
    Expect(1, 123, '\p{^isposixword}', "");
    Expect(1, 123, '\P{isposixword}', "");
    Expect(0, 123, '\P{^isposixword}', "");
    Expect(1, 122, '\p{	-Is_PosixWord}', "");
    Expect(0, 122, '\p{^	-Is_PosixWord}', "");
    Expect(0, 122, '\P{	-Is_PosixWord}', "");
    Expect(1, 122, '\P{^	-Is_PosixWord}', "");
    Expect(0, 123, '\p{	-Is_PosixWord}', "");
    Expect(1, 123, '\p{^	-Is_PosixWord}', "");
    Expect(1, 123, '\P{	-Is_PosixWord}', "");
    Expect(0, 123, '\P{^	-Is_PosixWord}', "");
    Error('\p{		Is_perlword/a/}');
    Error('\P{		Is_perlword/a/}');
    Expect(1, 122, '\p{isperlword}', "");
    Expect(0, 122, '\p{^isperlword}', "");
    Expect(0, 122, '\P{isperlword}', "");
    Expect(1, 122, '\P{^isperlword}', "");
    Expect(0, 123, '\p{isperlword}', "");
    Expect(1, 123, '\p{^isperlword}', "");
    Expect(1, 123, '\P{isperlword}', "");
    Expect(0, 123, '\P{^isperlword}', "");
    Expect(1, 122, '\p{	 IS_PERLWORD}', "");
    Expect(0, 122, '\p{^	 IS_PERLWORD}', "");
    Expect(0, 122, '\P{	 IS_PERLWORD}', "");
    Expect(1, 122, '\P{^	 IS_PERLWORD}', "");
    Expect(0, 123, '\p{	 IS_PERLWORD}', "");
    Expect(1, 123, '\p{^	 IS_PERLWORD}', "");
    Expect(1, 123, '\P{	 IS_PERLWORD}', "");
    Expect(0, 123, '\P{^	 IS_PERLWORD}', "");
    Error('\p{:=PosixXDigit}');
    Error('\P{:=PosixXDigit}');
    Expect(1, 102, '\p{posixxdigit}', "");
    Expect(0, 102, '\p{^posixxdigit}', "");
    Expect(0, 102, '\P{posixxdigit}', "");
    Expect(1, 102, '\P{^posixxdigit}', "");
    Expect(0, 103, '\p{posixxdigit}', "");
    Expect(1, 103, '\p{^posixxdigit}', "");
    Expect(1, 103, '\P{posixxdigit}', "");
    Expect(0, 103, '\P{^posixxdigit}', "");
    Expect(1, 102, '\p{ _PosixXDigit}', "");
    Expect(0, 102, '\p{^ _PosixXDigit}', "");
    Expect(0, 102, '\P{ _PosixXDigit}', "");
    Expect(1, 102, '\P{^ _PosixXDigit}', "");
    Expect(0, 103, '\p{ _PosixXDigit}', "");
    Expect(1, 103, '\p{^ _PosixXDigit}', "");
    Expect(1, 103, '\P{ _PosixXDigit}', "");
    Expect(0, 103, '\P{^ _PosixXDigit}', "");
    Error('\p{_:=IS_PosixXDigit}');
    Error('\P{_:=IS_PosixXDigit}');
    Expect(1, 102, '\p{isposixxdigit}', "");
    Expect(0, 102, '\p{^isposixxdigit}', "");
    Expect(0, 102, '\P{isposixxdigit}', "");
    Expect(1, 102, '\P{^isposixxdigit}', "");
    Expect(0, 103, '\p{isposixxdigit}', "");
    Expect(1, 103, '\p{^isposixxdigit}', "");
    Expect(1, 103, '\P{isposixxdigit}', "");
    Expect(0, 103, '\P{^isposixxdigit}', "");
    Expect(1, 102, '\p{_ IS_posixxdigit}', "");
    Expect(0, 102, '\p{^_ IS_posixxdigit}', "");
    Expect(0, 102, '\P{_ IS_posixxdigit}', "");
    Expect(1, 102, '\P{^_ IS_posixxdigit}', "");
    Expect(0, 103, '\p{_ IS_posixxdigit}', "");
    Expect(1, 103, '\p{^_ IS_posixxdigit}', "");
    Expect(1, 103, '\P{_ IS_posixxdigit}', "");
    Expect(0, 103, '\P{^_ IS_posixxdigit}', "");
    Error('\p{:=-_ASCII_HEX_DIGIT}');
    Error('\P{:=-_ASCII_HEX_DIGIT}');
    Expect(1, 102, '\p{asciihexdigit}', "");
    Expect(0, 102, '\p{^asciihexdigit}', "");
    Expect(0, 102, '\P{asciihexdigit}', "");
    Expect(1, 102, '\P{^asciihexdigit}', "");
    Expect(0, 103, '\p{asciihexdigit}', "");
    Expect(1, 103, '\p{^asciihexdigit}', "");
    Expect(1, 103, '\P{asciihexdigit}', "");
    Expect(0, 103, '\P{^asciihexdigit}', "");
    Expect(1, 102, '\p{		ASCII_Hex_Digit}', "");
    Expect(0, 102, '\p{^		ASCII_Hex_Digit}', "");
    Expect(0, 102, '\P{		ASCII_Hex_Digit}', "");
    Expect(1, 102, '\P{^		ASCII_Hex_Digit}', "");
    Expect(0, 103, '\p{		ASCII_Hex_Digit}', "");
    Expect(1, 103, '\p{^		ASCII_Hex_Digit}', "");
    Expect(1, 103, '\P{		ASCII_Hex_Digit}', "");
    Expect(0, 103, '\P{^		ASCII_Hex_Digit}', "");
    Error('\p{/a/__Is_ascii_hex_digit}');
    Error('\P{/a/__Is_ascii_hex_digit}');
    Expect(1, 102, '\p{isasciihexdigit}', "");
    Expect(0, 102, '\p{^isasciihexdigit}', "");
    Expect(0, 102, '\P{isasciihexdigit}', "");
    Expect(1, 102, '\P{^isasciihexdigit}', "");
    Expect(0, 103, '\p{isasciihexdigit}', "");
    Expect(1, 103, '\p{^isasciihexdigit}', "");
    Expect(1, 103, '\P{isasciihexdigit}', "");
    Expect(0, 103, '\P{^isasciihexdigit}', "");
    Expect(1, 102, '\p{ 	is_ASCII_Hex_Digit}', "");
    Expect(0, 102, '\p{^ 	is_ASCII_Hex_Digit}', "");
    Expect(0, 102, '\P{ 	is_ASCII_Hex_Digit}', "");
    Expect(1, 102, '\P{^ 	is_ASCII_Hex_Digit}', "");
    Expect(0, 103, '\p{ 	is_ASCII_Hex_Digit}', "");
    Expect(1, 103, '\p{^ 	is_ASCII_Hex_Digit}', "");
    Expect(1, 103, '\P{ 	is_ASCII_Hex_Digit}', "");
    Expect(0, 103, '\P{^ 	is_ASCII_Hex_Digit}', "");
    Error('\p{_/a/AHex}');
    Error('\P{_/a/AHex}');
    Expect(1, 102, '\p{ahex}', "");
    Expect(0, 102, '\p{^ahex}', "");
    Expect(0, 102, '\P{ahex}', "");
    Expect(1, 102, '\P{^ahex}', "");
    Expect(0, 103, '\p{ahex}', "");
    Expect(1, 103, '\p{^ahex}', "");
    Expect(1, 103, '\P{ahex}', "");
    Expect(0, 103, '\P{^ahex}', "");
    Expect(1, 102, '\p{	AHex}', "");
    Expect(0, 102, '\p{^	AHex}', "");
    Expect(0, 102, '\P{	AHex}', "");
    Expect(1, 102, '\P{^	AHex}', "");
    Expect(0, 103, '\p{	AHex}', "");
    Expect(1, 103, '\p{^	AHex}', "");
    Expect(1, 103, '\P{	AHex}', "");
    Expect(0, 103, '\P{^	AHex}', "");
    Error('\p{-Is_AHEX/a/}');
    Error('\P{-Is_AHEX/a/}');
    Expect(1, 102, '\p{isahex}', "");
    Expect(0, 102, '\p{^isahex}', "");
    Expect(0, 102, '\P{isahex}', "");
    Expect(1, 102, '\P{^isahex}', "");
    Expect(0, 103, '\p{isahex}', "");
    Expect(1, 103, '\p{^isahex}', "");
    Expect(1, 103, '\P{isahex}', "");
    Expect(0, 103, '\P{^isahex}', "");
    Expect(1, 102, '\p{ -Is_ahex}', "");
    Expect(0, 102, '\p{^ -Is_ahex}', "");
    Expect(0, 102, '\P{ -Is_ahex}', "");
    Expect(1, 102, '\P{^ -Is_ahex}', "");
    Expect(0, 103, '\p{ -Is_ahex}', "");
    Expect(1, 103, '\p{^ -Is_ahex}', "");
    Expect(1, 103, '\P{ -Is_ahex}', "");
    Expect(0, 103, '\P{^ -Is_ahex}', "");
    Error('\p{_/a/Prepended_Concatenation_mark}');
    Error('\P{_/a/Prepended_Concatenation_mark}');
    Expect(1, 69837, '\p{prependedconcatenationmark}', "");
    Expect(0, 69837, '\p{^prependedconcatenationmark}', "");
    Expect(0, 69837, '\P{prependedconcatenationmark}', "");
    Expect(1, 69837, '\P{^prependedconcatenationmark}', "");
    Expect(0, 69838, '\p{prependedconcatenationmark}', "");
    Expect(1, 69838, '\p{^prependedconcatenationmark}', "");
    Expect(1, 69838, '\P{prependedconcatenationmark}', "");
    Expect(0, 69838, '\P{^prependedconcatenationmark}', "");
    Expect(1, 69837, '\p{	Prepended_CONCATENATION_Mark}', "");
    Expect(0, 69837, '\p{^	Prepended_CONCATENATION_Mark}', "");
    Expect(0, 69837, '\P{	Prepended_CONCATENATION_Mark}', "");
    Expect(1, 69837, '\P{^	Prepended_CONCATENATION_Mark}', "");
    Expect(0, 69838, '\p{	Prepended_CONCATENATION_Mark}', "");
    Expect(1, 69838, '\p{^	Prepended_CONCATENATION_Mark}', "");
    Expect(1, 69838, '\P{	Prepended_CONCATENATION_Mark}', "");
    Expect(0, 69838, '\P{^	Prepended_CONCATENATION_Mark}', "");
    Error('\p{/a/Is_prepended_Concatenation_MARK}');
    Error('\P{/a/Is_prepended_Concatenation_MARK}');
    Expect(1, 69837, '\p{isprependedconcatenationmark}', "");
    Expect(0, 69837, '\p{^isprependedconcatenationmark}', "");
    Expect(0, 69837, '\P{isprependedconcatenationmark}', "");
    Expect(1, 69837, '\P{^isprependedconcatenationmark}', "");
    Expect(0, 69838, '\p{isprependedconcatenationmark}', "");
    Expect(1, 69838, '\p{^isprependedconcatenationmark}', "");
    Expect(1, 69838, '\P{isprependedconcatenationmark}', "");
    Expect(0, 69838, '\P{^isprependedconcatenationmark}', "");
    Expect(1, 69837, '\p{-Is_Prepended_Concatenation_MARK}', "");
    Expect(0, 69837, '\p{^-Is_Prepended_Concatenation_MARK}', "");
    Expect(0, 69837, '\P{-Is_Prepended_Concatenation_MARK}', "");
    Expect(1, 69837, '\P{^-Is_Prepended_Concatenation_MARK}', "");
    Expect(0, 69838, '\p{-Is_Prepended_Concatenation_MARK}', "");
    Expect(1, 69838, '\p{^-Is_Prepended_Concatenation_MARK}', "");
    Expect(1, 69838, '\P{-Is_Prepended_Concatenation_MARK}', "");
    Expect(0, 69838, '\P{^-Is_Prepended_Concatenation_MARK}', "");
    Error('\p{/a/PCM}');
    Error('\P{/a/PCM}');
    Expect(1, 69837, '\p{pcm}', "");
    Expect(0, 69837, '\p{^pcm}', "");
    Expect(0, 69837, '\P{pcm}', "");
    Expect(1, 69837, '\P{^pcm}', "");
    Expect(0, 69838, '\p{pcm}', "");
    Expect(1, 69838, '\p{^pcm}', "");
    Expect(1, 69838, '\P{pcm}', "");
    Expect(0, 69838, '\P{^pcm}', "");
    Expect(1, 69837, '\p{ _PCM}', "");
    Expect(0, 69837, '\p{^ _PCM}', "");
    Expect(0, 69837, '\P{ _PCM}', "");
    Expect(1, 69837, '\P{^ _PCM}', "");
    Expect(0, 69838, '\p{ _PCM}', "");
    Expect(1, 69838, '\p{^ _PCM}', "");
    Expect(1, 69838, '\P{ _PCM}', "");
    Expect(0, 69838, '\P{^ _PCM}', "");
    Error('\p{/a/  is_pcm}');
    Error('\P{/a/  is_pcm}');
    Expect(1, 69837, '\p{ispcm}', "");
    Expect(0, 69837, '\p{^ispcm}', "");
    Expect(0, 69837, '\P{ispcm}', "");
    Expect(1, 69837, '\P{^ispcm}', "");
    Expect(0, 69838, '\p{ispcm}', "");
    Expect(1, 69838, '\p{^ispcm}', "");
    Expect(1, 69838, '\P{ispcm}', "");
    Expect(0, 69838, '\P{^ispcm}', "");
    Expect(1, 69837, '\p{-Is_PCM}', "");
    Expect(0, 69837, '\p{^-Is_PCM}', "");
    Expect(0, 69837, '\P{-Is_PCM}', "");
    Expect(1, 69837, '\P{^-Is_PCM}', "");
    Expect(0, 69838, '\p{-Is_PCM}', "");
    Expect(1, 69838, '\p{^-Is_PCM}', "");
    Expect(1, 69838, '\P{-Is_PCM}', "");
    Expect(0, 69838, '\P{^-Is_PCM}', "");
    Error('\p{_ XPosixPrint/a/}');
    Error('\P{_ XPosixPrint/a/}');
    Expect(1, 1114109, '\p{xposixprint}', "");
    Expect(0, 1114109, '\p{^xposixprint}', "");
    Expect(0, 1114109, '\P{xposixprint}', "");
    Expect(1, 1114109, '\P{^xposixprint}', "");
    Expect(0, 918000, '\p{xposixprint}', "");
    Expect(1, 918000, '\p{^xposixprint}', "");
    Expect(1, 918000, '\P{xposixprint}', "");
    Expect(0, 918000, '\P{^xposixprint}', "");
    Expect(1, 1114109, '\p{--XPOSIXPRINT}', "");
    Expect(0, 1114109, '\p{^--XPOSIXPRINT}', "");
    Expect(0, 1114109, '\P{--XPOSIXPRINT}', "");
    Expect(1, 1114109, '\P{^--XPOSIXPRINT}', "");
    Expect(0, 918000, '\p{--XPOSIXPRINT}', "");
    Expect(1, 918000, '\p{^--XPOSIXPRINT}', "");
    Expect(1, 918000, '\P{--XPOSIXPRINT}', "");
    Expect(0, 918000, '\P{^--XPOSIXPRINT}', "");
    Error('\p{/a/-Print}');
    Error('\P{/a/-Print}');
    Expect(1, 1114109, '\p{print}', "");
    Expect(0, 1114109, '\p{^print}', "");
    Expect(0, 1114109, '\P{print}', "");
    Expect(1, 1114109, '\P{^print}', "");
    Expect(0, 918000, '\p{print}', "");
    Expect(1, 918000, '\p{^print}', "");
    Expect(1, 918000, '\P{print}', "");
    Expect(0, 918000, '\P{^print}', "");
    Expect(1, 1114109, '\p{	Print}', "");
    Expect(0, 1114109, '\p{^	Print}', "");
    Expect(0, 1114109, '\P{	Print}', "");
    Expect(1, 1114109, '\P{^	Print}', "");
    Expect(0, 918000, '\p{	Print}', "");
    Expect(1, 918000, '\p{^	Print}', "");
    Expect(1, 918000, '\P{	Print}', "");
    Expect(0, 918000, '\P{^	Print}', "");
    Error('\p{/a/_	Is_XPosixPrint}');
    Error('\P{/a/_	Is_XPosixPrint}');
    Expect(1, 1114109, '\p{isxposixprint}', "");
    Expect(0, 1114109, '\p{^isxposixprint}', "");
    Expect(0, 1114109, '\P{isxposixprint}', "");
    Expect(1, 1114109, '\P{^isxposixprint}', "");
    Expect(0, 918000, '\p{isxposixprint}', "");
    Expect(1, 918000, '\p{^isxposixprint}', "");
    Expect(1, 918000, '\P{isxposixprint}', "");
    Expect(0, 918000, '\P{^isxposixprint}', "");
    Expect(1, 1114109, '\p{Is_XPosixPrint}', "");
    Expect(0, 1114109, '\p{^Is_XPosixPrint}', "");
    Expect(0, 1114109, '\P{Is_XPosixPrint}', "");
    Expect(1, 1114109, '\P{^Is_XPosixPrint}', "");
    Expect(0, 918000, '\p{Is_XPosixPrint}', "");
    Expect(1, 918000, '\p{^Is_XPosixPrint}', "");
    Expect(1, 918000, '\P{Is_XPosixPrint}', "");
    Expect(0, 918000, '\P{^Is_XPosixPrint}', "");
    Error('\p{:=__is_PRINT}');
    Error('\P{:=__is_PRINT}');
    Expect(1, 1114109, '\p{isprint}', "");
    Expect(0, 1114109, '\p{^isprint}', "");
    Expect(0, 1114109, '\P{isprint}', "");
    Expect(1, 1114109, '\P{^isprint}', "");
    Expect(0, 918000, '\p{isprint}', "");
    Expect(1, 918000, '\p{^isprint}', "");
    Expect(1, 918000, '\P{isprint}', "");
    Expect(0, 918000, '\P{^isprint}', "");
    Expect(1, 1114109, '\p{ 	Is_Print}', "");
    Expect(0, 1114109, '\p{^ 	Is_Print}', "");
    Expect(0, 1114109, '\P{ 	Is_Print}', "");
    Expect(1, 1114109, '\P{^ 	Is_Print}', "");
    Expect(0, 918000, '\p{ 	Is_Print}', "");
    Expect(1, 918000, '\p{^ 	Is_Print}', "");
    Expect(1, 918000, '\P{ 	Is_Print}', "");
    Expect(0, 918000, '\P{^ 	Is_Print}', "");
    Error('\p{:=	_Private_Use}');
    Error('\P{:=	_Private_Use}');
    Expect(1, 1114109, '\p{privateuse}', "");
    Expect(0, 1114109, '\p{^privateuse}', "");
    Expect(0, 1114109, '\P{privateuse}', "");
    Expect(1, 1114109, '\P{^privateuse}', "");
    Expect(0, 63744, '\p{privateuse}', "");
    Expect(1, 63744, '\p{^privateuse}', "");
    Expect(1, 63744, '\P{privateuse}', "");
    Expect(0, 63744, '\P{^privateuse}', "");
    Expect(1, 1114109, '\p{ Private_Use}', "");
    Expect(0, 1114109, '\p{^ Private_Use}', "");
    Expect(0, 1114109, '\P{ Private_Use}', "");
    Expect(1, 1114109, '\P{^ Private_Use}', "");
    Expect(0, 63744, '\p{ Private_Use}', "");
    Expect(1, 63744, '\p{^ Private_Use}', "");
    Expect(1, 63744, '\P{ Private_Use}', "");
    Expect(0, 63744, '\P{^ Private_Use}', "");
    Error('\p{/a/_is_private_Use}');
    Error('\P{/a/_is_private_Use}');
    Expect(1, 1114109, '\p{isprivateuse}', "");
    Expect(0, 1114109, '\p{^isprivateuse}', "");
    Expect(0, 1114109, '\P{isprivateuse}', "");
    Expect(1, 1114109, '\P{^isprivateuse}', "");
    Expect(0, 63744, '\p{isprivateuse}', "");
    Expect(1, 63744, '\p{^isprivateuse}', "");
    Expect(1, 63744, '\P{isprivateuse}', "");
    Expect(0, 63744, '\P{^isprivateuse}', "");
    Expect(1, 1114109, '\p{-_Is_Private_Use}', "");
    Expect(0, 1114109, '\p{^-_Is_Private_Use}', "");
    Expect(0, 1114109, '\P{-_Is_Private_Use}', "");
    Expect(1, 1114109, '\P{^-_Is_Private_Use}', "");
    Expect(0, 63744, '\p{-_Is_Private_Use}', "");
    Expect(1, 63744, '\p{^-_Is_Private_Use}', "");
    Expect(1, 63744, '\P{-_Is_Private_Use}', "");
    Expect(0, 63744, '\P{^-_Is_Private_Use}', "");
    Error('\p{-/a/CO}');
    Error('\P{-/a/CO}');
    Expect(1, 1114109, '\p{co}', "");
    Expect(0, 1114109, '\p{^co}', "");
    Expect(0, 1114109, '\P{co}', "");
    Expect(1, 1114109, '\P{^co}', "");
    Expect(0, 63744, '\p{co}', "");
    Expect(1, 63744, '\p{^co}', "");
    Expect(1, 63744, '\P{co}', "");
    Expect(0, 63744, '\P{^co}', "");
    Expect(1, 1114109, '\p{	 CO}', "");
    Expect(0, 1114109, '\p{^	 CO}', "");
    Expect(0, 1114109, '\P{	 CO}', "");
    Expect(1, 1114109, '\P{^	 CO}', "");
    Expect(0, 63744, '\p{	 CO}', "");
    Expect(1, 63744, '\p{^	 CO}', "");
    Expect(1, 63744, '\P{	 CO}', "");
    Expect(0, 63744, '\P{^	 CO}', "");
    Error('\p{	/a/Is_co}');
    Error('\P{	/a/Is_co}');
    Expect(1, 1114109, '\p{isco}', "");
    Expect(0, 1114109, '\p{^isco}', "");
    Expect(0, 1114109, '\P{isco}', "");
    Expect(1, 1114109, '\P{^isco}', "");
    Expect(0, 63744, '\p{isco}', "");
    Expect(1, 63744, '\p{^isco}', "");
    Expect(1, 63744, '\P{isco}', "");
    Expect(0, 63744, '\P{^isco}', "");
    Expect(1, 1114109, '\p{Is_Co}', "");
    Expect(0, 1114109, '\p{^Is_Co}', "");
    Expect(0, 1114109, '\P{Is_Co}', "");
    Expect(1, 1114109, '\P{^Is_Co}', "");
    Expect(0, 63744, '\p{Is_Co}', "");
    Expect(1, 63744, '\p{^Is_Co}', "");
    Expect(1, 63744, '\P{Is_Co}', "");
    Expect(0, 63744, '\P{^Is_Co}', "");
    Error('\p{-/a/PRIVATE_Use_AREA}');
    Error('\P{-/a/PRIVATE_Use_AREA}');
    Expect(1, 63743, '\p{privateusearea}', "");
    Expect(0, 63743, '\p{^privateusearea}', "");
    Expect(0, 63743, '\P{privateusearea}', "");
    Expect(1, 63743, '\P{^privateusearea}', "");
    Expect(0, 63744, '\p{privateusearea}', "");
    Expect(1, 63744, '\p{^privateusearea}', "");
    Expect(1, 63744, '\P{privateusearea}', "");
    Expect(0, 63744, '\P{^privateusearea}', "");
    Expect(1, 63743, '\p{-Private_USE_area}', "");
    Expect(0, 63743, '\p{^-Private_USE_area}', "");
    Expect(0, 63743, '\P{-Private_USE_area}', "");
    Expect(1, 63743, '\P{^-Private_USE_area}', "");
    Expect(0, 63744, '\p{-Private_USE_area}', "");
    Expect(1, 63744, '\p{^-Private_USE_area}', "");
    Expect(1, 63744, '\P{-Private_USE_area}', "");
    Expect(0, 63744, '\P{^-Private_USE_area}', "");
    Error('\p{:=_Is_Private_use_AREA}');
    Error('\P{:=_Is_Private_use_AREA}');
    Expect(1, 63743, '\p{isprivateusearea}', "");
    Expect(0, 63743, '\p{^isprivateusearea}', "");
    Expect(0, 63743, '\P{isprivateusearea}', "");
    Expect(1, 63743, '\P{^isprivateusearea}', "");
    Expect(0, 63744, '\p{isprivateusearea}', "");
    Expect(1, 63744, '\p{^isprivateusearea}', "");
    Expect(1, 63744, '\P{isprivateusearea}', "");
    Expect(0, 63744, '\P{^isprivateusearea}', "");
    Expect(1, 63743, '\p{--is_private_USE_AREA}', "");
    Expect(0, 63743, '\p{^--is_private_USE_AREA}', "");
    Expect(0, 63743, '\P{--is_private_USE_AREA}', "");
    Expect(1, 63743, '\P{^--is_private_USE_AREA}', "");
    Expect(0, 63744, '\p{--is_private_USE_AREA}', "");
    Expect(1, 63744, '\p{^--is_private_USE_AREA}', "");
    Expect(1, 63744, '\P{--is_private_USE_AREA}', "");
    Expect(0, 63744, '\P{^--is_private_USE_AREA}', "");
    Error('\p{-in_private_Use_AREA/a/}');
    Error('\P{-in_private_Use_AREA/a/}');
    Expect(1, 63743, '\p{inprivateusearea}', "");
    Expect(0, 63743, '\p{^inprivateusearea}', "");
    Expect(0, 63743, '\P{inprivateusearea}', "");
    Expect(1, 63743, '\P{^inprivateusearea}', "");
    Expect(0, 63744, '\p{inprivateusearea}', "");
    Expect(1, 63744, '\p{^inprivateusearea}', "");
    Expect(1, 63744, '\P{inprivateusearea}', "");
    Expect(0, 63744, '\P{^inprivateusearea}', "");
    Expect(1, 63743, '\p{-	In_Private_USE_Area}', "");
    Expect(0, 63743, '\p{^-	In_Private_USE_Area}', "");
    Expect(0, 63743, '\P{-	In_Private_USE_Area}', "");
    Expect(1, 63743, '\P{^-	In_Private_USE_Area}', "");
    Expect(0, 63744, '\p{-	In_Private_USE_Area}', "");
    Expect(1, 63744, '\p{^-	In_Private_USE_Area}', "");
    Expect(1, 63744, '\P{-	In_Private_USE_Area}', "");
    Expect(0, 63744, '\P{^-	In_Private_USE_Area}', "");
    Error('\p{/a/-PUA}');
    Error('\P{/a/-PUA}');
    Expect(1, 63743, '\p{pua}', "");
    Expect(0, 63743, '\p{^pua}', "");
    Expect(0, 63743, '\P{pua}', "");
    Expect(1, 63743, '\P{^pua}', "");
    Expect(0, 63744, '\p{pua}', "");
    Expect(1, 63744, '\p{^pua}', "");
    Expect(1, 63744, '\P{pua}', "");
    Expect(0, 63744, '\P{^pua}', "");
    Expect(1, 63743, '\p{-PUA}', "");
    Expect(0, 63743, '\p{^-PUA}', "");
    Expect(0, 63743, '\P{-PUA}', "");
    Expect(1, 63743, '\P{^-PUA}', "");
    Expect(0, 63744, '\p{-PUA}', "");
    Expect(1, 63744, '\p{^-PUA}', "");
    Expect(1, 63744, '\P{-PUA}', "");
    Expect(0, 63744, '\P{^-PUA}', "");
    Error('\p{:=_ is_pua}');
    Error('\P{:=_ is_pua}');
    Expect(1, 63743, '\p{ispua}', "");
    Expect(0, 63743, '\p{^ispua}', "");
    Expect(0, 63743, '\P{ispua}', "");
    Expect(1, 63743, '\P{^ispua}', "");
    Expect(0, 63744, '\p{ispua}', "");
    Expect(1, 63744, '\p{^ispua}', "");
    Expect(1, 63744, '\P{ispua}', "");
    Expect(0, 63744, '\P{^ispua}', "");
    Expect(1, 63743, '\p{-_IS_PUA}', "");
    Expect(0, 63743, '\p{^-_IS_PUA}', "");
    Expect(0, 63743, '\P{-_IS_PUA}', "");
    Expect(1, 63743, '\P{^-_IS_PUA}', "");
    Expect(0, 63744, '\p{-_IS_PUA}', "");
    Expect(1, 63744, '\p{^-_IS_PUA}', "");
    Expect(1, 63744, '\P{-_IS_PUA}', "");
    Expect(0, 63744, '\P{^-_IS_PUA}', "");
    Error('\p{/a/__IN_PUA}');
    Error('\P{/a/__IN_PUA}');
    Expect(1, 63743, '\p{inpua}', "");
    Expect(0, 63743, '\p{^inpua}', "");
    Expect(0, 63743, '\P{inpua}', "");
    Expect(1, 63743, '\P{^inpua}', "");
    Expect(0, 63744, '\p{inpua}', "");
    Expect(1, 63744, '\p{^inpua}', "");
    Expect(1, 63744, '\P{inpua}', "");
    Expect(0, 63744, '\P{^inpua}', "");
    Expect(1, 63743, '\p{- IN_pua}', "");
    Expect(0, 63743, '\p{^- IN_pua}', "");
    Expect(0, 63743, '\P{- IN_pua}', "");
    Expect(1, 63743, '\P{^- IN_pua}', "");
    Expect(0, 63744, '\p{- IN_pua}', "");
    Expect(1, 63744, '\p{^- IN_pua}', "");
    Expect(1, 63744, '\P{- IN_pua}', "");
    Expect(0, 63744, '\P{^- IN_pua}', "");
    Error('\p{:= In_private_Use}');
    Error('\P{:= In_private_Use}');
    Expect(1, 63743, '\p{inprivateuse}', "");
    Expect(0, 63743, '\p{^inprivateuse}', "");
    Expect(0, 63743, '\P{inprivateuse}', "");
    Expect(1, 63743, '\P{^inprivateuse}', "");
    Expect(0, 63744, '\p{inprivateuse}', "");
    Expect(1, 63744, '\p{^inprivateuse}', "");
    Expect(1, 63744, '\P{inprivateuse}', "");
    Expect(0, 63744, '\P{^inprivateuse}', "");
    Expect(1, 63743, '\p{_-In_PRIVATE_use}', "");
    Expect(0, 63743, '\p{^_-In_PRIVATE_use}', "");
    Expect(0, 63743, '\P{_-In_PRIVATE_use}', "");
    Expect(1, 63743, '\P{^_-In_PRIVATE_use}', "");
    Expect(0, 63744, '\p{_-In_PRIVATE_use}', "");
    Expect(1, 63744, '\p{^_-In_PRIVATE_use}', "");
    Expect(1, 63744, '\P{_-In_PRIVATE_use}', "");
    Expect(0, 63744, '\P{^_-In_PRIVATE_use}', "");
    Error('\p{	:=psalter_Pahlavi}');
    Error('\P{	:=psalter_Pahlavi}');
    Expect(1, 68527, '\p{psalterpahlavi}', "");
    Expect(0, 68527, '\p{^psalterpahlavi}', "");
    Expect(0, 68527, '\P{psalterpahlavi}', "");
    Expect(1, 68527, '\P{^psalterpahlavi}', "");
    Expect(0, 68528, '\p{psalterpahlavi}', "");
    Expect(1, 68528, '\p{^psalterpahlavi}', "");
    Expect(1, 68528, '\P{psalterpahlavi}', "");
    Expect(0, 68528, '\P{^psalterpahlavi}', "");
    Expect(1, 68527, '\p{- Psalter_Pahlavi}', "");
    Expect(0, 68527, '\p{^- Psalter_Pahlavi}', "");
    Expect(0, 68527, '\P{- Psalter_Pahlavi}', "");
    Expect(1, 68527, '\P{^- Psalter_Pahlavi}', "");
    Expect(0, 68528, '\p{- Psalter_Pahlavi}', "");
    Expect(1, 68528, '\p{^- Psalter_Pahlavi}', "");
    Expect(1, 68528, '\P{- Psalter_Pahlavi}', "");
    Expect(0, 68528, '\P{^- Psalter_Pahlavi}', "");
    Error('\p{is_psalter_pahlavi/a/}');
    Error('\P{is_psalter_pahlavi/a/}');
    Expect(1, 68527, '\p{ispsalterpahlavi}', "");
    Expect(0, 68527, '\p{^ispsalterpahlavi}', "");
    Expect(0, 68527, '\P{ispsalterpahlavi}', "");
    Expect(1, 68527, '\P{^ispsalterpahlavi}', "");
    Expect(0, 68528, '\p{ispsalterpahlavi}', "");
    Expect(1, 68528, '\p{^ispsalterpahlavi}', "");
    Expect(1, 68528, '\P{ispsalterpahlavi}', "");
    Expect(0, 68528, '\P{^ispsalterpahlavi}', "");
    Expect(1, 68527, '\p{-Is_psalter_Pahlavi}', "");
    Expect(0, 68527, '\p{^-Is_psalter_Pahlavi}', "");
    Expect(0, 68527, '\P{-Is_psalter_Pahlavi}', "");
    Expect(1, 68527, '\P{^-Is_psalter_Pahlavi}', "");
    Expect(0, 68528, '\p{-Is_psalter_Pahlavi}', "");
    Expect(1, 68528, '\p{^-Is_psalter_Pahlavi}', "");
    Expect(1, 68528, '\P{-Is_psalter_Pahlavi}', "");
    Expect(0, 68528, '\P{^-Is_psalter_Pahlavi}', "");
    Error('\p{:=_ phlp}');
    Error('\P{:=_ phlp}');
    Expect(1, 68527, '\p{phlp}', "");
    Expect(0, 68527, '\p{^phlp}', "");
    Expect(0, 68527, '\P{phlp}', "");
    Expect(1, 68527, '\P{^phlp}', "");
    Expect(0, 68528, '\p{phlp}', "");
    Expect(1, 68528, '\p{^phlp}', "");
    Expect(1, 68528, '\P{phlp}', "");
    Expect(0, 68528, '\P{^phlp}', "");
    Expect(1, 68527, '\p{	_Phlp}', "");
    Expect(0, 68527, '\p{^	_Phlp}', "");
    Expect(0, 68527, '\P{	_Phlp}', "");
    Expect(1, 68527, '\P{^	_Phlp}', "");
    Expect(0, 68528, '\p{	_Phlp}', "");
    Expect(1, 68528, '\p{^	_Phlp}', "");
    Expect(1, 68528, '\P{	_Phlp}', "");
    Expect(0, 68528, '\P{^	_Phlp}', "");
    Error('\p{_:=is_Phlp}');
    Error('\P{_:=is_Phlp}');
    Expect(1, 68527, '\p{isphlp}', "");
    Expect(0, 68527, '\p{^isphlp}', "");
    Expect(0, 68527, '\P{isphlp}', "");
    Expect(1, 68527, '\P{^isphlp}', "");
    Expect(0, 68528, '\p{isphlp}', "");
    Expect(1, 68528, '\p{^isphlp}', "");
    Expect(1, 68528, '\P{isphlp}', "");
    Expect(0, 68528, '\P{^isphlp}', "");
    Expect(1, 68527, '\p{-is_Phlp}', "");
    Expect(0, 68527, '\p{^-is_Phlp}', "");
    Expect(0, 68527, '\P{-is_Phlp}', "");
    Expect(1, 68527, '\P{^-is_Phlp}', "");
    Expect(0, 68528, '\p{-is_Phlp}', "");
    Expect(1, 68528, '\p{^-is_Phlp}', "");
    Expect(1, 68528, '\P{-is_Phlp}', "");
    Expect(0, 68528, '\P{^-is_Phlp}', "");
    Error('\p{:=punct}');
    Error('\P{:=punct}');
    Expect(1, 125279, '\p{punct}', "");
    Expect(0, 125279, '\p{^punct}', "");
    Expect(0, 125279, '\P{punct}', "");
    Expect(1, 125279, '\P{^punct}', "");
    Expect(0, 125280, '\p{punct}', "");
    Expect(1, 125280, '\p{^punct}', "");
    Expect(1, 125280, '\P{punct}', "");
    Expect(0, 125280, '\P{^punct}', "");
    Expect(1, 125279, '\p{-Punct}', "");
    Expect(0, 125279, '\p{^-Punct}', "");
    Expect(0, 125279, '\P{-Punct}', "");
    Expect(1, 125279, '\P{^-Punct}', "");
    Expect(0, 125280, '\p{-Punct}', "");
    Expect(1, 125280, '\p{^-Punct}', "");
    Expect(1, 125280, '\P{-Punct}', "");
    Expect(0, 125280, '\P{^-Punct}', "");
    Error('\p{_:=Is_punct}');
    Error('\P{_:=Is_punct}');
    Expect(1, 125279, '\p{ispunct}', "");
    Expect(0, 125279, '\p{^ispunct}', "");
    Expect(0, 125279, '\P{ispunct}', "");
    Expect(1, 125279, '\P{^ispunct}', "");
    Expect(0, 125280, '\p{ispunct}', "");
    Expect(1, 125280, '\p{^ispunct}', "");
    Expect(1, 125280, '\P{ispunct}', "");
    Expect(0, 125280, '\P{^ispunct}', "");
    Expect(1, 125279, '\p{ is_Punct}', "");
    Expect(0, 125279, '\p{^ is_Punct}', "");
    Expect(0, 125279, '\P{ is_Punct}', "");
    Expect(1, 125279, '\P{^ is_Punct}', "");
    Expect(0, 125280, '\p{ is_Punct}', "");
    Expect(1, 125280, '\p{^ is_Punct}', "");
    Expect(1, 125280, '\P{ is_Punct}', "");
    Expect(0, 125280, '\P{^ is_Punct}', "");
    Error('\p{- Punctuation:=}');
    Error('\P{- Punctuation:=}');
    Expect(1, 125279, '\p{punctuation}', "");
    Expect(0, 125279, '\p{^punctuation}', "");
    Expect(0, 125279, '\P{punctuation}', "");
    Expect(1, 125279, '\P{^punctuation}', "");
    Expect(0, 125280, '\p{punctuation}', "");
    Expect(1, 125280, '\p{^punctuation}', "");
    Expect(1, 125280, '\P{punctuation}', "");
    Expect(0, 125280, '\P{^punctuation}', "");
    Expect(1, 125279, '\p{_Punctuation}', "");
    Expect(0, 125279, '\p{^_Punctuation}', "");
    Expect(0, 125279, '\P{_Punctuation}', "");
    Expect(1, 125279, '\P{^_Punctuation}', "");
    Expect(0, 125280, '\p{_Punctuation}', "");
    Expect(1, 125280, '\p{^_Punctuation}', "");
    Expect(1, 125280, '\P{_Punctuation}', "");
    Expect(0, 125280, '\P{^_Punctuation}', "");
    Error('\p{ 	Is_punctuation:=}');
    Error('\P{ 	Is_punctuation:=}');
    Expect(1, 125279, '\p{ispunctuation}', "");
    Expect(0, 125279, '\p{^ispunctuation}', "");
    Expect(0, 125279, '\P{ispunctuation}', "");
    Expect(1, 125279, '\P{^ispunctuation}', "");
    Expect(0, 125280, '\p{ispunctuation}', "");
    Expect(1, 125280, '\p{^ispunctuation}', "");
    Expect(1, 125280, '\P{ispunctuation}', "");
    Expect(0, 125280, '\P{^ispunctuation}', "");
    Expect(1, 125279, '\p{	IS_Punctuation}', "");
    Expect(0, 125279, '\p{^	IS_Punctuation}', "");
    Expect(0, 125279, '\P{	IS_Punctuation}', "");
    Expect(1, 125279, '\P{^	IS_Punctuation}', "");
    Expect(0, 125280, '\p{	IS_Punctuation}', "");
    Expect(1, 125280, '\p{^	IS_Punctuation}', "");
    Expect(1, 125280, '\P{	IS_Punctuation}', "");
    Expect(0, 125280, '\P{^	IS_Punctuation}', "");
    Error('\p{/a/- p}');
    Error('\P{/a/- p}');
    Expect(1, 125279, '\p{p}', "");
    Expect(0, 125279, '\p{^p}', "");
    Expect(0, 125279, '\P{p}', "");
    Expect(1, 125279, '\P{^p}', "");
    Expect(0, 125280, '\p{p}', "");
    Expect(1, 125280, '\p{^p}', "");
    Expect(1, 125280, '\P{p}', "");
    Expect(0, 125280, '\P{^p}', "");
    Expect(1, 125279, '\p{-	P}', "");
    Expect(0, 125279, '\p{^-	P}', "");
    Expect(0, 125279, '\P{-	P}', "");
    Expect(1, 125279, '\P{^-	P}', "");
    Expect(0, 125280, '\p{-	P}', "");
    Expect(1, 125280, '\p{^-	P}', "");
    Expect(1, 125280, '\P{-	P}', "");
    Expect(0, 125280, '\P{^-	P}', "");
    Error('\p{	-IS_P/a/}');
    Error('\P{	-IS_P/a/}');
    Expect(1, 125279, '\p{isp}', "");
    Expect(0, 125279, '\p{^isp}', "");
    Expect(0, 125279, '\P{isp}', "");
    Expect(1, 125279, '\P{^isp}', "");
    Expect(0, 125280, '\p{isp}', "");
    Expect(1, 125280, '\p{^isp}', "");
    Expect(1, 125280, '\P{isp}', "");
    Expect(0, 125280, '\P{^isp}', "");
    Expect(1, 125279, '\p{_ IS_p}', "");
    Expect(0, 125279, '\p{^_ IS_p}', "");
    Expect(0, 125279, '\P{_ IS_p}', "");
    Expect(1, 125279, '\P{^_ IS_p}', "");
    Expect(0, 125280, '\p{_ IS_p}', "");
    Expect(1, 125280, '\p{^_ IS_p}', "");
    Expect(1, 125280, '\P{_ IS_p}', "");
    Expect(0, 125280, '\P{^_ IS_p}', "");
    Error('\p{	-quotation_Mark/a/}');
    Error('\P{	-quotation_Mark/a/}');
    Expect(1, 65379, '\p{quotationmark}', "");
    Expect(0, 65379, '\p{^quotationmark}', "");
    Expect(0, 65379, '\P{quotationmark}', "");
    Expect(1, 65379, '\P{^quotationmark}', "");
    Expect(0, 65380, '\p{quotationmark}', "");
    Expect(1, 65380, '\p{^quotationmark}', "");
    Expect(1, 65380, '\P{quotationmark}', "");
    Expect(0, 65380, '\P{^quotationmark}', "");
    Expect(1, 65379, '\p{	-QUOTATION_Mark}', "");
    Expect(0, 65379, '\p{^	-QUOTATION_Mark}', "");
    Expect(0, 65379, '\P{	-QUOTATION_Mark}', "");
    Expect(1, 65379, '\P{^	-QUOTATION_Mark}', "");
    Expect(0, 65380, '\p{	-QUOTATION_Mark}', "");
    Expect(1, 65380, '\p{^	-QUOTATION_Mark}', "");
    Expect(1, 65380, '\P{	-QUOTATION_Mark}', "");
    Expect(0, 65380, '\P{^	-QUOTATION_Mark}', "");
    Error('\p{/a/Is_QUOTATION_MARK}');
    Error('\P{/a/Is_QUOTATION_MARK}');
    Expect(1, 65379, '\p{isquotationmark}', "");
    Expect(0, 65379, '\p{^isquotationmark}', "");
    Expect(0, 65379, '\P{isquotationmark}', "");
    Expect(1, 65379, '\P{^isquotationmark}', "");
    Expect(0, 65380, '\p{isquotationmark}', "");
    Expect(1, 65380, '\p{^isquotationmark}', "");
    Expect(1, 65380, '\P{isquotationmark}', "");
    Expect(0, 65380, '\P{^isquotationmark}', "");
    Expect(1, 65379, '\p{--is_Quotation_MARK}', "");
    Expect(0, 65379, '\p{^--is_Quotation_MARK}', "");
    Expect(0, 65379, '\P{--is_Quotation_MARK}', "");
    Expect(1, 65379, '\P{^--is_Quotation_MARK}', "");
    Expect(0, 65380, '\p{--is_Quotation_MARK}', "");
    Expect(1, 65380, '\p{^--is_Quotation_MARK}', "");
    Expect(1, 65380, '\P{--is_Quotation_MARK}', "");
    Expect(0, 65380, '\P{^--is_Quotation_MARK}', "");
    Error('\p{	QMark/a/}');
    Error('\P{	QMark/a/}');
    Expect(1, 65379, '\p{qmark}', "");
    Expect(0, 65379, '\p{^qmark}', "");
    Expect(0, 65379, '\P{qmark}', "");
    Expect(1, 65379, '\P{^qmark}', "");
    Expect(0, 65380, '\p{qmark}', "");
    Expect(1, 65380, '\p{^qmark}', "");
    Expect(1, 65380, '\P{qmark}', "");
    Expect(0, 65380, '\P{^qmark}', "");
    Expect(1, 65379, '\p{ QMARK}', "");
    Expect(0, 65379, '\p{^ QMARK}', "");
    Expect(0, 65379, '\P{ QMARK}', "");
    Expect(1, 65379, '\P{^ QMARK}', "");
    Expect(0, 65380, '\p{ QMARK}', "");
    Expect(1, 65380, '\p{^ QMARK}', "");
    Expect(1, 65380, '\P{ QMARK}', "");
    Expect(0, 65380, '\P{^ QMARK}', "");
    Error('\p{--is_qmark/a/}');
    Error('\P{--is_qmark/a/}');
    Expect(1, 65379, '\p{isqmark}', "");
    Expect(0, 65379, '\p{^isqmark}', "");
    Expect(0, 65379, '\P{isqmark}', "");
    Expect(1, 65379, '\P{^isqmark}', "");
    Expect(0, 65380, '\p{isqmark}', "");
    Expect(1, 65380, '\p{^isqmark}', "");
    Expect(1, 65380, '\P{isqmark}', "");
    Expect(0, 65380, '\P{^isqmark}', "");
    Expect(1, 65379, '\p{-is_QMARK}', "");
    Expect(0, 65379, '\p{^-is_QMARK}', "");
    Expect(0, 65379, '\P{-is_QMARK}', "");
    Expect(1, 65379, '\P{^-is_QMARK}', "");
    Expect(0, 65380, '\p{-is_QMARK}', "");
    Expect(1, 65380, '\p{^-is_QMARK}', "");
    Expect(1, 65380, '\P{-is_QMARK}', "");
    Expect(0, 65380, '\P{^-is_QMARK}', "");
    Error('\p{ /a/Radical}');
    Error('\P{ /a/Radical}');
    Expect(1, 12245, '\p{radical}', "");
    Expect(0, 12245, '\p{^radical}', "");
    Expect(0, 12245, '\P{radical}', "");
    Expect(1, 12245, '\P{^radical}', "");
    Expect(0, 12246, '\p{radical}', "");
    Expect(1, 12246, '\p{^radical}', "");
    Expect(1, 12246, '\P{radical}', "");
    Expect(0, 12246, '\P{^radical}', "");
    Expect(1, 12245, '\p{	-Radical}', "");
    Expect(0, 12245, '\p{^	-Radical}', "");
    Expect(0, 12245, '\P{	-Radical}', "");
    Expect(1, 12245, '\P{^	-Radical}', "");
    Expect(0, 12246, '\p{	-Radical}', "");
    Expect(1, 12246, '\p{^	-Radical}', "");
    Expect(1, 12246, '\P{	-Radical}', "");
    Expect(0, 12246, '\P{^	-Radical}', "");
    Error('\p{:= 	Is_RADICAL}');
    Error('\P{:= 	Is_RADICAL}');
    Expect(1, 12245, '\p{isradical}', "");
    Expect(0, 12245, '\p{^isradical}', "");
    Expect(0, 12245, '\P{isradical}', "");
    Expect(1, 12245, '\P{^isradical}', "");
    Expect(0, 12246, '\p{isradical}', "");
    Expect(1, 12246, '\p{^isradical}', "");
    Expect(1, 12246, '\P{isradical}', "");
    Expect(0, 12246, '\P{^isradical}', "");
    Expect(1, 12245, '\p{	 is_RADICAL}', "");
    Expect(0, 12245, '\p{^	 is_RADICAL}', "");
    Expect(0, 12245, '\P{	 is_RADICAL}', "");
    Expect(1, 12245, '\P{^	 is_RADICAL}', "");
    Expect(0, 12246, '\p{	 is_RADICAL}', "");
    Expect(1, 12246, '\p{^	 is_RADICAL}', "");
    Expect(1, 12246, '\P{	 is_RADICAL}', "");
    Expect(0, 12246, '\P{^	 is_RADICAL}', "");
    Error('\p{ :=REGIONAL_INDICATOR}');
    Error('\P{ :=REGIONAL_INDICATOR}');
    Expect(1, 127487, '\p{regionalindicator}', "");
    Expect(0, 127487, '\p{^regionalindicator}', "");
    Expect(0, 127487, '\P{regionalindicator}', "");
    Expect(1, 127487, '\P{^regionalindicator}', "");
    Expect(0, 127488, '\p{regionalindicator}', "");
    Expect(1, 127488, '\p{^regionalindicator}', "");
    Expect(1, 127488, '\P{regionalindicator}', "");
    Expect(0, 127488, '\P{^regionalindicator}', "");
    Expect(1, 127487, '\p{_-Regional_INDICATOR}', "");
    Expect(0, 127487, '\p{^_-Regional_INDICATOR}', "");
    Expect(0, 127487, '\P{_-Regional_INDICATOR}', "");
    Expect(1, 127487, '\P{^_-Regional_INDICATOR}', "");
    Expect(0, 127488, '\p{_-Regional_INDICATOR}', "");
    Expect(1, 127488, '\p{^_-Regional_INDICATOR}', "");
    Expect(1, 127488, '\P{_-Regional_INDICATOR}', "");
    Expect(0, 127488, '\P{^_-Regional_INDICATOR}', "");
    Error('\p{	 Is_Regional_Indicator:=}');
    Error('\P{	 Is_Regional_Indicator:=}');
    Expect(1, 127487, '\p{isregionalindicator}', "");
    Expect(0, 127487, '\p{^isregionalindicator}', "");
    Expect(0, 127487, '\P{isregionalindicator}', "");
    Expect(1, 127487, '\P{^isregionalindicator}', "");
    Expect(0, 127488, '\p{isregionalindicator}', "");
    Expect(1, 127488, '\p{^isregionalindicator}', "");
    Expect(1, 127488, '\P{isregionalindicator}', "");
    Expect(0, 127488, '\P{^isregionalindicator}', "");
    Expect(1, 127487, '\p{ -IS_REGIONAL_Indicator}', "");
    Expect(0, 127487, '\p{^ -IS_REGIONAL_Indicator}', "");
    Expect(0, 127487, '\P{ -IS_REGIONAL_Indicator}', "");
    Expect(1, 127487, '\P{^ -IS_REGIONAL_Indicator}', "");
    Expect(0, 127488, '\p{ -IS_REGIONAL_Indicator}', "");
    Expect(1, 127488, '\p{^ -IS_REGIONAL_Indicator}', "");
    Expect(1, 127488, '\P{ -IS_REGIONAL_Indicator}', "");
    Expect(0, 127488, '\P{^ -IS_REGIONAL_Indicator}', "");
    Error('\p{:=RI}');
    Error('\P{:=RI}');
    Expect(1, 127487, '\p{ri}', "");
    Expect(0, 127487, '\p{^ri}', "");
    Expect(0, 127487, '\P{ri}', "");
    Expect(1, 127487, '\P{^ri}', "");
    Expect(0, 127488, '\p{ri}', "");
    Expect(1, 127488, '\p{^ri}', "");
    Expect(1, 127488, '\P{ri}', "");
    Expect(0, 127488, '\P{^ri}', "");
    Expect(1, 127487, '\p{-_ri}', "");
    Expect(0, 127487, '\p{^-_ri}', "");
    Expect(0, 127487, '\P{-_ri}', "");
    Expect(1, 127487, '\P{^-_ri}', "");
    Expect(0, 127488, '\p{-_ri}', "");
    Expect(1, 127488, '\p{^-_ri}', "");
    Expect(1, 127488, '\P{-_ri}', "");
    Expect(0, 127488, '\P{^-_ri}', "");
    Error('\p{_/a/is_RI}');
    Error('\P{_/a/is_RI}');
    Expect(1, 127487, '\p{isri}', "");
    Expect(0, 127487, '\p{^isri}', "");
    Expect(0, 127487, '\P{isri}', "");
    Expect(1, 127487, '\P{^isri}', "");
    Expect(0, 127488, '\p{isri}', "");
    Expect(1, 127488, '\p{^isri}', "");
    Expect(1, 127488, '\P{isri}', "");
    Expect(0, 127488, '\P{^isri}', "");
    Expect(1, 127487, '\p{__is_RI}', "");
    Expect(0, 127487, '\p{^__is_RI}', "");
    Expect(0, 127487, '\P{__is_RI}', "");
    Expect(1, 127487, '\P{^__is_RI}', "");
    Expect(0, 127488, '\p{__is_RI}', "");
    Expect(1, 127488, '\p{^__is_RI}', "");
    Expect(1, 127488, '\P{__is_RI}', "");
    Expect(0, 127488, '\P{^__is_RI}', "");
    Error('\p{:=	_Rejang}');
    Error('\P{:=	_Rejang}');
    Expect(1, 43359, '\p{rejang}', "");
    Expect(0, 43359, '\p{^rejang}', "");
    Expect(0, 43359, '\P{rejang}', "");
    Expect(1, 43359, '\P{^rejang}', "");
    Expect(0, 43360, '\p{rejang}', "");
    Expect(1, 43360, '\p{^rejang}', "");
    Expect(1, 43360, '\P{rejang}', "");
    Expect(0, 43360, '\P{^rejang}', "");
    Expect(1, 43359, '\p{_REJANG}', "");
    Expect(0, 43359, '\p{^_REJANG}', "");
    Expect(0, 43359, '\P{_REJANG}', "");
    Expect(1, 43359, '\P{^_REJANG}', "");
    Expect(0, 43360, '\p{_REJANG}', "");
    Expect(1, 43360, '\p{^_REJANG}', "");
    Expect(1, 43360, '\P{_REJANG}', "");
    Expect(0, 43360, '\P{^_REJANG}', "");
    Error('\p{_-Is_Rejang/a/}');
    Error('\P{_-Is_Rejang/a/}');
    Expect(1, 43359, '\p{isrejang}', "");
    Expect(0, 43359, '\p{^isrejang}', "");
    Expect(0, 43359, '\P{isrejang}', "");
    Expect(1, 43359, '\P{^isrejang}', "");
    Expect(0, 43360, '\p{isrejang}', "");
    Expect(1, 43360, '\p{^isrejang}', "");
    Expect(1, 43360, '\P{isrejang}', "");
    Expect(0, 43360, '\P{^isrejang}', "");
    Expect(1, 43359, '\p{		is_REJANG}', "");
    Expect(0, 43359, '\p{^		is_REJANG}', "");
    Expect(0, 43359, '\P{		is_REJANG}', "");
    Expect(1, 43359, '\P{^		is_REJANG}', "");
    Expect(0, 43360, '\p{		is_REJANG}', "");
    Expect(1, 43360, '\p{^		is_REJANG}', "");
    Expect(1, 43360, '\P{		is_REJANG}', "");
    Expect(0, 43360, '\P{^		is_REJANG}', "");
    Error('\p{		Rjng/a/}');
    Error('\P{		Rjng/a/}');
    Expect(1, 43359, '\p{rjng}', "");
    Expect(0, 43359, '\p{^rjng}', "");
    Expect(0, 43359, '\P{rjng}', "");
    Expect(1, 43359, '\P{^rjng}', "");
    Expect(0, 43360, '\p{rjng}', "");
    Expect(1, 43360, '\p{^rjng}', "");
    Expect(1, 43360, '\P{rjng}', "");
    Expect(0, 43360, '\P{^rjng}', "");
    Expect(1, 43359, '\p{-RJNG}', "");
    Expect(0, 43359, '\p{^-RJNG}', "");
    Expect(0, 43359, '\P{-RJNG}', "");
    Expect(1, 43359, '\P{^-RJNG}', "");
    Expect(0, 43360, '\p{-RJNG}', "");
    Expect(1, 43360, '\p{^-RJNG}', "");
    Expect(1, 43360, '\P{-RJNG}', "");
    Expect(0, 43360, '\P{^-RJNG}', "");
    Error('\p{	Is_Rjng:=}');
    Error('\P{	Is_Rjng:=}');
    Expect(1, 43359, '\p{isrjng}', "");
    Expect(0, 43359, '\p{^isrjng}', "");
    Expect(0, 43359, '\P{isrjng}', "");
    Expect(1, 43359, '\P{^isrjng}', "");
    Expect(0, 43360, '\p{isrjng}', "");
    Expect(1, 43360, '\p{^isrjng}', "");
    Expect(1, 43360, '\P{isrjng}', "");
    Expect(0, 43360, '\P{^isrjng}', "");
    Expect(1, 43359, '\p{  Is_rjng}', "");
    Expect(0, 43359, '\p{^  Is_rjng}', "");
    Expect(0, 43359, '\P{  Is_rjng}', "");
    Expect(1, 43359, '\P{^  Is_rjng}', "");
    Expect(0, 43360, '\p{  Is_rjng}', "");
    Expect(1, 43360, '\p{^  Is_rjng}', "");
    Expect(1, 43360, '\P{  Is_rjng}', "");
    Expect(0, 43360, '\P{^  Is_rjng}', "");
    Error('\p{ 	Rumi_Numeral_symbols/a/}');
}
if (!$::TESTCHUNK or $::TESTCHUNK == 4) {
    Error('\P{ 	Rumi_Numeral_symbols/a/}');
    Expect(1, 69247, '\p{ruminumeralsymbols}', "");
    Expect(0, 69247, '\p{^ruminumeralsymbols}', "");
    Expect(0, 69247, '\P{ruminumeralsymbols}', "");
    Expect(1, 69247, '\P{^ruminumeralsymbols}', "");
    Expect(0, 69248, '\p{ruminumeralsymbols}', "");
    Expect(1, 69248, '\p{^ruminumeralsymbols}', "");
    Expect(1, 69248, '\P{ruminumeralsymbols}', "");
    Expect(0, 69248, '\P{^ruminumeralsymbols}', "");
    Expect(1, 69247, '\p{ _RUMI_NUMERAL_Symbols}', "");
    Expect(0, 69247, '\p{^ _RUMI_NUMERAL_Symbols}', "");
    Expect(0, 69247, '\P{ _RUMI_NUMERAL_Symbols}', "");
    Expect(1, 69247, '\P{^ _RUMI_NUMERAL_Symbols}', "");
    Expect(0, 69248, '\p{ _RUMI_NUMERAL_Symbols}', "");
    Expect(1, 69248, '\p{^ _RUMI_NUMERAL_Symbols}', "");
    Expect(1, 69248, '\P{ _RUMI_NUMERAL_Symbols}', "");
    Expect(0, 69248, '\P{^ _RUMI_NUMERAL_Symbols}', "");
    Error('\p{-Is_RUMI_Numeral_Symbols/a/}');
    Error('\P{-Is_RUMI_Numeral_Symbols/a/}');
    Expect(1, 69247, '\p{isruminumeralsymbols}', "");
    Expect(0, 69247, '\p{^isruminumeralsymbols}', "");
    Expect(0, 69247, '\P{isruminumeralsymbols}', "");
    Expect(1, 69247, '\P{^isruminumeralsymbols}', "");
    Expect(0, 69248, '\p{isruminumeralsymbols}', "");
    Expect(1, 69248, '\p{^isruminumeralsymbols}', "");
    Expect(1, 69248, '\P{isruminumeralsymbols}', "");
    Expect(0, 69248, '\P{^isruminumeralsymbols}', "");
    Expect(1, 69247, '\p{ Is_rumi_NUMERAL_symbols}', "");
    Expect(0, 69247, '\p{^ Is_rumi_NUMERAL_symbols}', "");
    Expect(0, 69247, '\P{ Is_rumi_NUMERAL_symbols}', "");
    Expect(1, 69247, '\P{^ Is_rumi_NUMERAL_symbols}', "");
    Expect(0, 69248, '\p{ Is_rumi_NUMERAL_symbols}', "");
    Expect(1, 69248, '\p{^ Is_rumi_NUMERAL_symbols}', "");
    Expect(1, 69248, '\P{ Is_rumi_NUMERAL_symbols}', "");
    Expect(0, 69248, '\P{^ Is_rumi_NUMERAL_symbols}', "");
    Error('\p{/a/	In_RUMI_Numeral_symbols}');
    Error('\P{/a/	In_RUMI_Numeral_symbols}');
    Expect(1, 69247, '\p{inruminumeralsymbols}', "");
    Expect(0, 69247, '\p{^inruminumeralsymbols}', "");
    Expect(0, 69247, '\P{inruminumeralsymbols}', "");
    Expect(1, 69247, '\P{^inruminumeralsymbols}', "");
    Expect(0, 69248, '\p{inruminumeralsymbols}', "");
    Expect(1, 69248, '\p{^inruminumeralsymbols}', "");
    Expect(1, 69248, '\P{inruminumeralsymbols}', "");
    Expect(0, 69248, '\P{^inruminumeralsymbols}', "");
    Expect(1, 69247, '\p{- IN_Rumi_Numeral_symbols}', "");
    Expect(0, 69247, '\p{^- IN_Rumi_Numeral_symbols}', "");
    Expect(0, 69247, '\P{- IN_Rumi_Numeral_symbols}', "");
    Expect(1, 69247, '\P{^- IN_Rumi_Numeral_symbols}', "");
    Expect(0, 69248, '\p{- IN_Rumi_Numeral_symbols}', "");
    Expect(1, 69248, '\p{^- IN_Rumi_Numeral_symbols}', "");
    Expect(1, 69248, '\P{- IN_Rumi_Numeral_symbols}', "");
    Expect(0, 69248, '\P{^- IN_Rumi_Numeral_symbols}', "");
    Error('\p{	 RUMI/a/}');
    Error('\P{	 RUMI/a/}');
    Expect(1, 69247, '\p{rumi}', "");
    Expect(0, 69247, '\p{^rumi}', "");
    Expect(0, 69247, '\P{rumi}', "");
    Expect(1, 69247, '\P{^rumi}', "");
    Expect(0, 69248, '\p{rumi}', "");
    Expect(1, 69248, '\p{^rumi}', "");
    Expect(1, 69248, '\P{rumi}', "");
    Expect(0, 69248, '\P{^rumi}', "");
    Expect(1, 69247, '\p{--rumi}', "");
    Expect(0, 69247, '\p{^--rumi}', "");
    Expect(0, 69247, '\P{--rumi}', "");
    Expect(1, 69247, '\P{^--rumi}', "");
    Expect(0, 69248, '\p{--rumi}', "");
    Expect(1, 69248, '\p{^--rumi}', "");
    Expect(1, 69248, '\P{--rumi}', "");
    Expect(0, 69248, '\P{^--rumi}', "");
    Error('\p{ 	Is_Rumi:=}');
    Error('\P{ 	Is_Rumi:=}');
    Expect(1, 69247, '\p{isrumi}', "");
    Expect(0, 69247, '\p{^isrumi}', "");
    Expect(0, 69247, '\P{isrumi}', "");
    Expect(1, 69247, '\P{^isrumi}', "");
    Expect(0, 69248, '\p{isrumi}', "");
    Expect(1, 69248, '\p{^isrumi}', "");
    Expect(1, 69248, '\P{isrumi}', "");
    Expect(0, 69248, '\P{^isrumi}', "");
    Expect(1, 69247, '\p{_is_rumi}', "");
    Expect(0, 69247, '\p{^_is_rumi}', "");
    Expect(0, 69247, '\P{_is_rumi}', "");
    Expect(1, 69247, '\P{^_is_rumi}', "");
    Expect(0, 69248, '\p{_is_rumi}', "");
    Expect(1, 69248, '\p{^_is_rumi}', "");
    Expect(1, 69248, '\P{_is_rumi}', "");
    Expect(0, 69248, '\P{^_is_rumi}', "");
    Error('\p{-_in_rumi/a/}');
    Error('\P{-_in_rumi/a/}');
    Expect(1, 69247, '\p{inrumi}', "");
    Expect(0, 69247, '\p{^inrumi}', "");
    Expect(0, 69247, '\P{inrumi}', "");
    Expect(1, 69247, '\P{^inrumi}', "");
    Expect(0, 69248, '\p{inrumi}', "");
    Expect(1, 69248, '\p{^inrumi}', "");
    Expect(1, 69248, '\P{inrumi}', "");
    Expect(0, 69248, '\P{^inrumi}', "");
    Expect(1, 69247, '\p{-	In_RUMI}', "");
    Expect(0, 69247, '\p{^-	In_RUMI}', "");
    Expect(0, 69247, '\P{-	In_RUMI}', "");
    Expect(1, 69247, '\P{^-	In_RUMI}', "");
    Expect(0, 69248, '\p{-	In_RUMI}', "");
    Expect(1, 69248, '\p{^-	In_RUMI}', "");
    Expect(1, 69248, '\P{-	In_RUMI}', "");
    Expect(0, 69248, '\P{^-	In_RUMI}', "");
    Error('\p{  Runic/a/}');
    Error('\P{  Runic/a/}');
    Expect(1, 5880, '\p{runic}', "");
    Expect(0, 5880, '\p{^runic}', "");
    Expect(0, 5880, '\P{runic}', "");
    Expect(1, 5880, '\P{^runic}', "");
    Expect(0, 5881, '\p{runic}', "");
    Expect(1, 5881, '\p{^runic}', "");
    Expect(1, 5881, '\P{runic}', "");
    Expect(0, 5881, '\P{^runic}', "");
    Expect(1, 5880, '\p{ 	RUNIC}', "");
    Expect(0, 5880, '\p{^ 	RUNIC}', "");
    Expect(0, 5880, '\P{ 	RUNIC}', "");
    Expect(1, 5880, '\P{^ 	RUNIC}', "");
    Expect(0, 5881, '\p{ 	RUNIC}', "");
    Expect(1, 5881, '\p{^ 	RUNIC}', "");
    Expect(1, 5881, '\P{ 	RUNIC}', "");
    Expect(0, 5881, '\P{^ 	RUNIC}', "");
    Error('\p{ _Is_runic:=}');
    Error('\P{ _Is_runic:=}');
    Expect(1, 5880, '\p{isrunic}', "");
    Expect(0, 5880, '\p{^isrunic}', "");
    Expect(0, 5880, '\P{isrunic}', "");
    Expect(1, 5880, '\P{^isrunic}', "");
    Expect(0, 5881, '\p{isrunic}', "");
    Expect(1, 5881, '\p{^isrunic}', "");
    Expect(1, 5881, '\P{isrunic}', "");
    Expect(0, 5881, '\P{^isrunic}', "");
    Expect(1, 5880, '\p{-_Is_runic}', "");
    Expect(0, 5880, '\p{^-_Is_runic}', "");
    Expect(0, 5880, '\P{-_Is_runic}', "");
    Expect(1, 5880, '\P{^-_Is_runic}', "");
    Expect(0, 5881, '\p{-_Is_runic}', "");
    Expect(1, 5881, '\p{^-_Is_runic}', "");
    Expect(1, 5881, '\P{-_Is_runic}', "");
    Expect(0, 5881, '\P{^-_Is_runic}', "");
    Error('\p{_/a/runr}');
    Error('\P{_/a/runr}');
    Expect(1, 5880, '\p{runr}', "");
    Expect(0, 5880, '\p{^runr}', "");
    Expect(0, 5880, '\P{runr}', "");
    Expect(1, 5880, '\P{^runr}', "");
    Expect(0, 5881, '\p{runr}', "");
    Expect(1, 5881, '\p{^runr}', "");
    Expect(1, 5881, '\P{runr}', "");
    Expect(0, 5881, '\P{^runr}', "");
    Expect(1, 5880, '\p{_	runr}', "");
    Expect(0, 5880, '\p{^_	runr}', "");
    Expect(0, 5880, '\P{_	runr}', "");
    Expect(1, 5880, '\P{^_	runr}', "");
    Expect(0, 5881, '\p{_	runr}', "");
    Expect(1, 5881, '\p{^_	runr}', "");
    Expect(1, 5881, '\P{_	runr}', "");
    Expect(0, 5881, '\P{^_	runr}', "");
    Error('\p{-/a/Is_Runr}');
    Error('\P{-/a/Is_Runr}');
    Expect(1, 5880, '\p{isrunr}', "");
    Expect(0, 5880, '\p{^isrunr}', "");
    Expect(0, 5880, '\P{isrunr}', "");
    Expect(1, 5880, '\P{^isrunr}', "");
    Expect(0, 5881, '\p{isrunr}', "");
    Expect(1, 5881, '\p{^isrunr}', "");
    Expect(1, 5881, '\P{isrunr}', "");
    Expect(0, 5881, '\P{^isrunr}', "");
    Expect(1, 5880, '\p{ Is_Runr}', "");
    Expect(0, 5880, '\p{^ Is_Runr}', "");
    Expect(0, 5880, '\P{ Is_Runr}', "");
    Expect(1, 5880, '\P{^ Is_Runr}', "");
    Expect(0, 5881, '\p{ Is_Runr}', "");
    Expect(1, 5881, '\p{^ Is_Runr}', "");
    Expect(1, 5881, '\P{ Is_Runr}', "");
    Expect(0, 5881, '\P{^ Is_Runr}', "");
    Error('\p{_/a/Samaritan}');
    Error('\P{_/a/Samaritan}');
    Expect(1, 2110, '\p{samaritan}', "");
    Expect(0, 2110, '\p{^samaritan}', "");
    Expect(0, 2110, '\P{samaritan}', "");
    Expect(1, 2110, '\P{^samaritan}', "");
    Expect(0, 2111, '\p{samaritan}', "");
    Expect(1, 2111, '\p{^samaritan}', "");
    Expect(1, 2111, '\P{samaritan}', "");
    Expect(0, 2111, '\P{^samaritan}', "");
    Expect(1, 2110, '\p{_ samaritan}', "");
    Expect(0, 2110, '\p{^_ samaritan}', "");
    Expect(0, 2110, '\P{_ samaritan}', "");
    Expect(1, 2110, '\P{^_ samaritan}', "");
    Expect(0, 2111, '\p{_ samaritan}', "");
    Expect(1, 2111, '\p{^_ samaritan}', "");
    Expect(1, 2111, '\P{_ samaritan}', "");
    Expect(0, 2111, '\P{^_ samaritan}', "");
    Error('\p{/a/IS_samaritan}');
    Error('\P{/a/IS_samaritan}');
    Expect(1, 2110, '\p{issamaritan}', "");
    Expect(0, 2110, '\p{^issamaritan}', "");
    Expect(0, 2110, '\P{issamaritan}', "");
    Expect(1, 2110, '\P{^issamaritan}', "");
    Expect(0, 2111, '\p{issamaritan}', "");
    Expect(1, 2111, '\p{^issamaritan}', "");
    Expect(1, 2111, '\P{issamaritan}', "");
    Expect(0, 2111, '\P{^issamaritan}', "");
    Expect(1, 2110, '\p{_-IS_Samaritan}', "");
    Expect(0, 2110, '\p{^_-IS_Samaritan}', "");
    Expect(0, 2110, '\P{_-IS_Samaritan}', "");
    Expect(1, 2110, '\P{^_-IS_Samaritan}', "");
    Expect(0, 2111, '\p{_-IS_Samaritan}', "");
    Expect(1, 2111, '\p{^_-IS_Samaritan}', "");
    Expect(1, 2111, '\P{_-IS_Samaritan}', "");
    Expect(0, 2111, '\P{^_-IS_Samaritan}', "");
    Error('\p{_/a/Samr}');
    Error('\P{_/a/Samr}');
    Expect(1, 2110, '\p{samr}', "");
    Expect(0, 2110, '\p{^samr}', "");
    Expect(0, 2110, '\P{samr}', "");
    Expect(1, 2110, '\P{^samr}', "");
    Expect(0, 2111, '\p{samr}', "");
    Expect(1, 2111, '\p{^samr}', "");
    Expect(1, 2111, '\P{samr}', "");
    Expect(0, 2111, '\P{^samr}', "");
    Expect(1, 2110, '\p{- Samr}', "");
    Expect(0, 2110, '\p{^- Samr}', "");
    Expect(0, 2110, '\P{- Samr}', "");
    Expect(1, 2110, '\P{^- Samr}', "");
    Expect(0, 2111, '\p{- Samr}', "");
    Expect(1, 2111, '\p{^- Samr}', "");
    Expect(1, 2111, '\P{- Samr}', "");
    Expect(0, 2111, '\P{^- Samr}', "");
    Error('\p{  Is_SAMR:=}');
    Error('\P{  Is_SAMR:=}');
    Expect(1, 2110, '\p{issamr}', "");
    Expect(0, 2110, '\p{^issamr}', "");
    Expect(0, 2110, '\P{issamr}', "");
    Expect(1, 2110, '\P{^issamr}', "");
    Expect(0, 2111, '\p{issamr}', "");
    Expect(1, 2111, '\p{^issamr}', "");
    Expect(1, 2111, '\P{issamr}', "");
    Expect(0, 2111, '\P{^issamr}', "");
    Expect(1, 2110, '\p{ IS_Samr}', "");
    Expect(0, 2110, '\p{^ IS_Samr}', "");
    Expect(0, 2110, '\P{ IS_Samr}', "");
    Expect(1, 2110, '\P{^ IS_Samr}', "");
    Expect(0, 2111, '\p{ IS_Samr}', "");
    Expect(1, 2111, '\p{^ IS_Samr}', "");
    Expect(1, 2111, '\P{ IS_Samr}', "");
    Expect(0, 2111, '\P{^ IS_Samr}', "");
    Error('\p{:=-SAURASHTRA}');
    Error('\P{:=-SAURASHTRA}');
    Expect(1, 43225, '\p{saurashtra}', "");
    Expect(0, 43225, '\p{^saurashtra}', "");
    Expect(0, 43225, '\P{saurashtra}', "");
    Expect(1, 43225, '\P{^saurashtra}', "");
    Expect(0, 43226, '\p{saurashtra}', "");
    Expect(1, 43226, '\p{^saurashtra}', "");
    Expect(1, 43226, '\P{saurashtra}', "");
    Expect(0, 43226, '\P{^saurashtra}', "");
    Expect(1, 43225, '\p{ Saurashtra}', "");
    Expect(0, 43225, '\p{^ Saurashtra}', "");
    Expect(0, 43225, '\P{ Saurashtra}', "");
    Expect(1, 43225, '\P{^ Saurashtra}', "");
    Expect(0, 43226, '\p{ Saurashtra}', "");
    Expect(1, 43226, '\p{^ Saurashtra}', "");
    Expect(1, 43226, '\P{ Saurashtra}', "");
    Expect(0, 43226, '\P{^ Saurashtra}', "");
    Error('\p{  Is_saurashtra/a/}');
    Error('\P{  Is_saurashtra/a/}');
    Expect(1, 43225, '\p{issaurashtra}', "");
    Expect(0, 43225, '\p{^issaurashtra}', "");
    Expect(0, 43225, '\P{issaurashtra}', "");
    Expect(1, 43225, '\P{^issaurashtra}', "");
    Expect(0, 43226, '\p{issaurashtra}', "");
    Expect(1, 43226, '\p{^issaurashtra}', "");
    Expect(1, 43226, '\P{issaurashtra}', "");
    Expect(0, 43226, '\P{^issaurashtra}', "");
    Expect(1, 43225, '\p{__Is_SAURASHTRA}', "");
    Expect(0, 43225, '\p{^__Is_SAURASHTRA}', "");
    Expect(0, 43225, '\P{__Is_SAURASHTRA}', "");
    Expect(1, 43225, '\P{^__Is_SAURASHTRA}', "");
    Expect(0, 43226, '\p{__Is_SAURASHTRA}', "");
    Expect(1, 43226, '\p{^__Is_SAURASHTRA}', "");
    Expect(1, 43226, '\P{__Is_SAURASHTRA}', "");
    Expect(0, 43226, '\P{^__Is_SAURASHTRA}', "");
    Error('\p{_	Saur:=}');
    Error('\P{_	Saur:=}');
    Expect(1, 43225, '\p{saur}', "");
    Expect(0, 43225, '\p{^saur}', "");
    Expect(0, 43225, '\P{saur}', "");
    Expect(1, 43225, '\P{^saur}', "");
    Expect(0, 43226, '\p{saur}', "");
    Expect(1, 43226, '\p{^saur}', "");
    Expect(1, 43226, '\P{saur}', "");
    Expect(0, 43226, '\P{^saur}', "");
    Expect(1, 43225, '\p{_ SAUR}', "");
    Expect(0, 43225, '\p{^_ SAUR}', "");
    Expect(0, 43225, '\P{_ SAUR}', "");
    Expect(1, 43225, '\P{^_ SAUR}', "");
    Expect(0, 43226, '\p{_ SAUR}', "");
    Expect(1, 43226, '\p{^_ SAUR}', "");
    Expect(1, 43226, '\P{_ SAUR}', "");
    Expect(0, 43226, '\P{^_ SAUR}', "");
    Error('\p{/a/Is_Saur}');
    Error('\P{/a/Is_Saur}');
    Expect(1, 43225, '\p{issaur}', "");
    Expect(0, 43225, '\p{^issaur}', "");
    Expect(0, 43225, '\P{issaur}', "");
    Expect(1, 43225, '\P{^issaur}', "");
    Expect(0, 43226, '\p{issaur}', "");
    Expect(1, 43226, '\p{^issaur}', "");
    Expect(1, 43226, '\P{issaur}', "");
    Expect(0, 43226, '\P{^issaur}', "");
    Expect(1, 43225, '\p{_	IS_Saur}', "");
    Expect(0, 43225, '\p{^_	IS_Saur}', "");
    Expect(0, 43225, '\P{_	IS_Saur}', "");
    Expect(1, 43225, '\P{^_	IS_Saur}', "");
    Expect(0, 43226, '\p{_	IS_Saur}', "");
    Expect(1, 43226, '\p{^_	IS_Saur}', "");
    Expect(1, 43226, '\P{_	IS_Saur}', "");
    Expect(0, 43226, '\P{^_	IS_Saur}', "");
    Error('\p{/a/		sentence_terminal}');
    Error('\P{/a/		sentence_terminal}');
    Expect(1, 121480, '\p{sentenceterminal}', "");
    Expect(0, 121480, '\p{^sentenceterminal}', "");
    Expect(0, 121480, '\P{sentenceterminal}', "");
    Expect(1, 121480, '\P{^sentenceterminal}', "");
    Expect(0, 121481, '\p{sentenceterminal}', "");
    Expect(1, 121481, '\p{^sentenceterminal}', "");
    Expect(1, 121481, '\P{sentenceterminal}', "");
    Expect(0, 121481, '\P{^sentenceterminal}', "");
    Expect(1, 121480, '\p{ _sentence_TERMINAL}', "");
    Expect(0, 121480, '\p{^ _sentence_TERMINAL}', "");
    Expect(0, 121480, '\P{ _sentence_TERMINAL}', "");
    Expect(1, 121480, '\P{^ _sentence_TERMINAL}', "");
    Expect(0, 121481, '\p{ _sentence_TERMINAL}', "");
    Expect(1, 121481, '\p{^ _sentence_TERMINAL}', "");
    Expect(1, 121481, '\P{ _sentence_TERMINAL}', "");
    Expect(0, 121481, '\P{^ _sentence_TERMINAL}', "");
    Error('\p{_Is_SENTENCE_terminal/a/}');
    Error('\P{_Is_SENTENCE_terminal/a/}');
    Expect(1, 121480, '\p{issentenceterminal}', "");
    Expect(0, 121480, '\p{^issentenceterminal}', "");
    Expect(0, 121480, '\P{issentenceterminal}', "");
    Expect(1, 121480, '\P{^issentenceterminal}', "");
    Expect(0, 121481, '\p{issentenceterminal}', "");
    Expect(1, 121481, '\p{^issentenceterminal}', "");
    Expect(1, 121481, '\P{issentenceterminal}', "");
    Expect(0, 121481, '\P{^issentenceterminal}', "");
    Expect(1, 121480, '\p{is_Sentence_Terminal}', "");
    Expect(0, 121480, '\p{^is_Sentence_Terminal}', "");
    Expect(0, 121480, '\P{is_Sentence_Terminal}', "");
    Expect(1, 121480, '\P{^is_Sentence_Terminal}', "");
    Expect(0, 121481, '\p{is_Sentence_Terminal}', "");
    Expect(1, 121481, '\p{^is_Sentence_Terminal}', "");
    Expect(1, 121481, '\P{is_Sentence_Terminal}', "");
    Expect(0, 121481, '\P{^is_Sentence_Terminal}', "");
    Error('\p{	STerm/a/}');
    Error('\P{	STerm/a/}');
    Expect(1, 121480, '\p{sterm}', "");
    Expect(0, 121480, '\p{^sterm}', "");
    Expect(0, 121480, '\P{sterm}', "");
    Expect(1, 121480, '\P{^sterm}', "");
    Expect(0, 121481, '\p{sterm}', "");
    Expect(1, 121481, '\p{^sterm}', "");
    Expect(1, 121481, '\P{sterm}', "");
    Expect(0, 121481, '\P{^sterm}', "");
    Expect(1, 121480, '\p{- STERM}', "");
    Expect(0, 121480, '\p{^- STERM}', "");
    Expect(0, 121480, '\P{- STERM}', "");
    Expect(1, 121480, '\P{^- STERM}', "");
    Expect(0, 121481, '\p{- STERM}', "");
    Expect(1, 121481, '\p{^- STERM}', "");
    Expect(1, 121481, '\P{- STERM}', "");
    Expect(0, 121481, '\P{^- STERM}', "");
    Error('\p{ 	Is_STerm/a/}');
    Error('\P{ 	Is_STerm/a/}');
    Expect(1, 121480, '\p{issterm}', "");
    Expect(0, 121480, '\p{^issterm}', "");
    Expect(0, 121480, '\P{issterm}', "");
    Expect(1, 121480, '\P{^issterm}', "");
    Expect(0, 121481, '\p{issterm}', "");
    Expect(1, 121481, '\p{^issterm}', "");
    Expect(1, 121481, '\P{issterm}', "");
    Expect(0, 121481, '\P{^issterm}', "");
    Expect(1, 121480, '\p{_IS_sterm}', "");
    Expect(0, 121480, '\p{^_IS_sterm}', "");
    Expect(0, 121480, '\P{_IS_sterm}', "");
    Expect(1, 121480, '\P{^_IS_sterm}', "");
    Expect(0, 121481, '\p{_IS_sterm}', "");
    Expect(1, 121481, '\p{^_IS_sterm}', "");
    Expect(1, 121481, '\P{_IS_sterm}', "");
    Expect(0, 121481, '\P{^_IS_sterm}', "");
    Error('\p{/a/ _Separator}');
    Error('\P{/a/ _Separator}');
    Expect(1, 12288, '\p{separator}', "");
    Expect(0, 12288, '\p{^separator}', "");
    Expect(0, 12288, '\P{separator}', "");
    Expect(1, 12288, '\P{^separator}', "");
    Expect(0, 12289, '\p{separator}', "");
    Expect(1, 12289, '\p{^separator}', "");
    Expect(1, 12289, '\P{separator}', "");
    Expect(0, 12289, '\P{^separator}', "");
    Expect(1, 12288, '\p{- SEPARATOR}', "");
    Expect(0, 12288, '\p{^- SEPARATOR}', "");
    Expect(0, 12288, '\P{- SEPARATOR}', "");
    Expect(1, 12288, '\P{^- SEPARATOR}', "");
    Expect(0, 12289, '\p{- SEPARATOR}', "");
    Expect(1, 12289, '\p{^- SEPARATOR}', "");
    Expect(1, 12289, '\P{- SEPARATOR}', "");
    Expect(0, 12289, '\P{^- SEPARATOR}', "");
    Error('\p{/a/  is_Separator}');
    Error('\P{/a/  is_Separator}');
    Expect(1, 12288, '\p{isseparator}', "");
    Expect(0, 12288, '\p{^isseparator}', "");
    Expect(0, 12288, '\P{isseparator}', "");
    Expect(1, 12288, '\P{^isseparator}', "");
    Expect(0, 12289, '\p{isseparator}', "");
    Expect(1, 12289, '\p{^isseparator}', "");
    Expect(1, 12289, '\P{isseparator}', "");
    Expect(0, 12289, '\P{^isseparator}', "");
    Expect(1, 12288, '\p{		Is_separator}', "");
    Expect(0, 12288, '\p{^		Is_separator}', "");
    Expect(0, 12288, '\P{		Is_separator}', "");
    Expect(1, 12288, '\P{^		Is_separator}', "");
    Expect(0, 12289, '\p{		Is_separator}', "");
    Expect(1, 12289, '\p{^		Is_separator}', "");
    Expect(1, 12289, '\P{		Is_separator}', "");
    Expect(0, 12289, '\P{^		Is_separator}', "");
    Error('\p{/a/	 Z}');
    Error('\P{/a/	 Z}');
    Expect(1, 12288, '\p{z}', "");
    Expect(0, 12288, '\p{^z}', "");
    Expect(0, 12288, '\P{z}', "");
    Expect(1, 12288, '\P{^z}', "");
    Expect(0, 12289, '\p{z}', "");
    Expect(1, 12289, '\p{^z}', "");
    Expect(1, 12289, '\P{z}', "");
    Expect(0, 12289, '\P{^z}', "");
    Expect(1, 12288, '\p{ 	Z}', "");
    Expect(0, 12288, '\p{^ 	Z}', "");
    Expect(0, 12288, '\P{ 	Z}', "");
    Expect(1, 12288, '\P{^ 	Z}', "");
    Expect(0, 12289, '\p{ 	Z}', "");
    Expect(1, 12289, '\p{^ 	Z}', "");
    Expect(1, 12289, '\P{ 	Z}', "");
    Expect(0, 12289, '\P{^ 	Z}', "");
    Error('\p{/a/ 	Is_Z}');
    Error('\P{/a/ 	Is_Z}');
    Expect(1, 12288, '\p{isz}', "");
    Expect(0, 12288, '\p{^isz}', "");
    Expect(0, 12288, '\P{isz}', "");
    Expect(1, 12288, '\P{^isz}', "");
    Expect(0, 12289, '\p{isz}', "");
    Expect(1, 12289, '\p{^isz}', "");
    Expect(1, 12289, '\P{isz}', "");
    Expect(0, 12289, '\P{^isz}', "");
    Expect(1, 12288, '\p{_is_Z}', "");
    Expect(0, 12288, '\p{^_is_Z}', "");
    Expect(0, 12288, '\P{_is_Z}', "");
    Expect(1, 12288, '\P{^_is_Z}', "");
    Expect(0, 12289, '\p{_is_Z}', "");
    Expect(1, 12289, '\p{^_is_Z}', "");
    Expect(1, 12289, '\P{_is_Z}', "");
    Expect(0, 12289, '\P{^_is_Z}', "");
    Error('\p{/a/	_sharada}');
    Error('\P{/a/	_sharada}');
    Expect(1, 70111, '\p{sharada}', "");
    Expect(0, 70111, '\p{^sharada}', "");
    Expect(0, 70111, '\P{sharada}', "");
    Expect(1, 70111, '\P{^sharada}', "");
    Expect(0, 70112, '\p{sharada}', "");
    Expect(1, 70112, '\p{^sharada}', "");
    Expect(1, 70112, '\P{sharada}', "");
    Expect(0, 70112, '\P{^sharada}', "");
    Expect(1, 70111, '\p{		Sharada}', "");
    Expect(0, 70111, '\p{^		Sharada}', "");
    Expect(0, 70111, '\P{		Sharada}', "");
    Expect(1, 70111, '\P{^		Sharada}', "");
    Expect(0, 70112, '\p{		Sharada}', "");
    Expect(1, 70112, '\p{^		Sharada}', "");
    Expect(1, 70112, '\P{		Sharada}', "");
    Expect(0, 70112, '\P{^		Sharada}', "");
    Error('\p{_:=Is_sharada}');
    Error('\P{_:=Is_sharada}');
    Expect(1, 70111, '\p{issharada}', "");
    Expect(0, 70111, '\p{^issharada}', "");
    Expect(0, 70111, '\P{issharada}', "");
    Expect(1, 70111, '\P{^issharada}', "");
    Expect(0, 70112, '\p{issharada}', "");
    Expect(1, 70112, '\p{^issharada}', "");
    Expect(1, 70112, '\P{issharada}', "");
    Expect(0, 70112, '\P{^issharada}', "");
    Expect(1, 70111, '\p{is_sharada}', "");
    Expect(0, 70111, '\p{^is_sharada}', "");
    Expect(0, 70111, '\P{is_sharada}', "");
    Expect(1, 70111, '\P{^is_sharada}', "");
    Expect(0, 70112, '\p{is_sharada}', "");
    Expect(1, 70112, '\p{^is_sharada}', "");
    Expect(1, 70112, '\P{is_sharada}', "");
    Expect(0, 70112, '\P{^is_sharada}', "");
    Error('\p{	_shrd:=}');
    Error('\P{	_shrd:=}');
    Expect(1, 70111, '\p{shrd}', "");
    Expect(0, 70111, '\p{^shrd}', "");
    Expect(0, 70111, '\P{shrd}', "");
    Expect(1, 70111, '\P{^shrd}', "");
    Expect(0, 70112, '\p{shrd}', "");
    Expect(1, 70112, '\p{^shrd}', "");
    Expect(1, 70112, '\P{shrd}', "");
    Expect(0, 70112, '\P{^shrd}', "");
    Expect(1, 70111, '\p{-	Shrd}', "");
    Expect(0, 70111, '\p{^-	Shrd}', "");
    Expect(0, 70111, '\P{-	Shrd}', "");
    Expect(1, 70111, '\P{^-	Shrd}', "");
    Expect(0, 70112, '\p{-	Shrd}', "");
    Expect(1, 70112, '\p{^-	Shrd}', "");
    Expect(1, 70112, '\P{-	Shrd}', "");
    Expect(0, 70112, '\P{^-	Shrd}', "");
    Error('\p{-:=Is_Shrd}');
    Error('\P{-:=Is_Shrd}');
    Expect(1, 70111, '\p{isshrd}', "");
    Expect(0, 70111, '\p{^isshrd}', "");
    Expect(0, 70111, '\P{isshrd}', "");
    Expect(1, 70111, '\P{^isshrd}', "");
    Expect(0, 70112, '\p{isshrd}', "");
    Expect(1, 70112, '\p{^isshrd}', "");
    Expect(1, 70112, '\P{isshrd}', "");
    Expect(0, 70112, '\P{^isshrd}', "");
    Expect(1, 70111, '\p{- IS_Shrd}', "");
    Expect(0, 70111, '\p{^- IS_Shrd}', "");
    Expect(0, 70111, '\P{- IS_Shrd}', "");
    Expect(1, 70111, '\P{^- IS_Shrd}', "");
    Expect(0, 70112, '\p{- IS_Shrd}', "");
    Expect(1, 70112, '\p{^- IS_Shrd}', "");
    Expect(1, 70112, '\P{- IS_Shrd}', "");
    Expect(0, 70112, '\P{^- IS_Shrd}', "");
    Error('\p{	SHAVIAN/a/}');
    Error('\P{	SHAVIAN/a/}');
    Expect(1, 66687, '\p{shavian}', "");
    Expect(0, 66687, '\p{^shavian}', "");
    Expect(0, 66687, '\P{shavian}', "");
    Expect(1, 66687, '\P{^shavian}', "");
    Expect(0, 66688, '\p{shavian}', "");
    Expect(1, 66688, '\p{^shavian}', "");
    Expect(1, 66688, '\P{shavian}', "");
    Expect(0, 66688, '\P{^shavian}', "");
    Expect(1, 66687, '\p{-_Shavian}', "");
    Expect(0, 66687, '\p{^-_Shavian}', "");
    Expect(0, 66687, '\P{-_Shavian}', "");
    Expect(1, 66687, '\P{^-_Shavian}', "");
    Expect(0, 66688, '\p{-_Shavian}', "");
    Expect(1, 66688, '\p{^-_Shavian}', "");
    Expect(1, 66688, '\P{-_Shavian}', "");
    Expect(0, 66688, '\P{^-_Shavian}', "");
    Error('\p{/a/Is_SHAVIAN}');
    Error('\P{/a/Is_SHAVIAN}');
    Expect(1, 66687, '\p{isshavian}', "");
    Expect(0, 66687, '\p{^isshavian}', "");
    Expect(0, 66687, '\P{isshavian}', "");
    Expect(1, 66687, '\P{^isshavian}', "");
    Expect(0, 66688, '\p{isshavian}', "");
    Expect(1, 66688, '\p{^isshavian}', "");
    Expect(1, 66688, '\P{isshavian}', "");
    Expect(0, 66688, '\P{^isshavian}', "");
    Expect(1, 66687, '\p{__is_shavian}', "");
    Expect(0, 66687, '\p{^__is_shavian}', "");
    Expect(0, 66687, '\P{__is_shavian}', "");
    Expect(1, 66687, '\P{^__is_shavian}', "");
    Expect(0, 66688, '\p{__is_shavian}', "");
    Expect(1, 66688, '\p{^__is_shavian}', "");
    Expect(1, 66688, '\P{__is_shavian}', "");
    Expect(0, 66688, '\P{^__is_shavian}', "");
    Error('\p{:=	_SHAW}');
    Error('\P{:=	_SHAW}');
    Expect(1, 66687, '\p{shaw}', "");
    Expect(0, 66687, '\p{^shaw}', "");
    Expect(0, 66687, '\P{shaw}', "");
    Expect(1, 66687, '\P{^shaw}', "");
    Expect(0, 66688, '\p{shaw}', "");
    Expect(1, 66688, '\p{^shaw}', "");
    Expect(1, 66688, '\P{shaw}', "");
    Expect(0, 66688, '\P{^shaw}', "");
    Error('\p{--is_Shaw/a/}');
    Error('\P{--is_Shaw/a/}');
    Expect(1, 66687, '\p{isshaw}', "");
    Expect(0, 66687, '\p{^isshaw}', "");
    Expect(0, 66687, '\P{isshaw}', "");
    Expect(1, 66687, '\P{^isshaw}', "");
    Expect(0, 66688, '\p{isshaw}', "");
    Expect(1, 66688, '\p{^isshaw}', "");
    Expect(1, 66688, '\P{isshaw}', "");
    Expect(0, 66688, '\P{^isshaw}', "");
    Expect(1, 66687, '\p{_-IS_SHAW}', "");
    Expect(0, 66687, '\p{^_-IS_SHAW}', "");
    Expect(0, 66687, '\P{_-IS_SHAW}', "");
    Expect(1, 66687, '\P{^_-IS_SHAW}', "");
    Expect(0, 66688, '\p{_-IS_SHAW}', "");
    Expect(1, 66688, '\p{^_-IS_SHAW}', "");
    Expect(1, 66688, '\P{_-IS_SHAW}', "");
    Expect(0, 66688, '\P{^_-IS_SHAW}', "");
    Error('\p{/a/	Shorthand_FORMAT_Controls}');
    Error('\P{/a/	Shorthand_FORMAT_Controls}');
    Expect(1, 113839, '\p{shorthandformatcontrols}', "");
    Expect(0, 113839, '\p{^shorthandformatcontrols}', "");
    Expect(0, 113839, '\P{shorthandformatcontrols}', "");
    Expect(1, 113839, '\P{^shorthandformatcontrols}', "");
    Expect(0, 113840, '\p{shorthandformatcontrols}', "");
    Expect(1, 113840, '\p{^shorthandformatcontrols}', "");
    Expect(1, 113840, '\P{shorthandformatcontrols}', "");
    Expect(0, 113840, '\P{^shorthandformatcontrols}', "");
    Expect(1, 113839, '\p{-_SHORTHAND_format_Controls}', "");
    Expect(0, 113839, '\p{^-_SHORTHAND_format_Controls}', "");
    Expect(0, 113839, '\P{-_SHORTHAND_format_Controls}', "");
    Expect(1, 113839, '\P{^-_SHORTHAND_format_Controls}', "");
    Expect(0, 113840, '\p{-_SHORTHAND_format_Controls}', "");
    Expect(1, 113840, '\p{^-_SHORTHAND_format_Controls}', "");
    Expect(1, 113840, '\P{-_SHORTHAND_format_Controls}', "");
    Expect(0, 113840, '\P{^-_SHORTHAND_format_Controls}', "");
    Error('\p{	:=Is_Shorthand_Format_controls}');
    Error('\P{	:=Is_Shorthand_Format_controls}');
    Expect(1, 113839, '\p{isshorthandformatcontrols}', "");
    Expect(0, 113839, '\p{^isshorthandformatcontrols}', "");
    Expect(0, 113839, '\P{isshorthandformatcontrols}', "");
    Expect(1, 113839, '\P{^isshorthandformatcontrols}', "");
    Expect(0, 113840, '\p{isshorthandformatcontrols}', "");
    Expect(1, 113840, '\p{^isshorthandformatcontrols}', "");
    Expect(1, 113840, '\P{isshorthandformatcontrols}', "");
    Expect(0, 113840, '\P{^isshorthandformatcontrols}', "");
    Expect(1, 113839, '\p{ is_shorthand_format_CONTROLS}', "");
    Expect(0, 113839, '\p{^ is_shorthand_format_CONTROLS}', "");
    Expect(0, 113839, '\P{ is_shorthand_format_CONTROLS}', "");
    Expect(1, 113839, '\P{^ is_shorthand_format_CONTROLS}', "");
    Expect(0, 113840, '\p{ is_shorthand_format_CONTROLS}', "");
    Expect(1, 113840, '\p{^ is_shorthand_format_CONTROLS}', "");
    Expect(1, 113840, '\P{ is_shorthand_format_CONTROLS}', "");
    Expect(0, 113840, '\P{^ is_shorthand_format_CONTROLS}', "");
    Error('\p{- In_Shorthand_format_CONTROLS:=}');
    Error('\P{- In_Shorthand_format_CONTROLS:=}');
    Expect(1, 113839, '\p{inshorthandformatcontrols}', "");
    Expect(0, 113839, '\p{^inshorthandformatcontrols}', "");
    Expect(0, 113839, '\P{inshorthandformatcontrols}', "");
    Expect(1, 113839, '\P{^inshorthandformatcontrols}', "");
    Expect(0, 113840, '\p{inshorthandformatcontrols}', "");
    Expect(1, 113840, '\p{^inshorthandformatcontrols}', "");
    Expect(1, 113840, '\P{inshorthandformatcontrols}', "");
    Expect(0, 113840, '\P{^inshorthandformatcontrols}', "");
    Expect(1, 113839, '\p{-IN_SHORTHAND_Format_Controls}', "");
    Expect(0, 113839, '\p{^-IN_SHORTHAND_Format_Controls}', "");
    Expect(0, 113839, '\P{-IN_SHORTHAND_Format_Controls}', "");
    Expect(1, 113839, '\P{^-IN_SHORTHAND_Format_Controls}', "");
    Expect(0, 113840, '\p{-IN_SHORTHAND_Format_Controls}', "");
    Expect(1, 113840, '\p{^-IN_SHORTHAND_Format_Controls}', "");
    Expect(1, 113840, '\P{-IN_SHORTHAND_Format_Controls}', "");
    Expect(0, 113840, '\P{^-IN_SHORTHAND_Format_Controls}', "");
    Error('\p{		SIDDHAM:=}');
    Error('\P{		SIDDHAM:=}');
    Expect(1, 71133, '\p{siddham}', "");
    Expect(0, 71133, '\p{^siddham}', "");
    Expect(0, 71133, '\P{siddham}', "");
    Expect(1, 71133, '\P{^siddham}', "");
    Expect(0, 71134, '\p{siddham}', "");
    Expect(1, 71134, '\p{^siddham}', "");
    Expect(1, 71134, '\P{siddham}', "");
    Expect(0, 71134, '\P{^siddham}', "");
    Expect(1, 71133, '\p{ 	Siddham}', "");
    Expect(0, 71133, '\p{^ 	Siddham}', "");
    Expect(0, 71133, '\P{ 	Siddham}', "");
    Expect(1, 71133, '\P{^ 	Siddham}', "");
    Expect(0, 71134, '\p{ 	Siddham}', "");
    Expect(1, 71134, '\p{^ 	Siddham}', "");
    Expect(1, 71134, '\P{ 	Siddham}', "");
    Expect(0, 71134, '\P{^ 	Siddham}', "");
    Error('\p{/a/-_Is_Siddham}');
    Error('\P{/a/-_Is_Siddham}');
    Expect(1, 71133, '\p{issiddham}', "");
    Expect(0, 71133, '\p{^issiddham}', "");
    Expect(0, 71133, '\P{issiddham}', "");
    Expect(1, 71133, '\P{^issiddham}', "");
    Expect(0, 71134, '\p{issiddham}', "");
    Expect(1, 71134, '\p{^issiddham}', "");
    Expect(1, 71134, '\P{issiddham}', "");
    Expect(0, 71134, '\P{^issiddham}', "");
    Expect(1, 71133, '\p{	-IS_SIDDHAM}', "");
    Expect(0, 71133, '\p{^	-IS_SIDDHAM}', "");
    Expect(0, 71133, '\P{	-IS_SIDDHAM}', "");
    Expect(1, 71133, '\P{^	-IS_SIDDHAM}', "");
    Expect(0, 71134, '\p{	-IS_SIDDHAM}', "");
    Expect(1, 71134, '\p{^	-IS_SIDDHAM}', "");
    Expect(1, 71134, '\P{	-IS_SIDDHAM}', "");
    Expect(0, 71134, '\P{^	-IS_SIDDHAM}', "");
    Error('\p{/a/--Sidd}');
    Error('\P{/a/--Sidd}');
    Expect(1, 71133, '\p{sidd}', "");
    Expect(0, 71133, '\p{^sidd}', "");
    Expect(0, 71133, '\P{sidd}', "");
    Expect(1, 71133, '\P{^sidd}', "");
    Expect(0, 71134, '\p{sidd}', "");
    Expect(1, 71134, '\p{^sidd}', "");
    Expect(1, 71134, '\P{sidd}', "");
    Expect(0, 71134, '\P{^sidd}', "");
    Expect(1, 71133, '\p{-_sidd}', "");
    Expect(0, 71133, '\p{^-_sidd}', "");
    Expect(0, 71133, '\P{-_sidd}', "");
    Expect(1, 71133, '\P{^-_sidd}', "");
    Expect(0, 71134, '\p{-_sidd}', "");
    Expect(1, 71134, '\p{^-_sidd}', "");
    Expect(1, 71134, '\P{-_sidd}', "");
    Expect(0, 71134, '\P{^-_sidd}', "");
    Error('\p{:=  Is_Sidd}');
    Error('\P{:=  Is_Sidd}');
    Expect(1, 71133, '\p{issidd}', "");
    Expect(0, 71133, '\p{^issidd}', "");
    Expect(0, 71133, '\P{issidd}', "");
    Expect(1, 71133, '\P{^issidd}', "");
    Expect(0, 71134, '\p{issidd}', "");
    Expect(1, 71134, '\p{^issidd}', "");
    Expect(1, 71134, '\P{issidd}', "");
    Expect(0, 71134, '\P{^issidd}', "");
    Expect(1, 71133, '\p{ Is_sidd}', "");
    Expect(0, 71133, '\p{^ Is_sidd}', "");
    Expect(0, 71133, '\P{ Is_sidd}', "");
    Expect(1, 71133, '\P{^ Is_sidd}', "");
    Expect(0, 71134, '\p{ Is_sidd}', "");
    Expect(1, 71134, '\p{^ Is_sidd}', "");
    Expect(1, 71134, '\P{ Is_sidd}', "");
    Expect(0, 71134, '\P{^ Is_sidd}', "");
    Error('\p{ /a/SignWriting}');
    Error('\P{ /a/SignWriting}');
    Expect(1, 121519, '\p{signwriting}', "");
    Expect(0, 121519, '\p{^signwriting}', "");
    Expect(0, 121519, '\P{signwriting}', "");
    Expect(1, 121519, '\P{^signwriting}', "");
    Expect(0, 121520, '\p{signwriting}', "");
    Expect(1, 121520, '\p{^signwriting}', "");
    Expect(1, 121520, '\P{signwriting}', "");
    Expect(0, 121520, '\P{^signwriting}', "");
    Expect(1, 121519, '\p{-SignWriting}', "");
    Expect(0, 121519, '\p{^-SignWriting}', "");
    Expect(0, 121519, '\P{-SignWriting}', "");
    Expect(1, 121519, '\P{^-SignWriting}', "");
    Expect(0, 121520, '\p{-SignWriting}', "");
    Expect(1, 121520, '\p{^-SignWriting}', "");
    Expect(1, 121520, '\P{-SignWriting}', "");
    Expect(0, 121520, '\P{^-SignWriting}', "");
    Error('\p{ -IS_SignWriting/a/}');
    Error('\P{ -IS_SignWriting/a/}');
    Expect(1, 121519, '\p{issignwriting}', "");
    Expect(0, 121519, '\p{^issignwriting}', "");
    Expect(0, 121519, '\P{issignwriting}', "");
    Expect(1, 121519, '\P{^issignwriting}', "");
    Expect(0, 121520, '\p{issignwriting}', "");
    Expect(1, 121520, '\p{^issignwriting}', "");
    Expect(1, 121520, '\P{issignwriting}', "");
    Expect(0, 121520, '\P{^issignwriting}', "");
    Expect(1, 121519, '\p{-	IS_SignWriting}', "");
    Expect(0, 121519, '\p{^-	IS_SignWriting}', "");
    Expect(0, 121519, '\P{-	IS_SignWriting}', "");
    Expect(1, 121519, '\P{^-	IS_SignWriting}', "");
    Expect(0, 121520, '\p{-	IS_SignWriting}', "");
    Expect(1, 121520, '\p{^-	IS_SignWriting}', "");
    Expect(1, 121520, '\P{-	IS_SignWriting}', "");
    Expect(0, 121520, '\P{^-	IS_SignWriting}', "");
    Error('\p{:=-sgnw}');
    Error('\P{:=-sgnw}');
    Expect(1, 121519, '\p{sgnw}', "");
    Expect(0, 121519, '\p{^sgnw}', "");
    Expect(0, 121519, '\P{sgnw}', "");
    Expect(1, 121519, '\P{^sgnw}', "");
    Expect(0, 121520, '\p{sgnw}', "");
    Expect(1, 121520, '\p{^sgnw}', "");
    Expect(1, 121520, '\P{sgnw}', "");
    Expect(0, 121520, '\P{^sgnw}', "");
    Expect(1, 121519, '\p{	 sgnw}', "");
    Expect(0, 121519, '\p{^	 sgnw}', "");
    Expect(0, 121519, '\P{	 sgnw}', "");
    Expect(1, 121519, '\P{^	 sgnw}', "");
    Expect(0, 121520, '\p{	 sgnw}', "");
    Expect(1, 121520, '\p{^	 sgnw}', "");
    Expect(1, 121520, '\P{	 sgnw}', "");
    Expect(0, 121520, '\P{^	 sgnw}', "");
    Error('\p{ :=IS_Sgnw}');
    Error('\P{ :=IS_Sgnw}');
    Expect(1, 121519, '\p{issgnw}', "");
    Expect(0, 121519, '\p{^issgnw}', "");
    Expect(0, 121519, '\P{issgnw}', "");
    Expect(1, 121519, '\P{^issgnw}', "");
    Expect(0, 121520, '\p{issgnw}', "");
    Expect(1, 121520, '\p{^issgnw}', "");
    Expect(1, 121520, '\P{issgnw}', "");
    Expect(0, 121520, '\P{^issgnw}', "");
    Expect(1, 121519, '\p{	 IS_sgnw}', "");
    Expect(0, 121519, '\p{^	 IS_sgnw}', "");
    Expect(0, 121519, '\P{	 IS_sgnw}', "");
    Expect(1, 121519, '\P{^	 IS_sgnw}', "");
    Expect(0, 121520, '\p{	 IS_sgnw}', "");
    Expect(1, 121520, '\p{^	 IS_sgnw}', "");
    Expect(1, 121520, '\P{	 IS_sgnw}', "");
    Expect(0, 121520, '\P{^	 IS_sgnw}', "");
    Error('\p{ Sinhala/a/}');
    Error('\P{ Sinhala/a/}');
    Expect(1, 70132, '\p{sinhala}', "");
    Expect(0, 70132, '\p{^sinhala}', "");
    Expect(0, 70132, '\P{sinhala}', "");
    Expect(1, 70132, '\P{^sinhala}', "");
    Expect(0, 70133, '\p{sinhala}', "");
    Expect(1, 70133, '\p{^sinhala}', "");
    Expect(1, 70133, '\P{sinhala}', "");
    Expect(0, 70133, '\P{^sinhala}', "");
    Expect(1, 70132, '\p{-_Sinhala}', "");
    Expect(0, 70132, '\p{^-_Sinhala}', "");
    Expect(0, 70132, '\P{-_Sinhala}', "");
    Expect(1, 70132, '\P{^-_Sinhala}', "");
    Expect(0, 70133, '\p{-_Sinhala}', "");
    Expect(1, 70133, '\p{^-_Sinhala}', "");
    Expect(1, 70133, '\P{-_Sinhala}', "");
    Expect(0, 70133, '\P{^-_Sinhala}', "");
    Error('\p{/a/ 	is_SINHALA}');
    Error('\P{/a/ 	is_SINHALA}');
    Expect(1, 70132, '\p{issinhala}', "");
    Expect(0, 70132, '\p{^issinhala}', "");
    Expect(0, 70132, '\P{issinhala}', "");
    Expect(1, 70132, '\P{^issinhala}', "");
    Expect(0, 70133, '\p{issinhala}', "");
    Expect(1, 70133, '\p{^issinhala}', "");
    Expect(1, 70133, '\P{issinhala}', "");
    Expect(0, 70133, '\P{^issinhala}', "");
    Expect(1, 70132, '\p{_IS_Sinhala}', "");
    Expect(0, 70132, '\p{^_IS_Sinhala}', "");
    Expect(0, 70132, '\P{_IS_Sinhala}', "");
    Expect(1, 70132, '\P{^_IS_Sinhala}', "");
    Expect(0, 70133, '\p{_IS_Sinhala}', "");
    Expect(1, 70133, '\p{^_IS_Sinhala}', "");
    Expect(1, 70133, '\P{_IS_Sinhala}', "");
    Expect(0, 70133, '\P{^_IS_Sinhala}', "");
    Error('\p{_Sinh:=}');
    Error('\P{_Sinh:=}');
    Expect(1, 70132, '\p{sinh}', "");
    Expect(0, 70132, '\p{^sinh}', "");
    Expect(0, 70132, '\P{sinh}', "");
    Expect(1, 70132, '\P{^sinh}', "");
    Expect(0, 70133, '\p{sinh}', "");
    Expect(1, 70133, '\p{^sinh}', "");
    Expect(1, 70133, '\P{sinh}', "");
    Expect(0, 70133, '\P{^sinh}', "");
    Expect(1, 70132, '\p{-SINH}', "");
    Expect(0, 70132, '\p{^-SINH}', "");
    Expect(0, 70132, '\P{-SINH}', "");
    Expect(1, 70132, '\P{^-SINH}', "");
    Expect(0, 70133, '\p{-SINH}', "");
    Expect(1, 70133, '\p{^-SINH}', "");
    Expect(1, 70133, '\P{-SINH}', "");
    Expect(0, 70133, '\P{^-SINH}', "");
    Error('\p{/a/	-IS_SINH}');
    Error('\P{/a/	-IS_SINH}');
    Expect(1, 70132, '\p{issinh}', "");
    Expect(0, 70132, '\p{^issinh}', "");
    Expect(0, 70132, '\P{issinh}', "");
    Expect(1, 70132, '\P{^issinh}', "");
    Expect(0, 70133, '\p{issinh}', "");
    Expect(1, 70133, '\p{^issinh}', "");
    Expect(1, 70133, '\P{issinh}', "");
    Expect(0, 70133, '\P{^issinh}', "");
    Expect(1, 70132, '\p{ 	Is_Sinh}', "");
    Expect(0, 70132, '\p{^ 	Is_Sinh}', "");
    Expect(0, 70132, '\P{ 	Is_Sinh}', "");
    Expect(1, 70132, '\P{^ 	Is_Sinh}', "");
    Expect(0, 70133, '\p{ 	Is_Sinh}', "");
    Expect(1, 70133, '\p{^ 	Is_Sinh}', "");
    Expect(1, 70133, '\P{ 	Is_Sinh}', "");
    Expect(0, 70133, '\P{^ 	Is_Sinh}', "");
    Error('\p{ sinhala_ARCHAIC_Numbers/a/}');
    Error('\P{ sinhala_ARCHAIC_Numbers/a/}');
    Expect(1, 70143, '\p{sinhalaarchaicnumbers}', "");
    Expect(0, 70143, '\p{^sinhalaarchaicnumbers}', "");
    Expect(0, 70143, '\P{sinhalaarchaicnumbers}', "");
    Expect(1, 70143, '\P{^sinhalaarchaicnumbers}', "");
    Expect(0, 70144, '\p{sinhalaarchaicnumbers}', "");
    Expect(1, 70144, '\p{^sinhalaarchaicnumbers}', "");
    Expect(1, 70144, '\P{sinhalaarchaicnumbers}', "");
    Expect(0, 70144, '\P{^sinhalaarchaicnumbers}', "");
    Expect(1, 70143, '\p{-Sinhala_ARCHAIC_Numbers}', "");
    Expect(0, 70143, '\p{^-Sinhala_ARCHAIC_Numbers}', "");
    Expect(0, 70143, '\P{-Sinhala_ARCHAIC_Numbers}', "");
    Expect(1, 70143, '\P{^-Sinhala_ARCHAIC_Numbers}', "");
    Expect(0, 70144, '\p{-Sinhala_ARCHAIC_Numbers}', "");
    Expect(1, 70144, '\p{^-Sinhala_ARCHAIC_Numbers}', "");
    Expect(1, 70144, '\P{-Sinhala_ARCHAIC_Numbers}', "");
    Expect(0, 70144, '\P{^-Sinhala_ARCHAIC_Numbers}', "");
    Error('\p{__Is_Sinhala_Archaic_NUMBERS/a/}');
    Error('\P{__Is_Sinhala_Archaic_NUMBERS/a/}');
    Expect(1, 70143, '\p{issinhalaarchaicnumbers}', "");
    Expect(0, 70143, '\p{^issinhalaarchaicnumbers}', "");
    Expect(0, 70143, '\P{issinhalaarchaicnumbers}', "");
    Expect(1, 70143, '\P{^issinhalaarchaicnumbers}', "");
    Expect(0, 70144, '\p{issinhalaarchaicnumbers}', "");
    Expect(1, 70144, '\p{^issinhalaarchaicnumbers}', "");
    Expect(1, 70144, '\P{issinhalaarchaicnumbers}', "");
    Expect(0, 70144, '\P{^issinhalaarchaicnumbers}', "");
    Expect(1, 70143, '\p{- Is_Sinhala_ARCHAIC_Numbers}', "");
    Expect(0, 70143, '\p{^- Is_Sinhala_ARCHAIC_Numbers}', "");
    Expect(0, 70143, '\P{- Is_Sinhala_ARCHAIC_Numbers}', "");
    Expect(1, 70143, '\P{^- Is_Sinhala_ARCHAIC_Numbers}', "");
    Expect(0, 70144, '\p{- Is_Sinhala_ARCHAIC_Numbers}', "");
    Expect(1, 70144, '\p{^- Is_Sinhala_ARCHAIC_Numbers}', "");
    Expect(1, 70144, '\P{- Is_Sinhala_ARCHAIC_Numbers}', "");
    Expect(0, 70144, '\P{^- Is_Sinhala_ARCHAIC_Numbers}', "");
    Error('\p{/a/_-in_Sinhala_Archaic_Numbers}');
    Error('\P{/a/_-in_Sinhala_Archaic_Numbers}');
    Expect(1, 70143, '\p{insinhalaarchaicnumbers}', "");
    Expect(0, 70143, '\p{^insinhalaarchaicnumbers}', "");
    Expect(0, 70143, '\P{insinhalaarchaicnumbers}', "");
    Expect(1, 70143, '\P{^insinhalaarchaicnumbers}', "");
    Expect(0, 70144, '\p{insinhalaarchaicnumbers}', "");
    Expect(1, 70144, '\p{^insinhalaarchaicnumbers}', "");
    Expect(1, 70144, '\P{insinhalaarchaicnumbers}', "");
    Expect(0, 70144, '\P{^insinhalaarchaicnumbers}', "");
    Expect(1, 70143, '\p{__IN_sinhala_Archaic_Numbers}', "");
    Expect(0, 70143, '\p{^__IN_sinhala_Archaic_Numbers}', "");
    Expect(0, 70143, '\P{__IN_sinhala_Archaic_Numbers}', "");
    Expect(1, 70143, '\P{^__IN_sinhala_Archaic_Numbers}', "");
    Expect(0, 70144, '\p{__IN_sinhala_Archaic_Numbers}', "");
    Expect(1, 70144, '\p{^__IN_sinhala_Archaic_Numbers}', "");
    Expect(1, 70144, '\P{__IN_sinhala_Archaic_Numbers}', "");
    Expect(0, 70144, '\P{^__IN_sinhala_Archaic_Numbers}', "");
    Error('\p{		SMALL_form_Variants/a/}');
    Error('\P{		SMALL_form_Variants/a/}');
    Expect(1, 65135, '\p{smallformvariants}', "");
    Expect(0, 65135, '\p{^smallformvariants}', "");
    Expect(0, 65135, '\P{smallformvariants}', "");
    Expect(1, 65135, '\P{^smallformvariants}', "");
    Expect(0, 65136, '\p{smallformvariants}', "");
    Expect(1, 65136, '\p{^smallformvariants}', "");
    Expect(1, 65136, '\P{smallformvariants}', "");
    Expect(0, 65136, '\P{^smallformvariants}', "");
    Expect(1, 65135, '\p{	_SMALL_FORM_Variants}', "");
    Expect(0, 65135, '\p{^	_SMALL_FORM_Variants}', "");
    Expect(0, 65135, '\P{	_SMALL_FORM_Variants}', "");
    Expect(1, 65135, '\P{^	_SMALL_FORM_Variants}', "");
    Expect(0, 65136, '\p{	_SMALL_FORM_Variants}', "");
    Expect(1, 65136, '\p{^	_SMALL_FORM_Variants}', "");
    Expect(1, 65136, '\P{	_SMALL_FORM_Variants}', "");
    Expect(0, 65136, '\P{^	_SMALL_FORM_Variants}', "");
    Error('\p{/a/_-Is_Small_Form_VARIANTS}');
    Error('\P{/a/_-Is_Small_Form_VARIANTS}');
    Expect(1, 65135, '\p{issmallformvariants}', "");
    Expect(0, 65135, '\p{^issmallformvariants}', "");
    Expect(0, 65135, '\P{issmallformvariants}', "");
    Expect(1, 65135, '\P{^issmallformvariants}', "");
    Expect(0, 65136, '\p{issmallformvariants}', "");
    Expect(1, 65136, '\p{^issmallformvariants}', "");
    Expect(1, 65136, '\P{issmallformvariants}', "");
    Expect(0, 65136, '\P{^issmallformvariants}', "");
    Expect(1, 65135, '\p{	-Is_Small_FORM_Variants}', "");
    Expect(0, 65135, '\p{^	-Is_Small_FORM_Variants}', "");
    Expect(0, 65135, '\P{	-Is_Small_FORM_Variants}', "");
    Expect(1, 65135, '\P{^	-Is_Small_FORM_Variants}', "");
    Expect(0, 65136, '\p{	-Is_Small_FORM_Variants}', "");
    Expect(1, 65136, '\p{^	-Is_Small_FORM_Variants}', "");
    Expect(1, 65136, '\P{	-Is_Small_FORM_Variants}', "");
    Expect(0, 65136, '\P{^	-Is_Small_FORM_Variants}', "");
    Error('\p{/a/	-IN_Small_form_Variants}');
    Error('\P{/a/	-IN_Small_form_Variants}');
    Expect(1, 65135, '\p{insmallformvariants}', "");
    Expect(0, 65135, '\p{^insmallformvariants}', "");
    Expect(0, 65135, '\P{insmallformvariants}', "");
    Expect(1, 65135, '\P{^insmallformvariants}', "");
    Expect(0, 65136, '\p{insmallformvariants}', "");
    Expect(1, 65136, '\p{^insmallformvariants}', "");
    Expect(1, 65136, '\P{insmallformvariants}', "");
    Expect(0, 65136, '\P{^insmallformvariants}', "");
    Expect(1, 65135, '\p{_	In_Small_FORM_variants}', "");
    Expect(0, 65135, '\p{^_	In_Small_FORM_variants}', "");
    Expect(0, 65135, '\P{_	In_Small_FORM_variants}', "");
    Expect(1, 65135, '\P{^_	In_Small_FORM_variants}', "");
    Expect(0, 65136, '\p{_	In_Small_FORM_variants}', "");
    Expect(1, 65136, '\p{^_	In_Small_FORM_variants}', "");
    Expect(1, 65136, '\P{_	In_Small_FORM_variants}', "");
    Expect(0, 65136, '\P{^_	In_Small_FORM_variants}', "");
    Error('\p{-:=Small_forms}');
    Error('\P{-:=Small_forms}');
    Expect(1, 65135, '\p{smallforms}', "");
    Expect(0, 65135, '\p{^smallforms}', "");
    Expect(0, 65135, '\P{smallforms}', "");
    Expect(1, 65135, '\P{^smallforms}', "");
    Expect(0, 65136, '\p{smallforms}', "");
    Expect(1, 65136, '\p{^smallforms}', "");
    Expect(1, 65136, '\P{smallforms}', "");
    Expect(0, 65136, '\P{^smallforms}', "");
    Expect(1, 65135, '\p{_ Small_forms}', "");
    Expect(0, 65135, '\p{^_ Small_forms}', "");
    Expect(0, 65135, '\P{_ Small_forms}', "");
    Expect(1, 65135, '\P{^_ Small_forms}', "");
    Expect(0, 65136, '\p{_ Small_forms}', "");
    Expect(1, 65136, '\p{^_ Small_forms}', "");
    Expect(1, 65136, '\P{_ Small_forms}', "");
    Expect(0, 65136, '\P{^_ Small_forms}', "");
    Error('\p{_:=is_small_FORMS}');
    Error('\P{_:=is_small_FORMS}');
    Expect(1, 65135, '\p{issmallforms}', "");
    Expect(0, 65135, '\p{^issmallforms}', "");
    Expect(0, 65135, '\P{issmallforms}', "");
    Expect(1, 65135, '\P{^issmallforms}', "");
    Expect(0, 65136, '\p{issmallforms}', "");
    Expect(1, 65136, '\p{^issmallforms}', "");
    Expect(1, 65136, '\P{issmallforms}', "");
    Expect(0, 65136, '\P{^issmallforms}', "");
    Expect(1, 65135, '\p{ Is_Small_FORMS}', "");
    Expect(0, 65135, '\p{^ Is_Small_FORMS}', "");
    Expect(0, 65135, '\P{ Is_Small_FORMS}', "");
    Expect(1, 65135, '\P{^ Is_Small_FORMS}', "");
    Expect(0, 65136, '\p{ Is_Small_FORMS}', "");
    Expect(1, 65136, '\p{^ Is_Small_FORMS}', "");
    Expect(1, 65136, '\P{ Is_Small_FORMS}', "");
    Expect(0, 65136, '\P{^ Is_Small_FORMS}', "");
    Error('\p{ 	In_SMALL_forms/a/}');
    Error('\P{ 	In_SMALL_forms/a/}');
    Expect(1, 65135, '\p{insmallforms}', "");
    Expect(0, 65135, '\p{^insmallforms}', "");
    Expect(0, 65135, '\P{insmallforms}', "");
    Expect(1, 65135, '\P{^insmallforms}', "");
    Expect(0, 65136, '\p{insmallforms}', "");
    Expect(1, 65136, '\p{^insmallforms}', "");
    Expect(1, 65136, '\P{insmallforms}', "");
    Expect(0, 65136, '\P{^insmallforms}', "");
    Expect(1, 65135, '\p{	_In_Small_FORMS}', "");
    Expect(0, 65135, '\p{^	_In_Small_FORMS}', "");
    Expect(0, 65135, '\P{	_In_Small_FORMS}', "");
    Expect(1, 65135, '\P{^	_In_Small_FORMS}', "");
    Expect(0, 65136, '\p{	_In_Small_FORMS}', "");
    Expect(1, 65136, '\p{^	_In_Small_FORMS}', "");
    Expect(1, 65136, '\P{	_In_Small_FORMS}', "");
    Expect(0, 65136, '\P{^	_In_Small_FORMS}', "");
    Error('\p{:= -Small_Kana_extension}');
    Error('\P{:= -Small_Kana_extension}');
    Expect(1, 110959, '\p{smallkanaextension}', "");
    Expect(0, 110959, '\p{^smallkanaextension}', "");
    Expect(0, 110959, '\P{smallkanaextension}', "");
    Expect(1, 110959, '\P{^smallkanaextension}', "");
    Expect(0, 110960, '\p{smallkanaextension}', "");
    Expect(1, 110960, '\p{^smallkanaextension}', "");
    Expect(1, 110960, '\P{smallkanaextension}', "");
    Expect(0, 110960, '\P{^smallkanaextension}', "");
    Expect(1, 110959, '\p{		Small_Kana_Extension}', "");
    Expect(0, 110959, '\p{^		Small_Kana_Extension}', "");
    Expect(0, 110959, '\P{		Small_Kana_Extension}', "");
    Expect(1, 110959, '\P{^		Small_Kana_Extension}', "");
    Expect(0, 110960, '\p{		Small_Kana_Extension}', "");
    Expect(1, 110960, '\p{^		Small_Kana_Extension}', "");
    Expect(1, 110960, '\P{		Small_Kana_Extension}', "");
    Expect(0, 110960, '\P{^		Small_Kana_Extension}', "");
    Error('\p{/a/ Is_small_KANA_EXTENSION}');
    Error('\P{/a/ Is_small_KANA_EXTENSION}');
    Expect(1, 110959, '\p{issmallkanaextension}', "");
    Expect(0, 110959, '\p{^issmallkanaextension}', "");
    Expect(0, 110959, '\P{issmallkanaextension}', "");
    Expect(1, 110959, '\P{^issmallkanaextension}', "");
    Expect(0, 110960, '\p{issmallkanaextension}', "");
    Expect(1, 110960, '\p{^issmallkanaextension}', "");
    Expect(1, 110960, '\P{issmallkanaextension}', "");
    Expect(0, 110960, '\P{^issmallkanaextension}', "");
    Expect(1, 110959, '\p{  Is_small_kana_Extension}', "");
    Expect(0, 110959, '\p{^  Is_small_kana_Extension}', "");
    Expect(0, 110959, '\P{  Is_small_kana_Extension}', "");
    Expect(1, 110959, '\P{^  Is_small_kana_Extension}', "");
    Expect(0, 110960, '\p{  Is_small_kana_Extension}', "");
    Expect(1, 110960, '\p{^  Is_small_kana_Extension}', "");
    Expect(1, 110960, '\P{  Is_small_kana_Extension}', "");
    Expect(0, 110960, '\P{^  Is_small_kana_Extension}', "");
    Error('\p{/a/IN_SMALL_Kana_EXTENSION}');
    Error('\P{/a/IN_SMALL_Kana_EXTENSION}');
    Expect(1, 110959, '\p{insmallkanaextension}', "");
    Expect(0, 110959, '\p{^insmallkanaextension}', "");
    Expect(0, 110959, '\P{insmallkanaextension}', "");
    Expect(1, 110959, '\P{^insmallkanaextension}', "");
    Expect(0, 110960, '\p{insmallkanaextension}', "");
    Expect(1, 110960, '\p{^insmallkanaextension}', "");
    Expect(1, 110960, '\P{insmallkanaextension}', "");
    Expect(0, 110960, '\P{^insmallkanaextension}', "");
    Expect(1, 110959, '\p{		in_Small_kana_Extension}', "");
    Expect(0, 110959, '\p{^		in_Small_kana_Extension}', "");
    Expect(0, 110959, '\P{		in_Small_kana_Extension}', "");
    Expect(1, 110959, '\P{^		in_Small_kana_Extension}', "");
    Expect(0, 110960, '\p{		in_Small_kana_Extension}', "");
    Expect(1, 110960, '\p{^		in_Small_kana_Extension}', "");
    Expect(1, 110960, '\P{		in_Small_kana_Extension}', "");
    Expect(0, 110960, '\P{^		in_Small_kana_Extension}', "");
    Error('\p{/a/_ SMALL_KANA_Ext}');
    Error('\P{/a/_ SMALL_KANA_Ext}');
    Expect(1, 110959, '\p{smallkanaext}', "");
    Expect(0, 110959, '\p{^smallkanaext}', "");
    Expect(0, 110959, '\P{smallkanaext}', "");
    Expect(1, 110959, '\P{^smallkanaext}', "");
    Expect(0, 110960, '\p{smallkanaext}', "");
    Expect(1, 110960, '\p{^smallkanaext}', "");
    Expect(1, 110960, '\P{smallkanaext}', "");
    Expect(0, 110960, '\P{^smallkanaext}', "");
    Expect(1, 110959, '\p{-Small_kana_Ext}', "");
    Expect(0, 110959, '\p{^-Small_kana_Ext}', "");
    Expect(0, 110959, '\P{-Small_kana_Ext}', "");
    Expect(1, 110959, '\P{^-Small_kana_Ext}', "");
    Expect(0, 110960, '\p{-Small_kana_Ext}', "");
    Expect(1, 110960, '\p{^-Small_kana_Ext}', "");
    Expect(1, 110960, '\P{-Small_kana_Ext}', "");
    Expect(0, 110960, '\P{^-Small_kana_Ext}', "");
    Error('\p{:=  is_SMALL_Kana_ext}');
    Error('\P{:=  is_SMALL_Kana_ext}');
    Expect(1, 110959, '\p{issmallkanaext}', "");
    Expect(0, 110959, '\p{^issmallkanaext}', "");
    Expect(0, 110959, '\P{issmallkanaext}', "");
    Expect(1, 110959, '\P{^issmallkanaext}', "");
    Expect(0, 110960, '\p{issmallkanaext}', "");
    Expect(1, 110960, '\p{^issmallkanaext}', "");
    Expect(1, 110960, '\P{issmallkanaext}', "");
    Expect(0, 110960, '\P{^issmallkanaext}', "");
    Expect(1, 110959, '\p{_-Is_small_KANA_EXT}', "");
    Expect(0, 110959, '\p{^_-Is_small_KANA_EXT}', "");
    Expect(0, 110959, '\P{_-Is_small_KANA_EXT}', "");
    Expect(1, 110959, '\P{^_-Is_small_KANA_EXT}', "");
    Expect(0, 110960, '\p{_-Is_small_KANA_EXT}', "");
    Expect(1, 110960, '\p{^_-Is_small_KANA_EXT}', "");
    Expect(1, 110960, '\P{_-Is_small_KANA_EXT}', "");
    Expect(0, 110960, '\P{^_-Is_small_KANA_EXT}', "");
    Error('\p{	/a/IN_Small_kana_Ext}');
    Error('\P{	/a/IN_Small_kana_Ext}');
    Expect(1, 110959, '\p{insmallkanaext}', "");
    Expect(0, 110959, '\p{^insmallkanaext}', "");
    Expect(0, 110959, '\P{insmallkanaext}', "");
    Expect(1, 110959, '\P{^insmallkanaext}', "");
    Expect(0, 110960, '\p{insmallkanaext}', "");
    Expect(1, 110960, '\p{^insmallkanaext}', "");
    Expect(1, 110960, '\P{insmallkanaext}', "");
    Expect(0, 110960, '\P{^insmallkanaext}', "");
    Expect(1, 110959, '\p{_In_Small_Kana_ext}', "");
    Expect(0, 110959, '\p{^_In_Small_Kana_ext}', "");
    Expect(0, 110959, '\P{_In_Small_Kana_ext}', "");
    Expect(1, 110959, '\P{^_In_Small_Kana_ext}', "");
    Expect(0, 110960, '\p{_In_Small_Kana_ext}', "");
    Expect(1, 110960, '\p{^_In_Small_Kana_ext}', "");
    Expect(1, 110960, '\P{_In_Small_Kana_ext}', "");
    Expect(0, 110960, '\P{^_In_Small_Kana_ext}', "");
    Error('\p{:= _Soft_dotted}');
    Error('\P{:= _Soft_dotted}');
    Expect(1, 122984, '\p{softdotted}', "");
    Expect(0, 122984, '\p{^softdotted}', "");
    Expect(0, 122984, '\P{softdotted}', "");
    Expect(1, 122984, '\P{^softdotted}', "");
    Expect(0, 122985, '\p{softdotted}', "");
    Expect(1, 122985, '\p{^softdotted}', "");
    Expect(1, 122985, '\P{softdotted}', "");
    Expect(0, 122985, '\P{^softdotted}', "");
    Expect(1, 122984, '\p{_-soft_Dotted}', "");
    Expect(0, 122984, '\p{^_-soft_Dotted}', "");
    Expect(0, 122984, '\P{_-soft_Dotted}', "");
    Expect(1, 122984, '\P{^_-soft_Dotted}', "");
    Expect(0, 122985, '\p{_-soft_Dotted}', "");
    Expect(1, 122985, '\p{^_-soft_Dotted}', "");
    Expect(1, 122985, '\P{_-soft_Dotted}', "");
    Expect(0, 122985, '\P{^_-soft_Dotted}', "");
    Error('\p{/a/-IS_Soft_DOTTED}');
    Error('\P{/a/-IS_Soft_DOTTED}');
    Expect(1, 122984, '\p{issoftdotted}', "");
    Expect(0, 122984, '\p{^issoftdotted}', "");
    Expect(0, 122984, '\P{issoftdotted}', "");
    Expect(1, 122984, '\P{^issoftdotted}', "");
    Expect(0, 122985, '\p{issoftdotted}', "");
    Expect(1, 122985, '\p{^issoftdotted}', "");
    Expect(1, 122985, '\P{issoftdotted}', "");
    Expect(0, 122985, '\P{^issoftdotted}', "");
    Expect(1, 122984, '\p{_	Is_soft_DOTTED}', "");
    Expect(0, 122984, '\p{^_	Is_soft_DOTTED}', "");
    Expect(0, 122984, '\P{_	Is_soft_DOTTED}', "");
    Expect(1, 122984, '\P{^_	Is_soft_DOTTED}', "");
    Expect(0, 122985, '\p{_	Is_soft_DOTTED}', "");
    Expect(1, 122985, '\p{^_	Is_soft_DOTTED}', "");
    Expect(1, 122985, '\P{_	Is_soft_DOTTED}', "");
    Expect(0, 122985, '\P{^_	Is_soft_DOTTED}', "");
    Error('\p{/a/SD}');
    Error('\P{/a/SD}');
    Expect(1, 122984, '\p{sd}', "");
    Expect(0, 122984, '\p{^sd}', "");
    Expect(0, 122984, '\P{sd}', "");
    Expect(1, 122984, '\P{^sd}', "");
    Expect(0, 122985, '\p{sd}', "");
    Expect(1, 122985, '\p{^sd}', "");
    Expect(1, 122985, '\P{sd}', "");
    Expect(0, 122985, '\P{^sd}', "");
    Expect(1, 122984, '\p{ -sd}', "");
    Expect(0, 122984, '\p{^ -sd}', "");
    Expect(0, 122984, '\P{ -sd}', "");
    Expect(1, 122984, '\P{^ -sd}', "");
    Expect(0, 122985, '\p{ -sd}', "");
    Expect(1, 122985, '\p{^ -sd}', "");
    Expect(1, 122985, '\P{ -sd}', "");
    Expect(0, 122985, '\P{^ -sd}', "");
    Error('\p{:=-_is_sd}');
    Error('\P{:=-_is_sd}');
    Expect(1, 122984, '\p{issd}', "");
    Expect(0, 122984, '\p{^issd}', "");
    Expect(0, 122984, '\P{issd}', "");
    Expect(1, 122984, '\P{^issd}', "");
    Expect(0, 122985, '\p{issd}', "");
    Expect(1, 122985, '\p{^issd}', "");
    Expect(1, 122985, '\P{issd}', "");
    Expect(0, 122985, '\P{^issd}', "");
    Expect(1, 122984, '\p{__Is_sd}', "");
    Expect(0, 122984, '\p{^__Is_sd}', "");
    Expect(0, 122984, '\P{__Is_sd}', "");
    Expect(1, 122984, '\P{^__Is_sd}', "");
    Expect(0, 122985, '\p{__Is_sd}', "");
    Expect(1, 122985, '\p{^__Is_sd}', "");
    Expect(1, 122985, '\P{__Is_sd}', "");
    Expect(0, 122985, '\P{^__Is_sd}', "");
    Error('\p{_/a/Sogdian}');
    Error('\P{_/a/Sogdian}');
    Expect(1, 69465, '\p{sogdian}', "");
    Expect(0, 69465, '\p{^sogdian}', "");
    Expect(0, 69465, '\P{sogdian}', "");
    Expect(1, 69465, '\P{^sogdian}', "");
    Expect(0, 69466, '\p{sogdian}', "");
    Expect(1, 69466, '\p{^sogdian}', "");
    Expect(1, 69466, '\P{sogdian}', "");
    Expect(0, 69466, '\P{^sogdian}', "");
    Expect(1, 69465, '\p{--Sogdian}', "");
    Expect(0, 69465, '\p{^--Sogdian}', "");
    Expect(0, 69465, '\P{--Sogdian}', "");
    Expect(1, 69465, '\P{^--Sogdian}', "");
    Expect(0, 69466, '\p{--Sogdian}', "");
    Expect(1, 69466, '\p{^--Sogdian}', "");
    Expect(1, 69466, '\P{--Sogdian}', "");
    Expect(0, 69466, '\P{^--Sogdian}', "");
    Error('\p{/a/ Is_Sogdian}');
    Error('\P{/a/ Is_Sogdian}');
    Expect(1, 69465, '\p{issogdian}', "");
    Expect(0, 69465, '\p{^issogdian}', "");
    Expect(0, 69465, '\P{issogdian}', "");
    Expect(1, 69465, '\P{^issogdian}', "");
    Expect(0, 69466, '\p{issogdian}', "");
    Expect(1, 69466, '\p{^issogdian}', "");
    Expect(1, 69466, '\P{issogdian}', "");
    Expect(0, 69466, '\P{^issogdian}', "");
    Expect(1, 69465, '\p{-_IS_Sogdian}', "");
    Expect(0, 69465, '\p{^-_IS_Sogdian}', "");
    Expect(0, 69465, '\P{-_IS_Sogdian}', "");
    Expect(1, 69465, '\P{^-_IS_Sogdian}', "");
    Expect(0, 69466, '\p{-_IS_Sogdian}', "");
    Expect(1, 69466, '\p{^-_IS_Sogdian}', "");
    Expect(1, 69466, '\P{-_IS_Sogdian}', "");
    Expect(0, 69466, '\P{^-_IS_Sogdian}', "");
    Error('\p{ :=Sogd}');
    Error('\P{ :=Sogd}');
    Expect(1, 69465, '\p{sogd}', "");
    Expect(0, 69465, '\p{^sogd}', "");
    Expect(0, 69465, '\P{sogd}', "");
    Expect(1, 69465, '\P{^sogd}', "");
    Expect(0, 69466, '\p{sogd}', "");
    Expect(1, 69466, '\p{^sogd}', "");
    Expect(1, 69466, '\P{sogd}', "");
    Expect(0, 69466, '\P{^sogd}', "");
    Expect(1, 69465, '\p{	 SOGD}', "");
    Expect(0, 69465, '\p{^	 SOGD}', "");
    Expect(0, 69465, '\P{	 SOGD}', "");
    Expect(1, 69465, '\P{^	 SOGD}', "");
    Expect(0, 69466, '\p{	 SOGD}', "");
    Expect(1, 69466, '\p{^	 SOGD}', "");
    Expect(1, 69466, '\P{	 SOGD}', "");
    Expect(0, 69466, '\P{^	 SOGD}', "");
    Error('\p{__Is_sogd:=}');
    Error('\P{__Is_sogd:=}');
    Expect(1, 69465, '\p{issogd}', "");
    Expect(0, 69465, '\p{^issogd}', "");
    Expect(0, 69465, '\P{issogd}', "");
    Expect(1, 69465, '\P{^issogd}', "");
    Expect(0, 69466, '\p{issogd}', "");
    Expect(1, 69466, '\p{^issogd}', "");
    Expect(1, 69466, '\P{issogd}', "");
    Expect(0, 69466, '\P{^issogd}', "");
    Expect(1, 69465, '\p{  IS_Sogd}', "");
    Expect(0, 69465, '\p{^  IS_Sogd}', "");
    Expect(0, 69465, '\P{  IS_Sogd}', "");
    Expect(1, 69465, '\P{^  IS_Sogd}', "");
    Expect(0, 69466, '\p{  IS_Sogd}', "");
    Expect(1, 69466, '\p{^  IS_Sogd}', "");
    Expect(1, 69466, '\P{  IS_Sogd}', "");
    Expect(0, 69466, '\P{^  IS_Sogd}', "");
    Error('\p{-_Sora_SOMPENG:=}');
    Error('\P{-_Sora_SOMPENG:=}');
    Expect(1, 69881, '\p{sorasompeng}', "");
    Expect(0, 69881, '\p{^sorasompeng}', "");
    Expect(0, 69881, '\P{sorasompeng}', "");
    Expect(1, 69881, '\P{^sorasompeng}', "");
    Expect(0, 69882, '\p{sorasompeng}', "");
    Expect(1, 69882, '\p{^sorasompeng}', "");
    Expect(1, 69882, '\P{sorasompeng}', "");
    Expect(0, 69882, '\P{^sorasompeng}', "");
    Expect(1, 69881, '\p{	-SORA_sompeng}', "");
    Expect(0, 69881, '\p{^	-SORA_sompeng}', "");
    Expect(0, 69881, '\P{	-SORA_sompeng}', "");
    Expect(1, 69881, '\P{^	-SORA_sompeng}', "");
    Expect(0, 69882, '\p{	-SORA_sompeng}', "");
    Expect(1, 69882, '\p{^	-SORA_sompeng}', "");
    Expect(1, 69882, '\P{	-SORA_sompeng}', "");
    Expect(0, 69882, '\P{^	-SORA_sompeng}', "");
    Error('\p{/a/__Is_SORA_Sompeng}');
    Error('\P{/a/__Is_SORA_Sompeng}');
    Expect(1, 69881, '\p{issorasompeng}', "");
    Expect(0, 69881, '\p{^issorasompeng}', "");
    Expect(0, 69881, '\P{issorasompeng}', "");
    Expect(1, 69881, '\P{^issorasompeng}', "");
    Expect(0, 69882, '\p{issorasompeng}', "");
    Expect(1, 69882, '\p{^issorasompeng}', "");
    Expect(1, 69882, '\P{issorasompeng}', "");
    Expect(0, 69882, '\P{^issorasompeng}', "");
    Expect(1, 69881, '\p{	-IS_Sora_SOMPENG}', "");
    Expect(0, 69881, '\p{^	-IS_Sora_SOMPENG}', "");
    Expect(0, 69881, '\P{	-IS_Sora_SOMPENG}', "");
    Expect(1, 69881, '\P{^	-IS_Sora_SOMPENG}', "");
    Expect(0, 69882, '\p{	-IS_Sora_SOMPENG}', "");
    Expect(1, 69882, '\p{^	-IS_Sora_SOMPENG}', "");
    Expect(1, 69882, '\P{	-IS_Sora_SOMPENG}', "");
    Expect(0, 69882, '\P{^	-IS_Sora_SOMPENG}', "");
    Error('\p{/a/_-sora}');
    Error('\P{/a/_-sora}');
    Expect(1, 69881, '\p{sora}', "");
    Expect(0, 69881, '\p{^sora}', "");
    Expect(0, 69881, '\P{sora}', "");
    Expect(1, 69881, '\P{^sora}', "");
    Expect(0, 69882, '\p{sora}', "");
    Expect(1, 69882, '\p{^sora}', "");
    Expect(1, 69882, '\P{sora}', "");
    Expect(0, 69882, '\P{^sora}', "");
    Expect(1, 69881, '\p{ Sora}', "");
    Expect(0, 69881, '\p{^ Sora}', "");
    Expect(0, 69881, '\P{ Sora}', "");
    Expect(1, 69881, '\P{^ Sora}', "");
    Expect(0, 69882, '\p{ Sora}', "");
    Expect(1, 69882, '\p{^ Sora}', "");
    Expect(1, 69882, '\P{ Sora}', "");
    Expect(0, 69882, '\P{^ Sora}', "");
    Error('\p{		is_sora/a/}');
    Error('\P{		is_sora/a/}');
    Expect(1, 69881, '\p{issora}', "");
    Expect(0, 69881, '\p{^issora}', "");
    Expect(0, 69881, '\P{issora}', "");
    Expect(1, 69881, '\P{^issora}', "");
    Expect(0, 69882, '\p{issora}', "");
    Expect(1, 69882, '\p{^issora}', "");
    Expect(1, 69882, '\P{issora}', "");
    Expect(0, 69882, '\P{^issora}', "");
    Expect(1, 69881, '\p{ _is_sora}', "");
    Expect(0, 69881, '\p{^ _is_sora}', "");
    Expect(0, 69881, '\P{ _is_sora}', "");
    Expect(1, 69881, '\P{^ _is_sora}', "");
    Expect(0, 69882, '\p{ _is_sora}', "");
    Expect(1, 69882, '\p{^ _is_sora}', "");
    Expect(1, 69882, '\P{ _is_sora}', "");
    Expect(0, 69882, '\P{^ _is_sora}', "");
    Error('\p{/a/_	Soyombo}');
    Error('\P{/a/_	Soyombo}');
    Expect(1, 72354, '\p{soyombo}', "");
    Expect(0, 72354, '\p{^soyombo}', "");
    Expect(0, 72354, '\P{soyombo}', "");
    Expect(1, 72354, '\P{^soyombo}', "");
    Expect(0, 72355, '\p{soyombo}', "");
    Expect(1, 72355, '\p{^soyombo}', "");
    Expect(1, 72355, '\P{soyombo}', "");
    Expect(0, 72355, '\P{^soyombo}', "");
    Expect(1, 72354, '\p{  Soyombo}', "");
    Expect(0, 72354, '\p{^  Soyombo}', "");
    Expect(0, 72354, '\P{  Soyombo}', "");
    Expect(1, 72354, '\P{^  Soyombo}', "");
    Expect(0, 72355, '\p{  Soyombo}', "");
    Expect(1, 72355, '\p{^  Soyombo}', "");
    Expect(1, 72355, '\P{  Soyombo}', "");
    Expect(0, 72355, '\P{^  Soyombo}', "");
    Error('\p{_Is_soyombo/a/}');
    Error('\P{_Is_soyombo/a/}');
    Expect(1, 72354, '\p{issoyombo}', "");
    Expect(0, 72354, '\p{^issoyombo}', "");
    Expect(0, 72354, '\P{issoyombo}', "");
    Expect(1, 72354, '\P{^issoyombo}', "");
    Expect(0, 72355, '\p{issoyombo}', "");
    Expect(1, 72355, '\p{^issoyombo}', "");
    Expect(1, 72355, '\P{issoyombo}', "");
    Expect(0, 72355, '\P{^issoyombo}', "");
    Expect(1, 72354, '\p{  Is_Soyombo}', "");
    Expect(0, 72354, '\p{^  Is_Soyombo}', "");
    Expect(0, 72354, '\P{  Is_Soyombo}', "");
    Expect(1, 72354, '\P{^  Is_Soyombo}', "");
    Expect(0, 72355, '\p{  Is_Soyombo}', "");
    Expect(1, 72355, '\p{^  Is_Soyombo}', "");
    Expect(1, 72355, '\P{  Is_Soyombo}', "");
    Expect(0, 72355, '\P{^  Is_Soyombo}', "");
    Error('\p{/a/__Soyo}');
    Error('\P{/a/__Soyo}');
    Expect(1, 72354, '\p{soyo}', "");
    Expect(0, 72354, '\p{^soyo}', "");
    Expect(0, 72354, '\P{soyo}', "");
    Expect(1, 72354, '\P{^soyo}', "");
    Expect(0, 72355, '\p{soyo}', "");
    Expect(1, 72355, '\p{^soyo}', "");
    Expect(1, 72355, '\P{soyo}', "");
    Expect(0, 72355, '\P{^soyo}', "");
    Expect(1, 72354, '\p{-_SOYO}', "");
    Expect(0, 72354, '\p{^-_SOYO}', "");
    Expect(0, 72354, '\P{-_SOYO}', "");
    Expect(1, 72354, '\P{^-_SOYO}', "");
    Expect(0, 72355, '\p{-_SOYO}', "");
    Expect(1, 72355, '\p{^-_SOYO}', "");
    Expect(1, 72355, '\P{-_SOYO}', "");
    Expect(0, 72355, '\P{^-_SOYO}', "");
    Error('\p{/a/_-is_Soyo}');
    Error('\P{/a/_-is_Soyo}');
    Expect(1, 72354, '\p{issoyo}', "");
    Expect(0, 72354, '\p{^issoyo}', "");
    Expect(0, 72354, '\P{issoyo}', "");
    Expect(1, 72354, '\P{^issoyo}', "");
    Expect(0, 72355, '\p{issoyo}', "");
    Expect(1, 72355, '\p{^issoyo}', "");
    Expect(1, 72355, '\P{issoyo}', "");
    Expect(0, 72355, '\P{^issoyo}', "");
    Expect(1, 72354, '\p{--IS_soyo}', "");
    Expect(0, 72354, '\p{^--IS_soyo}', "");
    Expect(0, 72354, '\P{--IS_soyo}', "");
    Expect(1, 72354, '\P{^--IS_soyo}', "");
    Expect(0, 72355, '\p{--IS_soyo}', "");
    Expect(1, 72355, '\p{^--IS_soyo}', "");
    Expect(1, 72355, '\P{--IS_soyo}', "");
    Expect(0, 72355, '\P{^--IS_soyo}', "");
    Error('\p{/a/-_space_separator}');
    Error('\P{/a/-_space_separator}');
    Expect(1, 12288, '\p{spaceseparator}', "");
    Expect(0, 12288, '\p{^spaceseparator}', "");
    Expect(0, 12288, '\P{spaceseparator}', "");
    Expect(1, 12288, '\P{^spaceseparator}', "");
    Expect(0, 12289, '\p{spaceseparator}', "");
    Expect(1, 12289, '\p{^spaceseparator}', "");
    Expect(1, 12289, '\P{spaceseparator}', "");
    Expect(0, 12289, '\P{^spaceseparator}', "");
    Expect(1, 12288, '\p{_-Space_Separator}', "");
    Expect(0, 12288, '\p{^_-Space_Separator}', "");
    Expect(0, 12288, '\P{_-Space_Separator}', "");
    Expect(1, 12288, '\P{^_-Space_Separator}', "");
    Expect(0, 12289, '\p{_-Space_Separator}', "");
    Expect(1, 12289, '\p{^_-Space_Separator}', "");
    Expect(1, 12289, '\P{_-Space_Separator}', "");
    Expect(0, 12289, '\P{^_-Space_Separator}', "");
    Error('\p{	-is_Space_separator/a/}');
    Error('\P{	-is_Space_separator/a/}');
    Expect(1, 12288, '\p{isspaceseparator}', "");
    Expect(0, 12288, '\p{^isspaceseparator}', "");
    Expect(0, 12288, '\P{isspaceseparator}', "");
    Expect(1, 12288, '\P{^isspaceseparator}', "");
    Expect(0, 12289, '\p{isspaceseparator}', "");
    Expect(1, 12289, '\p{^isspaceseparator}', "");
    Expect(1, 12289, '\P{isspaceseparator}', "");
    Expect(0, 12289, '\P{^isspaceseparator}', "");
    Expect(1, 12288, '\p{		Is_Space_Separator}', "");
    Expect(0, 12288, '\p{^		Is_Space_Separator}', "");
    Expect(0, 12288, '\P{		Is_Space_Separator}', "");
    Expect(1, 12288, '\P{^		Is_Space_Separator}', "");
    Expect(0, 12289, '\p{		Is_Space_Separator}', "");
    Expect(1, 12289, '\p{^		Is_Space_Separator}', "");
    Expect(1, 12289, '\P{		Is_Space_Separator}', "");
    Expect(0, 12289, '\P{^		Is_Space_Separator}', "");
    Error('\p{:=	_Zs}');
    Error('\P{:=	_Zs}');
    Expect(1, 12288, '\p{zs}', "");
    Expect(0, 12288, '\p{^zs}', "");
    Expect(0, 12288, '\P{zs}', "");
    Expect(1, 12288, '\P{^zs}', "");
    Expect(0, 12289, '\p{zs}', "");
    Expect(1, 12289, '\p{^zs}', "");
    Expect(1, 12289, '\P{zs}', "");
    Expect(0, 12289, '\P{^zs}', "");
    Expect(1, 12288, '\p{	Zs}', "");
    Expect(0, 12288, '\p{^	Zs}', "");
    Expect(0, 12288, '\P{	Zs}', "");
    Expect(1, 12288, '\P{^	Zs}', "");
    Expect(0, 12289, '\p{	Zs}', "");
    Expect(1, 12289, '\p{^	Zs}', "");
    Expect(1, 12289, '\P{	Zs}', "");
    Expect(0, 12289, '\P{^	Zs}', "");
    Error('\p{/a/is_ZS}');
    Error('\P{/a/is_ZS}');
    Expect(1, 12288, '\p{iszs}', "");
    Expect(0, 12288, '\p{^iszs}', "");
    Expect(0, 12288, '\P{iszs}', "");
    Expect(1, 12288, '\P{^iszs}', "");
    Expect(0, 12289, '\p{iszs}', "");
    Expect(1, 12289, '\p{^iszs}', "");
    Expect(1, 12289, '\P{iszs}', "");
    Expect(0, 12289, '\P{^iszs}', "");
    Expect(1, 12288, '\p{ 	Is_Zs}', "");
    Expect(0, 12288, '\p{^ 	Is_Zs}', "");
    Expect(0, 12288, '\P{ 	Is_Zs}', "");
    Expect(1, 12288, '\P{^ 	Is_Zs}', "");
    Expect(0, 12289, '\p{ 	Is_Zs}', "");
    Expect(1, 12289, '\p{^ 	Is_Zs}', "");
    Expect(1, 12289, '\P{ 	Is_Zs}', "");
    Expect(0, 12289, '\P{^ 	Is_Zs}', "");
    Error('\p{:= spacing_Mark}');
    Error('\P{:= spacing_Mark}');
    Expect(1, 119154, '\p{spacingmark}', "");
    Expect(0, 119154, '\p{^spacingmark}', "");
    Expect(0, 119154, '\P{spacingmark}', "");
    Expect(1, 119154, '\P{^spacingmark}', "");
    Expect(0, 119155, '\p{spacingmark}', "");
    Expect(1, 119155, '\p{^spacingmark}', "");
    Expect(1, 119155, '\P{spacingmark}', "");
    Expect(0, 119155, '\P{^spacingmark}', "");
    Expect(1, 119154, '\p{_	SPACING_MARK}', "");
    Expect(0, 119154, '\p{^_	SPACING_MARK}', "");
    Expect(0, 119154, '\P{_	SPACING_MARK}', "");
    Expect(1, 119154, '\P{^_	SPACING_MARK}', "");
    Expect(0, 119155, '\p{_	SPACING_MARK}', "");
    Expect(1, 119155, '\p{^_	SPACING_MARK}', "");
    Expect(1, 119155, '\P{_	SPACING_MARK}', "");
    Expect(0, 119155, '\P{^_	SPACING_MARK}', "");
    Error('\p{:=- Is_Spacing_Mark}');
    Error('\P{:=- Is_Spacing_Mark}');
    Expect(1, 119154, '\p{isspacingmark}', "");
    Expect(0, 119154, '\p{^isspacingmark}', "");
    Expect(0, 119154, '\P{isspacingmark}', "");
    Expect(1, 119154, '\P{^isspacingmark}', "");
    Expect(0, 119155, '\p{isspacingmark}', "");
    Expect(1, 119155, '\p{^isspacingmark}', "");
    Expect(1, 119155, '\P{isspacingmark}', "");
    Expect(0, 119155, '\P{^isspacingmark}', "");
    Expect(1, 119154, '\p{	is_Spacing_Mark}', "");
    Expect(0, 119154, '\p{^	is_Spacing_Mark}', "");
    Expect(0, 119154, '\P{	is_Spacing_Mark}', "");
    Expect(1, 119154, '\P{^	is_Spacing_Mark}', "");
    Expect(0, 119155, '\p{	is_Spacing_Mark}', "");
    Expect(1, 119155, '\p{^	is_Spacing_Mark}', "");
    Expect(1, 119155, '\P{	is_Spacing_Mark}', "");
    Expect(0, 119155, '\P{^	is_Spacing_Mark}', "");
    Error('\p{ Mc:=}');
    Error('\P{ Mc:=}');
    Expect(1, 119154, '\p{mc}', "");
    Expect(0, 119154, '\p{^mc}', "");
    Expect(0, 119154, '\P{mc}', "");
    Expect(1, 119154, '\P{^mc}', "");
    Expect(0, 119155, '\p{mc}', "");
    Expect(1, 119155, '\p{^mc}', "");
    Expect(1, 119155, '\P{mc}', "");
    Expect(0, 119155, '\P{^mc}', "");
    Expect(1, 119154, '\p{_Mc}', "");
    Expect(0, 119154, '\p{^_Mc}', "");
    Expect(0, 119154, '\P{_Mc}', "");
    Expect(1, 119154, '\P{^_Mc}', "");
    Expect(0, 119155, '\p{_Mc}', "");
    Expect(1, 119155, '\p{^_Mc}', "");
    Expect(1, 119155, '\P{_Mc}', "");
    Expect(0, 119155, '\P{^_Mc}', "");
    Error('\p{_-is_Mc/a/}');
    Error('\P{_-is_Mc/a/}');
    Expect(1, 119154, '\p{ismc}', "");
    Expect(0, 119154, '\p{^ismc}', "");
    Expect(0, 119154, '\P{ismc}', "");
    Expect(1, 119154, '\P{^ismc}', "");
    Expect(0, 119155, '\p{ismc}', "");
    Expect(1, 119155, '\p{^ismc}', "");
    Expect(1, 119155, '\P{ismc}', "");
    Expect(0, 119155, '\P{^ismc}', "");
    Expect(1, 119154, '\p{ 	Is_mc}', "");
    Expect(0, 119154, '\p{^ 	Is_mc}', "");
    Expect(0, 119154, '\P{ 	Is_mc}', "");
    Expect(1, 119154, '\P{^ 	Is_mc}', "");
    Expect(0, 119155, '\p{ 	Is_mc}', "");
    Expect(1, 119155, '\p{^ 	Is_mc}', "");
    Expect(1, 119155, '\P{ 	Is_mc}', "");
    Expect(0, 119155, '\P{^ 	Is_mc}', "");
    Error('\p{	:=Spacing_Modifier_Letters}');
    Error('\P{	:=Spacing_Modifier_Letters}');
    Expect(1, 767, '\p{spacingmodifierletters}', "");
    Expect(0, 767, '\p{^spacingmodifierletters}', "");
    Expect(0, 767, '\P{spacingmodifierletters}', "");
    Expect(1, 767, '\P{^spacingmodifierletters}', "");
    Expect(0, 768, '\p{spacingmodifierletters}', "");
    Expect(1, 768, '\p{^spacingmodifierletters}', "");
    Expect(1, 768, '\P{spacingmodifierletters}', "");
    Expect(0, 768, '\P{^spacingmodifierletters}', "");
    Expect(1, 767, '\p{ 	SPACING_modifier_LETTERS}', "");
    Expect(0, 767, '\p{^ 	SPACING_modifier_LETTERS}', "");
    Expect(0, 767, '\P{ 	SPACING_modifier_LETTERS}', "");
    Expect(1, 767, '\P{^ 	SPACING_modifier_LETTERS}', "");
    Expect(0, 768, '\p{ 	SPACING_modifier_LETTERS}', "");
    Expect(1, 768, '\p{^ 	SPACING_modifier_LETTERS}', "");
    Expect(1, 768, '\P{ 	SPACING_modifier_LETTERS}', "");
    Expect(0, 768, '\P{^ 	SPACING_modifier_LETTERS}', "");
    Error('\p{:=__Is_Spacing_MODIFIER_Letters}');
    Error('\P{:=__Is_Spacing_MODIFIER_Letters}');
    Expect(1, 767, '\p{isspacingmodifierletters}', "");
    Expect(0, 767, '\p{^isspacingmodifierletters}', "");
    Expect(0, 767, '\P{isspacingmodifierletters}', "");
    Expect(1, 767, '\P{^isspacingmodifierletters}', "");
    Expect(0, 768, '\p{isspacingmodifierletters}', "");
    Expect(1, 768, '\p{^isspacingmodifierletters}', "");
    Expect(1, 768, '\P{isspacingmodifierletters}', "");
    Expect(0, 768, '\P{^isspacingmodifierletters}', "");
    Expect(1, 767, '\p{ 	is_SPACING_MODIFIER_LETTERS}', "");
    Expect(0, 767, '\p{^ 	is_SPACING_MODIFIER_LETTERS}', "");
    Expect(0, 767, '\P{ 	is_SPACING_MODIFIER_LETTERS}', "");
    Expect(1, 767, '\P{^ 	is_SPACING_MODIFIER_LETTERS}', "");
    Expect(0, 768, '\p{ 	is_SPACING_MODIFIER_LETTERS}', "");
    Expect(1, 768, '\p{^ 	is_SPACING_MODIFIER_LETTERS}', "");
    Expect(1, 768, '\P{ 	is_SPACING_MODIFIER_LETTERS}', "");
    Expect(0, 768, '\P{^ 	is_SPACING_MODIFIER_LETTERS}', "");
    Error('\p{ :=In_Spacing_modifier_Letters}');
    Error('\P{ :=In_Spacing_modifier_Letters}');
    Expect(1, 767, '\p{inspacingmodifierletters}', "");
    Expect(0, 767, '\p{^inspacingmodifierletters}', "");
    Expect(0, 767, '\P{inspacingmodifierletters}', "");
    Expect(1, 767, '\P{^inspacingmodifierletters}', "");
    Expect(0, 768, '\p{inspacingmodifierletters}', "");
    Expect(1, 768, '\p{^inspacingmodifierletters}', "");
    Expect(1, 768, '\P{inspacingmodifierletters}', "");
    Expect(0, 768, '\P{^inspacingmodifierletters}', "");
    Expect(1, 767, '\p{ -In_SPACING_Modifier_LETTERS}', "");
    Expect(0, 767, '\p{^ -In_SPACING_Modifier_LETTERS}', "");
    Expect(0, 767, '\P{ -In_SPACING_Modifier_LETTERS}', "");
    Expect(1, 767, '\P{^ -In_SPACING_Modifier_LETTERS}', "");
    Expect(0, 768, '\p{ -In_SPACING_Modifier_LETTERS}', "");
    Expect(1, 768, '\p{^ -In_SPACING_Modifier_LETTERS}', "");
    Expect(1, 768, '\P{ -In_SPACING_Modifier_LETTERS}', "");
    Expect(0, 768, '\P{^ -In_SPACING_Modifier_LETTERS}', "");
    Error('\p{ 	MODIFIER_letters:=}');
    Error('\P{ 	MODIFIER_letters:=}');
    Expect(1, 767, '\p{modifierletters}', "");
    Expect(0, 767, '\p{^modifierletters}', "");
    Expect(0, 767, '\P{modifierletters}', "");
    Expect(1, 767, '\P{^modifierletters}', "");
    Expect(0, 768, '\p{modifierletters}', "");
    Expect(1, 768, '\p{^modifierletters}', "");
    Expect(1, 768, '\P{modifierletters}', "");
    Expect(0, 768, '\P{^modifierletters}', "");
    Expect(1, 767, '\p{-Modifier_LETTERS}', "");
    Expect(0, 767, '\p{^-Modifier_LETTERS}', "");
    Expect(0, 767, '\P{-Modifier_LETTERS}', "");
    Expect(1, 767, '\P{^-Modifier_LETTERS}', "");
    Expect(0, 768, '\p{-Modifier_LETTERS}', "");
    Expect(1, 768, '\p{^-Modifier_LETTERS}', "");
    Expect(1, 768, '\P{-Modifier_LETTERS}', "");
    Expect(0, 768, '\P{^-Modifier_LETTERS}', "");
    Error('\p{:=IS_Modifier_Letters}');
    Error('\P{:=IS_Modifier_Letters}');
    Expect(1, 767, '\p{ismodifierletters}', "");
    Expect(0, 767, '\p{^ismodifierletters}', "");
    Expect(0, 767, '\P{ismodifierletters}', "");
    Expect(1, 767, '\P{^ismodifierletters}', "");
    Expect(0, 768, '\p{ismodifierletters}', "");
    Expect(1, 768, '\p{^ismodifierletters}', "");
    Expect(1, 768, '\P{ismodifierletters}', "");
    Expect(0, 768, '\P{^ismodifierletters}', "");
    Expect(1, 767, '\p{	Is_modifier_letters}', "");
    Expect(0, 767, '\p{^	Is_modifier_letters}', "");
    Expect(0, 767, '\P{	Is_modifier_letters}', "");
    Expect(1, 767, '\P{^	Is_modifier_letters}', "");
    Expect(0, 768, '\p{	Is_modifier_letters}', "");
    Expect(1, 768, '\p{^	Is_modifier_letters}', "");
    Expect(1, 768, '\P{	Is_modifier_letters}', "");
    Expect(0, 768, '\P{^	Is_modifier_letters}', "");
    Error('\p{:=IN_MODIFIER_Letters}');
    Error('\P{:=IN_MODIFIER_Letters}');
    Expect(1, 767, '\p{inmodifierletters}', "");
    Expect(0, 767, '\p{^inmodifierletters}', "");
    Expect(0, 767, '\P{inmodifierletters}', "");
    Expect(1, 767, '\P{^inmodifierletters}', "");
    Expect(0, 768, '\p{inmodifierletters}', "");
    Expect(1, 768, '\p{^inmodifierletters}', "");
    Expect(1, 768, '\P{inmodifierletters}', "");
    Expect(0, 768, '\P{^inmodifierletters}', "");
    Expect(1, 767, '\p{ -In_Modifier_letters}', "");
    Expect(0, 767, '\p{^ -In_Modifier_letters}', "");
    Expect(0, 767, '\P{ -In_Modifier_letters}', "");
    Expect(1, 767, '\P{^ -In_Modifier_letters}', "");
    Expect(0, 768, '\p{ -In_Modifier_letters}', "");
    Expect(1, 768, '\p{^ -In_Modifier_letters}', "");
    Expect(1, 768, '\P{ -In_Modifier_letters}', "");
    Expect(0, 768, '\P{^ -In_Modifier_letters}', "");
    Error('\p{ _Specials/a/}');
    Error('\P{ _Specials/a/}');
    Expect(1, 65520, '\p{specials}', "");
    Expect(0, 65520, '\p{^specials}', "");
    Expect(0, 65520, '\P{specials}', "");
    Expect(1, 65520, '\P{^specials}', "");
    Expect(0, 65536, '\p{specials}', "");
    Expect(1, 65536, '\p{^specials}', "");
    Expect(1, 65536, '\P{specials}', "");
    Expect(0, 65536, '\P{^specials}', "");
    Expect(1, 65520, '\p{	 specials}', "");
    Expect(0, 65520, '\p{^	 specials}', "");
    Expect(0, 65520, '\P{	 specials}', "");
    Expect(1, 65520, '\P{^	 specials}', "");
    Expect(0, 65536, '\p{	 specials}', "");
    Expect(1, 65536, '\p{^	 specials}', "");
    Expect(1, 65536, '\P{	 specials}', "");
    Expect(0, 65536, '\P{^	 specials}', "");
    Error('\p{:=_	is_Specials}');
    Error('\P{:=_	is_Specials}');
    Expect(1, 65520, '\p{isspecials}', "");
    Expect(0, 65520, '\p{^isspecials}', "");
    Expect(0, 65520, '\P{isspecials}', "");
    Expect(1, 65520, '\P{^isspecials}', "");
    Expect(0, 65536, '\p{isspecials}', "");
    Expect(1, 65536, '\p{^isspecials}', "");
    Expect(1, 65536, '\P{isspecials}', "");
    Expect(0, 65536, '\P{^isspecials}', "");
    Expect(1, 65520, '\p{_	Is_specials}', "");
    Expect(0, 65520, '\p{^_	Is_specials}', "");
    Expect(0, 65520, '\P{_	Is_specials}', "");
    Expect(1, 65520, '\P{^_	Is_specials}', "");
    Expect(0, 65536, '\p{_	Is_specials}', "");
    Expect(1, 65536, '\p{^_	Is_specials}', "");
    Expect(1, 65536, '\P{_	Is_specials}', "");
    Expect(0, 65536, '\P{^_	Is_specials}', "");
    Error('\p{_	In_specials:=}');
    Error('\P{_	In_specials:=}');
    Expect(1, 65520, '\p{inspecials}', "");
    Expect(0, 65520, '\p{^inspecials}', "");
    Expect(0, 65520, '\P{inspecials}', "");
    Expect(1, 65520, '\P{^inspecials}', "");
    Expect(0, 65536, '\p{inspecials}', "");
    Expect(1, 65536, '\p{^inspecials}', "");
    Expect(1, 65536, '\P{inspecials}', "");
    Expect(0, 65536, '\P{^inspecials}', "");
    Expect(1, 65520, '\p{_ in_Specials}', "");
    Expect(0, 65520, '\p{^_ in_Specials}', "");
    Expect(0, 65520, '\P{_ in_Specials}', "");
    Expect(1, 65520, '\P{^_ in_Specials}', "");
    Expect(0, 65536, '\p{_ in_Specials}', "");
    Expect(1, 65536, '\p{^_ in_Specials}', "");
    Expect(1, 65536, '\P{_ in_Specials}', "");
    Expect(0, 65536, '\P{^_ in_Specials}', "");
    Error('\p{ Sundanese:=}');
    Error('\P{ Sundanese:=}');
    Expect(1, 7367, '\p{sundanese}', "");
    Expect(0, 7367, '\p{^sundanese}', "");
    Expect(0, 7367, '\P{sundanese}', "");
    Expect(1, 7367, '\P{^sundanese}', "");
    Expect(0, 7368, '\p{sundanese}', "");
    Expect(1, 7368, '\p{^sundanese}', "");
    Expect(1, 7368, '\P{sundanese}', "");
    Expect(0, 7368, '\P{^sundanese}', "");
    Expect(1, 7367, '\p{_Sundanese}', "");
    Expect(0, 7367, '\p{^_Sundanese}', "");
    Expect(0, 7367, '\P{_Sundanese}', "");
    Expect(1, 7367, '\P{^_Sundanese}', "");
    Expect(0, 7368, '\p{_Sundanese}', "");
    Expect(1, 7368, '\p{^_Sundanese}', "");
    Expect(1, 7368, '\P{_Sundanese}', "");
    Expect(0, 7368, '\P{^_Sundanese}', "");
    Error('\p{	-Is_sundanese:=}');
    Error('\P{	-Is_sundanese:=}');
    Expect(1, 7367, '\p{issundanese}', "");
    Expect(0, 7367, '\p{^issundanese}', "");
    Expect(0, 7367, '\P{issundanese}', "");
    Expect(1, 7367, '\P{^issundanese}', "");
    Expect(0, 7368, '\p{issundanese}', "");
    Expect(1, 7368, '\p{^issundanese}', "");
    Expect(1, 7368, '\P{issundanese}', "");
    Expect(0, 7368, '\P{^issundanese}', "");
    Expect(1, 7367, '\p{	_IS_Sundanese}', "");
    Expect(0, 7367, '\p{^	_IS_Sundanese}', "");
    Expect(0, 7367, '\P{	_IS_Sundanese}', "");
    Expect(1, 7367, '\P{^	_IS_Sundanese}', "");
    Expect(0, 7368, '\p{	_IS_Sundanese}', "");
    Expect(1, 7368, '\p{^	_IS_Sundanese}', "");
    Expect(1, 7368, '\P{	_IS_Sundanese}', "");
    Expect(0, 7368, '\P{^	_IS_Sundanese}', "");
    Error('\p{  sund:=}');
    Error('\P{  sund:=}');
    Expect(1, 7367, '\p{sund}', "");
    Expect(0, 7367, '\p{^sund}', "");
    Expect(0, 7367, '\P{sund}', "");
    Expect(1, 7367, '\P{^sund}', "");
    Expect(0, 7368, '\p{sund}', "");
    Expect(1, 7368, '\p{^sund}', "");
    Expect(1, 7368, '\P{sund}', "");
    Expect(0, 7368, '\P{^sund}', "");
    Expect(1, 7367, '\p{  Sund}', "");
    Expect(0, 7367, '\p{^  Sund}', "");
    Expect(0, 7367, '\P{  Sund}', "");
    Expect(1, 7367, '\P{^  Sund}', "");
    Expect(0, 7368, '\p{  Sund}', "");
    Expect(1, 7368, '\p{^  Sund}', "");
    Expect(1, 7368, '\P{  Sund}', "");
    Expect(0, 7368, '\P{^  Sund}', "");
    Error('\p{/a/IS_sund}');
    Error('\P{/a/IS_sund}');
    Expect(1, 7367, '\p{issund}', "");
    Expect(0, 7367, '\p{^issund}', "");
    Expect(0, 7367, '\P{issund}', "");
    Expect(1, 7367, '\P{^issund}', "");
    Expect(0, 7368, '\p{issund}', "");
    Expect(1, 7368, '\p{^issund}', "");
    Expect(1, 7368, '\P{issund}', "");
    Expect(0, 7368, '\P{^issund}', "");
    Expect(1, 7367, '\p{ is_Sund}', "");
    Expect(0, 7367, '\p{^ is_Sund}', "");
    Expect(0, 7367, '\P{ is_Sund}', "");
    Expect(1, 7367, '\P{^ is_Sund}', "");
    Expect(0, 7368, '\p{ is_Sund}', "");
    Expect(1, 7368, '\p{^ is_Sund}', "");
    Expect(1, 7368, '\P{ is_Sund}', "");
    Expect(0, 7368, '\P{^ is_Sund}', "");
    Error('\p{	:=Sundanese_Supplement}');
    Error('\P{	:=Sundanese_Supplement}');
    Expect(1, 7375, '\p{sundanesesupplement}', "");
    Expect(0, 7375, '\p{^sundanesesupplement}', "");
    Expect(0, 7375, '\P{sundanesesupplement}', "");
    Expect(1, 7375, '\P{^sundanesesupplement}', "");
    Expect(0, 7376, '\p{sundanesesupplement}', "");
    Expect(1, 7376, '\p{^sundanesesupplement}', "");
    Expect(1, 7376, '\P{sundanesesupplement}', "");
    Expect(0, 7376, '\P{^sundanesesupplement}', "");
    Expect(1, 7375, '\p{ 	Sundanese_Supplement}', "");
    Expect(0, 7375, '\p{^ 	Sundanese_Supplement}', "");
    Expect(0, 7375, '\P{ 	Sundanese_Supplement}', "");
    Expect(1, 7375, '\P{^ 	Sundanese_Supplement}', "");
    Expect(0, 7376, '\p{ 	Sundanese_Supplement}', "");
    Expect(1, 7376, '\p{^ 	Sundanese_Supplement}', "");
    Expect(1, 7376, '\P{ 	Sundanese_Supplement}', "");
    Expect(0, 7376, '\P{^ 	Sundanese_Supplement}', "");
    Error('\p{/a/ -IS_Sundanese_Supplement}');
    Error('\P{/a/ -IS_Sundanese_Supplement}');
    Expect(1, 7375, '\p{issundanesesupplement}', "");
    Expect(0, 7375, '\p{^issundanesesupplement}', "");
    Expect(0, 7375, '\P{issundanesesupplement}', "");
    Expect(1, 7375, '\P{^issundanesesupplement}', "");
    Expect(0, 7376, '\p{issundanesesupplement}', "");
    Expect(1, 7376, '\p{^issundanesesupplement}', "");
    Expect(1, 7376, '\P{issundanesesupplement}', "");
    Expect(0, 7376, '\P{^issundanesesupplement}', "");
    Expect(1, 7375, '\p{--is_sundanese_SUPPLEMENT}', "");
    Expect(0, 7375, '\p{^--is_sundanese_SUPPLEMENT}', "");
    Expect(0, 7375, '\P{--is_sundanese_SUPPLEMENT}', "");
    Expect(1, 7375, '\P{^--is_sundanese_SUPPLEMENT}', "");
    Expect(0, 7376, '\p{--is_sundanese_SUPPLEMENT}', "");
    Expect(1, 7376, '\p{^--is_sundanese_SUPPLEMENT}', "");
    Expect(1, 7376, '\P{--is_sundanese_SUPPLEMENT}', "");
    Expect(0, 7376, '\P{^--is_sundanese_SUPPLEMENT}', "");
    Error('\p{-:=IN_Sundanese_Supplement}');
    Error('\P{-:=IN_Sundanese_Supplement}');
    Expect(1, 7375, '\p{insundanesesupplement}', "");
    Expect(0, 7375, '\p{^insundanesesupplement}', "");
    Expect(0, 7375, '\P{insundanesesupplement}', "");
    Expect(1, 7375, '\P{^insundanesesupplement}', "");
    Expect(0, 7376, '\p{insundanesesupplement}', "");
    Expect(1, 7376, '\p{^insundanesesupplement}', "");
    Expect(1, 7376, '\P{insundanesesupplement}', "");
    Expect(0, 7376, '\P{^insundanesesupplement}', "");
    Expect(1, 7375, '\p{__In_Sundanese_Supplement}', "");
    Expect(0, 7375, '\p{^__In_Sundanese_Supplement}', "");
    Expect(0, 7375, '\P{__In_Sundanese_Supplement}', "");
    Expect(1, 7375, '\P{^__In_Sundanese_Supplement}', "");
    Expect(0, 7376, '\p{__In_Sundanese_Supplement}', "");
    Expect(1, 7376, '\p{^__In_Sundanese_Supplement}', "");
    Expect(1, 7376, '\P{__In_Sundanese_Supplement}', "");
    Expect(0, 7376, '\P{^__In_Sundanese_Supplement}', "");
    Error('\p{/a/Sundanese_SUP}');
    Error('\P{/a/Sundanese_SUP}');
    Expect(1, 7375, '\p{sundanesesup}', "");
    Expect(0, 7375, '\p{^sundanesesup}', "");
    Expect(0, 7375, '\P{sundanesesup}', "");
    Expect(1, 7375, '\P{^sundanesesup}', "");
    Expect(0, 7376, '\p{sundanesesup}', "");
    Expect(1, 7376, '\p{^sundanesesup}', "");
    Expect(1, 7376, '\P{sundanesesup}', "");
    Expect(0, 7376, '\P{^sundanesesup}', "");
    Expect(1, 7375, '\p{		Sundanese_SUP}', "");
    Expect(0, 7375, '\p{^		Sundanese_SUP}', "");
    Expect(0, 7375, '\P{		Sundanese_SUP}', "");
    Expect(1, 7375, '\P{^		Sundanese_SUP}', "");
    Expect(0, 7376, '\p{		Sundanese_SUP}', "");
    Expect(1, 7376, '\p{^		Sundanese_SUP}', "");
    Expect(1, 7376, '\P{		Sundanese_SUP}', "");
    Expect(0, 7376, '\P{^		Sundanese_SUP}', "");
    Error('\p{_IS_Sundanese_Sup/a/}');
    Error('\P{_IS_Sundanese_Sup/a/}');
    Expect(1, 7375, '\p{issundanesesup}', "");
    Expect(0, 7375, '\p{^issundanesesup}', "");
    Expect(0, 7375, '\P{issundanesesup}', "");
    Expect(1, 7375, '\P{^issundanesesup}', "");
    Expect(0, 7376, '\p{issundanesesup}', "");
    Expect(1, 7376, '\p{^issundanesesup}', "");
    Expect(1, 7376, '\P{issundanesesup}', "");
    Expect(0, 7376, '\P{^issundanesesup}', "");
    Expect(1, 7375, '\p{--Is_SUNDANESE_Sup}', "");
    Expect(0, 7375, '\p{^--Is_SUNDANESE_Sup}', "");
    Expect(0, 7375, '\P{--Is_SUNDANESE_Sup}', "");
    Expect(1, 7375, '\P{^--Is_SUNDANESE_Sup}', "");
    Expect(0, 7376, '\p{--Is_SUNDANESE_Sup}', "");
    Expect(1, 7376, '\p{^--Is_SUNDANESE_Sup}', "");
    Expect(1, 7376, '\P{--Is_SUNDANESE_Sup}', "");
    Expect(0, 7376, '\P{^--Is_SUNDANESE_Sup}', "");
    Error('\p{:= 	IN_Sundanese_SUP}');
    Error('\P{:= 	IN_Sundanese_SUP}');
    Expect(1, 7375, '\p{insundanesesup}', "");
    Expect(0, 7375, '\p{^insundanesesup}', "");
    Expect(0, 7375, '\P{insundanesesup}', "");
    Expect(1, 7375, '\P{^insundanesesup}', "");
    Expect(0, 7376, '\p{insundanesesup}', "");
    Expect(1, 7376, '\p{^insundanesesup}', "");
    Expect(1, 7376, '\P{insundanesesup}', "");
    Expect(0, 7376, '\P{^insundanesesup}', "");
    Expect(1, 7375, '\p{		IN_sundanese_sup}', "");
    Expect(0, 7375, '\p{^		IN_sundanese_sup}', "");
    Expect(0, 7375, '\P{		IN_sundanese_sup}', "");
    Expect(1, 7375, '\P{^		IN_sundanese_sup}', "");
    Expect(0, 7376, '\p{		IN_sundanese_sup}', "");
    Expect(1, 7376, '\p{^		IN_sundanese_sup}', "");
    Expect(1, 7376, '\P{		IN_sundanese_sup}', "");
    Expect(0, 7376, '\P{^		IN_sundanese_sup}', "");
    Error('\p{_ Superscripts_And_subscripts:=}');
    Error('\P{_ Superscripts_And_subscripts:=}');
    Expect(1, 8351, '\p{superscriptsandsubscripts}', "");
    Expect(0, 8351, '\p{^superscriptsandsubscripts}', "");
    Expect(0, 8351, '\P{superscriptsandsubscripts}', "");
    Expect(1, 8351, '\P{^superscriptsandsubscripts}', "");
    Expect(0, 8352, '\p{superscriptsandsubscripts}', "");
    Expect(1, 8352, '\p{^superscriptsandsubscripts}', "");
    Expect(1, 8352, '\P{superscriptsandsubscripts}', "");
    Expect(0, 8352, '\P{^superscriptsandsubscripts}', "");
    Expect(1, 8351, '\p{	-SUPERSCRIPTS_AND_subscripts}', "");
    Expect(0, 8351, '\p{^	-SUPERSCRIPTS_AND_subscripts}', "");
    Expect(0, 8351, '\P{	-SUPERSCRIPTS_AND_subscripts}', "");
    Expect(1, 8351, '\P{^	-SUPERSCRIPTS_AND_subscripts}', "");
    Expect(0, 8352, '\p{	-SUPERSCRIPTS_AND_subscripts}', "");
    Expect(1, 8352, '\p{^	-SUPERSCRIPTS_AND_subscripts}', "");
    Expect(1, 8352, '\P{	-SUPERSCRIPTS_AND_subscripts}', "");
    Expect(0, 8352, '\P{^	-SUPERSCRIPTS_AND_subscripts}', "");
    Error('\p{/a/is_Superscripts_and_Subscripts}');
    Error('\P{/a/is_Superscripts_and_Subscripts}');
    Expect(1, 8351, '\p{issuperscriptsandsubscripts}', "");
    Expect(0, 8351, '\p{^issuperscriptsandsubscripts}', "");
    Expect(0, 8351, '\P{issuperscriptsandsubscripts}', "");
    Expect(1, 8351, '\P{^issuperscriptsandsubscripts}', "");
    Expect(0, 8352, '\p{issuperscriptsandsubscripts}', "");
    Expect(1, 8352, '\p{^issuperscriptsandsubscripts}', "");
    Expect(1, 8352, '\P{issuperscriptsandsubscripts}', "");
    Expect(0, 8352, '\P{^issuperscriptsandsubscripts}', "");
    Expect(1, 8351, '\p{_-IS_SUPERSCRIPTS_and_Subscripts}', "");
    Expect(0, 8351, '\p{^_-IS_SUPERSCRIPTS_and_Subscripts}', "");
    Expect(0, 8351, '\P{_-IS_SUPERSCRIPTS_and_Subscripts}', "");
    Expect(1, 8351, '\P{^_-IS_SUPERSCRIPTS_and_Subscripts}', "");
    Expect(0, 8352, '\p{_-IS_SUPERSCRIPTS_and_Subscripts}', "");
    Expect(1, 8352, '\p{^_-IS_SUPERSCRIPTS_and_Subscripts}', "");
    Expect(1, 8352, '\P{_-IS_SUPERSCRIPTS_and_Subscripts}', "");
    Expect(0, 8352, '\P{^_-IS_SUPERSCRIPTS_and_Subscripts}', "");
    Error('\p{  In_Superscripts_and_Subscripts:=}');
    Error('\P{  In_Superscripts_and_Subscripts:=}');
    Expect(1, 8351, '\p{insuperscriptsandsubscripts}', "");
    Expect(0, 8351, '\p{^insuperscriptsandsubscripts}', "");
    Expect(0, 8351, '\P{insuperscriptsandsubscripts}', "");
    Expect(1, 8351, '\P{^insuperscriptsandsubscripts}', "");
    Expect(0, 8352, '\p{insuperscriptsandsubscripts}', "");
    Expect(1, 8352, '\p{^insuperscriptsandsubscripts}', "");
    Expect(1, 8352, '\P{insuperscriptsandsubscripts}', "");
    Expect(0, 8352, '\P{^insuperscriptsandsubscripts}', "");
    Expect(1, 8351, '\p{_-In_SUPERSCRIPTS_And_subscripts}', "");
    Expect(0, 8351, '\p{^_-In_SUPERSCRIPTS_And_subscripts}', "");
    Expect(0, 8351, '\P{_-In_SUPERSCRIPTS_And_subscripts}', "");
    Expect(1, 8351, '\P{^_-In_SUPERSCRIPTS_And_subscripts}', "");
    Expect(0, 8352, '\p{_-In_SUPERSCRIPTS_And_subscripts}', "");
    Expect(1, 8352, '\p{^_-In_SUPERSCRIPTS_And_subscripts}', "");
    Expect(1, 8352, '\P{_-In_SUPERSCRIPTS_And_subscripts}', "");
    Expect(0, 8352, '\P{^_-In_SUPERSCRIPTS_And_subscripts}', "");
    Error('\p{_:=Super_And_sub}');
    Error('\P{_:=Super_And_sub}');
    Expect(1, 8351, '\p{superandsub}', "");
    Expect(0, 8351, '\p{^superandsub}', "");
    Expect(0, 8351, '\P{superandsub}', "");
    Expect(1, 8351, '\P{^superandsub}', "");
    Expect(0, 8352, '\p{superandsub}', "");
    Expect(1, 8352, '\p{^superandsub}', "");
    Expect(1, 8352, '\P{superandsub}', "");
    Expect(0, 8352, '\P{^superandsub}', "");
    Expect(1, 8351, '\p{_ Super_and_sub}', "");
    Expect(0, 8351, '\p{^_ Super_and_sub}', "");
    Expect(0, 8351, '\P{_ Super_and_sub}', "");
    Expect(1, 8351, '\P{^_ Super_and_sub}', "");
    Expect(0, 8352, '\p{_ Super_and_sub}', "");
    Expect(1, 8352, '\p{^_ Super_and_sub}', "");
    Expect(1, 8352, '\P{_ Super_and_sub}', "");
    Expect(0, 8352, '\P{^_ Super_and_sub}', "");
    Error('\p{	 IS_Super_and_Sub:=}');
    Error('\P{	 IS_Super_and_Sub:=}');
    Expect(1, 8351, '\p{issuperandsub}', "");
    Expect(0, 8351, '\p{^issuperandsub}', "");
    Expect(0, 8351, '\P{issuperandsub}', "");
    Expect(1, 8351, '\P{^issuperandsub}', "");
    Expect(0, 8352, '\p{issuperandsub}', "");
    Expect(1, 8352, '\p{^issuperandsub}', "");
    Expect(1, 8352, '\P{issuperandsub}', "");
    Expect(0, 8352, '\P{^issuperandsub}', "");
    Expect(1, 8351, '\p{ is_SUPER_AND_SUB}', "");
    Expect(0, 8351, '\p{^ is_SUPER_AND_SUB}', "");
    Expect(0, 8351, '\P{ is_SUPER_AND_SUB}', "");
    Expect(1, 8351, '\P{^ is_SUPER_AND_SUB}', "");
    Expect(0, 8352, '\p{ is_SUPER_AND_SUB}', "");
    Expect(1, 8352, '\p{^ is_SUPER_AND_SUB}', "");
    Expect(1, 8352, '\P{ is_SUPER_AND_SUB}', "");
    Expect(0, 8352, '\P{^ is_SUPER_AND_SUB}', "");
    Error('\p{	IN_super_And_Sub:=}');
    Error('\P{	IN_super_And_Sub:=}');
    Expect(1, 8351, '\p{insuperandsub}', "");
    Expect(0, 8351, '\p{^insuperandsub}', "");
    Expect(0, 8351, '\P{insuperandsub}', "");
    Expect(1, 8351, '\P{^insuperandsub}', "");
    Expect(0, 8352, '\p{insuperandsub}', "");
    Expect(1, 8352, '\p{^insuperandsub}', "");
    Expect(1, 8352, '\P{insuperandsub}', "");
    Expect(0, 8352, '\P{^insuperandsub}', "");
    Expect(1, 8351, '\p{--In_super_AND_SUB}', "");
    Expect(0, 8351, '\p{^--In_super_AND_SUB}', "");
    Expect(0, 8351, '\P{--In_super_AND_SUB}', "");
    Expect(1, 8351, '\P{^--In_super_AND_SUB}', "");
    Expect(0, 8352, '\p{--In_super_AND_SUB}', "");
    Expect(1, 8352, '\p{^--In_super_AND_SUB}', "");
    Expect(1, 8352, '\P{--In_super_AND_SUB}', "");
    Expect(0, 8352, '\P{^--In_super_AND_SUB}', "");
    Error('\p{/a/-Supplemental_arrows_A}');
    Error('\P{/a/-Supplemental_arrows_A}');
    Expect(1, 10239, '\p{supplementalarrowsa}', "");
    Expect(0, 10239, '\p{^supplementalarrowsa}', "");
    Expect(0, 10239, '\P{supplementalarrowsa}', "");
    Expect(1, 10239, '\P{^supplementalarrowsa}', "");
    Expect(0, 10240, '\p{supplementalarrowsa}', "");
    Expect(1, 10240, '\p{^supplementalarrowsa}', "");
    Expect(1, 10240, '\P{supplementalarrowsa}', "");
    Expect(0, 10240, '\P{^supplementalarrowsa}', "");
    Expect(1, 10239, '\p{ 	Supplemental_Arrows_A}', "");
    Expect(0, 10239, '\p{^ 	Supplemental_Arrows_A}', "");
    Expect(0, 10239, '\P{ 	Supplemental_Arrows_A}', "");
    Expect(1, 10239, '\P{^ 	Supplemental_Arrows_A}', "");
    Expect(0, 10240, '\p{ 	Supplemental_Arrows_A}', "");
    Expect(1, 10240, '\p{^ 	Supplemental_Arrows_A}', "");
    Expect(1, 10240, '\P{ 	Supplemental_Arrows_A}', "");
    Expect(0, 10240, '\P{^ 	Supplemental_Arrows_A}', "");
    Error('\p{:= -is_Supplemental_Arrows_a}');
    Error('\P{:= -is_Supplemental_Arrows_a}');
    Expect(1, 10239, '\p{issupplementalarrowsa}', "");
    Expect(0, 10239, '\p{^issupplementalarrowsa}', "");
    Expect(0, 10239, '\P{issupplementalarrowsa}', "");
    Expect(1, 10239, '\P{^issupplementalarrowsa}', "");
    Expect(0, 10240, '\p{issupplementalarrowsa}', "");
    Expect(1, 10240, '\p{^issupplementalarrowsa}', "");
    Expect(1, 10240, '\P{issupplementalarrowsa}', "");
    Expect(0, 10240, '\P{^issupplementalarrowsa}', "");
    Expect(1, 10239, '\p{is_supplemental_ARROWS_A}', "");
    Expect(0, 10239, '\p{^is_supplemental_ARROWS_A}', "");
    Expect(0, 10239, '\P{is_supplemental_ARROWS_A}', "");
    Expect(1, 10239, '\P{^is_supplemental_ARROWS_A}', "");
    Expect(0, 10240, '\p{is_supplemental_ARROWS_A}', "");
    Expect(1, 10240, '\p{^is_supplemental_ARROWS_A}', "");
    Expect(1, 10240, '\P{is_supplemental_ARROWS_A}', "");
    Expect(0, 10240, '\P{^is_supplemental_ARROWS_A}', "");
    Error('\p{:=_	in_supplemental_arrows_A}');
    Error('\P{:=_	in_supplemental_arrows_A}');
    Expect(1, 10239, '\p{insupplementalarrowsa}', "");
    Expect(0, 10239, '\p{^insupplementalarrowsa}', "");
    Expect(0, 10239, '\P{insupplementalarrowsa}', "");
    Expect(1, 10239, '\P{^insupplementalarrowsa}', "");
    Expect(0, 10240, '\p{insupplementalarrowsa}', "");
    Expect(1, 10240, '\p{^insupplementalarrowsa}', "");
    Expect(1, 10240, '\P{insupplementalarrowsa}', "");
    Expect(0, 10240, '\P{^insupplementalarrowsa}', "");
    Expect(1, 10239, '\p{		In_Supplemental_Arrows_A}', "");
    Expect(0, 10239, '\p{^		In_Supplemental_Arrows_A}', "");
    Expect(0, 10239, '\P{		In_Supplemental_Arrows_A}', "");
    Expect(1, 10239, '\P{^		In_Supplemental_Arrows_A}', "");
    Expect(0, 10240, '\p{		In_Supplemental_Arrows_A}', "");
    Expect(1, 10240, '\p{^		In_Supplemental_Arrows_A}', "");
    Expect(1, 10240, '\P{		In_Supplemental_Arrows_A}', "");
    Expect(0, 10240, '\P{^		In_Supplemental_Arrows_A}', "");
    Error('\p{--Sup_ARROWS_A/a/}');
    Error('\P{--Sup_ARROWS_A/a/}');
    Expect(1, 10239, '\p{suparrowsa}', "");
    Expect(0, 10239, '\p{^suparrowsa}', "");
    Expect(0, 10239, '\P{suparrowsa}', "");
    Expect(1, 10239, '\P{^suparrowsa}', "");
    Expect(0, 10240, '\p{suparrowsa}', "");
    Expect(1, 10240, '\p{^suparrowsa}', "");
    Expect(1, 10240, '\P{suparrowsa}', "");
    Expect(0, 10240, '\P{^suparrowsa}', "");
    Expect(1, 10239, '\p{--Sup_Arrows_a}', "");
    Expect(0, 10239, '\p{^--Sup_Arrows_a}', "");
    Expect(0, 10239, '\P{--Sup_Arrows_a}', "");
    Expect(1, 10239, '\P{^--Sup_Arrows_a}', "");
    Expect(0, 10240, '\p{--Sup_Arrows_a}', "");
    Expect(1, 10240, '\p{^--Sup_Arrows_a}', "");
    Expect(1, 10240, '\P{--Sup_Arrows_a}', "");
    Expect(0, 10240, '\P{^--Sup_Arrows_a}', "");
    Error('\p{/a/--IS_SUP_arrows_A}');
    Error('\P{/a/--IS_SUP_arrows_A}');
    Expect(1, 10239, '\p{issuparrowsa}', "");
    Expect(0, 10239, '\p{^issuparrowsa}', "");
    Expect(0, 10239, '\P{issuparrowsa}', "");
    Expect(1, 10239, '\P{^issuparrowsa}', "");
    Expect(0, 10240, '\p{issuparrowsa}', "");
    Expect(1, 10240, '\p{^issuparrowsa}', "");
    Expect(1, 10240, '\P{issuparrowsa}', "");
    Expect(0, 10240, '\P{^issuparrowsa}', "");
    Expect(1, 10239, '\p{		IS_sup_ARROWS_a}', "");
    Expect(0, 10239, '\p{^		IS_sup_ARROWS_a}', "");
    Expect(0, 10239, '\P{		IS_sup_ARROWS_a}', "");
    Expect(1, 10239, '\P{^		IS_sup_ARROWS_a}', "");
    Expect(0, 10240, '\p{		IS_sup_ARROWS_a}', "");
    Expect(1, 10240, '\p{^		IS_sup_ARROWS_a}', "");
    Expect(1, 10240, '\P{		IS_sup_ARROWS_a}', "");
    Expect(0, 10240, '\P{^		IS_sup_ARROWS_a}', "");
    Error('\p{- In_SUP_arrows_A:=}');
    Error('\P{- In_SUP_arrows_A:=}');
    Expect(1, 10239, '\p{insuparrowsa}', "");
    Expect(0, 10239, '\p{^insuparrowsa}', "");
    Expect(0, 10239, '\P{insuparrowsa}', "");
    Expect(1, 10239, '\P{^insuparrowsa}', "");
    Expect(0, 10240, '\p{insuparrowsa}', "");
    Expect(1, 10240, '\p{^insuparrowsa}', "");
    Expect(1, 10240, '\P{insuparrowsa}', "");
    Expect(0, 10240, '\P{^insuparrowsa}', "");
    Expect(1, 10239, '\p{ -In_Sup_Arrows_a}', "");
    Expect(0, 10239, '\p{^ -In_Sup_Arrows_a}', "");
    Expect(0, 10239, '\P{ -In_Sup_Arrows_a}', "");
    Expect(1, 10239, '\P{^ -In_Sup_Arrows_a}', "");
    Expect(0, 10240, '\p{ -In_Sup_Arrows_a}', "");
    Expect(1, 10240, '\p{^ -In_Sup_Arrows_a}', "");
    Expect(1, 10240, '\P{ -In_Sup_Arrows_a}', "");
    Expect(0, 10240, '\P{^ -In_Sup_Arrows_a}', "");
    Error('\p{ -supplemental_arrows_b/a/}');
    Error('\P{ -supplemental_arrows_b/a/}');
    Expect(1, 10623, '\p{supplementalarrowsb}', "");
    Expect(0, 10623, '\p{^supplementalarrowsb}', "");
    Expect(0, 10623, '\P{supplementalarrowsb}', "");
    Expect(1, 10623, '\P{^supplementalarrowsb}', "");
    Expect(0, 10624, '\p{supplementalarrowsb}', "");
    Expect(1, 10624, '\p{^supplementalarrowsb}', "");
    Expect(1, 10624, '\P{supplementalarrowsb}', "");
    Expect(0, 10624, '\P{^supplementalarrowsb}', "");
    Expect(1, 10623, '\p{supplemental_Arrows_B}', "");
    Expect(0, 10623, '\p{^supplemental_Arrows_B}', "");
    Expect(0, 10623, '\P{supplemental_Arrows_B}', "");
    Expect(1, 10623, '\P{^supplemental_Arrows_B}', "");
    Expect(0, 10624, '\p{supplemental_Arrows_B}', "");
    Expect(1, 10624, '\p{^supplemental_Arrows_B}', "");
    Expect(1, 10624, '\P{supplemental_Arrows_B}', "");
    Expect(0, 10624, '\P{^supplemental_Arrows_B}', "");
    Error('\p{-IS_supplemental_Arrows_b:=}');
    Error('\P{-IS_supplemental_Arrows_b:=}');
    Expect(1, 10623, '\p{issupplementalarrowsb}', "");
    Expect(0, 10623, '\p{^issupplementalarrowsb}', "");
    Expect(0, 10623, '\P{issupplementalarrowsb}', "");
    Expect(1, 10623, '\P{^issupplementalarrowsb}', "");
    Expect(0, 10624, '\p{issupplementalarrowsb}', "");
    Expect(1, 10624, '\p{^issupplementalarrowsb}', "");
    Expect(1, 10624, '\P{issupplementalarrowsb}', "");
    Expect(0, 10624, '\P{^issupplementalarrowsb}', "");
    Expect(1, 10623, '\p{	Is_SUPPLEMENTAL_ARROWS_B}', "");
    Expect(0, 10623, '\p{^	Is_SUPPLEMENTAL_ARROWS_B}', "");
    Expect(0, 10623, '\P{	Is_SUPPLEMENTAL_ARROWS_B}', "");
    Expect(1, 10623, '\P{^	Is_SUPPLEMENTAL_ARROWS_B}', "");
    Expect(0, 10624, '\p{	Is_SUPPLEMENTAL_ARROWS_B}', "");
    Expect(1, 10624, '\p{^	Is_SUPPLEMENTAL_ARROWS_B}', "");
    Expect(1, 10624, '\P{	Is_SUPPLEMENTAL_ARROWS_B}', "");
    Expect(0, 10624, '\P{^	Is_SUPPLEMENTAL_ARROWS_B}', "");
    Error('\p{-:=in_Supplemental_Arrows_b}');
    Error('\P{-:=in_Supplemental_Arrows_b}');
    Expect(1, 10623, '\p{insupplementalarrowsb}', "");
    Expect(0, 10623, '\p{^insupplementalarrowsb}', "");
    Expect(0, 10623, '\P{insupplementalarrowsb}', "");
    Expect(1, 10623, '\P{^insupplementalarrowsb}', "");
    Expect(0, 10624, '\p{insupplementalarrowsb}', "");
    Expect(1, 10624, '\p{^insupplementalarrowsb}', "");
    Expect(1, 10624, '\P{insupplementalarrowsb}', "");
    Expect(0, 10624, '\P{^insupplementalarrowsb}', "");
    Expect(1, 10623, '\p{_	In_supplemental_Arrows_B}', "");
    Expect(0, 10623, '\p{^_	In_supplemental_Arrows_B}', "");
    Expect(0, 10623, '\P{_	In_supplemental_Arrows_B}', "");
    Expect(1, 10623, '\P{^_	In_supplemental_Arrows_B}', "");
    Expect(0, 10624, '\p{_	In_supplemental_Arrows_B}', "");
    Expect(1, 10624, '\p{^_	In_supplemental_Arrows_B}', "");
    Expect(1, 10624, '\P{_	In_supplemental_Arrows_B}', "");
    Expect(0, 10624, '\P{^_	In_supplemental_Arrows_B}', "");
    Error('\p{:=Sup_Arrows_B}');
    Error('\P{:=Sup_Arrows_B}');
    Expect(1, 10623, '\p{suparrowsb}', "");
    Expect(0, 10623, '\p{^suparrowsb}', "");
    Expect(0, 10623, '\P{suparrowsb}', "");
    Expect(1, 10623, '\P{^suparrowsb}', "");
    Expect(0, 10624, '\p{suparrowsb}', "");
    Expect(1, 10624, '\p{^suparrowsb}', "");
    Expect(1, 10624, '\P{suparrowsb}', "");
    Expect(0, 10624, '\P{^suparrowsb}', "");
    Expect(1, 10623, '\p{ SUP_Arrows_b}', "");
    Expect(0, 10623, '\p{^ SUP_Arrows_b}', "");
    Expect(0, 10623, '\P{ SUP_Arrows_b}', "");
    Expect(1, 10623, '\P{^ SUP_Arrows_b}', "");
    Expect(0, 10624, '\p{ SUP_Arrows_b}', "");
    Expect(1, 10624, '\p{^ SUP_Arrows_b}', "");
    Expect(1, 10624, '\P{ SUP_Arrows_b}', "");
    Expect(0, 10624, '\P{^ SUP_Arrows_b}', "");
    Error('\p{	/a/Is_SUP_arrows_B}');
    Error('\P{	/a/Is_SUP_arrows_B}');
    Expect(1, 10623, '\p{issuparrowsb}', "");
    Expect(0, 10623, '\p{^issuparrowsb}', "");
    Expect(0, 10623, '\P{issuparrowsb}', "");
    Expect(1, 10623, '\P{^issuparrowsb}', "");
    Expect(0, 10624, '\p{issuparrowsb}', "");
    Expect(1, 10624, '\p{^issuparrowsb}', "");
    Expect(1, 10624, '\P{issuparrowsb}', "");
    Expect(0, 10624, '\P{^issuparrowsb}', "");
    Expect(1, 10623, '\p{		IS_Sup_arrows_B}', "");
    Expect(0, 10623, '\p{^		IS_Sup_arrows_B}', "");
    Expect(0, 10623, '\P{		IS_Sup_arrows_B}', "");
    Expect(1, 10623, '\P{^		IS_Sup_arrows_B}', "");
    Expect(0, 10624, '\p{		IS_Sup_arrows_B}', "");
    Expect(1, 10624, '\p{^		IS_Sup_arrows_B}', "");
    Expect(1, 10624, '\P{		IS_Sup_arrows_B}', "");
    Expect(0, 10624, '\P{^		IS_Sup_arrows_B}', "");
    Error('\p{_In_SUP_arrows_B:=}');
    Error('\P{_In_SUP_arrows_B:=}');
    Expect(1, 10623, '\p{insuparrowsb}', "");
    Expect(0, 10623, '\p{^insuparrowsb}', "");
    Expect(0, 10623, '\P{insuparrowsb}', "");
    Expect(1, 10623, '\P{^insuparrowsb}', "");
    Expect(0, 10624, '\p{insuparrowsb}', "");
    Expect(1, 10624, '\p{^insuparrowsb}', "");
    Expect(1, 10624, '\P{insuparrowsb}', "");
    Expect(0, 10624, '\P{^insuparrowsb}', "");
    Expect(1, 10623, '\p{_ in_Sup_arrows_B}', "");
    Expect(0, 10623, '\p{^_ in_Sup_arrows_B}', "");
    Expect(0, 10623, '\P{_ in_Sup_arrows_B}', "");
    Expect(1, 10623, '\P{^_ in_Sup_arrows_B}', "");
    Expect(0, 10624, '\p{_ in_Sup_arrows_B}', "");
    Expect(1, 10624, '\p{^_ in_Sup_arrows_B}', "");
    Expect(1, 10624, '\P{_ in_Sup_arrows_B}', "");
    Expect(0, 10624, '\P{^_ in_Sup_arrows_B}', "");
    Error('\p{ :=Supplemental_Arrows_C}');
    Error('\P{ :=Supplemental_Arrows_C}');
    Expect(1, 129279, '\p{supplementalarrowsc}', "");
    Expect(0, 129279, '\p{^supplementalarrowsc}', "");
    Expect(0, 129279, '\P{supplementalarrowsc}', "");
    Expect(1, 129279, '\P{^supplementalarrowsc}', "");
    Expect(0, 129280, '\p{supplementalarrowsc}', "");
    Expect(1, 129280, '\p{^supplementalarrowsc}', "");
    Expect(1, 129280, '\P{supplementalarrowsc}', "");
    Expect(0, 129280, '\P{^supplementalarrowsc}', "");
    Expect(1, 129279, '\p{_SUPPLEMENTAL_arrows_C}', "");
    Expect(0, 129279, '\p{^_SUPPLEMENTAL_arrows_C}', "");
    Expect(0, 129279, '\P{_SUPPLEMENTAL_arrows_C}', "");
    Expect(1, 129279, '\P{^_SUPPLEMENTAL_arrows_C}', "");
    Expect(0, 129280, '\p{_SUPPLEMENTAL_arrows_C}', "");
    Expect(1, 129280, '\p{^_SUPPLEMENTAL_arrows_C}', "");
    Expect(1, 129280, '\P{_SUPPLEMENTAL_arrows_C}', "");
    Expect(0, 129280, '\P{^_SUPPLEMENTAL_arrows_C}', "");
    Error('\p{/a/Is_supplemental_Arrows_C}');
    Error('\P{/a/Is_supplemental_Arrows_C}');
    Expect(1, 129279, '\p{issupplementalarrowsc}', "");
    Expect(0, 129279, '\p{^issupplementalarrowsc}', "");
    Expect(0, 129279, '\P{issupplementalarrowsc}', "");
    Expect(1, 129279, '\P{^issupplementalarrowsc}', "");
    Expect(0, 129280, '\p{issupplementalarrowsc}', "");
    Expect(1, 129280, '\p{^issupplementalarrowsc}', "");
    Expect(1, 129280, '\P{issupplementalarrowsc}', "");
    Expect(0, 129280, '\P{^issupplementalarrowsc}', "");
    Expect(1, 129279, '\p{ _Is_Supplemental_Arrows_C}', "");
    Expect(0, 129279, '\p{^ _Is_Supplemental_Arrows_C}', "");
    Expect(0, 129279, '\P{ _Is_Supplemental_Arrows_C}', "");
    Expect(1, 129279, '\P{^ _Is_Supplemental_Arrows_C}', "");
    Expect(0, 129280, '\p{ _Is_Supplemental_Arrows_C}', "");
    Expect(1, 129280, '\p{^ _Is_Supplemental_Arrows_C}', "");
    Expect(1, 129280, '\P{ _Is_Supplemental_Arrows_C}', "");
    Expect(0, 129280, '\P{^ _Is_Supplemental_Arrows_C}', "");
    Error('\p{/a/	In_SUPPLEMENTAL_arrows_C}');
    Error('\P{/a/	In_SUPPLEMENTAL_arrows_C}');
    Expect(1, 129279, '\p{insupplementalarrowsc}', "");
    Expect(0, 129279, '\p{^insupplementalarrowsc}', "");
    Expect(0, 129279, '\P{insupplementalarrowsc}', "");
    Expect(1, 129279, '\P{^insupplementalarrowsc}', "");
    Expect(0, 129280, '\p{insupplementalarrowsc}', "");
    Expect(1, 129280, '\p{^insupplementalarrowsc}', "");
    Expect(1, 129280, '\P{insupplementalarrowsc}', "");
    Expect(0, 129280, '\P{^insupplementalarrowsc}', "");
    Expect(1, 129279, '\p{_In_Supplemental_arrows_C}', "");
    Expect(0, 129279, '\p{^_In_Supplemental_arrows_C}', "");
    Expect(0, 129279, '\P{_In_Supplemental_arrows_C}', "");
    Expect(1, 129279, '\P{^_In_Supplemental_arrows_C}', "");
    Expect(0, 129280, '\p{_In_Supplemental_arrows_C}', "");
    Expect(1, 129280, '\p{^_In_Supplemental_arrows_C}', "");
    Expect(1, 129280, '\P{_In_Supplemental_arrows_C}', "");
    Expect(0, 129280, '\P{^_In_Supplemental_arrows_C}', "");
    Error('\p{ :=Sup_Arrows_C}');
    Error('\P{ :=Sup_Arrows_C}');
    Expect(1, 129279, '\p{suparrowsc}', "");
    Expect(0, 129279, '\p{^suparrowsc}', "");
    Expect(0, 129279, '\P{suparrowsc}', "");
    Expect(1, 129279, '\P{^suparrowsc}', "");
    Expect(0, 129280, '\p{suparrowsc}', "");
    Expect(1, 129280, '\p{^suparrowsc}', "");
    Expect(1, 129280, '\P{suparrowsc}', "");
    Expect(0, 129280, '\P{^suparrowsc}', "");
    Expect(1, 129279, '\p{_ sup_arrows_C}', "");
    Expect(0, 129279, '\p{^_ sup_arrows_C}', "");
    Expect(0, 129279, '\P{_ sup_arrows_C}', "");
    Expect(1, 129279, '\P{^_ sup_arrows_C}', "");
    Expect(0, 129280, '\p{_ sup_arrows_C}', "");
    Expect(1, 129280, '\p{^_ sup_arrows_C}', "");
    Expect(1, 129280, '\P{_ sup_arrows_C}', "");
    Expect(0, 129280, '\P{^_ sup_arrows_C}', "");
    Error('\p{-:=Is_sup_arrows_C}');
    Error('\P{-:=Is_sup_arrows_C}');
    Expect(1, 129279, '\p{issuparrowsc}', "");
    Expect(0, 129279, '\p{^issuparrowsc}', "");
    Expect(0, 129279, '\P{issuparrowsc}', "");
    Expect(1, 129279, '\P{^issuparrowsc}', "");
    Expect(0, 129280, '\p{issuparrowsc}', "");
    Expect(1, 129280, '\p{^issuparrowsc}', "");
    Expect(1, 129280, '\P{issuparrowsc}', "");
    Expect(0, 129280, '\P{^issuparrowsc}', "");
    Expect(1, 129279, '\p{  IS_Sup_Arrows_c}', "");
    Expect(0, 129279, '\p{^  IS_Sup_Arrows_c}', "");
    Expect(0, 129279, '\P{  IS_Sup_Arrows_c}', "");
    Expect(1, 129279, '\P{^  IS_Sup_Arrows_c}', "");
    Expect(0, 129280, '\p{  IS_Sup_Arrows_c}', "");
    Expect(1, 129280, '\p{^  IS_Sup_Arrows_c}', "");
    Expect(1, 129280, '\P{  IS_Sup_Arrows_c}', "");
    Expect(0, 129280, '\P{^  IS_Sup_Arrows_c}', "");
    Error('\p{-/a/In_Sup_Arrows_c}');
    Error('\P{-/a/In_Sup_Arrows_c}');
    Expect(1, 129279, '\p{insuparrowsc}', "");
    Expect(0, 129279, '\p{^insuparrowsc}', "");
    Expect(0, 129279, '\P{insuparrowsc}', "");
    Expect(1, 129279, '\P{^insuparrowsc}', "");
    Expect(0, 129280, '\p{insuparrowsc}', "");
    Expect(1, 129280, '\p{^insuparrowsc}', "");
    Expect(1, 129280, '\P{insuparrowsc}', "");
    Expect(0, 129280, '\P{^insuparrowsc}', "");
    Expect(1, 129279, '\p{	In_sup_Arrows_C}', "");
    Expect(0, 129279, '\p{^	In_sup_Arrows_C}', "");
    Expect(0, 129279, '\P{	In_sup_Arrows_C}', "");
    Expect(1, 129279, '\P{^	In_sup_Arrows_C}', "");
    Expect(0, 129280, '\p{	In_sup_Arrows_C}', "");
    Expect(1, 129280, '\p{^	In_sup_Arrows_C}', "");
    Expect(1, 129280, '\P{	In_sup_Arrows_C}', "");
    Expect(0, 129280, '\P{^	In_sup_Arrows_C}', "");
    Error('\p{-_Supplemental_MATHEMATICAL_Operators/a/}');
    Error('\P{-_Supplemental_MATHEMATICAL_Operators/a/}');
    Expect(1, 11007, '\p{supplementalmathematicaloperators}', "");
    Expect(0, 11007, '\p{^supplementalmathematicaloperators}', "");
    Expect(0, 11007, '\P{supplementalmathematicaloperators}', "");
    Expect(1, 11007, '\P{^supplementalmathematicaloperators}', "");
    Expect(0, 11008, '\p{supplementalmathematicaloperators}', "");
    Expect(1, 11008, '\p{^supplementalmathematicaloperators}', "");
    Expect(1, 11008, '\P{supplementalmathematicaloperators}', "");
    Expect(0, 11008, '\P{^supplementalmathematicaloperators}', "");
    Expect(1, 11007, '\p{	_supplemental_Mathematical_operators}', "");
    Expect(0, 11007, '\p{^	_supplemental_Mathematical_operators}', "");
    Expect(0, 11007, '\P{	_supplemental_Mathematical_operators}', "");
    Expect(1, 11007, '\P{^	_supplemental_Mathematical_operators}', "");
    Expect(0, 11008, '\p{	_supplemental_Mathematical_operators}', "");
    Expect(1, 11008, '\p{^	_supplemental_Mathematical_operators}', "");
    Expect(1, 11008, '\P{	_supplemental_Mathematical_operators}', "");
    Expect(0, 11008, '\P{^	_supplemental_Mathematical_operators}', "");
    Error('\p{:=  Is_supplemental_Mathematical_Operators}');
    Error('\P{:=  Is_supplemental_Mathematical_Operators}');
    Expect(1, 11007, '\p{issupplementalmathematicaloperators}', "");
    Expect(0, 11007, '\p{^issupplementalmathematicaloperators}', "");
    Expect(0, 11007, '\P{issupplementalmathematicaloperators}', "");
    Expect(1, 11007, '\P{^issupplementalmathematicaloperators}', "");
    Expect(0, 11008, '\p{issupplementalmathematicaloperators}', "");
    Expect(1, 11008, '\p{^issupplementalmathematicaloperators}', "");
    Expect(1, 11008, '\P{issupplementalmathematicaloperators}', "");
    Expect(0, 11008, '\P{^issupplementalmathematicaloperators}', "");
    Expect(1, 11007, '\p{_ Is_Supplemental_Mathematical_Operators}', "");
    Expect(0, 11007, '\p{^_ Is_Supplemental_Mathematical_Operators}', "");
    Expect(0, 11007, '\P{_ Is_Supplemental_Mathematical_Operators}', "");
    Expect(1, 11007, '\P{^_ Is_Supplemental_Mathematical_Operators}', "");
    Expect(0, 11008, '\p{_ Is_Supplemental_Mathematical_Operators}', "");
    Expect(1, 11008, '\p{^_ Is_Supplemental_Mathematical_Operators}', "");
    Expect(1, 11008, '\P{_ Is_Supplemental_Mathematical_Operators}', "");
    Expect(0, 11008, '\P{^_ Is_Supplemental_Mathematical_Operators}', "");
    Error('\p{ /a/In_SUPPLEMENTAL_mathematical_Operators}');
    Error('\P{ /a/In_SUPPLEMENTAL_mathematical_Operators}');
    Expect(1, 11007, '\p{insupplementalmathematicaloperators}', "");
    Expect(0, 11007, '\p{^insupplementalmathematicaloperators}', "");
    Expect(0, 11007, '\P{insupplementalmathematicaloperators}', "");
    Expect(1, 11007, '\P{^insupplementalmathematicaloperators}', "");
    Expect(0, 11008, '\p{insupplementalmathematicaloperators}', "");
    Expect(1, 11008, '\p{^insupplementalmathematicaloperators}', "");
    Expect(1, 11008, '\P{insupplementalmathematicaloperators}', "");
    Expect(0, 11008, '\P{^insupplementalmathematicaloperators}', "");
    Expect(1, 11007, '\p{  In_SUPPLEMENTAL_Mathematical_operators}', "");
    Expect(0, 11007, '\p{^  In_SUPPLEMENTAL_Mathematical_operators}', "");
    Expect(0, 11007, '\P{  In_SUPPLEMENTAL_Mathematical_operators}', "");
    Expect(1, 11007, '\P{^  In_SUPPLEMENTAL_Mathematical_operators}', "");
    Expect(0, 11008, '\p{  In_SUPPLEMENTAL_Mathematical_operators}', "");
    Expect(1, 11008, '\p{^  In_SUPPLEMENTAL_Mathematical_operators}', "");
    Expect(1, 11008, '\P{  In_SUPPLEMENTAL_Mathematical_operators}', "");
    Expect(0, 11008, '\P{^  In_SUPPLEMENTAL_Mathematical_operators}', "");
    Error('\p{	:=sup_MATH_operators}');
    Error('\P{	:=sup_MATH_operators}');
    Expect(1, 11007, '\p{supmathoperators}', "");
    Expect(0, 11007, '\p{^supmathoperators}', "");
    Expect(0, 11007, '\P{supmathoperators}', "");
    Expect(1, 11007, '\P{^supmathoperators}', "");
    Expect(0, 11008, '\p{supmathoperators}', "");
    Expect(1, 11008, '\p{^supmathoperators}', "");
    Expect(1, 11008, '\P{supmathoperators}', "");
    Expect(0, 11008, '\P{^supmathoperators}', "");
    Expect(1, 11007, '\p{ -Sup_math_Operators}', "");
    Expect(0, 11007, '\p{^ -Sup_math_Operators}', "");
    Expect(0, 11007, '\P{ -Sup_math_Operators}', "");
    Expect(1, 11007, '\P{^ -Sup_math_Operators}', "");
    Expect(0, 11008, '\p{ -Sup_math_Operators}', "");
    Expect(1, 11008, '\p{^ -Sup_math_Operators}', "");
    Expect(1, 11008, '\P{ -Sup_math_Operators}', "");
    Expect(0, 11008, '\P{^ -Sup_math_Operators}', "");
    Error('\p{	_IS_SUP_math_Operators/a/}');
    Error('\P{	_IS_SUP_math_Operators/a/}');
    Expect(1, 11007, '\p{issupmathoperators}', "");
    Expect(0, 11007, '\p{^issupmathoperators}', "");
    Expect(0, 11007, '\P{issupmathoperators}', "");
    Expect(1, 11007, '\P{^issupmathoperators}', "");
    Expect(0, 11008, '\p{issupmathoperators}', "");
    Expect(1, 11008, '\p{^issupmathoperators}', "");
    Expect(1, 11008, '\P{issupmathoperators}', "");
    Expect(0, 11008, '\P{^issupmathoperators}', "");
    Expect(1, 11007, '\p{Is_Sup_Math_operators}', "");
    Expect(0, 11007, '\p{^Is_Sup_Math_operators}', "");
    Expect(0, 11007, '\P{Is_Sup_Math_operators}', "");
    Expect(1, 11007, '\P{^Is_Sup_Math_operators}', "");
    Expect(0, 11008, '\p{Is_Sup_Math_operators}', "");
    Expect(1, 11008, '\p{^Is_Sup_Math_operators}', "");
    Expect(1, 11008, '\P{Is_Sup_Math_operators}', "");
    Expect(0, 11008, '\P{^Is_Sup_Math_operators}', "");
    Error('\p{_/a/In_sup_Math_OPERATORS}');
    Error('\P{_/a/In_sup_Math_OPERATORS}');
    Expect(1, 11007, '\p{insupmathoperators}', "");
    Expect(0, 11007, '\p{^insupmathoperators}', "");
    Expect(0, 11007, '\P{insupmathoperators}', "");
    Expect(1, 11007, '\P{^insupmathoperators}', "");
    Expect(0, 11008, '\p{insupmathoperators}', "");
    Expect(1, 11008, '\p{^insupmathoperators}', "");
    Expect(1, 11008, '\P{insupmathoperators}', "");
    Expect(0, 11008, '\P{^insupmathoperators}', "");
    Expect(1, 11007, '\p{_-in_SUP_math_OPERATORS}', "");
    Expect(0, 11007, '\p{^_-in_SUP_math_OPERATORS}', "");
    Expect(0, 11007, '\P{_-in_SUP_math_OPERATORS}', "");
    Expect(1, 11007, '\P{^_-in_SUP_math_OPERATORS}', "");
    Expect(0, 11008, '\p{_-in_SUP_math_OPERATORS}', "");
    Expect(1, 11008, '\p{^_-in_SUP_math_OPERATORS}', "");
    Expect(1, 11008, '\P{_-in_SUP_math_OPERATORS}', "");
    Expect(0, 11008, '\P{^_-in_SUP_math_OPERATORS}', "");
    Error('\p{_SUPPLEMENTAL_Punctuation:=}');
    Error('\P{_SUPPLEMENTAL_Punctuation:=}');
    Expect(1, 11903, '\p{supplementalpunctuation}', "");
    Expect(0, 11903, '\p{^supplementalpunctuation}', "");
    Expect(0, 11903, '\P{supplementalpunctuation}', "");
    Expect(1, 11903, '\P{^supplementalpunctuation}', "");
    Expect(0, 11904, '\p{supplementalpunctuation}', "");
    Expect(1, 11904, '\p{^supplementalpunctuation}', "");
    Expect(1, 11904, '\P{supplementalpunctuation}', "");
    Expect(0, 11904, '\P{^supplementalpunctuation}', "");
    Expect(1, 11903, '\p{-_Supplemental_PUNCTUATION}', "");
    Expect(0, 11903, '\p{^-_Supplemental_PUNCTUATION}', "");
    Expect(0, 11903, '\P{-_Supplemental_PUNCTUATION}', "");
    Expect(1, 11903, '\P{^-_Supplemental_PUNCTUATION}', "");
    Expect(0, 11904, '\p{-_Supplemental_PUNCTUATION}', "");
    Expect(1, 11904, '\p{^-_Supplemental_PUNCTUATION}', "");
    Expect(1, 11904, '\P{-_Supplemental_PUNCTUATION}', "");
    Expect(0, 11904, '\P{^-_Supplemental_PUNCTUATION}', "");
    Error('\p{	_Is_SUPPLEMENTAL_Punctuation:=}');
    Error('\P{	_Is_SUPPLEMENTAL_Punctuation:=}');
    Expect(1, 11903, '\p{issupplementalpunctuation}', "");
    Expect(0, 11903, '\p{^issupplementalpunctuation}', "");
    Expect(0, 11903, '\P{issupplementalpunctuation}', "");
    Expect(1, 11903, '\P{^issupplementalpunctuation}', "");
    Expect(0, 11904, '\p{issupplementalpunctuation}', "");
    Expect(1, 11904, '\p{^issupplementalpunctuation}', "");
    Expect(1, 11904, '\P{issupplementalpunctuation}', "");
    Expect(0, 11904, '\P{^issupplementalpunctuation}', "");
    Expect(1, 11903, '\p{ Is_supplemental_Punctuation}', "");
    Expect(0, 11903, '\p{^ Is_supplemental_Punctuation}', "");
    Expect(0, 11903, '\P{ Is_supplemental_Punctuation}', "");
    Expect(1, 11903, '\P{^ Is_supplemental_Punctuation}', "");
    Expect(0, 11904, '\p{ Is_supplemental_Punctuation}', "");
    Expect(1, 11904, '\p{^ Is_supplemental_Punctuation}', "");
    Expect(1, 11904, '\P{ Is_supplemental_Punctuation}', "");
    Expect(0, 11904, '\P{^ Is_supplemental_Punctuation}', "");
    Error('\p{ in_Supplemental_punctuation:=}');
    Error('\P{ in_Supplemental_punctuation:=}');
    Expect(1, 11903, '\p{insupplementalpunctuation}', "");
    Expect(0, 11903, '\p{^insupplementalpunctuation}', "");
    Expect(0, 11903, '\P{insupplementalpunctuation}', "");
    Expect(1, 11903, '\P{^insupplementalpunctuation}', "");
    Expect(0, 11904, '\p{insupplementalpunctuation}', "");
    Expect(1, 11904, '\p{^insupplementalpunctuation}', "");
    Expect(1, 11904, '\P{insupplementalpunctuation}', "");
    Expect(0, 11904, '\P{^insupplementalpunctuation}', "");
    Expect(1, 11903, '\p{_IN_Supplemental_PUNCTUATION}', "");
    Expect(0, 11903, '\p{^_IN_Supplemental_PUNCTUATION}', "");
    Expect(0, 11903, '\P{_IN_Supplemental_PUNCTUATION}', "");
    Expect(1, 11903, '\P{^_IN_Supplemental_PUNCTUATION}', "");
    Expect(0, 11904, '\p{_IN_Supplemental_PUNCTUATION}', "");
    Expect(1, 11904, '\p{^_IN_Supplemental_PUNCTUATION}', "");
    Expect(1, 11904, '\P{_IN_Supplemental_PUNCTUATION}', "");
    Expect(0, 11904, '\P{^_IN_Supplemental_PUNCTUATION}', "");
    Error('\p{/a/	 sup_Punctuation}');
    Error('\P{/a/	 sup_Punctuation}');
    Expect(1, 11903, '\p{suppunctuation}', "");
    Expect(0, 11903, '\p{^suppunctuation}', "");
    Expect(0, 11903, '\P{suppunctuation}', "");
    Expect(1, 11903, '\P{^suppunctuation}', "");
    Expect(0, 11904, '\p{suppunctuation}', "");
    Expect(1, 11904, '\p{^suppunctuation}', "");
    Expect(1, 11904, '\P{suppunctuation}', "");
    Expect(0, 11904, '\P{^suppunctuation}', "");
    Expect(1, 11903, '\p{ Sup_punctuation}', "");
    Expect(0, 11903, '\p{^ Sup_punctuation}', "");
    Expect(0, 11903, '\P{ Sup_punctuation}', "");
    Expect(1, 11903, '\P{^ Sup_punctuation}', "");
    Expect(0, 11904, '\p{ Sup_punctuation}', "");
    Expect(1, 11904, '\p{^ Sup_punctuation}', "");
    Expect(1, 11904, '\P{ Sup_punctuation}', "");
    Expect(0, 11904, '\P{^ Sup_punctuation}', "");
    Error('\p{:=--Is_SUP_Punctuation}');
    Error('\P{:=--Is_SUP_Punctuation}');
    Expect(1, 11903, '\p{issuppunctuation}', "");
    Expect(0, 11903, '\p{^issuppunctuation}', "");
    Expect(0, 11903, '\P{issuppunctuation}', "");
    Expect(1, 11903, '\P{^issuppunctuation}', "");
    Expect(0, 11904, '\p{issuppunctuation}', "");
    Expect(1, 11904, '\p{^issuppunctuation}', "");
    Expect(1, 11904, '\P{issuppunctuation}', "");
    Expect(0, 11904, '\P{^issuppunctuation}', "");
    Expect(1, 11903, '\p{	-is_Sup_punctuation}', "");
    Expect(0, 11903, '\p{^	-is_Sup_punctuation}', "");
    Expect(0, 11903, '\P{	-is_Sup_punctuation}', "");
    Expect(1, 11903, '\P{^	-is_Sup_punctuation}', "");
    Expect(0, 11904, '\p{	-is_Sup_punctuation}', "");
    Expect(1, 11904, '\p{^	-is_Sup_punctuation}', "");
    Expect(1, 11904, '\P{	-is_Sup_punctuation}', "");
    Expect(0, 11904, '\P{^	-is_Sup_punctuation}', "");
    Error('\p{	/a/In_Sup_punctuation}');
    Error('\P{	/a/In_Sup_punctuation}');
    Expect(1, 11903, '\p{insuppunctuation}', "");
    Expect(0, 11903, '\p{^insuppunctuation}', "");
    Expect(0, 11903, '\P{insuppunctuation}', "");
    Expect(1, 11903, '\P{^insuppunctuation}', "");
    Expect(0, 11904, '\p{insuppunctuation}', "");
    Expect(1, 11904, '\p{^insuppunctuation}', "");
    Expect(1, 11904, '\P{insuppunctuation}', "");
    Expect(0, 11904, '\P{^insuppunctuation}', "");
    Expect(1, 11903, '\p{	 In_Sup_PUNCTUATION}', "");
    Expect(0, 11903, '\p{^	 In_Sup_PUNCTUATION}', "");
    Expect(0, 11903, '\P{	 In_Sup_PUNCTUATION}', "");
    Expect(1, 11903, '\P{^	 In_Sup_PUNCTUATION}', "");
    Expect(0, 11904, '\p{	 In_Sup_PUNCTUATION}', "");
    Expect(1, 11904, '\p{^	 In_Sup_PUNCTUATION}', "");
    Expect(1, 11904, '\P{	 In_Sup_PUNCTUATION}', "");
    Expect(0, 11904, '\P{^	 In_Sup_PUNCTUATION}', "");
    Error('\p{_ SUPPLEMENTAL_SYMBOLS_AND_PICTOGRAPHS:=}');
    Error('\P{_ SUPPLEMENTAL_SYMBOLS_AND_PICTOGRAPHS:=}');
    Expect(1, 129535, '\p{supplementalsymbolsandpictographs}', "");
    Expect(0, 129535, '\p{^supplementalsymbolsandpictographs}', "");
    Expect(0, 129535, '\P{supplementalsymbolsandpictographs}', "");
    Expect(1, 129535, '\P{^supplementalsymbolsandpictographs}', "");
    Expect(0, 129536, '\p{supplementalsymbolsandpictographs}', "");
    Expect(1, 129536, '\p{^supplementalsymbolsandpictographs}', "");
    Expect(1, 129536, '\P{supplementalsymbolsandpictographs}', "");
    Expect(0, 129536, '\P{^supplementalsymbolsandpictographs}', "");
    Expect(1, 129535, '\p{		Supplemental_symbols_AND_Pictographs}', "");
    Expect(0, 129535, '\p{^		Supplemental_symbols_AND_Pictographs}', "");
    Expect(0, 129535, '\P{		Supplemental_symbols_AND_Pictographs}', "");
    Expect(1, 129535, '\P{^		Supplemental_symbols_AND_Pictographs}', "");
    Expect(0, 129536, '\p{		Supplemental_symbols_AND_Pictographs}', "");
    Expect(1, 129536, '\p{^		Supplemental_symbols_AND_Pictographs}', "");
    Expect(1, 129536, '\P{		Supplemental_symbols_AND_Pictographs}', "");
    Expect(0, 129536, '\P{^		Supplemental_symbols_AND_Pictographs}', "");
    Error('\p{:=Is_SUPPLEMENTAL_Symbols_and_Pictographs}');
    Error('\P{:=Is_SUPPLEMENTAL_Symbols_and_Pictographs}');
    Expect(1, 129535, '\p{issupplementalsymbolsandpictographs}', "");
    Expect(0, 129535, '\p{^issupplementalsymbolsandpictographs}', "");
    Expect(0, 129535, '\P{issupplementalsymbolsandpictographs}', "");
    Expect(1, 129535, '\P{^issupplementalsymbolsandpictographs}', "");
    Expect(0, 129536, '\p{issupplementalsymbolsandpictographs}', "");
    Expect(1, 129536, '\p{^issupplementalsymbolsandpictographs}', "");
    Expect(1, 129536, '\P{issupplementalsymbolsandpictographs}', "");
    Expect(0, 129536, '\P{^issupplementalsymbolsandpictographs}', "");
    Expect(1, 129535, '\p{_-Is_supplemental_Symbols_AND_Pictographs}', "");
    Expect(0, 129535, '\p{^_-Is_supplemental_Symbols_AND_Pictographs}', "");
    Expect(0, 129535, '\P{_-Is_supplemental_Symbols_AND_Pictographs}', "");
    Expect(1, 129535, '\P{^_-Is_supplemental_Symbols_AND_Pictographs}', "");
    Expect(0, 129536, '\p{_-Is_supplemental_Symbols_AND_Pictographs}', "");
    Expect(1, 129536, '\p{^_-Is_supplemental_Symbols_AND_Pictographs}', "");
    Expect(1, 129536, '\P{_-Is_supplemental_Symbols_AND_Pictographs}', "");
    Expect(0, 129536, '\P{^_-Is_supplemental_Symbols_AND_Pictographs}', "");
    Error('\p{ :=In_Supplemental_SYMBOLS_AND_Pictographs}');
    Error('\P{ :=In_Supplemental_SYMBOLS_AND_Pictographs}');
    Expect(1, 129535, '\p{insupplementalsymbolsandpictographs}', "");
    Expect(0, 129535, '\p{^insupplementalsymbolsandpictographs}', "");
    Expect(0, 129535, '\P{insupplementalsymbolsandpictographs}', "");
    Expect(1, 129535, '\P{^insupplementalsymbolsandpictographs}', "");
    Expect(0, 129536, '\p{insupplementalsymbolsandpictographs}', "");
    Expect(1, 129536, '\p{^insupplementalsymbolsandpictographs}', "");
    Expect(1, 129536, '\P{insupplementalsymbolsandpictographs}', "");
    Expect(0, 129536, '\P{^insupplementalsymbolsandpictographs}', "");
    Expect(1, 129535, '\p{		in_supplemental_symbols_And_Pictographs}', "");
    Expect(0, 129535, '\p{^		in_supplemental_symbols_And_Pictographs}', "");
    Expect(0, 129535, '\P{		in_supplemental_symbols_And_Pictographs}', "");
    Expect(1, 129535, '\P{^		in_supplemental_symbols_And_Pictographs}', "");
    Expect(0, 129536, '\p{		in_supplemental_symbols_And_Pictographs}', "");
    Expect(1, 129536, '\p{^		in_supplemental_symbols_And_Pictographs}', "");
    Expect(1, 129536, '\P{		in_supplemental_symbols_And_Pictographs}', "");
    Expect(0, 129536, '\P{^		in_supplemental_symbols_And_Pictographs}', "");
    Error('\p{/a/__Sup_Symbols_And_Pictographs}');
    Error('\P{/a/__Sup_Symbols_And_Pictographs}');
    Expect(1, 129535, '\p{supsymbolsandpictographs}', "");
    Expect(0, 129535, '\p{^supsymbolsandpictographs}', "");
    Expect(0, 129535, '\P{supsymbolsandpictographs}', "");
    Expect(1, 129535, '\P{^supsymbolsandpictographs}', "");
    Expect(0, 129536, '\p{supsymbolsandpictographs}', "");
    Expect(1, 129536, '\p{^supsymbolsandpictographs}', "");
    Expect(1, 129536, '\P{supsymbolsandpictographs}', "");
    Expect(0, 129536, '\P{^supsymbolsandpictographs}', "");
    Expect(1, 129535, '\p{ -Sup_symbols_and_Pictographs}', "");
    Expect(0, 129535, '\p{^ -Sup_symbols_and_Pictographs}', "");
    Expect(0, 129535, '\P{ -Sup_symbols_and_Pictographs}', "");
    Expect(1, 129535, '\P{^ -Sup_symbols_and_Pictographs}', "");
    Expect(0, 129536, '\p{ -Sup_symbols_and_Pictographs}', "");
    Expect(1, 129536, '\p{^ -Sup_symbols_and_Pictographs}', "");
    Expect(1, 129536, '\P{ -Sup_symbols_and_Pictographs}', "");
    Expect(0, 129536, '\P{^ -Sup_symbols_and_Pictographs}', "");
    Error('\p{:=	 Is_SUP_Symbols_AND_Pictographs}');
    Error('\P{:=	 Is_SUP_Symbols_AND_Pictographs}');
    Expect(1, 129535, '\p{issupsymbolsandpictographs}', "");
    Expect(0, 129535, '\p{^issupsymbolsandpictographs}', "");
    Expect(0, 129535, '\P{issupsymbolsandpictographs}', "");
    Expect(1, 129535, '\P{^issupsymbolsandpictographs}', "");
    Expect(0, 129536, '\p{issupsymbolsandpictographs}', "");
    Expect(1, 129536, '\p{^issupsymbolsandpictographs}', "");
    Expect(1, 129536, '\P{issupsymbolsandpictographs}', "");
    Expect(0, 129536, '\P{^issupsymbolsandpictographs}', "");
    Expect(1, 129535, '\p{		is_Sup_Symbols_And_PICTOGRAPHS}', "");
    Expect(0, 129535, '\p{^		is_Sup_Symbols_And_PICTOGRAPHS}', "");
    Expect(0, 129535, '\P{		is_Sup_Symbols_And_PICTOGRAPHS}', "");
    Expect(1, 129535, '\P{^		is_Sup_Symbols_And_PICTOGRAPHS}', "");
    Expect(0, 129536, '\p{		is_Sup_Symbols_And_PICTOGRAPHS}', "");
    Expect(1, 129536, '\p{^		is_Sup_Symbols_And_PICTOGRAPHS}', "");
    Expect(1, 129536, '\P{		is_Sup_Symbols_And_PICTOGRAPHS}', "");
    Expect(0, 129536, '\P{^		is_Sup_Symbols_And_PICTOGRAPHS}', "");
    Error('\p{:= IN_sup_Symbols_and_PICTOGRAPHS}');
    Error('\P{:= IN_sup_Symbols_and_PICTOGRAPHS}');
    Expect(1, 129535, '\p{insupsymbolsandpictographs}', "");
    Expect(0, 129535, '\p{^insupsymbolsandpictographs}', "");
    Expect(0, 129535, '\P{insupsymbolsandpictographs}', "");
    Expect(1, 129535, '\P{^insupsymbolsandpictographs}', "");
    Expect(0, 129536, '\p{insupsymbolsandpictographs}', "");
    Expect(1, 129536, '\p{^insupsymbolsandpictographs}', "");
    Expect(1, 129536, '\P{insupsymbolsandpictographs}', "");
    Expect(0, 129536, '\P{^insupsymbolsandpictographs}', "");
    Expect(1, 129535, '\p{-_IN_SUP_Symbols_AND_PICTOGRAPHS}', "");
    Expect(0, 129535, '\p{^-_IN_SUP_Symbols_AND_PICTOGRAPHS}', "");
    Expect(0, 129535, '\P{-_IN_SUP_Symbols_AND_PICTOGRAPHS}', "");
    Expect(1, 129535, '\P{^-_IN_SUP_Symbols_AND_PICTOGRAPHS}', "");
    Expect(0, 129536, '\p{-_IN_SUP_Symbols_AND_PICTOGRAPHS}', "");
    Expect(1, 129536, '\p{^-_IN_SUP_Symbols_AND_PICTOGRAPHS}', "");
    Expect(1, 129536, '\P{-_IN_SUP_Symbols_AND_PICTOGRAPHS}', "");
    Expect(0, 129536, '\P{^-_IN_SUP_Symbols_AND_PICTOGRAPHS}', "");
    Error('\p{:=	-Supplementary_Private_Use_AREA_a}');
    Error('\P{:=	-Supplementary_Private_Use_AREA_a}');
    Expect(1, 983040, '\p{supplementaryprivateuseareaa}', "");
    Expect(0, 983040, '\p{^supplementaryprivateuseareaa}', "");
    Expect(0, 983040, '\P{supplementaryprivateuseareaa}', "");
    Expect(1, 983040, '\P{^supplementaryprivateuseareaa}', "");
    Expect(0, 1048576, '\p{supplementaryprivateuseareaa}', "");
    Expect(1, 1048576, '\p{^supplementaryprivateuseareaa}', "");
    Expect(1, 1048576, '\P{supplementaryprivateuseareaa}', "");
    Expect(0, 1048576, '\P{^supplementaryprivateuseareaa}', "");
    Expect(1, 983040, '\p{ supplementary_Private_Use_AREA_A}', "");
    Expect(0, 983040, '\p{^ supplementary_Private_Use_AREA_A}', "");
    Expect(0, 983040, '\P{ supplementary_Private_Use_AREA_A}', "");
    Expect(1, 983040, '\P{^ supplementary_Private_Use_AREA_A}', "");
    Expect(0, 1048576, '\p{ supplementary_Private_Use_AREA_A}', "");
    Expect(1, 1048576, '\p{^ supplementary_Private_Use_AREA_A}', "");
    Expect(1, 1048576, '\P{ supplementary_Private_Use_AREA_A}', "");
    Expect(0, 1048576, '\P{^ supplementary_Private_Use_AREA_A}', "");
    Error('\p{/a/Is_supplementary_Private_use_AREA_A}');
    Error('\P{/a/Is_supplementary_Private_use_AREA_A}');
    Expect(1, 983040, '\p{issupplementaryprivateuseareaa}', "");
    Expect(0, 983040, '\p{^issupplementaryprivateuseareaa}', "");
    Expect(0, 983040, '\P{issupplementaryprivateuseareaa}', "");
    Expect(1, 983040, '\P{^issupplementaryprivateuseareaa}', "");
    Expect(0, 1048576, '\p{issupplementaryprivateuseareaa}', "");
    Expect(1, 1048576, '\p{^issupplementaryprivateuseareaa}', "");
    Expect(1, 1048576, '\P{issupplementaryprivateuseareaa}', "");
    Expect(0, 1048576, '\P{^issupplementaryprivateuseareaa}', "");
    Expect(1, 983040, '\p{	 IS_supplementary_PRIVATE_Use_Area_a}', "");
    Expect(0, 983040, '\p{^	 IS_supplementary_PRIVATE_Use_Area_a}', "");
    Expect(0, 983040, '\P{	 IS_supplementary_PRIVATE_Use_Area_a}', "");
    Expect(1, 983040, '\P{^	 IS_supplementary_PRIVATE_Use_Area_a}', "");
    Expect(0, 1048576, '\p{	 IS_supplementary_PRIVATE_Use_Area_a}', "");
    Expect(1, 1048576, '\p{^	 IS_supplementary_PRIVATE_Use_Area_a}', "");
    Expect(1, 1048576, '\P{	 IS_supplementary_PRIVATE_Use_Area_a}', "");
    Expect(0, 1048576, '\P{^	 IS_supplementary_PRIVATE_Use_Area_a}', "");
    Error('\p{:=_IN_supplementary_PRIVATE_use_AREA_a}');
    Error('\P{:=_IN_supplementary_PRIVATE_use_AREA_a}');
    Expect(1, 983040, '\p{insupplementaryprivateuseareaa}', "");
    Expect(0, 983040, '\p{^insupplementaryprivateuseareaa}', "");
    Expect(0, 983040, '\P{insupplementaryprivateuseareaa}', "");
    Expect(1, 983040, '\P{^insupplementaryprivateuseareaa}', "");
    Expect(0, 1048576, '\p{insupplementaryprivateuseareaa}', "");
    Expect(1, 1048576, '\p{^insupplementaryprivateuseareaa}', "");
    Expect(1, 1048576, '\P{insupplementaryprivateuseareaa}', "");
    Expect(0, 1048576, '\P{^insupplementaryprivateuseareaa}', "");
    Expect(1, 983040, '\p{	-In_SUPPLEMENTARY_private_USE_Area_A}', "");
    Expect(0, 983040, '\p{^	-In_SUPPLEMENTARY_private_USE_Area_A}', "");
    Expect(0, 983040, '\P{	-In_SUPPLEMENTARY_private_USE_Area_A}', "");
    Expect(1, 983040, '\P{^	-In_SUPPLEMENTARY_private_USE_Area_A}', "");
    Expect(0, 1048576, '\p{	-In_SUPPLEMENTARY_private_USE_Area_A}', "");
    Expect(1, 1048576, '\p{^	-In_SUPPLEMENTARY_private_USE_Area_A}', "");
    Expect(1, 1048576, '\P{	-In_SUPPLEMENTARY_private_USE_Area_A}', "");
    Expect(0, 1048576, '\P{^	-In_SUPPLEMENTARY_private_USE_Area_A}', "");
    Error('\p{:=- Sup_PUA_a}');
    Error('\P{:=- Sup_PUA_a}');
    Expect(1, 983040, '\p{suppuaa}', "");
    Expect(0, 983040, '\p{^suppuaa}', "");
    Expect(0, 983040, '\P{suppuaa}', "");
    Expect(1, 983040, '\P{^suppuaa}', "");
    Expect(0, 1048576, '\p{suppuaa}', "");
    Expect(1, 1048576, '\p{^suppuaa}', "");
    Expect(1, 1048576, '\P{suppuaa}', "");
    Expect(0, 1048576, '\P{^suppuaa}', "");
    Expect(1, 983040, '\p{	SUP_pua_A}', "");
    Expect(0, 983040, '\p{^	SUP_pua_A}', "");
    Expect(0, 983040, '\P{	SUP_pua_A}', "");
    Expect(1, 983040, '\P{^	SUP_pua_A}', "");
    Expect(0, 1048576, '\p{	SUP_pua_A}', "");
    Expect(1, 1048576, '\p{^	SUP_pua_A}', "");
    Expect(1, 1048576, '\P{	SUP_pua_A}', "");
    Expect(0, 1048576, '\P{^	SUP_pua_A}', "");
    Error('\p{-Is_SUP_PUA_A/a/}');
    Error('\P{-Is_SUP_PUA_A/a/}');
    Expect(1, 983040, '\p{issuppuaa}', "");
    Expect(0, 983040, '\p{^issuppuaa}', "");
    Expect(0, 983040, '\P{issuppuaa}', "");
    Expect(1, 983040, '\P{^issuppuaa}', "");
    Expect(0, 1048576, '\p{issuppuaa}', "");
    Expect(1, 1048576, '\p{^issuppuaa}', "");
    Expect(1, 1048576, '\P{issuppuaa}', "");
    Expect(0, 1048576, '\P{^issuppuaa}', "");
    Expect(1, 983040, '\p{_-IS_SUP_PUA_A}', "");
    Expect(0, 983040, '\p{^_-IS_SUP_PUA_A}', "");
    Expect(0, 983040, '\P{_-IS_SUP_PUA_A}', "");
    Expect(1, 983040, '\P{^_-IS_SUP_PUA_A}', "");
    Expect(0, 1048576, '\p{_-IS_SUP_PUA_A}', "");
    Expect(1, 1048576, '\p{^_-IS_SUP_PUA_A}', "");
    Expect(1, 1048576, '\P{_-IS_SUP_PUA_A}', "");
    Expect(0, 1048576, '\P{^_-IS_SUP_PUA_A}', "");
    Error('\p{/a/- In_sup_pua_A}');
    Error('\P{/a/- In_sup_pua_A}');
    Expect(1, 983040, '\p{insuppuaa}', "");
    Expect(0, 983040, '\p{^insuppuaa}', "");
    Expect(0, 983040, '\P{insuppuaa}', "");
    Expect(1, 983040, '\P{^insuppuaa}', "");
    Expect(0, 1048576, '\p{insuppuaa}', "");
    Expect(1, 1048576, '\p{^insuppuaa}', "");
    Expect(1, 1048576, '\P{insuppuaa}', "");
    Expect(0, 1048576, '\P{^insuppuaa}', "");
    Expect(1, 983040, '\p{--In_sup_PUA_A}', "");
    Expect(0, 983040, '\p{^--In_sup_PUA_A}', "");
    Expect(0, 983040, '\P{--In_sup_PUA_A}', "");
    Expect(1, 983040, '\P{^--In_sup_PUA_A}', "");
    Expect(0, 1048576, '\p{--In_sup_PUA_A}', "");
    Expect(1, 1048576, '\p{^--In_sup_PUA_A}', "");
    Expect(1, 1048576, '\P{--In_sup_PUA_A}', "");
    Expect(0, 1048576, '\P{^--In_sup_PUA_A}', "");
    Error('\p{/a/	Supplementary_private_Use_Area_b}');
    Error('\P{/a/	Supplementary_private_Use_Area_b}');
    Expect(1, 1048576, '\p{supplementaryprivateuseareab}', "");
    Expect(0, 1048576, '\p{^supplementaryprivateuseareab}', "");
    Expect(0, 1048576, '\P{supplementaryprivateuseareab}', "");
    Expect(1, 1048576, '\P{^supplementaryprivateuseareab}', "");
    Expect(0, 1, '\p{supplementaryprivateuseareab}', "");
    Expect(1, 1, '\p{^supplementaryprivateuseareab}', "");
    Expect(1, 1, '\P{supplementaryprivateuseareab}', "");
    Expect(0, 1, '\P{^supplementaryprivateuseareab}', "");
    Expect(1, 1048576, '\p{_SUPPLEMENTARY_private_use_Area_b}', "");
    Expect(0, 1048576, '\p{^_SUPPLEMENTARY_private_use_Area_b}', "");
    Expect(0, 1048576, '\P{_SUPPLEMENTARY_private_use_Area_b}', "");
    Expect(1, 1048576, '\P{^_SUPPLEMENTARY_private_use_Area_b}', "");
    Expect(0, 1, '\p{_SUPPLEMENTARY_private_use_Area_b}', "");
    Expect(1, 1, '\p{^_SUPPLEMENTARY_private_use_Area_b}', "");
    Expect(1, 1, '\P{_SUPPLEMENTARY_private_use_Area_b}', "");
    Expect(0, 1, '\P{^_SUPPLEMENTARY_private_use_Area_b}', "");
    Error('\p{_-Is_SUPPLEMENTARY_PRIVATE_use_Area_B/a/}');
    Error('\P{_-Is_SUPPLEMENTARY_PRIVATE_use_Area_B/a/}');
    Expect(1, 1048576, '\p{issupplementaryprivateuseareab}', "");
    Expect(0, 1048576, '\p{^issupplementaryprivateuseareab}', "");
    Expect(0, 1048576, '\P{issupplementaryprivateuseareab}', "");
    Expect(1, 1048576, '\P{^issupplementaryprivateuseareab}', "");
    Expect(0, 1, '\p{issupplementaryprivateuseareab}', "");
    Expect(1, 1, '\p{^issupplementaryprivateuseareab}', "");
    Expect(1, 1, '\P{issupplementaryprivateuseareab}', "");
    Expect(0, 1, '\P{^issupplementaryprivateuseareab}', "");
    Expect(1, 1048576, '\p{_ Is_Supplementary_Private_USE_AREA_B}', "");
    Expect(0, 1048576, '\p{^_ Is_Supplementary_Private_USE_AREA_B}', "");
    Expect(0, 1048576, '\P{_ Is_Supplementary_Private_USE_AREA_B}', "");
    Expect(1, 1048576, '\P{^_ Is_Supplementary_Private_USE_AREA_B}', "");
    Expect(0, 1, '\p{_ Is_Supplementary_Private_USE_AREA_B}', "");
    Expect(1, 1, '\p{^_ Is_Supplementary_Private_USE_AREA_B}', "");
    Expect(1, 1, '\P{_ Is_Supplementary_Private_USE_AREA_B}', "");
    Expect(0, 1, '\P{^_ Is_Supplementary_Private_USE_AREA_B}', "");
    Error('\p{-_in_SUPPLEMENTARY_PRIVATE_use_Area_b:=}');
    Error('\P{-_in_SUPPLEMENTARY_PRIVATE_use_Area_b:=}');
    Expect(1, 1048576, '\p{insupplementaryprivateuseareab}', "");
    Expect(0, 1048576, '\p{^insupplementaryprivateuseareab}', "");
    Expect(0, 1048576, '\P{insupplementaryprivateuseareab}', "");
    Expect(1, 1048576, '\P{^insupplementaryprivateuseareab}', "");
    Expect(0, 1, '\p{insupplementaryprivateuseareab}', "");
    Expect(1, 1, '\p{^insupplementaryprivateuseareab}', "");
    Expect(1, 1, '\P{insupplementaryprivateuseareab}', "");
    Expect(0, 1, '\P{^insupplementaryprivateuseareab}', "");
    Expect(1, 1048576, '\p{ -In_supplementary_private_Use_Area_B}', "");
    Expect(0, 1048576, '\p{^ -In_supplementary_private_Use_Area_B}', "");
    Expect(0, 1048576, '\P{ -In_supplementary_private_Use_Area_B}', "");
    Expect(1, 1048576, '\P{^ -In_supplementary_private_Use_Area_B}', "");
    Expect(0, 1, '\p{ -In_supplementary_private_Use_Area_B}', "");
    Expect(1, 1, '\p{^ -In_supplementary_private_Use_Area_B}', "");
    Expect(1, 1, '\P{ -In_supplementary_private_Use_Area_B}', "");
    Expect(0, 1, '\P{^ -In_supplementary_private_Use_Area_B}', "");
    Error('\p{/a/	SUP_PUA_B}');
    Error('\P{/a/	SUP_PUA_B}');
    Expect(1, 1048576, '\p{suppuab}', "");
    Expect(0, 1048576, '\p{^suppuab}', "");
    Expect(0, 1048576, '\P{suppuab}', "");
    Expect(1, 1048576, '\P{^suppuab}', "");
    Expect(0, 1, '\p{suppuab}', "");
    Expect(1, 1, '\p{^suppuab}', "");
    Expect(1, 1, '\P{suppuab}', "");
    Expect(0, 1, '\P{^suppuab}', "");
    Expect(1, 1048576, '\p{	 Sup_PUA_b}', "");
    Expect(0, 1048576, '\p{^	 Sup_PUA_b}', "");
    Expect(0, 1048576, '\P{	 Sup_PUA_b}', "");
    Expect(1, 1048576, '\P{^	 Sup_PUA_b}', "");
    Expect(0, 1, '\p{	 Sup_PUA_b}', "");
    Expect(1, 1, '\p{^	 Sup_PUA_b}', "");
    Expect(1, 1, '\P{	 Sup_PUA_b}', "");
    Expect(0, 1, '\P{^	 Sup_PUA_b}', "");
    Error('\p{__is_sup_PUA_B/a/}');
    Error('\P{__is_sup_PUA_B/a/}');
    Expect(1, 1048576, '\p{issuppuab}', "");
    Expect(0, 1048576, '\p{^issuppuab}', "");
    Expect(0, 1048576, '\P{issuppuab}', "");
    Expect(1, 1048576, '\P{^issuppuab}', "");
    Expect(0, 1, '\p{issuppuab}', "");
    Expect(1, 1, '\p{^issuppuab}', "");
    Expect(1, 1, '\P{issuppuab}', "");
    Expect(0, 1, '\P{^issuppuab}', "");
    Expect(1, 1048576, '\p{- Is_Sup_PUA_B}', "");
    Expect(0, 1048576, '\p{^- Is_Sup_PUA_B}', "");
    Expect(0, 1048576, '\P{- Is_Sup_PUA_B}', "");
    Expect(1, 1048576, '\P{^- Is_Sup_PUA_B}', "");
    Expect(0, 1, '\p{- Is_Sup_PUA_B}', "");
    Expect(1, 1, '\p{^- Is_Sup_PUA_B}', "");
    Expect(1, 1, '\P{- Is_Sup_PUA_B}', "");
    Expect(0, 1, '\P{^- Is_Sup_PUA_B}', "");
    Error('\p{/a/_	in_Sup_PUA_B}');
    Error('\P{/a/_	in_Sup_PUA_B}');
    Expect(1, 1048576, '\p{insuppuab}', "");
    Expect(0, 1048576, '\p{^insuppuab}', "");
    Expect(0, 1048576, '\P{insuppuab}', "");
    Expect(1, 1048576, '\P{^insuppuab}', "");
    Expect(0, 1, '\p{insuppuab}', "");
    Expect(1, 1, '\p{^insuppuab}', "");
    Expect(1, 1, '\P{insuppuab}', "");
    Expect(0, 1, '\P{^insuppuab}', "");
    Expect(1, 1048576, '\p{	-In_SUP_PUA_B}', "");
    Expect(0, 1048576, '\p{^	-In_SUP_PUA_B}', "");
    Expect(0, 1048576, '\P{	-In_SUP_PUA_B}', "");
    Expect(1, 1048576, '\P{^	-In_SUP_PUA_B}', "");
    Expect(0, 1, '\p{	-In_SUP_PUA_B}', "");
    Expect(1, 1, '\p{^	-In_SUP_PUA_B}', "");
    Expect(1, 1, '\P{	-In_SUP_PUA_B}', "");
    Expect(0, 1, '\P{^	-In_SUP_PUA_B}', "");
    Error('\p{/a/Surrogate}');
    Error('\P{/a/Surrogate}');
    Expect(1, 57343, '\p{surrogate}', "");
    Expect(0, 57343, '\p{^surrogate}', "");
    Expect(0, 57343, '\P{surrogate}', "");
    Expect(1, 57343, '\P{^surrogate}', "");
    Expect(0, 57344, '\p{surrogate}', "");
    Expect(1, 57344, '\p{^surrogate}', "");
    Expect(1, 57344, '\P{surrogate}', "");
    Expect(0, 57344, '\P{^surrogate}', "");
    Expect(1, 57343, '\p{  SURROGATE}', "");
    Expect(0, 57343, '\p{^  SURROGATE}', "");
    Expect(0, 57343, '\P{  SURROGATE}', "");
    Expect(1, 57343, '\P{^  SURROGATE}', "");
    Expect(0, 57344, '\p{  SURROGATE}', "");
    Expect(1, 57344, '\p{^  SURROGATE}', "");
    Expect(1, 57344, '\P{  SURROGATE}', "");
    Expect(0, 57344, '\P{^  SURROGATE}', "");
    Error('\p{/a/ _IS_SURROGATE}');
    Error('\P{/a/ _IS_SURROGATE}');
    Expect(1, 57343, '\p{issurrogate}', "");
    Expect(0, 57343, '\p{^issurrogate}', "");
    Expect(0, 57343, '\P{issurrogate}', "");
    Expect(1, 57343, '\P{^issurrogate}', "");
    Expect(0, 57344, '\p{issurrogate}', "");
    Expect(1, 57344, '\p{^issurrogate}', "");
    Expect(1, 57344, '\P{issurrogate}', "");
    Expect(0, 57344, '\P{^issurrogate}', "");
    Expect(1, 57343, '\p{_Is_SURROGATE}', "");
    Expect(0, 57343, '\p{^_Is_SURROGATE}', "");
    Expect(0, 57343, '\P{_Is_SURROGATE}', "");
    Expect(1, 57343, '\P{^_Is_SURROGATE}', "");
    Expect(0, 57344, '\p{_Is_SURROGATE}', "");
    Expect(1, 57344, '\p{^_Is_SURROGATE}', "");
    Expect(1, 57344, '\P{_Is_SURROGATE}', "");
    Expect(0, 57344, '\P{^_Is_SURROGATE}', "");
    Error('\p{ CS:=}');
    Error('\P{ CS:=}');
    Expect(1, 57343, '\p{cs}', "");
    Expect(0, 57343, '\p{^cs}', "");
    Expect(0, 57343, '\P{cs}', "");
    Expect(1, 57343, '\P{^cs}', "");
    Expect(0, 57344, '\p{cs}', "");
    Expect(1, 57344, '\p{^cs}', "");
    Expect(1, 57344, '\P{cs}', "");
    Expect(0, 57344, '\P{^cs}', "");
    Expect(1, 57343, '\p{	 Cs}', "");
    Expect(0, 57343, '\p{^	 Cs}', "");
    Expect(0, 57343, '\P{	 Cs}', "");
    Expect(1, 57343, '\P{^	 Cs}', "");
    Expect(0, 57344, '\p{	 Cs}', "");
    Expect(1, 57344, '\p{^	 Cs}', "");
    Expect(1, 57344, '\P{	 Cs}', "");
    Expect(0, 57344, '\P{^	 Cs}', "");
    Error('\p{IS_Cs:=}');
    Error('\P{IS_Cs:=}');
    Expect(1, 57343, '\p{iscs}', "");
    Expect(0, 57343, '\p{^iscs}', "");
    Expect(0, 57343, '\P{iscs}', "");
    Expect(1, 57343, '\P{^iscs}', "");
    Expect(0, 57344, '\p{iscs}', "");
    Expect(1, 57344, '\p{^iscs}', "");
    Expect(1, 57344, '\P{iscs}', "");
    Expect(0, 57344, '\P{^iscs}', "");
    Expect(1, 57343, '\p{	_is_CS}', "");
    Expect(0, 57343, '\p{^	_is_CS}', "");
    Expect(0, 57343, '\P{	_is_CS}', "");
    Expect(1, 57343, '\P{^	_is_CS}', "");
    Expect(0, 57344, '\p{	_is_CS}', "");
    Expect(1, 57344, '\p{^	_is_CS}', "");
    Expect(1, 57344, '\P{	_is_CS}', "");
    Expect(0, 57344, '\P{^	_is_CS}', "");
    Error('\p{-:=SUTTON_SignWriting}');
    Error('\P{-:=SUTTON_SignWriting}');
    Expect(1, 121519, '\p{suttonsignwriting}', "");
    Expect(0, 121519, '\p{^suttonsignwriting}', "");
    Expect(0, 121519, '\P{suttonsignwriting}', "");
    Expect(1, 121519, '\P{^suttonsignwriting}', "");
    Expect(0, 121520, '\p{suttonsignwriting}', "");
    Expect(1, 121520, '\p{^suttonsignwriting}', "");
    Expect(1, 121520, '\P{suttonsignwriting}', "");
    Expect(0, 121520, '\P{^suttonsignwriting}', "");
    Expect(1, 121519, '\p{	_Sutton_SignWriting}', "");
    Expect(0, 121519, '\p{^	_Sutton_SignWriting}', "");
    Expect(0, 121519, '\P{	_Sutton_SignWriting}', "");
    Expect(1, 121519, '\P{^	_Sutton_SignWriting}', "");
    Expect(0, 121520, '\p{	_Sutton_SignWriting}', "");
    Expect(1, 121520, '\p{^	_Sutton_SignWriting}', "");
    Expect(1, 121520, '\P{	_Sutton_SignWriting}', "");
    Expect(0, 121520, '\P{^	_Sutton_SignWriting}', "");
    Error('\p{/a/is_SUTTON_SignWriting}');
    Error('\P{/a/is_SUTTON_SignWriting}');
    Expect(1, 121519, '\p{issuttonsignwriting}', "");
    Expect(0, 121519, '\p{^issuttonsignwriting}', "");
    Expect(0, 121519, '\P{issuttonsignwriting}', "");
    Expect(1, 121519, '\P{^issuttonsignwriting}', "");
    Expect(0, 121520, '\p{issuttonsignwriting}', "");
    Expect(1, 121520, '\p{^issuttonsignwriting}', "");
    Expect(1, 121520, '\P{issuttonsignwriting}', "");
    Expect(0, 121520, '\P{^issuttonsignwriting}', "");
    Expect(1, 121519, '\p{	_IS_SUTTON_SignWriting}', "");
    Expect(0, 121519, '\p{^	_IS_SUTTON_SignWriting}', "");
    Expect(0, 121519, '\P{	_IS_SUTTON_SignWriting}', "");
    Expect(1, 121519, '\P{^	_IS_SUTTON_SignWriting}', "");
    Expect(0, 121520, '\p{	_IS_SUTTON_SignWriting}', "");
    Expect(1, 121520, '\p{^	_IS_SUTTON_SignWriting}', "");
    Expect(1, 121520, '\P{	_IS_SUTTON_SignWriting}', "");
    Expect(0, 121520, '\P{^	_IS_SUTTON_SignWriting}', "");
    Error('\p{:= _In_Sutton_SignWriting}');
    Error('\P{:= _In_Sutton_SignWriting}');
    Expect(1, 121519, '\p{insuttonsignwriting}', "");
    Expect(0, 121519, '\p{^insuttonsignwriting}', "");
    Expect(0, 121519, '\P{insuttonsignwriting}', "");
    Expect(1, 121519, '\P{^insuttonsignwriting}', "");
    Expect(0, 121520, '\p{insuttonsignwriting}', "");
    Expect(1, 121520, '\p{^insuttonsignwriting}', "");
    Expect(1, 121520, '\P{insuttonsignwriting}', "");
    Expect(0, 121520, '\P{^insuttonsignwriting}', "");
    Expect(1, 121519, '\p{-In_SUTTON_SignWriting}', "");
    Expect(0, 121519, '\p{^-In_SUTTON_SignWriting}', "");
    Expect(0, 121519, '\P{-In_SUTTON_SignWriting}', "");
    Expect(1, 121519, '\P{^-In_SUTTON_SignWriting}', "");
    Expect(0, 121520, '\p{-In_SUTTON_SignWriting}', "");
    Expect(1, 121520, '\p{^-In_SUTTON_SignWriting}', "");
    Expect(1, 121520, '\P{-In_SUTTON_SignWriting}', "");
    Expect(0, 121520, '\P{^-In_SUTTON_SignWriting}', "");
    Error('\p{/a/	_Syloti_Nagri}');
    Error('\P{/a/	_Syloti_Nagri}');
    Expect(1, 43052, '\p{sylotinagri}', "");
    Expect(0, 43052, '\p{^sylotinagri}', "");
    Expect(0, 43052, '\P{sylotinagri}', "");
    Expect(1, 43052, '\P{^sylotinagri}', "");
    Expect(0, 43053, '\p{sylotinagri}', "");
    Expect(1, 43053, '\p{^sylotinagri}', "");
    Expect(1, 43053, '\P{sylotinagri}', "");
    Expect(0, 43053, '\P{^sylotinagri}', "");
    Expect(1, 43052, '\p{	_syloti_NAGRI}', "");
    Expect(0, 43052, '\p{^	_syloti_NAGRI}', "");
    Expect(0, 43052, '\P{	_syloti_NAGRI}', "");
    Expect(1, 43052, '\P{^	_syloti_NAGRI}', "");
    Expect(0, 43053, '\p{	_syloti_NAGRI}', "");
    Expect(1, 43053, '\p{^	_syloti_NAGRI}', "");
    Expect(1, 43053, '\P{	_syloti_NAGRI}', "");
    Expect(0, 43053, '\P{^	_syloti_NAGRI}', "");
    Error('\p{/a/_ IS_Syloti_Nagri}');
    Error('\P{/a/_ IS_Syloti_Nagri}');
    Expect(1, 43052, '\p{issylotinagri}', "");
    Expect(0, 43052, '\p{^issylotinagri}', "");
    Expect(0, 43052, '\P{issylotinagri}', "");
    Expect(1, 43052, '\P{^issylotinagri}', "");
    Expect(0, 43053, '\p{issylotinagri}', "");
    Expect(1, 43053, '\p{^issylotinagri}', "");
    Expect(1, 43053, '\P{issylotinagri}', "");
    Expect(0, 43053, '\P{^issylotinagri}', "");
    Expect(1, 43052, '\p{	Is_Syloti_Nagri}', "");
    Expect(0, 43052, '\p{^	Is_Syloti_Nagri}', "");
    Expect(0, 43052, '\P{	Is_Syloti_Nagri}', "");
    Expect(1, 43052, '\P{^	Is_Syloti_Nagri}', "");
    Expect(0, 43053, '\p{	Is_Syloti_Nagri}', "");
    Expect(1, 43053, '\p{^	Is_Syloti_Nagri}', "");
    Expect(1, 43053, '\P{	Is_Syloti_Nagri}', "");
    Expect(0, 43053, '\P{^	Is_Syloti_Nagri}', "");
    Error('\p{:=_Sylo}');
    Error('\P{:=_Sylo}');
    Expect(1, 43052, '\p{sylo}', "");
    Expect(0, 43052, '\p{^sylo}', "");
    Expect(0, 43052, '\P{sylo}', "");
    Expect(1, 43052, '\P{^sylo}', "");
    Expect(0, 43053, '\p{sylo}', "");
    Expect(1, 43053, '\p{^sylo}', "");
    Expect(1, 43053, '\P{sylo}', "");
    Expect(0, 43053, '\P{^sylo}', "");
    Expect(1, 43052, '\p{ SYLO}', "");
    Expect(0, 43052, '\p{^ SYLO}', "");
    Expect(0, 43052, '\P{ SYLO}', "");
    Expect(1, 43052, '\P{^ SYLO}', "");
    Expect(0, 43053, '\p{ SYLO}', "");
    Expect(1, 43053, '\p{^ SYLO}', "");
    Expect(1, 43053, '\P{ SYLO}', "");
    Expect(0, 43053, '\P{^ SYLO}', "");
    Error('\p{	Is_SYLO/a/}');
    Error('\P{	Is_SYLO/a/}');
    Expect(1, 43052, '\p{issylo}', "");
    Expect(0, 43052, '\p{^issylo}', "");
    Expect(0, 43052, '\P{issylo}', "");
    Expect(1, 43052, '\P{^issylo}', "");
    Expect(0, 43053, '\p{issylo}', "");
    Expect(1, 43053, '\p{^issylo}', "");
    Expect(1, 43053, '\P{issylo}', "");
    Expect(0, 43053, '\P{^issylo}', "");
    Expect(1, 43052, '\p{_	is_Sylo}', "");
    Expect(0, 43052, '\p{^_	is_Sylo}', "");
    Expect(0, 43052, '\P{_	is_Sylo}', "");
    Expect(1, 43052, '\P{^_	is_Sylo}', "");
    Expect(0, 43053, '\p{_	is_Sylo}', "");
    Expect(1, 43053, '\p{^_	is_Sylo}', "");
    Expect(1, 43053, '\P{_	is_Sylo}', "");
    Expect(0, 43053, '\P{^_	is_Sylo}', "");
    Error('\p{:= 	Symbol}');
    Error('\P{:= 	Symbol}');
    Expect(1, 129994, '\p{symbol}', "");
    Expect(0, 129994, '\p{^symbol}', "");
    Expect(0, 129994, '\P{symbol}', "");
    Expect(1, 129994, '\P{^symbol}', "");
    Expect(0, 129995, '\p{symbol}', "");
    Expect(1, 129995, '\p{^symbol}', "");
    Expect(1, 129995, '\P{symbol}', "");
    Expect(0, 129995, '\P{^symbol}', "");
    Expect(1, 129994, '\p{_	Symbol}', "");
    Expect(0, 129994, '\p{^_	Symbol}', "");
    Expect(0, 129994, '\P{_	Symbol}', "");
    Expect(1, 129994, '\P{^_	Symbol}', "");
    Expect(0, 129995, '\p{_	Symbol}', "");
    Expect(1, 129995, '\p{^_	Symbol}', "");
    Expect(1, 129995, '\P{_	Symbol}', "");
    Expect(0, 129995, '\P{^_	Symbol}', "");
    Error('\p{ _Is_Symbol:=}');
    Error('\P{ _Is_Symbol:=}');
    Expect(1, 129994, '\p{issymbol}', "");
    Expect(0, 129994, '\p{^issymbol}', "");
    Expect(0, 129994, '\P{issymbol}', "");
    Expect(1, 129994, '\P{^issymbol}', "");
    Expect(0, 129995, '\p{issymbol}', "");
    Expect(1, 129995, '\p{^issymbol}', "");
    Expect(1, 129995, '\P{issymbol}', "");
    Expect(0, 129995, '\P{^issymbol}', "");
    Expect(1, 129994, '\p{	is_SYMBOL}', "");
    Expect(0, 129994, '\p{^	is_SYMBOL}', "");
    Expect(0, 129994, '\P{	is_SYMBOL}', "");
    Expect(1, 129994, '\P{^	is_SYMBOL}', "");
    Expect(0, 129995, '\p{	is_SYMBOL}', "");
    Expect(1, 129995, '\p{^	is_SYMBOL}', "");
    Expect(1, 129995, '\P{	is_SYMBOL}', "");
    Expect(0, 129995, '\P{^	is_SYMBOL}', "");
    Error('\p{/a/  S}');
    Error('\P{/a/  S}');
    Expect(1, 129994, '\p{s}', "");
    Expect(0, 129994, '\p{^s}', "");
    Expect(0, 129994, '\P{s}', "");
    Expect(1, 129994, '\P{^s}', "");
    Expect(0, 129995, '\p{s}', "");
    Expect(1, 129995, '\p{^s}', "");
    Expect(1, 129995, '\P{s}', "");
    Expect(0, 129995, '\P{^s}', "");
    Expect(1, 129994, '\p{--s}', "");
    Expect(0, 129994, '\p{^--s}', "");
    Expect(0, 129994, '\P{--s}', "");
    Expect(1, 129994, '\P{^--s}', "");
    Expect(0, 129995, '\p{--s}', "");
    Expect(1, 129995, '\p{^--s}', "");
    Expect(1, 129995, '\P{--s}', "");
    Expect(0, 129995, '\P{^--s}', "");
    Error('\p{__Is_S:=}');
    Error('\P{__Is_S:=}');
    Expect(1, 129994, '\p{iss}', "");
    Expect(0, 129994, '\p{^iss}', "");
    Expect(0, 129994, '\P{iss}', "");
    Expect(1, 129994, '\P{^iss}', "");
    Expect(0, 129995, '\p{iss}', "");
    Expect(1, 129995, '\p{^iss}', "");
    Expect(1, 129995, '\P{iss}', "");
    Expect(0, 129995, '\P{^iss}', "");
    Expect(1, 129994, '\p{-is_s}', "");
    Expect(0, 129994, '\p{^-is_s}', "");
    Expect(0, 129994, '\P{-is_s}', "");
    Expect(1, 129994, '\P{^-is_s}', "");
    Expect(0, 129995, '\p{-is_s}', "");
    Expect(1, 129995, '\p{^-is_s}', "");
    Expect(1, 129995, '\P{-is_s}', "");
    Expect(0, 129995, '\P{^-is_s}', "");
    Error('\p{_ Symbols_AND_Pictographs_EXTENDED_A:=}');
    Error('\P{_ Symbols_AND_Pictographs_EXTENDED_A:=}');
    Expect(1, 129791, '\p{symbolsandpictographsextendeda}', "");
    Expect(0, 129791, '\p{^symbolsandpictographsextendeda}', "");
    Expect(0, 129791, '\P{symbolsandpictographsextendeda}', "");
    Expect(1, 129791, '\P{^symbolsandpictographsextendeda}', "");
    Expect(0, 129792, '\p{symbolsandpictographsextendeda}', "");
    Expect(1, 129792, '\p{^symbolsandpictographsextendeda}', "");
    Expect(1, 129792, '\P{symbolsandpictographsextendeda}', "");
    Expect(0, 129792, '\P{^symbolsandpictographsextendeda}', "");
    Expect(1, 129791, '\p{_ symbols_And_Pictographs_Extended_a}', "");
    Expect(0, 129791, '\p{^_ symbols_And_Pictographs_Extended_a}', "");
    Expect(0, 129791, '\P{_ symbols_And_Pictographs_Extended_a}', "");
    Expect(1, 129791, '\P{^_ symbols_And_Pictographs_Extended_a}', "");
    Expect(0, 129792, '\p{_ symbols_And_Pictographs_Extended_a}', "");
    Expect(1, 129792, '\p{^_ symbols_And_Pictographs_Extended_a}', "");
    Expect(1, 129792, '\P{_ symbols_And_Pictographs_Extended_a}', "");
    Expect(0, 129792, '\P{^_ symbols_And_Pictographs_Extended_a}', "");
    Error('\p{/a/	-IS_SYMBOLS_and_Pictographs_Extended_A}');
    Error('\P{/a/	-IS_SYMBOLS_and_Pictographs_Extended_A}');
    Expect(1, 129791, '\p{issymbolsandpictographsextendeda}', "");
    Expect(0, 129791, '\p{^issymbolsandpictographsextendeda}', "");
    Expect(0, 129791, '\P{issymbolsandpictographsextendeda}', "");
    Expect(1, 129791, '\P{^issymbolsandpictographsextendeda}', "");
    Expect(0, 129792, '\p{issymbolsandpictographsextendeda}', "");
    Expect(1, 129792, '\p{^issymbolsandpictographsextendeda}', "");
    Expect(1, 129792, '\P{issymbolsandpictographsextendeda}', "");
    Expect(0, 129792, '\P{^issymbolsandpictographsextendeda}', "");
    Expect(1, 129791, '\p{	_is_symbols_And_PICTOGRAPHS_Extended_A}', "");
    Expect(0, 129791, '\p{^	_is_symbols_And_PICTOGRAPHS_Extended_A}', "");
    Expect(0, 129791, '\P{	_is_symbols_And_PICTOGRAPHS_Extended_A}', "");
    Expect(1, 129791, '\P{^	_is_symbols_And_PICTOGRAPHS_Extended_A}', "");
    Expect(0, 129792, '\p{	_is_symbols_And_PICTOGRAPHS_Extended_A}', "");
    Expect(1, 129792, '\p{^	_is_symbols_And_PICTOGRAPHS_Extended_A}', "");
    Expect(1, 129792, '\P{	_is_symbols_And_PICTOGRAPHS_Extended_A}', "");
    Expect(0, 129792, '\P{^	_is_symbols_And_PICTOGRAPHS_Extended_A}', "");
    Error('\p{ /a/In_SYMBOLS_And_Pictographs_extended_A}');
    Error('\P{ /a/In_SYMBOLS_And_Pictographs_extended_A}');
    Expect(1, 129791, '\p{insymbolsandpictographsextendeda}', "");
    Expect(0, 129791, '\p{^insymbolsandpictographsextendeda}', "");
    Expect(0, 129791, '\P{insymbolsandpictographsextendeda}', "");
    Expect(1, 129791, '\P{^insymbolsandpictographsextendeda}', "");
    Expect(0, 129792, '\p{insymbolsandpictographsextendeda}', "");
    Expect(1, 129792, '\p{^insymbolsandpictographsextendeda}', "");
    Expect(1, 129792, '\P{insymbolsandpictographsextendeda}', "");
    Expect(0, 129792, '\P{^insymbolsandpictographsextendeda}', "");
    Expect(1, 129791, '\p{- In_Symbols_and_pictographs_EXTENDED_A}', "");
    Expect(0, 129791, '\p{^- In_Symbols_and_pictographs_EXTENDED_A}', "");
    Expect(0, 129791, '\P{- In_Symbols_and_pictographs_EXTENDED_A}', "");
    Expect(1, 129791, '\P{^- In_Symbols_and_pictographs_EXTENDED_A}', "");
    Expect(0, 129792, '\p{- In_Symbols_and_pictographs_EXTENDED_A}', "");
    Expect(1, 129792, '\p{^- In_Symbols_and_pictographs_EXTENDED_A}', "");
    Expect(1, 129792, '\P{- In_Symbols_and_pictographs_EXTENDED_A}', "");
    Expect(0, 129792, '\P{^- In_Symbols_and_pictographs_EXTENDED_A}', "");
    Error('\p{/a/Symbols_And_Pictographs_Ext_A}');
    Error('\P{/a/Symbols_And_Pictographs_Ext_A}');
    Expect(1, 129791, '\p{symbolsandpictographsexta}', "");
    Expect(0, 129791, '\p{^symbolsandpictographsexta}', "");
    Expect(0, 129791, '\P{symbolsandpictographsexta}', "");
    Expect(1, 129791, '\P{^symbolsandpictographsexta}', "");
    Expect(0, 129792, '\p{symbolsandpictographsexta}', "");
    Expect(1, 129792, '\p{^symbolsandpictographsexta}', "");
    Expect(1, 129792, '\P{symbolsandpictographsexta}', "");
    Expect(0, 129792, '\P{^symbolsandpictographsexta}', "");
    Expect(1, 129791, '\p{  Symbols_And_Pictographs_EXT_A}', "");
    Expect(0, 129791, '\p{^  Symbols_And_Pictographs_EXT_A}', "");
    Expect(0, 129791, '\P{  Symbols_And_Pictographs_EXT_A}', "");
    Expect(1, 129791, '\P{^  Symbols_And_Pictographs_EXT_A}', "");
    Expect(0, 129792, '\p{  Symbols_And_Pictographs_EXT_A}', "");
    Expect(1, 129792, '\p{^  Symbols_And_Pictographs_EXT_A}', "");
    Expect(1, 129792, '\P{  Symbols_And_Pictographs_EXT_A}', "");
    Expect(0, 129792, '\P{^  Symbols_And_Pictographs_EXT_A}', "");
    Error('\p{:=	Is_symbols_and_Pictographs_Ext_A}');
    Error('\P{:=	Is_symbols_and_Pictographs_Ext_A}');
    Expect(1, 129791, '\p{issymbolsandpictographsexta}', "");
    Expect(0, 129791, '\p{^issymbolsandpictographsexta}', "");
    Expect(0, 129791, '\P{issymbolsandpictographsexta}', "");
    Expect(1, 129791, '\P{^issymbolsandpictographsexta}', "");
    Expect(0, 129792, '\p{issymbolsandpictographsexta}', "");
    Expect(1, 129792, '\p{^issymbolsandpictographsexta}', "");
    Expect(1, 129792, '\P{issymbolsandpictographsexta}', "");
    Expect(0, 129792, '\P{^issymbolsandpictographsexta}', "");
    Expect(1, 129791, '\p{-Is_Symbols_and_PICTOGRAPHS_ext_a}', "");
    Expect(0, 129791, '\p{^-Is_Symbols_and_PICTOGRAPHS_ext_a}', "");
    Expect(0, 129791, '\P{-Is_Symbols_and_PICTOGRAPHS_ext_a}', "");
    Expect(1, 129791, '\P{^-Is_Symbols_and_PICTOGRAPHS_ext_a}', "");
    Expect(0, 129792, '\p{-Is_Symbols_and_PICTOGRAPHS_ext_a}', "");
    Expect(1, 129792, '\p{^-Is_Symbols_and_PICTOGRAPHS_ext_a}', "");
    Expect(1, 129792, '\P{-Is_Symbols_and_PICTOGRAPHS_ext_a}', "");
    Expect(0, 129792, '\P{^-Is_Symbols_and_PICTOGRAPHS_ext_a}', "");
    Error('\p{_/a/IN_Symbols_AND_pictographs_Ext_A}');
    Error('\P{_/a/IN_Symbols_AND_pictographs_Ext_A}');
    Expect(1, 129791, '\p{insymbolsandpictographsexta}', "");
    Expect(0, 129791, '\p{^insymbolsandpictographsexta}', "");
    Expect(0, 129791, '\P{insymbolsandpictographsexta}', "");
    Expect(1, 129791, '\P{^insymbolsandpictographsexta}', "");
    Expect(0, 129792, '\p{insymbolsandpictographsexta}', "");
    Expect(1, 129792, '\p{^insymbolsandpictographsexta}', "");
    Expect(1, 129792, '\P{insymbolsandpictographsexta}', "");
    Expect(0, 129792, '\P{^insymbolsandpictographsexta}', "");
    Expect(1, 129791, '\p{ In_SYMBOLS_And_PICTOGRAPHS_Ext_A}', "");
    Expect(0, 129791, '\p{^ In_SYMBOLS_And_PICTOGRAPHS_Ext_A}', "");
    Expect(0, 129791, '\P{ In_SYMBOLS_And_PICTOGRAPHS_Ext_A}', "");
    Expect(1, 129791, '\P{^ In_SYMBOLS_And_PICTOGRAPHS_Ext_A}', "");
    Expect(0, 129792, '\p{ In_SYMBOLS_And_PICTOGRAPHS_Ext_A}', "");
    Expect(1, 129792, '\p{^ In_SYMBOLS_And_PICTOGRAPHS_Ext_A}', "");
    Expect(1, 129792, '\P{ In_SYMBOLS_And_PICTOGRAPHS_Ext_A}', "");
    Expect(0, 129792, '\P{^ In_SYMBOLS_And_PICTOGRAPHS_Ext_A}', "");
    Error('\p{ :=symbols_FOR_LEGACY_Computing}');
    Error('\P{ :=symbols_FOR_LEGACY_Computing}');
    Expect(1, 130047, '\p{symbolsforlegacycomputing}', "");
    Expect(0, 130047, '\p{^symbolsforlegacycomputing}', "");
    Expect(0, 130047, '\P{symbolsforlegacycomputing}', "");
    Expect(1, 130047, '\P{^symbolsforlegacycomputing}', "");
    Expect(0, 130048, '\p{symbolsforlegacycomputing}', "");
    Expect(1, 130048, '\p{^symbolsforlegacycomputing}', "");
    Expect(1, 130048, '\P{symbolsforlegacycomputing}', "");
    Expect(0, 130048, '\P{^symbolsforlegacycomputing}', "");
    Expect(1, 130047, '\p{- Symbols_For_Legacy_COMPUTING}', "");
    Expect(0, 130047, '\p{^- Symbols_For_Legacy_COMPUTING}', "");
    Expect(0, 130047, '\P{- Symbols_For_Legacy_COMPUTING}', "");
    Expect(1, 130047, '\P{^- Symbols_For_Legacy_COMPUTING}', "");
    Expect(0, 130048, '\p{- Symbols_For_Legacy_COMPUTING}', "");
    Expect(1, 130048, '\p{^- Symbols_For_Legacy_COMPUTING}', "");
    Expect(1, 130048, '\P{- Symbols_For_Legacy_COMPUTING}', "");
    Expect(0, 130048, '\P{^- Symbols_For_Legacy_COMPUTING}', "");
    Error('\p{	 Is_SYMBOLS_For_legacy_computing:=}');
    Error('\P{	 Is_SYMBOLS_For_legacy_computing:=}');
    Expect(1, 130047, '\p{issymbolsforlegacycomputing}', "");
    Expect(0, 130047, '\p{^issymbolsforlegacycomputing}', "");
    Expect(0, 130047, '\P{issymbolsforlegacycomputing}', "");
    Expect(1, 130047, '\P{^issymbolsforlegacycomputing}', "");
    Expect(0, 130048, '\p{issymbolsforlegacycomputing}', "");
    Expect(1, 130048, '\p{^issymbolsforlegacycomputing}', "");
    Expect(1, 130048, '\P{issymbolsforlegacycomputing}', "");
    Expect(0, 130048, '\P{^issymbolsforlegacycomputing}', "");
    Expect(1, 130047, '\p{ 	Is_SYMBOLS_For_Legacy_COMPUTING}', "");
    Expect(0, 130047, '\p{^ 	Is_SYMBOLS_For_Legacy_COMPUTING}', "");
    Expect(0, 130047, '\P{ 	Is_SYMBOLS_For_Legacy_COMPUTING}', "");
    Expect(1, 130047, '\P{^ 	Is_SYMBOLS_For_Legacy_COMPUTING}', "");
    Expect(0, 130048, '\p{ 	Is_SYMBOLS_For_Legacy_COMPUTING}', "");
    Expect(1, 130048, '\p{^ 	Is_SYMBOLS_For_Legacy_COMPUTING}', "");
    Expect(1, 130048, '\P{ 	Is_SYMBOLS_For_Legacy_COMPUTING}', "");
    Expect(0, 130048, '\P{^ 	Is_SYMBOLS_For_Legacy_COMPUTING}', "");
    Error('\p{IN_SYMBOLS_For_LEGACY_computing:=}');
    Error('\P{IN_SYMBOLS_For_LEGACY_computing:=}');
    Expect(1, 130047, '\p{insymbolsforlegacycomputing}', "");
    Expect(0, 130047, '\p{^insymbolsforlegacycomputing}', "");
    Expect(0, 130047, '\P{insymbolsforlegacycomputing}', "");
    Expect(1, 130047, '\P{^insymbolsforlegacycomputing}', "");
    Expect(0, 130048, '\p{insymbolsforlegacycomputing}', "");
    Expect(1, 130048, '\p{^insymbolsforlegacycomputing}', "");
    Expect(1, 130048, '\P{insymbolsforlegacycomputing}', "");
    Expect(0, 130048, '\P{^insymbolsforlegacycomputing}', "");
    Expect(1, 130047, '\p{		In_Symbols_For_Legacy_Computing}', "");
    Expect(0, 130047, '\p{^		In_Symbols_For_Legacy_Computing}', "");
    Expect(0, 130047, '\P{		In_Symbols_For_Legacy_Computing}', "");
    Expect(1, 130047, '\P{^		In_Symbols_For_Legacy_Computing}', "");
    Expect(0, 130048, '\p{		In_Symbols_For_Legacy_Computing}', "");
    Expect(1, 130048, '\p{^		In_Symbols_For_Legacy_Computing}', "");
    Expect(1, 130048, '\P{		In_Symbols_For_Legacy_Computing}', "");
    Expect(0, 130048, '\P{^		In_Symbols_For_Legacy_Computing}', "");
    Error('\p{- SYRIAC/a/}');
    Error('\P{- SYRIAC/a/}');
    Expect(1, 7674, '\p{syriac}', "");
    Expect(0, 7674, '\p{^syriac}', "");
    Expect(0, 7674, '\P{syriac}', "");
    Expect(1, 7674, '\P{^syriac}', "");
    Expect(0, 7675, '\p{syriac}', "");
    Expect(1, 7675, '\p{^syriac}', "");
    Expect(1, 7675, '\P{syriac}', "");
    Expect(0, 7675, '\P{^syriac}', "");
    Expect(1, 7674, '\p{_	syriac}', "");
    Expect(0, 7674, '\p{^_	syriac}', "");
    Expect(0, 7674, '\P{_	syriac}', "");
    Expect(1, 7674, '\P{^_	syriac}', "");
    Expect(0, 7675, '\p{_	syriac}', "");
    Expect(1, 7675, '\p{^_	syriac}', "");
    Expect(1, 7675, '\P{_	syriac}', "");
    Expect(0, 7675, '\P{^_	syriac}', "");
    Error('\p{-Is_syriac:=}');
    Error('\P{-Is_syriac:=}');
    Expect(1, 7674, '\p{issyriac}', "");
    Expect(0, 7674, '\p{^issyriac}', "");
    Expect(0, 7674, '\P{issyriac}', "");
    Expect(1, 7674, '\P{^issyriac}', "");
    Expect(0, 7675, '\p{issyriac}', "");
    Expect(1, 7675, '\p{^issyriac}', "");
    Expect(1, 7675, '\P{issyriac}', "");
    Expect(0, 7675, '\P{^issyriac}', "");
    Expect(1, 7674, '\p{_ IS_SYRIAC}', "");
    Expect(0, 7674, '\p{^_ IS_SYRIAC}', "");
    Expect(0, 7674, '\P{_ IS_SYRIAC}', "");
    Expect(1, 7674, '\P{^_ IS_SYRIAC}', "");
    Expect(0, 7675, '\p{_ IS_SYRIAC}', "");
    Expect(1, 7675, '\p{^_ IS_SYRIAC}', "");
    Expect(1, 7675, '\P{_ IS_SYRIAC}', "");
    Expect(0, 7675, '\P{^_ IS_SYRIAC}', "");
    Error('\p{:=syrc}');
    Error('\P{:=syrc}');
    Expect(1, 7674, '\p{syrc}', "");
    Expect(0, 7674, '\p{^syrc}', "");
    Expect(0, 7674, '\P{syrc}', "");
    Expect(1, 7674, '\P{^syrc}', "");
    Expect(0, 7675, '\p{syrc}', "");
    Expect(1, 7675, '\p{^syrc}', "");
    Expect(1, 7675, '\P{syrc}', "");
    Expect(0, 7675, '\P{^syrc}', "");
    Expect(1, 7674, '\p{-	Syrc}', "");
    Expect(0, 7674, '\p{^-	Syrc}', "");
    Expect(0, 7674, '\P{-	Syrc}', "");
    Expect(1, 7674, '\P{^-	Syrc}', "");
    Expect(0, 7675, '\p{-	Syrc}', "");
    Expect(1, 7675, '\p{^-	Syrc}', "");
    Expect(1, 7675, '\P{-	Syrc}', "");
    Expect(0, 7675, '\P{^-	Syrc}', "");
    Error('\p{ :=Is_Syrc}');
    Error('\P{ :=Is_Syrc}');
    Expect(1, 7674, '\p{issyrc}', "");
    Expect(0, 7674, '\p{^issyrc}', "");
    Expect(0, 7674, '\P{issyrc}', "");
    Expect(1, 7674, '\P{^issyrc}', "");
    Expect(0, 7675, '\p{issyrc}', "");
    Expect(1, 7675, '\p{^issyrc}', "");
    Expect(1, 7675, '\P{issyrc}', "");
    Expect(0, 7675, '\P{^issyrc}', "");
    Expect(1, 7674, '\p{	is_syrc}', "");
    Expect(0, 7674, '\p{^	is_syrc}', "");
    Expect(0, 7674, '\P{	is_syrc}', "");
    Expect(1, 7674, '\P{^	is_syrc}', "");
    Expect(0, 7675, '\p{	is_syrc}', "");
    Expect(1, 7675, '\p{^	is_syrc}', "");
    Expect(1, 7675, '\P{	is_syrc}', "");
    Expect(0, 7675, '\P{^	is_syrc}', "");
    Error('\p{/a/_Syriac_supplement}');
    Error('\P{/a/_Syriac_supplement}');
    Expect(1, 2159, '\p{syriacsupplement}', "");
    Expect(0, 2159, '\p{^syriacsupplement}', "");
    Expect(0, 2159, '\P{syriacsupplement}', "");
    Expect(1, 2159, '\P{^syriacsupplement}', "");
    Expect(0, 2160, '\p{syriacsupplement}', "");
    Expect(1, 2160, '\p{^syriacsupplement}', "");
    Expect(1, 2160, '\P{syriacsupplement}', "");
    Expect(0, 2160, '\P{^syriacsupplement}', "");
    Expect(1, 2159, '\p{-_syriac_Supplement}', "");
    Expect(0, 2159, '\p{^-_syriac_Supplement}', "");
    Expect(0, 2159, '\P{-_syriac_Supplement}', "");
    Expect(1, 2159, '\P{^-_syriac_Supplement}', "");
    Expect(0, 2160, '\p{-_syriac_Supplement}', "");
    Expect(1, 2160, '\p{^-_syriac_Supplement}', "");
    Expect(1, 2160, '\P{-_syriac_Supplement}', "");
    Expect(0, 2160, '\P{^-_syriac_Supplement}', "");
    Error('\p{:=_ Is_syriac_Supplement}');
    Error('\P{:=_ Is_syriac_Supplement}');
    Expect(1, 2159, '\p{issyriacsupplement}', "");
    Expect(0, 2159, '\p{^issyriacsupplement}', "");
    Expect(0, 2159, '\P{issyriacsupplement}', "");
    Expect(1, 2159, '\P{^issyriacsupplement}', "");
    Expect(0, 2160, '\p{issyriacsupplement}', "");
    Expect(1, 2160, '\p{^issyriacsupplement}', "");
    Expect(1, 2160, '\P{issyriacsupplement}', "");
    Expect(0, 2160, '\P{^issyriacsupplement}', "");
    Expect(1, 2159, '\p{	is_syriac_SUPPLEMENT}', "");
    Expect(0, 2159, '\p{^	is_syriac_SUPPLEMENT}', "");
    Expect(0, 2159, '\P{	is_syriac_SUPPLEMENT}', "");
    Expect(1, 2159, '\P{^	is_syriac_SUPPLEMENT}', "");
    Expect(0, 2160, '\p{	is_syriac_SUPPLEMENT}', "");
    Expect(1, 2160, '\p{^	is_syriac_SUPPLEMENT}', "");
    Expect(1, 2160, '\P{	is_syriac_SUPPLEMENT}', "");
    Expect(0, 2160, '\P{^	is_syriac_SUPPLEMENT}', "");
    Error('\p{:=  IN_Syriac_Supplement}');
    Error('\P{:=  IN_Syriac_Supplement}');
    Expect(1, 2159, '\p{insyriacsupplement}', "");
    Expect(0, 2159, '\p{^insyriacsupplement}', "");
    Expect(0, 2159, '\P{insyriacsupplement}', "");
    Expect(1, 2159, '\P{^insyriacsupplement}', "");
    Expect(0, 2160, '\p{insyriacsupplement}', "");
    Expect(1, 2160, '\p{^insyriacsupplement}', "");
    Expect(1, 2160, '\P{insyriacsupplement}', "");
    Expect(0, 2160, '\P{^insyriacsupplement}', "");
    Expect(1, 2159, '\p{- In_SYRIAC_supplement}', "");
    Expect(0, 2159, '\p{^- In_SYRIAC_supplement}', "");
    Expect(0, 2159, '\P{- In_SYRIAC_supplement}', "");
    Expect(1, 2159, '\P{^- In_SYRIAC_supplement}', "");
    Expect(0, 2160, '\p{- In_SYRIAC_supplement}', "");
    Expect(1, 2160, '\p{^- In_SYRIAC_supplement}', "");
    Expect(1, 2160, '\P{- In_SYRIAC_supplement}', "");
    Expect(0, 2160, '\P{^- In_SYRIAC_supplement}', "");
    Error('\p{:= Syriac_Sup}');
    Error('\P{:= Syriac_Sup}');
    Expect(1, 2159, '\p{syriacsup}', "");
    Expect(0, 2159, '\p{^syriacsup}', "");
    Expect(0, 2159, '\P{syriacsup}', "");
    Expect(1, 2159, '\P{^syriacsup}', "");
    Expect(0, 2160, '\p{syriacsup}', "");
    Expect(1, 2160, '\p{^syriacsup}', "");
    Expect(1, 2160, '\P{syriacsup}', "");
    Expect(0, 2160, '\P{^syriacsup}', "");
    Expect(1, 2159, '\p{  Syriac_Sup}', "");
    Expect(0, 2159, '\p{^  Syriac_Sup}', "");
    Expect(0, 2159, '\P{  Syriac_Sup}', "");
    Expect(1, 2159, '\P{^  Syriac_Sup}', "");
    Expect(0, 2160, '\p{  Syriac_Sup}', "");
    Expect(1, 2160, '\p{^  Syriac_Sup}', "");
    Expect(1, 2160, '\P{  Syriac_Sup}', "");
    Expect(0, 2160, '\P{^  Syriac_Sup}', "");
    Error('\p{:=	Is_SYRIAC_SUP}');
    Error('\P{:=	Is_SYRIAC_SUP}');
    Expect(1, 2159, '\p{issyriacsup}', "");
    Expect(0, 2159, '\p{^issyriacsup}', "");
    Expect(0, 2159, '\P{issyriacsup}', "");
    Expect(1, 2159, '\P{^issyriacsup}', "");
    Expect(0, 2160, '\p{issyriacsup}', "");
    Expect(1, 2160, '\p{^issyriacsup}', "");
    Expect(1, 2160, '\P{issyriacsup}', "");
    Expect(0, 2160, '\P{^issyriacsup}', "");
    Expect(1, 2159, '\p{_-is_syriac_sup}', "");
    Expect(0, 2159, '\p{^_-is_syriac_sup}', "");
    Expect(0, 2159, '\P{_-is_syriac_sup}', "");
    Expect(1, 2159, '\P{^_-is_syriac_sup}', "");
    Expect(0, 2160, '\p{_-is_syriac_sup}', "");
    Expect(1, 2160, '\p{^_-is_syriac_sup}', "");
    Expect(1, 2160, '\P{_-is_syriac_sup}', "");
    Expect(0, 2160, '\P{^_-is_syriac_sup}', "");
    Error('\p{_ IN_SYRIAC_SUP/a/}');
    Error('\P{_ IN_SYRIAC_SUP/a/}');
    Expect(1, 2159, '\p{insyriacsup}', "");
    Expect(0, 2159, '\p{^insyriacsup}', "");
    Expect(0, 2159, '\P{insyriacsup}', "");
    Expect(1, 2159, '\P{^insyriacsup}', "");
    Expect(0, 2160, '\p{insyriacsup}', "");
    Expect(1, 2160, '\p{^insyriacsup}', "");
    Expect(1, 2160, '\P{insyriacsup}', "");
    Expect(0, 2160, '\P{^insyriacsup}', "");
    Expect(1, 2159, '\p{-	in_SYRIAC_Sup}', "");
    Expect(0, 2159, '\p{^-	in_SYRIAC_Sup}', "");
    Expect(0, 2159, '\P{-	in_SYRIAC_Sup}', "");
    Expect(1, 2159, '\P{^-	in_SYRIAC_Sup}', "");
    Expect(0, 2160, '\p{-	in_SYRIAC_Sup}', "");
    Expect(1, 2160, '\p{^-	in_SYRIAC_Sup}', "");
    Expect(1, 2160, '\P{-	in_SYRIAC_Sup}', "");
    Expect(0, 2160, '\P{^-	in_SYRIAC_Sup}', "");
    Error('\p{/a/_	TAGALOG}');
    Error('\P{/a/_	TAGALOG}');
    Expect(1, 5942, '\p{tagalog}', "");
    Expect(0, 5942, '\p{^tagalog}', "");
    Expect(0, 5942, '\P{tagalog}', "");
    Expect(1, 5942, '\P{^tagalog}', "");
    Expect(0, 5943, '\p{tagalog}', "");
    Expect(1, 5943, '\p{^tagalog}', "");
    Expect(1, 5943, '\P{tagalog}', "");
    Expect(0, 5943, '\P{^tagalog}', "");
    Expect(1, 5942, '\p{_Tagalog}', "");
    Expect(0, 5942, '\p{^_Tagalog}', "");
    Expect(0, 5942, '\P{_Tagalog}', "");
    Expect(1, 5942, '\P{^_Tagalog}', "");
    Expect(0, 5943, '\p{_Tagalog}', "");
    Expect(1, 5943, '\p{^_Tagalog}', "");
    Expect(1, 5943, '\P{_Tagalog}', "");
    Expect(0, 5943, '\P{^_Tagalog}', "");
    Error('\p{:=is_TAGALOG}');
    Error('\P{:=is_TAGALOG}');
    Expect(1, 5942, '\p{istagalog}', "");
    Expect(0, 5942, '\p{^istagalog}', "");
    Expect(0, 5942, '\P{istagalog}', "");
    Expect(1, 5942, '\P{^istagalog}', "");
    Expect(0, 5943, '\p{istagalog}', "");
    Expect(1, 5943, '\p{^istagalog}', "");
    Expect(1, 5943, '\P{istagalog}', "");
    Expect(0, 5943, '\P{^istagalog}', "");
    Expect(1, 5942, '\p{  IS_TAGALOG}', "");
    Expect(0, 5942, '\p{^  IS_TAGALOG}', "");
    Expect(0, 5942, '\P{  IS_TAGALOG}', "");
    Expect(1, 5942, '\P{^  IS_TAGALOG}', "");
    Expect(0, 5943, '\p{  IS_TAGALOG}', "");
    Expect(1, 5943, '\p{^  IS_TAGALOG}', "");
    Expect(1, 5943, '\P{  IS_TAGALOG}', "");
    Expect(0, 5943, '\P{^  IS_TAGALOG}', "");
    Error('\p{_TGLG:=}');
    Error('\P{_TGLG:=}');
    Expect(1, 5942, '\p{tglg}', "");
    Expect(0, 5942, '\p{^tglg}', "");
    Expect(0, 5942, '\P{tglg}', "");
    Expect(1, 5942, '\P{^tglg}', "");
    Expect(0, 5943, '\p{tglg}', "");
    Expect(1, 5943, '\p{^tglg}', "");
    Expect(1, 5943, '\P{tglg}', "");
    Expect(0, 5943, '\P{^tglg}', "");
    Expect(1, 5942, '\p{ 	tglg}', "");
    Expect(0, 5942, '\p{^ 	tglg}', "");
    Expect(0, 5942, '\P{ 	tglg}', "");
    Expect(1, 5942, '\P{^ 	tglg}', "");
    Expect(0, 5943, '\p{ 	tglg}', "");
    Expect(1, 5943, '\p{^ 	tglg}', "");
    Expect(1, 5943, '\P{ 	tglg}', "");
    Expect(0, 5943, '\P{^ 	tglg}', "");
    Error('\p{:=_	Is_Tglg}');
    Error('\P{:=_	Is_Tglg}');
    Expect(1, 5942, '\p{istglg}', "");
    Expect(0, 5942, '\p{^istglg}', "");
    Expect(0, 5942, '\P{istglg}', "");
    Expect(1, 5942, '\P{^istglg}', "");
    Expect(0, 5943, '\p{istglg}', "");
    Expect(1, 5943, '\p{^istglg}', "");
    Expect(1, 5943, '\P{istglg}', "");
    Expect(0, 5943, '\P{^istglg}', "");
    Expect(1, 5942, '\p{ 	Is_tglg}', "");
    Expect(0, 5942, '\p{^ 	Is_tglg}', "");
    Expect(0, 5942, '\P{ 	Is_tglg}', "");
    Expect(1, 5942, '\P{^ 	Is_tglg}', "");
    Expect(0, 5943, '\p{ 	Is_tglg}', "");
    Expect(1, 5943, '\p{^ 	Is_tglg}', "");
    Expect(1, 5943, '\P{ 	Is_tglg}', "");
    Expect(0, 5943, '\P{^ 	Is_tglg}', "");
    Error('\p{:=-	tagbanwa}');
    Error('\P{:=-	tagbanwa}');
    Expect(1, 6003, '\p{tagbanwa}', "");
    Expect(0, 6003, '\p{^tagbanwa}', "");
    Expect(0, 6003, '\P{tagbanwa}', "");
    Expect(1, 6003, '\P{^tagbanwa}', "");
    Expect(0, 6004, '\p{tagbanwa}', "");
    Expect(1, 6004, '\p{^tagbanwa}', "");
    Expect(1, 6004, '\P{tagbanwa}', "");
    Expect(0, 6004, '\P{^tagbanwa}', "");
    Expect(1, 6003, '\p{ -TAGBANWA}', "");
    Expect(0, 6003, '\p{^ -TAGBANWA}', "");
    Expect(0, 6003, '\P{ -TAGBANWA}', "");
    Expect(1, 6003, '\P{^ -TAGBANWA}', "");
    Expect(0, 6004, '\p{ -TAGBANWA}', "");
    Expect(1, 6004, '\p{^ -TAGBANWA}', "");
    Expect(1, 6004, '\P{ -TAGBANWA}', "");
    Expect(0, 6004, '\P{^ -TAGBANWA}', "");
    Error('\p{-/a/IS_Tagbanwa}');
    Error('\P{-/a/IS_Tagbanwa}');
    Expect(1, 6003, '\p{istagbanwa}', "");
    Expect(0, 6003, '\p{^istagbanwa}', "");
    Expect(0, 6003, '\P{istagbanwa}', "");
    Expect(1, 6003, '\P{^istagbanwa}', "");
    Expect(0, 6004, '\p{istagbanwa}', "");
    Expect(1, 6004, '\p{^istagbanwa}', "");
    Expect(1, 6004, '\P{istagbanwa}', "");
    Expect(0, 6004, '\P{^istagbanwa}', "");
    Expect(1, 6003, '\p{_ is_TAGBANWA}', "");
    Expect(0, 6003, '\p{^_ is_TAGBANWA}', "");
    Expect(0, 6003, '\P{_ is_TAGBANWA}', "");
    Expect(1, 6003, '\P{^_ is_TAGBANWA}', "");
    Expect(0, 6004, '\p{_ is_TAGBANWA}', "");
    Expect(1, 6004, '\p{^_ is_TAGBANWA}', "");
    Expect(1, 6004, '\P{_ is_TAGBANWA}', "");
    Expect(0, 6004, '\P{^_ is_TAGBANWA}', "");
    Error('\p{_/a/TAGB}');
    Error('\P{_/a/TAGB}');
    Expect(1, 6003, '\p{tagb}', "");
    Expect(0, 6003, '\p{^tagb}', "");
    Expect(0, 6003, '\P{tagb}', "");
    Expect(1, 6003, '\P{^tagb}', "");
    Expect(0, 6004, '\p{tagb}', "");
    Expect(1, 6004, '\p{^tagb}', "");
    Expect(1, 6004, '\P{tagb}', "");
    Expect(0, 6004, '\P{^tagb}', "");
    Expect(1, 6003, '\p{-	Tagb}', "");
    Expect(0, 6003, '\p{^-	Tagb}', "");
    Expect(0, 6003, '\P{-	Tagb}', "");
    Expect(1, 6003, '\P{^-	Tagb}', "");
    Expect(0, 6004, '\p{-	Tagb}', "");
    Expect(1, 6004, '\p{^-	Tagb}', "");
    Expect(1, 6004, '\P{-	Tagb}', "");
    Expect(0, 6004, '\P{^-	Tagb}', "");
    Error('\p{/a/IS_Tagb}');
    Error('\P{/a/IS_Tagb}');
    Expect(1, 6003, '\p{istagb}', "");
    Expect(0, 6003, '\p{^istagb}', "");
    Expect(0, 6003, '\P{istagb}', "");
    Expect(1, 6003, '\P{^istagb}', "");
    Expect(0, 6004, '\p{istagb}', "");
    Expect(1, 6004, '\p{^istagb}', "");
    Expect(1, 6004, '\P{istagb}', "");
    Expect(0, 6004, '\P{^istagb}', "");
    Expect(1, 6003, '\p{-	Is_tagb}', "");
    Expect(0, 6003, '\p{^-	Is_tagb}', "");
    Expect(0, 6003, '\P{-	Is_tagb}', "");
    Expect(1, 6003, '\P{^-	Is_tagb}', "");
    Expect(0, 6004, '\p{-	Is_tagb}', "");
    Expect(1, 6004, '\p{^-	Is_tagb}', "");
    Expect(1, 6004, '\P{-	Is_tagb}', "");
    Expect(0, 6004, '\P{^-	Is_tagb}', "");
    Error('\p{ -Tags:=}');
    Error('\P{ -Tags:=}');
    Expect(1, 917631, '\p{tags}', "");
    Expect(0, 917631, '\p{^tags}', "");
    Expect(0, 917631, '\P{tags}', "");
    Expect(1, 917631, '\P{^tags}', "");
    Expect(0, 917632, '\p{tags}', "");
    Expect(1, 917632, '\p{^tags}', "");
    Expect(1, 917632, '\P{tags}', "");
    Expect(0, 917632, '\P{^tags}', "");
    Expect(1, 917631, '\p{	Tags}', "");
    Expect(0, 917631, '\p{^	Tags}', "");
    Expect(0, 917631, '\P{	Tags}', "");
    Expect(1, 917631, '\P{^	Tags}', "");
    Expect(0, 917632, '\p{	Tags}', "");
    Expect(1, 917632, '\p{^	Tags}', "");
    Expect(1, 917632, '\P{	Tags}', "");
    Expect(0, 917632, '\P{^	Tags}', "");
    Error('\p{_:=is_tags}');
    Error('\P{_:=is_tags}');
    Expect(1, 917631, '\p{istags}', "");
    Expect(0, 917631, '\p{^istags}', "");
    Expect(0, 917631, '\P{istags}', "");
    Expect(1, 917631, '\P{^istags}', "");
    Expect(0, 917632, '\p{istags}', "");
    Expect(1, 917632, '\p{^istags}', "");
    Expect(1, 917632, '\P{istags}', "");
    Expect(0, 917632, '\P{^istags}', "");
    Expect(1, 917631, '\p{- is_Tags}', "");
    Expect(0, 917631, '\p{^- is_Tags}', "");
    Expect(0, 917631, '\P{- is_Tags}', "");
    Expect(1, 917631, '\P{^- is_Tags}', "");
    Expect(0, 917632, '\p{- is_Tags}', "");
    Expect(1, 917632, '\p{^- is_Tags}', "");
    Expect(1, 917632, '\P{- is_Tags}', "");
    Expect(0, 917632, '\P{^- is_Tags}', "");
    Error('\p{ :=IN_Tags}');
    Error('\P{ :=IN_Tags}');
    Expect(1, 917631, '\p{intags}', "");
    Expect(0, 917631, '\p{^intags}', "");
    Expect(0, 917631, '\P{intags}', "");
    Expect(1, 917631, '\P{^intags}', "");
    Expect(0, 917632, '\p{intags}', "");
    Expect(1, 917632, '\p{^intags}', "");
    Expect(1, 917632, '\P{intags}', "");
    Expect(0, 917632, '\P{^intags}', "");
    Expect(1, 917631, '\p{--IN_tags}', "");
    Expect(0, 917631, '\p{^--IN_tags}', "");
    Expect(0, 917631, '\P{--IN_tags}', "");
    Expect(1, 917631, '\P{^--IN_tags}', "");
    Expect(0, 917632, '\p{--IN_tags}', "");
    Expect(1, 917632, '\p{^--IN_tags}', "");
    Expect(1, 917632, '\P{--IN_tags}', "");
    Expect(0, 917632, '\P{^--IN_tags}', "");
    Error('\p{_TAI_le:=}');
    Error('\P{_TAI_le:=}');
    Expect(1, 6516, '\p{taile}', "");
    Expect(0, 6516, '\p{^taile}', "");
    Expect(0, 6516, '\P{taile}', "");
    Expect(1, 6516, '\P{^taile}', "");
    Expect(0, 6517, '\p{taile}', "");
    Expect(1, 6517, '\p{^taile}', "");
    Expect(1, 6517, '\P{taile}', "");
    Expect(0, 6517, '\P{^taile}', "");
    Expect(1, 6516, '\p{_Tai_Le}', "");
    Expect(0, 6516, '\p{^_Tai_Le}', "");
    Expect(0, 6516, '\P{_Tai_Le}', "");
    Expect(1, 6516, '\P{^_Tai_Le}', "");
    Expect(0, 6517, '\p{_Tai_Le}', "");
    Expect(1, 6517, '\p{^_Tai_Le}', "");
    Expect(1, 6517, '\P{_Tai_Le}', "");
    Expect(0, 6517, '\P{^_Tai_Le}', "");
    Error('\p{	/a/Is_TAI_Le}');
    Error('\P{	/a/Is_TAI_Le}');
    Expect(1, 6516, '\p{istaile}', "");
    Expect(0, 6516, '\p{^istaile}', "");
    Expect(0, 6516, '\P{istaile}', "");
    Expect(1, 6516, '\P{^istaile}', "");
    Expect(0, 6517, '\p{istaile}', "");
    Expect(1, 6517, '\p{^istaile}', "");
    Expect(1, 6517, '\P{istaile}', "");
    Expect(0, 6517, '\P{^istaile}', "");
    Expect(1, 6516, '\p{  IS_TAI_le}', "");
    Expect(0, 6516, '\p{^  IS_TAI_le}', "");
    Expect(0, 6516, '\P{  IS_TAI_le}', "");
    Expect(1, 6516, '\P{^  IS_TAI_le}', "");
    Expect(0, 6517, '\p{  IS_TAI_le}', "");
    Expect(1, 6517, '\p{^  IS_TAI_le}', "");
    Expect(1, 6517, '\P{  IS_TAI_le}', "");
    Expect(0, 6517, '\P{^  IS_TAI_le}', "");
    Error('\p{-/a/TALE}');
    Error('\P{-/a/TALE}');
    Expect(1, 6516, '\p{tale}', "");
    Expect(0, 6516, '\p{^tale}', "");
    Expect(0, 6516, '\P{tale}', "");
    Expect(1, 6516, '\P{^tale}', "");
    Expect(0, 6517, '\p{tale}', "");
    Expect(1, 6517, '\p{^tale}', "");
    Expect(1, 6517, '\P{tale}', "");
    Expect(0, 6517, '\P{^tale}', "");
    Expect(1, 6516, '\p{ _Tale}', "");
    Expect(0, 6516, '\p{^ _Tale}', "");
    Expect(0, 6516, '\P{ _Tale}', "");
    Expect(1, 6516, '\P{^ _Tale}', "");
    Expect(0, 6517, '\p{ _Tale}', "");
    Expect(1, 6517, '\p{^ _Tale}', "");
    Expect(1, 6517, '\P{ _Tale}', "");
    Expect(0, 6517, '\P{^ _Tale}', "");
    Error('\p{:=-Is_tale}');
    Error('\P{:=-Is_tale}');
    Expect(1, 6516, '\p{istale}', "");
    Expect(0, 6516, '\p{^istale}', "");
    Expect(0, 6516, '\P{istale}', "");
    Expect(1, 6516, '\P{^istale}', "");
    Expect(0, 6517, '\p{istale}', "");
    Expect(1, 6517, '\p{^istale}', "");
    Expect(1, 6517, '\P{istale}', "");
    Expect(0, 6517, '\P{^istale}', "");
    Expect(1, 6516, '\p{  is_Tale}', "");
    Expect(0, 6516, '\p{^  is_Tale}', "");
    Expect(0, 6516, '\P{  is_Tale}', "");
    Expect(1, 6516, '\P{^  is_Tale}', "");
    Expect(0, 6517, '\p{  is_Tale}', "");
    Expect(1, 6517, '\p{^  is_Tale}', "");
    Expect(1, 6517, '\P{  is_Tale}', "");
    Expect(0, 6517, '\P{^  is_Tale}', "");
    Error('\p{:=_-TAI_Tham}');
    Error('\P{:=_-TAI_Tham}');
    Expect(1, 6829, '\p{taitham}', "");
    Expect(0, 6829, '\p{^taitham}', "");
    Expect(0, 6829, '\P{taitham}', "");
    Expect(1, 6829, '\P{^taitham}', "");
    Expect(0, 6830, '\p{taitham}', "");
    Expect(1, 6830, '\p{^taitham}', "");
    Expect(1, 6830, '\P{taitham}', "");
    Expect(0, 6830, '\P{^taitham}', "");
    Expect(1, 6829, '\p{ _tai_Tham}', "");
    Expect(0, 6829, '\p{^ _tai_Tham}', "");
    Expect(0, 6829, '\P{ _tai_Tham}', "");
    Expect(1, 6829, '\P{^ _tai_Tham}', "");
    Expect(0, 6830, '\p{ _tai_Tham}', "");
    Expect(1, 6830, '\p{^ _tai_Tham}', "");
    Expect(1, 6830, '\P{ _tai_Tham}', "");
    Expect(0, 6830, '\P{^ _tai_Tham}', "");
    Error('\p{:=	_IS_Tai_tham}');
    Error('\P{:=	_IS_Tai_tham}');
    Expect(1, 6829, '\p{istaitham}', "");
    Expect(0, 6829, '\p{^istaitham}', "");
    Expect(0, 6829, '\P{istaitham}', "");
    Expect(1, 6829, '\P{^istaitham}', "");
    Expect(0, 6830, '\p{istaitham}', "");
    Expect(1, 6830, '\p{^istaitham}', "");
    Expect(1, 6830, '\P{istaitham}', "");
    Expect(0, 6830, '\P{^istaitham}', "");
    Expect(1, 6829, '\p{ _IS_tai_Tham}', "");
    Expect(0, 6829, '\p{^ _IS_tai_Tham}', "");
    Expect(0, 6829, '\P{ _IS_tai_Tham}', "");
    Expect(1, 6829, '\P{^ _IS_tai_Tham}', "");
    Expect(0, 6830, '\p{ _IS_tai_Tham}', "");
    Expect(1, 6830, '\p{^ _IS_tai_Tham}', "");
    Expect(1, 6830, '\P{ _IS_tai_Tham}', "");
    Expect(0, 6830, '\P{^ _IS_tai_Tham}', "");
    Error('\p{-/a/Lana}');
    Error('\P{-/a/Lana}');
    Expect(1, 6829, '\p{lana}', "");
    Expect(0, 6829, '\p{^lana}', "");
    Expect(0, 6829, '\P{lana}', "");
    Expect(1, 6829, '\P{^lana}', "");
    Expect(0, 6830, '\p{lana}', "");
    Expect(1, 6830, '\p{^lana}', "");
    Expect(1, 6830, '\P{lana}', "");
    Expect(0, 6830, '\P{^lana}', "");
    Expect(1, 6829, '\p{_ LANA}', "");
    Expect(0, 6829, '\p{^_ LANA}', "");
    Expect(0, 6829, '\P{_ LANA}', "");
    Expect(1, 6829, '\P{^_ LANA}', "");
    Expect(0, 6830, '\p{_ LANA}', "");
    Expect(1, 6830, '\p{^_ LANA}', "");
    Expect(1, 6830, '\P{_ LANA}', "");
    Expect(0, 6830, '\P{^_ LANA}', "");
    Error('\p{:=-Is_lana}');
    Error('\P{:=-Is_lana}');
    Expect(1, 6829, '\p{islana}', "");
    Expect(0, 6829, '\p{^islana}', "");
    Expect(0, 6829, '\P{islana}', "");
    Expect(1, 6829, '\P{^islana}', "");
    Expect(0, 6830, '\p{islana}', "");
    Expect(1, 6830, '\p{^islana}', "");
    Expect(1, 6830, '\P{islana}', "");
    Expect(0, 6830, '\P{^islana}', "");
    Expect(1, 6829, '\p{__Is_Lana}', "");
    Expect(0, 6829, '\p{^__Is_Lana}', "");
    Expect(0, 6829, '\P{__Is_Lana}', "");
    Expect(1, 6829, '\P{^__Is_Lana}', "");
    Expect(0, 6830, '\p{__Is_Lana}', "");
    Expect(1, 6830, '\p{^__Is_Lana}', "");
    Expect(1, 6830, '\P{__Is_Lana}', "");
    Expect(0, 6830, '\P{^__Is_Lana}', "");
    Error('\p{/a/	 Tai_Viet}');
    Error('\P{/a/	 Tai_Viet}');
    Expect(1, 43743, '\p{taiviet}', "");
    Expect(0, 43743, '\p{^taiviet}', "");
    Expect(0, 43743, '\P{taiviet}', "");
    Expect(1, 43743, '\P{^taiviet}', "");
    Expect(0, 43744, '\p{taiviet}', "");
    Expect(1, 43744, '\p{^taiviet}', "");
    Expect(1, 43744, '\P{taiviet}', "");
    Expect(0, 43744, '\P{^taiviet}', "");
    Expect(1, 43743, '\p{--TAI_VIET}', "");
    Expect(0, 43743, '\p{^--TAI_VIET}', "");
    Expect(0, 43743, '\P{--TAI_VIET}', "");
    Expect(1, 43743, '\P{^--TAI_VIET}', "");
    Expect(0, 43744, '\p{--TAI_VIET}', "");
    Expect(1, 43744, '\p{^--TAI_VIET}', "");
    Expect(1, 43744, '\P{--TAI_VIET}', "");
    Expect(0, 43744, '\P{^--TAI_VIET}', "");
    Error('\p{_ IS_Tai_Viet/a/}');
    Error('\P{_ IS_Tai_Viet/a/}');
    Expect(1, 43743, '\p{istaiviet}', "");
    Expect(0, 43743, '\p{^istaiviet}', "");
    Expect(0, 43743, '\P{istaiviet}', "");
    Expect(1, 43743, '\P{^istaiviet}', "");
    Expect(0, 43744, '\p{istaiviet}', "");
    Expect(1, 43744, '\p{^istaiviet}', "");
    Expect(1, 43744, '\P{istaiviet}', "");
    Expect(0, 43744, '\P{^istaiviet}', "");
    Expect(1, 43743, '\p{	is_tai_Viet}', "");
    Expect(0, 43743, '\p{^	is_tai_Viet}', "");
    Expect(0, 43743, '\P{	is_tai_Viet}', "");
    Expect(1, 43743, '\P{^	is_tai_Viet}', "");
    Expect(0, 43744, '\p{	is_tai_Viet}', "");
    Expect(1, 43744, '\p{^	is_tai_Viet}', "");
    Expect(1, 43744, '\P{	is_tai_Viet}', "");
    Expect(0, 43744, '\P{^	is_tai_Viet}', "");
    Error('\p{ /a/Tavt}');
    Error('\P{ /a/Tavt}');
    Expect(1, 43743, '\p{tavt}', "");
    Expect(0, 43743, '\p{^tavt}', "");
    Expect(0, 43743, '\P{tavt}', "");
    Expect(1, 43743, '\P{^tavt}', "");
    Expect(0, 43744, '\p{tavt}', "");
    Expect(1, 43744, '\p{^tavt}', "");
    Expect(1, 43744, '\P{tavt}', "");
    Expect(0, 43744, '\P{^tavt}', "");
    Expect(1, 43743, '\p{-	Tavt}', "");
    Expect(0, 43743, '\p{^-	Tavt}', "");
    Expect(0, 43743, '\P{-	Tavt}', "");
    Expect(1, 43743, '\P{^-	Tavt}', "");
    Expect(0, 43744, '\p{-	Tavt}', "");
    Expect(1, 43744, '\p{^-	Tavt}', "");
    Expect(1, 43744, '\P{-	Tavt}', "");
    Expect(0, 43744, '\P{^-	Tavt}', "");
    Error('\p{-_is_Tavt/a/}');
    Error('\P{-_is_Tavt/a/}');
    Expect(1, 43743, '\p{istavt}', "");
    Expect(0, 43743, '\p{^istavt}', "");
    Expect(0, 43743, '\P{istavt}', "");
    Expect(1, 43743, '\P{^istavt}', "");
    Expect(0, 43744, '\p{istavt}', "");
    Expect(1, 43744, '\p{^istavt}', "");
    Expect(1, 43744, '\P{istavt}', "");
    Expect(0, 43744, '\P{^istavt}', "");
    Expect(1, 43743, '\p{	Is_Tavt}', "");
    Expect(0, 43743, '\p{^	Is_Tavt}', "");
    Expect(0, 43743, '\P{	Is_Tavt}', "");
    Expect(1, 43743, '\P{^	Is_Tavt}', "");
    Expect(0, 43744, '\p{	Is_Tavt}', "");
    Expect(1, 43744, '\p{^	Is_Tavt}', "");
    Expect(1, 43744, '\P{	Is_Tavt}', "");
    Expect(0, 43744, '\P{^	Is_Tavt}', "");
    Error('\p{ tai_Xuan_Jing_symbols/a/}');
    Error('\P{ tai_Xuan_Jing_symbols/a/}');
    Expect(1, 119647, '\p{taixuanjingsymbols}', "");
    Expect(0, 119647, '\p{^taixuanjingsymbols}', "");
    Expect(0, 119647, '\P{taixuanjingsymbols}', "");
    Expect(1, 119647, '\P{^taixuanjingsymbols}', "");
    Expect(0, 119648, '\p{taixuanjingsymbols}', "");
    Expect(1, 119648, '\p{^taixuanjingsymbols}', "");
    Expect(1, 119648, '\P{taixuanjingsymbols}', "");
    Expect(0, 119648, '\P{^taixuanjingsymbols}', "");
    Expect(1, 119647, '\p{--tai_Xuan_jing_Symbols}', "");
    Expect(0, 119647, '\p{^--tai_Xuan_jing_Symbols}', "");
    Expect(0, 119647, '\P{--tai_Xuan_jing_Symbols}', "");
    Expect(1, 119647, '\P{^--tai_Xuan_jing_Symbols}', "");
    Expect(0, 119648, '\p{--tai_Xuan_jing_Symbols}', "");
    Expect(1, 119648, '\p{^--tai_Xuan_jing_Symbols}', "");
    Expect(1, 119648, '\P{--tai_Xuan_jing_Symbols}', "");
    Expect(0, 119648, '\P{^--tai_Xuan_jing_Symbols}', "");
    Error('\p{:=-Is_TAI_Xuan_Jing_SYMBOLS}');
    Error('\P{:=-Is_TAI_Xuan_Jing_SYMBOLS}');
    Expect(1, 119647, '\p{istaixuanjingsymbols}', "");
    Expect(0, 119647, '\p{^istaixuanjingsymbols}', "");
    Expect(0, 119647, '\P{istaixuanjingsymbols}', "");
    Expect(1, 119647, '\P{^istaixuanjingsymbols}', "");
    Expect(0, 119648, '\p{istaixuanjingsymbols}', "");
    Expect(1, 119648, '\p{^istaixuanjingsymbols}', "");
    Expect(1, 119648, '\P{istaixuanjingsymbols}', "");
    Expect(0, 119648, '\P{^istaixuanjingsymbols}', "");
    Expect(1, 119647, '\p{_Is_TAI_xuan_Jing_symbols}', "");
    Expect(0, 119647, '\p{^_Is_TAI_xuan_Jing_symbols}', "");
    Expect(0, 119647, '\P{_Is_TAI_xuan_Jing_symbols}', "");
    Expect(1, 119647, '\P{^_Is_TAI_xuan_Jing_symbols}', "");
    Expect(0, 119648, '\p{_Is_TAI_xuan_Jing_symbols}', "");
    Expect(1, 119648, '\p{^_Is_TAI_xuan_Jing_symbols}', "");
    Expect(1, 119648, '\P{_Is_TAI_xuan_Jing_symbols}', "");
    Expect(0, 119648, '\P{^_Is_TAI_xuan_Jing_symbols}', "");
    Error('\p{_In_Tai_XUAN_jing_SYMBOLS:=}');
    Error('\P{_In_Tai_XUAN_jing_SYMBOLS:=}');
    Expect(1, 119647, '\p{intaixuanjingsymbols}', "");
    Expect(0, 119647, '\p{^intaixuanjingsymbols}', "");
    Expect(0, 119647, '\P{intaixuanjingsymbols}', "");
    Expect(1, 119647, '\P{^intaixuanjingsymbols}', "");
    Expect(0, 119648, '\p{intaixuanjingsymbols}', "");
    Expect(1, 119648, '\p{^intaixuanjingsymbols}', "");
    Expect(1, 119648, '\P{intaixuanjingsymbols}', "");
    Expect(0, 119648, '\P{^intaixuanjingsymbols}', "");
    Expect(1, 119647, '\p{-	In_TAI_Xuan_JING_symbols}', "");
    Expect(0, 119647, '\p{^-	In_TAI_Xuan_JING_symbols}', "");
    Expect(0, 119647, '\P{-	In_TAI_Xuan_JING_symbols}', "");
    Expect(1, 119647, '\P{^-	In_TAI_Xuan_JING_symbols}', "");
    Expect(0, 119648, '\p{-	In_TAI_Xuan_JING_symbols}', "");
    Expect(1, 119648, '\p{^-	In_TAI_Xuan_JING_symbols}', "");
    Expect(1, 119648, '\P{-	In_TAI_Xuan_JING_symbols}', "");
    Expect(0, 119648, '\P{^-	In_TAI_Xuan_JING_symbols}', "");
    Error('\p{/a/TAI_xuan_JING}');
    Error('\P{/a/TAI_xuan_JING}');
    Expect(1, 119647, '\p{taixuanjing}', "");
    Expect(0, 119647, '\p{^taixuanjing}', "");
    Expect(0, 119647, '\P{taixuanjing}', "");
    Expect(1, 119647, '\P{^taixuanjing}', "");
    Expect(0, 119648, '\p{taixuanjing}', "");
    Expect(1, 119648, '\p{^taixuanjing}', "");
    Expect(1, 119648, '\P{taixuanjing}', "");
    Expect(0, 119648, '\P{^taixuanjing}', "");
    Expect(1, 119647, '\p{-TAI_Xuan_Jing}', "");
    Expect(0, 119647, '\p{^-TAI_Xuan_Jing}', "");
    Expect(0, 119647, '\P{-TAI_Xuan_Jing}', "");
    Expect(1, 119647, '\P{^-TAI_Xuan_Jing}', "");
    Expect(0, 119648, '\p{-TAI_Xuan_Jing}', "");
    Expect(1, 119648, '\p{^-TAI_Xuan_Jing}', "");
    Expect(1, 119648, '\P{-TAI_Xuan_Jing}', "");
    Expect(0, 119648, '\P{^-TAI_Xuan_Jing}', "");
    Error('\p{:= Is_Tai_Xuan_Jing}');
    Error('\P{:= Is_Tai_Xuan_Jing}');
    Expect(1, 119647, '\p{istaixuanjing}', "");
    Expect(0, 119647, '\p{^istaixuanjing}', "");
    Expect(0, 119647, '\P{istaixuanjing}', "");
    Expect(1, 119647, '\P{^istaixuanjing}', "");
    Expect(0, 119648, '\p{istaixuanjing}', "");
    Expect(1, 119648, '\p{^istaixuanjing}', "");
    Expect(1, 119648, '\P{istaixuanjing}', "");
    Expect(0, 119648, '\P{^istaixuanjing}', "");
    Expect(1, 119647, '\p{ Is_Tai_Xuan_jing}', "");
    Expect(0, 119647, '\p{^ Is_Tai_Xuan_jing}', "");
    Expect(0, 119647, '\P{ Is_Tai_Xuan_jing}', "");
    Expect(1, 119647, '\P{^ Is_Tai_Xuan_jing}', "");
    Expect(0, 119648, '\p{ Is_Tai_Xuan_jing}', "");
    Expect(1, 119648, '\p{^ Is_Tai_Xuan_jing}', "");
    Expect(1, 119648, '\P{ Is_Tai_Xuan_jing}', "");
    Expect(0, 119648, '\P{^ Is_Tai_Xuan_jing}', "");
    Error('\p{	IN_TAI_Xuan_jing/a/}');
    Error('\P{	IN_TAI_Xuan_jing/a/}');
    Expect(1, 119647, '\p{intaixuanjing}', "");
    Expect(0, 119647, '\p{^intaixuanjing}', "");
    Expect(0, 119647, '\P{intaixuanjing}', "");
    Expect(1, 119647, '\P{^intaixuanjing}', "");
    Expect(0, 119648, '\p{intaixuanjing}', "");
    Expect(1, 119648, '\p{^intaixuanjing}', "");
    Expect(1, 119648, '\P{intaixuanjing}', "");
    Expect(0, 119648, '\P{^intaixuanjing}', "");
    Expect(1, 119647, '\p{_In_TAI_XUAN_jing}', "");
    Expect(0, 119647, '\p{^_In_TAI_XUAN_jing}', "");
    Expect(0, 119647, '\P{_In_TAI_XUAN_jing}', "");
    Expect(1, 119647, '\P{^_In_TAI_XUAN_jing}', "");
    Expect(0, 119648, '\p{_In_TAI_XUAN_jing}', "");
    Expect(1, 119648, '\p{^_In_TAI_XUAN_jing}', "");
    Expect(1, 119648, '\P{_In_TAI_XUAN_jing}', "");
    Expect(0, 119648, '\P{^_In_TAI_XUAN_jing}', "");
    Error('\p{-	TAKRI:=}');
    Error('\P{-	TAKRI:=}');
    Expect(1, 71369, '\p{takri}', "");
    Expect(0, 71369, '\p{^takri}', "");
    Expect(0, 71369, '\P{takri}', "");
    Expect(1, 71369, '\P{^takri}', "");
    Expect(0, 71370, '\p{takri}', "");
    Expect(1, 71370, '\p{^takri}', "");
    Expect(1, 71370, '\P{takri}', "");
    Expect(0, 71370, '\P{^takri}', "");
    Expect(1, 71369, '\p{_-Takri}', "");
    Expect(0, 71369, '\p{^_-Takri}', "");
    Expect(0, 71369, '\P{_-Takri}', "");
    Expect(1, 71369, '\P{^_-Takri}', "");
    Expect(0, 71370, '\p{_-Takri}', "");
    Expect(1, 71370, '\p{^_-Takri}', "");
    Expect(1, 71370, '\P{_-Takri}', "");
    Expect(0, 71370, '\P{^_-Takri}', "");
    Error('\p{:= -Is_takri}');
    Error('\P{:= -Is_takri}');
    Expect(1, 71369, '\p{istakri}', "");
    Expect(0, 71369, '\p{^istakri}', "");
    Expect(0, 71369, '\P{istakri}', "");
    Expect(1, 71369, '\P{^istakri}', "");
    Expect(0, 71370, '\p{istakri}', "");
    Expect(1, 71370, '\p{^istakri}', "");
    Expect(1, 71370, '\P{istakri}', "");
    Expect(0, 71370, '\P{^istakri}', "");
    Expect(1, 71369, '\p{ _is_Takri}', "");
    Expect(0, 71369, '\p{^ _is_Takri}', "");
    Expect(0, 71369, '\P{ _is_Takri}', "");
    Expect(1, 71369, '\P{^ _is_Takri}', "");
    Expect(0, 71370, '\p{ _is_Takri}', "");
    Expect(1, 71370, '\p{^ _is_Takri}', "");
    Expect(1, 71370, '\P{ _is_Takri}', "");
    Expect(0, 71370, '\P{^ _is_Takri}', "");
    Error('\p{:= _Takr}');
    Error('\P{:= _Takr}');
    Expect(1, 71369, '\p{takr}', "");
    Expect(0, 71369, '\p{^takr}', "");
    Expect(0, 71369, '\P{takr}', "");
    Expect(1, 71369, '\P{^takr}', "");
    Expect(0, 71370, '\p{takr}', "");
    Expect(1, 71370, '\p{^takr}', "");
    Expect(1, 71370, '\P{takr}', "");
    Expect(0, 71370, '\P{^takr}', "");
    Expect(1, 71369, '\p{ takr}', "");
    Expect(0, 71369, '\p{^ takr}', "");
    Expect(0, 71369, '\P{ takr}', "");
    Expect(1, 71369, '\P{^ takr}', "");
    Expect(0, 71370, '\p{ takr}', "");
    Expect(1, 71370, '\p{^ takr}', "");
    Expect(1, 71370, '\P{ takr}', "");
    Expect(0, 71370, '\P{^ takr}', "");
    Error('\p{-	Is_takr:=}');
    Error('\P{-	Is_takr:=}');
    Expect(1, 71369, '\p{istakr}', "");
    Expect(0, 71369, '\p{^istakr}', "");
    Expect(0, 71369, '\P{istakr}', "");
    Expect(1, 71369, '\P{^istakr}', "");
    Expect(0, 71370, '\p{istakr}', "");
    Expect(1, 71370, '\p{^istakr}', "");
    Expect(1, 71370, '\P{istakr}', "");
    Expect(0, 71370, '\P{^istakr}', "");
    Expect(1, 71369, '\p{		is_Takr}', "");
    Expect(0, 71369, '\p{^		is_Takr}', "");
    Expect(0, 71369, '\P{		is_Takr}', "");
    Expect(1, 71369, '\P{^		is_Takr}', "");
    Expect(0, 71370, '\p{		is_Takr}', "");
    Expect(1, 71370, '\p{^		is_Takr}', "");
    Expect(1, 71370, '\P{		is_Takr}', "");
    Expect(0, 71370, '\P{^		is_Takr}', "");
    Error('\p{:= _TAMIL}');
    Error('\P{:= _TAMIL}');
    Expect(1, 73727, '\p{tamil}', "");
    Expect(0, 73727, '\p{^tamil}', "");
    Expect(0, 73727, '\P{tamil}', "");
    Expect(1, 73727, '\P{^tamil}', "");
    Expect(0, 73728, '\p{tamil}', "");
    Expect(1, 73728, '\p{^tamil}', "");
    Expect(1, 73728, '\P{tamil}', "");
    Expect(0, 73728, '\P{^tamil}', "");
    Expect(1, 73727, '\p{ _Tamil}', "");
    Expect(0, 73727, '\p{^ _Tamil}', "");
    Expect(0, 73727, '\P{ _Tamil}', "");
    Expect(1, 73727, '\P{^ _Tamil}', "");
    Expect(0, 73728, '\p{ _Tamil}', "");
    Expect(1, 73728, '\p{^ _Tamil}', "");
    Expect(1, 73728, '\P{ _Tamil}', "");
    Expect(0, 73728, '\P{^ _Tamil}', "");
    Error('\p{ :=is_Tamil}');
    Error('\P{ :=is_Tamil}');
    Expect(1, 73727, '\p{istamil}', "");
    Expect(0, 73727, '\p{^istamil}', "");
    Expect(0, 73727, '\P{istamil}', "");
    Expect(1, 73727, '\P{^istamil}', "");
    Expect(0, 73728, '\p{istamil}', "");
    Expect(1, 73728, '\p{^istamil}', "");
    Expect(1, 73728, '\P{istamil}', "");
    Expect(0, 73728, '\P{^istamil}', "");
    Expect(1, 73727, '\p{--Is_TAMIL}', "");
    Expect(0, 73727, '\p{^--Is_TAMIL}', "");
    Expect(0, 73727, '\P{--Is_TAMIL}', "");
    Expect(1, 73727, '\P{^--Is_TAMIL}', "");
    Expect(0, 73728, '\p{--Is_TAMIL}', "");
    Expect(1, 73728, '\p{^--Is_TAMIL}', "");
    Expect(1, 73728, '\P{--Is_TAMIL}', "");
    Expect(0, 73728, '\P{^--Is_TAMIL}', "");
    Error('\p{/a/	 TAML}');
    Error('\P{/a/	 TAML}');
    Expect(1, 73727, '\p{taml}', "");
    Expect(0, 73727, '\p{^taml}', "");
    Expect(0, 73727, '\P{taml}', "");
    Expect(1, 73727, '\P{^taml}', "");
    Expect(0, 73728, '\p{taml}', "");
    Expect(1, 73728, '\p{^taml}', "");
    Expect(1, 73728, '\P{taml}', "");
    Expect(0, 73728, '\P{^taml}', "");
    Expect(1, 73727, '\p{ taml}', "");
    Expect(0, 73727, '\p{^ taml}', "");
    Expect(0, 73727, '\P{ taml}', "");
    Expect(1, 73727, '\P{^ taml}', "");
    Expect(0, 73728, '\p{ taml}', "");
    Expect(1, 73728, '\p{^ taml}', "");
    Expect(1, 73728, '\P{ taml}', "");
    Expect(0, 73728, '\P{^ taml}', "");
    Error('\p{-	is_Taml:=}');
    Error('\P{-	is_Taml:=}');
    Expect(1, 73727, '\p{istaml}', "");
    Expect(0, 73727, '\p{^istaml}', "");
    Expect(0, 73727, '\P{istaml}', "");
    Expect(1, 73727, '\P{^istaml}', "");
    Expect(0, 73728, '\p{istaml}', "");
    Expect(1, 73728, '\p{^istaml}', "");
    Expect(1, 73728, '\P{istaml}', "");
    Expect(0, 73728, '\P{^istaml}', "");
    Expect(1, 73727, '\p{ 	IS_Taml}', "");
    Expect(0, 73727, '\p{^ 	IS_Taml}', "");
    Expect(0, 73727, '\P{ 	IS_Taml}', "");
    Expect(1, 73727, '\P{^ 	IS_Taml}', "");
    Expect(0, 73728, '\p{ 	IS_Taml}', "");
    Expect(1, 73728, '\p{^ 	IS_Taml}', "");
    Expect(1, 73728, '\P{ 	IS_Taml}', "");
    Expect(0, 73728, '\P{^ 	IS_Taml}', "");
    Error('\p{/a/-Tamil_Supplement}');
    Error('\P{/a/-Tamil_Supplement}');
    Expect(1, 73727, '\p{tamilsupplement}', "");
    Expect(0, 73727, '\p{^tamilsupplement}', "");
    Expect(0, 73727, '\P{tamilsupplement}', "");
    Expect(1, 73727, '\P{^tamilsupplement}', "");
    Expect(0, 73728, '\p{tamilsupplement}', "");
    Expect(1, 73728, '\p{^tamilsupplement}', "");
    Expect(1, 73728, '\P{tamilsupplement}', "");
    Expect(0, 73728, '\P{^tamilsupplement}', "");
    Expect(1, 73727, '\p{-_Tamil_supplement}', "");
    Expect(0, 73727, '\p{^-_Tamil_supplement}', "");
    Expect(0, 73727, '\P{-_Tamil_supplement}', "");
    Expect(1, 73727, '\P{^-_Tamil_supplement}', "");
    Expect(0, 73728, '\p{-_Tamil_supplement}', "");
    Expect(1, 73728, '\p{^-_Tamil_supplement}', "");
    Expect(1, 73728, '\P{-_Tamil_supplement}', "");
    Expect(0, 73728, '\P{^-_Tamil_supplement}', "");
    Error('\p{_IS_Tamil_SUPPLEMENT/a/}');
    Error('\P{_IS_Tamil_SUPPLEMENT/a/}');
    Expect(1, 73727, '\p{istamilsupplement}', "");
    Expect(0, 73727, '\p{^istamilsupplement}', "");
    Expect(0, 73727, '\P{istamilsupplement}', "");
    Expect(1, 73727, '\P{^istamilsupplement}', "");
    Expect(0, 73728, '\p{istamilsupplement}', "");
    Expect(1, 73728, '\p{^istamilsupplement}', "");
    Expect(1, 73728, '\P{istamilsupplement}', "");
    Expect(0, 73728, '\P{^istamilsupplement}', "");
    Expect(1, 73727, '\p{-_Is_Tamil_SUPPLEMENT}', "");
    Expect(0, 73727, '\p{^-_Is_Tamil_SUPPLEMENT}', "");
    Expect(0, 73727, '\P{-_Is_Tamil_SUPPLEMENT}', "");
    Expect(1, 73727, '\P{^-_Is_Tamil_SUPPLEMENT}', "");
    Expect(0, 73728, '\p{-_Is_Tamil_SUPPLEMENT}', "");
    Expect(1, 73728, '\p{^-_Is_Tamil_SUPPLEMENT}', "");
    Expect(1, 73728, '\P{-_Is_Tamil_SUPPLEMENT}', "");
    Expect(0, 73728, '\P{^-_Is_Tamil_SUPPLEMENT}', "");
    Error('\p{_/a/In_Tamil_Supplement}');
    Error('\P{_/a/In_Tamil_Supplement}');
    Expect(1, 73727, '\p{intamilsupplement}', "");
    Expect(0, 73727, '\p{^intamilsupplement}', "");
    Expect(0, 73727, '\P{intamilsupplement}', "");
    Expect(1, 73727, '\P{^intamilsupplement}', "");
    Expect(0, 73728, '\p{intamilsupplement}', "");
    Expect(1, 73728, '\p{^intamilsupplement}', "");
    Expect(1, 73728, '\P{intamilsupplement}', "");
    Expect(0, 73728, '\P{^intamilsupplement}', "");
    Expect(1, 73727, '\p{ In_TAMIL_Supplement}', "");
    Expect(0, 73727, '\p{^ In_TAMIL_Supplement}', "");
    Expect(0, 73727, '\P{ In_TAMIL_Supplement}', "");
    Expect(1, 73727, '\P{^ In_TAMIL_Supplement}', "");
    Expect(0, 73728, '\p{ In_TAMIL_Supplement}', "");
    Expect(1, 73728, '\p{^ In_TAMIL_Supplement}', "");
    Expect(1, 73728, '\P{ In_TAMIL_Supplement}', "");
    Expect(0, 73728, '\P{^ In_TAMIL_Supplement}', "");
    Error('\p{	:=TAMIL_SUP}');
    Error('\P{	:=TAMIL_SUP}');
    Expect(1, 73727, '\p{tamilsup}', "");
    Expect(0, 73727, '\p{^tamilsup}', "");
    Expect(0, 73727, '\P{tamilsup}', "");
    Expect(1, 73727, '\P{^tamilsup}', "");
    Expect(0, 73728, '\p{tamilsup}', "");
    Expect(1, 73728, '\p{^tamilsup}', "");
    Expect(1, 73728, '\P{tamilsup}', "");
    Expect(0, 73728, '\P{^tamilsup}', "");
    Expect(1, 73727, '\p{ _tamil_SUP}', "");
    Expect(0, 73727, '\p{^ _tamil_SUP}', "");
    Expect(0, 73727, '\P{ _tamil_SUP}', "");
    Expect(1, 73727, '\P{^ _tamil_SUP}', "");
    Expect(0, 73728, '\p{ _tamil_SUP}', "");
    Expect(1, 73728, '\p{^ _tamil_SUP}', "");
    Expect(1, 73728, '\P{ _tamil_SUP}', "");
    Expect(0, 73728, '\P{^ _tamil_SUP}', "");
    Error('\p{/a/__IS_TAMIL_sup}');
    Error('\P{/a/__IS_TAMIL_sup}');
    Expect(1, 73727, '\p{istamilsup}', "");
    Expect(0, 73727, '\p{^istamilsup}', "");
    Expect(0, 73727, '\P{istamilsup}', "");
    Expect(1, 73727, '\P{^istamilsup}', "");
    Expect(0, 73728, '\p{istamilsup}', "");
    Expect(1, 73728, '\p{^istamilsup}', "");
    Expect(1, 73728, '\P{istamilsup}', "");
    Expect(0, 73728, '\P{^istamilsup}', "");
    Expect(1, 73727, '\p{	Is_Tamil_Sup}', "");
    Expect(0, 73727, '\p{^	Is_Tamil_Sup}', "");
    Expect(0, 73727, '\P{	Is_Tamil_Sup}', "");
    Expect(1, 73727, '\P{^	Is_Tamil_Sup}', "");
    Expect(0, 73728, '\p{	Is_Tamil_Sup}', "");
    Expect(1, 73728, '\p{^	Is_Tamil_Sup}', "");
    Expect(1, 73728, '\P{	Is_Tamil_Sup}', "");
    Expect(0, 73728, '\P{^	Is_Tamil_Sup}', "");
    Error('\p{-	In_Tamil_Sup:=}');
    Error('\P{-	In_Tamil_Sup:=}');
    Expect(1, 73727, '\p{intamilsup}', "");
    Expect(0, 73727, '\p{^intamilsup}', "");
    Expect(0, 73727, '\P{intamilsup}', "");
    Expect(1, 73727, '\P{^intamilsup}', "");
    Expect(0, 73728, '\p{intamilsup}', "");
    Expect(1, 73728, '\p{^intamilsup}', "");
    Expect(1, 73728, '\P{intamilsup}', "");
    Expect(0, 73728, '\P{^intamilsup}', "");
    Expect(1, 73727, '\p{ IN_tamil_sup}', "");
    Expect(0, 73727, '\p{^ IN_tamil_sup}', "");
    Expect(0, 73727, '\P{ IN_tamil_sup}', "");
    Expect(1, 73727, '\P{^ IN_tamil_sup}', "");
    Expect(0, 73728, '\p{ IN_tamil_sup}', "");
    Expect(1, 73728, '\p{^ IN_tamil_sup}', "");
    Expect(1, 73728, '\P{ IN_tamil_sup}', "");
    Expect(0, 73728, '\P{^ IN_tamil_sup}', "");
    Error('\p{  TANGSA:=}');
    Error('\P{  TANGSA:=}');
    Expect(1, 92873, '\p{tangsa}', "");
    Expect(0, 92873, '\p{^tangsa}', "");
    Expect(0, 92873, '\P{tangsa}', "");
    Expect(1, 92873, '\P{^tangsa}', "");
    Expect(0, 92874, '\p{tangsa}', "");
    Expect(1, 92874, '\p{^tangsa}', "");
    Expect(1, 92874, '\P{tangsa}', "");
    Expect(0, 92874, '\P{^tangsa}', "");
    Expect(1, 92873, '\p{ TANGSA}', "");
    Expect(0, 92873, '\p{^ TANGSA}', "");
    Expect(0, 92873, '\P{ TANGSA}', "");
    Expect(1, 92873, '\P{^ TANGSA}', "");
    Expect(0, 92874, '\p{ TANGSA}', "");
    Expect(1, 92874, '\p{^ TANGSA}', "");
    Expect(1, 92874, '\P{ TANGSA}', "");
    Expect(0, 92874, '\P{^ TANGSA}', "");
    Error('\p{/a/ -Is_Tangsa}');
    Error('\P{/a/ -Is_Tangsa}');
    Expect(1, 92873, '\p{istangsa}', "");
    Expect(0, 92873, '\p{^istangsa}', "");
    Expect(0, 92873, '\P{istangsa}', "");
    Expect(1, 92873, '\P{^istangsa}', "");
    Expect(0, 92874, '\p{istangsa}', "");
    Expect(1, 92874, '\p{^istangsa}', "");
    Expect(1, 92874, '\P{istangsa}', "");
    Expect(0, 92874, '\P{^istangsa}', "");
    Expect(1, 92873, '\p{_Is_tangsa}', "");
    Expect(0, 92873, '\p{^_Is_tangsa}', "");
    Expect(0, 92873, '\P{_Is_tangsa}', "");
    Expect(1, 92873, '\P{^_Is_tangsa}', "");
    Expect(0, 92874, '\p{_Is_tangsa}', "");
    Expect(1, 92874, '\p{^_Is_tangsa}', "");
    Expect(1, 92874, '\P{_Is_tangsa}', "");
    Expect(0, 92874, '\P{^_Is_tangsa}', "");
    Error('\p{_Tnsa:=}');
    Error('\P{_Tnsa:=}');
    Expect(1, 92873, '\p{tnsa}', "");
    Expect(0, 92873, '\p{^tnsa}', "");
    Expect(0, 92873, '\P{tnsa}', "");
    Expect(1, 92873, '\P{^tnsa}', "");
    Expect(0, 92874, '\p{tnsa}', "");
    Expect(1, 92874, '\p{^tnsa}', "");
    Expect(1, 92874, '\P{tnsa}', "");
    Expect(0, 92874, '\P{^tnsa}', "");
    Expect(1, 92873, '\p{-Tnsa}', "");
    Expect(0, 92873, '\p{^-Tnsa}', "");
    Expect(0, 92873, '\P{-Tnsa}', "");
    Expect(1, 92873, '\P{^-Tnsa}', "");
    Expect(0, 92874, '\p{-Tnsa}', "");
    Expect(1, 92874, '\p{^-Tnsa}', "");
    Expect(1, 92874, '\P{-Tnsa}', "");
    Expect(0, 92874, '\P{^-Tnsa}', "");
    Error('\p{:=Is_Tnsa}');
    Error('\P{:=Is_Tnsa}');
    Expect(1, 92873, '\p{istnsa}', "");
    Expect(0, 92873, '\p{^istnsa}', "");
    Expect(0, 92873, '\P{istnsa}', "");
    Expect(1, 92873, '\P{^istnsa}', "");
    Expect(0, 92874, '\p{istnsa}', "");
    Expect(1, 92874, '\p{^istnsa}', "");
    Expect(1, 92874, '\P{istnsa}', "");
    Expect(0, 92874, '\P{^istnsa}', "");
    Expect(1, 92873, '\p{	Is_tnsa}', "");
    Expect(0, 92873, '\p{^	Is_tnsa}', "");
    Expect(0, 92873, '\P{	Is_tnsa}', "");
    Expect(1, 92873, '\P{^	Is_tnsa}', "");
    Expect(0, 92874, '\p{	Is_tnsa}', "");
    Expect(1, 92874, '\p{^	Is_tnsa}', "");
    Expect(1, 92874, '\P{	Is_tnsa}', "");
    Expect(0, 92874, '\P{^	Is_tnsa}', "");
    Error('\p{	-Tangut:=}');
    Error('\P{	-Tangut:=}');
    Expect(1, 101640, '\p{tangut}', "");
    Expect(0, 101640, '\p{^tangut}', "");
    Expect(0, 101640, '\P{tangut}', "");
    Expect(1, 101640, '\P{^tangut}', "");
    Expect(0, 101641, '\p{tangut}', "");
    Expect(1, 101641, '\p{^tangut}', "");
    Expect(1, 101641, '\P{tangut}', "");
    Expect(0, 101641, '\P{^tangut}', "");
    Expect(1, 101640, '\p{	_tangut}', "");
    Expect(0, 101640, '\p{^	_tangut}', "");
    Expect(0, 101640, '\P{	_tangut}', "");
    Expect(1, 101640, '\P{^	_tangut}', "");
    Expect(0, 101641, '\p{	_tangut}', "");
    Expect(1, 101641, '\p{^	_tangut}', "");
    Expect(1, 101641, '\P{	_tangut}', "");
    Expect(0, 101641, '\P{^	_tangut}', "");
    Error('\p{/a/is_TANGUT}');
    Error('\P{/a/is_TANGUT}');
    Expect(1, 101640, '\p{istangut}', "");
    Expect(0, 101640, '\p{^istangut}', "");
    Expect(0, 101640, '\P{istangut}', "");
    Expect(1, 101640, '\P{^istangut}', "");
    Expect(0, 101641, '\p{istangut}', "");
    Expect(1, 101641, '\p{^istangut}', "");
    Expect(1, 101641, '\P{istangut}', "");
    Expect(0, 101641, '\P{^istangut}', "");
    Expect(1, 101640, '\p{ -Is_tangut}', "");
    Expect(0, 101640, '\p{^ -Is_tangut}', "");
    Expect(0, 101640, '\P{ -Is_tangut}', "");
    Expect(1, 101640, '\P{^ -Is_tangut}', "");
    Expect(0, 101641, '\p{ -Is_tangut}', "");
    Expect(1, 101641, '\p{^ -Is_tangut}', "");
    Expect(1, 101641, '\P{ -Is_tangut}', "");
    Expect(0, 101641, '\P{^ -Is_tangut}', "");
    Error('\p{-Tang:=}');
    Error('\P{-Tang:=}');
    Expect(1, 101640, '\p{tang}', "");
    Expect(0, 101640, '\p{^tang}', "");
    Expect(0, 101640, '\P{tang}', "");
    Expect(1, 101640, '\P{^tang}', "");
    Expect(0, 101641, '\p{tang}', "");
    Expect(1, 101641, '\p{^tang}', "");
    Expect(1, 101641, '\P{tang}', "");
    Expect(0, 101641, '\P{^tang}', "");
    Expect(1, 101640, '\p{	_Tang}', "");
    Expect(0, 101640, '\p{^	_Tang}', "");
    Expect(0, 101640, '\P{	_Tang}', "");
    Expect(1, 101640, '\P{^	_Tang}', "");
    Expect(0, 101641, '\p{	_Tang}', "");
    Expect(1, 101641, '\p{^	_Tang}', "");
    Expect(1, 101641, '\P{	_Tang}', "");
    Expect(0, 101641, '\P{^	_Tang}', "");
    Error('\p{:=_	is_TANG}');
    Error('\P{:=_	is_TANG}');
    Expect(1, 101640, '\p{istang}', "");
    Expect(0, 101640, '\p{^istang}', "");
    Expect(0, 101640, '\P{istang}', "");
    Expect(1, 101640, '\P{^istang}', "");
    Expect(0, 101641, '\p{istang}', "");
    Expect(1, 101641, '\p{^istang}', "");
    Expect(1, 101641, '\P{istang}', "");
    Expect(0, 101641, '\P{^istang}', "");
    Expect(1, 101640, '\p{- Is_Tang}', "");
    Expect(0, 101640, '\p{^- Is_Tang}', "");
    Expect(0, 101640, '\P{- Is_Tang}', "");
    Expect(1, 101640, '\P{^- Is_Tang}', "");
    Expect(0, 101641, '\p{- Is_Tang}', "");
    Expect(1, 101641, '\p{^- Is_Tang}', "");
    Expect(1, 101641, '\P{- Is_Tang}', "");
    Expect(0, 101641, '\P{^- Is_Tang}', "");
    Error('\p{:= TANGUT_Components}');
    Error('\P{:= TANGUT_Components}');
    Expect(1, 101119, '\p{tangutcomponents}', "");
    Expect(0, 101119, '\p{^tangutcomponents}', "");
    Expect(0, 101119, '\P{tangutcomponents}', "");
    Expect(1, 101119, '\P{^tangutcomponents}', "");
    Expect(0, 101120, '\p{tangutcomponents}', "");
    Expect(1, 101120, '\p{^tangutcomponents}', "");
    Expect(1, 101120, '\P{tangutcomponents}', "");
    Expect(0, 101120, '\P{^tangutcomponents}', "");
    Expect(1, 101119, '\p{ _Tangut_components}', "");
    Expect(0, 101119, '\p{^ _Tangut_components}', "");
    Expect(0, 101119, '\P{ _Tangut_components}', "");
    Expect(1, 101119, '\P{^ _Tangut_components}', "");
    Expect(0, 101120, '\p{ _Tangut_components}', "");
    Expect(1, 101120, '\p{^ _Tangut_components}', "");
    Expect(1, 101120, '\P{ _Tangut_components}', "");
    Expect(0, 101120, '\P{^ _Tangut_components}', "");
    Error('\p{:= is_Tangut_Components}');
    Error('\P{:= is_Tangut_Components}');
    Expect(1, 101119, '\p{istangutcomponents}', "");
    Expect(0, 101119, '\p{^istangutcomponents}', "");
    Expect(0, 101119, '\P{istangutcomponents}', "");
    Expect(1, 101119, '\P{^istangutcomponents}', "");
    Expect(0, 101120, '\p{istangutcomponents}', "");
    Expect(1, 101120, '\p{^istangutcomponents}', "");
    Expect(1, 101120, '\P{istangutcomponents}', "");
    Expect(0, 101120, '\P{^istangutcomponents}', "");
    Expect(1, 101119, '\p{-is_tangut_components}', "");
    Expect(0, 101119, '\p{^-is_tangut_components}', "");
    Expect(0, 101119, '\P{-is_tangut_components}', "");
    Expect(1, 101119, '\P{^-is_tangut_components}', "");
    Expect(0, 101120, '\p{-is_tangut_components}', "");
    Expect(1, 101120, '\p{^-is_tangut_components}', "");
    Expect(1, 101120, '\P{-is_tangut_components}', "");
    Expect(0, 101120, '\P{^-is_tangut_components}', "");
    Error('\p{/a/_IN_TANGUT_Components}');
    Error('\P{/a/_IN_TANGUT_Components}');
    Expect(1, 101119, '\p{intangutcomponents}', "");
    Expect(0, 101119, '\p{^intangutcomponents}', "");
    Expect(0, 101119, '\P{intangutcomponents}', "");
    Expect(1, 101119, '\P{^intangutcomponents}', "");
    Expect(0, 101120, '\p{intangutcomponents}', "");
    Expect(1, 101120, '\p{^intangutcomponents}', "");
    Expect(1, 101120, '\P{intangutcomponents}', "");
    Expect(0, 101120, '\P{^intangutcomponents}', "");
    Expect(1, 101119, '\p{  IN_Tangut_components}', "");
    Expect(0, 101119, '\p{^  IN_Tangut_components}', "");
    Expect(0, 101119, '\P{  IN_Tangut_components}', "");
    Expect(1, 101119, '\P{^  IN_Tangut_components}', "");
    Expect(0, 101120, '\p{  IN_Tangut_components}', "");
    Expect(1, 101120, '\p{^  IN_Tangut_components}', "");
    Expect(1, 101120, '\P{  IN_Tangut_components}', "");
    Expect(0, 101120, '\P{^  IN_Tangut_components}', "");
    Error('\p{ :=tangut_supplement}');
    Error('\P{ :=tangut_supplement}');
    Expect(1, 101759, '\p{tangutsupplement}', "");
    Expect(0, 101759, '\p{^tangutsupplement}', "");
    Expect(0, 101759, '\P{tangutsupplement}', "");
    Expect(1, 101759, '\P{^tangutsupplement}', "");
    Expect(0, 101760, '\p{tangutsupplement}', "");
    Expect(1, 101760, '\p{^tangutsupplement}', "");
    Expect(1, 101760, '\P{tangutsupplement}', "");
    Expect(0, 101760, '\P{^tangutsupplement}', "");
    Expect(1, 101759, '\p{ -TANGUT_SUPPLEMENT}', "");
    Expect(0, 101759, '\p{^ -TANGUT_SUPPLEMENT}', "");
    Expect(0, 101759, '\P{ -TANGUT_SUPPLEMENT}', "");
    Expect(1, 101759, '\P{^ -TANGUT_SUPPLEMENT}', "");
    Expect(0, 101760, '\p{ -TANGUT_SUPPLEMENT}', "");
    Expect(1, 101760, '\p{^ -TANGUT_SUPPLEMENT}', "");
    Expect(1, 101760, '\P{ -TANGUT_SUPPLEMENT}', "");
    Expect(0, 101760, '\P{^ -TANGUT_SUPPLEMENT}', "");
    Error('\p{/a/		IS_Tangut_supplement}');
    Error('\P{/a/		IS_Tangut_supplement}');
    Expect(1, 101759, '\p{istangutsupplement}', "");
    Expect(0, 101759, '\p{^istangutsupplement}', "");
    Expect(0, 101759, '\P{istangutsupplement}', "");
    Expect(1, 101759, '\P{^istangutsupplement}', "");
    Expect(0, 101760, '\p{istangutsupplement}', "");
    Expect(1, 101760, '\p{^istangutsupplement}', "");
    Expect(1, 101760, '\P{istangutsupplement}', "");
    Expect(0, 101760, '\P{^istangutsupplement}', "");
    Expect(1, 101759, '\p{-_is_Tangut_Supplement}', "");
    Expect(0, 101759, '\p{^-_is_Tangut_Supplement}', "");
    Expect(0, 101759, '\P{-_is_Tangut_Supplement}', "");
    Expect(1, 101759, '\P{^-_is_Tangut_Supplement}', "");
    Expect(0, 101760, '\p{-_is_Tangut_Supplement}', "");
    Expect(1, 101760, '\p{^-_is_Tangut_Supplement}', "");
    Expect(1, 101760, '\P{-_is_Tangut_Supplement}', "");
    Expect(0, 101760, '\P{^-_is_Tangut_Supplement}', "");
    Error('\p{	/a/in_Tangut_Supplement}');
    Error('\P{	/a/in_Tangut_Supplement}');
    Expect(1, 101759, '\p{intangutsupplement}', "");
    Expect(0, 101759, '\p{^intangutsupplement}', "");
    Expect(0, 101759, '\P{intangutsupplement}', "");
    Expect(1, 101759, '\P{^intangutsupplement}', "");
    Expect(0, 101760, '\p{intangutsupplement}', "");
    Expect(1, 101760, '\p{^intangutsupplement}', "");
    Expect(1, 101760, '\P{intangutsupplement}', "");
    Expect(0, 101760, '\P{^intangutsupplement}', "");
    Expect(1, 101759, '\p{_ In_tangut_Supplement}', "");
    Expect(0, 101759, '\p{^_ In_tangut_Supplement}', "");
    Expect(0, 101759, '\P{_ In_tangut_Supplement}', "");
    Expect(1, 101759, '\P{^_ In_tangut_Supplement}', "");
    Expect(0, 101760, '\p{_ In_tangut_Supplement}', "");
    Expect(1, 101760, '\p{^_ In_tangut_Supplement}', "");
    Expect(1, 101760, '\P{_ In_tangut_Supplement}', "");
    Expect(0, 101760, '\P{^_ In_tangut_Supplement}', "");
    Error('\p{	:=Tangut_Sup}');
    Error('\P{	:=Tangut_Sup}');
    Expect(1, 101759, '\p{tangutsup}', "");
    Expect(0, 101759, '\p{^tangutsup}', "");
    Expect(0, 101759, '\P{tangutsup}', "");
    Expect(1, 101759, '\P{^tangutsup}', "");
    Expect(0, 101760, '\p{tangutsup}', "");
    Expect(1, 101760, '\p{^tangutsup}', "");
    Expect(1, 101760, '\P{tangutsup}', "");
    Expect(0, 101760, '\P{^tangutsup}', "");
    Expect(1, 101759, '\p{-	Tangut_Sup}', "");
    Expect(0, 101759, '\p{^-	Tangut_Sup}', "");
    Expect(0, 101759, '\P{-	Tangut_Sup}', "");
    Expect(1, 101759, '\P{^-	Tangut_Sup}', "");
    Expect(0, 101760, '\p{-	Tangut_Sup}', "");
    Expect(1, 101760, '\p{^-	Tangut_Sup}', "");
    Expect(1, 101760, '\P{-	Tangut_Sup}', "");
    Expect(0, 101760, '\P{^-	Tangut_Sup}', "");
    Error('\p{	_Is_Tangut_sup:=}');
    Error('\P{	_Is_Tangut_sup:=}');
    Expect(1, 101759, '\p{istangutsup}', "");
    Expect(0, 101759, '\p{^istangutsup}', "");
    Expect(0, 101759, '\P{istangutsup}', "");
    Expect(1, 101759, '\P{^istangutsup}', "");
    Expect(0, 101760, '\p{istangutsup}', "");
    Expect(1, 101760, '\p{^istangutsup}', "");
    Expect(1, 101760, '\P{istangutsup}', "");
    Expect(0, 101760, '\P{^istangutsup}', "");
    Expect(1, 101759, '\p{-_Is_TANGUT_SUP}', "");
    Expect(0, 101759, '\p{^-_Is_TANGUT_SUP}', "");
    Expect(0, 101759, '\P{-_Is_TANGUT_SUP}', "");
    Expect(1, 101759, '\P{^-_Is_TANGUT_SUP}', "");
    Expect(0, 101760, '\p{-_Is_TANGUT_SUP}', "");
    Expect(1, 101760, '\p{^-_Is_TANGUT_SUP}', "");
    Expect(1, 101760, '\P{-_Is_TANGUT_SUP}', "");
    Expect(0, 101760, '\P{^-_Is_TANGUT_SUP}', "");
    Error('\p{-in_TANGUT_SUP:=}');
    Error('\P{-in_TANGUT_SUP:=}');
    Expect(1, 101759, '\p{intangutsup}', "");
    Expect(0, 101759, '\p{^intangutsup}', "");
    Expect(0, 101759, '\P{intangutsup}', "");
    Expect(1, 101759, '\P{^intangutsup}', "");
    Expect(0, 101760, '\p{intangutsup}', "");
    Expect(1, 101760, '\p{^intangutsup}', "");
    Expect(1, 101760, '\P{intangutsup}', "");
    Expect(0, 101760, '\P{^intangutsup}', "");
    Expect(1, 101759, '\p{-In_Tangut_sup}', "");
    Expect(0, 101759, '\p{^-In_Tangut_sup}', "");
    Expect(0, 101759, '\P{-In_Tangut_sup}', "");
    Expect(1, 101759, '\P{^-In_Tangut_sup}', "");
    Expect(0, 101760, '\p{-In_Tangut_sup}', "");
    Expect(1, 101760, '\p{^-In_Tangut_sup}', "");
    Expect(1, 101760, '\P{-In_Tangut_sup}', "");
    Expect(0, 101760, '\P{^-In_Tangut_sup}', "");
    Error('\p{-_Telugu/a/}');
    Error('\P{-_Telugu/a/}');
    Expect(1, 7410, '\p{telugu}', "");
    Expect(0, 7410, '\p{^telugu}', "");
    Expect(0, 7410, '\P{telugu}', "");
    Expect(1, 7410, '\P{^telugu}', "");
    Expect(0, 7411, '\p{telugu}', "");
    Expect(1, 7411, '\p{^telugu}', "");
    Expect(1, 7411, '\P{telugu}', "");
    Expect(0, 7411, '\P{^telugu}', "");
    Expect(1, 7410, '\p{_ telugu}', "");
    Expect(0, 7410, '\p{^_ telugu}', "");
    Expect(0, 7410, '\P{_ telugu}', "");
    Expect(1, 7410, '\P{^_ telugu}', "");
    Expect(0, 7411, '\p{_ telugu}', "");
    Expect(1, 7411, '\p{^_ telugu}', "");
    Expect(1, 7411, '\P{_ telugu}', "");
    Expect(0, 7411, '\P{^_ telugu}', "");
    Error('\p{/a/-IS_Telugu}');
    Error('\P{/a/-IS_Telugu}');
    Expect(1, 7410, '\p{istelugu}', "");
    Expect(0, 7410, '\p{^istelugu}', "");
    Expect(0, 7410, '\P{istelugu}', "");
    Expect(1, 7410, '\P{^istelugu}', "");
    Expect(0, 7411, '\p{istelugu}', "");
    Expect(1, 7411, '\p{^istelugu}', "");
    Expect(1, 7411, '\P{istelugu}', "");
    Expect(0, 7411, '\P{^istelugu}', "");
    Expect(1, 7410, '\p{--Is_Telugu}', "");
    Expect(0, 7410, '\p{^--Is_Telugu}', "");
    Expect(0, 7410, '\P{--Is_Telugu}', "");
    Expect(1, 7410, '\P{^--Is_Telugu}', "");
    Expect(0, 7411, '\p{--Is_Telugu}', "");
    Expect(1, 7411, '\p{^--Is_Telugu}', "");
    Expect(1, 7411, '\P{--Is_Telugu}', "");
    Expect(0, 7411, '\P{^--Is_Telugu}', "");
    Error('\p{-:=Telu}');
    Error('\P{-:=Telu}');
    Expect(1, 7410, '\p{telu}', "");
    Expect(0, 7410, '\p{^telu}', "");
    Expect(0, 7410, '\P{telu}', "");
    Expect(1, 7410, '\P{^telu}', "");
    Expect(0, 7411, '\p{telu}', "");
    Expect(1, 7411, '\p{^telu}', "");
    Expect(1, 7411, '\P{telu}', "");
    Expect(0, 7411, '\P{^telu}', "");
    Expect(1, 7410, '\p{  Telu}', "");
    Expect(0, 7410, '\p{^  Telu}', "");
    Expect(0, 7410, '\P{  Telu}', "");
    Expect(1, 7410, '\P{^  Telu}', "");
    Expect(0, 7411, '\p{  Telu}', "");
    Expect(1, 7411, '\p{^  Telu}', "");
    Expect(1, 7411, '\P{  Telu}', "");
    Expect(0, 7411, '\P{^  Telu}', "");
    Error('\p{/a/_	is_Telu}');
    Error('\P{/a/_	is_Telu}');
    Expect(1, 7410, '\p{istelu}', "");
    Expect(0, 7410, '\p{^istelu}', "");
    Expect(0, 7410, '\P{istelu}', "");
    Expect(1, 7410, '\P{^istelu}', "");
    Expect(0, 7411, '\p{istelu}', "");
    Expect(1, 7411, '\p{^istelu}', "");
    Expect(1, 7411, '\P{istelu}', "");
    Expect(0, 7411, '\P{^istelu}', "");
    Expect(1, 7410, '\p{_	Is_TELU}', "");
    Expect(0, 7410, '\p{^_	Is_TELU}', "");
    Expect(0, 7410, '\P{_	Is_TELU}', "");
    Expect(1, 7410, '\P{^_	Is_TELU}', "");
    Expect(0, 7411, '\p{_	Is_TELU}', "");
    Expect(1, 7411, '\p{^_	Is_TELU}', "");
    Expect(1, 7411, '\P{_	Is_TELU}', "");
    Expect(0, 7411, '\P{^_	Is_TELU}', "");
    Error('\p{	:=Terminal_PUNCTUATION}');
    Error('\P{	:=Terminal_PUNCTUATION}');
    Expect(1, 121482, '\p{terminalpunctuation}', "");
    Expect(0, 121482, '\p{^terminalpunctuation}', "");
    Expect(0, 121482, '\P{terminalpunctuation}', "");
    Expect(1, 121482, '\P{^terminalpunctuation}', "");
    Expect(0, 121483, '\p{terminalpunctuation}', "");
    Expect(1, 121483, '\p{^terminalpunctuation}', "");
    Expect(1, 121483, '\P{terminalpunctuation}', "");
    Expect(0, 121483, '\P{^terminalpunctuation}', "");
    Expect(1, 121482, '\p{Terminal_Punctuation}', "");
    Expect(0, 121482, '\p{^Terminal_Punctuation}', "");
    Expect(0, 121482, '\P{Terminal_Punctuation}', "");
    Expect(1, 121482, '\P{^Terminal_Punctuation}', "");
    Expect(0, 121483, '\p{Terminal_Punctuation}', "");
    Expect(1, 121483, '\p{^Terminal_Punctuation}', "");
    Expect(1, 121483, '\P{Terminal_Punctuation}', "");
    Expect(0, 121483, '\P{^Terminal_Punctuation}', "");
    Error('\p{	-Is_Terminal_punctuation:=}');
    Error('\P{	-Is_Terminal_punctuation:=}');
    Expect(1, 121482, '\p{isterminalpunctuation}', "");
    Expect(0, 121482, '\p{^isterminalpunctuation}', "");
    Expect(0, 121482, '\P{isterminalpunctuation}', "");
    Expect(1, 121482, '\P{^isterminalpunctuation}', "");
    Expect(0, 121483, '\p{isterminalpunctuation}', "");
    Expect(1, 121483, '\p{^isterminalpunctuation}', "");
    Expect(1, 121483, '\P{isterminalpunctuation}', "");
    Expect(0, 121483, '\P{^isterminalpunctuation}', "");
    Expect(1, 121482, '\p{	IS_Terminal_Punctuation}', "");
    Expect(0, 121482, '\p{^	IS_Terminal_Punctuation}', "");
    Expect(0, 121482, '\P{	IS_Terminal_Punctuation}', "");
    Expect(1, 121482, '\P{^	IS_Terminal_Punctuation}', "");
    Expect(0, 121483, '\p{	IS_Terminal_Punctuation}', "");
    Expect(1, 121483, '\p{^	IS_Terminal_Punctuation}', "");
    Expect(1, 121483, '\P{	IS_Terminal_Punctuation}', "");
    Expect(0, 121483, '\P{^	IS_Terminal_Punctuation}', "");
    Error('\p{:=_ term}');
    Error('\P{:=_ term}');
    Expect(1, 121482, '\p{term}', "");
    Expect(0, 121482, '\p{^term}', "");
    Expect(0, 121482, '\P{term}', "");
    Expect(1, 121482, '\P{^term}', "");
    Expect(0, 121483, '\p{term}', "");
    Expect(1, 121483, '\p{^term}', "");
    Expect(1, 121483, '\P{term}', "");
    Expect(0, 121483, '\P{^term}', "");
    Expect(1, 121482, '\p{  term}', "");
    Expect(0, 121482, '\p{^  term}', "");
    Expect(0, 121482, '\P{  term}', "");
    Expect(1, 121482, '\P{^  term}', "");
    Expect(0, 121483, '\p{  term}', "");
    Expect(1, 121483, '\p{^  term}', "");
    Expect(1, 121483, '\P{  term}', "");
    Expect(0, 121483, '\P{^  term}', "");
    Error('\p{	IS_Term:=}');
    Error('\P{	IS_Term:=}');
    Expect(1, 121482, '\p{isterm}', "");
    Expect(0, 121482, '\p{^isterm}', "");
    Expect(0, 121482, '\P{isterm}', "");
    Expect(1, 121482, '\P{^isterm}', "");
    Expect(0, 121483, '\p{isterm}', "");
    Expect(1, 121483, '\p{^isterm}', "");
    Expect(1, 121483, '\P{isterm}', "");
    Expect(0, 121483, '\P{^isterm}', "");
    Expect(1, 121482, '\p{	 Is_Term}', "");
    Expect(0, 121482, '\p{^	 Is_Term}', "");
    Expect(0, 121482, '\P{	 Is_Term}', "");
    Expect(1, 121482, '\P{^	 Is_Term}', "");
    Expect(0, 121483, '\p{	 Is_Term}', "");
    Expect(1, 121483, '\p{^	 Is_Term}', "");
    Expect(1, 121483, '\P{	 Is_Term}', "");
    Expect(0, 121483, '\P{^	 Is_Term}', "");
    Error('\p{ /a/Thaana}');
    Error('\P{ /a/Thaana}');
    Expect(1, 65021, '\p{thaana}', "");
    Expect(0, 65021, '\p{^thaana}', "");
    Expect(0, 65021, '\P{thaana}', "");
    Expect(1, 65021, '\P{^thaana}', "");
    Expect(0, 65022, '\p{thaana}', "");
    Expect(1, 65022, '\p{^thaana}', "");
    Expect(1, 65022, '\P{thaana}', "");
    Expect(0, 65022, '\P{^thaana}', "");
    Expect(1, 65021, '\p{-Thaana}', "");
    Expect(0, 65021, '\p{^-Thaana}', "");
    Expect(0, 65021, '\P{-Thaana}', "");
    Expect(1, 65021, '\P{^-Thaana}', "");
    Expect(0, 65022, '\p{-Thaana}', "");
    Expect(1, 65022, '\p{^-Thaana}', "");
    Expect(1, 65022, '\P{-Thaana}', "");
    Expect(0, 65022, '\P{^-Thaana}', "");
    Error('\p{:=_Is_Thaana}');
    Error('\P{:=_Is_Thaana}');
    Expect(1, 65021, '\p{isthaana}', "");
    Expect(0, 65021, '\p{^isthaana}', "");
    Expect(0, 65021, '\P{isthaana}', "");
    Expect(1, 65021, '\P{^isthaana}', "");
    Expect(0, 65022, '\p{isthaana}', "");
    Expect(1, 65022, '\p{^isthaana}', "");
    Expect(1, 65022, '\P{isthaana}', "");
    Expect(0, 65022, '\P{^isthaana}', "");
    Expect(1, 65021, '\p{ 	Is_Thaana}', "");
    Expect(0, 65021, '\p{^ 	Is_Thaana}', "");
    Expect(0, 65021, '\P{ 	Is_Thaana}', "");
    Expect(1, 65021, '\P{^ 	Is_Thaana}', "");
    Expect(0, 65022, '\p{ 	Is_Thaana}', "");
    Expect(1, 65022, '\p{^ 	Is_Thaana}', "");
    Expect(1, 65022, '\P{ 	Is_Thaana}', "");
    Expect(0, 65022, '\P{^ 	Is_Thaana}', "");
    Error('\p{ /a/Thaa}');
    Error('\P{ /a/Thaa}');
    Expect(1, 65021, '\p{thaa}', "");
    Expect(0, 65021, '\p{^thaa}', "");
    Expect(0, 65021, '\P{thaa}', "");
    Expect(1, 65021, '\P{^thaa}', "");
    Expect(0, 65022, '\p{thaa}', "");
    Expect(1, 65022, '\p{^thaa}', "");
    Expect(1, 65022, '\P{thaa}', "");
    Expect(0, 65022, '\P{^thaa}', "");
    Expect(1, 65021, '\p{_Thaa}', "");
    Expect(0, 65021, '\p{^_Thaa}', "");
    Expect(0, 65021, '\P{_Thaa}', "");
    Expect(1, 65021, '\P{^_Thaa}', "");
    Expect(0, 65022, '\p{_Thaa}', "");
    Expect(1, 65022, '\p{^_Thaa}', "");
    Expect(1, 65022, '\P{_Thaa}', "");
    Expect(0, 65022, '\P{^_Thaa}', "");
    Error('\p{:=	Is_Thaa}');
    Error('\P{:=	Is_Thaa}');
    Expect(1, 65021, '\p{isthaa}', "");
    Expect(0, 65021, '\p{^isthaa}', "");
    Expect(0, 65021, '\P{isthaa}', "");
    Expect(1, 65021, '\P{^isthaa}', "");
    Expect(0, 65022, '\p{isthaa}', "");
    Expect(1, 65022, '\p{^isthaa}', "");
    Expect(1, 65022, '\P{isthaa}', "");
    Expect(0, 65022, '\P{^isthaa}', "");
    Expect(1, 65021, '\p{-IS_Thaa}', "");
    Expect(0, 65021, '\p{^-IS_Thaa}', "");
    Expect(0, 65021, '\P{-IS_Thaa}', "");
    Expect(1, 65021, '\P{^-IS_Thaa}', "");
    Expect(0, 65022, '\p{-IS_Thaa}', "");
    Expect(1, 65022, '\p{^-IS_Thaa}', "");
    Expect(1, 65022, '\P{-IS_Thaa}', "");
    Expect(0, 65022, '\P{^-IS_Thaa}', "");
    Error('\p{:=	 Thai}');
    Error('\P{:=	 Thai}');
    Expect(1, 3675, '\p{thai}', "");
    Expect(0, 3675, '\p{^thai}', "");
    Expect(0, 3675, '\P{thai}', "");
    Expect(1, 3675, '\P{^thai}', "");
    Expect(0, 3676, '\p{thai}', "");
    Expect(1, 3676, '\p{^thai}', "");
    Expect(1, 3676, '\P{thai}', "");
    Expect(0, 3676, '\P{^thai}', "");
    Expect(1, 3675, '\p{__thai}', "");
    Expect(0, 3675, '\p{^__thai}', "");
    Expect(0, 3675, '\P{__thai}', "");
    Expect(1, 3675, '\P{^__thai}', "");
    Expect(0, 3676, '\p{__thai}', "");
    Expect(1, 3676, '\p{^__thai}', "");
    Expect(1, 3676, '\P{__thai}', "");
    Expect(0, 3676, '\P{^__thai}', "");
    Error('\p{	:=Is_Thai}');
    Error('\P{	:=Is_Thai}');
    Expect(1, 3675, '\p{isthai}', "");
    Expect(0, 3675, '\p{^isthai}', "");
    Expect(0, 3675, '\P{isthai}', "");
    Expect(1, 3675, '\P{^isthai}', "");
    Expect(0, 3676, '\p{isthai}', "");
    Expect(1, 3676, '\p{^isthai}', "");
    Expect(1, 3676, '\P{isthai}', "");
    Expect(0, 3676, '\P{^isthai}', "");
    Expect(1, 3675, '\p{_Is_thai}', "");
    Expect(0, 3675, '\p{^_Is_thai}', "");
    Expect(0, 3675, '\P{_Is_thai}', "");
    Expect(1, 3675, '\P{^_Is_thai}', "");
    Expect(0, 3676, '\p{_Is_thai}', "");
    Expect(1, 3676, '\p{^_Is_thai}', "");
    Expect(1, 3676, '\P{_Is_thai}', "");
    Expect(0, 3676, '\P{^_Is_thai}', "");
    Error('\p{ /a/Tibetan}');
    Error('\P{ /a/Tibetan}');
    Expect(1, 4058, '\p{tibetan}', "");
    Expect(0, 4058, '\p{^tibetan}', "");
    Expect(0, 4058, '\P{tibetan}', "");
    Expect(1, 4058, '\P{^tibetan}', "");
    Expect(0, 4059, '\p{tibetan}', "");
    Expect(1, 4059, '\p{^tibetan}', "");
    Expect(1, 4059, '\P{tibetan}', "");
    Expect(0, 4059, '\P{^tibetan}', "");
    Expect(1, 4058, '\p{		TIBETAN}', "");
    Expect(0, 4058, '\p{^		TIBETAN}', "");
    Expect(0, 4058, '\P{		TIBETAN}', "");
    Expect(1, 4058, '\P{^		TIBETAN}', "");
    Expect(0, 4059, '\p{		TIBETAN}', "");
    Expect(1, 4059, '\p{^		TIBETAN}', "");
    Expect(1, 4059, '\P{		TIBETAN}', "");
    Expect(0, 4059, '\P{^		TIBETAN}', "");
    Error('\p{_:=is_Tibetan}');
    Error('\P{_:=is_Tibetan}');
    Expect(1, 4058, '\p{istibetan}', "");
    Expect(0, 4058, '\p{^istibetan}', "");
    Expect(0, 4058, '\P{istibetan}', "");
    Expect(1, 4058, '\P{^istibetan}', "");
    Expect(0, 4059, '\p{istibetan}', "");
    Expect(1, 4059, '\p{^istibetan}', "");
    Expect(1, 4059, '\P{istibetan}', "");
    Expect(0, 4059, '\P{^istibetan}', "");
    Expect(1, 4058, '\p{	-Is_Tibetan}', "");
    Expect(0, 4058, '\p{^	-Is_Tibetan}', "");
    Expect(0, 4058, '\P{	-Is_Tibetan}', "");
    Expect(1, 4058, '\P{^	-Is_Tibetan}', "");
    Expect(0, 4059, '\p{	-Is_Tibetan}', "");
    Expect(1, 4059, '\p{^	-Is_Tibetan}', "");
    Expect(1, 4059, '\P{	-Is_Tibetan}', "");
    Expect(0, 4059, '\P{^	-Is_Tibetan}', "");
    Error('\p{/a/tibt}');
    Error('\P{/a/tibt}');
    Expect(1, 4058, '\p{tibt}', "");
    Expect(0, 4058, '\p{^tibt}', "");
    Expect(0, 4058, '\P{tibt}', "");
    Expect(1, 4058, '\P{^tibt}', "");
    Expect(0, 4059, '\p{tibt}', "");
    Expect(1, 4059, '\p{^tibt}', "");
    Expect(1, 4059, '\P{tibt}', "");
    Expect(0, 4059, '\P{^tibt}', "");
    Expect(1, 4058, '\p{_-Tibt}', "");
    Expect(0, 4058, '\p{^_-Tibt}', "");
    Expect(0, 4058, '\P{_-Tibt}', "");
    Expect(1, 4058, '\P{^_-Tibt}', "");
    Expect(0, 4059, '\p{_-Tibt}', "");
    Expect(1, 4059, '\p{^_-Tibt}', "");
    Expect(1, 4059, '\P{_-Tibt}', "");
    Expect(0, 4059, '\P{^_-Tibt}', "");
    Error('\p{/a/-Is_Tibt}');
    Error('\P{/a/-Is_Tibt}');
    Expect(1, 4058, '\p{istibt}', "");
    Expect(0, 4058, '\p{^istibt}', "");
    Expect(0, 4058, '\P{istibt}', "");
    Expect(1, 4058, '\P{^istibt}', "");
    Expect(0, 4059, '\p{istibt}', "");
    Expect(1, 4059, '\p{^istibt}', "");
    Expect(1, 4059, '\P{istibt}', "");
    Expect(0, 4059, '\P{^istibt}', "");
    Expect(1, 4058, '\p{__Is_tibt}', "");
    Expect(0, 4058, '\p{^__Is_tibt}', "");
    Expect(0, 4058, '\P{__Is_tibt}', "");
    Expect(1, 4058, '\P{^__Is_tibt}', "");
    Expect(0, 4059, '\p{__Is_tibt}', "");
    Expect(1, 4059, '\p{^__Is_tibt}', "");
    Expect(1, 4059, '\P{__Is_tibt}', "");
    Expect(0, 4059, '\P{^__Is_tibt}', "");
    Error('\p{ /a/tifinagh}');
    Error('\P{ /a/tifinagh}');
    Expect(1, 11647, '\p{tifinagh}', "");
    Expect(0, 11647, '\p{^tifinagh}', "");
    Expect(0, 11647, '\P{tifinagh}', "");
    Expect(1, 11647, '\P{^tifinagh}', "");
    Expect(0, 11648, '\p{tifinagh}', "");
    Expect(1, 11648, '\p{^tifinagh}', "");
    Expect(1, 11648, '\P{tifinagh}', "");
    Expect(0, 11648, '\P{^tifinagh}', "");
    Expect(1, 11647, '\p{ _Tifinagh}', "");
    Expect(0, 11647, '\p{^ _Tifinagh}', "");
    Expect(0, 11647, '\P{ _Tifinagh}', "");
    Expect(1, 11647, '\P{^ _Tifinagh}', "");
    Expect(0, 11648, '\p{ _Tifinagh}', "");
    Expect(1, 11648, '\p{^ _Tifinagh}', "");
    Expect(1, 11648, '\P{ _Tifinagh}', "");
    Expect(0, 11648, '\P{^ _Tifinagh}', "");
    Error('\p{:=	-IS_TIFINAGH}');
    Error('\P{:=	-IS_TIFINAGH}');
    Expect(1, 11647, '\p{istifinagh}', "");
    Expect(0, 11647, '\p{^istifinagh}', "");
    Expect(0, 11647, '\P{istifinagh}', "");
    Expect(1, 11647, '\P{^istifinagh}', "");
    Expect(0, 11648, '\p{istifinagh}', "");
    Expect(1, 11648, '\p{^istifinagh}', "");
    Expect(1, 11648, '\P{istifinagh}', "");
    Expect(0, 11648, '\P{^istifinagh}', "");
    Expect(1, 11647, '\p{-is_Tifinagh}', "");
    Expect(0, 11647, '\p{^-is_Tifinagh}', "");
    Expect(0, 11647, '\P{-is_Tifinagh}', "");
    Expect(1, 11647, '\P{^-is_Tifinagh}', "");
    Expect(0, 11648, '\p{-is_Tifinagh}', "");
    Expect(1, 11648, '\p{^-is_Tifinagh}', "");
    Expect(1, 11648, '\P{-is_Tifinagh}', "");
    Expect(0, 11648, '\P{^-is_Tifinagh}', "");
    Error('\p{/a/tfng}');
    Error('\P{/a/tfng}');
    Expect(1, 11647, '\p{tfng}', "");
    Expect(0, 11647, '\p{^tfng}', "");
    Expect(0, 11647, '\P{tfng}', "");
    Expect(1, 11647, '\P{^tfng}', "");
    Expect(0, 11648, '\p{tfng}', "");
    Expect(1, 11648, '\p{^tfng}', "");
    Expect(1, 11648, '\P{tfng}', "");
    Expect(0, 11648, '\P{^tfng}', "");
    Expect(1, 11647, '\p{ -Tfng}', "");
    Expect(0, 11647, '\p{^ -Tfng}', "");
    Expect(0, 11647, '\P{ -Tfng}', "");
    Expect(1, 11647, '\P{^ -Tfng}', "");
    Expect(0, 11648, '\p{ -Tfng}', "");
    Expect(1, 11648, '\p{^ -Tfng}', "");
    Expect(1, 11648, '\P{ -Tfng}', "");
    Expect(0, 11648, '\P{^ -Tfng}', "");
    Error('\p{	:=Is_TFNG}');
    Error('\P{	:=Is_TFNG}');
    Expect(1, 11647, '\p{istfng}', "");
    Expect(0, 11647, '\p{^istfng}', "");
    Expect(0, 11647, '\P{istfng}', "");
    Expect(1, 11647, '\P{^istfng}', "");
    Expect(0, 11648, '\p{istfng}', "");
    Expect(1, 11648, '\p{^istfng}', "");
    Expect(1, 11648, '\P{istfng}', "");
    Expect(0, 11648, '\P{^istfng}', "");
    Expect(1, 11647, '\p{	IS_tfng}', "");
    Expect(0, 11647, '\p{^	IS_tfng}', "");
    Expect(0, 11647, '\P{	IS_tfng}', "");
    Expect(1, 11647, '\P{^	IS_tfng}', "");
    Expect(0, 11648, '\p{	IS_tfng}', "");
    Expect(1, 11648, '\p{^	IS_tfng}', "");
    Expect(1, 11648, '\P{	IS_tfng}', "");
    Expect(0, 11648, '\P{^	IS_tfng}', "");
    Error('\p{_/a/TIRHUTA}');
    Error('\P{_/a/TIRHUTA}');
    Expect(1, 70873, '\p{tirhuta}', "");
    Expect(0, 70873, '\p{^tirhuta}', "");
    Expect(0, 70873, '\P{tirhuta}', "");
    Expect(1, 70873, '\P{^tirhuta}', "");
    Expect(0, 70874, '\p{tirhuta}', "");
    Expect(1, 70874, '\p{^tirhuta}', "");
    Expect(1, 70874, '\P{tirhuta}', "");
    Expect(0, 70874, '\P{^tirhuta}', "");
    Expect(1, 70873, '\p{ -TIRHUTA}', "");
    Expect(0, 70873, '\p{^ -TIRHUTA}', "");
    Expect(0, 70873, '\P{ -TIRHUTA}', "");
    Expect(1, 70873, '\P{^ -TIRHUTA}', "");
    Expect(0, 70874, '\p{ -TIRHUTA}', "");
    Expect(1, 70874, '\p{^ -TIRHUTA}', "");
    Expect(1, 70874, '\P{ -TIRHUTA}', "");
    Expect(0, 70874, '\P{^ -TIRHUTA}', "");
    Error('\p{	_IS_TIRHUTA:=}');
    Error('\P{	_IS_TIRHUTA:=}');
    Expect(1, 70873, '\p{istirhuta}', "");
    Expect(0, 70873, '\p{^istirhuta}', "");
    Expect(0, 70873, '\P{istirhuta}', "");
    Expect(1, 70873, '\P{^istirhuta}', "");
    Expect(0, 70874, '\p{istirhuta}', "");
    Expect(1, 70874, '\p{^istirhuta}', "");
    Expect(1, 70874, '\P{istirhuta}', "");
    Expect(0, 70874, '\P{^istirhuta}', "");
    Expect(1, 70873, '\p{is_TIRHUTA}', "");
    Expect(0, 70873, '\p{^is_TIRHUTA}', "");
    Expect(0, 70873, '\P{is_TIRHUTA}', "");
    Expect(1, 70873, '\P{^is_TIRHUTA}', "");
    Expect(0, 70874, '\p{is_TIRHUTA}', "");
    Expect(1, 70874, '\p{^is_TIRHUTA}', "");
    Expect(1, 70874, '\P{is_TIRHUTA}', "");
    Expect(0, 70874, '\P{^is_TIRHUTA}', "");
    Error('\p{ Tirh/a/}');
    Error('\P{ Tirh/a/}');
    Expect(1, 70873, '\p{tirh}', "");
    Expect(0, 70873, '\p{^tirh}', "");
    Expect(0, 70873, '\P{tirh}', "");
    Expect(1, 70873, '\P{^tirh}', "");
    Expect(0, 70874, '\p{tirh}', "");
    Expect(1, 70874, '\p{^tirh}', "");
    Expect(1, 70874, '\P{tirh}', "");
    Expect(0, 70874, '\P{^tirh}', "");
    Expect(1, 70873, '\p{_TIRH}', "");
    Expect(0, 70873, '\p{^_TIRH}', "");
    Expect(0, 70873, '\P{_TIRH}', "");
    Expect(1, 70873, '\P{^_TIRH}', "");
    Expect(0, 70874, '\p{_TIRH}', "");
    Expect(1, 70874, '\p{^_TIRH}', "");
    Expect(1, 70874, '\P{_TIRH}', "");
    Expect(0, 70874, '\P{^_TIRH}', "");
    Error('\p{ :=is_Tirh}');
    Error('\P{ :=is_Tirh}');
    Expect(1, 70873, '\p{istirh}', "");
    Expect(0, 70873, '\p{^istirh}', "");
    Expect(0, 70873, '\P{istirh}', "");
    Expect(1, 70873, '\P{^istirh}', "");
    Expect(0, 70874, '\p{istirh}', "");
    Expect(1, 70874, '\p{^istirh}', "");
    Expect(1, 70874, '\P{istirh}', "");
    Expect(0, 70874, '\P{^istirh}', "");
    Expect(1, 70873, '\p{Is_TIRH}', "");
    Expect(0, 70873, '\p{^Is_TIRH}', "");
    Expect(0, 70873, '\P{Is_TIRH}', "");
    Expect(1, 70873, '\P{^Is_TIRH}', "");
    Expect(0, 70874, '\p{Is_TIRH}', "");
    Expect(1, 70874, '\p{^Is_TIRH}', "");
    Expect(1, 70874, '\P{Is_TIRH}', "");
    Expect(0, 70874, '\P{^Is_TIRH}', "");
    Error('\p{--Titlecase/a/}');
    Error('\P{--Titlecase/a/}');
    Expect(1, 8188, '\p{titlecase}', "");
    Expect(0, 8188, '\p{^titlecase}', "");
    Expect(0, 8188, '\P{titlecase}', "");
    Expect(1, 8188, '\P{^titlecase}', "");
    Expect(0, 8189, '\p{titlecase}', "");
    Expect(1, 8189, '\p{^titlecase}', "");
    Expect(1, 8189, '\P{titlecase}', "");
    Expect(0, 8189, '\P{^titlecase}', "");
    Expect(1, 8188, '\p{_-TITLECASE}', "");
    Expect(0, 8188, '\p{^_-TITLECASE}', "");
    Expect(0, 8188, '\P{_-TITLECASE}', "");
    Expect(1, 8188, '\P{^_-TITLECASE}', "");
    Expect(0, 8189, '\p{_-TITLECASE}', "");
    Expect(1, 8189, '\p{^_-TITLECASE}', "");
    Expect(1, 8189, '\P{_-TITLECASE}', "");
    Expect(0, 8189, '\P{^_-TITLECASE}', "");
    Error('\p{:=-title}');
    Error('\P{:=-title}');
    Expect(1, 8188, '\p{title}', "");
    Expect(0, 8188, '\p{^title}', "");
    Expect(0, 8188, '\P{title}', "");
    Expect(1, 8188, '\P{^title}', "");
    Expect(0, 8189, '\p{title}', "");
    Expect(1, 8189, '\p{^title}', "");
    Expect(1, 8189, '\P{title}', "");
    Expect(0, 8189, '\P{^title}', "");
    Expect(1, 8188, '\p{ -Title}', "");
    Expect(0, 8188, '\p{^ -Title}', "");
    Expect(0, 8188, '\P{ -Title}', "");
    Expect(1, 8188, '\P{^ -Title}', "");
    Expect(0, 8189, '\p{ -Title}', "");
    Expect(1, 8189, '\p{^ -Title}', "");
    Expect(1, 8189, '\P{ -Title}', "");
    Expect(0, 8189, '\P{^ -Title}', "");
    Error('\p{-/a/is_titlecase}');
    Error('\P{-/a/is_titlecase}');
    Expect(1, 8188, '\p{istitlecase}', "");
    Expect(0, 8188, '\p{^istitlecase}', "");
    Expect(0, 8188, '\P{istitlecase}', "");
    Expect(1, 8188, '\P{^istitlecase}', "");
    Expect(0, 8189, '\p{istitlecase}', "");
    Expect(1, 8189, '\p{^istitlecase}', "");
    Expect(1, 8189, '\P{istitlecase}', "");
    Expect(0, 8189, '\P{^istitlecase}', "");
    Expect(1, 8188, '\p{_-Is_Titlecase}', "");
    Expect(0, 8188, '\p{^_-Is_Titlecase}', "");
    Expect(0, 8188, '\P{_-Is_Titlecase}', "");
    Expect(1, 8188, '\P{^_-Is_Titlecase}', "");
    Expect(0, 8189, '\p{_-Is_Titlecase}', "");
    Expect(1, 8189, '\p{^_-Is_Titlecase}', "");
    Expect(1, 8189, '\P{_-Is_Titlecase}', "");
    Expect(0, 8189, '\P{^_-Is_Titlecase}', "");
    Error('\p{:=Is_title}');
    Error('\P{:=Is_title}');
    Expect(1, 8188, '\p{istitle}', "");
    Expect(0, 8188, '\p{^istitle}', "");
    Expect(0, 8188, '\P{istitle}', "");
    Expect(1, 8188, '\P{^istitle}', "");
    Expect(0, 8189, '\p{istitle}', "");
    Expect(1, 8189, '\p{^istitle}', "");
    Expect(1, 8189, '\P{istitle}', "");
    Expect(0, 8189, '\P{^istitle}', "");
    Expect(1, 8188, '\p{IS_title}', "");
    Expect(0, 8188, '\p{^IS_title}', "");
    Expect(0, 8188, '\P{IS_title}', "");
    Expect(1, 8188, '\P{^IS_title}', "");
    Expect(0, 8189, '\p{IS_title}', "");
    Expect(1, 8189, '\p{^IS_title}', "");
    Expect(1, 8189, '\P{IS_title}', "");
    Expect(0, 8189, '\P{^IS_title}', "");
    Error('\p{/a/_ TITLECASE_LETTER}');
    Error('\P{/a/_ TITLECASE_LETTER}');
    Expect(1, 8188, '\p{titlecaseletter}', "");
    Expect(0, 8188, '\p{^titlecaseletter}', "");
    Expect(0, 8188, '\P{titlecaseletter}', "");
    Expect(1, 8188, '\P{^titlecaseletter}', "");
    Expect(0, 8189, '\p{titlecaseletter}', "");
    Expect(1, 8189, '\p{^titlecaseletter}', "");
    Expect(1, 8189, '\P{titlecaseletter}', "");
    Expect(0, 8189, '\P{^titlecaseletter}', "");
    Expect(1, 8188, '\p{  TITLECASE_Letter}', "");
    Expect(0, 8188, '\p{^  TITLECASE_Letter}', "");
    Expect(0, 8188, '\P{  TITLECASE_Letter}', "");
    Expect(1, 8188, '\P{^  TITLECASE_Letter}', "");
    Expect(0, 8189, '\p{  TITLECASE_Letter}', "");
    Expect(1, 8189, '\p{^  TITLECASE_Letter}', "");
    Expect(1, 8189, '\P{  TITLECASE_Letter}', "");
    Expect(0, 8189, '\P{^  TITLECASE_Letter}', "");
    Error('\p{:=_-Is_titlecase_Letter}');
    Error('\P{:=_-Is_titlecase_Letter}');
    Expect(1, 8188, '\p{istitlecaseletter}', "");
    Expect(0, 8188, '\p{^istitlecaseletter}', "");
    Expect(0, 8188, '\P{istitlecaseletter}', "");
    Expect(1, 8188, '\P{^istitlecaseletter}', "");
    Expect(0, 8189, '\p{istitlecaseletter}', "");
    Expect(1, 8189, '\p{^istitlecaseletter}', "");
    Expect(1, 8189, '\P{istitlecaseletter}', "");
    Expect(0, 8189, '\P{^istitlecaseletter}', "");
    Expect(1, 8188, '\p{_Is_Titlecase_Letter}', "");
    Expect(0, 8188, '\p{^_Is_Titlecase_Letter}', "");
    Expect(0, 8188, '\P{_Is_Titlecase_Letter}', "");
    Expect(1, 8188, '\P{^_Is_Titlecase_Letter}', "");
    Expect(0, 8189, '\p{_Is_Titlecase_Letter}', "");
    Expect(1, 8189, '\p{^_Is_Titlecase_Letter}', "");
    Expect(1, 8189, '\P{_Is_Titlecase_Letter}', "");
    Expect(0, 8189, '\P{^_Is_Titlecase_Letter}', "");
    Error('\p{/a/Lt}');
    Error('\P{/a/Lt}');
    Expect(1, 8188, '\p{lt}', "");
    Expect(0, 8188, '\p{^lt}', "");
    Expect(0, 8188, '\P{lt}', "");
    Expect(1, 8188, '\P{^lt}', "");
    Expect(0, 8189, '\p{lt}', "");
    Expect(1, 8189, '\p{^lt}', "");
    Expect(1, 8189, '\P{lt}', "");
    Expect(0, 8189, '\P{^lt}', "");
    Expect(1, 8188, '\p{  Lt}', "");
    Expect(0, 8188, '\p{^  Lt}', "");
    Expect(0, 8188, '\P{  Lt}', "");
    Expect(1, 8188, '\P{^  Lt}', "");
    Expect(0, 8189, '\p{  Lt}', "");
    Expect(1, 8189, '\p{^  Lt}', "");
    Expect(1, 8189, '\P{  Lt}', "");
    Expect(0, 8189, '\P{^  Lt}', "");
    Error('\p{-:=IS_LT}');
    Error('\P{-:=IS_LT}');
    Expect(1, 8188, '\p{islt}', "");
    Expect(0, 8188, '\p{^islt}', "");
    Expect(0, 8188, '\P{islt}', "");
    Expect(1, 8188, '\P{^islt}', "");
    Expect(0, 8189, '\p{islt}', "");
    Expect(1, 8189, '\p{^islt}', "");
    Expect(1, 8189, '\P{islt}', "");
    Expect(0, 8189, '\P{^islt}', "");
    Expect(1, 8188, '\p{	-IS_Lt}', "");
    Expect(0, 8188, '\p{^	-IS_Lt}', "");
    Expect(0, 8188, '\P{	-IS_Lt}', "");
    Expect(1, 8188, '\P{^	-IS_Lt}', "");
    Expect(0, 8189, '\p{	-IS_Lt}', "");
    Expect(1, 8189, '\p{^	-IS_Lt}', "");
    Expect(1, 8189, '\P{	-IS_Lt}', "");
    Expect(0, 8189, '\P{^	-IS_Lt}', "");
    Error('\p{ /a/toto}');
    Error('\P{ /a/toto}');
    Expect(1, 123566, '\p{toto}', "");
    Expect(0, 123566, '\p{^toto}', "");
    Expect(0, 123566, '\P{toto}', "");
    Expect(1, 123566, '\P{^toto}', "");
    Expect(0, 123567, '\p{toto}', "");
    Expect(1, 123567, '\p{^toto}', "");
    Expect(1, 123567, '\P{toto}', "");
    Expect(0, 123567, '\P{^toto}', "");
    Error('\p{:=  is_Toto}');
    Error('\P{:=  is_Toto}');
    Expect(1, 123566, '\p{istoto}', "");
    Expect(0, 123566, '\p{^istoto}', "");
    Expect(0, 123566, '\P{istoto}', "");
    Expect(1, 123566, '\P{^istoto}', "");
    Expect(0, 123567, '\p{istoto}', "");
    Expect(1, 123567, '\p{^istoto}', "");
    Expect(1, 123567, '\P{istoto}', "");
    Expect(0, 123567, '\P{^istoto}', "");
    Expect(1, 123566, '\p{ -Is_toto}', "");
    Expect(0, 123566, '\p{^ -Is_toto}', "");
    Expect(0, 123566, '\P{ -Is_toto}', "");
    Expect(1, 123566, '\P{^ -Is_toto}', "");
    Expect(0, 123567, '\p{ -Is_toto}', "");
    Expect(1, 123567, '\p{^ -Is_toto}', "");
    Expect(1, 123567, '\P{ -Is_toto}', "");
    Expect(0, 123567, '\P{^ -Is_toto}', "");
    Error('\p{	Transport_and_Map_Symbols:=}');
    Error('\P{	Transport_and_Map_Symbols:=}');
    Expect(1, 128767, '\p{transportandmapsymbols}', "");
    Expect(0, 128767, '\p{^transportandmapsymbols}', "");
    Expect(0, 128767, '\P{transportandmapsymbols}', "");
    Expect(1, 128767, '\P{^transportandmapsymbols}', "");
    Expect(0, 128768, '\p{transportandmapsymbols}', "");
    Expect(1, 128768, '\p{^transportandmapsymbols}', "");
    Expect(1, 128768, '\P{transportandmapsymbols}', "");
    Expect(0, 128768, '\P{^transportandmapsymbols}', "");
    Expect(1, 128767, '\p{	-TRANSPORT_And_Map_SYMBOLS}', "");
    Expect(0, 128767, '\p{^	-TRANSPORT_And_Map_SYMBOLS}', "");
    Expect(0, 128767, '\P{	-TRANSPORT_And_Map_SYMBOLS}', "");
    Expect(1, 128767, '\P{^	-TRANSPORT_And_Map_SYMBOLS}', "");
    Expect(0, 128768, '\p{	-TRANSPORT_And_Map_SYMBOLS}', "");
    Expect(1, 128768, '\p{^	-TRANSPORT_And_Map_SYMBOLS}', "");
    Expect(1, 128768, '\P{	-TRANSPORT_And_Map_SYMBOLS}', "");
    Expect(0, 128768, '\P{^	-TRANSPORT_And_Map_SYMBOLS}', "");
    Error('\p{/a/Is_Transport_And_MAP_symbols}');
    Error('\P{/a/Is_Transport_And_MAP_symbols}');
    Expect(1, 128767, '\p{istransportandmapsymbols}', "");
    Expect(0, 128767, '\p{^istransportandmapsymbols}', "");
    Expect(0, 128767, '\P{istransportandmapsymbols}', "");
    Expect(1, 128767, '\P{^istransportandmapsymbols}', "");
    Expect(0, 128768, '\p{istransportandmapsymbols}', "");
    Expect(1, 128768, '\p{^istransportandmapsymbols}', "");
    Expect(1, 128768, '\P{istransportandmapsymbols}', "");
    Expect(0, 128768, '\P{^istransportandmapsymbols}', "");
    Expect(1, 128767, '\p{__Is_Transport_AND_Map_Symbols}', "");
    Expect(0, 128767, '\p{^__Is_Transport_AND_Map_Symbols}', "");
    Expect(0, 128767, '\P{__Is_Transport_AND_Map_Symbols}', "");
    Expect(1, 128767, '\P{^__Is_Transport_AND_Map_Symbols}', "");
    Expect(0, 128768, '\p{__Is_Transport_AND_Map_Symbols}', "");
    Expect(1, 128768, '\p{^__Is_Transport_AND_Map_Symbols}', "");
    Expect(1, 128768, '\P{__Is_Transport_AND_Map_Symbols}', "");
    Expect(0, 128768, '\P{^__Is_Transport_AND_Map_Symbols}', "");
    Error('\p{	 IN_TRANSPORT_AND_Map_Symbols/a/}');
    Error('\P{	 IN_TRANSPORT_AND_Map_Symbols/a/}');
    Expect(1, 128767, '\p{intransportandmapsymbols}', "");
    Expect(0, 128767, '\p{^intransportandmapsymbols}', "");
    Expect(0, 128767, '\P{intransportandmapsymbols}', "");
    Expect(1, 128767, '\P{^intransportandmapsymbols}', "");
    Expect(0, 128768, '\p{intransportandmapsymbols}', "");
    Expect(1, 128768, '\p{^intransportandmapsymbols}', "");
    Expect(1, 128768, '\P{intransportandmapsymbols}', "");
    Expect(0, 128768, '\P{^intransportandmapsymbols}', "");
    Expect(1, 128767, '\p{-	in_TRANSPORT_And_MAP_symbols}', "");
    Expect(0, 128767, '\p{^-	in_TRANSPORT_And_MAP_symbols}', "");
    Expect(0, 128767, '\P{-	in_TRANSPORT_And_MAP_symbols}', "");
    Expect(1, 128767, '\P{^-	in_TRANSPORT_And_MAP_symbols}', "");
    Expect(0, 128768, '\p{-	in_TRANSPORT_And_MAP_symbols}', "");
    Expect(1, 128768, '\p{^-	in_TRANSPORT_And_MAP_symbols}', "");
    Expect(1, 128768, '\P{-	in_TRANSPORT_And_MAP_symbols}', "");
    Expect(0, 128768, '\P{^-	in_TRANSPORT_And_MAP_symbols}', "");
    Error('\p{	TRANSPORT_AND_Map:=}');
    Error('\P{	TRANSPORT_AND_Map:=}');
    Expect(1, 128767, '\p{transportandmap}', "");
    Expect(0, 128767, '\p{^transportandmap}', "");
    Expect(0, 128767, '\P{transportandmap}', "");
    Expect(1, 128767, '\P{^transportandmap}', "");
    Expect(0, 128768, '\p{transportandmap}', "");
    Expect(1, 128768, '\p{^transportandmap}', "");
    Expect(1, 128768, '\P{transportandmap}', "");
    Expect(0, 128768, '\P{^transportandmap}', "");
    Expect(1, 128767, '\p{ 	Transport_and_map}', "");
    Expect(0, 128767, '\p{^ 	Transport_and_map}', "");
    Expect(0, 128767, '\P{ 	Transport_and_map}', "");
    Expect(1, 128767, '\P{^ 	Transport_and_map}', "");
    Expect(0, 128768, '\p{ 	Transport_and_map}', "");
    Expect(1, 128768, '\p{^ 	Transport_and_map}', "");
    Expect(1, 128768, '\P{ 	Transport_and_map}', "");
    Expect(0, 128768, '\P{^ 	Transport_and_map}', "");
    Error('\p{ IS_Transport_And_map/a/}');
    Error('\P{ IS_Transport_And_map/a/}');
    Expect(1, 128767, '\p{istransportandmap}', "");
    Expect(0, 128767, '\p{^istransportandmap}', "");
    Expect(0, 128767, '\P{istransportandmap}', "");
    Expect(1, 128767, '\P{^istransportandmap}', "");
    Expect(0, 128768, '\p{istransportandmap}', "");
    Expect(1, 128768, '\p{^istransportandmap}', "");
    Expect(1, 128768, '\P{istransportandmap}', "");
    Expect(0, 128768, '\P{^istransportandmap}', "");
    Expect(1, 128767, '\p{ Is_TRANSPORT_And_Map}', "");
    Expect(0, 128767, '\p{^ Is_TRANSPORT_And_Map}', "");
    Expect(0, 128767, '\P{ Is_TRANSPORT_And_Map}', "");
    Expect(1, 128767, '\P{^ Is_TRANSPORT_And_Map}', "");
    Expect(0, 128768, '\p{ Is_TRANSPORT_And_Map}', "");
    Expect(1, 128768, '\p{^ Is_TRANSPORT_And_Map}', "");
    Expect(1, 128768, '\P{ Is_TRANSPORT_And_Map}', "");
    Expect(0, 128768, '\P{^ Is_TRANSPORT_And_Map}', "");
    Error('\p{:=_In_Transport_And_map}');
    Error('\P{:=_In_Transport_And_map}');
    Expect(1, 128767, '\p{intransportandmap}', "");
    Expect(0, 128767, '\p{^intransportandmap}', "");
    Expect(0, 128767, '\P{intransportandmap}', "");
    Expect(1, 128767, '\P{^intransportandmap}', "");
    Expect(0, 128768, '\p{intransportandmap}', "");
    Expect(1, 128768, '\p{^intransportandmap}', "");
    Expect(1, 128768, '\P{intransportandmap}', "");
    Expect(0, 128768, '\P{^intransportandmap}', "");
    Expect(1, 128767, '\p{ IN_Transport_And_map}', "");
    Expect(0, 128767, '\p{^ IN_Transport_And_map}', "");
    Expect(0, 128767, '\P{ IN_Transport_And_map}', "");
    Expect(1, 128767, '\P{^ IN_Transport_And_map}', "");
    Expect(0, 128768, '\p{ IN_Transport_And_map}', "");
    Expect(1, 128768, '\p{^ IN_Transport_And_map}', "");
    Expect(1, 128768, '\P{ IN_Transport_And_map}', "");
    Expect(0, 128768, '\P{^ IN_Transport_And_map}', "");
    Error('\p{	-UGARITIC:=}');
    Error('\P{	-UGARITIC:=}');
    Expect(1, 66463, '\p{ugaritic}', "");
    Expect(0, 66463, '\p{^ugaritic}', "");
    Expect(0, 66463, '\P{ugaritic}', "");
    Expect(1, 66463, '\P{^ugaritic}', "");
    Expect(0, 66464, '\p{ugaritic}', "");
    Expect(1, 66464, '\p{^ugaritic}', "");
    Expect(1, 66464, '\P{ugaritic}', "");
    Expect(0, 66464, '\P{^ugaritic}', "");
    Expect(1, 66463, '\p{	_ugaritic}', "");
    Expect(0, 66463, '\p{^	_ugaritic}', "");
    Expect(0, 66463, '\P{	_ugaritic}', "");
    Expect(1, 66463, '\P{^	_ugaritic}', "");
    Expect(0, 66464, '\p{	_ugaritic}', "");
    Expect(1, 66464, '\p{^	_ugaritic}', "");
    Expect(1, 66464, '\P{	_ugaritic}', "");
    Expect(0, 66464, '\P{^	_ugaritic}', "");
    Error('\p{_	IS_Ugaritic/a/}');
    Error('\P{_	IS_Ugaritic/a/}');
    Expect(1, 66463, '\p{isugaritic}', "");
    Expect(0, 66463, '\p{^isugaritic}', "");
    Expect(0, 66463, '\P{isugaritic}', "");
    Expect(1, 66463, '\P{^isugaritic}', "");
    Expect(0, 66464, '\p{isugaritic}', "");
    Expect(1, 66464, '\p{^isugaritic}', "");
    Expect(1, 66464, '\P{isugaritic}', "");
    Expect(0, 66464, '\P{^isugaritic}', "");
    Expect(1, 66463, '\p{- Is_UGARITIC}', "");
    Expect(0, 66463, '\p{^- Is_UGARITIC}', "");
    Expect(0, 66463, '\P{- Is_UGARITIC}', "");
    Expect(1, 66463, '\P{^- Is_UGARITIC}', "");
    Expect(0, 66464, '\p{- Is_UGARITIC}', "");
    Expect(1, 66464, '\p{^- Is_UGARITIC}', "");
    Expect(1, 66464, '\P{- Is_UGARITIC}', "");
    Expect(0, 66464, '\P{^- Is_UGARITIC}', "");
    Error('\p{ ugar/a/}');
    Error('\P{ ugar/a/}');
    Expect(1, 66463, '\p{ugar}', "");
    Expect(0, 66463, '\p{^ugar}', "");
    Expect(0, 66463, '\P{ugar}', "");
    Expect(1, 66463, '\P{^ugar}', "");
    Expect(0, 66464, '\p{ugar}', "");
    Expect(1, 66464, '\p{^ugar}', "");
    Expect(1, 66464, '\P{ugar}', "");
    Expect(0, 66464, '\P{^ugar}', "");
    Expect(1, 66463, '\p{  Ugar}', "");
    Expect(0, 66463, '\p{^  Ugar}', "");
    Expect(0, 66463, '\P{  Ugar}', "");
    Expect(1, 66463, '\P{^  Ugar}', "");
    Expect(0, 66464, '\p{  Ugar}', "");
    Expect(1, 66464, '\p{^  Ugar}', "");
    Expect(1, 66464, '\P{  Ugar}', "");
    Expect(0, 66464, '\P{^  Ugar}', "");
    Error('\p{:=- Is_UGAR}');
    Error('\P{:=- Is_UGAR}');
    Expect(1, 66463, '\p{isugar}', "");
    Expect(0, 66463, '\p{^isugar}', "");
    Expect(0, 66463, '\P{isugar}', "");
    Expect(1, 66463, '\P{^isugar}', "");
    Expect(0, 66464, '\p{isugar}', "");
    Expect(1, 66464, '\p{^isugar}', "");
    Expect(1, 66464, '\P{isugar}', "");
    Expect(0, 66464, '\P{^isugar}', "");
    Expect(1, 66463, '\p{ Is_UGAR}', "");
    Expect(0, 66463, '\p{^ Is_UGAR}', "");
    Expect(0, 66463, '\P{ Is_UGAR}', "");
    Expect(1, 66463, '\P{^ Is_UGAR}', "");
    Expect(0, 66464, '\p{ Is_UGAR}', "");
    Expect(1, 66464, '\p{^ Is_UGAR}', "");
    Expect(1, 66464, '\P{ Is_UGAR}', "");
    Expect(0, 66464, '\P{^ Is_UGAR}', "");
    Error('\p{--Unassigned/a/}');
    Error('\P{--Unassigned/a/}');
    Expect(1, 918000, '\p{unassigned}', "");
    Expect(0, 918000, '\p{^unassigned}', "");
    Expect(0, 918000, '\P{unassigned}', "");
    Expect(1, 918000, '\P{^unassigned}', "");
    Expect(0, 1114109, '\p{unassigned}', "");
    Expect(1, 1114109, '\p{^unassigned}', "");
    Expect(1, 1114109, '\P{unassigned}', "");
    Expect(0, 1114109, '\P{^unassigned}', "");
    Expect(1, 918000, '\p{Unassigned}', "");
    Expect(0, 918000, '\p{^Unassigned}', "");
    Expect(0, 918000, '\P{Unassigned}', "");
    Expect(1, 918000, '\P{^Unassigned}', "");
    Expect(0, 1114109, '\p{Unassigned}', "");
    Expect(1, 1114109, '\p{^Unassigned}', "");
    Expect(1, 1114109, '\P{Unassigned}', "");
    Expect(0, 1114109, '\P{^Unassigned}', "");
    Error('\p{	-is_Unassigned/a/}');
    Error('\P{	-is_Unassigned/a/}');
    Expect(1, 918000, '\p{isunassigned}', "");
    Expect(0, 918000, '\p{^isunassigned}', "");
    Expect(0, 918000, '\P{isunassigned}', "");
    Expect(1, 918000, '\P{^isunassigned}', "");
    Expect(0, 1114109, '\p{isunassigned}', "");
    Expect(1, 1114109, '\p{^isunassigned}', "");
    Expect(1, 1114109, '\P{isunassigned}', "");
    Expect(0, 1114109, '\P{^isunassigned}', "");
    Expect(1, 918000, '\p{ Is_UNASSIGNED}', "");
    Expect(0, 918000, '\p{^ Is_UNASSIGNED}', "");
    Expect(0, 918000, '\P{ Is_UNASSIGNED}', "");
    Expect(1, 918000, '\P{^ Is_UNASSIGNED}', "");
    Expect(0, 1114109, '\p{ Is_UNASSIGNED}', "");
    Expect(1, 1114109, '\p{^ Is_UNASSIGNED}', "");
    Expect(1, 1114109, '\P{ Is_UNASSIGNED}', "");
    Expect(0, 1114109, '\P{^ Is_UNASSIGNED}', "");
    Error('\p{/a/Cn}');
    Error('\P{/a/Cn}');
    Expect(1, 918000, '\p{cn}', "");
    Expect(0, 918000, '\p{^cn}', "");
    Expect(0, 918000, '\P{cn}', "");
    Expect(1, 918000, '\P{^cn}', "");
    Expect(0, 1114109, '\p{cn}', "");
    Expect(1, 1114109, '\p{^cn}', "");
    Expect(1, 1114109, '\P{cn}', "");
    Expect(0, 1114109, '\P{^cn}', "");
    Expect(1, 918000, '\p{_	Cn}', "");
    Expect(0, 918000, '\p{^_	Cn}', "");
    Expect(0, 918000, '\P{_	Cn}', "");
    Expect(1, 918000, '\P{^_	Cn}', "");
    Expect(0, 1114109, '\p{_	Cn}', "");
    Expect(1, 1114109, '\p{^_	Cn}', "");
    Expect(1, 1114109, '\P{_	Cn}', "");
    Expect(0, 1114109, '\P{^_	Cn}', "");
    Error('\p{	-IS_cn/a/}');
    Error('\P{	-IS_cn/a/}');
    Expect(1, 918000, '\p{iscn}', "");
    Expect(0, 918000, '\p{^iscn}', "");
    Expect(0, 918000, '\P{iscn}', "");
    Expect(1, 918000, '\P{^iscn}', "");
    Expect(0, 1114109, '\p{iscn}', "");
    Expect(1, 1114109, '\p{^iscn}', "");
    Expect(1, 1114109, '\P{iscn}', "");
    Expect(0, 1114109, '\P{^iscn}', "");
    Expect(1, 918000, '\p{_is_Cn}', "");
    Expect(0, 918000, '\p{^_is_Cn}', "");
    Expect(0, 918000, '\P{_is_Cn}', "");
    Expect(1, 918000, '\P{^_is_Cn}', "");
    Expect(0, 1114109, '\p{_is_Cn}', "");
    Expect(1, 1114109, '\p{^_is_Cn}', "");
    Expect(1, 1114109, '\P{_is_Cn}', "");
    Expect(0, 1114109, '\P{^_is_Cn}', "");
    Error('\p{	 unified_CANADIAN_Aboriginal_SYLLABICS:=}');
    Error('\P{	 unified_CANADIAN_Aboriginal_SYLLABICS:=}');
    Expect(1, 5759, '\p{unifiedcanadianaboriginalsyllabics}', "");
    Expect(0, 5759, '\p{^unifiedcanadianaboriginalsyllabics}', "");
    Expect(0, 5759, '\P{unifiedcanadianaboriginalsyllabics}', "");
    Expect(1, 5759, '\P{^unifiedcanadianaboriginalsyllabics}', "");
    Expect(0, 5760, '\p{unifiedcanadianaboriginalsyllabics}', "");
    Expect(1, 5760, '\p{^unifiedcanadianaboriginalsyllabics}', "");
    Expect(1, 5760, '\P{unifiedcanadianaboriginalsyllabics}', "");
    Expect(0, 5760, '\P{^unifiedcanadianaboriginalsyllabics}', "");
    Expect(1, 5759, '\p{-unified_Canadian_aboriginal_syllabics}', "");
    Expect(0, 5759, '\p{^-unified_Canadian_aboriginal_syllabics}', "");
    Expect(0, 5759, '\P{-unified_Canadian_aboriginal_syllabics}', "");
    Expect(1, 5759, '\P{^-unified_Canadian_aboriginal_syllabics}', "");
    Expect(0, 5760, '\p{-unified_Canadian_aboriginal_syllabics}', "");
    Expect(1, 5760, '\p{^-unified_Canadian_aboriginal_syllabics}', "");
    Expect(1, 5760, '\P{-unified_Canadian_aboriginal_syllabics}', "");
    Expect(0, 5760, '\P{^-unified_Canadian_aboriginal_syllabics}', "");
    Error('\p{/a/-_IS_Unified_canadian_ABORIGINAL_Syllabics}');
    Error('\P{/a/-_IS_Unified_canadian_ABORIGINAL_Syllabics}');
    Expect(1, 5759, '\p{isunifiedcanadianaboriginalsyllabics}', "");
    Expect(0, 5759, '\p{^isunifiedcanadianaboriginalsyllabics}', "");
    Expect(0, 5759, '\P{isunifiedcanadianaboriginalsyllabics}', "");
    Expect(1, 5759, '\P{^isunifiedcanadianaboriginalsyllabics}', "");
    Expect(0, 5760, '\p{isunifiedcanadianaboriginalsyllabics}', "");
    Expect(1, 5760, '\p{^isunifiedcanadianaboriginalsyllabics}', "");
    Expect(1, 5760, '\P{isunifiedcanadianaboriginalsyllabics}', "");
    Expect(0, 5760, '\P{^isunifiedcanadianaboriginalsyllabics}', "");
    Expect(1, 5759, '\p{  is_Unified_Canadian_aboriginal_Syllabics}', "");
    Expect(0, 5759, '\p{^  is_Unified_Canadian_aboriginal_Syllabics}', "");
    Expect(0, 5759, '\P{  is_Unified_Canadian_aboriginal_Syllabics}', "");
    Expect(1, 5759, '\P{^  is_Unified_Canadian_aboriginal_Syllabics}', "");
    Expect(0, 5760, '\p{  is_Unified_Canadian_aboriginal_Syllabics}', "");
    Expect(1, 5760, '\p{^  is_Unified_Canadian_aboriginal_Syllabics}', "");
    Expect(1, 5760, '\P{  is_Unified_Canadian_aboriginal_Syllabics}', "");
    Expect(0, 5760, '\P{^  is_Unified_Canadian_aboriginal_Syllabics}', "");
    Error('\p{	_In_Unified_canadian_aboriginal_syllabics:=}');
    Error('\P{	_In_Unified_canadian_aboriginal_syllabics:=}');
    Expect(1, 5759, '\p{inunifiedcanadianaboriginalsyllabics}', "");
    Expect(0, 5759, '\p{^inunifiedcanadianaboriginalsyllabics}', "");
    Expect(0, 5759, '\P{inunifiedcanadianaboriginalsyllabics}', "");
    Expect(1, 5759, '\P{^inunifiedcanadianaboriginalsyllabics}', "");
    Expect(0, 5760, '\p{inunifiedcanadianaboriginalsyllabics}', "");
    Expect(1, 5760, '\p{^inunifiedcanadianaboriginalsyllabics}', "");
    Expect(1, 5760, '\P{inunifiedcanadianaboriginalsyllabics}', "");
    Expect(0, 5760, '\P{^inunifiedcanadianaboriginalsyllabics}', "");
    Expect(1, 5759, '\p{-In_unified_Canadian_Aboriginal_SYLLABICS}', "");
    Expect(0, 5759, '\p{^-In_unified_Canadian_Aboriginal_SYLLABICS}', "");
    Expect(0, 5759, '\P{-In_unified_Canadian_Aboriginal_SYLLABICS}', "");
    Expect(1, 5759, '\P{^-In_unified_Canadian_Aboriginal_SYLLABICS}', "");
    Expect(0, 5760, '\p{-In_unified_Canadian_Aboriginal_SYLLABICS}', "");
    Expect(1, 5760, '\p{^-In_unified_Canadian_Aboriginal_SYLLABICS}', "");
    Expect(1, 5760, '\P{-In_unified_Canadian_Aboriginal_SYLLABICS}', "");
    Expect(0, 5760, '\P{^-In_unified_Canadian_Aboriginal_SYLLABICS}', "");
    Error('\p{_/a/ucas}');
    Error('\P{_/a/ucas}');
    Expect(1, 5759, '\p{ucas}', "");
    Expect(0, 5759, '\p{^ucas}', "");
    Expect(0, 5759, '\P{ucas}', "");
    Expect(1, 5759, '\P{^ucas}', "");
    Expect(0, 5760, '\p{ucas}', "");
    Expect(1, 5760, '\p{^ucas}', "");
    Expect(1, 5760, '\P{ucas}', "");
    Expect(0, 5760, '\P{^ucas}', "");
    Expect(1, 5759, '\p{ 	UCAS}', "");
    Expect(0, 5759, '\p{^ 	UCAS}', "");
    Expect(0, 5759, '\P{ 	UCAS}', "");
    Expect(1, 5759, '\P{^ 	UCAS}', "");
    Expect(0, 5760, '\p{ 	UCAS}', "");
    Expect(1, 5760, '\p{^ 	UCAS}', "");
    Expect(1, 5760, '\P{ 	UCAS}', "");
    Expect(0, 5760, '\P{^ 	UCAS}', "");
    Error('\p{:=_IS_UCAS}');
    Error('\P{:=_IS_UCAS}');
    Expect(1, 5759, '\p{isucas}', "");
    Expect(0, 5759, '\p{^isucas}', "");
    Expect(0, 5759, '\P{isucas}', "");
    Expect(1, 5759, '\P{^isucas}', "");
    Expect(0, 5760, '\p{isucas}', "");
    Expect(1, 5760, '\p{^isucas}', "");
    Expect(1, 5760, '\P{isucas}', "");
    Expect(0, 5760, '\P{^isucas}', "");
    Expect(1, 5759, '\p{ _Is_ucas}', "");
    Expect(0, 5759, '\p{^ _Is_ucas}', "");
    Expect(0, 5759, '\P{ _Is_ucas}', "");
    Expect(1, 5759, '\P{^ _Is_ucas}', "");
    Expect(0, 5760, '\p{ _Is_ucas}', "");
    Expect(1, 5760, '\p{^ _Is_ucas}', "");
    Expect(1, 5760, '\P{ _Is_ucas}', "");
    Expect(0, 5760, '\P{^ _Is_ucas}', "");
    Error('\p{-IN_UCAS:=}');
    Error('\P{-IN_UCAS:=}');
    Expect(1, 5759, '\p{inucas}', "");
    Expect(0, 5759, '\p{^inucas}', "");
    Expect(0, 5759, '\P{inucas}', "");
    Expect(1, 5759, '\P{^inucas}', "");
    Expect(0, 5760, '\p{inucas}', "");
    Expect(1, 5760, '\p{^inucas}', "");
    Expect(1, 5760, '\P{inucas}', "");
    Expect(0, 5760, '\P{^inucas}', "");
    Expect(1, 5759, '\p{ In_UCAS}', "");
    Expect(0, 5759, '\p{^ In_UCAS}', "");
    Expect(0, 5759, '\P{ In_UCAS}', "");
    Expect(1, 5759, '\P{^ In_UCAS}', "");
    Expect(0, 5760, '\p{ In_UCAS}', "");
    Expect(1, 5760, '\p{^ In_UCAS}', "");
    Expect(1, 5760, '\P{ In_UCAS}', "");
    Expect(0, 5760, '\P{^ In_UCAS}', "");
    Error('\p{/a/		CANADIAN_Syllabics}');
    Error('\P{/a/		CANADIAN_Syllabics}');
    Expect(1, 5759, '\p{canadiansyllabics}', "");
    Expect(0, 5759, '\p{^canadiansyllabics}', "");
    Expect(0, 5759, '\P{canadiansyllabics}', "");
    Expect(1, 5759, '\P{^canadiansyllabics}', "");
    Expect(0, 5760, '\p{canadiansyllabics}', "");
    Expect(1, 5760, '\p{^canadiansyllabics}', "");
    Expect(1, 5760, '\P{canadiansyllabics}', "");
    Expect(0, 5760, '\P{^canadiansyllabics}', "");
    Expect(1, 5759, '\p{--CANADIAN_Syllabics}', "");
    Expect(0, 5759, '\p{^--CANADIAN_Syllabics}', "");
    Expect(0, 5759, '\P{--CANADIAN_Syllabics}', "");
    Expect(1, 5759, '\P{^--CANADIAN_Syllabics}', "");
    Expect(0, 5760, '\p{--CANADIAN_Syllabics}', "");
    Expect(1, 5760, '\p{^--CANADIAN_Syllabics}', "");
    Expect(1, 5760, '\P{--CANADIAN_Syllabics}', "");
    Expect(0, 5760, '\P{^--CANADIAN_Syllabics}', "");
    Error('\p{	-IS_Canadian_syllabics/a/}');
    Error('\P{	-IS_Canadian_syllabics/a/}');
    Expect(1, 5759, '\p{iscanadiansyllabics}', "");
    Expect(0, 5759, '\p{^iscanadiansyllabics}', "");
    Expect(0, 5759, '\P{iscanadiansyllabics}', "");
    Expect(1, 5759, '\P{^iscanadiansyllabics}', "");
    Expect(0, 5760, '\p{iscanadiansyllabics}', "");
    Expect(1, 5760, '\p{^iscanadiansyllabics}', "");
    Expect(1, 5760, '\P{iscanadiansyllabics}', "");
    Expect(0, 5760, '\P{^iscanadiansyllabics}', "");
    Expect(1, 5759, '\p{- IS_Canadian_Syllabics}', "");
    Expect(0, 5759, '\p{^- IS_Canadian_Syllabics}', "");
    Expect(0, 5759, '\P{- IS_Canadian_Syllabics}', "");
    Expect(1, 5759, '\P{^- IS_Canadian_Syllabics}', "");
    Expect(0, 5760, '\p{- IS_Canadian_Syllabics}', "");
    Expect(1, 5760, '\p{^- IS_Canadian_Syllabics}', "");
    Expect(1, 5760, '\P{- IS_Canadian_Syllabics}', "");
    Expect(0, 5760, '\P{^- IS_Canadian_Syllabics}', "");
    Error('\p{-/a/In_Canadian_SYLLABICS}');
    Error('\P{-/a/In_Canadian_SYLLABICS}');
    Expect(1, 5759, '\p{incanadiansyllabics}', "");
    Expect(0, 5759, '\p{^incanadiansyllabics}', "");
    Expect(0, 5759, '\P{incanadiansyllabics}', "");
    Expect(1, 5759, '\P{^incanadiansyllabics}', "");
    Expect(0, 5760, '\p{incanadiansyllabics}', "");
    Expect(1, 5760, '\p{^incanadiansyllabics}', "");
    Expect(1, 5760, '\P{incanadiansyllabics}', "");
    Expect(0, 5760, '\P{^incanadiansyllabics}', "");
    Expect(1, 5759, '\p{ In_canadian_Syllabics}', "");
    Expect(0, 5759, '\p{^ In_canadian_Syllabics}', "");
    Expect(0, 5759, '\P{ In_canadian_Syllabics}', "");
    Expect(1, 5759, '\P{^ In_canadian_Syllabics}', "");
    Expect(0, 5760, '\p{ In_canadian_Syllabics}', "");
    Expect(1, 5760, '\p{^ In_canadian_Syllabics}', "");
    Expect(1, 5760, '\P{ In_canadian_Syllabics}', "");
    Expect(0, 5760, '\P{^ In_canadian_Syllabics}', "");
    Error('\p{:=_UNIFIED_CANADIAN_aboriginal_SYLLABICS_extended}');
    Error('\P{:=_UNIFIED_CANADIAN_aboriginal_SYLLABICS_extended}');
    Expect(1, 6399, '\p{unifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(0, 6399, '\p{^unifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(0, 6399, '\P{unifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(1, 6399, '\P{^unifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(0, 6400, '\p{unifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(1, 6400, '\p{^unifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(1, 6400, '\P{unifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(0, 6400, '\P{^unifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(1, 6399, '\p{-Unified_CANADIAN_Aboriginal_SYLLABICS_Extended}', "");
    Expect(0, 6399, '\p{^-Unified_CANADIAN_Aboriginal_SYLLABICS_Extended}', "");
    Expect(0, 6399, '\P{-Unified_CANADIAN_Aboriginal_SYLLABICS_Extended}', "");
    Expect(1, 6399, '\P{^-Unified_CANADIAN_Aboriginal_SYLLABICS_Extended}', "");
    Expect(0, 6400, '\p{-Unified_CANADIAN_Aboriginal_SYLLABICS_Extended}', "");
    Expect(1, 6400, '\p{^-Unified_CANADIAN_Aboriginal_SYLLABICS_Extended}', "");
    Expect(1, 6400, '\P{-Unified_CANADIAN_Aboriginal_SYLLABICS_Extended}', "");
    Expect(0, 6400, '\P{^-Unified_CANADIAN_Aboriginal_SYLLABICS_Extended}', "");
    Error('\p{/a/ -is_UNIFIED_canadian_aboriginal_SYLLABICS_EXTENDED}');
    Error('\P{/a/ -is_UNIFIED_canadian_aboriginal_SYLLABICS_EXTENDED}');
    Expect(1, 6399, '\p{isunifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(0, 6399, '\p{^isunifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(0, 6399, '\P{isunifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(1, 6399, '\P{^isunifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(0, 6400, '\p{isunifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(1, 6400, '\p{^isunifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(1, 6400, '\P{isunifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(0, 6400, '\P{^isunifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(1, 6399, '\p{	Is_unified_canadian_ABORIGINAL_Syllabics_Extended}', "");
    Expect(0, 6399, '\p{^	Is_unified_canadian_ABORIGINAL_Syllabics_Extended}', "");
    Expect(0, 6399, '\P{	Is_unified_canadian_ABORIGINAL_Syllabics_Extended}', "");
    Expect(1, 6399, '\P{^	Is_unified_canadian_ABORIGINAL_Syllabics_Extended}', "");
    Expect(0, 6400, '\p{	Is_unified_canadian_ABORIGINAL_Syllabics_Extended}', "");
    Expect(1, 6400, '\p{^	Is_unified_canadian_ABORIGINAL_Syllabics_Extended}', "");
    Expect(1, 6400, '\P{	Is_unified_canadian_ABORIGINAL_Syllabics_Extended}', "");
    Expect(0, 6400, '\P{^	Is_unified_canadian_ABORIGINAL_Syllabics_Extended}', "");
    Error('\p{ In_UNIFIED_CANADIAN_ABORIGINAL_Syllabics_extended:=}');
    Error('\P{ In_UNIFIED_CANADIAN_ABORIGINAL_Syllabics_extended:=}');
    Expect(1, 6399, '\p{inunifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(0, 6399, '\p{^inunifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(0, 6399, '\P{inunifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(1, 6399, '\P{^inunifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(0, 6400, '\p{inunifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(1, 6400, '\p{^inunifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(1, 6400, '\P{inunifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(0, 6400, '\P{^inunifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(1, 6399, '\p{_ in_unified_CANADIAN_aboriginal_syllabics_Extended}', "");
    Expect(0, 6399, '\p{^_ in_unified_CANADIAN_aboriginal_syllabics_Extended}', "");
    Expect(0, 6399, '\P{_ in_unified_CANADIAN_aboriginal_syllabics_Extended}', "");
    Expect(1, 6399, '\P{^_ in_unified_CANADIAN_aboriginal_syllabics_Extended}', "");
    Expect(0, 6400, '\p{_ in_unified_CANADIAN_aboriginal_syllabics_Extended}', "");
    Expect(1, 6400, '\p{^_ in_unified_CANADIAN_aboriginal_syllabics_Extended}', "");
    Expect(1, 6400, '\P{_ in_unified_CANADIAN_aboriginal_syllabics_Extended}', "");
    Expect(0, 6400, '\P{^_ in_unified_CANADIAN_aboriginal_syllabics_Extended}', "");
    Error('\p{/a/ucas_ext}');
    Error('\P{/a/ucas_ext}');
    Expect(1, 6399, '\p{ucasext}', "");
    Expect(0, 6399, '\p{^ucasext}', "");
    Expect(0, 6399, '\P{ucasext}', "");
    Expect(1, 6399, '\P{^ucasext}', "");
    Expect(0, 6400, '\p{ucasext}', "");
    Expect(1, 6400, '\p{^ucasext}', "");
    Expect(1, 6400, '\P{ucasext}', "");
    Expect(0, 6400, '\P{^ucasext}', "");
    Expect(1, 6399, '\p{UCAS_EXT}', "");
    Expect(0, 6399, '\p{^UCAS_EXT}', "");
    Expect(0, 6399, '\P{UCAS_EXT}', "");
    Expect(1, 6399, '\P{^UCAS_EXT}', "");
    Expect(0, 6400, '\p{UCAS_EXT}', "");
    Expect(1, 6400, '\p{^UCAS_EXT}', "");
    Expect(1, 6400, '\P{UCAS_EXT}', "");
    Expect(0, 6400, '\P{^UCAS_EXT}', "");
    Error('\p{:=-	Is_ucas_Ext}');
    Error('\P{:=-	Is_ucas_Ext}');
    Expect(1, 6399, '\p{isucasext}', "");
    Expect(0, 6399, '\p{^isucasext}', "");
    Expect(0, 6399, '\P{isucasext}', "");
    Expect(1, 6399, '\P{^isucasext}', "");
    Expect(0, 6400, '\p{isucasext}', "");
    Expect(1, 6400, '\p{^isucasext}', "");
    Expect(1, 6400, '\P{isucasext}', "");
    Expect(0, 6400, '\P{^isucasext}', "");
    Expect(1, 6399, '\p{ -Is_UCAS_Ext}', "");
    Expect(0, 6399, '\p{^ -Is_UCAS_Ext}', "");
    Expect(0, 6399, '\P{ -Is_UCAS_Ext}', "");
    Expect(1, 6399, '\P{^ -Is_UCAS_Ext}', "");
    Expect(0, 6400, '\p{ -Is_UCAS_Ext}', "");
    Expect(1, 6400, '\p{^ -Is_UCAS_Ext}', "");
    Expect(1, 6400, '\P{ -Is_UCAS_Ext}', "");
    Expect(0, 6400, '\P{^ -Is_UCAS_Ext}', "");
    Error('\p{-_In_UCAS_ext/a/}');
    Error('\P{-_In_UCAS_ext/a/}');
    Expect(1, 6399, '\p{inucasext}', "");
    Expect(0, 6399, '\p{^inucasext}', "");
    Expect(0, 6399, '\P{inucasext}', "");
    Expect(1, 6399, '\P{^inucasext}', "");
    Expect(0, 6400, '\p{inucasext}', "");
    Expect(1, 6400, '\p{^inucasext}', "");
    Expect(1, 6400, '\P{inucasext}', "");
    Expect(0, 6400, '\P{^inucasext}', "");
    Expect(1, 6399, '\p{ 	In_ucas_Ext}', "");
    Expect(0, 6399, '\p{^ 	In_ucas_Ext}', "");
    Expect(0, 6399, '\P{ 	In_ucas_Ext}', "");
    Expect(1, 6399, '\P{^ 	In_ucas_Ext}', "");
    Expect(0, 6400, '\p{ 	In_ucas_Ext}', "");
    Expect(1, 6400, '\p{^ 	In_ucas_Ext}', "");
    Expect(1, 6400, '\P{ 	In_ucas_Ext}', "");
    Expect(0, 6400, '\P{^ 	In_ucas_Ext}', "");
    Error('\p{_:=Unified_Canadian_aboriginal_Syllabics_Extended_a}');
    Error('\P{_:=Unified_Canadian_aboriginal_Syllabics_Extended_a}');
    Expect(1, 72383, '\p{unifiedcanadianaboriginalsyllabicsextendeda}', "");
    Expect(0, 72383, '\p{^unifiedcanadianaboriginalsyllabicsextendeda}', "");
    Expect(0, 72383, '\P{unifiedcanadianaboriginalsyllabicsextendeda}', "");
    Expect(1, 72383, '\P{^unifiedcanadianaboriginalsyllabicsextendeda}', "");
    Expect(0, 72384, '\p{unifiedcanadianaboriginalsyllabicsextendeda}', "");
    Expect(1, 72384, '\p{^unifiedcanadianaboriginalsyllabicsextendeda}', "");
    Expect(1, 72384, '\P{unifiedcanadianaboriginalsyllabicsextendeda}', "");
    Expect(0, 72384, '\P{^unifiedcanadianaboriginalsyllabicsextendeda}', "");
    Expect(1, 72383, '\p{-	UNIFIED_canadian_Aboriginal_SYLLABICS_Extended_A}', "");
    Expect(0, 72383, '\p{^-	UNIFIED_canadian_Aboriginal_SYLLABICS_Extended_A}', "");
    Expect(0, 72383, '\P{-	UNIFIED_canadian_Aboriginal_SYLLABICS_Extended_A}', "");
    Expect(1, 72383, '\P{^-	UNIFIED_canadian_Aboriginal_SYLLABICS_Extended_A}', "");
    Expect(0, 72384, '\p{-	UNIFIED_canadian_Aboriginal_SYLLABICS_Extended_A}', "");
    Expect(1, 72384, '\p{^-	UNIFIED_canadian_Aboriginal_SYLLABICS_Extended_A}', "");
    Expect(1, 72384, '\P{-	UNIFIED_canadian_Aboriginal_SYLLABICS_Extended_A}', "");
    Expect(0, 72384, '\P{^-	UNIFIED_canadian_Aboriginal_SYLLABICS_Extended_A}', "");
    Error('\p{/a/Is_Unified_Canadian_aboriginal_syllabics_extended_A}');
    Error('\P{/a/Is_Unified_Canadian_aboriginal_syllabics_extended_A}');
    Expect(1, 72383, '\p{isunifiedcanadianaboriginalsyllabicsextendeda}', "");
    Expect(0, 72383, '\p{^isunifiedcanadianaboriginalsyllabicsextendeda}', "");
    Expect(0, 72383, '\P{isunifiedcanadianaboriginalsyllabicsextendeda}', "");
    Expect(1, 72383, '\P{^isunifiedcanadianaboriginalsyllabicsextendeda}', "");
    Expect(0, 72384, '\p{isunifiedcanadianaboriginalsyllabicsextendeda}', "");
    Expect(1, 72384, '\p{^isunifiedcanadianaboriginalsyllabicsextendeda}', "");
    Expect(1, 72384, '\P{isunifiedcanadianaboriginalsyllabicsextendeda}', "");
    Expect(0, 72384, '\P{^isunifiedcanadianaboriginalsyllabicsextendeda}', "");
    Expect(1, 72383, '\p{-_IS_UNIFIED_CANADIAN_aboriginal_Syllabics_extended_a}', "");
    Expect(0, 72383, '\p{^-_IS_UNIFIED_CANADIAN_aboriginal_Syllabics_extended_a}', "");
    Expect(0, 72383, '\P{-_IS_UNIFIED_CANADIAN_aboriginal_Syllabics_extended_a}', "");
    Expect(1, 72383, '\P{^-_IS_UNIFIED_CANADIAN_aboriginal_Syllabics_extended_a}', "");
    Expect(0, 72384, '\p{-_IS_UNIFIED_CANADIAN_aboriginal_Syllabics_extended_a}', "");
    Expect(1, 72384, '\p{^-_IS_UNIFIED_CANADIAN_aboriginal_Syllabics_extended_a}', "");
    Expect(1, 72384, '\P{-_IS_UNIFIED_CANADIAN_aboriginal_Syllabics_extended_a}', "");
    Expect(0, 72384, '\P{^-_IS_UNIFIED_CANADIAN_aboriginal_Syllabics_extended_a}', "");
    Error('\p{:=-	in_unified_Canadian_ABORIGINAL_Syllabics_Extended_A}');
    Error('\P{:=-	in_unified_Canadian_ABORIGINAL_Syllabics_Extended_A}');
    Expect(1, 72383, '\p{inunifiedcanadianaboriginalsyllabicsextendeda}', "");
    Expect(0, 72383, '\p{^inunifiedcanadianaboriginalsyllabicsextendeda}', "");
    Expect(0, 72383, '\P{inunifiedcanadianaboriginalsyllabicsextendeda}', "");
    Expect(1, 72383, '\P{^inunifiedcanadianaboriginalsyllabicsextendeda}', "");
    Expect(0, 72384, '\p{inunifiedcanadianaboriginalsyllabicsextendeda}', "");
    Expect(1, 72384, '\p{^inunifiedcanadianaboriginalsyllabicsextendeda}', "");
    Expect(1, 72384, '\P{inunifiedcanadianaboriginalsyllabicsextendeda}', "");
    Expect(0, 72384, '\P{^inunifiedcanadianaboriginalsyllabicsextendeda}', "");
    Expect(1, 72383, '\p{ 	in_Unified_Canadian_Aboriginal_syllabics_EXTENDED_a}', "");
    Expect(0, 72383, '\p{^ 	in_Unified_Canadian_Aboriginal_syllabics_EXTENDED_a}', "");
    Expect(0, 72383, '\P{ 	in_Unified_Canadian_Aboriginal_syllabics_EXTENDED_a}', "");
    Expect(1, 72383, '\P{^ 	in_Unified_Canadian_Aboriginal_syllabics_EXTENDED_a}', "");
    Expect(0, 72384, '\p{ 	in_Unified_Canadian_Aboriginal_syllabics_EXTENDED_a}', "");
    Expect(1, 72384, '\p{^ 	in_Unified_Canadian_Aboriginal_syllabics_EXTENDED_a}', "");
    Expect(1, 72384, '\P{ 	in_Unified_Canadian_Aboriginal_syllabics_EXTENDED_a}', "");
    Expect(0, 72384, '\P{^ 	in_Unified_Canadian_Aboriginal_syllabics_EXTENDED_a}', "");
    Error('\p{ /a/UCAS_Ext_a}');
    Error('\P{ /a/UCAS_Ext_a}');
    Expect(1, 72383, '\p{ucasexta}', "");
    Expect(0, 72383, '\p{^ucasexta}', "");
    Expect(0, 72383, '\P{ucasexta}', "");
    Expect(1, 72383, '\P{^ucasexta}', "");
    Expect(0, 72384, '\p{ucasexta}', "");
    Expect(1, 72384, '\p{^ucasexta}', "");
    Expect(1, 72384, '\P{ucasexta}', "");
    Expect(0, 72384, '\P{^ucasexta}', "");
    Expect(1, 72383, '\p{_	UCAS_Ext_A}', "");
    Expect(0, 72383, '\p{^_	UCAS_Ext_A}', "");
    Expect(0, 72383, '\P{_	UCAS_Ext_A}', "");
    Expect(1, 72383, '\P{^_	UCAS_Ext_A}', "");
    Expect(0, 72384, '\p{_	UCAS_Ext_A}', "");
    Expect(1, 72384, '\p{^_	UCAS_Ext_A}', "");
    Expect(1, 72384, '\P{_	UCAS_Ext_A}', "");
    Expect(0, 72384, '\P{^_	UCAS_Ext_A}', "");
    Error('\p{	IS_UCAS_ext_A:=}');
    Error('\P{	IS_UCAS_ext_A:=}');
    Expect(1, 72383, '\p{isucasexta}', "");
    Expect(0, 72383, '\p{^isucasexta}', "");
    Expect(0, 72383, '\P{isucasexta}', "");
    Expect(1, 72383, '\P{^isucasexta}', "");
    Expect(0, 72384, '\p{isucasexta}', "");
    Expect(1, 72384, '\p{^isucasexta}', "");
    Expect(1, 72384, '\P{isucasexta}', "");
    Expect(0, 72384, '\P{^isucasexta}', "");
    Expect(1, 72383, '\p{	 Is_UCAS_EXT_A}', "");
    Expect(0, 72383, '\p{^	 Is_UCAS_EXT_A}', "");
    Expect(0, 72383, '\P{	 Is_UCAS_EXT_A}', "");
    Expect(1, 72383, '\P{^	 Is_UCAS_EXT_A}', "");
    Expect(0, 72384, '\p{	 Is_UCAS_EXT_A}', "");
    Expect(1, 72384, '\p{^	 Is_UCAS_EXT_A}', "");
    Expect(1, 72384, '\P{	 Is_UCAS_EXT_A}', "");
    Expect(0, 72384, '\P{^	 Is_UCAS_EXT_A}', "");
    Error('\p{-:=in_UCAS_ext_A}');
    Error('\P{-:=in_UCAS_ext_A}');
    Expect(1, 72383, '\p{inucasexta}', "");
    Expect(0, 72383, '\p{^inucasexta}', "");
    Expect(0, 72383, '\P{inucasexta}', "");
    Expect(1, 72383, '\P{^inucasexta}', "");
    Expect(0, 72384, '\p{inucasexta}', "");
    Expect(1, 72384, '\p{^inucasexta}', "");
    Expect(1, 72384, '\P{inucasexta}', "");
    Expect(0, 72384, '\P{^inucasexta}', "");
    Expect(1, 72383, '\p{-_IN_UCAS_Ext_A}', "");
    Expect(0, 72383, '\p{^-_IN_UCAS_Ext_A}', "");
    Expect(0, 72383, '\P{-_IN_UCAS_Ext_A}', "");
    Expect(1, 72383, '\P{^-_IN_UCAS_Ext_A}', "");
    Expect(0, 72384, '\p{-_IN_UCAS_Ext_A}', "");
    Expect(1, 72384, '\p{^-_IN_UCAS_Ext_A}', "");
    Expect(1, 72384, '\P{-_IN_UCAS_Ext_A}', "");
    Expect(0, 72384, '\P{^-_IN_UCAS_Ext_A}', "");
    Error('\p{/a/_Unified_ideograph}');
    Error('\P{/a/_Unified_ideograph}');
    Expect(1, 205743, '\p{unifiedideograph}', "");
    Expect(0, 205743, '\p{^unifiedideograph}', "");
    Expect(0, 205743, '\P{unifiedideograph}', "");
    Expect(1, 205743, '\P{^unifiedideograph}', "");
    Expect(0, 205744, '\p{unifiedideograph}', "");
    Expect(1, 205744, '\p{^unifiedideograph}', "");
    Expect(1, 205744, '\P{unifiedideograph}', "");
    Expect(0, 205744, '\P{^unifiedideograph}', "");
    Expect(1, 205743, '\p{--Unified_ideograph}', "");
    Expect(0, 205743, '\p{^--Unified_ideograph}', "");
    Expect(0, 205743, '\P{--Unified_ideograph}', "");
    Expect(1, 205743, '\P{^--Unified_ideograph}', "");
    Expect(0, 205744, '\p{--Unified_ideograph}', "");
    Expect(1, 205744, '\p{^--Unified_ideograph}', "");
    Expect(1, 205744, '\P{--Unified_ideograph}', "");
    Expect(0, 205744, '\P{^--Unified_ideograph}', "");
    Error('\p{_:=is_UNIFIED_ideograph}');
    Error('\P{_:=is_UNIFIED_ideograph}');
    Expect(1, 205743, '\p{isunifiedideograph}', "");
    Expect(0, 205743, '\p{^isunifiedideograph}', "");
    Expect(0, 205743, '\P{isunifiedideograph}', "");
    Expect(1, 205743, '\P{^isunifiedideograph}', "");
    Expect(0, 205744, '\p{isunifiedideograph}', "");
    Expect(1, 205744, '\p{^isunifiedideograph}', "");
    Expect(1, 205744, '\P{isunifiedideograph}', "");
    Expect(0, 205744, '\P{^isunifiedideograph}', "");
    Expect(1, 205743, '\p{	 is_unified_IDEOGRAPH}', "");
    Expect(0, 205743, '\p{^	 is_unified_IDEOGRAPH}', "");
    Expect(0, 205743, '\P{	 is_unified_IDEOGRAPH}', "");
    Expect(1, 205743, '\P{^	 is_unified_IDEOGRAPH}', "");
    Expect(0, 205744, '\p{	 is_unified_IDEOGRAPH}', "");
    Expect(1, 205744, '\p{^	 is_unified_IDEOGRAPH}', "");
    Expect(1, 205744, '\P{	 is_unified_IDEOGRAPH}', "");
    Expect(0, 205744, '\P{^	 is_unified_IDEOGRAPH}', "");
    Error('\p{/a/  UIdeo}');
    Error('\P{/a/  UIdeo}');
    Expect(1, 205743, '\p{uideo}', "");
    Expect(0, 205743, '\p{^uideo}', "");
    Expect(0, 205743, '\P{uideo}', "");
    Expect(1, 205743, '\P{^uideo}', "");
    Expect(0, 205744, '\p{uideo}', "");
    Expect(1, 205744, '\p{^uideo}', "");
    Expect(1, 205744, '\P{uideo}', "");
    Expect(0, 205744, '\P{^uideo}', "");
    Expect(1, 205743, '\p{	uideo}', "");
    Expect(0, 205743, '\p{^	uideo}', "");
    Expect(0, 205743, '\P{	uideo}', "");
    Expect(1, 205743, '\P{^	uideo}', "");
    Expect(0, 205744, '\p{	uideo}', "");
    Expect(1, 205744, '\p{^	uideo}', "");
    Expect(1, 205744, '\P{	uideo}', "");
    Expect(0, 205744, '\P{^	uideo}', "");
    Error('\p{_is_UIDEO:=}');
    Error('\P{_is_UIDEO:=}');
    Expect(1, 205743, '\p{isuideo}', "");
    Expect(0, 205743, '\p{^isuideo}', "");
    Expect(0, 205743, '\P{isuideo}', "");
    Expect(1, 205743, '\P{^isuideo}', "");
    Expect(0, 205744, '\p{isuideo}', "");
    Expect(1, 205744, '\p{^isuideo}', "");
    Expect(1, 205744, '\P{isuideo}', "");
    Expect(0, 205744, '\P{^isuideo}', "");
    Expect(1, 205743, '\p{  Is_uideo}', "");
    Expect(0, 205743, '\p{^  Is_uideo}', "");
    Expect(0, 205743, '\P{  Is_uideo}', "");
    Expect(1, 205743, '\P{^  Is_uideo}', "");
    Expect(0, 205744, '\p{  Is_uideo}', "");
    Expect(1, 205744, '\p{^  Is_uideo}', "");
    Expect(1, 205744, '\P{  Is_uideo}', "");
    Expect(0, 205744, '\P{^  Is_uideo}', "");
    Error('\p{:=- unknown}');
    Error('\P{:=- unknown}');
    Expect(1, 918000, '\p{unknown}', "");
    Expect(0, 918000, '\p{^unknown}', "");
    Expect(0, 918000, '\P{unknown}', "");
    Expect(1, 918000, '\P{^unknown}', "");
    Expect(0, 917999, '\p{unknown}', "");
    Expect(1, 917999, '\p{^unknown}', "");
    Expect(1, 917999, '\P{unknown}', "");
    Expect(0, 917999, '\P{^unknown}', "");
    Expect(1, 918000, '\p{ _UNKNOWN}', "");
    Expect(0, 918000, '\p{^ _UNKNOWN}', "");
    Expect(0, 918000, '\P{ _UNKNOWN}', "");
    Expect(1, 918000, '\P{^ _UNKNOWN}', "");
    Expect(0, 917999, '\p{ _UNKNOWN}', "");
    Expect(1, 917999, '\p{^ _UNKNOWN}', "");
    Expect(1, 917999, '\P{ _UNKNOWN}', "");
    Expect(0, 917999, '\P{^ _UNKNOWN}', "");
    Error('\p{/a/Is_Unknown}');
    Error('\P{/a/Is_Unknown}');
    Expect(1, 918000, '\p{isunknown}', "");
    Expect(0, 918000, '\p{^isunknown}', "");
    Expect(0, 918000, '\P{isunknown}', "");
    Expect(1, 918000, '\P{^isunknown}', "");
    Expect(0, 917999, '\p{isunknown}', "");
    Expect(1, 917999, '\p{^isunknown}', "");
    Expect(1, 917999, '\P{isunknown}', "");
    Expect(0, 917999, '\P{^isunknown}', "");
    Expect(1, 918000, '\p{Is_Unknown}', "");
    Expect(0, 918000, '\p{^Is_Unknown}', "");
    Expect(0, 918000, '\P{Is_Unknown}', "");
    Expect(1, 918000, '\P{^Is_Unknown}', "");
    Expect(0, 917999, '\p{Is_Unknown}', "");
    Expect(1, 917999, '\p{^Is_Unknown}', "");
    Expect(1, 917999, '\P{Is_Unknown}', "");
    Expect(0, 917999, '\P{^Is_Unknown}', "");
    Error('\p{ -Zzzz/a/}');
    Error('\P{ -Zzzz/a/}');
    Expect(1, 918000, '\p{zzzz}', "");
    Expect(0, 918000, '\p{^zzzz}', "");
    Expect(0, 918000, '\P{zzzz}', "");
    Expect(1, 918000, '\P{^zzzz}', "");
    Expect(0, 917999, '\p{zzzz}', "");
    Expect(1, 917999, '\p{^zzzz}', "");
    Expect(1, 917999, '\P{zzzz}', "");
    Expect(0, 917999, '\P{^zzzz}', "");
    Expect(1, 918000, '\p{ 	zzzz}', "");
    Expect(0, 918000, '\p{^ 	zzzz}', "");
    Expect(0, 918000, '\P{ 	zzzz}', "");
    Expect(1, 918000, '\P{^ 	zzzz}', "");
    Expect(0, 917999, '\p{ 	zzzz}', "");
    Expect(1, 917999, '\p{^ 	zzzz}', "");
    Expect(1, 917999, '\P{ 	zzzz}', "");
    Expect(0, 917999, '\P{^ 	zzzz}', "");
    Error('\p{	IS_Zzzz/a/}');
    Error('\P{	IS_Zzzz/a/}');
    Expect(1, 918000, '\p{iszzzz}', "");
    Expect(0, 918000, '\p{^iszzzz}', "");
    Expect(0, 918000, '\P{iszzzz}', "");
    Expect(1, 918000, '\P{^iszzzz}', "");
    Expect(0, 917999, '\p{iszzzz}', "");
    Expect(1, 917999, '\p{^iszzzz}', "");
    Expect(1, 917999, '\P{iszzzz}', "");
    Expect(0, 917999, '\P{^iszzzz}', "");
    Expect(1, 918000, '\p{__Is_zzzz}', "");
    Expect(0, 918000, '\p{^__Is_zzzz}', "");
    Expect(0, 918000, '\P{__Is_zzzz}', "");
    Expect(1, 918000, '\P{^__Is_zzzz}', "");
    Expect(0, 917999, '\p{__Is_zzzz}', "");
    Expect(1, 917999, '\p{^__Is_zzzz}', "");
    Expect(1, 917999, '\P{__Is_zzzz}', "");
    Expect(0, 917999, '\P{^__Is_zzzz}', "");
    Error('\p{/a/_ Uppercase_Letter}');
    Error('\P{/a/_ Uppercase_Letter}');
    Expect(1, 125217, '\p{uppercaseletter}', "");
    Expect(0, 125217, '\p{^uppercaseletter}', "");
    Expect(0, 125217, '\P{uppercaseletter}', "");
    Expect(1, 125217, '\P{^uppercaseletter}', "");
    Expect(0, 125218, '\p{uppercaseletter}', "");
    Expect(1, 125218, '\p{^uppercaseletter}', "");
    Expect(1, 125218, '\P{uppercaseletter}', "");
    Expect(0, 125218, '\P{^uppercaseletter}', "");
    Expect(1, 125217, '\p{-	UPPERCASE_Letter}', "");
    Expect(0, 125217, '\p{^-	UPPERCASE_Letter}', "");
    Expect(0, 125217, '\P{-	UPPERCASE_Letter}', "");
    Expect(1, 125217, '\P{^-	UPPERCASE_Letter}', "");
    Expect(0, 125218, '\p{-	UPPERCASE_Letter}', "");
    Expect(1, 125218, '\p{^-	UPPERCASE_Letter}', "");
    Expect(1, 125218, '\P{-	UPPERCASE_Letter}', "");
    Expect(0, 125218, '\P{^-	UPPERCASE_Letter}', "");
    Error('\p{/a/is_Uppercase_Letter}');
    Error('\P{/a/is_Uppercase_Letter}');
    Expect(1, 125217, '\p{isuppercaseletter}', "");
    Expect(0, 125217, '\p{^isuppercaseletter}', "");
    Expect(0, 125217, '\P{isuppercaseletter}', "");
    Expect(1, 125217, '\P{^isuppercaseletter}', "");
    Expect(0, 125218, '\p{isuppercaseletter}', "");
    Expect(1, 125218, '\p{^isuppercaseletter}', "");
    Expect(1, 125218, '\P{isuppercaseletter}', "");
    Expect(0, 125218, '\P{^isuppercaseletter}', "");
    Expect(1, 125217, '\p{_-IS_Uppercase_Letter}', "");
    Expect(0, 125217, '\p{^_-IS_Uppercase_Letter}', "");
    Expect(0, 125217, '\P{_-IS_Uppercase_Letter}', "");
    Expect(1, 125217, '\P{^_-IS_Uppercase_Letter}', "");
    Expect(0, 125218, '\p{_-IS_Uppercase_Letter}', "");
    Expect(1, 125218, '\p{^_-IS_Uppercase_Letter}', "");
    Expect(1, 125218, '\P{_-IS_Uppercase_Letter}', "");
    Expect(0, 125218, '\P{^_-IS_Uppercase_Letter}', "");
    Error('\p{:=-	Lu}');
    Error('\P{:=-	Lu}');
    Expect(1, 125217, '\p{lu}', "");
    Expect(0, 125217, '\p{^lu}', "");
    Expect(0, 125217, '\P{lu}', "");
    Expect(1, 125217, '\P{^lu}', "");
    Expect(0, 125218, '\p{lu}', "");
    Expect(1, 125218, '\p{^lu}', "");
    Expect(1, 125218, '\P{lu}', "");
    Expect(0, 125218, '\P{^lu}', "");
    Expect(1, 125217, '\p{-lu}', "");
    Expect(0, 125217, '\p{^-lu}', "");
    Expect(0, 125217, '\P{-lu}', "");
    Expect(1, 125217, '\P{^-lu}', "");
    Expect(0, 125218, '\p{-lu}', "");
    Expect(1, 125218, '\p{^-lu}', "");
    Expect(1, 125218, '\P{-lu}', "");
    Expect(0, 125218, '\P{^-lu}', "");
    Error('\p{/a/-Is_Lu}');
    Error('\P{/a/-Is_Lu}');
    Expect(1, 125217, '\p{islu}', "");
    Expect(0, 125217, '\p{^islu}', "");
    Expect(0, 125217, '\P{islu}', "");
    Expect(1, 125217, '\P{^islu}', "");
    Expect(0, 125218, '\p{islu}', "");
    Expect(1, 125218, '\p{^islu}', "");
    Expect(1, 125218, '\P{islu}', "");
    Expect(0, 125218, '\P{^islu}', "");
    Expect(1, 125217, '\p{_Is_LU}', "");
    Expect(0, 125217, '\p{^_Is_LU}', "");
    Expect(0, 125217, '\P{_Is_LU}', "");
    Expect(1, 125217, '\P{^_Is_LU}', "");
    Expect(0, 125218, '\p{_Is_LU}', "");
    Expect(1, 125218, '\p{^_Is_LU}', "");
    Expect(1, 125218, '\P{_Is_LU}', "");
    Expect(0, 125218, '\P{^_Is_LU}', "");
    Error('\p{	/a/Vai}');
    Error('\P{	/a/Vai}');
    Expect(1, 42539, '\p{vai}', "");
    Expect(0, 42539, '\p{^vai}', "");
    Expect(0, 42539, '\P{vai}', "");
    Expect(1, 42539, '\P{^vai}', "");
    Expect(0, 42540, '\p{vai}', "");
    Expect(1, 42540, '\p{^vai}', "");
    Expect(1, 42540, '\P{vai}', "");
    Expect(0, 42540, '\P{^vai}', "");
    Expect(1, 42539, '\p{-_Vai}', "");
    Expect(0, 42539, '\p{^-_Vai}', "");
    Expect(0, 42539, '\P{-_Vai}', "");
    Expect(1, 42539, '\P{^-_Vai}', "");
    Expect(0, 42540, '\p{-_Vai}', "");
    Expect(1, 42540, '\p{^-_Vai}', "");
    Expect(1, 42540, '\P{-_Vai}', "");
    Expect(0, 42540, '\P{^-_Vai}', "");
    Error('\p{_/a/Is_Vai}');
    Error('\P{_/a/Is_Vai}');
    Expect(1, 42539, '\p{isvai}', "");
    Expect(0, 42539, '\p{^isvai}', "");
    Expect(0, 42539, '\P{isvai}', "");
    Expect(1, 42539, '\P{^isvai}', "");
    Expect(0, 42540, '\p{isvai}', "");
    Expect(1, 42540, '\p{^isvai}', "");
    Expect(1, 42540, '\P{isvai}', "");
    Expect(0, 42540, '\P{^isvai}', "");
    Expect(1, 42539, '\p{ is_Vai}', "");
    Expect(0, 42539, '\p{^ is_Vai}', "");
    Expect(0, 42539, '\P{ is_Vai}', "");
    Expect(1, 42539, '\P{^ is_Vai}', "");
    Expect(0, 42540, '\p{ is_Vai}', "");
    Expect(1, 42540, '\p{^ is_Vai}', "");
    Expect(1, 42540, '\P{ is_Vai}', "");
    Expect(0, 42540, '\P{^ is_Vai}', "");
    Error('\p{--VAII/a/}');
    Error('\P{--VAII/a/}');
    Expect(1, 42539, '\p{vaii}', "");
    Expect(0, 42539, '\p{^vaii}', "");
    Expect(0, 42539, '\P{vaii}', "");
    Expect(1, 42539, '\P{^vaii}', "");
    Expect(0, 42540, '\p{vaii}', "");
    Expect(1, 42540, '\p{^vaii}', "");
    Expect(1, 42540, '\P{vaii}', "");
    Expect(0, 42540, '\P{^vaii}', "");
    Expect(1, 42539, '\p{	 Vaii}', "");
    Expect(0, 42539, '\p{^	 Vaii}', "");
    Expect(0, 42539, '\P{	 Vaii}', "");
    Expect(1, 42539, '\P{^	 Vaii}', "");
    Expect(0, 42540, '\p{	 Vaii}', "");
    Expect(1, 42540, '\p{^	 Vaii}', "");
    Expect(1, 42540, '\P{	 Vaii}', "");
    Expect(0, 42540, '\P{^	 Vaii}', "");
    Error('\p{_	Is_Vaii:=}');
    Error('\P{_	Is_Vaii:=}');
    Expect(1, 42539, '\p{isvaii}', "");
    Expect(0, 42539, '\p{^isvaii}', "");
    Expect(0, 42539, '\P{isvaii}', "");
    Expect(1, 42539, '\P{^isvaii}', "");
    Expect(0, 42540, '\p{isvaii}', "");
    Expect(1, 42540, '\p{^isvaii}', "");
    Expect(1, 42540, '\P{isvaii}', "");
    Expect(0, 42540, '\P{^isvaii}', "");
    Expect(1, 42539, '\p{-Is_Vaii}', "");
    Expect(0, 42539, '\p{^-Is_Vaii}', "");
    Expect(0, 42539, '\P{-Is_Vaii}', "");
    Expect(1, 42539, '\P{^-Is_Vaii}', "");
    Expect(0, 42540, '\p{-Is_Vaii}', "");
    Expect(1, 42540, '\p{^-Is_Vaii}', "");
    Expect(1, 42540, '\P{-Is_Vaii}', "");
    Expect(0, 42540, '\P{^-Is_Vaii}', "");
    Error('\p{/a/__variation_SELECTOR}');
    Error('\P{/a/__variation_SELECTOR}');
    Expect(1, 917999, '\p{variationselector}', "");
    Expect(0, 917999, '\p{^variationselector}', "");
    Expect(0, 917999, '\P{variationselector}', "");
    Expect(1, 917999, '\P{^variationselector}', "");
    Expect(0, 918000, '\p{variationselector}', "");
    Expect(1, 918000, '\p{^variationselector}', "");
    Expect(1, 918000, '\P{variationselector}', "");
    Expect(0, 918000, '\P{^variationselector}', "");
    Expect(1, 917999, '\p{	 Variation_Selector}', "");
    Expect(0, 917999, '\p{^	 Variation_Selector}', "");
    Expect(0, 917999, '\P{	 Variation_Selector}', "");
    Expect(1, 917999, '\P{^	 Variation_Selector}', "");
    Expect(0, 918000, '\p{	 Variation_Selector}', "");
    Expect(1, 918000, '\p{^	 Variation_Selector}', "");
    Expect(1, 918000, '\P{	 Variation_Selector}', "");
    Expect(0, 918000, '\P{^	 Variation_Selector}', "");
    Error('\p{-:=IS_variation_Selector}');
    Error('\P{-:=IS_variation_Selector}');
    Expect(1, 917999, '\p{isvariationselector}', "");
    Expect(0, 917999, '\p{^isvariationselector}', "");
    Expect(0, 917999, '\P{isvariationselector}', "");
    Expect(1, 917999, '\P{^isvariationselector}', "");
    Expect(0, 918000, '\p{isvariationselector}', "");
    Expect(1, 918000, '\p{^isvariationselector}', "");
    Expect(1, 918000, '\P{isvariationselector}', "");
    Expect(0, 918000, '\P{^isvariationselector}', "");
    Expect(1, 917999, '\p{- IS_Variation_Selector}', "");
    Expect(0, 917999, '\p{^- IS_Variation_Selector}', "");
    Expect(0, 917999, '\P{- IS_Variation_Selector}', "");
    Expect(1, 917999, '\P{^- IS_Variation_Selector}', "");
    Expect(0, 918000, '\p{- IS_Variation_Selector}', "");
    Expect(1, 918000, '\p{^- IS_Variation_Selector}', "");
    Expect(1, 918000, '\P{- IS_Variation_Selector}', "");
    Expect(0, 918000, '\P{^- IS_Variation_Selector}', "");
    Error('\p{-VS:=}');
    Error('\P{-VS:=}');
    Expect(1, 917999, '\p{vs}', "");
    Expect(0, 917999, '\p{^vs}', "");
    Expect(0, 917999, '\P{vs}', "");
    Expect(1, 917999, '\P{^vs}', "");
    Expect(0, 918000, '\p{vs}', "");
    Expect(1, 918000, '\p{^vs}', "");
    Expect(1, 918000, '\P{vs}', "");
    Expect(0, 918000, '\P{^vs}', "");
    Expect(1, 917999, '\p{	_VS}', "");
    Expect(0, 917999, '\p{^	_VS}', "");
    Expect(0, 917999, '\P{	_VS}', "");
    Expect(1, 917999, '\P{^	_VS}', "");
    Expect(0, 918000, '\p{	_VS}', "");
    Expect(1, 918000, '\p{^	_VS}', "");
    Expect(1, 918000, '\P{	_VS}', "");
    Expect(0, 918000, '\P{^	_VS}', "");
    Error('\p{ _is_VS:=}');
    Error('\P{ _is_VS:=}');
    Expect(1, 917999, '\p{isvs}', "");
    Expect(0, 917999, '\p{^isvs}', "");
    Expect(0, 917999, '\P{isvs}', "");
    Expect(1, 917999, '\P{^isvs}', "");
    Expect(0, 918000, '\p{isvs}', "");
    Expect(1, 918000, '\p{^isvs}', "");
    Expect(1, 918000, '\P{isvs}', "");
    Expect(0, 918000, '\P{^isvs}', "");
    Expect(1, 917999, '\p{__Is_VS}', "");
    Expect(0, 917999, '\p{^__Is_VS}', "");
    Expect(0, 917999, '\P{__Is_VS}', "");
    Expect(1, 917999, '\P{^__Is_VS}', "");
    Expect(0, 918000, '\p{__Is_VS}', "");
    Expect(1, 918000, '\p{^__Is_VS}', "");
    Expect(1, 918000, '\P{__Is_VS}', "");
    Expect(0, 918000, '\P{^__Is_VS}', "");
    Error('\p{_/a/Variation_selectors}');
    Error('\P{_/a/Variation_selectors}');
    Expect(1, 65039, '\p{variationselectors}', "");
    Expect(0, 65039, '\p{^variationselectors}', "");
    Expect(0, 65039, '\P{variationselectors}', "");
    Expect(1, 65039, '\P{^variationselectors}', "");
    Expect(0, 65040, '\p{variationselectors}', "");
    Expect(1, 65040, '\p{^variationselectors}', "");
    Expect(1, 65040, '\P{variationselectors}', "");
    Expect(0, 65040, '\P{^variationselectors}', "");
    Expect(1, 65039, '\p{	variation_selectors}', "");
    Expect(0, 65039, '\p{^	variation_selectors}', "");
    Expect(0, 65039, '\P{	variation_selectors}', "");
    Expect(1, 65039, '\P{^	variation_selectors}', "");
    Expect(0, 65040, '\p{	variation_selectors}', "");
    Expect(1, 65040, '\p{^	variation_selectors}', "");
    Expect(1, 65040, '\P{	variation_selectors}', "");
    Expect(0, 65040, '\P{^	variation_selectors}', "");
    Error('\p{-_Is_variation_SELECTORS/a/}');
    Error('\P{-_Is_variation_SELECTORS/a/}');
    Expect(1, 65039, '\p{isvariationselectors}', "");
    Expect(0, 65039, '\p{^isvariationselectors}', "");
    Expect(0, 65039, '\P{isvariationselectors}', "");
    Expect(1, 65039, '\P{^isvariationselectors}', "");
    Expect(0, 65040, '\p{isvariationselectors}', "");
    Expect(1, 65040, '\p{^isvariationselectors}', "");
    Expect(1, 65040, '\P{isvariationselectors}', "");
    Expect(0, 65040, '\P{^isvariationselectors}', "");
    Expect(1, 65039, '\p{_-Is_Variation_Selectors}', "");
    Expect(0, 65039, '\p{^_-Is_Variation_Selectors}', "");
    Expect(0, 65039, '\P{_-Is_Variation_Selectors}', "");
    Expect(1, 65039, '\P{^_-Is_Variation_Selectors}', "");
    Expect(0, 65040, '\p{_-Is_Variation_Selectors}', "");
    Expect(1, 65040, '\p{^_-Is_Variation_Selectors}', "");
    Expect(1, 65040, '\P{_-Is_Variation_Selectors}', "");
    Expect(0, 65040, '\P{^_-Is_Variation_Selectors}', "");
    Error('\p{--In_Variation_Selectors/a/}');
    Error('\P{--In_Variation_Selectors/a/}');
    Expect(1, 65039, '\p{invariationselectors}', "");
    Expect(0, 65039, '\p{^invariationselectors}', "");
    Expect(0, 65039, '\P{invariationselectors}', "");
    Expect(1, 65039, '\P{^invariationselectors}', "");
    Expect(0, 65040, '\p{invariationselectors}', "");
    Expect(1, 65040, '\p{^invariationselectors}', "");
    Expect(1, 65040, '\P{invariationselectors}', "");
    Expect(0, 65040, '\P{^invariationselectors}', "");
    Expect(1, 65039, '\p{ _In_variation_SELECTORS}', "");
    Expect(0, 65039, '\p{^ _In_variation_SELECTORS}', "");
    Expect(0, 65039, '\P{ _In_variation_SELECTORS}', "");
    Expect(1, 65039, '\P{^ _In_variation_SELECTORS}', "");
    Expect(0, 65040, '\p{ _In_variation_SELECTORS}', "");
    Expect(1, 65040, '\p{^ _In_variation_SELECTORS}', "");
    Expect(1, 65040, '\P{ _In_variation_SELECTORS}', "");
    Expect(0, 65040, '\P{^ _In_variation_SELECTORS}', "");
    Error('\p{:=  IN_VS}');
    Error('\P{:=  IN_VS}');
    Expect(1, 65039, '\p{invs}', "");
    Expect(0, 65039, '\p{^invs}', "");
    Expect(0, 65039, '\P{invs}', "");
    Expect(1, 65039, '\P{^invs}', "");
    Expect(0, 65040, '\p{invs}', "");
    Expect(1, 65040, '\p{^invs}', "");
    Expect(1, 65040, '\P{invs}', "");
    Expect(0, 65040, '\P{^invs}', "");
    Expect(1, 65039, '\p{-_in_vs}', "");
    Expect(0, 65039, '\p{^-_in_vs}', "");
    Expect(0, 65039, '\P{-_in_vs}', "");
    Expect(1, 65039, '\P{^-_in_vs}', "");
    Expect(0, 65040, '\p{-_in_vs}', "");
    Expect(1, 65040, '\p{^-_in_vs}', "");
    Expect(1, 65040, '\P{-_in_vs}', "");
    Expect(0, 65040, '\P{^-_in_vs}', "");
    Error('\p{-Variation_Selectors_supplement:=}');
    Error('\P{-Variation_Selectors_supplement:=}');
    Expect(1, 917999, '\p{variationselectorssupplement}', "");
    Expect(0, 917999, '\p{^variationselectorssupplement}', "");
    Expect(0, 917999, '\P{variationselectorssupplement}', "");
    Expect(1, 917999, '\P{^variationselectorssupplement}', "");
    Expect(0, 918000, '\p{variationselectorssupplement}', "");
    Expect(1, 918000, '\p{^variationselectorssupplement}', "");
    Expect(1, 918000, '\P{variationselectorssupplement}', "");
    Expect(0, 918000, '\P{^variationselectorssupplement}', "");
    Expect(1, 917999, '\p{	 Variation_SELECTORS_SUPPLEMENT}', "");
    Expect(0, 917999, '\p{^	 Variation_SELECTORS_SUPPLEMENT}', "");
    Expect(0, 917999, '\P{	 Variation_SELECTORS_SUPPLEMENT}', "");
    Expect(1, 917999, '\P{^	 Variation_SELECTORS_SUPPLEMENT}', "");
    Expect(0, 918000, '\p{	 Variation_SELECTORS_SUPPLEMENT}', "");
    Expect(1, 918000, '\p{^	 Variation_SELECTORS_SUPPLEMENT}', "");
    Expect(1, 918000, '\P{	 Variation_SELECTORS_SUPPLEMENT}', "");
    Expect(0, 918000, '\P{^	 Variation_SELECTORS_SUPPLEMENT}', "");
    Error('\p{:=-	Is_Variation_SELECTORS_SUPPLEMENT}');
    Error('\P{:=-	Is_Variation_SELECTORS_SUPPLEMENT}');
    Expect(1, 917999, '\p{isvariationselectorssupplement}', "");
    Expect(0, 917999, '\p{^isvariationselectorssupplement}', "");
    Expect(0, 917999, '\P{isvariationselectorssupplement}', "");
    Expect(1, 917999, '\P{^isvariationselectorssupplement}', "");
    Expect(0, 918000, '\p{isvariationselectorssupplement}', "");
    Expect(1, 918000, '\p{^isvariationselectorssupplement}', "");
    Expect(1, 918000, '\P{isvariationselectorssupplement}', "");
    Expect(0, 918000, '\P{^isvariationselectorssupplement}', "");
    Expect(1, 917999, '\p{ IS_Variation_Selectors_Supplement}', "");
    Expect(0, 917999, '\p{^ IS_Variation_Selectors_Supplement}', "");
    Expect(0, 917999, '\P{ IS_Variation_Selectors_Supplement}', "");
    Expect(1, 917999, '\P{^ IS_Variation_Selectors_Supplement}', "");
    Expect(0, 918000, '\p{ IS_Variation_Selectors_Supplement}', "");
    Expect(1, 918000, '\p{^ IS_Variation_Selectors_Supplement}', "");
    Expect(1, 918000, '\P{ IS_Variation_Selectors_Supplement}', "");
    Expect(0, 918000, '\P{^ IS_Variation_Selectors_Supplement}', "");
    Error('\p{:= _In_VARIATION_Selectors_supplement}');
    Error('\P{:= _In_VARIATION_Selectors_supplement}');
    Expect(1, 917999, '\p{invariationselectorssupplement}', "");
    Expect(0, 917999, '\p{^invariationselectorssupplement}', "");
    Expect(0, 917999, '\P{invariationselectorssupplement}', "");
    Expect(1, 917999, '\P{^invariationselectorssupplement}', "");
    Expect(0, 918000, '\p{invariationselectorssupplement}', "");
    Expect(1, 918000, '\p{^invariationselectorssupplement}', "");
    Expect(1, 918000, '\P{invariationselectorssupplement}', "");
    Expect(0, 918000, '\P{^invariationselectorssupplement}', "");
    Expect(1, 917999, '\p{-in_VARIATION_Selectors_Supplement}', "");
    Expect(0, 917999, '\p{^-in_VARIATION_Selectors_Supplement}', "");
    Expect(0, 917999, '\P{-in_VARIATION_Selectors_Supplement}', "");
    Expect(1, 917999, '\P{^-in_VARIATION_Selectors_Supplement}', "");
    Expect(0, 918000, '\p{-in_VARIATION_Selectors_Supplement}', "");
    Expect(1, 918000, '\p{^-in_VARIATION_Selectors_Supplement}', "");
    Expect(1, 918000, '\P{-in_VARIATION_Selectors_Supplement}', "");
    Expect(0, 918000, '\P{^-in_VARIATION_Selectors_Supplement}', "");
    Error('\p{/a/	-vs_sup}');
    Error('\P{/a/	-vs_sup}');
    Expect(1, 917999, '\p{vssup}', "");
    Expect(0, 917999, '\p{^vssup}', "");
    Expect(0, 917999, '\P{vssup}', "");
    Expect(1, 917999, '\P{^vssup}', "");
    Expect(0, 918000, '\p{vssup}', "");
    Expect(1, 918000, '\p{^vssup}', "");
    Expect(1, 918000, '\P{vssup}', "");
    Expect(0, 918000, '\P{^vssup}', "");
    Expect(1, 917999, '\p{	vs_SUP}', "");
    Expect(0, 917999, '\p{^	vs_SUP}', "");
    Expect(0, 917999, '\P{	vs_SUP}', "");
    Expect(1, 917999, '\P{^	vs_SUP}', "");
    Expect(0, 918000, '\p{	vs_SUP}', "");
    Expect(1, 918000, '\p{^	vs_SUP}', "");
    Expect(1, 918000, '\P{	vs_SUP}', "");
    Expect(0, 918000, '\P{^	vs_SUP}', "");
    Error('\p{__IS_vs_Sup:=}');
    Error('\P{__IS_vs_Sup:=}');
    Expect(1, 917999, '\p{isvssup}', "");
    Expect(0, 917999, '\p{^isvssup}', "");
    Expect(0, 917999, '\P{isvssup}', "");
    Expect(1, 917999, '\P{^isvssup}', "");
    Expect(0, 918000, '\p{isvssup}', "");
    Expect(1, 918000, '\p{^isvssup}', "");
    Expect(1, 918000, '\P{isvssup}', "");
    Expect(0, 918000, '\P{^isvssup}', "");
    Expect(1, 917999, '\p{		Is_vs_Sup}', "");
    Expect(0, 917999, '\p{^		Is_vs_Sup}', "");
    Expect(0, 917999, '\P{		Is_vs_Sup}', "");
    Expect(1, 917999, '\P{^		Is_vs_Sup}', "");
    Expect(0, 918000, '\p{		Is_vs_Sup}', "");
    Expect(1, 918000, '\p{^		Is_vs_Sup}', "");
    Expect(1, 918000, '\P{		Is_vs_Sup}', "");
    Expect(0, 918000, '\P{^		Is_vs_Sup}', "");
    Error('\p{:= -in_VS_Sup}');
    Error('\P{:= -in_VS_Sup}');
    Expect(1, 917999, '\p{invssup}', "");
    Expect(0, 917999, '\p{^invssup}', "");
    Expect(0, 917999, '\P{invssup}', "");
    Expect(1, 917999, '\P{^invssup}', "");
    Expect(0, 918000, '\p{invssup}', "");
    Expect(1, 918000, '\p{^invssup}', "");
    Expect(1, 918000, '\P{invssup}', "");
    Expect(0, 918000, '\P{^invssup}', "");
    Expect(1, 917999, '\p{	_in_VS_sup}', "");
    Expect(0, 917999, '\p{^	_in_VS_sup}', "");
    Expect(0, 917999, '\P{	_in_VS_sup}', "");
    Expect(1, 917999, '\P{^	_in_VS_sup}', "");
    Expect(0, 918000, '\p{	_in_VS_sup}', "");
    Expect(1, 918000, '\p{^	_in_VS_sup}', "");
    Expect(1, 918000, '\P{	_in_VS_sup}', "");
    Expect(0, 918000, '\P{^	_in_VS_sup}', "");
    Error('\p{:=_	VEDIC_extensions}');
    Error('\P{:=_	VEDIC_extensions}');
    Expect(1, 7423, '\p{vedicextensions}', "");
    Expect(0, 7423, '\p{^vedicextensions}', "");
    Expect(0, 7423, '\P{vedicextensions}', "");
    Expect(1, 7423, '\P{^vedicextensions}', "");
    Expect(0, 7424, '\p{vedicextensions}', "");
    Expect(1, 7424, '\p{^vedicextensions}', "");
    Expect(1, 7424, '\P{vedicextensions}', "");
    Expect(0, 7424, '\P{^vedicextensions}', "");
    Expect(1, 7423, '\p{_	vedic_Extensions}', "");
    Expect(0, 7423, '\p{^_	vedic_Extensions}', "");
    Expect(0, 7423, '\P{_	vedic_Extensions}', "");
    Expect(1, 7423, '\P{^_	vedic_Extensions}', "");
    Expect(0, 7424, '\p{_	vedic_Extensions}', "");
    Expect(1, 7424, '\p{^_	vedic_Extensions}', "");
    Expect(1, 7424, '\P{_	vedic_Extensions}', "");
    Expect(0, 7424, '\P{^_	vedic_Extensions}', "");
    Error('\p{	_Is_VEDIC_extensions:=}');
    Error('\P{	_Is_VEDIC_extensions:=}');
    Expect(1, 7423, '\p{isvedicextensions}', "");
    Expect(0, 7423, '\p{^isvedicextensions}', "");
    Expect(0, 7423, '\P{isvedicextensions}', "");
    Expect(1, 7423, '\P{^isvedicextensions}', "");
    Expect(0, 7424, '\p{isvedicextensions}', "");
    Expect(1, 7424, '\p{^isvedicextensions}', "");
    Expect(1, 7424, '\P{isvedicextensions}', "");
    Expect(0, 7424, '\P{^isvedicextensions}', "");
    Expect(1, 7423, '\p{-	is_Vedic_EXTENSIONS}', "");
    Expect(0, 7423, '\p{^-	is_Vedic_EXTENSIONS}', "");
    Expect(0, 7423, '\P{-	is_Vedic_EXTENSIONS}', "");
    Expect(1, 7423, '\P{^-	is_Vedic_EXTENSIONS}', "");
    Expect(0, 7424, '\p{-	is_Vedic_EXTENSIONS}', "");
    Expect(1, 7424, '\p{^-	is_Vedic_EXTENSIONS}', "");
    Expect(1, 7424, '\P{-	is_Vedic_EXTENSIONS}', "");
    Expect(0, 7424, '\P{^-	is_Vedic_EXTENSIONS}', "");
    Error('\p{/a/	 in_Vedic_Extensions}');
    Error('\P{/a/	 in_Vedic_Extensions}');
    Expect(1, 7423, '\p{invedicextensions}', "");
    Expect(0, 7423, '\p{^invedicextensions}', "");
    Expect(0, 7423, '\P{invedicextensions}', "");
    Expect(1, 7423, '\P{^invedicextensions}', "");
    Expect(0, 7424, '\p{invedicextensions}', "");
    Expect(1, 7424, '\p{^invedicextensions}', "");
    Expect(1, 7424, '\P{invedicextensions}', "");
    Expect(0, 7424, '\P{^invedicextensions}', "");
    Expect(1, 7423, '\p{In_Vedic_Extensions}', "");
    Expect(0, 7423, '\p{^In_Vedic_Extensions}', "");
    Expect(0, 7423, '\P{In_Vedic_Extensions}', "");
    Expect(1, 7423, '\P{^In_Vedic_Extensions}', "");
    Expect(0, 7424, '\p{In_Vedic_Extensions}', "");
    Expect(1, 7424, '\p{^In_Vedic_Extensions}', "");
    Expect(1, 7424, '\P{In_Vedic_Extensions}', "");
    Expect(0, 7424, '\P{^In_Vedic_Extensions}', "");
    Error('\p{:=	_vedic_ext}');
    Error('\P{:=	_vedic_ext}');
    Expect(1, 7423, '\p{vedicext}', "");
    Expect(0, 7423, '\p{^vedicext}', "");
    Expect(0, 7423, '\P{vedicext}', "");
    Expect(1, 7423, '\P{^vedicext}', "");
    Expect(0, 7424, '\p{vedicext}', "");
    Expect(1, 7424, '\p{^vedicext}', "");
    Expect(1, 7424, '\P{vedicext}', "");
    Expect(0, 7424, '\P{^vedicext}', "");
    Expect(1, 7423, '\p{-Vedic_Ext}', "");
    Expect(0, 7423, '\p{^-Vedic_Ext}', "");
    Expect(0, 7423, '\P{-Vedic_Ext}', "");
    Expect(1, 7423, '\P{^-Vedic_Ext}', "");
    Expect(0, 7424, '\p{-Vedic_Ext}', "");
    Expect(1, 7424, '\p{^-Vedic_Ext}', "");
    Expect(1, 7424, '\P{-Vedic_Ext}', "");
    Expect(0, 7424, '\P{^-Vedic_Ext}', "");
    Error('\p{/a/-IS_Vedic_EXT}');
    Error('\P{/a/-IS_Vedic_EXT}');
    Expect(1, 7423, '\p{isvedicext}', "");
    Expect(0, 7423, '\p{^isvedicext}', "");
    Expect(0, 7423, '\P{isvedicext}', "");
    Expect(1, 7423, '\P{^isvedicext}', "");
    Expect(0, 7424, '\p{isvedicext}', "");
    Expect(1, 7424, '\p{^isvedicext}', "");
    Expect(1, 7424, '\P{isvedicext}', "");
    Expect(0, 7424, '\P{^isvedicext}', "");
    Expect(1, 7423, '\p{-_Is_Vedic_Ext}', "");
    Expect(0, 7423, '\p{^-_Is_Vedic_Ext}', "");
    Expect(0, 7423, '\P{-_Is_Vedic_Ext}', "");
    Expect(1, 7423, '\P{^-_Is_Vedic_Ext}', "");
    Expect(0, 7424, '\p{-_Is_Vedic_Ext}', "");
    Expect(1, 7424, '\p{^-_Is_Vedic_Ext}', "");
    Expect(1, 7424, '\P{-_Is_Vedic_Ext}', "");
    Expect(0, 7424, '\P{^-_Is_Vedic_Ext}', "");
    Error('\p{:=	 In_vedic_ext}');
    Error('\P{:=	 In_vedic_ext}');
    Expect(1, 7423, '\p{invedicext}', "");
    Expect(0, 7423, '\p{^invedicext}', "");
    Expect(0, 7423, '\P{invedicext}', "");
    Expect(1, 7423, '\P{^invedicext}', "");
    Expect(0, 7424, '\p{invedicext}', "");
    Expect(1, 7424, '\p{^invedicext}', "");
    Expect(1, 7424, '\P{invedicext}', "");
    Expect(0, 7424, '\P{^invedicext}', "");
    Expect(1, 7423, '\p{ 	In_vedic_Ext}', "");
    Expect(0, 7423, '\p{^ 	In_vedic_Ext}', "");
    Expect(0, 7423, '\P{ 	In_vedic_Ext}', "");
    Expect(1, 7423, '\P{^ 	In_vedic_Ext}', "");
    Expect(0, 7424, '\p{ 	In_vedic_Ext}', "");
    Expect(1, 7424, '\p{^ 	In_vedic_Ext}', "");
    Expect(1, 7424, '\P{ 	In_vedic_Ext}', "");
    Expect(0, 7424, '\P{^ 	In_vedic_Ext}', "");
    Error('\p{_-Vertical_Forms/a/}');
    Error('\P{_-Vertical_Forms/a/}');
    Expect(1, 65055, '\p{verticalforms}', "");
    Expect(0, 65055, '\p{^verticalforms}', "");
    Expect(0, 65055, '\P{verticalforms}', "");
    Expect(1, 65055, '\P{^verticalforms}', "");
    Expect(0, 65056, '\p{verticalforms}', "");
    Expect(1, 65056, '\p{^verticalforms}', "");
    Expect(1, 65056, '\P{verticalforms}', "");
    Expect(0, 65056, '\P{^verticalforms}', "");
    Expect(1, 65055, '\p{	_VERTICAL_Forms}', "");
    Expect(0, 65055, '\p{^	_VERTICAL_Forms}', "");
    Expect(0, 65055, '\P{	_VERTICAL_Forms}', "");
    Expect(1, 65055, '\P{^	_VERTICAL_Forms}', "");
    Expect(0, 65056, '\p{	_VERTICAL_Forms}', "");
    Expect(1, 65056, '\p{^	_VERTICAL_Forms}', "");
    Expect(1, 65056, '\P{	_VERTICAL_Forms}', "");
    Expect(0, 65056, '\P{^	_VERTICAL_Forms}', "");
    Error('\p{-/a/IS_Vertical_FORMS}');
    Error('\P{-/a/IS_Vertical_FORMS}');
    Expect(1, 65055, '\p{isverticalforms}', "");
    Expect(0, 65055, '\p{^isverticalforms}', "");
    Expect(0, 65055, '\P{isverticalforms}', "");
    Expect(1, 65055, '\P{^isverticalforms}', "");
    Expect(0, 65056, '\p{isverticalforms}', "");
    Expect(1, 65056, '\p{^isverticalforms}', "");
    Expect(1, 65056, '\P{isverticalforms}', "");
    Expect(0, 65056, '\P{^isverticalforms}', "");
    Expect(1, 65055, '\p{		is_VERTICAL_Forms}', "");
    Expect(0, 65055, '\p{^		is_VERTICAL_Forms}', "");
    Expect(0, 65055, '\P{		is_VERTICAL_Forms}', "");
    Expect(1, 65055, '\P{^		is_VERTICAL_Forms}', "");
    Expect(0, 65056, '\p{		is_VERTICAL_Forms}', "");
    Expect(1, 65056, '\p{^		is_VERTICAL_Forms}', "");
    Expect(1, 65056, '\P{		is_VERTICAL_Forms}', "");
    Expect(0, 65056, '\P{^		is_VERTICAL_Forms}', "");
    Error('\p{in_Vertical_forms:=}');
    Error('\P{in_Vertical_forms:=}');
    Expect(1, 65055, '\p{inverticalforms}', "");
    Expect(0, 65055, '\p{^inverticalforms}', "");
    Expect(0, 65055, '\P{inverticalforms}', "");
    Expect(1, 65055, '\P{^inverticalforms}', "");
    Expect(0, 65056, '\p{inverticalforms}', "");
    Expect(1, 65056, '\p{^inverticalforms}', "");
    Expect(1, 65056, '\P{inverticalforms}', "");
    Expect(0, 65056, '\P{^inverticalforms}', "");
    Expect(1, 65055, '\p{__In_Vertical_forms}', "");
    Expect(0, 65055, '\p{^__In_Vertical_forms}', "");
    Expect(0, 65055, '\P{__In_Vertical_forms}', "");
    Expect(1, 65055, '\P{^__In_Vertical_forms}', "");
    Expect(0, 65056, '\p{__In_Vertical_forms}', "");
    Expect(1, 65056, '\p{^__In_Vertical_forms}', "");
    Expect(1, 65056, '\P{__In_Vertical_forms}', "");
    Expect(0, 65056, '\P{^__In_Vertical_forms}', "");
    Error('\p{:=		VertSpace}');
    Error('\P{:=		VertSpace}');
    Expect(1, 8233, '\p{vertspace}', "");
    Expect(0, 8233, '\p{^vertspace}', "");
    Expect(0, 8233, '\P{vertspace}', "");
    Expect(1, 8233, '\P{^vertspace}', "");
    Expect(0, 8234, '\p{vertspace}', "");
    Expect(1, 8234, '\p{^vertspace}', "");
    Expect(1, 8234, '\P{vertspace}', "");
    Expect(0, 8234, '\P{^vertspace}', "");
    Expect(1, 8233, '\p{	VERTSPACE}', "");
    Expect(0, 8233, '\p{^	VERTSPACE}', "");
    Expect(0, 8233, '\P{	VERTSPACE}', "");
    Expect(1, 8233, '\P{^	VERTSPACE}', "");
    Expect(0, 8234, '\p{	VERTSPACE}', "");
    Expect(1, 8234, '\p{^	VERTSPACE}', "");
    Expect(1, 8234, '\P{	VERTSPACE}', "");
    Expect(0, 8234, '\P{^	VERTSPACE}', "");
    Error('\p{	-IS_VertSpace:=}');
    Error('\P{	-IS_VertSpace:=}');
    Expect(1, 8233, '\p{isvertspace}', "");
    Expect(0, 8233, '\p{^isvertspace}', "");
    Expect(0, 8233, '\P{isvertspace}', "");
    Expect(1, 8233, '\P{^isvertspace}', "");
    Expect(0, 8234, '\p{isvertspace}', "");
    Expect(1, 8234, '\p{^isvertspace}', "");
    Expect(1, 8234, '\P{isvertspace}', "");
    Expect(0, 8234, '\P{^isvertspace}', "");
    Expect(1, 8233, '\p{__is_VertSpace}', "");
    Expect(0, 8233, '\p{^__is_VertSpace}', "");
    Expect(0, 8233, '\P{__is_VertSpace}', "");
    Expect(1, 8233, '\P{^__is_VertSpace}', "");
    Expect(0, 8234, '\p{__is_VertSpace}', "");
    Expect(1, 8234, '\p{^__is_VertSpace}', "");
    Expect(1, 8234, '\P{__is_VertSpace}', "");
    Expect(0, 8234, '\P{^__is_VertSpace}', "");
    Error('\p{	/a/Vithkuqi}');
    Error('\P{	/a/Vithkuqi}');
    Expect(1, 67004, '\p{vithkuqi}', "");
    Expect(0, 67004, '\p{^vithkuqi}', "");
    Expect(0, 67004, '\P{vithkuqi}', "");
    Expect(1, 67004, '\P{^vithkuqi}', "");
    Expect(0, 67005, '\p{vithkuqi}', "");
    Expect(1, 67005, '\p{^vithkuqi}', "");
    Expect(1, 67005, '\P{vithkuqi}', "");
    Expect(0, 67005, '\P{^vithkuqi}', "");
    Expect(1, 67004, '\p{- vithkuqi}', "");
    Expect(0, 67004, '\p{^- vithkuqi}', "");
    Expect(0, 67004, '\P{- vithkuqi}', "");
    Expect(1, 67004, '\P{^- vithkuqi}', "");
    Expect(0, 67005, '\p{- vithkuqi}', "");
    Expect(1, 67005, '\p{^- vithkuqi}', "");
    Expect(1, 67005, '\P{- vithkuqi}', "");
    Expect(0, 67005, '\P{^- vithkuqi}', "");
    Error('\p{-	Is_Vithkuqi/a/}');
    Error('\P{-	Is_Vithkuqi/a/}');
    Expect(1, 67004, '\p{isvithkuqi}', "");
    Expect(0, 67004, '\p{^isvithkuqi}', "");
    Expect(0, 67004, '\P{isvithkuqi}', "");
    Expect(1, 67004, '\P{^isvithkuqi}', "");
    Expect(0, 67005, '\p{isvithkuqi}', "");
    Expect(1, 67005, '\p{^isvithkuqi}', "");
    Expect(1, 67005, '\P{isvithkuqi}', "");
    Expect(0, 67005, '\P{^isvithkuqi}', "");
    Expect(1, 67004, '\p{- is_Vithkuqi}', "");
    Expect(0, 67004, '\p{^- is_Vithkuqi}', "");
    Expect(0, 67004, '\P{- is_Vithkuqi}', "");
    Expect(1, 67004, '\P{^- is_Vithkuqi}', "");
    Expect(0, 67005, '\p{- is_Vithkuqi}', "");
    Expect(1, 67005, '\p{^- is_Vithkuqi}', "");
    Expect(1, 67005, '\P{- is_Vithkuqi}', "");
    Expect(0, 67005, '\P{^- is_Vithkuqi}', "");
    Error('\p{/a/-vith}');
    Error('\P{/a/-vith}');
    Expect(1, 67004, '\p{vith}', "");
    Expect(0, 67004, '\p{^vith}', "");
    Expect(0, 67004, '\P{vith}', "");
    Expect(1, 67004, '\P{^vith}', "");
    Expect(0, 67005, '\p{vith}', "");
    Expect(1, 67005, '\p{^vith}', "");
    Expect(1, 67005, '\P{vith}', "");
    Expect(0, 67005, '\P{^vith}', "");
    Expect(1, 67004, '\p{  Vith}', "");
    Expect(0, 67004, '\p{^  Vith}', "");
    Expect(0, 67004, '\P{  Vith}', "");
    Expect(1, 67004, '\P{^  Vith}', "");
    Expect(0, 67005, '\p{  Vith}', "");
    Expect(1, 67005, '\p{^  Vith}', "");
    Expect(1, 67005, '\P{  Vith}', "");
    Expect(0, 67005, '\P{^  Vith}', "");
    Error('\p{:=IS_Vith}');
    Error('\P{:=IS_Vith}');
    Expect(1, 67004, '\p{isvith}', "");
    Expect(0, 67004, '\p{^isvith}', "");
    Expect(0, 67004, '\P{isvith}', "");
    Expect(1, 67004, '\P{^isvith}', "");
    Expect(0, 67005, '\p{isvith}', "");
    Expect(1, 67005, '\p{^isvith}', "");
    Expect(1, 67005, '\P{isvith}', "");
    Expect(0, 67005, '\P{^isvith}', "");
    Expect(1, 67004, '\p{-IS_vith}', "");
    Expect(0, 67004, '\p{^-IS_vith}', "");
    Expect(0, 67004, '\P{-IS_vith}', "");
    Expect(1, 67004, '\P{^-IS_vith}', "");
    Expect(0, 67005, '\p{-IS_vith}', "");
    Expect(1, 67005, '\p{^-IS_vith}', "");
    Expect(1, 67005, '\P{-IS_vith}', "");
    Expect(0, 67005, '\P{^-IS_vith}', "");
    Error('\p{-WANCHO:=}');
    Error('\P{-WANCHO:=}');
    Expect(1, 123647, '\p{wancho}', "");
    Expect(0, 123647, '\p{^wancho}', "");
    Expect(0, 123647, '\P{wancho}', "");
    Expect(1, 123647, '\P{^wancho}', "");
    Expect(0, 123648, '\p{wancho}', "");
    Expect(1, 123648, '\p{^wancho}', "");
    Expect(1, 123648, '\P{wancho}', "");
    Expect(0, 123648, '\P{^wancho}', "");
    Expect(1, 123647, '\p{	WANCHO}', "");
    Expect(0, 123647, '\p{^	WANCHO}', "");
    Expect(0, 123647, '\P{	WANCHO}', "");
    Expect(1, 123647, '\P{^	WANCHO}', "");
    Expect(0, 123648, '\p{	WANCHO}', "");
    Expect(1, 123648, '\p{^	WANCHO}', "");
    Expect(1, 123648, '\P{	WANCHO}', "");
    Expect(0, 123648, '\P{^	WANCHO}', "");
    Error('\p{-	is_wancho/a/}');
    Error('\P{-	is_wancho/a/}');
    Expect(1, 123647, '\p{iswancho}', "");
    Expect(0, 123647, '\p{^iswancho}', "");
    Expect(0, 123647, '\P{iswancho}', "");
    Expect(1, 123647, '\P{^iswancho}', "");
    Expect(0, 123648, '\p{iswancho}', "");
    Expect(1, 123648, '\p{^iswancho}', "");
    Expect(1, 123648, '\P{iswancho}', "");
    Expect(0, 123648, '\P{^iswancho}', "");
    Expect(1, 123647, '\p{-	IS_WANCHO}', "");
    Expect(0, 123647, '\p{^-	IS_WANCHO}', "");
    Expect(0, 123647, '\P{-	IS_WANCHO}', "");
    Expect(1, 123647, '\P{^-	IS_WANCHO}', "");
    Expect(0, 123648, '\p{-	IS_WANCHO}', "");
    Expect(1, 123648, '\p{^-	IS_WANCHO}', "");
    Expect(1, 123648, '\P{-	IS_WANCHO}', "");
    Expect(0, 123648, '\P{^-	IS_WANCHO}', "");
    Error('\p{_	Wcho/a/}');
    Error('\P{_	Wcho/a/}');
    Expect(1, 123647, '\p{wcho}', "");
    Expect(0, 123647, '\p{^wcho}', "");
    Expect(0, 123647, '\P{wcho}', "");
    Expect(1, 123647, '\P{^wcho}', "");
    Expect(0, 123648, '\p{wcho}', "");
    Expect(1, 123648, '\p{^wcho}', "");
    Expect(1, 123648, '\P{wcho}', "");
    Expect(0, 123648, '\P{^wcho}', "");
    Expect(1, 123647, '\p{-	wcho}', "");
    Expect(0, 123647, '\p{^-	wcho}', "");
    Expect(0, 123647, '\P{-	wcho}', "");
    Expect(1, 123647, '\P{^-	wcho}', "");
    Expect(0, 123648, '\p{-	wcho}', "");
    Expect(1, 123648, '\p{^-	wcho}', "");
    Expect(1, 123648, '\P{-	wcho}', "");
    Expect(0, 123648, '\P{^-	wcho}', "");
    Error('\p{_	IS_wcho/a/}');
    Error('\P{_	IS_wcho/a/}');
    Expect(1, 123647, '\p{iswcho}', "");
    Expect(0, 123647, '\p{^iswcho}', "");
    Expect(0, 123647, '\P{iswcho}', "");
    Expect(1, 123647, '\P{^iswcho}', "");
    Expect(0, 123648, '\p{iswcho}', "");
    Expect(1, 123648, '\p{^iswcho}', "");
    Expect(1, 123648, '\P{iswcho}', "");
    Expect(0, 123648, '\P{^iswcho}', "");
    Expect(1, 123647, '\p{-	is_wcho}', "");
    Expect(0, 123647, '\p{^-	is_wcho}', "");
    Expect(0, 123647, '\P{-	is_wcho}', "");
    Expect(1, 123647, '\P{^-	is_wcho}', "");
    Expect(0, 123648, '\p{-	is_wcho}', "");
    Expect(1, 123648, '\p{^-	is_wcho}', "");
    Expect(1, 123648, '\P{-	is_wcho}', "");
    Expect(0, 123648, '\P{^-	is_wcho}', "");
    Error('\p{/a/Warang_CITI}');
    Error('\P{/a/Warang_CITI}');
    Expect(1, 71935, '\p{warangciti}', "");
    Expect(0, 71935, '\p{^warangciti}', "");
    Expect(0, 71935, '\P{warangciti}', "");
    Expect(1, 71935, '\P{^warangciti}', "");
    Expect(0, 71936, '\p{warangciti}', "");
    Expect(1, 71936, '\p{^warangciti}', "");
    Expect(1, 71936, '\P{warangciti}', "");
    Expect(0, 71936, '\P{^warangciti}', "");
    Expect(1, 71935, '\p{--WARANG_Citi}', "");
    Expect(0, 71935, '\p{^--WARANG_Citi}', "");
    Expect(0, 71935, '\P{--WARANG_Citi}', "");
    Expect(1, 71935, '\P{^--WARANG_Citi}', "");
    Expect(0, 71936, '\p{--WARANG_Citi}', "");
    Expect(1, 71936, '\p{^--WARANG_Citi}', "");
    Expect(1, 71936, '\P{--WARANG_Citi}', "");
    Expect(0, 71936, '\P{^--WARANG_Citi}', "");
    Error('\p{:=_Is_Warang_citi}');
    Error('\P{:=_Is_Warang_citi}');
    Expect(1, 71935, '\p{iswarangciti}', "");
    Expect(0, 71935, '\p{^iswarangciti}', "");
    Expect(0, 71935, '\P{iswarangciti}', "");
    Expect(1, 71935, '\P{^iswarangciti}', "");
    Expect(0, 71936, '\p{iswarangciti}', "");
    Expect(1, 71936, '\p{^iswarangciti}', "");
    Expect(1, 71936, '\P{iswarangciti}', "");
    Expect(0, 71936, '\P{^iswarangciti}', "");
    Expect(1, 71935, '\p{_is_WARANG_citi}', "");
    Expect(0, 71935, '\p{^_is_WARANG_citi}', "");
    Expect(0, 71935, '\P{_is_WARANG_citi}', "");
    Expect(1, 71935, '\P{^_is_WARANG_citi}', "");
    Expect(0, 71936, '\p{_is_WARANG_citi}', "");
    Expect(1, 71936, '\p{^_is_WARANG_citi}', "");
    Expect(1, 71936, '\P{_is_WARANG_citi}', "");
    Expect(0, 71936, '\P{^_is_WARANG_citi}', "");
    Error('\p{  WARA:=}');
    Error('\P{  WARA:=}');
    Expect(1, 71935, '\p{wara}', "");
    Expect(0, 71935, '\p{^wara}', "");
    Expect(0, 71935, '\P{wara}', "");
    Expect(1, 71935, '\P{^wara}', "");
    Expect(0, 71936, '\p{wara}', "");
    Expect(1, 71936, '\p{^wara}', "");
    Expect(1, 71936, '\P{wara}', "");
    Expect(0, 71936, '\P{^wara}', "");
    Expect(1, 71935, '\p{-_Wara}', "");
    Expect(0, 71935, '\p{^-_Wara}', "");
    Expect(0, 71935, '\P{-_Wara}', "");
    Expect(1, 71935, '\P{^-_Wara}', "");
    Expect(0, 71936, '\p{-_Wara}', "");
    Expect(1, 71936, '\p{^-_Wara}', "");
    Expect(1, 71936, '\P{-_Wara}', "");
    Expect(0, 71936, '\P{^-_Wara}', "");
    Error('\p{/a/	-IS_Wara}');
    Error('\P{/a/	-IS_Wara}');
    Expect(1, 71935, '\p{iswara}', "");
    Expect(0, 71935, '\p{^iswara}', "");
    Expect(0, 71935, '\P{iswara}', "");
    Expect(1, 71935, '\P{^iswara}', "");
    Expect(0, 71936, '\p{iswara}', "");
    Expect(1, 71936, '\p{^iswara}', "");
    Expect(1, 71936, '\P{iswara}', "");
    Expect(0, 71936, '\P{^iswara}', "");
    Expect(1, 71935, '\p{	_Is_Wara}', "");
    Expect(0, 71935, '\p{^	_Is_Wara}', "");
    Expect(0, 71935, '\P{	_Is_Wara}', "");
    Expect(1, 71935, '\P{^	_Is_Wara}', "");
    Expect(0, 71936, '\p{	_Is_Wara}', "");
    Expect(1, 71936, '\p{^	_Is_Wara}', "");
    Expect(1, 71936, '\P{	_Is_Wara}', "");
    Expect(0, 71936, '\P{^	_Is_Wara}', "");
    Error('\p{ :=White_SPACE}');
    Error('\P{ :=White_SPACE}');
    Expect(1, 12288, '\p{whitespace}', "");
    Expect(0, 12288, '\p{^whitespace}', "");
    Expect(0, 12288, '\P{whitespace}', "");
    Expect(1, 12288, '\P{^whitespace}', "");
    Expect(0, 12289, '\p{whitespace}', "");
    Expect(1, 12289, '\p{^whitespace}', "");
    Expect(1, 12289, '\P{whitespace}', "");
    Expect(0, 12289, '\P{^whitespace}', "");
    Expect(1, 12288, '\p{_-White_Space}', "");
    Expect(0, 12288, '\p{^_-White_Space}', "");
    Expect(0, 12288, '\P{_-White_Space}', "");
    Expect(1, 12288, '\P{^_-White_Space}', "");
    Expect(0, 12289, '\p{_-White_Space}', "");
    Expect(1, 12289, '\p{^_-White_Space}', "");
    Expect(1, 12289, '\P{_-White_Space}', "");
    Expect(0, 12289, '\P{^_-White_Space}', "");
    Error('\p{/a/ is_White_Space}');
    Error('\P{/a/ is_White_Space}');
    Expect(1, 12288, '\p{iswhitespace}', "");
    Expect(0, 12288, '\p{^iswhitespace}', "");
    Expect(0, 12288, '\P{iswhitespace}', "");
    Expect(1, 12288, '\P{^iswhitespace}', "");
    Expect(0, 12289, '\p{iswhitespace}', "");
    Expect(1, 12289, '\p{^iswhitespace}', "");
    Expect(1, 12289, '\P{iswhitespace}', "");
    Expect(0, 12289, '\P{^iswhitespace}', "");
    Expect(1, 12288, '\p{ Is_White_Space}', "");
    Expect(0, 12288, '\p{^ Is_White_Space}', "");
    Expect(0, 12288, '\P{ Is_White_Space}', "");
    Expect(1, 12288, '\P{^ Is_White_Space}', "");
    Expect(0, 12289, '\p{ Is_White_Space}', "");
    Expect(1, 12289, '\p{^ Is_White_Space}', "");
    Expect(1, 12289, '\P{ Is_White_Space}', "");
    Expect(0, 12289, '\P{^ Is_White_Space}', "");
    Error('\p{--wspace:=}');
    Error('\P{--wspace:=}');
    Expect(1, 12288, '\p{wspace}', "");
    Expect(0, 12288, '\p{^wspace}', "");
    Expect(0, 12288, '\P{wspace}', "");
    Expect(1, 12288, '\P{^wspace}', "");
    Expect(0, 12289, '\p{wspace}', "");
    Expect(1, 12289, '\p{^wspace}', "");
    Expect(1, 12289, '\P{wspace}', "");
    Expect(0, 12289, '\P{^wspace}', "");
    Expect(1, 12288, '\p{__wspace}', "");
    Expect(0, 12288, '\p{^__wspace}', "");
    Expect(0, 12288, '\P{__wspace}', "");
    Expect(1, 12288, '\P{^__wspace}', "");
    Expect(0, 12289, '\p{__wspace}', "");
    Expect(1, 12289, '\p{^__wspace}', "");
    Expect(1, 12289, '\P{__wspace}', "");
    Expect(0, 12289, '\P{^__wspace}', "");
    Error('\p{:=-	is_WSpace}');
    Error('\P{:=-	is_WSpace}');
    Expect(1, 12288, '\p{iswspace}', "");
    Expect(0, 12288, '\p{^iswspace}', "");
    Expect(0, 12288, '\P{iswspace}', "");
    Expect(1, 12288, '\P{^iswspace}', "");
    Expect(0, 12289, '\p{iswspace}', "");
    Expect(1, 12289, '\p{^iswspace}', "");
    Expect(1, 12289, '\P{iswspace}', "");
    Expect(0, 12289, '\P{^iswspace}', "");
    Expect(1, 12288, '\p{ 	Is_WSPACE}', "");
    Expect(0, 12288, '\p{^ 	Is_WSPACE}', "");
    Expect(0, 12288, '\P{ 	Is_WSPACE}', "");
    Expect(1, 12288, '\P{^ 	Is_WSPACE}', "");
    Expect(0, 12289, '\p{ 	Is_WSPACE}', "");
    Expect(1, 12289, '\p{^ 	Is_WSPACE}', "");
    Expect(1, 12289, '\P{ 	Is_WSPACE}', "");
    Expect(0, 12289, '\P{^ 	Is_WSPACE}', "");
    Error('\p{:=_	Space}');
    Error('\P{:=_	Space}');
    Expect(1, 12288, '\p{space}', "");
    Expect(0, 12288, '\p{^space}', "");
    Expect(0, 12288, '\P{space}', "");
    Expect(1, 12288, '\P{^space}', "");
    Expect(0, 12289, '\p{space}', "");
    Expect(1, 12289, '\p{^space}', "");
    Expect(1, 12289, '\P{space}', "");
    Expect(0, 12289, '\P{^space}', "");
    Expect(1, 12288, '\p{-Space}', "");
    Expect(0, 12288, '\p{^-Space}', "");
    Expect(0, 12288, '\P{-Space}', "");
    Expect(1, 12288, '\P{^-Space}', "");
    Expect(0, 12289, '\p{-Space}', "");
    Expect(1, 12289, '\p{^-Space}', "");
    Expect(1, 12289, '\P{-Space}', "");
    Expect(0, 12289, '\P{^-Space}', "");
    Error('\p{:=-	Is_SPACE}');
    Error('\P{:=-	Is_SPACE}');
    Expect(1, 12288, '\p{isspace}', "");
    Expect(0, 12288, '\p{^isspace}', "");
    Expect(0, 12288, '\P{isspace}', "");
    Expect(1, 12288, '\P{^isspace}', "");
    Expect(0, 12289, '\p{isspace}', "");
    Expect(1, 12289, '\p{^isspace}', "");
    Expect(1, 12289, '\P{isspace}', "");
    Expect(0, 12289, '\P{^isspace}', "");
    Expect(1, 12288, '\p{--is_space}', "");
    Expect(0, 12288, '\p{^--is_space}', "");
    Expect(0, 12288, '\P{--is_space}', "");
    Expect(1, 12288, '\P{^--is_space}', "");
    Expect(0, 12289, '\p{--is_space}', "");
    Expect(1, 12289, '\p{^--is_space}', "");
    Expect(1, 12289, '\P{--is_space}', "");
    Expect(0, 12289, '\P{^--is_space}', "");
    Error('\p{/a/ XPosixWord}');
    Error('\P{/a/ XPosixWord}');
    Expect(1, 917999, '\p{xposixword}', "");
    Expect(0, 917999, '\p{^xposixword}', "");
    Expect(0, 917999, '\P{xposixword}', "");
    Expect(1, 917999, '\P{^xposixword}', "");
    Expect(0, 918000, '\p{xposixword}', "");
    Expect(1, 918000, '\p{^xposixword}', "");
    Expect(1, 918000, '\P{xposixword}', "");
    Expect(0, 918000, '\P{^xposixword}', "");
    Expect(1, 917999, '\p{	_XPOSIXWORD}', "");
    Expect(0, 917999, '\p{^	_XPOSIXWORD}', "");
    Expect(0, 917999, '\P{	_XPOSIXWORD}', "");
    Expect(1, 917999, '\P{^	_XPOSIXWORD}', "");
    Expect(0, 918000, '\p{	_XPOSIXWORD}', "");
    Expect(1, 918000, '\p{^	_XPOSIXWORD}', "");
    Expect(1, 918000, '\P{	_XPOSIXWORD}', "");
    Expect(0, 918000, '\P{^	_XPOSIXWORD}', "");
    Error('\p{/a/		word}');
    Error('\P{/a/		word}');
    Expect(1, 917999, '\p{word}', "");
    Expect(0, 917999, '\p{^word}', "");
    Expect(0, 917999, '\P{word}', "");
    Expect(1, 917999, '\P{^word}', "");
    Expect(0, 918000, '\p{word}', "");
    Expect(1, 918000, '\p{^word}', "");
    Expect(1, 918000, '\P{word}', "");
    Expect(0, 918000, '\P{^word}', "");
    Expect(1, 917999, '\p{WORD}', "");
    Expect(0, 917999, '\p{^WORD}', "");
    Expect(0, 917999, '\P{WORD}', "");
    Expect(1, 917999, '\P{^WORD}', "");
    Expect(0, 918000, '\p{WORD}', "");
    Expect(1, 918000, '\p{^WORD}', "");
    Expect(1, 918000, '\P{WORD}', "");
    Expect(0, 918000, '\P{^WORD}', "");
    Error('\p{/a/is_XPosixWord}');
    Error('\P{/a/is_XPosixWord}');
    Expect(1, 917999, '\p{isxposixword}', "");
    Expect(0, 917999, '\p{^isxposixword}', "");
    Expect(0, 917999, '\P{isxposixword}', "");
    Expect(1, 917999, '\P{^isxposixword}', "");
    Expect(0, 918000, '\p{isxposixword}', "");
    Expect(1, 918000, '\p{^isxposixword}', "");
    Expect(1, 918000, '\P{isxposixword}', "");
    Expect(0, 918000, '\P{^isxposixword}', "");
    Expect(1, 917999, '\p{	Is_XPosixWord}', "");
    Expect(0, 917999, '\p{^	Is_XPosixWord}', "");
    Expect(0, 917999, '\P{	Is_XPosixWord}', "");
    Expect(1, 917999, '\P{^	Is_XPosixWord}', "");
    Expect(0, 918000, '\p{	Is_XPosixWord}', "");
    Expect(1, 918000, '\p{^	Is_XPosixWord}', "");
    Expect(1, 918000, '\P{	Is_XPosixWord}', "");
    Expect(0, 918000, '\P{^	Is_XPosixWord}', "");
    Error('\p{--is_word/a/}');
    Error('\P{--is_word/a/}');
    Expect(1, 917999, '\p{isword}', "");
    Expect(0, 917999, '\p{^isword}', "");
    Expect(0, 917999, '\P{isword}', "");
    Expect(1, 917999, '\P{^isword}', "");
    Expect(0, 918000, '\p{isword}', "");
    Expect(1, 918000, '\p{^isword}', "");
    Expect(1, 918000, '\P{isword}', "");
    Expect(0, 918000, '\P{^isword}', "");
    Expect(1, 917999, '\p{-Is_WORD}', "");
    Expect(0, 917999, '\p{^-Is_WORD}', "");
    Expect(0, 917999, '\P{-Is_WORD}', "");
    Expect(1, 917999, '\P{^-Is_WORD}', "");
    Expect(0, 918000, '\p{-Is_WORD}', "");
    Expect(1, 918000, '\p{^-Is_WORD}', "");
    Expect(1, 918000, '\P{-Is_WORD}', "");
    Expect(0, 918000, '\P{^-Is_WORD}', "");
    Error('\p{/a/ 	XPOSIXXDIGIT}');
    Error('\P{/a/ 	XPOSIXXDIGIT}');
    Expect(1, 65350, '\p{xposixxdigit}', "");
    Expect(0, 65350, '\p{^xposixxdigit}', "");
    Expect(0, 65350, '\P{xposixxdigit}', "");
    Expect(1, 65350, '\P{^xposixxdigit}', "");
    Expect(0, 65351, '\p{xposixxdigit}', "");
    Expect(1, 65351, '\p{^xposixxdigit}', "");
    Expect(1, 65351, '\P{xposixxdigit}', "");
    Expect(0, 65351, '\P{^xposixxdigit}', "");
    Expect(1, 65350, '\p{- XPosixXDigit}', "");
    Expect(0, 65350, '\p{^- XPosixXDigit}', "");
    Expect(0, 65350, '\P{- XPosixXDigit}', "");
    Expect(1, 65350, '\P{^- XPosixXDigit}', "");
    Expect(0, 65351, '\p{- XPosixXDigit}', "");
    Expect(1, 65351, '\p{^- XPosixXDigit}', "");
    Expect(1, 65351, '\P{- XPosixXDigit}', "");
    Expect(0, 65351, '\P{^- XPosixXDigit}', "");
    Error('\p{-/a/XDigit}');
    Error('\P{-/a/XDigit}');
    Expect(1, 65350, '\p{xdigit}', "");
    Expect(0, 65350, '\p{^xdigit}', "");
    Expect(0, 65350, '\P{xdigit}', "");
    Expect(1, 65350, '\P{^xdigit}', "");
    Expect(0, 65351, '\p{xdigit}', "");
    Expect(1, 65351, '\p{^xdigit}', "");
    Expect(1, 65351, '\P{xdigit}', "");
    Expect(0, 65351, '\P{^xdigit}', "");
    Expect(1, 65350, '\p{- XDIGIT}', "");
    Expect(0, 65350, '\p{^- XDIGIT}', "");
    Expect(0, 65350, '\P{- XDIGIT}', "");
    Expect(1, 65350, '\P{^- XDIGIT}', "");
    Expect(0, 65351, '\p{- XDIGIT}', "");
    Expect(1, 65351, '\p{^- XDIGIT}', "");
    Expect(1, 65351, '\P{- XDIGIT}', "");
    Expect(0, 65351, '\P{^- XDIGIT}', "");
    Error('\p{:=--Is_XPOSIXXDIGIT}');
    Error('\P{:=--Is_XPOSIXXDIGIT}');
    Expect(1, 65350, '\p{isxposixxdigit}', "");
    Expect(0, 65350, '\p{^isxposixxdigit}', "");
    Expect(0, 65350, '\P{isxposixxdigit}', "");
    Expect(1, 65350, '\P{^isxposixxdigit}', "");
    Expect(0, 65351, '\p{isxposixxdigit}', "");
    Expect(1, 65351, '\p{^isxposixxdigit}', "");
    Expect(1, 65351, '\P{isxposixxdigit}', "");
    Expect(0, 65351, '\P{^isxposixxdigit}', "");
    Expect(1, 65350, '\p{ IS_XPOSIXXDIGIT}', "");
    Expect(0, 65350, '\p{^ IS_XPOSIXXDIGIT}', "");
    Expect(0, 65350, '\P{ IS_XPOSIXXDIGIT}', "");
    Expect(1, 65350, '\P{^ IS_XPOSIXXDIGIT}', "");
    Expect(0, 65351, '\p{ IS_XPOSIXXDIGIT}', "");
    Expect(1, 65351, '\p{^ IS_XPOSIXXDIGIT}', "");
    Expect(1, 65351, '\P{ IS_XPOSIXXDIGIT}', "");
    Expect(0, 65351, '\P{^ IS_XPOSIXXDIGIT}', "");
    Error('\p{- Is_XDIGIT:=}');
    Error('\P{- Is_XDIGIT:=}');
    Expect(1, 65350, '\p{isxdigit}', "");
    Expect(0, 65350, '\p{^isxdigit}', "");
    Expect(0, 65350, '\P{isxdigit}', "");
    Expect(1, 65350, '\P{^isxdigit}', "");
    Expect(0, 65351, '\p{isxdigit}', "");
    Expect(1, 65351, '\p{^isxdigit}', "");
    Expect(1, 65351, '\P{isxdigit}', "");
    Expect(0, 65351, '\P{^isxdigit}', "");
    Expect(1, 65350, '\p{__is_XDIGIT}', "");
    Expect(0, 65350, '\p{^__is_XDIGIT}', "");
    Expect(0, 65350, '\P{__is_XDIGIT}', "");
    Expect(1, 65350, '\P{^__is_XDIGIT}', "");
    Expect(0, 65351, '\p{__is_XDIGIT}', "");
    Expect(1, 65351, '\p{^__is_XDIGIT}', "");
    Expect(1, 65351, '\P{__is_XDIGIT}', "");
    Expect(0, 65351, '\P{^__is_XDIGIT}', "");
    Error('\p{-/a/hex_digit}');
    Error('\P{-/a/hex_digit}');
    Expect(1, 65350, '\p{hexdigit}', "");
    Expect(0, 65350, '\p{^hexdigit}', "");
    Expect(0, 65350, '\P{hexdigit}', "");
    Expect(1, 65350, '\P{^hexdigit}', "");
    Expect(0, 65351, '\p{hexdigit}', "");
    Expect(1, 65351, '\p{^hexdigit}', "");
    Expect(1, 65351, '\P{hexdigit}', "");
    Expect(0, 65351, '\P{^hexdigit}', "");
    Expect(1, 65350, '\p{ hex_digit}', "");
    Expect(0, 65350, '\p{^ hex_digit}', "");
    Expect(0, 65350, '\P{ hex_digit}', "");
    Expect(1, 65350, '\P{^ hex_digit}', "");
    Expect(0, 65351, '\p{ hex_digit}', "");
    Expect(1, 65351, '\p{^ hex_digit}', "");
    Expect(1, 65351, '\P{ hex_digit}', "");
    Expect(0, 65351, '\P{^ hex_digit}', "");
    Error('\p{_Is_Hex_DIGIT:=}');
    Error('\P{_Is_Hex_DIGIT:=}');
    Expect(1, 65350, '\p{ishexdigit}', "");
    Expect(0, 65350, '\p{^ishexdigit}', "");
    Expect(0, 65350, '\P{ishexdigit}', "");
    Expect(1, 65350, '\P{^ishexdigit}', "");
    Expect(0, 65351, '\p{ishexdigit}', "");
    Expect(1, 65351, '\p{^ishexdigit}', "");
    Expect(1, 65351, '\P{ishexdigit}', "");
    Expect(0, 65351, '\P{^ishexdigit}', "");
    Expect(1, 65350, '\p{-IS_HEX_Digit}', "");
    Expect(0, 65350, '\p{^-IS_HEX_Digit}', "");
    Expect(0, 65350, '\P{-IS_HEX_Digit}', "");
    Expect(1, 65350, '\P{^-IS_HEX_Digit}', "");
    Expect(0, 65351, '\p{-IS_HEX_Digit}', "");
    Expect(1, 65351, '\p{^-IS_HEX_Digit}', "");
    Expect(1, 65351, '\P{-IS_HEX_Digit}', "");
    Expect(0, 65351, '\P{^-IS_HEX_Digit}', "");
    Error('\p{:= hex}');
    Error('\P{:= hex}');
    Expect(1, 65350, '\p{hex}', "");
    Expect(0, 65350, '\p{^hex}', "");
    Expect(0, 65350, '\P{hex}', "");
    Expect(1, 65350, '\P{^hex}', "");
    Expect(0, 65351, '\p{hex}', "");
    Expect(1, 65351, '\p{^hex}', "");
    Expect(1, 65351, '\P{hex}', "");
    Expect(0, 65351, '\P{^hex}', "");
    Expect(1, 65350, '\p{__HEX}', "");
    Expect(0, 65350, '\p{^__HEX}', "");
    Expect(0, 65350, '\P{__HEX}', "");
    Expect(1, 65350, '\P{^__HEX}', "");
    Expect(0, 65351, '\p{__HEX}', "");
    Expect(1, 65351, '\p{^__HEX}', "");
    Expect(1, 65351, '\P{__HEX}', "");
    Expect(0, 65351, '\P{^__HEX}', "");
    Error('\p{_	is_Hex/a/}');
    Error('\P{_	is_Hex/a/}');
    Expect(1, 65350, '\p{ishex}', "");
    Expect(0, 65350, '\p{^ishex}', "");
    Expect(0, 65350, '\P{ishex}', "");
    Expect(1, 65350, '\P{^ishex}', "");
    Expect(0, 65351, '\p{ishex}', "");
    Expect(1, 65351, '\p{^ishex}', "");
    Expect(1, 65351, '\P{ishex}', "");
    Expect(0, 65351, '\P{^ishex}', "");
    Expect(1, 65350, '\p{- is_Hex}', "");
    Expect(0, 65350, '\p{^- is_Hex}', "");
    Expect(0, 65350, '\P{- is_Hex}', "");
    Expect(1, 65350, '\P{^- is_Hex}', "");
    Expect(0, 65351, '\p{- is_Hex}', "");
    Expect(1, 65351, '\p{^- is_Hex}', "");
    Expect(1, 65351, '\P{- is_Hex}', "");
    Expect(0, 65351, '\P{^- is_Hex}', "");
    Error('\p{ XID_Continue/a/}');
    Error('\P{ XID_Continue/a/}');
    Expect(1, 917999, '\p{xidcontinue}', "");
    Expect(0, 917999, '\p{^xidcontinue}', "");
    Expect(0, 917999, '\P{xidcontinue}', "");
    Expect(1, 917999, '\P{^xidcontinue}', "");
    Expect(0, 918000, '\p{xidcontinue}', "");
    Expect(1, 918000, '\p{^xidcontinue}', "");
    Expect(1, 918000, '\P{xidcontinue}', "");
    Expect(0, 918000, '\P{^xidcontinue}', "");
    Expect(1, 917999, '\p{_	xid_continue}', "");
    Expect(0, 917999, '\p{^_	xid_continue}', "");
    Expect(0, 917999, '\P{_	xid_continue}', "");
    Expect(1, 917999, '\P{^_	xid_continue}', "");
    Expect(0, 918000, '\p{_	xid_continue}', "");
    Expect(1, 918000, '\p{^_	xid_continue}', "");
    Expect(1, 918000, '\P{_	xid_continue}', "");
    Expect(0, 918000, '\P{^_	xid_continue}', "");
    Error('\p{-IS_XID_continue/a/}');
    Error('\P{-IS_XID_continue/a/}');
    Expect(1, 917999, '\p{isxidcontinue}', "");
    Expect(0, 917999, '\p{^isxidcontinue}', "");
    Expect(0, 917999, '\P{isxidcontinue}', "");
    Expect(1, 917999, '\P{^isxidcontinue}', "");
    Expect(0, 918000, '\p{isxidcontinue}', "");
    Expect(1, 918000, '\p{^isxidcontinue}', "");
    Expect(1, 918000, '\P{isxidcontinue}', "");
    Expect(0, 918000, '\P{^isxidcontinue}', "");
    Expect(1, 917999, '\p{is_XID_CONTINUE}', "");
    Expect(0, 917999, '\p{^is_XID_CONTINUE}', "");
    Expect(0, 917999, '\P{is_XID_CONTINUE}', "");
    Expect(1, 917999, '\P{^is_XID_CONTINUE}', "");
    Expect(0, 918000, '\p{is_XID_CONTINUE}', "");
    Expect(1, 918000, '\p{^is_XID_CONTINUE}', "");
    Expect(1, 918000, '\P{is_XID_CONTINUE}', "");
    Expect(0, 918000, '\P{^is_XID_CONTINUE}', "");
    Error('\p{-XIDC/a/}');
    Error('\P{-XIDC/a/}');
    Expect(1, 917999, '\p{xidc}', "");
    Expect(0, 917999, '\p{^xidc}', "");
    Expect(0, 917999, '\P{xidc}', "");
    Expect(1, 917999, '\P{^xidc}', "");
    Expect(0, 918000, '\p{xidc}', "");
    Expect(1, 918000, '\p{^xidc}', "");
    Expect(1, 918000, '\P{xidc}', "");
    Expect(0, 918000, '\P{^xidc}', "");
    Expect(1, 917999, '\p{	 XIDC}', "");
    Expect(0, 917999, '\p{^	 XIDC}', "");
    Expect(0, 917999, '\P{	 XIDC}', "");
    Expect(1, 917999, '\P{^	 XIDC}', "");
    Expect(0, 918000, '\p{	 XIDC}', "");
    Expect(1, 918000, '\p{^	 XIDC}', "");
    Expect(1, 918000, '\P{	 XIDC}', "");
    Expect(0, 918000, '\P{^	 XIDC}', "");
    Error('\p{		IS_XIDC/a/}');
    Error('\P{		IS_XIDC/a/}');
    Expect(1, 917999, '\p{isxidc}', "");
    Expect(0, 917999, '\p{^isxidc}', "");
    Expect(0, 917999, '\P{isxidc}', "");
    Expect(1, 917999, '\P{^isxidc}', "");
    Expect(0, 918000, '\p{isxidc}', "");
    Expect(1, 918000, '\p{^isxidc}', "");
    Expect(1, 918000, '\P{isxidc}', "");
    Expect(0, 918000, '\P{^isxidc}', "");
    Expect(1, 917999, '\p{-_is_XIDC}', "");
    Expect(0, 917999, '\p{^-_is_XIDC}', "");
    Expect(0, 917999, '\P{-_is_XIDC}', "");
    Expect(1, 917999, '\P{^-_is_XIDC}', "");
    Expect(0, 918000, '\p{-_is_XIDC}', "");
    Expect(1, 918000, '\p{^-_is_XIDC}', "");
    Expect(1, 918000, '\P{-_is_XIDC}', "");
    Expect(0, 918000, '\P{^-_is_XIDC}', "");
    Error('\p{:= XID_Start}');
    Error('\P{:= XID_Start}');
    Expect(1, 205743, '\p{xidstart}', "");
    Expect(0, 205743, '\p{^xidstart}', "");
    Expect(0, 205743, '\P{xidstart}', "");
    Expect(1, 205743, '\P{^xidstart}', "");
    Expect(0, 205744, '\p{xidstart}', "");
    Expect(1, 205744, '\p{^xidstart}', "");
    Expect(1, 205744, '\P{xidstart}', "");
    Expect(0, 205744, '\P{^xidstart}', "");
    Expect(1, 205743, '\p{ XID_Start}', "");
    Expect(0, 205743, '\p{^ XID_Start}', "");
    Expect(0, 205743, '\P{ XID_Start}', "");
    Expect(1, 205743, '\P{^ XID_Start}', "");
    Expect(0, 205744, '\p{ XID_Start}', "");
    Expect(1, 205744, '\p{^ XID_Start}', "");
    Expect(1, 205744, '\P{ XID_Start}', "");
    Expect(0, 205744, '\P{^ XID_Start}', "");
    Error('\p{ _Is_XID_start/a/}');
    Error('\P{ _Is_XID_start/a/}');
    Expect(1, 205743, '\p{isxidstart}', "");
    Expect(0, 205743, '\p{^isxidstart}', "");
    Expect(0, 205743, '\P{isxidstart}', "");
    Expect(1, 205743, '\P{^isxidstart}', "");
    Expect(0, 205744, '\p{isxidstart}', "");
    Expect(1, 205744, '\p{^isxidstart}', "");
    Expect(1, 205744, '\P{isxidstart}', "");
    Expect(0, 205744, '\P{^isxidstart}', "");
    Expect(1, 205743, '\p{  is_XID_Start}', "");
    Expect(0, 205743, '\p{^  is_XID_Start}', "");
    Expect(0, 205743, '\P{  is_XID_Start}', "");
    Expect(1, 205743, '\P{^  is_XID_Start}', "");
    Expect(0, 205744, '\p{  is_XID_Start}', "");
    Expect(1, 205744, '\p{^  is_XID_Start}', "");
    Expect(1, 205744, '\P{  is_XID_Start}', "");
    Expect(0, 205744, '\P{^  is_XID_Start}', "");
    Error('\p{	XIDS/a/}');
    Error('\P{	XIDS/a/}');
    Expect(1, 205743, '\p{xids}', "");
    Expect(0, 205743, '\p{^xids}', "");
    Expect(0, 205743, '\P{xids}', "");
    Expect(1, 205743, '\P{^xids}', "");
    Expect(0, 205744, '\p{xids}', "");
    Expect(1, 205744, '\p{^xids}', "");
    Expect(1, 205744, '\P{xids}', "");
    Expect(0, 205744, '\P{^xids}', "");
    Expect(1, 205743, '\p{ XIDS}', "");
    Expect(0, 205743, '\p{^ XIDS}', "");
    Expect(0, 205743, '\P{ XIDS}', "");
    Expect(1, 205743, '\P{^ XIDS}', "");
    Expect(0, 205744, '\p{ XIDS}', "");
    Expect(1, 205744, '\p{^ XIDS}', "");
    Expect(1, 205744, '\P{ XIDS}', "");
    Expect(0, 205744, '\P{^ XIDS}', "");
    Error('\p{_Is_XIDS:=}');
    Error('\P{_Is_XIDS:=}');
    Expect(1, 205743, '\p{isxids}', "");
    Expect(0, 205743, '\p{^isxids}', "");
    Expect(0, 205743, '\P{isxids}', "");
    Expect(1, 205743, '\P{^isxids}', "");
    Expect(0, 205744, '\p{isxids}', "");
    Expect(1, 205744, '\p{^isxids}', "");
    Expect(1, 205744, '\P{isxids}', "");
    Expect(0, 205744, '\P{^isxids}', "");
    Expect(1, 205743, '\p{-Is_XIDS}', "");
    Expect(0, 205743, '\p{^-Is_XIDS}', "");
    Expect(0, 205743, '\P{-Is_XIDS}', "");
    Expect(1, 205743, '\P{^-Is_XIDS}', "");
    Expect(0, 205744, '\p{-Is_XIDS}', "");
    Expect(1, 205744, '\p{^-Is_XIDS}', "");
    Expect(1, 205744, '\P{-Is_XIDS}', "");
    Expect(0, 205744, '\P{^-Is_XIDS}', "");
    Error('\p{	/a/XPosixAlpha}');
    Error('\P{	/a/XPosixAlpha}');
    Expect(1, 205743, '\p{xposixalpha}', "");
    Expect(0, 205743, '\p{^xposixalpha}', "");
    Expect(0, 205743, '\P{xposixalpha}', "");
    Expect(1, 205743, '\P{^xposixalpha}', "");
    Expect(0, 205744, '\p{xposixalpha}', "");
    Expect(1, 205744, '\p{^xposixalpha}', "");
    Expect(1, 205744, '\P{xposixalpha}', "");
    Expect(0, 205744, '\P{^xposixalpha}', "");
    Expect(1, 205743, '\p{- XPosixAlpha}', "");
    Expect(0, 205743, '\p{^- XPosixAlpha}', "");
    Expect(0, 205743, '\P{- XPosixAlpha}', "");
    Expect(1, 205743, '\P{^- XPosixAlpha}', "");
    Expect(0, 205744, '\p{- XPosixAlpha}', "");
    Expect(1, 205744, '\p{^- XPosixAlpha}', "");
    Expect(1, 205744, '\P{- XPosixAlpha}', "");
    Expect(0, 205744, '\P{^- XPosixAlpha}', "");
    Error('\p{:=		Is_XPosixAlpha}');
    Error('\P{:=		Is_XPosixAlpha}');
    Expect(1, 205743, '\p{isxposixalpha}', "");
    Expect(0, 205743, '\p{^isxposixalpha}', "");
    Expect(0, 205743, '\P{isxposixalpha}', "");
    Expect(1, 205743, '\P{^isxposixalpha}', "");
    Expect(0, 205744, '\p{isxposixalpha}', "");
    Expect(1, 205744, '\p{^isxposixalpha}', "");
    Expect(1, 205744, '\P{isxposixalpha}', "");
    Expect(0, 205744, '\P{^isxposixalpha}', "");
    Expect(1, 205743, '\p{	_Is_XPosixAlpha}', "");
    Expect(0, 205743, '\p{^	_Is_XPosixAlpha}', "");
    Expect(0, 205743, '\P{	_Is_XPosixAlpha}', "");
    Expect(1, 205743, '\P{^	_Is_XPosixAlpha}', "");
    Expect(0, 205744, '\p{	_Is_XPosixAlpha}', "");
    Expect(1, 205744, '\p{^	_Is_XPosixAlpha}', "");
    Expect(1, 205744, '\P{	_Is_XPosixAlpha}', "");
    Expect(0, 205744, '\P{^	_Is_XPosixAlpha}', "");
    Error('\p{/a/	Alphabetic}');
    Error('\P{/a/	Alphabetic}');
    Expect(1, 205743, '\p{alphabetic}', "");
    Expect(0, 205743, '\p{^alphabetic}', "");
    Expect(0, 205743, '\P{alphabetic}', "");
    Expect(1, 205743, '\P{^alphabetic}', "");
    Expect(0, 205744, '\p{alphabetic}', "");
    Expect(1, 205744, '\p{^alphabetic}', "");
    Expect(1, 205744, '\P{alphabetic}', "");
    Expect(0, 205744, '\P{^alphabetic}', "");
    Expect(1, 205743, '\p{_ alphabetic}', "");
    Expect(0, 205743, '\p{^_ alphabetic}', "");
    Expect(0, 205743, '\P{_ alphabetic}', "");
    Expect(1, 205743, '\P{^_ alphabetic}', "");
    Expect(0, 205744, '\p{_ alphabetic}', "");
    Expect(1, 205744, '\p{^_ alphabetic}', "");
    Expect(1, 205744, '\P{_ alphabetic}', "");
    Expect(0, 205744, '\P{^_ alphabetic}', "");
    Error('\p{:=		Is_Alphabetic}');
    Error('\P{:=		Is_Alphabetic}');
    Expect(1, 205743, '\p{isalphabetic}', "");
    Expect(0, 205743, '\p{^isalphabetic}', "");
    Expect(0, 205743, '\P{isalphabetic}', "");
    Expect(1, 205743, '\P{^isalphabetic}', "");
    Expect(0, 205744, '\p{isalphabetic}', "");
    Expect(1, 205744, '\p{^isalphabetic}', "");
    Expect(1, 205744, '\P{isalphabetic}', "");
    Expect(0, 205744, '\P{^isalphabetic}', "");
    Expect(1, 205743, '\p{ Is_Alphabetic}', "");
    Expect(0, 205743, '\p{^ Is_Alphabetic}', "");
    Expect(0, 205743, '\P{ Is_Alphabetic}', "");
    Expect(1, 205743, '\P{^ Is_Alphabetic}', "");
    Expect(0, 205744, '\p{ Is_Alphabetic}', "");
    Expect(1, 205744, '\p{^ Is_Alphabetic}', "");
    Expect(1, 205744, '\P{ Is_Alphabetic}', "");
    Expect(0, 205744, '\P{^ Is_Alphabetic}', "");
    Error('\p{/a/	_Alpha}');
    Error('\P{/a/	_Alpha}');
    Expect(1, 205743, '\p{alpha}', "");
    Expect(0, 205743, '\p{^alpha}', "");
    Expect(0, 205743, '\P{alpha}', "");
    Expect(1, 205743, '\P{^alpha}', "");
    Expect(0, 205744, '\p{alpha}', "");
    Expect(1, 205744, '\p{^alpha}', "");
    Expect(1, 205744, '\P{alpha}', "");
    Expect(0, 205744, '\P{^alpha}', "");
    Expect(1, 205743, '\p{_-Alpha}', "");
    Expect(0, 205743, '\p{^_-Alpha}', "");
    Expect(0, 205743, '\P{_-Alpha}', "");
    Expect(1, 205743, '\P{^_-Alpha}', "");
    Expect(0, 205744, '\p{_-Alpha}', "");
    Expect(1, 205744, '\p{^_-Alpha}', "");
    Expect(1, 205744, '\P{_-Alpha}', "");
    Expect(0, 205744, '\P{^_-Alpha}', "");
    Error('\p{		is_Alpha/a/}');
    Error('\P{		is_Alpha/a/}');
    Expect(1, 205743, '\p{isalpha}', "");
    Expect(0, 205743, '\p{^isalpha}', "");
    Expect(0, 205743, '\P{isalpha}', "");
    Expect(1, 205743, '\P{^isalpha}', "");
    Expect(0, 205744, '\p{isalpha}', "");
    Expect(1, 205744, '\p{^isalpha}', "");
    Expect(1, 205744, '\P{isalpha}', "");
    Expect(0, 205744, '\P{^isalpha}', "");
    Expect(1, 205743, '\p{	 Is_Alpha}', "");
    Expect(0, 205743, '\p{^	 Is_Alpha}', "");
    Expect(0, 205743, '\P{	 Is_Alpha}', "");
    Expect(1, 205743, '\P{^	 Is_Alpha}', "");
    Expect(0, 205744, '\p{	 Is_Alpha}', "");
    Expect(1, 205744, '\p{^	 Is_Alpha}', "");
    Expect(1, 205744, '\P{	 Is_Alpha}', "");
    Expect(0, 205744, '\P{^	 Is_Alpha}', "");
    Error('\p{ :=XPOSIXLOWER}');
    Error('\P{ :=XPOSIXLOWER}');
    Expect(1, 125251, '\p{xposixlower}', "");
    Expect(0, 125251, '\p{^xposixlower}', "");
    Expect(0, 125251, '\P{xposixlower}', "");
    Expect(1, 125251, '\P{^xposixlower}', "");
    Expect(0, 125252, '\p{xposixlower}', "");
    Expect(1, 125252, '\p{^xposixlower}', "");
    Expect(1, 125252, '\P{xposixlower}', "");
    Expect(0, 125252, '\P{^xposixlower}', "");
    Expect(1, 125251, '\p{--XPOSIXLOWER}', "");
    Expect(0, 125251, '\p{^--XPOSIXLOWER}', "");
    Expect(0, 125251, '\P{--XPOSIXLOWER}', "");
    Expect(1, 125251, '\P{^--XPOSIXLOWER}', "");
    Expect(0, 125252, '\p{--XPOSIXLOWER}', "");
    Expect(1, 125252, '\p{^--XPOSIXLOWER}', "");
    Expect(1, 125252, '\P{--XPOSIXLOWER}', "");
    Expect(0, 125252, '\P{^--XPOSIXLOWER}', "");
    Error('\p{/a/_-Is_XPosixLower}');
    Error('\P{/a/_-Is_XPosixLower}');
    Expect(1, 125251, '\p{isxposixlower}', "");
    Expect(0, 125251, '\p{^isxposixlower}', "");
    Expect(0, 125251, '\P{isxposixlower}', "");
    Expect(1, 125251, '\P{^isxposixlower}', "");
    Expect(0, 125252, '\p{isxposixlower}', "");
    Expect(1, 125252, '\p{^isxposixlower}', "");
    Expect(1, 125252, '\P{isxposixlower}', "");
    Expect(0, 125252, '\P{^isxposixlower}', "");
    Expect(1, 125251, '\p{_Is_XPOSIXLOWER}', "");
    Expect(0, 125251, '\p{^_Is_XPOSIXLOWER}', "");
    Expect(0, 125251, '\P{_Is_XPOSIXLOWER}', "");
    Expect(1, 125251, '\P{^_Is_XPOSIXLOWER}', "");
    Expect(0, 125252, '\p{_Is_XPOSIXLOWER}', "");
    Expect(1, 125252, '\p{^_Is_XPOSIXLOWER}', "");
    Expect(1, 125252, '\P{_Is_XPOSIXLOWER}', "");
    Expect(0, 125252, '\P{^_Is_XPOSIXLOWER}', "");
    Error('\p{:=_LOWERCASE}');
    Error('\P{:=_LOWERCASE}');
    Expect(1, 125251, '\p{lowercase}', "");
    Expect(0, 125251, '\p{^lowercase}', "");
    Expect(0, 125251, '\P{lowercase}', "");
    Expect(1, 125251, '\P{^lowercase}', "");
    Expect(0, 125252, '\p{lowercase}', "");
    Expect(1, 125252, '\p{^lowercase}', "");
    Expect(1, 125252, '\P{lowercase}', "");
    Expect(0, 125252, '\P{^lowercase}', "");
    Expect(1, 125251, '\p{	Lowercase}', "");
    Expect(0, 125251, '\p{^	Lowercase}', "");
    Expect(0, 125251, '\P{	Lowercase}', "");
    Expect(1, 125251, '\P{^	Lowercase}', "");
    Expect(0, 125252, '\p{	Lowercase}', "");
    Expect(1, 125252, '\p{^	Lowercase}', "");
    Expect(1, 125252, '\P{	Lowercase}', "");
    Expect(0, 125252, '\P{^	Lowercase}', "");
    Error('\p{Is_Lowercase/a/}');
    Error('\P{Is_Lowercase/a/}');
    Expect(1, 125251, '\p{islowercase}', "");
    Expect(0, 125251, '\p{^islowercase}', "");
    Expect(0, 125251, '\P{islowercase}', "");
    Expect(1, 125251, '\P{^islowercase}', "");
    Expect(0, 125252, '\p{islowercase}', "");
    Expect(1, 125252, '\p{^islowercase}', "");
    Expect(1, 125252, '\P{islowercase}', "");
    Expect(0, 125252, '\P{^islowercase}', "");
    Expect(1, 125251, '\p{ Is_Lowercase}', "");
    Expect(0, 125251, '\p{^ Is_Lowercase}', "");
    Expect(0, 125251, '\P{ Is_Lowercase}', "");
    Expect(1, 125251, '\P{^ Is_Lowercase}', "");
    Expect(0, 125252, '\p{ Is_Lowercase}', "");
    Expect(1, 125252, '\p{^ Is_Lowercase}', "");
    Expect(1, 125252, '\P{ Is_Lowercase}', "");
    Expect(0, 125252, '\P{^ Is_Lowercase}', "");
    Error('\p{/a/	Lower}');
    Error('\P{/a/	Lower}');
    Expect(1, 125251, '\p{lower}', "");
    Expect(0, 125251, '\p{^lower}', "");
    Expect(0, 125251, '\P{lower}', "");
    Expect(1, 125251, '\P{^lower}', "");
    Expect(0, 125252, '\p{lower}', "");
    Expect(1, 125252, '\p{^lower}', "");
    Expect(1, 125252, '\P{lower}', "");
    Expect(0, 125252, '\P{^lower}', "");
    Expect(1, 125251, '\p{  Lower}', "");
    Expect(0, 125251, '\p{^  Lower}', "");
    Expect(0, 125251, '\P{  Lower}', "");
    Expect(1, 125251, '\P{^  Lower}', "");
    Expect(0, 125252, '\p{  Lower}', "");
    Expect(1, 125252, '\p{^  Lower}', "");
    Expect(1, 125252, '\P{  Lower}', "");
    Expect(0, 125252, '\P{^  Lower}', "");
    Error('\p{	is_Lower/a/}');
    Error('\P{	is_Lower/a/}');
    Expect(1, 125251, '\p{islower}', "");
    Expect(0, 125251, '\p{^islower}', "");
    Expect(0, 125251, '\P{islower}', "");
    Expect(1, 125251, '\P{^islower}', "");
    Expect(0, 125252, '\p{islower}', "");
    Expect(1, 125252, '\p{^islower}', "");
    Expect(1, 125252, '\P{islower}', "");
    Expect(0, 125252, '\P{^islower}', "");
    Expect(1, 125251, '\p{_Is_LOWER}', "");
    Expect(0, 125251, '\p{^_Is_LOWER}', "");
    Expect(0, 125251, '\P{_Is_LOWER}', "");
    Expect(1, 125251, '\P{^_Is_LOWER}', "");
    Expect(0, 125252, '\p{_Is_LOWER}', "");
    Expect(1, 125252, '\p{^_Is_LOWER}', "");
    Expect(1, 125252, '\P{_Is_LOWER}', "");
    Expect(0, 125252, '\P{^_Is_LOWER}', "");
    Error('\p{_:=XPosixPunct}');
    Error('\P{_:=XPosixPunct}');
    Expect(1, 125279, '\p{xposixpunct}', "");
    Expect(0, 125279, '\p{^xposixpunct}', "");
    Expect(0, 125279, '\P{xposixpunct}', "");
    Expect(1, 125279, '\P{^xposixpunct}', "");
    Expect(0, 125280, '\p{xposixpunct}', "");
    Expect(1, 125280, '\p{^xposixpunct}', "");
    Expect(1, 125280, '\P{xposixpunct}', "");
    Expect(0, 125280, '\P{^xposixpunct}', "");
    Expect(1, 125279, '\p{-XPosixPunct}', "");
    Expect(0, 125279, '\p{^-XPosixPunct}', "");
    Expect(0, 125279, '\P{-XPosixPunct}', "");
    Expect(1, 125279, '\P{^-XPosixPunct}', "");
    Expect(0, 125280, '\p{-XPosixPunct}', "");
    Expect(1, 125280, '\p{^-XPosixPunct}', "");
    Expect(1, 125280, '\P{-XPosixPunct}', "");
    Expect(0, 125280, '\P{^-XPosixPunct}', "");
    Error('\p{/a/	 IS_XPOSIXPUNCT}');
    Error('\P{/a/	 IS_XPOSIXPUNCT}');
    Expect(1, 125279, '\p{isxposixpunct}', "");
    Expect(0, 125279, '\p{^isxposixpunct}', "");
    Expect(0, 125279, '\P{isxposixpunct}', "");
    Expect(1, 125279, '\P{^isxposixpunct}', "");
    Expect(0, 125280, '\p{isxposixpunct}', "");
    Expect(1, 125280, '\p{^isxposixpunct}', "");
    Expect(1, 125280, '\P{isxposixpunct}', "");
    Expect(0, 125280, '\P{^isxposixpunct}', "");
    Expect(1, 125279, '\p{-Is_XPosixPunct}', "");
    Expect(0, 125279, '\p{^-Is_XPosixPunct}', "");
    Expect(0, 125279, '\P{-Is_XPosixPunct}', "");
    Expect(1, 125279, '\P{^-Is_XPosixPunct}', "");
    Expect(0, 125280, '\p{-Is_XPosixPunct}', "");
    Expect(1, 125280, '\p{^-Is_XPosixPunct}', "");
    Expect(1, 125280, '\P{-Is_XPosixPunct}', "");
    Expect(0, 125280, '\P{^-Is_XPosixPunct}', "");
    Error('\p{/a/_XPOSIXSPACE}');
    Error('\P{/a/_XPOSIXSPACE}');
    Expect(1, 12288, '\p{xposixspace}', "");
    Expect(0, 12288, '\p{^xposixspace}', "");
    Expect(0, 12288, '\P{xposixspace}', "");
    Expect(1, 12288, '\P{^xposixspace}', "");
    Expect(0, 12289, '\p{xposixspace}', "");
    Expect(1, 12289, '\p{^xposixspace}', "");
    Expect(1, 12289, '\P{xposixspace}', "");
    Expect(0, 12289, '\P{^xposixspace}', "");
    Expect(1, 12288, '\p{		XPosixSpace}', "");
    Expect(0, 12288, '\p{^		XPosixSpace}', "");
    Expect(0, 12288, '\P{		XPosixSpace}', "");
    Expect(1, 12288, '\P{^		XPosixSpace}', "");
    Expect(0, 12289, '\p{		XPosixSpace}', "");
    Expect(1, 12289, '\p{^		XPosixSpace}', "");
    Expect(1, 12289, '\P{		XPosixSpace}', "");
    Expect(0, 12289, '\P{^		XPosixSpace}', "");
    Error('\p{-:=XPERLSPACE}');
    Error('\P{-:=XPERLSPACE}');
    Expect(1, 12288, '\p{xperlspace}', "");
    Expect(0, 12288, '\p{^xperlspace}', "");
    Expect(0, 12288, '\P{xperlspace}', "");
    Expect(1, 12288, '\P{^xperlspace}', "");
    Expect(0, 12289, '\p{xperlspace}', "");
    Expect(1, 12289, '\p{^xperlspace}', "");
    Expect(1, 12289, '\P{xperlspace}', "");
    Expect(0, 12289, '\P{^xperlspace}', "");
    Expect(1, 12288, '\p{		XPerlSpace}', "");
    Expect(0, 12288, '\p{^		XPerlSpace}', "");
    Expect(0, 12288, '\P{		XPerlSpace}', "");
    Expect(1, 12288, '\P{^		XPerlSpace}', "");
    Expect(0, 12289, '\p{		XPerlSpace}', "");
    Expect(1, 12289, '\p{^		XPerlSpace}', "");
    Expect(1, 12289, '\P{		XPerlSpace}', "");
    Expect(0, 12289, '\P{^		XPerlSpace}', "");
    Error('\p{:=_spaceperl}');
    Error('\P{:=_spaceperl}');
    Expect(1, 12288, '\p{spaceperl}', "");
    Expect(0, 12288, '\p{^spaceperl}', "");
    Expect(0, 12288, '\P{spaceperl}', "");
    Expect(1, 12288, '\P{^spaceperl}', "");
    Expect(0, 12289, '\p{spaceperl}', "");
    Expect(1, 12289, '\p{^spaceperl}', "");
    Expect(1, 12289, '\P{spaceperl}', "");
    Expect(0, 12289, '\P{^spaceperl}', "");
    Expect(1, 12288, '\p{  spaceperl}', "");
    Expect(0, 12288, '\p{^  spaceperl}', "");
    Expect(0, 12288, '\P{  spaceperl}', "");
    Expect(1, 12288, '\P{^  spaceperl}', "");
    Expect(0, 12289, '\p{  spaceperl}', "");
    Expect(1, 12289, '\p{^  spaceperl}', "");
    Expect(1, 12289, '\P{  spaceperl}', "");
    Expect(0, 12289, '\P{^  spaceperl}', "");
    Error('\p{:=_ Is_XPosixSpace}');
    Error('\P{:=_ Is_XPosixSpace}');
    Expect(1, 12288, '\p{isxposixspace}', "");
    Expect(0, 12288, '\p{^isxposixspace}', "");
    Expect(0, 12288, '\P{isxposixspace}', "");
    Expect(1, 12288, '\P{^isxposixspace}', "");
    Expect(0, 12289, '\p{isxposixspace}', "");
    Expect(1, 12289, '\p{^isxposixspace}', "");
    Expect(1, 12289, '\P{isxposixspace}', "");
    Expect(0, 12289, '\P{^isxposixspace}', "");
    Expect(1, 12288, '\p{__is_XPosixSpace}', "");
    Expect(0, 12288, '\p{^__is_XPosixSpace}', "");
    Expect(0, 12288, '\P{__is_XPosixSpace}', "");
    Expect(1, 12288, '\P{^__is_XPosixSpace}', "");
    Expect(0, 12289, '\p{__is_XPosixSpace}', "");
    Expect(1, 12289, '\p{^__is_XPosixSpace}', "");
    Expect(1, 12289, '\P{__is_XPosixSpace}', "");
    Expect(0, 12289, '\P{^__is_XPosixSpace}', "");
    Error('\p{/a/ Is_XPERLSPACE}');
    Error('\P{/a/ Is_XPERLSPACE}');
    Expect(1, 12288, '\p{isxperlspace}', "");
    Expect(0, 12288, '\p{^isxperlspace}', "");
    Expect(0, 12288, '\P{isxperlspace}', "");
    Expect(1, 12288, '\P{^isxperlspace}', "");
    Expect(0, 12289, '\p{isxperlspace}', "");
    Expect(1, 12289, '\p{^isxperlspace}', "");
    Expect(1, 12289, '\P{isxperlspace}', "");
    Expect(0, 12289, '\P{^isxperlspace}', "");
    Expect(1, 12288, '\p{ IS_XPERLSPACE}', "");
    Expect(0, 12288, '\p{^ IS_XPERLSPACE}', "");
    Expect(0, 12288, '\P{ IS_XPERLSPACE}', "");
    Expect(1, 12288, '\P{^ IS_XPERLSPACE}', "");
    Expect(0, 12289, '\p{ IS_XPERLSPACE}', "");
    Expect(1, 12289, '\p{^ IS_XPERLSPACE}', "");
    Expect(1, 12289, '\P{ IS_XPERLSPACE}', "");
    Expect(0, 12289, '\P{^ IS_XPERLSPACE}', "");
    Error('\p{:=	Is_SpacePerl}');
    Error('\P{:=	Is_SpacePerl}');
    Expect(1, 12288, '\p{isspaceperl}', "");
    Expect(0, 12288, '\p{^isspaceperl}', "");
    Expect(0, 12288, '\P{isspaceperl}', "");
    Expect(1, 12288, '\P{^isspaceperl}', "");
    Expect(0, 12289, '\p{isspaceperl}', "");
    Expect(1, 12289, '\p{^isspaceperl}', "");
    Expect(1, 12289, '\P{isspaceperl}', "");
    Expect(0, 12289, '\P{^isspaceperl}', "");
    Expect(1, 12288, '\p{	Is_spaceperl}', "");
    Expect(0, 12288, '\p{^	Is_spaceperl}', "");
    Expect(0, 12288, '\P{	Is_spaceperl}', "");
    Expect(1, 12288, '\P{^	Is_spaceperl}', "");
    Expect(0, 12289, '\p{	Is_spaceperl}', "");
    Expect(1, 12289, '\p{^	Is_spaceperl}', "");
    Expect(1, 12289, '\P{	Is_spaceperl}', "");
    Expect(0, 12289, '\P{^	Is_spaceperl}', "");
    Error('\p{/a/XPosixUpper}');
    Error('\P{/a/XPosixUpper}');
    Expect(1, 127369, '\p{xposixupper}', "");
    Expect(0, 127369, '\p{^xposixupper}', "");
    Expect(0, 127369, '\P{xposixupper}', "");
    Expect(1, 127369, '\P{^xposixupper}', "");
    Expect(0, 127370, '\p{xposixupper}', "");
    Expect(1, 127370, '\p{^xposixupper}', "");
    Expect(1, 127370, '\P{xposixupper}', "");
    Expect(0, 127370, '\P{^xposixupper}', "");
    Expect(1, 127369, '\p{_-XPosixUpper}', "");
    Expect(0, 127369, '\p{^_-XPosixUpper}', "");
    Expect(0, 127369, '\P{_-XPosixUpper}', "");
    Expect(1, 127369, '\P{^_-XPosixUpper}', "");
    Expect(0, 127370, '\p{_-XPosixUpper}', "");
    Expect(1, 127370, '\p{^_-XPosixUpper}', "");
    Expect(1, 127370, '\P{_-XPosixUpper}', "");
    Expect(0, 127370, '\P{^_-XPosixUpper}', "");
    Error('\p{_:=is_xposixupper}');
    Error('\P{_:=is_xposixupper}');
    Expect(1, 127369, '\p{isxposixupper}', "");
    Expect(0, 127369, '\p{^isxposixupper}', "");
    Expect(0, 127369, '\P{isxposixupper}', "");
    Expect(1, 127369, '\P{^isxposixupper}', "");
    Expect(0, 127370, '\p{isxposixupper}', "");
    Expect(1, 127370, '\p{^isxposixupper}', "");
    Expect(1, 127370, '\P{isxposixupper}', "");
    Expect(0, 127370, '\P{^isxposixupper}', "");
    Expect(1, 127369, '\p{--IS_XPosixUpper}', "");
    Expect(0, 127369, '\p{^--IS_XPosixUpper}', "");
    Expect(0, 127369, '\P{--IS_XPosixUpper}', "");
    Expect(1, 127369, '\P{^--IS_XPosixUpper}', "");
    Expect(0, 127370, '\p{--IS_XPosixUpper}', "");
    Expect(1, 127370, '\p{^--IS_XPosixUpper}', "");
    Expect(1, 127370, '\P{--IS_XPosixUpper}', "");
    Expect(0, 127370, '\P{^--IS_XPosixUpper}', "");
    Error('\p{:=_	UPPERCASE}');
    Error('\P{:=_	UPPERCASE}');
    Expect(1, 127369, '\p{uppercase}', "");
    Expect(0, 127369, '\p{^uppercase}', "");
    Expect(0, 127369, '\P{uppercase}', "");
    Expect(1, 127369, '\P{^uppercase}', "");
    Expect(0, 127370, '\p{uppercase}', "");
    Expect(1, 127370, '\p{^uppercase}', "");
    Expect(1, 127370, '\P{uppercase}', "");
    Expect(0, 127370, '\P{^uppercase}', "");
    Expect(1, 127369, '\p{_ uppercase}', "");
    Expect(0, 127369, '\p{^_ uppercase}', "");
    Expect(0, 127369, '\P{_ uppercase}', "");
    Expect(1, 127369, '\P{^_ uppercase}', "");
    Expect(0, 127370, '\p{_ uppercase}', "");
    Expect(1, 127370, '\p{^_ uppercase}', "");
    Expect(1, 127370, '\P{_ uppercase}', "");
    Expect(0, 127370, '\P{^_ uppercase}', "");
    Error('\p{/a/-is_Uppercase}');
    Error('\P{/a/-is_Uppercase}');
    Expect(1, 127369, '\p{isuppercase}', "");
    Expect(0, 127369, '\p{^isuppercase}', "");
    Expect(0, 127369, '\P{isuppercase}', "");
    Expect(1, 127369, '\P{^isuppercase}', "");
    Expect(0, 127370, '\p{isuppercase}', "");
    Expect(1, 127370, '\p{^isuppercase}', "");
    Expect(1, 127370, '\P{isuppercase}', "");
    Expect(0, 127370, '\P{^isuppercase}', "");
    Expect(1, 127369, '\p{-_IS_Uppercase}', "");
    Expect(0, 127369, '\p{^-_IS_Uppercase}', "");
    Expect(0, 127369, '\P{-_IS_Uppercase}', "");
    Expect(1, 127369, '\P{^-_IS_Uppercase}', "");
    Expect(0, 127370, '\p{-_IS_Uppercase}', "");
    Expect(1, 127370, '\p{^-_IS_Uppercase}', "");
    Expect(1, 127370, '\P{-_IS_Uppercase}', "");
    Expect(0, 127370, '\P{^-_IS_Uppercase}', "");
    Error('\p{	upper:=}');
    Error('\P{	upper:=}');
    Expect(1, 127369, '\p{upper}', "");
    Expect(0, 127369, '\p{^upper}', "");
    Expect(0, 127369, '\P{upper}', "");
    Expect(1, 127369, '\P{^upper}', "");
    Expect(0, 127370, '\p{upper}', "");
    Expect(1, 127370, '\p{^upper}', "");
    Expect(1, 127370, '\P{upper}', "");
    Expect(0, 127370, '\P{^upper}', "");
    Expect(1, 127369, '\p{	UPPER}', "");
    Expect(0, 127369, '\p{^	UPPER}', "");
    Expect(0, 127369, '\P{	UPPER}', "");
    Expect(1, 127369, '\P{^	UPPER}', "");
    Expect(0, 127370, '\p{	UPPER}', "");
    Expect(1, 127370, '\p{^	UPPER}', "");
    Expect(1, 127370, '\P{	UPPER}', "");
    Expect(0, 127370, '\P{^	UPPER}', "");
    Error('\p{-:=Is_upper}');
    Error('\P{-:=Is_upper}');
    Expect(1, 127369, '\p{isupper}', "");
    Expect(0, 127369, '\p{^isupper}', "");
    Expect(0, 127369, '\P{isupper}', "");
    Expect(1, 127369, '\P{^isupper}', "");
    Expect(0, 127370, '\p{isupper}', "");
    Expect(1, 127370, '\p{^isupper}', "");
    Expect(1, 127370, '\P{isupper}', "");
    Expect(0, 127370, '\P{^isupper}', "");
    Expect(1, 127369, '\p{ IS_Upper}', "");
    Expect(0, 127369, '\p{^ IS_Upper}', "");
    Expect(0, 127369, '\P{ IS_Upper}', "");
    Expect(1, 127369, '\P{^ IS_Upper}', "");
    Expect(0, 127370, '\p{ IS_Upper}', "");
    Expect(1, 127370, '\p{^ IS_Upper}', "");
    Expect(1, 127370, '\P{ IS_Upper}', "");
    Expect(0, 127370, '\P{^ IS_Upper}', "");
    Error('\p{-:=Yezidi}');
    Error('\P{-:=Yezidi}');
    Expect(1, 69297, '\p{yezidi}', "");
    Expect(0, 69297, '\p{^yezidi}', "");
    Expect(0, 69297, '\P{yezidi}', "");
    Expect(1, 69297, '\P{^yezidi}', "");
    Expect(0, 69298, '\p{yezidi}', "");
    Expect(1, 69298, '\p{^yezidi}', "");
    Expect(1, 69298, '\P{yezidi}', "");
    Expect(0, 69298, '\P{^yezidi}', "");
    Expect(1, 69297, '\p{_-YEZIDI}', "");
    Expect(0, 69297, '\p{^_-YEZIDI}', "");
    Expect(0, 69297, '\P{_-YEZIDI}', "");
    Expect(1, 69297, '\P{^_-YEZIDI}', "");
    Expect(0, 69298, '\p{_-YEZIDI}', "");
    Expect(1, 69298, '\p{^_-YEZIDI}', "");
    Expect(1, 69298, '\P{_-YEZIDI}', "");
    Expect(0, 69298, '\P{^_-YEZIDI}', "");
    Error('\p{_/a/Is_yezidi}');
    Error('\P{_/a/Is_yezidi}');
    Expect(1, 69297, '\p{isyezidi}', "");
    Expect(0, 69297, '\p{^isyezidi}', "");
    Expect(0, 69297, '\P{isyezidi}', "");
    Expect(1, 69297, '\P{^isyezidi}', "");
    Expect(0, 69298, '\p{isyezidi}', "");
    Expect(1, 69298, '\p{^isyezidi}', "");
    Expect(1, 69298, '\P{isyezidi}', "");
    Expect(0, 69298, '\P{^isyezidi}', "");
    Expect(1, 69297, '\p{  Is_Yezidi}', "");
    Expect(0, 69297, '\p{^  Is_Yezidi}', "");
    Expect(0, 69297, '\P{  Is_Yezidi}', "");
    Expect(1, 69297, '\P{^  Is_Yezidi}', "");
    Expect(0, 69298, '\p{  Is_Yezidi}', "");
    Expect(1, 69298, '\p{^  Is_Yezidi}', "");
    Expect(1, 69298, '\P{  Is_Yezidi}', "");
    Expect(0, 69298, '\P{^  Is_Yezidi}', "");
    Error('\p{ 	Yezi:=}');
    Error('\P{ 	Yezi:=}');
    Expect(1, 69297, '\p{yezi}', "");
    Expect(0, 69297, '\p{^yezi}', "");
    Expect(0, 69297, '\P{yezi}', "");
    Expect(1, 69297, '\P{^yezi}', "");
    Expect(0, 69298, '\p{yezi}', "");
    Expect(1, 69298, '\p{^yezi}', "");
    Expect(1, 69298, '\P{yezi}', "");
    Expect(0, 69298, '\P{^yezi}', "");
    Expect(1, 69297, '\p{-Yezi}', "");
    Expect(0, 69297, '\p{^-Yezi}', "");
    Expect(0, 69297, '\P{-Yezi}', "");
    Expect(1, 69297, '\P{^-Yezi}', "");
    Expect(0, 69298, '\p{-Yezi}', "");
    Expect(1, 69298, '\p{^-Yezi}', "");
    Expect(1, 69298, '\P{-Yezi}', "");
    Expect(0, 69298, '\P{^-Yezi}', "");
    Error('\p{:=-	IS_Yezi}');
    Error('\P{:=-	IS_Yezi}');
    Expect(1, 69297, '\p{isyezi}', "");
    Expect(0, 69297, '\p{^isyezi}', "");
    Expect(0, 69297, '\P{isyezi}', "");
    Expect(1, 69297, '\P{^isyezi}', "");
    Expect(0, 69298, '\p{isyezi}', "");
    Expect(1, 69298, '\p{^isyezi}', "");
    Expect(1, 69298, '\P{isyezi}', "");
    Expect(0, 69298, '\P{^isyezi}', "");
    Expect(1, 69297, '\p{ 	Is_YEZI}', "");
    Expect(0, 69297, '\p{^ 	Is_YEZI}', "");
    Expect(0, 69297, '\P{ 	Is_YEZI}', "");
    Expect(1, 69297, '\P{^ 	Is_YEZI}', "");
    Expect(0, 69298, '\p{ 	Is_YEZI}', "");
    Expect(1, 69298, '\p{^ 	Is_YEZI}', "");
    Expect(1, 69298, '\P{ 	Is_YEZI}', "");
    Expect(0, 69298, '\P{^ 	Is_YEZI}', "");
    Error('\p{:=	_YI}');
    Error('\P{:=	_YI}');
    Expect(1, 65381, '\p{yi}', "");
    Expect(0, 65381, '\p{^yi}', "");
    Expect(0, 65381, '\P{yi}', "");
    Expect(1, 65381, '\P{^yi}', "");
    Expect(0, 65382, '\p{yi}', "");
    Expect(1, 65382, '\p{^yi}', "");
    Expect(1, 65382, '\P{yi}', "");
    Expect(0, 65382, '\P{^yi}', "");
    Expect(1, 65381, '\p{- Yi}', "");
    Expect(0, 65381, '\p{^- Yi}', "");
    Expect(0, 65381, '\P{- Yi}', "");
    Expect(1, 65381, '\P{^- Yi}', "");
    Expect(0, 65382, '\p{- Yi}', "");
    Expect(1, 65382, '\p{^- Yi}', "");
    Expect(1, 65382, '\P{- Yi}', "");
    Expect(0, 65382, '\P{^- Yi}', "");
    Error('\p{:=is_Yi}');
    Error('\P{:=is_Yi}');
    Expect(1, 65381, '\p{isyi}', "");
    Expect(0, 65381, '\p{^isyi}', "");
    Expect(0, 65381, '\P{isyi}', "");
    Expect(1, 65381, '\P{^isyi}', "");
    Expect(0, 65382, '\p{isyi}', "");
    Expect(1, 65382, '\p{^isyi}', "");
    Expect(1, 65382, '\P{isyi}', "");
    Expect(0, 65382, '\P{^isyi}', "");
    Expect(1, 65381, '\p{_ Is_yi}', "");
    Expect(0, 65381, '\p{^_ Is_yi}', "");
    Expect(0, 65381, '\P{_ Is_yi}', "");
    Expect(1, 65381, '\P{^_ Is_yi}', "");
    Expect(0, 65382, '\p{_ Is_yi}', "");
    Expect(1, 65382, '\p{^_ Is_yi}', "");
    Expect(1, 65382, '\P{_ Is_yi}', "");
    Expect(0, 65382, '\P{^_ Is_yi}', "");
    Error('\p{/a/_	Yiii}');
    Error('\P{/a/_	Yiii}');
    Expect(1, 65381, '\p{yiii}', "");
    Expect(0, 65381, '\p{^yiii}', "");
    Expect(0, 65381, '\P{yiii}', "");
    Expect(1, 65381, '\P{^yiii}', "");
    Expect(0, 65382, '\p{yiii}', "");
    Expect(1, 65382, '\p{^yiii}', "");
    Expect(1, 65382, '\P{yiii}', "");
    Expect(0, 65382, '\P{^yiii}', "");
    Expect(1, 65381, '\p{ Yiii}', "");
    Expect(0, 65381, '\p{^ Yiii}', "");
    Expect(0, 65381, '\P{ Yiii}', "");
    Expect(1, 65381, '\P{^ Yiii}', "");
    Expect(0, 65382, '\p{ Yiii}', "");
    Expect(1, 65382, '\p{^ Yiii}', "");
    Expect(1, 65382, '\P{ Yiii}', "");
    Expect(0, 65382, '\P{^ Yiii}', "");
    Error('\p{:=IS_YIII}');
    Error('\P{:=IS_YIII}');
    Expect(1, 65381, '\p{isyiii}', "");
    Expect(0, 65381, '\p{^isyiii}', "");
    Expect(0, 65381, '\P{isyiii}', "");
    Expect(1, 65381, '\P{^isyiii}', "");
    Expect(0, 65382, '\p{isyiii}', "");
    Expect(1, 65382, '\p{^isyiii}', "");
    Expect(1, 65382, '\P{isyiii}', "");
    Expect(0, 65382, '\P{^isyiii}', "");
    Expect(1, 65381, '\p{_ IS_Yiii}', "");
    Expect(0, 65381, '\p{^_ IS_Yiii}', "");
    Expect(0, 65381, '\P{_ IS_Yiii}', "");
    Expect(1, 65381, '\P{^_ IS_Yiii}', "");
    Expect(0, 65382, '\p{_ IS_Yiii}', "");
    Expect(1, 65382, '\p{^_ IS_Yiii}', "");
    Expect(1, 65382, '\P{_ IS_Yiii}', "");
    Expect(0, 65382, '\P{^_ IS_Yiii}', "");
    Error('\p{_yi_RADICALS/a/}');
    Error('\P{_yi_RADICALS/a/}');
    Expect(1, 42191, '\p{yiradicals}', "");
    Expect(0, 42191, '\p{^yiradicals}', "");
    Expect(0, 42191, '\P{yiradicals}', "");
    Expect(1, 42191, '\P{^yiradicals}', "");
    Expect(0, 42192, '\p{yiradicals}', "");
    Expect(1, 42192, '\p{^yiradicals}', "");
    Expect(1, 42192, '\P{yiradicals}', "");
    Expect(0, 42192, '\P{^yiradicals}', "");
    Expect(1, 42191, '\p{-	Yi_Radicals}', "");
    Expect(0, 42191, '\p{^-	Yi_Radicals}', "");
    Expect(0, 42191, '\P{-	Yi_Radicals}', "");
    Expect(1, 42191, '\P{^-	Yi_Radicals}', "");
    Expect(0, 42192, '\p{-	Yi_Radicals}', "");
    Expect(1, 42192, '\p{^-	Yi_Radicals}', "");
    Expect(1, 42192, '\P{-	Yi_Radicals}', "");
    Expect(0, 42192, '\P{^-	Yi_Radicals}', "");
    Error('\p{:=	_Is_Yi_Radicals}');
    Error('\P{:=	_Is_Yi_Radicals}');
    Expect(1, 42191, '\p{isyiradicals}', "");
    Expect(0, 42191, '\p{^isyiradicals}', "");
    Expect(0, 42191, '\P{isyiradicals}', "");
    Expect(1, 42191, '\P{^isyiradicals}', "");
    Expect(0, 42192, '\p{isyiradicals}', "");
    Expect(1, 42192, '\p{^isyiradicals}', "");
    Expect(1, 42192, '\P{isyiradicals}', "");
    Expect(0, 42192, '\P{^isyiradicals}', "");
    Expect(1, 42191, '\p{	 IS_YI_Radicals}', "");
    Expect(0, 42191, '\p{^	 IS_YI_Radicals}', "");
    Expect(0, 42191, '\P{	 IS_YI_Radicals}', "");
    Expect(1, 42191, '\P{^	 IS_YI_Radicals}', "");
    Expect(0, 42192, '\p{	 IS_YI_Radicals}', "");
    Expect(1, 42192, '\p{^	 IS_YI_Radicals}', "");
    Expect(1, 42192, '\P{	 IS_YI_Radicals}', "");
    Expect(0, 42192, '\P{^	 IS_YI_Radicals}', "");
    Error('\p{:=	_In_yi_Radicals}');
    Error('\P{:=	_In_yi_Radicals}');
    Expect(1, 42191, '\p{inyiradicals}', "");
    Expect(0, 42191, '\p{^inyiradicals}', "");
    Expect(0, 42191, '\P{inyiradicals}', "");
    Expect(1, 42191, '\P{^inyiradicals}', "");
    Expect(0, 42192, '\p{inyiradicals}', "");
    Expect(1, 42192, '\p{^inyiradicals}', "");
    Expect(1, 42192, '\P{inyiradicals}', "");
    Expect(0, 42192, '\P{^inyiradicals}', "");
    Expect(1, 42191, '\p{ -in_Yi_Radicals}', "");
    Expect(0, 42191, '\p{^ -in_Yi_Radicals}', "");
    Expect(0, 42191, '\P{ -in_Yi_Radicals}', "");
    Expect(1, 42191, '\P{^ -in_Yi_Radicals}', "");
    Expect(0, 42192, '\p{ -in_Yi_Radicals}', "");
    Expect(1, 42192, '\p{^ -in_Yi_Radicals}', "");
    Expect(1, 42192, '\P{ -in_Yi_Radicals}', "");
    Expect(0, 42192, '\P{^ -in_Yi_Radicals}', "");
    Error('\p{ /a/Yi_Syllables}');
    Error('\P{ /a/Yi_Syllables}');
    Expect(1, 42127, '\p{yisyllables}', "");
    Expect(0, 42127, '\p{^yisyllables}', "");
    Expect(0, 42127, '\P{yisyllables}', "");
    Expect(1, 42127, '\P{^yisyllables}', "");
    Expect(0, 42128, '\p{yisyllables}', "");
    Expect(1, 42128, '\p{^yisyllables}', "");
    Expect(1, 42128, '\P{yisyllables}', "");
    Expect(0, 42128, '\P{^yisyllables}', "");
    Expect(1, 42127, '\p{_-Yi_SYLLABLES}', "");
    Expect(0, 42127, '\p{^_-Yi_SYLLABLES}', "");
    Expect(0, 42127, '\P{_-Yi_SYLLABLES}', "");
    Expect(1, 42127, '\P{^_-Yi_SYLLABLES}', "");
    Expect(0, 42128, '\p{_-Yi_SYLLABLES}', "");
    Expect(1, 42128, '\p{^_-Yi_SYLLABLES}', "");
    Expect(1, 42128, '\P{_-Yi_SYLLABLES}', "");
    Expect(0, 42128, '\P{^_-Yi_SYLLABLES}', "");
    Error('\p{/a/	-Is_Yi_Syllables}');
    Error('\P{/a/	-Is_Yi_Syllables}');
    Expect(1, 42127, '\p{isyisyllables}', "");
    Expect(0, 42127, '\p{^isyisyllables}', "");
    Expect(0, 42127, '\P{isyisyllables}', "");
    Expect(1, 42127, '\P{^isyisyllables}', "");
    Expect(0, 42128, '\p{isyisyllables}', "");
    Expect(1, 42128, '\p{^isyisyllables}', "");
    Expect(1, 42128, '\P{isyisyllables}', "");
    Expect(0, 42128, '\P{^isyisyllables}', "");
    Expect(1, 42127, '\p{	Is_Yi_Syllables}', "");
    Expect(0, 42127, '\p{^	Is_Yi_Syllables}', "");
    Expect(0, 42127, '\P{	Is_Yi_Syllables}', "");
    Expect(1, 42127, '\P{^	Is_Yi_Syllables}', "");
    Expect(0, 42128, '\p{	Is_Yi_Syllables}', "");
    Expect(1, 42128, '\p{^	Is_Yi_Syllables}', "");
    Expect(1, 42128, '\P{	Is_Yi_Syllables}', "");
    Expect(0, 42128, '\P{^	Is_Yi_Syllables}', "");
    Error('\p{:=  in_YI_Syllables}');
    Error('\P{:=  in_YI_Syllables}');
    Expect(1, 42127, '\p{inyisyllables}', "");
    Expect(0, 42127, '\p{^inyisyllables}', "");
    Expect(0, 42127, '\P{inyisyllables}', "");
    Expect(1, 42127, '\P{^inyisyllables}', "");
    Expect(0, 42128, '\p{inyisyllables}', "");
    Expect(1, 42128, '\p{^inyisyllables}', "");
    Expect(1, 42128, '\P{inyisyllables}', "");
    Expect(0, 42128, '\P{^inyisyllables}', "");
    Expect(1, 42127, '\p{	-In_Yi_Syllables}', "");
    Expect(0, 42127, '\p{^	-In_Yi_Syllables}', "");
    Expect(0, 42127, '\P{	-In_Yi_Syllables}', "");
    Expect(1, 42127, '\P{^	-In_Yi_Syllables}', "");
    Expect(0, 42128, '\p{	-In_Yi_Syllables}', "");
    Expect(1, 42128, '\p{^	-In_Yi_Syllables}', "");
    Expect(1, 42128, '\P{	-In_Yi_Syllables}', "");
    Expect(0, 42128, '\P{^	-In_Yi_Syllables}', "");
    Error('\p{ Yijing_HEXAGRAM_Symbols/a/}');
    Error('\P{ Yijing_HEXAGRAM_Symbols/a/}');
    Expect(1, 19967, '\p{yijinghexagramsymbols}', "");
    Expect(0, 19967, '\p{^yijinghexagramsymbols}', "");
    Expect(0, 19967, '\P{yijinghexagramsymbols}', "");
    Expect(1, 19967, '\P{^yijinghexagramsymbols}', "");
    Expect(0, 19968, '\p{yijinghexagramsymbols}', "");
    Expect(1, 19968, '\p{^yijinghexagramsymbols}', "");
    Expect(1, 19968, '\P{yijinghexagramsymbols}', "");
    Expect(0, 19968, '\P{^yijinghexagramsymbols}', "");
    Expect(1, 19967, '\p{	_YIJING_HEXAGRAM_Symbols}', "");
    Expect(0, 19967, '\p{^	_YIJING_HEXAGRAM_Symbols}', "");
    Expect(0, 19967, '\P{	_YIJING_HEXAGRAM_Symbols}', "");
    Expect(1, 19967, '\P{^	_YIJING_HEXAGRAM_Symbols}', "");
    Expect(0, 19968, '\p{	_YIJING_HEXAGRAM_Symbols}', "");
    Expect(1, 19968, '\p{^	_YIJING_HEXAGRAM_Symbols}', "");
    Expect(1, 19968, '\P{	_YIJING_HEXAGRAM_Symbols}', "");
    Expect(0, 19968, '\P{^	_YIJING_HEXAGRAM_Symbols}', "");
    Error('\p{ 	IS_Yijing_hexagram_SYMBOLS:=}');
    Error('\P{ 	IS_Yijing_hexagram_SYMBOLS:=}');
    Expect(1, 19967, '\p{isyijinghexagramsymbols}', "");
    Expect(0, 19967, '\p{^isyijinghexagramsymbols}', "");
    Expect(0, 19967, '\P{isyijinghexagramsymbols}', "");
    Expect(1, 19967, '\P{^isyijinghexagramsymbols}', "");
    Expect(0, 19968, '\p{isyijinghexagramsymbols}', "");
    Expect(1, 19968, '\p{^isyijinghexagramsymbols}', "");
    Expect(1, 19968, '\P{isyijinghexagramsymbols}', "");
    Expect(0, 19968, '\P{^isyijinghexagramsymbols}', "");
    Expect(1, 19967, '\p{_IS_yijing_Hexagram_SYMBOLS}', "");
    Expect(0, 19967, '\p{^_IS_yijing_Hexagram_SYMBOLS}', "");
    Expect(0, 19967, '\P{_IS_yijing_Hexagram_SYMBOLS}', "");
    Expect(1, 19967, '\P{^_IS_yijing_Hexagram_SYMBOLS}', "");
    Expect(0, 19968, '\p{_IS_yijing_Hexagram_SYMBOLS}', "");
    Expect(1, 19968, '\p{^_IS_yijing_Hexagram_SYMBOLS}', "");
    Expect(1, 19968, '\P{_IS_yijing_Hexagram_SYMBOLS}', "");
    Expect(0, 19968, '\P{^_IS_yijing_Hexagram_SYMBOLS}', "");
    Error('\p{ _In_Yijing_HEXAGRAM_Symbols:=}');
    Error('\P{ _In_Yijing_HEXAGRAM_Symbols:=}');
    Expect(1, 19967, '\p{inyijinghexagramsymbols}', "");
    Expect(0, 19967, '\p{^inyijinghexagramsymbols}', "");
    Expect(0, 19967, '\P{inyijinghexagramsymbols}', "");
    Expect(1, 19967, '\P{^inyijinghexagramsymbols}', "");
    Expect(0, 19968, '\p{inyijinghexagramsymbols}', "");
    Expect(1, 19968, '\p{^inyijinghexagramsymbols}', "");
    Expect(1, 19968, '\P{inyijinghexagramsymbols}', "");
    Expect(0, 19968, '\P{^inyijinghexagramsymbols}', "");
    Expect(1, 19967, '\p{		In_Yijing_Hexagram_Symbols}', "");
    Expect(0, 19967, '\p{^		In_Yijing_Hexagram_Symbols}', "");
    Expect(0, 19967, '\P{		In_Yijing_Hexagram_Symbols}', "");
    Expect(1, 19967, '\P{^		In_Yijing_Hexagram_Symbols}', "");
    Expect(0, 19968, '\p{		In_Yijing_Hexagram_Symbols}', "");
    Expect(1, 19968, '\p{^		In_Yijing_Hexagram_Symbols}', "");
    Expect(1, 19968, '\P{		In_Yijing_Hexagram_Symbols}', "");
    Expect(0, 19968, '\P{^		In_Yijing_Hexagram_Symbols}', "");
    Error('\p{_/a/YIJING}');
    Error('\P{_/a/YIJING}');
    Expect(1, 19967, '\p{yijing}', "");
    Expect(0, 19967, '\p{^yijing}', "");
    Expect(0, 19967, '\P{yijing}', "");
    Expect(1, 19967, '\P{^yijing}', "");
    Expect(0, 19968, '\p{yijing}', "");
    Expect(1, 19968, '\p{^yijing}', "");
    Expect(1, 19968, '\P{yijing}', "");
    Expect(0, 19968, '\P{^yijing}', "");
    Expect(1, 19967, '\p{		Yijing}', "");
    Expect(0, 19967, '\p{^		Yijing}', "");
    Expect(0, 19967, '\P{		Yijing}', "");
    Expect(1, 19967, '\P{^		Yijing}', "");
    Expect(0, 19968, '\p{		Yijing}', "");
    Expect(1, 19968, '\p{^		Yijing}', "");
    Expect(1, 19968, '\P{		Yijing}', "");
    Expect(0, 19968, '\P{^		Yijing}', "");
    Error('\p{/a/ IS_Yijing}');
    Error('\P{/a/ IS_Yijing}');
    Expect(1, 19967, '\p{isyijing}', "");
    Expect(0, 19967, '\p{^isyijing}', "");
    Expect(0, 19967, '\P{isyijing}', "");
    Expect(1, 19967, '\P{^isyijing}', "");
    Expect(0, 19968, '\p{isyijing}', "");
    Expect(1, 19968, '\p{^isyijing}', "");
    Expect(1, 19968, '\P{isyijing}', "");
    Expect(0, 19968, '\P{^isyijing}', "");
    Expect(1, 19967, '\p{-is_Yijing}', "");
    Expect(0, 19967, '\p{^-is_Yijing}', "");
    Expect(0, 19967, '\P{-is_Yijing}', "");
    Expect(1, 19967, '\P{^-is_Yijing}', "");
    Expect(0, 19968, '\p{-is_Yijing}', "");
    Expect(1, 19968, '\p{^-is_Yijing}', "");
    Expect(1, 19968, '\P{-is_Yijing}', "");
    Expect(0, 19968, '\P{^-is_Yijing}', "");
    Error('\p{ 	In_YIJING:=}');
    Error('\P{ 	In_YIJING:=}');
    Expect(1, 19967, '\p{inyijing}', "");
    Expect(0, 19967, '\p{^inyijing}', "");
    Expect(0, 19967, '\P{inyijing}', "");
    Expect(1, 19967, '\P{^inyijing}', "");
    Expect(0, 19968, '\p{inyijing}', "");
    Expect(1, 19968, '\p{^inyijing}', "");
    Expect(1, 19968, '\P{inyijing}', "");
    Expect(0, 19968, '\P{^inyijing}', "");
    Expect(1, 19967, '\p{- In_YIJING}', "");
    Expect(0, 19967, '\p{^- In_YIJING}', "");
    Expect(0, 19967, '\P{- In_YIJING}', "");
    Expect(1, 19967, '\P{^- In_YIJING}', "");
    Expect(0, 19968, '\p{- In_YIJING}', "");
    Expect(1, 19968, '\p{^- In_YIJING}', "");
    Expect(1, 19968, '\P{- In_YIJING}', "");
    Expect(0, 19968, '\P{^- In_YIJING}', "");
    Error('\p{-/a/Zanabazar_square}');
    Error('\P{-/a/Zanabazar_square}');
    Expect(1, 72263, '\p{zanabazarsquare}', "");
    Expect(0, 72263, '\p{^zanabazarsquare}', "");
    Expect(0, 72263, '\P{zanabazarsquare}', "");
    Expect(1, 72263, '\P{^zanabazarsquare}', "");
    Expect(0, 72264, '\p{zanabazarsquare}', "");
    Expect(1, 72264, '\p{^zanabazarsquare}', "");
    Expect(1, 72264, '\P{zanabazarsquare}', "");
    Expect(0, 72264, '\P{^zanabazarsquare}', "");
    Expect(1, 72263, '\p{	-ZANABAZAR_Square}', "");
    Expect(0, 72263, '\p{^	-ZANABAZAR_Square}', "");
    Expect(0, 72263, '\P{	-ZANABAZAR_Square}', "");
    Expect(1, 72263, '\P{^	-ZANABAZAR_Square}', "");
    Expect(0, 72264, '\p{	-ZANABAZAR_Square}', "");
    Expect(1, 72264, '\p{^	-ZANABAZAR_Square}', "");
    Expect(1, 72264, '\P{	-ZANABAZAR_Square}', "");
    Expect(0, 72264, '\P{^	-ZANABAZAR_Square}', "");
    Error('\p{_/a/IS_zanabazar_square}');
    Error('\P{_/a/IS_zanabazar_square}');
    Expect(1, 72263, '\p{iszanabazarsquare}', "");
    Expect(0, 72263, '\p{^iszanabazarsquare}', "");
    Expect(0, 72263, '\P{iszanabazarsquare}', "");
    Expect(1, 72263, '\P{^iszanabazarsquare}', "");
    Expect(0, 72264, '\p{iszanabazarsquare}', "");
    Expect(1, 72264, '\p{^iszanabazarsquare}', "");
    Expect(1, 72264, '\P{iszanabazarsquare}', "");
    Expect(0, 72264, '\P{^iszanabazarsquare}', "");
    Expect(1, 72263, '\p{ Is_ZANABAZAR_square}', "");
    Expect(0, 72263, '\p{^ Is_ZANABAZAR_square}', "");
    Expect(0, 72263, '\P{ Is_ZANABAZAR_square}', "");
    Expect(1, 72263, '\P{^ Is_ZANABAZAR_square}', "");
    Expect(0, 72264, '\p{ Is_ZANABAZAR_square}', "");
    Expect(1, 72264, '\p{^ Is_ZANABAZAR_square}', "");
    Expect(1, 72264, '\P{ Is_ZANABAZAR_square}', "");
    Expect(0, 72264, '\P{^ Is_ZANABAZAR_square}', "");
    Error('\p{/a/__Zanb}');
    Error('\P{/a/__Zanb}');
    Expect(1, 72263, '\p{zanb}', "");
    Expect(0, 72263, '\p{^zanb}', "");
    Expect(0, 72263, '\P{zanb}', "");
    Expect(1, 72263, '\P{^zanb}', "");
    Expect(0, 72264, '\p{zanb}', "");
    Expect(1, 72264, '\p{^zanb}', "");
    Expect(1, 72264, '\P{zanb}', "");
    Expect(0, 72264, '\P{^zanb}', "");
    Expect(1, 72263, '\p{_-Zanb}', "");
    Expect(0, 72263, '\p{^_-Zanb}', "");
    Expect(0, 72263, '\P{_-Zanb}', "");
    Expect(1, 72263, '\P{^_-Zanb}', "");
    Expect(0, 72264, '\p{_-Zanb}', "");
    Expect(1, 72264, '\p{^_-Zanb}', "");
    Expect(1, 72264, '\P{_-Zanb}', "");
    Expect(0, 72264, '\P{^_-Zanb}', "");
    Error('\p{:= 	Is_zanb}');
    Error('\P{:= 	Is_zanb}');
    Expect(1, 72263, '\p{iszanb}', "");
    Expect(0, 72263, '\p{^iszanb}', "");
    Expect(0, 72263, '\P{iszanb}', "");
    Expect(1, 72263, '\P{^iszanb}', "");
    Expect(0, 72264, '\p{iszanb}', "");
    Expect(1, 72264, '\p{^iszanb}', "");
    Expect(1, 72264, '\P{iszanb}', "");
    Expect(0, 72264, '\P{^iszanb}', "");
    Expect(1, 72263, '\p{-IS_Zanb}', "");
    Expect(0, 72263, '\p{^-IS_Zanb}', "");
    Expect(0, 72263, '\P{-IS_Zanb}', "");
    Expect(1, 72263, '\P{^-IS_Zanb}', "");
    Expect(0, 72264, '\p{-IS_Zanb}', "");
    Expect(1, 72264, '\p{^-IS_Zanb}', "");
    Expect(1, 72264, '\P{-IS_Zanb}', "");
    Expect(0, 72264, '\P{^-IS_Zanb}', "");
    Error('\p{-/a/ZNAMENNY_Musical_notation}');
    Error('\P{-/a/ZNAMENNY_Musical_notation}');
    Expect(1, 118735, '\p{znamennymusicalnotation}', "");
    Expect(0, 118735, '\p{^znamennymusicalnotation}', "");
    Expect(0, 118735, '\P{znamennymusicalnotation}', "");
    Expect(1, 118735, '\P{^znamennymusicalnotation}', "");
    Expect(0, 118736, '\p{znamennymusicalnotation}', "");
    Expect(1, 118736, '\p{^znamennymusicalnotation}', "");
    Expect(1, 118736, '\P{znamennymusicalnotation}', "");
    Expect(0, 118736, '\P{^znamennymusicalnotation}', "");
    Expect(1, 118735, '\p{	-znamenny_Musical_NOTATION}', "");
    Expect(0, 118735, '\p{^	-znamenny_Musical_NOTATION}', "");
    Expect(0, 118735, '\P{	-znamenny_Musical_NOTATION}', "");
    Expect(1, 118735, '\P{^	-znamenny_Musical_NOTATION}', "");
    Expect(0, 118736, '\p{	-znamenny_Musical_NOTATION}', "");
    Expect(1, 118736, '\p{^	-znamenny_Musical_NOTATION}', "");
    Expect(1, 118736, '\P{	-znamenny_Musical_NOTATION}', "");
    Expect(0, 118736, '\P{^	-znamenny_Musical_NOTATION}', "");
    Error('\p{:=	_IS_ZNAMENNY_Musical_NOTATION}');
    Error('\P{:=	_IS_ZNAMENNY_Musical_NOTATION}');
    Expect(1, 118735, '\p{isznamennymusicalnotation}', "");
    Expect(0, 118735, '\p{^isznamennymusicalnotation}', "");
    Expect(0, 118735, '\P{isznamennymusicalnotation}', "");
    Expect(1, 118735, '\P{^isznamennymusicalnotation}', "");
    Expect(0, 118736, '\p{isznamennymusicalnotation}', "");
    Expect(1, 118736, '\p{^isznamennymusicalnotation}', "");
    Expect(1, 118736, '\P{isznamennymusicalnotation}', "");
    Expect(0, 118736, '\P{^isznamennymusicalnotation}', "");
    Expect(1, 118735, '\p{_ is_ZNAMENNY_Musical_Notation}', "");
    Expect(0, 118735, '\p{^_ is_ZNAMENNY_Musical_Notation}', "");
    Expect(0, 118735, '\P{_ is_ZNAMENNY_Musical_Notation}', "");
    Expect(1, 118735, '\P{^_ is_ZNAMENNY_Musical_Notation}', "");
    Expect(0, 118736, '\p{_ is_ZNAMENNY_Musical_Notation}', "");
    Expect(1, 118736, '\p{^_ is_ZNAMENNY_Musical_Notation}', "");
    Expect(1, 118736, '\P{_ is_ZNAMENNY_Musical_Notation}', "");
    Expect(0, 118736, '\P{^_ is_ZNAMENNY_Musical_Notation}', "");
    Error('\p{/a/in_znamenny_Musical_notation}');
    Error('\P{/a/in_znamenny_Musical_notation}');
    Expect(1, 118735, '\p{inznamennymusicalnotation}', "");
    Expect(0, 118735, '\p{^inznamennymusicalnotation}', "");
    Expect(0, 118735, '\P{inznamennymusicalnotation}', "");
    Expect(1, 118735, '\P{^inznamennymusicalnotation}', "");
    Expect(0, 118736, '\p{inznamennymusicalnotation}', "");
    Expect(1, 118736, '\p{^inznamennymusicalnotation}', "");
    Expect(1, 118736, '\P{inznamennymusicalnotation}', "");
    Expect(0, 118736, '\P{^inznamennymusicalnotation}', "");
    Expect(1, 118735, '\p{__In_Znamenny_musical_notation}', "");
    Expect(0, 118735, '\p{^__In_Znamenny_musical_notation}', "");
    Expect(0, 118735, '\P{__In_Znamenny_musical_notation}', "");
    Expect(1, 118735, '\P{^__In_Znamenny_musical_notation}', "");
    Expect(0, 118736, '\p{__In_Znamenny_musical_notation}', "");
    Expect(1, 118736, '\p{^__In_Znamenny_musical_notation}', "");
    Expect(1, 118736, '\P{__In_Znamenny_musical_notation}', "");
    Expect(0, 118736, '\P{^__In_Znamenny_musical_notation}', "");
    Error('\p{_-Znamenny_Music:=}');
    Error('\P{_-Znamenny_Music:=}');
    Expect(1, 118735, '\p{znamennymusic}', "");
    Expect(0, 118735, '\p{^znamennymusic}', "");
    Expect(0, 118735, '\P{znamennymusic}', "");
    Expect(1, 118735, '\P{^znamennymusic}', "");
    Expect(0, 118736, '\p{znamennymusic}', "");
    Expect(1, 118736, '\p{^znamennymusic}', "");
    Expect(1, 118736, '\P{znamennymusic}', "");
    Expect(0, 118736, '\P{^znamennymusic}', "");
    Expect(1, 118735, '\p{ Znamenny_music}', "");
    Expect(0, 118735, '\p{^ Znamenny_music}', "");
    Expect(0, 118735, '\P{ Znamenny_music}', "");
    Expect(1, 118735, '\P{^ Znamenny_music}', "");
    Expect(0, 118736, '\p{ Znamenny_music}', "");
    Expect(1, 118736, '\p{^ Znamenny_music}', "");
    Expect(1, 118736, '\P{ Znamenny_music}', "");
    Expect(0, 118736, '\P{^ Znamenny_music}', "");
    Error('\p{-/a/IS_znamenny_music}');
    Error('\P{-/a/IS_znamenny_music}');
    Expect(1, 118735, '\p{isznamennymusic}', "");
    Expect(0, 118735, '\p{^isznamennymusic}', "");
    Expect(0, 118735, '\P{isznamennymusic}', "");
    Expect(1, 118735, '\P{^isznamennymusic}', "");
    Expect(0, 118736, '\p{isznamennymusic}', "");
    Expect(1, 118736, '\p{^isznamennymusic}', "");
    Expect(1, 118736, '\P{isznamennymusic}', "");
    Expect(0, 118736, '\P{^isznamennymusic}', "");
    Expect(1, 118735, '\p{-	IS_znamenny_Music}', "");
    Expect(0, 118735, '\p{^-	IS_znamenny_Music}', "");
    Expect(0, 118735, '\P{-	IS_znamenny_Music}', "");
    Expect(1, 118735, '\P{^-	IS_znamenny_Music}', "");
    Expect(0, 118736, '\p{-	IS_znamenny_Music}', "");
    Expect(1, 118736, '\p{^-	IS_znamenny_Music}', "");
    Expect(1, 118736, '\P{-	IS_znamenny_Music}', "");
    Expect(0, 118736, '\P{^-	IS_znamenny_Music}', "");
    Error('\p{/a/	In_Znamenny_music}');
    Error('\P{/a/	In_Znamenny_music}');
    Expect(1, 118735, '\p{inznamennymusic}', "");
    Expect(0, 118735, '\p{^inznamennymusic}', "");
    Expect(0, 118735, '\P{inznamennymusic}', "");
    Expect(1, 118735, '\P{^inznamennymusic}', "");
    Expect(0, 118736, '\p{inznamennymusic}', "");
    Expect(1, 118736, '\p{^inznamennymusic}', "");
    Expect(1, 118736, '\P{inznamennymusic}', "");
    Expect(0, 118736, '\P{^inznamennymusic}', "");
    Expect(1, 118735, '\p{ 	In_znamenny_MUSIC}', "");
    Expect(0, 118735, '\p{^ 	In_znamenny_MUSIC}', "");
    Expect(0, 118735, '\P{ 	In_znamenny_MUSIC}', "");
    Expect(1, 118735, '\P{^ 	In_znamenny_MUSIC}', "");
    Expect(0, 118736, '\p{ 	In_znamenny_MUSIC}', "");
    Expect(1, 118736, '\p{^ 	In_znamenny_MUSIC}', "");
    Expect(1, 118736, '\P{ 	In_znamenny_MUSIC}', "");
    Expect(0, 118736, '\P{^ 	In_znamenny_MUSIC}', "");
    Error('\p{perlcharnames}');
    Error('\P{perlcharnames}');
    Error('\p{perldecimaldigit}');
    Error('\P{perldecimaldigit}');
    Error('\p{perldecompositionmapping}');
    Error('\P{perldecompositionmapping}');
    Error('\p{Quotation_Mark=:=_NO}');
    Error('\P{Quotation_Mark=:=_NO}');
    Expect(1, 65380, '\p{Quotation_Mark=:\ANo\z:}', "");;
    Expect(0, 65379, '\p{Quotation_Mark=:\ANo\z:}', "");;
    Expect(1, 65380, '\p{Quotation_Mark=no}', "");
    Expect(0, 65380, '\p{^Quotation_Mark=no}', "");
    Expect(0, 65380, '\P{Quotation_Mark=no}', "");
    Expect(1, 65380, '\P{^Quotation_Mark=no}', "");
    Expect(0, 65379, '\p{Quotation_Mark=no}', "");
    Expect(1, 65379, '\p{^Quotation_Mark=no}', "");
    Expect(1, 65379, '\P{Quotation_Mark=no}', "");
    Expect(0, 65379, '\P{^Quotation_Mark=no}', "");
    Expect(1, 65380, '\p{Quotation_Mark=:\Ano\z:}', "");;
    Expect(0, 65379, '\p{Quotation_Mark=:\Ano\z:}', "");;
    Expect(1, 65380, '\p{Quotation_Mark: _No}', "");
    Expect(0, 65380, '\p{^Quotation_Mark: _No}', "");
    Expect(0, 65380, '\P{Quotation_Mark: _No}', "");
    Expect(1, 65380, '\P{^Quotation_Mark: _No}', "");
    Expect(0, 65379, '\p{Quotation_Mark: _No}', "");
    Expect(1, 65379, '\p{^Quotation_Mark: _No}', "");
    Expect(1, 65379, '\P{Quotation_Mark: _No}', "");
    Expect(0, 65379, '\P{^Quotation_Mark: _No}', "");
    Error('\p{QMark=		N:=}');
    Error('\P{QMark=		N:=}');
    Expect(1, 65380, '\p{QMark=:\AN\z:}', "");;
    Expect(0, 65379, '\p{QMark=:\AN\z:}', "");;
    Expect(1, 65380, '\p{QMark=n}', "");
    Expect(0, 65380, '\p{^QMark=n}', "");
    Expect(0, 65380, '\P{QMark=n}', "");
    Expect(1, 65380, '\P{^QMark=n}', "");
    Expect(0, 65379, '\p{QMark=n}', "");
    Expect(1, 65379, '\p{^QMark=n}', "");
    Expect(1, 65379, '\P{QMark=n}', "");
    Expect(0, 65379, '\P{^QMark=n}', "");
    Expect(1, 65380, '\p{QMark=:\An\z:}', "");;
    Expect(0, 65379, '\p{QMark=:\An\z:}', "");;
    Expect(1, 65380, '\p{QMark:   -N}', "");
    Expect(0, 65380, '\p{^QMark:   -N}', "");
    Expect(0, 65380, '\P{QMark:   -N}', "");
    Expect(1, 65380, '\P{^QMark:   -N}', "");
    Expect(0, 65379, '\p{QMark:   -N}', "");
    Expect(1, 65379, '\p{^QMark:   -N}', "");
    Expect(1, 65379, '\P{QMark:   -N}', "");
    Expect(0, 65379, '\P{^QMark:   -N}', "");
    Error('\p{Is_Quotation_Mark=/a/_F}');
    Error('\P{Is_Quotation_Mark=/a/_F}');
    Expect(1, 65380, '\p{Is_Quotation_Mark=f}', "");
    Expect(0, 65380, '\p{^Is_Quotation_Mark=f}', "");
    Expect(0, 65380, '\P{Is_Quotation_Mark=f}', "");
    Expect(1, 65380, '\P{^Is_Quotation_Mark=f}', "");
    Expect(0, 65379, '\p{Is_Quotation_Mark=f}', "");
    Expect(1, 65379, '\p{^Is_Quotation_Mark=f}', "");
    Expect(1, 65379, '\P{Is_Quotation_Mark=f}', "");
    Expect(0, 65379, '\P{^Is_Quotation_Mark=f}', "");
    Expect(1, 65380, '\p{Is_Quotation_Mark=_-F}', "");
    Expect(0, 65380, '\p{^Is_Quotation_Mark=_-F}', "");
    Expect(0, 65380, '\P{Is_Quotation_Mark=_-F}', "");
    Expect(1, 65380, '\P{^Is_Quotation_Mark=_-F}', "");
    Expect(0, 65379, '\p{Is_Quotation_Mark=_-F}', "");
    Expect(1, 65379, '\p{^Is_Quotation_Mark=_-F}', "");
    Expect(1, 65379, '\P{Is_Quotation_Mark=_-F}', "");
    Expect(0, 65379, '\P{^Is_Quotation_Mark=_-F}', "");
    Error('\p{Is_QMark=-/a/false}');
    Error('\P{Is_QMark=-/a/false}');
    Expect(1, 65380, '\p{Is_QMark:	false}', "");
    Expect(0, 65380, '\p{^Is_QMark:	false}', "");
    Expect(0, 65380, '\P{Is_QMark:	false}', "");
    Expect(1, 65380, '\P{^Is_QMark:	false}', "");
    Expect(0, 65379, '\p{Is_QMark:	false}', "");
    Expect(1, 65379, '\p{^Is_QMark:	false}', "");
    Expect(1, 65379, '\P{Is_QMark:	false}', "");
    Expect(0, 65379, '\P{^Is_QMark:	false}', "");
    Expect(1, 65380, '\p{Is_QMark=__False}', "");
    Expect(0, 65380, '\p{^Is_QMark=__False}', "");
    Expect(0, 65380, '\P{Is_QMark=__False}', "");
    Expect(1, 65380, '\P{^Is_QMark=__False}', "");
    Expect(0, 65379, '\p{Is_QMark=__False}', "");
    Expect(1, 65379, '\p{^Is_QMark=__False}', "");
    Expect(1, 65379, '\P{Is_QMark=__False}', "");
    Expect(0, 65379, '\P{^Is_QMark=__False}', "");
    Error('\p{Quotation_Mark=/a/-	Yes}');
    Error('\P{Quotation_Mark=/a/-	Yes}');
    Expect(1, 65379, '\p{Quotation_Mark=:\AYes\z:}', "");;
    Expect(0, 65380, '\p{Quotation_Mark=:\AYes\z:}', "");;
    Expect(1, 65379, '\p{Quotation_Mark=yes}', "");
    Expect(0, 65379, '\p{^Quotation_Mark=yes}', "");
    Expect(0, 65379, '\P{Quotation_Mark=yes}', "");
    Expect(1, 65379, '\P{^Quotation_Mark=yes}', "");
    Expect(0, 65380, '\p{Quotation_Mark=yes}', "");
    Expect(1, 65380, '\p{^Quotation_Mark=yes}', "");
    Expect(1, 65380, '\P{Quotation_Mark=yes}', "");
    Expect(0, 65380, '\P{^Quotation_Mark=yes}', "");
    Expect(1, 65379, '\p{Quotation_Mark=:\Ayes\z:}', "");;
    Expect(0, 65380, '\p{Quotation_Mark=:\Ayes\z:}', "");;
    Expect(1, 65379, '\p{Quotation_Mark=__yes}', "");
    Expect(0, 65379, '\p{^Quotation_Mark=__yes}', "");
    Expect(0, 65379, '\P{Quotation_Mark=__yes}', "");
    Expect(1, 65379, '\P{^Quotation_Mark=__yes}', "");
    Expect(0, 65380, '\p{Quotation_Mark=__yes}', "");
    Expect(1, 65380, '\p{^Quotation_Mark=__yes}', "");
    Expect(1, 65380, '\P{Quotation_Mark=__yes}', "");
    Expect(0, 65380, '\P{^Quotation_Mark=__yes}', "");
    Error('\p{QMark=-Y/a/}');
    Error('\P{QMark=-Y/a/}');
    Expect(1, 65379, '\p{QMark=:\AY\z:}', "");;
    Expect(0, 65380, '\p{QMark=:\AY\z:}', "");;
    Expect(1, 65379, '\p{QMark=y}', "");
    Expect(0, 65379, '\p{^QMark=y}', "");
    Expect(0, 65379, '\P{QMark=y}', "");
    Expect(1, 65379, '\P{^QMark=y}', "");
    Expect(0, 65380, '\p{QMark=y}', "");
    Expect(1, 65380, '\p{^QMark=y}', "");
    Expect(1, 65380, '\P{QMark=y}', "");
    Expect(0, 65380, '\P{^QMark=y}', "");
    Expect(1, 65379, '\p{QMark=:\Ay\z:}', "");;
    Expect(0, 65380, '\p{QMark=:\Ay\z:}', "");;
    Expect(1, 65379, '\p{QMark=	Y}', "");
    Expect(0, 65379, '\p{^QMark=	Y}', "");
    Expect(0, 65379, '\P{QMark=	Y}', "");
    Expect(1, 65379, '\P{^QMark=	Y}', "");
    Expect(0, 65380, '\p{QMark=	Y}', "");
    Expect(1, 65380, '\p{^QMark=	Y}', "");
    Expect(1, 65380, '\P{QMark=	Y}', "");
    Expect(0, 65380, '\P{^QMark=	Y}', "");
    Error('\p{Is_Quotation_Mark=/a/	T}');
    Error('\P{Is_Quotation_Mark=/a/	T}');
    Expect(1, 65379, '\p{Is_Quotation_Mark=t}', "");
    Expect(0, 65379, '\p{^Is_Quotation_Mark=t}', "");
    Expect(0, 65379, '\P{Is_Quotation_Mark=t}', "");
    Expect(1, 65379, '\P{^Is_Quotation_Mark=t}', "");
    Expect(0, 65380, '\p{Is_Quotation_Mark=t}', "");
    Expect(1, 65380, '\p{^Is_Quotation_Mark=t}', "");
    Expect(1, 65380, '\P{Is_Quotation_Mark=t}', "");
    Expect(0, 65380, '\P{^Is_Quotation_Mark=t}', "");
    Expect(1, 65379, '\p{Is_Quotation_Mark:		T}', "");
    Expect(0, 65379, '\p{^Is_Quotation_Mark:		T}', "");
    Expect(0, 65379, '\P{Is_Quotation_Mark:		T}', "");
    Expect(1, 65379, '\P{^Is_Quotation_Mark:		T}', "");
    Expect(0, 65380, '\p{Is_Quotation_Mark:		T}', "");
    Expect(1, 65380, '\p{^Is_Quotation_Mark:		T}', "");
    Expect(1, 65380, '\P{Is_Quotation_Mark:		T}', "");
    Expect(0, 65380, '\P{^Is_Quotation_Mark:		T}', "");
    Error('\p{Is_QMark=:=_ True}');
    Error('\P{Is_QMark=:=_ True}');
    Expect(1, 65379, '\p{Is_QMark=true}', "");
    Expect(0, 65379, '\p{^Is_QMark=true}', "");
    Expect(0, 65379, '\P{Is_QMark=true}', "");
    Expect(1, 65379, '\P{^Is_QMark=true}', "");
    Expect(0, 65380, '\p{Is_QMark=true}', "");
    Expect(1, 65380, '\p{^Is_QMark=true}', "");
    Expect(1, 65380, '\P{Is_QMark=true}', "");
    Expect(0, 65380, '\P{^Is_QMark=true}', "");
    Expect(1, 65379, '\p{Is_QMark=--true}', "");
    Expect(0, 65379, '\p{^Is_QMark=--true}', "");
    Expect(0, 65379, '\P{Is_QMark=--true}', "");
    Expect(1, 65379, '\P{^Is_QMark=--true}', "");
    Expect(0, 65380, '\p{Is_QMark=--true}', "");
    Expect(1, 65380, '\p{^Is_QMark=--true}', "");
    Expect(1, 65380, '\P{Is_QMark=--true}', "");
    Expect(0, 65380, '\P{^Is_QMark=--true}', "");
    Error('\p{Radical=	/a/No}');
    Error('\P{Radical=	/a/No}');
    Expect(1, 12246, '\p{Radical=:\ANo\z:}', "");;
    Expect(0, 12245, '\p{Radical=:\ANo\z:}', "");;
    Expect(1, 12246, '\p{Radical=no}', "");
    Expect(0, 12246, '\p{^Radical=no}', "");
    Expect(0, 12246, '\P{Radical=no}', "");
    Expect(1, 12246, '\P{^Radical=no}', "");
    Expect(0, 12245, '\p{Radical=no}', "");
    Expect(1, 12245, '\p{^Radical=no}', "");
    Expect(1, 12245, '\P{Radical=no}', "");
    Expect(0, 12245, '\P{^Radical=no}', "");
    Expect(1, 12246, '\p{Radical=:\Ano\z:}', "");;
    Expect(0, 12245, '\p{Radical=:\Ano\z:}', "");;
    Expect(1, 12246, '\p{Radical= NO}', "");
    Expect(0, 12246, '\p{^Radical= NO}', "");
    Expect(0, 12246, '\P{Radical= NO}', "");
    Expect(1, 12246, '\P{^Radical= NO}', "");
    Expect(0, 12245, '\p{Radical= NO}', "");
    Expect(1, 12245, '\p{^Radical= NO}', "");
    Expect(1, 12245, '\P{Radical= NO}', "");
    Expect(0, 12245, '\P{^Radical= NO}', "");
    Error('\p{Is_Radical=	-N:=}');
    Error('\P{Is_Radical=	-N:=}');
    Expect(1, 12246, '\p{Is_Radical:	n}', "");
    Expect(0, 12246, '\p{^Is_Radical:	n}', "");
    Expect(0, 12246, '\P{Is_Radical:	n}', "");
    Expect(1, 12246, '\P{^Is_Radical:	n}', "");
    Expect(0, 12245, '\p{Is_Radical:	n}', "");
    Expect(1, 12245, '\p{^Is_Radical:	n}', "");
    Expect(1, 12245, '\P{Is_Radical:	n}', "");
    Expect(0, 12245, '\P{^Is_Radical:	n}', "");
    Expect(1, 12246, '\p{Is_Radical=	 n}', "");
    Expect(0, 12246, '\p{^Is_Radical=	 n}', "");
    Expect(0, 12246, '\P{Is_Radical=	 n}', "");
    Expect(1, 12246, '\P{^Is_Radical=	 n}', "");
    Expect(0, 12245, '\p{Is_Radical=	 n}', "");
    Expect(1, 12245, '\p{^Is_Radical=	 n}', "");
    Expect(1, 12245, '\P{Is_Radical=	 n}', "");
    Expect(0, 12245, '\P{^Is_Radical=	 n}', "");
    Error('\p{Radical= _F/a/}');
    Error('\P{Radical= _F/a/}');
    Expect(1, 12246, '\p{Radical=:\AF\z:}', "");;
    Expect(0, 12245, '\p{Radical=:\AF\z:}', "");;
    Expect(1, 12246, '\p{Radical=f}', "");
    Expect(0, 12246, '\p{^Radical=f}', "");
    Expect(0, 12246, '\P{Radical=f}', "");
    Expect(1, 12246, '\P{^Radical=f}', "");
    Expect(0, 12245, '\p{Radical=f}', "");
    Expect(1, 12245, '\p{^Radical=f}', "");
    Expect(1, 12245, '\P{Radical=f}', "");
    Expect(0, 12245, '\P{^Radical=f}', "");
    Expect(1, 12246, '\p{Radical=:\Af\z:}', "");;
    Expect(0, 12245, '\p{Radical=:\Af\z:}', "");;
    Expect(1, 12246, '\p{Radical=-F}', "");
    Expect(0, 12246, '\p{^Radical=-F}', "");
    Expect(0, 12246, '\P{Radical=-F}', "");
    Expect(1, 12246, '\P{^Radical=-F}', "");
    Expect(0, 12245, '\p{Radical=-F}', "");
    Expect(1, 12245, '\p{^Radical=-F}', "");
    Expect(1, 12245, '\P{Radical=-F}', "");
    Expect(0, 12245, '\P{^Radical=-F}', "");
    Error('\p{Is_Radical=/a/	_false}');
    Error('\P{Is_Radical=/a/	_false}');
    Expect(1, 12246, '\p{Is_Radical:   false}', "");
    Expect(0, 12246, '\p{^Is_Radical:   false}', "");
    Expect(0, 12246, '\P{Is_Radical:   false}', "");
    Expect(1, 12246, '\P{^Is_Radical:   false}', "");
    Expect(0, 12245, '\p{Is_Radical:   false}', "");
    Expect(1, 12245, '\p{^Is_Radical:   false}', "");
    Expect(1, 12245, '\P{Is_Radical:   false}', "");
    Expect(0, 12245, '\P{^Is_Radical:   false}', "");
    Expect(1, 12246, '\p{Is_Radical=_	False}', "");
    Expect(0, 12246, '\p{^Is_Radical=_	False}', "");
    Expect(0, 12246, '\P{Is_Radical=_	False}', "");
    Expect(1, 12246, '\P{^Is_Radical=_	False}', "");
    Expect(0, 12245, '\p{Is_Radical=_	False}', "");
    Expect(1, 12245, '\p{^Is_Radical=_	False}', "");
    Expect(1, 12245, '\P{Is_Radical=_	False}', "");
    Expect(0, 12245, '\P{^Is_Radical=_	False}', "");
    Error('\p{Radical=__YES:=}');
    Error('\P{Radical=__YES:=}');
    Expect(1, 12245, '\p{Radical=:\AYes\z:}', "");;
    Expect(0, 12246, '\p{Radical=:\AYes\z:}', "");;
    Expect(1, 12245, '\p{Radical=yes}', "");
    Expect(0, 12245, '\p{^Radical=yes}', "");
    Expect(0, 12245, '\P{Radical=yes}', "");
    Expect(1, 12245, '\P{^Radical=yes}', "");
    Expect(0, 12246, '\p{Radical=yes}', "");
    Expect(1, 12246, '\p{^Radical=yes}', "");
    Expect(1, 12246, '\P{Radical=yes}', "");
    Expect(0, 12246, '\P{^Radical=yes}', "");
    Expect(1, 12245, '\p{Radical=:\Ayes\z:}', "");;
    Expect(0, 12246, '\p{Radical=:\Ayes\z:}', "");;
    Expect(1, 12245, '\p{Radical=_-YES}', "");
    Expect(0, 12245, '\p{^Radical=_-YES}', "");
    Expect(0, 12245, '\P{Radical=_-YES}', "");
    Expect(1, 12245, '\P{^Radical=_-YES}', "");
    Expect(0, 12246, '\p{Radical=_-YES}', "");
    Expect(1, 12246, '\p{^Radical=_-YES}', "");
    Expect(1, 12246, '\P{Radical=_-YES}', "");
    Expect(0, 12246, '\P{^Radical=_-YES}', "");
    Error('\p{Is_Radical=	:=Y}');
    Error('\P{Is_Radical=	:=Y}');
    Expect(1, 12245, '\p{Is_Radical=y}', "");
    Expect(0, 12245, '\p{^Is_Radical=y}', "");
    Expect(0, 12245, '\P{Is_Radical=y}', "");
    Expect(1, 12245, '\P{^Is_Radical=y}', "");
    Expect(0, 12246, '\p{Is_Radical=y}', "");
    Expect(1, 12246, '\p{^Is_Radical=y}', "");
    Expect(1, 12246, '\P{Is_Radical=y}', "");
    Expect(0, 12246, '\P{^Is_Radical=y}', "");
    Expect(1, 12245, '\p{Is_Radical=--Y}', "");
    Expect(0, 12245, '\p{^Is_Radical=--Y}', "");
    Expect(0, 12245, '\P{Is_Radical=--Y}', "");
    Expect(1, 12245, '\P{^Is_Radical=--Y}', "");
    Expect(0, 12246, '\p{Is_Radical=--Y}', "");
    Expect(1, 12246, '\p{^Is_Radical=--Y}', "");
    Expect(1, 12246, '\P{Is_Radical=--Y}', "");
    Expect(0, 12246, '\P{^Is_Radical=--Y}', "");
    Error('\p{Radical=-:=t}');
    Error('\P{Radical=-:=t}');
    Expect(1, 12245, '\p{Radical=:\AT\z:}', "");;
    Expect(0, 12246, '\p{Radical=:\AT\z:}', "");;
    Expect(1, 12245, '\p{Radical:	t}', "");
    Expect(0, 12245, '\p{^Radical:	t}', "");
    Expect(0, 12245, '\P{Radical:	t}', "");
    Expect(1, 12245, '\P{^Radical:	t}', "");
    Expect(0, 12246, '\p{Radical:	t}', "");
    Expect(1, 12246, '\p{^Radical:	t}', "");
    Expect(1, 12246, '\P{Radical:	t}', "");
    Expect(0, 12246, '\P{^Radical:	t}', "");
    Expect(1, 12245, '\p{Radical=:\At\z:}', "");;
    Expect(0, 12246, '\p{Radical=:\At\z:}', "");;
    Expect(1, 12245, '\p{Radical=T}', "");
    Expect(0, 12245, '\p{^Radical=T}', "");
    Expect(0, 12245, '\P{Radical=T}', "");
    Expect(1, 12245, '\P{^Radical=T}', "");
    Expect(0, 12246, '\p{Radical=T}', "");
    Expect(1, 12246, '\p{^Radical=T}', "");
    Expect(1, 12246, '\P{Radical=T}', "");
    Expect(0, 12246, '\P{^Radical=T}', "");
    Error('\p{Is_Radical=/a/		TRUE}');
    Error('\P{Is_Radical=/a/		TRUE}');
    Expect(1, 12245, '\p{Is_Radical:true}', "");
    Expect(0, 12245, '\p{^Is_Radical:true}', "");
    Expect(0, 12245, '\P{Is_Radical:true}', "");
    Expect(1, 12245, '\P{^Is_Radical:true}', "");
    Expect(0, 12246, '\p{Is_Radical:true}', "");
    Expect(1, 12246, '\p{^Is_Radical:true}', "");
    Expect(1, 12246, '\P{Is_Radical:true}', "");
    Expect(0, 12246, '\P{^Is_Radical:true}', "");
    Expect(1, 12245, '\p{Is_Radical=	true}', "");
    Expect(0, 12245, '\p{^Is_Radical=	true}', "");
    Expect(0, 12245, '\P{Is_Radical=	true}', "");
    Expect(1, 12245, '\P{^Is_Radical=	true}', "");
    Expect(0, 12246, '\p{Is_Radical=	true}', "");
    Expect(1, 12246, '\p{^Is_Radical=	true}', "");
    Expect(1, 12246, '\P{Is_Radical=	true}', "");
    Expect(0, 12246, '\P{^Is_Radical=	true}', "");
    Error('\p{Regional_Indicator= 	No:=}');
    Error('\P{Regional_Indicator= 	No:=}');
    Expect(1, 127488, '\p{Regional_Indicator=:\ANo\z:}', "");;
    Expect(0, 127487, '\p{Regional_Indicator=:\ANo\z:}', "");;
    Expect(1, 127488, '\p{Regional_Indicator=no}', "");
    Expect(0, 127488, '\p{^Regional_Indicator=no}', "");
    Expect(0, 127488, '\P{Regional_Indicator=no}', "");
    Expect(1, 127488, '\P{^Regional_Indicator=no}', "");
    Expect(0, 127487, '\p{Regional_Indicator=no}', "");
    Expect(1, 127487, '\p{^Regional_Indicator=no}', "");
    Expect(1, 127487, '\P{Regional_Indicator=no}', "");
    Expect(0, 127487, '\P{^Regional_Indicator=no}', "");
    Expect(1, 127488, '\p{Regional_Indicator=:\Ano\z:}', "");;
    Expect(0, 127487, '\p{Regional_Indicator=:\Ano\z:}', "");;
    Expect(1, 127488, '\p{Regional_Indicator=--No}', "");
    Expect(0, 127488, '\p{^Regional_Indicator=--No}', "");
    Expect(0, 127488, '\P{Regional_Indicator=--No}', "");
    Expect(1, 127488, '\P{^Regional_Indicator=--No}', "");
    Expect(0, 127487, '\p{Regional_Indicator=--No}', "");
    Expect(1, 127487, '\p{^Regional_Indicator=--No}', "");
    Expect(1, 127487, '\P{Regional_Indicator=--No}', "");
    Expect(0, 127487, '\P{^Regional_Indicator=--No}', "");
    Error('\p{RI=	:=N}');
    Error('\P{RI=	:=N}');
    Expect(1, 127488, '\p{RI=:\AN\z:}', "");;
    Expect(0, 127487, '\p{RI=:\AN\z:}', "");;
    Expect(1, 127488, '\p{RI=n}', "");
    Expect(0, 127488, '\p{^RI=n}', "");
    Expect(0, 127488, '\P{RI=n}', "");
    Expect(1, 127488, '\P{^RI=n}', "");
    Expect(0, 127487, '\p{RI=n}', "");
    Expect(1, 127487, '\p{^RI=n}', "");
    Expect(1, 127487, '\P{RI=n}', "");
    Expect(0, 127487, '\P{^RI=n}', "");
    Expect(1, 127488, '\p{RI=:\An\z:}', "");;
    Expect(0, 127487, '\p{RI=:\An\z:}', "");;
    Expect(1, 127488, '\p{RI= 	n}', "");
    Expect(0, 127488, '\p{^RI= 	n}', "");
    Expect(0, 127488, '\P{RI= 	n}', "");
    Expect(1, 127488, '\P{^RI= 	n}', "");
    Expect(0, 127487, '\p{RI= 	n}', "");
    Expect(1, 127487, '\p{^RI= 	n}', "");
    Expect(1, 127487, '\P{RI= 	n}', "");
    Expect(0, 127487, '\P{^RI= 	n}', "");
    Error('\p{Is_Regional_Indicator=/a/	f}');
    Error('\P{Is_Regional_Indicator=/a/	f}');
    Expect(1, 127488, '\p{Is_Regional_Indicator=f}', "");
    Expect(0, 127488, '\p{^Is_Regional_Indicator=f}', "");
    Expect(0, 127488, '\P{Is_Regional_Indicator=f}', "");
    Expect(1, 127488, '\P{^Is_Regional_Indicator=f}', "");
    Expect(0, 127487, '\p{Is_Regional_Indicator=f}', "");
    Expect(1, 127487, '\p{^Is_Regional_Indicator=f}', "");
    Expect(1, 127487, '\P{Is_Regional_Indicator=f}', "");
    Expect(0, 127487, '\P{^Is_Regional_Indicator=f}', "");
    Expect(1, 127488, '\p{Is_Regional_Indicator=- f}', "");
    Expect(0, 127488, '\p{^Is_Regional_Indicator=- f}', "");
    Expect(0, 127488, '\P{Is_Regional_Indicator=- f}', "");
    Expect(1, 127488, '\P{^Is_Regional_Indicator=- f}', "");
    Expect(0, 127487, '\p{Is_Regional_Indicator=- f}', "");
    Expect(1, 127487, '\p{^Is_Regional_Indicator=- f}', "");
    Expect(1, 127487, '\P{Is_Regional_Indicator=- f}', "");
    Expect(0, 127487, '\P{^Is_Regional_Indicator=- f}', "");
    Error('\p{Is_RI=:=_False}');
    Error('\P{Is_RI=:=_False}');
    Expect(1, 127488, '\p{Is_RI:false}', "");
    Expect(0, 127488, '\p{^Is_RI:false}', "");
    Expect(0, 127488, '\P{Is_RI:false}', "");
    Expect(1, 127488, '\P{^Is_RI:false}', "");
    Expect(0, 127487, '\p{Is_RI:false}', "");
    Expect(1, 127487, '\p{^Is_RI:false}', "");
    Expect(1, 127487, '\P{Is_RI:false}', "");
    Expect(0, 127487, '\P{^Is_RI:false}', "");
    Expect(1, 127488, '\p{Is_RI=  False}', "");
    Expect(0, 127488, '\p{^Is_RI=  False}', "");
    Expect(0, 127488, '\P{Is_RI=  False}', "");
    Expect(1, 127488, '\P{^Is_RI=  False}', "");
    Expect(0, 127487, '\p{Is_RI=  False}', "");
    Expect(1, 127487, '\p{^Is_RI=  False}', "");
    Expect(1, 127487, '\P{Is_RI=  False}', "");
    Expect(0, 127487, '\P{^Is_RI=  False}', "");
    Error('\p{Regional_Indicator=/a/YES}');
    Error('\P{Regional_Indicator=/a/YES}');
    Expect(1, 127487, '\p{Regional_Indicator=:\AYes\z:}', "");;
    Expect(0, 127488, '\p{Regional_Indicator=:\AYes\z:}', "");;
    Expect(1, 127487, '\p{Regional_Indicator=yes}', "");
    Expect(0, 127487, '\p{^Regional_Indicator=yes}', "");
    Expect(0, 127487, '\P{Regional_Indicator=yes}', "");
    Expect(1, 127487, '\P{^Regional_Indicator=yes}', "");
    Expect(0, 127488, '\p{Regional_Indicator=yes}', "");
    Expect(1, 127488, '\p{^Regional_Indicator=yes}', "");
    Expect(1, 127488, '\P{Regional_Indicator=yes}', "");
    Expect(0, 127488, '\P{^Regional_Indicator=yes}', "");
    Expect(1, 127487, '\p{Regional_Indicator=:\Ayes\z:}', "");;
    Expect(0, 127488, '\p{Regional_Indicator=:\Ayes\z:}', "");;
    Expect(1, 127487, '\p{Regional_Indicator=	YES}', "");
    Expect(0, 127487, '\p{^Regional_Indicator=	YES}', "");
    Expect(0, 127487, '\P{Regional_Indicator=	YES}', "");
    Expect(1, 127487, '\P{^Regional_Indicator=	YES}', "");
    Expect(0, 127488, '\p{Regional_Indicator=	YES}', "");
    Expect(1, 127488, '\p{^Regional_Indicator=	YES}', "");
    Expect(1, 127488, '\P{Regional_Indicator=	YES}', "");
    Expect(0, 127488, '\P{^Regional_Indicator=	YES}', "");
    Error('\p{RI:   /a/Y}');
    Error('\P{RI:   /a/Y}');
    Expect(1, 127487, '\p{RI=:\AY\z:}', "");;
    Expect(0, 127488, '\p{RI=:\AY\z:}', "");;
    Expect(1, 127487, '\p{RI=y}', "");
    Expect(0, 127487, '\p{^RI=y}', "");
    Expect(0, 127487, '\P{RI=y}', "");
    Expect(1, 127487, '\P{^RI=y}', "");
    Expect(0, 127488, '\p{RI=y}', "");
    Expect(1, 127488, '\p{^RI=y}', "");
    Expect(1, 127488, '\P{RI=y}', "");
    Expect(0, 127488, '\P{^RI=y}', "");
    Expect(1, 127487, '\p{RI=:\Ay\z:}', "");;
    Expect(0, 127488, '\p{RI=:\Ay\z:}', "");;
    Expect(1, 127487, '\p{RI=_ Y}', "");
    Expect(0, 127487, '\p{^RI=_ Y}', "");
    Expect(0, 127487, '\P{RI=_ Y}', "");
    Expect(1, 127487, '\P{^RI=_ Y}', "");
    Expect(0, 127488, '\p{RI=_ Y}', "");
    Expect(1, 127488, '\p{^RI=_ Y}', "");
    Expect(1, 127488, '\P{RI=_ Y}', "");
    Expect(0, 127488, '\P{^RI=_ Y}', "");
    Error('\p{Is_Regional_Indicator=:=-_T}');
    Error('\P{Is_Regional_Indicator=:=-_T}');
    Expect(1, 127487, '\p{Is_Regional_Indicator=t}', "");
    Expect(0, 127487, '\p{^Is_Regional_Indicator=t}', "");
    Expect(0, 127487, '\P{Is_Regional_Indicator=t}', "");
    Expect(1, 127487, '\P{^Is_Regional_Indicator=t}', "");
    Expect(0, 127488, '\p{Is_Regional_Indicator=t}', "");
    Expect(1, 127488, '\p{^Is_Regional_Indicator=t}', "");
    Expect(1, 127488, '\P{Is_Regional_Indicator=t}', "");
    Expect(0, 127488, '\P{^Is_Regional_Indicator=t}', "");
    Expect(1, 127487, '\p{Is_Regional_Indicator=_ T}', "");
    Expect(0, 127487, '\p{^Is_Regional_Indicator=_ T}', "");
    Expect(0, 127487, '\P{Is_Regional_Indicator=_ T}', "");
    Expect(1, 127487, '\P{^Is_Regional_Indicator=_ T}', "");
    Expect(0, 127488, '\p{Is_Regional_Indicator=_ T}', "");
    Expect(1, 127488, '\p{^Is_Regional_Indicator=_ T}', "");
    Expect(1, 127488, '\P{Is_Regional_Indicator=_ T}', "");
    Expect(0, 127488, '\P{^Is_Regional_Indicator=_ T}', "");
    Error('\p{Is_RI=_/a/TRUE}');
    Error('\P{Is_RI=_/a/TRUE}');
    Expect(1, 127487, '\p{Is_RI=true}', "");
    Expect(0, 127487, '\p{^Is_RI=true}', "");
    Expect(0, 127487, '\P{Is_RI=true}', "");
    Expect(1, 127487, '\P{^Is_RI=true}', "");
    Expect(0, 127488, '\p{Is_RI=true}', "");
    Expect(1, 127488, '\p{^Is_RI=true}', "");
    Expect(1, 127488, '\P{Is_RI=true}', "");
    Expect(0, 127488, '\P{^Is_RI=true}', "");
    Error('\p{sentencebreak}');
    Error('\P{sentencebreak}');
    Error('\p{sb}');
    Error('\P{sb}');
    Error('\p{_perlsb}');
    Error('\P{_perlsb}');
    Error('\p{Sentence_Break:	/a/aterm}');
    Error('\P{Sentence_Break:	/a/aterm}');
    Expect(1, 65294, '\p{Sentence_Break=:\AATerm\z:}', "");;
    Expect(0, 65295, '\p{Sentence_Break=:\AATerm\z:}', "");;
    Expect(1, 65294, '\p{Sentence_Break=aterm}', "");
    Expect(0, 65294, '\p{^Sentence_Break=aterm}', "");
    Expect(0, 65294, '\P{Sentence_Break=aterm}', "");
    Expect(1, 65294, '\P{^Sentence_Break=aterm}', "");
    Expect(0, 65295, '\p{Sentence_Break=aterm}', "");
    Expect(1, 65295, '\p{^Sentence_Break=aterm}', "");
    Expect(1, 65295, '\P{Sentence_Break=aterm}', "");
    Expect(0, 65295, '\P{^Sentence_Break=aterm}', "");
    Expect(1, 65294, '\p{Sentence_Break=:\Aaterm\z:}', "");;
    Expect(0, 65295, '\p{Sentence_Break=:\Aaterm\z:}', "");;
    Expect(1, 65294, '\p{Sentence_Break=__ATerm}', "");
    Expect(0, 65294, '\p{^Sentence_Break=__ATerm}', "");
    Expect(0, 65294, '\P{Sentence_Break=__ATerm}', "");
    Expect(1, 65294, '\P{^Sentence_Break=__ATerm}', "");
    Expect(0, 65295, '\p{Sentence_Break=__ATerm}', "");
    Expect(1, 65295, '\p{^Sentence_Break=__ATerm}', "");
    Expect(1, 65295, '\P{Sentence_Break=__ATerm}', "");
    Expect(0, 65295, '\P{^Sentence_Break=__ATerm}', "");
    Error('\p{SB=_:=AT}');
    Error('\P{SB=_:=AT}');
    Expect(1, 65294, '\p{SB=:\AAT\z:}', "");;
    Expect(0, 65295, '\p{SB=:\AAT\z:}', "");;
    Expect(1, 65294, '\p{SB=at}', "");
    Expect(0, 65294, '\p{^SB=at}', "");
    Expect(0, 65294, '\P{SB=at}', "");
    Expect(1, 65294, '\P{^SB=at}', "");
    Expect(0, 65295, '\p{SB=at}', "");
    Expect(1, 65295, '\p{^SB=at}', "");
    Expect(1, 65295, '\P{SB=at}', "");
    Expect(0, 65295, '\P{^SB=at}', "");
    Expect(1, 65294, '\p{SB=:\Aat\z:}', "");;
    Expect(0, 65295, '\p{SB=:\Aat\z:}', "");;
    Expect(1, 65294, '\p{SB=  at}', "");
    Expect(0, 65294, '\p{^SB=  at}', "");
    Expect(0, 65294, '\P{SB=  at}', "");
    Expect(1, 65294, '\P{^SB=  at}', "");
    Expect(0, 65295, '\p{SB=  at}', "");
    Expect(1, 65295, '\p{^SB=  at}', "");
    Expect(1, 65295, '\P{SB=  at}', "");
    Expect(0, 65295, '\P{^SB=  at}', "");
    Error('\p{Is_Sentence_Break=	/a/ATERM}');
    Error('\P{Is_Sentence_Break=	/a/ATERM}');
    Expect(1, 65294, '\p{Is_Sentence_Break:aterm}', "");
    Expect(0, 65294, '\p{^Is_Sentence_Break:aterm}', "");
    Expect(0, 65294, '\P{Is_Sentence_Break:aterm}', "");
    Expect(1, 65294, '\P{^Is_Sentence_Break:aterm}', "");
    Expect(0, 65295, '\p{Is_Sentence_Break:aterm}', "");
    Expect(1, 65295, '\p{^Is_Sentence_Break:aterm}', "");
    Expect(1, 65295, '\P{Is_Sentence_Break:aterm}', "");
    Expect(0, 65295, '\P{^Is_Sentence_Break:aterm}', "");
    Expect(1, 65294, '\p{Is_Sentence_Break=--ATERM}', "");
    Expect(0, 65294, '\p{^Is_Sentence_Break=--ATERM}', "");
    Expect(0, 65294, '\P{Is_Sentence_Break=--ATERM}', "");
    Expect(1, 65294, '\P{^Is_Sentence_Break=--ATERM}', "");
    Expect(0, 65295, '\p{Is_Sentence_Break=--ATERM}', "");
    Expect(1, 65295, '\p{^Is_Sentence_Break=--ATERM}', "");
    Expect(1, 65295, '\P{Is_Sentence_Break=--ATERM}', "");
    Expect(0, 65295, '\P{^Is_Sentence_Break=--ATERM}', "");
    Error('\p{Is_SB:	 AT/a/}');
    Error('\P{Is_SB:	 AT/a/}');
    Expect(1, 65294, '\p{Is_SB=at}', "");
    Expect(0, 65294, '\p{^Is_SB=at}', "");
    Expect(0, 65294, '\P{Is_SB=at}', "");
    Expect(1, 65294, '\P{^Is_SB=at}', "");
    Expect(0, 65295, '\p{Is_SB=at}', "");
    Expect(1, 65295, '\p{^Is_SB=at}', "");
    Expect(1, 65295, '\P{Is_SB=at}', "");
    Expect(0, 65295, '\P{^Is_SB=at}', "");
    Expect(1, 65294, '\p{Is_SB=  at}', "");
    Expect(0, 65294, '\p{^Is_SB=  at}', "");
    Expect(0, 65294, '\P{Is_SB=  at}', "");
    Expect(1, 65294, '\P{^Is_SB=  at}', "");
    Expect(0, 65295, '\p{Is_SB=  at}', "");
    Expect(1, 65295, '\p{^Is_SB=  at}', "");
    Expect(1, 65295, '\P{Is_SB=  at}', "");
    Expect(0, 65295, '\P{^Is_SB=  at}', "");
    Error('\p{Sentence_Break=/a/CLOSE}');
    Error('\P{Sentence_Break=/a/CLOSE}');
    Expect(1, 128632, '\p{Sentence_Break=:\AClose\z:}', "");;
    Expect(0, 128633, '\p{Sentence_Break=:\AClose\z:}', "");;
    Expect(1, 128632, '\p{Sentence_Break=close}', "");
    Expect(0, 128632, '\p{^Sentence_Break=close}', "");
    Expect(0, 128632, '\P{Sentence_Break=close}', "");
    Expect(1, 128632, '\P{^Sentence_Break=close}', "");
    Expect(0, 128633, '\p{Sentence_Break=close}', "");
    Expect(1, 128633, '\p{^Sentence_Break=close}', "");
    Expect(1, 128633, '\P{Sentence_Break=close}', "");
    Expect(0, 128633, '\P{^Sentence_Break=close}', "");
    Expect(1, 128632, '\p{Sentence_Break=:\Aclose\z:}', "");;
    Expect(0, 128633, '\p{Sentence_Break=:\Aclose\z:}', "");;
    Expect(1, 128632, '\p{Sentence_Break= 	Close}', "");
    Expect(0, 128632, '\p{^Sentence_Break= 	Close}', "");
    Expect(0, 128632, '\P{Sentence_Break= 	Close}', "");
    Expect(1, 128632, '\P{^Sentence_Break= 	Close}', "");
    Expect(0, 128633, '\p{Sentence_Break= 	Close}', "");
    Expect(1, 128633, '\p{^Sentence_Break= 	Close}', "");
    Expect(1, 128633, '\P{Sentence_Break= 	Close}', "");
    Expect(0, 128633, '\P{^Sentence_Break= 	Close}', "");
    Error('\p{SB=:=-CL}');
    Error('\P{SB=:=-CL}');
    Expect(1, 128632, '\p{SB=:\ACL\z:}', "");;
    Expect(0, 128633, '\p{SB=:\ACL\z:}', "");;
    Expect(1, 128632, '\p{SB=cl}', "");
    Expect(0, 128632, '\p{^SB=cl}', "");
    Expect(0, 128632, '\P{SB=cl}', "");
    Expect(1, 128632, '\P{^SB=cl}', "");
    Expect(0, 128633, '\p{SB=cl}', "");
    Expect(1, 128633, '\p{^SB=cl}', "");
    Expect(1, 128633, '\P{SB=cl}', "");
    Expect(0, 128633, '\P{^SB=cl}', "");
    Expect(1, 128632, '\p{SB=:\Acl\z:}', "");;
    Expect(0, 128633, '\p{SB=:\Acl\z:}', "");;
    Expect(1, 128632, '\p{SB= CL}', "");
    Expect(0, 128632, '\p{^SB= CL}', "");
    Expect(0, 128632, '\P{SB= CL}', "");
    Expect(1, 128632, '\P{^SB= CL}', "");
    Expect(0, 128633, '\p{SB= CL}', "");
    Expect(1, 128633, '\p{^SB= CL}', "");
    Expect(1, 128633, '\P{SB= CL}', "");
    Expect(0, 128633, '\P{^SB= CL}', "");
    Error('\p{Is_Sentence_Break=	_CLOSE/a/}');
    Error('\P{Is_Sentence_Break=	_CLOSE/a/}');
    Expect(1, 128632, '\p{Is_Sentence_Break=close}', "");
    Expect(0, 128632, '\p{^Is_Sentence_Break=close}', "");
    Expect(0, 128632, '\P{Is_Sentence_Break=close}', "");
    Expect(1, 128632, '\P{^Is_Sentence_Break=close}', "");
    Expect(0, 128633, '\p{Is_Sentence_Break=close}', "");
    Expect(1, 128633, '\p{^Is_Sentence_Break=close}', "");
    Expect(1, 128633, '\P{Is_Sentence_Break=close}', "");
    Expect(0, 128633, '\P{^Is_Sentence_Break=close}', "");
    Expect(1, 128632, '\p{Is_Sentence_Break=	-CLOSE}', "");
    Expect(0, 128632, '\p{^Is_Sentence_Break=	-CLOSE}', "");
    Expect(0, 128632, '\P{Is_Sentence_Break=	-CLOSE}', "");
    Expect(1, 128632, '\P{^Is_Sentence_Break=	-CLOSE}', "");
    Expect(0, 128633, '\p{Is_Sentence_Break=	-CLOSE}', "");
    Expect(1, 128633, '\p{^Is_Sentence_Break=	-CLOSE}', "");
    Expect(1, 128633, '\P{Is_Sentence_Break=	-CLOSE}', "");
    Expect(0, 128633, '\P{^Is_Sentence_Break=	-CLOSE}', "");
    Error('\p{Is_SB=-/a/cl}');
    Error('\P{Is_SB=-/a/cl}');
    Expect(1, 128632, '\p{Is_SB=cl}', "");
    Expect(0, 128632, '\p{^Is_SB=cl}', "");
    Expect(0, 128632, '\P{Is_SB=cl}', "");
    Expect(1, 128632, '\P{^Is_SB=cl}', "");
    Expect(0, 128633, '\p{Is_SB=cl}', "");
    Expect(1, 128633, '\p{^Is_SB=cl}', "");
    Expect(1, 128633, '\P{Is_SB=cl}', "");
    Expect(0, 128633, '\P{^Is_SB=cl}', "");
    Expect(1, 128632, '\p{Is_SB=-_cl}', "");
    Expect(0, 128632, '\p{^Is_SB=-_cl}', "");
    Expect(0, 128632, '\P{Is_SB=-_cl}', "");
    Expect(1, 128632, '\P{^Is_SB=-_cl}', "");
    Expect(0, 128633, '\p{Is_SB=-_cl}', "");
    Expect(1, 128633, '\p{^Is_SB=-_cl}', "");
    Expect(1, 128633, '\P{Is_SB=-_cl}', "");
    Expect(0, 128633, '\P{^Is_SB=-_cl}', "");
    Error('\p{Sentence_Break=:=CR}');
    Error('\P{Sentence_Break=:=CR}');
    Expect(1, 13, '\p{Sentence_Break=:\ACR\z:}', "");;
    Expect(0, 14, '\p{Sentence_Break=:\ACR\z:}', "");;
    Expect(1, 13, '\p{Sentence_Break:cr}', "");
    Expect(0, 13, '\p{^Sentence_Break:cr}', "");
    Expect(0, 13, '\P{Sentence_Break:cr}', "");
    Expect(1, 13, '\P{^Sentence_Break:cr}', "");
    Expect(0, 14, '\p{Sentence_Break:cr}', "");
    Expect(1, 14, '\p{^Sentence_Break:cr}', "");
    Expect(1, 14, '\P{Sentence_Break:cr}', "");
    Expect(0, 14, '\P{^Sentence_Break:cr}', "");
    Expect(1, 13, '\p{Sentence_Break=:\Acr\z:}', "");;
    Expect(0, 14, '\p{Sentence_Break=:\Acr\z:}', "");;
    Error('\p{SB= :=CR}');
    Error('\P{SB= :=CR}');
    Expect(1, 13, '\p{SB=:\ACR\z:}', "");;
    Expect(0, 14, '\p{SB=:\ACR\z:}', "");;
    Expect(1, 13, '\p{SB=cr}', "");
    Expect(0, 13, '\p{^SB=cr}', "");
    Expect(0, 13, '\P{SB=cr}', "");
    Expect(1, 13, '\P{^SB=cr}', "");
    Expect(0, 14, '\p{SB=cr}', "");
    Expect(1, 14, '\p{^SB=cr}', "");
    Expect(1, 14, '\P{SB=cr}', "");
    Expect(0, 14, '\P{^SB=cr}', "");
    Expect(1, 13, '\p{SB=:\Acr\z:}', "");;
    Expect(0, 14, '\p{SB=:\Acr\z:}', "");;
    Expect(1, 13, '\p{SB=--CR}', "");
    Expect(0, 13, '\p{^SB=--CR}', "");
    Expect(0, 13, '\P{SB=--CR}', "");
    Expect(1, 13, '\P{^SB=--CR}', "");
    Expect(0, 14, '\p{SB=--CR}', "");
    Expect(1, 14, '\p{^SB=--CR}', "");
    Expect(1, 14, '\P{SB=--CR}', "");
    Expect(0, 14, '\P{^SB=--CR}', "");
    Error('\p{Is_Sentence_Break=	/a/cr}');
    Error('\P{Is_Sentence_Break=	/a/cr}');
    Expect(1, 13, '\p{Is_Sentence_Break=cr}', "");
    Expect(0, 13, '\p{^Is_Sentence_Break=cr}', "");
    Expect(0, 13, '\P{Is_Sentence_Break=cr}', "");
    Expect(1, 13, '\P{^Is_Sentence_Break=cr}', "");
    Expect(0, 14, '\p{Is_Sentence_Break=cr}', "");
    Expect(1, 14, '\p{^Is_Sentence_Break=cr}', "");
    Expect(1, 14, '\P{Is_Sentence_Break=cr}', "");
    Expect(0, 14, '\P{^Is_Sentence_Break=cr}', "");
    Expect(1, 13, '\p{Is_Sentence_Break=-_CR}', "");
    Expect(0, 13, '\p{^Is_Sentence_Break=-_CR}', "");
    Expect(0, 13, '\P{Is_Sentence_Break=-_CR}', "");
    Expect(1, 13, '\P{^Is_Sentence_Break=-_CR}', "");
    Expect(0, 14, '\p{Is_Sentence_Break=-_CR}', "");
    Expect(1, 14, '\p{^Is_Sentence_Break=-_CR}', "");
    Expect(1, 14, '\P{Is_Sentence_Break=-_CR}', "");
    Expect(0, 14, '\P{^Is_Sentence_Break=-_CR}', "");
    Error('\p{Is_SB=:=_	CR}');
    Error('\P{Is_SB=:=_	CR}');
    Expect(1, 13, '\p{Is_SB=cr}', "");
    Expect(0, 13, '\p{^Is_SB=cr}', "");
    Expect(0, 13, '\P{Is_SB=cr}', "");
    Expect(1, 13, '\P{^Is_SB=cr}', "");
    Expect(0, 14, '\p{Is_SB=cr}', "");
    Expect(1, 14, '\p{^Is_SB=cr}', "");
    Expect(1, 14, '\P{Is_SB=cr}', "");
    Expect(0, 14, '\P{^Is_SB=cr}', "");
    Expect(1, 13, '\p{Is_SB= 	cr}', "");
    Expect(0, 13, '\p{^Is_SB= 	cr}', "");
    Expect(0, 13, '\P{Is_SB= 	cr}', "");
    Expect(1, 13, '\P{^Is_SB= 	cr}', "");
    Expect(0, 14, '\p{Is_SB= 	cr}', "");
    Expect(1, 14, '\p{^Is_SB= 	cr}', "");
    Expect(1, 14, '\P{Is_SB= 	cr}', "");
    Expect(0, 14, '\P{^Is_SB= 	cr}', "");
    Error('\p{Sentence_Break= 	extend:=}');
    Error('\P{Sentence_Break= 	extend:=}');
    Expect(1, 917999, '\p{Sentence_Break=:\AExtend\z:}', "");;
    Expect(0, 918000, '\p{Sentence_Break=:\AExtend\z:}', "");;
    Expect(1, 917999, '\p{Sentence_Break=extend}', "");
    Expect(0, 917999, '\p{^Sentence_Break=extend}', "");
    Expect(0, 917999, '\P{Sentence_Break=extend}', "");
    Expect(1, 917999, '\P{^Sentence_Break=extend}', "");
    Expect(0, 918000, '\p{Sentence_Break=extend}', "");
    Expect(1, 918000, '\p{^Sentence_Break=extend}', "");
    Expect(1, 918000, '\P{Sentence_Break=extend}', "");
    Expect(0, 918000, '\P{^Sentence_Break=extend}', "");
    Expect(1, 917999, '\p{Sentence_Break=:\Aextend\z:}', "");;
    Expect(0, 918000, '\p{Sentence_Break=:\Aextend\z:}', "");;
    Expect(1, 917999, '\p{Sentence_Break=-Extend}', "");
    Expect(0, 917999, '\p{^Sentence_Break=-Extend}', "");
    Expect(0, 917999, '\P{Sentence_Break=-Extend}', "");
    Expect(1, 917999, '\P{^Sentence_Break=-Extend}', "");
    Expect(0, 918000, '\p{Sentence_Break=-Extend}', "");
    Expect(1, 918000, '\p{^Sentence_Break=-Extend}', "");
    Expect(1, 918000, '\P{Sentence_Break=-Extend}', "");
    Expect(0, 918000, '\P{^Sentence_Break=-Extend}', "");
    Error('\p{SB=:=	-ex}');
    Error('\P{SB=:=	-ex}');
    Expect(1, 917999, '\p{SB=:\AEX\z:}', "");;
    Expect(0, 918000, '\p{SB=:\AEX\z:}', "");;
    Expect(1, 917999, '\p{SB=ex}', "");
    Expect(0, 917999, '\p{^SB=ex}', "");
    Expect(0, 917999, '\P{SB=ex}', "");
    Expect(1, 917999, '\P{^SB=ex}', "");
    Expect(0, 918000, '\p{SB=ex}', "");
    Expect(1, 918000, '\p{^SB=ex}', "");
    Expect(1, 918000, '\P{SB=ex}', "");
    Expect(0, 918000, '\P{^SB=ex}', "");
    Expect(1, 917999, '\p{SB=:\Aex\z:}', "");;
    Expect(0, 918000, '\p{SB=:\Aex\z:}', "");;
    Expect(1, 917999, '\p{SB= _EX}', "");
    Expect(0, 917999, '\p{^SB= _EX}', "");
    Expect(0, 917999, '\P{SB= _EX}', "");
    Expect(1, 917999, '\P{^SB= _EX}', "");
    Expect(0, 918000, '\p{SB= _EX}', "");
    Expect(1, 918000, '\p{^SB= _EX}', "");
    Expect(1, 918000, '\P{SB= _EX}', "");
    Expect(0, 918000, '\P{^SB= _EX}', "");
    Error('\p{Is_Sentence_Break=:=Extend}');
    Error('\P{Is_Sentence_Break=:=Extend}');
    Expect(1, 917999, '\p{Is_Sentence_Break:   extend}', "");
    Expect(0, 917999, '\p{^Is_Sentence_Break:   extend}', "");
    Expect(0, 917999, '\P{Is_Sentence_Break:   extend}', "");
    Expect(1, 917999, '\P{^Is_Sentence_Break:   extend}', "");
    Expect(0, 918000, '\p{Is_Sentence_Break:   extend}', "");
    Expect(1, 918000, '\p{^Is_Sentence_Break:   extend}', "");
    Expect(1, 918000, '\P{Is_Sentence_Break:   extend}', "");
    Expect(0, 918000, '\P{^Is_Sentence_Break:   extend}', "");
    Expect(1, 917999, '\p{Is_Sentence_Break=	 extend}', "");
    Expect(0, 917999, '\p{^Is_Sentence_Break=	 extend}', "");
    Expect(0, 917999, '\P{Is_Sentence_Break=	 extend}', "");
    Expect(1, 917999, '\P{^Is_Sentence_Break=	 extend}', "");
    Expect(0, 918000, '\p{Is_Sentence_Break=	 extend}', "");
    Expect(1, 918000, '\p{^Is_Sentence_Break=	 extend}', "");
    Expect(1, 918000, '\P{Is_Sentence_Break=	 extend}', "");
    Expect(0, 918000, '\P{^Is_Sentence_Break=	 extend}', "");
    Error('\p{Is_SB= :=EX}');
    Error('\P{Is_SB= :=EX}');
    Expect(1, 917999, '\p{Is_SB:   ex}', "");
    Expect(0, 917999, '\p{^Is_SB:   ex}', "");
    Expect(0, 917999, '\P{Is_SB:   ex}', "");
    Expect(1, 917999, '\P{^Is_SB:   ex}', "");
    Expect(0, 918000, '\p{Is_SB:   ex}', "");
    Expect(1, 918000, '\p{^Is_SB:   ex}', "");
    Expect(1, 918000, '\P{Is_SB:   ex}', "");
    Expect(0, 918000, '\P{^Is_SB:   ex}', "");
    Expect(1, 917999, '\p{Is_SB=-	EX}', "");
    Expect(0, 917999, '\p{^Is_SB=-	EX}', "");
    Expect(0, 917999, '\P{Is_SB=-	EX}', "");
    Expect(1, 917999, '\P{^Is_SB=-	EX}', "");
    Expect(0, 918000, '\p{Is_SB=-	EX}', "");
    Expect(1, 918000, '\p{^Is_SB=-	EX}', "");
    Expect(1, 918000, '\P{Is_SB=-	EX}', "");
    Expect(0, 918000, '\P{^Is_SB=-	EX}', "");
    Error('\p{Sentence_Break=_ Format:=}');
    Error('\P{Sentence_Break=_ Format:=}');
    Expect(1, 917505, '\p{Sentence_Break=:\AFormat\z:}', "");;
    Expect(0, 917506, '\p{Sentence_Break=:\AFormat\z:}', "");;
    Expect(1, 917505, '\p{Sentence_Break=format}', "");
    Expect(0, 917505, '\p{^Sentence_Break=format}', "");
    Expect(0, 917505, '\P{Sentence_Break=format}', "");
    Expect(1, 917505, '\P{^Sentence_Break=format}', "");
    Expect(0, 917506, '\p{Sentence_Break=format}', "");
    Expect(1, 917506, '\p{^Sentence_Break=format}', "");
    Expect(1, 917506, '\P{Sentence_Break=format}', "");
    Expect(0, 917506, '\P{^Sentence_Break=format}', "");
    Expect(1, 917505, '\p{Sentence_Break=:\Aformat\z:}', "");;
    Expect(0, 917506, '\p{Sentence_Break=:\Aformat\z:}', "");;
    Expect(1, 917505, '\p{Sentence_Break= -format}', "");
    Expect(0, 917505, '\p{^Sentence_Break= -format}', "");
    Expect(0, 917505, '\P{Sentence_Break= -format}', "");
    Expect(1, 917505, '\P{^Sentence_Break= -format}', "");
    Expect(0, 917506, '\p{Sentence_Break= -format}', "");
    Expect(1, 917506, '\p{^Sentence_Break= -format}', "");
    Expect(1, 917506, '\P{Sentence_Break= -format}', "");
    Expect(0, 917506, '\P{^Sentence_Break= -format}', "");
    Error('\p{SB= :=FO}');
    Error('\P{SB= :=FO}');
    Expect(1, 917505, '\p{SB=:\AFO\z:}', "");;
    Expect(0, 917506, '\p{SB=:\AFO\z:}', "");;
    Expect(1, 917505, '\p{SB=fo}', "");
    Expect(0, 917505, '\p{^SB=fo}', "");
    Expect(0, 917505, '\P{SB=fo}', "");
    Expect(1, 917505, '\P{^SB=fo}', "");
    Expect(0, 917506, '\p{SB=fo}', "");
    Expect(1, 917506, '\p{^SB=fo}', "");
    Expect(1, 917506, '\P{SB=fo}', "");
    Expect(0, 917506, '\P{^SB=fo}', "");
    Expect(1, 917505, '\p{SB=:\Afo\z:}', "");;
    Expect(0, 917506, '\p{SB=:\Afo\z:}', "");;
    Expect(1, 917505, '\p{SB:   - FO}', "");
    Expect(0, 917505, '\p{^SB:   - FO}', "");
    Expect(0, 917505, '\P{SB:   - FO}', "");
    Expect(1, 917505, '\P{^SB:   - FO}', "");
    Expect(0, 917506, '\p{SB:   - FO}', "");
    Expect(1, 917506, '\p{^SB:   - FO}', "");
    Expect(1, 917506, '\P{SB:   - FO}', "");
    Expect(0, 917506, '\P{^SB:   - FO}', "");
    Error('\p{Is_Sentence_Break=/a/	format}');
    Error('\P{Is_Sentence_Break=/a/	format}');
    Expect(1, 917505, '\p{Is_Sentence_Break=format}', "");
    Expect(0, 917505, '\p{^Is_Sentence_Break=format}', "");
    Expect(0, 917505, '\P{Is_Sentence_Break=format}', "");
    Expect(1, 917505, '\P{^Is_Sentence_Break=format}', "");
    Expect(0, 917506, '\p{Is_Sentence_Break=format}', "");
    Expect(1, 917506, '\p{^Is_Sentence_Break=format}', "");
    Expect(1, 917506, '\P{Is_Sentence_Break=format}', "");
    Expect(0, 917506, '\P{^Is_Sentence_Break=format}', "");
    Expect(1, 917505, '\p{Is_Sentence_Break=	 FORMAT}', "");
    Expect(0, 917505, '\p{^Is_Sentence_Break=	 FORMAT}', "");
    Expect(0, 917505, '\P{Is_Sentence_Break=	 FORMAT}', "");
    Expect(1, 917505, '\P{^Is_Sentence_Break=	 FORMAT}', "");
    Expect(0, 917506, '\p{Is_Sentence_Break=	 FORMAT}', "");
    Expect(1, 917506, '\p{^Is_Sentence_Break=	 FORMAT}', "");
    Expect(1, 917506, '\P{Is_Sentence_Break=	 FORMAT}', "");
    Expect(0, 917506, '\P{^Is_Sentence_Break=	 FORMAT}', "");
    Error('\p{Is_SB: := FO}');
    Error('\P{Is_SB: := FO}');
    Expect(1, 917505, '\p{Is_SB:	fo}', "");
    Expect(0, 917505, '\p{^Is_SB:	fo}', "");
    Expect(0, 917505, '\P{Is_SB:	fo}', "");
    Expect(1, 917505, '\P{^Is_SB:	fo}', "");
    Expect(0, 917506, '\p{Is_SB:	fo}', "");
    Expect(1, 917506, '\p{^Is_SB:	fo}', "");
    Expect(1, 917506, '\P{Is_SB:	fo}', "");
    Expect(0, 917506, '\P{^Is_SB:	fo}', "");
    Expect(1, 917505, '\p{Is_SB=	FO}', "");
    Expect(0, 917505, '\p{^Is_SB=	FO}', "");
    Expect(0, 917505, '\P{Is_SB=	FO}', "");
    Expect(1, 917505, '\P{^Is_SB=	FO}', "");
    Expect(0, 917506, '\p{Is_SB=	FO}', "");
    Expect(1, 917506, '\p{^Is_SB=	FO}', "");
    Expect(1, 917506, '\P{Is_SB=	FO}', "");
    Expect(0, 917506, '\P{^Is_SB=	FO}', "");
    Error('\p{Sentence_Break=:=OLETTER}');
    Error('\P{Sentence_Break=:=OLETTER}');
    Expect(1, 205743, '\p{Sentence_Break=:\AOLetter\z:}', "");;
    Expect(0, 205744, '\p{Sentence_Break=:\AOLetter\z:}', "");;
    Expect(1, 205743, '\p{Sentence_Break=oletter}', "");
    Expect(0, 205743, '\p{^Sentence_Break=oletter}', "");
    Expect(0, 205743, '\P{Sentence_Break=oletter}', "");
    Expect(1, 205743, '\P{^Sentence_Break=oletter}', "");
    Expect(0, 205744, '\p{Sentence_Break=oletter}', "");
    Expect(1, 205744, '\p{^Sentence_Break=oletter}', "");
    Expect(1, 205744, '\P{Sentence_Break=oletter}', "");
    Expect(0, 205744, '\P{^Sentence_Break=oletter}', "");
    Expect(1, 205743, '\p{Sentence_Break=:\Aoletter\z:}', "");;
    Expect(0, 205744, '\p{Sentence_Break=:\Aoletter\z:}', "");;
    Expect(1, 205743, '\p{Sentence_Break=_	OLetter}', "");
    Expect(0, 205743, '\p{^Sentence_Break=_	OLetter}', "");
    Expect(0, 205743, '\P{Sentence_Break=_	OLetter}', "");
    Expect(1, 205743, '\P{^Sentence_Break=_	OLetter}', "");
    Expect(0, 205744, '\p{Sentence_Break=_	OLetter}', "");
    Expect(1, 205744, '\p{^Sentence_Break=_	OLetter}', "");
    Expect(1, 205744, '\P{Sentence_Break=_	OLetter}', "");
    Expect(0, 205744, '\P{^Sentence_Break=_	OLetter}', "");
    Error('\p{SB= 	LE/a/}');
    Error('\P{SB= 	LE/a/}');
    Expect(1, 205743, '\p{SB=:\ALE\z:}', "");;
    Expect(0, 205744, '\p{SB=:\ALE\z:}', "");;
    Expect(1, 205743, '\p{SB=le}', "");
    Expect(0, 205743, '\p{^SB=le}', "");
    Expect(0, 205743, '\P{SB=le}', "");
    Expect(1, 205743, '\P{^SB=le}', "");
    Expect(0, 205744, '\p{SB=le}', "");
    Expect(1, 205744, '\p{^SB=le}', "");
    Expect(1, 205744, '\P{SB=le}', "");
    Expect(0, 205744, '\P{^SB=le}', "");
    Expect(1, 205743, '\p{SB=:\Ale\z:}', "");;
    Expect(0, 205744, '\p{SB=:\Ale\z:}', "");;
    Expect(1, 205743, '\p{SB= LE}', "");
    Expect(0, 205743, '\p{^SB= LE}', "");
    Expect(0, 205743, '\P{SB= LE}', "");
    Expect(1, 205743, '\P{^SB= LE}', "");
    Expect(0, 205744, '\p{SB= LE}', "");
    Expect(1, 205744, '\p{^SB= LE}', "");
    Expect(1, 205744, '\P{SB= LE}', "");
    Expect(0, 205744, '\P{^SB= LE}', "");
    Error('\p{Is_Sentence_Break=:= 	OLetter}');
    Error('\P{Is_Sentence_Break=:= 	OLetter}');
    Expect(1, 205743, '\p{Is_Sentence_Break=oletter}', "");
    Expect(0, 205743, '\p{^Is_Sentence_Break=oletter}', "");
    Expect(0, 205743, '\P{Is_Sentence_Break=oletter}', "");
    Expect(1, 205743, '\P{^Is_Sentence_Break=oletter}', "");
    Expect(0, 205744, '\p{Is_Sentence_Break=oletter}', "");
    Expect(1, 205744, '\p{^Is_Sentence_Break=oletter}', "");
    Expect(1, 205744, '\P{Is_Sentence_Break=oletter}', "");
    Expect(0, 205744, '\P{^Is_Sentence_Break=oletter}', "");
    Expect(1, 205743, '\p{Is_Sentence_Break=_OLetter}', "");
    Expect(0, 205743, '\p{^Is_Sentence_Break=_OLetter}', "");
    Expect(0, 205743, '\P{Is_Sentence_Break=_OLetter}', "");
    Expect(1, 205743, '\P{^Is_Sentence_Break=_OLetter}', "");
    Expect(0, 205744, '\p{Is_Sentence_Break=_OLetter}', "");
    Expect(1, 205744, '\p{^Is_Sentence_Break=_OLetter}', "");
    Expect(1, 205744, '\P{Is_Sentence_Break=_OLetter}', "");
    Expect(0, 205744, '\P{^Is_Sentence_Break=_OLetter}', "");
    Error('\p{Is_SB=:=LE}');
    Error('\P{Is_SB=:=LE}');
    Expect(1, 205743, '\p{Is_SB=le}', "");
    Expect(0, 205743, '\p{^Is_SB=le}', "");
    Expect(0, 205743, '\P{Is_SB=le}', "");
    Expect(1, 205743, '\P{^Is_SB=le}', "");
    Expect(0, 205744, '\p{Is_SB=le}', "");
    Expect(1, 205744, '\p{^Is_SB=le}', "");
    Expect(1, 205744, '\P{Is_SB=le}', "");
    Expect(0, 205744, '\P{^Is_SB=le}', "");
    Expect(1, 205743, '\p{Is_SB:	- le}', "");
    Expect(0, 205743, '\p{^Is_SB:	- le}', "");
    Expect(0, 205743, '\P{Is_SB:	- le}', "");
    Expect(1, 205743, '\P{^Is_SB:	- le}', "");
    Expect(0, 205744, '\p{Is_SB:	- le}', "");
    Expect(1, 205744, '\p{^Is_SB:	- le}', "");
    Expect(1, 205744, '\P{Is_SB:	- le}', "");
    Expect(0, 205744, '\P{^Is_SB:	- le}', "");
    Error('\p{Sentence_Break=	lf/a/}');
    Error('\P{Sentence_Break=	lf/a/}');
    Expect(1, 10, '\p{Sentence_Break=:\ALF\z:}', "");;
    Expect(0, 11, '\p{Sentence_Break=:\ALF\z:}', "");;
    Expect(1, 10, '\p{Sentence_Break=lf}', "");
    Expect(0, 10, '\p{^Sentence_Break=lf}', "");
    Expect(0, 10, '\P{Sentence_Break=lf}', "");
    Expect(1, 10, '\P{^Sentence_Break=lf}', "");
    Expect(0, 11, '\p{Sentence_Break=lf}', "");
    Expect(1, 11, '\p{^Sentence_Break=lf}', "");
    Expect(1, 11, '\P{Sentence_Break=lf}', "");
    Expect(0, 11, '\P{^Sentence_Break=lf}', "");
    Expect(1, 10, '\p{Sentence_Break=:\Alf\z:}', "");;
    Expect(0, 11, '\p{Sentence_Break=:\Alf\z:}', "");;
    Expect(1, 10, '\p{Sentence_Break= LF}', "");
    Expect(0, 10, '\p{^Sentence_Break= LF}', "");
    Expect(0, 10, '\P{Sentence_Break= LF}', "");
    Expect(1, 10, '\P{^Sentence_Break= LF}', "");
    Expect(0, 11, '\p{Sentence_Break= LF}', "");
    Expect(1, 11, '\p{^Sentence_Break= LF}', "");
    Expect(1, 11, '\P{Sentence_Break= LF}', "");
    Expect(0, 11, '\P{^Sentence_Break= LF}', "");
    Error('\p{SB=-lf/a/}');
    Error('\P{SB=-lf/a/}');
    Expect(1, 10, '\p{SB=:\ALF\z:}', "");;
    Expect(0, 11, '\p{SB=:\ALF\z:}', "");;
    Expect(1, 10, '\p{SB=lf}', "");
    Expect(0, 10, '\p{^SB=lf}', "");
    Expect(0, 10, '\P{SB=lf}', "");
    Expect(1, 10, '\P{^SB=lf}', "");
    Expect(0, 11, '\p{SB=lf}', "");
    Expect(1, 11, '\p{^SB=lf}', "");
    Expect(1, 11, '\P{SB=lf}', "");
    Expect(0, 11, '\P{^SB=lf}', "");
    Expect(1, 10, '\p{SB=:\Alf\z:}', "");;
    Expect(0, 11, '\p{SB=:\Alf\z:}', "");;
    Expect(1, 10, '\p{SB=	LF}', "");
    Expect(0, 10, '\p{^SB=	LF}', "");
    Expect(0, 10, '\P{SB=	LF}', "");
    Expect(1, 10, '\P{^SB=	LF}', "");
    Expect(0, 11, '\p{SB=	LF}', "");
    Expect(1, 11, '\p{^SB=	LF}', "");
    Expect(1, 11, '\P{SB=	LF}', "");
    Expect(0, 11, '\P{^SB=	LF}', "");
    Error('\p{Is_Sentence_Break=-LF:=}');
    Error('\P{Is_Sentence_Break=-LF:=}');
    Expect(1, 10, '\p{Is_Sentence_Break=lf}', "");
    Expect(0, 10, '\p{^Is_Sentence_Break=lf}', "");
    Expect(0, 10, '\P{Is_Sentence_Break=lf}', "");
    Expect(1, 10, '\P{^Is_Sentence_Break=lf}', "");
    Expect(0, 11, '\p{Is_Sentence_Break=lf}', "");
    Expect(1, 11, '\p{^Is_Sentence_Break=lf}', "");
    Expect(1, 11, '\P{Is_Sentence_Break=lf}', "");
    Expect(0, 11, '\P{^Is_Sentence_Break=lf}', "");
    Expect(1, 10, '\p{Is_Sentence_Break=- LF}', "");
    Expect(0, 10, '\p{^Is_Sentence_Break=- LF}', "");
    Expect(0, 10, '\P{Is_Sentence_Break=- LF}', "");
    Expect(1, 10, '\P{^Is_Sentence_Break=- LF}', "");
    Expect(0, 11, '\p{Is_Sentence_Break=- LF}', "");
    Expect(1, 11, '\p{^Is_Sentence_Break=- LF}', "");
    Expect(1, 11, '\P{Is_Sentence_Break=- LF}', "");
    Expect(0, 11, '\P{^Is_Sentence_Break=- LF}', "");
    Error('\p{Is_SB=:=__lf}');
    Error('\P{Is_SB=:=__lf}');
    Expect(1, 10, '\p{Is_SB=lf}', "");
    Expect(0, 10, '\p{^Is_SB=lf}', "");
    Expect(0, 10, '\P{Is_SB=lf}', "");
    Expect(1, 10, '\P{^Is_SB=lf}', "");
    Expect(0, 11, '\p{Is_SB=lf}', "");
    Expect(1, 11, '\p{^Is_SB=lf}', "");
    Expect(1, 11, '\P{Is_SB=lf}', "");
    Expect(0, 11, '\P{^Is_SB=lf}', "");
    Error('\p{Sentence_Break=/a/		Lower}');
    Error('\P{Sentence_Break=/a/		Lower}');
    Expect(1, 125251, '\p{Sentence_Break=:\ALower\z:}', "");;
    Expect(0, 125252, '\p{Sentence_Break=:\ALower\z:}', "");;
    Expect(1, 125251, '\p{Sentence_Break: lower}', "");
    Expect(0, 125251, '\p{^Sentence_Break: lower}', "");
    Expect(0, 125251, '\P{Sentence_Break: lower}', "");
    Expect(1, 125251, '\P{^Sentence_Break: lower}', "");
    Expect(0, 125252, '\p{Sentence_Break: lower}', "");
    Expect(1, 125252, '\p{^Sentence_Break: lower}', "");
    Expect(1, 125252, '\P{Sentence_Break: lower}', "");
    Expect(0, 125252, '\P{^Sentence_Break: lower}', "");
    Expect(1, 125251, '\p{Sentence_Break=:\Alower\z:}', "");;
    Expect(0, 125252, '\p{Sentence_Break=:\Alower\z:}', "");;
    Expect(1, 125251, '\p{Sentence_Break=-	LOWER}', "");
    Expect(0, 125251, '\p{^Sentence_Break=-	LOWER}', "");
    Expect(0, 125251, '\P{Sentence_Break=-	LOWER}', "");
    Expect(1, 125251, '\P{^Sentence_Break=-	LOWER}', "");
    Expect(0, 125252, '\p{Sentence_Break=-	LOWER}', "");
    Expect(1, 125252, '\p{^Sentence_Break=-	LOWER}', "");
    Expect(1, 125252, '\P{Sentence_Break=-	LOWER}', "");
    Expect(0, 125252, '\P{^Sentence_Break=-	LOWER}', "");
    Error('\p{SB::=lo}');
    Error('\P{SB::=lo}');
    Expect(1, 125251, '\p{SB=:\ALO\z:}', "");;
    Expect(0, 125252, '\p{SB=:\ALO\z:}', "");;
    Expect(1, 125251, '\p{SB=lo}', "");
    Expect(0, 125251, '\p{^SB=lo}', "");
    Expect(0, 125251, '\P{SB=lo}', "");
    Expect(1, 125251, '\P{^SB=lo}', "");
    Expect(0, 125252, '\p{SB=lo}', "");
    Expect(1, 125252, '\p{^SB=lo}', "");
    Expect(1, 125252, '\P{SB=lo}', "");
    Expect(0, 125252, '\P{^SB=lo}', "");
    Expect(1, 125251, '\p{SB=:\Alo\z:}', "");;
    Expect(0, 125252, '\p{SB=:\Alo\z:}', "");;
    Expect(1, 125251, '\p{SB=-LO}', "");
    Expect(0, 125251, '\p{^SB=-LO}', "");
    Expect(0, 125251, '\P{SB=-LO}', "");
    Expect(1, 125251, '\P{^SB=-LO}', "");
    Expect(0, 125252, '\p{SB=-LO}', "");
    Expect(1, 125252, '\p{^SB=-LO}', "");
    Expect(1, 125252, '\P{SB=-LO}', "");
    Expect(0, 125252, '\P{^SB=-LO}', "");
    Error('\p{Is_Sentence_Break= /a/lower}');
    Error('\P{Is_Sentence_Break= /a/lower}');
    Expect(1, 125251, '\p{Is_Sentence_Break=lower}', "");
    Expect(0, 125251, '\p{^Is_Sentence_Break=lower}', "");
    Expect(0, 125251, '\P{Is_Sentence_Break=lower}', "");
    Expect(1, 125251, '\P{^Is_Sentence_Break=lower}', "");
    Expect(0, 125252, '\p{Is_Sentence_Break=lower}', "");
    Expect(1, 125252, '\p{^Is_Sentence_Break=lower}', "");
    Expect(1, 125252, '\P{Is_Sentence_Break=lower}', "");
    Expect(0, 125252, '\P{^Is_Sentence_Break=lower}', "");
    Expect(1, 125251, '\p{Is_Sentence_Break=	 Lower}', "");
    Expect(0, 125251, '\p{^Is_Sentence_Break=	 Lower}', "");
    Expect(0, 125251, '\P{Is_Sentence_Break=	 Lower}', "");
    Expect(1, 125251, '\P{^Is_Sentence_Break=	 Lower}', "");
    Expect(0, 125252, '\p{Is_Sentence_Break=	 Lower}', "");
    Expect(1, 125252, '\p{^Is_Sentence_Break=	 Lower}', "");
    Expect(1, 125252, '\P{Is_Sentence_Break=	 Lower}', "");
    Expect(0, 125252, '\P{^Is_Sentence_Break=	 Lower}', "");
    Error('\p{Is_SB=:=--LO}');
    Error('\P{Is_SB=:=--LO}');
    Expect(1, 125251, '\p{Is_SB=lo}', "");
    Expect(0, 125251, '\p{^Is_SB=lo}', "");
    Expect(0, 125251, '\P{Is_SB=lo}', "");
    Expect(1, 125251, '\P{^Is_SB=lo}', "");
    Expect(0, 125252, '\p{Is_SB=lo}', "");
    Expect(1, 125252, '\p{^Is_SB=lo}', "");
    Expect(1, 125252, '\P{Is_SB=lo}', "");
    Expect(0, 125252, '\P{^Is_SB=lo}', "");
    Expect(1, 125251, '\p{Is_SB=	 lo}', "");
    Expect(0, 125251, '\p{^Is_SB=	 lo}', "");
    Expect(0, 125251, '\P{Is_SB=	 lo}', "");
    Expect(1, 125251, '\P{^Is_SB=	 lo}', "");
    Expect(0, 125252, '\p{Is_SB=	 lo}', "");
    Expect(1, 125252, '\p{^Is_SB=	 lo}', "");
    Expect(1, 125252, '\P{Is_SB=	 lo}', "");
    Expect(0, 125252, '\P{^Is_SB=	 lo}', "");
    Error('\p{Sentence_Break=/a/--NUMERIC}');
    Error('\P{Sentence_Break=/a/--NUMERIC}');
    Expect(1, 130041, '\p{Sentence_Break=:\ANumeric\z:}', "");;
    Expect(0, 130042, '\p{Sentence_Break=:\ANumeric\z:}', "");;
    Expect(1, 130041, '\p{Sentence_Break=numeric}', "");
    Expect(0, 130041, '\p{^Sentence_Break=numeric}', "");
    Expect(0, 130041, '\P{Sentence_Break=numeric}', "");
    Expect(1, 130041, '\P{^Sentence_Break=numeric}', "");
    Expect(0, 130042, '\p{Sentence_Break=numeric}', "");
    Expect(1, 130042, '\p{^Sentence_Break=numeric}', "");
    Expect(1, 130042, '\P{Sentence_Break=numeric}', "");
    Expect(0, 130042, '\P{^Sentence_Break=numeric}', "");
    Expect(1, 130041, '\p{Sentence_Break=:\Anumeric\z:}', "");;
    Expect(0, 130042, '\p{Sentence_Break=:\Anumeric\z:}', "");;
    Expect(1, 130041, '\p{Sentence_Break= -NUMERIC}', "");
    Expect(0, 130041, '\p{^Sentence_Break= -NUMERIC}', "");
    Expect(0, 130041, '\P{Sentence_Break= -NUMERIC}', "");
    Expect(1, 130041, '\P{^Sentence_Break= -NUMERIC}', "");
    Expect(0, 130042, '\p{Sentence_Break= -NUMERIC}', "");
    Expect(1, 130042, '\p{^Sentence_Break= -NUMERIC}', "");
    Expect(1, 130042, '\P{Sentence_Break= -NUMERIC}', "");
    Expect(0, 130042, '\P{^Sentence_Break= -NUMERIC}', "");
    Error('\p{SB= _nu:=}');
    Error('\P{SB= _nu:=}');
    Expect(1, 130041, '\p{SB=:\ANU\z:}', "");;
    Expect(0, 130042, '\p{SB=:\ANU\z:}', "");;
    Expect(1, 130041, '\p{SB:	nu}', "");
    Expect(0, 130041, '\p{^SB:	nu}', "");
    Expect(0, 130041, '\P{SB:	nu}', "");
    Expect(1, 130041, '\P{^SB:	nu}', "");
    Expect(0, 130042, '\p{SB:	nu}', "");
    Expect(1, 130042, '\p{^SB:	nu}', "");
    Expect(1, 130042, '\P{SB:	nu}', "");
    Expect(0, 130042, '\P{^SB:	nu}', "");
    Expect(1, 130041, '\p{SB=:\Anu\z:}', "");;
    Expect(0, 130042, '\p{SB=:\Anu\z:}', "");;
    Expect(1, 130041, '\p{SB=-NU}', "");
    Expect(0, 130041, '\p{^SB=-NU}', "");
    Expect(0, 130041, '\P{SB=-NU}', "");
    Expect(1, 130041, '\P{^SB=-NU}', "");
    Expect(0, 130042, '\p{SB=-NU}', "");
    Expect(1, 130042, '\p{^SB=-NU}', "");
    Expect(1, 130042, '\P{SB=-NU}', "");
    Expect(0, 130042, '\P{^SB=-NU}', "");
    Error('\p{Is_Sentence_Break= _NUMERIC:=}');
    Error('\P{Is_Sentence_Break= _NUMERIC:=}');
    Expect(1, 130041, '\p{Is_Sentence_Break=numeric}', "");
    Expect(0, 130041, '\p{^Is_Sentence_Break=numeric}', "");
    Expect(0, 130041, '\P{Is_Sentence_Break=numeric}', "");
    Expect(1, 130041, '\P{^Is_Sentence_Break=numeric}', "");
    Expect(0, 130042, '\p{Is_Sentence_Break=numeric}', "");
    Expect(1, 130042, '\p{^Is_Sentence_Break=numeric}', "");
    Expect(1, 130042, '\P{Is_Sentence_Break=numeric}', "");
    Expect(0, 130042, '\P{^Is_Sentence_Break=numeric}', "");
    Expect(1, 130041, '\p{Is_Sentence_Break= 	NUMERIC}', "");
    Expect(0, 130041, '\p{^Is_Sentence_Break= 	NUMERIC}', "");
    Expect(0, 130041, '\P{Is_Sentence_Break= 	NUMERIC}', "");
    Expect(1, 130041, '\P{^Is_Sentence_Break= 	NUMERIC}', "");
    Expect(0, 130042, '\p{Is_Sentence_Break= 	NUMERIC}', "");
    Expect(1, 130042, '\p{^Is_Sentence_Break= 	NUMERIC}', "");
    Expect(1, 130042, '\P{Is_Sentence_Break= 	NUMERIC}', "");
    Expect(0, 130042, '\P{^Is_Sentence_Break= 	NUMERIC}', "");
    Error('\p{Is_SB=-nu:=}');
    Error('\P{Is_SB=-nu:=}');
    Expect(1, 130041, '\p{Is_SB=nu}', "");
    Expect(0, 130041, '\p{^Is_SB=nu}', "");
    Expect(0, 130041, '\P{Is_SB=nu}', "");
    Expect(1, 130041, '\P{^Is_SB=nu}', "");
    Expect(0, 130042, '\p{Is_SB=nu}', "");
    Expect(1, 130042, '\p{^Is_SB=nu}', "");
    Expect(1, 130042, '\P{Is_SB=nu}', "");
    Expect(0, 130042, '\P{^Is_SB=nu}', "");
    Expect(1, 130041, '\p{Is_SB=-nu}', "");
    Expect(0, 130041, '\p{^Is_SB=-nu}', "");
    Expect(0, 130041, '\P{Is_SB=-nu}', "");
    Expect(1, 130041, '\P{^Is_SB=-nu}', "");
    Expect(0, 130042, '\p{Is_SB=-nu}', "");
    Expect(1, 130042, '\p{^Is_SB=-nu}', "");
    Expect(1, 130042, '\P{Is_SB=-nu}', "");
    Expect(0, 130042, '\P{^Is_SB=-nu}', "");
    Error('\p{Sentence_Break=:=-SCONTINUE}');
    Error('\P{Sentence_Break=:=-SCONTINUE}');
    Expect(1, 65380, '\p{Sentence_Break=:\ASContinue\z:}', "");;
    Expect(0, 65381, '\p{Sentence_Break=:\ASContinue\z:}', "");;
    Expect(1, 65380, '\p{Sentence_Break=scontinue}', "");
    Expect(0, 65380, '\p{^Sentence_Break=scontinue}', "");
    Expect(0, 65380, '\P{Sentence_Break=scontinue}', "");
    Expect(1, 65380, '\P{^Sentence_Break=scontinue}', "");
    Expect(0, 65381, '\p{Sentence_Break=scontinue}', "");
    Expect(1, 65381, '\p{^Sentence_Break=scontinue}', "");
    Expect(1, 65381, '\P{Sentence_Break=scontinue}', "");
    Expect(0, 65381, '\P{^Sentence_Break=scontinue}', "");
    Expect(1, 65380, '\p{Sentence_Break=:\Ascontinue\z:}', "");;
    Expect(0, 65381, '\p{Sentence_Break=:\Ascontinue\z:}', "");;
    Expect(1, 65380, '\p{Sentence_Break=__SContinue}', "");
    Expect(0, 65380, '\p{^Sentence_Break=__SContinue}', "");
    Expect(0, 65380, '\P{Sentence_Break=__SContinue}', "");
    Expect(1, 65380, '\P{^Sentence_Break=__SContinue}', "");
    Expect(0, 65381, '\p{Sentence_Break=__SContinue}', "");
    Expect(1, 65381, '\p{^Sentence_Break=__SContinue}', "");
    Expect(1, 65381, '\P{Sentence_Break=__SContinue}', "");
    Expect(0, 65381, '\P{^Sentence_Break=__SContinue}', "");
    Error('\p{SB:	/a/SC}');
    Error('\P{SB:	/a/SC}');
    Expect(1, 65380, '\p{SB=:\ASC\z:}', "");;
    Expect(0, 65381, '\p{SB=:\ASC\z:}', "");;
    Expect(1, 65380, '\p{SB=sc}', "");
    Expect(0, 65380, '\p{^SB=sc}', "");
    Expect(0, 65380, '\P{SB=sc}', "");
    Expect(1, 65380, '\P{^SB=sc}', "");
    Expect(0, 65381, '\p{SB=sc}', "");
    Expect(1, 65381, '\p{^SB=sc}', "");
    Expect(1, 65381, '\P{SB=sc}', "");
    Expect(0, 65381, '\P{^SB=sc}', "");
    Expect(1, 65380, '\p{SB=:\Asc\z:}', "");;
    Expect(0, 65381, '\p{SB=:\Asc\z:}', "");;
    Expect(1, 65380, '\p{SB= SC}', "");
    Expect(0, 65380, '\p{^SB= SC}', "");
    Expect(0, 65380, '\P{SB= SC}', "");
    Expect(1, 65380, '\P{^SB= SC}', "");
    Expect(0, 65381, '\p{SB= SC}', "");
    Expect(1, 65381, '\p{^SB= SC}', "");
    Expect(1, 65381, '\P{SB= SC}', "");
    Expect(0, 65381, '\P{^SB= SC}', "");
    Error('\p{Is_Sentence_Break=/a/		SContinue}');
    Error('\P{Is_Sentence_Break=/a/		SContinue}');
    Expect(1, 65380, '\p{Is_Sentence_Break=scontinue}', "");
    Expect(0, 65380, '\p{^Is_Sentence_Break=scontinue}', "");
    Expect(0, 65380, '\P{Is_Sentence_Break=scontinue}', "");
    Expect(1, 65380, '\P{^Is_Sentence_Break=scontinue}', "");
    Expect(0, 65381, '\p{Is_Sentence_Break=scontinue}', "");
    Expect(1, 65381, '\p{^Is_Sentence_Break=scontinue}', "");
    Expect(1, 65381, '\P{Is_Sentence_Break=scontinue}', "");
    Expect(0, 65381, '\P{^Is_Sentence_Break=scontinue}', "");
    Expect(1, 65380, '\p{Is_Sentence_Break=-	SContinue}', "");
    Expect(0, 65380, '\p{^Is_Sentence_Break=-	SContinue}', "");
    Expect(0, 65380, '\P{Is_Sentence_Break=-	SContinue}', "");
    Expect(1, 65380, '\P{^Is_Sentence_Break=-	SContinue}', "");
    Expect(0, 65381, '\p{Is_Sentence_Break=-	SContinue}', "");
    Expect(1, 65381, '\p{^Is_Sentence_Break=-	SContinue}', "");
    Expect(1, 65381, '\P{Is_Sentence_Break=-	SContinue}', "");
    Expect(0, 65381, '\P{^Is_Sentence_Break=-	SContinue}', "");
    Error('\p{Is_SB=/a/-_SC}');
    Error('\P{Is_SB=/a/-_SC}');
    Expect(1, 65380, '\p{Is_SB=sc}', "");
    Expect(0, 65380, '\p{^Is_SB=sc}', "");
    Expect(0, 65380, '\P{Is_SB=sc}', "");
    Expect(1, 65380, '\P{^Is_SB=sc}', "");
    Expect(0, 65381, '\p{Is_SB=sc}', "");
    Expect(1, 65381, '\p{^Is_SB=sc}', "");
    Expect(1, 65381, '\P{Is_SB=sc}', "");
    Expect(0, 65381, '\P{^Is_SB=sc}', "");
    Expect(1, 65380, '\p{Is_SB:   __SC}', "");
    Expect(0, 65380, '\p{^Is_SB:   __SC}', "");
    Expect(0, 65380, '\P{Is_SB:   __SC}', "");
    Expect(1, 65380, '\P{^Is_SB:   __SC}', "");
    Expect(0, 65381, '\p{Is_SB:   __SC}', "");
    Expect(1, 65381, '\p{^Is_SB:   __SC}', "");
    Expect(1, 65381, '\P{Is_SB:   __SC}', "");
    Expect(0, 65381, '\P{^Is_SB:   __SC}', "");
    Error('\p{Sentence_Break=:=Sep}');
    Error('\P{Sentence_Break=:=Sep}');
    Expect(1, 8233, '\p{Sentence_Break=:\ASep\z:}', "");;
    Expect(0, 8234, '\p{Sentence_Break=:\ASep\z:}', "");;
    Expect(1, 8233, '\p{Sentence_Break=sep}', "");
    Expect(0, 8233, '\p{^Sentence_Break=sep}', "");
    Expect(0, 8233, '\P{Sentence_Break=sep}', "");
    Expect(1, 8233, '\P{^Sentence_Break=sep}', "");
    Expect(0, 8234, '\p{Sentence_Break=sep}', "");
    Expect(1, 8234, '\p{^Sentence_Break=sep}', "");
    Expect(1, 8234, '\P{Sentence_Break=sep}', "");
    Expect(0, 8234, '\P{^Sentence_Break=sep}', "");
    Expect(1, 8233, '\p{Sentence_Break=:\Asep\z:}', "");;
    Expect(0, 8234, '\p{Sentence_Break=:\Asep\z:}', "");;
    Expect(1, 8233, '\p{Sentence_Break: _Sep}', "");
    Expect(0, 8233, '\p{^Sentence_Break: _Sep}', "");
    Expect(0, 8233, '\P{Sentence_Break: _Sep}', "");
    Expect(1, 8233, '\P{^Sentence_Break: _Sep}', "");
    Expect(0, 8234, '\p{Sentence_Break: _Sep}', "");
    Expect(1, 8234, '\p{^Sentence_Break: _Sep}', "");
    Expect(1, 8234, '\P{Sentence_Break: _Sep}', "");
    Expect(0, 8234, '\P{^Sentence_Break: _Sep}', "");
    Error('\p{SB=/a/ SE}');
    Error('\P{SB=/a/ SE}');
    Expect(1, 8233, '\p{SB=:\ASE\z:}', "");;
    Expect(0, 8234, '\p{SB=:\ASE\z:}', "");;
    Expect(1, 8233, '\p{SB=se}', "");
    Expect(0, 8233, '\p{^SB=se}', "");
    Expect(0, 8233, '\P{SB=se}', "");
    Expect(1, 8233, '\P{^SB=se}', "");
    Expect(0, 8234, '\p{SB=se}', "");
    Expect(1, 8234, '\p{^SB=se}', "");
    Expect(1, 8234, '\P{SB=se}', "");
    Expect(0, 8234, '\P{^SB=se}', "");
    Expect(1, 8233, '\p{SB=:\Ase\z:}', "");;
    Expect(0, 8234, '\p{SB=:\Ase\z:}', "");;
    Expect(1, 8233, '\p{SB=__SE}', "");
    Expect(0, 8233, '\p{^SB=__SE}', "");
    Expect(0, 8233, '\P{SB=__SE}', "");
    Expect(1, 8233, '\P{^SB=__SE}', "");
    Expect(0, 8234, '\p{SB=__SE}', "");
    Expect(1, 8234, '\p{^SB=__SE}', "");
    Expect(1, 8234, '\P{SB=__SE}', "");
    Expect(0, 8234, '\P{^SB=__SE}', "");
    Error('\p{Is_Sentence_Break=	Sep/a/}');
    Error('\P{Is_Sentence_Break=	Sep/a/}');
    Expect(1, 8233, '\p{Is_Sentence_Break:	sep}', "");
    Expect(0, 8233, '\p{^Is_Sentence_Break:	sep}', "");
    Expect(0, 8233, '\P{Is_Sentence_Break:	sep}', "");
    Expect(1, 8233, '\P{^Is_Sentence_Break:	sep}', "");
    Expect(0, 8234, '\p{Is_Sentence_Break:	sep}', "");
    Expect(1, 8234, '\p{^Is_Sentence_Break:	sep}', "");
    Expect(1, 8234, '\P{Is_Sentence_Break:	sep}', "");
    Expect(0, 8234, '\P{^Is_Sentence_Break:	sep}', "");
    Expect(1, 8233, '\p{Is_Sentence_Break=- SEP}', "");
    Expect(0, 8233, '\p{^Is_Sentence_Break=- SEP}', "");
    Expect(0, 8233, '\P{Is_Sentence_Break=- SEP}', "");
    Expect(1, 8233, '\P{^Is_Sentence_Break=- SEP}', "");
    Expect(0, 8234, '\p{Is_Sentence_Break=- SEP}', "");
    Expect(1, 8234, '\p{^Is_Sentence_Break=- SEP}', "");
    Expect(1, 8234, '\P{Is_Sentence_Break=- SEP}', "");
    Expect(0, 8234, '\P{^Is_Sentence_Break=- SEP}', "");
    Error('\p{Is_SB= :=SE}');
    Error('\P{Is_SB= :=SE}');
    Expect(1, 8233, '\p{Is_SB=se}', "");
    Expect(0, 8233, '\p{^Is_SB=se}', "");
    Expect(0, 8233, '\P{Is_SB=se}', "");
    Expect(1, 8233, '\P{^Is_SB=se}', "");
    Expect(0, 8234, '\p{Is_SB=se}', "");
    Expect(1, 8234, '\p{^Is_SB=se}', "");
    Expect(1, 8234, '\P{Is_SB=se}', "");
    Expect(0, 8234, '\P{^Is_SB=se}', "");
    Expect(1, 8233, '\p{Is_SB=_ SE}', "");
    Expect(0, 8233, '\p{^Is_SB=_ SE}', "");
    Expect(0, 8233, '\P{Is_SB=_ SE}', "");
    Expect(1, 8233, '\P{^Is_SB=_ SE}', "");
    Expect(0, 8234, '\p{Is_SB=_ SE}', "");
    Expect(1, 8234, '\p{^Is_SB=_ SE}', "");
    Expect(1, 8234, '\P{Is_SB=_ SE}', "");
    Expect(0, 8234, '\P{^Is_SB=_ SE}', "");
    Error('\p{Sentence_Break=Sp:=}');
    Error('\P{Sentence_Break=Sp:=}');
    Expect(1, 12288, '\p{Sentence_Break=:\ASp\z:}', "");;
    Expect(0, 12289, '\p{Sentence_Break=:\ASp\z:}', "");;
    Expect(1, 12288, '\p{Sentence_Break=sp}', "");
    Expect(0, 12288, '\p{^Sentence_Break=sp}', "");
    Expect(0, 12288, '\P{Sentence_Break=sp}', "");
    Expect(1, 12288, '\P{^Sentence_Break=sp}', "");
    Expect(0, 12289, '\p{Sentence_Break=sp}', "");
    Expect(1, 12289, '\p{^Sentence_Break=sp}', "");
    Expect(1, 12289, '\P{Sentence_Break=sp}', "");
    Expect(0, 12289, '\P{^Sentence_Break=sp}', "");
    Expect(1, 12288, '\p{Sentence_Break=:\Asp\z:}', "");;
    Expect(0, 12289, '\p{Sentence_Break=:\Asp\z:}', "");;
    Expect(1, 12288, '\p{Sentence_Break=		Sp}', "");
    Expect(0, 12288, '\p{^Sentence_Break=		Sp}', "");
    Expect(0, 12288, '\P{Sentence_Break=		Sp}', "");
    Expect(1, 12288, '\P{^Sentence_Break=		Sp}', "");
    Expect(0, 12289, '\p{Sentence_Break=		Sp}', "");
    Expect(1, 12289, '\p{^Sentence_Break=		Sp}', "");
    Expect(1, 12289, '\P{Sentence_Break=		Sp}', "");
    Expect(0, 12289, '\P{^Sentence_Break=		Sp}', "");
    Error('\p{SB=:=-Sp}');
    Error('\P{SB=:=-Sp}');
    Expect(1, 12288, '\p{SB=:\ASp\z:}', "");;
    Expect(0, 12289, '\p{SB=:\ASp\z:}', "");;
    Expect(1, 12288, '\p{SB=sp}', "");
    Expect(0, 12288, '\p{^SB=sp}', "");
    Expect(0, 12288, '\P{SB=sp}', "");
    Expect(1, 12288, '\P{^SB=sp}', "");
    Expect(0, 12289, '\p{SB=sp}', "");
    Expect(1, 12289, '\p{^SB=sp}', "");
    Expect(1, 12289, '\P{SB=sp}', "");
    Expect(0, 12289, '\P{^SB=sp}', "");
    Expect(1, 12288, '\p{SB=:\Asp\z:}', "");;
    Expect(0, 12289, '\p{SB=:\Asp\z:}', "");;
    Expect(1, 12288, '\p{SB=_SP}', "");
    Expect(0, 12288, '\p{^SB=_SP}', "");
    Expect(0, 12288, '\P{SB=_SP}', "");
    Expect(1, 12288, '\P{^SB=_SP}', "");
    Expect(0, 12289, '\p{SB=_SP}', "");
    Expect(1, 12289, '\p{^SB=_SP}', "");
    Expect(1, 12289, '\P{SB=_SP}', "");
    Expect(0, 12289, '\P{^SB=_SP}', "");
    Error('\p{Is_Sentence_Break=:= 	sp}');
    Error('\P{Is_Sentence_Break=:= 	sp}');
    Expect(1, 12288, '\p{Is_Sentence_Break=sp}', "");
    Expect(0, 12288, '\p{^Is_Sentence_Break=sp}', "");
    Expect(0, 12288, '\P{Is_Sentence_Break=sp}', "");
    Expect(1, 12288, '\P{^Is_Sentence_Break=sp}', "");
    Expect(0, 12289, '\p{Is_Sentence_Break=sp}', "");
    Expect(1, 12289, '\p{^Is_Sentence_Break=sp}', "");
    Expect(1, 12289, '\P{Is_Sentence_Break=sp}', "");
    Expect(0, 12289, '\P{^Is_Sentence_Break=sp}', "");
    Expect(1, 12288, '\p{Is_Sentence_Break= 	Sp}', "");
    Expect(0, 12288, '\p{^Is_Sentence_Break= 	Sp}', "");
    Expect(0, 12288, '\P{Is_Sentence_Break= 	Sp}', "");
    Expect(1, 12288, '\P{^Is_Sentence_Break= 	Sp}', "");
    Expect(0, 12289, '\p{Is_Sentence_Break= 	Sp}', "");
    Expect(1, 12289, '\p{^Is_Sentence_Break= 	Sp}', "");
    Expect(1, 12289, '\P{Is_Sentence_Break= 	Sp}', "");
    Expect(0, 12289, '\P{^Is_Sentence_Break= 	Sp}', "");
    Error('\p{Is_SB=:=	sp}');
    Error('\P{Is_SB=:=	sp}');
    Expect(1, 12288, '\p{Is_SB=sp}', "");
    Expect(0, 12288, '\p{^Is_SB=sp}', "");
    Expect(0, 12288, '\P{Is_SB=sp}', "");
    Expect(1, 12288, '\P{^Is_SB=sp}', "");
    Expect(0, 12289, '\p{Is_SB=sp}', "");
    Expect(1, 12289, '\p{^Is_SB=sp}', "");
    Expect(1, 12289, '\P{Is_SB=sp}', "");
    Expect(0, 12289, '\P{^Is_SB=sp}', "");
    Expect(1, 12288, '\p{Is_SB=		Sp}', "");
    Expect(0, 12288, '\p{^Is_SB=		Sp}', "");
    Expect(0, 12288, '\P{Is_SB=		Sp}', "");
    Expect(1, 12288, '\P{^Is_SB=		Sp}', "");
    Expect(0, 12289, '\p{Is_SB=		Sp}', "");
    Expect(1, 12289, '\p{^Is_SB=		Sp}', "");
    Expect(1, 12289, '\P{Is_SB=		Sp}', "");
    Expect(0, 12289, '\P{^Is_SB=		Sp}', "");
    Error('\p{Sentence_Break=/a/-	STERM}');
    Error('\P{Sentence_Break=/a/-	STERM}');
    Expect(1, 121480, '\p{Sentence_Break=:\ASTerm\z:}', "");;
    Expect(0, 121481, '\p{Sentence_Break=:\ASTerm\z:}', "");;
    Expect(1, 121480, '\p{Sentence_Break=sterm}', "");
    Expect(0, 121480, '\p{^Sentence_Break=sterm}', "");
    Expect(0, 121480, '\P{Sentence_Break=sterm}', "");
    Expect(1, 121480, '\P{^Sentence_Break=sterm}', "");
    Expect(0, 121481, '\p{Sentence_Break=sterm}', "");
    Expect(1, 121481, '\p{^Sentence_Break=sterm}', "");
    Expect(1, 121481, '\P{Sentence_Break=sterm}', "");
    Expect(0, 121481, '\P{^Sentence_Break=sterm}', "");
    Expect(1, 121480, '\p{Sentence_Break=:\Asterm\z:}', "");;
    Expect(0, 121481, '\p{Sentence_Break=:\Asterm\z:}', "");;
    Expect(1, 121480, '\p{Sentence_Break= 	STerm}', "");
    Expect(0, 121480, '\p{^Sentence_Break= 	STerm}', "");
    Expect(0, 121480, '\P{Sentence_Break= 	STerm}', "");
    Expect(1, 121480, '\P{^Sentence_Break= 	STerm}', "");
    Expect(0, 121481, '\p{Sentence_Break= 	STerm}', "");
    Expect(1, 121481, '\p{^Sentence_Break= 	STerm}', "");
    Expect(1, 121481, '\P{Sentence_Break= 	STerm}', "");
    Expect(0, 121481, '\P{^Sentence_Break= 	STerm}', "");
    Error('\p{SB=_ ST:=}');
    Error('\P{SB=_ ST:=}');
    Expect(1, 121480, '\p{SB=:\AST\z:}', "");;
    Expect(0, 121481, '\p{SB=:\AST\z:}', "");;
    Expect(1, 121480, '\p{SB=st}', "");
    Expect(0, 121480, '\p{^SB=st}', "");
    Expect(0, 121480, '\P{SB=st}', "");
    Expect(1, 121480, '\P{^SB=st}', "");
    Expect(0, 121481, '\p{SB=st}', "");
    Expect(1, 121481, '\p{^SB=st}', "");
    Expect(1, 121481, '\P{SB=st}', "");
    Expect(0, 121481, '\P{^SB=st}', "");
    Expect(1, 121480, '\p{SB=:\Ast\z:}', "");;
    Expect(0, 121481, '\p{SB=:\Ast\z:}', "");;
    Expect(1, 121480, '\p{SB:   --ST}', "");
    Expect(0, 121480, '\p{^SB:   --ST}', "");
    Expect(0, 121480, '\P{SB:   --ST}', "");
    Expect(1, 121480, '\P{^SB:   --ST}', "");
    Expect(0, 121481, '\p{SB:   --ST}', "");
    Expect(1, 121481, '\p{^SB:   --ST}', "");
    Expect(1, 121481, '\P{SB:   --ST}', "");
    Expect(0, 121481, '\P{^SB:   --ST}', "");
    Error('\p{Is_Sentence_Break= STerm/a/}');
    Error('\P{Is_Sentence_Break= STerm/a/}');
    Expect(1, 121480, '\p{Is_Sentence_Break=sterm}', "");
    Expect(0, 121480, '\p{^Is_Sentence_Break=sterm}', "");
    Expect(0, 121480, '\P{Is_Sentence_Break=sterm}', "");
    Expect(1, 121480, '\P{^Is_Sentence_Break=sterm}', "");
    Expect(0, 121481, '\p{Is_Sentence_Break=sterm}', "");
    Expect(1, 121481, '\p{^Is_Sentence_Break=sterm}', "");
    Expect(1, 121481, '\P{Is_Sentence_Break=sterm}', "");
    Expect(0, 121481, '\P{^Is_Sentence_Break=sterm}', "");
    Expect(1, 121480, '\p{Is_Sentence_Break=_-STerm}', "");
    Expect(0, 121480, '\p{^Is_Sentence_Break=_-STerm}', "");
    Expect(0, 121480, '\P{Is_Sentence_Break=_-STerm}', "");
    Expect(1, 121480, '\P{^Is_Sentence_Break=_-STerm}', "");
    Expect(0, 121481, '\p{Is_Sentence_Break=_-STerm}', "");
    Expect(1, 121481, '\p{^Is_Sentence_Break=_-STerm}', "");
    Expect(1, 121481, '\P{Is_Sentence_Break=_-STerm}', "");
    Expect(0, 121481, '\P{^Is_Sentence_Break=_-STerm}', "");
    Error('\p{Is_SB=  ST/a/}');
    Error('\P{Is_SB=  ST/a/}');
    Expect(1, 121480, '\p{Is_SB=st}', "");
    Expect(0, 121480, '\p{^Is_SB=st}', "");
    Expect(0, 121480, '\P{Is_SB=st}', "");
    Expect(1, 121480, '\P{^Is_SB=st}', "");
    Expect(0, 121481, '\p{Is_SB=st}', "");
    Expect(1, 121481, '\p{^Is_SB=st}', "");
    Expect(1, 121481, '\P{Is_SB=st}', "");
    Expect(0, 121481, '\P{^Is_SB=st}', "");
    Expect(1, 121480, '\p{Is_SB=  st}', "");
    Expect(0, 121480, '\p{^Is_SB=  st}', "");
    Expect(0, 121480, '\P{Is_SB=  st}', "");
    Expect(1, 121480, '\P{^Is_SB=  st}', "");
    Expect(0, 121481, '\p{Is_SB=  st}', "");
    Expect(1, 121481, '\p{^Is_SB=  st}', "");
    Expect(1, 121481, '\P{Is_SB=  st}', "");
    Expect(0, 121481, '\P{^Is_SB=  st}', "");
    Error('\p{Sentence_Break:   /a/	-Upper}');
    Error('\P{Sentence_Break:   /a/	-Upper}');
    Expect(1, 127369, '\p{Sentence_Break=:\AUpper\z:}', "");;
    Expect(0, 127370, '\p{Sentence_Break=:\AUpper\z:}', "");;
    Expect(1, 127369, '\p{Sentence_Break:   upper}', "");
    Expect(0, 127369, '\p{^Sentence_Break:   upper}', "");
    Expect(0, 127369, '\P{Sentence_Break:   upper}', "");
    Expect(1, 127369, '\P{^Sentence_Break:   upper}', "");
    Expect(0, 127370, '\p{Sentence_Break:   upper}', "");
    Expect(1, 127370, '\p{^Sentence_Break:   upper}', "");
    Expect(1, 127370, '\P{Sentence_Break:   upper}', "");
    Expect(0, 127370, '\P{^Sentence_Break:   upper}', "");
    Expect(1, 127369, '\p{Sentence_Break=:\Aupper\z:}', "");;
    Expect(0, 127370, '\p{Sentence_Break=:\Aupper\z:}', "");;
    Expect(1, 127369, '\p{Sentence_Break=  Upper}', "");
    Expect(0, 127369, '\p{^Sentence_Break=  Upper}', "");
    Expect(0, 127369, '\P{Sentence_Break=  Upper}', "");
    Expect(1, 127369, '\P{^Sentence_Break=  Upper}', "");
    Expect(0, 127370, '\p{Sentence_Break=  Upper}', "");
    Expect(1, 127370, '\p{^Sentence_Break=  Upper}', "");
    Expect(1, 127370, '\P{Sentence_Break=  Upper}', "");
    Expect(0, 127370, '\P{^Sentence_Break=  Upper}', "");
    Error('\p{SB=/a/	-UP}');
    Error('\P{SB=/a/	-UP}');
    Expect(1, 127369, '\p{SB=:\AUP\z:}', "");;
    Expect(0, 127370, '\p{SB=:\AUP\z:}', "");;
    Expect(1, 127369, '\p{SB=up}', "");
    Expect(0, 127369, '\p{^SB=up}', "");
    Expect(0, 127369, '\P{SB=up}', "");
    Expect(1, 127369, '\P{^SB=up}', "");
    Expect(0, 127370, '\p{SB=up}', "");
    Expect(1, 127370, '\p{^SB=up}', "");
    Expect(1, 127370, '\P{SB=up}', "");
    Expect(0, 127370, '\P{^SB=up}', "");
    Expect(1, 127369, '\p{SB=:\Aup\z:}', "");;
    Expect(0, 127370, '\p{SB=:\Aup\z:}', "");;
    Expect(1, 127369, '\p{SB=UP}', "");
    Expect(0, 127369, '\p{^SB=UP}', "");
    Expect(0, 127369, '\P{SB=UP}', "");
    Expect(1, 127369, '\P{^SB=UP}', "");
    Expect(0, 127370, '\p{SB=UP}', "");
    Expect(1, 127370, '\p{^SB=UP}', "");
    Expect(1, 127370, '\P{SB=UP}', "");
    Expect(0, 127370, '\P{^SB=UP}', "");
    Error('\p{Is_Sentence_Break= upper/a/}');
    Error('\P{Is_Sentence_Break= upper/a/}');
    Expect(1, 127369, '\p{Is_Sentence_Break=upper}', "");
    Expect(0, 127369, '\p{^Is_Sentence_Break=upper}', "");
    Expect(0, 127369, '\P{Is_Sentence_Break=upper}', "");
    Expect(1, 127369, '\P{^Is_Sentence_Break=upper}', "");
    Expect(0, 127370, '\p{Is_Sentence_Break=upper}', "");
    Expect(1, 127370, '\p{^Is_Sentence_Break=upper}', "");
    Expect(1, 127370, '\P{Is_Sentence_Break=upper}', "");
    Expect(0, 127370, '\P{^Is_Sentence_Break=upper}', "");
    Expect(1, 127369, '\p{Is_Sentence_Break=-Upper}', "");
    Expect(0, 127369, '\p{^Is_Sentence_Break=-Upper}', "");
    Expect(0, 127369, '\P{Is_Sentence_Break=-Upper}', "");
    Expect(1, 127369, '\P{^Is_Sentence_Break=-Upper}', "");
    Expect(0, 127370, '\p{Is_Sentence_Break=-Upper}', "");
    Expect(1, 127370, '\p{^Is_Sentence_Break=-Upper}', "");
    Expect(1, 127370, '\P{Is_Sentence_Break=-Upper}', "");
    Expect(0, 127370, '\P{^Is_Sentence_Break=-Upper}', "");
    Error('\p{Is_SB=:=UP}');
    Error('\P{Is_SB=:=UP}');
    Expect(1, 127369, '\p{Is_SB=up}', "");
    Expect(0, 127369, '\p{^Is_SB=up}', "");
    Expect(0, 127369, '\P{Is_SB=up}', "");
    Expect(1, 127369, '\P{^Is_SB=up}', "");
    Expect(0, 127370, '\p{Is_SB=up}', "");
    Expect(1, 127370, '\p{^Is_SB=up}', "");
    Expect(1, 127370, '\P{Is_SB=up}', "");
    Expect(0, 127370, '\P{^Is_SB=up}', "");
    Expect(1, 127369, '\p{Is_SB=	-UP}', "");
    Expect(0, 127369, '\p{^Is_SB=	-UP}', "");
    Expect(0, 127369, '\P{Is_SB=	-UP}', "");
    Expect(1, 127369, '\P{^Is_SB=	-UP}', "");
    Expect(0, 127370, '\p{Is_SB=	-UP}', "");
    Expect(1, 127370, '\p{^Is_SB=	-UP}', "");
    Expect(1, 127370, '\P{Is_SB=	-UP}', "");
    Expect(0, 127370, '\P{^Is_SB=	-UP}', "");
    Error('\p{Sentence_Break=_/a/OTHER}');
    Error('\P{Sentence_Break=_/a/OTHER}');
    Expect(1, 918000, '\p{Sentence_Break=:\AOther\z:}', "");;
    Expect(0, 917999, '\p{Sentence_Break=:\AOther\z:}', "");;
    Expect(1, 918000, '\p{Sentence_Break=other}', "");
    Expect(0, 918000, '\p{^Sentence_Break=other}', "");
    Expect(0, 918000, '\P{Sentence_Break=other}', "");
    Expect(1, 918000, '\P{^Sentence_Break=other}', "");
    Expect(0, 917999, '\p{Sentence_Break=other}', "");
    Expect(1, 917999, '\p{^Sentence_Break=other}', "");
    Expect(1, 917999, '\P{Sentence_Break=other}', "");
    Expect(0, 917999, '\P{^Sentence_Break=other}', "");
    Expect(1, 918000, '\p{Sentence_Break=:\Aother\z:}', "");;
    Expect(0, 917999, '\p{Sentence_Break=:\Aother\z:}', "");;
    Expect(1, 918000, '\p{Sentence_Break=-	other}', "");
    Expect(0, 918000, '\p{^Sentence_Break=-	other}', "");
    Expect(0, 918000, '\P{Sentence_Break=-	other}', "");
    Expect(1, 918000, '\P{^Sentence_Break=-	other}', "");
    Expect(0, 917999, '\p{Sentence_Break=-	other}', "");
    Expect(1, 917999, '\p{^Sentence_Break=-	other}', "");
    Expect(1, 917999, '\P{Sentence_Break=-	other}', "");
    Expect(0, 917999, '\P{^Sentence_Break=-	other}', "");
    Error('\p{SB=/a/_xx}');
    Error('\P{SB=/a/_xx}');
    Expect(1, 918000, '\p{SB=:\AXX\z:}', "");;
    Expect(0, 917999, '\p{SB=:\AXX\z:}', "");;
    Expect(1, 918000, '\p{SB=xx}', "");
    Expect(0, 918000, '\p{^SB=xx}', "");
    Expect(0, 918000, '\P{SB=xx}', "");
    Expect(1, 918000, '\P{^SB=xx}', "");
    Expect(0, 917999, '\p{SB=xx}', "");
    Expect(1, 917999, '\p{^SB=xx}', "");
    Expect(1, 917999, '\P{SB=xx}', "");
    Expect(0, 917999, '\P{^SB=xx}', "");
    Expect(1, 918000, '\p{SB=:\Axx\z:}', "");;
    Expect(0, 917999, '\p{SB=:\Axx\z:}', "");;
    Expect(1, 918000, '\p{SB= 	XX}', "");
    Expect(0, 918000, '\p{^SB= 	XX}', "");
    Expect(0, 918000, '\P{SB= 	XX}', "");
    Expect(1, 918000, '\P{^SB= 	XX}', "");
    Expect(0, 917999, '\p{SB= 	XX}', "");
    Expect(1, 917999, '\p{^SB= 	XX}', "");
    Expect(1, 917999, '\P{SB= 	XX}', "");
    Expect(0, 917999, '\P{^SB= 	XX}', "");
    Error('\p{Is_Sentence_Break= OTHER/a/}');
    Error('\P{Is_Sentence_Break= OTHER/a/}');
    Expect(1, 918000, '\p{Is_Sentence_Break=other}', "");
    Expect(0, 918000, '\p{^Is_Sentence_Break=other}', "");
    Expect(0, 918000, '\P{Is_Sentence_Break=other}', "");
    Expect(1, 918000, '\P{^Is_Sentence_Break=other}', "");
    Expect(0, 917999, '\p{Is_Sentence_Break=other}', "");
    Expect(1, 917999, '\p{^Is_Sentence_Break=other}', "");
    Expect(1, 917999, '\P{Is_Sentence_Break=other}', "");
    Expect(0, 917999, '\P{^Is_Sentence_Break=other}', "");
    Expect(1, 918000, '\p{Is_Sentence_Break=	-Other}', "");
    Expect(0, 918000, '\p{^Is_Sentence_Break=	-Other}', "");
    Expect(0, 918000, '\P{Is_Sentence_Break=	-Other}', "");
    Expect(1, 918000, '\P{^Is_Sentence_Break=	-Other}', "");
    Expect(0, 917999, '\p{Is_Sentence_Break=	-Other}', "");
    Expect(1, 917999, '\p{^Is_Sentence_Break=	-Other}', "");
    Expect(1, 917999, '\P{Is_Sentence_Break=	-Other}', "");
    Expect(0, 917999, '\P{^Is_Sentence_Break=	-Other}', "");
    Error('\p{Is_SB:	_-XX:=}');
    Error('\P{Is_SB:	_-XX:=}');
    Expect(1, 918000, '\p{Is_SB=xx}', "");
    Expect(0, 918000, '\p{^Is_SB=xx}', "");
    Expect(0, 918000, '\P{Is_SB=xx}', "");
    Expect(1, 918000, '\P{^Is_SB=xx}', "");
    Expect(0, 917999, '\p{Is_SB=xx}', "");
    Expect(1, 917999, '\p{^Is_SB=xx}', "");
    Expect(1, 917999, '\P{Is_SB=xx}', "");
    Expect(0, 917999, '\P{^Is_SB=xx}', "");
    Expect(1, 918000, '\p{Is_SB=-_XX}', "");
    Expect(0, 918000, '\p{^Is_SB=-_XX}', "");
    Expect(0, 918000, '\P{Is_SB=-_XX}', "");
    Expect(1, 918000, '\P{^Is_SB=-_XX}', "");
    Expect(0, 917999, '\p{Is_SB=-_XX}', "");
    Expect(1, 917999, '\p{^Is_SB=-_XX}', "");
    Expect(1, 917999, '\P{Is_SB=-_XX}', "");
    Expect(0, 917999, '\P{^Is_SB=-_XX}', "");
    Error('\p{script}');
    Error('\P{script}');
    Error('\p{Script: --Adlam/a/}');
    Error('\P{Script: --Adlam/a/}');
    Expect(1, 125279, '\p{Script=:\AAdlam\z:}', "");;
    Expect(0, 125280, '\p{Script=:\AAdlam\z:}', "");;
    Expect(1, 125279, '\p{Script=adlam}', "");
    Expect(0, 125279, '\p{^Script=adlam}', "");
    Expect(0, 125279, '\P{Script=adlam}', "");
    Expect(1, 125279, '\P{^Script=adlam}', "");
    Expect(0, 125280, '\p{Script=adlam}', "");
    Expect(1, 125280, '\p{^Script=adlam}', "");
    Expect(1, 125280, '\P{Script=adlam}', "");
    Expect(0, 125280, '\P{^Script=adlam}', "");
    Expect(1, 125279, '\p{Script=:\Aadlam\z:}', "");;
    Expect(0, 125280, '\p{Script=:\Aadlam\z:}', "");;
    Expect(1, 125279, '\p{Script= Adlam}', "");
    Expect(0, 125279, '\p{^Script= Adlam}', "");
    Expect(0, 125279, '\P{Script= Adlam}', "");
    Expect(1, 125279, '\P{^Script= Adlam}', "");
    Expect(0, 125280, '\p{Script= Adlam}', "");
    Expect(1, 125280, '\p{^Script= Adlam}', "");
    Expect(1, 125280, '\P{Script= Adlam}', "");
    Expect(0, 125280, '\P{^Script= Adlam}', "");
    Error('\p{Sc=/a/ -Adlm}');
    Error('\P{Sc=/a/ -Adlm}');
    Expect(1, 125279, '\p{Sc=:\AAdlm\z:}', "");;
    Expect(0, 125280, '\p{Sc=:\AAdlm\z:}', "");;
    Expect(1, 125279, '\p{Sc=adlm}', "");
    Expect(0, 125279, '\p{^Sc=adlm}', "");
    Expect(0, 125279, '\P{Sc=adlm}', "");
    Expect(1, 125279, '\P{^Sc=adlm}', "");
    Expect(0, 125280, '\p{Sc=adlm}', "");
    Expect(1, 125280, '\p{^Sc=adlm}', "");
    Expect(1, 125280, '\P{Sc=adlm}', "");
    Expect(0, 125280, '\P{^Sc=adlm}', "");
    Expect(1, 125279, '\p{Sc=:\Aadlm\z:}', "");;
    Expect(0, 125280, '\p{Sc=:\Aadlm\z:}', "");;
    Expect(1, 125279, '\p{Sc=  Adlm}', "");
    Expect(0, 125279, '\p{^Sc=  Adlm}', "");
    Expect(0, 125279, '\P{Sc=  Adlm}', "");
    Expect(1, 125279, '\P{^Sc=  Adlm}', "");
    Expect(0, 125280, '\p{Sc=  Adlm}', "");
    Expect(1, 125280, '\p{^Sc=  Adlm}', "");
    Expect(1, 125280, '\P{Sc=  Adlm}', "");
    Expect(0, 125280, '\P{^Sc=  Adlm}', "");
    Error('\p{Is_Script= :=Adlam}');
    Error('\P{Is_Script= :=Adlam}');
    Expect(1, 125279, '\p{Is_Script=adlam}', "");
    Expect(0, 125279, '\p{^Is_Script=adlam}', "");
    Expect(0, 125279, '\P{Is_Script=adlam}', "");
    Expect(1, 125279, '\P{^Is_Script=adlam}', "");
    Expect(0, 125280, '\p{Is_Script=adlam}', "");
    Expect(1, 125280, '\p{^Is_Script=adlam}', "");
    Expect(1, 125280, '\P{Is_Script=adlam}', "");
    Expect(0, 125280, '\P{^Is_Script=adlam}', "");
    Expect(1, 125279, '\p{Is_Script=__adlam}', "");
    Expect(0, 125279, '\p{^Is_Script=__adlam}', "");
    Expect(0, 125279, '\P{Is_Script=__adlam}', "");
    Expect(1, 125279, '\P{^Is_Script=__adlam}', "");
    Expect(0, 125280, '\p{Is_Script=__adlam}', "");
    Expect(1, 125280, '\p{^Is_Script=__adlam}', "");
    Expect(1, 125280, '\P{Is_Script=__adlam}', "");
    Expect(0, 125280, '\P{^Is_Script=__adlam}', "");
    Error('\p{Is_Sc::=-_adlm}');
    Error('\P{Is_Sc::=-_adlm}');
    Expect(1, 125279, '\p{Is_Sc=adlm}', "");
    Expect(0, 125279, '\p{^Is_Sc=adlm}', "");
    Expect(0, 125279, '\P{Is_Sc=adlm}', "");
    Expect(1, 125279, '\P{^Is_Sc=adlm}', "");
    Expect(0, 125280, '\p{Is_Sc=adlm}', "");
    Expect(1, 125280, '\p{^Is_Sc=adlm}', "");
    Expect(1, 125280, '\P{Is_Sc=adlm}', "");
    Expect(0, 125280, '\P{^Is_Sc=adlm}', "");
    Expect(1, 125279, '\p{Is_Sc= -ADLM}', "");
    Expect(0, 125279, '\p{^Is_Sc= -ADLM}', "");
    Expect(0, 125279, '\P{Is_Sc= -ADLM}', "");
    Expect(1, 125279, '\P{^Is_Sc= -ADLM}', "");
    Expect(0, 125280, '\p{Is_Sc= -ADLM}', "");
    Expect(1, 125280, '\p{^Is_Sc= -ADLM}', "");
    Expect(1, 125280, '\P{Is_Sc= -ADLM}', "");
    Expect(0, 125280, '\P{^Is_Sc= -ADLM}', "");
    Error('\p{Script=- Caucasian_Albanian:=}');
    Error('\P{Script=- Caucasian_Albanian:=}');
    Expect(1, 66927, '\p{Script=:\ACaucasian_Albanian\z:}', "");;
    Expect(0, 66928, '\p{Script=:\ACaucasian_Albanian\z:}', "");;
    Expect(1, 66927, '\p{Script:caucasianalbanian}', "");
    Expect(0, 66927, '\p{^Script:caucasianalbanian}', "");
    Expect(0, 66927, '\P{Script:caucasianalbanian}', "");
    Expect(1, 66927, '\P{^Script:caucasianalbanian}', "");
    Expect(0, 66928, '\p{Script:caucasianalbanian}', "");
    Expect(1, 66928, '\p{^Script:caucasianalbanian}', "");
    Expect(1, 66928, '\P{Script:caucasianalbanian}', "");
    Expect(0, 66928, '\P{^Script:caucasianalbanian}', "");
    Expect(1, 66927, '\p{Script=:\Acaucasianalbanian\z:}', "");;
    Expect(0, 66928, '\p{Script=:\Acaucasianalbanian\z:}', "");;
    Expect(1, 66927, '\p{Script=Caucasian_ALBANIAN}', "");
    Expect(0, 66927, '\p{^Script=Caucasian_ALBANIAN}', "");
    Expect(0, 66927, '\P{Script=Caucasian_ALBANIAN}', "");
    Expect(1, 66927, '\P{^Script=Caucasian_ALBANIAN}', "");
    Expect(0, 66928, '\p{Script=Caucasian_ALBANIAN}', "");
    Expect(1, 66928, '\p{^Script=Caucasian_ALBANIAN}', "");
    Expect(1, 66928, '\P{Script=Caucasian_ALBANIAN}', "");
    Expect(0, 66928, '\P{^Script=Caucasian_ALBANIAN}', "");
    Error('\p{Sc=/a/	-Aghb}');
    Error('\P{Sc=/a/	-Aghb}');
    Expect(1, 66927, '\p{Sc=:\AAghb\z:}', "");;
    Expect(0, 66928, '\p{Sc=:\AAghb\z:}', "");;
    Expect(1, 66927, '\p{Sc=aghb}', "");
    Expect(0, 66927, '\p{^Sc=aghb}', "");
    Expect(0, 66927, '\P{Sc=aghb}', "");
    Expect(1, 66927, '\P{^Sc=aghb}', "");
    Expect(0, 66928, '\p{Sc=aghb}', "");
    Expect(1, 66928, '\p{^Sc=aghb}', "");
    Expect(1, 66928, '\P{Sc=aghb}', "");
    Expect(0, 66928, '\P{^Sc=aghb}', "");
    Expect(1, 66927, '\p{Sc=:\Aaghb\z:}', "");;
    Expect(0, 66928, '\p{Sc=:\Aaghb\z:}', "");;
    Expect(1, 66927, '\p{Sc:			AGHB}', "");
    Expect(0, 66927, '\p{^Sc:			AGHB}', "");
    Expect(0, 66927, '\P{Sc:			AGHB}', "");
    Expect(1, 66927, '\P{^Sc:			AGHB}', "");
    Expect(0, 66928, '\p{Sc:			AGHB}', "");
    Expect(1, 66928, '\p{^Sc:			AGHB}', "");
    Expect(1, 66928, '\P{Sc:			AGHB}', "");
    Expect(0, 66928, '\P{^Sc:			AGHB}', "");
    Error('\p{Is_Script=_ CAUCASIAN_ALBANIAN/a/}');
    Error('\P{Is_Script=_ CAUCASIAN_ALBANIAN/a/}');
    Expect(1, 66927, '\p{Is_Script=caucasianalbanian}', "");
    Expect(0, 66927, '\p{^Is_Script=caucasianalbanian}', "");
    Expect(0, 66927, '\P{Is_Script=caucasianalbanian}', "");
    Expect(1, 66927, '\P{^Is_Script=caucasianalbanian}', "");
    Expect(0, 66928, '\p{Is_Script=caucasianalbanian}', "");
    Expect(1, 66928, '\p{^Is_Script=caucasianalbanian}', "");
    Expect(1, 66928, '\P{Is_Script=caucasianalbanian}', "");
    Expect(0, 66928, '\P{^Is_Script=caucasianalbanian}', "");
    Expect(1, 66927, '\p{Is_Script=	caucasian_ALBANIAN}', "");
    Expect(0, 66927, '\p{^Is_Script=	caucasian_ALBANIAN}', "");
    Expect(0, 66927, '\P{Is_Script=	caucasian_ALBANIAN}', "");
    Expect(1, 66927, '\P{^Is_Script=	caucasian_ALBANIAN}', "");
    Expect(0, 66928, '\p{Is_Script=	caucasian_ALBANIAN}', "");
    Expect(1, 66928, '\p{^Is_Script=	caucasian_ALBANIAN}', "");
    Expect(1, 66928, '\P{Is_Script=	caucasian_ALBANIAN}', "");
    Expect(0, 66928, '\P{^Is_Script=	caucasian_ALBANIAN}', "");
    Error('\p{Is_Sc=:= Aghb}');
    Error('\P{Is_Sc=:= Aghb}');
    Expect(1, 66927, '\p{Is_Sc=aghb}', "");
    Expect(0, 66927, '\p{^Is_Sc=aghb}', "");
    Expect(0, 66927, '\P{Is_Sc=aghb}', "");
    Expect(1, 66927, '\P{^Is_Sc=aghb}', "");
    Expect(0, 66928, '\p{Is_Sc=aghb}', "");
    Expect(1, 66928, '\p{^Is_Sc=aghb}', "");
    Expect(1, 66928, '\P{Is_Sc=aghb}', "");
    Expect(0, 66928, '\P{^Is_Sc=aghb}', "");
    Expect(1, 66927, '\p{Is_Sc=- aghb}', "");
    Expect(0, 66927, '\p{^Is_Sc=- aghb}', "");
    Expect(0, 66927, '\P{Is_Sc=- aghb}', "");
    Expect(1, 66927, '\P{^Is_Sc=- aghb}', "");
    Expect(0, 66928, '\p{Is_Sc=- aghb}', "");
    Expect(1, 66928, '\p{^Is_Sc=- aghb}', "");
    Expect(1, 66928, '\P{Is_Sc=- aghb}', "");
    Expect(0, 66928, '\P{^Is_Sc=- aghb}', "");
    Error('\p{Script=	:=ahom}');
    Error('\P{Script=	:=ahom}');
    Expect(1, 71494, '\p{Script=:\AAhom\z:}', "");;
    Expect(0, 71495, '\p{Script=:\AAhom\z:}', "");;
    Expect(1, 71494, '\p{Script=ahom}', "");
    Expect(0, 71494, '\p{^Script=ahom}', "");
    Expect(0, 71494, '\P{Script=ahom}', "");
    Expect(1, 71494, '\P{^Script=ahom}', "");
    Expect(0, 71495, '\p{Script=ahom}', "");
    Expect(1, 71495, '\p{^Script=ahom}', "");
    Expect(1, 71495, '\P{Script=ahom}', "");
    Expect(0, 71495, '\P{^Script=ahom}', "");
    Expect(1, 71494, '\p{Script=:\Aahom\z:}', "");;
    Expect(0, 71495, '\p{Script=:\Aahom\z:}', "");;
    Expect(1, 71494, '\p{Script= -Ahom}', "");
    Expect(0, 71494, '\p{^Script= -Ahom}', "");
    Expect(0, 71494, '\P{Script= -Ahom}', "");
    Expect(1, 71494, '\P{^Script= -Ahom}', "");
    Expect(0, 71495, '\p{Script= -Ahom}', "");
    Expect(1, 71495, '\p{^Script= -Ahom}', "");
    Expect(1, 71495, '\P{Script= -Ahom}', "");
    Expect(0, 71495, '\P{^Script= -Ahom}', "");
    Error('\p{Sc=:=_	AHOM}');
    Error('\P{Sc=:=_	AHOM}');
    Expect(1, 71494, '\p{Sc=:\AAhom\z:}', "");;
    Expect(0, 71495, '\p{Sc=:\AAhom\z:}', "");;
    Expect(1, 71494, '\p{Sc=ahom}', "");
    Expect(0, 71494, '\p{^Sc=ahom}', "");
    Expect(0, 71494, '\P{Sc=ahom}', "");
    Expect(1, 71494, '\P{^Sc=ahom}', "");
    Expect(0, 71495, '\p{Sc=ahom}', "");
    Expect(1, 71495, '\p{^Sc=ahom}', "");
    Expect(1, 71495, '\P{Sc=ahom}', "");
    Expect(0, 71495, '\P{^Sc=ahom}', "");
    Expect(1, 71494, '\p{Sc=:\Aahom\z:}', "");;
    Expect(0, 71495, '\p{Sc=:\Aahom\z:}', "");;
    Expect(1, 71494, '\p{Sc=Ahom}', "");
    Expect(0, 71494, '\p{^Sc=Ahom}', "");
    Expect(0, 71494, '\P{Sc=Ahom}', "");
    Expect(1, 71494, '\P{^Sc=Ahom}', "");
    Expect(0, 71495, '\p{Sc=Ahom}', "");
    Expect(1, 71495, '\p{^Sc=Ahom}', "");
    Expect(1, 71495, '\P{Sc=Ahom}', "");
    Expect(0, 71495, '\P{^Sc=Ahom}', "");
    Error('\p{Is_Script=:=AHOM}');
    Error('\P{Is_Script=:=AHOM}');
    Expect(1, 71494, '\p{Is_Script=ahom}', "");
    Expect(0, 71494, '\p{^Is_Script=ahom}', "");
    Expect(0, 71494, '\P{Is_Script=ahom}', "");
    Expect(1, 71494, '\P{^Is_Script=ahom}', "");
    Expect(0, 71495, '\p{Is_Script=ahom}', "");
    Expect(1, 71495, '\p{^Is_Script=ahom}', "");
    Expect(1, 71495, '\P{Is_Script=ahom}', "");
    Expect(0, 71495, '\P{^Is_Script=ahom}', "");
    Expect(1, 71494, '\p{Is_Script:	_-AHOM}', "");
    Expect(0, 71494, '\p{^Is_Script:	_-AHOM}', "");
    Expect(0, 71494, '\P{Is_Script:	_-AHOM}', "");
    Expect(1, 71494, '\P{^Is_Script:	_-AHOM}', "");
    Expect(0, 71495, '\p{Is_Script:	_-AHOM}', "");
    Expect(1, 71495, '\p{^Is_Script:	_-AHOM}', "");
    Expect(1, 71495, '\P{Is_Script:	_-AHOM}', "");
    Expect(0, 71495, '\P{^Is_Script:	_-AHOM}', "");
    Error('\p{Is_Sc=-	AHOM/a/}');
    Error('\P{Is_Sc=-	AHOM/a/}');
    Expect(1, 71494, '\p{Is_Sc=ahom}', "");
    Expect(0, 71494, '\p{^Is_Sc=ahom}', "");
    Expect(0, 71494, '\P{Is_Sc=ahom}', "");
    Expect(1, 71494, '\P{^Is_Sc=ahom}', "");
    Expect(0, 71495, '\p{Is_Sc=ahom}', "");
    Expect(1, 71495, '\p{^Is_Sc=ahom}', "");
    Expect(1, 71495, '\P{Is_Sc=ahom}', "");
    Expect(0, 71495, '\P{^Is_Sc=ahom}', "");
    Expect(1, 71494, '\p{Is_Sc:	__AHOM}', "");
    Expect(0, 71494, '\p{^Is_Sc:	__AHOM}', "");
    Expect(0, 71494, '\P{Is_Sc:	__AHOM}', "");
    Expect(1, 71494, '\P{^Is_Sc:	__AHOM}', "");
    Expect(0, 71495, '\p{Is_Sc:	__AHOM}', "");
    Expect(1, 71495, '\p{^Is_Sc:	__AHOM}', "");
    Expect(1, 71495, '\P{Is_Sc:	__AHOM}', "");
    Expect(0, 71495, '\P{^Is_Sc:	__AHOM}', "");
    Error('\p{Script=:=-ARABIC}');
    Error('\P{Script=:=-ARABIC}');
    Expect(1, 126705, '\p{Script=:\AArabic\z:}', "");;
    Expect(0, 126706, '\p{Script=:\AArabic\z:}', "");;
    Expect(1, 126705, '\p{Script=arabic}', "");
    Expect(0, 126705, '\p{^Script=arabic}', "");
    Expect(0, 126705, '\P{Script=arabic}', "");
    Expect(1, 126705, '\P{^Script=arabic}', "");
    Expect(0, 126706, '\p{Script=arabic}', "");
    Expect(1, 126706, '\p{^Script=arabic}', "");
    Expect(1, 126706, '\P{Script=arabic}', "");
    Expect(0, 126706, '\P{^Script=arabic}', "");
    Expect(1, 126705, '\p{Script=:\Aarabic\z:}', "");;
    Expect(0, 126706, '\p{Script=:\Aarabic\z:}', "");;
    Expect(1, 126705, '\p{Script=  arabic}', "");
    Expect(0, 126705, '\p{^Script=  arabic}', "");
    Expect(0, 126705, '\P{Script=  arabic}', "");
    Expect(1, 126705, '\P{^Script=  arabic}', "");
    Expect(0, 126706, '\p{Script=  arabic}', "");
    Expect(1, 126706, '\p{^Script=  arabic}', "");
    Expect(1, 126706, '\P{Script=  arabic}', "");
    Expect(0, 126706, '\P{^Script=  arabic}', "");
    Error('\p{Sc=_:=Arab}');
    Error('\P{Sc=_:=Arab}');
    Expect(1, 126705, '\p{Sc=:\AArab\z:}', "");;
    Expect(0, 126706, '\p{Sc=:\AArab\z:}', "");;
    Expect(1, 126705, '\p{Sc:   arab}', "");
    Expect(0, 126705, '\p{^Sc:   arab}', "");
    Expect(0, 126705, '\P{Sc:   arab}', "");
    Expect(1, 126705, '\P{^Sc:   arab}', "");
    Expect(0, 126706, '\p{Sc:   arab}', "");
    Expect(1, 126706, '\p{^Sc:   arab}', "");
    Expect(1, 126706, '\P{Sc:   arab}', "");
    Expect(0, 126706, '\P{^Sc:   arab}', "");
    Expect(1, 126705, '\p{Sc=:\Aarab\z:}', "");;
    Expect(0, 126706, '\p{Sc=:\Aarab\z:}', "");;
    Expect(1, 126705, '\p{Sc=	 Arab}', "");
    Expect(0, 126705, '\p{^Sc=	 Arab}', "");
    Expect(0, 126705, '\P{Sc=	 Arab}', "");
    Expect(1, 126705, '\P{^Sc=	 Arab}', "");
    Expect(0, 126706, '\p{Sc=	 Arab}', "");
    Expect(1, 126706, '\p{^Sc=	 Arab}', "");
    Expect(1, 126706, '\P{Sc=	 Arab}', "");
    Expect(0, 126706, '\P{^Sc=	 Arab}', "");
    Error('\p{Is_Script=:=	arabic}');
    Error('\P{Is_Script=:=	arabic}');
    Expect(1, 126705, '\p{Is_Script=arabic}', "");
    Expect(0, 126705, '\p{^Is_Script=arabic}', "");
    Expect(0, 126705, '\P{Is_Script=arabic}', "");
    Expect(1, 126705, '\P{^Is_Script=arabic}', "");
    Expect(0, 126706, '\p{Is_Script=arabic}', "");
    Expect(1, 126706, '\p{^Is_Script=arabic}', "");
    Expect(1, 126706, '\P{Is_Script=arabic}', "");
    Expect(0, 126706, '\P{^Is_Script=arabic}', "");
    Expect(1, 126705, '\p{Is_Script=		Arabic}', "");
    Expect(0, 126705, '\p{^Is_Script=		Arabic}', "");
    Expect(0, 126705, '\P{Is_Script=		Arabic}', "");
    Expect(1, 126705, '\P{^Is_Script=		Arabic}', "");
    Expect(0, 126706, '\p{Is_Script=		Arabic}', "");
    Expect(1, 126706, '\p{^Is_Script=		Arabic}', "");
    Expect(1, 126706, '\P{Is_Script=		Arabic}', "");
    Expect(0, 126706, '\P{^Is_Script=		Arabic}', "");
    Error('\p{Is_Sc=_/a/Arab}');
    Error('\P{Is_Sc=_/a/Arab}');
    Expect(1, 126705, '\p{Is_Sc=arab}', "");
    Expect(0, 126705, '\p{^Is_Sc=arab}', "");
    Expect(0, 126705, '\P{Is_Sc=arab}', "");
    Expect(1, 126705, '\P{^Is_Sc=arab}', "");
    Expect(0, 126706, '\p{Is_Sc=arab}', "");
    Expect(1, 126706, '\p{^Is_Sc=arab}', "");
    Expect(1, 126706, '\P{Is_Sc=arab}', "");
    Expect(0, 126706, '\P{^Is_Sc=arab}', "");
    Expect(1, 126705, '\p{Is_Sc:  _arab}', "");
    Expect(0, 126705, '\p{^Is_Sc:  _arab}', "");
    Expect(0, 126705, '\P{Is_Sc:  _arab}', "");
    Expect(1, 126705, '\P{^Is_Sc:  _arab}', "");
    Expect(0, 126706, '\p{Is_Sc:  _arab}', "");
    Expect(1, 126706, '\p{^Is_Sc:  _arab}', "");
    Expect(1, 126706, '\P{Is_Sc:  _arab}', "");
    Expect(0, 126706, '\P{^Is_Sc:  _arab}', "");
    Error('\p{Script= 	Imperial_ARAMAIC:=}');
    Error('\P{Script= 	Imperial_ARAMAIC:=}');
    Expect(1, 67679, '\p{Script=:\AImperial_Aramaic\z:}', "");;
    Expect(0, 67680, '\p{Script=:\AImperial_Aramaic\z:}', "");;
    Expect(1, 67679, '\p{Script=imperialaramaic}', "");
    Expect(0, 67679, '\p{^Script=imperialaramaic}', "");
    Expect(0, 67679, '\P{Script=imperialaramaic}', "");
    Expect(1, 67679, '\P{^Script=imperialaramaic}', "");
    Expect(0, 67680, '\p{Script=imperialaramaic}', "");
    Expect(1, 67680, '\p{^Script=imperialaramaic}', "");
    Expect(1, 67680, '\P{Script=imperialaramaic}', "");
    Expect(0, 67680, '\P{^Script=imperialaramaic}', "");
    Expect(1, 67679, '\p{Script=:\Aimperialaramaic\z:}', "");;
    Expect(0, 67680, '\p{Script=:\Aimperialaramaic\z:}', "");;
    Expect(1, 67679, '\p{Script=  Imperial_aramaic}', "");
    Expect(0, 67679, '\p{^Script=  Imperial_aramaic}', "");
    Expect(0, 67679, '\P{Script=  Imperial_aramaic}', "");
    Expect(1, 67679, '\P{^Script=  Imperial_aramaic}', "");
    Expect(0, 67680, '\p{Script=  Imperial_aramaic}', "");
    Expect(1, 67680, '\p{^Script=  Imperial_aramaic}', "");
    Expect(1, 67680, '\P{Script=  Imperial_aramaic}', "");
    Expect(0, 67680, '\P{^Script=  Imperial_aramaic}', "");
    Error('\p{Sc=	Armi:=}');
    Error('\P{Sc=	Armi:=}');
    Expect(1, 67679, '\p{Sc=:\AArmi\z:}', "");;
    Expect(0, 67680, '\p{Sc=:\AArmi\z:}', "");;
    Expect(1, 67679, '\p{Sc=armi}', "");
    Expect(0, 67679, '\p{^Sc=armi}', "");
    Expect(0, 67679, '\P{Sc=armi}', "");
    Expect(1, 67679, '\P{^Sc=armi}', "");
    Expect(0, 67680, '\p{Sc=armi}', "");
    Expect(1, 67680, '\p{^Sc=armi}', "");
    Expect(1, 67680, '\P{Sc=armi}', "");
    Expect(0, 67680, '\P{^Sc=armi}', "");
    Expect(1, 67679, '\p{Sc=:\Aarmi\z:}', "");;
    Expect(0, 67680, '\p{Sc=:\Aarmi\z:}', "");;
    Expect(1, 67679, '\p{Sc=-armi}', "");
    Expect(0, 67679, '\p{^Sc=-armi}', "");
    Expect(0, 67679, '\P{Sc=-armi}', "");
    Expect(1, 67679, '\P{^Sc=-armi}', "");
    Expect(0, 67680, '\p{Sc=-armi}', "");
    Expect(1, 67680, '\p{^Sc=-armi}', "");
    Expect(1, 67680, '\P{Sc=-armi}', "");
    Expect(0, 67680, '\P{^Sc=-armi}', "");
    Error('\p{Is_Script=_-Imperial_Aramaic:=}');
    Error('\P{Is_Script=_-Imperial_Aramaic:=}');
    Expect(1, 67679, '\p{Is_Script=imperialaramaic}', "");
    Expect(0, 67679, '\p{^Is_Script=imperialaramaic}', "");
    Expect(0, 67679, '\P{Is_Script=imperialaramaic}', "");
    Expect(1, 67679, '\P{^Is_Script=imperialaramaic}', "");
    Expect(0, 67680, '\p{Is_Script=imperialaramaic}', "");
    Expect(1, 67680, '\p{^Is_Script=imperialaramaic}', "");
    Expect(1, 67680, '\P{Is_Script=imperialaramaic}', "");
    Expect(0, 67680, '\P{^Is_Script=imperialaramaic}', "");
    Expect(1, 67679, '\p{Is_Script=IMPERIAL_ARAMAIC}', "");
    Expect(0, 67679, '\p{^Is_Script=IMPERIAL_ARAMAIC}', "");
    Expect(0, 67679, '\P{Is_Script=IMPERIAL_ARAMAIC}', "");
    Expect(1, 67679, '\P{^Is_Script=IMPERIAL_ARAMAIC}', "");
    Expect(0, 67680, '\p{Is_Script=IMPERIAL_ARAMAIC}', "");
    Expect(1, 67680, '\p{^Is_Script=IMPERIAL_ARAMAIC}', "");
    Expect(1, 67680, '\P{Is_Script=IMPERIAL_ARAMAIC}', "");
    Expect(0, 67680, '\P{^Is_Script=IMPERIAL_ARAMAIC}', "");
    Error('\p{Is_Sc=_ Armi:=}');
    Error('\P{Is_Sc=_ Armi:=}');
    Expect(1, 67679, '\p{Is_Sc:	armi}', "");
    Expect(0, 67679, '\p{^Is_Sc:	armi}', "");
    Expect(0, 67679, '\P{Is_Sc:	armi}', "");
    Expect(1, 67679, '\P{^Is_Sc:	armi}', "");
    Expect(0, 67680, '\p{Is_Sc:	armi}', "");
    Expect(1, 67680, '\p{^Is_Sc:	armi}', "");
    Expect(1, 67680, '\P{Is_Sc:	armi}', "");
    Expect(0, 67680, '\P{^Is_Sc:	armi}', "");
    Expect(1, 67679, '\p{Is_Sc=  Armi}', "");
    Expect(0, 67679, '\p{^Is_Sc=  Armi}', "");
    Expect(0, 67679, '\P{Is_Sc=  Armi}', "");
    Expect(1, 67679, '\P{^Is_Sc=  Armi}', "");
    Expect(0, 67680, '\p{Is_Sc=  Armi}', "");
    Expect(1, 67680, '\p{^Is_Sc=  Armi}', "");
    Expect(1, 67680, '\P{Is_Sc=  Armi}', "");
    Expect(0, 67680, '\P{^Is_Sc=  Armi}', "");
    Error('\p{Script=	 Armenian:=}');
    Error('\P{Script=	 Armenian:=}');
    Expect(1, 64279, '\p{Script=:\AArmenian\z:}', "");;
    Expect(0, 64280, '\p{Script=:\AArmenian\z:}', "");;
    Expect(1, 64279, '\p{Script=armenian}', "");
    Expect(0, 64279, '\p{^Script=armenian}', "");
    Expect(0, 64279, '\P{Script=armenian}', "");
    Expect(1, 64279, '\P{^Script=armenian}', "");
    Expect(0, 64280, '\p{Script=armenian}', "");
    Expect(1, 64280, '\p{^Script=armenian}', "");
    Expect(1, 64280, '\P{Script=armenian}', "");
    Expect(0, 64280, '\P{^Script=armenian}', "");
    Expect(1, 64279, '\p{Script=:\Aarmenian\z:}', "");;
    Expect(0, 64280, '\p{Script=:\Aarmenian\z:}', "");;
    Expect(1, 64279, '\p{Script=_-Armenian}', "");
    Expect(0, 64279, '\p{^Script=_-Armenian}', "");
    Expect(0, 64279, '\P{Script=_-Armenian}', "");
    Expect(1, 64279, '\P{^Script=_-Armenian}', "");
    Expect(0, 64280, '\p{Script=_-Armenian}', "");
    Expect(1, 64280, '\p{^Script=_-Armenian}', "");
    Expect(1, 64280, '\P{Script=_-Armenian}', "");
    Expect(0, 64280, '\P{^Script=_-Armenian}', "");
    Error('\p{Sc=- Armn:=}');
    Error('\P{Sc=- Armn:=}');
    Expect(1, 64279, '\p{Sc=:\AArmn\z:}', "");;
    Expect(0, 64280, '\p{Sc=:\AArmn\z:}', "");;
    Expect(1, 64279, '\p{Sc=armn}', "");
    Expect(0, 64279, '\p{^Sc=armn}', "");
    Expect(0, 64279, '\P{Sc=armn}', "");
    Expect(1, 64279, '\P{^Sc=armn}', "");
    Expect(0, 64280, '\p{Sc=armn}', "");
    Expect(1, 64280, '\p{^Sc=armn}', "");
    Expect(1, 64280, '\P{Sc=armn}', "");
    Expect(0, 64280, '\P{^Sc=armn}', "");
    Expect(1, 64279, '\p{Sc=:\Aarmn\z:}', "");;
    Expect(0, 64280, '\p{Sc=:\Aarmn\z:}', "");;
    Expect(1, 64279, '\p{Sc=_Armn}', "");
    Expect(0, 64279, '\p{^Sc=_Armn}', "");
    Expect(0, 64279, '\P{Sc=_Armn}', "");
    Expect(1, 64279, '\P{^Sc=_Armn}', "");
    Expect(0, 64280, '\p{Sc=_Armn}', "");
    Expect(1, 64280, '\p{^Sc=_Armn}', "");
    Expect(1, 64280, '\P{Sc=_Armn}', "");
    Expect(0, 64280, '\P{^Sc=_Armn}', "");
    Error('\p{Is_Script=/a/Armenian}');
    Error('\P{Is_Script=/a/Armenian}');
    Expect(1, 64279, '\p{Is_Script=armenian}', "");
    Expect(0, 64279, '\p{^Is_Script=armenian}', "");
    Expect(0, 64279, '\P{Is_Script=armenian}', "");
    Expect(1, 64279, '\P{^Is_Script=armenian}', "");
    Expect(0, 64280, '\p{Is_Script=armenian}', "");
    Expect(1, 64280, '\p{^Is_Script=armenian}', "");
    Expect(1, 64280, '\P{Is_Script=armenian}', "");
    Expect(0, 64280, '\P{^Is_Script=armenian}', "");
    Expect(1, 64279, '\p{Is_Script=__armenian}', "");
    Expect(0, 64279, '\p{^Is_Script=__armenian}', "");
    Expect(0, 64279, '\P{Is_Script=__armenian}', "");
    Expect(1, 64279, '\P{^Is_Script=__armenian}', "");
    Expect(0, 64280, '\p{Is_Script=__armenian}', "");
    Expect(1, 64280, '\p{^Is_Script=__armenian}', "");
    Expect(1, 64280, '\P{Is_Script=__armenian}', "");
    Expect(0, 64280, '\P{^Is_Script=__armenian}', "");
    Error('\p{Is_Sc=	armn/a/}');
    Error('\P{Is_Sc=	armn/a/}');
    Expect(1, 64279, '\p{Is_Sc=armn}', "");
    Expect(0, 64279, '\p{^Is_Sc=armn}', "");
    Expect(0, 64279, '\P{Is_Sc=armn}', "");
    Expect(1, 64279, '\P{^Is_Sc=armn}', "");
    Expect(0, 64280, '\p{Is_Sc=armn}', "");
    Expect(1, 64280, '\p{^Is_Sc=armn}', "");
    Expect(1, 64280, '\P{Is_Sc=armn}', "");
    Expect(0, 64280, '\P{^Is_Sc=armn}', "");
    Expect(1, 64279, '\p{Is_Sc:-_Armn}', "");
    Expect(0, 64279, '\p{^Is_Sc:-_Armn}', "");
    Expect(0, 64279, '\P{Is_Sc:-_Armn}', "");
    Expect(1, 64279, '\P{^Is_Sc:-_Armn}', "");
    Expect(0, 64280, '\p{Is_Sc:-_Armn}', "");
    Expect(1, 64280, '\p{^Is_Sc:-_Armn}', "");
    Expect(1, 64280, '\P{Is_Sc:-_Armn}', "");
    Expect(0, 64280, '\P{^Is_Sc:-_Armn}', "");
    Error('\p{Script=:=		AVESTAN}');
    Error('\P{Script=:=		AVESTAN}');
    Expect(1, 68415, '\p{Script=:\AAvestan\z:}', "");;
    Expect(0, 68416, '\p{Script=:\AAvestan\z:}', "");;
    Expect(1, 68415, '\p{Script:avestan}', "");
    Expect(0, 68415, '\p{^Script:avestan}', "");
    Expect(0, 68415, '\P{Script:avestan}', "");
    Expect(1, 68415, '\P{^Script:avestan}', "");
    Expect(0, 68416, '\p{Script:avestan}', "");
    Expect(1, 68416, '\p{^Script:avestan}', "");
    Expect(1, 68416, '\P{Script:avestan}', "");
    Expect(0, 68416, '\P{^Script:avestan}', "");
    Expect(1, 68415, '\p{Script=:\Aavestan\z:}', "");;
    Expect(0, 68416, '\p{Script=:\Aavestan\z:}', "");;
    Expect(1, 68415, '\p{Script=_Avestan}', "");
    Expect(0, 68415, '\p{^Script=_Avestan}', "");
    Expect(0, 68415, '\P{Script=_Avestan}', "");
    Expect(1, 68415, '\P{^Script=_Avestan}', "");
    Expect(0, 68416, '\p{Script=_Avestan}', "");
    Expect(1, 68416, '\p{^Script=_Avestan}', "");
    Expect(1, 68416, '\P{Script=_Avestan}', "");
    Expect(0, 68416, '\P{^Script=_Avestan}', "");
    Error('\p{Sc=:= Avst}');
    Error('\P{Sc=:= Avst}');
    Expect(1, 68415, '\p{Sc=:\AAvst\z:}', "");;
    Expect(0, 68416, '\p{Sc=:\AAvst\z:}', "");;
    Expect(1, 68415, '\p{Sc=avst}', "");
    Expect(0, 68415, '\p{^Sc=avst}', "");
    Expect(0, 68415, '\P{Sc=avst}', "");
    Expect(1, 68415, '\P{^Sc=avst}', "");
    Expect(0, 68416, '\p{Sc=avst}', "");
    Expect(1, 68416, '\p{^Sc=avst}', "");
    Expect(1, 68416, '\P{Sc=avst}', "");
    Expect(0, 68416, '\P{^Sc=avst}', "");
    Expect(1, 68415, '\p{Sc=:\Aavst\z:}', "");;
    Expect(0, 68416, '\p{Sc=:\Aavst\z:}', "");;
    Expect(1, 68415, '\p{Sc= AVST}', "");
    Expect(0, 68415, '\p{^Sc= AVST}', "");
    Expect(0, 68415, '\P{Sc= AVST}', "");
    Expect(1, 68415, '\P{^Sc= AVST}', "");
    Expect(0, 68416, '\p{Sc= AVST}', "");
    Expect(1, 68416, '\p{^Sc= AVST}', "");
    Expect(1, 68416, '\P{Sc= AVST}', "");
    Expect(0, 68416, '\P{^Sc= AVST}', "");
    Error('\p{Is_Script=-/a/Avestan}');
    Error('\P{Is_Script=-/a/Avestan}');
    Expect(1, 68415, '\p{Is_Script=avestan}', "");
    Expect(0, 68415, '\p{^Is_Script=avestan}', "");
    Expect(0, 68415, '\P{Is_Script=avestan}', "");
    Expect(1, 68415, '\P{^Is_Script=avestan}', "");
    Expect(0, 68416, '\p{Is_Script=avestan}', "");
    Expect(1, 68416, '\p{^Is_Script=avestan}', "");
    Expect(1, 68416, '\P{Is_Script=avestan}', "");
    Expect(0, 68416, '\P{^Is_Script=avestan}', "");
    Expect(1, 68415, '\p{Is_Script=	_AVESTAN}', "");
    Expect(0, 68415, '\p{^Is_Script=	_AVESTAN}', "");
    Expect(0, 68415, '\P{Is_Script=	_AVESTAN}', "");
    Expect(1, 68415, '\P{^Is_Script=	_AVESTAN}', "");
    Expect(0, 68416, '\p{Is_Script=	_AVESTAN}', "");
    Expect(1, 68416, '\p{^Is_Script=	_AVESTAN}', "");
    Expect(1, 68416, '\P{Is_Script=	_AVESTAN}', "");
    Expect(0, 68416, '\P{^Is_Script=	_AVESTAN}', "");
    Error('\p{Is_Sc=:=-_AVST}');
    Error('\P{Is_Sc=:=-_AVST}');
    Expect(1, 68415, '\p{Is_Sc=avst}', "");
    Expect(0, 68415, '\p{^Is_Sc=avst}', "");
    Expect(0, 68415, '\P{Is_Sc=avst}', "");
    Expect(1, 68415, '\P{^Is_Sc=avst}', "");
    Expect(0, 68416, '\p{Is_Sc=avst}', "");
    Expect(1, 68416, '\p{^Is_Sc=avst}', "");
    Expect(1, 68416, '\P{Is_Sc=avst}', "");
    Expect(0, 68416, '\P{^Is_Sc=avst}', "");
    Expect(1, 68415, '\p{Is_Sc=		Avst}', "");
    Expect(0, 68415, '\p{^Is_Sc=		Avst}', "");
    Expect(0, 68415, '\P{Is_Sc=		Avst}', "");
    Expect(1, 68415, '\P{^Is_Sc=		Avst}', "");
    Expect(0, 68416, '\p{Is_Sc=		Avst}', "");
    Expect(1, 68416, '\p{^Is_Sc=		Avst}', "");
    Expect(1, 68416, '\P{Is_Sc=		Avst}', "");
    Expect(0, 68416, '\P{^Is_Sc=		Avst}', "");
    Error('\p{Script::= Balinese}');
    Error('\P{Script::= Balinese}');
    Expect(1, 7038, '\p{Script=:\ABalinese\z:}', "");;
    Expect(0, 7039, '\p{Script=:\ABalinese\z:}', "");;
    Expect(1, 7038, '\p{Script=balinese}', "");
    Expect(0, 7038, '\p{^Script=balinese}', "");
    Expect(0, 7038, '\P{Script=balinese}', "");
    Expect(1, 7038, '\P{^Script=balinese}', "");
    Expect(0, 7039, '\p{Script=balinese}', "");
    Expect(1, 7039, '\p{^Script=balinese}', "");
    Expect(1, 7039, '\P{Script=balinese}', "");
    Expect(0, 7039, '\P{^Script=balinese}', "");
    Expect(1, 7038, '\p{Script=:\Abalinese\z:}', "");;
    Expect(0, 7039, '\p{Script=:\Abalinese\z:}', "");;
    Expect(1, 7038, '\p{Script=	 BALINESE}', "");
    Expect(0, 7038, '\p{^Script=	 BALINESE}', "");
    Expect(0, 7038, '\P{Script=	 BALINESE}', "");
    Expect(1, 7038, '\P{^Script=	 BALINESE}', "");
    Expect(0, 7039, '\p{Script=	 BALINESE}', "");
    Expect(1, 7039, '\p{^Script=	 BALINESE}', "");
    Expect(1, 7039, '\P{Script=	 BALINESE}', "");
    Expect(0, 7039, '\P{^Script=	 BALINESE}', "");
    Error('\p{Sc=_/a/bali}');
    Error('\P{Sc=_/a/bali}');
    Expect(1, 7038, '\p{Sc=:\ABali\z:}', "");;
    Expect(0, 7039, '\p{Sc=:\ABali\z:}', "");;
    Expect(1, 7038, '\p{Sc=bali}', "");
    Expect(0, 7038, '\p{^Sc=bali}', "");
    Expect(0, 7038, '\P{Sc=bali}', "");
    Expect(1, 7038, '\P{^Sc=bali}', "");
    Expect(0, 7039, '\p{Sc=bali}', "");
    Expect(1, 7039, '\p{^Sc=bali}', "");
    Expect(1, 7039, '\P{Sc=bali}', "");
    Expect(0, 7039, '\P{^Sc=bali}', "");
    Expect(1, 7038, '\p{Sc=:\Abali\z:}', "");;
    Expect(0, 7039, '\p{Sc=:\Abali\z:}', "");;
    Expect(1, 7038, '\p{Sc=	bali}', "");
    Expect(0, 7038, '\p{^Sc=	bali}', "");
    Expect(0, 7038, '\P{Sc=	bali}', "");
    Expect(1, 7038, '\P{^Sc=	bali}', "");
    Expect(0, 7039, '\p{Sc=	bali}', "");
    Expect(1, 7039, '\p{^Sc=	bali}', "");
    Expect(1, 7039, '\P{Sc=	bali}', "");
    Expect(0, 7039, '\P{^Sc=	bali}', "");
    Error('\p{Is_Script=_/a/balinese}');
    Error('\P{Is_Script=_/a/balinese}');
    Expect(1, 7038, '\p{Is_Script=balinese}', "");
    Expect(0, 7038, '\p{^Is_Script=balinese}', "");
    Expect(0, 7038, '\P{Is_Script=balinese}', "");
    Expect(1, 7038, '\P{^Is_Script=balinese}', "");
    Expect(0, 7039, '\p{Is_Script=balinese}', "");
    Expect(1, 7039, '\p{^Is_Script=balinese}', "");
    Expect(1, 7039, '\P{Is_Script=balinese}', "");
    Expect(0, 7039, '\P{^Is_Script=balinese}', "");
    Expect(1, 7038, '\p{Is_Script=-_balinese}', "");
    Expect(0, 7038, '\p{^Is_Script=-_balinese}', "");
    Expect(0, 7038, '\P{Is_Script=-_balinese}', "");
    Expect(1, 7038, '\P{^Is_Script=-_balinese}', "");
    Expect(0, 7039, '\p{Is_Script=-_balinese}', "");
    Expect(1, 7039, '\p{^Is_Script=-_balinese}', "");
    Expect(1, 7039, '\P{Is_Script=-_balinese}', "");
    Expect(0, 7039, '\P{^Is_Script=-_balinese}', "");
    Error('\p{Is_Sc=/a/	 bali}');
    Error('\P{Is_Sc=/a/	 bali}');
    Expect(1, 7038, '\p{Is_Sc=bali}', "");
    Expect(0, 7038, '\p{^Is_Sc=bali}', "");
    Expect(0, 7038, '\P{Is_Sc=bali}', "");
    Expect(1, 7038, '\P{^Is_Sc=bali}', "");
    Expect(0, 7039, '\p{Is_Sc=bali}', "");
    Expect(1, 7039, '\p{^Is_Sc=bali}', "");
    Expect(1, 7039, '\P{Is_Sc=bali}', "");
    Expect(0, 7039, '\P{^Is_Sc=bali}', "");
    Expect(1, 7038, '\p{Is_Sc=Bali}', "");
    Expect(0, 7038, '\p{^Is_Sc=Bali}', "");
    Expect(0, 7038, '\P{Is_Sc=Bali}', "");
    Expect(1, 7038, '\P{^Is_Sc=Bali}', "");
    Expect(0, 7039, '\p{Is_Sc=Bali}', "");
    Expect(1, 7039, '\p{^Is_Sc=Bali}', "");
    Expect(1, 7039, '\P{Is_Sc=Bali}', "");
    Expect(0, 7039, '\P{^Is_Sc=Bali}', "");
    Error('\p{Script= -Bamum/a/}');
    Error('\P{Script= -Bamum/a/}');
    Expect(1, 92728, '\p{Script=:\ABamum\z:}', "");;
    Expect(0, 92729, '\p{Script=:\ABamum\z:}', "");;
    Expect(1, 92728, '\p{Script:   bamum}', "");
    Expect(0, 92728, '\p{^Script:   bamum}', "");
    Expect(0, 92728, '\P{Script:   bamum}', "");
    Expect(1, 92728, '\P{^Script:   bamum}', "");
    Expect(0, 92729, '\p{Script:   bamum}', "");
    Expect(1, 92729, '\p{^Script:   bamum}', "");
    Expect(1, 92729, '\P{Script:   bamum}', "");
    Expect(0, 92729, '\P{^Script:   bamum}', "");
    Expect(1, 92728, '\p{Script=:\Abamum\z:}', "");;
    Expect(0, 92729, '\p{Script=:\Abamum\z:}', "");;
    Expect(1, 92728, '\p{Script=	Bamum}', "");
    Expect(0, 92728, '\p{^Script=	Bamum}', "");
    Expect(0, 92728, '\P{Script=	Bamum}', "");
    Expect(1, 92728, '\P{^Script=	Bamum}', "");
    Expect(0, 92729, '\p{Script=	Bamum}', "");
    Expect(1, 92729, '\p{^Script=	Bamum}', "");
    Expect(1, 92729, '\P{Script=	Bamum}', "");
    Expect(0, 92729, '\P{^Script=	Bamum}', "");
    Error('\p{Sc:	_-bamu:=}');
    Error('\P{Sc:	_-bamu:=}');
    Expect(1, 92728, '\p{Sc=:\ABamu\z:}', "");;
    Expect(0, 92729, '\p{Sc=:\ABamu\z:}', "");;
    Expect(1, 92728, '\p{Sc=bamu}', "");
    Expect(0, 92728, '\p{^Sc=bamu}', "");
    Expect(0, 92728, '\P{Sc=bamu}', "");
    Expect(1, 92728, '\P{^Sc=bamu}', "");
    Expect(0, 92729, '\p{Sc=bamu}', "");
    Expect(1, 92729, '\p{^Sc=bamu}', "");
    Expect(1, 92729, '\P{Sc=bamu}', "");
    Expect(0, 92729, '\P{^Sc=bamu}', "");
    Expect(1, 92728, '\p{Sc=:\Abamu\z:}', "");;
    Expect(0, 92729, '\p{Sc=:\Abamu\z:}', "");;
    Expect(1, 92728, '\p{Sc=_bamu}', "");
    Expect(0, 92728, '\p{^Sc=_bamu}', "");
    Expect(0, 92728, '\P{Sc=_bamu}', "");
    Expect(1, 92728, '\P{^Sc=_bamu}', "");
    Expect(0, 92729, '\p{Sc=_bamu}', "");
    Expect(1, 92729, '\p{^Sc=_bamu}', "");
    Expect(1, 92729, '\P{Sc=_bamu}', "");
    Expect(0, 92729, '\P{^Sc=_bamu}', "");
    Error('\p{Is_Script=	BAMUM:=}');
    Error('\P{Is_Script=	BAMUM:=}');
    Expect(1, 92728, '\p{Is_Script=bamum}', "");
    Expect(0, 92728, '\p{^Is_Script=bamum}', "");
    Expect(0, 92728, '\P{Is_Script=bamum}', "");
    Expect(1, 92728, '\P{^Is_Script=bamum}', "");
    Expect(0, 92729, '\p{Is_Script=bamum}', "");
    Expect(1, 92729, '\p{^Is_Script=bamum}', "");
    Expect(1, 92729, '\P{Is_Script=bamum}', "");
    Expect(0, 92729, '\P{^Is_Script=bamum}', "");
    Expect(1, 92728, '\p{Is_Script=-	Bamum}', "");
    Expect(0, 92728, '\p{^Is_Script=-	Bamum}', "");
    Expect(0, 92728, '\P{Is_Script=-	Bamum}', "");
    Expect(1, 92728, '\P{^Is_Script=-	Bamum}', "");
    Expect(0, 92729, '\p{Is_Script=-	Bamum}', "");
    Expect(1, 92729, '\p{^Is_Script=-	Bamum}', "");
    Expect(1, 92729, '\P{Is_Script=-	Bamum}', "");
    Expect(0, 92729, '\P{^Is_Script=-	Bamum}', "");
    Error('\p{Is_Sc=-bamu/a/}');
    Error('\P{Is_Sc=-bamu/a/}');
    Expect(1, 92728, '\p{Is_Sc=bamu}', "");
    Expect(0, 92728, '\p{^Is_Sc=bamu}', "");
    Expect(0, 92728, '\P{Is_Sc=bamu}', "");
    Expect(1, 92728, '\P{^Is_Sc=bamu}', "");
    Expect(0, 92729, '\p{Is_Sc=bamu}', "");
    Expect(1, 92729, '\p{^Is_Sc=bamu}', "");
    Expect(1, 92729, '\P{Is_Sc=bamu}', "");
    Expect(0, 92729, '\P{^Is_Sc=bamu}', "");
    Expect(1, 92728, '\p{Is_Sc=_-Bamu}', "");
    Expect(0, 92728, '\p{^Is_Sc=_-Bamu}', "");
    Expect(0, 92728, '\P{Is_Sc=_-Bamu}', "");
    Expect(1, 92728, '\P{^Is_Sc=_-Bamu}', "");
    Expect(0, 92729, '\p{Is_Sc=_-Bamu}', "");
    Expect(1, 92729, '\p{^Is_Sc=_-Bamu}', "");
    Expect(1, 92729, '\P{Is_Sc=_-Bamu}', "");
    Expect(0, 92729, '\P{^Is_Sc=_-Bamu}', "");
    Error('\p{Script= /a/Bassa_VAH}');
    Error('\P{Script= /a/Bassa_VAH}');
    Expect(1, 92917, '\p{Script=:\ABassa_Vah\z:}', "");;
    Expect(0, 92918, '\p{Script=:\ABassa_Vah\z:}', "");;
    Expect(1, 92917, '\p{Script: bassavah}', "");
    Expect(0, 92917, '\p{^Script: bassavah}', "");
    Expect(0, 92917, '\P{Script: bassavah}', "");
    Expect(1, 92917, '\P{^Script: bassavah}', "");
    Expect(0, 92918, '\p{Script: bassavah}', "");
    Expect(1, 92918, '\p{^Script: bassavah}', "");
    Expect(1, 92918, '\P{Script: bassavah}', "");
    Expect(0, 92918, '\P{^Script: bassavah}', "");
    Expect(1, 92917, '\p{Script=:\Abassavah\z:}', "");;
    Expect(0, 92918, '\p{Script=:\Abassavah\z:}', "");;
    Expect(1, 92917, '\p{Script=	-BASSA_VAH}', "");
    Expect(0, 92917, '\p{^Script=	-BASSA_VAH}', "");
    Expect(0, 92917, '\P{Script=	-BASSA_VAH}', "");
    Expect(1, 92917, '\P{^Script=	-BASSA_VAH}', "");
    Expect(0, 92918, '\p{Script=	-BASSA_VAH}', "");
    Expect(1, 92918, '\p{^Script=	-BASSA_VAH}', "");
    Expect(1, 92918, '\P{Script=	-BASSA_VAH}', "");
    Expect(0, 92918, '\P{^Script=	-BASSA_VAH}', "");
    Error('\p{Sc=	:=Bass}');
    Error('\P{Sc=	:=Bass}');
    Expect(1, 92917, '\p{Sc=:\ABass\z:}', "");;
    Expect(0, 92918, '\p{Sc=:\ABass\z:}', "");;
    Expect(1, 92917, '\p{Sc=bass}', "");
    Expect(0, 92917, '\p{^Sc=bass}', "");
    Expect(0, 92917, '\P{Sc=bass}', "");
    Expect(1, 92917, '\P{^Sc=bass}', "");
    Expect(0, 92918, '\p{Sc=bass}', "");
    Expect(1, 92918, '\p{^Sc=bass}', "");
    Expect(1, 92918, '\P{Sc=bass}', "");
    Expect(0, 92918, '\P{^Sc=bass}', "");
    Expect(1, 92917, '\p{Sc=:\Abass\z:}', "");;
    Expect(0, 92918, '\p{Sc=:\Abass\z:}', "");;
    Expect(1, 92917, '\p{Sc=_bass}', "");
    Expect(0, 92917, '\p{^Sc=_bass}', "");
    Expect(0, 92917, '\P{Sc=_bass}', "");
    Expect(1, 92917, '\P{^Sc=_bass}', "");
    Expect(0, 92918, '\p{Sc=_bass}', "");
    Expect(1, 92918, '\p{^Sc=_bass}', "");
    Expect(1, 92918, '\P{Sc=_bass}', "");
    Expect(0, 92918, '\P{^Sc=_bass}', "");
    Error('\p{Is_Script=:=__Bassa_Vah}');
    Error('\P{Is_Script=:=__Bassa_Vah}');
    Expect(1, 92917, '\p{Is_Script=bassavah}', "");
    Expect(0, 92917, '\p{^Is_Script=bassavah}', "");
    Expect(0, 92917, '\P{Is_Script=bassavah}', "");
    Expect(1, 92917, '\P{^Is_Script=bassavah}', "");
    Expect(0, 92918, '\p{Is_Script=bassavah}', "");
    Expect(1, 92918, '\p{^Is_Script=bassavah}', "");
    Expect(1, 92918, '\P{Is_Script=bassavah}', "");
    Expect(0, 92918, '\P{^Is_Script=bassavah}', "");
    Expect(1, 92917, '\p{Is_Script=_Bassa_VAH}', "");
    Expect(0, 92917, '\p{^Is_Script=_Bassa_VAH}', "");
    Expect(0, 92917, '\P{Is_Script=_Bassa_VAH}', "");
    Expect(1, 92917, '\P{^Is_Script=_Bassa_VAH}', "");
    Expect(0, 92918, '\p{Is_Script=_Bassa_VAH}', "");
    Expect(1, 92918, '\p{^Is_Script=_Bassa_VAH}', "");
    Expect(1, 92918, '\P{Is_Script=_Bassa_VAH}', "");
    Expect(0, 92918, '\P{^Is_Script=_Bassa_VAH}', "");
    Error('\p{Is_Sc=	bass/a/}');
    Error('\P{Is_Sc=	bass/a/}');
    Expect(1, 92917, '\p{Is_Sc=bass}', "");
    Expect(0, 92917, '\p{^Is_Sc=bass}', "");
    Expect(0, 92917, '\P{Is_Sc=bass}', "");
    Expect(1, 92917, '\P{^Is_Sc=bass}', "");
    Expect(0, 92918, '\p{Is_Sc=bass}', "");
    Expect(1, 92918, '\p{^Is_Sc=bass}', "");
    Expect(1, 92918, '\P{Is_Sc=bass}', "");
    Expect(0, 92918, '\P{^Is_Sc=bass}', "");
    Expect(1, 92917, '\p{Is_Sc=Bass}', "");
    Expect(0, 92917, '\p{^Is_Sc=Bass}', "");
    Expect(0, 92917, '\P{Is_Sc=Bass}', "");
    Expect(1, 92917, '\P{^Is_Sc=Bass}', "");
    Expect(0, 92918, '\p{Is_Sc=Bass}', "");
    Expect(1, 92918, '\p{^Is_Sc=Bass}', "");
    Expect(1, 92918, '\P{Is_Sc=Bass}', "");
    Expect(0, 92918, '\P{^Is_Sc=Bass}', "");
    Error('\p{Script=-:=batak}');
    Error('\P{Script=-:=batak}');
    Expect(1, 7167, '\p{Script=:\ABatak\z:}', "");;
    Expect(0, 7168, '\p{Script=:\ABatak\z:}', "");;
    Expect(1, 7167, '\p{Script=batak}', "");
    Expect(0, 7167, '\p{^Script=batak}', "");
    Expect(0, 7167, '\P{Script=batak}', "");
    Expect(1, 7167, '\P{^Script=batak}', "");
    Expect(0, 7168, '\p{Script=batak}', "");
    Expect(1, 7168, '\p{^Script=batak}', "");
    Expect(1, 7168, '\P{Script=batak}', "");
    Expect(0, 7168, '\P{^Script=batak}', "");
    Expect(1, 7167, '\p{Script=:\Abatak\z:}', "");;
    Expect(0, 7168, '\p{Script=:\Abatak\z:}', "");;
    Expect(1, 7167, '\p{Script=__Batak}', "");
    Expect(0, 7167, '\p{^Script=__Batak}', "");
    Expect(0, 7167, '\P{Script=__Batak}', "");
    Expect(1, 7167, '\P{^Script=__Batak}', "");
    Expect(0, 7168, '\p{Script=__Batak}', "");
    Expect(1, 7168, '\p{^Script=__Batak}', "");
    Expect(1, 7168, '\P{Script=__Batak}', "");
    Expect(0, 7168, '\P{^Script=__Batak}', "");
    Error('\p{Sc=-batk:=}');
    Error('\P{Sc=-batk:=}');
    Expect(1, 7167, '\p{Sc=:\ABatk\z:}', "");;
    Expect(0, 7168, '\p{Sc=:\ABatk\z:}', "");;
    Expect(1, 7167, '\p{Sc:batk}', "");
    Expect(0, 7167, '\p{^Sc:batk}', "");
    Expect(0, 7167, '\P{Sc:batk}', "");
    Expect(1, 7167, '\P{^Sc:batk}', "");
    Expect(0, 7168, '\p{Sc:batk}', "");
    Expect(1, 7168, '\p{^Sc:batk}', "");
    Expect(1, 7168, '\P{Sc:batk}', "");
    Expect(0, 7168, '\P{^Sc:batk}', "");
    Expect(1, 7167, '\p{Sc=:\Abatk\z:}', "");;
    Expect(0, 7168, '\p{Sc=:\Abatk\z:}', "");;
    Expect(1, 7167, '\p{Sc=	 Batk}', "");
    Expect(0, 7167, '\p{^Sc=	 Batk}', "");
    Expect(0, 7167, '\P{Sc=	 Batk}', "");
    Expect(1, 7167, '\P{^Sc=	 Batk}', "");
    Expect(0, 7168, '\p{Sc=	 Batk}', "");
    Expect(1, 7168, '\p{^Sc=	 Batk}', "");
    Expect(1, 7168, '\P{Sc=	 Batk}', "");
    Expect(0, 7168, '\P{^Sc=	 Batk}', "");
    Error('\p{Is_Script=:= -batak}');
    Error('\P{Is_Script=:= -batak}');
    Expect(1, 7167, '\p{Is_Script=batak}', "");
    Expect(0, 7167, '\p{^Is_Script=batak}', "");
    Expect(0, 7167, '\P{Is_Script=batak}', "");
    Expect(1, 7167, '\P{^Is_Script=batak}', "");
    Expect(0, 7168, '\p{Is_Script=batak}', "");
    Expect(1, 7168, '\p{^Is_Script=batak}', "");
    Expect(1, 7168, '\P{Is_Script=batak}', "");
    Expect(0, 7168, '\P{^Is_Script=batak}', "");
    Expect(1, 7167, '\p{Is_Script=	 BATAK}', "");
    Expect(0, 7167, '\p{^Is_Script=	 BATAK}', "");
    Expect(0, 7167, '\P{Is_Script=	 BATAK}', "");
    Expect(1, 7167, '\P{^Is_Script=	 BATAK}', "");
    Expect(0, 7168, '\p{Is_Script=	 BATAK}', "");
    Expect(1, 7168, '\p{^Is_Script=	 BATAK}', "");
    Expect(1, 7168, '\P{Is_Script=	 BATAK}', "");
    Expect(0, 7168, '\P{^Is_Script=	 BATAK}', "");
    Error('\p{Is_Sc: 	Batk/a/}');
    Error('\P{Is_Sc: 	Batk/a/}');
    Expect(1, 7167, '\p{Is_Sc=batk}', "");
    Expect(0, 7167, '\p{^Is_Sc=batk}', "");
    Expect(0, 7167, '\P{Is_Sc=batk}', "");
    Expect(1, 7167, '\P{^Is_Sc=batk}', "");
    Expect(0, 7168, '\p{Is_Sc=batk}', "");
    Expect(1, 7168, '\p{^Is_Sc=batk}', "");
    Expect(1, 7168, '\P{Is_Sc=batk}', "");
    Expect(0, 7168, '\P{^Is_Sc=batk}', "");
    Expect(1, 7167, '\p{Is_Sc=--Batk}', "");
    Expect(0, 7167, '\p{^Is_Sc=--Batk}', "");
    Expect(0, 7167, '\P{Is_Sc=--Batk}', "");
    Expect(1, 7167, '\P{^Is_Sc=--Batk}', "");
    Expect(0, 7168, '\p{Is_Sc=--Batk}', "");
    Expect(1, 7168, '\p{^Is_Sc=--Batk}', "");
    Expect(1, 7168, '\P{Is_Sc=--Batk}', "");
    Expect(0, 7168, '\P{^Is_Sc=--Batk}', "");
    Error('\p{Script=_bengali:=}');
    Error('\P{Script=_bengali:=}');
    Expect(1, 2558, '\p{Script=:\ABengali\z:}', "");;
    Expect(0, 2559, '\p{Script=:\ABengali\z:}', "");;
    Expect(1, 2558, '\p{Script=bengali}', "");
    Expect(0, 2558, '\p{^Script=bengali}', "");
    Expect(0, 2558, '\P{Script=bengali}', "");
    Expect(1, 2558, '\P{^Script=bengali}', "");
    Expect(0, 2559, '\p{Script=bengali}', "");
    Expect(1, 2559, '\p{^Script=bengali}', "");
    Expect(1, 2559, '\P{Script=bengali}', "");
    Expect(0, 2559, '\P{^Script=bengali}', "");
    Expect(1, 2558, '\p{Script=:\Abengali\z:}', "");;
    Expect(0, 2559, '\p{Script=:\Abengali\z:}', "");;
    Expect(1, 2558, '\p{Script=__bengali}', "");
    Expect(0, 2558, '\p{^Script=__bengali}', "");
    Expect(0, 2558, '\P{Script=__bengali}', "");
    Expect(1, 2558, '\P{^Script=__bengali}', "");
    Expect(0, 2559, '\p{Script=__bengali}', "");
    Expect(1, 2559, '\p{^Script=__bengali}', "");
    Expect(1, 2559, '\P{Script=__bengali}', "");
    Expect(0, 2559, '\P{^Script=__bengali}', "");
    Error('\p{Sc= /a/Beng}');
    Error('\P{Sc= /a/Beng}');
    Expect(1, 2558, '\p{Sc=:\ABeng\z:}', "");;
    Expect(0, 2559, '\p{Sc=:\ABeng\z:}', "");;
    Expect(1, 2558, '\p{Sc=beng}', "");
    Expect(0, 2558, '\p{^Sc=beng}', "");
    Expect(0, 2558, '\P{Sc=beng}', "");
    Expect(1, 2558, '\P{^Sc=beng}', "");
    Expect(0, 2559, '\p{Sc=beng}', "");
    Expect(1, 2559, '\p{^Sc=beng}', "");
    Expect(1, 2559, '\P{Sc=beng}', "");
    Expect(0, 2559, '\P{^Sc=beng}', "");
    Expect(1, 2558, '\p{Sc=:\Abeng\z:}', "");;
    Expect(0, 2559, '\p{Sc=:\Abeng\z:}', "");;
    Expect(1, 2558, '\p{Sc=	-beng}', "");
    Expect(0, 2558, '\p{^Sc=	-beng}', "");
    Expect(0, 2558, '\P{Sc=	-beng}', "");
    Expect(1, 2558, '\P{^Sc=	-beng}', "");
    Expect(0, 2559, '\p{Sc=	-beng}', "");
    Expect(1, 2559, '\p{^Sc=	-beng}', "");
    Expect(1, 2559, '\P{Sc=	-beng}', "");
    Expect(0, 2559, '\P{^Sc=	-beng}', "");
    Error('\p{Is_Script= _Bengali:=}');
    Error('\P{Is_Script= _Bengali:=}');
    Expect(1, 2558, '\p{Is_Script=bengali}', "");
    Expect(0, 2558, '\p{^Is_Script=bengali}', "");
    Expect(0, 2558, '\P{Is_Script=bengali}', "");
    Expect(1, 2558, '\P{^Is_Script=bengali}', "");
    Expect(0, 2559, '\p{Is_Script=bengali}', "");
    Expect(1, 2559, '\p{^Is_Script=bengali}', "");
    Expect(1, 2559, '\P{Is_Script=bengali}', "");
    Expect(0, 2559, '\P{^Is_Script=bengali}', "");
    Expect(1, 2558, '\p{Is_Script=	_Bengali}', "");
    Expect(0, 2558, '\p{^Is_Script=	_Bengali}', "");
    Expect(0, 2558, '\P{Is_Script=	_Bengali}', "");
    Expect(1, 2558, '\P{^Is_Script=	_Bengali}', "");
    Expect(0, 2559, '\p{Is_Script=	_Bengali}', "");
    Expect(1, 2559, '\p{^Is_Script=	_Bengali}', "");
    Expect(1, 2559, '\P{Is_Script=	_Bengali}', "");
    Expect(0, 2559, '\P{^Is_Script=	_Bengali}', "");
    Error('\p{Is_Sc=-/a/beng}');
    Error('\P{Is_Sc=-/a/beng}');
    Expect(1, 2558, '\p{Is_Sc=beng}', "");
    Expect(0, 2558, '\p{^Is_Sc=beng}', "");
    Expect(0, 2558, '\P{Is_Sc=beng}', "");
    Expect(1, 2558, '\P{^Is_Sc=beng}', "");
    Expect(0, 2559, '\p{Is_Sc=beng}', "");
    Expect(1, 2559, '\p{^Is_Sc=beng}', "");
    Expect(1, 2559, '\P{Is_Sc=beng}', "");
    Expect(0, 2559, '\P{^Is_Sc=beng}', "");
    Expect(1, 2558, '\p{Is_Sc=- BENG}', "");
    Expect(0, 2558, '\p{^Is_Sc=- BENG}', "");
    Expect(0, 2558, '\P{Is_Sc=- BENG}', "");
    Expect(1, 2558, '\P{^Is_Sc=- BENG}', "");
    Expect(0, 2559, '\p{Is_Sc=- BENG}', "");
    Expect(1, 2559, '\p{^Is_Sc=- BENG}', "");
    Expect(1, 2559, '\P{Is_Sc=- BENG}', "");
    Expect(0, 2559, '\P{^Is_Sc=- BENG}', "");
    Error('\p{Script=-_BHAIKSUKI:=}');
    Error('\P{Script=-_BHAIKSUKI:=}');
    Expect(1, 72812, '\p{Script=:\ABhaiksuki\z:}', "");;
    Expect(0, 72813, '\p{Script=:\ABhaiksuki\z:}', "");;
    Expect(1, 72812, '\p{Script:   bhaiksuki}', "");
    Expect(0, 72812, '\p{^Script:   bhaiksuki}', "");
    Expect(0, 72812, '\P{Script:   bhaiksuki}', "");
    Expect(1, 72812, '\P{^Script:   bhaiksuki}', "");
    Expect(0, 72813, '\p{Script:   bhaiksuki}', "");
    Expect(1, 72813, '\p{^Script:   bhaiksuki}', "");
    Expect(1, 72813, '\P{Script:   bhaiksuki}', "");
    Expect(0, 72813, '\P{^Script:   bhaiksuki}', "");
    Expect(1, 72812, '\p{Script=:\Abhaiksuki\z:}', "");;
    Expect(0, 72813, '\p{Script=:\Abhaiksuki\z:}', "");;
    Expect(1, 72812, '\p{Script=--bhaiksuki}', "");
    Expect(0, 72812, '\p{^Script=--bhaiksuki}', "");
    Expect(0, 72812, '\P{Script=--bhaiksuki}', "");
    Expect(1, 72812, '\P{^Script=--bhaiksuki}', "");
    Expect(0, 72813, '\p{Script=--bhaiksuki}', "");
    Expect(1, 72813, '\p{^Script=--bhaiksuki}', "");
    Expect(1, 72813, '\P{Script=--bhaiksuki}', "");
    Expect(0, 72813, '\P{^Script=--bhaiksuki}', "");
    Error('\p{Sc=-:=Bhks}');
    Error('\P{Sc=-:=Bhks}');
    Expect(1, 72812, '\p{Sc=:\ABhks\z:}', "");;
    Expect(0, 72813, '\p{Sc=:\ABhks\z:}', "");;
    Expect(1, 72812, '\p{Sc=bhks}', "");
    Expect(0, 72812, '\p{^Sc=bhks}', "");
    Expect(0, 72812, '\P{Sc=bhks}', "");
    Expect(1, 72812, '\P{^Sc=bhks}', "");
    Expect(0, 72813, '\p{Sc=bhks}', "");
    Expect(1, 72813, '\p{^Sc=bhks}', "");
    Expect(1, 72813, '\P{Sc=bhks}', "");
    Expect(0, 72813, '\P{^Sc=bhks}', "");
    Expect(1, 72812, '\p{Sc=:\Abhks\z:}', "");;
    Expect(0, 72813, '\p{Sc=:\Abhks\z:}', "");;
    Expect(1, 72812, '\p{Sc=--BHKS}', "");
    Expect(0, 72812, '\p{^Sc=--BHKS}', "");
    Expect(0, 72812, '\P{Sc=--BHKS}', "");
    Expect(1, 72812, '\P{^Sc=--BHKS}', "");
    Expect(0, 72813, '\p{Sc=--BHKS}', "");
    Expect(1, 72813, '\p{^Sc=--BHKS}', "");
    Expect(1, 72813, '\P{Sc=--BHKS}', "");
    Expect(0, 72813, '\P{^Sc=--BHKS}', "");
    Error('\p{Is_Script=_/a/Bhaiksuki}');
    Error('\P{Is_Script=_/a/Bhaiksuki}');
    Expect(1, 72812, '\p{Is_Script=bhaiksuki}', "");
    Expect(0, 72812, '\p{^Is_Script=bhaiksuki}', "");
    Expect(0, 72812, '\P{Is_Script=bhaiksuki}', "");
    Expect(1, 72812, '\P{^Is_Script=bhaiksuki}', "");
    Expect(0, 72813, '\p{Is_Script=bhaiksuki}', "");
    Expect(1, 72813, '\p{^Is_Script=bhaiksuki}', "");
    Expect(1, 72813, '\P{Is_Script=bhaiksuki}', "");
    Expect(0, 72813, '\P{^Is_Script=bhaiksuki}', "");
    Expect(1, 72812, '\p{Is_Script=- Bhaiksuki}', "");
    Expect(0, 72812, '\p{^Is_Script=- Bhaiksuki}', "");
    Expect(0, 72812, '\P{Is_Script=- Bhaiksuki}', "");
    Expect(1, 72812, '\P{^Is_Script=- Bhaiksuki}', "");
    Expect(0, 72813, '\p{Is_Script=- Bhaiksuki}', "");
    Expect(1, 72813, '\p{^Is_Script=- Bhaiksuki}', "");
    Expect(1, 72813, '\P{Is_Script=- Bhaiksuki}', "");
    Expect(0, 72813, '\P{^Is_Script=- Bhaiksuki}', "");
    Error('\p{Is_Sc=/a/	BHKS}');
    Error('\P{Is_Sc=/a/	BHKS}');
    Expect(1, 72812, '\p{Is_Sc=bhks}', "");
    Expect(0, 72812, '\p{^Is_Sc=bhks}', "");
    Expect(0, 72812, '\P{Is_Sc=bhks}', "");
    Expect(1, 72812, '\P{^Is_Sc=bhks}', "");
    Expect(0, 72813, '\p{Is_Sc=bhks}', "");
    Expect(1, 72813, '\p{^Is_Sc=bhks}', "");
    Expect(1, 72813, '\P{Is_Sc=bhks}', "");
    Expect(0, 72813, '\P{^Is_Sc=bhks}', "");
    Expect(1, 72812, '\p{Is_Sc:- bhks}', "");
    Expect(0, 72812, '\p{^Is_Sc:- bhks}', "");
    Expect(0, 72812, '\P{Is_Sc:- bhks}', "");
    Expect(1, 72812, '\P{^Is_Sc:- bhks}', "");
    Expect(0, 72813, '\p{Is_Sc:- bhks}', "");
    Expect(1, 72813, '\p{^Is_Sc:- bhks}', "");
    Expect(1, 72813, '\P{Is_Sc:- bhks}', "");
    Expect(0, 72813, '\P{^Is_Sc:- bhks}', "");
    Error('\p{Script=		Bopomofo/a/}');
    Error('\P{Script=		Bopomofo/a/}');
    Expect(1, 12735, '\p{Script=:\ABopomofo\z:}', "");;
    Expect(0, 12736, '\p{Script=:\ABopomofo\z:}', "");;
    Expect(1, 12735, '\p{Script=bopomofo}', "");
    Expect(0, 12735, '\p{^Script=bopomofo}', "");
    Expect(0, 12735, '\P{Script=bopomofo}', "");
    Expect(1, 12735, '\P{^Script=bopomofo}', "");
    Expect(0, 12736, '\p{Script=bopomofo}', "");
    Expect(1, 12736, '\p{^Script=bopomofo}', "");
    Expect(1, 12736, '\P{Script=bopomofo}', "");
    Expect(0, 12736, '\P{^Script=bopomofo}', "");
    Expect(1, 12735, '\p{Script=:\Abopomofo\z:}', "");;
    Expect(0, 12736, '\p{Script=:\Abopomofo\z:}', "");;
    Expect(1, 12735, '\p{Script=	 BOPOMOFO}', "");
    Expect(0, 12735, '\p{^Script=	 BOPOMOFO}', "");
    Expect(0, 12735, '\P{Script=	 BOPOMOFO}', "");
    Expect(1, 12735, '\P{^Script=	 BOPOMOFO}', "");
    Expect(0, 12736, '\p{Script=	 BOPOMOFO}', "");
    Expect(1, 12736, '\p{^Script=	 BOPOMOFO}', "");
    Expect(1, 12736, '\P{Script=	 BOPOMOFO}', "");
    Expect(0, 12736, '\P{^Script=	 BOPOMOFO}', "");
    Error('\p{Sc=  bopo/a/}');
    Error('\P{Sc=  bopo/a/}');
    Expect(1, 12735, '\p{Sc=:\ABopo\z:}', "");;
    Expect(0, 12736, '\p{Sc=:\ABopo\z:}', "");;
    Expect(1, 12735, '\p{Sc=bopo}', "");
    Expect(0, 12735, '\p{^Sc=bopo}', "");
    Expect(0, 12735, '\P{Sc=bopo}', "");
    Expect(1, 12735, '\P{^Sc=bopo}', "");
    Expect(0, 12736, '\p{Sc=bopo}', "");
    Expect(1, 12736, '\p{^Sc=bopo}', "");
    Expect(1, 12736, '\P{Sc=bopo}', "");
    Expect(0, 12736, '\P{^Sc=bopo}', "");
    Expect(1, 12735, '\p{Sc=:\Abopo\z:}', "");;
    Expect(0, 12736, '\p{Sc=:\Abopo\z:}', "");;
    Expect(1, 12735, '\p{Sc=- BOPO}', "");
    Expect(0, 12735, '\p{^Sc=- BOPO}', "");
    Expect(0, 12735, '\P{Sc=- BOPO}', "");
    Expect(1, 12735, '\P{^Sc=- BOPO}', "");
    Expect(0, 12736, '\p{Sc=- BOPO}', "");
    Expect(1, 12736, '\p{^Sc=- BOPO}', "");
    Expect(1, 12736, '\P{Sc=- BOPO}', "");
    Expect(0, 12736, '\P{^Sc=- BOPO}', "");
    Error('\p{Is_Script=	/a/Bopomofo}');
    Error('\P{Is_Script=	/a/Bopomofo}');
    Expect(1, 12735, '\p{Is_Script=bopomofo}', "");
    Expect(0, 12735, '\p{^Is_Script=bopomofo}', "");
    Expect(0, 12735, '\P{Is_Script=bopomofo}', "");
    Expect(1, 12735, '\P{^Is_Script=bopomofo}', "");
    Expect(0, 12736, '\p{Is_Script=bopomofo}', "");
    Expect(1, 12736, '\p{^Is_Script=bopomofo}', "");
    Expect(1, 12736, '\P{Is_Script=bopomofo}', "");
    Expect(0, 12736, '\P{^Is_Script=bopomofo}', "");
    Expect(1, 12735, '\p{Is_Script=-_BOPOMOFO}', "");
    Expect(0, 12735, '\p{^Is_Script=-_BOPOMOFO}', "");
    Expect(0, 12735, '\P{Is_Script=-_BOPOMOFO}', "");
    Expect(1, 12735, '\P{^Is_Script=-_BOPOMOFO}', "");
    Expect(0, 12736, '\p{Is_Script=-_BOPOMOFO}', "");
    Expect(1, 12736, '\p{^Is_Script=-_BOPOMOFO}', "");
    Expect(1, 12736, '\P{Is_Script=-_BOPOMOFO}', "");
    Expect(0, 12736, '\P{^Is_Script=-_BOPOMOFO}', "");
    Error('\p{Is_Sc=	/a/BOPO}');
    Error('\P{Is_Sc=	/a/BOPO}');
    Expect(1, 12735, '\p{Is_Sc=bopo}', "");
    Expect(0, 12735, '\p{^Is_Sc=bopo}', "");
    Expect(0, 12735, '\P{Is_Sc=bopo}', "");
    Expect(1, 12735, '\P{^Is_Sc=bopo}', "");
    Expect(0, 12736, '\p{Is_Sc=bopo}', "");
    Expect(1, 12736, '\p{^Is_Sc=bopo}', "");
    Expect(1, 12736, '\P{Is_Sc=bopo}', "");
    Expect(0, 12736, '\P{^Is_Sc=bopo}', "");
    Expect(1, 12735, '\p{Is_Sc=- bopo}', "");
    Expect(0, 12735, '\p{^Is_Sc=- bopo}', "");
    Expect(0, 12735, '\P{Is_Sc=- bopo}', "");
    Expect(1, 12735, '\P{^Is_Sc=- bopo}', "");
    Expect(0, 12736, '\p{Is_Sc=- bopo}', "");
    Expect(1, 12736, '\p{^Is_Sc=- bopo}', "");
    Expect(1, 12736, '\P{Is_Sc=- bopo}', "");
    Expect(0, 12736, '\P{^Is_Sc=- bopo}', "");
    Error('\p{Script: 	BRAHMI/a/}');
    Error('\P{Script: 	BRAHMI/a/}');
    Expect(1, 69759, '\p{Script=:\ABrahmi\z:}', "");;
    Expect(0, 69760, '\p{Script=:\ABrahmi\z:}', "");;
    Expect(1, 69759, '\p{Script=brahmi}', "");
    Expect(0, 69759, '\p{^Script=brahmi}', "");
    Expect(0, 69759, '\P{Script=brahmi}', "");
    Expect(1, 69759, '\P{^Script=brahmi}', "");
    Expect(0, 69760, '\p{Script=brahmi}', "");
    Expect(1, 69760, '\p{^Script=brahmi}', "");
    Expect(1, 69760, '\P{Script=brahmi}', "");
    Expect(0, 69760, '\P{^Script=brahmi}', "");
    Expect(1, 69759, '\p{Script=:\Abrahmi\z:}', "");;
    Expect(0, 69760, '\p{Script=:\Abrahmi\z:}', "");;
    Expect(1, 69759, '\p{Script= 	BRAHMI}', "");
    Expect(0, 69759, '\p{^Script= 	BRAHMI}', "");
    Expect(0, 69759, '\P{Script= 	BRAHMI}', "");
    Expect(1, 69759, '\P{^Script= 	BRAHMI}', "");
    Expect(0, 69760, '\p{Script= 	BRAHMI}', "");
    Expect(1, 69760, '\p{^Script= 	BRAHMI}', "");
    Expect(1, 69760, '\P{Script= 	BRAHMI}', "");
    Expect(0, 69760, '\P{^Script= 	BRAHMI}', "");
    Error('\p{Sc=_Brah/a/}');
    Error('\P{Sc=_Brah/a/}');
    Expect(1, 69759, '\p{Sc=:\ABrah\z:}', "");;
    Expect(0, 69760, '\p{Sc=:\ABrah\z:}', "");;
    Expect(1, 69759, '\p{Sc=brah}', "");
    Expect(0, 69759, '\p{^Sc=brah}', "");
    Expect(0, 69759, '\P{Sc=brah}', "");
    Expect(1, 69759, '\P{^Sc=brah}', "");
    Expect(0, 69760, '\p{Sc=brah}', "");
    Expect(1, 69760, '\p{^Sc=brah}', "");
    Expect(1, 69760, '\P{Sc=brah}', "");
    Expect(0, 69760, '\P{^Sc=brah}', "");
    Expect(1, 69759, '\p{Sc=:\Abrah\z:}', "");;
    Expect(0, 69760, '\p{Sc=:\Abrah\z:}', "");;
    Expect(1, 69759, '\p{Sc=-Brah}', "");
    Expect(0, 69759, '\p{^Sc=-Brah}', "");
    Expect(0, 69759, '\P{Sc=-Brah}', "");
    Expect(1, 69759, '\P{^Sc=-Brah}', "");
    Expect(0, 69760, '\p{Sc=-Brah}', "");
    Expect(1, 69760, '\p{^Sc=-Brah}', "");
    Expect(1, 69760, '\P{Sc=-Brah}', "");
    Expect(0, 69760, '\P{^Sc=-Brah}', "");
    Error('\p{Is_Script=	/a/BRAHMI}');
    Error('\P{Is_Script=	/a/BRAHMI}');
    Expect(1, 69759, '\p{Is_Script=brahmi}', "");
    Expect(0, 69759, '\p{^Is_Script=brahmi}', "");
    Expect(0, 69759, '\P{Is_Script=brahmi}', "");
    Expect(1, 69759, '\P{^Is_Script=brahmi}', "");
    Expect(0, 69760, '\p{Is_Script=brahmi}', "");
    Expect(1, 69760, '\p{^Is_Script=brahmi}', "");
    Expect(1, 69760, '\P{Is_Script=brahmi}', "");
    Expect(0, 69760, '\P{^Is_Script=brahmi}', "");
    Expect(1, 69759, '\p{Is_Script=	-BRAHMI}', "");
    Expect(0, 69759, '\p{^Is_Script=	-BRAHMI}', "");
    Expect(0, 69759, '\P{Is_Script=	-BRAHMI}', "");
    Expect(1, 69759, '\P{^Is_Script=	-BRAHMI}', "");
    Expect(0, 69760, '\p{Is_Script=	-BRAHMI}', "");
    Expect(1, 69760, '\p{^Is_Script=	-BRAHMI}', "");
    Expect(1, 69760, '\P{Is_Script=	-BRAHMI}', "");
    Expect(0, 69760, '\P{^Is_Script=	-BRAHMI}', "");
    Error('\p{Is_Sc=	 BRAH:=}');
    Error('\P{Is_Sc=	 BRAH:=}');
    Expect(1, 69759, '\p{Is_Sc=brah}', "");
    Expect(0, 69759, '\p{^Is_Sc=brah}', "");
    Expect(0, 69759, '\P{Is_Sc=brah}', "");
    Expect(1, 69759, '\P{^Is_Sc=brah}', "");
    Expect(0, 69760, '\p{Is_Sc=brah}', "");
    Expect(1, 69760, '\p{^Is_Sc=brah}', "");
    Expect(1, 69760, '\P{Is_Sc=brah}', "");
    Expect(0, 69760, '\P{^Is_Sc=brah}', "");
    Expect(1, 69759, '\p{Is_Sc=		Brah}', "");
    Expect(0, 69759, '\p{^Is_Sc=		Brah}', "");
    Expect(0, 69759, '\P{Is_Sc=		Brah}', "");
    Expect(1, 69759, '\P{^Is_Sc=		Brah}', "");
    Expect(0, 69760, '\p{Is_Sc=		Brah}', "");
    Expect(1, 69760, '\p{^Is_Sc=		Brah}', "");
    Expect(1, 69760, '\P{Is_Sc=		Brah}', "");
    Expect(0, 69760, '\P{^Is_Sc=		Brah}', "");
    Error('\p{Script=:=BRAILLE}');
    Error('\P{Script=:=BRAILLE}');
    Expect(1, 10495, '\p{Script=:\ABraille\z:}', "");;
    Expect(0, 10496, '\p{Script=:\ABraille\z:}', "");;
    Expect(1, 10495, '\p{Script=braille}', "");
    Expect(0, 10495, '\p{^Script=braille}', "");
    Expect(0, 10495, '\P{Script=braille}', "");
    Expect(1, 10495, '\P{^Script=braille}', "");
    Expect(0, 10496, '\p{Script=braille}', "");
    Expect(1, 10496, '\p{^Script=braille}', "");
    Expect(1, 10496, '\P{Script=braille}', "");
    Expect(0, 10496, '\P{^Script=braille}', "");
    Expect(1, 10495, '\p{Script=:\Abraille\z:}', "");;
    Expect(0, 10496, '\p{Script=:\Abraille\z:}', "");;
    Expect(1, 10495, '\p{Script=	 BRAILLE}', "");
    Expect(0, 10495, '\p{^Script=	 BRAILLE}', "");
    Expect(0, 10495, '\P{Script=	 BRAILLE}', "");
    Expect(1, 10495, '\P{^Script=	 BRAILLE}', "");
    Expect(0, 10496, '\p{Script=	 BRAILLE}', "");
    Expect(1, 10496, '\p{^Script=	 BRAILLE}', "");
    Expect(1, 10496, '\P{Script=	 BRAILLE}', "");
    Expect(0, 10496, '\P{^Script=	 BRAILLE}', "");
    Error('\p{Sc=:= -Brai}');
    Error('\P{Sc=:= -Brai}');
    Expect(1, 10495, '\p{Sc=:\ABrai\z:}', "");;
    Expect(0, 10496, '\p{Sc=:\ABrai\z:}', "");;
    Expect(1, 10495, '\p{Sc=brai}', "");
    Expect(0, 10495, '\p{^Sc=brai}', "");
    Expect(0, 10495, '\P{Sc=brai}', "");
    Expect(1, 10495, '\P{^Sc=brai}', "");
    Expect(0, 10496, '\p{Sc=brai}', "");
    Expect(1, 10496, '\p{^Sc=brai}', "");
    Expect(1, 10496, '\P{Sc=brai}', "");
    Expect(0, 10496, '\P{^Sc=brai}', "");
    Expect(1, 10495, '\p{Sc=:\Abrai\z:}', "");;
    Expect(0, 10496, '\p{Sc=:\Abrai\z:}', "");;
    Expect(1, 10495, '\p{Sc=	Brai}', "");
    Expect(0, 10495, '\p{^Sc=	Brai}', "");
    Expect(0, 10495, '\P{Sc=	Brai}', "");
    Expect(1, 10495, '\P{^Sc=	Brai}', "");
    Expect(0, 10496, '\p{Sc=	Brai}', "");
    Expect(1, 10496, '\p{^Sc=	Brai}', "");
    Expect(1, 10496, '\P{Sc=	Brai}', "");
    Expect(0, 10496, '\P{^Sc=	Brai}', "");
    Error('\p{Is_Script=	/a/braille}');
    Error('\P{Is_Script=	/a/braille}');
    Expect(1, 10495, '\p{Is_Script=braille}', "");
    Expect(0, 10495, '\p{^Is_Script=braille}', "");
    Expect(0, 10495, '\P{Is_Script=braille}', "");
    Expect(1, 10495, '\P{^Is_Script=braille}', "");
    Expect(0, 10496, '\p{Is_Script=braille}', "");
    Expect(1, 10496, '\p{^Is_Script=braille}', "");
    Expect(1, 10496, '\P{Is_Script=braille}', "");
    Expect(0, 10496, '\P{^Is_Script=braille}', "");
    Expect(1, 10495, '\p{Is_Script= _Braille}', "");
    Expect(0, 10495, '\p{^Is_Script= _Braille}', "");
    Expect(0, 10495, '\P{Is_Script= _Braille}', "");
    Expect(1, 10495, '\P{^Is_Script= _Braille}', "");
    Expect(0, 10496, '\p{Is_Script= _Braille}', "");
    Expect(1, 10496, '\p{^Is_Script= _Braille}', "");
    Expect(1, 10496, '\P{Is_Script= _Braille}', "");
    Expect(0, 10496, '\P{^Is_Script= _Braille}', "");
    Error('\p{Is_Sc=_/a/Brai}');
    Error('\P{Is_Sc=_/a/Brai}');
    Expect(1, 10495, '\p{Is_Sc=brai}', "");
    Expect(0, 10495, '\p{^Is_Sc=brai}', "");
    Expect(0, 10495, '\P{Is_Sc=brai}', "");
    Expect(1, 10495, '\P{^Is_Sc=brai}', "");
    Expect(0, 10496, '\p{Is_Sc=brai}', "");
    Expect(1, 10496, '\p{^Is_Sc=brai}', "");
    Expect(1, 10496, '\P{Is_Sc=brai}', "");
    Expect(0, 10496, '\P{^Is_Sc=brai}', "");
    Expect(1, 10495, '\p{Is_Sc=-brai}', "");
    Expect(0, 10495, '\p{^Is_Sc=-brai}', "");
    Expect(0, 10495, '\P{Is_Sc=-brai}', "");
    Expect(1, 10495, '\P{^Is_Sc=-brai}', "");
    Expect(0, 10496, '\p{Is_Sc=-brai}', "");
    Expect(1, 10496, '\p{^Is_Sc=-brai}', "");
    Expect(1, 10496, '\P{Is_Sc=-brai}', "");
    Expect(0, 10496, '\P{^Is_Sc=-brai}', "");
    Error('\p{Script= Buginese/a/}');
    Error('\P{Script= Buginese/a/}');
    Expect(1, 6687, '\p{Script=:\ABuginese\z:}', "");;
    Expect(0, 6688, '\p{Script=:\ABuginese\z:}', "");;
    Expect(1, 6687, '\p{Script=buginese}', "");
    Expect(0, 6687, '\p{^Script=buginese}', "");
    Expect(0, 6687, '\P{Script=buginese}', "");
    Expect(1, 6687, '\P{^Script=buginese}', "");
    Expect(0, 6688, '\p{Script=buginese}', "");
    Expect(1, 6688, '\p{^Script=buginese}', "");
    Expect(1, 6688, '\P{Script=buginese}', "");
    Expect(0, 6688, '\P{^Script=buginese}', "");
    Expect(1, 6687, '\p{Script=:\Abuginese\z:}', "");;
    Expect(0, 6688, '\p{Script=:\Abuginese\z:}', "");;
    Expect(1, 6687, '\p{Script=_Buginese}', "");
    Expect(0, 6687, '\p{^Script=_Buginese}', "");
    Expect(0, 6687, '\P{Script=_Buginese}', "");
    Expect(1, 6687, '\P{^Script=_Buginese}', "");
    Expect(0, 6688, '\p{Script=_Buginese}', "");
    Expect(1, 6688, '\p{^Script=_Buginese}', "");
    Expect(1, 6688, '\P{Script=_Buginese}', "");
    Expect(0, 6688, '\P{^Script=_Buginese}', "");
    Error('\p{Sc::=- bugi}');
    Error('\P{Sc::=- bugi}');
    Expect(1, 6687, '\p{Sc=:\ABugi\z:}', "");;
    Expect(0, 6688, '\p{Sc=:\ABugi\z:}', "");;
    Expect(1, 6687, '\p{Sc=bugi}', "");
    Expect(0, 6687, '\p{^Sc=bugi}', "");
    Expect(0, 6687, '\P{Sc=bugi}', "");
    Expect(1, 6687, '\P{^Sc=bugi}', "");
    Expect(0, 6688, '\p{Sc=bugi}', "");
    Expect(1, 6688, '\p{^Sc=bugi}', "");
    Expect(1, 6688, '\P{Sc=bugi}', "");
    Expect(0, 6688, '\P{^Sc=bugi}', "");
    Expect(1, 6687, '\p{Sc=:\Abugi\z:}', "");;
    Expect(0, 6688, '\p{Sc=:\Abugi\z:}', "");;
    Expect(1, 6687, '\p{Sc=	_Bugi}', "");
    Expect(0, 6687, '\p{^Sc=	_Bugi}', "");
    Expect(0, 6687, '\P{Sc=	_Bugi}', "");
    Expect(1, 6687, '\P{^Sc=	_Bugi}', "");
    Expect(0, 6688, '\p{Sc=	_Bugi}', "");
    Expect(1, 6688, '\p{^Sc=	_Bugi}', "");
    Expect(1, 6688, '\P{Sc=	_Bugi}', "");
    Expect(0, 6688, '\P{^Sc=	_Bugi}', "");
    Error('\p{Is_Script=--BUGINESE:=}');
    Error('\P{Is_Script=--BUGINESE:=}');
    Expect(1, 6687, '\p{Is_Script: buginese}', "");
    Expect(0, 6687, '\p{^Is_Script: buginese}', "");
    Expect(0, 6687, '\P{Is_Script: buginese}', "");
    Expect(1, 6687, '\P{^Is_Script: buginese}', "");
    Expect(0, 6688, '\p{Is_Script: buginese}', "");
    Expect(1, 6688, '\p{^Is_Script: buginese}', "");
    Expect(1, 6688, '\P{Is_Script: buginese}', "");
    Expect(0, 6688, '\P{^Is_Script: buginese}', "");
    Expect(1, 6687, '\p{Is_Script= 	Buginese}', "");
    Expect(0, 6687, '\p{^Is_Script= 	Buginese}', "");
    Expect(0, 6687, '\P{Is_Script= 	Buginese}', "");
    Expect(1, 6687, '\P{^Is_Script= 	Buginese}', "");
    Expect(0, 6688, '\p{Is_Script= 	Buginese}', "");
    Expect(1, 6688, '\p{^Is_Script= 	Buginese}', "");
    Expect(1, 6688, '\P{Is_Script= 	Buginese}', "");
    Expect(0, 6688, '\P{^Is_Script= 	Buginese}', "");
    Error('\p{Is_Sc= /a/Bugi}');
    Error('\P{Is_Sc= /a/Bugi}');
    Expect(1, 6687, '\p{Is_Sc=bugi}', "");
    Expect(0, 6687, '\p{^Is_Sc=bugi}', "");
    Expect(0, 6687, '\P{Is_Sc=bugi}', "");
    Expect(1, 6687, '\P{^Is_Sc=bugi}', "");
    Expect(0, 6688, '\p{Is_Sc=bugi}', "");
    Expect(1, 6688, '\p{^Is_Sc=bugi}', "");
    Expect(1, 6688, '\P{Is_Sc=bugi}', "");
    Expect(0, 6688, '\P{^Is_Sc=bugi}', "");
    Expect(1, 6687, '\p{Is_Sc=__Bugi}', "");
    Expect(0, 6687, '\p{^Is_Sc=__Bugi}', "");
    Expect(0, 6687, '\P{Is_Sc=__Bugi}', "");
    Expect(1, 6687, '\P{^Is_Sc=__Bugi}', "");
    Expect(0, 6688, '\p{Is_Sc=__Bugi}', "");
    Expect(1, 6688, '\p{^Is_Sc=__Bugi}', "");
    Expect(1, 6688, '\P{Is_Sc=__Bugi}', "");
    Expect(0, 6688, '\P{^Is_Sc=__Bugi}', "");
    Error('\p{Script= -BUHID:=}');
    Error('\P{Script= -BUHID:=}');
    Expect(1, 5971, '\p{Script=:\ABuhid\z:}', "");;
    Expect(0, 5972, '\p{Script=:\ABuhid\z:}', "");;
    Expect(1, 5971, '\p{Script=buhid}', "");
    Expect(0, 5971, '\p{^Script=buhid}', "");
    Expect(0, 5971, '\P{Script=buhid}', "");
    Expect(1, 5971, '\P{^Script=buhid}', "");
    Expect(0, 5972, '\p{Script=buhid}', "");
    Expect(1, 5972, '\p{^Script=buhid}', "");
    Expect(1, 5972, '\P{Script=buhid}', "");
    Expect(0, 5972, '\P{^Script=buhid}', "");
    Expect(1, 5971, '\p{Script=:\Abuhid\z:}', "");;
    Expect(0, 5972, '\p{Script=:\Abuhid\z:}', "");;
    Expect(1, 5971, '\p{Script=	Buhid}', "");
    Expect(0, 5971, '\p{^Script=	Buhid}', "");
    Expect(0, 5971, '\P{Script=	Buhid}', "");
    Expect(1, 5971, '\P{^Script=	Buhid}', "");
    Expect(0, 5972, '\p{Script=	Buhid}', "");
    Expect(1, 5972, '\p{^Script=	Buhid}', "");
    Expect(1, 5972, '\P{Script=	Buhid}', "");
    Expect(0, 5972, '\P{^Script=	Buhid}', "");
    Error('\p{Sc=-/a/Buhd}');
    Error('\P{Sc=-/a/Buhd}');
    Expect(1, 5971, '\p{Sc=:\ABuhd\z:}', "");;
    Expect(0, 5972, '\p{Sc=:\ABuhd\z:}', "");;
    Expect(1, 5971, '\p{Sc=buhd}', "");
    Expect(0, 5971, '\p{^Sc=buhd}', "");
    Expect(0, 5971, '\P{Sc=buhd}', "");
    Expect(1, 5971, '\P{^Sc=buhd}', "");
    Expect(0, 5972, '\p{Sc=buhd}', "");
    Expect(1, 5972, '\p{^Sc=buhd}', "");
    Expect(1, 5972, '\P{Sc=buhd}', "");
    Expect(0, 5972, '\P{^Sc=buhd}', "");
    Expect(1, 5971, '\p{Sc=:\Abuhd\z:}', "");;
    Expect(0, 5972, '\p{Sc=:\Abuhd\z:}', "");;
    Expect(1, 5971, '\p{Sc:-Buhd}', "");
    Expect(0, 5971, '\p{^Sc:-Buhd}', "");
    Expect(0, 5971, '\P{Sc:-Buhd}', "");
    Expect(1, 5971, '\P{^Sc:-Buhd}', "");
    Expect(0, 5972, '\p{Sc:-Buhd}', "");
    Expect(1, 5972, '\p{^Sc:-Buhd}', "");
    Expect(1, 5972, '\P{Sc:-Buhd}', "");
    Expect(0, 5972, '\P{^Sc:-Buhd}', "");
    Error('\p{Is_Script=/a/_-Buhid}');
    Error('\P{Is_Script=/a/_-Buhid}');
    Expect(1, 5971, '\p{Is_Script=buhid}', "");
    Expect(0, 5971, '\p{^Is_Script=buhid}', "");
    Expect(0, 5971, '\P{Is_Script=buhid}', "");
    Expect(1, 5971, '\P{^Is_Script=buhid}', "");
    Expect(0, 5972, '\p{Is_Script=buhid}', "");
    Expect(1, 5972, '\p{^Is_Script=buhid}', "");
    Expect(1, 5972, '\P{Is_Script=buhid}', "");
    Expect(0, 5972, '\P{^Is_Script=buhid}', "");
    Expect(1, 5971, '\p{Is_Script=-	buhid}', "");
    Expect(0, 5971, '\p{^Is_Script=-	buhid}', "");
    Expect(0, 5971, '\P{Is_Script=-	buhid}', "");
    Expect(1, 5971, '\P{^Is_Script=-	buhid}', "");
    Expect(0, 5972, '\p{Is_Script=-	buhid}', "");
    Expect(1, 5972, '\p{^Is_Script=-	buhid}', "");
    Expect(1, 5972, '\P{Is_Script=-	buhid}', "");
    Expect(0, 5972, '\P{^Is_Script=-	buhid}', "");
    Error('\p{Is_Sc=_/a/buhd}');
    Error('\P{Is_Sc=_/a/buhd}');
    Expect(1, 5971, '\p{Is_Sc=buhd}', "");
    Expect(0, 5971, '\p{^Is_Sc=buhd}', "");
    Expect(0, 5971, '\P{Is_Sc=buhd}', "");
    Expect(1, 5971, '\P{^Is_Sc=buhd}', "");
    Expect(0, 5972, '\p{Is_Sc=buhd}', "");
    Expect(1, 5972, '\p{^Is_Sc=buhd}', "");
    Expect(1, 5972, '\P{Is_Sc=buhd}', "");
    Expect(0, 5972, '\P{^Is_Sc=buhd}', "");
    Expect(1, 5971, '\p{Is_Sc=Buhd}', "");
    Expect(0, 5971, '\p{^Is_Sc=Buhd}', "");
    Expect(0, 5971, '\P{Is_Sc=Buhd}', "");
    Expect(1, 5971, '\P{^Is_Sc=Buhd}', "");
    Expect(0, 5972, '\p{Is_Sc=Buhd}', "");
    Expect(1, 5972, '\p{^Is_Sc=Buhd}', "");
    Expect(1, 5972, '\P{Is_Sc=Buhd}', "");
    Expect(0, 5972, '\P{^Is_Sc=Buhd}', "");
    Error('\p{Script=:=	CHAKMA}');
    Error('\P{Script=:=	CHAKMA}');
    Expect(1, 69959, '\p{Script=:\AChakma\z:}', "");;
    Expect(0, 69960, '\p{Script=:\AChakma\z:}', "");;
    Expect(1, 69959, '\p{Script=chakma}', "");
    Expect(0, 69959, '\p{^Script=chakma}', "");
    Expect(0, 69959, '\P{Script=chakma}', "");
    Expect(1, 69959, '\P{^Script=chakma}', "");
    Expect(0, 69960, '\p{Script=chakma}', "");
    Expect(1, 69960, '\p{^Script=chakma}', "");
    Expect(1, 69960, '\P{Script=chakma}', "");
    Expect(0, 69960, '\P{^Script=chakma}', "");
    Expect(1, 69959, '\p{Script=:\Achakma\z:}', "");;
    Expect(0, 69960, '\p{Script=:\Achakma\z:}', "");;
    Expect(1, 69959, '\p{Script=	_Chakma}', "");
    Expect(0, 69959, '\p{^Script=	_Chakma}', "");
    Expect(0, 69959, '\P{Script=	_Chakma}', "");
    Expect(1, 69959, '\P{^Script=	_Chakma}', "");
    Expect(0, 69960, '\p{Script=	_Chakma}', "");
    Expect(1, 69960, '\p{^Script=	_Chakma}', "");
    Expect(1, 69960, '\P{Script=	_Chakma}', "");
    Expect(0, 69960, '\P{^Script=	_Chakma}', "");
    Error('\p{Sc=_Cakm:=}');
    Error('\P{Sc=_Cakm:=}');
    Expect(1, 69959, '\p{Sc=:\ACakm\z:}', "");;
    Expect(0, 69960, '\p{Sc=:\ACakm\z:}', "");;
    Expect(1, 69959, '\p{Sc=cakm}', "");
    Expect(0, 69959, '\p{^Sc=cakm}', "");
    Expect(0, 69959, '\P{Sc=cakm}', "");
    Expect(1, 69959, '\P{^Sc=cakm}', "");
    Expect(0, 69960, '\p{Sc=cakm}', "");
    Expect(1, 69960, '\p{^Sc=cakm}', "");
    Expect(1, 69960, '\P{Sc=cakm}', "");
    Expect(0, 69960, '\P{^Sc=cakm}', "");
    Expect(1, 69959, '\p{Sc=:\Acakm\z:}', "");;
    Expect(0, 69960, '\p{Sc=:\Acakm\z:}', "");;
    Expect(1, 69959, '\p{Sc=		cakm}', "");
    Expect(0, 69959, '\p{^Sc=		cakm}', "");
    Expect(0, 69959, '\P{Sc=		cakm}', "");
    Expect(1, 69959, '\P{^Sc=		cakm}', "");
    Expect(0, 69960, '\p{Sc=		cakm}', "");
    Expect(1, 69960, '\p{^Sc=		cakm}', "");
    Expect(1, 69960, '\P{Sc=		cakm}', "");
    Expect(0, 69960, '\P{^Sc=		cakm}', "");
    Error('\p{Is_Script=:= CHAKMA}');
    Error('\P{Is_Script=:= CHAKMA}');
    Expect(1, 69959, '\p{Is_Script=chakma}', "");
    Expect(0, 69959, '\p{^Is_Script=chakma}', "");
    Expect(0, 69959, '\P{Is_Script=chakma}', "");
    Expect(1, 69959, '\P{^Is_Script=chakma}', "");
    Expect(0, 69960, '\p{Is_Script=chakma}', "");
    Expect(1, 69960, '\p{^Is_Script=chakma}', "");
    Expect(1, 69960, '\P{Is_Script=chakma}', "");
    Expect(0, 69960, '\P{^Is_Script=chakma}', "");
    Expect(1, 69959, '\p{Is_Script=_ Chakma}', "");
    Expect(0, 69959, '\p{^Is_Script=_ Chakma}', "");
    Expect(0, 69959, '\P{Is_Script=_ Chakma}', "");
    Expect(1, 69959, '\P{^Is_Script=_ Chakma}', "");
    Expect(0, 69960, '\p{Is_Script=_ Chakma}', "");
    Expect(1, 69960, '\p{^Is_Script=_ Chakma}', "");
    Expect(1, 69960, '\P{Is_Script=_ Chakma}', "");
    Expect(0, 69960, '\P{^Is_Script=_ Chakma}', "");
    Error('\p{Is_Sc=/a/		Cakm}');
    Error('\P{Is_Sc=/a/		Cakm}');
    Expect(1, 69959, '\p{Is_Sc=cakm}', "");
    Expect(0, 69959, '\p{^Is_Sc=cakm}', "");
    Expect(0, 69959, '\P{Is_Sc=cakm}', "");
    Expect(1, 69959, '\P{^Is_Sc=cakm}', "");
    Expect(0, 69960, '\p{Is_Sc=cakm}', "");
    Expect(1, 69960, '\p{^Is_Sc=cakm}', "");
    Expect(1, 69960, '\P{Is_Sc=cakm}', "");
    Expect(0, 69960, '\P{^Is_Sc=cakm}', "");
    Expect(1, 69959, '\p{Is_Sc:	 	CAKM}', "");
    Expect(0, 69959, '\p{^Is_Sc:	 	CAKM}', "");
    Expect(0, 69959, '\P{Is_Sc:	 	CAKM}', "");
    Expect(1, 69959, '\P{^Is_Sc:	 	CAKM}', "");
    Expect(0, 69960, '\p{Is_Sc:	 	CAKM}', "");
    Expect(1, 69960, '\p{^Is_Sc:	 	CAKM}', "");
    Expect(1, 69960, '\P{Is_Sc:	 	CAKM}', "");
    Expect(0, 69960, '\P{^Is_Sc:	 	CAKM}', "");
    Error('\p{Script= /a/canadian_ABORIGINAL}');
    Error('\P{Script= /a/canadian_ABORIGINAL}');
    Expect(1, 72383, '\p{Script=:\ACanadian_Aboriginal\z:}', "");;
    Expect(0, 72384, '\p{Script=:\ACanadian_Aboriginal\z:}', "");;
    Expect(1, 72383, '\p{Script=canadianaboriginal}', "");
    Expect(0, 72383, '\p{^Script=canadianaboriginal}', "");
    Expect(0, 72383, '\P{Script=canadianaboriginal}', "");
    Expect(1, 72383, '\P{^Script=canadianaboriginal}', "");
    Expect(0, 72384, '\p{Script=canadianaboriginal}', "");
    Expect(1, 72384, '\p{^Script=canadianaboriginal}', "");
    Expect(1, 72384, '\P{Script=canadianaboriginal}', "");
    Expect(0, 72384, '\P{^Script=canadianaboriginal}', "");
    Expect(1, 72383, '\p{Script=:\Acanadianaboriginal\z:}', "");;
    Expect(0, 72384, '\p{Script=:\Acanadianaboriginal\z:}', "");;
    Expect(1, 72383, '\p{Script:	-Canadian_Aboriginal}', "");
    Expect(0, 72383, '\p{^Script:	-Canadian_Aboriginal}', "");
    Expect(0, 72383, '\P{Script:	-Canadian_Aboriginal}', "");
    Expect(1, 72383, '\P{^Script:	-Canadian_Aboriginal}', "");
    Expect(0, 72384, '\p{Script:	-Canadian_Aboriginal}', "");
    Expect(1, 72384, '\p{^Script:	-Canadian_Aboriginal}', "");
    Expect(1, 72384, '\P{Script:	-Canadian_Aboriginal}', "");
    Expect(0, 72384, '\P{^Script:	-Canadian_Aboriginal}', "");
    Error('\p{Sc=	CANS:=}');
    Error('\P{Sc=	CANS:=}');
    Expect(1, 72383, '\p{Sc=:\ACans\z:}', "");;
    Expect(0, 72384, '\p{Sc=:\ACans\z:}', "");;
    Expect(1, 72383, '\p{Sc=cans}', "");
    Expect(0, 72383, '\p{^Sc=cans}', "");
    Expect(0, 72383, '\P{Sc=cans}', "");
    Expect(1, 72383, '\P{^Sc=cans}', "");
    Expect(0, 72384, '\p{Sc=cans}', "");
    Expect(1, 72384, '\p{^Sc=cans}', "");
    Expect(1, 72384, '\P{Sc=cans}', "");
    Expect(0, 72384, '\P{^Sc=cans}', "");
    Expect(1, 72383, '\p{Sc=:\Acans\z:}', "");;
    Expect(0, 72384, '\p{Sc=:\Acans\z:}', "");;
    Expect(1, 72383, '\p{Sc= cans}', "");
    Expect(0, 72383, '\p{^Sc= cans}', "");
    Expect(0, 72383, '\P{Sc= cans}', "");
    Expect(1, 72383, '\P{^Sc= cans}', "");
    Expect(0, 72384, '\p{Sc= cans}', "");
    Expect(1, 72384, '\p{^Sc= cans}', "");
    Expect(1, 72384, '\P{Sc= cans}', "");
    Expect(0, 72384, '\P{^Sc= cans}', "");
    Error('\p{Is_Script=_:=Canadian_Aboriginal}');
    Error('\P{Is_Script=_:=Canadian_Aboriginal}');
    Expect(1, 72383, '\p{Is_Script=canadianaboriginal}', "");
    Expect(0, 72383, '\p{^Is_Script=canadianaboriginal}', "");
    Expect(0, 72383, '\P{Is_Script=canadianaboriginal}', "");
    Expect(1, 72383, '\P{^Is_Script=canadianaboriginal}', "");
    Expect(0, 72384, '\p{Is_Script=canadianaboriginal}', "");
    Expect(1, 72384, '\p{^Is_Script=canadianaboriginal}', "");
    Expect(1, 72384, '\P{Is_Script=canadianaboriginal}', "");
    Expect(0, 72384, '\P{^Is_Script=canadianaboriginal}', "");
    Expect(1, 72383, '\p{Is_Script=-_CANADIAN_aboriginal}', "");
    Expect(0, 72383, '\p{^Is_Script=-_CANADIAN_aboriginal}', "");
    Expect(0, 72383, '\P{Is_Script=-_CANADIAN_aboriginal}', "");
    Expect(1, 72383, '\P{^Is_Script=-_CANADIAN_aboriginal}', "");
    Expect(0, 72384, '\p{Is_Script=-_CANADIAN_aboriginal}', "");
    Expect(1, 72384, '\p{^Is_Script=-_CANADIAN_aboriginal}', "");
    Expect(1, 72384, '\P{Is_Script=-_CANADIAN_aboriginal}', "");
    Expect(0, 72384, '\P{^Is_Script=-_CANADIAN_aboriginal}', "");
    Error('\p{Is_Sc=_:=cans}');
    Error('\P{Is_Sc=_:=cans}');
    Expect(1, 72383, '\p{Is_Sc=cans}', "");
    Expect(0, 72383, '\p{^Is_Sc=cans}', "");
    Expect(0, 72383, '\P{Is_Sc=cans}', "");
    Expect(1, 72383, '\P{^Is_Sc=cans}', "");
    Expect(0, 72384, '\p{Is_Sc=cans}', "");
    Expect(1, 72384, '\p{^Is_Sc=cans}', "");
    Expect(1, 72384, '\P{Is_Sc=cans}', "");
    Expect(0, 72384, '\P{^Is_Sc=cans}', "");
    Expect(1, 72383, '\p{Is_Sc=-	Cans}', "");
    Expect(0, 72383, '\p{^Is_Sc=-	Cans}', "");
    Expect(0, 72383, '\P{Is_Sc=-	Cans}', "");
    Expect(1, 72383, '\P{^Is_Sc=-	Cans}', "");
    Expect(0, 72384, '\p{Is_Sc=-	Cans}', "");
    Expect(1, 72384, '\p{^Is_Sc=-	Cans}', "");
    Expect(1, 72384, '\P{Is_Sc=-	Cans}', "");
    Expect(0, 72384, '\P{^Is_Sc=-	Cans}', "");
    Error('\p{Script= _carian:=}');
    Error('\P{Script= _carian:=}');
    Expect(1, 66256, '\p{Script=:\ACarian\z:}', "");;
    Expect(0, 66257, '\p{Script=:\ACarian\z:}', "");;
    Expect(1, 66256, '\p{Script=carian}', "");
    Expect(0, 66256, '\p{^Script=carian}', "");
    Expect(0, 66256, '\P{Script=carian}', "");
    Expect(1, 66256, '\P{^Script=carian}', "");
    Expect(0, 66257, '\p{Script=carian}', "");
    Expect(1, 66257, '\p{^Script=carian}', "");
    Expect(1, 66257, '\P{Script=carian}', "");
    Expect(0, 66257, '\P{^Script=carian}', "");
    Expect(1, 66256, '\p{Script=:\Acarian\z:}', "");;
    Expect(0, 66257, '\p{Script=:\Acarian\z:}', "");;
    Expect(1, 66256, '\p{Script=	carian}', "");
    Expect(0, 66256, '\p{^Script=	carian}', "");
    Expect(0, 66256, '\P{Script=	carian}', "");
    Expect(1, 66256, '\P{^Script=	carian}', "");
    Expect(0, 66257, '\p{Script=	carian}', "");
    Expect(1, 66257, '\p{^Script=	carian}', "");
    Expect(1, 66257, '\P{Script=	carian}', "");
    Expect(0, 66257, '\P{^Script=	carian}', "");
    Error('\p{Sc=:=CARI}');
    Error('\P{Sc=:=CARI}');
    Expect(1, 66256, '\p{Sc=:\ACari\z:}', "");;
    Expect(0, 66257, '\p{Sc=:\ACari\z:}', "");;
    Expect(1, 66256, '\p{Sc=cari}', "");
    Expect(0, 66256, '\p{^Sc=cari}', "");
    Expect(0, 66256, '\P{Sc=cari}', "");
    Expect(1, 66256, '\P{^Sc=cari}', "");
    Expect(0, 66257, '\p{Sc=cari}', "");
    Expect(1, 66257, '\p{^Sc=cari}', "");
    Expect(1, 66257, '\P{Sc=cari}', "");
    Expect(0, 66257, '\P{^Sc=cari}', "");
    Expect(1, 66256, '\p{Sc=:\Acari\z:}', "");;
    Expect(0, 66257, '\p{Sc=:\Acari\z:}', "");;
    Expect(1, 66256, '\p{Sc=_	Cari}', "");
    Expect(0, 66256, '\p{^Sc=_	Cari}', "");
    Expect(0, 66256, '\P{Sc=_	Cari}', "");
    Expect(1, 66256, '\P{^Sc=_	Cari}', "");
    Expect(0, 66257, '\p{Sc=_	Cari}', "");
    Expect(1, 66257, '\p{^Sc=_	Cari}', "");
    Expect(1, 66257, '\P{Sc=_	Cari}', "");
    Expect(0, 66257, '\P{^Sc=_	Cari}', "");
    Error('\p{Is_Script:	/a/carian}');
    Error('\P{Is_Script:	/a/carian}');
    Expect(1, 66256, '\p{Is_Script=carian}', "");
    Expect(0, 66256, '\p{^Is_Script=carian}', "");
    Expect(0, 66256, '\P{Is_Script=carian}', "");
    Expect(1, 66256, '\P{^Is_Script=carian}', "");
    Expect(0, 66257, '\p{Is_Script=carian}', "");
    Expect(1, 66257, '\p{^Is_Script=carian}', "");
    Expect(1, 66257, '\P{Is_Script=carian}', "");
    Expect(0, 66257, '\P{^Is_Script=carian}', "");
    Expect(1, 66256, '\p{Is_Script=Carian}', "");
    Expect(0, 66256, '\p{^Is_Script=Carian}', "");
    Expect(0, 66256, '\P{Is_Script=Carian}', "");
    Expect(1, 66256, '\P{^Is_Script=Carian}', "");
    Expect(0, 66257, '\p{Is_Script=Carian}', "");
    Expect(1, 66257, '\p{^Is_Script=Carian}', "");
    Expect(1, 66257, '\P{Is_Script=Carian}', "");
    Expect(0, 66257, '\P{^Is_Script=Carian}', "");
    Error('\p{Is_Sc=_cari/a/}');
    Error('\P{Is_Sc=_cari/a/}');
    Expect(1, 66256, '\p{Is_Sc=cari}', "");
    Expect(0, 66256, '\p{^Is_Sc=cari}', "");
    Expect(0, 66256, '\P{Is_Sc=cari}', "");
    Expect(1, 66256, '\P{^Is_Sc=cari}', "");
    Expect(0, 66257, '\p{Is_Sc=cari}', "");
    Expect(1, 66257, '\p{^Is_Sc=cari}', "");
    Expect(1, 66257, '\P{Is_Sc=cari}', "");
    Expect(0, 66257, '\P{^Is_Sc=cari}', "");
    Expect(1, 66256, '\p{Is_Sc=_-Cari}', "");
    Expect(0, 66256, '\p{^Is_Sc=_-Cari}', "");
    Expect(0, 66256, '\P{Is_Sc=_-Cari}', "");
    Expect(1, 66256, '\P{^Is_Sc=_-Cari}', "");
    Expect(0, 66257, '\p{Is_Sc=_-Cari}', "");
    Expect(1, 66257, '\p{^Is_Sc=_-Cari}', "");
    Expect(1, 66257, '\P{Is_Sc=_-Cari}', "");
    Expect(0, 66257, '\P{^Is_Sc=_-Cari}', "");
    Error('\p{Script=/a/ 	Cham}');
    Error('\P{Script=/a/ 	Cham}');
    Expect(1, 43615, '\p{Script=:\ACham\z:}', "");;
    Expect(0, 43616, '\p{Script=:\ACham\z:}', "");;
    Expect(1, 43615, '\p{Script=cham}', "");
    Expect(0, 43615, '\p{^Script=cham}', "");
    Expect(0, 43615, '\P{Script=cham}', "");
    Expect(1, 43615, '\P{^Script=cham}', "");
    Expect(0, 43616, '\p{Script=cham}', "");
    Expect(1, 43616, '\p{^Script=cham}', "");
    Expect(1, 43616, '\P{Script=cham}', "");
    Expect(0, 43616, '\P{^Script=cham}', "");
    Expect(1, 43615, '\p{Script=:\Acham\z:}', "");;
    Expect(0, 43616, '\p{Script=:\Acham\z:}', "");;
    Expect(1, 43615, '\p{Script:	--cham}', "");
    Expect(0, 43615, '\p{^Script:	--cham}', "");
    Expect(0, 43615, '\P{Script:	--cham}', "");
    Expect(1, 43615, '\P{^Script:	--cham}', "");
    Expect(0, 43616, '\p{Script:	--cham}', "");
    Expect(1, 43616, '\p{^Script:	--cham}', "");
    Expect(1, 43616, '\P{Script:	--cham}', "");
    Expect(0, 43616, '\P{^Script:	--cham}', "");
    Error('\p{Sc=:=_Cham}');
    Error('\P{Sc=:=_Cham}');
    Expect(1, 43615, '\p{Sc=:\ACham\z:}', "");;
    Expect(0, 43616, '\p{Sc=:\ACham\z:}', "");;
    Expect(1, 43615, '\p{Sc=cham}', "");
    Expect(0, 43615, '\p{^Sc=cham}', "");
    Expect(0, 43615, '\P{Sc=cham}', "");
    Expect(1, 43615, '\P{^Sc=cham}', "");
    Expect(0, 43616, '\p{Sc=cham}', "");
    Expect(1, 43616, '\p{^Sc=cham}', "");
    Expect(1, 43616, '\P{Sc=cham}', "");
    Expect(0, 43616, '\P{^Sc=cham}', "");
    Expect(1, 43615, '\p{Sc=:\Acham\z:}', "");;
    Expect(0, 43616, '\p{Sc=:\Acham\z:}', "");;
    Expect(1, 43615, '\p{Sc=_cham}', "");
    Expect(0, 43615, '\p{^Sc=_cham}', "");
    Expect(0, 43615, '\P{Sc=_cham}', "");
    Expect(1, 43615, '\P{^Sc=_cham}', "");
    Expect(0, 43616, '\p{Sc=_cham}', "");
    Expect(1, 43616, '\p{^Sc=_cham}', "");
    Expect(1, 43616, '\P{Sc=_cham}', "");
    Expect(0, 43616, '\P{^Sc=_cham}', "");
    Error('\p{Is_Script=_:=CHAM}');
    Error('\P{Is_Script=_:=CHAM}');
    Expect(1, 43615, '\p{Is_Script=cham}', "");
    Expect(0, 43615, '\p{^Is_Script=cham}', "");
    Expect(0, 43615, '\P{Is_Script=cham}', "");
    Expect(1, 43615, '\P{^Is_Script=cham}', "");
    Expect(0, 43616, '\p{Is_Script=cham}', "");
    Expect(1, 43616, '\p{^Is_Script=cham}', "");
    Expect(1, 43616, '\P{Is_Script=cham}', "");
    Expect(0, 43616, '\P{^Is_Script=cham}', "");
    Expect(1, 43615, '\p{Is_Script=_ Cham}', "");
    Expect(0, 43615, '\p{^Is_Script=_ Cham}', "");
    Expect(0, 43615, '\P{Is_Script=_ Cham}', "");
    Expect(1, 43615, '\P{^Is_Script=_ Cham}', "");
    Expect(0, 43616, '\p{Is_Script=_ Cham}', "");
    Expect(1, 43616, '\p{^Is_Script=_ Cham}', "");
    Expect(1, 43616, '\P{Is_Script=_ Cham}', "");
    Expect(0, 43616, '\P{^Is_Script=_ Cham}', "");
    Error('\p{Is_Sc=:=_Cham}');
    Error('\P{Is_Sc=:=_Cham}');
    Expect(1, 43615, '\p{Is_Sc=cham}', "");
    Expect(0, 43615, '\p{^Is_Sc=cham}', "");
    Expect(0, 43615, '\P{Is_Sc=cham}', "");
    Expect(1, 43615, '\P{^Is_Sc=cham}', "");
    Expect(0, 43616, '\p{Is_Sc=cham}', "");
    Expect(1, 43616, '\p{^Is_Sc=cham}', "");
    Expect(1, 43616, '\P{Is_Sc=cham}', "");
    Expect(0, 43616, '\P{^Is_Sc=cham}', "");
    Expect(1, 43615, '\p{Is_Sc=_	cham}', "");
    Expect(0, 43615, '\p{^Is_Sc=_	cham}', "");
    Expect(0, 43615, '\P{Is_Sc=_	cham}', "");
    Expect(1, 43615, '\P{^Is_Sc=_	cham}', "");
    Expect(0, 43616, '\p{Is_Sc=_	cham}', "");
    Expect(1, 43616, '\p{^Is_Sc=_	cham}', "");
    Expect(1, 43616, '\P{Is_Sc=_	cham}', "");
    Expect(0, 43616, '\P{^Is_Sc=_	cham}', "");
    Error('\p{Script=	 Cherokee/a/}');
    Error('\P{Script=	 Cherokee/a/}');
    Expect(1, 43967, '\p{Script=:\ACherokee\z:}', "");;
    Expect(0, 43968, '\p{Script=:\ACherokee\z:}', "");;
    Expect(1, 43967, '\p{Script=cherokee}', "");
    Expect(0, 43967, '\p{^Script=cherokee}', "");
    Expect(0, 43967, '\P{Script=cherokee}', "");
    Expect(1, 43967, '\P{^Script=cherokee}', "");
    Expect(0, 43968, '\p{Script=cherokee}', "");
    Expect(1, 43968, '\p{^Script=cherokee}', "");
    Expect(1, 43968, '\P{Script=cherokee}', "");
    Expect(0, 43968, '\P{^Script=cherokee}', "");
    Expect(1, 43967, '\p{Script=:\Acherokee\z:}', "");;
    Expect(0, 43968, '\p{Script=:\Acherokee\z:}', "");;
    Expect(1, 43967, '\p{Script= _CHEROKEE}', "");
    Expect(0, 43967, '\p{^Script= _CHEROKEE}', "");
    Expect(0, 43967, '\P{Script= _CHEROKEE}', "");
    Expect(1, 43967, '\P{^Script= _CHEROKEE}', "");
    Expect(0, 43968, '\p{Script= _CHEROKEE}', "");
    Expect(1, 43968, '\p{^Script= _CHEROKEE}', "");
    Expect(1, 43968, '\P{Script= _CHEROKEE}', "");
    Expect(0, 43968, '\P{^Script= _CHEROKEE}', "");
    Error('\p{Sc=/a/_	CHER}');
    Error('\P{Sc=/a/_	CHER}');
    Expect(1, 43967, '\p{Sc=:\ACher\z:}', "");;
    Expect(0, 43968, '\p{Sc=:\ACher\z:}', "");;
    Expect(1, 43967, '\p{Sc=cher}', "");
    Expect(0, 43967, '\p{^Sc=cher}', "");
    Expect(0, 43967, '\P{Sc=cher}', "");
    Expect(1, 43967, '\P{^Sc=cher}', "");
    Expect(0, 43968, '\p{Sc=cher}', "");
    Expect(1, 43968, '\p{^Sc=cher}', "");
    Expect(1, 43968, '\P{Sc=cher}', "");
    Expect(0, 43968, '\P{^Sc=cher}', "");
    Expect(1, 43967, '\p{Sc=:\Acher\z:}', "");;
    Expect(0, 43968, '\p{Sc=:\Acher\z:}', "");;
    Expect(1, 43967, '\p{Sc=_	Cher}', "");
    Expect(0, 43967, '\p{^Sc=_	Cher}', "");
    Expect(0, 43967, '\P{Sc=_	Cher}', "");
    Expect(1, 43967, '\P{^Sc=_	Cher}', "");
    Expect(0, 43968, '\p{Sc=_	Cher}', "");
    Expect(1, 43968, '\p{^Sc=_	Cher}', "");
    Expect(1, 43968, '\P{Sc=_	Cher}', "");
    Expect(0, 43968, '\P{^Sc=_	Cher}', "");
    Error('\p{Is_Script:   :=_ Cherokee}');
    Error('\P{Is_Script:   :=_ Cherokee}');
    Expect(1, 43967, '\p{Is_Script=cherokee}', "");
    Expect(0, 43967, '\p{^Is_Script=cherokee}', "");
    Expect(0, 43967, '\P{Is_Script=cherokee}', "");
    Expect(1, 43967, '\P{^Is_Script=cherokee}', "");
    Expect(0, 43968, '\p{Is_Script=cherokee}', "");
    Expect(1, 43968, '\p{^Is_Script=cherokee}', "");
    Expect(1, 43968, '\P{Is_Script=cherokee}', "");
    Expect(0, 43968, '\P{^Is_Script=cherokee}', "");
    Expect(1, 43967, '\p{Is_Script=-	CHEROKEE}', "");
    Expect(0, 43967, '\p{^Is_Script=-	CHEROKEE}', "");
    Expect(0, 43967, '\P{Is_Script=-	CHEROKEE}', "");
    Expect(1, 43967, '\P{^Is_Script=-	CHEROKEE}', "");
    Expect(0, 43968, '\p{Is_Script=-	CHEROKEE}', "");
    Expect(1, 43968, '\p{^Is_Script=-	CHEROKEE}', "");
    Expect(1, 43968, '\P{Is_Script=-	CHEROKEE}', "");
    Expect(0, 43968, '\P{^Is_Script=-	CHEROKEE}', "");
    Error('\p{Is_Sc=/a/_CHER}');
    Error('\P{Is_Sc=/a/_CHER}');
    Expect(1, 43967, '\p{Is_Sc=cher}', "");
    Expect(0, 43967, '\p{^Is_Sc=cher}', "");
    Expect(0, 43967, '\P{Is_Sc=cher}', "");
    Expect(1, 43967, '\P{^Is_Sc=cher}', "");
    Expect(0, 43968, '\p{Is_Sc=cher}', "");
    Expect(1, 43968, '\p{^Is_Sc=cher}', "");
    Expect(1, 43968, '\P{Is_Sc=cher}', "");
    Expect(0, 43968, '\P{^Is_Sc=cher}', "");
    Expect(1, 43967, '\p{Is_Sc=	_cher}', "");
    Expect(0, 43967, '\p{^Is_Sc=	_cher}', "");
    Expect(0, 43967, '\P{Is_Sc=	_cher}', "");
    Expect(1, 43967, '\P{^Is_Sc=	_cher}', "");
    Expect(0, 43968, '\p{Is_Sc=	_cher}', "");
    Expect(1, 43968, '\p{^Is_Sc=	_cher}', "");
    Expect(1, 43968, '\P{Is_Sc=	_cher}', "");
    Expect(0, 43968, '\P{^Is_Sc=	_cher}', "");
    Error('\p{Script=/a/_Chorasmian}');
    Error('\P{Script=/a/_Chorasmian}');
    Expect(1, 69579, '\p{Script=:\AChorasmian\z:}', "");;
    Expect(0, 69580, '\p{Script=:\AChorasmian\z:}', "");;
    Expect(1, 69579, '\p{Script=chorasmian}', "");
    Expect(0, 69579, '\p{^Script=chorasmian}', "");
    Expect(0, 69579, '\P{Script=chorasmian}', "");
    Expect(1, 69579, '\P{^Script=chorasmian}', "");
    Expect(0, 69580, '\p{Script=chorasmian}', "");
    Expect(1, 69580, '\p{^Script=chorasmian}', "");
    Expect(1, 69580, '\P{Script=chorasmian}', "");
    Expect(0, 69580, '\P{^Script=chorasmian}', "");
    Expect(1, 69579, '\p{Script=:\Achorasmian\z:}', "");;
    Expect(0, 69580, '\p{Script=:\Achorasmian\z:}', "");;
    Expect(1, 69579, '\p{Script=	_Chorasmian}', "");
    Expect(0, 69579, '\p{^Script=	_Chorasmian}', "");
    Expect(0, 69579, '\P{Script=	_Chorasmian}', "");
    Expect(1, 69579, '\P{^Script=	_Chorasmian}', "");
    Expect(0, 69580, '\p{Script=	_Chorasmian}', "");
    Expect(1, 69580, '\p{^Script=	_Chorasmian}', "");
    Expect(1, 69580, '\P{Script=	_Chorasmian}', "");
    Expect(0, 69580, '\P{^Script=	_Chorasmian}', "");
    Error('\p{Sc=:=	_Chrs}');
    Error('\P{Sc=:=	_Chrs}');
    Expect(1, 69579, '\p{Sc=:\AChrs\z:}', "");;
    Expect(0, 69580, '\p{Sc=:\AChrs\z:}', "");;
    Expect(1, 69579, '\p{Sc=chrs}', "");
    Expect(0, 69579, '\p{^Sc=chrs}', "");
    Expect(0, 69579, '\P{Sc=chrs}', "");
    Expect(1, 69579, '\P{^Sc=chrs}', "");
    Expect(0, 69580, '\p{Sc=chrs}', "");
    Expect(1, 69580, '\p{^Sc=chrs}', "");
    Expect(1, 69580, '\P{Sc=chrs}', "");
    Expect(0, 69580, '\P{^Sc=chrs}', "");
    Expect(1, 69579, '\p{Sc=:\Achrs\z:}', "");;
    Expect(0, 69580, '\p{Sc=:\Achrs\z:}', "");;
    Expect(1, 69579, '\p{Sc= _CHRS}', "");
    Expect(0, 69579, '\p{^Sc= _CHRS}', "");
    Expect(0, 69579, '\P{Sc= _CHRS}', "");
    Expect(1, 69579, '\P{^Sc= _CHRS}', "");
    Expect(0, 69580, '\p{Sc= _CHRS}', "");
    Expect(1, 69580, '\p{^Sc= _CHRS}', "");
    Expect(1, 69580, '\P{Sc= _CHRS}', "");
    Expect(0, 69580, '\P{^Sc= _CHRS}', "");
    Error('\p{Is_Script:		-Chorasmian:=}');
    Error('\P{Is_Script:		-Chorasmian:=}');
    Expect(1, 69579, '\p{Is_Script:	chorasmian}', "");
    Expect(0, 69579, '\p{^Is_Script:	chorasmian}', "");
    Expect(0, 69579, '\P{Is_Script:	chorasmian}', "");
    Expect(1, 69579, '\P{^Is_Script:	chorasmian}', "");
    Expect(0, 69580, '\p{Is_Script:	chorasmian}', "");
    Expect(1, 69580, '\p{^Is_Script:	chorasmian}', "");
    Expect(1, 69580, '\P{Is_Script:	chorasmian}', "");
    Expect(0, 69580, '\P{^Is_Script:	chorasmian}', "");
    Expect(1, 69579, '\p{Is_Script=	Chorasmian}', "");
    Expect(0, 69579, '\p{^Is_Script=	Chorasmian}', "");
    Expect(0, 69579, '\P{Is_Script=	Chorasmian}', "");
    Expect(1, 69579, '\P{^Is_Script=	Chorasmian}', "");
    Expect(0, 69580, '\p{Is_Script=	Chorasmian}', "");
    Expect(1, 69580, '\p{^Is_Script=	Chorasmian}', "");
    Expect(1, 69580, '\P{Is_Script=	Chorasmian}', "");
    Expect(0, 69580, '\P{^Is_Script=	Chorasmian}', "");
    Error('\p{Is_Sc=/a/_Chrs}');
    Error('\P{Is_Sc=/a/_Chrs}');
    Expect(1, 69579, '\p{Is_Sc=chrs}', "");
    Expect(0, 69579, '\p{^Is_Sc=chrs}', "");
    Expect(0, 69579, '\P{Is_Sc=chrs}', "");
    Expect(1, 69579, '\P{^Is_Sc=chrs}', "");
    Expect(0, 69580, '\p{Is_Sc=chrs}', "");
    Expect(1, 69580, '\p{^Is_Sc=chrs}', "");
    Expect(1, 69580, '\P{Is_Sc=chrs}', "");
    Expect(0, 69580, '\P{^Is_Sc=chrs}', "");
    Expect(1, 69579, '\p{Is_Sc:			Chrs}', "");
    Expect(0, 69579, '\p{^Is_Sc:			Chrs}', "");
    Expect(0, 69579, '\P{Is_Sc:			Chrs}', "");
    Expect(1, 69579, '\P{^Is_Sc:			Chrs}', "");
    Expect(0, 69580, '\p{Is_Sc:			Chrs}', "");
    Expect(1, 69580, '\p{^Is_Sc:			Chrs}', "");
    Expect(1, 69580, '\P{Is_Sc:			Chrs}', "");
    Expect(0, 69580, '\P{^Is_Sc:			Chrs}', "");
    Error('\p{Script=:=Coptic}');
    Error('\P{Script=:=Coptic}');
    Expect(1, 11519, '\p{Script=:\ACoptic\z:}', "");;
    Expect(0, 11520, '\p{Script=:\ACoptic\z:}', "");;
    Expect(1, 11519, '\p{Script=coptic}', "");
    Expect(0, 11519, '\p{^Script=coptic}', "");
    Expect(0, 11519, '\P{Script=coptic}', "");
    Expect(1, 11519, '\P{^Script=coptic}', "");
    Expect(0, 11520, '\p{Script=coptic}', "");
    Expect(1, 11520, '\p{^Script=coptic}', "");
    Expect(1, 11520, '\P{Script=coptic}', "");
    Expect(0, 11520, '\P{^Script=coptic}', "");
    Expect(1, 11519, '\p{Script=:\Acoptic\z:}', "");;
    Expect(0, 11520, '\p{Script=:\Acoptic\z:}', "");;
    Expect(1, 11519, '\p{Script= -coptic}', "");
    Expect(0, 11519, '\p{^Script= -coptic}', "");
    Expect(0, 11519, '\P{Script= -coptic}', "");
    Expect(1, 11519, '\P{^Script= -coptic}', "");
    Expect(0, 11520, '\p{Script= -coptic}', "");
    Expect(1, 11520, '\p{^Script= -coptic}', "");
    Expect(1, 11520, '\P{Script= -coptic}', "");
    Expect(0, 11520, '\P{^Script= -coptic}', "");
    Error('\p{Sc=/a/_ COPT}');
    Error('\P{Sc=/a/_ COPT}');
    Expect(1, 11519, '\p{Sc=:\ACopt\z:}', "");;
    Expect(0, 11520, '\p{Sc=:\ACopt\z:}', "");;
    Expect(1, 11519, '\p{Sc=copt}', "");
    Expect(0, 11519, '\p{^Sc=copt}', "");
    Expect(0, 11519, '\P{Sc=copt}', "");
    Expect(1, 11519, '\P{^Sc=copt}', "");
    Expect(0, 11520, '\p{Sc=copt}', "");
    Expect(1, 11520, '\p{^Sc=copt}', "");
    Expect(1, 11520, '\P{Sc=copt}', "");
    Expect(0, 11520, '\P{^Sc=copt}', "");
    Expect(1, 11519, '\p{Sc=:\Acopt\z:}', "");;
    Expect(0, 11520, '\p{Sc=:\Acopt\z:}', "");;
    Expect(1, 11519, '\p{Sc= Copt}', "");
    Expect(0, 11519, '\p{^Sc= Copt}', "");
    Expect(0, 11519, '\P{Sc= Copt}', "");
    Expect(1, 11519, '\P{^Sc= Copt}', "");
    Expect(0, 11520, '\p{Sc= Copt}', "");
    Expect(1, 11520, '\p{^Sc= Copt}', "");
    Expect(1, 11520, '\P{Sc= Copt}', "");
    Expect(0, 11520, '\P{^Sc= Copt}', "");
    Error('\p{Is_Script=	:=Qaac}');
    Error('\P{Is_Script=	:=Qaac}');
    Expect(1, 11519, '\p{Is_Script=qaac}', "");
    Expect(0, 11519, '\p{^Is_Script=qaac}', "");
    Expect(0, 11519, '\P{Is_Script=qaac}', "");
    Expect(1, 11519, '\P{^Is_Script=qaac}', "");
    Expect(0, 11520, '\p{Is_Script=qaac}', "");
    Expect(1, 11520, '\p{^Is_Script=qaac}', "");
    Expect(1, 11520, '\P{Is_Script=qaac}', "");
    Expect(0, 11520, '\P{^Is_Script=qaac}', "");
    Expect(1, 11519, '\p{Is_Script=	Qaac}', "");
    Expect(0, 11519, '\p{^Is_Script=	Qaac}', "");
    Expect(0, 11519, '\P{Is_Script=	Qaac}', "");
    Expect(1, 11519, '\P{^Is_Script=	Qaac}', "");
    Expect(0, 11520, '\p{Is_Script=	Qaac}', "");
    Expect(1, 11520, '\p{^Is_Script=	Qaac}', "");
    Expect(1, 11520, '\P{Is_Script=	Qaac}', "");
    Expect(0, 11520, '\P{^Is_Script=	Qaac}', "");
    Error('\p{Is_Sc=/a/ -coptic}');
    Error('\P{Is_Sc=/a/ -coptic}');
    Expect(1, 11519, '\p{Is_Sc=coptic}', "");
    Expect(0, 11519, '\p{^Is_Sc=coptic}', "");
    Expect(0, 11519, '\P{Is_Sc=coptic}', "");
    Expect(1, 11519, '\P{^Is_Sc=coptic}', "");
    Expect(0, 11520, '\p{Is_Sc=coptic}', "");
    Expect(1, 11520, '\p{^Is_Sc=coptic}', "");
    Expect(1, 11520, '\P{Is_Sc=coptic}', "");
    Expect(0, 11520, '\P{^Is_Sc=coptic}', "");
    Expect(1, 11519, '\p{Is_Sc= 	COPTIC}', "");
    Expect(0, 11519, '\p{^Is_Sc= 	COPTIC}', "");
    Expect(0, 11519, '\P{Is_Sc= 	COPTIC}', "");
    Expect(1, 11519, '\P{^Is_Sc= 	COPTIC}', "");
    Expect(0, 11520, '\p{Is_Sc= 	COPTIC}', "");
    Expect(1, 11520, '\p{^Is_Sc= 	COPTIC}', "");
    Expect(1, 11520, '\P{Is_Sc= 	COPTIC}', "");
    Expect(0, 11520, '\P{^Is_Sc= 	COPTIC}', "");
    Error('\p{Script=	:=Cypro_minoan}');
    Error('\P{Script=	:=Cypro_minoan}');
    Expect(1, 77810, '\p{Script=:\ACypro_Minoan\z:}', "");;
    Expect(0, 77811, '\p{Script=:\ACypro_Minoan\z:}', "");;
    Expect(1, 77810, '\p{Script=cyprominoan}', "");
    Expect(0, 77810, '\p{^Script=cyprominoan}', "");
    Expect(0, 77810, '\P{Script=cyprominoan}', "");
    Expect(1, 77810, '\P{^Script=cyprominoan}', "");
    Expect(0, 77811, '\p{Script=cyprominoan}', "");
    Expect(1, 77811, '\p{^Script=cyprominoan}', "");
    Expect(1, 77811, '\P{Script=cyprominoan}', "");
    Expect(0, 77811, '\P{^Script=cyprominoan}', "");
    Expect(1, 77810, '\p{Script=:\Acyprominoan\z:}', "");;
    Expect(0, 77811, '\p{Script=:\Acyprominoan\z:}', "");;
    Expect(1, 77810, '\p{Script=-cypro_MINOAN}', "");
    Expect(0, 77810, '\p{^Script=-cypro_MINOAN}', "");
    Expect(0, 77810, '\P{Script=-cypro_MINOAN}', "");
    Expect(1, 77810, '\P{^Script=-cypro_MINOAN}', "");
    Expect(0, 77811, '\p{Script=-cypro_MINOAN}', "");
    Expect(1, 77811, '\p{^Script=-cypro_MINOAN}', "");
    Expect(1, 77811, '\P{Script=-cypro_MINOAN}', "");
    Expect(0, 77811, '\P{^Script=-cypro_MINOAN}', "");
    Error('\p{Sc=Cpmn:=}');
    Error('\P{Sc=Cpmn:=}');
    Expect(1, 77810, '\p{Sc=:\ACpmn\z:}', "");;
    Expect(0, 77811, '\p{Sc=:\ACpmn\z:}', "");;
    Expect(1, 77810, '\p{Sc=cpmn}', "");
    Expect(0, 77810, '\p{^Sc=cpmn}', "");
    Expect(0, 77810, '\P{Sc=cpmn}', "");
    Expect(1, 77810, '\P{^Sc=cpmn}', "");
    Expect(0, 77811, '\p{Sc=cpmn}', "");
    Expect(1, 77811, '\p{^Sc=cpmn}', "");
    Expect(1, 77811, '\P{Sc=cpmn}', "");
    Expect(0, 77811, '\P{^Sc=cpmn}', "");
    Expect(1, 77810, '\p{Sc=:\Acpmn\z:}', "");;
    Expect(0, 77811, '\p{Sc=:\Acpmn\z:}', "");;
    Expect(1, 77810, '\p{Sc=_	CPMN}', "");
    Expect(0, 77810, '\p{^Sc=_	CPMN}', "");
    Expect(0, 77810, '\P{Sc=_	CPMN}', "");
    Expect(1, 77810, '\P{^Sc=_	CPMN}', "");
    Expect(0, 77811, '\p{Sc=_	CPMN}', "");
    Expect(1, 77811, '\p{^Sc=_	CPMN}', "");
    Expect(1, 77811, '\P{Sc=_	CPMN}', "");
    Expect(0, 77811, '\P{^Sc=_	CPMN}', "");
    Error('\p{Is_Script:	-cypro_Minoan/a/}');
    Error('\P{Is_Script:	-cypro_Minoan/a/}');
    Expect(1, 77810, '\p{Is_Script=cyprominoan}', "");
    Expect(0, 77810, '\p{^Is_Script=cyprominoan}', "");
    Expect(0, 77810, '\P{Is_Script=cyprominoan}', "");
    Expect(1, 77810, '\P{^Is_Script=cyprominoan}', "");
    Expect(0, 77811, '\p{Is_Script=cyprominoan}', "");
    Expect(1, 77811, '\p{^Is_Script=cyprominoan}', "");
    Expect(1, 77811, '\P{Is_Script=cyprominoan}', "");
    Expect(0, 77811, '\P{^Is_Script=cyprominoan}', "");
    Expect(1, 77810, '\p{Is_Script=-Cypro_minoan}', "");
    Expect(0, 77810, '\p{^Is_Script=-Cypro_minoan}', "");
    Expect(0, 77810, '\P{Is_Script=-Cypro_minoan}', "");
    Expect(1, 77810, '\P{^Is_Script=-Cypro_minoan}', "");
    Expect(0, 77811, '\p{Is_Script=-Cypro_minoan}', "");
    Expect(1, 77811, '\p{^Is_Script=-Cypro_minoan}', "");
    Expect(1, 77811, '\P{Is_Script=-Cypro_minoan}', "");
    Expect(0, 77811, '\P{^Is_Script=-Cypro_minoan}', "");
    Error('\p{Is_Sc=	 Cpmn:=}');
    Error('\P{Is_Sc=	 Cpmn:=}');
    Expect(1, 77810, '\p{Is_Sc=cpmn}', "");
    Expect(0, 77810, '\p{^Is_Sc=cpmn}', "");
    Expect(0, 77810, '\P{Is_Sc=cpmn}', "");
    Expect(1, 77810, '\P{^Is_Sc=cpmn}', "");
    Expect(0, 77811, '\p{Is_Sc=cpmn}', "");
    Expect(1, 77811, '\p{^Is_Sc=cpmn}', "");
    Expect(1, 77811, '\P{Is_Sc=cpmn}', "");
    Expect(0, 77811, '\P{^Is_Sc=cpmn}', "");
    Expect(1, 77810, '\p{Is_Sc= _Cpmn}', "");
    Expect(0, 77810, '\p{^Is_Sc= _Cpmn}', "");
    Expect(0, 77810, '\P{Is_Sc= _Cpmn}', "");
    Expect(1, 77810, '\P{^Is_Sc= _Cpmn}', "");
    Expect(0, 77811, '\p{Is_Sc= _Cpmn}', "");
    Expect(1, 77811, '\p{^Is_Sc= _Cpmn}', "");
    Expect(1, 77811, '\P{Is_Sc= _Cpmn}', "");
    Expect(0, 77811, '\P{^Is_Sc= _Cpmn}', "");
    Error('\p{Script= _Cypriot/a/}');
    Error('\P{Script= _Cypriot/a/}');
    Expect(1, 67647, '\p{Script=:\ACypriot\z:}', "");;
    Expect(0, 67648, '\p{Script=:\ACypriot\z:}', "");;
    Expect(1, 67647, '\p{Script=cypriot}', "");
    Expect(0, 67647, '\p{^Script=cypriot}', "");
    Expect(0, 67647, '\P{Script=cypriot}', "");
    Expect(1, 67647, '\P{^Script=cypriot}', "");
    Expect(0, 67648, '\p{Script=cypriot}', "");
    Expect(1, 67648, '\p{^Script=cypriot}', "");
    Expect(1, 67648, '\P{Script=cypriot}', "");
    Expect(0, 67648, '\P{^Script=cypriot}', "");
    Expect(1, 67647, '\p{Script=:\Acypriot\z:}', "");;
    Expect(0, 67648, '\p{Script=:\Acypriot\z:}', "");;
    Expect(1, 67647, '\p{Script=		CYPRIOT}', "");
    Expect(0, 67647, '\p{^Script=		CYPRIOT}', "");
    Expect(0, 67647, '\P{Script=		CYPRIOT}', "");
    Expect(1, 67647, '\P{^Script=		CYPRIOT}', "");
    Expect(0, 67648, '\p{Script=		CYPRIOT}', "");
    Expect(1, 67648, '\p{^Script=		CYPRIOT}', "");
    Expect(1, 67648, '\P{Script=		CYPRIOT}', "");
    Expect(0, 67648, '\P{^Script=		CYPRIOT}', "");
    Error('\p{Sc=/a/Cprt}');
    Error('\P{Sc=/a/Cprt}');
    Expect(1, 67647, '\p{Sc=:\ACprt\z:}', "");;
    Expect(0, 67648, '\p{Sc=:\ACprt\z:}', "");;
    Expect(1, 67647, '\p{Sc=cprt}', "");
    Expect(0, 67647, '\p{^Sc=cprt}', "");
    Expect(0, 67647, '\P{Sc=cprt}', "");
    Expect(1, 67647, '\P{^Sc=cprt}', "");
    Expect(0, 67648, '\p{Sc=cprt}', "");
    Expect(1, 67648, '\p{^Sc=cprt}', "");
    Expect(1, 67648, '\P{Sc=cprt}', "");
    Expect(0, 67648, '\P{^Sc=cprt}', "");
    Expect(1, 67647, '\p{Sc=:\Acprt\z:}', "");;
    Expect(0, 67648, '\p{Sc=:\Acprt\z:}', "");;
    Expect(1, 67647, '\p{Sc= CPRT}', "");
    Expect(0, 67647, '\p{^Sc= CPRT}', "");
    Expect(0, 67647, '\P{Sc= CPRT}', "");
    Expect(1, 67647, '\P{^Sc= CPRT}', "");
    Expect(0, 67648, '\p{Sc= CPRT}', "");
    Expect(1, 67648, '\p{^Sc= CPRT}', "");
    Expect(1, 67648, '\P{Sc= CPRT}', "");
    Expect(0, 67648, '\P{^Sc= CPRT}', "");
    Error('\p{Is_Script=_/a/CYPRIOT}');
    Error('\P{Is_Script=_/a/CYPRIOT}');
    Expect(1, 67647, '\p{Is_Script:   cypriot}', "");
    Expect(0, 67647, '\p{^Is_Script:   cypriot}', "");
    Expect(0, 67647, '\P{Is_Script:   cypriot}', "");
    Expect(1, 67647, '\P{^Is_Script:   cypriot}', "");
    Expect(0, 67648, '\p{Is_Script:   cypriot}', "");
    Expect(1, 67648, '\p{^Is_Script:   cypriot}', "");
    Expect(1, 67648, '\P{Is_Script:   cypriot}', "");
    Expect(0, 67648, '\P{^Is_Script:   cypriot}', "");
    Expect(1, 67647, '\p{Is_Script= Cypriot}', "");
    Expect(0, 67647, '\p{^Is_Script= Cypriot}', "");
    Expect(0, 67647, '\P{Is_Script= Cypriot}', "");
    Expect(1, 67647, '\P{^Is_Script= Cypriot}', "");
    Expect(0, 67648, '\p{Is_Script= Cypriot}', "");
    Expect(1, 67648, '\p{^Is_Script= Cypriot}', "");
    Expect(1, 67648, '\P{Is_Script= Cypriot}', "");
    Expect(0, 67648, '\P{^Is_Script= Cypriot}', "");
    Error('\p{Is_Sc=/a/- Cprt}');
    Error('\P{Is_Sc=/a/- Cprt}');
    Expect(1, 67647, '\p{Is_Sc=cprt}', "");
    Expect(0, 67647, '\p{^Is_Sc=cprt}', "");
    Expect(0, 67647, '\P{Is_Sc=cprt}', "");
    Expect(1, 67647, '\P{^Is_Sc=cprt}', "");
    Expect(0, 67648, '\p{Is_Sc=cprt}', "");
    Expect(1, 67648, '\p{^Is_Sc=cprt}', "");
    Expect(1, 67648, '\P{Is_Sc=cprt}', "");
    Expect(0, 67648, '\P{^Is_Sc=cprt}', "");
    Expect(1, 67647, '\p{Is_Sc=-	cprt}', "");
    Expect(0, 67647, '\p{^Is_Sc=-	cprt}', "");
    Expect(0, 67647, '\P{Is_Sc=-	cprt}', "");
    Expect(1, 67647, '\P{^Is_Sc=-	cprt}', "");
    Expect(0, 67648, '\p{Is_Sc=-	cprt}', "");
    Expect(1, 67648, '\p{^Is_Sc=-	cprt}', "");
    Expect(1, 67648, '\P{Is_Sc=-	cprt}', "");
    Expect(0, 67648, '\P{^Is_Sc=-	cprt}', "");
    Error('\p{Script: /a/Cyrillic}');
    Error('\P{Script: /a/Cyrillic}');
    Expect(1, 123023, '\p{Script=:\ACyrillic\z:}', "");;
    Expect(0, 123024, '\p{Script=:\ACyrillic\z:}', "");;
    Expect(1, 123023, '\p{Script=cyrillic}', "");
    Expect(0, 123023, '\p{^Script=cyrillic}', "");
    Expect(0, 123023, '\P{Script=cyrillic}', "");
    Expect(1, 123023, '\P{^Script=cyrillic}', "");
    Expect(0, 123024, '\p{Script=cyrillic}', "");
    Expect(1, 123024, '\p{^Script=cyrillic}', "");
    Expect(1, 123024, '\P{Script=cyrillic}', "");
    Expect(0, 123024, '\P{^Script=cyrillic}', "");
    Expect(1, 123023, '\p{Script=:\Acyrillic\z:}', "");;
    Expect(0, 123024, '\p{Script=:\Acyrillic\z:}', "");;
    Expect(1, 123023, '\p{Script=__cyrillic}', "");
    Expect(0, 123023, '\p{^Script=__cyrillic}', "");
    Expect(0, 123023, '\P{Script=__cyrillic}', "");
    Expect(1, 123023, '\P{^Script=__cyrillic}', "");
    Expect(0, 123024, '\p{Script=__cyrillic}', "");
    Expect(1, 123024, '\p{^Script=__cyrillic}', "");
    Expect(1, 123024, '\P{Script=__cyrillic}', "");
    Expect(0, 123024, '\P{^Script=__cyrillic}', "");
    Error('\p{Sc=:=_CYRL}');
    Error('\P{Sc=:=_CYRL}');
    Expect(1, 123023, '\p{Sc=:\ACyrl\z:}', "");;
    Expect(0, 123024, '\p{Sc=:\ACyrl\z:}', "");;
    Expect(1, 123023, '\p{Sc=cyrl}', "");
    Expect(0, 123023, '\p{^Sc=cyrl}', "");
    Expect(0, 123023, '\P{Sc=cyrl}', "");
    Expect(1, 123023, '\P{^Sc=cyrl}', "");
    Expect(0, 123024, '\p{Sc=cyrl}', "");
    Expect(1, 123024, '\p{^Sc=cyrl}', "");
    Expect(1, 123024, '\P{Sc=cyrl}', "");
    Expect(0, 123024, '\P{^Sc=cyrl}', "");
    Expect(1, 123023, '\p{Sc=:\Acyrl\z:}', "");;
    Expect(0, 123024, '\p{Sc=:\Acyrl\z:}', "");;
    Expect(1, 123023, '\p{Sc= 	cyrl}', "");
    Expect(0, 123023, '\p{^Sc= 	cyrl}', "");
    Expect(0, 123023, '\P{Sc= 	cyrl}', "");
    Expect(1, 123023, '\P{^Sc= 	cyrl}', "");
    Expect(0, 123024, '\p{Sc= 	cyrl}', "");
    Expect(1, 123024, '\p{^Sc= 	cyrl}', "");
    Expect(1, 123024, '\P{Sc= 	cyrl}', "");
    Expect(0, 123024, '\P{^Sc= 	cyrl}', "");
    Error('\p{Is_Script=/a/-	Cyrillic}');
    Error('\P{Is_Script=/a/-	Cyrillic}');
    Expect(1, 123023, '\p{Is_Script=cyrillic}', "");
    Expect(0, 123023, '\p{^Is_Script=cyrillic}', "");
    Expect(0, 123023, '\P{Is_Script=cyrillic}', "");
    Expect(1, 123023, '\P{^Is_Script=cyrillic}', "");
    Expect(0, 123024, '\p{Is_Script=cyrillic}', "");
    Expect(1, 123024, '\p{^Is_Script=cyrillic}', "");
    Expect(1, 123024, '\P{Is_Script=cyrillic}', "");
    Expect(0, 123024, '\P{^Is_Script=cyrillic}', "");
    Expect(1, 123023, '\p{Is_Script=_	Cyrillic}', "");
    Expect(0, 123023, '\p{^Is_Script=_	Cyrillic}', "");
    Expect(0, 123023, '\P{Is_Script=_	Cyrillic}', "");
    Expect(1, 123023, '\P{^Is_Script=_	Cyrillic}', "");
    Expect(0, 123024, '\p{Is_Script=_	Cyrillic}', "");
    Expect(1, 123024, '\p{^Is_Script=_	Cyrillic}', "");
    Expect(1, 123024, '\P{Is_Script=_	Cyrillic}', "");
    Expect(0, 123024, '\P{^Is_Script=_	Cyrillic}', "");
    Error('\p{Is_Sc=:=CYRL}');
    Error('\P{Is_Sc=:=CYRL}');
    Expect(1, 123023, '\p{Is_Sc=cyrl}', "");
    Expect(0, 123023, '\p{^Is_Sc=cyrl}', "");
    Expect(0, 123023, '\P{Is_Sc=cyrl}', "");
    Expect(1, 123023, '\P{^Is_Sc=cyrl}', "");
    Expect(0, 123024, '\p{Is_Sc=cyrl}', "");
    Expect(1, 123024, '\p{^Is_Sc=cyrl}', "");
    Expect(1, 123024, '\P{Is_Sc=cyrl}', "");
    Expect(0, 123024, '\P{^Is_Sc=cyrl}', "");
    Expect(1, 123023, '\p{Is_Sc=		Cyrl}', "");
    Expect(0, 123023, '\p{^Is_Sc=		Cyrl}', "");
    Expect(0, 123023, '\P{Is_Sc=		Cyrl}', "");
    Expect(1, 123023, '\P{^Is_Sc=		Cyrl}', "");
    Expect(0, 123024, '\p{Is_Sc=		Cyrl}', "");
    Expect(1, 123024, '\p{^Is_Sc=		Cyrl}', "");
    Expect(1, 123024, '\P{Is_Sc=		Cyrl}', "");
    Expect(0, 123024, '\P{^Is_Sc=		Cyrl}', "");
    Error('\p{Script=:=_devanagari}');
    Error('\P{Script=:=_devanagari}');
    Expect(1, 72457, '\p{Script=:\ADevanagari\z:}', "");;
    Expect(0, 72458, '\p{Script=:\ADevanagari\z:}', "");;
    Expect(1, 72457, '\p{Script=devanagari}', "");
    Expect(0, 72457, '\p{^Script=devanagari}', "");
    Expect(0, 72457, '\P{Script=devanagari}', "");
    Expect(1, 72457, '\P{^Script=devanagari}', "");
    Expect(0, 72458, '\p{Script=devanagari}', "");
    Expect(1, 72458, '\p{^Script=devanagari}', "");
    Expect(1, 72458, '\P{Script=devanagari}', "");
    Expect(0, 72458, '\P{^Script=devanagari}', "");
    Expect(1, 72457, '\p{Script=:\Adevanagari\z:}', "");;
    Expect(0, 72458, '\p{Script=:\Adevanagari\z:}', "");;
    Expect(1, 72457, '\p{Script=  devanagari}', "");
    Expect(0, 72457, '\p{^Script=  devanagari}', "");
    Expect(0, 72457, '\P{Script=  devanagari}', "");
    Expect(1, 72457, '\P{^Script=  devanagari}', "");
    Expect(0, 72458, '\p{Script=  devanagari}', "");
    Expect(1, 72458, '\p{^Script=  devanagari}', "");
    Expect(1, 72458, '\P{Script=  devanagari}', "");
    Expect(0, 72458, '\P{^Script=  devanagari}', "");
    Error('\p{Sc=	_deva:=}');
    Error('\P{Sc=	_deva:=}');
    Expect(1, 72457, '\p{Sc=:\ADeva\z:}', "");;
    Expect(0, 72458, '\p{Sc=:\ADeva\z:}', "");;
    Expect(1, 72457, '\p{Sc=deva}', "");
    Expect(0, 72457, '\p{^Sc=deva}', "");
    Expect(0, 72457, '\P{Sc=deva}', "");
    Expect(1, 72457, '\P{^Sc=deva}', "");
    Expect(0, 72458, '\p{Sc=deva}', "");
    Expect(1, 72458, '\p{^Sc=deva}', "");
    Expect(1, 72458, '\P{Sc=deva}', "");
    Expect(0, 72458, '\P{^Sc=deva}', "");
    Expect(1, 72457, '\p{Sc=:\Adeva\z:}', "");;
    Expect(0, 72458, '\p{Sc=:\Adeva\z:}', "");;
    Expect(1, 72457, '\p{Sc=- Deva}', "");
    Expect(0, 72457, '\p{^Sc=- Deva}', "");
    Expect(0, 72457, '\P{Sc=- Deva}', "");
    Expect(1, 72457, '\P{^Sc=- Deva}', "");
    Expect(0, 72458, '\p{Sc=- Deva}', "");
    Expect(1, 72458, '\p{^Sc=- Deva}', "");
    Expect(1, 72458, '\P{Sc=- Deva}', "");
    Expect(0, 72458, '\P{^Sc=- Deva}', "");
    Error('\p{Is_Script=:= _DEVANAGARI}');
    Error('\P{Is_Script=:= _DEVANAGARI}');
    Expect(1, 72457, '\p{Is_Script:	devanagari}', "");
    Expect(0, 72457, '\p{^Is_Script:	devanagari}', "");
    Expect(0, 72457, '\P{Is_Script:	devanagari}', "");
    Expect(1, 72457, '\P{^Is_Script:	devanagari}', "");
    Expect(0, 72458, '\p{Is_Script:	devanagari}', "");
    Expect(1, 72458, '\p{^Is_Script:	devanagari}', "");
    Expect(1, 72458, '\P{Is_Script:	devanagari}', "");
    Expect(0, 72458, '\P{^Is_Script:	devanagari}', "");
    Expect(1, 72457, '\p{Is_Script=- DEVANAGARI}', "");
    Expect(0, 72457, '\p{^Is_Script=- DEVANAGARI}', "");
    Expect(0, 72457, '\P{Is_Script=- DEVANAGARI}', "");
    Expect(1, 72457, '\P{^Is_Script=- DEVANAGARI}', "");
    Expect(0, 72458, '\p{Is_Script=- DEVANAGARI}', "");
    Expect(1, 72458, '\p{^Is_Script=- DEVANAGARI}', "");
    Expect(1, 72458, '\P{Is_Script=- DEVANAGARI}', "");
    Expect(0, 72458, '\P{^Is_Script=- DEVANAGARI}', "");
    Error('\p{Is_Sc=/a/	 deva}');
    Error('\P{Is_Sc=/a/	 deva}');
    Expect(1, 72457, '\p{Is_Sc=deva}', "");
    Expect(0, 72457, '\p{^Is_Sc=deva}', "");
    Expect(0, 72457, '\P{Is_Sc=deva}', "");
    Expect(1, 72457, '\P{^Is_Sc=deva}', "");
    Expect(0, 72458, '\p{Is_Sc=deva}', "");
    Expect(1, 72458, '\p{^Is_Sc=deva}', "");
    Expect(1, 72458, '\P{Is_Sc=deva}', "");
    Expect(0, 72458, '\P{^Is_Sc=deva}', "");
    Expect(1, 72457, '\p{Is_Sc= 	Deva}', "");
    Expect(0, 72457, '\p{^Is_Sc= 	Deva}', "");
    Expect(0, 72457, '\P{Is_Sc= 	Deva}', "");
    Expect(1, 72457, '\P{^Is_Sc= 	Deva}', "");
    Expect(0, 72458, '\p{Is_Sc= 	Deva}', "");
    Expect(1, 72458, '\p{^Is_Sc= 	Deva}', "");
    Expect(1, 72458, '\P{Is_Sc= 	Deva}', "");
    Expect(0, 72458, '\P{^Is_Sc= 	Deva}', "");
    Error('\p{Script=_:=Dives_akuru}');
    Error('\P{Script=_:=Dives_akuru}');
    Expect(1, 72025, '\p{Script=:\ADives_Akuru\z:}', "");;
    Expect(0, 72026, '\p{Script=:\ADives_Akuru\z:}', "");;
    Expect(1, 72025, '\p{Script=divesakuru}', "");
    Expect(0, 72025, '\p{^Script=divesakuru}', "");
    Expect(0, 72025, '\P{Script=divesakuru}', "");
    Expect(1, 72025, '\P{^Script=divesakuru}', "");
    Expect(0, 72026, '\p{Script=divesakuru}', "");
    Expect(1, 72026, '\p{^Script=divesakuru}', "");
    Expect(1, 72026, '\P{Script=divesakuru}', "");
    Expect(0, 72026, '\P{^Script=divesakuru}', "");
    Expect(1, 72025, '\p{Script=:\Adivesakuru\z:}', "");;
    Expect(0, 72026, '\p{Script=:\Adivesakuru\z:}', "");;
    Expect(1, 72025, '\p{Script=-	Dives_akuru}', "");
    Expect(0, 72025, '\p{^Script=-	Dives_akuru}', "");
    Expect(0, 72025, '\P{Script=-	Dives_akuru}', "");
    Expect(1, 72025, '\P{^Script=-	Dives_akuru}', "");
    Expect(0, 72026, '\p{Script=-	Dives_akuru}', "");
    Expect(1, 72026, '\p{^Script=-	Dives_akuru}', "");
    Expect(1, 72026, '\P{Script=-	Dives_akuru}', "");
    Expect(0, 72026, '\P{^Script=-	Dives_akuru}', "");
    Error('\p{Sc=-diak/a/}');
    Error('\P{Sc=-diak/a/}');
    Expect(1, 72025, '\p{Sc=:\ADiak\z:}', "");;
    Expect(0, 72026, '\p{Sc=:\ADiak\z:}', "");;
    Expect(1, 72025, '\p{Sc=diak}', "");
    Expect(0, 72025, '\p{^Sc=diak}', "");
    Expect(0, 72025, '\P{Sc=diak}', "");
    Expect(1, 72025, '\P{^Sc=diak}', "");
    Expect(0, 72026, '\p{Sc=diak}', "");
    Expect(1, 72026, '\p{^Sc=diak}', "");
    Expect(1, 72026, '\P{Sc=diak}', "");
    Expect(0, 72026, '\P{^Sc=diak}', "");
    Expect(1, 72025, '\p{Sc=:\Adiak\z:}', "");;
    Expect(0, 72026, '\p{Sc=:\Adiak\z:}', "");;
    Expect(1, 72025, '\p{Sc=	-DIAK}', "");
    Expect(0, 72025, '\p{^Sc=	-DIAK}', "");
    Expect(0, 72025, '\P{Sc=	-DIAK}', "");
    Expect(1, 72025, '\P{^Sc=	-DIAK}', "");
    Expect(0, 72026, '\p{Sc=	-DIAK}', "");
    Expect(1, 72026, '\p{^Sc=	-DIAK}', "");
    Expect(1, 72026, '\P{Sc=	-DIAK}', "");
    Expect(0, 72026, '\P{^Sc=	-DIAK}', "");
    Error('\p{Is_Script= _Dives_AKURU:=}');
    Error('\P{Is_Script= _Dives_AKURU:=}');
    Expect(1, 72025, '\p{Is_Script=divesakuru}', "");
    Expect(0, 72025, '\p{^Is_Script=divesakuru}', "");
    Expect(0, 72025, '\P{Is_Script=divesakuru}', "");
    Expect(1, 72025, '\P{^Is_Script=divesakuru}', "");
    Expect(0, 72026, '\p{Is_Script=divesakuru}', "");
    Expect(1, 72026, '\p{^Is_Script=divesakuru}', "");
    Expect(1, 72026, '\P{Is_Script=divesakuru}', "");
    Expect(0, 72026, '\P{^Is_Script=divesakuru}', "");
    Expect(1, 72025, '\p{Is_Script=-_dives_akuru}', "");
    Expect(0, 72025, '\p{^Is_Script=-_dives_akuru}', "");
    Expect(0, 72025, '\P{Is_Script=-_dives_akuru}', "");
    Expect(1, 72025, '\P{^Is_Script=-_dives_akuru}', "");
    Expect(0, 72026, '\p{Is_Script=-_dives_akuru}', "");
    Expect(1, 72026, '\p{^Is_Script=-_dives_akuru}', "");
    Expect(1, 72026, '\P{Is_Script=-_dives_akuru}', "");
    Expect(0, 72026, '\P{^Is_Script=-_dives_akuru}', "");
    Error('\p{Is_Sc=-:=Diak}');
    Error('\P{Is_Sc=-:=Diak}');
    Expect(1, 72025, '\p{Is_Sc=diak}', "");
    Expect(0, 72025, '\p{^Is_Sc=diak}', "");
    Expect(0, 72025, '\P{Is_Sc=diak}', "");
    Expect(1, 72025, '\P{^Is_Sc=diak}', "");
    Expect(0, 72026, '\p{Is_Sc=diak}', "");
    Expect(1, 72026, '\p{^Is_Sc=diak}', "");
    Expect(1, 72026, '\P{Is_Sc=diak}', "");
    Expect(0, 72026, '\P{^Is_Sc=diak}', "");
    Expect(1, 72025, '\p{Is_Sc=	_Diak}', "");
    Expect(0, 72025, '\p{^Is_Sc=	_Diak}', "");
    Expect(0, 72025, '\P{Is_Sc=	_Diak}', "");
    Expect(1, 72025, '\P{^Is_Sc=	_Diak}', "");
    Expect(0, 72026, '\p{Is_Sc=	_Diak}', "");
    Expect(1, 72026, '\p{^Is_Sc=	_Diak}', "");
    Expect(1, 72026, '\P{Is_Sc=	_Diak}', "");
    Expect(0, 72026, '\P{^Is_Sc=	_Diak}', "");
    Error('\p{Script=_:=Dogra}');
    Error('\P{Script=_:=Dogra}');
    Expect(1, 71739, '\p{Script=:\ADogra\z:}', "");;
    Expect(0, 71740, '\p{Script=:\ADogra\z:}', "");;
    Expect(1, 71739, '\p{Script=dogra}', "");
    Expect(0, 71739, '\p{^Script=dogra}', "");
    Expect(0, 71739, '\P{Script=dogra}', "");
    Expect(1, 71739, '\P{^Script=dogra}', "");
    Expect(0, 71740, '\p{Script=dogra}', "");
    Expect(1, 71740, '\p{^Script=dogra}', "");
    Expect(1, 71740, '\P{Script=dogra}', "");
    Expect(0, 71740, '\P{^Script=dogra}', "");
    Expect(1, 71739, '\p{Script=:\Adogra\z:}', "");;
    Expect(0, 71740, '\p{Script=:\Adogra\z:}', "");;
    Expect(1, 71739, '\p{Script= _Dogra}', "");
    Expect(0, 71739, '\p{^Script= _Dogra}', "");
    Expect(0, 71739, '\P{Script= _Dogra}', "");
    Expect(1, 71739, '\P{^Script= _Dogra}', "");
    Expect(0, 71740, '\p{Script= _Dogra}', "");
    Expect(1, 71740, '\p{^Script= _Dogra}', "");
    Expect(1, 71740, '\P{Script= _Dogra}', "");
    Expect(0, 71740, '\P{^Script= _Dogra}', "");
    Error('\p{Sc=-dogr:=}');
    Error('\P{Sc=-dogr:=}');
    Expect(1, 71739, '\p{Sc=:\ADogr\z:}', "");;
    Expect(0, 71740, '\p{Sc=:\ADogr\z:}', "");;
    Expect(1, 71739, '\p{Sc=dogr}', "");
    Expect(0, 71739, '\p{^Sc=dogr}', "");
    Expect(0, 71739, '\P{Sc=dogr}', "");
    Expect(1, 71739, '\P{^Sc=dogr}', "");
    Expect(0, 71740, '\p{Sc=dogr}', "");
    Expect(1, 71740, '\p{^Sc=dogr}', "");
    Expect(1, 71740, '\P{Sc=dogr}', "");
    Expect(0, 71740, '\P{^Sc=dogr}', "");
    Expect(1, 71739, '\p{Sc=:\Adogr\z:}', "");;
    Expect(0, 71740, '\p{Sc=:\Adogr\z:}', "");;
    Expect(1, 71739, '\p{Sc=	Dogr}', "");
    Expect(0, 71739, '\p{^Sc=	Dogr}', "");
    Expect(0, 71739, '\P{Sc=	Dogr}', "");
    Expect(1, 71739, '\P{^Sc=	Dogr}', "");
    Expect(0, 71740, '\p{Sc=	Dogr}', "");
    Expect(1, 71740, '\p{^Sc=	Dogr}', "");
    Expect(1, 71740, '\P{Sc=	Dogr}', "");
    Expect(0, 71740, '\P{^Sc=	Dogr}', "");
    Error('\p{Is_Script=:=DOGRA}');
    Error('\P{Is_Script=:=DOGRA}');
    Expect(1, 71739, '\p{Is_Script=dogra}', "");
    Expect(0, 71739, '\p{^Is_Script=dogra}', "");
    Expect(0, 71739, '\P{Is_Script=dogra}', "");
    Expect(1, 71739, '\P{^Is_Script=dogra}', "");
    Expect(0, 71740, '\p{Is_Script=dogra}', "");
    Expect(1, 71740, '\p{^Is_Script=dogra}', "");
    Expect(1, 71740, '\P{Is_Script=dogra}', "");
    Expect(0, 71740, '\P{^Is_Script=dogra}', "");
    Expect(1, 71739, '\p{Is_Script=_Dogra}', "");
    Expect(0, 71739, '\p{^Is_Script=_Dogra}', "");
    Expect(0, 71739, '\P{Is_Script=_Dogra}', "");
    Expect(1, 71739, '\P{^Is_Script=_Dogra}', "");
    Expect(0, 71740, '\p{Is_Script=_Dogra}', "");
    Expect(1, 71740, '\p{^Is_Script=_Dogra}', "");
    Expect(1, 71740, '\P{Is_Script=_Dogra}', "");
    Expect(0, 71740, '\P{^Is_Script=_Dogra}', "");
    Error('\p{Is_Sc= :=Dogr}');
    Error('\P{Is_Sc= :=Dogr}');
    Expect(1, 71739, '\p{Is_Sc=dogr}', "");
    Expect(0, 71739, '\p{^Is_Sc=dogr}', "");
    Expect(0, 71739, '\P{Is_Sc=dogr}', "");
    Expect(1, 71739, '\P{^Is_Sc=dogr}', "");
    Expect(0, 71740, '\p{Is_Sc=dogr}', "");
    Expect(1, 71740, '\p{^Is_Sc=dogr}', "");
    Expect(1, 71740, '\P{Is_Sc=dogr}', "");
    Expect(0, 71740, '\P{^Is_Sc=dogr}', "");
    Expect(1, 71739, '\p{Is_Sc=-Dogr}', "");
    Expect(0, 71739, '\p{^Is_Sc=-Dogr}', "");
    Expect(0, 71739, '\P{Is_Sc=-Dogr}', "");
    Expect(1, 71739, '\P{^Is_Sc=-Dogr}', "");
    Expect(0, 71740, '\p{Is_Sc=-Dogr}', "");
    Expect(1, 71740, '\p{^Is_Sc=-Dogr}', "");
    Expect(1, 71740, '\P{Is_Sc=-Dogr}', "");
    Expect(0, 71740, '\P{^Is_Sc=-Dogr}', "");
    Error('\p{Script:	/a/-deseret}');
    Error('\P{Script:	/a/-deseret}');
    Expect(1, 66639, '\p{Script=:\ADeseret\z:}', "");;
    Expect(0, 66640, '\p{Script=:\ADeseret\z:}', "");;
    Expect(1, 66639, '\p{Script=deseret}', "");
    Expect(0, 66639, '\p{^Script=deseret}', "");
    Expect(0, 66639, '\P{Script=deseret}', "");
    Expect(1, 66639, '\P{^Script=deseret}', "");
    Expect(0, 66640, '\p{Script=deseret}', "");
    Expect(1, 66640, '\p{^Script=deseret}', "");
    Expect(1, 66640, '\P{Script=deseret}', "");
    Expect(0, 66640, '\P{^Script=deseret}', "");
    Expect(1, 66639, '\p{Script=:\Adeseret\z:}', "");;
    Expect(0, 66640, '\p{Script=:\Adeseret\z:}', "");;
    Expect(1, 66639, '\p{Script=-_DESERET}', "");
    Expect(0, 66639, '\p{^Script=-_DESERET}', "");
    Expect(0, 66639, '\P{Script=-_DESERET}', "");
    Expect(1, 66639, '\P{^Script=-_DESERET}', "");
    Expect(0, 66640, '\p{Script=-_DESERET}', "");
    Expect(1, 66640, '\p{^Script=-_DESERET}', "");
    Expect(1, 66640, '\P{Script=-_DESERET}', "");
    Expect(0, 66640, '\P{^Script=-_DESERET}', "");
    Error('\p{Sc=/a/	 Dsrt}');
    Error('\P{Sc=/a/	 Dsrt}');
    Expect(1, 66639, '\p{Sc=:\ADsrt\z:}', "");;
    Expect(0, 66640, '\p{Sc=:\ADsrt\z:}', "");;
    Expect(1, 66639, '\p{Sc=dsrt}', "");
    Expect(0, 66639, '\p{^Sc=dsrt}', "");
    Expect(0, 66639, '\P{Sc=dsrt}', "");
    Expect(1, 66639, '\P{^Sc=dsrt}', "");
    Expect(0, 66640, '\p{Sc=dsrt}', "");
    Expect(1, 66640, '\p{^Sc=dsrt}', "");
    Expect(1, 66640, '\P{Sc=dsrt}', "");
    Expect(0, 66640, '\P{^Sc=dsrt}', "");
    Expect(1, 66639, '\p{Sc=:\Adsrt\z:}', "");;
    Expect(0, 66640, '\p{Sc=:\Adsrt\z:}', "");;
    Expect(1, 66639, '\p{Sc=--DSRT}', "");
    Expect(0, 66639, '\p{^Sc=--DSRT}', "");
    Expect(0, 66639, '\P{Sc=--DSRT}', "");
    Expect(1, 66639, '\P{^Sc=--DSRT}', "");
    Expect(0, 66640, '\p{Sc=--DSRT}', "");
    Expect(1, 66640, '\p{^Sc=--DSRT}', "");
    Expect(1, 66640, '\P{Sc=--DSRT}', "");
    Expect(0, 66640, '\P{^Sc=--DSRT}', "");
    Error('\p{Is_Script=/a/	DESERET}');
    Error('\P{Is_Script=/a/	DESERET}');
    Expect(1, 66639, '\p{Is_Script=deseret}', "");
    Expect(0, 66639, '\p{^Is_Script=deseret}', "");
    Expect(0, 66639, '\P{Is_Script=deseret}', "");
    Expect(1, 66639, '\P{^Is_Script=deseret}', "");
    Expect(0, 66640, '\p{Is_Script=deseret}', "");
    Expect(1, 66640, '\p{^Is_Script=deseret}', "");
    Expect(1, 66640, '\P{Is_Script=deseret}', "");
    Expect(0, 66640, '\P{^Is_Script=deseret}', "");
    Expect(1, 66639, '\p{Is_Script= 	Deseret}', "");
    Expect(0, 66639, '\p{^Is_Script= 	Deseret}', "");
    Expect(0, 66639, '\P{Is_Script= 	Deseret}', "");
    Expect(1, 66639, '\P{^Is_Script= 	Deseret}', "");
    Expect(0, 66640, '\p{Is_Script= 	Deseret}', "");
    Expect(1, 66640, '\p{^Is_Script= 	Deseret}', "");
    Expect(1, 66640, '\P{Is_Script= 	Deseret}', "");
    Expect(0, 66640, '\P{^Is_Script= 	Deseret}', "");
    Error('\p{Is_Sc=-Dsrt:=}');
    Error('\P{Is_Sc=-Dsrt:=}');
    Expect(1, 66639, '\p{Is_Sc=dsrt}', "");
    Expect(0, 66639, '\p{^Is_Sc=dsrt}', "");
    Expect(0, 66639, '\P{Is_Sc=dsrt}', "");
    Expect(1, 66639, '\P{^Is_Sc=dsrt}', "");
    Expect(0, 66640, '\p{Is_Sc=dsrt}', "");
    Expect(1, 66640, '\p{^Is_Sc=dsrt}', "");
    Expect(1, 66640, '\P{Is_Sc=dsrt}', "");
    Expect(0, 66640, '\P{^Is_Sc=dsrt}', "");
    Expect(1, 66639, '\p{Is_Sc=  Dsrt}', "");
    Expect(0, 66639, '\p{^Is_Sc=  Dsrt}', "");
    Expect(0, 66639, '\P{Is_Sc=  Dsrt}', "");
    Expect(1, 66639, '\P{^Is_Sc=  Dsrt}', "");
    Expect(0, 66640, '\p{Is_Sc=  Dsrt}', "");
    Expect(1, 66640, '\p{^Is_Sc=  Dsrt}', "");
    Expect(1, 66640, '\P{Is_Sc=  Dsrt}', "");
    Expect(0, 66640, '\P{^Is_Sc=  Dsrt}', "");
    Error('\p{Script= /a/duployan}');
    Error('\P{Script= /a/duployan}');
    Expect(1, 113823, '\p{Script=:\ADuployan\z:}', "");;
    Expect(0, 113824, '\p{Script=:\ADuployan\z:}', "");;
    Expect(1, 113823, '\p{Script=duployan}', "");
    Expect(0, 113823, '\p{^Script=duployan}', "");
    Expect(0, 113823, '\P{Script=duployan}', "");
    Expect(1, 113823, '\P{^Script=duployan}', "");
    Expect(0, 113824, '\p{Script=duployan}', "");
    Expect(1, 113824, '\p{^Script=duployan}', "");
    Expect(1, 113824, '\P{Script=duployan}', "");
    Expect(0, 113824, '\P{^Script=duployan}', "");
    Expect(1, 113823, '\p{Script=:\Aduployan\z:}', "");;
    Expect(0, 113824, '\p{Script=:\Aduployan\z:}', "");;
    Expect(1, 113823, '\p{Script=	_DUPLOYAN}', "");
    Expect(0, 113823, '\p{^Script=	_DUPLOYAN}', "");
    Expect(0, 113823, '\P{Script=	_DUPLOYAN}', "");
    Expect(1, 113823, '\P{^Script=	_DUPLOYAN}', "");
    Expect(0, 113824, '\p{Script=	_DUPLOYAN}', "");
    Expect(1, 113824, '\p{^Script=	_DUPLOYAN}', "");
    Expect(1, 113824, '\P{Script=	_DUPLOYAN}', "");
    Expect(0, 113824, '\P{^Script=	_DUPLOYAN}', "");
    Error('\p{Sc=/a/_-DUPL}');
    Error('\P{Sc=/a/_-DUPL}');
    Expect(1, 113823, '\p{Sc=:\ADupl\z:}', "");;
    Expect(0, 113824, '\p{Sc=:\ADupl\z:}', "");;
    Expect(1, 113823, '\p{Sc=dupl}', "");
    Expect(0, 113823, '\p{^Sc=dupl}', "");
    Expect(0, 113823, '\P{Sc=dupl}', "");
    Expect(1, 113823, '\P{^Sc=dupl}', "");
    Expect(0, 113824, '\p{Sc=dupl}', "");
    Expect(1, 113824, '\p{^Sc=dupl}', "");
    Expect(1, 113824, '\P{Sc=dupl}', "");
    Expect(0, 113824, '\P{^Sc=dupl}', "");
    Expect(1, 113823, '\p{Sc=:\Adupl\z:}', "");;
    Expect(0, 113824, '\p{Sc=:\Adupl\z:}', "");;
    Expect(1, 113823, '\p{Sc=	 dupl}', "");
    Expect(0, 113823, '\p{^Sc=	 dupl}', "");
    Expect(0, 113823, '\P{Sc=	 dupl}', "");
    Expect(1, 113823, '\P{^Sc=	 dupl}', "");
    Expect(0, 113824, '\p{Sc=	 dupl}', "");
    Expect(1, 113824, '\p{^Sc=	 dupl}', "");
    Expect(1, 113824, '\P{Sc=	 dupl}', "");
    Expect(0, 113824, '\P{^Sc=	 dupl}', "");
    Error('\p{Is_Script=:=_-Duployan}');
    Error('\P{Is_Script=:=_-Duployan}');
    Expect(1, 113823, '\p{Is_Script=duployan}', "");
    Expect(0, 113823, '\p{^Is_Script=duployan}', "");
    Expect(0, 113823, '\P{Is_Script=duployan}', "");
    Expect(1, 113823, '\P{^Is_Script=duployan}', "");
    Expect(0, 113824, '\p{Is_Script=duployan}', "");
    Expect(1, 113824, '\p{^Is_Script=duployan}', "");
    Expect(1, 113824, '\P{Is_Script=duployan}', "");
    Expect(0, 113824, '\P{^Is_Script=duployan}', "");
    Expect(1, 113823, '\p{Is_Script=__Duployan}', "");
    Expect(0, 113823, '\p{^Is_Script=__Duployan}', "");
    Expect(0, 113823, '\P{Is_Script=__Duployan}', "");
    Expect(1, 113823, '\P{^Is_Script=__Duployan}', "");
    Expect(0, 113824, '\p{Is_Script=__Duployan}', "");
    Expect(1, 113824, '\p{^Is_Script=__Duployan}', "");
    Expect(1, 113824, '\P{Is_Script=__Duployan}', "");
    Expect(0, 113824, '\P{^Is_Script=__Duployan}', "");
    Error('\p{Is_Sc=:=Dupl}');
    Error('\P{Is_Sc=:=Dupl}');
    Expect(1, 113823, '\p{Is_Sc:	dupl}', "");
    Expect(0, 113823, '\p{^Is_Sc:	dupl}', "");
    Expect(0, 113823, '\P{Is_Sc:	dupl}', "");
    Expect(1, 113823, '\P{^Is_Sc:	dupl}', "");
    Expect(0, 113824, '\p{Is_Sc:	dupl}', "");
    Expect(1, 113824, '\p{^Is_Sc:	dupl}', "");
    Expect(1, 113824, '\P{Is_Sc:	dupl}', "");
    Expect(0, 113824, '\P{^Is_Sc:	dupl}', "");
    Expect(1, 113823, '\p{Is_Sc= Dupl}', "");
    Expect(0, 113823, '\p{^Is_Sc= Dupl}', "");
    Expect(0, 113823, '\P{Is_Sc= Dupl}', "");
    Expect(1, 113823, '\P{^Is_Sc= Dupl}', "");
    Expect(0, 113824, '\p{Is_Sc= Dupl}', "");
    Expect(1, 113824, '\p{^Is_Sc= Dupl}', "");
    Expect(1, 113824, '\P{Is_Sc= Dupl}', "");
    Expect(0, 113824, '\P{^Is_Sc= Dupl}', "");
    Error('\p{Script=:=	Egyptian_Hieroglyphs}');
    Error('\P{Script=:=	Egyptian_Hieroglyphs}');
    Expect(1, 78933, '\p{Script=:\AEgyptian_Hieroglyphs\z:}', "");;
    Expect(0, 78934, '\p{Script=:\AEgyptian_Hieroglyphs\z:}', "");;
    Expect(1, 78933, '\p{Script=egyptianhieroglyphs}', "");
    Expect(0, 78933, '\p{^Script=egyptianhieroglyphs}', "");
    Expect(0, 78933, '\P{Script=egyptianhieroglyphs}', "");
    Expect(1, 78933, '\P{^Script=egyptianhieroglyphs}', "");
    Expect(0, 78934, '\p{Script=egyptianhieroglyphs}', "");
    Expect(1, 78934, '\p{^Script=egyptianhieroglyphs}', "");
    Expect(1, 78934, '\P{Script=egyptianhieroglyphs}', "");
    Expect(0, 78934, '\P{^Script=egyptianhieroglyphs}', "");
    Expect(1, 78933, '\p{Script=:\Aegyptianhieroglyphs\z:}', "");;
    Expect(0, 78934, '\p{Script=:\Aegyptianhieroglyphs\z:}', "");;
    Expect(1, 78933, '\p{Script=	EGYPTIAN_HIEROGLYPHS}', "");
    Expect(0, 78933, '\p{^Script=	EGYPTIAN_HIEROGLYPHS}', "");
    Expect(0, 78933, '\P{Script=	EGYPTIAN_HIEROGLYPHS}', "");
    Expect(1, 78933, '\P{^Script=	EGYPTIAN_HIEROGLYPHS}', "");
    Expect(0, 78934, '\p{Script=	EGYPTIAN_HIEROGLYPHS}', "");
    Expect(1, 78934, '\p{^Script=	EGYPTIAN_HIEROGLYPHS}', "");
    Expect(1, 78934, '\P{Script=	EGYPTIAN_HIEROGLYPHS}', "");
    Expect(0, 78934, '\P{^Script=	EGYPTIAN_HIEROGLYPHS}', "");
    Error('\p{Sc=/a/  EGYP}');
    Error('\P{Sc=/a/  EGYP}');
    Expect(1, 78933, '\p{Sc=:\AEgyp\z:}', "");;
    Expect(0, 78934, '\p{Sc=:\AEgyp\z:}', "");;
    Expect(1, 78933, '\p{Sc=egyp}', "");
    Expect(0, 78933, '\p{^Sc=egyp}', "");
    Expect(0, 78933, '\P{Sc=egyp}', "");
    Expect(1, 78933, '\P{^Sc=egyp}', "");
    Expect(0, 78934, '\p{Sc=egyp}', "");
    Expect(1, 78934, '\p{^Sc=egyp}', "");
    Expect(1, 78934, '\P{Sc=egyp}', "");
    Expect(0, 78934, '\P{^Sc=egyp}', "");
    Expect(1, 78933, '\p{Sc=:\Aegyp\z:}', "");;
    Expect(0, 78934, '\p{Sc=:\Aegyp\z:}', "");;
    Expect(1, 78933, '\p{Sc:  egyp}', "");
    Expect(0, 78933, '\p{^Sc:  egyp}', "");
    Expect(0, 78933, '\P{Sc:  egyp}', "");
    Expect(1, 78933, '\P{^Sc:  egyp}', "");
    Expect(0, 78934, '\p{Sc:  egyp}', "");
    Expect(1, 78934, '\p{^Sc:  egyp}', "");
    Expect(1, 78934, '\P{Sc:  egyp}', "");
    Expect(0, 78934, '\P{^Sc:  egyp}', "");
    Error('\p{Is_Script= -egyptian_Hieroglyphs/a/}');
    Error('\P{Is_Script= -egyptian_Hieroglyphs/a/}');
    Expect(1, 78933, '\p{Is_Script=egyptianhieroglyphs}', "");
    Expect(0, 78933, '\p{^Is_Script=egyptianhieroglyphs}', "");
    Expect(0, 78933, '\P{Is_Script=egyptianhieroglyphs}', "");
    Expect(1, 78933, '\P{^Is_Script=egyptianhieroglyphs}', "");
    Expect(0, 78934, '\p{Is_Script=egyptianhieroglyphs}', "");
    Expect(1, 78934, '\p{^Is_Script=egyptianhieroglyphs}', "");
    Expect(1, 78934, '\P{Is_Script=egyptianhieroglyphs}', "");
    Expect(0, 78934, '\P{^Is_Script=egyptianhieroglyphs}', "");
    Expect(1, 78933, '\p{Is_Script=-	egyptian_Hieroglyphs}', "");
    Expect(0, 78933, '\p{^Is_Script=-	egyptian_Hieroglyphs}', "");
    Expect(0, 78933, '\P{Is_Script=-	egyptian_Hieroglyphs}', "");
    Expect(1, 78933, '\P{^Is_Script=-	egyptian_Hieroglyphs}', "");
    Expect(0, 78934, '\p{Is_Script=-	egyptian_Hieroglyphs}', "");
    Expect(1, 78934, '\p{^Is_Script=-	egyptian_Hieroglyphs}', "");
    Expect(1, 78934, '\P{Is_Script=-	egyptian_Hieroglyphs}', "");
    Expect(0, 78934, '\P{^Is_Script=-	egyptian_Hieroglyphs}', "");
    Error('\p{Is_Sc=/a/	 EGYP}');
    Error('\P{Is_Sc=/a/	 EGYP}');
    Expect(1, 78933, '\p{Is_Sc=egyp}', "");
    Expect(0, 78933, '\p{^Is_Sc=egyp}', "");
    Expect(0, 78933, '\P{Is_Sc=egyp}', "");
    Expect(1, 78933, '\P{^Is_Sc=egyp}', "");
    Expect(0, 78934, '\p{Is_Sc=egyp}', "");
    Expect(1, 78934, '\p{^Is_Sc=egyp}', "");
    Expect(1, 78934, '\P{Is_Sc=egyp}', "");
    Expect(0, 78934, '\P{^Is_Sc=egyp}', "");
    Expect(1, 78933, '\p{Is_Sc=	-Egyp}', "");
    Expect(0, 78933, '\p{^Is_Sc=	-Egyp}', "");
    Expect(0, 78933, '\P{Is_Sc=	-Egyp}', "");
    Expect(1, 78933, '\P{^Is_Sc=	-Egyp}', "");
    Expect(0, 78934, '\p{Is_Sc=	-Egyp}', "");
    Expect(1, 78934, '\p{^Is_Sc=	-Egyp}', "");
    Expect(1, 78934, '\P{Is_Sc=	-Egyp}', "");
    Expect(0, 78934, '\P{^Is_Sc=	-Egyp}', "");
    Error('\p{Script=/a/ Elbasan}');
    Error('\P{Script=/a/ Elbasan}');
    Expect(1, 66855, '\p{Script=:\AElbasan\z:}', "");;
    Expect(0, 66856, '\p{Script=:\AElbasan\z:}', "");;
    Expect(1, 66855, '\p{Script=elbasan}', "");
    Expect(0, 66855, '\p{^Script=elbasan}', "");
    Expect(0, 66855, '\P{Script=elbasan}', "");
    Expect(1, 66855, '\P{^Script=elbasan}', "");
    Expect(0, 66856, '\p{Script=elbasan}', "");
    Expect(1, 66856, '\p{^Script=elbasan}', "");
    Expect(1, 66856, '\P{Script=elbasan}', "");
    Expect(0, 66856, '\P{^Script=elbasan}', "");
    Expect(1, 66855, '\p{Script=:\Aelbasan\z:}', "");;
    Expect(0, 66856, '\p{Script=:\Aelbasan\z:}', "");;
    Expect(1, 66855, '\p{Script=_ elbasan}', "");
    Expect(0, 66855, '\p{^Script=_ elbasan}', "");
    Expect(0, 66855, '\P{Script=_ elbasan}', "");
    Expect(1, 66855, '\P{^Script=_ elbasan}', "");
    Expect(0, 66856, '\p{Script=_ elbasan}', "");
    Expect(1, 66856, '\p{^Script=_ elbasan}', "");
    Expect(1, 66856, '\P{Script=_ elbasan}', "");
    Expect(0, 66856, '\P{^Script=_ elbasan}', "");
    Error('\p{Sc=:=-Elba}');
    Error('\P{Sc=:=-Elba}');
    Expect(1, 66855, '\p{Sc=:\AElba\z:}', "");;
    Expect(0, 66856, '\p{Sc=:\AElba\z:}', "");;
    Expect(1, 66855, '\p{Sc: elba}', "");
    Expect(0, 66855, '\p{^Sc: elba}', "");
    Expect(0, 66855, '\P{Sc: elba}', "");
    Expect(1, 66855, '\P{^Sc: elba}', "");
    Expect(0, 66856, '\p{Sc: elba}', "");
    Expect(1, 66856, '\p{^Sc: elba}', "");
    Expect(1, 66856, '\P{Sc: elba}', "");
    Expect(0, 66856, '\P{^Sc: elba}', "");
    Expect(1, 66855, '\p{Sc=:\Aelba\z:}', "");;
    Expect(0, 66856, '\p{Sc=:\Aelba\z:}', "");;
    Expect(1, 66855, '\p{Sc=	Elba}', "");
    Expect(0, 66855, '\p{^Sc=	Elba}', "");
    Expect(0, 66855, '\P{Sc=	Elba}', "");
    Expect(1, 66855, '\P{^Sc=	Elba}', "");
    Expect(0, 66856, '\p{Sc=	Elba}', "");
    Expect(1, 66856, '\p{^Sc=	Elba}', "");
    Expect(1, 66856, '\P{Sc=	Elba}', "");
    Expect(0, 66856, '\P{^Sc=	Elba}', "");
    Error('\p{Is_Script= Elbasan:=}');
    Error('\P{Is_Script= Elbasan:=}');
    Expect(1, 66855, '\p{Is_Script=elbasan}', "");
    Expect(0, 66855, '\p{^Is_Script=elbasan}', "");
    Expect(0, 66855, '\P{Is_Script=elbasan}', "");
    Expect(1, 66855, '\P{^Is_Script=elbasan}', "");
    Expect(0, 66856, '\p{Is_Script=elbasan}', "");
    Expect(1, 66856, '\p{^Is_Script=elbasan}', "");
    Expect(1, 66856, '\P{Is_Script=elbasan}', "");
    Expect(0, 66856, '\P{^Is_Script=elbasan}', "");
    Expect(1, 66855, '\p{Is_Script=	ELBASAN}', "");
    Expect(0, 66855, '\p{^Is_Script=	ELBASAN}', "");
    Expect(0, 66855, '\P{Is_Script=	ELBASAN}', "");
    Expect(1, 66855, '\P{^Is_Script=	ELBASAN}', "");
    Expect(0, 66856, '\p{Is_Script=	ELBASAN}', "");
    Expect(1, 66856, '\p{^Is_Script=	ELBASAN}', "");
    Expect(1, 66856, '\P{Is_Script=	ELBASAN}', "");
    Expect(0, 66856, '\P{^Is_Script=	ELBASAN}', "");
    Error('\p{Is_Sc=/a/_-Elba}');
    Error('\P{Is_Sc=/a/_-Elba}');
    Expect(1, 66855, '\p{Is_Sc=elba}', "");
    Expect(0, 66855, '\p{^Is_Sc=elba}', "");
    Expect(0, 66855, '\P{Is_Sc=elba}', "");
    Expect(1, 66855, '\P{^Is_Sc=elba}', "");
    Expect(0, 66856, '\p{Is_Sc=elba}', "");
    Expect(1, 66856, '\p{^Is_Sc=elba}', "");
    Expect(1, 66856, '\P{Is_Sc=elba}', "");
    Expect(0, 66856, '\P{^Is_Sc=elba}', "");
    Expect(1, 66855, '\p{Is_Sc:   _	elba}', "");
    Expect(0, 66855, '\p{^Is_Sc:   _	elba}', "");
    Expect(0, 66855, '\P{Is_Sc:   _	elba}', "");
    Expect(1, 66855, '\P{^Is_Sc:   _	elba}', "");
    Expect(0, 66856, '\p{Is_Sc:   _	elba}', "");
    Expect(1, 66856, '\p{^Is_Sc:   _	elba}', "");
    Expect(1, 66856, '\P{Is_Sc:   _	elba}', "");
    Expect(0, 66856, '\P{^Is_Sc:   _	elba}', "");
    Error('\p{Script= ELYMAIC/a/}');
    Error('\P{Script= ELYMAIC/a/}');
    Expect(1, 69622, '\p{Script=:\AElymaic\z:}', "");;
    Expect(0, 69623, '\p{Script=:\AElymaic\z:}', "");;
    Expect(1, 69622, '\p{Script:elymaic}', "");
    Expect(0, 69622, '\p{^Script:elymaic}', "");
    Expect(0, 69622, '\P{Script:elymaic}', "");
    Expect(1, 69622, '\P{^Script:elymaic}', "");
    Expect(0, 69623, '\p{Script:elymaic}', "");
    Expect(1, 69623, '\p{^Script:elymaic}', "");
    Expect(1, 69623, '\P{Script:elymaic}', "");
    Expect(0, 69623, '\P{^Script:elymaic}', "");
    Expect(1, 69622, '\p{Script=:\Aelymaic\z:}', "");;
    Expect(0, 69623, '\p{Script=:\Aelymaic\z:}', "");;
    Expect(1, 69622, '\p{Script=-	elymaic}', "");
    Expect(0, 69622, '\p{^Script=-	elymaic}', "");
    Expect(0, 69622, '\P{Script=-	elymaic}', "");
    Expect(1, 69622, '\P{^Script=-	elymaic}', "");
    Expect(0, 69623, '\p{Script=-	elymaic}', "");
    Expect(1, 69623, '\p{^Script=-	elymaic}', "");
    Expect(1, 69623, '\P{Script=-	elymaic}', "");
    Expect(0, 69623, '\P{^Script=-	elymaic}', "");
    Error('\p{Sc=	 Elym/a/}');
    Error('\P{Sc=	 Elym/a/}');
    Expect(1, 69622, '\p{Sc=:\AElym\z:}', "");;
    Expect(0, 69623, '\p{Sc=:\AElym\z:}', "");;
    Expect(1, 69622, '\p{Sc=elym}', "");
    Expect(0, 69622, '\p{^Sc=elym}', "");
    Expect(0, 69622, '\P{Sc=elym}', "");
    Expect(1, 69622, '\P{^Sc=elym}', "");
    Expect(0, 69623, '\p{Sc=elym}', "");
    Expect(1, 69623, '\p{^Sc=elym}', "");
    Expect(1, 69623, '\P{Sc=elym}', "");
    Expect(0, 69623, '\P{^Sc=elym}', "");
    Expect(1, 69622, '\p{Sc=:\Aelym\z:}', "");;
    Expect(0, 69623, '\p{Sc=:\Aelym\z:}', "");;
    Expect(1, 69622, '\p{Sc=--elym}', "");
    Expect(0, 69622, '\p{^Sc=--elym}', "");
    Expect(0, 69622, '\P{Sc=--elym}', "");
    Expect(1, 69622, '\P{^Sc=--elym}', "");
    Expect(0, 69623, '\p{Sc=--elym}', "");
    Expect(1, 69623, '\p{^Sc=--elym}', "");
    Expect(1, 69623, '\P{Sc=--elym}', "");
    Expect(0, 69623, '\P{^Sc=--elym}', "");
    Error('\p{Is_Script=:=Elymaic}');
    Error('\P{Is_Script=:=Elymaic}');
    Expect(1, 69622, '\p{Is_Script=elymaic}', "");
    Expect(0, 69622, '\p{^Is_Script=elymaic}', "");
    Expect(0, 69622, '\P{Is_Script=elymaic}', "");
    Expect(1, 69622, '\P{^Is_Script=elymaic}', "");
    Expect(0, 69623, '\p{Is_Script=elymaic}', "");
    Expect(1, 69623, '\p{^Is_Script=elymaic}', "");
    Expect(1, 69623, '\P{Is_Script=elymaic}', "");
    Expect(0, 69623, '\P{^Is_Script=elymaic}', "");
    Expect(1, 69622, '\p{Is_Script: _elymaic}', "");
    Expect(0, 69622, '\p{^Is_Script: _elymaic}', "");
    Expect(0, 69622, '\P{Is_Script: _elymaic}', "");
    Expect(1, 69622, '\P{^Is_Script: _elymaic}', "");
    Expect(0, 69623, '\p{Is_Script: _elymaic}', "");
    Expect(1, 69623, '\p{^Is_Script: _elymaic}', "");
    Expect(1, 69623, '\P{Is_Script: _elymaic}', "");
    Expect(0, 69623, '\P{^Is_Script: _elymaic}', "");
    Error('\p{Is_Sc: :=	-ELYM}');
    Error('\P{Is_Sc: :=	-ELYM}');
    Expect(1, 69622, '\p{Is_Sc=elym}', "");
    Expect(0, 69622, '\p{^Is_Sc=elym}', "");
    Expect(0, 69622, '\P{Is_Sc=elym}', "");
    Expect(1, 69622, '\P{^Is_Sc=elym}', "");
    Expect(0, 69623, '\p{Is_Sc=elym}', "");
    Expect(1, 69623, '\p{^Is_Sc=elym}', "");
    Expect(1, 69623, '\P{Is_Sc=elym}', "");
    Expect(0, 69623, '\P{^Is_Sc=elym}', "");
    Expect(1, 69622, '\p{Is_Sc=-ELYM}', "");
    Expect(0, 69622, '\p{^Is_Sc=-ELYM}', "");
    Expect(0, 69622, '\P{Is_Sc=-ELYM}', "");
    Expect(1, 69622, '\P{^Is_Sc=-ELYM}', "");
    Expect(0, 69623, '\p{Is_Sc=-ELYM}', "");
    Expect(1, 69623, '\p{^Is_Sc=-ELYM}', "");
    Expect(1, 69623, '\P{Is_Sc=-ELYM}', "");
    Expect(0, 69623, '\P{^Is_Sc=-ELYM}', "");
    Error('\p{Script=/a/-ethiopic}');
    Error('\P{Script=/a/-ethiopic}');
    Expect(1, 124926, '\p{Script=:\AEthiopic\z:}', "");;
    Expect(0, 124927, '\p{Script=:\AEthiopic\z:}', "");;
    Expect(1, 124926, '\p{Script=ethiopic}', "");
    Expect(0, 124926, '\p{^Script=ethiopic}', "");
    Expect(0, 124926, '\P{Script=ethiopic}', "");
    Expect(1, 124926, '\P{^Script=ethiopic}', "");
    Expect(0, 124927, '\p{Script=ethiopic}', "");
    Expect(1, 124927, '\p{^Script=ethiopic}', "");
    Expect(1, 124927, '\P{Script=ethiopic}', "");
    Expect(0, 124927, '\P{^Script=ethiopic}', "");
    Expect(1, 124926, '\p{Script=:\Aethiopic\z:}', "");;
    Expect(0, 124927, '\p{Script=:\Aethiopic\z:}', "");;
    Expect(1, 124926, '\p{Script:   - Ethiopic}', "");
    Expect(0, 124926, '\p{^Script:   - Ethiopic}', "");
    Expect(0, 124926, '\P{Script:   - Ethiopic}', "");
    Expect(1, 124926, '\P{^Script:   - Ethiopic}', "");
    Expect(0, 124927, '\p{Script:   - Ethiopic}', "");
    Expect(1, 124927, '\p{^Script:   - Ethiopic}', "");
    Expect(1, 124927, '\P{Script:   - Ethiopic}', "");
    Expect(0, 124927, '\P{^Script:   - Ethiopic}', "");
    Error('\p{Sc=/a/-ETHI}');
    Error('\P{Sc=/a/-ETHI}');
    Expect(1, 124926, '\p{Sc=:\AEthi\z:}', "");;
    Expect(0, 124927, '\p{Sc=:\AEthi\z:}', "");;
    Expect(1, 124926, '\p{Sc=ethi}', "");
    Expect(0, 124926, '\p{^Sc=ethi}', "");
    Expect(0, 124926, '\P{Sc=ethi}', "");
    Expect(1, 124926, '\P{^Sc=ethi}', "");
    Expect(0, 124927, '\p{Sc=ethi}', "");
    Expect(1, 124927, '\p{^Sc=ethi}', "");
    Expect(1, 124927, '\P{Sc=ethi}', "");
    Expect(0, 124927, '\P{^Sc=ethi}', "");
    Expect(1, 124926, '\p{Sc=:\Aethi\z:}', "");;
    Expect(0, 124927, '\p{Sc=:\Aethi\z:}', "");;
    Expect(1, 124926, '\p{Sc= -Ethi}', "");
    Expect(0, 124926, '\p{^Sc= -Ethi}', "");
    Expect(0, 124926, '\P{Sc= -Ethi}', "");
    Expect(1, 124926, '\P{^Sc= -Ethi}', "");
    Expect(0, 124927, '\p{Sc= -Ethi}', "");
    Expect(1, 124927, '\p{^Sc= -Ethi}', "");
    Expect(1, 124927, '\P{Sc= -Ethi}', "");
    Expect(0, 124927, '\P{^Sc= -Ethi}', "");
    Error('\p{Is_Script=/a/	_Ethiopic}');
    Error('\P{Is_Script=/a/	_Ethiopic}');
    Expect(1, 124926, '\p{Is_Script=ethiopic}', "");
    Expect(0, 124926, '\p{^Is_Script=ethiopic}', "");
    Expect(0, 124926, '\P{Is_Script=ethiopic}', "");
    Expect(1, 124926, '\P{^Is_Script=ethiopic}', "");
    Expect(0, 124927, '\p{Is_Script=ethiopic}', "");
    Expect(1, 124927, '\p{^Is_Script=ethiopic}', "");
    Expect(1, 124927, '\P{Is_Script=ethiopic}', "");
    Expect(0, 124927, '\P{^Is_Script=ethiopic}', "");
    Expect(1, 124926, '\p{Is_Script=_-Ethiopic}', "");
    Expect(0, 124926, '\p{^Is_Script=_-Ethiopic}', "");
    Expect(0, 124926, '\P{Is_Script=_-Ethiopic}', "");
    Expect(1, 124926, '\P{^Is_Script=_-Ethiopic}', "");
    Expect(0, 124927, '\p{Is_Script=_-Ethiopic}', "");
    Expect(1, 124927, '\p{^Is_Script=_-Ethiopic}', "");
    Expect(1, 124927, '\P{Is_Script=_-Ethiopic}', "");
    Expect(0, 124927, '\P{^Is_Script=_-Ethiopic}', "");
    Error('\p{Is_Sc=:=_	ETHI}');
    Error('\P{Is_Sc=:=_	ETHI}');
    Expect(1, 124926, '\p{Is_Sc:   ethi}', "");
    Expect(0, 124926, '\p{^Is_Sc:   ethi}', "");
    Expect(0, 124926, '\P{Is_Sc:   ethi}', "");
    Expect(1, 124926, '\P{^Is_Sc:   ethi}', "");
    Expect(0, 124927, '\p{Is_Sc:   ethi}', "");
    Expect(1, 124927, '\p{^Is_Sc:   ethi}', "");
    Expect(1, 124927, '\P{Is_Sc:   ethi}', "");
    Expect(0, 124927, '\P{^Is_Sc:   ethi}', "");
    Expect(1, 124926, '\p{Is_Sc=ETHI}', "");
    Expect(0, 124926, '\p{^Is_Sc=ETHI}', "");
    Expect(0, 124926, '\P{Is_Sc=ETHI}', "");
    Expect(1, 124926, '\P{^Is_Sc=ETHI}', "");
    Expect(0, 124927, '\p{Is_Sc=ETHI}', "");
    Expect(1, 124927, '\p{^Is_Sc=ETHI}', "");
    Expect(1, 124927, '\P{Is_Sc=ETHI}', "");
    Expect(0, 124927, '\P{^Is_Sc=ETHI}', "");
    Error('\p{Script= /a/Georgian}');
    Error('\P{Script= /a/Georgian}');
    Expect(1, 11565, '\p{Script=:\AGeorgian\z:}', "");;
    Expect(0, 11566, '\p{Script=:\AGeorgian\z:}', "");;
    Expect(1, 11565, '\p{Script=georgian}', "");
    Expect(0, 11565, '\p{^Script=georgian}', "");
    Expect(0, 11565, '\P{Script=georgian}', "");
    Expect(1, 11565, '\P{^Script=georgian}', "");
    Expect(0, 11566, '\p{Script=georgian}', "");
    Expect(1, 11566, '\p{^Script=georgian}', "");
    Expect(1, 11566, '\P{Script=georgian}', "");
    Expect(0, 11566, '\P{^Script=georgian}', "");
    Expect(1, 11565, '\p{Script=:\Ageorgian\z:}', "");;
    Expect(0, 11566, '\p{Script=:\Ageorgian\z:}', "");;
    Expect(1, 11565, '\p{Script=-_GEORGIAN}', "");
    Expect(0, 11565, '\p{^Script=-_GEORGIAN}', "");
    Expect(0, 11565, '\P{Script=-_GEORGIAN}', "");
    Expect(1, 11565, '\P{^Script=-_GEORGIAN}', "");
    Expect(0, 11566, '\p{Script=-_GEORGIAN}', "");
    Expect(1, 11566, '\p{^Script=-_GEORGIAN}', "");
    Expect(1, 11566, '\P{Script=-_GEORGIAN}', "");
    Expect(0, 11566, '\P{^Script=-_GEORGIAN}', "");
    Error('\p{Sc=/a/-	Geor}');
    Error('\P{Sc=/a/-	Geor}');
    Expect(1, 11565, '\p{Sc=:\AGeor\z:}', "");;
    Expect(0, 11566, '\p{Sc=:\AGeor\z:}', "");;
    Expect(1, 11565, '\p{Sc=geor}', "");
    Expect(0, 11565, '\p{^Sc=geor}', "");
    Expect(0, 11565, '\P{Sc=geor}', "");
    Expect(1, 11565, '\P{^Sc=geor}', "");
    Expect(0, 11566, '\p{Sc=geor}', "");
    Expect(1, 11566, '\p{^Sc=geor}', "");
    Expect(1, 11566, '\P{Sc=geor}', "");
    Expect(0, 11566, '\P{^Sc=geor}', "");
    Expect(1, 11565, '\p{Sc=:\Ageor\z:}', "");;
    Expect(0, 11566, '\p{Sc=:\Ageor\z:}', "");;
    Expect(1, 11565, '\p{Sc=Geor}', "");
    Expect(0, 11565, '\p{^Sc=Geor}', "");
    Expect(0, 11565, '\P{Sc=Geor}', "");
    Expect(1, 11565, '\P{^Sc=Geor}', "");
    Expect(0, 11566, '\p{Sc=Geor}', "");
    Expect(1, 11566, '\p{^Sc=Geor}', "");
    Expect(1, 11566, '\P{Sc=Geor}', "");
    Expect(0, 11566, '\P{^Sc=Geor}', "");
    Error('\p{Is_Script= GEORGIAN/a/}');
    Error('\P{Is_Script= GEORGIAN/a/}');
    Expect(1, 11565, '\p{Is_Script=georgian}', "");
    Expect(0, 11565, '\p{^Is_Script=georgian}', "");
    Expect(0, 11565, '\P{Is_Script=georgian}', "");
    Expect(1, 11565, '\P{^Is_Script=georgian}', "");
    Expect(0, 11566, '\p{Is_Script=georgian}', "");
    Expect(1, 11566, '\p{^Is_Script=georgian}', "");
    Expect(1, 11566, '\P{Is_Script=georgian}', "");
    Expect(0, 11566, '\P{^Is_Script=georgian}', "");
    Expect(1, 11565, '\p{Is_Script=_-GEORGIAN}', "");
    Expect(0, 11565, '\p{^Is_Script=_-GEORGIAN}', "");
    Expect(0, 11565, '\P{Is_Script=_-GEORGIAN}', "");
    Expect(1, 11565, '\P{^Is_Script=_-GEORGIAN}', "");
    Expect(0, 11566, '\p{Is_Script=_-GEORGIAN}', "");
    Expect(1, 11566, '\p{^Is_Script=_-GEORGIAN}', "");
    Expect(1, 11566, '\P{Is_Script=_-GEORGIAN}', "");
    Expect(0, 11566, '\P{^Is_Script=_-GEORGIAN}', "");
    Error('\p{Is_Sc=/a/-geor}');
    Error('\P{Is_Sc=/a/-geor}');
    Expect(1, 11565, '\p{Is_Sc=geor}', "");
    Expect(0, 11565, '\p{^Is_Sc=geor}', "");
    Expect(0, 11565, '\P{Is_Sc=geor}', "");
    Expect(1, 11565, '\P{^Is_Sc=geor}', "");
    Expect(0, 11566, '\p{Is_Sc=geor}', "");
    Expect(1, 11566, '\p{^Is_Sc=geor}', "");
    Expect(1, 11566, '\P{Is_Sc=geor}', "");
    Expect(0, 11566, '\P{^Is_Sc=geor}', "");
    Expect(1, 11565, '\p{Is_Sc=__Geor}', "");
    Expect(0, 11565, '\p{^Is_Sc=__Geor}', "");
    Expect(0, 11565, '\P{Is_Sc=__Geor}', "");
    Expect(1, 11565, '\P{^Is_Sc=__Geor}', "");
    Expect(0, 11566, '\p{Is_Sc=__Geor}', "");
    Expect(1, 11566, '\p{^Is_Sc=__Geor}', "");
    Expect(1, 11566, '\P{Is_Sc=__Geor}', "");
    Expect(0, 11566, '\P{^Is_Sc=__Geor}', "");
    Error('\p{Script=-:=Glagolitic}');
    Error('\P{Script=-:=Glagolitic}');
    Expect(1, 122922, '\p{Script=:\AGlagolitic\z:}', "");;
    Expect(0, 122923, '\p{Script=:\AGlagolitic\z:}', "");;
    Expect(1, 122922, '\p{Script=glagolitic}', "");
    Expect(0, 122922, '\p{^Script=glagolitic}', "");
    Expect(0, 122922, '\P{Script=glagolitic}', "");
    Expect(1, 122922, '\P{^Script=glagolitic}', "");
    Expect(0, 122923, '\p{Script=glagolitic}', "");
    Expect(1, 122923, '\p{^Script=glagolitic}', "");
    Expect(1, 122923, '\P{Script=glagolitic}', "");
    Expect(0, 122923, '\P{^Script=glagolitic}', "");
    Expect(1, 122922, '\p{Script=:\Aglagolitic\z:}', "");;
    Expect(0, 122923, '\p{Script=:\Aglagolitic\z:}', "");;
    Expect(1, 122922, '\p{Script=_-glagolitic}', "");
    Expect(0, 122922, '\p{^Script=_-glagolitic}', "");
    Expect(0, 122922, '\P{Script=_-glagolitic}', "");
    Expect(1, 122922, '\P{^Script=_-glagolitic}', "");
    Expect(0, 122923, '\p{Script=_-glagolitic}', "");
    Expect(1, 122923, '\p{^Script=_-glagolitic}', "");
    Expect(1, 122923, '\P{Script=_-glagolitic}', "");
    Expect(0, 122923, '\P{^Script=_-glagolitic}', "");
    Error('\p{Sc=_:=Glag}');
    Error('\P{Sc=_:=Glag}');
    Expect(1, 122922, '\p{Sc=:\AGlag\z:}', "");;
    Expect(0, 122923, '\p{Sc=:\AGlag\z:}', "");;
    Expect(1, 122922, '\p{Sc=glag}', "");
    Expect(0, 122922, '\p{^Sc=glag}', "");
    Expect(0, 122922, '\P{Sc=glag}', "");
    Expect(1, 122922, '\P{^Sc=glag}', "");
    Expect(0, 122923, '\p{Sc=glag}', "");
    Expect(1, 122923, '\p{^Sc=glag}', "");
    Expect(1, 122923, '\P{Sc=glag}', "");
    Expect(0, 122923, '\P{^Sc=glag}', "");
    Expect(1, 122922, '\p{Sc=:\Aglag\z:}', "");;
    Expect(0, 122923, '\p{Sc=:\Aglag\z:}', "");;
    Expect(1, 122922, '\p{Sc=_-Glag}', "");
    Expect(0, 122922, '\p{^Sc=_-Glag}', "");
    Expect(0, 122922, '\P{Sc=_-Glag}', "");
    Expect(1, 122922, '\P{^Sc=_-Glag}', "");
    Expect(0, 122923, '\p{Sc=_-Glag}', "");
    Expect(1, 122923, '\p{^Sc=_-Glag}', "");
    Expect(1, 122923, '\P{Sc=_-Glag}', "");
    Expect(0, 122923, '\P{^Sc=_-Glag}', "");
    Error('\p{Is_Script=-_Glagolitic:=}');
    Error('\P{Is_Script=-_Glagolitic:=}');
    Expect(1, 122922, '\p{Is_Script:glagolitic}', "");
    Expect(0, 122922, '\p{^Is_Script:glagolitic}', "");
    Expect(0, 122922, '\P{Is_Script:glagolitic}', "");
    Expect(1, 122922, '\P{^Is_Script:glagolitic}', "");
    Expect(0, 122923, '\p{Is_Script:glagolitic}', "");
    Expect(1, 122923, '\p{^Is_Script:glagolitic}', "");
    Expect(1, 122923, '\P{Is_Script:glagolitic}', "");
    Expect(0, 122923, '\P{^Is_Script:glagolitic}', "");
    Expect(1, 122922, '\p{Is_Script=	_Glagolitic}', "");
    Expect(0, 122922, '\p{^Is_Script=	_Glagolitic}', "");
    Expect(0, 122922, '\P{Is_Script=	_Glagolitic}', "");
    Expect(1, 122922, '\P{^Is_Script=	_Glagolitic}', "");
    Expect(0, 122923, '\p{Is_Script=	_Glagolitic}', "");
    Expect(1, 122923, '\p{^Is_Script=	_Glagolitic}', "");
    Expect(1, 122923, '\P{Is_Script=	_Glagolitic}', "");
    Expect(0, 122923, '\P{^Is_Script=	_Glagolitic}', "");
    Error('\p{Is_Sc: :=-Glag}');
    Error('\P{Is_Sc: :=-Glag}');
    Expect(1, 122922, '\p{Is_Sc=glag}', "");
    Expect(0, 122922, '\p{^Is_Sc=glag}', "");
    Expect(0, 122922, '\P{Is_Sc=glag}', "");
    Expect(1, 122922, '\P{^Is_Sc=glag}', "");
    Expect(0, 122923, '\p{Is_Sc=glag}', "");
    Expect(1, 122923, '\p{^Is_Sc=glag}', "");
    Expect(1, 122923, '\P{Is_Sc=glag}', "");
    Expect(0, 122923, '\P{^Is_Sc=glag}', "");
    Expect(1, 122922, '\p{Is_Sc=Glag}', "");
    Expect(0, 122922, '\p{^Is_Sc=Glag}', "");
    Expect(0, 122922, '\P{Is_Sc=Glag}', "");
    Expect(1, 122922, '\P{^Is_Sc=Glag}', "");
    Expect(0, 122923, '\p{Is_Sc=Glag}', "");
    Expect(1, 122923, '\p{^Is_Sc=Glag}', "");
    Expect(1, 122923, '\P{Is_Sc=Glag}', "");
    Expect(0, 122923, '\P{^Is_Sc=Glag}', "");
    Error('\p{Script= Gunjala_Gondi/a/}');
    Error('\P{Script= Gunjala_Gondi/a/}');
    Expect(1, 73129, '\p{Script=:\AGunjala_Gondi\z:}', "");;
    Expect(0, 73130, '\p{Script=:\AGunjala_Gondi\z:}', "");;
    Expect(1, 73129, '\p{Script=gunjalagondi}', "");
    Expect(0, 73129, '\p{^Script=gunjalagondi}', "");
    Expect(0, 73129, '\P{Script=gunjalagondi}', "");
    Expect(1, 73129, '\P{^Script=gunjalagondi}', "");
    Expect(0, 73130, '\p{Script=gunjalagondi}', "");
    Expect(1, 73130, '\p{^Script=gunjalagondi}', "");
    Expect(1, 73130, '\P{Script=gunjalagondi}', "");
    Expect(0, 73130, '\P{^Script=gunjalagondi}', "");
    Expect(1, 73129, '\p{Script=:\Agunjalagondi\z:}', "");;
    Expect(0, 73130, '\p{Script=:\Agunjalagondi\z:}', "");;
    Expect(1, 73129, '\p{Script=_-Gunjala_GONDI}', "");
    Expect(0, 73129, '\p{^Script=_-Gunjala_GONDI}', "");
    Expect(0, 73129, '\P{Script=_-Gunjala_GONDI}', "");
    Expect(1, 73129, '\P{^Script=_-Gunjala_GONDI}', "");
    Expect(0, 73130, '\p{Script=_-Gunjala_GONDI}', "");
    Expect(1, 73130, '\p{^Script=_-Gunjala_GONDI}', "");
    Expect(1, 73130, '\P{Script=_-Gunjala_GONDI}', "");
    Expect(0, 73130, '\P{^Script=_-Gunjala_GONDI}', "");
    Error('\p{Sc: /a/ _gong}');
    Error('\P{Sc: /a/ _gong}');
    Expect(1, 73129, '\p{Sc=:\AGong\z:}', "");;
    Expect(0, 73130, '\p{Sc=:\AGong\z:}', "");;
    Expect(1, 73129, '\p{Sc=gong}', "");
    Expect(0, 73129, '\p{^Sc=gong}', "");
    Expect(0, 73129, '\P{Sc=gong}', "");
    Expect(1, 73129, '\P{^Sc=gong}', "");
    Expect(0, 73130, '\p{Sc=gong}', "");
    Expect(1, 73130, '\p{^Sc=gong}', "");
    Expect(1, 73130, '\P{Sc=gong}', "");
    Expect(0, 73130, '\P{^Sc=gong}', "");
    Expect(1, 73129, '\p{Sc=:\Agong\z:}', "");;
    Expect(0, 73130, '\p{Sc=:\Agong\z:}', "");;
    Expect(1, 73129, '\p{Sc= Gong}', "");
    Expect(0, 73129, '\p{^Sc= Gong}', "");
    Expect(0, 73129, '\P{Sc= Gong}', "");
    Expect(1, 73129, '\P{^Sc= Gong}', "");
    Expect(0, 73130, '\p{Sc= Gong}', "");
    Expect(1, 73130, '\p{^Sc= Gong}', "");
    Expect(1, 73130, '\P{Sc= Gong}', "");
    Expect(0, 73130, '\P{^Sc= Gong}', "");
    Error('\p{Is_Script=/a/	-Gunjala_GONDI}');
    Error('\P{Is_Script=/a/	-Gunjala_GONDI}');
    Expect(1, 73129, '\p{Is_Script=gunjalagondi}', "");
    Expect(0, 73129, '\p{^Is_Script=gunjalagondi}', "");
    Expect(0, 73129, '\P{Is_Script=gunjalagondi}', "");
    Expect(1, 73129, '\P{^Is_Script=gunjalagondi}', "");
    Expect(0, 73130, '\p{Is_Script=gunjalagondi}', "");
    Expect(1, 73130, '\p{^Is_Script=gunjalagondi}', "");
    Expect(1, 73130, '\P{Is_Script=gunjalagondi}', "");
    Expect(0, 73130, '\P{^Is_Script=gunjalagondi}', "");
    Expect(1, 73129, '\p{Is_Script=-	Gunjala_GONDI}', "");
    Expect(0, 73129, '\p{^Is_Script=-	Gunjala_GONDI}', "");
    Expect(0, 73129, '\P{Is_Script=-	Gunjala_GONDI}', "");
    Expect(1, 73129, '\P{^Is_Script=-	Gunjala_GONDI}', "");
    Expect(0, 73130, '\p{Is_Script=-	Gunjala_GONDI}', "");
    Expect(1, 73130, '\p{^Is_Script=-	Gunjala_GONDI}', "");
    Expect(1, 73130, '\P{Is_Script=-	Gunjala_GONDI}', "");
    Expect(0, 73130, '\P{^Is_Script=-	Gunjala_GONDI}', "");
    Error('\p{Is_Sc=-/a/gong}');
    Error('\P{Is_Sc=-/a/gong}');
    Expect(1, 73129, '\p{Is_Sc=gong}', "");
    Expect(0, 73129, '\p{^Is_Sc=gong}', "");
    Expect(0, 73129, '\P{Is_Sc=gong}', "");
    Expect(1, 73129, '\P{^Is_Sc=gong}', "");
    Expect(0, 73130, '\p{Is_Sc=gong}', "");
    Expect(1, 73130, '\p{^Is_Sc=gong}', "");
    Expect(1, 73130, '\P{Is_Sc=gong}', "");
    Expect(0, 73130, '\P{^Is_Sc=gong}', "");
    Expect(1, 73129, '\p{Is_Sc=	gong}', "");
    Expect(0, 73129, '\p{^Is_Sc=	gong}', "");
    Expect(0, 73129, '\P{Is_Sc=	gong}', "");
    Expect(1, 73129, '\P{^Is_Sc=	gong}', "");
    Expect(0, 73130, '\p{Is_Sc=	gong}', "");
    Expect(1, 73130, '\p{^Is_Sc=	gong}', "");
    Expect(1, 73130, '\P{Is_Sc=	gong}', "");
    Expect(0, 73130, '\P{^Is_Sc=	gong}', "");
    Error('\p{Script=-/a/Masaram_Gondi}');
    Error('\P{Script=-/a/Masaram_Gondi}');
    Expect(1, 73049, '\p{Script=:\AMasaram_Gondi\z:}', "");;
    Expect(0, 73050, '\p{Script=:\AMasaram_Gondi\z:}', "");;
    Expect(1, 73049, '\p{Script=masaramgondi}', "");
    Expect(0, 73049, '\p{^Script=masaramgondi}', "");
    Expect(0, 73049, '\P{Script=masaramgondi}', "");
    Expect(1, 73049, '\P{^Script=masaramgondi}', "");
    Expect(0, 73050, '\p{Script=masaramgondi}', "");
    Expect(1, 73050, '\p{^Script=masaramgondi}', "");
    Expect(1, 73050, '\P{Script=masaramgondi}', "");
    Expect(0, 73050, '\P{^Script=masaramgondi}', "");
    Expect(1, 73049, '\p{Script=:\Amasaramgondi\z:}', "");;
    Expect(0, 73050, '\p{Script=:\Amasaramgondi\z:}', "");;
    Expect(1, 73049, '\p{Script=	_Masaram_gondi}', "");
    Expect(0, 73049, '\p{^Script=	_Masaram_gondi}', "");
    Expect(0, 73049, '\P{Script=	_Masaram_gondi}', "");
    Expect(1, 73049, '\P{^Script=	_Masaram_gondi}', "");
    Expect(0, 73050, '\p{Script=	_Masaram_gondi}', "");
    Expect(1, 73050, '\p{^Script=	_Masaram_gondi}', "");
    Expect(1, 73050, '\P{Script=	_Masaram_gondi}', "");
    Expect(0, 73050, '\P{^Script=	_Masaram_gondi}', "");
    Error('\p{Sc: 		GONM:=}');
    Error('\P{Sc: 		GONM:=}');
    Expect(1, 73049, '\p{Sc=:\AGonm\z:}', "");;
    Expect(0, 73050, '\p{Sc=:\AGonm\z:}', "");;
    Expect(1, 73049, '\p{Sc=gonm}', "");
    Expect(0, 73049, '\p{^Sc=gonm}', "");
    Expect(0, 73049, '\P{Sc=gonm}', "");
    Expect(1, 73049, '\P{^Sc=gonm}', "");
    Expect(0, 73050, '\p{Sc=gonm}', "");
    Expect(1, 73050, '\p{^Sc=gonm}', "");
    Expect(1, 73050, '\P{Sc=gonm}', "");
    Expect(0, 73050, '\P{^Sc=gonm}', "");
    Expect(1, 73049, '\p{Sc=:\Agonm\z:}', "");;
    Expect(0, 73050, '\p{Sc=:\Agonm\z:}', "");;
    Expect(1, 73049, '\p{Sc= _gonm}', "");
    Expect(0, 73049, '\p{^Sc= _gonm}', "");
    Expect(0, 73049, '\P{Sc= _gonm}', "");
    Expect(1, 73049, '\P{^Sc= _gonm}', "");
    Expect(0, 73050, '\p{Sc= _gonm}', "");
    Expect(1, 73050, '\p{^Sc= _gonm}', "");
    Expect(1, 73050, '\P{Sc= _gonm}', "");
    Expect(0, 73050, '\P{^Sc= _gonm}', "");
    Error('\p{Is_Script=:=	 Masaram_GONDI}');
    Error('\P{Is_Script=:=	 Masaram_GONDI}');
    Expect(1, 73049, '\p{Is_Script=masaramgondi}', "");
    Expect(0, 73049, '\p{^Is_Script=masaramgondi}', "");
    Expect(0, 73049, '\P{Is_Script=masaramgondi}', "");
    Expect(1, 73049, '\P{^Is_Script=masaramgondi}', "");
    Expect(0, 73050, '\p{Is_Script=masaramgondi}', "");
    Expect(1, 73050, '\p{^Is_Script=masaramgondi}', "");
    Expect(1, 73050, '\P{Is_Script=masaramgondi}', "");
    Expect(0, 73050, '\P{^Is_Script=masaramgondi}', "");
    Expect(1, 73049, '\p{Is_Script=	 MASARAM_Gondi}', "");
    Expect(0, 73049, '\p{^Is_Script=	 MASARAM_Gondi}', "");
    Expect(0, 73049, '\P{Is_Script=	 MASARAM_Gondi}', "");
    Expect(1, 73049, '\P{^Is_Script=	 MASARAM_Gondi}', "");
    Expect(0, 73050, '\p{Is_Script=	 MASARAM_Gondi}', "");
    Expect(1, 73050, '\p{^Is_Script=	 MASARAM_Gondi}', "");
    Expect(1, 73050, '\P{Is_Script=	 MASARAM_Gondi}', "");
    Expect(0, 73050, '\P{^Is_Script=	 MASARAM_Gondi}', "");
    Error('\p{Is_Sc:	:=_	Gonm}');
    Error('\P{Is_Sc:	:=_	Gonm}');
    Expect(1, 73049, '\p{Is_Sc=gonm}', "");
    Expect(0, 73049, '\p{^Is_Sc=gonm}', "");
    Expect(0, 73049, '\P{Is_Sc=gonm}', "");
    Expect(1, 73049, '\P{^Is_Sc=gonm}', "");
    Expect(0, 73050, '\p{Is_Sc=gonm}', "");
    Expect(1, 73050, '\p{^Is_Sc=gonm}', "");
    Expect(1, 73050, '\P{Is_Sc=gonm}', "");
    Expect(0, 73050, '\P{^Is_Sc=gonm}', "");
    Expect(1, 73049, '\p{Is_Sc= GONM}', "");
    Expect(0, 73049, '\p{^Is_Sc= GONM}', "");
    Expect(0, 73049, '\P{Is_Sc= GONM}', "");
    Expect(1, 73049, '\P{^Is_Sc= GONM}', "");
    Expect(0, 73050, '\p{Is_Sc= GONM}', "");
    Expect(1, 73050, '\p{^Is_Sc= GONM}', "");
    Expect(1, 73050, '\P{Is_Sc= GONM}', "");
    Expect(0, 73050, '\P{^Is_Sc= GONM}', "");
    Error('\p{Script=-	Gothic/a/}');
    Error('\P{Script=-	Gothic/a/}');
    Expect(1, 66378, '\p{Script=:\AGothic\z:}', "");;
    Expect(0, 66379, '\p{Script=:\AGothic\z:}', "");;
    Expect(1, 66378, '\p{Script=gothic}', "");
    Expect(0, 66378, '\p{^Script=gothic}', "");
    Expect(0, 66378, '\P{Script=gothic}', "");
    Expect(1, 66378, '\P{^Script=gothic}', "");
    Expect(0, 66379, '\p{Script=gothic}', "");
    Expect(1, 66379, '\p{^Script=gothic}', "");
    Expect(1, 66379, '\P{Script=gothic}', "");
    Expect(0, 66379, '\P{^Script=gothic}', "");
    Expect(1, 66378, '\p{Script=:\Agothic\z:}', "");;
    Expect(0, 66379, '\p{Script=:\Agothic\z:}', "");;
    Expect(1, 66378, '\p{Script=_-GOTHIC}', "");
    Expect(0, 66378, '\p{^Script=_-GOTHIC}', "");
    Expect(0, 66378, '\P{Script=_-GOTHIC}', "");
    Expect(1, 66378, '\P{^Script=_-GOTHIC}', "");
    Expect(0, 66379, '\p{Script=_-GOTHIC}', "");
    Expect(1, 66379, '\p{^Script=_-GOTHIC}', "");
    Expect(1, 66379, '\P{Script=_-GOTHIC}', "");
    Expect(0, 66379, '\P{^Script=_-GOTHIC}', "");
    Error('\p{Sc=:=  GOTH}');
    Error('\P{Sc=:=  GOTH}');
    Expect(1, 66378, '\p{Sc=:\AGoth\z:}', "");;
    Expect(0, 66379, '\p{Sc=:\AGoth\z:}', "");;
    Expect(1, 66378, '\p{Sc=goth}', "");
    Expect(0, 66378, '\p{^Sc=goth}', "");
    Expect(0, 66378, '\P{Sc=goth}', "");
    Expect(1, 66378, '\P{^Sc=goth}', "");
    Expect(0, 66379, '\p{Sc=goth}', "");
    Expect(1, 66379, '\p{^Sc=goth}', "");
    Expect(1, 66379, '\P{Sc=goth}', "");
    Expect(0, 66379, '\P{^Sc=goth}', "");
    Expect(1, 66378, '\p{Sc=:\Agoth\z:}', "");;
    Expect(0, 66379, '\p{Sc=:\Agoth\z:}', "");;
    Expect(1, 66378, '\p{Sc=	-goth}', "");
    Expect(0, 66378, '\p{^Sc=	-goth}', "");
    Expect(0, 66378, '\P{Sc=	-goth}', "");
    Expect(1, 66378, '\P{^Sc=	-goth}', "");
    Expect(0, 66379, '\p{Sc=	-goth}', "");
    Expect(1, 66379, '\p{^Sc=	-goth}', "");
    Expect(1, 66379, '\P{Sc=	-goth}', "");
    Expect(0, 66379, '\P{^Sc=	-goth}', "");
    Error('\p{Is_Script=:=	-Gothic}');
    Error('\P{Is_Script=:=	-Gothic}');
    Expect(1, 66378, '\p{Is_Script=gothic}', "");
    Expect(0, 66378, '\p{^Is_Script=gothic}', "");
    Expect(0, 66378, '\P{Is_Script=gothic}', "");
    Expect(1, 66378, '\P{^Is_Script=gothic}', "");
    Expect(0, 66379, '\p{Is_Script=gothic}', "");
    Expect(1, 66379, '\p{^Is_Script=gothic}', "");
    Expect(1, 66379, '\P{Is_Script=gothic}', "");
    Expect(0, 66379, '\P{^Is_Script=gothic}', "");
    Expect(1, 66378, '\p{Is_Script=		gothic}', "");
    Expect(0, 66378, '\p{^Is_Script=		gothic}', "");
    Expect(0, 66378, '\P{Is_Script=		gothic}', "");
    Expect(1, 66378, '\P{^Is_Script=		gothic}', "");
    Expect(0, 66379, '\p{Is_Script=		gothic}', "");
    Expect(1, 66379, '\p{^Is_Script=		gothic}', "");
    Expect(1, 66379, '\P{Is_Script=		gothic}', "");
    Expect(0, 66379, '\P{^Is_Script=		gothic}', "");
    Error('\p{Is_Sc=_	Goth:=}');
    Error('\P{Is_Sc=_	Goth:=}');
    Expect(1, 66378, '\p{Is_Sc=goth}', "");
    Expect(0, 66378, '\p{^Is_Sc=goth}', "");
    Expect(0, 66378, '\P{Is_Sc=goth}', "");
    Expect(1, 66378, '\P{^Is_Sc=goth}', "");
    Expect(0, 66379, '\p{Is_Sc=goth}', "");
    Expect(1, 66379, '\p{^Is_Sc=goth}', "");
    Expect(1, 66379, '\P{Is_Sc=goth}', "");
    Expect(0, 66379, '\P{^Is_Sc=goth}', "");
    Expect(1, 66378, '\p{Is_Sc= goth}', "");
    Expect(0, 66378, '\p{^Is_Sc= goth}', "");
    Expect(0, 66378, '\P{Is_Sc= goth}', "");
    Expect(1, 66378, '\P{^Is_Sc= goth}', "");
    Expect(0, 66379, '\p{Is_Sc= goth}', "");
    Expect(1, 66379, '\p{^Is_Sc= goth}', "");
    Expect(1, 66379, '\P{Is_Sc= goth}', "");
    Expect(0, 66379, '\P{^Is_Sc= goth}', "");
    Error('\p{Script=-	grantha/a/}');
    Error('\P{Script=-	grantha/a/}');
    Expect(1, 70516, '\p{Script=:\AGrantha\z:}', "");;
    Expect(0, 70517, '\p{Script=:\AGrantha\z:}', "");;
    Expect(1, 70516, '\p{Script=grantha}', "");
    Expect(0, 70516, '\p{^Script=grantha}', "");
    Expect(0, 70516, '\P{Script=grantha}', "");
    Expect(1, 70516, '\P{^Script=grantha}', "");
    Expect(0, 70517, '\p{Script=grantha}', "");
    Expect(1, 70517, '\p{^Script=grantha}', "");
    Expect(1, 70517, '\P{Script=grantha}', "");
    Expect(0, 70517, '\P{^Script=grantha}', "");
    Expect(1, 70516, '\p{Script=:\Agrantha\z:}', "");;
    Expect(0, 70517, '\p{Script=:\Agrantha\z:}', "");;
    Expect(1, 70516, '\p{Script:    grantha}', "");
    Expect(0, 70516, '\p{^Script:    grantha}', "");
    Expect(0, 70516, '\P{Script:    grantha}', "");
    Expect(1, 70516, '\P{^Script:    grantha}', "");
    Expect(0, 70517, '\p{Script:    grantha}', "");
    Expect(1, 70517, '\p{^Script:    grantha}', "");
    Expect(1, 70517, '\P{Script:    grantha}', "");
    Expect(0, 70517, '\P{^Script:    grantha}', "");
    Error('\p{Sc=_:=Gran}');
    Error('\P{Sc=_:=Gran}');
    Expect(1, 70516, '\p{Sc=:\AGran\z:}', "");;
    Expect(0, 70517, '\p{Sc=:\AGran\z:}', "");;
    Expect(1, 70516, '\p{Sc=gran}', "");
    Expect(0, 70516, '\p{^Sc=gran}', "");
    Expect(0, 70516, '\P{Sc=gran}', "");
    Expect(1, 70516, '\P{^Sc=gran}', "");
    Expect(0, 70517, '\p{Sc=gran}', "");
    Expect(1, 70517, '\p{^Sc=gran}', "");
    Expect(1, 70517, '\P{Sc=gran}', "");
    Expect(0, 70517, '\P{^Sc=gran}', "");
    Expect(1, 70516, '\p{Sc=:\Agran\z:}', "");;
    Expect(0, 70517, '\p{Sc=:\Agran\z:}', "");;
    Expect(1, 70516, '\p{Sc=	 Gran}', "");
    Expect(0, 70516, '\p{^Sc=	 Gran}', "");
    Expect(0, 70516, '\P{Sc=	 Gran}', "");
    Expect(1, 70516, '\P{^Sc=	 Gran}', "");
    Expect(0, 70517, '\p{Sc=	 Gran}', "");
    Expect(1, 70517, '\p{^Sc=	 Gran}', "");
    Expect(1, 70517, '\P{Sc=	 Gran}', "");
    Expect(0, 70517, '\P{^Sc=	 Gran}', "");
    Error('\p{Is_Script=_/a/grantha}');
    Error('\P{Is_Script=_/a/grantha}');
    Expect(1, 70516, '\p{Is_Script=grantha}', "");
    Expect(0, 70516, '\p{^Is_Script=grantha}', "");
    Expect(0, 70516, '\P{Is_Script=grantha}', "");
    Expect(1, 70516, '\P{^Is_Script=grantha}', "");
    Expect(0, 70517, '\p{Is_Script=grantha}', "");
    Expect(1, 70517, '\p{^Is_Script=grantha}', "");
    Expect(1, 70517, '\P{Is_Script=grantha}', "");
    Expect(0, 70517, '\P{^Is_Script=grantha}', "");
    Expect(1, 70516, '\p{Is_Script=-	Grantha}', "");
    Expect(0, 70516, '\p{^Is_Script=-	Grantha}', "");
    Expect(0, 70516, '\P{Is_Script=-	Grantha}', "");
    Expect(1, 70516, '\P{^Is_Script=-	Grantha}', "");
    Expect(0, 70517, '\p{Is_Script=-	Grantha}', "");
    Expect(1, 70517, '\p{^Is_Script=-	Grantha}', "");
    Expect(1, 70517, '\P{Is_Script=-	Grantha}', "");
    Expect(0, 70517, '\P{^Is_Script=-	Grantha}', "");
    Error('\p{Is_Sc=/a/_	Gran}');
    Error('\P{Is_Sc=/a/_	Gran}');
    Expect(1, 70516, '\p{Is_Sc=gran}', "");
    Expect(0, 70516, '\p{^Is_Sc=gran}', "");
    Expect(0, 70516, '\P{Is_Sc=gran}', "");
    Expect(1, 70516, '\P{^Is_Sc=gran}', "");
    Expect(0, 70517, '\p{Is_Sc=gran}', "");
    Expect(1, 70517, '\p{^Is_Sc=gran}', "");
    Expect(1, 70517, '\P{Is_Sc=gran}', "");
    Expect(0, 70517, '\P{^Is_Sc=gran}', "");
    Expect(1, 70516, '\p{Is_Sc=_	Gran}', "");
    Expect(0, 70516, '\p{^Is_Sc=_	Gran}', "");
    Expect(0, 70516, '\P{Is_Sc=_	Gran}', "");
    Expect(1, 70516, '\P{^Is_Sc=_	Gran}', "");
    Expect(0, 70517, '\p{Is_Sc=_	Gran}', "");
    Expect(1, 70517, '\p{^Is_Sc=_	Gran}', "");
    Expect(1, 70517, '\P{Is_Sc=_	Gran}', "");
    Expect(0, 70517, '\P{^Is_Sc=_	Gran}', "");
    Error('\p{Script=/a/	 GREEK}');
    Error('\P{Script=/a/	 GREEK}');
    Expect(1, 119365, '\p{Script=:\AGreek\z:}', "");;
    Expect(0, 119366, '\p{Script=:\AGreek\z:}', "");;
    Expect(1, 119365, '\p{Script=greek}', "");
    Expect(0, 119365, '\p{^Script=greek}', "");
    Expect(0, 119365, '\P{Script=greek}', "");
    Expect(1, 119365, '\P{^Script=greek}', "");
    Expect(0, 119366, '\p{Script=greek}', "");
    Expect(1, 119366, '\p{^Script=greek}', "");
    Expect(1, 119366, '\P{Script=greek}', "");
    Expect(0, 119366, '\P{^Script=greek}', "");
    Expect(1, 119365, '\p{Script=:\Agreek\z:}', "");;
    Expect(0, 119366, '\p{Script=:\Agreek\z:}', "");;
    Expect(1, 119365, '\p{Script= Greek}', "");
    Expect(0, 119365, '\p{^Script= Greek}', "");
    Expect(0, 119365, '\P{Script= Greek}', "");
    Expect(1, 119365, '\P{^Script= Greek}', "");
    Expect(0, 119366, '\p{Script= Greek}', "");
    Expect(1, 119366, '\p{^Script= Greek}', "");
    Expect(1, 119366, '\P{Script= Greek}', "");
    Expect(0, 119366, '\P{^Script= Greek}', "");
    Error('\p{Sc=		Grek/a/}');
    Error('\P{Sc=		Grek/a/}');
    Expect(1, 119365, '\p{Sc=:\AGrek\z:}', "");;
    Expect(0, 119366, '\p{Sc=:\AGrek\z:}', "");;
    Expect(1, 119365, '\p{Sc:   grek}', "");
    Expect(0, 119365, '\p{^Sc:   grek}', "");
    Expect(0, 119365, '\P{Sc:   grek}', "");
    Expect(1, 119365, '\P{^Sc:   grek}', "");
    Expect(0, 119366, '\p{Sc:   grek}', "");
    Expect(1, 119366, '\p{^Sc:   grek}', "");
    Expect(1, 119366, '\P{Sc:   grek}', "");
    Expect(0, 119366, '\P{^Sc:   grek}', "");
    Expect(1, 119365, '\p{Sc=:\Agrek\z:}', "");;
    Expect(0, 119366, '\p{Sc=:\Agrek\z:}', "");;
    Expect(1, 119365, '\p{Sc=  Grek}', "");
    Expect(0, 119365, '\p{^Sc=  Grek}', "");
    Expect(0, 119365, '\P{Sc=  Grek}', "");
    Expect(1, 119365, '\P{^Sc=  Grek}', "");
    Expect(0, 119366, '\p{Sc=  Grek}', "");
    Expect(1, 119366, '\p{^Sc=  Grek}', "");
    Expect(1, 119366, '\P{Sc=  Grek}', "");
    Expect(0, 119366, '\P{^Sc=  Grek}', "");
    Error('\p{Is_Script=/a/--greek}');
    Error('\P{Is_Script=/a/--greek}');
    Expect(1, 119365, '\p{Is_Script=greek}', "");
    Expect(0, 119365, '\p{^Is_Script=greek}', "");
    Expect(0, 119365, '\P{Is_Script=greek}', "");
    Expect(1, 119365, '\P{^Is_Script=greek}', "");
    Expect(0, 119366, '\p{Is_Script=greek}', "");
    Expect(1, 119366, '\p{^Is_Script=greek}', "");
    Expect(1, 119366, '\P{Is_Script=greek}', "");
    Expect(0, 119366, '\P{^Is_Script=greek}', "");
    Expect(1, 119365, '\p{Is_Script=_	greek}', "");
    Expect(0, 119365, '\p{^Is_Script=_	greek}', "");
    Expect(0, 119365, '\P{Is_Script=_	greek}', "");
    Expect(1, 119365, '\P{^Is_Script=_	greek}', "");
    Expect(0, 119366, '\p{Is_Script=_	greek}', "");
    Expect(1, 119366, '\p{^Is_Script=_	greek}', "");
    Expect(1, 119366, '\P{Is_Script=_	greek}', "");
    Expect(0, 119366, '\P{^Is_Script=_	greek}', "");
    Error('\p{Is_Sc=--GREK:=}');
    Error('\P{Is_Sc=--GREK:=}');
    Expect(1, 119365, '\p{Is_Sc=grek}', "");
    Expect(0, 119365, '\p{^Is_Sc=grek}', "");
    Expect(0, 119365, '\P{Is_Sc=grek}', "");
    Expect(1, 119365, '\P{^Is_Sc=grek}', "");
    Expect(0, 119366, '\p{Is_Sc=grek}', "");
    Expect(1, 119366, '\p{^Is_Sc=grek}', "");
    Expect(1, 119366, '\P{Is_Sc=grek}', "");
    Expect(0, 119366, '\P{^Is_Sc=grek}', "");
    Expect(1, 119365, '\p{Is_Sc=-GREK}', "");
    Expect(0, 119365, '\p{^Is_Sc=-GREK}', "");
    Expect(0, 119365, '\P{Is_Sc=-GREK}', "");
    Expect(1, 119365, '\P{^Is_Sc=-GREK}', "");
    Expect(0, 119366, '\p{Is_Sc=-GREK}', "");
    Expect(1, 119366, '\p{^Is_Sc=-GREK}', "");
    Expect(1, 119366, '\P{Is_Sc=-GREK}', "");
    Expect(0, 119366, '\P{^Is_Sc=-GREK}', "");
    Error('\p{Script=  gujarati/a/}');
    Error('\P{Script=  gujarati/a/}');
    Expect(1, 2815, '\p{Script=:\AGujarati\z:}', "");;
    Expect(0, 2816, '\p{Script=:\AGujarati\z:}', "");;
    Expect(1, 2815, '\p{Script=gujarati}', "");
    Expect(0, 2815, '\p{^Script=gujarati}', "");
    Expect(0, 2815, '\P{Script=gujarati}', "");
    Expect(1, 2815, '\P{^Script=gujarati}', "");
    Expect(0, 2816, '\p{Script=gujarati}', "");
    Expect(1, 2816, '\p{^Script=gujarati}', "");
    Expect(1, 2816, '\P{Script=gujarati}', "");
    Expect(0, 2816, '\P{^Script=gujarati}', "");
    Expect(1, 2815, '\p{Script=:\Agujarati\z:}', "");;
    Expect(0, 2816, '\p{Script=:\Agujarati\z:}', "");;
    Expect(1, 2815, '\p{Script=		Gujarati}', "");
    Expect(0, 2815, '\p{^Script=		Gujarati}', "");
    Expect(0, 2815, '\P{Script=		Gujarati}', "");
    Expect(1, 2815, '\P{^Script=		Gujarati}', "");
    Expect(0, 2816, '\p{Script=		Gujarati}', "");
    Expect(1, 2816, '\p{^Script=		Gujarati}', "");
    Expect(1, 2816, '\P{Script=		Gujarati}', "");
    Expect(0, 2816, '\P{^Script=		Gujarati}', "");
    Error('\p{Sc= 	GUJR:=}');
    Error('\P{Sc= 	GUJR:=}');
    Expect(1, 2815, '\p{Sc=:\AGujr\z:}', "");;
    Expect(0, 2816, '\p{Sc=:\AGujr\z:}', "");;
    Expect(1, 2815, '\p{Sc=gujr}', "");
    Expect(0, 2815, '\p{^Sc=gujr}', "");
    Expect(0, 2815, '\P{Sc=gujr}', "");
    Expect(1, 2815, '\P{^Sc=gujr}', "");
    Expect(0, 2816, '\p{Sc=gujr}', "");
    Expect(1, 2816, '\p{^Sc=gujr}', "");
    Expect(1, 2816, '\P{Sc=gujr}', "");
    Expect(0, 2816, '\P{^Sc=gujr}', "");
    Expect(1, 2815, '\p{Sc=:\Agujr\z:}', "");;
    Expect(0, 2816, '\p{Sc=:\Agujr\z:}', "");;
    Expect(1, 2815, '\p{Sc=		GUJR}', "");
    Expect(0, 2815, '\p{^Sc=		GUJR}', "");
    Expect(0, 2815, '\P{Sc=		GUJR}', "");
    Expect(1, 2815, '\P{^Sc=		GUJR}', "");
    Expect(0, 2816, '\p{Sc=		GUJR}', "");
    Expect(1, 2816, '\p{^Sc=		GUJR}', "");
    Expect(1, 2816, '\P{Sc=		GUJR}', "");
    Expect(0, 2816, '\P{^Sc=		GUJR}', "");
    Error('\p{Is_Script= Gujarati/a/}');
    Error('\P{Is_Script= Gujarati/a/}');
    Expect(1, 2815, '\p{Is_Script=gujarati}', "");
    Expect(0, 2815, '\p{^Is_Script=gujarati}', "");
    Expect(0, 2815, '\P{Is_Script=gujarati}', "");
    Expect(1, 2815, '\P{^Is_Script=gujarati}', "");
    Expect(0, 2816, '\p{Is_Script=gujarati}', "");
    Expect(1, 2816, '\p{^Is_Script=gujarati}', "");
    Expect(1, 2816, '\P{Is_Script=gujarati}', "");
    Expect(0, 2816, '\P{^Is_Script=gujarati}', "");
    Expect(1, 2815, '\p{Is_Script=_Gujarati}', "");
    Expect(0, 2815, '\p{^Is_Script=_Gujarati}', "");
    Expect(0, 2815, '\P{Is_Script=_Gujarati}', "");
    Expect(1, 2815, '\P{^Is_Script=_Gujarati}', "");
    Expect(0, 2816, '\p{Is_Script=_Gujarati}', "");
    Expect(1, 2816, '\p{^Is_Script=_Gujarati}', "");
    Expect(1, 2816, '\P{Is_Script=_Gujarati}', "");
    Expect(0, 2816, '\P{^Is_Script=_Gujarati}', "");
    Error('\p{Is_Sc=--Gujr:=}');
    Error('\P{Is_Sc=--Gujr:=}');
    Expect(1, 2815, '\p{Is_Sc=gujr}', "");
    Expect(0, 2815, '\p{^Is_Sc=gujr}', "");
    Expect(0, 2815, '\P{Is_Sc=gujr}', "");
    Expect(1, 2815, '\P{^Is_Sc=gujr}', "");
    Expect(0, 2816, '\p{Is_Sc=gujr}', "");
    Expect(1, 2816, '\p{^Is_Sc=gujr}', "");
    Expect(1, 2816, '\P{Is_Sc=gujr}', "");
    Expect(0, 2816, '\P{^Is_Sc=gujr}', "");
    Expect(1, 2815, '\p{Is_Sc=	Gujr}', "");
    Expect(0, 2815, '\p{^Is_Sc=	Gujr}', "");
    Expect(0, 2815, '\P{Is_Sc=	Gujr}', "");
    Expect(1, 2815, '\P{^Is_Sc=	Gujr}', "");
    Expect(0, 2816, '\p{Is_Sc=	Gujr}', "");
    Expect(1, 2816, '\p{^Is_Sc=	Gujr}', "");
    Expect(1, 2816, '\P{Is_Sc=	Gujr}', "");
    Expect(0, 2816, '\P{^Is_Sc=	Gujr}', "");
    Error('\p{Script=	/a/GURMUKHI}');
    Error('\P{Script=	/a/GURMUKHI}');
    Expect(1, 2678, '\p{Script=:\AGurmukhi\z:}', "");;
    Expect(0, 2679, '\p{Script=:\AGurmukhi\z:}', "");;
    Expect(1, 2678, '\p{Script=gurmukhi}', "");
    Expect(0, 2678, '\p{^Script=gurmukhi}', "");
    Expect(0, 2678, '\P{Script=gurmukhi}', "");
    Expect(1, 2678, '\P{^Script=gurmukhi}', "");
    Expect(0, 2679, '\p{Script=gurmukhi}', "");
    Expect(1, 2679, '\p{^Script=gurmukhi}', "");
    Expect(1, 2679, '\P{Script=gurmukhi}', "");
    Expect(0, 2679, '\P{^Script=gurmukhi}', "");
    Expect(1, 2678, '\p{Script=:\Agurmukhi\z:}', "");;
    Expect(0, 2679, '\p{Script=:\Agurmukhi\z:}', "");;
    Expect(1, 2678, '\p{Script= GURMUKHI}', "");
    Expect(0, 2678, '\p{^Script= GURMUKHI}', "");
    Expect(0, 2678, '\P{Script= GURMUKHI}', "");
    Expect(1, 2678, '\P{^Script= GURMUKHI}', "");
    Expect(0, 2679, '\p{Script= GURMUKHI}', "");
    Expect(1, 2679, '\p{^Script= GURMUKHI}', "");
    Expect(1, 2679, '\P{Script= GURMUKHI}', "");
    Expect(0, 2679, '\P{^Script= GURMUKHI}', "");
    Error('\p{Sc=:= _Guru}');
    Error('\P{Sc=:= _Guru}');
    Expect(1, 2678, '\p{Sc=:\AGuru\z:}', "");;
    Expect(0, 2679, '\p{Sc=:\AGuru\z:}', "");;
    Expect(1, 2678, '\p{Sc=guru}', "");
    Expect(0, 2678, '\p{^Sc=guru}', "");
    Expect(0, 2678, '\P{Sc=guru}', "");
    Expect(1, 2678, '\P{^Sc=guru}', "");
    Expect(0, 2679, '\p{Sc=guru}', "");
    Expect(1, 2679, '\p{^Sc=guru}', "");
    Expect(1, 2679, '\P{Sc=guru}', "");
    Expect(0, 2679, '\P{^Sc=guru}', "");
    Expect(1, 2678, '\p{Sc=:\Aguru\z:}', "");;
    Expect(0, 2679, '\p{Sc=:\Aguru\z:}', "");;
    Expect(1, 2678, '\p{Sc: 	 guru}', "");
    Expect(0, 2678, '\p{^Sc: 	 guru}', "");
    Expect(0, 2678, '\P{Sc: 	 guru}', "");
    Expect(1, 2678, '\P{^Sc: 	 guru}', "");
    Expect(0, 2679, '\p{Sc: 	 guru}', "");
    Expect(1, 2679, '\p{^Sc: 	 guru}', "");
    Expect(1, 2679, '\P{Sc: 	 guru}', "");
    Expect(0, 2679, '\P{^Sc: 	 guru}', "");
    Error('\p{Is_Script=/a/  GURMUKHI}');
    Error('\P{Is_Script=/a/  GURMUKHI}');
    Expect(1, 2678, '\p{Is_Script:	gurmukhi}', "");
    Expect(0, 2678, '\p{^Is_Script:	gurmukhi}', "");
    Expect(0, 2678, '\P{Is_Script:	gurmukhi}', "");
    Expect(1, 2678, '\P{^Is_Script:	gurmukhi}', "");
    Expect(0, 2679, '\p{Is_Script:	gurmukhi}', "");
    Expect(1, 2679, '\p{^Is_Script:	gurmukhi}', "");
    Expect(1, 2679, '\P{Is_Script:	gurmukhi}', "");
    Expect(0, 2679, '\P{^Is_Script:	gurmukhi}', "");
    Expect(1, 2678, '\p{Is_Script=	Gurmukhi}', "");
    Expect(0, 2678, '\p{^Is_Script=	Gurmukhi}', "");
    Expect(0, 2678, '\P{Is_Script=	Gurmukhi}', "");
    Expect(1, 2678, '\P{^Is_Script=	Gurmukhi}', "");
    Expect(0, 2679, '\p{Is_Script=	Gurmukhi}', "");
    Expect(1, 2679, '\p{^Is_Script=	Gurmukhi}', "");
    Expect(1, 2679, '\P{Is_Script=	Gurmukhi}', "");
    Expect(0, 2679, '\P{^Is_Script=	Gurmukhi}', "");
    Error('\p{Is_Sc= _Guru:=}');
    Error('\P{Is_Sc= _Guru:=}');
    Expect(1, 2678, '\p{Is_Sc=guru}', "");
    Expect(0, 2678, '\p{^Is_Sc=guru}', "");
    Expect(0, 2678, '\P{Is_Sc=guru}', "");
    Expect(1, 2678, '\P{^Is_Sc=guru}', "");
    Expect(0, 2679, '\p{Is_Sc=guru}', "");
    Expect(1, 2679, '\p{^Is_Sc=guru}', "");
    Expect(1, 2679, '\P{Is_Sc=guru}', "");
    Expect(0, 2679, '\P{^Is_Sc=guru}', "");
    Expect(1, 2678, '\p{Is_Sc= GURU}', "");
    Expect(0, 2678, '\p{^Is_Sc= GURU}', "");
    Expect(0, 2678, '\P{Is_Sc= GURU}', "");
    Expect(1, 2678, '\P{^Is_Sc= GURU}', "");
    Expect(0, 2679, '\p{Is_Sc= GURU}', "");
    Expect(1, 2679, '\p{^Is_Sc= GURU}', "");
    Expect(1, 2679, '\P{Is_Sc= GURU}', "");
    Expect(0, 2679, '\P{^Is_Sc= GURU}', "");
    Error('\p{Script: __Hangul:=}');
    Error('\P{Script: __Hangul:=}');
    Expect(1, 65500, '\p{Script=:\AHangul\z:}', "");;
    Expect(0, 65501, '\p{Script=:\AHangul\z:}', "");;
    Expect(1, 65500, '\p{Script=hangul}', "");
    Expect(0, 65500, '\p{^Script=hangul}', "");
    Expect(0, 65500, '\P{Script=hangul}', "");
    Expect(1, 65500, '\P{^Script=hangul}', "");
    Expect(0, 65501, '\p{Script=hangul}', "");
    Expect(1, 65501, '\p{^Script=hangul}', "");
    Expect(1, 65501, '\P{Script=hangul}', "");
    Expect(0, 65501, '\P{^Script=hangul}', "");
    Expect(1, 65500, '\p{Script=:\Ahangul\z:}', "");;
    Expect(0, 65501, '\p{Script=:\Ahangul\z:}', "");;
    Expect(1, 65500, '\p{Script=_	Hangul}', "");
    Expect(0, 65500, '\p{^Script=_	Hangul}', "");
    Expect(0, 65500, '\P{Script=_	Hangul}', "");
    Expect(1, 65500, '\P{^Script=_	Hangul}', "");
    Expect(0, 65501, '\p{Script=_	Hangul}', "");
    Expect(1, 65501, '\p{^Script=_	Hangul}', "");
    Expect(1, 65501, '\P{Script=_	Hangul}', "");
    Expect(0, 65501, '\P{^Script=_	Hangul}', "");
    Error('\p{Sc:  :=HANG}');
    Error('\P{Sc:  :=HANG}');
    Expect(1, 65500, '\p{Sc=:\AHang\z:}', "");;
    Expect(0, 65501, '\p{Sc=:\AHang\z:}', "");;
    Expect(1, 65500, '\p{Sc=hang}', "");
    Expect(0, 65500, '\p{^Sc=hang}', "");
    Expect(0, 65500, '\P{Sc=hang}', "");
    Expect(1, 65500, '\P{^Sc=hang}', "");
    Expect(0, 65501, '\p{Sc=hang}', "");
    Expect(1, 65501, '\p{^Sc=hang}', "");
    Expect(1, 65501, '\P{Sc=hang}', "");
    Expect(0, 65501, '\P{^Sc=hang}', "");
    Expect(1, 65500, '\p{Sc=:\Ahang\z:}', "");;
    Expect(0, 65501, '\p{Sc=:\Ahang\z:}', "");;
    Expect(1, 65500, '\p{Sc: - HANG}', "");
    Expect(0, 65500, '\p{^Sc: - HANG}', "");
    Expect(0, 65500, '\P{Sc: - HANG}', "");
    Expect(1, 65500, '\P{^Sc: - HANG}', "");
    Expect(0, 65501, '\p{Sc: - HANG}', "");
    Expect(1, 65501, '\p{^Sc: - HANG}', "");
    Expect(1, 65501, '\P{Sc: - HANG}', "");
    Expect(0, 65501, '\P{^Sc: - HANG}', "");
    Error('\p{Is_Script:_/a/Hangul}');
    Error('\P{Is_Script:_/a/Hangul}');
    Expect(1, 65500, '\p{Is_Script=hangul}', "");
    Expect(0, 65500, '\p{^Is_Script=hangul}', "");
    Expect(0, 65500, '\P{Is_Script=hangul}', "");
    Expect(1, 65500, '\P{^Is_Script=hangul}', "");
    Expect(0, 65501, '\p{Is_Script=hangul}', "");
    Expect(1, 65501, '\p{^Is_Script=hangul}', "");
    Expect(1, 65501, '\P{Is_Script=hangul}', "");
    Expect(0, 65501, '\P{^Is_Script=hangul}', "");
    Expect(1, 65500, '\p{Is_Script=	hangul}', "");
    Expect(0, 65500, '\p{^Is_Script=	hangul}', "");
    Expect(0, 65500, '\P{Is_Script=	hangul}', "");
    Expect(1, 65500, '\P{^Is_Script=	hangul}', "");
    Expect(0, 65501, '\p{Is_Script=	hangul}', "");
    Expect(1, 65501, '\p{^Is_Script=	hangul}', "");
    Expect(1, 65501, '\P{Is_Script=	hangul}', "");
    Expect(0, 65501, '\P{^Is_Script=	hangul}', "");
    Error('\p{Is_Sc=_	HANG/a/}');
    Error('\P{Is_Sc=_	HANG/a/}');
    Expect(1, 65500, '\p{Is_Sc=hang}', "");
    Expect(0, 65500, '\p{^Is_Sc=hang}', "");
    Expect(0, 65500, '\P{Is_Sc=hang}', "");
    Expect(1, 65500, '\P{^Is_Sc=hang}', "");
    Expect(0, 65501, '\p{Is_Sc=hang}', "");
    Expect(1, 65501, '\p{^Is_Sc=hang}', "");
    Expect(1, 65501, '\P{Is_Sc=hang}', "");
    Expect(0, 65501, '\P{^Is_Sc=hang}', "");
    Expect(1, 65500, '\p{Is_Sc=_ Hang}', "");
    Expect(0, 65500, '\p{^Is_Sc=_ Hang}', "");
    Expect(0, 65500, '\P{Is_Sc=_ Hang}', "");
    Expect(1, 65500, '\P{^Is_Sc=_ Hang}', "");
    Expect(0, 65501, '\p{Is_Sc=_ Hang}', "");
    Expect(1, 65501, '\p{^Is_Sc=_ Hang}', "");
    Expect(1, 65501, '\P{Is_Sc=_ Hang}', "");
    Expect(0, 65501, '\P{^Is_Sc=_ Hang}', "");
    Error('\p{Script=/a/_Han}');
    Error('\P{Script=/a/_Han}');
    Expect(1, 205743, '\p{Script=:\AHan\z:}', "");;
    Expect(0, 205744, '\p{Script=:\AHan\z:}', "");;
    Expect(1, 205743, '\p{Script=han}', "");
    Expect(0, 205743, '\p{^Script=han}', "");
    Expect(0, 205743, '\P{Script=han}', "");
    Expect(1, 205743, '\P{^Script=han}', "");
    Expect(0, 205744, '\p{Script=han}', "");
    Expect(1, 205744, '\p{^Script=han}', "");
    Expect(1, 205744, '\P{Script=han}', "");
    Expect(0, 205744, '\P{^Script=han}', "");
    Expect(1, 205743, '\p{Script=:\Ahan\z:}', "");;
    Expect(0, 205744, '\p{Script=:\Ahan\z:}', "");;
    Expect(1, 205743, '\p{Script= han}', "");
    Expect(0, 205743, '\p{^Script= han}', "");
    Expect(0, 205743, '\P{Script= han}', "");
    Expect(1, 205743, '\P{^Script= han}', "");
    Expect(0, 205744, '\p{Script= han}', "");
    Expect(1, 205744, '\p{^Script= han}', "");
    Expect(1, 205744, '\P{Script= han}', "");
    Expect(0, 205744, '\P{^Script= han}', "");
    Error('\p{Sc=:=-	hani}');
    Error('\P{Sc=:=-	hani}');
    Expect(1, 205743, '\p{Sc=:\AHani\z:}', "");;
    Expect(0, 205744, '\p{Sc=:\AHani\z:}', "");;
    Expect(1, 205743, '\p{Sc=hani}', "");
    Expect(0, 205743, '\p{^Sc=hani}', "");
    Expect(0, 205743, '\P{Sc=hani}', "");
    Expect(1, 205743, '\P{^Sc=hani}', "");
    Expect(0, 205744, '\p{Sc=hani}', "");
    Expect(1, 205744, '\p{^Sc=hani}', "");
    Expect(1, 205744, '\P{Sc=hani}', "");
    Expect(0, 205744, '\P{^Sc=hani}', "");
    Expect(1, 205743, '\p{Sc=:\Ahani\z:}', "");;
    Expect(0, 205744, '\p{Sc=:\Ahani\z:}', "");;
    Expect(1, 205743, '\p{Sc=--HANI}', "");
    Expect(0, 205743, '\p{^Sc=--HANI}', "");
    Expect(0, 205743, '\P{Sc=--HANI}', "");
    Expect(1, 205743, '\P{^Sc=--HANI}', "");
    Expect(0, 205744, '\p{Sc=--HANI}', "");
    Expect(1, 205744, '\p{^Sc=--HANI}', "");
    Expect(1, 205744, '\P{Sc=--HANI}', "");
    Expect(0, 205744, '\P{^Sc=--HANI}', "");
    Error('\p{Is_Script=:=	-Han}');
    Error('\P{Is_Script=:=	-Han}');
    Expect(1, 205743, '\p{Is_Script=han}', "");
    Expect(0, 205743, '\p{^Is_Script=han}', "");
    Expect(0, 205743, '\P{Is_Script=han}', "");
    Expect(1, 205743, '\P{^Is_Script=han}', "");
    Expect(0, 205744, '\p{Is_Script=han}', "");
    Expect(1, 205744, '\p{^Is_Script=han}', "");
    Expect(1, 205744, '\P{Is_Script=han}', "");
    Expect(0, 205744, '\P{^Is_Script=han}', "");
    Expect(1, 205743, '\p{Is_Script= _HAN}', "");
    Expect(0, 205743, '\p{^Is_Script= _HAN}', "");
    Expect(0, 205743, '\P{Is_Script= _HAN}', "");
    Expect(1, 205743, '\P{^Is_Script= _HAN}', "");
    Expect(0, 205744, '\p{Is_Script= _HAN}', "");
    Expect(1, 205744, '\p{^Is_Script= _HAN}', "");
    Expect(1, 205744, '\P{Is_Script= _HAN}', "");
    Expect(0, 205744, '\P{^Is_Script= _HAN}', "");
    Error('\p{Is_Sc=/a/Hani}');
    Error('\P{Is_Sc=/a/Hani}');
    Expect(1, 205743, '\p{Is_Sc=hani}', "");
    Expect(0, 205743, '\p{^Is_Sc=hani}', "");
    Expect(0, 205743, '\P{Is_Sc=hani}', "");
    Expect(1, 205743, '\P{^Is_Sc=hani}', "");
    Expect(0, 205744, '\p{Is_Sc=hani}', "");
    Expect(1, 205744, '\p{^Is_Sc=hani}', "");
    Expect(1, 205744, '\P{Is_Sc=hani}', "");
    Expect(0, 205744, '\P{^Is_Sc=hani}', "");
    Expect(1, 205743, '\p{Is_Sc=_	Hani}', "");
    Expect(0, 205743, '\p{^Is_Sc=_	Hani}', "");
    Expect(0, 205743, '\P{Is_Sc=_	Hani}', "");
    Expect(1, 205743, '\P{^Is_Sc=_	Hani}', "");
    Expect(0, 205744, '\p{Is_Sc=_	Hani}', "");
    Expect(1, 205744, '\p{^Is_Sc=_	Hani}', "");
    Expect(1, 205744, '\P{Is_Sc=_	Hani}', "");
    Expect(0, 205744, '\P{^Is_Sc=_	Hani}', "");
    Error('\p{Script=  Hanunoo:=}');
    Error('\P{Script=  Hanunoo:=}');
    Expect(1, 5940, '\p{Script=:\AHanunoo\z:}', "");;
    Expect(0, 5941, '\p{Script=:\AHanunoo\z:}', "");;
    Expect(1, 5940, '\p{Script=hanunoo}', "");
    Expect(0, 5940, '\p{^Script=hanunoo}', "");
    Expect(0, 5940, '\P{Script=hanunoo}', "");
    Expect(1, 5940, '\P{^Script=hanunoo}', "");
    Expect(0, 5941, '\p{Script=hanunoo}', "");
    Expect(1, 5941, '\p{^Script=hanunoo}', "");
    Expect(1, 5941, '\P{Script=hanunoo}', "");
    Expect(0, 5941, '\P{^Script=hanunoo}', "");
    Expect(1, 5940, '\p{Script=:\Ahanunoo\z:}', "");;
    Expect(0, 5941, '\p{Script=:\Ahanunoo\z:}', "");;
    Expect(1, 5940, '\p{Script=_-Hanunoo}', "");
    Expect(0, 5940, '\p{^Script=_-Hanunoo}', "");
    Expect(0, 5940, '\P{Script=_-Hanunoo}', "");
    Expect(1, 5940, '\P{^Script=_-Hanunoo}', "");
    Expect(0, 5941, '\p{Script=_-Hanunoo}', "");
    Expect(1, 5941, '\p{^Script=_-Hanunoo}', "");
    Expect(1, 5941, '\P{Script=_-Hanunoo}', "");
    Expect(0, 5941, '\P{^Script=_-Hanunoo}', "");
    Error('\p{Sc= :=HANO}');
    Error('\P{Sc= :=HANO}');
    Expect(1, 5940, '\p{Sc=:\AHano\z:}', "");;
    Expect(0, 5941, '\p{Sc=:\AHano\z:}', "");;
    Expect(1, 5940, '\p{Sc=hano}', "");
    Expect(0, 5940, '\p{^Sc=hano}', "");
    Expect(0, 5940, '\P{Sc=hano}', "");
    Expect(1, 5940, '\P{^Sc=hano}', "");
    Expect(0, 5941, '\p{Sc=hano}', "");
    Expect(1, 5941, '\p{^Sc=hano}', "");
    Expect(1, 5941, '\P{Sc=hano}', "");
    Expect(0, 5941, '\P{^Sc=hano}', "");
    Expect(1, 5940, '\p{Sc=:\Ahano\z:}', "");;
    Expect(0, 5941, '\p{Sc=:\Ahano\z:}', "");;
    Expect(1, 5940, '\p{Sc=	_Hano}', "");
    Expect(0, 5940, '\p{^Sc=	_Hano}', "");
    Expect(0, 5940, '\P{Sc=	_Hano}', "");
    Expect(1, 5940, '\P{^Sc=	_Hano}', "");
    Expect(0, 5941, '\p{Sc=	_Hano}', "");
    Expect(1, 5941, '\p{^Sc=	_Hano}', "");
    Expect(1, 5941, '\P{Sc=	_Hano}', "");
    Expect(0, 5941, '\P{^Sc=	_Hano}', "");
    Error('\p{Is_Script=- Hanunoo:=}');
    Error('\P{Is_Script=- Hanunoo:=}');
    Expect(1, 5940, '\p{Is_Script=hanunoo}', "");
    Expect(0, 5940, '\p{^Is_Script=hanunoo}', "");
    Expect(0, 5940, '\P{Is_Script=hanunoo}', "");
    Expect(1, 5940, '\P{^Is_Script=hanunoo}', "");
    Expect(0, 5941, '\p{Is_Script=hanunoo}', "");
    Expect(1, 5941, '\p{^Is_Script=hanunoo}', "");
    Expect(1, 5941, '\P{Is_Script=hanunoo}', "");
    Expect(0, 5941, '\P{^Is_Script=hanunoo}', "");
    Expect(1, 5940, '\p{Is_Script: - hanunoo}', "");
    Expect(0, 5940, '\p{^Is_Script: - hanunoo}', "");
    Expect(0, 5940, '\P{Is_Script: - hanunoo}', "");
    Expect(1, 5940, '\P{^Is_Script: - hanunoo}', "");
    Expect(0, 5941, '\p{Is_Script: - hanunoo}', "");
    Expect(1, 5941, '\p{^Is_Script: - hanunoo}', "");
    Expect(1, 5941, '\P{Is_Script: - hanunoo}', "");
    Expect(0, 5941, '\P{^Is_Script: - hanunoo}', "");
    Error('\p{Is_Sc=_-hano/a/}');
    Error('\P{Is_Sc=_-hano/a/}');
    Expect(1, 5940, '\p{Is_Sc=hano}', "");
    Expect(0, 5940, '\p{^Is_Sc=hano}', "");
    Expect(0, 5940, '\P{Is_Sc=hano}', "");
    Expect(1, 5940, '\P{^Is_Sc=hano}', "");
    Expect(0, 5941, '\p{Is_Sc=hano}', "");
    Expect(1, 5941, '\p{^Is_Sc=hano}', "");
    Expect(1, 5941, '\P{Is_Sc=hano}', "");
    Expect(0, 5941, '\P{^Is_Sc=hano}', "");
    Expect(1, 5940, '\p{Is_Sc=	-Hano}', "");
    Expect(0, 5940, '\p{^Is_Sc=	-Hano}', "");
    Expect(0, 5940, '\P{Is_Sc=	-Hano}', "");
    Expect(1, 5940, '\P{^Is_Sc=	-Hano}', "");
    Expect(0, 5941, '\p{Is_Sc=	-Hano}', "");
    Expect(1, 5941, '\p{^Is_Sc=	-Hano}', "");
    Expect(1, 5941, '\P{Is_Sc=	-Hano}', "");
    Expect(0, 5941, '\P{^Is_Sc=	-Hano}', "");
    Error('\p{Script=_:=Hatran}');
    Error('\P{Script=_:=Hatran}');
    Expect(1, 67839, '\p{Script=:\AHatran\z:}', "");;
    Expect(0, 67840, '\p{Script=:\AHatran\z:}', "");;
    Expect(1, 67839, '\p{Script=hatran}', "");
    Expect(0, 67839, '\p{^Script=hatran}', "");
    Expect(0, 67839, '\P{Script=hatran}', "");
    Expect(1, 67839, '\P{^Script=hatran}', "");
    Expect(0, 67840, '\p{Script=hatran}', "");
    Expect(1, 67840, '\p{^Script=hatran}', "");
    Expect(1, 67840, '\P{Script=hatran}', "");
    Expect(0, 67840, '\P{^Script=hatran}', "");
    Expect(1, 67839, '\p{Script=:\Ahatran\z:}', "");;
    Expect(0, 67840, '\p{Script=:\Ahatran\z:}', "");;
    Expect(1, 67839, '\p{Script=--Hatran}', "");
    Expect(0, 67839, '\p{^Script=--Hatran}', "");
    Expect(0, 67839, '\P{Script=--Hatran}', "");
    Expect(1, 67839, '\P{^Script=--Hatran}', "");
    Expect(0, 67840, '\p{Script=--Hatran}', "");
    Expect(1, 67840, '\p{^Script=--Hatran}', "");
    Expect(1, 67840, '\P{Script=--Hatran}', "");
    Expect(0, 67840, '\P{^Script=--Hatran}', "");
    Error('\p{Sc=-/a/hatr}');
    Error('\P{Sc=-/a/hatr}');
    Expect(1, 67839, '\p{Sc=:\AHatr\z:}', "");;
    Expect(0, 67840, '\p{Sc=:\AHatr\z:}', "");;
    Expect(1, 67839, '\p{Sc=hatr}', "");
    Expect(0, 67839, '\p{^Sc=hatr}', "");
    Expect(0, 67839, '\P{Sc=hatr}', "");
    Expect(1, 67839, '\P{^Sc=hatr}', "");
    Expect(0, 67840, '\p{Sc=hatr}', "");
    Expect(1, 67840, '\p{^Sc=hatr}', "");
    Expect(1, 67840, '\P{Sc=hatr}', "");
    Expect(0, 67840, '\P{^Sc=hatr}', "");
    Expect(1, 67839, '\p{Sc=:\Ahatr\z:}', "");;
    Expect(0, 67840, '\p{Sc=:\Ahatr\z:}', "");;
    Expect(1, 67839, '\p{Sc=		HATR}', "");
    Expect(0, 67839, '\p{^Sc=		HATR}', "");
    Expect(0, 67839, '\P{Sc=		HATR}', "");
    Expect(1, 67839, '\P{^Sc=		HATR}', "");
    Expect(0, 67840, '\p{Sc=		HATR}', "");
    Expect(1, 67840, '\p{^Sc=		HATR}', "");
    Expect(1, 67840, '\P{Sc=		HATR}', "");
    Expect(0, 67840, '\P{^Sc=		HATR}', "");
    Error('\p{Is_Script=:= -Hatran}');
    Error('\P{Is_Script=:= -Hatran}');
    Expect(1, 67839, '\p{Is_Script=hatran}', "");
    Expect(0, 67839, '\p{^Is_Script=hatran}', "");
    Expect(0, 67839, '\P{Is_Script=hatran}', "");
    Expect(1, 67839, '\P{^Is_Script=hatran}', "");
    Expect(0, 67840, '\p{Is_Script=hatran}', "");
    Expect(1, 67840, '\p{^Is_Script=hatran}', "");
    Expect(1, 67840, '\P{Is_Script=hatran}', "");
    Expect(0, 67840, '\P{^Is_Script=hatran}', "");
    Expect(1, 67839, '\p{Is_Script=- Hatran}', "");
    Expect(0, 67839, '\p{^Is_Script=- Hatran}', "");
    Expect(0, 67839, '\P{Is_Script=- Hatran}', "");
    Expect(1, 67839, '\P{^Is_Script=- Hatran}', "");
    Expect(0, 67840, '\p{Is_Script=- Hatran}', "");
    Expect(1, 67840, '\p{^Is_Script=- Hatran}', "");
    Expect(1, 67840, '\P{Is_Script=- Hatran}', "");
    Expect(0, 67840, '\P{^Is_Script=- Hatran}', "");
    Error('\p{Is_Sc=	HATR:=}');
    Error('\P{Is_Sc=	HATR:=}');
    Expect(1, 67839, '\p{Is_Sc: hatr}', "");
    Expect(0, 67839, '\p{^Is_Sc: hatr}', "");
    Expect(0, 67839, '\P{Is_Sc: hatr}', "");
    Expect(1, 67839, '\P{^Is_Sc: hatr}', "");
    Expect(0, 67840, '\p{Is_Sc: hatr}', "");
    Expect(1, 67840, '\p{^Is_Sc: hatr}', "");
    Expect(1, 67840, '\P{Is_Sc: hatr}', "");
    Expect(0, 67840, '\P{^Is_Sc: hatr}', "");
    Expect(1, 67839, '\p{Is_Sc:	 _HATR}', "");
    Expect(0, 67839, '\p{^Is_Sc:	 _HATR}', "");
    Expect(0, 67839, '\P{Is_Sc:	 _HATR}', "");
    Expect(1, 67839, '\P{^Is_Sc:	 _HATR}', "");
    Expect(0, 67840, '\p{Is_Sc:	 _HATR}', "");
    Expect(1, 67840, '\p{^Is_Sc:	 _HATR}', "");
    Expect(1, 67840, '\P{Is_Sc:	 _HATR}', "");
    Expect(0, 67840, '\P{^Is_Sc:	 _HATR}', "");
    Error('\p{Script=/a/		Hebrew}');
    Error('\P{Script=/a/		Hebrew}');
    Expect(1, 64335, '\p{Script=:\AHebrew\z:}', "");;
    Expect(0, 64336, '\p{Script=:\AHebrew\z:}', "");;
    Expect(1, 64335, '\p{Script=hebrew}', "");
    Expect(0, 64335, '\p{^Script=hebrew}', "");
    Expect(0, 64335, '\P{Script=hebrew}', "");
    Expect(1, 64335, '\P{^Script=hebrew}', "");
    Expect(0, 64336, '\p{Script=hebrew}', "");
    Expect(1, 64336, '\p{^Script=hebrew}', "");
    Expect(1, 64336, '\P{Script=hebrew}', "");
    Expect(0, 64336, '\P{^Script=hebrew}', "");
    Expect(1, 64335, '\p{Script=:\Ahebrew\z:}', "");;
    Expect(0, 64336, '\p{Script=:\Ahebrew\z:}', "");;
    Expect(1, 64335, '\p{Script= Hebrew}', "");
    Expect(0, 64335, '\p{^Script= Hebrew}', "");
    Expect(0, 64335, '\P{Script= Hebrew}', "");
    Expect(1, 64335, '\P{^Script= Hebrew}', "");
    Expect(0, 64336, '\p{Script= Hebrew}', "");
    Expect(1, 64336, '\p{^Script= Hebrew}', "");
    Expect(1, 64336, '\P{Script= Hebrew}', "");
    Expect(0, 64336, '\P{^Script= Hebrew}', "");
    Error('\p{Sc:		 HEBR/a/}');
    Error('\P{Sc:		 HEBR/a/}');
    Expect(1, 64335, '\p{Sc=:\AHebr\z:}', "");;
    Expect(0, 64336, '\p{Sc=:\AHebr\z:}', "");;
    Expect(1, 64335, '\p{Sc:	hebr}', "");
    Expect(0, 64335, '\p{^Sc:	hebr}', "");
    Expect(0, 64335, '\P{Sc:	hebr}', "");
    Expect(1, 64335, '\P{^Sc:	hebr}', "");
    Expect(0, 64336, '\p{Sc:	hebr}', "");
    Expect(1, 64336, '\p{^Sc:	hebr}', "");
    Expect(1, 64336, '\P{Sc:	hebr}', "");
    Expect(0, 64336, '\P{^Sc:	hebr}', "");
    Expect(1, 64335, '\p{Sc=:\Ahebr\z:}', "");;
    Expect(0, 64336, '\p{Sc=:\Ahebr\z:}', "");;
    Expect(1, 64335, '\p{Sc= 	hebr}', "");
    Expect(0, 64335, '\p{^Sc= 	hebr}', "");
    Expect(0, 64335, '\P{Sc= 	hebr}', "");
    Expect(1, 64335, '\P{^Sc= 	hebr}', "");
    Expect(0, 64336, '\p{Sc= 	hebr}', "");
    Expect(1, 64336, '\p{^Sc= 	hebr}', "");
    Expect(1, 64336, '\P{Sc= 	hebr}', "");
    Expect(0, 64336, '\P{^Sc= 	hebr}', "");
    Error('\p{Is_Script= :=HEBREW}');
    Error('\P{Is_Script= :=HEBREW}');
    Expect(1, 64335, '\p{Is_Script=hebrew}', "");
    Expect(0, 64335, '\p{^Is_Script=hebrew}', "");
    Expect(0, 64335, '\P{Is_Script=hebrew}', "");
    Expect(1, 64335, '\P{^Is_Script=hebrew}', "");
    Expect(0, 64336, '\p{Is_Script=hebrew}', "");
    Expect(1, 64336, '\p{^Is_Script=hebrew}', "");
    Expect(1, 64336, '\P{Is_Script=hebrew}', "");
    Expect(0, 64336, '\P{^Is_Script=hebrew}', "");
    Expect(1, 64335, '\p{Is_Script=__Hebrew}', "");
    Expect(0, 64335, '\p{^Is_Script=__Hebrew}', "");
    Expect(0, 64335, '\P{Is_Script=__Hebrew}', "");
    Expect(1, 64335, '\P{^Is_Script=__Hebrew}', "");
    Expect(0, 64336, '\p{Is_Script=__Hebrew}', "");
    Expect(1, 64336, '\p{^Is_Script=__Hebrew}', "");
    Expect(1, 64336, '\P{Is_Script=__Hebrew}', "");
    Expect(0, 64336, '\P{^Is_Script=__Hebrew}', "");
    Error('\p{Is_Sc=		hebr:=}');
    Error('\P{Is_Sc=		hebr:=}');
    Expect(1, 64335, '\p{Is_Sc=hebr}', "");
    Expect(0, 64335, '\p{^Is_Sc=hebr}', "");
    Expect(0, 64335, '\P{Is_Sc=hebr}', "");
    Expect(1, 64335, '\P{^Is_Sc=hebr}', "");
    Expect(0, 64336, '\p{Is_Sc=hebr}', "");
    Expect(1, 64336, '\p{^Is_Sc=hebr}', "");
    Expect(1, 64336, '\P{Is_Sc=hebr}', "");
    Expect(0, 64336, '\P{^Is_Sc=hebr}', "");
    Expect(1, 64335, '\p{Is_Sc:	-_Hebr}', "");
    Expect(0, 64335, '\p{^Is_Sc:	-_Hebr}', "");
    Expect(0, 64335, '\P{Is_Sc:	-_Hebr}', "");
    Expect(1, 64335, '\P{^Is_Sc:	-_Hebr}', "");
    Expect(0, 64336, '\p{Is_Sc:	-_Hebr}', "");
    Expect(1, 64336, '\p{^Is_Sc:	-_Hebr}', "");
    Expect(1, 64336, '\P{Is_Sc:	-_Hebr}', "");
    Expect(0, 64336, '\P{^Is_Sc:	-_Hebr}', "");
    Error('\p{Script=-/a/Hiragana}');
    Error('\P{Script=-/a/Hiragana}');
    Expect(1, 127488, '\p{Script=:\AHiragana\z:}', "");;
    Expect(0, 127489, '\p{Script=:\AHiragana\z:}', "");;
    Expect(1, 127488, '\p{Script:   hiragana}', "");
    Expect(0, 127488, '\p{^Script:   hiragana}', "");
    Expect(0, 127488, '\P{Script:   hiragana}', "");
    Expect(1, 127488, '\P{^Script:   hiragana}', "");
    Expect(0, 127489, '\p{Script:   hiragana}', "");
    Expect(1, 127489, '\p{^Script:   hiragana}', "");
    Expect(1, 127489, '\P{Script:   hiragana}', "");
    Expect(0, 127489, '\P{^Script:   hiragana}', "");
    Expect(1, 127488, '\p{Script=:\Ahiragana\z:}', "");;
    Expect(0, 127489, '\p{Script=:\Ahiragana\z:}', "");;
    Expect(1, 127488, '\p{Script:   -Hiragana}', "");
    Expect(0, 127488, '\p{^Script:   -Hiragana}', "");
    Expect(0, 127488, '\P{Script:   -Hiragana}', "");
    Expect(1, 127488, '\P{^Script:   -Hiragana}', "");
    Expect(0, 127489, '\p{Script:   -Hiragana}', "");
    Expect(1, 127489, '\p{^Script:   -Hiragana}', "");
    Expect(1, 127489, '\P{Script:   -Hiragana}', "");
    Expect(0, 127489, '\P{^Script:   -Hiragana}', "");
    Error('\p{Sc=- HIRA/a/}');
    Error('\P{Sc=- HIRA/a/}');
    Expect(1, 127488, '\p{Sc=:\AHira\z:}', "");;
    Expect(0, 127489, '\p{Sc=:\AHira\z:}', "");;
    Expect(1, 127488, '\p{Sc=hira}', "");
    Expect(0, 127488, '\p{^Sc=hira}', "");
    Expect(0, 127488, '\P{Sc=hira}', "");
    Expect(1, 127488, '\P{^Sc=hira}', "");
    Expect(0, 127489, '\p{Sc=hira}', "");
    Expect(1, 127489, '\p{^Sc=hira}', "");
    Expect(1, 127489, '\P{Sc=hira}', "");
    Expect(0, 127489, '\P{^Sc=hira}', "");
    Expect(1, 127488, '\p{Sc=:\Ahira\z:}', "");;
    Expect(0, 127489, '\p{Sc=:\Ahira\z:}', "");;
    Error('\p{Is_Script=/a/		HIRAGANA}');
    Error('\P{Is_Script=/a/		HIRAGANA}');
    Expect(1, 127488, '\p{Is_Script=hiragana}', "");
    Expect(0, 127488, '\p{^Is_Script=hiragana}', "");
    Expect(0, 127488, '\P{Is_Script=hiragana}', "");
    Expect(1, 127488, '\P{^Is_Script=hiragana}', "");
    Expect(0, 127489, '\p{Is_Script=hiragana}', "");
    Expect(1, 127489, '\p{^Is_Script=hiragana}', "");
    Expect(1, 127489, '\P{Is_Script=hiragana}', "");
    Expect(0, 127489, '\P{^Is_Script=hiragana}', "");
    Expect(1, 127488, '\p{Is_Script=--HIRAGANA}', "");
    Expect(0, 127488, '\p{^Is_Script=--HIRAGANA}', "");
    Expect(0, 127488, '\P{Is_Script=--HIRAGANA}', "");
    Expect(1, 127488, '\P{^Is_Script=--HIRAGANA}', "");
    Expect(0, 127489, '\p{Is_Script=--HIRAGANA}', "");
    Expect(1, 127489, '\p{^Is_Script=--HIRAGANA}', "");
    Expect(1, 127489, '\P{Is_Script=--HIRAGANA}', "");
    Expect(0, 127489, '\P{^Is_Script=--HIRAGANA}', "");
    Error('\p{Is_Sc=/a/	_hira}');
    Error('\P{Is_Sc=/a/	_hira}');
    Expect(1, 127488, '\p{Is_Sc=hira}', "");
    Expect(0, 127488, '\p{^Is_Sc=hira}', "");
    Expect(0, 127488, '\P{Is_Sc=hira}', "");
    Expect(1, 127488, '\P{^Is_Sc=hira}', "");
    Expect(0, 127489, '\p{Is_Sc=hira}', "");
    Expect(1, 127489, '\p{^Is_Sc=hira}', "");
    Expect(1, 127489, '\P{Is_Sc=hira}', "");
    Expect(0, 127489, '\P{^Is_Sc=hira}', "");
    Expect(1, 127488, '\p{Is_Sc=HIRA}', "");
    Expect(0, 127488, '\p{^Is_Sc=HIRA}', "");
    Expect(0, 127488, '\P{Is_Sc=HIRA}', "");
    Expect(1, 127488, '\P{^Is_Sc=HIRA}', "");
    Expect(0, 127489, '\p{Is_Sc=HIRA}', "");
    Expect(1, 127489, '\p{^Is_Sc=HIRA}', "");
    Expect(1, 127489, '\P{Is_Sc=HIRA}', "");
    Expect(0, 127489, '\P{^Is_Sc=HIRA}', "");
    Error('\p{Script=-:=Anatolian_hieroglyphs}');
    Error('\P{Script=-:=Anatolian_hieroglyphs}');
    Expect(1, 83526, '\p{Script=:\AAnatolian_Hieroglyphs\z:}', "");;
    Expect(0, 83527, '\p{Script=:\AAnatolian_Hieroglyphs\z:}', "");;
    Expect(1, 83526, '\p{Script=anatolianhieroglyphs}', "");
    Expect(0, 83526, '\p{^Script=anatolianhieroglyphs}', "");
    Expect(0, 83526, '\P{Script=anatolianhieroglyphs}', "");
    Expect(1, 83526, '\P{^Script=anatolianhieroglyphs}', "");
    Expect(0, 83527, '\p{Script=anatolianhieroglyphs}', "");
    Expect(1, 83527, '\p{^Script=anatolianhieroglyphs}', "");
    Expect(1, 83527, '\P{Script=anatolianhieroglyphs}', "");
    Expect(0, 83527, '\P{^Script=anatolianhieroglyphs}', "");
    Expect(1, 83526, '\p{Script=:\Aanatolianhieroglyphs\z:}', "");;
    Expect(0, 83527, '\p{Script=:\Aanatolianhieroglyphs\z:}', "");;
    Expect(1, 83526, '\p{Script:_anatolian_Hieroglyphs}', "");
    Expect(0, 83526, '\p{^Script:_anatolian_Hieroglyphs}', "");
    Expect(0, 83526, '\P{Script:_anatolian_Hieroglyphs}', "");
    Expect(1, 83526, '\P{^Script:_anatolian_Hieroglyphs}', "");
    Expect(0, 83527, '\p{Script:_anatolian_Hieroglyphs}', "");
    Expect(1, 83527, '\p{^Script:_anatolian_Hieroglyphs}', "");
    Expect(1, 83527, '\P{Script:_anatolian_Hieroglyphs}', "");
    Expect(0, 83527, '\P{^Script:_anatolian_Hieroglyphs}', "");
    Error('\p{Sc=	HLUW:=}');
    Error('\P{Sc=	HLUW:=}');
    Expect(1, 83526, '\p{Sc=:\AHluw\z:}', "");;
    Expect(0, 83527, '\p{Sc=:\AHluw\z:}', "");;
    Expect(1, 83526, '\p{Sc=hluw}', "");
    Expect(0, 83526, '\p{^Sc=hluw}', "");
    Expect(0, 83526, '\P{Sc=hluw}', "");
    Expect(1, 83526, '\P{^Sc=hluw}', "");
    Expect(0, 83527, '\p{Sc=hluw}', "");
    Expect(1, 83527, '\p{^Sc=hluw}', "");
    Expect(1, 83527, '\P{Sc=hluw}', "");
    Expect(0, 83527, '\P{^Sc=hluw}', "");
    Expect(1, 83526, '\p{Sc=:\Ahluw\z:}', "");;
    Expect(0, 83527, '\p{Sc=:\Ahluw\z:}', "");;
    Expect(1, 83526, '\p{Sc= hluw}', "");
    Expect(0, 83526, '\p{^Sc= hluw}', "");
    Expect(0, 83526, '\P{Sc= hluw}', "");
    Expect(1, 83526, '\P{^Sc= hluw}', "");
    Expect(0, 83527, '\p{Sc= hluw}', "");
    Expect(1, 83527, '\p{^Sc= hluw}', "");
    Expect(1, 83527, '\P{Sc= hluw}', "");
    Expect(0, 83527, '\P{^Sc= hluw}', "");
    Error('\p{Is_Script=_ANATOLIAN_hieroglyphs/a/}');
    Error('\P{Is_Script=_ANATOLIAN_hieroglyphs/a/}');
    Expect(1, 83526, '\p{Is_Script:	anatolianhieroglyphs}', "");
    Expect(0, 83526, '\p{^Is_Script:	anatolianhieroglyphs}', "");
    Expect(0, 83526, '\P{Is_Script:	anatolianhieroglyphs}', "");
    Expect(1, 83526, '\P{^Is_Script:	anatolianhieroglyphs}', "");
    Expect(0, 83527, '\p{Is_Script:	anatolianhieroglyphs}', "");
    Expect(1, 83527, '\p{^Is_Script:	anatolianhieroglyphs}', "");
    Expect(1, 83527, '\P{Is_Script:	anatolianhieroglyphs}', "");
    Expect(0, 83527, '\P{^Is_Script:	anatolianhieroglyphs}', "");
    Expect(1, 83526, '\p{Is_Script=Anatolian_Hieroglyphs}', "");
    Expect(0, 83526, '\p{^Is_Script=Anatolian_Hieroglyphs}', "");
    Expect(0, 83526, '\P{Is_Script=Anatolian_Hieroglyphs}', "");
    Expect(1, 83526, '\P{^Is_Script=Anatolian_Hieroglyphs}', "");
    Expect(0, 83527, '\p{Is_Script=Anatolian_Hieroglyphs}', "");
    Expect(1, 83527, '\p{^Is_Script=Anatolian_Hieroglyphs}', "");
    Expect(1, 83527, '\P{Is_Script=Anatolian_Hieroglyphs}', "");
    Expect(0, 83527, '\P{^Is_Script=Anatolian_Hieroglyphs}', "");
    Error('\p{Is_Sc:	/a/-Hluw}');
    Error('\P{Is_Sc:	/a/-Hluw}');
    Expect(1, 83526, '\p{Is_Sc=hluw}', "");
    Expect(0, 83526, '\p{^Is_Sc=hluw}', "");
    Expect(0, 83526, '\P{Is_Sc=hluw}', "");
    Expect(1, 83526, '\P{^Is_Sc=hluw}', "");
    Expect(0, 83527, '\p{Is_Sc=hluw}', "");
    Expect(1, 83527, '\p{^Is_Sc=hluw}', "");
    Expect(1, 83527, '\P{Is_Sc=hluw}', "");
    Expect(0, 83527, '\P{^Is_Sc=hluw}', "");
    Expect(1, 83526, '\p{Is_Sc=	-hluw}', "");
    Expect(0, 83526, '\p{^Is_Sc=	-hluw}', "");
    Expect(0, 83526, '\P{Is_Sc=	-hluw}', "");
    Expect(1, 83526, '\P{^Is_Sc=	-hluw}', "");
    Expect(0, 83527, '\p{Is_Sc=	-hluw}', "");
    Expect(1, 83527, '\p{^Is_Sc=	-hluw}', "");
    Expect(1, 83527, '\P{Is_Sc=	-hluw}', "");
    Expect(0, 83527, '\P{^Is_Sc=	-hluw}', "");
    Error('\p{Script: _:=Pahawh_Hmong}');
    Error('\P{Script: _:=Pahawh_Hmong}');
    Expect(1, 93071, '\p{Script=:\APahawh_Hmong\z:}', "");;
    Expect(0, 93072, '\p{Script=:\APahawh_Hmong\z:}', "");;
    Expect(1, 93071, '\p{Script=pahawhhmong}', "");
    Expect(0, 93071, '\p{^Script=pahawhhmong}', "");
    Expect(0, 93071, '\P{Script=pahawhhmong}', "");
    Expect(1, 93071, '\P{^Script=pahawhhmong}', "");
    Expect(0, 93072, '\p{Script=pahawhhmong}', "");
    Expect(1, 93072, '\p{^Script=pahawhhmong}', "");
    Expect(1, 93072, '\P{Script=pahawhhmong}', "");
    Expect(0, 93072, '\P{^Script=pahawhhmong}', "");
    Expect(1, 93071, '\p{Script=:\Apahawhhmong\z:}', "");;
    Expect(0, 93072, '\p{Script=:\Apahawhhmong\z:}', "");;
    Expect(1, 93071, '\p{Script= -Pahawh_Hmong}', "");
    Expect(0, 93071, '\p{^Script= -Pahawh_Hmong}', "");
    Expect(0, 93071, '\P{Script= -Pahawh_Hmong}', "");
    Expect(1, 93071, '\P{^Script= -Pahawh_Hmong}', "");
    Expect(0, 93072, '\p{Script= -Pahawh_Hmong}', "");
    Expect(1, 93072, '\p{^Script= -Pahawh_Hmong}', "");
    Expect(1, 93072, '\P{Script= -Pahawh_Hmong}', "");
    Expect(0, 93072, '\P{^Script= -Pahawh_Hmong}', "");
    Error('\p{Sc=-/a/Hmng}');
    Error('\P{Sc=-/a/Hmng}');
    Expect(1, 93071, '\p{Sc=:\AHmng\z:}', "");;
    Expect(0, 93072, '\p{Sc=:\AHmng\z:}', "");;
    Expect(1, 93071, '\p{Sc=hmng}', "");
    Expect(0, 93071, '\p{^Sc=hmng}', "");
    Expect(0, 93071, '\P{Sc=hmng}', "");
    Expect(1, 93071, '\P{^Sc=hmng}', "");
    Expect(0, 93072, '\p{Sc=hmng}', "");
    Expect(1, 93072, '\p{^Sc=hmng}', "");
    Expect(1, 93072, '\P{Sc=hmng}', "");
    Expect(0, 93072, '\P{^Sc=hmng}', "");
    Expect(1, 93071, '\p{Sc=:\Ahmng\z:}', "");;
    Expect(0, 93072, '\p{Sc=:\Ahmng\z:}', "");;
    Expect(1, 93071, '\p{Sc=	Hmng}', "");
    Expect(0, 93071, '\p{^Sc=	Hmng}', "");
    Expect(0, 93071, '\P{Sc=	Hmng}', "");
    Expect(1, 93071, '\P{^Sc=	Hmng}', "");
    Expect(0, 93072, '\p{Sc=	Hmng}', "");
    Expect(1, 93072, '\p{^Sc=	Hmng}', "");
    Expect(1, 93072, '\P{Sc=	Hmng}', "");
    Expect(0, 93072, '\P{^Sc=	Hmng}', "");
    Error('\p{Is_Script=:=-_pahawh_Hmong}');
    Error('\P{Is_Script=:=-_pahawh_Hmong}');
    Expect(1, 93071, '\p{Is_Script=pahawhhmong}', "");
    Expect(0, 93071, '\p{^Is_Script=pahawhhmong}', "");
    Expect(0, 93071, '\P{Is_Script=pahawhhmong}', "");
    Expect(1, 93071, '\P{^Is_Script=pahawhhmong}', "");
    Expect(0, 93072, '\p{Is_Script=pahawhhmong}', "");
    Expect(1, 93072, '\p{^Is_Script=pahawhhmong}', "");
    Expect(1, 93072, '\P{Is_Script=pahawhhmong}', "");
    Expect(0, 93072, '\P{^Is_Script=pahawhhmong}', "");
    Expect(1, 93071, '\p{Is_Script=-	Pahawh_hmong}', "");
    Expect(0, 93071, '\p{^Is_Script=-	Pahawh_hmong}', "");
    Expect(0, 93071, '\P{Is_Script=-	Pahawh_hmong}', "");
    Expect(1, 93071, '\P{^Is_Script=-	Pahawh_hmong}', "");
    Expect(0, 93072, '\p{Is_Script=-	Pahawh_hmong}', "");
    Expect(1, 93072, '\p{^Is_Script=-	Pahawh_hmong}', "");
    Expect(1, 93072, '\P{Is_Script=-	Pahawh_hmong}', "");
    Expect(0, 93072, '\P{^Is_Script=-	Pahawh_hmong}', "");
    Error('\p{Is_Sc:   /a/-Hmng}');
    Error('\P{Is_Sc:   /a/-Hmng}');
    Expect(1, 93071, '\p{Is_Sc=hmng}', "");
    Expect(0, 93071, '\p{^Is_Sc=hmng}', "");
    Expect(0, 93071, '\P{Is_Sc=hmng}', "");
    Expect(1, 93071, '\P{^Is_Sc=hmng}', "");
    Expect(0, 93072, '\p{Is_Sc=hmng}', "");
    Expect(1, 93072, '\p{^Is_Sc=hmng}', "");
    Expect(1, 93072, '\P{Is_Sc=hmng}', "");
    Expect(0, 93072, '\P{^Is_Sc=hmng}', "");
    Expect(1, 93071, '\p{Is_Sc=		Hmng}', "");
    Expect(0, 93071, '\p{^Is_Sc=		Hmng}', "");
    Expect(0, 93071, '\P{Is_Sc=		Hmng}', "");
    Expect(1, 93071, '\P{^Is_Sc=		Hmng}', "");
    Expect(0, 93072, '\p{Is_Sc=		Hmng}', "");
    Expect(1, 93072, '\p{^Is_Sc=		Hmng}', "");
    Expect(1, 93072, '\P{Is_Sc=		Hmng}', "");
    Expect(0, 93072, '\P{^Is_Sc=		Hmng}', "");
    Error('\p{Script=  Nyiakeng_Puachue_Hmong/a/}');
    Error('\P{Script=  Nyiakeng_Puachue_Hmong/a/}');
    Expect(1, 123215, '\p{Script=:\ANyiakeng_Puachue_Hmong\z:}', "");;
    Expect(0, 123216, '\p{Script=:\ANyiakeng_Puachue_Hmong\z:}', "");;
    Expect(1, 123215, '\p{Script=nyiakengpuachuehmong}', "");
    Expect(0, 123215, '\p{^Script=nyiakengpuachuehmong}', "");
    Expect(0, 123215, '\P{Script=nyiakengpuachuehmong}', "");
    Expect(1, 123215, '\P{^Script=nyiakengpuachuehmong}', "");
    Expect(0, 123216, '\p{Script=nyiakengpuachuehmong}', "");
    Expect(1, 123216, '\p{^Script=nyiakengpuachuehmong}', "");
    Expect(1, 123216, '\P{Script=nyiakengpuachuehmong}', "");
    Expect(0, 123216, '\P{^Script=nyiakengpuachuehmong}', "");
    Expect(1, 123215, '\p{Script=:\Anyiakengpuachuehmong\z:}', "");;
    Expect(0, 123216, '\p{Script=:\Anyiakengpuachuehmong\z:}', "");;
    Expect(1, 123215, '\p{Script=-_Nyiakeng_PUACHUE_HMONG}', "");
    Expect(0, 123215, '\p{^Script=-_Nyiakeng_PUACHUE_HMONG}', "");
    Expect(0, 123215, '\P{Script=-_Nyiakeng_PUACHUE_HMONG}', "");
    Expect(1, 123215, '\P{^Script=-_Nyiakeng_PUACHUE_HMONG}', "");
    Expect(0, 123216, '\p{Script=-_Nyiakeng_PUACHUE_HMONG}', "");
    Expect(1, 123216, '\p{^Script=-_Nyiakeng_PUACHUE_HMONG}', "");
    Expect(1, 123216, '\P{Script=-_Nyiakeng_PUACHUE_HMONG}', "");
    Expect(0, 123216, '\P{^Script=-_Nyiakeng_PUACHUE_HMONG}', "");
    Error('\p{Sc=/a/_	hmnp}');
    Error('\P{Sc=/a/_	hmnp}');
    Expect(1, 123215, '\p{Sc=:\AHmnp\z:}', "");;
    Expect(0, 123216, '\p{Sc=:\AHmnp\z:}', "");;
    Expect(1, 123215, '\p{Sc=hmnp}', "");
    Expect(0, 123215, '\p{^Sc=hmnp}', "");
    Expect(0, 123215, '\P{Sc=hmnp}', "");
    Expect(1, 123215, '\P{^Sc=hmnp}', "");
    Expect(0, 123216, '\p{Sc=hmnp}', "");
    Expect(1, 123216, '\p{^Sc=hmnp}', "");
    Expect(1, 123216, '\P{Sc=hmnp}', "");
    Expect(0, 123216, '\P{^Sc=hmnp}', "");
    Expect(1, 123215, '\p{Sc=:\Ahmnp\z:}', "");;
    Expect(0, 123216, '\p{Sc=:\Ahmnp\z:}', "");;
    Expect(1, 123215, '\p{Sc= -Hmnp}', "");
    Expect(0, 123215, '\p{^Sc= -Hmnp}', "");
    Expect(0, 123215, '\P{Sc= -Hmnp}', "");
    Expect(1, 123215, '\P{^Sc= -Hmnp}', "");
    Expect(0, 123216, '\p{Sc= -Hmnp}', "");
    Expect(1, 123216, '\p{^Sc= -Hmnp}', "");
    Expect(1, 123216, '\P{Sc= -Hmnp}', "");
    Expect(0, 123216, '\P{^Sc= -Hmnp}', "");
    Error('\p{Is_Script: 	NYIAKENG_Puachue_Hmong:=}');
    Error('\P{Is_Script: 	NYIAKENG_Puachue_Hmong:=}');
    Expect(1, 123215, '\p{Is_Script=nyiakengpuachuehmong}', "");
    Expect(0, 123215, '\p{^Is_Script=nyiakengpuachuehmong}', "");
    Expect(0, 123215, '\P{Is_Script=nyiakengpuachuehmong}', "");
    Expect(1, 123215, '\P{^Is_Script=nyiakengpuachuehmong}', "");
    Expect(0, 123216, '\p{Is_Script=nyiakengpuachuehmong}', "");
    Expect(1, 123216, '\p{^Is_Script=nyiakengpuachuehmong}', "");
    Expect(1, 123216, '\P{Is_Script=nyiakengpuachuehmong}', "");
    Expect(0, 123216, '\P{^Is_Script=nyiakengpuachuehmong}', "");
    Expect(1, 123215, '\p{Is_Script= -NYIAKENG_puachue_Hmong}', "");
    Expect(0, 123215, '\p{^Is_Script= -NYIAKENG_puachue_Hmong}', "");
    Expect(0, 123215, '\P{Is_Script= -NYIAKENG_puachue_Hmong}', "");
    Expect(1, 123215, '\P{^Is_Script= -NYIAKENG_puachue_Hmong}', "");
    Expect(0, 123216, '\p{Is_Script= -NYIAKENG_puachue_Hmong}', "");
    Expect(1, 123216, '\p{^Is_Script= -NYIAKENG_puachue_Hmong}', "");
    Expect(1, 123216, '\P{Is_Script= -NYIAKENG_puachue_Hmong}', "");
    Expect(0, 123216, '\P{^Is_Script= -NYIAKENG_puachue_Hmong}', "");
    Error('\p{Is_Sc: HMNP:=}');
    Error('\P{Is_Sc: HMNP:=}');
    Expect(1, 123215, '\p{Is_Sc=hmnp}', "");
    Expect(0, 123215, '\p{^Is_Sc=hmnp}', "");
    Expect(0, 123215, '\P{Is_Sc=hmnp}', "");
    Expect(1, 123215, '\P{^Is_Sc=hmnp}', "");
    Expect(0, 123216, '\p{Is_Sc=hmnp}', "");
    Expect(1, 123216, '\p{^Is_Sc=hmnp}', "");
    Expect(1, 123216, '\P{Is_Sc=hmnp}', "");
    Expect(0, 123216, '\P{^Is_Sc=hmnp}', "");
    Expect(1, 123215, '\p{Is_Sc=		hmnp}', "");
    Expect(0, 123215, '\p{^Is_Sc=		hmnp}', "");
    Expect(0, 123215, '\P{Is_Sc=		hmnp}', "");
    Expect(1, 123215, '\P{^Is_Sc=		hmnp}', "");
    Expect(0, 123216, '\p{Is_Sc=		hmnp}', "");
    Expect(1, 123216, '\p{^Is_Sc=		hmnp}', "");
    Expect(1, 123216, '\P{Is_Sc=		hmnp}', "");
    Expect(0, 123216, '\P{^Is_Sc=		hmnp}', "");
    Error('\p{Script=Katakana_Or_Hiragana}');
    Error('\P{Script=Katakana_Or_Hiragana}');
    Error('\p{Sc=Hrkt}');
    Error('\P{Sc=Hrkt}');
    Error('\p{Is_Script=Katakana_Or_Hiragana}');
    Error('\P{Is_Script=Katakana_Or_Hiragana}');
    Error('\p{Is_Sc=Hrkt}');
    Error('\P{Is_Sc=Hrkt}');
    Error('\p{Script=:=Old_hungarian}');
    Error('\P{Script=:=Old_hungarian}');
    Expect(1, 68863, '\p{Script=:\AOld_Hungarian\z:}', "");;
    Expect(0, 68864, '\p{Script=:\AOld_Hungarian\z:}', "");;
    Expect(1, 68863, '\p{Script=oldhungarian}', "");
    Expect(0, 68863, '\p{^Script=oldhungarian}', "");
    Expect(0, 68863, '\P{Script=oldhungarian}', "");
    Expect(1, 68863, '\P{^Script=oldhungarian}', "");
    Expect(0, 68864, '\p{Script=oldhungarian}', "");
    Expect(1, 68864, '\p{^Script=oldhungarian}', "");
    Expect(1, 68864, '\P{Script=oldhungarian}', "");
    Expect(0, 68864, '\P{^Script=oldhungarian}', "");
    Expect(1, 68863, '\p{Script=:\Aoldhungarian\z:}', "");;
    Expect(0, 68864, '\p{Script=:\Aoldhungarian\z:}', "");;
    Expect(1, 68863, '\p{Script= Old_Hungarian}', "");
    Expect(0, 68863, '\p{^Script= Old_Hungarian}', "");
    Expect(0, 68863, '\P{Script= Old_Hungarian}', "");
    Expect(1, 68863, '\P{^Script= Old_Hungarian}', "");
    Expect(0, 68864, '\p{Script= Old_Hungarian}', "");
    Expect(1, 68864, '\p{^Script= Old_Hungarian}', "");
    Expect(1, 68864, '\P{Script= Old_Hungarian}', "");
    Expect(0, 68864, '\P{^Script= Old_Hungarian}', "");
    Error('\p{Sc=:=_	HUNG}');
    Error('\P{Sc=:=_	HUNG}');
    Expect(1, 68863, '\p{Sc=:\AHung\z:}', "");;
    Expect(0, 68864, '\p{Sc=:\AHung\z:}', "");;
    Expect(1, 68863, '\p{Sc:hung}', "");
    Expect(0, 68863, '\p{^Sc:hung}', "");
    Expect(0, 68863, '\P{Sc:hung}', "");
    Expect(1, 68863, '\P{^Sc:hung}', "");
    Expect(0, 68864, '\p{Sc:hung}', "");
    Expect(1, 68864, '\p{^Sc:hung}', "");
    Expect(1, 68864, '\P{Sc:hung}', "");
    Expect(0, 68864, '\P{^Sc:hung}', "");
    Expect(1, 68863, '\p{Sc=:\Ahung\z:}', "");;
    Expect(0, 68864, '\p{Sc=:\Ahung\z:}', "");;
    Expect(1, 68863, '\p{Sc=_HUNG}', "");
    Expect(0, 68863, '\p{^Sc=_HUNG}', "");
    Expect(0, 68863, '\P{Sc=_HUNG}', "");
    Expect(1, 68863, '\P{^Sc=_HUNG}', "");
    Expect(0, 68864, '\p{Sc=_HUNG}', "");
    Expect(1, 68864, '\p{^Sc=_HUNG}', "");
    Expect(1, 68864, '\P{Sc=_HUNG}', "");
    Expect(0, 68864, '\P{^Sc=_HUNG}', "");
    Error('\p{Is_Script=_-old_HUNGARIAN/a/}');
    Error('\P{Is_Script=_-old_HUNGARIAN/a/}');
    Expect(1, 68863, '\p{Is_Script=oldhungarian}', "");
    Expect(0, 68863, '\p{^Is_Script=oldhungarian}', "");
    Expect(0, 68863, '\P{Is_Script=oldhungarian}', "");
    Expect(1, 68863, '\P{^Is_Script=oldhungarian}', "");
    Expect(0, 68864, '\p{Is_Script=oldhungarian}', "");
    Expect(1, 68864, '\p{^Is_Script=oldhungarian}', "");
    Expect(1, 68864, '\P{Is_Script=oldhungarian}', "");
    Expect(0, 68864, '\P{^Is_Script=oldhungarian}', "");
    Expect(1, 68863, '\p{Is_Script:  -old_hungarian}', "");
    Expect(0, 68863, '\p{^Is_Script:  -old_hungarian}', "");
    Expect(0, 68863, '\P{Is_Script:  -old_hungarian}', "");
    Expect(1, 68863, '\P{^Is_Script:  -old_hungarian}', "");
    Expect(0, 68864, '\p{Is_Script:  -old_hungarian}', "");
    Expect(1, 68864, '\p{^Is_Script:  -old_hungarian}', "");
    Expect(1, 68864, '\P{Is_Script:  -old_hungarian}', "");
    Expect(0, 68864, '\P{^Is_Script:  -old_hungarian}', "");
    Error('\p{Is_Sc=/a/Hung}');
    Error('\P{Is_Sc=/a/Hung}');
    Expect(1, 68863, '\p{Is_Sc=hung}', "");
    Expect(0, 68863, '\p{^Is_Sc=hung}', "");
    Expect(0, 68863, '\P{Is_Sc=hung}', "");
    Expect(1, 68863, '\P{^Is_Sc=hung}', "");
    Expect(0, 68864, '\p{Is_Sc=hung}', "");
    Expect(1, 68864, '\p{^Is_Sc=hung}', "");
    Expect(1, 68864, '\P{Is_Sc=hung}', "");
    Expect(0, 68864, '\P{^Is_Sc=hung}', "");
    Expect(1, 68863, '\p{Is_Sc= -Hung}', "");
    Expect(0, 68863, '\p{^Is_Sc= -Hung}', "");
    Expect(0, 68863, '\P{Is_Sc= -Hung}', "");
    Expect(1, 68863, '\P{^Is_Sc= -Hung}', "");
    Expect(0, 68864, '\p{Is_Sc= -Hung}', "");
    Expect(1, 68864, '\p{^Is_Sc= -Hung}', "");
    Expect(1, 68864, '\P{Is_Sc= -Hung}', "");
    Expect(0, 68864, '\P{^Is_Sc= -Hung}', "");
    Error('\p{Script= /a/old_italic}');
    Error('\P{Script= /a/old_italic}');
    Expect(1, 66351, '\p{Script=:\AOld_Italic\z:}', "");;
    Expect(0, 66352, '\p{Script=:\AOld_Italic\z:}', "");;
    Expect(1, 66351, '\p{Script=olditalic}', "");
    Expect(0, 66351, '\p{^Script=olditalic}', "");
    Expect(0, 66351, '\P{Script=olditalic}', "");
    Expect(1, 66351, '\P{^Script=olditalic}', "");
    Expect(0, 66352, '\p{Script=olditalic}', "");
    Expect(1, 66352, '\p{^Script=olditalic}', "");
    Expect(1, 66352, '\P{Script=olditalic}', "");
    Expect(0, 66352, '\P{^Script=olditalic}', "");
    Expect(1, 66351, '\p{Script=:\Aolditalic\z:}', "");;
    Expect(0, 66352, '\p{Script=:\Aolditalic\z:}', "");;
    Expect(1, 66351, '\p{Script= OLD_Italic}', "");
    Expect(0, 66351, '\p{^Script= OLD_Italic}', "");
    Expect(0, 66351, '\P{Script= OLD_Italic}', "");
    Expect(1, 66351, '\P{^Script= OLD_Italic}', "");
    Expect(0, 66352, '\p{Script= OLD_Italic}', "");
    Expect(1, 66352, '\p{^Script= OLD_Italic}', "");
    Expect(1, 66352, '\P{Script= OLD_Italic}', "");
    Expect(0, 66352, '\P{^Script= OLD_Italic}', "");
    Error('\p{Sc=/a/	 Ital}');
    Error('\P{Sc=/a/	 Ital}');
    Expect(1, 66351, '\p{Sc=:\AItal\z:}', "");;
    Expect(0, 66352, '\p{Sc=:\AItal\z:}', "");;
    Expect(1, 66351, '\p{Sc=ital}', "");
    Expect(0, 66351, '\p{^Sc=ital}', "");
    Expect(0, 66351, '\P{Sc=ital}', "");
    Expect(1, 66351, '\P{^Sc=ital}', "");
    Expect(0, 66352, '\p{Sc=ital}', "");
    Expect(1, 66352, '\p{^Sc=ital}', "");
    Expect(1, 66352, '\P{Sc=ital}', "");
    Expect(0, 66352, '\P{^Sc=ital}', "");
    Expect(1, 66351, '\p{Sc=:\Aital\z:}', "");;
    Expect(0, 66352, '\p{Sc=:\Aital\z:}', "");;
    Expect(1, 66351, '\p{Sc=- Ital}', "");
    Expect(0, 66351, '\p{^Sc=- Ital}', "");
    Expect(0, 66351, '\P{Sc=- Ital}', "");
    Expect(1, 66351, '\P{^Sc=- Ital}', "");
    Expect(0, 66352, '\p{Sc=- Ital}', "");
    Expect(1, 66352, '\p{^Sc=- Ital}', "");
    Expect(1, 66352, '\P{Sc=- Ital}', "");
    Expect(0, 66352, '\P{^Sc=- Ital}', "");
    Error('\p{Is_Script=:=-old_ITALIC}');
    Error('\P{Is_Script=:=-old_ITALIC}');
    Expect(1, 66351, '\p{Is_Script=olditalic}', "");
    Expect(0, 66351, '\p{^Is_Script=olditalic}', "");
    Expect(0, 66351, '\P{Is_Script=olditalic}', "");
    Expect(1, 66351, '\P{^Is_Script=olditalic}', "");
    Expect(0, 66352, '\p{Is_Script=olditalic}', "");
    Expect(1, 66352, '\p{^Is_Script=olditalic}', "");
    Expect(1, 66352, '\P{Is_Script=olditalic}', "");
    Expect(0, 66352, '\P{^Is_Script=olditalic}', "");
    Expect(1, 66351, '\p{Is_Script=-_Old_Italic}', "");
    Expect(0, 66351, '\p{^Is_Script=-_Old_Italic}', "");
    Expect(0, 66351, '\P{Is_Script=-_Old_Italic}', "");
    Expect(1, 66351, '\P{^Is_Script=-_Old_Italic}', "");
    Expect(0, 66352, '\p{Is_Script=-_Old_Italic}', "");
    Expect(1, 66352, '\p{^Is_Script=-_Old_Italic}', "");
    Expect(1, 66352, '\P{Is_Script=-_Old_Italic}', "");
    Expect(0, 66352, '\P{^Is_Script=-_Old_Italic}', "");
    Error('\p{Is_Sc=/a/-ital}');
    Error('\P{Is_Sc=/a/-ital}');
    Expect(1, 66351, '\p{Is_Sc=ital}', "");
    Expect(0, 66351, '\p{^Is_Sc=ital}', "");
    Expect(0, 66351, '\P{Is_Sc=ital}', "");
    Expect(1, 66351, '\P{^Is_Sc=ital}', "");
    Expect(0, 66352, '\p{Is_Sc=ital}', "");
    Expect(1, 66352, '\p{^Is_Sc=ital}', "");
    Expect(1, 66352, '\P{Is_Sc=ital}', "");
    Expect(0, 66352, '\P{^Is_Sc=ital}', "");
    Expect(1, 66351, '\p{Is_Sc=_ITAL}', "");
    Expect(0, 66351, '\p{^Is_Sc=_ITAL}', "");
    Expect(0, 66351, '\P{Is_Sc=_ITAL}', "");
    Expect(1, 66351, '\P{^Is_Sc=_ITAL}', "");
    Expect(0, 66352, '\p{Is_Sc=_ITAL}', "");
    Expect(1, 66352, '\p{^Is_Sc=_ITAL}', "");
    Expect(1, 66352, '\P{Is_Sc=_ITAL}', "");
    Expect(0, 66352, '\P{^Is_Sc=_ITAL}', "");
    Error('\p{Script=-/a/JAVANESE}');
    Error('\P{Script=-/a/JAVANESE}');
    Expect(1, 43487, '\p{Script=:\AJavanese\z:}', "");;
    Expect(0, 43488, '\p{Script=:\AJavanese\z:}', "");;
    Expect(1, 43487, '\p{Script=javanese}', "");
    Expect(0, 43487, '\p{^Script=javanese}', "");
    Expect(0, 43487, '\P{Script=javanese}', "");
    Expect(1, 43487, '\P{^Script=javanese}', "");
    Expect(0, 43488, '\p{Script=javanese}', "");
    Expect(1, 43488, '\p{^Script=javanese}', "");
    Expect(1, 43488, '\P{Script=javanese}', "");
    Expect(0, 43488, '\P{^Script=javanese}', "");
    Expect(1, 43487, '\p{Script=:\Ajavanese\z:}', "");;
    Expect(0, 43488, '\p{Script=:\Ajavanese\z:}', "");;
    Expect(1, 43487, '\p{Script=-_Javanese}', "");
    Expect(0, 43487, '\p{^Script=-_Javanese}', "");
    Expect(0, 43487, '\P{Script=-_Javanese}', "");
    Expect(1, 43487, '\P{^Script=-_Javanese}', "");
    Expect(0, 43488, '\p{Script=-_Javanese}', "");
    Expect(1, 43488, '\p{^Script=-_Javanese}', "");
    Expect(1, 43488, '\P{Script=-_Javanese}', "");
    Expect(0, 43488, '\P{^Script=-_Javanese}', "");
    Error('\p{Sc=/a/java}');
    Error('\P{Sc=/a/java}');
    Expect(1, 43487, '\p{Sc=:\AJava\z:}', "");;
    Expect(0, 43488, '\p{Sc=:\AJava\z:}', "");;
    Expect(1, 43487, '\p{Sc=java}', "");
    Expect(0, 43487, '\p{^Sc=java}', "");
    Expect(0, 43487, '\P{Sc=java}', "");
    Expect(1, 43487, '\P{^Sc=java}', "");
    Expect(0, 43488, '\p{Sc=java}', "");
    Expect(1, 43488, '\p{^Sc=java}', "");
    Expect(1, 43488, '\P{Sc=java}', "");
    Expect(0, 43488, '\P{^Sc=java}', "");
    Expect(1, 43487, '\p{Sc=:\Ajava\z:}', "");;
    Expect(0, 43488, '\p{Sc=:\Ajava\z:}', "");;
    Expect(1, 43487, '\p{Sc=_java}', "");
    Expect(0, 43487, '\p{^Sc=_java}', "");
    Expect(0, 43487, '\P{Sc=_java}', "");
    Expect(1, 43487, '\P{^Sc=_java}', "");
    Expect(0, 43488, '\p{Sc=_java}', "");
    Expect(1, 43488, '\p{^Sc=_java}', "");
    Expect(1, 43488, '\P{Sc=_java}', "");
    Expect(0, 43488, '\P{^Sc=_java}', "");
    Error('\p{Is_Script:	- Javanese:=}');
    Error('\P{Is_Script:	- Javanese:=}');
    Expect(1, 43487, '\p{Is_Script=javanese}', "");
    Expect(0, 43487, '\p{^Is_Script=javanese}', "");
    Expect(0, 43487, '\P{Is_Script=javanese}', "");
    Expect(1, 43487, '\P{^Is_Script=javanese}', "");
    Expect(0, 43488, '\p{Is_Script=javanese}', "");
    Expect(1, 43488, '\p{^Is_Script=javanese}', "");
    Expect(1, 43488, '\P{Is_Script=javanese}', "");
    Expect(0, 43488, '\P{^Is_Script=javanese}', "");
    Expect(1, 43487, '\p{Is_Script= -JAVANESE}', "");
    Expect(0, 43487, '\p{^Is_Script= -JAVANESE}', "");
    Expect(0, 43487, '\P{Is_Script= -JAVANESE}', "");
    Expect(1, 43487, '\P{^Is_Script= -JAVANESE}', "");
    Expect(0, 43488, '\p{Is_Script= -JAVANESE}', "");
    Expect(1, 43488, '\p{^Is_Script= -JAVANESE}', "");
    Expect(1, 43488, '\P{Is_Script= -JAVANESE}', "");
    Expect(0, 43488, '\P{^Is_Script= -JAVANESE}', "");
    Error('\p{Is_Sc= -java/a/}');
    Error('\P{Is_Sc= -java/a/}');
    Expect(1, 43487, '\p{Is_Sc=java}', "");
    Expect(0, 43487, '\p{^Is_Sc=java}', "");
    Expect(0, 43487, '\P{Is_Sc=java}', "");
    Expect(1, 43487, '\P{^Is_Sc=java}', "");
    Expect(0, 43488, '\p{Is_Sc=java}', "");
    Expect(1, 43488, '\p{^Is_Sc=java}', "");
    Expect(1, 43488, '\P{Is_Sc=java}', "");
    Expect(0, 43488, '\P{^Is_Sc=java}', "");
    Expect(1, 43487, '\p{Is_Sc=JAVA}', "");
    Expect(0, 43487, '\p{^Is_Sc=JAVA}', "");
    Expect(0, 43487, '\P{Is_Sc=JAVA}', "");
    Expect(1, 43487, '\P{^Is_Sc=JAVA}', "");
    Expect(0, 43488, '\p{Is_Sc=JAVA}', "");
    Expect(1, 43488, '\p{^Is_Sc=JAVA}', "");
    Expect(1, 43488, '\P{Is_Sc=JAVA}', "");
    Expect(0, 43488, '\P{^Is_Sc=JAVA}', "");
    Error('\p{Script:	/a/	 KAYAH_li}');
    Error('\P{Script:	/a/	 KAYAH_li}');
    Expect(1, 43311, '\p{Script=:\AKayah_Li\z:}', "");;
    Expect(0, 43312, '\p{Script=:\AKayah_Li\z:}', "");;
    Expect(1, 43311, '\p{Script=kayahli}', "");
    Expect(0, 43311, '\p{^Script=kayahli}', "");
    Expect(0, 43311, '\P{Script=kayahli}', "");
    Expect(1, 43311, '\P{^Script=kayahli}', "");
    Expect(0, 43312, '\p{Script=kayahli}', "");
    Expect(1, 43312, '\p{^Script=kayahli}', "");
    Expect(1, 43312, '\P{Script=kayahli}', "");
    Expect(0, 43312, '\P{^Script=kayahli}', "");
    Expect(1, 43311, '\p{Script=:\Akayahli\z:}', "");;
    Expect(0, 43312, '\p{Script=:\Akayahli\z:}', "");;
    Expect(1, 43311, '\p{Script: 	_Kayah_li}', "");
    Expect(0, 43311, '\p{^Script: 	_Kayah_li}', "");
    Expect(0, 43311, '\P{Script: 	_Kayah_li}', "");
    Expect(1, 43311, '\P{^Script: 	_Kayah_li}', "");
    Expect(0, 43312, '\p{Script: 	_Kayah_li}', "");
    Expect(1, 43312, '\p{^Script: 	_Kayah_li}', "");
    Expect(1, 43312, '\P{Script: 	_Kayah_li}', "");
    Expect(0, 43312, '\P{^Script: 	_Kayah_li}', "");
    Error('\p{Sc=KALI/a/}');
    Error('\P{Sc=KALI/a/}');
    Expect(1, 43311, '\p{Sc=:\AKali\z:}', "");;
    Expect(0, 43312, '\p{Sc=:\AKali\z:}', "");;
    Expect(1, 43311, '\p{Sc:kali}', "");
    Expect(0, 43311, '\p{^Sc:kali}', "");
    Expect(0, 43311, '\P{Sc:kali}', "");
    Expect(1, 43311, '\P{^Sc:kali}', "");
    Expect(0, 43312, '\p{Sc:kali}', "");
    Expect(1, 43312, '\p{^Sc:kali}', "");
    Expect(1, 43312, '\P{Sc:kali}', "");
    Expect(0, 43312, '\P{^Sc:kali}', "");
    Expect(1, 43311, '\p{Sc=:\Akali\z:}', "");;
    Expect(0, 43312, '\p{Sc=:\Akali\z:}', "");;
    Expect(1, 43311, '\p{Sc=-Kali}', "");
    Expect(0, 43311, '\p{^Sc=-Kali}', "");
    Expect(0, 43311, '\P{Sc=-Kali}', "");
    Expect(1, 43311, '\P{^Sc=-Kali}', "");
    Expect(0, 43312, '\p{Sc=-Kali}', "");
    Expect(1, 43312, '\p{^Sc=-Kali}', "");
    Expect(1, 43312, '\P{Sc=-Kali}', "");
    Expect(0, 43312, '\P{^Sc=-Kali}', "");
    Error('\p{Is_Script=:=--Kayah_Li}');
    Error('\P{Is_Script=:=--Kayah_Li}');
    Expect(1, 43311, '\p{Is_Script=kayahli}', "");
    Expect(0, 43311, '\p{^Is_Script=kayahli}', "");
    Expect(0, 43311, '\P{Is_Script=kayahli}', "");
    Expect(1, 43311, '\P{^Is_Script=kayahli}', "");
    Expect(0, 43312, '\p{Is_Script=kayahli}', "");
    Expect(1, 43312, '\p{^Is_Script=kayahli}', "");
    Expect(1, 43312, '\P{Is_Script=kayahli}', "");
    Expect(0, 43312, '\P{^Is_Script=kayahli}', "");
    Expect(1, 43311, '\p{Is_Script=		KAYAH_LI}', "");
    Expect(0, 43311, '\p{^Is_Script=		KAYAH_LI}', "");
    Expect(0, 43311, '\P{Is_Script=		KAYAH_LI}', "");
    Expect(1, 43311, '\P{^Is_Script=		KAYAH_LI}', "");
    Expect(0, 43312, '\p{Is_Script=		KAYAH_LI}', "");
    Expect(1, 43312, '\p{^Is_Script=		KAYAH_LI}', "");
    Expect(1, 43312, '\P{Is_Script=		KAYAH_LI}', "");
    Expect(0, 43312, '\P{^Is_Script=		KAYAH_LI}', "");
    Error('\p{Is_Sc=_/a/KALI}');
    Error('\P{Is_Sc=_/a/KALI}');
    Expect(1, 43311, '\p{Is_Sc=kali}', "");
    Expect(0, 43311, '\p{^Is_Sc=kali}', "");
    Expect(0, 43311, '\P{Is_Sc=kali}', "");
    Expect(1, 43311, '\P{^Is_Sc=kali}', "");
    Expect(0, 43312, '\p{Is_Sc=kali}', "");
    Expect(1, 43312, '\p{^Is_Sc=kali}', "");
    Expect(1, 43312, '\P{Is_Sc=kali}', "");
    Expect(0, 43312, '\P{^Is_Sc=kali}', "");
    Expect(1, 43311, '\p{Is_Sc=		KALI}', "");
    Expect(0, 43311, '\p{^Is_Sc=		KALI}', "");
    Expect(0, 43311, '\P{Is_Sc=		KALI}', "");
    Expect(1, 43311, '\P{^Is_Sc=		KALI}', "");
    Expect(0, 43312, '\p{Is_Sc=		KALI}', "");
    Expect(1, 43312, '\p{^Is_Sc=		KALI}', "");
    Expect(1, 43312, '\P{Is_Sc=		KALI}', "");
    Expect(0, 43312, '\P{^Is_Sc=		KALI}', "");
    Error('\p{Script=_/a/Katakana}');
    Error('\P{Script=_/a/Katakana}');
    Expect(1, 110951, '\p{Script=:\AKatakana\z:}', "");;
    Expect(0, 110952, '\p{Script=:\AKatakana\z:}', "");;
    Expect(1, 110951, '\p{Script=katakana}', "");
    Expect(0, 110951, '\p{^Script=katakana}', "");
    Expect(0, 110951, '\P{Script=katakana}', "");
    Expect(1, 110951, '\P{^Script=katakana}', "");
    Expect(0, 110952, '\p{Script=katakana}', "");
    Expect(1, 110952, '\p{^Script=katakana}', "");
    Expect(1, 110952, '\P{Script=katakana}', "");
    Expect(0, 110952, '\P{^Script=katakana}', "");
    Expect(1, 110951, '\p{Script=:\Akatakana\z:}', "");;
    Expect(0, 110952, '\p{Script=:\Akatakana\z:}', "");;
    Expect(1, 110951, '\p{Script:	- Katakana}', "");
    Expect(0, 110951, '\p{^Script:	- Katakana}', "");
    Expect(0, 110951, '\P{Script:	- Katakana}', "");
    Expect(1, 110951, '\P{^Script:	- Katakana}', "");
    Expect(0, 110952, '\p{Script:	- Katakana}', "");
    Expect(1, 110952, '\p{^Script:	- Katakana}', "");
    Expect(1, 110952, '\P{Script:	- Katakana}', "");
    Expect(0, 110952, '\P{^Script:	- Katakana}', "");
    Error('\p{Sc=	kana:=}');
    Error('\P{Sc=	kana:=}');
    Expect(1, 110951, '\p{Sc=:\AKana\z:}', "");;
    Expect(0, 110952, '\p{Sc=:\AKana\z:}', "");;
    Expect(1, 110951, '\p{Sc=kana}', "");
    Expect(0, 110951, '\p{^Sc=kana}', "");
    Expect(0, 110951, '\P{Sc=kana}', "");
    Expect(1, 110951, '\P{^Sc=kana}', "");
    Expect(0, 110952, '\p{Sc=kana}', "");
    Expect(1, 110952, '\p{^Sc=kana}', "");
    Expect(1, 110952, '\P{Sc=kana}', "");
    Expect(0, 110952, '\P{^Sc=kana}', "");
    Expect(1, 110951, '\p{Sc=:\Akana\z:}', "");;
    Expect(0, 110952, '\p{Sc=:\Akana\z:}', "");;
    Expect(1, 110951, '\p{Sc=-kana}', "");
    Expect(0, 110951, '\p{^Sc=-kana}', "");
    Expect(0, 110951, '\P{Sc=-kana}', "");
    Expect(1, 110951, '\P{^Sc=-kana}', "");
    Expect(0, 110952, '\p{Sc=-kana}', "");
    Expect(1, 110952, '\p{^Sc=-kana}', "");
    Expect(1, 110952, '\P{Sc=-kana}', "");
    Expect(0, 110952, '\P{^Sc=-kana}', "");
    Error('\p{Is_Script:/a/ _Katakana}');
    Error('\P{Is_Script:/a/ _Katakana}');
    Expect(1, 110951, '\p{Is_Script:katakana}', "");
    Expect(0, 110951, '\p{^Is_Script:katakana}', "");
    Expect(0, 110951, '\P{Is_Script:katakana}', "");
    Expect(1, 110951, '\P{^Is_Script:katakana}', "");
    Expect(0, 110952, '\p{Is_Script:katakana}', "");
    Expect(1, 110952, '\p{^Is_Script:katakana}', "");
    Expect(1, 110952, '\P{Is_Script:katakana}', "");
    Expect(0, 110952, '\P{^Is_Script:katakana}', "");
    Expect(1, 110951, '\p{Is_Script=KATAKANA}', "");
    Expect(0, 110951, '\p{^Is_Script=KATAKANA}', "");
    Expect(0, 110951, '\P{Is_Script=KATAKANA}', "");
    Expect(1, 110951, '\P{^Is_Script=KATAKANA}', "");
    Expect(0, 110952, '\p{Is_Script=KATAKANA}', "");
    Expect(1, 110952, '\p{^Is_Script=KATAKANA}', "");
    Expect(1, 110952, '\P{Is_Script=KATAKANA}', "");
    Expect(0, 110952, '\P{^Is_Script=KATAKANA}', "");
    Error('\p{Is_Sc=-:=KANA}');
    Error('\P{Is_Sc=-:=KANA}');
    Expect(1, 110951, '\p{Is_Sc=kana}', "");
    Expect(0, 110951, '\p{^Is_Sc=kana}', "");
    Expect(0, 110951, '\P{Is_Sc=kana}', "");
    Expect(1, 110951, '\P{^Is_Sc=kana}', "");
    Expect(0, 110952, '\p{Is_Sc=kana}', "");
    Expect(1, 110952, '\p{^Is_Sc=kana}', "");
    Expect(1, 110952, '\P{Is_Sc=kana}', "");
    Expect(0, 110952, '\P{^Is_Sc=kana}', "");
    Expect(1, 110951, '\p{Is_Sc: Kana}', "");
    Expect(0, 110951, '\p{^Is_Sc: Kana}', "");
    Expect(0, 110951, '\P{Is_Sc: Kana}', "");
    Expect(1, 110951, '\P{^Is_Sc: Kana}', "");
    Expect(0, 110952, '\p{Is_Sc: Kana}', "");
    Expect(1, 110952, '\p{^Is_Sc: Kana}', "");
    Expect(1, 110952, '\P{Is_Sc: Kana}', "");
    Expect(0, 110952, '\P{^Is_Sc: Kana}', "");
    Error('\p{Script= Kawi:=}');
    Error('\P{Script= Kawi:=}');
    Expect(1, 73561, '\p{Script=:\AKawi\z:}', "");;
    Expect(0, 73562, '\p{Script=:\AKawi\z:}', "");;
    Expect(1, 73561, '\p{Script=kawi}', "");
    Expect(0, 73561, '\p{^Script=kawi}', "");
    Expect(0, 73561, '\P{Script=kawi}', "");
    Expect(1, 73561, '\P{^Script=kawi}', "");
    Expect(0, 73562, '\p{Script=kawi}', "");
    Expect(1, 73562, '\p{^Script=kawi}', "");
    Expect(1, 73562, '\P{Script=kawi}', "");
    Expect(0, 73562, '\P{^Script=kawi}', "");
    Expect(1, 73561, '\p{Script=:\Akawi\z:}', "");;
    Expect(0, 73562, '\p{Script=:\Akawi\z:}', "");;
    Expect(1, 73561, '\p{Script=-	Kawi}', "");
    Expect(0, 73561, '\p{^Script=-	Kawi}', "");
    Expect(0, 73561, '\P{Script=-	Kawi}', "");
    Expect(1, 73561, '\P{^Script=-	Kawi}', "");
    Expect(0, 73562, '\p{Script=-	Kawi}', "");
    Expect(1, 73562, '\p{^Script=-	Kawi}', "");
    Expect(1, 73562, '\P{Script=-	Kawi}', "");
    Expect(0, 73562, '\P{^Script=-	Kawi}', "");
    Error('\p{Sc=-	Kawi:=}');
    Error('\P{Sc=-	Kawi:=}');
    Expect(1, 73561, '\p{Sc=:\AKawi\z:}', "");;
    Expect(0, 73562, '\p{Sc=:\AKawi\z:}', "");;
    Expect(1, 73561, '\p{Sc=kawi}', "");
    Expect(0, 73561, '\p{^Sc=kawi}', "");
    Expect(0, 73561, '\P{Sc=kawi}', "");
    Expect(1, 73561, '\P{^Sc=kawi}', "");
    Expect(0, 73562, '\p{Sc=kawi}', "");
    Expect(1, 73562, '\p{^Sc=kawi}', "");
    Expect(1, 73562, '\P{Sc=kawi}', "");
    Expect(0, 73562, '\P{^Sc=kawi}', "");
    Expect(1, 73561, '\p{Sc=:\Akawi\z:}', "");;
    Expect(0, 73562, '\p{Sc=:\Akawi\z:}', "");;
    Expect(1, 73561, '\p{Sc=_ KAWI}', "");
    Expect(0, 73561, '\p{^Sc=_ KAWI}', "");
    Expect(0, 73561, '\P{Sc=_ KAWI}', "");
    Expect(1, 73561, '\P{^Sc=_ KAWI}', "");
    Expect(0, 73562, '\p{Sc=_ KAWI}', "");
    Expect(1, 73562, '\p{^Sc=_ KAWI}', "");
    Expect(1, 73562, '\P{Sc=_ KAWI}', "");
    Expect(0, 73562, '\P{^Sc=_ KAWI}', "");
    Error('\p{Is_Script=:=KAWI}');
    Error('\P{Is_Script=:=KAWI}');
    Expect(1, 73561, '\p{Is_Script=kawi}', "");
    Expect(0, 73561, '\p{^Is_Script=kawi}', "");
    Expect(0, 73561, '\P{Is_Script=kawi}', "");
    Expect(1, 73561, '\P{^Is_Script=kawi}', "");
    Expect(0, 73562, '\p{Is_Script=kawi}', "");
    Expect(1, 73562, '\p{^Is_Script=kawi}', "");
    Expect(1, 73562, '\P{Is_Script=kawi}', "");
    Expect(0, 73562, '\P{^Is_Script=kawi}', "");
    Expect(1, 73561, '\p{Is_Script: -Kawi}', "");
    Expect(0, 73561, '\p{^Is_Script: -Kawi}', "");
    Expect(0, 73561, '\P{Is_Script: -Kawi}', "");
    Expect(1, 73561, '\P{^Is_Script: -Kawi}', "");
    Expect(0, 73562, '\p{Is_Script: -Kawi}', "");
    Expect(1, 73562, '\p{^Is_Script: -Kawi}', "");
    Expect(1, 73562, '\P{Is_Script: -Kawi}', "");
    Expect(0, 73562, '\P{^Is_Script: -Kawi}', "");
    Error('\p{Is_Sc=/a/ 	KAWI}');
    Error('\P{Is_Sc=/a/ 	KAWI}');
    Expect(1, 73561, '\p{Is_Sc=kawi}', "");
    Expect(0, 73561, '\p{^Is_Sc=kawi}', "");
    Expect(0, 73561, '\P{Is_Sc=kawi}', "");
    Expect(1, 73561, '\P{^Is_Sc=kawi}', "");
    Expect(0, 73562, '\p{Is_Sc=kawi}', "");
    Expect(1, 73562, '\p{^Is_Sc=kawi}', "");
    Expect(1, 73562, '\P{Is_Sc=kawi}', "");
    Expect(0, 73562, '\P{^Is_Sc=kawi}', "");
    Expect(1, 73561, '\p{Is_Sc= 	KAWI}', "");
    Expect(0, 73561, '\p{^Is_Sc= 	KAWI}', "");
    Expect(0, 73561, '\P{Is_Sc= 	KAWI}', "");
    Expect(1, 73561, '\P{^Is_Sc= 	KAWI}', "");
    Expect(0, 73562, '\p{Is_Sc= 	KAWI}', "");
    Expect(1, 73562, '\p{^Is_Sc= 	KAWI}', "");
    Expect(1, 73562, '\P{Is_Sc= 	KAWI}', "");
    Expect(0, 73562, '\P{^Is_Sc= 	KAWI}', "");
    Error('\p{Script=:=	 Kharoshthi}');
    Error('\P{Script=:=	 Kharoshthi}');
    Expect(1, 68184, '\p{Script=:\AKharoshthi\z:}', "");;
    Expect(0, 68185, '\p{Script=:\AKharoshthi\z:}', "");;
    Expect(1, 68184, '\p{Script=kharoshthi}', "");
    Expect(0, 68184, '\p{^Script=kharoshthi}', "");
    Expect(0, 68184, '\P{Script=kharoshthi}', "");
    Expect(1, 68184, '\P{^Script=kharoshthi}', "");
    Expect(0, 68185, '\p{Script=kharoshthi}', "");
    Expect(1, 68185, '\p{^Script=kharoshthi}', "");
    Expect(1, 68185, '\P{Script=kharoshthi}', "");
    Expect(0, 68185, '\P{^Script=kharoshthi}', "");
    Expect(1, 68184, '\p{Script=:\Akharoshthi\z:}', "");;
    Expect(0, 68185, '\p{Script=:\Akharoshthi\z:}', "");;
    Expect(1, 68184, '\p{Script=	Kharoshthi}', "");
    Expect(0, 68184, '\p{^Script=	Kharoshthi}', "");
    Expect(0, 68184, '\P{Script=	Kharoshthi}', "");
    Expect(1, 68184, '\P{^Script=	Kharoshthi}', "");
    Expect(0, 68185, '\p{Script=	Kharoshthi}', "");
    Expect(1, 68185, '\p{^Script=	Kharoshthi}', "");
    Expect(1, 68185, '\P{Script=	Kharoshthi}', "");
    Expect(0, 68185, '\P{^Script=	Kharoshthi}', "");
    Error('\p{Sc=:= 	khar}');
    Error('\P{Sc=:= 	khar}');
    Expect(1, 68184, '\p{Sc=:\AKhar\z:}', "");;
    Expect(0, 68185, '\p{Sc=:\AKhar\z:}', "");;
    Expect(1, 68184, '\p{Sc=khar}', "");
    Expect(0, 68184, '\p{^Sc=khar}', "");
    Expect(0, 68184, '\P{Sc=khar}', "");
    Expect(1, 68184, '\P{^Sc=khar}', "");
    Expect(0, 68185, '\p{Sc=khar}', "");
    Expect(1, 68185, '\p{^Sc=khar}', "");
    Expect(1, 68185, '\P{Sc=khar}', "");
    Expect(0, 68185, '\P{^Sc=khar}', "");
    Expect(1, 68184, '\p{Sc=:\Akhar\z:}', "");;
    Expect(0, 68185, '\p{Sc=:\Akhar\z:}', "");;
    Expect(1, 68184, '\p{Sc:	-Khar}', "");
    Expect(0, 68184, '\p{^Sc:	-Khar}', "");
    Expect(0, 68184, '\P{Sc:	-Khar}', "");
    Expect(1, 68184, '\P{^Sc:	-Khar}', "");
    Expect(0, 68185, '\p{Sc:	-Khar}', "");
    Expect(1, 68185, '\p{^Sc:	-Khar}', "");
    Expect(1, 68185, '\P{Sc:	-Khar}', "");
    Expect(0, 68185, '\P{^Sc:	-Khar}', "");
    Error('\p{Is_Script=	/a/Kharoshthi}');
    Error('\P{Is_Script=	/a/Kharoshthi}');
    Expect(1, 68184, '\p{Is_Script=kharoshthi}', "");
    Expect(0, 68184, '\p{^Is_Script=kharoshthi}', "");
    Expect(0, 68184, '\P{Is_Script=kharoshthi}', "");
    Expect(1, 68184, '\P{^Is_Script=kharoshthi}', "");
    Expect(0, 68185, '\p{Is_Script=kharoshthi}', "");
    Expect(1, 68185, '\p{^Is_Script=kharoshthi}', "");
    Expect(1, 68185, '\P{Is_Script=kharoshthi}', "");
    Expect(0, 68185, '\P{^Is_Script=kharoshthi}', "");
    Expect(1, 68184, '\p{Is_Script=_KHAROSHTHI}', "");
    Expect(0, 68184, '\p{^Is_Script=_KHAROSHTHI}', "");
    Expect(0, 68184, '\P{Is_Script=_KHAROSHTHI}', "");
    Expect(1, 68184, '\P{^Is_Script=_KHAROSHTHI}', "");
    Expect(0, 68185, '\p{Is_Script=_KHAROSHTHI}', "");
    Expect(1, 68185, '\p{^Is_Script=_KHAROSHTHI}', "");
    Expect(1, 68185, '\P{Is_Script=_KHAROSHTHI}', "");
    Expect(0, 68185, '\P{^Is_Script=_KHAROSHTHI}', "");
    Error('\p{Is_Sc=Khar/a/}');
    Error('\P{Is_Sc=Khar/a/}');
    Expect(1, 68184, '\p{Is_Sc=khar}', "");
    Expect(0, 68184, '\p{^Is_Sc=khar}', "");
    Expect(0, 68184, '\P{Is_Sc=khar}', "");
    Expect(1, 68184, '\P{^Is_Sc=khar}', "");
    Expect(0, 68185, '\p{Is_Sc=khar}', "");
    Expect(1, 68185, '\p{^Is_Sc=khar}', "");
    Expect(1, 68185, '\P{Is_Sc=khar}', "");
    Expect(0, 68185, '\P{^Is_Sc=khar}', "");
    Expect(1, 68184, '\p{Is_Sc:  _Khar}', "");
    Expect(0, 68184, '\p{^Is_Sc:  _Khar}', "");
    Expect(0, 68184, '\P{Is_Sc:  _Khar}', "");
    Expect(1, 68184, '\P{^Is_Sc:  _Khar}', "");
    Expect(0, 68185, '\p{Is_Sc:  _Khar}', "");
    Expect(1, 68185, '\p{^Is_Sc:  _Khar}', "");
    Expect(1, 68185, '\P{Is_Sc:  _Khar}', "");
    Expect(0, 68185, '\P{^Is_Sc:  _Khar}', "");
    Error('\p{Script=:=	khmer}');
    Error('\P{Script=:=	khmer}');
    Expect(1, 6655, '\p{Script=:\AKhmer\z:}', "");;
    Expect(0, 6656, '\p{Script=:\AKhmer\z:}', "");;
    Expect(1, 6655, '\p{Script=khmer}', "");
    Expect(0, 6655, '\p{^Script=khmer}', "");
    Expect(0, 6655, '\P{Script=khmer}', "");
    Expect(1, 6655, '\P{^Script=khmer}', "");
    Expect(0, 6656, '\p{Script=khmer}', "");
    Expect(1, 6656, '\p{^Script=khmer}', "");
    Expect(1, 6656, '\P{Script=khmer}', "");
    Expect(0, 6656, '\P{^Script=khmer}', "");
    Expect(1, 6655, '\p{Script=:\Akhmer\z:}', "");;
    Expect(0, 6656, '\p{Script=:\Akhmer\z:}', "");;
    Expect(1, 6655, '\p{Script=	 khmer}', "");
    Expect(0, 6655, '\p{^Script=	 khmer}', "");
    Expect(0, 6655, '\P{Script=	 khmer}', "");
    Expect(1, 6655, '\P{^Script=	 khmer}', "");
    Expect(0, 6656, '\p{Script=	 khmer}', "");
    Expect(1, 6656, '\p{^Script=	 khmer}', "");
    Expect(1, 6656, '\P{Script=	 khmer}', "");
    Expect(0, 6656, '\P{^Script=	 khmer}', "");
    Error('\p{Sc=:=_ khmr}');
    Error('\P{Sc=:=_ khmr}');
    Expect(1, 6655, '\p{Sc=:\AKhmr\z:}', "");;
    Expect(0, 6656, '\p{Sc=:\AKhmr\z:}', "");;
    Expect(1, 6655, '\p{Sc=khmr}', "");
    Expect(0, 6655, '\p{^Sc=khmr}', "");
    Expect(0, 6655, '\P{Sc=khmr}', "");
    Expect(1, 6655, '\P{^Sc=khmr}', "");
    Expect(0, 6656, '\p{Sc=khmr}', "");
    Expect(1, 6656, '\p{^Sc=khmr}', "");
    Expect(1, 6656, '\P{Sc=khmr}', "");
    Expect(0, 6656, '\P{^Sc=khmr}', "");
    Expect(1, 6655, '\p{Sc=:\Akhmr\z:}', "");;
    Expect(0, 6656, '\p{Sc=:\Akhmr\z:}', "");;
    Expect(1, 6655, '\p{Sc=_KHMR}', "");
    Expect(0, 6655, '\p{^Sc=_KHMR}', "");
    Expect(0, 6655, '\P{Sc=_KHMR}', "");
    Expect(1, 6655, '\P{^Sc=_KHMR}', "");
    Expect(0, 6656, '\p{Sc=_KHMR}', "");
    Expect(1, 6656, '\p{^Sc=_KHMR}', "");
    Expect(1, 6656, '\P{Sc=_KHMR}', "");
    Expect(0, 6656, '\P{^Sc=_KHMR}', "");
    Error('\p{Is_Script=/a/	khmer}');
    Error('\P{Is_Script=/a/	khmer}');
    Expect(1, 6655, '\p{Is_Script: khmer}', "");
    Expect(0, 6655, '\p{^Is_Script: khmer}', "");
    Expect(0, 6655, '\P{Is_Script: khmer}', "");
    Expect(1, 6655, '\P{^Is_Script: khmer}', "");
    Expect(0, 6656, '\p{Is_Script: khmer}', "");
    Expect(1, 6656, '\p{^Is_Script: khmer}', "");
    Expect(1, 6656, '\P{Is_Script: khmer}', "");
    Expect(0, 6656, '\P{^Is_Script: khmer}', "");
    Expect(1, 6655, '\p{Is_Script=	_Khmer}', "");
    Expect(0, 6655, '\p{^Is_Script=	_Khmer}', "");
    Expect(0, 6655, '\P{Is_Script=	_Khmer}', "");
    Expect(1, 6655, '\P{^Is_Script=	_Khmer}', "");
    Expect(0, 6656, '\p{Is_Script=	_Khmer}', "");
    Expect(1, 6656, '\p{^Is_Script=	_Khmer}', "");
    Expect(1, 6656, '\P{Is_Script=	_Khmer}', "");
    Expect(0, 6656, '\P{^Is_Script=	_Khmer}', "");
    Error('\p{Is_Sc:	/a/--Khmr}');
    Error('\P{Is_Sc:	/a/--Khmr}');
    Expect(1, 6655, '\p{Is_Sc=khmr}', "");
    Expect(0, 6655, '\p{^Is_Sc=khmr}', "");
    Expect(0, 6655, '\P{Is_Sc=khmr}', "");
    Expect(1, 6655, '\P{^Is_Sc=khmr}', "");
    Expect(0, 6656, '\p{Is_Sc=khmr}', "");
    Expect(1, 6656, '\p{^Is_Sc=khmr}', "");
    Expect(1, 6656, '\P{Is_Sc=khmr}', "");
    Expect(0, 6656, '\P{^Is_Sc=khmr}', "");
    Expect(1, 6655, '\p{Is_Sc=	_khmr}', "");
    Expect(0, 6655, '\p{^Is_Sc=	_khmr}', "");
    Expect(0, 6655, '\P{Is_Sc=	_khmr}', "");
    Expect(1, 6655, '\P{^Is_Sc=	_khmr}', "");
    Expect(0, 6656, '\p{Is_Sc=	_khmr}', "");
    Expect(1, 6656, '\p{^Is_Sc=	_khmr}', "");
    Expect(1, 6656, '\P{Is_Sc=	_khmr}', "");
    Expect(0, 6656, '\P{^Is_Sc=	_khmr}', "");
    Error('\p{Script= Khojki/a/}');
    Error('\P{Script= Khojki/a/}');
    Expect(1, 70209, '\p{Script=:\AKhojki\z:}', "");;
    Expect(0, 70210, '\p{Script=:\AKhojki\z:}', "");;
    Expect(1, 70209, '\p{Script=khojki}', "");
    Expect(0, 70209, '\p{^Script=khojki}', "");
    Expect(0, 70209, '\P{Script=khojki}', "");
    Expect(1, 70209, '\P{^Script=khojki}', "");
    Expect(0, 70210, '\p{Script=khojki}', "");
    Expect(1, 70210, '\p{^Script=khojki}', "");
    Expect(1, 70210, '\P{Script=khojki}', "");
    Expect(0, 70210, '\P{^Script=khojki}', "");
    Expect(1, 70209, '\p{Script=:\Akhojki\z:}', "");;
    Expect(0, 70210, '\p{Script=:\Akhojki\z:}', "");;
    Expect(1, 70209, '\p{Script:		Khojki}', "");
    Expect(0, 70209, '\p{^Script:		Khojki}', "");
    Expect(0, 70209, '\P{Script:		Khojki}', "");
    Expect(1, 70209, '\P{^Script:		Khojki}', "");
    Expect(0, 70210, '\p{Script:		Khojki}', "");
    Expect(1, 70210, '\p{^Script:		Khojki}', "");
    Expect(1, 70210, '\P{Script:		Khojki}', "");
    Expect(0, 70210, '\P{^Script:		Khojki}', "");
    Error('\p{Sc=	/a/Khoj}');
    Error('\P{Sc=	/a/Khoj}');
    Expect(1, 70209, '\p{Sc=:\AKhoj\z:}', "");;
    Expect(0, 70210, '\p{Sc=:\AKhoj\z:}', "");;
    Expect(1, 70209, '\p{Sc=khoj}', "");
    Expect(0, 70209, '\p{^Sc=khoj}', "");
    Expect(0, 70209, '\P{Sc=khoj}', "");
    Expect(1, 70209, '\P{^Sc=khoj}', "");
    Expect(0, 70210, '\p{Sc=khoj}', "");
    Expect(1, 70210, '\p{^Sc=khoj}', "");
    Expect(1, 70210, '\P{Sc=khoj}', "");
    Expect(0, 70210, '\P{^Sc=khoj}', "");
    Expect(1, 70209, '\p{Sc=:\Akhoj\z:}', "");;
    Expect(0, 70210, '\p{Sc=:\Akhoj\z:}', "");;
    Expect(1, 70209, '\p{Sc:	 KHOJ}', "");
    Expect(0, 70209, '\p{^Sc:	 KHOJ}', "");
    Expect(0, 70209, '\P{Sc:	 KHOJ}', "");
    Expect(1, 70209, '\P{^Sc:	 KHOJ}', "");
    Expect(0, 70210, '\p{Sc:	 KHOJ}', "");
    Expect(1, 70210, '\p{^Sc:	 KHOJ}', "");
    Expect(1, 70210, '\P{Sc:	 KHOJ}', "");
    Expect(0, 70210, '\P{^Sc:	 KHOJ}', "");
    Error('\p{Is_Script=:=_	khojki}');
    Error('\P{Is_Script=:=_	khojki}');
    Expect(1, 70209, '\p{Is_Script=khojki}', "");
    Expect(0, 70209, '\p{^Is_Script=khojki}', "");
    Expect(0, 70209, '\P{Is_Script=khojki}', "");
    Expect(1, 70209, '\P{^Is_Script=khojki}', "");
    Expect(0, 70210, '\p{Is_Script=khojki}', "");
    Expect(1, 70210, '\p{^Is_Script=khojki}', "");
    Expect(1, 70210, '\P{Is_Script=khojki}', "");
    Expect(0, 70210, '\P{^Is_Script=khojki}', "");
    Expect(1, 70209, '\p{Is_Script=- Khojki}', "");
    Expect(0, 70209, '\p{^Is_Script=- Khojki}', "");
    Expect(0, 70209, '\P{Is_Script=- Khojki}', "");
    Expect(1, 70209, '\P{^Is_Script=- Khojki}', "");
    Expect(0, 70210, '\p{Is_Script=- Khojki}', "");
    Expect(1, 70210, '\p{^Is_Script=- Khojki}', "");
    Expect(1, 70210, '\P{Is_Script=- Khojki}', "");
    Expect(0, 70210, '\P{^Is_Script=- Khojki}', "");
    Error('\p{Is_Sc=/a/_ khoj}');
    Error('\P{Is_Sc=/a/_ khoj}');
    Expect(1, 70209, '\p{Is_Sc=khoj}', "");
    Expect(0, 70209, '\p{^Is_Sc=khoj}', "");
    Expect(0, 70209, '\P{Is_Sc=khoj}', "");
    Expect(1, 70209, '\P{^Is_Sc=khoj}', "");
    Expect(0, 70210, '\p{Is_Sc=khoj}', "");
    Expect(1, 70210, '\p{^Is_Sc=khoj}', "");
    Expect(1, 70210, '\P{Is_Sc=khoj}', "");
    Expect(0, 70210, '\P{^Is_Sc=khoj}', "");
    Expect(1, 70209, '\p{Is_Sc=-	Khoj}', "");
    Expect(0, 70209, '\p{^Is_Sc=-	Khoj}', "");
    Expect(0, 70209, '\P{Is_Sc=-	Khoj}', "");
    Expect(1, 70209, '\P{^Is_Sc=-	Khoj}', "");
    Expect(0, 70210, '\p{Is_Sc=-	Khoj}', "");
    Expect(1, 70210, '\p{^Is_Sc=-	Khoj}', "");
    Expect(1, 70210, '\P{Is_Sc=-	Khoj}', "");
    Expect(0, 70210, '\P{^Is_Sc=-	Khoj}', "");
    Error('\p{Script=/a/Khitan_small_SCRIPT}');
    Error('\P{Script=/a/Khitan_small_SCRIPT}');
    Expect(1, 101589, '\p{Script=:\AKhitan_Small_Script\z:}', "");;
    Expect(0, 101590, '\p{Script=:\AKhitan_Small_Script\z:}', "");;
    Expect(1, 101589, '\p{Script=khitansmallscript}', "");
    Expect(0, 101589, '\p{^Script=khitansmallscript}', "");
    Expect(0, 101589, '\P{Script=khitansmallscript}', "");
    Expect(1, 101589, '\P{^Script=khitansmallscript}', "");
    Expect(0, 101590, '\p{Script=khitansmallscript}', "");
    Expect(1, 101590, '\p{^Script=khitansmallscript}', "");
    Expect(1, 101590, '\P{Script=khitansmallscript}', "");
    Expect(0, 101590, '\P{^Script=khitansmallscript}', "");
    Expect(1, 101589, '\p{Script=:\Akhitansmallscript\z:}', "");;
    Expect(0, 101590, '\p{Script=:\Akhitansmallscript\z:}', "");;
    Expect(1, 101589, '\p{Script=	Khitan_Small_SCRIPT}', "");
    Expect(0, 101589, '\p{^Script=	Khitan_Small_SCRIPT}', "");
    Expect(0, 101589, '\P{Script=	Khitan_Small_SCRIPT}', "");
    Expect(1, 101589, '\P{^Script=	Khitan_Small_SCRIPT}', "");
    Expect(0, 101590, '\p{Script=	Khitan_Small_SCRIPT}', "");
    Expect(1, 101590, '\p{^Script=	Khitan_Small_SCRIPT}', "");
    Expect(1, 101590, '\P{Script=	Khitan_Small_SCRIPT}', "");
    Expect(0, 101590, '\P{^Script=	Khitan_Small_SCRIPT}', "");
    Error('\p{Sc= /a/kits}');
    Error('\P{Sc= /a/kits}');
    Expect(1, 101589, '\p{Sc=:\AKits\z:}', "");;
    Expect(0, 101590, '\p{Sc=:\AKits\z:}', "");;
    Expect(1, 101589, '\p{Sc:	kits}', "");
    Expect(0, 101589, '\p{^Sc:	kits}', "");
    Expect(0, 101589, '\P{Sc:	kits}', "");
    Expect(1, 101589, '\P{^Sc:	kits}', "");
    Expect(0, 101590, '\p{Sc:	kits}', "");
    Expect(1, 101590, '\p{^Sc:	kits}', "");
    Expect(1, 101590, '\P{Sc:	kits}', "");
    Expect(0, 101590, '\P{^Sc:	kits}', "");
    Expect(1, 101589, '\p{Sc=:\Akits\z:}', "");;
    Expect(0, 101590, '\p{Sc=:\Akits\z:}', "");;
    Expect(1, 101589, '\p{Sc:	 _KITS}', "");
    Expect(0, 101589, '\p{^Sc:	 _KITS}', "");
    Expect(0, 101589, '\P{Sc:	 _KITS}', "");
    Expect(1, 101589, '\P{^Sc:	 _KITS}', "");
    Expect(0, 101590, '\p{Sc:	 _KITS}', "");
    Expect(1, 101590, '\p{^Sc:	 _KITS}', "");
    Expect(1, 101590, '\P{Sc:	 _KITS}', "");
    Expect(0, 101590, '\P{^Sc:	 _KITS}', "");
    Error('\p{Is_Script::=	KHITAN_Small_Script}');
    Error('\P{Is_Script::=	KHITAN_Small_Script}');
    Expect(1, 101589, '\p{Is_Script=khitansmallscript}', "");
    Expect(0, 101589, '\p{^Is_Script=khitansmallscript}', "");
    Expect(0, 101589, '\P{Is_Script=khitansmallscript}', "");
    Expect(1, 101589, '\P{^Is_Script=khitansmallscript}', "");
    Expect(0, 101590, '\p{Is_Script=khitansmallscript}', "");
    Expect(1, 101590, '\p{^Is_Script=khitansmallscript}', "");
    Expect(1, 101590, '\P{Is_Script=khitansmallscript}', "");
    Expect(0, 101590, '\P{^Is_Script=khitansmallscript}', "");
    Expect(1, 101589, '\p{Is_Script=-_Khitan_SMALL_SCRIPT}', "");
    Expect(0, 101589, '\p{^Is_Script=-_Khitan_SMALL_SCRIPT}', "");
    Expect(0, 101589, '\P{Is_Script=-_Khitan_SMALL_SCRIPT}', "");
    Expect(1, 101589, '\P{^Is_Script=-_Khitan_SMALL_SCRIPT}', "");
    Expect(0, 101590, '\p{Is_Script=-_Khitan_SMALL_SCRIPT}', "");
    Expect(1, 101590, '\p{^Is_Script=-_Khitan_SMALL_SCRIPT}', "");
    Expect(1, 101590, '\P{Is_Script=-_Khitan_SMALL_SCRIPT}', "");
    Expect(0, 101590, '\P{^Is_Script=-_Khitan_SMALL_SCRIPT}', "");
    Error('\p{Is_Sc=:= Kits}');
    Error('\P{Is_Sc=:= Kits}');
    Expect(1, 101589, '\p{Is_Sc=kits}', "");
    Expect(0, 101589, '\p{^Is_Sc=kits}', "");
    Expect(0, 101589, '\P{Is_Sc=kits}', "");
    Expect(1, 101589, '\P{^Is_Sc=kits}', "");
    Expect(0, 101590, '\p{Is_Sc=kits}', "");
    Expect(1, 101590, '\p{^Is_Sc=kits}', "");
    Expect(1, 101590, '\P{Is_Sc=kits}', "");
    Expect(0, 101590, '\P{^Is_Sc=kits}', "");
    Expect(1, 101589, '\p{Is_Sc=	 kits}', "");
    Expect(0, 101589, '\p{^Is_Sc=	 kits}', "");
    Expect(0, 101589, '\P{Is_Sc=	 kits}', "");
    Expect(1, 101589, '\P{^Is_Sc=	 kits}', "");
    Expect(0, 101590, '\p{Is_Sc=	 kits}', "");
    Expect(1, 101590, '\p{^Is_Sc=	 kits}', "");
    Expect(1, 101590, '\P{Is_Sc=	 kits}', "");
    Expect(0, 101590, '\P{^Is_Sc=	 kits}', "");
    Error('\p{Script=-Kannada:=}');
    Error('\P{Script=-Kannada:=}');
    Expect(1, 3315, '\p{Script=:\AKannada\z:}', "");;
    Expect(0, 3316, '\p{Script=:\AKannada\z:}', "");;
    Expect(1, 3315, '\p{Script=kannada}', "");
    Expect(0, 3315, '\p{^Script=kannada}', "");
    Expect(0, 3315, '\P{Script=kannada}', "");
    Expect(1, 3315, '\P{^Script=kannada}', "");
    Expect(0, 3316, '\p{Script=kannada}', "");
    Expect(1, 3316, '\p{^Script=kannada}', "");
    Expect(1, 3316, '\P{Script=kannada}', "");
    Expect(0, 3316, '\P{^Script=kannada}', "");
    Expect(1, 3315, '\p{Script=:\Akannada\z:}', "");;
    Expect(0, 3316, '\p{Script=:\Akannada\z:}', "");;
    Expect(1, 3315, '\p{Script= Kannada}', "");
    Expect(0, 3315, '\p{^Script= Kannada}', "");
    Expect(0, 3315, '\P{Script= Kannada}', "");
    Expect(1, 3315, '\P{^Script= Kannada}', "");
    Expect(0, 3316, '\p{Script= Kannada}', "");
    Expect(1, 3316, '\p{^Script= Kannada}', "");
    Expect(1, 3316, '\P{Script= Kannada}', "");
    Expect(0, 3316, '\P{^Script= Kannada}', "");
    Error('\p{Sc=--KNDA:=}');
    Error('\P{Sc=--KNDA:=}');
    Expect(1, 3315, '\p{Sc=:\AKnda\z:}', "");;
    Expect(0, 3316, '\p{Sc=:\AKnda\z:}', "");;
    Expect(1, 3315, '\p{Sc=knda}', "");
    Expect(0, 3315, '\p{^Sc=knda}', "");
    Expect(0, 3315, '\P{Sc=knda}', "");
    Expect(1, 3315, '\P{^Sc=knda}', "");
    Expect(0, 3316, '\p{Sc=knda}', "");
    Expect(1, 3316, '\p{^Sc=knda}', "");
    Expect(1, 3316, '\P{Sc=knda}', "");
    Expect(0, 3316, '\P{^Sc=knda}', "");
    Expect(1, 3315, '\p{Sc=:\Aknda\z:}', "");;
    Expect(0, 3316, '\p{Sc=:\Aknda\z:}', "");;
    Expect(1, 3315, '\p{Sc= Knda}', "");
    Expect(0, 3315, '\p{^Sc= Knda}', "");
    Expect(0, 3315, '\P{Sc= Knda}', "");
    Expect(1, 3315, '\P{^Sc= Knda}', "");
    Expect(0, 3316, '\p{Sc= Knda}', "");
    Expect(1, 3316, '\p{^Sc= Knda}', "");
    Expect(1, 3316, '\P{Sc= Knda}', "");
    Expect(0, 3316, '\P{^Sc= Knda}', "");
    Error('\p{Is_Script:/a/_Kannada}');
    Error('\P{Is_Script:/a/_Kannada}');
    Expect(1, 3315, '\p{Is_Script=kannada}', "");
    Expect(0, 3315, '\p{^Is_Script=kannada}', "");
    Expect(0, 3315, '\P{Is_Script=kannada}', "");
    Expect(1, 3315, '\P{^Is_Script=kannada}', "");
    Expect(0, 3316, '\p{Is_Script=kannada}', "");
    Expect(1, 3316, '\p{^Is_Script=kannada}', "");
    Expect(1, 3316, '\P{Is_Script=kannada}', "");
    Expect(0, 3316, '\P{^Is_Script=kannada}', "");
    Expect(1, 3315, '\p{Is_Script:   _ KANNADA}', "");
    Expect(0, 3315, '\p{^Is_Script:   _ KANNADA}', "");
    Expect(0, 3315, '\P{Is_Script:   _ KANNADA}', "");
    Expect(1, 3315, '\P{^Is_Script:   _ KANNADA}', "");
    Expect(0, 3316, '\p{Is_Script:   _ KANNADA}', "");
    Expect(1, 3316, '\p{^Is_Script:   _ KANNADA}', "");
    Expect(1, 3316, '\P{Is_Script:   _ KANNADA}', "");
    Expect(0, 3316, '\P{^Is_Script:   _ KANNADA}', "");
    Error('\p{Is_Sc::=		KNDA}');
    Error('\P{Is_Sc::=		KNDA}');
    Expect(1, 3315, '\p{Is_Sc=knda}', "");
    Expect(0, 3315, '\p{^Is_Sc=knda}', "");
    Expect(0, 3315, '\P{Is_Sc=knda}', "");
    Expect(1, 3315, '\P{^Is_Sc=knda}', "");
    Expect(0, 3316, '\p{Is_Sc=knda}', "");
    Expect(1, 3316, '\p{^Is_Sc=knda}', "");
    Expect(1, 3316, '\P{Is_Sc=knda}', "");
    Expect(0, 3316, '\P{^Is_Sc=knda}', "");
    Expect(1, 3315, '\p{Is_Sc=_Knda}', "");
    Expect(0, 3315, '\p{^Is_Sc=_Knda}', "");
    Expect(0, 3315, '\P{Is_Sc=_Knda}', "");
    Expect(1, 3315, '\P{^Is_Sc=_Knda}', "");
    Expect(0, 3316, '\p{Is_Sc=_Knda}', "");
    Expect(1, 3316, '\p{^Is_Sc=_Knda}', "");
    Expect(1, 3316, '\P{Is_Sc=_Knda}', "");
    Expect(0, 3316, '\P{^Is_Sc=_Knda}', "");
    Error('\p{Script=-kaithi/a/}');
    Error('\P{Script=-kaithi/a/}');
    Expect(1, 69837, '\p{Script=:\AKaithi\z:}', "");;
    Expect(0, 69838, '\p{Script=:\AKaithi\z:}', "");;
    Expect(1, 69837, '\p{Script=kaithi}', "");
    Expect(0, 69837, '\p{^Script=kaithi}', "");
    Expect(0, 69837, '\P{Script=kaithi}', "");
    Expect(1, 69837, '\P{^Script=kaithi}', "");
    Expect(0, 69838, '\p{Script=kaithi}', "");
    Expect(1, 69838, '\p{^Script=kaithi}', "");
    Expect(1, 69838, '\P{Script=kaithi}', "");
    Expect(0, 69838, '\P{^Script=kaithi}', "");
    Expect(1, 69837, '\p{Script=:\Akaithi\z:}', "");;
    Expect(0, 69838, '\p{Script=:\Akaithi\z:}', "");;
    Expect(1, 69837, '\p{Script=_ Kaithi}', "");
    Expect(0, 69837, '\p{^Script=_ Kaithi}', "");
    Expect(0, 69837, '\P{Script=_ Kaithi}', "");
    Expect(1, 69837, '\P{^Script=_ Kaithi}', "");
    Expect(0, 69838, '\p{Script=_ Kaithi}', "");
    Expect(1, 69838, '\p{^Script=_ Kaithi}', "");
    Expect(1, 69838, '\P{Script=_ Kaithi}', "");
    Expect(0, 69838, '\P{^Script=_ Kaithi}', "");
    Error('\p{Sc=_/a/Kthi}');
    Error('\P{Sc=_/a/Kthi}');
    Expect(1, 69837, '\p{Sc=:\AKthi\z:}', "");;
    Expect(0, 69838, '\p{Sc=:\AKthi\z:}', "");;
    Expect(1, 69837, '\p{Sc=kthi}', "");
    Expect(0, 69837, '\p{^Sc=kthi}', "");
    Expect(0, 69837, '\P{Sc=kthi}', "");
    Expect(1, 69837, '\P{^Sc=kthi}', "");
    Expect(0, 69838, '\p{Sc=kthi}', "");
    Expect(1, 69838, '\p{^Sc=kthi}', "");
    Expect(1, 69838, '\P{Sc=kthi}', "");
    Expect(0, 69838, '\P{^Sc=kthi}', "");
    Expect(1, 69837, '\p{Sc=:\Akthi\z:}', "");;
    Expect(0, 69838, '\p{Sc=:\Akthi\z:}', "");;
    Expect(1, 69837, '\p{Sc=	 Kthi}', "");
    Expect(0, 69837, '\p{^Sc=	 Kthi}', "");
    Expect(0, 69837, '\P{Sc=	 Kthi}', "");
    Expect(1, 69837, '\P{^Sc=	 Kthi}', "");
    Expect(0, 69838, '\p{Sc=	 Kthi}', "");
    Expect(1, 69838, '\p{^Sc=	 Kthi}', "");
    Expect(1, 69838, '\P{Sc=	 Kthi}', "");
    Expect(0, 69838, '\P{^Sc=	 Kthi}', "");
    Error('\p{Is_Script=__Kaithi/a/}');
    Error('\P{Is_Script=__Kaithi/a/}');
    Expect(1, 69837, '\p{Is_Script=kaithi}', "");
    Expect(0, 69837, '\p{^Is_Script=kaithi}', "");
    Expect(0, 69837, '\P{Is_Script=kaithi}', "");
    Expect(1, 69837, '\P{^Is_Script=kaithi}', "");
    Expect(0, 69838, '\p{Is_Script=kaithi}', "");
    Expect(1, 69838, '\p{^Is_Script=kaithi}', "");
    Expect(1, 69838, '\P{Is_Script=kaithi}', "");
    Expect(0, 69838, '\P{^Is_Script=kaithi}', "");
    Expect(1, 69837, '\p{Is_Script= 	Kaithi}', "");
    Expect(0, 69837, '\p{^Is_Script= 	Kaithi}', "");
    Expect(0, 69837, '\P{Is_Script= 	Kaithi}', "");
    Expect(1, 69837, '\P{^Is_Script= 	Kaithi}', "");
    Expect(0, 69838, '\p{Is_Script= 	Kaithi}', "");
    Expect(1, 69838, '\p{^Is_Script= 	Kaithi}', "");
    Expect(1, 69838, '\P{Is_Script= 	Kaithi}', "");
    Expect(0, 69838, '\P{^Is_Script= 	Kaithi}', "");
    Error('\p{Is_Sc=:=KTHI}');
    Error('\P{Is_Sc=:=KTHI}');
    Expect(1, 69837, '\p{Is_Sc=kthi}', "");
    Expect(0, 69837, '\p{^Is_Sc=kthi}', "");
    Expect(0, 69837, '\P{Is_Sc=kthi}', "");
    Expect(1, 69837, '\P{^Is_Sc=kthi}', "");
    Expect(0, 69838, '\p{Is_Sc=kthi}', "");
    Expect(1, 69838, '\p{^Is_Sc=kthi}', "");
    Expect(1, 69838, '\P{Is_Sc=kthi}', "");
    Expect(0, 69838, '\P{^Is_Sc=kthi}', "");
    Expect(1, 69837, '\p{Is_Sc= 	Kthi}', "");
    Expect(0, 69837, '\p{^Is_Sc= 	Kthi}', "");
    Expect(0, 69837, '\P{Is_Sc= 	Kthi}', "");
    Expect(1, 69837, '\P{^Is_Sc= 	Kthi}', "");
    Expect(0, 69838, '\p{Is_Sc= 	Kthi}', "");
    Expect(1, 69838, '\p{^Is_Sc= 	Kthi}', "");
    Expect(1, 69838, '\P{Is_Sc= 	Kthi}', "");
    Expect(0, 69838, '\P{^Is_Sc= 	Kthi}', "");
    Error('\p{Script=:=Tai_Tham}');
    Error('\P{Script=:=Tai_Tham}');
    Expect(1, 6829, '\p{Script=:\ATai_Tham\z:}', "");;
    Expect(0, 6830, '\p{Script=:\ATai_Tham\z:}', "");;
    Expect(1, 6829, '\p{Script=taitham}', "");
    Expect(0, 6829, '\p{^Script=taitham}', "");
    Expect(0, 6829, '\P{Script=taitham}', "");
    Expect(1, 6829, '\P{^Script=taitham}', "");
    Expect(0, 6830, '\p{Script=taitham}', "");
    Expect(1, 6830, '\p{^Script=taitham}', "");
    Expect(1, 6830, '\P{Script=taitham}', "");
    Expect(0, 6830, '\P{^Script=taitham}', "");
    Expect(1, 6829, '\p{Script=:\Ataitham\z:}', "");;
    Expect(0, 6830, '\p{Script=:\Ataitham\z:}', "");;
    Expect(1, 6829, '\p{Script=	-tai_THAM}', "");
    Expect(0, 6829, '\p{^Script=	-tai_THAM}', "");
    Expect(0, 6829, '\P{Script=	-tai_THAM}', "");
    Expect(1, 6829, '\P{^Script=	-tai_THAM}', "");
    Expect(0, 6830, '\p{Script=	-tai_THAM}', "");
    Expect(1, 6830, '\p{^Script=	-tai_THAM}', "");
    Expect(1, 6830, '\P{Script=	-tai_THAM}', "");
    Expect(0, 6830, '\P{^Script=	-tai_THAM}', "");
    Error('\p{Sc=/a/_	LANA}');
    Error('\P{Sc=/a/_	LANA}');
    Expect(1, 6829, '\p{Sc=:\ALana\z:}', "");;
    Expect(0, 6830, '\p{Sc=:\ALana\z:}', "");;
    Expect(1, 6829, '\p{Sc=lana}', "");
    Expect(0, 6829, '\p{^Sc=lana}', "");
    Expect(0, 6829, '\P{Sc=lana}', "");
    Expect(1, 6829, '\P{^Sc=lana}', "");
    Expect(0, 6830, '\p{Sc=lana}', "");
    Expect(1, 6830, '\p{^Sc=lana}', "");
    Expect(1, 6830, '\P{Sc=lana}', "");
    Expect(0, 6830, '\P{^Sc=lana}', "");
    Expect(1, 6829, '\p{Sc=:\Alana\z:}', "");;
    Expect(0, 6830, '\p{Sc=:\Alana\z:}', "");;
    Expect(1, 6829, '\p{Sc=--Lana}', "");
    Expect(0, 6829, '\p{^Sc=--Lana}', "");
    Expect(0, 6829, '\P{Sc=--Lana}', "");
    Expect(1, 6829, '\P{^Sc=--Lana}', "");
    Expect(0, 6830, '\p{Sc=--Lana}', "");
    Expect(1, 6830, '\p{^Sc=--Lana}', "");
    Expect(1, 6830, '\P{Sc=--Lana}', "");
    Expect(0, 6830, '\P{^Sc=--Lana}', "");
    Error('\p{Is_Script= Tai_THAM:=}');
    Error('\P{Is_Script= Tai_THAM:=}');
    Expect(1, 6829, '\p{Is_Script=taitham}', "");
    Expect(0, 6829, '\p{^Is_Script=taitham}', "");
    Expect(0, 6829, '\P{Is_Script=taitham}', "");
    Expect(1, 6829, '\P{^Is_Script=taitham}', "");
    Expect(0, 6830, '\p{Is_Script=taitham}', "");
    Expect(1, 6830, '\p{^Is_Script=taitham}', "");
    Expect(1, 6830, '\P{Is_Script=taitham}', "");
    Expect(0, 6830, '\P{^Is_Script=taitham}', "");
    Expect(1, 6829, '\p{Is_Script=_Tai_Tham}', "");
    Expect(0, 6829, '\p{^Is_Script=_Tai_Tham}', "");
    Expect(0, 6829, '\P{Is_Script=_Tai_Tham}', "");
    Expect(1, 6829, '\P{^Is_Script=_Tai_Tham}', "");
    Expect(0, 6830, '\p{Is_Script=_Tai_Tham}', "");
    Expect(1, 6830, '\p{^Is_Script=_Tai_Tham}', "");
    Expect(1, 6830, '\P{Is_Script=_Tai_Tham}', "");
    Expect(0, 6830, '\P{^Is_Script=_Tai_Tham}', "");
    Error('\p{Is_Sc: -Lana:=}');
    Error('\P{Is_Sc: -Lana:=}');
    Expect(1, 6829, '\p{Is_Sc=lana}', "");
    Expect(0, 6829, '\p{^Is_Sc=lana}', "");
    Expect(0, 6829, '\P{Is_Sc=lana}', "");
    Expect(1, 6829, '\P{^Is_Sc=lana}', "");
    Expect(0, 6830, '\p{Is_Sc=lana}', "");
    Expect(1, 6830, '\p{^Is_Sc=lana}', "");
    Expect(1, 6830, '\P{Is_Sc=lana}', "");
    Expect(0, 6830, '\P{^Is_Sc=lana}', "");
    Expect(1, 6829, '\p{Is_Sc=	-lana}', "");
    Expect(0, 6829, '\p{^Is_Sc=	-lana}', "");
    Expect(0, 6829, '\P{Is_Sc=	-lana}', "");
    Expect(1, 6829, '\P{^Is_Sc=	-lana}', "");
    Expect(0, 6830, '\p{Is_Sc=	-lana}', "");
    Expect(1, 6830, '\p{^Is_Sc=	-lana}', "");
    Expect(1, 6830, '\P{Is_Sc=	-lana}', "");
    Expect(0, 6830, '\P{^Is_Sc=	-lana}', "");
    Error('\p{Script=:=-Lao}');
    Error('\P{Script=:=-Lao}');
    Expect(1, 3807, '\p{Script=:\ALao\z:}', "");;
    Expect(0, 3808, '\p{Script=:\ALao\z:}', "");;
    Expect(1, 3807, '\p{Script:   lao}', "");
    Expect(0, 3807, '\p{^Script:   lao}', "");
    Expect(0, 3807, '\P{Script:   lao}', "");
    Expect(1, 3807, '\P{^Script:   lao}', "");
    Expect(0, 3808, '\p{Script:   lao}', "");
    Expect(1, 3808, '\p{^Script:   lao}', "");
    Expect(1, 3808, '\P{Script:   lao}', "");
    Expect(0, 3808, '\P{^Script:   lao}', "");
    Expect(1, 3807, '\p{Script=:\Alao\z:}', "");;
    Expect(0, 3808, '\p{Script=:\Alao\z:}', "");;
    Expect(1, 3807, '\p{Script:   __Lao}', "");
    Expect(0, 3807, '\p{^Script:   __Lao}', "");
    Expect(0, 3807, '\P{Script:   __Lao}', "");
    Expect(1, 3807, '\P{^Script:   __Lao}', "");
    Expect(0, 3808, '\p{Script:   __Lao}', "");
    Expect(1, 3808, '\p{^Script:   __Lao}', "");
    Expect(1, 3808, '\P{Script:   __Lao}', "");
    Expect(0, 3808, '\P{^Script:   __Lao}', "");
    Error('\p{Sc=_:=Laoo}');
    Error('\P{Sc=_:=Laoo}');
    Expect(1, 3807, '\p{Sc=:\ALaoo\z:}', "");;
    Expect(0, 3808, '\p{Sc=:\ALaoo\z:}', "");;
    Expect(1, 3807, '\p{Sc:laoo}', "");
    Expect(0, 3807, '\p{^Sc:laoo}', "");
    Expect(0, 3807, '\P{Sc:laoo}', "");
    Expect(1, 3807, '\P{^Sc:laoo}', "");
    Expect(0, 3808, '\p{Sc:laoo}', "");
    Expect(1, 3808, '\p{^Sc:laoo}', "");
    Expect(1, 3808, '\P{Sc:laoo}', "");
    Expect(0, 3808, '\P{^Sc:laoo}', "");
    Expect(1, 3807, '\p{Sc=:\Alaoo\z:}', "");;
    Expect(0, 3808, '\p{Sc=:\Alaoo\z:}', "");;
    Expect(1, 3807, '\p{Sc=	Laoo}', "");
    Expect(0, 3807, '\p{^Sc=	Laoo}', "");
    Expect(0, 3807, '\P{Sc=	Laoo}', "");
    Expect(1, 3807, '\P{^Sc=	Laoo}', "");
    Expect(0, 3808, '\p{Sc=	Laoo}', "");
    Expect(1, 3808, '\p{^Sc=	Laoo}', "");
    Expect(1, 3808, '\P{Sc=	Laoo}', "");
    Expect(0, 3808, '\P{^Sc=	Laoo}', "");
    Error('\p{Is_Script=_Lao/a/}');
    Error('\P{Is_Script=_Lao/a/}');
    Expect(1, 3807, '\p{Is_Script=lao}', "");
    Expect(0, 3807, '\p{^Is_Script=lao}', "");
    Expect(0, 3807, '\P{Is_Script=lao}', "");
    Expect(1, 3807, '\P{^Is_Script=lao}', "");
    Expect(0, 3808, '\p{Is_Script=lao}', "");
    Expect(1, 3808, '\p{^Is_Script=lao}', "");
    Expect(1, 3808, '\P{Is_Script=lao}', "");
    Expect(0, 3808, '\P{^Is_Script=lao}', "");
    Expect(1, 3807, '\p{Is_Script= lao}', "");
    Expect(0, 3807, '\p{^Is_Script= lao}', "");
    Expect(0, 3807, '\P{Is_Script= lao}', "");
    Expect(1, 3807, '\P{^Is_Script= lao}', "");
    Expect(0, 3808, '\p{Is_Script= lao}', "");
    Expect(1, 3808, '\p{^Is_Script= lao}', "");
    Expect(1, 3808, '\P{Is_Script= lao}', "");
    Expect(0, 3808, '\P{^Is_Script= lao}', "");
    Error('\p{Is_Sc=-:=Laoo}');
    Error('\P{Is_Sc=-:=Laoo}');
    Expect(1, 3807, '\p{Is_Sc=laoo}', "");
    Expect(0, 3807, '\p{^Is_Sc=laoo}', "");
    Expect(0, 3807, '\P{Is_Sc=laoo}', "");
    Expect(1, 3807, '\P{^Is_Sc=laoo}', "");
    Expect(0, 3808, '\p{Is_Sc=laoo}', "");
    Expect(1, 3808, '\p{^Is_Sc=laoo}', "");
    Expect(1, 3808, '\P{Is_Sc=laoo}', "");
    Expect(0, 3808, '\P{^Is_Sc=laoo}', "");
    Expect(1, 3807, '\p{Is_Sc=		LAOO}', "");
    Expect(0, 3807, '\p{^Is_Sc=		LAOO}', "");
    Expect(0, 3807, '\P{Is_Sc=		LAOO}', "");
    Expect(1, 3807, '\P{^Is_Sc=		LAOO}', "");
    Expect(0, 3808, '\p{Is_Sc=		LAOO}', "");
    Expect(1, 3808, '\p{^Is_Sc=		LAOO}', "");
    Expect(1, 3808, '\P{Is_Sc=		LAOO}', "");
    Expect(0, 3808, '\P{^Is_Sc=		LAOO}', "");
    Error('\p{Script: -/a/latin}');
    Error('\P{Script: -/a/latin}');
    Expect(1, 122666, '\p{Script=:\ALatin\z:}', "");;
    Expect(0, 122667, '\p{Script=:\ALatin\z:}', "");;
    Expect(1, 122666, '\p{Script:latin}', "");
    Expect(0, 122666, '\p{^Script:latin}', "");
    Expect(0, 122666, '\P{Script:latin}', "");
    Expect(1, 122666, '\P{^Script:latin}', "");
    Expect(0, 122667, '\p{Script:latin}', "");
    Expect(1, 122667, '\p{^Script:latin}', "");
    Expect(1, 122667, '\P{Script:latin}', "");
    Expect(0, 122667, '\P{^Script:latin}', "");
    Expect(1, 122666, '\p{Script=:\Alatin\z:}', "");;
    Expect(0, 122667, '\p{Script=:\Alatin\z:}', "");;
    Expect(1, 122666, '\p{Script=_latin}', "");
    Expect(0, 122666, '\p{^Script=_latin}', "");
    Expect(0, 122666, '\P{Script=_latin}', "");
    Expect(1, 122666, '\P{^Script=_latin}', "");
    Expect(0, 122667, '\p{Script=_latin}', "");
    Expect(1, 122667, '\p{^Script=_latin}', "");
    Expect(1, 122667, '\P{Script=_latin}', "");
    Expect(0, 122667, '\P{^Script=_latin}', "");
    Error('\p{Sc=	LATN/a/}');
    Error('\P{Sc=	LATN/a/}');
    Expect(1, 122666, '\p{Sc=:\ALatn\z:}', "");;
    Expect(0, 122667, '\p{Sc=:\ALatn\z:}', "");;
    Expect(1, 122666, '\p{Sc=latn}', "");
    Expect(0, 122666, '\p{^Sc=latn}', "");
    Expect(0, 122666, '\P{Sc=latn}', "");
    Expect(1, 122666, '\P{^Sc=latn}', "");
    Expect(0, 122667, '\p{Sc=latn}', "");
    Expect(1, 122667, '\p{^Sc=latn}', "");
    Expect(1, 122667, '\P{Sc=latn}', "");
    Expect(0, 122667, '\P{^Sc=latn}', "");
    Expect(1, 122666, '\p{Sc=:\Alatn\z:}', "");;
    Expect(0, 122667, '\p{Sc=:\Alatn\z:}', "");;
    Expect(1, 122666, '\p{Sc=_-Latn}', "");
    Expect(0, 122666, '\p{^Sc=_-Latn}', "");
    Expect(0, 122666, '\P{Sc=_-Latn}', "");
    Expect(1, 122666, '\P{^Sc=_-Latn}', "");
    Expect(0, 122667, '\p{Sc=_-Latn}', "");
    Expect(1, 122667, '\p{^Sc=_-Latn}', "");
    Expect(1, 122667, '\P{Sc=_-Latn}', "");
    Expect(0, 122667, '\P{^Sc=_-Latn}', "");
    Error('\p{Is_Script=/a/_Latin}');
    Error('\P{Is_Script=/a/_Latin}');
    Expect(1, 122666, '\p{Is_Script=latin}', "");
    Expect(0, 122666, '\p{^Is_Script=latin}', "");
    Expect(0, 122666, '\P{Is_Script=latin}', "");
    Expect(1, 122666, '\P{^Is_Script=latin}', "");
    Expect(0, 122667, '\p{Is_Script=latin}', "");
    Expect(1, 122667, '\p{^Is_Script=latin}', "");
    Expect(1, 122667, '\P{Is_Script=latin}', "");
    Expect(0, 122667, '\P{^Is_Script=latin}', "");
    Expect(1, 122666, '\p{Is_Script= Latin}', "");
    Expect(0, 122666, '\p{^Is_Script= Latin}', "");
    Expect(0, 122666, '\P{Is_Script= Latin}', "");
    Expect(1, 122666, '\P{^Is_Script= Latin}', "");
    Expect(0, 122667, '\p{Is_Script= Latin}', "");
    Expect(1, 122667, '\p{^Is_Script= Latin}', "");
    Expect(1, 122667, '\P{Is_Script= Latin}', "");
    Expect(0, 122667, '\P{^Is_Script= Latin}', "");
    Error('\p{Is_Sc=	/a/Latn}');
    Error('\P{Is_Sc=	/a/Latn}');
    Expect(1, 122666, '\p{Is_Sc:   latn}', "");
    Expect(0, 122666, '\p{^Is_Sc:   latn}', "");
    Expect(0, 122666, '\P{Is_Sc:   latn}', "");
    Expect(1, 122666, '\P{^Is_Sc:   latn}', "");
    Expect(0, 122667, '\p{Is_Sc:   latn}', "");
    Expect(1, 122667, '\p{^Is_Sc:   latn}', "");
    Expect(1, 122667, '\P{Is_Sc:   latn}', "");
    Expect(0, 122667, '\P{^Is_Sc:   latn}', "");
    Expect(1, 122666, '\p{Is_Sc=Latn}', "");
    Expect(0, 122666, '\p{^Is_Sc=Latn}', "");
    Expect(0, 122666, '\P{Is_Sc=Latn}', "");
    Expect(1, 122666, '\P{^Is_Sc=Latn}', "");
    Expect(0, 122667, '\p{Is_Sc=Latn}', "");
    Expect(1, 122667, '\p{^Is_Sc=Latn}', "");
    Expect(1, 122667, '\P{Is_Sc=Latn}', "");
    Expect(0, 122667, '\P{^Is_Sc=Latn}', "");
    Error('\p{Script=:= lepcha}');
    Error('\P{Script=:= lepcha}');
    Expect(1, 7247, '\p{Script=:\ALepcha\z:}', "");;
    Expect(0, 7248, '\p{Script=:\ALepcha\z:}', "");;
    Expect(1, 7247, '\p{Script=lepcha}', "");
    Expect(0, 7247, '\p{^Script=lepcha}', "");
    Expect(0, 7247, '\P{Script=lepcha}', "");
    Expect(1, 7247, '\P{^Script=lepcha}', "");
    Expect(0, 7248, '\p{Script=lepcha}', "");
    Expect(1, 7248, '\p{^Script=lepcha}', "");
    Expect(1, 7248, '\P{Script=lepcha}', "");
    Expect(0, 7248, '\P{^Script=lepcha}', "");
    Expect(1, 7247, '\p{Script=:\Alepcha\z:}', "");;
    Expect(0, 7248, '\p{Script=:\Alepcha\z:}', "");;
    Expect(1, 7247, '\p{Script=-	lepcha}', "");
    Expect(0, 7247, '\p{^Script=-	lepcha}', "");
    Expect(0, 7247, '\P{Script=-	lepcha}', "");
    Expect(1, 7247, '\P{^Script=-	lepcha}', "");
    Expect(0, 7248, '\p{Script=-	lepcha}', "");
    Expect(1, 7248, '\p{^Script=-	lepcha}', "");
    Expect(1, 7248, '\P{Script=-	lepcha}', "");
    Expect(0, 7248, '\P{^Script=-	lepcha}', "");
    Error('\p{Sc=/a/lepc}');
    Error('\P{Sc=/a/lepc}');
    Expect(1, 7247, '\p{Sc=:\ALepc\z:}', "");;
    Expect(0, 7248, '\p{Sc=:\ALepc\z:}', "");;
    Expect(1, 7247, '\p{Sc=lepc}', "");
    Expect(0, 7247, '\p{^Sc=lepc}', "");
    Expect(0, 7247, '\P{Sc=lepc}', "");
    Expect(1, 7247, '\P{^Sc=lepc}', "");
    Expect(0, 7248, '\p{Sc=lepc}', "");
    Expect(1, 7248, '\p{^Sc=lepc}', "");
    Expect(1, 7248, '\P{Sc=lepc}', "");
    Expect(0, 7248, '\P{^Sc=lepc}', "");
    Expect(1, 7247, '\p{Sc=:\Alepc\z:}', "");;
    Expect(0, 7248, '\p{Sc=:\Alepc\z:}', "");;
    Expect(1, 7247, '\p{Sc=	_lepc}', "");
    Expect(0, 7247, '\p{^Sc=	_lepc}', "");
    Expect(0, 7247, '\P{Sc=	_lepc}', "");
    Expect(1, 7247, '\P{^Sc=	_lepc}', "");
    Expect(0, 7248, '\p{Sc=	_lepc}', "");
    Expect(1, 7248, '\p{^Sc=	_lepc}', "");
    Expect(1, 7248, '\P{Sc=	_lepc}', "");
    Expect(0, 7248, '\P{^Sc=	_lepc}', "");
    Error('\p{Is_Script=	-LEPCHA:=}');
    Error('\P{Is_Script=	-LEPCHA:=}');
    Expect(1, 7247, '\p{Is_Script=lepcha}', "");
    Expect(0, 7247, '\p{^Is_Script=lepcha}', "");
    Expect(0, 7247, '\P{Is_Script=lepcha}', "");
    Expect(1, 7247, '\P{^Is_Script=lepcha}', "");
    Expect(0, 7248, '\p{Is_Script=lepcha}', "");
    Expect(1, 7248, '\p{^Is_Script=lepcha}', "");
    Expect(1, 7248, '\P{Is_Script=lepcha}', "");
    Expect(0, 7248, '\P{^Is_Script=lepcha}', "");
    Expect(1, 7247, '\p{Is_Script=  Lepcha}', "");
    Expect(0, 7247, '\p{^Is_Script=  Lepcha}', "");
    Expect(0, 7247, '\P{Is_Script=  Lepcha}', "");
    Expect(1, 7247, '\P{^Is_Script=  Lepcha}', "");
    Expect(0, 7248, '\p{Is_Script=  Lepcha}', "");
    Expect(1, 7248, '\p{^Is_Script=  Lepcha}', "");
    Expect(1, 7248, '\P{Is_Script=  Lepcha}', "");
    Expect(0, 7248, '\P{^Is_Script=  Lepcha}', "");
    Error('\p{Is_Sc=/a/LEPC}');
    Error('\P{Is_Sc=/a/LEPC}');
    Expect(1, 7247, '\p{Is_Sc=lepc}', "");
    Expect(0, 7247, '\p{^Is_Sc=lepc}', "");
    Expect(0, 7247, '\P{Is_Sc=lepc}', "");
    Expect(1, 7247, '\P{^Is_Sc=lepc}', "");
    Expect(0, 7248, '\p{Is_Sc=lepc}', "");
    Expect(1, 7248, '\p{^Is_Sc=lepc}', "");
    Expect(1, 7248, '\P{Is_Sc=lepc}', "");
    Expect(0, 7248, '\P{^Is_Sc=lepc}', "");
    Expect(1, 7247, '\p{Is_Sc=-	lepc}', "");
    Expect(0, 7247, '\p{^Is_Sc=-	lepc}', "");
    Expect(0, 7247, '\P{Is_Sc=-	lepc}', "");
    Expect(1, 7247, '\P{^Is_Sc=-	lepc}', "");
    Expect(0, 7248, '\p{Is_Sc=-	lepc}', "");
    Expect(1, 7248, '\p{^Is_Sc=-	lepc}', "");
    Expect(1, 7248, '\P{Is_Sc=-	lepc}', "");
    Expect(0, 7248, '\P{^Is_Sc=-	lepc}', "");
    Error('\p{Script= _limbu/a/}');
    Error('\P{Script= _limbu/a/}');
    Expect(1, 6479, '\p{Script=:\ALimbu\z:}', "");;
    Expect(0, 6480, '\p{Script=:\ALimbu\z:}', "");;
    Expect(1, 6479, '\p{Script=limbu}', "");
    Expect(0, 6479, '\p{^Script=limbu}', "");
    Expect(0, 6479, '\P{Script=limbu}', "");
    Expect(1, 6479, '\P{^Script=limbu}', "");
    Expect(0, 6480, '\p{Script=limbu}', "");
    Expect(1, 6480, '\p{^Script=limbu}', "");
    Expect(1, 6480, '\P{Script=limbu}', "");
    Expect(0, 6480, '\P{^Script=limbu}', "");
    Expect(1, 6479, '\p{Script=:\Alimbu\z:}', "");;
    Expect(0, 6480, '\p{Script=:\Alimbu\z:}', "");;
    Expect(1, 6479, '\p{Script: -	LIMBU}', "");
    Expect(0, 6479, '\p{^Script: -	LIMBU}', "");
    Expect(0, 6479, '\P{Script: -	LIMBU}', "");
    Expect(1, 6479, '\P{^Script: -	LIMBU}', "");
    Expect(0, 6480, '\p{Script: -	LIMBU}', "");
    Expect(1, 6480, '\p{^Script: -	LIMBU}', "");
    Expect(1, 6480, '\P{Script: -	LIMBU}', "");
    Expect(0, 6480, '\P{^Script: -	LIMBU}', "");
    Error('\p{Sc=/a/ -Limb}');
    Error('\P{Sc=/a/ -Limb}');
    Expect(1, 6479, '\p{Sc=:\ALimb\z:}', "");;
    Expect(0, 6480, '\p{Sc=:\ALimb\z:}', "");;
    Expect(1, 6479, '\p{Sc=limb}', "");
    Expect(0, 6479, '\p{^Sc=limb}', "");
    Expect(0, 6479, '\P{Sc=limb}', "");
    Expect(1, 6479, '\P{^Sc=limb}', "");
    Expect(0, 6480, '\p{Sc=limb}', "");
    Expect(1, 6480, '\p{^Sc=limb}', "");
    Expect(1, 6480, '\P{Sc=limb}', "");
    Expect(0, 6480, '\P{^Sc=limb}', "");
    Expect(1, 6479, '\p{Sc=:\Alimb\z:}', "");;
    Expect(0, 6480, '\p{Sc=:\Alimb\z:}', "");;
    Expect(1, 6479, '\p{Sc= 	LIMB}', "");
    Expect(0, 6479, '\p{^Sc= 	LIMB}', "");
    Expect(0, 6479, '\P{Sc= 	LIMB}', "");
    Expect(1, 6479, '\P{^Sc= 	LIMB}', "");
    Expect(0, 6480, '\p{Sc= 	LIMB}', "");
    Expect(1, 6480, '\p{^Sc= 	LIMB}', "");
    Expect(1, 6480, '\P{Sc= 	LIMB}', "");
    Expect(0, 6480, '\P{^Sc= 	LIMB}', "");
    Error('\p{Is_Script=/a/-	Limbu}');
    Error('\P{Is_Script=/a/-	Limbu}');
    Expect(1, 6479, '\p{Is_Script=limbu}', "");
    Expect(0, 6479, '\p{^Is_Script=limbu}', "");
    Expect(0, 6479, '\P{Is_Script=limbu}', "");
    Expect(1, 6479, '\P{^Is_Script=limbu}', "");
    Expect(0, 6480, '\p{Is_Script=limbu}', "");
    Expect(1, 6480, '\p{^Is_Script=limbu}', "");
    Expect(1, 6480, '\P{Is_Script=limbu}', "");
    Expect(0, 6480, '\P{^Is_Script=limbu}', "");
    Expect(1, 6479, '\p{Is_Script:	-	LIMBU}', "");
    Expect(0, 6479, '\p{^Is_Script:	-	LIMBU}', "");
    Expect(0, 6479, '\P{Is_Script:	-	LIMBU}', "");
    Expect(1, 6479, '\P{^Is_Script:	-	LIMBU}', "");
    Expect(0, 6480, '\p{Is_Script:	-	LIMBU}', "");
    Expect(1, 6480, '\p{^Is_Script:	-	LIMBU}', "");
    Expect(1, 6480, '\P{Is_Script:	-	LIMBU}', "");
    Expect(0, 6480, '\P{^Is_Script:	-	LIMBU}', "");
    Error('\p{Is_Sc=/a/limb}');
    Error('\P{Is_Sc=/a/limb}');
    Expect(1, 6479, '\p{Is_Sc=limb}', "");
    Expect(0, 6479, '\p{^Is_Sc=limb}', "");
    Expect(0, 6479, '\P{Is_Sc=limb}', "");
    Expect(1, 6479, '\P{^Is_Sc=limb}', "");
    Expect(0, 6480, '\p{Is_Sc=limb}', "");
    Expect(1, 6480, '\p{^Is_Sc=limb}', "");
    Expect(1, 6480, '\P{Is_Sc=limb}', "");
    Expect(0, 6480, '\P{^Is_Sc=limb}', "");
    Expect(1, 6479, '\p{Is_Sc=	 Limb}', "");
    Expect(0, 6479, '\p{^Is_Sc=	 Limb}', "");
    Expect(0, 6479, '\P{Is_Sc=	 Limb}', "");
    Expect(1, 6479, '\P{^Is_Sc=	 Limb}', "");
    Expect(0, 6480, '\p{Is_Sc=	 Limb}', "");
    Expect(1, 6480, '\p{^Is_Sc=	 Limb}', "");
    Expect(1, 6480, '\P{Is_Sc=	 Limb}', "");
    Expect(0, 6480, '\P{^Is_Sc=	 Limb}', "");
    Error('\p{Script=	:=linear_A}');
    Error('\P{Script=	:=linear_A}');
    Expect(1, 67431, '\p{Script=:\ALinear_A\z:}', "");;
    Expect(0, 67432, '\p{Script=:\ALinear_A\z:}', "");;
    Expect(1, 67431, '\p{Script=lineara}', "");
    Expect(0, 67431, '\p{^Script=lineara}', "");
    Expect(0, 67431, '\P{Script=lineara}', "");
    Expect(1, 67431, '\P{^Script=lineara}', "");
    Expect(0, 67432, '\p{Script=lineara}', "");
    Expect(1, 67432, '\p{^Script=lineara}', "");
    Expect(1, 67432, '\P{Script=lineara}', "");
    Expect(0, 67432, '\P{^Script=lineara}', "");
    Expect(1, 67431, '\p{Script=:\Alineara\z:}', "");;
    Expect(0, 67432, '\p{Script=:\Alineara\z:}', "");;
    Expect(1, 67431, '\p{Script=	Linear_a}', "");
    Expect(0, 67431, '\p{^Script=	Linear_a}', "");
    Expect(0, 67431, '\P{Script=	Linear_a}', "");
    Expect(1, 67431, '\P{^Script=	Linear_a}', "");
    Expect(0, 67432, '\p{Script=	Linear_a}', "");
    Expect(1, 67432, '\p{^Script=	Linear_a}', "");
    Expect(1, 67432, '\P{Script=	Linear_a}', "");
    Expect(0, 67432, '\P{^Script=	Linear_a}', "");
    Error('\p{Sc= :=Lina}');
    Error('\P{Sc= :=Lina}');
    Expect(1, 67431, '\p{Sc=:\ALina\z:}', "");;
    Expect(0, 67432, '\p{Sc=:\ALina\z:}', "");;
    Expect(1, 67431, '\p{Sc=lina}', "");
    Expect(0, 67431, '\p{^Sc=lina}', "");
    Expect(0, 67431, '\P{Sc=lina}', "");
    Expect(1, 67431, '\P{^Sc=lina}', "");
    Expect(0, 67432, '\p{Sc=lina}', "");
    Expect(1, 67432, '\p{^Sc=lina}', "");
    Expect(1, 67432, '\P{Sc=lina}', "");
    Expect(0, 67432, '\P{^Sc=lina}', "");
    Expect(1, 67431, '\p{Sc=:\Alina\z:}', "");;
    Expect(0, 67432, '\p{Sc=:\Alina\z:}', "");;
    Expect(1, 67431, '\p{Sc=		LINA}', "");
    Expect(0, 67431, '\p{^Sc=		LINA}', "");
    Expect(0, 67431, '\P{Sc=		LINA}', "");
    Expect(1, 67431, '\P{^Sc=		LINA}', "");
    Expect(0, 67432, '\p{Sc=		LINA}', "");
    Expect(1, 67432, '\p{^Sc=		LINA}', "");
    Expect(1, 67432, '\P{Sc=		LINA}', "");
    Expect(0, 67432, '\P{^Sc=		LINA}', "");
    Error('\p{Is_Script=_:=linear_a}');
    Error('\P{Is_Script=_:=linear_a}');
    Expect(1, 67431, '\p{Is_Script=lineara}', "");
    Expect(0, 67431, '\p{^Is_Script=lineara}', "");
    Expect(0, 67431, '\P{Is_Script=lineara}', "");
    Expect(1, 67431, '\P{^Is_Script=lineara}', "");
    Expect(0, 67432, '\p{Is_Script=lineara}', "");
    Expect(1, 67432, '\p{^Is_Script=lineara}', "");
    Expect(1, 67432, '\P{Is_Script=lineara}', "");
    Expect(0, 67432, '\P{^Is_Script=lineara}', "");
    Expect(1, 67431, '\p{Is_Script:	 -LINEAR_A}', "");
    Expect(0, 67431, '\p{^Is_Script:	 -LINEAR_A}', "");
    Expect(0, 67431, '\P{Is_Script:	 -LINEAR_A}', "");
    Expect(1, 67431, '\P{^Is_Script:	 -LINEAR_A}', "");
    Expect(0, 67432, '\p{Is_Script:	 -LINEAR_A}', "");
    Expect(1, 67432, '\p{^Is_Script:	 -LINEAR_A}', "");
    Expect(1, 67432, '\P{Is_Script:	 -LINEAR_A}', "");
    Expect(0, 67432, '\P{^Is_Script:	 -LINEAR_A}', "");
    Error('\p{Is_Sc=:= -LINA}');
    Error('\P{Is_Sc=:= -LINA}');
    Expect(1, 67431, '\p{Is_Sc=lina}', "");
    Expect(0, 67431, '\p{^Is_Sc=lina}', "");
    Expect(0, 67431, '\P{Is_Sc=lina}', "");
    Expect(1, 67431, '\P{^Is_Sc=lina}', "");
    Expect(0, 67432, '\p{Is_Sc=lina}', "");
    Expect(1, 67432, '\p{^Is_Sc=lina}', "");
    Expect(1, 67432, '\P{Is_Sc=lina}', "");
    Expect(0, 67432, '\P{^Is_Sc=lina}', "");
    Expect(1, 67431, '\p{Is_Sc=	 Lina}', "");
    Expect(0, 67431, '\p{^Is_Sc=	 Lina}', "");
    Expect(0, 67431, '\P{Is_Sc=	 Lina}', "");
    Expect(1, 67431, '\P{^Is_Sc=	 Lina}', "");
    Expect(0, 67432, '\p{Is_Sc=	 Lina}', "");
    Expect(1, 67432, '\p{^Is_Sc=	 Lina}', "");
    Expect(1, 67432, '\P{Is_Sc=	 Lina}', "");
    Expect(0, 67432, '\P{^Is_Sc=	 Lina}', "");
    Error('\p{Script=-/a/linear_B}');
    Error('\P{Script=-/a/linear_B}');
    Expect(1, 65786, '\p{Script=:\ALinear_B\z:}', "");;
    Expect(0, 65787, '\p{Script=:\ALinear_B\z:}', "");;
    Expect(1, 65786, '\p{Script=linearb}', "");
    Expect(0, 65786, '\p{^Script=linearb}', "");
    Expect(0, 65786, '\P{Script=linearb}', "");
    Expect(1, 65786, '\P{^Script=linearb}', "");
    Expect(0, 65787, '\p{Script=linearb}', "");
    Expect(1, 65787, '\p{^Script=linearb}', "");
    Expect(1, 65787, '\P{Script=linearb}', "");
    Expect(0, 65787, '\P{^Script=linearb}', "");
    Expect(1, 65786, '\p{Script=:\Alinearb\z:}', "");;
    Expect(0, 65787, '\p{Script=:\Alinearb\z:}', "");;
    Expect(1, 65786, '\p{Script=	 Linear_B}', "");
    Expect(0, 65786, '\p{^Script=	 Linear_B}', "");
    Expect(0, 65786, '\P{Script=	 Linear_B}', "");
    Expect(1, 65786, '\P{^Script=	 Linear_B}', "");
    Expect(0, 65787, '\p{Script=	 Linear_B}', "");
    Expect(1, 65787, '\p{^Script=	 Linear_B}', "");
    Expect(1, 65787, '\P{Script=	 Linear_B}', "");
    Expect(0, 65787, '\P{^Script=	 Linear_B}', "");
    Error('\p{Sc=_	Linb:=}');
    Error('\P{Sc=_	Linb:=}');
    Expect(1, 65786, '\p{Sc=:\ALinb\z:}', "");;
    Expect(0, 65787, '\p{Sc=:\ALinb\z:}', "");;
    Expect(1, 65786, '\p{Sc=linb}', "");
    Expect(0, 65786, '\p{^Sc=linb}', "");
    Expect(0, 65786, '\P{Sc=linb}', "");
    Expect(1, 65786, '\P{^Sc=linb}', "");
    Expect(0, 65787, '\p{Sc=linb}', "");
    Expect(1, 65787, '\p{^Sc=linb}', "");
    Expect(1, 65787, '\P{Sc=linb}', "");
    Expect(0, 65787, '\P{^Sc=linb}', "");
    Expect(1, 65786, '\p{Sc=:\Alinb\z:}', "");;
    Expect(0, 65787, '\p{Sc=:\Alinb\z:}', "");;
    Expect(1, 65786, '\p{Sc:_LINB}', "");
    Expect(0, 65786, '\p{^Sc:_LINB}', "");
    Expect(0, 65786, '\P{Sc:_LINB}', "");
    Expect(1, 65786, '\P{^Sc:_LINB}', "");
    Expect(0, 65787, '\p{Sc:_LINB}', "");
    Expect(1, 65787, '\p{^Sc:_LINB}', "");
    Expect(1, 65787, '\P{Sc:_LINB}', "");
    Expect(0, 65787, '\P{^Sc:_LINB}', "");
    Error('\p{Is_Script=/a/LINEAR_B}');
    Error('\P{Is_Script=/a/LINEAR_B}');
    Expect(1, 65786, '\p{Is_Script=linearb}', "");
    Expect(0, 65786, '\p{^Is_Script=linearb}', "");
    Expect(0, 65786, '\P{Is_Script=linearb}', "");
    Expect(1, 65786, '\P{^Is_Script=linearb}', "");
    Expect(0, 65787, '\p{Is_Script=linearb}', "");
    Expect(1, 65787, '\p{^Is_Script=linearb}', "");
    Expect(1, 65787, '\P{Is_Script=linearb}', "");
    Expect(0, 65787, '\P{^Is_Script=linearb}', "");
    Expect(1, 65786, '\p{Is_Script=_	Linear_B}', "");
    Expect(0, 65786, '\p{^Is_Script=_	Linear_B}', "");
    Expect(0, 65786, '\P{Is_Script=_	Linear_B}', "");
    Expect(1, 65786, '\P{^Is_Script=_	Linear_B}', "");
    Expect(0, 65787, '\p{Is_Script=_	Linear_B}', "");
    Expect(1, 65787, '\p{^Is_Script=_	Linear_B}', "");
    Expect(1, 65787, '\P{Is_Script=_	Linear_B}', "");
    Expect(0, 65787, '\P{^Is_Script=_	Linear_B}', "");
    Error('\p{Is_Sc=	/a/linb}');
    Error('\P{Is_Sc=	/a/linb}');
    Expect(1, 65786, '\p{Is_Sc=linb}', "");
    Expect(0, 65786, '\p{^Is_Sc=linb}', "");
    Expect(0, 65786, '\P{Is_Sc=linb}', "");
    Expect(1, 65786, '\P{^Is_Sc=linb}', "");
    Expect(0, 65787, '\p{Is_Sc=linb}', "");
    Expect(1, 65787, '\p{^Is_Sc=linb}', "");
    Expect(1, 65787, '\P{Is_Sc=linb}', "");
    Expect(0, 65787, '\P{^Is_Sc=linb}', "");
    Expect(1, 65786, '\p{Is_Sc=	_linb}', "");
    Expect(0, 65786, '\p{^Is_Sc=	_linb}', "");
    Expect(0, 65786, '\P{Is_Sc=	_linb}', "");
    Expect(1, 65786, '\P{^Is_Sc=	_linb}', "");
    Expect(0, 65787, '\p{Is_Sc=	_linb}', "");
    Expect(1, 65787, '\p{^Is_Sc=	_linb}', "");
    Expect(1, 65787, '\P{Is_Sc=	_linb}', "");
    Expect(0, 65787, '\P{^Is_Sc=	_linb}', "");
    Error('\p{Script=- lisu:=}');
    Error('\P{Script=- lisu:=}');
    Expect(1, 73648, '\p{Script=:\ALisu\z:}', "");;
    Expect(0, 73649, '\p{Script=:\ALisu\z:}', "");;
    Expect(1, 73648, '\p{Script:   lisu}', "");
    Expect(0, 73648, '\p{^Script:   lisu}', "");
    Expect(0, 73648, '\P{Script:   lisu}', "");
    Expect(1, 73648, '\P{^Script:   lisu}', "");
    Expect(0, 73649, '\p{Script:   lisu}', "");
    Expect(1, 73649, '\p{^Script:   lisu}', "");
    Expect(1, 73649, '\P{Script:   lisu}', "");
    Expect(0, 73649, '\P{^Script:   lisu}', "");
    Expect(1, 73648, '\p{Script=:\Alisu\z:}', "");;
    Expect(0, 73649, '\p{Script=:\Alisu\z:}', "");;
    Expect(1, 73648, '\p{Script=	_Lisu}', "");
    Expect(0, 73648, '\p{^Script=	_Lisu}', "");
    Expect(0, 73648, '\P{Script=	_Lisu}', "");
    Expect(1, 73648, '\P{^Script=	_Lisu}', "");
    Expect(0, 73649, '\p{Script=	_Lisu}', "");
    Expect(1, 73649, '\p{^Script=	_Lisu}', "");
    Expect(1, 73649, '\P{Script=	_Lisu}', "");
    Expect(0, 73649, '\P{^Script=	_Lisu}', "");
    Error('\p{Sc=/a/ 	Lisu}');
    Error('\P{Sc=/a/ 	Lisu}');
    Expect(1, 73648, '\p{Sc=:\ALisu\z:}', "");;
    Expect(0, 73649, '\p{Sc=:\ALisu\z:}', "");;
    Expect(1, 73648, '\p{Sc=lisu}', "");
    Expect(0, 73648, '\p{^Sc=lisu}', "");
    Expect(0, 73648, '\P{Sc=lisu}', "");
    Expect(1, 73648, '\P{^Sc=lisu}', "");
    Expect(0, 73649, '\p{Sc=lisu}', "");
    Expect(1, 73649, '\p{^Sc=lisu}', "");
    Expect(1, 73649, '\P{Sc=lisu}', "");
    Expect(0, 73649, '\P{^Sc=lisu}', "");
    Expect(1, 73648, '\p{Sc=:\Alisu\z:}', "");;
    Expect(0, 73649, '\p{Sc=:\Alisu\z:}', "");;
    Expect(1, 73648, '\p{Sc=__Lisu}', "");
    Expect(0, 73648, '\p{^Sc=__Lisu}', "");
    Expect(0, 73648, '\P{Sc=__Lisu}', "");
    Expect(1, 73648, '\P{^Sc=__Lisu}', "");
    Expect(0, 73649, '\p{Sc=__Lisu}', "");
    Expect(1, 73649, '\p{^Sc=__Lisu}', "");
    Expect(1, 73649, '\P{Sc=__Lisu}', "");
    Expect(0, 73649, '\P{^Sc=__Lisu}', "");
    Error('\p{Is_Script=/a/		Lisu}');
    Error('\P{Is_Script=/a/		Lisu}');
    Expect(1, 73648, '\p{Is_Script=lisu}', "");
    Expect(0, 73648, '\p{^Is_Script=lisu}', "");
    Expect(0, 73648, '\P{Is_Script=lisu}', "");
    Expect(1, 73648, '\P{^Is_Script=lisu}', "");
    Expect(0, 73649, '\p{Is_Script=lisu}', "");
    Expect(1, 73649, '\p{^Is_Script=lisu}', "");
    Expect(1, 73649, '\P{Is_Script=lisu}', "");
    Expect(0, 73649, '\P{^Is_Script=lisu}', "");
    Expect(1, 73648, '\p{Is_Script= Lisu}', "");
    Expect(0, 73648, '\p{^Is_Script= Lisu}', "");
    Expect(0, 73648, '\P{Is_Script= Lisu}', "");
    Expect(1, 73648, '\P{^Is_Script= Lisu}', "");
    Expect(0, 73649, '\p{Is_Script= Lisu}', "");
    Expect(1, 73649, '\p{^Is_Script= Lisu}', "");
    Expect(1, 73649, '\P{Is_Script= Lisu}', "");
    Expect(0, 73649, '\P{^Is_Script= Lisu}', "");
    Error('\p{Is_Sc=_-lisu:=}');
    Error('\P{Is_Sc=_-lisu:=}');
    Expect(1, 73648, '\p{Is_Sc=lisu}', "");
    Expect(0, 73648, '\p{^Is_Sc=lisu}', "");
    Expect(0, 73648, '\P{Is_Sc=lisu}', "");
    Expect(1, 73648, '\P{^Is_Sc=lisu}', "");
    Expect(0, 73649, '\p{Is_Sc=lisu}', "");
    Expect(1, 73649, '\p{^Is_Sc=lisu}', "");
    Expect(1, 73649, '\P{Is_Sc=lisu}', "");
    Expect(0, 73649, '\P{^Is_Sc=lisu}', "");
    Expect(1, 73648, '\p{Is_Sc=__lisu}', "");
    Expect(0, 73648, '\p{^Is_Sc=__lisu}', "");
    Expect(0, 73648, '\P{Is_Sc=__lisu}', "");
    Expect(1, 73648, '\P{^Is_Sc=__lisu}', "");
    Expect(0, 73649, '\p{Is_Sc=__lisu}', "");
    Expect(1, 73649, '\p{^Is_Sc=__lisu}', "");
    Expect(1, 73649, '\P{Is_Sc=__lisu}', "");
    Expect(0, 73649, '\P{^Is_Sc=__lisu}', "");
    Error('\p{Script=:=lycian}');
    Error('\P{Script=:=lycian}');
    Expect(1, 66204, '\p{Script=:\ALycian\z:}', "");;
    Expect(0, 66205, '\p{Script=:\ALycian\z:}', "");;
    Expect(1, 66204, '\p{Script=lycian}', "");
    Expect(0, 66204, '\p{^Script=lycian}', "");
    Expect(0, 66204, '\P{Script=lycian}', "");
    Expect(1, 66204, '\P{^Script=lycian}', "");
    Expect(0, 66205, '\p{Script=lycian}', "");
    Expect(1, 66205, '\p{^Script=lycian}', "");
    Expect(1, 66205, '\P{Script=lycian}', "");
    Expect(0, 66205, '\P{^Script=lycian}', "");
    Expect(1, 66204, '\p{Script=:\Alycian\z:}', "");;
    Expect(0, 66205, '\p{Script=:\Alycian\z:}', "");;
    Expect(1, 66204, '\p{Script:	Lycian}', "");
    Expect(0, 66204, '\p{^Script:	Lycian}', "");
    Expect(0, 66204, '\P{Script:	Lycian}', "");
    Expect(1, 66204, '\P{^Script:	Lycian}', "");
    Expect(0, 66205, '\p{Script:	Lycian}', "");
    Expect(1, 66205, '\p{^Script:	Lycian}', "");
    Expect(1, 66205, '\P{Script:	Lycian}', "");
    Expect(0, 66205, '\P{^Script:	Lycian}', "");
    Error('\p{Sc=:=	 lyci}');
    Error('\P{Sc=:=	 lyci}');
    Expect(1, 66204, '\p{Sc=:\ALyci\z:}', "");;
    Expect(0, 66205, '\p{Sc=:\ALyci\z:}', "");;
    Expect(1, 66204, '\p{Sc=lyci}', "");
    Expect(0, 66204, '\p{^Sc=lyci}', "");
    Expect(0, 66204, '\P{Sc=lyci}', "");
    Expect(1, 66204, '\P{^Sc=lyci}', "");
    Expect(0, 66205, '\p{Sc=lyci}', "");
    Expect(1, 66205, '\p{^Sc=lyci}', "");
    Expect(1, 66205, '\P{Sc=lyci}', "");
    Expect(0, 66205, '\P{^Sc=lyci}', "");
    Expect(1, 66204, '\p{Sc=:\Alyci\z:}', "");;
    Expect(0, 66205, '\p{Sc=:\Alyci\z:}', "");;
    Expect(1, 66204, '\p{Sc=-Lyci}', "");
    Expect(0, 66204, '\p{^Sc=-Lyci}', "");
    Expect(0, 66204, '\P{Sc=-Lyci}', "");
    Expect(1, 66204, '\P{^Sc=-Lyci}', "");
    Expect(0, 66205, '\p{Sc=-Lyci}', "");
    Expect(1, 66205, '\p{^Sc=-Lyci}', "");
    Expect(1, 66205, '\P{Sc=-Lyci}', "");
    Expect(0, 66205, '\P{^Sc=-Lyci}', "");
    Error('\p{Is_Script=-:=Lycian}');
    Error('\P{Is_Script=-:=Lycian}');
    Expect(1, 66204, '\p{Is_Script:	lycian}', "");
    Expect(0, 66204, '\p{^Is_Script:	lycian}', "");
    Expect(0, 66204, '\P{Is_Script:	lycian}', "");
    Expect(1, 66204, '\P{^Is_Script:	lycian}', "");
    Expect(0, 66205, '\p{Is_Script:	lycian}', "");
    Expect(1, 66205, '\p{^Is_Script:	lycian}', "");
    Expect(1, 66205, '\P{Is_Script:	lycian}', "");
    Expect(0, 66205, '\P{^Is_Script:	lycian}', "");
    Expect(1, 66204, '\p{Is_Script: Lycian}', "");
    Expect(0, 66204, '\p{^Is_Script: Lycian}', "");
    Expect(0, 66204, '\P{Is_Script: Lycian}', "");
    Expect(1, 66204, '\P{^Is_Script: Lycian}', "");
    Expect(0, 66205, '\p{Is_Script: Lycian}', "");
    Expect(1, 66205, '\p{^Is_Script: Lycian}', "");
    Expect(1, 66205, '\P{Is_Script: Lycian}', "");
    Expect(0, 66205, '\P{^Is_Script: Lycian}', "");
    Error('\p{Is_Sc=- Lyci:=}');
    Error('\P{Is_Sc=- Lyci:=}');
    Expect(1, 66204, '\p{Is_Sc=lyci}', "");
    Expect(0, 66204, '\p{^Is_Sc=lyci}', "");
    Expect(0, 66204, '\P{Is_Sc=lyci}', "");
    Expect(1, 66204, '\P{^Is_Sc=lyci}', "");
    Expect(0, 66205, '\p{Is_Sc=lyci}', "");
    Expect(1, 66205, '\p{^Is_Sc=lyci}', "");
    Expect(1, 66205, '\P{Is_Sc=lyci}', "");
    Expect(0, 66205, '\P{^Is_Sc=lyci}', "");
    Expect(1, 66204, '\p{Is_Sc=__LYCI}', "");
    Expect(0, 66204, '\p{^Is_Sc=__LYCI}', "");
    Expect(0, 66204, '\P{Is_Sc=__LYCI}', "");
    Expect(1, 66204, '\P{^Is_Sc=__LYCI}', "");
    Expect(0, 66205, '\p{Is_Sc=__LYCI}', "");
    Expect(1, 66205, '\p{^Is_Sc=__LYCI}', "");
    Expect(1, 66205, '\P{Is_Sc=__LYCI}', "");
    Expect(0, 66205, '\P{^Is_Sc=__LYCI}', "");
    Error('\p{Script=	_lydian/a/}');
    Error('\P{Script=	_lydian/a/}');
    Expect(1, 67903, '\p{Script=:\ALydian\z:}', "");;
    Expect(0, 67904, '\p{Script=:\ALydian\z:}', "");;
    Expect(1, 67903, '\p{Script:   lydian}', "");
    Expect(0, 67903, '\p{^Script:   lydian}', "");
    Expect(0, 67903, '\P{Script:   lydian}', "");
    Expect(1, 67903, '\P{^Script:   lydian}', "");
    Expect(0, 67904, '\p{Script:   lydian}', "");
    Expect(1, 67904, '\p{^Script:   lydian}', "");
    Expect(1, 67904, '\P{Script:   lydian}', "");
    Expect(0, 67904, '\P{^Script:   lydian}', "");
    Expect(1, 67903, '\p{Script=:\Alydian\z:}', "");;
    Expect(0, 67904, '\p{Script=:\Alydian\z:}', "");;
    Expect(1, 67903, '\p{Script: --lydian}', "");
    Expect(0, 67903, '\p{^Script: --lydian}', "");
    Expect(0, 67903, '\P{Script: --lydian}', "");
    Expect(1, 67903, '\P{^Script: --lydian}', "");
    Expect(0, 67904, '\p{Script: --lydian}', "");
    Expect(1, 67904, '\p{^Script: --lydian}', "");
    Expect(1, 67904, '\P{Script: --lydian}', "");
    Expect(0, 67904, '\P{^Script: --lydian}', "");
    Error('\p{Sc=	 Lydi:=}');
    Error('\P{Sc=	 Lydi:=}');
    Expect(1, 67903, '\p{Sc=:\ALydi\z:}', "");;
    Expect(0, 67904, '\p{Sc=:\ALydi\z:}', "");;
    Expect(1, 67903, '\p{Sc=lydi}', "");
    Expect(0, 67903, '\p{^Sc=lydi}', "");
    Expect(0, 67903, '\P{Sc=lydi}', "");
    Expect(1, 67903, '\P{^Sc=lydi}', "");
    Expect(0, 67904, '\p{Sc=lydi}', "");
    Expect(1, 67904, '\p{^Sc=lydi}', "");
    Expect(1, 67904, '\P{Sc=lydi}', "");
    Expect(0, 67904, '\P{^Sc=lydi}', "");
    Expect(1, 67903, '\p{Sc=:\Alydi\z:}', "");;
    Expect(0, 67904, '\p{Sc=:\Alydi\z:}', "");;
    Expect(1, 67903, '\p{Sc= -Lydi}', "");
    Expect(0, 67903, '\p{^Sc= -Lydi}', "");
    Expect(0, 67903, '\P{Sc= -Lydi}', "");
    Expect(1, 67903, '\P{^Sc= -Lydi}', "");
    Expect(0, 67904, '\p{Sc= -Lydi}', "");
    Expect(1, 67904, '\p{^Sc= -Lydi}', "");
    Expect(1, 67904, '\P{Sc= -Lydi}', "");
    Expect(0, 67904, '\P{^Sc= -Lydi}', "");
    Error('\p{Is_Script=/a/LYDIAN}');
    Error('\P{Is_Script=/a/LYDIAN}');
    Expect(1, 67903, '\p{Is_Script:lydian}', "");
    Expect(0, 67903, '\p{^Is_Script:lydian}', "");
    Expect(0, 67903, '\P{Is_Script:lydian}', "");
    Expect(1, 67903, '\P{^Is_Script:lydian}', "");
    Expect(0, 67904, '\p{Is_Script:lydian}', "");
    Expect(1, 67904, '\p{^Is_Script:lydian}', "");
    Expect(1, 67904, '\P{Is_Script:lydian}', "");
    Expect(0, 67904, '\P{^Is_Script:lydian}', "");
    Expect(1, 67903, '\p{Is_Script= lydian}', "");
    Expect(0, 67903, '\p{^Is_Script= lydian}', "");
    Expect(0, 67903, '\P{Is_Script= lydian}', "");
    Expect(1, 67903, '\P{^Is_Script= lydian}', "");
    Expect(0, 67904, '\p{Is_Script= lydian}', "");
    Expect(1, 67904, '\p{^Is_Script= lydian}', "");
    Expect(1, 67904, '\P{Is_Script= lydian}', "");
    Expect(0, 67904, '\P{^Is_Script= lydian}', "");
    Error('\p{Is_Sc=:=_LYDI}');
    Error('\P{Is_Sc=:=_LYDI}');
    Expect(1, 67903, '\p{Is_Sc:   lydi}', "");
    Expect(0, 67903, '\p{^Is_Sc:   lydi}', "");
    Expect(0, 67903, '\P{Is_Sc:   lydi}', "");
    Expect(1, 67903, '\P{^Is_Sc:   lydi}', "");
    Expect(0, 67904, '\p{Is_Sc:   lydi}', "");
    Expect(1, 67904, '\p{^Is_Sc:   lydi}', "");
    Expect(1, 67904, '\P{Is_Sc:   lydi}', "");
    Expect(0, 67904, '\P{^Is_Sc:   lydi}', "");
    Expect(1, 67903, '\p{Is_Sc:_Lydi}', "");
    Expect(0, 67903, '\p{^Is_Sc:_Lydi}', "");
    Expect(0, 67903, '\P{Is_Sc:_Lydi}', "");
    Expect(1, 67903, '\P{^Is_Sc:_Lydi}', "");
    Expect(0, 67904, '\p{Is_Sc:_Lydi}', "");
    Expect(1, 67904, '\p{^Is_Sc:_Lydi}', "");
    Expect(1, 67904, '\P{Is_Sc:_Lydi}', "");
    Expect(0, 67904, '\P{^Is_Sc:_Lydi}', "");
    Error('\p{Script=:=_-MAHAJANI}');
    Error('\P{Script=:=_-MAHAJANI}');
    Expect(1, 70006, '\p{Script=:\AMahajani\z:}', "");;
    Expect(0, 70007, '\p{Script=:\AMahajani\z:}', "");;
    Expect(1, 70006, '\p{Script=mahajani}', "");
    Expect(0, 70006, '\p{^Script=mahajani}', "");
    Expect(0, 70006, '\P{Script=mahajani}', "");
    Expect(1, 70006, '\P{^Script=mahajani}', "");
    Expect(0, 70007, '\p{Script=mahajani}', "");
    Expect(1, 70007, '\p{^Script=mahajani}', "");
    Expect(1, 70007, '\P{Script=mahajani}', "");
    Expect(0, 70007, '\P{^Script=mahajani}', "");
    Expect(1, 70006, '\p{Script=:\Amahajani\z:}', "");;
    Expect(0, 70007, '\p{Script=:\Amahajani\z:}', "");;
    Expect(1, 70006, '\p{Script=- MAHAJANI}', "");
    Expect(0, 70006, '\p{^Script=- MAHAJANI}', "");
    Expect(0, 70006, '\P{Script=- MAHAJANI}', "");
    Expect(1, 70006, '\P{^Script=- MAHAJANI}', "");
    Expect(0, 70007, '\p{Script=- MAHAJANI}', "");
    Expect(1, 70007, '\p{^Script=- MAHAJANI}', "");
    Expect(1, 70007, '\P{Script=- MAHAJANI}', "");
    Expect(0, 70007, '\P{^Script=- MAHAJANI}', "");
    Error('\p{Sc=_/a/Mahj}');
    Error('\P{Sc=_/a/Mahj}');
    Expect(1, 70006, '\p{Sc=:\AMahj\z:}', "");;
    Expect(0, 70007, '\p{Sc=:\AMahj\z:}', "");;
    Expect(1, 70006, '\p{Sc=mahj}', "");
    Expect(0, 70006, '\p{^Sc=mahj}', "");
    Expect(0, 70006, '\P{Sc=mahj}', "");
    Expect(1, 70006, '\P{^Sc=mahj}', "");
    Expect(0, 70007, '\p{Sc=mahj}', "");
    Expect(1, 70007, '\p{^Sc=mahj}', "");
    Expect(1, 70007, '\P{Sc=mahj}', "");
    Expect(0, 70007, '\P{^Sc=mahj}', "");
    Expect(1, 70006, '\p{Sc=:\Amahj\z:}', "");;
    Expect(0, 70007, '\p{Sc=:\Amahj\z:}', "");;
    Expect(1, 70006, '\p{Sc=-mahj}', "");
    Expect(0, 70006, '\p{^Sc=-mahj}', "");
    Expect(0, 70006, '\P{Sc=-mahj}', "");
    Expect(1, 70006, '\P{^Sc=-mahj}', "");
    Expect(0, 70007, '\p{Sc=-mahj}', "");
    Expect(1, 70007, '\p{^Sc=-mahj}', "");
    Expect(1, 70007, '\P{Sc=-mahj}', "");
    Expect(0, 70007, '\P{^Sc=-mahj}', "");
    Error('\p{Is_Script=/a/	MAHAJANI}');
    Error('\P{Is_Script=/a/	MAHAJANI}');
    Expect(1, 70006, '\p{Is_Script=mahajani}', "");
    Expect(0, 70006, '\p{^Is_Script=mahajani}', "");
    Expect(0, 70006, '\P{Is_Script=mahajani}', "");
    Expect(1, 70006, '\P{^Is_Script=mahajani}', "");
    Expect(0, 70007, '\p{Is_Script=mahajani}', "");
    Expect(1, 70007, '\p{^Is_Script=mahajani}', "");
    Expect(1, 70007, '\P{Is_Script=mahajani}', "");
    Expect(0, 70007, '\P{^Is_Script=mahajani}', "");
    Expect(1, 70006, '\p{Is_Script=- Mahajani}', "");
    Expect(0, 70006, '\p{^Is_Script=- Mahajani}', "");
    Expect(0, 70006, '\P{Is_Script=- Mahajani}', "");
    Expect(1, 70006, '\P{^Is_Script=- Mahajani}', "");
    Expect(0, 70007, '\p{Is_Script=- Mahajani}', "");
    Expect(1, 70007, '\p{^Is_Script=- Mahajani}', "");
    Expect(1, 70007, '\P{Is_Script=- Mahajani}', "");
    Expect(0, 70007, '\P{^Is_Script=- Mahajani}', "");
    Error('\p{Is_Sc=/a/  mahj}');
    Error('\P{Is_Sc=/a/  mahj}');
    Expect(1, 70006, '\p{Is_Sc=mahj}', "");
    Expect(0, 70006, '\p{^Is_Sc=mahj}', "");
    Expect(0, 70006, '\P{Is_Sc=mahj}', "");
    Expect(1, 70006, '\P{^Is_Sc=mahj}', "");
    Expect(0, 70007, '\p{Is_Sc=mahj}', "");
    Expect(1, 70007, '\p{^Is_Sc=mahj}', "");
    Expect(1, 70007, '\P{Is_Sc=mahj}', "");
    Expect(0, 70007, '\P{^Is_Sc=mahj}', "");
    Expect(1, 70006, '\p{Is_Sc=	MAHJ}', "");
    Expect(0, 70006, '\p{^Is_Sc=	MAHJ}', "");
    Expect(0, 70006, '\P{Is_Sc=	MAHJ}', "");
    Expect(1, 70006, '\P{^Is_Sc=	MAHJ}', "");
    Expect(0, 70007, '\p{Is_Sc=	MAHJ}', "");
    Expect(1, 70007, '\p{^Is_Sc=	MAHJ}', "");
    Expect(1, 70007, '\P{Is_Sc=	MAHJ}', "");
    Expect(0, 70007, '\P{^Is_Sc=	MAHJ}', "");
    Error('\p{Script=:=Makasar}');
    Error('\P{Script=:=Makasar}');
    Expect(1, 73464, '\p{Script=:\AMakasar\z:}', "");;
    Expect(0, 73465, '\p{Script=:\AMakasar\z:}', "");;
    Expect(1, 73464, '\p{Script=makasar}', "");
    Expect(0, 73464, '\p{^Script=makasar}', "");
    Expect(0, 73464, '\P{Script=makasar}', "");
    Expect(1, 73464, '\P{^Script=makasar}', "");
    Expect(0, 73465, '\p{Script=makasar}', "");
    Expect(1, 73465, '\p{^Script=makasar}', "");
    Expect(1, 73465, '\P{Script=makasar}', "");
    Expect(0, 73465, '\P{^Script=makasar}', "");
    Expect(1, 73464, '\p{Script=:\Amakasar\z:}', "");;
    Expect(0, 73465, '\p{Script=:\Amakasar\z:}', "");;
    Expect(1, 73464, '\p{Script=_	makasar}', "");
    Expect(0, 73464, '\p{^Script=_	makasar}', "");
    Expect(0, 73464, '\P{Script=_	makasar}', "");
    Expect(1, 73464, '\P{^Script=_	makasar}', "");
    Expect(0, 73465, '\p{Script=_	makasar}', "");
    Expect(1, 73465, '\p{^Script=_	makasar}', "");
    Expect(1, 73465, '\P{Script=_	makasar}', "");
    Expect(0, 73465, '\P{^Script=_	makasar}', "");
    Error('\p{Sc=:=		MAKA}');
    Error('\P{Sc=:=		MAKA}');
    Expect(1, 73464, '\p{Sc=:\AMaka\z:}', "");;
    Expect(0, 73465, '\p{Sc=:\AMaka\z:}', "");;
    Expect(1, 73464, '\p{Sc=maka}', "");
    Expect(0, 73464, '\p{^Sc=maka}', "");
    Expect(0, 73464, '\P{Sc=maka}', "");
    Expect(1, 73464, '\P{^Sc=maka}', "");
    Expect(0, 73465, '\p{Sc=maka}', "");
    Expect(1, 73465, '\p{^Sc=maka}', "");
    Expect(1, 73465, '\P{Sc=maka}', "");
    Expect(0, 73465, '\P{^Sc=maka}', "");
    Expect(1, 73464, '\p{Sc=:\Amaka\z:}', "");;
    Expect(0, 73465, '\p{Sc=:\Amaka\z:}', "");;
    Expect(1, 73464, '\p{Sc=-	MAKA}', "");
    Expect(0, 73464, '\p{^Sc=-	MAKA}', "");
    Expect(0, 73464, '\P{Sc=-	MAKA}', "");
    Expect(1, 73464, '\P{^Sc=-	MAKA}', "");
    Expect(0, 73465, '\p{Sc=-	MAKA}', "");
    Expect(1, 73465, '\p{^Sc=-	MAKA}', "");
    Expect(1, 73465, '\P{Sc=-	MAKA}', "");
    Expect(0, 73465, '\P{^Sc=-	MAKA}', "");
    Error('\p{Is_Script=	Makasar/a/}');
    Error('\P{Is_Script=	Makasar/a/}');
    Expect(1, 73464, '\p{Is_Script=makasar}', "");
    Expect(0, 73464, '\p{^Is_Script=makasar}', "");
    Expect(0, 73464, '\P{Is_Script=makasar}', "");
    Expect(1, 73464, '\P{^Is_Script=makasar}', "");
    Expect(0, 73465, '\p{Is_Script=makasar}', "");
    Expect(1, 73465, '\p{^Is_Script=makasar}', "");
    Expect(1, 73465, '\P{Is_Script=makasar}', "");
    Expect(0, 73465, '\P{^Is_Script=makasar}', "");
    Expect(1, 73464, '\p{Is_Script=-Makasar}', "");
    Expect(0, 73464, '\p{^Is_Script=-Makasar}', "");
    Expect(0, 73464, '\P{Is_Script=-Makasar}', "");
    Expect(1, 73464, '\P{^Is_Script=-Makasar}', "");
    Expect(0, 73465, '\p{Is_Script=-Makasar}', "");
    Expect(1, 73465, '\p{^Is_Script=-Makasar}', "");
    Expect(1, 73465, '\P{Is_Script=-Makasar}', "");
    Expect(0, 73465, '\P{^Is_Script=-Makasar}', "");
    Error('\p{Is_Sc=-:=Maka}');
    Error('\P{Is_Sc=-:=Maka}');
    Expect(1, 73464, '\p{Is_Sc=maka}', "");
    Expect(0, 73464, '\p{^Is_Sc=maka}', "");
    Expect(0, 73464, '\P{Is_Sc=maka}', "");
    Expect(1, 73464, '\P{^Is_Sc=maka}', "");
    Expect(0, 73465, '\p{Is_Sc=maka}', "");
    Expect(1, 73465, '\p{^Is_Sc=maka}', "");
    Expect(1, 73465, '\P{Is_Sc=maka}', "");
    Expect(0, 73465, '\P{^Is_Sc=maka}', "");
    Expect(1, 73464, '\p{Is_Sc= -Maka}', "");
    Expect(0, 73464, '\p{^Is_Sc= -Maka}', "");
    Expect(0, 73464, '\P{Is_Sc= -Maka}', "");
    Expect(1, 73464, '\P{^Is_Sc= -Maka}', "");
    Expect(0, 73465, '\p{Is_Sc= -Maka}', "");
    Expect(1, 73465, '\p{^Is_Sc= -Maka}', "");
    Expect(1, 73465, '\P{Is_Sc= -Maka}', "");
    Expect(0, 73465, '\P{^Is_Sc= -Maka}', "");
    Error('\p{Script=	:=mandaic}');
    Error('\P{Script=	:=mandaic}');
    Expect(1, 2142, '\p{Script=:\AMandaic\z:}', "");;
    Expect(0, 2143, '\p{Script=:\AMandaic\z:}', "");;
    Expect(1, 2142, '\p{Script=mandaic}', "");
    Expect(0, 2142, '\p{^Script=mandaic}', "");
    Expect(0, 2142, '\P{Script=mandaic}', "");
    Expect(1, 2142, '\P{^Script=mandaic}', "");
    Expect(0, 2143, '\p{Script=mandaic}', "");
    Expect(1, 2143, '\p{^Script=mandaic}', "");
    Expect(1, 2143, '\P{Script=mandaic}', "");
    Expect(0, 2143, '\P{^Script=mandaic}', "");
    Expect(1, 2142, '\p{Script=:\Amandaic\z:}', "");;
    Expect(0, 2143, '\p{Script=:\Amandaic\z:}', "");;
    Expect(1, 2142, '\p{Script=--Mandaic}', "");
    Expect(0, 2142, '\p{^Script=--Mandaic}', "");
    Expect(0, 2142, '\P{Script=--Mandaic}', "");
    Expect(1, 2142, '\P{^Script=--Mandaic}', "");
    Expect(0, 2143, '\p{Script=--Mandaic}', "");
    Expect(1, 2143, '\p{^Script=--Mandaic}', "");
    Expect(1, 2143, '\P{Script=--Mandaic}', "");
    Expect(0, 2143, '\P{^Script=--Mandaic}', "");
    Error('\p{Sc=	_Mand:=}');
    Error('\P{Sc=	_Mand:=}');
    Expect(1, 2142, '\p{Sc=:\AMand\z:}', "");;
    Expect(0, 2143, '\p{Sc=:\AMand\z:}', "");;
    Expect(1, 2142, '\p{Sc=mand}', "");
    Expect(0, 2142, '\p{^Sc=mand}', "");
    Expect(0, 2142, '\P{Sc=mand}', "");
    Expect(1, 2142, '\P{^Sc=mand}', "");
    Expect(0, 2143, '\p{Sc=mand}', "");
    Expect(1, 2143, '\p{^Sc=mand}', "");
    Expect(1, 2143, '\P{Sc=mand}', "");
    Expect(0, 2143, '\P{^Sc=mand}', "");
    Expect(1, 2142, '\p{Sc=:\Amand\z:}', "");;
    Expect(0, 2143, '\p{Sc=:\Amand\z:}', "");;
    Expect(1, 2142, '\p{Sc=__mand}', "");
    Expect(0, 2142, '\p{^Sc=__mand}', "");
    Expect(0, 2142, '\P{Sc=__mand}', "");
    Expect(1, 2142, '\P{^Sc=__mand}', "");
    Expect(0, 2143, '\p{Sc=__mand}', "");
    Expect(1, 2143, '\p{^Sc=__mand}', "");
    Expect(1, 2143, '\P{Sc=__mand}', "");
    Expect(0, 2143, '\P{^Sc=__mand}', "");
    Error('\p{Is_Script=-	MANDAIC:=}');
    Error('\P{Is_Script=-	MANDAIC:=}');
    Expect(1, 2142, '\p{Is_Script=mandaic}', "");
    Expect(0, 2142, '\p{^Is_Script=mandaic}', "");
    Expect(0, 2142, '\P{Is_Script=mandaic}', "");
    Expect(1, 2142, '\P{^Is_Script=mandaic}', "");
    Expect(0, 2143, '\p{Is_Script=mandaic}', "");
    Expect(1, 2143, '\p{^Is_Script=mandaic}', "");
    Expect(1, 2143, '\P{Is_Script=mandaic}', "");
    Expect(0, 2143, '\P{^Is_Script=mandaic}', "");
    Expect(1, 2142, '\p{Is_Script=  Mandaic}', "");
    Expect(0, 2142, '\p{^Is_Script=  Mandaic}', "");
    Expect(0, 2142, '\P{Is_Script=  Mandaic}', "");
    Expect(1, 2142, '\P{^Is_Script=  Mandaic}', "");
    Expect(0, 2143, '\p{Is_Script=  Mandaic}', "");
    Expect(1, 2143, '\p{^Is_Script=  Mandaic}', "");
    Expect(1, 2143, '\P{Is_Script=  Mandaic}', "");
    Expect(0, 2143, '\P{^Is_Script=  Mandaic}', "");
    Error('\p{Is_Sc=:=	 Mand}');
    Error('\P{Is_Sc=:=	 Mand}');
    Expect(1, 2142, '\p{Is_Sc=mand}', "");
    Expect(0, 2142, '\p{^Is_Sc=mand}', "");
    Expect(0, 2142, '\P{Is_Sc=mand}', "");
    Expect(1, 2142, '\P{^Is_Sc=mand}', "");
    Expect(0, 2143, '\p{Is_Sc=mand}', "");
    Expect(1, 2143, '\p{^Is_Sc=mand}', "");
    Expect(1, 2143, '\P{Is_Sc=mand}', "");
    Expect(0, 2143, '\P{^Is_Sc=mand}', "");
    Expect(1, 2142, '\p{Is_Sc= _MAND}', "");
    Expect(0, 2142, '\p{^Is_Sc= _MAND}', "");
    Expect(0, 2142, '\P{Is_Sc= _MAND}', "");
    Expect(1, 2142, '\P{^Is_Sc= _MAND}', "");
    Expect(0, 2143, '\p{Is_Sc= _MAND}', "");
    Expect(1, 2143, '\p{^Is_Sc= _MAND}', "");
    Expect(1, 2143, '\P{Is_Sc= _MAND}', "");
    Expect(0, 2143, '\P{^Is_Sc= _MAND}', "");
    Error('\p{Script= -Manichaean:=}');
    Error('\P{Script= -Manichaean:=}');
    Expect(1, 68342, '\p{Script=:\AManichaean\z:}', "");;
    Expect(0, 68343, '\p{Script=:\AManichaean\z:}', "");;
    Expect(1, 68342, '\p{Script=manichaean}', "");
    Expect(0, 68342, '\p{^Script=manichaean}', "");
    Expect(0, 68342, '\P{Script=manichaean}', "");
    Expect(1, 68342, '\P{^Script=manichaean}', "");
    Expect(0, 68343, '\p{Script=manichaean}', "");
    Expect(1, 68343, '\p{^Script=manichaean}', "");
    Expect(1, 68343, '\P{Script=manichaean}', "");
    Expect(0, 68343, '\P{^Script=manichaean}', "");
    Expect(1, 68342, '\p{Script=:\Amanichaean\z:}', "");;
    Expect(0, 68343, '\p{Script=:\Amanichaean\z:}', "");;
    Expect(1, 68342, '\p{Script= -Manichaean}', "");
    Expect(0, 68342, '\p{^Script= -Manichaean}', "");
    Expect(0, 68342, '\P{Script= -Manichaean}', "");
    Expect(1, 68342, '\P{^Script= -Manichaean}', "");
    Expect(0, 68343, '\p{Script= -Manichaean}', "");
    Expect(1, 68343, '\p{^Script= -Manichaean}', "");
    Expect(1, 68343, '\P{Script= -Manichaean}', "");
    Expect(0, 68343, '\P{^Script= -Manichaean}', "");
    Error('\p{Sc=	:=MANI}');
    Error('\P{Sc=	:=MANI}');
    Expect(1, 68342, '\p{Sc=:\AMani\z:}', "");;
    Expect(0, 68343, '\p{Sc=:\AMani\z:}', "");;
    Expect(1, 68342, '\p{Sc=mani}', "");
    Expect(0, 68342, '\p{^Sc=mani}', "");
    Expect(0, 68342, '\P{Sc=mani}', "");
    Expect(1, 68342, '\P{^Sc=mani}', "");
    Expect(0, 68343, '\p{Sc=mani}', "");
    Expect(1, 68343, '\p{^Sc=mani}', "");
    Expect(1, 68343, '\P{Sc=mani}', "");
    Expect(0, 68343, '\P{^Sc=mani}', "");
    Expect(1, 68342, '\p{Sc=:\Amani\z:}', "");;
    Expect(0, 68343, '\p{Sc=:\Amani\z:}', "");;
    Expect(1, 68342, '\p{Sc=		Mani}', "");
    Expect(0, 68342, '\p{^Sc=		Mani}', "");
    Expect(0, 68342, '\P{Sc=		Mani}', "");
    Expect(1, 68342, '\P{^Sc=		Mani}', "");
    Expect(0, 68343, '\p{Sc=		Mani}', "");
    Expect(1, 68343, '\p{^Sc=		Mani}', "");
    Expect(1, 68343, '\P{Sc=		Mani}', "");
    Expect(0, 68343, '\P{^Sc=		Mani}', "");
    Error('\p{Is_Script= Manichaean:=}');
    Error('\P{Is_Script= Manichaean:=}');
    Expect(1, 68342, '\p{Is_Script=manichaean}', "");
    Expect(0, 68342, '\p{^Is_Script=manichaean}', "");
    Expect(0, 68342, '\P{Is_Script=manichaean}', "");
    Expect(1, 68342, '\P{^Is_Script=manichaean}', "");
    Expect(0, 68343, '\p{Is_Script=manichaean}', "");
    Expect(1, 68343, '\p{^Is_Script=manichaean}', "");
    Expect(1, 68343, '\P{Is_Script=manichaean}', "");
    Expect(0, 68343, '\P{^Is_Script=manichaean}', "");
    Expect(1, 68342, '\p{Is_Script=_ manichaean}', "");
    Expect(0, 68342, '\p{^Is_Script=_ manichaean}', "");
    Expect(0, 68342, '\P{Is_Script=_ manichaean}', "");
    Expect(1, 68342, '\P{^Is_Script=_ manichaean}', "");
    Expect(0, 68343, '\p{Is_Script=_ manichaean}', "");
    Expect(1, 68343, '\p{^Is_Script=_ manichaean}', "");
    Expect(1, 68343, '\P{Is_Script=_ manichaean}', "");
    Expect(0, 68343, '\P{^Is_Script=_ manichaean}', "");
    Error('\p{Is_Sc=:=__Mani}');
    Error('\P{Is_Sc=:=__Mani}');
    Expect(1, 68342, '\p{Is_Sc=mani}', "");
    Expect(0, 68342, '\p{^Is_Sc=mani}', "");
    Expect(0, 68342, '\P{Is_Sc=mani}', "");
    Expect(1, 68342, '\P{^Is_Sc=mani}', "");
    Expect(0, 68343, '\p{Is_Sc=mani}', "");
    Expect(1, 68343, '\p{^Is_Sc=mani}', "");
    Expect(1, 68343, '\P{Is_Sc=mani}', "");
    Expect(0, 68343, '\P{^Is_Sc=mani}', "");
    Expect(1, 68342, '\p{Is_Sc=-	MANI}', "");
    Expect(0, 68342, '\p{^Is_Sc=-	MANI}', "");
    Expect(0, 68342, '\P{Is_Sc=-	MANI}', "");
    Expect(1, 68342, '\P{^Is_Sc=-	MANI}', "");
    Expect(0, 68343, '\p{Is_Sc=-	MANI}', "");
    Expect(1, 68343, '\p{^Is_Sc=-	MANI}', "");
    Expect(1, 68343, '\P{Is_Sc=-	MANI}', "");
    Expect(0, 68343, '\P{^Is_Sc=-	MANI}', "");
    Error('\p{Script:   -marchen/a/}');
    Error('\P{Script:   -marchen/a/}');
    Expect(1, 72886, '\p{Script=:\AMarchen\z:}', "");;
    Expect(0, 72887, '\p{Script=:\AMarchen\z:}', "");;
    Expect(1, 72886, '\p{Script=marchen}', "");
    Expect(0, 72886, '\p{^Script=marchen}', "");
    Expect(0, 72886, '\P{Script=marchen}', "");
    Expect(1, 72886, '\P{^Script=marchen}', "");
    Expect(0, 72887, '\p{Script=marchen}', "");
    Expect(1, 72887, '\p{^Script=marchen}', "");
    Expect(1, 72887, '\P{Script=marchen}', "");
    Expect(0, 72887, '\P{^Script=marchen}', "");
    Expect(1, 72886, '\p{Script=:\Amarchen\z:}', "");;
    Expect(0, 72887, '\p{Script=:\Amarchen\z:}', "");;
    Expect(1, 72886, '\p{Script=-	Marchen}', "");
    Expect(0, 72886, '\p{^Script=-	Marchen}', "");
    Expect(0, 72886, '\P{Script=-	Marchen}', "");
    Expect(1, 72886, '\P{^Script=-	Marchen}', "");
    Expect(0, 72887, '\p{Script=-	Marchen}', "");
    Expect(1, 72887, '\p{^Script=-	Marchen}', "");
    Expect(1, 72887, '\P{Script=-	Marchen}', "");
    Expect(0, 72887, '\P{^Script=-	Marchen}', "");
    Error('\p{Sc=:=_ Marc}');
    Error('\P{Sc=:=_ Marc}');
    Expect(1, 72886, '\p{Sc=:\AMarc\z:}', "");;
    Expect(0, 72887, '\p{Sc=:\AMarc\z:}', "");;
    Expect(1, 72886, '\p{Sc=marc}', "");
    Expect(0, 72886, '\p{^Sc=marc}', "");
    Expect(0, 72886, '\P{Sc=marc}', "");
    Expect(1, 72886, '\P{^Sc=marc}', "");
    Expect(0, 72887, '\p{Sc=marc}', "");
    Expect(1, 72887, '\p{^Sc=marc}', "");
    Expect(1, 72887, '\P{Sc=marc}', "");
    Expect(0, 72887, '\P{^Sc=marc}', "");
    Expect(1, 72886, '\p{Sc=:\Amarc\z:}', "");;
    Expect(0, 72887, '\p{Sc=:\Amarc\z:}', "");;
    Expect(1, 72886, '\p{Sc=	_Marc}', "");
    Expect(0, 72886, '\p{^Sc=	_Marc}', "");
    Expect(0, 72886, '\P{Sc=	_Marc}', "");
    Expect(1, 72886, '\P{^Sc=	_Marc}', "");
    Expect(0, 72887, '\p{Sc=	_Marc}', "");
    Expect(1, 72887, '\p{^Sc=	_Marc}', "");
    Expect(1, 72887, '\P{Sc=	_Marc}', "");
    Expect(0, 72887, '\P{^Sc=	_Marc}', "");
    Error('\p{Is_Script=-/a/Marchen}');
    Error('\P{Is_Script=-/a/Marchen}');
    Expect(1, 72886, '\p{Is_Script=marchen}', "");
    Expect(0, 72886, '\p{^Is_Script=marchen}', "");
    Expect(0, 72886, '\P{Is_Script=marchen}', "");
    Expect(1, 72886, '\P{^Is_Script=marchen}', "");
    Expect(0, 72887, '\p{Is_Script=marchen}', "");
    Expect(1, 72887, '\p{^Is_Script=marchen}', "");
    Expect(1, 72887, '\P{Is_Script=marchen}', "");
    Expect(0, 72887, '\P{^Is_Script=marchen}', "");
    Expect(1, 72886, '\p{Is_Script=__Marchen}', "");
    Expect(0, 72886, '\p{^Is_Script=__Marchen}', "");
    Expect(0, 72886, '\P{Is_Script=__Marchen}', "");
    Expect(1, 72886, '\P{^Is_Script=__Marchen}', "");
    Expect(0, 72887, '\p{Is_Script=__Marchen}', "");
    Expect(1, 72887, '\p{^Is_Script=__Marchen}', "");
    Expect(1, 72887, '\P{Is_Script=__Marchen}', "");
    Expect(0, 72887, '\P{^Is_Script=__Marchen}', "");
    Error('\p{Is_Sc= -Marc:=}');
    Error('\P{Is_Sc= -Marc:=}');
    Expect(1, 72886, '\p{Is_Sc=marc}', "");
    Expect(0, 72886, '\p{^Is_Sc=marc}', "");
    Expect(0, 72886, '\P{Is_Sc=marc}', "");
    Expect(1, 72886, '\P{^Is_Sc=marc}', "");
    Expect(0, 72887, '\p{Is_Sc=marc}', "");
    Expect(1, 72887, '\p{^Is_Sc=marc}', "");
    Expect(1, 72887, '\P{Is_Sc=marc}', "");
    Expect(0, 72887, '\P{^Is_Sc=marc}', "");
    Expect(1, 72886, '\p{Is_Sc:	- Marc}', "");
    Expect(0, 72886, '\p{^Is_Sc:	- Marc}', "");
    Expect(0, 72886, '\P{Is_Sc:	- Marc}', "");
    Expect(1, 72886, '\P{^Is_Sc:	- Marc}', "");
    Expect(0, 72887, '\p{Is_Sc:	- Marc}', "");
    Expect(1, 72887, '\p{^Is_Sc:	- Marc}', "");
    Expect(1, 72887, '\P{Is_Sc:	- Marc}', "");
    Expect(0, 72887, '\P{^Is_Sc:	- Marc}', "");
    Error('\p{Script:-:=medefaidrin}');
    Error('\P{Script:-:=medefaidrin}');
    Expect(1, 93850, '\p{Script=:\AMedefaidrin\z:}', "");;
    Expect(0, 93851, '\p{Script=:\AMedefaidrin\z:}', "");;
    Expect(1, 93850, '\p{Script=medefaidrin}', "");
    Expect(0, 93850, '\p{^Script=medefaidrin}', "");
    Expect(0, 93850, '\P{Script=medefaidrin}', "");
    Expect(1, 93850, '\P{^Script=medefaidrin}', "");
    Expect(0, 93851, '\p{Script=medefaidrin}', "");
    Expect(1, 93851, '\p{^Script=medefaidrin}', "");
    Expect(1, 93851, '\P{Script=medefaidrin}', "");
    Expect(0, 93851, '\P{^Script=medefaidrin}', "");
    Expect(1, 93850, '\p{Script=:\Amedefaidrin\z:}', "");;
    Expect(0, 93851, '\p{Script=:\Amedefaidrin\z:}', "");;
    Expect(1, 93850, '\p{Script=_ Medefaidrin}', "");
    Expect(0, 93850, '\p{^Script=_ Medefaidrin}', "");
    Expect(0, 93850, '\P{Script=_ Medefaidrin}', "");
    Expect(1, 93850, '\P{^Script=_ Medefaidrin}', "");
    Expect(0, 93851, '\p{Script=_ Medefaidrin}', "");
    Expect(1, 93851, '\p{^Script=_ Medefaidrin}', "");
    Expect(1, 93851, '\P{Script=_ Medefaidrin}', "");
    Expect(0, 93851, '\P{^Script=_ Medefaidrin}', "");
    Error('\p{Sc=--MEDF:=}');
    Error('\P{Sc=--MEDF:=}');
    Expect(1, 93850, '\p{Sc=:\AMedf\z:}', "");;
    Expect(0, 93851, '\p{Sc=:\AMedf\z:}', "");;
    Expect(1, 93850, '\p{Sc=medf}', "");
    Expect(0, 93850, '\p{^Sc=medf}', "");
    Expect(0, 93850, '\P{Sc=medf}', "");
    Expect(1, 93850, '\P{^Sc=medf}', "");
    Expect(0, 93851, '\p{Sc=medf}', "");
    Expect(1, 93851, '\p{^Sc=medf}', "");
    Expect(1, 93851, '\P{Sc=medf}', "");
    Expect(0, 93851, '\P{^Sc=medf}', "");
    Expect(1, 93850, '\p{Sc=:\Amedf\z:}', "");;
    Expect(0, 93851, '\p{Sc=:\Amedf\z:}', "");;
    Expect(1, 93850, '\p{Sc=_-MEDF}', "");
    Expect(0, 93850, '\p{^Sc=_-MEDF}', "");
    Expect(0, 93850, '\P{Sc=_-MEDF}', "");
    Expect(1, 93850, '\P{^Sc=_-MEDF}', "");
    Expect(0, 93851, '\p{Sc=_-MEDF}', "");
    Expect(1, 93851, '\p{^Sc=_-MEDF}', "");
    Expect(1, 93851, '\P{Sc=_-MEDF}', "");
    Expect(0, 93851, '\P{^Sc=_-MEDF}', "");
    Error('\p{Is_Script=-/a/medefaidrin}');
    Error('\P{Is_Script=-/a/medefaidrin}');
    Expect(1, 93850, '\p{Is_Script=medefaidrin}', "");
    Expect(0, 93850, '\p{^Is_Script=medefaidrin}', "");
    Expect(0, 93850, '\P{Is_Script=medefaidrin}', "");
    Expect(1, 93850, '\P{^Is_Script=medefaidrin}', "");
    Expect(0, 93851, '\p{Is_Script=medefaidrin}', "");
    Expect(1, 93851, '\p{^Is_Script=medefaidrin}', "");
    Expect(1, 93851, '\P{Is_Script=medefaidrin}', "");
    Expect(0, 93851, '\P{^Is_Script=medefaidrin}', "");
    Expect(1, 93850, '\p{Is_Script=-medefaidrin}', "");
    Expect(0, 93850, '\p{^Is_Script=-medefaidrin}', "");
    Expect(0, 93850, '\P{Is_Script=-medefaidrin}', "");
    Expect(1, 93850, '\P{^Is_Script=-medefaidrin}', "");
    Expect(0, 93851, '\p{Is_Script=-medefaidrin}', "");
    Expect(1, 93851, '\p{^Is_Script=-medefaidrin}', "");
    Expect(1, 93851, '\P{Is_Script=-medefaidrin}', "");
    Expect(0, 93851, '\P{^Is_Script=-medefaidrin}', "");
    Error('\p{Is_Sc=_-medf/a/}');
    Error('\P{Is_Sc=_-medf/a/}');
    Expect(1, 93850, '\p{Is_Sc=medf}', "");
    Expect(0, 93850, '\p{^Is_Sc=medf}', "");
    Expect(0, 93850, '\P{Is_Sc=medf}', "");
    Expect(1, 93850, '\P{^Is_Sc=medf}', "");
    Expect(0, 93851, '\p{Is_Sc=medf}', "");
    Expect(1, 93851, '\p{^Is_Sc=medf}', "");
    Expect(1, 93851, '\P{Is_Sc=medf}', "");
    Expect(0, 93851, '\P{^Is_Sc=medf}', "");
    Expect(1, 93850, '\p{Is_Sc=_Medf}', "");
    Expect(0, 93850, '\p{^Is_Sc=_Medf}', "");
    Expect(0, 93850, '\P{Is_Sc=_Medf}', "");
    Expect(1, 93850, '\P{^Is_Sc=_Medf}', "");
    Expect(0, 93851, '\p{Is_Sc=_Medf}', "");
    Expect(1, 93851, '\p{^Is_Sc=_Medf}', "");
    Expect(1, 93851, '\P{Is_Sc=_Medf}', "");
    Expect(0, 93851, '\P{^Is_Sc=_Medf}', "");
    Error('\p{Script=-/a/Mende_kikakui}');
    Error('\P{Script=-/a/Mende_kikakui}');
    Expect(1, 125142, '\p{Script=:\AMende_Kikakui\z:}', "");;
    Expect(0, 125143, '\p{Script=:\AMende_Kikakui\z:}', "");;
    Expect(1, 125142, '\p{Script=mendekikakui}', "");
    Expect(0, 125142, '\p{^Script=mendekikakui}', "");
    Expect(0, 125142, '\P{Script=mendekikakui}', "");
    Expect(1, 125142, '\P{^Script=mendekikakui}', "");
    Expect(0, 125143, '\p{Script=mendekikakui}', "");
    Expect(1, 125143, '\p{^Script=mendekikakui}', "");
    Expect(1, 125143, '\P{Script=mendekikakui}', "");
    Expect(0, 125143, '\P{^Script=mendekikakui}', "");
    Expect(1, 125142, '\p{Script=:\Amendekikakui\z:}', "");;
    Expect(0, 125143, '\p{Script=:\Amendekikakui\z:}', "");;
    Expect(1, 125142, '\p{Script=_	mende_Kikakui}', "");
    Expect(0, 125142, '\p{^Script=_	mende_Kikakui}', "");
    Expect(0, 125142, '\P{Script=_	mende_Kikakui}', "");
    Expect(1, 125142, '\P{^Script=_	mende_Kikakui}', "");
    Expect(0, 125143, '\p{Script=_	mende_Kikakui}', "");
    Expect(1, 125143, '\p{^Script=_	mende_Kikakui}', "");
    Expect(1, 125143, '\P{Script=_	mende_Kikakui}', "");
    Expect(0, 125143, '\P{^Script=_	mende_Kikakui}', "");
    Error('\p{Sc=/a/	 mend}');
    Error('\P{Sc=/a/	 mend}');
    Expect(1, 125142, '\p{Sc=:\AMend\z:}', "");;
    Expect(0, 125143, '\p{Sc=:\AMend\z:}', "");;
    Expect(1, 125142, '\p{Sc=mend}', "");
    Expect(0, 125142, '\p{^Sc=mend}', "");
    Expect(0, 125142, '\P{Sc=mend}', "");
    Expect(1, 125142, '\P{^Sc=mend}', "");
    Expect(0, 125143, '\p{Sc=mend}', "");
    Expect(1, 125143, '\p{^Sc=mend}', "");
    Expect(1, 125143, '\P{Sc=mend}', "");
    Expect(0, 125143, '\P{^Sc=mend}', "");
    Expect(1, 125142, '\p{Sc=:\Amend\z:}', "");;
    Expect(0, 125143, '\p{Sc=:\Amend\z:}', "");;
    Expect(1, 125142, '\p{Sc=-Mend}', "");
    Expect(0, 125142, '\p{^Sc=-Mend}', "");
    Expect(0, 125142, '\P{Sc=-Mend}', "");
    Expect(1, 125142, '\P{^Sc=-Mend}', "");
    Expect(0, 125143, '\p{Sc=-Mend}', "");
    Expect(1, 125143, '\p{^Sc=-Mend}', "");
    Expect(1, 125143, '\P{Sc=-Mend}', "");
    Expect(0, 125143, '\P{^Sc=-Mend}', "");
    Error('\p{Is_Script=-/a/MENDE_Kikakui}');
    Error('\P{Is_Script=-/a/MENDE_Kikakui}');
    Expect(1, 125142, '\p{Is_Script=mendekikakui}', "");
    Expect(0, 125142, '\p{^Is_Script=mendekikakui}', "");
    Expect(0, 125142, '\P{Is_Script=mendekikakui}', "");
    Expect(1, 125142, '\P{^Is_Script=mendekikakui}', "");
    Expect(0, 125143, '\p{Is_Script=mendekikakui}', "");
    Expect(1, 125143, '\p{^Is_Script=mendekikakui}', "");
    Expect(1, 125143, '\P{Is_Script=mendekikakui}', "");
    Expect(0, 125143, '\P{^Is_Script=mendekikakui}', "");
    Expect(1, 125142, '\p{Is_Script:    	Mende_KIKAKUI}', "");
    Expect(0, 125142, '\p{^Is_Script:    	Mende_KIKAKUI}', "");
    Expect(0, 125142, '\P{Is_Script:    	Mende_KIKAKUI}', "");
    Expect(1, 125142, '\P{^Is_Script:    	Mende_KIKAKUI}', "");
    Expect(0, 125143, '\p{Is_Script:    	Mende_KIKAKUI}', "");
    Expect(1, 125143, '\p{^Is_Script:    	Mende_KIKAKUI}', "");
    Expect(1, 125143, '\P{Is_Script:    	Mende_KIKAKUI}', "");
    Expect(0, 125143, '\P{^Is_Script:    	Mende_KIKAKUI}', "");
    Error('\p{Is_Sc=	_Mend/a/}');
    Error('\P{Is_Sc=	_Mend/a/}');
    Expect(1, 125142, '\p{Is_Sc=mend}', "");
    Expect(0, 125142, '\p{^Is_Sc=mend}', "");
    Expect(0, 125142, '\P{Is_Sc=mend}', "");
    Expect(1, 125142, '\P{^Is_Sc=mend}', "");
    Expect(0, 125143, '\p{Is_Sc=mend}', "");
    Expect(1, 125143, '\p{^Is_Sc=mend}', "");
    Expect(1, 125143, '\P{Is_Sc=mend}', "");
    Expect(0, 125143, '\P{^Is_Sc=mend}', "");
    Expect(1, 125142, '\p{Is_Sc= 	Mend}', "");
    Expect(0, 125142, '\p{^Is_Sc= 	Mend}', "");
    Expect(0, 125142, '\P{Is_Sc= 	Mend}', "");
    Expect(1, 125142, '\P{^Is_Sc= 	Mend}', "");
    Expect(0, 125143, '\p{Is_Sc= 	Mend}', "");
    Expect(1, 125143, '\p{^Is_Sc= 	Mend}', "");
    Expect(1, 125143, '\P{Is_Sc= 	Mend}', "");
    Expect(0, 125143, '\P{^Is_Sc= 	Mend}', "");
    Error('\p{Script=/a/ meroitic_Cursive}');
    Error('\P{Script=/a/ meroitic_Cursive}');
    Expect(1, 68095, '\p{Script=:\AMeroitic_Cursive\z:}', "");;
    Expect(0, 68096, '\p{Script=:\AMeroitic_Cursive\z:}', "");;
    Expect(1, 68095, '\p{Script=meroiticcursive}', "");
    Expect(0, 68095, '\p{^Script=meroiticcursive}', "");
    Expect(0, 68095, '\P{Script=meroiticcursive}', "");
    Expect(1, 68095, '\P{^Script=meroiticcursive}', "");
    Expect(0, 68096, '\p{Script=meroiticcursive}', "");
    Expect(1, 68096, '\p{^Script=meroiticcursive}', "");
    Expect(1, 68096, '\P{Script=meroiticcursive}', "");
    Expect(0, 68096, '\P{^Script=meroiticcursive}', "");
    Expect(1, 68095, '\p{Script=:\Ameroiticcursive\z:}', "");;
    Expect(0, 68096, '\p{Script=:\Ameroiticcursive\z:}', "");;
    Expect(1, 68095, '\p{Script= _Meroitic_cursive}', "");
    Expect(0, 68095, '\p{^Script= _Meroitic_cursive}', "");
    Expect(0, 68095, '\P{Script= _Meroitic_cursive}', "");
    Expect(1, 68095, '\P{^Script= _Meroitic_cursive}', "");
    Expect(0, 68096, '\p{Script= _Meroitic_cursive}', "");
    Expect(1, 68096, '\p{^Script= _Meroitic_cursive}', "");
    Expect(1, 68096, '\P{Script= _Meroitic_cursive}', "");
    Expect(0, 68096, '\P{^Script= _Meroitic_cursive}', "");
    Error('\p{Sc=	/a/Merc}');
    Error('\P{Sc=	/a/Merc}');
    Expect(1, 68095, '\p{Sc=:\AMerc\z:}', "");;
    Expect(0, 68096, '\p{Sc=:\AMerc\z:}', "");;
    Expect(1, 68095, '\p{Sc:merc}', "");
    Expect(0, 68095, '\p{^Sc:merc}', "");
    Expect(0, 68095, '\P{Sc:merc}', "");
    Expect(1, 68095, '\P{^Sc:merc}', "");
    Expect(0, 68096, '\p{Sc:merc}', "");
    Expect(1, 68096, '\p{^Sc:merc}', "");
    Expect(1, 68096, '\P{Sc:merc}', "");
    Expect(0, 68096, '\P{^Sc:merc}', "");
    Expect(1, 68095, '\p{Sc=:\Amerc\z:}', "");;
    Expect(0, 68096, '\p{Sc=:\Amerc\z:}', "");;
    Expect(1, 68095, '\p{Sc=--MERC}', "");
    Expect(0, 68095, '\p{^Sc=--MERC}', "");
    Expect(0, 68095, '\P{Sc=--MERC}', "");
    Expect(1, 68095, '\P{^Sc=--MERC}', "");
    Expect(0, 68096, '\p{Sc=--MERC}', "");
    Expect(1, 68096, '\p{^Sc=--MERC}', "");
    Expect(1, 68096, '\P{Sc=--MERC}', "");
    Expect(0, 68096, '\P{^Sc=--MERC}', "");
    Error('\p{Is_Script=:=	 Meroitic_Cursive}');
    Error('\P{Is_Script=:=	 Meroitic_Cursive}');
    Expect(1, 68095, '\p{Is_Script=meroiticcursive}', "");
    Expect(0, 68095, '\p{^Is_Script=meroiticcursive}', "");
    Expect(0, 68095, '\P{Is_Script=meroiticcursive}', "");
    Expect(1, 68095, '\P{^Is_Script=meroiticcursive}', "");
    Expect(0, 68096, '\p{Is_Script=meroiticcursive}', "");
    Expect(1, 68096, '\p{^Is_Script=meroiticcursive}', "");
    Expect(1, 68096, '\P{Is_Script=meroiticcursive}', "");
    Expect(0, 68096, '\P{^Is_Script=meroiticcursive}', "");
    Expect(1, 68095, '\p{Is_Script=-Meroitic_cursive}', "");
    Expect(0, 68095, '\p{^Is_Script=-Meroitic_cursive}', "");
    Expect(0, 68095, '\P{Is_Script=-Meroitic_cursive}', "");
    Expect(1, 68095, '\P{^Is_Script=-Meroitic_cursive}', "");
    Expect(0, 68096, '\p{Is_Script=-Meroitic_cursive}', "");
    Expect(1, 68096, '\p{^Is_Script=-Meroitic_cursive}', "");
    Expect(1, 68096, '\P{Is_Script=-Meroitic_cursive}', "");
    Expect(0, 68096, '\P{^Is_Script=-Meroitic_cursive}', "");
    Error('\p{Is_Sc=/a/	_Merc}');
    Error('\P{Is_Sc=/a/	_Merc}');
    Expect(1, 68095, '\p{Is_Sc: merc}', "");
    Expect(0, 68095, '\p{^Is_Sc: merc}', "");
    Expect(0, 68095, '\P{Is_Sc: merc}', "");
    Expect(1, 68095, '\P{^Is_Sc: merc}', "");
    Expect(0, 68096, '\p{Is_Sc: merc}', "");
    Expect(1, 68096, '\p{^Is_Sc: merc}', "");
    Expect(1, 68096, '\P{Is_Sc: merc}', "");
    Expect(0, 68096, '\P{^Is_Sc: merc}', "");
    Expect(1, 68095, '\p{Is_Sc=-	MERC}', "");
    Expect(0, 68095, '\p{^Is_Sc=-	MERC}', "");
    Expect(0, 68095, '\P{Is_Sc=-	MERC}', "");
    Expect(1, 68095, '\P{^Is_Sc=-	MERC}', "");
    Expect(0, 68096, '\p{Is_Sc=-	MERC}', "");
    Expect(1, 68096, '\p{^Is_Sc=-	MERC}', "");
    Expect(1, 68096, '\P{Is_Sc=-	MERC}', "");
    Expect(0, 68096, '\P{^Is_Sc=-	MERC}', "");
    Error('\p{Script=/a/meroitic_Hieroglyphs}');
    Error('\P{Script=/a/meroitic_Hieroglyphs}');
    Expect(1, 67999, '\p{Script=:\AMeroitic_Hieroglyphs\z:}', "");;
    Expect(0, 68000, '\p{Script=:\AMeroitic_Hieroglyphs\z:}', "");;
    Expect(1, 67999, '\p{Script=meroitichieroglyphs}', "");
    Expect(0, 67999, '\p{^Script=meroitichieroglyphs}', "");
    Expect(0, 67999, '\P{Script=meroitichieroglyphs}', "");
    Expect(1, 67999, '\P{^Script=meroitichieroglyphs}', "");
    Expect(0, 68000, '\p{Script=meroitichieroglyphs}', "");
    Expect(1, 68000, '\p{^Script=meroitichieroglyphs}', "");
    Expect(1, 68000, '\P{Script=meroitichieroglyphs}', "");
    Expect(0, 68000, '\P{^Script=meroitichieroglyphs}', "");
    Expect(1, 67999, '\p{Script=:\Ameroitichieroglyphs\z:}', "");;
    Expect(0, 68000, '\p{Script=:\Ameroitichieroglyphs\z:}', "");;
    Expect(1, 67999, '\p{Script=--meroitic_Hieroglyphs}', "");
    Expect(0, 67999, '\p{^Script=--meroitic_Hieroglyphs}', "");
    Expect(0, 67999, '\P{Script=--meroitic_Hieroglyphs}', "");
    Expect(1, 67999, '\P{^Script=--meroitic_Hieroglyphs}', "");
    Expect(0, 68000, '\p{Script=--meroitic_Hieroglyphs}', "");
    Expect(1, 68000, '\p{^Script=--meroitic_Hieroglyphs}', "");
    Expect(1, 68000, '\P{Script=--meroitic_Hieroglyphs}', "");
    Expect(0, 68000, '\P{^Script=--meroitic_Hieroglyphs}', "");
    Error('\p{Sc=_-Mero:=}');
    Error('\P{Sc=_-Mero:=}');
    Expect(1, 67999, '\p{Sc=:\AMero\z:}', "");;
    Expect(0, 68000, '\p{Sc=:\AMero\z:}', "");;
    Expect(1, 67999, '\p{Sc=mero}', "");
    Expect(0, 67999, '\p{^Sc=mero}', "");
    Expect(0, 67999, '\P{Sc=mero}', "");
    Expect(1, 67999, '\P{^Sc=mero}', "");
    Expect(0, 68000, '\p{Sc=mero}', "");
    Expect(1, 68000, '\p{^Sc=mero}', "");
    Expect(1, 68000, '\P{Sc=mero}', "");
    Expect(0, 68000, '\P{^Sc=mero}', "");
    Expect(1, 67999, '\p{Sc=:\Amero\z:}', "");;
    Expect(0, 68000, '\p{Sc=:\Amero\z:}', "");;
    Expect(1, 67999, '\p{Sc=-	MERO}', "");
    Expect(0, 67999, '\p{^Sc=-	MERO}', "");
    Expect(0, 67999, '\P{Sc=-	MERO}', "");
    Expect(1, 67999, '\P{^Sc=-	MERO}', "");
    Expect(0, 68000, '\p{Sc=-	MERO}', "");
    Expect(1, 68000, '\p{^Sc=-	MERO}', "");
    Expect(1, 68000, '\P{Sc=-	MERO}', "");
    Expect(0, 68000, '\P{^Sc=-	MERO}', "");
    Error('\p{Is_Script=:=_	MEROITIC_hieroglyphs}');
    Error('\P{Is_Script=:=_	MEROITIC_hieroglyphs}');
    Expect(1, 67999, '\p{Is_Script=meroitichieroglyphs}', "");
    Expect(0, 67999, '\p{^Is_Script=meroitichieroglyphs}', "");
    Expect(0, 67999, '\P{Is_Script=meroitichieroglyphs}', "");
    Expect(1, 67999, '\P{^Is_Script=meroitichieroglyphs}', "");
    Expect(0, 68000, '\p{Is_Script=meroitichieroglyphs}', "");
    Expect(1, 68000, '\p{^Is_Script=meroitichieroglyphs}', "");
    Expect(1, 68000, '\P{Is_Script=meroitichieroglyphs}', "");
    Expect(0, 68000, '\P{^Is_Script=meroitichieroglyphs}', "");
    Expect(1, 67999, '\p{Is_Script=_-meroitic_HIEROGLYPHS}', "");
    Expect(0, 67999, '\p{^Is_Script=_-meroitic_HIEROGLYPHS}', "");
    Expect(0, 67999, '\P{Is_Script=_-meroitic_HIEROGLYPHS}', "");
    Expect(1, 67999, '\P{^Is_Script=_-meroitic_HIEROGLYPHS}', "");
    Expect(0, 68000, '\p{Is_Script=_-meroitic_HIEROGLYPHS}', "");
    Expect(1, 68000, '\p{^Is_Script=_-meroitic_HIEROGLYPHS}', "");
    Expect(1, 68000, '\P{Is_Script=_-meroitic_HIEROGLYPHS}', "");
    Expect(0, 68000, '\P{^Is_Script=_-meroitic_HIEROGLYPHS}', "");
    Error('\p{Is_Sc=_:=MERO}');
    Error('\P{Is_Sc=_:=MERO}');
    Expect(1, 67999, '\p{Is_Sc=mero}', "");
    Expect(0, 67999, '\p{^Is_Sc=mero}', "");
    Expect(0, 67999, '\P{Is_Sc=mero}', "");
    Expect(1, 67999, '\P{^Is_Sc=mero}', "");
    Expect(0, 68000, '\p{Is_Sc=mero}', "");
    Expect(1, 68000, '\p{^Is_Sc=mero}', "");
    Expect(1, 68000, '\P{Is_Sc=mero}', "");
    Expect(0, 68000, '\P{^Is_Sc=mero}', "");
    Expect(1, 67999, '\p{Is_Sc=	-MERO}', "");
    Expect(0, 67999, '\p{^Is_Sc=	-MERO}', "");
    Expect(0, 67999, '\P{Is_Sc=	-MERO}', "");
    Expect(1, 67999, '\P{^Is_Sc=	-MERO}', "");
    Expect(0, 68000, '\p{Is_Sc=	-MERO}', "");
    Expect(1, 68000, '\p{^Is_Sc=	-MERO}', "");
    Expect(1, 68000, '\P{Is_Sc=	-MERO}', "");
    Expect(0, 68000, '\P{^Is_Sc=	-MERO}', "");
    Error('\p{Script=-/a/malayalam}');
    Error('\P{Script=-/a/malayalam}');
    Expect(1, 3455, '\p{Script=:\AMalayalam\z:}', "");;
    Expect(0, 3456, '\p{Script=:\AMalayalam\z:}', "");;
    Expect(1, 3455, '\p{Script=malayalam}', "");
    Expect(0, 3455, '\p{^Script=malayalam}', "");
    Expect(0, 3455, '\P{Script=malayalam}', "");
    Expect(1, 3455, '\P{^Script=malayalam}', "");
    Expect(0, 3456, '\p{Script=malayalam}', "");
    Expect(1, 3456, '\p{^Script=malayalam}', "");
    Expect(1, 3456, '\P{Script=malayalam}', "");
    Expect(0, 3456, '\P{^Script=malayalam}', "");
    Expect(1, 3455, '\p{Script=:\Amalayalam\z:}', "");;
    Expect(0, 3456, '\p{Script=:\Amalayalam\z:}', "");;
    Expect(1, 3455, '\p{Script= malayalam}', "");
    Expect(0, 3455, '\p{^Script= malayalam}', "");
    Expect(0, 3455, '\P{Script= malayalam}', "");
    Expect(1, 3455, '\P{^Script= malayalam}', "");
    Expect(0, 3456, '\p{Script= malayalam}', "");
    Expect(1, 3456, '\p{^Script= malayalam}', "");
    Expect(1, 3456, '\P{Script= malayalam}', "");
    Expect(0, 3456, '\P{^Script= malayalam}', "");
    Error('\p{Sc= :=mlym}');
    Error('\P{Sc= :=mlym}');
    Expect(1, 3455, '\p{Sc=:\AMlym\z:}', "");;
    Expect(0, 3456, '\p{Sc=:\AMlym\z:}', "");;
    Expect(1, 3455, '\p{Sc=mlym}', "");
    Expect(0, 3455, '\p{^Sc=mlym}', "");
    Expect(0, 3455, '\P{Sc=mlym}', "");
    Expect(1, 3455, '\P{^Sc=mlym}', "");
    Expect(0, 3456, '\p{Sc=mlym}', "");
    Expect(1, 3456, '\p{^Sc=mlym}', "");
    Expect(1, 3456, '\P{Sc=mlym}', "");
    Expect(0, 3456, '\P{^Sc=mlym}', "");
    Expect(1, 3455, '\p{Sc=:\Amlym\z:}', "");;
    Expect(0, 3456, '\p{Sc=:\Amlym\z:}', "");;
    Expect(1, 3455, '\p{Sc=_mlym}', "");
    Expect(0, 3455, '\p{^Sc=_mlym}', "");
    Expect(0, 3455, '\P{Sc=_mlym}', "");
    Expect(1, 3455, '\P{^Sc=_mlym}', "");
    Expect(0, 3456, '\p{Sc=_mlym}', "");
    Expect(1, 3456, '\p{^Sc=_mlym}', "");
    Expect(1, 3456, '\P{Sc=_mlym}', "");
    Expect(0, 3456, '\P{^Sc=_mlym}', "");
    Error('\p{Is_Script=/a/ 	Malayalam}');
    Error('\P{Is_Script=/a/ 	Malayalam}');
    Expect(1, 3455, '\p{Is_Script:	malayalam}', "");
    Expect(0, 3455, '\p{^Is_Script:	malayalam}', "");
    Expect(0, 3455, '\P{Is_Script:	malayalam}', "");
    Expect(1, 3455, '\P{^Is_Script:	malayalam}', "");
    Expect(0, 3456, '\p{Is_Script:	malayalam}', "");
    Expect(1, 3456, '\p{^Is_Script:	malayalam}', "");
    Expect(1, 3456, '\P{Is_Script:	malayalam}', "");
    Expect(0, 3456, '\P{^Is_Script:	malayalam}', "");
    Expect(1, 3455, '\p{Is_Script=	MALAYALAM}', "");
    Expect(0, 3455, '\p{^Is_Script=	MALAYALAM}', "");
    Expect(0, 3455, '\P{Is_Script=	MALAYALAM}', "");
    Expect(1, 3455, '\P{^Is_Script=	MALAYALAM}', "");
    Expect(0, 3456, '\p{Is_Script=	MALAYALAM}', "");
    Expect(1, 3456, '\p{^Is_Script=	MALAYALAM}', "");
    Expect(1, 3456, '\P{Is_Script=	MALAYALAM}', "");
    Expect(0, 3456, '\P{^Is_Script=	MALAYALAM}', "");
    Error('\p{Is_Sc=/a/	_MLYM}');
    Error('\P{Is_Sc=/a/	_MLYM}');
    Expect(1, 3455, '\p{Is_Sc:   mlym}', "");
    Expect(0, 3455, '\p{^Is_Sc:   mlym}', "");
    Expect(0, 3455, '\P{Is_Sc:   mlym}', "");
    Expect(1, 3455, '\P{^Is_Sc:   mlym}', "");
    Expect(0, 3456, '\p{Is_Sc:   mlym}', "");
    Expect(1, 3456, '\p{^Is_Sc:   mlym}', "");
    Expect(1, 3456, '\P{Is_Sc:   mlym}', "");
    Expect(0, 3456, '\P{^Is_Sc:   mlym}', "");
    Expect(1, 3455, '\p{Is_Sc= mlym}', "");
    Expect(0, 3455, '\p{^Is_Sc= mlym}', "");
    Expect(0, 3455, '\P{Is_Sc= mlym}', "");
    Expect(1, 3455, '\P{^Is_Sc= mlym}', "");
    Expect(0, 3456, '\p{Is_Sc= mlym}', "");
    Expect(1, 3456, '\p{^Is_Sc= mlym}', "");
    Expect(1, 3456, '\P{Is_Sc= mlym}', "");
    Expect(0, 3456, '\P{^Is_Sc= mlym}', "");
    Error('\p{Script=:=-	MODI}');
    Error('\P{Script=:=-	MODI}');
    Expect(1, 71257, '\p{Script=:\AModi\z:}', "");;
    Expect(0, 71258, '\p{Script=:\AModi\z:}', "");;
    Expect(1, 71257, '\p{Script=modi}', "");
    Expect(0, 71257, '\p{^Script=modi}', "");
    Expect(0, 71257, '\P{Script=modi}', "");
    Expect(1, 71257, '\P{^Script=modi}', "");
    Expect(0, 71258, '\p{Script=modi}', "");
    Expect(1, 71258, '\p{^Script=modi}', "");
    Expect(1, 71258, '\P{Script=modi}', "");
    Expect(0, 71258, '\P{^Script=modi}', "");
    Expect(1, 71257, '\p{Script=:\Amodi\z:}', "");;
    Expect(0, 71258, '\p{Script=:\Amodi\z:}', "");;
    Expect(1, 71257, '\p{Script=__modi}', "");
    Expect(0, 71257, '\p{^Script=__modi}', "");
    Expect(0, 71257, '\P{Script=__modi}', "");
    Expect(1, 71257, '\P{^Script=__modi}', "");
    Expect(0, 71258, '\p{Script=__modi}', "");
    Expect(1, 71258, '\p{^Script=__modi}', "");
    Expect(1, 71258, '\P{Script=__modi}', "");
    Expect(0, 71258, '\P{^Script=__modi}', "");
    Error('\p{Sc=/a/ 	modi}');
    Error('\P{Sc=/a/ 	modi}');
    Expect(1, 71257, '\p{Sc=:\AModi\z:}', "");;
    Expect(0, 71258, '\p{Sc=:\AModi\z:}', "");;
    Expect(1, 71257, '\p{Sc=modi}', "");
    Expect(0, 71257, '\p{^Sc=modi}', "");
    Expect(0, 71257, '\P{Sc=modi}', "");
    Expect(1, 71257, '\P{^Sc=modi}', "");
    Expect(0, 71258, '\p{Sc=modi}', "");
    Expect(1, 71258, '\p{^Sc=modi}', "");
    Expect(1, 71258, '\P{Sc=modi}', "");
    Expect(0, 71258, '\P{^Sc=modi}', "");
    Expect(1, 71257, '\p{Sc=:\Amodi\z:}', "");;
    Expect(0, 71258, '\p{Sc=:\Amodi\z:}', "");;
    Expect(1, 71257, '\p{Sc=--Modi}', "");
    Expect(0, 71257, '\p{^Sc=--Modi}', "");
    Expect(0, 71257, '\P{Sc=--Modi}', "");
    Expect(1, 71257, '\P{^Sc=--Modi}', "");
    Expect(0, 71258, '\p{Sc=--Modi}', "");
    Expect(1, 71258, '\p{^Sc=--Modi}', "");
    Expect(1, 71258, '\P{Sc=--Modi}', "");
    Expect(0, 71258, '\P{^Sc=--Modi}', "");
    Error('\p{Is_Script=-MODI/a/}');
    Error('\P{Is_Script=-MODI/a/}');
    Expect(1, 71257, '\p{Is_Script=modi}', "");
    Expect(0, 71257, '\p{^Is_Script=modi}', "");
    Expect(0, 71257, '\P{Is_Script=modi}', "");
    Expect(1, 71257, '\P{^Is_Script=modi}', "");
    Expect(0, 71258, '\p{Is_Script=modi}', "");
    Expect(1, 71258, '\p{^Is_Script=modi}', "");
    Expect(1, 71258, '\P{Is_Script=modi}', "");
    Expect(0, 71258, '\P{^Is_Script=modi}', "");
    Expect(1, 71257, '\p{Is_Script=	_modi}', "");
    Expect(0, 71257, '\p{^Is_Script=	_modi}', "");
    Expect(0, 71257, '\P{Is_Script=	_modi}', "");
    Expect(1, 71257, '\P{^Is_Script=	_modi}', "");
    Expect(0, 71258, '\p{Is_Script=	_modi}', "");
    Expect(1, 71258, '\p{^Is_Script=	_modi}', "");
    Expect(1, 71258, '\P{Is_Script=	_modi}', "");
    Expect(0, 71258, '\P{^Is_Script=	_modi}', "");
    Error('\p{Is_Sc=/a/		Modi}');
    Error('\P{Is_Sc=/a/		Modi}');
    Expect(1, 71257, '\p{Is_Sc=modi}', "");
    Expect(0, 71257, '\p{^Is_Sc=modi}', "");
    Expect(0, 71257, '\P{Is_Sc=modi}', "");
    Expect(1, 71257, '\P{^Is_Sc=modi}', "");
    Expect(0, 71258, '\p{Is_Sc=modi}', "");
    Expect(1, 71258, '\p{^Is_Sc=modi}', "");
    Expect(1, 71258, '\P{Is_Sc=modi}', "");
    Expect(0, 71258, '\P{^Is_Sc=modi}', "");
    Expect(1, 71257, '\p{Is_Sc=  Modi}', "");
    Expect(0, 71257, '\p{^Is_Sc=  Modi}', "");
    Expect(0, 71257, '\P{Is_Sc=  Modi}', "");
    Expect(1, 71257, '\P{^Is_Sc=  Modi}', "");
    Expect(0, 71258, '\p{Is_Sc=  Modi}', "");
    Expect(1, 71258, '\p{^Is_Sc=  Modi}', "");
    Expect(1, 71258, '\P{Is_Sc=  Modi}', "");
    Expect(0, 71258, '\P{^Is_Sc=  Modi}', "");
    Error('\p{Script=:=_-Mongolian}');
    Error('\P{Script=:=_-Mongolian}');
    Expect(1, 71276, '\p{Script=:\AMongolian\z:}', "");;
    Expect(0, 71277, '\p{Script=:\AMongolian\z:}', "");;
    Expect(1, 71276, '\p{Script=mongolian}', "");
    Expect(0, 71276, '\p{^Script=mongolian}', "");
    Expect(0, 71276, '\P{Script=mongolian}', "");
    Expect(1, 71276, '\P{^Script=mongolian}', "");
    Expect(0, 71277, '\p{Script=mongolian}', "");
    Expect(1, 71277, '\p{^Script=mongolian}', "");
    Expect(1, 71277, '\P{Script=mongolian}', "");
    Expect(0, 71277, '\P{^Script=mongolian}', "");
    Expect(1, 71276, '\p{Script=:\Amongolian\z:}', "");;
    Expect(0, 71277, '\p{Script=:\Amongolian\z:}', "");;
    Expect(1, 71276, '\p{Script: -	Mongolian}', "");
    Expect(0, 71276, '\p{^Script: -	Mongolian}', "");
    Expect(0, 71276, '\P{Script: -	Mongolian}', "");
    Expect(1, 71276, '\P{^Script: -	Mongolian}', "");
    Expect(0, 71277, '\p{Script: -	Mongolian}', "");
    Expect(1, 71277, '\p{^Script: -	Mongolian}', "");
    Expect(1, 71277, '\P{Script: -	Mongolian}', "");
    Expect(0, 71277, '\P{^Script: -	Mongolian}', "");
    Error('\p{Sc=	:=Mong}');
    Error('\P{Sc=	:=Mong}');
    Expect(1, 71276, '\p{Sc=:\AMong\z:}', "");;
    Expect(0, 71277, '\p{Sc=:\AMong\z:}', "");;
    Expect(1, 71276, '\p{Sc=mong}', "");
    Expect(0, 71276, '\p{^Sc=mong}', "");
    Expect(0, 71276, '\P{Sc=mong}', "");
    Expect(1, 71276, '\P{^Sc=mong}', "");
    Expect(0, 71277, '\p{Sc=mong}', "");
    Expect(1, 71277, '\p{^Sc=mong}', "");
    Expect(1, 71277, '\P{Sc=mong}', "");
    Expect(0, 71277, '\P{^Sc=mong}', "");
    Expect(1, 71276, '\p{Sc=:\Among\z:}', "");;
    Expect(0, 71277, '\p{Sc=:\Among\z:}', "");;
    Expect(1, 71276, '\p{Sc= _Mong}', "");
    Expect(0, 71276, '\p{^Sc= _Mong}', "");
    Expect(0, 71276, '\P{Sc= _Mong}', "");
    Expect(1, 71276, '\P{^Sc= _Mong}', "");
    Expect(0, 71277, '\p{Sc= _Mong}', "");
    Expect(1, 71277, '\p{^Sc= _Mong}', "");
    Expect(1, 71277, '\P{Sc= _Mong}', "");
    Expect(0, 71277, '\P{^Sc= _Mong}', "");
    Error('\p{Is_Script=/a/-	Mongolian}');
    Error('\P{Is_Script=/a/-	Mongolian}');
    Expect(1, 71276, '\p{Is_Script=mongolian}', "");
    Expect(0, 71276, '\p{^Is_Script=mongolian}', "");
    Expect(0, 71276, '\P{Is_Script=mongolian}', "");
    Expect(1, 71276, '\P{^Is_Script=mongolian}', "");
    Expect(0, 71277, '\p{Is_Script=mongolian}', "");
    Expect(1, 71277, '\p{^Is_Script=mongolian}', "");
    Expect(1, 71277, '\P{Is_Script=mongolian}', "");
    Expect(0, 71277, '\P{^Is_Script=mongolian}', "");
    Expect(1, 71276, '\p{Is_Script= _mongolian}', "");
    Expect(0, 71276, '\p{^Is_Script= _mongolian}', "");
    Expect(0, 71276, '\P{Is_Script= _mongolian}', "");
    Expect(1, 71276, '\P{^Is_Script= _mongolian}', "");
    Expect(0, 71277, '\p{Is_Script= _mongolian}', "");
    Expect(1, 71277, '\p{^Is_Script= _mongolian}', "");
    Expect(1, 71277, '\P{Is_Script= _mongolian}', "");
    Expect(0, 71277, '\P{^Is_Script= _mongolian}', "");
    Error('\p{Is_Sc=:=mong}');
    Error('\P{Is_Sc=:=mong}');
    Expect(1, 71276, '\p{Is_Sc=mong}', "");
    Expect(0, 71276, '\p{^Is_Sc=mong}', "");
    Expect(0, 71276, '\P{Is_Sc=mong}', "");
    Expect(1, 71276, '\P{^Is_Sc=mong}', "");
    Expect(0, 71277, '\p{Is_Sc=mong}', "");
    Expect(1, 71277, '\p{^Is_Sc=mong}', "");
    Expect(1, 71277, '\P{Is_Sc=mong}', "");
    Expect(0, 71277, '\P{^Is_Sc=mong}', "");
    Expect(1, 71276, '\p{Is_Sc=	_mong}', "");
    Expect(0, 71276, '\p{^Is_Sc=	_mong}', "");
    Expect(0, 71276, '\P{Is_Sc=	_mong}', "");
    Expect(1, 71276, '\P{^Is_Sc=	_mong}', "");
    Expect(0, 71277, '\p{Is_Sc=	_mong}', "");
    Expect(1, 71277, '\p{^Is_Sc=	_mong}', "");
    Expect(1, 71277, '\P{Is_Sc=	_mong}', "");
    Expect(0, 71277, '\P{^Is_Sc=	_mong}', "");
    Error('\p{Script=	:=Mro}');
    Error('\P{Script=	:=Mro}');
    Expect(1, 92783, '\p{Script=:\AMro\z:}', "");;
    Expect(0, 92784, '\p{Script=:\AMro\z:}', "");;
    Expect(1, 92783, '\p{Script=mro}', "");
    Expect(0, 92783, '\p{^Script=mro}', "");
    Expect(0, 92783, '\P{Script=mro}', "");
    Expect(1, 92783, '\P{^Script=mro}', "");
    Expect(0, 92784, '\p{Script=mro}', "");
    Expect(1, 92784, '\p{^Script=mro}', "");
    Expect(1, 92784, '\P{Script=mro}', "");
    Expect(0, 92784, '\P{^Script=mro}', "");
    Expect(1, 92783, '\p{Script=:\Amro\z:}', "");;
    Expect(0, 92784, '\p{Script=:\Amro\z:}', "");;
    Expect(1, 92783, '\p{Script= _mro}', "");
    Expect(0, 92783, '\p{^Script= _mro}', "");
    Expect(0, 92783, '\P{Script= _mro}', "");
    Expect(1, 92783, '\P{^Script= _mro}', "");
    Expect(0, 92784, '\p{Script= _mro}', "");
    Expect(1, 92784, '\p{^Script= _mro}', "");
    Expect(1, 92784, '\P{Script= _mro}', "");
    Expect(0, 92784, '\P{^Script= _mro}', "");
    Error('\p{Sc=_MROO:=}');
    Error('\P{Sc=_MROO:=}');
    Expect(1, 92783, '\p{Sc=:\AMroo\z:}', "");;
    Expect(0, 92784, '\p{Sc=:\AMroo\z:}', "");;
    Expect(1, 92783, '\p{Sc:mroo}', "");
    Expect(0, 92783, '\p{^Sc:mroo}', "");
    Expect(0, 92783, '\P{Sc:mroo}', "");
    Expect(1, 92783, '\P{^Sc:mroo}', "");
    Expect(0, 92784, '\p{Sc:mroo}', "");
    Expect(1, 92784, '\p{^Sc:mroo}', "");
    Expect(1, 92784, '\P{Sc:mroo}', "");
    Expect(0, 92784, '\P{^Sc:mroo}', "");
    Expect(1, 92783, '\p{Sc=:\Amroo\z:}', "");;
    Expect(0, 92784, '\p{Sc=:\Amroo\z:}', "");;
    Expect(1, 92783, '\p{Sc=-MROO}', "");
    Expect(0, 92783, '\p{^Sc=-MROO}', "");
    Expect(0, 92783, '\P{Sc=-MROO}', "");
    Expect(1, 92783, '\P{^Sc=-MROO}', "");
    Expect(0, 92784, '\p{Sc=-MROO}', "");
    Expect(1, 92784, '\p{^Sc=-MROO}', "");
    Expect(1, 92784, '\P{Sc=-MROO}', "");
    Expect(0, 92784, '\P{^Sc=-MROO}', "");
    Error('\p{Is_Script=		mro/a/}');
    Error('\P{Is_Script=		mro/a/}');
    Expect(1, 92783, '\p{Is_Script=mro}', "");
    Expect(0, 92783, '\p{^Is_Script=mro}', "");
    Expect(0, 92783, '\P{Is_Script=mro}', "");
    Expect(1, 92783, '\P{^Is_Script=mro}', "");
    Expect(0, 92784, '\p{Is_Script=mro}', "");
    Expect(1, 92784, '\p{^Is_Script=mro}', "");
    Expect(1, 92784, '\P{Is_Script=mro}', "");
    Expect(0, 92784, '\P{^Is_Script=mro}', "");
    Expect(1, 92783, '\p{Is_Script=-Mro}', "");
    Expect(0, 92783, '\p{^Is_Script=-Mro}', "");
    Expect(0, 92783, '\P{Is_Script=-Mro}', "");
    Expect(1, 92783, '\P{^Is_Script=-Mro}', "");
    Expect(0, 92784, '\p{Is_Script=-Mro}', "");
    Expect(1, 92784, '\p{^Is_Script=-Mro}', "");
    Expect(1, 92784, '\P{Is_Script=-Mro}', "");
    Expect(0, 92784, '\P{^Is_Script=-Mro}', "");
    Error('\p{Is_Sc=	-mroo/a/}');
    Error('\P{Is_Sc=	-mroo/a/}');
    Expect(1, 92783, '\p{Is_Sc=mroo}', "");
    Expect(0, 92783, '\p{^Is_Sc=mroo}', "");
    Expect(0, 92783, '\P{Is_Sc=mroo}', "");
    Expect(1, 92783, '\P{^Is_Sc=mroo}', "");
    Expect(0, 92784, '\p{Is_Sc=mroo}', "");
    Expect(1, 92784, '\p{^Is_Sc=mroo}', "");
    Expect(1, 92784, '\P{Is_Sc=mroo}', "");
    Expect(0, 92784, '\P{^Is_Sc=mroo}', "");
    Expect(1, 92783, '\p{Is_Sc=--mroo}', "");
    Expect(0, 92783, '\p{^Is_Sc=--mroo}', "");
    Expect(0, 92783, '\P{Is_Sc=--mroo}', "");
    Expect(1, 92783, '\P{^Is_Sc=--mroo}', "");
    Expect(0, 92784, '\p{Is_Sc=--mroo}', "");
    Expect(1, 92784, '\p{^Is_Sc=--mroo}', "");
    Expect(1, 92784, '\P{Is_Sc=--mroo}', "");
    Expect(0, 92784, '\P{^Is_Sc=--mroo}', "");
    Error('\p{Script=	Meetei_MAYEK:=}');
    Error('\P{Script=	Meetei_MAYEK:=}');
    Expect(1, 44025, '\p{Script=:\AMeetei_Mayek\z:}', "");;
    Expect(0, 44026, '\p{Script=:\AMeetei_Mayek\z:}', "");;
    Expect(1, 44025, '\p{Script=meeteimayek}', "");
    Expect(0, 44025, '\p{^Script=meeteimayek}', "");
    Expect(0, 44025, '\P{Script=meeteimayek}', "");
    Expect(1, 44025, '\P{^Script=meeteimayek}', "");
    Expect(0, 44026, '\p{Script=meeteimayek}', "");
    Expect(1, 44026, '\p{^Script=meeteimayek}', "");
    Expect(1, 44026, '\P{Script=meeteimayek}', "");
    Expect(0, 44026, '\P{^Script=meeteimayek}', "");
    Expect(1, 44025, '\p{Script=:\Ameeteimayek\z:}', "");;
    Expect(0, 44026, '\p{Script=:\Ameeteimayek\z:}', "");;
    Expect(1, 44025, '\p{Script= MEETEI_Mayek}', "");
    Expect(0, 44025, '\p{^Script= MEETEI_Mayek}', "");
    Expect(0, 44025, '\P{Script= MEETEI_Mayek}', "");
    Expect(1, 44025, '\P{^Script= MEETEI_Mayek}', "");
    Expect(0, 44026, '\p{Script= MEETEI_Mayek}', "");
    Expect(1, 44026, '\p{^Script= MEETEI_Mayek}', "");
    Expect(1, 44026, '\P{Script= MEETEI_Mayek}', "");
    Expect(0, 44026, '\P{^Script= MEETEI_Mayek}', "");
    Error('\p{Sc=:=-_Mtei}');
    Error('\P{Sc=:=-_Mtei}');
    Expect(1, 44025, '\p{Sc=:\AMtei\z:}', "");;
    Expect(0, 44026, '\p{Sc=:\AMtei\z:}', "");;
    Expect(1, 44025, '\p{Sc=mtei}', "");
    Expect(0, 44025, '\p{^Sc=mtei}', "");
    Expect(0, 44025, '\P{Sc=mtei}', "");
    Expect(1, 44025, '\P{^Sc=mtei}', "");
    Expect(0, 44026, '\p{Sc=mtei}', "");
    Expect(1, 44026, '\p{^Sc=mtei}', "");
    Expect(1, 44026, '\P{Sc=mtei}', "");
    Expect(0, 44026, '\P{^Sc=mtei}', "");
    Expect(1, 44025, '\p{Sc=:\Amtei\z:}', "");;
    Expect(0, 44026, '\p{Sc=:\Amtei\z:}', "");;
    Expect(1, 44025, '\p{Sc=		Mtei}', "");
    Expect(0, 44025, '\p{^Sc=		Mtei}', "");
    Expect(0, 44025, '\P{Sc=		Mtei}', "");
    Expect(1, 44025, '\P{^Sc=		Mtei}', "");
    Expect(0, 44026, '\p{Sc=		Mtei}', "");
    Expect(1, 44026, '\p{^Sc=		Mtei}', "");
    Expect(1, 44026, '\P{Sc=		Mtei}', "");
    Expect(0, 44026, '\P{^Sc=		Mtei}', "");
    Error('\p{Is_Script= -Meetei_MAYEK:=}');
    Error('\P{Is_Script= -Meetei_MAYEK:=}');
    Expect(1, 44025, '\p{Is_Script=meeteimayek}', "");
    Expect(0, 44025, '\p{^Is_Script=meeteimayek}', "");
    Expect(0, 44025, '\P{Is_Script=meeteimayek}', "");
    Expect(1, 44025, '\P{^Is_Script=meeteimayek}', "");
    Expect(0, 44026, '\p{Is_Script=meeteimayek}', "");
    Expect(1, 44026, '\p{^Is_Script=meeteimayek}', "");
    Expect(1, 44026, '\P{Is_Script=meeteimayek}', "");
    Expect(0, 44026, '\P{^Is_Script=meeteimayek}', "");
    Expect(1, 44025, '\p{Is_Script=-meetei_Mayek}', "");
    Expect(0, 44025, '\p{^Is_Script=-meetei_Mayek}', "");
    Expect(0, 44025, '\P{Is_Script=-meetei_Mayek}', "");
    Expect(1, 44025, '\P{^Is_Script=-meetei_Mayek}', "");
    Expect(0, 44026, '\p{Is_Script=-meetei_Mayek}', "");
    Expect(1, 44026, '\p{^Is_Script=-meetei_Mayek}', "");
    Expect(1, 44026, '\P{Is_Script=-meetei_Mayek}', "");
    Expect(0, 44026, '\P{^Is_Script=-meetei_Mayek}', "");
    Error('\p{Is_Sc: :=__Mtei}');
    Error('\P{Is_Sc: :=__Mtei}');
    Expect(1, 44025, '\p{Is_Sc=mtei}', "");
    Expect(0, 44025, '\p{^Is_Sc=mtei}', "");
    Expect(0, 44025, '\P{Is_Sc=mtei}', "");
    Expect(1, 44025, '\P{^Is_Sc=mtei}', "");
    Expect(0, 44026, '\p{Is_Sc=mtei}', "");
    Expect(1, 44026, '\p{^Is_Sc=mtei}', "");
    Expect(1, 44026, '\P{Is_Sc=mtei}', "");
    Expect(0, 44026, '\P{^Is_Sc=mtei}', "");
    Expect(1, 44025, '\p{Is_Sc=-_Mtei}', "");
    Expect(0, 44025, '\p{^Is_Sc=-_Mtei}', "");
    Expect(0, 44025, '\P{Is_Sc=-_Mtei}', "");
    Expect(1, 44025, '\P{^Is_Sc=-_Mtei}', "");
    Expect(0, 44026, '\p{Is_Sc=-_Mtei}', "");
    Expect(1, 44026, '\p{^Is_Sc=-_Mtei}', "");
    Expect(1, 44026, '\P{Is_Sc=-_Mtei}', "");
    Expect(0, 44026, '\P{^Is_Sc=-_Mtei}', "");
    Error('\p{Script=-Multani:=}');
    Error('\P{Script=-Multani:=}');
    Expect(1, 70313, '\p{Script=:\AMultani\z:}', "");;
    Expect(0, 70314, '\p{Script=:\AMultani\z:}', "");;
    Expect(1, 70313, '\p{Script=multani}', "");
    Expect(0, 70313, '\p{^Script=multani}', "");
    Expect(0, 70313, '\P{Script=multani}', "");
    Expect(1, 70313, '\P{^Script=multani}', "");
    Expect(0, 70314, '\p{Script=multani}', "");
    Expect(1, 70314, '\p{^Script=multani}', "");
    Expect(1, 70314, '\P{Script=multani}', "");
    Expect(0, 70314, '\P{^Script=multani}', "");
    Expect(1, 70313, '\p{Script=:\Amultani\z:}', "");;
    Expect(0, 70314, '\p{Script=:\Amultani\z:}', "");;
    Expect(1, 70313, '\p{Script=_Multani}', "");
    Expect(0, 70313, '\p{^Script=_Multani}', "");
    Expect(0, 70313, '\P{Script=_Multani}', "");
    Expect(1, 70313, '\P{^Script=_Multani}', "");
    Expect(0, 70314, '\p{Script=_Multani}', "");
    Expect(1, 70314, '\p{^Script=_Multani}', "");
    Expect(1, 70314, '\P{Script=_Multani}', "");
    Expect(0, 70314, '\P{^Script=_Multani}', "");
    Error('\p{Sc=:=__MULT}');
    Error('\P{Sc=:=__MULT}');
    Expect(1, 70313, '\p{Sc=:\AMult\z:}', "");;
    Expect(0, 70314, '\p{Sc=:\AMult\z:}', "");;
    Expect(1, 70313, '\p{Sc:mult}', "");
    Expect(0, 70313, '\p{^Sc:mult}', "");
    Expect(0, 70313, '\P{Sc:mult}', "");
    Expect(1, 70313, '\P{^Sc:mult}', "");
    Expect(0, 70314, '\p{Sc:mult}', "");
    Expect(1, 70314, '\p{^Sc:mult}', "");
    Expect(1, 70314, '\P{Sc:mult}', "");
    Expect(0, 70314, '\P{^Sc:mult}', "");
    Expect(1, 70313, '\p{Sc=:\Amult\z:}', "");;
    Expect(0, 70314, '\p{Sc=:\Amult\z:}', "");;
    Expect(1, 70313, '\p{Sc=Mult}', "");
    Expect(0, 70313, '\p{^Sc=Mult}', "");
    Expect(0, 70313, '\P{Sc=Mult}', "");
    Expect(1, 70313, '\P{^Sc=Mult}', "");
    Expect(0, 70314, '\p{Sc=Mult}', "");
    Expect(1, 70314, '\p{^Sc=Mult}', "");
    Expect(1, 70314, '\P{Sc=Mult}', "");
    Expect(0, 70314, '\P{^Sc=Mult}', "");
    Error('\p{Is_Script=:= -Multani}');
    Error('\P{Is_Script=:= -Multani}');
    Expect(1, 70313, '\p{Is_Script=multani}', "");
    Expect(0, 70313, '\p{^Is_Script=multani}', "");
    Expect(0, 70313, '\P{Is_Script=multani}', "");
    Expect(1, 70313, '\P{^Is_Script=multani}', "");
    Expect(0, 70314, '\p{Is_Script=multani}', "");
    Expect(1, 70314, '\p{^Is_Script=multani}', "");
    Expect(1, 70314, '\P{Is_Script=multani}', "");
    Expect(0, 70314, '\P{^Is_Script=multani}', "");
    Expect(1, 70313, '\p{Is_Script= _Multani}', "");
    Expect(0, 70313, '\p{^Is_Script= _Multani}', "");
    Expect(0, 70313, '\P{Is_Script= _Multani}', "");
    Expect(1, 70313, '\P{^Is_Script= _Multani}', "");
    Expect(0, 70314, '\p{Is_Script= _Multani}', "");
    Expect(1, 70314, '\p{^Is_Script= _Multani}', "");
    Expect(1, 70314, '\P{Is_Script= _Multani}', "");
    Expect(0, 70314, '\P{^Is_Script= _Multani}', "");
    Error('\p{Is_Sc=--mult/a/}');
    Error('\P{Is_Sc=--mult/a/}');
    Expect(1, 70313, '\p{Is_Sc=mult}', "");
    Expect(0, 70313, '\p{^Is_Sc=mult}', "");
    Expect(0, 70313, '\P{Is_Sc=mult}', "");
    Expect(1, 70313, '\P{^Is_Sc=mult}', "");
    Expect(0, 70314, '\p{Is_Sc=mult}', "");
    Expect(1, 70314, '\p{^Is_Sc=mult}', "");
    Expect(1, 70314, '\P{Is_Sc=mult}', "");
    Expect(0, 70314, '\P{^Is_Sc=mult}', "");
    Expect(1, 70313, '\p{Is_Sc=	mult}', "");
    Expect(0, 70313, '\p{^Is_Sc=	mult}', "");
    Expect(0, 70313, '\P{Is_Sc=	mult}', "");
    Expect(1, 70313, '\P{^Is_Sc=	mult}', "");
    Expect(0, 70314, '\p{Is_Sc=	mult}', "");
    Expect(1, 70314, '\p{^Is_Sc=	mult}', "");
    Expect(1, 70314, '\P{Is_Sc=	mult}', "");
    Expect(0, 70314, '\P{^Is_Sc=	mult}', "");
    Error('\p{Script=	/a/myanmar}');
    Error('\P{Script=	/a/myanmar}');
    Expect(1, 43647, '\p{Script=:\AMyanmar\z:}', "");;
    Expect(0, 43648, '\p{Script=:\AMyanmar\z:}', "");;
    Expect(1, 43647, '\p{Script=myanmar}', "");
    Expect(0, 43647, '\p{^Script=myanmar}', "");
    Expect(0, 43647, '\P{Script=myanmar}', "");
    Expect(1, 43647, '\P{^Script=myanmar}', "");
    Expect(0, 43648, '\p{Script=myanmar}', "");
    Expect(1, 43648, '\p{^Script=myanmar}', "");
    Expect(1, 43648, '\P{Script=myanmar}', "");
    Expect(0, 43648, '\P{^Script=myanmar}', "");
    Expect(1, 43647, '\p{Script=:\Amyanmar\z:}', "");;
    Expect(0, 43648, '\p{Script=:\Amyanmar\z:}', "");;
    Expect(1, 43647, '\p{Script= myanmar}', "");
    Expect(0, 43647, '\p{^Script= myanmar}', "");
    Expect(0, 43647, '\P{Script= myanmar}', "");
    Expect(1, 43647, '\P{^Script= myanmar}', "");
    Expect(0, 43648, '\p{Script= myanmar}', "");
    Expect(1, 43648, '\p{^Script= myanmar}', "");
    Expect(1, 43648, '\P{Script= myanmar}', "");
    Expect(0, 43648, '\P{^Script= myanmar}', "");
    Error('\p{Sc=__MYMR:=}');
    Error('\P{Sc=__MYMR:=}');
    Expect(1, 43647, '\p{Sc=:\AMymr\z:}', "");;
    Expect(0, 43648, '\p{Sc=:\AMymr\z:}', "");;
    Expect(1, 43647, '\p{Sc=mymr}', "");
    Expect(0, 43647, '\p{^Sc=mymr}', "");
    Expect(0, 43647, '\P{Sc=mymr}', "");
    Expect(1, 43647, '\P{^Sc=mymr}', "");
    Expect(0, 43648, '\p{Sc=mymr}', "");
    Expect(1, 43648, '\p{^Sc=mymr}', "");
    Expect(1, 43648, '\P{Sc=mymr}', "");
    Expect(0, 43648, '\P{^Sc=mymr}', "");
    Expect(1, 43647, '\p{Sc=:\Amymr\z:}', "");;
    Expect(0, 43648, '\p{Sc=:\Amymr\z:}', "");;
    Expect(1, 43647, '\p{Sc=__Mymr}', "");
    Expect(0, 43647, '\p{^Sc=__Mymr}', "");
    Expect(0, 43647, '\P{Sc=__Mymr}', "");
    Expect(1, 43647, '\P{^Sc=__Mymr}', "");
    Expect(0, 43648, '\p{Sc=__Mymr}', "");
    Expect(1, 43648, '\p{^Sc=__Mymr}', "");
    Expect(1, 43648, '\P{Sc=__Mymr}', "");
    Expect(0, 43648, '\P{^Sc=__Mymr}', "");
    Error('\p{Is_Script=	 Myanmar/a/}');
    Error('\P{Is_Script=	 Myanmar/a/}');
    Expect(1, 43647, '\p{Is_Script=myanmar}', "");
    Expect(0, 43647, '\p{^Is_Script=myanmar}', "");
    Expect(0, 43647, '\P{Is_Script=myanmar}', "");
    Expect(1, 43647, '\P{^Is_Script=myanmar}', "");
    Expect(0, 43648, '\p{Is_Script=myanmar}', "");
    Expect(1, 43648, '\p{^Is_Script=myanmar}', "");
    Expect(1, 43648, '\P{Is_Script=myanmar}', "");
    Expect(0, 43648, '\P{^Is_Script=myanmar}', "");
    Expect(1, 43647, '\p{Is_Script=Myanmar}', "");
    Expect(0, 43647, '\p{^Is_Script=Myanmar}', "");
    Expect(0, 43647, '\P{Is_Script=Myanmar}', "");
    Expect(1, 43647, '\P{^Is_Script=Myanmar}', "");
    Expect(0, 43648, '\p{Is_Script=Myanmar}', "");
    Expect(1, 43648, '\p{^Is_Script=Myanmar}', "");
    Expect(1, 43648, '\P{Is_Script=Myanmar}', "");
    Expect(0, 43648, '\P{^Is_Script=Myanmar}', "");
    Error('\p{Is_Sc=-/a/Mymr}');
    Error('\P{Is_Sc=-/a/Mymr}');
    Expect(1, 43647, '\p{Is_Sc=mymr}', "");
    Expect(0, 43647, '\p{^Is_Sc=mymr}', "");
    Expect(0, 43647, '\P{Is_Sc=mymr}', "");
    Expect(1, 43647, '\P{^Is_Sc=mymr}', "");
    Expect(0, 43648, '\p{Is_Sc=mymr}', "");
    Expect(1, 43648, '\p{^Is_Sc=mymr}', "");
    Expect(1, 43648, '\P{Is_Sc=mymr}', "");
    Expect(0, 43648, '\P{^Is_Sc=mymr}', "");
    Expect(1, 43647, '\p{Is_Sc=	-MYMR}', "");
    Expect(0, 43647, '\p{^Is_Sc=	-MYMR}', "");
    Expect(0, 43647, '\P{Is_Sc=	-MYMR}', "");
    Expect(1, 43647, '\P{^Is_Sc=	-MYMR}', "");
    Expect(0, 43648, '\p{Is_Sc=	-MYMR}', "");
    Expect(1, 43648, '\p{^Is_Sc=	-MYMR}', "");
    Expect(1, 43648, '\P{Is_Sc=	-MYMR}', "");
    Expect(0, 43648, '\P{^Is_Sc=	-MYMR}', "");
    Error('\p{Script=/a/__Nag_Mundari}');
    Error('\P{Script=/a/__Nag_Mundari}');
    Expect(1, 124153, '\p{Script=:\ANag_Mundari\z:}', "");;
    Expect(0, 124154, '\p{Script=:\ANag_Mundari\z:}', "");;
    Expect(1, 124153, '\p{Script=nagmundari}', "");
    Expect(0, 124153, '\p{^Script=nagmundari}', "");
    Expect(0, 124153, '\P{Script=nagmundari}', "");
    Expect(1, 124153, '\P{^Script=nagmundari}', "");
    Expect(0, 124154, '\p{Script=nagmundari}', "");
    Expect(1, 124154, '\p{^Script=nagmundari}', "");
    Expect(1, 124154, '\P{Script=nagmundari}', "");
    Expect(0, 124154, '\P{^Script=nagmundari}', "");
    Expect(1, 124153, '\p{Script=:\Anagmundari\z:}', "");;
    Expect(0, 124154, '\p{Script=:\Anagmundari\z:}', "");;
    Expect(1, 124153, '\p{Script=	Nag_Mundari}', "");
    Expect(0, 124153, '\p{^Script=	Nag_Mundari}', "");
    Expect(0, 124153, '\P{Script=	Nag_Mundari}', "");
    Expect(1, 124153, '\P{^Script=	Nag_Mundari}', "");
    Expect(0, 124154, '\p{Script=	Nag_Mundari}', "");
    Expect(1, 124154, '\p{^Script=	Nag_Mundari}', "");
    Expect(1, 124154, '\P{Script=	Nag_Mundari}', "");
    Expect(0, 124154, '\P{^Script=	Nag_Mundari}', "");
    Error('\p{Sc=_:=nagm}');
    Error('\P{Sc=_:=nagm}');
    Expect(1, 124153, '\p{Sc=:\ANagm\z:}', "");;
    Expect(0, 124154, '\p{Sc=:\ANagm\z:}', "");;
    Expect(1, 124153, '\p{Sc=nagm}', "");
    Expect(0, 124153, '\p{^Sc=nagm}', "");
    Expect(0, 124153, '\P{Sc=nagm}', "");
    Expect(1, 124153, '\P{^Sc=nagm}', "");
    Expect(0, 124154, '\p{Sc=nagm}', "");
    Expect(1, 124154, '\p{^Sc=nagm}', "");
    Expect(1, 124154, '\P{Sc=nagm}', "");
    Expect(0, 124154, '\P{^Sc=nagm}', "");
    Expect(1, 124153, '\p{Sc=:\Anagm\z:}', "");;
    Expect(0, 124154, '\p{Sc=:\Anagm\z:}', "");;
    Expect(1, 124153, '\p{Sc=_Nagm}', "");
    Expect(0, 124153, '\p{^Sc=_Nagm}', "");
    Expect(0, 124153, '\P{Sc=_Nagm}', "");
    Expect(1, 124153, '\P{^Sc=_Nagm}', "");
    Expect(0, 124154, '\p{Sc=_Nagm}', "");
    Expect(1, 124154, '\p{^Sc=_Nagm}', "");
    Expect(1, 124154, '\P{Sc=_Nagm}', "");
    Expect(0, 124154, '\P{^Sc=_Nagm}', "");
    Error('\p{Is_Script=	/a/NAG_Mundari}');
    Error('\P{Is_Script=	/a/NAG_Mundari}');
    Expect(1, 124153, '\p{Is_Script=nagmundari}', "");
    Expect(0, 124153, '\p{^Is_Script=nagmundari}', "");
    Expect(0, 124153, '\P{Is_Script=nagmundari}', "");
    Expect(1, 124153, '\P{^Is_Script=nagmundari}', "");
    Expect(0, 124154, '\p{Is_Script=nagmundari}', "");
    Expect(1, 124154, '\p{^Is_Script=nagmundari}', "");
    Expect(1, 124154, '\P{Is_Script=nagmundari}', "");
    Expect(0, 124154, '\P{^Is_Script=nagmundari}', "");
    Expect(1, 124153, '\p{Is_Script=	-Nag_Mundari}', "");
    Expect(0, 124153, '\p{^Is_Script=	-Nag_Mundari}', "");
    Expect(0, 124153, '\P{Is_Script=	-Nag_Mundari}', "");
    Expect(1, 124153, '\P{^Is_Script=	-Nag_Mundari}', "");
    Expect(0, 124154, '\p{Is_Script=	-Nag_Mundari}', "");
    Expect(1, 124154, '\p{^Is_Script=	-Nag_Mundari}', "");
    Expect(1, 124154, '\P{Is_Script=	-Nag_Mundari}', "");
    Expect(0, 124154, '\P{^Is_Script=	-Nag_Mundari}', "");
    Error('\p{Is_Sc=_	NAGM/a/}');
    Error('\P{Is_Sc=_	NAGM/a/}');
    Expect(1, 124153, '\p{Is_Sc=nagm}', "");
    Expect(0, 124153, '\p{^Is_Sc=nagm}', "");
    Expect(0, 124153, '\P{Is_Sc=nagm}', "");
    Expect(1, 124153, '\P{^Is_Sc=nagm}', "");
    Expect(0, 124154, '\p{Is_Sc=nagm}', "");
    Expect(1, 124154, '\p{^Is_Sc=nagm}', "");
    Expect(1, 124154, '\P{Is_Sc=nagm}', "");
    Expect(0, 124154, '\P{^Is_Sc=nagm}', "");
    Expect(1, 124153, '\p{Is_Sc=--nagm}', "");
    Expect(0, 124153, '\p{^Is_Sc=--nagm}', "");
    Expect(0, 124153, '\P{Is_Sc=--nagm}', "");
    Expect(1, 124153, '\P{^Is_Sc=--nagm}', "");
    Expect(0, 124154, '\p{Is_Sc=--nagm}', "");
    Expect(1, 124154, '\p{^Is_Sc=--nagm}', "");
    Expect(1, 124154, '\P{Is_Sc=--nagm}', "");
    Expect(0, 124154, '\P{^Is_Sc=--nagm}', "");
    Error('\p{Script=:=_Nandinagari}');
    Error('\P{Script=:=_Nandinagari}');
    Expect(1, 72164, '\p{Script=:\ANandinagari\z:}', "");;
    Expect(0, 72165, '\p{Script=:\ANandinagari\z:}', "");;
    Expect(1, 72164, '\p{Script=nandinagari}', "");
    Expect(0, 72164, '\p{^Script=nandinagari}', "");
    Expect(0, 72164, '\P{Script=nandinagari}', "");
    Expect(1, 72164, '\P{^Script=nandinagari}', "");
    Expect(0, 72165, '\p{Script=nandinagari}', "");
    Expect(1, 72165, '\p{^Script=nandinagari}', "");
    Expect(1, 72165, '\P{Script=nandinagari}', "");
    Expect(0, 72165, '\P{^Script=nandinagari}', "");
    Expect(1, 72164, '\p{Script=:\Anandinagari\z:}', "");;
    Expect(0, 72165, '\p{Script=:\Anandinagari\z:}', "");;
    Expect(1, 72164, '\p{Script=_NANDINAGARI}', "");
    Expect(0, 72164, '\p{^Script=_NANDINAGARI}', "");
    Expect(0, 72164, '\P{Script=_NANDINAGARI}', "");
    Expect(1, 72164, '\P{^Script=_NANDINAGARI}', "");
    Expect(0, 72165, '\p{Script=_NANDINAGARI}', "");
    Expect(1, 72165, '\p{^Script=_NANDINAGARI}', "");
    Expect(1, 72165, '\P{Script=_NANDINAGARI}', "");
    Expect(0, 72165, '\P{^Script=_NANDINAGARI}', "");
    Error('\p{Sc=:=-Nand}');
    Error('\P{Sc=:=-Nand}');
    Expect(1, 72164, '\p{Sc=:\ANand\z:}', "");;
    Expect(0, 72165, '\p{Sc=:\ANand\z:}', "");;
    Expect(1, 72164, '\p{Sc=nand}', "");
    Expect(0, 72164, '\p{^Sc=nand}', "");
    Expect(0, 72164, '\P{Sc=nand}', "");
    Expect(1, 72164, '\P{^Sc=nand}', "");
    Expect(0, 72165, '\p{Sc=nand}', "");
    Expect(1, 72165, '\p{^Sc=nand}', "");
    Expect(1, 72165, '\P{Sc=nand}', "");
    Expect(0, 72165, '\P{^Sc=nand}', "");
    Expect(1, 72164, '\p{Sc=:\Anand\z:}', "");;
    Expect(0, 72165, '\p{Sc=:\Anand\z:}', "");;
    Expect(1, 72164, '\p{Sc= _Nand}', "");
    Expect(0, 72164, '\p{^Sc= _Nand}', "");
    Expect(0, 72164, '\P{Sc= _Nand}', "");
    Expect(1, 72164, '\P{^Sc= _Nand}', "");
    Expect(0, 72165, '\p{Sc= _Nand}', "");
    Expect(1, 72165, '\p{^Sc= _Nand}', "");
    Expect(1, 72165, '\P{Sc= _Nand}', "");
    Expect(0, 72165, '\P{^Sc= _Nand}', "");
    Error('\p{Is_Script=  Nandinagari:=}');
    Error('\P{Is_Script=  Nandinagari:=}');
    Expect(1, 72164, '\p{Is_Script:nandinagari}', "");
    Expect(0, 72164, '\p{^Is_Script:nandinagari}', "");
    Expect(0, 72164, '\P{Is_Script:nandinagari}', "");
    Expect(1, 72164, '\P{^Is_Script:nandinagari}', "");
    Expect(0, 72165, '\p{Is_Script:nandinagari}', "");
    Expect(1, 72165, '\p{^Is_Script:nandinagari}', "");
    Expect(1, 72165, '\P{Is_Script:nandinagari}', "");
    Expect(0, 72165, '\P{^Is_Script:nandinagari}', "");
    Expect(1, 72164, '\p{Is_Script=	-Nandinagari}', "");
    Expect(0, 72164, '\p{^Is_Script=	-Nandinagari}', "");
    Expect(0, 72164, '\P{Is_Script=	-Nandinagari}', "");
    Expect(1, 72164, '\P{^Is_Script=	-Nandinagari}', "");
    Expect(0, 72165, '\p{Is_Script=	-Nandinagari}', "");
    Expect(1, 72165, '\p{^Is_Script=	-Nandinagari}', "");
    Expect(1, 72165, '\P{Is_Script=	-Nandinagari}', "");
    Expect(0, 72165, '\P{^Is_Script=	-Nandinagari}', "");
    Error('\p{Is_Sc= Nand/a/}');
    Error('\P{Is_Sc= Nand/a/}');
    Expect(1, 72164, '\p{Is_Sc=nand}', "");
    Expect(0, 72164, '\p{^Is_Sc=nand}', "");
    Expect(0, 72164, '\P{Is_Sc=nand}', "");
    Expect(1, 72164, '\P{^Is_Sc=nand}', "");
    Expect(0, 72165, '\p{Is_Sc=nand}', "");
    Expect(1, 72165, '\p{^Is_Sc=nand}', "");
    Expect(1, 72165, '\P{Is_Sc=nand}', "");
    Expect(0, 72165, '\P{^Is_Sc=nand}', "");
    Expect(1, 72164, '\p{Is_Sc=_ nand}', "");
    Expect(0, 72164, '\p{^Is_Sc=_ nand}', "");
    Expect(0, 72164, '\P{Is_Sc=_ nand}', "");
    Expect(1, 72164, '\P{^Is_Sc=_ nand}', "");
    Expect(0, 72165, '\p{Is_Sc=_ nand}', "");
    Expect(1, 72165, '\p{^Is_Sc=_ nand}', "");
    Expect(1, 72165, '\P{Is_Sc=_ nand}', "");
    Expect(0, 72165, '\P{^Is_Sc=_ nand}', "");
    Error('\p{Script=_OLD_NORTH_Arabian/a/}');
    Error('\P{Script=_OLD_NORTH_Arabian/a/}');
    Expect(1, 68255, '\p{Script=:\AOld_North_Arabian\z:}', "");;
    Expect(0, 68256, '\p{Script=:\AOld_North_Arabian\z:}', "");;
    Expect(1, 68255, '\p{Script=oldnortharabian}', "");
    Expect(0, 68255, '\p{^Script=oldnortharabian}', "");
    Expect(0, 68255, '\P{Script=oldnortharabian}', "");
    Expect(1, 68255, '\P{^Script=oldnortharabian}', "");
    Expect(0, 68256, '\p{Script=oldnortharabian}', "");
    Expect(1, 68256, '\p{^Script=oldnortharabian}', "");
    Expect(1, 68256, '\P{Script=oldnortharabian}', "");
    Expect(0, 68256, '\P{^Script=oldnortharabian}', "");
    Expect(1, 68255, '\p{Script=:\Aoldnortharabian\z:}', "");;
    Expect(0, 68256, '\p{Script=:\Aoldnortharabian\z:}', "");;
    Expect(1, 68255, '\p{Script=-Old_North_ARABIAN}', "");
    Expect(0, 68255, '\p{^Script=-Old_North_ARABIAN}', "");
    Expect(0, 68255, '\P{Script=-Old_North_ARABIAN}', "");
    Expect(1, 68255, '\P{^Script=-Old_North_ARABIAN}', "");
    Expect(0, 68256, '\p{Script=-Old_North_ARABIAN}', "");
    Expect(1, 68256, '\p{^Script=-Old_North_ARABIAN}', "");
    Expect(1, 68256, '\P{Script=-Old_North_ARABIAN}', "");
    Expect(0, 68256, '\P{^Script=-Old_North_ARABIAN}', "");
    Error('\p{Sc:-Narb/a/}');
    Error('\P{Sc:-Narb/a/}');
    Expect(1, 68255, '\p{Sc=:\ANarb\z:}', "");;
    Expect(0, 68256, '\p{Sc=:\ANarb\z:}', "");;
    Expect(1, 68255, '\p{Sc=narb}', "");
    Expect(0, 68255, '\p{^Sc=narb}', "");
    Expect(0, 68255, '\P{Sc=narb}', "");
    Expect(1, 68255, '\P{^Sc=narb}', "");
    Expect(0, 68256, '\p{Sc=narb}', "");
    Expect(1, 68256, '\p{^Sc=narb}', "");
    Expect(1, 68256, '\P{Sc=narb}', "");
    Expect(0, 68256, '\P{^Sc=narb}', "");
    Expect(1, 68255, '\p{Sc=:\Anarb\z:}', "");;
    Expect(0, 68256, '\p{Sc=:\Anarb\z:}', "");;
    Expect(1, 68255, '\p{Sc=	Narb}', "");
    Expect(0, 68255, '\p{^Sc=	Narb}', "");
    Expect(0, 68255, '\P{Sc=	Narb}', "");
    Expect(1, 68255, '\P{^Sc=	Narb}', "");
    Expect(0, 68256, '\p{Sc=	Narb}', "");
    Expect(1, 68256, '\p{^Sc=	Narb}', "");
    Expect(1, 68256, '\P{Sc=	Narb}', "");
    Expect(0, 68256, '\P{^Sc=	Narb}', "");
    Error('\p{Is_Script= _Old_North_arabian:=}');
    Error('\P{Is_Script= _Old_North_arabian:=}');
    Expect(1, 68255, '\p{Is_Script=oldnortharabian}', "");
    Expect(0, 68255, '\p{^Is_Script=oldnortharabian}', "");
    Expect(0, 68255, '\P{Is_Script=oldnortharabian}', "");
    Expect(1, 68255, '\P{^Is_Script=oldnortharabian}', "");
    Expect(0, 68256, '\p{Is_Script=oldnortharabian}', "");
    Expect(1, 68256, '\p{^Is_Script=oldnortharabian}', "");
    Expect(1, 68256, '\P{Is_Script=oldnortharabian}', "");
    Expect(0, 68256, '\P{^Is_Script=oldnortharabian}', "");
    Expect(1, 68255, '\p{Is_Script=--old_North_Arabian}', "");
    Expect(0, 68255, '\p{^Is_Script=--old_North_Arabian}', "");
    Expect(0, 68255, '\P{Is_Script=--old_North_Arabian}', "");
    Expect(1, 68255, '\P{^Is_Script=--old_North_Arabian}', "");
    Expect(0, 68256, '\p{Is_Script=--old_North_Arabian}', "");
    Expect(1, 68256, '\p{^Is_Script=--old_North_Arabian}', "");
    Expect(1, 68256, '\P{Is_Script=--old_North_Arabian}', "");
    Expect(0, 68256, '\P{^Is_Script=--old_North_Arabian}', "");
    Error('\p{Is_Sc=-/a/narb}');
    Error('\P{Is_Sc=-/a/narb}');
    Expect(1, 68255, '\p{Is_Sc=narb}', "");
    Expect(0, 68255, '\p{^Is_Sc=narb}', "");
    Expect(0, 68255, '\P{Is_Sc=narb}', "");
    Expect(1, 68255, '\P{^Is_Sc=narb}', "");
    Expect(0, 68256, '\p{Is_Sc=narb}', "");
    Expect(1, 68256, '\p{^Is_Sc=narb}', "");
    Expect(1, 68256, '\P{Is_Sc=narb}', "");
    Expect(0, 68256, '\P{^Is_Sc=narb}', "");
    Expect(1, 68255, '\p{Is_Sc= -Narb}', "");
    Expect(0, 68255, '\p{^Is_Sc= -Narb}', "");
    Expect(0, 68255, '\P{Is_Sc= -Narb}', "");
    Expect(1, 68255, '\P{^Is_Sc= -Narb}', "");
    Expect(0, 68256, '\p{Is_Sc= -Narb}', "");
    Expect(1, 68256, '\p{^Is_Sc= -Narb}', "");
    Expect(1, 68256, '\P{Is_Sc= -Narb}', "");
    Expect(0, 68256, '\P{^Is_Sc= -Narb}', "");
    Error('\p{Script=	_Nabataean:=}');
    Error('\P{Script=	_Nabataean:=}');
    Expect(1, 67759, '\p{Script=:\ANabataean\z:}', "");;
    Expect(0, 67760, '\p{Script=:\ANabataean\z:}', "");;
    Expect(1, 67759, '\p{Script=nabataean}', "");
    Expect(0, 67759, '\p{^Script=nabataean}', "");
    Expect(0, 67759, '\P{Script=nabataean}', "");
    Expect(1, 67759, '\P{^Script=nabataean}', "");
    Expect(0, 67760, '\p{Script=nabataean}', "");
    Expect(1, 67760, '\p{^Script=nabataean}', "");
    Expect(1, 67760, '\P{Script=nabataean}', "");
    Expect(0, 67760, '\P{^Script=nabataean}', "");
    Expect(1, 67759, '\p{Script=:\Anabataean\z:}', "");;
    Expect(0, 67760, '\p{Script=:\Anabataean\z:}', "");;
    Expect(1, 67759, '\p{Script=  Nabataean}', "");
    Expect(0, 67759, '\p{^Script=  Nabataean}', "");
    Expect(0, 67759, '\P{Script=  Nabataean}', "");
    Expect(1, 67759, '\P{^Script=  Nabataean}', "");
    Expect(0, 67760, '\p{Script=  Nabataean}', "");
    Expect(1, 67760, '\p{^Script=  Nabataean}', "");
    Expect(1, 67760, '\P{Script=  Nabataean}', "");
    Expect(0, 67760, '\P{^Script=  Nabataean}', "");
    Error('\p{Sc=-/a/Nbat}');
    Error('\P{Sc=-/a/Nbat}');
    Expect(1, 67759, '\p{Sc=:\ANbat\z:}', "");;
    Expect(0, 67760, '\p{Sc=:\ANbat\z:}', "");;
    Expect(1, 67759, '\p{Sc=nbat}', "");
    Expect(0, 67759, '\p{^Sc=nbat}', "");
    Expect(0, 67759, '\P{Sc=nbat}', "");
    Expect(1, 67759, '\P{^Sc=nbat}', "");
    Expect(0, 67760, '\p{Sc=nbat}', "");
    Expect(1, 67760, '\p{^Sc=nbat}', "");
    Expect(1, 67760, '\P{Sc=nbat}', "");
    Expect(0, 67760, '\P{^Sc=nbat}', "");
    Expect(1, 67759, '\p{Sc=:\Anbat\z:}', "");;
    Expect(0, 67760, '\p{Sc=:\Anbat\z:}', "");;
    Expect(1, 67759, '\p{Sc=	Nbat}', "");
    Expect(0, 67759, '\p{^Sc=	Nbat}', "");
    Expect(0, 67759, '\P{Sc=	Nbat}', "");
    Expect(1, 67759, '\P{^Sc=	Nbat}', "");
    Expect(0, 67760, '\p{Sc=	Nbat}', "");
    Expect(1, 67760, '\p{^Sc=	Nbat}', "");
    Expect(1, 67760, '\P{Sc=	Nbat}', "");
    Expect(0, 67760, '\P{^Sc=	Nbat}', "");
    Error('\p{Is_Script=:=	_Nabataean}');
    Error('\P{Is_Script=:=	_Nabataean}');
    Expect(1, 67759, '\p{Is_Script=nabataean}', "");
    Expect(0, 67759, '\p{^Is_Script=nabataean}', "");
    Expect(0, 67759, '\P{Is_Script=nabataean}', "");
    Expect(1, 67759, '\P{^Is_Script=nabataean}', "");
    Expect(0, 67760, '\p{Is_Script=nabataean}', "");
    Expect(1, 67760, '\p{^Is_Script=nabataean}', "");
    Expect(1, 67760, '\P{Is_Script=nabataean}', "");
    Expect(0, 67760, '\P{^Is_Script=nabataean}', "");
    Expect(1, 67759, '\p{Is_Script= _NABATAEAN}', "");
    Expect(0, 67759, '\p{^Is_Script= _NABATAEAN}', "");
    Expect(0, 67759, '\P{Is_Script= _NABATAEAN}', "");
    Expect(1, 67759, '\P{^Is_Script= _NABATAEAN}', "");
    Expect(0, 67760, '\p{Is_Script= _NABATAEAN}', "");
    Expect(1, 67760, '\p{^Is_Script= _NABATAEAN}', "");
    Expect(1, 67760, '\P{Is_Script= _NABATAEAN}', "");
    Expect(0, 67760, '\P{^Is_Script= _NABATAEAN}', "");
    Error('\p{Is_Sc=/a/-NBAT}');
    Error('\P{Is_Sc=/a/-NBAT}');
    Expect(1, 67759, '\p{Is_Sc=nbat}', "");
    Expect(0, 67759, '\p{^Is_Sc=nbat}', "");
    Expect(0, 67759, '\P{Is_Sc=nbat}', "");
    Expect(1, 67759, '\P{^Is_Sc=nbat}', "");
    Expect(0, 67760, '\p{Is_Sc=nbat}', "");
    Expect(1, 67760, '\p{^Is_Sc=nbat}', "");
    Expect(1, 67760, '\P{Is_Sc=nbat}', "");
    Expect(0, 67760, '\P{^Is_Sc=nbat}', "");
    Expect(1, 67759, '\p{Is_Sc=--NBAT}', "");
    Expect(0, 67759, '\p{^Is_Sc=--NBAT}', "");
    Expect(0, 67759, '\P{Is_Sc=--NBAT}', "");
    Expect(1, 67759, '\P{^Is_Sc=--NBAT}', "");
    Expect(0, 67760, '\p{Is_Sc=--NBAT}', "");
    Expect(1, 67760, '\p{^Is_Sc=--NBAT}', "");
    Expect(1, 67760, '\P{Is_Sc=--NBAT}', "");
    Expect(0, 67760, '\P{^Is_Sc=--NBAT}', "");
    Error('\p{Script:   :=Newa}');
    Error('\P{Script:   :=Newa}');
    Expect(1, 70753, '\p{Script=:\ANewa\z:}', "");;
    Expect(0, 70754, '\p{Script=:\ANewa\z:}', "");;
    Expect(1, 70753, '\p{Script=newa}', "");
    Expect(0, 70753, '\p{^Script=newa}', "");
    Expect(0, 70753, '\P{Script=newa}', "");
    Expect(1, 70753, '\P{^Script=newa}', "");
    Expect(0, 70754, '\p{Script=newa}', "");
    Expect(1, 70754, '\p{^Script=newa}', "");
    Expect(1, 70754, '\P{Script=newa}', "");
    Expect(0, 70754, '\P{^Script=newa}', "");
    Expect(1, 70753, '\p{Script=:\Anewa\z:}', "");;
    Expect(0, 70754, '\p{Script=:\Anewa\z:}', "");;
    Expect(1, 70753, '\p{Script=_Newa}', "");
    Expect(0, 70753, '\p{^Script=_Newa}', "");
    Expect(0, 70753, '\P{Script=_Newa}', "");
    Expect(1, 70753, '\P{^Script=_Newa}', "");
    Expect(0, 70754, '\p{Script=_Newa}', "");
    Expect(1, 70754, '\p{^Script=_Newa}', "");
    Expect(1, 70754, '\P{Script=_Newa}', "");
    Expect(0, 70754, '\P{^Script=_Newa}', "");
    Error('\p{Sc=__newa/a/}');
    Error('\P{Sc=__newa/a/}');
    Expect(1, 70753, '\p{Sc=:\ANewa\z:}', "");;
    Expect(0, 70754, '\p{Sc=:\ANewa\z:}', "");;
    Expect(1, 70753, '\p{Sc=newa}', "");
    Expect(0, 70753, '\p{^Sc=newa}', "");
    Expect(0, 70753, '\P{Sc=newa}', "");
    Expect(1, 70753, '\P{^Sc=newa}', "");
    Expect(0, 70754, '\p{Sc=newa}', "");
    Expect(1, 70754, '\p{^Sc=newa}', "");
    Expect(1, 70754, '\P{Sc=newa}', "");
    Expect(0, 70754, '\P{^Sc=newa}', "");
    Expect(1, 70753, '\p{Sc=:\Anewa\z:}', "");;
    Expect(0, 70754, '\p{Sc=:\Anewa\z:}', "");;
    Expect(1, 70753, '\p{Sc=--NEWA}', "");
    Expect(0, 70753, '\p{^Sc=--NEWA}', "");
    Expect(0, 70753, '\P{Sc=--NEWA}', "");
    Expect(1, 70753, '\P{^Sc=--NEWA}', "");
    Expect(0, 70754, '\p{Sc=--NEWA}', "");
    Expect(1, 70754, '\p{^Sc=--NEWA}', "");
    Expect(1, 70754, '\P{Sc=--NEWA}', "");
    Expect(0, 70754, '\P{^Sc=--NEWA}', "");
    Error('\p{Is_Script= /a/Newa}');
    Error('\P{Is_Script= /a/Newa}');
    Expect(1, 70753, '\p{Is_Script=newa}', "");
    Expect(0, 70753, '\p{^Is_Script=newa}', "");
    Expect(0, 70753, '\P{Is_Script=newa}', "");
    Expect(1, 70753, '\P{^Is_Script=newa}', "");
    Expect(0, 70754, '\p{Is_Script=newa}', "");
    Expect(1, 70754, '\p{^Is_Script=newa}', "");
    Expect(1, 70754, '\P{Is_Script=newa}', "");
    Expect(0, 70754, '\P{^Is_Script=newa}', "");
    Expect(1, 70753, '\p{Is_Script=	-Newa}', "");
    Expect(0, 70753, '\p{^Is_Script=	-Newa}', "");
    Expect(0, 70753, '\P{Is_Script=	-Newa}', "");
    Expect(1, 70753, '\P{^Is_Script=	-Newa}', "");
    Expect(0, 70754, '\p{Is_Script=	-Newa}', "");
    Expect(1, 70754, '\p{^Is_Script=	-Newa}', "");
    Expect(1, 70754, '\P{Is_Script=	-Newa}', "");
    Expect(0, 70754, '\P{^Is_Script=	-Newa}', "");
    Error('\p{Is_Sc=_/a/newa}');
    Error('\P{Is_Sc=_/a/newa}');
    Expect(1, 70753, '\p{Is_Sc=newa}', "");
    Expect(0, 70753, '\p{^Is_Sc=newa}', "");
    Expect(0, 70753, '\P{Is_Sc=newa}', "");
    Expect(1, 70753, '\P{^Is_Sc=newa}', "");
    Expect(0, 70754, '\p{Is_Sc=newa}', "");
    Expect(1, 70754, '\p{^Is_Sc=newa}', "");
    Expect(1, 70754, '\P{Is_Sc=newa}', "");
    Expect(0, 70754, '\P{^Is_Sc=newa}', "");
    Expect(1, 70753, '\p{Is_Sc=_newa}', "");
    Expect(0, 70753, '\p{^Is_Sc=_newa}', "");
    Expect(0, 70753, '\P{Is_Sc=_newa}', "");
    Expect(1, 70753, '\P{^Is_Sc=_newa}', "");
    Expect(0, 70754, '\p{Is_Sc=_newa}', "");
    Expect(1, 70754, '\p{^Is_Sc=_newa}', "");
    Expect(1, 70754, '\P{Is_Sc=_newa}', "");
    Expect(0, 70754, '\P{^Is_Sc=_newa}', "");
    Error('\p{Script=/a/NKO}');
    Error('\P{Script=/a/NKO}');
    Expect(1, 2047, '\p{Script=:\ANko\z:}', "");;
    Expect(0, 2048, '\p{Script=:\ANko\z:}', "");;
    Expect(1, 2047, '\p{Script=nko}', "");
    Expect(0, 2047, '\p{^Script=nko}', "");
    Expect(0, 2047, '\P{Script=nko}', "");
    Expect(1, 2047, '\P{^Script=nko}', "");
    Expect(0, 2048, '\p{Script=nko}', "");
    Expect(1, 2048, '\p{^Script=nko}', "");
    Expect(1, 2048, '\P{Script=nko}', "");
    Expect(0, 2048, '\P{^Script=nko}', "");
    Expect(1, 2047, '\p{Script=:\Anko\z:}', "");;
    Expect(0, 2048, '\p{Script=:\Anko\z:}', "");;
    Expect(1, 2047, '\p{Script=	 NKO}', "");
    Expect(0, 2047, '\p{^Script=	 NKO}', "");
    Expect(0, 2047, '\P{Script=	 NKO}', "");
    Expect(1, 2047, '\P{^Script=	 NKO}', "");
    Expect(0, 2048, '\p{Script=	 NKO}', "");
    Expect(1, 2048, '\p{^Script=	 NKO}', "");
    Expect(1, 2048, '\P{Script=	 NKO}', "");
    Expect(0, 2048, '\P{^Script=	 NKO}', "");
    Error('\p{Sc=_	nkoo:=}');
    Error('\P{Sc=_	nkoo:=}');
    Expect(1, 2047, '\p{Sc=:\ANkoo\z:}', "");;
    Expect(0, 2048, '\p{Sc=:\ANkoo\z:}', "");;
    Expect(1, 2047, '\p{Sc=nkoo}', "");
    Expect(0, 2047, '\p{^Sc=nkoo}', "");
    Expect(0, 2047, '\P{Sc=nkoo}', "");
    Expect(1, 2047, '\P{^Sc=nkoo}', "");
    Expect(0, 2048, '\p{Sc=nkoo}', "");
    Expect(1, 2048, '\p{^Sc=nkoo}', "");
    Expect(1, 2048, '\P{Sc=nkoo}', "");
    Expect(0, 2048, '\P{^Sc=nkoo}', "");
    Expect(1, 2047, '\p{Sc=:\Ankoo\z:}', "");;
    Expect(0, 2048, '\p{Sc=:\Ankoo\z:}', "");;
    Expect(1, 2047, '\p{Sc= _nkoo}', "");
    Expect(0, 2047, '\p{^Sc= _nkoo}', "");
    Expect(0, 2047, '\P{Sc= _nkoo}', "");
    Expect(1, 2047, '\P{^Sc= _nkoo}', "");
    Expect(0, 2048, '\p{Sc= _nkoo}', "");
    Expect(1, 2048, '\p{^Sc= _nkoo}', "");
    Expect(1, 2048, '\P{Sc= _nkoo}', "");
    Expect(0, 2048, '\P{^Sc= _nkoo}', "");
    Error('\p{Is_Script= Nko/a/}');
    Error('\P{Is_Script= Nko/a/}');
    Expect(1, 2047, '\p{Is_Script:	nko}', "");
    Expect(0, 2047, '\p{^Is_Script:	nko}', "");
    Expect(0, 2047, '\P{Is_Script:	nko}', "");
    Expect(1, 2047, '\P{^Is_Script:	nko}', "");
    Expect(0, 2048, '\p{Is_Script:	nko}', "");
    Expect(1, 2048, '\p{^Is_Script:	nko}', "");
    Expect(1, 2048, '\P{Is_Script:	nko}', "");
    Expect(0, 2048, '\P{^Is_Script:	nko}', "");
    Expect(1, 2047, '\p{Is_Script=_-NKO}', "");
    Expect(0, 2047, '\p{^Is_Script=_-NKO}', "");
    Expect(0, 2047, '\P{Is_Script=_-NKO}', "");
    Expect(1, 2047, '\P{^Is_Script=_-NKO}', "");
    Expect(0, 2048, '\p{Is_Script=_-NKO}', "");
    Expect(1, 2048, '\p{^Is_Script=_-NKO}', "");
    Expect(1, 2048, '\P{Is_Script=_-NKO}', "");
    Expect(0, 2048, '\P{^Is_Script=_-NKO}', "");
    Error('\p{Is_Sc=	/a/Nkoo}');
    Error('\P{Is_Sc=	/a/Nkoo}');
    Expect(1, 2047, '\p{Is_Sc=nkoo}', "");
    Expect(0, 2047, '\p{^Is_Sc=nkoo}', "");
    Expect(0, 2047, '\P{Is_Sc=nkoo}', "");
    Expect(1, 2047, '\P{^Is_Sc=nkoo}', "");
    Expect(0, 2048, '\p{Is_Sc=nkoo}', "");
    Expect(1, 2048, '\p{^Is_Sc=nkoo}', "");
    Expect(1, 2048, '\P{Is_Sc=nkoo}', "");
    Expect(0, 2048, '\P{^Is_Sc=nkoo}', "");
    Expect(1, 2047, '\p{Is_Sc=-NKOO}', "");
    Expect(0, 2047, '\p{^Is_Sc=-NKOO}', "");
    Expect(0, 2047, '\P{Is_Sc=-NKOO}', "");
    Expect(1, 2047, '\P{^Is_Sc=-NKOO}', "");
    Expect(0, 2048, '\p{Is_Sc=-NKOO}', "");
    Expect(1, 2048, '\p{^Is_Sc=-NKOO}', "");
    Expect(1, 2048, '\P{Is_Sc=-NKOO}', "");
    Expect(0, 2048, '\P{^Is_Sc=-NKOO}', "");
    Error('\p{Script=- NUSHU:=}');
    Error('\P{Script=- NUSHU:=}');
    Expect(1, 111355, '\p{Script=:\ANushu\z:}', "");;
    Expect(0, 111356, '\p{Script=:\ANushu\z:}', "");;
    Expect(1, 111355, '\p{Script=nushu}', "");
    Expect(0, 111355, '\p{^Script=nushu}', "");
    Expect(0, 111355, '\P{Script=nushu}', "");
    Expect(1, 111355, '\P{^Script=nushu}', "");
    Expect(0, 111356, '\p{Script=nushu}', "");
    Expect(1, 111356, '\p{^Script=nushu}', "");
    Expect(1, 111356, '\P{Script=nushu}', "");
    Expect(0, 111356, '\P{^Script=nushu}', "");
    Expect(1, 111355, '\p{Script=:\Anushu\z:}', "");;
    Expect(0, 111356, '\p{Script=:\Anushu\z:}', "");;
    Expect(1, 111355, '\p{Script=-	nushu}', "");
    Expect(0, 111355, '\p{^Script=-	nushu}', "");
    Expect(0, 111355, '\P{Script=-	nushu}', "");
    Expect(1, 111355, '\P{^Script=-	nushu}', "");
    Expect(0, 111356, '\p{Script=-	nushu}', "");
    Expect(1, 111356, '\p{^Script=-	nushu}', "");
    Expect(1, 111356, '\P{Script=-	nushu}', "");
    Expect(0, 111356, '\P{^Script=-	nushu}', "");
    Error('\p{Sc=- NSHU:=}');
    Error('\P{Sc=- NSHU:=}');
    Expect(1, 111355, '\p{Sc=:\ANshu\z:}', "");;
    Expect(0, 111356, '\p{Sc=:\ANshu\z:}', "");;
    Expect(1, 111355, '\p{Sc=nshu}', "");
    Expect(0, 111355, '\p{^Sc=nshu}', "");
    Expect(0, 111355, '\P{Sc=nshu}', "");
    Expect(1, 111355, '\P{^Sc=nshu}', "");
    Expect(0, 111356, '\p{Sc=nshu}', "");
    Expect(1, 111356, '\p{^Sc=nshu}', "");
    Expect(1, 111356, '\P{Sc=nshu}', "");
    Expect(0, 111356, '\P{^Sc=nshu}', "");
    Expect(1, 111355, '\p{Sc=:\Anshu\z:}', "");;
    Expect(0, 111356, '\p{Sc=:\Anshu\z:}', "");;
    Expect(1, 111355, '\p{Sc=	Nshu}', "");
    Expect(0, 111355, '\p{^Sc=	Nshu}', "");
    Expect(0, 111355, '\P{Sc=	Nshu}', "");
    Expect(1, 111355, '\P{^Sc=	Nshu}', "");
    Expect(0, 111356, '\p{Sc=	Nshu}', "");
    Expect(1, 111356, '\p{^Sc=	Nshu}', "");
    Expect(1, 111356, '\P{Sc=	Nshu}', "");
    Expect(0, 111356, '\P{^Sc=	Nshu}', "");
    Error('\p{Is_Script=-:=NUSHU}');
    Error('\P{Is_Script=-:=NUSHU}');
    Expect(1, 111355, '\p{Is_Script=nushu}', "");
    Expect(0, 111355, '\p{^Is_Script=nushu}', "");
    Expect(0, 111355, '\P{Is_Script=nushu}', "");
    Expect(1, 111355, '\P{^Is_Script=nushu}', "");
    Expect(0, 111356, '\p{Is_Script=nushu}', "");
    Expect(1, 111356, '\p{^Is_Script=nushu}', "");
    Expect(1, 111356, '\P{Is_Script=nushu}', "");
    Expect(0, 111356, '\P{^Is_Script=nushu}', "");
    Expect(1, 111355, '\p{Is_Script= nushu}', "");
    Expect(0, 111355, '\p{^Is_Script= nushu}', "");
    Expect(0, 111355, '\P{Is_Script= nushu}', "");
    Expect(1, 111355, '\P{^Is_Script= nushu}', "");
    Expect(0, 111356, '\p{Is_Script= nushu}', "");
    Expect(1, 111356, '\p{^Is_Script= nushu}', "");
    Expect(1, 111356, '\P{Is_Script= nushu}', "");
    Expect(0, 111356, '\P{^Is_Script= nushu}', "");
    Error('\p{Is_Sc:   -nshu:=}');
    Error('\P{Is_Sc:   -nshu:=}');
    Expect(1, 111355, '\p{Is_Sc:   nshu}', "");
    Expect(0, 111355, '\p{^Is_Sc:   nshu}', "");
    Expect(0, 111355, '\P{Is_Sc:   nshu}', "");
    Expect(1, 111355, '\P{^Is_Sc:   nshu}', "");
    Expect(0, 111356, '\p{Is_Sc:   nshu}', "");
    Expect(1, 111356, '\p{^Is_Sc:   nshu}', "");
    Expect(1, 111356, '\P{Is_Sc:   nshu}', "");
    Expect(0, 111356, '\P{^Is_Sc:   nshu}', "");
    Expect(1, 111355, '\p{Is_Sc=	-Nshu}', "");
    Expect(0, 111355, '\p{^Is_Sc=	-Nshu}', "");
    Expect(0, 111355, '\P{Is_Sc=	-Nshu}', "");
    Expect(1, 111355, '\P{^Is_Sc=	-Nshu}', "");
    Expect(0, 111356, '\p{Is_Sc=	-Nshu}', "");
    Expect(1, 111356, '\p{^Is_Sc=	-Nshu}', "");
    Expect(1, 111356, '\P{Is_Sc=	-Nshu}', "");
    Expect(0, 111356, '\P{^Is_Sc=	-Nshu}', "");
    Error('\p{Script=	-ogham:=}');
    Error('\P{Script=	-ogham:=}');
    Expect(1, 5788, '\p{Script=:\AOgham\z:}', "");;
    Expect(0, 5789, '\p{Script=:\AOgham\z:}', "");;
    Expect(1, 5788, '\p{Script=ogham}', "");
    Expect(0, 5788, '\p{^Script=ogham}', "");
    Expect(0, 5788, '\P{Script=ogham}', "");
    Expect(1, 5788, '\P{^Script=ogham}', "");
    Expect(0, 5789, '\p{Script=ogham}', "");
    Expect(1, 5789, '\p{^Script=ogham}', "");
    Expect(1, 5789, '\P{Script=ogham}', "");
    Expect(0, 5789, '\P{^Script=ogham}', "");
    Expect(1, 5788, '\p{Script=:\Aogham\z:}', "");;
    Expect(0, 5789, '\p{Script=:\Aogham\z:}', "");;
    Error('\p{Sc=-:=Ogam}');
    Error('\P{Sc=-:=Ogam}');
    Expect(1, 5788, '\p{Sc=:\AOgam\z:}', "");;
    Expect(0, 5789, '\p{Sc=:\AOgam\z:}', "");;
    Expect(1, 5788, '\p{Sc=ogam}', "");
    Expect(0, 5788, '\p{^Sc=ogam}', "");
    Expect(0, 5788, '\P{Sc=ogam}', "");
    Expect(1, 5788, '\P{^Sc=ogam}', "");
    Expect(0, 5789, '\p{Sc=ogam}', "");
    Expect(1, 5789, '\p{^Sc=ogam}', "");
    Expect(1, 5789, '\P{Sc=ogam}', "");
    Expect(0, 5789, '\P{^Sc=ogam}', "");
    Expect(1, 5788, '\p{Sc=:\Aogam\z:}', "");;
    Expect(0, 5789, '\p{Sc=:\Aogam\z:}', "");;
    Expect(1, 5788, '\p{Sc=- ogam}', "");
    Expect(0, 5788, '\p{^Sc=- ogam}', "");
    Expect(0, 5788, '\P{Sc=- ogam}', "");
    Expect(1, 5788, '\P{^Sc=- ogam}', "");
    Expect(0, 5789, '\p{Sc=- ogam}', "");
    Expect(1, 5789, '\p{^Sc=- ogam}', "");
    Expect(1, 5789, '\P{Sc=- ogam}', "");
    Expect(0, 5789, '\P{^Sc=- ogam}', "");
    Error('\p{Is_Script=/a/-_ogham}');
    Error('\P{Is_Script=/a/-_ogham}');
    Expect(1, 5788, '\p{Is_Script=ogham}', "");
    Expect(0, 5788, '\p{^Is_Script=ogham}', "");
    Expect(0, 5788, '\P{Is_Script=ogham}', "");
    Expect(1, 5788, '\P{^Is_Script=ogham}', "");
    Expect(0, 5789, '\p{Is_Script=ogham}', "");
    Expect(1, 5789, '\p{^Is_Script=ogham}', "");
    Expect(1, 5789, '\P{Is_Script=ogham}', "");
    Expect(0, 5789, '\P{^Is_Script=ogham}', "");
    Expect(1, 5788, '\p{Is_Script=  OGHAM}', "");
    Expect(0, 5788, '\p{^Is_Script=  OGHAM}', "");
    Expect(0, 5788, '\P{Is_Script=  OGHAM}', "");
    Expect(1, 5788, '\P{^Is_Script=  OGHAM}', "");
    Expect(0, 5789, '\p{Is_Script=  OGHAM}', "");
    Expect(1, 5789, '\p{^Is_Script=  OGHAM}', "");
    Expect(1, 5789, '\P{Is_Script=  OGHAM}', "");
    Expect(0, 5789, '\P{^Is_Script=  OGHAM}', "");
    Error('\p{Is_Sc=_ Ogam/a/}');
    Error('\P{Is_Sc=_ Ogam/a/}');
    Expect(1, 5788, '\p{Is_Sc=ogam}', "");
    Expect(0, 5788, '\p{^Is_Sc=ogam}', "");
    Expect(0, 5788, '\P{Is_Sc=ogam}', "");
    Expect(1, 5788, '\P{^Is_Sc=ogam}', "");
    Expect(0, 5789, '\p{Is_Sc=ogam}', "");
    Expect(1, 5789, '\p{^Is_Sc=ogam}', "");
    Expect(1, 5789, '\P{Is_Sc=ogam}', "");
    Expect(0, 5789, '\P{^Is_Sc=ogam}', "");
    Expect(1, 5788, '\p{Is_Sc:-Ogam}', "");
    Expect(0, 5788, '\p{^Is_Sc:-Ogam}', "");
    Expect(0, 5788, '\P{Is_Sc:-Ogam}', "");
    Expect(1, 5788, '\P{^Is_Sc:-Ogam}', "");
    Expect(0, 5789, '\p{Is_Sc:-Ogam}', "");
    Expect(1, 5789, '\p{^Is_Sc:-Ogam}', "");
    Expect(1, 5789, '\P{Is_Sc:-Ogam}', "");
    Expect(0, 5789, '\P{^Is_Sc:-Ogam}', "");
    Error('\p{Script=/a/ Ol_Chiki}');
    Error('\P{Script=/a/ Ol_Chiki}');
    Expect(1, 7295, '\p{Script=:\AOl_Chiki\z:}', "");;
    Expect(0, 7296, '\p{Script=:\AOl_Chiki\z:}', "");;
    Expect(1, 7295, '\p{Script=olchiki}', "");
    Expect(0, 7295, '\p{^Script=olchiki}', "");
    Expect(0, 7295, '\P{Script=olchiki}', "");
    Expect(1, 7295, '\P{^Script=olchiki}', "");
    Expect(0, 7296, '\p{Script=olchiki}', "");
    Expect(1, 7296, '\p{^Script=olchiki}', "");
    Expect(1, 7296, '\P{Script=olchiki}', "");
    Expect(0, 7296, '\P{^Script=olchiki}', "");
    Expect(1, 7295, '\p{Script=:\Aolchiki\z:}', "");;
    Expect(0, 7296, '\p{Script=:\Aolchiki\z:}', "");;
    Expect(1, 7295, '\p{Script= -ol_Chiki}', "");
    Expect(0, 7295, '\p{^Script= -ol_Chiki}', "");
    Expect(0, 7295, '\P{Script= -ol_Chiki}', "");
    Expect(1, 7295, '\P{^Script= -ol_Chiki}', "");
    Expect(0, 7296, '\p{Script= -ol_Chiki}', "");
    Expect(1, 7296, '\p{^Script= -ol_Chiki}', "");
    Expect(1, 7296, '\P{Script= -ol_Chiki}', "");
    Expect(0, 7296, '\P{^Script= -ol_Chiki}', "");
    Error('\p{Sc=/a/_-Olck}');
    Error('\P{Sc=/a/_-Olck}');
    Expect(1, 7295, '\p{Sc=:\AOlck\z:}', "");;
    Expect(0, 7296, '\p{Sc=:\AOlck\z:}', "");;
    Expect(1, 7295, '\p{Sc:	olck}', "");
    Expect(0, 7295, '\p{^Sc:	olck}', "");
    Expect(0, 7295, '\P{Sc:	olck}', "");
    Expect(1, 7295, '\P{^Sc:	olck}', "");
    Expect(0, 7296, '\p{Sc:	olck}', "");
    Expect(1, 7296, '\p{^Sc:	olck}', "");
    Expect(1, 7296, '\P{Sc:	olck}', "");
    Expect(0, 7296, '\P{^Sc:	olck}', "");
    Expect(1, 7295, '\p{Sc=:\Aolck\z:}', "");;
    Expect(0, 7296, '\p{Sc=:\Aolck\z:}', "");;
    Expect(1, 7295, '\p{Sc=-olck}', "");
    Expect(0, 7295, '\p{^Sc=-olck}', "");
    Expect(0, 7295, '\P{Sc=-olck}', "");
    Expect(1, 7295, '\P{^Sc=-olck}', "");
    Expect(0, 7296, '\p{Sc=-olck}', "");
    Expect(1, 7296, '\p{^Sc=-olck}', "");
    Expect(1, 7296, '\P{Sc=-olck}', "");
    Expect(0, 7296, '\P{^Sc=-olck}', "");
    Error('\p{Is_Script=:=Ol_Chiki}');
    Error('\P{Is_Script=:=Ol_Chiki}');
    Expect(1, 7295, '\p{Is_Script=olchiki}', "");
    Expect(0, 7295, '\p{^Is_Script=olchiki}', "");
    Expect(0, 7295, '\P{Is_Script=olchiki}', "");
    Expect(1, 7295, '\P{^Is_Script=olchiki}', "");
    Expect(0, 7296, '\p{Is_Script=olchiki}', "");
    Expect(1, 7296, '\p{^Is_Script=olchiki}', "");
    Expect(1, 7296, '\P{Is_Script=olchiki}', "");
    Expect(0, 7296, '\P{^Is_Script=olchiki}', "");
    Expect(1, 7295, '\p{Is_Script=	-OL_Chiki}', "");
    Expect(0, 7295, '\p{^Is_Script=	-OL_Chiki}', "");
    Expect(0, 7295, '\P{Is_Script=	-OL_Chiki}', "");
    Expect(1, 7295, '\P{^Is_Script=	-OL_Chiki}', "");
    Expect(0, 7296, '\p{Is_Script=	-OL_Chiki}', "");
    Expect(1, 7296, '\p{^Is_Script=	-OL_Chiki}', "");
    Expect(1, 7296, '\P{Is_Script=	-OL_Chiki}', "");
    Expect(0, 7296, '\P{^Is_Script=	-OL_Chiki}', "");
    Error('\p{Is_Sc=:= 	olck}');
    Error('\P{Is_Sc=:= 	olck}');
    Expect(1, 7295, '\p{Is_Sc=olck}', "");
    Expect(0, 7295, '\p{^Is_Sc=olck}', "");
    Expect(0, 7295, '\P{Is_Sc=olck}', "");
    Expect(1, 7295, '\P{^Is_Sc=olck}', "");
    Expect(0, 7296, '\p{Is_Sc=olck}', "");
    Expect(1, 7296, '\p{^Is_Sc=olck}', "");
    Expect(1, 7296, '\P{Is_Sc=olck}', "");
    Expect(0, 7296, '\P{^Is_Sc=olck}', "");
    Expect(1, 7295, '\p{Is_Sc=_-Olck}', "");
    Expect(0, 7295, '\p{^Is_Sc=_-Olck}', "");
    Expect(0, 7295, '\P{Is_Sc=_-Olck}', "");
    Expect(1, 7295, '\P{^Is_Sc=_-Olck}', "");
    Expect(0, 7296, '\p{Is_Sc=_-Olck}', "");
    Expect(1, 7296, '\p{^Is_Sc=_-Olck}', "");
    Expect(1, 7296, '\P{Is_Sc=_-Olck}', "");
    Expect(0, 7296, '\P{^Is_Sc=_-Olck}', "");
    Error('\p{Script=-_old_TURKIC:=}');
    Error('\P{Script=-_old_TURKIC:=}');
    Expect(1, 68680, '\p{Script=:\AOld_Turkic\z:}', "");;
    Expect(0, 68681, '\p{Script=:\AOld_Turkic\z:}', "");;
    Expect(1, 68680, '\p{Script=oldturkic}', "");
    Expect(0, 68680, '\p{^Script=oldturkic}', "");
    Expect(0, 68680, '\P{Script=oldturkic}', "");
    Expect(1, 68680, '\P{^Script=oldturkic}', "");
    Expect(0, 68681, '\p{Script=oldturkic}', "");
    Expect(1, 68681, '\p{^Script=oldturkic}', "");
    Expect(1, 68681, '\P{Script=oldturkic}', "");
    Expect(0, 68681, '\P{^Script=oldturkic}', "");
    Expect(1, 68680, '\p{Script=:\Aoldturkic\z:}', "");;
    Expect(0, 68681, '\p{Script=:\Aoldturkic\z:}', "");;
    Expect(1, 68680, '\p{Script:   -_old_Turkic}', "");
    Expect(0, 68680, '\p{^Script:   -_old_Turkic}', "");
    Expect(0, 68680, '\P{Script:   -_old_Turkic}', "");
    Expect(1, 68680, '\P{^Script:   -_old_Turkic}', "");
    Expect(0, 68681, '\p{Script:   -_old_Turkic}', "");
    Expect(1, 68681, '\p{^Script:   -_old_Turkic}', "");
    Expect(1, 68681, '\P{Script:   -_old_Turkic}', "");
    Expect(0, 68681, '\P{^Script:   -_old_Turkic}', "");
    Error('\p{Sc=_ orkh:=}');
    Error('\P{Sc=_ orkh:=}');
    Expect(1, 68680, '\p{Sc=:\AOrkh\z:}', "");;
    Expect(0, 68681, '\p{Sc=:\AOrkh\z:}', "");;
    Expect(1, 68680, '\p{Sc=orkh}', "");
    Expect(0, 68680, '\p{^Sc=orkh}', "");
    Expect(0, 68680, '\P{Sc=orkh}', "");
    Expect(1, 68680, '\P{^Sc=orkh}', "");
    Expect(0, 68681, '\p{Sc=orkh}', "");
    Expect(1, 68681, '\p{^Sc=orkh}', "");
    Expect(1, 68681, '\P{Sc=orkh}', "");
    Expect(0, 68681, '\P{^Sc=orkh}', "");
    Expect(1, 68680, '\p{Sc=:\Aorkh\z:}', "");;
    Expect(0, 68681, '\p{Sc=:\Aorkh\z:}', "");;
    Expect(1, 68680, '\p{Sc=	Orkh}', "");
    Expect(0, 68680, '\p{^Sc=	Orkh}', "");
    Expect(0, 68680, '\P{Sc=	Orkh}', "");
    Expect(1, 68680, '\P{^Sc=	Orkh}', "");
    Expect(0, 68681, '\p{Sc=	Orkh}', "");
    Expect(1, 68681, '\p{^Sc=	Orkh}', "");
    Expect(1, 68681, '\P{Sc=	Orkh}', "");
    Expect(0, 68681, '\P{^Sc=	Orkh}', "");
    Error('\p{Is_Script=-Old_Turkic/a/}');
    Error('\P{Is_Script=-Old_Turkic/a/}');
    Expect(1, 68680, '\p{Is_Script=oldturkic}', "");
    Expect(0, 68680, '\p{^Is_Script=oldturkic}', "");
    Expect(0, 68680, '\P{Is_Script=oldturkic}', "");
    Expect(1, 68680, '\P{^Is_Script=oldturkic}', "");
    Expect(0, 68681, '\p{Is_Script=oldturkic}', "");
    Expect(1, 68681, '\p{^Is_Script=oldturkic}', "");
    Expect(1, 68681, '\P{Is_Script=oldturkic}', "");
    Expect(0, 68681, '\P{^Is_Script=oldturkic}', "");
    Expect(1, 68680, '\p{Is_Script=_ Old_TURKIC}', "");
    Expect(0, 68680, '\p{^Is_Script=_ Old_TURKIC}', "");
    Expect(0, 68680, '\P{Is_Script=_ Old_TURKIC}', "");
    Expect(1, 68680, '\P{^Is_Script=_ Old_TURKIC}', "");
    Expect(0, 68681, '\p{Is_Script=_ Old_TURKIC}', "");
    Expect(1, 68681, '\p{^Is_Script=_ Old_TURKIC}', "");
    Expect(1, 68681, '\P{Is_Script=_ Old_TURKIC}', "");
    Expect(0, 68681, '\P{^Is_Script=_ Old_TURKIC}', "");
    Error('\p{Is_Sc=/a/-orkh}');
    Error('\P{Is_Sc=/a/-orkh}');
    Expect(1, 68680, '\p{Is_Sc=orkh}', "");
    Expect(0, 68680, '\p{^Is_Sc=orkh}', "");
    Expect(0, 68680, '\P{Is_Sc=orkh}', "");
    Expect(1, 68680, '\P{^Is_Sc=orkh}', "");
    Expect(0, 68681, '\p{Is_Sc=orkh}', "");
    Expect(1, 68681, '\p{^Is_Sc=orkh}', "");
    Expect(1, 68681, '\P{Is_Sc=orkh}', "");
    Expect(0, 68681, '\P{^Is_Sc=orkh}', "");
    Expect(1, 68680, '\p{Is_Sc:   _ Orkh}', "");
    Expect(0, 68680, '\p{^Is_Sc:   _ Orkh}', "");
    Expect(0, 68680, '\P{Is_Sc:   _ Orkh}', "");
    Expect(1, 68680, '\P{^Is_Sc:   _ Orkh}', "");
    Expect(0, 68681, '\p{Is_Sc:   _ Orkh}', "");
    Expect(1, 68681, '\p{^Is_Sc:   _ Orkh}', "");
    Expect(1, 68681, '\P{Is_Sc:   _ Orkh}', "");
    Expect(0, 68681, '\P{^Is_Sc:   _ Orkh}', "");
    Error('\p{Script=:=--Oriya}');
    Error('\P{Script=:=--Oriya}');
    Expect(1, 2935, '\p{Script=:\AOriya\z:}', "");;
    Expect(0, 2936, '\p{Script=:\AOriya\z:}', "");;
    Expect(1, 2935, '\p{Script=oriya}', "");
    Expect(0, 2935, '\p{^Script=oriya}', "");
    Expect(0, 2935, '\P{Script=oriya}', "");
    Expect(1, 2935, '\P{^Script=oriya}', "");
    Expect(0, 2936, '\p{Script=oriya}', "");
    Expect(1, 2936, '\p{^Script=oriya}', "");
    Expect(1, 2936, '\P{Script=oriya}', "");
    Expect(0, 2936, '\P{^Script=oriya}', "");
    Expect(1, 2935, '\p{Script=:\Aoriya\z:}', "");;
    Expect(0, 2936, '\p{Script=:\Aoriya\z:}', "");;
    Expect(1, 2935, '\p{Script=	Oriya}', "");
    Expect(0, 2935, '\p{^Script=	Oriya}', "");
    Expect(0, 2935, '\P{Script=	Oriya}', "");
    Expect(1, 2935, '\P{^Script=	Oriya}', "");
    Expect(0, 2936, '\p{Script=	Oriya}', "");
    Expect(1, 2936, '\p{^Script=	Oriya}', "");
    Expect(1, 2936, '\P{Script=	Oriya}', "");
    Expect(0, 2936, '\P{^Script=	Oriya}', "");
    Error('\p{Sc=-:=orya}');
    Error('\P{Sc=-:=orya}');
    Expect(1, 2935, '\p{Sc=:\AOrya\z:}', "");;
    Expect(0, 2936, '\p{Sc=:\AOrya\z:}', "");;
    Expect(1, 2935, '\p{Sc=orya}', "");
    Expect(0, 2935, '\p{^Sc=orya}', "");
    Expect(0, 2935, '\P{Sc=orya}', "");
    Expect(1, 2935, '\P{^Sc=orya}', "");
    Expect(0, 2936, '\p{Sc=orya}', "");
    Expect(1, 2936, '\p{^Sc=orya}', "");
    Expect(1, 2936, '\P{Sc=orya}', "");
    Expect(0, 2936, '\P{^Sc=orya}', "");
    Expect(1, 2935, '\p{Sc=:\Aorya\z:}', "");;
    Expect(0, 2936, '\p{Sc=:\Aorya\z:}', "");;
    Expect(1, 2935, '\p{Sc:  _ORYA}', "");
    Expect(0, 2935, '\p{^Sc:  _ORYA}', "");
    Expect(0, 2935, '\P{Sc:  _ORYA}', "");
    Expect(1, 2935, '\P{^Sc:  _ORYA}', "");
    Expect(0, 2936, '\p{Sc:  _ORYA}', "");
    Expect(1, 2936, '\p{^Sc:  _ORYA}', "");
    Expect(1, 2936, '\P{Sc:  _ORYA}', "");
    Expect(0, 2936, '\P{^Sc:  _ORYA}', "");
    Error('\p{Is_Script=_/a/oriya}');
    Error('\P{Is_Script=_/a/oriya}');
    Expect(1, 2935, '\p{Is_Script=oriya}', "");
    Expect(0, 2935, '\p{^Is_Script=oriya}', "");
    Expect(0, 2935, '\P{Is_Script=oriya}', "");
    Expect(1, 2935, '\P{^Is_Script=oriya}', "");
    Expect(0, 2936, '\p{Is_Script=oriya}', "");
    Expect(1, 2936, '\p{^Is_Script=oriya}', "");
    Expect(1, 2936, '\P{Is_Script=oriya}', "");
    Expect(0, 2936, '\P{^Is_Script=oriya}', "");
    Expect(1, 2935, '\p{Is_Script=_	ORIYA}', "");
    Expect(0, 2935, '\p{^Is_Script=_	ORIYA}', "");
    Expect(0, 2935, '\P{Is_Script=_	ORIYA}', "");
    Expect(1, 2935, '\P{^Is_Script=_	ORIYA}', "");
    Expect(0, 2936, '\p{Is_Script=_	ORIYA}', "");
    Expect(1, 2936, '\p{^Is_Script=_	ORIYA}', "");
    Expect(1, 2936, '\P{Is_Script=_	ORIYA}', "");
    Expect(0, 2936, '\P{^Is_Script=_	ORIYA}', "");
    Error('\p{Is_Sc=-ORYA/a/}');
    Error('\P{Is_Sc=-ORYA/a/}');
    Expect(1, 2935, '\p{Is_Sc=orya}', "");
    Expect(0, 2935, '\p{^Is_Sc=orya}', "");
    Expect(0, 2935, '\P{Is_Sc=orya}', "");
    Expect(1, 2935, '\P{^Is_Sc=orya}', "");
    Expect(0, 2936, '\p{Is_Sc=orya}', "");
    Expect(1, 2936, '\p{^Is_Sc=orya}', "");
    Expect(1, 2936, '\P{Is_Sc=orya}', "");
    Expect(0, 2936, '\P{^Is_Sc=orya}', "");
    Expect(1, 2935, '\p{Is_Sc=	Orya}', "");
    Expect(0, 2935, '\p{^Is_Sc=	Orya}', "");
    Expect(0, 2935, '\P{Is_Sc=	Orya}', "");
    Expect(1, 2935, '\P{^Is_Sc=	Orya}', "");
    Expect(0, 2936, '\p{Is_Sc=	Orya}', "");
    Expect(1, 2936, '\p{^Is_Sc=	Orya}', "");
    Expect(1, 2936, '\P{Is_Sc=	Orya}', "");
    Expect(0, 2936, '\P{^Is_Sc=	Orya}', "");
    Error('\p{Script=/a/--Osage}');
    Error('\P{Script=/a/--Osage}');
    Expect(1, 66811, '\p{Script=:\AOsage\z:}', "");;
    Expect(0, 66812, '\p{Script=:\AOsage\z:}', "");;
    Expect(1, 66811, '\p{Script=osage}', "");
    Expect(0, 66811, '\p{^Script=osage}', "");
    Expect(0, 66811, '\P{Script=osage}', "");
    Expect(1, 66811, '\P{^Script=osage}', "");
    Expect(0, 66812, '\p{Script=osage}', "");
    Expect(1, 66812, '\p{^Script=osage}', "");
    Expect(1, 66812, '\P{Script=osage}', "");
    Expect(0, 66812, '\P{^Script=osage}', "");
    Expect(1, 66811, '\p{Script=:\Aosage\z:}', "");;
    Expect(0, 66812, '\p{Script=:\Aosage\z:}', "");;
    Expect(1, 66811, '\p{Script=--Osage}', "");
    Expect(0, 66811, '\p{^Script=--Osage}', "");
    Expect(0, 66811, '\P{Script=--Osage}', "");
    Expect(1, 66811, '\P{^Script=--Osage}', "");
    Expect(0, 66812, '\p{Script=--Osage}', "");
    Expect(1, 66812, '\p{^Script=--Osage}', "");
    Expect(1, 66812, '\P{Script=--Osage}', "");
    Expect(0, 66812, '\P{^Script=--Osage}', "");
    Error('\p{Sc=/a/__Osge}');
    Error('\P{Sc=/a/__Osge}');
    Expect(1, 66811, '\p{Sc=:\AOsge\z:}', "");;
    Expect(0, 66812, '\p{Sc=:\AOsge\z:}', "");;
    Expect(1, 66811, '\p{Sc=osge}', "");
    Expect(0, 66811, '\p{^Sc=osge}', "");
    Expect(0, 66811, '\P{Sc=osge}', "");
    Expect(1, 66811, '\P{^Sc=osge}', "");
    Expect(0, 66812, '\p{Sc=osge}', "");
    Expect(1, 66812, '\p{^Sc=osge}', "");
    Expect(1, 66812, '\P{Sc=osge}', "");
    Expect(0, 66812, '\P{^Sc=osge}', "");
    Expect(1, 66811, '\p{Sc=:\Aosge\z:}', "");;
    Expect(0, 66812, '\p{Sc=:\Aosge\z:}', "");;
    Expect(1, 66811, '\p{Sc:   _ Osge}', "");
    Expect(0, 66811, '\p{^Sc:   _ Osge}', "");
    Expect(0, 66811, '\P{Sc:   _ Osge}', "");
    Expect(1, 66811, '\P{^Sc:   _ Osge}', "");
    Expect(0, 66812, '\p{Sc:   _ Osge}', "");
    Expect(1, 66812, '\p{^Sc:   _ Osge}', "");
    Expect(1, 66812, '\P{Sc:   _ Osge}', "");
    Expect(0, 66812, '\P{^Sc:   _ Osge}', "");
    Error('\p{Is_Script=/a/__Osage}');
    Error('\P{Is_Script=/a/__Osage}');
    Expect(1, 66811, '\p{Is_Script=osage}', "");
    Expect(0, 66811, '\p{^Is_Script=osage}', "");
    Expect(0, 66811, '\P{Is_Script=osage}', "");
    Expect(1, 66811, '\P{^Is_Script=osage}', "");
    Expect(0, 66812, '\p{Is_Script=osage}', "");
    Expect(1, 66812, '\p{^Is_Script=osage}', "");
    Expect(1, 66812, '\P{Is_Script=osage}', "");
    Expect(0, 66812, '\P{^Is_Script=osage}', "");
    Expect(1, 66811, '\p{Is_Script= OSAGE}', "");
    Expect(0, 66811, '\p{^Is_Script= OSAGE}', "");
    Expect(0, 66811, '\P{Is_Script= OSAGE}', "");
    Expect(1, 66811, '\P{^Is_Script= OSAGE}', "");
    Expect(0, 66812, '\p{Is_Script= OSAGE}', "");
    Expect(1, 66812, '\p{^Is_Script= OSAGE}', "");
    Expect(1, 66812, '\P{Is_Script= OSAGE}', "");
    Expect(0, 66812, '\P{^Is_Script= OSAGE}', "");
    Error('\p{Is_Sc=_	osge:=}');
    Error('\P{Is_Sc=_	osge:=}');
    Expect(1, 66811, '\p{Is_Sc=osge}', "");
    Expect(0, 66811, '\p{^Is_Sc=osge}', "");
    Expect(0, 66811, '\P{Is_Sc=osge}', "");
    Expect(1, 66811, '\P{^Is_Sc=osge}', "");
    Expect(0, 66812, '\p{Is_Sc=osge}', "");
    Expect(1, 66812, '\p{^Is_Sc=osge}', "");
    Expect(1, 66812, '\P{Is_Sc=osge}', "");
    Expect(0, 66812, '\P{^Is_Sc=osge}', "");
    Expect(1, 66811, '\p{Is_Sc= -OSGE}', "");
    Expect(0, 66811, '\p{^Is_Sc= -OSGE}', "");
    Expect(0, 66811, '\P{Is_Sc= -OSGE}', "");
    Expect(1, 66811, '\P{^Is_Sc= -OSGE}', "");
    Expect(0, 66812, '\p{Is_Sc= -OSGE}', "");
    Expect(1, 66812, '\p{^Is_Sc= -OSGE}', "");
    Expect(1, 66812, '\P{Is_Sc= -OSGE}', "");
    Expect(0, 66812, '\P{^Is_Sc= -OSGE}', "");
    Error('\p{Script:	-osmanya:=}');
    Error('\P{Script:	-osmanya:=}');
    Expect(1, 66729, '\p{Script=:\AOsmanya\z:}', "");;
    Expect(0, 66730, '\p{Script=:\AOsmanya\z:}', "");;
    Expect(1, 66729, '\p{Script: osmanya}', "");
    Expect(0, 66729, '\p{^Script: osmanya}', "");
    Expect(0, 66729, '\P{Script: osmanya}', "");
    Expect(1, 66729, '\P{^Script: osmanya}', "");
    Expect(0, 66730, '\p{Script: osmanya}', "");
    Expect(1, 66730, '\p{^Script: osmanya}', "");
    Expect(1, 66730, '\P{Script: osmanya}', "");
    Expect(0, 66730, '\P{^Script: osmanya}', "");
    Expect(1, 66729, '\p{Script=:\Aosmanya\z:}', "");;
    Expect(0, 66730, '\p{Script=:\Aosmanya\z:}', "");;
    Expect(1, 66729, '\p{Script=-OSMANYA}', "");
    Expect(0, 66729, '\p{^Script=-OSMANYA}', "");
    Expect(0, 66729, '\P{Script=-OSMANYA}', "");
    Expect(1, 66729, '\P{^Script=-OSMANYA}', "");
    Expect(0, 66730, '\p{Script=-OSMANYA}', "");
    Expect(1, 66730, '\p{^Script=-OSMANYA}', "");
    Expect(1, 66730, '\P{Script=-OSMANYA}', "");
    Expect(0, 66730, '\P{^Script=-OSMANYA}', "");
    Error('\p{Sc=	:=Osma}');
    Error('\P{Sc=	:=Osma}');
    Expect(1, 66729, '\p{Sc=:\AOsma\z:}', "");;
    Expect(0, 66730, '\p{Sc=:\AOsma\z:}', "");;
    Expect(1, 66729, '\p{Sc:   osma}', "");
    Expect(0, 66729, '\p{^Sc:   osma}', "");
    Expect(0, 66729, '\P{Sc:   osma}', "");
    Expect(1, 66729, '\P{^Sc:   osma}', "");
    Expect(0, 66730, '\p{Sc:   osma}', "");
    Expect(1, 66730, '\p{^Sc:   osma}', "");
    Expect(1, 66730, '\P{Sc:   osma}', "");
    Expect(0, 66730, '\P{^Sc:   osma}', "");
    Expect(1, 66729, '\p{Sc=:\Aosma\z:}', "");;
    Expect(0, 66730, '\p{Sc=:\Aosma\z:}', "");;
    Expect(1, 66729, '\p{Sc=-_Osma}', "");
    Expect(0, 66729, '\p{^Sc=-_Osma}', "");
    Expect(0, 66729, '\P{Sc=-_Osma}', "");
    Expect(1, 66729, '\P{^Sc=-_Osma}', "");
    Expect(0, 66730, '\p{Sc=-_Osma}', "");
    Expect(1, 66730, '\p{^Sc=-_Osma}', "");
    Expect(1, 66730, '\P{Sc=-_Osma}', "");
    Expect(0, 66730, '\P{^Sc=-_Osma}', "");
    Error('\p{Is_Script:	/a/ Osmanya}');
    Error('\P{Is_Script:	/a/ Osmanya}');
    Expect(1, 66729, '\p{Is_Script=osmanya}', "");
    Expect(0, 66729, '\p{^Is_Script=osmanya}', "");
    Expect(0, 66729, '\P{Is_Script=osmanya}', "");
    Expect(1, 66729, '\P{^Is_Script=osmanya}', "");
    Expect(0, 66730, '\p{Is_Script=osmanya}', "");
    Expect(1, 66730, '\p{^Is_Script=osmanya}', "");
    Expect(1, 66730, '\P{Is_Script=osmanya}', "");
    Expect(0, 66730, '\P{^Is_Script=osmanya}', "");
    Expect(1, 66729, '\p{Is_Script=Osmanya}', "");
    Expect(0, 66729, '\p{^Is_Script=Osmanya}', "");
    Expect(0, 66729, '\P{Is_Script=Osmanya}', "");
    Expect(1, 66729, '\P{^Is_Script=Osmanya}', "");
    Expect(0, 66730, '\p{Is_Script=Osmanya}', "");
    Expect(1, 66730, '\p{^Is_Script=Osmanya}', "");
    Expect(1, 66730, '\P{Is_Script=Osmanya}', "");
    Expect(0, 66730, '\P{^Is_Script=Osmanya}', "");
    Error('\p{Is_Sc: /a/Osma}');
    Error('\P{Is_Sc: /a/Osma}');
    Expect(1, 66729, '\p{Is_Sc=osma}', "");
    Expect(0, 66729, '\p{^Is_Sc=osma}', "");
    Expect(0, 66729, '\P{Is_Sc=osma}', "");
    Expect(1, 66729, '\P{^Is_Sc=osma}', "");
    Expect(0, 66730, '\p{Is_Sc=osma}', "");
    Expect(1, 66730, '\p{^Is_Sc=osma}', "");
    Expect(1, 66730, '\P{Is_Sc=osma}', "");
    Expect(0, 66730, '\P{^Is_Sc=osma}', "");
    Expect(1, 66729, '\p{Is_Sc=-_Osma}', "");
    Expect(0, 66729, '\p{^Is_Sc=-_Osma}', "");
    Expect(0, 66729, '\P{Is_Sc=-_Osma}', "");
    Expect(1, 66729, '\P{^Is_Sc=-_Osma}', "");
    Expect(0, 66730, '\p{Is_Sc=-_Osma}', "");
    Expect(1, 66730, '\p{^Is_Sc=-_Osma}', "");
    Expect(1, 66730, '\P{Is_Sc=-_Osma}', "");
    Expect(0, 66730, '\P{^Is_Sc=-_Osma}', "");
    Error('\p{Script=/a/_old_Uyghur}');
    Error('\P{Script=/a/_old_Uyghur}');
    Expect(1, 69513, '\p{Script=:\AOld_Uyghur\z:}', "");;
    Expect(0, 69514, '\p{Script=:\AOld_Uyghur\z:}', "");;
    Expect(1, 69513, '\p{Script=olduyghur}', "");
    Expect(0, 69513, '\p{^Script=olduyghur}', "");
    Expect(0, 69513, '\P{Script=olduyghur}', "");
    Expect(1, 69513, '\P{^Script=olduyghur}', "");
    Expect(0, 69514, '\p{Script=olduyghur}', "");
    Expect(1, 69514, '\p{^Script=olduyghur}', "");
    Expect(1, 69514, '\P{Script=olduyghur}', "");
    Expect(0, 69514, '\P{^Script=olduyghur}', "");
    Expect(1, 69513, '\p{Script=:\Aolduyghur\z:}', "");;
    Expect(0, 69514, '\p{Script=:\Aolduyghur\z:}', "");;
    Expect(1, 69513, '\p{Script= _Old_uyghur}', "");
    Expect(0, 69513, '\p{^Script= _Old_uyghur}', "");
    Expect(0, 69513, '\P{Script= _Old_uyghur}', "");
    Expect(1, 69513, '\P{^Script= _Old_uyghur}', "");
    Expect(0, 69514, '\p{Script= _Old_uyghur}', "");
    Expect(1, 69514, '\p{^Script= _Old_uyghur}', "");
    Expect(1, 69514, '\P{Script= _Old_uyghur}', "");
    Expect(0, 69514, '\P{^Script= _Old_uyghur}', "");
    Error('\p{Sc=:=Ougr}');
    Error('\P{Sc=:=Ougr}');
    Expect(1, 69513, '\p{Sc=:\AOugr\z:}', "");;
    Expect(0, 69514, '\p{Sc=:\AOugr\z:}', "");;
    Expect(1, 69513, '\p{Sc=ougr}', "");
    Expect(0, 69513, '\p{^Sc=ougr}', "");
    Expect(0, 69513, '\P{Sc=ougr}', "");
    Expect(1, 69513, '\P{^Sc=ougr}', "");
    Expect(0, 69514, '\p{Sc=ougr}', "");
    Expect(1, 69514, '\p{^Sc=ougr}', "");
    Expect(1, 69514, '\P{Sc=ougr}', "");
    Expect(0, 69514, '\P{^Sc=ougr}', "");
    Expect(1, 69513, '\p{Sc=:\Aougr\z:}', "");;
    Expect(0, 69514, '\p{Sc=:\Aougr\z:}', "");;
    Expect(1, 69513, '\p{Sc= _Ougr}', "");
    Expect(0, 69513, '\p{^Sc= _Ougr}', "");
    Expect(0, 69513, '\P{Sc= _Ougr}', "");
    Expect(1, 69513, '\P{^Sc= _Ougr}', "");
    Expect(0, 69514, '\p{Sc= _Ougr}', "");
    Expect(1, 69514, '\p{^Sc= _Ougr}', "");
    Expect(1, 69514, '\P{Sc= _Ougr}', "");
    Expect(0, 69514, '\P{^Sc= _Ougr}', "");
    Error('\p{Is_Script=	:=old_Uyghur}');
    Error('\P{Is_Script=	:=old_Uyghur}');
    Expect(1, 69513, '\p{Is_Script=olduyghur}', "");
    Expect(0, 69513, '\p{^Is_Script=olduyghur}', "");
    Expect(0, 69513, '\P{Is_Script=olduyghur}', "");
    Expect(1, 69513, '\P{^Is_Script=olduyghur}', "");
    Expect(0, 69514, '\p{Is_Script=olduyghur}', "");
    Expect(1, 69514, '\p{^Is_Script=olduyghur}', "");
    Expect(1, 69514, '\P{Is_Script=olduyghur}', "");
    Expect(0, 69514, '\P{^Is_Script=olduyghur}', "");
    Expect(1, 69513, '\p{Is_Script=-	Old_Uyghur}', "");
    Expect(0, 69513, '\p{^Is_Script=-	Old_Uyghur}', "");
    Expect(0, 69513, '\P{Is_Script=-	Old_Uyghur}', "");
    Expect(1, 69513, '\P{^Is_Script=-	Old_Uyghur}', "");
    Expect(0, 69514, '\p{Is_Script=-	Old_Uyghur}', "");
    Expect(1, 69514, '\p{^Is_Script=-	Old_Uyghur}', "");
    Expect(1, 69514, '\P{Is_Script=-	Old_Uyghur}', "");
    Expect(0, 69514, '\P{^Is_Script=-	Old_Uyghur}', "");
    Error('\p{Is_Sc=	:=ougr}');
    Error('\P{Is_Sc=	:=ougr}');
    Expect(1, 69513, '\p{Is_Sc=ougr}', "");
    Expect(0, 69513, '\p{^Is_Sc=ougr}', "");
    Expect(0, 69513, '\P{Is_Sc=ougr}', "");
    Expect(1, 69513, '\P{^Is_Sc=ougr}', "");
    Expect(0, 69514, '\p{Is_Sc=ougr}', "");
    Expect(1, 69514, '\p{^Is_Sc=ougr}', "");
    Expect(1, 69514, '\P{Is_Sc=ougr}', "");
    Expect(0, 69514, '\P{^Is_Sc=ougr}', "");
    Expect(1, 69513, '\p{Is_Sc=--OUGR}', "");
    Expect(0, 69513, '\p{^Is_Sc=--OUGR}', "");
    Expect(0, 69513, '\P{Is_Sc=--OUGR}', "");
    Expect(1, 69513, '\P{^Is_Sc=--OUGR}', "");
    Expect(0, 69514, '\p{Is_Sc=--OUGR}', "");
    Expect(1, 69514, '\p{^Is_Sc=--OUGR}', "");
    Expect(1, 69514, '\P{Is_Sc=--OUGR}', "");
    Expect(0, 69514, '\P{^Is_Sc=--OUGR}', "");
    Error('\p{Script=-:=palmyrene}');
    Error('\P{Script=-:=palmyrene}');
    Expect(1, 67711, '\p{Script=:\APalmyrene\z:}', "");;
    Expect(0, 67712, '\p{Script=:\APalmyrene\z:}', "");;
    Expect(1, 67711, '\p{Script=palmyrene}', "");
    Expect(0, 67711, '\p{^Script=palmyrene}', "");
    Expect(0, 67711, '\P{Script=palmyrene}', "");
    Expect(1, 67711, '\P{^Script=palmyrene}', "");
    Expect(0, 67712, '\p{Script=palmyrene}', "");
    Expect(1, 67712, '\p{^Script=palmyrene}', "");
    Expect(1, 67712, '\P{Script=palmyrene}', "");
    Expect(0, 67712, '\P{^Script=palmyrene}', "");
    Expect(1, 67711, '\p{Script=:\Apalmyrene\z:}', "");;
    Expect(0, 67712, '\p{Script=:\Apalmyrene\z:}', "");;
    Expect(1, 67711, '\p{Script:	Palmyrene}', "");
    Expect(0, 67711, '\p{^Script:	Palmyrene}', "");
    Expect(0, 67711, '\P{Script:	Palmyrene}', "");
    Expect(1, 67711, '\P{^Script:	Palmyrene}', "");
    Expect(0, 67712, '\p{Script:	Palmyrene}', "");
    Expect(1, 67712, '\p{^Script:	Palmyrene}', "");
    Expect(1, 67712, '\P{Script:	Palmyrene}', "");
    Expect(0, 67712, '\P{^Script:	Palmyrene}', "");
    Error('\p{Sc=  palm/a/}');
    Error('\P{Sc=  palm/a/}');
    Expect(1, 67711, '\p{Sc=:\APalm\z:}', "");;
    Expect(0, 67712, '\p{Sc=:\APalm\z:}', "");;
    Expect(1, 67711, '\p{Sc=palm}', "");
    Expect(0, 67711, '\p{^Sc=palm}', "");
    Expect(0, 67711, '\P{Sc=palm}', "");
    Expect(1, 67711, '\P{^Sc=palm}', "");
    Expect(0, 67712, '\p{Sc=palm}', "");
    Expect(1, 67712, '\p{^Sc=palm}', "");
    Expect(1, 67712, '\P{Sc=palm}', "");
    Expect(0, 67712, '\P{^Sc=palm}', "");
    Expect(1, 67711, '\p{Sc=:\Apalm\z:}', "");;
    Expect(0, 67712, '\p{Sc=:\Apalm\z:}', "");;
    Expect(1, 67711, '\p{Sc=_palm}', "");
    Expect(0, 67711, '\p{^Sc=_palm}', "");
    Expect(0, 67711, '\P{Sc=_palm}', "");
    Expect(1, 67711, '\P{^Sc=_palm}', "");
    Expect(0, 67712, '\p{Sc=_palm}', "");
    Expect(1, 67712, '\p{^Sc=_palm}', "");
    Expect(1, 67712, '\P{Sc=_palm}', "");
    Expect(0, 67712, '\P{^Sc=_palm}', "");
    Error('\p{Is_Script=:=_	PALMYRENE}');
    Error('\P{Is_Script=:=_	PALMYRENE}');
    Expect(1, 67711, '\p{Is_Script=palmyrene}', "");
    Expect(0, 67711, '\p{^Is_Script=palmyrene}', "");
    Expect(0, 67711, '\P{Is_Script=palmyrene}', "");
    Expect(1, 67711, '\P{^Is_Script=palmyrene}', "");
    Expect(0, 67712, '\p{Is_Script=palmyrene}', "");
    Expect(1, 67712, '\p{^Is_Script=palmyrene}', "");
    Expect(1, 67712, '\P{Is_Script=palmyrene}', "");
    Expect(0, 67712, '\P{^Is_Script=palmyrene}', "");
    Expect(1, 67711, '\p{Is_Script=_palmyrene}', "");
    Expect(0, 67711, '\p{^Is_Script=_palmyrene}', "");
    Expect(0, 67711, '\P{Is_Script=_palmyrene}', "");
    Expect(1, 67711, '\P{^Is_Script=_palmyrene}', "");
    Expect(0, 67712, '\p{Is_Script=_palmyrene}', "");
    Expect(1, 67712, '\p{^Is_Script=_palmyrene}', "");
    Expect(1, 67712, '\P{Is_Script=_palmyrene}', "");
    Expect(0, 67712, '\P{^Is_Script=_palmyrene}', "");
    Error('\p{Is_Sc=-:=palm}');
    Error('\P{Is_Sc=-:=palm}');
    Expect(1, 67711, '\p{Is_Sc=palm}', "");
    Expect(0, 67711, '\p{^Is_Sc=palm}', "");
    Expect(0, 67711, '\P{Is_Sc=palm}', "");
    Expect(1, 67711, '\P{^Is_Sc=palm}', "");
    Expect(0, 67712, '\p{Is_Sc=palm}', "");
    Expect(1, 67712, '\p{^Is_Sc=palm}', "");
    Expect(1, 67712, '\P{Is_Sc=palm}', "");
    Expect(0, 67712, '\P{^Is_Sc=palm}', "");
    Expect(1, 67711, '\p{Is_Sc=	Palm}', "");
    Expect(0, 67711, '\p{^Is_Sc=	Palm}', "");
    Expect(0, 67711, '\P{Is_Sc=	Palm}', "");
    Expect(1, 67711, '\P{^Is_Sc=	Palm}', "");
    Expect(0, 67712, '\p{Is_Sc=	Palm}', "");
    Expect(1, 67712, '\p{^Is_Sc=	Palm}', "");
    Expect(1, 67712, '\P{Is_Sc=	Palm}', "");
    Expect(0, 67712, '\P{^Is_Sc=	Palm}', "");
    Error('\p{Script=		Pau_CIN_HAU/a/}');
    Error('\P{Script=		Pau_CIN_HAU/a/}');
    Expect(1, 72440, '\p{Script=:\APau_Cin_Hau\z:}', "");;
    Expect(0, 72441, '\p{Script=:\APau_Cin_Hau\z:}', "");;
    Expect(1, 72440, '\p{Script=paucinhau}', "");
    Expect(0, 72440, '\p{^Script=paucinhau}', "");
    Expect(0, 72440, '\P{Script=paucinhau}', "");
    Expect(1, 72440, '\P{^Script=paucinhau}', "");
    Expect(0, 72441, '\p{Script=paucinhau}', "");
    Expect(1, 72441, '\p{^Script=paucinhau}', "");
    Expect(1, 72441, '\P{Script=paucinhau}', "");
    Expect(0, 72441, '\P{^Script=paucinhau}', "");
    Expect(1, 72440, '\p{Script=:\Apaucinhau\z:}', "");;
    Expect(0, 72441, '\p{Script=:\Apaucinhau\z:}', "");;
    Expect(1, 72440, '\p{Script=	-PAU_cin_HAU}', "");
    Expect(0, 72440, '\p{^Script=	-PAU_cin_HAU}', "");
    Expect(0, 72440, '\P{Script=	-PAU_cin_HAU}', "");
    Expect(1, 72440, '\P{^Script=	-PAU_cin_HAU}', "");
    Expect(0, 72441, '\p{Script=	-PAU_cin_HAU}', "");
    Expect(1, 72441, '\p{^Script=	-PAU_cin_HAU}', "");
    Expect(1, 72441, '\P{Script=	-PAU_cin_HAU}', "");
    Expect(0, 72441, '\P{^Script=	-PAU_cin_HAU}', "");
    Error('\p{Sc=/a/ PAUC}');
    Error('\P{Sc=/a/ PAUC}');
    Expect(1, 72440, '\p{Sc=:\APauc\z:}', "");;
    Expect(0, 72441, '\p{Sc=:\APauc\z:}', "");;
    Expect(1, 72440, '\p{Sc=pauc}', "");
    Expect(0, 72440, '\p{^Sc=pauc}', "");
    Expect(0, 72440, '\P{Sc=pauc}', "");
    Expect(1, 72440, '\P{^Sc=pauc}', "");
    Expect(0, 72441, '\p{Sc=pauc}', "");
    Expect(1, 72441, '\p{^Sc=pauc}', "");
    Expect(1, 72441, '\P{Sc=pauc}', "");
    Expect(0, 72441, '\P{^Sc=pauc}', "");
    Expect(1, 72440, '\p{Sc=:\Apauc\z:}', "");;
    Expect(0, 72441, '\p{Sc=:\Apauc\z:}', "");;
    Expect(1, 72440, '\p{Sc:   - Pauc}', "");
    Expect(0, 72440, '\p{^Sc:   - Pauc}', "");
    Expect(0, 72440, '\P{Sc:   - Pauc}', "");
    Expect(1, 72440, '\P{^Sc:   - Pauc}', "");
    Expect(0, 72441, '\p{Sc:   - Pauc}', "");
    Expect(1, 72441, '\p{^Sc:   - Pauc}', "");
    Expect(1, 72441, '\P{Sc:   - Pauc}', "");
    Expect(0, 72441, '\P{^Sc:   - Pauc}', "");
    Error('\p{Is_Script=_Pau_cin_HAU:=}');
    Error('\P{Is_Script=_Pau_cin_HAU:=}');
    Expect(1, 72440, '\p{Is_Script:paucinhau}', "");
    Expect(0, 72440, '\p{^Is_Script:paucinhau}', "");
    Expect(0, 72440, '\P{Is_Script:paucinhau}', "");
    Expect(1, 72440, '\P{^Is_Script:paucinhau}', "");
    Expect(0, 72441, '\p{Is_Script:paucinhau}', "");
    Expect(1, 72441, '\p{^Is_Script:paucinhau}', "");
    Expect(1, 72441, '\P{Is_Script:paucinhau}', "");
    Expect(0, 72441, '\P{^Is_Script:paucinhau}', "");
    Expect(1, 72440, '\p{Is_Script=-	Pau_cin_hau}', "");
    Expect(0, 72440, '\p{^Is_Script=-	Pau_cin_hau}', "");
    Expect(0, 72440, '\P{Is_Script=-	Pau_cin_hau}', "");
    Expect(1, 72440, '\P{^Is_Script=-	Pau_cin_hau}', "");
    Expect(0, 72441, '\p{Is_Script=-	Pau_cin_hau}', "");
    Expect(1, 72441, '\p{^Is_Script=-	Pau_cin_hau}', "");
    Expect(1, 72441, '\P{Is_Script=-	Pau_cin_hau}', "");
    Expect(0, 72441, '\P{^Is_Script=-	Pau_cin_hau}', "");
    Error('\p{Is_Sc: 	:=Pauc}');
    Error('\P{Is_Sc: 	:=Pauc}');
    Expect(1, 72440, '\p{Is_Sc=pauc}', "");
    Expect(0, 72440, '\p{^Is_Sc=pauc}', "");
    Expect(0, 72440, '\P{Is_Sc=pauc}', "");
    Expect(1, 72440, '\P{^Is_Sc=pauc}', "");
    Expect(0, 72441, '\p{Is_Sc=pauc}', "");
    Expect(1, 72441, '\p{^Is_Sc=pauc}', "");
    Expect(1, 72441, '\P{Is_Sc=pauc}', "");
    Expect(0, 72441, '\P{^Is_Sc=pauc}', "");
    Expect(1, 72440, '\p{Is_Sc= Pauc}', "");
    Expect(0, 72440, '\p{^Is_Sc= Pauc}', "");
    Expect(0, 72440, '\P{Is_Sc= Pauc}', "");
    Expect(1, 72440, '\P{^Is_Sc= Pauc}', "");
    Expect(0, 72441, '\p{Is_Sc= Pauc}', "");
    Expect(1, 72441, '\p{^Is_Sc= Pauc}', "");
    Expect(1, 72441, '\P{Is_Sc= Pauc}', "");
    Expect(0, 72441, '\P{^Is_Sc= Pauc}', "");
    Error('\p{Script=:=--OLD_PERMIC}');
    Error('\P{Script=:=--OLD_PERMIC}');
    Expect(1, 66426, '\p{Script=:\AOld_Permic\z:}', "");;
    Expect(0, 66427, '\p{Script=:\AOld_Permic\z:}', "");;
    Expect(1, 66426, '\p{Script=oldpermic}', "");
    Expect(0, 66426, '\p{^Script=oldpermic}', "");
    Expect(0, 66426, '\P{Script=oldpermic}', "");
    Expect(1, 66426, '\P{^Script=oldpermic}', "");
    Expect(0, 66427, '\p{Script=oldpermic}', "");
    Expect(1, 66427, '\p{^Script=oldpermic}', "");
    Expect(1, 66427, '\P{Script=oldpermic}', "");
    Expect(0, 66427, '\P{^Script=oldpermic}', "");
    Expect(1, 66426, '\p{Script=:\Aoldpermic\z:}', "");;
    Expect(0, 66427, '\p{Script=:\Aoldpermic\z:}', "");;
    Expect(1, 66426, '\p{Script=	OLD_Permic}', "");
    Expect(0, 66426, '\p{^Script=	OLD_Permic}', "");
    Expect(0, 66426, '\P{Script=	OLD_Permic}', "");
    Expect(1, 66426, '\P{^Script=	OLD_Permic}', "");
    Expect(0, 66427, '\p{Script=	OLD_Permic}', "");
    Expect(1, 66427, '\p{^Script=	OLD_Permic}', "");
    Expect(1, 66427, '\P{Script=	OLD_Permic}', "");
    Expect(0, 66427, '\P{^Script=	OLD_Permic}', "");
    Error('\p{Sc=/a/PERM}');
    Error('\P{Sc=/a/PERM}');
    Expect(1, 66426, '\p{Sc=:\APerm\z:}', "");;
    Expect(0, 66427, '\p{Sc=:\APerm\z:}', "");;
    Expect(1, 66426, '\p{Sc=perm}', "");
    Expect(0, 66426, '\p{^Sc=perm}', "");
    Expect(0, 66426, '\P{Sc=perm}', "");
    Expect(1, 66426, '\P{^Sc=perm}', "");
    Expect(0, 66427, '\p{Sc=perm}', "");
    Expect(1, 66427, '\p{^Sc=perm}', "");
    Expect(1, 66427, '\P{Sc=perm}', "");
    Expect(0, 66427, '\P{^Sc=perm}', "");
    Expect(1, 66426, '\p{Sc=:\Aperm\z:}', "");;
    Expect(0, 66427, '\p{Sc=:\Aperm\z:}', "");;
    Expect(1, 66426, '\p{Sc=-perm}', "");
    Expect(0, 66426, '\p{^Sc=-perm}', "");
    Expect(0, 66426, '\P{Sc=-perm}', "");
    Expect(1, 66426, '\P{^Sc=-perm}', "");
    Expect(0, 66427, '\p{Sc=-perm}', "");
    Expect(1, 66427, '\p{^Sc=-perm}', "");
    Expect(1, 66427, '\P{Sc=-perm}', "");
    Expect(0, 66427, '\P{^Sc=-perm}', "");
    Error('\p{Is_Script=:=	Old_Permic}');
    Error('\P{Is_Script=:=	Old_Permic}');
    Expect(1, 66426, '\p{Is_Script:   oldpermic}', "");
    Expect(0, 66426, '\p{^Is_Script:   oldpermic}', "");
    Expect(0, 66426, '\P{Is_Script:   oldpermic}', "");
    Expect(1, 66426, '\P{^Is_Script:   oldpermic}', "");
    Expect(0, 66427, '\p{Is_Script:   oldpermic}', "");
    Expect(1, 66427, '\p{^Is_Script:   oldpermic}', "");
    Expect(1, 66427, '\P{Is_Script:   oldpermic}', "");
    Expect(0, 66427, '\P{^Is_Script:   oldpermic}', "");
    Expect(1, 66426, '\p{Is_Script=-Old_Permic}', "");
    Expect(0, 66426, '\p{^Is_Script=-Old_Permic}', "");
    Expect(0, 66426, '\P{Is_Script=-Old_Permic}', "");
    Expect(1, 66426, '\P{^Is_Script=-Old_Permic}', "");
    Expect(0, 66427, '\p{Is_Script=-Old_Permic}', "");
    Expect(1, 66427, '\p{^Is_Script=-Old_Permic}', "");
    Expect(1, 66427, '\P{Is_Script=-Old_Permic}', "");
    Expect(0, 66427, '\P{^Is_Script=-Old_Permic}', "");
    Error('\p{Is_Sc=_	Perm/a/}');
    Error('\P{Is_Sc=_	Perm/a/}');
    Expect(1, 66426, '\p{Is_Sc=perm}', "");
    Expect(0, 66426, '\p{^Is_Sc=perm}', "");
    Expect(0, 66426, '\P{Is_Sc=perm}', "");
    Expect(1, 66426, '\P{^Is_Sc=perm}', "");
    Expect(0, 66427, '\p{Is_Sc=perm}', "");
    Expect(1, 66427, '\p{^Is_Sc=perm}', "");
    Expect(1, 66427, '\P{Is_Sc=perm}', "");
    Expect(0, 66427, '\P{^Is_Sc=perm}', "");
    Expect(1, 66426, '\p{Is_Sc=_ Perm}', "");
    Expect(0, 66426, '\p{^Is_Sc=_ Perm}', "");
    Expect(0, 66426, '\P{Is_Sc=_ Perm}', "");
    Expect(1, 66426, '\P{^Is_Sc=_ Perm}', "");
    Expect(0, 66427, '\p{Is_Sc=_ Perm}', "");
    Expect(1, 66427, '\p{^Is_Sc=_ Perm}', "");
    Expect(1, 66427, '\P{Is_Sc=_ Perm}', "");
    Expect(0, 66427, '\P{^Is_Sc=_ Perm}', "");
    Error('\p{Script:_-Phags_Pa/a/}');
    Error('\P{Script:_-Phags_Pa/a/}');
    Expect(1, 43127, '\p{Script=:\APhags_Pa\z:}', "");;
    Expect(0, 43128, '\p{Script=:\APhags_Pa\z:}', "");;
    Expect(1, 43127, '\p{Script=phagspa}', "");
    Expect(0, 43127, '\p{^Script=phagspa}', "");
    Expect(0, 43127, '\P{Script=phagspa}', "");
    Expect(1, 43127, '\P{^Script=phagspa}', "");
    Expect(0, 43128, '\p{Script=phagspa}', "");
    Expect(1, 43128, '\p{^Script=phagspa}', "");
    Expect(1, 43128, '\P{Script=phagspa}', "");
    Expect(0, 43128, '\P{^Script=phagspa}', "");
    Expect(1, 43127, '\p{Script=:\Aphagspa\z:}', "");;
    Expect(0, 43128, '\p{Script=:\Aphagspa\z:}', "");;
    Expect(1, 43127, '\p{Script=_PHAGS_Pa}', "");
    Expect(0, 43127, '\p{^Script=_PHAGS_Pa}', "");
    Expect(0, 43127, '\P{Script=_PHAGS_Pa}', "");
    Expect(1, 43127, '\P{^Script=_PHAGS_Pa}', "");
    Expect(0, 43128, '\p{Script=_PHAGS_Pa}', "");
    Expect(1, 43128, '\p{^Script=_PHAGS_Pa}', "");
    Expect(1, 43128, '\P{Script=_PHAGS_Pa}', "");
    Expect(0, 43128, '\P{^Script=_PHAGS_Pa}', "");
    Error('\p{Sc:   := _Phag}');
    Error('\P{Sc:   := _Phag}');
    Expect(1, 43127, '\p{Sc=:\APhag\z:}', "");;
    Expect(0, 43128, '\p{Sc=:\APhag\z:}', "");;
    Expect(1, 43127, '\p{Sc=phag}', "");
    Expect(0, 43127, '\p{^Sc=phag}', "");
    Expect(0, 43127, '\P{Sc=phag}', "");
    Expect(1, 43127, '\P{^Sc=phag}', "");
    Expect(0, 43128, '\p{Sc=phag}', "");
    Expect(1, 43128, '\p{^Sc=phag}', "");
    Expect(1, 43128, '\P{Sc=phag}', "");
    Expect(0, 43128, '\P{^Sc=phag}', "");
    Expect(1, 43127, '\p{Sc=:\Aphag\z:}', "");;
    Expect(0, 43128, '\p{Sc=:\Aphag\z:}', "");;
    Expect(1, 43127, '\p{Sc:	-PHAG}', "");
    Expect(0, 43127, '\p{^Sc:	-PHAG}', "");
    Expect(0, 43127, '\P{Sc:	-PHAG}', "");
    Expect(1, 43127, '\P{^Sc:	-PHAG}', "");
    Expect(0, 43128, '\p{Sc:	-PHAG}', "");
    Expect(1, 43128, '\p{^Sc:	-PHAG}', "");
    Expect(1, 43128, '\P{Sc:	-PHAG}', "");
    Expect(0, 43128, '\P{^Sc:	-PHAG}', "");
    Error('\p{Is_Script:    :=phags_Pa}');
    Error('\P{Is_Script:    :=phags_Pa}');
    Expect(1, 43127, '\p{Is_Script=phagspa}', "");
    Expect(0, 43127, '\p{^Is_Script=phagspa}', "");
    Expect(0, 43127, '\P{Is_Script=phagspa}', "");
    Expect(1, 43127, '\P{^Is_Script=phagspa}', "");
    Expect(0, 43128, '\p{Is_Script=phagspa}', "");
    Expect(1, 43128, '\p{^Is_Script=phagspa}', "");
    Expect(1, 43128, '\P{Is_Script=phagspa}', "");
    Expect(0, 43128, '\P{^Is_Script=phagspa}', "");
    Expect(1, 43127, '\p{Is_Script=	-phags_pa}', "");
    Expect(0, 43127, '\p{^Is_Script=	-phags_pa}', "");
    Expect(0, 43127, '\P{Is_Script=	-phags_pa}', "");
    Expect(1, 43127, '\P{^Is_Script=	-phags_pa}', "");
    Expect(0, 43128, '\p{Is_Script=	-phags_pa}', "");
    Expect(1, 43128, '\p{^Is_Script=	-phags_pa}', "");
    Expect(1, 43128, '\P{Is_Script=	-phags_pa}', "");
    Expect(0, 43128, '\P{^Is_Script=	-phags_pa}', "");
    Error('\p{Is_Sc=:=	 phag}');
    Error('\P{Is_Sc=:=	 phag}');
    Expect(1, 43127, '\p{Is_Sc=phag}', "");
    Expect(0, 43127, '\p{^Is_Sc=phag}', "");
    Expect(0, 43127, '\P{Is_Sc=phag}', "");
    Expect(1, 43127, '\P{^Is_Sc=phag}', "");
    Expect(0, 43128, '\p{Is_Sc=phag}', "");
    Expect(1, 43128, '\p{^Is_Sc=phag}', "");
    Expect(1, 43128, '\P{Is_Sc=phag}', "");
    Expect(0, 43128, '\P{^Is_Sc=phag}', "");
    Expect(1, 43127, '\p{Is_Sc:__PHAG}', "");
    Expect(0, 43127, '\p{^Is_Sc:__PHAG}', "");
    Expect(0, 43127, '\P{Is_Sc:__PHAG}', "");
    Expect(1, 43127, '\P{^Is_Sc:__PHAG}', "");
    Expect(0, 43128, '\p{Is_Sc:__PHAG}', "");
    Expect(1, 43128, '\p{^Is_Sc:__PHAG}', "");
    Expect(1, 43128, '\P{Is_Sc:__PHAG}', "");
    Expect(0, 43128, '\P{^Is_Sc:__PHAG}', "");
    Error('\p{Script=__Inscriptional_PAHLAVI:=}');
    Error('\P{Script=__Inscriptional_PAHLAVI:=}');
    Expect(1, 68479, '\p{Script=:\AInscriptional_Pahlavi\z:}', "");;
    Expect(0, 68480, '\p{Script=:\AInscriptional_Pahlavi\z:}', "");;
    Expect(1, 68479, '\p{Script=inscriptionalpahlavi}', "");
    Expect(0, 68479, '\p{^Script=inscriptionalpahlavi}', "");
    Expect(0, 68479, '\P{Script=inscriptionalpahlavi}', "");
    Expect(1, 68479, '\P{^Script=inscriptionalpahlavi}', "");
    Expect(0, 68480, '\p{Script=inscriptionalpahlavi}', "");
    Expect(1, 68480, '\p{^Script=inscriptionalpahlavi}', "");
    Expect(1, 68480, '\P{Script=inscriptionalpahlavi}', "");
    Expect(0, 68480, '\P{^Script=inscriptionalpahlavi}', "");
    Expect(1, 68479, '\p{Script=:\Ainscriptionalpahlavi\z:}', "");;
    Expect(0, 68480, '\p{Script=:\Ainscriptionalpahlavi\z:}', "");;
    Expect(1, 68479, '\p{Script=-_Inscriptional_Pahlavi}', "");
    Expect(0, 68479, '\p{^Script=-_Inscriptional_Pahlavi}', "");
    Expect(0, 68479, '\P{Script=-_Inscriptional_Pahlavi}', "");
    Expect(1, 68479, '\P{^Script=-_Inscriptional_Pahlavi}', "");
    Expect(0, 68480, '\p{Script=-_Inscriptional_Pahlavi}', "");
    Expect(1, 68480, '\p{^Script=-_Inscriptional_Pahlavi}', "");
    Expect(1, 68480, '\P{Script=-_Inscriptional_Pahlavi}', "");
    Expect(0, 68480, '\P{^Script=-_Inscriptional_Pahlavi}', "");
    Error('\p{Sc= :=Phli}');
    Error('\P{Sc= :=Phli}');
    Expect(1, 68479, '\p{Sc=:\APhli\z:}', "");;
    Expect(0, 68480, '\p{Sc=:\APhli\z:}', "");;
    Expect(1, 68479, '\p{Sc=phli}', "");
    Expect(0, 68479, '\p{^Sc=phli}', "");
    Expect(0, 68479, '\P{Sc=phli}', "");
    Expect(1, 68479, '\P{^Sc=phli}', "");
    Expect(0, 68480, '\p{Sc=phli}', "");
    Expect(1, 68480, '\p{^Sc=phli}', "");
    Expect(1, 68480, '\P{Sc=phli}', "");
    Expect(0, 68480, '\P{^Sc=phli}', "");
    Expect(1, 68479, '\p{Sc=:\Aphli\z:}', "");;
    Expect(0, 68480, '\p{Sc=:\Aphli\z:}', "");;
    Expect(1, 68479, '\p{Sc=	Phli}', "");
    Expect(0, 68479, '\p{^Sc=	Phli}', "");
    Expect(0, 68479, '\P{Sc=	Phli}', "");
    Expect(1, 68479, '\P{^Sc=	Phli}', "");
    Expect(0, 68480, '\p{Sc=	Phli}', "");
    Expect(1, 68480, '\p{^Sc=	Phli}', "");
    Expect(1, 68480, '\P{Sc=	Phli}', "");
    Expect(0, 68480, '\P{^Sc=	Phli}', "");
    Error('\p{Is_Script=- Inscriptional_pahlavi/a/}');
    Error('\P{Is_Script=- Inscriptional_pahlavi/a/}');
    Expect(1, 68479, '\p{Is_Script=inscriptionalpahlavi}', "");
    Expect(0, 68479, '\p{^Is_Script=inscriptionalpahlavi}', "");
    Expect(0, 68479, '\P{Is_Script=inscriptionalpahlavi}', "");
    Expect(1, 68479, '\P{^Is_Script=inscriptionalpahlavi}', "");
    Expect(0, 68480, '\p{Is_Script=inscriptionalpahlavi}', "");
    Expect(1, 68480, '\p{^Is_Script=inscriptionalpahlavi}', "");
    Expect(1, 68480, '\P{Is_Script=inscriptionalpahlavi}', "");
    Expect(0, 68480, '\P{^Is_Script=inscriptionalpahlavi}', "");
    Expect(1, 68479, '\p{Is_Script=	-Inscriptional_pahlavi}', "");
    Expect(0, 68479, '\p{^Is_Script=	-Inscriptional_pahlavi}', "");
    Expect(0, 68479, '\P{Is_Script=	-Inscriptional_pahlavi}', "");
    Expect(1, 68479, '\P{^Is_Script=	-Inscriptional_pahlavi}', "");
    Expect(0, 68480, '\p{Is_Script=	-Inscriptional_pahlavi}', "");
    Expect(1, 68480, '\p{^Is_Script=	-Inscriptional_pahlavi}', "");
    Expect(1, 68480, '\P{Is_Script=	-Inscriptional_pahlavi}', "");
    Expect(0, 68480, '\P{^Is_Script=	-Inscriptional_pahlavi}', "");
    Error('\p{Is_Sc=/a/_ phli}');
    Error('\P{Is_Sc=/a/_ phli}');
    Expect(1, 68479, '\p{Is_Sc=phli}', "");
    Expect(0, 68479, '\p{^Is_Sc=phli}', "");
    Expect(0, 68479, '\P{Is_Sc=phli}', "");
    Expect(1, 68479, '\P{^Is_Sc=phli}', "");
    Expect(0, 68480, '\p{Is_Sc=phli}', "");
    Expect(1, 68480, '\p{^Is_Sc=phli}', "");
    Expect(1, 68480, '\P{Is_Sc=phli}', "");
    Expect(0, 68480, '\P{^Is_Sc=phli}', "");
    Expect(1, 68479, '\p{Is_Sc=_	PHLI}', "");
    Expect(0, 68479, '\p{^Is_Sc=_	PHLI}', "");
    Expect(0, 68479, '\P{Is_Sc=_	PHLI}', "");
    Expect(1, 68479, '\P{^Is_Sc=_	PHLI}', "");
    Expect(0, 68480, '\p{Is_Sc=_	PHLI}', "");
    Expect(1, 68480, '\p{^Is_Sc=_	PHLI}', "");
    Expect(1, 68480, '\P{Is_Sc=_	PHLI}', "");
    Expect(0, 68480, '\P{^Is_Sc=_	PHLI}', "");
    Error('\p{Script=/a/	psalter_PAHLAVI}');
    Error('\P{Script=/a/	psalter_PAHLAVI}');
    Expect(1, 68527, '\p{Script=:\APsalter_Pahlavi\z:}', "");;
    Expect(0, 68528, '\p{Script=:\APsalter_Pahlavi\z:}', "");;
    Expect(1, 68527, '\p{Script:psalterpahlavi}', "");
    Expect(0, 68527, '\p{^Script:psalterpahlavi}', "");
    Expect(0, 68527, '\P{Script:psalterpahlavi}', "");
    Expect(1, 68527, '\P{^Script:psalterpahlavi}', "");
    Expect(0, 68528, '\p{Script:psalterpahlavi}', "");
    Expect(1, 68528, '\p{^Script:psalterpahlavi}', "");
    Expect(1, 68528, '\P{Script:psalterpahlavi}', "");
    Expect(0, 68528, '\P{^Script:psalterpahlavi}', "");
    Expect(1, 68527, '\p{Script=:\Apsalterpahlavi\z:}', "");;
    Expect(0, 68528, '\p{Script=:\Apsalterpahlavi\z:}', "");;
    Expect(1, 68527, '\p{Script=- PSALTER_Pahlavi}', "");
    Expect(0, 68527, '\p{^Script=- PSALTER_Pahlavi}', "");
    Expect(0, 68527, '\P{Script=- PSALTER_Pahlavi}', "");
    Expect(1, 68527, '\P{^Script=- PSALTER_Pahlavi}', "");
    Expect(0, 68528, '\p{Script=- PSALTER_Pahlavi}', "");
    Expect(1, 68528, '\p{^Script=- PSALTER_Pahlavi}', "");
    Expect(1, 68528, '\P{Script=- PSALTER_Pahlavi}', "");
    Expect(0, 68528, '\P{^Script=- PSALTER_Pahlavi}', "");
    Error('\p{Sc: 	-Phlp/a/}');
    Error('\P{Sc: 	-Phlp/a/}');
    Expect(1, 68527, '\p{Sc=:\APhlp\z:}', "");;
    Expect(0, 68528, '\p{Sc=:\APhlp\z:}', "");;
    Expect(1, 68527, '\p{Sc=phlp}', "");
    Expect(0, 68527, '\p{^Sc=phlp}', "");
    Expect(0, 68527, '\P{Sc=phlp}', "");
    Expect(1, 68527, '\P{^Sc=phlp}', "");
    Expect(0, 68528, '\p{Sc=phlp}', "");
    Expect(1, 68528, '\p{^Sc=phlp}', "");
    Expect(1, 68528, '\P{Sc=phlp}', "");
    Expect(0, 68528, '\P{^Sc=phlp}', "");
    Expect(1, 68527, '\p{Sc=:\Aphlp\z:}', "");;
    Expect(0, 68528, '\p{Sc=:\Aphlp\z:}', "");;
    Expect(1, 68527, '\p{Sc=-PHLP}', "");
    Expect(0, 68527, '\p{^Sc=-PHLP}', "");
    Expect(0, 68527, '\P{Sc=-PHLP}', "");
    Expect(1, 68527, '\P{^Sc=-PHLP}', "");
    Expect(0, 68528, '\p{Sc=-PHLP}', "");
    Expect(1, 68528, '\p{^Sc=-PHLP}', "");
    Expect(1, 68528, '\P{Sc=-PHLP}', "");
    Expect(0, 68528, '\P{^Sc=-PHLP}', "");
    Error('\p{Is_Script=/a/ psalter_pahlavi}');
    Error('\P{Is_Script=/a/ psalter_pahlavi}');
    Expect(1, 68527, '\p{Is_Script=psalterpahlavi}', "");
    Expect(0, 68527, '\p{^Is_Script=psalterpahlavi}', "");
    Expect(0, 68527, '\P{Is_Script=psalterpahlavi}', "");
    Expect(1, 68527, '\P{^Is_Script=psalterpahlavi}', "");
    Expect(0, 68528, '\p{Is_Script=psalterpahlavi}', "");
    Expect(1, 68528, '\p{^Is_Script=psalterpahlavi}', "");
    Expect(1, 68528, '\P{Is_Script=psalterpahlavi}', "");
    Expect(0, 68528, '\P{^Is_Script=psalterpahlavi}', "");
    Expect(1, 68527, '\p{Is_Script= psalter_PAHLAVI}', "");
    Expect(0, 68527, '\p{^Is_Script= psalter_PAHLAVI}', "");
    Expect(0, 68527, '\P{Is_Script= psalter_PAHLAVI}', "");
    Expect(1, 68527, '\P{^Is_Script= psalter_PAHLAVI}', "");
    Expect(0, 68528, '\p{Is_Script= psalter_PAHLAVI}', "");
    Expect(1, 68528, '\p{^Is_Script= psalter_PAHLAVI}', "");
    Expect(1, 68528, '\P{Is_Script= psalter_PAHLAVI}', "");
    Expect(0, 68528, '\P{^Is_Script= psalter_PAHLAVI}', "");
    Error('\p{Is_Sc::=_Phlp}');
    Error('\P{Is_Sc::=_Phlp}');
    Expect(1, 68527, '\p{Is_Sc=phlp}', "");
    Expect(0, 68527, '\p{^Is_Sc=phlp}', "");
    Expect(0, 68527, '\P{Is_Sc=phlp}', "");
    Expect(1, 68527, '\P{^Is_Sc=phlp}', "");
    Expect(0, 68528, '\p{Is_Sc=phlp}', "");
    Expect(1, 68528, '\p{^Is_Sc=phlp}', "");
    Expect(1, 68528, '\P{Is_Sc=phlp}', "");
    Expect(0, 68528, '\P{^Is_Sc=phlp}', "");
    Expect(1, 68527, '\p{Is_Sc= PHLP}', "");
    Expect(0, 68527, '\p{^Is_Sc= PHLP}', "");
    Expect(0, 68527, '\P{Is_Sc= PHLP}', "");
    Expect(1, 68527, '\P{^Is_Sc= PHLP}', "");
    Expect(0, 68528, '\p{Is_Sc= PHLP}', "");
    Expect(1, 68528, '\p{^Is_Sc= PHLP}', "");
    Expect(1, 68528, '\P{Is_Sc= PHLP}', "");
    Expect(0, 68528, '\P{^Is_Sc= PHLP}', "");
    Error('\p{Script=	-phoenician:=}');
    Error('\P{Script=	-phoenician:=}');
    Expect(1, 67871, '\p{Script=:\APhoenician\z:}', "");;
    Expect(0, 67872, '\p{Script=:\APhoenician\z:}', "");;
    Expect(1, 67871, '\p{Script=phoenician}', "");
    Expect(0, 67871, '\p{^Script=phoenician}', "");
    Expect(0, 67871, '\P{Script=phoenician}', "");
    Expect(1, 67871, '\P{^Script=phoenician}', "");
    Expect(0, 67872, '\p{Script=phoenician}', "");
    Expect(1, 67872, '\p{^Script=phoenician}', "");
    Expect(1, 67872, '\P{Script=phoenician}', "");
    Expect(0, 67872, '\P{^Script=phoenician}', "");
    Expect(1, 67871, '\p{Script=:\Aphoenician\z:}', "");;
    Expect(0, 67872, '\p{Script=:\Aphoenician\z:}', "");;
    Expect(1, 67871, '\p{Script=--Phoenician}', "");
    Expect(0, 67871, '\p{^Script=--Phoenician}', "");
    Expect(0, 67871, '\P{Script=--Phoenician}', "");
    Expect(1, 67871, '\P{^Script=--Phoenician}', "");
    Expect(0, 67872, '\p{Script=--Phoenician}', "");
    Expect(1, 67872, '\p{^Script=--Phoenician}', "");
    Expect(1, 67872, '\P{Script=--Phoenician}', "");
    Expect(0, 67872, '\P{^Script=--Phoenician}', "");
    Error('\p{Sc=- phnx:=}');
    Error('\P{Sc=- phnx:=}');
    Expect(1, 67871, '\p{Sc=:\APhnx\z:}', "");;
    Expect(0, 67872, '\p{Sc=:\APhnx\z:}', "");;
    Expect(1, 67871, '\p{Sc=phnx}', "");
    Expect(0, 67871, '\p{^Sc=phnx}', "");
    Expect(0, 67871, '\P{Sc=phnx}', "");
    Expect(1, 67871, '\P{^Sc=phnx}', "");
    Expect(0, 67872, '\p{Sc=phnx}', "");
    Expect(1, 67872, '\p{^Sc=phnx}', "");
    Expect(1, 67872, '\P{Sc=phnx}', "");
    Expect(0, 67872, '\P{^Sc=phnx}', "");
    Expect(1, 67871, '\p{Sc=:\Aphnx\z:}', "");;
    Expect(0, 67872, '\p{Sc=:\Aphnx\z:}', "");;
    Expect(1, 67871, '\p{Sc=	Phnx}', "");
    Expect(0, 67871, '\p{^Sc=	Phnx}', "");
    Expect(0, 67871, '\P{Sc=	Phnx}', "");
    Expect(1, 67871, '\P{^Sc=	Phnx}', "");
    Expect(0, 67872, '\p{Sc=	Phnx}', "");
    Expect(1, 67872, '\p{^Sc=	Phnx}', "");
    Expect(1, 67872, '\P{Sc=	Phnx}', "");
    Expect(0, 67872, '\P{^Sc=	Phnx}', "");
    Error('\p{Is_Script=	Phoenician:=}');
    Error('\P{Is_Script=	Phoenician:=}');
    Expect(1, 67871, '\p{Is_Script=phoenician}', "");
    Expect(0, 67871, '\p{^Is_Script=phoenician}', "");
    Expect(0, 67871, '\P{Is_Script=phoenician}', "");
    Expect(1, 67871, '\P{^Is_Script=phoenician}', "");
    Expect(0, 67872, '\p{Is_Script=phoenician}', "");
    Expect(1, 67872, '\p{^Is_Script=phoenician}', "");
    Expect(1, 67872, '\P{Is_Script=phoenician}', "");
    Expect(0, 67872, '\P{^Is_Script=phoenician}', "");
    Expect(1, 67871, '\p{Is_Script=	phoenician}', "");
    Expect(0, 67871, '\p{^Is_Script=	phoenician}', "");
    Expect(0, 67871, '\P{Is_Script=	phoenician}', "");
    Expect(1, 67871, '\P{^Is_Script=	phoenician}', "");
    Expect(0, 67872, '\p{Is_Script=	phoenician}', "");
    Expect(1, 67872, '\p{^Is_Script=	phoenician}', "");
    Expect(1, 67872, '\P{Is_Script=	phoenician}', "");
    Expect(0, 67872, '\P{^Is_Script=	phoenician}', "");
    Error('\p{Is_Sc:	/a/__PHNX}');
    Error('\P{Is_Sc:	/a/__PHNX}');
    Expect(1, 67871, '\p{Is_Sc=phnx}', "");
    Expect(0, 67871, '\p{^Is_Sc=phnx}', "");
    Expect(0, 67871, '\P{Is_Sc=phnx}', "");
    Expect(1, 67871, '\P{^Is_Sc=phnx}', "");
    Expect(0, 67872, '\p{Is_Sc=phnx}', "");
    Expect(1, 67872, '\p{^Is_Sc=phnx}', "");
    Expect(1, 67872, '\P{Is_Sc=phnx}', "");
    Expect(0, 67872, '\P{^Is_Sc=phnx}', "");
    Expect(1, 67871, '\p{Is_Sc=--phnx}', "");
    Expect(0, 67871, '\p{^Is_Sc=--phnx}', "");
    Expect(0, 67871, '\P{Is_Sc=--phnx}', "");
    Expect(1, 67871, '\P{^Is_Sc=--phnx}', "");
    Expect(0, 67872, '\p{Is_Sc=--phnx}', "");
    Expect(1, 67872, '\p{^Is_Sc=--phnx}', "");
    Expect(1, 67872, '\P{Is_Sc=--phnx}', "");
    Expect(0, 67872, '\P{^Is_Sc=--phnx}', "");
    Error('\p{Script=-/a/Miao}');
    Error('\P{Script=-/a/Miao}');
    Expect(1, 94111, '\p{Script=:\AMiao\z:}', "");;
    Expect(0, 94112, '\p{Script=:\AMiao\z:}', "");;
    Expect(1, 94111, '\p{Script=miao}', "");
    Expect(0, 94111, '\p{^Script=miao}', "");
    Expect(0, 94111, '\P{Script=miao}', "");
    Expect(1, 94111, '\P{^Script=miao}', "");
    Expect(0, 94112, '\p{Script=miao}', "");
    Expect(1, 94112, '\p{^Script=miao}', "");
    Expect(1, 94112, '\P{Script=miao}', "");
    Expect(0, 94112, '\P{^Script=miao}', "");
    Expect(1, 94111, '\p{Script=:\Amiao\z:}', "");;
    Expect(0, 94112, '\p{Script=:\Amiao\z:}', "");;
    Expect(1, 94111, '\p{Script=		Miao}', "");
    Expect(0, 94111, '\p{^Script=		Miao}', "");
    Expect(0, 94111, '\P{Script=		Miao}', "");
    Expect(1, 94111, '\P{^Script=		Miao}', "");
    Expect(0, 94112, '\p{Script=		Miao}', "");
    Expect(1, 94112, '\p{^Script=		Miao}', "");
    Expect(1, 94112, '\P{Script=		Miao}', "");
    Expect(0, 94112, '\P{^Script=		Miao}', "");
    Error('\p{Sc:	_Plrd:=}');
    Error('\P{Sc:	_Plrd:=}');
    Expect(1, 94111, '\p{Sc=:\APlrd\z:}', "");;
    Expect(0, 94112, '\p{Sc=:\APlrd\z:}', "");;
    Expect(1, 94111, '\p{Sc=plrd}', "");
    Expect(0, 94111, '\p{^Sc=plrd}', "");
    Expect(0, 94111, '\P{Sc=plrd}', "");
    Expect(1, 94111, '\P{^Sc=plrd}', "");
    Expect(0, 94112, '\p{Sc=plrd}', "");
    Expect(1, 94112, '\p{^Sc=plrd}', "");
    Expect(1, 94112, '\P{Sc=plrd}', "");
    Expect(0, 94112, '\P{^Sc=plrd}', "");
    Expect(1, 94111, '\p{Sc=:\Aplrd\z:}', "");;
    Expect(0, 94112, '\p{Sc=:\Aplrd\z:}', "");;
    Expect(1, 94111, '\p{Sc=_	Plrd}', "");
    Expect(0, 94111, '\p{^Sc=_	Plrd}', "");
    Expect(0, 94111, '\P{Sc=_	Plrd}', "");
    Expect(1, 94111, '\P{^Sc=_	Plrd}', "");
    Expect(0, 94112, '\p{Sc=_	Plrd}', "");
    Expect(1, 94112, '\p{^Sc=_	Plrd}', "");
    Expect(1, 94112, '\P{Sc=_	Plrd}', "");
    Expect(0, 94112, '\P{^Sc=_	Plrd}', "");
    Error('\p{Is_Script=	miao/a/}');
    Error('\P{Is_Script=	miao/a/}');
    Expect(1, 94111, '\p{Is_Script=miao}', "");
    Expect(0, 94111, '\p{^Is_Script=miao}', "");
    Expect(0, 94111, '\P{Is_Script=miao}', "");
    Expect(1, 94111, '\P{^Is_Script=miao}', "");
    Expect(0, 94112, '\p{Is_Script=miao}', "");
    Expect(1, 94112, '\p{^Is_Script=miao}', "");
    Expect(1, 94112, '\P{Is_Script=miao}', "");
    Expect(0, 94112, '\P{^Is_Script=miao}', "");
    Expect(1, 94111, '\p{Is_Script=_miao}', "");
    Expect(0, 94111, '\p{^Is_Script=_miao}', "");
    Expect(0, 94111, '\P{Is_Script=_miao}', "");
    Expect(1, 94111, '\P{^Is_Script=_miao}', "");
    Expect(0, 94112, '\p{Is_Script=_miao}', "");
    Expect(1, 94112, '\p{^Is_Script=_miao}', "");
    Expect(1, 94112, '\P{Is_Script=_miao}', "");
    Expect(0, 94112, '\P{^Is_Script=_miao}', "");
    Error('\p{Is_Sc=/a/-	Plrd}');
    Error('\P{Is_Sc=/a/-	Plrd}');
    Expect(1, 94111, '\p{Is_Sc=plrd}', "");
    Expect(0, 94111, '\p{^Is_Sc=plrd}', "");
    Expect(0, 94111, '\P{Is_Sc=plrd}', "");
    Expect(1, 94111, '\P{^Is_Sc=plrd}', "");
    Expect(0, 94112, '\p{Is_Sc=plrd}', "");
    Expect(1, 94112, '\p{^Is_Sc=plrd}', "");
    Expect(1, 94112, '\P{Is_Sc=plrd}', "");
    Expect(0, 94112, '\P{^Is_Sc=plrd}', "");
    Expect(1, 94111, '\p{Is_Sc: -Plrd}', "");
    Expect(0, 94111, '\p{^Is_Sc: -Plrd}', "");
    Expect(0, 94111, '\P{Is_Sc: -Plrd}', "");
    Expect(1, 94111, '\P{^Is_Sc: -Plrd}', "");
    Expect(0, 94112, '\p{Is_Sc: -Plrd}', "");
    Expect(1, 94112, '\p{^Is_Sc: -Plrd}', "");
    Expect(1, 94112, '\P{Is_Sc: -Plrd}', "");
    Expect(0, 94112, '\P{^Is_Sc: -Plrd}', "");
    Error('\p{Script=	_inscriptional_PARTHIAN:=}');
    Error('\P{Script=	_inscriptional_PARTHIAN:=}');
    Expect(1, 68447, '\p{Script=:\AInscriptional_Parthian\z:}', "");;
    Expect(0, 68448, '\p{Script=:\AInscriptional_Parthian\z:}', "");;
    Expect(1, 68447, '\p{Script=inscriptionalparthian}', "");
    Expect(0, 68447, '\p{^Script=inscriptionalparthian}', "");
    Expect(0, 68447, '\P{Script=inscriptionalparthian}', "");
    Expect(1, 68447, '\P{^Script=inscriptionalparthian}', "");
    Expect(0, 68448, '\p{Script=inscriptionalparthian}', "");
    Expect(1, 68448, '\p{^Script=inscriptionalparthian}', "");
    Expect(1, 68448, '\P{Script=inscriptionalparthian}', "");
    Expect(0, 68448, '\P{^Script=inscriptionalparthian}', "");
    Expect(1, 68447, '\p{Script=:\Ainscriptionalparthian\z:}', "");;
    Expect(0, 68448, '\p{Script=:\Ainscriptionalparthian\z:}', "");;
    Expect(1, 68447, '\p{Script= Inscriptional_PARTHIAN}', "");
    Expect(0, 68447, '\p{^Script= Inscriptional_PARTHIAN}', "");
    Expect(0, 68447, '\P{Script= Inscriptional_PARTHIAN}', "");
    Expect(1, 68447, '\P{^Script= Inscriptional_PARTHIAN}', "");
    Expect(0, 68448, '\p{Script= Inscriptional_PARTHIAN}', "");
    Expect(1, 68448, '\p{^Script= Inscriptional_PARTHIAN}', "");
    Expect(1, 68448, '\P{Script= Inscriptional_PARTHIAN}', "");
    Expect(0, 68448, '\P{^Script= Inscriptional_PARTHIAN}', "");
    Error('\p{Sc: _Prti:=}');
    Error('\P{Sc: _Prti:=}');
    Expect(1, 68447, '\p{Sc=:\APrti\z:}', "");;
    Expect(0, 68448, '\p{Sc=:\APrti\z:}', "");;
    Expect(1, 68447, '\p{Sc=prti}', "");
    Expect(0, 68447, '\p{^Sc=prti}', "");
    Expect(0, 68447, '\P{Sc=prti}', "");
    Expect(1, 68447, '\P{^Sc=prti}', "");
    Expect(0, 68448, '\p{Sc=prti}', "");
    Expect(1, 68448, '\p{^Sc=prti}', "");
    Expect(1, 68448, '\P{Sc=prti}', "");
    Expect(0, 68448, '\P{^Sc=prti}', "");
    Expect(1, 68447, '\p{Sc=:\Aprti\z:}', "");;
    Expect(0, 68448, '\p{Sc=:\Aprti\z:}', "");;
    Expect(1, 68447, '\p{Sc=- PRTI}', "");
    Expect(0, 68447, '\p{^Sc=- PRTI}', "");
    Expect(0, 68447, '\P{Sc=- PRTI}', "");
    Expect(1, 68447, '\P{^Sc=- PRTI}', "");
    Expect(0, 68448, '\p{Sc=- PRTI}', "");
    Expect(1, 68448, '\p{^Sc=- PRTI}', "");
    Expect(1, 68448, '\P{Sc=- PRTI}', "");
    Expect(0, 68448, '\P{^Sc=- PRTI}', "");
    Error('\p{Is_Script=	:=INSCRIPTIONAL_Parthian}');
    Error('\P{Is_Script=	:=INSCRIPTIONAL_Parthian}');
    Expect(1, 68447, '\p{Is_Script=inscriptionalparthian}', "");
    Expect(0, 68447, '\p{^Is_Script=inscriptionalparthian}', "");
    Expect(0, 68447, '\P{Is_Script=inscriptionalparthian}', "");
    Expect(1, 68447, '\P{^Is_Script=inscriptionalparthian}', "");
    Expect(0, 68448, '\p{Is_Script=inscriptionalparthian}', "");
    Expect(1, 68448, '\p{^Is_Script=inscriptionalparthian}', "");
    Expect(1, 68448, '\P{Is_Script=inscriptionalparthian}', "");
    Expect(0, 68448, '\P{^Is_Script=inscriptionalparthian}', "");
    Expect(1, 68447, '\p{Is_Script=-	INSCRIPTIONAL_parthian}', "");
    Expect(0, 68447, '\p{^Is_Script=-	INSCRIPTIONAL_parthian}', "");
    Expect(0, 68447, '\P{Is_Script=-	INSCRIPTIONAL_parthian}', "");
    Expect(1, 68447, '\P{^Is_Script=-	INSCRIPTIONAL_parthian}', "");
    Expect(0, 68448, '\p{Is_Script=-	INSCRIPTIONAL_parthian}', "");
    Expect(1, 68448, '\p{^Is_Script=-	INSCRIPTIONAL_parthian}', "");
    Expect(1, 68448, '\P{Is_Script=-	INSCRIPTIONAL_parthian}', "");
    Expect(0, 68448, '\P{^Is_Script=-	INSCRIPTIONAL_parthian}', "");
    Error('\p{Is_Sc=:= -PRTI}');
    Error('\P{Is_Sc=:= -PRTI}');
    Expect(1, 68447, '\p{Is_Sc:prti}', "");
    Expect(0, 68447, '\p{^Is_Sc:prti}', "");
    Expect(0, 68447, '\P{Is_Sc:prti}', "");
    Expect(1, 68447, '\P{^Is_Sc:prti}', "");
    Expect(0, 68448, '\p{Is_Sc:prti}', "");
    Expect(1, 68448, '\p{^Is_Sc:prti}', "");
    Expect(1, 68448, '\P{Is_Sc:prti}', "");
    Expect(0, 68448, '\P{^Is_Sc:prti}', "");
    Expect(1, 68447, '\p{Is_Sc= -PRTI}', "");
    Expect(0, 68447, '\p{^Is_Sc= -PRTI}', "");
    Expect(0, 68447, '\P{Is_Sc= -PRTI}', "");
    Expect(1, 68447, '\P{^Is_Sc= -PRTI}', "");
    Expect(0, 68448, '\p{Is_Sc= -PRTI}', "");
    Expect(1, 68448, '\p{^Is_Sc= -PRTI}', "");
    Expect(1, 68448, '\P{Is_Sc= -PRTI}', "");
    Expect(0, 68448, '\P{^Is_Sc= -PRTI}', "");
    Error('\p{Script=	 REJANG/a/}');
    Error('\P{Script=	 REJANG/a/}');
    Expect(1, 43359, '\p{Script=:\ARejang\z:}', "");;
    Expect(0, 43360, '\p{Script=:\ARejang\z:}', "");;
    Expect(1, 43359, '\p{Script=rejang}', "");
    Expect(0, 43359, '\p{^Script=rejang}', "");
    Expect(0, 43359, '\P{Script=rejang}', "");
    Expect(1, 43359, '\P{^Script=rejang}', "");
    Expect(0, 43360, '\p{Script=rejang}', "");
    Expect(1, 43360, '\p{^Script=rejang}', "");
    Expect(1, 43360, '\P{Script=rejang}', "");
    Expect(0, 43360, '\P{^Script=rejang}', "");
    Expect(1, 43359, '\p{Script=:\Arejang\z:}', "");;
    Expect(0, 43360, '\p{Script=:\Arejang\z:}', "");;
    Expect(1, 43359, '\p{Script=_rejang}', "");
    Expect(0, 43359, '\p{^Script=_rejang}', "");
    Expect(0, 43359, '\P{Script=_rejang}', "");
    Expect(1, 43359, '\P{^Script=_rejang}', "");
    Expect(0, 43360, '\p{Script=_rejang}', "");
    Expect(1, 43360, '\p{^Script=_rejang}', "");
    Expect(1, 43360, '\P{Script=_rejang}', "");
    Expect(0, 43360, '\P{^Script=_rejang}', "");
    Error('\p{Sc=__Rjng:=}');
    Error('\P{Sc=__Rjng:=}');
    Expect(1, 43359, '\p{Sc=:\ARjng\z:}', "");;
    Expect(0, 43360, '\p{Sc=:\ARjng\z:}', "");;
    Expect(1, 43359, '\p{Sc=rjng}', "");
    Expect(0, 43359, '\p{^Sc=rjng}', "");
    Expect(0, 43359, '\P{Sc=rjng}', "");
    Expect(1, 43359, '\P{^Sc=rjng}', "");
    Expect(0, 43360, '\p{Sc=rjng}', "");
    Expect(1, 43360, '\p{^Sc=rjng}', "");
    Expect(1, 43360, '\P{Sc=rjng}', "");
    Expect(0, 43360, '\P{^Sc=rjng}', "");
    Expect(1, 43359, '\p{Sc=:\Arjng\z:}', "");;
    Expect(0, 43360, '\p{Sc=:\Arjng\z:}', "");;
    Expect(1, 43359, '\p{Sc=-	rjng}', "");
    Expect(0, 43359, '\p{^Sc=-	rjng}', "");
    Expect(0, 43359, '\P{Sc=-	rjng}', "");
    Expect(1, 43359, '\P{^Sc=-	rjng}', "");
    Expect(0, 43360, '\p{Sc=-	rjng}', "");
    Expect(1, 43360, '\p{^Sc=-	rjng}', "");
    Expect(1, 43360, '\P{Sc=-	rjng}', "");
    Expect(0, 43360, '\P{^Sc=-	rjng}', "");
    Error('\p{Is_Script:   /a/ -rejang}');
    Error('\P{Is_Script:   /a/ -rejang}');
    Expect(1, 43359, '\p{Is_Script: rejang}', "");
    Expect(0, 43359, '\p{^Is_Script: rejang}', "");
    Expect(0, 43359, '\P{Is_Script: rejang}', "");
    Expect(1, 43359, '\P{^Is_Script: rejang}', "");
    Expect(0, 43360, '\p{Is_Script: rejang}', "");
    Expect(1, 43360, '\p{^Is_Script: rejang}', "");
    Expect(1, 43360, '\P{Is_Script: rejang}', "");
    Expect(0, 43360, '\P{^Is_Script: rejang}', "");
    Expect(1, 43359, '\p{Is_Script:		_Rejang}', "");
    Expect(0, 43359, '\p{^Is_Script:		_Rejang}', "");
    Expect(0, 43359, '\P{Is_Script:		_Rejang}', "");
    Expect(1, 43359, '\P{^Is_Script:		_Rejang}', "");
    Expect(0, 43360, '\p{Is_Script:		_Rejang}', "");
    Expect(1, 43360, '\p{^Is_Script:		_Rejang}', "");
    Expect(1, 43360, '\P{Is_Script:		_Rejang}', "");
    Expect(0, 43360, '\P{^Is_Script:		_Rejang}', "");
    Error('\p{Is_Sc= -RJNG/a/}');
    Error('\P{Is_Sc= -RJNG/a/}');
    Expect(1, 43359, '\p{Is_Sc=rjng}', "");
    Expect(0, 43359, '\p{^Is_Sc=rjng}', "");
    Expect(0, 43359, '\P{Is_Sc=rjng}', "");
    Expect(1, 43359, '\P{^Is_Sc=rjng}', "");
    Expect(0, 43360, '\p{Is_Sc=rjng}', "");
    Expect(1, 43360, '\p{^Is_Sc=rjng}', "");
    Expect(1, 43360, '\P{Is_Sc=rjng}', "");
    Expect(0, 43360, '\P{^Is_Sc=rjng}', "");
    Expect(1, 43359, '\p{Is_Sc:		rjng}', "");
    Expect(0, 43359, '\p{^Is_Sc:		rjng}', "");
    Expect(0, 43359, '\P{Is_Sc:		rjng}', "");
    Expect(1, 43359, '\P{^Is_Sc:		rjng}', "");
    Expect(0, 43360, '\p{Is_Sc:		rjng}', "");
    Expect(1, 43360, '\p{^Is_Sc:		rjng}', "");
    Expect(1, 43360, '\P{Is_Sc:		rjng}', "");
    Expect(0, 43360, '\P{^Is_Sc:		rjng}', "");
    Error('\p{Script::=	_HANIFI_Rohingya}');
    Error('\P{Script::=	_HANIFI_Rohingya}');
    Expect(1, 68921, '\p{Script=:\AHanifi_Rohingya\z:}', "");;
    Expect(0, 68922, '\p{Script=:\AHanifi_Rohingya\z:}', "");;
    Expect(1, 68921, '\p{Script=hanifirohingya}', "");
    Expect(0, 68921, '\p{^Script=hanifirohingya}', "");
    Expect(0, 68921, '\P{Script=hanifirohingya}', "");
    Expect(1, 68921, '\P{^Script=hanifirohingya}', "");
    Expect(0, 68922, '\p{Script=hanifirohingya}', "");
    Expect(1, 68922, '\p{^Script=hanifirohingya}', "");
    Expect(1, 68922, '\P{Script=hanifirohingya}', "");
    Expect(0, 68922, '\P{^Script=hanifirohingya}', "");
    Expect(1, 68921, '\p{Script=:\Ahanifirohingya\z:}', "");;
    Expect(0, 68922, '\p{Script=:\Ahanifirohingya\z:}', "");;
    Expect(1, 68921, '\p{Script:	 	hanifi_ROHINGYA}', "");
    Expect(0, 68921, '\p{^Script:	 	hanifi_ROHINGYA}', "");
    Expect(0, 68921, '\P{Script:	 	hanifi_ROHINGYA}', "");
    Expect(1, 68921, '\P{^Script:	 	hanifi_ROHINGYA}', "");
    Expect(0, 68922, '\p{Script:	 	hanifi_ROHINGYA}', "");
    Expect(1, 68922, '\p{^Script:	 	hanifi_ROHINGYA}', "");
    Expect(1, 68922, '\P{Script:	 	hanifi_ROHINGYA}', "");
    Expect(0, 68922, '\P{^Script:	 	hanifi_ROHINGYA}', "");
    Error('\p{Sc=-Rohg/a/}');
    Error('\P{Sc=-Rohg/a/}');
    Expect(1, 68921, '\p{Sc=:\ARohg\z:}', "");;
    Expect(0, 68922, '\p{Sc=:\ARohg\z:}', "");;
    Expect(1, 68921, '\p{Sc:   rohg}', "");
    Expect(0, 68921, '\p{^Sc:   rohg}', "");
    Expect(0, 68921, '\P{Sc:   rohg}', "");
    Expect(1, 68921, '\P{^Sc:   rohg}', "");
    Expect(0, 68922, '\p{Sc:   rohg}', "");
    Expect(1, 68922, '\p{^Sc:   rohg}', "");
    Expect(1, 68922, '\P{Sc:   rohg}', "");
    Expect(0, 68922, '\P{^Sc:   rohg}', "");
    Expect(1, 68921, '\p{Sc=:\Arohg\z:}', "");;
    Expect(0, 68922, '\p{Sc=:\Arohg\z:}', "");;
    Expect(1, 68921, '\p{Sc=-ROHG}', "");
    Expect(0, 68921, '\p{^Sc=-ROHG}', "");
    Expect(0, 68921, '\P{Sc=-ROHG}', "");
    Expect(1, 68921, '\P{^Sc=-ROHG}', "");
    Expect(0, 68922, '\p{Sc=-ROHG}', "");
    Expect(1, 68922, '\p{^Sc=-ROHG}', "");
    Expect(1, 68922, '\P{Sc=-ROHG}', "");
    Expect(0, 68922, '\P{^Sc=-ROHG}', "");
    Error('\p{Is_Script=:=HANIFI_Rohingya}');
    Error('\P{Is_Script=:=HANIFI_Rohingya}');
    Expect(1, 68921, '\p{Is_Script=hanifirohingya}', "");
    Expect(0, 68921, '\p{^Is_Script=hanifirohingya}', "");
    Expect(0, 68921, '\P{Is_Script=hanifirohingya}', "");
    Expect(1, 68921, '\P{^Is_Script=hanifirohingya}', "");
    Expect(0, 68922, '\p{Is_Script=hanifirohingya}', "");
    Expect(1, 68922, '\p{^Is_Script=hanifirohingya}', "");
    Expect(1, 68922, '\P{Is_Script=hanifirohingya}', "");
    Expect(0, 68922, '\P{^Is_Script=hanifirohingya}', "");
    Expect(1, 68921, '\p{Is_Script:-_hanifi_rohingya}', "");
    Expect(0, 68921, '\p{^Is_Script:-_hanifi_rohingya}', "");
    Expect(0, 68921, '\P{Is_Script:-_hanifi_rohingya}', "");
    Expect(1, 68921, '\P{^Is_Script:-_hanifi_rohingya}', "");
    Expect(0, 68922, '\p{Is_Script:-_hanifi_rohingya}', "");
    Expect(1, 68922, '\p{^Is_Script:-_hanifi_rohingya}', "");
    Expect(1, 68922, '\P{Is_Script:-_hanifi_rohingya}', "");
    Expect(0, 68922, '\P{^Is_Script:-_hanifi_rohingya}', "");
    Error('\p{Is_Sc=:= _ROHG}');
    Error('\P{Is_Sc=:= _ROHG}');
    Expect(1, 68921, '\p{Is_Sc=rohg}', "");
    Expect(0, 68921, '\p{^Is_Sc=rohg}', "");
    Expect(0, 68921, '\P{Is_Sc=rohg}', "");
    Expect(1, 68921, '\P{^Is_Sc=rohg}', "");
    Expect(0, 68922, '\p{Is_Sc=rohg}', "");
    Expect(1, 68922, '\p{^Is_Sc=rohg}', "");
    Expect(1, 68922, '\P{Is_Sc=rohg}', "");
    Expect(0, 68922, '\P{^Is_Sc=rohg}', "");
    Expect(1, 68921, '\p{Is_Sc=		rohg}', "");
    Expect(0, 68921, '\p{^Is_Sc=		rohg}', "");
    Expect(0, 68921, '\P{Is_Sc=		rohg}', "");
    Expect(1, 68921, '\P{^Is_Sc=		rohg}', "");
    Expect(0, 68922, '\p{Is_Sc=		rohg}', "");
    Expect(1, 68922, '\p{^Is_Sc=		rohg}', "");
    Expect(1, 68922, '\P{Is_Sc=		rohg}', "");
    Expect(0, 68922, '\P{^Is_Sc=		rohg}', "");
    Error('\p{Script:   /a/-_Runic}');
    Error('\P{Script:   /a/-_Runic}');
    Expect(1, 5880, '\p{Script=:\ARunic\z:}', "");;
    Expect(0, 5881, '\p{Script=:\ARunic\z:}', "");;
    Expect(1, 5880, '\p{Script=runic}', "");
    Expect(0, 5880, '\p{^Script=runic}', "");
    Expect(0, 5880, '\P{Script=runic}', "");
    Expect(1, 5880, '\P{^Script=runic}', "");
    Expect(0, 5881, '\p{Script=runic}', "");
    Expect(1, 5881, '\p{^Script=runic}', "");
    Expect(1, 5881, '\P{Script=runic}', "");
    Expect(0, 5881, '\P{^Script=runic}', "");
    Expect(1, 5880, '\p{Script=:\Arunic\z:}', "");;
    Expect(0, 5881, '\p{Script=:\Arunic\z:}', "");;
    Expect(1, 5880, '\p{Script=- Runic}', "");
    Expect(0, 5880, '\p{^Script=- Runic}', "");
    Expect(0, 5880, '\P{Script=- Runic}', "");
    Expect(1, 5880, '\P{^Script=- Runic}', "");
    Expect(0, 5881, '\p{Script=- Runic}', "");
    Expect(1, 5881, '\p{^Script=- Runic}', "");
    Expect(1, 5881, '\P{Script=- Runic}', "");
    Expect(0, 5881, '\P{^Script=- Runic}', "");
    Error('\p{Sc=/a/_	RUNR}');
    Error('\P{Sc=/a/_	RUNR}');
    Expect(1, 5880, '\p{Sc=:\ARunr\z:}', "");;
    Expect(0, 5881, '\p{Sc=:\ARunr\z:}', "");;
    Expect(1, 5880, '\p{Sc=runr}', "");
    Expect(0, 5880, '\p{^Sc=runr}', "");
    Expect(0, 5880, '\P{Sc=runr}', "");
    Expect(1, 5880, '\P{^Sc=runr}', "");
    Expect(0, 5881, '\p{Sc=runr}', "");
    Expect(1, 5881, '\p{^Sc=runr}', "");
    Expect(1, 5881, '\P{Sc=runr}', "");
    Expect(0, 5881, '\P{^Sc=runr}', "");
    Expect(1, 5880, '\p{Sc=:\Arunr\z:}', "");;
    Expect(0, 5881, '\p{Sc=:\Arunr\z:}', "");;
    Expect(1, 5880, '\p{Sc=-	Runr}', "");
    Expect(0, 5880, '\p{^Sc=-	Runr}', "");
    Expect(0, 5880, '\P{Sc=-	Runr}', "");
    Expect(1, 5880, '\P{^Sc=-	Runr}', "");
    Expect(0, 5881, '\p{Sc=-	Runr}', "");
    Expect(1, 5881, '\p{^Sc=-	Runr}', "");
    Expect(1, 5881, '\P{Sc=-	Runr}', "");
    Expect(0, 5881, '\P{^Sc=-	Runr}', "");
    Error('\p{Is_Script=	-RUNIC:=}');
    Error('\P{Is_Script=	-RUNIC:=}');
    Expect(1, 5880, '\p{Is_Script=runic}', "");
    Expect(0, 5880, '\p{^Is_Script=runic}', "");
    Expect(0, 5880, '\P{Is_Script=runic}', "");
    Expect(1, 5880, '\P{^Is_Script=runic}', "");
    Expect(0, 5881, '\p{Is_Script=runic}', "");
    Expect(1, 5881, '\p{^Is_Script=runic}', "");
    Expect(1, 5881, '\P{Is_Script=runic}', "");
    Expect(0, 5881, '\P{^Is_Script=runic}', "");
    Expect(1, 5880, '\p{Is_Script=	 RUNIC}', "");
    Expect(0, 5880, '\p{^Is_Script=	 RUNIC}', "");
    Expect(0, 5880, '\P{Is_Script=	 RUNIC}', "");
    Expect(1, 5880, '\P{^Is_Script=	 RUNIC}', "");
    Expect(0, 5881, '\p{Is_Script=	 RUNIC}', "");
    Expect(1, 5881, '\p{^Is_Script=	 RUNIC}', "");
    Expect(1, 5881, '\P{Is_Script=	 RUNIC}', "");
    Expect(0, 5881, '\P{^Is_Script=	 RUNIC}', "");
    Error('\p{Is_Sc=RUNR:=}');
    Error('\P{Is_Sc=RUNR:=}');
    Expect(1, 5880, '\p{Is_Sc=runr}', "");
    Expect(0, 5880, '\p{^Is_Sc=runr}', "");
    Expect(0, 5880, '\P{Is_Sc=runr}', "");
    Expect(1, 5880, '\P{^Is_Sc=runr}', "");
    Expect(0, 5881, '\p{Is_Sc=runr}', "");
    Expect(1, 5881, '\p{^Is_Sc=runr}', "");
    Expect(1, 5881, '\P{Is_Sc=runr}', "");
    Expect(0, 5881, '\P{^Is_Sc=runr}', "");
    Expect(1, 5880, '\p{Is_Sc=	_Runr}', "");
    Expect(0, 5880, '\p{^Is_Sc=	_Runr}', "");
    Expect(0, 5880, '\P{Is_Sc=	_Runr}', "");
    Expect(1, 5880, '\P{^Is_Sc=	_Runr}', "");
    Expect(0, 5881, '\p{Is_Sc=	_Runr}', "");
    Expect(1, 5881, '\p{^Is_Sc=	_Runr}', "");
    Expect(1, 5881, '\P{Is_Sc=	_Runr}', "");
    Expect(0, 5881, '\P{^Is_Sc=	_Runr}', "");
    Error('\p{Script=/a/	Samaritan}');
    Error('\P{Script=/a/	Samaritan}');
    Expect(1, 2110, '\p{Script=:\ASamaritan\z:}', "");;
    Expect(0, 2111, '\p{Script=:\ASamaritan\z:}', "");;
    Expect(1, 2110, '\p{Script=samaritan}', "");
    Expect(0, 2110, '\p{^Script=samaritan}', "");
    Expect(0, 2110, '\P{Script=samaritan}', "");
    Expect(1, 2110, '\P{^Script=samaritan}', "");
    Expect(0, 2111, '\p{Script=samaritan}', "");
    Expect(1, 2111, '\p{^Script=samaritan}', "");
    Expect(1, 2111, '\P{Script=samaritan}', "");
    Expect(0, 2111, '\P{^Script=samaritan}', "");
    Expect(1, 2110, '\p{Script=:\Asamaritan\z:}', "");;
    Expect(0, 2111, '\p{Script=:\Asamaritan\z:}', "");;
    Error('\p{Sc=	SAMR:=}');
    Error('\P{Sc=	SAMR:=}');
    Expect(1, 2110, '\p{Sc=:\ASamr\z:}', "");;
    Expect(0, 2111, '\p{Sc=:\ASamr\z:}', "");;
    Expect(1, 2110, '\p{Sc=samr}', "");
    Expect(0, 2110, '\p{^Sc=samr}', "");
    Expect(0, 2110, '\P{Sc=samr}', "");
    Expect(1, 2110, '\P{^Sc=samr}', "");
    Expect(0, 2111, '\p{Sc=samr}', "");
    Expect(1, 2111, '\p{^Sc=samr}', "");
    Expect(1, 2111, '\P{Sc=samr}', "");
    Expect(0, 2111, '\P{^Sc=samr}', "");
    Expect(1, 2110, '\p{Sc=:\Asamr\z:}', "");;
    Expect(0, 2111, '\p{Sc=:\Asamr\z:}', "");;
    Expect(1, 2110, '\p{Sc=	 Samr}', "");
    Expect(0, 2110, '\p{^Sc=	 Samr}', "");
    Expect(0, 2110, '\P{Sc=	 Samr}', "");
    Expect(1, 2110, '\P{^Sc=	 Samr}', "");
    Expect(0, 2111, '\p{Sc=	 Samr}', "");
    Expect(1, 2111, '\p{^Sc=	 Samr}', "");
    Expect(1, 2111, '\P{Sc=	 Samr}', "");
    Expect(0, 2111, '\P{^Sc=	 Samr}', "");
    Error('\p{Is_Script:   /a/SAMARITAN}');
    Error('\P{Is_Script:   /a/SAMARITAN}');
    Expect(1, 2110, '\p{Is_Script=samaritan}', "");
    Expect(0, 2110, '\p{^Is_Script=samaritan}', "");
    Expect(0, 2110, '\P{Is_Script=samaritan}', "");
    Expect(1, 2110, '\P{^Is_Script=samaritan}', "");
    Expect(0, 2111, '\p{Is_Script=samaritan}', "");
    Expect(1, 2111, '\p{^Is_Script=samaritan}', "");
    Expect(1, 2111, '\P{Is_Script=samaritan}', "");
    Expect(0, 2111, '\P{^Is_Script=samaritan}', "");
    Expect(1, 2110, '\p{Is_Script:  _samaritan}', "");
    Expect(0, 2110, '\p{^Is_Script:  _samaritan}', "");
    Expect(0, 2110, '\P{Is_Script:  _samaritan}', "");
    Expect(1, 2110, '\P{^Is_Script:  _samaritan}', "");
    Expect(0, 2111, '\p{Is_Script:  _samaritan}', "");
    Expect(1, 2111, '\p{^Is_Script:  _samaritan}', "");
    Expect(1, 2111, '\P{Is_Script:  _samaritan}', "");
    Expect(0, 2111, '\P{^Is_Script:  _samaritan}', "");
    Error('\p{Is_Sc=_/a/Samr}');
    Error('\P{Is_Sc=_/a/Samr}');
    Expect(1, 2110, '\p{Is_Sc=samr}', "");
    Expect(0, 2110, '\p{^Is_Sc=samr}', "");
    Expect(0, 2110, '\P{Is_Sc=samr}', "");
    Expect(1, 2110, '\P{^Is_Sc=samr}', "");
    Expect(0, 2111, '\p{Is_Sc=samr}', "");
    Expect(1, 2111, '\p{^Is_Sc=samr}', "");
    Expect(1, 2111, '\P{Is_Sc=samr}', "");
    Expect(0, 2111, '\P{^Is_Sc=samr}', "");
    Error('\p{Script=_/a/old_South_ARABIAN}');
    Error('\P{Script=_/a/old_South_ARABIAN}');
    Expect(1, 68223, '\p{Script=:\AOld_South_Arabian\z:}', "");;
    Expect(0, 68224, '\p{Script=:\AOld_South_Arabian\z:}', "");;
    Expect(1, 68223, '\p{Script=oldsoutharabian}', "");
    Expect(0, 68223, '\p{^Script=oldsoutharabian}', "");
    Expect(0, 68223, '\P{Script=oldsoutharabian}', "");
    Expect(1, 68223, '\P{^Script=oldsoutharabian}', "");
    Expect(0, 68224, '\p{Script=oldsoutharabian}', "");
    Expect(1, 68224, '\p{^Script=oldsoutharabian}', "");
    Expect(1, 68224, '\P{Script=oldsoutharabian}', "");
    Expect(0, 68224, '\P{^Script=oldsoutharabian}', "");
    Expect(1, 68223, '\p{Script=:\Aoldsoutharabian\z:}', "");;
    Expect(0, 68224, '\p{Script=:\Aoldsoutharabian\z:}', "");;
    Expect(1, 68223, '\p{Script=- OLD_South_Arabian}', "");
    Expect(0, 68223, '\p{^Script=- OLD_South_Arabian}', "");
    Expect(0, 68223, '\P{Script=- OLD_South_Arabian}', "");
    Expect(1, 68223, '\P{^Script=- OLD_South_Arabian}', "");
    Expect(0, 68224, '\p{Script=- OLD_South_Arabian}', "");
    Expect(1, 68224, '\p{^Script=- OLD_South_Arabian}', "");
    Expect(1, 68224, '\P{Script=- OLD_South_Arabian}', "");
    Expect(0, 68224, '\P{^Script=- OLD_South_Arabian}', "");
    Error('\p{Sc=_sarb/a/}');
    Error('\P{Sc=_sarb/a/}');
    Expect(1, 68223, '\p{Sc=:\ASarb\z:}', "");;
    Expect(0, 68224, '\p{Sc=:\ASarb\z:}', "");;
    Expect(1, 68223, '\p{Sc=sarb}', "");
    Expect(0, 68223, '\p{^Sc=sarb}', "");
    Expect(0, 68223, '\P{Sc=sarb}', "");
    Expect(1, 68223, '\P{^Sc=sarb}', "");
    Expect(0, 68224, '\p{Sc=sarb}', "");
    Expect(1, 68224, '\p{^Sc=sarb}', "");
    Expect(1, 68224, '\P{Sc=sarb}', "");
    Expect(0, 68224, '\P{^Sc=sarb}', "");
    Expect(1, 68223, '\p{Sc=:\Asarb\z:}', "");;
    Expect(0, 68224, '\p{Sc=:\Asarb\z:}', "");;
    Expect(1, 68223, '\p{Sc=_ Sarb}', "");
    Expect(0, 68223, '\p{^Sc=_ Sarb}', "");
    Expect(0, 68223, '\P{Sc=_ Sarb}', "");
    Expect(1, 68223, '\P{^Sc=_ Sarb}', "");
    Expect(0, 68224, '\p{Sc=_ Sarb}', "");
    Expect(1, 68224, '\p{^Sc=_ Sarb}', "");
    Expect(1, 68224, '\P{Sc=_ Sarb}', "");
    Expect(0, 68224, '\P{^Sc=_ Sarb}', "");
    Error('\p{Is_Script=:=__Old_South_Arabian}');
    Error('\P{Is_Script=:=__Old_South_Arabian}');
    Expect(1, 68223, '\p{Is_Script=oldsoutharabian}', "");
    Expect(0, 68223, '\p{^Is_Script=oldsoutharabian}', "");
    Expect(0, 68223, '\P{Is_Script=oldsoutharabian}', "");
    Expect(1, 68223, '\P{^Is_Script=oldsoutharabian}', "");
    Expect(0, 68224, '\p{Is_Script=oldsoutharabian}', "");
    Expect(1, 68224, '\p{^Is_Script=oldsoutharabian}', "");
    Expect(1, 68224, '\P{Is_Script=oldsoutharabian}', "");
    Expect(0, 68224, '\P{^Is_Script=oldsoutharabian}', "");
    Expect(1, 68223, '\p{Is_Script=	-Old_South_ARABIAN}', "");
    Expect(0, 68223, '\p{^Is_Script=	-Old_South_ARABIAN}', "");
    Expect(0, 68223, '\P{Is_Script=	-Old_South_ARABIAN}', "");
    Expect(1, 68223, '\P{^Is_Script=	-Old_South_ARABIAN}', "");
    Expect(0, 68224, '\p{Is_Script=	-Old_South_ARABIAN}', "");
    Expect(1, 68224, '\p{^Is_Script=	-Old_South_ARABIAN}', "");
    Expect(1, 68224, '\P{Is_Script=	-Old_South_ARABIAN}', "");
    Expect(0, 68224, '\P{^Is_Script=	-Old_South_ARABIAN}', "");
    Error('\p{Is_Sc= 	SARB/a/}');
    Error('\P{Is_Sc= 	SARB/a/}');
    Expect(1, 68223, '\p{Is_Sc=sarb}', "");
    Expect(0, 68223, '\p{^Is_Sc=sarb}', "");
    Expect(0, 68223, '\P{Is_Sc=sarb}', "");
    Expect(1, 68223, '\P{^Is_Sc=sarb}', "");
    Expect(0, 68224, '\p{Is_Sc=sarb}', "");
    Expect(1, 68224, '\p{^Is_Sc=sarb}', "");
    Expect(1, 68224, '\P{Is_Sc=sarb}', "");
    Expect(0, 68224, '\P{^Is_Sc=sarb}', "");
    Expect(1, 68223, '\p{Is_Sc=-	SARB}', "");
    Expect(0, 68223, '\p{^Is_Sc=-	SARB}', "");
    Expect(0, 68223, '\P{Is_Sc=-	SARB}', "");
    Expect(1, 68223, '\P{^Is_Sc=-	SARB}', "");
    Expect(0, 68224, '\p{Is_Sc=-	SARB}', "");
    Expect(1, 68224, '\p{^Is_Sc=-	SARB}', "");
    Expect(1, 68224, '\P{Is_Sc=-	SARB}', "");
    Expect(0, 68224, '\P{^Is_Sc=-	SARB}', "");
    Error('\p{Script=:=Saurashtra}');
    Error('\P{Script=:=Saurashtra}');
    Expect(1, 43225, '\p{Script=:\ASaurashtra\z:}', "");;
    Expect(0, 43226, '\p{Script=:\ASaurashtra\z:}', "");;
    Expect(1, 43225, '\p{Script=saurashtra}', "");
    Expect(0, 43225, '\p{^Script=saurashtra}', "");
    Expect(0, 43225, '\P{Script=saurashtra}', "");
    Expect(1, 43225, '\P{^Script=saurashtra}', "");
    Expect(0, 43226, '\p{Script=saurashtra}', "");
    Expect(1, 43226, '\p{^Script=saurashtra}', "");
    Expect(1, 43226, '\P{Script=saurashtra}', "");
    Expect(0, 43226, '\P{^Script=saurashtra}', "");
    Expect(1, 43225, '\p{Script=:\Asaurashtra\z:}', "");;
    Expect(0, 43226, '\p{Script=:\Asaurashtra\z:}', "");;
    Expect(1, 43225, '\p{Script=	saurashtra}', "");
    Expect(0, 43225, '\p{^Script=	saurashtra}', "");
    Expect(0, 43225, '\P{Script=	saurashtra}', "");
    Expect(1, 43225, '\P{^Script=	saurashtra}', "");
    Expect(0, 43226, '\p{Script=	saurashtra}', "");
    Expect(1, 43226, '\p{^Script=	saurashtra}', "");
    Expect(1, 43226, '\P{Script=	saurashtra}', "");
    Expect(0, 43226, '\P{^Script=	saurashtra}', "");
    Error('\p{Sc=	 saur/a/}');
    Error('\P{Sc=	 saur/a/}');
    Expect(1, 43225, '\p{Sc=:\ASaur\z:}', "");;
    Expect(0, 43226, '\p{Sc=:\ASaur\z:}', "");;
    Expect(1, 43225, '\p{Sc=saur}', "");
    Expect(0, 43225, '\p{^Sc=saur}', "");
    Expect(0, 43225, '\P{Sc=saur}', "");
    Expect(1, 43225, '\P{^Sc=saur}', "");
    Expect(0, 43226, '\p{Sc=saur}', "");
    Expect(1, 43226, '\p{^Sc=saur}', "");
    Expect(1, 43226, '\P{Sc=saur}', "");
    Expect(0, 43226, '\P{^Sc=saur}', "");
    Expect(1, 43225, '\p{Sc=:\Asaur\z:}', "");;
    Expect(0, 43226, '\p{Sc=:\Asaur\z:}', "");;
    Expect(1, 43225, '\p{Sc=-Saur}', "");
    Expect(0, 43225, '\p{^Sc=-Saur}', "");
    Expect(0, 43225, '\P{Sc=-Saur}', "");
    Expect(1, 43225, '\P{^Sc=-Saur}', "");
    Expect(0, 43226, '\p{Sc=-Saur}', "");
    Expect(1, 43226, '\p{^Sc=-Saur}', "");
    Expect(1, 43226, '\P{Sc=-Saur}', "");
    Expect(0, 43226, '\P{^Sc=-Saur}', "");
    Error('\p{Is_Script=/a/	-SAURASHTRA}');
    Error('\P{Is_Script=/a/	-SAURASHTRA}');
    Expect(1, 43225, '\p{Is_Script=saurashtra}', "");
    Expect(0, 43225, '\p{^Is_Script=saurashtra}', "");
    Expect(0, 43225, '\P{Is_Script=saurashtra}', "");
    Expect(1, 43225, '\P{^Is_Script=saurashtra}', "");
    Expect(0, 43226, '\p{Is_Script=saurashtra}', "");
    Expect(1, 43226, '\p{^Is_Script=saurashtra}', "");
    Expect(1, 43226, '\P{Is_Script=saurashtra}', "");
    Expect(0, 43226, '\P{^Is_Script=saurashtra}', "");
    Expect(1, 43225, '\p{Is_Script=-	Saurashtra}', "");
    Expect(0, 43225, '\p{^Is_Script=-	Saurashtra}', "");
    Expect(0, 43225, '\P{Is_Script=-	Saurashtra}', "");
    Expect(1, 43225, '\P{^Is_Script=-	Saurashtra}', "");
    Expect(0, 43226, '\p{Is_Script=-	Saurashtra}', "");
    Expect(1, 43226, '\p{^Is_Script=-	Saurashtra}', "");
    Expect(1, 43226, '\P{Is_Script=-	Saurashtra}', "");
    Expect(0, 43226, '\P{^Is_Script=-	Saurashtra}', "");
    Error('\p{Is_Sc:	/a/_ Saur}');
    Error('\P{Is_Sc:	/a/_ Saur}');
    Expect(1, 43225, '\p{Is_Sc=saur}', "");
    Expect(0, 43225, '\p{^Is_Sc=saur}', "");
    Expect(0, 43225, '\P{Is_Sc=saur}', "");
    Expect(1, 43225, '\P{^Is_Sc=saur}', "");
    Expect(0, 43226, '\p{Is_Sc=saur}', "");
    Expect(1, 43226, '\p{^Is_Sc=saur}', "");
    Expect(1, 43226, '\P{Is_Sc=saur}', "");
    Expect(0, 43226, '\P{^Is_Sc=saur}', "");
    Expect(1, 43225, '\p{Is_Sc=-Saur}', "");
    Expect(0, 43225, '\p{^Is_Sc=-Saur}', "");
    Expect(0, 43225, '\P{Is_Sc=-Saur}', "");
    Expect(1, 43225, '\P{^Is_Sc=-Saur}', "");
    Expect(0, 43226, '\p{Is_Sc=-Saur}', "");
    Expect(1, 43226, '\p{^Is_Sc=-Saur}', "");
    Expect(1, 43226, '\P{Is_Sc=-Saur}', "");
    Expect(0, 43226, '\P{^Is_Sc=-Saur}', "");
    Error('\p{Script=	 SIGNWRITING/a/}');
    Error('\P{Script=	 SIGNWRITING/a/}');
    Expect(1, 121519, '\p{Script=:\ASignWriting\z:}', "");;
    Expect(0, 121520, '\p{Script=:\ASignWriting\z:}', "");;
    Expect(1, 121519, '\p{Script=signwriting}', "");
    Expect(0, 121519, '\p{^Script=signwriting}', "");
    Expect(0, 121519, '\P{Script=signwriting}', "");
    Expect(1, 121519, '\P{^Script=signwriting}', "");
    Expect(0, 121520, '\p{Script=signwriting}', "");
    Expect(1, 121520, '\p{^Script=signwriting}', "");
    Expect(1, 121520, '\P{Script=signwriting}', "");
    Expect(0, 121520, '\P{^Script=signwriting}', "");
    Expect(1, 121519, '\p{Script=:\Asignwriting\z:}', "");;
    Expect(0, 121520, '\p{Script=:\Asignwriting\z:}', "");;
    Expect(1, 121519, '\p{Script=- SignWriting}', "");
    Expect(0, 121519, '\p{^Script=- SignWriting}', "");
    Expect(0, 121519, '\P{Script=- SignWriting}', "");
    Expect(1, 121519, '\P{^Script=- SignWriting}', "");
    Expect(0, 121520, '\p{Script=- SignWriting}', "");
    Expect(1, 121520, '\p{^Script=- SignWriting}', "");
    Expect(1, 121520, '\P{Script=- SignWriting}', "");
    Expect(0, 121520, '\P{^Script=- SignWriting}', "");
    Error('\p{Sc=:= _Sgnw}');
    Error('\P{Sc=:= _Sgnw}');
    Expect(1, 121519, '\p{Sc=:\ASgnw\z:}', "");;
    Expect(0, 121520, '\p{Sc=:\ASgnw\z:}', "");;
    Expect(1, 121519, '\p{Sc=sgnw}', "");
    Expect(0, 121519, '\p{^Sc=sgnw}', "");
    Expect(0, 121519, '\P{Sc=sgnw}', "");
    Expect(1, 121519, '\P{^Sc=sgnw}', "");
    Expect(0, 121520, '\p{Sc=sgnw}', "");
    Expect(1, 121520, '\p{^Sc=sgnw}', "");
    Expect(1, 121520, '\P{Sc=sgnw}', "");
    Expect(0, 121520, '\P{^Sc=sgnw}', "");
    Expect(1, 121519, '\p{Sc=:\Asgnw\z:}', "");;
    Expect(0, 121520, '\p{Sc=:\Asgnw\z:}', "");;
    Expect(1, 121519, '\p{Sc:	-Sgnw}', "");
    Expect(0, 121519, '\p{^Sc:	-Sgnw}', "");
    Expect(0, 121519, '\P{Sc:	-Sgnw}', "");
    Expect(1, 121519, '\P{^Sc:	-Sgnw}', "");
    Expect(0, 121520, '\p{Sc:	-Sgnw}', "");
    Expect(1, 121520, '\p{^Sc:	-Sgnw}', "");
    Expect(1, 121520, '\P{Sc:	-Sgnw}', "");
    Expect(0, 121520, '\P{^Sc:	-Sgnw}', "");
    Error('\p{Is_Script=/a/_SIGNWRITING}');
    Error('\P{Is_Script=/a/_SIGNWRITING}');
    Expect(1, 121519, '\p{Is_Script=signwriting}', "");
    Expect(0, 121519, '\p{^Is_Script=signwriting}', "");
    Expect(0, 121519, '\P{Is_Script=signwriting}', "");
    Expect(1, 121519, '\P{^Is_Script=signwriting}', "");
    Expect(0, 121520, '\p{Is_Script=signwriting}', "");
    Expect(1, 121520, '\p{^Is_Script=signwriting}', "");
    Expect(1, 121520, '\P{Is_Script=signwriting}', "");
    Expect(0, 121520, '\P{^Is_Script=signwriting}', "");
    Expect(1, 121519, '\p{Is_Script=- SignWriting}', "");
    Expect(0, 121519, '\p{^Is_Script=- SignWriting}', "");
    Expect(0, 121519, '\P{Is_Script=- SignWriting}', "");
    Expect(1, 121519, '\P{^Is_Script=- SignWriting}', "");
    Expect(0, 121520, '\p{Is_Script=- SignWriting}', "");
    Expect(1, 121520, '\p{^Is_Script=- SignWriting}', "");
    Expect(1, 121520, '\P{Is_Script=- SignWriting}', "");
    Expect(0, 121520, '\P{^Is_Script=- SignWriting}', "");
    Error('\p{Is_Sc= :=SGNW}');
    Error('\P{Is_Sc= :=SGNW}');
    Expect(1, 121519, '\p{Is_Sc=sgnw}', "");
    Expect(0, 121519, '\p{^Is_Sc=sgnw}', "");
    Expect(0, 121519, '\P{Is_Sc=sgnw}', "");
    Expect(1, 121519, '\P{^Is_Sc=sgnw}', "");
    Expect(0, 121520, '\p{Is_Sc=sgnw}', "");
    Expect(1, 121520, '\p{^Is_Sc=sgnw}', "");
    Expect(1, 121520, '\P{Is_Sc=sgnw}', "");
    Expect(0, 121520, '\P{^Is_Sc=sgnw}', "");
    Expect(1, 121519, '\p{Is_Sc=	SGNW}', "");
    Expect(0, 121519, '\p{^Is_Sc=	SGNW}', "");
    Expect(0, 121519, '\P{Is_Sc=	SGNW}', "");
    Expect(1, 121519, '\P{^Is_Sc=	SGNW}', "");
    Expect(0, 121520, '\p{Is_Sc=	SGNW}', "");
    Expect(1, 121520, '\p{^Is_Sc=	SGNW}', "");
    Expect(1, 121520, '\P{Is_Sc=	SGNW}', "");
    Expect(0, 121520, '\P{^Is_Sc=	SGNW}', "");
    Error('\p{Script:   _:=SHAVIAN}');
    Error('\P{Script:   _:=SHAVIAN}');
    Expect(1, 66687, '\p{Script=:\AShavian\z:}', "");;
    Expect(0, 66688, '\p{Script=:\AShavian\z:}', "");;
    Expect(1, 66687, '\p{Script=shavian}', "");
    Expect(0, 66687, '\p{^Script=shavian}', "");
    Expect(0, 66687, '\P{Script=shavian}', "");
    Expect(1, 66687, '\P{^Script=shavian}', "");
    Expect(0, 66688, '\p{Script=shavian}', "");
    Expect(1, 66688, '\p{^Script=shavian}', "");
    Expect(1, 66688, '\P{Script=shavian}', "");
    Expect(0, 66688, '\P{^Script=shavian}', "");
    Expect(1, 66687, '\p{Script=:\Ashavian\z:}', "");;
    Expect(0, 66688, '\p{Script=:\Ashavian\z:}', "");;
    Expect(1, 66687, '\p{Script=--Shavian}', "");
    Expect(0, 66687, '\p{^Script=--Shavian}', "");
    Expect(0, 66687, '\P{Script=--Shavian}', "");
    Expect(1, 66687, '\P{^Script=--Shavian}', "");
    Expect(0, 66688, '\p{Script=--Shavian}', "");
    Expect(1, 66688, '\p{^Script=--Shavian}', "");
    Expect(1, 66688, '\P{Script=--Shavian}', "");
    Expect(0, 66688, '\P{^Script=--Shavian}', "");
    Error('\p{Sc=_SHAW/a/}');
    Error('\P{Sc=_SHAW/a/}');
    Expect(1, 66687, '\p{Sc=:\AShaw\z:}', "");;
    Expect(0, 66688, '\p{Sc=:\AShaw\z:}', "");;
    Expect(1, 66687, '\p{Sc=shaw}', "");
    Expect(0, 66687, '\p{^Sc=shaw}', "");
    Expect(0, 66687, '\P{Sc=shaw}', "");
    Expect(1, 66687, '\P{^Sc=shaw}', "");
    Expect(0, 66688, '\p{Sc=shaw}', "");
    Expect(1, 66688, '\p{^Sc=shaw}', "");
    Expect(1, 66688, '\P{Sc=shaw}', "");
    Expect(0, 66688, '\P{^Sc=shaw}', "");
    Expect(1, 66687, '\p{Sc=:\Ashaw\z:}', "");;
    Expect(0, 66688, '\p{Sc=:\Ashaw\z:}', "");;
    Expect(1, 66687, '\p{Sc= _shaw}', "");
    Expect(0, 66687, '\p{^Sc= _shaw}', "");
    Expect(0, 66687, '\P{Sc= _shaw}', "");
    Expect(1, 66687, '\P{^Sc= _shaw}', "");
    Expect(0, 66688, '\p{Sc= _shaw}', "");
    Expect(1, 66688, '\p{^Sc= _shaw}', "");
    Expect(1, 66688, '\P{Sc= _shaw}', "");
    Expect(0, 66688, '\P{^Sc= _shaw}', "");
    Error('\p{Is_Script::=_	Shavian}');
    Error('\P{Is_Script::=_	Shavian}');
    Expect(1, 66687, '\p{Is_Script=shavian}', "");
    Expect(0, 66687, '\p{^Is_Script=shavian}', "");
    Expect(0, 66687, '\P{Is_Script=shavian}', "");
    Expect(1, 66687, '\P{^Is_Script=shavian}', "");
    Expect(0, 66688, '\p{Is_Script=shavian}', "");
    Expect(1, 66688, '\p{^Is_Script=shavian}', "");
    Expect(1, 66688, '\P{Is_Script=shavian}', "");
    Expect(0, 66688, '\P{^Is_Script=shavian}', "");
    Expect(1, 66687, '\p{Is_Script=	shavian}', "");
    Expect(0, 66687, '\p{^Is_Script=	shavian}', "");
    Expect(0, 66687, '\P{Is_Script=	shavian}', "");
    Expect(1, 66687, '\P{^Is_Script=	shavian}', "");
    Expect(0, 66688, '\p{Is_Script=	shavian}', "");
    Expect(1, 66688, '\p{^Is_Script=	shavian}', "");
    Expect(1, 66688, '\P{Is_Script=	shavian}', "");
    Expect(0, 66688, '\P{^Is_Script=	shavian}', "");
    Error('\p{Is_Sc=	Shaw/a/}');
    Error('\P{Is_Sc=	Shaw/a/}');
    Expect(1, 66687, '\p{Is_Sc:shaw}', "");
    Expect(0, 66687, '\p{^Is_Sc:shaw}', "");
    Expect(0, 66687, '\P{Is_Sc:shaw}', "");
    Expect(1, 66687, '\P{^Is_Sc:shaw}', "");
    Expect(0, 66688, '\p{Is_Sc:shaw}', "");
    Expect(1, 66688, '\p{^Is_Sc:shaw}', "");
    Expect(1, 66688, '\P{Is_Sc:shaw}', "");
    Expect(0, 66688, '\P{^Is_Sc:shaw}', "");
    Expect(1, 66687, '\p{Is_Sc=	SHAW}', "");
    Expect(0, 66687, '\p{^Is_Sc=	SHAW}', "");
    Expect(0, 66687, '\P{Is_Sc=	SHAW}', "");
    Expect(1, 66687, '\P{^Is_Sc=	SHAW}', "");
    Expect(0, 66688, '\p{Is_Sc=	SHAW}', "");
    Expect(1, 66688, '\p{^Is_Sc=	SHAW}', "");
    Expect(1, 66688, '\P{Is_Sc=	SHAW}', "");
    Expect(0, 66688, '\P{^Is_Sc=	SHAW}', "");
    Error('\p{Script: /a/		Sharada}');
    Error('\P{Script: /a/		Sharada}');
    Expect(1, 70111, '\p{Script=:\ASharada\z:}', "");;
    Expect(0, 70112, '\p{Script=:\ASharada\z:}', "");;
    Expect(1, 70111, '\p{Script=sharada}', "");
    Expect(0, 70111, '\p{^Script=sharada}', "");
    Expect(0, 70111, '\P{Script=sharada}', "");
    Expect(1, 70111, '\P{^Script=sharada}', "");
    Expect(0, 70112, '\p{Script=sharada}', "");
    Expect(1, 70112, '\p{^Script=sharada}', "");
    Expect(1, 70112, '\P{Script=sharada}', "");
    Expect(0, 70112, '\P{^Script=sharada}', "");
    Expect(1, 70111, '\p{Script=:\Asharada\z:}', "");;
    Expect(0, 70112, '\p{Script=:\Asharada\z:}', "");;
    Expect(1, 70111, '\p{Script=_ Sharada}', "");
    Expect(0, 70111, '\p{^Script=_ Sharada}', "");
    Expect(0, 70111, '\P{Script=_ Sharada}', "");
    Expect(1, 70111, '\P{^Script=_ Sharada}', "");
    Expect(0, 70112, '\p{Script=_ Sharada}', "");
    Expect(1, 70112, '\p{^Script=_ Sharada}', "");
    Expect(1, 70112, '\P{Script=_ Sharada}', "");
    Expect(0, 70112, '\P{^Script=_ Sharada}', "");
    Error('\p{Sc=_:=SHRD}');
    Error('\P{Sc=_:=SHRD}');
    Expect(1, 70111, '\p{Sc=:\AShrd\z:}', "");;
    Expect(0, 70112, '\p{Sc=:\AShrd\z:}', "");;
    Expect(1, 70111, '\p{Sc=shrd}', "");
    Expect(0, 70111, '\p{^Sc=shrd}', "");
    Expect(0, 70111, '\P{Sc=shrd}', "");
    Expect(1, 70111, '\P{^Sc=shrd}', "");
    Expect(0, 70112, '\p{Sc=shrd}', "");
    Expect(1, 70112, '\p{^Sc=shrd}', "");
    Expect(1, 70112, '\P{Sc=shrd}', "");
    Expect(0, 70112, '\P{^Sc=shrd}', "");
    Expect(1, 70111, '\p{Sc=:\Ashrd\z:}', "");;
    Expect(0, 70112, '\p{Sc=:\Ashrd\z:}', "");;
    Expect(1, 70111, '\p{Sc=		SHRD}', "");
    Expect(0, 70111, '\p{^Sc=		SHRD}', "");
    Expect(0, 70111, '\P{Sc=		SHRD}', "");
    Expect(1, 70111, '\P{^Sc=		SHRD}', "");
    Expect(0, 70112, '\p{Sc=		SHRD}', "");
    Expect(1, 70112, '\p{^Sc=		SHRD}', "");
    Expect(1, 70112, '\P{Sc=		SHRD}', "");
    Expect(0, 70112, '\P{^Sc=		SHRD}', "");
    Error('\p{Is_Script=/a/-_sharada}');
    Error('\P{Is_Script=/a/-_sharada}');
    Expect(1, 70111, '\p{Is_Script=sharada}', "");
    Expect(0, 70111, '\p{^Is_Script=sharada}', "");
    Expect(0, 70111, '\P{Is_Script=sharada}', "");
    Expect(1, 70111, '\P{^Is_Script=sharada}', "");
    Expect(0, 70112, '\p{Is_Script=sharada}', "");
    Expect(1, 70112, '\p{^Is_Script=sharada}', "");
    Expect(1, 70112, '\P{Is_Script=sharada}', "");
    Expect(0, 70112, '\P{^Is_Script=sharada}', "");
    Expect(1, 70111, '\p{Is_Script=_sharada}', "");
    Expect(0, 70111, '\p{^Is_Script=_sharada}', "");
    Expect(0, 70111, '\P{Is_Script=_sharada}', "");
    Expect(1, 70111, '\P{^Is_Script=_sharada}', "");
    Expect(0, 70112, '\p{Is_Script=_sharada}', "");
    Expect(1, 70112, '\p{^Is_Script=_sharada}', "");
    Expect(1, 70112, '\P{Is_Script=_sharada}', "");
    Expect(0, 70112, '\P{^Is_Script=_sharada}', "");
    Error('\p{Is_Sc=-:=SHRD}');
    Error('\P{Is_Sc=-:=SHRD}');
    Expect(1, 70111, '\p{Is_Sc=shrd}', "");
    Expect(0, 70111, '\p{^Is_Sc=shrd}', "");
    Expect(0, 70111, '\P{Is_Sc=shrd}', "");
    Expect(1, 70111, '\P{^Is_Sc=shrd}', "");
    Expect(0, 70112, '\p{Is_Sc=shrd}', "");
    Expect(1, 70112, '\p{^Is_Sc=shrd}', "");
    Expect(1, 70112, '\P{Is_Sc=shrd}', "");
    Expect(0, 70112, '\P{^Is_Sc=shrd}', "");
    Expect(1, 70111, '\p{Is_Sc=	shrd}', "");
    Expect(0, 70111, '\p{^Is_Sc=	shrd}', "");
    Expect(0, 70111, '\P{Is_Sc=	shrd}', "");
    Expect(1, 70111, '\P{^Is_Sc=	shrd}', "");
    Expect(0, 70112, '\p{Is_Sc=	shrd}', "");
    Expect(1, 70112, '\p{^Is_Sc=	shrd}', "");
    Expect(1, 70112, '\P{Is_Sc=	shrd}', "");
    Expect(0, 70112, '\P{^Is_Sc=	shrd}', "");
    Error('\p{Script= 	Siddham/a/}');
    Error('\P{Script= 	Siddham/a/}');
    Expect(1, 71133, '\p{Script=:\ASiddham\z:}', "");;
    Expect(0, 71134, '\p{Script=:\ASiddham\z:}', "");;
    Expect(1, 71133, '\p{Script:siddham}', "");
    Expect(0, 71133, '\p{^Script:siddham}', "");
    Expect(0, 71133, '\P{Script:siddham}', "");
    Expect(1, 71133, '\P{^Script:siddham}', "");
    Expect(0, 71134, '\p{Script:siddham}', "");
    Expect(1, 71134, '\p{^Script:siddham}', "");
    Expect(1, 71134, '\P{Script:siddham}', "");
    Expect(0, 71134, '\P{^Script:siddham}', "");
    Expect(1, 71133, '\p{Script=:\Asiddham\z:}', "");;
    Expect(0, 71134, '\p{Script=:\Asiddham\z:}', "");;
    Expect(1, 71133, '\p{Script=-	Siddham}', "");
    Expect(0, 71133, '\p{^Script=-	Siddham}', "");
    Expect(0, 71133, '\P{Script=-	Siddham}', "");
    Expect(1, 71133, '\P{^Script=-	Siddham}', "");
    Expect(0, 71134, '\p{Script=-	Siddham}', "");
    Expect(1, 71134, '\p{^Script=-	Siddham}', "");
    Expect(1, 71134, '\P{Script=-	Siddham}', "");
    Expect(0, 71134, '\P{^Script=-	Siddham}', "");
    Error('\p{Sc=_	Sidd:=}');
    Error('\P{Sc=_	Sidd:=}');
    Expect(1, 71133, '\p{Sc=:\ASidd\z:}', "");;
    Expect(0, 71134, '\p{Sc=:\ASidd\z:}', "");;
    Expect(1, 71133, '\p{Sc: sidd}', "");
    Expect(0, 71133, '\p{^Sc: sidd}', "");
    Expect(0, 71133, '\P{Sc: sidd}', "");
    Expect(1, 71133, '\P{^Sc: sidd}', "");
    Expect(0, 71134, '\p{Sc: sidd}', "");
    Expect(1, 71134, '\p{^Sc: sidd}', "");
    Expect(1, 71134, '\P{Sc: sidd}', "");
    Expect(0, 71134, '\P{^Sc: sidd}', "");
    Expect(1, 71133, '\p{Sc=:\Asidd\z:}', "");;
    Expect(0, 71134, '\p{Sc=:\Asidd\z:}', "");;
    Expect(1, 71133, '\p{Sc= sidd}', "");
    Expect(0, 71133, '\p{^Sc= sidd}', "");
    Expect(0, 71133, '\P{Sc= sidd}', "");
    Expect(1, 71133, '\P{^Sc= sidd}', "");
    Expect(0, 71134, '\p{Sc= sidd}', "");
    Expect(1, 71134, '\p{^Sc= sidd}', "");
    Expect(1, 71134, '\P{Sc= sidd}', "");
    Expect(0, 71134, '\P{^Sc= sidd}', "");
    Error('\p{Is_Script=	 siddham:=}');
    Error('\P{Is_Script=	 siddham:=}');
    Expect(1, 71133, '\p{Is_Script=siddham}', "");
    Expect(0, 71133, '\p{^Is_Script=siddham}', "");
    Expect(0, 71133, '\P{Is_Script=siddham}', "");
    Expect(1, 71133, '\P{^Is_Script=siddham}', "");
    Expect(0, 71134, '\p{Is_Script=siddham}', "");
    Expect(1, 71134, '\p{^Is_Script=siddham}', "");
    Expect(1, 71134, '\P{Is_Script=siddham}', "");
    Expect(0, 71134, '\P{^Is_Script=siddham}', "");
    Expect(1, 71133, '\p{Is_Script=-Siddham}', "");
    Expect(0, 71133, '\p{^Is_Script=-Siddham}', "");
    Expect(0, 71133, '\P{Is_Script=-Siddham}', "");
    Expect(1, 71133, '\P{^Is_Script=-Siddham}', "");
    Expect(0, 71134, '\p{Is_Script=-Siddham}', "");
    Expect(1, 71134, '\p{^Is_Script=-Siddham}', "");
    Expect(1, 71134, '\P{Is_Script=-Siddham}', "");
    Expect(0, 71134, '\P{^Is_Script=-Siddham}', "");
    Error('\p{Is_Sc=/a/-Sidd}');
    Error('\P{Is_Sc=/a/-Sidd}');
    Expect(1, 71133, '\p{Is_Sc:   sidd}', "");
    Expect(0, 71133, '\p{^Is_Sc:   sidd}', "");
    Expect(0, 71133, '\P{Is_Sc:   sidd}', "");
    Expect(1, 71133, '\P{^Is_Sc:   sidd}', "");
    Expect(0, 71134, '\p{Is_Sc:   sidd}', "");
    Expect(1, 71134, '\p{^Is_Sc:   sidd}', "");
    Expect(1, 71134, '\P{Is_Sc:   sidd}', "");
    Expect(0, 71134, '\P{^Is_Sc:   sidd}', "");
    Expect(1, 71133, '\p{Is_Sc=	-Sidd}', "");
    Expect(0, 71133, '\p{^Is_Sc=	-Sidd}', "");
    Expect(0, 71133, '\P{Is_Sc=	-Sidd}', "");
    Expect(1, 71133, '\P{^Is_Sc=	-Sidd}', "");
    Expect(0, 71134, '\p{Is_Sc=	-Sidd}', "");
    Expect(1, 71134, '\p{^Is_Sc=	-Sidd}', "");
    Expect(1, 71134, '\P{Is_Sc=	-Sidd}', "");
    Expect(0, 71134, '\P{^Is_Sc=	-Sidd}', "");
    Error('\p{Script:-_Khudawadi:=}');
    Error('\P{Script:-_Khudawadi:=}');
    Expect(1, 70393, '\p{Script=:\AKhudawadi\z:}', "");;
    Expect(0, 70394, '\p{Script=:\AKhudawadi\z:}', "");;
    Expect(1, 70393, '\p{Script=khudawadi}', "");
    Expect(0, 70393, '\p{^Script=khudawadi}', "");
    Expect(0, 70393, '\P{Script=khudawadi}', "");
    Expect(1, 70393, '\P{^Script=khudawadi}', "");
    Expect(0, 70394, '\p{Script=khudawadi}', "");
    Expect(1, 70394, '\p{^Script=khudawadi}', "");
    Expect(1, 70394, '\P{Script=khudawadi}', "");
    Expect(0, 70394, '\P{^Script=khudawadi}', "");
    Expect(1, 70393, '\p{Script=:\Akhudawadi\z:}', "");;
    Expect(0, 70394, '\p{Script=:\Akhudawadi\z:}', "");;
    Expect(1, 70393, '\p{Script=__KHUDAWADI}', "");
    Expect(0, 70393, '\p{^Script=__KHUDAWADI}', "");
    Expect(0, 70393, '\P{Script=__KHUDAWADI}', "");
    Expect(1, 70393, '\P{^Script=__KHUDAWADI}', "");
    Expect(0, 70394, '\p{Script=__KHUDAWADI}', "");
    Expect(1, 70394, '\p{^Script=__KHUDAWADI}', "");
    Expect(1, 70394, '\P{Script=__KHUDAWADI}', "");
    Expect(0, 70394, '\P{^Script=__KHUDAWADI}', "");
    Error('\p{Sc=_SIND/a/}');
    Error('\P{Sc=_SIND/a/}');
    Expect(1, 70393, '\p{Sc=:\ASind\z:}', "");;
    Expect(0, 70394, '\p{Sc=:\ASind\z:}', "");;
    Expect(1, 70393, '\p{Sc=sind}', "");
    Expect(0, 70393, '\p{^Sc=sind}', "");
    Expect(0, 70393, '\P{Sc=sind}', "");
    Expect(1, 70393, '\P{^Sc=sind}', "");
    Expect(0, 70394, '\p{Sc=sind}', "");
    Expect(1, 70394, '\p{^Sc=sind}', "");
    Expect(1, 70394, '\P{Sc=sind}', "");
    Expect(0, 70394, '\P{^Sc=sind}', "");
    Expect(1, 70393, '\p{Sc=:\Asind\z:}', "");;
    Expect(0, 70394, '\p{Sc=:\Asind\z:}', "");;
    Expect(1, 70393, '\p{Sc:   -Sind}', "");
    Expect(0, 70393, '\p{^Sc:   -Sind}', "");
    Expect(0, 70393, '\P{Sc:   -Sind}', "");
    Expect(1, 70393, '\P{^Sc:   -Sind}', "");
    Expect(0, 70394, '\p{Sc:   -Sind}', "");
    Expect(1, 70394, '\p{^Sc:   -Sind}', "");
    Expect(1, 70394, '\P{Sc:   -Sind}', "");
    Expect(0, 70394, '\P{^Sc:   -Sind}', "");
    Error('\p{Is_Script=-/a/khudawadi}');
    Error('\P{Is_Script=-/a/khudawadi}');
    Expect(1, 70393, '\p{Is_Script=khudawadi}', "");
    Expect(0, 70393, '\p{^Is_Script=khudawadi}', "");
    Expect(0, 70393, '\P{Is_Script=khudawadi}', "");
    Expect(1, 70393, '\P{^Is_Script=khudawadi}', "");
    Expect(0, 70394, '\p{Is_Script=khudawadi}', "");
    Expect(1, 70394, '\p{^Is_Script=khudawadi}', "");
    Expect(1, 70394, '\P{Is_Script=khudawadi}', "");
    Expect(0, 70394, '\P{^Is_Script=khudawadi}', "");
    Expect(1, 70393, '\p{Is_Script=_ KHUDAWADI}', "");
    Expect(0, 70393, '\p{^Is_Script=_ KHUDAWADI}', "");
    Expect(0, 70393, '\P{Is_Script=_ KHUDAWADI}', "");
    Expect(1, 70393, '\P{^Is_Script=_ KHUDAWADI}', "");
    Expect(0, 70394, '\p{Is_Script=_ KHUDAWADI}', "");
    Expect(1, 70394, '\p{^Is_Script=_ KHUDAWADI}', "");
    Expect(1, 70394, '\P{Is_Script=_ KHUDAWADI}', "");
    Expect(0, 70394, '\P{^Is_Script=_ KHUDAWADI}', "");
    Error('\p{Is_Sc= :=sind}');
    Error('\P{Is_Sc= :=sind}');
    Expect(1, 70393, '\p{Is_Sc=sind}', "");
    Expect(0, 70393, '\p{^Is_Sc=sind}', "");
    Expect(0, 70393, '\P{Is_Sc=sind}', "");
    Expect(1, 70393, '\P{^Is_Sc=sind}', "");
    Expect(0, 70394, '\p{Is_Sc=sind}', "");
    Expect(1, 70394, '\p{^Is_Sc=sind}', "");
    Expect(1, 70394, '\P{Is_Sc=sind}', "");
    Expect(0, 70394, '\P{^Is_Sc=sind}', "");
    Expect(1, 70393, '\p{Is_Sc= -SIND}', "");
    Expect(0, 70393, '\p{^Is_Sc= -SIND}', "");
    Expect(0, 70393, '\P{Is_Sc= -SIND}', "");
    Expect(1, 70393, '\P{^Is_Sc= -SIND}', "");
    Expect(0, 70394, '\p{Is_Sc= -SIND}', "");
    Expect(1, 70394, '\p{^Is_Sc= -SIND}', "");
    Expect(1, 70394, '\P{Is_Sc= -SIND}', "");
    Expect(0, 70394, '\P{^Is_Sc= -SIND}', "");
    Error('\p{Script=-/a/Sinhala}');
    Error('\P{Script=-/a/Sinhala}');
    Expect(1, 70132, '\p{Script=:\ASinhala\z:}', "");;
    Expect(0, 70133, '\p{Script=:\ASinhala\z:}', "");;
    Expect(1, 70132, '\p{Script=sinhala}', "");
    Expect(0, 70132, '\p{^Script=sinhala}', "");
    Expect(0, 70132, '\P{Script=sinhala}', "");
    Expect(1, 70132, '\P{^Script=sinhala}', "");
    Expect(0, 70133, '\p{Script=sinhala}', "");
    Expect(1, 70133, '\p{^Script=sinhala}', "");
    Expect(1, 70133, '\P{Script=sinhala}', "");
    Expect(0, 70133, '\P{^Script=sinhala}', "");
    Expect(1, 70132, '\p{Script=:\Asinhala\z:}', "");;
    Expect(0, 70133, '\p{Script=:\Asinhala\z:}', "");;
    Expect(1, 70132, '\p{Script=-_Sinhala}', "");
    Expect(0, 70132, '\p{^Script=-_Sinhala}', "");
    Expect(0, 70132, '\P{Script=-_Sinhala}', "");
    Expect(1, 70132, '\P{^Script=-_Sinhala}', "");
    Expect(0, 70133, '\p{Script=-_Sinhala}', "");
    Expect(1, 70133, '\p{^Script=-_Sinhala}', "");
    Expect(1, 70133, '\P{Script=-_Sinhala}', "");
    Expect(0, 70133, '\P{^Script=-_Sinhala}', "");
    Error('\p{Sc=_-sinh:=}');
    Error('\P{Sc=_-sinh:=}');
    Expect(1, 70132, '\p{Sc=:\ASinh\z:}', "");;
    Expect(0, 70133, '\p{Sc=:\ASinh\z:}', "");;
    Expect(1, 70132, '\p{Sc=sinh}', "");
    Expect(0, 70132, '\p{^Sc=sinh}', "");
    Expect(0, 70132, '\P{Sc=sinh}', "");
    Expect(1, 70132, '\P{^Sc=sinh}', "");
    Expect(0, 70133, '\p{Sc=sinh}', "");
    Expect(1, 70133, '\p{^Sc=sinh}', "");
    Expect(1, 70133, '\P{Sc=sinh}', "");
    Expect(0, 70133, '\P{^Sc=sinh}', "");
    Expect(1, 70132, '\p{Sc=:\Asinh\z:}', "");;
    Expect(0, 70133, '\p{Sc=:\Asinh\z:}', "");;
    Expect(1, 70132, '\p{Sc:   - Sinh}', "");
    Expect(0, 70132, '\p{^Sc:   - Sinh}', "");
    Expect(0, 70132, '\P{Sc:   - Sinh}', "");
    Expect(1, 70132, '\P{^Sc:   - Sinh}', "");
    Expect(0, 70133, '\p{Sc:   - Sinh}', "");
    Expect(1, 70133, '\p{^Sc:   - Sinh}', "");
    Expect(1, 70133, '\P{Sc:   - Sinh}', "");
    Expect(0, 70133, '\P{^Sc:   - Sinh}', "");
    Error('\p{Is_Script=_:=Sinhala}');
    Error('\P{Is_Script=_:=Sinhala}');
    Expect(1, 70132, '\p{Is_Script=sinhala}', "");
    Expect(0, 70132, '\p{^Is_Script=sinhala}', "");
    Expect(0, 70132, '\P{Is_Script=sinhala}', "");
    Expect(1, 70132, '\P{^Is_Script=sinhala}', "");
    Expect(0, 70133, '\p{Is_Script=sinhala}', "");
    Expect(1, 70133, '\p{^Is_Script=sinhala}', "");
    Expect(1, 70133, '\P{Is_Script=sinhala}', "");
    Expect(0, 70133, '\P{^Is_Script=sinhala}', "");
    Expect(1, 70132, '\p{Is_Script:   _Sinhala}', "");
    Expect(0, 70132, '\p{^Is_Script:   _Sinhala}', "");
    Expect(0, 70132, '\P{Is_Script:   _Sinhala}', "");
    Expect(1, 70132, '\P{^Is_Script:   _Sinhala}', "");
    Expect(0, 70133, '\p{Is_Script:   _Sinhala}', "");
    Expect(1, 70133, '\p{^Is_Script:   _Sinhala}', "");
    Expect(1, 70133, '\P{Is_Script:   _Sinhala}', "");
    Expect(0, 70133, '\P{^Is_Script:   _Sinhala}', "");
    Error('\p{Is_Sc=:=_-sinh}');
    Error('\P{Is_Sc=:=_-sinh}');
    Expect(1, 70132, '\p{Is_Sc=sinh}', "");
    Expect(0, 70132, '\p{^Is_Sc=sinh}', "");
    Expect(0, 70132, '\P{Is_Sc=sinh}', "");
    Expect(1, 70132, '\P{^Is_Sc=sinh}', "");
    Expect(0, 70133, '\p{Is_Sc=sinh}', "");
    Expect(1, 70133, '\p{^Is_Sc=sinh}', "");
    Expect(1, 70133, '\P{Is_Sc=sinh}', "");
    Expect(0, 70133, '\P{^Is_Sc=sinh}', "");
    Expect(1, 70132, '\p{Is_Sc=		SINH}', "");
    Expect(0, 70132, '\p{^Is_Sc=		SINH}', "");
    Expect(0, 70132, '\P{Is_Sc=		SINH}', "");
    Expect(1, 70132, '\P{^Is_Sc=		SINH}', "");
    Expect(0, 70133, '\p{Is_Sc=		SINH}', "");
    Expect(1, 70133, '\p{^Is_Sc=		SINH}', "");
    Expect(1, 70133, '\P{Is_Sc=		SINH}', "");
    Expect(0, 70133, '\P{^Is_Sc=		SINH}', "");
    Error('\p{Script=_-Sogdian:=}');
    Error('\P{Script=_-Sogdian:=}');
    Expect(1, 69465, '\p{Script=:\ASogdian\z:}', "");;
    Expect(0, 69466, '\p{Script=:\ASogdian\z:}', "");;
    Expect(1, 69465, '\p{Script=sogdian}', "");
    Expect(0, 69465, '\p{^Script=sogdian}', "");
    Expect(0, 69465, '\P{Script=sogdian}', "");
    Expect(1, 69465, '\P{^Script=sogdian}', "");
    Expect(0, 69466, '\p{Script=sogdian}', "");
    Expect(1, 69466, '\p{^Script=sogdian}', "");
    Expect(1, 69466, '\P{Script=sogdian}', "");
    Expect(0, 69466, '\P{^Script=sogdian}', "");
    Expect(1, 69465, '\p{Script=:\Asogdian\z:}', "");;
    Expect(0, 69466, '\p{Script=:\Asogdian\z:}', "");;
    Expect(1, 69465, '\p{Script=	Sogdian}', "");
    Expect(0, 69465, '\p{^Script=	Sogdian}', "");
    Expect(0, 69465, '\P{Script=	Sogdian}', "");
    Expect(1, 69465, '\P{^Script=	Sogdian}', "");
    Expect(0, 69466, '\p{Script=	Sogdian}', "");
    Expect(1, 69466, '\p{^Script=	Sogdian}', "");
    Expect(1, 69466, '\P{Script=	Sogdian}', "");
    Expect(0, 69466, '\P{^Script=	Sogdian}', "");
    Error('\p{Sc=_:=Sogd}');
    Error('\P{Sc=_:=Sogd}');
    Expect(1, 69465, '\p{Sc=:\ASogd\z:}', "");;
    Expect(0, 69466, '\p{Sc=:\ASogd\z:}', "");;
    Expect(1, 69465, '\p{Sc:sogd}', "");
    Expect(0, 69465, '\p{^Sc:sogd}', "");
    Expect(0, 69465, '\P{Sc:sogd}', "");
    Expect(1, 69465, '\P{^Sc:sogd}', "");
    Expect(0, 69466, '\p{Sc:sogd}', "");
    Expect(1, 69466, '\p{^Sc:sogd}', "");
    Expect(1, 69466, '\P{Sc:sogd}', "");
    Expect(0, 69466, '\P{^Sc:sogd}', "");
    Expect(1, 69465, '\p{Sc=:\Asogd\z:}', "");;
    Expect(0, 69466, '\p{Sc=:\Asogd\z:}', "");;
    Expect(1, 69465, '\p{Sc=-SOGD}', "");
    Expect(0, 69465, '\p{^Sc=-SOGD}', "");
    Expect(0, 69465, '\P{Sc=-SOGD}', "");
    Expect(1, 69465, '\P{^Sc=-SOGD}', "");
    Expect(0, 69466, '\p{Sc=-SOGD}', "");
    Expect(1, 69466, '\p{^Sc=-SOGD}', "");
    Expect(1, 69466, '\P{Sc=-SOGD}', "");
    Expect(0, 69466, '\P{^Sc=-SOGD}', "");
    Error('\p{Is_Script=_:=SOGDIAN}');
    Error('\P{Is_Script=_:=SOGDIAN}');
    Expect(1, 69465, '\p{Is_Script=sogdian}', "");
    Expect(0, 69465, '\p{^Is_Script=sogdian}', "");
    Expect(0, 69465, '\P{Is_Script=sogdian}', "");
    Expect(1, 69465, '\P{^Is_Script=sogdian}', "");
    Expect(0, 69466, '\p{Is_Script=sogdian}', "");
    Expect(1, 69466, '\p{^Is_Script=sogdian}', "");
    Expect(1, 69466, '\P{Is_Script=sogdian}', "");
    Expect(0, 69466, '\P{^Is_Script=sogdian}', "");
    Expect(1, 69465, '\p{Is_Script=	-sogdian}', "");
    Expect(0, 69465, '\p{^Is_Script=	-sogdian}', "");
    Expect(0, 69465, '\P{Is_Script=	-sogdian}', "");
    Expect(1, 69465, '\P{^Is_Script=	-sogdian}', "");
    Expect(0, 69466, '\p{Is_Script=	-sogdian}', "");
    Expect(1, 69466, '\p{^Is_Script=	-sogdian}', "");
    Expect(1, 69466, '\P{Is_Script=	-sogdian}', "");
    Expect(0, 69466, '\P{^Is_Script=	-sogdian}', "");
    Error('\p{Is_Sc=/a/-	Sogd}');
    Error('\P{Is_Sc=/a/-	Sogd}');
    Expect(1, 69465, '\p{Is_Sc=sogd}', "");
    Expect(0, 69465, '\p{^Is_Sc=sogd}', "");
    Expect(0, 69465, '\P{Is_Sc=sogd}', "");
    Expect(1, 69465, '\P{^Is_Sc=sogd}', "");
    Expect(0, 69466, '\p{Is_Sc=sogd}', "");
    Expect(1, 69466, '\p{^Is_Sc=sogd}', "");
    Expect(1, 69466, '\P{Is_Sc=sogd}', "");
    Expect(0, 69466, '\P{^Is_Sc=sogd}', "");
    Expect(1, 69465, '\p{Is_Sc=	-Sogd}', "");
    Expect(0, 69465, '\p{^Is_Sc=	-Sogd}', "");
    Expect(0, 69465, '\P{Is_Sc=	-Sogd}', "");
    Expect(1, 69465, '\P{^Is_Sc=	-Sogd}', "");
    Expect(0, 69466, '\p{Is_Sc=	-Sogd}', "");
    Expect(1, 69466, '\p{^Is_Sc=	-Sogd}', "");
    Expect(1, 69466, '\P{Is_Sc=	-Sogd}', "");
    Expect(0, 69466, '\P{^Is_Sc=	-Sogd}', "");
    Error('\p{Script=- Old_SOGDIAN:=}');
    Error('\P{Script=- Old_SOGDIAN:=}');
    Expect(1, 69415, '\p{Script=:\AOld_Sogdian\z:}', "");;
    Expect(0, 69416, '\p{Script=:\AOld_Sogdian\z:}', "");;
    Expect(1, 69415, '\p{Script=oldsogdian}', "");
    Expect(0, 69415, '\p{^Script=oldsogdian}', "");
    Expect(0, 69415, '\P{Script=oldsogdian}', "");
    Expect(1, 69415, '\P{^Script=oldsogdian}', "");
    Expect(0, 69416, '\p{Script=oldsogdian}', "");
    Expect(1, 69416, '\p{^Script=oldsogdian}', "");
    Expect(1, 69416, '\P{Script=oldsogdian}', "");
    Expect(0, 69416, '\P{^Script=oldsogdian}', "");
    Expect(1, 69415, '\p{Script=:\Aoldsogdian\z:}', "");;
    Expect(0, 69416, '\p{Script=:\Aoldsogdian\z:}', "");;
    Expect(1, 69415, '\p{Script=	old_SOGDIAN}', "");
    Expect(0, 69415, '\p{^Script=	old_SOGDIAN}', "");
    Expect(0, 69415, '\P{Script=	old_SOGDIAN}', "");
    Expect(1, 69415, '\P{^Script=	old_SOGDIAN}', "");
    Expect(0, 69416, '\p{Script=	old_SOGDIAN}', "");
    Expect(1, 69416, '\p{^Script=	old_SOGDIAN}', "");
    Expect(1, 69416, '\P{Script=	old_SOGDIAN}', "");
    Expect(0, 69416, '\P{^Script=	old_SOGDIAN}', "");
    Error('\p{Sc=:=-	Sogo}');
    Error('\P{Sc=:=-	Sogo}');
    Expect(1, 69415, '\p{Sc=:\ASogo\z:}', "");;
    Expect(0, 69416, '\p{Sc=:\ASogo\z:}', "");;
    Expect(1, 69415, '\p{Sc=sogo}', "");
    Expect(0, 69415, '\p{^Sc=sogo}', "");
    Expect(0, 69415, '\P{Sc=sogo}', "");
    Expect(1, 69415, '\P{^Sc=sogo}', "");
    Expect(0, 69416, '\p{Sc=sogo}', "");
    Expect(1, 69416, '\p{^Sc=sogo}', "");
    Expect(1, 69416, '\P{Sc=sogo}', "");
    Expect(0, 69416, '\P{^Sc=sogo}', "");
    Expect(1, 69415, '\p{Sc=:\Asogo\z:}', "");;
    Expect(0, 69416, '\p{Sc=:\Asogo\z:}', "");;
    Expect(1, 69415, '\p{Sc=  sogo}', "");
    Expect(0, 69415, '\p{^Sc=  sogo}', "");
    Expect(0, 69415, '\P{Sc=  sogo}', "");
    Expect(1, 69415, '\P{^Sc=  sogo}', "");
    Expect(0, 69416, '\p{Sc=  sogo}', "");
    Expect(1, 69416, '\p{^Sc=  sogo}', "");
    Expect(1, 69416, '\P{Sc=  sogo}', "");
    Expect(0, 69416, '\P{^Sc=  sogo}', "");
    Error('\p{Is_Script=:=_OLD_Sogdian}');
    Error('\P{Is_Script=:=_OLD_Sogdian}');
    Expect(1, 69415, '\p{Is_Script: oldsogdian}', "");
    Expect(0, 69415, '\p{^Is_Script: oldsogdian}', "");
    Expect(0, 69415, '\P{Is_Script: oldsogdian}', "");
    Expect(1, 69415, '\P{^Is_Script: oldsogdian}', "");
    Expect(0, 69416, '\p{Is_Script: oldsogdian}', "");
    Expect(1, 69416, '\p{^Is_Script: oldsogdian}', "");
    Expect(1, 69416, '\P{Is_Script: oldsogdian}', "");
    Expect(0, 69416, '\P{^Is_Script: oldsogdian}', "");
    Expect(1, 69415, '\p{Is_Script= Old_sogdian}', "");
    Expect(0, 69415, '\p{^Is_Script= Old_sogdian}', "");
    Expect(0, 69415, '\P{Is_Script= Old_sogdian}', "");
    Expect(1, 69415, '\P{^Is_Script= Old_sogdian}', "");
    Expect(0, 69416, '\p{Is_Script= Old_sogdian}', "");
    Expect(1, 69416, '\p{^Is_Script= Old_sogdian}', "");
    Expect(1, 69416, '\P{Is_Script= Old_sogdian}', "");
    Expect(0, 69416, '\P{^Is_Script= Old_sogdian}', "");
    Error('\p{Is_Sc=  Sogo:=}');
    Error('\P{Is_Sc=  Sogo:=}');
    Expect(1, 69415, '\p{Is_Sc=sogo}', "");
    Expect(0, 69415, '\p{^Is_Sc=sogo}', "");
    Expect(0, 69415, '\P{Is_Sc=sogo}', "");
    Expect(1, 69415, '\P{^Is_Sc=sogo}', "");
    Expect(0, 69416, '\p{Is_Sc=sogo}', "");
    Expect(1, 69416, '\p{^Is_Sc=sogo}', "");
    Expect(1, 69416, '\P{Is_Sc=sogo}', "");
    Expect(0, 69416, '\P{^Is_Sc=sogo}', "");
    Expect(1, 69415, '\p{Is_Sc:   - SOGO}', "");
    Expect(0, 69415, '\p{^Is_Sc:   - SOGO}', "");
    Expect(0, 69415, '\P{Is_Sc:   - SOGO}', "");
    Expect(1, 69415, '\P{^Is_Sc:   - SOGO}', "");
    Expect(0, 69416, '\p{Is_Sc:   - SOGO}', "");
    Expect(1, 69416, '\p{^Is_Sc:   - SOGO}', "");
    Expect(1, 69416, '\P{Is_Sc:   - SOGO}', "");
    Expect(0, 69416, '\P{^Is_Sc:   - SOGO}', "");
    Error('\p{Script=/a/		sora_SOMPENG}');
    Error('\P{Script=/a/		sora_SOMPENG}');
    Expect(1, 69881, '\p{Script=:\ASora_Sompeng\z:}', "");;
    Expect(0, 69882, '\p{Script=:\ASora_Sompeng\z:}', "");;
    Expect(1, 69881, '\p{Script=sorasompeng}', "");
    Expect(0, 69881, '\p{^Script=sorasompeng}', "");
    Expect(0, 69881, '\P{Script=sorasompeng}', "");
    Expect(1, 69881, '\P{^Script=sorasompeng}', "");
    Expect(0, 69882, '\p{Script=sorasompeng}', "");
    Expect(1, 69882, '\p{^Script=sorasompeng}', "");
    Expect(1, 69882, '\P{Script=sorasompeng}', "");
    Expect(0, 69882, '\P{^Script=sorasompeng}', "");
    Expect(1, 69881, '\p{Script=:\Asorasompeng\z:}', "");;
    Expect(0, 69882, '\p{Script=:\Asorasompeng\z:}', "");;
    Expect(1, 69881, '\p{Script= _Sora_sompeng}', "");
    Expect(0, 69881, '\p{^Script= _Sora_sompeng}', "");
    Expect(0, 69881, '\P{Script= _Sora_sompeng}', "");
    Expect(1, 69881, '\P{^Script= _Sora_sompeng}', "");
    Expect(0, 69882, '\p{Script= _Sora_sompeng}', "");
    Expect(1, 69882, '\p{^Script= _Sora_sompeng}', "");
    Expect(1, 69882, '\P{Script= _Sora_sompeng}', "");
    Expect(0, 69882, '\P{^Script= _Sora_sompeng}', "");
    Error('\p{Sc=	SORA:=}');
    Error('\P{Sc=	SORA:=}');
    Expect(1, 69881, '\p{Sc=:\ASora\z:}', "");;
    Expect(0, 69882, '\p{Sc=:\ASora\z:}', "");;
    Expect(1, 69881, '\p{Sc=sora}', "");
    Expect(0, 69881, '\p{^Sc=sora}', "");
    Expect(0, 69881, '\P{Sc=sora}', "");
    Expect(1, 69881, '\P{^Sc=sora}', "");
    Expect(0, 69882, '\p{Sc=sora}', "");
    Expect(1, 69882, '\p{^Sc=sora}', "");
    Expect(1, 69882, '\P{Sc=sora}', "");
    Expect(0, 69882, '\P{^Sc=sora}', "");
    Expect(1, 69881, '\p{Sc=:\Asora\z:}', "");;
    Expect(0, 69882, '\p{Sc=:\Asora\z:}', "");;
    Expect(1, 69881, '\p{Sc=-sora}', "");
    Expect(0, 69881, '\p{^Sc=-sora}', "");
    Expect(0, 69881, '\P{Sc=-sora}', "");
    Expect(1, 69881, '\P{^Sc=-sora}', "");
    Expect(0, 69882, '\p{Sc=-sora}', "");
    Expect(1, 69882, '\p{^Sc=-sora}', "");
    Expect(1, 69882, '\P{Sc=-sora}', "");
    Expect(0, 69882, '\P{^Sc=-sora}', "");
    Error('\p{Is_Script= :=Sora_Sompeng}');
    Error('\P{Is_Script= :=Sora_Sompeng}');
    Expect(1, 69881, '\p{Is_Script=sorasompeng}', "");
    Expect(0, 69881, '\p{^Is_Script=sorasompeng}', "");
    Expect(0, 69881, '\P{Is_Script=sorasompeng}', "");
    Expect(1, 69881, '\P{^Is_Script=sorasompeng}', "");
    Expect(0, 69882, '\p{Is_Script=sorasompeng}', "");
    Expect(1, 69882, '\p{^Is_Script=sorasompeng}', "");
    Expect(1, 69882, '\P{Is_Script=sorasompeng}', "");
    Expect(0, 69882, '\P{^Is_Script=sorasompeng}', "");
    Expect(1, 69881, '\p{Is_Script=		sora_Sompeng}', "");
    Expect(0, 69881, '\p{^Is_Script=		sora_Sompeng}', "");
    Expect(0, 69881, '\P{Is_Script=		sora_Sompeng}', "");
    Expect(1, 69881, '\P{^Is_Script=		sora_Sompeng}', "");
    Expect(0, 69882, '\p{Is_Script=		sora_Sompeng}', "");
    Expect(1, 69882, '\p{^Is_Script=		sora_Sompeng}', "");
    Expect(1, 69882, '\P{Is_Script=		sora_Sompeng}', "");
    Expect(0, 69882, '\P{^Is_Script=		sora_Sompeng}', "");
    Error('\p{Is_Sc=	/a/SORA}');
    Error('\P{Is_Sc=	/a/SORA}');
    Expect(1, 69881, '\p{Is_Sc=sora}', "");
    Expect(0, 69881, '\p{^Is_Sc=sora}', "");
    Expect(0, 69881, '\P{Is_Sc=sora}', "");
    Expect(1, 69881, '\P{^Is_Sc=sora}', "");
    Expect(0, 69882, '\p{Is_Sc=sora}', "");
    Expect(1, 69882, '\p{^Is_Sc=sora}', "");
    Expect(1, 69882, '\P{Is_Sc=sora}', "");
    Expect(0, 69882, '\P{^Is_Sc=sora}', "");
    Expect(1, 69881, '\p{Is_Sc=-sora}', "");
    Expect(0, 69881, '\p{^Is_Sc=-sora}', "");
    Expect(0, 69881, '\P{Is_Sc=-sora}', "");
    Expect(1, 69881, '\P{^Is_Sc=-sora}', "");
    Expect(0, 69882, '\p{Is_Sc=-sora}', "");
    Expect(1, 69882, '\p{^Is_Sc=-sora}', "");
    Expect(1, 69882, '\P{Is_Sc=-sora}', "");
    Expect(0, 69882, '\P{^Is_Sc=-sora}', "");
    Error('\p{Script=	soyombo/a/}');
    Error('\P{Script=	soyombo/a/}');
    Expect(1, 72354, '\p{Script=:\ASoyombo\z:}', "");;
    Expect(0, 72355, '\p{Script=:\ASoyombo\z:}', "");;
    Expect(1, 72354, '\p{Script=soyombo}', "");
    Expect(0, 72354, '\p{^Script=soyombo}', "");
    Expect(0, 72354, '\P{Script=soyombo}', "");
    Expect(1, 72354, '\P{^Script=soyombo}', "");
    Expect(0, 72355, '\p{Script=soyombo}', "");
    Expect(1, 72355, '\p{^Script=soyombo}', "");
    Expect(1, 72355, '\P{Script=soyombo}', "");
    Expect(0, 72355, '\P{^Script=soyombo}', "");
    Expect(1, 72354, '\p{Script=:\Asoyombo\z:}', "");;
    Expect(0, 72355, '\p{Script=:\Asoyombo\z:}', "");;
    Expect(1, 72354, '\p{Script=_Soyombo}', "");
    Expect(0, 72354, '\p{^Script=_Soyombo}', "");
    Expect(0, 72354, '\P{Script=_Soyombo}', "");
    Expect(1, 72354, '\P{^Script=_Soyombo}', "");
    Expect(0, 72355, '\p{Script=_Soyombo}', "");
    Expect(1, 72355, '\p{^Script=_Soyombo}', "");
    Expect(1, 72355, '\P{Script=_Soyombo}', "");
    Expect(0, 72355, '\P{^Script=_Soyombo}', "");
    Error('\p{Sc: 	soyo/a/}');
    Error('\P{Sc: 	soyo/a/}');
    Expect(1, 72354, '\p{Sc=:\ASoyo\z:}', "");;
    Expect(0, 72355, '\p{Sc=:\ASoyo\z:}', "");;
    Expect(1, 72354, '\p{Sc=soyo}', "");
    Expect(0, 72354, '\p{^Sc=soyo}', "");
    Expect(0, 72354, '\P{Sc=soyo}', "");
    Expect(1, 72354, '\P{^Sc=soyo}', "");
    Expect(0, 72355, '\p{Sc=soyo}', "");
    Expect(1, 72355, '\p{^Sc=soyo}', "");
    Expect(1, 72355, '\P{Sc=soyo}', "");
    Expect(0, 72355, '\P{^Sc=soyo}', "");
    Expect(1, 72354, '\p{Sc=:\Asoyo\z:}', "");;
    Expect(0, 72355, '\p{Sc=:\Asoyo\z:}', "");;
    Expect(1, 72354, '\p{Sc=	 soyo}', "");
    Expect(0, 72354, '\p{^Sc=	 soyo}', "");
    Expect(0, 72354, '\P{Sc=	 soyo}', "");
    Expect(1, 72354, '\P{^Sc=	 soyo}', "");
    Expect(0, 72355, '\p{Sc=	 soyo}', "");
    Expect(1, 72355, '\p{^Sc=	 soyo}', "");
    Expect(1, 72355, '\P{Sc=	 soyo}', "");
    Expect(0, 72355, '\P{^Sc=	 soyo}', "");
    Error('\p{Is_Script=--Soyombo/a/}');
    Error('\P{Is_Script=--Soyombo/a/}');
    Expect(1, 72354, '\p{Is_Script=soyombo}', "");
    Expect(0, 72354, '\p{^Is_Script=soyombo}', "");
    Expect(0, 72354, '\P{Is_Script=soyombo}', "");
    Expect(1, 72354, '\P{^Is_Script=soyombo}', "");
    Expect(0, 72355, '\p{Is_Script=soyombo}', "");
    Expect(1, 72355, '\p{^Is_Script=soyombo}', "");
    Expect(1, 72355, '\P{Is_Script=soyombo}', "");
    Expect(0, 72355, '\P{^Is_Script=soyombo}', "");
    Expect(1, 72354, '\p{Is_Script=	soyombo}', "");
    Expect(0, 72354, '\p{^Is_Script=	soyombo}', "");
    Expect(0, 72354, '\P{Is_Script=	soyombo}', "");
    Expect(1, 72354, '\P{^Is_Script=	soyombo}', "");
    Expect(0, 72355, '\p{Is_Script=	soyombo}', "");
    Expect(1, 72355, '\p{^Is_Script=	soyombo}', "");
    Expect(1, 72355, '\P{Is_Script=	soyombo}', "");
    Expect(0, 72355, '\P{^Is_Script=	soyombo}', "");
    Error('\p{Is_Sc=	/a/SOYO}');
    Error('\P{Is_Sc=	/a/SOYO}');
    Expect(1, 72354, '\p{Is_Sc:   soyo}', "");
    Expect(0, 72354, '\p{^Is_Sc:   soyo}', "");
    Expect(0, 72354, '\P{Is_Sc:   soyo}', "");
    Expect(1, 72354, '\P{^Is_Sc:   soyo}', "");
    Expect(0, 72355, '\p{Is_Sc:   soyo}', "");
    Expect(1, 72355, '\p{^Is_Sc:   soyo}', "");
    Expect(1, 72355, '\P{Is_Sc:   soyo}', "");
    Expect(0, 72355, '\P{^Is_Sc:   soyo}', "");
    Expect(1, 72354, '\p{Is_Sc= _SOYO}', "");
    Expect(0, 72354, '\p{^Is_Sc= _SOYO}', "");
    Expect(0, 72354, '\P{Is_Sc= _SOYO}', "");
    Expect(1, 72354, '\P{^Is_Sc= _SOYO}', "");
    Expect(0, 72355, '\p{Is_Sc= _SOYO}', "");
    Expect(1, 72355, '\p{^Is_Sc= _SOYO}', "");
    Expect(1, 72355, '\P{Is_Sc= _SOYO}', "");
    Expect(0, 72355, '\P{^Is_Sc= _SOYO}', "");
    Error('\p{Script=/a/-SUNDANESE}');
    Error('\P{Script=/a/-SUNDANESE}');
    Expect(1, 7367, '\p{Script=:\ASundanese\z:}', "");;
    Expect(0, 7368, '\p{Script=:\ASundanese\z:}', "");;
    Expect(1, 7367, '\p{Script=sundanese}', "");
    Expect(0, 7367, '\p{^Script=sundanese}', "");
    Expect(0, 7367, '\P{Script=sundanese}', "");
    Expect(1, 7367, '\P{^Script=sundanese}', "");
    Expect(0, 7368, '\p{Script=sundanese}', "");
    Expect(1, 7368, '\p{^Script=sundanese}', "");
    Expect(1, 7368, '\P{Script=sundanese}', "");
    Expect(0, 7368, '\P{^Script=sundanese}', "");
    Expect(1, 7367, '\p{Script=:\Asundanese\z:}', "");;
    Expect(0, 7368, '\p{Script=:\Asundanese\z:}', "");;
    Expect(1, 7367, '\p{Script=  Sundanese}', "");
    Expect(0, 7367, '\p{^Script=  Sundanese}', "");
    Expect(0, 7367, '\P{Script=  Sundanese}', "");
    Expect(1, 7367, '\P{^Script=  Sundanese}', "");
    Expect(0, 7368, '\p{Script=  Sundanese}', "");
    Expect(1, 7368, '\p{^Script=  Sundanese}', "");
    Expect(1, 7368, '\P{Script=  Sundanese}', "");
    Expect(0, 7368, '\P{^Script=  Sundanese}', "");
    Error('\p{Sc=	sund:=}');
    Error('\P{Sc=	sund:=}');
    Expect(1, 7367, '\p{Sc=:\ASund\z:}', "");;
    Expect(0, 7368, '\p{Sc=:\ASund\z:}', "");;
    Expect(1, 7367, '\p{Sc=sund}', "");
    Expect(0, 7367, '\p{^Sc=sund}', "");
    Expect(0, 7367, '\P{Sc=sund}', "");
    Expect(1, 7367, '\P{^Sc=sund}', "");
    Expect(0, 7368, '\p{Sc=sund}', "");
    Expect(1, 7368, '\p{^Sc=sund}', "");
    Expect(1, 7368, '\P{Sc=sund}', "");
    Expect(0, 7368, '\P{^Sc=sund}', "");
    Expect(1, 7367, '\p{Sc=:\Asund\z:}', "");;
    Expect(0, 7368, '\p{Sc=:\Asund\z:}', "");;
    Expect(1, 7367, '\p{Sc=_ Sund}', "");
    Expect(0, 7367, '\p{^Sc=_ Sund}', "");
    Expect(0, 7367, '\P{Sc=_ Sund}', "");
    Expect(1, 7367, '\P{^Sc=_ Sund}', "");
    Expect(0, 7368, '\p{Sc=_ Sund}', "");
    Expect(1, 7368, '\p{^Sc=_ Sund}', "");
    Expect(1, 7368, '\P{Sc=_ Sund}', "");
    Expect(0, 7368, '\P{^Sc=_ Sund}', "");
    Error('\p{Is_Script=/a/ -Sundanese}');
    Error('\P{Is_Script=/a/ -Sundanese}');
    Expect(1, 7367, '\p{Is_Script=sundanese}', "");
    Expect(0, 7367, '\p{^Is_Script=sundanese}', "");
    Expect(0, 7367, '\P{Is_Script=sundanese}', "");
    Expect(1, 7367, '\P{^Is_Script=sundanese}', "");
    Expect(0, 7368, '\p{Is_Script=sundanese}', "");
    Expect(1, 7368, '\p{^Is_Script=sundanese}', "");
    Expect(1, 7368, '\P{Is_Script=sundanese}', "");
    Expect(0, 7368, '\P{^Is_Script=sundanese}', "");
    Expect(1, 7367, '\p{Is_Script:   __SUNDANESE}', "");
    Expect(0, 7367, '\p{^Is_Script:   __SUNDANESE}', "");
    Expect(0, 7367, '\P{Is_Script:   __SUNDANESE}', "");
    Expect(1, 7367, '\P{^Is_Script:   __SUNDANESE}', "");
    Expect(0, 7368, '\p{Is_Script:   __SUNDANESE}', "");
    Expect(1, 7368, '\p{^Is_Script:   __SUNDANESE}', "");
    Expect(1, 7368, '\P{Is_Script:   __SUNDANESE}', "");
    Expect(0, 7368, '\P{^Is_Script:   __SUNDANESE}', "");
    Error('\p{Is_Sc=	:=Sund}');
    Error('\P{Is_Sc=	:=Sund}');
    Expect(1, 7367, '\p{Is_Sc=sund}', "");
    Expect(0, 7367, '\p{^Is_Sc=sund}', "");
    Expect(0, 7367, '\P{Is_Sc=sund}', "");
    Expect(1, 7367, '\P{^Is_Sc=sund}', "");
    Expect(0, 7368, '\p{Is_Sc=sund}', "");
    Expect(1, 7368, '\p{^Is_Sc=sund}', "");
    Expect(1, 7368, '\P{Is_Sc=sund}', "");
    Expect(0, 7368, '\P{^Is_Sc=sund}', "");
    Expect(1, 7367, '\p{Is_Sc=_Sund}', "");
    Expect(0, 7367, '\p{^Is_Sc=_Sund}', "");
    Expect(0, 7367, '\P{Is_Sc=_Sund}', "");
    Expect(1, 7367, '\P{^Is_Sc=_Sund}', "");
    Expect(0, 7368, '\p{Is_Sc=_Sund}', "");
    Expect(1, 7368, '\p{^Is_Sc=_Sund}', "");
    Expect(1, 7368, '\P{Is_Sc=_Sund}', "");
    Expect(0, 7368, '\P{^Is_Sc=_Sund}', "");
    Error('\p{Script:	-_SYLOTI_NAGRI/a/}');
    Error('\P{Script:	-_SYLOTI_NAGRI/a/}');
    Expect(1, 43052, '\p{Script=:\ASyloti_Nagri\z:}', "");;
    Expect(0, 43053, '\p{Script=:\ASyloti_Nagri\z:}', "");;
    Expect(1, 43052, '\p{Script=sylotinagri}', "");
    Expect(0, 43052, '\p{^Script=sylotinagri}', "");
    Expect(0, 43052, '\P{Script=sylotinagri}', "");
    Expect(1, 43052, '\P{^Script=sylotinagri}', "");
    Expect(0, 43053, '\p{Script=sylotinagri}', "");
    Expect(1, 43053, '\p{^Script=sylotinagri}', "");
    Expect(1, 43053, '\P{Script=sylotinagri}', "");
    Expect(0, 43053, '\P{^Script=sylotinagri}', "");
    Expect(1, 43052, '\p{Script=:\Asylotinagri\z:}', "");;
    Expect(0, 43053, '\p{Script=:\Asylotinagri\z:}', "");;
    Expect(1, 43052, '\p{Script=- Syloti_Nagri}', "");
    Expect(0, 43052, '\p{^Script=- Syloti_Nagri}', "");
    Expect(0, 43052, '\P{Script=- Syloti_Nagri}', "");
    Expect(1, 43052, '\P{^Script=- Syloti_Nagri}', "");
    Expect(0, 43053, '\p{Script=- Syloti_Nagri}', "");
    Expect(1, 43053, '\p{^Script=- Syloti_Nagri}', "");
    Expect(1, 43053, '\P{Script=- Syloti_Nagri}', "");
    Expect(0, 43053, '\P{^Script=- Syloti_Nagri}', "");
    Error('\p{Sc= /a/Sylo}');
    Error('\P{Sc= /a/Sylo}');
    Expect(1, 43052, '\p{Sc=:\ASylo\z:}', "");;
    Expect(0, 43053, '\p{Sc=:\ASylo\z:}', "");;
    Expect(1, 43052, '\p{Sc=sylo}', "");
    Expect(0, 43052, '\p{^Sc=sylo}', "");
    Expect(0, 43052, '\P{Sc=sylo}', "");
    Expect(1, 43052, '\P{^Sc=sylo}', "");
    Expect(0, 43053, '\p{Sc=sylo}', "");
    Expect(1, 43053, '\p{^Sc=sylo}', "");
    Expect(1, 43053, '\P{Sc=sylo}', "");
    Expect(0, 43053, '\P{^Sc=sylo}', "");
    Expect(1, 43052, '\p{Sc=:\Asylo\z:}', "");;
    Expect(0, 43053, '\p{Sc=:\Asylo\z:}', "");;
    Expect(1, 43052, '\p{Sc=	_sylo}', "");
    Expect(0, 43052, '\p{^Sc=	_sylo}', "");
    Expect(0, 43052, '\P{Sc=	_sylo}', "");
    Expect(1, 43052, '\P{^Sc=	_sylo}', "");
    Expect(0, 43053, '\p{Sc=	_sylo}', "");
    Expect(1, 43053, '\p{^Sc=	_sylo}', "");
    Expect(1, 43053, '\P{Sc=	_sylo}', "");
    Expect(0, 43053, '\P{^Sc=	_sylo}', "");
    Error('\p{Is_Script=/a/ 	Syloti_Nagri}');
    Error('\P{Is_Script=/a/ 	Syloti_Nagri}');
    Expect(1, 43052, '\p{Is_Script=sylotinagri}', "");
    Expect(0, 43052, '\p{^Is_Script=sylotinagri}', "");
    Expect(0, 43052, '\P{Is_Script=sylotinagri}', "");
    Expect(1, 43052, '\P{^Is_Script=sylotinagri}', "");
    Expect(0, 43053, '\p{Is_Script=sylotinagri}', "");
    Expect(1, 43053, '\p{^Is_Script=sylotinagri}', "");
    Expect(1, 43053, '\P{Is_Script=sylotinagri}', "");
    Expect(0, 43053, '\P{^Is_Script=sylotinagri}', "");
    Expect(1, 43052, '\p{Is_Script=_ Syloti_nagri}', "");
    Expect(0, 43052, '\p{^Is_Script=_ Syloti_nagri}', "");
    Expect(0, 43052, '\P{Is_Script=_ Syloti_nagri}', "");
    Expect(1, 43052, '\P{^Is_Script=_ Syloti_nagri}', "");
    Expect(0, 43053, '\p{Is_Script=_ Syloti_nagri}', "");
    Expect(1, 43053, '\p{^Is_Script=_ Syloti_nagri}', "");
    Expect(1, 43053, '\P{Is_Script=_ Syloti_nagri}', "");
    Expect(0, 43053, '\P{^Is_Script=_ Syloti_nagri}', "");
    Error('\p{Is_Sc=/a/_Sylo}');
    Error('\P{Is_Sc=/a/_Sylo}');
    Expect(1, 43052, '\p{Is_Sc=sylo}', "");
    Expect(0, 43052, '\p{^Is_Sc=sylo}', "");
    Expect(0, 43052, '\P{Is_Sc=sylo}', "");
    Expect(1, 43052, '\P{^Is_Sc=sylo}', "");
    Expect(0, 43053, '\p{Is_Sc=sylo}', "");
    Expect(1, 43053, '\p{^Is_Sc=sylo}', "");
    Expect(1, 43053, '\P{Is_Sc=sylo}', "");
    Expect(0, 43053, '\P{^Is_Sc=sylo}', "");
    Expect(1, 43052, '\p{Is_Sc:  sylo}', "");
    Expect(0, 43052, '\p{^Is_Sc:  sylo}', "");
    Expect(0, 43052, '\P{Is_Sc:  sylo}', "");
    Expect(1, 43052, '\P{^Is_Sc:  sylo}', "");
    Expect(0, 43053, '\p{Is_Sc:  sylo}', "");
    Expect(1, 43053, '\p{^Is_Sc:  sylo}', "");
    Expect(1, 43053, '\P{Is_Sc:  sylo}', "");
    Expect(0, 43053, '\P{^Is_Sc:  sylo}', "");
    Error('\p{Script= /a/Syriac}');
    Error('\P{Script= /a/Syriac}');
    Expect(1, 2154, '\p{Script=:\ASyriac\z:}', "");;
    Expect(0, 2155, '\p{Script=:\ASyriac\z:}', "");;
    Expect(1, 2154, '\p{Script=syriac}', "");
    Expect(0, 2154, '\p{^Script=syriac}', "");
    Expect(0, 2154, '\P{Script=syriac}', "");
    Expect(1, 2154, '\P{^Script=syriac}', "");
    Expect(0, 2155, '\p{Script=syriac}', "");
    Expect(1, 2155, '\p{^Script=syriac}', "");
    Expect(1, 2155, '\P{Script=syriac}', "");
    Expect(0, 2155, '\P{^Script=syriac}', "");
    Expect(1, 2154, '\p{Script=:\Asyriac\z:}', "");;
    Expect(0, 2155, '\p{Script=:\Asyriac\z:}', "");;
    Expect(1, 2154, '\p{Script:   -_SYRIAC}', "");
    Expect(0, 2154, '\p{^Script:   -_SYRIAC}', "");
    Expect(0, 2154, '\P{Script:   -_SYRIAC}', "");
    Expect(1, 2154, '\P{^Script:   -_SYRIAC}', "");
    Expect(0, 2155, '\p{Script:   -_SYRIAC}', "");
    Expect(1, 2155, '\p{^Script:   -_SYRIAC}', "");
    Expect(1, 2155, '\P{Script:   -_SYRIAC}', "");
    Expect(0, 2155, '\P{^Script:   -_SYRIAC}', "");
    Error('\p{Sc=	/a/Syrc}');
    Error('\P{Sc=	/a/Syrc}');
    Expect(1, 2154, '\p{Sc=:\ASyrc\z:}', "");;
    Expect(0, 2155, '\p{Sc=:\ASyrc\z:}', "");;
    Expect(1, 2154, '\p{Sc=syrc}', "");
    Expect(0, 2154, '\p{^Sc=syrc}', "");
    Expect(0, 2154, '\P{Sc=syrc}', "");
    Expect(1, 2154, '\P{^Sc=syrc}', "");
    Expect(0, 2155, '\p{Sc=syrc}', "");
    Expect(1, 2155, '\p{^Sc=syrc}', "");
    Expect(1, 2155, '\P{Sc=syrc}', "");
    Expect(0, 2155, '\P{^Sc=syrc}', "");
    Expect(1, 2154, '\p{Sc=:\Asyrc\z:}', "");;
    Expect(0, 2155, '\p{Sc=:\Asyrc\z:}', "");;
    Expect(1, 2154, '\p{Sc=_SYRC}', "");
    Expect(0, 2154, '\p{^Sc=_SYRC}', "");
    Expect(0, 2154, '\P{Sc=_SYRC}', "");
    Expect(1, 2154, '\P{^Sc=_SYRC}', "");
    Expect(0, 2155, '\p{Sc=_SYRC}', "");
    Expect(1, 2155, '\p{^Sc=_SYRC}', "");
    Expect(1, 2155, '\P{Sc=_SYRC}', "");
    Expect(0, 2155, '\P{^Sc=_SYRC}', "");
    Error('\p{Is_Script=_	syriac/a/}');
    Error('\P{Is_Script=_	syriac/a/}');
    Expect(1, 2154, '\p{Is_Script=syriac}', "");
    Expect(0, 2154, '\p{^Is_Script=syriac}', "");
    Expect(0, 2154, '\P{Is_Script=syriac}', "");
    Expect(1, 2154, '\P{^Is_Script=syriac}', "");
    Expect(0, 2155, '\p{Is_Script=syriac}', "");
    Expect(1, 2155, '\p{^Is_Script=syriac}', "");
    Expect(1, 2155, '\P{Is_Script=syriac}', "");
    Expect(0, 2155, '\P{^Is_Script=syriac}', "");
    Expect(1, 2154, '\p{Is_Script:		_SYRIAC}', "");
    Expect(0, 2154, '\p{^Is_Script:		_SYRIAC}', "");
    Expect(0, 2154, '\P{Is_Script:		_SYRIAC}', "");
    Expect(1, 2154, '\P{^Is_Script:		_SYRIAC}', "");
    Expect(0, 2155, '\p{Is_Script:		_SYRIAC}', "");
    Expect(1, 2155, '\p{^Is_Script:		_SYRIAC}', "");
    Expect(1, 2155, '\P{Is_Script:		_SYRIAC}', "");
    Expect(0, 2155, '\P{^Is_Script:		_SYRIAC}', "");
    Error('\p{Is_Sc= /a/Syrc}');
    Error('\P{Is_Sc= /a/Syrc}');
    Expect(1, 2154, '\p{Is_Sc=syrc}', "");
    Expect(0, 2154, '\p{^Is_Sc=syrc}', "");
    Expect(0, 2154, '\P{Is_Sc=syrc}', "");
    Expect(1, 2154, '\P{^Is_Sc=syrc}', "");
    Expect(0, 2155, '\p{Is_Sc=syrc}', "");
    Expect(1, 2155, '\p{^Is_Sc=syrc}', "");
    Expect(1, 2155, '\P{Is_Sc=syrc}', "");
    Expect(0, 2155, '\P{^Is_Sc=syrc}', "");
    Expect(1, 2154, '\p{Is_Sc=	syrc}', "");
    Expect(0, 2154, '\p{^Is_Sc=	syrc}', "");
    Expect(0, 2154, '\P{Is_Sc=	syrc}', "");
    Expect(1, 2154, '\P{^Is_Sc=	syrc}', "");
    Expect(0, 2155, '\p{Is_Sc=	syrc}', "");
    Expect(1, 2155, '\p{^Is_Sc=	syrc}', "");
    Expect(1, 2155, '\P{Is_Sc=	syrc}', "");
    Expect(0, 2155, '\P{^Is_Sc=	syrc}', "");
    Error('\p{Script=-	TAGBANWA:=}');
    Error('\P{Script=-	TAGBANWA:=}');
    Expect(1, 6003, '\p{Script=:\ATagbanwa\z:}', "");;
    Expect(0, 6004, '\p{Script=:\ATagbanwa\z:}', "");;
    Expect(1, 6003, '\p{Script=tagbanwa}', "");
    Expect(0, 6003, '\p{^Script=tagbanwa}', "");
    Expect(0, 6003, '\P{Script=tagbanwa}', "");
    Expect(1, 6003, '\P{^Script=tagbanwa}', "");
    Expect(0, 6004, '\p{Script=tagbanwa}', "");
    Expect(1, 6004, '\p{^Script=tagbanwa}', "");
    Expect(1, 6004, '\P{Script=tagbanwa}', "");
    Expect(0, 6004, '\P{^Script=tagbanwa}', "");
    Expect(1, 6003, '\p{Script=:\Atagbanwa\z:}', "");;
    Expect(0, 6004, '\p{Script=:\Atagbanwa\z:}', "");;
    Expect(1, 6003, '\p{Script=_Tagbanwa}', "");
    Expect(0, 6003, '\p{^Script=_Tagbanwa}', "");
    Expect(0, 6003, '\P{Script=_Tagbanwa}', "");
    Expect(1, 6003, '\P{^Script=_Tagbanwa}', "");
    Expect(0, 6004, '\p{Script=_Tagbanwa}', "");
    Expect(1, 6004, '\p{^Script=_Tagbanwa}', "");
    Expect(1, 6004, '\P{Script=_Tagbanwa}', "");
    Expect(0, 6004, '\P{^Script=_Tagbanwa}', "");
    Error('\p{Sc= _tagb:=}');
    Error('\P{Sc= _tagb:=}');
    Expect(1, 6003, '\p{Sc=:\ATagb\z:}', "");;
    Expect(0, 6004, '\p{Sc=:\ATagb\z:}', "");;
    Expect(1, 6003, '\p{Sc=tagb}', "");
    Expect(0, 6003, '\p{^Sc=tagb}', "");
    Expect(0, 6003, '\P{Sc=tagb}', "");
    Expect(1, 6003, '\P{^Sc=tagb}', "");
    Expect(0, 6004, '\p{Sc=tagb}', "");
    Expect(1, 6004, '\p{^Sc=tagb}', "");
    Expect(1, 6004, '\P{Sc=tagb}', "");
    Expect(0, 6004, '\P{^Sc=tagb}', "");
    Expect(1, 6003, '\p{Sc=:\Atagb\z:}', "");;
    Expect(0, 6004, '\p{Sc=:\Atagb\z:}', "");;
    Expect(1, 6003, '\p{Sc=_-TAGB}', "");
    Expect(0, 6003, '\p{^Sc=_-TAGB}', "");
    Expect(0, 6003, '\P{Sc=_-TAGB}', "");
    Expect(1, 6003, '\P{^Sc=_-TAGB}', "");
    Expect(0, 6004, '\p{Sc=_-TAGB}', "");
    Expect(1, 6004, '\p{^Sc=_-TAGB}', "");
    Expect(1, 6004, '\P{Sc=_-TAGB}', "");
    Expect(0, 6004, '\P{^Sc=_-TAGB}', "");
    Error('\p{Is_Script=	tagbanwa/a/}');
    Error('\P{Is_Script=	tagbanwa/a/}');
    Expect(1, 6003, '\p{Is_Script=tagbanwa}', "");
    Expect(0, 6003, '\p{^Is_Script=tagbanwa}', "");
    Expect(0, 6003, '\P{Is_Script=tagbanwa}', "");
    Expect(1, 6003, '\P{^Is_Script=tagbanwa}', "");
    Expect(0, 6004, '\p{Is_Script=tagbanwa}', "");
    Expect(1, 6004, '\p{^Is_Script=tagbanwa}', "");
    Expect(1, 6004, '\P{Is_Script=tagbanwa}', "");
    Expect(0, 6004, '\P{^Is_Script=tagbanwa}', "");
    Expect(1, 6003, '\p{Is_Script=Tagbanwa}', "");
    Expect(0, 6003, '\p{^Is_Script=Tagbanwa}', "");
    Expect(0, 6003, '\P{Is_Script=Tagbanwa}', "");
    Expect(1, 6003, '\P{^Is_Script=Tagbanwa}', "");
    Expect(0, 6004, '\p{Is_Script=Tagbanwa}', "");
    Expect(1, 6004, '\p{^Is_Script=Tagbanwa}', "");
    Expect(1, 6004, '\P{Is_Script=Tagbanwa}', "");
    Expect(0, 6004, '\P{^Is_Script=Tagbanwa}', "");
    Error('\p{Is_Sc=:=	_Tagb}');
    Error('\P{Is_Sc=:=	_Tagb}');
    Expect(1, 6003, '\p{Is_Sc=tagb}', "");
    Expect(0, 6003, '\p{^Is_Sc=tagb}', "");
    Expect(0, 6003, '\P{Is_Sc=tagb}', "");
    Expect(1, 6003, '\P{^Is_Sc=tagb}', "");
    Expect(0, 6004, '\p{Is_Sc=tagb}', "");
    Expect(1, 6004, '\p{^Is_Sc=tagb}', "");
    Expect(1, 6004, '\P{Is_Sc=tagb}', "");
    Expect(0, 6004, '\P{^Is_Sc=tagb}', "");
    Expect(1, 6003, '\p{Is_Sc=_ tagb}', "");
    Expect(0, 6003, '\p{^Is_Sc=_ tagb}', "");
    Expect(0, 6003, '\P{Is_Sc=_ tagb}', "");
    Expect(1, 6003, '\P{^Is_Sc=_ tagb}', "");
    Expect(0, 6004, '\p{Is_Sc=_ tagb}', "");
    Expect(1, 6004, '\p{^Is_Sc=_ tagb}', "");
    Expect(1, 6004, '\P{Is_Sc=_ tagb}', "");
    Expect(0, 6004, '\P{^Is_Sc=_ tagb}', "");
    Error('\p{Script=	takri:=}');
    Error('\P{Script=	takri:=}');
    Expect(1, 71369, '\p{Script=:\ATakri\z:}', "");;
    Expect(0, 71370, '\p{Script=:\ATakri\z:}', "");;
    Expect(1, 71369, '\p{Script=takri}', "");
    Expect(0, 71369, '\p{^Script=takri}', "");
    Expect(0, 71369, '\P{Script=takri}', "");
    Expect(1, 71369, '\P{^Script=takri}', "");
    Expect(0, 71370, '\p{Script=takri}', "");
    Expect(1, 71370, '\p{^Script=takri}', "");
    Expect(1, 71370, '\P{Script=takri}', "");
    Expect(0, 71370, '\P{^Script=takri}', "");
    Expect(1, 71369, '\p{Script=:\Atakri\z:}', "");;
    Expect(0, 71370, '\p{Script=:\Atakri\z:}', "");;
    Expect(1, 71369, '\p{Script=_Takri}', "");
    Expect(0, 71369, '\p{^Script=_Takri}', "");
    Expect(0, 71369, '\P{Script=_Takri}', "");
    Expect(1, 71369, '\P{^Script=_Takri}', "");
    Expect(0, 71370, '\p{Script=_Takri}', "");
    Expect(1, 71370, '\p{^Script=_Takri}', "");
    Expect(1, 71370, '\P{Script=_Takri}', "");
    Expect(0, 71370, '\P{^Script=_Takri}', "");
    Error('\p{Sc: :=Takr}');
    Error('\P{Sc: :=Takr}');
    Expect(1, 71369, '\p{Sc=:\ATakr\z:}', "");;
    Expect(0, 71370, '\p{Sc=:\ATakr\z:}', "");;
    Expect(1, 71369, '\p{Sc=takr}', "");
    Expect(0, 71369, '\p{^Sc=takr}', "");
    Expect(0, 71369, '\P{Sc=takr}', "");
    Expect(1, 71369, '\P{^Sc=takr}', "");
    Expect(0, 71370, '\p{Sc=takr}', "");
    Expect(1, 71370, '\p{^Sc=takr}', "");
    Expect(1, 71370, '\P{Sc=takr}', "");
    Expect(0, 71370, '\P{^Sc=takr}', "");
    Expect(1, 71369, '\p{Sc=:\Atakr\z:}', "");;
    Expect(0, 71370, '\p{Sc=:\Atakr\z:}', "");;
    Expect(1, 71369, '\p{Sc=-Takr}', "");
    Expect(0, 71369, '\p{^Sc=-Takr}', "");
    Expect(0, 71369, '\P{Sc=-Takr}', "");
    Expect(1, 71369, '\P{^Sc=-Takr}', "");
    Expect(0, 71370, '\p{Sc=-Takr}', "");
    Expect(1, 71370, '\p{^Sc=-Takr}', "");
    Expect(1, 71370, '\P{Sc=-Takr}', "");
    Expect(0, 71370, '\P{^Sc=-Takr}', "");
    Error('\p{Is_Script=/a/_takri}');
    Error('\P{Is_Script=/a/_takri}');
    Expect(1, 71369, '\p{Is_Script=takri}', "");
    Expect(0, 71369, '\p{^Is_Script=takri}', "");
    Expect(0, 71369, '\P{Is_Script=takri}', "");
    Expect(1, 71369, '\P{^Is_Script=takri}', "");
    Expect(0, 71370, '\p{Is_Script=takri}', "");
    Expect(1, 71370, '\p{^Is_Script=takri}', "");
    Expect(1, 71370, '\P{Is_Script=takri}', "");
    Expect(0, 71370, '\P{^Is_Script=takri}', "");
    Expect(1, 71369, '\p{Is_Script=-takri}', "");
    Expect(0, 71369, '\p{^Is_Script=-takri}', "");
    Expect(0, 71369, '\P{Is_Script=-takri}', "");
    Expect(1, 71369, '\P{^Is_Script=-takri}', "");
    Expect(0, 71370, '\p{Is_Script=-takri}', "");
    Expect(1, 71370, '\p{^Is_Script=-takri}', "");
    Expect(1, 71370, '\P{Is_Script=-takri}', "");
    Expect(0, 71370, '\P{^Is_Script=-takri}', "");
    Error('\p{Is_Sc=:=__Takr}');
    Error('\P{Is_Sc=:=__Takr}');
    Expect(1, 71369, '\p{Is_Sc=takr}', "");
    Expect(0, 71369, '\p{^Is_Sc=takr}', "");
    Expect(0, 71369, '\P{Is_Sc=takr}', "");
    Expect(1, 71369, '\P{^Is_Sc=takr}', "");
    Expect(0, 71370, '\p{Is_Sc=takr}', "");
    Expect(1, 71370, '\p{^Is_Sc=takr}', "");
    Expect(1, 71370, '\P{Is_Sc=takr}', "");
    Expect(0, 71370, '\P{^Is_Sc=takr}', "");
    Expect(1, 71369, '\p{Is_Sc=_-takr}', "");
    Expect(0, 71369, '\p{^Is_Sc=_-takr}', "");
    Expect(0, 71369, '\P{Is_Sc=_-takr}', "");
    Expect(1, 71369, '\P{^Is_Sc=_-takr}', "");
    Expect(0, 71370, '\p{Is_Sc=_-takr}', "");
    Expect(1, 71370, '\p{^Is_Sc=_-takr}', "");
    Expect(1, 71370, '\P{Is_Sc=_-takr}', "");
    Expect(0, 71370, '\P{^Is_Sc=_-takr}', "");
    Error('\p{Script=	:=tai_le}');
    Error('\P{Script=	:=tai_le}');
    Expect(1, 6516, '\p{Script=:\ATai_Le\z:}', "");;
    Expect(0, 6517, '\p{Script=:\ATai_Le\z:}', "");;
    Expect(1, 6516, '\p{Script=taile}', "");
    Expect(0, 6516, '\p{^Script=taile}', "");
    Expect(0, 6516, '\P{Script=taile}', "");
    Expect(1, 6516, '\P{^Script=taile}', "");
    Expect(0, 6517, '\p{Script=taile}', "");
    Expect(1, 6517, '\p{^Script=taile}', "");
    Expect(1, 6517, '\P{Script=taile}', "");
    Expect(0, 6517, '\P{^Script=taile}', "");
    Expect(1, 6516, '\p{Script=:\Ataile\z:}', "");;
    Expect(0, 6517, '\p{Script=:\Ataile\z:}', "");;
    Expect(1, 6516, '\p{Script=	TAI_LE}', "");
    Expect(0, 6516, '\p{^Script=	TAI_LE}', "");
    Expect(0, 6516, '\P{Script=	TAI_LE}', "");
    Expect(1, 6516, '\P{^Script=	TAI_LE}', "");
    Expect(0, 6517, '\p{Script=	TAI_LE}', "");
    Expect(1, 6517, '\p{^Script=	TAI_LE}', "");
    Expect(1, 6517, '\P{Script=	TAI_LE}', "");
    Expect(0, 6517, '\P{^Script=	TAI_LE}', "");
    Error('\p{Sc= 	Tale/a/}');
    Error('\P{Sc= 	Tale/a/}');
    Expect(1, 6516, '\p{Sc=:\ATale\z:}', "");;
    Expect(0, 6517, '\p{Sc=:\ATale\z:}', "");;
    Expect(1, 6516, '\p{Sc=tale}', "");
    Expect(0, 6516, '\p{^Sc=tale}', "");
    Expect(0, 6516, '\P{Sc=tale}', "");
    Expect(1, 6516, '\P{^Sc=tale}', "");
    Expect(0, 6517, '\p{Sc=tale}', "");
    Expect(1, 6517, '\p{^Sc=tale}', "");
    Expect(1, 6517, '\P{Sc=tale}', "");
    Expect(0, 6517, '\P{^Sc=tale}', "");
    Expect(1, 6516, '\p{Sc=:\Atale\z:}', "");;
    Expect(0, 6517, '\p{Sc=:\Atale\z:}', "");;
    Expect(1, 6516, '\p{Sc=	-Tale}', "");
    Expect(0, 6516, '\p{^Sc=	-Tale}', "");
    Expect(0, 6516, '\P{Sc=	-Tale}', "");
    Expect(1, 6516, '\P{^Sc=	-Tale}', "");
    Expect(0, 6517, '\p{Sc=	-Tale}', "");
    Expect(1, 6517, '\p{^Sc=	-Tale}', "");
    Expect(1, 6517, '\P{Sc=	-Tale}', "");
    Expect(0, 6517, '\P{^Sc=	-Tale}', "");
    Error('\p{Is_Script=:= 	Tai_Le}');
    Error('\P{Is_Script=:= 	Tai_Le}');
    Expect(1, 6516, '\p{Is_Script=taile}', "");
    Expect(0, 6516, '\p{^Is_Script=taile}', "");
    Expect(0, 6516, '\P{Is_Script=taile}', "");
    Expect(1, 6516, '\P{^Is_Script=taile}', "");
    Expect(0, 6517, '\p{Is_Script=taile}', "");
    Expect(1, 6517, '\p{^Is_Script=taile}', "");
    Expect(1, 6517, '\P{Is_Script=taile}', "");
    Expect(0, 6517, '\P{^Is_Script=taile}', "");
    Expect(1, 6516, '\p{Is_Script=--tai_le}', "");
    Expect(0, 6516, '\p{^Is_Script=--tai_le}', "");
    Expect(0, 6516, '\P{Is_Script=--tai_le}', "");
    Expect(1, 6516, '\P{^Is_Script=--tai_le}', "");
    Expect(0, 6517, '\p{Is_Script=--tai_le}', "");
    Expect(1, 6517, '\p{^Is_Script=--tai_le}', "");
    Expect(1, 6517, '\P{Is_Script=--tai_le}', "");
    Expect(0, 6517, '\P{^Is_Script=--tai_le}', "");
    Error('\p{Is_Sc=_/a/TALE}');
    Error('\P{Is_Sc=_/a/TALE}');
    Expect(1, 6516, '\p{Is_Sc=tale}', "");
    Expect(0, 6516, '\p{^Is_Sc=tale}', "");
    Expect(0, 6516, '\P{Is_Sc=tale}', "");
    Expect(1, 6516, '\P{^Is_Sc=tale}', "");
    Expect(0, 6517, '\p{Is_Sc=tale}', "");
    Expect(1, 6517, '\p{^Is_Sc=tale}', "");
    Expect(1, 6517, '\P{Is_Sc=tale}', "");
    Expect(0, 6517, '\P{^Is_Sc=tale}', "");
    Expect(1, 6516, '\p{Is_Sc: _Tale}', "");
    Expect(0, 6516, '\p{^Is_Sc: _Tale}', "");
    Expect(0, 6516, '\P{Is_Sc: _Tale}', "");
    Expect(1, 6516, '\P{^Is_Sc: _Tale}', "");
    Expect(0, 6517, '\p{Is_Sc: _Tale}', "");
    Expect(1, 6517, '\p{^Is_Sc: _Tale}', "");
    Expect(1, 6517, '\P{Is_Sc: _Tale}', "");
    Expect(0, 6517, '\P{^Is_Sc: _Tale}', "");
    Error('\p{Script=	/a/New_tai_Lue}');
    Error('\P{Script=	/a/New_tai_Lue}');
    Expect(1, 6623, '\p{Script=:\ANew_Tai_Lue\z:}', "");;
    Expect(0, 6624, '\p{Script=:\ANew_Tai_Lue\z:}', "");;
    Expect(1, 6623, '\p{Script=newtailue}', "");
    Expect(0, 6623, '\p{^Script=newtailue}', "");
    Expect(0, 6623, '\P{Script=newtailue}', "");
    Expect(1, 6623, '\P{^Script=newtailue}', "");
    Expect(0, 6624, '\p{Script=newtailue}', "");
    Expect(1, 6624, '\p{^Script=newtailue}', "");
    Expect(1, 6624, '\P{Script=newtailue}', "");
    Expect(0, 6624, '\P{^Script=newtailue}', "");
    Expect(1, 6623, '\p{Script=:\Anewtailue\z:}', "");;
    Expect(0, 6624, '\p{Script=:\Anewtailue\z:}', "");;
    Expect(1, 6623, '\p{Script= New_TAI_Lue}', "");
    Expect(0, 6623, '\p{^Script= New_TAI_Lue}', "");
    Expect(0, 6623, '\P{Script= New_TAI_Lue}', "");
    Expect(1, 6623, '\P{^Script= New_TAI_Lue}', "");
    Expect(0, 6624, '\p{Script= New_TAI_Lue}', "");
    Expect(1, 6624, '\p{^Script= New_TAI_Lue}', "");
    Expect(1, 6624, '\P{Script= New_TAI_Lue}', "");
    Expect(0, 6624, '\P{^Script= New_TAI_Lue}', "");
    Error('\p{Sc=:=	_talu}');
    Error('\P{Sc=:=	_talu}');
    Expect(1, 6623, '\p{Sc=:\ATalu\z:}', "");;
    Expect(0, 6624, '\p{Sc=:\ATalu\z:}', "");;
    Expect(1, 6623, '\p{Sc=talu}', "");
    Expect(0, 6623, '\p{^Sc=talu}', "");
    Expect(0, 6623, '\P{Sc=talu}', "");
    Expect(1, 6623, '\P{^Sc=talu}', "");
    Expect(0, 6624, '\p{Sc=talu}', "");
    Expect(1, 6624, '\p{^Sc=talu}', "");
    Expect(1, 6624, '\P{Sc=talu}', "");
    Expect(0, 6624, '\P{^Sc=talu}', "");
    Expect(1, 6623, '\p{Sc=:\Atalu\z:}', "");;
    Expect(0, 6624, '\p{Sc=:\Atalu\z:}', "");;
    Expect(1, 6623, '\p{Sc=_	talu}', "");
    Expect(0, 6623, '\p{^Sc=_	talu}', "");
    Expect(0, 6623, '\P{Sc=_	talu}', "");
    Expect(1, 6623, '\P{^Sc=_	talu}', "");
    Expect(0, 6624, '\p{Sc=_	talu}', "");
    Expect(1, 6624, '\p{^Sc=_	talu}', "");
    Expect(1, 6624, '\P{Sc=_	talu}', "");
    Expect(0, 6624, '\P{^Sc=_	talu}', "");
    Error('\p{Is_Script=_ New_TAI_Lue:=}');
    Error('\P{Is_Script=_ New_TAI_Lue:=}');
    Expect(1, 6623, '\p{Is_Script=newtailue}', "");
    Expect(0, 6623, '\p{^Is_Script=newtailue}', "");
    Expect(0, 6623, '\P{Is_Script=newtailue}', "");
    Expect(1, 6623, '\P{^Is_Script=newtailue}', "");
    Expect(0, 6624, '\p{Is_Script=newtailue}', "");
    Expect(1, 6624, '\p{^Is_Script=newtailue}', "");
    Expect(1, 6624, '\P{Is_Script=newtailue}', "");
    Expect(0, 6624, '\P{^Is_Script=newtailue}', "");
    Expect(1, 6623, '\p{Is_Script=-new_tai_LUE}', "");
    Expect(0, 6623, '\p{^Is_Script=-new_tai_LUE}', "");
    Expect(0, 6623, '\P{Is_Script=-new_tai_LUE}', "");
    Expect(1, 6623, '\P{^Is_Script=-new_tai_LUE}', "");
    Expect(0, 6624, '\p{Is_Script=-new_tai_LUE}', "");
    Expect(1, 6624, '\p{^Is_Script=-new_tai_LUE}', "");
    Expect(1, 6624, '\P{Is_Script=-new_tai_LUE}', "");
    Expect(0, 6624, '\P{^Is_Script=-new_tai_LUE}', "");
    Error('\p{Is_Sc=:= Talu}');
    Error('\P{Is_Sc=:= Talu}');
    Expect(1, 6623, '\p{Is_Sc=talu}', "");
    Expect(0, 6623, '\p{^Is_Sc=talu}', "");
    Expect(0, 6623, '\P{Is_Sc=talu}', "");
    Expect(1, 6623, '\P{^Is_Sc=talu}', "");
    Expect(0, 6624, '\p{Is_Sc=talu}', "");
    Expect(1, 6624, '\p{^Is_Sc=talu}', "");
    Expect(1, 6624, '\P{Is_Sc=talu}', "");
    Expect(0, 6624, '\P{^Is_Sc=talu}', "");
    Expect(1, 6623, '\p{Is_Sc=Talu}', "");
    Expect(0, 6623, '\p{^Is_Sc=Talu}', "");
    Expect(0, 6623, '\P{Is_Sc=Talu}', "");
    Expect(1, 6623, '\P{^Is_Sc=Talu}', "");
    Expect(0, 6624, '\p{Is_Sc=Talu}', "");
    Expect(1, 6624, '\p{^Is_Sc=Talu}', "");
    Expect(1, 6624, '\P{Is_Sc=Talu}', "");
    Expect(0, 6624, '\P{^Is_Sc=Talu}', "");
    Error('\p{Script=- Tamil/a/}');
    Error('\P{Script=- Tamil/a/}');
    Expect(1, 73727, '\p{Script=:\ATamil\z:}', "");;
    Expect(0, 73728, '\p{Script=:\ATamil\z:}', "");;
    Expect(1, 73727, '\p{Script=tamil}', "");
    Expect(0, 73727, '\p{^Script=tamil}', "");
    Expect(0, 73727, '\P{Script=tamil}', "");
    Expect(1, 73727, '\P{^Script=tamil}', "");
    Expect(0, 73728, '\p{Script=tamil}', "");
    Expect(1, 73728, '\p{^Script=tamil}', "");
    Expect(1, 73728, '\P{Script=tamil}', "");
    Expect(0, 73728, '\P{^Script=tamil}', "");
    Expect(1, 73727, '\p{Script=:\Atamil\z:}', "");;
    Expect(0, 73728, '\p{Script=:\Atamil\z:}', "");;
    Expect(1, 73727, '\p{Script=	Tamil}', "");
    Expect(0, 73727, '\p{^Script=	Tamil}', "");
    Expect(0, 73727, '\P{Script=	Tamil}', "");
    Expect(1, 73727, '\P{^Script=	Tamil}', "");
    Expect(0, 73728, '\p{Script=	Tamil}', "");
    Expect(1, 73728, '\p{^Script=	Tamil}', "");
    Expect(1, 73728, '\P{Script=	Tamil}', "");
    Expect(0, 73728, '\P{^Script=	Tamil}', "");
    Error('\p{Sc=:=	TAML}');
    Error('\P{Sc=:=	TAML}');
    Expect(1, 73727, '\p{Sc=:\ATaml\z:}', "");;
    Expect(0, 73728, '\p{Sc=:\ATaml\z:}', "");;
    Expect(1, 73727, '\p{Sc=taml}', "");
    Expect(0, 73727, '\p{^Sc=taml}', "");
    Expect(0, 73727, '\P{Sc=taml}', "");
    Expect(1, 73727, '\P{^Sc=taml}', "");
    Expect(0, 73728, '\p{Sc=taml}', "");
    Expect(1, 73728, '\p{^Sc=taml}', "");
    Expect(1, 73728, '\P{Sc=taml}', "");
    Expect(0, 73728, '\P{^Sc=taml}', "");
    Expect(1, 73727, '\p{Sc=:\Ataml\z:}', "");;
    Expect(0, 73728, '\p{Sc=:\Ataml\z:}', "");;
    Expect(1, 73727, '\p{Sc= 	taml}', "");
    Expect(0, 73727, '\p{^Sc= 	taml}', "");
    Expect(0, 73727, '\P{Sc= 	taml}', "");
    Expect(1, 73727, '\P{^Sc= 	taml}', "");
    Expect(0, 73728, '\p{Sc= 	taml}', "");
    Expect(1, 73728, '\p{^Sc= 	taml}', "");
    Expect(1, 73728, '\P{Sc= 	taml}', "");
    Expect(0, 73728, '\P{^Sc= 	taml}', "");
    Error('\p{Is_Script: :=_	tamil}');
    Error('\P{Is_Script: :=_	tamil}');
    Expect(1, 73727, '\p{Is_Script=tamil}', "");
    Expect(0, 73727, '\p{^Is_Script=tamil}', "");
    Expect(0, 73727, '\P{Is_Script=tamil}', "");
    Expect(1, 73727, '\P{^Is_Script=tamil}', "");
    Expect(0, 73728, '\p{Is_Script=tamil}', "");
    Expect(1, 73728, '\p{^Is_Script=tamil}', "");
    Expect(1, 73728, '\P{Is_Script=tamil}', "");
    Expect(0, 73728, '\P{^Is_Script=tamil}', "");
    Expect(1, 73727, '\p{Is_Script=	TAMIL}', "");
    Expect(0, 73727, '\p{^Is_Script=	TAMIL}', "");
    Expect(0, 73727, '\P{Is_Script=	TAMIL}', "");
    Expect(1, 73727, '\P{^Is_Script=	TAMIL}', "");
    Expect(0, 73728, '\p{Is_Script=	TAMIL}', "");
    Expect(1, 73728, '\p{^Is_Script=	TAMIL}', "");
    Expect(1, 73728, '\P{Is_Script=	TAMIL}', "");
    Expect(0, 73728, '\P{^Is_Script=	TAMIL}', "");
    Error('\p{Is_Sc=	:=Taml}');
    Error('\P{Is_Sc=	:=Taml}');
    Expect(1, 73727, '\p{Is_Sc=taml}', "");
    Expect(0, 73727, '\p{^Is_Sc=taml}', "");
    Expect(0, 73727, '\P{Is_Sc=taml}', "");
    Expect(1, 73727, '\P{^Is_Sc=taml}', "");
    Expect(0, 73728, '\p{Is_Sc=taml}', "");
    Expect(1, 73728, '\p{^Is_Sc=taml}', "");
    Expect(1, 73728, '\P{Is_Sc=taml}', "");
    Expect(0, 73728, '\P{^Is_Sc=taml}', "");
    Expect(1, 73727, '\p{Is_Sc=-_taml}', "");
    Expect(0, 73727, '\p{^Is_Sc=-_taml}', "");
    Expect(0, 73727, '\P{Is_Sc=-_taml}', "");
    Expect(1, 73727, '\P{^Is_Sc=-_taml}', "");
    Expect(0, 73728, '\p{Is_Sc=-_taml}', "");
    Expect(1, 73728, '\p{^Is_Sc=-_taml}', "");
    Expect(1, 73728, '\P{Is_Sc=-_taml}', "");
    Expect(0, 73728, '\P{^Is_Sc=-_taml}', "");
    Error('\p{Script=_	Tangut/a/}');
    Error('\P{Script=_	Tangut/a/}');
    Expect(1, 101640, '\p{Script=:\ATangut\z:}', "");;
    Expect(0, 101641, '\p{Script=:\ATangut\z:}', "");;
    Expect(1, 101640, '\p{Script=tangut}', "");
    Expect(0, 101640, '\p{^Script=tangut}', "");
    Expect(0, 101640, '\P{Script=tangut}', "");
    Expect(1, 101640, '\P{^Script=tangut}', "");
    Expect(0, 101641, '\p{Script=tangut}', "");
    Expect(1, 101641, '\p{^Script=tangut}', "");
    Expect(1, 101641, '\P{Script=tangut}', "");
    Expect(0, 101641, '\P{^Script=tangut}', "");
    Expect(1, 101640, '\p{Script=:\Atangut\z:}', "");;
    Expect(0, 101641, '\p{Script=:\Atangut\z:}', "");;
    Expect(1, 101640, '\p{Script=Tangut}', "");
    Expect(0, 101640, '\p{^Script=Tangut}', "");
    Expect(0, 101640, '\P{Script=Tangut}', "");
    Expect(1, 101640, '\P{^Script=Tangut}', "");
    Expect(0, 101641, '\p{Script=Tangut}', "");
    Expect(1, 101641, '\p{^Script=Tangut}', "");
    Expect(1, 101641, '\P{Script=Tangut}', "");
    Expect(0, 101641, '\P{^Script=Tangut}', "");
    Error('\p{Sc=/a/ _Tang}');
    Error('\P{Sc=/a/ _Tang}');
    Expect(1, 101640, '\p{Sc=:\ATang\z:}', "");;
    Expect(0, 101641, '\p{Sc=:\ATang\z:}', "");;
    Expect(1, 101640, '\p{Sc=tang}', "");
    Expect(0, 101640, '\p{^Sc=tang}', "");
    Expect(0, 101640, '\P{Sc=tang}', "");
    Expect(1, 101640, '\P{^Sc=tang}', "");
    Expect(0, 101641, '\p{Sc=tang}', "");
    Expect(1, 101641, '\p{^Sc=tang}', "");
    Expect(1, 101641, '\P{Sc=tang}', "");
    Expect(0, 101641, '\P{^Sc=tang}', "");
    Expect(1, 101640, '\p{Sc=:\Atang\z:}', "");;
    Expect(0, 101641, '\p{Sc=:\Atang\z:}', "");;
    Expect(1, 101640, '\p{Sc= tang}', "");
    Expect(0, 101640, '\p{^Sc= tang}', "");
    Expect(0, 101640, '\P{Sc= tang}', "");
    Expect(1, 101640, '\P{^Sc= tang}', "");
    Expect(0, 101641, '\p{Sc= tang}', "");
    Expect(1, 101641, '\p{^Sc= tang}', "");
    Expect(1, 101641, '\P{Sc= tang}', "");
    Expect(0, 101641, '\P{^Sc= tang}', "");
    Error('\p{Is_Script=/a/	-TANGUT}');
    Error('\P{Is_Script=/a/	-TANGUT}');
    Expect(1, 101640, '\p{Is_Script:	tangut}', "");
    Expect(0, 101640, '\p{^Is_Script:	tangut}', "");
    Expect(0, 101640, '\P{Is_Script:	tangut}', "");
    Expect(1, 101640, '\P{^Is_Script:	tangut}', "");
    Expect(0, 101641, '\p{Is_Script:	tangut}', "");
    Expect(1, 101641, '\p{^Is_Script:	tangut}', "");
    Expect(1, 101641, '\P{Is_Script:	tangut}', "");
    Expect(0, 101641, '\P{^Is_Script:	tangut}', "");
    Expect(1, 101640, '\p{Is_Script= Tangut}', "");
    Expect(0, 101640, '\p{^Is_Script= Tangut}', "");
    Expect(0, 101640, '\P{Is_Script= Tangut}', "");
    Expect(1, 101640, '\P{^Is_Script= Tangut}', "");
    Expect(0, 101641, '\p{Is_Script= Tangut}', "");
    Expect(1, 101641, '\p{^Is_Script= Tangut}', "");
    Expect(1, 101641, '\P{Is_Script= Tangut}', "");
    Expect(0, 101641, '\P{^Is_Script= Tangut}', "");
    Error('\p{Is_Sc=:=	TANG}');
    Error('\P{Is_Sc=:=	TANG}');
    Expect(1, 101640, '\p{Is_Sc:tang}', "");
    Expect(0, 101640, '\p{^Is_Sc:tang}', "");
    Expect(0, 101640, '\P{Is_Sc:tang}', "");
    Expect(1, 101640, '\P{^Is_Sc:tang}', "");
    Expect(0, 101641, '\p{Is_Sc:tang}', "");
    Expect(1, 101641, '\p{^Is_Sc:tang}', "");
    Expect(1, 101641, '\P{Is_Sc:tang}', "");
    Expect(0, 101641, '\P{^Is_Sc:tang}', "");
    Expect(1, 101640, '\p{Is_Sc=	 Tang}', "");
    Expect(0, 101640, '\p{^Is_Sc=	 Tang}', "");
    Expect(0, 101640, '\P{Is_Sc=	 Tang}', "");
    Expect(1, 101640, '\P{^Is_Sc=	 Tang}', "");
    Expect(0, 101641, '\p{Is_Sc=	 Tang}', "");
    Expect(1, 101641, '\p{^Is_Sc=	 Tang}', "");
    Expect(1, 101641, '\P{Is_Sc=	 Tang}', "");
    Expect(0, 101641, '\P{^Is_Sc=	 Tang}', "");
    Error('\p{Script= :=Tai_VIET}');
    Error('\P{Script= :=Tai_VIET}');
    Expect(1, 43743, '\p{Script=:\ATai_Viet\z:}', "");;
    Expect(0, 43744, '\p{Script=:\ATai_Viet\z:}', "");;
    Expect(1, 43743, '\p{Script=taiviet}', "");
    Expect(0, 43743, '\p{^Script=taiviet}', "");
    Expect(0, 43743, '\P{Script=taiviet}', "");
    Expect(1, 43743, '\P{^Script=taiviet}', "");
    Expect(0, 43744, '\p{Script=taiviet}', "");
    Expect(1, 43744, '\p{^Script=taiviet}', "");
    Expect(1, 43744, '\P{Script=taiviet}', "");
    Expect(0, 43744, '\P{^Script=taiviet}', "");
    Expect(1, 43743, '\p{Script=:\Ataiviet\z:}', "");;
    Expect(0, 43744, '\p{Script=:\Ataiviet\z:}', "");;
    Expect(1, 43743, '\p{Script=_ Tai_Viet}', "");
    Expect(0, 43743, '\p{^Script=_ Tai_Viet}', "");
    Expect(0, 43743, '\P{Script=_ Tai_Viet}', "");
    Expect(1, 43743, '\P{^Script=_ Tai_Viet}', "");
    Expect(0, 43744, '\p{Script=_ Tai_Viet}', "");
    Expect(1, 43744, '\p{^Script=_ Tai_Viet}', "");
    Expect(1, 43744, '\P{Script=_ Tai_Viet}', "");
    Expect(0, 43744, '\P{^Script=_ Tai_Viet}', "");
    Error('\p{Sc=:= tavt}');
    Error('\P{Sc=:= tavt}');
    Expect(1, 43743, '\p{Sc=:\ATavt\z:}', "");;
    Expect(0, 43744, '\p{Sc=:\ATavt\z:}', "");;
    Expect(1, 43743, '\p{Sc=tavt}', "");
    Expect(0, 43743, '\p{^Sc=tavt}', "");
    Expect(0, 43743, '\P{Sc=tavt}', "");
    Expect(1, 43743, '\P{^Sc=tavt}', "");
    Expect(0, 43744, '\p{Sc=tavt}', "");
    Expect(1, 43744, '\p{^Sc=tavt}', "");
    Expect(1, 43744, '\P{Sc=tavt}', "");
    Expect(0, 43744, '\P{^Sc=tavt}', "");
    Expect(1, 43743, '\p{Sc=:\Atavt\z:}', "");;
    Expect(0, 43744, '\p{Sc=:\Atavt\z:}', "");;
    Expect(1, 43743, '\p{Sc= -TAVT}', "");
    Expect(0, 43743, '\p{^Sc= -TAVT}', "");
    Expect(0, 43743, '\P{Sc= -TAVT}', "");
    Expect(1, 43743, '\P{^Sc= -TAVT}', "");
    Expect(0, 43744, '\p{Sc= -TAVT}', "");
    Expect(1, 43744, '\p{^Sc= -TAVT}', "");
    Expect(1, 43744, '\P{Sc= -TAVT}', "");
    Expect(0, 43744, '\P{^Sc= -TAVT}', "");
    Error('\p{Is_Script=		tai_Viet:=}');
    Error('\P{Is_Script=		tai_Viet:=}');
    Expect(1, 43743, '\p{Is_Script=taiviet}', "");
    Expect(0, 43743, '\p{^Is_Script=taiviet}', "");
    Expect(0, 43743, '\P{Is_Script=taiviet}', "");
    Expect(1, 43743, '\P{^Is_Script=taiviet}', "");
    Expect(0, 43744, '\p{Is_Script=taiviet}', "");
    Expect(1, 43744, '\p{^Is_Script=taiviet}', "");
    Expect(1, 43744, '\P{Is_Script=taiviet}', "");
    Expect(0, 43744, '\P{^Is_Script=taiviet}', "");
    Expect(1, 43743, '\p{Is_Script=-	TAI_Viet}', "");
    Expect(0, 43743, '\p{^Is_Script=-	TAI_Viet}', "");
    Expect(0, 43743, '\P{Is_Script=-	TAI_Viet}', "");
    Expect(1, 43743, '\P{^Is_Script=-	TAI_Viet}', "");
    Expect(0, 43744, '\p{Is_Script=-	TAI_Viet}', "");
    Expect(1, 43744, '\p{^Is_Script=-	TAI_Viet}', "");
    Expect(1, 43744, '\P{Is_Script=-	TAI_Viet}', "");
    Expect(0, 43744, '\P{^Is_Script=-	TAI_Viet}', "");
    Error('\p{Is_Sc=/a/ 	tavt}');
    Error('\P{Is_Sc=/a/ 	tavt}');
    Expect(1, 43743, '\p{Is_Sc=tavt}', "");
    Expect(0, 43743, '\p{^Is_Sc=tavt}', "");
    Expect(0, 43743, '\P{Is_Sc=tavt}', "");
    Expect(1, 43743, '\P{^Is_Sc=tavt}', "");
    Expect(0, 43744, '\p{Is_Sc=tavt}', "");
    Expect(1, 43744, '\p{^Is_Sc=tavt}', "");
    Expect(1, 43744, '\P{Is_Sc=tavt}', "");
    Expect(0, 43744, '\P{^Is_Sc=tavt}', "");
    Expect(1, 43743, '\p{Is_Sc=-	Tavt}', "");
    Expect(0, 43743, '\p{^Is_Sc=-	Tavt}', "");
    Expect(0, 43743, '\P{Is_Sc=-	Tavt}', "");
    Expect(1, 43743, '\P{^Is_Sc=-	Tavt}', "");
    Expect(0, 43744, '\p{Is_Sc=-	Tavt}', "");
    Expect(1, 43744, '\p{^Is_Sc=-	Tavt}', "");
    Expect(1, 43744, '\P{Is_Sc=-	Tavt}', "");
    Expect(0, 43744, '\P{^Is_Sc=-	Tavt}', "");
    Error('\p{Script=:=	Telugu}');
    Error('\P{Script=:=	Telugu}');
    Expect(1, 3199, '\p{Script=:\ATelugu\z:}', "");;
    Expect(0, 3200, '\p{Script=:\ATelugu\z:}', "");;
    Expect(1, 3199, '\p{Script:telugu}', "");
    Expect(0, 3199, '\p{^Script:telugu}', "");
    Expect(0, 3199, '\P{Script:telugu}', "");
    Expect(1, 3199, '\P{^Script:telugu}', "");
    Expect(0, 3200, '\p{Script:telugu}', "");
    Expect(1, 3200, '\p{^Script:telugu}', "");
    Expect(1, 3200, '\P{Script:telugu}', "");
    Expect(0, 3200, '\P{^Script:telugu}', "");
    Expect(1, 3199, '\p{Script=:\Atelugu\z:}', "");;
    Expect(0, 3200, '\p{Script=:\Atelugu\z:}', "");;
    Expect(1, 3199, '\p{Script=-telugu}', "");
    Expect(0, 3199, '\p{^Script=-telugu}', "");
    Expect(0, 3199, '\P{Script=-telugu}', "");
    Expect(1, 3199, '\P{^Script=-telugu}', "");
    Expect(0, 3200, '\p{Script=-telugu}', "");
    Expect(1, 3200, '\p{^Script=-telugu}', "");
    Expect(1, 3200, '\P{Script=-telugu}', "");
    Expect(0, 3200, '\P{^Script=-telugu}', "");
    Error('\p{Sc= /a/Telu}');
    Error('\P{Sc= /a/Telu}');
    Expect(1, 3199, '\p{Sc=:\ATelu\z:}', "");;
    Expect(0, 3200, '\p{Sc=:\ATelu\z:}', "");;
    Expect(1, 3199, '\p{Sc=telu}', "");
    Expect(0, 3199, '\p{^Sc=telu}', "");
    Expect(0, 3199, '\P{Sc=telu}', "");
    Expect(1, 3199, '\P{^Sc=telu}', "");
    Expect(0, 3200, '\p{Sc=telu}', "");
    Expect(1, 3200, '\p{^Sc=telu}', "");
    Expect(1, 3200, '\P{Sc=telu}', "");
    Expect(0, 3200, '\P{^Sc=telu}', "");
    Expect(1, 3199, '\p{Sc=:\Atelu\z:}', "");;
    Expect(0, 3200, '\p{Sc=:\Atelu\z:}', "");;
    Expect(1, 3199, '\p{Sc=__TELU}', "");
    Expect(0, 3199, '\p{^Sc=__TELU}', "");
    Expect(0, 3199, '\P{Sc=__TELU}', "");
    Expect(1, 3199, '\P{^Sc=__TELU}', "");
    Expect(0, 3200, '\p{Sc=__TELU}', "");
    Expect(1, 3200, '\p{^Sc=__TELU}', "");
    Expect(1, 3200, '\P{Sc=__TELU}', "");
    Expect(0, 3200, '\P{^Sc=__TELU}', "");
    Error('\p{Is_Script=_:=Telugu}');
    Error('\P{Is_Script=_:=Telugu}');
    Expect(1, 3199, '\p{Is_Script=telugu}', "");
    Expect(0, 3199, '\p{^Is_Script=telugu}', "");
    Expect(0, 3199, '\P{Is_Script=telugu}', "");
    Expect(1, 3199, '\P{^Is_Script=telugu}', "");
    Expect(0, 3200, '\p{Is_Script=telugu}', "");
    Expect(1, 3200, '\p{^Is_Script=telugu}', "");
    Expect(1, 3200, '\P{Is_Script=telugu}', "");
    Expect(0, 3200, '\P{^Is_Script=telugu}', "");
    Expect(1, 3199, '\p{Is_Script=	_telugu}', "");
    Expect(0, 3199, '\p{^Is_Script=	_telugu}', "");
    Expect(0, 3199, '\P{Is_Script=	_telugu}', "");
    Expect(1, 3199, '\P{^Is_Script=	_telugu}', "");
    Expect(0, 3200, '\p{Is_Script=	_telugu}', "");
    Expect(1, 3200, '\p{^Is_Script=	_telugu}', "");
    Expect(1, 3200, '\P{Is_Script=	_telugu}', "");
    Expect(0, 3200, '\P{^Is_Script=	_telugu}', "");
    Error('\p{Is_Sc:_/a/Telu}');
    Error('\P{Is_Sc:_/a/Telu}');
    Expect(1, 3199, '\p{Is_Sc=telu}', "");
    Expect(0, 3199, '\p{^Is_Sc=telu}', "");
    Expect(0, 3199, '\P{Is_Sc=telu}', "");
    Expect(1, 3199, '\P{^Is_Sc=telu}', "");
    Expect(0, 3200, '\p{Is_Sc=telu}', "");
    Expect(1, 3200, '\p{^Is_Sc=telu}', "");
    Expect(1, 3200, '\P{Is_Sc=telu}', "");
    Expect(0, 3200, '\P{^Is_Sc=telu}', "");
    Expect(1, 3199, '\p{Is_Sc=	telu}', "");
    Expect(0, 3199, '\p{^Is_Sc=	telu}', "");
    Expect(0, 3199, '\P{Is_Sc=	telu}', "");
    Expect(1, 3199, '\P{^Is_Sc=	telu}', "");
    Expect(0, 3200, '\p{Is_Sc=	telu}', "");
    Expect(1, 3200, '\p{^Is_Sc=	telu}', "");
    Expect(1, 3200, '\P{Is_Sc=	telu}', "");
    Expect(0, 3200, '\P{^Is_Sc=	telu}', "");
    Error('\p{Script:   _:=Tifinagh}');
    Error('\P{Script:   _:=Tifinagh}');
    Expect(1, 11647, '\p{Script=:\ATifinagh\z:}', "");;
    Expect(0, 11648, '\p{Script=:\ATifinagh\z:}', "");;
    Expect(1, 11647, '\p{Script=tifinagh}', "");
    Expect(0, 11647, '\p{^Script=tifinagh}', "");
    Expect(0, 11647, '\P{Script=tifinagh}', "");
    Expect(1, 11647, '\P{^Script=tifinagh}', "");
    Expect(0, 11648, '\p{Script=tifinagh}', "");
    Expect(1, 11648, '\p{^Script=tifinagh}', "");
    Expect(1, 11648, '\P{Script=tifinagh}', "");
    Expect(0, 11648, '\P{^Script=tifinagh}', "");
    Expect(1, 11647, '\p{Script=:\Atifinagh\z:}', "");;
    Expect(0, 11648, '\p{Script=:\Atifinagh\z:}', "");;
    Expect(1, 11647, '\p{Script=	tifinagh}', "");
    Expect(0, 11647, '\p{^Script=	tifinagh}', "");
    Expect(0, 11647, '\P{Script=	tifinagh}', "");
    Expect(1, 11647, '\P{^Script=	tifinagh}', "");
    Expect(0, 11648, '\p{Script=	tifinagh}', "");
    Expect(1, 11648, '\p{^Script=	tifinagh}', "");
    Expect(1, 11648, '\P{Script=	tifinagh}', "");
    Expect(0, 11648, '\P{^Script=	tifinagh}', "");
    Error('\p{Sc=:= TFNG}');
    Error('\P{Sc=:= TFNG}');
    Expect(1, 11647, '\p{Sc=:\ATfng\z:}', "");;
    Expect(0, 11648, '\p{Sc=:\ATfng\z:}', "");;
    Expect(1, 11647, '\p{Sc=tfng}', "");
    Expect(0, 11647, '\p{^Sc=tfng}', "");
    Expect(0, 11647, '\P{Sc=tfng}', "");
    Expect(1, 11647, '\P{^Sc=tfng}', "");
    Expect(0, 11648, '\p{Sc=tfng}', "");
    Expect(1, 11648, '\p{^Sc=tfng}', "");
    Expect(1, 11648, '\P{Sc=tfng}', "");
    Expect(0, 11648, '\P{^Sc=tfng}', "");
    Expect(1, 11647, '\p{Sc=:\Atfng\z:}', "");;
    Expect(0, 11648, '\p{Sc=:\Atfng\z:}', "");;
    Expect(1, 11647, '\p{Sc=- Tfng}', "");
    Expect(0, 11647, '\p{^Sc=- Tfng}', "");
    Expect(0, 11647, '\P{Sc=- Tfng}', "");
    Expect(1, 11647, '\P{^Sc=- Tfng}', "");
    Expect(0, 11648, '\p{Sc=- Tfng}', "");
    Expect(1, 11648, '\p{^Sc=- Tfng}', "");
    Expect(1, 11648, '\P{Sc=- Tfng}', "");
    Expect(0, 11648, '\P{^Sc=- Tfng}', "");
    Error('\p{Is_Script=--TIFINAGH/a/}');
    Error('\P{Is_Script=--TIFINAGH/a/}');
    Expect(1, 11647, '\p{Is_Script=tifinagh}', "");
    Expect(0, 11647, '\p{^Is_Script=tifinagh}', "");
    Expect(0, 11647, '\P{Is_Script=tifinagh}', "");
    Expect(1, 11647, '\P{^Is_Script=tifinagh}', "");
    Expect(0, 11648, '\p{Is_Script=tifinagh}', "");
    Expect(1, 11648, '\p{^Is_Script=tifinagh}', "");
    Expect(1, 11648, '\P{Is_Script=tifinagh}', "");
    Expect(0, 11648, '\P{^Is_Script=tifinagh}', "");
    Expect(1, 11647, '\p{Is_Script=  TIFINAGH}', "");
    Expect(0, 11647, '\p{^Is_Script=  TIFINAGH}', "");
    Expect(0, 11647, '\P{Is_Script=  TIFINAGH}', "");
    Expect(1, 11647, '\P{^Is_Script=  TIFINAGH}', "");
    Expect(0, 11648, '\p{Is_Script=  TIFINAGH}', "");
    Expect(1, 11648, '\p{^Is_Script=  TIFINAGH}', "");
    Expect(1, 11648, '\P{Is_Script=  TIFINAGH}', "");
    Expect(0, 11648, '\P{^Is_Script=  TIFINAGH}', "");
    Error('\p{Is_Sc=:= Tfng}');
    Error('\P{Is_Sc=:= Tfng}');
    Expect(1, 11647, '\p{Is_Sc:	tfng}', "");
    Expect(0, 11647, '\p{^Is_Sc:	tfng}', "");
    Expect(0, 11647, '\P{Is_Sc:	tfng}', "");
    Expect(1, 11647, '\P{^Is_Sc:	tfng}', "");
    Expect(0, 11648, '\p{Is_Sc:	tfng}', "");
    Expect(1, 11648, '\p{^Is_Sc:	tfng}', "");
    Expect(1, 11648, '\P{Is_Sc:	tfng}', "");
    Expect(0, 11648, '\P{^Is_Sc:	tfng}', "");
    Expect(1, 11647, '\p{Is_Sc=-Tfng}', "");
    Expect(0, 11647, '\p{^Is_Sc=-Tfng}', "");
    Expect(0, 11647, '\P{Is_Sc=-Tfng}', "");
    Expect(1, 11647, '\P{^Is_Sc=-Tfng}', "");
    Expect(0, 11648, '\p{Is_Sc=-Tfng}', "");
    Expect(1, 11648, '\p{^Is_Sc=-Tfng}', "");
    Expect(1, 11648, '\P{Is_Sc=-Tfng}', "");
    Expect(0, 11648, '\P{^Is_Sc=-Tfng}', "");
    Error('\p{Script=/a/_-tagalog}');
    Error('\P{Script=/a/_-tagalog}');
    Expect(1, 5919, '\p{Script=:\ATagalog\z:}', "");;
    Expect(0, 5920, '\p{Script=:\ATagalog\z:}', "");;
    Expect(1, 5919, '\p{Script=tagalog}', "");
    Expect(0, 5919, '\p{^Script=tagalog}', "");
    Expect(0, 5919, '\P{Script=tagalog}', "");
    Expect(1, 5919, '\P{^Script=tagalog}', "");
    Expect(0, 5920, '\p{Script=tagalog}', "");
    Expect(1, 5920, '\p{^Script=tagalog}', "");
    Expect(1, 5920, '\P{Script=tagalog}', "");
    Expect(0, 5920, '\P{^Script=tagalog}', "");
    Expect(1, 5919, '\p{Script=:\Atagalog\z:}', "");;
    Expect(0, 5920, '\p{Script=:\Atagalog\z:}', "");;
    Expect(1, 5919, '\p{Script=	-tagalog}', "");
    Expect(0, 5919, '\p{^Script=	-tagalog}', "");
    Expect(0, 5919, '\P{Script=	-tagalog}', "");
    Expect(1, 5919, '\P{^Script=	-tagalog}', "");
    Expect(0, 5920, '\p{Script=	-tagalog}', "");
    Expect(1, 5920, '\p{^Script=	-tagalog}', "");
    Expect(1, 5920, '\P{Script=	-tagalog}', "");
    Expect(0, 5920, '\P{^Script=	-tagalog}', "");
    Error('\p{Sc=:=-tglg}');
    Error('\P{Sc=:=-tglg}');
    Expect(1, 5919, '\p{Sc=:\ATglg\z:}', "");;
    Expect(0, 5920, '\p{Sc=:\ATglg\z:}', "");;
    Expect(1, 5919, '\p{Sc=tglg}', "");
    Expect(0, 5919, '\p{^Sc=tglg}', "");
    Expect(0, 5919, '\P{Sc=tglg}', "");
    Expect(1, 5919, '\P{^Sc=tglg}', "");
    Expect(0, 5920, '\p{Sc=tglg}', "");
    Expect(1, 5920, '\p{^Sc=tglg}', "");
    Expect(1, 5920, '\P{Sc=tglg}', "");
    Expect(0, 5920, '\P{^Sc=tglg}', "");
    Expect(1, 5919, '\p{Sc=:\Atglg\z:}', "");;
    Expect(0, 5920, '\p{Sc=:\Atglg\z:}', "");;
    Expect(1, 5919, '\p{Sc= -Tglg}', "");
    Expect(0, 5919, '\p{^Sc= -Tglg}', "");
    Expect(0, 5919, '\P{Sc= -Tglg}', "");
    Expect(1, 5919, '\P{^Sc= -Tglg}', "");
    Expect(0, 5920, '\p{Sc= -Tglg}', "");
    Expect(1, 5920, '\p{^Sc= -Tglg}', "");
    Expect(1, 5920, '\P{Sc= -Tglg}', "");
    Expect(0, 5920, '\P{^Sc= -Tglg}', "");
    Error('\p{Is_Script:/a/	_Tagalog}');
    Error('\P{Is_Script:/a/	_Tagalog}');
    Expect(1, 5919, '\p{Is_Script=tagalog}', "");
    Expect(0, 5919, '\p{^Is_Script=tagalog}', "");
    Expect(0, 5919, '\P{Is_Script=tagalog}', "");
    Expect(1, 5919, '\P{^Is_Script=tagalog}', "");
    Expect(0, 5920, '\p{Is_Script=tagalog}', "");
    Expect(1, 5920, '\p{^Is_Script=tagalog}', "");
    Expect(1, 5920, '\P{Is_Script=tagalog}', "");
    Expect(0, 5920, '\P{^Is_Script=tagalog}', "");
    Expect(1, 5919, '\p{Is_Script=--Tagalog}', "");
    Expect(0, 5919, '\p{^Is_Script=--Tagalog}', "");
    Expect(0, 5919, '\P{Is_Script=--Tagalog}', "");
    Expect(1, 5919, '\P{^Is_Script=--Tagalog}', "");
    Expect(0, 5920, '\p{Is_Script=--Tagalog}', "");
    Expect(1, 5920, '\p{^Is_Script=--Tagalog}', "");
    Expect(1, 5920, '\P{Is_Script=--Tagalog}', "");
    Expect(0, 5920, '\P{^Is_Script=--Tagalog}', "");
    Error('\p{Is_Sc=	/a/TGLG}');
    Error('\P{Is_Sc=	/a/TGLG}');
    Expect(1, 5919, '\p{Is_Sc=tglg}', "");
    Expect(0, 5919, '\p{^Is_Sc=tglg}', "");
    Expect(0, 5919, '\P{Is_Sc=tglg}', "");
    Expect(1, 5919, '\P{^Is_Sc=tglg}', "");
    Expect(0, 5920, '\p{Is_Sc=tglg}', "");
    Expect(1, 5920, '\p{^Is_Sc=tglg}', "");
    Expect(1, 5920, '\P{Is_Sc=tglg}', "");
    Expect(0, 5920, '\P{^Is_Sc=tglg}', "");
    Expect(1, 5919, '\p{Is_Sc=	 TGLG}', "");
    Expect(0, 5919, '\p{^Is_Sc=	 TGLG}', "");
    Expect(0, 5919, '\P{Is_Sc=	 TGLG}', "");
    Expect(1, 5919, '\P{^Is_Sc=	 TGLG}', "");
    Expect(0, 5920, '\p{Is_Sc=	 TGLG}', "");
    Expect(1, 5920, '\p{^Is_Sc=	 TGLG}', "");
    Expect(1, 5920, '\P{Is_Sc=	 TGLG}', "");
    Expect(0, 5920, '\P{^Is_Sc=	 TGLG}', "");
    Error('\p{Script=-Thaana:=}');
    Error('\P{Script=-Thaana:=}');
    Expect(1, 1969, '\p{Script=:\AThaana\z:}', "");;
    Expect(0, 1970, '\p{Script=:\AThaana\z:}', "");;
    Expect(1, 1969, '\p{Script=thaana}', "");
    Expect(0, 1969, '\p{^Script=thaana}', "");
    Expect(0, 1969, '\P{Script=thaana}', "");
    Expect(1, 1969, '\P{^Script=thaana}', "");
    Expect(0, 1970, '\p{Script=thaana}', "");
    Expect(1, 1970, '\p{^Script=thaana}', "");
    Expect(1, 1970, '\P{Script=thaana}', "");
    Expect(0, 1970, '\P{^Script=thaana}', "");
    Expect(1, 1969, '\p{Script=:\Athaana\z:}', "");;
    Expect(0, 1970, '\p{Script=:\Athaana\z:}', "");;
    Expect(1, 1969, '\p{Script=_ THAANA}', "");
    Expect(0, 1969, '\p{^Script=_ THAANA}', "");
    Expect(0, 1969, '\P{Script=_ THAANA}', "");
    Expect(1, 1969, '\P{^Script=_ THAANA}', "");
    Expect(0, 1970, '\p{Script=_ THAANA}', "");
    Expect(1, 1970, '\p{^Script=_ THAANA}', "");
    Expect(1, 1970, '\P{Script=_ THAANA}', "");
    Expect(0, 1970, '\P{^Script=_ THAANA}', "");
    Error('\p{Sc=-thaa:=}');
    Error('\P{Sc=-thaa:=}');
    Expect(1, 1969, '\p{Sc=:\AThaa\z:}', "");;
    Expect(0, 1970, '\p{Sc=:\AThaa\z:}', "");;
    Expect(1, 1969, '\p{Sc=thaa}', "");
    Expect(0, 1969, '\p{^Sc=thaa}', "");
    Expect(0, 1969, '\P{Sc=thaa}', "");
    Expect(1, 1969, '\P{^Sc=thaa}', "");
    Expect(0, 1970, '\p{Sc=thaa}', "");
    Expect(1, 1970, '\p{^Sc=thaa}', "");
    Expect(1, 1970, '\P{Sc=thaa}', "");
    Expect(0, 1970, '\P{^Sc=thaa}', "");
    Expect(1, 1969, '\p{Sc=:\Athaa\z:}', "");;
    Expect(0, 1970, '\p{Sc=:\Athaa\z:}', "");;
    Expect(1, 1969, '\p{Sc= Thaa}', "");
    Expect(0, 1969, '\p{^Sc= Thaa}', "");
    Expect(0, 1969, '\P{Sc= Thaa}', "");
    Expect(1, 1969, '\P{^Sc= Thaa}', "");
    Expect(0, 1970, '\p{Sc= Thaa}', "");
    Expect(1, 1970, '\p{^Sc= Thaa}', "");
    Expect(1, 1970, '\P{Sc= Thaa}', "");
    Expect(0, 1970, '\P{^Sc= Thaa}', "");
    Error('\p{Is_Script=/a/	-THAANA}');
    Error('\P{Is_Script=/a/	-THAANA}');
    Expect(1, 1969, '\p{Is_Script=thaana}', "");
    Expect(0, 1969, '\p{^Is_Script=thaana}', "");
    Expect(0, 1969, '\P{Is_Script=thaana}', "");
    Expect(1, 1969, '\P{^Is_Script=thaana}', "");
    Expect(0, 1970, '\p{Is_Script=thaana}', "");
    Expect(1, 1970, '\p{^Is_Script=thaana}', "");
    Expect(1, 1970, '\P{Is_Script=thaana}', "");
    Expect(0, 1970, '\P{^Is_Script=thaana}', "");
    Expect(1, 1969, '\p{Is_Script=		thaana}', "");
    Expect(0, 1969, '\p{^Is_Script=		thaana}', "");
    Expect(0, 1969, '\P{Is_Script=		thaana}', "");
    Expect(1, 1969, '\P{^Is_Script=		thaana}', "");
    Expect(0, 1970, '\p{Is_Script=		thaana}', "");
    Expect(1, 1970, '\p{^Is_Script=		thaana}', "");
    Expect(1, 1970, '\P{Is_Script=		thaana}', "");
    Expect(0, 1970, '\P{^Is_Script=		thaana}', "");
    Error('\p{Is_Sc=	/a/Thaa}');
    Error('\P{Is_Sc=	/a/Thaa}');
    Expect(1, 1969, '\p{Is_Sc=thaa}', "");
    Expect(0, 1969, '\p{^Is_Sc=thaa}', "");
    Expect(0, 1969, '\P{Is_Sc=thaa}', "");
    Expect(1, 1969, '\P{^Is_Sc=thaa}', "");
    Expect(0, 1970, '\p{Is_Sc=thaa}', "");
    Expect(1, 1970, '\p{^Is_Sc=thaa}', "");
    Expect(1, 1970, '\P{Is_Sc=thaa}', "");
    Expect(0, 1970, '\P{^Is_Sc=thaa}', "");
    Expect(1, 1969, '\p{Is_Sc=--thaa}', "");
    Expect(0, 1969, '\p{^Is_Sc=--thaa}', "");
    Expect(0, 1969, '\P{Is_Sc=--thaa}', "");
    Expect(1, 1969, '\P{^Is_Sc=--thaa}', "");
    Expect(0, 1970, '\p{Is_Sc=--thaa}', "");
    Expect(1, 1970, '\p{^Is_Sc=--thaa}', "");
    Expect(1, 1970, '\P{Is_Sc=--thaa}', "");
    Expect(0, 1970, '\P{^Is_Sc=--thaa}', "");
    Error('\p{Script=/a/	_thai}');
    Error('\P{Script=/a/	_thai}');
    Expect(1, 3675, '\p{Script=:\AThai\z:}', "");;
    Expect(0, 3676, '\p{Script=:\AThai\z:}', "");;
    Expect(1, 3675, '\p{Script:   thai}', "");
    Expect(0, 3675, '\p{^Script:   thai}', "");
    Expect(0, 3675, '\P{Script:   thai}', "");
    Expect(1, 3675, '\P{^Script:   thai}', "");
    Expect(0, 3676, '\p{Script:   thai}', "");
    Expect(1, 3676, '\p{^Script:   thai}', "");
    Expect(1, 3676, '\P{Script:   thai}', "");
    Expect(0, 3676, '\P{^Script:   thai}', "");
    Expect(1, 3675, '\p{Script=:\Athai\z:}', "");;
    Expect(0, 3676, '\p{Script=:\Athai\z:}', "");;
    Expect(1, 3675, '\p{Script=--Thai}', "");
    Expect(0, 3675, '\p{^Script=--Thai}', "");
    Expect(0, 3675, '\P{Script=--Thai}', "");
    Expect(1, 3675, '\P{^Script=--Thai}', "");
    Expect(0, 3676, '\p{Script=--Thai}', "");
    Expect(1, 3676, '\p{^Script=--Thai}', "");
    Expect(1, 3676, '\P{Script=--Thai}', "");
    Expect(0, 3676, '\P{^Script=--Thai}', "");
    Error('\p{Sc=/a/_	Thai}');
    Error('\P{Sc=/a/_	Thai}');
    Expect(1, 3675, '\p{Sc=:\AThai\z:}', "");;
    Expect(0, 3676, '\p{Sc=:\AThai\z:}', "");;
    Expect(1, 3675, '\p{Sc: thai}', "");
    Expect(0, 3675, '\p{^Sc: thai}', "");
    Expect(0, 3675, '\P{Sc: thai}', "");
    Expect(1, 3675, '\P{^Sc: thai}', "");
    Expect(0, 3676, '\p{Sc: thai}', "");
    Expect(1, 3676, '\p{^Sc: thai}', "");
    Expect(1, 3676, '\P{Sc: thai}', "");
    Expect(0, 3676, '\P{^Sc: thai}', "");
    Expect(1, 3675, '\p{Sc=:\Athai\z:}', "");;
    Expect(0, 3676, '\p{Sc=:\Athai\z:}', "");;
    Expect(1, 3675, '\p{Sc=Thai}', "");
    Expect(0, 3675, '\p{^Sc=Thai}', "");
    Expect(0, 3675, '\P{Sc=Thai}', "");
    Expect(1, 3675, '\P{^Sc=Thai}', "");
    Expect(0, 3676, '\p{Sc=Thai}', "");
    Expect(1, 3676, '\p{^Sc=Thai}', "");
    Expect(1, 3676, '\P{Sc=Thai}', "");
    Expect(0, 3676, '\P{^Sc=Thai}', "");
    Error('\p{Is_Script=:=  Thai}');
    Error('\P{Is_Script=:=  Thai}');
    Expect(1, 3675, '\p{Is_Script=thai}', "");
    Expect(0, 3675, '\p{^Is_Script=thai}', "");
    Expect(0, 3675, '\P{Is_Script=thai}', "");
    Expect(1, 3675, '\P{^Is_Script=thai}', "");
    Expect(0, 3676, '\p{Is_Script=thai}', "");
    Expect(1, 3676, '\p{^Is_Script=thai}', "");
    Expect(1, 3676, '\P{Is_Script=thai}', "");
    Expect(0, 3676, '\P{^Is_Script=thai}', "");
    Expect(1, 3675, '\p{Is_Script=  Thai}', "");
    Expect(0, 3675, '\p{^Is_Script=  Thai}', "");
    Expect(0, 3675, '\P{Is_Script=  Thai}', "");
    Expect(1, 3675, '\P{^Is_Script=  Thai}', "");
    Expect(0, 3676, '\p{Is_Script=  Thai}', "");
    Expect(1, 3676, '\p{^Is_Script=  Thai}', "");
    Expect(1, 3676, '\P{Is_Script=  Thai}', "");
    Expect(0, 3676, '\P{^Is_Script=  Thai}', "");
    Error('\p{Is_Sc= :=Thai}');
    Error('\P{Is_Sc= :=Thai}');
    Expect(1, 3675, '\p{Is_Sc=thai}', "");
    Expect(0, 3675, '\p{^Is_Sc=thai}', "");
    Expect(0, 3675, '\P{Is_Sc=thai}', "");
    Expect(1, 3675, '\P{^Is_Sc=thai}', "");
    Expect(0, 3676, '\p{Is_Sc=thai}', "");
    Expect(1, 3676, '\p{^Is_Sc=thai}', "");
    Expect(1, 3676, '\P{Is_Sc=thai}', "");
    Expect(0, 3676, '\P{^Is_Sc=thai}', "");
    Expect(1, 3675, '\p{Is_Sc=_Thai}', "");
    Expect(0, 3675, '\p{^Is_Sc=_Thai}', "");
    Expect(0, 3675, '\P{Is_Sc=_Thai}', "");
    Expect(1, 3675, '\P{^Is_Sc=_Thai}', "");
    Expect(0, 3676, '\p{Is_Sc=_Thai}', "");
    Expect(1, 3676, '\p{^Is_Sc=_Thai}', "");
    Expect(1, 3676, '\P{Is_Sc=_Thai}', "");
    Expect(0, 3676, '\P{^Is_Sc=_Thai}', "");
    Error('\p{Script=-TIBETAN:=}');
    Error('\P{Script=-TIBETAN:=}');
    Expect(1, 4058, '\p{Script=:\ATibetan\z:}', "");;
    Expect(0, 4059, '\p{Script=:\ATibetan\z:}', "");;
    Expect(1, 4058, '\p{Script=tibetan}', "");
    Expect(0, 4058, '\p{^Script=tibetan}', "");
    Expect(0, 4058, '\P{Script=tibetan}', "");
    Expect(1, 4058, '\P{^Script=tibetan}', "");
    Expect(0, 4059, '\p{Script=tibetan}', "");
    Expect(1, 4059, '\p{^Script=tibetan}', "");
    Expect(1, 4059, '\P{Script=tibetan}', "");
    Expect(0, 4059, '\P{^Script=tibetan}', "");
    Expect(1, 4058, '\p{Script=:\Atibetan\z:}', "");;
    Expect(0, 4059, '\p{Script=:\Atibetan\z:}', "");;
    Expect(1, 4058, '\p{Script=__Tibetan}', "");
    Expect(0, 4058, '\p{^Script=__Tibetan}', "");
    Expect(0, 4058, '\P{Script=__Tibetan}', "");
    Expect(1, 4058, '\P{^Script=__Tibetan}', "");
    Expect(0, 4059, '\p{Script=__Tibetan}', "");
    Expect(1, 4059, '\p{^Script=__Tibetan}', "");
    Expect(1, 4059, '\P{Script=__Tibetan}', "");
    Expect(0, 4059, '\P{^Script=__Tibetan}', "");
    Error('\p{Sc= /a/TIBT}');
    Error('\P{Sc= /a/TIBT}');
    Expect(1, 4058, '\p{Sc=:\ATibt\z:}', "");;
    Expect(0, 4059, '\p{Sc=:\ATibt\z:}', "");;
    Expect(1, 4058, '\p{Sc=tibt}', "");
    Expect(0, 4058, '\p{^Sc=tibt}', "");
    Expect(0, 4058, '\P{Sc=tibt}', "");
    Expect(1, 4058, '\P{^Sc=tibt}', "");
    Expect(0, 4059, '\p{Sc=tibt}', "");
    Expect(1, 4059, '\p{^Sc=tibt}', "");
    Expect(1, 4059, '\P{Sc=tibt}', "");
    Expect(0, 4059, '\P{^Sc=tibt}', "");
    Expect(1, 4058, '\p{Sc=:\Atibt\z:}', "");;
    Expect(0, 4059, '\p{Sc=:\Atibt\z:}', "");;
    Expect(1, 4058, '\p{Sc=-_tibt}', "");
    Expect(0, 4058, '\p{^Sc=-_tibt}', "");
    Expect(0, 4058, '\P{Sc=-_tibt}', "");
    Expect(1, 4058, '\P{^Sc=-_tibt}', "");
    Expect(0, 4059, '\p{Sc=-_tibt}', "");
    Expect(1, 4059, '\p{^Sc=-_tibt}', "");
    Expect(1, 4059, '\P{Sc=-_tibt}', "");
    Expect(0, 4059, '\P{^Sc=-_tibt}', "");
    Error('\p{Is_Script=	TIBETAN:=}');
    Error('\P{Is_Script=	TIBETAN:=}');
    Expect(1, 4058, '\p{Is_Script=tibetan}', "");
    Expect(0, 4058, '\p{^Is_Script=tibetan}', "");
    Expect(0, 4058, '\P{Is_Script=tibetan}', "");
    Expect(1, 4058, '\P{^Is_Script=tibetan}', "");
    Expect(0, 4059, '\p{Is_Script=tibetan}', "");
    Expect(1, 4059, '\p{^Is_Script=tibetan}', "");
    Expect(1, 4059, '\P{Is_Script=tibetan}', "");
    Expect(0, 4059, '\P{^Is_Script=tibetan}', "");
    Expect(1, 4058, '\p{Is_Script=-Tibetan}', "");
    Expect(0, 4058, '\p{^Is_Script=-Tibetan}', "");
    Expect(0, 4058, '\P{Is_Script=-Tibetan}', "");
    Expect(1, 4058, '\P{^Is_Script=-Tibetan}', "");
    Expect(0, 4059, '\p{Is_Script=-Tibetan}', "");
    Expect(1, 4059, '\p{^Is_Script=-Tibetan}', "");
    Expect(1, 4059, '\P{Is_Script=-Tibetan}', "");
    Expect(0, 4059, '\P{^Is_Script=-Tibetan}', "");
    Error('\p{Is_Sc: Tibt:=}');
    Error('\P{Is_Sc: Tibt:=}');
    Expect(1, 4058, '\p{Is_Sc=tibt}', "");
    Expect(0, 4058, '\p{^Is_Sc=tibt}', "");
    Expect(0, 4058, '\P{Is_Sc=tibt}', "");
    Expect(1, 4058, '\P{^Is_Sc=tibt}', "");
    Expect(0, 4059, '\p{Is_Sc=tibt}', "");
    Expect(1, 4059, '\p{^Is_Sc=tibt}', "");
    Expect(1, 4059, '\P{Is_Sc=tibt}', "");
    Expect(0, 4059, '\P{^Is_Sc=tibt}', "");
    Error('\p{Script=-_TIRHUTA:=}');
    Error('\P{Script=-_TIRHUTA:=}');
    Expect(1, 70873, '\p{Script=:\ATirhuta\z:}', "");;
    Expect(0, 70874, '\p{Script=:\ATirhuta\z:}', "");;
    Expect(1, 70873, '\p{Script=tirhuta}', "");
    Expect(0, 70873, '\p{^Script=tirhuta}', "");
    Expect(0, 70873, '\P{Script=tirhuta}', "");
    Expect(1, 70873, '\P{^Script=tirhuta}', "");
    Expect(0, 70874, '\p{Script=tirhuta}', "");
    Expect(1, 70874, '\p{^Script=tirhuta}', "");
    Expect(1, 70874, '\P{Script=tirhuta}', "");
    Expect(0, 70874, '\P{^Script=tirhuta}', "");
    Expect(1, 70873, '\p{Script=:\Atirhuta\z:}', "");;
    Expect(0, 70874, '\p{Script=:\Atirhuta\z:}', "");;
    Expect(1, 70873, '\p{Script=-Tirhuta}', "");
    Expect(0, 70873, '\p{^Script=-Tirhuta}', "");
    Expect(0, 70873, '\P{Script=-Tirhuta}', "");
    Expect(1, 70873, '\P{^Script=-Tirhuta}', "");
    Expect(0, 70874, '\p{Script=-Tirhuta}', "");
    Expect(1, 70874, '\p{^Script=-Tirhuta}', "");
    Expect(1, 70874, '\P{Script=-Tirhuta}', "");
    Expect(0, 70874, '\P{^Script=-Tirhuta}', "");
    Error('\p{Sc=:=__TIRH}');
    Error('\P{Sc=:=__TIRH}');
    Expect(1, 70873, '\p{Sc=:\ATirh\z:}', "");;
    Expect(0, 70874, '\p{Sc=:\ATirh\z:}', "");;
    Expect(1, 70873, '\p{Sc=tirh}', "");
    Expect(0, 70873, '\p{^Sc=tirh}', "");
    Expect(0, 70873, '\P{Sc=tirh}', "");
    Expect(1, 70873, '\P{^Sc=tirh}', "");
    Expect(0, 70874, '\p{Sc=tirh}', "");
    Expect(1, 70874, '\p{^Sc=tirh}', "");
    Expect(1, 70874, '\P{Sc=tirh}', "");
    Expect(0, 70874, '\P{^Sc=tirh}', "");
    Expect(1, 70873, '\p{Sc=:\Atirh\z:}', "");;
    Expect(0, 70874, '\p{Sc=:\Atirh\z:}', "");;
    Expect(1, 70873, '\p{Sc=	_Tirh}', "");
    Expect(0, 70873, '\p{^Sc=	_Tirh}', "");
    Expect(0, 70873, '\P{Sc=	_Tirh}', "");
    Expect(1, 70873, '\P{^Sc=	_Tirh}', "");
    Expect(0, 70874, '\p{Sc=	_Tirh}', "");
    Expect(1, 70874, '\p{^Sc=	_Tirh}', "");
    Expect(1, 70874, '\P{Sc=	_Tirh}', "");
    Expect(0, 70874, '\P{^Sc=	_Tirh}', "");
    Error('\p{Is_Script=:=	-Tirhuta}');
    Error('\P{Is_Script=:=	-Tirhuta}');
    Expect(1, 70873, '\p{Is_Script=tirhuta}', "");
    Expect(0, 70873, '\p{^Is_Script=tirhuta}', "");
    Expect(0, 70873, '\P{Is_Script=tirhuta}', "");
    Expect(1, 70873, '\P{^Is_Script=tirhuta}', "");
    Expect(0, 70874, '\p{Is_Script=tirhuta}', "");
    Expect(1, 70874, '\p{^Is_Script=tirhuta}', "");
    Expect(1, 70874, '\P{Is_Script=tirhuta}', "");
    Expect(0, 70874, '\P{^Is_Script=tirhuta}', "");
    Expect(1, 70873, '\p{Is_Script=__Tirhuta}', "");
    Expect(0, 70873, '\p{^Is_Script=__Tirhuta}', "");
    Expect(0, 70873, '\P{Is_Script=__Tirhuta}', "");
    Expect(1, 70873, '\P{^Is_Script=__Tirhuta}', "");
    Expect(0, 70874, '\p{Is_Script=__Tirhuta}', "");
    Expect(1, 70874, '\p{^Is_Script=__Tirhuta}', "");
    Expect(1, 70874, '\P{Is_Script=__Tirhuta}', "");
    Expect(0, 70874, '\P{^Is_Script=__Tirhuta}', "");
    Error('\p{Is_Sc:		:=tirh}');
    Error('\P{Is_Sc:		:=tirh}');
    Expect(1, 70873, '\p{Is_Sc=tirh}', "");
    Expect(0, 70873, '\p{^Is_Sc=tirh}', "");
    Expect(0, 70873, '\P{Is_Sc=tirh}', "");
    Expect(1, 70873, '\P{^Is_Sc=tirh}', "");
    Expect(0, 70874, '\p{Is_Sc=tirh}', "");
    Expect(1, 70874, '\p{^Is_Sc=tirh}', "");
    Expect(1, 70874, '\P{Is_Sc=tirh}', "");
    Expect(0, 70874, '\P{^Is_Sc=tirh}', "");
    Expect(1, 70873, '\p{Is_Sc=-	TIRH}', "");
    Expect(0, 70873, '\p{^Is_Sc=-	TIRH}', "");
    Expect(0, 70873, '\P{Is_Sc=-	TIRH}', "");
    Expect(1, 70873, '\P{^Is_Sc=-	TIRH}', "");
    Expect(0, 70874, '\p{Is_Sc=-	TIRH}', "");
    Expect(1, 70874, '\p{^Is_Sc=-	TIRH}', "");
    Expect(1, 70874, '\P{Is_Sc=-	TIRH}', "");
    Expect(0, 70874, '\P{^Is_Sc=-	TIRH}', "");
    Error('\p{Script=__tangsa/a/}');
    Error('\P{Script=__tangsa/a/}');
    Expect(1, 92873, '\p{Script=:\ATangsa\z:}', "");;
    Expect(0, 92874, '\p{Script=:\ATangsa\z:}', "");;
    Expect(1, 92873, '\p{Script=tangsa}', "");
    Expect(0, 92873, '\p{^Script=tangsa}', "");
    Expect(0, 92873, '\P{Script=tangsa}', "");
    Expect(1, 92873, '\P{^Script=tangsa}', "");
    Expect(0, 92874, '\p{Script=tangsa}', "");
    Expect(1, 92874, '\p{^Script=tangsa}', "");
    Expect(1, 92874, '\P{Script=tangsa}', "");
    Expect(0, 92874, '\P{^Script=tangsa}', "");
    Expect(1, 92873, '\p{Script=:\Atangsa\z:}', "");;
    Expect(0, 92874, '\p{Script=:\Atangsa\z:}', "");;
    Expect(1, 92873, '\p{Script=_ Tangsa}', "");
    Expect(0, 92873, '\p{^Script=_ Tangsa}', "");
    Expect(0, 92873, '\P{Script=_ Tangsa}', "");
    Expect(1, 92873, '\P{^Script=_ Tangsa}', "");
    Expect(0, 92874, '\p{Script=_ Tangsa}', "");
    Expect(1, 92874, '\p{^Script=_ Tangsa}', "");
    Expect(1, 92874, '\P{Script=_ Tangsa}', "");
    Expect(0, 92874, '\P{^Script=_ Tangsa}', "");
    Error('\p{Sc=_:=Tnsa}');
    Error('\P{Sc=_:=Tnsa}');
    Expect(1, 92873, '\p{Sc=:\ATnsa\z:}', "");;
    Expect(0, 92874, '\p{Sc=:\ATnsa\z:}', "");;
    Expect(1, 92873, '\p{Sc:tnsa}', "");
    Expect(0, 92873, '\p{^Sc:tnsa}', "");
    Expect(0, 92873, '\P{Sc:tnsa}', "");
    Expect(1, 92873, '\P{^Sc:tnsa}', "");
    Expect(0, 92874, '\p{Sc:tnsa}', "");
    Expect(1, 92874, '\p{^Sc:tnsa}', "");
    Expect(1, 92874, '\P{Sc:tnsa}', "");
    Expect(0, 92874, '\P{^Sc:tnsa}', "");
    Expect(1, 92873, '\p{Sc=:\Atnsa\z:}', "");;
    Expect(0, 92874, '\p{Sc=:\Atnsa\z:}', "");;
    Expect(1, 92873, '\p{Sc=-_Tnsa}', "");
    Expect(0, 92873, '\p{^Sc=-_Tnsa}', "");
    Expect(0, 92873, '\P{Sc=-_Tnsa}', "");
    Expect(1, 92873, '\P{^Sc=-_Tnsa}', "");
    Expect(0, 92874, '\p{Sc=-_Tnsa}', "");
    Expect(1, 92874, '\p{^Sc=-_Tnsa}', "");
    Expect(1, 92874, '\P{Sc=-_Tnsa}', "");
    Expect(0, 92874, '\P{^Sc=-_Tnsa}', "");
    Error('\p{Is_Script=_	tangsa:=}');
    Error('\P{Is_Script=_	tangsa:=}');
    Expect(1, 92873, '\p{Is_Script=tangsa}', "");
    Expect(0, 92873, '\p{^Is_Script=tangsa}', "");
    Expect(0, 92873, '\P{Is_Script=tangsa}', "");
    Expect(1, 92873, '\P{^Is_Script=tangsa}', "");
    Expect(0, 92874, '\p{Is_Script=tangsa}', "");
    Expect(1, 92874, '\p{^Is_Script=tangsa}', "");
    Expect(1, 92874, '\P{Is_Script=tangsa}', "");
    Expect(0, 92874, '\P{^Is_Script=tangsa}', "");
    Expect(1, 92873, '\p{Is_Script:- Tangsa}', "");
    Expect(0, 92873, '\p{^Is_Script:- Tangsa}', "");
    Expect(0, 92873, '\P{Is_Script:- Tangsa}', "");
    Expect(1, 92873, '\P{^Is_Script:- Tangsa}', "");
    Expect(0, 92874, '\p{Is_Script:- Tangsa}', "");
    Expect(1, 92874, '\p{^Is_Script:- Tangsa}', "");
    Expect(1, 92874, '\P{Is_Script:- Tangsa}', "");
    Expect(0, 92874, '\P{^Is_Script:- Tangsa}', "");
    Error('\p{Is_Sc:   	 TNSA/a/}');
    Error('\P{Is_Sc:   	 TNSA/a/}');
    Expect(1, 92873, '\p{Is_Sc:	tnsa}', "");
    Expect(0, 92873, '\p{^Is_Sc:	tnsa}', "");
    Expect(0, 92873, '\P{Is_Sc:	tnsa}', "");
    Expect(1, 92873, '\P{^Is_Sc:	tnsa}', "");
    Expect(0, 92874, '\p{Is_Sc:	tnsa}', "");
    Expect(1, 92874, '\p{^Is_Sc:	tnsa}', "");
    Expect(1, 92874, '\P{Is_Sc:	tnsa}', "");
    Expect(0, 92874, '\P{^Is_Sc:	tnsa}', "");
    Expect(1, 92873, '\p{Is_Sc=_TNSA}', "");
    Expect(0, 92873, '\p{^Is_Sc=_TNSA}', "");
    Expect(0, 92873, '\P{Is_Sc=_TNSA}', "");
    Expect(1, 92873, '\P{^Is_Sc=_TNSA}', "");
    Expect(0, 92874, '\p{Is_Sc=_TNSA}', "");
    Expect(1, 92874, '\p{^Is_Sc=_TNSA}', "");
    Expect(1, 92874, '\P{Is_Sc=_TNSA}', "");
    Expect(0, 92874, '\P{^Is_Sc=_TNSA}', "");
    Error('\p{Script=/a/__toto}');
    Error('\P{Script=/a/__toto}');
    Expect(1, 123566, '\p{Script=:\AToto\z:}', "");;
    Expect(0, 123567, '\p{Script=:\AToto\z:}', "");;
    Expect(1, 123566, '\p{Script=toto}', "");
    Expect(0, 123566, '\p{^Script=toto}', "");
    Expect(0, 123566, '\P{Script=toto}', "");
    Expect(1, 123566, '\P{^Script=toto}', "");
    Expect(0, 123567, '\p{Script=toto}', "");
    Expect(1, 123567, '\p{^Script=toto}', "");
    Expect(1, 123567, '\P{Script=toto}', "");
    Expect(0, 123567, '\P{^Script=toto}', "");
    Expect(1, 123566, '\p{Script=:\Atoto\z:}', "");;
    Expect(0, 123567, '\p{Script=:\Atoto\z:}', "");;
    Expect(1, 123566, '\p{Script=__toto}', "");
    Expect(0, 123566, '\p{^Script=__toto}', "");
    Expect(0, 123566, '\P{Script=__toto}', "");
    Expect(1, 123566, '\P{^Script=__toto}', "");
    Expect(0, 123567, '\p{Script=__toto}', "");
    Expect(1, 123567, '\p{^Script=__toto}', "");
    Expect(1, 123567, '\P{Script=__toto}', "");
    Expect(0, 123567, '\P{^Script=__toto}', "");
    Error('\p{Sc= Toto/a/}');
    Error('\P{Sc= Toto/a/}');
    Expect(1, 123566, '\p{Sc=:\AToto\z:}', "");;
    Expect(0, 123567, '\p{Sc=:\AToto\z:}', "");;
    Expect(1, 123566, '\p{Sc=toto}', "");
    Expect(0, 123566, '\p{^Sc=toto}', "");
    Expect(0, 123566, '\P{Sc=toto}', "");
    Expect(1, 123566, '\P{^Sc=toto}', "");
    Expect(0, 123567, '\p{Sc=toto}', "");
    Expect(1, 123567, '\p{^Sc=toto}', "");
    Expect(1, 123567, '\P{Sc=toto}', "");
    Expect(0, 123567, '\P{^Sc=toto}', "");
    Expect(1, 123566, '\p{Sc=:\Atoto\z:}', "");;
    Expect(0, 123567, '\p{Sc=:\Atoto\z:}', "");;
    Expect(1, 123566, '\p{Sc=	-Toto}', "");
    Expect(0, 123566, '\p{^Sc=	-Toto}', "");
    Expect(0, 123566, '\P{Sc=	-Toto}', "");
    Expect(1, 123566, '\P{^Sc=	-Toto}', "");
    Expect(0, 123567, '\p{Sc=	-Toto}', "");
    Expect(1, 123567, '\p{^Sc=	-Toto}', "");
    Expect(1, 123567, '\P{Sc=	-Toto}', "");
    Expect(0, 123567, '\P{^Sc=	-Toto}', "");
    Error('\p{Is_Script=/a/	-Toto}');
    Error('\P{Is_Script=/a/	-Toto}');
    Expect(1, 123566, '\p{Is_Script=toto}', "");
    Expect(0, 123566, '\p{^Is_Script=toto}', "");
    Expect(0, 123566, '\P{Is_Script=toto}', "");
    Expect(1, 123566, '\P{^Is_Script=toto}', "");
    Expect(0, 123567, '\p{Is_Script=toto}', "");
    Expect(1, 123567, '\p{^Is_Script=toto}', "");
    Expect(1, 123567, '\P{Is_Script=toto}', "");
    Expect(0, 123567, '\P{^Is_Script=toto}', "");
    Expect(1, 123566, '\p{Is_Script= _Toto}', "");
    Expect(0, 123566, '\p{^Is_Script= _Toto}', "");
    Expect(0, 123566, '\P{Is_Script= _Toto}', "");
    Expect(1, 123566, '\P{^Is_Script= _Toto}', "");
    Expect(0, 123567, '\p{Is_Script= _Toto}', "");
    Expect(1, 123567, '\p{^Is_Script= _Toto}', "");
    Expect(1, 123567, '\P{Is_Script= _Toto}', "");
    Expect(0, 123567, '\P{^Is_Script= _Toto}', "");
    Error('\p{Is_Sc=_Toto:=}');
    Error('\P{Is_Sc=_Toto:=}');
    Expect(1, 123566, '\p{Is_Sc=toto}', "");
    Expect(0, 123566, '\p{^Is_Sc=toto}', "");
    Expect(0, 123566, '\P{Is_Sc=toto}', "");
    Expect(1, 123566, '\P{^Is_Sc=toto}', "");
    Expect(0, 123567, '\p{Is_Sc=toto}', "");
    Expect(1, 123567, '\p{^Is_Sc=toto}', "");
    Expect(1, 123567, '\P{Is_Sc=toto}', "");
    Expect(0, 123567, '\P{^Is_Sc=toto}', "");
    Expect(1, 123566, '\p{Is_Sc=	 Toto}', "");
    Expect(0, 123566, '\p{^Is_Sc=	 Toto}', "");
    Expect(0, 123566, '\P{Is_Sc=	 Toto}', "");
    Expect(1, 123566, '\P{^Is_Sc=	 Toto}', "");
    Expect(0, 123567, '\p{Is_Sc=	 Toto}', "");
    Expect(1, 123567, '\p{^Is_Sc=	 Toto}', "");
    Expect(1, 123567, '\P{Is_Sc=	 Toto}', "");
    Expect(0, 123567, '\P{^Is_Sc=	 Toto}', "");
    Error('\p{Script=/a/Ugaritic}');
    Error('\P{Script=/a/Ugaritic}');
    Expect(1, 66463, '\p{Script=:\AUgaritic\z:}', "");;
    Expect(0, 66464, '\p{Script=:\AUgaritic\z:}', "");;
    Expect(1, 66463, '\p{Script=ugaritic}', "");
    Expect(0, 66463, '\p{^Script=ugaritic}', "");
    Expect(0, 66463, '\P{Script=ugaritic}', "");
    Expect(1, 66463, '\P{^Script=ugaritic}', "");
    Expect(0, 66464, '\p{Script=ugaritic}', "");
    Expect(1, 66464, '\p{^Script=ugaritic}', "");
    Expect(1, 66464, '\P{Script=ugaritic}', "");
    Expect(0, 66464, '\P{^Script=ugaritic}', "");
    Expect(1, 66463, '\p{Script=:\Augaritic\z:}', "");;
    Expect(0, 66464, '\p{Script=:\Augaritic\z:}', "");;
    Expect(1, 66463, '\p{Script=	-UGARITIC}', "");
    Expect(0, 66463, '\p{^Script=	-UGARITIC}', "");
    Expect(0, 66463, '\P{Script=	-UGARITIC}', "");
    Expect(1, 66463, '\P{^Script=	-UGARITIC}', "");
    Expect(0, 66464, '\p{Script=	-UGARITIC}', "");
    Expect(1, 66464, '\p{^Script=	-UGARITIC}', "");
    Expect(1, 66464, '\P{Script=	-UGARITIC}', "");
    Expect(0, 66464, '\P{^Script=	-UGARITIC}', "");
    Error('\p{Sc= -Ugar/a/}');
    Error('\P{Sc= -Ugar/a/}');
    Expect(1, 66463, '\p{Sc=:\AUgar\z:}', "");;
    Expect(0, 66464, '\p{Sc=:\AUgar\z:}', "");;
    Expect(1, 66463, '\p{Sc=ugar}', "");
    Expect(0, 66463, '\p{^Sc=ugar}', "");
    Expect(0, 66463, '\P{Sc=ugar}', "");
    Expect(1, 66463, '\P{^Sc=ugar}', "");
    Expect(0, 66464, '\p{Sc=ugar}', "");
    Expect(1, 66464, '\p{^Sc=ugar}', "");
    Expect(1, 66464, '\P{Sc=ugar}', "");
    Expect(0, 66464, '\P{^Sc=ugar}', "");
    Expect(1, 66463, '\p{Sc=:\Augar\z:}', "");;
    Expect(0, 66464, '\p{Sc=:\Augar\z:}', "");;
    Expect(1, 66463, '\p{Sc= Ugar}', "");
    Expect(0, 66463, '\p{^Sc= Ugar}', "");
    Expect(0, 66463, '\P{Sc= Ugar}', "");
    Expect(1, 66463, '\P{^Sc= Ugar}', "");
    Expect(0, 66464, '\p{Sc= Ugar}', "");
    Expect(1, 66464, '\p{^Sc= Ugar}', "");
    Expect(1, 66464, '\P{Sc= Ugar}', "");
    Expect(0, 66464, '\P{^Sc= Ugar}', "");
    Error('\p{Is_Script=/a/-Ugaritic}');
    Error('\P{Is_Script=/a/-Ugaritic}');
    Expect(1, 66463, '\p{Is_Script=ugaritic}', "");
    Expect(0, 66463, '\p{^Is_Script=ugaritic}', "");
    Expect(0, 66463, '\P{Is_Script=ugaritic}', "");
    Expect(1, 66463, '\P{^Is_Script=ugaritic}', "");
    Expect(0, 66464, '\p{Is_Script=ugaritic}', "");
    Expect(1, 66464, '\p{^Is_Script=ugaritic}', "");
    Expect(1, 66464, '\P{Is_Script=ugaritic}', "");
    Expect(0, 66464, '\P{^Is_Script=ugaritic}', "");
    Expect(1, 66463, '\p{Is_Script=_ Ugaritic}', "");
    Expect(0, 66463, '\p{^Is_Script=_ Ugaritic}', "");
    Expect(0, 66463, '\P{Is_Script=_ Ugaritic}', "");
    Expect(1, 66463, '\P{^Is_Script=_ Ugaritic}', "");
    Expect(0, 66464, '\p{Is_Script=_ Ugaritic}', "");
    Expect(1, 66464, '\p{^Is_Script=_ Ugaritic}', "");
    Expect(1, 66464, '\P{Is_Script=_ Ugaritic}', "");
    Expect(0, 66464, '\P{^Is_Script=_ Ugaritic}', "");
    Error('\p{Is_Sc=/a/_	Ugar}');
    Error('\P{Is_Sc=/a/_	Ugar}');
    Expect(1, 66463, '\p{Is_Sc=ugar}', "");
    Expect(0, 66463, '\p{^Is_Sc=ugar}', "");
    Expect(0, 66463, '\P{Is_Sc=ugar}', "");
    Expect(1, 66463, '\P{^Is_Sc=ugar}', "");
    Expect(0, 66464, '\p{Is_Sc=ugar}', "");
    Expect(1, 66464, '\p{^Is_Sc=ugar}', "");
    Expect(1, 66464, '\P{Is_Sc=ugar}', "");
    Expect(0, 66464, '\P{^Is_Sc=ugar}', "");
    Expect(1, 66463, '\p{Is_Sc= -UGAR}', "");
    Expect(0, 66463, '\p{^Is_Sc= -UGAR}', "");
    Expect(0, 66463, '\P{Is_Sc= -UGAR}', "");
    Expect(1, 66463, '\P{^Is_Sc= -UGAR}', "");
    Expect(0, 66464, '\p{Is_Sc= -UGAR}', "");
    Expect(1, 66464, '\p{^Is_Sc= -UGAR}', "");
    Expect(1, 66464, '\P{Is_Sc= -UGAR}', "");
    Expect(0, 66464, '\P{^Is_Sc= -UGAR}', "");
    Error('\p{Script=_-Vai/a/}');
    Error('\P{Script=_-Vai/a/}');
    Expect(1, 42539, '\p{Script=:\AVai\z:}', "");;
    Expect(0, 42540, '\p{Script=:\AVai\z:}', "");;
    Expect(1, 42539, '\p{Script=vai}', "");
    Expect(0, 42539, '\p{^Script=vai}', "");
    Expect(0, 42539, '\P{Script=vai}', "");
    Expect(1, 42539, '\P{^Script=vai}', "");
    Expect(0, 42540, '\p{Script=vai}', "");
    Expect(1, 42540, '\p{^Script=vai}', "");
    Expect(1, 42540, '\P{Script=vai}', "");
    Expect(0, 42540, '\P{^Script=vai}', "");
    Expect(1, 42539, '\p{Script=:\Avai\z:}', "");;
    Expect(0, 42540, '\p{Script=:\Avai\z:}', "");;
    Expect(1, 42539, '\p{Script= -Vai}', "");
    Expect(0, 42539, '\p{^Script= -Vai}', "");
    Expect(0, 42539, '\P{Script= -Vai}', "");
    Expect(1, 42539, '\P{^Script= -Vai}', "");
    Expect(0, 42540, '\p{Script= -Vai}', "");
    Expect(1, 42540, '\p{^Script= -Vai}', "");
    Expect(1, 42540, '\P{Script= -Vai}', "");
    Expect(0, 42540, '\P{^Script= -Vai}', "");
    Error('\p{Sc=:= -Vaii}');
    Error('\P{Sc=:= -Vaii}');
    Expect(1, 42539, '\p{Sc=:\AVaii\z:}', "");;
    Expect(0, 42540, '\p{Sc=:\AVaii\z:}', "");;
    Expect(1, 42539, '\p{Sc=vaii}', "");
    Expect(0, 42539, '\p{^Sc=vaii}', "");
    Expect(0, 42539, '\P{Sc=vaii}', "");
    Expect(1, 42539, '\P{^Sc=vaii}', "");
    Expect(0, 42540, '\p{Sc=vaii}', "");
    Expect(1, 42540, '\p{^Sc=vaii}', "");
    Expect(1, 42540, '\P{Sc=vaii}', "");
    Expect(0, 42540, '\P{^Sc=vaii}', "");
    Expect(1, 42539, '\p{Sc=:\Avaii\z:}', "");;
    Expect(0, 42540, '\p{Sc=:\Avaii\z:}', "");;
    Expect(1, 42539, '\p{Sc: _ VAII}', "");
    Expect(0, 42539, '\p{^Sc: _ VAII}', "");
    Expect(0, 42539, '\P{Sc: _ VAII}', "");
    Expect(1, 42539, '\P{^Sc: _ VAII}', "");
    Expect(0, 42540, '\p{Sc: _ VAII}', "");
    Expect(1, 42540, '\p{^Sc: _ VAII}', "");
    Expect(1, 42540, '\P{Sc: _ VAII}', "");
    Expect(0, 42540, '\P{^Sc: _ VAII}', "");
    Error('\p{Is_Script=/a/Vai}');
    Error('\P{Is_Script=/a/Vai}');
    Expect(1, 42539, '\p{Is_Script=vai}', "");
    Expect(0, 42539, '\p{^Is_Script=vai}', "");
    Expect(0, 42539, '\P{Is_Script=vai}', "");
    Expect(1, 42539, '\P{^Is_Script=vai}', "");
    Expect(0, 42540, '\p{Is_Script=vai}', "");
    Expect(1, 42540, '\p{^Is_Script=vai}', "");
    Expect(1, 42540, '\P{Is_Script=vai}', "");
    Expect(0, 42540, '\P{^Is_Script=vai}', "");
    Expect(1, 42539, '\p{Is_Script=- Vai}', "");
    Expect(0, 42539, '\p{^Is_Script=- Vai}', "");
    Expect(0, 42539, '\P{Is_Script=- Vai}', "");
    Expect(1, 42539, '\P{^Is_Script=- Vai}', "");
    Expect(0, 42540, '\p{Is_Script=- Vai}', "");
    Expect(1, 42540, '\p{^Is_Script=- Vai}', "");
    Expect(1, 42540, '\P{Is_Script=- Vai}', "");
    Expect(0, 42540, '\P{^Is_Script=- Vai}', "");
    Error('\p{Is_Sc=_	VAII:=}');
    Error('\P{Is_Sc=_	VAII:=}');
    Expect(1, 42539, '\p{Is_Sc=vaii}', "");
    Expect(0, 42539, '\p{^Is_Sc=vaii}', "");
    Expect(0, 42539, '\P{Is_Sc=vaii}', "");
    Expect(1, 42539, '\P{^Is_Sc=vaii}', "");
    Expect(0, 42540, '\p{Is_Sc=vaii}', "");
    Expect(1, 42540, '\p{^Is_Sc=vaii}', "");
    Expect(1, 42540, '\P{Is_Sc=vaii}', "");
    Expect(0, 42540, '\P{^Is_Sc=vaii}', "");
    Expect(1, 42539, '\p{Is_Sc= vaii}', "");
    Expect(0, 42539, '\p{^Is_Sc= vaii}', "");
    Expect(0, 42539, '\P{Is_Sc= vaii}', "");
    Expect(1, 42539, '\P{^Is_Sc= vaii}', "");
    Expect(0, 42540, '\p{Is_Sc= vaii}', "");
    Expect(1, 42540, '\p{^Is_Sc= vaii}', "");
    Expect(1, 42540, '\P{Is_Sc= vaii}', "");
    Expect(0, 42540, '\P{^Is_Sc= vaii}', "");
    Error('\p{Script=_:=VITHKUQI}');
    Error('\P{Script=_:=VITHKUQI}');
    Expect(1, 67004, '\p{Script=:\AVithkuqi\z:}', "");;
    Expect(0, 67005, '\p{Script=:\AVithkuqi\z:}', "");;
    Expect(1, 67004, '\p{Script=vithkuqi}', "");
    Expect(0, 67004, '\p{^Script=vithkuqi}', "");
    Expect(0, 67004, '\P{Script=vithkuqi}', "");
    Expect(1, 67004, '\P{^Script=vithkuqi}', "");
    Expect(0, 67005, '\p{Script=vithkuqi}', "");
    Expect(1, 67005, '\p{^Script=vithkuqi}', "");
    Expect(1, 67005, '\P{Script=vithkuqi}', "");
    Expect(0, 67005, '\P{^Script=vithkuqi}', "");
    Expect(1, 67004, '\p{Script=:\Avithkuqi\z:}', "");;
    Expect(0, 67005, '\p{Script=:\Avithkuqi\z:}', "");;
    Expect(1, 67004, '\p{Script=	 Vithkuqi}', "");
    Expect(0, 67004, '\p{^Script=	 Vithkuqi}', "");
    Expect(0, 67004, '\P{Script=	 Vithkuqi}', "");
    Expect(1, 67004, '\P{^Script=	 Vithkuqi}', "");
    Expect(0, 67005, '\p{Script=	 Vithkuqi}', "");
    Expect(1, 67005, '\p{^Script=	 Vithkuqi}', "");
    Expect(1, 67005, '\P{Script=	 Vithkuqi}', "");
    Expect(0, 67005, '\P{^Script=	 Vithkuqi}', "");
    Error('\p{Sc=/a/Vith}');
    Error('\P{Sc=/a/Vith}');
    Expect(1, 67004, '\p{Sc=:\AVith\z:}', "");;
    Expect(0, 67005, '\p{Sc=:\AVith\z:}', "");;
    Expect(1, 67004, '\p{Sc=vith}', "");
    Expect(0, 67004, '\p{^Sc=vith}', "");
    Expect(0, 67004, '\P{Sc=vith}', "");
    Expect(1, 67004, '\P{^Sc=vith}', "");
    Expect(0, 67005, '\p{Sc=vith}', "");
    Expect(1, 67005, '\p{^Sc=vith}', "");
    Expect(1, 67005, '\P{Sc=vith}', "");
    Expect(0, 67005, '\P{^Sc=vith}', "");
    Expect(1, 67004, '\p{Sc=:\Avith\z:}', "");;
    Expect(0, 67005, '\p{Sc=:\Avith\z:}', "");;
    Expect(1, 67004, '\p{Sc=- Vith}', "");
    Expect(0, 67004, '\p{^Sc=- Vith}', "");
    Expect(0, 67004, '\P{Sc=- Vith}', "");
    Expect(1, 67004, '\P{^Sc=- Vith}', "");
    Expect(0, 67005, '\p{Sc=- Vith}', "");
    Expect(1, 67005, '\p{^Sc=- Vith}', "");
    Expect(1, 67005, '\P{Sc=- Vith}', "");
    Expect(0, 67005, '\P{^Sc=- Vith}', "");
    Error('\p{Is_Script=:=__Vithkuqi}');
    Error('\P{Is_Script=:=__Vithkuqi}');
    Expect(1, 67004, '\p{Is_Script=vithkuqi}', "");
    Expect(0, 67004, '\p{^Is_Script=vithkuqi}', "");
    Expect(0, 67004, '\P{Is_Script=vithkuqi}', "");
    Expect(1, 67004, '\P{^Is_Script=vithkuqi}', "");
    Expect(0, 67005, '\p{Is_Script=vithkuqi}', "");
    Expect(1, 67005, '\p{^Is_Script=vithkuqi}', "");
    Expect(1, 67005, '\P{Is_Script=vithkuqi}', "");
    Expect(0, 67005, '\P{^Is_Script=vithkuqi}', "");
    Expect(1, 67004, '\p{Is_Script=-Vithkuqi}', "");
    Expect(0, 67004, '\p{^Is_Script=-Vithkuqi}', "");
    Expect(0, 67004, '\P{Is_Script=-Vithkuqi}', "");
    Expect(1, 67004, '\P{^Is_Script=-Vithkuqi}', "");
    Expect(0, 67005, '\p{Is_Script=-Vithkuqi}', "");
    Expect(1, 67005, '\p{^Is_Script=-Vithkuqi}', "");
    Expect(1, 67005, '\P{Is_Script=-Vithkuqi}', "");
    Expect(0, 67005, '\P{^Is_Script=-Vithkuqi}', "");
    Error('\p{Is_Sc=:=_VITH}');
    Error('\P{Is_Sc=:=_VITH}');
    Expect(1, 67004, '\p{Is_Sc:vith}', "");
    Expect(0, 67004, '\p{^Is_Sc:vith}', "");
    Expect(0, 67004, '\P{Is_Sc:vith}', "");
    Expect(1, 67004, '\P{^Is_Sc:vith}', "");
    Expect(0, 67005, '\p{Is_Sc:vith}', "");
    Expect(1, 67005, '\p{^Is_Sc:vith}', "");
    Expect(1, 67005, '\P{Is_Sc:vith}', "");
    Expect(0, 67005, '\P{^Is_Sc:vith}', "");
    Expect(1, 67004, '\p{Is_Sc= vith}', "");
    Expect(0, 67004, '\p{^Is_Sc= vith}', "");
    Expect(0, 67004, '\P{Is_Sc= vith}', "");
    Expect(1, 67004, '\P{^Is_Sc= vith}', "");
    Expect(0, 67005, '\p{Is_Sc= vith}', "");
    Expect(1, 67005, '\p{^Is_Sc= vith}', "");
    Expect(1, 67005, '\P{Is_Sc= vith}', "");
    Expect(0, 67005, '\P{^Is_Sc= vith}', "");
    Error('\p{Script=	WARANG_citi/a/}');
    Error('\P{Script=	WARANG_citi/a/}');
    Expect(1, 71935, '\p{Script=:\AWarang_Citi\z:}', "");;
    Expect(0, 71936, '\p{Script=:\AWarang_Citi\z:}', "");;
    Expect(1, 71935, '\p{Script=warangciti}', "");
    Expect(0, 71935, '\p{^Script=warangciti}', "");
    Expect(0, 71935, '\P{Script=warangciti}', "");
    Expect(1, 71935, '\P{^Script=warangciti}', "");
    Expect(0, 71936, '\p{Script=warangciti}', "");
    Expect(1, 71936, '\p{^Script=warangciti}', "");
    Expect(1, 71936, '\P{Script=warangciti}', "");
    Expect(0, 71936, '\P{^Script=warangciti}', "");
    Expect(1, 71935, '\p{Script=:\Awarangciti\z:}', "");;
    Expect(0, 71936, '\p{Script=:\Awarangciti\z:}', "");;
    Expect(1, 71935, '\p{Script=-WARANG_citi}', "");
    Expect(0, 71935, '\p{^Script=-WARANG_citi}', "");
    Expect(0, 71935, '\P{Script=-WARANG_citi}', "");
    Expect(1, 71935, '\P{^Script=-WARANG_citi}', "");
    Expect(0, 71936, '\p{Script=-WARANG_citi}', "");
    Expect(1, 71936, '\p{^Script=-WARANG_citi}', "");
    Expect(1, 71936, '\P{Script=-WARANG_citi}', "");
    Expect(0, 71936, '\P{^Script=-WARANG_citi}', "");
    Error('\p{Sc=-:=wara}');
    Error('\P{Sc=-:=wara}');
    Expect(1, 71935, '\p{Sc=:\AWara\z:}', "");;
    Expect(0, 71936, '\p{Sc=:\AWara\z:}', "");;
    Expect(1, 71935, '\p{Sc=wara}', "");
    Expect(0, 71935, '\p{^Sc=wara}', "");
    Expect(0, 71935, '\P{Sc=wara}', "");
    Expect(1, 71935, '\P{^Sc=wara}', "");
    Expect(0, 71936, '\p{Sc=wara}', "");
    Expect(1, 71936, '\p{^Sc=wara}', "");
    Expect(1, 71936, '\P{Sc=wara}', "");
    Expect(0, 71936, '\P{^Sc=wara}', "");
    Expect(1, 71935, '\p{Sc=:\Awara\z:}', "");;
    Expect(0, 71936, '\p{Sc=:\Awara\z:}', "");;
    Expect(1, 71935, '\p{Sc=_ Wara}', "");
    Expect(0, 71935, '\p{^Sc=_ Wara}', "");
    Expect(0, 71935, '\P{Sc=_ Wara}', "");
    Expect(1, 71935, '\P{^Sc=_ Wara}', "");
    Expect(0, 71936, '\p{Sc=_ Wara}', "");
    Expect(1, 71936, '\p{^Sc=_ Wara}', "");
    Expect(1, 71936, '\P{Sc=_ Wara}', "");
    Expect(0, 71936, '\P{^Sc=_ Wara}', "");
    Error('\p{Is_Script=_WARANG_citi/a/}');
    Error('\P{Is_Script=_WARANG_citi/a/}');
    Expect(1, 71935, '\p{Is_Script=warangciti}', "");
    Expect(0, 71935, '\p{^Is_Script=warangciti}', "");
    Expect(0, 71935, '\P{Is_Script=warangciti}', "");
    Expect(1, 71935, '\P{^Is_Script=warangciti}', "");
    Expect(0, 71936, '\p{Is_Script=warangciti}', "");
    Expect(1, 71936, '\p{^Is_Script=warangciti}', "");
    Expect(1, 71936, '\P{Is_Script=warangciti}', "");
    Expect(0, 71936, '\P{^Is_Script=warangciti}', "");
    Expect(1, 71935, '\p{Is_Script= 	Warang_citi}', "");
    Expect(0, 71935, '\p{^Is_Script= 	Warang_citi}', "");
    Expect(0, 71935, '\P{Is_Script= 	Warang_citi}', "");
    Expect(1, 71935, '\P{^Is_Script= 	Warang_citi}', "");
    Expect(0, 71936, '\p{Is_Script= 	Warang_citi}', "");
    Expect(1, 71936, '\p{^Is_Script= 	Warang_citi}', "");
    Expect(1, 71936, '\P{Is_Script= 	Warang_citi}', "");
    Expect(0, 71936, '\P{^Is_Script= 	Warang_citi}', "");
    Error('\p{Is_Sc= /a/Wara}');
    Error('\P{Is_Sc= /a/Wara}');
    Expect(1, 71935, '\p{Is_Sc=wara}', "");
    Expect(0, 71935, '\p{^Is_Sc=wara}', "");
    Expect(0, 71935, '\P{Is_Sc=wara}', "");
    Expect(1, 71935, '\P{^Is_Sc=wara}', "");
    Expect(0, 71936, '\p{Is_Sc=wara}', "");
    Expect(1, 71936, '\p{^Is_Sc=wara}', "");
    Expect(1, 71936, '\P{Is_Sc=wara}', "");
    Expect(0, 71936, '\P{^Is_Sc=wara}', "");
    Expect(1, 71935, '\p{Is_Sc=-_Wara}', "");
    Expect(0, 71935, '\p{^Is_Sc=-_Wara}', "");
    Expect(0, 71935, '\P{Is_Sc=-_Wara}', "");
    Expect(1, 71935, '\P{^Is_Sc=-_Wara}', "");
    Expect(0, 71936, '\p{Is_Sc=-_Wara}', "");
    Expect(1, 71936, '\p{^Is_Sc=-_Wara}', "");
    Expect(1, 71936, '\P{Is_Sc=-_Wara}', "");
    Expect(0, 71936, '\P{^Is_Sc=-_Wara}', "");
    Error('\p{Script=/a/ 	wancho}');
    Error('\P{Script=/a/ 	wancho}');
    Expect(1, 123647, '\p{Script=:\AWancho\z:}', "");;
    Expect(0, 123648, '\p{Script=:\AWancho\z:}', "");;
    Expect(1, 123647, '\p{Script=wancho}', "");
    Expect(0, 123647, '\p{^Script=wancho}', "");
    Expect(0, 123647, '\P{Script=wancho}', "");
    Expect(1, 123647, '\P{^Script=wancho}', "");
    Expect(0, 123648, '\p{Script=wancho}', "");
    Expect(1, 123648, '\p{^Script=wancho}', "");
    Expect(1, 123648, '\P{Script=wancho}', "");
    Expect(0, 123648, '\P{^Script=wancho}', "");
    Expect(1, 123647, '\p{Script=:\Awancho\z:}', "");;
    Expect(0, 123648, '\p{Script=:\Awancho\z:}', "");;
    Expect(1, 123647, '\p{Script=  Wancho}', "");
    Expect(0, 123647, '\p{^Script=  Wancho}', "");
    Expect(0, 123647, '\P{Script=  Wancho}', "");
    Expect(1, 123647, '\P{^Script=  Wancho}', "");
    Expect(0, 123648, '\p{Script=  Wancho}', "");
    Expect(1, 123648, '\p{^Script=  Wancho}', "");
    Expect(1, 123648, '\P{Script=  Wancho}', "");
    Expect(0, 123648, '\P{^Script=  Wancho}', "");
    Error('\p{Sc=	Wcho:=}');
    Error('\P{Sc=	Wcho:=}');
    Expect(1, 123647, '\p{Sc=:\AWcho\z:}', "");;
    Expect(0, 123648, '\p{Sc=:\AWcho\z:}', "");;
    Expect(1, 123647, '\p{Sc: wcho}', "");
    Expect(0, 123647, '\p{^Sc: wcho}', "");
    Expect(0, 123647, '\P{Sc: wcho}', "");
    Expect(1, 123647, '\P{^Sc: wcho}', "");
    Expect(0, 123648, '\p{Sc: wcho}', "");
    Expect(1, 123648, '\p{^Sc: wcho}', "");
    Expect(1, 123648, '\P{Sc: wcho}', "");
    Expect(0, 123648, '\P{^Sc: wcho}', "");
    Expect(1, 123647, '\p{Sc=:\Awcho\z:}', "");;
    Expect(0, 123648, '\p{Sc=:\Awcho\z:}', "");;
    Expect(1, 123647, '\p{Sc=Wcho}', "");
    Expect(0, 123647, '\p{^Sc=Wcho}', "");
    Expect(0, 123647, '\P{Sc=Wcho}', "");
    Expect(1, 123647, '\P{^Sc=Wcho}', "");
    Expect(0, 123648, '\p{Sc=Wcho}', "");
    Expect(1, 123648, '\p{^Sc=Wcho}', "");
    Expect(1, 123648, '\P{Sc=Wcho}', "");
    Expect(0, 123648, '\P{^Sc=Wcho}', "");
    Error('\p{Is_Script=	/a/Wancho}');
    Error('\P{Is_Script=	/a/Wancho}');
    Expect(1, 123647, '\p{Is_Script:wancho}', "");
    Expect(0, 123647, '\p{^Is_Script:wancho}', "");
    Expect(0, 123647, '\P{Is_Script:wancho}', "");
    Expect(1, 123647, '\P{^Is_Script:wancho}', "");
    Expect(0, 123648, '\p{Is_Script:wancho}', "");
    Expect(1, 123648, '\p{^Is_Script:wancho}', "");
    Expect(1, 123648, '\P{Is_Script:wancho}', "");
    Expect(0, 123648, '\P{^Is_Script:wancho}', "");
    Expect(1, 123647, '\p{Is_Script=	-WANCHO}', "");
    Expect(0, 123647, '\p{^Is_Script=	-WANCHO}', "");
    Expect(0, 123647, '\P{Is_Script=	-WANCHO}', "");
    Expect(1, 123647, '\P{^Is_Script=	-WANCHO}', "");
    Expect(0, 123648, '\p{Is_Script=	-WANCHO}', "");
    Expect(1, 123648, '\p{^Is_Script=	-WANCHO}', "");
    Expect(1, 123648, '\P{Is_Script=	-WANCHO}', "");
    Expect(0, 123648, '\P{^Is_Script=	-WANCHO}', "");
    Error('\p{Is_Sc= /a/wcho}');
    Error('\P{Is_Sc= /a/wcho}');
    Expect(1, 123647, '\p{Is_Sc=wcho}', "");
    Expect(0, 123647, '\p{^Is_Sc=wcho}', "");
    Expect(0, 123647, '\P{Is_Sc=wcho}', "");
    Expect(1, 123647, '\P{^Is_Sc=wcho}', "");
    Expect(0, 123648, '\p{Is_Sc=wcho}', "");
    Expect(1, 123648, '\p{^Is_Sc=wcho}', "");
    Expect(1, 123648, '\P{Is_Sc=wcho}', "");
    Expect(0, 123648, '\P{^Is_Sc=wcho}', "");
    Expect(1, 123647, '\p{Is_Sc=-WCHO}', "");
    Expect(0, 123647, '\p{^Is_Sc=-WCHO}', "");
    Expect(0, 123647, '\P{Is_Sc=-WCHO}', "");
    Expect(1, 123647, '\P{^Is_Sc=-WCHO}', "");
    Expect(0, 123648, '\p{Is_Sc=-WCHO}', "");
    Expect(1, 123648, '\p{^Is_Sc=-WCHO}', "");
    Expect(1, 123648, '\P{Is_Sc=-WCHO}', "");
    Expect(0, 123648, '\P{^Is_Sc=-WCHO}', "");
    Error('\p{Script=_OLD_PERSIAN:=}');
    Error('\P{Script=_OLD_PERSIAN:=}');
    Expect(1, 66517, '\p{Script=:\AOld_Persian\z:}', "");;
    Expect(0, 66518, '\p{Script=:\AOld_Persian\z:}', "");;
    Expect(1, 66517, '\p{Script=oldpersian}', "");
    Expect(0, 66517, '\p{^Script=oldpersian}', "");
    Expect(0, 66517, '\P{Script=oldpersian}', "");
    Expect(1, 66517, '\P{^Script=oldpersian}', "");
    Expect(0, 66518, '\p{Script=oldpersian}', "");
    Expect(1, 66518, '\p{^Script=oldpersian}', "");
    Expect(1, 66518, '\P{Script=oldpersian}', "");
    Expect(0, 66518, '\P{^Script=oldpersian}', "");
    Expect(1, 66517, '\p{Script=:\Aoldpersian\z:}', "");;
    Expect(0, 66518, '\p{Script=:\Aoldpersian\z:}', "");;
    Expect(1, 66517, '\p{Script=_Old_Persian}', "");
    Expect(0, 66517, '\p{^Script=_Old_Persian}', "");
    Expect(0, 66517, '\P{Script=_Old_Persian}', "");
    Expect(1, 66517, '\P{^Script=_Old_Persian}', "");
    Expect(0, 66518, '\p{Script=_Old_Persian}', "");
    Expect(1, 66518, '\p{^Script=_Old_Persian}', "");
    Expect(1, 66518, '\P{Script=_Old_Persian}', "");
    Expect(0, 66518, '\P{^Script=_Old_Persian}', "");
    Error('\p{Sc=_Xpeo/a/}');
    Error('\P{Sc=_Xpeo/a/}');
    Expect(1, 66517, '\p{Sc=:\AXpeo\z:}', "");;
    Expect(0, 66518, '\p{Sc=:\AXpeo\z:}', "");;
    Expect(1, 66517, '\p{Sc=xpeo}', "");
    Expect(0, 66517, '\p{^Sc=xpeo}', "");
    Expect(0, 66517, '\P{Sc=xpeo}', "");
    Expect(1, 66517, '\P{^Sc=xpeo}', "");
    Expect(0, 66518, '\p{Sc=xpeo}', "");
    Expect(1, 66518, '\p{^Sc=xpeo}', "");
    Expect(1, 66518, '\P{Sc=xpeo}', "");
    Expect(0, 66518, '\P{^Sc=xpeo}', "");
    Expect(1, 66517, '\p{Sc=:\Axpeo\z:}', "");;
    Expect(0, 66518, '\p{Sc=:\Axpeo\z:}', "");;
    Expect(1, 66517, '\p{Sc=-	xpeo}', "");
    Expect(0, 66517, '\p{^Sc=-	xpeo}', "");
    Expect(0, 66517, '\P{Sc=-	xpeo}', "");
    Expect(1, 66517, '\P{^Sc=-	xpeo}', "");
    Expect(0, 66518, '\p{Sc=-	xpeo}', "");
    Expect(1, 66518, '\p{^Sc=-	xpeo}', "");
    Expect(1, 66518, '\P{Sc=-	xpeo}', "");
    Expect(0, 66518, '\P{^Sc=-	xpeo}', "");
    Error('\p{Is_Script= OLD_PERSIAN/a/}');
    Error('\P{Is_Script= OLD_PERSIAN/a/}');
    Expect(1, 66517, '\p{Is_Script:	oldpersian}', "");
    Expect(0, 66517, '\p{^Is_Script:	oldpersian}', "");
    Expect(0, 66517, '\P{Is_Script:	oldpersian}', "");
    Expect(1, 66517, '\P{^Is_Script:	oldpersian}', "");
    Expect(0, 66518, '\p{Is_Script:	oldpersian}', "");
    Expect(1, 66518, '\p{^Is_Script:	oldpersian}', "");
    Expect(1, 66518, '\P{Is_Script:	oldpersian}', "");
    Expect(0, 66518, '\P{^Is_Script:	oldpersian}', "");
    Expect(1, 66517, '\p{Is_Script= _Old_Persian}', "");
    Expect(0, 66517, '\p{^Is_Script= _Old_Persian}', "");
    Expect(0, 66517, '\P{Is_Script= _Old_Persian}', "");
    Expect(1, 66517, '\P{^Is_Script= _Old_Persian}', "");
    Expect(0, 66518, '\p{Is_Script= _Old_Persian}', "");
    Expect(1, 66518, '\p{^Is_Script= _Old_Persian}', "");
    Expect(1, 66518, '\P{Is_Script= _Old_Persian}', "");
    Expect(0, 66518, '\P{^Is_Script= _Old_Persian}', "");
    Error('\p{Is_Sc= /a/XPEO}');
    Error('\P{Is_Sc= /a/XPEO}');
    Expect(1, 66517, '\p{Is_Sc=xpeo}', "");
    Expect(0, 66517, '\p{^Is_Sc=xpeo}', "");
    Expect(0, 66517, '\P{Is_Sc=xpeo}', "");
    Expect(1, 66517, '\P{^Is_Sc=xpeo}', "");
    Expect(0, 66518, '\p{Is_Sc=xpeo}', "");
    Expect(1, 66518, '\p{^Is_Sc=xpeo}', "");
    Expect(1, 66518, '\P{Is_Sc=xpeo}', "");
    Expect(0, 66518, '\P{^Is_Sc=xpeo}', "");
    Expect(1, 66517, '\p{Is_Sc=  Xpeo}', "");
    Expect(0, 66517, '\p{^Is_Sc=  Xpeo}', "");
    Expect(0, 66517, '\P{Is_Sc=  Xpeo}', "");
    Expect(1, 66517, '\P{^Is_Sc=  Xpeo}', "");
    Expect(0, 66518, '\p{Is_Sc=  Xpeo}', "");
    Expect(1, 66518, '\p{^Is_Sc=  Xpeo}', "");
    Expect(1, 66518, '\P{Is_Sc=  Xpeo}', "");
    Expect(0, 66518, '\P{^Is_Sc=  Xpeo}', "");
    Error('\p{Script=/a/- Cuneiform}');
    Error('\P{Script=/a/- Cuneiform}');
    Expect(1, 75075, '\p{Script=:\ACuneiform\z:}', "");;
    Expect(0, 75076, '\p{Script=:\ACuneiform\z:}', "");;
    Expect(1, 75075, '\p{Script=cuneiform}', "");
    Expect(0, 75075, '\p{^Script=cuneiform}', "");
    Expect(0, 75075, '\P{Script=cuneiform}', "");
    Expect(1, 75075, '\P{^Script=cuneiform}', "");
    Expect(0, 75076, '\p{Script=cuneiform}', "");
    Expect(1, 75076, '\p{^Script=cuneiform}', "");
    Expect(1, 75076, '\P{Script=cuneiform}', "");
    Expect(0, 75076, '\P{^Script=cuneiform}', "");
    Expect(1, 75075, '\p{Script=:\Acuneiform\z:}', "");;
    Expect(0, 75076, '\p{Script=:\Acuneiform\z:}', "");;
    Expect(1, 75075, '\p{Script:-	Cuneiform}', "");
    Expect(0, 75075, '\p{^Script:-	Cuneiform}', "");
    Expect(0, 75075, '\P{Script:-	Cuneiform}', "");
    Expect(1, 75075, '\P{^Script:-	Cuneiform}', "");
    Expect(0, 75076, '\p{Script:-	Cuneiform}', "");
    Expect(1, 75076, '\p{^Script:-	Cuneiform}', "");
    Expect(1, 75076, '\P{Script:-	Cuneiform}', "");
    Expect(0, 75076, '\P{^Script:-	Cuneiform}', "");
    Error('\p{Sc=/a/--xsux}');
    Error('\P{Sc=/a/--xsux}');
    Expect(1, 75075, '\p{Sc=:\AXsux\z:}', "");;
    Expect(0, 75076, '\p{Sc=:\AXsux\z:}', "");;
    Expect(1, 75075, '\p{Sc=xsux}', "");
    Expect(0, 75075, '\p{^Sc=xsux}', "");
    Expect(0, 75075, '\P{Sc=xsux}', "");
    Expect(1, 75075, '\P{^Sc=xsux}', "");
    Expect(0, 75076, '\p{Sc=xsux}', "");
    Expect(1, 75076, '\p{^Sc=xsux}', "");
    Expect(1, 75076, '\P{Sc=xsux}', "");
    Expect(0, 75076, '\P{^Sc=xsux}', "");
    Expect(1, 75075, '\p{Sc=:\Axsux\z:}', "");;
    Expect(0, 75076, '\p{Sc=:\Axsux\z:}', "");;
    Expect(1, 75075, '\p{Sc=-_xsux}', "");
    Expect(0, 75075, '\p{^Sc=-_xsux}', "");
    Expect(0, 75075, '\P{Sc=-_xsux}', "");
    Expect(1, 75075, '\P{^Sc=-_xsux}', "");
    Expect(0, 75076, '\p{Sc=-_xsux}', "");
    Expect(1, 75076, '\p{^Sc=-_xsux}', "");
    Expect(1, 75076, '\P{Sc=-_xsux}', "");
    Expect(0, 75076, '\P{^Sc=-_xsux}', "");
    Error('\p{Is_Script=_	Cuneiform:=}');
    Error('\P{Is_Script=_	Cuneiform:=}');
    Expect(1, 75075, '\p{Is_Script=cuneiform}', "");
    Expect(0, 75075, '\p{^Is_Script=cuneiform}', "");
    Expect(0, 75075, '\P{Is_Script=cuneiform}', "");
    Expect(1, 75075, '\P{^Is_Script=cuneiform}', "");
    Expect(0, 75076, '\p{Is_Script=cuneiform}', "");
    Expect(1, 75076, '\p{^Is_Script=cuneiform}', "");
    Expect(1, 75076, '\P{Is_Script=cuneiform}', "");
    Expect(0, 75076, '\P{^Is_Script=cuneiform}', "");
    Expect(1, 75075, '\p{Is_Script=-_Cuneiform}', "");
    Expect(0, 75075, '\p{^Is_Script=-_Cuneiform}', "");
    Expect(0, 75075, '\P{Is_Script=-_Cuneiform}', "");
    Expect(1, 75075, '\P{^Is_Script=-_Cuneiform}', "");
    Expect(0, 75076, '\p{Is_Script=-_Cuneiform}', "");
    Expect(1, 75076, '\p{^Is_Script=-_Cuneiform}', "");
    Expect(1, 75076, '\P{Is_Script=-_Cuneiform}', "");
    Expect(0, 75076, '\P{^Is_Script=-_Cuneiform}', "");
    Error('\p{Is_Sc:	:= -XSUX}');
    Error('\P{Is_Sc:	:= -XSUX}');
    Expect(1, 75075, '\p{Is_Sc=xsux}', "");
    Expect(0, 75075, '\p{^Is_Sc=xsux}', "");
    Expect(0, 75075, '\P{Is_Sc=xsux}', "");
    Expect(1, 75075, '\P{^Is_Sc=xsux}', "");
    Expect(0, 75076, '\p{Is_Sc=xsux}', "");
    Expect(1, 75076, '\p{^Is_Sc=xsux}', "");
    Expect(1, 75076, '\P{Is_Sc=xsux}', "");
    Expect(0, 75076, '\P{^Is_Sc=xsux}', "");
    Expect(1, 75075, '\p{Is_Sc= -XSUX}', "");
    Expect(0, 75075, '\p{^Is_Sc= -XSUX}', "");
    Expect(0, 75075, '\P{Is_Sc= -XSUX}', "");
    Expect(1, 75075, '\P{^Is_Sc= -XSUX}', "");
    Expect(0, 75076, '\p{Is_Sc= -XSUX}', "");
    Expect(1, 75076, '\p{^Is_Sc= -XSUX}', "");
    Expect(1, 75076, '\P{Is_Sc= -XSUX}', "");
    Expect(0, 75076, '\P{^Is_Sc= -XSUX}', "");
    Error('\p{Script=:=Yezidi}');
    Error('\P{Script=:=Yezidi}');
    Expect(1, 69297, '\p{Script=:\AYezidi\z:}', "");;
    Expect(0, 69298, '\p{Script=:\AYezidi\z:}', "");;
    Expect(1, 69297, '\p{Script=yezidi}', "");
    Expect(0, 69297, '\p{^Script=yezidi}', "");
    Expect(0, 69297, '\P{Script=yezidi}', "");
    Expect(1, 69297, '\P{^Script=yezidi}', "");
    Expect(0, 69298, '\p{Script=yezidi}', "");
    Expect(1, 69298, '\p{^Script=yezidi}', "");
    Expect(1, 69298, '\P{Script=yezidi}', "");
    Expect(0, 69298, '\P{^Script=yezidi}', "");
    Expect(1, 69297, '\p{Script=:\Ayezidi\z:}', "");;
    Expect(0, 69298, '\p{Script=:\Ayezidi\z:}', "");;
    Expect(1, 69297, '\p{Script:   -yezidi}', "");
    Expect(0, 69297, '\p{^Script:   -yezidi}', "");
    Expect(0, 69297, '\P{Script:   -yezidi}', "");
    Expect(1, 69297, '\P{^Script:   -yezidi}', "");
    Expect(0, 69298, '\p{Script:   -yezidi}', "");
    Expect(1, 69298, '\p{^Script:   -yezidi}', "");
    Expect(1, 69298, '\P{Script:   -yezidi}', "");
    Expect(0, 69298, '\P{^Script:   -yezidi}', "");
    Error('\p{Sc=-yezi:=}');
    Error('\P{Sc=-yezi:=}');
    Expect(1, 69297, '\p{Sc=:\AYezi\z:}', "");;
    Expect(0, 69298, '\p{Sc=:\AYezi\z:}', "");;
    Expect(1, 69297, '\p{Sc=yezi}', "");
    Expect(0, 69297, '\p{^Sc=yezi}', "");
    Expect(0, 69297, '\P{Sc=yezi}', "");
    Expect(1, 69297, '\P{^Sc=yezi}', "");
    Expect(0, 69298, '\p{Sc=yezi}', "");
    Expect(1, 69298, '\p{^Sc=yezi}', "");
    Expect(1, 69298, '\P{Sc=yezi}', "");
    Expect(0, 69298, '\P{^Sc=yezi}', "");
    Expect(1, 69297, '\p{Sc=:\Ayezi\z:}', "");;
    Expect(0, 69298, '\p{Sc=:\Ayezi\z:}', "");;
    Expect(1, 69297, '\p{Sc=	 YEZI}', "");
    Expect(0, 69297, '\p{^Sc=	 YEZI}', "");
    Expect(0, 69297, '\P{Sc=	 YEZI}', "");
    Expect(1, 69297, '\P{^Sc=	 YEZI}', "");
    Expect(0, 69298, '\p{Sc=	 YEZI}', "");
    Expect(1, 69298, '\p{^Sc=	 YEZI}', "");
    Expect(1, 69298, '\P{Sc=	 YEZI}', "");
    Expect(0, 69298, '\P{^Sc=	 YEZI}', "");
    Error('\p{Is_Script=	:=Yezidi}');
    Error('\P{Is_Script=	:=Yezidi}');
    Expect(1, 69297, '\p{Is_Script=yezidi}', "");
    Expect(0, 69297, '\p{^Is_Script=yezidi}', "");
    Expect(0, 69297, '\P{Is_Script=yezidi}', "");
    Expect(1, 69297, '\P{^Is_Script=yezidi}', "");
    Expect(0, 69298, '\p{Is_Script=yezidi}', "");
    Expect(1, 69298, '\p{^Is_Script=yezidi}', "");
    Expect(1, 69298, '\P{Is_Script=yezidi}', "");
    Expect(0, 69298, '\P{^Is_Script=yezidi}', "");
    Expect(1, 69297, '\p{Is_Script=_ Yezidi}', "");
    Expect(0, 69297, '\p{^Is_Script=_ Yezidi}', "");
    Expect(0, 69297, '\P{Is_Script=_ Yezidi}', "");
    Expect(1, 69297, '\P{^Is_Script=_ Yezidi}', "");
    Expect(0, 69298, '\p{Is_Script=_ Yezidi}', "");
    Expect(1, 69298, '\p{^Is_Script=_ Yezidi}', "");
    Expect(1, 69298, '\P{Is_Script=_ Yezidi}', "");
    Expect(0, 69298, '\P{^Is_Script=_ Yezidi}', "");
    Error('\p{Is_Sc= Yezi/a/}');
    Error('\P{Is_Sc= Yezi/a/}');
    Expect(1, 69297, '\p{Is_Sc=yezi}', "");
    Expect(0, 69297, '\p{^Is_Sc=yezi}', "");
    Expect(0, 69297, '\P{Is_Sc=yezi}', "");
    Expect(1, 69297, '\P{^Is_Sc=yezi}', "");
    Expect(0, 69298, '\p{Is_Sc=yezi}', "");
    Expect(1, 69298, '\p{^Is_Sc=yezi}', "");
    Expect(1, 69298, '\P{Is_Sc=yezi}', "");
    Expect(0, 69298, '\P{^Is_Sc=yezi}', "");
    Expect(1, 69297, '\p{Is_Sc=_-yezi}', "");
    Expect(0, 69297, '\p{^Is_Sc=_-yezi}', "");
    Expect(0, 69297, '\P{Is_Sc=_-yezi}', "");
    Expect(1, 69297, '\P{^Is_Sc=_-yezi}', "");
    Expect(0, 69298, '\p{Is_Sc=_-yezi}', "");
    Expect(1, 69298, '\p{^Is_Sc=_-yezi}', "");
    Expect(1, 69298, '\P{Is_Sc=_-yezi}', "");
    Expect(0, 69298, '\P{^Is_Sc=_-yezi}', "");
    Error('\p{Script=/a/ 	Yi}');
    Error('\P{Script=/a/ 	Yi}');
    Expect(1, 42182, '\p{Script=:\AYi\z:}', "");;
    Expect(0, 42183, '\p{Script=:\AYi\z:}', "");;
    Expect(1, 42182, '\p{Script=yi}', "");
    Expect(0, 42182, '\p{^Script=yi}', "");
    Expect(0, 42182, '\P{Script=yi}', "");
    Expect(1, 42182, '\P{^Script=yi}', "");
    Expect(0, 42183, '\p{Script=yi}', "");
    Expect(1, 42183, '\p{^Script=yi}', "");
    Expect(1, 42183, '\P{Script=yi}', "");
    Expect(0, 42183, '\P{^Script=yi}', "");
    Expect(1, 42182, '\p{Script=:\Ayi\z:}', "");;
    Expect(0, 42183, '\p{Script=:\Ayi\z:}', "");;
    Expect(1, 42182, '\p{Script=	_yi}', "");
    Expect(0, 42182, '\p{^Script=	_yi}', "");
    Expect(0, 42182, '\P{Script=	_yi}', "");
    Expect(1, 42182, '\P{^Script=	_yi}', "");
    Expect(0, 42183, '\p{Script=	_yi}', "");
    Expect(1, 42183, '\p{^Script=	_yi}', "");
    Expect(1, 42183, '\P{Script=	_yi}', "");
    Expect(0, 42183, '\P{^Script=	_yi}', "");
    Error('\p{Sc:	-Yiii:=}');
    Error('\P{Sc:	-Yiii:=}');
    Expect(1, 42182, '\p{Sc=:\AYiii\z:}', "");;
    Expect(0, 42183, '\p{Sc=:\AYiii\z:}', "");;
    Expect(1, 42182, '\p{Sc=yiii}', "");
    Expect(0, 42182, '\p{^Sc=yiii}', "");
    Expect(0, 42182, '\P{Sc=yiii}', "");
    Expect(1, 42182, '\P{^Sc=yiii}', "");
    Expect(0, 42183, '\p{Sc=yiii}', "");
    Expect(1, 42183, '\p{^Sc=yiii}', "");
    Expect(1, 42183, '\P{Sc=yiii}', "");
    Expect(0, 42183, '\P{^Sc=yiii}', "");
    Expect(1, 42182, '\p{Sc=:\Ayiii\z:}', "");;
    Expect(0, 42183, '\p{Sc=:\Ayiii\z:}', "");;
    Expect(1, 42182, '\p{Sc=	_Yiii}', "");
    Expect(0, 42182, '\p{^Sc=	_Yiii}', "");
    Expect(0, 42182, '\P{Sc=	_Yiii}', "");
    Expect(1, 42182, '\P{^Sc=	_Yiii}', "");
    Expect(0, 42183, '\p{Sc=	_Yiii}', "");
    Expect(1, 42183, '\p{^Sc=	_Yiii}', "");
    Expect(1, 42183, '\P{Sc=	_Yiii}', "");
    Expect(0, 42183, '\P{^Sc=	_Yiii}', "");
    Error('\p{Is_Script=:=-	Yi}');
    Error('\P{Is_Script=:=-	Yi}');
    Expect(1, 42182, '\p{Is_Script=yi}', "");
    Expect(0, 42182, '\p{^Is_Script=yi}', "");
    Expect(0, 42182, '\P{Is_Script=yi}', "");
    Expect(1, 42182, '\P{^Is_Script=yi}', "");
    Expect(0, 42183, '\p{Is_Script=yi}', "");
    Expect(1, 42183, '\p{^Is_Script=yi}', "");
    Expect(1, 42183, '\P{Is_Script=yi}', "");
    Expect(0, 42183, '\P{^Is_Script=yi}', "");
    Expect(1, 42182, '\p{Is_Script=_	Yi}', "");
    Expect(0, 42182, '\p{^Is_Script=_	Yi}', "");
    Expect(0, 42182, '\P{Is_Script=_	Yi}', "");
    Expect(1, 42182, '\P{^Is_Script=_	Yi}', "");
    Expect(0, 42183, '\p{Is_Script=_	Yi}', "");
    Expect(1, 42183, '\p{^Is_Script=_	Yi}', "");
    Expect(1, 42183, '\P{Is_Script=_	Yi}', "");
    Expect(0, 42183, '\P{^Is_Script=_	Yi}', "");
    Error('\p{Is_Sc=/a/  Yiii}');
    Error('\P{Is_Sc=/a/  Yiii}');
    Expect(1, 42182, '\p{Is_Sc=yiii}', "");
    Expect(0, 42182, '\p{^Is_Sc=yiii}', "");
    Expect(0, 42182, '\P{Is_Sc=yiii}', "");
    Expect(1, 42182, '\P{^Is_Sc=yiii}', "");
    Expect(0, 42183, '\p{Is_Sc=yiii}', "");
    Expect(1, 42183, '\p{^Is_Sc=yiii}', "");
    Expect(1, 42183, '\P{Is_Sc=yiii}', "");
    Expect(0, 42183, '\P{^Is_Sc=yiii}', "");
    Expect(1, 42182, '\p{Is_Sc=-Yiii}', "");
    Expect(0, 42182, '\p{^Is_Sc=-Yiii}', "");
    Expect(0, 42182, '\P{Is_Sc=-Yiii}', "");
    Expect(1, 42182, '\P{^Is_Sc=-Yiii}', "");
    Expect(0, 42183, '\p{Is_Sc=-Yiii}', "");
    Expect(1, 42183, '\p{^Is_Sc=-Yiii}', "");
    Expect(1, 42183, '\P{Is_Sc=-Yiii}', "");
    Expect(0, 42183, '\P{^Is_Sc=-Yiii}', "");
    Error('\p{Script:   :=--Zanabazar_SQUARE}');
    Error('\P{Script:   :=--Zanabazar_SQUARE}');
    Expect(1, 72263, '\p{Script=:\AZanabazar_Square\z:}', "");;
    Expect(0, 72264, '\p{Script=:\AZanabazar_Square\z:}', "");;
    Expect(1, 72263, '\p{Script=zanabazarsquare}', "");
    Expect(0, 72263, '\p{^Script=zanabazarsquare}', "");
    Expect(0, 72263, '\P{Script=zanabazarsquare}', "");
    Expect(1, 72263, '\P{^Script=zanabazarsquare}', "");
    Expect(0, 72264, '\p{Script=zanabazarsquare}', "");
    Expect(1, 72264, '\p{^Script=zanabazarsquare}', "");
    Expect(1, 72264, '\P{Script=zanabazarsquare}', "");
    Expect(0, 72264, '\P{^Script=zanabazarsquare}', "");
    Expect(1, 72263, '\p{Script=:\Azanabazarsquare\z:}', "");;
    Expect(0, 72264, '\p{Script=:\Azanabazarsquare\z:}', "");;
    Expect(1, 72263, '\p{Script:   -_Zanabazar_Square}', "");
    Expect(0, 72263, '\p{^Script:   -_Zanabazar_Square}', "");
    Expect(0, 72263, '\P{Script:   -_Zanabazar_Square}', "");
    Expect(1, 72263, '\P{^Script:   -_Zanabazar_Square}', "");
    Expect(0, 72264, '\p{Script:   -_Zanabazar_Square}', "");
    Expect(1, 72264, '\p{^Script:   -_Zanabazar_Square}', "");
    Expect(1, 72264, '\P{Script:   -_Zanabazar_Square}', "");
    Expect(0, 72264, '\P{^Script:   -_Zanabazar_Square}', "");
    Error('\p{Sc=	zanb:=}');
    Error('\P{Sc=	zanb:=}');
    Expect(1, 72263, '\p{Sc=:\AZanb\z:}', "");;
    Expect(0, 72264, '\p{Sc=:\AZanb\z:}', "");;
    Expect(1, 72263, '\p{Sc=zanb}', "");
    Expect(0, 72263, '\p{^Sc=zanb}', "");
    Expect(0, 72263, '\P{Sc=zanb}', "");
    Expect(1, 72263, '\P{^Sc=zanb}', "");
    Expect(0, 72264, '\p{Sc=zanb}', "");
    Expect(1, 72264, '\p{^Sc=zanb}', "");
    Expect(1, 72264, '\P{Sc=zanb}', "");
    Expect(0, 72264, '\P{^Sc=zanb}', "");
    Expect(1, 72263, '\p{Sc=:\Azanb\z:}', "");;
    Expect(0, 72264, '\p{Sc=:\Azanb\z:}', "");;
    Expect(1, 72263, '\p{Sc=-	ZANB}', "");
    Expect(0, 72263, '\p{^Sc=-	ZANB}', "");
    Expect(0, 72263, '\P{Sc=-	ZANB}', "");
    Expect(1, 72263, '\P{^Sc=-	ZANB}', "");
    Expect(0, 72264, '\p{Sc=-	ZANB}', "");
    Expect(1, 72264, '\p{^Sc=-	ZANB}', "");
    Expect(1, 72264, '\P{Sc=-	ZANB}', "");
    Expect(0, 72264, '\P{^Sc=-	ZANB}', "");
    Error('\p{Is_Script=/a/ 	zanabazar_Square}');
    Error('\P{Is_Script=/a/ 	zanabazar_Square}');
    Expect(1, 72263, '\p{Is_Script=zanabazarsquare}', "");
    Expect(0, 72263, '\p{^Is_Script=zanabazarsquare}', "");
    Expect(0, 72263, '\P{Is_Script=zanabazarsquare}', "");
    Expect(1, 72263, '\P{^Is_Script=zanabazarsquare}', "");
    Expect(0, 72264, '\p{Is_Script=zanabazarsquare}', "");
    Expect(1, 72264, '\p{^Is_Script=zanabazarsquare}', "");
    Expect(1, 72264, '\P{Is_Script=zanabazarsquare}', "");
    Expect(0, 72264, '\P{^Is_Script=zanabazarsquare}', "");
    Expect(1, 72263, '\p{Is_Script= 	ZANABAZAR_Square}', "");
    Expect(0, 72263, '\p{^Is_Script= 	ZANABAZAR_Square}', "");
    Expect(0, 72263, '\P{Is_Script= 	ZANABAZAR_Square}', "");
    Expect(1, 72263, '\P{^Is_Script= 	ZANABAZAR_Square}', "");
    Expect(0, 72264, '\p{Is_Script= 	ZANABAZAR_Square}', "");
    Expect(1, 72264, '\p{^Is_Script= 	ZANABAZAR_Square}', "");
    Expect(1, 72264, '\P{Is_Script= 	ZANABAZAR_Square}', "");
    Expect(0, 72264, '\P{^Is_Script= 	ZANABAZAR_Square}', "");
    Error('\p{Is_Sc=_	Zanb/a/}');
    Error('\P{Is_Sc=_	Zanb/a/}');
    Expect(1, 72263, '\p{Is_Sc: zanb}', "");
    Expect(0, 72263, '\p{^Is_Sc: zanb}', "");
    Expect(0, 72263, '\P{Is_Sc: zanb}', "");
    Expect(1, 72263, '\P{^Is_Sc: zanb}', "");
    Expect(0, 72264, '\p{Is_Sc: zanb}', "");
    Expect(1, 72264, '\p{^Is_Sc: zanb}', "");
    Expect(1, 72264, '\P{Is_Sc: zanb}', "");
    Expect(0, 72264, '\P{^Is_Sc: zanb}', "");
    Expect(1, 72263, '\p{Is_Sc=--ZANB}', "");
    Expect(0, 72263, '\p{^Is_Sc=--ZANB}', "");
    Expect(0, 72263, '\P{Is_Sc=--ZANB}', "");
    Expect(1, 72263, '\P{^Is_Sc=--ZANB}', "");
    Expect(0, 72264, '\p{Is_Sc=--ZANB}', "");
    Expect(1, 72264, '\p{^Is_Sc=--ZANB}', "");
    Expect(1, 72264, '\P{Is_Sc=--ZANB}', "");
    Expect(0, 72264, '\P{^Is_Sc=--ZANB}', "");
    Error('\p{Script=--Inherited:=}');
    Error('\P{Script=--Inherited:=}');
    Expect(1, 917999, '\p{Script=:\AInherited\z:}', "");;
    Expect(0, 918000, '\p{Script=:\AInherited\z:}', "");;
    Expect(1, 917999, '\p{Script=inherited}', "");
    Expect(0, 917999, '\p{^Script=inherited}', "");
    Expect(0, 917999, '\P{Script=inherited}', "");
    Expect(1, 917999, '\P{^Script=inherited}', "");
    Expect(0, 918000, '\p{Script=inherited}', "");
    Expect(1, 918000, '\p{^Script=inherited}', "");
    Expect(1, 918000, '\P{Script=inherited}', "");
    Expect(0, 918000, '\P{^Script=inherited}', "");
    Expect(1, 917999, '\p{Script=:\Ainherited\z:}', "");;
    Expect(0, 918000, '\p{Script=:\Ainherited\z:}', "");;
    Expect(1, 917999, '\p{Script:  	inherited}', "");
    Expect(0, 917999, '\p{^Script:  	inherited}', "");
    Expect(0, 917999, '\P{Script:  	inherited}', "");
    Expect(1, 917999, '\P{^Script:  	inherited}', "");
    Expect(0, 918000, '\p{Script:  	inherited}', "");
    Expect(1, 918000, '\p{^Script:  	inherited}', "");
    Expect(1, 918000, '\P{Script:  	inherited}', "");
    Expect(0, 918000, '\P{^Script:  	inherited}', "");
    Error('\p{Sc=:=_	ZINH}');
    Error('\P{Sc=:=_	ZINH}');
    Expect(1, 917999, '\p{Sc=:\AZinh\z:}', "");;
    Expect(0, 918000, '\p{Sc=:\AZinh\z:}', "");;
    Expect(1, 917999, '\p{Sc=zinh}', "");
    Expect(0, 917999, '\p{^Sc=zinh}', "");
    Expect(0, 917999, '\P{Sc=zinh}', "");
    Expect(1, 917999, '\P{^Sc=zinh}', "");
    Expect(0, 918000, '\p{Sc=zinh}', "");
    Expect(1, 918000, '\p{^Sc=zinh}', "");
    Expect(1, 918000, '\P{Sc=zinh}', "");
    Expect(0, 918000, '\P{^Sc=zinh}', "");
    Expect(1, 917999, '\p{Sc=:\Azinh\z:}', "");;
    Expect(0, 918000, '\p{Sc=:\Azinh\z:}', "");;
    Expect(1, 917999, '\p{Sc=-zinh}', "");
    Expect(0, 917999, '\p{^Sc=-zinh}', "");
    Expect(0, 917999, '\P{Sc=-zinh}', "");
    Expect(1, 917999, '\P{^Sc=-zinh}', "");
    Expect(0, 918000, '\p{Sc=-zinh}', "");
    Expect(1, 918000, '\p{^Sc=-zinh}', "");
    Expect(1, 918000, '\P{Sc=-zinh}', "");
    Expect(0, 918000, '\P{^Sc=-zinh}', "");
    Error('\p{Is_Script=	_Qaai:=}');
    Error('\P{Is_Script=	_Qaai:=}');
    Expect(1, 917999, '\p{Is_Script=qaai}', "");
    Expect(0, 917999, '\p{^Is_Script=qaai}', "");
    Expect(0, 917999, '\P{Is_Script=qaai}', "");
    Expect(1, 917999, '\P{^Is_Script=qaai}', "");
    Expect(0, 918000, '\p{Is_Script=qaai}', "");
    Expect(1, 918000, '\p{^Is_Script=qaai}', "");
    Expect(1, 918000, '\P{Is_Script=qaai}', "");
    Expect(0, 918000, '\P{^Is_Script=qaai}', "");
    Expect(1, 917999, '\p{Is_Script=__qaai}', "");
    Expect(0, 917999, '\p{^Is_Script=__qaai}', "");
    Expect(0, 917999, '\P{Is_Script=__qaai}', "");
    Expect(1, 917999, '\P{^Is_Script=__qaai}', "");
    Expect(0, 918000, '\p{Is_Script=__qaai}', "");
    Expect(1, 918000, '\p{^Is_Script=__qaai}', "");
    Expect(1, 918000, '\P{Is_Script=__qaai}', "");
    Expect(0, 918000, '\P{^Is_Script=__qaai}', "");
    Error('\p{Is_Sc:	-:=INHERITED}');
    Error('\P{Is_Sc:	-:=INHERITED}');
    Expect(1, 917999, '\p{Is_Sc=inherited}', "");
    Expect(0, 917999, '\p{^Is_Sc=inherited}', "");
    Expect(0, 917999, '\P{Is_Sc=inherited}', "");
    Expect(1, 917999, '\P{^Is_Sc=inherited}', "");
    Expect(0, 918000, '\p{Is_Sc=inherited}', "");
    Expect(1, 918000, '\p{^Is_Sc=inherited}', "");
    Expect(1, 918000, '\P{Is_Sc=inherited}', "");
    Expect(0, 918000, '\P{^Is_Sc=inherited}', "");
    Expect(1, 917999, '\p{Is_Sc=_Inherited}', "");
    Expect(0, 917999, '\p{^Is_Sc=_Inherited}', "");
    Expect(0, 917999, '\P{Is_Sc=_Inherited}', "");
    Expect(1, 917999, '\P{^Is_Sc=_Inherited}', "");
    Expect(0, 918000, '\p{Is_Sc=_Inherited}', "");
    Expect(1, 918000, '\p{^Is_Sc=_Inherited}', "");
    Expect(1, 918000, '\P{Is_Sc=_Inherited}', "");
    Expect(0, 918000, '\P{^Is_Sc=_Inherited}', "");
    Error('\p{Script=- COMMON:=}');
    Error('\P{Script=- COMMON:=}');
    Expect(1, 917631, '\p{Script=:\ACommon\z:}', "");;
    Expect(0, 917632, '\p{Script=:\ACommon\z:}', "");;
    Expect(1, 917631, '\p{Script=common}', "");
    Expect(0, 917631, '\p{^Script=common}', "");
    Expect(0, 917631, '\P{Script=common}', "");
    Expect(1, 917631, '\P{^Script=common}', "");
    Expect(0, 917632, '\p{Script=common}', "");
    Expect(1, 917632, '\p{^Script=common}', "");
    Expect(1, 917632, '\P{Script=common}', "");
    Expect(0, 917632, '\P{^Script=common}', "");
    Expect(1, 917631, '\p{Script=:\Acommon\z:}', "");;
    Expect(0, 917632, '\p{Script=:\Acommon\z:}', "");;
    Expect(1, 917631, '\p{Script=	COMMON}', "");
    Expect(0, 917631, '\p{^Script=	COMMON}', "");
    Expect(0, 917631, '\P{Script=	COMMON}', "");
    Expect(1, 917631, '\P{^Script=	COMMON}', "");
    Expect(0, 917632, '\p{Script=	COMMON}', "");
    Expect(1, 917632, '\p{^Script=	COMMON}', "");
    Expect(1, 917632, '\P{Script=	COMMON}', "");
    Expect(0, 917632, '\P{^Script=	COMMON}', "");
    Error('\p{Sc= :=Zyyy}');
    Error('\P{Sc= :=Zyyy}');
    Expect(1, 917631, '\p{Sc=:\AZyyy\z:}', "");;
    Expect(0, 917632, '\p{Sc=:\AZyyy\z:}', "");;
    Expect(1, 917631, '\p{Sc=zyyy}', "");
    Expect(0, 917631, '\p{^Sc=zyyy}', "");
    Expect(0, 917631, '\P{Sc=zyyy}', "");
    Expect(1, 917631, '\P{^Sc=zyyy}', "");
    Expect(0, 917632, '\p{Sc=zyyy}', "");
    Expect(1, 917632, '\p{^Sc=zyyy}', "");
    Expect(1, 917632, '\P{Sc=zyyy}', "");
    Expect(0, 917632, '\P{^Sc=zyyy}', "");
    Expect(1, 917631, '\p{Sc=:\Azyyy\z:}', "");;
    Expect(0, 917632, '\p{Sc=:\Azyyy\z:}', "");;
    Expect(1, 917631, '\p{Sc=_ZYYY}', "");
    Expect(0, 917631, '\p{^Sc=_ZYYY}', "");
    Expect(0, 917631, '\P{Sc=_ZYYY}', "");
    Expect(1, 917631, '\P{^Sc=_ZYYY}', "");
    Expect(0, 917632, '\p{Sc=_ZYYY}', "");
    Expect(1, 917632, '\p{^Sc=_ZYYY}', "");
    Expect(1, 917632, '\P{Sc=_ZYYY}', "");
    Expect(0, 917632, '\P{^Sc=_ZYYY}', "");
    Error('\p{Is_Script=		Common:=}');
    Error('\P{Is_Script=		Common:=}');
    Expect(1, 917631, '\p{Is_Script:common}', "");
    Expect(0, 917631, '\p{^Is_Script:common}', "");
    Expect(0, 917631, '\P{Is_Script:common}', "");
    Expect(1, 917631, '\P{^Is_Script:common}', "");
    Expect(0, 917632, '\p{Is_Script:common}', "");
    Expect(1, 917632, '\p{^Is_Script:common}', "");
    Expect(1, 917632, '\P{Is_Script:common}', "");
    Expect(0, 917632, '\P{^Is_Script:common}', "");
    Expect(1, 917631, '\p{Is_Script=	_common}', "");
    Expect(0, 917631, '\p{^Is_Script=	_common}', "");
    Expect(0, 917631, '\P{Is_Script=	_common}', "");
    Expect(1, 917631, '\P{^Is_Script=	_common}', "");
    Expect(0, 917632, '\p{Is_Script=	_common}', "");
    Expect(1, 917632, '\p{^Is_Script=	_common}', "");
    Expect(1, 917632, '\P{Is_Script=	_common}', "");
    Expect(0, 917632, '\P{^Is_Script=	_common}', "");
    Error('\p{Is_Sc= :=zyyy}');
    Error('\P{Is_Sc= :=zyyy}');
    Expect(1, 917631, '\p{Is_Sc=zyyy}', "");
    Expect(0, 917631, '\p{^Is_Sc=zyyy}', "");
    Expect(0, 917631, '\P{Is_Sc=zyyy}', "");
    Expect(1, 917631, '\P{^Is_Sc=zyyy}', "");
    Expect(0, 917632, '\p{Is_Sc=zyyy}', "");
    Expect(1, 917632, '\p{^Is_Sc=zyyy}', "");
    Expect(1, 917632, '\P{Is_Sc=zyyy}', "");
    Expect(0, 917632, '\P{^Is_Sc=zyyy}', "");
    Expect(1, 917631, '\p{Is_Sc=_Zyyy}', "");
    Expect(0, 917631, '\p{^Is_Sc=_Zyyy}', "");
    Expect(0, 917631, '\P{Is_Sc=_Zyyy}', "");
    Expect(1, 917631, '\P{^Is_Sc=_Zyyy}', "");
    Expect(0, 917632, '\p{Is_Sc=_Zyyy}', "");
    Expect(1, 917632, '\p{^Is_Sc=_Zyyy}', "");
    Expect(1, 917632, '\P{Is_Sc=_Zyyy}', "");
    Expect(0, 917632, '\P{^Is_Sc=_Zyyy}', "");
    Error('\p{Script:   /a/UNKNOWN}');
    Error('\P{Script:   /a/UNKNOWN}');
    Expect(1, 918000, '\p{Script=:\AUnknown\z:}', "");;
    Expect(0, 917999, '\p{Script=:\AUnknown\z:}', "");;
    Expect(1, 918000, '\p{Script=unknown}', "");
    Expect(0, 918000, '\p{^Script=unknown}', "");
    Expect(0, 918000, '\P{Script=unknown}', "");
    Expect(1, 918000, '\P{^Script=unknown}', "");
    Expect(0, 917999, '\p{Script=unknown}', "");
    Expect(1, 917999, '\p{^Script=unknown}', "");
    Expect(1, 917999, '\P{Script=unknown}', "");
    Expect(0, 917999, '\P{^Script=unknown}', "");
    Expect(1, 918000, '\p{Script=:\Aunknown\z:}', "");;
    Expect(0, 917999, '\p{Script=:\Aunknown\z:}', "");;
    Expect(1, 918000, '\p{Script= Unknown}', "");
    Expect(0, 918000, '\p{^Script= Unknown}', "");
    Expect(0, 918000, '\P{Script= Unknown}', "");
    Expect(1, 918000, '\P{^Script= Unknown}', "");
    Expect(0, 917999, '\p{Script= Unknown}', "");
    Expect(1, 917999, '\p{^Script= Unknown}', "");
    Expect(1, 917999, '\P{Script= Unknown}', "");
    Expect(0, 917999, '\P{^Script= Unknown}', "");
    Error('\p{Sc=_ ZZZZ:=}');
    Error('\P{Sc=_ ZZZZ:=}');
    Expect(1, 918000, '\p{Sc=:\AZzzz\z:}', "");;
    Expect(0, 917999, '\p{Sc=:\AZzzz\z:}', "");;
    Expect(1, 918000, '\p{Sc=zzzz}', "");
    Expect(0, 918000, '\p{^Sc=zzzz}', "");
    Expect(0, 918000, '\P{Sc=zzzz}', "");
    Expect(1, 918000, '\P{^Sc=zzzz}', "");
    Expect(0, 917999, '\p{Sc=zzzz}', "");
    Expect(1, 917999, '\p{^Sc=zzzz}', "");
    Expect(1, 917999, '\P{Sc=zzzz}', "");
    Expect(0, 917999, '\P{^Sc=zzzz}', "");
    Expect(1, 918000, '\p{Sc=:\Azzzz\z:}', "");;
    Expect(0, 917999, '\p{Sc=:\Azzzz\z:}', "");;
    Expect(1, 918000, '\p{Sc=- zzzz}', "");
    Expect(0, 918000, '\p{^Sc=- zzzz}', "");
    Expect(0, 918000, '\P{Sc=- zzzz}', "");
    Expect(1, 918000, '\P{^Sc=- zzzz}', "");
    Expect(0, 917999, '\p{Sc=- zzzz}', "");
    Expect(1, 917999, '\p{^Sc=- zzzz}', "");
    Expect(1, 917999, '\P{Sc=- zzzz}', "");
    Expect(0, 917999, '\P{^Sc=- zzzz}', "");
    Error('\p{Is_Script:	_:=unknown}');
    Error('\P{Is_Script:	_:=unknown}');
    Expect(1, 918000, '\p{Is_Script=unknown}', "");
    Expect(0, 918000, '\p{^Is_Script=unknown}', "");
    Expect(0, 918000, '\P{Is_Script=unknown}', "");
    Expect(1, 918000, '\P{^Is_Script=unknown}', "");
    Expect(0, 917999, '\p{Is_Script=unknown}', "");
    Expect(1, 917999, '\p{^Is_Script=unknown}', "");
    Expect(1, 917999, '\P{Is_Script=unknown}', "");
    Expect(0, 917999, '\P{^Is_Script=unknown}', "");
    Expect(1, 918000, '\p{Is_Script=	_unknown}', "");
    Expect(0, 918000, '\p{^Is_Script=	_unknown}', "");
    Expect(0, 918000, '\P{Is_Script=	_unknown}', "");
    Expect(1, 918000, '\P{^Is_Script=	_unknown}', "");
    Expect(0, 917999, '\p{Is_Script=	_unknown}', "");
    Expect(1, 917999, '\p{^Is_Script=	_unknown}', "");
    Expect(1, 917999, '\P{Is_Script=	_unknown}', "");
    Expect(0, 917999, '\P{^Is_Script=	_unknown}', "");
    Error('\p{Is_Sc=:=zzzz}');
    Error('\P{Is_Sc=:=zzzz}');
    Expect(1, 918000, '\p{Is_Sc=zzzz}', "");
    Expect(0, 918000, '\p{^Is_Sc=zzzz}', "");
    Expect(0, 918000, '\P{Is_Sc=zzzz}', "");
    Expect(1, 918000, '\P{^Is_Sc=zzzz}', "");
    Expect(0, 917999, '\p{Is_Sc=zzzz}', "");
    Expect(1, 917999, '\p{^Is_Sc=zzzz}', "");
    Expect(1, 917999, '\P{Is_Sc=zzzz}', "");
    Expect(0, 917999, '\P{^Is_Sc=zzzz}', "");
    Expect(1, 918000, '\p{Is_Sc=		zzzz}', "");
    Expect(0, 918000, '\p{^Is_Sc=		zzzz}', "");
    Expect(0, 918000, '\P{Is_Sc=		zzzz}', "");
    Expect(1, 918000, '\P{^Is_Sc=		zzzz}', "");
    Expect(0, 917999, '\p{Is_Sc=		zzzz}', "");
    Expect(1, 917999, '\p{^Is_Sc=		zzzz}', "");
    Expect(1, 917999, '\P{Is_Sc=		zzzz}', "");
    Expect(0, 917999, '\P{^Is_Sc=		zzzz}', "");
    Error('\p{simplecasefolding}');
    Error('\P{simplecasefolding}');
    Error('\p{scf}');
    Error('\P{scf}');
    Error('\p{sfc}');
    Error('\P{sfc}');
    Error('\p{scriptextensions}');
    Error('\P{scriptextensions}');
    Error('\p{scx}');
    Error('\P{scx}');
    Error('\p{Script_Extensions=/a/_Adlam}');
    Error('\P{Script_Extensions=/a/_Adlam}');
    Expect(1, 125279, '\p{Script_Extensions=:\AAdlam\z:}', "");;
    Expect(0, 125280, '\p{Script_Extensions=:\AAdlam\z:}', "");;
    Expect(1, 125279, '\p{Script_Extensions:	adlam}', "");
    Expect(0, 125279, '\p{^Script_Extensions:	adlam}', "");
    Expect(0, 125279, '\P{Script_Extensions:	adlam}', "");
    Expect(1, 125279, '\P{^Script_Extensions:	adlam}', "");
    Expect(0, 125280, '\p{Script_Extensions:	adlam}', "");
    Expect(1, 125280, '\p{^Script_Extensions:	adlam}', "");
    Expect(1, 125280, '\P{Script_Extensions:	adlam}', "");
    Expect(0, 125280, '\P{^Script_Extensions:	adlam}', "");
    Expect(1, 125279, '\p{Script_Extensions=:\Aadlam\z:}', "");;
    Expect(0, 125280, '\p{Script_Extensions=:\Aadlam\z:}', "");;
    Expect(1, 125279, '\p{Script_Extensions= 	Adlam}', "");
    Expect(0, 125279, '\p{^Script_Extensions= 	Adlam}', "");
    Expect(0, 125279, '\P{Script_Extensions= 	Adlam}', "");
    Expect(1, 125279, '\P{^Script_Extensions= 	Adlam}', "");
    Expect(0, 125280, '\p{Script_Extensions= 	Adlam}', "");
    Expect(1, 125280, '\p{^Script_Extensions= 	Adlam}', "");
    Expect(1, 125280, '\P{Script_Extensions= 	Adlam}', "");
    Expect(0, 125280, '\P{^Script_Extensions= 	Adlam}', "");
    Error('\p{Scx=-	ADLM:=}');
    Error('\P{Scx=-	ADLM:=}');
    Expect(1, 125279, '\p{Scx=:\AAdlm\z:}', "");;
    Expect(0, 125280, '\p{Scx=:\AAdlm\z:}', "");;
    Expect(1, 125279, '\p{Scx=adlm}', "");
    Expect(0, 125279, '\p{^Scx=adlm}', "");
    Expect(0, 125279, '\P{Scx=adlm}', "");
    Expect(1, 125279, '\P{^Scx=adlm}', "");
    Expect(0, 125280, '\p{Scx=adlm}', "");
    Expect(1, 125280, '\p{^Scx=adlm}', "");
    Expect(1, 125280, '\P{Scx=adlm}', "");
    Expect(0, 125280, '\P{^Scx=adlm}', "");
    Expect(1, 125279, '\p{Scx=:\Aadlm\z:}', "");;
    Expect(0, 125280, '\p{Scx=:\Aadlm\z:}', "");;
    Expect(1, 125279, '\p{Scx= _adlm}', "");
    Expect(0, 125279, '\p{^Scx= _adlm}', "");
    Expect(0, 125279, '\P{Scx= _adlm}', "");
    Expect(1, 125279, '\P{^Scx= _adlm}', "");
    Expect(0, 125280, '\p{Scx= _adlm}', "");
    Expect(1, 125280, '\p{^Scx= _adlm}', "");
    Expect(1, 125280, '\P{Scx= _adlm}', "");
    Expect(0, 125280, '\P{^Scx= _adlm}', "");
    Error('\p{Is_Script_Extensions=-ADLAM:=}');
    Error('\P{Is_Script_Extensions=-ADLAM:=}');
    Expect(1, 125279, '\p{Is_Script_Extensions=adlam}', "");
    Expect(0, 125279, '\p{^Is_Script_Extensions=adlam}', "");
    Expect(0, 125279, '\P{Is_Script_Extensions=adlam}', "");
    Expect(1, 125279, '\P{^Is_Script_Extensions=adlam}', "");
    Expect(0, 125280, '\p{Is_Script_Extensions=adlam}', "");
    Expect(1, 125280, '\p{^Is_Script_Extensions=adlam}', "");
    Expect(1, 125280, '\P{Is_Script_Extensions=adlam}', "");
    Expect(0, 125280, '\P{^Is_Script_Extensions=adlam}', "");
    Expect(1, 125279, '\p{Is_Script_Extensions=	_Adlam}', "");
    Expect(0, 125279, '\p{^Is_Script_Extensions=	_Adlam}', "");
    Expect(0, 125279, '\P{Is_Script_Extensions=	_Adlam}', "");
    Expect(1, 125279, '\P{^Is_Script_Extensions=	_Adlam}', "");
    Expect(0, 125280, '\p{Is_Script_Extensions=	_Adlam}', "");
    Expect(1, 125280, '\p{^Is_Script_Extensions=	_Adlam}', "");
    Expect(1, 125280, '\P{Is_Script_Extensions=	_Adlam}', "");
    Expect(0, 125280, '\P{^Is_Script_Extensions=	_Adlam}', "");
    Error('\p{Is_Scx=_Adlm:=}');
    Error('\P{Is_Scx=_Adlm:=}');
    Expect(1, 125279, '\p{Is_Scx=adlm}', "");
    Expect(0, 125279, '\p{^Is_Scx=adlm}', "");
    Expect(0, 125279, '\P{Is_Scx=adlm}', "");
    Expect(1, 125279, '\P{^Is_Scx=adlm}', "");
    Expect(0, 125280, '\p{Is_Scx=adlm}', "");
    Expect(1, 125280, '\p{^Is_Scx=adlm}', "");
    Expect(1, 125280, '\P{Is_Scx=adlm}', "");
    Expect(0, 125280, '\P{^Is_Scx=adlm}', "");
    Expect(1, 125279, '\p{Is_Scx=	 ADLM}', "");
    Expect(0, 125279, '\p{^Is_Scx=	 ADLM}', "");
    Expect(0, 125279, '\P{Is_Scx=	 ADLM}', "");
    Expect(1, 125279, '\P{^Is_Scx=	 ADLM}', "");
    Expect(0, 125280, '\p{Is_Scx=	 ADLM}', "");
    Expect(1, 125280, '\p{^Is_Scx=	 ADLM}', "");
    Expect(1, 125280, '\P{Is_Scx=	 ADLM}', "");
    Expect(0, 125280, '\P{^Is_Scx=	 ADLM}', "");
    Error('\p{Script_Extensions=-:=CAUCASIAN_albanian}');
    Error('\P{Script_Extensions=-:=CAUCASIAN_albanian}');
    Expect(1, 66927, '\p{Script_Extensions=:\ACaucasian_Albanian\z:}', "");;
    Expect(0, 66928, '\p{Script_Extensions=:\ACaucasian_Albanian\z:}', "");;
    Expect(1, 66927, '\p{Script_Extensions=caucasianalbanian}', "");
    Expect(0, 66927, '\p{^Script_Extensions=caucasianalbanian}', "");
    Expect(0, 66927, '\P{Script_Extensions=caucasianalbanian}', "");
    Expect(1, 66927, '\P{^Script_Extensions=caucasianalbanian}', "");
    Expect(0, 66928, '\p{Script_Extensions=caucasianalbanian}', "");
    Expect(1, 66928, '\p{^Script_Extensions=caucasianalbanian}', "");
    Expect(1, 66928, '\P{Script_Extensions=caucasianalbanian}', "");
    Expect(0, 66928, '\P{^Script_Extensions=caucasianalbanian}', "");
    Expect(1, 66927, '\p{Script_Extensions=:\Acaucasianalbanian\z:}', "");;
    Expect(0, 66928, '\p{Script_Extensions=:\Acaucasianalbanian\z:}', "");;
    Expect(1, 66927, '\p{Script_Extensions= _Caucasian_Albanian}', "");
    Expect(0, 66927, '\p{^Script_Extensions= _Caucasian_Albanian}', "");
    Expect(0, 66927, '\P{Script_Extensions= _Caucasian_Albanian}', "");
    Expect(1, 66927, '\P{^Script_Extensions= _Caucasian_Albanian}', "");
    Expect(0, 66928, '\p{Script_Extensions= _Caucasian_Albanian}', "");
    Expect(1, 66928, '\p{^Script_Extensions= _Caucasian_Albanian}', "");
    Expect(1, 66928, '\P{Script_Extensions= _Caucasian_Albanian}', "");
    Expect(0, 66928, '\P{^Script_Extensions= _Caucasian_Albanian}', "");
    Error('\p{Scx=/a/Aghb}');
    Error('\P{Scx=/a/Aghb}');
    Expect(1, 66927, '\p{Scx=:\AAghb\z:}', "");;
    Expect(0, 66928, '\p{Scx=:\AAghb\z:}', "");;
    Expect(1, 66927, '\p{Scx=aghb}', "");
    Expect(0, 66927, '\p{^Scx=aghb}', "");
    Expect(0, 66927, '\P{Scx=aghb}', "");
    Expect(1, 66927, '\P{^Scx=aghb}', "");
    Expect(0, 66928, '\p{Scx=aghb}', "");
    Expect(1, 66928, '\p{^Scx=aghb}', "");
    Expect(1, 66928, '\P{Scx=aghb}', "");
    Expect(0, 66928, '\P{^Scx=aghb}', "");
    Expect(1, 66927, '\p{Scx=:\Aaghb\z:}', "");;
    Expect(0, 66928, '\p{Scx=:\Aaghb\z:}', "");;
    Expect(1, 66927, '\p{Scx=AGHB}', "");
    Expect(0, 66927, '\p{^Scx=AGHB}', "");
    Expect(0, 66927, '\P{Scx=AGHB}', "");
    Expect(1, 66927, '\P{^Scx=AGHB}', "");
    Expect(0, 66928, '\p{Scx=AGHB}', "");
    Expect(1, 66928, '\p{^Scx=AGHB}', "");
    Expect(1, 66928, '\P{Scx=AGHB}', "");
    Expect(0, 66928, '\P{^Scx=AGHB}', "");
    Error('\p{Is_Script_Extensions:	/a/-	Caucasian_ALBANIAN}');
    Error('\P{Is_Script_Extensions:	/a/-	Caucasian_ALBANIAN}');
    Expect(1, 66927, '\p{Is_Script_Extensions=caucasianalbanian}', "");
    Expect(0, 66927, '\p{^Is_Script_Extensions=caucasianalbanian}', "");
    Expect(0, 66927, '\P{Is_Script_Extensions=caucasianalbanian}', "");
    Expect(1, 66927, '\P{^Is_Script_Extensions=caucasianalbanian}', "");
    Expect(0, 66928, '\p{Is_Script_Extensions=caucasianalbanian}', "");
    Expect(1, 66928, '\p{^Is_Script_Extensions=caucasianalbanian}', "");
    Expect(1, 66928, '\P{Is_Script_Extensions=caucasianalbanian}', "");
    Expect(0, 66928, '\P{^Is_Script_Extensions=caucasianalbanian}', "");
    Expect(1, 66927, '\p{Is_Script_Extensions= -Caucasian_Albanian}', "");
    Expect(0, 66927, '\p{^Is_Script_Extensions= -Caucasian_Albanian}', "");
    Expect(0, 66927, '\P{Is_Script_Extensions= -Caucasian_Albanian}', "");
    Expect(1, 66927, '\P{^Is_Script_Extensions= -Caucasian_Albanian}', "");
    Expect(0, 66928, '\p{Is_Script_Extensions= -Caucasian_Albanian}', "");
    Expect(1, 66928, '\p{^Is_Script_Extensions= -Caucasian_Albanian}', "");
    Expect(1, 66928, '\P{Is_Script_Extensions= -Caucasian_Albanian}', "");
    Expect(0, 66928, '\P{^Is_Script_Extensions= -Caucasian_Albanian}', "");
    Error('\p{Is_Scx=_/a/Aghb}');
    Error('\P{Is_Scx=_/a/Aghb}');
    Expect(1, 66927, '\p{Is_Scx=aghb}', "");
    Expect(0, 66927, '\p{^Is_Scx=aghb}', "");
    Expect(0, 66927, '\P{Is_Scx=aghb}', "");
    Expect(1, 66927, '\P{^Is_Scx=aghb}', "");
    Expect(0, 66928, '\p{Is_Scx=aghb}', "");
    Expect(1, 66928, '\p{^Is_Scx=aghb}', "");
    Expect(1, 66928, '\P{Is_Scx=aghb}', "");
    Expect(0, 66928, '\P{^Is_Scx=aghb}', "");
    Expect(1, 66927, '\p{Is_Scx:  _Aghb}', "");
    Expect(0, 66927, '\p{^Is_Scx:  _Aghb}', "");
    Expect(0, 66927, '\P{Is_Scx:  _Aghb}', "");
    Expect(1, 66927, '\P{^Is_Scx:  _Aghb}', "");
    Expect(0, 66928, '\p{Is_Scx:  _Aghb}', "");
    Expect(1, 66928, '\p{^Is_Scx:  _Aghb}', "");
    Expect(1, 66928, '\P{Is_Scx:  _Aghb}', "");
    Expect(0, 66928, '\P{^Is_Scx:  _Aghb}', "");
    Error('\p{Script_Extensions=	ahom/a/}');
    Error('\P{Script_Extensions=	ahom/a/}');
    Expect(1, 71494, '\p{Script_Extensions=:\AAhom\z:}', "");;
    Expect(0, 71495, '\p{Script_Extensions=:\AAhom\z:}', "");;
    Expect(1, 71494, '\p{Script_Extensions=ahom}', "");
    Expect(0, 71494, '\p{^Script_Extensions=ahom}', "");
    Expect(0, 71494, '\P{Script_Extensions=ahom}', "");
    Expect(1, 71494, '\P{^Script_Extensions=ahom}', "");
    Expect(0, 71495, '\p{Script_Extensions=ahom}', "");
    Expect(1, 71495, '\p{^Script_Extensions=ahom}', "");
    Expect(1, 71495, '\P{Script_Extensions=ahom}', "");
    Expect(0, 71495, '\P{^Script_Extensions=ahom}', "");
    Expect(1, 71494, '\p{Script_Extensions=:\Aahom\z:}', "");;
    Expect(0, 71495, '\p{Script_Extensions=:\Aahom\z:}', "");;
    Expect(1, 71494, '\p{Script_Extensions:   -	ahom}', "");
    Expect(0, 71494, '\p{^Script_Extensions:   -	ahom}', "");
    Expect(0, 71494, '\P{Script_Extensions:   -	ahom}', "");
    Expect(1, 71494, '\P{^Script_Extensions:   -	ahom}', "");
    Expect(0, 71495, '\p{Script_Extensions:   -	ahom}', "");
    Expect(1, 71495, '\p{^Script_Extensions:   -	ahom}', "");
    Expect(1, 71495, '\P{Script_Extensions:   -	ahom}', "");
    Expect(0, 71495, '\P{^Script_Extensions:   -	ahom}', "");
    Error('\p{Scx=/a/-Ahom}');
    Error('\P{Scx=/a/-Ahom}');
    Expect(1, 71494, '\p{Scx=:\AAhom\z:}', "");;
    Expect(0, 71495, '\p{Scx=:\AAhom\z:}', "");;
    Expect(1, 71494, '\p{Scx=ahom}', "");
    Expect(0, 71494, '\p{^Scx=ahom}', "");
    Expect(0, 71494, '\P{Scx=ahom}', "");
    Expect(1, 71494, '\P{^Scx=ahom}', "");
    Expect(0, 71495, '\p{Scx=ahom}', "");
    Expect(1, 71495, '\p{^Scx=ahom}', "");
    Expect(1, 71495, '\P{Scx=ahom}', "");
    Expect(0, 71495, '\P{^Scx=ahom}', "");
    Expect(1, 71494, '\p{Scx=:\Aahom\z:}', "");;
    Expect(0, 71495, '\p{Scx=:\Aahom\z:}', "");;
    Expect(1, 71494, '\p{Scx:   -	ahom}', "");
    Expect(0, 71494, '\p{^Scx:   -	ahom}', "");
    Expect(0, 71494, '\P{Scx:   -	ahom}', "");
    Expect(1, 71494, '\P{^Scx:   -	ahom}', "");
    Expect(0, 71495, '\p{Scx:   -	ahom}', "");
    Expect(1, 71495, '\p{^Scx:   -	ahom}', "");
    Expect(1, 71495, '\P{Scx:   -	ahom}', "");
    Expect(0, 71495, '\P{^Scx:   -	ahom}', "");
    Error('\p{Is_Script_Extensions=/a/_Ahom}');
    Error('\P{Is_Script_Extensions=/a/_Ahom}');
    Expect(1, 71494, '\p{Is_Script_Extensions: ahom}', "");
    Expect(0, 71494, '\p{^Is_Script_Extensions: ahom}', "");
    Expect(0, 71494, '\P{Is_Script_Extensions: ahom}', "");
    Expect(1, 71494, '\P{^Is_Script_Extensions: ahom}', "");
    Expect(0, 71495, '\p{Is_Script_Extensions: ahom}', "");
    Expect(1, 71495, '\p{^Is_Script_Extensions: ahom}', "");
    Expect(1, 71495, '\P{Is_Script_Extensions: ahom}', "");
    Expect(0, 71495, '\P{^Is_Script_Extensions: ahom}', "");
    Expect(1, 71494, '\p{Is_Script_Extensions=  Ahom}', "");
    Expect(0, 71494, '\p{^Is_Script_Extensions=  Ahom}', "");
    Expect(0, 71494, '\P{Is_Script_Extensions=  Ahom}', "");
    Expect(1, 71494, '\P{^Is_Script_Extensions=  Ahom}', "");
    Expect(0, 71495, '\p{Is_Script_Extensions=  Ahom}', "");
    Expect(1, 71495, '\p{^Is_Script_Extensions=  Ahom}', "");
    Expect(1, 71495, '\P{Is_Script_Extensions=  Ahom}', "");
    Expect(0, 71495, '\P{^Is_Script_Extensions=  Ahom}', "");
    Error('\p{Is_Scx=:=_	AHOM}');
    Error('\P{Is_Scx=:=_	AHOM}');
    Expect(1, 71494, '\p{Is_Scx=ahom}', "");
    Expect(0, 71494, '\p{^Is_Scx=ahom}', "");
    Expect(0, 71494, '\P{Is_Scx=ahom}', "");
    Expect(1, 71494, '\P{^Is_Scx=ahom}', "");
    Expect(0, 71495, '\p{Is_Scx=ahom}', "");
    Expect(1, 71495, '\p{^Is_Scx=ahom}', "");
    Expect(1, 71495, '\P{Is_Scx=ahom}', "");
    Expect(0, 71495, '\P{^Is_Scx=ahom}', "");
    Expect(1, 71494, '\p{Is_Scx=_	ahom}', "");
    Expect(0, 71494, '\p{^Is_Scx=_	ahom}', "");
    Expect(0, 71494, '\P{Is_Scx=_	ahom}', "");
    Expect(1, 71494, '\P{^Is_Scx=_	ahom}', "");
    Expect(0, 71495, '\p{Is_Scx=_	ahom}', "");
    Expect(1, 71495, '\p{^Is_Scx=_	ahom}', "");
    Expect(1, 71495, '\P{Is_Scx=_	ahom}', "");
    Expect(0, 71495, '\P{^Is_Scx=_	ahom}', "");
    Error('\p{Script_Extensions=-:=arabic}');
    Error('\P{Script_Extensions=-:=arabic}');
    Expect(1, 126705, '\p{Script_Extensions=:\AArabic\z:}', "");;
    Expect(0, 126706, '\p{Script_Extensions=:\AArabic\z:}', "");;
    Expect(1, 126705, '\p{Script_Extensions:arabic}', "");
    Expect(0, 126705, '\p{^Script_Extensions:arabic}', "");
    Expect(0, 126705, '\P{Script_Extensions:arabic}', "");
    Expect(1, 126705, '\P{^Script_Extensions:arabic}', "");
    Expect(0, 126706, '\p{Script_Extensions:arabic}', "");
    Expect(1, 126706, '\p{^Script_Extensions:arabic}', "");
    Expect(1, 126706, '\P{Script_Extensions:arabic}', "");
    Expect(0, 126706, '\P{^Script_Extensions:arabic}', "");
    Expect(1, 126705, '\p{Script_Extensions=:\Aarabic\z:}', "");;
    Expect(0, 126706, '\p{Script_Extensions=:\Aarabic\z:}', "");;
    Expect(1, 126705, '\p{Script_Extensions:  _Arabic}', "");
    Expect(0, 126705, '\p{^Script_Extensions:  _Arabic}', "");
    Expect(0, 126705, '\P{Script_Extensions:  _Arabic}', "");
    Expect(1, 126705, '\P{^Script_Extensions:  _Arabic}', "");
    Expect(0, 126706, '\p{Script_Extensions:  _Arabic}', "");
    Expect(1, 126706, '\p{^Script_Extensions:  _Arabic}', "");
    Expect(1, 126706, '\P{Script_Extensions:  _Arabic}', "");
    Expect(0, 126706, '\P{^Script_Extensions:  _Arabic}', "");
    Error('\p{Scx=_:=ARAB}');
    Error('\P{Scx=_:=ARAB}');
    Expect(1, 126705, '\p{Scx=:\AArab\z:}', "");;
    Expect(0, 126706, '\p{Scx=:\AArab\z:}', "");;
    Expect(1, 126705, '\p{Scx=arab}', "");
    Expect(0, 126705, '\p{^Scx=arab}', "");
    Expect(0, 126705, '\P{Scx=arab}', "");
    Expect(1, 126705, '\P{^Scx=arab}', "");
    Expect(0, 126706, '\p{Scx=arab}', "");
    Expect(1, 126706, '\p{^Scx=arab}', "");
    Expect(1, 126706, '\P{Scx=arab}', "");
    Expect(0, 126706, '\P{^Scx=arab}', "");
    Expect(1, 126705, '\p{Scx=:\Aarab\z:}', "");;
    Expect(0, 126706, '\p{Scx=:\Aarab\z:}', "");;
    Expect(1, 126705, '\p{Scx=-	ARAB}', "");
    Expect(0, 126705, '\p{^Scx=-	ARAB}', "");
    Expect(0, 126705, '\P{Scx=-	ARAB}', "");
    Expect(1, 126705, '\P{^Scx=-	ARAB}', "");
    Expect(0, 126706, '\p{Scx=-	ARAB}', "");
    Expect(1, 126706, '\p{^Scx=-	ARAB}', "");
    Expect(1, 126706, '\P{Scx=-	ARAB}', "");
    Expect(0, 126706, '\P{^Scx=-	ARAB}', "");
    Error('\p{Is_Script_Extensions=_-Arabic:=}');
    Error('\P{Is_Script_Extensions=_-Arabic:=}');
    Expect(1, 126705, '\p{Is_Script_Extensions=arabic}', "");
    Expect(0, 126705, '\p{^Is_Script_Extensions=arabic}', "");
    Expect(0, 126705, '\P{Is_Script_Extensions=arabic}', "");
    Expect(1, 126705, '\P{^Is_Script_Extensions=arabic}', "");
    Expect(0, 126706, '\p{Is_Script_Extensions=arabic}', "");
    Expect(1, 126706, '\p{^Is_Script_Extensions=arabic}', "");
    Expect(1, 126706, '\P{Is_Script_Extensions=arabic}', "");
    Expect(0, 126706, '\P{^Is_Script_Extensions=arabic}', "");
    Expect(1, 126705, '\p{Is_Script_Extensions=-Arabic}', "");
    Expect(0, 126705, '\p{^Is_Script_Extensions=-Arabic}', "");
    Expect(0, 126705, '\P{Is_Script_Extensions=-Arabic}', "");
    Expect(1, 126705, '\P{^Is_Script_Extensions=-Arabic}', "");
    Expect(0, 126706, '\p{Is_Script_Extensions=-Arabic}', "");
    Expect(1, 126706, '\p{^Is_Script_Extensions=-Arabic}', "");
    Expect(1, 126706, '\P{Is_Script_Extensions=-Arabic}', "");
    Expect(0, 126706, '\P{^Is_Script_Extensions=-Arabic}', "");
    Error('\p{Is_Scx= /a/ARAB}');
    Error('\P{Is_Scx= /a/ARAB}');
    Expect(1, 126705, '\p{Is_Scx=arab}', "");
    Expect(0, 126705, '\p{^Is_Scx=arab}', "");
    Expect(0, 126705, '\P{Is_Scx=arab}', "");
    Expect(1, 126705, '\P{^Is_Scx=arab}', "");
    Expect(0, 126706, '\p{Is_Scx=arab}', "");
    Expect(1, 126706, '\p{^Is_Scx=arab}', "");
    Expect(1, 126706, '\P{Is_Scx=arab}', "");
    Expect(0, 126706, '\P{^Is_Scx=arab}', "");
    Expect(1, 126705, '\p{Is_Scx=  ARAB}', "");
    Expect(0, 126705, '\p{^Is_Scx=  ARAB}', "");
    Expect(0, 126705, '\P{Is_Scx=  ARAB}', "");
    Expect(1, 126705, '\P{^Is_Scx=  ARAB}', "");
    Expect(0, 126706, '\p{Is_Scx=  ARAB}', "");
    Expect(1, 126706, '\p{^Is_Scx=  ARAB}', "");
    Expect(1, 126706, '\P{Is_Scx=  ARAB}', "");
    Expect(0, 126706, '\P{^Is_Scx=  ARAB}', "");
    Error('\p{Script_Extensions=_/a/IMPERIAL_Aramaic}');
    Error('\P{Script_Extensions=_/a/IMPERIAL_Aramaic}');
    Expect(1, 67679, '\p{Script_Extensions=:\AImperial_Aramaic\z:}', "");;
    Expect(0, 67680, '\p{Script_Extensions=:\AImperial_Aramaic\z:}', "");;
    Expect(1, 67679, '\p{Script_Extensions=imperialaramaic}', "");
    Expect(0, 67679, '\p{^Script_Extensions=imperialaramaic}', "");
    Expect(0, 67679, '\P{Script_Extensions=imperialaramaic}', "");
    Expect(1, 67679, '\P{^Script_Extensions=imperialaramaic}', "");
    Expect(0, 67680, '\p{Script_Extensions=imperialaramaic}', "");
    Expect(1, 67680, '\p{^Script_Extensions=imperialaramaic}', "");
    Expect(1, 67680, '\P{Script_Extensions=imperialaramaic}', "");
    Expect(0, 67680, '\P{^Script_Extensions=imperialaramaic}', "");
    Expect(1, 67679, '\p{Script_Extensions=:\Aimperialaramaic\z:}', "");;
    Expect(0, 67680, '\p{Script_Extensions=:\Aimperialaramaic\z:}', "");;
    Expect(1, 67679, '\p{Script_Extensions=_Imperial_ARAMAIC}', "");
    Expect(0, 67679, '\p{^Script_Extensions=_Imperial_ARAMAIC}', "");
    Expect(0, 67679, '\P{Script_Extensions=_Imperial_ARAMAIC}', "");
    Expect(1, 67679, '\P{^Script_Extensions=_Imperial_ARAMAIC}', "");
    Expect(0, 67680, '\p{Script_Extensions=_Imperial_ARAMAIC}', "");
    Expect(1, 67680, '\p{^Script_Extensions=_Imperial_ARAMAIC}', "");
    Expect(1, 67680, '\P{Script_Extensions=_Imperial_ARAMAIC}', "");
    Expect(0, 67680, '\P{^Script_Extensions=_Imperial_ARAMAIC}', "");
    Error('\p{Scx=:=	 Armi}');
    Error('\P{Scx=:=	 Armi}');
    Expect(1, 67679, '\p{Scx=:\AArmi\z:}', "");;
    Expect(0, 67680, '\p{Scx=:\AArmi\z:}', "");;
    Expect(1, 67679, '\p{Scx=armi}', "");
    Expect(0, 67679, '\p{^Scx=armi}', "");
    Expect(0, 67679, '\P{Scx=armi}', "");
    Expect(1, 67679, '\P{^Scx=armi}', "");
    Expect(0, 67680, '\p{Scx=armi}', "");
    Expect(1, 67680, '\p{^Scx=armi}', "");
    Expect(1, 67680, '\P{Scx=armi}', "");
    Expect(0, 67680, '\P{^Scx=armi}', "");
    Expect(1, 67679, '\p{Scx=:\Aarmi\z:}', "");;
    Expect(0, 67680, '\p{Scx=:\Aarmi\z:}', "");;
    Expect(1, 67679, '\p{Scx=_-ARMI}', "");
    Expect(0, 67679, '\p{^Scx=_-ARMI}', "");
    Expect(0, 67679, '\P{Scx=_-ARMI}', "");
    Expect(1, 67679, '\P{^Scx=_-ARMI}', "");
    Expect(0, 67680, '\p{Scx=_-ARMI}', "");
    Expect(1, 67680, '\p{^Scx=_-ARMI}', "");
    Expect(1, 67680, '\P{Scx=_-ARMI}', "");
    Expect(0, 67680, '\P{^Scx=_-ARMI}', "");
    Error('\p{Is_Script_Extensions=_/a/imperial_Aramaic}');
    Error('\P{Is_Script_Extensions=_/a/imperial_Aramaic}');
    Expect(1, 67679, '\p{Is_Script_Extensions=imperialaramaic}', "");
    Expect(0, 67679, '\p{^Is_Script_Extensions=imperialaramaic}', "");
    Expect(0, 67679, '\P{Is_Script_Extensions=imperialaramaic}', "");
    Expect(1, 67679, '\P{^Is_Script_Extensions=imperialaramaic}', "");
    Expect(0, 67680, '\p{Is_Script_Extensions=imperialaramaic}', "");
    Expect(1, 67680, '\p{^Is_Script_Extensions=imperialaramaic}', "");
    Expect(1, 67680, '\P{Is_Script_Extensions=imperialaramaic}', "");
    Expect(0, 67680, '\P{^Is_Script_Extensions=imperialaramaic}', "");
    Expect(1, 67679, '\p{Is_Script_Extensions=__imperial_aramaic}', "");
    Expect(0, 67679, '\p{^Is_Script_Extensions=__imperial_aramaic}', "");
    Expect(0, 67679, '\P{Is_Script_Extensions=__imperial_aramaic}', "");
    Expect(1, 67679, '\P{^Is_Script_Extensions=__imperial_aramaic}', "");
    Expect(0, 67680, '\p{Is_Script_Extensions=__imperial_aramaic}', "");
    Expect(1, 67680, '\p{^Is_Script_Extensions=__imperial_aramaic}', "");
    Expect(1, 67680, '\P{Is_Script_Extensions=__imperial_aramaic}', "");
    Expect(0, 67680, '\P{^Is_Script_Extensions=__imperial_aramaic}', "");
    Error('\p{Is_Scx=-Armi:=}');
    Error('\P{Is_Scx=-Armi:=}');
    Expect(1, 67679, '\p{Is_Scx=armi}', "");
    Expect(0, 67679, '\p{^Is_Scx=armi}', "");
    Expect(0, 67679, '\P{Is_Scx=armi}', "");
    Expect(1, 67679, '\P{^Is_Scx=armi}', "");
    Expect(0, 67680, '\p{Is_Scx=armi}', "");
    Expect(1, 67680, '\p{^Is_Scx=armi}', "");
    Expect(1, 67680, '\P{Is_Scx=armi}', "");
    Expect(0, 67680, '\P{^Is_Scx=armi}', "");
    Expect(1, 67679, '\p{Is_Scx= Armi}', "");
    Expect(0, 67679, '\p{^Is_Scx= Armi}', "");
    Expect(0, 67679, '\P{Is_Scx= Armi}', "");
    Expect(1, 67679, '\P{^Is_Scx= Armi}', "");
    Expect(0, 67680, '\p{Is_Scx= Armi}', "");
    Expect(1, 67680, '\p{^Is_Scx= Armi}', "");
    Expect(1, 67680, '\P{Is_Scx= Armi}', "");
    Expect(0, 67680, '\P{^Is_Scx= Armi}', "");
    Error('\p{Script_Extensions=/a/-Armenian}');
    Error('\P{Script_Extensions=/a/-Armenian}');
    Expect(1, 64279, '\p{Script_Extensions=:\AArmenian\z:}', "");;
    Expect(0, 64280, '\p{Script_Extensions=:\AArmenian\z:}', "");;
    Expect(1, 64279, '\p{Script_Extensions=armenian}', "");
    Expect(0, 64279, '\p{^Script_Extensions=armenian}', "");
    Expect(0, 64279, '\P{Script_Extensions=armenian}', "");
    Expect(1, 64279, '\P{^Script_Extensions=armenian}', "");
    Expect(0, 64280, '\p{Script_Extensions=armenian}', "");
    Expect(1, 64280, '\p{^Script_Extensions=armenian}', "");
    Expect(1, 64280, '\P{Script_Extensions=armenian}', "");
    Expect(0, 64280, '\P{^Script_Extensions=armenian}', "");
    Expect(1, 64279, '\p{Script_Extensions=:\Aarmenian\z:}', "");;
    Expect(0, 64280, '\p{Script_Extensions=:\Aarmenian\z:}', "");;
    Expect(1, 64279, '\p{Script_Extensions=__armenian}', "");
    Expect(0, 64279, '\p{^Script_Extensions=__armenian}', "");
    Expect(0, 64279, '\P{Script_Extensions=__armenian}', "");
    Expect(1, 64279, '\P{^Script_Extensions=__armenian}', "");
    Expect(0, 64280, '\p{Script_Extensions=__armenian}', "");
    Expect(1, 64280, '\p{^Script_Extensions=__armenian}', "");
    Expect(1, 64280, '\P{Script_Extensions=__armenian}', "");
    Expect(0, 64280, '\P{^Script_Extensions=__armenian}', "");
    Error('\p{Scx=:=_ armn}');
    Error('\P{Scx=:=_ armn}');
    Expect(1, 64279, '\p{Scx=:\AArmn\z:}', "");;
    Expect(0, 64280, '\p{Scx=:\AArmn\z:}', "");;
    Expect(1, 64279, '\p{Scx=armn}', "");
    Expect(0, 64279, '\p{^Scx=armn}', "");
    Expect(0, 64279, '\P{Scx=armn}', "");
    Expect(1, 64279, '\P{^Scx=armn}', "");
    Expect(0, 64280, '\p{Scx=armn}', "");
    Expect(1, 64280, '\p{^Scx=armn}', "");
    Expect(1, 64280, '\P{Scx=armn}', "");
    Expect(0, 64280, '\P{^Scx=armn}', "");
    Expect(1, 64279, '\p{Scx=:\Aarmn\z:}', "");;
    Expect(0, 64280, '\p{Scx=:\Aarmn\z:}', "");;
    Expect(1, 64279, '\p{Scx: 	 armn}', "");
    Expect(0, 64279, '\p{^Scx: 	 armn}', "");
    Expect(0, 64279, '\P{Scx: 	 armn}', "");
    Expect(1, 64279, '\P{^Scx: 	 armn}', "");
    Expect(0, 64280, '\p{Scx: 	 armn}', "");
    Expect(1, 64280, '\p{^Scx: 	 armn}', "");
    Expect(1, 64280, '\P{Scx: 	 armn}', "");
    Expect(0, 64280, '\P{^Scx: 	 armn}', "");
    Error('\p{Is_Script_Extensions=_:=Armenian}');
    Error('\P{Is_Script_Extensions=_:=Armenian}');
    Expect(1, 64279, '\p{Is_Script_Extensions:	armenian}', "");
    Expect(0, 64279, '\p{^Is_Script_Extensions:	armenian}', "");
    Expect(0, 64279, '\P{Is_Script_Extensions:	armenian}', "");
    Expect(1, 64279, '\P{^Is_Script_Extensions:	armenian}', "");
    Expect(0, 64280, '\p{Is_Script_Extensions:	armenian}', "");
    Expect(1, 64280, '\p{^Is_Script_Extensions:	armenian}', "");
    Expect(1, 64280, '\P{Is_Script_Extensions:	armenian}', "");
    Expect(0, 64280, '\P{^Is_Script_Extensions:	armenian}', "");
    Expect(1, 64279, '\p{Is_Script_Extensions=_	ARMENIAN}', "");
    Expect(0, 64279, '\p{^Is_Script_Extensions=_	ARMENIAN}', "");
    Expect(0, 64279, '\P{Is_Script_Extensions=_	ARMENIAN}', "");
    Expect(1, 64279, '\P{^Is_Script_Extensions=_	ARMENIAN}', "");
    Expect(0, 64280, '\p{Is_Script_Extensions=_	ARMENIAN}', "");
    Expect(1, 64280, '\p{^Is_Script_Extensions=_	ARMENIAN}', "");
    Expect(1, 64280, '\P{Is_Script_Extensions=_	ARMENIAN}', "");
    Expect(0, 64280, '\P{^Is_Script_Extensions=_	ARMENIAN}', "");
    Error('\p{Is_Scx:	_armn/a/}');
    Error('\P{Is_Scx:	_armn/a/}');
    Expect(1, 64279, '\p{Is_Scx=armn}', "");
    Expect(0, 64279, '\p{^Is_Scx=armn}', "");
    Expect(0, 64279, '\P{Is_Scx=armn}', "");
    Expect(1, 64279, '\P{^Is_Scx=armn}', "");
    Expect(0, 64280, '\p{Is_Scx=armn}', "");
    Expect(1, 64280, '\p{^Is_Scx=armn}', "");
    Expect(1, 64280, '\P{Is_Scx=armn}', "");
    Expect(0, 64280, '\P{^Is_Scx=armn}', "");
    Expect(1, 64279, '\p{Is_Scx=__ARMN}', "");
    Expect(0, 64279, '\p{^Is_Scx=__ARMN}', "");
    Expect(0, 64279, '\P{Is_Scx=__ARMN}', "");
    Expect(1, 64279, '\P{^Is_Scx=__ARMN}', "");
    Expect(0, 64280, '\p{Is_Scx=__ARMN}', "");
    Expect(1, 64280, '\p{^Is_Scx=__ARMN}', "");
    Expect(1, 64280, '\P{Is_Scx=__ARMN}', "");
    Expect(0, 64280, '\P{^Is_Scx=__ARMN}', "");
    Error('\p{Script_Extensions= 	avestan:=}');
    Error('\P{Script_Extensions= 	avestan:=}');
    Expect(1, 68415, '\p{Script_Extensions=:\AAvestan\z:}', "");;
    Expect(0, 68416, '\p{Script_Extensions=:\AAvestan\z:}', "");;
    Expect(1, 68415, '\p{Script_Extensions=avestan}', "");
    Expect(0, 68415, '\p{^Script_Extensions=avestan}', "");
    Expect(0, 68415, '\P{Script_Extensions=avestan}', "");
    Expect(1, 68415, '\P{^Script_Extensions=avestan}', "");
    Expect(0, 68416, '\p{Script_Extensions=avestan}', "");
    Expect(1, 68416, '\p{^Script_Extensions=avestan}', "");
    Expect(1, 68416, '\P{Script_Extensions=avestan}', "");
    Expect(0, 68416, '\P{^Script_Extensions=avestan}', "");
    Expect(1, 68415, '\p{Script_Extensions=:\Aavestan\z:}', "");;
    Expect(0, 68416, '\p{Script_Extensions=:\Aavestan\z:}', "");;
    Expect(1, 68415, '\p{Script_Extensions:-avestan}', "");
    Expect(0, 68415, '\p{^Script_Extensions:-avestan}', "");
    Expect(0, 68415, '\P{Script_Extensions:-avestan}', "");
    Expect(1, 68415, '\P{^Script_Extensions:-avestan}', "");
    Expect(0, 68416, '\p{Script_Extensions:-avestan}', "");
    Expect(1, 68416, '\p{^Script_Extensions:-avestan}', "");
    Expect(1, 68416, '\P{Script_Extensions:-avestan}', "");
    Expect(0, 68416, '\P{^Script_Extensions:-avestan}', "");
    Error('\p{Scx=/a/_Avst}');
    Error('\P{Scx=/a/_Avst}');
    Expect(1, 68415, '\p{Scx=:\AAvst\z:}', "");;
    Expect(0, 68416, '\p{Scx=:\AAvst\z:}', "");;
    Expect(1, 68415, '\p{Scx=avst}', "");
    Expect(0, 68415, '\p{^Scx=avst}', "");
    Expect(0, 68415, '\P{Scx=avst}', "");
    Expect(1, 68415, '\P{^Scx=avst}', "");
    Expect(0, 68416, '\p{Scx=avst}', "");
    Expect(1, 68416, '\p{^Scx=avst}', "");
    Expect(1, 68416, '\P{Scx=avst}', "");
    Expect(0, 68416, '\P{^Scx=avst}', "");
    Expect(1, 68415, '\p{Scx=:\Aavst\z:}', "");;
    Expect(0, 68416, '\p{Scx=:\Aavst\z:}', "");;
    Expect(1, 68415, '\p{Scx=_ Avst}', "");
    Expect(0, 68415, '\p{^Scx=_ Avst}', "");
    Expect(0, 68415, '\P{Scx=_ Avst}', "");
    Expect(1, 68415, '\P{^Scx=_ Avst}', "");
    Expect(0, 68416, '\p{Scx=_ Avst}', "");
    Expect(1, 68416, '\p{^Scx=_ Avst}', "");
    Expect(1, 68416, '\P{Scx=_ Avst}', "");
    Expect(0, 68416, '\P{^Scx=_ Avst}', "");
    Error('\p{Is_Script_Extensions= /a/avestan}');
    Error('\P{Is_Script_Extensions= /a/avestan}');
    Expect(1, 68415, '\p{Is_Script_Extensions:	avestan}', "");
    Expect(0, 68415, '\p{^Is_Script_Extensions:	avestan}', "");
    Expect(0, 68415, '\P{Is_Script_Extensions:	avestan}', "");
    Expect(1, 68415, '\P{^Is_Script_Extensions:	avestan}', "");
    Expect(0, 68416, '\p{Is_Script_Extensions:	avestan}', "");
    Expect(1, 68416, '\p{^Is_Script_Extensions:	avestan}', "");
    Expect(1, 68416, '\P{Is_Script_Extensions:	avestan}', "");
    Expect(0, 68416, '\P{^Is_Script_Extensions:	avestan}', "");
    Expect(1, 68415, '\p{Is_Script_Extensions= -Avestan}', "");
    Expect(0, 68415, '\p{^Is_Script_Extensions= -Avestan}', "");
    Expect(0, 68415, '\P{Is_Script_Extensions= -Avestan}', "");
    Expect(1, 68415, '\P{^Is_Script_Extensions= -Avestan}', "");
    Expect(0, 68416, '\p{Is_Script_Extensions= -Avestan}', "");
    Expect(1, 68416, '\p{^Is_Script_Extensions= -Avestan}', "");
    Expect(1, 68416, '\P{Is_Script_Extensions= -Avestan}', "");
    Expect(0, 68416, '\P{^Is_Script_Extensions= -Avestan}', "");
    Error('\p{Is_Scx=-	avst:=}');
    Error('\P{Is_Scx=-	avst:=}');
    Expect(1, 68415, '\p{Is_Scx=avst}', "");
    Expect(0, 68415, '\p{^Is_Scx=avst}', "");
    Expect(0, 68415, '\P{Is_Scx=avst}', "");
    Expect(1, 68415, '\P{^Is_Scx=avst}', "");
    Expect(0, 68416, '\p{Is_Scx=avst}', "");
    Expect(1, 68416, '\p{^Is_Scx=avst}', "");
    Expect(1, 68416, '\P{Is_Scx=avst}', "");
    Expect(0, 68416, '\P{^Is_Scx=avst}', "");
    Expect(1, 68415, '\p{Is_Scx=-_Avst}', "");
    Expect(0, 68415, '\p{^Is_Scx=-_Avst}', "");
    Expect(0, 68415, '\P{Is_Scx=-_Avst}', "");
    Expect(1, 68415, '\P{^Is_Scx=-_Avst}', "");
    Expect(0, 68416, '\p{Is_Scx=-_Avst}', "");
    Expect(1, 68416, '\p{^Is_Scx=-_Avst}', "");
    Expect(1, 68416, '\P{Is_Scx=-_Avst}', "");
    Expect(0, 68416, '\P{^Is_Scx=-_Avst}', "");
    Error('\p{Script_Extensions=-BALINESE/a/}');
    Error('\P{Script_Extensions=-BALINESE/a/}');
    Expect(1, 7038, '\p{Script_Extensions=:\ABalinese\z:}', "");;
    Expect(0, 7039, '\p{Script_Extensions=:\ABalinese\z:}', "");;
    Expect(1, 7038, '\p{Script_Extensions:	balinese}', "");
    Expect(0, 7038, '\p{^Script_Extensions:	balinese}', "");
    Expect(0, 7038, '\P{Script_Extensions:	balinese}', "");
    Expect(1, 7038, '\P{^Script_Extensions:	balinese}', "");
    Expect(0, 7039, '\p{Script_Extensions:	balinese}', "");
    Expect(1, 7039, '\p{^Script_Extensions:	balinese}', "");
    Expect(1, 7039, '\P{Script_Extensions:	balinese}', "");
    Expect(0, 7039, '\P{^Script_Extensions:	balinese}', "");
    Expect(1, 7038, '\p{Script_Extensions=:\Abalinese\z:}', "");;
    Expect(0, 7039, '\p{Script_Extensions=:\Abalinese\z:}', "");;
    Expect(1, 7038, '\p{Script_Extensions=- Balinese}', "");
    Expect(0, 7038, '\p{^Script_Extensions=- Balinese}', "");
    Expect(0, 7038, '\P{Script_Extensions=- Balinese}', "");
    Expect(1, 7038, '\P{^Script_Extensions=- Balinese}', "");
    Expect(0, 7039, '\p{Script_Extensions=- Balinese}', "");
    Expect(1, 7039, '\p{^Script_Extensions=- Balinese}', "");
    Expect(1, 7039, '\P{Script_Extensions=- Balinese}', "");
    Expect(0, 7039, '\P{^Script_Extensions=- Balinese}', "");
    Error('\p{Scx=/a/_-BALI}');
    Error('\P{Scx=/a/_-BALI}');
    Expect(1, 7038, '\p{Scx=:\ABali\z:}', "");;
    Expect(0, 7039, '\p{Scx=:\ABali\z:}', "");;
    Expect(1, 7038, '\p{Scx=bali}', "");
    Expect(0, 7038, '\p{^Scx=bali}', "");
    Expect(0, 7038, '\P{Scx=bali}', "");
    Expect(1, 7038, '\P{^Scx=bali}', "");
    Expect(0, 7039, '\p{Scx=bali}', "");
    Expect(1, 7039, '\p{^Scx=bali}', "");
    Expect(1, 7039, '\P{Scx=bali}', "");
    Expect(0, 7039, '\P{^Scx=bali}', "");
    Expect(1, 7038, '\p{Scx=:\Abali\z:}', "");;
    Expect(0, 7039, '\p{Scx=:\Abali\z:}', "");;
    Expect(1, 7038, '\p{Scx: 		Bali}', "");
    Expect(0, 7038, '\p{^Scx: 		Bali}', "");
    Expect(0, 7038, '\P{Scx: 		Bali}', "");
    Expect(1, 7038, '\P{^Scx: 		Bali}', "");
    Expect(0, 7039, '\p{Scx: 		Bali}', "");
    Expect(1, 7039, '\p{^Scx: 		Bali}', "");
    Expect(1, 7039, '\P{Scx: 		Bali}', "");
    Expect(0, 7039, '\P{^Scx: 		Bali}', "");
    Error('\p{Is_Script_Extensions=/a/_	Balinese}');
    Error('\P{Is_Script_Extensions=/a/_	Balinese}');
    Expect(1, 7038, '\p{Is_Script_Extensions=balinese}', "");
    Expect(0, 7038, '\p{^Is_Script_Extensions=balinese}', "");
    Expect(0, 7038, '\P{Is_Script_Extensions=balinese}', "");
    Expect(1, 7038, '\P{^Is_Script_Extensions=balinese}', "");
    Expect(0, 7039, '\p{Is_Script_Extensions=balinese}', "");
    Expect(1, 7039, '\p{^Is_Script_Extensions=balinese}', "");
    Expect(1, 7039, '\P{Is_Script_Extensions=balinese}', "");
    Expect(0, 7039, '\P{^Is_Script_Extensions=balinese}', "");
    Expect(1, 7038, '\p{Is_Script_Extensions=_-BALINESE}', "");
    Expect(0, 7038, '\p{^Is_Script_Extensions=_-BALINESE}', "");
    Expect(0, 7038, '\P{Is_Script_Extensions=_-BALINESE}', "");
    Expect(1, 7038, '\P{^Is_Script_Extensions=_-BALINESE}', "");
    Expect(0, 7039, '\p{Is_Script_Extensions=_-BALINESE}', "");
    Expect(1, 7039, '\p{^Is_Script_Extensions=_-BALINESE}', "");
    Expect(1, 7039, '\P{Is_Script_Extensions=_-BALINESE}', "");
    Expect(0, 7039, '\P{^Is_Script_Extensions=_-BALINESE}', "");
    Error('\p{Is_Scx=:= Bali}');
    Error('\P{Is_Scx=:= Bali}');
    Expect(1, 7038, '\p{Is_Scx=bali}', "");
    Expect(0, 7038, '\p{^Is_Scx=bali}', "");
    Expect(0, 7038, '\P{Is_Scx=bali}', "");
    Expect(1, 7038, '\P{^Is_Scx=bali}', "");
    Expect(0, 7039, '\p{Is_Scx=bali}', "");
    Expect(1, 7039, '\p{^Is_Scx=bali}', "");
    Expect(1, 7039, '\P{Is_Scx=bali}', "");
    Expect(0, 7039, '\P{^Is_Scx=bali}', "");
    Expect(1, 7038, '\p{Is_Scx=- bali}', "");
    Expect(0, 7038, '\p{^Is_Scx=- bali}', "");
    Expect(0, 7038, '\P{Is_Scx=- bali}', "");
    Expect(1, 7038, '\P{^Is_Scx=- bali}', "");
    Expect(0, 7039, '\p{Is_Scx=- bali}', "");
    Expect(1, 7039, '\p{^Is_Scx=- bali}', "");
    Expect(1, 7039, '\P{Is_Scx=- bali}', "");
    Expect(0, 7039, '\P{^Is_Scx=- bali}', "");
    Error('\p{Script_Extensions=/a/	 Bamum}');
    Error('\P{Script_Extensions=/a/	 Bamum}');
    Expect(1, 92728, '\p{Script_Extensions=:\ABamum\z:}', "");;
    Expect(0, 92729, '\p{Script_Extensions=:\ABamum\z:}', "");;
    Expect(1, 92728, '\p{Script_Extensions=bamum}', "");
    Expect(0, 92728, '\p{^Script_Extensions=bamum}', "");
    Expect(0, 92728, '\P{Script_Extensions=bamum}', "");
    Expect(1, 92728, '\P{^Script_Extensions=bamum}', "");
    Expect(0, 92729, '\p{Script_Extensions=bamum}', "");
    Expect(1, 92729, '\p{^Script_Extensions=bamum}', "");
    Expect(1, 92729, '\P{Script_Extensions=bamum}', "");
    Expect(0, 92729, '\P{^Script_Extensions=bamum}', "");
    Expect(1, 92728, '\p{Script_Extensions=:\Abamum\z:}', "");;
    Expect(0, 92729, '\p{Script_Extensions=:\Abamum\z:}', "");;
    Expect(1, 92728, '\p{Script_Extensions=_BAMUM}', "");
    Expect(0, 92728, '\p{^Script_Extensions=_BAMUM}', "");
    Expect(0, 92728, '\P{Script_Extensions=_BAMUM}', "");
    Expect(1, 92728, '\P{^Script_Extensions=_BAMUM}', "");
    Expect(0, 92729, '\p{Script_Extensions=_BAMUM}', "");
    Expect(1, 92729, '\p{^Script_Extensions=_BAMUM}', "");
    Expect(1, 92729, '\P{Script_Extensions=_BAMUM}', "");
    Expect(0, 92729, '\P{^Script_Extensions=_BAMUM}', "");
    Error('\p{Scx=:=Bamu}');
    Error('\P{Scx=:=Bamu}');
    Expect(1, 92728, '\p{Scx=:\ABamu\z:}', "");;
    Expect(0, 92729, '\p{Scx=:\ABamu\z:}', "");;
    Expect(1, 92728, '\p{Scx=bamu}', "");
    Expect(0, 92728, '\p{^Scx=bamu}', "");
    Expect(0, 92728, '\P{Scx=bamu}', "");
    Expect(1, 92728, '\P{^Scx=bamu}', "");
    Expect(0, 92729, '\p{Scx=bamu}', "");
    Expect(1, 92729, '\p{^Scx=bamu}', "");
    Expect(1, 92729, '\P{Scx=bamu}', "");
    Expect(0, 92729, '\P{^Scx=bamu}', "");
    Expect(1, 92728, '\p{Scx=:\Abamu\z:}', "");;
    Expect(0, 92729, '\p{Scx=:\Abamu\z:}', "");;
    Expect(1, 92728, '\p{Scx= _bamu}', "");
    Expect(0, 92728, '\p{^Scx= _bamu}', "");
    Expect(0, 92728, '\P{Scx= _bamu}', "");
    Expect(1, 92728, '\P{^Scx= _bamu}', "");
    Expect(0, 92729, '\p{Scx= _bamu}', "");
    Expect(1, 92729, '\p{^Scx= _bamu}', "");
    Expect(1, 92729, '\P{Scx= _bamu}', "");
    Expect(0, 92729, '\P{^Scx= _bamu}', "");
    Error('\p{Is_Script_Extensions=/a/_Bamum}');
    Error('\P{Is_Script_Extensions=/a/_Bamum}');
    Expect(1, 92728, '\p{Is_Script_Extensions=bamum}', "");
    Expect(0, 92728, '\p{^Is_Script_Extensions=bamum}', "");
    Expect(0, 92728, '\P{Is_Script_Extensions=bamum}', "");
    Expect(1, 92728, '\P{^Is_Script_Extensions=bamum}', "");
    Expect(0, 92729, '\p{Is_Script_Extensions=bamum}', "");
    Expect(1, 92729, '\p{^Is_Script_Extensions=bamum}', "");
    Expect(1, 92729, '\P{Is_Script_Extensions=bamum}', "");
    Expect(0, 92729, '\P{^Is_Script_Extensions=bamum}', "");
    Expect(1, 92728, '\p{Is_Script_Extensions=  bamum}', "");
    Expect(0, 92728, '\p{^Is_Script_Extensions=  bamum}', "");
    Expect(0, 92728, '\P{Is_Script_Extensions=  bamum}', "");
    Expect(1, 92728, '\P{^Is_Script_Extensions=  bamum}', "");
    Expect(0, 92729, '\p{Is_Script_Extensions=  bamum}', "");
    Expect(1, 92729, '\p{^Is_Script_Extensions=  bamum}', "");
    Expect(1, 92729, '\P{Is_Script_Extensions=  bamum}', "");
    Expect(0, 92729, '\P{^Is_Script_Extensions=  bamum}', "");
    Error('\p{Is_Scx=/a/	-bamu}');
    Error('\P{Is_Scx=/a/	-bamu}');
    Expect(1, 92728, '\p{Is_Scx=bamu}', "");
    Expect(0, 92728, '\p{^Is_Scx=bamu}', "");
    Expect(0, 92728, '\P{Is_Scx=bamu}', "");
    Expect(1, 92728, '\P{^Is_Scx=bamu}', "");
    Expect(0, 92729, '\p{Is_Scx=bamu}', "");
    Expect(1, 92729, '\p{^Is_Scx=bamu}', "");
    Expect(1, 92729, '\P{Is_Scx=bamu}', "");
    Expect(0, 92729, '\P{^Is_Scx=bamu}', "");
    Expect(1, 92728, '\p{Is_Scx=Bamu}', "");
    Expect(0, 92728, '\p{^Is_Scx=Bamu}', "");
    Expect(0, 92728, '\P{Is_Scx=Bamu}', "");
    Expect(1, 92728, '\P{^Is_Scx=Bamu}', "");
    Expect(0, 92729, '\p{Is_Scx=Bamu}', "");
    Expect(1, 92729, '\p{^Is_Scx=Bamu}', "");
    Expect(1, 92729, '\P{Is_Scx=Bamu}', "");
    Expect(0, 92729, '\P{^Is_Scx=Bamu}', "");
    Error('\p{Script_Extensions=:=Bassa_Vah}');
    Error('\P{Script_Extensions=:=Bassa_Vah}');
    Expect(1, 92917, '\p{Script_Extensions=:\ABassa_Vah\z:}', "");;
    Expect(0, 92918, '\p{Script_Extensions=:\ABassa_Vah\z:}', "");;
    Expect(1, 92917, '\p{Script_Extensions=bassavah}', "");
    Expect(0, 92917, '\p{^Script_Extensions=bassavah}', "");
    Expect(0, 92917, '\P{Script_Extensions=bassavah}', "");
    Expect(1, 92917, '\P{^Script_Extensions=bassavah}', "");
    Expect(0, 92918, '\p{Script_Extensions=bassavah}', "");
    Expect(1, 92918, '\p{^Script_Extensions=bassavah}', "");
    Expect(1, 92918, '\P{Script_Extensions=bassavah}', "");
    Expect(0, 92918, '\P{^Script_Extensions=bassavah}', "");
    Expect(1, 92917, '\p{Script_Extensions=:\Abassavah\z:}', "");;
    Expect(0, 92918, '\p{Script_Extensions=:\Abassavah\z:}', "");;
    Expect(1, 92917, '\p{Script_Extensions=	bassa_vah}', "");
    Expect(0, 92917, '\p{^Script_Extensions=	bassa_vah}', "");
    Expect(0, 92917, '\P{Script_Extensions=	bassa_vah}', "");
    Expect(1, 92917, '\P{^Script_Extensions=	bassa_vah}', "");
    Expect(0, 92918, '\p{Script_Extensions=	bassa_vah}', "");
    Expect(1, 92918, '\p{^Script_Extensions=	bassa_vah}', "");
    Expect(1, 92918, '\P{Script_Extensions=	bassa_vah}', "");
    Expect(0, 92918, '\P{^Script_Extensions=	bassa_vah}', "");
    Error('\p{Scx=/a/ _Bass}');
    Error('\P{Scx=/a/ _Bass}');
    Expect(1, 92917, '\p{Scx=:\ABass\z:}', "");;
    Expect(0, 92918, '\p{Scx=:\ABass\z:}', "");;
    Expect(1, 92917, '\p{Scx=bass}', "");
    Expect(0, 92917, '\p{^Scx=bass}', "");
    Expect(0, 92917, '\P{Scx=bass}', "");
    Expect(1, 92917, '\P{^Scx=bass}', "");
    Expect(0, 92918, '\p{Scx=bass}', "");
    Expect(1, 92918, '\p{^Scx=bass}', "");
    Expect(1, 92918, '\P{Scx=bass}', "");
    Expect(0, 92918, '\P{^Scx=bass}', "");
    Expect(1, 92917, '\p{Scx=:\Abass\z:}', "");;
    Expect(0, 92918, '\p{Scx=:\Abass\z:}', "");;
    Expect(1, 92917, '\p{Scx:	- bass}', "");
    Expect(0, 92917, '\p{^Scx:	- bass}', "");
    Expect(0, 92917, '\P{Scx:	- bass}', "");
    Expect(1, 92917, '\P{^Scx:	- bass}', "");
    Expect(0, 92918, '\p{Scx:	- bass}', "");
    Expect(1, 92918, '\p{^Scx:	- bass}', "");
    Expect(1, 92918, '\P{Scx:	- bass}', "");
    Expect(0, 92918, '\P{^Scx:	- bass}', "");
    Error('\p{Is_Script_Extensions=_:=bassa_vah}');
    Error('\P{Is_Script_Extensions=_:=bassa_vah}');
    Expect(1, 92917, '\p{Is_Script_Extensions=bassavah}', "");
    Expect(0, 92917, '\p{^Is_Script_Extensions=bassavah}', "");
    Expect(0, 92917, '\P{Is_Script_Extensions=bassavah}', "");
    Expect(1, 92917, '\P{^Is_Script_Extensions=bassavah}', "");
    Expect(0, 92918, '\p{Is_Script_Extensions=bassavah}', "");
    Expect(1, 92918, '\p{^Is_Script_Extensions=bassavah}', "");
    Expect(1, 92918, '\P{Is_Script_Extensions=bassavah}', "");
    Expect(0, 92918, '\P{^Is_Script_Extensions=bassavah}', "");
    Expect(1, 92917, '\p{Is_Script_Extensions=--bassa_Vah}', "");
    Expect(0, 92917, '\p{^Is_Script_Extensions=--bassa_Vah}', "");
    Expect(0, 92917, '\P{Is_Script_Extensions=--bassa_Vah}', "");
    Expect(1, 92917, '\P{^Is_Script_Extensions=--bassa_Vah}', "");
    Expect(0, 92918, '\p{Is_Script_Extensions=--bassa_Vah}', "");
    Expect(1, 92918, '\p{^Is_Script_Extensions=--bassa_Vah}', "");
    Expect(1, 92918, '\P{Is_Script_Extensions=--bassa_Vah}', "");
    Expect(0, 92918, '\P{^Is_Script_Extensions=--bassa_Vah}', "");
    Error('\p{Is_Scx:	-/a/Bass}');
    Error('\P{Is_Scx:	-/a/Bass}');
    Expect(1, 92917, '\p{Is_Scx:	bass}', "");
    Expect(0, 92917, '\p{^Is_Scx:	bass}', "");
    Expect(0, 92917, '\P{Is_Scx:	bass}', "");
    Expect(1, 92917, '\P{^Is_Scx:	bass}', "");
    Expect(0, 92918, '\p{Is_Scx:	bass}', "");
    Expect(1, 92918, '\p{^Is_Scx:	bass}', "");
    Expect(1, 92918, '\P{Is_Scx:	bass}', "");
    Expect(0, 92918, '\P{^Is_Scx:	bass}', "");
    Expect(1, 92917, '\p{Is_Scx=	Bass}', "");
    Expect(0, 92917, '\p{^Is_Scx=	Bass}', "");
    Expect(0, 92917, '\P{Is_Scx=	Bass}', "");
    Expect(1, 92917, '\P{^Is_Scx=	Bass}', "");
    Expect(0, 92918, '\p{Is_Scx=	Bass}', "");
    Expect(1, 92918, '\p{^Is_Scx=	Bass}', "");
    Expect(1, 92918, '\P{Is_Scx=	Bass}', "");
    Expect(0, 92918, '\P{^Is_Scx=	Bass}', "");
    Error('\p{Script_Extensions=/a/_Batak}');
    Error('\P{Script_Extensions=/a/_Batak}');
    Expect(1, 7167, '\p{Script_Extensions=:\ABatak\z:}', "");;
    Expect(0, 7168, '\p{Script_Extensions=:\ABatak\z:}', "");;
    Expect(1, 7167, '\p{Script_Extensions=batak}', "");
    Expect(0, 7167, '\p{^Script_Extensions=batak}', "");
    Expect(0, 7167, '\P{Script_Extensions=batak}', "");
    Expect(1, 7167, '\P{^Script_Extensions=batak}', "");
    Expect(0, 7168, '\p{Script_Extensions=batak}', "");
    Expect(1, 7168, '\p{^Script_Extensions=batak}', "");
    Expect(1, 7168, '\P{Script_Extensions=batak}', "");
    Expect(0, 7168, '\P{^Script_Extensions=batak}', "");
    Expect(1, 7167, '\p{Script_Extensions=:\Abatak\z:}', "");;
    Expect(0, 7168, '\p{Script_Extensions=:\Abatak\z:}', "");;
    Expect(1, 7167, '\p{Script_Extensions=	batak}', "");
    Expect(0, 7167, '\p{^Script_Extensions=	batak}', "");
    Expect(0, 7167, '\P{Script_Extensions=	batak}', "");
    Expect(1, 7167, '\P{^Script_Extensions=	batak}', "");
    Expect(0, 7168, '\p{Script_Extensions=	batak}', "");
    Expect(1, 7168, '\p{^Script_Extensions=	batak}', "");
    Expect(1, 7168, '\P{Script_Extensions=	batak}', "");
    Expect(0, 7168, '\P{^Script_Extensions=	batak}', "");
    Error('\p{Scx=/a/_	Batk}');
    Error('\P{Scx=/a/_	Batk}');
    Expect(1, 7167, '\p{Scx=:\ABatk\z:}', "");;
    Expect(0, 7168, '\p{Scx=:\ABatk\z:}', "");;
    Expect(1, 7167, '\p{Scx=batk}', "");
    Expect(0, 7167, '\p{^Scx=batk}', "");
    Expect(0, 7167, '\P{Scx=batk}', "");
    Expect(1, 7167, '\P{^Scx=batk}', "");
    Expect(0, 7168, '\p{Scx=batk}', "");
    Expect(1, 7168, '\p{^Scx=batk}', "");
    Expect(1, 7168, '\P{Scx=batk}', "");
    Expect(0, 7168, '\P{^Scx=batk}', "");
    Expect(1, 7167, '\p{Scx=:\Abatk\z:}', "");;
    Expect(0, 7168, '\p{Scx=:\Abatk\z:}', "");;
    Expect(1, 7167, '\p{Scx= batk}', "");
    Expect(0, 7167, '\p{^Scx= batk}', "");
    Expect(0, 7167, '\P{Scx= batk}', "");
    Expect(1, 7167, '\P{^Scx= batk}', "");
    Expect(0, 7168, '\p{Scx= batk}', "");
    Expect(1, 7168, '\p{^Scx= batk}', "");
    Expect(1, 7168, '\P{Scx= batk}', "");
    Expect(0, 7168, '\P{^Scx= batk}', "");
    Error('\p{Is_Script_Extensions=_-BATAK:=}');
    Error('\P{Is_Script_Extensions=_-BATAK:=}');
    Expect(1, 7167, '\p{Is_Script_Extensions=batak}', "");
    Expect(0, 7167, '\p{^Is_Script_Extensions=batak}', "");
    Expect(0, 7167, '\P{Is_Script_Extensions=batak}', "");
    Expect(1, 7167, '\P{^Is_Script_Extensions=batak}', "");
    Expect(0, 7168, '\p{Is_Script_Extensions=batak}', "");
    Expect(1, 7168, '\p{^Is_Script_Extensions=batak}', "");
    Expect(1, 7168, '\P{Is_Script_Extensions=batak}', "");
    Expect(0, 7168, '\P{^Is_Script_Extensions=batak}', "");
    Expect(1, 7167, '\p{Is_Script_Extensions=	-batak}', "");
    Expect(0, 7167, '\p{^Is_Script_Extensions=	-batak}', "");
    Expect(0, 7167, '\P{Is_Script_Extensions=	-batak}', "");
    Expect(1, 7167, '\P{^Is_Script_Extensions=	-batak}', "");
    Expect(0, 7168, '\p{Is_Script_Extensions=	-batak}', "");
    Expect(1, 7168, '\p{^Is_Script_Extensions=	-batak}', "");
    Expect(1, 7168, '\P{Is_Script_Extensions=	-batak}', "");
    Expect(0, 7168, '\P{^Is_Script_Extensions=	-batak}', "");
    Error('\p{Is_Scx=__Batk:=}');
    Error('\P{Is_Scx=__Batk:=}');
    Expect(1, 7167, '\p{Is_Scx=batk}', "");
    Expect(0, 7167, '\p{^Is_Scx=batk}', "");
    Expect(0, 7167, '\P{Is_Scx=batk}', "");
    Expect(1, 7167, '\P{^Is_Scx=batk}', "");
    Expect(0, 7168, '\p{Is_Scx=batk}', "");
    Expect(1, 7168, '\p{^Is_Scx=batk}', "");
    Expect(1, 7168, '\P{Is_Scx=batk}', "");
    Expect(0, 7168, '\P{^Is_Scx=batk}', "");
    Expect(1, 7167, '\p{Is_Scx=	Batk}', "");
    Expect(0, 7167, '\p{^Is_Scx=	Batk}', "");
    Expect(0, 7167, '\P{Is_Scx=	Batk}', "");
    Expect(1, 7167, '\P{^Is_Scx=	Batk}', "");
    Expect(0, 7168, '\p{Is_Scx=	Batk}', "");
    Expect(1, 7168, '\p{^Is_Scx=	Batk}', "");
    Expect(1, 7168, '\P{Is_Scx=	Batk}', "");
    Expect(0, 7168, '\P{^Is_Scx=	Batk}', "");
    Error('\p{Script_Extensions:   	Bengali/a/}');
    Error('\P{Script_Extensions:   	Bengali/a/}');
    Expect(1, 43249, '\p{Script_Extensions=:\ABengali\z:}', "");;
    Expect(0, 43250, '\p{Script_Extensions=:\ABengali\z:}', "");;
    Expect(1, 43249, '\p{Script_Extensions=bengali}', "");
    Expect(0, 43249, '\p{^Script_Extensions=bengali}', "");
    Expect(0, 43249, '\P{Script_Extensions=bengali}', "");
    Expect(1, 43249, '\P{^Script_Extensions=bengali}', "");
    Expect(0, 43250, '\p{Script_Extensions=bengali}', "");
    Expect(1, 43250, '\p{^Script_Extensions=bengali}', "");
    Expect(1, 43250, '\P{Script_Extensions=bengali}', "");
    Expect(0, 43250, '\P{^Script_Extensions=bengali}', "");
    Expect(1, 43249, '\p{Script_Extensions=:\Abengali\z:}', "");;
    Expect(0, 43250, '\p{Script_Extensions=:\Abengali\z:}', "");;
    Expect(1, 43249, '\p{Script_Extensions:   _ BENGALI}', "");
    Expect(0, 43249, '\p{^Script_Extensions:   _ BENGALI}', "");
    Expect(0, 43249, '\P{Script_Extensions:   _ BENGALI}', "");
    Expect(1, 43249, '\P{^Script_Extensions:   _ BENGALI}', "");
    Expect(0, 43250, '\p{Script_Extensions:   _ BENGALI}', "");
    Expect(1, 43250, '\p{^Script_Extensions:   _ BENGALI}', "");
    Expect(1, 43250, '\P{Script_Extensions:   _ BENGALI}', "");
    Expect(0, 43250, '\P{^Script_Extensions:   _ BENGALI}', "");
    Error('\p{Scx=:=Beng}');
    Error('\P{Scx=:=Beng}');
    Expect(1, 43249, '\p{Scx=:\ABeng\z:}', "");;
    Expect(0, 43250, '\p{Scx=:\ABeng\z:}', "");;
    Expect(1, 43249, '\p{Scx=beng}', "");
    Expect(0, 43249, '\p{^Scx=beng}', "");
    Expect(0, 43249, '\P{Scx=beng}', "");
    Expect(1, 43249, '\P{^Scx=beng}', "");
    Expect(0, 43250, '\p{Scx=beng}', "");
    Expect(1, 43250, '\p{^Scx=beng}', "");
    Expect(1, 43250, '\P{Scx=beng}', "");
    Expect(0, 43250, '\P{^Scx=beng}', "");
    Expect(1, 43249, '\p{Scx=:\Abeng\z:}', "");;
    Expect(0, 43250, '\p{Scx=:\Abeng\z:}', "");;
    Expect(1, 43249, '\p{Scx:	 	Beng}', "");
    Expect(0, 43249, '\p{^Scx:	 	Beng}', "");
    Expect(0, 43249, '\P{Scx:	 	Beng}', "");
    Expect(1, 43249, '\P{^Scx:	 	Beng}', "");
    Expect(0, 43250, '\p{Scx:	 	Beng}', "");
    Expect(1, 43250, '\p{^Scx:	 	Beng}', "");
    Expect(1, 43250, '\P{Scx:	 	Beng}', "");
    Expect(0, 43250, '\P{^Scx:	 	Beng}', "");
    Error('\p{Is_Script_Extensions=-	Bengali:=}');
    Error('\P{Is_Script_Extensions=-	Bengali:=}');
    Expect(1, 43249, '\p{Is_Script_Extensions=bengali}', "");
    Expect(0, 43249, '\p{^Is_Script_Extensions=bengali}', "");
    Expect(0, 43249, '\P{Is_Script_Extensions=bengali}', "");
    Expect(1, 43249, '\P{^Is_Script_Extensions=bengali}', "");
    Expect(0, 43250, '\p{Is_Script_Extensions=bengali}', "");
    Expect(1, 43250, '\p{^Is_Script_Extensions=bengali}', "");
    Expect(1, 43250, '\P{Is_Script_Extensions=bengali}', "");
    Expect(0, 43250, '\P{^Is_Script_Extensions=bengali}', "");
    Expect(1, 43249, '\p{Is_Script_Extensions=		BENGALI}', "");
    Expect(0, 43249, '\p{^Is_Script_Extensions=		BENGALI}', "");
    Expect(0, 43249, '\P{Is_Script_Extensions=		BENGALI}', "");
    Expect(1, 43249, '\P{^Is_Script_Extensions=		BENGALI}', "");
    Expect(0, 43250, '\p{Is_Script_Extensions=		BENGALI}', "");
    Expect(1, 43250, '\p{^Is_Script_Extensions=		BENGALI}', "");
    Expect(1, 43250, '\P{Is_Script_Extensions=		BENGALI}', "");
    Expect(0, 43250, '\P{^Is_Script_Extensions=		BENGALI}', "");
    Error('\p{Is_Scx: :=_	beng}');
    Error('\P{Is_Scx: :=_	beng}');
    Expect(1, 43249, '\p{Is_Scx=beng}', "");
    Expect(0, 43249, '\p{^Is_Scx=beng}', "");
    Expect(0, 43249, '\P{Is_Scx=beng}', "");
    Expect(1, 43249, '\P{^Is_Scx=beng}', "");
    Expect(0, 43250, '\p{Is_Scx=beng}', "");
    Expect(1, 43250, '\p{^Is_Scx=beng}', "");
    Expect(1, 43250, '\P{Is_Scx=beng}', "");
    Expect(0, 43250, '\P{^Is_Scx=beng}', "");
    Expect(1, 43249, '\p{Is_Scx=  Beng}', "");
    Expect(0, 43249, '\p{^Is_Scx=  Beng}', "");
    Expect(0, 43249, '\P{Is_Scx=  Beng}', "");
    Expect(1, 43249, '\P{^Is_Scx=  Beng}', "");
    Expect(0, 43250, '\p{Is_Scx=  Beng}', "");
    Expect(1, 43250, '\p{^Is_Scx=  Beng}', "");
    Expect(1, 43250, '\P{Is_Scx=  Beng}', "");
    Expect(0, 43250, '\P{^Is_Scx=  Beng}', "");
    Error('\p{Script_Extensions=/a/-_Bhaiksuki}');
    Error('\P{Script_Extensions=/a/-_Bhaiksuki}');
    Expect(1, 72812, '\p{Script_Extensions=:\ABhaiksuki\z:}', "");;
    Expect(0, 72813, '\p{Script_Extensions=:\ABhaiksuki\z:}', "");;
    Expect(1, 72812, '\p{Script_Extensions=bhaiksuki}', "");
    Expect(0, 72812, '\p{^Script_Extensions=bhaiksuki}', "");
    Expect(0, 72812, '\P{Script_Extensions=bhaiksuki}', "");
    Expect(1, 72812, '\P{^Script_Extensions=bhaiksuki}', "");
    Expect(0, 72813, '\p{Script_Extensions=bhaiksuki}', "");
    Expect(1, 72813, '\p{^Script_Extensions=bhaiksuki}', "");
    Expect(1, 72813, '\P{Script_Extensions=bhaiksuki}', "");
    Expect(0, 72813, '\P{^Script_Extensions=bhaiksuki}', "");
    Expect(1, 72812, '\p{Script_Extensions=:\Abhaiksuki\z:}', "");;
    Expect(0, 72813, '\p{Script_Extensions=:\Abhaiksuki\z:}', "");;
    Expect(1, 72812, '\p{Script_Extensions=  BHAIKSUKI}', "");
    Expect(0, 72812, '\p{^Script_Extensions=  BHAIKSUKI}', "");
    Expect(0, 72812, '\P{Script_Extensions=  BHAIKSUKI}', "");
    Expect(1, 72812, '\P{^Script_Extensions=  BHAIKSUKI}', "");
    Expect(0, 72813, '\p{Script_Extensions=  BHAIKSUKI}', "");
    Expect(1, 72813, '\p{^Script_Extensions=  BHAIKSUKI}', "");
    Expect(1, 72813, '\P{Script_Extensions=  BHAIKSUKI}', "");
    Expect(0, 72813, '\P{^Script_Extensions=  BHAIKSUKI}', "");
    Error('\p{Scx=/a/  Bhks}');
    Error('\P{Scx=/a/  Bhks}');
    Expect(1, 72812, '\p{Scx=:\ABhks\z:}', "");;
    Expect(0, 72813, '\p{Scx=:\ABhks\z:}', "");;
    Expect(1, 72812, '\p{Scx=bhks}', "");
    Expect(0, 72812, '\p{^Scx=bhks}', "");
    Expect(0, 72812, '\P{Scx=bhks}', "");
    Expect(1, 72812, '\P{^Scx=bhks}', "");
    Expect(0, 72813, '\p{Scx=bhks}', "");
    Expect(1, 72813, '\p{^Scx=bhks}', "");
    Expect(1, 72813, '\P{Scx=bhks}', "");
    Expect(0, 72813, '\P{^Scx=bhks}', "");
    Expect(1, 72812, '\p{Scx=:\Abhks\z:}', "");;
    Expect(0, 72813, '\p{Scx=:\Abhks\z:}', "");;
    Expect(1, 72812, '\p{Scx=_-Bhks}', "");
    Expect(0, 72812, '\p{^Scx=_-Bhks}', "");
    Expect(0, 72812, '\P{Scx=_-Bhks}', "");
    Expect(1, 72812, '\P{^Scx=_-Bhks}', "");
    Expect(0, 72813, '\p{Scx=_-Bhks}', "");
    Expect(1, 72813, '\p{^Scx=_-Bhks}', "");
    Expect(1, 72813, '\P{Scx=_-Bhks}', "");
    Expect(0, 72813, '\P{^Scx=_-Bhks}', "");
    Error('\p{Is_Script_Extensions=	 Bhaiksuki/a/}');
    Error('\P{Is_Script_Extensions=	 Bhaiksuki/a/}');
    Expect(1, 72812, '\p{Is_Script_Extensions=bhaiksuki}', "");
    Expect(0, 72812, '\p{^Is_Script_Extensions=bhaiksuki}', "");
    Expect(0, 72812, '\P{Is_Script_Extensions=bhaiksuki}', "");
    Expect(1, 72812, '\P{^Is_Script_Extensions=bhaiksuki}', "");
    Expect(0, 72813, '\p{Is_Script_Extensions=bhaiksuki}', "");
    Expect(1, 72813, '\p{^Is_Script_Extensions=bhaiksuki}', "");
    Expect(1, 72813, '\P{Is_Script_Extensions=bhaiksuki}', "");
    Expect(0, 72813, '\P{^Is_Script_Extensions=bhaiksuki}', "");
    Expect(1, 72812, '\p{Is_Script_Extensions: 		bhaiksuki}', "");
    Expect(0, 72812, '\p{^Is_Script_Extensions: 		bhaiksuki}', "");
    Expect(0, 72812, '\P{Is_Script_Extensions: 		bhaiksuki}', "");
    Expect(1, 72812, '\P{^Is_Script_Extensions: 		bhaiksuki}', "");
    Expect(0, 72813, '\p{Is_Script_Extensions: 		bhaiksuki}', "");
    Expect(1, 72813, '\p{^Is_Script_Extensions: 		bhaiksuki}', "");
    Expect(1, 72813, '\P{Is_Script_Extensions: 		bhaiksuki}', "");
    Expect(0, 72813, '\P{^Is_Script_Extensions: 		bhaiksuki}', "");
    Error('\p{Is_Scx=_/a/Bhks}');
    Error('\P{Is_Scx=_/a/Bhks}');
    Expect(1, 72812, '\p{Is_Scx=bhks}', "");
    Expect(0, 72812, '\p{^Is_Scx=bhks}', "");
    Expect(0, 72812, '\P{Is_Scx=bhks}', "");
    Expect(1, 72812, '\P{^Is_Scx=bhks}', "");
    Expect(0, 72813, '\p{Is_Scx=bhks}', "");
    Expect(1, 72813, '\p{^Is_Scx=bhks}', "");
    Expect(1, 72813, '\P{Is_Scx=bhks}', "");
    Expect(0, 72813, '\P{^Is_Scx=bhks}', "");
    Expect(1, 72812, '\p{Is_Scx= -Bhks}', "");
    Expect(0, 72812, '\p{^Is_Scx= -Bhks}', "");
    Expect(0, 72812, '\P{Is_Scx= -Bhks}', "");
    Expect(1, 72812, '\P{^Is_Scx= -Bhks}', "");
    Expect(0, 72813, '\p{Is_Scx= -Bhks}', "");
    Expect(1, 72813, '\p{^Is_Scx= -Bhks}', "");
    Expect(1, 72813, '\P{Is_Scx= -Bhks}', "");
    Expect(0, 72813, '\P{^Is_Scx= -Bhks}', "");
    Error('\p{Script_Extensions=_Bopomofo/a/}');
    Error('\P{Script_Extensions=_Bopomofo/a/}');
    Expect(1, 65381, '\p{Script_Extensions=:\ABopomofo\z:}', "");;
    Expect(0, 65382, '\p{Script_Extensions=:\ABopomofo\z:}', "");;
    Expect(1, 65381, '\p{Script_Extensions=bopomofo}', "");
    Expect(0, 65381, '\p{^Script_Extensions=bopomofo}', "");
    Expect(0, 65381, '\P{Script_Extensions=bopomofo}', "");
    Expect(1, 65381, '\P{^Script_Extensions=bopomofo}', "");
    Expect(0, 65382, '\p{Script_Extensions=bopomofo}', "");
    Expect(1, 65382, '\p{^Script_Extensions=bopomofo}', "");
    Expect(1, 65382, '\P{Script_Extensions=bopomofo}', "");
    Expect(0, 65382, '\P{^Script_Extensions=bopomofo}', "");
    Expect(1, 65381, '\p{Script_Extensions=:\Abopomofo\z:}', "");;
    Expect(0, 65382, '\p{Script_Extensions=:\Abopomofo\z:}', "");;
    Expect(1, 65381, '\p{Script_Extensions=	_bopomofo}', "");
    Expect(0, 65381, '\p{^Script_Extensions=	_bopomofo}', "");
    Expect(0, 65381, '\P{Script_Extensions=	_bopomofo}', "");
    Expect(1, 65381, '\P{^Script_Extensions=	_bopomofo}', "");
    Expect(0, 65382, '\p{Script_Extensions=	_bopomofo}', "");
    Expect(1, 65382, '\p{^Script_Extensions=	_bopomofo}', "");
    Expect(1, 65382, '\P{Script_Extensions=	_bopomofo}', "");
    Expect(0, 65382, '\P{^Script_Extensions=	_bopomofo}', "");
    Error('\p{Scx=_ Bopo:=}');
    Error('\P{Scx=_ Bopo:=}');
    Expect(1, 65381, '\p{Scx=:\ABopo\z:}', "");;
    Expect(0, 65382, '\p{Scx=:\ABopo\z:}', "");;
    Expect(1, 65381, '\p{Scx=bopo}', "");
    Expect(0, 65381, '\p{^Scx=bopo}', "");
    Expect(0, 65381, '\P{Scx=bopo}', "");
    Expect(1, 65381, '\P{^Scx=bopo}', "");
    Expect(0, 65382, '\p{Scx=bopo}', "");
    Expect(1, 65382, '\p{^Scx=bopo}', "");
    Expect(1, 65382, '\P{Scx=bopo}', "");
    Expect(0, 65382, '\P{^Scx=bopo}', "");
    Expect(1, 65381, '\p{Scx=:\Abopo\z:}', "");;
    Expect(0, 65382, '\p{Scx=:\Abopo\z:}', "");;
    Expect(1, 65381, '\p{Scx=Bopo}', "");
    Expect(0, 65381, '\p{^Scx=Bopo}', "");
    Expect(0, 65381, '\P{Scx=Bopo}', "");
    Expect(1, 65381, '\P{^Scx=Bopo}', "");
    Expect(0, 65382, '\p{Scx=Bopo}', "");
    Expect(1, 65382, '\p{^Scx=Bopo}', "");
    Expect(1, 65382, '\P{Scx=Bopo}', "");
    Expect(0, 65382, '\P{^Scx=Bopo}', "");
    Error('\p{Is_Script_Extensions= Bopomofo:=}');
    Error('\P{Is_Script_Extensions= Bopomofo:=}');
    Expect(1, 65381, '\p{Is_Script_Extensions=bopomofo}', "");
    Expect(0, 65381, '\p{^Is_Script_Extensions=bopomofo}', "");
    Expect(0, 65381, '\P{Is_Script_Extensions=bopomofo}', "");
    Expect(1, 65381, '\P{^Is_Script_Extensions=bopomofo}', "");
    Expect(0, 65382, '\p{Is_Script_Extensions=bopomofo}', "");
    Expect(1, 65382, '\p{^Is_Script_Extensions=bopomofo}', "");
    Expect(1, 65382, '\P{Is_Script_Extensions=bopomofo}', "");
    Expect(0, 65382, '\P{^Is_Script_Extensions=bopomofo}', "");
    Expect(1, 65381, '\p{Is_Script_Extensions= 	Bopomofo}', "");
    Expect(0, 65381, '\p{^Is_Script_Extensions= 	Bopomofo}', "");
    Expect(0, 65381, '\P{Is_Script_Extensions= 	Bopomofo}', "");
    Expect(1, 65381, '\P{^Is_Script_Extensions= 	Bopomofo}', "");
    Expect(0, 65382, '\p{Is_Script_Extensions= 	Bopomofo}', "");
    Expect(1, 65382, '\p{^Is_Script_Extensions= 	Bopomofo}', "");
    Expect(1, 65382, '\P{Is_Script_Extensions= 	Bopomofo}', "");
    Expect(0, 65382, '\P{^Is_Script_Extensions= 	Bopomofo}', "");
    Error('\p{Is_Scx=/a/-bopo}');
    Error('\P{Is_Scx=/a/-bopo}');
    Expect(1, 65381, '\p{Is_Scx=bopo}', "");
    Expect(0, 65381, '\p{^Is_Scx=bopo}', "");
    Expect(0, 65381, '\P{Is_Scx=bopo}', "");
    Expect(1, 65381, '\P{^Is_Scx=bopo}', "");
    Expect(0, 65382, '\p{Is_Scx=bopo}', "");
    Expect(1, 65382, '\p{^Is_Scx=bopo}', "");
    Expect(1, 65382, '\P{Is_Scx=bopo}', "");
    Expect(0, 65382, '\P{^Is_Scx=bopo}', "");
    Expect(1, 65381, '\p{Is_Scx=_-BOPO}', "");
    Expect(0, 65381, '\p{^Is_Scx=_-BOPO}', "");
    Expect(0, 65381, '\P{Is_Scx=_-BOPO}', "");
    Expect(1, 65381, '\P{^Is_Scx=_-BOPO}', "");
    Expect(0, 65382, '\p{Is_Scx=_-BOPO}', "");
    Expect(1, 65382, '\p{^Is_Scx=_-BOPO}', "");
    Expect(1, 65382, '\P{Is_Scx=_-BOPO}', "");
    Expect(0, 65382, '\P{^Is_Scx=_-BOPO}', "");
    Error('\p{Script_Extensions=	 Brahmi/a/}');
    Error('\P{Script_Extensions=	 Brahmi/a/}');
    Expect(1, 69759, '\p{Script_Extensions=:\ABrahmi\z:}', "");;
    Expect(0, 69760, '\p{Script_Extensions=:\ABrahmi\z:}', "");;
    Expect(1, 69759, '\p{Script_Extensions:brahmi}', "");
    Expect(0, 69759, '\p{^Script_Extensions:brahmi}', "");
    Expect(0, 69759, '\P{Script_Extensions:brahmi}', "");
    Expect(1, 69759, '\P{^Script_Extensions:brahmi}', "");
    Expect(0, 69760, '\p{Script_Extensions:brahmi}', "");
    Expect(1, 69760, '\p{^Script_Extensions:brahmi}', "");
    Expect(1, 69760, '\P{Script_Extensions:brahmi}', "");
    Expect(0, 69760, '\P{^Script_Extensions:brahmi}', "");
    Expect(1, 69759, '\p{Script_Extensions=:\Abrahmi\z:}', "");;
    Expect(0, 69760, '\p{Script_Extensions=:\Abrahmi\z:}', "");;
    Expect(1, 69759, '\p{Script_Extensions=	 brahmi}', "");
    Expect(0, 69759, '\p{^Script_Extensions=	 brahmi}', "");
    Expect(0, 69759, '\P{Script_Extensions=	 brahmi}', "");
    Expect(1, 69759, '\P{^Script_Extensions=	 brahmi}', "");
    Expect(0, 69760, '\p{Script_Extensions=	 brahmi}', "");
    Expect(1, 69760, '\p{^Script_Extensions=	 brahmi}', "");
    Expect(1, 69760, '\P{Script_Extensions=	 brahmi}', "");
    Expect(0, 69760, '\P{^Script_Extensions=	 brahmi}', "");
    Error('\p{Scx=:=-	brah}');
    Error('\P{Scx=:=-	brah}');
    Expect(1, 69759, '\p{Scx=:\ABrah\z:}', "");;
    Expect(0, 69760, '\p{Scx=:\ABrah\z:}', "");;
    Expect(1, 69759, '\p{Scx=brah}', "");
    Expect(0, 69759, '\p{^Scx=brah}', "");
    Expect(0, 69759, '\P{Scx=brah}', "");
    Expect(1, 69759, '\P{^Scx=brah}', "");
    Expect(0, 69760, '\p{Scx=brah}', "");
    Expect(1, 69760, '\p{^Scx=brah}', "");
    Expect(1, 69760, '\P{Scx=brah}', "");
    Expect(0, 69760, '\P{^Scx=brah}', "");
    Expect(1, 69759, '\p{Scx=:\Abrah\z:}', "");;
    Expect(0, 69760, '\p{Scx=:\Abrah\z:}', "");;
    Expect(1, 69759, '\p{Scx=_BRAH}', "");
    Expect(0, 69759, '\p{^Scx=_BRAH}', "");
    Expect(0, 69759, '\P{Scx=_BRAH}', "");
    Expect(1, 69759, '\P{^Scx=_BRAH}', "");
    Expect(0, 69760, '\p{Scx=_BRAH}', "");
    Expect(1, 69760, '\p{^Scx=_BRAH}', "");
    Expect(1, 69760, '\P{Scx=_BRAH}', "");
    Expect(0, 69760, '\P{^Scx=_BRAH}', "");
    Error('\p{Is_Script_Extensions=--Brahmi:=}');
    Error('\P{Is_Script_Extensions=--Brahmi:=}');
    Expect(1, 69759, '\p{Is_Script_Extensions=brahmi}', "");
    Expect(0, 69759, '\p{^Is_Script_Extensions=brahmi}', "");
    Expect(0, 69759, '\P{Is_Script_Extensions=brahmi}', "");
    Expect(1, 69759, '\P{^Is_Script_Extensions=brahmi}', "");
    Expect(0, 69760, '\p{Is_Script_Extensions=brahmi}', "");
    Expect(1, 69760, '\p{^Is_Script_Extensions=brahmi}', "");
    Expect(1, 69760, '\P{Is_Script_Extensions=brahmi}', "");
    Expect(0, 69760, '\P{^Is_Script_Extensions=brahmi}', "");
    Expect(1, 69759, '\p{Is_Script_Extensions: - Brahmi}', "");
    Expect(0, 69759, '\p{^Is_Script_Extensions: - Brahmi}', "");
    Expect(0, 69759, '\P{Is_Script_Extensions: - Brahmi}', "");
    Expect(1, 69759, '\P{^Is_Script_Extensions: - Brahmi}', "");
    Expect(0, 69760, '\p{Is_Script_Extensions: - Brahmi}', "");
    Expect(1, 69760, '\p{^Is_Script_Extensions: - Brahmi}', "");
    Expect(1, 69760, '\P{Is_Script_Extensions: - Brahmi}', "");
    Expect(0, 69760, '\P{^Is_Script_Extensions: - Brahmi}', "");
    Error('\p{Is_Scx=:= Brah}');
    Error('\P{Is_Scx=:= Brah}');
    Expect(1, 69759, '\p{Is_Scx=brah}', "");
    Expect(0, 69759, '\p{^Is_Scx=brah}', "");
    Expect(0, 69759, '\P{Is_Scx=brah}', "");
    Expect(1, 69759, '\P{^Is_Scx=brah}', "");
    Expect(0, 69760, '\p{Is_Scx=brah}', "");
    Expect(1, 69760, '\p{^Is_Scx=brah}', "");
    Expect(1, 69760, '\P{Is_Scx=brah}', "");
    Expect(0, 69760, '\P{^Is_Scx=brah}', "");
    Expect(1, 69759, '\p{Is_Scx= brah}', "");
    Expect(0, 69759, '\p{^Is_Scx= brah}', "");
    Expect(0, 69759, '\P{Is_Scx= brah}', "");
    Expect(1, 69759, '\P{^Is_Scx= brah}', "");
    Expect(0, 69760, '\p{Is_Scx= brah}', "");
    Expect(1, 69760, '\p{^Is_Scx= brah}', "");
    Expect(1, 69760, '\P{Is_Scx= brah}', "");
    Expect(0, 69760, '\P{^Is_Scx= brah}', "");
    Error('\p{Script_Extensions=:=	_braille}');
    Error('\P{Script_Extensions=:=	_braille}');
    Expect(1, 10495, '\p{Script_Extensions=:\ABraille\z:}', "");;
    Expect(0, 10496, '\p{Script_Extensions=:\ABraille\z:}', "");;
    Expect(1, 10495, '\p{Script_Extensions=braille}', "");
    Expect(0, 10495, '\p{^Script_Extensions=braille}', "");
    Expect(0, 10495, '\P{Script_Extensions=braille}', "");
    Expect(1, 10495, '\P{^Script_Extensions=braille}', "");
    Expect(0, 10496, '\p{Script_Extensions=braille}', "");
    Expect(1, 10496, '\p{^Script_Extensions=braille}', "");
    Expect(1, 10496, '\P{Script_Extensions=braille}', "");
    Expect(0, 10496, '\P{^Script_Extensions=braille}', "");
    Expect(1, 10495, '\p{Script_Extensions=:\Abraille\z:}', "");;
    Expect(0, 10496, '\p{Script_Extensions=:\Abraille\z:}', "");;
    Expect(1, 10495, '\p{Script_Extensions=	-Braille}', "");
    Expect(0, 10495, '\p{^Script_Extensions=	-Braille}', "");
    Expect(0, 10495, '\P{Script_Extensions=	-Braille}', "");
    Expect(1, 10495, '\P{^Script_Extensions=	-Braille}', "");
    Expect(0, 10496, '\p{Script_Extensions=	-Braille}', "");
    Expect(1, 10496, '\p{^Script_Extensions=	-Braille}', "");
    Expect(1, 10496, '\P{Script_Extensions=	-Braille}', "");
    Expect(0, 10496, '\P{^Script_Extensions=	-Braille}', "");
    Error('\p{Scx=/a/ BRAI}');
    Error('\P{Scx=/a/ BRAI}');
    Expect(1, 10495, '\p{Scx=:\ABrai\z:}', "");;
    Expect(0, 10496, '\p{Scx=:\ABrai\z:}', "");;
    Expect(1, 10495, '\p{Scx:	brai}', "");
    Expect(0, 10495, '\p{^Scx:	brai}', "");
    Expect(0, 10495, '\P{Scx:	brai}', "");
    Expect(1, 10495, '\P{^Scx:	brai}', "");
    Expect(0, 10496, '\p{Scx:	brai}', "");
    Expect(1, 10496, '\p{^Scx:	brai}', "");
    Expect(1, 10496, '\P{Scx:	brai}', "");
    Expect(0, 10496, '\P{^Scx:	brai}', "");
    Expect(1, 10495, '\p{Scx=:\Abrai\z:}', "");;
    Expect(0, 10496, '\p{Scx=:\Abrai\z:}', "");;
    Expect(1, 10495, '\p{Scx= 	BRAI}', "");
    Expect(0, 10495, '\p{^Scx= 	BRAI}', "");
    Expect(0, 10495, '\P{Scx= 	BRAI}', "");
    Expect(1, 10495, '\P{^Scx= 	BRAI}', "");
    Expect(0, 10496, '\p{Scx= 	BRAI}', "");
    Expect(1, 10496, '\p{^Scx= 	BRAI}', "");
    Expect(1, 10496, '\P{Scx= 	BRAI}', "");
    Expect(0, 10496, '\P{^Scx= 	BRAI}', "");
    Error('\p{Is_Script_Extensions=_/a/Braille}');
    Error('\P{Is_Script_Extensions=_/a/Braille}');
    Expect(1, 10495, '\p{Is_Script_Extensions=braille}', "");
    Expect(0, 10495, '\p{^Is_Script_Extensions=braille}', "");
    Expect(0, 10495, '\P{Is_Script_Extensions=braille}', "");
    Expect(1, 10495, '\P{^Is_Script_Extensions=braille}', "");
    Expect(0, 10496, '\p{Is_Script_Extensions=braille}', "");
    Expect(1, 10496, '\p{^Is_Script_Extensions=braille}', "");
    Expect(1, 10496, '\P{Is_Script_Extensions=braille}', "");
    Expect(0, 10496, '\P{^Is_Script_Extensions=braille}', "");
    Expect(1, 10495, '\p{Is_Script_Extensions= _Braille}', "");
    Expect(0, 10495, '\p{^Is_Script_Extensions= _Braille}', "");
    Expect(0, 10495, '\P{Is_Script_Extensions= _Braille}', "");
    Expect(1, 10495, '\P{^Is_Script_Extensions= _Braille}', "");
    Expect(0, 10496, '\p{Is_Script_Extensions= _Braille}', "");
    Expect(1, 10496, '\p{^Is_Script_Extensions= _Braille}', "");
    Expect(1, 10496, '\P{Is_Script_Extensions= _Braille}', "");
    Expect(0, 10496, '\P{^Is_Script_Extensions= _Braille}', "");
    Error('\p{Is_Scx= /a/brai}');
    Error('\P{Is_Scx= /a/brai}');
    Expect(1, 10495, '\p{Is_Scx=brai}', "");
    Expect(0, 10495, '\p{^Is_Scx=brai}', "");
    Expect(0, 10495, '\P{Is_Scx=brai}', "");
    Expect(1, 10495, '\P{^Is_Scx=brai}', "");
    Expect(0, 10496, '\p{Is_Scx=brai}', "");
    Expect(1, 10496, '\p{^Is_Scx=brai}', "");
    Expect(1, 10496, '\P{Is_Scx=brai}', "");
    Expect(0, 10496, '\P{^Is_Scx=brai}', "");
    Expect(1, 10495, '\p{Is_Scx=_BRAI}', "");
    Expect(0, 10495, '\p{^Is_Scx=_BRAI}', "");
    Expect(0, 10495, '\P{Is_Scx=_BRAI}', "");
    Expect(1, 10495, '\P{^Is_Scx=_BRAI}', "");
    Expect(0, 10496, '\p{Is_Scx=_BRAI}', "");
    Expect(1, 10496, '\p{^Is_Scx=_BRAI}', "");
    Expect(1, 10496, '\P{Is_Scx=_BRAI}', "");
    Expect(0, 10496, '\P{^Is_Scx=_BRAI}', "");
    Error('\p{Script_Extensions=:=  BUGINESE}');
    Error('\P{Script_Extensions=:=  BUGINESE}');
    Expect(1, 43471, '\p{Script_Extensions=:\ABuginese\z:}', "");;
    Expect(0, 43472, '\p{Script_Extensions=:\ABuginese\z:}', "");;
    Expect(1, 43471, '\p{Script_Extensions=buginese}', "");
    Expect(0, 43471, '\p{^Script_Extensions=buginese}', "");
    Expect(0, 43471, '\P{Script_Extensions=buginese}', "");
    Expect(1, 43471, '\P{^Script_Extensions=buginese}', "");
    Expect(0, 43472, '\p{Script_Extensions=buginese}', "");
    Expect(1, 43472, '\p{^Script_Extensions=buginese}', "");
    Expect(1, 43472, '\P{Script_Extensions=buginese}', "");
    Expect(0, 43472, '\P{^Script_Extensions=buginese}', "");
    Expect(1, 43471, '\p{Script_Extensions=:\Abuginese\z:}', "");;
    Expect(0, 43472, '\p{Script_Extensions=:\Abuginese\z:}', "");;
    Expect(1, 43471, '\p{Script_Extensions=	-Buginese}', "");
    Expect(0, 43471, '\p{^Script_Extensions=	-Buginese}', "");
    Expect(0, 43471, '\P{Script_Extensions=	-Buginese}', "");
    Expect(1, 43471, '\P{^Script_Extensions=	-Buginese}', "");
    Expect(0, 43472, '\p{Script_Extensions=	-Buginese}', "");
    Expect(1, 43472, '\p{^Script_Extensions=	-Buginese}', "");
    Expect(1, 43472, '\P{Script_Extensions=	-Buginese}', "");
    Expect(0, 43472, '\P{^Script_Extensions=	-Buginese}', "");
    Error('\p{Scx=/a/_bugi}');
    Error('\P{Scx=/a/_bugi}');
    Expect(1, 43471, '\p{Scx=:\ABugi\z:}', "");;
    Expect(0, 43472, '\p{Scx=:\ABugi\z:}', "");;
    Expect(1, 43471, '\p{Scx=bugi}', "");
    Expect(0, 43471, '\p{^Scx=bugi}', "");
    Expect(0, 43471, '\P{Scx=bugi}', "");
    Expect(1, 43471, '\P{^Scx=bugi}', "");
    Expect(0, 43472, '\p{Scx=bugi}', "");
    Expect(1, 43472, '\p{^Scx=bugi}', "");
    Expect(1, 43472, '\P{Scx=bugi}', "");
    Expect(0, 43472, '\P{^Scx=bugi}', "");
    Expect(1, 43471, '\p{Scx=:\Abugi\z:}', "");;
    Expect(0, 43472, '\p{Scx=:\Abugi\z:}', "");;
    Expect(1, 43471, '\p{Scx=_-Bugi}', "");
    Expect(0, 43471, '\p{^Scx=_-Bugi}', "");
    Expect(0, 43471, '\P{Scx=_-Bugi}', "");
    Expect(1, 43471, '\P{^Scx=_-Bugi}', "");
    Expect(0, 43472, '\p{Scx=_-Bugi}', "");
    Expect(1, 43472, '\p{^Scx=_-Bugi}', "");
    Expect(1, 43472, '\P{Scx=_-Bugi}', "");
    Expect(0, 43472, '\P{^Scx=_-Bugi}', "");
    Error('\p{Is_Script_Extensions=:=	BUGINESE}');
    Error('\P{Is_Script_Extensions=:=	BUGINESE}');
    Expect(1, 43471, '\p{Is_Script_Extensions=buginese}', "");
    Expect(0, 43471, '\p{^Is_Script_Extensions=buginese}', "");
    Expect(0, 43471, '\P{Is_Script_Extensions=buginese}', "");
    Expect(1, 43471, '\P{^Is_Script_Extensions=buginese}', "");
    Expect(0, 43472, '\p{Is_Script_Extensions=buginese}', "");
    Expect(1, 43472, '\p{^Is_Script_Extensions=buginese}', "");
    Expect(1, 43472, '\P{Is_Script_Extensions=buginese}', "");
    Expect(0, 43472, '\P{^Is_Script_Extensions=buginese}', "");
    Expect(1, 43471, '\p{Is_Script_Extensions= buginese}', "");
    Expect(0, 43471, '\p{^Is_Script_Extensions= buginese}', "");
    Expect(0, 43471, '\P{Is_Script_Extensions= buginese}', "");
    Expect(1, 43471, '\P{^Is_Script_Extensions= buginese}', "");
    Expect(0, 43472, '\p{Is_Script_Extensions= buginese}', "");
    Expect(1, 43472, '\p{^Is_Script_Extensions= buginese}', "");
    Expect(1, 43472, '\P{Is_Script_Extensions= buginese}', "");
    Expect(0, 43472, '\P{^Is_Script_Extensions= buginese}', "");
    Error('\p{Is_Scx: /a/-Bugi}');
    Error('\P{Is_Scx: /a/-Bugi}');
    Expect(1, 43471, '\p{Is_Scx=bugi}', "");
    Expect(0, 43471, '\p{^Is_Scx=bugi}', "");
    Expect(0, 43471, '\P{Is_Scx=bugi}', "");
    Expect(1, 43471, '\P{^Is_Scx=bugi}', "");
    Expect(0, 43472, '\p{Is_Scx=bugi}', "");
    Expect(1, 43472, '\p{^Is_Scx=bugi}', "");
    Expect(1, 43472, '\P{Is_Scx=bugi}', "");
    Expect(0, 43472, '\P{^Is_Scx=bugi}', "");
    Expect(1, 43471, '\p{Is_Scx=Bugi}', "");
    Expect(0, 43471, '\p{^Is_Scx=Bugi}', "");
    Expect(0, 43471, '\P{Is_Scx=Bugi}', "");
    Expect(1, 43471, '\P{^Is_Scx=Bugi}', "");
    Expect(0, 43472, '\p{Is_Scx=Bugi}', "");
    Expect(1, 43472, '\p{^Is_Scx=Bugi}', "");
    Expect(1, 43472, '\P{Is_Scx=Bugi}', "");
    Expect(0, 43472, '\P{^Is_Scx=Bugi}', "");
    Error('\p{Script_Extensions=:=  Buhid}');
    Error('\P{Script_Extensions=:=  Buhid}');
    Expect(1, 5971, '\p{Script_Extensions=:\ABuhid\z:}', "");;
    Expect(0, 5972, '\p{Script_Extensions=:\ABuhid\z:}', "");;
    Expect(1, 5971, '\p{Script_Extensions=buhid}', "");
    Expect(0, 5971, '\p{^Script_Extensions=buhid}', "");
    Expect(0, 5971, '\P{Script_Extensions=buhid}', "");
    Expect(1, 5971, '\P{^Script_Extensions=buhid}', "");
    Expect(0, 5972, '\p{Script_Extensions=buhid}', "");
    Expect(1, 5972, '\p{^Script_Extensions=buhid}', "");
    Expect(1, 5972, '\P{Script_Extensions=buhid}', "");
    Expect(0, 5972, '\P{^Script_Extensions=buhid}', "");
    Expect(1, 5971, '\p{Script_Extensions=:\Abuhid\z:}', "");;
    Expect(0, 5972, '\p{Script_Extensions=:\Abuhid\z:}', "");;
    Expect(1, 5971, '\p{Script_Extensions=		BUHID}', "");
    Expect(0, 5971, '\p{^Script_Extensions=		BUHID}', "");
    Expect(0, 5971, '\P{Script_Extensions=		BUHID}', "");
    Expect(1, 5971, '\P{^Script_Extensions=		BUHID}', "");
    Expect(0, 5972, '\p{Script_Extensions=		BUHID}', "");
    Expect(1, 5972, '\p{^Script_Extensions=		BUHID}', "");
    Expect(1, 5972, '\P{Script_Extensions=		BUHID}', "");
    Expect(0, 5972, '\P{^Script_Extensions=		BUHID}', "");
    Error('\p{Scx=- Buhd/a/}');
    Error('\P{Scx=- Buhd/a/}');
    Expect(1, 5971, '\p{Scx=:\ABuhd\z:}', "");;
    Expect(0, 5972, '\p{Scx=:\ABuhd\z:}', "");;
    Expect(1, 5971, '\p{Scx=buhd}', "");
    Expect(0, 5971, '\p{^Scx=buhd}', "");
    Expect(0, 5971, '\P{Scx=buhd}', "");
    Expect(1, 5971, '\P{^Scx=buhd}', "");
    Expect(0, 5972, '\p{Scx=buhd}', "");
    Expect(1, 5972, '\p{^Scx=buhd}', "");
    Expect(1, 5972, '\P{Scx=buhd}', "");
    Expect(0, 5972, '\P{^Scx=buhd}', "");
    Expect(1, 5971, '\p{Scx=:\Abuhd\z:}', "");;
    Expect(0, 5972, '\p{Scx=:\Abuhd\z:}', "");;
    Expect(1, 5971, '\p{Scx=-buhd}', "");
    Expect(0, 5971, '\p{^Scx=-buhd}', "");
    Expect(0, 5971, '\P{Scx=-buhd}', "");
    Expect(1, 5971, '\P{^Scx=-buhd}', "");
    Expect(0, 5972, '\p{Scx=-buhd}', "");
    Expect(1, 5972, '\p{^Scx=-buhd}', "");
    Expect(1, 5972, '\P{Scx=-buhd}', "");
    Expect(0, 5972, '\P{^Scx=-buhd}', "");
    Error('\p{Is_Script_Extensions= :=Buhid}');
    Error('\P{Is_Script_Extensions= :=Buhid}');
    Expect(1, 5971, '\p{Is_Script_Extensions=buhid}', "");
    Expect(0, 5971, '\p{^Is_Script_Extensions=buhid}', "");
    Expect(0, 5971, '\P{Is_Script_Extensions=buhid}', "");
    Expect(1, 5971, '\P{^Is_Script_Extensions=buhid}', "");
    Expect(0, 5972, '\p{Is_Script_Extensions=buhid}', "");
    Expect(1, 5972, '\p{^Is_Script_Extensions=buhid}', "");
    Expect(1, 5972, '\P{Is_Script_Extensions=buhid}', "");
    Expect(0, 5972, '\P{^Is_Script_Extensions=buhid}', "");
    Expect(1, 5971, '\p{Is_Script_Extensions=-buhid}', "");
    Expect(0, 5971, '\p{^Is_Script_Extensions=-buhid}', "");
    Expect(0, 5971, '\P{Is_Script_Extensions=-buhid}', "");
    Expect(1, 5971, '\P{^Is_Script_Extensions=-buhid}', "");
    Expect(0, 5972, '\p{Is_Script_Extensions=-buhid}', "");
    Expect(1, 5972, '\p{^Is_Script_Extensions=-buhid}', "");
    Expect(1, 5972, '\P{Is_Script_Extensions=-buhid}', "");
    Expect(0, 5972, '\P{^Is_Script_Extensions=-buhid}', "");
    Error('\p{Is_Scx=_	Buhd/a/}');
    Error('\P{Is_Scx=_	Buhd/a/}');
    Expect(1, 5971, '\p{Is_Scx=buhd}', "");
    Expect(0, 5971, '\p{^Is_Scx=buhd}', "");
    Expect(0, 5971, '\P{Is_Scx=buhd}', "");
    Expect(1, 5971, '\P{^Is_Scx=buhd}', "");
    Expect(0, 5972, '\p{Is_Scx=buhd}', "");
    Expect(1, 5972, '\p{^Is_Scx=buhd}', "");
    Expect(1, 5972, '\P{Is_Scx=buhd}', "");
    Expect(0, 5972, '\P{^Is_Scx=buhd}', "");
    Expect(1, 5971, '\p{Is_Scx=		Buhd}', "");
    Expect(0, 5971, '\p{^Is_Scx=		Buhd}', "");
    Expect(0, 5971, '\P{Is_Scx=		Buhd}', "");
    Expect(1, 5971, '\P{^Is_Scx=		Buhd}', "");
    Expect(0, 5972, '\p{Is_Scx=		Buhd}', "");
    Expect(1, 5972, '\p{^Is_Scx=		Buhd}', "");
    Expect(1, 5972, '\P{Is_Scx=		Buhd}', "");
    Expect(0, 5972, '\P{^Is_Scx=		Buhd}', "");
    Error('\p{Script_Extensions=-/a/Chakma}');
    Error('\P{Script_Extensions=-/a/Chakma}');
    Expect(1, 69959, '\p{Script_Extensions=:\AChakma\z:}', "");;
    Expect(0, 69960, '\p{Script_Extensions=:\AChakma\z:}', "");;
    Expect(1, 69959, '\p{Script_Extensions=chakma}', "");
    Expect(0, 69959, '\p{^Script_Extensions=chakma}', "");
    Expect(0, 69959, '\P{Script_Extensions=chakma}', "");
    Expect(1, 69959, '\P{^Script_Extensions=chakma}', "");
    Expect(0, 69960, '\p{Script_Extensions=chakma}', "");
    Expect(1, 69960, '\p{^Script_Extensions=chakma}', "");
    Expect(1, 69960, '\P{Script_Extensions=chakma}', "");
    Expect(0, 69960, '\P{^Script_Extensions=chakma}', "");
    Expect(1, 69959, '\p{Script_Extensions=:\Achakma\z:}', "");;
    Expect(0, 69960, '\p{Script_Extensions=:\Achakma\z:}', "");;
    Expect(1, 69959, '\p{Script_Extensions=__chakma}', "");
    Expect(0, 69959, '\p{^Script_Extensions=__chakma}', "");
    Expect(0, 69959, '\P{Script_Extensions=__chakma}', "");
    Expect(1, 69959, '\P{^Script_Extensions=__chakma}', "");
    Expect(0, 69960, '\p{Script_Extensions=__chakma}', "");
    Expect(1, 69960, '\p{^Script_Extensions=__chakma}', "");
    Expect(1, 69960, '\P{Script_Extensions=__chakma}', "");
    Expect(0, 69960, '\P{^Script_Extensions=__chakma}', "");
    Error('\p{Scx:/a/  cakm}');
    Error('\P{Scx:/a/  cakm}');
    Expect(1, 69959, '\p{Scx=:\ACakm\z:}', "");;
    Expect(0, 69960, '\p{Scx=:\ACakm\z:}', "");;
    Expect(1, 69959, '\p{Scx=cakm}', "");
    Expect(0, 69959, '\p{^Scx=cakm}', "");
    Expect(0, 69959, '\P{Scx=cakm}', "");
    Expect(1, 69959, '\P{^Scx=cakm}', "");
    Expect(0, 69960, '\p{Scx=cakm}', "");
    Expect(1, 69960, '\p{^Scx=cakm}', "");
    Expect(1, 69960, '\P{Scx=cakm}', "");
    Expect(0, 69960, '\P{^Scx=cakm}', "");
    Expect(1, 69959, '\p{Scx=:\Acakm\z:}', "");;
    Expect(0, 69960, '\p{Scx=:\Acakm\z:}', "");;
    Expect(1, 69959, '\p{Scx=_Cakm}', "");
    Expect(0, 69959, '\p{^Scx=_Cakm}', "");
    Expect(0, 69959, '\P{Scx=_Cakm}', "");
    Expect(1, 69959, '\P{^Scx=_Cakm}', "");
    Expect(0, 69960, '\p{Scx=_Cakm}', "");
    Expect(1, 69960, '\p{^Scx=_Cakm}', "");
    Expect(1, 69960, '\P{Scx=_Cakm}', "");
    Expect(0, 69960, '\P{^Scx=_Cakm}', "");
    Error('\p{Is_Script_Extensions=	:=Chakma}');
    Error('\P{Is_Script_Extensions=	:=Chakma}');
    Expect(1, 69959, '\p{Is_Script_Extensions=chakma}', "");
    Expect(0, 69959, '\p{^Is_Script_Extensions=chakma}', "");
    Expect(0, 69959, '\P{Is_Script_Extensions=chakma}', "");
    Expect(1, 69959, '\P{^Is_Script_Extensions=chakma}', "");
    Expect(0, 69960, '\p{Is_Script_Extensions=chakma}', "");
    Expect(1, 69960, '\p{^Is_Script_Extensions=chakma}', "");
    Expect(1, 69960, '\P{Is_Script_Extensions=chakma}', "");
    Expect(0, 69960, '\P{^Is_Script_Extensions=chakma}', "");
    Expect(1, 69959, '\p{Is_Script_Extensions= -CHAKMA}', "");
    Expect(0, 69959, '\p{^Is_Script_Extensions= -CHAKMA}', "");
    Expect(0, 69959, '\P{Is_Script_Extensions= -CHAKMA}', "");
    Expect(1, 69959, '\P{^Is_Script_Extensions= -CHAKMA}', "");
    Expect(0, 69960, '\p{Is_Script_Extensions= -CHAKMA}', "");
    Expect(1, 69960, '\p{^Is_Script_Extensions= -CHAKMA}', "");
    Expect(1, 69960, '\P{Is_Script_Extensions= -CHAKMA}', "");
    Expect(0, 69960, '\P{^Is_Script_Extensions= -CHAKMA}', "");
    Error('\p{Is_Scx: 	/a/CAKM}');
    Error('\P{Is_Scx: 	/a/CAKM}');
    Expect(1, 69959, '\p{Is_Scx=cakm}', "");
    Expect(0, 69959, '\p{^Is_Scx=cakm}', "");
    Expect(0, 69959, '\P{Is_Scx=cakm}', "");
    Expect(1, 69959, '\P{^Is_Scx=cakm}', "");
    Expect(0, 69960, '\p{Is_Scx=cakm}', "");
    Expect(1, 69960, '\p{^Is_Scx=cakm}', "");
    Expect(1, 69960, '\P{Is_Scx=cakm}', "");
    Expect(0, 69960, '\P{^Is_Scx=cakm}', "");
    Expect(1, 69959, '\p{Is_Scx=Cakm}', "");
    Expect(0, 69959, '\p{^Is_Scx=Cakm}', "");
    Expect(0, 69959, '\P{Is_Scx=Cakm}', "");
    Expect(1, 69959, '\P{^Is_Scx=Cakm}', "");
    Expect(0, 69960, '\p{Is_Scx=Cakm}', "");
    Expect(1, 69960, '\p{^Is_Scx=Cakm}', "");
    Expect(1, 69960, '\P{Is_Scx=Cakm}', "");
    Expect(0, 69960, '\P{^Is_Scx=Cakm}', "");
    Error('\p{Script_Extensions: -_canadian_ABORIGINAL/a/}');
    Error('\P{Script_Extensions: -_canadian_ABORIGINAL/a/}');
    Expect(1, 72383, '\p{Script_Extensions=:\ACanadian_Aboriginal\z:}', "");;
    Expect(0, 72384, '\p{Script_Extensions=:\ACanadian_Aboriginal\z:}', "");;
    Expect(1, 72383, '\p{Script_Extensions:canadianaboriginal}', "");
    Expect(0, 72383, '\p{^Script_Extensions:canadianaboriginal}', "");
    Expect(0, 72383, '\P{Script_Extensions:canadianaboriginal}', "");
    Expect(1, 72383, '\P{^Script_Extensions:canadianaboriginal}', "");
    Expect(0, 72384, '\p{Script_Extensions:canadianaboriginal}', "");
    Expect(1, 72384, '\p{^Script_Extensions:canadianaboriginal}', "");
    Expect(1, 72384, '\P{Script_Extensions:canadianaboriginal}', "");
    Expect(0, 72384, '\P{^Script_Extensions:canadianaboriginal}', "");
    Expect(1, 72383, '\p{Script_Extensions=:\Acanadianaboriginal\z:}', "");;
    Expect(0, 72384, '\p{Script_Extensions=:\Acanadianaboriginal\z:}', "");;
    Expect(1, 72383, '\p{Script_Extensions=	Canadian_Aboriginal}', "");
    Expect(0, 72383, '\p{^Script_Extensions=	Canadian_Aboriginal}', "");
    Expect(0, 72383, '\P{Script_Extensions=	Canadian_Aboriginal}', "");
    Expect(1, 72383, '\P{^Script_Extensions=	Canadian_Aboriginal}', "");
    Expect(0, 72384, '\p{Script_Extensions=	Canadian_Aboriginal}', "");
    Expect(1, 72384, '\p{^Script_Extensions=	Canadian_Aboriginal}', "");
    Expect(1, 72384, '\P{Script_Extensions=	Canadian_Aboriginal}', "");
    Expect(0, 72384, '\P{^Script_Extensions=	Canadian_Aboriginal}', "");
    Error('\p{Scx=_:=Cans}');
    Error('\P{Scx=_:=Cans}');
    Expect(1, 72383, '\p{Scx=:\ACans\z:}', "");;
    Expect(0, 72384, '\p{Scx=:\ACans\z:}', "");;
    Expect(1, 72383, '\p{Scx=cans}', "");
    Expect(0, 72383, '\p{^Scx=cans}', "");
    Expect(0, 72383, '\P{Scx=cans}', "");
    Expect(1, 72383, '\P{^Scx=cans}', "");
    Expect(0, 72384, '\p{Scx=cans}', "");
    Expect(1, 72384, '\p{^Scx=cans}', "");
    Expect(1, 72384, '\P{Scx=cans}', "");
    Expect(0, 72384, '\P{^Scx=cans}', "");
    Expect(1, 72383, '\p{Scx=:\Acans\z:}', "");;
    Expect(0, 72384, '\p{Scx=:\Acans\z:}', "");;
    Expect(1, 72383, '\p{Scx=_ CANS}', "");
    Expect(0, 72383, '\p{^Scx=_ CANS}', "");
    Expect(0, 72383, '\P{Scx=_ CANS}', "");
    Expect(1, 72383, '\P{^Scx=_ CANS}', "");
    Expect(0, 72384, '\p{Scx=_ CANS}', "");
    Expect(1, 72384, '\p{^Scx=_ CANS}', "");
    Expect(1, 72384, '\P{Scx=_ CANS}', "");
    Expect(0, 72384, '\P{^Scx=_ CANS}', "");
    Error('\p{Is_Script_Extensions=- CANADIAN_Aboriginal:=}');
    Error('\P{Is_Script_Extensions=- CANADIAN_Aboriginal:=}');
    Expect(1, 72383, '\p{Is_Script_Extensions=canadianaboriginal}', "");
    Expect(0, 72383, '\p{^Is_Script_Extensions=canadianaboriginal}', "");
    Expect(0, 72383, '\P{Is_Script_Extensions=canadianaboriginal}', "");
    Expect(1, 72383, '\P{^Is_Script_Extensions=canadianaboriginal}', "");
    Expect(0, 72384, '\p{Is_Script_Extensions=canadianaboriginal}', "");
    Expect(1, 72384, '\p{^Is_Script_Extensions=canadianaboriginal}', "");
    Expect(1, 72384, '\P{Is_Script_Extensions=canadianaboriginal}', "");
    Expect(0, 72384, '\P{^Is_Script_Extensions=canadianaboriginal}', "");
    Expect(1, 72383, '\p{Is_Script_Extensions=  canadian_Aboriginal}', "");
    Expect(0, 72383, '\p{^Is_Script_Extensions=  canadian_Aboriginal}', "");
    Expect(0, 72383, '\P{Is_Script_Extensions=  canadian_Aboriginal}', "");
    Expect(1, 72383, '\P{^Is_Script_Extensions=  canadian_Aboriginal}', "");
    Expect(0, 72384, '\p{Is_Script_Extensions=  canadian_Aboriginal}', "");
    Expect(1, 72384, '\p{^Is_Script_Extensions=  canadian_Aboriginal}', "");
    Expect(1, 72384, '\P{Is_Script_Extensions=  canadian_Aboriginal}', "");
    Expect(0, 72384, '\P{^Is_Script_Extensions=  canadian_Aboriginal}', "");
    Error('\p{Is_Scx=:=	_CANS}');
    Error('\P{Is_Scx=:=	_CANS}');
    Expect(1, 72383, '\p{Is_Scx=cans}', "");
    Expect(0, 72383, '\p{^Is_Scx=cans}', "");
    Expect(0, 72383, '\P{Is_Scx=cans}', "");
    Expect(1, 72383, '\P{^Is_Scx=cans}', "");
    Expect(0, 72384, '\p{Is_Scx=cans}', "");
    Expect(1, 72384, '\p{^Is_Scx=cans}', "");
    Expect(1, 72384, '\P{Is_Scx=cans}', "");
    Expect(0, 72384, '\P{^Is_Scx=cans}', "");
    Expect(1, 72383, '\p{Is_Scx=--Cans}', "");
    Expect(0, 72383, '\p{^Is_Scx=--Cans}', "");
    Expect(0, 72383, '\P{Is_Scx=--Cans}', "");
    Expect(1, 72383, '\P{^Is_Scx=--Cans}', "");
    Expect(0, 72384, '\p{Is_Scx=--Cans}', "");
    Expect(1, 72384, '\p{^Is_Scx=--Cans}', "");
    Expect(1, 72384, '\P{Is_Scx=--Cans}', "");
    Expect(0, 72384, '\P{^Is_Scx=--Cans}', "");
    Error('\p{Script_Extensions= -Carian:=}');
    Error('\P{Script_Extensions= -Carian:=}');
    Expect(1, 66256, '\p{Script_Extensions=:\ACarian\z:}', "");;
    Expect(0, 66257, '\p{Script_Extensions=:\ACarian\z:}', "");;
    Expect(1, 66256, '\p{Script_Extensions=carian}', "");
    Expect(0, 66256, '\p{^Script_Extensions=carian}', "");
    Expect(0, 66256, '\P{Script_Extensions=carian}', "");
    Expect(1, 66256, '\P{^Script_Extensions=carian}', "");
    Expect(0, 66257, '\p{Script_Extensions=carian}', "");
    Expect(1, 66257, '\p{^Script_Extensions=carian}', "");
    Expect(1, 66257, '\P{Script_Extensions=carian}', "");
    Expect(0, 66257, '\P{^Script_Extensions=carian}', "");
    Expect(1, 66256, '\p{Script_Extensions=:\Acarian\z:}', "");;
    Expect(0, 66257, '\p{Script_Extensions=:\Acarian\z:}', "");;
    Expect(1, 66256, '\p{Script_Extensions:   --Carian}', "");
    Expect(0, 66256, '\p{^Script_Extensions:   --Carian}', "");
    Expect(0, 66256, '\P{Script_Extensions:   --Carian}', "");
    Expect(1, 66256, '\P{^Script_Extensions:   --Carian}', "");
    Expect(0, 66257, '\p{Script_Extensions:   --Carian}', "");
    Expect(1, 66257, '\p{^Script_Extensions:   --Carian}', "");
    Expect(1, 66257, '\P{Script_Extensions:   --Carian}', "");
    Expect(0, 66257, '\P{^Script_Extensions:   --Carian}', "");
    Error('\p{Scx=CARI/a/}');
    Error('\P{Scx=CARI/a/}');
    Expect(1, 66256, '\p{Scx=:\ACari\z:}', "");;
    Expect(0, 66257, '\p{Scx=:\ACari\z:}', "");;
    Expect(1, 66256, '\p{Scx=cari}', "");
    Expect(0, 66256, '\p{^Scx=cari}', "");
    Expect(0, 66256, '\P{Scx=cari}', "");
    Expect(1, 66256, '\P{^Scx=cari}', "");
    Expect(0, 66257, '\p{Scx=cari}', "");
    Expect(1, 66257, '\p{^Scx=cari}', "");
    Expect(1, 66257, '\P{Scx=cari}', "");
    Expect(0, 66257, '\P{^Scx=cari}', "");
    Expect(1, 66256, '\p{Scx=:\Acari\z:}', "");;
    Expect(0, 66257, '\p{Scx=:\Acari\z:}', "");;
    Expect(1, 66256, '\p{Scx= -CARI}', "");
    Expect(0, 66256, '\p{^Scx= -CARI}', "");
    Expect(0, 66256, '\P{Scx= -CARI}', "");
    Expect(1, 66256, '\P{^Scx= -CARI}', "");
    Expect(0, 66257, '\p{Scx= -CARI}', "");
    Expect(1, 66257, '\p{^Scx= -CARI}', "");
    Expect(1, 66257, '\P{Scx= -CARI}', "");
    Expect(0, 66257, '\P{^Scx= -CARI}', "");
    Error('\p{Is_Script_Extensions=		CARIAN/a/}');
    Error('\P{Is_Script_Extensions=		CARIAN/a/}');
    Expect(1, 66256, '\p{Is_Script_Extensions:	carian}', "");
    Expect(0, 66256, '\p{^Is_Script_Extensions:	carian}', "");
    Expect(0, 66256, '\P{Is_Script_Extensions:	carian}', "");
    Expect(1, 66256, '\P{^Is_Script_Extensions:	carian}', "");
    Expect(0, 66257, '\p{Is_Script_Extensions:	carian}', "");
    Expect(1, 66257, '\p{^Is_Script_Extensions:	carian}', "");
    Expect(1, 66257, '\P{Is_Script_Extensions:	carian}', "");
    Expect(0, 66257, '\P{^Is_Script_Extensions:	carian}', "");
    Expect(1, 66256, '\p{Is_Script_Extensions=_ CARIAN}', "");
    Expect(0, 66256, '\p{^Is_Script_Extensions=_ CARIAN}', "");
    Expect(0, 66256, '\P{Is_Script_Extensions=_ CARIAN}', "");
    Expect(1, 66256, '\P{^Is_Script_Extensions=_ CARIAN}', "");
    Expect(0, 66257, '\p{Is_Script_Extensions=_ CARIAN}', "");
    Expect(1, 66257, '\p{^Is_Script_Extensions=_ CARIAN}', "");
    Expect(1, 66257, '\P{Is_Script_Extensions=_ CARIAN}', "");
    Expect(0, 66257, '\P{^Is_Script_Extensions=_ CARIAN}', "");
    Error('\p{Is_Scx=	 cari:=}');
    Error('\P{Is_Scx=	 cari:=}');
    Expect(1, 66256, '\p{Is_Scx=cari}', "");
    Expect(0, 66256, '\p{^Is_Scx=cari}', "");
    Expect(0, 66256, '\P{Is_Scx=cari}', "");
    Expect(1, 66256, '\P{^Is_Scx=cari}', "");
    Expect(0, 66257, '\p{Is_Scx=cari}', "");
    Expect(1, 66257, '\p{^Is_Scx=cari}', "");
    Expect(1, 66257, '\P{Is_Scx=cari}', "");
    Expect(0, 66257, '\P{^Is_Scx=cari}', "");
    Expect(1, 66256, '\p{Is_Scx= 	Cari}', "");
    Expect(0, 66256, '\p{^Is_Scx= 	Cari}', "");
    Expect(0, 66256, '\P{Is_Scx= 	Cari}', "");
    Expect(1, 66256, '\P{^Is_Scx= 	Cari}', "");
    Expect(0, 66257, '\p{Is_Scx= 	Cari}', "");
    Expect(1, 66257, '\p{^Is_Scx= 	Cari}', "");
    Expect(1, 66257, '\P{Is_Scx= 	Cari}', "");
    Expect(0, 66257, '\P{^Is_Scx= 	Cari}', "");
    Error('\p{Script_Extensions=:=_	Cham}');
    Error('\P{Script_Extensions=:=_	Cham}');
    Expect(1, 43615, '\p{Script_Extensions=:\ACham\z:}', "");;
    Expect(0, 43616, '\p{Script_Extensions=:\ACham\z:}', "");;
    Expect(1, 43615, '\p{Script_Extensions=cham}', "");
    Expect(0, 43615, '\p{^Script_Extensions=cham}', "");
    Expect(0, 43615, '\P{Script_Extensions=cham}', "");
    Expect(1, 43615, '\P{^Script_Extensions=cham}', "");
    Expect(0, 43616, '\p{Script_Extensions=cham}', "");
    Expect(1, 43616, '\p{^Script_Extensions=cham}', "");
    Expect(1, 43616, '\P{Script_Extensions=cham}', "");
    Expect(0, 43616, '\P{^Script_Extensions=cham}', "");
    Expect(1, 43615, '\p{Script_Extensions=:\Acham\z:}', "");;
    Expect(0, 43616, '\p{Script_Extensions=:\Acham\z:}', "");;
    Expect(1, 43615, '\p{Script_Extensions=__Cham}', "");
    Expect(0, 43615, '\p{^Script_Extensions=__Cham}', "");
    Expect(0, 43615, '\P{Script_Extensions=__Cham}', "");
    Expect(1, 43615, '\P{^Script_Extensions=__Cham}', "");
    Expect(0, 43616, '\p{Script_Extensions=__Cham}', "");
    Expect(1, 43616, '\p{^Script_Extensions=__Cham}', "");
    Expect(1, 43616, '\P{Script_Extensions=__Cham}', "");
    Expect(0, 43616, '\P{^Script_Extensions=__Cham}', "");
    Error('\p{Scx=:=_Cham}');
    Error('\P{Scx=:=_Cham}');
    Expect(1, 43615, '\p{Scx=:\ACham\z:}', "");;
    Expect(0, 43616, '\p{Scx=:\ACham\z:}', "");;
    Expect(1, 43615, '\p{Scx=cham}', "");
    Expect(0, 43615, '\p{^Scx=cham}', "");
    Expect(0, 43615, '\P{Scx=cham}', "");
    Expect(1, 43615, '\P{^Scx=cham}', "");
    Expect(0, 43616, '\p{Scx=cham}', "");
    Expect(1, 43616, '\p{^Scx=cham}', "");
    Expect(1, 43616, '\P{Scx=cham}', "");
    Expect(0, 43616, '\P{^Scx=cham}', "");
    Expect(1, 43615, '\p{Scx=:\Acham\z:}', "");;
    Expect(0, 43616, '\p{Scx=:\Acham\z:}', "");;
    Expect(1, 43615, '\p{Scx=	-CHAM}', "");
    Expect(0, 43615, '\p{^Scx=	-CHAM}', "");
    Expect(0, 43615, '\P{Scx=	-CHAM}', "");
    Expect(1, 43615, '\P{^Scx=	-CHAM}', "");
    Expect(0, 43616, '\p{Scx=	-CHAM}', "");
    Expect(1, 43616, '\p{^Scx=	-CHAM}', "");
    Expect(1, 43616, '\P{Scx=	-CHAM}', "");
    Expect(0, 43616, '\P{^Scx=	-CHAM}', "");
    Error('\p{Is_Script_Extensions=	-cham/a/}');
    Error('\P{Is_Script_Extensions=	-cham/a/}');
    Expect(1, 43615, '\p{Is_Script_Extensions=cham}', "");
    Expect(0, 43615, '\p{^Is_Script_Extensions=cham}', "");
    Expect(0, 43615, '\P{Is_Script_Extensions=cham}', "");
    Expect(1, 43615, '\P{^Is_Script_Extensions=cham}', "");
    Expect(0, 43616, '\p{Is_Script_Extensions=cham}', "");
    Expect(1, 43616, '\p{^Is_Script_Extensions=cham}', "");
    Expect(1, 43616, '\P{Is_Script_Extensions=cham}', "");
    Expect(0, 43616, '\P{^Is_Script_Extensions=cham}', "");
    Expect(1, 43615, '\p{Is_Script_Extensions=_CHAM}', "");
    Expect(0, 43615, '\p{^Is_Script_Extensions=_CHAM}', "");
    Expect(0, 43615, '\P{Is_Script_Extensions=_CHAM}', "");
    Expect(1, 43615, '\P{^Is_Script_Extensions=_CHAM}', "");
    Expect(0, 43616, '\p{Is_Script_Extensions=_CHAM}', "");
    Expect(1, 43616, '\p{^Is_Script_Extensions=_CHAM}', "");
    Expect(1, 43616, '\P{Is_Script_Extensions=_CHAM}', "");
    Expect(0, 43616, '\P{^Is_Script_Extensions=_CHAM}', "");
    Error('\p{Is_Scx=	CHAM:=}');
    Error('\P{Is_Scx=	CHAM:=}');
    Expect(1, 43615, '\p{Is_Scx=cham}', "");
    Expect(0, 43615, '\p{^Is_Scx=cham}', "");
    Expect(0, 43615, '\P{Is_Scx=cham}', "");
    Expect(1, 43615, '\P{^Is_Scx=cham}', "");
    Expect(0, 43616, '\p{Is_Scx=cham}', "");
    Expect(1, 43616, '\p{^Is_Scx=cham}', "");
    Expect(1, 43616, '\P{Is_Scx=cham}', "");
    Expect(0, 43616, '\P{^Is_Scx=cham}', "");
    Expect(1, 43615, '\p{Is_Scx=-_Cham}', "");
    Expect(0, 43615, '\p{^Is_Scx=-_Cham}', "");
    Expect(0, 43615, '\P{Is_Scx=-_Cham}', "");
    Expect(1, 43615, '\P{^Is_Scx=-_Cham}', "");
    Expect(0, 43616, '\p{Is_Scx=-_Cham}', "");
    Expect(1, 43616, '\p{^Is_Scx=-_Cham}', "");
    Expect(1, 43616, '\P{Is_Scx=-_Cham}', "");
    Expect(0, 43616, '\P{^Is_Scx=-_Cham}', "");
    Error('\p{Script_Extensions=_:=CHEROKEE}');
    Error('\P{Script_Extensions=_:=CHEROKEE}');
    Expect(1, 43967, '\p{Script_Extensions=:\ACherokee\z:}', "");;
    Expect(0, 43968, '\p{Script_Extensions=:\ACherokee\z:}', "");;
    Expect(1, 43967, '\p{Script_Extensions:cherokee}', "");
    Expect(0, 43967, '\p{^Script_Extensions:cherokee}', "");
    Expect(0, 43967, '\P{Script_Extensions:cherokee}', "");
    Expect(1, 43967, '\P{^Script_Extensions:cherokee}', "");
    Expect(0, 43968, '\p{Script_Extensions:cherokee}', "");
    Expect(1, 43968, '\p{^Script_Extensions:cherokee}', "");
    Expect(1, 43968, '\P{Script_Extensions:cherokee}', "");
    Expect(0, 43968, '\P{^Script_Extensions:cherokee}', "");
    Expect(1, 43967, '\p{Script_Extensions=:\Acherokee\z:}', "");;
    Expect(0, 43968, '\p{Script_Extensions=:\Acherokee\z:}', "");;
    Expect(1, 43967, '\p{Script_Extensions=  CHEROKEE}', "");
    Expect(0, 43967, '\p{^Script_Extensions=  CHEROKEE}', "");
    Expect(0, 43967, '\P{Script_Extensions=  CHEROKEE}', "");
    Expect(1, 43967, '\P{^Script_Extensions=  CHEROKEE}', "");
    Expect(0, 43968, '\p{Script_Extensions=  CHEROKEE}', "");
    Expect(1, 43968, '\p{^Script_Extensions=  CHEROKEE}', "");
    Expect(1, 43968, '\P{Script_Extensions=  CHEROKEE}', "");
    Expect(0, 43968, '\P{^Script_Extensions=  CHEROKEE}', "");
    Error('\p{Scx=-_cher/a/}');
    Error('\P{Scx=-_cher/a/}');
    Expect(1, 43967, '\p{Scx=:\ACher\z:}', "");;
    Expect(0, 43968, '\p{Scx=:\ACher\z:}', "");;
    Expect(1, 43967, '\p{Scx:   cher}', "");
    Expect(0, 43967, '\p{^Scx:   cher}', "");
    Expect(0, 43967, '\P{Scx:   cher}', "");
    Expect(1, 43967, '\P{^Scx:   cher}', "");
    Expect(0, 43968, '\p{Scx:   cher}', "");
    Expect(1, 43968, '\p{^Scx:   cher}', "");
    Expect(1, 43968, '\P{Scx:   cher}', "");
    Expect(0, 43968, '\P{^Scx:   cher}', "");
    Expect(1, 43967, '\p{Scx=:\Acher\z:}', "");;
    Expect(0, 43968, '\p{Scx=:\Acher\z:}', "");;
    Expect(1, 43967, '\p{Scx=-Cher}', "");
    Expect(0, 43967, '\p{^Scx=-Cher}', "");
    Expect(0, 43967, '\P{Scx=-Cher}', "");
    Expect(1, 43967, '\P{^Scx=-Cher}', "");
    Expect(0, 43968, '\p{Scx=-Cher}', "");
    Expect(1, 43968, '\p{^Scx=-Cher}', "");
    Expect(1, 43968, '\P{Scx=-Cher}', "");
    Expect(0, 43968, '\P{^Scx=-Cher}', "");
    Error('\p{Is_Script_Extensions= /a/Cherokee}');
    Error('\P{Is_Script_Extensions= /a/Cherokee}');
    Expect(1, 43967, '\p{Is_Script_Extensions=cherokee}', "");
    Expect(0, 43967, '\p{^Is_Script_Extensions=cherokee}', "");
    Expect(0, 43967, '\P{Is_Script_Extensions=cherokee}', "");
    Expect(1, 43967, '\P{^Is_Script_Extensions=cherokee}', "");
    Expect(0, 43968, '\p{Is_Script_Extensions=cherokee}', "");
    Expect(1, 43968, '\p{^Is_Script_Extensions=cherokee}', "");
    Expect(1, 43968, '\P{Is_Script_Extensions=cherokee}', "");
    Expect(0, 43968, '\P{^Is_Script_Extensions=cherokee}', "");
    Expect(1, 43967, '\p{Is_Script_Extensions=	CHEROKEE}', "");
    Expect(0, 43967, '\p{^Is_Script_Extensions=	CHEROKEE}', "");
    Expect(0, 43967, '\P{Is_Script_Extensions=	CHEROKEE}', "");
    Expect(1, 43967, '\P{^Is_Script_Extensions=	CHEROKEE}', "");
    Expect(0, 43968, '\p{Is_Script_Extensions=	CHEROKEE}', "");
    Expect(1, 43968, '\p{^Is_Script_Extensions=	CHEROKEE}', "");
    Expect(1, 43968, '\P{Is_Script_Extensions=	CHEROKEE}', "");
    Expect(0, 43968, '\P{^Is_Script_Extensions=	CHEROKEE}', "");
    Error('\p{Is_Scx=	/a/cher}');
    Error('\P{Is_Scx=	/a/cher}');
    Expect(1, 43967, '\p{Is_Scx=cher}', "");
    Expect(0, 43967, '\p{^Is_Scx=cher}', "");
    Expect(0, 43967, '\P{Is_Scx=cher}', "");
    Expect(1, 43967, '\P{^Is_Scx=cher}', "");
    Expect(0, 43968, '\p{Is_Scx=cher}', "");
    Expect(1, 43968, '\p{^Is_Scx=cher}', "");
    Expect(1, 43968, '\P{Is_Scx=cher}', "");
    Expect(0, 43968, '\P{^Is_Scx=cher}', "");
    Expect(1, 43967, '\p{Is_Scx=-cher}', "");
    Expect(0, 43967, '\p{^Is_Scx=-cher}', "");
    Expect(0, 43967, '\P{Is_Scx=-cher}', "");
    Expect(1, 43967, '\P{^Is_Scx=-cher}', "");
    Expect(0, 43968, '\p{Is_Scx=-cher}', "");
    Expect(1, 43968, '\p{^Is_Scx=-cher}', "");
    Expect(1, 43968, '\P{Is_Scx=-cher}', "");
    Expect(0, 43968, '\P{^Is_Scx=-cher}', "");
    Error('\p{Script_Extensions=/a/ CHORASMIAN}');
    Error('\P{Script_Extensions=/a/ CHORASMIAN}');
    Expect(1, 69579, '\p{Script_Extensions=:\AChorasmian\z:}', "");;
    Expect(0, 69580, '\p{Script_Extensions=:\AChorasmian\z:}', "");;
    Expect(1, 69579, '\p{Script_Extensions=chorasmian}', "");
    Expect(0, 69579, '\p{^Script_Extensions=chorasmian}', "");
    Expect(0, 69579, '\P{Script_Extensions=chorasmian}', "");
    Expect(1, 69579, '\P{^Script_Extensions=chorasmian}', "");
    Expect(0, 69580, '\p{Script_Extensions=chorasmian}', "");
    Expect(1, 69580, '\p{^Script_Extensions=chorasmian}', "");
    Expect(1, 69580, '\P{Script_Extensions=chorasmian}', "");
    Expect(0, 69580, '\P{^Script_Extensions=chorasmian}', "");
    Expect(1, 69579, '\p{Script_Extensions=:\Achorasmian\z:}', "");;
    Expect(0, 69580, '\p{Script_Extensions=:\Achorasmian\z:}', "");;
    Expect(1, 69579, '\p{Script_Extensions=__chorasmian}', "");
    Expect(0, 69579, '\p{^Script_Extensions=__chorasmian}', "");
    Expect(0, 69579, '\P{Script_Extensions=__chorasmian}', "");
    Expect(1, 69579, '\P{^Script_Extensions=__chorasmian}', "");
    Expect(0, 69580, '\p{Script_Extensions=__chorasmian}', "");
    Expect(1, 69580, '\p{^Script_Extensions=__chorasmian}', "");
    Expect(1, 69580, '\P{Script_Extensions=__chorasmian}', "");
    Expect(0, 69580, '\P{^Script_Extensions=__chorasmian}', "");
    Error('\p{Scx=:=	Chrs}');
    Error('\P{Scx=:=	Chrs}');
    Expect(1, 69579, '\p{Scx=:\AChrs\z:}', "");;
    Expect(0, 69580, '\p{Scx=:\AChrs\z:}', "");;
    Expect(1, 69579, '\p{Scx=chrs}', "");
    Expect(0, 69579, '\p{^Scx=chrs}', "");
    Expect(0, 69579, '\P{Scx=chrs}', "");
    Expect(1, 69579, '\P{^Scx=chrs}', "");
    Expect(0, 69580, '\p{Scx=chrs}', "");
    Expect(1, 69580, '\p{^Scx=chrs}', "");
    Expect(1, 69580, '\P{Scx=chrs}', "");
    Expect(0, 69580, '\P{^Scx=chrs}', "");
    Expect(1, 69579, '\p{Scx=:\Achrs\z:}', "");;
    Expect(0, 69580, '\p{Scx=:\Achrs\z:}', "");;
    Expect(1, 69579, '\p{Scx=	 Chrs}', "");
    Expect(0, 69579, '\p{^Scx=	 Chrs}', "");
    Expect(0, 69579, '\P{Scx=	 Chrs}', "");
    Expect(1, 69579, '\P{^Scx=	 Chrs}', "");
    Expect(0, 69580, '\p{Scx=	 Chrs}', "");
    Expect(1, 69580, '\p{^Scx=	 Chrs}', "");
    Expect(1, 69580, '\P{Scx=	 Chrs}', "");
    Expect(0, 69580, '\P{^Scx=	 Chrs}', "");
    Error('\p{Is_Script_Extensions=:=CHORASMIAN}');
    Error('\P{Is_Script_Extensions=:=CHORASMIAN}');
    Expect(1, 69579, '\p{Is_Script_Extensions=chorasmian}', "");
    Expect(0, 69579, '\p{^Is_Script_Extensions=chorasmian}', "");
    Expect(0, 69579, '\P{Is_Script_Extensions=chorasmian}', "");
    Expect(1, 69579, '\P{^Is_Script_Extensions=chorasmian}', "");
    Expect(0, 69580, '\p{Is_Script_Extensions=chorasmian}', "");
    Expect(1, 69580, '\p{^Is_Script_Extensions=chorasmian}', "");
    Expect(1, 69580, '\P{Is_Script_Extensions=chorasmian}', "");
    Expect(0, 69580, '\P{^Is_Script_Extensions=chorasmian}', "");
    Expect(1, 69579, '\p{Is_Script_Extensions=		CHORASMIAN}', "");
    Expect(0, 69579, '\p{^Is_Script_Extensions=		CHORASMIAN}', "");
    Expect(0, 69579, '\P{Is_Script_Extensions=		CHORASMIAN}', "");
    Expect(1, 69579, '\P{^Is_Script_Extensions=		CHORASMIAN}', "");
    Expect(0, 69580, '\p{Is_Script_Extensions=		CHORASMIAN}', "");
    Expect(1, 69580, '\p{^Is_Script_Extensions=		CHORASMIAN}', "");
    Expect(1, 69580, '\P{Is_Script_Extensions=		CHORASMIAN}', "");
    Expect(0, 69580, '\P{^Is_Script_Extensions=		CHORASMIAN}', "");
    Error('\p{Is_Scx=	_CHRS:=}');
    Error('\P{Is_Scx=	_CHRS:=}');
    Expect(1, 69579, '\p{Is_Scx=chrs}', "");
    Expect(0, 69579, '\p{^Is_Scx=chrs}', "");
    Expect(0, 69579, '\P{Is_Scx=chrs}', "");
    Expect(1, 69579, '\P{^Is_Scx=chrs}', "");
    Expect(0, 69580, '\p{Is_Scx=chrs}', "");
    Expect(1, 69580, '\p{^Is_Scx=chrs}', "");
    Expect(1, 69580, '\P{Is_Scx=chrs}', "");
    Expect(0, 69580, '\P{^Is_Scx=chrs}', "");
    Expect(1, 69579, '\p{Is_Scx=__chrs}', "");
    Expect(0, 69579, '\p{^Is_Scx=__chrs}', "");
    Expect(0, 69579, '\P{Is_Scx=__chrs}', "");
    Expect(1, 69579, '\P{^Is_Scx=__chrs}', "");
    Expect(0, 69580, '\p{Is_Scx=__chrs}', "");
    Expect(1, 69580, '\p{^Is_Scx=__chrs}', "");
    Expect(1, 69580, '\P{Is_Scx=__chrs}', "");
    Expect(0, 69580, '\P{^Is_Scx=__chrs}', "");
    Error('\p{Script_Extensions= _coptic/a/}');
    Error('\P{Script_Extensions= _coptic/a/}');
    Expect(1, 66299, '\p{Script_Extensions=:\ACoptic\z:}', "");;
    Expect(0, 66300, '\p{Script_Extensions=:\ACoptic\z:}', "");;
    Expect(1, 66299, '\p{Script_Extensions=coptic}', "");
    Expect(0, 66299, '\p{^Script_Extensions=coptic}', "");
    Expect(0, 66299, '\P{Script_Extensions=coptic}', "");
    Expect(1, 66299, '\P{^Script_Extensions=coptic}', "");
    Expect(0, 66300, '\p{Script_Extensions=coptic}', "");
    Expect(1, 66300, '\p{^Script_Extensions=coptic}', "");
    Expect(1, 66300, '\P{Script_Extensions=coptic}', "");
    Expect(0, 66300, '\P{^Script_Extensions=coptic}', "");
    Expect(1, 66299, '\p{Script_Extensions=:\Acoptic\z:}', "");;
    Expect(0, 66300, '\p{Script_Extensions=:\Acoptic\z:}', "");;
    Expect(1, 66299, '\p{Script_Extensions:	 -Coptic}', "");
    Expect(0, 66299, '\p{^Script_Extensions:	 -Coptic}', "");
    Expect(0, 66299, '\P{Script_Extensions:	 -Coptic}', "");
    Expect(1, 66299, '\P{^Script_Extensions:	 -Coptic}', "");
    Expect(0, 66300, '\p{Script_Extensions:	 -Coptic}', "");
    Expect(1, 66300, '\p{^Script_Extensions:	 -Coptic}', "");
    Expect(1, 66300, '\P{Script_Extensions:	 -Coptic}', "");
    Expect(0, 66300, '\P{^Script_Extensions:	 -Coptic}', "");
    Error('\p{Scx=_:=Copt}');
    Error('\P{Scx=_:=Copt}');
    Expect(1, 66299, '\p{Scx=:\ACopt\z:}', "");;
    Expect(0, 66300, '\p{Scx=:\ACopt\z:}', "");;
    Expect(1, 66299, '\p{Scx=copt}', "");
    Expect(0, 66299, '\p{^Scx=copt}', "");
    Expect(0, 66299, '\P{Scx=copt}', "");
    Expect(1, 66299, '\P{^Scx=copt}', "");
    Expect(0, 66300, '\p{Scx=copt}', "");
    Expect(1, 66300, '\p{^Scx=copt}', "");
    Expect(1, 66300, '\P{Scx=copt}', "");
    Expect(0, 66300, '\P{^Scx=copt}', "");
    Expect(1, 66299, '\p{Scx=:\Acopt\z:}', "");;
    Expect(0, 66300, '\p{Scx=:\Acopt\z:}', "");;
    Expect(1, 66299, '\p{Scx= _copt}', "");
    Expect(0, 66299, '\p{^Scx= _copt}', "");
    Expect(0, 66299, '\P{Scx= _copt}', "");
    Expect(1, 66299, '\P{^Scx= _copt}', "");
    Expect(0, 66300, '\p{Scx= _copt}', "");
    Expect(1, 66300, '\p{^Scx= _copt}', "");
    Expect(1, 66300, '\P{Scx= _copt}', "");
    Expect(0, 66300, '\P{^Scx= _copt}', "");
    Error('\p{Is_Script_Extensions:	-_Qaac/a/}');
    Error('\P{Is_Script_Extensions:	-_Qaac/a/}');
    Expect(1, 66299, '\p{Is_Script_Extensions=qaac}', "");
    Expect(0, 66299, '\p{^Is_Script_Extensions=qaac}', "");
    Expect(0, 66299, '\P{Is_Script_Extensions=qaac}', "");
    Expect(1, 66299, '\P{^Is_Script_Extensions=qaac}', "");
    Expect(0, 66300, '\p{Is_Script_Extensions=qaac}', "");
    Expect(1, 66300, '\p{^Is_Script_Extensions=qaac}', "");
    Expect(1, 66300, '\P{Is_Script_Extensions=qaac}', "");
    Expect(0, 66300, '\P{^Is_Script_Extensions=qaac}', "");
    Expect(1, 66299, '\p{Is_Script_Extensions=--Qaac}', "");
    Expect(0, 66299, '\p{^Is_Script_Extensions=--Qaac}', "");
    Expect(0, 66299, '\P{Is_Script_Extensions=--Qaac}', "");
    Expect(1, 66299, '\P{^Is_Script_Extensions=--Qaac}', "");
    Expect(0, 66300, '\p{Is_Script_Extensions=--Qaac}', "");
    Expect(1, 66300, '\p{^Is_Script_Extensions=--Qaac}', "");
    Expect(1, 66300, '\P{Is_Script_Extensions=--Qaac}', "");
    Expect(0, 66300, '\P{^Is_Script_Extensions=--Qaac}', "");
    Error('\p{Is_Scx=/a/	coptic}');
    Error('\P{Is_Scx=/a/	coptic}');
    Expect(1, 66299, '\p{Is_Scx=coptic}', "");
    Expect(0, 66299, '\p{^Is_Scx=coptic}', "");
    Expect(0, 66299, '\P{Is_Scx=coptic}', "");
    Expect(1, 66299, '\P{^Is_Scx=coptic}', "");
    Expect(0, 66300, '\p{Is_Scx=coptic}', "");
    Expect(1, 66300, '\p{^Is_Scx=coptic}', "");
    Expect(1, 66300, '\P{Is_Scx=coptic}', "");
    Expect(0, 66300, '\P{^Is_Scx=coptic}', "");
    Expect(1, 66299, '\p{Is_Scx=	COPTIC}', "");
    Expect(0, 66299, '\p{^Is_Scx=	COPTIC}', "");
    Expect(0, 66299, '\P{Is_Scx=	COPTIC}', "");
    Expect(1, 66299, '\P{^Is_Scx=	COPTIC}', "");
    Expect(0, 66300, '\p{Is_Scx=	COPTIC}', "");
    Expect(1, 66300, '\p{^Is_Scx=	COPTIC}', "");
    Expect(1, 66300, '\P{Is_Scx=	COPTIC}', "");
    Expect(0, 66300, '\P{^Is_Scx=	COPTIC}', "");
    Error('\p{Script_Extensions=/a/-Cypro_MINOAN}');
    Error('\P{Script_Extensions=/a/-Cypro_MINOAN}');
    Expect(1, 77810, '\p{Script_Extensions=:\ACypro_Minoan\z:}', "");;
    Expect(0, 77811, '\p{Script_Extensions=:\ACypro_Minoan\z:}', "");;
    Expect(1, 77810, '\p{Script_Extensions=cyprominoan}', "");
    Expect(0, 77810, '\p{^Script_Extensions=cyprominoan}', "");
    Expect(0, 77810, '\P{Script_Extensions=cyprominoan}', "");
    Expect(1, 77810, '\P{^Script_Extensions=cyprominoan}', "");
    Expect(0, 77811, '\p{Script_Extensions=cyprominoan}', "");
    Expect(1, 77811, '\p{^Script_Extensions=cyprominoan}', "");
    Expect(1, 77811, '\P{Script_Extensions=cyprominoan}', "");
    Expect(0, 77811, '\P{^Script_Extensions=cyprominoan}', "");
    Expect(1, 77810, '\p{Script_Extensions=:\Acyprominoan\z:}', "");;
    Expect(0, 77811, '\p{Script_Extensions=:\Acyprominoan\z:}', "");;
    Expect(1, 77810, '\p{Script_Extensions=-cypro_minoan}', "");
    Expect(0, 77810, '\p{^Script_Extensions=-cypro_minoan}', "");
    Expect(0, 77810, '\P{Script_Extensions=-cypro_minoan}', "");
    Expect(1, 77810, '\P{^Script_Extensions=-cypro_minoan}', "");
    Expect(0, 77811, '\p{Script_Extensions=-cypro_minoan}', "");
    Expect(1, 77811, '\p{^Script_Extensions=-cypro_minoan}', "");
    Expect(1, 77811, '\P{Script_Extensions=-cypro_minoan}', "");
    Expect(0, 77811, '\P{^Script_Extensions=-cypro_minoan}', "");
    Error('\p{Scx=:=		Cpmn}');
    Error('\P{Scx=:=		Cpmn}');
    Expect(1, 77810, '\p{Scx=:\ACpmn\z:}', "");;
    Expect(0, 77811, '\p{Scx=:\ACpmn\z:}', "");;
    Expect(1, 77810, '\p{Scx=cpmn}', "");
    Expect(0, 77810, '\p{^Scx=cpmn}', "");
    Expect(0, 77810, '\P{Scx=cpmn}', "");
    Expect(1, 77810, '\P{^Scx=cpmn}', "");
    Expect(0, 77811, '\p{Scx=cpmn}', "");
    Expect(1, 77811, '\p{^Scx=cpmn}', "");
    Expect(1, 77811, '\P{Scx=cpmn}', "");
    Expect(0, 77811, '\P{^Scx=cpmn}', "");
    Expect(1, 77810, '\p{Scx=:\Acpmn\z:}', "");;
    Expect(0, 77811, '\p{Scx=:\Acpmn\z:}', "");;
    Expect(1, 77810, '\p{Scx=- CPMN}', "");
    Expect(0, 77810, '\p{^Scx=- CPMN}', "");
    Expect(0, 77810, '\P{Scx=- CPMN}', "");
    Expect(1, 77810, '\P{^Scx=- CPMN}', "");
    Expect(0, 77811, '\p{Scx=- CPMN}', "");
    Expect(1, 77811, '\p{^Scx=- CPMN}', "");
    Expect(1, 77811, '\P{Scx=- CPMN}', "");
    Expect(0, 77811, '\P{^Scx=- CPMN}', "");
    Error('\p{Is_Script_Extensions=:=-cypro_Minoan}');
    Error('\P{Is_Script_Extensions=:=-cypro_Minoan}');
    Expect(1, 77810, '\p{Is_Script_Extensions=cyprominoan}', "");
    Expect(0, 77810, '\p{^Is_Script_Extensions=cyprominoan}', "");
    Expect(0, 77810, '\P{Is_Script_Extensions=cyprominoan}', "");
    Expect(1, 77810, '\P{^Is_Script_Extensions=cyprominoan}', "");
    Expect(0, 77811, '\p{Is_Script_Extensions=cyprominoan}', "");
    Expect(1, 77811, '\p{^Is_Script_Extensions=cyprominoan}', "");
    Expect(1, 77811, '\P{Is_Script_Extensions=cyprominoan}', "");
    Expect(0, 77811, '\P{^Is_Script_Extensions=cyprominoan}', "");
    Expect(1, 77810, '\p{Is_Script_Extensions=__cypro_Minoan}', "");
    Expect(0, 77810, '\p{^Is_Script_Extensions=__cypro_Minoan}', "");
    Expect(0, 77810, '\P{Is_Script_Extensions=__cypro_Minoan}', "");
    Expect(1, 77810, '\P{^Is_Script_Extensions=__cypro_Minoan}', "");
    Expect(0, 77811, '\p{Is_Script_Extensions=__cypro_Minoan}', "");
    Expect(1, 77811, '\p{^Is_Script_Extensions=__cypro_Minoan}', "");
    Expect(1, 77811, '\P{Is_Script_Extensions=__cypro_Minoan}', "");
    Expect(0, 77811, '\P{^Is_Script_Extensions=__cypro_Minoan}', "");
    Error('\p{Is_Scx=/a/_Cpmn}');
    Error('\P{Is_Scx=/a/_Cpmn}');
    Expect(1, 77810, '\p{Is_Scx=cpmn}', "");
    Expect(0, 77810, '\p{^Is_Scx=cpmn}', "");
    Expect(0, 77810, '\P{Is_Scx=cpmn}', "");
    Expect(1, 77810, '\P{^Is_Scx=cpmn}', "");
    Expect(0, 77811, '\p{Is_Scx=cpmn}', "");
    Expect(1, 77811, '\p{^Is_Scx=cpmn}', "");
    Expect(1, 77811, '\P{Is_Scx=cpmn}', "");
    Expect(0, 77811, '\P{^Is_Scx=cpmn}', "");
    Expect(1, 77810, '\p{Is_Scx:	Cpmn}', "");
    Expect(0, 77810, '\p{^Is_Scx:	Cpmn}', "");
    Expect(0, 77810, '\P{Is_Scx:	Cpmn}', "");
    Expect(1, 77810, '\P{^Is_Scx:	Cpmn}', "");
    Expect(0, 77811, '\p{Is_Scx:	Cpmn}', "");
    Expect(1, 77811, '\p{^Is_Scx:	Cpmn}', "");
    Expect(1, 77811, '\P{Is_Scx:	Cpmn}', "");
    Expect(0, 77811, '\P{^Is_Scx:	Cpmn}', "");
    Error('\p{Script_Extensions=:=		cypriot}');
    Error('\P{Script_Extensions=:=		cypriot}');
    Expect(1, 67647, '\p{Script_Extensions=:\ACypriot\z:}', "");;
    Expect(0, 67648, '\p{Script_Extensions=:\ACypriot\z:}', "");;
    Expect(1, 67647, '\p{Script_Extensions=cypriot}', "");
    Expect(0, 67647, '\p{^Script_Extensions=cypriot}', "");
    Expect(0, 67647, '\P{Script_Extensions=cypriot}', "");
    Expect(1, 67647, '\P{^Script_Extensions=cypriot}', "");
    Expect(0, 67648, '\p{Script_Extensions=cypriot}', "");
    Expect(1, 67648, '\p{^Script_Extensions=cypriot}', "");
    Expect(1, 67648, '\P{Script_Extensions=cypriot}', "");
    Expect(0, 67648, '\P{^Script_Extensions=cypriot}', "");
    Expect(1, 67647, '\p{Script_Extensions=:\Acypriot\z:}', "");;
    Expect(0, 67648, '\p{Script_Extensions=:\Acypriot\z:}', "");;
    Expect(1, 67647, '\p{Script_Extensions= 	CYPRIOT}', "");
    Expect(0, 67647, '\p{^Script_Extensions= 	CYPRIOT}', "");
    Expect(0, 67647, '\P{Script_Extensions= 	CYPRIOT}', "");
    Expect(1, 67647, '\P{^Script_Extensions= 	CYPRIOT}', "");
    Expect(0, 67648, '\p{Script_Extensions= 	CYPRIOT}', "");
    Expect(1, 67648, '\p{^Script_Extensions= 	CYPRIOT}', "");
    Expect(1, 67648, '\P{Script_Extensions= 	CYPRIOT}', "");
    Expect(0, 67648, '\P{^Script_Extensions= 	CYPRIOT}', "");
    Error('\p{Scx= :=Cprt}');
    Error('\P{Scx= :=Cprt}');
    Expect(1, 67647, '\p{Scx=:\ACprt\z:}', "");;
    Expect(0, 67648, '\p{Scx=:\ACprt\z:}', "");;
    Expect(1, 67647, '\p{Scx=cprt}', "");
    Expect(0, 67647, '\p{^Scx=cprt}', "");
    Expect(0, 67647, '\P{Scx=cprt}', "");
    Expect(1, 67647, '\P{^Scx=cprt}', "");
    Expect(0, 67648, '\p{Scx=cprt}', "");
    Expect(1, 67648, '\p{^Scx=cprt}', "");
    Expect(1, 67648, '\P{Scx=cprt}', "");
    Expect(0, 67648, '\P{^Scx=cprt}', "");
    Expect(1, 67647, '\p{Scx=:\Acprt\z:}', "");;
    Expect(0, 67648, '\p{Scx=:\Acprt\z:}', "");;
    Expect(1, 67647, '\p{Scx=	Cprt}', "");
    Expect(0, 67647, '\p{^Scx=	Cprt}', "");
    Expect(0, 67647, '\P{Scx=	Cprt}', "");
    Expect(1, 67647, '\P{^Scx=	Cprt}', "");
    Expect(0, 67648, '\p{Scx=	Cprt}', "");
    Expect(1, 67648, '\p{^Scx=	Cprt}', "");
    Expect(1, 67648, '\P{Scx=	Cprt}', "");
    Expect(0, 67648, '\P{^Scx=	Cprt}', "");
    Error('\p{Is_Script_Extensions:	-	cypriot/a/}');
    Error('\P{Is_Script_Extensions:	-	cypriot/a/}');
    Expect(1, 67647, '\p{Is_Script_Extensions=cypriot}', "");
    Expect(0, 67647, '\p{^Is_Script_Extensions=cypriot}', "");
    Expect(0, 67647, '\P{Is_Script_Extensions=cypriot}', "");
    Expect(1, 67647, '\P{^Is_Script_Extensions=cypriot}', "");
    Expect(0, 67648, '\p{Is_Script_Extensions=cypriot}', "");
    Expect(1, 67648, '\p{^Is_Script_Extensions=cypriot}', "");
    Expect(1, 67648, '\P{Is_Script_Extensions=cypriot}', "");
    Expect(0, 67648, '\P{^Is_Script_Extensions=cypriot}', "");
    Expect(1, 67647, '\p{Is_Script_Extensions:    -cypriot}', "");
    Expect(0, 67647, '\p{^Is_Script_Extensions:    -cypriot}', "");
    Expect(0, 67647, '\P{Is_Script_Extensions:    -cypriot}', "");
    Expect(1, 67647, '\P{^Is_Script_Extensions:    -cypriot}', "");
    Expect(0, 67648, '\p{Is_Script_Extensions:    -cypriot}', "");
    Expect(1, 67648, '\p{^Is_Script_Extensions:    -cypriot}', "");
    Expect(1, 67648, '\P{Is_Script_Extensions:    -cypriot}', "");
    Expect(0, 67648, '\P{^Is_Script_Extensions:    -cypriot}', "");
    Error('\p{Is_Scx=		CPRT/a/}');
    Error('\P{Is_Scx=		CPRT/a/}');
    Expect(1, 67647, '\p{Is_Scx=cprt}', "");
    Expect(0, 67647, '\p{^Is_Scx=cprt}', "");
    Expect(0, 67647, '\P{Is_Scx=cprt}', "");
    Expect(1, 67647, '\P{^Is_Scx=cprt}', "");
    Expect(0, 67648, '\p{Is_Scx=cprt}', "");
    Expect(1, 67648, '\p{^Is_Scx=cprt}', "");
    Expect(1, 67648, '\P{Is_Scx=cprt}', "");
    Expect(0, 67648, '\P{^Is_Scx=cprt}', "");
    Expect(1, 67647, '\p{Is_Scx=	Cprt}', "");
    Expect(0, 67647, '\p{^Is_Scx=	Cprt}', "");
    Expect(0, 67647, '\P{Is_Scx=	Cprt}', "");
    Expect(1, 67647, '\P{^Is_Scx=	Cprt}', "");
    Expect(0, 67648, '\p{Is_Scx=	Cprt}', "");
    Expect(1, 67648, '\p{^Is_Scx=	Cprt}', "");
    Expect(1, 67648, '\P{Is_Scx=	Cprt}', "");
    Expect(0, 67648, '\P{^Is_Scx=	Cprt}', "");
    Error('\p{Script_Extensions=:=_CYRILLIC}');
    Error('\P{Script_Extensions=:=_CYRILLIC}');
    Expect(1, 123023, '\p{Script_Extensions=:\ACyrillic\z:}', "");;
    Expect(0, 123024, '\p{Script_Extensions=:\ACyrillic\z:}', "");;
    Expect(1, 123023, '\p{Script_Extensions=cyrillic}', "");
    Expect(0, 123023, '\p{^Script_Extensions=cyrillic}', "");
    Expect(0, 123023, '\P{Script_Extensions=cyrillic}', "");
    Expect(1, 123023, '\P{^Script_Extensions=cyrillic}', "");
    Expect(0, 123024, '\p{Script_Extensions=cyrillic}', "");
    Expect(1, 123024, '\p{^Script_Extensions=cyrillic}', "");
    Expect(1, 123024, '\P{Script_Extensions=cyrillic}', "");
    Expect(0, 123024, '\P{^Script_Extensions=cyrillic}', "");
    Expect(1, 123023, '\p{Script_Extensions=:\Acyrillic\z:}', "");;
    Expect(0, 123024, '\p{Script_Extensions=:\Acyrillic\z:}', "");;
    Expect(1, 123023, '\p{Script_Extensions=_Cyrillic}', "");
    Expect(0, 123023, '\p{^Script_Extensions=_Cyrillic}', "");
    Expect(0, 123023, '\P{Script_Extensions=_Cyrillic}', "");
    Expect(1, 123023, '\P{^Script_Extensions=_Cyrillic}', "");
    Expect(0, 123024, '\p{Script_Extensions=_Cyrillic}', "");
    Expect(1, 123024, '\p{^Script_Extensions=_Cyrillic}', "");
    Expect(1, 123024, '\P{Script_Extensions=_Cyrillic}', "");
    Expect(0, 123024, '\P{^Script_Extensions=_Cyrillic}', "");
    Error('\p{Scx=/a/-CYRL}');
    Error('\P{Scx=/a/-CYRL}');
    Expect(1, 123023, '\p{Scx=:\ACyrl\z:}', "");;
    Expect(0, 123024, '\p{Scx=:\ACyrl\z:}', "");;
    Expect(1, 123023, '\p{Scx=cyrl}', "");
    Expect(0, 123023, '\p{^Scx=cyrl}', "");
    Expect(0, 123023, '\P{Scx=cyrl}', "");
    Expect(1, 123023, '\P{^Scx=cyrl}', "");
    Expect(0, 123024, '\p{Scx=cyrl}', "");
    Expect(1, 123024, '\p{^Scx=cyrl}', "");
    Expect(1, 123024, '\P{Scx=cyrl}', "");
    Expect(0, 123024, '\P{^Scx=cyrl}', "");
    Expect(1, 123023, '\p{Scx=:\Acyrl\z:}', "");;
    Expect(0, 123024, '\p{Scx=:\Acyrl\z:}', "");;
    Expect(1, 123023, '\p{Scx=	-Cyrl}', "");
    Expect(0, 123023, '\p{^Scx=	-Cyrl}', "");
    Expect(0, 123023, '\P{Scx=	-Cyrl}', "");
    Expect(1, 123023, '\P{^Scx=	-Cyrl}', "");
    Expect(0, 123024, '\p{Scx=	-Cyrl}', "");
    Expect(1, 123024, '\p{^Scx=	-Cyrl}', "");
    Expect(1, 123024, '\P{Scx=	-Cyrl}', "");
    Expect(0, 123024, '\P{^Scx=	-Cyrl}', "");
    Error('\p{Is_Script_Extensions= /a/CYRILLIC}');
    Error('\P{Is_Script_Extensions= /a/CYRILLIC}');
    Expect(1, 123023, '\p{Is_Script_Extensions=cyrillic}', "");
    Expect(0, 123023, '\p{^Is_Script_Extensions=cyrillic}', "");
    Expect(0, 123023, '\P{Is_Script_Extensions=cyrillic}', "");
    Expect(1, 123023, '\P{^Is_Script_Extensions=cyrillic}', "");
    Expect(0, 123024, '\p{Is_Script_Extensions=cyrillic}', "");
    Expect(1, 123024, '\p{^Is_Script_Extensions=cyrillic}', "");
    Expect(1, 123024, '\P{Is_Script_Extensions=cyrillic}', "");
    Expect(0, 123024, '\P{^Is_Script_Extensions=cyrillic}', "");
    Expect(1, 123023, '\p{Is_Script_Extensions=--cyrillic}', "");
    Expect(0, 123023, '\p{^Is_Script_Extensions=--cyrillic}', "");
    Expect(0, 123023, '\P{Is_Script_Extensions=--cyrillic}', "");
    Expect(1, 123023, '\P{^Is_Script_Extensions=--cyrillic}', "");
    Expect(0, 123024, '\p{Is_Script_Extensions=--cyrillic}', "");
    Expect(1, 123024, '\p{^Is_Script_Extensions=--cyrillic}', "");
    Expect(1, 123024, '\P{Is_Script_Extensions=--cyrillic}', "");
    Expect(0, 123024, '\P{^Is_Script_Extensions=--cyrillic}', "");
    Error('\p{Is_Scx=:=_-Cyrl}');
    Error('\P{Is_Scx=:=_-Cyrl}');
    Expect(1, 123023, '\p{Is_Scx=cyrl}', "");
    Expect(0, 123023, '\p{^Is_Scx=cyrl}', "");
    Expect(0, 123023, '\P{Is_Scx=cyrl}', "");
    Expect(1, 123023, '\P{^Is_Scx=cyrl}', "");
    Expect(0, 123024, '\p{Is_Scx=cyrl}', "");
    Expect(1, 123024, '\p{^Is_Scx=cyrl}', "");
    Expect(1, 123024, '\P{Is_Scx=cyrl}', "");
    Expect(0, 123024, '\P{^Is_Scx=cyrl}', "");
    Expect(1, 123023, '\p{Is_Scx= -Cyrl}', "");
    Expect(0, 123023, '\p{^Is_Scx= -Cyrl}', "");
    Expect(0, 123023, '\P{Is_Scx= -Cyrl}', "");
    Expect(1, 123023, '\P{^Is_Scx= -Cyrl}', "");
    Expect(0, 123024, '\p{Is_Scx= -Cyrl}', "");
    Expect(1, 123024, '\p{^Is_Scx= -Cyrl}', "");
    Expect(1, 123024, '\P{Is_Scx= -Cyrl}', "");
    Expect(0, 123024, '\P{^Is_Scx= -Cyrl}', "");
    Error('\p{Script_Extensions= /a/Devanagari}');
    Error('\P{Script_Extensions= /a/Devanagari}');
    Expect(1, 72457, '\p{Script_Extensions=:\ADevanagari\z:}', "");;
    Expect(0, 72458, '\p{Script_Extensions=:\ADevanagari\z:}', "");;
    Expect(1, 72457, '\p{Script_Extensions=devanagari}', "");
    Expect(0, 72457, '\p{^Script_Extensions=devanagari}', "");
    Expect(0, 72457, '\P{Script_Extensions=devanagari}', "");
    Expect(1, 72457, '\P{^Script_Extensions=devanagari}', "");
    Expect(0, 72458, '\p{Script_Extensions=devanagari}', "");
    Expect(1, 72458, '\p{^Script_Extensions=devanagari}', "");
    Expect(1, 72458, '\P{Script_Extensions=devanagari}', "");
    Expect(0, 72458, '\P{^Script_Extensions=devanagari}', "");
    Expect(1, 72457, '\p{Script_Extensions=:\Adevanagari\z:}', "");;
    Expect(0, 72458, '\p{Script_Extensions=:\Adevanagari\z:}', "");;
    Expect(1, 72457, '\p{Script_Extensions=-DEVANAGARI}', "");
    Expect(0, 72457, '\p{^Script_Extensions=-DEVANAGARI}', "");
    Expect(0, 72457, '\P{Script_Extensions=-DEVANAGARI}', "");
    Expect(1, 72457, '\P{^Script_Extensions=-DEVANAGARI}', "");
    Expect(0, 72458, '\p{Script_Extensions=-DEVANAGARI}', "");
    Expect(1, 72458, '\p{^Script_Extensions=-DEVANAGARI}', "");
    Expect(1, 72458, '\P{Script_Extensions=-DEVANAGARI}', "");
    Expect(0, 72458, '\P{^Script_Extensions=-DEVANAGARI}', "");
    Error('\p{Scx=:=_deva}');
    Error('\P{Scx=:=_deva}');
    Expect(1, 72457, '\p{Scx=:\ADeva\z:}', "");;
    Expect(0, 72458, '\p{Scx=:\ADeva\z:}', "");;
    Expect(1, 72457, '\p{Scx=deva}', "");
    Expect(0, 72457, '\p{^Scx=deva}', "");
    Expect(0, 72457, '\P{Scx=deva}', "");
    Expect(1, 72457, '\P{^Scx=deva}', "");
    Expect(0, 72458, '\p{Scx=deva}', "");
    Expect(1, 72458, '\p{^Scx=deva}', "");
    Expect(1, 72458, '\P{Scx=deva}', "");
    Expect(0, 72458, '\P{^Scx=deva}', "");
    Expect(1, 72457, '\p{Scx=:\Adeva\z:}', "");;
    Expect(0, 72458, '\p{Scx=:\Adeva\z:}', "");;
    Expect(1, 72457, '\p{Scx:	-deva}', "");
    Expect(0, 72457, '\p{^Scx:	-deva}', "");
    Expect(0, 72457, '\P{Scx:	-deva}', "");
    Expect(1, 72457, '\P{^Scx:	-deva}', "");
    Expect(0, 72458, '\p{Scx:	-deva}', "");
    Expect(1, 72458, '\p{^Scx:	-deva}', "");
    Expect(1, 72458, '\P{Scx:	-deva}', "");
    Expect(0, 72458, '\P{^Scx:	-deva}', "");
    Error('\p{Is_Script_Extensions=- Devanagari:=}');
    Error('\P{Is_Script_Extensions=- Devanagari:=}');
    Expect(1, 72457, '\p{Is_Script_Extensions=devanagari}', "");
    Expect(0, 72457, '\p{^Is_Script_Extensions=devanagari}', "");
    Expect(0, 72457, '\P{Is_Script_Extensions=devanagari}', "");
    Expect(1, 72457, '\P{^Is_Script_Extensions=devanagari}', "");
    Expect(0, 72458, '\p{Is_Script_Extensions=devanagari}', "");
    Expect(1, 72458, '\p{^Is_Script_Extensions=devanagari}', "");
    Expect(1, 72458, '\P{Is_Script_Extensions=devanagari}', "");
    Expect(0, 72458, '\P{^Is_Script_Extensions=devanagari}', "");
    Expect(1, 72457, '\p{Is_Script_Extensions=-Devanagari}', "");
    Expect(0, 72457, '\p{^Is_Script_Extensions=-Devanagari}', "");
    Expect(0, 72457, '\P{Is_Script_Extensions=-Devanagari}', "");
    Expect(1, 72457, '\P{^Is_Script_Extensions=-Devanagari}', "");
    Expect(0, 72458, '\p{Is_Script_Extensions=-Devanagari}', "");
    Expect(1, 72458, '\p{^Is_Script_Extensions=-Devanagari}', "");
    Expect(1, 72458, '\P{Is_Script_Extensions=-Devanagari}', "");
    Expect(0, 72458, '\P{^Is_Script_Extensions=-Devanagari}', "");
    Error('\p{Is_Scx=:=__DEVA}');
    Error('\P{Is_Scx=:=__DEVA}');
    Expect(1, 72457, '\p{Is_Scx=deva}', "");
    Expect(0, 72457, '\p{^Is_Scx=deva}', "");
    Expect(0, 72457, '\P{Is_Scx=deva}', "");
    Expect(1, 72457, '\P{^Is_Scx=deva}', "");
    Expect(0, 72458, '\p{Is_Scx=deva}', "");
    Expect(1, 72458, '\p{^Is_Scx=deva}', "");
    Expect(1, 72458, '\P{Is_Scx=deva}', "");
    Expect(0, 72458, '\P{^Is_Scx=deva}', "");
    Expect(1, 72457, '\p{Is_Scx=_ Deva}', "");
    Expect(0, 72457, '\p{^Is_Scx=_ Deva}', "");
    Expect(0, 72457, '\P{Is_Scx=_ Deva}', "");
    Expect(1, 72457, '\P{^Is_Scx=_ Deva}', "");
    Expect(0, 72458, '\p{Is_Scx=_ Deva}', "");
    Expect(1, 72458, '\p{^Is_Scx=_ Deva}', "");
    Expect(1, 72458, '\P{Is_Scx=_ Deva}', "");
    Expect(0, 72458, '\P{^Is_Scx=_ Deva}', "");
    Error('\p{Script_Extensions= :=Dives_akuru}');
    Error('\P{Script_Extensions= :=Dives_akuru}');
    Expect(1, 72025, '\p{Script_Extensions=:\ADives_Akuru\z:}', "");;
    Expect(0, 72026, '\p{Script_Extensions=:\ADives_Akuru\z:}', "");;
    Expect(1, 72025, '\p{Script_Extensions=divesakuru}', "");
    Expect(0, 72025, '\p{^Script_Extensions=divesakuru}', "");
    Expect(0, 72025, '\P{Script_Extensions=divesakuru}', "");
    Expect(1, 72025, '\P{^Script_Extensions=divesakuru}', "");
    Expect(0, 72026, '\p{Script_Extensions=divesakuru}', "");
    Expect(1, 72026, '\p{^Script_Extensions=divesakuru}', "");
    Expect(1, 72026, '\P{Script_Extensions=divesakuru}', "");
    Expect(0, 72026, '\P{^Script_Extensions=divesakuru}', "");
    Expect(1, 72025, '\p{Script_Extensions=:\Adivesakuru\z:}', "");;
    Expect(0, 72026, '\p{Script_Extensions=:\Adivesakuru\z:}', "");;
    Expect(1, 72025, '\p{Script_Extensions=__Dives_Akuru}', "");
    Expect(0, 72025, '\p{^Script_Extensions=__Dives_Akuru}', "");
    Expect(0, 72025, '\P{Script_Extensions=__Dives_Akuru}', "");
    Expect(1, 72025, '\P{^Script_Extensions=__Dives_Akuru}', "");
    Expect(0, 72026, '\p{Script_Extensions=__Dives_Akuru}', "");
    Expect(1, 72026, '\p{^Script_Extensions=__Dives_Akuru}', "");
    Expect(1, 72026, '\P{Script_Extensions=__Dives_Akuru}', "");
    Expect(0, 72026, '\P{^Script_Extensions=__Dives_Akuru}', "");
    Error('\p{Scx:	 -Diak/a/}');
    Error('\P{Scx:	 -Diak/a/}');
    Expect(1, 72025, '\p{Scx=:\ADiak\z:}', "");;
    Expect(0, 72026, '\p{Scx=:\ADiak\z:}', "");;
    Expect(1, 72025, '\p{Scx=diak}', "");
    Expect(0, 72025, '\p{^Scx=diak}', "");
    Expect(0, 72025, '\P{Scx=diak}', "");
    Expect(1, 72025, '\P{^Scx=diak}', "");
    Expect(0, 72026, '\p{Scx=diak}', "");
    Expect(1, 72026, '\p{^Scx=diak}', "");
    Expect(1, 72026, '\P{Scx=diak}', "");
    Expect(0, 72026, '\P{^Scx=diak}', "");
    Expect(1, 72025, '\p{Scx=:\Adiak\z:}', "");;
    Expect(0, 72026, '\p{Scx=:\Adiak\z:}', "");;
    Expect(1, 72025, '\p{Scx=  Diak}', "");
    Expect(0, 72025, '\p{^Scx=  Diak}', "");
    Expect(0, 72025, '\P{Scx=  Diak}', "");
    Expect(1, 72025, '\P{^Scx=  Diak}', "");
    Expect(0, 72026, '\p{Scx=  Diak}', "");
    Expect(1, 72026, '\p{^Scx=  Diak}', "");
    Expect(1, 72026, '\P{Scx=  Diak}', "");
    Expect(0, 72026, '\P{^Scx=  Diak}', "");
    Error('\p{Is_Script_Extensions=__Dives_Akuru/a/}');
    Error('\P{Is_Script_Extensions=__Dives_Akuru/a/}');
    Expect(1, 72025, '\p{Is_Script_Extensions:divesakuru}', "");
    Expect(0, 72025, '\p{^Is_Script_Extensions:divesakuru}', "");
    Expect(0, 72025, '\P{Is_Script_Extensions:divesakuru}', "");
    Expect(1, 72025, '\P{^Is_Script_Extensions:divesakuru}', "");
    Expect(0, 72026, '\p{Is_Script_Extensions:divesakuru}', "");
    Expect(1, 72026, '\p{^Is_Script_Extensions:divesakuru}', "");
    Expect(1, 72026, '\P{Is_Script_Extensions:divesakuru}', "");
    Expect(0, 72026, '\P{^Is_Script_Extensions:divesakuru}', "");
    Expect(1, 72025, '\p{Is_Script_Extensions=--DIVES_akuru}', "");
    Expect(0, 72025, '\p{^Is_Script_Extensions=--DIVES_akuru}', "");
    Expect(0, 72025, '\P{Is_Script_Extensions=--DIVES_akuru}', "");
    Expect(1, 72025, '\P{^Is_Script_Extensions=--DIVES_akuru}', "");
    Expect(0, 72026, '\p{Is_Script_Extensions=--DIVES_akuru}', "");
    Expect(1, 72026, '\p{^Is_Script_Extensions=--DIVES_akuru}', "");
    Expect(1, 72026, '\P{Is_Script_Extensions=--DIVES_akuru}', "");
    Expect(0, 72026, '\P{^Is_Script_Extensions=--DIVES_akuru}', "");
    Error('\p{Is_Scx: --Diak:=}');
    Error('\P{Is_Scx: --Diak:=}');
    Expect(1, 72025, '\p{Is_Scx=diak}', "");
    Expect(0, 72025, '\p{^Is_Scx=diak}', "");
    Expect(0, 72025, '\P{Is_Scx=diak}', "");
    Expect(1, 72025, '\P{^Is_Scx=diak}', "");
    Expect(0, 72026, '\p{Is_Scx=diak}', "");
    Expect(1, 72026, '\p{^Is_Scx=diak}', "");
    Expect(1, 72026, '\P{Is_Scx=diak}', "");
    Expect(0, 72026, '\P{^Is_Scx=diak}', "");
    Expect(1, 72025, '\p{Is_Scx:		DIAK}', "");
    Expect(0, 72025, '\p{^Is_Scx:		DIAK}', "");
    Expect(0, 72025, '\P{Is_Scx:		DIAK}', "");
    Expect(1, 72025, '\P{^Is_Scx:		DIAK}', "");
    Expect(0, 72026, '\p{Is_Scx:		DIAK}', "");
    Expect(1, 72026, '\p{^Is_Scx:		DIAK}', "");
    Expect(1, 72026, '\P{Is_Scx:		DIAK}', "");
    Expect(0, 72026, '\P{^Is_Scx:		DIAK}', "");
    Error('\p{Script_Extensions=:=-dogra}');
    Error('\P{Script_Extensions=:=-dogra}');
    Expect(1, 71739, '\p{Script_Extensions=:\ADogra\z:}', "");;
    Expect(0, 71740, '\p{Script_Extensions=:\ADogra\z:}', "");;
    Expect(1, 71739, '\p{Script_Extensions:dogra}', "");
    Expect(0, 71739, '\p{^Script_Extensions:dogra}', "");
    Expect(0, 71739, '\P{Script_Extensions:dogra}', "");
    Expect(1, 71739, '\P{^Script_Extensions:dogra}', "");
    Expect(0, 71740, '\p{Script_Extensions:dogra}', "");
    Expect(1, 71740, '\p{^Script_Extensions:dogra}', "");
    Expect(1, 71740, '\P{Script_Extensions:dogra}', "");
    Expect(0, 71740, '\P{^Script_Extensions:dogra}', "");
    Expect(1, 71739, '\p{Script_Extensions=:\Adogra\z:}', "");;
    Expect(0, 71740, '\p{Script_Extensions=:\Adogra\z:}', "");;
    Expect(1, 71739, '\p{Script_Extensions=-_Dogra}', "");
    Expect(0, 71739, '\p{^Script_Extensions=-_Dogra}', "");
    Expect(0, 71739, '\P{Script_Extensions=-_Dogra}', "");
    Expect(1, 71739, '\P{^Script_Extensions=-_Dogra}', "");
    Expect(0, 71740, '\p{Script_Extensions=-_Dogra}', "");
    Expect(1, 71740, '\p{^Script_Extensions=-_Dogra}', "");
    Expect(1, 71740, '\P{Script_Extensions=-_Dogra}', "");
    Expect(0, 71740, '\P{^Script_Extensions=-_Dogra}', "");
    Error('\p{Scx=-/a/Dogr}');
    Error('\P{Scx=-/a/Dogr}');
    Expect(1, 71739, '\p{Scx=:\ADogr\z:}', "");;
    Expect(0, 71740, '\p{Scx=:\ADogr\z:}', "");;
    Expect(1, 71739, '\p{Scx=dogr}', "");
    Expect(0, 71739, '\p{^Scx=dogr}', "");
    Expect(0, 71739, '\P{Scx=dogr}', "");
    Expect(1, 71739, '\P{^Scx=dogr}', "");
    Expect(0, 71740, '\p{Scx=dogr}', "");
    Expect(1, 71740, '\p{^Scx=dogr}', "");
    Expect(1, 71740, '\P{Scx=dogr}', "");
    Expect(0, 71740, '\P{^Scx=dogr}', "");
    Expect(1, 71739, '\p{Scx=:\Adogr\z:}', "");;
    Expect(0, 71740, '\p{Scx=:\Adogr\z:}', "");;
    Expect(1, 71739, '\p{Scx=  Dogr}', "");
    Expect(0, 71739, '\p{^Scx=  Dogr}', "");
    Expect(0, 71739, '\P{Scx=  Dogr}', "");
    Expect(1, 71739, '\P{^Scx=  Dogr}', "");
    Expect(0, 71740, '\p{Scx=  Dogr}', "");
    Expect(1, 71740, '\p{^Scx=  Dogr}', "");
    Expect(1, 71740, '\P{Scx=  Dogr}', "");
    Expect(0, 71740, '\P{^Scx=  Dogr}', "");
    Error('\p{Is_Script_Extensions=	_Dogra/a/}');
    Error('\P{Is_Script_Extensions=	_Dogra/a/}');
    Expect(1, 71739, '\p{Is_Script_Extensions=dogra}', "");
    Expect(0, 71739, '\p{^Is_Script_Extensions=dogra}', "");
    Expect(0, 71739, '\P{Is_Script_Extensions=dogra}', "");
    Expect(1, 71739, '\P{^Is_Script_Extensions=dogra}', "");
    Expect(0, 71740, '\p{Is_Script_Extensions=dogra}', "");
    Expect(1, 71740, '\p{^Is_Script_Extensions=dogra}', "");
    Expect(1, 71740, '\P{Is_Script_Extensions=dogra}', "");
    Expect(0, 71740, '\P{^Is_Script_Extensions=dogra}', "");
    Expect(1, 71739, '\p{Is_Script_Extensions=_	Dogra}', "");
    Expect(0, 71739, '\p{^Is_Script_Extensions=_	Dogra}', "");
    Expect(0, 71739, '\P{Is_Script_Extensions=_	Dogra}', "");
    Expect(1, 71739, '\P{^Is_Script_Extensions=_	Dogra}', "");
    Expect(0, 71740, '\p{Is_Script_Extensions=_	Dogra}', "");
    Expect(1, 71740, '\p{^Is_Script_Extensions=_	Dogra}', "");
    Expect(1, 71740, '\P{Is_Script_Extensions=_	Dogra}', "");
    Expect(0, 71740, '\P{^Is_Script_Extensions=_	Dogra}', "");
    Error('\p{Is_Scx=_dogr:=}');
    Error('\P{Is_Scx=_dogr:=}');
    Expect(1, 71739, '\p{Is_Scx=dogr}', "");
    Expect(0, 71739, '\p{^Is_Scx=dogr}', "");
    Expect(0, 71739, '\P{Is_Scx=dogr}', "");
    Expect(1, 71739, '\P{^Is_Scx=dogr}', "");
    Expect(0, 71740, '\p{Is_Scx=dogr}', "");
    Expect(1, 71740, '\p{^Is_Scx=dogr}', "");
    Expect(1, 71740, '\P{Is_Scx=dogr}', "");
    Expect(0, 71740, '\P{^Is_Scx=dogr}', "");
    Expect(1, 71739, '\p{Is_Scx= -Dogr}', "");
    Expect(0, 71739, '\p{^Is_Scx= -Dogr}', "");
    Expect(0, 71739, '\P{Is_Scx= -Dogr}', "");
    Expect(1, 71739, '\P{^Is_Scx= -Dogr}', "");
    Expect(0, 71740, '\p{Is_Scx= -Dogr}', "");
    Expect(1, 71740, '\p{^Is_Scx= -Dogr}', "");
    Expect(1, 71740, '\P{Is_Scx= -Dogr}', "");
    Expect(0, 71740, '\P{^Is_Scx= -Dogr}', "");
    Error('\p{Script_Extensions=:=_	Deseret}');
    Error('\P{Script_Extensions=:=_	Deseret}');
    Expect(1, 66639, '\p{Script_Extensions=:\ADeseret\z:}', "");;
    Expect(0, 66640, '\p{Script_Extensions=:\ADeseret\z:}', "");;
    Expect(1, 66639, '\p{Script_Extensions=deseret}', "");
    Expect(0, 66639, '\p{^Script_Extensions=deseret}', "");
    Expect(0, 66639, '\P{Script_Extensions=deseret}', "");
    Expect(1, 66639, '\P{^Script_Extensions=deseret}', "");
    Expect(0, 66640, '\p{Script_Extensions=deseret}', "");
    Expect(1, 66640, '\p{^Script_Extensions=deseret}', "");
    Expect(1, 66640, '\P{Script_Extensions=deseret}', "");
    Expect(0, 66640, '\P{^Script_Extensions=deseret}', "");
    Expect(1, 66639, '\p{Script_Extensions=:\Adeseret\z:}', "");;
    Expect(0, 66640, '\p{Script_Extensions=:\Adeseret\z:}', "");;
    Expect(1, 66639, '\p{Script_Extensions=_-DESERET}', "");
    Expect(0, 66639, '\p{^Script_Extensions=_-DESERET}', "");
    Expect(0, 66639, '\P{Script_Extensions=_-DESERET}', "");
    Expect(1, 66639, '\P{^Script_Extensions=_-DESERET}', "");
    Expect(0, 66640, '\p{Script_Extensions=_-DESERET}', "");
    Expect(1, 66640, '\p{^Script_Extensions=_-DESERET}', "");
    Expect(1, 66640, '\P{Script_Extensions=_-DESERET}', "");
    Expect(0, 66640, '\P{^Script_Extensions=_-DESERET}', "");
    Error('\p{Scx:	-	DSRT/a/}');
    Error('\P{Scx:	-	DSRT/a/}');
    Expect(1, 66639, '\p{Scx=:\ADsrt\z:}', "");;
    Expect(0, 66640, '\p{Scx=:\ADsrt\z:}', "");;
    Expect(1, 66639, '\p{Scx=dsrt}', "");
    Expect(0, 66639, '\p{^Scx=dsrt}', "");
    Expect(0, 66639, '\P{Scx=dsrt}', "");
    Expect(1, 66639, '\P{^Scx=dsrt}', "");
    Expect(0, 66640, '\p{Scx=dsrt}', "");
    Expect(1, 66640, '\p{^Scx=dsrt}', "");
    Expect(1, 66640, '\P{Scx=dsrt}', "");
    Expect(0, 66640, '\P{^Scx=dsrt}', "");
    Expect(1, 66639, '\p{Scx=:\Adsrt\z:}', "");;
    Expect(0, 66640, '\p{Scx=:\Adsrt\z:}', "");;
    Expect(1, 66639, '\p{Scx=-DSRT}', "");
    Expect(0, 66639, '\p{^Scx=-DSRT}', "");
    Expect(0, 66639, '\P{Scx=-DSRT}', "");
    Expect(1, 66639, '\P{^Scx=-DSRT}', "");
    Expect(0, 66640, '\p{Scx=-DSRT}', "");
    Expect(1, 66640, '\p{^Scx=-DSRT}', "");
    Expect(1, 66640, '\P{Scx=-DSRT}', "");
    Expect(0, 66640, '\P{^Scx=-DSRT}', "");
    Error('\p{Is_Script_Extensions=-:=deseret}');
    Error('\P{Is_Script_Extensions=-:=deseret}');
    Expect(1, 66639, '\p{Is_Script_Extensions=deseret}', "");
    Expect(0, 66639, '\p{^Is_Script_Extensions=deseret}', "");
    Expect(0, 66639, '\P{Is_Script_Extensions=deseret}', "");
    Expect(1, 66639, '\P{^Is_Script_Extensions=deseret}', "");
    Expect(0, 66640, '\p{Is_Script_Extensions=deseret}', "");
    Expect(1, 66640, '\p{^Is_Script_Extensions=deseret}', "");
    Expect(1, 66640, '\P{Is_Script_Extensions=deseret}', "");
    Expect(0, 66640, '\P{^Is_Script_Extensions=deseret}', "");
    Expect(1, 66639, '\p{Is_Script_Extensions= deseret}', "");
    Expect(0, 66639, '\p{^Is_Script_Extensions= deseret}', "");
    Expect(0, 66639, '\P{Is_Script_Extensions= deseret}', "");
    Expect(1, 66639, '\P{^Is_Script_Extensions= deseret}', "");
    Expect(0, 66640, '\p{Is_Script_Extensions= deseret}', "");
    Expect(1, 66640, '\p{^Is_Script_Extensions= deseret}', "");
    Expect(1, 66640, '\P{Is_Script_Extensions= deseret}', "");
    Expect(0, 66640, '\P{^Is_Script_Extensions= deseret}', "");
    Error('\p{Is_Scx=_-dsrt:=}');
    Error('\P{Is_Scx=_-dsrt:=}');
    Expect(1, 66639, '\p{Is_Scx=dsrt}', "");
    Expect(0, 66639, '\p{^Is_Scx=dsrt}', "");
    Expect(0, 66639, '\P{Is_Scx=dsrt}', "");
    Expect(1, 66639, '\P{^Is_Scx=dsrt}', "");
    Expect(0, 66640, '\p{Is_Scx=dsrt}', "");
    Expect(1, 66640, '\p{^Is_Scx=dsrt}', "");
    Expect(1, 66640, '\P{Is_Scx=dsrt}', "");
    Expect(0, 66640, '\P{^Is_Scx=dsrt}', "");
    Expect(1, 66639, '\p{Is_Scx= -DSRT}', "");
    Expect(0, 66639, '\p{^Is_Scx= -DSRT}', "");
    Expect(0, 66639, '\P{Is_Scx= -DSRT}', "");
    Expect(1, 66639, '\P{^Is_Scx= -DSRT}', "");
    Expect(0, 66640, '\p{Is_Scx= -DSRT}', "");
    Expect(1, 66640, '\p{^Is_Scx= -DSRT}', "");
    Expect(1, 66640, '\P{Is_Scx= -DSRT}', "");
    Expect(0, 66640, '\P{^Is_Scx= -DSRT}', "");
    Error('\p{Script_Extensions:   /a/Duployan}');
    Error('\P{Script_Extensions:   /a/Duployan}');
    Expect(1, 113827, '\p{Script_Extensions=:\ADuployan\z:}', "");;
    Expect(0, 113828, '\p{Script_Extensions=:\ADuployan\z:}', "");;
    Expect(1, 113827, '\p{Script_Extensions=duployan}', "");
    Expect(0, 113827, '\p{^Script_Extensions=duployan}', "");
    Expect(0, 113827, '\P{Script_Extensions=duployan}', "");
    Expect(1, 113827, '\P{^Script_Extensions=duployan}', "");
    Expect(0, 113828, '\p{Script_Extensions=duployan}', "");
    Expect(1, 113828, '\p{^Script_Extensions=duployan}', "");
    Expect(1, 113828, '\P{Script_Extensions=duployan}', "");
    Expect(0, 113828, '\P{^Script_Extensions=duployan}', "");
    Expect(1, 113827, '\p{Script_Extensions=:\Aduployan\z:}', "");;
    Expect(0, 113828, '\p{Script_Extensions=:\Aduployan\z:}', "");;
    Expect(1, 113827, '\p{Script_Extensions=-	Duployan}', "");
    Expect(0, 113827, '\p{^Script_Extensions=-	Duployan}', "");
    Expect(0, 113827, '\P{Script_Extensions=-	Duployan}', "");
    Expect(1, 113827, '\P{^Script_Extensions=-	Duployan}', "");
    Expect(0, 113828, '\p{Script_Extensions=-	Duployan}', "");
    Expect(1, 113828, '\p{^Script_Extensions=-	Duployan}', "");
    Expect(1, 113828, '\P{Script_Extensions=-	Duployan}', "");
    Expect(0, 113828, '\P{^Script_Extensions=-	Duployan}', "");
    Error('\p{Scx=:=__Dupl}');
    Error('\P{Scx=:=__Dupl}');
    Expect(1, 113827, '\p{Scx=:\ADupl\z:}', "");;
    Expect(0, 113828, '\p{Scx=:\ADupl\z:}', "");;
    Expect(1, 113827, '\p{Scx=dupl}', "");
    Expect(0, 113827, '\p{^Scx=dupl}', "");
    Expect(0, 113827, '\P{Scx=dupl}', "");
    Expect(1, 113827, '\P{^Scx=dupl}', "");
    Expect(0, 113828, '\p{Scx=dupl}', "");
    Expect(1, 113828, '\p{^Scx=dupl}', "");
    Expect(1, 113828, '\P{Scx=dupl}', "");
    Expect(0, 113828, '\P{^Scx=dupl}', "");
    Expect(1, 113827, '\p{Scx=:\Adupl\z:}', "");;
    Expect(0, 113828, '\p{Scx=:\Adupl\z:}', "");;
    Expect(1, 113827, '\p{Scx:   -dupl}', "");
    Expect(0, 113827, '\p{^Scx:   -dupl}', "");
    Expect(0, 113827, '\P{Scx:   -dupl}', "");
    Expect(1, 113827, '\P{^Scx:   -dupl}', "");
    Expect(0, 113828, '\p{Scx:   -dupl}', "");
    Expect(1, 113828, '\p{^Scx:   -dupl}', "");
    Expect(1, 113828, '\P{Scx:   -dupl}', "");
    Expect(0, 113828, '\P{^Scx:   -dupl}', "");
    Error('\p{Is_Script_Extensions=:=	 DUPLOYAN}');
    Error('\P{Is_Script_Extensions=:=	 DUPLOYAN}');
    Expect(1, 113827, '\p{Is_Script_Extensions=duployan}', "");
    Expect(0, 113827, '\p{^Is_Script_Extensions=duployan}', "");
    Expect(0, 113827, '\P{Is_Script_Extensions=duployan}', "");
    Expect(1, 113827, '\P{^Is_Script_Extensions=duployan}', "");
    Expect(0, 113828, '\p{Is_Script_Extensions=duployan}', "");
    Expect(1, 113828, '\p{^Is_Script_Extensions=duployan}', "");
    Expect(1, 113828, '\P{Is_Script_Extensions=duployan}', "");
    Expect(0, 113828, '\P{^Is_Script_Extensions=duployan}', "");
    Expect(1, 113827, '\p{Is_Script_Extensions=--Duployan}', "");
    Expect(0, 113827, '\p{^Is_Script_Extensions=--Duployan}', "");
    Expect(0, 113827, '\P{Is_Script_Extensions=--Duployan}', "");
    Expect(1, 113827, '\P{^Is_Script_Extensions=--Duployan}', "");
    Expect(0, 113828, '\p{Is_Script_Extensions=--Duployan}', "");
    Expect(1, 113828, '\p{^Is_Script_Extensions=--Duployan}', "");
    Expect(1, 113828, '\P{Is_Script_Extensions=--Duployan}', "");
    Expect(0, 113828, '\P{^Is_Script_Extensions=--Duployan}', "");
    Error('\p{Is_Scx=:= 	dupl}');
    Error('\P{Is_Scx=:= 	dupl}');
    Expect(1, 113827, '\p{Is_Scx=dupl}', "");
    Expect(0, 113827, '\p{^Is_Scx=dupl}', "");
    Expect(0, 113827, '\P{Is_Scx=dupl}', "");
    Expect(1, 113827, '\P{^Is_Scx=dupl}', "");
    Expect(0, 113828, '\p{Is_Scx=dupl}', "");
    Expect(1, 113828, '\p{^Is_Scx=dupl}', "");
    Expect(1, 113828, '\P{Is_Scx=dupl}', "");
    Expect(0, 113828, '\P{^Is_Scx=dupl}', "");
    Expect(1, 113827, '\p{Is_Scx:	_Dupl}', "");
    Expect(0, 113827, '\p{^Is_Scx:	_Dupl}', "");
    Expect(0, 113827, '\P{Is_Scx:	_Dupl}', "");
    Expect(1, 113827, '\P{^Is_Scx:	_Dupl}', "");
    Expect(0, 113828, '\p{Is_Scx:	_Dupl}', "");
    Expect(1, 113828, '\p{^Is_Scx:	_Dupl}', "");
    Expect(1, 113828, '\P{Is_Scx:	_Dupl}', "");
    Expect(0, 113828, '\P{^Is_Scx:	_Dupl}', "");
    Error('\p{Script_Extensions=/a/	-egyptian_HIEROGLYPHS}');
    Error('\P{Script_Extensions=/a/	-egyptian_HIEROGLYPHS}');
    Expect(1, 78933, '\p{Script_Extensions=:\AEgyptian_Hieroglyphs\z:}', "");;
    Expect(0, 78934, '\p{Script_Extensions=:\AEgyptian_Hieroglyphs\z:}', "");;
    Expect(1, 78933, '\p{Script_Extensions=egyptianhieroglyphs}', "");
    Expect(0, 78933, '\p{^Script_Extensions=egyptianhieroglyphs}', "");
    Expect(0, 78933, '\P{Script_Extensions=egyptianhieroglyphs}', "");
    Expect(1, 78933, '\P{^Script_Extensions=egyptianhieroglyphs}', "");
    Expect(0, 78934, '\p{Script_Extensions=egyptianhieroglyphs}', "");
    Expect(1, 78934, '\p{^Script_Extensions=egyptianhieroglyphs}', "");
    Expect(1, 78934, '\P{Script_Extensions=egyptianhieroglyphs}', "");
    Expect(0, 78934, '\P{^Script_Extensions=egyptianhieroglyphs}', "");
    Expect(1, 78933, '\p{Script_Extensions=:\Aegyptianhieroglyphs\z:}', "");;
    Expect(0, 78934, '\p{Script_Extensions=:\Aegyptianhieroglyphs\z:}', "");;
    Expect(1, 78933, '\p{Script_Extensions=_-EGYPTIAN_Hieroglyphs}', "");
    Expect(0, 78933, '\p{^Script_Extensions=_-EGYPTIAN_Hieroglyphs}', "");
    Expect(0, 78933, '\P{Script_Extensions=_-EGYPTIAN_Hieroglyphs}', "");
    Expect(1, 78933, '\P{^Script_Extensions=_-EGYPTIAN_Hieroglyphs}', "");
    Expect(0, 78934, '\p{Script_Extensions=_-EGYPTIAN_Hieroglyphs}', "");
    Expect(1, 78934, '\p{^Script_Extensions=_-EGYPTIAN_Hieroglyphs}', "");
    Expect(1, 78934, '\P{Script_Extensions=_-EGYPTIAN_Hieroglyphs}', "");
    Expect(0, 78934, '\P{^Script_Extensions=_-EGYPTIAN_Hieroglyphs}', "");
    Error('\p{Scx=-/a/egyp}');
    Error('\P{Scx=-/a/egyp}');
    Expect(1, 78933, '\p{Scx=:\AEgyp\z:}', "");;
    Expect(0, 78934, '\p{Scx=:\AEgyp\z:}', "");;
    Expect(1, 78933, '\p{Scx=egyp}', "");
    Expect(0, 78933, '\p{^Scx=egyp}', "");
    Expect(0, 78933, '\P{Scx=egyp}', "");
    Expect(1, 78933, '\P{^Scx=egyp}', "");
    Expect(0, 78934, '\p{Scx=egyp}', "");
    Expect(1, 78934, '\p{^Scx=egyp}', "");
    Expect(1, 78934, '\P{Scx=egyp}', "");
    Expect(0, 78934, '\P{^Scx=egyp}', "");
    Expect(1, 78933, '\p{Scx=:\Aegyp\z:}', "");;
    Expect(0, 78934, '\p{Scx=:\Aegyp\z:}', "");;
    Expect(1, 78933, '\p{Scx=- Egyp}', "");
    Expect(0, 78933, '\p{^Scx=- Egyp}', "");
    Expect(0, 78933, '\P{Scx=- Egyp}', "");
    Expect(1, 78933, '\P{^Scx=- Egyp}', "");
    Expect(0, 78934, '\p{Scx=- Egyp}', "");
    Expect(1, 78934, '\p{^Scx=- Egyp}', "");
    Expect(1, 78934, '\P{Scx=- Egyp}', "");
    Expect(0, 78934, '\P{^Scx=- Egyp}', "");
    Error('\p{Is_Script_Extensions=-	Egyptian_Hieroglyphs:=}');
    Error('\P{Is_Script_Extensions=-	Egyptian_Hieroglyphs:=}');
    Expect(1, 78933, '\p{Is_Script_Extensions=egyptianhieroglyphs}', "");
    Expect(0, 78933, '\p{^Is_Script_Extensions=egyptianhieroglyphs}', "");
    Expect(0, 78933, '\P{Is_Script_Extensions=egyptianhieroglyphs}', "");
    Expect(1, 78933, '\P{^Is_Script_Extensions=egyptianhieroglyphs}', "");
    Expect(0, 78934, '\p{Is_Script_Extensions=egyptianhieroglyphs}', "");
    Expect(1, 78934, '\p{^Is_Script_Extensions=egyptianhieroglyphs}', "");
    Expect(1, 78934, '\P{Is_Script_Extensions=egyptianhieroglyphs}', "");
    Expect(0, 78934, '\P{^Is_Script_Extensions=egyptianhieroglyphs}', "");
    Expect(1, 78933, '\p{Is_Script_Extensions=  EGYPTIAN_Hieroglyphs}', "");
    Expect(0, 78933, '\p{^Is_Script_Extensions=  EGYPTIAN_Hieroglyphs}', "");
    Expect(0, 78933, '\P{Is_Script_Extensions=  EGYPTIAN_Hieroglyphs}', "");
    Expect(1, 78933, '\P{^Is_Script_Extensions=  EGYPTIAN_Hieroglyphs}', "");
    Expect(0, 78934, '\p{Is_Script_Extensions=  EGYPTIAN_Hieroglyphs}', "");
    Expect(1, 78934, '\p{^Is_Script_Extensions=  EGYPTIAN_Hieroglyphs}', "");
    Expect(1, 78934, '\P{Is_Script_Extensions=  EGYPTIAN_Hieroglyphs}', "");
    Expect(0, 78934, '\P{^Is_Script_Extensions=  EGYPTIAN_Hieroglyphs}', "");
    Error('\p{Is_Scx= /a/EGYP}');
    Error('\P{Is_Scx= /a/EGYP}');
    Expect(1, 78933, '\p{Is_Scx=egyp}', "");
    Expect(0, 78933, '\p{^Is_Scx=egyp}', "");
    Expect(0, 78933, '\P{Is_Scx=egyp}', "");
    Expect(1, 78933, '\P{^Is_Scx=egyp}', "");
    Expect(0, 78934, '\p{Is_Scx=egyp}', "");
    Expect(1, 78934, '\p{^Is_Scx=egyp}', "");
    Expect(1, 78934, '\P{Is_Scx=egyp}', "");
    Expect(0, 78934, '\P{^Is_Scx=egyp}', "");
    Expect(1, 78933, '\p{Is_Scx=		Egyp}', "");
    Expect(0, 78933, '\p{^Is_Scx=		Egyp}', "");
    Expect(0, 78933, '\P{Is_Scx=		Egyp}', "");
    Expect(1, 78933, '\P{^Is_Scx=		Egyp}', "");
    Expect(0, 78934, '\p{Is_Scx=		Egyp}', "");
    Expect(1, 78934, '\p{^Is_Scx=		Egyp}', "");
    Expect(1, 78934, '\P{Is_Scx=		Egyp}', "");
    Expect(0, 78934, '\P{^Is_Scx=		Egyp}', "");
    Error('\p{Script_Extensions:  _elbasan/a/}');
    Error('\P{Script_Extensions:  _elbasan/a/}');
    Expect(1, 66855, '\p{Script_Extensions=:\AElbasan\z:}', "");;
    Expect(0, 66856, '\p{Script_Extensions=:\AElbasan\z:}', "");;
    Expect(1, 66855, '\p{Script_Extensions=elbasan}', "");
    Expect(0, 66855, '\p{^Script_Extensions=elbasan}', "");
    Expect(0, 66855, '\P{Script_Extensions=elbasan}', "");
    Expect(1, 66855, '\P{^Script_Extensions=elbasan}', "");
    Expect(0, 66856, '\p{Script_Extensions=elbasan}', "");
    Expect(1, 66856, '\p{^Script_Extensions=elbasan}', "");
    Expect(1, 66856, '\P{Script_Extensions=elbasan}', "");
    Expect(0, 66856, '\P{^Script_Extensions=elbasan}', "");
    Expect(1, 66855, '\p{Script_Extensions=:\Aelbasan\z:}', "");;
    Expect(0, 66856, '\p{Script_Extensions=:\Aelbasan\z:}', "");;
    Expect(1, 66855, '\p{Script_Extensions=  Elbasan}', "");
    Expect(0, 66855, '\p{^Script_Extensions=  Elbasan}', "");
    Expect(0, 66855, '\P{Script_Extensions=  Elbasan}', "");
    Expect(1, 66855, '\P{^Script_Extensions=  Elbasan}', "");
    Expect(0, 66856, '\p{Script_Extensions=  Elbasan}', "");
    Expect(1, 66856, '\p{^Script_Extensions=  Elbasan}', "");
    Expect(1, 66856, '\P{Script_Extensions=  Elbasan}', "");
    Expect(0, 66856, '\P{^Script_Extensions=  Elbasan}', "");
    Error('\p{Scx=/a/	 Elba}');
    Error('\P{Scx=/a/	 Elba}');
    Expect(1, 66855, '\p{Scx=:\AElba\z:}', "");;
    Expect(0, 66856, '\p{Scx=:\AElba\z:}', "");;
    Expect(1, 66855, '\p{Scx=elba}', "");
    Expect(0, 66855, '\p{^Scx=elba}', "");
    Expect(0, 66855, '\P{Scx=elba}', "");
    Expect(1, 66855, '\P{^Scx=elba}', "");
    Expect(0, 66856, '\p{Scx=elba}', "");
    Expect(1, 66856, '\p{^Scx=elba}', "");
    Expect(1, 66856, '\P{Scx=elba}', "");
    Expect(0, 66856, '\P{^Scx=elba}', "");
    Expect(1, 66855, '\p{Scx=:\Aelba\z:}', "");;
    Expect(0, 66856, '\p{Scx=:\Aelba\z:}', "");;
    Expect(1, 66855, '\p{Scx=_elba}', "");
    Expect(0, 66855, '\p{^Scx=_elba}', "");
    Expect(0, 66855, '\P{Scx=_elba}', "");
    Expect(1, 66855, '\P{^Scx=_elba}', "");
    Expect(0, 66856, '\p{Scx=_elba}', "");
    Expect(1, 66856, '\p{^Scx=_elba}', "");
    Expect(1, 66856, '\P{Scx=_elba}', "");
    Expect(0, 66856, '\P{^Scx=_elba}', "");
    Error('\p{Is_Script_Extensions=:=Elbasan}');
    Error('\P{Is_Script_Extensions=:=Elbasan}');
    Expect(1, 66855, '\p{Is_Script_Extensions=elbasan}', "");
    Expect(0, 66855, '\p{^Is_Script_Extensions=elbasan}', "");
    Expect(0, 66855, '\P{Is_Script_Extensions=elbasan}', "");
    Expect(1, 66855, '\P{^Is_Script_Extensions=elbasan}', "");
    Expect(0, 66856, '\p{Is_Script_Extensions=elbasan}', "");
    Expect(1, 66856, '\p{^Is_Script_Extensions=elbasan}', "");
    Expect(1, 66856, '\P{Is_Script_Extensions=elbasan}', "");
    Expect(0, 66856, '\P{^Is_Script_Extensions=elbasan}', "");
    Expect(1, 66855, '\p{Is_Script_Extensions=-Elbasan}', "");
    Expect(0, 66855, '\p{^Is_Script_Extensions=-Elbasan}', "");
    Expect(0, 66855, '\P{Is_Script_Extensions=-Elbasan}', "");
    Expect(1, 66855, '\P{^Is_Script_Extensions=-Elbasan}', "");
    Expect(0, 66856, '\p{Is_Script_Extensions=-Elbasan}', "");
    Expect(1, 66856, '\p{^Is_Script_Extensions=-Elbasan}', "");
    Expect(1, 66856, '\P{Is_Script_Extensions=-Elbasan}', "");
    Expect(0, 66856, '\P{^Is_Script_Extensions=-Elbasan}', "");
    Error('\p{Is_Scx=--Elba:=}');
    Error('\P{Is_Scx=--Elba:=}');
    Expect(1, 66855, '\p{Is_Scx=elba}', "");
    Expect(0, 66855, '\p{^Is_Scx=elba}', "");
    Expect(0, 66855, '\P{Is_Scx=elba}', "");
    Expect(1, 66855, '\P{^Is_Scx=elba}', "");
    Expect(0, 66856, '\p{Is_Scx=elba}', "");
    Expect(1, 66856, '\p{^Is_Scx=elba}', "");
    Expect(1, 66856, '\P{Is_Scx=elba}', "");
    Expect(0, 66856, '\P{^Is_Scx=elba}', "");
    Expect(1, 66855, '\p{Is_Scx=	_Elba}', "");
    Expect(0, 66855, '\p{^Is_Scx=	_Elba}', "");
    Expect(0, 66855, '\P{Is_Scx=	_Elba}', "");
    Expect(1, 66855, '\P{^Is_Scx=	_Elba}', "");
    Expect(0, 66856, '\p{Is_Scx=	_Elba}', "");
    Expect(1, 66856, '\p{^Is_Scx=	_Elba}', "");
    Expect(1, 66856, '\P{Is_Scx=	_Elba}', "");
    Expect(0, 66856, '\P{^Is_Scx=	_Elba}', "");
    Error('\p{Script_Extensions=_:=ELYMAIC}');
    Error('\P{Script_Extensions=_:=ELYMAIC}');
    Expect(1, 69622, '\p{Script_Extensions=:\AElymaic\z:}', "");;
    Expect(0, 69623, '\p{Script_Extensions=:\AElymaic\z:}', "");;
    Expect(1, 69622, '\p{Script_Extensions=elymaic}', "");
    Expect(0, 69622, '\p{^Script_Extensions=elymaic}', "");
    Expect(0, 69622, '\P{Script_Extensions=elymaic}', "");
    Expect(1, 69622, '\P{^Script_Extensions=elymaic}', "");
    Expect(0, 69623, '\p{Script_Extensions=elymaic}', "");
    Expect(1, 69623, '\p{^Script_Extensions=elymaic}', "");
    Expect(1, 69623, '\P{Script_Extensions=elymaic}', "");
    Expect(0, 69623, '\P{^Script_Extensions=elymaic}', "");
    Expect(1, 69622, '\p{Script_Extensions=:\Aelymaic\z:}', "");;
    Expect(0, 69623, '\p{Script_Extensions=:\Aelymaic\z:}', "");;
    Expect(1, 69622, '\p{Script_Extensions= ELYMAIC}', "");
    Expect(0, 69622, '\p{^Script_Extensions= ELYMAIC}', "");
    Expect(0, 69622, '\P{Script_Extensions= ELYMAIC}', "");
    Expect(1, 69622, '\P{^Script_Extensions= ELYMAIC}', "");
    Expect(0, 69623, '\p{Script_Extensions= ELYMAIC}', "");
    Expect(1, 69623, '\p{^Script_Extensions= ELYMAIC}', "");
    Expect(1, 69623, '\P{Script_Extensions= ELYMAIC}', "");
    Expect(0, 69623, '\P{^Script_Extensions= ELYMAIC}', "");
    Error('\p{Scx:	:=elym}');
    Error('\P{Scx:	:=elym}');
    Expect(1, 69622, '\p{Scx=:\AElym\z:}', "");;
    Expect(0, 69623, '\p{Scx=:\AElym\z:}', "");;
    Expect(1, 69622, '\p{Scx=elym}', "");
    Expect(0, 69622, '\p{^Scx=elym}', "");
    Expect(0, 69622, '\P{Scx=elym}', "");
    Expect(1, 69622, '\P{^Scx=elym}', "");
    Expect(0, 69623, '\p{Scx=elym}', "");
    Expect(1, 69623, '\p{^Scx=elym}', "");
    Expect(1, 69623, '\P{Scx=elym}', "");
    Expect(0, 69623, '\P{^Scx=elym}', "");
    Expect(1, 69622, '\p{Scx=:\Aelym\z:}', "");;
    Expect(0, 69623, '\p{Scx=:\Aelym\z:}', "");;
    Expect(1, 69622, '\p{Scx=	ELYM}', "");
    Expect(0, 69622, '\p{^Scx=	ELYM}', "");
    Expect(0, 69622, '\P{Scx=	ELYM}', "");
    Expect(1, 69622, '\P{^Scx=	ELYM}', "");
    Expect(0, 69623, '\p{Scx=	ELYM}', "");
    Expect(1, 69623, '\p{^Scx=	ELYM}', "");
    Expect(1, 69623, '\P{Scx=	ELYM}', "");
    Expect(0, 69623, '\P{^Scx=	ELYM}', "");
    Error('\p{Is_Script_Extensions=/a/	-elymaic}');
    Error('\P{Is_Script_Extensions=/a/	-elymaic}');
    Expect(1, 69622, '\p{Is_Script_Extensions=elymaic}', "");
    Expect(0, 69622, '\p{^Is_Script_Extensions=elymaic}', "");
    Expect(0, 69622, '\P{Is_Script_Extensions=elymaic}', "");
    Expect(1, 69622, '\P{^Is_Script_Extensions=elymaic}', "");
    Expect(0, 69623, '\p{Is_Script_Extensions=elymaic}', "");
    Expect(1, 69623, '\p{^Is_Script_Extensions=elymaic}', "");
    Expect(1, 69623, '\P{Is_Script_Extensions=elymaic}', "");
    Expect(0, 69623, '\P{^Is_Script_Extensions=elymaic}', "");
    Expect(1, 69622, '\p{Is_Script_Extensions=_-Elymaic}', "");
    Expect(0, 69622, '\p{^Is_Script_Extensions=_-Elymaic}', "");
    Expect(0, 69622, '\P{Is_Script_Extensions=_-Elymaic}', "");
    Expect(1, 69622, '\P{^Is_Script_Extensions=_-Elymaic}', "");
    Expect(0, 69623, '\p{Is_Script_Extensions=_-Elymaic}', "");
    Expect(1, 69623, '\p{^Is_Script_Extensions=_-Elymaic}', "");
    Expect(1, 69623, '\P{Is_Script_Extensions=_-Elymaic}', "");
    Expect(0, 69623, '\P{^Is_Script_Extensions=_-Elymaic}', "");
    Error('\p{Is_Scx= ELYM:=}');
    Error('\P{Is_Scx= ELYM:=}');
    Expect(1, 69622, '\p{Is_Scx=elym}', "");
    Expect(0, 69622, '\p{^Is_Scx=elym}', "");
    Expect(0, 69622, '\P{Is_Scx=elym}', "");
    Expect(1, 69622, '\P{^Is_Scx=elym}', "");
    Expect(0, 69623, '\p{Is_Scx=elym}', "");
    Expect(1, 69623, '\p{^Is_Scx=elym}', "");
    Expect(1, 69623, '\P{Is_Scx=elym}', "");
    Expect(0, 69623, '\P{^Is_Scx=elym}', "");
    Expect(1, 69622, '\p{Is_Scx=_-ELYM}', "");
    Expect(0, 69622, '\p{^Is_Scx=_-ELYM}', "");
    Expect(0, 69622, '\P{Is_Scx=_-ELYM}', "");
    Expect(1, 69622, '\P{^Is_Scx=_-ELYM}', "");
    Expect(0, 69623, '\p{Is_Scx=_-ELYM}', "");
    Expect(1, 69623, '\p{^Is_Scx=_-ELYM}', "");
    Expect(1, 69623, '\P{Is_Scx=_-ELYM}', "");
    Expect(0, 69623, '\P{^Is_Scx=_-ELYM}', "");
    Error('\p{Script_Extensions=_/a/ETHIOPIC}');
    Error('\P{Script_Extensions=_/a/ETHIOPIC}');
    Expect(1, 124926, '\p{Script_Extensions=:\AEthiopic\z:}', "");;
    Expect(0, 124927, '\p{Script_Extensions=:\AEthiopic\z:}', "");;
    Expect(1, 124926, '\p{Script_Extensions=ethiopic}', "");
    Expect(0, 124926, '\p{^Script_Extensions=ethiopic}', "");
    Expect(0, 124926, '\P{Script_Extensions=ethiopic}', "");
    Expect(1, 124926, '\P{^Script_Extensions=ethiopic}', "");
    Expect(0, 124927, '\p{Script_Extensions=ethiopic}', "");
    Expect(1, 124927, '\p{^Script_Extensions=ethiopic}', "");
    Expect(1, 124927, '\P{Script_Extensions=ethiopic}', "");
    Expect(0, 124927, '\P{^Script_Extensions=ethiopic}', "");
    Expect(1, 124926, '\p{Script_Extensions=:\Aethiopic\z:}', "");;
    Expect(0, 124927, '\p{Script_Extensions=:\Aethiopic\z:}', "");;
    Expect(1, 124926, '\p{Script_Extensions= ETHIOPIC}', "");
    Expect(0, 124926, '\p{^Script_Extensions= ETHIOPIC}', "");
    Expect(0, 124926, '\P{Script_Extensions= ETHIOPIC}', "");
    Expect(1, 124926, '\P{^Script_Extensions= ETHIOPIC}', "");
    Expect(0, 124927, '\p{Script_Extensions= ETHIOPIC}', "");
    Expect(1, 124927, '\p{^Script_Extensions= ETHIOPIC}', "");
    Expect(1, 124927, '\P{Script_Extensions= ETHIOPIC}', "");
    Expect(0, 124927, '\P{^Script_Extensions= ETHIOPIC}', "");
    Error('\p{Scx=	ethi/a/}');
    Error('\P{Scx=	ethi/a/}');
    Expect(1, 124926, '\p{Scx=:\AEthi\z:}', "");;
    Expect(0, 124927, '\p{Scx=:\AEthi\z:}', "");;
    Expect(1, 124926, '\p{Scx=ethi}', "");
    Expect(0, 124926, '\p{^Scx=ethi}', "");
    Expect(0, 124926, '\P{Scx=ethi}', "");
    Expect(1, 124926, '\P{^Scx=ethi}', "");
    Expect(0, 124927, '\p{Scx=ethi}', "");
    Expect(1, 124927, '\p{^Scx=ethi}', "");
    Expect(1, 124927, '\P{Scx=ethi}', "");
    Expect(0, 124927, '\P{^Scx=ethi}', "");
    Expect(1, 124926, '\p{Scx=:\Aethi\z:}', "");;
    Expect(0, 124927, '\p{Scx=:\Aethi\z:}', "");;
    Expect(1, 124926, '\p{Scx= -Ethi}', "");
    Expect(0, 124926, '\p{^Scx= -Ethi}', "");
    Expect(0, 124926, '\P{Scx= -Ethi}', "");
    Expect(1, 124926, '\P{^Scx= -Ethi}', "");
    Expect(0, 124927, '\p{Scx= -Ethi}', "");
    Expect(1, 124927, '\p{^Scx= -Ethi}', "");
    Expect(1, 124927, '\P{Scx= -Ethi}', "");
    Expect(0, 124927, '\P{^Scx= -Ethi}', "");
    Error('\p{Is_Script_Extensions=:=-_ETHIOPIC}');
    Error('\P{Is_Script_Extensions=:=-_ETHIOPIC}');
    Expect(1, 124926, '\p{Is_Script_Extensions=ethiopic}', "");
    Expect(0, 124926, '\p{^Is_Script_Extensions=ethiopic}', "");
    Expect(0, 124926, '\P{Is_Script_Extensions=ethiopic}', "");
    Expect(1, 124926, '\P{^Is_Script_Extensions=ethiopic}', "");
    Expect(0, 124927, '\p{Is_Script_Extensions=ethiopic}', "");
    Expect(1, 124927, '\p{^Is_Script_Extensions=ethiopic}', "");
    Expect(1, 124927, '\P{Is_Script_Extensions=ethiopic}', "");
    Expect(0, 124927, '\P{^Is_Script_Extensions=ethiopic}', "");
    Expect(1, 124926, '\p{Is_Script_Extensions=__ETHIOPIC}', "");
    Expect(0, 124926, '\p{^Is_Script_Extensions=__ETHIOPIC}', "");
    Expect(0, 124926, '\P{Is_Script_Extensions=__ETHIOPIC}', "");
    Expect(1, 124926, '\P{^Is_Script_Extensions=__ETHIOPIC}', "");
    Expect(0, 124927, '\p{Is_Script_Extensions=__ETHIOPIC}', "");
    Expect(1, 124927, '\p{^Is_Script_Extensions=__ETHIOPIC}', "");
    Expect(1, 124927, '\P{Is_Script_Extensions=__ETHIOPIC}', "");
    Expect(0, 124927, '\P{^Is_Script_Extensions=__ETHIOPIC}', "");
    Error('\p{Is_Scx=Ethi/a/}');
    Error('\P{Is_Scx=Ethi/a/}');
    Expect(1, 124926, '\p{Is_Scx=ethi}', "");
    Expect(0, 124926, '\p{^Is_Scx=ethi}', "");
    Expect(0, 124926, '\P{Is_Scx=ethi}', "");
    Expect(1, 124926, '\P{^Is_Scx=ethi}', "");
    Expect(0, 124927, '\p{Is_Scx=ethi}', "");
    Expect(1, 124927, '\p{^Is_Scx=ethi}', "");
    Expect(1, 124927, '\P{Is_Scx=ethi}', "");
    Expect(0, 124927, '\P{^Is_Scx=ethi}', "");
    Expect(1, 124926, '\p{Is_Scx=  ethi}', "");
    Expect(0, 124926, '\p{^Is_Scx=  ethi}', "");
    Expect(0, 124926, '\P{Is_Scx=  ethi}', "");
    Expect(1, 124926, '\P{^Is_Scx=  ethi}', "");
    Expect(0, 124927, '\p{Is_Scx=  ethi}', "");
    Expect(1, 124927, '\p{^Is_Scx=  ethi}', "");
    Expect(1, 124927, '\P{Is_Scx=  ethi}', "");
    Expect(0, 124927, '\P{^Is_Scx=  ethi}', "");
    Error('\p{Script_Extensions=/a/_georgian}');
    Error('\P{Script_Extensions=/a/_georgian}');
    Expect(1, 11565, '\p{Script_Extensions=:\AGeorgian\z:}', "");;
    Expect(0, 11566, '\p{Script_Extensions=:\AGeorgian\z:}', "");;
    Expect(1, 11565, '\p{Script_Extensions=georgian}', "");
    Expect(0, 11565, '\p{^Script_Extensions=georgian}', "");
    Expect(0, 11565, '\P{Script_Extensions=georgian}', "");
    Expect(1, 11565, '\P{^Script_Extensions=georgian}', "");
    Expect(0, 11566, '\p{Script_Extensions=georgian}', "");
    Expect(1, 11566, '\p{^Script_Extensions=georgian}', "");
    Expect(1, 11566, '\P{Script_Extensions=georgian}', "");
    Expect(0, 11566, '\P{^Script_Extensions=georgian}', "");
    Expect(1, 11565, '\p{Script_Extensions=:\Ageorgian\z:}', "");;
    Expect(0, 11566, '\p{Script_Extensions=:\Ageorgian\z:}', "");;
    Expect(1, 11565, '\p{Script_Extensions=-_georgian}', "");
    Expect(0, 11565, '\p{^Script_Extensions=-_georgian}', "");
    Expect(0, 11565, '\P{Script_Extensions=-_georgian}', "");
    Expect(1, 11565, '\P{^Script_Extensions=-_georgian}', "");
    Expect(0, 11566, '\p{Script_Extensions=-_georgian}', "");
    Expect(1, 11566, '\p{^Script_Extensions=-_georgian}', "");
    Expect(1, 11566, '\P{Script_Extensions=-_georgian}', "");
    Expect(0, 11566, '\P{^Script_Extensions=-_georgian}', "");
    Error('\p{Scx:   :=	_Geor}');
    Error('\P{Scx:   :=	_Geor}');
    Expect(1, 11565, '\p{Scx=:\AGeor\z:}', "");;
    Expect(0, 11566, '\p{Scx=:\AGeor\z:}', "");;
    Expect(1, 11565, '\p{Scx=geor}', "");
    Expect(0, 11565, '\p{^Scx=geor}', "");
    Expect(0, 11565, '\P{Scx=geor}', "");
    Expect(1, 11565, '\P{^Scx=geor}', "");
    Expect(0, 11566, '\p{Scx=geor}', "");
    Expect(1, 11566, '\p{^Scx=geor}', "");
    Expect(1, 11566, '\P{Scx=geor}', "");
    Expect(0, 11566, '\P{^Scx=geor}', "");
    Expect(1, 11565, '\p{Scx=:\Ageor\z:}', "");;
    Expect(0, 11566, '\p{Scx=:\Ageor\z:}', "");;
    Expect(1, 11565, '\p{Scx=_GEOR}', "");
    Expect(0, 11565, '\p{^Scx=_GEOR}', "");
    Expect(0, 11565, '\P{Scx=_GEOR}', "");
    Expect(1, 11565, '\P{^Scx=_GEOR}', "");
    Expect(0, 11566, '\p{Scx=_GEOR}', "");
    Expect(1, 11566, '\p{^Scx=_GEOR}', "");
    Expect(1, 11566, '\P{Scx=_GEOR}', "");
    Expect(0, 11566, '\P{^Scx=_GEOR}', "");
    Error('\p{Is_Script_Extensions: -Georgian/a/}');
    Error('\P{Is_Script_Extensions: -Georgian/a/}');
    Expect(1, 11565, '\p{Is_Script_Extensions=georgian}', "");
    Expect(0, 11565, '\p{^Is_Script_Extensions=georgian}', "");
    Expect(0, 11565, '\P{Is_Script_Extensions=georgian}', "");
    Expect(1, 11565, '\P{^Is_Script_Extensions=georgian}', "");
    Expect(0, 11566, '\p{Is_Script_Extensions=georgian}', "");
    Expect(1, 11566, '\p{^Is_Script_Extensions=georgian}', "");
    Expect(1, 11566, '\P{Is_Script_Extensions=georgian}', "");
    Expect(0, 11566, '\P{^Is_Script_Extensions=georgian}', "");
    Expect(1, 11565, '\p{Is_Script_Extensions=	-GEORGIAN}', "");
    Expect(0, 11565, '\p{^Is_Script_Extensions=	-GEORGIAN}', "");
    Expect(0, 11565, '\P{Is_Script_Extensions=	-GEORGIAN}', "");
    Expect(1, 11565, '\P{^Is_Script_Extensions=	-GEORGIAN}', "");
    Expect(0, 11566, '\p{Is_Script_Extensions=	-GEORGIAN}', "");
    Expect(1, 11566, '\p{^Is_Script_Extensions=	-GEORGIAN}', "");
    Expect(1, 11566, '\P{Is_Script_Extensions=	-GEORGIAN}', "");
    Expect(0, 11566, '\P{^Is_Script_Extensions=	-GEORGIAN}', "");
    Error('\p{Is_Scx= Geor:=}');
    Error('\P{Is_Scx= Geor:=}');
    Expect(1, 11565, '\p{Is_Scx:geor}', "");
    Expect(0, 11565, '\p{^Is_Scx:geor}', "");
    Expect(0, 11565, '\P{Is_Scx:geor}', "");
    Expect(1, 11565, '\P{^Is_Scx:geor}', "");
    Expect(0, 11566, '\p{Is_Scx:geor}', "");
    Expect(1, 11566, '\p{^Is_Scx:geor}', "");
    Expect(1, 11566, '\P{Is_Scx:geor}', "");
    Expect(0, 11566, '\P{^Is_Scx:geor}', "");
    Expect(1, 11565, '\p{Is_Scx=-	Geor}', "");
    Expect(0, 11565, '\p{^Is_Scx=-	Geor}', "");
    Expect(0, 11565, '\P{Is_Scx=-	Geor}', "");
    Expect(1, 11565, '\P{^Is_Scx=-	Geor}', "");
    Expect(0, 11566, '\p{Is_Scx=-	Geor}', "");
    Expect(1, 11566, '\p{^Is_Scx=-	Geor}', "");
    Expect(1, 11566, '\P{Is_Scx=-	Geor}', "");
    Expect(0, 11566, '\P{^Is_Scx=-	Geor}', "");
    Error('\p{Script_Extensions=_/a/Glagolitic}');
    Error('\P{Script_Extensions=_/a/Glagolitic}');
    Expect(1, 122922, '\p{Script_Extensions=:\AGlagolitic\z:}', "");;
    Expect(0, 122923, '\p{Script_Extensions=:\AGlagolitic\z:}', "");;
    Expect(1, 122922, '\p{Script_Extensions=glagolitic}', "");
    Expect(0, 122922, '\p{^Script_Extensions=glagolitic}', "");
    Expect(0, 122922, '\P{Script_Extensions=glagolitic}', "");
    Expect(1, 122922, '\P{^Script_Extensions=glagolitic}', "");
    Expect(0, 122923, '\p{Script_Extensions=glagolitic}', "");
    Expect(1, 122923, '\p{^Script_Extensions=glagolitic}', "");
    Expect(1, 122923, '\P{Script_Extensions=glagolitic}', "");
    Expect(0, 122923, '\P{^Script_Extensions=glagolitic}', "");
    Expect(1, 122922, '\p{Script_Extensions=:\Aglagolitic\z:}', "");;
    Expect(0, 122923, '\p{Script_Extensions=:\Aglagolitic\z:}', "");;
    Expect(1, 122922, '\p{Script_Extensions=	-Glagolitic}', "");
    Expect(0, 122922, '\p{^Script_Extensions=	-Glagolitic}', "");
    Expect(0, 122922, '\P{Script_Extensions=	-Glagolitic}', "");
    Expect(1, 122922, '\P{^Script_Extensions=	-Glagolitic}', "");
    Expect(0, 122923, '\p{Script_Extensions=	-Glagolitic}', "");
    Expect(1, 122923, '\p{^Script_Extensions=	-Glagolitic}', "");
    Expect(1, 122923, '\P{Script_Extensions=	-Glagolitic}', "");
    Expect(0, 122923, '\P{^Script_Extensions=	-Glagolitic}', "");
    Error('\p{Scx=_glag:=}');
    Error('\P{Scx=_glag:=}');
    Expect(1, 122922, '\p{Scx=:\AGlag\z:}', "");;
    Expect(0, 122923, '\p{Scx=:\AGlag\z:}', "");;
    Expect(1, 122922, '\p{Scx:	glag}', "");
    Expect(0, 122922, '\p{^Scx:	glag}', "");
    Expect(0, 122922, '\P{Scx:	glag}', "");
    Expect(1, 122922, '\P{^Scx:	glag}', "");
    Expect(0, 122923, '\p{Scx:	glag}', "");
    Expect(1, 122923, '\p{^Scx:	glag}', "");
    Expect(1, 122923, '\P{Scx:	glag}', "");
    Expect(0, 122923, '\P{^Scx:	glag}', "");
    Expect(1, 122922, '\p{Scx=:\Aglag\z:}', "");;
    Expect(0, 122923, '\p{Scx=:\Aglag\z:}', "");;
    Expect(1, 122922, '\p{Scx=- GLAG}', "");
    Expect(0, 122922, '\p{^Scx=- GLAG}', "");
    Expect(0, 122922, '\P{Scx=- GLAG}', "");
    Expect(1, 122922, '\P{^Scx=- GLAG}', "");
    Expect(0, 122923, '\p{Scx=- GLAG}', "");
    Expect(1, 122923, '\p{^Scx=- GLAG}', "");
    Expect(1, 122923, '\P{Scx=- GLAG}', "");
    Expect(0, 122923, '\P{^Scx=- GLAG}', "");
    Error('\p{Is_Script_Extensions=	 glagolitic/a/}');
    Error('\P{Is_Script_Extensions=	 glagolitic/a/}');
    Expect(1, 122922, '\p{Is_Script_Extensions=glagolitic}', "");
    Expect(0, 122922, '\p{^Is_Script_Extensions=glagolitic}', "");
    Expect(0, 122922, '\P{Is_Script_Extensions=glagolitic}', "");
    Expect(1, 122922, '\P{^Is_Script_Extensions=glagolitic}', "");
    Expect(0, 122923, '\p{Is_Script_Extensions=glagolitic}', "");
    Expect(1, 122923, '\p{^Is_Script_Extensions=glagolitic}', "");
    Expect(1, 122923, '\P{Is_Script_Extensions=glagolitic}', "");
    Expect(0, 122923, '\P{^Is_Script_Extensions=glagolitic}', "");
    Expect(1, 122922, '\p{Is_Script_Extensions=_GLAGOLITIC}', "");
    Expect(0, 122922, '\p{^Is_Script_Extensions=_GLAGOLITIC}', "");
    Expect(0, 122922, '\P{Is_Script_Extensions=_GLAGOLITIC}', "");
    Expect(1, 122922, '\P{^Is_Script_Extensions=_GLAGOLITIC}', "");
    Expect(0, 122923, '\p{Is_Script_Extensions=_GLAGOLITIC}', "");
    Expect(1, 122923, '\p{^Is_Script_Extensions=_GLAGOLITIC}', "");
    Expect(1, 122923, '\P{Is_Script_Extensions=_GLAGOLITIC}', "");
    Expect(0, 122923, '\P{^Is_Script_Extensions=_GLAGOLITIC}', "");
    Error('\p{Is_Scx= /a/GLAG}');
    Error('\P{Is_Scx= /a/GLAG}');
    Expect(1, 122922, '\p{Is_Scx=glag}', "");
    Expect(0, 122922, '\p{^Is_Scx=glag}', "");
    Expect(0, 122922, '\P{Is_Scx=glag}', "");
    Expect(1, 122922, '\P{^Is_Scx=glag}', "");
    Expect(0, 122923, '\p{Is_Scx=glag}', "");
    Expect(1, 122923, '\p{^Is_Scx=glag}', "");
    Expect(1, 122923, '\P{Is_Scx=glag}', "");
    Expect(0, 122923, '\P{^Is_Scx=glag}', "");
    Expect(1, 122922, '\p{Is_Scx=-Glag}', "");
    Expect(0, 122922, '\p{^Is_Scx=-Glag}', "");
    Expect(0, 122922, '\P{Is_Scx=-Glag}', "");
    Expect(1, 122922, '\P{^Is_Scx=-Glag}', "");
    Expect(0, 122923, '\p{Is_Scx=-Glag}', "");
    Expect(1, 122923, '\p{^Is_Scx=-Glag}', "");
    Expect(1, 122923, '\P{Is_Scx=-Glag}', "");
    Expect(0, 122923, '\P{^Is_Scx=-Glag}', "");
    Error('\p{Script_Extensions=GUNJALA_GONDI/a/}');
    Error('\P{Script_Extensions=GUNJALA_GONDI/a/}');
    Expect(1, 73129, '\p{Script_Extensions=:\AGunjala_Gondi\z:}', "");;
    Expect(0, 73130, '\p{Script_Extensions=:\AGunjala_Gondi\z:}', "");;
    Expect(1, 73129, '\p{Script_Extensions=gunjalagondi}', "");
    Expect(0, 73129, '\p{^Script_Extensions=gunjalagondi}', "");
    Expect(0, 73129, '\P{Script_Extensions=gunjalagondi}', "");
    Expect(1, 73129, '\P{^Script_Extensions=gunjalagondi}', "");
    Expect(0, 73130, '\p{Script_Extensions=gunjalagondi}', "");
    Expect(1, 73130, '\p{^Script_Extensions=gunjalagondi}', "");
    Expect(1, 73130, '\P{Script_Extensions=gunjalagondi}', "");
    Expect(0, 73130, '\P{^Script_Extensions=gunjalagondi}', "");
    Expect(1, 73129, '\p{Script_Extensions=:\Agunjalagondi\z:}', "");;
    Expect(0, 73130, '\p{Script_Extensions=:\Agunjalagondi\z:}', "");;
    Expect(1, 73129, '\p{Script_Extensions=	Gunjala_Gondi}', "");
    Expect(0, 73129, '\p{^Script_Extensions=	Gunjala_Gondi}', "");
    Expect(0, 73129, '\P{Script_Extensions=	Gunjala_Gondi}', "");
    Expect(1, 73129, '\P{^Script_Extensions=	Gunjala_Gondi}', "");
    Expect(0, 73130, '\p{Script_Extensions=	Gunjala_Gondi}', "");
    Expect(1, 73130, '\p{^Script_Extensions=	Gunjala_Gondi}', "");
    Expect(1, 73130, '\P{Script_Extensions=	Gunjala_Gondi}', "");
    Expect(0, 73130, '\P{^Script_Extensions=	Gunjala_Gondi}', "");
    Error('\p{Scx=_ GONG:=}');
    Error('\P{Scx=_ GONG:=}');
    Expect(1, 73129, '\p{Scx=:\AGong\z:}', "");;
    Expect(0, 73130, '\p{Scx=:\AGong\z:}', "");;
    Expect(1, 73129, '\p{Scx=gong}', "");
    Expect(0, 73129, '\p{^Scx=gong}', "");
    Expect(0, 73129, '\P{Scx=gong}', "");
    Expect(1, 73129, '\P{^Scx=gong}', "");
    Expect(0, 73130, '\p{Scx=gong}', "");
    Expect(1, 73130, '\p{^Scx=gong}', "");
    Expect(1, 73130, '\P{Scx=gong}', "");
    Expect(0, 73130, '\P{^Scx=gong}', "");
    Expect(1, 73129, '\p{Scx=:\Agong\z:}', "");;
    Expect(0, 73130, '\p{Scx=:\Agong\z:}', "");;
    Expect(1, 73129, '\p{Scx=-Gong}', "");
    Expect(0, 73129, '\p{^Scx=-Gong}', "");
    Expect(0, 73129, '\P{Scx=-Gong}', "");
    Expect(1, 73129, '\P{^Scx=-Gong}', "");
    Expect(0, 73130, '\p{Scx=-Gong}', "");
    Expect(1, 73130, '\p{^Scx=-Gong}', "");
    Expect(1, 73130, '\P{Scx=-Gong}', "");
    Expect(0, 73130, '\P{^Scx=-Gong}', "");
    Error('\p{Is_Script_Extensions=	/a/GUNJALA_GONDI}');
    Error('\P{Is_Script_Extensions=	/a/GUNJALA_GONDI}');
    Expect(1, 73129, '\p{Is_Script_Extensions=gunjalagondi}', "");
    Expect(0, 73129, '\p{^Is_Script_Extensions=gunjalagondi}', "");
    Expect(0, 73129, '\P{Is_Script_Extensions=gunjalagondi}', "");
    Expect(1, 73129, '\P{^Is_Script_Extensions=gunjalagondi}', "");
    Expect(0, 73130, '\p{Is_Script_Extensions=gunjalagondi}', "");
    Expect(1, 73130, '\p{^Is_Script_Extensions=gunjalagondi}', "");
    Expect(1, 73130, '\P{Is_Script_Extensions=gunjalagondi}', "");
    Expect(0, 73130, '\P{^Is_Script_Extensions=gunjalagondi}', "");
    Expect(1, 73129, '\p{Is_Script_Extensions= -GUNJALA_gondi}', "");
    Expect(0, 73129, '\p{^Is_Script_Extensions= -GUNJALA_gondi}', "");
    Expect(0, 73129, '\P{Is_Script_Extensions= -GUNJALA_gondi}', "");
    Expect(1, 73129, '\P{^Is_Script_Extensions= -GUNJALA_gondi}', "");
    Expect(0, 73130, '\p{Is_Script_Extensions= -GUNJALA_gondi}', "");
    Expect(1, 73130, '\p{^Is_Script_Extensions= -GUNJALA_gondi}', "");
    Expect(1, 73130, '\P{Is_Script_Extensions= -GUNJALA_gondi}', "");
    Expect(0, 73130, '\P{^Is_Script_Extensions= -GUNJALA_gondi}', "");
    Error('\p{Is_Scx:   :=_ gong}');
    Error('\P{Is_Scx:   :=_ gong}');
    Expect(1, 73129, '\p{Is_Scx=gong}', "");
    Expect(0, 73129, '\p{^Is_Scx=gong}', "");
    Expect(0, 73129, '\P{Is_Scx=gong}', "");
    Expect(1, 73129, '\P{^Is_Scx=gong}', "");
    Expect(0, 73130, '\p{Is_Scx=gong}', "");
    Expect(1, 73130, '\p{^Is_Scx=gong}', "");
    Expect(1, 73130, '\P{Is_Scx=gong}', "");
    Expect(0, 73130, '\P{^Is_Scx=gong}', "");
    Expect(1, 73129, '\p{Is_Scx=	GONG}', "");
    Expect(0, 73129, '\p{^Is_Scx=	GONG}', "");
    Expect(0, 73129, '\P{Is_Scx=	GONG}', "");
    Expect(1, 73129, '\P{^Is_Scx=	GONG}', "");
    Expect(0, 73130, '\p{Is_Scx=	GONG}', "");
    Expect(1, 73130, '\p{^Is_Scx=	GONG}', "");
    Expect(1, 73130, '\P{Is_Scx=	GONG}', "");
    Expect(0, 73130, '\P{^Is_Scx=	GONG}', "");
    Error('\p{Script_Extensions=_/a/Masaram_GONDI}');
    Error('\P{Script_Extensions=_/a/Masaram_GONDI}');
    Expect(1, 73049, '\p{Script_Extensions=:\AMasaram_Gondi\z:}', "");;
    Expect(0, 73050, '\p{Script_Extensions=:\AMasaram_Gondi\z:}', "");;
    Expect(1, 73049, '\p{Script_Extensions=masaramgondi}', "");
    Expect(0, 73049, '\p{^Script_Extensions=masaramgondi}', "");
    Expect(0, 73049, '\P{Script_Extensions=masaramgondi}', "");
    Expect(1, 73049, '\P{^Script_Extensions=masaramgondi}', "");
    Expect(0, 73050, '\p{Script_Extensions=masaramgondi}', "");
    Expect(1, 73050, '\p{^Script_Extensions=masaramgondi}', "");
    Expect(1, 73050, '\P{Script_Extensions=masaramgondi}', "");
    Expect(0, 73050, '\P{^Script_Extensions=masaramgondi}', "");
    Expect(1, 73049, '\p{Script_Extensions=:\Amasaramgondi\z:}', "");;
    Expect(0, 73050, '\p{Script_Extensions=:\Amasaramgondi\z:}', "");;
    Expect(1, 73049, '\p{Script_Extensions=-	MASARAM_gondi}', "");
    Expect(0, 73049, '\p{^Script_Extensions=-	MASARAM_gondi}', "");
    Expect(0, 73049, '\P{Script_Extensions=-	MASARAM_gondi}', "");
    Expect(1, 73049, '\P{^Script_Extensions=-	MASARAM_gondi}', "");
    Expect(0, 73050, '\p{Script_Extensions=-	MASARAM_gondi}', "");
    Expect(1, 73050, '\p{^Script_Extensions=-	MASARAM_gondi}', "");
    Expect(1, 73050, '\P{Script_Extensions=-	MASARAM_gondi}', "");
    Expect(0, 73050, '\P{^Script_Extensions=-	MASARAM_gondi}', "");
    Error('\p{Scx= 	gonm/a/}');
    Error('\P{Scx= 	gonm/a/}');
    Expect(1, 73049, '\p{Scx=:\AGonm\z:}', "");;
    Expect(0, 73050, '\p{Scx=:\AGonm\z:}', "");;
    Expect(1, 73049, '\p{Scx=gonm}', "");
    Expect(0, 73049, '\p{^Scx=gonm}', "");
    Expect(0, 73049, '\P{Scx=gonm}', "");
    Expect(1, 73049, '\P{^Scx=gonm}', "");
    Expect(0, 73050, '\p{Scx=gonm}', "");
    Expect(1, 73050, '\p{^Scx=gonm}', "");
    Expect(1, 73050, '\P{Scx=gonm}', "");
    Expect(0, 73050, '\P{^Scx=gonm}', "");
    Expect(1, 73049, '\p{Scx=:\Agonm\z:}', "");;
    Expect(0, 73050, '\p{Scx=:\Agonm\z:}', "");;
    Expect(1, 73049, '\p{Scx:   - GONM}', "");
    Expect(0, 73049, '\p{^Scx:   - GONM}', "");
    Expect(0, 73049, '\P{Scx:   - GONM}', "");
    Expect(1, 73049, '\P{^Scx:   - GONM}', "");
    Expect(0, 73050, '\p{Scx:   - GONM}', "");
    Expect(1, 73050, '\p{^Scx:   - GONM}', "");
    Expect(1, 73050, '\P{Scx:   - GONM}', "");
    Expect(0, 73050, '\P{^Scx:   - GONM}', "");
    Error('\p{Is_Script_Extensions= MASARAM_GONDI:=}');
    Error('\P{Is_Script_Extensions= MASARAM_GONDI:=}');
    Expect(1, 73049, '\p{Is_Script_Extensions=masaramgondi}', "");
    Expect(0, 73049, '\p{^Is_Script_Extensions=masaramgondi}', "");
    Expect(0, 73049, '\P{Is_Script_Extensions=masaramgondi}', "");
    Expect(1, 73049, '\P{^Is_Script_Extensions=masaramgondi}', "");
    Expect(0, 73050, '\p{Is_Script_Extensions=masaramgondi}', "");
    Expect(1, 73050, '\p{^Is_Script_Extensions=masaramgondi}', "");
    Expect(1, 73050, '\P{Is_Script_Extensions=masaramgondi}', "");
    Expect(0, 73050, '\P{^Is_Script_Extensions=masaramgondi}', "");
    Expect(1, 73049, '\p{Is_Script_Extensions=-_Masaram_Gondi}', "");
    Expect(0, 73049, '\p{^Is_Script_Extensions=-_Masaram_Gondi}', "");
    Expect(0, 73049, '\P{Is_Script_Extensions=-_Masaram_Gondi}', "");
    Expect(1, 73049, '\P{^Is_Script_Extensions=-_Masaram_Gondi}', "");
    Expect(0, 73050, '\p{Is_Script_Extensions=-_Masaram_Gondi}', "");
    Expect(1, 73050, '\p{^Is_Script_Extensions=-_Masaram_Gondi}', "");
    Expect(1, 73050, '\P{Is_Script_Extensions=-_Masaram_Gondi}', "");
    Expect(0, 73050, '\P{^Is_Script_Extensions=-_Masaram_Gondi}', "");
    Error('\p{Is_Scx=:=-	gonm}');
    Error('\P{Is_Scx=:=-	gonm}');
    Expect(1, 73049, '\p{Is_Scx=gonm}', "");
    Expect(0, 73049, '\p{^Is_Scx=gonm}', "");
    Expect(0, 73049, '\P{Is_Scx=gonm}', "");
    Expect(1, 73049, '\P{^Is_Scx=gonm}', "");
    Expect(0, 73050, '\p{Is_Scx=gonm}', "");
    Expect(1, 73050, '\p{^Is_Scx=gonm}', "");
    Expect(1, 73050, '\P{Is_Scx=gonm}', "");
    Expect(0, 73050, '\P{^Is_Scx=gonm}', "");
    Expect(1, 73049, '\p{Is_Scx=-_Gonm}', "");
    Expect(0, 73049, '\p{^Is_Scx=-_Gonm}', "");
    Expect(0, 73049, '\P{Is_Scx=-_Gonm}', "");
    Expect(1, 73049, '\P{^Is_Scx=-_Gonm}', "");
    Expect(0, 73050, '\p{Is_Scx=-_Gonm}', "");
    Expect(1, 73050, '\p{^Is_Scx=-_Gonm}', "");
    Expect(1, 73050, '\P{Is_Scx=-_Gonm}', "");
    Expect(0, 73050, '\P{^Is_Scx=-_Gonm}', "");
    Error('\p{Script_Extensions=/a/ gothic}');
    Error('\P{Script_Extensions=/a/ gothic}');
    Expect(1, 66378, '\p{Script_Extensions=:\AGothic\z:}', "");;
    Expect(0, 66379, '\p{Script_Extensions=:\AGothic\z:}', "");;
    Expect(1, 66378, '\p{Script_Extensions=gothic}', "");
    Expect(0, 66378, '\p{^Script_Extensions=gothic}', "");
    Expect(0, 66378, '\P{Script_Extensions=gothic}', "");
    Expect(1, 66378, '\P{^Script_Extensions=gothic}', "");
    Expect(0, 66379, '\p{Script_Extensions=gothic}', "");
    Expect(1, 66379, '\p{^Script_Extensions=gothic}', "");
    Expect(1, 66379, '\P{Script_Extensions=gothic}', "");
    Expect(0, 66379, '\P{^Script_Extensions=gothic}', "");
    Expect(1, 66378, '\p{Script_Extensions=:\Agothic\z:}', "");;
    Expect(0, 66379, '\p{Script_Extensions=:\Agothic\z:}', "");;
    Expect(1, 66378, '\p{Script_Extensions=-GOTHIC}', "");
    Expect(0, 66378, '\p{^Script_Extensions=-GOTHIC}', "");
    Expect(0, 66378, '\P{Script_Extensions=-GOTHIC}', "");
    Expect(1, 66378, '\P{^Script_Extensions=-GOTHIC}', "");
    Expect(0, 66379, '\p{Script_Extensions=-GOTHIC}', "");
    Expect(1, 66379, '\p{^Script_Extensions=-GOTHIC}', "");
    Expect(1, 66379, '\P{Script_Extensions=-GOTHIC}', "");
    Expect(0, 66379, '\P{^Script_Extensions=-GOTHIC}', "");
    Error('\p{Scx= /a/Goth}');
    Error('\P{Scx= /a/Goth}');
    Expect(1, 66378, '\p{Scx=:\AGoth\z:}', "");;
    Expect(0, 66379, '\p{Scx=:\AGoth\z:}', "");;
    Expect(1, 66378, '\p{Scx=goth}', "");
    Expect(0, 66378, '\p{^Scx=goth}', "");
    Expect(0, 66378, '\P{Scx=goth}', "");
    Expect(1, 66378, '\P{^Scx=goth}', "");
    Expect(0, 66379, '\p{Scx=goth}', "");
    Expect(1, 66379, '\p{^Scx=goth}', "");
    Expect(1, 66379, '\P{Scx=goth}', "");
    Expect(0, 66379, '\P{^Scx=goth}', "");
    Expect(1, 66378, '\p{Scx=:\Agoth\z:}', "");;
    Expect(0, 66379, '\p{Scx=:\Agoth\z:}', "");;
    Expect(1, 66378, '\p{Scx=__GOTH}', "");
    Expect(0, 66378, '\p{^Scx=__GOTH}', "");
    Expect(0, 66378, '\P{Scx=__GOTH}', "");
    Expect(1, 66378, '\P{^Scx=__GOTH}', "");
    Expect(0, 66379, '\p{Scx=__GOTH}', "");
    Expect(1, 66379, '\p{^Scx=__GOTH}', "");
    Expect(1, 66379, '\P{Scx=__GOTH}', "");
    Expect(0, 66379, '\P{^Scx=__GOTH}', "");
    Error('\p{Is_Script_Extensions= /a/Gothic}');
    Error('\P{Is_Script_Extensions= /a/Gothic}');
    Expect(1, 66378, '\p{Is_Script_Extensions=gothic}', "");
    Expect(0, 66378, '\p{^Is_Script_Extensions=gothic}', "");
    Expect(0, 66378, '\P{Is_Script_Extensions=gothic}', "");
    Expect(1, 66378, '\P{^Is_Script_Extensions=gothic}', "");
    Expect(0, 66379, '\p{Is_Script_Extensions=gothic}', "");
    Expect(1, 66379, '\p{^Is_Script_Extensions=gothic}', "");
    Expect(1, 66379, '\P{Is_Script_Extensions=gothic}', "");
    Expect(0, 66379, '\P{^Is_Script_Extensions=gothic}', "");
    Expect(1, 66378, '\p{Is_Script_Extensions=__gothic}', "");
    Expect(0, 66378, '\p{^Is_Script_Extensions=__gothic}', "");
    Expect(0, 66378, '\P{Is_Script_Extensions=__gothic}', "");
    Expect(1, 66378, '\P{^Is_Script_Extensions=__gothic}', "");
    Expect(0, 66379, '\p{Is_Script_Extensions=__gothic}', "");
    Expect(1, 66379, '\p{^Is_Script_Extensions=__gothic}', "");
    Expect(1, 66379, '\P{Is_Script_Extensions=__gothic}', "");
    Expect(0, 66379, '\P{^Is_Script_Extensions=__gothic}', "");
    Error('\p{Is_Scx= :=Goth}');
    Error('\P{Is_Scx= :=Goth}');
    Expect(1, 66378, '\p{Is_Scx=goth}', "");
    Expect(0, 66378, '\p{^Is_Scx=goth}', "");
    Expect(0, 66378, '\P{Is_Scx=goth}', "");
    Expect(1, 66378, '\P{^Is_Scx=goth}', "");
    Expect(0, 66379, '\p{Is_Scx=goth}', "");
    Expect(1, 66379, '\p{^Is_Scx=goth}', "");
    Expect(1, 66379, '\P{Is_Scx=goth}', "");
    Expect(0, 66379, '\P{^Is_Scx=goth}', "");
    Expect(1, 66378, '\p{Is_Scx=  GOTH}', "");
    Expect(0, 66378, '\p{^Is_Scx=  GOTH}', "");
    Expect(0, 66378, '\P{Is_Scx=  GOTH}', "");
    Expect(1, 66378, '\P{^Is_Scx=  GOTH}', "");
    Expect(0, 66379, '\p{Is_Scx=  GOTH}', "");
    Expect(1, 66379, '\p{^Is_Scx=  GOTH}', "");
    Expect(1, 66379, '\P{Is_Scx=  GOTH}', "");
    Expect(0, 66379, '\P{^Is_Scx=  GOTH}', "");
    Error('\p{Script_Extensions=_/a/GRANTHA}');
    Error('\P{Script_Extensions=_/a/GRANTHA}');
    Expect(1, 73683, '\p{Script_Extensions=:\AGrantha\z:}', "");;
    Expect(0, 73684, '\p{Script_Extensions=:\AGrantha\z:}', "");;
    Expect(1, 73683, '\p{Script_Extensions=grantha}', "");
    Expect(0, 73683, '\p{^Script_Extensions=grantha}', "");
    Expect(0, 73683, '\P{Script_Extensions=grantha}', "");
    Expect(1, 73683, '\P{^Script_Extensions=grantha}', "");
    Expect(0, 73684, '\p{Script_Extensions=grantha}', "");
    Expect(1, 73684, '\p{^Script_Extensions=grantha}', "");
    Expect(1, 73684, '\P{Script_Extensions=grantha}', "");
    Expect(0, 73684, '\P{^Script_Extensions=grantha}', "");
    Expect(1, 73683, '\p{Script_Extensions=:\Agrantha\z:}', "");;
    Expect(0, 73684, '\p{Script_Extensions=:\Agrantha\z:}', "");;
    Expect(1, 73683, '\p{Script_Extensions=		grantha}', "");
    Expect(0, 73683, '\p{^Script_Extensions=		grantha}', "");
    Expect(0, 73683, '\P{Script_Extensions=		grantha}', "");
    Expect(1, 73683, '\P{^Script_Extensions=		grantha}', "");
    Expect(0, 73684, '\p{Script_Extensions=		grantha}', "");
    Expect(1, 73684, '\p{^Script_Extensions=		grantha}', "");
    Expect(1, 73684, '\P{Script_Extensions=		grantha}', "");
    Expect(0, 73684, '\P{^Script_Extensions=		grantha}', "");
    Error('\p{Scx=:=	GRAN}');
    Error('\P{Scx=:=	GRAN}');
    Expect(1, 73683, '\p{Scx=:\AGran\z:}', "");;
    Expect(0, 73684, '\p{Scx=:\AGran\z:}', "");;
    Expect(1, 73683, '\p{Scx=gran}', "");
    Expect(0, 73683, '\p{^Scx=gran}', "");
    Expect(0, 73683, '\P{Scx=gran}', "");
    Expect(1, 73683, '\P{^Scx=gran}', "");
    Expect(0, 73684, '\p{Scx=gran}', "");
    Expect(1, 73684, '\p{^Scx=gran}', "");
    Expect(1, 73684, '\P{Scx=gran}', "");
    Expect(0, 73684, '\P{^Scx=gran}', "");
    Expect(1, 73683, '\p{Scx=:\Agran\z:}', "");;
    Expect(0, 73684, '\p{Scx=:\Agran\z:}', "");;
    Expect(1, 73683, '\p{Scx=Gran}', "");
    Expect(0, 73683, '\p{^Scx=Gran}', "");
    Expect(0, 73683, '\P{Scx=Gran}', "");
    Expect(1, 73683, '\P{^Scx=Gran}', "");
    Expect(0, 73684, '\p{Scx=Gran}', "");
    Expect(1, 73684, '\p{^Scx=Gran}', "");
    Expect(1, 73684, '\P{Scx=Gran}', "");
    Expect(0, 73684, '\P{^Scx=Gran}', "");
    Error('\p{Is_Script_Extensions=	:=Grantha}');
    Error('\P{Is_Script_Extensions=	:=Grantha}');
    Expect(1, 73683, '\p{Is_Script_Extensions=grantha}', "");
    Expect(0, 73683, '\p{^Is_Script_Extensions=grantha}', "");
    Expect(0, 73683, '\P{Is_Script_Extensions=grantha}', "");
    Expect(1, 73683, '\P{^Is_Script_Extensions=grantha}', "");
    Expect(0, 73684, '\p{Is_Script_Extensions=grantha}', "");
    Expect(1, 73684, '\p{^Is_Script_Extensions=grantha}', "");
    Expect(1, 73684, '\P{Is_Script_Extensions=grantha}', "");
    Expect(0, 73684, '\P{^Is_Script_Extensions=grantha}', "");
    Expect(1, 73683, '\p{Is_Script_Extensions=- Grantha}', "");
    Expect(0, 73683, '\p{^Is_Script_Extensions=- Grantha}', "");
    Expect(0, 73683, '\P{Is_Script_Extensions=- Grantha}', "");
    Expect(1, 73683, '\P{^Is_Script_Extensions=- Grantha}', "");
    Expect(0, 73684, '\p{Is_Script_Extensions=- Grantha}', "");
    Expect(1, 73684, '\p{^Is_Script_Extensions=- Grantha}', "");
    Expect(1, 73684, '\P{Is_Script_Extensions=- Grantha}', "");
    Expect(0, 73684, '\P{^Is_Script_Extensions=- Grantha}', "");
    Error('\p{Is_Scx=-:=GRAN}');
    Error('\P{Is_Scx=-:=GRAN}');
    Expect(1, 73683, '\p{Is_Scx=gran}', "");
    Expect(0, 73683, '\p{^Is_Scx=gran}', "");
    Expect(0, 73683, '\P{Is_Scx=gran}', "");
    Expect(1, 73683, '\P{^Is_Scx=gran}', "");
    Expect(0, 73684, '\p{Is_Scx=gran}', "");
    Expect(1, 73684, '\p{^Is_Scx=gran}', "");
    Expect(1, 73684, '\P{Is_Scx=gran}', "");
    Expect(0, 73684, '\P{^Is_Scx=gran}', "");
    Expect(1, 73683, '\p{Is_Scx= gran}', "");
    Expect(0, 73683, '\p{^Is_Scx= gran}', "");
    Expect(0, 73683, '\P{Is_Scx= gran}', "");
    Expect(1, 73683, '\P{^Is_Scx= gran}', "");
    Expect(0, 73684, '\p{Is_Scx= gran}', "");
    Expect(1, 73684, '\p{^Is_Scx= gran}', "");
    Expect(1, 73684, '\P{Is_Scx= gran}', "");
    Expect(0, 73684, '\P{^Is_Scx= gran}', "");
    Error('\p{Script_Extensions: :=Greek}');
    Error('\P{Script_Extensions: :=Greek}');
    Expect(1, 119365, '\p{Script_Extensions=:\AGreek\z:}', "");;
    Expect(0, 119366, '\p{Script_Extensions=:\AGreek\z:}', "");;
    Expect(1, 119365, '\p{Script_Extensions=greek}', "");
    Expect(0, 119365, '\p{^Script_Extensions=greek}', "");
    Expect(0, 119365, '\P{Script_Extensions=greek}', "");
    Expect(1, 119365, '\P{^Script_Extensions=greek}', "");
    Expect(0, 119366, '\p{Script_Extensions=greek}', "");
    Expect(1, 119366, '\p{^Script_Extensions=greek}', "");
    Expect(1, 119366, '\P{Script_Extensions=greek}', "");
    Expect(0, 119366, '\P{^Script_Extensions=greek}', "");
    Expect(1, 119365, '\p{Script_Extensions=:\Agreek\z:}', "");;
    Expect(0, 119366, '\p{Script_Extensions=:\Agreek\z:}', "");;
    Expect(1, 119365, '\p{Script_Extensions=  Greek}', "");
    Expect(0, 119365, '\p{^Script_Extensions=  Greek}', "");
    Expect(0, 119365, '\P{Script_Extensions=  Greek}', "");
    Expect(1, 119365, '\P{^Script_Extensions=  Greek}', "");
    Expect(0, 119366, '\p{Script_Extensions=  Greek}', "");
    Expect(1, 119366, '\p{^Script_Extensions=  Greek}', "");
    Expect(1, 119366, '\P{Script_Extensions=  Greek}', "");
    Expect(0, 119366, '\P{^Script_Extensions=  Greek}', "");
    Error('\p{Scx= /a/GREK}');
    Error('\P{Scx= /a/GREK}');
    Expect(1, 119365, '\p{Scx=:\AGrek\z:}', "");;
    Expect(0, 119366, '\p{Scx=:\AGrek\z:}', "");;
    Expect(1, 119365, '\p{Scx=grek}', "");
    Expect(0, 119365, '\p{^Scx=grek}', "");
    Expect(0, 119365, '\P{Scx=grek}', "");
    Expect(1, 119365, '\P{^Scx=grek}', "");
    Expect(0, 119366, '\p{Scx=grek}', "");
    Expect(1, 119366, '\p{^Scx=grek}', "");
    Expect(1, 119366, '\P{Scx=grek}', "");
    Expect(0, 119366, '\P{^Scx=grek}', "");
    Expect(1, 119365, '\p{Scx=:\Agrek\z:}', "");;
    Expect(0, 119366, '\p{Scx=:\Agrek\z:}', "");;
    Expect(1, 119365, '\p{Scx=	 GREK}', "");
    Expect(0, 119365, '\p{^Scx=	 GREK}', "");
    Expect(0, 119365, '\P{Scx=	 GREK}', "");
    Expect(1, 119365, '\P{^Scx=	 GREK}', "");
    Expect(0, 119366, '\p{Scx=	 GREK}', "");
    Expect(1, 119366, '\p{^Scx=	 GREK}', "");
    Expect(1, 119366, '\P{Scx=	 GREK}', "");
    Expect(0, 119366, '\P{^Scx=	 GREK}', "");
    Error('\p{Is_Script_Extensions=-_Greek/a/}');
    Error('\P{Is_Script_Extensions=-_Greek/a/}');
    Expect(1, 119365, '\p{Is_Script_Extensions=greek}', "");
    Expect(0, 119365, '\p{^Is_Script_Extensions=greek}', "");
    Expect(0, 119365, '\P{Is_Script_Extensions=greek}', "");
    Expect(1, 119365, '\P{^Is_Script_Extensions=greek}', "");
    Expect(0, 119366, '\p{Is_Script_Extensions=greek}', "");
    Expect(1, 119366, '\p{^Is_Script_Extensions=greek}', "");
    Expect(1, 119366, '\P{Is_Script_Extensions=greek}', "");
    Expect(0, 119366, '\P{^Is_Script_Extensions=greek}', "");
    Expect(1, 119365, '\p{Is_Script_Extensions=-Greek}', "");
    Expect(0, 119365, '\p{^Is_Script_Extensions=-Greek}', "");
    Expect(0, 119365, '\P{Is_Script_Extensions=-Greek}', "");
    Expect(1, 119365, '\P{^Is_Script_Extensions=-Greek}', "");
    Expect(0, 119366, '\p{Is_Script_Extensions=-Greek}', "");
    Expect(1, 119366, '\p{^Is_Script_Extensions=-Greek}', "");
    Expect(1, 119366, '\P{Is_Script_Extensions=-Greek}', "");
    Expect(0, 119366, '\P{^Is_Script_Extensions=-Greek}', "");
    Error('\p{Is_Scx=/a/  Grek}');
    Error('\P{Is_Scx=/a/  Grek}');
    Expect(1, 119365, '\p{Is_Scx=grek}', "");
    Expect(0, 119365, '\p{^Is_Scx=grek}', "");
    Expect(0, 119365, '\P{Is_Scx=grek}', "");
    Expect(1, 119365, '\P{^Is_Scx=grek}', "");
    Expect(0, 119366, '\p{Is_Scx=grek}', "");
    Expect(1, 119366, '\p{^Is_Scx=grek}', "");
    Expect(1, 119366, '\P{Is_Scx=grek}', "");
    Expect(0, 119366, '\P{^Is_Scx=grek}', "");
    Expect(1, 119365, '\p{Is_Scx:    GREK}', "");
    Expect(0, 119365, '\p{^Is_Scx:    GREK}', "");
    Expect(0, 119365, '\P{Is_Scx:    GREK}', "");
    Expect(1, 119365, '\P{^Is_Scx:    GREK}', "");
    Expect(0, 119366, '\p{Is_Scx:    GREK}', "");
    Expect(1, 119366, '\p{^Is_Scx:    GREK}', "");
    Expect(1, 119366, '\P{Is_Scx:    GREK}', "");
    Expect(0, 119366, '\P{^Is_Scx:    GREK}', "");
    Error('\p{Script_Extensions=:=-_gujarati}');
    Error('\P{Script_Extensions=:=-_gujarati}');
    Expect(1, 43065, '\p{Script_Extensions=:\AGujarati\z:}', "");;
    Expect(0, 43066, '\p{Script_Extensions=:\AGujarati\z:}', "");;
    Expect(1, 43065, '\p{Script_Extensions=gujarati}', "");
    Expect(0, 43065, '\p{^Script_Extensions=gujarati}', "");
    Expect(0, 43065, '\P{Script_Extensions=gujarati}', "");
    Expect(1, 43065, '\P{^Script_Extensions=gujarati}', "");
    Expect(0, 43066, '\p{Script_Extensions=gujarati}', "");
    Expect(1, 43066, '\p{^Script_Extensions=gujarati}', "");
    Expect(1, 43066, '\P{Script_Extensions=gujarati}', "");
    Expect(0, 43066, '\P{^Script_Extensions=gujarati}', "");
    Expect(1, 43065, '\p{Script_Extensions=:\Agujarati\z:}', "");;
    Expect(0, 43066, '\p{Script_Extensions=:\Agujarati\z:}', "");;
    Expect(1, 43065, '\p{Script_Extensions=_	GUJARATI}', "");
    Expect(0, 43065, '\p{^Script_Extensions=_	GUJARATI}', "");
    Expect(0, 43065, '\P{Script_Extensions=_	GUJARATI}', "");
    Expect(1, 43065, '\P{^Script_Extensions=_	GUJARATI}', "");
    Expect(0, 43066, '\p{Script_Extensions=_	GUJARATI}', "");
    Expect(1, 43066, '\p{^Script_Extensions=_	GUJARATI}', "");
    Expect(1, 43066, '\P{Script_Extensions=_	GUJARATI}', "");
    Expect(0, 43066, '\P{^Script_Extensions=_	GUJARATI}', "");
    Error('\p{Scx=:=	GUJR}');
    Error('\P{Scx=:=	GUJR}');
    Expect(1, 43065, '\p{Scx=:\AGujr\z:}', "");;
    Expect(0, 43066, '\p{Scx=:\AGujr\z:}', "");;
    Expect(1, 43065, '\p{Scx: gujr}', "");
    Expect(0, 43065, '\p{^Scx: gujr}', "");
    Expect(0, 43065, '\P{Scx: gujr}', "");
    Expect(1, 43065, '\P{^Scx: gujr}', "");
    Expect(0, 43066, '\p{Scx: gujr}', "");
    Expect(1, 43066, '\p{^Scx: gujr}', "");
    Expect(1, 43066, '\P{Scx: gujr}', "");
    Expect(0, 43066, '\P{^Scx: gujr}', "");
    Expect(1, 43065, '\p{Scx=:\Agujr\z:}', "");;
    Expect(0, 43066, '\p{Scx=:\Agujr\z:}', "");;
    Expect(1, 43065, '\p{Scx=- Gujr}', "");
    Expect(0, 43065, '\p{^Scx=- Gujr}', "");
    Expect(0, 43065, '\P{Scx=- Gujr}', "");
    Expect(1, 43065, '\P{^Scx=- Gujr}', "");
    Expect(0, 43066, '\p{Scx=- Gujr}', "");
    Expect(1, 43066, '\p{^Scx=- Gujr}', "");
    Expect(1, 43066, '\P{Scx=- Gujr}', "");
    Expect(0, 43066, '\P{^Scx=- Gujr}', "");
    Error('\p{Is_Script_Extensions=	Gujarati:=}');
    Error('\P{Is_Script_Extensions=	Gujarati:=}');
    Expect(1, 43065, '\p{Is_Script_Extensions=gujarati}', "");
    Expect(0, 43065, '\p{^Is_Script_Extensions=gujarati}', "");
    Expect(0, 43065, '\P{Is_Script_Extensions=gujarati}', "");
    Expect(1, 43065, '\P{^Is_Script_Extensions=gujarati}', "");
    Expect(0, 43066, '\p{Is_Script_Extensions=gujarati}', "");
    Expect(1, 43066, '\p{^Is_Script_Extensions=gujarati}', "");
    Expect(1, 43066, '\P{Is_Script_Extensions=gujarati}', "");
    Expect(0, 43066, '\P{^Is_Script_Extensions=gujarati}', "");
    Expect(1, 43065, '\p{Is_Script_Extensions:		GUJARATI}', "");
    Expect(0, 43065, '\p{^Is_Script_Extensions:		GUJARATI}', "");
    Expect(0, 43065, '\P{Is_Script_Extensions:		GUJARATI}', "");
    Expect(1, 43065, '\P{^Is_Script_Extensions:		GUJARATI}', "");
    Expect(0, 43066, '\p{Is_Script_Extensions:		GUJARATI}', "");
    Expect(1, 43066, '\p{^Is_Script_Extensions:		GUJARATI}', "");
    Expect(1, 43066, '\P{Is_Script_Extensions:		GUJARATI}', "");
    Expect(0, 43066, '\P{^Is_Script_Extensions:		GUJARATI}', "");
    Error('\p{Is_Scx=/a/--Gujr}');
    Error('\P{Is_Scx=/a/--Gujr}');
    Expect(1, 43065, '\p{Is_Scx=gujr}', "");
    Expect(0, 43065, '\p{^Is_Scx=gujr}', "");
    Expect(0, 43065, '\P{Is_Scx=gujr}', "");
    Expect(1, 43065, '\P{^Is_Scx=gujr}', "");
    Expect(0, 43066, '\p{Is_Scx=gujr}', "");
    Expect(1, 43066, '\p{^Is_Scx=gujr}', "");
    Expect(1, 43066, '\P{Is_Scx=gujr}', "");
    Expect(0, 43066, '\P{^Is_Scx=gujr}', "");
    Expect(1, 43065, '\p{Is_Scx=GUJR}', "");
    Expect(0, 43065, '\p{^Is_Scx=GUJR}', "");
    Expect(0, 43065, '\P{Is_Scx=GUJR}', "");
    Expect(1, 43065, '\P{^Is_Scx=GUJR}', "");
    Expect(0, 43066, '\p{Is_Scx=GUJR}', "");
    Expect(1, 43066, '\p{^Is_Scx=GUJR}', "");
    Expect(1, 43066, '\P{Is_Scx=GUJR}', "");
    Expect(0, 43066, '\P{^Is_Scx=GUJR}', "");
    Error('\p{Script_Extensions=/a/_ GURMUKHI}');
    Error('\P{Script_Extensions=/a/_ GURMUKHI}');
    Expect(1, 43065, '\p{Script_Extensions=:\AGurmukhi\z:}', "");;
    Expect(0, 43066, '\p{Script_Extensions=:\AGurmukhi\z:}', "");;
    Expect(1, 43065, '\p{Script_Extensions:	gurmukhi}', "");
    Expect(0, 43065, '\p{^Script_Extensions:	gurmukhi}', "");
    Expect(0, 43065, '\P{Script_Extensions:	gurmukhi}', "");
    Expect(1, 43065, '\P{^Script_Extensions:	gurmukhi}', "");
    Expect(0, 43066, '\p{Script_Extensions:	gurmukhi}', "");
    Expect(1, 43066, '\p{^Script_Extensions:	gurmukhi}', "");
    Expect(1, 43066, '\P{Script_Extensions:	gurmukhi}', "");
    Expect(0, 43066, '\P{^Script_Extensions:	gurmukhi}', "");
    Expect(1, 43065, '\p{Script_Extensions=:\Agurmukhi\z:}', "");;
    Expect(0, 43066, '\p{Script_Extensions=:\Agurmukhi\z:}', "");;
    Expect(1, 43065, '\p{Script_Extensions=_Gurmukhi}', "");
    Expect(0, 43065, '\p{^Script_Extensions=_Gurmukhi}', "");
    Expect(0, 43065, '\P{Script_Extensions=_Gurmukhi}', "");
    Expect(1, 43065, '\P{^Script_Extensions=_Gurmukhi}', "");
    Expect(0, 43066, '\p{Script_Extensions=_Gurmukhi}', "");
    Expect(1, 43066, '\p{^Script_Extensions=_Gurmukhi}', "");
    Expect(1, 43066, '\P{Script_Extensions=_Gurmukhi}', "");
    Expect(0, 43066, '\P{^Script_Extensions=_Gurmukhi}', "");
    Error('\p{Scx=-	Guru:=}');
    Error('\P{Scx=-	Guru:=}');
    Expect(1, 43065, '\p{Scx=:\AGuru\z:}', "");;
    Expect(0, 43066, '\p{Scx=:\AGuru\z:}', "");;
    Expect(1, 43065, '\p{Scx:   guru}', "");
    Expect(0, 43065, '\p{^Scx:   guru}', "");
    Expect(0, 43065, '\P{Scx:   guru}', "");
    Expect(1, 43065, '\P{^Scx:   guru}', "");
    Expect(0, 43066, '\p{Scx:   guru}', "");
    Expect(1, 43066, '\p{^Scx:   guru}', "");
    Expect(1, 43066, '\P{Scx:   guru}', "");
    Expect(0, 43066, '\P{^Scx:   guru}', "");
    Expect(1, 43065, '\p{Scx=:\Aguru\z:}', "");;
    Expect(0, 43066, '\p{Scx=:\Aguru\z:}', "");;
    Expect(1, 43065, '\p{Scx=	_GURU}', "");
    Expect(0, 43065, '\p{^Scx=	_GURU}', "");
    Expect(0, 43065, '\P{Scx=	_GURU}', "");
    Expect(1, 43065, '\P{^Scx=	_GURU}', "");
    Expect(0, 43066, '\p{Scx=	_GURU}', "");
    Expect(1, 43066, '\p{^Scx=	_GURU}', "");
    Expect(1, 43066, '\P{Scx=	_GURU}', "");
    Expect(0, 43066, '\P{^Scx=	_GURU}', "");
    Error('\p{Is_Script_Extensions=:=_-Gurmukhi}');
    Error('\P{Is_Script_Extensions=:=_-Gurmukhi}');
    Expect(1, 43065, '\p{Is_Script_Extensions=gurmukhi}', "");
    Expect(0, 43065, '\p{^Is_Script_Extensions=gurmukhi}', "");
    Expect(0, 43065, '\P{Is_Script_Extensions=gurmukhi}', "");
    Expect(1, 43065, '\P{^Is_Script_Extensions=gurmukhi}', "");
    Expect(0, 43066, '\p{Is_Script_Extensions=gurmukhi}', "");
    Expect(1, 43066, '\p{^Is_Script_Extensions=gurmukhi}', "");
    Expect(1, 43066, '\P{Is_Script_Extensions=gurmukhi}', "");
    Expect(0, 43066, '\P{^Is_Script_Extensions=gurmukhi}', "");
    Expect(1, 43065, '\p{Is_Script_Extensions=- Gurmukhi}', "");
    Expect(0, 43065, '\p{^Is_Script_Extensions=- Gurmukhi}', "");
    Expect(0, 43065, '\P{Is_Script_Extensions=- Gurmukhi}', "");
    Expect(1, 43065, '\P{^Is_Script_Extensions=- Gurmukhi}', "");
    Expect(0, 43066, '\p{Is_Script_Extensions=- Gurmukhi}', "");
    Expect(1, 43066, '\p{^Is_Script_Extensions=- Gurmukhi}', "");
    Expect(1, 43066, '\P{Is_Script_Extensions=- Gurmukhi}', "");
    Expect(0, 43066, '\P{^Is_Script_Extensions=- Gurmukhi}', "");
    Error('\p{Is_Scx=:=-_guru}');
    Error('\P{Is_Scx=:=-_guru}');
    Expect(1, 43065, '\p{Is_Scx=guru}', "");
    Expect(0, 43065, '\p{^Is_Scx=guru}', "");
    Expect(0, 43065, '\P{Is_Scx=guru}', "");
    Expect(1, 43065, '\P{^Is_Scx=guru}', "");
    Expect(0, 43066, '\p{Is_Scx=guru}', "");
    Expect(1, 43066, '\p{^Is_Scx=guru}', "");
    Expect(1, 43066, '\P{Is_Scx=guru}', "");
    Expect(0, 43066, '\P{^Is_Scx=guru}', "");
    Expect(1, 43065, '\p{Is_Scx=-GURU}', "");
    Expect(0, 43065, '\p{^Is_Scx=-GURU}', "");
    Expect(0, 43065, '\P{Is_Scx=-GURU}', "");
    Expect(1, 43065, '\P{^Is_Scx=-GURU}', "");
    Expect(0, 43066, '\p{Is_Scx=-GURU}', "");
    Expect(1, 43066, '\p{^Is_Scx=-GURU}', "");
    Expect(1, 43066, '\P{Is_Scx=-GURU}', "");
    Expect(0, 43066, '\P{^Is_Scx=-GURU}', "");
    Error('\p{Script_Extensions=:=HANGUL}');
    Error('\P{Script_Extensions=:=HANGUL}');
    Expect(1, 65500, '\p{Script_Extensions=:\AHangul\z:}', "");;
    Expect(0, 65501, '\p{Script_Extensions=:\AHangul\z:}', "");;
    Expect(1, 65500, '\p{Script_Extensions:	hangul}', "");
    Expect(0, 65500, '\p{^Script_Extensions:	hangul}', "");
    Expect(0, 65500, '\P{Script_Extensions:	hangul}', "");
    Expect(1, 65500, '\P{^Script_Extensions:	hangul}', "");
    Expect(0, 65501, '\p{Script_Extensions:	hangul}', "");
    Expect(1, 65501, '\p{^Script_Extensions:	hangul}', "");
    Expect(1, 65501, '\P{Script_Extensions:	hangul}', "");
    Expect(0, 65501, '\P{^Script_Extensions:	hangul}', "");
    Expect(1, 65500, '\p{Script_Extensions=:\Ahangul\z:}', "");;
    Expect(0, 65501, '\p{Script_Extensions=:\Ahangul\z:}', "");;
    Expect(1, 65500, '\p{Script_Extensions=--hangul}', "");
    Expect(0, 65500, '\p{^Script_Extensions=--hangul}', "");
    Expect(0, 65500, '\P{Script_Extensions=--hangul}', "");
    Expect(1, 65500, '\P{^Script_Extensions=--hangul}', "");
    Expect(0, 65501, '\p{Script_Extensions=--hangul}', "");
    Expect(1, 65501, '\p{^Script_Extensions=--hangul}', "");
    Expect(1, 65501, '\P{Script_Extensions=--hangul}', "");
    Expect(0, 65501, '\P{^Script_Extensions=--hangul}', "");
    Error('\p{Scx= :=Hang}');
    Error('\P{Scx= :=Hang}');
    Expect(1, 65500, '\p{Scx=:\AHang\z:}', "");;
    Expect(0, 65501, '\p{Scx=:\AHang\z:}', "");;
    Expect(1, 65500, '\p{Scx=hang}', "");
    Expect(0, 65500, '\p{^Scx=hang}', "");
    Expect(0, 65500, '\P{Scx=hang}', "");
    Expect(1, 65500, '\P{^Scx=hang}', "");
    Expect(0, 65501, '\p{Scx=hang}', "");
    Expect(1, 65501, '\p{^Scx=hang}', "");
    Expect(1, 65501, '\P{Scx=hang}', "");
    Expect(0, 65501, '\P{^Scx=hang}', "");
    Expect(1, 65500, '\p{Scx=:\Ahang\z:}', "");;
    Expect(0, 65501, '\p{Scx=:\Ahang\z:}', "");;
    Expect(1, 65500, '\p{Scx=--Hang}', "");
    Expect(0, 65500, '\p{^Scx=--Hang}', "");
    Expect(0, 65500, '\P{Scx=--Hang}', "");
    Expect(1, 65500, '\P{^Scx=--Hang}', "");
    Expect(0, 65501, '\p{Scx=--Hang}', "");
    Expect(1, 65501, '\p{^Scx=--Hang}', "");
    Expect(1, 65501, '\P{Scx=--Hang}', "");
    Expect(0, 65501, '\P{^Scx=--Hang}', "");
    Error('\p{Is_Script_Extensions=-_Hangul/a/}');
    Error('\P{Is_Script_Extensions=-_Hangul/a/}');
    Expect(1, 65500, '\p{Is_Script_Extensions=hangul}', "");
    Expect(0, 65500, '\p{^Is_Script_Extensions=hangul}', "");
    Expect(0, 65500, '\P{Is_Script_Extensions=hangul}', "");
    Expect(1, 65500, '\P{^Is_Script_Extensions=hangul}', "");
    Expect(0, 65501, '\p{Is_Script_Extensions=hangul}', "");
    Expect(1, 65501, '\p{^Is_Script_Extensions=hangul}', "");
    Expect(1, 65501, '\P{Is_Script_Extensions=hangul}', "");
    Expect(0, 65501, '\P{^Is_Script_Extensions=hangul}', "");
    Expect(1, 65500, '\p{Is_Script_Extensions=_hangul}', "");
    Expect(0, 65500, '\p{^Is_Script_Extensions=_hangul}', "");
    Expect(0, 65500, '\P{Is_Script_Extensions=_hangul}', "");
    Expect(1, 65500, '\P{^Is_Script_Extensions=_hangul}', "");
    Expect(0, 65501, '\p{Is_Script_Extensions=_hangul}', "");
    Expect(1, 65501, '\p{^Is_Script_Extensions=_hangul}', "");
    Expect(1, 65501, '\P{Is_Script_Extensions=_hangul}', "");
    Expect(0, 65501, '\P{^Is_Script_Extensions=_hangul}', "");
    Error('\p{Is_Scx=:=_ hang}');
    Error('\P{Is_Scx=:=_ hang}');
    Expect(1, 65500, '\p{Is_Scx=hang}', "");
    Expect(0, 65500, '\p{^Is_Scx=hang}', "");
    Expect(0, 65500, '\P{Is_Scx=hang}', "");
    Expect(1, 65500, '\P{^Is_Scx=hang}', "");
    Expect(0, 65501, '\p{Is_Scx=hang}', "");
    Expect(1, 65501, '\p{^Is_Scx=hang}', "");
    Expect(1, 65501, '\P{Is_Scx=hang}', "");
    Expect(0, 65501, '\P{^Is_Scx=hang}', "");
    Expect(1, 65500, '\p{Is_Scx=_-Hang}', "");
    Expect(0, 65500, '\p{^Is_Scx=_-Hang}', "");
    Expect(0, 65500, '\P{Is_Scx=_-Hang}', "");
    Expect(1, 65500, '\P{^Is_Scx=_-Hang}', "");
    Expect(0, 65501, '\p{Is_Scx=_-Hang}', "");
    Expect(1, 65501, '\p{^Is_Scx=_-Hang}', "");
    Expect(1, 65501, '\P{Is_Scx=_-Hang}', "");
    Expect(0, 65501, '\P{^Is_Scx=_-Hang}', "");
    Error('\p{Script_Extensions=/a/ _Han}');
    Error('\P{Script_Extensions=/a/ _Han}');
    Expect(1, 205743, '\p{Script_Extensions=:\AHan\z:}', "");;
    Expect(0, 205744, '\p{Script_Extensions=:\AHan\z:}', "");;
    Expect(1, 205743, '\p{Script_Extensions:	han}', "");
    Expect(0, 205743, '\p{^Script_Extensions:	han}', "");
    Expect(0, 205743, '\P{Script_Extensions:	han}', "");
    Expect(1, 205743, '\P{^Script_Extensions:	han}', "");
    Expect(0, 205744, '\p{Script_Extensions:	han}', "");
    Expect(1, 205744, '\p{^Script_Extensions:	han}', "");
    Expect(1, 205744, '\P{Script_Extensions:	han}', "");
    Expect(0, 205744, '\P{^Script_Extensions:	han}', "");
    Expect(1, 205743, '\p{Script_Extensions=:\Ahan\z:}', "");;
    Expect(0, 205744, '\p{Script_Extensions=:\Ahan\z:}', "");;
    Expect(1, 205743, '\p{Script_Extensions=	Han}', "");
    Expect(0, 205743, '\p{^Script_Extensions=	Han}', "");
    Expect(0, 205743, '\P{Script_Extensions=	Han}', "");
    Expect(1, 205743, '\P{^Script_Extensions=	Han}', "");
    Expect(0, 205744, '\p{Script_Extensions=	Han}', "");
    Expect(1, 205744, '\p{^Script_Extensions=	Han}', "");
    Expect(1, 205744, '\P{Script_Extensions=	Han}', "");
    Expect(0, 205744, '\P{^Script_Extensions=	Han}', "");
    Error('\p{Scx=-	hani:=}');
    Error('\P{Scx=-	hani:=}');
    Expect(1, 205743, '\p{Scx=:\AHani\z:}', "");;
    Expect(0, 205744, '\p{Scx=:\AHani\z:}', "");;
    Expect(1, 205743, '\p{Scx=hani}', "");
    Expect(0, 205743, '\p{^Scx=hani}', "");
    Expect(0, 205743, '\P{Scx=hani}', "");
    Expect(1, 205743, '\P{^Scx=hani}', "");
    Expect(0, 205744, '\p{Scx=hani}', "");
    Expect(1, 205744, '\p{^Scx=hani}', "");
    Expect(1, 205744, '\P{Scx=hani}', "");
    Expect(0, 205744, '\P{^Scx=hani}', "");
    Expect(1, 205743, '\p{Scx=:\Ahani\z:}', "");;
    Expect(0, 205744, '\p{Scx=:\Ahani\z:}', "");;
    Expect(1, 205743, '\p{Scx= _Hani}', "");
    Expect(0, 205743, '\p{^Scx= _Hani}', "");
    Expect(0, 205743, '\P{Scx= _Hani}', "");
    Expect(1, 205743, '\P{^Scx= _Hani}', "");
    Expect(0, 205744, '\p{Scx= _Hani}', "");
    Expect(1, 205744, '\p{^Scx= _Hani}', "");
    Expect(1, 205744, '\P{Scx= _Hani}', "");
    Expect(0, 205744, '\P{^Scx= _Hani}', "");
    Error('\p{Is_Script_Extensions=-_Han/a/}');
    Error('\P{Is_Script_Extensions=-_Han/a/}');
    Expect(1, 205743, '\p{Is_Script_Extensions=han}', "");
    Expect(0, 205743, '\p{^Is_Script_Extensions=han}', "");
    Expect(0, 205743, '\P{Is_Script_Extensions=han}', "");
    Expect(1, 205743, '\P{^Is_Script_Extensions=han}', "");
    Expect(0, 205744, '\p{Is_Script_Extensions=han}', "");
    Expect(1, 205744, '\p{^Is_Script_Extensions=han}', "");
    Expect(1, 205744, '\P{Is_Script_Extensions=han}', "");
    Expect(0, 205744, '\P{^Is_Script_Extensions=han}', "");
    Expect(1, 205743, '\p{Is_Script_Extensions:__Han}', "");
    Expect(0, 205743, '\p{^Is_Script_Extensions:__Han}', "");
    Expect(0, 205743, '\P{Is_Script_Extensions:__Han}', "");
    Expect(1, 205743, '\P{^Is_Script_Extensions:__Han}', "");
    Expect(0, 205744, '\p{Is_Script_Extensions:__Han}', "");
    Expect(1, 205744, '\p{^Is_Script_Extensions:__Han}', "");
    Expect(1, 205744, '\P{Is_Script_Extensions:__Han}', "");
    Expect(0, 205744, '\P{^Is_Script_Extensions:__Han}', "");
    Error('\p{Is_Scx=:= hani}');
    Error('\P{Is_Scx=:= hani}');
    Expect(1, 205743, '\p{Is_Scx=hani}', "");
    Expect(0, 205743, '\p{^Is_Scx=hani}', "");
    Expect(0, 205743, '\P{Is_Scx=hani}', "");
    Expect(1, 205743, '\P{^Is_Scx=hani}', "");
    Expect(0, 205744, '\p{Is_Scx=hani}', "");
    Expect(1, 205744, '\p{^Is_Scx=hani}', "");
    Expect(1, 205744, '\P{Is_Scx=hani}', "");
    Expect(0, 205744, '\P{^Is_Scx=hani}', "");
    Expect(1, 205743, '\p{Is_Scx=_hani}', "");
    Expect(0, 205743, '\p{^Is_Scx=_hani}', "");
    Expect(0, 205743, '\P{Is_Scx=_hani}', "");
    Expect(1, 205743, '\P{^Is_Scx=_hani}', "");
    Expect(0, 205744, '\p{Is_Scx=_hani}', "");
    Expect(1, 205744, '\p{^Is_Scx=_hani}', "");
    Expect(1, 205744, '\P{Is_Scx=_hani}', "");
    Expect(0, 205744, '\P{^Is_Scx=_hani}', "");
    Error('\p{Script_Extensions=-/a/Hanunoo}');
    Error('\P{Script_Extensions=-/a/Hanunoo}');
    Expect(1, 5942, '\p{Script_Extensions=:\AHanunoo\z:}', "");;
    Expect(0, 5943, '\p{Script_Extensions=:\AHanunoo\z:}', "");;
    Expect(1, 5942, '\p{Script_Extensions=hanunoo}', "");
    Expect(0, 5942, '\p{^Script_Extensions=hanunoo}', "");
    Expect(0, 5942, '\P{Script_Extensions=hanunoo}', "");
    Expect(1, 5942, '\P{^Script_Extensions=hanunoo}', "");
    Expect(0, 5943, '\p{Script_Extensions=hanunoo}', "");
    Expect(1, 5943, '\p{^Script_Extensions=hanunoo}', "");
    Expect(1, 5943, '\P{Script_Extensions=hanunoo}', "");
    Expect(0, 5943, '\P{^Script_Extensions=hanunoo}', "");
    Expect(1, 5942, '\p{Script_Extensions=:\Ahanunoo\z:}', "");;
    Expect(0, 5943, '\p{Script_Extensions=:\Ahanunoo\z:}', "");;
    Expect(1, 5942, '\p{Script_Extensions=	HANUNOO}', "");
    Expect(0, 5942, '\p{^Script_Extensions=	HANUNOO}', "");
    Expect(0, 5942, '\P{Script_Extensions=	HANUNOO}', "");
    Expect(1, 5942, '\P{^Script_Extensions=	HANUNOO}', "");
    Expect(0, 5943, '\p{Script_Extensions=	HANUNOO}', "");
    Expect(1, 5943, '\p{^Script_Extensions=	HANUNOO}', "");
    Expect(1, 5943, '\P{Script_Extensions=	HANUNOO}', "");
    Expect(0, 5943, '\P{^Script_Extensions=	HANUNOO}', "");
    Error('\p{Scx=hano/a/}');
    Error('\P{Scx=hano/a/}');
    Expect(1, 5942, '\p{Scx=:\AHano\z:}', "");;
    Expect(0, 5943, '\p{Scx=:\AHano\z:}', "");;
    Expect(1, 5942, '\p{Scx=hano}', "");
    Expect(0, 5942, '\p{^Scx=hano}', "");
    Expect(0, 5942, '\P{Scx=hano}', "");
    Expect(1, 5942, '\P{^Scx=hano}', "");
    Expect(0, 5943, '\p{Scx=hano}', "");
    Expect(1, 5943, '\p{^Scx=hano}', "");
    Expect(1, 5943, '\P{Scx=hano}', "");
    Expect(0, 5943, '\P{^Scx=hano}', "");
    Expect(1, 5942, '\p{Scx=:\Ahano\z:}', "");;
    Expect(0, 5943, '\p{Scx=:\Ahano\z:}', "");;
    Expect(1, 5942, '\p{Scx=-	Hano}', "");
    Expect(0, 5942, '\p{^Scx=-	Hano}', "");
    Expect(0, 5942, '\P{Scx=-	Hano}', "");
    Expect(1, 5942, '\P{^Scx=-	Hano}', "");
    Expect(0, 5943, '\p{Scx=-	Hano}', "");
    Expect(1, 5943, '\p{^Scx=-	Hano}', "");
    Expect(1, 5943, '\P{Scx=-	Hano}', "");
    Expect(0, 5943, '\P{^Scx=-	Hano}', "");
    Error('\p{Is_Script_Extensions=-Hanunoo:=}');
    Error('\P{Is_Script_Extensions=-Hanunoo:=}');
    Expect(1, 5942, '\p{Is_Script_Extensions=hanunoo}', "");
    Expect(0, 5942, '\p{^Is_Script_Extensions=hanunoo}', "");
    Expect(0, 5942, '\P{Is_Script_Extensions=hanunoo}', "");
    Expect(1, 5942, '\P{^Is_Script_Extensions=hanunoo}', "");
    Expect(0, 5943, '\p{Is_Script_Extensions=hanunoo}', "");
    Expect(1, 5943, '\p{^Is_Script_Extensions=hanunoo}', "");
    Expect(1, 5943, '\P{Is_Script_Extensions=hanunoo}', "");
    Expect(0, 5943, '\P{^Is_Script_Extensions=hanunoo}', "");
    Expect(1, 5942, '\p{Is_Script_Extensions=  HANUNOO}', "");
    Expect(0, 5942, '\p{^Is_Script_Extensions=  HANUNOO}', "");
    Expect(0, 5942, '\P{Is_Script_Extensions=  HANUNOO}', "");
    Expect(1, 5942, '\P{^Is_Script_Extensions=  HANUNOO}', "");
    Expect(0, 5943, '\p{Is_Script_Extensions=  HANUNOO}', "");
    Expect(1, 5943, '\p{^Is_Script_Extensions=  HANUNOO}', "");
    Expect(1, 5943, '\P{Is_Script_Extensions=  HANUNOO}', "");
    Expect(0, 5943, '\P{^Is_Script_Extensions=  HANUNOO}', "");
    Error('\p{Is_Scx=/a/- Hano}');
    Error('\P{Is_Scx=/a/- Hano}');
    Expect(1, 5942, '\p{Is_Scx=hano}', "");
    Expect(0, 5942, '\p{^Is_Scx=hano}', "");
    Expect(0, 5942, '\P{Is_Scx=hano}', "");
    Expect(1, 5942, '\P{^Is_Scx=hano}', "");
    Expect(0, 5943, '\p{Is_Scx=hano}', "");
    Expect(1, 5943, '\p{^Is_Scx=hano}', "");
    Expect(1, 5943, '\P{Is_Scx=hano}', "");
    Expect(0, 5943, '\P{^Is_Scx=hano}', "");
    Expect(1, 5942, '\p{Is_Scx=	HANO}', "");
    Expect(0, 5942, '\p{^Is_Scx=	HANO}', "");
    Expect(0, 5942, '\P{Is_Scx=	HANO}', "");
    Expect(1, 5942, '\P{^Is_Scx=	HANO}', "");
    Expect(0, 5943, '\p{Is_Scx=	HANO}', "");
    Expect(1, 5943, '\p{^Is_Scx=	HANO}', "");
    Expect(1, 5943, '\P{Is_Scx=	HANO}', "");
    Expect(0, 5943, '\P{^Is_Scx=	HANO}', "");
    Error('\p{Script_Extensions= :=hatran}');
    Error('\P{Script_Extensions= :=hatran}');
    Expect(1, 67839, '\p{Script_Extensions=:\AHatran\z:}', "");;
    Expect(0, 67840, '\p{Script_Extensions=:\AHatran\z:}', "");;
    Expect(1, 67839, '\p{Script_Extensions:	hatran}', "");
    Expect(0, 67839, '\p{^Script_Extensions:	hatran}', "");
    Expect(0, 67839, '\P{Script_Extensions:	hatran}', "");
    Expect(1, 67839, '\P{^Script_Extensions:	hatran}', "");
    Expect(0, 67840, '\p{Script_Extensions:	hatran}', "");
    Expect(1, 67840, '\p{^Script_Extensions:	hatran}', "");
    Expect(1, 67840, '\P{Script_Extensions:	hatran}', "");
    Expect(0, 67840, '\P{^Script_Extensions:	hatran}', "");
    Expect(1, 67839, '\p{Script_Extensions=:\Ahatran\z:}', "");;
    Expect(0, 67840, '\p{Script_Extensions=:\Ahatran\z:}', "");;
    Expect(1, 67839, '\p{Script_Extensions= -Hatran}', "");
    Expect(0, 67839, '\p{^Script_Extensions= -Hatran}', "");
    Expect(0, 67839, '\P{Script_Extensions= -Hatran}', "");
    Expect(1, 67839, '\P{^Script_Extensions= -Hatran}', "");
    Expect(0, 67840, '\p{Script_Extensions= -Hatran}', "");
    Expect(1, 67840, '\p{^Script_Extensions= -Hatran}', "");
    Expect(1, 67840, '\P{Script_Extensions= -Hatran}', "");
    Expect(0, 67840, '\P{^Script_Extensions= -Hatran}', "");
    Error('\p{Scx=:=_ Hatr}');
    Error('\P{Scx=:=_ Hatr}');
    Expect(1, 67839, '\p{Scx=:\AHatr\z:}', "");;
    Expect(0, 67840, '\p{Scx=:\AHatr\z:}', "");;
    Expect(1, 67839, '\p{Scx=hatr}', "");
    Expect(0, 67839, '\p{^Scx=hatr}', "");
    Expect(0, 67839, '\P{Scx=hatr}', "");
    Expect(1, 67839, '\P{^Scx=hatr}', "");
    Expect(0, 67840, '\p{Scx=hatr}', "");
    Expect(1, 67840, '\p{^Scx=hatr}', "");
    Expect(1, 67840, '\P{Scx=hatr}', "");
    Expect(0, 67840, '\P{^Scx=hatr}', "");
    Expect(1, 67839, '\p{Scx=:\Ahatr\z:}', "");;
    Expect(0, 67840, '\p{Scx=:\Ahatr\z:}', "");;
    Expect(1, 67839, '\p{Scx=_-Hatr}', "");
    Expect(0, 67839, '\p{^Scx=_-Hatr}', "");
    Expect(0, 67839, '\P{Scx=_-Hatr}', "");
    Expect(1, 67839, '\P{^Scx=_-Hatr}', "");
    Expect(0, 67840, '\p{Scx=_-Hatr}', "");
    Expect(1, 67840, '\p{^Scx=_-Hatr}', "");
    Expect(1, 67840, '\P{Scx=_-Hatr}', "");
    Expect(0, 67840, '\P{^Scx=_-Hatr}', "");
    Error('\p{Is_Script_Extensions=:=hatran}');
    Error('\P{Is_Script_Extensions=:=hatran}');
    Expect(1, 67839, '\p{Is_Script_Extensions=hatran}', "");
    Expect(0, 67839, '\p{^Is_Script_Extensions=hatran}', "");
    Expect(0, 67839, '\P{Is_Script_Extensions=hatran}', "");
    Expect(1, 67839, '\P{^Is_Script_Extensions=hatran}', "");
    Expect(0, 67840, '\p{Is_Script_Extensions=hatran}', "");
    Expect(1, 67840, '\p{^Is_Script_Extensions=hatran}', "");
    Expect(1, 67840, '\P{Is_Script_Extensions=hatran}', "");
    Expect(0, 67840, '\P{^Is_Script_Extensions=hatran}', "");
    Expect(1, 67839, '\p{Is_Script_Extensions: -hatran}', "");
    Expect(0, 67839, '\p{^Is_Script_Extensions: -hatran}', "");
    Expect(0, 67839, '\P{Is_Script_Extensions: -hatran}', "");
    Expect(1, 67839, '\P{^Is_Script_Extensions: -hatran}', "");
    Expect(0, 67840, '\p{Is_Script_Extensions: -hatran}', "");
    Expect(1, 67840, '\p{^Is_Script_Extensions: -hatran}', "");
    Expect(1, 67840, '\P{Is_Script_Extensions: -hatran}', "");
    Expect(0, 67840, '\P{^Is_Script_Extensions: -hatran}', "");
    Error('\p{Is_Scx=/a/__HATR}');
    Error('\P{Is_Scx=/a/__HATR}');
    Expect(1, 67839, '\p{Is_Scx=hatr}', "");
    Expect(0, 67839, '\p{^Is_Scx=hatr}', "");
    Expect(0, 67839, '\P{Is_Scx=hatr}', "");
    Expect(1, 67839, '\P{^Is_Scx=hatr}', "");
    Expect(0, 67840, '\p{Is_Scx=hatr}', "");
    Expect(1, 67840, '\p{^Is_Scx=hatr}', "");
    Expect(1, 67840, '\P{Is_Scx=hatr}', "");
    Expect(0, 67840, '\P{^Is_Scx=hatr}', "");
    Expect(1, 67839, '\p{Is_Scx=	HATR}', "");
    Expect(0, 67839, '\p{^Is_Scx=	HATR}', "");
    Expect(0, 67839, '\P{Is_Scx=	HATR}', "");
    Expect(1, 67839, '\P{^Is_Scx=	HATR}', "");
    Expect(0, 67840, '\p{Is_Scx=	HATR}', "");
    Expect(1, 67840, '\p{^Is_Scx=	HATR}', "");
    Expect(1, 67840, '\P{Is_Scx=	HATR}', "");
    Expect(0, 67840, '\P{^Is_Scx=	HATR}', "");
    Error('\p{Script_Extensions=_/a/Hebrew}');
    Error('\P{Script_Extensions=_/a/Hebrew}');
    Expect(1, 64335, '\p{Script_Extensions=:\AHebrew\z:}', "");;
    Expect(0, 64336, '\p{Script_Extensions=:\AHebrew\z:}', "");;
    Expect(1, 64335, '\p{Script_Extensions=hebrew}', "");
    Expect(0, 64335, '\p{^Script_Extensions=hebrew}', "");
    Expect(0, 64335, '\P{Script_Extensions=hebrew}', "");
    Expect(1, 64335, '\P{^Script_Extensions=hebrew}', "");
    Expect(0, 64336, '\p{Script_Extensions=hebrew}', "");
    Expect(1, 64336, '\p{^Script_Extensions=hebrew}', "");
    Expect(1, 64336, '\P{Script_Extensions=hebrew}', "");
    Expect(0, 64336, '\P{^Script_Extensions=hebrew}', "");
    Expect(1, 64335, '\p{Script_Extensions=:\Ahebrew\z:}', "");;
    Expect(0, 64336, '\p{Script_Extensions=:\Ahebrew\z:}', "");;
    Expect(1, 64335, '\p{Script_Extensions=		HEBREW}', "");
    Expect(0, 64335, '\p{^Script_Extensions=		HEBREW}', "");
    Expect(0, 64335, '\P{Script_Extensions=		HEBREW}', "");
    Expect(1, 64335, '\P{^Script_Extensions=		HEBREW}', "");
    Expect(0, 64336, '\p{Script_Extensions=		HEBREW}', "");
    Expect(1, 64336, '\p{^Script_Extensions=		HEBREW}', "");
    Expect(1, 64336, '\P{Script_Extensions=		HEBREW}', "");
    Expect(0, 64336, '\P{^Script_Extensions=		HEBREW}', "");
    Error('\p{Scx=_/a/Hebr}');
    Error('\P{Scx=_/a/Hebr}');
    Expect(1, 64335, '\p{Scx=:\AHebr\z:}', "");;
    Expect(0, 64336, '\p{Scx=:\AHebr\z:}', "");;
    Expect(1, 64335, '\p{Scx=hebr}', "");
    Expect(0, 64335, '\p{^Scx=hebr}', "");
    Expect(0, 64335, '\P{Scx=hebr}', "");
    Expect(1, 64335, '\P{^Scx=hebr}', "");
    Expect(0, 64336, '\p{Scx=hebr}', "");
    Expect(1, 64336, '\p{^Scx=hebr}', "");
    Expect(1, 64336, '\P{Scx=hebr}', "");
    Expect(0, 64336, '\P{^Scx=hebr}', "");
    Expect(1, 64335, '\p{Scx=:\Ahebr\z:}', "");;
    Expect(0, 64336, '\p{Scx=:\Ahebr\z:}', "");;
    Expect(1, 64335, '\p{Scx=__Hebr}', "");
    Expect(0, 64335, '\p{^Scx=__Hebr}', "");
    Expect(0, 64335, '\P{Scx=__Hebr}', "");
    Expect(1, 64335, '\P{^Scx=__Hebr}', "");
    Expect(0, 64336, '\p{Scx=__Hebr}', "");
    Expect(1, 64336, '\p{^Scx=__Hebr}', "");
    Expect(1, 64336, '\P{Scx=__Hebr}', "");
    Expect(0, 64336, '\P{^Scx=__Hebr}', "");
    Error('\p{Is_Script_Extensions=	Hebrew/a/}');
    Error('\P{Is_Script_Extensions=	Hebrew/a/}');
    Expect(1, 64335, '\p{Is_Script_Extensions=hebrew}', "");
    Expect(0, 64335, '\p{^Is_Script_Extensions=hebrew}', "");
    Expect(0, 64335, '\P{Is_Script_Extensions=hebrew}', "");
    Expect(1, 64335, '\P{^Is_Script_Extensions=hebrew}', "");
    Expect(0, 64336, '\p{Is_Script_Extensions=hebrew}', "");
    Expect(1, 64336, '\p{^Is_Script_Extensions=hebrew}', "");
    Expect(1, 64336, '\P{Is_Script_Extensions=hebrew}', "");
    Expect(0, 64336, '\P{^Is_Script_Extensions=hebrew}', "");
    Expect(1, 64335, '\p{Is_Script_Extensions=	_Hebrew}', "");
    Expect(0, 64335, '\p{^Is_Script_Extensions=	_Hebrew}', "");
    Expect(0, 64335, '\P{Is_Script_Extensions=	_Hebrew}', "");
    Expect(1, 64335, '\P{^Is_Script_Extensions=	_Hebrew}', "");
    Expect(0, 64336, '\p{Is_Script_Extensions=	_Hebrew}', "");
    Expect(1, 64336, '\p{^Is_Script_Extensions=	_Hebrew}', "");
    Expect(1, 64336, '\P{Is_Script_Extensions=	_Hebrew}', "");
    Expect(0, 64336, '\P{^Is_Script_Extensions=	_Hebrew}', "");
    Error('\p{Is_Scx=:=	Hebr}');
    Error('\P{Is_Scx=:=	Hebr}');
    Expect(1, 64335, '\p{Is_Scx=hebr}', "");
    Expect(0, 64335, '\p{^Is_Scx=hebr}', "");
    Expect(0, 64335, '\P{Is_Scx=hebr}', "");
    Expect(1, 64335, '\P{^Is_Scx=hebr}', "");
    Expect(0, 64336, '\p{Is_Scx=hebr}', "");
    Expect(1, 64336, '\p{^Is_Scx=hebr}', "");
    Expect(1, 64336, '\P{Is_Scx=hebr}', "");
    Expect(0, 64336, '\P{^Is_Scx=hebr}', "");
    Expect(1, 64335, '\p{Is_Scx= -Hebr}', "");
    Expect(0, 64335, '\p{^Is_Scx= -Hebr}', "");
    Expect(0, 64335, '\P{Is_Scx= -Hebr}', "");
    Expect(1, 64335, '\P{^Is_Scx= -Hebr}', "");
    Expect(0, 64336, '\p{Is_Scx= -Hebr}', "");
    Expect(1, 64336, '\p{^Is_Scx= -Hebr}', "");
    Expect(1, 64336, '\P{Is_Scx= -Hebr}', "");
    Expect(0, 64336, '\P{^Is_Scx= -Hebr}', "");
    Error('\p{Script_Extensions=/a/--HIRAGANA}');
    Error('\P{Script_Extensions=/a/--HIRAGANA}');
    Expect(1, 127488, '\p{Script_Extensions=:\AHiragana\z:}', "");;
    Expect(0, 127489, '\p{Script_Extensions=:\AHiragana\z:}', "");;
    Expect(1, 127488, '\p{Script_Extensions=hiragana}', "");
    Expect(0, 127488, '\p{^Script_Extensions=hiragana}', "");
    Expect(0, 127488, '\P{Script_Extensions=hiragana}', "");
    Expect(1, 127488, '\P{^Script_Extensions=hiragana}', "");
    Expect(0, 127489, '\p{Script_Extensions=hiragana}', "");
    Expect(1, 127489, '\p{^Script_Extensions=hiragana}', "");
    Expect(1, 127489, '\P{Script_Extensions=hiragana}', "");
    Expect(0, 127489, '\P{^Script_Extensions=hiragana}', "");
    Expect(1, 127488, '\p{Script_Extensions=:\Ahiragana\z:}', "");;
    Expect(0, 127489, '\p{Script_Extensions=:\Ahiragana\z:}', "");;
    Expect(1, 127488, '\p{Script_Extensions=-_hiragana}', "");
    Expect(0, 127488, '\p{^Script_Extensions=-_hiragana}', "");
    Expect(0, 127488, '\P{Script_Extensions=-_hiragana}', "");
    Expect(1, 127488, '\P{^Script_Extensions=-_hiragana}', "");
    Expect(0, 127489, '\p{Script_Extensions=-_hiragana}', "");
    Expect(1, 127489, '\p{^Script_Extensions=-_hiragana}', "");
    Expect(1, 127489, '\P{Script_Extensions=-_hiragana}', "");
    Expect(0, 127489, '\P{^Script_Extensions=-_hiragana}', "");
    Error('\p{Scx=/a/hira}');
    Error('\P{Scx=/a/hira}');
    Expect(1, 127488, '\p{Scx=:\AHira\z:}', "");;
    Expect(0, 127489, '\p{Scx=:\AHira\z:}', "");;
    Expect(1, 127488, '\p{Scx=hira}', "");
    Expect(0, 127488, '\p{^Scx=hira}', "");
    Expect(0, 127488, '\P{Scx=hira}', "");
    Expect(1, 127488, '\P{^Scx=hira}', "");
    Expect(0, 127489, '\p{Scx=hira}', "");
    Expect(1, 127489, '\p{^Scx=hira}', "");
    Expect(1, 127489, '\P{Scx=hira}', "");
    Expect(0, 127489, '\P{^Scx=hira}', "");
    Expect(1, 127488, '\p{Scx=:\Ahira\z:}', "");;
    Expect(0, 127489, '\p{Scx=:\Ahira\z:}', "");;
    Expect(1, 127488, '\p{Scx=_hira}', "");
    Expect(0, 127488, '\p{^Scx=_hira}', "");
    Expect(0, 127488, '\P{Scx=_hira}', "");
    Expect(1, 127488, '\P{^Scx=_hira}', "");
    Expect(0, 127489, '\p{Scx=_hira}', "");
    Expect(1, 127489, '\p{^Scx=_hira}', "");
    Expect(1, 127489, '\P{Scx=_hira}', "");
    Expect(0, 127489, '\P{^Scx=_hira}', "");
    Error('\p{Is_Script_Extensions=-:=hiragana}');
    Error('\P{Is_Script_Extensions=-:=hiragana}');
    Expect(1, 127488, '\p{Is_Script_Extensions:	hiragana}', "");
    Expect(0, 127488, '\p{^Is_Script_Extensions:	hiragana}', "");
    Expect(0, 127488, '\P{Is_Script_Extensions:	hiragana}', "");
    Expect(1, 127488, '\P{^Is_Script_Extensions:	hiragana}', "");
    Expect(0, 127489, '\p{Is_Script_Extensions:	hiragana}', "");
    Expect(1, 127489, '\p{^Is_Script_Extensions:	hiragana}', "");
    Expect(1, 127489, '\P{Is_Script_Extensions:	hiragana}', "");
    Expect(0, 127489, '\P{^Is_Script_Extensions:	hiragana}', "");
    Expect(1, 127488, '\p{Is_Script_Extensions=-_HIRAGANA}', "");
    Expect(0, 127488, '\p{^Is_Script_Extensions=-_HIRAGANA}', "");
    Expect(0, 127488, '\P{Is_Script_Extensions=-_HIRAGANA}', "");
    Expect(1, 127488, '\P{^Is_Script_Extensions=-_HIRAGANA}', "");
    Expect(0, 127489, '\p{Is_Script_Extensions=-_HIRAGANA}', "");
    Expect(1, 127489, '\p{^Is_Script_Extensions=-_HIRAGANA}', "");
    Expect(1, 127489, '\P{Is_Script_Extensions=-_HIRAGANA}', "");
    Expect(0, 127489, '\P{^Is_Script_Extensions=-_HIRAGANA}', "");
    Error('\p{Is_Scx=- hira/a/}');
    Error('\P{Is_Scx=- hira/a/}');
    Expect(1, 127488, '\p{Is_Scx:	hira}', "");
    Expect(0, 127488, '\p{^Is_Scx:	hira}', "");
    Expect(0, 127488, '\P{Is_Scx:	hira}', "");
    Expect(1, 127488, '\P{^Is_Scx:	hira}', "");
    Expect(0, 127489, '\p{Is_Scx:	hira}', "");
    Expect(1, 127489, '\p{^Is_Scx:	hira}', "");
    Expect(1, 127489, '\P{Is_Scx:	hira}', "");
    Expect(0, 127489, '\P{^Is_Scx:	hira}', "");
    Expect(1, 127488, '\p{Is_Scx:     Hira}', "");
    Expect(0, 127488, '\p{^Is_Scx:     Hira}', "");
    Expect(0, 127488, '\P{Is_Scx:     Hira}', "");
    Expect(1, 127488, '\P{^Is_Scx:     Hira}', "");
    Expect(0, 127489, '\p{Is_Scx:     Hira}', "");
    Expect(1, 127489, '\p{^Is_Scx:     Hira}', "");
    Expect(1, 127489, '\P{Is_Scx:     Hira}', "");
    Expect(0, 127489, '\P{^Is_Scx:     Hira}', "");
    Error('\p{Script_Extensions=:=-_Anatolian_Hieroglyphs}');
    Error('\P{Script_Extensions=:=-_Anatolian_Hieroglyphs}');
    Expect(1, 83526, '\p{Script_Extensions=:\AAnatolian_Hieroglyphs\z:}', "");;
    Expect(0, 83527, '\p{Script_Extensions=:\AAnatolian_Hieroglyphs\z:}', "");;
    Expect(1, 83526, '\p{Script_Extensions=anatolianhieroglyphs}', "");
    Expect(0, 83526, '\p{^Script_Extensions=anatolianhieroglyphs}', "");
    Expect(0, 83526, '\P{Script_Extensions=anatolianhieroglyphs}', "");
    Expect(1, 83526, '\P{^Script_Extensions=anatolianhieroglyphs}', "");
    Expect(0, 83527, '\p{Script_Extensions=anatolianhieroglyphs}', "");
    Expect(1, 83527, '\p{^Script_Extensions=anatolianhieroglyphs}', "");
    Expect(1, 83527, '\P{Script_Extensions=anatolianhieroglyphs}', "");
    Expect(0, 83527, '\P{^Script_Extensions=anatolianhieroglyphs}', "");
    Expect(1, 83526, '\p{Script_Extensions=:\Aanatolianhieroglyphs\z:}', "");;
    Expect(0, 83527, '\p{Script_Extensions=:\Aanatolianhieroglyphs\z:}', "");;
    Expect(1, 83526, '\p{Script_Extensions:   _-anatolian_hieroglyphs}', "");
    Expect(0, 83526, '\p{^Script_Extensions:   _-anatolian_hieroglyphs}', "");
    Expect(0, 83526, '\P{Script_Extensions:   _-anatolian_hieroglyphs}', "");
    Expect(1, 83526, '\P{^Script_Extensions:   _-anatolian_hieroglyphs}', "");
    Expect(0, 83527, '\p{Script_Extensions:   _-anatolian_hieroglyphs}', "");
    Expect(1, 83527, '\p{^Script_Extensions:   _-anatolian_hieroglyphs}', "");
    Expect(1, 83527, '\P{Script_Extensions:   _-anatolian_hieroglyphs}', "");
    Expect(0, 83527, '\P{^Script_Extensions:   _-anatolian_hieroglyphs}', "");
    Error('\p{Scx=_:=Hluw}');
    Error('\P{Scx=_:=Hluw}');
    Expect(1, 83526, '\p{Scx=:\AHluw\z:}', "");;
    Expect(0, 83527, '\p{Scx=:\AHluw\z:}', "");;
    Expect(1, 83526, '\p{Scx=hluw}', "");
    Expect(0, 83526, '\p{^Scx=hluw}', "");
    Expect(0, 83526, '\P{Scx=hluw}', "");
    Expect(1, 83526, '\P{^Scx=hluw}', "");
    Expect(0, 83527, '\p{Scx=hluw}', "");
    Expect(1, 83527, '\p{^Scx=hluw}', "");
    Expect(1, 83527, '\P{Scx=hluw}', "");
    Expect(0, 83527, '\P{^Scx=hluw}', "");
    Expect(1, 83526, '\p{Scx=:\Ahluw\z:}', "");;
    Expect(0, 83527, '\p{Scx=:\Ahluw\z:}', "");;
    Expect(1, 83526, '\p{Scx= Hluw}', "");
    Expect(0, 83526, '\p{^Scx= Hluw}', "");
    Expect(0, 83526, '\P{Scx= Hluw}', "");
    Expect(1, 83526, '\P{^Scx= Hluw}', "");
    Expect(0, 83527, '\p{Scx= Hluw}', "");
    Expect(1, 83527, '\p{^Scx= Hluw}', "");
    Expect(1, 83527, '\P{Scx= Hluw}', "");
    Expect(0, 83527, '\P{^Scx= Hluw}', "");
    Error('\p{Is_Script_Extensions= 	ANATOLIAN_hieroglyphs:=}');
    Error('\P{Is_Script_Extensions= 	ANATOLIAN_hieroglyphs:=}');
    Expect(1, 83526, '\p{Is_Script_Extensions=anatolianhieroglyphs}', "");
    Expect(0, 83526, '\p{^Is_Script_Extensions=anatolianhieroglyphs}', "");
    Expect(0, 83526, '\P{Is_Script_Extensions=anatolianhieroglyphs}', "");
    Expect(1, 83526, '\P{^Is_Script_Extensions=anatolianhieroglyphs}', "");
    Expect(0, 83527, '\p{Is_Script_Extensions=anatolianhieroglyphs}', "");
    Expect(1, 83527, '\p{^Is_Script_Extensions=anatolianhieroglyphs}', "");
    Expect(1, 83527, '\P{Is_Script_Extensions=anatolianhieroglyphs}', "");
    Expect(0, 83527, '\P{^Is_Script_Extensions=anatolianhieroglyphs}', "");
    Expect(1, 83526, '\p{Is_Script_Extensions=  anatolian_HIEROGLYPHS}', "");
    Expect(0, 83526, '\p{^Is_Script_Extensions=  anatolian_HIEROGLYPHS}', "");
    Expect(0, 83526, '\P{Is_Script_Extensions=  anatolian_HIEROGLYPHS}', "");
    Expect(1, 83526, '\P{^Is_Script_Extensions=  anatolian_HIEROGLYPHS}', "");
    Expect(0, 83527, '\p{Is_Script_Extensions=  anatolian_HIEROGLYPHS}', "");
    Expect(1, 83527, '\p{^Is_Script_Extensions=  anatolian_HIEROGLYPHS}', "");
    Expect(1, 83527, '\P{Is_Script_Extensions=  anatolian_HIEROGLYPHS}', "");
    Expect(0, 83527, '\P{^Is_Script_Extensions=  anatolian_HIEROGLYPHS}', "");
    Error('\p{Is_Scx=--hluw:=}');
    Error('\P{Is_Scx=--hluw:=}');
    Expect(1, 83526, '\p{Is_Scx:   hluw}', "");
    Expect(0, 83526, '\p{^Is_Scx:   hluw}', "");
    Expect(0, 83526, '\P{Is_Scx:   hluw}', "");
    Expect(1, 83526, '\P{^Is_Scx:   hluw}', "");
    Expect(0, 83527, '\p{Is_Scx:   hluw}', "");
    Expect(1, 83527, '\p{^Is_Scx:   hluw}', "");
    Expect(1, 83527, '\P{Is_Scx:   hluw}', "");
    Expect(0, 83527, '\P{^Is_Scx:   hluw}', "");
    Expect(1, 83526, '\p{Is_Scx=_-HLUW}', "");
    Expect(0, 83526, '\p{^Is_Scx=_-HLUW}', "");
    Expect(0, 83526, '\P{Is_Scx=_-HLUW}', "");
    Expect(1, 83526, '\P{^Is_Scx=_-HLUW}', "");
    Expect(0, 83527, '\p{Is_Scx=_-HLUW}', "");
    Expect(1, 83527, '\p{^Is_Scx=_-HLUW}', "");
    Expect(1, 83527, '\P{Is_Scx=_-HLUW}', "");
    Expect(0, 83527, '\P{^Is_Scx=_-HLUW}', "");
    Error('\p{Script_Extensions=-/a/Pahawh_Hmong}');
    Error('\P{Script_Extensions=-/a/Pahawh_Hmong}');
    Expect(1, 93071, '\p{Script_Extensions=:\APahawh_Hmong\z:}', "");;
    Expect(0, 93072, '\p{Script_Extensions=:\APahawh_Hmong\z:}', "");;
    Expect(1, 93071, '\p{Script_Extensions=pahawhhmong}', "");
    Expect(0, 93071, '\p{^Script_Extensions=pahawhhmong}', "");
    Expect(0, 93071, '\P{Script_Extensions=pahawhhmong}', "");
    Expect(1, 93071, '\P{^Script_Extensions=pahawhhmong}', "");
    Expect(0, 93072, '\p{Script_Extensions=pahawhhmong}', "");
    Expect(1, 93072, '\p{^Script_Extensions=pahawhhmong}', "");
    Expect(1, 93072, '\P{Script_Extensions=pahawhhmong}', "");
    Expect(0, 93072, '\P{^Script_Extensions=pahawhhmong}', "");
    Expect(1, 93071, '\p{Script_Extensions=:\Apahawhhmong\z:}', "");;
    Expect(0, 93072, '\p{Script_Extensions=:\Apahawhhmong\z:}', "");;
    Expect(1, 93071, '\p{Script_Extensions= 	Pahawh_HMONG}', "");
    Expect(0, 93071, '\p{^Script_Extensions= 	Pahawh_HMONG}', "");
    Expect(0, 93071, '\P{Script_Extensions= 	Pahawh_HMONG}', "");
    Expect(1, 93071, '\P{^Script_Extensions= 	Pahawh_HMONG}', "");
    Expect(0, 93072, '\p{Script_Extensions= 	Pahawh_HMONG}', "");
    Expect(1, 93072, '\p{^Script_Extensions= 	Pahawh_HMONG}', "");
    Expect(1, 93072, '\P{Script_Extensions= 	Pahawh_HMONG}', "");
    Expect(0, 93072, '\P{^Script_Extensions= 	Pahawh_HMONG}', "");
    Error('\p{Scx=	-Hmng:=}');
    Error('\P{Scx=	-Hmng:=}');
    Expect(1, 93071, '\p{Scx=:\AHmng\z:}', "");;
    Expect(0, 93072, '\p{Scx=:\AHmng\z:}', "");;
    Expect(1, 93071, '\p{Scx=hmng}', "");
    Expect(0, 93071, '\p{^Scx=hmng}', "");
    Expect(0, 93071, '\P{Scx=hmng}', "");
    Expect(1, 93071, '\P{^Scx=hmng}', "");
    Expect(0, 93072, '\p{Scx=hmng}', "");
    Expect(1, 93072, '\p{^Scx=hmng}', "");
    Expect(1, 93072, '\P{Scx=hmng}', "");
    Expect(0, 93072, '\P{^Scx=hmng}', "");
    Expect(1, 93071, '\p{Scx=:\Ahmng\z:}', "");;
    Expect(0, 93072, '\p{Scx=:\Ahmng\z:}', "");;
    Expect(1, 93071, '\p{Scx=-HMNG}', "");
    Expect(0, 93071, '\p{^Scx=-HMNG}', "");
    Expect(0, 93071, '\P{Scx=-HMNG}', "");
    Expect(1, 93071, '\P{^Scx=-HMNG}', "");
    Expect(0, 93072, '\p{Scx=-HMNG}', "");
    Expect(1, 93072, '\p{^Scx=-HMNG}', "");
    Expect(1, 93072, '\P{Scx=-HMNG}', "");
    Expect(0, 93072, '\P{^Scx=-HMNG}', "");
    Error('\p{Is_Script_Extensions=:=_-Pahawh_HMONG}');
    Error('\P{Is_Script_Extensions=:=_-Pahawh_HMONG}');
    Expect(1, 93071, '\p{Is_Script_Extensions=pahawhhmong}', "");
    Expect(0, 93071, '\p{^Is_Script_Extensions=pahawhhmong}', "");
    Expect(0, 93071, '\P{Is_Script_Extensions=pahawhhmong}', "");
    Expect(1, 93071, '\P{^Is_Script_Extensions=pahawhhmong}', "");
    Expect(0, 93072, '\p{Is_Script_Extensions=pahawhhmong}', "");
    Expect(1, 93072, '\p{^Is_Script_Extensions=pahawhhmong}', "");
    Expect(1, 93072, '\P{Is_Script_Extensions=pahawhhmong}', "");
    Expect(0, 93072, '\P{^Is_Script_Extensions=pahawhhmong}', "");
    Expect(1, 93071, '\p{Is_Script_Extensions=__PAHAWH_hmong}', "");
    Expect(0, 93071, '\p{^Is_Script_Extensions=__PAHAWH_hmong}', "");
    Expect(0, 93071, '\P{Is_Script_Extensions=__PAHAWH_hmong}', "");
    Expect(1, 93071, '\P{^Is_Script_Extensions=__PAHAWH_hmong}', "");
    Expect(0, 93072, '\p{Is_Script_Extensions=__PAHAWH_hmong}', "");
    Expect(1, 93072, '\p{^Is_Script_Extensions=__PAHAWH_hmong}', "");
    Expect(1, 93072, '\P{Is_Script_Extensions=__PAHAWH_hmong}', "");
    Expect(0, 93072, '\P{^Is_Script_Extensions=__PAHAWH_hmong}', "");
    Error('\p{Is_Scx= HMNG/a/}');
    Error('\P{Is_Scx= HMNG/a/}');
    Expect(1, 93071, '\p{Is_Scx=hmng}', "");
    Expect(0, 93071, '\p{^Is_Scx=hmng}', "");
    Expect(0, 93071, '\P{Is_Scx=hmng}', "");
    Expect(1, 93071, '\P{^Is_Scx=hmng}', "");
    Expect(0, 93072, '\p{Is_Scx=hmng}', "");
    Expect(1, 93072, '\p{^Is_Scx=hmng}', "");
    Expect(1, 93072, '\P{Is_Scx=hmng}', "");
    Expect(0, 93072, '\P{^Is_Scx=hmng}', "");
    Expect(1, 93071, '\p{Is_Scx=_Hmng}', "");
    Expect(0, 93071, '\p{^Is_Scx=_Hmng}', "");
    Expect(0, 93071, '\P{Is_Scx=_Hmng}', "");
    Expect(1, 93071, '\P{^Is_Scx=_Hmng}', "");
    Expect(0, 93072, '\p{Is_Scx=_Hmng}', "");
    Expect(1, 93072, '\p{^Is_Scx=_Hmng}', "");
    Expect(1, 93072, '\P{Is_Scx=_Hmng}', "");
    Expect(0, 93072, '\P{^Is_Scx=_Hmng}', "");
    Error('\p{Script_Extensions=/a/-_Nyiakeng_PUACHUE_Hmong}');
    Error('\P{Script_Extensions=/a/-_Nyiakeng_PUACHUE_Hmong}');
    Expect(1, 123215, '\p{Script_Extensions=:\ANyiakeng_Puachue_Hmong\z:}', "");;
    Expect(0, 123216, '\p{Script_Extensions=:\ANyiakeng_Puachue_Hmong\z:}', "");;
    Expect(1, 123215, '\p{Script_Extensions=nyiakengpuachuehmong}', "");
    Expect(0, 123215, '\p{^Script_Extensions=nyiakengpuachuehmong}', "");
    Expect(0, 123215, '\P{Script_Extensions=nyiakengpuachuehmong}', "");
    Expect(1, 123215, '\P{^Script_Extensions=nyiakengpuachuehmong}', "");
    Expect(0, 123216, '\p{Script_Extensions=nyiakengpuachuehmong}', "");
    Expect(1, 123216, '\p{^Script_Extensions=nyiakengpuachuehmong}', "");
    Expect(1, 123216, '\P{Script_Extensions=nyiakengpuachuehmong}', "");
    Expect(0, 123216, '\P{^Script_Extensions=nyiakengpuachuehmong}', "");
    Expect(1, 123215, '\p{Script_Extensions=:\Anyiakengpuachuehmong\z:}', "");;
    Expect(0, 123216, '\p{Script_Extensions=:\Anyiakengpuachuehmong\z:}', "");;
    Expect(1, 123215, '\p{Script_Extensions=	_NYIAKENG_Puachue_HMONG}', "");
    Expect(0, 123215, '\p{^Script_Extensions=	_NYIAKENG_Puachue_HMONG}', "");
    Expect(0, 123215, '\P{Script_Extensions=	_NYIAKENG_Puachue_HMONG}', "");
    Expect(1, 123215, '\P{^Script_Extensions=	_NYIAKENG_Puachue_HMONG}', "");
    Expect(0, 123216, '\p{Script_Extensions=	_NYIAKENG_Puachue_HMONG}', "");
    Expect(1, 123216, '\p{^Script_Extensions=	_NYIAKENG_Puachue_HMONG}', "");
    Expect(1, 123216, '\P{Script_Extensions=	_NYIAKENG_Puachue_HMONG}', "");
    Expect(0, 123216, '\P{^Script_Extensions=	_NYIAKENG_Puachue_HMONG}', "");
    Error('\p{Scx=_Hmnp/a/}');
    Error('\P{Scx=_Hmnp/a/}');
    Expect(1, 123215, '\p{Scx=:\AHmnp\z:}', "");;
    Expect(0, 123216, '\p{Scx=:\AHmnp\z:}', "");;
    Expect(1, 123215, '\p{Scx=hmnp}', "");
    Expect(0, 123215, '\p{^Scx=hmnp}', "");
    Expect(0, 123215, '\P{Scx=hmnp}', "");
    Expect(1, 123215, '\P{^Scx=hmnp}', "");
    Expect(0, 123216, '\p{Scx=hmnp}', "");
    Expect(1, 123216, '\p{^Scx=hmnp}', "");
    Expect(1, 123216, '\P{Scx=hmnp}', "");
    Expect(0, 123216, '\P{^Scx=hmnp}', "");
    Expect(1, 123215, '\p{Scx=:\Ahmnp\z:}', "");;
    Expect(0, 123216, '\p{Scx=:\Ahmnp\z:}', "");;
    Expect(1, 123215, '\p{Scx=--hmnp}', "");
    Expect(0, 123215, '\p{^Scx=--hmnp}', "");
    Expect(0, 123215, '\P{Scx=--hmnp}', "");
    Expect(1, 123215, '\P{^Scx=--hmnp}', "");
    Expect(0, 123216, '\p{Scx=--hmnp}', "");
    Expect(1, 123216, '\p{^Scx=--hmnp}', "");
    Expect(1, 123216, '\P{Scx=--hmnp}', "");
    Expect(0, 123216, '\P{^Scx=--hmnp}', "");
    Error('\p{Is_Script_Extensions=	/a/NYIAKENG_PUACHUE_Hmong}');
    Error('\P{Is_Script_Extensions=	/a/NYIAKENG_PUACHUE_Hmong}');
    Expect(1, 123215, '\p{Is_Script_Extensions=nyiakengpuachuehmong}', "");
    Expect(0, 123215, '\p{^Is_Script_Extensions=nyiakengpuachuehmong}', "");
    Expect(0, 123215, '\P{Is_Script_Extensions=nyiakengpuachuehmong}', "");
    Expect(1, 123215, '\P{^Is_Script_Extensions=nyiakengpuachuehmong}', "");
    Expect(0, 123216, '\p{Is_Script_Extensions=nyiakengpuachuehmong}', "");
    Expect(1, 123216, '\p{^Is_Script_Extensions=nyiakengpuachuehmong}', "");
    Expect(1, 123216, '\P{Is_Script_Extensions=nyiakengpuachuehmong}', "");
    Expect(0, 123216, '\P{^Is_Script_Extensions=nyiakengpuachuehmong}', "");
    Expect(1, 123215, '\p{Is_Script_Extensions=__nyiakeng_Puachue_HMONG}', "");
    Expect(0, 123215, '\p{^Is_Script_Extensions=__nyiakeng_Puachue_HMONG}', "");
    Expect(0, 123215, '\P{Is_Script_Extensions=__nyiakeng_Puachue_HMONG}', "");
    Expect(1, 123215, '\P{^Is_Script_Extensions=__nyiakeng_Puachue_HMONG}', "");
    Expect(0, 123216, '\p{Is_Script_Extensions=__nyiakeng_Puachue_HMONG}', "");
    Expect(1, 123216, '\p{^Is_Script_Extensions=__nyiakeng_Puachue_HMONG}', "");
    Expect(1, 123216, '\P{Is_Script_Extensions=__nyiakeng_Puachue_HMONG}', "");
    Expect(0, 123216, '\P{^Is_Script_Extensions=__nyiakeng_Puachue_HMONG}', "");
    Error('\p{Is_Scx= /a/Hmnp}');
    Error('\P{Is_Scx= /a/Hmnp}');
    Expect(1, 123215, '\p{Is_Scx=hmnp}', "");
    Expect(0, 123215, '\p{^Is_Scx=hmnp}', "");
    Expect(0, 123215, '\P{Is_Scx=hmnp}', "");
    Expect(1, 123215, '\P{^Is_Scx=hmnp}', "");
    Expect(0, 123216, '\p{Is_Scx=hmnp}', "");
    Expect(1, 123216, '\p{^Is_Scx=hmnp}', "");
    Expect(1, 123216, '\P{Is_Scx=hmnp}', "");
    Expect(0, 123216, '\P{^Is_Scx=hmnp}', "");
    Expect(1, 123215, '\p{Is_Scx=-	Hmnp}', "");
    Expect(0, 123215, '\p{^Is_Scx=-	Hmnp}', "");
    Expect(0, 123215, '\P{Is_Scx=-	Hmnp}', "");
    Expect(1, 123215, '\P{^Is_Scx=-	Hmnp}', "");
    Expect(0, 123216, '\p{Is_Scx=-	Hmnp}', "");
    Expect(1, 123216, '\p{^Is_Scx=-	Hmnp}', "");
    Expect(1, 123216, '\P{Is_Scx=-	Hmnp}', "");
    Expect(0, 123216, '\P{^Is_Scx=-	Hmnp}', "");
    Error('\p{Script_Extensions=Katakana_Or_Hiragana}');
    Error('\P{Script_Extensions=Katakana_Or_Hiragana}');
    Error('\p{Scx:	Hrkt}');
    Error('\P{Scx:	Hrkt}');
    Error('\p{Is_Script_Extensions=Katakana_Or_Hiragana}');
    Error('\P{Is_Script_Extensions=Katakana_Or_Hiragana}');
    Error('\p{Is_Scx:   Hrkt}');
    Error('\P{Is_Scx:   Hrkt}');
    Error('\p{Script_Extensions=	-OLD_HUNGARIAN/a/}');
    Error('\P{Script_Extensions=	-OLD_HUNGARIAN/a/}');
    Expect(1, 68863, '\p{Script_Extensions=:\AOld_Hungarian\z:}', "");;
    Expect(0, 68864, '\p{Script_Extensions=:\AOld_Hungarian\z:}', "");;
    Expect(1, 68863, '\p{Script_Extensions=oldhungarian}', "");
    Expect(0, 68863, '\p{^Script_Extensions=oldhungarian}', "");
    Expect(0, 68863, '\P{Script_Extensions=oldhungarian}', "");
    Expect(1, 68863, '\P{^Script_Extensions=oldhungarian}', "");
    Expect(0, 68864, '\p{Script_Extensions=oldhungarian}', "");
    Expect(1, 68864, '\p{^Script_Extensions=oldhungarian}', "");
    Expect(1, 68864, '\P{Script_Extensions=oldhungarian}', "");
    Expect(0, 68864, '\P{^Script_Extensions=oldhungarian}', "");
    Expect(1, 68863, '\p{Script_Extensions=:\Aoldhungarian\z:}', "");;
    Expect(0, 68864, '\p{Script_Extensions=:\Aoldhungarian\z:}', "");;
    Expect(1, 68863, '\p{Script_Extensions=-_old_Hungarian}', "");
    Expect(0, 68863, '\p{^Script_Extensions=-_old_Hungarian}', "");
    Expect(0, 68863, '\P{Script_Extensions=-_old_Hungarian}', "");
    Expect(1, 68863, '\P{^Script_Extensions=-_old_Hungarian}', "");
    Expect(0, 68864, '\p{Script_Extensions=-_old_Hungarian}', "");
    Expect(1, 68864, '\p{^Script_Extensions=-_old_Hungarian}', "");
    Expect(1, 68864, '\P{Script_Extensions=-_old_Hungarian}', "");
    Expect(0, 68864, '\P{^Script_Extensions=-_old_Hungarian}', "");
    Error('\p{Scx=:=-Hung}');
    Error('\P{Scx=:=-Hung}');
    Expect(1, 68863, '\p{Scx=:\AHung\z:}', "");;
    Expect(0, 68864, '\p{Scx=:\AHung\z:}', "");;
    Expect(1, 68863, '\p{Scx=hung}', "");
    Expect(0, 68863, '\p{^Scx=hung}', "");
    Expect(0, 68863, '\P{Scx=hung}', "");
    Expect(1, 68863, '\P{^Scx=hung}', "");
    Expect(0, 68864, '\p{Scx=hung}', "");
    Expect(1, 68864, '\p{^Scx=hung}', "");
    Expect(1, 68864, '\P{Scx=hung}', "");
    Expect(0, 68864, '\P{^Scx=hung}', "");
    Expect(1, 68863, '\p{Scx=:\Ahung\z:}', "");;
    Expect(0, 68864, '\p{Scx=:\Ahung\z:}', "");;
    Expect(1, 68863, '\p{Scx=__Hung}', "");
    Expect(0, 68863, '\p{^Scx=__Hung}', "");
    Expect(0, 68863, '\P{Scx=__Hung}', "");
    Expect(1, 68863, '\P{^Scx=__Hung}', "");
    Expect(0, 68864, '\p{Scx=__Hung}', "");
    Expect(1, 68864, '\p{^Scx=__Hung}', "");
    Expect(1, 68864, '\P{Scx=__Hung}', "");
    Expect(0, 68864, '\P{^Scx=__Hung}', "");
    Error('\p{Is_Script_Extensions=-Old_Hungarian:=}');
    Error('\P{Is_Script_Extensions=-Old_Hungarian:=}');
    Expect(1, 68863, '\p{Is_Script_Extensions=oldhungarian}', "");
    Expect(0, 68863, '\p{^Is_Script_Extensions=oldhungarian}', "");
    Expect(0, 68863, '\P{Is_Script_Extensions=oldhungarian}', "");
    Expect(1, 68863, '\P{^Is_Script_Extensions=oldhungarian}', "");
    Expect(0, 68864, '\p{Is_Script_Extensions=oldhungarian}', "");
    Expect(1, 68864, '\p{^Is_Script_Extensions=oldhungarian}', "");
    Expect(1, 68864, '\P{Is_Script_Extensions=oldhungarian}', "");
    Expect(0, 68864, '\P{^Is_Script_Extensions=oldhungarian}', "");
    Expect(1, 68863, '\p{Is_Script_Extensions=--Old_Hungarian}', "");
    Expect(0, 68863, '\p{^Is_Script_Extensions=--Old_Hungarian}', "");
    Expect(0, 68863, '\P{Is_Script_Extensions=--Old_Hungarian}', "");
    Expect(1, 68863, '\P{^Is_Script_Extensions=--Old_Hungarian}', "");
    Expect(0, 68864, '\p{Is_Script_Extensions=--Old_Hungarian}', "");
    Expect(1, 68864, '\p{^Is_Script_Extensions=--Old_Hungarian}', "");
    Expect(1, 68864, '\P{Is_Script_Extensions=--Old_Hungarian}', "");
    Expect(0, 68864, '\P{^Is_Script_Extensions=--Old_Hungarian}', "");
    Error('\p{Is_Scx=:=	Hung}');
    Error('\P{Is_Scx=:=	Hung}');
    Expect(1, 68863, '\p{Is_Scx: hung}', "");
    Expect(0, 68863, '\p{^Is_Scx: hung}', "");
    Expect(0, 68863, '\P{Is_Scx: hung}', "");
    Expect(1, 68863, '\P{^Is_Scx: hung}', "");
    Expect(0, 68864, '\p{Is_Scx: hung}', "");
    Expect(1, 68864, '\p{^Is_Scx: hung}', "");
    Expect(1, 68864, '\P{Is_Scx: hung}', "");
    Expect(0, 68864, '\P{^Is_Scx: hung}', "");
    Expect(1, 68863, '\p{Is_Scx= -Hung}', "");
    Expect(0, 68863, '\p{^Is_Scx= -Hung}', "");
    Expect(0, 68863, '\P{Is_Scx= -Hung}', "");
    Expect(1, 68863, '\P{^Is_Scx= -Hung}', "");
    Expect(0, 68864, '\p{Is_Scx= -Hung}', "");
    Expect(1, 68864, '\p{^Is_Scx= -Hung}', "");
    Expect(1, 68864, '\P{Is_Scx= -Hung}', "");
    Expect(0, 68864, '\P{^Is_Scx= -Hung}', "");
    Error('\p{Script_Extensions=_	Old_Italic/a/}');
    Error('\P{Script_Extensions=_	Old_Italic/a/}');
    Expect(1, 66351, '\p{Script_Extensions=:\AOld_Italic\z:}', "");;
    Expect(0, 66352, '\p{Script_Extensions=:\AOld_Italic\z:}', "");;
    Expect(1, 66351, '\p{Script_Extensions=olditalic}', "");
    Expect(0, 66351, '\p{^Script_Extensions=olditalic}', "");
    Expect(0, 66351, '\P{Script_Extensions=olditalic}', "");
    Expect(1, 66351, '\P{^Script_Extensions=olditalic}', "");
    Expect(0, 66352, '\p{Script_Extensions=olditalic}', "");
    Expect(1, 66352, '\p{^Script_Extensions=olditalic}', "");
    Expect(1, 66352, '\P{Script_Extensions=olditalic}', "");
    Expect(0, 66352, '\P{^Script_Extensions=olditalic}', "");
    Expect(1, 66351, '\p{Script_Extensions=:\Aolditalic\z:}', "");;
    Expect(0, 66352, '\p{Script_Extensions=:\Aolditalic\z:}', "");;
    Expect(1, 66351, '\p{Script_Extensions= Old_Italic}', "");
    Expect(0, 66351, '\p{^Script_Extensions= Old_Italic}', "");
    Expect(0, 66351, '\P{Script_Extensions= Old_Italic}', "");
    Expect(1, 66351, '\P{^Script_Extensions= Old_Italic}', "");
    Expect(0, 66352, '\p{Script_Extensions= Old_Italic}', "");
    Expect(1, 66352, '\p{^Script_Extensions= Old_Italic}', "");
    Expect(1, 66352, '\P{Script_Extensions= Old_Italic}', "");
    Expect(0, 66352, '\P{^Script_Extensions= Old_Italic}', "");
    Error('\p{Scx= 	ital:=}');
    Error('\P{Scx= 	ital:=}');
    Expect(1, 66351, '\p{Scx=:\AItal\z:}', "");;
    Expect(0, 66352, '\p{Scx=:\AItal\z:}', "");;
    Expect(1, 66351, '\p{Scx=ital}', "");
    Expect(0, 66351, '\p{^Scx=ital}', "");
    Expect(0, 66351, '\P{Scx=ital}', "");
    Expect(1, 66351, '\P{^Scx=ital}', "");
    Expect(0, 66352, '\p{Scx=ital}', "");
    Expect(1, 66352, '\p{^Scx=ital}', "");
    Expect(1, 66352, '\P{Scx=ital}', "");
    Expect(0, 66352, '\P{^Scx=ital}', "");
    Expect(1, 66351, '\p{Scx=:\Aital\z:}', "");;
    Expect(0, 66352, '\p{Scx=:\Aital\z:}', "");;
    Expect(1, 66351, '\p{Scx= 	ITAL}', "");
    Expect(0, 66351, '\p{^Scx= 	ITAL}', "");
    Expect(0, 66351, '\P{Scx= 	ITAL}', "");
    Expect(1, 66351, '\P{^Scx= 	ITAL}', "");
    Expect(0, 66352, '\p{Scx= 	ITAL}', "");
    Expect(1, 66352, '\p{^Scx= 	ITAL}', "");
    Expect(1, 66352, '\P{Scx= 	ITAL}', "");
    Expect(0, 66352, '\P{^Scx= 	ITAL}', "");
    Error('\p{Is_Script_Extensions=:=-_old_ITALIC}');
    Error('\P{Is_Script_Extensions=:=-_old_ITALIC}');
    Expect(1, 66351, '\p{Is_Script_Extensions=olditalic}', "");
    Expect(0, 66351, '\p{^Is_Script_Extensions=olditalic}', "");
    Expect(0, 66351, '\P{Is_Script_Extensions=olditalic}', "");
    Expect(1, 66351, '\P{^Is_Script_Extensions=olditalic}', "");
    Expect(0, 66352, '\p{Is_Script_Extensions=olditalic}', "");
    Expect(1, 66352, '\p{^Is_Script_Extensions=olditalic}', "");
    Expect(1, 66352, '\P{Is_Script_Extensions=olditalic}', "");
    Expect(0, 66352, '\P{^Is_Script_Extensions=olditalic}', "");
    Expect(1, 66351, '\p{Is_Script_Extensions=	_old_Italic}', "");
    Expect(0, 66351, '\p{^Is_Script_Extensions=	_old_Italic}', "");
    Expect(0, 66351, '\P{Is_Script_Extensions=	_old_Italic}', "");
    Expect(1, 66351, '\P{^Is_Script_Extensions=	_old_Italic}', "");
    Expect(0, 66352, '\p{Is_Script_Extensions=	_old_Italic}', "");
    Expect(1, 66352, '\p{^Is_Script_Extensions=	_old_Italic}', "");
    Expect(1, 66352, '\P{Is_Script_Extensions=	_old_Italic}', "");
    Expect(0, 66352, '\P{^Is_Script_Extensions=	_old_Italic}', "");
    Error('\p{Is_Scx:	_:=ITAL}');
    Error('\P{Is_Scx:	_:=ITAL}');
    Expect(1, 66351, '\p{Is_Scx=ital}', "");
    Expect(0, 66351, '\p{^Is_Scx=ital}', "");
    Expect(0, 66351, '\P{Is_Scx=ital}', "");
    Expect(1, 66351, '\P{^Is_Scx=ital}', "");
    Expect(0, 66352, '\p{Is_Scx=ital}', "");
    Expect(1, 66352, '\p{^Is_Scx=ital}', "");
    Expect(1, 66352, '\P{Is_Scx=ital}', "");
    Expect(0, 66352, '\P{^Is_Scx=ital}', "");
    Expect(1, 66351, '\p{Is_Scx=_	Ital}', "");
    Expect(0, 66351, '\p{^Is_Scx=_	Ital}', "");
    Expect(0, 66351, '\P{Is_Scx=_	Ital}', "");
    Expect(1, 66351, '\P{^Is_Scx=_	Ital}', "");
    Expect(0, 66352, '\p{Is_Scx=_	Ital}', "");
    Expect(1, 66352, '\p{^Is_Scx=_	Ital}', "");
    Expect(1, 66352, '\P{Is_Scx=_	Ital}', "");
    Expect(0, 66352, '\P{^Is_Scx=_	Ital}', "");
    Error('\p{Script_Extensions= /a/Javanese}');
    Error('\P{Script_Extensions= /a/Javanese}');
    Expect(1, 43487, '\p{Script_Extensions=:\AJavanese\z:}', "");;
    Expect(0, 43488, '\p{Script_Extensions=:\AJavanese\z:}', "");;
    Expect(1, 43487, '\p{Script_Extensions=javanese}', "");
    Expect(0, 43487, '\p{^Script_Extensions=javanese}', "");
    Expect(0, 43487, '\P{Script_Extensions=javanese}', "");
    Expect(1, 43487, '\P{^Script_Extensions=javanese}', "");
    Expect(0, 43488, '\p{Script_Extensions=javanese}', "");
    Expect(1, 43488, '\p{^Script_Extensions=javanese}', "");
    Expect(1, 43488, '\P{Script_Extensions=javanese}', "");
    Expect(0, 43488, '\P{^Script_Extensions=javanese}', "");
    Expect(1, 43487, '\p{Script_Extensions=:\Ajavanese\z:}', "");;
    Expect(0, 43488, '\p{Script_Extensions=:\Ajavanese\z:}', "");;
    Expect(1, 43487, '\p{Script_Extensions=_ JAVANESE}', "");
    Expect(0, 43487, '\p{^Script_Extensions=_ JAVANESE}', "");
    Expect(0, 43487, '\P{Script_Extensions=_ JAVANESE}', "");
    Expect(1, 43487, '\P{^Script_Extensions=_ JAVANESE}', "");
    Expect(0, 43488, '\p{Script_Extensions=_ JAVANESE}', "");
    Expect(1, 43488, '\p{^Script_Extensions=_ JAVANESE}', "");
    Expect(1, 43488, '\P{Script_Extensions=_ JAVANESE}', "");
    Expect(0, 43488, '\P{^Script_Extensions=_ JAVANESE}', "");
    Error('\p{Scx=__Java:=}');
    Error('\P{Scx=__Java:=}');
    Expect(1, 43487, '\p{Scx=:\AJava\z:}', "");;
    Expect(0, 43488, '\p{Scx=:\AJava\z:}', "");;
    Expect(1, 43487, '\p{Scx=java}', "");
    Expect(0, 43487, '\p{^Scx=java}', "");
    Expect(0, 43487, '\P{Scx=java}', "");
    Expect(1, 43487, '\P{^Scx=java}', "");
    Expect(0, 43488, '\p{Scx=java}', "");
    Expect(1, 43488, '\p{^Scx=java}', "");
    Expect(1, 43488, '\P{Scx=java}', "");
    Expect(0, 43488, '\P{^Scx=java}', "");
    Expect(1, 43487, '\p{Scx=:\Ajava\z:}', "");;
    Expect(0, 43488, '\p{Scx=:\Ajava\z:}', "");;
    Expect(1, 43487, '\p{Scx=		java}', "");
    Expect(0, 43487, '\p{^Scx=		java}', "");
    Expect(0, 43487, '\P{Scx=		java}', "");
    Expect(1, 43487, '\P{^Scx=		java}', "");
    Expect(0, 43488, '\p{Scx=		java}', "");
    Expect(1, 43488, '\p{^Scx=		java}', "");
    Expect(1, 43488, '\P{Scx=		java}', "");
    Expect(0, 43488, '\P{^Scx=		java}', "");
    Error('\p{Is_Script_Extensions=_-JAVANESE:=}');
    Error('\P{Is_Script_Extensions=_-JAVANESE:=}');
    Expect(1, 43487, '\p{Is_Script_Extensions=javanese}', "");
    Expect(0, 43487, '\p{^Is_Script_Extensions=javanese}', "");
    Expect(0, 43487, '\P{Is_Script_Extensions=javanese}', "");
    Expect(1, 43487, '\P{^Is_Script_Extensions=javanese}', "");
    Expect(0, 43488, '\p{Is_Script_Extensions=javanese}', "");
    Expect(1, 43488, '\p{^Is_Script_Extensions=javanese}', "");
    Expect(1, 43488, '\P{Is_Script_Extensions=javanese}', "");
    Expect(0, 43488, '\P{^Is_Script_Extensions=javanese}', "");
    Expect(1, 43487, '\p{Is_Script_Extensions= Javanese}', "");
    Expect(0, 43487, '\p{^Is_Script_Extensions= Javanese}', "");
    Expect(0, 43487, '\P{Is_Script_Extensions= Javanese}', "");
    Expect(1, 43487, '\P{^Is_Script_Extensions= Javanese}', "");
    Expect(0, 43488, '\p{Is_Script_Extensions= Javanese}', "");
    Expect(1, 43488, '\p{^Is_Script_Extensions= Javanese}', "");
    Expect(1, 43488, '\P{Is_Script_Extensions= Javanese}', "");
    Expect(0, 43488, '\P{^Is_Script_Extensions= Javanese}', "");
    Error('\p{Is_Scx=_/a/Java}');
    Error('\P{Is_Scx=_/a/Java}');
    Expect(1, 43487, '\p{Is_Scx=java}', "");
    Expect(0, 43487, '\p{^Is_Scx=java}', "");
    Expect(0, 43487, '\P{Is_Scx=java}', "");
    Expect(1, 43487, '\P{^Is_Scx=java}', "");
    Expect(0, 43488, '\p{Is_Scx=java}', "");
    Expect(1, 43488, '\p{^Is_Scx=java}', "");
    Expect(1, 43488, '\P{Is_Scx=java}', "");
    Expect(0, 43488, '\P{^Is_Scx=java}', "");
    Expect(1, 43487, '\p{Is_Scx=  Java}', "");
    Expect(0, 43487, '\p{^Is_Scx=  Java}', "");
    Expect(0, 43487, '\P{Is_Scx=  Java}', "");
    Expect(1, 43487, '\P{^Is_Scx=  Java}', "");
    Expect(0, 43488, '\p{Is_Scx=  Java}', "");
    Expect(1, 43488, '\p{^Is_Scx=  Java}', "");
    Expect(1, 43488, '\P{Is_Scx=  Java}', "");
    Expect(0, 43488, '\P{^Is_Scx=  Java}', "");
    Error('\p{Script_Extensions=	/a/Kayah_Li}');
    Error('\P{Script_Extensions=	/a/Kayah_Li}');
    Expect(1, 43311, '\p{Script_Extensions=:\AKayah_Li\z:}', "");;
    Expect(0, 43312, '\p{Script_Extensions=:\AKayah_Li\z:}', "");;
    Expect(1, 43311, '\p{Script_Extensions=kayahli}', "");
    Expect(0, 43311, '\p{^Script_Extensions=kayahli}', "");
    Expect(0, 43311, '\P{Script_Extensions=kayahli}', "");
    Expect(1, 43311, '\P{^Script_Extensions=kayahli}', "");
    Expect(0, 43312, '\p{Script_Extensions=kayahli}', "");
    Expect(1, 43312, '\p{^Script_Extensions=kayahli}', "");
    Expect(1, 43312, '\P{Script_Extensions=kayahli}', "");
    Expect(0, 43312, '\P{^Script_Extensions=kayahli}', "");
    Expect(1, 43311, '\p{Script_Extensions=:\Akayahli\z:}', "");;
    Expect(0, 43312, '\p{Script_Extensions=:\Akayahli\z:}', "");;
    Expect(1, 43311, '\p{Script_Extensions=-Kayah_LI}', "");
    Expect(0, 43311, '\p{^Script_Extensions=-Kayah_LI}', "");
    Expect(0, 43311, '\P{Script_Extensions=-Kayah_LI}', "");
    Expect(1, 43311, '\P{^Script_Extensions=-Kayah_LI}', "");
    Expect(0, 43312, '\p{Script_Extensions=-Kayah_LI}', "");
    Expect(1, 43312, '\p{^Script_Extensions=-Kayah_LI}', "");
    Expect(1, 43312, '\P{Script_Extensions=-Kayah_LI}', "");
    Expect(0, 43312, '\P{^Script_Extensions=-Kayah_LI}', "");
    Error('\p{Scx=_/a/Kali}');
    Error('\P{Scx=_/a/Kali}');
    Expect(1, 43311, '\p{Scx=:\AKali\z:}', "");;
    Expect(0, 43312, '\p{Scx=:\AKali\z:}', "");;
    Expect(1, 43311, '\p{Scx=kali}', "");
    Expect(0, 43311, '\p{^Scx=kali}', "");
    Expect(0, 43311, '\P{Scx=kali}', "");
    Expect(1, 43311, '\P{^Scx=kali}', "");
    Expect(0, 43312, '\p{Scx=kali}', "");
    Expect(1, 43312, '\p{^Scx=kali}', "");
    Expect(1, 43312, '\P{Scx=kali}', "");
    Expect(0, 43312, '\P{^Scx=kali}', "");
    Expect(1, 43311, '\p{Scx=:\Akali\z:}', "");;
    Expect(0, 43312, '\p{Scx=:\Akali\z:}', "");;
    Expect(1, 43311, '\p{Scx=- KALI}', "");
    Expect(0, 43311, '\p{^Scx=- KALI}', "");
    Expect(0, 43311, '\P{Scx=- KALI}', "");
    Expect(1, 43311, '\P{^Scx=- KALI}', "");
    Expect(0, 43312, '\p{Scx=- KALI}', "");
    Expect(1, 43312, '\p{^Scx=- KALI}', "");
    Expect(1, 43312, '\P{Scx=- KALI}', "");
    Expect(0, 43312, '\P{^Scx=- KALI}', "");
    Error('\p{Is_Script_Extensions=/a/__Kayah_Li}');
    Error('\P{Is_Script_Extensions=/a/__Kayah_Li}');
    Expect(1, 43311, '\p{Is_Script_Extensions=kayahli}', "");
    Expect(0, 43311, '\p{^Is_Script_Extensions=kayahli}', "");
    Expect(0, 43311, '\P{Is_Script_Extensions=kayahli}', "");
    Expect(1, 43311, '\P{^Is_Script_Extensions=kayahli}', "");
    Expect(0, 43312, '\p{Is_Script_Extensions=kayahli}', "");
    Expect(1, 43312, '\p{^Is_Script_Extensions=kayahli}', "");
    Expect(1, 43312, '\P{Is_Script_Extensions=kayahli}', "");
    Expect(0, 43312, '\P{^Is_Script_Extensions=kayahli}', "");
    Expect(1, 43311, '\p{Is_Script_Extensions=-Kayah_li}', "");
    Expect(0, 43311, '\p{^Is_Script_Extensions=-Kayah_li}', "");
    Expect(0, 43311, '\P{Is_Script_Extensions=-Kayah_li}', "");
    Expect(1, 43311, '\P{^Is_Script_Extensions=-Kayah_li}', "");
    Expect(0, 43312, '\p{Is_Script_Extensions=-Kayah_li}', "");
    Expect(1, 43312, '\p{^Is_Script_Extensions=-Kayah_li}', "");
    Expect(1, 43312, '\P{Is_Script_Extensions=-Kayah_li}', "");
    Expect(0, 43312, '\P{^Is_Script_Extensions=-Kayah_li}', "");
    Error('\p{Is_Scx=:=- Kali}');
    Error('\P{Is_Scx=:=- Kali}');
    Expect(1, 43311, '\p{Is_Scx=kali}', "");
    Expect(0, 43311, '\p{^Is_Scx=kali}', "");
    Expect(0, 43311, '\P{Is_Scx=kali}', "");
    Expect(1, 43311, '\P{^Is_Scx=kali}', "");
    Expect(0, 43312, '\p{Is_Scx=kali}', "");
    Expect(1, 43312, '\p{^Is_Scx=kali}', "");
    Expect(1, 43312, '\P{Is_Scx=kali}', "");
    Expect(0, 43312, '\P{^Is_Scx=kali}', "");
    Expect(1, 43311, '\p{Is_Scx:   __Kali}', "");
    Expect(0, 43311, '\p{^Is_Scx:   __Kali}', "");
    Expect(0, 43311, '\P{Is_Scx:   __Kali}', "");
    Expect(1, 43311, '\P{^Is_Scx:   __Kali}', "");
    Expect(0, 43312, '\p{Is_Scx:   __Kali}', "");
    Expect(1, 43312, '\p{^Is_Scx:   __Kali}', "");
    Expect(1, 43312, '\P{Is_Scx:   __Kali}', "");
    Expect(0, 43312, '\P{^Is_Scx:   __Kali}', "");
    Error('\p{Script_Extensions:	:=	Katakana}');
    Error('\P{Script_Extensions:	:=	Katakana}');
    Expect(1, 110951, '\p{Script_Extensions=:\AKatakana\z:}', "");;
    Expect(0, 110952, '\p{Script_Extensions=:\AKatakana\z:}', "");;
    Expect(1, 110951, '\p{Script_Extensions=katakana}', "");
    Expect(0, 110951, '\p{^Script_Extensions=katakana}', "");
    Expect(0, 110951, '\P{Script_Extensions=katakana}', "");
    Expect(1, 110951, '\P{^Script_Extensions=katakana}', "");
    Expect(0, 110952, '\p{Script_Extensions=katakana}', "");
    Expect(1, 110952, '\p{^Script_Extensions=katakana}', "");
    Expect(1, 110952, '\P{Script_Extensions=katakana}', "");
    Expect(0, 110952, '\P{^Script_Extensions=katakana}', "");
    Expect(1, 110951, '\p{Script_Extensions=:\Akatakana\z:}', "");;
    Expect(0, 110952, '\p{Script_Extensions=:\Akatakana\z:}', "");;
    Error('\p{Scx= Kana:=}');
    Error('\P{Scx= Kana:=}');
    Expect(1, 110951, '\p{Scx=:\AKana\z:}', "");;
    Expect(0, 110952, '\p{Scx=:\AKana\z:}', "");;
    Expect(1, 110951, '\p{Scx=kana}', "");
    Expect(0, 110951, '\p{^Scx=kana}', "");
    Expect(0, 110951, '\P{Scx=kana}', "");
    Expect(1, 110951, '\P{^Scx=kana}', "");
    Expect(0, 110952, '\p{Scx=kana}', "");
    Expect(1, 110952, '\p{^Scx=kana}', "");
    Expect(1, 110952, '\P{Scx=kana}', "");
    Expect(0, 110952, '\P{^Scx=kana}', "");
    Expect(1, 110951, '\p{Scx=:\Akana\z:}', "");;
    Expect(0, 110952, '\p{Scx=:\Akana\z:}', "");;
    Expect(1, 110951, '\p{Scx=  kana}', "");
    Expect(0, 110951, '\p{^Scx=  kana}', "");
    Expect(0, 110951, '\P{Scx=  kana}', "");
    Expect(1, 110951, '\P{^Scx=  kana}', "");
    Expect(0, 110952, '\p{Scx=  kana}', "");
    Expect(1, 110952, '\p{^Scx=  kana}', "");
    Expect(1, 110952, '\P{Scx=  kana}', "");
    Expect(0, 110952, '\P{^Scx=  kana}', "");
    Error('\p{Is_Script_Extensions=_	katakana/a/}');
    Error('\P{Is_Script_Extensions=_	katakana/a/}');
    Expect(1, 110951, '\p{Is_Script_Extensions=katakana}', "");
    Expect(0, 110951, '\p{^Is_Script_Extensions=katakana}', "");
    Expect(0, 110951, '\P{Is_Script_Extensions=katakana}', "");
    Expect(1, 110951, '\P{^Is_Script_Extensions=katakana}', "");
    Expect(0, 110952, '\p{Is_Script_Extensions=katakana}', "");
    Expect(1, 110952, '\p{^Is_Script_Extensions=katakana}', "");
    Expect(1, 110952, '\P{Is_Script_Extensions=katakana}', "");
    Expect(0, 110952, '\P{^Is_Script_Extensions=katakana}', "");
    Expect(1, 110951, '\p{Is_Script_Extensions:   	katakana}', "");
    Expect(0, 110951, '\p{^Is_Script_Extensions:   	katakana}', "");
    Expect(0, 110951, '\P{Is_Script_Extensions:   	katakana}', "");
    Expect(1, 110951, '\P{^Is_Script_Extensions:   	katakana}', "");
    Expect(0, 110952, '\p{Is_Script_Extensions:   	katakana}', "");
    Expect(1, 110952, '\p{^Is_Script_Extensions:   	katakana}', "");
    Expect(1, 110952, '\P{Is_Script_Extensions:   	katakana}', "");
    Expect(0, 110952, '\P{^Is_Script_Extensions:   	katakana}', "");
    Error('\p{Is_Scx=/a/Kana}');
    Error('\P{Is_Scx=/a/Kana}');
    Expect(1, 110951, '\p{Is_Scx=kana}', "");
    Expect(0, 110951, '\p{^Is_Scx=kana}', "");
    Expect(0, 110951, '\P{Is_Scx=kana}', "");
    Expect(1, 110951, '\P{^Is_Scx=kana}', "");
    Expect(0, 110952, '\p{Is_Scx=kana}', "");
    Expect(1, 110952, '\p{^Is_Scx=kana}', "");
    Expect(1, 110952, '\P{Is_Scx=kana}', "");
    Expect(0, 110952, '\P{^Is_Scx=kana}', "");
    Expect(1, 110951, '\p{Is_Scx= Kana}', "");
    Expect(0, 110951, '\p{^Is_Scx= Kana}', "");
    Expect(0, 110951, '\P{Is_Scx= Kana}', "");
    Expect(1, 110951, '\P{^Is_Scx= Kana}', "");
    Expect(0, 110952, '\p{Is_Scx= Kana}', "");
    Expect(1, 110952, '\p{^Is_Scx= Kana}', "");
    Expect(1, 110952, '\P{Is_Scx= Kana}', "");
    Expect(0, 110952, '\P{^Is_Scx= Kana}', "");
    Error('\p{Script_Extensions=-:=Kawi}');
    Error('\P{Script_Extensions=-:=Kawi}');
    Expect(1, 73561, '\p{Script_Extensions=:\AKawi\z:}', "");;
    Expect(0, 73562, '\p{Script_Extensions=:\AKawi\z:}', "");;
    Expect(1, 73561, '\p{Script_Extensions=kawi}', "");
    Expect(0, 73561, '\p{^Script_Extensions=kawi}', "");
    Expect(0, 73561, '\P{Script_Extensions=kawi}', "");
    Expect(1, 73561, '\P{^Script_Extensions=kawi}', "");
    Expect(0, 73562, '\p{Script_Extensions=kawi}', "");
    Expect(1, 73562, '\p{^Script_Extensions=kawi}', "");
    Expect(1, 73562, '\P{Script_Extensions=kawi}', "");
    Expect(0, 73562, '\P{^Script_Extensions=kawi}', "");
    Expect(1, 73561, '\p{Script_Extensions=:\Akawi\z:}', "");;
    Expect(0, 73562, '\p{Script_Extensions=:\Akawi\z:}', "");;
    Expect(1, 73561, '\p{Script_Extensions=	kawi}', "");
    Expect(0, 73561, '\p{^Script_Extensions=	kawi}', "");
    Expect(0, 73561, '\P{Script_Extensions=	kawi}', "");
    Expect(1, 73561, '\P{^Script_Extensions=	kawi}', "");
    Expect(0, 73562, '\p{Script_Extensions=	kawi}', "");
    Expect(1, 73562, '\p{^Script_Extensions=	kawi}', "");
    Expect(1, 73562, '\P{Script_Extensions=	kawi}', "");
    Expect(0, 73562, '\P{^Script_Extensions=	kawi}', "");
    Error('\p{Scx=	kawi/a/}');
    Error('\P{Scx=	kawi/a/}');
    Expect(1, 73561, '\p{Scx=:\AKawi\z:}', "");;
    Expect(0, 73562, '\p{Scx=:\AKawi\z:}', "");;
    Expect(1, 73561, '\p{Scx=kawi}', "");
    Expect(0, 73561, '\p{^Scx=kawi}', "");
    Expect(0, 73561, '\P{Scx=kawi}', "");
    Expect(1, 73561, '\P{^Scx=kawi}', "");
    Expect(0, 73562, '\p{Scx=kawi}', "");
    Expect(1, 73562, '\p{^Scx=kawi}', "");
    Expect(1, 73562, '\P{Scx=kawi}', "");
    Expect(0, 73562, '\P{^Scx=kawi}', "");
    Expect(1, 73561, '\p{Scx=:\Akawi\z:}', "");;
    Expect(0, 73562, '\p{Scx=:\Akawi\z:}', "");;
    Expect(1, 73561, '\p{Scx=	 Kawi}', "");
    Expect(0, 73561, '\p{^Scx=	 Kawi}', "");
    Expect(0, 73561, '\P{Scx=	 Kawi}', "");
    Expect(1, 73561, '\P{^Scx=	 Kawi}', "");
    Expect(0, 73562, '\p{Scx=	 Kawi}', "");
    Expect(1, 73562, '\p{^Scx=	 Kawi}', "");
    Expect(1, 73562, '\P{Scx=	 Kawi}', "");
    Expect(0, 73562, '\P{^Scx=	 Kawi}', "");
    Error('\p{Is_Script_Extensions=_	kawi/a/}');
    Error('\P{Is_Script_Extensions=_	kawi/a/}');
    Expect(1, 73561, '\p{Is_Script_Extensions=kawi}', "");
    Expect(0, 73561, '\p{^Is_Script_Extensions=kawi}', "");
    Expect(0, 73561, '\P{Is_Script_Extensions=kawi}', "");
    Expect(1, 73561, '\P{^Is_Script_Extensions=kawi}', "");
    Expect(0, 73562, '\p{Is_Script_Extensions=kawi}', "");
    Expect(1, 73562, '\p{^Is_Script_Extensions=kawi}', "");
    Expect(1, 73562, '\P{Is_Script_Extensions=kawi}', "");
    Expect(0, 73562, '\P{^Is_Script_Extensions=kawi}', "");
    Expect(1, 73561, '\p{Is_Script_Extensions=_-Kawi}', "");
    Expect(0, 73561, '\p{^Is_Script_Extensions=_-Kawi}', "");
    Expect(0, 73561, '\P{Is_Script_Extensions=_-Kawi}', "");
    Expect(1, 73561, '\P{^Is_Script_Extensions=_-Kawi}', "");
    Expect(0, 73562, '\p{Is_Script_Extensions=_-Kawi}', "");
    Expect(1, 73562, '\p{^Is_Script_Extensions=_-Kawi}', "");
    Expect(1, 73562, '\P{Is_Script_Extensions=_-Kawi}', "");
    Expect(0, 73562, '\P{^Is_Script_Extensions=_-Kawi}', "");
    Error('\p{Is_Scx=/a/ -kawi}');
    Error('\P{Is_Scx=/a/ -kawi}');
    Expect(1, 73561, '\p{Is_Scx=kawi}', "");
    Expect(0, 73561, '\p{^Is_Scx=kawi}', "");
    Expect(0, 73561, '\P{Is_Scx=kawi}', "");
    Expect(1, 73561, '\P{^Is_Scx=kawi}', "");
    Expect(0, 73562, '\p{Is_Scx=kawi}', "");
    Expect(1, 73562, '\p{^Is_Scx=kawi}', "");
    Expect(1, 73562, '\P{Is_Scx=kawi}', "");
    Expect(0, 73562, '\P{^Is_Scx=kawi}', "");
    Expect(1, 73561, '\p{Is_Scx:	-_Kawi}', "");
    Expect(0, 73561, '\p{^Is_Scx:	-_Kawi}', "");
    Expect(0, 73561, '\P{Is_Scx:	-_Kawi}', "");
    Expect(1, 73561, '\P{^Is_Scx:	-_Kawi}', "");
    Expect(0, 73562, '\p{Is_Scx:	-_Kawi}', "");
    Expect(1, 73562, '\p{^Is_Scx:	-_Kawi}', "");
    Expect(1, 73562, '\P{Is_Scx:	-_Kawi}', "");
    Expect(0, 73562, '\P{^Is_Scx:	-_Kawi}', "");
    Error('\p{Script_Extensions:	_ Kharoshthi:=}');
    Error('\P{Script_Extensions:	_ Kharoshthi:=}');
    Expect(1, 68184, '\p{Script_Extensions=:\AKharoshthi\z:}', "");;
    Expect(0, 68185, '\p{Script_Extensions=:\AKharoshthi\z:}', "");;
    Expect(1, 68184, '\p{Script_Extensions=kharoshthi}', "");
    Expect(0, 68184, '\p{^Script_Extensions=kharoshthi}', "");
    Expect(0, 68184, '\P{Script_Extensions=kharoshthi}', "");
    Expect(1, 68184, '\P{^Script_Extensions=kharoshthi}', "");
    Expect(0, 68185, '\p{Script_Extensions=kharoshthi}', "");
    Expect(1, 68185, '\p{^Script_Extensions=kharoshthi}', "");
    Expect(1, 68185, '\P{Script_Extensions=kharoshthi}', "");
    Expect(0, 68185, '\P{^Script_Extensions=kharoshthi}', "");
    Expect(1, 68184, '\p{Script_Extensions=:\Akharoshthi\z:}', "");;
    Expect(0, 68185, '\p{Script_Extensions=:\Akharoshthi\z:}', "");;
    Expect(1, 68184, '\p{Script_Extensions= Kharoshthi}', "");
    Expect(0, 68184, '\p{^Script_Extensions= Kharoshthi}', "");
    Expect(0, 68184, '\P{Script_Extensions= Kharoshthi}', "");
    Expect(1, 68184, '\P{^Script_Extensions= Kharoshthi}', "");
    Expect(0, 68185, '\p{Script_Extensions= Kharoshthi}', "");
    Expect(1, 68185, '\p{^Script_Extensions= Kharoshthi}', "");
    Expect(1, 68185, '\P{Script_Extensions= Kharoshthi}', "");
    Expect(0, 68185, '\P{^Script_Extensions= Kharoshthi}', "");
    Error('\p{Scx= _KHAR:=}');
    Error('\P{Scx= _KHAR:=}');
    Expect(1, 68184, '\p{Scx=:\AKhar\z:}', "");;
    Expect(0, 68185, '\p{Scx=:\AKhar\z:}', "");;
    Expect(1, 68184, '\p{Scx:   khar}', "");
    Expect(0, 68184, '\p{^Scx:   khar}', "");
    Expect(0, 68184, '\P{Scx:   khar}', "");
    Expect(1, 68184, '\P{^Scx:   khar}', "");
    Expect(0, 68185, '\p{Scx:   khar}', "");
    Expect(1, 68185, '\p{^Scx:   khar}', "");
    Expect(1, 68185, '\P{Scx:   khar}', "");
    Expect(0, 68185, '\P{^Scx:   khar}', "");
    Expect(1, 68184, '\p{Scx=:\Akhar\z:}', "");;
    Expect(0, 68185, '\p{Scx=:\Akhar\z:}', "");;
    Expect(1, 68184, '\p{Scx=  KHAR}', "");
    Expect(0, 68184, '\p{^Scx=  KHAR}', "");
    Expect(0, 68184, '\P{Scx=  KHAR}', "");
    Expect(1, 68184, '\P{^Scx=  KHAR}', "");
    Expect(0, 68185, '\p{Scx=  KHAR}', "");
    Expect(1, 68185, '\p{^Scx=  KHAR}', "");
    Expect(1, 68185, '\P{Scx=  KHAR}', "");
    Expect(0, 68185, '\P{^Scx=  KHAR}', "");
    Error('\p{Is_Script_Extensions=:=_Kharoshthi}');
    Error('\P{Is_Script_Extensions=:=_Kharoshthi}');
    Expect(1, 68184, '\p{Is_Script_Extensions=kharoshthi}', "");
    Expect(0, 68184, '\p{^Is_Script_Extensions=kharoshthi}', "");
    Expect(0, 68184, '\P{Is_Script_Extensions=kharoshthi}', "");
    Expect(1, 68184, '\P{^Is_Script_Extensions=kharoshthi}', "");
    Expect(0, 68185, '\p{Is_Script_Extensions=kharoshthi}', "");
    Expect(1, 68185, '\p{^Is_Script_Extensions=kharoshthi}', "");
    Expect(1, 68185, '\P{Is_Script_Extensions=kharoshthi}', "");
    Expect(0, 68185, '\P{^Is_Script_Extensions=kharoshthi}', "");
    Error('\p{Is_Scx=	/a/KHAR}');
    Error('\P{Is_Scx=	/a/KHAR}');
    Expect(1, 68184, '\p{Is_Scx=khar}', "");
    Expect(0, 68184, '\p{^Is_Scx=khar}', "");
    Expect(0, 68184, '\P{Is_Scx=khar}', "");
    Expect(1, 68184, '\P{^Is_Scx=khar}', "");
    Expect(0, 68185, '\p{Is_Scx=khar}', "");
    Expect(1, 68185, '\p{^Is_Scx=khar}', "");
    Expect(1, 68185, '\P{Is_Scx=khar}', "");
    Expect(0, 68185, '\P{^Is_Scx=khar}', "");
    Expect(1, 68184, '\p{Is_Scx:	Khar}', "");
    Expect(0, 68184, '\p{^Is_Scx:	Khar}', "");
    Expect(0, 68184, '\P{Is_Scx:	Khar}', "");
    Expect(1, 68184, '\P{^Is_Scx:	Khar}', "");
    Expect(0, 68185, '\p{Is_Scx:	Khar}', "");
    Expect(1, 68185, '\p{^Is_Scx:	Khar}', "");
    Expect(1, 68185, '\P{Is_Scx:	Khar}', "");
    Expect(0, 68185, '\P{^Is_Scx:	Khar}', "");
    Error('\p{Script_Extensions=:=	-khmer}');
    Error('\P{Script_Extensions=:=	-khmer}');
    Expect(1, 6655, '\p{Script_Extensions=:\AKhmer\z:}', "");;
    Expect(0, 6656, '\p{Script_Extensions=:\AKhmer\z:}', "");;
    Expect(1, 6655, '\p{Script_Extensions=khmer}', "");
    Expect(0, 6655, '\p{^Script_Extensions=khmer}', "");
    Expect(0, 6655, '\P{Script_Extensions=khmer}', "");
    Expect(1, 6655, '\P{^Script_Extensions=khmer}', "");
    Expect(0, 6656, '\p{Script_Extensions=khmer}', "");
    Expect(1, 6656, '\p{^Script_Extensions=khmer}', "");
    Expect(1, 6656, '\P{Script_Extensions=khmer}', "");
    Expect(0, 6656, '\P{^Script_Extensions=khmer}', "");
    Expect(1, 6655, '\p{Script_Extensions=:\Akhmer\z:}', "");;
    Expect(0, 6656, '\p{Script_Extensions=:\Akhmer\z:}', "");;
    Expect(1, 6655, '\p{Script_Extensions:    	KHMER}', "");
    Expect(0, 6655, '\p{^Script_Extensions:    	KHMER}', "");
    Expect(0, 6655, '\P{Script_Extensions:    	KHMER}', "");
    Expect(1, 6655, '\P{^Script_Extensions:    	KHMER}', "");
    Expect(0, 6656, '\p{Script_Extensions:    	KHMER}', "");
    Expect(1, 6656, '\p{^Script_Extensions:    	KHMER}', "");
    Expect(1, 6656, '\P{Script_Extensions:    	KHMER}', "");
    Expect(0, 6656, '\P{^Script_Extensions:    	KHMER}', "");
    Error('\p{Scx=	/a/KHMR}');
    Error('\P{Scx=	/a/KHMR}');
    Expect(1, 6655, '\p{Scx=:\AKhmr\z:}', "");;
    Expect(0, 6656, '\p{Scx=:\AKhmr\z:}', "");;
    Expect(1, 6655, '\p{Scx=khmr}', "");
    Expect(0, 6655, '\p{^Scx=khmr}', "");
    Expect(0, 6655, '\P{Scx=khmr}', "");
    Expect(1, 6655, '\P{^Scx=khmr}', "");
    Expect(0, 6656, '\p{Scx=khmr}', "");
    Expect(1, 6656, '\p{^Scx=khmr}', "");
    Expect(1, 6656, '\P{Scx=khmr}', "");
    Expect(0, 6656, '\P{^Scx=khmr}', "");
    Expect(1, 6655, '\p{Scx=:\Akhmr\z:}', "");;
    Expect(0, 6656, '\p{Scx=:\Akhmr\z:}', "");;
    Expect(1, 6655, '\p{Scx=-_Khmr}', "");
    Expect(0, 6655, '\p{^Scx=-_Khmr}', "");
    Expect(0, 6655, '\P{Scx=-_Khmr}', "");
    Expect(1, 6655, '\P{^Scx=-_Khmr}', "");
    Expect(0, 6656, '\p{Scx=-_Khmr}', "");
    Expect(1, 6656, '\p{^Scx=-_Khmr}', "");
    Expect(1, 6656, '\P{Scx=-_Khmr}', "");
    Expect(0, 6656, '\P{^Scx=-_Khmr}', "");
    Error('\p{Is_Script_Extensions=_ Khmer:=}');
    Error('\P{Is_Script_Extensions=_ Khmer:=}');
    Expect(1, 6655, '\p{Is_Script_Extensions:khmer}', "");
    Expect(0, 6655, '\p{^Is_Script_Extensions:khmer}', "");
    Expect(0, 6655, '\P{Is_Script_Extensions:khmer}', "");
    Expect(1, 6655, '\P{^Is_Script_Extensions:khmer}', "");
    Expect(0, 6656, '\p{Is_Script_Extensions:khmer}', "");
    Expect(1, 6656, '\p{^Is_Script_Extensions:khmer}', "");
    Expect(1, 6656, '\P{Is_Script_Extensions:khmer}', "");
    Expect(0, 6656, '\P{^Is_Script_Extensions:khmer}', "");
    Expect(1, 6655, '\p{Is_Script_Extensions=--KHMER}', "");
    Expect(0, 6655, '\p{^Is_Script_Extensions=--KHMER}', "");
    Expect(0, 6655, '\P{Is_Script_Extensions=--KHMER}', "");
    Expect(1, 6655, '\P{^Is_Script_Extensions=--KHMER}', "");
    Expect(0, 6656, '\p{Is_Script_Extensions=--KHMER}', "");
    Expect(1, 6656, '\p{^Is_Script_Extensions=--KHMER}', "");
    Expect(1, 6656, '\P{Is_Script_Extensions=--KHMER}', "");
    Expect(0, 6656, '\P{^Is_Script_Extensions=--KHMER}', "");
    Error('\p{Is_Scx:	 	Khmr:=}');
    Error('\P{Is_Scx:	 	Khmr:=}');
    Expect(1, 6655, '\p{Is_Scx=khmr}', "");
    Expect(0, 6655, '\p{^Is_Scx=khmr}', "");
    Expect(0, 6655, '\P{Is_Scx=khmr}', "");
    Expect(1, 6655, '\P{^Is_Scx=khmr}', "");
    Expect(0, 6656, '\p{Is_Scx=khmr}', "");
    Expect(1, 6656, '\p{^Is_Scx=khmr}', "");
    Expect(1, 6656, '\P{Is_Scx=khmr}', "");
    Expect(0, 6656, '\P{^Is_Scx=khmr}', "");
    Expect(1, 6655, '\p{Is_Scx=	_Khmr}', "");
    Expect(0, 6655, '\p{^Is_Scx=	_Khmr}', "");
    Expect(0, 6655, '\P{Is_Scx=	_Khmr}', "");
    Expect(1, 6655, '\P{^Is_Scx=	_Khmr}', "");
    Expect(0, 6656, '\p{Is_Scx=	_Khmr}', "");
    Expect(1, 6656, '\p{^Is_Scx=	_Khmr}', "");
    Expect(1, 6656, '\P{Is_Scx=	_Khmr}', "");
    Expect(0, 6656, '\P{^Is_Scx=	_Khmr}', "");
    Error('\p{Script_Extensions= :=khojki}');
    Error('\P{Script_Extensions= :=khojki}');
    Expect(1, 70209, '\p{Script_Extensions=:\AKhojki\z:}', "");;
    Expect(0, 70210, '\p{Script_Extensions=:\AKhojki\z:}', "");;
    Expect(1, 70209, '\p{Script_Extensions=khojki}', "");
    Expect(0, 70209, '\p{^Script_Extensions=khojki}', "");
    Expect(0, 70209, '\P{Script_Extensions=khojki}', "");
    Expect(1, 70209, '\P{^Script_Extensions=khojki}', "");
    Expect(0, 70210, '\p{Script_Extensions=khojki}', "");
    Expect(1, 70210, '\p{^Script_Extensions=khojki}', "");
    Expect(1, 70210, '\P{Script_Extensions=khojki}', "");
    Expect(0, 70210, '\P{^Script_Extensions=khojki}', "");
    Expect(1, 70209, '\p{Script_Extensions=:\Akhojki\z:}', "");;
    Expect(0, 70210, '\p{Script_Extensions=:\Akhojki\z:}', "");;
    Expect(1, 70209, '\p{Script_Extensions= -khojki}', "");
    Expect(0, 70209, '\p{^Script_Extensions= -khojki}', "");
    Expect(0, 70209, '\P{Script_Extensions= -khojki}', "");
    Expect(1, 70209, '\P{^Script_Extensions= -khojki}', "");
    Expect(0, 70210, '\p{Script_Extensions= -khojki}', "");
    Expect(1, 70210, '\p{^Script_Extensions= -khojki}', "");
    Expect(1, 70210, '\P{Script_Extensions= -khojki}', "");
    Expect(0, 70210, '\P{^Script_Extensions= -khojki}', "");
    Error('\p{Scx:   := Khoj}');
    Error('\P{Scx:   := Khoj}');
    Expect(1, 70209, '\p{Scx=:\AKhoj\z:}', "");;
    Expect(0, 70210, '\p{Scx=:\AKhoj\z:}', "");;
    Expect(1, 70209, '\p{Scx=khoj}', "");
    Expect(0, 70209, '\p{^Scx=khoj}', "");
    Expect(0, 70209, '\P{Scx=khoj}', "");
    Expect(1, 70209, '\P{^Scx=khoj}', "");
    Expect(0, 70210, '\p{Scx=khoj}', "");
    Expect(1, 70210, '\p{^Scx=khoj}', "");
    Expect(1, 70210, '\P{Scx=khoj}', "");
    Expect(0, 70210, '\P{^Scx=khoj}', "");
    Expect(1, 70209, '\p{Scx=:\Akhoj\z:}', "");;
    Expect(0, 70210, '\p{Scx=:\Akhoj\z:}', "");;
    Error('\p{Is_Script_Extensions=/a/	KHOJKI}');
    Error('\P{Is_Script_Extensions=/a/	KHOJKI}');
    Expect(1, 70209, '\p{Is_Script_Extensions=khojki}', "");
    Expect(0, 70209, '\p{^Is_Script_Extensions=khojki}', "");
    Expect(0, 70209, '\P{Is_Script_Extensions=khojki}', "");
    Expect(1, 70209, '\P{^Is_Script_Extensions=khojki}', "");
    Expect(0, 70210, '\p{Is_Script_Extensions=khojki}', "");
    Expect(1, 70210, '\p{^Is_Script_Extensions=khojki}', "");
    Expect(1, 70210, '\P{Is_Script_Extensions=khojki}', "");
    Expect(0, 70210, '\P{^Is_Script_Extensions=khojki}', "");
    Expect(1, 70209, '\p{Is_Script_Extensions=	KHOJKI}', "");
    Expect(0, 70209, '\p{^Is_Script_Extensions=	KHOJKI}', "");
    Expect(0, 70209, '\P{Is_Script_Extensions=	KHOJKI}', "");
    Expect(1, 70209, '\P{^Is_Script_Extensions=	KHOJKI}', "");
    Expect(0, 70210, '\p{Is_Script_Extensions=	KHOJKI}', "");
    Expect(1, 70210, '\p{^Is_Script_Extensions=	KHOJKI}', "");
    Expect(1, 70210, '\P{Is_Script_Extensions=	KHOJKI}', "");
    Expect(0, 70210, '\P{^Is_Script_Extensions=	KHOJKI}', "");
    Error('\p{Is_Scx=:=khoj}');
    Error('\P{Is_Scx=:=khoj}');
    Expect(1, 70209, '\p{Is_Scx=khoj}', "");
    Expect(0, 70209, '\p{^Is_Scx=khoj}', "");
    Expect(0, 70209, '\P{Is_Scx=khoj}', "");
    Expect(1, 70209, '\P{^Is_Scx=khoj}', "");
    Expect(0, 70210, '\p{Is_Scx=khoj}', "");
    Expect(1, 70210, '\p{^Is_Scx=khoj}', "");
    Expect(1, 70210, '\P{Is_Scx=khoj}', "");
    Expect(0, 70210, '\P{^Is_Scx=khoj}', "");
    Expect(1, 70209, '\p{Is_Scx=	KHOJ}', "");
    Expect(0, 70209, '\p{^Is_Scx=	KHOJ}', "");
    Expect(0, 70209, '\P{Is_Scx=	KHOJ}', "");
    Expect(1, 70209, '\P{^Is_Scx=	KHOJ}', "");
    Expect(0, 70210, '\p{Is_Scx=	KHOJ}', "");
    Expect(1, 70210, '\p{^Is_Scx=	KHOJ}', "");
    Expect(1, 70210, '\P{Is_Scx=	KHOJ}', "");
    Expect(0, 70210, '\P{^Is_Scx=	KHOJ}', "");
    Error('\p{Script_Extensions=	:=Khitan_small_SCRIPT}');
    Error('\P{Script_Extensions=	:=Khitan_small_SCRIPT}');
    Expect(1, 101589, '\p{Script_Extensions=:\AKhitan_Small_Script\z:}', "");;
    Expect(0, 101590, '\p{Script_Extensions=:\AKhitan_Small_Script\z:}', "");;
    Expect(1, 101589, '\p{Script_Extensions=khitansmallscript}', "");
    Expect(0, 101589, '\p{^Script_Extensions=khitansmallscript}', "");
    Expect(0, 101589, '\P{Script_Extensions=khitansmallscript}', "");
    Expect(1, 101589, '\P{^Script_Extensions=khitansmallscript}', "");
    Expect(0, 101590, '\p{Script_Extensions=khitansmallscript}', "");
    Expect(1, 101590, '\p{^Script_Extensions=khitansmallscript}', "");
    Expect(1, 101590, '\P{Script_Extensions=khitansmallscript}', "");
    Expect(0, 101590, '\P{^Script_Extensions=khitansmallscript}', "");
    Expect(1, 101589, '\p{Script_Extensions=:\Akhitansmallscript\z:}', "");;
    Expect(0, 101590, '\p{Script_Extensions=:\Akhitansmallscript\z:}', "");;
    Expect(1, 101589, '\p{Script_Extensions=		Khitan_Small_SCRIPT}', "");
    Expect(0, 101589, '\p{^Script_Extensions=		Khitan_Small_SCRIPT}', "");
    Expect(0, 101589, '\P{Script_Extensions=		Khitan_Small_SCRIPT}', "");
    Expect(1, 101589, '\P{^Script_Extensions=		Khitan_Small_SCRIPT}', "");
    Expect(0, 101590, '\p{Script_Extensions=		Khitan_Small_SCRIPT}', "");
    Expect(1, 101590, '\p{^Script_Extensions=		Khitan_Small_SCRIPT}', "");
    Expect(1, 101590, '\P{Script_Extensions=		Khitan_Small_SCRIPT}', "");
    Expect(0, 101590, '\P{^Script_Extensions=		Khitan_Small_SCRIPT}', "");
    Error('\p{Scx=KITS/a/}');
    Error('\P{Scx=KITS/a/}');
    Expect(1, 101589, '\p{Scx=:\AKits\z:}', "");;
    Expect(0, 101590, '\p{Scx=:\AKits\z:}', "");;
    Expect(1, 101589, '\p{Scx=kits}', "");
    Expect(0, 101589, '\p{^Scx=kits}', "");
    Expect(0, 101589, '\P{Scx=kits}', "");
    Expect(1, 101589, '\P{^Scx=kits}', "");
    Expect(0, 101590, '\p{Scx=kits}', "");
    Expect(1, 101590, '\p{^Scx=kits}', "");
    Expect(1, 101590, '\P{Scx=kits}', "");
    Expect(0, 101590, '\P{^Scx=kits}', "");
    Expect(1, 101589, '\p{Scx=:\Akits\z:}', "");;
    Expect(0, 101590, '\p{Scx=:\Akits\z:}', "");;
    Expect(1, 101589, '\p{Scx=	kits}', "");
    Expect(0, 101589, '\p{^Scx=	kits}', "");
    Expect(0, 101589, '\P{Scx=	kits}', "");
    Expect(1, 101589, '\P{^Scx=	kits}', "");
    Expect(0, 101590, '\p{Scx=	kits}', "");
    Expect(1, 101590, '\p{^Scx=	kits}', "");
    Expect(1, 101590, '\P{Scx=	kits}', "");
    Expect(0, 101590, '\P{^Scx=	kits}', "");
    Error('\p{Is_Script_Extensions:	:= 	KHITAN_Small_SCRIPT}');
    Error('\P{Is_Script_Extensions:	:= 	KHITAN_Small_SCRIPT}');
    Expect(1, 101589, '\p{Is_Script_Extensions=khitansmallscript}', "");
    Expect(0, 101589, '\p{^Is_Script_Extensions=khitansmallscript}', "");
    Expect(0, 101589, '\P{Is_Script_Extensions=khitansmallscript}', "");
    Expect(1, 101589, '\P{^Is_Script_Extensions=khitansmallscript}', "");
    Expect(0, 101590, '\p{Is_Script_Extensions=khitansmallscript}', "");
    Expect(1, 101590, '\p{^Is_Script_Extensions=khitansmallscript}', "");
    Expect(1, 101590, '\P{Is_Script_Extensions=khitansmallscript}', "");
    Expect(0, 101590, '\P{^Is_Script_Extensions=khitansmallscript}', "");
    Expect(1, 101589, '\p{Is_Script_Extensions=  khitan_Small_script}', "");
    Expect(0, 101589, '\p{^Is_Script_Extensions=  khitan_Small_script}', "");
    Expect(0, 101589, '\P{Is_Script_Extensions=  khitan_Small_script}', "");
    Expect(1, 101589, '\P{^Is_Script_Extensions=  khitan_Small_script}', "");
    Expect(0, 101590, '\p{Is_Script_Extensions=  khitan_Small_script}', "");
    Expect(1, 101590, '\p{^Is_Script_Extensions=  khitan_Small_script}', "");
    Expect(1, 101590, '\P{Is_Script_Extensions=  khitan_Small_script}', "");
    Expect(0, 101590, '\P{^Is_Script_Extensions=  khitan_Small_script}', "");
    Error('\p{Is_Scx=		KITS:=}');
    Error('\P{Is_Scx=		KITS:=}');
    Expect(1, 101589, '\p{Is_Scx=kits}', "");
    Expect(0, 101589, '\p{^Is_Scx=kits}', "");
    Expect(0, 101589, '\P{Is_Scx=kits}', "");
    Expect(1, 101589, '\P{^Is_Scx=kits}', "");
    Expect(0, 101590, '\p{Is_Scx=kits}', "");
    Expect(1, 101590, '\p{^Is_Scx=kits}', "");
    Expect(1, 101590, '\P{Is_Scx=kits}', "");
    Expect(0, 101590, '\P{^Is_Scx=kits}', "");
    Expect(1, 101589, '\p{Is_Scx=-	KITS}', "");
    Expect(0, 101589, '\p{^Is_Scx=-	KITS}', "");
    Expect(0, 101589, '\P{Is_Scx=-	KITS}', "");
    Expect(1, 101589, '\P{^Is_Scx=-	KITS}', "");
    Expect(0, 101590, '\p{Is_Scx=-	KITS}', "");
    Expect(1, 101590, '\p{^Is_Scx=-	KITS}', "");
    Expect(1, 101590, '\P{Is_Scx=-	KITS}', "");
    Expect(0, 101590, '\P{^Is_Scx=-	KITS}', "");
    Error('\p{Script_Extensions=/a/ _KANNADA}');
    Error('\P{Script_Extensions=/a/ _KANNADA}');
    Expect(1, 43061, '\p{Script_Extensions=:\AKannada\z:}', "");;
    Expect(0, 43062, '\p{Script_Extensions=:\AKannada\z:}', "");;
    Expect(1, 43061, '\p{Script_Extensions=kannada}', "");
    Expect(0, 43061, '\p{^Script_Extensions=kannada}', "");
    Expect(0, 43061, '\P{Script_Extensions=kannada}', "");
    Expect(1, 43061, '\P{^Script_Extensions=kannada}', "");
    Expect(0, 43062, '\p{Script_Extensions=kannada}', "");
    Expect(1, 43062, '\p{^Script_Extensions=kannada}', "");
    Expect(1, 43062, '\P{Script_Extensions=kannada}', "");
    Expect(0, 43062, '\P{^Script_Extensions=kannada}', "");
    Expect(1, 43061, '\p{Script_Extensions=:\Akannada\z:}', "");;
    Expect(0, 43062, '\p{Script_Extensions=:\Akannada\z:}', "");;
    Expect(1, 43061, '\p{Script_Extensions=-Kannada}', "");
    Expect(0, 43061, '\p{^Script_Extensions=-Kannada}', "");
    Expect(0, 43061, '\P{Script_Extensions=-Kannada}', "");
    Expect(1, 43061, '\P{^Script_Extensions=-Kannada}', "");
    Expect(0, 43062, '\p{Script_Extensions=-Kannada}', "");
    Expect(1, 43062, '\p{^Script_Extensions=-Kannada}', "");
    Expect(1, 43062, '\P{Script_Extensions=-Kannada}', "");
    Expect(0, 43062, '\P{^Script_Extensions=-Kannada}', "");
    Error('\p{Scx=:=	Knda}');
    Error('\P{Scx=:=	Knda}');
    Expect(1, 43061, '\p{Scx=:\AKnda\z:}', "");;
    Expect(0, 43062, '\p{Scx=:\AKnda\z:}', "");;
    Expect(1, 43061, '\p{Scx=knda}', "");
    Expect(0, 43061, '\p{^Scx=knda}', "");
    Expect(0, 43061, '\P{Scx=knda}', "");
    Expect(1, 43061, '\P{^Scx=knda}', "");
    Expect(0, 43062, '\p{Scx=knda}', "");
    Expect(1, 43062, '\p{^Scx=knda}', "");
    Expect(1, 43062, '\P{Scx=knda}', "");
    Expect(0, 43062, '\P{^Scx=knda}', "");
    Expect(1, 43061, '\p{Scx=:\Aknda\z:}', "");;
    Expect(0, 43062, '\p{Scx=:\Aknda\z:}', "");;
    Expect(1, 43061, '\p{Scx=	Knda}', "");
    Expect(0, 43061, '\p{^Scx=	Knda}', "");
    Expect(0, 43061, '\P{Scx=	Knda}', "");
    Expect(1, 43061, '\P{^Scx=	Knda}', "");
    Expect(0, 43062, '\p{Scx=	Knda}', "");
    Expect(1, 43062, '\p{^Scx=	Knda}', "");
    Expect(1, 43062, '\P{Scx=	Knda}', "");
    Expect(0, 43062, '\P{^Scx=	Knda}', "");
    Error('\p{Is_Script_Extensions=  kannada:=}');
    Error('\P{Is_Script_Extensions=  kannada:=}');
    Expect(1, 43061, '\p{Is_Script_Extensions:kannada}', "");
    Expect(0, 43061, '\p{^Is_Script_Extensions:kannada}', "");
    Expect(0, 43061, '\P{Is_Script_Extensions:kannada}', "");
    Expect(1, 43061, '\P{^Is_Script_Extensions:kannada}', "");
    Expect(0, 43062, '\p{Is_Script_Extensions:kannada}', "");
    Expect(1, 43062, '\p{^Is_Script_Extensions:kannada}', "");
    Expect(1, 43062, '\P{Is_Script_Extensions:kannada}', "");
    Expect(0, 43062, '\P{^Is_Script_Extensions:kannada}', "");
    Expect(1, 43061, '\p{Is_Script_Extensions:Kannada}', "");
    Expect(0, 43061, '\p{^Is_Script_Extensions:Kannada}', "");
    Expect(0, 43061, '\P{Is_Script_Extensions:Kannada}', "");
    Expect(1, 43061, '\P{^Is_Script_Extensions:Kannada}', "");
    Expect(0, 43062, '\p{Is_Script_Extensions:Kannada}', "");
    Expect(1, 43062, '\p{^Is_Script_Extensions:Kannada}', "");
    Expect(1, 43062, '\P{Is_Script_Extensions:Kannada}', "");
    Expect(0, 43062, '\P{^Is_Script_Extensions:Kannada}', "");
    Error('\p{Is_Scx:   Knda:=}');
    Error('\P{Is_Scx:   Knda:=}');
    Expect(1, 43061, '\p{Is_Scx=knda}', "");
    Expect(0, 43061, '\p{^Is_Scx=knda}', "");
    Expect(0, 43061, '\P{Is_Scx=knda}', "");
    Expect(1, 43061, '\P{^Is_Scx=knda}', "");
    Expect(0, 43062, '\p{Is_Scx=knda}', "");
    Expect(1, 43062, '\p{^Is_Scx=knda}', "");
    Expect(1, 43062, '\P{Is_Scx=knda}', "");
    Expect(0, 43062, '\P{^Is_Scx=knda}', "");
    Expect(1, 43061, '\p{Is_Scx=	_Knda}', "");
    Expect(0, 43061, '\p{^Is_Scx=	_Knda}', "");
    Expect(0, 43061, '\P{Is_Scx=	_Knda}', "");
    Expect(1, 43061, '\P{^Is_Scx=	_Knda}', "");
    Expect(0, 43062, '\p{Is_Scx=	_Knda}', "");
    Expect(1, 43062, '\p{^Is_Scx=	_Knda}', "");
    Expect(1, 43062, '\P{Is_Scx=	_Knda}', "");
    Expect(0, 43062, '\P{^Is_Scx=	_Knda}', "");
    Error('\p{Script_Extensions=/a/  KAITHI}');
    Error('\P{Script_Extensions=/a/  KAITHI}');
    Expect(1, 69837, '\p{Script_Extensions=:\AKaithi\z:}', "");;
    Expect(0, 69838, '\p{Script_Extensions=:\AKaithi\z:}', "");;
    Expect(1, 69837, '\p{Script_Extensions=kaithi}', "");
    Expect(0, 69837, '\p{^Script_Extensions=kaithi}', "");
    Expect(0, 69837, '\P{Script_Extensions=kaithi}', "");
    Expect(1, 69837, '\P{^Script_Extensions=kaithi}', "");
    Expect(0, 69838, '\p{Script_Extensions=kaithi}', "");
    Expect(1, 69838, '\p{^Script_Extensions=kaithi}', "");
    Expect(1, 69838, '\P{Script_Extensions=kaithi}', "");
    Expect(0, 69838, '\P{^Script_Extensions=kaithi}', "");
    Expect(1, 69837, '\p{Script_Extensions=:\Akaithi\z:}', "");;
    Expect(0, 69838, '\p{Script_Extensions=:\Akaithi\z:}', "");;
    Expect(1, 69837, '\p{Script_Extensions=__Kaithi}', "");
    Expect(0, 69837, '\p{^Script_Extensions=__Kaithi}', "");
    Expect(0, 69837, '\P{Script_Extensions=__Kaithi}', "");
    Expect(1, 69837, '\P{^Script_Extensions=__Kaithi}', "");
    Expect(0, 69838, '\p{Script_Extensions=__Kaithi}', "");
    Expect(1, 69838, '\p{^Script_Extensions=__Kaithi}', "");
    Expect(1, 69838, '\P{Script_Extensions=__Kaithi}', "");
    Expect(0, 69838, '\P{^Script_Extensions=__Kaithi}', "");
    Error('\p{Scx= -Kthi/a/}');
    Error('\P{Scx= -Kthi/a/}');
    Expect(1, 69837, '\p{Scx=:\AKthi\z:}', "");;
    Expect(0, 69838, '\p{Scx=:\AKthi\z:}', "");;
    Expect(1, 69837, '\p{Scx=kthi}', "");
    Expect(0, 69837, '\p{^Scx=kthi}', "");
    Expect(0, 69837, '\P{Scx=kthi}', "");
    Expect(1, 69837, '\P{^Scx=kthi}', "");
    Expect(0, 69838, '\p{Scx=kthi}', "");
    Expect(1, 69838, '\p{^Scx=kthi}', "");
    Expect(1, 69838, '\P{Scx=kthi}', "");
    Expect(0, 69838, '\P{^Scx=kthi}', "");
    Expect(1, 69837, '\p{Scx=:\Akthi\z:}', "");;
    Expect(0, 69838, '\p{Scx=:\Akthi\z:}', "");;
    Expect(1, 69837, '\p{Scx= Kthi}', "");
    Expect(0, 69837, '\p{^Scx= Kthi}', "");
    Expect(0, 69837, '\P{Scx= Kthi}', "");
    Expect(1, 69837, '\P{^Scx= Kthi}', "");
    Expect(0, 69838, '\p{Scx= Kthi}', "");
    Expect(1, 69838, '\p{^Scx= Kthi}', "");
    Expect(1, 69838, '\P{Scx= Kthi}', "");
    Expect(0, 69838, '\P{^Scx= Kthi}', "");
    Error('\p{Is_Script_Extensions= :=Kaithi}');
    Error('\P{Is_Script_Extensions= :=Kaithi}');
    Expect(1, 69837, '\p{Is_Script_Extensions=kaithi}', "");
    Expect(0, 69837, '\p{^Is_Script_Extensions=kaithi}', "");
    Expect(0, 69837, '\P{Is_Script_Extensions=kaithi}', "");
    Expect(1, 69837, '\P{^Is_Script_Extensions=kaithi}', "");
    Expect(0, 69838, '\p{Is_Script_Extensions=kaithi}', "");
    Expect(1, 69838, '\p{^Is_Script_Extensions=kaithi}', "");
    Expect(1, 69838, '\P{Is_Script_Extensions=kaithi}', "");
    Expect(0, 69838, '\P{^Is_Script_Extensions=kaithi}', "");
    Expect(1, 69837, '\p{Is_Script_Extensions= 	kaithi}', "");
    Expect(0, 69837, '\p{^Is_Script_Extensions= 	kaithi}', "");
    Expect(0, 69837, '\P{Is_Script_Extensions= 	kaithi}', "");
    Expect(1, 69837, '\P{^Is_Script_Extensions= 	kaithi}', "");
    Expect(0, 69838, '\p{Is_Script_Extensions= 	kaithi}', "");
    Expect(1, 69838, '\p{^Is_Script_Extensions= 	kaithi}', "");
    Expect(1, 69838, '\P{Is_Script_Extensions= 	kaithi}', "");
    Expect(0, 69838, '\P{^Is_Script_Extensions= 	kaithi}', "");
    Error('\p{Is_Scx=:=_Kthi}');
    Error('\P{Is_Scx=:=_Kthi}');
    Expect(1, 69837, '\p{Is_Scx=kthi}', "");
    Expect(0, 69837, '\p{^Is_Scx=kthi}', "");
    Expect(0, 69837, '\P{Is_Scx=kthi}', "");
    Expect(1, 69837, '\P{^Is_Scx=kthi}', "");
    Expect(0, 69838, '\p{Is_Scx=kthi}', "");
    Expect(1, 69838, '\p{^Is_Scx=kthi}', "");
    Expect(1, 69838, '\P{Is_Scx=kthi}', "");
    Expect(0, 69838, '\P{^Is_Scx=kthi}', "");
    Expect(1, 69837, '\p{Is_Scx=	Kthi}', "");
    Expect(0, 69837, '\p{^Is_Scx=	Kthi}', "");
    Expect(0, 69837, '\P{Is_Scx=	Kthi}', "");
    Expect(1, 69837, '\P{^Is_Scx=	Kthi}', "");
    Expect(0, 69838, '\p{Is_Scx=	Kthi}', "");
    Expect(1, 69838, '\p{^Is_Scx=	Kthi}', "");
    Expect(1, 69838, '\P{Is_Scx=	Kthi}', "");
    Expect(0, 69838, '\P{^Is_Scx=	Kthi}', "");
    Error('\p{Script_Extensions:   :=tai_tham}');
    Error('\P{Script_Extensions:   :=tai_tham}');
    Expect(1, 6829, '\p{Script_Extensions=:\ATai_Tham\z:}', "");;
    Expect(0, 6830, '\p{Script_Extensions=:\ATai_Tham\z:}', "");;
    Expect(1, 6829, '\p{Script_Extensions=taitham}', "");
    Expect(0, 6829, '\p{^Script_Extensions=taitham}', "");
    Expect(0, 6829, '\P{Script_Extensions=taitham}', "");
    Expect(1, 6829, '\P{^Script_Extensions=taitham}', "");
    Expect(0, 6830, '\p{Script_Extensions=taitham}', "");
    Expect(1, 6830, '\p{^Script_Extensions=taitham}', "");
    Expect(1, 6830, '\P{Script_Extensions=taitham}', "");
    Expect(0, 6830, '\P{^Script_Extensions=taitham}', "");
    Expect(1, 6829, '\p{Script_Extensions=:\Ataitham\z:}', "");;
    Expect(0, 6830, '\p{Script_Extensions=:\Ataitham\z:}', "");;
    Expect(1, 6829, '\p{Script_Extensions=  tai_Tham}', "");
    Expect(0, 6829, '\p{^Script_Extensions=  tai_Tham}', "");
    Expect(0, 6829, '\P{Script_Extensions=  tai_Tham}', "");
    Expect(1, 6829, '\P{^Script_Extensions=  tai_Tham}', "");
    Expect(0, 6830, '\p{Script_Extensions=  tai_Tham}', "");
    Expect(1, 6830, '\p{^Script_Extensions=  tai_Tham}', "");
    Expect(1, 6830, '\P{Script_Extensions=  tai_Tham}', "");
    Expect(0, 6830, '\P{^Script_Extensions=  tai_Tham}', "");
    Error('\p{Scx=	-LANA:=}');
    Error('\P{Scx=	-LANA:=}');
    Expect(1, 6829, '\p{Scx=:\ALana\z:}', "");;
    Expect(0, 6830, '\p{Scx=:\ALana\z:}', "");;
    Expect(1, 6829, '\p{Scx: lana}', "");
    Expect(0, 6829, '\p{^Scx: lana}', "");
    Expect(0, 6829, '\P{Scx: lana}', "");
    Expect(1, 6829, '\P{^Scx: lana}', "");
    Expect(0, 6830, '\p{Scx: lana}', "");
    Expect(1, 6830, '\p{^Scx: lana}', "");
    Expect(1, 6830, '\P{Scx: lana}', "");
    Expect(0, 6830, '\P{^Scx: lana}', "");
    Expect(1, 6829, '\p{Scx=:\Alana\z:}', "");;
    Expect(0, 6830, '\p{Scx=:\Alana\z:}', "");;
    Expect(1, 6829, '\p{Scx=_Lana}', "");
    Expect(0, 6829, '\p{^Scx=_Lana}', "");
    Expect(0, 6829, '\P{Scx=_Lana}', "");
    Expect(1, 6829, '\P{^Scx=_Lana}', "");
    Expect(0, 6830, '\p{Scx=_Lana}', "");
    Expect(1, 6830, '\p{^Scx=_Lana}', "");
    Expect(1, 6830, '\P{Scx=_Lana}', "");
    Expect(0, 6830, '\P{^Scx=_Lana}', "");
    Error('\p{Is_Script_Extensions= _Tai_Tham:=}');
    Error('\P{Is_Script_Extensions= _Tai_Tham:=}');
    Expect(1, 6829, '\p{Is_Script_Extensions=taitham}', "");
    Expect(0, 6829, '\p{^Is_Script_Extensions=taitham}', "");
    Expect(0, 6829, '\P{Is_Script_Extensions=taitham}', "");
    Expect(1, 6829, '\P{^Is_Script_Extensions=taitham}', "");
    Expect(0, 6830, '\p{Is_Script_Extensions=taitham}', "");
    Expect(1, 6830, '\p{^Is_Script_Extensions=taitham}', "");
    Expect(1, 6830, '\P{Is_Script_Extensions=taitham}', "");
    Expect(0, 6830, '\P{^Is_Script_Extensions=taitham}', "");
    Expect(1, 6829, '\p{Is_Script_Extensions= -Tai_THAM}', "");
    Expect(0, 6829, '\p{^Is_Script_Extensions= -Tai_THAM}', "");
    Expect(0, 6829, '\P{Is_Script_Extensions= -Tai_THAM}', "");
    Expect(1, 6829, '\P{^Is_Script_Extensions= -Tai_THAM}', "");
    Expect(0, 6830, '\p{Is_Script_Extensions= -Tai_THAM}', "");
    Expect(1, 6830, '\p{^Is_Script_Extensions= -Tai_THAM}', "");
    Expect(1, 6830, '\P{Is_Script_Extensions= -Tai_THAM}', "");
    Expect(0, 6830, '\P{^Is_Script_Extensions= -Tai_THAM}', "");
    Error('\p{Is_Scx:   :=_LANA}');
    Error('\P{Is_Scx:   :=_LANA}');
    Expect(1, 6829, '\p{Is_Scx=lana}', "");
    Expect(0, 6829, '\p{^Is_Scx=lana}', "");
    Expect(0, 6829, '\P{Is_Scx=lana}', "");
    Expect(1, 6829, '\P{^Is_Scx=lana}', "");
    Expect(0, 6830, '\p{Is_Scx=lana}', "");
    Expect(1, 6830, '\p{^Is_Scx=lana}', "");
    Expect(1, 6830, '\P{Is_Scx=lana}', "");
    Expect(0, 6830, '\P{^Is_Scx=lana}', "");
    Expect(1, 6829, '\p{Is_Scx:   _ lana}', "");
    Expect(0, 6829, '\p{^Is_Scx:   _ lana}', "");
    Expect(0, 6829, '\P{Is_Scx:   _ lana}', "");
    Expect(1, 6829, '\P{^Is_Scx:   _ lana}', "");
    Expect(0, 6830, '\p{Is_Scx:   _ lana}', "");
    Expect(1, 6830, '\p{^Is_Scx:   _ lana}', "");
    Expect(1, 6830, '\P{Is_Scx:   _ lana}', "");
    Expect(0, 6830, '\P{^Is_Scx:   _ lana}', "");
    Error('\p{Script_Extensions:   	/a/LAO}');
    Error('\P{Script_Extensions:   	/a/LAO}');
    Expect(1, 3807, '\p{Script_Extensions=:\ALao\z:}', "");;
    Expect(0, 3808, '\p{Script_Extensions=:\ALao\z:}', "");;
    Expect(1, 3807, '\p{Script_Extensions=lao}', "");
    Expect(0, 3807, '\p{^Script_Extensions=lao}', "");
    Expect(0, 3807, '\P{Script_Extensions=lao}', "");
    Expect(1, 3807, '\P{^Script_Extensions=lao}', "");
    Expect(0, 3808, '\p{Script_Extensions=lao}', "");
    Expect(1, 3808, '\p{^Script_Extensions=lao}', "");
    Expect(1, 3808, '\P{Script_Extensions=lao}', "");
    Expect(0, 3808, '\P{^Script_Extensions=lao}', "");
    Expect(1, 3807, '\p{Script_Extensions=:\Alao\z:}', "");;
    Expect(0, 3808, '\p{Script_Extensions=:\Alao\z:}', "");;
    Expect(1, 3807, '\p{Script_Extensions= 	Lao}', "");
    Expect(0, 3807, '\p{^Script_Extensions= 	Lao}', "");
    Expect(0, 3807, '\P{Script_Extensions= 	Lao}', "");
    Expect(1, 3807, '\P{^Script_Extensions= 	Lao}', "");
    Expect(0, 3808, '\p{Script_Extensions= 	Lao}', "");
    Expect(1, 3808, '\p{^Script_Extensions= 	Lao}', "");
    Expect(1, 3808, '\P{Script_Extensions= 	Lao}', "");
    Expect(0, 3808, '\P{^Script_Extensions= 	Lao}', "");
    Error('\p{Scx=		LAOO/a/}');
    Error('\P{Scx=		LAOO/a/}');
    Expect(1, 3807, '\p{Scx=:\ALaoo\z:}', "");;
    Expect(0, 3808, '\p{Scx=:\ALaoo\z:}', "");;
    Expect(1, 3807, '\p{Scx=laoo}', "");
    Expect(0, 3807, '\p{^Scx=laoo}', "");
    Expect(0, 3807, '\P{Scx=laoo}', "");
    Expect(1, 3807, '\P{^Scx=laoo}', "");
    Expect(0, 3808, '\p{Scx=laoo}', "");
    Expect(1, 3808, '\p{^Scx=laoo}', "");
    Expect(1, 3808, '\P{Scx=laoo}', "");
    Expect(0, 3808, '\P{^Scx=laoo}', "");
    Expect(1, 3807, '\p{Scx=:\Alaoo\z:}', "");;
    Expect(0, 3808, '\p{Scx=:\Alaoo\z:}', "");;
    Expect(1, 3807, '\p{Scx=	LAOO}', "");
    Expect(0, 3807, '\p{^Scx=	LAOO}', "");
    Expect(0, 3807, '\P{Scx=	LAOO}', "");
    Expect(1, 3807, '\P{^Scx=	LAOO}', "");
    Expect(0, 3808, '\p{Scx=	LAOO}', "");
    Expect(1, 3808, '\p{^Scx=	LAOO}', "");
    Expect(1, 3808, '\P{Scx=	LAOO}', "");
    Expect(0, 3808, '\P{^Scx=	LAOO}', "");
    Error('\p{Is_Script_Extensions: /a/lao}');
    Error('\P{Is_Script_Extensions: /a/lao}');
    Expect(1, 3807, '\p{Is_Script_Extensions=lao}', "");
    Expect(0, 3807, '\p{^Is_Script_Extensions=lao}', "");
    Expect(0, 3807, '\P{Is_Script_Extensions=lao}', "");
    Expect(1, 3807, '\P{^Is_Script_Extensions=lao}', "");
    Expect(0, 3808, '\p{Is_Script_Extensions=lao}', "");
    Expect(1, 3808, '\p{^Is_Script_Extensions=lao}', "");
    Expect(1, 3808, '\P{Is_Script_Extensions=lao}', "");
    Expect(0, 3808, '\P{^Is_Script_Extensions=lao}', "");
    Expect(1, 3807, '\p{Is_Script_Extensions=  lao}', "");
    Expect(0, 3807, '\p{^Is_Script_Extensions=  lao}', "");
    Expect(0, 3807, '\P{Is_Script_Extensions=  lao}', "");
    Expect(1, 3807, '\P{^Is_Script_Extensions=  lao}', "");
    Expect(0, 3808, '\p{Is_Script_Extensions=  lao}', "");
    Expect(1, 3808, '\p{^Is_Script_Extensions=  lao}', "");
    Expect(1, 3808, '\P{Is_Script_Extensions=  lao}', "");
    Expect(0, 3808, '\P{^Is_Script_Extensions=  lao}', "");
    Error('\p{Is_Scx= /a/laoo}');
    Error('\P{Is_Scx= /a/laoo}');
    Expect(1, 3807, '\p{Is_Scx=laoo}', "");
    Expect(0, 3807, '\p{^Is_Scx=laoo}', "");
    Expect(0, 3807, '\P{Is_Scx=laoo}', "");
    Expect(1, 3807, '\P{^Is_Scx=laoo}', "");
    Expect(0, 3808, '\p{Is_Scx=laoo}', "");
    Expect(1, 3808, '\p{^Is_Scx=laoo}', "");
    Expect(1, 3808, '\P{Is_Scx=laoo}', "");
    Expect(0, 3808, '\P{^Is_Scx=laoo}', "");
    Expect(1, 3807, '\p{Is_Scx=  Laoo}', "");
    Expect(0, 3807, '\p{^Is_Scx=  Laoo}', "");
    Expect(0, 3807, '\P{Is_Scx=  Laoo}', "");
    Expect(1, 3807, '\P{^Is_Scx=  Laoo}', "");
    Expect(0, 3808, '\p{Is_Scx=  Laoo}', "");
    Expect(1, 3808, '\p{^Is_Scx=  Laoo}', "");
    Expect(1, 3808, '\P{Is_Scx=  Laoo}', "");
    Expect(0, 3808, '\P{^Is_Scx=  Laoo}', "");
    Error('\p{Script_Extensions=_	LATIN:=}');
    Error('\P{Script_Extensions=_	LATIN:=}');
    Expect(1, 122666, '\p{Script_Extensions=:\ALatin\z:}', "");;
    Expect(0, 122667, '\p{Script_Extensions=:\ALatin\z:}', "");;
    Expect(1, 122666, '\p{Script_Extensions=latin}', "");
    Expect(0, 122666, '\p{^Script_Extensions=latin}', "");
    Expect(0, 122666, '\P{Script_Extensions=latin}', "");
    Expect(1, 122666, '\P{^Script_Extensions=latin}', "");
    Expect(0, 122667, '\p{Script_Extensions=latin}', "");
    Expect(1, 122667, '\p{^Script_Extensions=latin}', "");
    Expect(1, 122667, '\P{Script_Extensions=latin}', "");
    Expect(0, 122667, '\P{^Script_Extensions=latin}', "");
    Expect(1, 122666, '\p{Script_Extensions=:\Alatin\z:}', "");;
    Expect(0, 122667, '\p{Script_Extensions=:\Alatin\z:}', "");;
    Expect(1, 122666, '\p{Script_Extensions=_	Latin}', "");
    Expect(0, 122666, '\p{^Script_Extensions=_	Latin}', "");
    Expect(0, 122666, '\P{Script_Extensions=_	Latin}', "");
    Expect(1, 122666, '\P{^Script_Extensions=_	Latin}', "");
    Expect(0, 122667, '\p{Script_Extensions=_	Latin}', "");
    Expect(1, 122667, '\p{^Script_Extensions=_	Latin}', "");
    Expect(1, 122667, '\P{Script_Extensions=_	Latin}', "");
    Expect(0, 122667, '\P{^Script_Extensions=_	Latin}', "");
    Error('\p{Scx=/a/- Latn}');
    Error('\P{Scx=/a/- Latn}');
    Expect(1, 122666, '\p{Scx=:\ALatn\z:}', "");;
    Expect(0, 122667, '\p{Scx=:\ALatn\z:}', "");;
    Expect(1, 122666, '\p{Scx=latn}', "");
    Expect(0, 122666, '\p{^Scx=latn}', "");
    Expect(0, 122666, '\P{Scx=latn}', "");
    Expect(1, 122666, '\P{^Scx=latn}', "");
    Expect(0, 122667, '\p{Scx=latn}', "");
    Expect(1, 122667, '\p{^Scx=latn}', "");
    Expect(1, 122667, '\P{Scx=latn}', "");
    Expect(0, 122667, '\P{^Scx=latn}', "");
    Expect(1, 122666, '\p{Scx=:\Alatn\z:}', "");;
    Expect(0, 122667, '\p{Scx=:\Alatn\z:}', "");;
    Expect(1, 122666, '\p{Scx=	 latn}', "");
    Expect(0, 122666, '\p{^Scx=	 latn}', "");
    Expect(0, 122666, '\P{Scx=	 latn}', "");
    Expect(1, 122666, '\P{^Scx=	 latn}', "");
    Expect(0, 122667, '\p{Scx=	 latn}', "");
    Expect(1, 122667, '\p{^Scx=	 latn}', "");
    Expect(1, 122667, '\P{Scx=	 latn}', "");
    Expect(0, 122667, '\P{^Scx=	 latn}', "");
    Error('\p{Is_Script_Extensions=	/a/Latin}');
    Error('\P{Is_Script_Extensions=	/a/Latin}');
    Expect(1, 122666, '\p{Is_Script_Extensions: latin}', "");
    Expect(0, 122666, '\p{^Is_Script_Extensions: latin}', "");
    Expect(0, 122666, '\P{Is_Script_Extensions: latin}', "");
    Expect(1, 122666, '\P{^Is_Script_Extensions: latin}', "");
    Expect(0, 122667, '\p{Is_Script_Extensions: latin}', "");
    Expect(1, 122667, '\p{^Is_Script_Extensions: latin}', "");
    Expect(1, 122667, '\P{Is_Script_Extensions: latin}', "");
    Expect(0, 122667, '\P{^Is_Script_Extensions: latin}', "");
    Expect(1, 122666, '\p{Is_Script_Extensions=- Latin}', "");
    Expect(0, 122666, '\p{^Is_Script_Extensions=- Latin}', "");
    Expect(0, 122666, '\P{Is_Script_Extensions=- Latin}', "");
    Expect(1, 122666, '\P{^Is_Script_Extensions=- Latin}', "");
    Expect(0, 122667, '\p{Is_Script_Extensions=- Latin}', "");
    Expect(1, 122667, '\p{^Is_Script_Extensions=- Latin}', "");
    Expect(1, 122667, '\P{Is_Script_Extensions=- Latin}', "");
    Expect(0, 122667, '\P{^Is_Script_Extensions=- Latin}', "");
    Error('\p{Is_Scx=:=Latn}');
    Error('\P{Is_Scx=:=Latn}');
    Expect(1, 122666, '\p{Is_Scx=latn}', "");
    Expect(0, 122666, '\p{^Is_Scx=latn}', "");
    Expect(0, 122666, '\P{Is_Scx=latn}', "");
    Expect(1, 122666, '\P{^Is_Scx=latn}', "");
    Expect(0, 122667, '\p{Is_Scx=latn}', "");
    Expect(1, 122667, '\p{^Is_Scx=latn}', "");
    Expect(1, 122667, '\P{Is_Scx=latn}', "");
    Expect(0, 122667, '\P{^Is_Scx=latn}', "");
    Expect(1, 122666, '\p{Is_Scx=_	Latn}', "");
    Expect(0, 122666, '\p{^Is_Scx=_	Latn}', "");
    Expect(0, 122666, '\P{Is_Scx=_	Latn}', "");
    Expect(1, 122666, '\P{^Is_Scx=_	Latn}', "");
    Expect(0, 122667, '\p{Is_Scx=_	Latn}', "");
    Expect(1, 122667, '\p{^Is_Scx=_	Latn}', "");
    Expect(1, 122667, '\P{Is_Scx=_	Latn}', "");
    Expect(0, 122667, '\P{^Is_Scx=_	Latn}', "");
    Error('\p{Script_Extensions= /a/Lepcha}');
    Error('\P{Script_Extensions= /a/Lepcha}');
    Expect(1, 7247, '\p{Script_Extensions=:\ALepcha\z:}', "");;
    Expect(0, 7248, '\p{Script_Extensions=:\ALepcha\z:}', "");;
    Expect(1, 7247, '\p{Script_Extensions:lepcha}', "");
    Expect(0, 7247, '\p{^Script_Extensions:lepcha}', "");
    Expect(0, 7247, '\P{Script_Extensions:lepcha}', "");
    Expect(1, 7247, '\P{^Script_Extensions:lepcha}', "");
    Expect(0, 7248, '\p{Script_Extensions:lepcha}', "");
    Expect(1, 7248, '\p{^Script_Extensions:lepcha}', "");
    Expect(1, 7248, '\P{Script_Extensions:lepcha}', "");
    Expect(0, 7248, '\P{^Script_Extensions:lepcha}', "");
    Expect(1, 7247, '\p{Script_Extensions=:\Alepcha\z:}', "");;
    Expect(0, 7248, '\p{Script_Extensions=:\Alepcha\z:}', "");;
    Expect(1, 7247, '\p{Script_Extensions=_LEPCHA}', "");
    Expect(0, 7247, '\p{^Script_Extensions=_LEPCHA}', "");
    Expect(0, 7247, '\P{Script_Extensions=_LEPCHA}', "");
    Expect(1, 7247, '\P{^Script_Extensions=_LEPCHA}', "");
    Expect(0, 7248, '\p{Script_Extensions=_LEPCHA}', "");
    Expect(1, 7248, '\p{^Script_Extensions=_LEPCHA}', "");
    Expect(1, 7248, '\P{Script_Extensions=_LEPCHA}', "");
    Expect(0, 7248, '\P{^Script_Extensions=_LEPCHA}', "");
    Error('\p{Scx:   /a/Lepc}');
    Error('\P{Scx:   /a/Lepc}');
    Expect(1, 7247, '\p{Scx=:\ALepc\z:}', "");;
    Expect(0, 7248, '\p{Scx=:\ALepc\z:}', "");;
    Expect(1, 7247, '\p{Scx=lepc}', "");
    Expect(0, 7247, '\p{^Scx=lepc}', "");
    Expect(0, 7247, '\P{Scx=lepc}', "");
    Expect(1, 7247, '\P{^Scx=lepc}', "");
    Expect(0, 7248, '\p{Scx=lepc}', "");
    Expect(1, 7248, '\p{^Scx=lepc}', "");
    Expect(1, 7248, '\P{Scx=lepc}', "");
    Expect(0, 7248, '\P{^Scx=lepc}', "");
    Expect(1, 7247, '\p{Scx=:\Alepc\z:}', "");;
    Expect(0, 7248, '\p{Scx=:\Alepc\z:}', "");;
    Expect(1, 7247, '\p{Scx=--lepc}', "");
    Expect(0, 7247, '\p{^Scx=--lepc}', "");
    Expect(0, 7247, '\P{Scx=--lepc}', "");
    Expect(1, 7247, '\P{^Scx=--lepc}', "");
    Expect(0, 7248, '\p{Scx=--lepc}', "");
    Expect(1, 7248, '\p{^Scx=--lepc}', "");
    Expect(1, 7248, '\P{Scx=--lepc}', "");
    Expect(0, 7248, '\P{^Scx=--lepc}', "");
    Error('\p{Is_Script_Extensions=--lepcha:=}');
    Error('\P{Is_Script_Extensions=--lepcha:=}');
    Expect(1, 7247, '\p{Is_Script_Extensions=lepcha}', "");
    Expect(0, 7247, '\p{^Is_Script_Extensions=lepcha}', "");
    Expect(0, 7247, '\P{Is_Script_Extensions=lepcha}', "");
    Expect(1, 7247, '\P{^Is_Script_Extensions=lepcha}', "");
    Expect(0, 7248, '\p{Is_Script_Extensions=lepcha}', "");
    Expect(1, 7248, '\p{^Is_Script_Extensions=lepcha}', "");
    Expect(1, 7248, '\P{Is_Script_Extensions=lepcha}', "");
    Expect(0, 7248, '\P{^Is_Script_Extensions=lepcha}', "");
    Expect(1, 7247, '\p{Is_Script_Extensions=-_LEPCHA}', "");
    Expect(0, 7247, '\p{^Is_Script_Extensions=-_LEPCHA}', "");
    Expect(0, 7247, '\P{Is_Script_Extensions=-_LEPCHA}', "");
    Expect(1, 7247, '\P{^Is_Script_Extensions=-_LEPCHA}', "");
    Expect(0, 7248, '\p{Is_Script_Extensions=-_LEPCHA}', "");
    Expect(1, 7248, '\p{^Is_Script_Extensions=-_LEPCHA}', "");
    Expect(1, 7248, '\P{Is_Script_Extensions=-_LEPCHA}', "");
    Expect(0, 7248, '\P{^Is_Script_Extensions=-_LEPCHA}', "");
    Error('\p{Is_Scx=-	lepc:=}');
    Error('\P{Is_Scx=-	lepc:=}');
    Expect(1, 7247, '\p{Is_Scx=lepc}', "");
    Expect(0, 7247, '\p{^Is_Scx=lepc}', "");
    Expect(0, 7247, '\P{Is_Scx=lepc}', "");
    Expect(1, 7247, '\P{^Is_Scx=lepc}', "");
    Expect(0, 7248, '\p{Is_Scx=lepc}', "");
    Expect(1, 7248, '\p{^Is_Scx=lepc}', "");
    Expect(1, 7248, '\P{Is_Scx=lepc}', "");
    Expect(0, 7248, '\P{^Is_Scx=lepc}', "");
    Expect(1, 7247, '\p{Is_Scx= _lepc}', "");
    Expect(0, 7247, '\p{^Is_Scx= _lepc}', "");
    Expect(0, 7247, '\P{Is_Scx= _lepc}', "");
    Expect(1, 7247, '\P{^Is_Scx= _lepc}', "");
    Expect(0, 7248, '\p{Is_Scx= _lepc}', "");
    Expect(1, 7248, '\p{^Is_Scx= _lepc}', "");
    Expect(1, 7248, '\P{Is_Scx= _lepc}', "");
    Expect(0, 7248, '\P{^Is_Scx= _lepc}', "");
    Error('\p{Script_Extensions=-:=limbu}');
    Error('\P{Script_Extensions=-:=limbu}');
    Expect(1, 6479, '\p{Script_Extensions=:\ALimbu\z:}', "");;
    Expect(0, 6480, '\p{Script_Extensions=:\ALimbu\z:}', "");;
    Expect(1, 6479, '\p{Script_Extensions:limbu}', "");
    Expect(0, 6479, '\p{^Script_Extensions:limbu}', "");
    Expect(0, 6479, '\P{Script_Extensions:limbu}', "");
    Expect(1, 6479, '\P{^Script_Extensions:limbu}', "");
    Expect(0, 6480, '\p{Script_Extensions:limbu}', "");
    Expect(1, 6480, '\p{^Script_Extensions:limbu}', "");
    Expect(1, 6480, '\P{Script_Extensions:limbu}', "");
    Expect(0, 6480, '\P{^Script_Extensions:limbu}', "");
    Expect(1, 6479, '\p{Script_Extensions=:\Alimbu\z:}', "");;
    Expect(0, 6480, '\p{Script_Extensions=:\Alimbu\z:}', "");;
    Expect(1, 6479, '\p{Script_Extensions=-limbu}', "");
    Expect(0, 6479, '\p{^Script_Extensions=-limbu}', "");
    Expect(0, 6479, '\P{Script_Extensions=-limbu}', "");
    Expect(1, 6479, '\P{^Script_Extensions=-limbu}', "");
    Expect(0, 6480, '\p{Script_Extensions=-limbu}', "");
    Expect(1, 6480, '\p{^Script_Extensions=-limbu}', "");
    Expect(1, 6480, '\P{Script_Extensions=-limbu}', "");
    Expect(0, 6480, '\P{^Script_Extensions=-limbu}', "");
    Error('\p{Scx=:=	_limb}');
    Error('\P{Scx=:=	_limb}');
    Expect(1, 6479, '\p{Scx=:\ALimb\z:}', "");;
    Expect(0, 6480, '\p{Scx=:\ALimb\z:}', "");;
    Expect(1, 6479, '\p{Scx=limb}', "");
    Expect(0, 6479, '\p{^Scx=limb}', "");
    Expect(0, 6479, '\P{Scx=limb}', "");
    Expect(1, 6479, '\P{^Scx=limb}', "");
    Expect(0, 6480, '\p{Scx=limb}', "");
    Expect(1, 6480, '\p{^Scx=limb}', "");
    Expect(1, 6480, '\P{Scx=limb}', "");
    Expect(0, 6480, '\P{^Scx=limb}', "");
    Expect(1, 6479, '\p{Scx=:\Alimb\z:}', "");;
    Expect(0, 6480, '\p{Scx=:\Alimb\z:}', "");;
    Expect(1, 6479, '\p{Scx=	-Limb}', "");
    Expect(0, 6479, '\p{^Scx=	-Limb}', "");
    Expect(0, 6479, '\P{Scx=	-Limb}', "");
    Expect(1, 6479, '\P{^Scx=	-Limb}', "");
    Expect(0, 6480, '\p{Scx=	-Limb}', "");
    Expect(1, 6480, '\p{^Scx=	-Limb}', "");
    Expect(1, 6480, '\P{Scx=	-Limb}', "");
    Expect(0, 6480, '\P{^Scx=	-Limb}', "");
    Error('\p{Is_Script_Extensions=_:=Limbu}');
    Error('\P{Is_Script_Extensions=_:=Limbu}');
    Expect(1, 6479, '\p{Is_Script_Extensions=limbu}', "");
    Expect(0, 6479, '\p{^Is_Script_Extensions=limbu}', "");
    Expect(0, 6479, '\P{Is_Script_Extensions=limbu}', "");
    Expect(1, 6479, '\P{^Is_Script_Extensions=limbu}', "");
    Expect(0, 6480, '\p{Is_Script_Extensions=limbu}', "");
    Expect(1, 6480, '\p{^Is_Script_Extensions=limbu}', "");
    Expect(1, 6480, '\P{Is_Script_Extensions=limbu}', "");
    Expect(0, 6480, '\P{^Is_Script_Extensions=limbu}', "");
    Expect(1, 6479, '\p{Is_Script_Extensions=	limbu}', "");
    Expect(0, 6479, '\p{^Is_Script_Extensions=	limbu}', "");
    Expect(0, 6479, '\P{Is_Script_Extensions=	limbu}', "");
    Expect(1, 6479, '\P{^Is_Script_Extensions=	limbu}', "");
    Expect(0, 6480, '\p{Is_Script_Extensions=	limbu}', "");
    Expect(1, 6480, '\p{^Is_Script_Extensions=	limbu}', "");
    Expect(1, 6480, '\P{Is_Script_Extensions=	limbu}', "");
    Expect(0, 6480, '\P{^Is_Script_Extensions=	limbu}', "");
    Error('\p{Is_Scx: :=Limb}');
    Error('\P{Is_Scx: :=Limb}');
    Expect(1, 6479, '\p{Is_Scx=limb}', "");
    Expect(0, 6479, '\p{^Is_Scx=limb}', "");
    Expect(0, 6479, '\P{Is_Scx=limb}', "");
    Expect(1, 6479, '\P{^Is_Scx=limb}', "");
    Expect(0, 6480, '\p{Is_Scx=limb}', "");
    Expect(1, 6480, '\p{^Is_Scx=limb}', "");
    Expect(1, 6480, '\P{Is_Scx=limb}', "");
    Expect(0, 6480, '\P{^Is_Scx=limb}', "");
    Expect(1, 6479, '\p{Is_Scx= 	limb}', "");
    Expect(0, 6479, '\p{^Is_Scx= 	limb}', "");
    Expect(0, 6479, '\P{Is_Scx= 	limb}', "");
    Expect(1, 6479, '\P{^Is_Scx= 	limb}', "");
    Expect(0, 6480, '\p{Is_Scx= 	limb}', "");
    Expect(1, 6480, '\p{^Is_Scx= 	limb}', "");
    Expect(1, 6480, '\P{Is_Scx= 	limb}', "");
    Expect(0, 6480, '\P{^Is_Scx= 	limb}', "");
    Error('\p{Script_Extensions=:=_LINEAR_A}');
    Error('\P{Script_Extensions=:=_LINEAR_A}');
    Expect(1, 67431, '\p{Script_Extensions=:\ALinear_A\z:}', "");;
    Expect(0, 67432, '\p{Script_Extensions=:\ALinear_A\z:}', "");;
    Expect(1, 67431, '\p{Script_Extensions=lineara}', "");
    Expect(0, 67431, '\p{^Script_Extensions=lineara}', "");
    Expect(0, 67431, '\P{Script_Extensions=lineara}', "");
    Expect(1, 67431, '\P{^Script_Extensions=lineara}', "");
    Expect(0, 67432, '\p{Script_Extensions=lineara}', "");
    Expect(1, 67432, '\p{^Script_Extensions=lineara}', "");
    Expect(1, 67432, '\P{Script_Extensions=lineara}', "");
    Expect(0, 67432, '\P{^Script_Extensions=lineara}', "");
    Expect(1, 67431, '\p{Script_Extensions=:\Alineara\z:}', "");;
    Expect(0, 67432, '\p{Script_Extensions=:\Alineara\z:}', "");;
    Expect(1, 67431, '\p{Script_Extensions=	-linear_A}', "");
    Expect(0, 67431, '\p{^Script_Extensions=	-linear_A}', "");
    Expect(0, 67431, '\P{Script_Extensions=	-linear_A}', "");
    Expect(1, 67431, '\P{^Script_Extensions=	-linear_A}', "");
    Expect(0, 67432, '\p{Script_Extensions=	-linear_A}', "");
    Expect(1, 67432, '\p{^Script_Extensions=	-linear_A}', "");
    Expect(1, 67432, '\P{Script_Extensions=	-linear_A}', "");
    Expect(0, 67432, '\P{^Script_Extensions=	-linear_A}', "");
    Error('\p{Scx= :=LINA}');
    Error('\P{Scx= :=LINA}');
    Expect(1, 67431, '\p{Scx=:\ALina\z:}', "");;
    Expect(0, 67432, '\p{Scx=:\ALina\z:}', "");;
    Expect(1, 67431, '\p{Scx=lina}', "");
    Expect(0, 67431, '\p{^Scx=lina}', "");
    Expect(0, 67431, '\P{Scx=lina}', "");
    Expect(1, 67431, '\P{^Scx=lina}', "");
    Expect(0, 67432, '\p{Scx=lina}', "");
    Expect(1, 67432, '\p{^Scx=lina}', "");
    Expect(1, 67432, '\P{Scx=lina}', "");
    Expect(0, 67432, '\P{^Scx=lina}', "");
    Expect(1, 67431, '\p{Scx=:\Alina\z:}', "");;
    Expect(0, 67432, '\p{Scx=:\Alina\z:}', "");;
    Expect(1, 67431, '\p{Scx=-	lina}', "");
    Expect(0, 67431, '\p{^Scx=-	lina}', "");
    Expect(0, 67431, '\P{Scx=-	lina}', "");
    Expect(1, 67431, '\P{^Scx=-	lina}', "");
    Expect(0, 67432, '\p{Scx=-	lina}', "");
    Expect(1, 67432, '\p{^Scx=-	lina}', "");
    Expect(1, 67432, '\P{Scx=-	lina}', "");
    Expect(0, 67432, '\P{^Scx=-	lina}', "");
    Error('\p{Is_Script_Extensions:	__Linear_A:=}');
    Error('\P{Is_Script_Extensions:	__Linear_A:=}');
    Expect(1, 67431, '\p{Is_Script_Extensions:lineara}', "");
    Expect(0, 67431, '\p{^Is_Script_Extensions:lineara}', "");
    Expect(0, 67431, '\P{Is_Script_Extensions:lineara}', "");
    Expect(1, 67431, '\P{^Is_Script_Extensions:lineara}', "");
    Expect(0, 67432, '\p{Is_Script_Extensions:lineara}', "");
    Expect(1, 67432, '\p{^Is_Script_Extensions:lineara}', "");
    Expect(1, 67432, '\P{Is_Script_Extensions:lineara}', "");
    Expect(0, 67432, '\P{^Is_Script_Extensions:lineara}', "");
    Expect(1, 67431, '\p{Is_Script_Extensions:   _-LINEAR_A}', "");
    Expect(0, 67431, '\p{^Is_Script_Extensions:   _-LINEAR_A}', "");
    Expect(0, 67431, '\P{Is_Script_Extensions:   _-LINEAR_A}', "");
    Expect(1, 67431, '\P{^Is_Script_Extensions:   _-LINEAR_A}', "");
    Expect(0, 67432, '\p{Is_Script_Extensions:   _-LINEAR_A}', "");
    Expect(1, 67432, '\p{^Is_Script_Extensions:   _-LINEAR_A}', "");
    Expect(1, 67432, '\P{Is_Script_Extensions:   _-LINEAR_A}', "");
    Expect(0, 67432, '\P{^Is_Script_Extensions:   _-LINEAR_A}', "");
    Error('\p{Is_Scx=:=- Lina}');
    Error('\P{Is_Scx=:=- Lina}');
    Expect(1, 67431, '\p{Is_Scx=lina}', "");
    Expect(0, 67431, '\p{^Is_Scx=lina}', "");
    Expect(0, 67431, '\P{Is_Scx=lina}', "");
    Expect(1, 67431, '\P{^Is_Scx=lina}', "");
    Expect(0, 67432, '\p{Is_Scx=lina}', "");
    Expect(1, 67432, '\p{^Is_Scx=lina}', "");
    Expect(1, 67432, '\P{Is_Scx=lina}', "");
    Expect(0, 67432, '\P{^Is_Scx=lina}', "");
    Expect(1, 67431, '\p{Is_Scx=_ LINA}', "");
    Expect(0, 67431, '\p{^Is_Scx=_ LINA}', "");
    Expect(0, 67431, '\P{Is_Scx=_ LINA}', "");
    Expect(1, 67431, '\P{^Is_Scx=_ LINA}', "");
    Expect(0, 67432, '\p{Is_Scx=_ LINA}', "");
    Expect(1, 67432, '\p{^Is_Scx=_ LINA}', "");
    Expect(1, 67432, '\P{Is_Scx=_ LINA}', "");
    Expect(0, 67432, '\P{^Is_Scx=_ LINA}', "");
    Error('\p{Script_Extensions=	linear_b/a/}');
    Error('\P{Script_Extensions=	linear_b/a/}');
    Expect(1, 65855, '\p{Script_Extensions=:\ALinear_B\z:}', "");;
    Expect(0, 65856, '\p{Script_Extensions=:\ALinear_B\z:}', "");;
    Expect(1, 65855, '\p{Script_Extensions=linearb}', "");
    Expect(0, 65855, '\p{^Script_Extensions=linearb}', "");
    Expect(0, 65855, '\P{Script_Extensions=linearb}', "");
    Expect(1, 65855, '\P{^Script_Extensions=linearb}', "");
    Expect(0, 65856, '\p{Script_Extensions=linearb}', "");
    Expect(1, 65856, '\p{^Script_Extensions=linearb}', "");
    Expect(1, 65856, '\P{Script_Extensions=linearb}', "");
    Expect(0, 65856, '\P{^Script_Extensions=linearb}', "");
    Expect(1, 65855, '\p{Script_Extensions=:\Alinearb\z:}', "");;
    Expect(0, 65856, '\p{Script_Extensions=:\Alinearb\z:}', "");;
    Expect(1, 65855, '\p{Script_Extensions=	linear_b}', "");
    Expect(0, 65855, '\p{^Script_Extensions=	linear_b}', "");
    Expect(0, 65855, '\P{Script_Extensions=	linear_b}', "");
    Expect(1, 65855, '\P{^Script_Extensions=	linear_b}', "");
    Expect(0, 65856, '\p{Script_Extensions=	linear_b}', "");
    Expect(1, 65856, '\p{^Script_Extensions=	linear_b}', "");
    Expect(1, 65856, '\P{Script_Extensions=	linear_b}', "");
    Expect(0, 65856, '\P{^Script_Extensions=	linear_b}', "");
    Error('\p{Scx=_-Linb/a/}');
    Error('\P{Scx=_-Linb/a/}');
    Expect(1, 65855, '\p{Scx=:\ALinb\z:}', "");;
    Expect(0, 65856, '\p{Scx=:\ALinb\z:}', "");;
    Expect(1, 65855, '\p{Scx=linb}', "");
    Expect(0, 65855, '\p{^Scx=linb}', "");
    Expect(0, 65855, '\P{Scx=linb}', "");
    Expect(1, 65855, '\P{^Scx=linb}', "");
    Expect(0, 65856, '\p{Scx=linb}', "");
    Expect(1, 65856, '\p{^Scx=linb}', "");
    Expect(1, 65856, '\P{Scx=linb}', "");
    Expect(0, 65856, '\P{^Scx=linb}', "");
    Expect(1, 65855, '\p{Scx=:\Alinb\z:}', "");;
    Expect(0, 65856, '\p{Scx=:\Alinb\z:}', "");;
    Error('\p{Is_Script_Extensions=-_linear_B:=}');
    Error('\P{Is_Script_Extensions=-_linear_B:=}');
    Expect(1, 65855, '\p{Is_Script_Extensions=linearb}', "");
    Expect(0, 65855, '\p{^Is_Script_Extensions=linearb}', "");
    Expect(0, 65855, '\P{Is_Script_Extensions=linearb}', "");
    Expect(1, 65855, '\P{^Is_Script_Extensions=linearb}', "");
    Expect(0, 65856, '\p{Is_Script_Extensions=linearb}', "");
    Expect(1, 65856, '\p{^Is_Script_Extensions=linearb}', "");
    Expect(1, 65856, '\P{Is_Script_Extensions=linearb}', "");
    Expect(0, 65856, '\P{^Is_Script_Extensions=linearb}', "");
    Expect(1, 65855, '\p{Is_Script_Extensions=Linear_B}', "");
    Expect(0, 65855, '\p{^Is_Script_Extensions=Linear_B}', "");
    Expect(0, 65855, '\P{Is_Script_Extensions=Linear_B}', "");
    Expect(1, 65855, '\P{^Is_Script_Extensions=Linear_B}', "");
    Expect(0, 65856, '\p{Is_Script_Extensions=Linear_B}', "");
    Expect(1, 65856, '\p{^Is_Script_Extensions=Linear_B}', "");
    Expect(1, 65856, '\P{Is_Script_Extensions=Linear_B}', "");
    Expect(0, 65856, '\P{^Is_Script_Extensions=Linear_B}', "");
    Error('\p{Is_Scx=	linb:=}');
    Error('\P{Is_Scx=	linb:=}');
    Expect(1, 65855, '\p{Is_Scx=linb}', "");
    Expect(0, 65855, '\p{^Is_Scx=linb}', "");
    Expect(0, 65855, '\P{Is_Scx=linb}', "");
    Expect(1, 65855, '\P{^Is_Scx=linb}', "");
    Expect(0, 65856, '\p{Is_Scx=linb}', "");
    Expect(1, 65856, '\p{^Is_Scx=linb}', "");
    Expect(1, 65856, '\P{Is_Scx=linb}', "");
    Expect(0, 65856, '\P{^Is_Scx=linb}', "");
    Expect(1, 65855, '\p{Is_Scx: 	-LINB}', "");
    Expect(0, 65855, '\p{^Is_Scx: 	-LINB}', "");
    Expect(0, 65855, '\P{Is_Scx: 	-LINB}', "");
    Expect(1, 65855, '\P{^Is_Scx: 	-LINB}', "");
    Expect(0, 65856, '\p{Is_Scx: 	-LINB}', "");
    Expect(1, 65856, '\p{^Is_Scx: 	-LINB}', "");
    Expect(1, 65856, '\P{Is_Scx: 	-LINB}', "");
    Expect(0, 65856, '\P{^Is_Scx: 	-LINB}', "");
    Error('\p{Script_Extensions:   /a/lisu}');
    Error('\P{Script_Extensions:   /a/lisu}');
    Expect(1, 73648, '\p{Script_Extensions=:\ALisu\z:}', "");;
    Expect(0, 73649, '\p{Script_Extensions=:\ALisu\z:}', "");;
    Expect(1, 73648, '\p{Script_Extensions=lisu}', "");
    Expect(0, 73648, '\p{^Script_Extensions=lisu}', "");
    Expect(0, 73648, '\P{Script_Extensions=lisu}', "");
    Expect(1, 73648, '\P{^Script_Extensions=lisu}', "");
    Expect(0, 73649, '\p{Script_Extensions=lisu}', "");
    Expect(1, 73649, '\p{^Script_Extensions=lisu}', "");
    Expect(1, 73649, '\P{Script_Extensions=lisu}', "");
    Expect(0, 73649, '\P{^Script_Extensions=lisu}', "");
    Expect(1, 73648, '\p{Script_Extensions=:\Alisu\z:}', "");;
    Expect(0, 73649, '\p{Script_Extensions=:\Alisu\z:}', "");;
    Expect(1, 73648, '\p{Script_Extensions=--LISU}', "");
    Expect(0, 73648, '\p{^Script_Extensions=--LISU}', "");
    Expect(0, 73648, '\P{Script_Extensions=--LISU}', "");
    Expect(1, 73648, '\P{^Script_Extensions=--LISU}', "");
    Expect(0, 73649, '\p{Script_Extensions=--LISU}', "");
    Expect(1, 73649, '\p{^Script_Extensions=--LISU}', "");
    Expect(1, 73649, '\P{Script_Extensions=--LISU}', "");
    Expect(0, 73649, '\P{^Script_Extensions=--LISU}', "");
    Error('\p{Scx=	Lisu:=}');
    Error('\P{Scx=	Lisu:=}');
    Expect(1, 73648, '\p{Scx=:\ALisu\z:}', "");;
    Expect(0, 73649, '\p{Scx=:\ALisu\z:}', "");;
    Expect(1, 73648, '\p{Scx=lisu}', "");
    Expect(0, 73648, '\p{^Scx=lisu}', "");
    Expect(0, 73648, '\P{Scx=lisu}', "");
    Expect(1, 73648, '\P{^Scx=lisu}', "");
    Expect(0, 73649, '\p{Scx=lisu}', "");
    Expect(1, 73649, '\p{^Scx=lisu}', "");
    Expect(1, 73649, '\P{Scx=lisu}', "");
    Expect(0, 73649, '\P{^Scx=lisu}', "");
    Expect(1, 73648, '\p{Scx=:\Alisu\z:}', "");;
    Expect(0, 73649, '\p{Scx=:\Alisu\z:}', "");;
    Expect(1, 73648, '\p{Scx=_-lisu}', "");
    Expect(0, 73648, '\p{^Scx=_-lisu}', "");
    Expect(0, 73648, '\P{Scx=_-lisu}', "");
    Expect(1, 73648, '\P{^Scx=_-lisu}', "");
    Expect(0, 73649, '\p{Scx=_-lisu}', "");
    Expect(1, 73649, '\p{^Scx=_-lisu}', "");
    Expect(1, 73649, '\P{Scx=_-lisu}', "");
    Expect(0, 73649, '\P{^Scx=_-lisu}', "");
    Error('\p{Is_Script_Extensions=/a/-lisu}');
    Error('\P{Is_Script_Extensions=/a/-lisu}');
    Expect(1, 73648, '\p{Is_Script_Extensions=lisu}', "");
    Expect(0, 73648, '\p{^Is_Script_Extensions=lisu}', "");
    Expect(0, 73648, '\P{Is_Script_Extensions=lisu}', "");
    Expect(1, 73648, '\P{^Is_Script_Extensions=lisu}', "");
    Expect(0, 73649, '\p{Is_Script_Extensions=lisu}', "");
    Expect(1, 73649, '\p{^Is_Script_Extensions=lisu}', "");
    Expect(1, 73649, '\P{Is_Script_Extensions=lisu}', "");
    Expect(0, 73649, '\P{^Is_Script_Extensions=lisu}', "");
    Expect(1, 73648, '\p{Is_Script_Extensions:   -_lisu}', "");
    Expect(0, 73648, '\p{^Is_Script_Extensions:   -_lisu}', "");
    Expect(0, 73648, '\P{Is_Script_Extensions:   -_lisu}', "");
    Expect(1, 73648, '\P{^Is_Script_Extensions:   -_lisu}', "");
    Expect(0, 73649, '\p{Is_Script_Extensions:   -_lisu}', "");
    Expect(1, 73649, '\p{^Is_Script_Extensions:   -_lisu}', "");
    Expect(1, 73649, '\P{Is_Script_Extensions:   -_lisu}', "");
    Expect(0, 73649, '\P{^Is_Script_Extensions:   -_lisu}', "");
    Error('\p{Is_Scx=	Lisu:=}');
    Error('\P{Is_Scx=	Lisu:=}');
    Expect(1, 73648, '\p{Is_Scx=lisu}', "");
    Expect(0, 73648, '\p{^Is_Scx=lisu}', "");
    Expect(0, 73648, '\P{Is_Scx=lisu}', "");
    Expect(1, 73648, '\P{^Is_Scx=lisu}', "");
    Expect(0, 73649, '\p{Is_Scx=lisu}', "");
    Expect(1, 73649, '\p{^Is_Scx=lisu}', "");
    Expect(1, 73649, '\P{Is_Scx=lisu}', "");
    Expect(0, 73649, '\P{^Is_Scx=lisu}', "");
    Expect(1, 73648, '\p{Is_Scx:	-LISU}', "");
    Expect(0, 73648, '\p{^Is_Scx:	-LISU}', "");
    Expect(0, 73648, '\P{Is_Scx:	-LISU}', "");
    Expect(1, 73648, '\P{^Is_Scx:	-LISU}', "");
    Expect(0, 73649, '\p{Is_Scx:	-LISU}', "");
    Expect(1, 73649, '\p{^Is_Scx:	-LISU}', "");
    Expect(1, 73649, '\P{Is_Scx:	-LISU}', "");
    Expect(0, 73649, '\P{^Is_Scx:	-LISU}', "");
    Error('\p{Script_Extensions=	:=lycian}');
    Error('\P{Script_Extensions=	:=lycian}');
    Expect(1, 66204, '\p{Script_Extensions=:\ALycian\z:}', "");;
    Expect(0, 66205, '\p{Script_Extensions=:\ALycian\z:}', "");;
    Expect(1, 66204, '\p{Script_Extensions=lycian}', "");
    Expect(0, 66204, '\p{^Script_Extensions=lycian}', "");
    Expect(0, 66204, '\P{Script_Extensions=lycian}', "");
    Expect(1, 66204, '\P{^Script_Extensions=lycian}', "");
    Expect(0, 66205, '\p{Script_Extensions=lycian}', "");
    Expect(1, 66205, '\p{^Script_Extensions=lycian}', "");
    Expect(1, 66205, '\P{Script_Extensions=lycian}', "");
    Expect(0, 66205, '\P{^Script_Extensions=lycian}', "");
    Expect(1, 66204, '\p{Script_Extensions=:\Alycian\z:}', "");;
    Expect(0, 66205, '\p{Script_Extensions=:\Alycian\z:}', "");;
    Expect(1, 66204, '\p{Script_Extensions=		Lycian}', "");
    Expect(0, 66204, '\p{^Script_Extensions=		Lycian}', "");
    Expect(0, 66204, '\P{Script_Extensions=		Lycian}', "");
    Expect(1, 66204, '\P{^Script_Extensions=		Lycian}', "");
    Expect(0, 66205, '\p{Script_Extensions=		Lycian}', "");
    Expect(1, 66205, '\p{^Script_Extensions=		Lycian}', "");
    Expect(1, 66205, '\P{Script_Extensions=		Lycian}', "");
    Expect(0, 66205, '\P{^Script_Extensions=		Lycian}', "");
    Error('\p{Scx=/a/- Lyci}');
    Error('\P{Scx=/a/- Lyci}');
    Expect(1, 66204, '\p{Scx=:\ALyci\z:}', "");;
    Expect(0, 66205, '\p{Scx=:\ALyci\z:}', "");;
    Expect(1, 66204, '\p{Scx=lyci}', "");
    Expect(0, 66204, '\p{^Scx=lyci}', "");
    Expect(0, 66204, '\P{Scx=lyci}', "");
    Expect(1, 66204, '\P{^Scx=lyci}', "");
    Expect(0, 66205, '\p{Scx=lyci}', "");
    Expect(1, 66205, '\p{^Scx=lyci}', "");
    Expect(1, 66205, '\P{Scx=lyci}', "");
    Expect(0, 66205, '\P{^Scx=lyci}', "");
    Expect(1, 66204, '\p{Scx=:\Alyci\z:}', "");;
    Expect(0, 66205, '\p{Scx=:\Alyci\z:}', "");;
    Expect(1, 66204, '\p{Scx=  lyci}', "");
    Expect(0, 66204, '\p{^Scx=  lyci}', "");
    Expect(0, 66204, '\P{Scx=  lyci}', "");
    Expect(1, 66204, '\P{^Scx=  lyci}', "");
    Expect(0, 66205, '\p{Scx=  lyci}', "");
    Expect(1, 66205, '\p{^Scx=  lyci}', "");
    Expect(1, 66205, '\P{Scx=  lyci}', "");
    Expect(0, 66205, '\P{^Scx=  lyci}', "");
    Error('\p{Is_Script_Extensions:   -:=Lycian}');
    Error('\P{Is_Script_Extensions:   -:=Lycian}');
    Expect(1, 66204, '\p{Is_Script_Extensions=lycian}', "");
    Expect(0, 66204, '\p{^Is_Script_Extensions=lycian}', "");
    Expect(0, 66204, '\P{Is_Script_Extensions=lycian}', "");
    Expect(1, 66204, '\P{^Is_Script_Extensions=lycian}', "");
    Expect(0, 66205, '\p{Is_Script_Extensions=lycian}', "");
    Expect(1, 66205, '\p{^Is_Script_Extensions=lycian}', "");
    Expect(1, 66205, '\P{Is_Script_Extensions=lycian}', "");
    Expect(0, 66205, '\P{^Is_Script_Extensions=lycian}', "");
    Expect(1, 66204, '\p{Is_Script_Extensions: 	-LYCIAN}', "");
    Expect(0, 66204, '\p{^Is_Script_Extensions: 	-LYCIAN}', "");
    Expect(0, 66204, '\P{Is_Script_Extensions: 	-LYCIAN}', "");
    Expect(1, 66204, '\P{^Is_Script_Extensions: 	-LYCIAN}', "");
    Expect(0, 66205, '\p{Is_Script_Extensions: 	-LYCIAN}', "");
    Expect(1, 66205, '\p{^Is_Script_Extensions: 	-LYCIAN}', "");
    Expect(1, 66205, '\P{Is_Script_Extensions: 	-LYCIAN}', "");
    Expect(0, 66205, '\P{^Is_Script_Extensions: 	-LYCIAN}', "");
    Error('\p{Is_Scx=	:=LYCI}');
    Error('\P{Is_Scx=	:=LYCI}');
    Expect(1, 66204, '\p{Is_Scx=lyci}', "");
    Expect(0, 66204, '\p{^Is_Scx=lyci}', "");
    Expect(0, 66204, '\P{Is_Scx=lyci}', "");
    Expect(1, 66204, '\P{^Is_Scx=lyci}', "");
    Expect(0, 66205, '\p{Is_Scx=lyci}', "");
    Expect(1, 66205, '\p{^Is_Scx=lyci}', "");
    Expect(1, 66205, '\P{Is_Scx=lyci}', "");
    Expect(0, 66205, '\P{^Is_Scx=lyci}', "");
    Expect(1, 66204, '\p{Is_Scx=  Lyci}', "");
    Expect(0, 66204, '\p{^Is_Scx=  Lyci}', "");
    Expect(0, 66204, '\P{Is_Scx=  Lyci}', "");
    Expect(1, 66204, '\P{^Is_Scx=  Lyci}', "");
    Expect(0, 66205, '\p{Is_Scx=  Lyci}', "");
    Expect(1, 66205, '\p{^Is_Scx=  Lyci}', "");
    Expect(1, 66205, '\P{Is_Scx=  Lyci}', "");
    Expect(0, 66205, '\P{^Is_Scx=  Lyci}', "");
    Error('\p{Script_Extensions=/a/ 	Lydian}');
    Error('\P{Script_Extensions=/a/ 	Lydian}');
    Expect(1, 67903, '\p{Script_Extensions=:\ALydian\z:}', "");;
    Expect(0, 67904, '\p{Script_Extensions=:\ALydian\z:}', "");;
    Expect(1, 67903, '\p{Script_Extensions=lydian}', "");
    Expect(0, 67903, '\p{^Script_Extensions=lydian}', "");
    Expect(0, 67903, '\P{Script_Extensions=lydian}', "");
    Expect(1, 67903, '\P{^Script_Extensions=lydian}', "");
    Expect(0, 67904, '\p{Script_Extensions=lydian}', "");
    Expect(1, 67904, '\p{^Script_Extensions=lydian}', "");
    Expect(1, 67904, '\P{Script_Extensions=lydian}', "");
    Expect(0, 67904, '\P{^Script_Extensions=lydian}', "");
    Expect(1, 67903, '\p{Script_Extensions=:\Alydian\z:}', "");;
    Expect(0, 67904, '\p{Script_Extensions=:\Alydian\z:}', "");;
    Expect(1, 67903, '\p{Script_Extensions=		Lydian}', "");
    Expect(0, 67903, '\p{^Script_Extensions=		Lydian}', "");
    Expect(0, 67903, '\P{Script_Extensions=		Lydian}', "");
    Expect(1, 67903, '\P{^Script_Extensions=		Lydian}', "");
    Expect(0, 67904, '\p{Script_Extensions=		Lydian}', "");
    Expect(1, 67904, '\p{^Script_Extensions=		Lydian}', "");
    Expect(1, 67904, '\P{Script_Extensions=		Lydian}', "");
    Expect(0, 67904, '\P{^Script_Extensions=		Lydian}', "");
    Error('\p{Scx=	:=lydi}');
    Error('\P{Scx=	:=lydi}');
    Expect(1, 67903, '\p{Scx=:\ALydi\z:}', "");;
    Expect(0, 67904, '\p{Scx=:\ALydi\z:}', "");;
    Expect(1, 67903, '\p{Scx=lydi}', "");
    Expect(0, 67903, '\p{^Scx=lydi}', "");
    Expect(0, 67903, '\P{Scx=lydi}', "");
    Expect(1, 67903, '\P{^Scx=lydi}', "");
    Expect(0, 67904, '\p{Scx=lydi}', "");
    Expect(1, 67904, '\p{^Scx=lydi}', "");
    Expect(1, 67904, '\P{Scx=lydi}', "");
    Expect(0, 67904, '\P{^Scx=lydi}', "");
    Expect(1, 67903, '\p{Scx=:\Alydi\z:}', "");;
    Expect(0, 67904, '\p{Scx=:\Alydi\z:}', "");;
    Expect(1, 67903, '\p{Scx=-_Lydi}', "");
    Expect(0, 67903, '\p{^Scx=-_Lydi}', "");
    Expect(0, 67903, '\P{Scx=-_Lydi}', "");
    Expect(1, 67903, '\P{^Scx=-_Lydi}', "");
    Expect(0, 67904, '\p{Scx=-_Lydi}', "");
    Expect(1, 67904, '\p{^Scx=-_Lydi}', "");
    Expect(1, 67904, '\P{Scx=-_Lydi}', "");
    Expect(0, 67904, '\P{^Scx=-_Lydi}', "");
    Error('\p{Is_Script_Extensions=	-Lydian/a/}');
    Error('\P{Is_Script_Extensions=	-Lydian/a/}');
    Expect(1, 67903, '\p{Is_Script_Extensions=lydian}', "");
    Expect(0, 67903, '\p{^Is_Script_Extensions=lydian}', "");
    Expect(0, 67903, '\P{Is_Script_Extensions=lydian}', "");
    Expect(1, 67903, '\P{^Is_Script_Extensions=lydian}', "");
    Expect(0, 67904, '\p{Is_Script_Extensions=lydian}', "");
    Expect(1, 67904, '\p{^Is_Script_Extensions=lydian}', "");
    Expect(1, 67904, '\P{Is_Script_Extensions=lydian}', "");
    Expect(0, 67904, '\P{^Is_Script_Extensions=lydian}', "");
    Expect(1, 67903, '\p{Is_Script_Extensions=_lydian}', "");
    Expect(0, 67903, '\p{^Is_Script_Extensions=_lydian}', "");
    Expect(0, 67903, '\P{Is_Script_Extensions=_lydian}', "");
    Expect(1, 67903, '\P{^Is_Script_Extensions=_lydian}', "");
    Expect(0, 67904, '\p{Is_Script_Extensions=_lydian}', "");
    Expect(1, 67904, '\p{^Is_Script_Extensions=_lydian}', "");
    Expect(1, 67904, '\P{Is_Script_Extensions=_lydian}', "");
    Expect(0, 67904, '\P{^Is_Script_Extensions=_lydian}', "");
    Error('\p{Is_Scx=:=Lydi}');
    Error('\P{Is_Scx=:=Lydi}');
    Expect(1, 67903, '\p{Is_Scx=lydi}', "");
    Expect(0, 67903, '\p{^Is_Scx=lydi}', "");
    Expect(0, 67903, '\P{Is_Scx=lydi}', "");
    Expect(1, 67903, '\P{^Is_Scx=lydi}', "");
    Expect(0, 67904, '\p{Is_Scx=lydi}', "");
    Expect(1, 67904, '\p{^Is_Scx=lydi}', "");
    Expect(1, 67904, '\P{Is_Scx=lydi}', "");
    Expect(0, 67904, '\P{^Is_Scx=lydi}', "");
    Expect(1, 67903, '\p{Is_Scx=_	Lydi}', "");
    Expect(0, 67903, '\p{^Is_Scx=_	Lydi}', "");
    Expect(0, 67903, '\P{Is_Scx=_	Lydi}', "");
    Expect(1, 67903, '\P{^Is_Scx=_	Lydi}', "");
    Expect(0, 67904, '\p{Is_Scx=_	Lydi}', "");
    Expect(1, 67904, '\p{^Is_Scx=_	Lydi}', "");
    Expect(1, 67904, '\P{Is_Scx=_	Lydi}', "");
    Expect(0, 67904, '\P{^Is_Scx=_	Lydi}', "");
    Error('\p{Script_Extensions=_:=MAHAJANI}');
    Error('\P{Script_Extensions=_:=MAHAJANI}');
    Expect(1, 70006, '\p{Script_Extensions=:\AMahajani\z:}', "");;
    Expect(0, 70007, '\p{Script_Extensions=:\AMahajani\z:}', "");;
    Expect(1, 70006, '\p{Script_Extensions: mahajani}', "");
    Expect(0, 70006, '\p{^Script_Extensions: mahajani}', "");
    Expect(0, 70006, '\P{Script_Extensions: mahajani}', "");
    Expect(1, 70006, '\P{^Script_Extensions: mahajani}', "");
    Expect(0, 70007, '\p{Script_Extensions: mahajani}', "");
    Expect(1, 70007, '\p{^Script_Extensions: mahajani}', "");
    Expect(1, 70007, '\P{Script_Extensions: mahajani}', "");
    Expect(0, 70007, '\P{^Script_Extensions: mahajani}', "");
    Expect(1, 70006, '\p{Script_Extensions=:\Amahajani\z:}', "");;
    Expect(0, 70007, '\p{Script_Extensions=:\Amahajani\z:}', "");;
    Expect(1, 70006, '\p{Script_Extensions=-mahajani}', "");
    Expect(0, 70006, '\p{^Script_Extensions=-mahajani}', "");
    Expect(0, 70006, '\P{Script_Extensions=-mahajani}', "");
    Expect(1, 70006, '\P{^Script_Extensions=-mahajani}', "");
    Expect(0, 70007, '\p{Script_Extensions=-mahajani}', "");
    Expect(1, 70007, '\p{^Script_Extensions=-mahajani}', "");
    Expect(1, 70007, '\P{Script_Extensions=-mahajani}', "");
    Expect(0, 70007, '\P{^Script_Extensions=-mahajani}', "");
    Error('\p{Scx=-	Mahj:=}');
    Error('\P{Scx=-	Mahj:=}');
    Expect(1, 70006, '\p{Scx=:\AMahj\z:}', "");;
    Expect(0, 70007, '\p{Scx=:\AMahj\z:}', "");;
    Expect(1, 70006, '\p{Scx=mahj}', "");
    Expect(0, 70006, '\p{^Scx=mahj}', "");
    Expect(0, 70006, '\P{Scx=mahj}', "");
    Expect(1, 70006, '\P{^Scx=mahj}', "");
    Expect(0, 70007, '\p{Scx=mahj}', "");
    Expect(1, 70007, '\p{^Scx=mahj}', "");
    Expect(1, 70007, '\P{Scx=mahj}', "");
    Expect(0, 70007, '\P{^Scx=mahj}', "");
    Expect(1, 70006, '\p{Scx=:\Amahj\z:}', "");;
    Expect(0, 70007, '\p{Scx=:\Amahj\z:}', "");;
    Expect(1, 70006, '\p{Scx= _Mahj}', "");
    Expect(0, 70006, '\p{^Scx= _Mahj}', "");
    Expect(0, 70006, '\P{Scx= _Mahj}', "");
    Expect(1, 70006, '\P{^Scx= _Mahj}', "");
    Expect(0, 70007, '\p{Scx= _Mahj}', "");
    Expect(1, 70007, '\p{^Scx= _Mahj}', "");
    Expect(1, 70007, '\P{Scx= _Mahj}', "");
    Expect(0, 70007, '\P{^Scx= _Mahj}', "");
    Error('\p{Is_Script_Extensions:		 Mahajani:=}');
    Error('\P{Is_Script_Extensions:		 Mahajani:=}');
    Expect(1, 70006, '\p{Is_Script_Extensions=mahajani}', "");
    Expect(0, 70006, '\p{^Is_Script_Extensions=mahajani}', "");
    Expect(0, 70006, '\P{Is_Script_Extensions=mahajani}', "");
    Expect(1, 70006, '\P{^Is_Script_Extensions=mahajani}', "");
    Expect(0, 70007, '\p{Is_Script_Extensions=mahajani}', "");
    Expect(1, 70007, '\p{^Is_Script_Extensions=mahajani}', "");
    Expect(1, 70007, '\P{Is_Script_Extensions=mahajani}', "");
    Expect(0, 70007, '\P{^Is_Script_Extensions=mahajani}', "");
    Expect(1, 70006, '\p{Is_Script_Extensions:   -MAHAJANI}', "");
    Expect(0, 70006, '\p{^Is_Script_Extensions:   -MAHAJANI}', "");
    Expect(0, 70006, '\P{Is_Script_Extensions:   -MAHAJANI}', "");
    Expect(1, 70006, '\P{^Is_Script_Extensions:   -MAHAJANI}', "");
    Expect(0, 70007, '\p{Is_Script_Extensions:   -MAHAJANI}', "");
    Expect(1, 70007, '\p{^Is_Script_Extensions:   -MAHAJANI}', "");
    Expect(1, 70007, '\P{Is_Script_Extensions:   -MAHAJANI}', "");
    Expect(0, 70007, '\P{^Is_Script_Extensions:   -MAHAJANI}', "");
    Error('\p{Is_Scx=	/a/MAHJ}');
    Error('\P{Is_Scx=	/a/MAHJ}');
    Expect(1, 70006, '\p{Is_Scx=mahj}', "");
    Expect(0, 70006, '\p{^Is_Scx=mahj}', "");
    Expect(0, 70006, '\P{Is_Scx=mahj}', "");
    Expect(1, 70006, '\P{^Is_Scx=mahj}', "");
    Expect(0, 70007, '\p{Is_Scx=mahj}', "");
    Expect(1, 70007, '\p{^Is_Scx=mahj}', "");
    Expect(1, 70007, '\P{Is_Scx=mahj}', "");
    Expect(0, 70007, '\P{^Is_Scx=mahj}', "");
    Expect(1, 70006, '\p{Is_Scx= _mahj}', "");
    Expect(0, 70006, '\p{^Is_Scx= _mahj}', "");
    Expect(0, 70006, '\P{Is_Scx= _mahj}', "");
    Expect(1, 70006, '\P{^Is_Scx= _mahj}', "");
    Expect(0, 70007, '\p{Is_Scx= _mahj}', "");
    Expect(1, 70007, '\p{^Is_Scx= _mahj}', "");
    Expect(1, 70007, '\P{Is_Scx= _mahj}', "");
    Expect(0, 70007, '\P{^Is_Scx= _mahj}', "");
    Error('\p{Script_Extensions: :=	-makasar}');
    Error('\P{Script_Extensions: :=	-makasar}');
    Expect(1, 73464, '\p{Script_Extensions=:\AMakasar\z:}', "");;
    Expect(0, 73465, '\p{Script_Extensions=:\AMakasar\z:}', "");;
    Expect(1, 73464, '\p{Script_Extensions=makasar}', "");
    Expect(0, 73464, '\p{^Script_Extensions=makasar}', "");
    Expect(0, 73464, '\P{Script_Extensions=makasar}', "");
    Expect(1, 73464, '\P{^Script_Extensions=makasar}', "");
    Expect(0, 73465, '\p{Script_Extensions=makasar}', "");
    Expect(1, 73465, '\p{^Script_Extensions=makasar}', "");
    Expect(1, 73465, '\P{Script_Extensions=makasar}', "");
    Expect(0, 73465, '\P{^Script_Extensions=makasar}', "");
    Expect(1, 73464, '\p{Script_Extensions=:\Amakasar\z:}', "");;
    Expect(0, 73465, '\p{Script_Extensions=:\Amakasar\z:}', "");;
    Expect(1, 73464, '\p{Script_Extensions=  Makasar}', "");
    Expect(0, 73464, '\p{^Script_Extensions=  Makasar}', "");
    Expect(0, 73464, '\P{Script_Extensions=  Makasar}', "");
    Expect(1, 73464, '\P{^Script_Extensions=  Makasar}', "");
    Expect(0, 73465, '\p{Script_Extensions=  Makasar}', "");
    Expect(1, 73465, '\p{^Script_Extensions=  Makasar}', "");
    Expect(1, 73465, '\P{Script_Extensions=  Makasar}', "");
    Expect(0, 73465, '\P{^Script_Extensions=  Makasar}', "");
    Error('\p{Scx: /a/_Maka}');
    Error('\P{Scx: /a/_Maka}');
    Expect(1, 73464, '\p{Scx=:\AMaka\z:}', "");;
    Expect(0, 73465, '\p{Scx=:\AMaka\z:}', "");;
    Expect(1, 73464, '\p{Scx=maka}', "");
    Expect(0, 73464, '\p{^Scx=maka}', "");
    Expect(0, 73464, '\P{Scx=maka}', "");
    Expect(1, 73464, '\P{^Scx=maka}', "");
    Expect(0, 73465, '\p{Scx=maka}', "");
    Expect(1, 73465, '\p{^Scx=maka}', "");
    Expect(1, 73465, '\P{Scx=maka}', "");
    Expect(0, 73465, '\P{^Scx=maka}', "");
    Expect(1, 73464, '\p{Scx=:\Amaka\z:}', "");;
    Expect(0, 73465, '\p{Scx=:\Amaka\z:}', "");;
    Expect(1, 73464, '\p{Scx=_maka}', "");
    Expect(0, 73464, '\p{^Scx=_maka}', "");
    Expect(0, 73464, '\P{Scx=_maka}', "");
    Expect(1, 73464, '\P{^Scx=_maka}', "");
    Expect(0, 73465, '\p{Scx=_maka}', "");
    Expect(1, 73465, '\p{^Scx=_maka}', "");
    Expect(1, 73465, '\P{Scx=_maka}', "");
    Expect(0, 73465, '\P{^Scx=_maka}', "");
    Error('\p{Is_Script_Extensions=-Makasar/a/}');
    Error('\P{Is_Script_Extensions=-Makasar/a/}');
    Expect(1, 73464, '\p{Is_Script_Extensions=makasar}', "");
    Expect(0, 73464, '\p{^Is_Script_Extensions=makasar}', "");
    Expect(0, 73464, '\P{Is_Script_Extensions=makasar}', "");
    Expect(1, 73464, '\P{^Is_Script_Extensions=makasar}', "");
    Expect(0, 73465, '\p{Is_Script_Extensions=makasar}', "");
    Expect(1, 73465, '\p{^Is_Script_Extensions=makasar}', "");
    Expect(1, 73465, '\P{Is_Script_Extensions=makasar}', "");
    Expect(0, 73465, '\P{^Is_Script_Extensions=makasar}', "");
    Expect(1, 73464, '\p{Is_Script_Extensions=-makasar}', "");
    Expect(0, 73464, '\p{^Is_Script_Extensions=-makasar}', "");
    Expect(0, 73464, '\P{Is_Script_Extensions=-makasar}', "");
    Expect(1, 73464, '\P{^Is_Script_Extensions=-makasar}', "");
    Expect(0, 73465, '\p{Is_Script_Extensions=-makasar}', "");
    Expect(1, 73465, '\p{^Is_Script_Extensions=-makasar}', "");
    Expect(1, 73465, '\P{Is_Script_Extensions=-makasar}', "");
    Expect(0, 73465, '\P{^Is_Script_Extensions=-makasar}', "");
    Error('\p{Is_Scx=-	MAKA:=}');
    Error('\P{Is_Scx=-	MAKA:=}');
    Expect(1, 73464, '\p{Is_Scx=maka}', "");
    Expect(0, 73464, '\p{^Is_Scx=maka}', "");
    Expect(0, 73464, '\P{Is_Scx=maka}', "");
    Expect(1, 73464, '\P{^Is_Scx=maka}', "");
    Expect(0, 73465, '\p{Is_Scx=maka}', "");
    Expect(1, 73465, '\p{^Is_Scx=maka}', "");
    Expect(1, 73465, '\P{Is_Scx=maka}', "");
    Expect(0, 73465, '\P{^Is_Scx=maka}', "");
    Expect(1, 73464, '\p{Is_Scx=- Maka}', "");
    Expect(0, 73464, '\p{^Is_Scx=- Maka}', "");
    Expect(0, 73464, '\P{Is_Scx=- Maka}', "");
    Expect(1, 73464, '\P{^Is_Scx=- Maka}', "");
    Expect(0, 73465, '\p{Is_Scx=- Maka}', "");
    Expect(1, 73465, '\p{^Is_Scx=- Maka}', "");
    Expect(1, 73465, '\P{Is_Scx=- Maka}', "");
    Expect(0, 73465, '\P{^Is_Scx=- Maka}', "");
    Error('\p{Script_Extensions= _Mandaic:=}');
    Error('\P{Script_Extensions= _Mandaic:=}');
    Expect(1, 2142, '\p{Script_Extensions=:\AMandaic\z:}', "");;
    Expect(0, 2143, '\p{Script_Extensions=:\AMandaic\z:}', "");;
    Expect(1, 2142, '\p{Script_Extensions:   mandaic}', "");
    Expect(0, 2142, '\p{^Script_Extensions:   mandaic}', "");
    Expect(0, 2142, '\P{Script_Extensions:   mandaic}', "");
    Expect(1, 2142, '\P{^Script_Extensions:   mandaic}', "");
    Expect(0, 2143, '\p{Script_Extensions:   mandaic}', "");
    Expect(1, 2143, '\p{^Script_Extensions:   mandaic}', "");
    Expect(1, 2143, '\P{Script_Extensions:   mandaic}', "");
    Expect(0, 2143, '\P{^Script_Extensions:   mandaic}', "");
    Expect(1, 2142, '\p{Script_Extensions=:\Amandaic\z:}', "");;
    Expect(0, 2143, '\p{Script_Extensions=:\Amandaic\z:}', "");;
    Expect(1, 2142, '\p{Script_Extensions=_Mandaic}', "");
    Expect(0, 2142, '\p{^Script_Extensions=_Mandaic}', "");
    Expect(0, 2142, '\P{Script_Extensions=_Mandaic}', "");
    Expect(1, 2142, '\P{^Script_Extensions=_Mandaic}', "");
    Expect(0, 2143, '\p{Script_Extensions=_Mandaic}', "");
    Expect(1, 2143, '\p{^Script_Extensions=_Mandaic}', "");
    Expect(1, 2143, '\P{Script_Extensions=_Mandaic}', "");
    Expect(0, 2143, '\P{^Script_Extensions=_Mandaic}', "");
    Error('\p{Scx= :=Mand}');
    Error('\P{Scx= :=Mand}');
    Expect(1, 2142, '\p{Scx=:\AMand\z:}', "");;
    Expect(0, 2143, '\p{Scx=:\AMand\z:}', "");;
    Expect(1, 2142, '\p{Scx=mand}', "");
    Expect(0, 2142, '\p{^Scx=mand}', "");
    Expect(0, 2142, '\P{Scx=mand}', "");
    Expect(1, 2142, '\P{^Scx=mand}', "");
    Expect(0, 2143, '\p{Scx=mand}', "");
    Expect(1, 2143, '\p{^Scx=mand}', "");
    Expect(1, 2143, '\P{Scx=mand}', "");
    Expect(0, 2143, '\P{^Scx=mand}', "");
    Expect(1, 2142, '\p{Scx=:\Amand\z:}', "");;
    Expect(0, 2143, '\p{Scx=:\Amand\z:}', "");;
    Expect(1, 2142, '\p{Scx=-_mand}', "");
    Expect(0, 2142, '\p{^Scx=-_mand}', "");
    Expect(0, 2142, '\P{Scx=-_mand}', "");
    Expect(1, 2142, '\P{^Scx=-_mand}', "");
    Expect(0, 2143, '\p{Scx=-_mand}', "");
    Expect(1, 2143, '\p{^Scx=-_mand}', "");
    Expect(1, 2143, '\P{Scx=-_mand}', "");
    Expect(0, 2143, '\P{^Scx=-_mand}', "");
    Error('\p{Is_Script_Extensions=	Mandaic/a/}');
    Error('\P{Is_Script_Extensions=	Mandaic/a/}');
    Expect(1, 2142, '\p{Is_Script_Extensions=mandaic}', "");
    Expect(0, 2142, '\p{^Is_Script_Extensions=mandaic}', "");
    Expect(0, 2142, '\P{Is_Script_Extensions=mandaic}', "");
    Expect(1, 2142, '\P{^Is_Script_Extensions=mandaic}', "");
    Expect(0, 2143, '\p{Is_Script_Extensions=mandaic}', "");
    Expect(1, 2143, '\p{^Is_Script_Extensions=mandaic}', "");
    Expect(1, 2143, '\P{Is_Script_Extensions=mandaic}', "");
    Expect(0, 2143, '\P{^Is_Script_Extensions=mandaic}', "");
    Expect(1, 2142, '\p{Is_Script_Extensions= _Mandaic}', "");
    Expect(0, 2142, '\p{^Is_Script_Extensions= _Mandaic}', "");
    Expect(0, 2142, '\P{Is_Script_Extensions= _Mandaic}', "");
    Expect(1, 2142, '\P{^Is_Script_Extensions= _Mandaic}', "");
    Expect(0, 2143, '\p{Is_Script_Extensions= _Mandaic}', "");
    Expect(1, 2143, '\p{^Is_Script_Extensions= _Mandaic}', "");
    Expect(1, 2143, '\P{Is_Script_Extensions= _Mandaic}', "");
    Expect(0, 2143, '\P{^Is_Script_Extensions= _Mandaic}', "");
    Error('\p{Is_Scx=-/a/mand}');
    Error('\P{Is_Scx=-/a/mand}');
    Expect(1, 2142, '\p{Is_Scx=mand}', "");
    Expect(0, 2142, '\p{^Is_Scx=mand}', "");
    Expect(0, 2142, '\P{Is_Scx=mand}', "");
    Expect(1, 2142, '\P{^Is_Scx=mand}', "");
    Expect(0, 2143, '\p{Is_Scx=mand}', "");
    Expect(1, 2143, '\p{^Is_Scx=mand}', "");
    Expect(1, 2143, '\P{Is_Scx=mand}', "");
    Expect(0, 2143, '\P{^Is_Scx=mand}', "");
    Expect(1, 2142, '\p{Is_Scx=	_MAND}', "");
    Expect(0, 2142, '\p{^Is_Scx=	_MAND}', "");
    Expect(0, 2142, '\P{Is_Scx=	_MAND}', "");
    Expect(1, 2142, '\P{^Is_Scx=	_MAND}', "");
    Expect(0, 2143, '\p{Is_Scx=	_MAND}', "");
    Expect(1, 2143, '\p{^Is_Scx=	_MAND}', "");
    Expect(1, 2143, '\P{Is_Scx=	_MAND}', "");
    Expect(0, 2143, '\P{^Is_Scx=	_MAND}', "");
    Error('\p{Script_Extensions=-:=Manichaean}');
    Error('\P{Script_Extensions=-:=Manichaean}');
    Expect(1, 68342, '\p{Script_Extensions=:\AManichaean\z:}', "");;
    Expect(0, 68343, '\p{Script_Extensions=:\AManichaean\z:}', "");;
    Expect(1, 68342, '\p{Script_Extensions=manichaean}', "");
    Expect(0, 68342, '\p{^Script_Extensions=manichaean}', "");
    Expect(0, 68342, '\P{Script_Extensions=manichaean}', "");
    Expect(1, 68342, '\P{^Script_Extensions=manichaean}', "");
    Expect(0, 68343, '\p{Script_Extensions=manichaean}', "");
    Expect(1, 68343, '\p{^Script_Extensions=manichaean}', "");
    Expect(1, 68343, '\P{Script_Extensions=manichaean}', "");
    Expect(0, 68343, '\P{^Script_Extensions=manichaean}', "");
    Expect(1, 68342, '\p{Script_Extensions=:\Amanichaean\z:}', "");;
    Expect(0, 68343, '\p{Script_Extensions=:\Amanichaean\z:}', "");;
    Expect(1, 68342, '\p{Script_Extensions=-Manichaean}', "");
    Expect(0, 68342, '\p{^Script_Extensions=-Manichaean}', "");
    Expect(0, 68342, '\P{Script_Extensions=-Manichaean}', "");
    Expect(1, 68342, '\P{^Script_Extensions=-Manichaean}', "");
    Expect(0, 68343, '\p{Script_Extensions=-Manichaean}', "");
    Expect(1, 68343, '\p{^Script_Extensions=-Manichaean}', "");
    Expect(1, 68343, '\P{Script_Extensions=-Manichaean}', "");
    Expect(0, 68343, '\P{^Script_Extensions=-Manichaean}', "");
    Error('\p{Scx=:=	_mani}');
    Error('\P{Scx=:=	_mani}');
    Expect(1, 68342, '\p{Scx=:\AMani\z:}', "");;
    Expect(0, 68343, '\p{Scx=:\AMani\z:}', "");;
    Expect(1, 68342, '\p{Scx=mani}', "");
    Expect(0, 68342, '\p{^Scx=mani}', "");
    Expect(0, 68342, '\P{Scx=mani}', "");
    Expect(1, 68342, '\P{^Scx=mani}', "");
    Expect(0, 68343, '\p{Scx=mani}', "");
    Expect(1, 68343, '\p{^Scx=mani}', "");
    Expect(1, 68343, '\P{Scx=mani}', "");
    Expect(0, 68343, '\P{^Scx=mani}', "");
    Expect(1, 68342, '\p{Scx=:\Amani\z:}', "");;
    Expect(0, 68343, '\p{Scx=:\Amani\z:}', "");;
    Expect(1, 68342, '\p{Scx=-	MANI}', "");
    Expect(0, 68342, '\p{^Scx=-	MANI}', "");
    Expect(0, 68342, '\P{Scx=-	MANI}', "");
    Expect(1, 68342, '\P{^Scx=-	MANI}', "");
    Expect(0, 68343, '\p{Scx=-	MANI}', "");
    Expect(1, 68343, '\p{^Scx=-	MANI}', "");
    Expect(1, 68343, '\P{Scx=-	MANI}', "");
    Expect(0, 68343, '\P{^Scx=-	MANI}', "");
    Error('\p{Is_Script_Extensions=_MANICHAEAN/a/}');
    Error('\P{Is_Script_Extensions=_MANICHAEAN/a/}');
    Expect(1, 68342, '\p{Is_Script_Extensions=manichaean}', "");
    Expect(0, 68342, '\p{^Is_Script_Extensions=manichaean}', "");
    Expect(0, 68342, '\P{Is_Script_Extensions=manichaean}', "");
    Expect(1, 68342, '\P{^Is_Script_Extensions=manichaean}', "");
    Expect(0, 68343, '\p{Is_Script_Extensions=manichaean}', "");
    Expect(1, 68343, '\p{^Is_Script_Extensions=manichaean}', "");
    Expect(1, 68343, '\P{Is_Script_Extensions=manichaean}', "");
    Expect(0, 68343, '\P{^Is_Script_Extensions=manichaean}', "");
    Expect(1, 68342, '\p{Is_Script_Extensions= MANICHAEAN}', "");
    Expect(0, 68342, '\p{^Is_Script_Extensions= MANICHAEAN}', "");
    Expect(0, 68342, '\P{Is_Script_Extensions= MANICHAEAN}', "");
    Expect(1, 68342, '\P{^Is_Script_Extensions= MANICHAEAN}', "");
    Expect(0, 68343, '\p{Is_Script_Extensions= MANICHAEAN}', "");
    Expect(1, 68343, '\p{^Is_Script_Extensions= MANICHAEAN}', "");
    Expect(1, 68343, '\P{Is_Script_Extensions= MANICHAEAN}', "");
    Expect(0, 68343, '\P{^Is_Script_Extensions= MANICHAEAN}', "");
    Error('\p{Is_Scx=/a/- mani}');
    Error('\P{Is_Scx=/a/- mani}');
    Expect(1, 68342, '\p{Is_Scx=mani}', "");
    Expect(0, 68342, '\p{^Is_Scx=mani}', "");
    Expect(0, 68342, '\P{Is_Scx=mani}', "");
    Expect(1, 68342, '\P{^Is_Scx=mani}', "");
    Expect(0, 68343, '\p{Is_Scx=mani}', "");
    Expect(1, 68343, '\p{^Is_Scx=mani}', "");
    Expect(1, 68343, '\P{Is_Scx=mani}', "");
    Expect(0, 68343, '\P{^Is_Scx=mani}', "");
    Expect(1, 68342, '\p{Is_Scx=__Mani}', "");
    Expect(0, 68342, '\p{^Is_Scx=__Mani}', "");
    Expect(0, 68342, '\P{Is_Scx=__Mani}', "");
    Expect(1, 68342, '\P{^Is_Scx=__Mani}', "");
    Expect(0, 68343, '\p{Is_Scx=__Mani}', "");
    Expect(1, 68343, '\p{^Is_Scx=__Mani}', "");
    Expect(1, 68343, '\P{Is_Scx=__Mani}', "");
    Expect(0, 68343, '\P{^Is_Scx=__Mani}', "");
    Error('\p{Script_Extensions=/a/_	marchen}');
    Error('\P{Script_Extensions=/a/_	marchen}');
    Expect(1, 72886, '\p{Script_Extensions=:\AMarchen\z:}', "");;
    Expect(0, 72887, '\p{Script_Extensions=:\AMarchen\z:}', "");;
    Expect(1, 72886, '\p{Script_Extensions=marchen}', "");
    Expect(0, 72886, '\p{^Script_Extensions=marchen}', "");
    Expect(0, 72886, '\P{Script_Extensions=marchen}', "");
    Expect(1, 72886, '\P{^Script_Extensions=marchen}', "");
    Expect(0, 72887, '\p{Script_Extensions=marchen}', "");
    Expect(1, 72887, '\p{^Script_Extensions=marchen}', "");
    Expect(1, 72887, '\P{Script_Extensions=marchen}', "");
    Expect(0, 72887, '\P{^Script_Extensions=marchen}', "");
    Expect(1, 72886, '\p{Script_Extensions=:\Amarchen\z:}', "");;
    Expect(0, 72887, '\p{Script_Extensions=:\Amarchen\z:}', "");;
    Expect(1, 72886, '\p{Script_Extensions=_	Marchen}', "");
    Expect(0, 72886, '\p{^Script_Extensions=_	Marchen}', "");
    Expect(0, 72886, '\P{Script_Extensions=_	Marchen}', "");
    Expect(1, 72886, '\P{^Script_Extensions=_	Marchen}', "");
    Expect(0, 72887, '\p{Script_Extensions=_	Marchen}', "");
    Expect(1, 72887, '\p{^Script_Extensions=_	Marchen}', "");
    Expect(1, 72887, '\P{Script_Extensions=_	Marchen}', "");
    Expect(0, 72887, '\P{^Script_Extensions=_	Marchen}', "");
    Error('\p{Scx:-Marc/a/}');
    Error('\P{Scx:-Marc/a/}');
    Expect(1, 72886, '\p{Scx=:\AMarc\z:}', "");;
    Expect(0, 72887, '\p{Scx=:\AMarc\z:}', "");;
    Expect(1, 72886, '\p{Scx=marc}', "");
    Expect(0, 72886, '\p{^Scx=marc}', "");
    Expect(0, 72886, '\P{Scx=marc}', "");
    Expect(1, 72886, '\P{^Scx=marc}', "");
    Expect(0, 72887, '\p{Scx=marc}', "");
    Expect(1, 72887, '\p{^Scx=marc}', "");
    Expect(1, 72887, '\P{Scx=marc}', "");
    Expect(0, 72887, '\P{^Scx=marc}', "");
    Expect(1, 72886, '\p{Scx=:\Amarc\z:}', "");;
    Expect(0, 72887, '\p{Scx=:\Amarc\z:}', "");;
    Expect(1, 72886, '\p{Scx=_	marc}', "");
    Expect(0, 72886, '\p{^Scx=_	marc}', "");
    Expect(0, 72886, '\P{Scx=_	marc}', "");
    Expect(1, 72886, '\P{^Scx=_	marc}', "");
    Expect(0, 72887, '\p{Scx=_	marc}', "");
    Expect(1, 72887, '\p{^Scx=_	marc}', "");
    Expect(1, 72887, '\P{Scx=_	marc}', "");
    Expect(0, 72887, '\P{^Scx=_	marc}', "");
    Error('\p{Is_Script_Extensions= /a/MARCHEN}');
    Error('\P{Is_Script_Extensions= /a/MARCHEN}');
    Expect(1, 72886, '\p{Is_Script_Extensions=marchen}', "");
    Expect(0, 72886, '\p{^Is_Script_Extensions=marchen}', "");
    Expect(0, 72886, '\P{Is_Script_Extensions=marchen}', "");
    Expect(1, 72886, '\P{^Is_Script_Extensions=marchen}', "");
    Expect(0, 72887, '\p{Is_Script_Extensions=marchen}', "");
    Expect(1, 72887, '\p{^Is_Script_Extensions=marchen}', "");
    Expect(1, 72887, '\P{Is_Script_Extensions=marchen}', "");
    Expect(0, 72887, '\P{^Is_Script_Extensions=marchen}', "");
    Expect(1, 72886, '\p{Is_Script_Extensions:  	marchen}', "");
    Expect(0, 72886, '\p{^Is_Script_Extensions:  	marchen}', "");
    Expect(0, 72886, '\P{Is_Script_Extensions:  	marchen}', "");
    Expect(1, 72886, '\P{^Is_Script_Extensions:  	marchen}', "");
    Expect(0, 72887, '\p{Is_Script_Extensions:  	marchen}', "");
    Expect(1, 72887, '\p{^Is_Script_Extensions:  	marchen}', "");
    Expect(1, 72887, '\P{Is_Script_Extensions:  	marchen}', "");
    Expect(0, 72887, '\P{^Is_Script_Extensions:  	marchen}', "");
    Error('\p{Is_Scx=/a/_	MARC}');
    Error('\P{Is_Scx=/a/_	MARC}');
    Expect(1, 72886, '\p{Is_Scx=marc}', "");
    Expect(0, 72886, '\p{^Is_Scx=marc}', "");
    Expect(0, 72886, '\P{Is_Scx=marc}', "");
    Expect(1, 72886, '\P{^Is_Scx=marc}', "");
    Expect(0, 72887, '\p{Is_Scx=marc}', "");
    Expect(1, 72887, '\p{^Is_Scx=marc}', "");
    Expect(1, 72887, '\P{Is_Scx=marc}', "");
    Expect(0, 72887, '\P{^Is_Scx=marc}', "");
    Expect(1, 72886, '\p{Is_Scx=__Marc}', "");
    Expect(0, 72886, '\p{^Is_Scx=__Marc}', "");
    Expect(0, 72886, '\P{Is_Scx=__Marc}', "");
    Expect(1, 72886, '\P{^Is_Scx=__Marc}', "");
    Expect(0, 72887, '\p{Is_Scx=__Marc}', "");
    Expect(1, 72887, '\p{^Is_Scx=__Marc}', "");
    Expect(1, 72887, '\P{Is_Scx=__Marc}', "");
    Expect(0, 72887, '\P{^Is_Scx=__Marc}', "");
    Error('\p{Script_Extensions=/a/ medefaidrin}');
    Error('\P{Script_Extensions=/a/ medefaidrin}');
    Expect(1, 93850, '\p{Script_Extensions=:\AMedefaidrin\z:}', "");;
    Expect(0, 93851, '\p{Script_Extensions=:\AMedefaidrin\z:}', "");;
    Expect(1, 93850, '\p{Script_Extensions=medefaidrin}', "");
    Expect(0, 93850, '\p{^Script_Extensions=medefaidrin}', "");
    Expect(0, 93850, '\P{Script_Extensions=medefaidrin}', "");
    Expect(1, 93850, '\P{^Script_Extensions=medefaidrin}', "");
    Expect(0, 93851, '\p{Script_Extensions=medefaidrin}', "");
    Expect(1, 93851, '\p{^Script_Extensions=medefaidrin}', "");
    Expect(1, 93851, '\P{Script_Extensions=medefaidrin}', "");
    Expect(0, 93851, '\P{^Script_Extensions=medefaidrin}', "");
    Expect(1, 93850, '\p{Script_Extensions=:\Amedefaidrin\z:}', "");;
    Expect(0, 93851, '\p{Script_Extensions=:\Amedefaidrin\z:}', "");;
    Expect(1, 93850, '\p{Script_Extensions=  Medefaidrin}', "");
    Expect(0, 93850, '\p{^Script_Extensions=  Medefaidrin}', "");
    Expect(0, 93850, '\P{Script_Extensions=  Medefaidrin}', "");
    Expect(1, 93850, '\P{^Script_Extensions=  Medefaidrin}', "");
    Expect(0, 93851, '\p{Script_Extensions=  Medefaidrin}', "");
    Expect(1, 93851, '\p{^Script_Extensions=  Medefaidrin}', "");
    Expect(1, 93851, '\P{Script_Extensions=  Medefaidrin}', "");
    Expect(0, 93851, '\P{^Script_Extensions=  Medefaidrin}', "");
    Error('\p{Scx=/a/	-MEDF}');
    Error('\P{Scx=/a/	-MEDF}');
    Expect(1, 93850, '\p{Scx=:\AMedf\z:}', "");;
    Expect(0, 93851, '\p{Scx=:\AMedf\z:}', "");;
    Expect(1, 93850, '\p{Scx=medf}', "");
    Expect(0, 93850, '\p{^Scx=medf}', "");
    Expect(0, 93850, '\P{Scx=medf}', "");
    Expect(1, 93850, '\P{^Scx=medf}', "");
    Expect(0, 93851, '\p{Scx=medf}', "");
    Expect(1, 93851, '\p{^Scx=medf}', "");
    Expect(1, 93851, '\P{Scx=medf}', "");
    Expect(0, 93851, '\P{^Scx=medf}', "");
    Expect(1, 93850, '\p{Scx=:\Amedf\z:}', "");;
    Expect(0, 93851, '\p{Scx=:\Amedf\z:}', "");;
    Expect(1, 93850, '\p{Scx:	- MEDF}', "");
    Expect(0, 93850, '\p{^Scx:	- MEDF}', "");
    Expect(0, 93850, '\P{Scx:	- MEDF}', "");
    Expect(1, 93850, '\P{^Scx:	- MEDF}', "");
    Expect(0, 93851, '\p{Scx:	- MEDF}', "");
    Expect(1, 93851, '\p{^Scx:	- MEDF}', "");
    Expect(1, 93851, '\P{Scx:	- MEDF}', "");
    Expect(0, 93851, '\P{^Scx:	- MEDF}', "");
    Error('\p{Is_Script_Extensions=-Medefaidrin:=}');
    Error('\P{Is_Script_Extensions=-Medefaidrin:=}');
    Expect(1, 93850, '\p{Is_Script_Extensions=medefaidrin}', "");
    Expect(0, 93850, '\p{^Is_Script_Extensions=medefaidrin}', "");
    Expect(0, 93850, '\P{Is_Script_Extensions=medefaidrin}', "");
    Expect(1, 93850, '\P{^Is_Script_Extensions=medefaidrin}', "");
    Expect(0, 93851, '\p{Is_Script_Extensions=medefaidrin}', "");
    Expect(1, 93851, '\p{^Is_Script_Extensions=medefaidrin}', "");
    Expect(1, 93851, '\P{Is_Script_Extensions=medefaidrin}', "");
    Expect(0, 93851, '\P{^Is_Script_Extensions=medefaidrin}', "");
    Expect(1, 93850, '\p{Is_Script_Extensions:     Medefaidrin}', "");
    Expect(0, 93850, '\p{^Is_Script_Extensions:     Medefaidrin}', "");
    Expect(0, 93850, '\P{Is_Script_Extensions:     Medefaidrin}', "");
    Expect(1, 93850, '\P{^Is_Script_Extensions:     Medefaidrin}', "");
    Expect(0, 93851, '\p{Is_Script_Extensions:     Medefaidrin}', "");
    Expect(1, 93851, '\p{^Is_Script_Extensions:     Medefaidrin}', "");
    Expect(1, 93851, '\P{Is_Script_Extensions:     Medefaidrin}', "");
    Expect(0, 93851, '\P{^Is_Script_Extensions:     Medefaidrin}', "");
    Error('\p{Is_Scx=-/a/Medf}');
    Error('\P{Is_Scx=-/a/Medf}');
    Expect(1, 93850, '\p{Is_Scx=medf}', "");
    Expect(0, 93850, '\p{^Is_Scx=medf}', "");
    Expect(0, 93850, '\P{Is_Scx=medf}', "");
    Expect(1, 93850, '\P{^Is_Scx=medf}', "");
    Expect(0, 93851, '\p{Is_Scx=medf}', "");
    Expect(1, 93851, '\p{^Is_Scx=medf}', "");
    Expect(1, 93851, '\P{Is_Scx=medf}', "");
    Expect(0, 93851, '\P{^Is_Scx=medf}', "");
    Expect(1, 93850, '\p{Is_Scx=	 medf}', "");
    Expect(0, 93850, '\p{^Is_Scx=	 medf}', "");
    Expect(0, 93850, '\P{Is_Scx=	 medf}', "");
    Expect(1, 93850, '\P{^Is_Scx=	 medf}', "");
    Expect(0, 93851, '\p{Is_Scx=	 medf}', "");
    Expect(1, 93851, '\p{^Is_Scx=	 medf}', "");
    Expect(1, 93851, '\P{Is_Scx=	 medf}', "");
    Expect(0, 93851, '\P{^Is_Scx=	 medf}', "");
    Error('\p{Script_Extensions: :=--mende_Kikakui}');
    Error('\P{Script_Extensions: :=--mende_Kikakui}');
    Expect(1, 125142, '\p{Script_Extensions=:\AMende_Kikakui\z:}', "");;
    Expect(0, 125143, '\p{Script_Extensions=:\AMende_Kikakui\z:}', "");;
    Expect(1, 125142, '\p{Script_Extensions=mendekikakui}', "");
    Expect(0, 125142, '\p{^Script_Extensions=mendekikakui}', "");
    Expect(0, 125142, '\P{Script_Extensions=mendekikakui}', "");
    Expect(1, 125142, '\P{^Script_Extensions=mendekikakui}', "");
    Expect(0, 125143, '\p{Script_Extensions=mendekikakui}', "");
    Expect(1, 125143, '\p{^Script_Extensions=mendekikakui}', "");
    Expect(1, 125143, '\P{Script_Extensions=mendekikakui}', "");
    Expect(0, 125143, '\P{^Script_Extensions=mendekikakui}', "");
    Expect(1, 125142, '\p{Script_Extensions=:\Amendekikakui\z:}', "");;
    Expect(0, 125143, '\p{Script_Extensions=:\Amendekikakui\z:}', "");;
    Expect(1, 125142, '\p{Script_Extensions=-mende_kikakui}', "");
    Expect(0, 125142, '\p{^Script_Extensions=-mende_kikakui}', "");
    Expect(0, 125142, '\P{Script_Extensions=-mende_kikakui}', "");
    Expect(1, 125142, '\P{^Script_Extensions=-mende_kikakui}', "");
    Expect(0, 125143, '\p{Script_Extensions=-mende_kikakui}', "");
    Expect(1, 125143, '\p{^Script_Extensions=-mende_kikakui}', "");
    Expect(1, 125143, '\P{Script_Extensions=-mende_kikakui}', "");
    Expect(0, 125143, '\P{^Script_Extensions=-mende_kikakui}', "");
    Error('\p{Scx=/a/MEND}');
    Error('\P{Scx=/a/MEND}');
    Expect(1, 125142, '\p{Scx=:\AMend\z:}', "");;
    Expect(0, 125143, '\p{Scx=:\AMend\z:}', "");;
    Expect(1, 125142, '\p{Scx=mend}', "");
    Expect(0, 125142, '\p{^Scx=mend}', "");
    Expect(0, 125142, '\P{Scx=mend}', "");
    Expect(1, 125142, '\P{^Scx=mend}', "");
    Expect(0, 125143, '\p{Scx=mend}', "");
    Expect(1, 125143, '\p{^Scx=mend}', "");
    Expect(1, 125143, '\P{Scx=mend}', "");
    Expect(0, 125143, '\P{^Scx=mend}', "");
    Expect(1, 125142, '\p{Scx=:\Amend\z:}', "");;
    Expect(0, 125143, '\p{Scx=:\Amend\z:}', "");;
    Expect(1, 125142, '\p{Scx=	mend}', "");
    Expect(0, 125142, '\p{^Scx=	mend}', "");
    Expect(0, 125142, '\P{Scx=	mend}', "");
    Expect(1, 125142, '\P{^Scx=	mend}', "");
    Expect(0, 125143, '\p{Scx=	mend}', "");
    Expect(1, 125143, '\p{^Scx=	mend}', "");
    Expect(1, 125143, '\P{Scx=	mend}', "");
    Expect(0, 125143, '\P{^Scx=	mend}', "");
    Error('\p{Is_Script_Extensions: _-Mende_kikakui/a/}');
    Error('\P{Is_Script_Extensions: _-Mende_kikakui/a/}');
    Expect(1, 125142, '\p{Is_Script_Extensions:   mendekikakui}', "");
    Expect(0, 125142, '\p{^Is_Script_Extensions:   mendekikakui}', "");
    Expect(0, 125142, '\P{Is_Script_Extensions:   mendekikakui}', "");
    Expect(1, 125142, '\P{^Is_Script_Extensions:   mendekikakui}', "");
    Expect(0, 125143, '\p{Is_Script_Extensions:   mendekikakui}', "");
    Expect(1, 125143, '\p{^Is_Script_Extensions:   mendekikakui}', "");
    Expect(1, 125143, '\P{Is_Script_Extensions:   mendekikakui}', "");
    Expect(0, 125143, '\P{^Is_Script_Extensions:   mendekikakui}', "");
    Expect(1, 125142, '\p{Is_Script_Extensions=		Mende_Kikakui}', "");
    Expect(0, 125142, '\p{^Is_Script_Extensions=		Mende_Kikakui}', "");
    Expect(0, 125142, '\P{Is_Script_Extensions=		Mende_Kikakui}', "");
    Expect(1, 125142, '\P{^Is_Script_Extensions=		Mende_Kikakui}', "");
    Expect(0, 125143, '\p{Is_Script_Extensions=		Mende_Kikakui}', "");
    Expect(1, 125143, '\p{^Is_Script_Extensions=		Mende_Kikakui}', "");
    Expect(1, 125143, '\P{Is_Script_Extensions=		Mende_Kikakui}', "");
    Expect(0, 125143, '\P{^Is_Script_Extensions=		Mende_Kikakui}', "");
    Error('\p{Is_Scx=:=_MEND}');
    Error('\P{Is_Scx=:=_MEND}');
    Expect(1, 125142, '\p{Is_Scx=mend}', "");
    Expect(0, 125142, '\p{^Is_Scx=mend}', "");
    Expect(0, 125142, '\P{Is_Scx=mend}', "");
    Expect(1, 125142, '\P{^Is_Scx=mend}', "");
    Expect(0, 125143, '\p{Is_Scx=mend}', "");
    Expect(1, 125143, '\p{^Is_Scx=mend}', "");
    Expect(1, 125143, '\P{Is_Scx=mend}', "");
    Expect(0, 125143, '\P{^Is_Scx=mend}', "");
    Expect(1, 125142, '\p{Is_Scx: -	Mend}', "");
    Expect(0, 125142, '\p{^Is_Scx: -	Mend}', "");
    Expect(0, 125142, '\P{Is_Scx: -	Mend}', "");
    Expect(1, 125142, '\P{^Is_Scx: -	Mend}', "");
    Expect(0, 125143, '\p{Is_Scx: -	Mend}', "");
    Expect(1, 125143, '\p{^Is_Scx: -	Mend}', "");
    Expect(1, 125143, '\P{Is_Scx: -	Mend}', "");
    Expect(0, 125143, '\P{^Is_Scx: -	Mend}', "");
    Error('\p{Script_Extensions=:=	Meroitic_cursive}');
    Error('\P{Script_Extensions=:=	Meroitic_cursive}');
    Expect(1, 68095, '\p{Script_Extensions=:\AMeroitic_Cursive\z:}', "");;
    Expect(0, 68096, '\p{Script_Extensions=:\AMeroitic_Cursive\z:}', "");;
    Expect(1, 68095, '\p{Script_Extensions=meroiticcursive}', "");
    Expect(0, 68095, '\p{^Script_Extensions=meroiticcursive}', "");
    Expect(0, 68095, '\P{Script_Extensions=meroiticcursive}', "");
    Expect(1, 68095, '\P{^Script_Extensions=meroiticcursive}', "");
    Expect(0, 68096, '\p{Script_Extensions=meroiticcursive}', "");
    Expect(1, 68096, '\p{^Script_Extensions=meroiticcursive}', "");
    Expect(1, 68096, '\P{Script_Extensions=meroiticcursive}', "");
    Expect(0, 68096, '\P{^Script_Extensions=meroiticcursive}', "");
    Expect(1, 68095, '\p{Script_Extensions=:\Ameroiticcursive\z:}', "");;
    Expect(0, 68096, '\p{Script_Extensions=:\Ameroiticcursive\z:}', "");;
    Expect(1, 68095, '\p{Script_Extensions=  Meroitic_CURSIVE}', "");
    Expect(0, 68095, '\p{^Script_Extensions=  Meroitic_CURSIVE}', "");
    Expect(0, 68095, '\P{Script_Extensions=  Meroitic_CURSIVE}', "");
    Expect(1, 68095, '\P{^Script_Extensions=  Meroitic_CURSIVE}', "");
    Expect(0, 68096, '\p{Script_Extensions=  Meroitic_CURSIVE}', "");
    Expect(1, 68096, '\p{^Script_Extensions=  Meroitic_CURSIVE}', "");
    Expect(1, 68096, '\P{Script_Extensions=  Meroitic_CURSIVE}', "");
    Expect(0, 68096, '\P{^Script_Extensions=  Meroitic_CURSIVE}', "");
    Error('\p{Scx=		Merc:=}');
    Error('\P{Scx=		Merc:=}');
    Expect(1, 68095, '\p{Scx=:\AMerc\z:}', "");;
    Expect(0, 68096, '\p{Scx=:\AMerc\z:}', "");;
    Expect(1, 68095, '\p{Scx=merc}', "");
    Expect(0, 68095, '\p{^Scx=merc}', "");
    Expect(0, 68095, '\P{Scx=merc}', "");
    Expect(1, 68095, '\P{^Scx=merc}', "");
    Expect(0, 68096, '\p{Scx=merc}', "");
    Expect(1, 68096, '\p{^Scx=merc}', "");
    Expect(1, 68096, '\P{Scx=merc}', "");
    Expect(0, 68096, '\P{^Scx=merc}', "");
    Expect(1, 68095, '\p{Scx=:\Amerc\z:}', "");;
    Expect(0, 68096, '\p{Scx=:\Amerc\z:}', "");;
    Expect(1, 68095, '\p{Scx= -Merc}', "");
    Expect(0, 68095, '\p{^Scx= -Merc}', "");
    Expect(0, 68095, '\P{Scx= -Merc}', "");
    Expect(1, 68095, '\P{^Scx= -Merc}', "");
    Expect(0, 68096, '\p{Scx= -Merc}', "");
    Expect(1, 68096, '\p{^Scx= -Merc}', "");
    Expect(1, 68096, '\P{Scx= -Merc}', "");
    Expect(0, 68096, '\P{^Scx= -Merc}', "");
    Error('\p{Is_Script_Extensions=:=-_Meroitic_Cursive}');
    Error('\P{Is_Script_Extensions=:=-_Meroitic_Cursive}');
    Expect(1, 68095, '\p{Is_Script_Extensions=meroiticcursive}', "");
    Expect(0, 68095, '\p{^Is_Script_Extensions=meroiticcursive}', "");
    Expect(0, 68095, '\P{Is_Script_Extensions=meroiticcursive}', "");
    Expect(1, 68095, '\P{^Is_Script_Extensions=meroiticcursive}', "");
    Expect(0, 68096, '\p{Is_Script_Extensions=meroiticcursive}', "");
    Expect(1, 68096, '\p{^Is_Script_Extensions=meroiticcursive}', "");
    Expect(1, 68096, '\P{Is_Script_Extensions=meroiticcursive}', "");
    Expect(0, 68096, '\P{^Is_Script_Extensions=meroiticcursive}', "");
    Expect(1, 68095, '\p{Is_Script_Extensions:  Meroitic_Cursive}', "");
    Expect(0, 68095, '\p{^Is_Script_Extensions:  Meroitic_Cursive}', "");
    Expect(0, 68095, '\P{Is_Script_Extensions:  Meroitic_Cursive}', "");
    Expect(1, 68095, '\P{^Is_Script_Extensions:  Meroitic_Cursive}', "");
    Expect(0, 68096, '\p{Is_Script_Extensions:  Meroitic_Cursive}', "");
    Expect(1, 68096, '\p{^Is_Script_Extensions:  Meroitic_Cursive}', "");
    Expect(1, 68096, '\P{Is_Script_Extensions:  Meroitic_Cursive}', "");
    Expect(0, 68096, '\P{^Is_Script_Extensions:  Meroitic_Cursive}', "");
    Error('\p{Is_Scx:	 :=MERC}');
    Error('\P{Is_Scx:	 :=MERC}');
    Expect(1, 68095, '\p{Is_Scx=merc}', "");
    Expect(0, 68095, '\p{^Is_Scx=merc}', "");
    Expect(0, 68095, '\P{Is_Scx=merc}', "");
    Expect(1, 68095, '\P{^Is_Scx=merc}', "");
    Expect(0, 68096, '\p{Is_Scx=merc}', "");
    Expect(1, 68096, '\p{^Is_Scx=merc}', "");
    Expect(1, 68096, '\P{Is_Scx=merc}', "");
    Expect(0, 68096, '\P{^Is_Scx=merc}', "");
    Expect(1, 68095, '\p{Is_Scx=_	Merc}', "");
    Expect(0, 68095, '\p{^Is_Scx=_	Merc}', "");
    Expect(0, 68095, '\P{Is_Scx=_	Merc}', "");
    Expect(1, 68095, '\P{^Is_Scx=_	Merc}', "");
    Expect(0, 68096, '\p{Is_Scx=_	Merc}', "");
    Expect(1, 68096, '\p{^Is_Scx=_	Merc}', "");
    Expect(1, 68096, '\P{Is_Scx=_	Merc}', "");
    Expect(0, 68096, '\P{^Is_Scx=_	Merc}', "");
    Error('\p{Script_Extensions=/a/meroitic_Hieroglyphs}');
    Error('\P{Script_Extensions=/a/meroitic_Hieroglyphs}');
    Expect(1, 67999, '\p{Script_Extensions=:\AMeroitic_Hieroglyphs\z:}', "");;
    Expect(0, 68000, '\p{Script_Extensions=:\AMeroitic_Hieroglyphs\z:}', "");;
    Expect(1, 67999, '\p{Script_Extensions=meroitichieroglyphs}', "");
    Expect(0, 67999, '\p{^Script_Extensions=meroitichieroglyphs}', "");
    Expect(0, 67999, '\P{Script_Extensions=meroitichieroglyphs}', "");
    Expect(1, 67999, '\P{^Script_Extensions=meroitichieroglyphs}', "");
    Expect(0, 68000, '\p{Script_Extensions=meroitichieroglyphs}', "");
    Expect(1, 68000, '\p{^Script_Extensions=meroitichieroglyphs}', "");
    Expect(1, 68000, '\P{Script_Extensions=meroitichieroglyphs}', "");
    Expect(0, 68000, '\P{^Script_Extensions=meroitichieroglyphs}', "");
    Expect(1, 67999, '\p{Script_Extensions=:\Ameroitichieroglyphs\z:}', "");;
    Expect(0, 68000, '\p{Script_Extensions=:\Ameroitichieroglyphs\z:}', "");;
    Expect(1, 67999, '\p{Script_Extensions=-	MEROITIC_hieroglyphs}', "");
    Expect(0, 67999, '\p{^Script_Extensions=-	MEROITIC_hieroglyphs}', "");
    Expect(0, 67999, '\P{Script_Extensions=-	MEROITIC_hieroglyphs}', "");
    Expect(1, 67999, '\P{^Script_Extensions=-	MEROITIC_hieroglyphs}', "");
    Expect(0, 68000, '\p{Script_Extensions=-	MEROITIC_hieroglyphs}', "");
    Expect(1, 68000, '\p{^Script_Extensions=-	MEROITIC_hieroglyphs}', "");
    Expect(1, 68000, '\P{Script_Extensions=-	MEROITIC_hieroglyphs}', "");
    Expect(0, 68000, '\P{^Script_Extensions=-	MEROITIC_hieroglyphs}', "");
    Error('\p{Scx= :=mero}');
    Error('\P{Scx= :=mero}');
    Expect(1, 67999, '\p{Scx=:\AMero\z:}', "");;
    Expect(0, 68000, '\p{Scx=:\AMero\z:}', "");;
    Expect(1, 67999, '\p{Scx=mero}', "");
    Expect(0, 67999, '\p{^Scx=mero}', "");
    Expect(0, 67999, '\P{Scx=mero}', "");
    Expect(1, 67999, '\P{^Scx=mero}', "");
    Expect(0, 68000, '\p{Scx=mero}', "");
    Expect(1, 68000, '\p{^Scx=mero}', "");
    Expect(1, 68000, '\P{Scx=mero}', "");
    Expect(0, 68000, '\P{^Scx=mero}', "");
    Expect(1, 67999, '\p{Scx=:\Amero\z:}', "");;
    Expect(0, 68000, '\p{Scx=:\Amero\z:}', "");;
    Expect(1, 67999, '\p{Scx= 	mero}', "");
    Expect(0, 67999, '\p{^Scx= 	mero}', "");
    Expect(0, 67999, '\P{Scx= 	mero}', "");
    Expect(1, 67999, '\P{^Scx= 	mero}', "");
    Expect(0, 68000, '\p{Scx= 	mero}', "");
    Expect(1, 68000, '\p{^Scx= 	mero}', "");
    Expect(1, 68000, '\P{Scx= 	mero}', "");
    Expect(0, 68000, '\P{^Scx= 	mero}', "");
    Error('\p{Is_Script_Extensions=_ Meroitic_hieroglyphs/a/}');
    Error('\P{Is_Script_Extensions=_ Meroitic_hieroglyphs/a/}');
    Expect(1, 67999, '\p{Is_Script_Extensions=meroitichieroglyphs}', "");
    Expect(0, 67999, '\p{^Is_Script_Extensions=meroitichieroglyphs}', "");
    Expect(0, 67999, '\P{Is_Script_Extensions=meroitichieroglyphs}', "");
    Expect(1, 67999, '\P{^Is_Script_Extensions=meroitichieroglyphs}', "");
    Expect(0, 68000, '\p{Is_Script_Extensions=meroitichieroglyphs}', "");
    Expect(1, 68000, '\p{^Is_Script_Extensions=meroitichieroglyphs}', "");
    Expect(1, 68000, '\P{Is_Script_Extensions=meroitichieroglyphs}', "");
    Expect(0, 68000, '\P{^Is_Script_Extensions=meroitichieroglyphs}', "");
    Expect(1, 67999, '\p{Is_Script_Extensions=-	Meroitic_hieroglyphs}', "");
    Expect(0, 67999, '\p{^Is_Script_Extensions=-	Meroitic_hieroglyphs}', "");
    Expect(0, 67999, '\P{Is_Script_Extensions=-	Meroitic_hieroglyphs}', "");
    Expect(1, 67999, '\P{^Is_Script_Extensions=-	Meroitic_hieroglyphs}', "");
    Expect(0, 68000, '\p{Is_Script_Extensions=-	Meroitic_hieroglyphs}', "");
    Expect(1, 68000, '\p{^Is_Script_Extensions=-	Meroitic_hieroglyphs}', "");
    Expect(1, 68000, '\P{Is_Script_Extensions=-	Meroitic_hieroglyphs}', "");
    Expect(0, 68000, '\P{^Is_Script_Extensions=-	Meroitic_hieroglyphs}', "");
    Error('\p{Is_Scx= :=Mero}');
    Error('\P{Is_Scx= :=Mero}');
    Expect(1, 67999, '\p{Is_Scx=mero}', "");
    Expect(0, 67999, '\p{^Is_Scx=mero}', "");
    Expect(0, 67999, '\P{Is_Scx=mero}', "");
    Expect(1, 67999, '\P{^Is_Scx=mero}', "");
    Expect(0, 68000, '\p{Is_Scx=mero}', "");
    Expect(1, 68000, '\p{^Is_Scx=mero}', "");
    Expect(1, 68000, '\P{Is_Scx=mero}', "");
    Expect(0, 68000, '\P{^Is_Scx=mero}', "");
    Expect(1, 67999, '\p{Is_Scx=	 Mero}', "");
    Expect(0, 67999, '\p{^Is_Scx=	 Mero}', "");
    Expect(0, 67999, '\P{Is_Scx=	 Mero}', "");
    Expect(1, 67999, '\P{^Is_Scx=	 Mero}', "");
    Expect(0, 68000, '\p{Is_Scx=	 Mero}', "");
    Expect(1, 68000, '\p{^Is_Scx=	 Mero}', "");
    Expect(1, 68000, '\P{Is_Scx=	 Mero}', "");
    Expect(0, 68000, '\P{^Is_Scx=	 Mero}', "");
    Error('\p{Script_Extensions:	_:=Malayalam}');
    Error('\P{Script_Extensions:	_:=Malayalam}');
    Expect(1, 43058, '\p{Script_Extensions=:\AMalayalam\z:}', "");;
    Expect(0, 43059, '\p{Script_Extensions=:\AMalayalam\z:}', "");;
    Expect(1, 43058, '\p{Script_Extensions=malayalam}', "");
    Expect(0, 43058, '\p{^Script_Extensions=malayalam}', "");
    Expect(0, 43058, '\P{Script_Extensions=malayalam}', "");
    Expect(1, 43058, '\P{^Script_Extensions=malayalam}', "");
    Expect(0, 43059, '\p{Script_Extensions=malayalam}', "");
    Expect(1, 43059, '\p{^Script_Extensions=malayalam}', "");
    Expect(1, 43059, '\P{Script_Extensions=malayalam}', "");
    Expect(0, 43059, '\P{^Script_Extensions=malayalam}', "");
    Expect(1, 43058, '\p{Script_Extensions=:\Amalayalam\z:}', "");;
    Expect(0, 43059, '\p{Script_Extensions=:\Amalayalam\z:}', "");;
    Expect(1, 43058, '\p{Script_Extensions:	- Malayalam}', "");
    Expect(0, 43058, '\p{^Script_Extensions:	- Malayalam}', "");
    Expect(0, 43058, '\P{Script_Extensions:	- Malayalam}', "");
    Expect(1, 43058, '\P{^Script_Extensions:	- Malayalam}', "");
    Expect(0, 43059, '\p{Script_Extensions:	- Malayalam}', "");
    Expect(1, 43059, '\p{^Script_Extensions:	- Malayalam}', "");
    Expect(1, 43059, '\P{Script_Extensions:	- Malayalam}', "");
    Expect(0, 43059, '\P{^Script_Extensions:	- Malayalam}', "");
    Error('\p{Scx:/a/ -Mlym}');
    Error('\P{Scx:/a/ -Mlym}');
    Expect(1, 43058, '\p{Scx=:\AMlym\z:}', "");;
    Expect(0, 43059, '\p{Scx=:\AMlym\z:}', "");;
    Expect(1, 43058, '\p{Scx=mlym}', "");
    Expect(0, 43058, '\p{^Scx=mlym}', "");
    Expect(0, 43058, '\P{Scx=mlym}', "");
    Expect(1, 43058, '\P{^Scx=mlym}', "");
    Expect(0, 43059, '\p{Scx=mlym}', "");
    Expect(1, 43059, '\p{^Scx=mlym}', "");
    Expect(1, 43059, '\P{Scx=mlym}', "");
    Expect(0, 43059, '\P{^Scx=mlym}', "");
    Expect(1, 43058, '\p{Scx=:\Amlym\z:}', "");;
    Expect(0, 43059, '\p{Scx=:\Amlym\z:}', "");;
    Expect(1, 43058, '\p{Scx=-MLYM}', "");
    Expect(0, 43058, '\p{^Scx=-MLYM}', "");
    Expect(0, 43058, '\P{Scx=-MLYM}', "");
    Expect(1, 43058, '\P{^Scx=-MLYM}', "");
    Expect(0, 43059, '\p{Scx=-MLYM}', "");
    Expect(1, 43059, '\p{^Scx=-MLYM}', "");
    Expect(1, 43059, '\P{Scx=-MLYM}', "");
    Expect(0, 43059, '\P{^Scx=-MLYM}', "");
    Error('\p{Is_Script_Extensions=:=_ Malayalam}');
    Error('\P{Is_Script_Extensions=:=_ Malayalam}');
    Expect(1, 43058, '\p{Is_Script_Extensions=malayalam}', "");
    Expect(0, 43058, '\p{^Is_Script_Extensions=malayalam}', "");
    Expect(0, 43058, '\P{Is_Script_Extensions=malayalam}', "");
    Expect(1, 43058, '\P{^Is_Script_Extensions=malayalam}', "");
    Expect(0, 43059, '\p{Is_Script_Extensions=malayalam}', "");
    Expect(1, 43059, '\p{^Is_Script_Extensions=malayalam}', "");
    Expect(1, 43059, '\P{Is_Script_Extensions=malayalam}', "");
    Expect(0, 43059, '\P{^Is_Script_Extensions=malayalam}', "");
    Expect(1, 43058, '\p{Is_Script_Extensions=	_MALAYALAM}', "");
    Expect(0, 43058, '\p{^Is_Script_Extensions=	_MALAYALAM}', "");
    Expect(0, 43058, '\P{Is_Script_Extensions=	_MALAYALAM}', "");
    Expect(1, 43058, '\P{^Is_Script_Extensions=	_MALAYALAM}', "");
    Expect(0, 43059, '\p{Is_Script_Extensions=	_MALAYALAM}', "");
    Expect(1, 43059, '\p{^Is_Script_Extensions=	_MALAYALAM}', "");
    Expect(1, 43059, '\P{Is_Script_Extensions=	_MALAYALAM}', "");
    Expect(0, 43059, '\P{^Is_Script_Extensions=	_MALAYALAM}', "");
    Error('\p{Is_Scx=:=_	Mlym}');
    Error('\P{Is_Scx=:=_	Mlym}');
    Expect(1, 43058, '\p{Is_Scx=mlym}', "");
    Expect(0, 43058, '\p{^Is_Scx=mlym}', "");
    Expect(0, 43058, '\P{Is_Scx=mlym}', "");
    Expect(1, 43058, '\P{^Is_Scx=mlym}', "");
    Expect(0, 43059, '\p{Is_Scx=mlym}', "");
    Expect(1, 43059, '\p{^Is_Scx=mlym}', "");
    Expect(1, 43059, '\P{Is_Scx=mlym}', "");
    Expect(0, 43059, '\P{^Is_Scx=mlym}', "");
    Expect(1, 43058, '\p{Is_Scx=	Mlym}', "");
    Expect(0, 43058, '\p{^Is_Scx=	Mlym}', "");
    Expect(0, 43058, '\P{Is_Scx=	Mlym}', "");
    Expect(1, 43058, '\P{^Is_Scx=	Mlym}', "");
    Expect(0, 43059, '\p{Is_Scx=	Mlym}', "");
    Expect(1, 43059, '\p{^Is_Scx=	Mlym}', "");
    Expect(1, 43059, '\P{Is_Scx=	Mlym}', "");
    Expect(0, 43059, '\P{^Is_Scx=	Mlym}', "");
    Error('\p{Script_Extensions= :=modi}');
    Error('\P{Script_Extensions= :=modi}');
    Expect(1, 71257, '\p{Script_Extensions=:\AModi\z:}', "");;
    Expect(0, 71258, '\p{Script_Extensions=:\AModi\z:}', "");;
    Expect(1, 71257, '\p{Script_Extensions=modi}', "");
    Expect(0, 71257, '\p{^Script_Extensions=modi}', "");
    Expect(0, 71257, '\P{Script_Extensions=modi}', "");
    Expect(1, 71257, '\P{^Script_Extensions=modi}', "");
    Expect(0, 71258, '\p{Script_Extensions=modi}', "");
    Expect(1, 71258, '\p{^Script_Extensions=modi}', "");
    Expect(1, 71258, '\P{Script_Extensions=modi}', "");
    Expect(0, 71258, '\P{^Script_Extensions=modi}', "");
    Expect(1, 71257, '\p{Script_Extensions=:\Amodi\z:}', "");;
    Expect(0, 71258, '\p{Script_Extensions=:\Amodi\z:}', "");;
    Expect(1, 71257, '\p{Script_Extensions=__MODI}', "");
    Expect(0, 71257, '\p{^Script_Extensions=__MODI}', "");
    Expect(0, 71257, '\P{Script_Extensions=__MODI}', "");
    Expect(1, 71257, '\P{^Script_Extensions=__MODI}', "");
    Expect(0, 71258, '\p{Script_Extensions=__MODI}', "");
    Expect(1, 71258, '\p{^Script_Extensions=__MODI}', "");
    Expect(1, 71258, '\P{Script_Extensions=__MODI}', "");
    Expect(0, 71258, '\P{^Script_Extensions=__MODI}', "");
    Error('\p{Scx:	/a/	Modi}');
    Error('\P{Scx:	/a/	Modi}');
    Expect(1, 71257, '\p{Scx=:\AModi\z:}', "");;
    Expect(0, 71258, '\p{Scx=:\AModi\z:}', "");;
    Expect(1, 71257, '\p{Scx=modi}', "");
    Expect(0, 71257, '\p{^Scx=modi}', "");
    Expect(0, 71257, '\P{Scx=modi}', "");
    Expect(1, 71257, '\P{^Scx=modi}', "");
    Expect(0, 71258, '\p{Scx=modi}', "");
    Expect(1, 71258, '\p{^Scx=modi}', "");
    Expect(1, 71258, '\P{Scx=modi}', "");
    Expect(0, 71258, '\P{^Scx=modi}', "");
    Expect(1, 71257, '\p{Scx=:\Amodi\z:}', "");;
    Expect(0, 71258, '\p{Scx=:\Amodi\z:}', "");;
    Expect(1, 71257, '\p{Scx=_Modi}', "");
    Expect(0, 71257, '\p{^Scx=_Modi}', "");
    Expect(0, 71257, '\P{Scx=_Modi}', "");
    Expect(1, 71257, '\P{^Scx=_Modi}', "");
    Expect(0, 71258, '\p{Scx=_Modi}', "");
    Expect(1, 71258, '\p{^Scx=_Modi}', "");
    Expect(1, 71258, '\P{Scx=_Modi}', "");
    Expect(0, 71258, '\P{^Scx=_Modi}', "");
    Error('\p{Is_Script_Extensions=-:=MODI}');
    Error('\P{Is_Script_Extensions=-:=MODI}');
    Expect(1, 71257, '\p{Is_Script_Extensions=modi}', "");
    Expect(0, 71257, '\p{^Is_Script_Extensions=modi}', "");
    Expect(0, 71257, '\P{Is_Script_Extensions=modi}', "");
    Expect(1, 71257, '\P{^Is_Script_Extensions=modi}', "");
    Expect(0, 71258, '\p{Is_Script_Extensions=modi}', "");
    Expect(1, 71258, '\p{^Is_Script_Extensions=modi}', "");
    Expect(1, 71258, '\P{Is_Script_Extensions=modi}', "");
    Expect(0, 71258, '\P{^Is_Script_Extensions=modi}', "");
    Expect(1, 71257, '\p{Is_Script_Extensions=- modi}', "");
    Expect(0, 71257, '\p{^Is_Script_Extensions=- modi}', "");
    Expect(0, 71257, '\P{Is_Script_Extensions=- modi}', "");
    Expect(1, 71257, '\P{^Is_Script_Extensions=- modi}', "");
    Expect(0, 71258, '\p{Is_Script_Extensions=- modi}', "");
    Expect(1, 71258, '\p{^Is_Script_Extensions=- modi}', "");
    Expect(1, 71258, '\P{Is_Script_Extensions=- modi}', "");
    Expect(0, 71258, '\P{^Is_Script_Extensions=- modi}', "");
    Error('\p{Is_Scx=:=_-modi}');
    Error('\P{Is_Scx=:=_-modi}');
    Expect(1, 71257, '\p{Is_Scx=modi}', "");
    Expect(0, 71257, '\p{^Is_Scx=modi}', "");
    Expect(0, 71257, '\P{Is_Scx=modi}', "");
    Expect(1, 71257, '\P{^Is_Scx=modi}', "");
    Expect(0, 71258, '\p{Is_Scx=modi}', "");
    Expect(1, 71258, '\p{^Is_Scx=modi}', "");
    Expect(1, 71258, '\P{Is_Scx=modi}', "");
    Expect(0, 71258, '\P{^Is_Scx=modi}', "");
    Expect(1, 71257, '\p{Is_Scx=		MODI}', "");
    Expect(0, 71257, '\p{^Is_Scx=		MODI}', "");
    Expect(0, 71257, '\P{Is_Scx=		MODI}', "");
    Expect(1, 71257, '\P{^Is_Scx=		MODI}', "");
    Expect(0, 71258, '\p{Is_Scx=		MODI}', "");
    Expect(1, 71258, '\p{^Is_Scx=		MODI}', "");
    Expect(1, 71258, '\P{Is_Scx=		MODI}', "");
    Expect(0, 71258, '\P{^Is_Scx=		MODI}', "");
    Error('\p{Script_Extensions=:=-	MONGOLIAN}');
    Error('\P{Script_Extensions=:=-	MONGOLIAN}');
    Expect(1, 71276, '\p{Script_Extensions=:\AMongolian\z:}', "");;
    Expect(0, 71277, '\p{Script_Extensions=:\AMongolian\z:}', "");;
    Expect(1, 71276, '\p{Script_Extensions=mongolian}', "");
    Expect(0, 71276, '\p{^Script_Extensions=mongolian}', "");
    Expect(0, 71276, '\P{Script_Extensions=mongolian}', "");
    Expect(1, 71276, '\P{^Script_Extensions=mongolian}', "");
    Expect(0, 71277, '\p{Script_Extensions=mongolian}', "");
    Expect(1, 71277, '\p{^Script_Extensions=mongolian}', "");
    Expect(1, 71277, '\P{Script_Extensions=mongolian}', "");
    Expect(0, 71277, '\P{^Script_Extensions=mongolian}', "");
    Expect(1, 71276, '\p{Script_Extensions=:\Amongolian\z:}', "");;
    Expect(0, 71277, '\p{Script_Extensions=:\Amongolian\z:}', "");;
    Expect(1, 71276, '\p{Script_Extensions=	-mongolian}', "");
    Expect(0, 71276, '\p{^Script_Extensions=	-mongolian}', "");
    Expect(0, 71276, '\P{Script_Extensions=	-mongolian}', "");
    Expect(1, 71276, '\P{^Script_Extensions=	-mongolian}', "");
    Expect(0, 71277, '\p{Script_Extensions=	-mongolian}', "");
    Expect(1, 71277, '\p{^Script_Extensions=	-mongolian}', "");
    Expect(1, 71277, '\P{Script_Extensions=	-mongolian}', "");
    Expect(0, 71277, '\P{^Script_Extensions=	-mongolian}', "");
    Error('\p{Scx= 	Mong/a/}');
    Error('\P{Scx= 	Mong/a/}');
    Expect(1, 71276, '\p{Scx=:\AMong\z:}', "");;
    Expect(0, 71277, '\p{Scx=:\AMong\z:}', "");;
    Expect(1, 71276, '\p{Scx:mong}', "");
    Expect(0, 71276, '\p{^Scx:mong}', "");
    Expect(0, 71276, '\P{Scx:mong}', "");
    Expect(1, 71276, '\P{^Scx:mong}', "");
    Expect(0, 71277, '\p{Scx:mong}', "");
    Expect(1, 71277, '\p{^Scx:mong}', "");
    Expect(1, 71277, '\P{Scx:mong}', "");
    Expect(0, 71277, '\P{^Scx:mong}', "");
    Expect(1, 71276, '\p{Scx=:\Among\z:}', "");;
    Expect(0, 71277, '\p{Scx=:\Among\z:}', "");;
    Expect(1, 71276, '\p{Scx=	-mong}', "");
    Expect(0, 71276, '\p{^Scx=	-mong}', "");
    Expect(0, 71276, '\P{Scx=	-mong}', "");
    Expect(1, 71276, '\P{^Scx=	-mong}', "");
    Expect(0, 71277, '\p{Scx=	-mong}', "");
    Expect(1, 71277, '\p{^Scx=	-mong}', "");
    Expect(1, 71277, '\P{Scx=	-mong}', "");
    Expect(0, 71277, '\P{^Scx=	-mong}', "");
    Error('\p{Is_Script_Extensions: /a/-_mongolian}');
    Error('\P{Is_Script_Extensions: /a/-_mongolian}');
    Expect(1, 71276, '\p{Is_Script_Extensions=mongolian}', "");
    Expect(0, 71276, '\p{^Is_Script_Extensions=mongolian}', "");
    Expect(0, 71276, '\P{Is_Script_Extensions=mongolian}', "");
    Expect(1, 71276, '\P{^Is_Script_Extensions=mongolian}', "");
    Expect(0, 71277, '\p{Is_Script_Extensions=mongolian}', "");
    Expect(1, 71277, '\p{^Is_Script_Extensions=mongolian}', "");
    Expect(1, 71277, '\P{Is_Script_Extensions=mongolian}', "");
    Expect(0, 71277, '\P{^Is_Script_Extensions=mongolian}', "");
    Expect(1, 71276, '\p{Is_Script_Extensions=_	mongolian}', "");
    Expect(0, 71276, '\p{^Is_Script_Extensions=_	mongolian}', "");
    Expect(0, 71276, '\P{Is_Script_Extensions=_	mongolian}', "");
    Expect(1, 71276, '\P{^Is_Script_Extensions=_	mongolian}', "");
    Expect(0, 71277, '\p{Is_Script_Extensions=_	mongolian}', "");
    Expect(1, 71277, '\p{^Is_Script_Extensions=_	mongolian}', "");
    Expect(1, 71277, '\P{Is_Script_Extensions=_	mongolian}', "");
    Expect(0, 71277, '\P{^Is_Script_Extensions=_	mongolian}', "");
    Error('\p{Is_Scx=:=_	mong}');
    Error('\P{Is_Scx=:=_	mong}');
    Expect(1, 71276, '\p{Is_Scx=mong}', "");
    Expect(0, 71276, '\p{^Is_Scx=mong}', "");
    Expect(0, 71276, '\P{Is_Scx=mong}', "");
    Expect(1, 71276, '\P{^Is_Scx=mong}', "");
    Expect(0, 71277, '\p{Is_Scx=mong}', "");
    Expect(1, 71277, '\p{^Is_Scx=mong}', "");
    Expect(1, 71277, '\P{Is_Scx=mong}', "");
    Expect(0, 71277, '\P{^Is_Scx=mong}', "");
    Expect(1, 71276, '\p{Is_Scx=	_Mong}', "");
    Expect(0, 71276, '\p{^Is_Scx=	_Mong}', "");
    Expect(0, 71276, '\P{Is_Scx=	_Mong}', "");
    Expect(1, 71276, '\P{^Is_Scx=	_Mong}', "");
    Expect(0, 71277, '\p{Is_Scx=	_Mong}', "");
    Expect(1, 71277, '\p{^Is_Scx=	_Mong}', "");
    Expect(1, 71277, '\P{Is_Scx=	_Mong}', "");
    Expect(0, 71277, '\P{^Is_Scx=	_Mong}', "");
    Error('\p{Script_Extensions=-/a/mro}');
    Error('\P{Script_Extensions=-/a/mro}');
    Expect(1, 92783, '\p{Script_Extensions=:\AMro\z:}', "");;
    Expect(0, 92784, '\p{Script_Extensions=:\AMro\z:}', "");;
    Expect(1, 92783, '\p{Script_Extensions=mro}', "");
    Expect(0, 92783, '\p{^Script_Extensions=mro}', "");
    Expect(0, 92783, '\P{Script_Extensions=mro}', "");
    Expect(1, 92783, '\P{^Script_Extensions=mro}', "");
    Expect(0, 92784, '\p{Script_Extensions=mro}', "");
    Expect(1, 92784, '\p{^Script_Extensions=mro}', "");
    Expect(1, 92784, '\P{Script_Extensions=mro}', "");
    Expect(0, 92784, '\P{^Script_Extensions=mro}', "");
    Expect(1, 92783, '\p{Script_Extensions=:\Amro\z:}', "");;
    Expect(0, 92784, '\p{Script_Extensions=:\Amro\z:}', "");;
    Expect(1, 92783, '\p{Script_Extensions= _mro}', "");
    Expect(0, 92783, '\p{^Script_Extensions= _mro}', "");
    Expect(0, 92783, '\P{Script_Extensions= _mro}', "");
    Expect(1, 92783, '\P{^Script_Extensions= _mro}', "");
    Expect(0, 92784, '\p{Script_Extensions= _mro}', "");
    Expect(1, 92784, '\p{^Script_Extensions= _mro}', "");
    Expect(1, 92784, '\P{Script_Extensions= _mro}', "");
    Expect(0, 92784, '\P{^Script_Extensions= _mro}', "");
    Error('\p{Scx=	MROO:=}');
    Error('\P{Scx=	MROO:=}');
    Expect(1, 92783, '\p{Scx=:\AMroo\z:}', "");;
    Expect(0, 92784, '\p{Scx=:\AMroo\z:}', "");;
    Expect(1, 92783, '\p{Scx=mroo}', "");
    Expect(0, 92783, '\p{^Scx=mroo}', "");
    Expect(0, 92783, '\P{Scx=mroo}', "");
    Expect(1, 92783, '\P{^Scx=mroo}', "");
    Expect(0, 92784, '\p{Scx=mroo}', "");
    Expect(1, 92784, '\p{^Scx=mroo}', "");
    Expect(1, 92784, '\P{Scx=mroo}', "");
    Expect(0, 92784, '\P{^Scx=mroo}', "");
    Expect(1, 92783, '\p{Scx=:\Amroo\z:}', "");;
    Expect(0, 92784, '\p{Scx=:\Amroo\z:}', "");;
    Expect(1, 92783, '\p{Scx: --Mroo}', "");
    Expect(0, 92783, '\p{^Scx: --Mroo}', "");
    Expect(0, 92783, '\P{Scx: --Mroo}', "");
    Expect(1, 92783, '\P{^Scx: --Mroo}', "");
    Expect(0, 92784, '\p{Scx: --Mroo}', "");
    Expect(1, 92784, '\p{^Scx: --Mroo}', "");
    Expect(1, 92784, '\P{Scx: --Mroo}', "");
    Expect(0, 92784, '\P{^Scx: --Mroo}', "");
    Error('\p{Is_Script_Extensions=_MRO/a/}');
    Error('\P{Is_Script_Extensions=_MRO/a/}');
    Expect(1, 92783, '\p{Is_Script_Extensions=mro}', "");
    Expect(0, 92783, '\p{^Is_Script_Extensions=mro}', "");
    Expect(0, 92783, '\P{Is_Script_Extensions=mro}', "");
    Expect(1, 92783, '\P{^Is_Script_Extensions=mro}', "");
    Expect(0, 92784, '\p{Is_Script_Extensions=mro}', "");
    Expect(1, 92784, '\p{^Is_Script_Extensions=mro}', "");
    Expect(1, 92784, '\P{Is_Script_Extensions=mro}', "");
    Expect(0, 92784, '\P{^Is_Script_Extensions=mro}', "");
    Expect(1, 92783, '\p{Is_Script_Extensions=	MRO}', "");
    Expect(0, 92783, '\p{^Is_Script_Extensions=	MRO}', "");
    Expect(0, 92783, '\P{Is_Script_Extensions=	MRO}', "");
    Expect(1, 92783, '\P{^Is_Script_Extensions=	MRO}', "");
    Expect(0, 92784, '\p{Is_Script_Extensions=	MRO}', "");
    Expect(1, 92784, '\p{^Is_Script_Extensions=	MRO}', "");
    Expect(1, 92784, '\P{Is_Script_Extensions=	MRO}', "");
    Expect(0, 92784, '\P{^Is_Script_Extensions=	MRO}', "");
    Error('\p{Is_Scx=_Mroo/a/}');
    Error('\P{Is_Scx=_Mroo/a/}');
    Expect(1, 92783, '\p{Is_Scx=mroo}', "");
    Expect(0, 92783, '\p{^Is_Scx=mroo}', "");
    Expect(0, 92783, '\P{Is_Scx=mroo}', "");
    Expect(1, 92783, '\P{^Is_Scx=mroo}', "");
    Expect(0, 92784, '\p{Is_Scx=mroo}', "");
    Expect(1, 92784, '\p{^Is_Scx=mroo}', "");
    Expect(1, 92784, '\P{Is_Scx=mroo}', "");
    Expect(0, 92784, '\P{^Is_Scx=mroo}', "");
    Expect(1, 92783, '\p{Is_Scx=	 mroo}', "");
    Expect(0, 92783, '\p{^Is_Scx=	 mroo}', "");
    Expect(0, 92783, '\P{Is_Scx=	 mroo}', "");
    Expect(1, 92783, '\P{^Is_Scx=	 mroo}', "");
    Expect(0, 92784, '\p{Is_Scx=	 mroo}', "");
    Expect(1, 92784, '\p{^Is_Scx=	 mroo}', "");
    Expect(1, 92784, '\P{Is_Scx=	 mroo}', "");
    Expect(0, 92784, '\P{^Is_Scx=	 mroo}', "");
    Error('\p{Script_Extensions= :=Meetei_mayek}');
    Error('\P{Script_Extensions= :=Meetei_mayek}');
    Expect(1, 44025, '\p{Script_Extensions=:\AMeetei_Mayek\z:}', "");;
    Expect(0, 44026, '\p{Script_Extensions=:\AMeetei_Mayek\z:}', "");;
    Expect(1, 44025, '\p{Script_Extensions=meeteimayek}', "");
    Expect(0, 44025, '\p{^Script_Extensions=meeteimayek}', "");
    Expect(0, 44025, '\P{Script_Extensions=meeteimayek}', "");
    Expect(1, 44025, '\P{^Script_Extensions=meeteimayek}', "");
    Expect(0, 44026, '\p{Script_Extensions=meeteimayek}', "");
    Expect(1, 44026, '\p{^Script_Extensions=meeteimayek}', "");
    Expect(1, 44026, '\P{Script_Extensions=meeteimayek}', "");
    Expect(0, 44026, '\P{^Script_Extensions=meeteimayek}', "");
    Expect(1, 44025, '\p{Script_Extensions=:\Ameeteimayek\z:}', "");;
    Expect(0, 44026, '\p{Script_Extensions=:\Ameeteimayek\z:}', "");;
    Expect(1, 44025, '\p{Script_Extensions= -Meetei_MAYEK}', "");
    Expect(0, 44025, '\p{^Script_Extensions= -Meetei_MAYEK}', "");
    Expect(0, 44025, '\P{Script_Extensions= -Meetei_MAYEK}', "");
    Expect(1, 44025, '\P{^Script_Extensions= -Meetei_MAYEK}', "");
    Expect(0, 44026, '\p{Script_Extensions= -Meetei_MAYEK}', "");
    Expect(1, 44026, '\p{^Script_Extensions= -Meetei_MAYEK}', "");
    Expect(1, 44026, '\P{Script_Extensions= -Meetei_MAYEK}', "");
    Expect(0, 44026, '\P{^Script_Extensions= -Meetei_MAYEK}', "");
    Error('\p{Scx=:=_Mtei}');
    Error('\P{Scx=:=_Mtei}');
    Expect(1, 44025, '\p{Scx=:\AMtei\z:}', "");;
    Expect(0, 44026, '\p{Scx=:\AMtei\z:}', "");;
    Expect(1, 44025, '\p{Scx: mtei}', "");
    Expect(0, 44025, '\p{^Scx: mtei}', "");
    Expect(0, 44025, '\P{Scx: mtei}', "");
    Expect(1, 44025, '\P{^Scx: mtei}', "");
    Expect(0, 44026, '\p{Scx: mtei}', "");
    Expect(1, 44026, '\p{^Scx: mtei}', "");
    Expect(1, 44026, '\P{Scx: mtei}', "");
    Expect(0, 44026, '\P{^Scx: mtei}', "");
    Expect(1, 44025, '\p{Scx=:\Amtei\z:}', "");;
    Expect(0, 44026, '\p{Scx=:\Amtei\z:}', "");;
    Expect(1, 44025, '\p{Scx=- Mtei}', "");
    Expect(0, 44025, '\p{^Scx=- Mtei}', "");
    Expect(0, 44025, '\P{Scx=- Mtei}', "");
    Expect(1, 44025, '\P{^Scx=- Mtei}', "");
    Expect(0, 44026, '\p{Scx=- Mtei}', "");
    Expect(1, 44026, '\p{^Scx=- Mtei}', "");
    Expect(1, 44026, '\P{Scx=- Mtei}', "");
    Expect(0, 44026, '\P{^Scx=- Mtei}', "");
    Error('\p{Is_Script_Extensions=/a/ _Meetei_MAYEK}');
    Error('\P{Is_Script_Extensions=/a/ _Meetei_MAYEK}');
    Expect(1, 44025, '\p{Is_Script_Extensions=meeteimayek}', "");
    Expect(0, 44025, '\p{^Is_Script_Extensions=meeteimayek}', "");
    Expect(0, 44025, '\P{Is_Script_Extensions=meeteimayek}', "");
    Expect(1, 44025, '\P{^Is_Script_Extensions=meeteimayek}', "");
    Expect(0, 44026, '\p{Is_Script_Extensions=meeteimayek}', "");
    Expect(1, 44026, '\p{^Is_Script_Extensions=meeteimayek}', "");
    Expect(1, 44026, '\P{Is_Script_Extensions=meeteimayek}', "");
    Expect(0, 44026, '\P{^Is_Script_Extensions=meeteimayek}', "");
    Expect(1, 44025, '\p{Is_Script_Extensions=	meetei_mayek}', "");
    Expect(0, 44025, '\p{^Is_Script_Extensions=	meetei_mayek}', "");
    Expect(0, 44025, '\P{Is_Script_Extensions=	meetei_mayek}', "");
    Expect(1, 44025, '\P{^Is_Script_Extensions=	meetei_mayek}', "");
    Expect(0, 44026, '\p{Is_Script_Extensions=	meetei_mayek}', "");
    Expect(1, 44026, '\p{^Is_Script_Extensions=	meetei_mayek}', "");
    Expect(1, 44026, '\P{Is_Script_Extensions=	meetei_mayek}', "");
    Expect(0, 44026, '\P{^Is_Script_Extensions=	meetei_mayek}', "");
    Error('\p{Is_Scx=__mtei/a/}');
    Error('\P{Is_Scx=__mtei/a/}');
    Expect(1, 44025, '\p{Is_Scx=mtei}', "");
    Expect(0, 44025, '\p{^Is_Scx=mtei}', "");
    Expect(0, 44025, '\P{Is_Scx=mtei}', "");
    Expect(1, 44025, '\P{^Is_Scx=mtei}', "");
    Expect(0, 44026, '\p{Is_Scx=mtei}', "");
    Expect(1, 44026, '\p{^Is_Scx=mtei}', "");
    Expect(1, 44026, '\P{Is_Scx=mtei}', "");
    Expect(0, 44026, '\P{^Is_Scx=mtei}', "");
    Expect(1, 44025, '\p{Is_Scx= 	Mtei}', "");
    Expect(0, 44025, '\p{^Is_Scx= 	Mtei}', "");
    Expect(0, 44025, '\P{Is_Scx= 	Mtei}', "");
    Expect(1, 44025, '\P{^Is_Scx= 	Mtei}', "");
    Expect(0, 44026, '\p{Is_Scx= 	Mtei}', "");
    Expect(1, 44026, '\p{^Is_Scx= 	Mtei}', "");
    Expect(1, 44026, '\P{Is_Scx= 	Mtei}', "");
    Expect(0, 44026, '\P{^Is_Scx= 	Mtei}', "");
    Error('\p{Script_Extensions:	 -Multani:=}');
    Error('\P{Script_Extensions:	 -Multani:=}');
    Expect(1, 70313, '\p{Script_Extensions=:\AMultani\z:}', "");;
    Expect(0, 70314, '\p{Script_Extensions=:\AMultani\z:}', "");;
    Expect(1, 70313, '\p{Script_Extensions=multani}', "");
    Expect(0, 70313, '\p{^Script_Extensions=multani}', "");
    Expect(0, 70313, '\P{Script_Extensions=multani}', "");
    Expect(1, 70313, '\P{^Script_Extensions=multani}', "");
    Expect(0, 70314, '\p{Script_Extensions=multani}', "");
    Expect(1, 70314, '\p{^Script_Extensions=multani}', "");
    Expect(1, 70314, '\P{Script_Extensions=multani}', "");
    Expect(0, 70314, '\P{^Script_Extensions=multani}', "");
    Expect(1, 70313, '\p{Script_Extensions=:\Amultani\z:}', "");;
    Expect(0, 70314, '\p{Script_Extensions=:\Amultani\z:}', "");;
    Expect(1, 70313, '\p{Script_Extensions=_ Multani}', "");
    Expect(0, 70313, '\p{^Script_Extensions=_ Multani}', "");
    Expect(0, 70313, '\P{Script_Extensions=_ Multani}', "");
    Expect(1, 70313, '\P{^Script_Extensions=_ Multani}', "");
    Expect(0, 70314, '\p{Script_Extensions=_ Multani}', "");
    Expect(1, 70314, '\p{^Script_Extensions=_ Multani}', "");
    Expect(1, 70314, '\P{Script_Extensions=_ Multani}', "");
    Expect(0, 70314, '\P{^Script_Extensions=_ Multani}', "");
    Error('\p{Scx=-:=Mult}');
    Error('\P{Scx=-:=Mult}');
    Expect(1, 70313, '\p{Scx=:\AMult\z:}', "");;
    Expect(0, 70314, '\p{Scx=:\AMult\z:}', "");;
    Expect(1, 70313, '\p{Scx=mult}', "");
    Expect(0, 70313, '\p{^Scx=mult}', "");
    Expect(0, 70313, '\P{Scx=mult}', "");
    Expect(1, 70313, '\P{^Scx=mult}', "");
    Expect(0, 70314, '\p{Scx=mult}', "");
    Expect(1, 70314, '\p{^Scx=mult}', "");
    Expect(1, 70314, '\P{Scx=mult}', "");
    Expect(0, 70314, '\P{^Scx=mult}', "");
    Expect(1, 70313, '\p{Scx=:\Amult\z:}', "");;
    Expect(0, 70314, '\p{Scx=:\Amult\z:}', "");;
    Expect(1, 70313, '\p{Scx=-_mult}', "");
    Expect(0, 70313, '\p{^Scx=-_mult}', "");
    Expect(0, 70313, '\P{Scx=-_mult}', "");
    Expect(1, 70313, '\P{^Scx=-_mult}', "");
    Expect(0, 70314, '\p{Scx=-_mult}', "");
    Expect(1, 70314, '\p{^Scx=-_mult}', "");
    Expect(1, 70314, '\P{Scx=-_mult}', "");
    Expect(0, 70314, '\P{^Scx=-_mult}', "");
    Error('\p{Is_Script_Extensions=-/a/multani}');
    Error('\P{Is_Script_Extensions=-/a/multani}');
    Expect(1, 70313, '\p{Is_Script_Extensions=multani}', "");
    Expect(0, 70313, '\p{^Is_Script_Extensions=multani}', "");
    Expect(0, 70313, '\P{Is_Script_Extensions=multani}', "");
    Expect(1, 70313, '\P{^Is_Script_Extensions=multani}', "");
    Expect(0, 70314, '\p{Is_Script_Extensions=multani}', "");
    Expect(1, 70314, '\p{^Is_Script_Extensions=multani}', "");
    Expect(1, 70314, '\P{Is_Script_Extensions=multani}', "");
    Expect(0, 70314, '\P{^Is_Script_Extensions=multani}', "");
    Expect(1, 70313, '\p{Is_Script_Extensions=-multani}', "");
    Expect(0, 70313, '\p{^Is_Script_Extensions=-multani}', "");
    Expect(0, 70313, '\P{Is_Script_Extensions=-multani}', "");
    Expect(1, 70313, '\P{^Is_Script_Extensions=-multani}', "");
    Expect(0, 70314, '\p{Is_Script_Extensions=-multani}', "");
    Expect(1, 70314, '\p{^Is_Script_Extensions=-multani}', "");
    Expect(1, 70314, '\P{Is_Script_Extensions=-multani}', "");
    Expect(0, 70314, '\P{^Is_Script_Extensions=-multani}', "");
    Error('\p{Is_Scx=	:=mult}');
    Error('\P{Is_Scx=	:=mult}');
    Expect(1, 70313, '\p{Is_Scx=mult}', "");
    Expect(0, 70313, '\p{^Is_Scx=mult}', "");
    Expect(0, 70313, '\P{Is_Scx=mult}', "");
    Expect(1, 70313, '\P{^Is_Scx=mult}', "");
    Expect(0, 70314, '\p{Is_Scx=mult}', "");
    Expect(1, 70314, '\p{^Is_Scx=mult}', "");
    Expect(1, 70314, '\P{Is_Scx=mult}', "");
    Expect(0, 70314, '\P{^Is_Scx=mult}', "");
    Expect(1, 70313, '\p{Is_Scx=_	mult}', "");
    Expect(0, 70313, '\p{^Is_Scx=_	mult}', "");
    Expect(0, 70313, '\P{Is_Scx=_	mult}', "");
    Expect(1, 70313, '\P{^Is_Scx=_	mult}', "");
    Expect(0, 70314, '\p{Is_Scx=_	mult}', "");
    Expect(1, 70314, '\p{^Is_Scx=_	mult}', "");
    Expect(1, 70314, '\P{Is_Scx=_	mult}', "");
    Expect(0, 70314, '\P{^Is_Scx=_	mult}', "");
    Error('\p{Script_Extensions=/a/	myanmar}');
    Error('\P{Script_Extensions=/a/	myanmar}');
    Expect(1, 43647, '\p{Script_Extensions=:\AMyanmar\z:}', "");;
    Expect(0, 43648, '\p{Script_Extensions=:\AMyanmar\z:}', "");;
    Expect(1, 43647, '\p{Script_Extensions=myanmar}', "");
    Expect(0, 43647, '\p{^Script_Extensions=myanmar}', "");
    Expect(0, 43647, '\P{Script_Extensions=myanmar}', "");
    Expect(1, 43647, '\P{^Script_Extensions=myanmar}', "");
    Expect(0, 43648, '\p{Script_Extensions=myanmar}', "");
    Expect(1, 43648, '\p{^Script_Extensions=myanmar}', "");
    Expect(1, 43648, '\P{Script_Extensions=myanmar}', "");
    Expect(0, 43648, '\P{^Script_Extensions=myanmar}', "");
    Expect(1, 43647, '\p{Script_Extensions=:\Amyanmar\z:}', "");;
    Expect(0, 43648, '\p{Script_Extensions=:\Amyanmar\z:}', "");;
    Expect(1, 43647, '\p{Script_Extensions= _Myanmar}', "");
    Expect(0, 43647, '\p{^Script_Extensions= _Myanmar}', "");
    Expect(0, 43647, '\P{Script_Extensions= _Myanmar}', "");
    Expect(1, 43647, '\P{^Script_Extensions= _Myanmar}', "");
    Expect(0, 43648, '\p{Script_Extensions= _Myanmar}', "");
    Expect(1, 43648, '\p{^Script_Extensions= _Myanmar}', "");
    Expect(1, 43648, '\P{Script_Extensions= _Myanmar}', "");
    Expect(0, 43648, '\P{^Script_Extensions= _Myanmar}', "");
    Error('\p{Scx=	Mymr/a/}');
    Error('\P{Scx=	Mymr/a/}');
    Expect(1, 43647, '\p{Scx=:\AMymr\z:}', "");;
    Expect(0, 43648, '\p{Scx=:\AMymr\z:}', "");;
    Expect(1, 43647, '\p{Scx:mymr}', "");
    Expect(0, 43647, '\p{^Scx:mymr}', "");
    Expect(0, 43647, '\P{Scx:mymr}', "");
    Expect(1, 43647, '\P{^Scx:mymr}', "");
    Expect(0, 43648, '\p{Scx:mymr}', "");
    Expect(1, 43648, '\p{^Scx:mymr}', "");
    Expect(1, 43648, '\P{Scx:mymr}', "");
    Expect(0, 43648, '\P{^Scx:mymr}', "");
    Expect(1, 43647, '\p{Scx=:\Amymr\z:}', "");;
    Expect(0, 43648, '\p{Scx=:\Amymr\z:}', "");;
    Expect(1, 43647, '\p{Scx:     Mymr}', "");
    Expect(0, 43647, '\p{^Scx:     Mymr}', "");
    Expect(0, 43647, '\P{Scx:     Mymr}', "");
    Expect(1, 43647, '\P{^Scx:     Mymr}', "");
    Expect(0, 43648, '\p{Scx:     Mymr}', "");
    Expect(1, 43648, '\p{^Scx:     Mymr}', "");
    Expect(1, 43648, '\P{Scx:     Mymr}', "");
    Expect(0, 43648, '\P{^Scx:     Mymr}', "");
    Error('\p{Is_Script_Extensions=/a/ _myanmar}');
    Error('\P{Is_Script_Extensions=/a/ _myanmar}');
    Expect(1, 43647, '\p{Is_Script_Extensions=myanmar}', "");
    Expect(0, 43647, '\p{^Is_Script_Extensions=myanmar}', "");
    Expect(0, 43647, '\P{Is_Script_Extensions=myanmar}', "");
    Expect(1, 43647, '\P{^Is_Script_Extensions=myanmar}', "");
    Expect(0, 43648, '\p{Is_Script_Extensions=myanmar}', "");
    Expect(1, 43648, '\p{^Is_Script_Extensions=myanmar}', "");
    Expect(1, 43648, '\P{Is_Script_Extensions=myanmar}', "");
    Expect(0, 43648, '\P{^Is_Script_Extensions=myanmar}', "");
    Expect(1, 43647, '\p{Is_Script_Extensions=	 Myanmar}', "");
    Expect(0, 43647, '\p{^Is_Script_Extensions=	 Myanmar}', "");
    Expect(0, 43647, '\P{Is_Script_Extensions=	 Myanmar}', "");
    Expect(1, 43647, '\P{^Is_Script_Extensions=	 Myanmar}', "");
    Expect(0, 43648, '\p{Is_Script_Extensions=	 Myanmar}', "");
    Expect(1, 43648, '\p{^Is_Script_Extensions=	 Myanmar}', "");
    Expect(1, 43648, '\P{Is_Script_Extensions=	 Myanmar}', "");
    Expect(0, 43648, '\P{^Is_Script_Extensions=	 Myanmar}', "");
    Error('\p{Is_Scx=	 Mymr:=}');
    Error('\P{Is_Scx=	 Mymr:=}');
    Expect(1, 43647, '\p{Is_Scx=mymr}', "");
    Expect(0, 43647, '\p{^Is_Scx=mymr}', "");
    Expect(0, 43647, '\P{Is_Scx=mymr}', "");
    Expect(1, 43647, '\P{^Is_Scx=mymr}', "");
    Expect(0, 43648, '\p{Is_Scx=mymr}', "");
    Expect(1, 43648, '\p{^Is_Scx=mymr}', "");
    Expect(1, 43648, '\P{Is_Scx=mymr}', "");
    Expect(0, 43648, '\P{^Is_Scx=mymr}', "");
    Expect(1, 43647, '\p{Is_Scx= Mymr}', "");
    Expect(0, 43647, '\p{^Is_Scx= Mymr}', "");
    Expect(0, 43647, '\P{Is_Scx= Mymr}', "");
    Expect(1, 43647, '\P{^Is_Scx= Mymr}', "");
    Expect(0, 43648, '\p{Is_Scx= Mymr}', "");
    Expect(1, 43648, '\p{^Is_Scx= Mymr}', "");
    Expect(1, 43648, '\P{Is_Scx= Mymr}', "");
    Expect(0, 43648, '\P{^Is_Scx= Mymr}', "");
    Error('\p{Script_Extensions=:=	Nag_mundari}');
    Error('\P{Script_Extensions=:=	Nag_mundari}');
    Expect(1, 124153, '\p{Script_Extensions=:\ANag_Mundari\z:}', "");;
    Expect(0, 124154, '\p{Script_Extensions=:\ANag_Mundari\z:}', "");;
    Expect(1, 124153, '\p{Script_Extensions:	nagmundari}', "");
    Expect(0, 124153, '\p{^Script_Extensions:	nagmundari}', "");
    Expect(0, 124153, '\P{Script_Extensions:	nagmundari}', "");
    Expect(1, 124153, '\P{^Script_Extensions:	nagmundari}', "");
    Expect(0, 124154, '\p{Script_Extensions:	nagmundari}', "");
    Expect(1, 124154, '\p{^Script_Extensions:	nagmundari}', "");
    Expect(1, 124154, '\P{Script_Extensions:	nagmundari}', "");
    Expect(0, 124154, '\P{^Script_Extensions:	nagmundari}', "");
    Expect(1, 124153, '\p{Script_Extensions=:\Anagmundari\z:}', "");;
    Expect(0, 124154, '\p{Script_Extensions=:\Anagmundari\z:}', "");;
    Expect(1, 124153, '\p{Script_Extensions= -Nag_MUNDARI}', "");
    Expect(0, 124153, '\p{^Script_Extensions= -Nag_MUNDARI}', "");
    Expect(0, 124153, '\P{Script_Extensions= -Nag_MUNDARI}', "");
    Expect(1, 124153, '\P{^Script_Extensions= -Nag_MUNDARI}', "");
    Expect(0, 124154, '\p{Script_Extensions= -Nag_MUNDARI}', "");
    Expect(1, 124154, '\p{^Script_Extensions= -Nag_MUNDARI}', "");
    Expect(1, 124154, '\P{Script_Extensions= -Nag_MUNDARI}', "");
    Expect(0, 124154, '\P{^Script_Extensions= -Nag_MUNDARI}', "");
    Error('\p{Scx=-_Nagm/a/}');
    Error('\P{Scx=-_Nagm/a/}');
    Expect(1, 124153, '\p{Scx=:\ANagm\z:}', "");;
    Expect(0, 124154, '\p{Scx=:\ANagm\z:}', "");;
    Expect(1, 124153, '\p{Scx:nagm}', "");
    Expect(0, 124153, '\p{^Scx:nagm}', "");
    Expect(0, 124153, '\P{Scx:nagm}', "");
    Expect(1, 124153, '\P{^Scx:nagm}', "");
    Expect(0, 124154, '\p{Scx:nagm}', "");
    Expect(1, 124154, '\p{^Scx:nagm}', "");
    Expect(1, 124154, '\P{Scx:nagm}', "");
    Expect(0, 124154, '\P{^Scx:nagm}', "");
    Expect(1, 124153, '\p{Scx=:\Anagm\z:}', "");;
    Expect(0, 124154, '\p{Scx=:\Anagm\z:}', "");;
    Expect(1, 124153, '\p{Scx= Nagm}', "");
    Expect(0, 124153, '\p{^Scx= Nagm}', "");
    Expect(0, 124153, '\P{Scx= Nagm}', "");
    Expect(1, 124153, '\P{^Scx= Nagm}', "");
    Expect(0, 124154, '\p{Scx= Nagm}', "");
    Expect(1, 124154, '\p{^Scx= Nagm}', "");
    Expect(1, 124154, '\P{Scx= Nagm}', "");
    Expect(0, 124154, '\P{^Scx= Nagm}', "");
    Error('\p{Is_Script_Extensions=/a/_Nag_Mundari}');
    Error('\P{Is_Script_Extensions=/a/_Nag_Mundari}');
    Expect(1, 124153, '\p{Is_Script_Extensions=nagmundari}', "");
    Expect(0, 124153, '\p{^Is_Script_Extensions=nagmundari}', "");
    Expect(0, 124153, '\P{Is_Script_Extensions=nagmundari}', "");
    Expect(1, 124153, '\P{^Is_Script_Extensions=nagmundari}', "");
    Expect(0, 124154, '\p{Is_Script_Extensions=nagmundari}', "");
    Expect(1, 124154, '\p{^Is_Script_Extensions=nagmundari}', "");
    Expect(1, 124154, '\P{Is_Script_Extensions=nagmundari}', "");
    Expect(0, 124154, '\P{^Is_Script_Extensions=nagmundari}', "");
    Expect(1, 124153, '\p{Is_Script_Extensions=--nag_Mundari}', "");
    Expect(0, 124153, '\p{^Is_Script_Extensions=--nag_Mundari}', "");
    Expect(0, 124153, '\P{Is_Script_Extensions=--nag_Mundari}', "");
    Expect(1, 124153, '\P{^Is_Script_Extensions=--nag_Mundari}', "");
    Expect(0, 124154, '\p{Is_Script_Extensions=--nag_Mundari}', "");
    Expect(1, 124154, '\p{^Is_Script_Extensions=--nag_Mundari}', "");
    Expect(1, 124154, '\P{Is_Script_Extensions=--nag_Mundari}', "");
    Expect(0, 124154, '\P{^Is_Script_Extensions=--nag_Mundari}', "");
    Error('\p{Is_Scx= :=Nagm}');
    Error('\P{Is_Scx= :=Nagm}');
    Expect(1, 124153, '\p{Is_Scx=nagm}', "");
    Expect(0, 124153, '\p{^Is_Scx=nagm}', "");
    Expect(0, 124153, '\P{Is_Scx=nagm}', "");
    Expect(1, 124153, '\P{^Is_Scx=nagm}', "");
    Expect(0, 124154, '\p{Is_Scx=nagm}', "");
    Expect(1, 124154, '\p{^Is_Scx=nagm}', "");
    Expect(1, 124154, '\P{Is_Scx=nagm}', "");
    Expect(0, 124154, '\P{^Is_Scx=nagm}', "");
    Expect(1, 124153, '\p{Is_Scx= 	nagm}', "");
    Expect(0, 124153, '\p{^Is_Scx= 	nagm}', "");
    Expect(0, 124153, '\P{Is_Scx= 	nagm}', "");
    Expect(1, 124153, '\P{^Is_Scx= 	nagm}', "");
    Expect(0, 124154, '\p{Is_Scx= 	nagm}', "");
    Expect(1, 124154, '\p{^Is_Scx= 	nagm}', "");
    Expect(1, 124154, '\P{Is_Scx= 	nagm}', "");
    Expect(0, 124154, '\P{^Is_Scx= 	nagm}', "");
    Error('\p{Script_Extensions=	:=Nandinagari}');
    Error('\P{Script_Extensions=	:=Nandinagari}');
    Expect(1, 72164, '\p{Script_Extensions=:\ANandinagari\z:}', "");;
    Expect(0, 72165, '\p{Script_Extensions=:\ANandinagari\z:}', "");;
    Expect(1, 72164, '\p{Script_Extensions=nandinagari}', "");
    Expect(0, 72164, '\p{^Script_Extensions=nandinagari}', "");
    Expect(0, 72164, '\P{Script_Extensions=nandinagari}', "");
    Expect(1, 72164, '\P{^Script_Extensions=nandinagari}', "");
    Expect(0, 72165, '\p{Script_Extensions=nandinagari}', "");
    Expect(1, 72165, '\p{^Script_Extensions=nandinagari}', "");
    Expect(1, 72165, '\P{Script_Extensions=nandinagari}', "");
    Expect(0, 72165, '\P{^Script_Extensions=nandinagari}', "");
    Expect(1, 72164, '\p{Script_Extensions=:\Anandinagari\z:}', "");;
    Expect(0, 72165, '\p{Script_Extensions=:\Anandinagari\z:}', "");;
    Expect(1, 72164, '\p{Script_Extensions= _NANDINAGARI}', "");
    Expect(0, 72164, '\p{^Script_Extensions= _NANDINAGARI}', "");
    Expect(0, 72164, '\P{Script_Extensions= _NANDINAGARI}', "");
    Expect(1, 72164, '\P{^Script_Extensions= _NANDINAGARI}', "");
    Expect(0, 72165, '\p{Script_Extensions= _NANDINAGARI}', "");
    Expect(1, 72165, '\p{^Script_Extensions= _NANDINAGARI}', "");
    Expect(1, 72165, '\P{Script_Extensions= _NANDINAGARI}', "");
    Expect(0, 72165, '\P{^Script_Extensions= _NANDINAGARI}', "");
    Error('\p{Scx=	 Nand/a/}');
    Error('\P{Scx=	 Nand/a/}');
    Expect(1, 72164, '\p{Scx=:\ANand\z:}', "");;
    Expect(0, 72165, '\p{Scx=:\ANand\z:}', "");;
    Expect(1, 72164, '\p{Scx=nand}', "");
    Expect(0, 72164, '\p{^Scx=nand}', "");
    Expect(0, 72164, '\P{Scx=nand}', "");
    Expect(1, 72164, '\P{^Scx=nand}', "");
    Expect(0, 72165, '\p{Scx=nand}', "");
    Expect(1, 72165, '\p{^Scx=nand}', "");
    Expect(1, 72165, '\P{Scx=nand}', "");
    Expect(0, 72165, '\P{^Scx=nand}', "");
    Expect(1, 72164, '\p{Scx=:\Anand\z:}', "");;
    Expect(0, 72165, '\p{Scx=:\Anand\z:}', "");;
    Expect(1, 72164, '\p{Scx:   -Nand}', "");
    Expect(0, 72164, '\p{^Scx:   -Nand}', "");
    Expect(0, 72164, '\P{Scx:   -Nand}', "");
    Expect(1, 72164, '\P{^Scx:   -Nand}', "");
    Expect(0, 72165, '\p{Scx:   -Nand}', "");
    Expect(1, 72165, '\p{^Scx:   -Nand}', "");
    Expect(1, 72165, '\P{Scx:   -Nand}', "");
    Expect(0, 72165, '\P{^Scx:   -Nand}', "");
    Error('\p{Is_Script_Extensions:   -:=NANDINAGARI}');
    Error('\P{Is_Script_Extensions:   -:=NANDINAGARI}');
    Expect(1, 72164, '\p{Is_Script_Extensions=nandinagari}', "");
    Expect(0, 72164, '\p{^Is_Script_Extensions=nandinagari}', "");
    Expect(0, 72164, '\P{Is_Script_Extensions=nandinagari}', "");
    Expect(1, 72164, '\P{^Is_Script_Extensions=nandinagari}', "");
    Expect(0, 72165, '\p{Is_Script_Extensions=nandinagari}', "");
    Expect(1, 72165, '\p{^Is_Script_Extensions=nandinagari}', "");
    Expect(1, 72165, '\P{Is_Script_Extensions=nandinagari}', "");
    Expect(0, 72165, '\P{^Is_Script_Extensions=nandinagari}', "");
    Expect(1, 72164, '\p{Is_Script_Extensions=	-Nandinagari}', "");
    Expect(0, 72164, '\p{^Is_Script_Extensions=	-Nandinagari}', "");
    Expect(0, 72164, '\P{Is_Script_Extensions=	-Nandinagari}', "");
    Expect(1, 72164, '\P{^Is_Script_Extensions=	-Nandinagari}', "");
    Expect(0, 72165, '\p{Is_Script_Extensions=	-Nandinagari}', "");
    Expect(1, 72165, '\p{^Is_Script_Extensions=	-Nandinagari}', "");
    Expect(1, 72165, '\P{Is_Script_Extensions=	-Nandinagari}', "");
    Expect(0, 72165, '\P{^Is_Script_Extensions=	-Nandinagari}', "");
    Error('\p{Is_Scx=/a/nand}');
    Error('\P{Is_Scx=/a/nand}');
    Expect(1, 72164, '\p{Is_Scx=nand}', "");
    Expect(0, 72164, '\p{^Is_Scx=nand}', "");
    Expect(0, 72164, '\P{Is_Scx=nand}', "");
    Expect(1, 72164, '\P{^Is_Scx=nand}', "");
    Expect(0, 72165, '\p{Is_Scx=nand}', "");
    Expect(1, 72165, '\p{^Is_Scx=nand}', "");
    Expect(1, 72165, '\P{Is_Scx=nand}', "");
    Expect(0, 72165, '\P{^Is_Scx=nand}', "");
    Expect(1, 72164, '\p{Is_Scx=	 Nand}', "");
    Expect(0, 72164, '\p{^Is_Scx=	 Nand}', "");
    Expect(0, 72164, '\P{Is_Scx=	 Nand}', "");
    Expect(1, 72164, '\P{^Is_Scx=	 Nand}', "");
    Expect(0, 72165, '\p{Is_Scx=	 Nand}', "");
    Expect(1, 72165, '\p{^Is_Scx=	 Nand}', "");
    Expect(1, 72165, '\P{Is_Scx=	 Nand}', "");
    Expect(0, 72165, '\P{^Is_Scx=	 Nand}', "");
    Error('\p{Script_Extensions=/a/	_Old_North_Arabian}');
    Error('\P{Script_Extensions=/a/	_Old_North_Arabian}');
    Expect(1, 68255, '\p{Script_Extensions=:\AOld_North_Arabian\z:}', "");;
    Expect(0, 68256, '\p{Script_Extensions=:\AOld_North_Arabian\z:}', "");;
    Expect(1, 68255, '\p{Script_Extensions=oldnortharabian}', "");
    Expect(0, 68255, '\p{^Script_Extensions=oldnortharabian}', "");
    Expect(0, 68255, '\P{Script_Extensions=oldnortharabian}', "");
    Expect(1, 68255, '\P{^Script_Extensions=oldnortharabian}', "");
    Expect(0, 68256, '\p{Script_Extensions=oldnortharabian}', "");
    Expect(1, 68256, '\p{^Script_Extensions=oldnortharabian}', "");
    Expect(1, 68256, '\P{Script_Extensions=oldnortharabian}', "");
    Expect(0, 68256, '\P{^Script_Extensions=oldnortharabian}', "");
    Expect(1, 68255, '\p{Script_Extensions=:\Aoldnortharabian\z:}', "");;
    Expect(0, 68256, '\p{Script_Extensions=:\Aoldnortharabian\z:}', "");;
    Expect(1, 68255, '\p{Script_Extensions= 	OLD_North_Arabian}', "");
    Expect(0, 68255, '\p{^Script_Extensions= 	OLD_North_Arabian}', "");
    Expect(0, 68255, '\P{Script_Extensions= 	OLD_North_Arabian}', "");
    Expect(1, 68255, '\P{^Script_Extensions= 	OLD_North_Arabian}', "");
    Expect(0, 68256, '\p{Script_Extensions= 	OLD_North_Arabian}', "");
    Expect(1, 68256, '\p{^Script_Extensions= 	OLD_North_Arabian}', "");
    Expect(1, 68256, '\P{Script_Extensions= 	OLD_North_Arabian}', "");
    Expect(0, 68256, '\P{^Script_Extensions= 	OLD_North_Arabian}', "");
    Error('\p{Scx= NARB/a/}');
    Error('\P{Scx= NARB/a/}');
    Expect(1, 68255, '\p{Scx=:\ANarb\z:}', "");;
    Expect(0, 68256, '\p{Scx=:\ANarb\z:}', "");;
    Expect(1, 68255, '\p{Scx:   narb}', "");
    Expect(0, 68255, '\p{^Scx:   narb}', "");
    Expect(0, 68255, '\P{Scx:   narb}', "");
    Expect(1, 68255, '\P{^Scx:   narb}', "");
    Expect(0, 68256, '\p{Scx:   narb}', "");
    Expect(1, 68256, '\p{^Scx:   narb}', "");
    Expect(1, 68256, '\P{Scx:   narb}', "");
    Expect(0, 68256, '\P{^Scx:   narb}', "");
    Expect(1, 68255, '\p{Scx=:\Anarb\z:}', "");;
    Expect(0, 68256, '\p{Scx=:\Anarb\z:}', "");;
    Expect(1, 68255, '\p{Scx: - narb}', "");
    Expect(0, 68255, '\p{^Scx: - narb}', "");
    Expect(0, 68255, '\P{Scx: - narb}', "");
    Expect(1, 68255, '\P{^Scx: - narb}', "");
    Expect(0, 68256, '\p{Scx: - narb}', "");
    Expect(1, 68256, '\p{^Scx: - narb}', "");
    Expect(1, 68256, '\P{Scx: - narb}', "");
    Expect(0, 68256, '\P{^Scx: - narb}', "");
    Error('\p{Is_Script_Extensions:    	OLD_north_Arabian:=}');
    Error('\P{Is_Script_Extensions:    	OLD_north_Arabian:=}');
    Expect(1, 68255, '\p{Is_Script_Extensions=oldnortharabian}', "");
    Expect(0, 68255, '\p{^Is_Script_Extensions=oldnortharabian}', "");
    Expect(0, 68255, '\P{Is_Script_Extensions=oldnortharabian}', "");
    Expect(1, 68255, '\P{^Is_Script_Extensions=oldnortharabian}', "");
    Expect(0, 68256, '\p{Is_Script_Extensions=oldnortharabian}', "");
    Expect(1, 68256, '\p{^Is_Script_Extensions=oldnortharabian}', "");
    Expect(1, 68256, '\P{Is_Script_Extensions=oldnortharabian}', "");
    Expect(0, 68256, '\P{^Is_Script_Extensions=oldnortharabian}', "");
    Expect(1, 68255, '\p{Is_Script_Extensions= 	old_North_ARABIAN}', "");
    Expect(0, 68255, '\p{^Is_Script_Extensions= 	old_North_ARABIAN}', "");
    Expect(0, 68255, '\P{Is_Script_Extensions= 	old_North_ARABIAN}', "");
    Expect(1, 68255, '\P{^Is_Script_Extensions= 	old_North_ARABIAN}', "");
    Expect(0, 68256, '\p{Is_Script_Extensions= 	old_North_ARABIAN}', "");
    Expect(1, 68256, '\p{^Is_Script_Extensions= 	old_North_ARABIAN}', "");
    Expect(1, 68256, '\P{Is_Script_Extensions= 	old_North_ARABIAN}', "");
    Expect(0, 68256, '\P{^Is_Script_Extensions= 	old_North_ARABIAN}', "");
    Error('\p{Is_Scx=:=_-Narb}');
    Error('\P{Is_Scx=:=_-Narb}');
    Expect(1, 68255, '\p{Is_Scx=narb}', "");
    Expect(0, 68255, '\p{^Is_Scx=narb}', "");
    Expect(0, 68255, '\P{Is_Scx=narb}', "");
    Expect(1, 68255, '\P{^Is_Scx=narb}', "");
    Expect(0, 68256, '\p{Is_Scx=narb}', "");
    Expect(1, 68256, '\p{^Is_Scx=narb}', "");
    Expect(1, 68256, '\P{Is_Scx=narb}', "");
    Expect(0, 68256, '\P{^Is_Scx=narb}', "");
    Expect(1, 68255, '\p{Is_Scx= _Narb}', "");
    Expect(0, 68255, '\p{^Is_Scx= _Narb}', "");
    Expect(0, 68255, '\P{Is_Scx= _Narb}', "");
    Expect(1, 68255, '\P{^Is_Scx= _Narb}', "");
    Expect(0, 68256, '\p{Is_Scx= _Narb}', "");
    Expect(1, 68256, '\p{^Is_Scx= _Narb}', "");
    Expect(1, 68256, '\P{Is_Scx= _Narb}', "");
    Expect(0, 68256, '\P{^Is_Scx= _Narb}', "");
    Error('\p{Script_Extensions=:=--Nabataean}');
    Error('\P{Script_Extensions=:=--Nabataean}');
    Expect(1, 67759, '\p{Script_Extensions=:\ANabataean\z:}', "");;
    Expect(0, 67760, '\p{Script_Extensions=:\ANabataean\z:}', "");;
    Expect(1, 67759, '\p{Script_Extensions=nabataean}', "");
    Expect(0, 67759, '\p{^Script_Extensions=nabataean}', "");
    Expect(0, 67759, '\P{Script_Extensions=nabataean}', "");
    Expect(1, 67759, '\P{^Script_Extensions=nabataean}', "");
    Expect(0, 67760, '\p{Script_Extensions=nabataean}', "");
    Expect(1, 67760, '\p{^Script_Extensions=nabataean}', "");
    Expect(1, 67760, '\P{Script_Extensions=nabataean}', "");
    Expect(0, 67760, '\P{^Script_Extensions=nabataean}', "");
    Expect(1, 67759, '\p{Script_Extensions=:\Anabataean\z:}', "");;
    Expect(0, 67760, '\p{Script_Extensions=:\Anabataean\z:}', "");;
    Expect(1, 67759, '\p{Script_Extensions=	nabataean}', "");
    Expect(0, 67759, '\p{^Script_Extensions=	nabataean}', "");
    Expect(0, 67759, '\P{Script_Extensions=	nabataean}', "");
    Expect(1, 67759, '\P{^Script_Extensions=	nabataean}', "");
    Expect(0, 67760, '\p{Script_Extensions=	nabataean}', "");
    Expect(1, 67760, '\p{^Script_Extensions=	nabataean}', "");
    Expect(1, 67760, '\P{Script_Extensions=	nabataean}', "");
    Expect(0, 67760, '\P{^Script_Extensions=	nabataean}', "");
    Error('\p{Scx=/a/- NBAT}');
    Error('\P{Scx=/a/- NBAT}');
    Expect(1, 67759, '\p{Scx=:\ANbat\z:}', "");;
    Expect(0, 67760, '\p{Scx=:\ANbat\z:}', "");;
    Expect(1, 67759, '\p{Scx=nbat}', "");
    Expect(0, 67759, '\p{^Scx=nbat}', "");
    Expect(0, 67759, '\P{Scx=nbat}', "");
    Expect(1, 67759, '\P{^Scx=nbat}', "");
    Expect(0, 67760, '\p{Scx=nbat}', "");
    Expect(1, 67760, '\p{^Scx=nbat}', "");
    Expect(1, 67760, '\P{Scx=nbat}', "");
    Expect(0, 67760, '\P{^Scx=nbat}', "");
    Expect(1, 67759, '\p{Scx=:\Anbat\z:}', "");;
    Expect(0, 67760, '\p{Scx=:\Anbat\z:}', "");;
    Expect(1, 67759, '\p{Scx=	Nbat}', "");
    Expect(0, 67759, '\p{^Scx=	Nbat}', "");
    Expect(0, 67759, '\P{Scx=	Nbat}', "");
    Expect(1, 67759, '\P{^Scx=	Nbat}', "");
    Expect(0, 67760, '\p{Scx=	Nbat}', "");
    Expect(1, 67760, '\p{^Scx=	Nbat}', "");
    Expect(1, 67760, '\P{Scx=	Nbat}', "");
    Expect(0, 67760, '\P{^Scx=	Nbat}', "");
    Error('\p{Is_Script_Extensions=/a/- Nabataean}');
    Error('\P{Is_Script_Extensions=/a/- Nabataean}');
    Expect(1, 67759, '\p{Is_Script_Extensions=nabataean}', "");
    Expect(0, 67759, '\p{^Is_Script_Extensions=nabataean}', "");
    Expect(0, 67759, '\P{Is_Script_Extensions=nabataean}', "");
    Expect(1, 67759, '\P{^Is_Script_Extensions=nabataean}', "");
    Expect(0, 67760, '\p{Is_Script_Extensions=nabataean}', "");
    Expect(1, 67760, '\p{^Is_Script_Extensions=nabataean}', "");
    Expect(1, 67760, '\P{Is_Script_Extensions=nabataean}', "");
    Expect(0, 67760, '\P{^Is_Script_Extensions=nabataean}', "");
    Expect(1, 67759, '\p{Is_Script_Extensions:  Nabataean}', "");
    Expect(0, 67759, '\p{^Is_Script_Extensions:  Nabataean}', "");
    Expect(0, 67759, '\P{Is_Script_Extensions:  Nabataean}', "");
    Expect(1, 67759, '\P{^Is_Script_Extensions:  Nabataean}', "");
    Expect(0, 67760, '\p{Is_Script_Extensions:  Nabataean}', "");
    Expect(1, 67760, '\p{^Is_Script_Extensions:  Nabataean}', "");
    Expect(1, 67760, '\P{Is_Script_Extensions:  Nabataean}', "");
    Expect(0, 67760, '\P{^Is_Script_Extensions:  Nabataean}', "");
    Error('\p{Is_Scx=:=-_Nbat}');
    Error('\P{Is_Scx=:=-_Nbat}');
    Expect(1, 67759, '\p{Is_Scx=nbat}', "");
    Expect(0, 67759, '\p{^Is_Scx=nbat}', "");
    Expect(0, 67759, '\P{Is_Scx=nbat}', "");
    Expect(1, 67759, '\P{^Is_Scx=nbat}', "");
    Expect(0, 67760, '\p{Is_Scx=nbat}', "");
    Expect(1, 67760, '\p{^Is_Scx=nbat}', "");
    Expect(1, 67760, '\P{Is_Scx=nbat}', "");
    Expect(0, 67760, '\P{^Is_Scx=nbat}', "");
    Expect(1, 67759, '\p{Is_Scx=_NBAT}', "");
    Expect(0, 67759, '\p{^Is_Scx=_NBAT}', "");
    Expect(0, 67759, '\P{Is_Scx=_NBAT}', "");
    Expect(1, 67759, '\P{^Is_Scx=_NBAT}', "");
    Expect(0, 67760, '\p{Is_Scx=_NBAT}', "");
    Expect(1, 67760, '\p{^Is_Scx=_NBAT}', "");
    Expect(1, 67760, '\P{Is_Scx=_NBAT}', "");
    Expect(0, 67760, '\P{^Is_Scx=_NBAT}', "");
    Error('\p{Script_Extensions=_:=Newa}');
    Error('\P{Script_Extensions=_:=Newa}');
    Expect(1, 70753, '\p{Script_Extensions=:\ANewa\z:}', "");;
    Expect(0, 70754, '\p{Script_Extensions=:\ANewa\z:}', "");;
    Expect(1, 70753, '\p{Script_Extensions=newa}', "");
    Expect(0, 70753, '\p{^Script_Extensions=newa}', "");
    Expect(0, 70753, '\P{Script_Extensions=newa}', "");
    Expect(1, 70753, '\P{^Script_Extensions=newa}', "");
    Expect(0, 70754, '\p{Script_Extensions=newa}', "");
    Expect(1, 70754, '\p{^Script_Extensions=newa}', "");
    Expect(1, 70754, '\P{Script_Extensions=newa}', "");
    Expect(0, 70754, '\P{^Script_Extensions=newa}', "");
    Expect(1, 70753, '\p{Script_Extensions=:\Anewa\z:}', "");;
    Expect(0, 70754, '\p{Script_Extensions=:\Anewa\z:}', "");;
    Expect(1, 70753, '\p{Script_Extensions=  Newa}', "");
    Expect(0, 70753, '\p{^Script_Extensions=  Newa}', "");
    Expect(0, 70753, '\P{Script_Extensions=  Newa}', "");
    Expect(1, 70753, '\P{^Script_Extensions=  Newa}', "");
    Expect(0, 70754, '\p{Script_Extensions=  Newa}', "");
    Expect(1, 70754, '\p{^Script_Extensions=  Newa}', "");
    Expect(1, 70754, '\P{Script_Extensions=  Newa}', "");
    Expect(0, 70754, '\P{^Script_Extensions=  Newa}', "");
    Error('\p{Scx=/a/_ Newa}');
    Error('\P{Scx=/a/_ Newa}');
    Expect(1, 70753, '\p{Scx=:\ANewa\z:}', "");;
    Expect(0, 70754, '\p{Scx=:\ANewa\z:}', "");;
    Expect(1, 70753, '\p{Scx=newa}', "");
    Expect(0, 70753, '\p{^Scx=newa}', "");
    Expect(0, 70753, '\P{Scx=newa}', "");
    Expect(1, 70753, '\P{^Scx=newa}', "");
    Expect(0, 70754, '\p{Scx=newa}', "");
    Expect(1, 70754, '\p{^Scx=newa}', "");
    Expect(1, 70754, '\P{Scx=newa}', "");
    Expect(0, 70754, '\P{^Scx=newa}', "");
    Expect(1, 70753, '\p{Scx=:\Anewa\z:}', "");;
    Expect(0, 70754, '\p{Scx=:\Anewa\z:}', "");;
    Expect(1, 70753, '\p{Scx=_NEWA}', "");
    Expect(0, 70753, '\p{^Scx=_NEWA}', "");
    Expect(0, 70753, '\P{Scx=_NEWA}', "");
    Expect(1, 70753, '\P{^Scx=_NEWA}', "");
    Expect(0, 70754, '\p{Scx=_NEWA}', "");
    Expect(1, 70754, '\p{^Scx=_NEWA}', "");
    Expect(1, 70754, '\P{Scx=_NEWA}', "");
    Expect(0, 70754, '\P{^Scx=_NEWA}', "");
    Error('\p{Is_Script_Extensions=  Newa:=}');
    Error('\P{Is_Script_Extensions=  Newa:=}');
    Expect(1, 70753, '\p{Is_Script_Extensions=newa}', "");
    Expect(0, 70753, '\p{^Is_Script_Extensions=newa}', "");
    Expect(0, 70753, '\P{Is_Script_Extensions=newa}', "");
    Expect(1, 70753, '\P{^Is_Script_Extensions=newa}', "");
    Expect(0, 70754, '\p{Is_Script_Extensions=newa}', "");
    Expect(1, 70754, '\p{^Is_Script_Extensions=newa}', "");
    Expect(1, 70754, '\P{Is_Script_Extensions=newa}', "");
    Expect(0, 70754, '\P{^Is_Script_Extensions=newa}', "");
    Expect(1, 70753, '\p{Is_Script_Extensions=Newa}', "");
    Expect(0, 70753, '\p{^Is_Script_Extensions=Newa}', "");
    Expect(0, 70753, '\P{Is_Script_Extensions=Newa}', "");
    Expect(1, 70753, '\P{^Is_Script_Extensions=Newa}', "");
    Expect(0, 70754, '\p{Is_Script_Extensions=Newa}', "");
    Expect(1, 70754, '\p{^Is_Script_Extensions=Newa}', "");
    Expect(1, 70754, '\P{Is_Script_Extensions=Newa}', "");
    Expect(0, 70754, '\P{^Is_Script_Extensions=Newa}', "");
    Error('\p{Is_Scx=	/a/Newa}');
    Error('\P{Is_Scx=	/a/Newa}');
    Expect(1, 70753, '\p{Is_Scx=newa}', "");
    Expect(0, 70753, '\p{^Is_Scx=newa}', "");
    Expect(0, 70753, '\P{Is_Scx=newa}', "");
    Expect(1, 70753, '\P{^Is_Scx=newa}', "");
    Expect(0, 70754, '\p{Is_Scx=newa}', "");
    Expect(1, 70754, '\p{^Is_Scx=newa}', "");
    Expect(1, 70754, '\P{Is_Scx=newa}', "");
    Expect(0, 70754, '\P{^Is_Scx=newa}', "");
    Expect(1, 70753, '\p{Is_Scx=__Newa}', "");
    Expect(0, 70753, '\p{^Is_Scx=__Newa}', "");
    Expect(0, 70753, '\P{Is_Scx=__Newa}', "");
    Expect(1, 70753, '\P{^Is_Scx=__Newa}', "");
    Expect(0, 70754, '\p{Is_Scx=__Newa}', "");
    Expect(1, 70754, '\p{^Is_Scx=__Newa}', "");
    Expect(1, 70754, '\P{Is_Scx=__Newa}', "");
    Expect(0, 70754, '\P{^Is_Scx=__Newa}', "");
    Error('\p{Script_Extensions=:=		Nko}');
    Error('\P{Script_Extensions=:=		Nko}');
    Expect(1, 64831, '\p{Script_Extensions=:\ANko\z:}', "");;
    Expect(0, 64832, '\p{Script_Extensions=:\ANko\z:}', "");;
    Expect(1, 64831, '\p{Script_Extensions=nko}', "");
    Expect(0, 64831, '\p{^Script_Extensions=nko}', "");
    Expect(0, 64831, '\P{Script_Extensions=nko}', "");
    Expect(1, 64831, '\P{^Script_Extensions=nko}', "");
    Expect(0, 64832, '\p{Script_Extensions=nko}', "");
    Expect(1, 64832, '\p{^Script_Extensions=nko}', "");
    Expect(1, 64832, '\P{Script_Extensions=nko}', "");
    Expect(0, 64832, '\P{^Script_Extensions=nko}', "");
    Expect(1, 64831, '\p{Script_Extensions=:\Anko\z:}', "");;
    Expect(0, 64832, '\p{Script_Extensions=:\Anko\z:}', "");;
    Expect(1, 64831, '\p{Script_Extensions=	Nko}', "");
    Expect(0, 64831, '\p{^Script_Extensions=	Nko}', "");
    Expect(0, 64831, '\P{Script_Extensions=	Nko}', "");
    Expect(1, 64831, '\P{^Script_Extensions=	Nko}', "");
    Expect(0, 64832, '\p{Script_Extensions=	Nko}', "");
    Expect(1, 64832, '\p{^Script_Extensions=	Nko}', "");
    Expect(1, 64832, '\P{Script_Extensions=	Nko}', "");
    Expect(0, 64832, '\P{^Script_Extensions=	Nko}', "");
    Error('\p{Scx=_:=nkoo}');
    Error('\P{Scx=_:=nkoo}');
    Expect(1, 64831, '\p{Scx=:\ANkoo\z:}', "");;
    Expect(0, 64832, '\p{Scx=:\ANkoo\z:}', "");;
    Expect(1, 64831, '\p{Scx=nkoo}', "");
    Expect(0, 64831, '\p{^Scx=nkoo}', "");
    Expect(0, 64831, '\P{Scx=nkoo}', "");
    Expect(1, 64831, '\P{^Scx=nkoo}', "");
    Expect(0, 64832, '\p{Scx=nkoo}', "");
    Expect(1, 64832, '\p{^Scx=nkoo}', "");
    Expect(1, 64832, '\P{Scx=nkoo}', "");
    Expect(0, 64832, '\P{^Scx=nkoo}', "");
    Expect(1, 64831, '\p{Scx=:\Ankoo\z:}', "");;
    Expect(0, 64832, '\p{Scx=:\Ankoo\z:}', "");;
    Expect(1, 64831, '\p{Scx=-NKOO}', "");
    Expect(0, 64831, '\p{^Scx=-NKOO}', "");
    Expect(0, 64831, '\P{Scx=-NKOO}', "");
    Expect(1, 64831, '\P{^Scx=-NKOO}', "");
    Expect(0, 64832, '\p{Scx=-NKOO}', "");
    Expect(1, 64832, '\p{^Scx=-NKOO}', "");
    Expect(1, 64832, '\P{Scx=-NKOO}', "");
    Expect(0, 64832, '\P{^Scx=-NKOO}', "");
    Error('\p{Is_Script_Extensions=__Nko/a/}');
    Error('\P{Is_Script_Extensions=__Nko/a/}');
    Expect(1, 64831, '\p{Is_Script_Extensions=nko}', "");
    Expect(0, 64831, '\p{^Is_Script_Extensions=nko}', "");
    Expect(0, 64831, '\P{Is_Script_Extensions=nko}', "");
    Expect(1, 64831, '\P{^Is_Script_Extensions=nko}', "");
    Expect(0, 64832, '\p{Is_Script_Extensions=nko}', "");
    Expect(1, 64832, '\p{^Is_Script_Extensions=nko}', "");
    Expect(1, 64832, '\P{Is_Script_Extensions=nko}', "");
    Expect(0, 64832, '\P{^Is_Script_Extensions=nko}', "");
    Expect(1, 64831, '\p{Is_Script_Extensions=	 Nko}', "");
    Expect(0, 64831, '\p{^Is_Script_Extensions=	 Nko}', "");
    Expect(0, 64831, '\P{Is_Script_Extensions=	 Nko}', "");
    Expect(1, 64831, '\P{^Is_Script_Extensions=	 Nko}', "");
    Expect(0, 64832, '\p{Is_Script_Extensions=	 Nko}', "");
    Expect(1, 64832, '\p{^Is_Script_Extensions=	 Nko}', "");
    Expect(1, 64832, '\P{Is_Script_Extensions=	 Nko}', "");
    Expect(0, 64832, '\P{^Is_Script_Extensions=	 Nko}', "");
    Error('\p{Is_Scx=-Nkoo/a/}');
    Error('\P{Is_Scx=-Nkoo/a/}');
    Expect(1, 64831, '\p{Is_Scx=nkoo}', "");
    Expect(0, 64831, '\p{^Is_Scx=nkoo}', "");
    Expect(0, 64831, '\P{Is_Scx=nkoo}', "");
    Expect(1, 64831, '\P{^Is_Scx=nkoo}', "");
    Expect(0, 64832, '\p{Is_Scx=nkoo}', "");
    Expect(1, 64832, '\p{^Is_Scx=nkoo}', "");
    Expect(1, 64832, '\P{Is_Scx=nkoo}', "");
    Expect(0, 64832, '\P{^Is_Scx=nkoo}', "");
    Expect(1, 64831, '\p{Is_Scx=	-NKOO}', "");
    Expect(0, 64831, '\p{^Is_Scx=	-NKOO}', "");
    Expect(0, 64831, '\P{Is_Scx=	-NKOO}', "");
    Expect(1, 64831, '\P{^Is_Scx=	-NKOO}', "");
    Expect(0, 64832, '\p{Is_Scx=	-NKOO}', "");
    Expect(1, 64832, '\p{^Is_Scx=	-NKOO}', "");
    Expect(1, 64832, '\P{Is_Scx=	-NKOO}', "");
    Expect(0, 64832, '\P{^Is_Scx=	-NKOO}', "");
    Error('\p{Script_Extensions=	-Nushu:=}');
    Error('\P{Script_Extensions=	-Nushu:=}');
    Expect(1, 111355, '\p{Script_Extensions=:\ANushu\z:}', "");;
    Expect(0, 111356, '\p{Script_Extensions=:\ANushu\z:}', "");;
    Expect(1, 111355, '\p{Script_Extensions:nushu}', "");
    Expect(0, 111355, '\p{^Script_Extensions:nushu}', "");
    Expect(0, 111355, '\P{Script_Extensions:nushu}', "");
    Expect(1, 111355, '\P{^Script_Extensions:nushu}', "");
    Expect(0, 111356, '\p{Script_Extensions:nushu}', "");
    Expect(1, 111356, '\p{^Script_Extensions:nushu}', "");
    Expect(1, 111356, '\P{Script_Extensions:nushu}', "");
    Expect(0, 111356, '\P{^Script_Extensions:nushu}', "");
    Expect(1, 111355, '\p{Script_Extensions=:\Anushu\z:}', "");;
    Expect(0, 111356, '\p{Script_Extensions=:\Anushu\z:}', "");;
    Expect(1, 111355, '\p{Script_Extensions= NUSHU}', "");
    Expect(0, 111355, '\p{^Script_Extensions= NUSHU}', "");
    Expect(0, 111355, '\P{Script_Extensions= NUSHU}', "");
    Expect(1, 111355, '\P{^Script_Extensions= NUSHU}', "");
    Expect(0, 111356, '\p{Script_Extensions= NUSHU}', "");
    Expect(1, 111356, '\p{^Script_Extensions= NUSHU}', "");
    Expect(1, 111356, '\P{Script_Extensions= NUSHU}', "");
    Expect(0, 111356, '\P{^Script_Extensions= NUSHU}', "");
    Error('\p{Scx=	/a/Nshu}');
    Error('\P{Scx=	/a/Nshu}');
    Expect(1, 111355, '\p{Scx=:\ANshu\z:}', "");;
    Expect(0, 111356, '\p{Scx=:\ANshu\z:}', "");;
    Expect(1, 111355, '\p{Scx=nshu}', "");
    Expect(0, 111355, '\p{^Scx=nshu}', "");
    Expect(0, 111355, '\P{Scx=nshu}', "");
    Expect(1, 111355, '\P{^Scx=nshu}', "");
    Expect(0, 111356, '\p{Scx=nshu}', "");
    Expect(1, 111356, '\p{^Scx=nshu}', "");
    Expect(1, 111356, '\P{Scx=nshu}', "");
    Expect(0, 111356, '\P{^Scx=nshu}', "");
    Expect(1, 111355, '\p{Scx=:\Anshu\z:}', "");;
    Expect(0, 111356, '\p{Scx=:\Anshu\z:}', "");;
    Expect(1, 111355, '\p{Scx=_Nshu}', "");
    Expect(0, 111355, '\p{^Scx=_Nshu}', "");
    Expect(0, 111355, '\P{Scx=_Nshu}', "");
    Expect(1, 111355, '\P{^Scx=_Nshu}', "");
    Expect(0, 111356, '\p{Scx=_Nshu}', "");
    Expect(1, 111356, '\p{^Scx=_Nshu}', "");
    Expect(1, 111356, '\P{Scx=_Nshu}', "");
    Expect(0, 111356, '\P{^Scx=_Nshu}', "");
    Error('\p{Is_Script_Extensions=/a/	_Nushu}');
    Error('\P{Is_Script_Extensions=/a/	_Nushu}');
    Expect(1, 111355, '\p{Is_Script_Extensions=nushu}', "");
    Expect(0, 111355, '\p{^Is_Script_Extensions=nushu}', "");
    Expect(0, 111355, '\P{Is_Script_Extensions=nushu}', "");
    Expect(1, 111355, '\P{^Is_Script_Extensions=nushu}', "");
    Expect(0, 111356, '\p{Is_Script_Extensions=nushu}', "");
    Expect(1, 111356, '\p{^Is_Script_Extensions=nushu}', "");
    Expect(1, 111356, '\P{Is_Script_Extensions=nushu}', "");
    Expect(0, 111356, '\P{^Is_Script_Extensions=nushu}', "");
    Expect(1, 111355, '\p{Is_Script_Extensions=_nushu}', "");
    Expect(0, 111355, '\p{^Is_Script_Extensions=_nushu}', "");
    Expect(0, 111355, '\P{Is_Script_Extensions=_nushu}', "");
    Expect(1, 111355, '\P{^Is_Script_Extensions=_nushu}', "");
    Expect(0, 111356, '\p{Is_Script_Extensions=_nushu}', "");
    Expect(1, 111356, '\p{^Is_Script_Extensions=_nushu}', "");
    Expect(1, 111356, '\P{Is_Script_Extensions=_nushu}', "");
    Expect(0, 111356, '\P{^Is_Script_Extensions=_nushu}', "");
    Error('\p{Is_Scx=/a/ 	NSHU}');
    Error('\P{Is_Scx=/a/ 	NSHU}');
    Expect(1, 111355, '\p{Is_Scx=nshu}', "");
    Expect(0, 111355, '\p{^Is_Scx=nshu}', "");
    Expect(0, 111355, '\P{Is_Scx=nshu}', "");
    Expect(1, 111355, '\P{^Is_Scx=nshu}', "");
    Expect(0, 111356, '\p{Is_Scx=nshu}', "");
    Expect(1, 111356, '\p{^Is_Scx=nshu}', "");
    Expect(1, 111356, '\P{Is_Scx=nshu}', "");
    Expect(0, 111356, '\P{^Is_Scx=nshu}', "");
    Expect(1, 111355, '\p{Is_Scx=_NSHU}', "");
    Expect(0, 111355, '\p{^Is_Scx=_NSHU}', "");
    Expect(0, 111355, '\P{Is_Scx=_NSHU}', "");
    Expect(1, 111355, '\P{^Is_Scx=_NSHU}', "");
    Expect(0, 111356, '\p{Is_Scx=_NSHU}', "");
    Expect(1, 111356, '\p{^Is_Scx=_NSHU}', "");
    Expect(1, 111356, '\P{Is_Scx=_NSHU}', "");
    Expect(0, 111356, '\P{^Is_Scx=_NSHU}', "");
    Error('\p{Script_Extensions=:=OGHAM}');
    Error('\P{Script_Extensions=:=OGHAM}');
    Expect(1, 5788, '\p{Script_Extensions=:\AOgham\z:}', "");;
    Expect(0, 5789, '\p{Script_Extensions=:\AOgham\z:}', "");;
    Expect(1, 5788, '\p{Script_Extensions=ogham}', "");
    Expect(0, 5788, '\p{^Script_Extensions=ogham}', "");
    Expect(0, 5788, '\P{Script_Extensions=ogham}', "");
    Expect(1, 5788, '\P{^Script_Extensions=ogham}', "");
    Expect(0, 5789, '\p{Script_Extensions=ogham}', "");
    Expect(1, 5789, '\p{^Script_Extensions=ogham}', "");
    Expect(1, 5789, '\P{Script_Extensions=ogham}', "");
    Expect(0, 5789, '\P{^Script_Extensions=ogham}', "");
    Expect(1, 5788, '\p{Script_Extensions=:\Aogham\z:}', "");;
    Expect(0, 5789, '\p{Script_Extensions=:\Aogham\z:}', "");;
    Expect(1, 5788, '\p{Script_Extensions=	Ogham}', "");
    Expect(0, 5788, '\p{^Script_Extensions=	Ogham}', "");
    Expect(0, 5788, '\P{Script_Extensions=	Ogham}', "");
    Expect(1, 5788, '\P{^Script_Extensions=	Ogham}', "");
    Expect(0, 5789, '\p{Script_Extensions=	Ogham}', "");
    Expect(1, 5789, '\p{^Script_Extensions=	Ogham}', "");
    Expect(1, 5789, '\P{Script_Extensions=	Ogham}', "");
    Expect(0, 5789, '\P{^Script_Extensions=	Ogham}', "");
    Error('\p{Scx: :=	OGAM}');
    Error('\P{Scx: :=	OGAM}');
    Expect(1, 5788, '\p{Scx=:\AOgam\z:}', "");;
    Expect(0, 5789, '\p{Scx=:\AOgam\z:}', "");;
    Expect(1, 5788, '\p{Scx: ogam}', "");
    Expect(0, 5788, '\p{^Scx: ogam}', "");
    Expect(0, 5788, '\P{Scx: ogam}', "");
    Expect(1, 5788, '\P{^Scx: ogam}', "");
    Expect(0, 5789, '\p{Scx: ogam}', "");
    Expect(1, 5789, '\p{^Scx: ogam}', "");
    Expect(1, 5789, '\P{Scx: ogam}', "");
    Expect(0, 5789, '\P{^Scx: ogam}', "");
    Expect(1, 5788, '\p{Scx=:\Aogam\z:}', "");;
    Expect(0, 5789, '\p{Scx=:\Aogam\z:}', "");;
    Expect(1, 5788, '\p{Scx= -Ogam}', "");
    Expect(0, 5788, '\p{^Scx= -Ogam}', "");
    Expect(0, 5788, '\P{Scx= -Ogam}', "");
    Expect(1, 5788, '\P{^Scx= -Ogam}', "");
    Expect(0, 5789, '\p{Scx= -Ogam}', "");
    Expect(1, 5789, '\p{^Scx= -Ogam}', "");
    Expect(1, 5789, '\P{Scx= -Ogam}', "");
    Expect(0, 5789, '\P{^Scx= -Ogam}', "");
    Error('\p{Is_Script_Extensions:/a/ogham}');
    Error('\P{Is_Script_Extensions:/a/ogham}');
    Expect(1, 5788, '\p{Is_Script_Extensions=ogham}', "");
    Expect(0, 5788, '\p{^Is_Script_Extensions=ogham}', "");
    Expect(0, 5788, '\P{Is_Script_Extensions=ogham}', "");
    Expect(1, 5788, '\P{^Is_Script_Extensions=ogham}', "");
    Expect(0, 5789, '\p{Is_Script_Extensions=ogham}', "");
    Expect(1, 5789, '\p{^Is_Script_Extensions=ogham}', "");
    Expect(1, 5789, '\P{Is_Script_Extensions=ogham}', "");
    Expect(0, 5789, '\P{^Is_Script_Extensions=ogham}', "");
    Expect(1, 5788, '\p{Is_Script_Extensions=		Ogham}', "");
    Expect(0, 5788, '\p{^Is_Script_Extensions=		Ogham}', "");
    Expect(0, 5788, '\P{Is_Script_Extensions=		Ogham}', "");
    Expect(1, 5788, '\P{^Is_Script_Extensions=		Ogham}', "");
    Expect(0, 5789, '\p{Is_Script_Extensions=		Ogham}', "");
    Expect(1, 5789, '\p{^Is_Script_Extensions=		Ogham}', "");
    Expect(1, 5789, '\P{Is_Script_Extensions=		Ogham}', "");
    Expect(0, 5789, '\P{^Is_Script_Extensions=		Ogham}', "");
    Error('\p{Is_Scx=:=_	ogam}');
    Error('\P{Is_Scx=:=_	ogam}');
    Expect(1, 5788, '\p{Is_Scx=ogam}', "");
    Expect(0, 5788, '\p{^Is_Scx=ogam}', "");
    Expect(0, 5788, '\P{Is_Scx=ogam}', "");
    Expect(1, 5788, '\P{^Is_Scx=ogam}', "");
    Expect(0, 5789, '\p{Is_Scx=ogam}', "");
    Expect(1, 5789, '\p{^Is_Scx=ogam}', "");
    Expect(1, 5789, '\P{Is_Scx=ogam}', "");
    Expect(0, 5789, '\P{^Is_Scx=ogam}', "");
    Expect(1, 5788, '\p{Is_Scx=-Ogam}', "");
    Expect(0, 5788, '\p{^Is_Scx=-Ogam}', "");
    Expect(0, 5788, '\P{Is_Scx=-Ogam}', "");
    Expect(1, 5788, '\P{^Is_Scx=-Ogam}', "");
    Expect(0, 5789, '\p{Is_Scx=-Ogam}', "");
    Expect(1, 5789, '\p{^Is_Scx=-Ogam}', "");
    Expect(1, 5789, '\P{Is_Scx=-Ogam}', "");
    Expect(0, 5789, '\P{^Is_Scx=-Ogam}', "");
    Error('\p{Script_Extensions=:=--OL_CHIKI}');
    Error('\P{Script_Extensions=:=--OL_CHIKI}');
    Expect(1, 7295, '\p{Script_Extensions=:\AOl_Chiki\z:}', "");;
    Expect(0, 7296, '\p{Script_Extensions=:\AOl_Chiki\z:}', "");;
    Expect(1, 7295, '\p{Script_Extensions=olchiki}', "");
    Expect(0, 7295, '\p{^Script_Extensions=olchiki}', "");
    Expect(0, 7295, '\P{Script_Extensions=olchiki}', "");
    Expect(1, 7295, '\P{^Script_Extensions=olchiki}', "");
    Expect(0, 7296, '\p{Script_Extensions=olchiki}', "");
    Expect(1, 7296, '\p{^Script_Extensions=olchiki}', "");
    Expect(1, 7296, '\P{Script_Extensions=olchiki}', "");
    Expect(0, 7296, '\P{^Script_Extensions=olchiki}', "");
    Expect(1, 7295, '\p{Script_Extensions=:\Aolchiki\z:}', "");;
    Expect(0, 7296, '\p{Script_Extensions=:\Aolchiki\z:}', "");;
    Expect(1, 7295, '\p{Script_Extensions=-Ol_Chiki}', "");
    Expect(0, 7295, '\p{^Script_Extensions=-Ol_Chiki}', "");
    Expect(0, 7295, '\P{Script_Extensions=-Ol_Chiki}', "");
    Expect(1, 7295, '\P{^Script_Extensions=-Ol_Chiki}', "");
    Expect(0, 7296, '\p{Script_Extensions=-Ol_Chiki}', "");
    Expect(1, 7296, '\p{^Script_Extensions=-Ol_Chiki}', "");
    Expect(1, 7296, '\P{Script_Extensions=-Ol_Chiki}', "");
    Expect(0, 7296, '\P{^Script_Extensions=-Ol_Chiki}', "");
    Error('\p{Scx= /a/Olck}');
    Error('\P{Scx= /a/Olck}');
    Expect(1, 7295, '\p{Scx=:\AOlck\z:}', "");;
    Expect(0, 7296, '\p{Scx=:\AOlck\z:}', "");;
    Expect(1, 7295, '\p{Scx:	olck}', "");
    Expect(0, 7295, '\p{^Scx:	olck}', "");
    Expect(0, 7295, '\P{Scx:	olck}', "");
    Expect(1, 7295, '\P{^Scx:	olck}', "");
    Expect(0, 7296, '\p{Scx:	olck}', "");
    Expect(1, 7296, '\p{^Scx:	olck}', "");
    Expect(1, 7296, '\P{Scx:	olck}', "");
    Expect(0, 7296, '\P{^Scx:	olck}', "");
    Expect(1, 7295, '\p{Scx=:\Aolck\z:}', "");;
    Expect(0, 7296, '\p{Scx=:\Aolck\z:}', "");;
    Expect(1, 7295, '\p{Scx=__olck}', "");
    Expect(0, 7295, '\p{^Scx=__olck}', "");
    Expect(0, 7295, '\P{Scx=__olck}', "");
    Expect(1, 7295, '\P{^Scx=__olck}', "");
    Expect(0, 7296, '\p{Scx=__olck}', "");
    Expect(1, 7296, '\p{^Scx=__olck}', "");
    Expect(1, 7296, '\P{Scx=__olck}', "");
    Expect(0, 7296, '\P{^Scx=__olck}', "");
    Error('\p{Is_Script_Extensions=/a/_ol_CHIKI}');
    Error('\P{Is_Script_Extensions=/a/_ol_CHIKI}');
    Expect(1, 7295, '\p{Is_Script_Extensions=olchiki}', "");
    Expect(0, 7295, '\p{^Is_Script_Extensions=olchiki}', "");
    Expect(0, 7295, '\P{Is_Script_Extensions=olchiki}', "");
    Expect(1, 7295, '\P{^Is_Script_Extensions=olchiki}', "");
    Expect(0, 7296, '\p{Is_Script_Extensions=olchiki}', "");
    Expect(1, 7296, '\p{^Is_Script_Extensions=olchiki}', "");
    Expect(1, 7296, '\P{Is_Script_Extensions=olchiki}', "");
    Expect(0, 7296, '\P{^Is_Script_Extensions=olchiki}', "");
    Expect(1, 7295, '\p{Is_Script_Extensions=_	Ol_chiki}', "");
    Expect(0, 7295, '\p{^Is_Script_Extensions=_	Ol_chiki}', "");
    Expect(0, 7295, '\P{Is_Script_Extensions=_	Ol_chiki}', "");
    Expect(1, 7295, '\P{^Is_Script_Extensions=_	Ol_chiki}', "");
    Expect(0, 7296, '\p{Is_Script_Extensions=_	Ol_chiki}', "");
    Expect(1, 7296, '\p{^Is_Script_Extensions=_	Ol_chiki}', "");
    Expect(1, 7296, '\P{Is_Script_Extensions=_	Ol_chiki}', "");
    Expect(0, 7296, '\P{^Is_Script_Extensions=_	Ol_chiki}', "");
    Error('\p{Is_Scx=_:=OLCK}');
    Error('\P{Is_Scx=_:=OLCK}');
    Expect(1, 7295, '\p{Is_Scx=olck}', "");
    Expect(0, 7295, '\p{^Is_Scx=olck}', "");
    Expect(0, 7295, '\P{Is_Scx=olck}', "");
    Expect(1, 7295, '\P{^Is_Scx=olck}', "");
    Expect(0, 7296, '\p{Is_Scx=olck}', "");
    Expect(1, 7296, '\p{^Is_Scx=olck}', "");
    Expect(1, 7296, '\P{Is_Scx=olck}', "");
    Expect(0, 7296, '\P{^Is_Scx=olck}', "");
    Expect(1, 7295, '\p{Is_Scx= Olck}', "");
    Expect(0, 7295, '\p{^Is_Scx= Olck}', "");
    Expect(0, 7295, '\P{Is_Scx= Olck}', "");
    Expect(1, 7295, '\P{^Is_Scx= Olck}', "");
    Expect(0, 7296, '\p{Is_Scx= Olck}', "");
    Expect(1, 7296, '\p{^Is_Scx= Olck}', "");
    Expect(1, 7296, '\P{Is_Scx= Olck}', "");
    Expect(0, 7296, '\P{^Is_Scx= Olck}', "");
    Error('\p{Script_Extensions=_:=old_TURKIC}');
    Error('\P{Script_Extensions=_:=old_TURKIC}');
    Expect(1, 68680, '\p{Script_Extensions=:\AOld_Turkic\z:}', "");;
    Expect(0, 68681, '\p{Script_Extensions=:\AOld_Turkic\z:}', "");;
    Expect(1, 68680, '\p{Script_Extensions=oldturkic}', "");
    Expect(0, 68680, '\p{^Script_Extensions=oldturkic}', "");
    Expect(0, 68680, '\P{Script_Extensions=oldturkic}', "");
    Expect(1, 68680, '\P{^Script_Extensions=oldturkic}', "");
    Expect(0, 68681, '\p{Script_Extensions=oldturkic}', "");
    Expect(1, 68681, '\p{^Script_Extensions=oldturkic}', "");
    Expect(1, 68681, '\P{Script_Extensions=oldturkic}', "");
    Expect(0, 68681, '\P{^Script_Extensions=oldturkic}', "");
    Expect(1, 68680, '\p{Script_Extensions=:\Aoldturkic\z:}', "");;
    Expect(0, 68681, '\p{Script_Extensions=:\Aoldturkic\z:}', "");;
    Expect(1, 68680, '\p{Script_Extensions=  Old_Turkic}', "");
    Expect(0, 68680, '\p{^Script_Extensions=  Old_Turkic}', "");
    Expect(0, 68680, '\P{Script_Extensions=  Old_Turkic}', "");
    Expect(1, 68680, '\P{^Script_Extensions=  Old_Turkic}', "");
    Expect(0, 68681, '\p{Script_Extensions=  Old_Turkic}', "");
    Expect(1, 68681, '\p{^Script_Extensions=  Old_Turkic}', "");
    Expect(1, 68681, '\P{Script_Extensions=  Old_Turkic}', "");
    Expect(0, 68681, '\P{^Script_Extensions=  Old_Turkic}', "");
    Error('\p{Scx=	:=orkh}');
    Error('\P{Scx=	:=orkh}');
    Expect(1, 68680, '\p{Scx=:\AOrkh\z:}', "");;
    Expect(0, 68681, '\p{Scx=:\AOrkh\z:}', "");;
    Expect(1, 68680, '\p{Scx=orkh}', "");
    Expect(0, 68680, '\p{^Scx=orkh}', "");
    Expect(0, 68680, '\P{Scx=orkh}', "");
    Expect(1, 68680, '\P{^Scx=orkh}', "");
    Expect(0, 68681, '\p{Scx=orkh}', "");
    Expect(1, 68681, '\p{^Scx=orkh}', "");
    Expect(1, 68681, '\P{Scx=orkh}', "");
    Expect(0, 68681, '\P{^Scx=orkh}', "");
    Expect(1, 68680, '\p{Scx=:\Aorkh\z:}', "");;
    Expect(0, 68681, '\p{Scx=:\Aorkh\z:}', "");;
    Expect(1, 68680, '\p{Scx=Orkh}', "");
    Expect(0, 68680, '\p{^Scx=Orkh}', "");
    Expect(0, 68680, '\P{Scx=Orkh}', "");
    Expect(1, 68680, '\P{^Scx=Orkh}', "");
    Expect(0, 68681, '\p{Scx=Orkh}', "");
    Expect(1, 68681, '\p{^Scx=Orkh}', "");
    Expect(1, 68681, '\P{Scx=Orkh}', "");
    Expect(0, 68681, '\P{^Scx=Orkh}', "");
    Error('\p{Is_Script_Extensions=:= -Old_Turkic}');
    Error('\P{Is_Script_Extensions=:= -Old_Turkic}');
    Expect(1, 68680, '\p{Is_Script_Extensions=oldturkic}', "");
    Expect(0, 68680, '\p{^Is_Script_Extensions=oldturkic}', "");
    Expect(0, 68680, '\P{Is_Script_Extensions=oldturkic}', "");
    Expect(1, 68680, '\P{^Is_Script_Extensions=oldturkic}', "");
    Expect(0, 68681, '\p{Is_Script_Extensions=oldturkic}', "");
    Expect(1, 68681, '\p{^Is_Script_Extensions=oldturkic}', "");
    Expect(1, 68681, '\P{Is_Script_Extensions=oldturkic}', "");
    Expect(0, 68681, '\P{^Is_Script_Extensions=oldturkic}', "");
    Expect(1, 68680, '\p{Is_Script_Extensions:   	-Old_Turkic}', "");
    Expect(0, 68680, '\p{^Is_Script_Extensions:   	-Old_Turkic}', "");
    Expect(0, 68680, '\P{Is_Script_Extensions:   	-Old_Turkic}', "");
    Expect(1, 68680, '\P{^Is_Script_Extensions:   	-Old_Turkic}', "");
    Expect(0, 68681, '\p{Is_Script_Extensions:   	-Old_Turkic}', "");
    Expect(1, 68681, '\p{^Is_Script_Extensions:   	-Old_Turkic}', "");
    Expect(1, 68681, '\P{Is_Script_Extensions:   	-Old_Turkic}', "");
    Expect(0, 68681, '\P{^Is_Script_Extensions:   	-Old_Turkic}', "");
    Error('\p{Is_Scx:	-/a/orkh}');
    Error('\P{Is_Scx:	-/a/orkh}');
    Expect(1, 68680, '\p{Is_Scx=orkh}', "");
    Expect(0, 68680, '\p{^Is_Scx=orkh}', "");
    Expect(0, 68680, '\P{Is_Scx=orkh}', "");
    Expect(1, 68680, '\P{^Is_Scx=orkh}', "");
    Expect(0, 68681, '\p{Is_Scx=orkh}', "");
    Expect(1, 68681, '\p{^Is_Scx=orkh}', "");
    Expect(1, 68681, '\P{Is_Scx=orkh}', "");
    Expect(0, 68681, '\P{^Is_Scx=orkh}', "");
    Expect(1, 68680, '\p{Is_Scx=__Orkh}', "");
    Expect(0, 68680, '\p{^Is_Scx=__Orkh}', "");
    Expect(0, 68680, '\P{Is_Scx=__Orkh}', "");
    Expect(1, 68680, '\P{^Is_Scx=__Orkh}', "");
    Expect(0, 68681, '\p{Is_Scx=__Orkh}', "");
    Expect(1, 68681, '\p{^Is_Scx=__Orkh}', "");
    Expect(1, 68681, '\P{Is_Scx=__Orkh}', "");
    Expect(0, 68681, '\P{^Is_Scx=__Orkh}', "");
    Error('\p{Script_Extensions=/a/Oriya}');
    Error('\P{Script_Extensions=/a/Oriya}');
    Expect(1, 7410, '\p{Script_Extensions=:\AOriya\z:}', "");;
    Expect(0, 7411, '\p{Script_Extensions=:\AOriya\z:}', "");;
    Expect(1, 7410, '\p{Script_Extensions=oriya}', "");
    Expect(0, 7410, '\p{^Script_Extensions=oriya}', "");
    Expect(0, 7410, '\P{Script_Extensions=oriya}', "");
    Expect(1, 7410, '\P{^Script_Extensions=oriya}', "");
    Expect(0, 7411, '\p{Script_Extensions=oriya}', "");
    Expect(1, 7411, '\p{^Script_Extensions=oriya}', "");
    Expect(1, 7411, '\P{Script_Extensions=oriya}', "");
    Expect(0, 7411, '\P{^Script_Extensions=oriya}', "");
    Expect(1, 7410, '\p{Script_Extensions=:\Aoriya\z:}', "");;
    Expect(0, 7411, '\p{Script_Extensions=:\Aoriya\z:}', "");;
    Expect(1, 7410, '\p{Script_Extensions=-oriya}', "");
    Expect(0, 7410, '\p{^Script_Extensions=-oriya}', "");
    Expect(0, 7410, '\P{Script_Extensions=-oriya}', "");
    Expect(1, 7410, '\P{^Script_Extensions=-oriya}', "");
    Expect(0, 7411, '\p{Script_Extensions=-oriya}', "");
    Expect(1, 7411, '\p{^Script_Extensions=-oriya}', "");
    Expect(1, 7411, '\P{Script_Extensions=-oriya}', "");
    Expect(0, 7411, '\P{^Script_Extensions=-oriya}', "");
    Error('\p{Scx=:=  ORYA}');
    Error('\P{Scx=:=  ORYA}');
    Expect(1, 7410, '\p{Scx=:\AOrya\z:}', "");;
    Expect(0, 7411, '\p{Scx=:\AOrya\z:}', "");;
    Expect(1, 7410, '\p{Scx=orya}', "");
    Expect(0, 7410, '\p{^Scx=orya}', "");
    Expect(0, 7410, '\P{Scx=orya}', "");
    Expect(1, 7410, '\P{^Scx=orya}', "");
    Expect(0, 7411, '\p{Scx=orya}', "");
    Expect(1, 7411, '\p{^Scx=orya}', "");
    Expect(1, 7411, '\P{Scx=orya}', "");
    Expect(0, 7411, '\P{^Scx=orya}', "");
    Expect(1, 7410, '\p{Scx=:\Aorya\z:}', "");;
    Expect(0, 7411, '\p{Scx=:\Aorya\z:}', "");;
    Expect(1, 7410, '\p{Scx=	_Orya}', "");
    Expect(0, 7410, '\p{^Scx=	_Orya}', "");
    Expect(0, 7410, '\P{Scx=	_Orya}', "");
    Expect(1, 7410, '\P{^Scx=	_Orya}', "");
    Expect(0, 7411, '\p{Scx=	_Orya}', "");
    Expect(1, 7411, '\p{^Scx=	_Orya}', "");
    Expect(1, 7411, '\P{Scx=	_Orya}', "");
    Expect(0, 7411, '\P{^Scx=	_Orya}', "");
    Error('\p{Is_Script_Extensions=-:=oriya}');
    Error('\P{Is_Script_Extensions=-:=oriya}');
    Expect(1, 7410, '\p{Is_Script_Extensions=oriya}', "");
    Expect(0, 7410, '\p{^Is_Script_Extensions=oriya}', "");
    Expect(0, 7410, '\P{Is_Script_Extensions=oriya}', "");
    Expect(1, 7410, '\P{^Is_Script_Extensions=oriya}', "");
    Expect(0, 7411, '\p{Is_Script_Extensions=oriya}', "");
    Expect(1, 7411, '\p{^Is_Script_Extensions=oriya}', "");
    Expect(1, 7411, '\P{Is_Script_Extensions=oriya}', "");
    Expect(0, 7411, '\P{^Is_Script_Extensions=oriya}', "");
    Expect(1, 7410, '\p{Is_Script_Extensions=_ Oriya}', "");
    Expect(0, 7410, '\p{^Is_Script_Extensions=_ Oriya}', "");
    Expect(0, 7410, '\P{Is_Script_Extensions=_ Oriya}', "");
    Expect(1, 7410, '\P{^Is_Script_Extensions=_ Oriya}', "");
    Expect(0, 7411, '\p{Is_Script_Extensions=_ Oriya}', "");
    Expect(1, 7411, '\p{^Is_Script_Extensions=_ Oriya}', "");
    Expect(1, 7411, '\P{Is_Script_Extensions=_ Oriya}', "");
    Expect(0, 7411, '\P{^Is_Script_Extensions=_ Oriya}', "");
    Error('\p{Is_Scx=:=_ orya}');
    Error('\P{Is_Scx=:=_ orya}');
    Expect(1, 7410, '\p{Is_Scx:orya}', "");
    Expect(0, 7410, '\p{^Is_Scx:orya}', "");
    Expect(0, 7410, '\P{Is_Scx:orya}', "");
    Expect(1, 7410, '\P{^Is_Scx:orya}', "");
    Expect(0, 7411, '\p{Is_Scx:orya}', "");
    Expect(1, 7411, '\p{^Is_Scx:orya}', "");
    Expect(1, 7411, '\P{Is_Scx:orya}', "");
    Expect(0, 7411, '\P{^Is_Scx:orya}', "");
    Expect(1, 7410, '\p{Is_Scx=		ORYA}', "");
    Expect(0, 7410, '\p{^Is_Scx=		ORYA}', "");
    Expect(0, 7410, '\P{Is_Scx=		ORYA}', "");
    Expect(1, 7410, '\P{^Is_Scx=		ORYA}', "");
    Expect(0, 7411, '\p{Is_Scx=		ORYA}', "");
    Expect(1, 7411, '\p{^Is_Scx=		ORYA}', "");
    Expect(1, 7411, '\P{Is_Scx=		ORYA}', "");
    Expect(0, 7411, '\P{^Is_Scx=		ORYA}', "");
    Error('\p{Script_Extensions=/a/osage}');
    Error('\P{Script_Extensions=/a/osage}');
    Expect(1, 66811, '\p{Script_Extensions=:\AOsage\z:}', "");;
    Expect(0, 66812, '\p{Script_Extensions=:\AOsage\z:}', "");;
    Expect(1, 66811, '\p{Script_Extensions=osage}', "");
    Expect(0, 66811, '\p{^Script_Extensions=osage}', "");
    Expect(0, 66811, '\P{Script_Extensions=osage}', "");
    Expect(1, 66811, '\P{^Script_Extensions=osage}', "");
    Expect(0, 66812, '\p{Script_Extensions=osage}', "");
    Expect(1, 66812, '\p{^Script_Extensions=osage}', "");
    Expect(1, 66812, '\P{Script_Extensions=osage}', "");
    Expect(0, 66812, '\P{^Script_Extensions=osage}', "");
    Expect(1, 66811, '\p{Script_Extensions=:\Aosage\z:}', "");;
    Expect(0, 66812, '\p{Script_Extensions=:\Aosage\z:}', "");;
    Expect(1, 66811, '\p{Script_Extensions=  osage}', "");
    Expect(0, 66811, '\p{^Script_Extensions=  osage}', "");
    Expect(0, 66811, '\P{Script_Extensions=  osage}', "");
    Expect(1, 66811, '\P{^Script_Extensions=  osage}', "");
    Expect(0, 66812, '\p{Script_Extensions=  osage}', "");
    Expect(1, 66812, '\p{^Script_Extensions=  osage}', "");
    Expect(1, 66812, '\P{Script_Extensions=  osage}', "");
    Expect(0, 66812, '\P{^Script_Extensions=  osage}', "");
    Error('\p{Scx=:=	Osge}');
    Error('\P{Scx=:=	Osge}');
    Expect(1, 66811, '\p{Scx=:\AOsge\z:}', "");;
    Expect(0, 66812, '\p{Scx=:\AOsge\z:}', "");;
    Expect(1, 66811, '\p{Scx=osge}', "");
    Expect(0, 66811, '\p{^Scx=osge}', "");
    Expect(0, 66811, '\P{Scx=osge}', "");
    Expect(1, 66811, '\P{^Scx=osge}', "");
    Expect(0, 66812, '\p{Scx=osge}', "");
    Expect(1, 66812, '\p{^Scx=osge}', "");
    Expect(1, 66812, '\P{Scx=osge}', "");
    Expect(0, 66812, '\P{^Scx=osge}', "");
    Expect(1, 66811, '\p{Scx=:\Aosge\z:}', "");;
    Expect(0, 66812, '\p{Scx=:\Aosge\z:}', "");;
    Error('\p{Is_Script_Extensions=_:=OSAGE}');
    Error('\P{Is_Script_Extensions=_:=OSAGE}');
    Expect(1, 66811, '\p{Is_Script_Extensions=osage}', "");
    Expect(0, 66811, '\p{^Is_Script_Extensions=osage}', "");
    Expect(0, 66811, '\P{Is_Script_Extensions=osage}', "");
    Expect(1, 66811, '\P{^Is_Script_Extensions=osage}', "");
    Expect(0, 66812, '\p{Is_Script_Extensions=osage}', "");
    Expect(1, 66812, '\p{^Is_Script_Extensions=osage}', "");
    Expect(1, 66812, '\P{Is_Script_Extensions=osage}', "");
    Expect(0, 66812, '\P{^Is_Script_Extensions=osage}', "");
    Expect(1, 66811, '\p{Is_Script_Extensions=_Osage}', "");
    Expect(0, 66811, '\p{^Is_Script_Extensions=_Osage}', "");
    Expect(0, 66811, '\P{Is_Script_Extensions=_Osage}', "");
    Expect(1, 66811, '\P{^Is_Script_Extensions=_Osage}', "");
    Expect(0, 66812, '\p{Is_Script_Extensions=_Osage}', "");
    Expect(1, 66812, '\p{^Is_Script_Extensions=_Osage}', "");
    Expect(1, 66812, '\P{Is_Script_Extensions=_Osage}', "");
    Expect(0, 66812, '\P{^Is_Script_Extensions=_Osage}', "");
    Error('\p{Is_Scx=/a/Osge}');
    Error('\P{Is_Scx=/a/Osge}');
    Expect(1, 66811, '\p{Is_Scx=osge}', "");
    Expect(0, 66811, '\p{^Is_Scx=osge}', "");
    Expect(0, 66811, '\P{Is_Scx=osge}', "");
    Expect(1, 66811, '\P{^Is_Scx=osge}', "");
    Expect(0, 66812, '\p{Is_Scx=osge}', "");
    Expect(1, 66812, '\p{^Is_Scx=osge}', "");
    Expect(1, 66812, '\P{Is_Scx=osge}', "");
    Expect(0, 66812, '\P{^Is_Scx=osge}', "");
    Expect(1, 66811, '\p{Is_Scx=	 OSGE}', "");
    Expect(0, 66811, '\p{^Is_Scx=	 OSGE}', "");
    Expect(0, 66811, '\P{Is_Scx=	 OSGE}', "");
    Expect(1, 66811, '\P{^Is_Scx=	 OSGE}', "");
    Expect(0, 66812, '\p{Is_Scx=	 OSGE}', "");
    Expect(1, 66812, '\p{^Is_Scx=	 OSGE}', "");
    Expect(1, 66812, '\P{Is_Scx=	 OSGE}', "");
    Expect(0, 66812, '\P{^Is_Scx=	 OSGE}', "");
    Error('\p{Script_Extensions=:=-	osmanya}');
    Error('\P{Script_Extensions=:=-	osmanya}');
    Expect(1, 66729, '\p{Script_Extensions=:\AOsmanya\z:}', "");;
    Expect(0, 66730, '\p{Script_Extensions=:\AOsmanya\z:}', "");;
    Expect(1, 66729, '\p{Script_Extensions=osmanya}', "");
    Expect(0, 66729, '\p{^Script_Extensions=osmanya}', "");
    Expect(0, 66729, '\P{Script_Extensions=osmanya}', "");
    Expect(1, 66729, '\P{^Script_Extensions=osmanya}', "");
    Expect(0, 66730, '\p{Script_Extensions=osmanya}', "");
    Expect(1, 66730, '\p{^Script_Extensions=osmanya}', "");
    Expect(1, 66730, '\P{Script_Extensions=osmanya}', "");
    Expect(0, 66730, '\P{^Script_Extensions=osmanya}', "");
    Expect(1, 66729, '\p{Script_Extensions=:\Aosmanya\z:}', "");;
    Expect(0, 66730, '\p{Script_Extensions=:\Aosmanya\z:}', "");;
    Expect(1, 66729, '\p{Script_Extensions:		 osmanya}', "");
    Expect(0, 66729, '\p{^Script_Extensions:		 osmanya}', "");
    Expect(0, 66729, '\P{Script_Extensions:		 osmanya}', "");
    Expect(1, 66729, '\P{^Script_Extensions:		 osmanya}', "");
    Expect(0, 66730, '\p{Script_Extensions:		 osmanya}', "");
    Expect(1, 66730, '\p{^Script_Extensions:		 osmanya}', "");
    Expect(1, 66730, '\P{Script_Extensions:		 osmanya}', "");
    Expect(0, 66730, '\P{^Script_Extensions:		 osmanya}', "");
    Error('\p{Scx=/a/ _OSMA}');
    Error('\P{Scx=/a/ _OSMA}');
    Expect(1, 66729, '\p{Scx=:\AOsma\z:}', "");;
    Expect(0, 66730, '\p{Scx=:\AOsma\z:}', "");;
    Expect(1, 66729, '\p{Scx=osma}', "");
    Expect(0, 66729, '\p{^Scx=osma}', "");
    Expect(0, 66729, '\P{Scx=osma}', "");
    Expect(1, 66729, '\P{^Scx=osma}', "");
    Expect(0, 66730, '\p{Scx=osma}', "");
    Expect(1, 66730, '\p{^Scx=osma}', "");
    Expect(1, 66730, '\P{Scx=osma}', "");
    Expect(0, 66730, '\P{^Scx=osma}', "");
    Expect(1, 66729, '\p{Scx=:\Aosma\z:}', "");;
    Expect(0, 66730, '\p{Scx=:\Aosma\z:}', "");;
    Expect(1, 66729, '\p{Scx=	_Osma}', "");
    Expect(0, 66729, '\p{^Scx=	_Osma}', "");
    Expect(0, 66729, '\P{Scx=	_Osma}', "");
    Expect(1, 66729, '\P{^Scx=	_Osma}', "");
    Expect(0, 66730, '\p{Scx=	_Osma}', "");
    Expect(1, 66730, '\p{^Scx=	_Osma}', "");
    Expect(1, 66730, '\P{Scx=	_Osma}', "");
    Expect(0, 66730, '\P{^Scx=	_Osma}', "");
    Error('\p{Is_Script_Extensions=_/a/Osmanya}');
    Error('\P{Is_Script_Extensions=_/a/Osmanya}');
    Expect(1, 66729, '\p{Is_Script_Extensions=osmanya}', "");
    Expect(0, 66729, '\p{^Is_Script_Extensions=osmanya}', "");
    Expect(0, 66729, '\P{Is_Script_Extensions=osmanya}', "");
    Expect(1, 66729, '\P{^Is_Script_Extensions=osmanya}', "");
    Expect(0, 66730, '\p{Is_Script_Extensions=osmanya}', "");
    Expect(1, 66730, '\p{^Is_Script_Extensions=osmanya}', "");
    Expect(1, 66730, '\P{Is_Script_Extensions=osmanya}', "");
    Expect(0, 66730, '\P{^Is_Script_Extensions=osmanya}', "");
    Expect(1, 66729, '\p{Is_Script_Extensions=	 OSMANYA}', "");
    Expect(0, 66729, '\p{^Is_Script_Extensions=	 OSMANYA}', "");
    Expect(0, 66729, '\P{Is_Script_Extensions=	 OSMANYA}', "");
    Expect(1, 66729, '\P{^Is_Script_Extensions=	 OSMANYA}', "");
    Expect(0, 66730, '\p{Is_Script_Extensions=	 OSMANYA}', "");
    Expect(1, 66730, '\p{^Is_Script_Extensions=	 OSMANYA}', "");
    Expect(1, 66730, '\P{Is_Script_Extensions=	 OSMANYA}', "");
    Expect(0, 66730, '\P{^Is_Script_Extensions=	 OSMANYA}', "");
    Error('\p{Is_Scx=/a/-Osma}');
    Error('\P{Is_Scx=/a/-Osma}');
    Expect(1, 66729, '\p{Is_Scx=osma}', "");
    Expect(0, 66729, '\p{^Is_Scx=osma}', "");
    Expect(0, 66729, '\P{Is_Scx=osma}', "");
    Expect(1, 66729, '\P{^Is_Scx=osma}', "");
    Expect(0, 66730, '\p{Is_Scx=osma}', "");
    Expect(1, 66730, '\p{^Is_Scx=osma}', "");
    Expect(1, 66730, '\P{Is_Scx=osma}', "");
    Expect(0, 66730, '\P{^Is_Scx=osma}', "");
    Expect(1, 66729, '\p{Is_Scx=-Osma}', "");
    Expect(0, 66729, '\p{^Is_Scx=-Osma}', "");
    Expect(0, 66729, '\P{Is_Scx=-Osma}', "");
    Expect(1, 66729, '\P{^Is_Scx=-Osma}', "");
    Expect(0, 66730, '\p{Is_Scx=-Osma}', "");
    Expect(1, 66730, '\p{^Is_Scx=-Osma}', "");
    Expect(1, 66730, '\P{Is_Scx=-Osma}', "");
    Expect(0, 66730, '\P{^Is_Scx=-Osma}', "");
    Error('\p{Script_Extensions:   /a/_Old_uyghur}');
    Error('\P{Script_Extensions:   /a/_Old_uyghur}');
    Expect(1, 69513, '\p{Script_Extensions=:\AOld_Uyghur\z:}', "");;
    Expect(0, 69514, '\p{Script_Extensions=:\AOld_Uyghur\z:}', "");;
    Expect(1, 69513, '\p{Script_Extensions=olduyghur}', "");
    Expect(0, 69513, '\p{^Script_Extensions=olduyghur}', "");
    Expect(0, 69513, '\P{Script_Extensions=olduyghur}', "");
    Expect(1, 69513, '\P{^Script_Extensions=olduyghur}', "");
    Expect(0, 69514, '\p{Script_Extensions=olduyghur}', "");
    Expect(1, 69514, '\p{^Script_Extensions=olduyghur}', "");
    Expect(1, 69514, '\P{Script_Extensions=olduyghur}', "");
    Expect(0, 69514, '\P{^Script_Extensions=olduyghur}', "");
    Expect(1, 69513, '\p{Script_Extensions=:\Aolduyghur\z:}', "");;
    Expect(0, 69514, '\p{Script_Extensions=:\Aolduyghur\z:}', "");;
    Expect(1, 69513, '\p{Script_Extensions= Old_UYGHUR}', "");
    Expect(0, 69513, '\p{^Script_Extensions= Old_UYGHUR}', "");
    Expect(0, 69513, '\P{Script_Extensions= Old_UYGHUR}', "");
    Expect(1, 69513, '\P{^Script_Extensions= Old_UYGHUR}', "");
    Expect(0, 69514, '\p{Script_Extensions= Old_UYGHUR}', "");
    Expect(1, 69514, '\p{^Script_Extensions= Old_UYGHUR}', "");
    Expect(1, 69514, '\P{Script_Extensions= Old_UYGHUR}', "");
    Expect(0, 69514, '\P{^Script_Extensions= Old_UYGHUR}', "");
    Error('\p{Scx=_	Ougr/a/}');
    Error('\P{Scx=_	Ougr/a/}');
    Expect(1, 69513, '\p{Scx=:\AOugr\z:}', "");;
    Expect(0, 69514, '\p{Scx=:\AOugr\z:}', "");;
    Expect(1, 69513, '\p{Scx=ougr}', "");
    Expect(0, 69513, '\p{^Scx=ougr}', "");
    Expect(0, 69513, '\P{Scx=ougr}', "");
    Expect(1, 69513, '\P{^Scx=ougr}', "");
    Expect(0, 69514, '\p{Scx=ougr}', "");
    Expect(1, 69514, '\p{^Scx=ougr}', "");
    Expect(1, 69514, '\P{Scx=ougr}', "");
    Expect(0, 69514, '\P{^Scx=ougr}', "");
    Expect(1, 69513, '\p{Scx=:\Aougr\z:}', "");;
    Expect(0, 69514, '\p{Scx=:\Aougr\z:}', "");;
    Expect(1, 69513, '\p{Scx=	-Ougr}', "");
    Expect(0, 69513, '\p{^Scx=	-Ougr}', "");
    Expect(0, 69513, '\P{Scx=	-Ougr}', "");
    Expect(1, 69513, '\P{^Scx=	-Ougr}', "");
    Expect(0, 69514, '\p{Scx=	-Ougr}', "");
    Expect(1, 69514, '\p{^Scx=	-Ougr}', "");
    Expect(1, 69514, '\P{Scx=	-Ougr}', "");
    Expect(0, 69514, '\P{^Scx=	-Ougr}', "");
    Error('\p{Is_Script_Extensions=:= _Old_Uyghur}');
    Error('\P{Is_Script_Extensions=:= _Old_Uyghur}');
    Expect(1, 69513, '\p{Is_Script_Extensions=olduyghur}', "");
    Expect(0, 69513, '\p{^Is_Script_Extensions=olduyghur}', "");
    Expect(0, 69513, '\P{Is_Script_Extensions=olduyghur}', "");
    Expect(1, 69513, '\P{^Is_Script_Extensions=olduyghur}', "");
    Expect(0, 69514, '\p{Is_Script_Extensions=olduyghur}', "");
    Expect(1, 69514, '\p{^Is_Script_Extensions=olduyghur}', "");
    Expect(1, 69514, '\P{Is_Script_Extensions=olduyghur}', "");
    Expect(0, 69514, '\P{^Is_Script_Extensions=olduyghur}', "");
    Expect(1, 69513, '\p{Is_Script_Extensions=-OLD_uyghur}', "");
    Expect(0, 69513, '\p{^Is_Script_Extensions=-OLD_uyghur}', "");
    Expect(0, 69513, '\P{Is_Script_Extensions=-OLD_uyghur}', "");
    Expect(1, 69513, '\P{^Is_Script_Extensions=-OLD_uyghur}', "");
    Expect(0, 69514, '\p{Is_Script_Extensions=-OLD_uyghur}', "");
    Expect(1, 69514, '\p{^Is_Script_Extensions=-OLD_uyghur}', "");
    Expect(1, 69514, '\P{Is_Script_Extensions=-OLD_uyghur}', "");
    Expect(0, 69514, '\P{^Is_Script_Extensions=-OLD_uyghur}', "");
    Error('\p{Is_Scx=_	Ougr/a/}');
    Error('\P{Is_Scx=_	Ougr/a/}');
    Expect(1, 69513, '\p{Is_Scx=ougr}', "");
    Expect(0, 69513, '\p{^Is_Scx=ougr}', "");
    Expect(0, 69513, '\P{Is_Scx=ougr}', "");
    Expect(1, 69513, '\P{^Is_Scx=ougr}', "");
    Expect(0, 69514, '\p{Is_Scx=ougr}', "");
    Expect(1, 69514, '\p{^Is_Scx=ougr}', "");
    Expect(1, 69514, '\P{Is_Scx=ougr}', "");
    Expect(0, 69514, '\P{^Is_Scx=ougr}', "");
    Expect(1, 69513, '\p{Is_Scx=	Ougr}', "");
    Expect(0, 69513, '\p{^Is_Scx=	Ougr}', "");
    Expect(0, 69513, '\P{Is_Scx=	Ougr}', "");
    Expect(1, 69513, '\P{^Is_Scx=	Ougr}', "");
    Expect(0, 69514, '\p{Is_Scx=	Ougr}', "");
    Expect(1, 69514, '\p{^Is_Scx=	Ougr}', "");
    Expect(1, 69514, '\P{Is_Scx=	Ougr}', "");
    Expect(0, 69514, '\P{^Is_Scx=	Ougr}', "");
    Error('\p{Script_Extensions=Palmyrene/a/}');
    Error('\P{Script_Extensions=Palmyrene/a/}');
    Expect(1, 67711, '\p{Script_Extensions=:\APalmyrene\z:}', "");;
    Expect(0, 67712, '\p{Script_Extensions=:\APalmyrene\z:}', "");;
    Expect(1, 67711, '\p{Script_Extensions=palmyrene}', "");
    Expect(0, 67711, '\p{^Script_Extensions=palmyrene}', "");
    Expect(0, 67711, '\P{Script_Extensions=palmyrene}', "");
    Expect(1, 67711, '\P{^Script_Extensions=palmyrene}', "");
    Expect(0, 67712, '\p{Script_Extensions=palmyrene}', "");
    Expect(1, 67712, '\p{^Script_Extensions=palmyrene}', "");
    Expect(1, 67712, '\P{Script_Extensions=palmyrene}', "");
    Expect(0, 67712, '\P{^Script_Extensions=palmyrene}', "");
    Expect(1, 67711, '\p{Script_Extensions=:\Apalmyrene\z:}', "");;
    Expect(0, 67712, '\p{Script_Extensions=:\Apalmyrene\z:}', "");;
    Expect(1, 67711, '\p{Script_Extensions=	-Palmyrene}', "");
    Expect(0, 67711, '\p{^Script_Extensions=	-Palmyrene}', "");
    Expect(0, 67711, '\P{Script_Extensions=	-Palmyrene}', "");
    Expect(1, 67711, '\P{^Script_Extensions=	-Palmyrene}', "");
    Expect(0, 67712, '\p{Script_Extensions=	-Palmyrene}', "");
    Expect(1, 67712, '\p{^Script_Extensions=	-Palmyrene}', "");
    Expect(1, 67712, '\P{Script_Extensions=	-Palmyrene}', "");
    Expect(0, 67712, '\P{^Script_Extensions=	-Palmyrene}', "");
    Error('\p{Scx=:= 	PALM}');
    Error('\P{Scx=:= 	PALM}');
    Expect(1, 67711, '\p{Scx=:\APalm\z:}', "");;
    Expect(0, 67712, '\p{Scx=:\APalm\z:}', "");;
    Expect(1, 67711, '\p{Scx=palm}', "");
    Expect(0, 67711, '\p{^Scx=palm}', "");
    Expect(0, 67711, '\P{Scx=palm}', "");
    Expect(1, 67711, '\P{^Scx=palm}', "");
    Expect(0, 67712, '\p{Scx=palm}', "");
    Expect(1, 67712, '\p{^Scx=palm}', "");
    Expect(1, 67712, '\P{Scx=palm}', "");
    Expect(0, 67712, '\P{^Scx=palm}', "");
    Expect(1, 67711, '\p{Scx=:\Apalm\z:}', "");;
    Expect(0, 67712, '\p{Scx=:\Apalm\z:}', "");;
    Expect(1, 67711, '\p{Scx= -PALM}', "");
    Expect(0, 67711, '\p{^Scx= -PALM}', "");
    Expect(0, 67711, '\P{Scx= -PALM}', "");
    Expect(1, 67711, '\P{^Scx= -PALM}', "");
    Expect(0, 67712, '\p{Scx= -PALM}', "");
    Expect(1, 67712, '\p{^Scx= -PALM}', "");
    Expect(1, 67712, '\P{Scx= -PALM}', "");
    Expect(0, 67712, '\P{^Scx= -PALM}', "");
    Error('\p{Is_Script_Extensions:	- PALMYRENE/a/}');
    Error('\P{Is_Script_Extensions:	- PALMYRENE/a/}');
    Expect(1, 67711, '\p{Is_Script_Extensions=palmyrene}', "");
    Expect(0, 67711, '\p{^Is_Script_Extensions=palmyrene}', "");
    Expect(0, 67711, '\P{Is_Script_Extensions=palmyrene}', "");
    Expect(1, 67711, '\P{^Is_Script_Extensions=palmyrene}', "");
    Expect(0, 67712, '\p{Is_Script_Extensions=palmyrene}', "");
    Expect(1, 67712, '\p{^Is_Script_Extensions=palmyrene}', "");
    Expect(1, 67712, '\P{Is_Script_Extensions=palmyrene}', "");
    Expect(0, 67712, '\P{^Is_Script_Extensions=palmyrene}', "");
    Expect(1, 67711, '\p{Is_Script_Extensions=_palmyrene}', "");
    Expect(0, 67711, '\p{^Is_Script_Extensions=_palmyrene}', "");
    Expect(0, 67711, '\P{Is_Script_Extensions=_palmyrene}', "");
    Expect(1, 67711, '\P{^Is_Script_Extensions=_palmyrene}', "");
    Expect(0, 67712, '\p{Is_Script_Extensions=_palmyrene}', "");
    Expect(1, 67712, '\p{^Is_Script_Extensions=_palmyrene}', "");
    Expect(1, 67712, '\P{Is_Script_Extensions=_palmyrene}', "");
    Expect(0, 67712, '\P{^Is_Script_Extensions=_palmyrene}', "");
    Error('\p{Is_Scx=-:=palm}');
    Error('\P{Is_Scx=-:=palm}');
    Expect(1, 67711, '\p{Is_Scx=palm}', "");
    Expect(0, 67711, '\p{^Is_Scx=palm}', "");
    Expect(0, 67711, '\P{Is_Scx=palm}', "");
    Expect(1, 67711, '\P{^Is_Scx=palm}', "");
    Expect(0, 67712, '\p{Is_Scx=palm}', "");
    Expect(1, 67712, '\p{^Is_Scx=palm}', "");
    Expect(1, 67712, '\P{Is_Scx=palm}', "");
    Expect(0, 67712, '\P{^Is_Scx=palm}', "");
    Expect(1, 67711, '\p{Is_Scx=	Palm}', "");
    Expect(0, 67711, '\p{^Is_Scx=	Palm}', "");
    Expect(0, 67711, '\P{Is_Scx=	Palm}', "");
    Expect(1, 67711, '\P{^Is_Scx=	Palm}', "");
    Expect(0, 67712, '\p{Is_Scx=	Palm}', "");
    Expect(1, 67712, '\p{^Is_Scx=	Palm}', "");
    Expect(1, 67712, '\P{Is_Scx=	Palm}', "");
    Expect(0, 67712, '\P{^Is_Scx=	Palm}', "");
    Error('\p{Script_Extensions= /a/pau_Cin_Hau}');
    Error('\P{Script_Extensions= /a/pau_Cin_Hau}');
    Expect(1, 72440, '\p{Script_Extensions=:\APau_Cin_Hau\z:}', "");;
    Expect(0, 72441, '\p{Script_Extensions=:\APau_Cin_Hau\z:}', "");;
    Expect(1, 72440, '\p{Script_Extensions:   paucinhau}', "");
    Expect(0, 72440, '\p{^Script_Extensions:   paucinhau}', "");
    Expect(0, 72440, '\P{Script_Extensions:   paucinhau}', "");
    Expect(1, 72440, '\P{^Script_Extensions:   paucinhau}', "");
    Expect(0, 72441, '\p{Script_Extensions:   paucinhau}', "");
    Expect(1, 72441, '\p{^Script_Extensions:   paucinhau}', "");
    Expect(1, 72441, '\P{Script_Extensions:   paucinhau}', "");
    Expect(0, 72441, '\P{^Script_Extensions:   paucinhau}', "");
    Expect(1, 72440, '\p{Script_Extensions=:\Apaucinhau\z:}', "");;
    Expect(0, 72441, '\p{Script_Extensions=:\Apaucinhau\z:}', "");;
    Expect(1, 72440, '\p{Script_Extensions:  	pau_Cin_Hau}', "");
    Expect(0, 72440, '\p{^Script_Extensions:  	pau_Cin_Hau}', "");
    Expect(0, 72440, '\P{Script_Extensions:  	pau_Cin_Hau}', "");
    Expect(1, 72440, '\P{^Script_Extensions:  	pau_Cin_Hau}', "");
    Expect(0, 72441, '\p{Script_Extensions:  	pau_Cin_Hau}', "");
    Expect(1, 72441, '\p{^Script_Extensions:  	pau_Cin_Hau}', "");
    Expect(1, 72441, '\P{Script_Extensions:  	pau_Cin_Hau}', "");
    Expect(0, 72441, '\P{^Script_Extensions:  	pau_Cin_Hau}', "");
    Error('\p{Scx=_pauc:=}');
    Error('\P{Scx=_pauc:=}');
    Expect(1, 72440, '\p{Scx=:\APauc\z:}', "");;
    Expect(0, 72441, '\p{Scx=:\APauc\z:}', "");;
    Expect(1, 72440, '\p{Scx:	pauc}', "");
    Expect(0, 72440, '\p{^Scx:	pauc}', "");
    Expect(0, 72440, '\P{Scx:	pauc}', "");
    Expect(1, 72440, '\P{^Scx:	pauc}', "");
    Expect(0, 72441, '\p{Scx:	pauc}', "");
    Expect(1, 72441, '\p{^Scx:	pauc}', "");
    Expect(1, 72441, '\P{Scx:	pauc}', "");
    Expect(0, 72441, '\P{^Scx:	pauc}', "");
    Expect(1, 72440, '\p{Scx=:\Apauc\z:}', "");;
    Expect(0, 72441, '\p{Scx=:\Apauc\z:}', "");;
    Expect(1, 72440, '\p{Scx:	 Pauc}', "");
    Expect(0, 72440, '\p{^Scx:	 Pauc}', "");
    Expect(0, 72440, '\P{Scx:	 Pauc}', "");
    Expect(1, 72440, '\P{^Scx:	 Pauc}', "");
    Expect(0, 72441, '\p{Scx:	 Pauc}', "");
    Expect(1, 72441, '\p{^Scx:	 Pauc}', "");
    Expect(1, 72441, '\P{Scx:	 Pauc}', "");
    Expect(0, 72441, '\P{^Scx:	 Pauc}', "");
    Error('\p{Is_Script_Extensions: _ Pau_cin_Hau:=}');
    Error('\P{Is_Script_Extensions: _ Pau_cin_Hau:=}');
    Expect(1, 72440, '\p{Is_Script_Extensions: paucinhau}', "");
    Expect(0, 72440, '\p{^Is_Script_Extensions: paucinhau}', "");
    Expect(0, 72440, '\P{Is_Script_Extensions: paucinhau}', "");
    Expect(1, 72440, '\P{^Is_Script_Extensions: paucinhau}', "");
    Expect(0, 72441, '\p{Is_Script_Extensions: paucinhau}', "");
    Expect(1, 72441, '\p{^Is_Script_Extensions: paucinhau}', "");
    Expect(1, 72441, '\P{Is_Script_Extensions: paucinhau}', "");
    Expect(0, 72441, '\P{^Is_Script_Extensions: paucinhau}', "");
    Expect(1, 72440, '\p{Is_Script_Extensions= _PAU_Cin_hau}', "");
    Expect(0, 72440, '\p{^Is_Script_Extensions= _PAU_Cin_hau}', "");
    Expect(0, 72440, '\P{Is_Script_Extensions= _PAU_Cin_hau}', "");
    Expect(1, 72440, '\P{^Is_Script_Extensions= _PAU_Cin_hau}', "");
    Expect(0, 72441, '\p{Is_Script_Extensions= _PAU_Cin_hau}', "");
    Expect(1, 72441, '\p{^Is_Script_Extensions= _PAU_Cin_hau}', "");
    Expect(1, 72441, '\P{Is_Script_Extensions= _PAU_Cin_hau}', "");
    Expect(0, 72441, '\P{^Is_Script_Extensions= _PAU_Cin_hau}', "");
    Error('\p{Is_Scx=- pauc/a/}');
    Error('\P{Is_Scx=- pauc/a/}');
    Expect(1, 72440, '\p{Is_Scx:   pauc}', "");
    Expect(0, 72440, '\p{^Is_Scx:   pauc}', "");
    Expect(0, 72440, '\P{Is_Scx:   pauc}', "");
    Expect(1, 72440, '\P{^Is_Scx:   pauc}', "");
    Expect(0, 72441, '\p{Is_Scx:   pauc}', "");
    Expect(1, 72441, '\p{^Is_Scx:   pauc}', "");
    Expect(1, 72441, '\P{Is_Scx:   pauc}', "");
    Expect(0, 72441, '\P{^Is_Scx:   pauc}', "");
    Expect(1, 72440, '\p{Is_Scx=	_Pauc}', "");
    Expect(0, 72440, '\p{^Is_Scx=	_Pauc}', "");
    Expect(0, 72440, '\P{Is_Scx=	_Pauc}', "");
    Expect(1, 72440, '\P{^Is_Scx=	_Pauc}', "");
    Expect(0, 72441, '\p{Is_Scx=	_Pauc}', "");
    Expect(1, 72441, '\p{^Is_Scx=	_Pauc}', "");
    Expect(1, 72441, '\P{Is_Scx=	_Pauc}', "");
    Expect(0, 72441, '\P{^Is_Scx=	_Pauc}', "");
    Error('\p{Script_Extensions=_old_PERMIC/a/}');
    Error('\P{Script_Extensions=_old_PERMIC/a/}');
    Expect(1, 66426, '\p{Script_Extensions=:\AOld_Permic\z:}', "");;
    Expect(0, 66427, '\p{Script_Extensions=:\AOld_Permic\z:}', "");;
    Expect(1, 66426, '\p{Script_Extensions: oldpermic}', "");
    Expect(0, 66426, '\p{^Script_Extensions: oldpermic}', "");
    Expect(0, 66426, '\P{Script_Extensions: oldpermic}', "");
    Expect(1, 66426, '\P{^Script_Extensions: oldpermic}', "");
    Expect(0, 66427, '\p{Script_Extensions: oldpermic}', "");
    Expect(1, 66427, '\p{^Script_Extensions: oldpermic}', "");
    Expect(1, 66427, '\P{Script_Extensions: oldpermic}', "");
    Expect(0, 66427, '\P{^Script_Extensions: oldpermic}', "");
    Expect(1, 66426, '\p{Script_Extensions=:\Aoldpermic\z:}', "");;
    Expect(0, 66427, '\p{Script_Extensions=:\Aoldpermic\z:}', "");;
    Expect(1, 66426, '\p{Script_Extensions= Old_PERMIC}', "");
    Expect(0, 66426, '\p{^Script_Extensions= Old_PERMIC}', "");
    Expect(0, 66426, '\P{Script_Extensions= Old_PERMIC}', "");
    Expect(1, 66426, '\P{^Script_Extensions= Old_PERMIC}', "");
    Expect(0, 66427, '\p{Script_Extensions= Old_PERMIC}', "");
    Expect(1, 66427, '\p{^Script_Extensions= Old_PERMIC}', "");
    Expect(1, 66427, '\P{Script_Extensions= Old_PERMIC}', "");
    Expect(0, 66427, '\P{^Script_Extensions= Old_PERMIC}', "");
    Error('\p{Scx: /a/	-Perm}');
    Error('\P{Scx: /a/	-Perm}');
    Expect(1, 66426, '\p{Scx=:\APerm\z:}', "");;
    Expect(0, 66427, '\p{Scx=:\APerm\z:}', "");;
    Expect(1, 66426, '\p{Scx=perm}', "");
    Expect(0, 66426, '\p{^Scx=perm}', "");
    Expect(0, 66426, '\P{Scx=perm}', "");
    Expect(1, 66426, '\P{^Scx=perm}', "");
    Expect(0, 66427, '\p{Scx=perm}', "");
    Expect(1, 66427, '\p{^Scx=perm}', "");
    Expect(1, 66427, '\P{Scx=perm}', "");
    Expect(0, 66427, '\P{^Scx=perm}', "");
    Expect(1, 66426, '\p{Scx=:\Aperm\z:}', "");;
    Expect(0, 66427, '\p{Scx=:\Aperm\z:}', "");;
    Expect(1, 66426, '\p{Scx:   -_PERM}', "");
    Expect(0, 66426, '\p{^Scx:   -_PERM}', "");
    Expect(0, 66426, '\P{Scx:   -_PERM}', "");
    Expect(1, 66426, '\P{^Scx:   -_PERM}', "");
    Expect(0, 66427, '\p{Scx:   -_PERM}', "");
    Expect(1, 66427, '\p{^Scx:   -_PERM}', "");
    Expect(1, 66427, '\P{Scx:   -_PERM}', "");
    Expect(0, 66427, '\P{^Scx:   -_PERM}', "");
    Error('\p{Is_Script_Extensions=	_OLD_PERMIC/a/}');
    Error('\P{Is_Script_Extensions=	_OLD_PERMIC/a/}');
    Expect(1, 66426, '\p{Is_Script_Extensions=oldpermic}', "");
    Expect(0, 66426, '\p{^Is_Script_Extensions=oldpermic}', "");
    Expect(0, 66426, '\P{Is_Script_Extensions=oldpermic}', "");
    Expect(1, 66426, '\P{^Is_Script_Extensions=oldpermic}', "");
    Expect(0, 66427, '\p{Is_Script_Extensions=oldpermic}', "");
    Expect(1, 66427, '\p{^Is_Script_Extensions=oldpermic}', "");
    Expect(1, 66427, '\P{Is_Script_Extensions=oldpermic}', "");
    Expect(0, 66427, '\P{^Is_Script_Extensions=oldpermic}', "");
    Expect(1, 66426, '\p{Is_Script_Extensions:		Old_Permic}', "");
    Expect(0, 66426, '\p{^Is_Script_Extensions:		Old_Permic}', "");
    Expect(0, 66426, '\P{Is_Script_Extensions:		Old_Permic}', "");
    Expect(1, 66426, '\P{^Is_Script_Extensions:		Old_Permic}', "");
    Expect(0, 66427, '\p{Is_Script_Extensions:		Old_Permic}', "");
    Expect(1, 66427, '\p{^Is_Script_Extensions:		Old_Permic}', "");
    Expect(1, 66427, '\P{Is_Script_Extensions:		Old_Permic}', "");
    Expect(0, 66427, '\P{^Is_Script_Extensions:		Old_Permic}', "");
    Error('\p{Is_Scx=	-Perm:=}');
    Error('\P{Is_Scx=	-Perm:=}');
    Expect(1, 66426, '\p{Is_Scx:	perm}', "");
    Expect(0, 66426, '\p{^Is_Scx:	perm}', "");
    Expect(0, 66426, '\P{Is_Scx:	perm}', "");
    Expect(1, 66426, '\P{^Is_Scx:	perm}', "");
    Expect(0, 66427, '\p{Is_Scx:	perm}', "");
    Expect(1, 66427, '\p{^Is_Scx:	perm}', "");
    Expect(1, 66427, '\P{Is_Scx:	perm}', "");
    Expect(0, 66427, '\P{^Is_Scx:	perm}', "");
    Expect(1, 66426, '\p{Is_Scx= _PERM}', "");
    Expect(0, 66426, '\p{^Is_Scx= _PERM}', "");
    Expect(0, 66426, '\P{Is_Scx= _PERM}', "");
    Expect(1, 66426, '\P{^Is_Scx= _PERM}', "");
    Expect(0, 66427, '\p{Is_Scx= _PERM}', "");
    Expect(1, 66427, '\p{^Is_Scx= _PERM}', "");
    Expect(1, 66427, '\P{Is_Scx= _PERM}', "");
    Expect(0, 66427, '\P{^Is_Scx= _PERM}', "");
    Error('\p{Script_Extensions=:= PHAGS_Pa}');
    Error('\P{Script_Extensions=:= PHAGS_Pa}');
    Expect(1, 43127, '\p{Script_Extensions=:\APhags_Pa\z:}', "");;
    Expect(0, 43128, '\p{Script_Extensions=:\APhags_Pa\z:}', "");;
    Expect(1, 43127, '\p{Script_Extensions=phagspa}', "");
    Expect(0, 43127, '\p{^Script_Extensions=phagspa}', "");
    Expect(0, 43127, '\P{Script_Extensions=phagspa}', "");
    Expect(1, 43127, '\P{^Script_Extensions=phagspa}', "");
    Expect(0, 43128, '\p{Script_Extensions=phagspa}', "");
    Expect(1, 43128, '\p{^Script_Extensions=phagspa}', "");
    Expect(1, 43128, '\P{Script_Extensions=phagspa}', "");
    Expect(0, 43128, '\P{^Script_Extensions=phagspa}', "");
    Expect(1, 43127, '\p{Script_Extensions=:\Aphagspa\z:}', "");;
    Expect(0, 43128, '\p{Script_Extensions=:\Aphagspa\z:}', "");;
    Expect(1, 43127, '\p{Script_Extensions=--Phags_Pa}', "");
    Expect(0, 43127, '\p{^Script_Extensions=--Phags_Pa}', "");
    Expect(0, 43127, '\P{Script_Extensions=--Phags_Pa}', "");
    Expect(1, 43127, '\P{^Script_Extensions=--Phags_Pa}', "");
    Expect(0, 43128, '\p{Script_Extensions=--Phags_Pa}', "");
    Expect(1, 43128, '\p{^Script_Extensions=--Phags_Pa}', "");
    Expect(1, 43128, '\P{Script_Extensions=--Phags_Pa}', "");
    Expect(0, 43128, '\P{^Script_Extensions=--Phags_Pa}', "");
    Error('\p{Scx=-_phag:=}');
    Error('\P{Scx=-_phag:=}');
    Expect(1, 43127, '\p{Scx=:\APhag\z:}', "");;
    Expect(0, 43128, '\p{Scx=:\APhag\z:}', "");;
    Expect(1, 43127, '\p{Scx=phag}', "");
    Expect(0, 43127, '\p{^Scx=phag}', "");
    Expect(0, 43127, '\P{Scx=phag}', "");
    Expect(1, 43127, '\P{^Scx=phag}', "");
    Expect(0, 43128, '\p{Scx=phag}', "");
    Expect(1, 43128, '\p{^Scx=phag}', "");
    Expect(1, 43128, '\P{Scx=phag}', "");
    Expect(0, 43128, '\P{^Scx=phag}', "");
    Expect(1, 43127, '\p{Scx=:\Aphag\z:}', "");;
    Expect(0, 43128, '\p{Scx=:\Aphag\z:}', "");;
    Expect(1, 43127, '\p{Scx=-	Phag}', "");
    Expect(0, 43127, '\p{^Scx=-	Phag}', "");
    Expect(0, 43127, '\P{Scx=-	Phag}', "");
    Expect(1, 43127, '\P{^Scx=-	Phag}', "");
    Expect(0, 43128, '\p{Scx=-	Phag}', "");
    Expect(1, 43128, '\p{^Scx=-	Phag}', "");
    Expect(1, 43128, '\P{Scx=-	Phag}', "");
    Expect(0, 43128, '\P{^Scx=-	Phag}', "");
    Error('\p{Is_Script_Extensions=-_Phags_pa:=}');
    Error('\P{Is_Script_Extensions=-_Phags_pa:=}');
    Expect(1, 43127, '\p{Is_Script_Extensions=phagspa}', "");
    Expect(0, 43127, '\p{^Is_Script_Extensions=phagspa}', "");
    Expect(0, 43127, '\P{Is_Script_Extensions=phagspa}', "");
    Expect(1, 43127, '\P{^Is_Script_Extensions=phagspa}', "");
    Expect(0, 43128, '\p{Is_Script_Extensions=phagspa}', "");
    Expect(1, 43128, '\p{^Is_Script_Extensions=phagspa}', "");
    Expect(1, 43128, '\P{Is_Script_Extensions=phagspa}', "");
    Expect(0, 43128, '\P{^Is_Script_Extensions=phagspa}', "");
    Expect(1, 43127, '\p{Is_Script_Extensions=_Phags_pa}', "");
    Expect(0, 43127, '\p{^Is_Script_Extensions=_Phags_pa}', "");
    Expect(0, 43127, '\P{Is_Script_Extensions=_Phags_pa}', "");
    Expect(1, 43127, '\P{^Is_Script_Extensions=_Phags_pa}', "");
    Expect(0, 43128, '\p{Is_Script_Extensions=_Phags_pa}', "");
    Expect(1, 43128, '\p{^Is_Script_Extensions=_Phags_pa}', "");
    Expect(1, 43128, '\P{Is_Script_Extensions=_Phags_pa}', "");
    Expect(0, 43128, '\P{^Is_Script_Extensions=_Phags_pa}', "");
    Error('\p{Is_Scx=	_phag:=}');
    Error('\P{Is_Scx=	_phag:=}');
    Expect(1, 43127, '\p{Is_Scx=phag}', "");
    Expect(0, 43127, '\p{^Is_Scx=phag}', "");
    Expect(0, 43127, '\P{Is_Scx=phag}', "");
    Expect(1, 43127, '\P{^Is_Scx=phag}', "");
    Expect(0, 43128, '\p{Is_Scx=phag}', "");
    Expect(1, 43128, '\p{^Is_Scx=phag}', "");
    Expect(1, 43128, '\P{Is_Scx=phag}', "");
    Expect(0, 43128, '\P{^Is_Scx=phag}', "");
    Expect(1, 43127, '\p{Is_Scx=	_Phag}', "");
    Expect(0, 43127, '\p{^Is_Scx=	_Phag}', "");
    Expect(0, 43127, '\P{Is_Scx=	_Phag}', "");
    Expect(1, 43127, '\P{^Is_Scx=	_Phag}', "");
    Expect(0, 43128, '\p{Is_Scx=	_Phag}', "");
    Expect(1, 43128, '\p{^Is_Scx=	_Phag}', "");
    Expect(1, 43128, '\P{Is_Scx=	_Phag}', "");
    Expect(0, 43128, '\P{^Is_Scx=	_Phag}', "");
    Error('\p{Script_Extensions=:=	inscriptional_pahlavi}');
    Error('\P{Script_Extensions=:=	inscriptional_pahlavi}');
    Expect(1, 68479, '\p{Script_Extensions=:\AInscriptional_Pahlavi\z:}', "");;
    Expect(0, 68480, '\p{Script_Extensions=:\AInscriptional_Pahlavi\z:}', "");;
    Expect(1, 68479, '\p{Script_Extensions: inscriptionalpahlavi}', "");
    Expect(0, 68479, '\p{^Script_Extensions: inscriptionalpahlavi}', "");
    Expect(0, 68479, '\P{Script_Extensions: inscriptionalpahlavi}', "");
    Expect(1, 68479, '\P{^Script_Extensions: inscriptionalpahlavi}', "");
    Expect(0, 68480, '\p{Script_Extensions: inscriptionalpahlavi}', "");
    Expect(1, 68480, '\p{^Script_Extensions: inscriptionalpahlavi}', "");
    Expect(1, 68480, '\P{Script_Extensions: inscriptionalpahlavi}', "");
    Expect(0, 68480, '\P{^Script_Extensions: inscriptionalpahlavi}', "");
    Expect(1, 68479, '\p{Script_Extensions=:\Ainscriptionalpahlavi\z:}', "");;
    Expect(0, 68480, '\p{Script_Extensions=:\Ainscriptionalpahlavi\z:}', "");;
    Expect(1, 68479, '\p{Script_Extensions= 	Inscriptional_Pahlavi}', "");
    Expect(0, 68479, '\p{^Script_Extensions= 	Inscriptional_Pahlavi}', "");
    Expect(0, 68479, '\P{Script_Extensions= 	Inscriptional_Pahlavi}', "");
    Expect(1, 68479, '\P{^Script_Extensions= 	Inscriptional_Pahlavi}', "");
    Expect(0, 68480, '\p{Script_Extensions= 	Inscriptional_Pahlavi}', "");
    Expect(1, 68480, '\p{^Script_Extensions= 	Inscriptional_Pahlavi}', "");
    Expect(1, 68480, '\P{Script_Extensions= 	Inscriptional_Pahlavi}', "");
    Expect(0, 68480, '\P{^Script_Extensions= 	Inscriptional_Pahlavi}', "");
    Error('\p{Scx: Phli/a/}');
    Error('\P{Scx: Phli/a/}');
    Expect(1, 68479, '\p{Scx=:\APhli\z:}', "");;
    Expect(0, 68480, '\p{Scx=:\APhli\z:}', "");;
    Expect(1, 68479, '\p{Scx=phli}', "");
    Expect(0, 68479, '\p{^Scx=phli}', "");
    Expect(0, 68479, '\P{Scx=phli}', "");
    Expect(1, 68479, '\P{^Scx=phli}', "");
    Expect(0, 68480, '\p{Scx=phli}', "");
    Expect(1, 68480, '\p{^Scx=phli}', "");
    Expect(1, 68480, '\P{Scx=phli}', "");
    Expect(0, 68480, '\P{^Scx=phli}', "");
    Expect(1, 68479, '\p{Scx=:\Aphli\z:}', "");;
    Expect(0, 68480, '\p{Scx=:\Aphli\z:}', "");;
    Expect(1, 68479, '\p{Scx=	 PHLI}', "");
    Expect(0, 68479, '\p{^Scx=	 PHLI}', "");
    Expect(0, 68479, '\P{Scx=	 PHLI}', "");
    Expect(1, 68479, '\P{^Scx=	 PHLI}', "");
    Expect(0, 68480, '\p{Scx=	 PHLI}', "");
    Expect(1, 68480, '\p{^Scx=	 PHLI}', "");
    Expect(1, 68480, '\P{Scx=	 PHLI}', "");
    Expect(0, 68480, '\P{^Scx=	 PHLI}', "");
    Error('\p{Is_Script_Extensions=/a/	-Inscriptional_pahlavi}');
    Error('\P{Is_Script_Extensions=/a/	-Inscriptional_pahlavi}');
    Expect(1, 68479, '\p{Is_Script_Extensions=inscriptionalpahlavi}', "");
    Expect(0, 68479, '\p{^Is_Script_Extensions=inscriptionalpahlavi}', "");
    Expect(0, 68479, '\P{Is_Script_Extensions=inscriptionalpahlavi}', "");
    Expect(1, 68479, '\P{^Is_Script_Extensions=inscriptionalpahlavi}', "");
    Expect(0, 68480, '\p{Is_Script_Extensions=inscriptionalpahlavi}', "");
    Expect(1, 68480, '\p{^Is_Script_Extensions=inscriptionalpahlavi}', "");
    Expect(1, 68480, '\P{Is_Script_Extensions=inscriptionalpahlavi}', "");
    Expect(0, 68480, '\P{^Is_Script_Extensions=inscriptionalpahlavi}', "");
    Expect(1, 68479, '\p{Is_Script_Extensions=	inscriptional_PAHLAVI}', "");
    Expect(0, 68479, '\p{^Is_Script_Extensions=	inscriptional_PAHLAVI}', "");
    Expect(0, 68479, '\P{Is_Script_Extensions=	inscriptional_PAHLAVI}', "");
    Expect(1, 68479, '\P{^Is_Script_Extensions=	inscriptional_PAHLAVI}', "");
    Expect(0, 68480, '\p{Is_Script_Extensions=	inscriptional_PAHLAVI}', "");
    Expect(1, 68480, '\p{^Is_Script_Extensions=	inscriptional_PAHLAVI}', "");
    Expect(1, 68480, '\P{Is_Script_Extensions=	inscriptional_PAHLAVI}', "");
    Expect(0, 68480, '\P{^Is_Script_Extensions=	inscriptional_PAHLAVI}', "");
    Error('\p{Is_Scx=	PHLI:=}');
    Error('\P{Is_Scx=	PHLI:=}');
    Expect(1, 68479, '\p{Is_Scx=phli}', "");
    Expect(0, 68479, '\p{^Is_Scx=phli}', "");
    Expect(0, 68479, '\P{Is_Scx=phli}', "");
    Expect(1, 68479, '\P{^Is_Scx=phli}', "");
    Expect(0, 68480, '\p{Is_Scx=phli}', "");
    Expect(1, 68480, '\p{^Is_Scx=phli}', "");
    Expect(1, 68480, '\P{Is_Scx=phli}', "");
    Expect(0, 68480, '\P{^Is_Scx=phli}', "");
    Expect(1, 68479, '\p{Is_Scx=_Phli}', "");
    Expect(0, 68479, '\p{^Is_Scx=_Phli}', "");
    Expect(0, 68479, '\P{Is_Scx=_Phli}', "");
    Expect(1, 68479, '\P{^Is_Scx=_Phli}', "");
    Expect(0, 68480, '\p{Is_Scx=_Phli}', "");
    Expect(1, 68480, '\p{^Is_Scx=_Phli}', "");
    Expect(1, 68480, '\P{Is_Scx=_Phli}', "");
    Expect(0, 68480, '\P{^Is_Scx=_Phli}', "");
    Error('\p{Script_Extensions=__Psalter_PAHLAVI:=}');
    Error('\P{Script_Extensions=__Psalter_PAHLAVI:=}');
    Expect(1, 68527, '\p{Script_Extensions=:\APsalter_Pahlavi\z:}', "");;
    Expect(0, 68528, '\p{Script_Extensions=:\APsalter_Pahlavi\z:}', "");;
    Expect(1, 68527, '\p{Script_Extensions=psalterpahlavi}', "");
    Expect(0, 68527, '\p{^Script_Extensions=psalterpahlavi}', "");
    Expect(0, 68527, '\P{Script_Extensions=psalterpahlavi}', "");
    Expect(1, 68527, '\P{^Script_Extensions=psalterpahlavi}', "");
    Expect(0, 68528, '\p{Script_Extensions=psalterpahlavi}', "");
    Expect(1, 68528, '\p{^Script_Extensions=psalterpahlavi}', "");
    Expect(1, 68528, '\P{Script_Extensions=psalterpahlavi}', "");
    Expect(0, 68528, '\P{^Script_Extensions=psalterpahlavi}', "");
    Expect(1, 68527, '\p{Script_Extensions=:\Apsalterpahlavi\z:}', "");;
    Expect(0, 68528, '\p{Script_Extensions=:\Apsalterpahlavi\z:}', "");;
    Expect(1, 68527, '\p{Script_Extensions=-Psalter_pahlavi}', "");
    Expect(0, 68527, '\p{^Script_Extensions=-Psalter_pahlavi}', "");
    Expect(0, 68527, '\P{Script_Extensions=-Psalter_pahlavi}', "");
    Expect(1, 68527, '\P{^Script_Extensions=-Psalter_pahlavi}', "");
    Expect(0, 68528, '\p{Script_Extensions=-Psalter_pahlavi}', "");
    Expect(1, 68528, '\p{^Script_Extensions=-Psalter_pahlavi}', "");
    Expect(1, 68528, '\P{Script_Extensions=-Psalter_pahlavi}', "");
    Expect(0, 68528, '\P{^Script_Extensions=-Psalter_pahlavi}', "");
    Error('\p{Scx: 	-Phlp/a/}');
    Error('\P{Scx: 	-Phlp/a/}');
    Expect(1, 68527, '\p{Scx=:\APhlp\z:}', "");;
    Expect(0, 68528, '\p{Scx=:\APhlp\z:}', "");;
    Expect(1, 68527, '\p{Scx=phlp}', "");
    Expect(0, 68527, '\p{^Scx=phlp}', "");
    Expect(0, 68527, '\P{Scx=phlp}', "");
    Expect(1, 68527, '\P{^Scx=phlp}', "");
    Expect(0, 68528, '\p{Scx=phlp}', "");
    Expect(1, 68528, '\p{^Scx=phlp}', "");
    Expect(1, 68528, '\P{Scx=phlp}', "");
    Expect(0, 68528, '\P{^Scx=phlp}', "");
    Expect(1, 68527, '\p{Scx=:\Aphlp\z:}', "");;
    Expect(0, 68528, '\p{Scx=:\Aphlp\z:}', "");;
    Expect(1, 68527, '\p{Scx=- phlp}', "");
    Expect(0, 68527, '\p{^Scx=- phlp}', "");
    Expect(0, 68527, '\P{Scx=- phlp}', "");
    Expect(1, 68527, '\P{^Scx=- phlp}', "");
    Expect(0, 68528, '\p{Scx=- phlp}', "");
    Expect(1, 68528, '\p{^Scx=- phlp}', "");
    Expect(1, 68528, '\P{Scx=- phlp}', "");
    Expect(0, 68528, '\P{^Scx=- phlp}', "");
    Error('\p{Is_Script_Extensions=/a/ -Psalter_pahlavi}');
    Error('\P{Is_Script_Extensions=/a/ -Psalter_pahlavi}');
    Expect(1, 68527, '\p{Is_Script_Extensions=psalterpahlavi}', "");
    Expect(0, 68527, '\p{^Is_Script_Extensions=psalterpahlavi}', "");
    Expect(0, 68527, '\P{Is_Script_Extensions=psalterpahlavi}', "");
    Expect(1, 68527, '\P{^Is_Script_Extensions=psalterpahlavi}', "");
    Expect(0, 68528, '\p{Is_Script_Extensions=psalterpahlavi}', "");
    Expect(1, 68528, '\p{^Is_Script_Extensions=psalterpahlavi}', "");
    Expect(1, 68528, '\P{Is_Script_Extensions=psalterpahlavi}', "");
    Expect(0, 68528, '\P{^Is_Script_Extensions=psalterpahlavi}', "");
    Expect(1, 68527, '\p{Is_Script_Extensions=	_Psalter_pahlavi}', "");
    Expect(0, 68527, '\p{^Is_Script_Extensions=	_Psalter_pahlavi}', "");
    Expect(0, 68527, '\P{Is_Script_Extensions=	_Psalter_pahlavi}', "");
    Expect(1, 68527, '\P{^Is_Script_Extensions=	_Psalter_pahlavi}', "");
    Expect(0, 68528, '\p{Is_Script_Extensions=	_Psalter_pahlavi}', "");
    Expect(1, 68528, '\p{^Is_Script_Extensions=	_Psalter_pahlavi}', "");
    Expect(1, 68528, '\P{Is_Script_Extensions=	_Psalter_pahlavi}', "");
    Expect(0, 68528, '\P{^Is_Script_Extensions=	_Psalter_pahlavi}', "");
    Error('\p{Is_Scx=-	Phlp:=}');
    Error('\P{Is_Scx=-	Phlp:=}');
    Expect(1, 68527, '\p{Is_Scx=phlp}', "");
    Expect(0, 68527, '\p{^Is_Scx=phlp}', "");
    Expect(0, 68527, '\P{Is_Scx=phlp}', "");
    Expect(1, 68527, '\P{^Is_Scx=phlp}', "");
    Expect(0, 68528, '\p{Is_Scx=phlp}', "");
    Expect(1, 68528, '\p{^Is_Scx=phlp}', "");
    Expect(1, 68528, '\P{Is_Scx=phlp}', "");
    Expect(0, 68528, '\P{^Is_Scx=phlp}', "");
    Expect(1, 68527, '\p{Is_Scx=_-phlp}', "");
    Expect(0, 68527, '\p{^Is_Scx=_-phlp}', "");
    Expect(0, 68527, '\P{Is_Scx=_-phlp}', "");
    Expect(1, 68527, '\P{^Is_Scx=_-phlp}', "");
    Expect(0, 68528, '\p{Is_Scx=_-phlp}', "");
    Expect(1, 68528, '\p{^Is_Scx=_-phlp}', "");
    Expect(1, 68528, '\P{Is_Scx=_-phlp}', "");
    Expect(0, 68528, '\P{^Is_Scx=_-phlp}', "");
    Error('\p{Script_Extensions= -phoenician/a/}');
    Error('\P{Script_Extensions= -phoenician/a/}');
    Expect(1, 67871, '\p{Script_Extensions=:\APhoenician\z:}', "");;
    Expect(0, 67872, '\p{Script_Extensions=:\APhoenician\z:}', "");;
    Expect(1, 67871, '\p{Script_Extensions=phoenician}', "");
    Expect(0, 67871, '\p{^Script_Extensions=phoenician}', "");
    Expect(0, 67871, '\P{Script_Extensions=phoenician}', "");
    Expect(1, 67871, '\P{^Script_Extensions=phoenician}', "");
    Expect(0, 67872, '\p{Script_Extensions=phoenician}', "");
    Expect(1, 67872, '\p{^Script_Extensions=phoenician}', "");
    Expect(1, 67872, '\P{Script_Extensions=phoenician}', "");
    Expect(0, 67872, '\P{^Script_Extensions=phoenician}', "");
    Expect(1, 67871, '\p{Script_Extensions=:\Aphoenician\z:}', "");;
    Expect(0, 67872, '\p{Script_Extensions=:\Aphoenician\z:}', "");;
    Expect(1, 67871, '\p{Script_Extensions=__PHOENICIAN}', "");
    Expect(0, 67871, '\p{^Script_Extensions=__PHOENICIAN}', "");
    Expect(0, 67871, '\P{Script_Extensions=__PHOENICIAN}', "");
    Expect(1, 67871, '\P{^Script_Extensions=__PHOENICIAN}', "");
    Expect(0, 67872, '\p{Script_Extensions=__PHOENICIAN}', "");
    Expect(1, 67872, '\p{^Script_Extensions=__PHOENICIAN}', "");
    Expect(1, 67872, '\P{Script_Extensions=__PHOENICIAN}', "");
    Expect(0, 67872, '\P{^Script_Extensions=__PHOENICIAN}', "");
    Error('\p{Scx=		Phnx/a/}');
    Error('\P{Scx=		Phnx/a/}');
    Expect(1, 67871, '\p{Scx=:\APhnx\z:}', "");;
    Expect(0, 67872, '\p{Scx=:\APhnx\z:}', "");;
    Expect(1, 67871, '\p{Scx=phnx}', "");
    Expect(0, 67871, '\p{^Scx=phnx}', "");
    Expect(0, 67871, '\P{Scx=phnx}', "");
    Expect(1, 67871, '\P{^Scx=phnx}', "");
    Expect(0, 67872, '\p{Scx=phnx}', "");
    Expect(1, 67872, '\p{^Scx=phnx}', "");
    Expect(1, 67872, '\P{Scx=phnx}', "");
    Expect(0, 67872, '\P{^Scx=phnx}', "");
    Expect(1, 67871, '\p{Scx=:\Aphnx\z:}', "");;
    Expect(0, 67872, '\p{Scx=:\Aphnx\z:}', "");;
    Expect(1, 67871, '\p{Scx=	Phnx}', "");
    Expect(0, 67871, '\p{^Scx=	Phnx}', "");
    Expect(0, 67871, '\P{Scx=	Phnx}', "");
    Expect(1, 67871, '\P{^Scx=	Phnx}', "");
    Expect(0, 67872, '\p{Scx=	Phnx}', "");
    Expect(1, 67872, '\p{^Scx=	Phnx}', "");
    Expect(1, 67872, '\P{Scx=	Phnx}', "");
    Expect(0, 67872, '\P{^Scx=	Phnx}', "");
    Error('\p{Is_Script_Extensions=/a/	 PHOENICIAN}');
    Error('\P{Is_Script_Extensions=/a/	 PHOENICIAN}');
    Expect(1, 67871, '\p{Is_Script_Extensions=phoenician}', "");
    Expect(0, 67871, '\p{^Is_Script_Extensions=phoenician}', "");
    Expect(0, 67871, '\P{Is_Script_Extensions=phoenician}', "");
    Expect(1, 67871, '\P{^Is_Script_Extensions=phoenician}', "");
    Expect(0, 67872, '\p{Is_Script_Extensions=phoenician}', "");
    Expect(1, 67872, '\p{^Is_Script_Extensions=phoenician}', "");
    Expect(1, 67872, '\P{Is_Script_Extensions=phoenician}', "");
    Expect(0, 67872, '\P{^Is_Script_Extensions=phoenician}', "");
    Expect(1, 67871, '\p{Is_Script_Extensions=		phoenician}', "");
    Expect(0, 67871, '\p{^Is_Script_Extensions=		phoenician}', "");
    Expect(0, 67871, '\P{Is_Script_Extensions=		phoenician}', "");
    Expect(1, 67871, '\P{^Is_Script_Extensions=		phoenician}', "");
    Expect(0, 67872, '\p{Is_Script_Extensions=		phoenician}', "");
    Expect(1, 67872, '\p{^Is_Script_Extensions=		phoenician}', "");
    Expect(1, 67872, '\P{Is_Script_Extensions=		phoenician}', "");
    Expect(0, 67872, '\P{^Is_Script_Extensions=		phoenician}', "");
    Error('\p{Is_Scx= :=phnx}');
    Error('\P{Is_Scx= :=phnx}');
    Expect(1, 67871, '\p{Is_Scx=phnx}', "");
    Expect(0, 67871, '\p{^Is_Scx=phnx}', "");
    Expect(0, 67871, '\P{Is_Scx=phnx}', "");
    Expect(1, 67871, '\P{^Is_Scx=phnx}', "");
    Expect(0, 67872, '\p{Is_Scx=phnx}', "");
    Expect(1, 67872, '\p{^Is_Scx=phnx}', "");
    Expect(1, 67872, '\P{Is_Scx=phnx}', "");
    Expect(0, 67872, '\P{^Is_Scx=phnx}', "");
    Expect(1, 67871, '\p{Is_Scx= _phnx}', "");
    Expect(0, 67871, '\p{^Is_Scx= _phnx}', "");
    Expect(0, 67871, '\P{Is_Scx= _phnx}', "");
    Expect(1, 67871, '\P{^Is_Scx= _phnx}', "");
    Expect(0, 67872, '\p{Is_Scx= _phnx}', "");
    Expect(1, 67872, '\p{^Is_Scx= _phnx}', "");
    Expect(1, 67872, '\P{Is_Scx= _phnx}', "");
    Expect(0, 67872, '\P{^Is_Scx= _phnx}', "");
    Error('\p{Script_Extensions=_:=MIAO}');
    Error('\P{Script_Extensions=_:=MIAO}');
    Expect(1, 94111, '\p{Script_Extensions=:\AMiao\z:}', "");;
    Expect(0, 94112, '\p{Script_Extensions=:\AMiao\z:}', "");;
    Expect(1, 94111, '\p{Script_Extensions=miao}', "");
    Expect(0, 94111, '\p{^Script_Extensions=miao}', "");
    Expect(0, 94111, '\P{Script_Extensions=miao}', "");
    Expect(1, 94111, '\P{^Script_Extensions=miao}', "");
    Expect(0, 94112, '\p{Script_Extensions=miao}', "");
    Expect(1, 94112, '\p{^Script_Extensions=miao}', "");
    Expect(1, 94112, '\P{Script_Extensions=miao}', "");
    Expect(0, 94112, '\P{^Script_Extensions=miao}', "");
    Expect(1, 94111, '\p{Script_Extensions=:\Amiao\z:}', "");;
    Expect(0, 94112, '\p{Script_Extensions=:\Amiao\z:}', "");;
    Expect(1, 94111, '\p{Script_Extensions=_	miao}', "");
    Expect(0, 94111, '\p{^Script_Extensions=_	miao}', "");
    Expect(0, 94111, '\P{Script_Extensions=_	miao}', "");
    Expect(1, 94111, '\P{^Script_Extensions=_	miao}', "");
    Expect(0, 94112, '\p{Script_Extensions=_	miao}', "");
    Expect(1, 94112, '\p{^Script_Extensions=_	miao}', "");
    Expect(1, 94112, '\P{Script_Extensions=_	miao}', "");
    Expect(0, 94112, '\P{^Script_Extensions=_	miao}', "");
    Error('\p{Scx= -plrd:=}');
    Error('\P{Scx= -plrd:=}');
    Expect(1, 94111, '\p{Scx=:\APlrd\z:}', "");;
    Expect(0, 94112, '\p{Scx=:\APlrd\z:}', "");;
    Expect(1, 94111, '\p{Scx=plrd}', "");
    Expect(0, 94111, '\p{^Scx=plrd}', "");
    Expect(0, 94111, '\P{Scx=plrd}', "");
    Expect(1, 94111, '\P{^Scx=plrd}', "");
    Expect(0, 94112, '\p{Scx=plrd}', "");
    Expect(1, 94112, '\p{^Scx=plrd}', "");
    Expect(1, 94112, '\P{Scx=plrd}', "");
    Expect(0, 94112, '\P{^Scx=plrd}', "");
    Expect(1, 94111, '\p{Scx=:\Aplrd\z:}', "");;
    Expect(0, 94112, '\p{Scx=:\Aplrd\z:}', "");;
    Expect(1, 94111, '\p{Scx=_plrd}', "");
    Expect(0, 94111, '\p{^Scx=_plrd}', "");
    Expect(0, 94111, '\P{Scx=_plrd}', "");
    Expect(1, 94111, '\P{^Scx=_plrd}', "");
    Expect(0, 94112, '\p{Scx=_plrd}', "");
    Expect(1, 94112, '\p{^Scx=_plrd}', "");
    Expect(1, 94112, '\P{Scx=_plrd}', "");
    Expect(0, 94112, '\P{^Scx=_plrd}', "");
    Error('\p{Is_Script_Extensions= MIAO:=}');
    Error('\P{Is_Script_Extensions= MIAO:=}');
    Expect(1, 94111, '\p{Is_Script_Extensions=miao}', "");
    Expect(0, 94111, '\p{^Is_Script_Extensions=miao}', "");
    Expect(0, 94111, '\P{Is_Script_Extensions=miao}', "");
    Expect(1, 94111, '\P{^Is_Script_Extensions=miao}', "");
    Expect(0, 94112, '\p{Is_Script_Extensions=miao}', "");
    Expect(1, 94112, '\p{^Is_Script_Extensions=miao}', "");
    Expect(1, 94112, '\P{Is_Script_Extensions=miao}', "");
    Expect(0, 94112, '\P{^Is_Script_Extensions=miao}', "");
    Expect(1, 94111, '\p{Is_Script_Extensions= -miao}', "");
    Expect(0, 94111, '\p{^Is_Script_Extensions= -miao}', "");
    Expect(0, 94111, '\P{Is_Script_Extensions= -miao}', "");
    Expect(1, 94111, '\P{^Is_Script_Extensions= -miao}', "");
    Expect(0, 94112, '\p{Is_Script_Extensions= -miao}', "");
    Expect(1, 94112, '\p{^Is_Script_Extensions= -miao}', "");
    Expect(1, 94112, '\P{Is_Script_Extensions= -miao}', "");
    Expect(0, 94112, '\P{^Is_Script_Extensions= -miao}', "");
    Error('\p{Is_Scx:     plrd:=}');
    Error('\P{Is_Scx:     plrd:=}');
    Expect(1, 94111, '\p{Is_Scx:plrd}', "");
    Expect(0, 94111, '\p{^Is_Scx:plrd}', "");
    Expect(0, 94111, '\P{Is_Scx:plrd}', "");
    Expect(1, 94111, '\P{^Is_Scx:plrd}', "");
    Expect(0, 94112, '\p{Is_Scx:plrd}', "");
    Expect(1, 94112, '\p{^Is_Scx:plrd}', "");
    Expect(1, 94112, '\P{Is_Scx:plrd}', "");
    Expect(0, 94112, '\P{^Is_Scx:plrd}', "");
    Expect(1, 94111, '\p{Is_Scx=_	Plrd}', "");
    Expect(0, 94111, '\p{^Is_Scx=_	Plrd}', "");
    Expect(0, 94111, '\P{Is_Scx=_	Plrd}', "");
    Expect(1, 94111, '\P{^Is_Scx=_	Plrd}', "");
    Expect(0, 94112, '\p{Is_Scx=_	Plrd}', "");
    Expect(1, 94112, '\p{^Is_Scx=_	Plrd}', "");
    Expect(1, 94112, '\P{Is_Scx=_	Plrd}', "");
    Expect(0, 94112, '\P{^Is_Scx=_	Plrd}', "");
    Error('\p{Script_Extensions: /a/	_INSCRIPTIONAL_parthian}');
    Error('\P{Script_Extensions: /a/	_INSCRIPTIONAL_parthian}');
    Expect(1, 68447, '\p{Script_Extensions=:\AInscriptional_Parthian\z:}', "");;
    Expect(0, 68448, '\p{Script_Extensions=:\AInscriptional_Parthian\z:}', "");;
    Expect(1, 68447, '\p{Script_Extensions=inscriptionalparthian}', "");
    Expect(0, 68447, '\p{^Script_Extensions=inscriptionalparthian}', "");
    Expect(0, 68447, '\P{Script_Extensions=inscriptionalparthian}', "");
    Expect(1, 68447, '\P{^Script_Extensions=inscriptionalparthian}', "");
    Expect(0, 68448, '\p{Script_Extensions=inscriptionalparthian}', "");
    Expect(1, 68448, '\p{^Script_Extensions=inscriptionalparthian}', "");
    Expect(1, 68448, '\P{Script_Extensions=inscriptionalparthian}', "");
    Expect(0, 68448, '\P{^Script_Extensions=inscriptionalparthian}', "");
    Expect(1, 68447, '\p{Script_Extensions=:\Ainscriptionalparthian\z:}', "");;
    Expect(0, 68448, '\p{Script_Extensions=:\Ainscriptionalparthian\z:}', "");;
    Expect(1, 68447, '\p{Script_Extensions= _inscriptional_Parthian}', "");
    Expect(0, 68447, '\p{^Script_Extensions= _inscriptional_Parthian}', "");
    Expect(0, 68447, '\P{Script_Extensions= _inscriptional_Parthian}', "");
    Expect(1, 68447, '\P{^Script_Extensions= _inscriptional_Parthian}', "");
    Expect(0, 68448, '\p{Script_Extensions= _inscriptional_Parthian}', "");
    Expect(1, 68448, '\p{^Script_Extensions= _inscriptional_Parthian}', "");
    Expect(1, 68448, '\P{Script_Extensions= _inscriptional_Parthian}', "");
    Expect(0, 68448, '\P{^Script_Extensions= _inscriptional_Parthian}', "");
    Error('\p{Scx=	_PRTI/a/}');
    Error('\P{Scx=	_PRTI/a/}');
    Expect(1, 68447, '\p{Scx=:\APrti\z:}', "");;
    Expect(0, 68448, '\p{Scx=:\APrti\z:}', "");;
    Expect(1, 68447, '\p{Scx=prti}', "");
    Expect(0, 68447, '\p{^Scx=prti}', "");
    Expect(0, 68447, '\P{Scx=prti}', "");
    Expect(1, 68447, '\P{^Scx=prti}', "");
    Expect(0, 68448, '\p{Scx=prti}', "");
    Expect(1, 68448, '\p{^Scx=prti}', "");
    Expect(1, 68448, '\P{Scx=prti}', "");
    Expect(0, 68448, '\P{^Scx=prti}', "");
    Expect(1, 68447, '\p{Scx=:\Aprti\z:}', "");;
    Expect(0, 68448, '\p{Scx=:\Aprti\z:}', "");;
    Expect(1, 68447, '\p{Scx=Prti}', "");
    Expect(0, 68447, '\p{^Scx=Prti}', "");
    Expect(0, 68447, '\P{Scx=Prti}', "");
    Expect(1, 68447, '\P{^Scx=Prti}', "");
    Expect(0, 68448, '\p{Scx=Prti}', "");
    Expect(1, 68448, '\p{^Scx=Prti}', "");
    Expect(1, 68448, '\P{Scx=Prti}', "");
    Expect(0, 68448, '\P{^Scx=Prti}', "");
    Error('\p{Is_Script_Extensions=:=--Inscriptional_Parthian}');
    Error('\P{Is_Script_Extensions=:=--Inscriptional_Parthian}');
    Expect(1, 68447, '\p{Is_Script_Extensions=inscriptionalparthian}', "");
    Expect(0, 68447, '\p{^Is_Script_Extensions=inscriptionalparthian}', "");
    Expect(0, 68447, '\P{Is_Script_Extensions=inscriptionalparthian}', "");
    Expect(1, 68447, '\P{^Is_Script_Extensions=inscriptionalparthian}', "");
    Expect(0, 68448, '\p{Is_Script_Extensions=inscriptionalparthian}', "");
    Expect(1, 68448, '\p{^Is_Script_Extensions=inscriptionalparthian}', "");
    Expect(1, 68448, '\P{Is_Script_Extensions=inscriptionalparthian}', "");
    Expect(0, 68448, '\P{^Is_Script_Extensions=inscriptionalparthian}', "");
    Expect(1, 68447, '\p{Is_Script_Extensions=	-inscriptional_PARTHIAN}', "");
    Expect(0, 68447, '\p{^Is_Script_Extensions=	-inscriptional_PARTHIAN}', "");
    Expect(0, 68447, '\P{Is_Script_Extensions=	-inscriptional_PARTHIAN}', "");
    Expect(1, 68447, '\P{^Is_Script_Extensions=	-inscriptional_PARTHIAN}', "");
    Expect(0, 68448, '\p{Is_Script_Extensions=	-inscriptional_PARTHIAN}', "");
    Expect(1, 68448, '\p{^Is_Script_Extensions=	-inscriptional_PARTHIAN}', "");
    Expect(1, 68448, '\P{Is_Script_Extensions=	-inscriptional_PARTHIAN}', "");
    Expect(0, 68448, '\P{^Is_Script_Extensions=	-inscriptional_PARTHIAN}', "");
    Error('\p{Is_Scx=:=		PRTI}');
    Error('\P{Is_Scx=:=		PRTI}');
    Expect(1, 68447, '\p{Is_Scx=prti}', "");
    Expect(0, 68447, '\p{^Is_Scx=prti}', "");
    Expect(0, 68447, '\P{Is_Scx=prti}', "");
    Expect(1, 68447, '\P{^Is_Scx=prti}', "");
    Expect(0, 68448, '\p{Is_Scx=prti}', "");
    Expect(1, 68448, '\p{^Is_Scx=prti}', "");
    Expect(1, 68448, '\P{Is_Scx=prti}', "");
    Expect(0, 68448, '\P{^Is_Scx=prti}', "");
    Expect(1, 68447, '\p{Is_Scx=	_Prti}', "");
    Expect(0, 68447, '\p{^Is_Scx=	_Prti}', "");
    Expect(0, 68447, '\P{Is_Scx=	_Prti}', "");
    Expect(1, 68447, '\P{^Is_Scx=	_Prti}', "");
    Expect(0, 68448, '\p{Is_Scx=	_Prti}', "");
    Expect(1, 68448, '\p{^Is_Scx=	_Prti}', "");
    Expect(1, 68448, '\P{Is_Scx=	_Prti}', "");
    Expect(0, 68448, '\P{^Is_Scx=	_Prti}', "");
    Error('\p{Script_Extensions: :=rejang}');
    Error('\P{Script_Extensions: :=rejang}');
    Expect(1, 43359, '\p{Script_Extensions=:\ARejang\z:}', "");;
    Expect(0, 43360, '\p{Script_Extensions=:\ARejang\z:}', "");;
    Expect(1, 43359, '\p{Script_Extensions=rejang}', "");
    Expect(0, 43359, '\p{^Script_Extensions=rejang}', "");
    Expect(0, 43359, '\P{Script_Extensions=rejang}', "");
    Expect(1, 43359, '\P{^Script_Extensions=rejang}', "");
    Expect(0, 43360, '\p{Script_Extensions=rejang}', "");
    Expect(1, 43360, '\p{^Script_Extensions=rejang}', "");
    Expect(1, 43360, '\P{Script_Extensions=rejang}', "");
    Expect(0, 43360, '\P{^Script_Extensions=rejang}', "");
    Expect(1, 43359, '\p{Script_Extensions=:\Arejang\z:}', "");;
    Expect(0, 43360, '\p{Script_Extensions=:\Arejang\z:}', "");;
    Expect(1, 43359, '\p{Script_Extensions=_rejang}', "");
    Expect(0, 43359, '\p{^Script_Extensions=_rejang}', "");
    Expect(0, 43359, '\P{Script_Extensions=_rejang}', "");
    Expect(1, 43359, '\P{^Script_Extensions=_rejang}', "");
    Expect(0, 43360, '\p{Script_Extensions=_rejang}', "");
    Expect(1, 43360, '\p{^Script_Extensions=_rejang}', "");
    Expect(1, 43360, '\P{Script_Extensions=_rejang}', "");
    Expect(0, 43360, '\P{^Script_Extensions=_rejang}', "");
    Error('\p{Scx=-_Rjng:=}');
    Error('\P{Scx=-_Rjng:=}');
    Expect(1, 43359, '\p{Scx=:\ARjng\z:}', "");;
    Expect(0, 43360, '\p{Scx=:\ARjng\z:}', "");;
    Expect(1, 43359, '\p{Scx=rjng}', "");
    Expect(0, 43359, '\p{^Scx=rjng}', "");
    Expect(0, 43359, '\P{Scx=rjng}', "");
    Expect(1, 43359, '\P{^Scx=rjng}', "");
    Expect(0, 43360, '\p{Scx=rjng}', "");
    Expect(1, 43360, '\p{^Scx=rjng}', "");
    Expect(1, 43360, '\P{Scx=rjng}', "");
    Expect(0, 43360, '\P{^Scx=rjng}', "");
    Expect(1, 43359, '\p{Scx=:\Arjng\z:}', "");;
    Expect(0, 43360, '\p{Scx=:\Arjng\z:}', "");;
    Expect(1, 43359, '\p{Scx=	RJNG}', "");
    Expect(0, 43359, '\p{^Scx=	RJNG}', "");
    Expect(0, 43359, '\P{Scx=	RJNG}', "");
    Expect(1, 43359, '\P{^Scx=	RJNG}', "");
    Expect(0, 43360, '\p{Scx=	RJNG}', "");
    Expect(1, 43360, '\p{^Scx=	RJNG}', "");
    Expect(1, 43360, '\P{Scx=	RJNG}', "");
    Expect(0, 43360, '\P{^Scx=	RJNG}', "");
    Error('\p{Is_Script_Extensions: :=_rejang}');
    Error('\P{Is_Script_Extensions: :=_rejang}');
    Expect(1, 43359, '\p{Is_Script_Extensions=rejang}', "");
    Expect(0, 43359, '\p{^Is_Script_Extensions=rejang}', "");
    Expect(0, 43359, '\P{Is_Script_Extensions=rejang}', "");
    Expect(1, 43359, '\P{^Is_Script_Extensions=rejang}', "");
    Expect(0, 43360, '\p{Is_Script_Extensions=rejang}', "");
    Expect(1, 43360, '\p{^Is_Script_Extensions=rejang}', "");
    Expect(1, 43360, '\P{Is_Script_Extensions=rejang}', "");
    Expect(0, 43360, '\P{^Is_Script_Extensions=rejang}', "");
    Expect(1, 43359, '\p{Is_Script_Extensions=_REJANG}', "");
    Expect(0, 43359, '\p{^Is_Script_Extensions=_REJANG}', "");
    Expect(0, 43359, '\P{Is_Script_Extensions=_REJANG}', "");
    Expect(1, 43359, '\P{^Is_Script_Extensions=_REJANG}', "");
    Expect(0, 43360, '\p{Is_Script_Extensions=_REJANG}', "");
    Expect(1, 43360, '\p{^Is_Script_Extensions=_REJANG}', "");
    Expect(1, 43360, '\P{Is_Script_Extensions=_REJANG}', "");
    Expect(0, 43360, '\P{^Is_Script_Extensions=_REJANG}', "");
    Error('\p{Is_Scx=/a/ Rjng}');
    Error('\P{Is_Scx=/a/ Rjng}');
    Expect(1, 43359, '\p{Is_Scx=rjng}', "");
    Expect(0, 43359, '\p{^Is_Scx=rjng}', "");
    Expect(0, 43359, '\P{Is_Scx=rjng}', "");
    Expect(1, 43359, '\P{^Is_Scx=rjng}', "");
    Expect(0, 43360, '\p{Is_Scx=rjng}', "");
    Expect(1, 43360, '\p{^Is_Scx=rjng}', "");
    Expect(1, 43360, '\P{Is_Scx=rjng}', "");
    Expect(0, 43360, '\P{^Is_Scx=rjng}', "");
    Expect(1, 43359, '\p{Is_Scx=Rjng}', "");
    Expect(0, 43359, '\p{^Is_Scx=Rjng}', "");
    Expect(0, 43359, '\P{Is_Scx=Rjng}', "");
    Expect(1, 43359, '\P{^Is_Scx=Rjng}', "");
    Expect(0, 43360, '\p{Is_Scx=Rjng}', "");
    Expect(1, 43360, '\p{^Is_Scx=Rjng}', "");
    Expect(1, 43360, '\P{Is_Scx=Rjng}', "");
    Expect(0, 43360, '\P{^Is_Scx=Rjng}', "");
    Error('\p{Script_Extensions=-/a/hanifi_ROHINGYA}');
    Error('\P{Script_Extensions=-/a/hanifi_ROHINGYA}');
    Expect(1, 68921, '\p{Script_Extensions=:\AHanifi_Rohingya\z:}', "");;
    Expect(0, 68922, '\p{Script_Extensions=:\AHanifi_Rohingya\z:}', "");;
    Expect(1, 68921, '\p{Script_Extensions=hanifirohingya}', "");
    Expect(0, 68921, '\p{^Script_Extensions=hanifirohingya}', "");
    Expect(0, 68921, '\P{Script_Extensions=hanifirohingya}', "");
    Expect(1, 68921, '\P{^Script_Extensions=hanifirohingya}', "");
    Expect(0, 68922, '\p{Script_Extensions=hanifirohingya}', "");
    Expect(1, 68922, '\p{^Script_Extensions=hanifirohingya}', "");
    Expect(1, 68922, '\P{Script_Extensions=hanifirohingya}', "");
    Expect(0, 68922, '\P{^Script_Extensions=hanifirohingya}', "");
    Expect(1, 68921, '\p{Script_Extensions=:\Ahanifirohingya\z:}', "");;
    Expect(0, 68922, '\p{Script_Extensions=:\Ahanifirohingya\z:}', "");;
    Expect(1, 68921, '\p{Script_Extensions:     hanifi_ROHINGYA}', "");
    Expect(0, 68921, '\p{^Script_Extensions:     hanifi_ROHINGYA}', "");
    Expect(0, 68921, '\P{Script_Extensions:     hanifi_ROHINGYA}', "");
    Expect(1, 68921, '\P{^Script_Extensions:     hanifi_ROHINGYA}', "");
    Expect(0, 68922, '\p{Script_Extensions:     hanifi_ROHINGYA}', "");
    Expect(1, 68922, '\p{^Script_Extensions:     hanifi_ROHINGYA}', "");
    Expect(1, 68922, '\P{Script_Extensions:     hanifi_ROHINGYA}', "");
    Expect(0, 68922, '\P{^Script_Extensions:     hanifi_ROHINGYA}', "");
    Error('\p{Scx=:=  Rohg}');
    Error('\P{Scx=:=  Rohg}');
    Expect(1, 68921, '\p{Scx=:\ARohg\z:}', "");;
    Expect(0, 68922, '\p{Scx=:\ARohg\z:}', "");;
    Expect(1, 68921, '\p{Scx=rohg}', "");
    Expect(0, 68921, '\p{^Scx=rohg}', "");
    Expect(0, 68921, '\P{Scx=rohg}', "");
    Expect(1, 68921, '\P{^Scx=rohg}', "");
    Expect(0, 68922, '\p{Scx=rohg}', "");
    Expect(1, 68922, '\p{^Scx=rohg}', "");
    Expect(1, 68922, '\P{Scx=rohg}', "");
    Expect(0, 68922, '\P{^Scx=rohg}', "");
    Expect(1, 68921, '\p{Scx=:\Arohg\z:}', "");;
    Expect(0, 68922, '\p{Scx=:\Arohg\z:}', "");;
    Expect(1, 68921, '\p{Scx=	Rohg}', "");
    Expect(0, 68921, '\p{^Scx=	Rohg}', "");
    Expect(0, 68921, '\P{Scx=	Rohg}', "");
    Expect(1, 68921, '\P{^Scx=	Rohg}', "");
    Expect(0, 68922, '\p{Scx=	Rohg}', "");
    Expect(1, 68922, '\p{^Scx=	Rohg}', "");
    Expect(1, 68922, '\P{Scx=	Rohg}', "");
    Expect(0, 68922, '\P{^Scx=	Rohg}', "");
    Error('\p{Is_Script_Extensions=/a/_Hanifi_rohingya}');
    Error('\P{Is_Script_Extensions=/a/_Hanifi_rohingya}');
    Expect(1, 68921, '\p{Is_Script_Extensions=hanifirohingya}', "");
    Expect(0, 68921, '\p{^Is_Script_Extensions=hanifirohingya}', "");
    Expect(0, 68921, '\P{Is_Script_Extensions=hanifirohingya}', "");
    Expect(1, 68921, '\P{^Is_Script_Extensions=hanifirohingya}', "");
    Expect(0, 68922, '\p{Is_Script_Extensions=hanifirohingya}', "");
    Expect(1, 68922, '\p{^Is_Script_Extensions=hanifirohingya}', "");
    Expect(1, 68922, '\P{Is_Script_Extensions=hanifirohingya}', "");
    Expect(0, 68922, '\P{^Is_Script_Extensions=hanifirohingya}', "");
    Expect(1, 68921, '\p{Is_Script_Extensions=_	Hanifi_ROHINGYA}', "");
    Expect(0, 68921, '\p{^Is_Script_Extensions=_	Hanifi_ROHINGYA}', "");
    Expect(0, 68921, '\P{Is_Script_Extensions=_	Hanifi_ROHINGYA}', "");
    Expect(1, 68921, '\P{^Is_Script_Extensions=_	Hanifi_ROHINGYA}', "");
    Expect(0, 68922, '\p{Is_Script_Extensions=_	Hanifi_ROHINGYA}', "");
    Expect(1, 68922, '\p{^Is_Script_Extensions=_	Hanifi_ROHINGYA}', "");
    Expect(1, 68922, '\P{Is_Script_Extensions=_	Hanifi_ROHINGYA}', "");
    Expect(0, 68922, '\P{^Is_Script_Extensions=_	Hanifi_ROHINGYA}', "");
    Error('\p{Is_Scx=-_Rohg/a/}');
    Error('\P{Is_Scx=-_Rohg/a/}');
    Expect(1, 68921, '\p{Is_Scx=rohg}', "");
    Expect(0, 68921, '\p{^Is_Scx=rohg}', "");
    Expect(0, 68921, '\P{Is_Scx=rohg}', "");
    Expect(1, 68921, '\P{^Is_Scx=rohg}', "");
    Expect(0, 68922, '\p{Is_Scx=rohg}', "");
    Expect(1, 68922, '\p{^Is_Scx=rohg}', "");
    Expect(1, 68922, '\P{Is_Scx=rohg}', "");
    Expect(0, 68922, '\P{^Is_Scx=rohg}', "");
    Expect(1, 68921, '\p{Is_Scx=_	ROHG}', "");
    Expect(0, 68921, '\p{^Is_Scx=_	ROHG}', "");
    Expect(0, 68921, '\P{Is_Scx=_	ROHG}', "");
    Expect(1, 68921, '\P{^Is_Scx=_	ROHG}', "");
    Expect(0, 68922, '\p{Is_Scx=_	ROHG}', "");
    Expect(1, 68922, '\p{^Is_Scx=_	ROHG}', "");
    Expect(1, 68922, '\P{Is_Scx=_	ROHG}', "");
    Expect(0, 68922, '\P{^Is_Scx=_	ROHG}', "");
    Error('\p{Script_Extensions:_/a/runic}');
    Error('\P{Script_Extensions:_/a/runic}');
    Expect(1, 5880, '\p{Script_Extensions=:\ARunic\z:}', "");;
    Expect(0, 5881, '\p{Script_Extensions=:\ARunic\z:}', "");;
    Expect(1, 5880, '\p{Script_Extensions=runic}', "");
    Expect(0, 5880, '\p{^Script_Extensions=runic}', "");
    Expect(0, 5880, '\P{Script_Extensions=runic}', "");
    Expect(1, 5880, '\P{^Script_Extensions=runic}', "");
    Expect(0, 5881, '\p{Script_Extensions=runic}', "");
    Expect(1, 5881, '\p{^Script_Extensions=runic}', "");
    Expect(1, 5881, '\P{Script_Extensions=runic}', "");
    Expect(0, 5881, '\P{^Script_Extensions=runic}', "");
    Expect(1, 5880, '\p{Script_Extensions=:\Arunic\z:}', "");;
    Expect(0, 5881, '\p{Script_Extensions=:\Arunic\z:}', "");;
    Expect(1, 5880, '\p{Script_Extensions=_RUNIC}', "");
    Expect(0, 5880, '\p{^Script_Extensions=_RUNIC}', "");
    Expect(0, 5880, '\P{Script_Extensions=_RUNIC}', "");
    Expect(1, 5880, '\P{^Script_Extensions=_RUNIC}', "");
    Expect(0, 5881, '\p{Script_Extensions=_RUNIC}', "");
    Expect(1, 5881, '\p{^Script_Extensions=_RUNIC}', "");
    Expect(1, 5881, '\P{Script_Extensions=_RUNIC}', "");
    Expect(0, 5881, '\P{^Script_Extensions=_RUNIC}', "");
    Error('\p{Scx=-:=Runr}');
    Error('\P{Scx=-:=Runr}');
    Expect(1, 5880, '\p{Scx=:\ARunr\z:}', "");;
    Expect(0, 5881, '\p{Scx=:\ARunr\z:}', "");;
    Expect(1, 5880, '\p{Scx=runr}', "");
    Expect(0, 5880, '\p{^Scx=runr}', "");
    Expect(0, 5880, '\P{Scx=runr}', "");
    Expect(1, 5880, '\P{^Scx=runr}', "");
    Expect(0, 5881, '\p{Scx=runr}', "");
    Expect(1, 5881, '\p{^Scx=runr}', "");
    Expect(1, 5881, '\P{Scx=runr}', "");
    Expect(0, 5881, '\P{^Scx=runr}', "");
    Expect(1, 5880, '\p{Scx=:\Arunr\z:}', "");;
    Expect(0, 5881, '\p{Scx=:\Arunr\z:}', "");;
    Expect(1, 5880, '\p{Scx=_runr}', "");
    Expect(0, 5880, '\p{^Scx=_runr}', "");
    Expect(0, 5880, '\P{Scx=_runr}', "");
    Expect(1, 5880, '\P{^Scx=_runr}', "");
    Expect(0, 5881, '\p{Scx=_runr}', "");
    Expect(1, 5881, '\p{^Scx=_runr}', "");
    Expect(1, 5881, '\P{Scx=_runr}', "");
    Expect(0, 5881, '\P{^Scx=_runr}', "");
    Error('\p{Is_Script_Extensions=:=runic}');
    Error('\P{Is_Script_Extensions=:=runic}');
    Expect(1, 5880, '\p{Is_Script_Extensions=runic}', "");
    Expect(0, 5880, '\p{^Is_Script_Extensions=runic}', "");
    Expect(0, 5880, '\P{Is_Script_Extensions=runic}', "");
    Expect(1, 5880, '\P{^Is_Script_Extensions=runic}', "");
    Expect(0, 5881, '\p{Is_Script_Extensions=runic}', "");
    Expect(1, 5881, '\p{^Is_Script_Extensions=runic}', "");
    Expect(1, 5881, '\P{Is_Script_Extensions=runic}', "");
    Expect(0, 5881, '\P{^Is_Script_Extensions=runic}', "");
    Expect(1, 5880, '\p{Is_Script_Extensions= 	runic}', "");
    Expect(0, 5880, '\p{^Is_Script_Extensions= 	runic}', "");
    Expect(0, 5880, '\P{Is_Script_Extensions= 	runic}', "");
    Expect(1, 5880, '\P{^Is_Script_Extensions= 	runic}', "");
    Expect(0, 5881, '\p{Is_Script_Extensions= 	runic}', "");
    Expect(1, 5881, '\p{^Is_Script_Extensions= 	runic}', "");
    Expect(1, 5881, '\P{Is_Script_Extensions= 	runic}', "");
    Expect(0, 5881, '\P{^Is_Script_Extensions= 	runic}', "");
    Error('\p{Is_Scx= /a/Runr}');
    Error('\P{Is_Scx= /a/Runr}');
    Expect(1, 5880, '\p{Is_Scx:	runr}', "");
    Expect(0, 5880, '\p{^Is_Scx:	runr}', "");
    Expect(0, 5880, '\P{Is_Scx:	runr}', "");
    Expect(1, 5880, '\P{^Is_Scx:	runr}', "");
    Expect(0, 5881, '\p{Is_Scx:	runr}', "");
    Expect(1, 5881, '\p{^Is_Scx:	runr}', "");
    Expect(1, 5881, '\P{Is_Scx:	runr}', "");
    Expect(0, 5881, '\P{^Is_Scx:	runr}', "");
    Expect(1, 5880, '\p{Is_Scx=_RUNR}', "");
    Expect(0, 5880, '\p{^Is_Scx=_RUNR}', "");
    Expect(0, 5880, '\P{Is_Scx=_RUNR}', "");
    Expect(1, 5880, '\P{^Is_Scx=_RUNR}', "");
    Expect(0, 5881, '\p{Is_Scx=_RUNR}', "");
    Expect(1, 5881, '\p{^Is_Scx=_RUNR}', "");
    Expect(1, 5881, '\P{Is_Scx=_RUNR}', "");
    Expect(0, 5881, '\P{^Is_Scx=_RUNR}', "");
    Error('\p{Script_Extensions=	-Samaritan/a/}');
    Error('\P{Script_Extensions=	-Samaritan/a/}');
    Expect(1, 2110, '\p{Script_Extensions=:\ASamaritan\z:}', "");;
    Expect(0, 2111, '\p{Script_Extensions=:\ASamaritan\z:}', "");;
    Expect(1, 2110, '\p{Script_Extensions=samaritan}', "");
    Expect(0, 2110, '\p{^Script_Extensions=samaritan}', "");
    Expect(0, 2110, '\P{Script_Extensions=samaritan}', "");
    Expect(1, 2110, '\P{^Script_Extensions=samaritan}', "");
    Expect(0, 2111, '\p{Script_Extensions=samaritan}', "");
    Expect(1, 2111, '\p{^Script_Extensions=samaritan}', "");
    Expect(1, 2111, '\P{Script_Extensions=samaritan}', "");
    Expect(0, 2111, '\P{^Script_Extensions=samaritan}', "");
    Expect(1, 2110, '\p{Script_Extensions=:\Asamaritan\z:}', "");;
    Expect(0, 2111, '\p{Script_Extensions=:\Asamaritan\z:}', "");;
    Expect(1, 2110, '\p{Script_Extensions=--Samaritan}', "");
    Expect(0, 2110, '\p{^Script_Extensions=--Samaritan}', "");
    Expect(0, 2110, '\P{Script_Extensions=--Samaritan}', "");
    Expect(1, 2110, '\P{^Script_Extensions=--Samaritan}', "");
    Expect(0, 2111, '\p{Script_Extensions=--Samaritan}', "");
    Expect(1, 2111, '\p{^Script_Extensions=--Samaritan}', "");
    Expect(1, 2111, '\P{Script_Extensions=--Samaritan}', "");
    Expect(0, 2111, '\P{^Script_Extensions=--Samaritan}', "");
    Error('\p{Scx=/a/-_SAMR}');
    Error('\P{Scx=/a/-_SAMR}');
    Expect(1, 2110, '\p{Scx=:\ASamr\z:}', "");;
    Expect(0, 2111, '\p{Scx=:\ASamr\z:}', "");;
    Expect(1, 2110, '\p{Scx:	samr}', "");
    Expect(0, 2110, '\p{^Scx:	samr}', "");
    Expect(0, 2110, '\P{Scx:	samr}', "");
    Expect(1, 2110, '\P{^Scx:	samr}', "");
    Expect(0, 2111, '\p{Scx:	samr}', "");
    Expect(1, 2111, '\p{^Scx:	samr}', "");
    Expect(1, 2111, '\P{Scx:	samr}', "");
    Expect(0, 2111, '\P{^Scx:	samr}', "");
    Expect(1, 2110, '\p{Scx=:\Asamr\z:}', "");;
    Expect(0, 2111, '\p{Scx=:\Asamr\z:}', "");;
    Expect(1, 2110, '\p{Scx=__Samr}', "");
    Expect(0, 2110, '\p{^Scx=__Samr}', "");
    Expect(0, 2110, '\P{Scx=__Samr}', "");
    Expect(1, 2110, '\P{^Scx=__Samr}', "");
    Expect(0, 2111, '\p{Scx=__Samr}', "");
    Expect(1, 2111, '\p{^Scx=__Samr}', "");
    Expect(1, 2111, '\P{Scx=__Samr}', "");
    Expect(0, 2111, '\P{^Scx=__Samr}', "");
    Error('\p{Is_Script_Extensions=/a/	-samaritan}');
    Error('\P{Is_Script_Extensions=/a/	-samaritan}');
    Expect(1, 2110, '\p{Is_Script_Extensions=samaritan}', "");
    Expect(0, 2110, '\p{^Is_Script_Extensions=samaritan}', "");
    Expect(0, 2110, '\P{Is_Script_Extensions=samaritan}', "");
    Expect(1, 2110, '\P{^Is_Script_Extensions=samaritan}', "");
    Expect(0, 2111, '\p{Is_Script_Extensions=samaritan}', "");
    Expect(1, 2111, '\p{^Is_Script_Extensions=samaritan}', "");
    Expect(1, 2111, '\P{Is_Script_Extensions=samaritan}', "");
    Expect(0, 2111, '\P{^Is_Script_Extensions=samaritan}', "");
    Expect(1, 2110, '\p{Is_Script_Extensions= samaritan}', "");
    Expect(0, 2110, '\p{^Is_Script_Extensions= samaritan}', "");
    Expect(0, 2110, '\P{Is_Script_Extensions= samaritan}', "");
    Expect(1, 2110, '\P{^Is_Script_Extensions= samaritan}', "");
    Expect(0, 2111, '\p{Is_Script_Extensions= samaritan}', "");
    Expect(1, 2111, '\p{^Is_Script_Extensions= samaritan}', "");
    Expect(1, 2111, '\P{Is_Script_Extensions= samaritan}', "");
    Expect(0, 2111, '\P{^Is_Script_Extensions= samaritan}', "");
    Error('\p{Is_Scx=-:=SAMR}');
    Error('\P{Is_Scx=-:=SAMR}');
    Expect(1, 2110, '\p{Is_Scx=samr}', "");
    Expect(0, 2110, '\p{^Is_Scx=samr}', "");
    Expect(0, 2110, '\P{Is_Scx=samr}', "");
    Expect(1, 2110, '\P{^Is_Scx=samr}', "");
    Expect(0, 2111, '\p{Is_Scx=samr}', "");
    Expect(1, 2111, '\p{^Is_Scx=samr}', "");
    Expect(1, 2111, '\P{Is_Scx=samr}', "");
    Expect(0, 2111, '\P{^Is_Scx=samr}', "");
    Expect(1, 2110, '\p{Is_Scx= -Samr}', "");
    Expect(0, 2110, '\p{^Is_Scx= -Samr}', "");
    Expect(0, 2110, '\P{Is_Scx= -Samr}', "");
    Expect(1, 2110, '\P{^Is_Scx= -Samr}', "");
    Expect(0, 2111, '\p{Is_Scx= -Samr}', "");
    Expect(1, 2111, '\p{^Is_Scx= -Samr}', "");
    Expect(1, 2111, '\P{Is_Scx= -Samr}', "");
    Expect(0, 2111, '\P{^Is_Scx= -Samr}', "");
    Error('\p{Script_Extensions= _old_SOUTH_Arabian:=}');
    Error('\P{Script_Extensions= _old_SOUTH_Arabian:=}');
    Expect(1, 68223, '\p{Script_Extensions=:\AOld_South_Arabian\z:}', "");;
    Expect(0, 68224, '\p{Script_Extensions=:\AOld_South_Arabian\z:}', "");;
    Expect(1, 68223, '\p{Script_Extensions=oldsoutharabian}', "");
    Expect(0, 68223, '\p{^Script_Extensions=oldsoutharabian}', "");
    Expect(0, 68223, '\P{Script_Extensions=oldsoutharabian}', "");
    Expect(1, 68223, '\P{^Script_Extensions=oldsoutharabian}', "");
    Expect(0, 68224, '\p{Script_Extensions=oldsoutharabian}', "");
    Expect(1, 68224, '\p{^Script_Extensions=oldsoutharabian}', "");
    Expect(1, 68224, '\P{Script_Extensions=oldsoutharabian}', "");
    Expect(0, 68224, '\P{^Script_Extensions=oldsoutharabian}', "");
    Expect(1, 68223, '\p{Script_Extensions=:\Aoldsoutharabian\z:}', "");;
    Expect(0, 68224, '\p{Script_Extensions=:\Aoldsoutharabian\z:}', "");;
    Expect(1, 68223, '\p{Script_Extensions=-	Old_South_Arabian}', "");
    Expect(0, 68223, '\p{^Script_Extensions=-	Old_South_Arabian}', "");
    Expect(0, 68223, '\P{Script_Extensions=-	Old_South_Arabian}', "");
    Expect(1, 68223, '\P{^Script_Extensions=-	Old_South_Arabian}', "");
    Expect(0, 68224, '\p{Script_Extensions=-	Old_South_Arabian}', "");
    Expect(1, 68224, '\p{^Script_Extensions=-	Old_South_Arabian}', "");
    Expect(1, 68224, '\P{Script_Extensions=-	Old_South_Arabian}', "");
    Expect(0, 68224, '\P{^Script_Extensions=-	Old_South_Arabian}', "");
    Error('\p{Scx:   :=	-SARB}');
    Error('\P{Scx:   :=	-SARB}');
    Expect(1, 68223, '\p{Scx=:\ASarb\z:}', "");;
    Expect(0, 68224, '\p{Scx=:\ASarb\z:}', "");;
    Expect(1, 68223, '\p{Scx=sarb}', "");
    Expect(0, 68223, '\p{^Scx=sarb}', "");
    Expect(0, 68223, '\P{Scx=sarb}', "");
    Expect(1, 68223, '\P{^Scx=sarb}', "");
    Expect(0, 68224, '\p{Scx=sarb}', "");
    Expect(1, 68224, '\p{^Scx=sarb}', "");
    Expect(1, 68224, '\P{Scx=sarb}', "");
    Expect(0, 68224, '\P{^Scx=sarb}', "");
    Expect(1, 68223, '\p{Scx=:\Asarb\z:}', "");;
    Expect(0, 68224, '\p{Scx=:\Asarb\z:}', "");;
    Expect(1, 68223, '\p{Scx=	 SARB}', "");
    Expect(0, 68223, '\p{^Scx=	 SARB}', "");
    Expect(0, 68223, '\P{Scx=	 SARB}', "");
    Expect(1, 68223, '\P{^Scx=	 SARB}', "");
    Expect(0, 68224, '\p{Scx=	 SARB}', "");
    Expect(1, 68224, '\p{^Scx=	 SARB}', "");
    Expect(1, 68224, '\P{Scx=	 SARB}', "");
    Expect(0, 68224, '\P{^Scx=	 SARB}', "");
    Error('\p{Is_Script_Extensions=:=  Old_South_ARABIAN}');
    Error('\P{Is_Script_Extensions=:=  Old_South_ARABIAN}');
    Expect(1, 68223, '\p{Is_Script_Extensions=oldsoutharabian}', "");
    Expect(0, 68223, '\p{^Is_Script_Extensions=oldsoutharabian}', "");
    Expect(0, 68223, '\P{Is_Script_Extensions=oldsoutharabian}', "");
    Expect(1, 68223, '\P{^Is_Script_Extensions=oldsoutharabian}', "");
    Expect(0, 68224, '\p{Is_Script_Extensions=oldsoutharabian}', "");
    Expect(1, 68224, '\p{^Is_Script_Extensions=oldsoutharabian}', "");
    Expect(1, 68224, '\P{Is_Script_Extensions=oldsoutharabian}', "");
    Expect(0, 68224, '\P{^Is_Script_Extensions=oldsoutharabian}', "");
    Expect(1, 68223, '\p{Is_Script_Extensions=	Old_SOUTH_arabian}', "");
    Expect(0, 68223, '\p{^Is_Script_Extensions=	Old_SOUTH_arabian}', "");
    Expect(0, 68223, '\P{Is_Script_Extensions=	Old_SOUTH_arabian}', "");
    Expect(1, 68223, '\P{^Is_Script_Extensions=	Old_SOUTH_arabian}', "");
    Expect(0, 68224, '\p{Is_Script_Extensions=	Old_SOUTH_arabian}', "");
    Expect(1, 68224, '\p{^Is_Script_Extensions=	Old_SOUTH_arabian}', "");
    Expect(1, 68224, '\P{Is_Script_Extensions=	Old_SOUTH_arabian}', "");
    Expect(0, 68224, '\P{^Is_Script_Extensions=	Old_SOUTH_arabian}', "");
    Error('\p{Is_Scx=_sarb:=}');
    Error('\P{Is_Scx=_sarb:=}');
    Expect(1, 68223, '\p{Is_Scx=sarb}', "");
    Expect(0, 68223, '\p{^Is_Scx=sarb}', "");
    Expect(0, 68223, '\P{Is_Scx=sarb}', "");
    Expect(1, 68223, '\P{^Is_Scx=sarb}', "");
    Expect(0, 68224, '\p{Is_Scx=sarb}', "");
    Expect(1, 68224, '\p{^Is_Scx=sarb}', "");
    Expect(1, 68224, '\P{Is_Scx=sarb}', "");
    Expect(0, 68224, '\P{^Is_Scx=sarb}', "");
    Expect(1, 68223, '\p{Is_Scx: 	SARB}', "");
    Expect(0, 68223, '\p{^Is_Scx: 	SARB}', "");
    Expect(0, 68223, '\P{Is_Scx: 	SARB}', "");
    Expect(1, 68223, '\P{^Is_Scx: 	SARB}', "");
    Expect(0, 68224, '\p{Is_Scx: 	SARB}', "");
    Expect(1, 68224, '\p{^Is_Scx: 	SARB}', "");
    Expect(1, 68224, '\P{Is_Scx: 	SARB}', "");
    Expect(0, 68224, '\P{^Is_Scx: 	SARB}', "");
    Error('\p{Script_Extensions=:=--saurashtra}');
    Error('\P{Script_Extensions=:=--saurashtra}');
    Expect(1, 43225, '\p{Script_Extensions=:\ASaurashtra\z:}', "");;
    Expect(0, 43226, '\p{Script_Extensions=:\ASaurashtra\z:}', "");;
    Expect(1, 43225, '\p{Script_Extensions=saurashtra}', "");
    Expect(0, 43225, '\p{^Script_Extensions=saurashtra}', "");
    Expect(0, 43225, '\P{Script_Extensions=saurashtra}', "");
    Expect(1, 43225, '\P{^Script_Extensions=saurashtra}', "");
    Expect(0, 43226, '\p{Script_Extensions=saurashtra}', "");
    Expect(1, 43226, '\p{^Script_Extensions=saurashtra}', "");
    Expect(1, 43226, '\P{Script_Extensions=saurashtra}', "");
    Expect(0, 43226, '\P{^Script_Extensions=saurashtra}', "");
    Expect(1, 43225, '\p{Script_Extensions=:\Asaurashtra\z:}', "");;
    Expect(0, 43226, '\p{Script_Extensions=:\Asaurashtra\z:}', "");;
    Expect(1, 43225, '\p{Script_Extensions= 	Saurashtra}', "");
    Expect(0, 43225, '\p{^Script_Extensions= 	Saurashtra}', "");
    Expect(0, 43225, '\P{Script_Extensions= 	Saurashtra}', "");
    Expect(1, 43225, '\P{^Script_Extensions= 	Saurashtra}', "");
    Expect(0, 43226, '\p{Script_Extensions= 	Saurashtra}', "");
    Expect(1, 43226, '\p{^Script_Extensions= 	Saurashtra}', "");
    Expect(1, 43226, '\P{Script_Extensions= 	Saurashtra}', "");
    Expect(0, 43226, '\P{^Script_Extensions= 	Saurashtra}', "");
    Error('\p{Scx=:=SAUR}');
    Error('\P{Scx=:=SAUR}');
    Expect(1, 43225, '\p{Scx=:\ASaur\z:}', "");;
    Expect(0, 43226, '\p{Scx=:\ASaur\z:}', "");;
    Expect(1, 43225, '\p{Scx=saur}', "");
    Expect(0, 43225, '\p{^Scx=saur}', "");
    Expect(0, 43225, '\P{Scx=saur}', "");
    Expect(1, 43225, '\P{^Scx=saur}', "");
    Expect(0, 43226, '\p{Scx=saur}', "");
    Expect(1, 43226, '\p{^Scx=saur}', "");
    Expect(1, 43226, '\P{Scx=saur}', "");
    Expect(0, 43226, '\P{^Scx=saur}', "");
    Expect(1, 43225, '\p{Scx=:\Asaur\z:}', "");;
    Expect(0, 43226, '\p{Scx=:\Asaur\z:}', "");;
    Expect(1, 43225, '\p{Scx=-saur}', "");
    Expect(0, 43225, '\p{^Scx=-saur}', "");
    Expect(0, 43225, '\P{Scx=-saur}', "");
    Expect(1, 43225, '\P{^Scx=-saur}', "");
    Expect(0, 43226, '\p{Scx=-saur}', "");
    Expect(1, 43226, '\p{^Scx=-saur}', "");
    Expect(1, 43226, '\P{Scx=-saur}', "");
    Expect(0, 43226, '\P{^Scx=-saur}', "");
    Error('\p{Is_Script_Extensions=/a/	Saurashtra}');
    Error('\P{Is_Script_Extensions=/a/	Saurashtra}');
    Expect(1, 43225, '\p{Is_Script_Extensions=saurashtra}', "");
    Expect(0, 43225, '\p{^Is_Script_Extensions=saurashtra}', "");
    Expect(0, 43225, '\P{Is_Script_Extensions=saurashtra}', "");
    Expect(1, 43225, '\P{^Is_Script_Extensions=saurashtra}', "");
    Expect(0, 43226, '\p{Is_Script_Extensions=saurashtra}', "");
    Expect(1, 43226, '\p{^Is_Script_Extensions=saurashtra}', "");
    Expect(1, 43226, '\P{Is_Script_Extensions=saurashtra}', "");
    Expect(0, 43226, '\P{^Is_Script_Extensions=saurashtra}', "");
    Expect(1, 43225, '\p{Is_Script_Extensions=		SAURASHTRA}', "");
    Expect(0, 43225, '\p{^Is_Script_Extensions=		SAURASHTRA}', "");
    Expect(0, 43225, '\P{Is_Script_Extensions=		SAURASHTRA}', "");
    Expect(1, 43225, '\P{^Is_Script_Extensions=		SAURASHTRA}', "");
    Expect(0, 43226, '\p{Is_Script_Extensions=		SAURASHTRA}', "");
    Expect(1, 43226, '\p{^Is_Script_Extensions=		SAURASHTRA}', "");
    Expect(1, 43226, '\P{Is_Script_Extensions=		SAURASHTRA}', "");
    Expect(0, 43226, '\P{^Is_Script_Extensions=		SAURASHTRA}', "");
    Error('\p{Is_Scx=	SAUR:=}');
    Error('\P{Is_Scx=	SAUR:=}');
    Expect(1, 43225, '\p{Is_Scx=saur}', "");
    Expect(0, 43225, '\p{^Is_Scx=saur}', "");
    Expect(0, 43225, '\P{Is_Scx=saur}', "");
    Expect(1, 43225, '\P{^Is_Scx=saur}', "");
    Expect(0, 43226, '\p{Is_Scx=saur}', "");
    Expect(1, 43226, '\p{^Is_Scx=saur}', "");
    Expect(1, 43226, '\P{Is_Scx=saur}', "");
    Expect(0, 43226, '\P{^Is_Scx=saur}', "");
    Expect(1, 43225, '\p{Is_Scx=	 Saur}', "");
    Expect(0, 43225, '\p{^Is_Scx=	 Saur}', "");
    Expect(0, 43225, '\P{Is_Scx=	 Saur}', "");
    Expect(1, 43225, '\P{^Is_Scx=	 Saur}', "");
    Expect(0, 43226, '\p{Is_Scx=	 Saur}', "");
    Expect(1, 43226, '\p{^Is_Scx=	 Saur}', "");
    Expect(1, 43226, '\P{Is_Scx=	 Saur}', "");
    Expect(0, 43226, '\P{^Is_Scx=	 Saur}', "");
    Error('\p{Script_Extensions=	-SignWriting/a/}');
    Error('\P{Script_Extensions=	-SignWriting/a/}');
    Expect(1, 121519, '\p{Script_Extensions=:\ASignWriting\z:}', "");;
    Expect(0, 121520, '\p{Script_Extensions=:\ASignWriting\z:}', "");;
    Expect(1, 121519, '\p{Script_Extensions=signwriting}', "");
    Expect(0, 121519, '\p{^Script_Extensions=signwriting}', "");
    Expect(0, 121519, '\P{Script_Extensions=signwriting}', "");
    Expect(1, 121519, '\P{^Script_Extensions=signwriting}', "");
    Expect(0, 121520, '\p{Script_Extensions=signwriting}', "");
    Expect(1, 121520, '\p{^Script_Extensions=signwriting}', "");
    Expect(1, 121520, '\P{Script_Extensions=signwriting}', "");
    Expect(0, 121520, '\P{^Script_Extensions=signwriting}', "");
    Expect(1, 121519, '\p{Script_Extensions=:\Asignwriting\z:}', "");;
    Expect(0, 121520, '\p{Script_Extensions=:\Asignwriting\z:}', "");;
    Expect(1, 121519, '\p{Script_Extensions=	SIGNWRITING}', "");
    Expect(0, 121519, '\p{^Script_Extensions=	SIGNWRITING}', "");
    Expect(0, 121519, '\P{Script_Extensions=	SIGNWRITING}', "");
    Expect(1, 121519, '\P{^Script_Extensions=	SIGNWRITING}', "");
    Expect(0, 121520, '\p{Script_Extensions=	SIGNWRITING}', "");
    Expect(1, 121520, '\p{^Script_Extensions=	SIGNWRITING}', "");
    Expect(1, 121520, '\P{Script_Extensions=	SIGNWRITING}', "");
    Expect(0, 121520, '\P{^Script_Extensions=	SIGNWRITING}', "");
    Error('\p{Scx=:=Sgnw}');
    Error('\P{Scx=:=Sgnw}');
    Expect(1, 121519, '\p{Scx=:\ASgnw\z:}', "");;
    Expect(0, 121520, '\p{Scx=:\ASgnw\z:}', "");;
    Expect(1, 121519, '\p{Scx=sgnw}', "");
    Expect(0, 121519, '\p{^Scx=sgnw}', "");
    Expect(0, 121519, '\P{Scx=sgnw}', "");
    Expect(1, 121519, '\P{^Scx=sgnw}', "");
    Expect(0, 121520, '\p{Scx=sgnw}', "");
    Expect(1, 121520, '\p{^Scx=sgnw}', "");
    Expect(1, 121520, '\P{Scx=sgnw}', "");
    Expect(0, 121520, '\P{^Scx=sgnw}', "");
    Expect(1, 121519, '\p{Scx=:\Asgnw\z:}', "");;
    Expect(0, 121520, '\p{Scx=:\Asgnw\z:}', "");;
    Expect(1, 121519, '\p{Scx=_SGNW}', "");
    Expect(0, 121519, '\p{^Scx=_SGNW}', "");
    Expect(0, 121519, '\P{Scx=_SGNW}', "");
    Expect(1, 121519, '\P{^Scx=_SGNW}', "");
    Expect(0, 121520, '\p{Scx=_SGNW}', "");
    Expect(1, 121520, '\p{^Scx=_SGNW}', "");
    Expect(1, 121520, '\P{Scx=_SGNW}', "");
    Expect(0, 121520, '\P{^Scx=_SGNW}', "");
    Error('\p{Is_Script_Extensions= SignWriting/a/}');
    Error('\P{Is_Script_Extensions= SignWriting/a/}');
    Expect(1, 121519, '\p{Is_Script_Extensions=signwriting}', "");
    Expect(0, 121519, '\p{^Is_Script_Extensions=signwriting}', "");
    Expect(0, 121519, '\P{Is_Script_Extensions=signwriting}', "");
    Expect(1, 121519, '\P{^Is_Script_Extensions=signwriting}', "");
    Expect(0, 121520, '\p{Is_Script_Extensions=signwriting}', "");
    Expect(1, 121520, '\p{^Is_Script_Extensions=signwriting}', "");
    Expect(1, 121520, '\P{Is_Script_Extensions=signwriting}', "");
    Expect(0, 121520, '\P{^Is_Script_Extensions=signwriting}', "");
    Expect(1, 121519, '\p{Is_Script_Extensions= 	signwriting}', "");
    Expect(0, 121519, '\p{^Is_Script_Extensions= 	signwriting}', "");
    Expect(0, 121519, '\P{Is_Script_Extensions= 	signwriting}', "");
    Expect(1, 121519, '\P{^Is_Script_Extensions= 	signwriting}', "");
    Expect(0, 121520, '\p{Is_Script_Extensions= 	signwriting}', "");
    Expect(1, 121520, '\p{^Is_Script_Extensions= 	signwriting}', "");
    Expect(1, 121520, '\P{Is_Script_Extensions= 	signwriting}', "");
    Expect(0, 121520, '\P{^Is_Script_Extensions= 	signwriting}', "");
    Error('\p{Is_Scx=/a/Sgnw}');
    Error('\P{Is_Scx=/a/Sgnw}');
    Expect(1, 121519, '\p{Is_Scx=sgnw}', "");
    Expect(0, 121519, '\p{^Is_Scx=sgnw}', "");
    Expect(0, 121519, '\P{Is_Scx=sgnw}', "");
    Expect(1, 121519, '\P{^Is_Scx=sgnw}', "");
    Expect(0, 121520, '\p{Is_Scx=sgnw}', "");
    Expect(1, 121520, '\p{^Is_Scx=sgnw}', "");
    Expect(1, 121520, '\P{Is_Scx=sgnw}', "");
    Expect(0, 121520, '\P{^Is_Scx=sgnw}', "");
    Expect(1, 121519, '\p{Is_Scx=--SGNW}', "");
    Expect(0, 121519, '\p{^Is_Scx=--SGNW}', "");
    Expect(0, 121519, '\P{Is_Scx=--SGNW}', "");
    Expect(1, 121519, '\P{^Is_Scx=--SGNW}', "");
    Expect(0, 121520, '\p{Is_Scx=--SGNW}', "");
    Expect(1, 121520, '\p{^Is_Scx=--SGNW}', "");
    Expect(1, 121520, '\P{Is_Scx=--SGNW}', "");
    Expect(0, 121520, '\P{^Is_Scx=--SGNW}', "");
    Error('\p{Script_Extensions=	/a/shavian}');
    Error('\P{Script_Extensions=	/a/shavian}');
    Expect(1, 66687, '\p{Script_Extensions=:\AShavian\z:}', "");;
    Expect(0, 66688, '\p{Script_Extensions=:\AShavian\z:}', "");;
    Expect(1, 66687, '\p{Script_Extensions=shavian}', "");
    Expect(0, 66687, '\p{^Script_Extensions=shavian}', "");
    Expect(0, 66687, '\P{Script_Extensions=shavian}', "");
    Expect(1, 66687, '\P{^Script_Extensions=shavian}', "");
    Expect(0, 66688, '\p{Script_Extensions=shavian}', "");
    Expect(1, 66688, '\p{^Script_Extensions=shavian}', "");
    Expect(1, 66688, '\P{Script_Extensions=shavian}', "");
    Expect(0, 66688, '\P{^Script_Extensions=shavian}', "");
    Expect(1, 66687, '\p{Script_Extensions=:\Ashavian\z:}', "");;
    Expect(0, 66688, '\p{Script_Extensions=:\Ashavian\z:}', "");;
    Expect(1, 66687, '\p{Script_Extensions=  shavian}', "");
    Expect(0, 66687, '\p{^Script_Extensions=  shavian}', "");
    Expect(0, 66687, '\P{Script_Extensions=  shavian}', "");
    Expect(1, 66687, '\P{^Script_Extensions=  shavian}', "");
    Expect(0, 66688, '\p{Script_Extensions=  shavian}', "");
    Expect(1, 66688, '\p{^Script_Extensions=  shavian}', "");
    Expect(1, 66688, '\P{Script_Extensions=  shavian}', "");
    Expect(0, 66688, '\P{^Script_Extensions=  shavian}', "");
    Error('\p{Scx:   	SHAW:=}');
    Error('\P{Scx:   	SHAW:=}');
    Expect(1, 66687, '\p{Scx=:\AShaw\z:}', "");;
    Expect(0, 66688, '\p{Scx=:\AShaw\z:}', "");;
    Expect(1, 66687, '\p{Scx:	shaw}', "");
    Expect(0, 66687, '\p{^Scx:	shaw}', "");
    Expect(0, 66687, '\P{Scx:	shaw}', "");
    Expect(1, 66687, '\P{^Scx:	shaw}', "");
    Expect(0, 66688, '\p{Scx:	shaw}', "");
    Expect(1, 66688, '\p{^Scx:	shaw}', "");
    Expect(1, 66688, '\P{Scx:	shaw}', "");
    Expect(0, 66688, '\P{^Scx:	shaw}', "");
    Expect(1, 66687, '\p{Scx=:\Ashaw\z:}', "");;
    Expect(0, 66688, '\p{Scx=:\Ashaw\z:}', "");;
    Expect(1, 66687, '\p{Scx:    SHAW}', "");
    Expect(0, 66687, '\p{^Scx:    SHAW}', "");
    Expect(0, 66687, '\P{Scx:    SHAW}', "");
    Expect(1, 66687, '\P{^Scx:    SHAW}', "");
    Expect(0, 66688, '\p{Scx:    SHAW}', "");
    Expect(1, 66688, '\p{^Scx:    SHAW}', "");
    Expect(1, 66688, '\P{Scx:    SHAW}', "");
    Expect(0, 66688, '\P{^Scx:    SHAW}', "");
    Error('\p{Is_Script_Extensions=/a/	_SHAVIAN}');
    Error('\P{Is_Script_Extensions=/a/	_SHAVIAN}');
    Expect(1, 66687, '\p{Is_Script_Extensions=shavian}', "");
    Expect(0, 66687, '\p{^Is_Script_Extensions=shavian}', "");
    Expect(0, 66687, '\P{Is_Script_Extensions=shavian}', "");
    Expect(1, 66687, '\P{^Is_Script_Extensions=shavian}', "");
    Expect(0, 66688, '\p{Is_Script_Extensions=shavian}', "");
    Expect(1, 66688, '\p{^Is_Script_Extensions=shavian}', "");
    Expect(1, 66688, '\P{Is_Script_Extensions=shavian}', "");
    Expect(0, 66688, '\P{^Is_Script_Extensions=shavian}', "");
    Expect(1, 66687, '\p{Is_Script_Extensions:   _Shavian}', "");
    Expect(0, 66687, '\p{^Is_Script_Extensions:   _Shavian}', "");
    Expect(0, 66687, '\P{Is_Script_Extensions:   _Shavian}', "");
    Expect(1, 66687, '\P{^Is_Script_Extensions:   _Shavian}', "");
    Expect(0, 66688, '\p{Is_Script_Extensions:   _Shavian}', "");
    Expect(1, 66688, '\p{^Is_Script_Extensions:   _Shavian}', "");
    Expect(1, 66688, '\P{Is_Script_Extensions:   _Shavian}', "");
    Expect(0, 66688, '\P{^Is_Script_Extensions:   _Shavian}', "");
    Error('\p{Is_Scx:    shaw/a/}');
    Error('\P{Is_Scx:    shaw/a/}');
    Expect(1, 66687, '\p{Is_Scx:   shaw}', "");
    Expect(0, 66687, '\p{^Is_Scx:   shaw}', "");
    Expect(0, 66687, '\P{Is_Scx:   shaw}', "");
    Expect(1, 66687, '\P{^Is_Scx:   shaw}', "");
    Expect(0, 66688, '\p{Is_Scx:   shaw}', "");
    Expect(1, 66688, '\p{^Is_Scx:   shaw}', "");
    Expect(1, 66688, '\P{Is_Scx:   shaw}', "");
    Expect(0, 66688, '\P{^Is_Scx:   shaw}', "");
    Expect(1, 66687, '\p{Is_Scx=-_SHAW}', "");
    Expect(0, 66687, '\p{^Is_Scx=-_SHAW}', "");
    Expect(0, 66687, '\P{Is_Scx=-_SHAW}', "");
    Expect(1, 66687, '\P{^Is_Scx=-_SHAW}', "");
    Expect(0, 66688, '\p{Is_Scx=-_SHAW}', "");
    Expect(1, 66688, '\p{^Is_Scx=-_SHAW}', "");
    Expect(1, 66688, '\P{Is_Scx=-_SHAW}', "");
    Expect(0, 66688, '\P{^Is_Scx=-_SHAW}', "");
    Error('\p{Script_Extensions= Sharada/a/}');
    Error('\P{Script_Extensions= Sharada/a/}');
    Expect(1, 70111, '\p{Script_Extensions=:\ASharada\z:}', "");;
    Expect(0, 70112, '\p{Script_Extensions=:\ASharada\z:}', "");;
    Expect(1, 70111, '\p{Script_Extensions=sharada}', "");
    Expect(0, 70111, '\p{^Script_Extensions=sharada}', "");
    Expect(0, 70111, '\P{Script_Extensions=sharada}', "");
    Expect(1, 70111, '\P{^Script_Extensions=sharada}', "");
    Expect(0, 70112, '\p{Script_Extensions=sharada}', "");
    Expect(1, 70112, '\p{^Script_Extensions=sharada}', "");
    Expect(1, 70112, '\P{Script_Extensions=sharada}', "");
    Expect(0, 70112, '\P{^Script_Extensions=sharada}', "");
    Expect(1, 70111, '\p{Script_Extensions=:\Asharada\z:}', "");;
    Expect(0, 70112, '\p{Script_Extensions=:\Asharada\z:}', "");;
    Expect(1, 70111, '\p{Script_Extensions=_Sharada}', "");
    Expect(0, 70111, '\p{^Script_Extensions=_Sharada}', "");
    Expect(0, 70111, '\P{Script_Extensions=_Sharada}', "");
    Expect(1, 70111, '\P{^Script_Extensions=_Sharada}', "");
    Expect(0, 70112, '\p{Script_Extensions=_Sharada}', "");
    Expect(1, 70112, '\p{^Script_Extensions=_Sharada}', "");
    Expect(1, 70112, '\P{Script_Extensions=_Sharada}', "");
    Expect(0, 70112, '\P{^Script_Extensions=_Sharada}', "");
    Error('\p{Scx=:=_ SHRD}');
    Error('\P{Scx=:=_ SHRD}');
    Expect(1, 70111, '\p{Scx=:\AShrd\z:}', "");;
    Expect(0, 70112, '\p{Scx=:\AShrd\z:}', "");;
    Expect(1, 70111, '\p{Scx=shrd}', "");
    Expect(0, 70111, '\p{^Scx=shrd}', "");
    Expect(0, 70111, '\P{Scx=shrd}', "");
    Expect(1, 70111, '\P{^Scx=shrd}', "");
    Expect(0, 70112, '\p{Scx=shrd}', "");
    Expect(1, 70112, '\p{^Scx=shrd}', "");
    Expect(1, 70112, '\P{Scx=shrd}', "");
    Expect(0, 70112, '\P{^Scx=shrd}', "");
    Expect(1, 70111, '\p{Scx=:\Ashrd\z:}', "");;
    Expect(0, 70112, '\p{Scx=:\Ashrd\z:}', "");;
    Expect(1, 70111, '\p{Scx=-SHRD}', "");
    Expect(0, 70111, '\p{^Scx=-SHRD}', "");
    Expect(0, 70111, '\P{Scx=-SHRD}', "");
    Expect(1, 70111, '\P{^Scx=-SHRD}', "");
    Expect(0, 70112, '\p{Scx=-SHRD}', "");
    Expect(1, 70112, '\p{^Scx=-SHRD}', "");
    Expect(1, 70112, '\P{Scx=-SHRD}', "");
    Expect(0, 70112, '\P{^Scx=-SHRD}', "");
    Error('\p{Is_Script_Extensions= 	SHARADA/a/}');
    Error('\P{Is_Script_Extensions= 	SHARADA/a/}');
    Expect(1, 70111, '\p{Is_Script_Extensions: sharada}', "");
    Expect(0, 70111, '\p{^Is_Script_Extensions: sharada}', "");
    Expect(0, 70111, '\P{Is_Script_Extensions: sharada}', "");
    Expect(1, 70111, '\P{^Is_Script_Extensions: sharada}', "");
    Expect(0, 70112, '\p{Is_Script_Extensions: sharada}', "");
    Expect(1, 70112, '\p{^Is_Script_Extensions: sharada}', "");
    Expect(1, 70112, '\P{Is_Script_Extensions: sharada}', "");
    Expect(0, 70112, '\P{^Is_Script_Extensions: sharada}', "");
    Expect(1, 70111, '\p{Is_Script_Extensions=_	sharada}', "");
    Expect(0, 70111, '\p{^Is_Script_Extensions=_	sharada}', "");
    Expect(0, 70111, '\P{Is_Script_Extensions=_	sharada}', "");
    Expect(1, 70111, '\P{^Is_Script_Extensions=_	sharada}', "");
    Expect(0, 70112, '\p{Is_Script_Extensions=_	sharada}', "");
    Expect(1, 70112, '\p{^Is_Script_Extensions=_	sharada}', "");
    Expect(1, 70112, '\P{Is_Script_Extensions=_	sharada}', "");
    Expect(0, 70112, '\P{^Is_Script_Extensions=_	sharada}', "");
    Error('\p{Is_Scx=	/a/Shrd}');
    Error('\P{Is_Scx=	/a/Shrd}');
    Expect(1, 70111, '\p{Is_Scx=shrd}', "");
    Expect(0, 70111, '\p{^Is_Scx=shrd}', "");
    Expect(0, 70111, '\P{Is_Scx=shrd}', "");
    Expect(1, 70111, '\P{^Is_Scx=shrd}', "");
    Expect(0, 70112, '\p{Is_Scx=shrd}', "");
    Expect(1, 70112, '\p{^Is_Scx=shrd}', "");
    Expect(1, 70112, '\P{Is_Scx=shrd}', "");
    Expect(0, 70112, '\P{^Is_Scx=shrd}', "");
    Expect(1, 70111, '\p{Is_Scx=_ Shrd}', "");
    Expect(0, 70111, '\p{^Is_Scx=_ Shrd}', "");
    Expect(0, 70111, '\P{Is_Scx=_ Shrd}', "");
    Expect(1, 70111, '\P{^Is_Scx=_ Shrd}', "");
    Expect(0, 70112, '\p{Is_Scx=_ Shrd}', "");
    Expect(1, 70112, '\p{^Is_Scx=_ Shrd}', "");
    Expect(1, 70112, '\P{Is_Scx=_ Shrd}', "");
    Expect(0, 70112, '\P{^Is_Scx=_ Shrd}', "");
    Error('\p{Script_Extensions=	:=siddham}');
    Error('\P{Script_Extensions=	:=siddham}');
    Expect(1, 71133, '\p{Script_Extensions=:\ASiddham\z:}', "");;
    Expect(0, 71134, '\p{Script_Extensions=:\ASiddham\z:}', "");;
    Expect(1, 71133, '\p{Script_Extensions=siddham}', "");
    Expect(0, 71133, '\p{^Script_Extensions=siddham}', "");
    Expect(0, 71133, '\P{Script_Extensions=siddham}', "");
    Expect(1, 71133, '\P{^Script_Extensions=siddham}', "");
    Expect(0, 71134, '\p{Script_Extensions=siddham}', "");
    Expect(1, 71134, '\p{^Script_Extensions=siddham}', "");
    Expect(1, 71134, '\P{Script_Extensions=siddham}', "");
    Expect(0, 71134, '\P{^Script_Extensions=siddham}', "");
    Expect(1, 71133, '\p{Script_Extensions=:\Asiddham\z:}', "");;
    Expect(0, 71134, '\p{Script_Extensions=:\Asiddham\z:}', "");;
    Expect(1, 71133, '\p{Script_Extensions=	 SIDDHAM}', "");
    Expect(0, 71133, '\p{^Script_Extensions=	 SIDDHAM}', "");
    Expect(0, 71133, '\P{Script_Extensions=	 SIDDHAM}', "");
    Expect(1, 71133, '\P{^Script_Extensions=	 SIDDHAM}', "");
    Expect(0, 71134, '\p{Script_Extensions=	 SIDDHAM}', "");
    Expect(1, 71134, '\p{^Script_Extensions=	 SIDDHAM}', "");
    Expect(1, 71134, '\P{Script_Extensions=	 SIDDHAM}', "");
    Expect(0, 71134, '\P{^Script_Extensions=	 SIDDHAM}', "");
    Error('\p{Scx=	-Sidd/a/}');
    Error('\P{Scx=	-Sidd/a/}');
    Expect(1, 71133, '\p{Scx=:\ASidd\z:}', "");;
    Expect(0, 71134, '\p{Scx=:\ASidd\z:}', "");;
    Expect(1, 71133, '\p{Scx:	sidd}', "");
    Expect(0, 71133, '\p{^Scx:	sidd}', "");
    Expect(0, 71133, '\P{Scx:	sidd}', "");
    Expect(1, 71133, '\P{^Scx:	sidd}', "");
    Expect(0, 71134, '\p{Scx:	sidd}', "");
    Expect(1, 71134, '\p{^Scx:	sidd}', "");
    Expect(1, 71134, '\P{Scx:	sidd}', "");
    Expect(0, 71134, '\P{^Scx:	sidd}', "");
    Expect(1, 71133, '\p{Scx=:\Asidd\z:}', "");;
    Expect(0, 71134, '\p{Scx=:\Asidd\z:}', "");;
    Expect(1, 71133, '\p{Scx=_-SIDD}', "");
    Expect(0, 71133, '\p{^Scx=_-SIDD}', "");
    Expect(0, 71133, '\P{Scx=_-SIDD}', "");
    Expect(1, 71133, '\P{^Scx=_-SIDD}', "");
    Expect(0, 71134, '\p{Scx=_-SIDD}', "");
    Expect(1, 71134, '\p{^Scx=_-SIDD}', "");
    Expect(1, 71134, '\P{Scx=_-SIDD}', "");
    Expect(0, 71134, '\P{^Scx=_-SIDD}', "");
    Error('\p{Is_Script_Extensions=/a/  siddham}');
    Error('\P{Is_Script_Extensions=/a/  siddham}');
    Expect(1, 71133, '\p{Is_Script_Extensions=siddham}', "");
    Expect(0, 71133, '\p{^Is_Script_Extensions=siddham}', "");
    Expect(0, 71133, '\P{Is_Script_Extensions=siddham}', "");
    Expect(1, 71133, '\P{^Is_Script_Extensions=siddham}', "");
    Expect(0, 71134, '\p{Is_Script_Extensions=siddham}', "");
    Expect(1, 71134, '\p{^Is_Script_Extensions=siddham}', "");
    Expect(1, 71134, '\P{Is_Script_Extensions=siddham}', "");
    Expect(0, 71134, '\P{^Is_Script_Extensions=siddham}', "");
    Expect(1, 71133, '\p{Is_Script_Extensions= siddham}', "");
    Expect(0, 71133, '\p{^Is_Script_Extensions= siddham}', "");
    Expect(0, 71133, '\P{Is_Script_Extensions= siddham}', "");
    Expect(1, 71133, '\P{^Is_Script_Extensions= siddham}', "");
    Expect(0, 71134, '\p{Is_Script_Extensions= siddham}', "");
    Expect(1, 71134, '\p{^Is_Script_Extensions= siddham}', "");
    Expect(1, 71134, '\P{Is_Script_Extensions= siddham}', "");
    Expect(0, 71134, '\P{^Is_Script_Extensions= siddham}', "");
    Error('\p{Is_Scx=/a/ _Sidd}');
    Error('\P{Is_Scx=/a/ _Sidd}');
    Expect(1, 71133, '\p{Is_Scx=sidd}', "");
    Expect(0, 71133, '\p{^Is_Scx=sidd}', "");
    Expect(0, 71133, '\P{Is_Scx=sidd}', "");
    Expect(1, 71133, '\P{^Is_Scx=sidd}', "");
    Expect(0, 71134, '\p{Is_Scx=sidd}', "");
    Expect(1, 71134, '\p{^Is_Scx=sidd}', "");
    Expect(1, 71134, '\P{Is_Scx=sidd}', "");
    Expect(0, 71134, '\P{^Is_Scx=sidd}', "");
    Expect(1, 71133, '\p{Is_Scx=	-Sidd}', "");
    Expect(0, 71133, '\p{^Is_Scx=	-Sidd}', "");
    Expect(0, 71133, '\P{Is_Scx=	-Sidd}', "");
    Expect(1, 71133, '\P{^Is_Scx=	-Sidd}', "");
    Expect(0, 71134, '\p{Is_Scx=	-Sidd}', "");
    Expect(1, 71134, '\p{^Is_Scx=	-Sidd}', "");
    Expect(1, 71134, '\P{Is_Scx=	-Sidd}', "");
    Expect(0, 71134, '\P{^Is_Scx=	-Sidd}', "");
    Error('\p{Script_Extensions=_-khudawadi/a/}');
    Error('\P{Script_Extensions=_-khudawadi/a/}');
    Expect(1, 70393, '\p{Script_Extensions=:\AKhudawadi\z:}', "");;
    Expect(0, 70394, '\p{Script_Extensions=:\AKhudawadi\z:}', "");;
    Expect(1, 70393, '\p{Script_Extensions=khudawadi}', "");
    Expect(0, 70393, '\p{^Script_Extensions=khudawadi}', "");
    Expect(0, 70393, '\P{Script_Extensions=khudawadi}', "");
    Expect(1, 70393, '\P{^Script_Extensions=khudawadi}', "");
    Expect(0, 70394, '\p{Script_Extensions=khudawadi}', "");
    Expect(1, 70394, '\p{^Script_Extensions=khudawadi}', "");
    Expect(1, 70394, '\P{Script_Extensions=khudawadi}', "");
    Expect(0, 70394, '\P{^Script_Extensions=khudawadi}', "");
    Expect(1, 70393, '\p{Script_Extensions=:\Akhudawadi\z:}', "");;
    Expect(0, 70394, '\p{Script_Extensions=:\Akhudawadi\z:}', "");;
    Expect(1, 70393, '\p{Script_Extensions=	_Khudawadi}', "");
    Expect(0, 70393, '\p{^Script_Extensions=	_Khudawadi}', "");
    Expect(0, 70393, '\P{Script_Extensions=	_Khudawadi}', "");
    Expect(1, 70393, '\P{^Script_Extensions=	_Khudawadi}', "");
    Expect(0, 70394, '\p{Script_Extensions=	_Khudawadi}', "");
    Expect(1, 70394, '\p{^Script_Extensions=	_Khudawadi}', "");
    Expect(1, 70394, '\P{Script_Extensions=	_Khudawadi}', "");
    Expect(0, 70394, '\P{^Script_Extensions=	_Khudawadi}', "");
    Error('\p{Scx: -/a/sind}');
    Error('\P{Scx: -/a/sind}');
    Expect(1, 70393, '\p{Scx=:\ASind\z:}', "");;
    Expect(0, 70394, '\p{Scx=:\ASind\z:}', "");;
    Expect(1, 70393, '\p{Scx=sind}', "");
    Expect(0, 70393, '\p{^Scx=sind}', "");
    Expect(0, 70393, '\P{Scx=sind}', "");
    Expect(1, 70393, '\P{^Scx=sind}', "");
    Expect(0, 70394, '\p{Scx=sind}', "");
    Expect(1, 70394, '\p{^Scx=sind}', "");
    Expect(1, 70394, '\P{Scx=sind}', "");
    Expect(0, 70394, '\P{^Scx=sind}', "");
    Expect(1, 70393, '\p{Scx=:\Asind\z:}', "");;
    Expect(0, 70394, '\p{Scx=:\Asind\z:}', "");;
    Expect(1, 70393, '\p{Scx=- SIND}', "");
    Expect(0, 70393, '\p{^Scx=- SIND}', "");
    Expect(0, 70393, '\P{Scx=- SIND}', "");
    Expect(1, 70393, '\P{^Scx=- SIND}', "");
    Expect(0, 70394, '\p{Scx=- SIND}', "");
    Expect(1, 70394, '\p{^Scx=- SIND}', "");
    Expect(1, 70394, '\P{Scx=- SIND}', "");
    Expect(0, 70394, '\P{^Scx=- SIND}', "");
    Error('\p{Is_Script_Extensions:	_:=Khudawadi}');
    Error('\P{Is_Script_Extensions:	_:=Khudawadi}');
    Expect(1, 70393, '\p{Is_Script_Extensions=khudawadi}', "");
    Expect(0, 70393, '\p{^Is_Script_Extensions=khudawadi}', "");
    Expect(0, 70393, '\P{Is_Script_Extensions=khudawadi}', "");
    Expect(1, 70393, '\P{^Is_Script_Extensions=khudawadi}', "");
    Expect(0, 70394, '\p{Is_Script_Extensions=khudawadi}', "");
    Expect(1, 70394, '\p{^Is_Script_Extensions=khudawadi}', "");
    Expect(1, 70394, '\P{Is_Script_Extensions=khudawadi}', "");
    Expect(0, 70394, '\P{^Is_Script_Extensions=khudawadi}', "");
    Expect(1, 70393, '\p{Is_Script_Extensions= Khudawadi}', "");
    Expect(0, 70393, '\p{^Is_Script_Extensions= Khudawadi}', "");
    Expect(0, 70393, '\P{Is_Script_Extensions= Khudawadi}', "");
    Expect(1, 70393, '\P{^Is_Script_Extensions= Khudawadi}', "");
    Expect(0, 70394, '\p{Is_Script_Extensions= Khudawadi}', "");
    Expect(1, 70394, '\p{^Is_Script_Extensions= Khudawadi}', "");
    Expect(1, 70394, '\P{Is_Script_Extensions= Khudawadi}', "");
    Expect(0, 70394, '\P{^Is_Script_Extensions= Khudawadi}', "");
    Error('\p{Is_Scx=		Sind:=}');
    Error('\P{Is_Scx=		Sind:=}');
    Expect(1, 70393, '\p{Is_Scx=sind}', "");
    Expect(0, 70393, '\p{^Is_Scx=sind}', "");
    Expect(0, 70393, '\P{Is_Scx=sind}', "");
    Expect(1, 70393, '\P{^Is_Scx=sind}', "");
    Expect(0, 70394, '\p{Is_Scx=sind}', "");
    Expect(1, 70394, '\p{^Is_Scx=sind}', "");
    Expect(1, 70394, '\P{Is_Scx=sind}', "");
    Expect(0, 70394, '\P{^Is_Scx=sind}', "");
    Expect(1, 70393, '\p{Is_Scx:  	sind}', "");
    Expect(0, 70393, '\p{^Is_Scx:  	sind}', "");
    Expect(0, 70393, '\P{Is_Scx:  	sind}', "");
    Expect(1, 70393, '\P{^Is_Scx:  	sind}', "");
    Expect(0, 70394, '\p{Is_Scx:  	sind}', "");
    Expect(1, 70394, '\p{^Is_Scx:  	sind}', "");
    Expect(1, 70394, '\P{Is_Scx:  	sind}', "");
    Expect(0, 70394, '\P{^Is_Scx:  	sind}', "");
    Error('\p{Script_Extensions=	:=Sinhala}');
    Error('\P{Script_Extensions=	:=Sinhala}');
    Expect(1, 70132, '\p{Script_Extensions=:\ASinhala\z:}', "");;
    Expect(0, 70133, '\p{Script_Extensions=:\ASinhala\z:}', "");;
    Expect(1, 70132, '\p{Script_Extensions=sinhala}', "");
    Expect(0, 70132, '\p{^Script_Extensions=sinhala}', "");
    Expect(0, 70132, '\P{Script_Extensions=sinhala}', "");
    Expect(1, 70132, '\P{^Script_Extensions=sinhala}', "");
    Expect(0, 70133, '\p{Script_Extensions=sinhala}', "");
    Expect(1, 70133, '\p{^Script_Extensions=sinhala}', "");
    Expect(1, 70133, '\P{Script_Extensions=sinhala}', "");
    Expect(0, 70133, '\P{^Script_Extensions=sinhala}', "");
    Expect(1, 70132, '\p{Script_Extensions=:\Asinhala\z:}', "");;
    Expect(0, 70133, '\p{Script_Extensions=:\Asinhala\z:}', "");;
    Expect(1, 70132, '\p{Script_Extensions=  Sinhala}', "");
    Expect(0, 70132, '\p{^Script_Extensions=  Sinhala}', "");
    Expect(0, 70132, '\P{Script_Extensions=  Sinhala}', "");
    Expect(1, 70132, '\P{^Script_Extensions=  Sinhala}', "");
    Expect(0, 70133, '\p{Script_Extensions=  Sinhala}', "");
    Expect(1, 70133, '\p{^Script_Extensions=  Sinhala}', "");
    Expect(1, 70133, '\P{Script_Extensions=  Sinhala}', "");
    Expect(0, 70133, '\P{^Script_Extensions=  Sinhala}', "");
    Error('\p{Scx=_/a/sinh}');
    Error('\P{Scx=_/a/sinh}');
    Expect(1, 70132, '\p{Scx=:\ASinh\z:}', "");;
    Expect(0, 70133, '\p{Scx=:\ASinh\z:}', "");;
    Expect(1, 70132, '\p{Scx: sinh}', "");
    Expect(0, 70132, '\p{^Scx: sinh}', "");
    Expect(0, 70132, '\P{Scx: sinh}', "");
    Expect(1, 70132, '\P{^Scx: sinh}', "");
    Expect(0, 70133, '\p{Scx: sinh}', "");
    Expect(1, 70133, '\p{^Scx: sinh}', "");
    Expect(1, 70133, '\P{Scx: sinh}', "");
    Expect(0, 70133, '\P{^Scx: sinh}', "");
    Expect(1, 70132, '\p{Scx=:\Asinh\z:}', "");;
    Expect(0, 70133, '\p{Scx=:\Asinh\z:}', "");;
    Expect(1, 70132, '\p{Scx=	Sinh}', "");
    Expect(0, 70132, '\p{^Scx=	Sinh}', "");
    Expect(0, 70132, '\P{Scx=	Sinh}', "");
    Expect(1, 70132, '\P{^Scx=	Sinh}', "");
    Expect(0, 70133, '\p{Scx=	Sinh}', "");
    Expect(1, 70133, '\p{^Scx=	Sinh}', "");
    Expect(1, 70133, '\P{Scx=	Sinh}', "");
    Expect(0, 70133, '\P{^Scx=	Sinh}', "");
    Error('\p{Is_Script_Extensions=/a/	 SINHALA}');
    Error('\P{Is_Script_Extensions=/a/	 SINHALA}');
    Expect(1, 70132, '\p{Is_Script_Extensions=sinhala}', "");
    Expect(0, 70132, '\p{^Is_Script_Extensions=sinhala}', "");
    Expect(0, 70132, '\P{Is_Script_Extensions=sinhala}', "");
    Expect(1, 70132, '\P{^Is_Script_Extensions=sinhala}', "");
    Expect(0, 70133, '\p{Is_Script_Extensions=sinhala}', "");
    Expect(1, 70133, '\p{^Is_Script_Extensions=sinhala}', "");
    Expect(1, 70133, '\P{Is_Script_Extensions=sinhala}', "");
    Expect(0, 70133, '\P{^Is_Script_Extensions=sinhala}', "");
    Expect(1, 70132, '\p{Is_Script_Extensions=_sinhala}', "");
    Expect(0, 70132, '\p{^Is_Script_Extensions=_sinhala}', "");
    Expect(0, 70132, '\P{Is_Script_Extensions=_sinhala}', "");
    Expect(1, 70132, '\P{^Is_Script_Extensions=_sinhala}', "");
    Expect(0, 70133, '\p{Is_Script_Extensions=_sinhala}', "");
    Expect(1, 70133, '\p{^Is_Script_Extensions=_sinhala}', "");
    Expect(1, 70133, '\P{Is_Script_Extensions=_sinhala}', "");
    Expect(0, 70133, '\P{^Is_Script_Extensions=_sinhala}', "");
    Error('\p{Is_Scx=	Sinh/a/}');
    Error('\P{Is_Scx=	Sinh/a/}');
    Expect(1, 70132, '\p{Is_Scx=sinh}', "");
    Expect(0, 70132, '\p{^Is_Scx=sinh}', "");
    Expect(0, 70132, '\P{Is_Scx=sinh}', "");
    Expect(1, 70132, '\P{^Is_Scx=sinh}', "");
    Expect(0, 70133, '\p{Is_Scx=sinh}', "");
    Expect(1, 70133, '\p{^Is_Scx=sinh}', "");
    Expect(1, 70133, '\P{Is_Scx=sinh}', "");
    Expect(0, 70133, '\P{^Is_Scx=sinh}', "");
    Expect(1, 70132, '\p{Is_Scx=	_Sinh}', "");
    Expect(0, 70132, '\p{^Is_Scx=	_Sinh}', "");
    Expect(0, 70132, '\P{Is_Scx=	_Sinh}', "");
    Expect(1, 70132, '\P{^Is_Scx=	_Sinh}', "");
    Expect(0, 70133, '\p{Is_Scx=	_Sinh}', "");
    Expect(1, 70133, '\p{^Is_Scx=	_Sinh}', "");
    Expect(1, 70133, '\P{Is_Scx=	_Sinh}', "");
    Expect(0, 70133, '\P{^Is_Scx=	_Sinh}', "");
    Error('\p{Script_Extensions=_-Sogdian:=}');
    Error('\P{Script_Extensions=_-Sogdian:=}');
    Expect(1, 69465, '\p{Script_Extensions=:\ASogdian\z:}', "");;
    Expect(0, 69466, '\p{Script_Extensions=:\ASogdian\z:}', "");;
    Expect(1, 69465, '\p{Script_Extensions=sogdian}', "");
    Expect(0, 69465, '\p{^Script_Extensions=sogdian}', "");
    Expect(0, 69465, '\P{Script_Extensions=sogdian}', "");
    Expect(1, 69465, '\P{^Script_Extensions=sogdian}', "");
    Expect(0, 69466, '\p{Script_Extensions=sogdian}', "");
    Expect(1, 69466, '\p{^Script_Extensions=sogdian}', "");
    Expect(1, 69466, '\P{Script_Extensions=sogdian}', "");
    Expect(0, 69466, '\P{^Script_Extensions=sogdian}', "");
    Expect(1, 69465, '\p{Script_Extensions=:\Asogdian\z:}', "");;
    Expect(0, 69466, '\p{Script_Extensions=:\Asogdian\z:}', "");;
    Expect(1, 69465, '\p{Script_Extensions= sogdian}', "");
    Expect(0, 69465, '\p{^Script_Extensions= sogdian}', "");
    Expect(0, 69465, '\P{Script_Extensions= sogdian}', "");
    Expect(1, 69465, '\P{^Script_Extensions= sogdian}', "");
    Expect(0, 69466, '\p{Script_Extensions= sogdian}', "");
    Expect(1, 69466, '\p{^Script_Extensions= sogdian}', "");
    Expect(1, 69466, '\P{Script_Extensions= sogdian}', "");
    Expect(0, 69466, '\P{^Script_Extensions= sogdian}', "");
    Error('\p{Scx=:=__SOGD}');
    Error('\P{Scx=:=__SOGD}');
    Expect(1, 69465, '\p{Scx=:\ASogd\z:}', "");;
    Expect(0, 69466, '\p{Scx=:\ASogd\z:}', "");;
    Expect(1, 69465, '\p{Scx: sogd}', "");
    Expect(0, 69465, '\p{^Scx: sogd}', "");
    Expect(0, 69465, '\P{Scx: sogd}', "");
    Expect(1, 69465, '\P{^Scx: sogd}', "");
    Expect(0, 69466, '\p{Scx: sogd}', "");
    Expect(1, 69466, '\p{^Scx: sogd}', "");
    Expect(1, 69466, '\P{Scx: sogd}', "");
    Expect(0, 69466, '\P{^Scx: sogd}', "");
    Expect(1, 69465, '\p{Scx=:\Asogd\z:}', "");;
    Expect(0, 69466, '\p{Scx=:\Asogd\z:}', "");;
    Expect(1, 69465, '\p{Scx:   _	Sogd}', "");
    Expect(0, 69465, '\p{^Scx:   _	Sogd}', "");
    Expect(0, 69465, '\P{Scx:   _	Sogd}', "");
    Expect(1, 69465, '\P{^Scx:   _	Sogd}', "");
    Expect(0, 69466, '\p{Scx:   _	Sogd}', "");
    Expect(1, 69466, '\p{^Scx:   _	Sogd}', "");
    Expect(1, 69466, '\P{Scx:   _	Sogd}', "");
    Expect(0, 69466, '\P{^Scx:   _	Sogd}', "");
    Error('\p{Is_Script_Extensions:	 :=Sogdian}');
    Error('\P{Is_Script_Extensions:	 :=Sogdian}');
    Expect(1, 69465, '\p{Is_Script_Extensions=sogdian}', "");
    Expect(0, 69465, '\p{^Is_Script_Extensions=sogdian}', "");
    Expect(0, 69465, '\P{Is_Script_Extensions=sogdian}', "");
    Expect(1, 69465, '\P{^Is_Script_Extensions=sogdian}', "");
    Expect(0, 69466, '\p{Is_Script_Extensions=sogdian}', "");
    Expect(1, 69466, '\p{^Is_Script_Extensions=sogdian}', "");
    Expect(1, 69466, '\P{Is_Script_Extensions=sogdian}', "");
    Expect(0, 69466, '\P{^Is_Script_Extensions=sogdian}', "");
    Expect(1, 69465, '\p{Is_Script_Extensions=--SOGDIAN}', "");
    Expect(0, 69465, '\p{^Is_Script_Extensions=--SOGDIAN}', "");
    Expect(0, 69465, '\P{Is_Script_Extensions=--SOGDIAN}', "");
    Expect(1, 69465, '\P{^Is_Script_Extensions=--SOGDIAN}', "");
    Expect(0, 69466, '\p{Is_Script_Extensions=--SOGDIAN}', "");
    Expect(1, 69466, '\p{^Is_Script_Extensions=--SOGDIAN}', "");
    Expect(1, 69466, '\P{Is_Script_Extensions=--SOGDIAN}', "");
    Expect(0, 69466, '\P{^Is_Script_Extensions=--SOGDIAN}', "");
    Error('\p{Is_Scx=:=  SOGD}');
    Error('\P{Is_Scx=:=  SOGD}');
    Expect(1, 69465, '\p{Is_Scx=sogd}', "");
    Expect(0, 69465, '\p{^Is_Scx=sogd}', "");
    Expect(0, 69465, '\P{Is_Scx=sogd}', "");
    Expect(1, 69465, '\P{^Is_Scx=sogd}', "");
    Expect(0, 69466, '\p{Is_Scx=sogd}', "");
    Expect(1, 69466, '\p{^Is_Scx=sogd}', "");
    Expect(1, 69466, '\P{Is_Scx=sogd}', "");
    Expect(0, 69466, '\P{^Is_Scx=sogd}', "");
    Expect(1, 69465, '\p{Is_Scx=-_Sogd}', "");
    Expect(0, 69465, '\p{^Is_Scx=-_Sogd}', "");
    Expect(0, 69465, '\P{Is_Scx=-_Sogd}', "");
    Expect(1, 69465, '\P{^Is_Scx=-_Sogd}', "");
    Expect(0, 69466, '\p{Is_Scx=-_Sogd}', "");
    Expect(1, 69466, '\p{^Is_Scx=-_Sogd}', "");
    Expect(1, 69466, '\P{Is_Scx=-_Sogd}', "");
    Expect(0, 69466, '\P{^Is_Scx=-_Sogd}', "");
    Error('\p{Script_Extensions=/a/Old_SOGDIAN}');
    Error('\P{Script_Extensions=/a/Old_SOGDIAN}');
    Expect(1, 69415, '\p{Script_Extensions=:\AOld_Sogdian\z:}', "");;
    Expect(0, 69416, '\p{Script_Extensions=:\AOld_Sogdian\z:}', "");;
    Expect(1, 69415, '\p{Script_Extensions=oldsogdian}', "");
    Expect(0, 69415, '\p{^Script_Extensions=oldsogdian}', "");
    Expect(0, 69415, '\P{Script_Extensions=oldsogdian}', "");
    Expect(1, 69415, '\P{^Script_Extensions=oldsogdian}', "");
    Expect(0, 69416, '\p{Script_Extensions=oldsogdian}', "");
    Expect(1, 69416, '\p{^Script_Extensions=oldsogdian}', "");
    Expect(1, 69416, '\P{Script_Extensions=oldsogdian}', "");
    Expect(0, 69416, '\P{^Script_Extensions=oldsogdian}', "");
    Expect(1, 69415, '\p{Script_Extensions=:\Aoldsogdian\z:}', "");;
    Expect(0, 69416, '\p{Script_Extensions=:\Aoldsogdian\z:}', "");;
    Expect(1, 69415, '\p{Script_Extensions=_-Old_Sogdian}', "");
    Expect(0, 69415, '\p{^Script_Extensions=_-Old_Sogdian}', "");
    Expect(0, 69415, '\P{Script_Extensions=_-Old_Sogdian}', "");
    Expect(1, 69415, '\P{^Script_Extensions=_-Old_Sogdian}', "");
    Expect(0, 69416, '\p{Script_Extensions=_-Old_Sogdian}', "");
    Expect(1, 69416, '\p{^Script_Extensions=_-Old_Sogdian}', "");
    Expect(1, 69416, '\P{Script_Extensions=_-Old_Sogdian}', "");
    Expect(0, 69416, '\P{^Script_Extensions=_-Old_Sogdian}', "");
    Error('\p{Scx: -Sogo/a/}');
    Error('\P{Scx: -Sogo/a/}');
    Expect(1, 69415, '\p{Scx=:\ASogo\z:}', "");;
    Expect(0, 69416, '\p{Scx=:\ASogo\z:}', "");;
    Expect(1, 69415, '\p{Scx=sogo}', "");
    Expect(0, 69415, '\p{^Scx=sogo}', "");
    Expect(0, 69415, '\P{Scx=sogo}', "");
    Expect(1, 69415, '\P{^Scx=sogo}', "");
    Expect(0, 69416, '\p{Scx=sogo}', "");
    Expect(1, 69416, '\p{^Scx=sogo}', "");
    Expect(1, 69416, '\P{Scx=sogo}', "");
    Expect(0, 69416, '\P{^Scx=sogo}', "");
    Expect(1, 69415, '\p{Scx=:\Asogo\z:}', "");;
    Expect(0, 69416, '\p{Scx=:\Asogo\z:}', "");;
    Expect(1, 69415, '\p{Scx=	SOGO}', "");
    Expect(0, 69415, '\p{^Scx=	SOGO}', "");
    Expect(0, 69415, '\P{Scx=	SOGO}', "");
    Expect(1, 69415, '\P{^Scx=	SOGO}', "");
    Expect(0, 69416, '\p{Scx=	SOGO}', "");
    Expect(1, 69416, '\p{^Scx=	SOGO}', "");
    Expect(1, 69416, '\P{Scx=	SOGO}', "");
    Expect(0, 69416, '\P{^Scx=	SOGO}', "");
    Error('\p{Is_Script_Extensions=:=	-Old_Sogdian}');
    Error('\P{Is_Script_Extensions=:=	-Old_Sogdian}');
    Expect(1, 69415, '\p{Is_Script_Extensions:	oldsogdian}', "");
    Expect(0, 69415, '\p{^Is_Script_Extensions:	oldsogdian}', "");
    Expect(0, 69415, '\P{Is_Script_Extensions:	oldsogdian}', "");
    Expect(1, 69415, '\P{^Is_Script_Extensions:	oldsogdian}', "");
    Expect(0, 69416, '\p{Is_Script_Extensions:	oldsogdian}', "");
    Expect(1, 69416, '\p{^Is_Script_Extensions:	oldsogdian}', "");
    Expect(1, 69416, '\P{Is_Script_Extensions:	oldsogdian}', "");
    Expect(0, 69416, '\P{^Is_Script_Extensions:	oldsogdian}', "");
    Expect(1, 69415, '\p{Is_Script_Extensions=-	Old_Sogdian}', "");
    Expect(0, 69415, '\p{^Is_Script_Extensions=-	Old_Sogdian}', "");
    Expect(0, 69415, '\P{Is_Script_Extensions=-	Old_Sogdian}', "");
    Expect(1, 69415, '\P{^Is_Script_Extensions=-	Old_Sogdian}', "");
    Expect(0, 69416, '\p{Is_Script_Extensions=-	Old_Sogdian}', "");
    Expect(1, 69416, '\p{^Is_Script_Extensions=-	Old_Sogdian}', "");
    Expect(1, 69416, '\P{Is_Script_Extensions=-	Old_Sogdian}', "");
    Expect(0, 69416, '\P{^Is_Script_Extensions=-	Old_Sogdian}', "");
    Error('\p{Is_Scx=/a/SOGO}');
    Error('\P{Is_Scx=/a/SOGO}');
    Expect(1, 69415, '\p{Is_Scx=sogo}', "");
    Expect(0, 69415, '\p{^Is_Scx=sogo}', "");
    Expect(0, 69415, '\P{Is_Scx=sogo}', "");
    Expect(1, 69415, '\P{^Is_Scx=sogo}', "");
    Expect(0, 69416, '\p{Is_Scx=sogo}', "");
    Expect(1, 69416, '\p{^Is_Scx=sogo}', "");
    Expect(1, 69416, '\P{Is_Scx=sogo}', "");
    Expect(0, 69416, '\P{^Is_Scx=sogo}', "");
    Expect(1, 69415, '\p{Is_Scx= -Sogo}', "");
    Expect(0, 69415, '\p{^Is_Scx= -Sogo}', "");
    Expect(0, 69415, '\P{Is_Scx= -Sogo}', "");
    Expect(1, 69415, '\P{^Is_Scx= -Sogo}', "");
    Expect(0, 69416, '\p{Is_Scx= -Sogo}', "");
    Expect(1, 69416, '\p{^Is_Scx= -Sogo}', "");
    Expect(1, 69416, '\P{Is_Scx= -Sogo}', "");
    Expect(0, 69416, '\P{^Is_Scx= -Sogo}', "");
    Error('\p{Script_Extensions=-/a/SORA_sompeng}');
    Error('\P{Script_Extensions=-/a/SORA_sompeng}');
    Expect(1, 69881, '\p{Script_Extensions=:\ASora_Sompeng\z:}', "");;
    Expect(0, 69882, '\p{Script_Extensions=:\ASora_Sompeng\z:}', "");;
    Expect(1, 69881, '\p{Script_Extensions=sorasompeng}', "");
    Expect(0, 69881, '\p{^Script_Extensions=sorasompeng}', "");
    Expect(0, 69881, '\P{Script_Extensions=sorasompeng}', "");
    Expect(1, 69881, '\P{^Script_Extensions=sorasompeng}', "");
    Expect(0, 69882, '\p{Script_Extensions=sorasompeng}', "");
    Expect(1, 69882, '\p{^Script_Extensions=sorasompeng}', "");
    Expect(1, 69882, '\P{Script_Extensions=sorasompeng}', "");
    Expect(0, 69882, '\P{^Script_Extensions=sorasompeng}', "");
    Expect(1, 69881, '\p{Script_Extensions=:\Asorasompeng\z:}', "");;
    Expect(0, 69882, '\p{Script_Extensions=:\Asorasompeng\z:}', "");;
    Expect(1, 69881, '\p{Script_Extensions:	 Sora_Sompeng}', "");
    Expect(0, 69881, '\p{^Script_Extensions:	 Sora_Sompeng}', "");
    Expect(0, 69881, '\P{Script_Extensions:	 Sora_Sompeng}', "");
    Expect(1, 69881, '\P{^Script_Extensions:	 Sora_Sompeng}', "");
    Expect(0, 69882, '\p{Script_Extensions:	 Sora_Sompeng}', "");
    Expect(1, 69882, '\p{^Script_Extensions:	 Sora_Sompeng}', "");
    Expect(1, 69882, '\P{Script_Extensions:	 Sora_Sompeng}', "");
    Expect(0, 69882, '\P{^Script_Extensions:	 Sora_Sompeng}', "");
    Error('\p{Scx=-SORA/a/}');
    Error('\P{Scx=-SORA/a/}');
    Expect(1, 69881, '\p{Scx=:\ASora\z:}', "");;
    Expect(0, 69882, '\p{Scx=:\ASora\z:}', "");;
    Expect(1, 69881, '\p{Scx=sora}', "");
    Expect(0, 69881, '\p{^Scx=sora}', "");
    Expect(0, 69881, '\P{Scx=sora}', "");
    Expect(1, 69881, '\P{^Scx=sora}', "");
    Expect(0, 69882, '\p{Scx=sora}', "");
    Expect(1, 69882, '\p{^Scx=sora}', "");
    Expect(1, 69882, '\P{Scx=sora}', "");
    Expect(0, 69882, '\P{^Scx=sora}', "");
    Expect(1, 69881, '\p{Scx=:\Asora\z:}', "");;
    Expect(0, 69882, '\p{Scx=:\Asora\z:}', "");;
    Expect(1, 69881, '\p{Scx=_ SORA}', "");
    Expect(0, 69881, '\p{^Scx=_ SORA}', "");
    Expect(0, 69881, '\P{Scx=_ SORA}', "");
    Expect(1, 69881, '\P{^Scx=_ SORA}', "");
    Expect(0, 69882, '\p{Scx=_ SORA}', "");
    Expect(1, 69882, '\p{^Scx=_ SORA}', "");
    Expect(1, 69882, '\P{Scx=_ SORA}', "");
    Expect(0, 69882, '\P{^Scx=_ SORA}', "");
    Error('\p{Is_Script_Extensions=:=-_Sora_Sompeng}');
    Error('\P{Is_Script_Extensions=:=-_Sora_Sompeng}');
    Expect(1, 69881, '\p{Is_Script_Extensions=sorasompeng}', "");
    Expect(0, 69881, '\p{^Is_Script_Extensions=sorasompeng}', "");
    Expect(0, 69881, '\P{Is_Script_Extensions=sorasompeng}', "");
    Expect(1, 69881, '\P{^Is_Script_Extensions=sorasompeng}', "");
    Expect(0, 69882, '\p{Is_Script_Extensions=sorasompeng}', "");
    Expect(1, 69882, '\p{^Is_Script_Extensions=sorasompeng}', "");
    Expect(1, 69882, '\P{Is_Script_Extensions=sorasompeng}', "");
    Expect(0, 69882, '\P{^Is_Script_Extensions=sorasompeng}', "");
    Expect(1, 69881, '\p{Is_Script_Extensions=		SORA_SOMPENG}', "");
    Expect(0, 69881, '\p{^Is_Script_Extensions=		SORA_SOMPENG}', "");
    Expect(0, 69881, '\P{Is_Script_Extensions=		SORA_SOMPENG}', "");
    Expect(1, 69881, '\P{^Is_Script_Extensions=		SORA_SOMPENG}', "");
    Expect(0, 69882, '\p{Is_Script_Extensions=		SORA_SOMPENG}', "");
    Expect(1, 69882, '\p{^Is_Script_Extensions=		SORA_SOMPENG}', "");
    Expect(1, 69882, '\P{Is_Script_Extensions=		SORA_SOMPENG}', "");
    Expect(0, 69882, '\P{^Is_Script_Extensions=		SORA_SOMPENG}', "");
    Error('\p{Is_Scx=_sora/a/}');
    Error('\P{Is_Scx=_sora/a/}');
    Expect(1, 69881, '\p{Is_Scx:	sora}', "");
    Expect(0, 69881, '\p{^Is_Scx:	sora}', "");
    Expect(0, 69881, '\P{Is_Scx:	sora}', "");
    Expect(1, 69881, '\P{^Is_Scx:	sora}', "");
    Expect(0, 69882, '\p{Is_Scx:	sora}', "");
    Expect(1, 69882, '\p{^Is_Scx:	sora}', "");
    Expect(1, 69882, '\P{Is_Scx:	sora}', "");
    Expect(0, 69882, '\P{^Is_Scx:	sora}', "");
    Expect(1, 69881, '\p{Is_Scx=- Sora}', "");
    Expect(0, 69881, '\p{^Is_Scx=- Sora}', "");
    Expect(0, 69881, '\P{Is_Scx=- Sora}', "");
    Expect(1, 69881, '\P{^Is_Scx=- Sora}', "");
    Expect(0, 69882, '\p{Is_Scx=- Sora}', "");
    Expect(1, 69882, '\p{^Is_Scx=- Sora}', "");
    Expect(1, 69882, '\P{Is_Scx=- Sora}', "");
    Expect(0, 69882, '\P{^Is_Scx=- Sora}', "");
    Error('\p{Script_Extensions=/a/	-soyombo}');
    Error('\P{Script_Extensions=/a/	-soyombo}');
    Expect(1, 72354, '\p{Script_Extensions=:\ASoyombo\z:}', "");;
    Expect(0, 72355, '\p{Script_Extensions=:\ASoyombo\z:}', "");;
    Expect(1, 72354, '\p{Script_Extensions:	soyombo}', "");
    Expect(0, 72354, '\p{^Script_Extensions:	soyombo}', "");
    Expect(0, 72354, '\P{Script_Extensions:	soyombo}', "");
    Expect(1, 72354, '\P{^Script_Extensions:	soyombo}', "");
    Expect(0, 72355, '\p{Script_Extensions:	soyombo}', "");
    Expect(1, 72355, '\p{^Script_Extensions:	soyombo}', "");
    Expect(1, 72355, '\P{Script_Extensions:	soyombo}', "");
    Expect(0, 72355, '\P{^Script_Extensions:	soyombo}', "");
    Expect(1, 72354, '\p{Script_Extensions=:\Asoyombo\z:}', "");;
    Expect(0, 72355, '\p{Script_Extensions=:\Asoyombo\z:}', "");;
    Expect(1, 72354, '\p{Script_Extensions=	soyombo}', "");
    Expect(0, 72354, '\p{^Script_Extensions=	soyombo}', "");
    Expect(0, 72354, '\P{Script_Extensions=	soyombo}', "");
    Expect(1, 72354, '\P{^Script_Extensions=	soyombo}', "");
    Expect(0, 72355, '\p{Script_Extensions=	soyombo}', "");
    Expect(1, 72355, '\p{^Script_Extensions=	soyombo}', "");
    Expect(1, 72355, '\P{Script_Extensions=	soyombo}', "");
    Expect(0, 72355, '\P{^Script_Extensions=	soyombo}', "");
    Error('\p{Scx=/a/_ Soyo}');
    Error('\P{Scx=/a/_ Soyo}');
    Expect(1, 72354, '\p{Scx=:\ASoyo\z:}', "");;
    Expect(0, 72355, '\p{Scx=:\ASoyo\z:}', "");;
    Expect(1, 72354, '\p{Scx=soyo}', "");
    Expect(0, 72354, '\p{^Scx=soyo}', "");
    Expect(0, 72354, '\P{Scx=soyo}', "");
    Expect(1, 72354, '\P{^Scx=soyo}', "");
    Expect(0, 72355, '\p{Scx=soyo}', "");
    Expect(1, 72355, '\p{^Scx=soyo}', "");
    Expect(1, 72355, '\P{Scx=soyo}', "");
    Expect(0, 72355, '\P{^Scx=soyo}', "");
    Expect(1, 72354, '\p{Scx=:\Asoyo\z:}', "");;
    Expect(0, 72355, '\p{Scx=:\Asoyo\z:}', "");;
    Expect(1, 72354, '\p{Scx=	-Soyo}', "");
    Expect(0, 72354, '\p{^Scx=	-Soyo}', "");
    Expect(0, 72354, '\P{Scx=	-Soyo}', "");
    Expect(1, 72354, '\P{^Scx=	-Soyo}', "");
    Expect(0, 72355, '\p{Scx=	-Soyo}', "");
    Expect(1, 72355, '\p{^Scx=	-Soyo}', "");
    Expect(1, 72355, '\P{Scx=	-Soyo}', "");
    Expect(0, 72355, '\P{^Scx=	-Soyo}', "");
    Error('\p{Is_Script_Extensions=/a/ -Soyombo}');
    Error('\P{Is_Script_Extensions=/a/ -Soyombo}');
    Expect(1, 72354, '\p{Is_Script_Extensions=soyombo}', "");
    Expect(0, 72354, '\p{^Is_Script_Extensions=soyombo}', "");
    Expect(0, 72354, '\P{Is_Script_Extensions=soyombo}', "");
    Expect(1, 72354, '\P{^Is_Script_Extensions=soyombo}', "");
    Expect(0, 72355, '\p{Is_Script_Extensions=soyombo}', "");
    Expect(1, 72355, '\p{^Is_Script_Extensions=soyombo}', "");
    Expect(1, 72355, '\P{Is_Script_Extensions=soyombo}', "");
    Expect(0, 72355, '\P{^Is_Script_Extensions=soyombo}', "");
    Expect(1, 72354, '\p{Is_Script_Extensions=		soyombo}', "");
    Expect(0, 72354, '\p{^Is_Script_Extensions=		soyombo}', "");
    Expect(0, 72354, '\P{Is_Script_Extensions=		soyombo}', "");
    Expect(1, 72354, '\P{^Is_Script_Extensions=		soyombo}', "");
    Expect(0, 72355, '\p{Is_Script_Extensions=		soyombo}', "");
    Expect(1, 72355, '\p{^Is_Script_Extensions=		soyombo}', "");
    Expect(1, 72355, '\P{Is_Script_Extensions=		soyombo}', "");
    Expect(0, 72355, '\P{^Is_Script_Extensions=		soyombo}', "");
    Error('\p{Is_Scx:	 /a/SOYO}');
    Error('\P{Is_Scx:	 /a/SOYO}');
    Expect(1, 72354, '\p{Is_Scx:	soyo}', "");
    Expect(0, 72354, '\p{^Is_Scx:	soyo}', "");
    Expect(0, 72354, '\P{Is_Scx:	soyo}', "");
    Expect(1, 72354, '\P{^Is_Scx:	soyo}', "");
    Expect(0, 72355, '\p{Is_Scx:	soyo}', "");
    Expect(1, 72355, '\p{^Is_Scx:	soyo}', "");
    Expect(1, 72355, '\P{Is_Scx:	soyo}', "");
    Expect(0, 72355, '\P{^Is_Scx:	soyo}', "");
    Expect(1, 72354, '\p{Is_Scx:	-Soyo}', "");
    Expect(0, 72354, '\p{^Is_Scx:	-Soyo}', "");
    Expect(0, 72354, '\P{Is_Scx:	-Soyo}', "");
    Expect(1, 72354, '\P{^Is_Scx:	-Soyo}', "");
    Expect(0, 72355, '\p{Is_Scx:	-Soyo}', "");
    Expect(1, 72355, '\p{^Is_Scx:	-Soyo}', "");
    Expect(1, 72355, '\P{Is_Scx:	-Soyo}', "");
    Expect(0, 72355, '\P{^Is_Scx:	-Soyo}', "");
    Error('\p{Script_Extensions=/a/Sundanese}');
    Error('\P{Script_Extensions=/a/Sundanese}');
    Expect(1, 7367, '\p{Script_Extensions=:\ASundanese\z:}', "");;
    Expect(0, 7368, '\p{Script_Extensions=:\ASundanese\z:}', "");;
    Expect(1, 7367, '\p{Script_Extensions=sundanese}', "");
    Expect(0, 7367, '\p{^Script_Extensions=sundanese}', "");
    Expect(0, 7367, '\P{Script_Extensions=sundanese}', "");
    Expect(1, 7367, '\P{^Script_Extensions=sundanese}', "");
    Expect(0, 7368, '\p{Script_Extensions=sundanese}', "");
    Expect(1, 7368, '\p{^Script_Extensions=sundanese}', "");
    Expect(1, 7368, '\P{Script_Extensions=sundanese}', "");
    Expect(0, 7368, '\P{^Script_Extensions=sundanese}', "");
    Expect(1, 7367, '\p{Script_Extensions=:\Asundanese\z:}', "");;
    Expect(0, 7368, '\p{Script_Extensions=:\Asundanese\z:}', "");;
    Expect(1, 7367, '\p{Script_Extensions=	-Sundanese}', "");
    Expect(0, 7367, '\p{^Script_Extensions=	-Sundanese}', "");
    Expect(0, 7367, '\P{Script_Extensions=	-Sundanese}', "");
    Expect(1, 7367, '\P{^Script_Extensions=	-Sundanese}', "");
    Expect(0, 7368, '\p{Script_Extensions=	-Sundanese}', "");
    Expect(1, 7368, '\p{^Script_Extensions=	-Sundanese}', "");
    Expect(1, 7368, '\P{Script_Extensions=	-Sundanese}', "");
    Expect(0, 7368, '\P{^Script_Extensions=	-Sundanese}', "");
    Error('\p{Scx=:=	sund}');
    Error('\P{Scx=:=	sund}');
    Expect(1, 7367, '\p{Scx=:\ASund\z:}', "");;
    Expect(0, 7368, '\p{Scx=:\ASund\z:}', "");;
    Expect(1, 7367, '\p{Scx=sund}', "");
    Expect(0, 7367, '\p{^Scx=sund}', "");
    Expect(0, 7367, '\P{Scx=sund}', "");
    Expect(1, 7367, '\P{^Scx=sund}', "");
    Expect(0, 7368, '\p{Scx=sund}', "");
    Expect(1, 7368, '\p{^Scx=sund}', "");
    Expect(1, 7368, '\P{Scx=sund}', "");
    Expect(0, 7368, '\P{^Scx=sund}', "");
    Expect(1, 7367, '\p{Scx=:\Asund\z:}', "");;
    Expect(0, 7368, '\p{Scx=:\Asund\z:}', "");;
    Expect(1, 7367, '\p{Scx:		-sund}', "");
    Expect(0, 7367, '\p{^Scx:		-sund}', "");
    Expect(0, 7367, '\P{Scx:		-sund}', "");
    Expect(1, 7367, '\P{^Scx:		-sund}', "");
    Expect(0, 7368, '\p{Scx:		-sund}', "");
    Expect(1, 7368, '\p{^Scx:		-sund}', "");
    Expect(1, 7368, '\P{Scx:		-sund}', "");
    Expect(0, 7368, '\P{^Scx:		-sund}', "");
    Error('\p{Is_Script_Extensions= -sundanese/a/}');
    Error('\P{Is_Script_Extensions= -sundanese/a/}');
    Expect(1, 7367, '\p{Is_Script_Extensions=sundanese}', "");
    Expect(0, 7367, '\p{^Is_Script_Extensions=sundanese}', "");
    Expect(0, 7367, '\P{Is_Script_Extensions=sundanese}', "");
    Expect(1, 7367, '\P{^Is_Script_Extensions=sundanese}', "");
    Expect(0, 7368, '\p{Is_Script_Extensions=sundanese}', "");
    Expect(1, 7368, '\p{^Is_Script_Extensions=sundanese}', "");
    Expect(1, 7368, '\P{Is_Script_Extensions=sundanese}', "");
    Expect(0, 7368, '\P{^Is_Script_Extensions=sundanese}', "");
    Expect(1, 7367, '\p{Is_Script_Extensions= Sundanese}', "");
    Expect(0, 7367, '\p{^Is_Script_Extensions= Sundanese}', "");
    Expect(0, 7367, '\P{Is_Script_Extensions= Sundanese}', "");
    Expect(1, 7367, '\P{^Is_Script_Extensions= Sundanese}', "");
    Expect(0, 7368, '\p{Is_Script_Extensions= Sundanese}', "");
    Expect(1, 7368, '\p{^Is_Script_Extensions= Sundanese}', "");
    Expect(1, 7368, '\P{Is_Script_Extensions= Sundanese}', "");
    Expect(0, 7368, '\P{^Is_Script_Extensions= Sundanese}', "");
    Error('\p{Is_Scx=_:=Sund}');
    Error('\P{Is_Scx=_:=Sund}');
    Expect(1, 7367, '\p{Is_Scx=sund}', "");
    Expect(0, 7367, '\p{^Is_Scx=sund}', "");
    Expect(0, 7367, '\P{Is_Scx=sund}', "");
    Expect(1, 7367, '\P{^Is_Scx=sund}', "");
    Expect(0, 7368, '\p{Is_Scx=sund}', "");
    Expect(1, 7368, '\p{^Is_Scx=sund}', "");
    Expect(1, 7368, '\P{Is_Scx=sund}', "");
    Expect(0, 7368, '\P{^Is_Scx=sund}', "");
    Expect(1, 7367, '\p{Is_Scx= Sund}', "");
    Expect(0, 7367, '\p{^Is_Scx= Sund}', "");
    Expect(0, 7367, '\P{Is_Scx= Sund}', "");
    Expect(1, 7367, '\P{^Is_Scx= Sund}', "");
    Expect(0, 7368, '\p{Is_Scx= Sund}', "");
    Expect(1, 7368, '\p{^Is_Scx= Sund}', "");
    Expect(1, 7368, '\P{Is_Scx= Sund}', "");
    Expect(0, 7368, '\P{^Is_Scx= Sund}', "");
    Error('\p{Script_Extensions=-:=SYLOTI_nagri}');
    Error('\P{Script_Extensions=-:=SYLOTI_nagri}');
    Expect(1, 43052, '\p{Script_Extensions=:\ASyloti_Nagri\z:}', "");;
    Expect(0, 43053, '\p{Script_Extensions=:\ASyloti_Nagri\z:}', "");;
    Expect(1, 43052, '\p{Script_Extensions=sylotinagri}', "");
    Expect(0, 43052, '\p{^Script_Extensions=sylotinagri}', "");
    Expect(0, 43052, '\P{Script_Extensions=sylotinagri}', "");
    Expect(1, 43052, '\P{^Script_Extensions=sylotinagri}', "");
    Expect(0, 43053, '\p{Script_Extensions=sylotinagri}', "");
    Expect(1, 43053, '\p{^Script_Extensions=sylotinagri}', "");
    Expect(1, 43053, '\P{Script_Extensions=sylotinagri}', "");
    Expect(0, 43053, '\P{^Script_Extensions=sylotinagri}', "");
    Expect(1, 43052, '\p{Script_Extensions=:\Asylotinagri\z:}', "");;
    Expect(0, 43053, '\p{Script_Extensions=:\Asylotinagri\z:}', "");;
    Expect(1, 43052, '\p{Script_Extensions:   -	Syloti_Nagri}', "");
    Expect(0, 43052, '\p{^Script_Extensions:   -	Syloti_Nagri}', "");
    Expect(0, 43052, '\P{Script_Extensions:   -	Syloti_Nagri}', "");
    Expect(1, 43052, '\P{^Script_Extensions:   -	Syloti_Nagri}', "");
    Expect(0, 43053, '\p{Script_Extensions:   -	Syloti_Nagri}', "");
    Expect(1, 43053, '\p{^Script_Extensions:   -	Syloti_Nagri}', "");
    Expect(1, 43053, '\P{Script_Extensions:   -	Syloti_Nagri}', "");
    Expect(0, 43053, '\P{^Script_Extensions:   -	Syloti_Nagri}', "");
    Error('\p{Scx= /a/SYLO}');
    Error('\P{Scx= /a/SYLO}');
    Expect(1, 43052, '\p{Scx=:\ASylo\z:}', "");;
    Expect(0, 43053, '\p{Scx=:\ASylo\z:}', "");;
    Expect(1, 43052, '\p{Scx:	sylo}', "");
    Expect(0, 43052, '\p{^Scx:	sylo}', "");
    Expect(0, 43052, '\P{Scx:	sylo}', "");
    Expect(1, 43052, '\P{^Scx:	sylo}', "");
    Expect(0, 43053, '\p{Scx:	sylo}', "");
    Expect(1, 43053, '\p{^Scx:	sylo}', "");
    Expect(1, 43053, '\P{Scx:	sylo}', "");
    Expect(0, 43053, '\P{^Scx:	sylo}', "");
    Expect(1, 43052, '\p{Scx=:\Asylo\z:}', "");;
    Expect(0, 43053, '\p{Scx=:\Asylo\z:}', "");;
    Expect(1, 43052, '\p{Scx=__Sylo}', "");
    Expect(0, 43052, '\p{^Scx=__Sylo}', "");
    Expect(0, 43052, '\P{Scx=__Sylo}', "");
    Expect(1, 43052, '\P{^Scx=__Sylo}', "");
    Expect(0, 43053, '\p{Scx=__Sylo}', "");
    Expect(1, 43053, '\p{^Scx=__Sylo}', "");
    Expect(1, 43053, '\P{Scx=__Sylo}', "");
    Expect(0, 43053, '\P{^Scx=__Sylo}', "");
    Error('\p{Is_Script_Extensions=	syloti_NAGRI/a/}');
    Error('\P{Is_Script_Extensions=	syloti_NAGRI/a/}');
    Expect(1, 43052, '\p{Is_Script_Extensions=sylotinagri}', "");
    Expect(0, 43052, '\p{^Is_Script_Extensions=sylotinagri}', "");
    Expect(0, 43052, '\P{Is_Script_Extensions=sylotinagri}', "");
    Expect(1, 43052, '\P{^Is_Script_Extensions=sylotinagri}', "");
    Expect(0, 43053, '\p{Is_Script_Extensions=sylotinagri}', "");
    Expect(1, 43053, '\p{^Is_Script_Extensions=sylotinagri}', "");
    Expect(1, 43053, '\P{Is_Script_Extensions=sylotinagri}', "");
    Expect(0, 43053, '\P{^Is_Script_Extensions=sylotinagri}', "");
    Expect(1, 43052, '\p{Is_Script_Extensions= Syloti_Nagri}', "");
    Expect(0, 43052, '\p{^Is_Script_Extensions= Syloti_Nagri}', "");
    Expect(0, 43052, '\P{Is_Script_Extensions= Syloti_Nagri}', "");
    Expect(1, 43052, '\P{^Is_Script_Extensions= Syloti_Nagri}', "");
    Expect(0, 43053, '\p{Is_Script_Extensions= Syloti_Nagri}', "");
    Expect(1, 43053, '\p{^Is_Script_Extensions= Syloti_Nagri}', "");
    Expect(1, 43053, '\P{Is_Script_Extensions= Syloti_Nagri}', "");
    Expect(0, 43053, '\P{^Is_Script_Extensions= Syloti_Nagri}', "");
    Error('\p{Is_Scx=/a/ Sylo}');
    Error('\P{Is_Scx=/a/ Sylo}');
    Expect(1, 43052, '\p{Is_Scx=sylo}', "");
    Expect(0, 43052, '\p{^Is_Scx=sylo}', "");
    Expect(0, 43052, '\P{Is_Scx=sylo}', "");
    Expect(1, 43052, '\P{^Is_Scx=sylo}', "");
    Expect(0, 43053, '\p{Is_Scx=sylo}', "");
    Expect(1, 43053, '\p{^Is_Scx=sylo}', "");
    Expect(1, 43053, '\P{Is_Scx=sylo}', "");
    Expect(0, 43053, '\P{^Is_Scx=sylo}', "");
    Expect(1, 43052, '\p{Is_Scx:_sylo}', "");
    Expect(0, 43052, '\p{^Is_Scx:_sylo}', "");
    Expect(0, 43052, '\P{Is_Scx:_sylo}', "");
    Expect(1, 43052, '\P{^Is_Scx:_sylo}', "");
    Expect(0, 43053, '\p{Is_Scx:_sylo}', "");
    Expect(1, 43053, '\p{^Is_Scx:_sylo}', "");
    Expect(1, 43053, '\P{Is_Scx:_sylo}', "");
    Expect(0, 43053, '\P{^Is_Scx:_sylo}', "");
    Error('\p{Script_Extensions=-Syriac/a/}');
    Error('\P{Script_Extensions=-Syriac/a/}');
    Expect(1, 7674, '\p{Script_Extensions=:\ASyriac\z:}', "");;
    Expect(0, 7675, '\p{Script_Extensions=:\ASyriac\z:}', "");;
    Expect(1, 7674, '\p{Script_Extensions=syriac}', "");
    Expect(0, 7674, '\p{^Script_Extensions=syriac}', "");
    Expect(0, 7674, '\P{Script_Extensions=syriac}', "");
    Expect(1, 7674, '\P{^Script_Extensions=syriac}', "");
    Expect(0, 7675, '\p{Script_Extensions=syriac}', "");
    Expect(1, 7675, '\p{^Script_Extensions=syriac}', "");
    Expect(1, 7675, '\P{Script_Extensions=syriac}', "");
    Expect(0, 7675, '\P{^Script_Extensions=syriac}', "");
    Expect(1, 7674, '\p{Script_Extensions=:\Asyriac\z:}', "");;
    Expect(0, 7675, '\p{Script_Extensions=:\Asyriac\z:}', "");;
    Expect(1, 7674, '\p{Script_Extensions=__Syriac}', "");
    Expect(0, 7674, '\p{^Script_Extensions=__Syriac}', "");
    Expect(0, 7674, '\P{Script_Extensions=__Syriac}', "");
    Expect(1, 7674, '\P{^Script_Extensions=__Syriac}', "");
    Expect(0, 7675, '\p{Script_Extensions=__Syriac}', "");
    Expect(1, 7675, '\p{^Script_Extensions=__Syriac}', "");
    Expect(1, 7675, '\P{Script_Extensions=__Syriac}', "");
    Expect(0, 7675, '\P{^Script_Extensions=__Syriac}', "");
    Error('\p{Scx=/a/	-SYRC}');
    Error('\P{Scx=/a/	-SYRC}');
    Expect(1, 7674, '\p{Scx=:\ASyrc\z:}', "");;
    Expect(0, 7675, '\p{Scx=:\ASyrc\z:}', "");;
    Expect(1, 7674, '\p{Scx=syrc}', "");
    Expect(0, 7674, '\p{^Scx=syrc}', "");
    Expect(0, 7674, '\P{Scx=syrc}', "");
    Expect(1, 7674, '\P{^Scx=syrc}', "");
    Expect(0, 7675, '\p{Scx=syrc}', "");
    Expect(1, 7675, '\p{^Scx=syrc}', "");
    Expect(1, 7675, '\P{Scx=syrc}', "");
    Expect(0, 7675, '\P{^Scx=syrc}', "");
    Expect(1, 7674, '\p{Scx=:\Asyrc\z:}', "");;
    Expect(0, 7675, '\p{Scx=:\Asyrc\z:}', "");;
    Expect(1, 7674, '\p{Scx=-syrc}', "");
    Expect(0, 7674, '\p{^Scx=-syrc}', "");
    Expect(0, 7674, '\P{Scx=-syrc}', "");
    Expect(1, 7674, '\P{^Scx=-syrc}', "");
    Expect(0, 7675, '\p{Scx=-syrc}', "");
    Expect(1, 7675, '\p{^Scx=-syrc}', "");
    Expect(1, 7675, '\P{Scx=-syrc}', "");
    Expect(0, 7675, '\P{^Scx=-syrc}', "");
    Error('\p{Is_Script_Extensions=/a/Syriac}');
    Error('\P{Is_Script_Extensions=/a/Syriac}');
    Expect(1, 7674, '\p{Is_Script_Extensions=syriac}', "");
    Expect(0, 7674, '\p{^Is_Script_Extensions=syriac}', "");
    Expect(0, 7674, '\P{Is_Script_Extensions=syriac}', "");
    Expect(1, 7674, '\P{^Is_Script_Extensions=syriac}', "");
    Expect(0, 7675, '\p{Is_Script_Extensions=syriac}', "");
    Expect(1, 7675, '\p{^Is_Script_Extensions=syriac}', "");
    Expect(1, 7675, '\P{Is_Script_Extensions=syriac}', "");
    Expect(0, 7675, '\P{^Is_Script_Extensions=syriac}', "");
    Expect(1, 7674, '\p{Is_Script_Extensions=- Syriac}', "");
    Expect(0, 7674, '\p{^Is_Script_Extensions=- Syriac}', "");
    Expect(0, 7674, '\P{Is_Script_Extensions=- Syriac}', "");
    Expect(1, 7674, '\P{^Is_Script_Extensions=- Syriac}', "");
    Expect(0, 7675, '\p{Is_Script_Extensions=- Syriac}', "");
    Expect(1, 7675, '\p{^Is_Script_Extensions=- Syriac}', "");
    Expect(1, 7675, '\P{Is_Script_Extensions=- Syriac}', "");
    Expect(0, 7675, '\P{^Is_Script_Extensions=- Syriac}', "");
    Error('\p{Is_Scx=:=Syrc}');
    Error('\P{Is_Scx=:=Syrc}');
    Expect(1, 7674, '\p{Is_Scx=syrc}', "");
    Expect(0, 7674, '\p{^Is_Scx=syrc}', "");
    Expect(0, 7674, '\P{Is_Scx=syrc}', "");
    Expect(1, 7674, '\P{^Is_Scx=syrc}', "");
    Expect(0, 7675, '\p{Is_Scx=syrc}', "");
    Expect(1, 7675, '\p{^Is_Scx=syrc}', "");
    Expect(1, 7675, '\P{Is_Scx=syrc}', "");
    Expect(0, 7675, '\P{^Is_Scx=syrc}', "");
    Expect(1, 7674, '\p{Is_Scx=SYRC}', "");
    Expect(0, 7674, '\p{^Is_Scx=SYRC}', "");
    Expect(0, 7674, '\P{Is_Scx=SYRC}', "");
    Expect(1, 7674, '\P{^Is_Scx=SYRC}', "");
    Expect(0, 7675, '\p{Is_Scx=SYRC}', "");
    Expect(1, 7675, '\p{^Is_Scx=SYRC}', "");
    Expect(1, 7675, '\P{Is_Scx=SYRC}', "");
    Expect(0, 7675, '\P{^Is_Scx=SYRC}', "");
    Error('\p{Script_Extensions=_Tagbanwa/a/}');
    Error('\P{Script_Extensions=_Tagbanwa/a/}');
    Expect(1, 6003, '\p{Script_Extensions=:\ATagbanwa\z:}', "");;
    Expect(0, 6004, '\p{Script_Extensions=:\ATagbanwa\z:}', "");;
    Expect(1, 6003, '\p{Script_Extensions=tagbanwa}', "");
    Expect(0, 6003, '\p{^Script_Extensions=tagbanwa}', "");
    Expect(0, 6003, '\P{Script_Extensions=tagbanwa}', "");
    Expect(1, 6003, '\P{^Script_Extensions=tagbanwa}', "");
    Expect(0, 6004, '\p{Script_Extensions=tagbanwa}', "");
    Expect(1, 6004, '\p{^Script_Extensions=tagbanwa}', "");
    Expect(1, 6004, '\P{Script_Extensions=tagbanwa}', "");
    Expect(0, 6004, '\P{^Script_Extensions=tagbanwa}', "");
    Expect(1, 6003, '\p{Script_Extensions=:\Atagbanwa\z:}', "");;
    Expect(0, 6004, '\p{Script_Extensions=:\Atagbanwa\z:}', "");;
    Expect(1, 6003, '\p{Script_Extensions=-	TAGBANWA}', "");
    Expect(0, 6003, '\p{^Script_Extensions=-	TAGBANWA}', "");
    Expect(0, 6003, '\P{Script_Extensions=-	TAGBANWA}', "");
    Expect(1, 6003, '\P{^Script_Extensions=-	TAGBANWA}', "");
    Expect(0, 6004, '\p{Script_Extensions=-	TAGBANWA}', "");
    Expect(1, 6004, '\p{^Script_Extensions=-	TAGBANWA}', "");
    Expect(1, 6004, '\P{Script_Extensions=-	TAGBANWA}', "");
    Expect(0, 6004, '\P{^Script_Extensions=-	TAGBANWA}', "");
    Error('\p{Scx=-	tagb:=}');
    Error('\P{Scx=-	tagb:=}');
    Expect(1, 6003, '\p{Scx=:\ATagb\z:}', "");;
    Expect(0, 6004, '\p{Scx=:\ATagb\z:}', "");;
    Expect(1, 6003, '\p{Scx=tagb}', "");
    Expect(0, 6003, '\p{^Scx=tagb}', "");
    Expect(0, 6003, '\P{Scx=tagb}', "");
    Expect(1, 6003, '\P{^Scx=tagb}', "");
    Expect(0, 6004, '\p{Scx=tagb}', "");
    Expect(1, 6004, '\p{^Scx=tagb}', "");
    Expect(1, 6004, '\P{Scx=tagb}', "");
    Expect(0, 6004, '\P{^Scx=tagb}', "");
    Expect(1, 6003, '\p{Scx=:\Atagb\z:}', "");;
    Expect(0, 6004, '\p{Scx=:\Atagb\z:}', "");;
    Expect(1, 6003, '\p{Scx=-	Tagb}', "");
    Expect(0, 6003, '\p{^Scx=-	Tagb}', "");
    Expect(0, 6003, '\P{Scx=-	Tagb}', "");
    Expect(1, 6003, '\P{^Scx=-	Tagb}', "");
    Expect(0, 6004, '\p{Scx=-	Tagb}', "");
    Expect(1, 6004, '\p{^Scx=-	Tagb}', "");
    Expect(1, 6004, '\P{Scx=-	Tagb}', "");
    Expect(0, 6004, '\P{^Scx=-	Tagb}', "");
    Error('\p{Is_Script_Extensions=_-Tagbanwa:=}');
    Error('\P{Is_Script_Extensions=_-Tagbanwa:=}');
    Expect(1, 6003, '\p{Is_Script_Extensions=tagbanwa}', "");
    Expect(0, 6003, '\p{^Is_Script_Extensions=tagbanwa}', "");
    Expect(0, 6003, '\P{Is_Script_Extensions=tagbanwa}', "");
    Expect(1, 6003, '\P{^Is_Script_Extensions=tagbanwa}', "");
    Expect(0, 6004, '\p{Is_Script_Extensions=tagbanwa}', "");
    Expect(1, 6004, '\p{^Is_Script_Extensions=tagbanwa}', "");
    Expect(1, 6004, '\P{Is_Script_Extensions=tagbanwa}', "");
    Expect(0, 6004, '\P{^Is_Script_Extensions=tagbanwa}', "");
    Expect(1, 6003, '\p{Is_Script_Extensions=_-TAGBANWA}', "");
    Expect(0, 6003, '\p{^Is_Script_Extensions=_-TAGBANWA}', "");
    Expect(0, 6003, '\P{Is_Script_Extensions=_-TAGBANWA}', "");
    Expect(1, 6003, '\P{^Is_Script_Extensions=_-TAGBANWA}', "");
    Expect(0, 6004, '\p{Is_Script_Extensions=_-TAGBANWA}', "");
    Expect(1, 6004, '\p{^Is_Script_Extensions=_-TAGBANWA}', "");
    Expect(1, 6004, '\P{Is_Script_Extensions=_-TAGBANWA}', "");
    Expect(0, 6004, '\P{^Is_Script_Extensions=_-TAGBANWA}', "");
    Error('\p{Is_Scx= :=Tagb}');
    Error('\P{Is_Scx= :=Tagb}');
    Expect(1, 6003, '\p{Is_Scx=tagb}', "");
    Expect(0, 6003, '\p{^Is_Scx=tagb}', "");
    Expect(0, 6003, '\P{Is_Scx=tagb}', "");
    Expect(1, 6003, '\P{^Is_Scx=tagb}', "");
    Expect(0, 6004, '\p{Is_Scx=tagb}', "");
    Expect(1, 6004, '\p{^Is_Scx=tagb}', "");
    Expect(1, 6004, '\P{Is_Scx=tagb}', "");
    Expect(0, 6004, '\P{^Is_Scx=tagb}', "");
    Expect(1, 6003, '\p{Is_Scx=-TAGB}', "");
    Expect(0, 6003, '\p{^Is_Scx=-TAGB}', "");
    Expect(0, 6003, '\P{Is_Scx=-TAGB}', "");
    Expect(1, 6003, '\P{^Is_Scx=-TAGB}', "");
    Expect(0, 6004, '\p{Is_Scx=-TAGB}', "");
    Expect(1, 6004, '\p{^Is_Scx=-TAGB}', "");
    Expect(1, 6004, '\P{Is_Scx=-TAGB}', "");
    Expect(0, 6004, '\P{^Is_Scx=-TAGB}', "");
    Error('\p{Script_Extensions=:= TAKRI}');
    Error('\P{Script_Extensions=:= TAKRI}');
    Expect(1, 71369, '\p{Script_Extensions=:\ATakri\z:}', "");;
    Expect(0, 71370, '\p{Script_Extensions=:\ATakri\z:}', "");;
    Expect(1, 71369, '\p{Script_Extensions=takri}', "");
    Expect(0, 71369, '\p{^Script_Extensions=takri}', "");
    Expect(0, 71369, '\P{Script_Extensions=takri}', "");
    Expect(1, 71369, '\P{^Script_Extensions=takri}', "");
    Expect(0, 71370, '\p{Script_Extensions=takri}', "");
    Expect(1, 71370, '\p{^Script_Extensions=takri}', "");
    Expect(1, 71370, '\P{Script_Extensions=takri}', "");
    Expect(0, 71370, '\P{^Script_Extensions=takri}', "");
    Expect(1, 71369, '\p{Script_Extensions=:\Atakri\z:}', "");;
    Expect(0, 71370, '\p{Script_Extensions=:\Atakri\z:}', "");;
    Expect(1, 71369, '\p{Script_Extensions=-_takri}', "");
    Expect(0, 71369, '\p{^Script_Extensions=-_takri}', "");
    Expect(0, 71369, '\P{Script_Extensions=-_takri}', "");
    Expect(1, 71369, '\P{^Script_Extensions=-_takri}', "");
    Expect(0, 71370, '\p{Script_Extensions=-_takri}', "");
    Expect(1, 71370, '\p{^Script_Extensions=-_takri}', "");
    Expect(1, 71370, '\P{Script_Extensions=-_takri}', "");
    Expect(0, 71370, '\P{^Script_Extensions=-_takri}', "");
    Error('\p{Scx=:= Takr}');
    Error('\P{Scx=:= Takr}');
    Expect(1, 71369, '\p{Scx=:\ATakr\z:}', "");;
    Expect(0, 71370, '\p{Scx=:\ATakr\z:}', "");;
    Expect(1, 71369, '\p{Scx:	takr}', "");
    Expect(0, 71369, '\p{^Scx:	takr}', "");
    Expect(0, 71369, '\P{Scx:	takr}', "");
    Expect(1, 71369, '\P{^Scx:	takr}', "");
    Expect(0, 71370, '\p{Scx:	takr}', "");
    Expect(1, 71370, '\p{^Scx:	takr}', "");
    Expect(1, 71370, '\P{Scx:	takr}', "");
    Expect(0, 71370, '\P{^Scx:	takr}', "");
    Expect(1, 71369, '\p{Scx=:\Atakr\z:}', "");;
    Expect(0, 71370, '\p{Scx=:\Atakr\z:}', "");;
    Expect(1, 71369, '\p{Scx=_	Takr}', "");
    Expect(0, 71369, '\p{^Scx=_	Takr}', "");
    Expect(0, 71369, '\P{Scx=_	Takr}', "");
    Expect(1, 71369, '\P{^Scx=_	Takr}', "");
    Expect(0, 71370, '\p{Scx=_	Takr}', "");
    Expect(1, 71370, '\p{^Scx=_	Takr}', "");
    Expect(1, 71370, '\P{Scx=_	Takr}', "");
    Expect(0, 71370, '\P{^Scx=_	Takr}', "");
    Error('\p{Is_Script_Extensions=--TAKRI/a/}');
    Error('\P{Is_Script_Extensions=--TAKRI/a/}');
    Expect(1, 71369, '\p{Is_Script_Extensions=takri}', "");
    Expect(0, 71369, '\p{^Is_Script_Extensions=takri}', "");
    Expect(0, 71369, '\P{Is_Script_Extensions=takri}', "");
    Expect(1, 71369, '\P{^Is_Script_Extensions=takri}', "");
    Expect(0, 71370, '\p{Is_Script_Extensions=takri}', "");
    Expect(1, 71370, '\p{^Is_Script_Extensions=takri}', "");
    Expect(1, 71370, '\P{Is_Script_Extensions=takri}', "");
    Expect(0, 71370, '\P{^Is_Script_Extensions=takri}', "");
    Expect(1, 71369, '\p{Is_Script_Extensions=-Takri}', "");
    Expect(0, 71369, '\p{^Is_Script_Extensions=-Takri}', "");
    Expect(0, 71369, '\P{Is_Script_Extensions=-Takri}', "");
    Expect(1, 71369, '\P{^Is_Script_Extensions=-Takri}', "");
    Expect(0, 71370, '\p{Is_Script_Extensions=-Takri}', "");
    Expect(1, 71370, '\p{^Is_Script_Extensions=-Takri}', "");
    Expect(1, 71370, '\P{Is_Script_Extensions=-Takri}', "");
    Expect(0, 71370, '\P{^Is_Script_Extensions=-Takri}', "");
    Error('\p{Is_Scx= :=Takr}');
    Error('\P{Is_Scx= :=Takr}');
    Expect(1, 71369, '\p{Is_Scx:	takr}', "");
    Expect(0, 71369, '\p{^Is_Scx:	takr}', "");
    Expect(0, 71369, '\P{Is_Scx:	takr}', "");
    Expect(1, 71369, '\P{^Is_Scx:	takr}', "");
    Expect(0, 71370, '\p{Is_Scx:	takr}', "");
    Expect(1, 71370, '\p{^Is_Scx:	takr}', "");
    Expect(1, 71370, '\P{Is_Scx:	takr}', "");
    Expect(0, 71370, '\P{^Is_Scx:	takr}', "");
    Expect(1, 71369, '\p{Is_Scx=-_Takr}', "");
    Expect(0, 71369, '\p{^Is_Scx=-_Takr}', "");
    Expect(0, 71369, '\P{Is_Scx=-_Takr}', "");
    Expect(1, 71369, '\P{^Is_Scx=-_Takr}', "");
    Expect(0, 71370, '\p{Is_Scx=-_Takr}', "");
    Expect(1, 71370, '\p{^Is_Scx=-_Takr}', "");
    Expect(1, 71370, '\P{Is_Scx=-_Takr}', "");
    Expect(0, 71370, '\P{^Is_Scx=-_Takr}', "");
    Error('\p{Script_Extensions=-tai_le/a/}');
    Error('\P{Script_Extensions=-tai_le/a/}');
    Expect(1, 6516, '\p{Script_Extensions=:\ATai_Le\z:}', "");;
    Expect(0, 6517, '\p{Script_Extensions=:\ATai_Le\z:}', "");;
    Expect(1, 6516, '\p{Script_Extensions=taile}', "");
    Expect(0, 6516, '\p{^Script_Extensions=taile}', "");
    Expect(0, 6516, '\P{Script_Extensions=taile}', "");
    Expect(1, 6516, '\P{^Script_Extensions=taile}', "");
    Expect(0, 6517, '\p{Script_Extensions=taile}', "");
    Expect(1, 6517, '\p{^Script_Extensions=taile}', "");
    Expect(1, 6517, '\P{Script_Extensions=taile}', "");
    Expect(0, 6517, '\P{^Script_Extensions=taile}', "");
    Expect(1, 6516, '\p{Script_Extensions=:\Ataile\z:}', "");;
    Expect(0, 6517, '\p{Script_Extensions=:\Ataile\z:}', "");;
    Expect(1, 6516, '\p{Script_Extensions=__TAI_Le}', "");
    Expect(0, 6516, '\p{^Script_Extensions=__TAI_Le}', "");
    Expect(0, 6516, '\P{Script_Extensions=__TAI_Le}', "");
    Expect(1, 6516, '\P{^Script_Extensions=__TAI_Le}', "");
    Expect(0, 6517, '\p{Script_Extensions=__TAI_Le}', "");
    Expect(1, 6517, '\p{^Script_Extensions=__TAI_Le}', "");
    Expect(1, 6517, '\P{Script_Extensions=__TAI_Le}', "");
    Expect(0, 6517, '\P{^Script_Extensions=__TAI_Le}', "");
    Error('\p{Scx=/a/Tale}');
    Error('\P{Scx=/a/Tale}');
    Expect(1, 6516, '\p{Scx=:\ATale\z:}', "");;
    Expect(0, 6517, '\p{Scx=:\ATale\z:}', "");;
    Expect(1, 6516, '\p{Scx=tale}', "");
    Expect(0, 6516, '\p{^Scx=tale}', "");
    Expect(0, 6516, '\P{Scx=tale}', "");
    Expect(1, 6516, '\P{^Scx=tale}', "");
    Expect(0, 6517, '\p{Scx=tale}', "");
    Expect(1, 6517, '\p{^Scx=tale}', "");
    Expect(1, 6517, '\P{Scx=tale}', "");
    Expect(0, 6517, '\P{^Scx=tale}', "");
    Expect(1, 6516, '\p{Scx=:\Atale\z:}', "");;
    Expect(0, 6517, '\p{Scx=:\Atale\z:}', "");;
    Expect(1, 6516, '\p{Scx:	--TALE}', "");
    Expect(0, 6516, '\p{^Scx:	--TALE}', "");
    Expect(0, 6516, '\P{Scx:	--TALE}', "");
    Expect(1, 6516, '\P{^Scx:	--TALE}', "");
    Expect(0, 6517, '\p{Scx:	--TALE}', "");
    Expect(1, 6517, '\p{^Scx:	--TALE}', "");
    Expect(1, 6517, '\P{Scx:	--TALE}', "");
    Expect(0, 6517, '\P{^Scx:	--TALE}', "");
    Error('\p{Is_Script_Extensions=_/a/TAI_Le}');
    Error('\P{Is_Script_Extensions=_/a/TAI_Le}');
    Expect(1, 6516, '\p{Is_Script_Extensions=taile}', "");
    Expect(0, 6516, '\p{^Is_Script_Extensions=taile}', "");
    Expect(0, 6516, '\P{Is_Script_Extensions=taile}', "");
    Expect(1, 6516, '\P{^Is_Script_Extensions=taile}', "");
    Expect(0, 6517, '\p{Is_Script_Extensions=taile}', "");
    Expect(1, 6517, '\p{^Is_Script_Extensions=taile}', "");
    Expect(1, 6517, '\P{Is_Script_Extensions=taile}', "");
    Expect(0, 6517, '\P{^Is_Script_Extensions=taile}', "");
    Expect(1, 6516, '\p{Is_Script_Extensions=  TAI_LE}', "");
    Expect(0, 6516, '\p{^Is_Script_Extensions=  TAI_LE}', "");
    Expect(0, 6516, '\P{Is_Script_Extensions=  TAI_LE}', "");
    Expect(1, 6516, '\P{^Is_Script_Extensions=  TAI_LE}', "");
    Expect(0, 6517, '\p{Is_Script_Extensions=  TAI_LE}', "");
    Expect(1, 6517, '\p{^Is_Script_Extensions=  TAI_LE}', "");
    Expect(1, 6517, '\P{Is_Script_Extensions=  TAI_LE}', "");
    Expect(0, 6517, '\P{^Is_Script_Extensions=  TAI_LE}', "");
    Error('\p{Is_Scx=/a/	 TALE}');
    Error('\P{Is_Scx=/a/	 TALE}');
    Expect(1, 6516, '\p{Is_Scx=tale}', "");
    Expect(0, 6516, '\p{^Is_Scx=tale}', "");
    Expect(0, 6516, '\P{Is_Scx=tale}', "");
    Expect(1, 6516, '\P{^Is_Scx=tale}', "");
    Expect(0, 6517, '\p{Is_Scx=tale}', "");
    Expect(1, 6517, '\p{^Is_Scx=tale}', "");
    Expect(1, 6517, '\P{Is_Scx=tale}', "");
    Expect(0, 6517, '\P{^Is_Scx=tale}', "");
    Expect(1, 6516, '\p{Is_Scx= 	Tale}', "");
    Expect(0, 6516, '\p{^Is_Scx= 	Tale}', "");
    Expect(0, 6516, '\P{Is_Scx= 	Tale}', "");
    Expect(1, 6516, '\P{^Is_Scx= 	Tale}', "");
    Expect(0, 6517, '\p{Is_Scx= 	Tale}', "");
    Expect(1, 6517, '\p{^Is_Scx= 	Tale}', "");
    Expect(1, 6517, '\P{Is_Scx= 	Tale}', "");
    Expect(0, 6517, '\P{^Is_Scx= 	Tale}', "");
    Error('\p{Script_Extensions=-	New_TAI_LUE:=}');
    Error('\P{Script_Extensions=-	New_TAI_LUE:=}');
    Expect(1, 6623, '\p{Script_Extensions=:\ANew_Tai_Lue\z:}', "");;
    Expect(0, 6624, '\p{Script_Extensions=:\ANew_Tai_Lue\z:}', "");;
    Expect(1, 6623, '\p{Script_Extensions=newtailue}', "");
    Expect(0, 6623, '\p{^Script_Extensions=newtailue}', "");
    Expect(0, 6623, '\P{Script_Extensions=newtailue}', "");
    Expect(1, 6623, '\P{^Script_Extensions=newtailue}', "");
    Expect(0, 6624, '\p{Script_Extensions=newtailue}', "");
    Expect(1, 6624, '\p{^Script_Extensions=newtailue}', "");
    Expect(1, 6624, '\P{Script_Extensions=newtailue}', "");
    Expect(0, 6624, '\P{^Script_Extensions=newtailue}', "");
    Expect(1, 6623, '\p{Script_Extensions=:\Anewtailue\z:}', "");;
    Expect(0, 6624, '\p{Script_Extensions=:\Anewtailue\z:}', "");;
    Expect(1, 6623, '\p{Script_Extensions=	_new_TAI_lue}', "");
    Expect(0, 6623, '\p{^Script_Extensions=	_new_TAI_lue}', "");
    Expect(0, 6623, '\P{Script_Extensions=	_new_TAI_lue}', "");
    Expect(1, 6623, '\P{^Script_Extensions=	_new_TAI_lue}', "");
    Expect(0, 6624, '\p{Script_Extensions=	_new_TAI_lue}', "");
    Expect(1, 6624, '\p{^Script_Extensions=	_new_TAI_lue}', "");
    Expect(1, 6624, '\P{Script_Extensions=	_new_TAI_lue}', "");
    Expect(0, 6624, '\P{^Script_Extensions=	_new_TAI_lue}', "");
    Error('\p{Scx= :=Talu}');
    Error('\P{Scx= :=Talu}');
    Expect(1, 6623, '\p{Scx=:\ATalu\z:}', "");;
    Expect(0, 6624, '\p{Scx=:\ATalu\z:}', "");;
    Expect(1, 6623, '\p{Scx=talu}', "");
    Expect(0, 6623, '\p{^Scx=talu}', "");
    Expect(0, 6623, '\P{Scx=talu}', "");
    Expect(1, 6623, '\P{^Scx=talu}', "");
    Expect(0, 6624, '\p{Scx=talu}', "");
    Expect(1, 6624, '\p{^Scx=talu}', "");
    Expect(1, 6624, '\P{Scx=talu}', "");
    Expect(0, 6624, '\P{^Scx=talu}', "");
    Expect(1, 6623, '\p{Scx=:\Atalu\z:}', "");;
    Expect(0, 6624, '\p{Scx=:\Atalu\z:}', "");;
    Expect(1, 6623, '\p{Scx=	-Talu}', "");
    Expect(0, 6623, '\p{^Scx=	-Talu}', "");
    Expect(0, 6623, '\P{Scx=	-Talu}', "");
    Expect(1, 6623, '\P{^Scx=	-Talu}', "");
    Expect(0, 6624, '\p{Scx=	-Talu}', "");
    Expect(1, 6624, '\p{^Scx=	-Talu}', "");
    Expect(1, 6624, '\P{Scx=	-Talu}', "");
    Expect(0, 6624, '\P{^Scx=	-Talu}', "");
    Error('\p{Is_Script_Extensions= -New_tai_lue:=}');
    Error('\P{Is_Script_Extensions= -New_tai_lue:=}');
    Expect(1, 6623, '\p{Is_Script_Extensions=newtailue}', "");
    Expect(0, 6623, '\p{^Is_Script_Extensions=newtailue}', "");
    Expect(0, 6623, '\P{Is_Script_Extensions=newtailue}', "");
    Expect(1, 6623, '\P{^Is_Script_Extensions=newtailue}', "");
    Expect(0, 6624, '\p{Is_Script_Extensions=newtailue}', "");
    Expect(1, 6624, '\p{^Is_Script_Extensions=newtailue}', "");
    Expect(1, 6624, '\P{Is_Script_Extensions=newtailue}', "");
    Expect(0, 6624, '\P{^Is_Script_Extensions=newtailue}', "");
    Expect(1, 6623, '\p{Is_Script_Extensions=-_New_TAI_LUE}', "");
    Expect(0, 6623, '\p{^Is_Script_Extensions=-_New_TAI_LUE}', "");
    Expect(0, 6623, '\P{Is_Script_Extensions=-_New_TAI_LUE}', "");
    Expect(1, 6623, '\P{^Is_Script_Extensions=-_New_TAI_LUE}', "");
    Expect(0, 6624, '\p{Is_Script_Extensions=-_New_TAI_LUE}', "");
    Expect(1, 6624, '\p{^Is_Script_Extensions=-_New_TAI_LUE}', "");
    Expect(1, 6624, '\P{Is_Script_Extensions=-_New_TAI_LUE}', "");
    Expect(0, 6624, '\P{^Is_Script_Extensions=-_New_TAI_LUE}', "");
    Error('\p{Is_Scx=	/a/talu}');
    Error('\P{Is_Scx=	/a/talu}');
    Expect(1, 6623, '\p{Is_Scx=talu}', "");
    Expect(0, 6623, '\p{^Is_Scx=talu}', "");
    Expect(0, 6623, '\P{Is_Scx=talu}', "");
    Expect(1, 6623, '\P{^Is_Scx=talu}', "");
    Expect(0, 6624, '\p{Is_Scx=talu}', "");
    Expect(1, 6624, '\p{^Is_Scx=talu}', "");
    Expect(1, 6624, '\P{Is_Scx=talu}', "");
    Expect(0, 6624, '\P{^Is_Scx=talu}', "");
    Expect(1, 6623, '\p{Is_Scx=Talu}', "");
    Expect(0, 6623, '\p{^Is_Scx=Talu}', "");
    Expect(0, 6623, '\P{Is_Scx=Talu}', "");
    Expect(1, 6623, '\P{^Is_Scx=Talu}', "");
    Expect(0, 6624, '\p{Is_Scx=Talu}', "");
    Expect(1, 6624, '\p{^Is_Scx=Talu}', "");
    Expect(1, 6624, '\P{Is_Scx=Talu}', "");
    Expect(0, 6624, '\P{^Is_Scx=Talu}', "");
    Error('\p{Script_Extensions=/a/ _Tamil}');
    Error('\P{Script_Extensions=/a/ _Tamil}');
    Expect(1, 73727, '\p{Script_Extensions=:\ATamil\z:}', "");;
    Expect(0, 73728, '\p{Script_Extensions=:\ATamil\z:}', "");;
    Expect(1, 73727, '\p{Script_Extensions=tamil}', "");
    Expect(0, 73727, '\p{^Script_Extensions=tamil}', "");
    Expect(0, 73727, '\P{Script_Extensions=tamil}', "");
    Expect(1, 73727, '\P{^Script_Extensions=tamil}', "");
    Expect(0, 73728, '\p{Script_Extensions=tamil}', "");
    Expect(1, 73728, '\p{^Script_Extensions=tamil}', "");
    Expect(1, 73728, '\P{Script_Extensions=tamil}', "");
    Expect(0, 73728, '\P{^Script_Extensions=tamil}', "");
    Expect(1, 73727, '\p{Script_Extensions=:\Atamil\z:}', "");;
    Expect(0, 73728, '\p{Script_Extensions=:\Atamil\z:}', "");;
    Expect(1, 73727, '\p{Script_Extensions=-tamil}', "");
    Expect(0, 73727, '\p{^Script_Extensions=-tamil}', "");
    Expect(0, 73727, '\P{Script_Extensions=-tamil}', "");
    Expect(1, 73727, '\P{^Script_Extensions=-tamil}', "");
    Expect(0, 73728, '\p{Script_Extensions=-tamil}', "");
    Expect(1, 73728, '\p{^Script_Extensions=-tamil}', "");
    Expect(1, 73728, '\P{Script_Extensions=-tamil}', "");
    Expect(0, 73728, '\P{^Script_Extensions=-tamil}', "");
    Error('\p{Scx=-Taml:=}');
    Error('\P{Scx=-Taml:=}');
    Expect(1, 73727, '\p{Scx=:\ATaml\z:}', "");;
    Expect(0, 73728, '\p{Scx=:\ATaml\z:}', "");;
    Expect(1, 73727, '\p{Scx=taml}', "");
    Expect(0, 73727, '\p{^Scx=taml}', "");
    Expect(0, 73727, '\P{Scx=taml}', "");
    Expect(1, 73727, '\P{^Scx=taml}', "");
    Expect(0, 73728, '\p{Scx=taml}', "");
    Expect(1, 73728, '\p{^Scx=taml}', "");
    Expect(1, 73728, '\P{Scx=taml}', "");
    Expect(0, 73728, '\P{^Scx=taml}', "");
    Expect(1, 73727, '\p{Scx=:\Ataml\z:}', "");;
    Expect(0, 73728, '\p{Scx=:\Ataml\z:}', "");;
    Expect(1, 73727, '\p{Scx=	TAML}', "");
    Expect(0, 73727, '\p{^Scx=	TAML}', "");
    Expect(0, 73727, '\P{Scx=	TAML}', "");
    Expect(1, 73727, '\P{^Scx=	TAML}', "");
    Expect(0, 73728, '\p{Scx=	TAML}', "");
    Expect(1, 73728, '\p{^Scx=	TAML}', "");
    Expect(1, 73728, '\P{Scx=	TAML}', "");
    Expect(0, 73728, '\P{^Scx=	TAML}', "");
    Error('\p{Is_Script_Extensions=-/a/Tamil}');
    Error('\P{Is_Script_Extensions=-/a/Tamil}');
    Expect(1, 73727, '\p{Is_Script_Extensions=tamil}', "");
    Expect(0, 73727, '\p{^Is_Script_Extensions=tamil}', "");
    Expect(0, 73727, '\P{Is_Script_Extensions=tamil}', "");
    Expect(1, 73727, '\P{^Is_Script_Extensions=tamil}', "");
    Expect(0, 73728, '\p{Is_Script_Extensions=tamil}', "");
    Expect(1, 73728, '\p{^Is_Script_Extensions=tamil}', "");
    Expect(1, 73728, '\P{Is_Script_Extensions=tamil}', "");
    Expect(0, 73728, '\P{^Is_Script_Extensions=tamil}', "");
    Expect(1, 73727, '\p{Is_Script_Extensions=	-tamil}', "");
    Expect(0, 73727, '\p{^Is_Script_Extensions=	-tamil}', "");
    Expect(0, 73727, '\P{Is_Script_Extensions=	-tamil}', "");
    Expect(1, 73727, '\P{^Is_Script_Extensions=	-tamil}', "");
    Expect(0, 73728, '\p{Is_Script_Extensions=	-tamil}', "");
    Expect(1, 73728, '\p{^Is_Script_Extensions=	-tamil}', "");
    Expect(1, 73728, '\P{Is_Script_Extensions=	-tamil}', "");
    Expect(0, 73728, '\P{^Is_Script_Extensions=	-tamil}', "");
    Error('\p{Is_Scx=	 Taml/a/}');
    Error('\P{Is_Scx=	 Taml/a/}');
    Expect(1, 73727, '\p{Is_Scx=taml}', "");
    Expect(0, 73727, '\p{^Is_Scx=taml}', "");
    Expect(0, 73727, '\P{Is_Scx=taml}', "");
    Expect(1, 73727, '\P{^Is_Scx=taml}', "");
    Expect(0, 73728, '\p{Is_Scx=taml}', "");
    Expect(1, 73728, '\p{^Is_Scx=taml}', "");
    Expect(1, 73728, '\P{Is_Scx=taml}', "");
    Expect(0, 73728, '\P{^Is_Scx=taml}', "");
    Expect(1, 73727, '\p{Is_Scx=_Taml}', "");
    Expect(0, 73727, '\p{^Is_Scx=_Taml}', "");
    Expect(0, 73727, '\P{Is_Scx=_Taml}', "");
    Expect(1, 73727, '\P{^Is_Scx=_Taml}', "");
    Expect(0, 73728, '\p{Is_Scx=_Taml}', "");
    Expect(1, 73728, '\p{^Is_Scx=_Taml}', "");
    Expect(1, 73728, '\P{Is_Scx=_Taml}', "");
    Expect(0, 73728, '\P{^Is_Scx=_Taml}', "");
    Error('\p{Script_Extensions= Tangut/a/}');
    Error('\P{Script_Extensions= Tangut/a/}');
    Expect(1, 101640, '\p{Script_Extensions=:\ATangut\z:}', "");;
    Expect(0, 101641, '\p{Script_Extensions=:\ATangut\z:}', "");;
    Expect(1, 101640, '\p{Script_Extensions:tangut}', "");
    Expect(0, 101640, '\p{^Script_Extensions:tangut}', "");
    Expect(0, 101640, '\P{Script_Extensions:tangut}', "");
    Expect(1, 101640, '\P{^Script_Extensions:tangut}', "");
    Expect(0, 101641, '\p{Script_Extensions:tangut}', "");
    Expect(1, 101641, '\p{^Script_Extensions:tangut}', "");
    Expect(1, 101641, '\P{Script_Extensions:tangut}', "");
    Expect(0, 101641, '\P{^Script_Extensions:tangut}', "");
    Expect(1, 101640, '\p{Script_Extensions=:\Atangut\z:}', "");;
    Expect(0, 101641, '\p{Script_Extensions=:\Atangut\z:}', "");;
    Expect(1, 101640, '\p{Script_Extensions:   	tangut}', "");
    Expect(0, 101640, '\p{^Script_Extensions:   	tangut}', "");
    Expect(0, 101640, '\P{Script_Extensions:   	tangut}', "");
    Expect(1, 101640, '\P{^Script_Extensions:   	tangut}', "");
    Expect(0, 101641, '\p{Script_Extensions:   	tangut}', "");
    Expect(1, 101641, '\p{^Script_Extensions:   	tangut}', "");
    Expect(1, 101641, '\P{Script_Extensions:   	tangut}', "");
    Expect(0, 101641, '\P{^Script_Extensions:   	tangut}', "");
    Error('\p{Scx:	--TANG/a/}');
    Error('\P{Scx:	--TANG/a/}');
    Expect(1, 101640, '\p{Scx=:\ATang\z:}', "");;
    Expect(0, 101641, '\p{Scx=:\ATang\z:}', "");;
    Expect(1, 101640, '\p{Scx=tang}', "");
    Expect(0, 101640, '\p{^Scx=tang}', "");
    Expect(0, 101640, '\P{Scx=tang}', "");
    Expect(1, 101640, '\P{^Scx=tang}', "");
    Expect(0, 101641, '\p{Scx=tang}', "");
    Expect(1, 101641, '\p{^Scx=tang}', "");
    Expect(1, 101641, '\P{Scx=tang}', "");
    Expect(0, 101641, '\P{^Scx=tang}', "");
    Expect(1, 101640, '\p{Scx=:\Atang\z:}', "");;
    Expect(0, 101641, '\p{Scx=:\Atang\z:}', "");;
    Expect(1, 101640, '\p{Scx= _Tang}', "");
    Expect(0, 101640, '\p{^Scx= _Tang}', "");
    Expect(0, 101640, '\P{Scx= _Tang}', "");
    Expect(1, 101640, '\P{^Scx= _Tang}', "");
    Expect(0, 101641, '\p{Scx= _Tang}', "");
    Expect(1, 101641, '\p{^Scx= _Tang}', "");
    Expect(1, 101641, '\P{Scx= _Tang}', "");
    Expect(0, 101641, '\P{^Scx= _Tang}', "");
    Error('\p{Is_Script_Extensions=_:=Tangut}');
    Error('\P{Is_Script_Extensions=_:=Tangut}');
    Expect(1, 101640, '\p{Is_Script_Extensions=tangut}', "");
    Expect(0, 101640, '\p{^Is_Script_Extensions=tangut}', "");
    Expect(0, 101640, '\P{Is_Script_Extensions=tangut}', "");
    Expect(1, 101640, '\P{^Is_Script_Extensions=tangut}', "");
    Expect(0, 101641, '\p{Is_Script_Extensions=tangut}', "");
    Expect(1, 101641, '\p{^Is_Script_Extensions=tangut}', "");
    Expect(1, 101641, '\P{Is_Script_Extensions=tangut}', "");
    Expect(0, 101641, '\P{^Is_Script_Extensions=tangut}', "");
    Expect(1, 101640, '\p{Is_Script_Extensions=_	Tangut}', "");
    Expect(0, 101640, '\p{^Is_Script_Extensions=_	Tangut}', "");
    Expect(0, 101640, '\P{Is_Script_Extensions=_	Tangut}', "");
    Expect(1, 101640, '\P{^Is_Script_Extensions=_	Tangut}', "");
    Expect(0, 101641, '\p{Is_Script_Extensions=_	Tangut}', "");
    Expect(1, 101641, '\p{^Is_Script_Extensions=_	Tangut}', "");
    Expect(1, 101641, '\P{Is_Script_Extensions=_	Tangut}', "");
    Expect(0, 101641, '\P{^Is_Script_Extensions=_	Tangut}', "");
    Error('\p{Is_Scx: _ tang:=}');
    Error('\P{Is_Scx: _ tang:=}');
    Expect(1, 101640, '\p{Is_Scx=tang}', "");
    Expect(0, 101640, '\p{^Is_Scx=tang}', "");
    Expect(0, 101640, '\P{Is_Scx=tang}', "");
    Expect(1, 101640, '\P{^Is_Scx=tang}', "");
    Expect(0, 101641, '\p{Is_Scx=tang}', "");
    Expect(1, 101641, '\p{^Is_Scx=tang}', "");
    Expect(1, 101641, '\P{Is_Scx=tang}', "");
    Expect(0, 101641, '\P{^Is_Scx=tang}', "");
    Expect(1, 101640, '\p{Is_Scx=- Tang}', "");
    Expect(0, 101640, '\p{^Is_Scx=- Tang}', "");
    Expect(0, 101640, '\P{Is_Scx=- Tang}', "");
    Expect(1, 101640, '\P{^Is_Scx=- Tang}', "");
    Expect(0, 101641, '\p{Is_Scx=- Tang}', "");
    Expect(1, 101641, '\p{^Is_Scx=- Tang}', "");
    Expect(1, 101641, '\P{Is_Scx=- Tang}', "");
    Expect(0, 101641, '\P{^Is_Scx=- Tang}', "");
    Error('\p{Script_Extensions=-TAI_Viet/a/}');
    Error('\P{Script_Extensions=-TAI_Viet/a/}');
    Expect(1, 43743, '\p{Script_Extensions=:\ATai_Viet\z:}', "");;
    Expect(0, 43744, '\p{Script_Extensions=:\ATai_Viet\z:}', "");;
    Expect(1, 43743, '\p{Script_Extensions=taiviet}', "");
    Expect(0, 43743, '\p{^Script_Extensions=taiviet}', "");
    Expect(0, 43743, '\P{Script_Extensions=taiviet}', "");
    Expect(1, 43743, '\P{^Script_Extensions=taiviet}', "");
    Expect(0, 43744, '\p{Script_Extensions=taiviet}', "");
    Expect(1, 43744, '\p{^Script_Extensions=taiviet}', "");
    Expect(1, 43744, '\P{Script_Extensions=taiviet}', "");
    Expect(0, 43744, '\P{^Script_Extensions=taiviet}', "");
    Expect(1, 43743, '\p{Script_Extensions=:\Ataiviet\z:}', "");;
    Expect(0, 43744, '\p{Script_Extensions=:\Ataiviet\z:}', "");;
    Expect(1, 43743, '\p{Script_Extensions= tai_Viet}', "");
    Expect(0, 43743, '\p{^Script_Extensions= tai_Viet}', "");
    Expect(0, 43743, '\P{Script_Extensions= tai_Viet}', "");
    Expect(1, 43743, '\P{^Script_Extensions= tai_Viet}', "");
    Expect(0, 43744, '\p{Script_Extensions= tai_Viet}', "");
    Expect(1, 43744, '\p{^Script_Extensions= tai_Viet}', "");
    Expect(1, 43744, '\P{Script_Extensions= tai_Viet}', "");
    Expect(0, 43744, '\P{^Script_Extensions= tai_Viet}', "");
    Error('\p{Scx:    /a/Tavt}');
    Error('\P{Scx:    /a/Tavt}');
    Expect(1, 43743, '\p{Scx=:\ATavt\z:}', "");;
    Expect(0, 43744, '\p{Scx=:\ATavt\z:}', "");;
    Expect(1, 43743, '\p{Scx=tavt}', "");
    Expect(0, 43743, '\p{^Scx=tavt}', "");
    Expect(0, 43743, '\P{Scx=tavt}', "");
    Expect(1, 43743, '\P{^Scx=tavt}', "");
    Expect(0, 43744, '\p{Scx=tavt}', "");
    Expect(1, 43744, '\p{^Scx=tavt}', "");
    Expect(1, 43744, '\P{Scx=tavt}', "");
    Expect(0, 43744, '\P{^Scx=tavt}', "");
    Expect(1, 43743, '\p{Scx=:\Atavt\z:}', "");;
    Expect(0, 43744, '\p{Scx=:\Atavt\z:}', "");;
    Expect(1, 43743, '\p{Scx=	-Tavt}', "");
    Expect(0, 43743, '\p{^Scx=	-Tavt}', "");
    Expect(0, 43743, '\P{Scx=	-Tavt}', "");
    Expect(1, 43743, '\P{^Scx=	-Tavt}', "");
    Expect(0, 43744, '\p{Scx=	-Tavt}', "");
    Expect(1, 43744, '\p{^Scx=	-Tavt}', "");
    Expect(1, 43744, '\P{Scx=	-Tavt}', "");
    Expect(0, 43744, '\P{^Scx=	-Tavt}', "");
    Error('\p{Is_Script_Extensions=/a/ Tai_viet}');
    Error('\P{Is_Script_Extensions=/a/ Tai_viet}');
    Expect(1, 43743, '\p{Is_Script_Extensions=taiviet}', "");
    Expect(0, 43743, '\p{^Is_Script_Extensions=taiviet}', "");
    Expect(0, 43743, '\P{Is_Script_Extensions=taiviet}', "");
    Expect(1, 43743, '\P{^Is_Script_Extensions=taiviet}', "");
    Expect(0, 43744, '\p{Is_Script_Extensions=taiviet}', "");
    Expect(1, 43744, '\p{^Is_Script_Extensions=taiviet}', "");
    Expect(1, 43744, '\P{Is_Script_Extensions=taiviet}', "");
    Expect(0, 43744, '\P{^Is_Script_Extensions=taiviet}', "");
    Expect(1, 43743, '\p{Is_Script_Extensions=_Tai_Viet}', "");
    Expect(0, 43743, '\p{^Is_Script_Extensions=_Tai_Viet}', "");
    Expect(0, 43743, '\P{Is_Script_Extensions=_Tai_Viet}', "");
    Expect(1, 43743, '\P{^Is_Script_Extensions=_Tai_Viet}', "");
    Expect(0, 43744, '\p{Is_Script_Extensions=_Tai_Viet}', "");
    Expect(1, 43744, '\p{^Is_Script_Extensions=_Tai_Viet}', "");
    Expect(1, 43744, '\P{Is_Script_Extensions=_Tai_Viet}', "");
    Expect(0, 43744, '\P{^Is_Script_Extensions=_Tai_Viet}', "");
    Error('\p{Is_Scx=_TAVT:=}');
    Error('\P{Is_Scx=_TAVT:=}');
    Expect(1, 43743, '\p{Is_Scx=tavt}', "");
    Expect(0, 43743, '\p{^Is_Scx=tavt}', "");
    Expect(0, 43743, '\P{Is_Scx=tavt}', "");
    Expect(1, 43743, '\P{^Is_Scx=tavt}', "");
    Expect(0, 43744, '\p{Is_Scx=tavt}', "");
    Expect(1, 43744, '\p{^Is_Scx=tavt}', "");
    Expect(1, 43744, '\P{Is_Scx=tavt}', "");
    Expect(0, 43744, '\P{^Is_Scx=tavt}', "");
    Expect(1, 43743, '\p{Is_Scx= _Tavt}', "");
    Expect(0, 43743, '\p{^Is_Scx= _Tavt}', "");
    Expect(0, 43743, '\P{Is_Scx= _Tavt}', "");
    Expect(1, 43743, '\P{^Is_Scx= _Tavt}', "");
    Expect(0, 43744, '\p{Is_Scx= _Tavt}', "");
    Expect(1, 43744, '\p{^Is_Scx= _Tavt}', "");
    Expect(1, 43744, '\P{Is_Scx= _Tavt}', "");
    Expect(0, 43744, '\P{^Is_Scx= _Tavt}', "");
    Error('\p{Script_Extensions=_:=TELUGU}');
    Error('\P{Script_Extensions=_:=TELUGU}');
    Expect(1, 7410, '\p{Script_Extensions=:\ATelugu\z:}', "");;
    Expect(0, 7411, '\p{Script_Extensions=:\ATelugu\z:}', "");;
    Expect(1, 7410, '\p{Script_Extensions=telugu}', "");
    Expect(0, 7410, '\p{^Script_Extensions=telugu}', "");
    Expect(0, 7410, '\P{Script_Extensions=telugu}', "");
    Expect(1, 7410, '\P{^Script_Extensions=telugu}', "");
    Expect(0, 7411, '\p{Script_Extensions=telugu}', "");
    Expect(1, 7411, '\p{^Script_Extensions=telugu}', "");
    Expect(1, 7411, '\P{Script_Extensions=telugu}', "");
    Expect(0, 7411, '\P{^Script_Extensions=telugu}', "");
    Expect(1, 7410, '\p{Script_Extensions=:\Atelugu\z:}', "");;
    Expect(0, 7411, '\p{Script_Extensions=:\Atelugu\z:}', "");;
    Expect(1, 7410, '\p{Script_Extensions=- telugu}', "");
    Expect(0, 7410, '\p{^Script_Extensions=- telugu}', "");
    Expect(0, 7410, '\P{Script_Extensions=- telugu}', "");
    Expect(1, 7410, '\P{^Script_Extensions=- telugu}', "");
    Expect(0, 7411, '\p{Script_Extensions=- telugu}', "");
    Expect(1, 7411, '\p{^Script_Extensions=- telugu}', "");
    Expect(1, 7411, '\P{Script_Extensions=- telugu}', "");
    Expect(0, 7411, '\P{^Script_Extensions=- telugu}', "");
    Error('\p{Scx=:=--TELU}');
    Error('\P{Scx=:=--TELU}');
    Expect(1, 7410, '\p{Scx=:\ATelu\z:}', "");;
    Expect(0, 7411, '\p{Scx=:\ATelu\z:}', "");;
    Expect(1, 7410, '\p{Scx:telu}', "");
    Expect(0, 7410, '\p{^Scx:telu}', "");
    Expect(0, 7410, '\P{Scx:telu}', "");
    Expect(1, 7410, '\P{^Scx:telu}', "");
    Expect(0, 7411, '\p{Scx:telu}', "");
    Expect(1, 7411, '\p{^Scx:telu}', "");
    Expect(1, 7411, '\P{Scx:telu}', "");
    Expect(0, 7411, '\P{^Scx:telu}', "");
    Expect(1, 7410, '\p{Scx=:\Atelu\z:}', "");;
    Expect(0, 7411, '\p{Scx=:\Atelu\z:}', "");;
    Expect(1, 7410, '\p{Scx=	TELU}', "");
    Expect(0, 7410, '\p{^Scx=	TELU}', "");
    Expect(0, 7410, '\P{Scx=	TELU}', "");
    Expect(1, 7410, '\P{^Scx=	TELU}', "");
    Expect(0, 7411, '\p{Scx=	TELU}', "");
    Expect(1, 7411, '\p{^Scx=	TELU}', "");
    Expect(1, 7411, '\P{Scx=	TELU}', "");
    Expect(0, 7411, '\P{^Scx=	TELU}', "");
    Error('\p{Is_Script_Extensions=/a/ _Telugu}');
    Error('\P{Is_Script_Extensions=/a/ _Telugu}');
    Expect(1, 7410, '\p{Is_Script_Extensions=telugu}', "");
    Expect(0, 7410, '\p{^Is_Script_Extensions=telugu}', "");
    Expect(0, 7410, '\P{Is_Script_Extensions=telugu}', "");
    Expect(1, 7410, '\P{^Is_Script_Extensions=telugu}', "");
    Expect(0, 7411, '\p{Is_Script_Extensions=telugu}', "");
    Expect(1, 7411, '\p{^Is_Script_Extensions=telugu}', "");
    Expect(1, 7411, '\P{Is_Script_Extensions=telugu}', "");
    Expect(0, 7411, '\P{^Is_Script_Extensions=telugu}', "");
    Expect(1, 7410, '\p{Is_Script_Extensions=_	Telugu}', "");
    Expect(0, 7410, '\p{^Is_Script_Extensions=_	Telugu}', "");
    Expect(0, 7410, '\P{Is_Script_Extensions=_	Telugu}', "");
    Expect(1, 7410, '\P{^Is_Script_Extensions=_	Telugu}', "");
    Expect(0, 7411, '\p{Is_Script_Extensions=_	Telugu}', "");
    Expect(1, 7411, '\p{^Is_Script_Extensions=_	Telugu}', "");
    Expect(1, 7411, '\P{Is_Script_Extensions=_	Telugu}', "");
    Expect(0, 7411, '\P{^Is_Script_Extensions=_	Telugu}', "");
    Error('\p{Is_Scx=-Telu/a/}');
    Error('\P{Is_Scx=-Telu/a/}');
    Expect(1, 7410, '\p{Is_Scx=telu}', "");
    Expect(0, 7410, '\p{^Is_Scx=telu}', "");
    Expect(0, 7410, '\P{Is_Scx=telu}', "");
    Expect(1, 7410, '\P{^Is_Scx=telu}', "");
    Expect(0, 7411, '\p{Is_Scx=telu}', "");
    Expect(1, 7411, '\p{^Is_Scx=telu}', "");
    Expect(1, 7411, '\P{Is_Scx=telu}', "");
    Expect(0, 7411, '\P{^Is_Scx=telu}', "");
    Expect(1, 7410, '\p{Is_Scx=_	telu}', "");
    Expect(0, 7410, '\p{^Is_Scx=_	telu}', "");
    Expect(0, 7410, '\P{Is_Scx=_	telu}', "");
    Expect(1, 7410, '\P{^Is_Scx=_	telu}', "");
    Expect(0, 7411, '\p{Is_Scx=_	telu}', "");
    Expect(1, 7411, '\p{^Is_Scx=_	telu}', "");
    Expect(1, 7411, '\P{Is_Scx=_	telu}', "");
    Expect(0, 7411, '\P{^Is_Scx=_	telu}', "");
    Error('\p{Script_Extensions:   /a/- Tifinagh}');
    Error('\P{Script_Extensions:   /a/- Tifinagh}');
    Expect(1, 11647, '\p{Script_Extensions=:\ATifinagh\z:}', "");;
    Expect(0, 11648, '\p{Script_Extensions=:\ATifinagh\z:}', "");;
    Expect(1, 11647, '\p{Script_Extensions=tifinagh}', "");
    Expect(0, 11647, '\p{^Script_Extensions=tifinagh}', "");
    Expect(0, 11647, '\P{Script_Extensions=tifinagh}', "");
    Expect(1, 11647, '\P{^Script_Extensions=tifinagh}', "");
    Expect(0, 11648, '\p{Script_Extensions=tifinagh}', "");
    Expect(1, 11648, '\p{^Script_Extensions=tifinagh}', "");
    Expect(1, 11648, '\P{Script_Extensions=tifinagh}', "");
    Expect(0, 11648, '\P{^Script_Extensions=tifinagh}', "");
    Expect(1, 11647, '\p{Script_Extensions=:\Atifinagh\z:}', "");;
    Expect(0, 11648, '\p{Script_Extensions=:\Atifinagh\z:}', "");;
    Expect(1, 11647, '\p{Script_Extensions= Tifinagh}', "");
    Expect(0, 11647, '\p{^Script_Extensions= Tifinagh}', "");
    Expect(0, 11647, '\P{Script_Extensions= Tifinagh}', "");
    Expect(1, 11647, '\P{^Script_Extensions= Tifinagh}', "");
    Expect(0, 11648, '\p{Script_Extensions= Tifinagh}', "");
    Expect(1, 11648, '\p{^Script_Extensions= Tifinagh}', "");
    Expect(1, 11648, '\P{Script_Extensions= Tifinagh}', "");
    Expect(0, 11648, '\P{^Script_Extensions= Tifinagh}', "");
    Error('\p{Scx:   /a/	TFNG}');
    Error('\P{Scx:   /a/	TFNG}');
    Expect(1, 11647, '\p{Scx=:\ATfng\z:}', "");;
    Expect(0, 11648, '\p{Scx=:\ATfng\z:}', "");;
    Expect(1, 11647, '\p{Scx=tfng}', "");
    Expect(0, 11647, '\p{^Scx=tfng}', "");
    Expect(0, 11647, '\P{Scx=tfng}', "");
    Expect(1, 11647, '\P{^Scx=tfng}', "");
    Expect(0, 11648, '\p{Scx=tfng}', "");
    Expect(1, 11648, '\p{^Scx=tfng}', "");
    Expect(1, 11648, '\P{Scx=tfng}', "");
    Expect(0, 11648, '\P{^Scx=tfng}', "");
    Expect(1, 11647, '\p{Scx=:\Atfng\z:}', "");;
    Expect(0, 11648, '\p{Scx=:\Atfng\z:}', "");;
    Expect(1, 11647, '\p{Scx=_TFNG}', "");
    Expect(0, 11647, '\p{^Scx=_TFNG}', "");
    Expect(0, 11647, '\P{Scx=_TFNG}', "");
    Expect(1, 11647, '\P{^Scx=_TFNG}', "");
    Expect(0, 11648, '\p{Scx=_TFNG}', "");
    Expect(1, 11648, '\p{^Scx=_TFNG}', "");
    Expect(1, 11648, '\P{Scx=_TFNG}', "");
    Expect(0, 11648, '\P{^Scx=_TFNG}', "");
    Error('\p{Is_Script_Extensions=  Tifinagh:=}');
    Error('\P{Is_Script_Extensions=  Tifinagh:=}');
    Expect(1, 11647, '\p{Is_Script_Extensions=tifinagh}', "");
    Expect(0, 11647, '\p{^Is_Script_Extensions=tifinagh}', "");
    Expect(0, 11647, '\P{Is_Script_Extensions=tifinagh}', "");
    Expect(1, 11647, '\P{^Is_Script_Extensions=tifinagh}', "");
    Expect(0, 11648, '\p{Is_Script_Extensions=tifinagh}', "");
    Expect(1, 11648, '\p{^Is_Script_Extensions=tifinagh}', "");
    Expect(1, 11648, '\P{Is_Script_Extensions=tifinagh}', "");
    Expect(0, 11648, '\P{^Is_Script_Extensions=tifinagh}', "");
    Expect(1, 11647, '\p{Is_Script_Extensions=--tifinagh}', "");
    Expect(0, 11647, '\p{^Is_Script_Extensions=--tifinagh}', "");
    Expect(0, 11647, '\P{Is_Script_Extensions=--tifinagh}', "");
    Expect(1, 11647, '\P{^Is_Script_Extensions=--tifinagh}', "");
    Expect(0, 11648, '\p{Is_Script_Extensions=--tifinagh}', "");
    Expect(1, 11648, '\p{^Is_Script_Extensions=--tifinagh}', "");
    Expect(1, 11648, '\P{Is_Script_Extensions=--tifinagh}', "");
    Expect(0, 11648, '\P{^Is_Script_Extensions=--tifinagh}', "");
    Error('\p{Is_Scx=:= 	Tfng}');
    Error('\P{Is_Scx=:= 	Tfng}');
    Expect(1, 11647, '\p{Is_Scx=tfng}', "");
    Expect(0, 11647, '\p{^Is_Scx=tfng}', "");
    Expect(0, 11647, '\P{Is_Scx=tfng}', "");
    Expect(1, 11647, '\P{^Is_Scx=tfng}', "");
    Expect(0, 11648, '\p{Is_Scx=tfng}', "");
    Expect(1, 11648, '\p{^Is_Scx=tfng}', "");
    Expect(1, 11648, '\P{Is_Scx=tfng}', "");
    Expect(0, 11648, '\P{^Is_Scx=tfng}', "");
    Expect(1, 11647, '\p{Is_Scx=_ Tfng}', "");
    Expect(0, 11647, '\p{^Is_Scx=_ Tfng}', "");
    Expect(0, 11647, '\P{Is_Scx=_ Tfng}', "");
    Expect(1, 11647, '\P{^Is_Scx=_ Tfng}', "");
    Expect(0, 11648, '\p{Is_Scx=_ Tfng}', "");
    Expect(1, 11648, '\p{^Is_Scx=_ Tfng}', "");
    Expect(1, 11648, '\P{Is_Scx=_ Tfng}', "");
    Expect(0, 11648, '\P{^Is_Scx=_ Tfng}', "");
    Error('\p{Script_Extensions=:=__tagalog}');
    Error('\P{Script_Extensions=:=__tagalog}');
    Expect(1, 5942, '\p{Script_Extensions=:\ATagalog\z:}', "");;
    Expect(0, 5943, '\p{Script_Extensions=:\ATagalog\z:}', "");;
    Expect(1, 5942, '\p{Script_Extensions=tagalog}', "");
    Expect(0, 5942, '\p{^Script_Extensions=tagalog}', "");
    Expect(0, 5942, '\P{Script_Extensions=tagalog}', "");
    Expect(1, 5942, '\P{^Script_Extensions=tagalog}', "");
    Expect(0, 5943, '\p{Script_Extensions=tagalog}', "");
    Expect(1, 5943, '\p{^Script_Extensions=tagalog}', "");
    Expect(1, 5943, '\P{Script_Extensions=tagalog}', "");
    Expect(0, 5943, '\P{^Script_Extensions=tagalog}', "");
    Expect(1, 5942, '\p{Script_Extensions=:\Atagalog\z:}', "");;
    Expect(0, 5943, '\p{Script_Extensions=:\Atagalog\z:}', "");;
    Expect(1, 5942, '\p{Script_Extensions=_	tagalog}', "");
    Expect(0, 5942, '\p{^Script_Extensions=_	tagalog}', "");
    Expect(0, 5942, '\P{Script_Extensions=_	tagalog}', "");
    Expect(1, 5942, '\P{^Script_Extensions=_	tagalog}', "");
    Expect(0, 5943, '\p{Script_Extensions=_	tagalog}', "");
    Expect(1, 5943, '\p{^Script_Extensions=_	tagalog}', "");
    Expect(1, 5943, '\P{Script_Extensions=_	tagalog}', "");
    Expect(0, 5943, '\P{^Script_Extensions=_	tagalog}', "");
    Error('\p{Scx:	:=	-Tglg}');
    Error('\P{Scx:	:=	-Tglg}');
    Expect(1, 5942, '\p{Scx=:\ATglg\z:}', "");;
    Expect(0, 5943, '\p{Scx=:\ATglg\z:}', "");;
    Expect(1, 5942, '\p{Scx=tglg}', "");
    Expect(0, 5942, '\p{^Scx=tglg}', "");
    Expect(0, 5942, '\P{Scx=tglg}', "");
    Expect(1, 5942, '\P{^Scx=tglg}', "");
    Expect(0, 5943, '\p{Scx=tglg}', "");
    Expect(1, 5943, '\p{^Scx=tglg}', "");
    Expect(1, 5943, '\P{Scx=tglg}', "");
    Expect(0, 5943, '\P{^Scx=tglg}', "");
    Expect(1, 5942, '\p{Scx=:\Atglg\z:}', "");;
    Expect(0, 5943, '\p{Scx=:\Atglg\z:}', "");;
    Expect(1, 5942, '\p{Scx=  tglg}', "");
    Expect(0, 5942, '\p{^Scx=  tglg}', "");
    Expect(0, 5942, '\P{Scx=  tglg}', "");
    Expect(1, 5942, '\P{^Scx=  tglg}', "");
    Expect(0, 5943, '\p{Scx=  tglg}', "");
    Expect(1, 5943, '\p{^Scx=  tglg}', "");
    Expect(1, 5943, '\P{Scx=  tglg}', "");
    Expect(0, 5943, '\P{^Scx=  tglg}', "");
    Error('\p{Is_Script_Extensions=	/a/TAGALOG}');
    Error('\P{Is_Script_Extensions=	/a/TAGALOG}');
    Expect(1, 5942, '\p{Is_Script_Extensions=tagalog}', "");
    Expect(0, 5942, '\p{^Is_Script_Extensions=tagalog}', "");
    Expect(0, 5942, '\P{Is_Script_Extensions=tagalog}', "");
    Expect(1, 5942, '\P{^Is_Script_Extensions=tagalog}', "");
    Expect(0, 5943, '\p{Is_Script_Extensions=tagalog}', "");
    Expect(1, 5943, '\p{^Is_Script_Extensions=tagalog}', "");
    Expect(1, 5943, '\P{Is_Script_Extensions=tagalog}', "");
    Expect(0, 5943, '\P{^Is_Script_Extensions=tagalog}', "");
    Expect(1, 5942, '\p{Is_Script_Extensions:  _TAGALOG}', "");
    Expect(0, 5942, '\p{^Is_Script_Extensions:  _TAGALOG}', "");
    Expect(0, 5942, '\P{Is_Script_Extensions:  _TAGALOG}', "");
    Expect(1, 5942, '\P{^Is_Script_Extensions:  _TAGALOG}', "");
    Expect(0, 5943, '\p{Is_Script_Extensions:  _TAGALOG}', "");
    Expect(1, 5943, '\p{^Is_Script_Extensions:  _TAGALOG}', "");
    Expect(1, 5943, '\P{Is_Script_Extensions:  _TAGALOG}', "");
    Expect(0, 5943, '\P{^Is_Script_Extensions:  _TAGALOG}', "");
    Error('\p{Is_Scx=:=TGLG}');
    Error('\P{Is_Scx=:=TGLG}');
    Expect(1, 5942, '\p{Is_Scx=tglg}', "");
    Expect(0, 5942, '\p{^Is_Scx=tglg}', "");
    Expect(0, 5942, '\P{Is_Scx=tglg}', "");
    Expect(1, 5942, '\P{^Is_Scx=tglg}', "");
    Expect(0, 5943, '\p{Is_Scx=tglg}', "");
    Expect(1, 5943, '\p{^Is_Scx=tglg}', "");
    Expect(1, 5943, '\P{Is_Scx=tglg}', "");
    Expect(0, 5943, '\P{^Is_Scx=tglg}', "");
    Expect(1, 5942, '\p{Is_Scx=_ TGLG}', "");
    Expect(0, 5942, '\p{^Is_Scx=_ TGLG}', "");
    Expect(0, 5942, '\P{Is_Scx=_ TGLG}', "");
    Expect(1, 5942, '\P{^Is_Scx=_ TGLG}', "");
    Expect(0, 5943, '\p{Is_Scx=_ TGLG}', "");
    Expect(1, 5943, '\p{^Is_Scx=_ TGLG}', "");
    Expect(1, 5943, '\P{Is_Scx=_ TGLG}', "");
    Expect(0, 5943, '\P{^Is_Scx=_ TGLG}', "");
    Error('\p{Script_Extensions=/a/THAANA}');
    Error('\P{Script_Extensions=/a/THAANA}');
    Expect(1, 65021, '\p{Script_Extensions=:\AThaana\z:}', "");;
    Expect(0, 65022, '\p{Script_Extensions=:\AThaana\z:}', "");;
    Expect(1, 65021, '\p{Script_Extensions=thaana}', "");
    Expect(0, 65021, '\p{^Script_Extensions=thaana}', "");
    Expect(0, 65021, '\P{Script_Extensions=thaana}', "");
    Expect(1, 65021, '\P{^Script_Extensions=thaana}', "");
    Expect(0, 65022, '\p{Script_Extensions=thaana}', "");
    Expect(1, 65022, '\p{^Script_Extensions=thaana}', "");
    Expect(1, 65022, '\P{Script_Extensions=thaana}', "");
    Expect(0, 65022, '\P{^Script_Extensions=thaana}', "");
    Expect(1, 65021, '\p{Script_Extensions=:\Athaana\z:}', "");;
    Expect(0, 65022, '\p{Script_Extensions=:\Athaana\z:}', "");;
    Expect(1, 65021, '\p{Script_Extensions=	_thaana}', "");
    Expect(0, 65021, '\p{^Script_Extensions=	_thaana}', "");
    Expect(0, 65021, '\P{Script_Extensions=	_thaana}', "");
    Expect(1, 65021, '\P{^Script_Extensions=	_thaana}', "");
    Expect(0, 65022, '\p{Script_Extensions=	_thaana}', "");
    Expect(1, 65022, '\p{^Script_Extensions=	_thaana}', "");
    Expect(1, 65022, '\P{Script_Extensions=	_thaana}', "");
    Expect(0, 65022, '\P{^Script_Extensions=	_thaana}', "");
    Error('\p{Scx= :=THAA}');
    Error('\P{Scx= :=THAA}');
    Expect(1, 65021, '\p{Scx=:\AThaa\z:}', "");;
    Expect(0, 65022, '\p{Scx=:\AThaa\z:}', "");;
    Expect(1, 65021, '\p{Scx=thaa}', "");
    Expect(0, 65021, '\p{^Scx=thaa}', "");
    Expect(0, 65021, '\P{Scx=thaa}', "");
    Expect(1, 65021, '\P{^Scx=thaa}', "");
    Expect(0, 65022, '\p{Scx=thaa}', "");
    Expect(1, 65022, '\p{^Scx=thaa}', "");
    Expect(1, 65022, '\P{Scx=thaa}', "");
    Expect(0, 65022, '\P{^Scx=thaa}', "");
    Expect(1, 65021, '\p{Scx=:\Athaa\z:}', "");;
    Expect(0, 65022, '\p{Scx=:\Athaa\z:}', "");;
    Expect(1, 65021, '\p{Scx=		thaa}', "");
    Expect(0, 65021, '\p{^Scx=		thaa}', "");
    Expect(0, 65021, '\P{Scx=		thaa}', "");
    Expect(1, 65021, '\P{^Scx=		thaa}', "");
    Expect(0, 65022, '\p{Scx=		thaa}', "");
    Expect(1, 65022, '\p{^Scx=		thaa}', "");
    Expect(1, 65022, '\P{Scx=		thaa}', "");
    Expect(0, 65022, '\P{^Scx=		thaa}', "");
    Error('\p{Is_Script_Extensions=:=	-thaana}');
    Error('\P{Is_Script_Extensions=:=	-thaana}');
    Expect(1, 65021, '\p{Is_Script_Extensions=thaana}', "");
    Expect(0, 65021, '\p{^Is_Script_Extensions=thaana}', "");
    Expect(0, 65021, '\P{Is_Script_Extensions=thaana}', "");
    Expect(1, 65021, '\P{^Is_Script_Extensions=thaana}', "");
    Expect(0, 65022, '\p{Is_Script_Extensions=thaana}', "");
    Expect(1, 65022, '\p{^Is_Script_Extensions=thaana}', "");
    Expect(1, 65022, '\P{Is_Script_Extensions=thaana}', "");
    Expect(0, 65022, '\P{^Is_Script_Extensions=thaana}', "");
    Expect(1, 65021, '\p{Is_Script_Extensions=_thaana}', "");
    Expect(0, 65021, '\p{^Is_Script_Extensions=_thaana}', "");
    Expect(0, 65021, '\P{Is_Script_Extensions=_thaana}', "");
    Expect(1, 65021, '\P{^Is_Script_Extensions=_thaana}', "");
    Expect(0, 65022, '\p{Is_Script_Extensions=_thaana}', "");
    Expect(1, 65022, '\p{^Is_Script_Extensions=_thaana}', "");
    Expect(1, 65022, '\P{Is_Script_Extensions=_thaana}', "");
    Expect(0, 65022, '\P{^Is_Script_Extensions=_thaana}', "");
    Error('\p{Is_Scx=	/a/Thaa}');
    Error('\P{Is_Scx=	/a/Thaa}');
    Expect(1, 65021, '\p{Is_Scx=thaa}', "");
    Expect(0, 65021, '\p{^Is_Scx=thaa}', "");
    Expect(0, 65021, '\P{Is_Scx=thaa}', "");
    Expect(1, 65021, '\P{^Is_Scx=thaa}', "");
    Expect(0, 65022, '\p{Is_Scx=thaa}', "");
    Expect(1, 65022, '\p{^Is_Scx=thaa}', "");
    Expect(1, 65022, '\P{Is_Scx=thaa}', "");
    Expect(0, 65022, '\P{^Is_Scx=thaa}', "");
    Expect(1, 65021, '\p{Is_Scx=-Thaa}', "");
    Expect(0, 65021, '\p{^Is_Scx=-Thaa}', "");
    Expect(0, 65021, '\P{Is_Scx=-Thaa}', "");
    Expect(1, 65021, '\P{^Is_Scx=-Thaa}', "");
    Expect(0, 65022, '\p{Is_Scx=-Thaa}', "");
    Expect(1, 65022, '\p{^Is_Scx=-Thaa}', "");
    Expect(1, 65022, '\P{Is_Scx=-Thaa}', "");
    Expect(0, 65022, '\P{^Is_Scx=-Thaa}', "");
    Error('\p{Script_Extensions=:=	_THAI}');
    Error('\P{Script_Extensions=:=	_THAI}');
    Expect(1, 3675, '\p{Script_Extensions=:\AThai\z:}', "");;
    Expect(0, 3676, '\p{Script_Extensions=:\AThai\z:}', "");;
    Expect(1, 3675, '\p{Script_Extensions=thai}', "");
    Expect(0, 3675, '\p{^Script_Extensions=thai}', "");
    Expect(0, 3675, '\P{Script_Extensions=thai}', "");
    Expect(1, 3675, '\P{^Script_Extensions=thai}', "");
    Expect(0, 3676, '\p{Script_Extensions=thai}', "");
    Expect(1, 3676, '\p{^Script_Extensions=thai}', "");
    Expect(1, 3676, '\P{Script_Extensions=thai}', "");
    Expect(0, 3676, '\P{^Script_Extensions=thai}', "");
    Expect(1, 3675, '\p{Script_Extensions=:\Athai\z:}', "");;
    Expect(0, 3676, '\p{Script_Extensions=:\Athai\z:}', "");;
    Expect(1, 3675, '\p{Script_Extensions=-_Thai}', "");
    Expect(0, 3675, '\p{^Script_Extensions=-_Thai}', "");
    Expect(0, 3675, '\P{Script_Extensions=-_Thai}', "");
    Expect(1, 3675, '\P{^Script_Extensions=-_Thai}', "");
    Expect(0, 3676, '\p{Script_Extensions=-_Thai}', "");
    Expect(1, 3676, '\p{^Script_Extensions=-_Thai}', "");
    Expect(1, 3676, '\P{Script_Extensions=-_Thai}', "");
    Expect(0, 3676, '\P{^Script_Extensions=-_Thai}', "");
    Error('\p{Scx= 	THAI/a/}');
    Error('\P{Scx= 	THAI/a/}');
    Expect(1, 3675, '\p{Scx=:\AThai\z:}', "");;
    Expect(0, 3676, '\p{Scx=:\AThai\z:}', "");;
    Expect(1, 3675, '\p{Scx=thai}', "");
    Expect(0, 3675, '\p{^Scx=thai}', "");
    Expect(0, 3675, '\P{Scx=thai}', "");
    Expect(1, 3675, '\P{^Scx=thai}', "");
    Expect(0, 3676, '\p{Scx=thai}', "");
    Expect(1, 3676, '\p{^Scx=thai}', "");
    Expect(1, 3676, '\P{Scx=thai}', "");
    Expect(0, 3676, '\P{^Scx=thai}', "");
    Expect(1, 3675, '\p{Scx=:\Athai\z:}', "");;
    Expect(0, 3676, '\p{Scx=:\Athai\z:}', "");;
    Expect(1, 3675, '\p{Scx= 	thai}', "");
    Expect(0, 3675, '\p{^Scx= 	thai}', "");
    Expect(0, 3675, '\P{Scx= 	thai}', "");
    Expect(1, 3675, '\P{^Scx= 	thai}', "");
    Expect(0, 3676, '\p{Scx= 	thai}', "");
    Expect(1, 3676, '\p{^Scx= 	thai}', "");
    Expect(1, 3676, '\P{Scx= 	thai}', "");
    Expect(0, 3676, '\P{^Scx= 	thai}', "");
    Error('\p{Is_Script_Extensions=_:=Thai}');
    Error('\P{Is_Script_Extensions=_:=Thai}');
    Expect(1, 3675, '\p{Is_Script_Extensions=thai}', "");
    Expect(0, 3675, '\p{^Is_Script_Extensions=thai}', "");
    Expect(0, 3675, '\P{Is_Script_Extensions=thai}', "");
    Expect(1, 3675, '\P{^Is_Script_Extensions=thai}', "");
    Expect(0, 3676, '\p{Is_Script_Extensions=thai}', "");
    Expect(1, 3676, '\p{^Is_Script_Extensions=thai}', "");
    Expect(1, 3676, '\P{Is_Script_Extensions=thai}', "");
    Expect(0, 3676, '\P{^Is_Script_Extensions=thai}', "");
    Expect(1, 3675, '\p{Is_Script_Extensions=	-THAI}', "");
    Expect(0, 3675, '\p{^Is_Script_Extensions=	-THAI}', "");
    Expect(0, 3675, '\P{Is_Script_Extensions=	-THAI}', "");
    Expect(1, 3675, '\P{^Is_Script_Extensions=	-THAI}', "");
    Expect(0, 3676, '\p{Is_Script_Extensions=	-THAI}', "");
    Expect(1, 3676, '\p{^Is_Script_Extensions=	-THAI}', "");
    Expect(1, 3676, '\P{Is_Script_Extensions=	-THAI}', "");
    Expect(0, 3676, '\P{^Is_Script_Extensions=	-THAI}', "");
    Error('\p{Is_Scx=/a/- THAI}');
    Error('\P{Is_Scx=/a/- THAI}');
    Expect(1, 3675, '\p{Is_Scx=thai}', "");
    Expect(0, 3675, '\p{^Is_Scx=thai}', "");
    Expect(0, 3675, '\P{Is_Scx=thai}', "");
    Expect(1, 3675, '\P{^Is_Scx=thai}', "");
    Expect(0, 3676, '\p{Is_Scx=thai}', "");
    Expect(1, 3676, '\p{^Is_Scx=thai}', "");
    Expect(1, 3676, '\P{Is_Scx=thai}', "");
    Expect(0, 3676, '\P{^Is_Scx=thai}', "");
    Expect(1, 3675, '\p{Is_Scx= _Thai}', "");
    Expect(0, 3675, '\p{^Is_Scx= _Thai}', "");
    Expect(0, 3675, '\P{Is_Scx= _Thai}', "");
    Expect(1, 3675, '\P{^Is_Scx= _Thai}', "");
    Expect(0, 3676, '\p{Is_Scx= _Thai}', "");
    Expect(1, 3676, '\p{^Is_Scx= _Thai}', "");
    Expect(1, 3676, '\P{Is_Scx= _Thai}', "");
    Expect(0, 3676, '\P{^Is_Scx= _Thai}', "");
    Error('\p{Script_Extensions=/a/-Tibetan}');
    Error('\P{Script_Extensions=/a/-Tibetan}');
    Expect(1, 4058, '\p{Script_Extensions=:\ATibetan\z:}', "");;
    Expect(0, 4059, '\p{Script_Extensions=:\ATibetan\z:}', "");;
    Expect(1, 4058, '\p{Script_Extensions=tibetan}', "");
    Expect(0, 4058, '\p{^Script_Extensions=tibetan}', "");
    Expect(0, 4058, '\P{Script_Extensions=tibetan}', "");
    Expect(1, 4058, '\P{^Script_Extensions=tibetan}', "");
    Expect(0, 4059, '\p{Script_Extensions=tibetan}', "");
    Expect(1, 4059, '\p{^Script_Extensions=tibetan}', "");
    Expect(1, 4059, '\P{Script_Extensions=tibetan}', "");
    Expect(0, 4059, '\P{^Script_Extensions=tibetan}', "");
    Expect(1, 4058, '\p{Script_Extensions=:\Atibetan\z:}', "");;
    Expect(0, 4059, '\p{Script_Extensions=:\Atibetan\z:}', "");;
    Expect(1, 4058, '\p{Script_Extensions=	_Tibetan}', "");
    Expect(0, 4058, '\p{^Script_Extensions=	_Tibetan}', "");
    Expect(0, 4058, '\P{Script_Extensions=	_Tibetan}', "");
    Expect(1, 4058, '\P{^Script_Extensions=	_Tibetan}', "");
    Expect(0, 4059, '\p{Script_Extensions=	_Tibetan}', "");
    Expect(1, 4059, '\p{^Script_Extensions=	_Tibetan}', "");
    Expect(1, 4059, '\P{Script_Extensions=	_Tibetan}', "");
    Expect(0, 4059, '\P{^Script_Extensions=	_Tibetan}', "");
    Error('\p{Scx=/a/Tibt}');
    Error('\P{Scx=/a/Tibt}');
    Expect(1, 4058, '\p{Scx=:\ATibt\z:}', "");;
    Expect(0, 4059, '\p{Scx=:\ATibt\z:}', "");;
    Expect(1, 4058, '\p{Scx=tibt}', "");
    Expect(0, 4058, '\p{^Scx=tibt}', "");
    Expect(0, 4058, '\P{Scx=tibt}', "");
    Expect(1, 4058, '\P{^Scx=tibt}', "");
    Expect(0, 4059, '\p{Scx=tibt}', "");
    Expect(1, 4059, '\p{^Scx=tibt}', "");
    Expect(1, 4059, '\P{Scx=tibt}', "");
    Expect(0, 4059, '\P{^Scx=tibt}', "");
    Expect(1, 4058, '\p{Scx=:\Atibt\z:}', "");;
    Expect(0, 4059, '\p{Scx=:\Atibt\z:}', "");;
    Expect(1, 4058, '\p{Scx: --TIBT}', "");
    Expect(0, 4058, '\p{^Scx: --TIBT}', "");
    Expect(0, 4058, '\P{Scx: --TIBT}', "");
    Expect(1, 4058, '\P{^Scx: --TIBT}', "");
    Expect(0, 4059, '\p{Scx: --TIBT}', "");
    Expect(1, 4059, '\p{^Scx: --TIBT}', "");
    Expect(1, 4059, '\P{Scx: --TIBT}', "");
    Expect(0, 4059, '\P{^Scx: --TIBT}', "");
    Error('\p{Is_Script_Extensions=_/a/tibetan}');
    Error('\P{Is_Script_Extensions=_/a/tibetan}');
    Expect(1, 4058, '\p{Is_Script_Extensions=tibetan}', "");
    Expect(0, 4058, '\p{^Is_Script_Extensions=tibetan}', "");
    Expect(0, 4058, '\P{Is_Script_Extensions=tibetan}', "");
    Expect(1, 4058, '\P{^Is_Script_Extensions=tibetan}', "");
    Expect(0, 4059, '\p{Is_Script_Extensions=tibetan}', "");
    Expect(1, 4059, '\p{^Is_Script_Extensions=tibetan}', "");
    Expect(1, 4059, '\P{Is_Script_Extensions=tibetan}', "");
    Expect(0, 4059, '\P{^Is_Script_Extensions=tibetan}', "");
    Expect(1, 4058, '\p{Is_Script_Extensions:--TIBETAN}', "");
    Expect(0, 4058, '\p{^Is_Script_Extensions:--TIBETAN}', "");
    Expect(0, 4058, '\P{Is_Script_Extensions:--TIBETAN}', "");
    Expect(1, 4058, '\P{^Is_Script_Extensions:--TIBETAN}', "");
    Expect(0, 4059, '\p{Is_Script_Extensions:--TIBETAN}', "");
    Expect(1, 4059, '\p{^Is_Script_Extensions:--TIBETAN}', "");
    Expect(1, 4059, '\P{Is_Script_Extensions:--TIBETAN}', "");
    Expect(0, 4059, '\P{^Is_Script_Extensions:--TIBETAN}', "");
    Error('\p{Is_Scx:   -tibt/a/}');
    Error('\P{Is_Scx:   -tibt/a/}');
    Expect(1, 4058, '\p{Is_Scx=tibt}', "");
    Expect(0, 4058, '\p{^Is_Scx=tibt}', "");
    Expect(0, 4058, '\P{Is_Scx=tibt}', "");
    Expect(1, 4058, '\P{^Is_Scx=tibt}', "");
    Expect(0, 4059, '\p{Is_Scx=tibt}', "");
    Expect(1, 4059, '\p{^Is_Scx=tibt}', "");
    Expect(1, 4059, '\P{Is_Scx=tibt}', "");
    Expect(0, 4059, '\P{^Is_Scx=tibt}', "");
    Expect(1, 4058, '\p{Is_Scx=_Tibt}', "");
    Expect(0, 4058, '\p{^Is_Scx=_Tibt}', "");
    Expect(0, 4058, '\P{Is_Scx=_Tibt}', "");
    Expect(1, 4058, '\P{^Is_Scx=_Tibt}', "");
    Expect(0, 4059, '\p{Is_Scx=_Tibt}', "");
    Expect(1, 4059, '\p{^Is_Scx=_Tibt}', "");
    Expect(1, 4059, '\P{Is_Scx=_Tibt}', "");
    Expect(0, 4059, '\P{^Is_Scx=_Tibt}', "");
    Error('\p{Script_Extensions:	/a/_TIRHUTA}');
    Error('\P{Script_Extensions:	/a/_TIRHUTA}');
    Expect(1, 70873, '\p{Script_Extensions=:\ATirhuta\z:}', "");;
    Expect(0, 70874, '\p{Script_Extensions=:\ATirhuta\z:}', "");;
    Expect(1, 70873, '\p{Script_Extensions=tirhuta}', "");
    Expect(0, 70873, '\p{^Script_Extensions=tirhuta}', "");
    Expect(0, 70873, '\P{Script_Extensions=tirhuta}', "");
    Expect(1, 70873, '\P{^Script_Extensions=tirhuta}', "");
    Expect(0, 70874, '\p{Script_Extensions=tirhuta}', "");
    Expect(1, 70874, '\p{^Script_Extensions=tirhuta}', "");
    Expect(1, 70874, '\P{Script_Extensions=tirhuta}', "");
    Expect(0, 70874, '\P{^Script_Extensions=tirhuta}', "");
    Expect(1, 70873, '\p{Script_Extensions=:\Atirhuta\z:}', "");;
    Expect(0, 70874, '\p{Script_Extensions=:\Atirhuta\z:}', "");;
    Expect(1, 70873, '\p{Script_Extensions=__Tirhuta}', "");
    Expect(0, 70873, '\p{^Script_Extensions=__Tirhuta}', "");
    Expect(0, 70873, '\P{Script_Extensions=__Tirhuta}', "");
    Expect(1, 70873, '\P{^Script_Extensions=__Tirhuta}', "");
    Expect(0, 70874, '\p{Script_Extensions=__Tirhuta}', "");
    Expect(1, 70874, '\p{^Script_Extensions=__Tirhuta}', "");
    Expect(1, 70874, '\P{Script_Extensions=__Tirhuta}', "");
    Expect(0, 70874, '\P{^Script_Extensions=__Tirhuta}', "");
    Error('\p{Scx= :=Tirh}');
    Error('\P{Scx= :=Tirh}');
    Expect(1, 70873, '\p{Scx=:\ATirh\z:}', "");;
    Expect(0, 70874, '\p{Scx=:\ATirh\z:}', "");;
    Expect(1, 70873, '\p{Scx=tirh}', "");
    Expect(0, 70873, '\p{^Scx=tirh}', "");
    Expect(0, 70873, '\P{Scx=tirh}', "");
    Expect(1, 70873, '\P{^Scx=tirh}', "");
    Expect(0, 70874, '\p{Scx=tirh}', "");
    Expect(1, 70874, '\p{^Scx=tirh}', "");
    Expect(1, 70874, '\P{Scx=tirh}', "");
    Expect(0, 70874, '\P{^Scx=tirh}', "");
    Expect(1, 70873, '\p{Scx=:\Atirh\z:}', "");;
    Expect(0, 70874, '\p{Scx=:\Atirh\z:}', "");;
    Expect(1, 70873, '\p{Scx=	 Tirh}', "");
    Expect(0, 70873, '\p{^Scx=	 Tirh}', "");
    Expect(0, 70873, '\P{Scx=	 Tirh}', "");
    Expect(1, 70873, '\P{^Scx=	 Tirh}', "");
    Expect(0, 70874, '\p{Scx=	 Tirh}', "");
    Expect(1, 70874, '\p{^Scx=	 Tirh}', "");
    Expect(1, 70874, '\P{Scx=	 Tirh}', "");
    Expect(0, 70874, '\P{^Scx=	 Tirh}', "");
    Error('\p{Is_Script_Extensions=:=- Tirhuta}');
    Error('\P{Is_Script_Extensions=:=- Tirhuta}');
    Expect(1, 70873, '\p{Is_Script_Extensions=tirhuta}', "");
    Expect(0, 70873, '\p{^Is_Script_Extensions=tirhuta}', "");
    Expect(0, 70873, '\P{Is_Script_Extensions=tirhuta}', "");
    Expect(1, 70873, '\P{^Is_Script_Extensions=tirhuta}', "");
    Expect(0, 70874, '\p{Is_Script_Extensions=tirhuta}', "");
    Expect(1, 70874, '\p{^Is_Script_Extensions=tirhuta}', "");
    Expect(1, 70874, '\P{Is_Script_Extensions=tirhuta}', "");
    Expect(0, 70874, '\P{^Is_Script_Extensions=tirhuta}', "");
    Expect(1, 70873, '\p{Is_Script_Extensions=	 Tirhuta}', "");
    Expect(0, 70873, '\p{^Is_Script_Extensions=	 Tirhuta}', "");
    Expect(0, 70873, '\P{Is_Script_Extensions=	 Tirhuta}', "");
    Expect(1, 70873, '\P{^Is_Script_Extensions=	 Tirhuta}', "");
    Expect(0, 70874, '\p{Is_Script_Extensions=	 Tirhuta}', "");
    Expect(1, 70874, '\p{^Is_Script_Extensions=	 Tirhuta}', "");
    Expect(1, 70874, '\P{Is_Script_Extensions=	 Tirhuta}', "");
    Expect(0, 70874, '\P{^Is_Script_Extensions=	 Tirhuta}', "");
    Error('\p{Is_Scx=/a/Tirh}');
    Error('\P{Is_Scx=/a/Tirh}');
    Expect(1, 70873, '\p{Is_Scx=tirh}', "");
    Expect(0, 70873, '\p{^Is_Scx=tirh}', "");
    Expect(0, 70873, '\P{Is_Scx=tirh}', "");
    Expect(1, 70873, '\P{^Is_Scx=tirh}', "");
    Expect(0, 70874, '\p{Is_Scx=tirh}', "");
    Expect(1, 70874, '\p{^Is_Scx=tirh}', "");
    Expect(1, 70874, '\P{Is_Scx=tirh}', "");
    Expect(0, 70874, '\P{^Is_Scx=tirh}', "");
    Expect(1, 70873, '\p{Is_Scx=		TIRH}', "");
    Expect(0, 70873, '\p{^Is_Scx=		TIRH}', "");
    Expect(0, 70873, '\P{Is_Scx=		TIRH}', "");
    Expect(1, 70873, '\P{^Is_Scx=		TIRH}', "");
    Expect(0, 70874, '\p{Is_Scx=		TIRH}', "");
    Expect(1, 70874, '\p{^Is_Scx=		TIRH}', "");
    Expect(1, 70874, '\P{Is_Scx=		TIRH}', "");
    Expect(0, 70874, '\P{^Is_Scx=		TIRH}', "");
    Error('\p{Script_Extensions=- Tangsa:=}');
    Error('\P{Script_Extensions=- Tangsa:=}');
    Expect(1, 92873, '\p{Script_Extensions=:\ATangsa\z:}', "");;
    Expect(0, 92874, '\p{Script_Extensions=:\ATangsa\z:}', "");;
    Expect(1, 92873, '\p{Script_Extensions:   tangsa}', "");
    Expect(0, 92873, '\p{^Script_Extensions:   tangsa}', "");
    Expect(0, 92873, '\P{Script_Extensions:   tangsa}', "");
    Expect(1, 92873, '\P{^Script_Extensions:   tangsa}', "");
    Expect(0, 92874, '\p{Script_Extensions:   tangsa}', "");
    Expect(1, 92874, '\p{^Script_Extensions:   tangsa}', "");
    Expect(1, 92874, '\P{Script_Extensions:   tangsa}', "");
    Expect(0, 92874, '\P{^Script_Extensions:   tangsa}', "");
    Expect(1, 92873, '\p{Script_Extensions=:\Atangsa\z:}', "");;
    Expect(0, 92874, '\p{Script_Extensions=:\Atangsa\z:}', "");;
    Expect(1, 92873, '\p{Script_Extensions=_-Tangsa}', "");
    Expect(0, 92873, '\p{^Script_Extensions=_-Tangsa}', "");
    Expect(0, 92873, '\P{Script_Extensions=_-Tangsa}', "");
    Expect(1, 92873, '\P{^Script_Extensions=_-Tangsa}', "");
    Expect(0, 92874, '\p{Script_Extensions=_-Tangsa}', "");
    Expect(1, 92874, '\p{^Script_Extensions=_-Tangsa}', "");
    Expect(1, 92874, '\P{Script_Extensions=_-Tangsa}', "");
    Expect(0, 92874, '\P{^Script_Extensions=_-Tangsa}', "");
    Error('\p{Scx=_	Tnsa:=}');
    Error('\P{Scx=_	Tnsa:=}');
    Expect(1, 92873, '\p{Scx=:\ATnsa\z:}', "");;
    Expect(0, 92874, '\p{Scx=:\ATnsa\z:}', "");;
    Expect(1, 92873, '\p{Scx=tnsa}', "");
    Expect(0, 92873, '\p{^Scx=tnsa}', "");
    Expect(0, 92873, '\P{Scx=tnsa}', "");
    Expect(1, 92873, '\P{^Scx=tnsa}', "");
    Expect(0, 92874, '\p{Scx=tnsa}', "");
    Expect(1, 92874, '\p{^Scx=tnsa}', "");
    Expect(1, 92874, '\P{Scx=tnsa}', "");
    Expect(0, 92874, '\P{^Scx=tnsa}', "");
    Expect(1, 92873, '\p{Scx=:\Atnsa\z:}', "");;
    Expect(0, 92874, '\p{Scx=:\Atnsa\z:}', "");;
    Expect(1, 92873, '\p{Scx=	-TNSA}', "");
    Expect(0, 92873, '\p{^Scx=	-TNSA}', "");
    Expect(0, 92873, '\P{Scx=	-TNSA}', "");
    Expect(1, 92873, '\P{^Scx=	-TNSA}', "");
    Expect(0, 92874, '\p{Scx=	-TNSA}', "");
    Expect(1, 92874, '\p{^Scx=	-TNSA}', "");
    Expect(1, 92874, '\P{Scx=	-TNSA}', "");
    Expect(0, 92874, '\P{^Scx=	-TNSA}', "");
    Error('\p{Is_Script_Extensions=_:=tangsa}');
    Error('\P{Is_Script_Extensions=_:=tangsa}');
    Expect(1, 92873, '\p{Is_Script_Extensions=tangsa}', "");
    Expect(0, 92873, '\p{^Is_Script_Extensions=tangsa}', "");
    Expect(0, 92873, '\P{Is_Script_Extensions=tangsa}', "");
    Expect(1, 92873, '\P{^Is_Script_Extensions=tangsa}', "");
    Expect(0, 92874, '\p{Is_Script_Extensions=tangsa}', "");
    Expect(1, 92874, '\p{^Is_Script_Extensions=tangsa}', "");
    Expect(1, 92874, '\P{Is_Script_Extensions=tangsa}', "");
    Expect(0, 92874, '\P{^Is_Script_Extensions=tangsa}', "");
    Expect(1, 92873, '\p{Is_Script_Extensions=- Tangsa}', "");
    Expect(0, 92873, '\p{^Is_Script_Extensions=- Tangsa}', "");
    Expect(0, 92873, '\P{Is_Script_Extensions=- Tangsa}', "");
    Expect(1, 92873, '\P{^Is_Script_Extensions=- Tangsa}', "");
    Expect(0, 92874, '\p{Is_Script_Extensions=- Tangsa}', "");
    Expect(1, 92874, '\p{^Is_Script_Extensions=- Tangsa}', "");
    Expect(1, 92874, '\P{Is_Script_Extensions=- Tangsa}', "");
    Expect(0, 92874, '\P{^Is_Script_Extensions=- Tangsa}', "");
    Error('\p{Is_Scx=-/a/TNSA}');
    Error('\P{Is_Scx=-/a/TNSA}');
    Expect(1, 92873, '\p{Is_Scx=tnsa}', "");
    Expect(0, 92873, '\p{^Is_Scx=tnsa}', "");
    Expect(0, 92873, '\P{Is_Scx=tnsa}', "");
    Expect(1, 92873, '\P{^Is_Scx=tnsa}', "");
    Expect(0, 92874, '\p{Is_Scx=tnsa}', "");
    Expect(1, 92874, '\p{^Is_Scx=tnsa}', "");
    Expect(1, 92874, '\P{Is_Scx=tnsa}', "");
    Expect(0, 92874, '\P{^Is_Scx=tnsa}', "");
    Expect(1, 92873, '\p{Is_Scx= Tnsa}', "");
    Expect(0, 92873, '\p{^Is_Scx= Tnsa}', "");
    Expect(0, 92873, '\P{Is_Scx= Tnsa}', "");
    Expect(1, 92873, '\P{^Is_Scx= Tnsa}', "");
    Expect(0, 92874, '\p{Is_Scx= Tnsa}', "");
    Expect(1, 92874, '\p{^Is_Scx= Tnsa}', "");
    Expect(1, 92874, '\P{Is_Scx= Tnsa}', "");
    Expect(0, 92874, '\P{^Is_Scx= Tnsa}', "");
    Error('\p{Script_Extensions= /a/toto}');
    Error('\P{Script_Extensions= /a/toto}');
    Expect(1, 123566, '\p{Script_Extensions=:\AToto\z:}', "");;
    Expect(0, 123567, '\p{Script_Extensions=:\AToto\z:}', "");;
    Expect(1, 123566, '\p{Script_Extensions=toto}', "");
    Expect(0, 123566, '\p{^Script_Extensions=toto}', "");
    Expect(0, 123566, '\P{Script_Extensions=toto}', "");
    Expect(1, 123566, '\P{^Script_Extensions=toto}', "");
    Expect(0, 123567, '\p{Script_Extensions=toto}', "");
    Expect(1, 123567, '\p{^Script_Extensions=toto}', "");
    Expect(1, 123567, '\P{Script_Extensions=toto}', "");
    Expect(0, 123567, '\P{^Script_Extensions=toto}', "");
    Expect(1, 123566, '\p{Script_Extensions=:\Atoto\z:}', "");;
    Expect(0, 123567, '\p{Script_Extensions=:\Atoto\z:}', "");;
    Expect(1, 123566, '\p{Script_Extensions= -Toto}', "");
    Expect(0, 123566, '\p{^Script_Extensions= -Toto}', "");
    Expect(0, 123566, '\P{Script_Extensions= -Toto}', "");
    Expect(1, 123566, '\P{^Script_Extensions= -Toto}', "");
    Expect(0, 123567, '\p{Script_Extensions= -Toto}', "");
    Expect(1, 123567, '\p{^Script_Extensions= -Toto}', "");
    Expect(1, 123567, '\P{Script_Extensions= -Toto}', "");
    Expect(0, 123567, '\P{^Script_Extensions= -Toto}', "");
    Error('\p{Scx: :=  toto}');
    Error('\P{Scx: :=  toto}');
    Expect(1, 123566, '\p{Scx=:\AToto\z:}', "");;
    Expect(0, 123567, '\p{Scx=:\AToto\z:}', "");;
    Expect(1, 123566, '\p{Scx=toto}', "");
    Expect(0, 123566, '\p{^Scx=toto}', "");
    Expect(0, 123566, '\P{Scx=toto}', "");
    Expect(1, 123566, '\P{^Scx=toto}', "");
    Expect(0, 123567, '\p{Scx=toto}', "");
    Expect(1, 123567, '\p{^Scx=toto}', "");
    Expect(1, 123567, '\P{Scx=toto}', "");
    Expect(0, 123567, '\P{^Scx=toto}', "");
    Expect(1, 123566, '\p{Scx=:\Atoto\z:}', "");;
    Expect(0, 123567, '\p{Scx=:\Atoto\z:}', "");;
    Expect(1, 123566, '\p{Scx=	toto}', "");
    Expect(0, 123566, '\p{^Scx=	toto}', "");
    Expect(0, 123566, '\P{Scx=	toto}', "");
    Expect(1, 123566, '\P{^Scx=	toto}', "");
    Expect(0, 123567, '\p{Scx=	toto}', "");
    Expect(1, 123567, '\p{^Scx=	toto}', "");
    Expect(1, 123567, '\P{Scx=	toto}', "");
    Expect(0, 123567, '\P{^Scx=	toto}', "");
    Error('\p{Is_Script_Extensions=:=-TOTO}');
    Error('\P{Is_Script_Extensions=:=-TOTO}');
    Expect(1, 123566, '\p{Is_Script_Extensions=toto}', "");
    Expect(0, 123566, '\p{^Is_Script_Extensions=toto}', "");
    Expect(0, 123566, '\P{Is_Script_Extensions=toto}', "");
    Expect(1, 123566, '\P{^Is_Script_Extensions=toto}', "");
    Expect(0, 123567, '\p{Is_Script_Extensions=toto}', "");
    Expect(1, 123567, '\p{^Is_Script_Extensions=toto}', "");
    Expect(1, 123567, '\P{Is_Script_Extensions=toto}', "");
    Expect(0, 123567, '\P{^Is_Script_Extensions=toto}', "");
    Expect(1, 123566, '\p{Is_Script_Extensions=	 toto}', "");
    Expect(0, 123566, '\p{^Is_Script_Extensions=	 toto}', "");
    Expect(0, 123566, '\P{Is_Script_Extensions=	 toto}', "");
    Expect(1, 123566, '\P{^Is_Script_Extensions=	 toto}', "");
    Expect(0, 123567, '\p{Is_Script_Extensions=	 toto}', "");
    Expect(1, 123567, '\p{^Is_Script_Extensions=	 toto}', "");
    Expect(1, 123567, '\P{Is_Script_Extensions=	 toto}', "");
    Expect(0, 123567, '\P{^Is_Script_Extensions=	 toto}', "");
    Error('\p{Is_Scx=:=-TOTO}');
    Error('\P{Is_Scx=:=-TOTO}');
    Expect(1, 123566, '\p{Is_Scx=toto}', "");
    Expect(0, 123566, '\p{^Is_Scx=toto}', "");
    Expect(0, 123566, '\P{Is_Scx=toto}', "");
    Expect(1, 123566, '\P{^Is_Scx=toto}', "");
    Expect(0, 123567, '\p{Is_Scx=toto}', "");
    Expect(1, 123567, '\p{^Is_Scx=toto}', "");
    Expect(1, 123567, '\P{Is_Scx=toto}', "");
    Expect(0, 123567, '\P{^Is_Scx=toto}', "");
    Expect(1, 123566, '\p{Is_Scx: -_Toto}', "");
    Expect(0, 123566, '\p{^Is_Scx: -_Toto}', "");
    Expect(0, 123566, '\P{Is_Scx: -_Toto}', "");
    Expect(1, 123566, '\P{^Is_Scx: -_Toto}', "");
    Expect(0, 123567, '\p{Is_Scx: -_Toto}', "");
    Expect(1, 123567, '\p{^Is_Scx: -_Toto}', "");
    Expect(1, 123567, '\P{Is_Scx: -_Toto}', "");
    Expect(0, 123567, '\P{^Is_Scx: -_Toto}', "");
    Error('\p{Script_Extensions=:=	Ugaritic}');
    Error('\P{Script_Extensions=:=	Ugaritic}');
    Expect(1, 66463, '\p{Script_Extensions=:\AUgaritic\z:}', "");;
    Expect(0, 66464, '\p{Script_Extensions=:\AUgaritic\z:}', "");;
    Expect(1, 66463, '\p{Script_Extensions=ugaritic}', "");
    Expect(0, 66463, '\p{^Script_Extensions=ugaritic}', "");
    Expect(0, 66463, '\P{Script_Extensions=ugaritic}', "");
    Expect(1, 66463, '\P{^Script_Extensions=ugaritic}', "");
    Expect(0, 66464, '\p{Script_Extensions=ugaritic}', "");
    Expect(1, 66464, '\p{^Script_Extensions=ugaritic}', "");
    Expect(1, 66464, '\P{Script_Extensions=ugaritic}', "");
    Expect(0, 66464, '\P{^Script_Extensions=ugaritic}', "");
    Expect(1, 66463, '\p{Script_Extensions=:\Augaritic\z:}', "");;
    Expect(0, 66464, '\p{Script_Extensions=:\Augaritic\z:}', "");;
    Expect(1, 66463, '\p{Script_Extensions=	Ugaritic}', "");
    Expect(0, 66463, '\p{^Script_Extensions=	Ugaritic}', "");
    Expect(0, 66463, '\P{Script_Extensions=	Ugaritic}', "");
    Expect(1, 66463, '\P{^Script_Extensions=	Ugaritic}', "");
    Expect(0, 66464, '\p{Script_Extensions=	Ugaritic}', "");
    Expect(1, 66464, '\p{^Script_Extensions=	Ugaritic}', "");
    Expect(1, 66464, '\P{Script_Extensions=	Ugaritic}', "");
    Expect(0, 66464, '\P{^Script_Extensions=	Ugaritic}', "");
    Error('\p{Scx=_:=ugar}');
    Error('\P{Scx=_:=ugar}');
    Expect(1, 66463, '\p{Scx=:\AUgar\z:}', "");;
    Expect(0, 66464, '\p{Scx=:\AUgar\z:}', "");;
    Expect(1, 66463, '\p{Scx=ugar}', "");
    Expect(0, 66463, '\p{^Scx=ugar}', "");
    Expect(0, 66463, '\P{Scx=ugar}', "");
    Expect(1, 66463, '\P{^Scx=ugar}', "");
    Expect(0, 66464, '\p{Scx=ugar}', "");
    Expect(1, 66464, '\p{^Scx=ugar}', "");
    Expect(1, 66464, '\P{Scx=ugar}', "");
    Expect(0, 66464, '\P{^Scx=ugar}', "");
    Expect(1, 66463, '\p{Scx=:\Augar\z:}', "");;
    Expect(0, 66464, '\p{Scx=:\Augar\z:}', "");;
    Expect(1, 66463, '\p{Scx: _ugar}', "");
    Expect(0, 66463, '\p{^Scx: _ugar}', "");
    Expect(0, 66463, '\P{Scx: _ugar}', "");
    Expect(1, 66463, '\P{^Scx: _ugar}', "");
    Expect(0, 66464, '\p{Scx: _ugar}', "");
    Expect(1, 66464, '\p{^Scx: _ugar}', "");
    Expect(1, 66464, '\P{Scx: _ugar}', "");
    Expect(0, 66464, '\P{^Scx: _ugar}', "");
    Error('\p{Is_Script_Extensions=:=UGARITIC}');
    Error('\P{Is_Script_Extensions=:=UGARITIC}');
    Expect(1, 66463, '\p{Is_Script_Extensions=ugaritic}', "");
    Expect(0, 66463, '\p{^Is_Script_Extensions=ugaritic}', "");
    Expect(0, 66463, '\P{Is_Script_Extensions=ugaritic}', "");
    Expect(1, 66463, '\P{^Is_Script_Extensions=ugaritic}', "");
    Expect(0, 66464, '\p{Is_Script_Extensions=ugaritic}', "");
    Expect(1, 66464, '\p{^Is_Script_Extensions=ugaritic}', "");
    Expect(1, 66464, '\P{Is_Script_Extensions=ugaritic}', "");
    Expect(0, 66464, '\P{^Is_Script_Extensions=ugaritic}', "");
    Expect(1, 66463, '\p{Is_Script_Extensions=-UGARITIC}', "");
    Expect(0, 66463, '\p{^Is_Script_Extensions=-UGARITIC}', "");
    Expect(0, 66463, '\P{Is_Script_Extensions=-UGARITIC}', "");
    Expect(1, 66463, '\P{^Is_Script_Extensions=-UGARITIC}', "");
    Expect(0, 66464, '\p{Is_Script_Extensions=-UGARITIC}', "");
    Expect(1, 66464, '\p{^Is_Script_Extensions=-UGARITIC}', "");
    Expect(1, 66464, '\P{Is_Script_Extensions=-UGARITIC}', "");
    Expect(0, 66464, '\P{^Is_Script_Extensions=-UGARITIC}', "");
    Error('\p{Is_Scx::= 	UGAR}');
    Error('\P{Is_Scx::= 	UGAR}');
    Expect(1, 66463, '\p{Is_Scx=ugar}', "");
    Expect(0, 66463, '\p{^Is_Scx=ugar}', "");
    Expect(0, 66463, '\P{Is_Scx=ugar}', "");
    Expect(1, 66463, '\P{^Is_Scx=ugar}', "");
    Expect(0, 66464, '\p{Is_Scx=ugar}', "");
    Expect(1, 66464, '\p{^Is_Scx=ugar}', "");
    Expect(1, 66464, '\P{Is_Scx=ugar}', "");
    Expect(0, 66464, '\P{^Is_Scx=ugar}', "");
    Expect(1, 66463, '\p{Is_Scx=	_ugar}', "");
    Expect(0, 66463, '\p{^Is_Scx=	_ugar}', "");
    Expect(0, 66463, '\P{Is_Scx=	_ugar}', "");
    Expect(1, 66463, '\P{^Is_Scx=	_ugar}', "");
    Expect(0, 66464, '\p{Is_Scx=	_ugar}', "");
    Expect(1, 66464, '\p{^Is_Scx=	_ugar}', "");
    Expect(1, 66464, '\P{Is_Scx=	_ugar}', "");
    Expect(0, 66464, '\P{^Is_Scx=	_ugar}', "");
    Error('\p{Script_Extensions:/a/_	Vai}');
    Error('\P{Script_Extensions:/a/_	Vai}');
    Expect(1, 42539, '\p{Script_Extensions=:\AVai\z:}', "");;
    Expect(0, 42540, '\p{Script_Extensions=:\AVai\z:}', "");;
    Expect(1, 42539, '\p{Script_Extensions:	vai}', "");
    Expect(0, 42539, '\p{^Script_Extensions:	vai}', "");
    Expect(0, 42539, '\P{Script_Extensions:	vai}', "");
    Expect(1, 42539, '\P{^Script_Extensions:	vai}', "");
    Expect(0, 42540, '\p{Script_Extensions:	vai}', "");
    Expect(1, 42540, '\p{^Script_Extensions:	vai}', "");
    Expect(1, 42540, '\P{Script_Extensions:	vai}', "");
    Expect(0, 42540, '\P{^Script_Extensions:	vai}', "");
    Expect(1, 42539, '\p{Script_Extensions=:\Avai\z:}', "");;
    Expect(0, 42540, '\p{Script_Extensions=:\Avai\z:}', "");;
    Expect(1, 42539, '\p{Script_Extensions=		VAI}', "");
    Expect(0, 42539, '\p{^Script_Extensions=		VAI}', "");
    Expect(0, 42539, '\P{Script_Extensions=		VAI}', "");
    Expect(1, 42539, '\P{^Script_Extensions=		VAI}', "");
    Expect(0, 42540, '\p{Script_Extensions=		VAI}', "");
    Expect(1, 42540, '\p{^Script_Extensions=		VAI}', "");
    Expect(1, 42540, '\P{Script_Extensions=		VAI}', "");
    Expect(0, 42540, '\P{^Script_Extensions=		VAI}', "");
    Error('\p{Scx=--Vaii/a/}');
    Error('\P{Scx=--Vaii/a/}');
    Expect(1, 42539, '\p{Scx=:\AVaii\z:}', "");;
    Expect(0, 42540, '\p{Scx=:\AVaii\z:}', "");;
    Expect(1, 42539, '\p{Scx=vaii}', "");
    Expect(0, 42539, '\p{^Scx=vaii}', "");
    Expect(0, 42539, '\P{Scx=vaii}', "");
    Expect(1, 42539, '\P{^Scx=vaii}', "");
    Expect(0, 42540, '\p{Scx=vaii}', "");
    Expect(1, 42540, '\p{^Scx=vaii}', "");
    Expect(1, 42540, '\P{Scx=vaii}', "");
    Expect(0, 42540, '\P{^Scx=vaii}', "");
    Expect(1, 42539, '\p{Scx=:\Avaii\z:}', "");;
    Expect(0, 42540, '\p{Scx=:\Avaii\z:}', "");;
    Expect(1, 42539, '\p{Scx=_-Vaii}', "");
    Expect(0, 42539, '\p{^Scx=_-Vaii}', "");
    Expect(0, 42539, '\P{Scx=_-Vaii}', "");
    Expect(1, 42539, '\P{^Scx=_-Vaii}', "");
    Expect(0, 42540, '\p{Scx=_-Vaii}', "");
    Expect(1, 42540, '\p{^Scx=_-Vaii}', "");
    Expect(1, 42540, '\P{Scx=_-Vaii}', "");
    Expect(0, 42540, '\P{^Scx=_-Vaii}', "");
    Error('\p{Is_Script_Extensions=	/a/Vai}');
    Error('\P{Is_Script_Extensions=	/a/Vai}');
    Expect(1, 42539, '\p{Is_Script_Extensions=vai}', "");
    Expect(0, 42539, '\p{^Is_Script_Extensions=vai}', "");
    Expect(0, 42539, '\P{Is_Script_Extensions=vai}', "");
    Expect(1, 42539, '\P{^Is_Script_Extensions=vai}', "");
    Expect(0, 42540, '\p{Is_Script_Extensions=vai}', "");
    Expect(1, 42540, '\p{^Is_Script_Extensions=vai}', "");
    Expect(1, 42540, '\P{Is_Script_Extensions=vai}', "");
    Expect(0, 42540, '\P{^Is_Script_Extensions=vai}', "");
    Expect(1, 42539, '\p{Is_Script_Extensions:   --Vai}', "");
    Expect(0, 42539, '\p{^Is_Script_Extensions:   --Vai}', "");
    Expect(0, 42539, '\P{Is_Script_Extensions:   --Vai}', "");
    Expect(1, 42539, '\P{^Is_Script_Extensions:   --Vai}', "");
    Expect(0, 42540, '\p{Is_Script_Extensions:   --Vai}', "");
    Expect(1, 42540, '\p{^Is_Script_Extensions:   --Vai}', "");
    Expect(1, 42540, '\P{Is_Script_Extensions:   --Vai}', "");
    Expect(0, 42540, '\P{^Is_Script_Extensions:   --Vai}', "");
    Error('\p{Is_Scx:	-VAII/a/}');
    Error('\P{Is_Scx:	-VAII/a/}');
    Expect(1, 42539, '\p{Is_Scx=vaii}', "");
    Expect(0, 42539, '\p{^Is_Scx=vaii}', "");
    Expect(0, 42539, '\P{Is_Scx=vaii}', "");
    Expect(1, 42539, '\P{^Is_Scx=vaii}', "");
    Expect(0, 42540, '\p{Is_Scx=vaii}', "");
    Expect(1, 42540, '\p{^Is_Scx=vaii}', "");
    Expect(1, 42540, '\P{Is_Scx=vaii}', "");
    Expect(0, 42540, '\P{^Is_Scx=vaii}', "");
    Expect(1, 42539, '\p{Is_Scx=__vaii}', "");
    Expect(0, 42539, '\p{^Is_Scx=__vaii}', "");
    Expect(0, 42539, '\P{Is_Scx=__vaii}', "");
    Expect(1, 42539, '\P{^Is_Scx=__vaii}', "");
    Expect(0, 42540, '\p{Is_Scx=__vaii}', "");
    Expect(1, 42540, '\p{^Is_Scx=__vaii}', "");
    Expect(1, 42540, '\P{Is_Scx=__vaii}', "");
    Expect(0, 42540, '\P{^Is_Scx=__vaii}', "");
    Error('\p{Script_Extensions=VITHKUQI/a/}');
    Error('\P{Script_Extensions=VITHKUQI/a/}');
    Expect(1, 67004, '\p{Script_Extensions=:\AVithkuqi\z:}', "");;
    Expect(0, 67005, '\p{Script_Extensions=:\AVithkuqi\z:}', "");;
    Expect(1, 67004, '\p{Script_Extensions=vithkuqi}', "");
    Expect(0, 67004, '\p{^Script_Extensions=vithkuqi}', "");
    Expect(0, 67004, '\P{Script_Extensions=vithkuqi}', "");
    Expect(1, 67004, '\P{^Script_Extensions=vithkuqi}', "");
    Expect(0, 67005, '\p{Script_Extensions=vithkuqi}', "");
    Expect(1, 67005, '\p{^Script_Extensions=vithkuqi}', "");
    Expect(1, 67005, '\P{Script_Extensions=vithkuqi}', "");
    Expect(0, 67005, '\P{^Script_Extensions=vithkuqi}', "");
    Expect(1, 67004, '\p{Script_Extensions=:\Avithkuqi\z:}', "");;
    Expect(0, 67005, '\p{Script_Extensions=:\Avithkuqi\z:}', "");;
    Expect(1, 67004, '\p{Script_Extensions=		vithkuqi}', "");
    Expect(0, 67004, '\p{^Script_Extensions=		vithkuqi}', "");
    Expect(0, 67004, '\P{Script_Extensions=		vithkuqi}', "");
    Expect(1, 67004, '\P{^Script_Extensions=		vithkuqi}', "");
    Expect(0, 67005, '\p{Script_Extensions=		vithkuqi}', "");
    Expect(1, 67005, '\p{^Script_Extensions=		vithkuqi}', "");
    Expect(1, 67005, '\P{Script_Extensions=		vithkuqi}', "");
    Expect(0, 67005, '\P{^Script_Extensions=		vithkuqi}', "");
    Error('\p{Scx=-/a/Vith}');
    Error('\P{Scx=-/a/Vith}');
    Expect(1, 67004, '\p{Scx=:\AVith\z:}', "");;
    Expect(0, 67005, '\p{Scx=:\AVith\z:}', "");;
    Expect(1, 67004, '\p{Scx=vith}', "");
    Expect(0, 67004, '\p{^Scx=vith}', "");
    Expect(0, 67004, '\P{Scx=vith}', "");
    Expect(1, 67004, '\P{^Scx=vith}', "");
    Expect(0, 67005, '\p{Scx=vith}', "");
    Expect(1, 67005, '\p{^Scx=vith}', "");
    Expect(1, 67005, '\P{Scx=vith}', "");
    Expect(0, 67005, '\P{^Scx=vith}', "");
    Expect(1, 67004, '\p{Scx=:\Avith\z:}', "");;
    Expect(0, 67005, '\p{Scx=:\Avith\z:}', "");;
    Expect(1, 67004, '\p{Scx=_	Vith}', "");
    Expect(0, 67004, '\p{^Scx=_	Vith}', "");
    Expect(0, 67004, '\P{Scx=_	Vith}', "");
    Expect(1, 67004, '\P{^Scx=_	Vith}', "");
    Expect(0, 67005, '\p{Scx=_	Vith}', "");
    Expect(1, 67005, '\p{^Scx=_	Vith}', "");
    Expect(1, 67005, '\P{Scx=_	Vith}', "");
    Expect(0, 67005, '\P{^Scx=_	Vith}', "");
    Error('\p{Is_Script_Extensions=/a/VITHKUQI}');
    Error('\P{Is_Script_Extensions=/a/VITHKUQI}');
    Expect(1, 67004, '\p{Is_Script_Extensions=vithkuqi}', "");
    Expect(0, 67004, '\p{^Is_Script_Extensions=vithkuqi}', "");
    Expect(0, 67004, '\P{Is_Script_Extensions=vithkuqi}', "");
    Expect(1, 67004, '\P{^Is_Script_Extensions=vithkuqi}', "");
    Expect(0, 67005, '\p{Is_Script_Extensions=vithkuqi}', "");
    Expect(1, 67005, '\p{^Is_Script_Extensions=vithkuqi}', "");
    Expect(1, 67005, '\P{Is_Script_Extensions=vithkuqi}', "");
    Expect(0, 67005, '\P{^Is_Script_Extensions=vithkuqi}', "");
    Expect(1, 67004, '\p{Is_Script_Extensions= _VITHKUQI}', "");
    Expect(0, 67004, '\p{^Is_Script_Extensions= _VITHKUQI}', "");
    Expect(0, 67004, '\P{Is_Script_Extensions= _VITHKUQI}', "");
    Expect(1, 67004, '\P{^Is_Script_Extensions= _VITHKUQI}', "");
    Expect(0, 67005, '\p{Is_Script_Extensions= _VITHKUQI}', "");
    Expect(1, 67005, '\p{^Is_Script_Extensions= _VITHKUQI}', "");
    Expect(1, 67005, '\P{Is_Script_Extensions= _VITHKUQI}', "");
    Expect(0, 67005, '\P{^Is_Script_Extensions= _VITHKUQI}', "");
    Error('\p{Is_Scx=  vith/a/}');
    Error('\P{Is_Scx=  vith/a/}');
    Expect(1, 67004, '\p{Is_Scx=vith}', "");
    Expect(0, 67004, '\p{^Is_Scx=vith}', "");
    Expect(0, 67004, '\P{Is_Scx=vith}', "");
    Expect(1, 67004, '\P{^Is_Scx=vith}', "");
    Expect(0, 67005, '\p{Is_Scx=vith}', "");
    Expect(1, 67005, '\p{^Is_Scx=vith}', "");
    Expect(1, 67005, '\P{Is_Scx=vith}', "");
    Expect(0, 67005, '\P{^Is_Scx=vith}', "");
    Expect(1, 67004, '\p{Is_Scx=	_Vith}', "");
    Expect(0, 67004, '\p{^Is_Scx=	_Vith}', "");
    Expect(0, 67004, '\P{Is_Scx=	_Vith}', "");
    Expect(1, 67004, '\P{^Is_Scx=	_Vith}', "");
    Expect(0, 67005, '\p{Is_Scx=	_Vith}', "");
    Expect(1, 67005, '\p{^Is_Scx=	_Vith}', "");
    Expect(1, 67005, '\P{Is_Scx=	_Vith}', "");
    Expect(0, 67005, '\P{^Is_Scx=	_Vith}', "");
    Error('\p{Script_Extensions:/a/WARANG_Citi}');
    Error('\P{Script_Extensions:/a/WARANG_Citi}');
    Expect(1, 71935, '\p{Script_Extensions=:\AWarang_Citi\z:}', "");;
    Expect(0, 71936, '\p{Script_Extensions=:\AWarang_Citi\z:}', "");;
    Expect(1, 71935, '\p{Script_Extensions=warangciti}', "");
    Expect(0, 71935, '\p{^Script_Extensions=warangciti}', "");
    Expect(0, 71935, '\P{Script_Extensions=warangciti}', "");
    Expect(1, 71935, '\P{^Script_Extensions=warangciti}', "");
    Expect(0, 71936, '\p{Script_Extensions=warangciti}', "");
    Expect(1, 71936, '\p{^Script_Extensions=warangciti}', "");
    Expect(1, 71936, '\P{Script_Extensions=warangciti}', "");
    Expect(0, 71936, '\P{^Script_Extensions=warangciti}', "");
    Expect(1, 71935, '\p{Script_Extensions=:\Awarangciti\z:}', "");;
    Expect(0, 71936, '\p{Script_Extensions=:\Awarangciti\z:}', "");;
    Expect(1, 71935, '\p{Script_Extensions= Warang_Citi}', "");
    Expect(0, 71935, '\p{^Script_Extensions= Warang_Citi}', "");
    Expect(0, 71935, '\P{Script_Extensions= Warang_Citi}', "");
    Expect(1, 71935, '\P{^Script_Extensions= Warang_Citi}', "");
    Expect(0, 71936, '\p{Script_Extensions= Warang_Citi}', "");
    Expect(1, 71936, '\p{^Script_Extensions= Warang_Citi}', "");
    Expect(1, 71936, '\P{Script_Extensions= Warang_Citi}', "");
    Expect(0, 71936, '\P{^Script_Extensions= Warang_Citi}', "");
    Error('\p{Scx=:=wara}');
    Error('\P{Scx=:=wara}');
    Expect(1, 71935, '\p{Scx=:\AWara\z:}', "");;
    Expect(0, 71936, '\p{Scx=:\AWara\z:}', "");;
    Expect(1, 71935, '\p{Scx=wara}', "");
    Expect(0, 71935, '\p{^Scx=wara}', "");
    Expect(0, 71935, '\P{Scx=wara}', "");
    Expect(1, 71935, '\P{^Scx=wara}', "");
    Expect(0, 71936, '\p{Scx=wara}', "");
    Expect(1, 71936, '\p{^Scx=wara}', "");
    Expect(1, 71936, '\P{Scx=wara}', "");
    Expect(0, 71936, '\P{^Scx=wara}', "");
    Expect(1, 71935, '\p{Scx=:\Awara\z:}', "");;
    Expect(0, 71936, '\p{Scx=:\Awara\z:}', "");;
    Expect(1, 71935, '\p{Scx=	-Wara}', "");
    Expect(0, 71935, '\p{^Scx=	-Wara}', "");
    Expect(0, 71935, '\P{Scx=	-Wara}', "");
    Expect(1, 71935, '\P{^Scx=	-Wara}', "");
    Expect(0, 71936, '\p{Scx=	-Wara}', "");
    Expect(1, 71936, '\p{^Scx=	-Wara}', "");
    Expect(1, 71936, '\P{Scx=	-Wara}', "");
    Expect(0, 71936, '\P{^Scx=	-Wara}', "");
    Error('\p{Is_Script_Extensions=/a/WARANG_Citi}');
    Error('\P{Is_Script_Extensions=/a/WARANG_Citi}');
    Expect(1, 71935, '\p{Is_Script_Extensions=warangciti}', "");
    Expect(0, 71935, '\p{^Is_Script_Extensions=warangciti}', "");
    Expect(0, 71935, '\P{Is_Script_Extensions=warangciti}', "");
    Expect(1, 71935, '\P{^Is_Script_Extensions=warangciti}', "");
    Expect(0, 71936, '\p{Is_Script_Extensions=warangciti}', "");
    Expect(1, 71936, '\p{^Is_Script_Extensions=warangciti}', "");
    Expect(1, 71936, '\P{Is_Script_Extensions=warangciti}', "");
    Expect(0, 71936, '\P{^Is_Script_Extensions=warangciti}', "");
    Expect(1, 71935, '\p{Is_Script_Extensions= Warang_CITI}', "");
    Expect(0, 71935, '\p{^Is_Script_Extensions= Warang_CITI}', "");
    Expect(0, 71935, '\P{Is_Script_Extensions= Warang_CITI}', "");
    Expect(1, 71935, '\P{^Is_Script_Extensions= Warang_CITI}', "");
    Expect(0, 71936, '\p{Is_Script_Extensions= Warang_CITI}', "");
    Expect(1, 71936, '\p{^Is_Script_Extensions= Warang_CITI}', "");
    Expect(1, 71936, '\P{Is_Script_Extensions= Warang_CITI}', "");
    Expect(0, 71936, '\P{^Is_Script_Extensions= Warang_CITI}', "");
    Error('\p{Is_Scx:   /a/ -WARA}');
    Error('\P{Is_Scx:   /a/ -WARA}');
    Expect(1, 71935, '\p{Is_Scx=wara}', "");
    Expect(0, 71935, '\p{^Is_Scx=wara}', "");
    Expect(0, 71935, '\P{Is_Scx=wara}', "");
    Expect(1, 71935, '\P{^Is_Scx=wara}', "");
    Expect(0, 71936, '\p{Is_Scx=wara}', "");
    Expect(1, 71936, '\p{^Is_Scx=wara}', "");
    Expect(1, 71936, '\P{Is_Scx=wara}', "");
    Expect(0, 71936, '\P{^Is_Scx=wara}', "");
    Expect(1, 71935, '\p{Is_Scx=  Wara}', "");
    Expect(0, 71935, '\p{^Is_Scx=  Wara}', "");
    Expect(0, 71935, '\P{Is_Scx=  Wara}', "");
    Expect(1, 71935, '\P{^Is_Scx=  Wara}', "");
    Expect(0, 71936, '\p{Is_Scx=  Wara}', "");
    Expect(1, 71936, '\p{^Is_Scx=  Wara}', "");
    Expect(1, 71936, '\P{Is_Scx=  Wara}', "");
    Expect(0, 71936, '\P{^Is_Scx=  Wara}', "");
    Error('\p{Script_Extensions=_ wancho:=}');
    Error('\P{Script_Extensions=_ wancho:=}');
    Expect(1, 123647, '\p{Script_Extensions=:\AWancho\z:}', "");;
    Expect(0, 123648, '\p{Script_Extensions=:\AWancho\z:}', "");;
    Expect(1, 123647, '\p{Script_Extensions=wancho}', "");
    Expect(0, 123647, '\p{^Script_Extensions=wancho}', "");
    Expect(0, 123647, '\P{Script_Extensions=wancho}', "");
    Expect(1, 123647, '\P{^Script_Extensions=wancho}', "");
    Expect(0, 123648, '\p{Script_Extensions=wancho}', "");
    Expect(1, 123648, '\p{^Script_Extensions=wancho}', "");
    Expect(1, 123648, '\P{Script_Extensions=wancho}', "");
    Expect(0, 123648, '\P{^Script_Extensions=wancho}', "");
    Expect(1, 123647, '\p{Script_Extensions=:\Awancho\z:}', "");;
    Expect(0, 123648, '\p{Script_Extensions=:\Awancho\z:}', "");;
    Expect(1, 123647, '\p{Script_Extensions=	-WANCHO}', "");
    Expect(0, 123647, '\p{^Script_Extensions=	-WANCHO}', "");
    Expect(0, 123647, '\P{Script_Extensions=	-WANCHO}', "");
    Expect(1, 123647, '\P{^Script_Extensions=	-WANCHO}', "");
    Expect(0, 123648, '\p{Script_Extensions=	-WANCHO}', "");
    Expect(1, 123648, '\p{^Script_Extensions=	-WANCHO}', "");
    Expect(1, 123648, '\P{Script_Extensions=	-WANCHO}', "");
    Expect(0, 123648, '\P{^Script_Extensions=	-WANCHO}', "");
    Error('\p{Scx=:=_ Wcho}');
    Error('\P{Scx=:=_ Wcho}');
    Expect(1, 123647, '\p{Scx=:\AWcho\z:}', "");;
    Expect(0, 123648, '\p{Scx=:\AWcho\z:}', "");;
    Expect(1, 123647, '\p{Scx=wcho}', "");
    Expect(0, 123647, '\p{^Scx=wcho}', "");
    Expect(0, 123647, '\P{Scx=wcho}', "");
    Expect(1, 123647, '\P{^Scx=wcho}', "");
    Expect(0, 123648, '\p{Scx=wcho}', "");
    Expect(1, 123648, '\p{^Scx=wcho}', "");
    Expect(1, 123648, '\P{Scx=wcho}', "");
    Expect(0, 123648, '\P{^Scx=wcho}', "");
    Expect(1, 123647, '\p{Scx=:\Awcho\z:}', "");;
    Expect(0, 123648, '\p{Scx=:\Awcho\z:}', "");;
    Expect(1, 123647, '\p{Scx=Wcho}', "");
    Expect(0, 123647, '\p{^Scx=Wcho}', "");
    Expect(0, 123647, '\P{Scx=Wcho}', "");
    Expect(1, 123647, '\P{^Scx=Wcho}', "");
    Expect(0, 123648, '\p{Scx=Wcho}', "");
    Expect(1, 123648, '\p{^Scx=Wcho}', "");
    Expect(1, 123648, '\P{Scx=Wcho}', "");
    Expect(0, 123648, '\P{^Scx=Wcho}', "");
    Error('\p{Is_Script_Extensions=-	Wancho/a/}');
    Error('\P{Is_Script_Extensions=-	Wancho/a/}');
    Expect(1, 123647, '\p{Is_Script_Extensions=wancho}', "");
    Expect(0, 123647, '\p{^Is_Script_Extensions=wancho}', "");
    Expect(0, 123647, '\P{Is_Script_Extensions=wancho}', "");
    Expect(1, 123647, '\P{^Is_Script_Extensions=wancho}', "");
    Expect(0, 123648, '\p{Is_Script_Extensions=wancho}', "");
    Expect(1, 123648, '\p{^Is_Script_Extensions=wancho}', "");
    Expect(1, 123648, '\P{Is_Script_Extensions=wancho}', "");
    Expect(0, 123648, '\P{^Is_Script_Extensions=wancho}', "");
    Expect(1, 123647, '\p{Is_Script_Extensions= _Wancho}', "");
    Expect(0, 123647, '\p{^Is_Script_Extensions= _Wancho}', "");
    Expect(0, 123647, '\P{Is_Script_Extensions= _Wancho}', "");
    Expect(1, 123647, '\P{^Is_Script_Extensions= _Wancho}', "");
    Expect(0, 123648, '\p{Is_Script_Extensions= _Wancho}', "");
    Expect(1, 123648, '\p{^Is_Script_Extensions= _Wancho}', "");
    Expect(1, 123648, '\P{Is_Script_Extensions= _Wancho}', "");
    Expect(0, 123648, '\P{^Is_Script_Extensions= _Wancho}', "");
    Error('\p{Is_Scx=:= Wcho}');
    Error('\P{Is_Scx=:= Wcho}');
    Expect(1, 123647, '\p{Is_Scx=wcho}', "");
    Expect(0, 123647, '\p{^Is_Scx=wcho}', "");
    Expect(0, 123647, '\P{Is_Scx=wcho}', "");
    Expect(1, 123647, '\P{^Is_Scx=wcho}', "");
    Expect(0, 123648, '\p{Is_Scx=wcho}', "");
    Expect(1, 123648, '\p{^Is_Scx=wcho}', "");
    Expect(1, 123648, '\P{Is_Scx=wcho}', "");
    Expect(0, 123648, '\P{^Is_Scx=wcho}', "");
    Expect(1, 123647, '\p{Is_Scx:		wcho}', "");
    Expect(0, 123647, '\p{^Is_Scx:		wcho}', "");
    Expect(0, 123647, '\P{Is_Scx:		wcho}', "");
    Expect(1, 123647, '\P{^Is_Scx:		wcho}', "");
    Expect(0, 123648, '\p{Is_Scx:		wcho}', "");
    Expect(1, 123648, '\p{^Is_Scx:		wcho}', "");
    Expect(1, 123648, '\P{Is_Scx:		wcho}', "");
    Expect(0, 123648, '\P{^Is_Scx:		wcho}', "");
    Error('\p{Script_Extensions=:= Old_Persian}');
    Error('\P{Script_Extensions=:= Old_Persian}');
    Expect(1, 66517, '\p{Script_Extensions=:\AOld_Persian\z:}', "");;
    Expect(0, 66518, '\p{Script_Extensions=:\AOld_Persian\z:}', "");;
    Expect(1, 66517, '\p{Script_Extensions=oldpersian}', "");
    Expect(0, 66517, '\p{^Script_Extensions=oldpersian}', "");
    Expect(0, 66517, '\P{Script_Extensions=oldpersian}', "");
    Expect(1, 66517, '\P{^Script_Extensions=oldpersian}', "");
    Expect(0, 66518, '\p{Script_Extensions=oldpersian}', "");
    Expect(1, 66518, '\p{^Script_Extensions=oldpersian}', "");
    Expect(1, 66518, '\P{Script_Extensions=oldpersian}', "");
    Expect(0, 66518, '\P{^Script_Extensions=oldpersian}', "");
    Expect(1, 66517, '\p{Script_Extensions=:\Aoldpersian\z:}', "");;
    Expect(0, 66518, '\p{Script_Extensions=:\Aoldpersian\z:}', "");;
    Expect(1, 66517, '\p{Script_Extensions= Old_Persian}', "");
    Expect(0, 66517, '\p{^Script_Extensions= Old_Persian}', "");
    Expect(0, 66517, '\P{Script_Extensions= Old_Persian}', "");
    Expect(1, 66517, '\P{^Script_Extensions= Old_Persian}', "");
    Expect(0, 66518, '\p{Script_Extensions= Old_Persian}', "");
    Expect(1, 66518, '\p{^Script_Extensions= Old_Persian}', "");
    Expect(1, 66518, '\P{Script_Extensions= Old_Persian}', "");
    Expect(0, 66518, '\P{^Script_Extensions= Old_Persian}', "");
    Error('\p{Scx=-/a/Xpeo}');
    Error('\P{Scx=-/a/Xpeo}');
    Expect(1, 66517, '\p{Scx=:\AXpeo\z:}', "");;
    Expect(0, 66518, '\p{Scx=:\AXpeo\z:}', "");;
    Expect(1, 66517, '\p{Scx=xpeo}', "");
    Expect(0, 66517, '\p{^Scx=xpeo}', "");
    Expect(0, 66517, '\P{Scx=xpeo}', "");
    Expect(1, 66517, '\P{^Scx=xpeo}', "");
    Expect(0, 66518, '\p{Scx=xpeo}', "");
    Expect(1, 66518, '\p{^Scx=xpeo}', "");
    Expect(1, 66518, '\P{Scx=xpeo}', "");
    Expect(0, 66518, '\P{^Scx=xpeo}', "");
    Expect(1, 66517, '\p{Scx=:\Axpeo\z:}', "");;
    Expect(0, 66518, '\p{Scx=:\Axpeo\z:}', "");;
    Expect(1, 66517, '\p{Scx=-XPEO}', "");
    Expect(0, 66517, '\p{^Scx=-XPEO}', "");
    Expect(0, 66517, '\P{Scx=-XPEO}', "");
    Expect(1, 66517, '\P{^Scx=-XPEO}', "");
    Expect(0, 66518, '\p{Scx=-XPEO}', "");
    Expect(1, 66518, '\p{^Scx=-XPEO}', "");
    Expect(1, 66518, '\P{Scx=-XPEO}', "");
    Expect(0, 66518, '\P{^Scx=-XPEO}', "");
    Error('\p{Is_Script_Extensions=-/a/Old_persian}');
    Error('\P{Is_Script_Extensions=-/a/Old_persian}');
    Expect(1, 66517, '\p{Is_Script_Extensions=oldpersian}', "");
    Expect(0, 66517, '\p{^Is_Script_Extensions=oldpersian}', "");
    Expect(0, 66517, '\P{Is_Script_Extensions=oldpersian}', "");
    Expect(1, 66517, '\P{^Is_Script_Extensions=oldpersian}', "");
    Expect(0, 66518, '\p{Is_Script_Extensions=oldpersian}', "");
    Expect(1, 66518, '\p{^Is_Script_Extensions=oldpersian}', "");
    Expect(1, 66518, '\P{Is_Script_Extensions=oldpersian}', "");
    Expect(0, 66518, '\P{^Is_Script_Extensions=oldpersian}', "");
    Expect(1, 66517, '\p{Is_Script_Extensions=	-Old_PERSIAN}', "");
    Expect(0, 66517, '\p{^Is_Script_Extensions=	-Old_PERSIAN}', "");
    Expect(0, 66517, '\P{Is_Script_Extensions=	-Old_PERSIAN}', "");
    Expect(1, 66517, '\P{^Is_Script_Extensions=	-Old_PERSIAN}', "");
    Expect(0, 66518, '\p{Is_Script_Extensions=	-Old_PERSIAN}', "");
    Expect(1, 66518, '\p{^Is_Script_Extensions=	-Old_PERSIAN}', "");
    Expect(1, 66518, '\P{Is_Script_Extensions=	-Old_PERSIAN}', "");
    Expect(0, 66518, '\P{^Is_Script_Extensions=	-Old_PERSIAN}', "");
    Error('\p{Is_Scx=-Xpeo/a/}');
    Error('\P{Is_Scx=-Xpeo/a/}');
    Expect(1, 66517, '\p{Is_Scx=xpeo}', "");
    Expect(0, 66517, '\p{^Is_Scx=xpeo}', "");
    Expect(0, 66517, '\P{Is_Scx=xpeo}', "");
    Expect(1, 66517, '\P{^Is_Scx=xpeo}', "");
    Expect(0, 66518, '\p{Is_Scx=xpeo}', "");
    Expect(1, 66518, '\p{^Is_Scx=xpeo}', "");
    Expect(1, 66518, '\P{Is_Scx=xpeo}', "");
    Expect(0, 66518, '\P{^Is_Scx=xpeo}', "");
    Expect(1, 66517, '\p{Is_Scx: --XPEO}', "");
    Expect(0, 66517, '\p{^Is_Scx: --XPEO}', "");
    Expect(0, 66517, '\P{Is_Scx: --XPEO}', "");
    Expect(1, 66517, '\P{^Is_Scx: --XPEO}', "");
    Expect(0, 66518, '\p{Is_Scx: --XPEO}', "");
    Expect(1, 66518, '\p{^Is_Scx: --XPEO}', "");
    Expect(1, 66518, '\P{Is_Scx: --XPEO}', "");
    Expect(0, 66518, '\P{^Is_Scx: --XPEO}', "");
    Error('\p{Script_Extensions=:=	_cuneiform}');
    Error('\P{Script_Extensions=:=	_cuneiform}');
    Expect(1, 75075, '\p{Script_Extensions=:\ACuneiform\z:}', "");;
    Expect(0, 75076, '\p{Script_Extensions=:\ACuneiform\z:}', "");;
    Expect(1, 75075, '\p{Script_Extensions=cuneiform}', "");
    Expect(0, 75075, '\p{^Script_Extensions=cuneiform}', "");
    Expect(0, 75075, '\P{Script_Extensions=cuneiform}', "");
    Expect(1, 75075, '\P{^Script_Extensions=cuneiform}', "");
    Expect(0, 75076, '\p{Script_Extensions=cuneiform}', "");
    Expect(1, 75076, '\p{^Script_Extensions=cuneiform}', "");
    Expect(1, 75076, '\P{Script_Extensions=cuneiform}', "");
    Expect(0, 75076, '\P{^Script_Extensions=cuneiform}', "");
    Expect(1, 75075, '\p{Script_Extensions=:\Acuneiform\z:}', "");;
    Expect(0, 75076, '\p{Script_Extensions=:\Acuneiform\z:}', "");;
    Expect(1, 75075, '\p{Script_Extensions=-_cuneiform}', "");
    Expect(0, 75075, '\p{^Script_Extensions=-_cuneiform}', "");
    Expect(0, 75075, '\P{Script_Extensions=-_cuneiform}', "");
    Expect(1, 75075, '\P{^Script_Extensions=-_cuneiform}', "");
    Expect(0, 75076, '\p{Script_Extensions=-_cuneiform}', "");
    Expect(1, 75076, '\p{^Script_Extensions=-_cuneiform}', "");
    Expect(1, 75076, '\P{Script_Extensions=-_cuneiform}', "");
    Expect(0, 75076, '\P{^Script_Extensions=-_cuneiform}', "");
    Error('\p{Scx= Xsux:=}');
    Error('\P{Scx= Xsux:=}');
    Expect(1, 75075, '\p{Scx=:\AXsux\z:}', "");;
    Expect(0, 75076, '\p{Scx=:\AXsux\z:}', "");;
    Expect(1, 75075, '\p{Scx=xsux}', "");
    Expect(0, 75075, '\p{^Scx=xsux}', "");
    Expect(0, 75075, '\P{Scx=xsux}', "");
    Expect(1, 75075, '\P{^Scx=xsux}', "");
    Expect(0, 75076, '\p{Scx=xsux}', "");
    Expect(1, 75076, '\p{^Scx=xsux}', "");
    Expect(1, 75076, '\P{Scx=xsux}', "");
    Expect(0, 75076, '\P{^Scx=xsux}', "");
    Expect(1, 75075, '\p{Scx=:\Axsux\z:}', "");;
    Expect(0, 75076, '\p{Scx=:\Axsux\z:}', "");;
    Expect(1, 75075, '\p{Scx= _Xsux}', "");
    Expect(0, 75075, '\p{^Scx= _Xsux}', "");
    Expect(0, 75075, '\P{Scx= _Xsux}', "");
    Expect(1, 75075, '\P{^Scx= _Xsux}', "");
    Expect(0, 75076, '\p{Scx= _Xsux}', "");
    Expect(1, 75076, '\p{^Scx= _Xsux}', "");
    Expect(1, 75076, '\P{Scx= _Xsux}', "");
    Expect(0, 75076, '\P{^Scx= _Xsux}', "");
    Error('\p{Is_Script_Extensions=:=__Cuneiform}');
    Error('\P{Is_Script_Extensions=:=__Cuneiform}');
    Expect(1, 75075, '\p{Is_Script_Extensions=cuneiform}', "");
    Expect(0, 75075, '\p{^Is_Script_Extensions=cuneiform}', "");
    Expect(0, 75075, '\P{Is_Script_Extensions=cuneiform}', "");
    Expect(1, 75075, '\P{^Is_Script_Extensions=cuneiform}', "");
    Expect(0, 75076, '\p{Is_Script_Extensions=cuneiform}', "");
    Expect(1, 75076, '\p{^Is_Script_Extensions=cuneiform}', "");
    Expect(1, 75076, '\P{Is_Script_Extensions=cuneiform}', "");
    Expect(0, 75076, '\P{^Is_Script_Extensions=cuneiform}', "");
    Expect(1, 75075, '\p{Is_Script_Extensions=	 CUNEIFORM}', "");
    Expect(0, 75075, '\p{^Is_Script_Extensions=	 CUNEIFORM}', "");
    Expect(0, 75075, '\P{Is_Script_Extensions=	 CUNEIFORM}', "");
    Expect(1, 75075, '\P{^Is_Script_Extensions=	 CUNEIFORM}', "");
    Expect(0, 75076, '\p{Is_Script_Extensions=	 CUNEIFORM}', "");
    Expect(1, 75076, '\p{^Is_Script_Extensions=	 CUNEIFORM}', "");
    Expect(1, 75076, '\P{Is_Script_Extensions=	 CUNEIFORM}', "");
    Expect(0, 75076, '\P{^Is_Script_Extensions=	 CUNEIFORM}', "");
    Error('\p{Is_Scx=	_Xsux:=}');
    Error('\P{Is_Scx=	_Xsux:=}');
    Expect(1, 75075, '\p{Is_Scx=xsux}', "");
    Expect(0, 75075, '\p{^Is_Scx=xsux}', "");
    Expect(0, 75075, '\P{Is_Scx=xsux}', "");
    Expect(1, 75075, '\P{^Is_Scx=xsux}', "");
    Expect(0, 75076, '\p{Is_Scx=xsux}', "");
    Expect(1, 75076, '\p{^Is_Scx=xsux}', "");
    Expect(1, 75076, '\P{Is_Scx=xsux}', "");
    Expect(0, 75076, '\P{^Is_Scx=xsux}', "");
    Expect(1, 75075, '\p{Is_Scx=-_Xsux}', "");
    Expect(0, 75075, '\p{^Is_Scx=-_Xsux}', "");
    Expect(0, 75075, '\P{Is_Scx=-_Xsux}', "");
    Expect(1, 75075, '\P{^Is_Scx=-_Xsux}', "");
    Expect(0, 75076, '\p{Is_Scx=-_Xsux}', "");
    Expect(1, 75076, '\p{^Is_Scx=-_Xsux}', "");
    Expect(1, 75076, '\P{Is_Scx=-_Xsux}', "");
    Expect(0, 75076, '\P{^Is_Scx=-_Xsux}', "");
    Error('\p{Script_Extensions=:= 	Yezidi}');
    Error('\P{Script_Extensions=:= 	Yezidi}');
    Expect(1, 69297, '\p{Script_Extensions=:\AYezidi\z:}', "");;
    Expect(0, 69298, '\p{Script_Extensions=:\AYezidi\z:}', "");;
    Expect(1, 69297, '\p{Script_Extensions=yezidi}', "");
    Expect(0, 69297, '\p{^Script_Extensions=yezidi}', "");
    Expect(0, 69297, '\P{Script_Extensions=yezidi}', "");
    Expect(1, 69297, '\P{^Script_Extensions=yezidi}', "");
    Expect(0, 69298, '\p{Script_Extensions=yezidi}', "");
    Expect(1, 69298, '\p{^Script_Extensions=yezidi}', "");
    Expect(1, 69298, '\P{Script_Extensions=yezidi}', "");
    Expect(0, 69298, '\P{^Script_Extensions=yezidi}', "");
    Expect(1, 69297, '\p{Script_Extensions=:\Ayezidi\z:}', "");;
    Expect(0, 69298, '\p{Script_Extensions=:\Ayezidi\z:}', "");;
    Expect(1, 69297, '\p{Script_Extensions=_Yezidi}', "");
    Expect(0, 69297, '\p{^Script_Extensions=_Yezidi}', "");
    Expect(0, 69297, '\P{Script_Extensions=_Yezidi}', "");
    Expect(1, 69297, '\P{^Script_Extensions=_Yezidi}', "");
    Expect(0, 69298, '\p{Script_Extensions=_Yezidi}', "");
    Expect(1, 69298, '\p{^Script_Extensions=_Yezidi}', "");
    Expect(1, 69298, '\P{Script_Extensions=_Yezidi}', "");
    Expect(0, 69298, '\P{^Script_Extensions=_Yezidi}', "");
    Error('\p{Scx=:= yezi}');
    Error('\P{Scx=:= yezi}');
    Expect(1, 69297, '\p{Scx=:\AYezi\z:}', "");;
    Expect(0, 69298, '\p{Scx=:\AYezi\z:}', "");;
    Expect(1, 69297, '\p{Scx=yezi}', "");
    Expect(0, 69297, '\p{^Scx=yezi}', "");
    Expect(0, 69297, '\P{Scx=yezi}', "");
    Expect(1, 69297, '\P{^Scx=yezi}', "");
    Expect(0, 69298, '\p{Scx=yezi}', "");
    Expect(1, 69298, '\p{^Scx=yezi}', "");
    Expect(1, 69298, '\P{Scx=yezi}', "");
    Expect(0, 69298, '\P{^Scx=yezi}', "");
    Expect(1, 69297, '\p{Scx=:\Ayezi\z:}', "");;
    Expect(0, 69298, '\p{Scx=:\Ayezi\z:}', "");;
    Expect(1, 69297, '\p{Scx=-	YEZI}', "");
    Expect(0, 69297, '\p{^Scx=-	YEZI}', "");
    Expect(0, 69297, '\P{Scx=-	YEZI}', "");
    Expect(1, 69297, '\P{^Scx=-	YEZI}', "");
    Expect(0, 69298, '\p{Scx=-	YEZI}', "");
    Expect(1, 69298, '\p{^Scx=-	YEZI}', "");
    Expect(1, 69298, '\P{Scx=-	YEZI}', "");
    Expect(0, 69298, '\P{^Scx=-	YEZI}', "");
    Error('\p{Is_Script_Extensions=_/a/Yezidi}');
    Error('\P{Is_Script_Extensions=_/a/Yezidi}');
    Expect(1, 69297, '\p{Is_Script_Extensions:   yezidi}', "");
    Expect(0, 69297, '\p{^Is_Script_Extensions:   yezidi}', "");
    Expect(0, 69297, '\P{Is_Script_Extensions:   yezidi}', "");
    Expect(1, 69297, '\P{^Is_Script_Extensions:   yezidi}', "");
    Expect(0, 69298, '\p{Is_Script_Extensions:   yezidi}', "");
    Expect(1, 69298, '\p{^Is_Script_Extensions:   yezidi}', "");
    Expect(1, 69298, '\P{Is_Script_Extensions:   yezidi}', "");
    Expect(0, 69298, '\P{^Is_Script_Extensions:   yezidi}', "");
    Expect(1, 69297, '\p{Is_Script_Extensions: _YEZIDI}', "");
    Expect(0, 69297, '\p{^Is_Script_Extensions: _YEZIDI}', "");
    Expect(0, 69297, '\P{Is_Script_Extensions: _YEZIDI}', "");
    Expect(1, 69297, '\P{^Is_Script_Extensions: _YEZIDI}', "");
    Expect(0, 69298, '\p{Is_Script_Extensions: _YEZIDI}', "");
    Expect(1, 69298, '\p{^Is_Script_Extensions: _YEZIDI}', "");
    Expect(1, 69298, '\P{Is_Script_Extensions: _YEZIDI}', "");
    Expect(0, 69298, '\P{^Is_Script_Extensions: _YEZIDI}', "");
    Error('\p{Is_Scx=/a/-	yezi}');
    Error('\P{Is_Scx=/a/-	yezi}');
    Expect(1, 69297, '\p{Is_Scx:   yezi}', "");
    Expect(0, 69297, '\p{^Is_Scx:   yezi}', "");
    Expect(0, 69297, '\P{Is_Scx:   yezi}', "");
    Expect(1, 69297, '\P{^Is_Scx:   yezi}', "");
    Expect(0, 69298, '\p{Is_Scx:   yezi}', "");
    Expect(1, 69298, '\p{^Is_Scx:   yezi}', "");
    Expect(1, 69298, '\P{Is_Scx:   yezi}', "");
    Expect(0, 69298, '\P{^Is_Scx:   yezi}', "");
    Expect(1, 69297, '\p{Is_Scx=- yezi}', "");
    Expect(0, 69297, '\p{^Is_Scx=- yezi}', "");
    Expect(0, 69297, '\P{Is_Scx=- yezi}', "");
    Expect(1, 69297, '\P{^Is_Scx=- yezi}', "");
    Expect(0, 69298, '\p{Is_Scx=- yezi}', "");
    Expect(1, 69298, '\p{^Is_Scx=- yezi}', "");
    Expect(1, 69298, '\P{Is_Scx=- yezi}', "");
    Expect(0, 69298, '\P{^Is_Scx=- yezi}', "");
    Error('\p{Script_Extensions=- Yi/a/}');
    Error('\P{Script_Extensions=- Yi/a/}');
    Expect(1, 65381, '\p{Script_Extensions=:\AYi\z:}', "");;
    Expect(0, 65382, '\p{Script_Extensions=:\AYi\z:}', "");;
    Expect(1, 65381, '\p{Script_Extensions=yi}', "");
    Expect(0, 65381, '\p{^Script_Extensions=yi}', "");
    Expect(0, 65381, '\P{Script_Extensions=yi}', "");
    Expect(1, 65381, '\P{^Script_Extensions=yi}', "");
    Expect(0, 65382, '\p{Script_Extensions=yi}', "");
    Expect(1, 65382, '\p{^Script_Extensions=yi}', "");
    Expect(1, 65382, '\P{Script_Extensions=yi}', "");
    Expect(0, 65382, '\P{^Script_Extensions=yi}', "");
    Expect(1, 65381, '\p{Script_Extensions=:\Ayi\z:}', "");;
    Expect(0, 65382, '\p{Script_Extensions=:\Ayi\z:}', "");;
    Expect(1, 65381, '\p{Script_Extensions:	 _YI}', "");
    Expect(0, 65381, '\p{^Script_Extensions:	 _YI}', "");
    Expect(0, 65381, '\P{Script_Extensions:	 _YI}', "");
    Expect(1, 65381, '\P{^Script_Extensions:	 _YI}', "");
    Expect(0, 65382, '\p{Script_Extensions:	 _YI}', "");
    Expect(1, 65382, '\p{^Script_Extensions:	 _YI}', "");
    Expect(1, 65382, '\P{Script_Extensions:	 _YI}', "");
    Expect(0, 65382, '\P{^Script_Extensions:	 _YI}', "");
    Error('\p{Scx=/a/ Yiii}');
    Error('\P{Scx=/a/ Yiii}');
    Expect(1, 65381, '\p{Scx=:\AYiii\z:}', "");;
    Expect(0, 65382, '\p{Scx=:\AYiii\z:}', "");;
    Expect(1, 65381, '\p{Scx=yiii}', "");
    Expect(0, 65381, '\p{^Scx=yiii}', "");
    Expect(0, 65381, '\P{Scx=yiii}', "");
    Expect(1, 65381, '\P{^Scx=yiii}', "");
    Expect(0, 65382, '\p{Scx=yiii}', "");
    Expect(1, 65382, '\p{^Scx=yiii}', "");
    Expect(1, 65382, '\P{Scx=yiii}', "");
    Expect(0, 65382, '\P{^Scx=yiii}', "");
    Expect(1, 65381, '\p{Scx=:\Ayiii\z:}', "");;
    Expect(0, 65382, '\p{Scx=:\Ayiii\z:}', "");;
    Expect(1, 65381, '\p{Scx:    -Yiii}', "");
    Expect(0, 65381, '\p{^Scx:    -Yiii}', "");
    Expect(0, 65381, '\P{Scx:    -Yiii}', "");
    Expect(1, 65381, '\P{^Scx:    -Yiii}', "");
    Expect(0, 65382, '\p{Scx:    -Yiii}', "");
    Expect(1, 65382, '\p{^Scx:    -Yiii}', "");
    Expect(1, 65382, '\P{Scx:    -Yiii}', "");
    Expect(0, 65382, '\P{^Scx:    -Yiii}', "");
    Error('\p{Is_Script_Extensions=yi/a/}');
    Error('\P{Is_Script_Extensions=yi/a/}');
    Expect(1, 65381, '\p{Is_Script_Extensions=yi}', "");
    Expect(0, 65381, '\p{^Is_Script_Extensions=yi}', "");
    Expect(0, 65381, '\P{Is_Script_Extensions=yi}', "");
    Expect(1, 65381, '\P{^Is_Script_Extensions=yi}', "");
    Expect(0, 65382, '\p{Is_Script_Extensions=yi}', "");
    Expect(1, 65382, '\p{^Is_Script_Extensions=yi}', "");
    Expect(1, 65382, '\P{Is_Script_Extensions=yi}', "");
    Expect(0, 65382, '\P{^Is_Script_Extensions=yi}', "");
    Expect(1, 65381, '\p{Is_Script_Extensions=	-YI}', "");
    Expect(0, 65381, '\p{^Is_Script_Extensions=	-YI}', "");
    Expect(0, 65381, '\P{Is_Script_Extensions=	-YI}', "");
    Expect(1, 65381, '\P{^Is_Script_Extensions=	-YI}', "");
    Expect(0, 65382, '\p{Is_Script_Extensions=	-YI}', "");
    Expect(1, 65382, '\p{^Is_Script_Extensions=	-YI}', "");
    Expect(1, 65382, '\P{Is_Script_Extensions=	-YI}', "");
    Expect(0, 65382, '\P{^Is_Script_Extensions=	-YI}', "");
    Error('\p{Is_Scx=/a/- Yiii}');
    Error('\P{Is_Scx=/a/- Yiii}');
    Expect(1, 65381, '\p{Is_Scx=yiii}', "");
    Expect(0, 65381, '\p{^Is_Scx=yiii}', "");
    Expect(0, 65381, '\P{Is_Scx=yiii}', "");
    Expect(1, 65381, '\P{^Is_Scx=yiii}', "");
    Expect(0, 65382, '\p{Is_Scx=yiii}', "");
    Expect(1, 65382, '\p{^Is_Scx=yiii}', "");
    Expect(1, 65382, '\P{Is_Scx=yiii}', "");
    Expect(0, 65382, '\P{^Is_Scx=yiii}', "");
    Expect(1, 65381, '\p{Is_Scx= -yiii}', "");
    Expect(0, 65381, '\p{^Is_Scx= -yiii}', "");
    Expect(0, 65381, '\P{Is_Scx= -yiii}', "");
    Expect(1, 65381, '\P{^Is_Scx= -yiii}', "");
    Expect(0, 65382, '\p{Is_Scx= -yiii}', "");
    Expect(1, 65382, '\p{^Is_Scx= -yiii}', "");
    Expect(1, 65382, '\P{Is_Scx= -yiii}', "");
    Expect(0, 65382, '\P{^Is_Scx= -yiii}', "");
    Error('\p{Script_Extensions= :=Zanabazar_Square}');
    Error('\P{Script_Extensions= :=Zanabazar_Square}');
    Expect(1, 72263, '\p{Script_Extensions=:\AZanabazar_Square\z:}', "");;
    Expect(0, 72264, '\p{Script_Extensions=:\AZanabazar_Square\z:}', "");;
    Expect(1, 72263, '\p{Script_Extensions:	zanabazarsquare}', "");
    Expect(0, 72263, '\p{^Script_Extensions:	zanabazarsquare}', "");
    Expect(0, 72263, '\P{Script_Extensions:	zanabazarsquare}', "");
    Expect(1, 72263, '\P{^Script_Extensions:	zanabazarsquare}', "");
    Expect(0, 72264, '\p{Script_Extensions:	zanabazarsquare}', "");
    Expect(1, 72264, '\p{^Script_Extensions:	zanabazarsquare}', "");
    Expect(1, 72264, '\P{Script_Extensions:	zanabazarsquare}', "");
    Expect(0, 72264, '\P{^Script_Extensions:	zanabazarsquare}', "");
    Expect(1, 72263, '\p{Script_Extensions=:\Azanabazarsquare\z:}', "");;
    Expect(0, 72264, '\p{Script_Extensions=:\Azanabazarsquare\z:}', "");;
    Expect(1, 72263, '\p{Script_Extensions=Zanabazar_Square}', "");
    Expect(0, 72263, '\p{^Script_Extensions=Zanabazar_Square}', "");
    Expect(0, 72263, '\P{Script_Extensions=Zanabazar_Square}', "");
    Expect(1, 72263, '\P{^Script_Extensions=Zanabazar_Square}', "");
    Expect(0, 72264, '\p{Script_Extensions=Zanabazar_Square}', "");
    Expect(1, 72264, '\p{^Script_Extensions=Zanabazar_Square}', "");
    Expect(1, 72264, '\P{Script_Extensions=Zanabazar_Square}', "");
    Expect(0, 72264, '\P{^Script_Extensions=Zanabazar_Square}', "");
    Error('\p{Scx=	/a/Zanb}');
    Error('\P{Scx=	/a/Zanb}');
    Expect(1, 72263, '\p{Scx=:\AZanb\z:}', "");;
    Expect(0, 72264, '\p{Scx=:\AZanb\z:}', "");;
    Expect(1, 72263, '\p{Scx=zanb}', "");
    Expect(0, 72263, '\p{^Scx=zanb}', "");
    Expect(0, 72263, '\P{Scx=zanb}', "");
    Expect(1, 72263, '\P{^Scx=zanb}', "");
    Expect(0, 72264, '\p{Scx=zanb}', "");
    Expect(1, 72264, '\p{^Scx=zanb}', "");
    Expect(1, 72264, '\P{Scx=zanb}', "");
    Expect(0, 72264, '\P{^Scx=zanb}', "");
    Expect(1, 72263, '\p{Scx=:\Azanb\z:}', "");;
    Expect(0, 72264, '\p{Scx=:\Azanb\z:}', "");;
    Expect(1, 72263, '\p{Scx:-zanb}', "");
    Expect(0, 72263, '\p{^Scx:-zanb}', "");
    Expect(0, 72263, '\P{Scx:-zanb}', "");
    Expect(1, 72263, '\P{^Scx:-zanb}', "");
    Expect(0, 72264, '\p{Scx:-zanb}', "");
    Expect(1, 72264, '\p{^Scx:-zanb}', "");
    Expect(1, 72264, '\P{Scx:-zanb}', "");
    Expect(0, 72264, '\P{^Scx:-zanb}', "");
    Error('\p{Is_Script_Extensions=_ ZANABAZAR_square/a/}');
    Error('\P{Is_Script_Extensions=_ ZANABAZAR_square/a/}');
    Expect(1, 72263, '\p{Is_Script_Extensions=zanabazarsquare}', "");
    Expect(0, 72263, '\p{^Is_Script_Extensions=zanabazarsquare}', "");
    Expect(0, 72263, '\P{Is_Script_Extensions=zanabazarsquare}', "");
    Expect(1, 72263, '\P{^Is_Script_Extensions=zanabazarsquare}', "");
    Expect(0, 72264, '\p{Is_Script_Extensions=zanabazarsquare}', "");
    Expect(1, 72264, '\p{^Is_Script_Extensions=zanabazarsquare}', "");
    Expect(1, 72264, '\P{Is_Script_Extensions=zanabazarsquare}', "");
    Expect(0, 72264, '\P{^Is_Script_Extensions=zanabazarsquare}', "");
    Expect(1, 72263, '\p{Is_Script_Extensions=- Zanabazar_SQUARE}', "");
    Expect(0, 72263, '\p{^Is_Script_Extensions=- Zanabazar_SQUARE}', "");
    Expect(0, 72263, '\P{Is_Script_Extensions=- Zanabazar_SQUARE}', "");
    Expect(1, 72263, '\P{^Is_Script_Extensions=- Zanabazar_SQUARE}', "");
    Expect(0, 72264, '\p{Is_Script_Extensions=- Zanabazar_SQUARE}', "");
    Expect(1, 72264, '\p{^Is_Script_Extensions=- Zanabazar_SQUARE}', "");
    Expect(1, 72264, '\P{Is_Script_Extensions=- Zanabazar_SQUARE}', "");
    Expect(0, 72264, '\P{^Is_Script_Extensions=- Zanabazar_SQUARE}', "");
    Error('\p{Is_Scx=/a/ZANB}');
    Error('\P{Is_Scx=/a/ZANB}');
    Expect(1, 72263, '\p{Is_Scx=zanb}', "");
    Expect(0, 72263, '\p{^Is_Scx=zanb}', "");
    Expect(0, 72263, '\P{Is_Scx=zanb}', "");
    Expect(1, 72263, '\P{^Is_Scx=zanb}', "");
    Expect(0, 72264, '\p{Is_Scx=zanb}', "");
    Expect(1, 72264, '\p{^Is_Scx=zanb}', "");
    Expect(1, 72264, '\P{Is_Scx=zanb}', "");
    Expect(0, 72264, '\P{^Is_Scx=zanb}', "");
    Expect(1, 72263, '\p{Is_Scx=  Zanb}', "");
    Expect(0, 72263, '\p{^Is_Scx=  Zanb}', "");
    Expect(0, 72263, '\P{Is_Scx=  Zanb}', "");
    Expect(1, 72263, '\P{^Is_Scx=  Zanb}', "");
    Expect(0, 72264, '\p{Is_Scx=  Zanb}', "");
    Expect(1, 72264, '\p{^Is_Scx=  Zanb}', "");
    Expect(1, 72264, '\P{Is_Scx=  Zanb}', "");
    Expect(0, 72264, '\P{^Is_Scx=  Zanb}', "");
    Error('\p{Script_Extensions=_:=inherited}');
    Error('\P{Script_Extensions=_:=inherited}');
    Expect(1, 917999, '\p{Script_Extensions=:\AInherited\z:}', "");;
    Expect(0, 918000, '\p{Script_Extensions=:\AInherited\z:}', "");;
    Expect(1, 917999, '\p{Script_Extensions=inherited}', "");
    Expect(0, 917999, '\p{^Script_Extensions=inherited}', "");
    Expect(0, 917999, '\P{Script_Extensions=inherited}', "");
    Expect(1, 917999, '\P{^Script_Extensions=inherited}', "");
    Expect(0, 918000, '\p{Script_Extensions=inherited}', "");
    Expect(1, 918000, '\p{^Script_Extensions=inherited}', "");
    Expect(1, 918000, '\P{Script_Extensions=inherited}', "");
    Expect(0, 918000, '\P{^Script_Extensions=inherited}', "");
    Expect(1, 917999, '\p{Script_Extensions=:\Ainherited\z:}', "");;
    Expect(0, 918000, '\p{Script_Extensions=:\Ainherited\z:}', "");;
    Expect(1, 917999, '\p{Script_Extensions=- Inherited}', "");
    Expect(0, 917999, '\p{^Script_Extensions=- Inherited}', "");
    Expect(0, 917999, '\P{Script_Extensions=- Inherited}', "");
    Expect(1, 917999, '\P{^Script_Extensions=- Inherited}', "");
    Expect(0, 918000, '\p{Script_Extensions=- Inherited}', "");
    Expect(1, 918000, '\p{^Script_Extensions=- Inherited}', "");
    Expect(1, 918000, '\P{Script_Extensions=- Inherited}', "");
    Expect(0, 918000, '\P{^Script_Extensions=- Inherited}', "");
    Error('\p{Scx=-:=Zinh}');
    Error('\P{Scx=-:=Zinh}');
    Expect(1, 917999, '\p{Scx=:\AZinh\z:}', "");;
    Expect(0, 918000, '\p{Scx=:\AZinh\z:}', "");;
    Expect(1, 917999, '\p{Scx=zinh}', "");
    Expect(0, 917999, '\p{^Scx=zinh}', "");
    Expect(0, 917999, '\P{Scx=zinh}', "");
    Expect(1, 917999, '\P{^Scx=zinh}', "");
    Expect(0, 918000, '\p{Scx=zinh}', "");
    Expect(1, 918000, '\p{^Scx=zinh}', "");
    Expect(1, 918000, '\P{Scx=zinh}', "");
    Expect(0, 918000, '\P{^Scx=zinh}', "");
    Expect(1, 917999, '\p{Scx=:\Azinh\z:}', "");;
    Expect(0, 918000, '\p{Scx=:\Azinh\z:}', "");;
    Expect(1, 917999, '\p{Scx=		zinh}', "");
    Expect(0, 917999, '\p{^Scx=		zinh}', "");
    Expect(0, 917999, '\P{Scx=		zinh}', "");
    Expect(1, 917999, '\P{^Scx=		zinh}', "");
    Expect(0, 918000, '\p{Scx=		zinh}', "");
    Expect(1, 918000, '\p{^Scx=		zinh}', "");
    Expect(1, 918000, '\P{Scx=		zinh}', "");
    Expect(0, 918000, '\P{^Scx=		zinh}', "");
    Error('\p{Is_Script_Extensions=/a/- Qaai}');
    Error('\P{Is_Script_Extensions=/a/- Qaai}');
    Expect(1, 917999, '\p{Is_Script_Extensions=qaai}', "");
    Expect(0, 917999, '\p{^Is_Script_Extensions=qaai}', "");
    Expect(0, 917999, '\P{Is_Script_Extensions=qaai}', "");
    Expect(1, 917999, '\P{^Is_Script_Extensions=qaai}', "");
    Expect(0, 918000, '\p{Is_Script_Extensions=qaai}', "");
    Expect(1, 918000, '\p{^Is_Script_Extensions=qaai}', "");
    Expect(1, 918000, '\P{Is_Script_Extensions=qaai}', "");
    Expect(0, 918000, '\P{^Is_Script_Extensions=qaai}', "");
    Expect(1, 917999, '\p{Is_Script_Extensions=_-Qaai}', "");
    Expect(0, 917999, '\p{^Is_Script_Extensions=_-Qaai}', "");
    Expect(0, 917999, '\P{Is_Script_Extensions=_-Qaai}', "");
    Expect(1, 917999, '\P{^Is_Script_Extensions=_-Qaai}', "");
    Expect(0, 918000, '\p{Is_Script_Extensions=_-Qaai}', "");
    Expect(1, 918000, '\p{^Is_Script_Extensions=_-Qaai}', "");
    Expect(1, 918000, '\P{Is_Script_Extensions=_-Qaai}', "");
    Expect(0, 918000, '\P{^Is_Script_Extensions=_-Qaai}', "");
    Error('\p{Is_Scx=/a/	-Inherited}');
    Error('\P{Is_Scx=/a/	-Inherited}');
    Expect(1, 917999, '\p{Is_Scx=inherited}', "");
    Expect(0, 917999, '\p{^Is_Scx=inherited}', "");
    Expect(0, 917999, '\P{Is_Scx=inherited}', "");
    Expect(1, 917999, '\P{^Is_Scx=inherited}', "");
    Expect(0, 918000, '\p{Is_Scx=inherited}', "");
    Expect(1, 918000, '\p{^Is_Scx=inherited}', "");
    Expect(1, 918000, '\P{Is_Scx=inherited}', "");
    Expect(0, 918000, '\P{^Is_Scx=inherited}', "");
    Expect(1, 917999, '\p{Is_Scx= Inherited}', "");
    Expect(0, 917999, '\p{^Is_Scx= Inherited}', "");
    Expect(0, 917999, '\P{Is_Scx= Inherited}', "");
    Expect(1, 917999, '\P{^Is_Scx= Inherited}', "");
    Expect(0, 918000, '\p{Is_Scx= Inherited}', "");
    Expect(1, 918000, '\p{^Is_Scx= Inherited}', "");
    Expect(1, 918000, '\P{Is_Scx= Inherited}', "");
    Expect(0, 918000, '\P{^Is_Scx= Inherited}', "");
    Error('\p{Script_Extensions: /a/Common}');
    Error('\P{Script_Extensions: /a/Common}');
    Expect(1, 917631, '\p{Script_Extensions=:\ACommon\z:}', "");;
    Expect(0, 917632, '\p{Script_Extensions=:\ACommon\z:}', "");;
    Expect(1, 917631, '\p{Script_Extensions=common}', "");
    Expect(0, 917631, '\p{^Script_Extensions=common}', "");
    Expect(0, 917631, '\P{Script_Extensions=common}', "");
    Expect(1, 917631, '\P{^Script_Extensions=common}', "");
    Expect(0, 917632, '\p{Script_Extensions=common}', "");
    Expect(1, 917632, '\p{^Script_Extensions=common}', "");
    Expect(1, 917632, '\P{Script_Extensions=common}', "");
    Expect(0, 917632, '\P{^Script_Extensions=common}', "");
    Expect(1, 917631, '\p{Script_Extensions=:\Acommon\z:}', "");;
    Expect(0, 917632, '\p{Script_Extensions=:\Acommon\z:}', "");;
    Expect(1, 917631, '\p{Script_Extensions= -COMMON}', "");
    Expect(0, 917631, '\p{^Script_Extensions= -COMMON}', "");
    Expect(0, 917631, '\P{Script_Extensions= -COMMON}', "");
    Expect(1, 917631, '\P{^Script_Extensions= -COMMON}', "");
    Expect(0, 917632, '\p{Script_Extensions= -COMMON}', "");
    Expect(1, 917632, '\p{^Script_Extensions= -COMMON}', "");
    Expect(1, 917632, '\P{Script_Extensions= -COMMON}', "");
    Expect(0, 917632, '\P{^Script_Extensions= -COMMON}', "");
    Error('\p{Scx=/a/_Zyyy}');
    Error('\P{Scx=/a/_Zyyy}');
    Expect(1, 917631, '\p{Scx=:\AZyyy\z:}', "");;
    Expect(0, 917632, '\p{Scx=:\AZyyy\z:}', "");;
    Expect(1, 917631, '\p{Scx=zyyy}', "");
    Expect(0, 917631, '\p{^Scx=zyyy}', "");
    Expect(0, 917631, '\P{Scx=zyyy}', "");
    Expect(1, 917631, '\P{^Scx=zyyy}', "");
    Expect(0, 917632, '\p{Scx=zyyy}', "");
    Expect(1, 917632, '\p{^Scx=zyyy}', "");
    Expect(1, 917632, '\P{Scx=zyyy}', "");
    Expect(0, 917632, '\P{^Scx=zyyy}', "");
    Expect(1, 917631, '\p{Scx=:\Azyyy\z:}', "");;
    Expect(0, 917632, '\p{Scx=:\Azyyy\z:}', "");;
    Expect(1, 917631, '\p{Scx=- ZYYY}', "");
    Expect(0, 917631, '\p{^Scx=- ZYYY}', "");
    Expect(0, 917631, '\P{Scx=- ZYYY}', "");
    Expect(1, 917631, '\P{^Scx=- ZYYY}', "");
    Expect(0, 917632, '\p{Scx=- ZYYY}', "");
    Expect(1, 917632, '\p{^Scx=- ZYYY}', "");
    Expect(1, 917632, '\P{Scx=- ZYYY}', "");
    Expect(0, 917632, '\P{^Scx=- ZYYY}', "");
    Error('\p{Is_Script_Extensions=:=	Common}');
    Error('\P{Is_Script_Extensions=:=	Common}');
    Expect(1, 917631, '\p{Is_Script_Extensions=common}', "");
    Expect(0, 917631, '\p{^Is_Script_Extensions=common}', "");
    Expect(0, 917631, '\P{Is_Script_Extensions=common}', "");
    Expect(1, 917631, '\P{^Is_Script_Extensions=common}', "");
    Expect(0, 917632, '\p{Is_Script_Extensions=common}', "");
    Expect(1, 917632, '\p{^Is_Script_Extensions=common}', "");
    Expect(1, 917632, '\P{Is_Script_Extensions=common}', "");
    Expect(0, 917632, '\P{^Is_Script_Extensions=common}', "");
    Expect(1, 917631, '\p{Is_Script_Extensions=-_Common}', "");
    Expect(0, 917631, '\p{^Is_Script_Extensions=-_Common}', "");
    Expect(0, 917631, '\P{Is_Script_Extensions=-_Common}', "");
    Expect(1, 917631, '\P{^Is_Script_Extensions=-_Common}', "");
    Expect(0, 917632, '\p{Is_Script_Extensions=-_Common}', "");
    Expect(1, 917632, '\p{^Is_Script_Extensions=-_Common}', "");
    Expect(1, 917632, '\P{Is_Script_Extensions=-_Common}', "");
    Expect(0, 917632, '\P{^Is_Script_Extensions=-_Common}', "");
    Error('\p{Is_Scx=:=Zyyy}');
    Error('\P{Is_Scx=:=Zyyy}');
    Expect(1, 917631, '\p{Is_Scx=zyyy}', "");
    Expect(0, 917631, '\p{^Is_Scx=zyyy}', "");
    Expect(0, 917631, '\P{Is_Scx=zyyy}', "");
    Expect(1, 917631, '\P{^Is_Scx=zyyy}', "");
    Expect(0, 917632, '\p{Is_Scx=zyyy}', "");
    Expect(1, 917632, '\p{^Is_Scx=zyyy}', "");
    Expect(1, 917632, '\P{Is_Scx=zyyy}', "");
    Expect(0, 917632, '\P{^Is_Scx=zyyy}', "");
    Expect(1, 917631, '\p{Is_Scx=- zyyy}', "");
    Expect(0, 917631, '\p{^Is_Scx=- zyyy}', "");
    Expect(0, 917631, '\P{Is_Scx=- zyyy}', "");
    Expect(1, 917631, '\P{^Is_Scx=- zyyy}', "");
    Expect(0, 917632, '\p{Is_Scx=- zyyy}', "");
    Expect(1, 917632, '\p{^Is_Scx=- zyyy}', "");
    Expect(1, 917632, '\P{Is_Scx=- zyyy}', "");
    Expect(0, 917632, '\P{^Is_Scx=- zyyy}', "");
    Error('\p{Script_Extensions=/a/_Unknown}');
    Error('\P{Script_Extensions=/a/_Unknown}');
    Expect(1, 918000, '\p{Script_Extensions=:\AUnknown\z:}', "");;
    Expect(0, 917999, '\p{Script_Extensions=:\AUnknown\z:}', "");;
    Expect(1, 918000, '\p{Script_Extensions=unknown}', "");
    Expect(0, 918000, '\p{^Script_Extensions=unknown}', "");
    Expect(0, 918000, '\P{Script_Extensions=unknown}', "");
    Expect(1, 918000, '\P{^Script_Extensions=unknown}', "");
    Expect(0, 917999, '\p{Script_Extensions=unknown}', "");
    Expect(1, 917999, '\p{^Script_Extensions=unknown}', "");
    Expect(1, 917999, '\P{Script_Extensions=unknown}', "");
    Expect(0, 917999, '\P{^Script_Extensions=unknown}', "");
    Expect(1, 918000, '\p{Script_Extensions=:\Aunknown\z:}', "");;
    Expect(0, 917999, '\p{Script_Extensions=:\Aunknown\z:}', "");;
    Expect(1, 918000, '\p{Script_Extensions=	_Unknown}', "");
    Expect(0, 918000, '\p{^Script_Extensions=	_Unknown}', "");
    Expect(0, 918000, '\P{Script_Extensions=	_Unknown}', "");
    Expect(1, 918000, '\P{^Script_Extensions=	_Unknown}', "");
    Expect(0, 917999, '\p{Script_Extensions=	_Unknown}', "");
    Expect(1, 917999, '\p{^Script_Extensions=	_Unknown}', "");
    Expect(1, 917999, '\P{Script_Extensions=	_Unknown}', "");
    Expect(0, 917999, '\P{^Script_Extensions=	_Unknown}', "");
    Error('\p{Scx=:=zzzz}');
    Error('\P{Scx=:=zzzz}');
    Expect(1, 918000, '\p{Scx=:\AZzzz\z:}', "");;
    Expect(0, 917999, '\p{Scx=:\AZzzz\z:}', "");;
    Expect(1, 918000, '\p{Scx=zzzz}', "");
    Expect(0, 918000, '\p{^Scx=zzzz}', "");
    Expect(0, 918000, '\P{Scx=zzzz}', "");
    Expect(1, 918000, '\P{^Scx=zzzz}', "");
    Expect(0, 917999, '\p{Scx=zzzz}', "");
    Expect(1, 917999, '\p{^Scx=zzzz}', "");
    Expect(1, 917999, '\P{Scx=zzzz}', "");
    Expect(0, 917999, '\P{^Scx=zzzz}', "");
    Expect(1, 918000, '\p{Scx=:\Azzzz\z:}', "");;
    Expect(0, 917999, '\p{Scx=:\Azzzz\z:}', "");;
    Expect(1, 918000, '\p{Scx=	 ZZZZ}', "");
    Expect(0, 918000, '\p{^Scx=	 ZZZZ}', "");
    Expect(0, 918000, '\P{Scx=	 ZZZZ}', "");
    Expect(1, 918000, '\P{^Scx=	 ZZZZ}', "");
    Expect(0, 917999, '\p{Scx=	 ZZZZ}', "");
    Expect(1, 917999, '\p{^Scx=	 ZZZZ}', "");
    Expect(1, 917999, '\P{Scx=	 ZZZZ}', "");
    Expect(0, 917999, '\P{^Scx=	 ZZZZ}', "");
    Error('\p{Is_Script_Extensions=-UNKNOWN:=}');
    Error('\P{Is_Script_Extensions=-UNKNOWN:=}');
    Expect(1, 918000, '\p{Is_Script_Extensions=unknown}', "");
    Expect(0, 918000, '\p{^Is_Script_Extensions=unknown}', "");
    Expect(0, 918000, '\P{Is_Script_Extensions=unknown}', "");
    Expect(1, 918000, '\P{^Is_Script_Extensions=unknown}', "");
    Expect(0, 917999, '\p{Is_Script_Extensions=unknown}', "");
    Expect(1, 917999, '\p{^Is_Script_Extensions=unknown}', "");
    Expect(1, 917999, '\P{Is_Script_Extensions=unknown}', "");
    Expect(0, 917999, '\P{^Is_Script_Extensions=unknown}', "");
    Expect(1, 918000, '\p{Is_Script_Extensions=	Unknown}', "");
    Expect(0, 918000, '\p{^Is_Script_Extensions=	Unknown}', "");
    Expect(0, 918000, '\P{Is_Script_Extensions=	Unknown}', "");
    Expect(1, 918000, '\P{^Is_Script_Extensions=	Unknown}', "");
    Expect(0, 917999, '\p{Is_Script_Extensions=	Unknown}', "");
    Expect(1, 917999, '\p{^Is_Script_Extensions=	Unknown}', "");
    Expect(1, 917999, '\P{Is_Script_Extensions=	Unknown}', "");
    Expect(0, 917999, '\P{^Is_Script_Extensions=	Unknown}', "");
    Error('\p{Is_Scx:	_/a/ZZZZ}');
    Error('\P{Is_Scx:	_/a/ZZZZ}');
    Expect(1, 918000, '\p{Is_Scx=zzzz}', "");
    Expect(0, 918000, '\p{^Is_Scx=zzzz}', "");
    Expect(0, 918000, '\P{Is_Scx=zzzz}', "");
    Expect(1, 918000, '\P{^Is_Scx=zzzz}', "");
    Expect(0, 917999, '\p{Is_Scx=zzzz}', "");
    Expect(1, 917999, '\p{^Is_Scx=zzzz}', "");
    Expect(1, 917999, '\P{Is_Scx=zzzz}', "");
    Expect(0, 917999, '\P{^Is_Scx=zzzz}', "");
    Expect(1, 918000, '\p{Is_Scx=__ZZZZ}', "");
    Expect(0, 918000, '\p{^Is_Scx=__ZZZZ}', "");
    Expect(0, 918000, '\P{Is_Scx=__ZZZZ}', "");
    Expect(1, 918000, '\P{^Is_Scx=__ZZZZ}', "");
    Expect(0, 917999, '\p{Is_Scx=__ZZZZ}', "");
    Expect(1, 917999, '\p{^Is_Scx=__ZZZZ}', "");
    Expect(1, 917999, '\P{Is_Scx=__ZZZZ}', "");
    Expect(0, 917999, '\P{^Is_Scx=__ZZZZ}', "");
    Error('\p{Soft_Dotted=:=--No}');
    Error('\P{Soft_Dotted=:=--No}');
    Expect(1, 122985, '\p{Soft_Dotted=:\ANo\z:}', "");;
    Expect(0, 122984, '\p{Soft_Dotted=:\ANo\z:}', "");;
    Expect(1, 122985, '\p{Soft_Dotted=no}', "");
    Expect(0, 122985, '\p{^Soft_Dotted=no}', "");
    Expect(0, 122985, '\P{Soft_Dotted=no}', "");
    Expect(1, 122985, '\P{^Soft_Dotted=no}', "");
    Expect(0, 122984, '\p{Soft_Dotted=no}', "");
    Expect(1, 122984, '\p{^Soft_Dotted=no}', "");
    Expect(1, 122984, '\P{Soft_Dotted=no}', "");
    Expect(0, 122984, '\P{^Soft_Dotted=no}', "");
    Expect(1, 122985, '\p{Soft_Dotted=:\Ano\z:}', "");;
    Expect(0, 122984, '\p{Soft_Dotted=:\Ano\z:}', "");;
    Expect(1, 122985, '\p{Soft_Dotted:   _-NO}', "");
    Expect(0, 122985, '\p{^Soft_Dotted:   _-NO}', "");
    Expect(0, 122985, '\P{Soft_Dotted:   _-NO}', "");
    Expect(1, 122985, '\P{^Soft_Dotted:   _-NO}', "");
    Expect(0, 122984, '\p{Soft_Dotted:   _-NO}', "");
    Expect(1, 122984, '\p{^Soft_Dotted:   _-NO}', "");
    Expect(1, 122984, '\P{Soft_Dotted:   _-NO}', "");
    Expect(0, 122984, '\P{^Soft_Dotted:   _-NO}', "");
    Error('\p{SD=:=	-N}');
    Error('\P{SD=:=	-N}');
    Expect(1, 122985, '\p{SD=:\AN\z:}', "");;
    Expect(0, 122984, '\p{SD=:\AN\z:}', "");;
    Expect(1, 122985, '\p{SD=n}', "");
    Expect(0, 122985, '\p{^SD=n}', "");
    Expect(0, 122985, '\P{SD=n}', "");
    Expect(1, 122985, '\P{^SD=n}', "");
    Expect(0, 122984, '\p{SD=n}', "");
    Expect(1, 122984, '\p{^SD=n}', "");
    Expect(1, 122984, '\P{SD=n}', "");
    Expect(0, 122984, '\P{^SD=n}', "");
    Expect(1, 122985, '\p{SD=:\An\z:}', "");;
    Expect(0, 122984, '\p{SD=:\An\z:}', "");;
    Expect(1, 122985, '\p{SD=- N}', "");
    Expect(0, 122985, '\p{^SD=- N}', "");
    Expect(0, 122985, '\P{SD=- N}', "");
    Expect(1, 122985, '\P{^SD=- N}', "");
    Expect(0, 122984, '\p{SD=- N}', "");
    Expect(1, 122984, '\p{^SD=- N}', "");
    Expect(1, 122984, '\P{SD=- N}', "");
    Expect(0, 122984, '\P{^SD=- N}', "");
    Error('\p{Is_Soft_Dotted= :=F}');
    Error('\P{Is_Soft_Dotted= :=F}');
    Expect(1, 122985, '\p{Is_Soft_Dotted=f}', "");
    Expect(0, 122985, '\p{^Is_Soft_Dotted=f}', "");
    Expect(0, 122985, '\P{Is_Soft_Dotted=f}', "");
    Expect(1, 122985, '\P{^Is_Soft_Dotted=f}', "");
    Expect(0, 122984, '\p{Is_Soft_Dotted=f}', "");
    Expect(1, 122984, '\p{^Is_Soft_Dotted=f}', "");
    Expect(1, 122984, '\P{Is_Soft_Dotted=f}', "");
    Expect(0, 122984, '\P{^Is_Soft_Dotted=f}', "");
    Expect(1, 122985, '\p{Is_Soft_Dotted=-_f}', "");
    Expect(0, 122985, '\p{^Is_Soft_Dotted=-_f}', "");
    Expect(0, 122985, '\P{Is_Soft_Dotted=-_f}', "");
    Expect(1, 122985, '\P{^Is_Soft_Dotted=-_f}', "");
    Expect(0, 122984, '\p{Is_Soft_Dotted=-_f}', "");
    Expect(1, 122984, '\p{^Is_Soft_Dotted=-_f}', "");
    Expect(1, 122984, '\P{Is_Soft_Dotted=-_f}', "");
    Expect(0, 122984, '\P{^Is_Soft_Dotted=-_f}', "");
    Error('\p{Is_SD=:=false}');
    Error('\P{Is_SD=:=false}');
    Expect(1, 122985, '\p{Is_SD=false}', "");
    Expect(0, 122985, '\p{^Is_SD=false}', "");
    Expect(0, 122985, '\P{Is_SD=false}', "");
    Expect(1, 122985, '\P{^Is_SD=false}', "");
    Expect(0, 122984, '\p{Is_SD=false}', "");
    Expect(1, 122984, '\p{^Is_SD=false}', "");
    Expect(1, 122984, '\P{Is_SD=false}', "");
    Expect(0, 122984, '\P{^Is_SD=false}', "");
    Expect(1, 122985, '\p{Is_SD=--False}', "");
    Expect(0, 122985, '\p{^Is_SD=--False}', "");
    Expect(0, 122985, '\P{Is_SD=--False}', "");
    Expect(1, 122985, '\P{^Is_SD=--False}', "");
    Expect(0, 122984, '\p{Is_SD=--False}', "");
    Expect(1, 122984, '\p{^Is_SD=--False}', "");
    Expect(1, 122984, '\P{Is_SD=--False}', "");
    Expect(0, 122984, '\P{^Is_SD=--False}', "");
    Error('\p{Soft_Dotted=-Yes/a/}');
    Error('\P{Soft_Dotted=-Yes/a/}');
    Expect(1, 122984, '\p{Soft_Dotted=:\AYes\z:}', "");;
    Expect(0, 122985, '\p{Soft_Dotted=:\AYes\z:}', "");;
    Expect(1, 122984, '\p{Soft_Dotted=yes}', "");
    Expect(0, 122984, '\p{^Soft_Dotted=yes}', "");
    Expect(0, 122984, '\P{Soft_Dotted=yes}', "");
    Expect(1, 122984, '\P{^Soft_Dotted=yes}', "");
    Expect(0, 122985, '\p{Soft_Dotted=yes}', "");
    Expect(1, 122985, '\p{^Soft_Dotted=yes}', "");
    Expect(1, 122985, '\P{Soft_Dotted=yes}', "");
    Expect(0, 122985, '\P{^Soft_Dotted=yes}', "");
    Expect(1, 122984, '\p{Soft_Dotted=:\Ayes\z:}', "");;
    Expect(0, 122985, '\p{Soft_Dotted=:\Ayes\z:}', "");;
    Expect(1, 122984, '\p{Soft_Dotted=-Yes}', "");
    Expect(0, 122984, '\p{^Soft_Dotted=-Yes}', "");
    Expect(0, 122984, '\P{Soft_Dotted=-Yes}', "");
    Expect(1, 122984, '\P{^Soft_Dotted=-Yes}', "");
    Expect(0, 122985, '\p{Soft_Dotted=-Yes}', "");
    Expect(1, 122985, '\p{^Soft_Dotted=-Yes}', "");
    Expect(1, 122985, '\P{Soft_Dotted=-Yes}', "");
    Expect(0, 122985, '\P{^Soft_Dotted=-Yes}', "");
    Error('\p{SD=/a/ -Y}');
    Error('\P{SD=/a/ -Y}');
    Expect(1, 122984, '\p{SD=:\AY\z:}', "");;
    Expect(0, 122985, '\p{SD=:\AY\z:}', "");;
    Expect(1, 122984, '\p{SD:	y}', "");
    Expect(0, 122984, '\p{^SD:	y}', "");
    Expect(0, 122984, '\P{SD:	y}', "");
    Expect(1, 122984, '\P{^SD:	y}', "");
    Expect(0, 122985, '\p{SD:	y}', "");
    Expect(1, 122985, '\p{^SD:	y}', "");
    Expect(1, 122985, '\P{SD:	y}', "");
    Expect(0, 122985, '\P{^SD:	y}', "");
    Expect(1, 122984, '\p{SD=:\Ay\z:}', "");;
    Expect(0, 122985, '\p{SD=:\Ay\z:}', "");;
    Expect(1, 122984, '\p{SD=-Y}', "");
    Expect(0, 122984, '\p{^SD=-Y}', "");
    Expect(0, 122984, '\P{SD=-Y}', "");
    Expect(1, 122984, '\P{^SD=-Y}', "");
    Expect(0, 122985, '\p{SD=-Y}', "");
    Expect(1, 122985, '\p{^SD=-Y}', "");
    Expect(1, 122985, '\P{SD=-Y}', "");
    Expect(0, 122985, '\P{^SD=-Y}', "");
    Error('\p{Is_Soft_Dotted= /a/T}');
    Error('\P{Is_Soft_Dotted= /a/T}');
    Expect(1, 122984, '\p{Is_Soft_Dotted:   t}', "");
    Expect(0, 122984, '\p{^Is_Soft_Dotted:   t}', "");
    Expect(0, 122984, '\P{Is_Soft_Dotted:   t}', "");
    Expect(1, 122984, '\P{^Is_Soft_Dotted:   t}', "");
    Expect(0, 122985, '\p{Is_Soft_Dotted:   t}', "");
    Expect(1, 122985, '\p{^Is_Soft_Dotted:   t}', "");
    Expect(1, 122985, '\P{Is_Soft_Dotted:   t}', "");
    Expect(0, 122985, '\P{^Is_Soft_Dotted:   t}', "");
    Expect(1, 122984, '\p{Is_Soft_Dotted= 	t}', "");
    Expect(0, 122984, '\p{^Is_Soft_Dotted= 	t}', "");
    Expect(0, 122984, '\P{Is_Soft_Dotted= 	t}', "");
    Expect(1, 122984, '\P{^Is_Soft_Dotted= 	t}', "");
    Expect(0, 122985, '\p{Is_Soft_Dotted= 	t}', "");
    Expect(1, 122985, '\p{^Is_Soft_Dotted= 	t}', "");
    Expect(1, 122985, '\P{Is_Soft_Dotted= 	t}', "");
    Expect(0, 122985, '\P{^Is_Soft_Dotted= 	t}', "");
    Error('\p{Is_SD=_-TRUE/a/}');
    Error('\P{Is_SD=_-TRUE/a/}');
    Expect(1, 122984, '\p{Is_SD: true}', "");
    Expect(0, 122984, '\p{^Is_SD: true}', "");
    Expect(0, 122984, '\P{Is_SD: true}', "");
    Expect(1, 122984, '\P{^Is_SD: true}', "");
    Expect(0, 122985, '\p{Is_SD: true}', "");
    Expect(1, 122985, '\p{^Is_SD: true}', "");
    Expect(1, 122985, '\P{Is_SD: true}', "");
    Expect(0, 122985, '\P{^Is_SD: true}', "");
    Expect(1, 122984, '\p{Is_SD=	_True}', "");
    Expect(0, 122984, '\p{^Is_SD=	_True}', "");
    Expect(0, 122984, '\P{Is_SD=	_True}', "");
    Expect(1, 122984, '\P{^Is_SD=	_True}', "");
    Expect(0, 122985, '\p{Is_SD=	_True}', "");
    Expect(1, 122985, '\p{^Is_SD=	_True}', "");
    Expect(1, 122985, '\P{Is_SD=	_True}', "");
    Expect(0, 122985, '\P{^Is_SD=	_True}', "");
    Error('\p{simplelowercasemapping}');
    Error('\P{simplelowercasemapping}');
    Error('\p{slc}');
    Error('\P{slc}');
    Error('\p{simpletitlecasemapping}');
    Error('\P{simpletitlecasemapping}');
    Error('\p{stc}');
    Error('\P{stc}');
    Error('\p{Sentence_Terminal=/a/	_No}');
    Error('\P{Sentence_Terminal=/a/	_No}');
    Expect(1, 121481, '\p{Sentence_Terminal=:\ANo\z:}', "");;
    Expect(0, 121480, '\p{Sentence_Terminal=:\ANo\z:}', "");;
    Expect(1, 121481, '\p{Sentence_Terminal:   no}', "");
    Expect(0, 121481, '\p{^Sentence_Terminal:   no}', "");
    Expect(0, 121481, '\P{Sentence_Terminal:   no}', "");
    Expect(1, 121481, '\P{^Sentence_Terminal:   no}', "");
    Expect(0, 121480, '\p{Sentence_Terminal:   no}', "");
    Expect(1, 121480, '\p{^Sentence_Terminal:   no}', "");
    Expect(1, 121480, '\P{Sentence_Terminal:   no}', "");
    Expect(0, 121480, '\P{^Sentence_Terminal:   no}', "");
    Expect(1, 121481, '\p{Sentence_Terminal=:\Ano\z:}', "");;
    Expect(0, 121480, '\p{Sentence_Terminal=:\Ano\z:}', "");;
    Expect(1, 121481, '\p{Sentence_Terminal=- no}', "");
    Expect(0, 121481, '\p{^Sentence_Terminal=- no}', "");
    Expect(0, 121481, '\P{Sentence_Terminal=- no}', "");
    Expect(1, 121481, '\P{^Sentence_Terminal=- no}', "");
    Expect(0, 121480, '\p{Sentence_Terminal=- no}', "");
    Expect(1, 121480, '\p{^Sentence_Terminal=- no}', "");
    Expect(1, 121480, '\P{Sentence_Terminal=- no}', "");
    Expect(0, 121480, '\P{^Sentence_Terminal=- no}', "");
    Error('\p{STerm=:= -N}');
    Error('\P{STerm=:= -N}');
    Expect(1, 121481, '\p{STerm=:\AN\z:}', "");;
    Expect(0, 121480, '\p{STerm=:\AN\z:}', "");;
    Expect(1, 121481, '\p{STerm=n}', "");
    Expect(0, 121481, '\p{^STerm=n}', "");
    Expect(0, 121481, '\P{STerm=n}', "");
    Expect(1, 121481, '\P{^STerm=n}', "");
    Expect(0, 121480, '\p{STerm=n}', "");
    Expect(1, 121480, '\p{^STerm=n}', "");
    Expect(1, 121480, '\P{STerm=n}', "");
    Expect(0, 121480, '\P{^STerm=n}', "");
    Expect(1, 121481, '\p{STerm=:\An\z:}', "");;
    Expect(0, 121480, '\p{STerm=:\An\z:}', "");;
    Expect(1, 121481, '\p{STerm=	 N}', "");
    Expect(0, 121481, '\p{^STerm=	 N}', "");
    Expect(0, 121481, '\P{STerm=	 N}', "");
    Expect(1, 121481, '\P{^STerm=	 N}', "");
    Expect(0, 121480, '\p{STerm=	 N}', "");
    Expect(1, 121480, '\p{^STerm=	 N}', "");
    Expect(1, 121480, '\P{STerm=	 N}', "");
    Expect(0, 121480, '\P{^STerm=	 N}', "");
    Error('\p{Is_Sentence_Terminal=_:=F}');
    Error('\P{Is_Sentence_Terminal=_:=F}');
    Expect(1, 121481, '\p{Is_Sentence_Terminal:	f}', "");
    Expect(0, 121481, '\p{^Is_Sentence_Terminal:	f}', "");
    Expect(0, 121481, '\P{Is_Sentence_Terminal:	f}', "");
    Expect(1, 121481, '\P{^Is_Sentence_Terminal:	f}', "");
    Expect(0, 121480, '\p{Is_Sentence_Terminal:	f}', "");
    Expect(1, 121480, '\p{^Is_Sentence_Terminal:	f}', "");
    Expect(1, 121480, '\P{Is_Sentence_Terminal:	f}', "");
    Expect(0, 121480, '\P{^Is_Sentence_Terminal:	f}', "");
    Expect(1, 121481, '\p{Is_Sentence_Terminal=_F}', "");
    Expect(0, 121481, '\p{^Is_Sentence_Terminal=_F}', "");
    Expect(0, 121481, '\P{Is_Sentence_Terminal=_F}', "");
    Expect(1, 121481, '\P{^Is_Sentence_Terminal=_F}', "");
    Expect(0, 121480, '\p{Is_Sentence_Terminal=_F}', "");
    Expect(1, 121480, '\p{^Is_Sentence_Terminal=_F}', "");
    Expect(1, 121480, '\P{Is_Sentence_Terminal=_F}', "");
    Expect(0, 121480, '\P{^Is_Sentence_Terminal=_F}', "");
    Error('\p{Is_STerm:   -:=False}');
    Error('\P{Is_STerm:   -:=False}');
    Expect(1, 121481, '\p{Is_STerm=false}', "");
    Expect(0, 121481, '\p{^Is_STerm=false}', "");
    Expect(0, 121481, '\P{Is_STerm=false}', "");
    Expect(1, 121481, '\P{^Is_STerm=false}', "");
    Expect(0, 121480, '\p{Is_STerm=false}', "");
    Expect(1, 121480, '\p{^Is_STerm=false}', "");
    Expect(1, 121480, '\P{Is_STerm=false}', "");
    Expect(0, 121480, '\P{^Is_STerm=false}', "");
    Expect(1, 121481, '\p{Is_STerm=  FALSE}', "");
    Expect(0, 121481, '\p{^Is_STerm=  FALSE}', "");
    Expect(0, 121481, '\P{Is_STerm=  FALSE}', "");
    Expect(1, 121481, '\P{^Is_STerm=  FALSE}', "");
    Expect(0, 121480, '\p{Is_STerm=  FALSE}', "");
    Expect(1, 121480, '\p{^Is_STerm=  FALSE}', "");
    Expect(1, 121480, '\P{Is_STerm=  FALSE}', "");
    Expect(0, 121480, '\P{^Is_STerm=  FALSE}', "");
    Error('\p{Sentence_Terminal=:=YES}');
    Error('\P{Sentence_Terminal=:=YES}');
    Expect(1, 121480, '\p{Sentence_Terminal=:\AYes\z:}', "");;
    Expect(0, 121481, '\p{Sentence_Terminal=:\AYes\z:}', "");;
    Expect(1, 121480, '\p{Sentence_Terminal=yes}', "");
    Expect(0, 121480, '\p{^Sentence_Terminal=yes}', "");
    Expect(0, 121480, '\P{Sentence_Terminal=yes}', "");
    Expect(1, 121480, '\P{^Sentence_Terminal=yes}', "");
    Expect(0, 121481, '\p{Sentence_Terminal=yes}', "");
    Expect(1, 121481, '\p{^Sentence_Terminal=yes}', "");
    Expect(1, 121481, '\P{Sentence_Terminal=yes}', "");
    Expect(0, 121481, '\P{^Sentence_Terminal=yes}', "");
    Expect(1, 121480, '\p{Sentence_Terminal=:\Ayes\z:}', "");;
    Expect(0, 121481, '\p{Sentence_Terminal=:\Ayes\z:}', "");;
    Expect(1, 121480, '\p{Sentence_Terminal=-_Yes}', "");
    Expect(0, 121480, '\p{^Sentence_Terminal=-_Yes}', "");
    Expect(0, 121480, '\P{Sentence_Terminal=-_Yes}', "");
    Expect(1, 121480, '\P{^Sentence_Terminal=-_Yes}', "");
    Expect(0, 121481, '\p{Sentence_Terminal=-_Yes}', "");
    Expect(1, 121481, '\p{^Sentence_Terminal=-_Yes}', "");
    Expect(1, 121481, '\P{Sentence_Terminal=-_Yes}', "");
    Expect(0, 121481, '\P{^Sentence_Terminal=-_Yes}', "");
    Error('\p{STerm=-_Y:=}');
    Error('\P{STerm=-_Y:=}');
    Expect(1, 121480, '\p{STerm=:\AY\z:}', "");;
    Expect(0, 121481, '\p{STerm=:\AY\z:}', "");;
    Expect(1, 121480, '\p{STerm=y}', "");
    Expect(0, 121480, '\p{^STerm=y}', "");
    Expect(0, 121480, '\P{STerm=y}', "");
    Expect(1, 121480, '\P{^STerm=y}', "");
    Expect(0, 121481, '\p{STerm=y}', "");
    Expect(1, 121481, '\p{^STerm=y}', "");
    Expect(1, 121481, '\P{STerm=y}', "");
    Expect(0, 121481, '\P{^STerm=y}', "");
    Expect(1, 121480, '\p{STerm=:\Ay\z:}', "");;
    Expect(0, 121481, '\p{STerm=:\Ay\z:}', "");;
    Expect(1, 121480, '\p{STerm:-	Y}', "");
    Expect(0, 121480, '\p{^STerm:-	Y}', "");
    Expect(0, 121480, '\P{STerm:-	Y}', "");
    Expect(1, 121480, '\P{^STerm:-	Y}', "");
    Expect(0, 121481, '\p{STerm:-	Y}', "");
    Expect(1, 121481, '\p{^STerm:-	Y}', "");
    Expect(1, 121481, '\P{STerm:-	Y}', "");
    Expect(0, 121481, '\P{^STerm:-	Y}', "");
    Error('\p{Is_Sentence_Terminal=_/a/T}');
    Error('\P{Is_Sentence_Terminal=_/a/T}');
    Expect(1, 121480, '\p{Is_Sentence_Terminal=t}', "");
    Expect(0, 121480, '\p{^Is_Sentence_Terminal=t}', "");
    Expect(0, 121480, '\P{Is_Sentence_Terminal=t}', "");
    Expect(1, 121480, '\P{^Is_Sentence_Terminal=t}', "");
    Expect(0, 121481, '\p{Is_Sentence_Terminal=t}', "");
    Expect(1, 121481, '\p{^Is_Sentence_Terminal=t}', "");
    Expect(1, 121481, '\P{Is_Sentence_Terminal=t}', "");
    Expect(0, 121481, '\P{^Is_Sentence_Terminal=t}', "");
    Expect(1, 121480, '\p{Is_Sentence_Terminal:__T}', "");
    Expect(0, 121480, '\p{^Is_Sentence_Terminal:__T}', "");
    Expect(0, 121480, '\P{Is_Sentence_Terminal:__T}', "");
    Expect(1, 121480, '\P{^Is_Sentence_Terminal:__T}', "");
    Expect(0, 121481, '\p{Is_Sentence_Terminal:__T}', "");
    Expect(1, 121481, '\p{^Is_Sentence_Terminal:__T}', "");
    Expect(1, 121481, '\P{Is_Sentence_Terminal:__T}', "");
    Expect(0, 121481, '\P{^Is_Sentence_Terminal:__T}', "");
    Error('\p{Is_STerm= /a/true}');
    Error('\P{Is_STerm= /a/true}');
    Expect(1, 121480, '\p{Is_STerm=true}', "");
    Expect(0, 121480, '\p{^Is_STerm=true}', "");
    Expect(0, 121480, '\P{Is_STerm=true}', "");
    Expect(1, 121480, '\P{^Is_STerm=true}', "");
    Expect(0, 121481, '\p{Is_STerm=true}', "");
    Expect(1, 121481, '\p{^Is_STerm=true}', "");
    Expect(1, 121481, '\P{Is_STerm=true}', "");
    Expect(0, 121481, '\P{^Is_STerm=true}', "");
    Expect(1, 121480, '\p{Is_STerm= 	True}', "");
    Expect(0, 121480, '\p{^Is_STerm= 	True}', "");
    Expect(0, 121480, '\P{Is_STerm= 	True}', "");
    Expect(1, 121480, '\P{^Is_STerm= 	True}', "");
    Expect(0, 121481, '\p{Is_STerm= 	True}', "");
    Expect(1, 121481, '\p{^Is_STerm= 	True}', "");
    Expect(1, 121481, '\P{Is_STerm= 	True}', "");
    Expect(0, 121481, '\P{^Is_STerm= 	True}', "");
    Error('\p{simpleuppercasemapping}');
    Error('\P{simpleuppercasemapping}');
    Error('\p{suc}');
    Error('\P{suc}');
    Error('\p{titlecasemapping}');
    Error('\P{titlecasemapping}');
    Error('\p{tc}');
    Error('\P{tc}');
    Error('\p{Terminal_Punctuation=__No:=}');
    Error('\P{Terminal_Punctuation=__No:=}');
    Expect(1, 121483, '\p{Terminal_Punctuation=:\ANo\z:}', "");;
    Expect(0, 121482, '\p{Terminal_Punctuation=:\ANo\z:}', "");;
    Expect(1, 121483, '\p{Terminal_Punctuation=no}', "");
    Expect(0, 121483, '\p{^Terminal_Punctuation=no}', "");
    Expect(0, 121483, '\P{Terminal_Punctuation=no}', "");
    Expect(1, 121483, '\P{^Terminal_Punctuation=no}', "");
    Expect(0, 121482, '\p{Terminal_Punctuation=no}', "");
    Expect(1, 121482, '\p{^Terminal_Punctuation=no}', "");
    Expect(1, 121482, '\P{Terminal_Punctuation=no}', "");
    Expect(0, 121482, '\P{^Terminal_Punctuation=no}', "");
    Expect(1, 121483, '\p{Terminal_Punctuation=:\Ano\z:}', "");;
    Expect(0, 121482, '\p{Terminal_Punctuation=:\Ano\z:}', "");;
    Expect(1, 121483, '\p{Terminal_Punctuation=	 NO}', "");
    Expect(0, 121483, '\p{^Terminal_Punctuation=	 NO}', "");
    Expect(0, 121483, '\P{Terminal_Punctuation=	 NO}', "");
    Expect(1, 121483, '\P{^Terminal_Punctuation=	 NO}', "");
    Expect(0, 121482, '\p{Terminal_Punctuation=	 NO}', "");
    Expect(1, 121482, '\p{^Terminal_Punctuation=	 NO}', "");
    Expect(1, 121482, '\P{Terminal_Punctuation=	 NO}', "");
    Expect(0, 121482, '\P{^Terminal_Punctuation=	 NO}', "");
    Error('\p{Term:   /a/-N}');
    Error('\P{Term:   /a/-N}');
    Expect(1, 121483, '\p{Term=:\AN\z:}', "");;
    Expect(0, 121482, '\p{Term=:\AN\z:}', "");;
    Expect(1, 121483, '\p{Term=n}', "");
    Expect(0, 121483, '\p{^Term=n}', "");
    Expect(0, 121483, '\P{Term=n}', "");
    Expect(1, 121483, '\P{^Term=n}', "");
    Expect(0, 121482, '\p{Term=n}', "");
    Expect(1, 121482, '\p{^Term=n}', "");
    Expect(1, 121482, '\P{Term=n}', "");
    Expect(0, 121482, '\P{^Term=n}', "");
    Expect(1, 121483, '\p{Term=:\An\z:}', "");;
    Expect(0, 121482, '\p{Term=:\An\z:}', "");;
    Expect(1, 121483, '\p{Term= 	n}', "");
    Expect(0, 121483, '\p{^Term= 	n}', "");
    Expect(0, 121483, '\P{Term= 	n}', "");
    Expect(1, 121483, '\P{^Term= 	n}', "");
    Expect(0, 121482, '\p{Term= 	n}', "");
    Expect(1, 121482, '\p{^Term= 	n}', "");
    Expect(1, 121482, '\P{Term= 	n}', "");
    Expect(0, 121482, '\P{^Term= 	n}', "");
    Error('\p{Is_Terminal_Punctuation=:= 	F}');
    Error('\P{Is_Terminal_Punctuation=:= 	F}');
    Expect(1, 121483, '\p{Is_Terminal_Punctuation=f}', "");
    Expect(0, 121483, '\p{^Is_Terminal_Punctuation=f}', "");
    Expect(0, 121483, '\P{Is_Terminal_Punctuation=f}', "");
    Expect(1, 121483, '\P{^Is_Terminal_Punctuation=f}', "");
    Expect(0, 121482, '\p{Is_Terminal_Punctuation=f}', "");
    Expect(1, 121482, '\p{^Is_Terminal_Punctuation=f}', "");
    Expect(1, 121482, '\P{Is_Terminal_Punctuation=f}', "");
    Expect(0, 121482, '\P{^Is_Terminal_Punctuation=f}', "");
    Expect(1, 121483, '\p{Is_Terminal_Punctuation= -F}', "");
    Expect(0, 121483, '\p{^Is_Terminal_Punctuation= -F}', "");
    Expect(0, 121483, '\P{Is_Terminal_Punctuation= -F}', "");
    Expect(1, 121483, '\P{^Is_Terminal_Punctuation= -F}', "");
    Expect(0, 121482, '\p{Is_Terminal_Punctuation= -F}', "");
    Expect(1, 121482, '\p{^Is_Terminal_Punctuation= -F}', "");
    Expect(1, 121482, '\P{Is_Terminal_Punctuation= -F}', "");
    Expect(0, 121482, '\P{^Is_Terminal_Punctuation= -F}', "");
    Error('\p{Is_Term=	:=False}');
    Error('\P{Is_Term=	:=False}');
    Expect(1, 121483, '\p{Is_Term=false}', "");
    Expect(0, 121483, '\p{^Is_Term=false}', "");
    Expect(0, 121483, '\P{Is_Term=false}', "");
    Expect(1, 121483, '\P{^Is_Term=false}', "");
    Expect(0, 121482, '\p{Is_Term=false}', "");
    Expect(1, 121482, '\p{^Is_Term=false}', "");
    Expect(1, 121482, '\P{Is_Term=false}', "");
    Expect(0, 121482, '\P{^Is_Term=false}', "");
    Expect(1, 121483, '\p{Is_Term= _False}', "");
    Expect(0, 121483, '\p{^Is_Term= _False}', "");
    Expect(0, 121483, '\P{Is_Term= _False}', "");
    Expect(1, 121483, '\P{^Is_Term= _False}', "");
    Expect(0, 121482, '\p{Is_Term= _False}', "");
    Expect(1, 121482, '\p{^Is_Term= _False}', "");
    Expect(1, 121482, '\P{Is_Term= _False}', "");
    Expect(0, 121482, '\P{^Is_Term= _False}', "");
    Error('\p{Terminal_Punctuation=-Yes/a/}');
    Error('\P{Terminal_Punctuation=-Yes/a/}');
    Expect(1, 121482, '\p{Terminal_Punctuation=:\AYes\z:}', "");;
    Expect(0, 121483, '\p{Terminal_Punctuation=:\AYes\z:}', "");;
    Expect(1, 121482, '\p{Terminal_Punctuation:	yes}', "");
    Expect(0, 121482, '\p{^Terminal_Punctuation:	yes}', "");
    Expect(0, 121482, '\P{Terminal_Punctuation:	yes}', "");
    Expect(1, 121482, '\P{^Terminal_Punctuation:	yes}', "");
    Expect(0, 121483, '\p{Terminal_Punctuation:	yes}', "");
    Expect(1, 121483, '\p{^Terminal_Punctuation:	yes}', "");
    Expect(1, 121483, '\P{Terminal_Punctuation:	yes}', "");
    Expect(0, 121483, '\P{^Terminal_Punctuation:	yes}', "");
    Expect(1, 121482, '\p{Terminal_Punctuation=:\Ayes\z:}', "");;
    Expect(0, 121483, '\p{Terminal_Punctuation=:\Ayes\z:}', "");;
    Expect(1, 121482, '\p{Terminal_Punctuation=		yes}', "");
    Expect(0, 121482, '\p{^Terminal_Punctuation=		yes}', "");
    Expect(0, 121482, '\P{Terminal_Punctuation=		yes}', "");
    Expect(1, 121482, '\P{^Terminal_Punctuation=		yes}', "");
    Expect(0, 121483, '\p{Terminal_Punctuation=		yes}', "");
    Expect(1, 121483, '\p{^Terminal_Punctuation=		yes}', "");
    Expect(1, 121483, '\P{Terminal_Punctuation=		yes}', "");
    Expect(0, 121483, '\P{^Terminal_Punctuation=		yes}', "");
    Error('\p{Term:   _y:=}');
    Error('\P{Term:   _y:=}');
    Expect(1, 121482, '\p{Term=:\AY\z:}', "");;
    Expect(0, 121483, '\p{Term=:\AY\z:}', "");;
    Expect(1, 121482, '\p{Term=y}', "");
    Expect(0, 121482, '\p{^Term=y}', "");
    Expect(0, 121482, '\P{Term=y}', "");
    Expect(1, 121482, '\P{^Term=y}', "");
    Expect(0, 121483, '\p{Term=y}', "");
    Expect(1, 121483, '\p{^Term=y}', "");
    Expect(1, 121483, '\P{Term=y}', "");
    Expect(0, 121483, '\P{^Term=y}', "");
    Expect(1, 121482, '\p{Term=:\Ay\z:}', "");;
    Expect(0, 121483, '\p{Term=:\Ay\z:}', "");;
    Expect(1, 121482, '\p{Term=_	y}', "");
    Expect(0, 121482, '\p{^Term=_	y}', "");
    Expect(0, 121482, '\P{Term=_	y}', "");
    Expect(1, 121482, '\P{^Term=_	y}', "");
    Expect(0, 121483, '\p{Term=_	y}', "");
    Expect(1, 121483, '\p{^Term=_	y}', "");
    Expect(1, 121483, '\P{Term=_	y}', "");
    Expect(0, 121483, '\P{^Term=_	y}', "");
    Error('\p{Is_Terminal_Punctuation=	:=T}');
    Error('\P{Is_Terminal_Punctuation=	:=T}');
    Expect(1, 121482, '\p{Is_Terminal_Punctuation=t}', "");
    Expect(0, 121482, '\p{^Is_Terminal_Punctuation=t}', "");
    Expect(0, 121482, '\P{Is_Terminal_Punctuation=t}', "");
    Expect(1, 121482, '\P{^Is_Terminal_Punctuation=t}', "");
    Expect(0, 121483, '\p{Is_Terminal_Punctuation=t}', "");
    Expect(1, 121483, '\p{^Is_Terminal_Punctuation=t}', "");
    Expect(1, 121483, '\P{Is_Terminal_Punctuation=t}', "");
    Expect(0, 121483, '\P{^Is_Terminal_Punctuation=t}', "");
    Expect(1, 121482, '\p{Is_Terminal_Punctuation= 	T}', "");
    Expect(0, 121482, '\p{^Is_Terminal_Punctuation= 	T}', "");
    Expect(0, 121482, '\P{Is_Terminal_Punctuation= 	T}', "");
    Expect(1, 121482, '\P{^Is_Terminal_Punctuation= 	T}', "");
    Expect(0, 121483, '\p{Is_Terminal_Punctuation= 	T}', "");
    Expect(1, 121483, '\p{^Is_Terminal_Punctuation= 	T}', "");
    Expect(1, 121483, '\P{Is_Terminal_Punctuation= 	T}', "");
    Expect(0, 121483, '\P{^Is_Terminal_Punctuation= 	T}', "");
    Error('\p{Is_Term=:=-	TRUE}');
    Error('\P{Is_Term=:=-	TRUE}');
    Expect(1, 121482, '\p{Is_Term=true}', "");
    Expect(0, 121482, '\p{^Is_Term=true}', "");
    Expect(0, 121482, '\P{Is_Term=true}', "");
    Expect(1, 121482, '\P{^Is_Term=true}', "");
    Expect(0, 121483, '\p{Is_Term=true}', "");
    Expect(1, 121483, '\p{^Is_Term=true}', "");
    Expect(1, 121483, '\P{Is_Term=true}', "");
    Expect(0, 121483, '\P{^Is_Term=true}', "");
    Expect(1, 121482, '\p{Is_Term: 	 True}', "");
    Expect(0, 121482, '\p{^Is_Term: 	 True}', "");
    Expect(0, 121482, '\P{Is_Term: 	 True}', "");
    Expect(1, 121482, '\P{^Is_Term: 	 True}', "");
    Expect(0, 121483, '\p{Is_Term: 	 True}', "");
    Expect(1, 121483, '\p{^Is_Term: 	 True}', "");
    Expect(1, 121483, '\P{Is_Term: 	 True}', "");
    Expect(0, 121483, '\P{^Is_Term: 	 True}', "");
    Error('\p{uppercasemapping}');
    Error('\P{uppercasemapping}');
    Error('\p{uc}');
    Error('\P{uc}');
    Error('\p{Unified_Ideograph=/a/ No}');
    Error('\P{Unified_Ideograph=/a/ No}');
    Expect(1, 205744, '\p{Unified_Ideograph=:\ANo\z:}', "");;
    Expect(0, 205743, '\p{Unified_Ideograph=:\ANo\z:}', "");;
    Expect(1, 205744, '\p{Unified_Ideograph=no}', "");
    Expect(0, 205744, '\p{^Unified_Ideograph=no}', "");
    Expect(0, 205744, '\P{Unified_Ideograph=no}', "");
    Expect(1, 205744, '\P{^Unified_Ideograph=no}', "");
    Expect(0, 205743, '\p{Unified_Ideograph=no}', "");
    Expect(1, 205743, '\p{^Unified_Ideograph=no}', "");
    Expect(1, 205743, '\P{Unified_Ideograph=no}', "");
    Expect(0, 205743, '\P{^Unified_Ideograph=no}', "");
    Expect(1, 205744, '\p{Unified_Ideograph=:\Ano\z:}', "");;
    Expect(0, 205743, '\p{Unified_Ideograph=:\Ano\z:}', "");;
    Expect(1, 205744, '\p{Unified_Ideograph: - NO}', "");
    Expect(0, 205744, '\p{^Unified_Ideograph: - NO}', "");
    Expect(0, 205744, '\P{Unified_Ideograph: - NO}', "");
    Expect(1, 205744, '\P{^Unified_Ideograph: - NO}', "");
    Expect(0, 205743, '\p{Unified_Ideograph: - NO}', "");
    Expect(1, 205743, '\p{^Unified_Ideograph: - NO}', "");
    Expect(1, 205743, '\P{Unified_Ideograph: - NO}', "");
    Expect(0, 205743, '\P{^Unified_Ideograph: - NO}', "");
    Error('\p{UIdeo=:=	N}');
    Error('\P{UIdeo=:=	N}');
    Expect(1, 205744, '\p{UIdeo=:\AN\z:}', "");;
    Expect(0, 205743, '\p{UIdeo=:\AN\z:}', "");;
    Expect(1, 205744, '\p{UIdeo=n}', "");
    Expect(0, 205744, '\p{^UIdeo=n}', "");
    Expect(0, 205744, '\P{UIdeo=n}', "");
    Expect(1, 205744, '\P{^UIdeo=n}', "");
    Expect(0, 205743, '\p{UIdeo=n}', "");
    Expect(1, 205743, '\p{^UIdeo=n}', "");
    Expect(1, 205743, '\P{UIdeo=n}', "");
    Expect(0, 205743, '\P{^UIdeo=n}', "");
    Expect(1, 205744, '\p{UIdeo=:\An\z:}', "");;
    Expect(0, 205743, '\p{UIdeo=:\An\z:}', "");;
    Expect(1, 205744, '\p{UIdeo=- N}', "");
    Expect(0, 205744, '\p{^UIdeo=- N}', "");
    Expect(0, 205744, '\P{UIdeo=- N}', "");
    Expect(1, 205744, '\P{^UIdeo=- N}', "");
    Expect(0, 205743, '\p{UIdeo=- N}', "");
    Expect(1, 205743, '\p{^UIdeo=- N}', "");
    Expect(1, 205743, '\P{UIdeo=- N}', "");
    Expect(0, 205743, '\P{^UIdeo=- N}', "");
    Error('\p{Is_Unified_Ideograph=:=	-F}');
    Error('\P{Is_Unified_Ideograph=:=	-F}');
    Expect(1, 205744, '\p{Is_Unified_Ideograph=f}', "");
    Expect(0, 205744, '\p{^Is_Unified_Ideograph=f}', "");
    Expect(0, 205744, '\P{Is_Unified_Ideograph=f}', "");
    Expect(1, 205744, '\P{^Is_Unified_Ideograph=f}', "");
    Expect(0, 205743, '\p{Is_Unified_Ideograph=f}', "");
    Expect(1, 205743, '\p{^Is_Unified_Ideograph=f}', "");
    Expect(1, 205743, '\P{Is_Unified_Ideograph=f}', "");
    Expect(0, 205743, '\P{^Is_Unified_Ideograph=f}', "");
    Expect(1, 205744, '\p{Is_Unified_Ideograph=	F}', "");
    Expect(0, 205744, '\p{^Is_Unified_Ideograph=	F}', "");
    Expect(0, 205744, '\P{Is_Unified_Ideograph=	F}', "");
    Expect(1, 205744, '\P{^Is_Unified_Ideograph=	F}', "");
    Expect(0, 205743, '\p{Is_Unified_Ideograph=	F}', "");
    Expect(1, 205743, '\p{^Is_Unified_Ideograph=	F}', "");
    Expect(1, 205743, '\P{Is_Unified_Ideograph=	F}', "");
    Expect(0, 205743, '\P{^Is_Unified_Ideograph=	F}', "");
    Error('\p{Is_UIdeo=:=FALSE}');
    Error('\P{Is_UIdeo=:=FALSE}');
    Expect(1, 205744, '\p{Is_UIdeo=false}', "");
    Expect(0, 205744, '\p{^Is_UIdeo=false}', "");
    Expect(0, 205744, '\P{Is_UIdeo=false}', "");
    Expect(1, 205744, '\P{^Is_UIdeo=false}', "");
    Expect(0, 205743, '\p{Is_UIdeo=false}', "");
    Expect(1, 205743, '\p{^Is_UIdeo=false}', "");
    Expect(1, 205743, '\P{Is_UIdeo=false}', "");
    Expect(0, 205743, '\P{^Is_UIdeo=false}', "");
    Expect(1, 205744, '\p{Is_UIdeo=_-False}', "");
    Expect(0, 205744, '\p{^Is_UIdeo=_-False}', "");
    Expect(0, 205744, '\P{Is_UIdeo=_-False}', "");
    Expect(1, 205744, '\P{^Is_UIdeo=_-False}', "");
    Expect(0, 205743, '\p{Is_UIdeo=_-False}', "");
    Expect(1, 205743, '\p{^Is_UIdeo=_-False}', "");
    Expect(1, 205743, '\P{Is_UIdeo=_-False}', "");
    Expect(0, 205743, '\P{^Is_UIdeo=_-False}', "");
    Error('\p{Unified_Ideograph:  Yes/a/}');
    Error('\P{Unified_Ideograph:  Yes/a/}');
    Expect(1, 205743, '\p{Unified_Ideograph=:\AYes\z:}', "");;
    Expect(0, 205744, '\p{Unified_Ideograph=:\AYes\z:}', "");;
    Expect(1, 205743, '\p{Unified_Ideograph=yes}', "");
    Expect(0, 205743, '\p{^Unified_Ideograph=yes}', "");
    Expect(0, 205743, '\P{Unified_Ideograph=yes}', "");
    Expect(1, 205743, '\P{^Unified_Ideograph=yes}', "");
    Expect(0, 205744, '\p{Unified_Ideograph=yes}', "");
    Expect(1, 205744, '\p{^Unified_Ideograph=yes}', "");
    Expect(1, 205744, '\P{Unified_Ideograph=yes}', "");
    Expect(0, 205744, '\P{^Unified_Ideograph=yes}', "");
    Expect(1, 205743, '\p{Unified_Ideograph=:\Ayes\z:}', "");;
    Expect(0, 205744, '\p{Unified_Ideograph=:\Ayes\z:}', "");;
    Expect(1, 205743, '\p{Unified_Ideograph=Yes}', "");
    Expect(0, 205743, '\p{^Unified_Ideograph=Yes}', "");
    Expect(0, 205743, '\P{Unified_Ideograph=Yes}', "");
    Expect(1, 205743, '\P{^Unified_Ideograph=Yes}', "");
    Expect(0, 205744, '\p{Unified_Ideograph=Yes}', "");
    Expect(1, 205744, '\p{^Unified_Ideograph=Yes}', "");
    Expect(1, 205744, '\P{Unified_Ideograph=Yes}', "");
    Expect(0, 205744, '\P{^Unified_Ideograph=Yes}', "");
    Error('\p{UIdeo=:=_ Y}');
    Error('\P{UIdeo=:=_ Y}');
    Expect(1, 205743, '\p{UIdeo=:\AY\z:}', "");;
    Expect(0, 205744, '\p{UIdeo=:\AY\z:}', "");;
    Expect(1, 205743, '\p{UIdeo:	y}', "");
    Expect(0, 205743, '\p{^UIdeo:	y}', "");
    Expect(0, 205743, '\P{UIdeo:	y}', "");
    Expect(1, 205743, '\P{^UIdeo:	y}', "");
    Expect(0, 205744, '\p{UIdeo:	y}', "");
    Expect(1, 205744, '\p{^UIdeo:	y}', "");
    Expect(1, 205744, '\P{UIdeo:	y}', "");
    Expect(0, 205744, '\P{^UIdeo:	y}', "");
    Expect(1, 205743, '\p{UIdeo=:\Ay\z:}', "");;
    Expect(0, 205744, '\p{UIdeo=:\Ay\z:}', "");;
    Expect(1, 205743, '\p{UIdeo= y}', "");
    Expect(0, 205743, '\p{^UIdeo= y}', "");
    Expect(0, 205743, '\P{UIdeo= y}', "");
    Expect(1, 205743, '\P{^UIdeo= y}', "");
    Expect(0, 205744, '\p{UIdeo= y}', "");
    Expect(1, 205744, '\p{^UIdeo= y}', "");
    Expect(1, 205744, '\P{UIdeo= y}', "");
    Expect(0, 205744, '\P{^UIdeo= y}', "");
    Error('\p{Is_Unified_Ideograph=_:=T}');
    Error('\P{Is_Unified_Ideograph=_:=T}');
    Expect(1, 205743, '\p{Is_Unified_Ideograph=t}', "");
    Expect(0, 205743, '\p{^Is_Unified_Ideograph=t}', "");
    Expect(0, 205743, '\P{Is_Unified_Ideograph=t}', "");
    Expect(1, 205743, '\P{^Is_Unified_Ideograph=t}', "");
    Expect(0, 205744, '\p{Is_Unified_Ideograph=t}', "");
    Expect(1, 205744, '\p{^Is_Unified_Ideograph=t}', "");
    Expect(1, 205744, '\P{Is_Unified_Ideograph=t}', "");
    Expect(0, 205744, '\P{^Is_Unified_Ideograph=t}', "");
    Expect(1, 205743, '\p{Is_Unified_Ideograph=-_T}', "");
    Expect(0, 205743, '\p{^Is_Unified_Ideograph=-_T}', "");
    Expect(0, 205743, '\P{Is_Unified_Ideograph=-_T}', "");
    Expect(1, 205743, '\P{^Is_Unified_Ideograph=-_T}', "");
    Expect(0, 205744, '\p{Is_Unified_Ideograph=-_T}', "");
    Expect(1, 205744, '\p{^Is_Unified_Ideograph=-_T}', "");
    Expect(1, 205744, '\P{Is_Unified_Ideograph=-_T}', "");
    Expect(0, 205744, '\P{^Is_Unified_Ideograph=-_T}', "");
    Error('\p{Is_UIdeo=:=-True}');
    Error('\P{Is_UIdeo=:=-True}');
    Expect(1, 205743, '\p{Is_UIdeo=true}', "");
    Expect(0, 205743, '\p{^Is_UIdeo=true}', "");
    Expect(0, 205743, '\P{Is_UIdeo=true}', "");
    Expect(1, 205743, '\P{^Is_UIdeo=true}', "");
    Expect(0, 205744, '\p{Is_UIdeo=true}', "");
    Expect(1, 205744, '\p{^Is_UIdeo=true}', "");
    Expect(1, 205744, '\P{Is_UIdeo=true}', "");
    Expect(0, 205744, '\P{^Is_UIdeo=true}', "");
    Expect(1, 205743, '\p{Is_UIdeo=- True}', "");
    Expect(0, 205743, '\p{^Is_UIdeo=- True}', "");
    Expect(0, 205743, '\P{Is_UIdeo=- True}', "");
    Expect(1, 205743, '\P{^Is_UIdeo=- True}', "");
    Expect(0, 205744, '\p{Is_UIdeo=- True}', "");
    Expect(1, 205744, '\p{^Is_UIdeo=- True}', "");
    Expect(1, 205744, '\P{Is_UIdeo=- True}', "");
    Expect(0, 205744, '\P{^Is_UIdeo=- True}', "");
    Error('\p{Uppercase= :=no}');
    Error('\P{Uppercase= :=no}');
    Expect(1, 127370, '\p{Uppercase=:\ANo\z:}', "");;
    Expect(0, 127369, '\p{Uppercase=:\ANo\z:}', "");;
    Expect(1, 127370, '\p{Uppercase=no}', "");
    Expect(0, 127370, '\p{^Uppercase=no}', "");
    Expect(0, 127370, '\P{Uppercase=no}', "");
    Expect(1, 127370, '\P{^Uppercase=no}', "");
    Expect(0, 127369, '\p{Uppercase=no}', "");
    Expect(1, 127369, '\p{^Uppercase=no}', "");
    Expect(1, 127369, '\P{Uppercase=no}', "");
    Expect(0, 127369, '\P{^Uppercase=no}', "");
    Expect(1, 127370, '\p{Uppercase=:\Ano\z:}', "");;
    Expect(0, 127369, '\p{Uppercase=:\Ano\z:}', "");;
    Expect(1, 127370, '\p{Uppercase=	-No}', "");
    Expect(0, 127370, '\p{^Uppercase=	-No}', "");
    Expect(0, 127370, '\P{Uppercase=	-No}', "");
    Expect(1, 127370, '\P{^Uppercase=	-No}', "");
    Expect(0, 127369, '\p{Uppercase=	-No}', "");
    Expect(1, 127369, '\p{^Uppercase=	-No}', "");
    Expect(1, 127369, '\P{Uppercase=	-No}', "");
    Expect(0, 127369, '\P{^Uppercase=	-No}', "");
    Error('\p{Upper:   /a/	N}');
    Error('\P{Upper:   /a/	N}');
    Expect(1, 127370, '\p{Upper=:\AN\z:}', "");;
    Expect(0, 127369, '\p{Upper=:\AN\z:}', "");;
    Expect(1, 127370, '\p{Upper=n}', "");
    Expect(0, 127370, '\p{^Upper=n}', "");
    Expect(0, 127370, '\P{Upper=n}', "");
    Expect(1, 127370, '\P{^Upper=n}', "");
    Expect(0, 127369, '\p{Upper=n}', "");
    Expect(1, 127369, '\p{^Upper=n}', "");
    Expect(1, 127369, '\P{Upper=n}', "");
    Expect(0, 127369, '\P{^Upper=n}', "");
    Expect(1, 127370, '\p{Upper=:\An\z:}', "");;
    Expect(0, 127369, '\p{Upper=:\An\z:}', "");;
    Expect(1, 127370, '\p{Upper:    _n}', "");
    Expect(0, 127370, '\p{^Upper:    _n}', "");
    Expect(0, 127370, '\P{Upper:    _n}', "");
    Expect(1, 127370, '\P{^Upper:    _n}', "");
    Expect(0, 127369, '\p{Upper:    _n}', "");
    Expect(1, 127369, '\p{^Upper:    _n}', "");
    Expect(1, 127369, '\P{Upper:    _n}', "");
    Expect(0, 127369, '\P{^Upper:    _n}', "");
    Error('\p{Is_Uppercase=-:=F}');
    Error('\P{Is_Uppercase=-:=F}');
    Expect(1, 127370, '\p{Is_Uppercase=f}', "");
    Expect(0, 127370, '\p{^Is_Uppercase=f}', "");
    Expect(0, 127370, '\P{Is_Uppercase=f}', "");
    Expect(1, 127370, '\P{^Is_Uppercase=f}', "");
    Expect(0, 127369, '\p{Is_Uppercase=f}', "");
    Expect(1, 127369, '\p{^Is_Uppercase=f}', "");
    Expect(1, 127369, '\P{Is_Uppercase=f}', "");
    Expect(0, 127369, '\P{^Is_Uppercase=f}', "");
    Expect(1, 127370, '\p{Is_Uppercase=__F}', "");
    Expect(0, 127370, '\p{^Is_Uppercase=__F}', "");
    Expect(0, 127370, '\P{Is_Uppercase=__F}', "");
    Expect(1, 127370, '\P{^Is_Uppercase=__F}', "");
    Expect(0, 127369, '\p{Is_Uppercase=__F}', "");
    Expect(1, 127369, '\p{^Is_Uppercase=__F}', "");
    Expect(1, 127369, '\P{Is_Uppercase=__F}', "");
    Expect(0, 127369, '\P{^Is_Uppercase=__F}', "");
    Error('\p{Is_Upper=:=		False}');
    Error('\P{Is_Upper=:=		False}');
    Expect(1, 127370, '\p{Is_Upper=false}', "");
    Expect(0, 127370, '\p{^Is_Upper=false}', "");
    Expect(0, 127370, '\P{Is_Upper=false}', "");
    Expect(1, 127370, '\P{^Is_Upper=false}', "");
    Expect(0, 127369, '\p{Is_Upper=false}', "");
    Expect(1, 127369, '\p{^Is_Upper=false}', "");
    Expect(1, 127369, '\P{Is_Upper=false}', "");
    Expect(0, 127369, '\P{^Is_Upper=false}', "");
    Expect(1, 127370, '\p{Is_Upper=-False}', "");
    Expect(0, 127370, '\p{^Is_Upper=-False}', "");
    Expect(0, 127370, '\P{Is_Upper=-False}', "");
    Expect(1, 127370, '\P{^Is_Upper=-False}', "");
    Expect(0, 127369, '\p{Is_Upper=-False}', "");
    Expect(1, 127369, '\p{^Is_Upper=-False}', "");
    Expect(1, 127369, '\P{Is_Upper=-False}', "");
    Expect(0, 127369, '\P{^Is_Upper=-False}', "");
    Error('\p{Uppercase=_:=Yes}');
    Error('\P{Uppercase=_:=Yes}');
    Expect(1, 127369, '\p{Uppercase=:\AYes\z:}', "");;
    Expect(0, 127370, '\p{Uppercase=:\AYes\z:}', "");;
    Expect(1, 127369, '\p{Uppercase=yes}', "");
    Expect(0, 127369, '\p{^Uppercase=yes}', "");
    Expect(0, 127369, '\P{Uppercase=yes}', "");
    Expect(1, 127369, '\P{^Uppercase=yes}', "");
    Expect(0, 127370, '\p{Uppercase=yes}', "");
    Expect(1, 127370, '\p{^Uppercase=yes}', "");
    Expect(1, 127370, '\P{Uppercase=yes}', "");
    Expect(0, 127370, '\P{^Uppercase=yes}', "");
    Expect(1, 127369, '\p{Uppercase=:\Ayes\z:}', "");;
    Expect(0, 127370, '\p{Uppercase=:\Ayes\z:}', "");;
    Expect(1, 127369, '\p{Uppercase: 	yes}', "");
    Expect(0, 127369, '\p{^Uppercase: 	yes}', "");
    Expect(0, 127369, '\P{Uppercase: 	yes}', "");
    Expect(1, 127369, '\P{^Uppercase: 	yes}', "");
    Expect(0, 127370, '\p{Uppercase: 	yes}', "");
    Expect(1, 127370, '\p{^Uppercase: 	yes}', "");
    Expect(1, 127370, '\P{Uppercase: 	yes}', "");
    Expect(0, 127370, '\P{^Uppercase: 	yes}', "");
    Error('\p{Upper= -Y/a/}');
    Error('\P{Upper= -Y/a/}');
    Expect(1, 127369, '\p{Upper=:\AY\z:}', "");;
    Expect(0, 127370, '\p{Upper=:\AY\z:}', "");;
    Expect(1, 127369, '\p{Upper=y}', "");
    Expect(0, 127369, '\p{^Upper=y}', "");
    Expect(0, 127369, '\P{Upper=y}', "");
    Expect(1, 127369, '\P{^Upper=y}', "");
    Expect(0, 127370, '\p{Upper=y}', "");
    Expect(1, 127370, '\p{^Upper=y}', "");
    Expect(1, 127370, '\P{Upper=y}', "");
    Expect(0, 127370, '\P{^Upper=y}', "");
    Expect(1, 127369, '\p{Upper=:\Ay\z:}', "");;
    Expect(0, 127370, '\p{Upper=:\Ay\z:}', "");;
    Expect(1, 127369, '\p{Upper= 	Y}', "");
    Expect(0, 127369, '\p{^Upper= 	Y}', "");
    Expect(0, 127369, '\P{Upper= 	Y}', "");
    Expect(1, 127369, '\P{^Upper= 	Y}', "");
    Expect(0, 127370, '\p{Upper= 	Y}', "");
    Expect(1, 127370, '\p{^Upper= 	Y}', "");
    Expect(1, 127370, '\P{Upper= 	Y}', "");
    Expect(0, 127370, '\P{^Upper= 	Y}', "");
    Error('\p{Is_Uppercase=/a/t}');
    Error('\P{Is_Uppercase=/a/t}');
    Expect(1, 127369, '\p{Is_Uppercase:t}', "");
    Expect(0, 127369, '\p{^Is_Uppercase:t}', "");
    Expect(0, 127369, '\P{Is_Uppercase:t}', "");
    Expect(1, 127369, '\P{^Is_Uppercase:t}', "");
    Expect(0, 127370, '\p{Is_Uppercase:t}', "");
    Expect(1, 127370, '\p{^Is_Uppercase:t}', "");
    Expect(1, 127370, '\P{Is_Uppercase:t}', "");
    Expect(0, 127370, '\P{^Is_Uppercase:t}', "");
    Expect(1, 127369, '\p{Is_Uppercase= _T}', "");
    Expect(0, 127369, '\p{^Is_Uppercase= _T}', "");
    Expect(0, 127369, '\P{Is_Uppercase= _T}', "");
    Expect(1, 127369, '\P{^Is_Uppercase= _T}', "");
    Expect(0, 127370, '\p{Is_Uppercase= _T}', "");
    Expect(1, 127370, '\p{^Is_Uppercase= _T}', "");
    Expect(1, 127370, '\P{Is_Uppercase= _T}', "");
    Expect(0, 127370, '\P{^Is_Uppercase= _T}', "");
    Error('\p{Is_Upper=/a/  True}');
    Error('\P{Is_Upper=/a/  True}');
    Expect(1, 127369, '\p{Is_Upper=true}', "");
    Expect(0, 127369, '\p{^Is_Upper=true}', "");
    Expect(0, 127369, '\P{Is_Upper=true}', "");
    Expect(1, 127369, '\P{^Is_Upper=true}', "");
    Expect(0, 127370, '\p{Is_Upper=true}', "");
    Expect(1, 127370, '\p{^Is_Upper=true}', "");
    Expect(1, 127370, '\P{Is_Upper=true}', "");
    Expect(0, 127370, '\P{^Is_Upper=true}', "");
    Expect(1, 127369, '\p{Is_Upper= -true}', "");
    Expect(0, 127369, '\p{^Is_Upper= -true}', "");
    Expect(0, 127369, '\P{Is_Upper= -true}', "");
    Expect(1, 127369, '\P{^Is_Upper= -true}', "");
    Expect(0, 127370, '\p{Is_Upper= -true}', "");
    Expect(1, 127370, '\p{^Is_Upper= -true}', "");
    Expect(1, 127370, '\P{Is_Upper= -true}', "");
    Expect(0, 127370, '\P{^Is_Upper= -true}', "");
    Error('\p{verticalorientation}');
    Error('\P{verticalorientation}');
    Error('\p{vo}');
    Error('\P{vo}');
    Error('\p{Vertical_Orientation=	:=rotated}');
    Error('\P{Vertical_Orientation=	:=rotated}');
    Expect(1, 262144, '\p{Vertical_Orientation=:\ARotated\z:}', "");;
    Expect(0, 1114109, '\p{Vertical_Orientation=:\ARotated\z:}', "");;
    Expect(1, 262144, '\p{Vertical_Orientation=rotated}', "");
    Expect(0, 262144, '\p{^Vertical_Orientation=rotated}', "");
    Expect(0, 262144, '\P{Vertical_Orientation=rotated}', "");
    Expect(1, 262144, '\P{^Vertical_Orientation=rotated}', "");
    Expect(0, 1114109, '\p{Vertical_Orientation=rotated}', "");
    Expect(1, 1114109, '\p{^Vertical_Orientation=rotated}', "");
    Expect(1, 1114109, '\P{Vertical_Orientation=rotated}', "");
    Expect(0, 1114109, '\P{^Vertical_Orientation=rotated}', "");
    Expect(1, 262144, '\p{Vertical_Orientation=:\Arotated\z:}', "");;
    Expect(0, 1114109, '\p{Vertical_Orientation=:\Arotated\z:}', "");;
    Expect(1, 262144, '\p{Vertical_Orientation=	rotated}', "");
    Expect(0, 262144, '\p{^Vertical_Orientation=	rotated}', "");
    Expect(0, 262144, '\P{Vertical_Orientation=	rotated}', "");
    Expect(1, 262144, '\P{^Vertical_Orientation=	rotated}', "");
    Expect(0, 1114109, '\p{Vertical_Orientation=	rotated}', "");
    Expect(1, 1114109, '\p{^Vertical_Orientation=	rotated}', "");
    Expect(1, 1114109, '\P{Vertical_Orientation=	rotated}', "");
    Expect(0, 1114109, '\P{^Vertical_Orientation=	rotated}', "");
    Error('\p{Vo=  R:=}');
    Error('\P{Vo=  R:=}');
    Expect(1, 262144, '\p{Vo=:\AR\z:}', "");;
    Expect(0, 1114109, '\p{Vo=:\AR\z:}', "");;
    Expect(1, 262144, '\p{Vo=r}', "");
    Expect(0, 262144, '\p{^Vo=r}', "");
    Expect(0, 262144, '\P{Vo=r}', "");
    Expect(1, 262144, '\P{^Vo=r}', "");
    Expect(0, 1114109, '\p{Vo=r}', "");
    Expect(1, 1114109, '\p{^Vo=r}', "");
    Expect(1, 1114109, '\P{Vo=r}', "");
    Expect(0, 1114109, '\P{^Vo=r}', "");
    Expect(1, 262144, '\p{Vo=:\Ar\z:}', "");;
    Expect(0, 1114109, '\p{Vo=:\Ar\z:}', "");;
    Expect(1, 262144, '\p{Vo= R}', "");
    Expect(0, 262144, '\p{^Vo= R}', "");
    Expect(0, 262144, '\P{Vo= R}', "");
    Expect(1, 262144, '\P{^Vo= R}', "");
    Expect(0, 1114109, '\p{Vo= R}', "");
    Expect(1, 1114109, '\p{^Vo= R}', "");
    Expect(1, 1114109, '\P{Vo= R}', "");
    Expect(0, 1114109, '\P{^Vo= R}', "");
    Error('\p{Is_Vertical_Orientation=:= 	Rotated}');
    Error('\P{Is_Vertical_Orientation=:= 	Rotated}');
    Expect(1, 262144, '\p{Is_Vertical_Orientation: rotated}', "");
    Expect(0, 262144, '\p{^Is_Vertical_Orientation: rotated}', "");
    Expect(0, 262144, '\P{Is_Vertical_Orientation: rotated}', "");
    Expect(1, 262144, '\P{^Is_Vertical_Orientation: rotated}', "");
    Expect(0, 1114109, '\p{Is_Vertical_Orientation: rotated}', "");
    Expect(1, 1114109, '\p{^Is_Vertical_Orientation: rotated}', "");
    Expect(1, 1114109, '\P{Is_Vertical_Orientation: rotated}', "");
    Expect(0, 1114109, '\P{^Is_Vertical_Orientation: rotated}', "");
    Expect(1, 262144, '\p{Is_Vertical_Orientation=	Rotated}', "");
    Expect(0, 262144, '\p{^Is_Vertical_Orientation=	Rotated}', "");
    Expect(0, 262144, '\P{Is_Vertical_Orientation=	Rotated}', "");
    Expect(1, 262144, '\P{^Is_Vertical_Orientation=	Rotated}', "");
    Expect(0, 1114109, '\p{Is_Vertical_Orientation=	Rotated}', "");
    Expect(1, 1114109, '\p{^Is_Vertical_Orientation=	Rotated}', "");
    Expect(1, 1114109, '\P{Is_Vertical_Orientation=	Rotated}', "");
    Expect(0, 1114109, '\P{^Is_Vertical_Orientation=	Rotated}', "");
    Error('\p{Is_Vo=_ R:=}');
    Error('\P{Is_Vo=_ R:=}');
    Expect(1, 262144, '\p{Is_Vo=r}', "");
    Expect(0, 262144, '\p{^Is_Vo=r}', "");
    Expect(0, 262144, '\P{Is_Vo=r}', "");
    Expect(1, 262144, '\P{^Is_Vo=r}', "");
    Expect(0, 1114109, '\p{Is_Vo=r}', "");
    Expect(1, 1114109, '\p{^Is_Vo=r}', "");
    Expect(1, 1114109, '\P{Is_Vo=r}', "");
    Expect(0, 1114109, '\P{^Is_Vo=r}', "");
    Expect(1, 262144, '\p{Is_Vo=__R}', "");
    Expect(0, 262144, '\p{^Is_Vo=__R}', "");
    Expect(0, 262144, '\P{Is_Vo=__R}', "");
    Expect(1, 262144, '\P{^Is_Vo=__R}', "");
    Expect(0, 1114109, '\p{Is_Vo=__R}', "");
    Expect(1, 1114109, '\p{^Is_Vo=__R}', "");
    Expect(1, 1114109, '\P{Is_Vo=__R}', "");
    Expect(0, 1114109, '\P{^Is_Vo=__R}', "");
    Error('\p{Vertical_Orientation=:=Transformed_ROTATED}');
    Error('\P{Vertical_Orientation=:=Transformed_ROTATED}');
    Expect(1, 65507, '\p{Vertical_Orientation=:\ATransformed_Rotated\z:}', "");;
    Expect(0, 65508, '\p{Vertical_Orientation=:\ATransformed_Rotated\z:}', "");;
    Expect(1, 65507, '\p{Vertical_Orientation=transformedrotated}', "");
    Expect(0, 65507, '\p{^Vertical_Orientation=transformedrotated}', "");
    Expect(0, 65507, '\P{Vertical_Orientation=transformedrotated}', "");
    Expect(1, 65507, '\P{^Vertical_Orientation=transformedrotated}', "");
    Expect(0, 65508, '\p{Vertical_Orientation=transformedrotated}', "");
    Expect(1, 65508, '\p{^Vertical_Orientation=transformedrotated}', "");
    Expect(1, 65508, '\P{Vertical_Orientation=transformedrotated}', "");
    Expect(0, 65508, '\P{^Vertical_Orientation=transformedrotated}', "");
    Expect(1, 65507, '\p{Vertical_Orientation=:\Atransformedrotated\z:}', "");;
    Expect(0, 65508, '\p{Vertical_Orientation=:\Atransformedrotated\z:}', "");;
    Expect(1, 65507, '\p{Vertical_Orientation=__Transformed_rotated}', "");
    Expect(0, 65507, '\p{^Vertical_Orientation=__Transformed_rotated}', "");
    Expect(0, 65507, '\P{Vertical_Orientation=__Transformed_rotated}', "");
    Expect(1, 65507, '\P{^Vertical_Orientation=__Transformed_rotated}', "");
    Expect(0, 65508, '\p{Vertical_Orientation=__Transformed_rotated}', "");
    Expect(1, 65508, '\p{^Vertical_Orientation=__Transformed_rotated}', "");
    Expect(1, 65508, '\P{Vertical_Orientation=__Transformed_rotated}', "");
    Expect(0, 65508, '\P{^Vertical_Orientation=__Transformed_rotated}', "");
    Error('\p{Vo= Tr:=}');
    Error('\P{Vo= Tr:=}');
    Expect(1, 65507, '\p{Vo=:\ATr\z:}', "");;
    Expect(0, 65508, '\p{Vo=:\ATr\z:}', "");;
    Expect(1, 65507, '\p{Vo=tr}', "");
    Expect(0, 65507, '\p{^Vo=tr}', "");
    Expect(0, 65507, '\P{Vo=tr}', "");
    Expect(1, 65507, '\P{^Vo=tr}', "");
    Expect(0, 65508, '\p{Vo=tr}', "");
    Expect(1, 65508, '\p{^Vo=tr}', "");
    Expect(1, 65508, '\P{Vo=tr}', "");
    Expect(0, 65508, '\P{^Vo=tr}', "");
    Expect(1, 65507, '\p{Vo=:\Atr\z:}', "");;
    Expect(0, 65508, '\p{Vo=:\Atr\z:}', "");;
    Expect(1, 65507, '\p{Vo= TR}', "");
    Expect(0, 65507, '\p{^Vo= TR}', "");
    Expect(0, 65507, '\P{Vo= TR}', "");
    Expect(1, 65507, '\P{^Vo= TR}', "");
    Expect(0, 65508, '\p{Vo= TR}', "");
    Expect(1, 65508, '\p{^Vo= TR}', "");
    Expect(1, 65508, '\P{Vo= TR}', "");
    Expect(0, 65508, '\P{^Vo= TR}', "");
    Error('\p{Is_Vertical_Orientation=	-TRANSFORMED_Rotated/a/}');
    Error('\P{Is_Vertical_Orientation=	-TRANSFORMED_Rotated/a/}');
    Expect(1, 65507, '\p{Is_Vertical_Orientation=transformedrotated}', "");
    Expect(0, 65507, '\p{^Is_Vertical_Orientation=transformedrotated}', "");
    Expect(0, 65507, '\P{Is_Vertical_Orientation=transformedrotated}', "");
    Expect(1, 65507, '\P{^Is_Vertical_Orientation=transformedrotated}', "");
    Expect(0, 65508, '\p{Is_Vertical_Orientation=transformedrotated}', "");
    Expect(1, 65508, '\p{^Is_Vertical_Orientation=transformedrotated}', "");
    Expect(1, 65508, '\P{Is_Vertical_Orientation=transformedrotated}', "");
    Expect(0, 65508, '\P{^Is_Vertical_Orientation=transformedrotated}', "");
    Expect(1, 65507, '\p{Is_Vertical_Orientation=		transformed_ROTATED}', "");
    Expect(0, 65507, '\p{^Is_Vertical_Orientation=		transformed_ROTATED}', "");
    Expect(0, 65507, '\P{Is_Vertical_Orientation=		transformed_ROTATED}', "");
    Expect(1, 65507, '\P{^Is_Vertical_Orientation=		transformed_ROTATED}', "");
    Expect(0, 65508, '\p{Is_Vertical_Orientation=		transformed_ROTATED}', "");
    Expect(1, 65508, '\p{^Is_Vertical_Orientation=		transformed_ROTATED}', "");
    Expect(1, 65508, '\P{Is_Vertical_Orientation=		transformed_ROTATED}', "");
    Expect(0, 65508, '\P{^Is_Vertical_Orientation=		transformed_ROTATED}', "");
    Error('\p{Is_Vo=:=	Tr}');
    Error('\P{Is_Vo=:=	Tr}');
    Expect(1, 65507, '\p{Is_Vo=tr}', "");
    Expect(0, 65507, '\p{^Is_Vo=tr}', "");
    Expect(0, 65507, '\P{Is_Vo=tr}', "");
    Expect(1, 65507, '\P{^Is_Vo=tr}', "");
    Expect(0, 65508, '\p{Is_Vo=tr}', "");
    Expect(1, 65508, '\p{^Is_Vo=tr}', "");
    Expect(1, 65508, '\P{Is_Vo=tr}', "");
    Expect(0, 65508, '\P{^Is_Vo=tr}', "");
    Expect(1, 65507, '\p{Is_Vo=-_Tr}', "");
    Expect(0, 65507, '\p{^Is_Vo=-_Tr}', "");
    Expect(0, 65507, '\P{Is_Vo=-_Tr}', "");
    Expect(1, 65507, '\P{^Is_Vo=-_Tr}', "");
    Expect(0, 65508, '\p{Is_Vo=-_Tr}', "");
    Expect(1, 65508, '\p{^Is_Vo=-_Tr}', "");
    Expect(1, 65508, '\P{Is_Vo=-_Tr}', "");
    Expect(0, 65508, '\P{^Is_Vo=-_Tr}', "");
    Error('\p{Vertical_Orientation=/a/transformed_Upright}');
    Error('\P{Vertical_Orientation=/a/transformed_Upright}');
    Expect(1, 127489, '\p{Vertical_Orientation=:\ATransformed_Upright\z:}', "");;
    Expect(0, 127490, '\p{Vertical_Orientation=:\ATransformed_Upright\z:}', "");;
    Expect(1, 127489, '\p{Vertical_Orientation=transformedupright}', "");
    Expect(0, 127489, '\p{^Vertical_Orientation=transformedupright}', "");
    Expect(0, 127489, '\P{Vertical_Orientation=transformedupright}', "");
    Expect(1, 127489, '\P{^Vertical_Orientation=transformedupright}', "");
    Expect(0, 127490, '\p{Vertical_Orientation=transformedupright}', "");
    Expect(1, 127490, '\p{^Vertical_Orientation=transformedupright}', "");
    Expect(1, 127490, '\P{Vertical_Orientation=transformedupright}', "");
    Expect(0, 127490, '\P{^Vertical_Orientation=transformedupright}', "");
    Expect(1, 127489, '\p{Vertical_Orientation=:\Atransformedupright\z:}', "");;
    Expect(0, 127490, '\p{Vertical_Orientation=:\Atransformedupright\z:}', "");;
    Expect(1, 127489, '\p{Vertical_Orientation:   	_Transformed_Upright}', "");
    Expect(0, 127489, '\p{^Vertical_Orientation:   	_Transformed_Upright}', "");
    Expect(0, 127489, '\P{Vertical_Orientation:   	_Transformed_Upright}', "");
    Expect(1, 127489, '\P{^Vertical_Orientation:   	_Transformed_Upright}', "");
    Expect(0, 127490, '\p{Vertical_Orientation:   	_Transformed_Upright}', "");
    Expect(1, 127490, '\p{^Vertical_Orientation:   	_Transformed_Upright}', "");
    Expect(1, 127490, '\P{Vertical_Orientation:   	_Transformed_Upright}', "");
    Expect(0, 127490, '\P{^Vertical_Orientation:   	_Transformed_Upright}', "");
    Error('\p{Vo=:=	tu}');
    Error('\P{Vo=:=	tu}');
    Expect(1, 127489, '\p{Vo=:\ATu\z:}', "");;
    Expect(0, 127490, '\p{Vo=:\ATu\z:}', "");;
    Expect(1, 127489, '\p{Vo=tu}', "");
    Expect(0, 127489, '\p{^Vo=tu}', "");
    Expect(0, 127489, '\P{Vo=tu}', "");
    Expect(1, 127489, '\P{^Vo=tu}', "");
    Expect(0, 127490, '\p{Vo=tu}', "");
    Expect(1, 127490, '\p{^Vo=tu}', "");
    Expect(1, 127490, '\P{Vo=tu}', "");
    Expect(0, 127490, '\P{^Vo=tu}', "");
    Expect(1, 127489, '\p{Vo=:\Atu\z:}', "");;
    Expect(0, 127490, '\p{Vo=:\Atu\z:}', "");;
    Expect(1, 127489, '\p{Vo=	 TU}', "");
    Expect(0, 127489, '\p{^Vo=	 TU}', "");
    Expect(0, 127489, '\P{Vo=	 TU}', "");
    Expect(1, 127489, '\P{^Vo=	 TU}', "");
    Expect(0, 127490, '\p{Vo=	 TU}', "");
    Expect(1, 127490, '\p{^Vo=	 TU}', "");
    Expect(1, 127490, '\P{Vo=	 TU}', "");
    Expect(0, 127490, '\P{^Vo=	 TU}', "");
    Error('\p{Is_Vertical_Orientation=/a/- Transformed_Upright}');
    Error('\P{Is_Vertical_Orientation=/a/- Transformed_Upright}');
    Expect(1, 127489, '\p{Is_Vertical_Orientation=transformedupright}', "");
    Expect(0, 127489, '\p{^Is_Vertical_Orientation=transformedupright}', "");
    Expect(0, 127489, '\P{Is_Vertical_Orientation=transformedupright}', "");
    Expect(1, 127489, '\P{^Is_Vertical_Orientation=transformedupright}', "");
    Expect(0, 127490, '\p{Is_Vertical_Orientation=transformedupright}', "");
    Expect(1, 127490, '\p{^Is_Vertical_Orientation=transformedupright}', "");
    Expect(1, 127490, '\P{Is_Vertical_Orientation=transformedupright}', "");
    Expect(0, 127490, '\P{^Is_Vertical_Orientation=transformedupright}', "");
    Expect(1, 127489, '\p{Is_Vertical_Orientation=  Transformed_UPRIGHT}', "");
    Expect(0, 127489, '\p{^Is_Vertical_Orientation=  Transformed_UPRIGHT}', "");
    Expect(0, 127489, '\P{Is_Vertical_Orientation=  Transformed_UPRIGHT}', "");
    Expect(1, 127489, '\P{^Is_Vertical_Orientation=  Transformed_UPRIGHT}', "");
    Expect(0, 127490, '\p{Is_Vertical_Orientation=  Transformed_UPRIGHT}', "");
    Expect(1, 127490, '\p{^Is_Vertical_Orientation=  Transformed_UPRIGHT}', "");
    Expect(1, 127490, '\P{Is_Vertical_Orientation=  Transformed_UPRIGHT}', "");
    Expect(0, 127490, '\P{^Is_Vertical_Orientation=  Transformed_UPRIGHT}', "");
    Error('\p{Is_Vo: 	/a/TU}');
    Error('\P{Is_Vo: 	/a/TU}');
    Expect(1, 127489, '\p{Is_Vo=tu}', "");
    Expect(0, 127489, '\p{^Is_Vo=tu}', "");
    Expect(0, 127489, '\P{Is_Vo=tu}', "");
    Expect(1, 127489, '\P{^Is_Vo=tu}', "");
    Expect(0, 127490, '\p{Is_Vo=tu}', "");
    Expect(1, 127490, '\p{^Is_Vo=tu}', "");
    Expect(1, 127490, '\P{Is_Vo=tu}', "");
    Expect(0, 127490, '\P{^Is_Vo=tu}', "");
    Expect(1, 127489, '\p{Is_Vo= Tu}', "");
    Expect(0, 127489, '\p{^Is_Vo= Tu}', "");
    Expect(0, 127489, '\P{Is_Vo= Tu}', "");
    Expect(1, 127489, '\P{^Is_Vo= Tu}', "");
    Expect(0, 127490, '\p{Is_Vo= Tu}', "");
    Expect(1, 127490, '\p{^Is_Vo= Tu}', "");
    Expect(1, 127490, '\P{Is_Vo= Tu}', "");
    Expect(0, 127490, '\P{^Is_Vo= Tu}', "");
    Error('\p{Vertical_Orientation= upright/a/}');
    Error('\P{Vertical_Orientation= upright/a/}');
    Expect(1, 1114109, '\p{Vertical_Orientation=:\AUpright\z:}', "");;
    Expect(0, 262144, '\p{Vertical_Orientation=:\AUpright\z:}', "");;
    Expect(1, 1114109, '\p{Vertical_Orientation=upright}', "");
    Expect(0, 1114109, '\p{^Vertical_Orientation=upright}', "");
    Expect(0, 1114109, '\P{Vertical_Orientation=upright}', "");
    Expect(1, 1114109, '\P{^Vertical_Orientation=upright}', "");
    Expect(0, 262144, '\p{Vertical_Orientation=upright}', "");
    Expect(1, 262144, '\p{^Vertical_Orientation=upright}', "");
    Expect(1, 262144, '\P{Vertical_Orientation=upright}', "");
    Expect(0, 262144, '\P{^Vertical_Orientation=upright}', "");
    Expect(1, 1114109, '\p{Vertical_Orientation=:\Aupright\z:}', "");;
    Expect(0, 262144, '\p{Vertical_Orientation=:\Aupright\z:}', "");;
    Expect(1, 1114109, '\p{Vertical_Orientation=--Upright}', "");
    Expect(0, 1114109, '\p{^Vertical_Orientation=--Upright}', "");
    Expect(0, 1114109, '\P{Vertical_Orientation=--Upright}', "");
    Expect(1, 1114109, '\P{^Vertical_Orientation=--Upright}', "");
    Expect(0, 262144, '\p{Vertical_Orientation=--Upright}', "");
    Expect(1, 262144, '\p{^Vertical_Orientation=--Upright}', "");
    Expect(1, 262144, '\P{Vertical_Orientation=--Upright}', "");
    Expect(0, 262144, '\P{^Vertical_Orientation=--Upright}', "");
    Error('\p{Vo: :=_ u}');
    Error('\P{Vo: :=_ u}');
    Expect(1, 1114109, '\p{Vo=:\AU\z:}', "");;
    Expect(0, 262144, '\p{Vo=:\AU\z:}', "");;
    Expect(1, 1114109, '\p{Vo=u}', "");
    Expect(0, 1114109, '\p{^Vo=u}', "");
    Expect(0, 1114109, '\P{Vo=u}', "");
    Expect(1, 1114109, '\P{^Vo=u}', "");
    Expect(0, 262144, '\p{Vo=u}', "");
    Expect(1, 262144, '\p{^Vo=u}', "");
    Expect(1, 262144, '\P{Vo=u}', "");
    Expect(0, 262144, '\P{^Vo=u}', "");
    Expect(1, 1114109, '\p{Vo=:\Au\z:}', "");;
    Expect(0, 262144, '\p{Vo=:\Au\z:}', "");;
    Expect(1, 1114109, '\p{Vo=	U}', "");
    Expect(0, 1114109, '\p{^Vo=	U}', "");
    Expect(0, 1114109, '\P{Vo=	U}', "");
    Expect(1, 1114109, '\P{^Vo=	U}', "");
    Expect(0, 262144, '\p{Vo=	U}', "");
    Expect(1, 262144, '\p{^Vo=	U}', "");
    Expect(1, 262144, '\P{Vo=	U}', "");
    Expect(0, 262144, '\P{^Vo=	U}', "");
    Error('\p{Is_Vertical_Orientation= 	Upright/a/}');
    Error('\P{Is_Vertical_Orientation= 	Upright/a/}');
    Expect(1, 1114109, '\p{Is_Vertical_Orientation:upright}', "");
    Expect(0, 1114109, '\p{^Is_Vertical_Orientation:upright}', "");
    Expect(0, 1114109, '\P{Is_Vertical_Orientation:upright}', "");
    Expect(1, 1114109, '\P{^Is_Vertical_Orientation:upright}', "");
    Expect(0, 262144, '\p{Is_Vertical_Orientation:upright}', "");
    Expect(1, 262144, '\p{^Is_Vertical_Orientation:upright}', "");
    Expect(1, 262144, '\P{Is_Vertical_Orientation:upright}', "");
    Expect(0, 262144, '\P{^Is_Vertical_Orientation:upright}', "");
    Expect(1, 1114109, '\p{Is_Vertical_Orientation=_ Upright}', "");
    Expect(0, 1114109, '\p{^Is_Vertical_Orientation=_ Upright}', "");
    Expect(0, 1114109, '\P{Is_Vertical_Orientation=_ Upright}', "");
    Expect(1, 1114109, '\P{^Is_Vertical_Orientation=_ Upright}', "");
    Expect(0, 262144, '\p{Is_Vertical_Orientation=_ Upright}', "");
    Expect(1, 262144, '\p{^Is_Vertical_Orientation=_ Upright}', "");
    Expect(1, 262144, '\P{Is_Vertical_Orientation=_ Upright}', "");
    Expect(0, 262144, '\P{^Is_Vertical_Orientation=_ Upright}', "");
    Error('\p{Is_Vo=/a/__u}');
    Error('\P{Is_Vo=/a/__u}');
    Expect(1, 1114109, '\p{Is_Vo=u}', "");
    Expect(0, 1114109, '\p{^Is_Vo=u}', "");
    Expect(0, 1114109, '\P{Is_Vo=u}', "");
    Expect(1, 1114109, '\P{^Is_Vo=u}', "");
    Expect(0, 262144, '\p{Is_Vo=u}', "");
    Expect(1, 262144, '\p{^Is_Vo=u}', "");
    Expect(1, 262144, '\P{Is_Vo=u}', "");
    Expect(0, 262144, '\P{^Is_Vo=u}', "");
    Expect(1, 1114109, '\p{Is_Vo=	U}', "");
    Expect(0, 1114109, '\p{^Is_Vo=	U}', "");
    Expect(0, 1114109, '\P{Is_Vo=	U}', "");
    Expect(1, 1114109, '\P{^Is_Vo=	U}', "");
    Expect(0, 262144, '\p{Is_Vo=	U}', "");
    Expect(1, 262144, '\p{^Is_Vo=	U}', "");
    Expect(1, 262144, '\P{Is_Vo=	U}', "");
    Expect(0, 262144, '\P{^Is_Vo=	U}', "");
    Error('\p{Variation_Selector: -:=no}');
    Error('\P{Variation_Selector: -:=no}');
    Expect(1, 918000, '\p{Variation_Selector=:\ANo\z:}', "");;
    Expect(0, 917999, '\p{Variation_Selector=:\ANo\z:}', "");;
    Expect(1, 918000, '\p{Variation_Selector=no}', "");
    Expect(0, 918000, '\p{^Variation_Selector=no}', "");
    Expect(0, 918000, '\P{Variation_Selector=no}', "");
    Expect(1, 918000, '\P{^Variation_Selector=no}', "");
    Expect(0, 917999, '\p{Variation_Selector=no}', "");
    Expect(1, 917999, '\p{^Variation_Selector=no}', "");
    Expect(1, 917999, '\P{Variation_Selector=no}', "");
    Expect(0, 917999, '\P{^Variation_Selector=no}', "");
    Expect(1, 918000, '\p{Variation_Selector=:\Ano\z:}', "");;
    Expect(0, 917999, '\p{Variation_Selector=:\Ano\z:}', "");;
    Expect(1, 918000, '\p{Variation_Selector=-no}', "");
    Expect(0, 918000, '\p{^Variation_Selector=-no}', "");
    Expect(0, 918000, '\P{Variation_Selector=-no}', "");
    Expect(1, 918000, '\P{^Variation_Selector=-no}', "");
    Expect(0, 917999, '\p{Variation_Selector=-no}', "");
    Expect(1, 917999, '\p{^Variation_Selector=-no}', "");
    Expect(1, 917999, '\P{Variation_Selector=-no}', "");
    Expect(0, 917999, '\P{^Variation_Selector=-no}', "");
    Error('\p{VS:/a/n}');
    Error('\P{VS:/a/n}');
    Expect(1, 918000, '\p{VS=:\AN\z:}', "");;
    Expect(0, 917999, '\p{VS=:\AN\z:}', "");;
    Expect(1, 918000, '\p{VS=n}', "");
    Expect(0, 918000, '\p{^VS=n}', "");
    Expect(0, 918000, '\P{VS=n}', "");
    Expect(1, 918000, '\P{^VS=n}', "");
    Expect(0, 917999, '\p{VS=n}', "");
    Expect(1, 917999, '\p{^VS=n}', "");
    Expect(1, 917999, '\P{VS=n}', "");
    Expect(0, 917999, '\P{^VS=n}', "");
    Expect(1, 918000, '\p{VS=:\An\z:}', "");;
    Expect(0, 917999, '\p{VS=:\An\z:}', "");;
    Expect(1, 918000, '\p{VS= N}', "");
    Expect(0, 918000, '\p{^VS= N}', "");
    Expect(0, 918000, '\P{VS= N}', "");
    Expect(1, 918000, '\P{^VS= N}', "");
    Expect(0, 917999, '\p{VS= N}', "");
    Expect(1, 917999, '\p{^VS= N}', "");
    Expect(1, 917999, '\P{VS= N}', "");
    Expect(0, 917999, '\P{^VS= N}', "");
    Error('\p{Is_Variation_Selector:	/a/ F}');
    Error('\P{Is_Variation_Selector:	/a/ F}');
    Expect(1, 918000, '\p{Is_Variation_Selector=f}', "");
    Expect(0, 918000, '\p{^Is_Variation_Selector=f}', "");
    Expect(0, 918000, '\P{Is_Variation_Selector=f}', "");
    Expect(1, 918000, '\P{^Is_Variation_Selector=f}', "");
    Expect(0, 917999, '\p{Is_Variation_Selector=f}', "");
    Expect(1, 917999, '\p{^Is_Variation_Selector=f}', "");
    Expect(1, 917999, '\P{Is_Variation_Selector=f}', "");
    Expect(0, 917999, '\P{^Is_Variation_Selector=f}', "");
    Expect(1, 918000, '\p{Is_Variation_Selector=	_F}', "");
    Expect(0, 918000, '\p{^Is_Variation_Selector=	_F}', "");
    Expect(0, 918000, '\P{Is_Variation_Selector=	_F}', "");
    Expect(1, 918000, '\P{^Is_Variation_Selector=	_F}', "");
    Expect(0, 917999, '\p{Is_Variation_Selector=	_F}', "");
    Expect(1, 917999, '\p{^Is_Variation_Selector=	_F}', "");
    Expect(1, 917999, '\P{Is_Variation_Selector=	_F}', "");
    Expect(0, 917999, '\P{^Is_Variation_Selector=	_F}', "");
    Error('\p{Is_VS=:=_False}');
    Error('\P{Is_VS=:=_False}');
    Expect(1, 918000, '\p{Is_VS=false}', "");
    Expect(0, 918000, '\p{^Is_VS=false}', "");
    Expect(0, 918000, '\P{Is_VS=false}', "");
    Expect(1, 918000, '\P{^Is_VS=false}', "");
    Expect(0, 917999, '\p{Is_VS=false}', "");
    Expect(1, 917999, '\p{^Is_VS=false}', "");
    Expect(1, 917999, '\P{Is_VS=false}', "");
    Expect(0, 917999, '\P{^Is_VS=false}', "");
    Expect(1, 918000, '\p{Is_VS=	 False}', "");
    Expect(0, 918000, '\p{^Is_VS=	 False}', "");
    Expect(0, 918000, '\P{Is_VS=	 False}', "");
    Expect(1, 918000, '\P{^Is_VS=	 False}', "");
    Expect(0, 917999, '\p{Is_VS=	 False}', "");
    Expect(1, 917999, '\p{^Is_VS=	 False}', "");
    Expect(1, 917999, '\P{Is_VS=	 False}', "");
    Expect(0, 917999, '\P{^Is_VS=	 False}', "");
    Error('\p{Variation_Selector=:=  yes}');
    Error('\P{Variation_Selector=:=  yes}');
    Expect(1, 917999, '\p{Variation_Selector=:\AYes\z:}', "");;
    Expect(0, 918000, '\p{Variation_Selector=:\AYes\z:}', "");;
    Expect(1, 917999, '\p{Variation_Selector=yes}', "");
    Expect(0, 917999, '\p{^Variation_Selector=yes}', "");
    Expect(0, 917999, '\P{Variation_Selector=yes}', "");
    Expect(1, 917999, '\P{^Variation_Selector=yes}', "");
    Expect(0, 918000, '\p{Variation_Selector=yes}', "");
    Expect(1, 918000, '\p{^Variation_Selector=yes}', "");
    Expect(1, 918000, '\P{Variation_Selector=yes}', "");
    Expect(0, 918000, '\P{^Variation_Selector=yes}', "");
    Expect(1, 917999, '\p{Variation_Selector=:\Ayes\z:}', "");;
    Expect(0, 918000, '\p{Variation_Selector=:\Ayes\z:}', "");;
    Expect(1, 917999, '\p{Variation_Selector=- YES}', "");
    Expect(0, 917999, '\p{^Variation_Selector=- YES}', "");
    Expect(0, 917999, '\P{Variation_Selector=- YES}', "");
    Expect(1, 917999, '\P{^Variation_Selector=- YES}', "");
    Expect(0, 918000, '\p{Variation_Selector=- YES}', "");
    Expect(1, 918000, '\p{^Variation_Selector=- YES}', "");
    Expect(1, 918000, '\P{Variation_Selector=- YES}', "");
    Expect(0, 918000, '\P{^Variation_Selector=- YES}', "");
    Error('\p{VS=-	y/a/}');
    Error('\P{VS=-	y/a/}');
    Expect(1, 917999, '\p{VS=:\AY\z:}', "");;
    Expect(0, 918000, '\p{VS=:\AY\z:}', "");;
    Expect(1, 917999, '\p{VS=y}', "");
    Expect(0, 917999, '\p{^VS=y}', "");
    Expect(0, 917999, '\P{VS=y}', "");
    Expect(1, 917999, '\P{^VS=y}', "");
    Expect(0, 918000, '\p{VS=y}', "");
    Expect(1, 918000, '\p{^VS=y}', "");
    Expect(1, 918000, '\P{VS=y}', "");
    Expect(0, 918000, '\P{^VS=y}', "");
    Expect(1, 917999, '\p{VS=:\Ay\z:}', "");;
    Expect(0, 918000, '\p{VS=:\Ay\z:}', "");;
    Expect(1, 917999, '\p{VS=		y}', "");
    Expect(0, 917999, '\p{^VS=		y}', "");
    Expect(0, 917999, '\P{VS=		y}', "");
    Expect(1, 917999, '\P{^VS=		y}', "");
    Expect(0, 918000, '\p{VS=		y}', "");
    Expect(1, 918000, '\p{^VS=		y}', "");
    Expect(1, 918000, '\P{VS=		y}', "");
    Expect(0, 918000, '\P{^VS=		y}', "");
    Error('\p{Is_Variation_Selector=_:=t}');
    Error('\P{Is_Variation_Selector=_:=t}');
    Expect(1, 917999, '\p{Is_Variation_Selector=t}', "");
    Expect(0, 917999, '\p{^Is_Variation_Selector=t}', "");
    Expect(0, 917999, '\P{Is_Variation_Selector=t}', "");
    Expect(1, 917999, '\P{^Is_Variation_Selector=t}', "");
    Expect(0, 918000, '\p{Is_Variation_Selector=t}', "");
    Expect(1, 918000, '\p{^Is_Variation_Selector=t}', "");
    Expect(1, 918000, '\P{Is_Variation_Selector=t}', "");
    Expect(0, 918000, '\P{^Is_Variation_Selector=t}', "");
    Expect(1, 917999, '\p{Is_Variation_Selector=-T}', "");
    Expect(0, 917999, '\p{^Is_Variation_Selector=-T}', "");
    Expect(0, 917999, '\P{Is_Variation_Selector=-T}', "");
    Expect(1, 917999, '\P{^Is_Variation_Selector=-T}', "");
    Expect(0, 918000, '\p{Is_Variation_Selector=-T}', "");
    Expect(1, 918000, '\p{^Is_Variation_Selector=-T}', "");
    Expect(1, 918000, '\P{Is_Variation_Selector=-T}', "");
    Expect(0, 918000, '\P{^Is_Variation_Selector=-T}', "");
    Error('\p{Is_VS=:=TRUE}');
    Error('\P{Is_VS=:=TRUE}');
    Expect(1, 917999, '\p{Is_VS: true}', "");
    Expect(0, 917999, '\p{^Is_VS: true}', "");
    Expect(0, 917999, '\P{Is_VS: true}', "");
    Expect(1, 917999, '\P{^Is_VS: true}', "");
    Expect(0, 918000, '\p{Is_VS: true}', "");
    Expect(1, 918000, '\p{^Is_VS: true}', "");
    Expect(1, 918000, '\P{Is_VS: true}', "");
    Expect(0, 918000, '\P{^Is_VS: true}', "");
    Expect(1, 917999, '\p{Is_VS=_	True}', "");
    Expect(0, 917999, '\p{^Is_VS=_	True}', "");
    Expect(0, 917999, '\P{Is_VS=_	True}', "");
    Expect(1, 917999, '\P{^Is_VS=_	True}', "");
    Expect(0, 918000, '\p{Is_VS=_	True}', "");
    Expect(1, 918000, '\p{^Is_VS=_	True}', "");
    Expect(1, 918000, '\P{Is_VS=_	True}', "");
    Expect(0, 918000, '\P{^Is_VS=_	True}', "");
    Error('\p{wordbreak}');
    Error('\P{wordbreak}');
    Error('\p{wb}');
    Error('\P{wb}');
    Error('\p{_perlwb}');
    Error('\P{_perlwb}');
    Error('\p{Word_Break=_/a/cr}');
    Error('\P{Word_Break=_/a/cr}');
    Expect(1, 13, '\p{Word_Break=:\ACR\z:}', "");;
    Expect(0, 14, '\p{Word_Break=:\ACR\z:}', "");;
    Expect(1, 13, '\p{Word_Break=cr}', "");
    Expect(0, 13, '\p{^Word_Break=cr}', "");
    Expect(0, 13, '\P{Word_Break=cr}', "");
    Expect(1, 13, '\P{^Word_Break=cr}', "");
    Expect(0, 14, '\p{Word_Break=cr}', "");
    Expect(1, 14, '\p{^Word_Break=cr}', "");
    Expect(1, 14, '\P{Word_Break=cr}', "");
    Expect(0, 14, '\P{^Word_Break=cr}', "");
    Expect(1, 13, '\p{Word_Break=:\Acr\z:}', "");;
    Expect(0, 14, '\p{Word_Break=:\Acr\z:}', "");;
    Expect(1, 13, '\p{Word_Break: -CR}', "");
    Expect(0, 13, '\p{^Word_Break: -CR}', "");
    Expect(0, 13, '\P{Word_Break: -CR}', "");
    Expect(1, 13, '\P{^Word_Break: -CR}', "");
    Expect(0, 14, '\p{Word_Break: -CR}', "");
    Expect(1, 14, '\p{^Word_Break: -CR}', "");
    Expect(1, 14, '\P{Word_Break: -CR}', "");
    Expect(0, 14, '\P{^Word_Break: -CR}', "");
    Error('\p{WB: _-CR/a/}');
    Error('\P{WB: _-CR/a/}');
    Expect(1, 13, '\p{WB=:\ACR\z:}', "");;
    Expect(0, 14, '\p{WB=:\ACR\z:}', "");;
    Expect(1, 13, '\p{WB=cr}', "");
    Expect(0, 13, '\p{^WB=cr}', "");
    Expect(0, 13, '\P{WB=cr}', "");
    Expect(1, 13, '\P{^WB=cr}', "");
    Expect(0, 14, '\p{WB=cr}', "");
    Expect(1, 14, '\p{^WB=cr}', "");
    Expect(1, 14, '\P{WB=cr}', "");
    Expect(0, 14, '\P{^WB=cr}', "");
    Expect(1, 13, '\p{WB=:\Acr\z:}', "");;
    Expect(0, 14, '\p{WB=:\Acr\z:}', "");;
    Expect(1, 13, '\p{WB=	_cr}', "");
    Expect(0, 13, '\p{^WB=	_cr}', "");
    Expect(0, 13, '\P{WB=	_cr}', "");
    Expect(1, 13, '\P{^WB=	_cr}', "");
    Expect(0, 14, '\p{WB=	_cr}', "");
    Expect(1, 14, '\p{^WB=	_cr}', "");
    Expect(1, 14, '\P{WB=	_cr}', "");
    Expect(0, 14, '\P{^WB=	_cr}', "");
    Error('\p{Is_Word_Break= CR/a/}');
    Error('\P{Is_Word_Break= CR/a/}');
    Expect(1, 13, '\p{Is_Word_Break=cr}', "");
    Expect(0, 13, '\p{^Is_Word_Break=cr}', "");
    Expect(0, 13, '\P{Is_Word_Break=cr}', "");
    Expect(1, 13, '\P{^Is_Word_Break=cr}', "");
    Expect(0, 14, '\p{Is_Word_Break=cr}', "");
    Expect(1, 14, '\p{^Is_Word_Break=cr}', "");
    Expect(1, 14, '\P{Is_Word_Break=cr}', "");
    Expect(0, 14, '\P{^Is_Word_Break=cr}', "");
    Expect(1, 13, '\p{Is_Word_Break=  CR}', "");
    Expect(0, 13, '\p{^Is_Word_Break=  CR}', "");
    Expect(0, 13, '\P{Is_Word_Break=  CR}', "");
    Expect(1, 13, '\P{^Is_Word_Break=  CR}', "");
    Expect(0, 14, '\p{Is_Word_Break=  CR}', "");
    Expect(1, 14, '\p{^Is_Word_Break=  CR}', "");
    Expect(1, 14, '\P{Is_Word_Break=  CR}', "");
    Expect(0, 14, '\P{^Is_Word_Break=  CR}', "");
    Error('\p{Is_WB=_CR:=}');
    Error('\P{Is_WB=_CR:=}');
    Expect(1, 13, '\p{Is_WB=cr}', "");
    Expect(0, 13, '\p{^Is_WB=cr}', "");
    Expect(0, 13, '\P{Is_WB=cr}', "");
    Expect(1, 13, '\P{^Is_WB=cr}', "");
    Expect(0, 14, '\p{Is_WB=cr}', "");
    Expect(1, 14, '\p{^Is_WB=cr}', "");
    Expect(1, 14, '\P{Is_WB=cr}', "");
    Expect(0, 14, '\P{^Is_WB=cr}', "");
    Expect(1, 13, '\p{Is_WB= -CR}', "");
    Expect(0, 13, '\p{^Is_WB= -CR}', "");
    Expect(0, 13, '\P{Is_WB= -CR}', "");
    Expect(1, 13, '\P{^Is_WB= -CR}', "");
    Expect(0, 14, '\p{Is_WB= -CR}', "");
    Expect(1, 14, '\p{^Is_WB= -CR}', "");
    Expect(1, 14, '\P{Is_WB= -CR}', "");
    Expect(0, 14, '\P{^Is_WB= -CR}', "");
    Error('\p{Word_Break=-Double_QUOTE:=}');
    Error('\P{Word_Break=-Double_QUOTE:=}');
    Expect(1, 34, '\p{Word_Break=:\ADouble_Quote\z:}', "");;
    Expect(0, 35, '\p{Word_Break=:\ADouble_Quote\z:}', "");;
    Expect(1, 34, '\p{Word_Break=doublequote}', "");
    Expect(0, 34, '\p{^Word_Break=doublequote}', "");
    Expect(0, 34, '\P{Word_Break=doublequote}', "");
    Expect(1, 34, '\P{^Word_Break=doublequote}', "");
    Expect(0, 35, '\p{Word_Break=doublequote}', "");
    Expect(1, 35, '\p{^Word_Break=doublequote}', "");
    Expect(1, 35, '\P{Word_Break=doublequote}', "");
    Expect(0, 35, '\P{^Word_Break=doublequote}', "");
    Expect(1, 34, '\p{Word_Break=:\Adoublequote\z:}', "");;
    Expect(0, 35, '\p{Word_Break=:\Adoublequote\z:}', "");;
    Expect(1, 34, '\p{Word_Break= _double_quote}', "");
    Expect(0, 34, '\p{^Word_Break= _double_quote}', "");
    Expect(0, 34, '\P{Word_Break= _double_quote}', "");
    Expect(1, 34, '\P{^Word_Break= _double_quote}', "");
    Expect(0, 35, '\p{Word_Break= _double_quote}', "");
    Expect(1, 35, '\p{^Word_Break= _double_quote}', "");
    Expect(1, 35, '\P{Word_Break= _double_quote}', "");
    Expect(0, 35, '\P{^Word_Break= _double_quote}', "");
    Error('\p{WB:_DQ:=}');
    Error('\P{WB:_DQ:=}');
    Expect(1, 34, '\p{WB=:\ADQ\z:}', "");;
    Expect(0, 35, '\p{WB=:\ADQ\z:}', "");;
    Expect(1, 34, '\p{WB=dq}', "");
    Expect(0, 34, '\p{^WB=dq}', "");
    Expect(0, 34, '\P{WB=dq}', "");
    Expect(1, 34, '\P{^WB=dq}', "");
    Expect(0, 35, '\p{WB=dq}', "");
    Expect(1, 35, '\p{^WB=dq}', "");
    Expect(1, 35, '\P{WB=dq}', "");
    Expect(0, 35, '\P{^WB=dq}', "");
    Expect(1, 34, '\p{WB=:\Adq\z:}', "");;
    Expect(0, 35, '\p{WB=:\Adq\z:}', "");;
    Expect(1, 34, '\p{WB=-DQ}', "");
    Expect(0, 34, '\p{^WB=-DQ}', "");
    Expect(0, 34, '\P{WB=-DQ}', "");
    Expect(1, 34, '\P{^WB=-DQ}', "");
    Expect(0, 35, '\p{WB=-DQ}', "");
    Expect(1, 35, '\p{^WB=-DQ}', "");
    Expect(1, 35, '\P{WB=-DQ}', "");
    Expect(0, 35, '\P{^WB=-DQ}', "");
    Error('\p{Is_Word_Break=/a/_double_quote}');
    Error('\P{Is_Word_Break=/a/_double_quote}');
    Expect(1, 34, '\p{Is_Word_Break:doublequote}', "");
    Expect(0, 34, '\p{^Is_Word_Break:doublequote}', "");
    Expect(0, 34, '\P{Is_Word_Break:doublequote}', "");
    Expect(1, 34, '\P{^Is_Word_Break:doublequote}', "");
    Expect(0, 35, '\p{Is_Word_Break:doublequote}', "");
    Expect(1, 35, '\p{^Is_Word_Break:doublequote}', "");
    Expect(1, 35, '\P{Is_Word_Break:doublequote}', "");
    Expect(0, 35, '\P{^Is_Word_Break:doublequote}', "");
    Expect(1, 34, '\p{Is_Word_Break=	DOUBLE_Quote}', "");
    Expect(0, 34, '\p{^Is_Word_Break=	DOUBLE_Quote}', "");
    Expect(0, 34, '\P{Is_Word_Break=	DOUBLE_Quote}', "");
    Expect(1, 34, '\P{^Is_Word_Break=	DOUBLE_Quote}', "");
    Expect(0, 35, '\p{Is_Word_Break=	DOUBLE_Quote}', "");
    Expect(1, 35, '\p{^Is_Word_Break=	DOUBLE_Quote}', "");
    Expect(1, 35, '\P{Is_Word_Break=	DOUBLE_Quote}', "");
    Expect(0, 35, '\P{^Is_Word_Break=	DOUBLE_Quote}', "");
    Error('\p{Is_WB= /a/DQ}');
    Error('\P{Is_WB= /a/DQ}');
    Expect(1, 34, '\p{Is_WB=dq}', "");
    Expect(0, 34, '\p{^Is_WB=dq}', "");
    Expect(0, 34, '\P{Is_WB=dq}', "");
    Expect(1, 34, '\P{^Is_WB=dq}', "");
    Expect(0, 35, '\p{Is_WB=dq}', "");
    Expect(1, 35, '\p{^Is_WB=dq}', "");
    Expect(1, 35, '\P{Is_WB=dq}', "");
    Expect(0, 35, '\P{^Is_WB=dq}', "");
    Expect(1, 34, '\p{Is_WB=	DQ}', "");
    Expect(0, 34, '\p{^Is_WB=	DQ}', "");
    Expect(0, 34, '\P{Is_WB=	DQ}', "");
    Expect(1, 34, '\P{^Is_WB=	DQ}', "");
    Expect(0, 35, '\p{Is_WB=	DQ}', "");
    Expect(1, 35, '\p{^Is_WB=	DQ}', "");
    Expect(1, 35, '\P{Is_WB=	DQ}', "");
    Expect(0, 35, '\P{^Is_WB=	DQ}', "");
    Error('\p{Word_Break= /a/e_base}');
    Error('\P{Word_Break= /a/e_base}');
    Expect(0, 1, '\p{Word_Break=:\AE_Base\z:}', "");;
    Expect(0, 1, '\p{Word_Break=ebase}', "");
    Expect(1, 1, '\p{^Word_Break=ebase}', "");
    Expect(1, 1, '\P{Word_Break=ebase}', "");
    Expect(0, 1, '\P{^Word_Break=ebase}', "");
    Expect(0, 1, '\p{Word_Break=:\Aebase\z:}', "");;
    Expect(0, 1, '\p{Word_Break=--E_Base}', "");
    Expect(1, 1, '\p{^Word_Break=--E_Base}', "");
    Expect(1, 1, '\P{Word_Break=--E_Base}', "");
    Expect(0, 1, '\P{^Word_Break=--E_Base}', "");
    Error('\p{WB=-/a/EB}');
    Error('\P{WB=-/a/EB}');
    Expect(0, 1, '\p{WB=:\AEB\z:}', "");;
    Expect(0, 1, '\p{WB=eb}', "");
    Expect(1, 1, '\p{^WB=eb}', "");
    Expect(1, 1, '\P{WB=eb}', "");
    Expect(0, 1, '\P{^WB=eb}', "");
    Expect(0, 1, '\p{WB=:\Aeb\z:}', "");;
    Expect(0, 1, '\p{WB= EB}', "");
    Expect(1, 1, '\p{^WB= EB}', "");
    Expect(1, 1, '\P{WB= EB}', "");
    Expect(0, 1, '\P{^WB= EB}', "");
    Error('\p{Is_Word_Break=	/a/e_BASE}');
    Error('\P{Is_Word_Break=	/a/e_BASE}');
    Expect(0, 1, '\p{Is_Word_Break=ebase}', "");
    Expect(1, 1, '\p{^Is_Word_Break=ebase}', "");
    Expect(1, 1, '\P{Is_Word_Break=ebase}', "");
    Expect(0, 1, '\P{^Is_Word_Break=ebase}', "");
    Expect(0, 1, '\p{Is_Word_Break:	 	e_Base}', "");
    Expect(1, 1, '\p{^Is_Word_Break:	 	e_Base}', "");
    Expect(1, 1, '\P{Is_Word_Break:	 	e_Base}', "");
    Expect(0, 1, '\P{^Is_Word_Break:	 	e_Base}', "");
    Error('\p{Is_WB=-/a/EB}');
    Error('\P{Is_WB=-/a/EB}');
    Expect(0, 1, '\p{Is_WB=eb}', "");
    Expect(1, 1, '\p{^Is_WB=eb}', "");
    Expect(1, 1, '\P{Is_WB=eb}', "");
    Expect(0, 1, '\P{^Is_WB=eb}', "");
    Expect(0, 1, '\p{Is_WB=  eb}', "");
    Expect(1, 1, '\p{^Is_WB=  eb}', "");
    Expect(1, 1, '\P{Is_WB=  eb}', "");
    Expect(0, 1, '\P{^Is_WB=  eb}', "");
    Error('\p{Word_Break=:=-E_BASE_GAZ}');
    Error('\P{Word_Break=:=-E_BASE_GAZ}');
    Expect(0, 1, '\p{Word_Break=:\AE_Base_GAZ\z:}', "");;
    Expect(0, 1, '\p{Word_Break=ebasegaz}', "");
    Expect(1, 1, '\p{^Word_Break=ebasegaz}', "");
    Expect(1, 1, '\P{Word_Break=ebasegaz}', "");
    Expect(0, 1, '\P{^Word_Break=ebasegaz}', "");
    Expect(0, 1, '\p{Word_Break=:\Aebasegaz\z:}', "");;
    Expect(0, 1, '\p{Word_Break= -E_Base_gaz}', "");
    Expect(1, 1, '\p{^Word_Break= -E_Base_gaz}', "");
    Expect(1, 1, '\P{Word_Break= -E_Base_gaz}', "");
    Expect(0, 1, '\P{^Word_Break= -E_Base_gaz}', "");
    Error('\p{WB:	_-EBG/a/}');
    Error('\P{WB:	_-EBG/a/}');
    Expect(0, 1, '\p{WB=:\AEBG\z:}', "");;
    Expect(0, 1, '\p{WB=ebg}', "");
    Expect(1, 1, '\p{^WB=ebg}', "");
    Expect(1, 1, '\P{WB=ebg}', "");
    Expect(0, 1, '\P{^WB=ebg}', "");
    Expect(0, 1, '\p{WB=:\Aebg\z:}', "");;
    Expect(0, 1, '\p{WB=--EBG}', "");
    Expect(1, 1, '\p{^WB=--EBG}', "");
    Expect(1, 1, '\P{WB=--EBG}', "");
    Expect(0, 1, '\P{^WB=--EBG}', "");
    Error('\p{Is_Word_Break=:=__E_base_GAZ}');
    Error('\P{Is_Word_Break=:=__E_base_GAZ}');
    Expect(0, 1, '\p{Is_Word_Break=ebasegaz}', "");
    Expect(1, 1, '\p{^Is_Word_Break=ebasegaz}', "");
    Expect(1, 1, '\P{Is_Word_Break=ebasegaz}', "");
    Expect(0, 1, '\P{^Is_Word_Break=ebasegaz}', "");
    Expect(0, 1, '\p{Is_Word_Break=_E_BASE_GAZ}', "");
    Expect(1, 1, '\p{^Is_Word_Break=_E_BASE_GAZ}', "");
    Expect(1, 1, '\P{Is_Word_Break=_E_BASE_GAZ}', "");
    Expect(0, 1, '\P{^Is_Word_Break=_E_BASE_GAZ}', "");
    Error('\p{Is_WB=/a/_ EBG}');
    Error('\P{Is_WB=/a/_ EBG}');
    Expect(0, 1, '\p{Is_WB=ebg}', "");
    Expect(1, 1, '\p{^Is_WB=ebg}', "");
    Expect(1, 1, '\P{Is_WB=ebg}', "");
    Expect(0, 1, '\P{^Is_WB=ebg}', "");
    Expect(0, 1, '\p{Is_WB=	 EBG}', "");
    Expect(1, 1, '\p{^Is_WB=	 EBG}', "");
    Expect(1, 1, '\P{Is_WB=	 EBG}', "");
    Expect(0, 1, '\P{^Is_WB=	 EBG}', "");
    Error('\p{Word_Break=  E_Modifier/a/}');
    Error('\P{Word_Break=  E_Modifier/a/}');
    Expect(0, 1, '\p{Word_Break=:\AE_Modifier\z:}', "");;
    Expect(0, 1, '\p{Word_Break=emodifier}', "");
    Expect(1, 1, '\p{^Word_Break=emodifier}', "");
    Expect(1, 1, '\P{Word_Break=emodifier}', "");
    Expect(0, 1, '\P{^Word_Break=emodifier}', "");
    Expect(0, 1, '\p{Word_Break=:\Aemodifier\z:}', "");;
    Expect(0, 1, '\p{Word_Break=_ e_Modifier}', "");
    Expect(1, 1, '\p{^Word_Break=_ e_Modifier}', "");
    Expect(1, 1, '\P{Word_Break=_ e_Modifier}', "");
    Expect(0, 1, '\P{^Word_Break=_ e_Modifier}', "");
    Error('\p{WB=	 EM/a/}');
    Error('\P{WB=	 EM/a/}');
    Expect(0, 1, '\p{WB=:\AEM\z:}', "");;
    Expect(0, 1, '\p{WB=em}', "");
    Expect(1, 1, '\p{^WB=em}', "");
    Expect(1, 1, '\P{WB=em}', "");
    Expect(0, 1, '\P{^WB=em}', "");
    Expect(0, 1, '\p{WB=:\Aem\z:}', "");;
    Expect(0, 1, '\p{WB:	-EM}', "");
    Expect(1, 1, '\p{^WB:	-EM}', "");
    Expect(1, 1, '\P{WB:	-EM}', "");
    Expect(0, 1, '\P{^WB:	-EM}', "");
    Error('\p{Is_Word_Break=/a/ 	e_Modifier}');
    Error('\P{Is_Word_Break=/a/ 	e_Modifier}');
    Expect(0, 1, '\p{Is_Word_Break=emodifier}', "");
    Expect(1, 1, '\p{^Is_Word_Break=emodifier}', "");
    Expect(1, 1, '\P{Is_Word_Break=emodifier}', "");
    Expect(0, 1, '\P{^Is_Word_Break=emodifier}', "");
    Expect(0, 1, '\p{Is_Word_Break:   		E_MODIFIER}', "");
    Expect(1, 1, '\p{^Is_Word_Break:   		E_MODIFIER}', "");
    Expect(1, 1, '\P{Is_Word_Break:   		E_MODIFIER}', "");
    Expect(0, 1, '\P{^Is_Word_Break:   		E_MODIFIER}', "");
    Error('\p{Is_WB=  em:=}');
    Error('\P{Is_WB=  em:=}');
    Expect(0, 1, '\p{Is_WB=em}', "");
    Expect(1, 1, '\p{^Is_WB=em}', "");
    Expect(1, 1, '\P{Is_WB=em}', "");
    Expect(0, 1, '\P{^Is_WB=em}', "");
    Expect(0, 1, '\p{Is_WB=_EM}', "");
    Expect(1, 1, '\p{^Is_WB=_EM}', "");
    Expect(1, 1, '\P{Is_WB=_EM}', "");
    Expect(0, 1, '\P{^Is_WB=_EM}', "");
    Error('\p{Word_Break: /a/extendnumlet}');
    Error('\P{Word_Break: /a/extendnumlet}');
    Expect(1, 65343, '\p{Word_Break=:\AExtendNumLet\z:}', "");;
    Expect(0, 65344, '\p{Word_Break=:\AExtendNumLet\z:}', "");;
    Expect(1, 65343, '\p{Word_Break=extendnumlet}', "");
    Expect(0, 65343, '\p{^Word_Break=extendnumlet}', "");
    Expect(0, 65343, '\P{Word_Break=extendnumlet}', "");
    Expect(1, 65343, '\P{^Word_Break=extendnumlet}', "");
    Expect(0, 65344, '\p{Word_Break=extendnumlet}', "");
    Expect(1, 65344, '\p{^Word_Break=extendnumlet}', "");
    Expect(1, 65344, '\P{Word_Break=extendnumlet}', "");
    Expect(0, 65344, '\P{^Word_Break=extendnumlet}', "");
    Expect(1, 65343, '\p{Word_Break=:\Aextendnumlet\z:}', "");;
    Expect(0, 65344, '\p{Word_Break=:\Aextendnumlet\z:}', "");;
    Expect(1, 65343, '\p{Word_Break:   _extendnumlet}', "");
    Expect(0, 65343, '\p{^Word_Break:   _extendnumlet}', "");
    Expect(0, 65343, '\P{Word_Break:   _extendnumlet}', "");
    Expect(1, 65343, '\P{^Word_Break:   _extendnumlet}', "");
    Expect(0, 65344, '\p{Word_Break:   _extendnumlet}', "");
    Expect(1, 65344, '\p{^Word_Break:   _extendnumlet}', "");
    Expect(1, 65344, '\P{Word_Break:   _extendnumlet}', "");
    Expect(0, 65344, '\P{^Word_Break:   _extendnumlet}', "");
    Error('\p{WB=	_EX:=}');
    Error('\P{WB=	_EX:=}');
    Expect(1, 65343, '\p{WB=:\AEX\z:}', "");;
    Expect(0, 65344, '\p{WB=:\AEX\z:}', "");;
    Expect(1, 65343, '\p{WB:ex}', "");
    Expect(0, 65343, '\p{^WB:ex}', "");
    Expect(0, 65343, '\P{WB:ex}', "");
    Expect(1, 65343, '\P{^WB:ex}', "");
    Expect(0, 65344, '\p{WB:ex}', "");
    Expect(1, 65344, '\p{^WB:ex}', "");
    Expect(1, 65344, '\P{WB:ex}', "");
    Expect(0, 65344, '\P{^WB:ex}', "");
    Expect(1, 65343, '\p{WB=:\Aex\z:}', "");;
    Expect(0, 65344, '\p{WB=:\Aex\z:}', "");;
    Expect(1, 65343, '\p{WB=-EX}', "");
    Expect(0, 65343, '\p{^WB=-EX}', "");
    Expect(0, 65343, '\P{WB=-EX}', "");
    Expect(1, 65343, '\P{^WB=-EX}', "");
    Expect(0, 65344, '\p{WB=-EX}', "");
    Expect(1, 65344, '\p{^WB=-EX}', "");
    Expect(1, 65344, '\P{WB=-EX}', "");
    Expect(0, 65344, '\P{^WB=-EX}', "");
    Error('\p{Is_Word_Break=	-EXTENDNUMLET:=}');
    Error('\P{Is_Word_Break=	-EXTENDNUMLET:=}');
    Expect(1, 65343, '\p{Is_Word_Break=extendnumlet}', "");
    Expect(0, 65343, '\p{^Is_Word_Break=extendnumlet}', "");
    Expect(0, 65343, '\P{Is_Word_Break=extendnumlet}', "");
    Expect(1, 65343, '\P{^Is_Word_Break=extendnumlet}', "");
    Expect(0, 65344, '\p{Is_Word_Break=extendnumlet}', "");
    Expect(1, 65344, '\p{^Is_Word_Break=extendnumlet}', "");
    Expect(1, 65344, '\P{Is_Word_Break=extendnumlet}', "");
    Expect(0, 65344, '\P{^Is_Word_Break=extendnumlet}', "");
    Expect(1, 65343, '\p{Is_Word_Break=_ExtendNumLet}', "");
    Expect(0, 65343, '\p{^Is_Word_Break=_ExtendNumLet}', "");
    Expect(0, 65343, '\P{Is_Word_Break=_ExtendNumLet}', "");
    Expect(1, 65343, '\P{^Is_Word_Break=_ExtendNumLet}', "");
    Expect(0, 65344, '\p{Is_Word_Break=_ExtendNumLet}', "");
    Expect(1, 65344, '\p{^Is_Word_Break=_ExtendNumLet}', "");
    Expect(1, 65344, '\P{Is_Word_Break=_ExtendNumLet}', "");
    Expect(0, 65344, '\P{^Is_Word_Break=_ExtendNumLet}', "");
    Error('\p{Is_WB= 	EX/a/}');
    Error('\P{Is_WB= 	EX/a/}');
    Expect(1, 65343, '\p{Is_WB=ex}', "");
    Expect(0, 65343, '\p{^Is_WB=ex}', "");
    Expect(0, 65343, '\P{Is_WB=ex}', "");
    Expect(1, 65343, '\P{^Is_WB=ex}', "");
    Expect(0, 65344, '\p{Is_WB=ex}', "");
    Expect(1, 65344, '\p{^Is_WB=ex}', "");
    Expect(1, 65344, '\P{Is_WB=ex}', "");
    Expect(0, 65344, '\P{^Is_WB=ex}', "");
    Expect(1, 65343, '\p{Is_WB=	-EX}', "");
    Expect(0, 65343, '\p{^Is_WB=	-EX}', "");
    Expect(0, 65343, '\P{Is_WB=	-EX}', "");
    Expect(1, 65343, '\P{^Is_WB=	-EX}', "");
    Expect(0, 65344, '\p{Is_WB=	-EX}', "");
    Expect(1, 65344, '\p{^Is_WB=	-EX}', "");
    Expect(1, 65344, '\P{Is_WB=	-EX}', "");
    Expect(0, 65344, '\P{^Is_WB=	-EX}', "");
    Error('\p{Word_Break=:=_	Extend}');
    Error('\P{Word_Break=:=_	Extend}');
    Expect(1, 917999, '\p{Word_Break=:\AExtend\z:}', "");;
    Expect(0, 918000, '\p{Word_Break=:\AExtend\z:}', "");;
    Expect(1, 917999, '\p{Word_Break=extend}', "");
    Expect(0, 917999, '\p{^Word_Break=extend}', "");
    Expect(0, 917999, '\P{Word_Break=extend}', "");
    Expect(1, 917999, '\P{^Word_Break=extend}', "");
    Expect(0, 918000, '\p{Word_Break=extend}', "");
    Expect(1, 918000, '\p{^Word_Break=extend}', "");
    Expect(1, 918000, '\P{Word_Break=extend}', "");
    Expect(0, 918000, '\P{^Word_Break=extend}', "");
    Expect(1, 917999, '\p{Word_Break=:\Aextend\z:}', "");;
    Expect(0, 918000, '\p{Word_Break=:\Aextend\z:}', "");;
    Expect(1, 917999, '\p{Word_Break: _Extend}', "");
    Expect(0, 917999, '\p{^Word_Break: _Extend}', "");
    Expect(0, 917999, '\P{Word_Break: _Extend}', "");
    Expect(1, 917999, '\P{^Word_Break: _Extend}', "");
    Expect(0, 918000, '\p{Word_Break: _Extend}', "");
    Expect(1, 918000, '\p{^Word_Break: _Extend}', "");
    Expect(1, 918000, '\P{Word_Break: _Extend}', "");
    Expect(0, 918000, '\P{^Word_Break: _Extend}', "");
    Error('\p{WB:		:=Extend}');
    Error('\P{WB:		:=Extend}');
    Expect(1, 917999, '\p{WB=:\AExtend\z:}', "");;
    Expect(0, 918000, '\p{WB=:\AExtend\z:}', "");;
    Expect(1, 917999, '\p{WB=extend}', "");
    Expect(0, 917999, '\p{^WB=extend}', "");
    Expect(0, 917999, '\P{WB=extend}', "");
    Expect(1, 917999, '\P{^WB=extend}', "");
    Expect(0, 918000, '\p{WB=extend}', "");
    Expect(1, 918000, '\p{^WB=extend}', "");
    Expect(1, 918000, '\P{WB=extend}', "");
    Expect(0, 918000, '\P{^WB=extend}', "");
    Expect(1, 917999, '\p{WB=:\Aextend\z:}', "");;
    Expect(0, 918000, '\p{WB=:\Aextend\z:}', "");;
    Expect(1, 917999, '\p{WB=_ EXTEND}', "");
    Expect(0, 917999, '\p{^WB=_ EXTEND}', "");
    Expect(0, 917999, '\P{WB=_ EXTEND}', "");
    Expect(1, 917999, '\P{^WB=_ EXTEND}', "");
    Expect(0, 918000, '\p{WB=_ EXTEND}', "");
    Expect(1, 918000, '\p{^WB=_ EXTEND}', "");
    Expect(1, 918000, '\P{WB=_ EXTEND}', "");
    Expect(0, 918000, '\P{^WB=_ EXTEND}', "");
    Error('\p{Is_Word_Break=:=		Extend}');
    Error('\P{Is_Word_Break=:=		Extend}');
    Expect(1, 917999, '\p{Is_Word_Break=extend}', "");
    Expect(0, 917999, '\p{^Is_Word_Break=extend}', "");
    Expect(0, 917999, '\P{Is_Word_Break=extend}', "");
    Expect(1, 917999, '\P{^Is_Word_Break=extend}', "");
    Expect(0, 918000, '\p{Is_Word_Break=extend}', "");
    Expect(1, 918000, '\p{^Is_Word_Break=extend}', "");
    Expect(1, 918000, '\P{Is_Word_Break=extend}', "");
    Expect(0, 918000, '\P{^Is_Word_Break=extend}', "");
    Expect(1, 917999, '\p{Is_Word_Break=_Extend}', "");
    Expect(0, 917999, '\p{^Is_Word_Break=_Extend}', "");
    Expect(0, 917999, '\P{Is_Word_Break=_Extend}', "");
    Expect(1, 917999, '\P{^Is_Word_Break=_Extend}', "");
    Expect(0, 918000, '\p{Is_Word_Break=_Extend}', "");
    Expect(1, 918000, '\p{^Is_Word_Break=_Extend}', "");
    Expect(1, 918000, '\P{Is_Word_Break=_Extend}', "");
    Expect(0, 918000, '\P{^Is_Word_Break=_Extend}', "");
    Error('\p{Is_WB=	 EXTEND:=}');
    Error('\P{Is_WB=	 EXTEND:=}');
    Expect(1, 917999, '\p{Is_WB:   extend}', "");
    Expect(0, 917999, '\p{^Is_WB:   extend}', "");
    Expect(0, 917999, '\P{Is_WB:   extend}', "");
    Expect(1, 917999, '\P{^Is_WB:   extend}', "");
    Expect(0, 918000, '\p{Is_WB:   extend}', "");
    Expect(1, 918000, '\p{^Is_WB:   extend}', "");
    Expect(1, 918000, '\P{Is_WB:   extend}', "");
    Expect(0, 918000, '\P{^Is_WB:   extend}', "");
    Expect(1, 917999, '\p{Is_WB=-EXTEND}', "");
    Expect(0, 917999, '\p{^Is_WB=-EXTEND}', "");
    Expect(0, 917999, '\P{Is_WB=-EXTEND}', "");
    Expect(1, 917999, '\P{^Is_WB=-EXTEND}', "");
    Expect(0, 918000, '\p{Is_WB=-EXTEND}', "");
    Expect(1, 918000, '\p{^Is_WB=-EXTEND}', "");
    Expect(1, 918000, '\P{Is_WB=-EXTEND}', "");
    Expect(0, 918000, '\P{^Is_WB=-EXTEND}', "");
    Error('\p{Word_Break=  FORMAT:=}');
    Error('\P{Word_Break=  FORMAT:=}');
    Expect(1, 917505, '\p{Word_Break=:\AFormat\z:}', "");;
    Expect(0, 917506, '\p{Word_Break=:\AFormat\z:}', "");;
    Expect(1, 917505, '\p{Word_Break=format}', "");
    Expect(0, 917505, '\p{^Word_Break=format}', "");
    Expect(0, 917505, '\P{Word_Break=format}', "");
    Expect(1, 917505, '\P{^Word_Break=format}', "");
    Expect(0, 917506, '\p{Word_Break=format}', "");
    Expect(1, 917506, '\p{^Word_Break=format}', "");
    Expect(1, 917506, '\P{Word_Break=format}', "");
    Expect(0, 917506, '\P{^Word_Break=format}', "");
    Expect(1, 917505, '\p{Word_Break=:\Aformat\z:}', "");;
    Expect(0, 917506, '\p{Word_Break=:\Aformat\z:}', "");;
    Expect(1, 917505, '\p{Word_Break: _-format}', "");
    Expect(0, 917505, '\p{^Word_Break: _-format}', "");
    Expect(0, 917505, '\P{Word_Break: _-format}', "");
    Expect(1, 917505, '\P{^Word_Break: _-format}', "");
    Expect(0, 917506, '\p{Word_Break: _-format}', "");
    Expect(1, 917506, '\p{^Word_Break: _-format}', "");
    Expect(1, 917506, '\P{Word_Break: _-format}', "");
    Expect(0, 917506, '\P{^Word_Break: _-format}', "");
    Error('\p{WB=/a/_-fo}');
    Error('\P{WB=/a/_-fo}');
    Expect(1, 917505, '\p{WB=:\AFO\z:}', "");;
    Expect(0, 917506, '\p{WB=:\AFO\z:}', "");;
    Expect(1, 917505, '\p{WB=fo}', "");
    Expect(0, 917505, '\p{^WB=fo}', "");
    Expect(0, 917505, '\P{WB=fo}', "");
    Expect(1, 917505, '\P{^WB=fo}', "");
    Expect(0, 917506, '\p{WB=fo}', "");
    Expect(1, 917506, '\p{^WB=fo}', "");
    Expect(1, 917506, '\P{WB=fo}', "");
    Expect(0, 917506, '\P{^WB=fo}', "");
    Expect(1, 917505, '\p{WB=:\Afo\z:}', "");;
    Expect(0, 917506, '\p{WB=:\Afo\z:}', "");;
    Expect(1, 917505, '\p{WB=	FO}', "");
    Expect(0, 917505, '\p{^WB=	FO}', "");
    Expect(0, 917505, '\P{WB=	FO}', "");
    Expect(1, 917505, '\P{^WB=	FO}', "");
    Expect(0, 917506, '\p{WB=	FO}', "");
    Expect(1, 917506, '\p{^WB=	FO}', "");
    Expect(1, 917506, '\P{WB=	FO}', "");
    Expect(0, 917506, '\P{^WB=	FO}', "");
    Error('\p{Is_Word_Break=/a/		Format}');
    Error('\P{Is_Word_Break=/a/		Format}');
    Expect(1, 917505, '\p{Is_Word_Break=format}', "");
    Expect(0, 917505, '\p{^Is_Word_Break=format}', "");
    Expect(0, 917505, '\P{Is_Word_Break=format}', "");
    Expect(1, 917505, '\P{^Is_Word_Break=format}', "");
    Expect(0, 917506, '\p{Is_Word_Break=format}', "");
    Expect(1, 917506, '\p{^Is_Word_Break=format}', "");
    Expect(1, 917506, '\P{Is_Word_Break=format}', "");
    Expect(0, 917506, '\P{^Is_Word_Break=format}', "");
    Expect(1, 917505, '\p{Is_Word_Break= Format}', "");
    Expect(0, 917505, '\p{^Is_Word_Break= Format}', "");
    Expect(0, 917505, '\P{Is_Word_Break= Format}', "");
    Expect(1, 917505, '\P{^Is_Word_Break= Format}', "");
    Expect(0, 917506, '\p{Is_Word_Break= Format}', "");
    Expect(1, 917506, '\p{^Is_Word_Break= Format}', "");
    Expect(1, 917506, '\P{Is_Word_Break= Format}', "");
    Expect(0, 917506, '\P{^Is_Word_Break= Format}', "");
    Error('\p{Is_WB=:=	_FO}');
    Error('\P{Is_WB=:=	_FO}');
    Expect(1, 917505, '\p{Is_WB=fo}', "");
    Expect(0, 917505, '\p{^Is_WB=fo}', "");
    Expect(0, 917505, '\P{Is_WB=fo}', "");
    Expect(1, 917505, '\P{^Is_WB=fo}', "");
    Expect(0, 917506, '\p{Is_WB=fo}', "");
    Expect(1, 917506, '\p{^Is_WB=fo}', "");
    Expect(1, 917506, '\P{Is_WB=fo}', "");
    Expect(0, 917506, '\P{^Is_WB=fo}', "");
    Expect(1, 917505, '\p{Is_WB=-fo}', "");
    Expect(0, 917505, '\p{^Is_WB=-fo}', "");
    Expect(0, 917505, '\P{Is_WB=-fo}', "");
    Expect(1, 917505, '\P{^Is_WB=-fo}', "");
    Expect(0, 917506, '\p{Is_WB=-fo}', "");
    Expect(1, 917506, '\p{^Is_WB=-fo}', "");
    Expect(1, 917506, '\P{Is_WB=-fo}', "");
    Expect(0, 917506, '\P{^Is_WB=-fo}', "");
    Error('\p{Word_Break= :=Glue_After_Zwj}');
    Error('\P{Word_Break= :=Glue_After_Zwj}');
    Expect(0, 1, '\p{Word_Break=:\AGlue_After_Zwj\z:}', "");;
    Expect(0, 1, '\p{Word_Break:glueafterzwj}', "");
    Expect(1, 1, '\p{^Word_Break:glueafterzwj}', "");
    Expect(1, 1, '\P{Word_Break:glueafterzwj}', "");
    Expect(0, 1, '\P{^Word_Break:glueafterzwj}', "");
    Expect(0, 1, '\p{Word_Break=:\Aglueafterzwj\z:}', "");;
    Expect(0, 1, '\p{Word_Break= _glue_after_Zwj}', "");
    Expect(1, 1, '\p{^Word_Break= _glue_after_Zwj}', "");
    Expect(1, 1, '\P{Word_Break= _glue_after_Zwj}', "");
    Expect(0, 1, '\P{^Word_Break= _glue_after_Zwj}', "");
    Error('\p{WB=_/a/GAZ}');
    Error('\P{WB=_/a/GAZ}');
    Expect(0, 1, '\p{WB=:\AGAZ\z:}', "");;
    Expect(0, 1, '\p{WB=gaz}', "");
    Expect(1, 1, '\p{^WB=gaz}', "");
    Expect(1, 1, '\P{WB=gaz}', "");
    Expect(0, 1, '\P{^WB=gaz}', "");
    Expect(0, 1, '\p{WB=:\Agaz\z:}', "");;
    Expect(0, 1, '\p{WB=-GAZ}', "");
    Expect(1, 1, '\p{^WB=-GAZ}', "");
    Expect(1, 1, '\P{WB=-GAZ}', "");
    Expect(0, 1, '\P{^WB=-GAZ}', "");
    Error('\p{Is_Word_Break=:=Glue_after_Zwj}');
    Error('\P{Is_Word_Break=:=Glue_after_Zwj}');
    Expect(0, 1, '\p{Is_Word_Break=glueafterzwj}', "");
    Expect(1, 1, '\p{^Is_Word_Break=glueafterzwj}', "");
    Expect(1, 1, '\P{Is_Word_Break=glueafterzwj}', "");
    Expect(0, 1, '\P{^Is_Word_Break=glueafterzwj}', "");
    Expect(0, 1, '\p{Is_Word_Break=-GLUE_After_zwj}', "");
    Expect(1, 1, '\p{^Is_Word_Break=-GLUE_After_zwj}', "");
    Expect(1, 1, '\P{Is_Word_Break=-GLUE_After_zwj}', "");
    Expect(0, 1, '\P{^Is_Word_Break=-GLUE_After_zwj}', "");
    Error('\p{Is_WB=	 gaz:=}');
    Error('\P{Is_WB=	 gaz:=}');
    Expect(0, 1, '\p{Is_WB=gaz}', "");
    Expect(1, 1, '\p{^Is_WB=gaz}', "");
    Expect(1, 1, '\P{Is_WB=gaz}', "");
    Expect(0, 1, '\P{^Is_WB=gaz}', "");
    Expect(0, 1, '\p{Is_WB= 	GAZ}', "");
    Expect(1, 1, '\p{^Is_WB= 	GAZ}', "");
    Expect(1, 1, '\P{Is_WB= 	GAZ}', "");
    Expect(0, 1, '\P{^Is_WB= 	GAZ}', "");
    Error('\p{Word_Break=--Hebrew_Letter/a/}');
    Error('\P{Word_Break=--Hebrew_Letter/a/}');
    Expect(1, 64335, '\p{Word_Break=:\AHebrew_Letter\z:}', "");;
    Expect(0, 64336, '\p{Word_Break=:\AHebrew_Letter\z:}', "");;
    Expect(1, 64335, '\p{Word_Break=hebrewletter}', "");
    Expect(0, 64335, '\p{^Word_Break=hebrewletter}', "");
    Expect(0, 64335, '\P{Word_Break=hebrewletter}', "");
    Expect(1, 64335, '\P{^Word_Break=hebrewletter}', "");
    Expect(0, 64336, '\p{Word_Break=hebrewletter}', "");
    Expect(1, 64336, '\p{^Word_Break=hebrewletter}', "");
    Expect(1, 64336, '\P{Word_Break=hebrewletter}', "");
    Expect(0, 64336, '\P{^Word_Break=hebrewletter}', "");
    Expect(1, 64335, '\p{Word_Break=:\Ahebrewletter\z:}', "");;
    Expect(0, 64336, '\p{Word_Break=:\Ahebrewletter\z:}', "");;
    Expect(1, 64335, '\p{Word_Break= HEBREW_LETTER}', "");
    Expect(0, 64335, '\p{^Word_Break= HEBREW_LETTER}', "");
    Expect(0, 64335, '\P{Word_Break= HEBREW_LETTER}', "");
    Expect(1, 64335, '\P{^Word_Break= HEBREW_LETTER}', "");
    Expect(0, 64336, '\p{Word_Break= HEBREW_LETTER}', "");
    Expect(1, 64336, '\p{^Word_Break= HEBREW_LETTER}', "");
    Expect(1, 64336, '\P{Word_Break= HEBREW_LETTER}', "");
    Expect(0, 64336, '\P{^Word_Break= HEBREW_LETTER}', "");
    Error('\p{WB=_-hl/a/}');
    Error('\P{WB=_-hl/a/}');
    Expect(1, 64335, '\p{WB=:\AHL\z:}', "");;
    Expect(0, 64336, '\p{WB=:\AHL\z:}', "");;
    Expect(1, 64335, '\p{WB=hl}', "");
    Expect(0, 64335, '\p{^WB=hl}', "");
    Expect(0, 64335, '\P{WB=hl}', "");
    Expect(1, 64335, '\P{^WB=hl}', "");
    Expect(0, 64336, '\p{WB=hl}', "");
    Expect(1, 64336, '\p{^WB=hl}', "");
    Expect(1, 64336, '\P{WB=hl}', "");
    Expect(0, 64336, '\P{^WB=hl}', "");
    Expect(1, 64335, '\p{WB=:\Ahl\z:}', "");;
    Expect(0, 64336, '\p{WB=:\Ahl\z:}', "");;
    Expect(1, 64335, '\p{WB: -	hl}', "");
    Expect(0, 64335, '\p{^WB: -	hl}', "");
    Expect(0, 64335, '\P{WB: -	hl}', "");
    Expect(1, 64335, '\P{^WB: -	hl}', "");
    Expect(0, 64336, '\p{WB: -	hl}', "");
    Expect(1, 64336, '\p{^WB: -	hl}', "");
    Expect(1, 64336, '\P{WB: -	hl}', "");
    Expect(0, 64336, '\P{^WB: -	hl}', "");
    Error('\p{Is_Word_Break=:= _Hebrew_LETTER}');
    Error('\P{Is_Word_Break=:= _Hebrew_LETTER}');
    Expect(1, 64335, '\p{Is_Word_Break=hebrewletter}', "");
    Expect(0, 64335, '\p{^Is_Word_Break=hebrewletter}', "");
    Expect(0, 64335, '\P{Is_Word_Break=hebrewletter}', "");
    Expect(1, 64335, '\P{^Is_Word_Break=hebrewletter}', "");
    Expect(0, 64336, '\p{Is_Word_Break=hebrewletter}', "");
    Expect(1, 64336, '\p{^Is_Word_Break=hebrewletter}', "");
    Expect(1, 64336, '\P{Is_Word_Break=hebrewletter}', "");
    Expect(0, 64336, '\P{^Is_Word_Break=hebrewletter}', "");
    Expect(1, 64335, '\p{Is_Word_Break= Hebrew_Letter}', "");
    Expect(0, 64335, '\p{^Is_Word_Break= Hebrew_Letter}', "");
    Expect(0, 64335, '\P{Is_Word_Break= Hebrew_Letter}', "");
    Expect(1, 64335, '\P{^Is_Word_Break= Hebrew_Letter}', "");
    Expect(0, 64336, '\p{Is_Word_Break= Hebrew_Letter}', "");
    Expect(1, 64336, '\p{^Is_Word_Break= Hebrew_Letter}', "");
    Expect(1, 64336, '\P{Is_Word_Break= Hebrew_Letter}', "");
    Expect(0, 64336, '\P{^Is_Word_Break= Hebrew_Letter}', "");
    Error('\p{Is_WB=-:=HL}');
    Error('\P{Is_WB=-:=HL}');
    Expect(1, 64335, '\p{Is_WB:   hl}', "");
    Expect(0, 64335, '\p{^Is_WB:   hl}', "");
    Expect(0, 64335, '\P{Is_WB:   hl}', "");
    Expect(1, 64335, '\P{^Is_WB:   hl}', "");
    Expect(0, 64336, '\p{Is_WB:   hl}', "");
    Expect(1, 64336, '\p{^Is_WB:   hl}', "");
    Expect(1, 64336, '\P{Is_WB:   hl}', "");
    Expect(0, 64336, '\P{^Is_WB:   hl}', "");
    Expect(1, 64335, '\p{Is_WB:   -	hl}', "");
    Expect(0, 64335, '\p{^Is_WB:   -	hl}', "");
    Expect(0, 64335, '\P{Is_WB:   -	hl}', "");
    Expect(1, 64335, '\P{^Is_WB:   -	hl}', "");
    Expect(0, 64336, '\p{Is_WB:   -	hl}', "");
    Expect(1, 64336, '\p{^Is_WB:   -	hl}', "");
    Expect(1, 64336, '\P{Is_WB:   -	hl}', "");
    Expect(0, 64336, '\P{^Is_WB:   -	hl}', "");
    Error('\p{Word_Break=/a/katakana}');
    Error('\P{Word_Break=/a/katakana}');
    Expect(1, 110951, '\p{Word_Break=:\AKatakana\z:}', "");;
    Expect(0, 110952, '\p{Word_Break=:\AKatakana\z:}', "");;
    Expect(1, 110951, '\p{Word_Break=katakana}', "");
    Expect(0, 110951, '\p{^Word_Break=katakana}', "");
    Expect(0, 110951, '\P{Word_Break=katakana}', "");
    Expect(1, 110951, '\P{^Word_Break=katakana}', "");
    Expect(0, 110952, '\p{Word_Break=katakana}', "");
    Expect(1, 110952, '\p{^Word_Break=katakana}', "");
    Expect(1, 110952, '\P{Word_Break=katakana}', "");
    Expect(0, 110952, '\P{^Word_Break=katakana}', "");
    Expect(1, 110951, '\p{Word_Break=:\Akatakana\z:}', "");;
    Expect(0, 110952, '\p{Word_Break=:\Akatakana\z:}', "");;
    Expect(1, 110951, '\p{Word_Break= _Katakana}', "");
    Expect(0, 110951, '\p{^Word_Break= _Katakana}', "");
    Expect(0, 110951, '\P{Word_Break= _Katakana}', "");
    Expect(1, 110951, '\P{^Word_Break= _Katakana}', "");
    Expect(0, 110952, '\p{Word_Break= _Katakana}', "");
    Expect(1, 110952, '\p{^Word_Break= _Katakana}', "");
    Expect(1, 110952, '\P{Word_Break= _Katakana}', "");
    Expect(0, 110952, '\P{^Word_Break= _Katakana}', "");
    Error('\p{WB=	ka/a/}');
    Error('\P{WB=	ka/a/}');
    Expect(1, 110951, '\p{WB=:\AKA\z:}', "");;
    Expect(0, 110952, '\p{WB=:\AKA\z:}', "");;
    Expect(1, 110951, '\p{WB=ka}', "");
    Expect(0, 110951, '\p{^WB=ka}', "");
    Expect(0, 110951, '\P{WB=ka}', "");
    Expect(1, 110951, '\P{^WB=ka}', "");
    Expect(0, 110952, '\p{WB=ka}', "");
    Expect(1, 110952, '\p{^WB=ka}', "");
    Expect(1, 110952, '\P{WB=ka}', "");
    Expect(0, 110952, '\P{^WB=ka}', "");
    Expect(1, 110951, '\p{WB=:\Aka\z:}', "");;
    Expect(0, 110952, '\p{WB=:\Aka\z:}', "");;
    Expect(1, 110951, '\p{WB=	 KA}', "");
    Expect(0, 110951, '\p{^WB=	 KA}', "");
    Expect(0, 110951, '\P{WB=	 KA}', "");
    Expect(1, 110951, '\P{^WB=	 KA}', "");
    Expect(0, 110952, '\p{WB=	 KA}', "");
    Expect(1, 110952, '\p{^WB=	 KA}', "");
    Expect(1, 110952, '\P{WB=	 KA}', "");
    Expect(0, 110952, '\P{^WB=	 KA}', "");
    Error('\p{Is_Word_Break:		:=Katakana}');
    Error('\P{Is_Word_Break:		:=Katakana}');
    Expect(1, 110951, '\p{Is_Word_Break=katakana}', "");
    Expect(0, 110951, '\p{^Is_Word_Break=katakana}', "");
    Expect(0, 110951, '\P{Is_Word_Break=katakana}', "");
    Expect(1, 110951, '\P{^Is_Word_Break=katakana}', "");
    Expect(0, 110952, '\p{Is_Word_Break=katakana}', "");
    Expect(1, 110952, '\p{^Is_Word_Break=katakana}', "");
    Expect(1, 110952, '\P{Is_Word_Break=katakana}', "");
    Expect(0, 110952, '\P{^Is_Word_Break=katakana}', "");
    Expect(1, 110951, '\p{Is_Word_Break=	Katakana}', "");
    Expect(0, 110951, '\p{^Is_Word_Break=	Katakana}', "");
    Expect(0, 110951, '\P{Is_Word_Break=	Katakana}', "");
    Expect(1, 110951, '\P{^Is_Word_Break=	Katakana}', "");
    Expect(0, 110952, '\p{Is_Word_Break=	Katakana}', "");
    Expect(1, 110952, '\p{^Is_Word_Break=	Katakana}', "");
    Expect(1, 110952, '\P{Is_Word_Break=	Katakana}', "");
    Expect(0, 110952, '\P{^Is_Word_Break=	Katakana}', "");
    Error('\p{Is_WB= KA:=}');
    Error('\P{Is_WB= KA:=}');
    Expect(1, 110951, '\p{Is_WB=ka}', "");
    Expect(0, 110951, '\p{^Is_WB=ka}', "");
    Expect(0, 110951, '\P{Is_WB=ka}', "");
    Expect(1, 110951, '\P{^Is_WB=ka}', "");
    Expect(0, 110952, '\p{Is_WB=ka}', "");
    Expect(1, 110952, '\p{^Is_WB=ka}', "");
    Expect(1, 110952, '\P{Is_WB=ka}', "");
    Expect(0, 110952, '\P{^Is_WB=ka}', "");
    Expect(1, 110951, '\p{Is_WB=-	KA}', "");
    Expect(0, 110951, '\p{^Is_WB=-	KA}', "");
    Expect(0, 110951, '\P{Is_WB=-	KA}', "");
    Expect(1, 110951, '\P{^Is_WB=-	KA}', "");
    Expect(0, 110952, '\p{Is_WB=-	KA}', "");
    Expect(1, 110952, '\p{^Is_WB=-	KA}', "");
    Expect(1, 110952, '\P{Is_WB=-	KA}', "");
    Expect(0, 110952, '\P{^Is_WB=-	KA}', "");
    Error('\p{Word_Break= _ALetter:=}');
    Error('\P{Word_Break= _ALetter:=}');
    Expect(1, 127369, '\p{Word_Break=:\AALetter\z:}', "");;
    Expect(0, 127370, '\p{Word_Break=:\AALetter\z:}', "");;
    Expect(1, 127369, '\p{Word_Break=aletter}', "");
    Expect(0, 127369, '\p{^Word_Break=aletter}', "");
    Expect(0, 127369, '\P{Word_Break=aletter}', "");
    Expect(1, 127369, '\P{^Word_Break=aletter}', "");
    Expect(0, 127370, '\p{Word_Break=aletter}', "");
    Expect(1, 127370, '\p{^Word_Break=aletter}', "");
    Expect(1, 127370, '\P{Word_Break=aletter}', "");
    Expect(0, 127370, '\P{^Word_Break=aletter}', "");
    Expect(1, 127369, '\p{Word_Break=:\Aaletter\z:}', "");;
    Expect(0, 127370, '\p{Word_Break=:\Aaletter\z:}', "");;
    Expect(1, 127369, '\p{Word_Break=	ALetter}', "");
    Expect(0, 127369, '\p{^Word_Break=	ALetter}', "");
    Expect(0, 127369, '\P{Word_Break=	ALetter}', "");
    Expect(1, 127369, '\P{^Word_Break=	ALetter}', "");
    Expect(0, 127370, '\p{Word_Break=	ALetter}', "");
    Expect(1, 127370, '\p{^Word_Break=	ALetter}', "");
    Expect(1, 127370, '\P{Word_Break=	ALetter}', "");
    Expect(0, 127370, '\P{^Word_Break=	ALetter}', "");
    Error('\p{WB=/a/le}');
    Error('\P{WB=/a/le}');
    Expect(1, 127369, '\p{WB=:\ALE\z:}', "");;
    Expect(0, 127370, '\p{WB=:\ALE\z:}', "");;
    Expect(1, 127369, '\p{WB=le}', "");
    Expect(0, 127369, '\p{^WB=le}', "");
    Expect(0, 127369, '\P{WB=le}', "");
    Expect(1, 127369, '\P{^WB=le}', "");
    Expect(0, 127370, '\p{WB=le}', "");
    Expect(1, 127370, '\p{^WB=le}', "");
    Expect(1, 127370, '\P{WB=le}', "");
    Expect(0, 127370, '\P{^WB=le}', "");
    Expect(1, 127369, '\p{WB=:\Ale\z:}', "");;
    Expect(0, 127370, '\p{WB=:\Ale\z:}', "");;
    Expect(1, 127369, '\p{WB= LE}', "");
    Expect(0, 127369, '\p{^WB= LE}', "");
    Expect(0, 127369, '\P{WB= LE}', "");
    Expect(1, 127369, '\P{^WB= LE}', "");
    Expect(0, 127370, '\p{WB= LE}', "");
    Expect(1, 127370, '\p{^WB= LE}', "");
    Expect(1, 127370, '\P{WB= LE}', "");
    Expect(0, 127370, '\P{^WB= LE}', "");
    Error('\p{Is_Word_Break:	_ALetter/a/}');
    Error('\P{Is_Word_Break:	_ALetter/a/}');
    Expect(1, 127369, '\p{Is_Word_Break=aletter}', "");
    Expect(0, 127369, '\p{^Is_Word_Break=aletter}', "");
    Expect(0, 127369, '\P{Is_Word_Break=aletter}', "");
    Expect(1, 127369, '\P{^Is_Word_Break=aletter}', "");
    Expect(0, 127370, '\p{Is_Word_Break=aletter}', "");
    Expect(1, 127370, '\p{^Is_Word_Break=aletter}', "");
    Expect(1, 127370, '\P{Is_Word_Break=aletter}', "");
    Expect(0, 127370, '\P{^Is_Word_Break=aletter}', "");
    Expect(1, 127369, '\p{Is_Word_Break=_-aletter}', "");
    Expect(0, 127369, '\p{^Is_Word_Break=_-aletter}', "");
    Expect(0, 127369, '\P{Is_Word_Break=_-aletter}', "");
    Expect(1, 127369, '\P{^Is_Word_Break=_-aletter}', "");
    Expect(0, 127370, '\p{Is_Word_Break=_-aletter}', "");
    Expect(1, 127370, '\p{^Is_Word_Break=_-aletter}', "");
    Expect(1, 127370, '\P{Is_Word_Break=_-aletter}', "");
    Expect(0, 127370, '\P{^Is_Word_Break=_-aletter}', "");
    Error('\p{Is_WB=-	LE/a/}');
    Error('\P{Is_WB=-	LE/a/}');
    Expect(1, 127369, '\p{Is_WB:le}', "");
    Expect(0, 127369, '\p{^Is_WB:le}', "");
    Expect(0, 127369, '\P{Is_WB:le}', "");
    Expect(1, 127369, '\P{^Is_WB:le}', "");
    Expect(0, 127370, '\p{Is_WB:le}', "");
    Expect(1, 127370, '\p{^Is_WB:le}', "");
    Expect(1, 127370, '\P{Is_WB:le}', "");
    Expect(0, 127370, '\P{^Is_WB:le}', "");
    Expect(1, 127369, '\p{Is_WB=_ le}', "");
    Expect(0, 127369, '\p{^Is_WB=_ le}', "");
    Expect(0, 127369, '\P{Is_WB=_ le}', "");
    Expect(1, 127369, '\P{^Is_WB=_ le}', "");
    Expect(0, 127370, '\p{Is_WB=_ le}', "");
    Expect(1, 127370, '\p{^Is_WB=_ le}', "");
    Expect(1, 127370, '\P{Is_WB=_ le}', "");
    Expect(0, 127370, '\P{^Is_WB=_ le}', "");
    Error('\p{Word_Break=	:=LF}');
    Error('\P{Word_Break=	:=LF}');
    Expect(1, 10, '\p{Word_Break=:\ALF\z:}', "");;
    Expect(0, 11, '\p{Word_Break=:\ALF\z:}', "");;
    Expect(1, 10, '\p{Word_Break=lf}', "");
    Expect(0, 10, '\p{^Word_Break=lf}', "");
    Expect(0, 10, '\P{Word_Break=lf}', "");
    Expect(1, 10, '\P{^Word_Break=lf}', "");
    Expect(0, 11, '\p{Word_Break=lf}', "");
    Expect(1, 11, '\p{^Word_Break=lf}', "");
    Expect(1, 11, '\P{Word_Break=lf}', "");
    Expect(0, 11, '\P{^Word_Break=lf}', "");
    Expect(1, 10, '\p{Word_Break=:\Alf\z:}', "");;
    Expect(0, 11, '\p{Word_Break=:\Alf\z:}', "");;
    Expect(1, 10, '\p{Word_Break:  lf}', "");
    Expect(0, 10, '\p{^Word_Break:  lf}', "");
    Expect(0, 10, '\P{Word_Break:  lf}', "");
    Expect(1, 10, '\P{^Word_Break:  lf}', "");
    Expect(0, 11, '\p{Word_Break:  lf}', "");
    Expect(1, 11, '\p{^Word_Break:  lf}', "");
    Expect(1, 11, '\P{Word_Break:  lf}', "");
    Expect(0, 11, '\P{^Word_Break:  lf}', "");
    Error('\p{WB=:=__LF}');
    Error('\P{WB=:=__LF}');
    Expect(1, 10, '\p{WB=:\ALF\z:}', "");;
    Expect(0, 11, '\p{WB=:\ALF\z:}', "");;
    Expect(1, 10, '\p{WB=lf}', "");
    Expect(0, 10, '\p{^WB=lf}', "");
    Expect(0, 10, '\P{WB=lf}', "");
    Expect(1, 10, '\P{^WB=lf}', "");
    Expect(0, 11, '\p{WB=lf}', "");
    Expect(1, 11, '\p{^WB=lf}', "");
    Expect(1, 11, '\P{WB=lf}', "");
    Expect(0, 11, '\P{^WB=lf}', "");
    Expect(1, 10, '\p{WB=:\Alf\z:}', "");;
    Expect(0, 11, '\p{WB=:\Alf\z:}', "");;
    Expect(1, 10, '\p{WB=-	LF}', "");
    Expect(0, 10, '\p{^WB=-	LF}', "");
    Expect(0, 10, '\P{WB=-	LF}', "");
    Expect(1, 10, '\P{^WB=-	LF}', "");
    Expect(0, 11, '\p{WB=-	LF}', "");
    Expect(1, 11, '\p{^WB=-	LF}', "");
    Expect(1, 11, '\P{WB=-	LF}', "");
    Expect(0, 11, '\P{^WB=-	LF}', "");
    Error('\p{Is_Word_Break=__LF:=}');
    Error('\P{Is_Word_Break=__LF:=}');
    Expect(1, 10, '\p{Is_Word_Break:	lf}', "");
    Expect(0, 10, '\p{^Is_Word_Break:	lf}', "");
    Expect(0, 10, '\P{Is_Word_Break:	lf}', "");
    Expect(1, 10, '\P{^Is_Word_Break:	lf}', "");
    Expect(0, 11, '\p{Is_Word_Break:	lf}', "");
    Expect(1, 11, '\p{^Is_Word_Break:	lf}', "");
    Expect(1, 11, '\P{Is_Word_Break:	lf}', "");
    Expect(0, 11, '\P{^Is_Word_Break:	lf}', "");
    Expect(1, 10, '\p{Is_Word_Break= 	lf}', "");
    Expect(0, 10, '\p{^Is_Word_Break= 	lf}', "");
    Expect(0, 10, '\P{Is_Word_Break= 	lf}', "");
    Expect(1, 10, '\P{^Is_Word_Break= 	lf}', "");
    Expect(0, 11, '\p{Is_Word_Break= 	lf}', "");
    Expect(1, 11, '\p{^Is_Word_Break= 	lf}', "");
    Expect(1, 11, '\P{Is_Word_Break= 	lf}', "");
    Expect(0, 11, '\P{^Is_Word_Break= 	lf}', "");
    Error('\p{Is_WB=_:=LF}');
    Error('\P{Is_WB=_:=LF}');
    Expect(1, 10, '\p{Is_WB=lf}', "");
    Expect(0, 10, '\p{^Is_WB=lf}', "");
    Expect(0, 10, '\P{Is_WB=lf}', "");
    Expect(1, 10, '\P{^Is_WB=lf}', "");
    Expect(0, 11, '\p{Is_WB=lf}', "");
    Expect(1, 11, '\p{^Is_WB=lf}', "");
    Expect(1, 11, '\P{Is_WB=lf}', "");
    Expect(0, 11, '\P{^Is_WB=lf}', "");
    Expect(1, 10, '\p{Is_WB:   	lf}', "");
    Expect(0, 10, '\p{^Is_WB:   	lf}', "");
    Expect(0, 10, '\P{Is_WB:   	lf}', "");
    Expect(1, 10, '\P{^Is_WB:   	lf}', "");
    Expect(0, 11, '\p{Is_WB:   	lf}', "");
    Expect(1, 11, '\p{^Is_WB:   	lf}', "");
    Expect(1, 11, '\P{Is_WB:   	lf}', "");
    Expect(0, 11, '\P{^Is_WB:   	lf}', "");
    Error('\p{Word_Break= MidNumLet/a/}');
    Error('\P{Word_Break= MidNumLet/a/}');
    Expect(1, 65294, '\p{Word_Break=:\AMidNumLet\z:}', "");;
    Expect(0, 65295, '\p{Word_Break=:\AMidNumLet\z:}', "");;
    Expect(1, 65294, '\p{Word_Break=midnumlet}', "");
    Expect(0, 65294, '\p{^Word_Break=midnumlet}', "");
    Expect(0, 65294, '\P{Word_Break=midnumlet}', "");
    Expect(1, 65294, '\P{^Word_Break=midnumlet}', "");
    Expect(0, 65295, '\p{Word_Break=midnumlet}', "");
    Expect(1, 65295, '\p{^Word_Break=midnumlet}', "");
    Expect(1, 65295, '\P{Word_Break=midnumlet}', "");
    Expect(0, 65295, '\P{^Word_Break=midnumlet}', "");
    Expect(1, 65294, '\p{Word_Break=:\Amidnumlet\z:}', "");;
    Expect(0, 65295, '\p{Word_Break=:\Amidnumlet\z:}', "");;
    Expect(1, 65294, '\p{Word_Break= -midnumlet}', "");
    Expect(0, 65294, '\p{^Word_Break= -midnumlet}', "");
    Expect(0, 65294, '\P{Word_Break= -midnumlet}', "");
    Expect(1, 65294, '\P{^Word_Break= -midnumlet}', "");
    Expect(0, 65295, '\p{Word_Break= -midnumlet}', "");
    Expect(1, 65295, '\p{^Word_Break= -midnumlet}', "");
    Expect(1, 65295, '\P{Word_Break= -midnumlet}', "");
    Expect(0, 65295, '\P{^Word_Break= -midnumlet}', "");
    Error('\p{WB= MB:=}');
    Error('\P{WB= MB:=}');
    Expect(1, 65294, '\p{WB=:\AMB\z:}', "");;
    Expect(0, 65295, '\p{WB=:\AMB\z:}', "");;
    Expect(1, 65294, '\p{WB=mb}', "");
    Expect(0, 65294, '\p{^WB=mb}', "");
    Expect(0, 65294, '\P{WB=mb}', "");
    Expect(1, 65294, '\P{^WB=mb}', "");
    Expect(0, 65295, '\p{WB=mb}', "");
    Expect(1, 65295, '\p{^WB=mb}', "");
    Expect(1, 65295, '\P{WB=mb}', "");
    Expect(0, 65295, '\P{^WB=mb}', "");
    Expect(1, 65294, '\p{WB=:\Amb\z:}', "");;
    Expect(0, 65295, '\p{WB=:\Amb\z:}', "");;
    Expect(1, 65294, '\p{WB= -MB}', "");
    Expect(0, 65294, '\p{^WB= -MB}', "");
    Expect(0, 65294, '\P{WB= -MB}', "");
    Expect(1, 65294, '\P{^WB= -MB}', "");
    Expect(0, 65295, '\p{WB= -MB}', "");
    Expect(1, 65295, '\p{^WB= -MB}', "");
    Expect(1, 65295, '\P{WB= -MB}', "");
    Expect(0, 65295, '\P{^WB= -MB}', "");
    Error('\p{Is_Word_Break=_MIDNUMLET/a/}');
    Error('\P{Is_Word_Break=_MIDNUMLET/a/}');
    Expect(1, 65294, '\p{Is_Word_Break=midnumlet}', "");
    Expect(0, 65294, '\p{^Is_Word_Break=midnumlet}', "");
    Expect(0, 65294, '\P{Is_Word_Break=midnumlet}', "");
    Expect(1, 65294, '\P{^Is_Word_Break=midnumlet}', "");
    Expect(0, 65295, '\p{Is_Word_Break=midnumlet}', "");
    Expect(1, 65295, '\p{^Is_Word_Break=midnumlet}', "");
    Expect(1, 65295, '\P{Is_Word_Break=midnumlet}', "");
    Expect(0, 65295, '\P{^Is_Word_Break=midnumlet}', "");
    Expect(1, 65294, '\p{Is_Word_Break= _MidNumLet}', "");
    Expect(0, 65294, '\p{^Is_Word_Break= _MidNumLet}', "");
    Expect(0, 65294, '\P{Is_Word_Break= _MidNumLet}', "");
    Expect(1, 65294, '\P{^Is_Word_Break= _MidNumLet}', "");
    Expect(0, 65295, '\p{Is_Word_Break= _MidNumLet}', "");
    Expect(1, 65295, '\p{^Is_Word_Break= _MidNumLet}', "");
    Expect(1, 65295, '\P{Is_Word_Break= _MidNumLet}', "");
    Expect(0, 65295, '\P{^Is_Word_Break= _MidNumLet}', "");
    Error('\p{Is_WB:   /a/MB}');
    Error('\P{Is_WB:   /a/MB}');
    Expect(1, 65294, '\p{Is_WB=mb}', "");
    Expect(0, 65294, '\p{^Is_WB=mb}', "");
    Expect(0, 65294, '\P{Is_WB=mb}', "");
    Expect(1, 65294, '\P{^Is_WB=mb}', "");
    Expect(0, 65295, '\p{Is_WB=mb}', "");
    Expect(1, 65295, '\p{^Is_WB=mb}', "");
    Expect(1, 65295, '\P{Is_WB=mb}', "");
    Expect(0, 65295, '\P{^Is_WB=mb}', "");
    Expect(1, 65294, '\p{Is_WB= -mb}', "");
    Expect(0, 65294, '\p{^Is_WB= -mb}', "");
    Expect(0, 65294, '\P{Is_WB= -mb}', "");
    Expect(1, 65294, '\P{^Is_WB= -mb}', "");
    Expect(0, 65295, '\p{Is_WB= -mb}', "");
    Expect(1, 65295, '\p{^Is_WB= -mb}', "");
    Expect(1, 65295, '\P{Is_WB= -mb}', "");
    Expect(0, 65295, '\P{^Is_WB= -mb}', "");
    Error('\p{Word_Break=/a/__MIDLETTER}');
    Error('\P{Word_Break=/a/__MIDLETTER}');
    Expect(1, 65306, '\p{Word_Break=:\AMidLetter\z:}', "");;
    Expect(0, 65307, '\p{Word_Break=:\AMidLetter\z:}', "");;
    Expect(1, 65306, '\p{Word_Break=midletter}', "");
    Expect(0, 65306, '\p{^Word_Break=midletter}', "");
    Expect(0, 65306, '\P{Word_Break=midletter}', "");
    Expect(1, 65306, '\P{^Word_Break=midletter}', "");
    Expect(0, 65307, '\p{Word_Break=midletter}', "");
    Expect(1, 65307, '\p{^Word_Break=midletter}', "");
    Expect(1, 65307, '\P{Word_Break=midletter}', "");
    Expect(0, 65307, '\P{^Word_Break=midletter}', "");
    Expect(1, 65306, '\p{Word_Break=:\Amidletter\z:}', "");;
    Expect(0, 65307, '\p{Word_Break=:\Amidletter\z:}', "");;
    Expect(1, 65306, '\p{Word_Break=-_MidLetter}', "");
    Expect(0, 65306, '\p{^Word_Break=-_MidLetter}', "");
    Expect(0, 65306, '\P{Word_Break=-_MidLetter}', "");
    Expect(1, 65306, '\P{^Word_Break=-_MidLetter}', "");
    Expect(0, 65307, '\p{Word_Break=-_MidLetter}', "");
    Expect(1, 65307, '\p{^Word_Break=-_MidLetter}', "");
    Expect(1, 65307, '\P{Word_Break=-_MidLetter}', "");
    Expect(0, 65307, '\P{^Word_Break=-_MidLetter}', "");
    Error('\p{WB= ML:=}');
    Error('\P{WB= ML:=}');
    Expect(1, 65306, '\p{WB=:\AML\z:}', "");;
    Expect(0, 65307, '\p{WB=:\AML\z:}', "");;
    Expect(1, 65306, '\p{WB=ml}', "");
    Expect(0, 65306, '\p{^WB=ml}', "");
    Expect(0, 65306, '\P{WB=ml}', "");
    Expect(1, 65306, '\P{^WB=ml}', "");
    Expect(0, 65307, '\p{WB=ml}', "");
    Expect(1, 65307, '\p{^WB=ml}', "");
    Expect(1, 65307, '\P{WB=ml}', "");
    Expect(0, 65307, '\P{^WB=ml}', "");
    Expect(1, 65306, '\p{WB=:\Aml\z:}', "");;
    Expect(0, 65307, '\p{WB=:\Aml\z:}', "");;
    Expect(1, 65306, '\p{WB=_	ML}', "");
    Expect(0, 65306, '\p{^WB=_	ML}', "");
    Expect(0, 65306, '\P{WB=_	ML}', "");
    Expect(1, 65306, '\P{^WB=_	ML}', "");
    Expect(0, 65307, '\p{WB=_	ML}', "");
    Expect(1, 65307, '\p{^WB=_	ML}', "");
    Expect(1, 65307, '\P{WB=_	ML}', "");
    Expect(0, 65307, '\P{^WB=_	ML}', "");
    Error('\p{Is_Word_Break=-	MIDLETTER/a/}');
    Error('\P{Is_Word_Break=-	MIDLETTER/a/}');
    Expect(1, 65306, '\p{Is_Word_Break=midletter}', "");
    Expect(0, 65306, '\p{^Is_Word_Break=midletter}', "");
    Expect(0, 65306, '\P{Is_Word_Break=midletter}', "");
    Expect(1, 65306, '\P{^Is_Word_Break=midletter}', "");
    Expect(0, 65307, '\p{Is_Word_Break=midletter}', "");
    Expect(1, 65307, '\p{^Is_Word_Break=midletter}', "");
    Expect(1, 65307, '\P{Is_Word_Break=midletter}', "");
    Expect(0, 65307, '\P{^Is_Word_Break=midletter}', "");
    Expect(1, 65306, '\p{Is_Word_Break:	 	MIDLETTER}', "");
    Expect(0, 65306, '\p{^Is_Word_Break:	 	MIDLETTER}', "");
    Expect(0, 65306, '\P{Is_Word_Break:	 	MIDLETTER}', "");
    Expect(1, 65306, '\P{^Is_Word_Break:	 	MIDLETTER}', "");
    Expect(0, 65307, '\p{Is_Word_Break:	 	MIDLETTER}', "");
    Expect(1, 65307, '\p{^Is_Word_Break:	 	MIDLETTER}', "");
    Expect(1, 65307, '\P{Is_Word_Break:	 	MIDLETTER}', "");
    Expect(0, 65307, '\P{^Is_Word_Break:	 	MIDLETTER}', "");
    Error('\p{Is_WB=:=ML}');
    Error('\P{Is_WB=:=ML}');
    Expect(1, 65306, '\p{Is_WB:ml}', "");
    Expect(0, 65306, '\p{^Is_WB:ml}', "");
    Expect(0, 65306, '\P{Is_WB:ml}', "");
    Expect(1, 65306, '\P{^Is_WB:ml}', "");
    Expect(0, 65307, '\p{Is_WB:ml}', "");
    Expect(1, 65307, '\p{^Is_WB:ml}', "");
    Expect(1, 65307, '\P{Is_WB:ml}', "");
    Expect(0, 65307, '\P{^Is_WB:ml}', "");
    Expect(1, 65306, '\p{Is_WB=	ML}', "");
    Expect(0, 65306, '\p{^Is_WB=	ML}', "");
    Expect(0, 65306, '\P{Is_WB=	ML}', "");
    Expect(1, 65306, '\P{^Is_WB=	ML}', "");
    Expect(0, 65307, '\p{Is_WB=	ML}', "");
    Expect(1, 65307, '\p{^Is_WB=	ML}', "");
    Expect(1, 65307, '\P{Is_WB=	ML}', "");
    Expect(0, 65307, '\P{^Is_WB=	ML}', "");
    Error('\p{Word_Break=		MIDNUM/a/}');
    Error('\P{Word_Break=		MIDNUM/a/}');
    Expect(1, 65307, '\p{Word_Break=:\AMidNum\z:}', "");;
    Expect(0, 65308, '\p{Word_Break=:\AMidNum\z:}', "");;
    Expect(1, 65307, '\p{Word_Break=midnum}', "");
    Expect(0, 65307, '\p{^Word_Break=midnum}', "");
    Expect(0, 65307, '\P{Word_Break=midnum}', "");
    Expect(1, 65307, '\P{^Word_Break=midnum}', "");
    Expect(0, 65308, '\p{Word_Break=midnum}', "");
    Expect(1, 65308, '\p{^Word_Break=midnum}', "");
    Expect(1, 65308, '\P{Word_Break=midnum}', "");
    Expect(0, 65308, '\P{^Word_Break=midnum}', "");
    Expect(1, 65307, '\p{Word_Break=:\Amidnum\z:}', "");;
    Expect(0, 65308, '\p{Word_Break=:\Amidnum\z:}', "");;
    Expect(1, 65307, '\p{Word_Break=_ MidNum}', "");
    Expect(0, 65307, '\p{^Word_Break=_ MidNum}', "");
    Expect(0, 65307, '\P{Word_Break=_ MidNum}', "");
    Expect(1, 65307, '\P{^Word_Break=_ MidNum}', "");
    Expect(0, 65308, '\p{Word_Break=_ MidNum}', "");
    Expect(1, 65308, '\p{^Word_Break=_ MidNum}', "");
    Expect(1, 65308, '\P{Word_Break=_ MidNum}', "");
    Expect(0, 65308, '\P{^Word_Break=_ MidNum}', "");
    Error('\p{WB:	-/a/mn}');
    Error('\P{WB:	-/a/mn}');
    Expect(1, 65307, '\p{WB=:\AMN\z:}', "");;
    Expect(0, 65308, '\p{WB=:\AMN\z:}', "");;
    Expect(1, 65307, '\p{WB=mn}', "");
    Expect(0, 65307, '\p{^WB=mn}', "");
    Expect(0, 65307, '\P{WB=mn}', "");
    Expect(1, 65307, '\P{^WB=mn}', "");
    Expect(0, 65308, '\p{WB=mn}', "");
    Expect(1, 65308, '\p{^WB=mn}', "");
    Expect(1, 65308, '\P{WB=mn}', "");
    Expect(0, 65308, '\P{^WB=mn}', "");
    Expect(1, 65307, '\p{WB=:\Amn\z:}', "");;
    Expect(0, 65308, '\p{WB=:\Amn\z:}', "");;
    Expect(1, 65307, '\p{WB:   _-MN}', "");
    Expect(0, 65307, '\p{^WB:   _-MN}', "");
    Expect(0, 65307, '\P{WB:   _-MN}', "");
    Expect(1, 65307, '\P{^WB:   _-MN}', "");
    Expect(0, 65308, '\p{WB:   _-MN}', "");
    Expect(1, 65308, '\p{^WB:   _-MN}', "");
    Expect(1, 65308, '\P{WB:   _-MN}', "");
    Expect(0, 65308, '\P{^WB:   _-MN}', "");
    Error('\p{Is_Word_Break=-:=midnum}');
    Error('\P{Is_Word_Break=-:=midnum}');
    Expect(1, 65307, '\p{Is_Word_Break=midnum}', "");
    Expect(0, 65307, '\p{^Is_Word_Break=midnum}', "");
    Expect(0, 65307, '\P{Is_Word_Break=midnum}', "");
    Expect(1, 65307, '\P{^Is_Word_Break=midnum}', "");
    Expect(0, 65308, '\p{Is_Word_Break=midnum}', "");
    Expect(1, 65308, '\p{^Is_Word_Break=midnum}', "");
    Expect(1, 65308, '\P{Is_Word_Break=midnum}', "");
    Expect(0, 65308, '\P{^Is_Word_Break=midnum}', "");
    Expect(1, 65307, '\p{Is_Word_Break=  MidNum}', "");
    Expect(0, 65307, '\p{^Is_Word_Break=  MidNum}', "");
    Expect(0, 65307, '\P{Is_Word_Break=  MidNum}', "");
    Expect(1, 65307, '\P{^Is_Word_Break=  MidNum}', "");
    Expect(0, 65308, '\p{Is_Word_Break=  MidNum}', "");
    Expect(1, 65308, '\p{^Is_Word_Break=  MidNum}', "");
    Expect(1, 65308, '\P{Is_Word_Break=  MidNum}', "");
    Expect(0, 65308, '\P{^Is_Word_Break=  MidNum}', "");
    Error('\p{Is_WB=:=MN}');
    Error('\P{Is_WB=:=MN}');
    Expect(1, 65307, '\p{Is_WB:	mn}', "");
    Expect(0, 65307, '\p{^Is_WB:	mn}', "");
    Expect(0, 65307, '\P{Is_WB:	mn}', "");
    Expect(1, 65307, '\P{^Is_WB:	mn}', "");
    Expect(0, 65308, '\p{Is_WB:	mn}', "");
    Expect(1, 65308, '\p{^Is_WB:	mn}', "");
    Expect(1, 65308, '\P{Is_WB:	mn}', "");
    Expect(0, 65308, '\P{^Is_WB:	mn}', "");
    Expect(1, 65307, '\p{Is_WB=MN}', "");
    Expect(0, 65307, '\p{^Is_WB=MN}', "");
    Expect(0, 65307, '\P{Is_WB=MN}', "");
    Expect(1, 65307, '\P{^Is_WB=MN}', "");
    Expect(0, 65308, '\p{Is_WB=MN}', "");
    Expect(1, 65308, '\p{^Is_WB=MN}', "");
    Expect(1, 65308, '\P{Is_WB=MN}', "");
    Expect(0, 65308, '\P{^Is_WB=MN}', "");
    Error('\p{Word_Break= Newline/a/}');
    Error('\P{Word_Break= Newline/a/}');
    Expect(1, 8233, '\p{Word_Break=:\ANewline\z:}', "");;
    Expect(0, 8234, '\p{Word_Break=:\ANewline\z:}', "");;
    Expect(1, 8233, '\p{Word_Break=newline}', "");
    Expect(0, 8233, '\p{^Word_Break=newline}', "");
    Expect(0, 8233, '\P{Word_Break=newline}', "");
    Expect(1, 8233, '\P{^Word_Break=newline}', "");
    Expect(0, 8234, '\p{Word_Break=newline}', "");
    Expect(1, 8234, '\p{^Word_Break=newline}', "");
    Expect(1, 8234, '\P{Word_Break=newline}', "");
    Expect(0, 8234, '\P{^Word_Break=newline}', "");
    Expect(1, 8233, '\p{Word_Break=:\Anewline\z:}', "");;
    Expect(0, 8234, '\p{Word_Break=:\Anewline\z:}', "");;
    Expect(1, 8233, '\p{Word_Break=	-Newline}', "");
    Expect(0, 8233, '\p{^Word_Break=	-Newline}', "");
    Expect(0, 8233, '\P{Word_Break=	-Newline}', "");
    Expect(1, 8233, '\P{^Word_Break=	-Newline}', "");
    Expect(0, 8234, '\p{Word_Break=	-Newline}', "");
    Expect(1, 8234, '\p{^Word_Break=	-Newline}', "");
    Expect(1, 8234, '\P{Word_Break=	-Newline}', "");
    Expect(0, 8234, '\P{^Word_Break=	-Newline}', "");
    Error('\p{WB=/a/_NL}');
    Error('\P{WB=/a/_NL}');
    Expect(1, 8233, '\p{WB=:\ANL\z:}', "");;
    Expect(0, 8234, '\p{WB=:\ANL\z:}', "");;
    Expect(1, 8233, '\p{WB=nl}', "");
    Expect(0, 8233, '\p{^WB=nl}', "");
    Expect(0, 8233, '\P{WB=nl}', "");
    Expect(1, 8233, '\P{^WB=nl}', "");
    Expect(0, 8234, '\p{WB=nl}', "");
    Expect(1, 8234, '\p{^WB=nl}', "");
    Expect(1, 8234, '\P{WB=nl}', "");
    Expect(0, 8234, '\P{^WB=nl}', "");
    Expect(1, 8233, '\p{WB=:\Anl\z:}', "");;
    Expect(0, 8234, '\p{WB=:\Anl\z:}', "");;
    Expect(1, 8233, '\p{WB=_NL}', "");
    Expect(0, 8233, '\p{^WB=_NL}', "");
    Expect(0, 8233, '\P{WB=_NL}', "");
    Expect(1, 8233, '\P{^WB=_NL}', "");
    Expect(0, 8234, '\p{WB=_NL}', "");
    Expect(1, 8234, '\p{^WB=_NL}', "");
    Expect(1, 8234, '\P{WB=_NL}', "");
    Expect(0, 8234, '\P{^WB=_NL}', "");
    Error('\p{Is_Word_Break=:=- NEWLINE}');
    Error('\P{Is_Word_Break=:=- NEWLINE}');
    Expect(1, 8233, '\p{Is_Word_Break=newline}', "");
    Expect(0, 8233, '\p{^Is_Word_Break=newline}', "");
    Expect(0, 8233, '\P{Is_Word_Break=newline}', "");
    Expect(1, 8233, '\P{^Is_Word_Break=newline}', "");
    Expect(0, 8234, '\p{Is_Word_Break=newline}', "");
    Expect(1, 8234, '\p{^Is_Word_Break=newline}', "");
    Expect(1, 8234, '\P{Is_Word_Break=newline}', "");
    Expect(0, 8234, '\P{^Is_Word_Break=newline}', "");
    Expect(1, 8233, '\p{Is_Word_Break=_NEWLINE}', "");
    Expect(0, 8233, '\p{^Is_Word_Break=_NEWLINE}', "");
    Expect(0, 8233, '\P{Is_Word_Break=_NEWLINE}', "");
    Expect(1, 8233, '\P{^Is_Word_Break=_NEWLINE}', "");
    Expect(0, 8234, '\p{Is_Word_Break=_NEWLINE}', "");
    Expect(1, 8234, '\p{^Is_Word_Break=_NEWLINE}', "");
    Expect(1, 8234, '\P{Is_Word_Break=_NEWLINE}', "");
    Expect(0, 8234, '\P{^Is_Word_Break=_NEWLINE}', "");
    Error('\p{Is_WB=_/a/NL}');
    Error('\P{Is_WB=_/a/NL}');
    Expect(1, 8233, '\p{Is_WB=nl}', "");
    Expect(0, 8233, '\p{^Is_WB=nl}', "");
    Expect(0, 8233, '\P{Is_WB=nl}', "");
    Expect(1, 8233, '\P{^Is_WB=nl}', "");
    Expect(0, 8234, '\p{Is_WB=nl}', "");
    Expect(1, 8234, '\p{^Is_WB=nl}', "");
    Expect(1, 8234, '\P{Is_WB=nl}', "");
    Expect(0, 8234, '\P{^Is_WB=nl}', "");
    Expect(1, 8233, '\p{Is_WB=_NL}', "");
    Expect(0, 8233, '\p{^Is_WB=_NL}', "");
    Expect(0, 8233, '\P{Is_WB=_NL}', "");
    Expect(1, 8233, '\P{^Is_WB=_NL}', "");
    Expect(0, 8234, '\p{Is_WB=_NL}', "");
    Expect(1, 8234, '\p{^Is_WB=_NL}', "");
    Expect(1, 8234, '\P{Is_WB=_NL}', "");
    Expect(0, 8234, '\P{^Is_WB=_NL}', "");
    Error('\p{Word_Break=_Numeric/a/}');
    Error('\P{Word_Break=_Numeric/a/}');
    Expect(1, 130041, '\p{Word_Break=:\ANumeric\z:}', "");;
    Expect(0, 130042, '\p{Word_Break=:\ANumeric\z:}', "");;
    Expect(1, 130041, '\p{Word_Break:numeric}', "");
    Expect(0, 130041, '\p{^Word_Break:numeric}', "");
    Expect(0, 130041, '\P{Word_Break:numeric}', "");
    Expect(1, 130041, '\P{^Word_Break:numeric}', "");
    Expect(0, 130042, '\p{Word_Break:numeric}', "");
    Expect(1, 130042, '\p{^Word_Break:numeric}', "");
    Expect(1, 130042, '\P{Word_Break:numeric}', "");
    Expect(0, 130042, '\P{^Word_Break:numeric}', "");
    Expect(1, 130041, '\p{Word_Break=:\Anumeric\z:}', "");;
    Expect(0, 130042, '\p{Word_Break=:\Anumeric\z:}', "");;
    Expect(1, 130041, '\p{Word_Break=	Numeric}', "");
    Expect(0, 130041, '\p{^Word_Break=	Numeric}', "");
    Expect(0, 130041, '\P{Word_Break=	Numeric}', "");
    Expect(1, 130041, '\P{^Word_Break=	Numeric}', "");
    Expect(0, 130042, '\p{Word_Break=	Numeric}', "");
    Expect(1, 130042, '\p{^Word_Break=	Numeric}', "");
    Expect(1, 130042, '\P{Word_Break=	Numeric}', "");
    Expect(0, 130042, '\P{^Word_Break=	Numeric}', "");
    Error('\p{WB= :=NU}');
    Error('\P{WB= :=NU}');
    Expect(1, 130041, '\p{WB=:\ANU\z:}', "");;
    Expect(0, 130042, '\p{WB=:\ANU\z:}', "");;
    Expect(1, 130041, '\p{WB=nu}', "");
    Expect(0, 130041, '\p{^WB=nu}', "");
    Expect(0, 130041, '\P{WB=nu}', "");
    Expect(1, 130041, '\P{^WB=nu}', "");
    Expect(0, 130042, '\p{WB=nu}', "");
    Expect(1, 130042, '\p{^WB=nu}', "");
    Expect(1, 130042, '\P{WB=nu}', "");
    Expect(0, 130042, '\P{^WB=nu}', "");
    Expect(1, 130041, '\p{WB=:\Anu\z:}', "");;
    Expect(0, 130042, '\p{WB=:\Anu\z:}', "");;
    Expect(1, 130041, '\p{WB=	NU}', "");
    Expect(0, 130041, '\p{^WB=	NU}', "");
    Expect(0, 130041, '\P{WB=	NU}', "");
    Expect(1, 130041, '\P{^WB=	NU}', "");
    Expect(0, 130042, '\p{WB=	NU}', "");
    Expect(1, 130042, '\p{^WB=	NU}', "");
    Expect(1, 130042, '\P{WB=	NU}', "");
    Expect(0, 130042, '\P{^WB=	NU}', "");
    Error('\p{Is_Word_Break=_-numeric/a/}');
    Error('\P{Is_Word_Break=_-numeric/a/}');
    Expect(1, 130041, '\p{Is_Word_Break=numeric}', "");
    Expect(0, 130041, '\p{^Is_Word_Break=numeric}', "");
    Expect(0, 130041, '\P{Is_Word_Break=numeric}', "");
    Expect(1, 130041, '\P{^Is_Word_Break=numeric}', "");
    Expect(0, 130042, '\p{Is_Word_Break=numeric}', "");
    Expect(1, 130042, '\p{^Is_Word_Break=numeric}', "");
    Expect(1, 130042, '\P{Is_Word_Break=numeric}', "");
    Expect(0, 130042, '\P{^Is_Word_Break=numeric}', "");
    Expect(1, 130041, '\p{Is_Word_Break=  NUMERIC}', "");
    Expect(0, 130041, '\p{^Is_Word_Break=  NUMERIC}', "");
    Expect(0, 130041, '\P{Is_Word_Break=  NUMERIC}', "");
    Expect(1, 130041, '\P{^Is_Word_Break=  NUMERIC}', "");
    Expect(0, 130042, '\p{Is_Word_Break=  NUMERIC}', "");
    Expect(1, 130042, '\p{^Is_Word_Break=  NUMERIC}', "");
    Expect(1, 130042, '\P{Is_Word_Break=  NUMERIC}', "");
    Expect(0, 130042, '\P{^Is_Word_Break=  NUMERIC}', "");
    Error('\p{Is_WB=		NU/a/}');
    Error('\P{Is_WB=		NU/a/}');
    Expect(1, 130041, '\p{Is_WB=nu}', "");
    Expect(0, 130041, '\p{^Is_WB=nu}', "");
    Expect(0, 130041, '\P{Is_WB=nu}', "");
    Expect(1, 130041, '\P{^Is_WB=nu}', "");
    Expect(0, 130042, '\p{Is_WB=nu}', "");
    Expect(1, 130042, '\p{^Is_WB=nu}', "");
    Expect(1, 130042, '\P{Is_WB=nu}', "");
    Expect(0, 130042, '\P{^Is_WB=nu}', "");
    Expect(1, 130041, '\p{Is_WB=-NU}', "");
    Expect(0, 130041, '\p{^Is_WB=-NU}', "");
    Expect(0, 130041, '\P{Is_WB=-NU}', "");
    Expect(1, 130041, '\P{^Is_WB=-NU}', "");
    Expect(0, 130042, '\p{Is_WB=-NU}', "");
    Expect(1, 130042, '\p{^Is_WB=-NU}', "");
    Expect(1, 130042, '\P{Is_WB=-NU}', "");
    Expect(0, 130042, '\P{^Is_WB=-NU}', "");
    Error('\p{Word_Break=-:=regional_INDICATOR}');
    Error('\P{Word_Break=-:=regional_INDICATOR}');
    Expect(1, 127487, '\p{Word_Break=:\ARegional_Indicator\z:}', "");;
    Expect(0, 127488, '\p{Word_Break=:\ARegional_Indicator\z:}', "");;
    Expect(1, 127487, '\p{Word_Break=regionalindicator}', "");
    Expect(0, 127487, '\p{^Word_Break=regionalindicator}', "");
    Expect(0, 127487, '\P{Word_Break=regionalindicator}', "");
    Expect(1, 127487, '\P{^Word_Break=regionalindicator}', "");
    Expect(0, 127488, '\p{Word_Break=regionalindicator}', "");
    Expect(1, 127488, '\p{^Word_Break=regionalindicator}', "");
    Expect(1, 127488, '\P{Word_Break=regionalindicator}', "");
    Expect(0, 127488, '\P{^Word_Break=regionalindicator}', "");
    Expect(1, 127487, '\p{Word_Break=:\Aregionalindicator\z:}', "");;
    Expect(0, 127488, '\p{Word_Break=:\Aregionalindicator\z:}', "");;
    Expect(1, 127487, '\p{Word_Break=Regional_Indicator}', "");
    Expect(0, 127487, '\p{^Word_Break=Regional_Indicator}', "");
    Expect(0, 127487, '\P{Word_Break=Regional_Indicator}', "");
    Expect(1, 127487, '\P{^Word_Break=Regional_Indicator}', "");
    Expect(0, 127488, '\p{Word_Break=Regional_Indicator}', "");
    Expect(1, 127488, '\p{^Word_Break=Regional_Indicator}', "");
    Expect(1, 127488, '\P{Word_Break=Regional_Indicator}', "");
    Expect(0, 127488, '\P{^Word_Break=Regional_Indicator}', "");
    Error('\p{WB= /a/RI}');
    Error('\P{WB= /a/RI}');
    Expect(1, 127487, '\p{WB=:\ARI\z:}', "");;
    Expect(0, 127488, '\p{WB=:\ARI\z:}', "");;
    Expect(1, 127487, '\p{WB=ri}', "");
    Expect(0, 127487, '\p{^WB=ri}', "");
    Expect(0, 127487, '\P{WB=ri}', "");
    Expect(1, 127487, '\P{^WB=ri}', "");
    Expect(0, 127488, '\p{WB=ri}', "");
    Expect(1, 127488, '\p{^WB=ri}', "");
    Expect(1, 127488, '\P{WB=ri}', "");
    Expect(0, 127488, '\P{^WB=ri}', "");
    Expect(1, 127487, '\p{WB=:\Ari\z:}', "");;
    Expect(0, 127488, '\p{WB=:\Ari\z:}', "");;
    Expect(1, 127487, '\p{WB=- RI}', "");
    Expect(0, 127487, '\p{^WB=- RI}', "");
    Expect(0, 127487, '\P{WB=- RI}', "");
    Expect(1, 127487, '\P{^WB=- RI}', "");
    Expect(0, 127488, '\p{WB=- RI}', "");
    Expect(1, 127488, '\p{^WB=- RI}', "");
    Expect(1, 127488, '\P{WB=- RI}', "");
    Expect(0, 127488, '\P{^WB=- RI}', "");
    Error('\p{Is_Word_Break=-/a/regional_INDICATOR}');
    Error('\P{Is_Word_Break=-/a/regional_INDICATOR}');
    Expect(1, 127487, '\p{Is_Word_Break=regionalindicator}', "");
    Expect(0, 127487, '\p{^Is_Word_Break=regionalindicator}', "");
    Expect(0, 127487, '\P{Is_Word_Break=regionalindicator}', "");
    Expect(1, 127487, '\P{^Is_Word_Break=regionalindicator}', "");
    Expect(0, 127488, '\p{Is_Word_Break=regionalindicator}', "");
    Expect(1, 127488, '\p{^Is_Word_Break=regionalindicator}', "");
    Expect(1, 127488, '\P{Is_Word_Break=regionalindicator}', "");
    Expect(0, 127488, '\P{^Is_Word_Break=regionalindicator}', "");
    Expect(1, 127487, '\p{Is_Word_Break=	-REGIONAL_INDICATOR}', "");
    Expect(0, 127487, '\p{^Is_Word_Break=	-REGIONAL_INDICATOR}', "");
    Expect(0, 127487, '\P{Is_Word_Break=	-REGIONAL_INDICATOR}', "");
    Expect(1, 127487, '\P{^Is_Word_Break=	-REGIONAL_INDICATOR}', "");
    Expect(0, 127488, '\p{Is_Word_Break=	-REGIONAL_INDICATOR}', "");
    Expect(1, 127488, '\p{^Is_Word_Break=	-REGIONAL_INDICATOR}', "");
    Expect(1, 127488, '\P{Is_Word_Break=	-REGIONAL_INDICATOR}', "");
    Expect(0, 127488, '\P{^Is_Word_Break=	-REGIONAL_INDICATOR}', "");
    Error('\p{Is_WB=-RI:=}');
    Error('\P{Is_WB=-RI:=}');
    Expect(1, 127487, '\p{Is_WB=ri}', "");
    Expect(0, 127487, '\p{^Is_WB=ri}', "");
    Expect(0, 127487, '\P{Is_WB=ri}', "");
    Expect(1, 127487, '\P{^Is_WB=ri}', "");
    Expect(0, 127488, '\p{Is_WB=ri}', "");
    Expect(1, 127488, '\p{^Is_WB=ri}', "");
    Expect(1, 127488, '\P{Is_WB=ri}', "");
    Expect(0, 127488, '\P{^Is_WB=ri}', "");
    Expect(1, 127487, '\p{Is_WB=- ri}', "");
    Expect(0, 127487, '\p{^Is_WB=- ri}', "");
    Expect(0, 127487, '\P{Is_WB=- ri}', "");
    Expect(1, 127487, '\P{^Is_WB=- ri}', "");
    Expect(0, 127488, '\p{Is_WB=- ri}', "");
    Expect(1, 127488, '\p{^Is_WB=- ri}', "");
    Expect(1, 127488, '\P{Is_WB=- ri}', "");
    Expect(0, 127488, '\P{^Is_WB=- ri}', "");
    Error('\p{Word_Break=/a/ 	SINGLE_Quote}');
    Error('\P{Word_Break=/a/ 	SINGLE_Quote}');
    Expect(1, 39, '\p{Word_Break=:\ASingle_Quote\z:}', "");;
    Expect(0, 40, '\p{Word_Break=:\ASingle_Quote\z:}', "");;
    Expect(1, 39, '\p{Word_Break=singlequote}', "");
    Expect(0, 39, '\p{^Word_Break=singlequote}', "");
    Expect(0, 39, '\P{Word_Break=singlequote}', "");
    Expect(1, 39, '\P{^Word_Break=singlequote}', "");
    Expect(0, 40, '\p{Word_Break=singlequote}', "");
    Expect(1, 40, '\p{^Word_Break=singlequote}', "");
    Expect(1, 40, '\P{Word_Break=singlequote}', "");
    Expect(0, 40, '\P{^Word_Break=singlequote}', "");
    Expect(1, 39, '\p{Word_Break=:\Asinglequote\z:}', "");;
    Expect(0, 40, '\p{Word_Break=:\Asinglequote\z:}', "");;
    Expect(1, 39, '\p{Word_Break= 	single_Quote}', "");
    Expect(0, 39, '\p{^Word_Break= 	single_Quote}', "");
    Expect(0, 39, '\P{Word_Break= 	single_Quote}', "");
    Expect(1, 39, '\P{^Word_Break= 	single_Quote}', "");
    Expect(0, 40, '\p{Word_Break= 	single_Quote}', "");
    Expect(1, 40, '\p{^Word_Break= 	single_Quote}', "");
    Expect(1, 40, '\P{Word_Break= 	single_Quote}', "");
    Expect(0, 40, '\P{^Word_Break= 	single_Quote}', "");
    Error('\p{WB=:=sq}');
    Error('\P{WB=:=sq}');
    Expect(1, 39, '\p{WB=:\ASQ\z:}', "");;
    Expect(0, 40, '\p{WB=:\ASQ\z:}', "");;
    Expect(1, 39, '\p{WB=sq}', "");
    Expect(0, 39, '\p{^WB=sq}', "");
    Expect(0, 39, '\P{WB=sq}', "");
    Expect(1, 39, '\P{^WB=sq}', "");
    Expect(0, 40, '\p{WB=sq}', "");
    Expect(1, 40, '\p{^WB=sq}', "");
    Expect(1, 40, '\P{WB=sq}', "");
    Expect(0, 40, '\P{^WB=sq}', "");
    Expect(1, 39, '\p{WB=:\Asq\z:}', "");;
    Expect(0, 40, '\p{WB=:\Asq\z:}', "");;
    Expect(1, 39, '\p{WB= _SQ}', "");
    Expect(0, 39, '\p{^WB= _SQ}', "");
    Expect(0, 39, '\P{WB= _SQ}', "");
    Expect(1, 39, '\P{^WB= _SQ}', "");
    Expect(0, 40, '\p{WB= _SQ}', "");
    Expect(1, 40, '\p{^WB= _SQ}', "");
    Expect(1, 40, '\P{WB= _SQ}', "");
    Expect(0, 40, '\P{^WB= _SQ}', "");
    Error('\p{Is_Word_Break=:=	-Single_QUOTE}');
    Error('\P{Is_Word_Break=:=	-Single_QUOTE}');
    Expect(1, 39, '\p{Is_Word_Break=singlequote}', "");
    Expect(0, 39, '\p{^Is_Word_Break=singlequote}', "");
    Expect(0, 39, '\P{Is_Word_Break=singlequote}', "");
    Expect(1, 39, '\P{^Is_Word_Break=singlequote}', "");
    Expect(0, 40, '\p{Is_Word_Break=singlequote}', "");
    Expect(1, 40, '\p{^Is_Word_Break=singlequote}', "");
    Expect(1, 40, '\P{Is_Word_Break=singlequote}', "");
    Expect(0, 40, '\P{^Is_Word_Break=singlequote}', "");
    Expect(1, 39, '\p{Is_Word_Break:	 -Single_quote}', "");
    Expect(0, 39, '\p{^Is_Word_Break:	 -Single_quote}', "");
    Expect(0, 39, '\P{Is_Word_Break:	 -Single_quote}', "");
    Expect(1, 39, '\P{^Is_Word_Break:	 -Single_quote}', "");
    Expect(0, 40, '\p{Is_Word_Break:	 -Single_quote}', "");
    Expect(1, 40, '\p{^Is_Word_Break:	 -Single_quote}', "");
    Expect(1, 40, '\P{Is_Word_Break:	 -Single_quote}', "");
    Expect(0, 40, '\P{^Is_Word_Break:	 -Single_quote}', "");
    Error('\p{Is_WB:_sq:=}');
    Error('\P{Is_WB:_sq:=}');
    Expect(1, 39, '\p{Is_WB=sq}', "");
    Expect(0, 39, '\p{^Is_WB=sq}', "");
    Expect(0, 39, '\P{Is_WB=sq}', "");
    Expect(1, 39, '\P{^Is_WB=sq}', "");
    Expect(0, 40, '\p{Is_WB=sq}', "");
    Expect(1, 40, '\p{^Is_WB=sq}', "");
    Expect(1, 40, '\P{Is_WB=sq}', "");
    Expect(0, 40, '\P{^Is_WB=sq}', "");
    Expect(1, 39, '\p{Is_WB= SQ}', "");
    Expect(0, 39, '\p{^Is_WB= SQ}', "");
    Expect(0, 39, '\P{Is_WB= SQ}', "");
    Expect(1, 39, '\P{^Is_WB= SQ}', "");
    Expect(0, 40, '\p{Is_WB= SQ}', "");
    Expect(1, 40, '\p{^Is_WB= SQ}', "");
    Expect(1, 40, '\P{Is_WB= SQ}', "");
    Expect(0, 40, '\P{^Is_WB= SQ}', "");
    Error('\p{Word_Break=:= -WSegSpace}');
    Error('\P{Word_Break=:= -WSegSpace}');
    Expect(1, 12288, '\p{Word_Break=:\AWSegSpace\z:}', "");;
    Expect(0, 12289, '\p{Word_Break=:\AWSegSpace\z:}', "");;
    Expect(1, 12288, '\p{Word_Break=wsegspace}', "");
    Expect(0, 12288, '\p{^Word_Break=wsegspace}', "");
    Expect(0, 12288, '\P{Word_Break=wsegspace}', "");
    Expect(1, 12288, '\P{^Word_Break=wsegspace}', "");
    Expect(0, 12289, '\p{Word_Break=wsegspace}', "");
    Expect(1, 12289, '\p{^Word_Break=wsegspace}', "");
    Expect(1, 12289, '\P{Word_Break=wsegspace}', "");
    Expect(0, 12289, '\P{^Word_Break=wsegspace}', "");
    Expect(1, 12288, '\p{Word_Break=:\Awsegspace\z:}', "");;
    Expect(0, 12289, '\p{Word_Break=:\Awsegspace\z:}', "");;
    Expect(1, 12288, '\p{Word_Break=	_WSegSpace}', "");
    Expect(0, 12288, '\p{^Word_Break=	_WSegSpace}', "");
    Expect(0, 12288, '\P{Word_Break=	_WSegSpace}', "");
    Expect(1, 12288, '\P{^Word_Break=	_WSegSpace}', "");
    Expect(0, 12289, '\p{Word_Break=	_WSegSpace}', "");
    Expect(1, 12289, '\p{^Word_Break=	_WSegSpace}', "");
    Expect(1, 12289, '\P{Word_Break=	_WSegSpace}', "");
    Expect(0, 12289, '\P{^Word_Break=	_WSegSpace}', "");
    Error('\p{WB=/a/ WSegSpace}');
    Error('\P{WB=/a/ WSegSpace}');
    Expect(1, 12288, '\p{WB=:\AWSegSpace\z:}', "");;
    Expect(0, 12289, '\p{WB=:\AWSegSpace\z:}', "");;
    Expect(1, 12288, '\p{WB=wsegspace}', "");
    Expect(0, 12288, '\p{^WB=wsegspace}', "");
    Expect(0, 12288, '\P{WB=wsegspace}', "");
    Expect(1, 12288, '\P{^WB=wsegspace}', "");
    Expect(0, 12289, '\p{WB=wsegspace}', "");
    Expect(1, 12289, '\p{^WB=wsegspace}', "");
    Expect(1, 12289, '\P{WB=wsegspace}', "");
    Expect(0, 12289, '\P{^WB=wsegspace}', "");
    Expect(1, 12288, '\p{WB=:\Awsegspace\z:}', "");;
    Expect(0, 12289, '\p{WB=:\Awsegspace\z:}', "");;
    Expect(1, 12288, '\p{WB=  WSegSpace}', "");
    Expect(0, 12288, '\p{^WB=  WSegSpace}', "");
    Expect(0, 12288, '\P{WB=  WSegSpace}', "");
    Expect(1, 12288, '\P{^WB=  WSegSpace}', "");
    Expect(0, 12289, '\p{WB=  WSegSpace}', "");
    Expect(1, 12289, '\p{^WB=  WSegSpace}', "");
    Expect(1, 12289, '\P{WB=  WSegSpace}', "");
    Expect(0, 12289, '\P{^WB=  WSegSpace}', "");
    Error('\p{Is_Word_Break=/a/  WSegSpace}');
    Error('\P{Is_Word_Break=/a/  WSegSpace}');
    Expect(1, 12288, '\p{Is_Word_Break=wsegspace}', "");
    Expect(0, 12288, '\p{^Is_Word_Break=wsegspace}', "");
    Expect(0, 12288, '\P{Is_Word_Break=wsegspace}', "");
    Expect(1, 12288, '\P{^Is_Word_Break=wsegspace}', "");
    Expect(0, 12289, '\p{Is_Word_Break=wsegspace}', "");
    Expect(1, 12289, '\p{^Is_Word_Break=wsegspace}', "");
    Expect(1, 12289, '\P{Is_Word_Break=wsegspace}', "");
    Expect(0, 12289, '\P{^Is_Word_Break=wsegspace}', "");
    Expect(1, 12288, '\p{Is_Word_Break=	WSegSpace}', "");
    Expect(0, 12288, '\p{^Is_Word_Break=	WSegSpace}', "");
    Expect(0, 12288, '\P{Is_Word_Break=	WSegSpace}', "");
    Expect(1, 12288, '\P{^Is_Word_Break=	WSegSpace}', "");
    Expect(0, 12289, '\p{Is_Word_Break=	WSegSpace}', "");
    Expect(1, 12289, '\p{^Is_Word_Break=	WSegSpace}', "");
    Expect(1, 12289, '\P{Is_Word_Break=	WSegSpace}', "");
    Expect(0, 12289, '\P{^Is_Word_Break=	WSegSpace}', "");
    Error('\p{Is_WB= -WSEGSPACE:=}');
    Error('\P{Is_WB= -WSEGSPACE:=}');
    Expect(1, 12288, '\p{Is_WB=wsegspace}', "");
    Expect(0, 12288, '\p{^Is_WB=wsegspace}', "");
    Expect(0, 12288, '\P{Is_WB=wsegspace}', "");
    Expect(1, 12288, '\P{^Is_WB=wsegspace}', "");
    Expect(0, 12289, '\p{Is_WB=wsegspace}', "");
    Expect(1, 12289, '\p{^Is_WB=wsegspace}', "");
    Expect(1, 12289, '\P{Is_WB=wsegspace}', "");
    Expect(0, 12289, '\P{^Is_WB=wsegspace}', "");
    Expect(1, 12288, '\p{Is_WB:	WSegSpace}', "");
    Expect(0, 12288, '\p{^Is_WB:	WSegSpace}', "");
    Expect(0, 12288, '\P{Is_WB:	WSegSpace}', "");
    Expect(1, 12288, '\P{^Is_WB:	WSegSpace}', "");
    Expect(0, 12289, '\p{Is_WB:	WSegSpace}', "");
    Expect(1, 12289, '\p{^Is_WB:	WSegSpace}', "");
    Expect(1, 12289, '\P{Is_WB:	WSegSpace}', "");
    Expect(0, 12289, '\P{^Is_WB:	WSegSpace}', "");
    Error('\p{Word_Break= -OTHER:=}');
    Error('\P{Word_Break= -OTHER:=}');
    Expect(1, 918000, '\p{Word_Break=:\AOther\z:}', "");;
    Expect(0, 917999, '\p{Word_Break=:\AOther\z:}', "");;
    Expect(1, 918000, '\p{Word_Break=other}', "");
    Expect(0, 918000, '\p{^Word_Break=other}', "");
    Expect(0, 918000, '\P{Word_Break=other}', "");
    Expect(1, 918000, '\P{^Word_Break=other}', "");
    Expect(0, 917999, '\p{Word_Break=other}', "");
    Expect(1, 917999, '\p{^Word_Break=other}', "");
    Expect(1, 917999, '\P{Word_Break=other}', "");
    Expect(0, 917999, '\P{^Word_Break=other}', "");
    Expect(1, 918000, '\p{Word_Break=:\Aother\z:}', "");;
    Expect(0, 917999, '\p{Word_Break=:\Aother\z:}', "");;
    Expect(1, 918000, '\p{Word_Break= 	Other}', "");
    Expect(0, 918000, '\p{^Word_Break= 	Other}', "");
    Expect(0, 918000, '\P{Word_Break= 	Other}', "");
    Expect(1, 918000, '\P{^Word_Break= 	Other}', "");
    Expect(0, 917999, '\p{Word_Break= 	Other}', "");
    Expect(1, 917999, '\p{^Word_Break= 	Other}', "");
    Expect(1, 917999, '\P{Word_Break= 	Other}', "");
    Expect(0, 917999, '\P{^Word_Break= 	Other}', "");
    Error('\p{WB:   :=_-XX}');
    Error('\P{WB:   :=_-XX}');
    Expect(1, 918000, '\p{WB=:\AXX\z:}', "");;
    Expect(0, 917999, '\p{WB=:\AXX\z:}', "");;
    Expect(1, 918000, '\p{WB=xx}', "");
    Expect(0, 918000, '\p{^WB=xx}', "");
    Expect(0, 918000, '\P{WB=xx}', "");
    Expect(1, 918000, '\P{^WB=xx}', "");
    Expect(0, 917999, '\p{WB=xx}', "");
    Expect(1, 917999, '\p{^WB=xx}', "");
    Expect(1, 917999, '\P{WB=xx}', "");
    Expect(0, 917999, '\P{^WB=xx}', "");
    Expect(1, 918000, '\p{WB=:\Axx\z:}', "");;
    Expect(0, 917999, '\p{WB=:\Axx\z:}', "");;
    Expect(1, 918000, '\p{WB:	XX}', "");
    Expect(0, 918000, '\p{^WB:	XX}', "");
    Expect(0, 918000, '\P{WB:	XX}', "");
    Expect(1, 918000, '\P{^WB:	XX}', "");
    Expect(0, 917999, '\p{WB:	XX}', "");
    Expect(1, 917999, '\p{^WB:	XX}', "");
    Expect(1, 917999, '\P{WB:	XX}', "");
    Expect(0, 917999, '\P{^WB:	XX}', "");
    Error('\p{Is_Word_Break:		 OTHER/a/}');
    Error('\P{Is_Word_Break:		 OTHER/a/}');
    Expect(1, 918000, '\p{Is_Word_Break=other}', "");
    Expect(0, 918000, '\p{^Is_Word_Break=other}', "");
    Expect(0, 918000, '\P{Is_Word_Break=other}', "");
    Expect(1, 918000, '\P{^Is_Word_Break=other}', "");
    Expect(0, 917999, '\p{Is_Word_Break=other}', "");
    Expect(1, 917999, '\p{^Is_Word_Break=other}', "");
    Expect(1, 917999, '\P{Is_Word_Break=other}', "");
    Expect(0, 917999, '\P{^Is_Word_Break=other}', "");
    Expect(1, 918000, '\p{Is_Word_Break=_Other}', "");
    Expect(0, 918000, '\p{^Is_Word_Break=_Other}', "");
    Expect(0, 918000, '\P{Is_Word_Break=_Other}', "");
    Expect(1, 918000, '\P{^Is_Word_Break=_Other}', "");
    Expect(0, 917999, '\p{Is_Word_Break=_Other}', "");
    Expect(1, 917999, '\p{^Is_Word_Break=_Other}', "");
    Expect(1, 917999, '\P{Is_Word_Break=_Other}', "");
    Expect(0, 917999, '\P{^Is_Word_Break=_Other}', "");
    Error('\p{Is_WB=	XX:=}');
    Error('\P{Is_WB=	XX:=}');
    Expect(1, 918000, '\p{Is_WB=xx}', "");
    Expect(0, 918000, '\p{^Is_WB=xx}', "");
    Expect(0, 918000, '\P{Is_WB=xx}', "");
    Expect(1, 918000, '\P{^Is_WB=xx}', "");
    Expect(0, 917999, '\p{Is_WB=xx}', "");
    Expect(1, 917999, '\p{^Is_WB=xx}', "");
    Expect(1, 917999, '\P{Is_WB=xx}', "");
    Expect(0, 917999, '\P{^Is_WB=xx}', "");
    Expect(1, 918000, '\p{Is_WB: -	XX}', "");
    Expect(0, 918000, '\p{^Is_WB: -	XX}', "");
    Expect(0, 918000, '\P{Is_WB: -	XX}', "");
    Expect(1, 918000, '\P{^Is_WB: -	XX}', "");
    Expect(0, 917999, '\p{Is_WB: -	XX}', "");
    Expect(1, 917999, '\p{^Is_WB: -	XX}', "");
    Expect(1, 917999, '\P{Is_WB: -	XX}', "");
    Expect(0, 917999, '\P{^Is_WB: -	XX}', "");
    Error('\p{Word_Break=/a/_-ZWJ}');
    Error('\P{Word_Break=/a/_-ZWJ}');
    Expect(1, 8205, '\p{Word_Break=:\AZWJ\z:}', "");;
    Expect(0, 8206, '\p{Word_Break=:\AZWJ\z:}', "");;
    Expect(1, 8205, '\p{Word_Break=zwj}', "");
    Expect(0, 8205, '\p{^Word_Break=zwj}', "");
    Expect(0, 8205, '\P{Word_Break=zwj}', "");
    Expect(1, 8205, '\P{^Word_Break=zwj}', "");
    Expect(0, 8206, '\p{Word_Break=zwj}', "");
    Expect(1, 8206, '\p{^Word_Break=zwj}', "");
    Expect(1, 8206, '\P{Word_Break=zwj}', "");
    Expect(0, 8206, '\P{^Word_Break=zwj}', "");
    Expect(1, 8205, '\p{Word_Break=:\Azwj\z:}', "");;
    Expect(0, 8206, '\p{Word_Break=:\Azwj\z:}', "");;
    Expect(1, 8205, '\p{Word_Break=_ ZWJ}', "");
    Expect(0, 8205, '\p{^Word_Break=_ ZWJ}', "");
    Expect(0, 8205, '\P{Word_Break=_ ZWJ}', "");
    Expect(1, 8205, '\P{^Word_Break=_ ZWJ}', "");
    Expect(0, 8206, '\p{Word_Break=_ ZWJ}', "");
    Expect(1, 8206, '\p{^Word_Break=_ ZWJ}', "");
    Expect(1, 8206, '\P{Word_Break=_ ZWJ}', "");
    Expect(0, 8206, '\P{^Word_Break=_ ZWJ}', "");
    Error('\p{WB=/a/ -ZWJ}');
    Error('\P{WB=/a/ -ZWJ}');
    Expect(1, 8205, '\p{WB=:\AZWJ\z:}', "");;
    Expect(0, 8206, '\p{WB=:\AZWJ\z:}', "");;
    Expect(1, 8205, '\p{WB=zwj}', "");
    Expect(0, 8205, '\p{^WB=zwj}', "");
    Expect(0, 8205, '\P{WB=zwj}', "");
    Expect(1, 8205, '\P{^WB=zwj}', "");
    Expect(0, 8206, '\p{WB=zwj}', "");
    Expect(1, 8206, '\p{^WB=zwj}', "");
    Expect(1, 8206, '\P{WB=zwj}', "");
    Expect(0, 8206, '\P{^WB=zwj}', "");
    Expect(1, 8205, '\p{WB=:\Azwj\z:}', "");;
    Expect(0, 8206, '\p{WB=:\Azwj\z:}', "");;
    Expect(1, 8205, '\p{WB=	zwj}', "");
    Expect(0, 8205, '\p{^WB=	zwj}', "");
    Expect(0, 8205, '\P{WB=	zwj}', "");
    Expect(1, 8205, '\P{^WB=	zwj}', "");
    Expect(0, 8206, '\p{WB=	zwj}', "");
    Expect(1, 8206, '\p{^WB=	zwj}', "");
    Expect(1, 8206, '\P{WB=	zwj}', "");
    Expect(0, 8206, '\P{^WB=	zwj}', "");
    Error('\p{Is_Word_Break:  :=ZWJ}');
    Error('\P{Is_Word_Break:  :=ZWJ}');
    Expect(1, 8205, '\p{Is_Word_Break:	zwj}', "");
    Expect(0, 8205, '\p{^Is_Word_Break:	zwj}', "");
    Expect(0, 8205, '\P{Is_Word_Break:	zwj}', "");
    Expect(1, 8205, '\P{^Is_Word_Break:	zwj}', "");
    Expect(0, 8206, '\p{Is_Word_Break:	zwj}', "");
    Expect(1, 8206, '\p{^Is_Word_Break:	zwj}', "");
    Expect(1, 8206, '\P{Is_Word_Break:	zwj}', "");
    Expect(0, 8206, '\P{^Is_Word_Break:	zwj}', "");
    Expect(1, 8205, '\p{Is_Word_Break=-ZWJ}', "");
    Expect(0, 8205, '\p{^Is_Word_Break=-ZWJ}', "");
    Expect(0, 8205, '\P{Is_Word_Break=-ZWJ}', "");
    Expect(1, 8205, '\P{^Is_Word_Break=-ZWJ}', "");
    Expect(0, 8206, '\p{Is_Word_Break=-ZWJ}', "");
    Expect(1, 8206, '\p{^Is_Word_Break=-ZWJ}', "");
    Expect(1, 8206, '\P{Is_Word_Break=-ZWJ}', "");
    Expect(0, 8206, '\P{^Is_Word_Break=-ZWJ}', "");
    Error('\p{Is_WB= :=ZWJ}');
    Error('\P{Is_WB= :=ZWJ}');
    Expect(1, 8205, '\p{Is_WB=zwj}', "");
    Expect(0, 8205, '\p{^Is_WB=zwj}', "");
    Expect(0, 8205, '\P{Is_WB=zwj}', "");
    Expect(1, 8205, '\P{^Is_WB=zwj}', "");
    Expect(0, 8206, '\p{Is_WB=zwj}', "");
    Expect(1, 8206, '\p{^Is_WB=zwj}', "");
    Expect(1, 8206, '\P{Is_WB=zwj}', "");
    Expect(0, 8206, '\P{^Is_WB=zwj}', "");
    Expect(1, 8205, '\p{Is_WB=--ZWJ}', "");
    Expect(0, 8205, '\p{^Is_WB=--ZWJ}', "");
    Expect(0, 8205, '\P{Is_WB=--ZWJ}', "");
    Expect(1, 8205, '\P{^Is_WB=--ZWJ}', "");
    Expect(0, 8206, '\p{Is_WB=--ZWJ}', "");
    Expect(1, 8206, '\p{^Is_WB=--ZWJ}', "");
    Expect(1, 8206, '\P{Is_WB=--ZWJ}', "");
    Expect(0, 8206, '\P{^Is_WB=--ZWJ}', "");
    Error('\p{White_Space: /a/NO}');
    Error('\P{White_Space: /a/NO}');
    Expect(1, 12289, '\p{White_Space=:\ANo\z:}', "");;
    Expect(0, 12288, '\p{White_Space=:\ANo\z:}', "");;
    Expect(1, 12289, '\p{White_Space=no}', "");
    Expect(0, 12289, '\p{^White_Space=no}', "");
    Expect(0, 12289, '\P{White_Space=no}', "");
    Expect(1, 12289, '\P{^White_Space=no}', "");
    Expect(0, 12288, '\p{White_Space=no}', "");
    Expect(1, 12288, '\p{^White_Space=no}', "");
    Expect(1, 12288, '\P{White_Space=no}', "");
    Expect(0, 12288, '\P{^White_Space=no}', "");
    Expect(1, 12289, '\p{White_Space=:\Ano\z:}', "");;
    Expect(0, 12288, '\p{White_Space=:\Ano\z:}', "");;
    Error('\p{WSpace=-_N:=}');
    Error('\P{WSpace=-_N:=}');
    Expect(1, 12289, '\p{WSpace=:\AN\z:}', "");;
    Expect(0, 12288, '\p{WSpace=:\AN\z:}', "");;
    Expect(1, 12289, '\p{WSpace:   n}', "");
    Expect(0, 12289, '\p{^WSpace:   n}', "");
    Expect(0, 12289, '\P{WSpace:   n}', "");
    Expect(1, 12289, '\P{^WSpace:   n}', "");
    Expect(0, 12288, '\p{WSpace:   n}', "");
    Expect(1, 12288, '\p{^WSpace:   n}', "");
    Expect(1, 12288, '\P{WSpace:   n}', "");
    Expect(0, 12288, '\P{^WSpace:   n}', "");
    Expect(1, 12289, '\p{WSpace=:\An\z:}', "");;
    Expect(0, 12288, '\p{WSpace=:\An\z:}', "");;
    Expect(1, 12289, '\p{WSpace=-	n}', "");
    Expect(0, 12289, '\p{^WSpace=-	n}', "");
    Expect(0, 12289, '\P{WSpace=-	n}', "");
    Expect(1, 12289, '\P{^WSpace=-	n}', "");
    Expect(0, 12288, '\p{WSpace=-	n}', "");
    Expect(1, 12288, '\p{^WSpace=-	n}', "");
    Expect(1, 12288, '\P{WSpace=-	n}', "");
    Expect(0, 12288, '\P{^WSpace=-	n}', "");
    Error('\p{Space= F/a/}');
    Error('\P{Space= F/a/}');
    Expect(1, 12289, '\p{Space=:\AF\z:}', "");;
    Expect(0, 12288, '\p{Space=:\AF\z:}', "");;
    Expect(1, 12289, '\p{Space:	f}', "");
    Expect(0, 12289, '\p{^Space:	f}', "");
    Expect(0, 12289, '\P{Space:	f}', "");
    Expect(1, 12289, '\P{^Space:	f}', "");
    Expect(0, 12288, '\p{Space:	f}', "");
    Expect(1, 12288, '\p{^Space:	f}', "");
    Expect(1, 12288, '\P{Space:	f}', "");
    Expect(0, 12288, '\P{^Space:	f}', "");
    Expect(1, 12289, '\p{Space=:\Af\z:}', "");;
    Expect(0, 12288, '\p{Space=:\Af\z:}', "");;
    Expect(1, 12289, '\p{Space= f}', "");
    Expect(0, 12289, '\p{^Space= f}', "");
    Expect(0, 12289, '\P{Space= f}', "");
    Expect(1, 12289, '\P{^Space= f}', "");
    Expect(0, 12288, '\p{Space= f}', "");
    Expect(1, 12288, '\p{^Space= f}', "");
    Expect(1, 12288, '\P{Space= f}', "");
    Expect(0, 12288, '\P{^Space= f}', "");
    Error('\p{Is_White_Space= 	false:=}');
    Error('\P{Is_White_Space= 	false:=}');
    Expect(1, 12289, '\p{Is_White_Space=false}', "");
    Expect(0, 12289, '\p{^Is_White_Space=false}', "");
    Expect(0, 12289, '\P{Is_White_Space=false}', "");
    Expect(1, 12289, '\P{^Is_White_Space=false}', "");
    Expect(0, 12288, '\p{Is_White_Space=false}', "");
    Expect(1, 12288, '\p{^Is_White_Space=false}', "");
    Expect(1, 12288, '\P{Is_White_Space=false}', "");
    Expect(0, 12288, '\P{^Is_White_Space=false}', "");
    Expect(1, 12289, '\p{Is_White_Space=		false}', "");
    Expect(0, 12289, '\p{^Is_White_Space=		false}', "");
    Expect(0, 12289, '\P{Is_White_Space=		false}', "");
    Expect(1, 12289, '\P{^Is_White_Space=		false}', "");
    Expect(0, 12288, '\p{Is_White_Space=		false}', "");
    Expect(1, 12288, '\p{^Is_White_Space=		false}', "");
    Expect(1, 12288, '\P{Is_White_Space=		false}', "");
    Expect(0, 12288, '\P{^Is_White_Space=		false}', "");
    Error('\p{Is_WSpace=-_NO/a/}');
    Error('\P{Is_WSpace=-_NO/a/}');
    Expect(1, 12289, '\p{Is_WSpace=no}', "");
    Expect(0, 12289, '\p{^Is_WSpace=no}', "");
    Expect(0, 12289, '\P{Is_WSpace=no}', "");
    Expect(1, 12289, '\P{^Is_WSpace=no}', "");
    Expect(0, 12288, '\p{Is_WSpace=no}', "");
    Expect(1, 12288, '\p{^Is_WSpace=no}', "");
    Expect(1, 12288, '\P{Is_WSpace=no}', "");
    Expect(0, 12288, '\P{^Is_WSpace=no}', "");
    Expect(1, 12289, '\p{Is_WSpace= _NO}', "");
    Expect(0, 12289, '\p{^Is_WSpace= _NO}', "");
    Expect(0, 12289, '\P{Is_WSpace= _NO}', "");
    Expect(1, 12289, '\P{^Is_WSpace= _NO}', "");
    Expect(0, 12288, '\p{Is_WSpace= _NO}', "");
    Expect(1, 12288, '\p{^Is_WSpace= _NO}', "");
    Expect(1, 12288, '\P{Is_WSpace= _NO}', "");
    Expect(0, 12288, '\P{^Is_WSpace= _NO}', "");
    Error('\p{Is_Space=	:=N}');
    Error('\P{Is_Space=	:=N}');
    Expect(1, 12289, '\p{Is_Space=n}', "");
    Expect(0, 12289, '\p{^Is_Space=n}', "");
    Expect(0, 12289, '\P{Is_Space=n}', "");
    Expect(1, 12289, '\P{^Is_Space=n}', "");
    Expect(0, 12288, '\p{Is_Space=n}', "");
    Expect(1, 12288, '\p{^Is_Space=n}', "");
    Expect(1, 12288, '\P{Is_Space=n}', "");
    Expect(0, 12288, '\P{^Is_Space=n}', "");
    Expect(1, 12289, '\p{Is_Space=-	n}', "");
    Expect(0, 12289, '\p{^Is_Space=-	n}', "");
    Expect(0, 12289, '\P{Is_Space=-	n}', "");
    Expect(1, 12289, '\P{^Is_Space=-	n}', "");
    Expect(0, 12288, '\p{Is_Space=-	n}', "");
    Expect(1, 12288, '\p{^Is_Space=-	n}', "");
    Expect(1, 12288, '\P{Is_Space=-	n}', "");
    Expect(0, 12288, '\P{^Is_Space=-	n}', "");
    Error('\p{White_Space=--YES/a/}');
    Error('\P{White_Space=--YES/a/}');
    Expect(1, 12288, '\p{White_Space=:\AYes\z:}', "");;
    Expect(0, 12289, '\p{White_Space=:\AYes\z:}', "");;
    Expect(1, 12288, '\p{White_Space=yes}', "");
    Expect(0, 12288, '\p{^White_Space=yes}', "");
    Expect(0, 12288, '\P{White_Space=yes}', "");
    Expect(1, 12288, '\P{^White_Space=yes}', "");
    Expect(0, 12289, '\p{White_Space=yes}', "");
    Expect(1, 12289, '\p{^White_Space=yes}', "");
    Expect(1, 12289, '\P{White_Space=yes}', "");
    Expect(0, 12289, '\P{^White_Space=yes}', "");
    Expect(1, 12288, '\p{White_Space=:\Ayes\z:}', "");;
    Expect(0, 12289, '\p{White_Space=:\Ayes\z:}', "");;
    Expect(1, 12288, '\p{White_Space=-yes}', "");
    Expect(0, 12288, '\p{^White_Space=-yes}', "");
    Expect(0, 12288, '\P{White_Space=-yes}', "");
    Expect(1, 12288, '\P{^White_Space=-yes}', "");
    Expect(0, 12289, '\p{White_Space=-yes}', "");
    Expect(1, 12289, '\p{^White_Space=-yes}', "");
    Expect(1, 12289, '\P{White_Space=-yes}', "");
    Expect(0, 12289, '\P{^White_Space=-yes}', "");
    Error('\p{WSpace:-:=Y}');
    Error('\P{WSpace:-:=Y}');
    Expect(1, 12288, '\p{WSpace=:\AY\z:}', "");;
    Expect(0, 12289, '\p{WSpace=:\AY\z:}', "");;
    Expect(1, 12288, '\p{WSpace=y}', "");
    Expect(0, 12288, '\p{^WSpace=y}', "");
    Expect(0, 12288, '\P{WSpace=y}', "");
    Expect(1, 12288, '\P{^WSpace=y}', "");
    Expect(0, 12289, '\p{WSpace=y}', "");
    Expect(1, 12289, '\p{^WSpace=y}', "");
    Expect(1, 12289, '\P{WSpace=y}', "");
    Expect(0, 12289, '\P{^WSpace=y}', "");
    Expect(1, 12288, '\p{WSpace=:\Ay\z:}', "");;
    Expect(0, 12289, '\p{WSpace=:\Ay\z:}', "");;
    Expect(1, 12288, '\p{WSpace:_Y}', "");
    Expect(0, 12288, '\p{^WSpace:_Y}', "");
    Expect(0, 12288, '\P{WSpace:_Y}', "");
    Expect(1, 12288, '\P{^WSpace:_Y}', "");
    Expect(0, 12289, '\p{WSpace:_Y}', "");
    Expect(1, 12289, '\p{^WSpace:_Y}', "");
    Expect(1, 12289, '\P{WSpace:_Y}', "");
    Expect(0, 12289, '\P{^WSpace:_Y}', "");
    Error('\p{Space=_ T:=}');
    Error('\P{Space=_ T:=}');
    Expect(1, 12288, '\p{Space=:\AT\z:}', "");;
    Expect(0, 12289, '\p{Space=:\AT\z:}', "");;
    Expect(1, 12288, '\p{Space=t}', "");
    Expect(0, 12288, '\p{^Space=t}', "");
    Expect(0, 12288, '\P{Space=t}', "");
    Expect(1, 12288, '\P{^Space=t}', "");
    Expect(0, 12289, '\p{Space=t}', "");
    Expect(1, 12289, '\p{^Space=t}', "");
    Expect(1, 12289, '\P{Space=t}', "");
    Expect(0, 12289, '\P{^Space=t}', "");
    Expect(1, 12288, '\p{Space=:\At\z:}', "");;
    Expect(0, 12289, '\p{Space=:\At\z:}', "");;
    Expect(1, 12288, '\p{Space=  T}', "");
    Expect(0, 12288, '\p{^Space=  T}', "");
    Expect(0, 12288, '\P{Space=  T}', "");
    Expect(1, 12288, '\P{^Space=  T}', "");
    Expect(0, 12289, '\p{Space=  T}', "");
    Expect(1, 12289, '\p{^Space=  T}', "");
    Expect(1, 12289, '\P{Space=  T}', "");
    Expect(0, 12289, '\P{^Space=  T}', "");
    Error('\p{Is_White_Space=	True:=}');
    Error('\P{Is_White_Space=	True:=}');
    Expect(1, 12288, '\p{Is_White_Space=true}', "");
    Expect(0, 12288, '\p{^Is_White_Space=true}', "");
    Expect(0, 12288, '\P{Is_White_Space=true}', "");
    Expect(1, 12288, '\P{^Is_White_Space=true}', "");
    Expect(0, 12289, '\p{Is_White_Space=true}', "");
    Expect(1, 12289, '\p{^Is_White_Space=true}', "");
    Expect(1, 12289, '\P{Is_White_Space=true}', "");
    Expect(0, 12289, '\P{^Is_White_Space=true}', "");
    Expect(1, 12288, '\p{Is_White_Space=-_true}', "");
    Expect(0, 12288, '\p{^Is_White_Space=-_true}', "");
    Expect(0, 12288, '\P{Is_White_Space=-_true}', "");
    Expect(1, 12288, '\P{^Is_White_Space=-_true}', "");
    Expect(0, 12289, '\p{Is_White_Space=-_true}', "");
    Expect(1, 12289, '\p{^Is_White_Space=-_true}', "");
    Expect(1, 12289, '\P{Is_White_Space=-_true}', "");
    Expect(0, 12289, '\P{^Is_White_Space=-_true}', "");
    Error('\p{Is_WSpace=_ Yes/a/}');
    Error('\P{Is_WSpace=_ Yes/a/}');
    Expect(1, 12288, '\p{Is_WSpace: yes}', "");
    Expect(0, 12288, '\p{^Is_WSpace: yes}', "");
    Expect(0, 12288, '\P{Is_WSpace: yes}', "");
    Expect(1, 12288, '\P{^Is_WSpace: yes}', "");
    Expect(0, 12289, '\p{Is_WSpace: yes}', "");
    Expect(1, 12289, '\p{^Is_WSpace: yes}', "");
    Expect(1, 12289, '\P{Is_WSpace: yes}', "");
    Expect(0, 12289, '\P{^Is_WSpace: yes}', "");
    Expect(1, 12288, '\p{Is_WSpace=Yes}', "");
    Expect(0, 12288, '\p{^Is_WSpace=Yes}', "");
    Expect(0, 12288, '\P{Is_WSpace=Yes}', "");
    Expect(1, 12288, '\P{^Is_WSpace=Yes}', "");
    Expect(0, 12289, '\p{Is_WSpace=Yes}', "");
    Expect(1, 12289, '\p{^Is_WSpace=Yes}', "");
    Expect(1, 12289, '\P{Is_WSpace=Yes}', "");
    Expect(0, 12289, '\P{^Is_WSpace=Yes}', "");
    Error('\p{Is_Space=/a/_	y}');
    Error('\P{Is_Space=/a/_	y}');
    Expect(1, 12288, '\p{Is_Space=y}', "");
    Expect(0, 12288, '\p{^Is_Space=y}', "");
    Expect(0, 12288, '\P{Is_Space=y}', "");
    Expect(1, 12288, '\P{^Is_Space=y}', "");
    Expect(0, 12289, '\p{Is_Space=y}', "");
    Expect(1, 12289, '\p{^Is_Space=y}', "");
    Expect(1, 12289, '\P{Is_Space=y}', "");
    Expect(0, 12289, '\P{^Is_Space=y}', "");
    Expect(1, 12288, '\p{Is_Space= y}', "");
    Expect(0, 12288, '\p{^Is_Space= y}', "");
    Expect(0, 12288, '\P{Is_Space= y}', "");
    Expect(1, 12288, '\P{^Is_Space= y}', "");
    Expect(0, 12289, '\p{Is_Space= y}', "");
    Expect(1, 12289, '\p{^Is_Space= y}', "");
    Expect(1, 12289, '\P{Is_Space= y}', "");
    Expect(0, 12289, '\P{^Is_Space= y}', "");
    Error('\p{XID_Continue=	/a/No}');
    Error('\P{XID_Continue=	/a/No}');
    Expect(1, 918000, '\p{XID_Continue=:\ANo\z:}', "");;
    Expect(0, 917999, '\p{XID_Continue=:\ANo\z:}', "");;
    Expect(1, 918000, '\p{XID_Continue=no}', "");
    Expect(0, 918000, '\p{^XID_Continue=no}', "");
    Expect(0, 918000, '\P{XID_Continue=no}', "");
    Expect(1, 918000, '\P{^XID_Continue=no}', "");
    Expect(0, 917999, '\p{XID_Continue=no}', "");
    Expect(1, 917999, '\p{^XID_Continue=no}', "");
    Expect(1, 917999, '\P{XID_Continue=no}', "");
    Expect(0, 917999, '\P{^XID_Continue=no}', "");
    Expect(1, 918000, '\p{XID_Continue=:\Ano\z:}', "");;
    Expect(0, 917999, '\p{XID_Continue=:\Ano\z:}', "");;
    Expect(1, 918000, '\p{XID_Continue=NO}', "");
    Expect(0, 918000, '\p{^XID_Continue=NO}', "");
    Expect(0, 918000, '\P{XID_Continue=NO}', "");
    Expect(1, 918000, '\P{^XID_Continue=NO}', "");
    Expect(0, 917999, '\p{XID_Continue=NO}', "");
    Expect(1, 917999, '\p{^XID_Continue=NO}', "");
    Expect(1, 917999, '\P{XID_Continue=NO}', "");
    Expect(0, 917999, '\P{^XID_Continue=NO}', "");
    Error('\p{XIDC=- N:=}');
    Error('\P{XIDC=- N:=}');
    Expect(1, 918000, '\p{XIDC=:\AN\z:}', "");;
    Expect(0, 917999, '\p{XIDC=:\AN\z:}', "");;
    Expect(1, 918000, '\p{XIDC=n}', "");
    Expect(0, 918000, '\p{^XIDC=n}', "");
    Expect(0, 918000, '\P{XIDC=n}', "");
    Expect(1, 918000, '\P{^XIDC=n}', "");
    Expect(0, 917999, '\p{XIDC=n}', "");
    Expect(1, 917999, '\p{^XIDC=n}', "");
    Expect(1, 917999, '\P{XIDC=n}', "");
    Expect(0, 917999, '\P{^XIDC=n}', "");
    Expect(1, 918000, '\p{XIDC=:\An\z:}', "");;
    Expect(0, 917999, '\p{XIDC=:\An\z:}', "");;
    Expect(1, 918000, '\p{XIDC=__n}', "");
    Expect(0, 918000, '\p{^XIDC=__n}', "");
    Expect(0, 918000, '\P{XIDC=__n}', "");
    Expect(1, 918000, '\P{^XIDC=__n}', "");
    Expect(0, 917999, '\p{XIDC=__n}', "");
    Expect(1, 917999, '\p{^XIDC=__n}', "");
    Expect(1, 917999, '\P{XIDC=__n}', "");
    Expect(0, 917999, '\P{^XIDC=__n}', "");
    Error('\p{Is_XID_Continue: -/a/F}');
    Error('\P{Is_XID_Continue: -/a/F}');
    Expect(1, 918000, '\p{Is_XID_Continue=f}', "");
    Expect(0, 918000, '\p{^Is_XID_Continue=f}', "");
    Expect(0, 918000, '\P{Is_XID_Continue=f}', "");
    Expect(1, 918000, '\P{^Is_XID_Continue=f}', "");
    Expect(0, 917999, '\p{Is_XID_Continue=f}', "");
    Expect(1, 917999, '\p{^Is_XID_Continue=f}', "");
    Expect(1, 917999, '\P{Is_XID_Continue=f}', "");
    Expect(0, 917999, '\P{^Is_XID_Continue=f}', "");
    Expect(1, 918000, '\p{Is_XID_Continue=F}', "");
    Expect(0, 918000, '\p{^Is_XID_Continue=F}', "");
    Expect(0, 918000, '\P{Is_XID_Continue=F}', "");
    Expect(1, 918000, '\P{^Is_XID_Continue=F}', "");
    Expect(0, 917999, '\p{Is_XID_Continue=F}', "");
    Expect(1, 917999, '\p{^Is_XID_Continue=F}', "");
    Expect(1, 917999, '\P{Is_XID_Continue=F}', "");
    Expect(0, 917999, '\P{^Is_XID_Continue=F}', "");
    Error('\p{Is_XIDC=_-False:=}');
    Error('\P{Is_XIDC=_-False:=}');
    Expect(1, 918000, '\p{Is_XIDC=false}', "");
    Expect(0, 918000, '\p{^Is_XIDC=false}', "");
    Expect(0, 918000, '\P{Is_XIDC=false}', "");
    Expect(1, 918000, '\P{^Is_XIDC=false}', "");
    Expect(0, 917999, '\p{Is_XIDC=false}', "");
    Expect(1, 917999, '\p{^Is_XIDC=false}', "");
    Expect(1, 917999, '\P{Is_XIDC=false}', "");
    Expect(0, 917999, '\P{^Is_XIDC=false}', "");
    Expect(1, 918000, '\p{Is_XIDC=_-False}', "");
    Expect(0, 918000, '\p{^Is_XIDC=_-False}', "");
    Expect(0, 918000, '\P{Is_XIDC=_-False}', "");
    Expect(1, 918000, '\P{^Is_XIDC=_-False}', "");
    Expect(0, 917999, '\p{Is_XIDC=_-False}', "");
    Expect(1, 917999, '\p{^Is_XIDC=_-False}', "");
    Expect(1, 917999, '\P{Is_XIDC=_-False}', "");
    Expect(0, 917999, '\P{^Is_XIDC=_-False}', "");
    Error('\p{XID_Continue=/a/ -Yes}');
    Error('\P{XID_Continue=/a/ -Yes}');
    Expect(1, 917999, '\p{XID_Continue=:\AYes\z:}', "");;
    Expect(0, 918000, '\p{XID_Continue=:\AYes\z:}', "");;
    Expect(1, 917999, '\p{XID_Continue=yes}', "");
    Expect(0, 917999, '\p{^XID_Continue=yes}', "");
    Expect(0, 917999, '\P{XID_Continue=yes}', "");
    Expect(1, 917999, '\P{^XID_Continue=yes}', "");
    Expect(0, 918000, '\p{XID_Continue=yes}', "");
    Expect(1, 918000, '\p{^XID_Continue=yes}', "");
    Expect(1, 918000, '\P{XID_Continue=yes}', "");
    Expect(0, 918000, '\P{^XID_Continue=yes}', "");
    Expect(1, 917999, '\p{XID_Continue=:\Ayes\z:}', "");;
    Expect(0, 918000, '\p{XID_Continue=:\Ayes\z:}', "");;
    Expect(1, 917999, '\p{XID_Continue=_yes}', "");
    Expect(0, 917999, '\p{^XID_Continue=_yes}', "");
    Expect(0, 917999, '\P{XID_Continue=_yes}', "");
    Expect(1, 917999, '\P{^XID_Continue=_yes}', "");
    Expect(0, 918000, '\p{XID_Continue=_yes}', "");
    Expect(1, 918000, '\p{^XID_Continue=_yes}', "");
    Expect(1, 918000, '\P{XID_Continue=_yes}', "");
    Expect(0, 918000, '\P{^XID_Continue=_yes}', "");
    Error('\p{XIDC=	y/a/}');
    Error('\P{XIDC=	y/a/}');
    Expect(1, 917999, '\p{XIDC=:\AY\z:}', "");;
    Expect(0, 918000, '\p{XIDC=:\AY\z:}', "");;
    Expect(1, 917999, '\p{XIDC=y}', "");
    Expect(0, 917999, '\p{^XIDC=y}', "");
    Expect(0, 917999, '\P{XIDC=y}', "");
    Expect(1, 917999, '\P{^XIDC=y}', "");
    Expect(0, 918000, '\p{XIDC=y}', "");
    Expect(1, 918000, '\p{^XIDC=y}', "");
    Expect(1, 918000, '\P{XIDC=y}', "");
    Expect(0, 918000, '\P{^XIDC=y}', "");
    Expect(1, 917999, '\p{XIDC=:\Ay\z:}', "");;
    Expect(0, 918000, '\p{XIDC=:\Ay\z:}', "");;
    Expect(1, 917999, '\p{XIDC= Y}', "");
    Expect(0, 917999, '\p{^XIDC= Y}', "");
    Expect(0, 917999, '\P{XIDC= Y}', "");
    Expect(1, 917999, '\P{^XIDC= Y}', "");
    Expect(0, 918000, '\p{XIDC= Y}', "");
    Expect(1, 918000, '\p{^XIDC= Y}', "");
    Expect(1, 918000, '\P{XIDC= Y}', "");
    Expect(0, 918000, '\P{^XIDC= Y}', "");
    Error('\p{Is_XID_Continue=_/a/T}');
    Error('\P{Is_XID_Continue=_/a/T}');
    Expect(1, 917999, '\p{Is_XID_Continue=t}', "");
    Expect(0, 917999, '\p{^Is_XID_Continue=t}', "");
    Expect(0, 917999, '\P{Is_XID_Continue=t}', "");
    Expect(1, 917999, '\P{^Is_XID_Continue=t}', "");
    Expect(0, 918000, '\p{Is_XID_Continue=t}', "");
    Expect(1, 918000, '\p{^Is_XID_Continue=t}', "");
    Expect(1, 918000, '\P{Is_XID_Continue=t}', "");
    Expect(0, 918000, '\P{^Is_XID_Continue=t}', "");
    Expect(1, 917999, '\p{Is_XID_Continue=	T}', "");
    Expect(0, 917999, '\p{^Is_XID_Continue=	T}', "");
    Expect(0, 917999, '\P{Is_XID_Continue=	T}', "");
    Expect(1, 917999, '\P{^Is_XID_Continue=	T}', "");
    Expect(0, 918000, '\p{Is_XID_Continue=	T}', "");
    Expect(1, 918000, '\p{^Is_XID_Continue=	T}', "");
    Expect(1, 918000, '\P{Is_XID_Continue=	T}', "");
    Expect(0, 918000, '\P{^Is_XID_Continue=	T}', "");
    Error('\p{Is_XIDC=_	TRUE:=}');
    Error('\P{Is_XIDC=_	TRUE:=}');
    Expect(1, 917999, '\p{Is_XIDC=true}', "");
    Expect(0, 917999, '\p{^Is_XIDC=true}', "");
    Expect(0, 917999, '\P{Is_XIDC=true}', "");
    Expect(1, 917999, '\P{^Is_XIDC=true}', "");
    Expect(0, 918000, '\p{Is_XIDC=true}', "");
    Expect(1, 918000, '\p{^Is_XIDC=true}', "");
    Expect(1, 918000, '\P{Is_XIDC=true}', "");
    Expect(0, 918000, '\P{^Is_XIDC=true}', "");
    Expect(1, 917999, '\p{Is_XIDC=_True}', "");
    Expect(0, 917999, '\p{^Is_XIDC=_True}', "");
    Expect(0, 917999, '\P{Is_XIDC=_True}', "");
    Expect(1, 917999, '\P{^Is_XIDC=_True}', "");
    Expect(0, 918000, '\p{Is_XIDC=_True}', "");
    Expect(1, 918000, '\p{^Is_XIDC=_True}', "");
    Expect(1, 918000, '\P{Is_XIDC=_True}', "");
    Expect(0, 918000, '\P{^Is_XIDC=_True}', "");
    Error('\p{XID_Start=	:=No}');
    Error('\P{XID_Start=	:=No}');
    Expect(1, 205744, '\p{XID_Start=:\ANo\z:}', "");;
    Expect(0, 205743, '\p{XID_Start=:\ANo\z:}', "");;
    Expect(1, 205744, '\p{XID_Start=no}', "");
    Expect(0, 205744, '\p{^XID_Start=no}', "");
    Expect(0, 205744, '\P{XID_Start=no}', "");
    Expect(1, 205744, '\P{^XID_Start=no}', "");
    Expect(0, 205743, '\p{XID_Start=no}', "");
    Expect(1, 205743, '\p{^XID_Start=no}', "");
    Expect(1, 205743, '\P{XID_Start=no}', "");
    Expect(0, 205743, '\P{^XID_Start=no}', "");
    Expect(1, 205744, '\p{XID_Start=:\Ano\z:}', "");;
    Expect(0, 205743, '\p{XID_Start=:\Ano\z:}', "");;
    Expect(1, 205744, '\p{XID_Start:	-No}', "");
    Expect(0, 205744, '\p{^XID_Start:	-No}', "");
    Expect(0, 205744, '\P{XID_Start:	-No}', "");
    Expect(1, 205744, '\P{^XID_Start:	-No}', "");
    Expect(0, 205743, '\p{XID_Start:	-No}', "");
    Expect(1, 205743, '\p{^XID_Start:	-No}', "");
    Expect(1, 205743, '\P{XID_Start:	-No}', "");
    Expect(0, 205743, '\P{^XID_Start:	-No}', "");
    Error('\p{XIDS=/a/ -N}');
    Error('\P{XIDS=/a/ -N}');
    Expect(1, 205744, '\p{XIDS=:\AN\z:}', "");;
    Expect(0, 205743, '\p{XIDS=:\AN\z:}', "");;
    Expect(1, 205744, '\p{XIDS=n}', "");
    Expect(0, 205744, '\p{^XIDS=n}', "");
    Expect(0, 205744, '\P{XIDS=n}', "");
    Expect(1, 205744, '\P{^XIDS=n}', "");
    Expect(0, 205743, '\p{XIDS=n}', "");
    Expect(1, 205743, '\p{^XIDS=n}', "");
    Expect(1, 205743, '\P{XIDS=n}', "");
    Expect(0, 205743, '\P{^XIDS=n}', "");
    Expect(1, 205744, '\p{XIDS=:\An\z:}', "");;
    Expect(0, 205743, '\p{XIDS=:\An\z:}', "");;
    Expect(1, 205744, '\p{XIDS=N}', "");
    Expect(0, 205744, '\p{^XIDS=N}', "");
    Expect(0, 205744, '\P{XIDS=N}', "");
    Expect(1, 205744, '\P{^XIDS=N}', "");
    Expect(0, 205743, '\p{XIDS=N}', "");
    Expect(1, 205743, '\p{^XIDS=N}', "");
    Expect(1, 205743, '\P{XIDS=N}', "");
    Expect(0, 205743, '\P{^XIDS=N}', "");
    Error('\p{Is_XID_Start=:=__F}');
    Error('\P{Is_XID_Start=:=__F}');
    Expect(1, 205744, '\p{Is_XID_Start=f}', "");
    Expect(0, 205744, '\p{^Is_XID_Start=f}', "");
    Expect(0, 205744, '\P{Is_XID_Start=f}', "");
    Expect(1, 205744, '\P{^Is_XID_Start=f}', "");
    Expect(0, 205743, '\p{Is_XID_Start=f}', "");
    Expect(1, 205743, '\p{^Is_XID_Start=f}', "");
    Expect(1, 205743, '\P{Is_XID_Start=f}', "");
    Expect(0, 205743, '\P{^Is_XID_Start=f}', "");
    Expect(1, 205744, '\p{Is_XID_Start=__F}', "");
    Expect(0, 205744, '\p{^Is_XID_Start=__F}', "");
    Expect(0, 205744, '\P{Is_XID_Start=__F}', "");
    Expect(1, 205744, '\P{^Is_XID_Start=__F}', "");
    Expect(0, 205743, '\p{Is_XID_Start=__F}', "");
    Expect(1, 205743, '\p{^Is_XID_Start=__F}', "");
    Expect(1, 205743, '\P{Is_XID_Start=__F}', "");
    Expect(0, 205743, '\P{^Is_XID_Start=__F}', "");
    Error('\p{Is_XIDS: 	:=FALSE}');
    Error('\P{Is_XIDS: 	:=FALSE}');
    Expect(1, 205744, '\p{Is_XIDS=false}', "");
    Expect(0, 205744, '\p{^Is_XIDS=false}', "");
    Expect(0, 205744, '\P{Is_XIDS=false}', "");
    Expect(1, 205744, '\P{^Is_XIDS=false}', "");
    Expect(0, 205743, '\p{Is_XIDS=false}', "");
    Expect(1, 205743, '\p{^Is_XIDS=false}', "");
    Expect(1, 205743, '\P{Is_XIDS=false}', "");
    Expect(0, 205743, '\P{^Is_XIDS=false}', "");
    Expect(1, 205744, '\p{Is_XIDS=	_False}', "");
    Expect(0, 205744, '\p{^Is_XIDS=	_False}', "");
    Expect(0, 205744, '\P{Is_XIDS=	_False}', "");
    Expect(1, 205744, '\P{^Is_XIDS=	_False}', "");
    Expect(0, 205743, '\p{Is_XIDS=	_False}', "");
    Expect(1, 205743, '\p{^Is_XIDS=	_False}', "");
    Expect(1, 205743, '\P{Is_XIDS=	_False}', "");
    Expect(0, 205743, '\P{^Is_XIDS=	_False}', "");
    Error('\p{XID_Start: -Yes/a/}');
    Error('\P{XID_Start: -Yes/a/}');
    Expect(1, 205743, '\p{XID_Start=:\AYes\z:}', "");;
    Expect(0, 205744, '\p{XID_Start=:\AYes\z:}', "");;
    Expect(1, 205743, '\p{XID_Start=yes}', "");
    Expect(0, 205743, '\p{^XID_Start=yes}', "");
    Expect(0, 205743, '\P{XID_Start=yes}', "");
    Expect(1, 205743, '\P{^XID_Start=yes}', "");
    Expect(0, 205744, '\p{XID_Start=yes}', "");
    Expect(1, 205744, '\p{^XID_Start=yes}', "");
    Expect(1, 205744, '\P{XID_Start=yes}', "");
    Expect(0, 205744, '\P{^XID_Start=yes}', "");
    Expect(1, 205743, '\p{XID_Start=:\Ayes\z:}', "");;
    Expect(0, 205744, '\p{XID_Start=:\Ayes\z:}', "");;
    Expect(1, 205743, '\p{XID_Start: YES}', "");
    Expect(0, 205743, '\p{^XID_Start: YES}', "");
    Expect(0, 205743, '\P{XID_Start: YES}', "");
    Expect(1, 205743, '\P{^XID_Start: YES}', "");
    Expect(0, 205744, '\p{XID_Start: YES}', "");
    Expect(1, 205744, '\p{^XID_Start: YES}', "");
    Expect(1, 205744, '\P{XID_Start: YES}', "");
    Expect(0, 205744, '\P{^XID_Start: YES}', "");
    Error('\p{XIDS=:=	_Y}');
    Error('\P{XIDS=:=	_Y}');
    Expect(1, 205743, '\p{XIDS=:\AY\z:}', "");;
    Expect(0, 205744, '\p{XIDS=:\AY\z:}', "");;
    Expect(1, 205743, '\p{XIDS:   y}', "");
    Expect(0, 205743, '\p{^XIDS:   y}', "");
    Expect(0, 205743, '\P{XIDS:   y}', "");
    Expect(1, 205743, '\P{^XIDS:   y}', "");
    Expect(0, 205744, '\p{XIDS:   y}', "");
    Expect(1, 205744, '\p{^XIDS:   y}', "");
    Expect(1, 205744, '\P{XIDS:   y}', "");
    Expect(0, 205744, '\P{^XIDS:   y}', "");
    Expect(1, 205743, '\p{XIDS=:\Ay\z:}', "");;
    Expect(0, 205744, '\p{XIDS=:\Ay\z:}', "");;
    Expect(1, 205743, '\p{XIDS=	Y}', "");
    Expect(0, 205743, '\p{^XIDS=	Y}', "");
    Expect(0, 205743, '\P{XIDS=	Y}', "");
    Expect(1, 205743, '\P{^XIDS=	Y}', "");
    Expect(0, 205744, '\p{XIDS=	Y}', "");
    Expect(1, 205744, '\p{^XIDS=	Y}', "");
    Expect(1, 205744, '\P{XIDS=	Y}', "");
    Expect(0, 205744, '\P{^XIDS=	Y}', "");
    Error('\p{Is_XID_Start=		T/a/}');
    Error('\P{Is_XID_Start=		T/a/}');
    Expect(1, 205743, '\p{Is_XID_Start=t}', "");
    Expect(0, 205743, '\p{^Is_XID_Start=t}', "");
    Expect(0, 205743, '\P{Is_XID_Start=t}', "");
    Expect(1, 205743, '\P{^Is_XID_Start=t}', "");
    Expect(0, 205744, '\p{Is_XID_Start=t}', "");
    Expect(1, 205744, '\p{^Is_XID_Start=t}', "");
    Expect(1, 205744, '\P{Is_XID_Start=t}', "");
    Expect(0, 205744, '\P{^Is_XID_Start=t}', "");
    Expect(1, 205743, '\p{Is_XID_Start:		-t}', "");
    Expect(0, 205743, '\p{^Is_XID_Start:		-t}', "");
    Expect(0, 205743, '\P{Is_XID_Start:		-t}', "");
    Expect(1, 205743, '\P{^Is_XID_Start:		-t}', "");
    Expect(0, 205744, '\p{Is_XID_Start:		-t}', "");
    Expect(1, 205744, '\p{^Is_XID_Start:		-t}', "");
    Expect(1, 205744, '\P{Is_XID_Start:		-t}', "");
    Expect(0, 205744, '\P{^Is_XID_Start:		-t}', "");
    Error('\p{Is_XIDS= true/a/}');
    Error('\P{Is_XIDS= true/a/}');
    Expect(1, 205743, '\p{Is_XIDS=true}', "");
    Expect(0, 205743, '\p{^Is_XIDS=true}', "");
    Expect(0, 205743, '\P{Is_XIDS=true}', "");
    Expect(1, 205743, '\P{^Is_XIDS=true}', "");
    Expect(0, 205744, '\p{Is_XIDS=true}', "");
    Expect(1, 205744, '\p{^Is_XIDS=true}', "");
    Expect(1, 205744, '\P{Is_XIDS=true}', "");
    Expect(0, 205744, '\P{^Is_XIDS=true}', "");
    Expect(1, 205743, '\p{Is_XIDS=	True}', "");
    Expect(0, 205743, '\p{^Is_XIDS=	True}', "");
    Expect(0, 205743, '\P{Is_XIDS=	True}', "");
    Expect(1, 205743, '\P{^Is_XIDS=	True}', "");
    Expect(0, 205744, '\p{Is_XIDS=	True}', "");
    Expect(1, 205744, '\p{^Is_XIDS=	True}', "");
    Expect(1, 205744, '\P{Is_XIDS=	True}', "");
    Expect(0, 205744, '\P{^Is_XIDS=	True}', "");
    Error('\p{Expands_On_NFC=No}');
    Error('\P{Expands_On_NFC=No}');
    Error('\p{XO_NFC=N}');
    Error('\P{XO_NFC=N}');
    Error('\p{Is_Expands_On_NFC:   F}');
    Error('\P{Is_Expands_On_NFC:   F}');
    Error('\p{Is_XO_NFC=False}');
    Error('\P{Is_XO_NFC=False}');
    Error('\p{Expands_On_NFC=Yes}');
    Error('\P{Expands_On_NFC=Yes}');
    Error('\p{XO_NFC=Y}');
    Error('\P{XO_NFC=Y}');
    Error('\p{Is_Expands_On_NFC=T}');
    Error('\P{Is_Expands_On_NFC=T}');
    Error('\p{Is_XO_NFC=True}');
    Error('\P{Is_XO_NFC=True}');
    Error('\p{Expands_On_NFD=No}');
    Error('\P{Expands_On_NFD=No}');
    Error('\p{XO_NFD=N}');
    Error('\P{XO_NFD=N}');
    Error('\p{Is_Expands_On_NFD=F}');
    Error('\P{Is_Expands_On_NFD=F}');
    Error('\p{Is_XO_NFD: False}');
    Error('\P{Is_XO_NFD: False}');
    Error('\p{Expands_On_NFD=Yes}');
    Error('\P{Expands_On_NFD=Yes}');
    Error('\p{XO_NFD=Y}');
    Error('\P{XO_NFD=Y}');
    Error('\p{Is_Expands_On_NFD=T}');
    Error('\P{Is_Expands_On_NFD=T}');
    Error('\p{Is_XO_NFD=True}');
    Error('\P{Is_XO_NFD=True}');
    Error('\p{Expands_On_NFKC=No}');
    Error('\P{Expands_On_NFKC=No}');
    Error('\p{XO_NFKC=N}');
    Error('\P{XO_NFKC=N}');
    Error('\p{Is_Expands_On_NFKC=F}');
    Error('\P{Is_Expands_On_NFKC=F}');
    Error('\p{Is_XO_NFKC=False}');
    Error('\P{Is_XO_NFKC=False}');
    Error('\p{Expands_On_NFKC=Yes}');
    Error('\P{Expands_On_NFKC=Yes}');
    Error('\p{XO_NFKC=Y}');
    Error('\P{XO_NFKC=Y}');
    Error('\p{Is_Expands_On_NFKC=T}');
    Error('\P{Is_Expands_On_NFKC=T}');
    Error('\p{Is_XO_NFKC=True}');
    Error('\P{Is_XO_NFKC=True}');
    Error('\p{Expands_On_NFKD=No}');
    Error('\P{Expands_On_NFKD=No}');
    Error('\p{XO_NFKD=N}');
    Error('\P{XO_NFKD=N}');
    Error('\p{Is_Expands_On_NFKD=F}');
    Error('\P{Is_Expands_On_NFKD=F}');
    Error('\p{Is_XO_NFKD=False}');
    Error('\P{Is_XO_NFKD=False}');
    Error('\p{Expands_On_NFKD=Yes}');
    Error('\P{Expands_On_NFKD=Yes}');
    Error('\p{XO_NFKD=Y}');
    Error('\P{XO_NFKD=Y}');
    Error('\p{Is_Expands_On_NFKD=T}');
    Error('\P{Is_Expands_On_NFKD=T}');
    Error('\p{Is_XO_NFKD=True}');
    Error('\P{Is_XO_NFKD=True}');
}
if (!$::TESTCHUNK or $::TESTCHUNK == 5) {
    Test_GCB('÷ 0020 ÷ 0020 ÷	#  ÷ [0.2] SPACE (Other) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 0020 × 0308 ÷ 0020 ÷	#  ÷ [0.2] SPACE (Other) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 0020 ÷ 000D ÷	#  ÷ [0.2] SPACE (Other) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ 0020 × 0308 ÷ 000D ÷	#  ÷ [0.2] SPACE (Other) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ 0020 ÷ 000A ÷	#  ÷ [0.2] SPACE (Other) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ 0020 × 0308 ÷ 000A ÷	#  ÷ [0.2] SPACE (Other) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ 0020 ÷ 0001 ÷	#  ÷ [0.2] SPACE (Other) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ 0020 × 0308 ÷ 0001 ÷	#  ÷ [0.2] SPACE (Other) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ 0020 × 034F ÷	#  ÷ [0.2] SPACE (Other) × [9.0] COMBINING GRAPHEME JOINER (Extend) ÷ [0.3]');
    Test_GCB('÷ 0020 × 0308 × 034F ÷	#  ÷ [0.2] SPACE (Other) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] COMBINING GRAPHEME JOINER (Extend) ÷ [0.3]');
    Test_GCB('÷ 0020 ÷ 1F1E6 ÷	#  ÷ [0.2] SPACE (Other) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ 0020 × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] SPACE (Other) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ 0020 ÷ 0600 ÷	#  ÷ [0.2] SPACE (Other) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ 0020 × 0308 ÷ 0600 ÷	#  ÷ [0.2] SPACE (Other) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ 0020 × 0903 ÷	#  ÷ [0.2] SPACE (Other) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ 0020 × 0308 × 0903 ÷	#  ÷ [0.2] SPACE (Other) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ 0020 ÷ 1100 ÷	#  ÷ [0.2] SPACE (Other) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 0020 × 0308 ÷ 1100 ÷	#  ÷ [0.2] SPACE (Other) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 0020 ÷ 1160 ÷	#  ÷ [0.2] SPACE (Other) ÷ [999.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ 0020 × 0308 ÷ 1160 ÷	#  ÷ [0.2] SPACE (Other) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ 0020 ÷ 11A8 ÷	#  ÷ [0.2] SPACE (Other) ÷ [999.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ 0020 × 0308 ÷ 11A8 ÷	#  ÷ [0.2] SPACE (Other) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ 0020 ÷ AC00 ÷	#  ÷ [0.2] SPACE (Other) ÷ [999.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ 0020 × 0308 ÷ AC00 ÷	#  ÷ [0.2] SPACE (Other) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ 0020 ÷ AC01 ÷	#  ÷ [0.2] SPACE (Other) ÷ [999.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ 0020 × 0308 ÷ AC01 ÷	#  ÷ [0.2] SPACE (Other) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ 0020 ÷ 231A ÷	#  ÷ [0.2] SPACE (Other) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_GCB('÷ 0020 × 0308 ÷ 231A ÷	#  ÷ [0.2] SPACE (Other) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_GCB('÷ 0020 × 0300 ÷	#  ÷ [0.2] SPACE (Other) × [9.0] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 0020 × 0308 × 0300 ÷	#  ÷ [0.2] SPACE (Other) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 0020 × 200D ÷	#  ÷ [0.2] SPACE (Other) × [9.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 0020 × 0308 × 200D ÷	#  ÷ [0.2] SPACE (Other) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 0020 ÷ 0378 ÷	#  ÷ [0.2] SPACE (Other) ÷ [999.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ 0020 × 0308 ÷ 0378 ÷	#  ÷ [0.2] SPACE (Other) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 0020 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 0308 ÷ 0020 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 000D ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 0308 ÷ 000D ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ 000D × 000A ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) × [3.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 0308 ÷ 000A ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 0001 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 0308 ÷ 0001 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 034F ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING GRAPHEME JOINER (Extend) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 0308 × 034F ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] COMBINING GRAPHEME JOINER (Extend) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 1F1E6 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 0600 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 0308 ÷ 0600 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 0903 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 0308 × 0903 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 1100 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 0308 ÷ 1100 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 1160 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 0308 ÷ 1160 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 11A8 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 0308 ÷ 11A8 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ AC00 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 0308 ÷ AC00 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ AC01 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 0308 ÷ AC01 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 231A ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] WATCH (ExtPict) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 0308 ÷ 231A ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 0300 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 0308 × 0300 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 200D ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 0308 × 200D ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 0378 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 0308 ÷ 0378 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 0020 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 0308 ÷ 0020 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 000D ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 0308 ÷ 000D ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 000A ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 0308 ÷ 000A ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 0001 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 0308 ÷ 0001 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 034F ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING GRAPHEME JOINER (Extend) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 0308 × 034F ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] COMBINING GRAPHEME JOINER (Extend) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 1F1E6 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 0600 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 0308 ÷ 0600 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 0903 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 0308 × 0903 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 1100 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 0308 ÷ 1100 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 1160 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 0308 ÷ 1160 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 11A8 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 0308 ÷ 11A8 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ AC00 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 0308 ÷ AC00 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ AC01 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 0308 ÷ AC01 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 231A ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] WATCH (ExtPict) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 0308 ÷ 231A ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 0300 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 0308 × 0300 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 200D ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 0308 × 200D ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 0378 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 0308 ÷ 0378 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 0020 ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 0308 ÷ 0020 ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 000D ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 0308 ÷ 000D ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 000A ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 0308 ÷ 000A ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 0001 ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 0308 ÷ 0001 ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 034F ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] COMBINING GRAPHEME JOINER (Extend) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 0308 × 034F ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] COMBINING GRAPHEME JOINER (Extend) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 1F1E6 ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 0600 ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 0308 ÷ 0600 ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 0903 ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 0308 × 0903 ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 1100 ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 0308 ÷ 1100 ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 1160 ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 0308 ÷ 1160 ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 11A8 ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 0308 ÷ 11A8 ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ AC00 ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 0308 ÷ AC00 ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ AC01 ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 0308 ÷ AC01 ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 231A ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] WATCH (ExtPict) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 0308 ÷ 231A ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 0300 ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 0308 × 0300 ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 200D ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 0308 × 200D ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 0378 ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 0308 ÷ 0378 ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ 034F ÷ 0020 ÷	#  ÷ [0.2] COMBINING GRAPHEME JOINER (Extend) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 034F × 0308 ÷ 0020 ÷	#  ÷ [0.2] COMBINING GRAPHEME JOINER (Extend) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 034F ÷ 000D ÷	#  ÷ [0.2] COMBINING GRAPHEME JOINER (Extend) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ 034F × 0308 ÷ 000D ÷	#  ÷ [0.2] COMBINING GRAPHEME JOINER (Extend) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ 034F ÷ 000A ÷	#  ÷ [0.2] COMBINING GRAPHEME JOINER (Extend) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ 034F × 0308 ÷ 000A ÷	#  ÷ [0.2] COMBINING GRAPHEME JOINER (Extend) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ 034F ÷ 0001 ÷	#  ÷ [0.2] COMBINING GRAPHEME JOINER (Extend) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ 034F × 0308 ÷ 0001 ÷	#  ÷ [0.2] COMBINING GRAPHEME JOINER (Extend) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ 034F × 034F ÷	#  ÷ [0.2] COMBINING GRAPHEME JOINER (Extend) × [9.0] COMBINING GRAPHEME JOINER (Extend) ÷ [0.3]');
    Test_GCB('÷ 034F × 0308 × 034F ÷	#  ÷ [0.2] COMBINING GRAPHEME JOINER (Extend) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] COMBINING GRAPHEME JOINER (Extend) ÷ [0.3]');
    Test_GCB('÷ 034F ÷ 1F1E6 ÷	#  ÷ [0.2] COMBINING GRAPHEME JOINER (Extend) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ 034F × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] COMBINING GRAPHEME JOINER (Extend) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ 034F ÷ 0600 ÷	#  ÷ [0.2] COMBINING GRAPHEME JOINER (Extend) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ 034F × 0308 ÷ 0600 ÷	#  ÷ [0.2] COMBINING GRAPHEME JOINER (Extend) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ 034F × 0903 ÷	#  ÷ [0.2] COMBINING GRAPHEME JOINER (Extend) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ 034F × 0308 × 0903 ÷	#  ÷ [0.2] COMBINING GRAPHEME JOINER (Extend) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ 034F ÷ 1100 ÷	#  ÷ [0.2] COMBINING GRAPHEME JOINER (Extend) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 034F × 0308 ÷ 1100 ÷	#  ÷ [0.2] COMBINING GRAPHEME JOINER (Extend) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 034F ÷ 1160 ÷	#  ÷ [0.2] COMBINING GRAPHEME JOINER (Extend) ÷ [999.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ 034F × 0308 ÷ 1160 ÷	#  ÷ [0.2] COMBINING GRAPHEME JOINER (Extend) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ 034F ÷ 11A8 ÷	#  ÷ [0.2] COMBINING GRAPHEME JOINER (Extend) ÷ [999.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ 034F × 0308 ÷ 11A8 ÷	#  ÷ [0.2] COMBINING GRAPHEME JOINER (Extend) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ 034F ÷ AC00 ÷	#  ÷ [0.2] COMBINING GRAPHEME JOINER (Extend) ÷ [999.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ 034F × 0308 ÷ AC00 ÷	#  ÷ [0.2] COMBINING GRAPHEME JOINER (Extend) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ 034F ÷ AC01 ÷	#  ÷ [0.2] COMBINING GRAPHEME JOINER (Extend) ÷ [999.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ 034F × 0308 ÷ AC01 ÷	#  ÷ [0.2] COMBINING GRAPHEME JOINER (Extend) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ 034F ÷ 231A ÷	#  ÷ [0.2] COMBINING GRAPHEME JOINER (Extend) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_GCB('÷ 034F × 0308 ÷ 231A ÷	#  ÷ [0.2] COMBINING GRAPHEME JOINER (Extend) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_GCB('÷ 034F × 0300 ÷	#  ÷ [0.2] COMBINING GRAPHEME JOINER (Extend) × [9.0] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 034F × 0308 × 0300 ÷	#  ÷ [0.2] COMBINING GRAPHEME JOINER (Extend) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 034F × 200D ÷	#  ÷ [0.2] COMBINING GRAPHEME JOINER (Extend) × [9.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 034F × 0308 × 200D ÷	#  ÷ [0.2] COMBINING GRAPHEME JOINER (Extend) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 034F ÷ 0378 ÷	#  ÷ [0.2] COMBINING GRAPHEME JOINER (Extend) ÷ [999.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ 034F × 0308 ÷ 0378 ÷	#  ÷ [0.2] COMBINING GRAPHEME JOINER (Extend) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 ÷ 0020 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 × 0308 ÷ 0020 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 ÷ 000D ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 × 0308 ÷ 000D ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 ÷ 000A ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 × 0308 ÷ 000A ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 ÷ 0001 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 × 0308 ÷ 0001 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 × 034F ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING GRAPHEME JOINER (Extend) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 × 0308 × 034F ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] COMBINING GRAPHEME JOINER (Extend) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 × 1F1E6 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [12.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 ÷ 0600 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 × 0308 ÷ 0600 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 × 0903 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 × 0308 × 0903 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 ÷ 1100 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 × 0308 ÷ 1100 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 ÷ 1160 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 × 0308 ÷ 1160 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 ÷ 11A8 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 × 0308 ÷ 11A8 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 ÷ AC00 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 × 0308 ÷ AC00 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 ÷ AC01 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 × 0308 ÷ AC01 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 ÷ 231A ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 × 0308 ÷ 231A ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 × 0300 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 × 0308 × 0300 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 × 200D ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 × 0308 × 200D ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 ÷ 0378 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 × 0308 ÷ 0378 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ 0600 × 0020 ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.2] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 0600 × 0308 ÷ 0020 ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 0600 ÷ 000D ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ 0600 × 0308 ÷ 000D ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ 0600 ÷ 000A ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ 0600 × 0308 ÷ 000A ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ 0600 ÷ 0001 ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ 0600 × 0308 ÷ 0001 ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ 0600 × 034F ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.0] COMBINING GRAPHEME JOINER (Extend) ÷ [0.3]');
    Test_GCB('÷ 0600 × 0308 × 034F ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] COMBINING GRAPHEME JOINER (Extend) ÷ [0.3]');
    Test_GCB('÷ 0600 × 1F1E6 ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ 0600 × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ 0600 × 0600 ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.2] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ 0600 × 0308 ÷ 0600 ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ 0600 × 0903 ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ 0600 × 0308 × 0903 ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ 0600 × 1100 ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.2] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 0600 × 0308 ÷ 1100 ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 0600 × 1160 ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.2] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ 0600 × 0308 ÷ 1160 ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ 0600 × 11A8 ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.2] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ 0600 × 0308 ÷ 11A8 ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ 0600 × AC00 ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.2] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ 0600 × 0308 ÷ AC00 ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ 0600 × AC01 ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.2] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ 0600 × 0308 ÷ AC01 ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ 0600 × 231A ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.2] WATCH (ExtPict) ÷ [0.3]');
    Test_GCB('÷ 0600 × 0308 ÷ 231A ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_GCB('÷ 0600 × 0300 ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.0] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 0600 × 0308 × 0300 ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 0600 × 200D ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 0600 × 0308 × 200D ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 0600 × 0378 ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.2] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ 0600 × 0308 ÷ 0378 ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ 0903 ÷ 0020 ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 0903 × 0308 ÷ 0020 ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 0903 ÷ 000D ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ 0903 × 0308 ÷ 000D ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ 0903 ÷ 000A ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ 0903 × 0308 ÷ 000A ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ 0903 ÷ 0001 ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ 0903 × 0308 ÷ 0001 ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ 0903 × 034F ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) × [9.0] COMBINING GRAPHEME JOINER (Extend) ÷ [0.3]');
    Test_GCB('÷ 0903 × 0308 × 034F ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] COMBINING GRAPHEME JOINER (Extend) ÷ [0.3]');
    Test_GCB('÷ 0903 ÷ 1F1E6 ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ 0903 × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ 0903 ÷ 0600 ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ 0903 × 0308 ÷ 0600 ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ 0903 × 0903 ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ 0903 × 0308 × 0903 ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ 0903 ÷ 1100 ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 0903 × 0308 ÷ 1100 ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 0903 ÷ 1160 ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [999.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ 0903 × 0308 ÷ 1160 ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ 0903 ÷ 11A8 ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [999.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ 0903 × 0308 ÷ 11A8 ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ 0903 ÷ AC00 ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [999.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ 0903 × 0308 ÷ AC00 ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ 0903 ÷ AC01 ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [999.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ 0903 × 0308 ÷ AC01 ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ 0903 ÷ 231A ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_GCB('÷ 0903 × 0308 ÷ 231A ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_GCB('÷ 0903 × 0300 ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) × [9.0] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 0903 × 0308 × 0300 ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 0903 × 200D ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) × [9.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 0903 × 0308 × 200D ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 0903 ÷ 0378 ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [999.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ 0903 × 0308 ÷ 0378 ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ 1100 ÷ 0020 ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 1100 × 0308 ÷ 0020 ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 1100 ÷ 000D ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ 1100 × 0308 ÷ 000D ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ 1100 ÷ 000A ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ 1100 × 0308 ÷ 000A ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ 1100 ÷ 0001 ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ 1100 × 0308 ÷ 0001 ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ 1100 × 034F ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) × [9.0] COMBINING GRAPHEME JOINER (Extend) ÷ [0.3]');
    Test_GCB('÷ 1100 × 0308 × 034F ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] COMBINING GRAPHEME JOINER (Extend) ÷ [0.3]');
    Test_GCB('÷ 1100 ÷ 1F1E6 ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ 1100 × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ 1100 ÷ 0600 ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ 1100 × 0308 ÷ 0600 ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ 1100 × 0903 ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ 1100 × 0308 × 0903 ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ 1100 × 1100 ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) × [6.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 1100 × 0308 ÷ 1100 ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 1100 × 1160 ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) × [6.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ 1100 × 0308 ÷ 1160 ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ 1100 ÷ 11A8 ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) ÷ [999.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ 1100 × 0308 ÷ 11A8 ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ 1100 × AC00 ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) × [6.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ 1100 × 0308 ÷ AC00 ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ 1100 × AC01 ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) × [6.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ 1100 × 0308 ÷ AC01 ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ 1100 ÷ 231A ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_GCB('÷ 1100 × 0308 ÷ 231A ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_GCB('÷ 1100 × 0300 ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) × [9.0] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 1100 × 0308 × 0300 ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 1100 × 200D ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) × [9.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 1100 × 0308 × 200D ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 1100 ÷ 0378 ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) ÷ [999.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ 1100 × 0308 ÷ 0378 ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ 1160 ÷ 0020 ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 1160 × 0308 ÷ 0020 ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 1160 ÷ 000D ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ 1160 × 0308 ÷ 000D ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ 1160 ÷ 000A ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ 1160 × 0308 ÷ 000A ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ 1160 ÷ 0001 ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ 1160 × 0308 ÷ 0001 ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ 1160 × 034F ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) × [9.0] COMBINING GRAPHEME JOINER (Extend) ÷ [0.3]');
    Test_GCB('÷ 1160 × 0308 × 034F ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] COMBINING GRAPHEME JOINER (Extend) ÷ [0.3]');
    Test_GCB('÷ 1160 ÷ 1F1E6 ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ 1160 × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ 1160 ÷ 0600 ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ 1160 × 0308 ÷ 0600 ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ 1160 × 0903 ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ 1160 × 0308 × 0903 ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ 1160 ÷ 1100 ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 1160 × 0308 ÷ 1100 ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 1160 × 1160 ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) × [7.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ 1160 × 0308 ÷ 1160 ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ 1160 × 11A8 ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) × [7.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ 1160 × 0308 ÷ 11A8 ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ 1160 ÷ AC00 ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) ÷ [999.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ 1160 × 0308 ÷ AC00 ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ 1160 ÷ AC01 ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) ÷ [999.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ 1160 × 0308 ÷ AC01 ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ 1160 ÷ 231A ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_GCB('÷ 1160 × 0308 ÷ 231A ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_GCB('÷ 1160 × 0300 ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) × [9.0] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 1160 × 0308 × 0300 ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 1160 × 200D ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) × [9.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 1160 × 0308 × 200D ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 1160 ÷ 0378 ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) ÷ [999.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ 1160 × 0308 ÷ 0378 ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ 11A8 ÷ 0020 ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 11A8 × 0308 ÷ 0020 ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 11A8 ÷ 000D ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ 11A8 × 0308 ÷ 000D ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ 11A8 ÷ 000A ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ 11A8 × 0308 ÷ 000A ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ 11A8 ÷ 0001 ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ 11A8 × 0308 ÷ 0001 ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ 11A8 × 034F ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) × [9.0] COMBINING GRAPHEME JOINER (Extend) ÷ [0.3]');
    Test_GCB('÷ 11A8 × 0308 × 034F ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] COMBINING GRAPHEME JOINER (Extend) ÷ [0.3]');
    Test_GCB('÷ 11A8 ÷ 1F1E6 ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ 11A8 × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ 11A8 ÷ 0600 ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ 11A8 × 0308 ÷ 0600 ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ 11A8 × 0903 ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ 11A8 × 0308 × 0903 ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ 11A8 ÷ 1100 ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 11A8 × 0308 ÷ 1100 ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 11A8 ÷ 1160 ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) ÷ [999.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ 11A8 × 0308 ÷ 1160 ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ 11A8 × 11A8 ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) × [8.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ 11A8 × 0308 ÷ 11A8 ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ 11A8 ÷ AC00 ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) ÷ [999.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ 11A8 × 0308 ÷ AC00 ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ 11A8 ÷ AC01 ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) ÷ [999.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ 11A8 × 0308 ÷ AC01 ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ 11A8 ÷ 231A ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_GCB('÷ 11A8 × 0308 ÷ 231A ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_GCB('÷ 11A8 × 0300 ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) × [9.0] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 11A8 × 0308 × 0300 ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 11A8 × 200D ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) × [9.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 11A8 × 0308 × 200D ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 11A8 ÷ 0378 ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) ÷ [999.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ 11A8 × 0308 ÷ 0378 ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ AC00 ÷ 0020 ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ AC00 × 0308 ÷ 0020 ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ AC00 ÷ 000D ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ AC00 × 0308 ÷ 000D ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ AC00 ÷ 000A ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ AC00 × 0308 ÷ 000A ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ AC00 ÷ 0001 ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ AC00 × 0308 ÷ 0001 ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ AC00 × 034F ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) × [9.0] COMBINING GRAPHEME JOINER (Extend) ÷ [0.3]');
    Test_GCB('÷ AC00 × 0308 × 034F ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] COMBINING GRAPHEME JOINER (Extend) ÷ [0.3]');
    Test_GCB('÷ AC00 ÷ 1F1E6 ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ AC00 × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ AC00 ÷ 0600 ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ AC00 × 0308 ÷ 0600 ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ AC00 × 0903 ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ AC00 × 0308 × 0903 ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ AC00 ÷ 1100 ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ AC00 × 0308 ÷ 1100 ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ AC00 × 1160 ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) × [7.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ AC00 × 0308 ÷ 1160 ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ AC00 × 11A8 ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) × [7.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ AC00 × 0308 ÷ 11A8 ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ AC00 ÷ AC00 ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) ÷ [999.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ AC00 × 0308 ÷ AC00 ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ AC00 ÷ AC01 ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) ÷ [999.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ AC00 × 0308 ÷ AC01 ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ AC00 ÷ 231A ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_GCB('÷ AC00 × 0308 ÷ 231A ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_GCB('÷ AC00 × 0300 ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) × [9.0] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ AC00 × 0308 × 0300 ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ AC00 × 200D ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) × [9.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ AC00 × 0308 × 200D ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ AC00 ÷ 0378 ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) ÷ [999.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ AC00 × 0308 ÷ 0378 ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ AC01 ÷ 0020 ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ AC01 × 0308 ÷ 0020 ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ AC01 ÷ 000D ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ AC01 × 0308 ÷ 000D ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ AC01 ÷ 000A ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ AC01 × 0308 ÷ 000A ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ AC01 ÷ 0001 ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ AC01 × 0308 ÷ 0001 ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ AC01 × 034F ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) × [9.0] COMBINING GRAPHEME JOINER (Extend) ÷ [0.3]');
    Test_GCB('÷ AC01 × 0308 × 034F ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] COMBINING GRAPHEME JOINER (Extend) ÷ [0.3]');
    Test_GCB('÷ AC01 ÷ 1F1E6 ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ AC01 × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ AC01 ÷ 0600 ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ AC01 × 0308 ÷ 0600 ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ AC01 × 0903 ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ AC01 × 0308 × 0903 ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ AC01 ÷ 1100 ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ AC01 × 0308 ÷ 1100 ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ AC01 ÷ 1160 ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) ÷ [999.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ AC01 × 0308 ÷ 1160 ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ AC01 × 11A8 ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) × [8.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ AC01 × 0308 ÷ 11A8 ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ AC01 ÷ AC00 ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) ÷ [999.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ AC01 × 0308 ÷ AC00 ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ AC01 ÷ AC01 ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) ÷ [999.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ AC01 × 0308 ÷ AC01 ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ AC01 ÷ 231A ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_GCB('÷ AC01 × 0308 ÷ 231A ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_GCB('÷ AC01 × 0300 ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) × [9.0] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ AC01 × 0308 × 0300 ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ AC01 × 200D ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) × [9.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ AC01 × 0308 × 200D ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ AC01 ÷ 0378 ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) ÷ [999.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ AC01 × 0308 ÷ 0378 ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ 231A ÷ 0020 ÷	#  ÷ [0.2] WATCH (ExtPict) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 231A × 0308 ÷ 0020 ÷	#  ÷ [0.2] WATCH (ExtPict) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 231A ÷ 000D ÷	#  ÷ [0.2] WATCH (ExtPict) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ 231A × 0308 ÷ 000D ÷	#  ÷ [0.2] WATCH (ExtPict) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ 231A ÷ 000A ÷	#  ÷ [0.2] WATCH (ExtPict) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ 231A × 0308 ÷ 000A ÷	#  ÷ [0.2] WATCH (ExtPict) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ 231A ÷ 0001 ÷	#  ÷ [0.2] WATCH (ExtPict) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ 231A × 0308 ÷ 0001 ÷	#  ÷ [0.2] WATCH (ExtPict) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ 231A × 034F ÷	#  ÷ [0.2] WATCH (ExtPict) × [9.0] COMBINING GRAPHEME JOINER (Extend) ÷ [0.3]');
    Test_GCB('÷ 231A × 0308 × 034F ÷	#  ÷ [0.2] WATCH (ExtPict) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] COMBINING GRAPHEME JOINER (Extend) ÷ [0.3]');
    Test_GCB('÷ 231A ÷ 1F1E6 ÷	#  ÷ [0.2] WATCH (ExtPict) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ 231A × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] WATCH (ExtPict) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ 231A ÷ 0600 ÷	#  ÷ [0.2] WATCH (ExtPict) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ 231A × 0308 ÷ 0600 ÷	#  ÷ [0.2] WATCH (ExtPict) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ 231A × 0903 ÷	#  ÷ [0.2] WATCH (ExtPict) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ 231A × 0308 × 0903 ÷	#  ÷ [0.2] WATCH (ExtPict) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ 231A ÷ 1100 ÷	#  ÷ [0.2] WATCH (ExtPict) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 231A × 0308 ÷ 1100 ÷	#  ÷ [0.2] WATCH (ExtPict) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 231A ÷ 1160 ÷	#  ÷ [0.2] WATCH (ExtPict) ÷ [999.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ 231A × 0308 ÷ 1160 ÷	#  ÷ [0.2] WATCH (ExtPict) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ 231A ÷ 11A8 ÷	#  ÷ [0.2] WATCH (ExtPict) ÷ [999.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ 231A × 0308 ÷ 11A8 ÷	#  ÷ [0.2] WATCH (ExtPict) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ 231A ÷ AC00 ÷	#  ÷ [0.2] WATCH (ExtPict) ÷ [999.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ 231A × 0308 ÷ AC00 ÷	#  ÷ [0.2] WATCH (ExtPict) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ 231A ÷ AC01 ÷	#  ÷ [0.2] WATCH (ExtPict) ÷ [999.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ 231A × 0308 ÷ AC01 ÷	#  ÷ [0.2] WATCH (ExtPict) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ 231A ÷ 231A ÷	#  ÷ [0.2] WATCH (ExtPict) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_GCB('÷ 231A × 0308 ÷ 231A ÷	#  ÷ [0.2] WATCH (ExtPict) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_GCB('÷ 231A × 0300 ÷	#  ÷ [0.2] WATCH (ExtPict) × [9.0] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 231A × 0308 × 0300 ÷	#  ÷ [0.2] WATCH (ExtPict) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 231A × 200D ÷	#  ÷ [0.2] WATCH (ExtPict) × [9.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 231A × 0308 × 200D ÷	#  ÷ [0.2] WATCH (ExtPict) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 231A ÷ 0378 ÷	#  ÷ [0.2] WATCH (ExtPict) ÷ [999.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ 231A × 0308 ÷ 0378 ÷	#  ÷ [0.2] WATCH (ExtPict) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ 0300 ÷ 0020 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 0300 × 0308 ÷ 0020 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 0300 ÷ 000D ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ 0300 × 0308 ÷ 000D ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ 0300 ÷ 000A ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ 0300 × 0308 ÷ 000A ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ 0300 ÷ 0001 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ 0300 × 0308 ÷ 0001 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ 0300 × 034F ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) × [9.0] COMBINING GRAPHEME JOINER (Extend) ÷ [0.3]');
    Test_GCB('÷ 0300 × 0308 × 034F ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] COMBINING GRAPHEME JOINER (Extend) ÷ [0.3]');
    Test_GCB('÷ 0300 ÷ 1F1E6 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ 0300 × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ 0300 ÷ 0600 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ 0300 × 0308 ÷ 0600 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ 0300 × 0903 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ 0300 × 0308 × 0903 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ 0300 ÷ 1100 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 0300 × 0308 ÷ 1100 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 0300 ÷ 1160 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [999.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ 0300 × 0308 ÷ 1160 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ 0300 ÷ 11A8 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [999.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ 0300 × 0308 ÷ 11A8 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ 0300 ÷ AC00 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [999.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ 0300 × 0308 ÷ AC00 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ 0300 ÷ AC01 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [999.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ 0300 × 0308 ÷ AC01 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ 0300 ÷ 231A ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_GCB('÷ 0300 × 0308 ÷ 231A ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_GCB('÷ 0300 × 0300 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) × [9.0] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 0300 × 0308 × 0300 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 0300 × 200D ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) × [9.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 0300 × 0308 × 200D ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 0300 ÷ 0378 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [999.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ 0300 × 0308 ÷ 0378 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ 200D ÷ 0020 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 200D × 0308 ÷ 0020 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 200D ÷ 000D ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ 200D × 0308 ÷ 000D ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ 200D ÷ 000A ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ 200D × 0308 ÷ 000A ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ 200D ÷ 0001 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ 200D × 0308 ÷ 0001 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ 200D × 034F ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) × [9.0] COMBINING GRAPHEME JOINER (Extend) ÷ [0.3]');
    Test_GCB('÷ 200D × 0308 × 034F ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] COMBINING GRAPHEME JOINER (Extend) ÷ [0.3]');
    Test_GCB('÷ 200D ÷ 1F1E6 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ 200D × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ 200D ÷ 0600 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ 200D × 0308 ÷ 0600 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ 200D × 0903 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ 200D × 0308 × 0903 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ 200D ÷ 1100 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 200D × 0308 ÷ 1100 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 200D ÷ 1160 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [999.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ 200D × 0308 ÷ 1160 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ 200D ÷ 11A8 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [999.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ 200D × 0308 ÷ 11A8 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ 200D ÷ AC00 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [999.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ 200D × 0308 ÷ AC00 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ 200D ÷ AC01 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [999.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ 200D × 0308 ÷ AC01 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ 200D ÷ 231A ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_GCB('÷ 200D × 0308 ÷ 231A ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_GCB('÷ 200D × 0300 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) × [9.0] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 200D × 0308 × 0300 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 200D × 200D ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) × [9.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 200D × 0308 × 200D ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 200D ÷ 0378 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [999.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ 200D × 0308 ÷ 0378 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ 0378 ÷ 0020 ÷	#  ÷ [0.2] <reserved-0378> (Other) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 0378 × 0308 ÷ 0020 ÷	#  ÷ [0.2] <reserved-0378> (Other) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 0378 ÷ 000D ÷	#  ÷ [0.2] <reserved-0378> (Other) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ 0378 × 0308 ÷ 000D ÷	#  ÷ [0.2] <reserved-0378> (Other) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ 0378 ÷ 000A ÷	#  ÷ [0.2] <reserved-0378> (Other) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ 0378 × 0308 ÷ 000A ÷	#  ÷ [0.2] <reserved-0378> (Other) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ 0378 ÷ 0001 ÷	#  ÷ [0.2] <reserved-0378> (Other) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ 0378 × 0308 ÷ 0001 ÷	#  ÷ [0.2] <reserved-0378> (Other) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ 0378 × 034F ÷	#  ÷ [0.2] <reserved-0378> (Other) × [9.0] COMBINING GRAPHEME JOINER (Extend) ÷ [0.3]');
    Test_GCB('÷ 0378 × 0308 × 034F ÷	#  ÷ [0.2] <reserved-0378> (Other) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] COMBINING GRAPHEME JOINER (Extend) ÷ [0.3]');
    Test_GCB('÷ 0378 ÷ 1F1E6 ÷	#  ÷ [0.2] <reserved-0378> (Other) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ 0378 × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] <reserved-0378> (Other) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ 0378 ÷ 0600 ÷	#  ÷ [0.2] <reserved-0378> (Other) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ 0378 × 0308 ÷ 0600 ÷	#  ÷ [0.2] <reserved-0378> (Other) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ 0378 × 0903 ÷	#  ÷ [0.2] <reserved-0378> (Other) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ 0378 × 0308 × 0903 ÷	#  ÷ [0.2] <reserved-0378> (Other) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ 0378 ÷ 1100 ÷	#  ÷ [0.2] <reserved-0378> (Other) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 0378 × 0308 ÷ 1100 ÷	#  ÷ [0.2] <reserved-0378> (Other) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 0378 ÷ 1160 ÷	#  ÷ [0.2] <reserved-0378> (Other) ÷ [999.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ 0378 × 0308 ÷ 1160 ÷	#  ÷ [0.2] <reserved-0378> (Other) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ 0378 ÷ 11A8 ÷	#  ÷ [0.2] <reserved-0378> (Other) ÷ [999.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ 0378 × 0308 ÷ 11A8 ÷	#  ÷ [0.2] <reserved-0378> (Other) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ 0378 ÷ AC00 ÷	#  ÷ [0.2] <reserved-0378> (Other) ÷ [999.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ 0378 × 0308 ÷ AC00 ÷	#  ÷ [0.2] <reserved-0378> (Other) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ 0378 ÷ AC01 ÷	#  ÷ [0.2] <reserved-0378> (Other) ÷ [999.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ 0378 × 0308 ÷ AC01 ÷	#  ÷ [0.2] <reserved-0378> (Other) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ 0378 ÷ 231A ÷	#  ÷ [0.2] <reserved-0378> (Other) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_GCB('÷ 0378 × 0308 ÷ 231A ÷	#  ÷ [0.2] <reserved-0378> (Other) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_GCB('÷ 0378 × 0300 ÷	#  ÷ [0.2] <reserved-0378> (Other) × [9.0] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 0378 × 0308 × 0300 ÷	#  ÷ [0.2] <reserved-0378> (Other) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 0378 × 200D ÷	#  ÷ [0.2] <reserved-0378> (Other) × [9.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 0378 × 0308 × 200D ÷	#  ÷ [0.2] <reserved-0378> (Other) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 0378 ÷ 0378 ÷	#  ÷ [0.2] <reserved-0378> (Other) ÷ [999.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ 0378 × 0308 ÷ 0378 ÷	#  ÷ [0.2] <reserved-0378> (Other) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ 000D × 000A ÷ 0061 ÷ 000A ÷ 0308 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) × [3.0] <LINE FEED (LF)> (LF) ÷ [4.0] LATIN SMALL LETTER A (Other) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 0061 × 0308 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Other) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 0020 × 200D ÷ 0646 ÷	#  ÷ [0.2] SPACE (Other) × [9.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [999.0] ARABIC LETTER NOON (Other) ÷ [0.3]');
    Test_GCB('÷ 0646 × 200D ÷ 0020 ÷	#  ÷ [0.2] ARABIC LETTER NOON (Other) × [9.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 1100 × 1100 ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) × [6.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ AC00 × 11A8 ÷ 1100 ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) × [7.0] HANGUL JONGSEONG KIYEOK (T) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ AC01 × 11A8 ÷ 1100 ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) × [8.0] HANGUL JONGSEONG KIYEOK (T) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 × 1F1E7 ÷ 1F1E8 ÷ 0062 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [12.0] REGIONAL INDICATOR SYMBOL LETTER B (RI) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER C (RI) ÷ [999.0] LATIN SMALL LETTER B (Other) ÷ [0.3]');
    Test_GCB('÷ 0061 ÷ 1F1E6 × 1F1E7 ÷ 1F1E8 ÷ 0062 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Other) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [13.0] REGIONAL INDICATOR SYMBOL LETTER B (RI) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER C (RI) ÷ [999.0] LATIN SMALL LETTER B (Other) ÷ [0.3]');
    Test_GCB('÷ 0061 ÷ 1F1E6 × 1F1E7 × 200D ÷ 1F1E8 ÷ 0062 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Other) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [13.0] REGIONAL INDICATOR SYMBOL LETTER B (RI) × [9.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER C (RI) ÷ [999.0] LATIN SMALL LETTER B (Other) ÷ [0.3]');
    Test_GCB('÷ 0061 ÷ 1F1E6 × 200D ÷ 1F1E7 × 1F1E8 ÷ 0062 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Other) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER B (RI) × [13.0] REGIONAL INDICATOR SYMBOL LETTER C (RI) ÷ [999.0] LATIN SMALL LETTER B (Other) ÷ [0.3]');
    Test_GCB('÷ 0061 ÷ 1F1E6 × 1F1E7 ÷ 1F1E8 × 1F1E9 ÷ 0062 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Other) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [13.0] REGIONAL INDICATOR SYMBOL LETTER B (RI) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER C (RI) × [13.0] REGIONAL INDICATOR SYMBOL LETTER D (RI) ÷ [999.0] LATIN SMALL LETTER B (Other) ÷ [0.3]');
    Test_GCB('÷ 0061 × 200D ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Other) × [9.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 0061 × 0308 ÷ 0062 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Other) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] LATIN SMALL LETTER B (Other) ÷ [0.3]');
    Test_GCB('÷ 0061 × 0903 ÷ 0062 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Other) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [999.0] LATIN SMALL LETTER B (Other) ÷ [0.3]');
    Test_GCB('÷ 0061 ÷ 0600 × 0062 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Other) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) × [9.2] LATIN SMALL LETTER B (Other) ÷ [0.3]');
    Test_GCB('÷ 1F476 × 1F3FF ÷ 1F476 ÷	#  ÷ [0.2] BABY (ExtPict) × [9.0] EMOJI MODIFIER FITZPATRICK TYPE-6 (Extend) ÷ [999.0] BABY (ExtPict) ÷ [0.3]');
    Test_GCB('÷ 0061 × 1F3FF ÷ 1F476 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Other) × [9.0] EMOJI MODIFIER FITZPATRICK TYPE-6 (Extend) ÷ [999.0] BABY (ExtPict) ÷ [0.3]');
    Test_GCB('÷ 0061 × 1F3FF ÷ 1F476 × 200D × 1F6D1 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Other) × [9.0] EMOJI MODIFIER FITZPATRICK TYPE-6 (Extend) ÷ [999.0] BABY (ExtPict) × [9.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) × [11.0] OCTAGONAL SIGN (ExtPict) ÷ [0.3]');
    Test_GCB('÷ 1F476 × 1F3FF × 0308 × 200D × 1F476 × 1F3FF ÷	#  ÷ [0.2] BABY (ExtPict) × [9.0] EMOJI MODIFIER FITZPATRICK TYPE-6 (Extend) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) × [11.0] BABY (ExtPict) × [9.0] EMOJI MODIFIER FITZPATRICK TYPE-6 (Extend) ÷ [0.3]');
    Test_GCB('÷ 1F6D1 × 200D × 1F6D1 ÷	#  ÷ [0.2] OCTAGONAL SIGN (ExtPict) × [9.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) × [11.0] OCTAGONAL SIGN (ExtPict) ÷ [0.3]');
    Test_GCB('÷ 0061 × 200D ÷ 1F6D1 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Other) × [9.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [999.0] OCTAGONAL SIGN (ExtPict) ÷ [0.3]');
    Test_GCB('÷ 2701 × 200D × 2701 ÷	#  ÷ [0.2] UPPER BLADE SCISSORS (Other) × [9.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) × [11.0] UPPER BLADE SCISSORS (Other) ÷ [0.3]');
    Test_GCB('÷ 0061 × 200D ÷ 2701 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Other) × [9.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [999.0] UPPER BLADE SCISSORS (Other) ÷ [0.3]');
    Test_SB('÷ 0001 × 0001 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [998.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_SB('÷ 0001 × 0308 × 0001 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_SB('÷ 0001 × 000D ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [998.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_SB('÷ 0001 × 0308 × 000D ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_SB('÷ 0001 × 000A ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [998.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_SB('÷ 0001 × 0308 × 000A ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_SB('÷ 0001 × 0085 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [998.0] <NEXT LINE (NEL)> (Sep) ÷ [0.3]');
    Test_SB('÷ 0001 × 0308 × 0085 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <NEXT LINE (NEL)> (Sep) ÷ [0.3]');
    Test_SB('÷ 0001 × 0009 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [998.0] <CHARACTER TABULATION> (Sp) ÷ [0.3]');
    Test_SB('÷ 0001 × 0308 × 0009 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <CHARACTER TABULATION> (Sp) ÷ [0.3]');
    Test_SB('÷ 0001 × 0061 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [998.0] LATIN SMALL LETTER A (Lower) ÷ [0.3]');
    Test_SB('÷ 0001 × 0308 × 0061 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN SMALL LETTER A (Lower) ÷ [0.3]');
    Test_SB('÷ 0001 × 0041 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [998.0] LATIN CAPITAL LETTER A (Upper) ÷ [0.3]');
    Test_SB('÷ 0001 × 0308 × 0041 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN CAPITAL LETTER A (Upper) ÷ [0.3]');
    Test_SB('÷ 0001 × 01BB ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [998.0] LATIN LETTER TWO WITH STROKE (OLetter) ÷ [0.3]');
    Test_SB('÷ 0001 × 0308 × 01BB ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN LETTER TWO WITH STROKE (OLetter) ÷ [0.3]');
    Test_SB('÷ 0001 × 0030 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [998.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_SB('÷ 0001 × 0308 × 0030 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_SB('÷ 0001 × 002E ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [998.0] FULL STOP (ATerm) ÷ [0.3]');
    Test_SB('÷ 0001 × 0308 × 002E ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] FULL STOP (ATerm) ÷ [0.3]');
    Test_SB('÷ 0001 × 0021 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [998.0] EXCLAMATION MARK (STerm) ÷ [0.3]');
    Test_SB('÷ 0001 × 0308 × 0021 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] EXCLAMATION MARK (STerm) ÷ [0.3]');
    Test_SB('÷ 0001 × 0022 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [998.0] QUOTATION MARK (Close) ÷ [0.3]');
    Test_SB('÷ 0001 × 0308 × 0022 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] QUOTATION MARK (Close) ÷ [0.3]');
    Test_SB('÷ 0001 × 002C ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [998.0] COMMA (SContinue) ÷ [0.3]');
    Test_SB('÷ 0001 × 0308 × 002C ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] COMMA (SContinue) ÷ [0.3]');
    Test_SB('÷ 0001 × 00AD ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [5.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_SB('÷ 0001 × 0308 × 00AD ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [5.0] COMBINING DIAERESIS (Extend_FE) × [5.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_SB('÷ 0001 × 0300 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 0001 × 0308 × 0300 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [5.0] COMBINING DIAERESIS (Extend_FE) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 000D ÷ 0001 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_SB('÷ 000D ÷ 0308 × 0001 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_SB('÷ 000D ÷ 000D ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_SB('÷ 000D ÷ 0308 × 000D ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_SB('÷ 000D × 000A ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) × [3.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_SB('÷ 000D ÷ 0308 × 000A ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_SB('÷ 000D ÷ 0085 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] <NEXT LINE (NEL)> (Sep) ÷ [0.3]');
    Test_SB('÷ 000D ÷ 0308 × 0085 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <NEXT LINE (NEL)> (Sep) ÷ [0.3]');
    Test_SB('÷ 000D ÷ 0009 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] <CHARACTER TABULATION> (Sp) ÷ [0.3]');
    Test_SB('÷ 000D ÷ 0308 × 0009 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <CHARACTER TABULATION> (Sp) ÷ [0.3]');
    Test_SB('÷ 000D ÷ 0061 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] LATIN SMALL LETTER A (Lower) ÷ [0.3]');
    Test_SB('÷ 000D ÷ 0308 × 0061 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN SMALL LETTER A (Lower) ÷ [0.3]');
    Test_SB('÷ 000D ÷ 0041 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] LATIN CAPITAL LETTER A (Upper) ÷ [0.3]');
    Test_SB('÷ 000D ÷ 0308 × 0041 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN CAPITAL LETTER A (Upper) ÷ [0.3]');
    Test_SB('÷ 000D ÷ 01BB ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] LATIN LETTER TWO WITH STROKE (OLetter) ÷ [0.3]');
    Test_SB('÷ 000D ÷ 0308 × 01BB ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN LETTER TWO WITH STROKE (OLetter) ÷ [0.3]');
    Test_SB('÷ 000D ÷ 0030 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_SB('÷ 000D ÷ 0308 × 0030 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_SB('÷ 000D ÷ 002E ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] FULL STOP (ATerm) ÷ [0.3]');
    Test_SB('÷ 000D ÷ 0308 × 002E ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] FULL STOP (ATerm) ÷ [0.3]');
    Test_SB('÷ 000D ÷ 0021 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] EXCLAMATION MARK (STerm) ÷ [0.3]');
    Test_SB('÷ 000D ÷ 0308 × 0021 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] EXCLAMATION MARK (STerm) ÷ [0.3]');
    Test_SB('÷ 000D ÷ 0022 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] QUOTATION MARK (Close) ÷ [0.3]');
    Test_SB('÷ 000D ÷ 0308 × 0022 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] QUOTATION MARK (Close) ÷ [0.3]');
    Test_SB('÷ 000D ÷ 002C ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMMA (SContinue) ÷ [0.3]');
    Test_SB('÷ 000D ÷ 0308 × 002C ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] COMMA (SContinue) ÷ [0.3]');
    Test_SB('÷ 000D ÷ 00AD ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_SB('÷ 000D ÷ 0308 × 00AD ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [5.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_SB('÷ 000D ÷ 0300 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 000D ÷ 0308 × 0300 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 000A ÷ 0001 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_SB('÷ 000A ÷ 0308 × 0001 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_SB('÷ 000A ÷ 000D ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_SB('÷ 000A ÷ 0308 × 000D ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_SB('÷ 000A ÷ 000A ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_SB('÷ 000A ÷ 0308 × 000A ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_SB('÷ 000A ÷ 0085 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] <NEXT LINE (NEL)> (Sep) ÷ [0.3]');
    Test_SB('÷ 000A ÷ 0308 × 0085 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <NEXT LINE (NEL)> (Sep) ÷ [0.3]');
    Test_SB('÷ 000A ÷ 0009 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] <CHARACTER TABULATION> (Sp) ÷ [0.3]');
    Test_SB('÷ 000A ÷ 0308 × 0009 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <CHARACTER TABULATION> (Sp) ÷ [0.3]');
    Test_SB('÷ 000A ÷ 0061 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] LATIN SMALL LETTER A (Lower) ÷ [0.3]');
    Test_SB('÷ 000A ÷ 0308 × 0061 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN SMALL LETTER A (Lower) ÷ [0.3]');
    Test_SB('÷ 000A ÷ 0041 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] LATIN CAPITAL LETTER A (Upper) ÷ [0.3]');
    Test_SB('÷ 000A ÷ 0308 × 0041 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN CAPITAL LETTER A (Upper) ÷ [0.3]');
    Test_SB('÷ 000A ÷ 01BB ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] LATIN LETTER TWO WITH STROKE (OLetter) ÷ [0.3]');
    Test_SB('÷ 000A ÷ 0308 × 01BB ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN LETTER TWO WITH STROKE (OLetter) ÷ [0.3]');
    Test_SB('÷ 000A ÷ 0030 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_SB('÷ 000A ÷ 0308 × 0030 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_SB('÷ 000A ÷ 002E ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] FULL STOP (ATerm) ÷ [0.3]');
    Test_SB('÷ 000A ÷ 0308 × 002E ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] FULL STOP (ATerm) ÷ [0.3]');
    Test_SB('÷ 000A ÷ 0021 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] EXCLAMATION MARK (STerm) ÷ [0.3]');
    Test_SB('÷ 000A ÷ 0308 × 0021 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] EXCLAMATION MARK (STerm) ÷ [0.3]');
    Test_SB('÷ 000A ÷ 0022 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] QUOTATION MARK (Close) ÷ [0.3]');
    Test_SB('÷ 000A ÷ 0308 × 0022 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] QUOTATION MARK (Close) ÷ [0.3]');
    Test_SB('÷ 000A ÷ 002C ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMMA (SContinue) ÷ [0.3]');
    Test_SB('÷ 000A ÷ 0308 × 002C ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] COMMA (SContinue) ÷ [0.3]');
    Test_SB('÷ 000A ÷ 00AD ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_SB('÷ 000A ÷ 0308 × 00AD ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [5.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_SB('÷ 000A ÷ 0300 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 000A ÷ 0308 × 0300 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 0085 ÷ 0001 ÷	#  ÷ [0.2] <NEXT LINE (NEL)> (Sep) ÷ [4.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_SB('÷ 0085 ÷ 0308 × 0001 ÷	#  ÷ [0.2] <NEXT LINE (NEL)> (Sep) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_SB('÷ 0085 ÷ 000D ÷	#  ÷ [0.2] <NEXT LINE (NEL)> (Sep) ÷ [4.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_SB('÷ 0085 ÷ 0308 × 000D ÷	#  ÷ [0.2] <NEXT LINE (NEL)> (Sep) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_SB('÷ 0085 ÷ 000A ÷	#  ÷ [0.2] <NEXT LINE (NEL)> (Sep) ÷ [4.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_SB('÷ 0085 ÷ 0308 × 000A ÷	#  ÷ [0.2] <NEXT LINE (NEL)> (Sep) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_SB('÷ 0085 ÷ 0085 ÷	#  ÷ [0.2] <NEXT LINE (NEL)> (Sep) ÷ [4.0] <NEXT LINE (NEL)> (Sep) ÷ [0.3]');
    Test_SB('÷ 0085 ÷ 0308 × 0085 ÷	#  ÷ [0.2] <NEXT LINE (NEL)> (Sep) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <NEXT LINE (NEL)> (Sep) ÷ [0.3]');
    Test_SB('÷ 0085 ÷ 0009 ÷	#  ÷ [0.2] <NEXT LINE (NEL)> (Sep) ÷ [4.0] <CHARACTER TABULATION> (Sp) ÷ [0.3]');
    Test_SB('÷ 0085 ÷ 0308 × 0009 ÷	#  ÷ [0.2] <NEXT LINE (NEL)> (Sep) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <CHARACTER TABULATION> (Sp) ÷ [0.3]');
    Test_SB('÷ 0085 ÷ 0061 ÷	#  ÷ [0.2] <NEXT LINE (NEL)> (Sep) ÷ [4.0] LATIN SMALL LETTER A (Lower) ÷ [0.3]');
    Test_SB('÷ 0085 ÷ 0308 × 0061 ÷	#  ÷ [0.2] <NEXT LINE (NEL)> (Sep) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN SMALL LETTER A (Lower) ÷ [0.3]');
    Test_SB('÷ 0085 ÷ 0041 ÷	#  ÷ [0.2] <NEXT LINE (NEL)> (Sep) ÷ [4.0] LATIN CAPITAL LETTER A (Upper) ÷ [0.3]');
    Test_SB('÷ 0085 ÷ 0308 × 0041 ÷	#  ÷ [0.2] <NEXT LINE (NEL)> (Sep) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN CAPITAL LETTER A (Upper) ÷ [0.3]');
    Test_SB('÷ 0085 ÷ 01BB ÷	#  ÷ [0.2] <NEXT LINE (NEL)> (Sep) ÷ [4.0] LATIN LETTER TWO WITH STROKE (OLetter) ÷ [0.3]');
    Test_SB('÷ 0085 ÷ 0308 × 01BB ÷	#  ÷ [0.2] <NEXT LINE (NEL)> (Sep) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN LETTER TWO WITH STROKE (OLetter) ÷ [0.3]');
    Test_SB('÷ 0085 ÷ 0030 ÷	#  ÷ [0.2] <NEXT LINE (NEL)> (Sep) ÷ [4.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_SB('÷ 0085 ÷ 0308 × 0030 ÷	#  ÷ [0.2] <NEXT LINE (NEL)> (Sep) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_SB('÷ 0085 ÷ 002E ÷	#  ÷ [0.2] <NEXT LINE (NEL)> (Sep) ÷ [4.0] FULL STOP (ATerm) ÷ [0.3]');
    Test_SB('÷ 0085 ÷ 0308 × 002E ÷	#  ÷ [0.2] <NEXT LINE (NEL)> (Sep) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] FULL STOP (ATerm) ÷ [0.3]');
    Test_SB('÷ 0085 ÷ 0021 ÷	#  ÷ [0.2] <NEXT LINE (NEL)> (Sep) ÷ [4.0] EXCLAMATION MARK (STerm) ÷ [0.3]');
    Test_SB('÷ 0085 ÷ 0308 × 0021 ÷	#  ÷ [0.2] <NEXT LINE (NEL)> (Sep) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] EXCLAMATION MARK (STerm) ÷ [0.3]');
    Test_SB('÷ 0085 ÷ 0022 ÷	#  ÷ [0.2] <NEXT LINE (NEL)> (Sep) ÷ [4.0] QUOTATION MARK (Close) ÷ [0.3]');
    Test_SB('÷ 0085 ÷ 0308 × 0022 ÷	#  ÷ [0.2] <NEXT LINE (NEL)> (Sep) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] QUOTATION MARK (Close) ÷ [0.3]');
    Test_SB('÷ 0085 ÷ 002C ÷	#  ÷ [0.2] <NEXT LINE (NEL)> (Sep) ÷ [4.0] COMMA (SContinue) ÷ [0.3]');
    Test_SB('÷ 0085 ÷ 0308 × 002C ÷	#  ÷ [0.2] <NEXT LINE (NEL)> (Sep) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] COMMA (SContinue) ÷ [0.3]');
    Test_SB('÷ 0085 ÷ 00AD ÷	#  ÷ [0.2] <NEXT LINE (NEL)> (Sep) ÷ [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_SB('÷ 0085 ÷ 0308 × 00AD ÷	#  ÷ [0.2] <NEXT LINE (NEL)> (Sep) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [5.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_SB('÷ 0085 ÷ 0300 ÷	#  ÷ [0.2] <NEXT LINE (NEL)> (Sep) ÷ [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 0085 ÷ 0308 × 0300 ÷	#  ÷ [0.2] <NEXT LINE (NEL)> (Sep) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 0009 × 0001 ÷	#  ÷ [0.2] <CHARACTER TABULATION> (Sp) × [998.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_SB('÷ 0009 × 0308 × 0001 ÷	#  ÷ [0.2] <CHARACTER TABULATION> (Sp) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_SB('÷ 0009 × 000D ÷	#  ÷ [0.2] <CHARACTER TABULATION> (Sp) × [998.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_SB('÷ 0009 × 0308 × 000D ÷	#  ÷ [0.2] <CHARACTER TABULATION> (Sp) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_SB('÷ 0009 × 000A ÷	#  ÷ [0.2] <CHARACTER TABULATION> (Sp) × [998.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_SB('÷ 0009 × 0308 × 000A ÷	#  ÷ [0.2] <CHARACTER TABULATION> (Sp) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_SB('÷ 0009 × 0085 ÷	#  ÷ [0.2] <CHARACTER TABULATION> (Sp) × [998.0] <NEXT LINE (NEL)> (Sep) ÷ [0.3]');
    Test_SB('÷ 0009 × 0308 × 0085 ÷	#  ÷ [0.2] <CHARACTER TABULATION> (Sp) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <NEXT LINE (NEL)> (Sep) ÷ [0.3]');
    Test_SB('÷ 0009 × 0009 ÷	#  ÷ [0.2] <CHARACTER TABULATION> (Sp) × [998.0] <CHARACTER TABULATION> (Sp) ÷ [0.3]');
    Test_SB('÷ 0009 × 0308 × 0009 ÷	#  ÷ [0.2] <CHARACTER TABULATION> (Sp) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <CHARACTER TABULATION> (Sp) ÷ [0.3]');
    Test_SB('÷ 0009 × 0061 ÷	#  ÷ [0.2] <CHARACTER TABULATION> (Sp) × [998.0] LATIN SMALL LETTER A (Lower) ÷ [0.3]');
    Test_SB('÷ 0009 × 0308 × 0061 ÷	#  ÷ [0.2] <CHARACTER TABULATION> (Sp) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN SMALL LETTER A (Lower) ÷ [0.3]');
    Test_SB('÷ 0009 × 0041 ÷	#  ÷ [0.2] <CHARACTER TABULATION> (Sp) × [998.0] LATIN CAPITAL LETTER A (Upper) ÷ [0.3]');
    Test_SB('÷ 0009 × 0308 × 0041 ÷	#  ÷ [0.2] <CHARACTER TABULATION> (Sp) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN CAPITAL LETTER A (Upper) ÷ [0.3]');
    Test_SB('÷ 0009 × 01BB ÷	#  ÷ [0.2] <CHARACTER TABULATION> (Sp) × [998.0] LATIN LETTER TWO WITH STROKE (OLetter) ÷ [0.3]');
    Test_SB('÷ 0009 × 0308 × 01BB ÷	#  ÷ [0.2] <CHARACTER TABULATION> (Sp) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN LETTER TWO WITH STROKE (OLetter) ÷ [0.3]');
    Test_SB('÷ 0009 × 0030 ÷	#  ÷ [0.2] <CHARACTER TABULATION> (Sp) × [998.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_SB('÷ 0009 × 0308 × 0030 ÷	#  ÷ [0.2] <CHARACTER TABULATION> (Sp) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_SB('÷ 0009 × 002E ÷	#  ÷ [0.2] <CHARACTER TABULATION> (Sp) × [998.0] FULL STOP (ATerm) ÷ [0.3]');
    Test_SB('÷ 0009 × 0308 × 002E ÷	#  ÷ [0.2] <CHARACTER TABULATION> (Sp) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] FULL STOP (ATerm) ÷ [0.3]');
    Test_SB('÷ 0009 × 0021 ÷	#  ÷ [0.2] <CHARACTER TABULATION> (Sp) × [998.0] EXCLAMATION MARK (STerm) ÷ [0.3]');
    Test_SB('÷ 0009 × 0308 × 0021 ÷	#  ÷ [0.2] <CHARACTER TABULATION> (Sp) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] EXCLAMATION MARK (STerm) ÷ [0.3]');
    Test_SB('÷ 0009 × 0022 ÷	#  ÷ [0.2] <CHARACTER TABULATION> (Sp) × [998.0] QUOTATION MARK (Close) ÷ [0.3]');
    Test_SB('÷ 0009 × 0308 × 0022 ÷	#  ÷ [0.2] <CHARACTER TABULATION> (Sp) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] QUOTATION MARK (Close) ÷ [0.3]');
    Test_SB('÷ 0009 × 002C ÷	#  ÷ [0.2] <CHARACTER TABULATION> (Sp) × [998.0] COMMA (SContinue) ÷ [0.3]');
    Test_SB('÷ 0009 × 0308 × 002C ÷	#  ÷ [0.2] <CHARACTER TABULATION> (Sp) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] COMMA (SContinue) ÷ [0.3]');
    Test_SB('÷ 0009 × 00AD ÷	#  ÷ [0.2] <CHARACTER TABULATION> (Sp) × [5.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_SB('÷ 0009 × 0308 × 00AD ÷	#  ÷ [0.2] <CHARACTER TABULATION> (Sp) × [5.0] COMBINING DIAERESIS (Extend_FE) × [5.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_SB('÷ 0009 × 0300 ÷	#  ÷ [0.2] <CHARACTER TABULATION> (Sp) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 0009 × 0308 × 0300 ÷	#  ÷ [0.2] <CHARACTER TABULATION> (Sp) × [5.0] COMBINING DIAERESIS (Extend_FE) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 0061 × 0001 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Lower) × [998.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_SB('÷ 0061 × 0308 × 0001 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Lower) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_SB('÷ 0061 × 000D ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Lower) × [998.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_SB('÷ 0061 × 0308 × 000D ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Lower) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_SB('÷ 0061 × 000A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Lower) × [998.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_SB('÷ 0061 × 0308 × 000A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Lower) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_SB('÷ 0061 × 0085 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Lower) × [998.0] <NEXT LINE (NEL)> (Sep) ÷ [0.3]');
    Test_SB('÷ 0061 × 0308 × 0085 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Lower) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <NEXT LINE (NEL)> (Sep) ÷ [0.3]');
    Test_SB('÷ 0061 × 0009 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Lower) × [998.0] <CHARACTER TABULATION> (Sp) ÷ [0.3]');
    Test_SB('÷ 0061 × 0308 × 0009 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Lower) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <CHARACTER TABULATION> (Sp) ÷ [0.3]');
    Test_SB('÷ 0061 × 0061 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Lower) × [998.0] LATIN SMALL LETTER A (Lower) ÷ [0.3]');
    Test_SB('÷ 0061 × 0308 × 0061 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Lower) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN SMALL LETTER A (Lower) ÷ [0.3]');
    Test_SB('÷ 0061 × 0041 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Lower) × [998.0] LATIN CAPITAL LETTER A (Upper) ÷ [0.3]');
    Test_SB('÷ 0061 × 0308 × 0041 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Lower) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN CAPITAL LETTER A (Upper) ÷ [0.3]');
    Test_SB('÷ 0061 × 01BB ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Lower) × [998.0] LATIN LETTER TWO WITH STROKE (OLetter) ÷ [0.3]');
    Test_SB('÷ 0061 × 0308 × 01BB ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Lower) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN LETTER TWO WITH STROKE (OLetter) ÷ [0.3]');
    Test_SB('÷ 0061 × 0030 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Lower) × [998.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_SB('÷ 0061 × 0308 × 0030 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Lower) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_SB('÷ 0061 × 002E ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Lower) × [998.0] FULL STOP (ATerm) ÷ [0.3]');
    Test_SB('÷ 0061 × 0308 × 002E ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Lower) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] FULL STOP (ATerm) ÷ [0.3]');
    Test_SB('÷ 0061 × 0021 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Lower) × [998.0] EXCLAMATION MARK (STerm) ÷ [0.3]');
    Test_SB('÷ 0061 × 0308 × 0021 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Lower) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] EXCLAMATION MARK (STerm) ÷ [0.3]');
    Test_SB('÷ 0061 × 0022 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Lower) × [998.0] QUOTATION MARK (Close) ÷ [0.3]');
    Test_SB('÷ 0061 × 0308 × 0022 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Lower) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] QUOTATION MARK (Close) ÷ [0.3]');
    Test_SB('÷ 0061 × 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Lower) × [998.0] COMMA (SContinue) ÷ [0.3]');
    Test_SB('÷ 0061 × 0308 × 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Lower) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] COMMA (SContinue) ÷ [0.3]');
    Test_SB('÷ 0061 × 00AD ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Lower) × [5.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_SB('÷ 0061 × 0308 × 00AD ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Lower) × [5.0] COMBINING DIAERESIS (Extend_FE) × [5.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_SB('÷ 0061 × 0300 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Lower) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 0061 × 0308 × 0300 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Lower) × [5.0] COMBINING DIAERESIS (Extend_FE) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 0041 × 0001 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (Upper) × [998.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_SB('÷ 0041 × 0308 × 0001 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (Upper) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_SB('÷ 0041 × 000D ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (Upper) × [998.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_SB('÷ 0041 × 0308 × 000D ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (Upper) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_SB('÷ 0041 × 000A ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (Upper) × [998.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_SB('÷ 0041 × 0308 × 000A ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (Upper) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_SB('÷ 0041 × 0085 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (Upper) × [998.0] <NEXT LINE (NEL)> (Sep) ÷ [0.3]');
    Test_SB('÷ 0041 × 0308 × 0085 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (Upper) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <NEXT LINE (NEL)> (Sep) ÷ [0.3]');
    Test_SB('÷ 0041 × 0009 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (Upper) × [998.0] <CHARACTER TABULATION> (Sp) ÷ [0.3]');
    Test_SB('÷ 0041 × 0308 × 0009 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (Upper) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <CHARACTER TABULATION> (Sp) ÷ [0.3]');
    Test_SB('÷ 0041 × 0061 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (Upper) × [998.0] LATIN SMALL LETTER A (Lower) ÷ [0.3]');
    Test_SB('÷ 0041 × 0308 × 0061 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (Upper) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN SMALL LETTER A (Lower) ÷ [0.3]');
    Test_SB('÷ 0041 × 0041 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (Upper) × [998.0] LATIN CAPITAL LETTER A (Upper) ÷ [0.3]');
    Test_SB('÷ 0041 × 0308 × 0041 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (Upper) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN CAPITAL LETTER A (Upper) ÷ [0.3]');
    Test_SB('÷ 0041 × 01BB ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (Upper) × [998.0] LATIN LETTER TWO WITH STROKE (OLetter) ÷ [0.3]');
    Test_SB('÷ 0041 × 0308 × 01BB ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (Upper) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN LETTER TWO WITH STROKE (OLetter) ÷ [0.3]');
    Test_SB('÷ 0041 × 0030 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (Upper) × [998.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_SB('÷ 0041 × 0308 × 0030 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (Upper) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_SB('÷ 0041 × 002E ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (Upper) × [998.0] FULL STOP (ATerm) ÷ [0.3]');
    Test_SB('÷ 0041 × 0308 × 002E ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (Upper) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] FULL STOP (ATerm) ÷ [0.3]');
    Test_SB('÷ 0041 × 0021 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (Upper) × [998.0] EXCLAMATION MARK (STerm) ÷ [0.3]');
    Test_SB('÷ 0041 × 0308 × 0021 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (Upper) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] EXCLAMATION MARK (STerm) ÷ [0.3]');
    Test_SB('÷ 0041 × 0022 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (Upper) × [998.0] QUOTATION MARK (Close) ÷ [0.3]');
    Test_SB('÷ 0041 × 0308 × 0022 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (Upper) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] QUOTATION MARK (Close) ÷ [0.3]');
    Test_SB('÷ 0041 × 002C ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (Upper) × [998.0] COMMA (SContinue) ÷ [0.3]');
    Test_SB('÷ 0041 × 0308 × 002C ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (Upper) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] COMMA (SContinue) ÷ [0.3]');
    Test_SB('÷ 0041 × 00AD ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (Upper) × [5.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_SB('÷ 0041 × 0308 × 00AD ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (Upper) × [5.0] COMBINING DIAERESIS (Extend_FE) × [5.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_SB('÷ 0041 × 0300 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (Upper) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 0041 × 0308 × 0300 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (Upper) × [5.0] COMBINING DIAERESIS (Extend_FE) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 01BB × 0001 ÷	#  ÷ [0.2] LATIN LETTER TWO WITH STROKE (OLetter) × [998.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_SB('÷ 01BB × 0308 × 0001 ÷	#  ÷ [0.2] LATIN LETTER TWO WITH STROKE (OLetter) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_SB('÷ 01BB × 000D ÷	#  ÷ [0.2] LATIN LETTER TWO WITH STROKE (OLetter) × [998.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_SB('÷ 01BB × 0308 × 000D ÷	#  ÷ [0.2] LATIN LETTER TWO WITH STROKE (OLetter) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_SB('÷ 01BB × 000A ÷	#  ÷ [0.2] LATIN LETTER TWO WITH STROKE (OLetter) × [998.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_SB('÷ 01BB × 0308 × 000A ÷	#  ÷ [0.2] LATIN LETTER TWO WITH STROKE (OLetter) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_SB('÷ 01BB × 0085 ÷	#  ÷ [0.2] LATIN LETTER TWO WITH STROKE (OLetter) × [998.0] <NEXT LINE (NEL)> (Sep) ÷ [0.3]');
    Test_SB('÷ 01BB × 0308 × 0085 ÷	#  ÷ [0.2] LATIN LETTER TWO WITH STROKE (OLetter) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <NEXT LINE (NEL)> (Sep) ÷ [0.3]');
    Test_SB('÷ 01BB × 0009 ÷	#  ÷ [0.2] LATIN LETTER TWO WITH STROKE (OLetter) × [998.0] <CHARACTER TABULATION> (Sp) ÷ [0.3]');
    Test_SB('÷ 01BB × 0308 × 0009 ÷	#  ÷ [0.2] LATIN LETTER TWO WITH STROKE (OLetter) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <CHARACTER TABULATION> (Sp) ÷ [0.3]');
    Test_SB('÷ 01BB × 0061 ÷	#  ÷ [0.2] LATIN LETTER TWO WITH STROKE (OLetter) × [998.0] LATIN SMALL LETTER A (Lower) ÷ [0.3]');
    Test_SB('÷ 01BB × 0308 × 0061 ÷	#  ÷ [0.2] LATIN LETTER TWO WITH STROKE (OLetter) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN SMALL LETTER A (Lower) ÷ [0.3]');
    Test_SB('÷ 01BB × 0041 ÷	#  ÷ [0.2] LATIN LETTER TWO WITH STROKE (OLetter) × [998.0] LATIN CAPITAL LETTER A (Upper) ÷ [0.3]');
    Test_SB('÷ 01BB × 0308 × 0041 ÷	#  ÷ [0.2] LATIN LETTER TWO WITH STROKE (OLetter) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN CAPITAL LETTER A (Upper) ÷ [0.3]');
    Test_SB('÷ 01BB × 01BB ÷	#  ÷ [0.2] LATIN LETTER TWO WITH STROKE (OLetter) × [998.0] LATIN LETTER TWO WITH STROKE (OLetter) ÷ [0.3]');
    Test_SB('÷ 01BB × 0308 × 01BB ÷	#  ÷ [0.2] LATIN LETTER TWO WITH STROKE (OLetter) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN LETTER TWO WITH STROKE (OLetter) ÷ [0.3]');
    Test_SB('÷ 01BB × 0030 ÷	#  ÷ [0.2] LATIN LETTER TWO WITH STROKE (OLetter) × [998.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_SB('÷ 01BB × 0308 × 0030 ÷	#  ÷ [0.2] LATIN LETTER TWO WITH STROKE (OLetter) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_SB('÷ 01BB × 002E ÷	#  ÷ [0.2] LATIN LETTER TWO WITH STROKE (OLetter) × [998.0] FULL STOP (ATerm) ÷ [0.3]');
    Test_SB('÷ 01BB × 0308 × 002E ÷	#  ÷ [0.2] LATIN LETTER TWO WITH STROKE (OLetter) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] FULL STOP (ATerm) ÷ [0.3]');
    Test_SB('÷ 01BB × 0021 ÷	#  ÷ [0.2] LATIN LETTER TWO WITH STROKE (OLetter) × [998.0] EXCLAMATION MARK (STerm) ÷ [0.3]');
    Test_SB('÷ 01BB × 0308 × 0021 ÷	#  ÷ [0.2] LATIN LETTER TWO WITH STROKE (OLetter) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] EXCLAMATION MARK (STerm) ÷ [0.3]');
    Test_SB('÷ 01BB × 0022 ÷	#  ÷ [0.2] LATIN LETTER TWO WITH STROKE (OLetter) × [998.0] QUOTATION MARK (Close) ÷ [0.3]');
    Test_SB('÷ 01BB × 0308 × 0022 ÷	#  ÷ [0.2] LATIN LETTER TWO WITH STROKE (OLetter) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] QUOTATION MARK (Close) ÷ [0.3]');
    Test_SB('÷ 01BB × 002C ÷	#  ÷ [0.2] LATIN LETTER TWO WITH STROKE (OLetter) × [998.0] COMMA (SContinue) ÷ [0.3]');
    Test_SB('÷ 01BB × 0308 × 002C ÷	#  ÷ [0.2] LATIN LETTER TWO WITH STROKE (OLetter) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] COMMA (SContinue) ÷ [0.3]');
    Test_SB('÷ 01BB × 00AD ÷	#  ÷ [0.2] LATIN LETTER TWO WITH STROKE (OLetter) × [5.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_SB('÷ 01BB × 0308 × 00AD ÷	#  ÷ [0.2] LATIN LETTER TWO WITH STROKE (OLetter) × [5.0] COMBINING DIAERESIS (Extend_FE) × [5.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_SB('÷ 01BB × 0300 ÷	#  ÷ [0.2] LATIN LETTER TWO WITH STROKE (OLetter) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 01BB × 0308 × 0300 ÷	#  ÷ [0.2] LATIN LETTER TWO WITH STROKE (OLetter) × [5.0] COMBINING DIAERESIS (Extend_FE) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 0030 × 0001 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [998.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_SB('÷ 0030 × 0308 × 0001 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_SB('÷ 0030 × 000D ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [998.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_SB('÷ 0030 × 0308 × 000D ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_SB('÷ 0030 × 000A ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [998.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_SB('÷ 0030 × 0308 × 000A ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_SB('÷ 0030 × 0085 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [998.0] <NEXT LINE (NEL)> (Sep) ÷ [0.3]');
    Test_SB('÷ 0030 × 0308 × 0085 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <NEXT LINE (NEL)> (Sep) ÷ [0.3]');
    Test_SB('÷ 0030 × 0009 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [998.0] <CHARACTER TABULATION> (Sp) ÷ [0.3]');
    Test_SB('÷ 0030 × 0308 × 0009 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <CHARACTER TABULATION> (Sp) ÷ [0.3]');
    Test_SB('÷ 0030 × 0061 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [998.0] LATIN SMALL LETTER A (Lower) ÷ [0.3]');
    Test_SB('÷ 0030 × 0308 × 0061 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN SMALL LETTER A (Lower) ÷ [0.3]');
    Test_SB('÷ 0030 × 0041 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [998.0] LATIN CAPITAL LETTER A (Upper) ÷ [0.3]');
    Test_SB('÷ 0030 × 0308 × 0041 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN CAPITAL LETTER A (Upper) ÷ [0.3]');
    Test_SB('÷ 0030 × 01BB ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [998.0] LATIN LETTER TWO WITH STROKE (OLetter) ÷ [0.3]');
    Test_SB('÷ 0030 × 0308 × 01BB ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN LETTER TWO WITH STROKE (OLetter) ÷ [0.3]');
    Test_SB('÷ 0030 × 0030 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [998.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_SB('÷ 0030 × 0308 × 0030 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_SB('÷ 0030 × 002E ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [998.0] FULL STOP (ATerm) ÷ [0.3]');
    Test_SB('÷ 0030 × 0308 × 002E ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] FULL STOP (ATerm) ÷ [0.3]');
    Test_SB('÷ 0030 × 0021 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [998.0] EXCLAMATION MARK (STerm) ÷ [0.3]');
    Test_SB('÷ 0030 × 0308 × 0021 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] EXCLAMATION MARK (STerm) ÷ [0.3]');
    Test_SB('÷ 0030 × 0022 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [998.0] QUOTATION MARK (Close) ÷ [0.3]');
    Test_SB('÷ 0030 × 0308 × 0022 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] QUOTATION MARK (Close) ÷ [0.3]');
    Test_SB('÷ 0030 × 002C ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [998.0] COMMA (SContinue) ÷ [0.3]');
    Test_SB('÷ 0030 × 0308 × 002C ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] COMMA (SContinue) ÷ [0.3]');
    Test_SB('÷ 0030 × 00AD ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [5.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_SB('÷ 0030 × 0308 × 00AD ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [5.0] COMBINING DIAERESIS (Extend_FE) × [5.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_SB('÷ 0030 × 0300 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 0030 × 0308 × 0300 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [5.0] COMBINING DIAERESIS (Extend_FE) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 002E ÷ 0001 ÷	#  ÷ [0.2] FULL STOP (ATerm) ÷ [11.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_SB('÷ 002E × 0308 ÷ 0001 ÷	#  ÷ [0.2] FULL STOP (ATerm) × [5.0] COMBINING DIAERESIS (Extend_FE) ÷ [11.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_SB('÷ 002E × 000D ÷	#  ÷ [0.2] FULL STOP (ATerm) × [9.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_SB('÷ 002E × 0308 × 000D ÷	#  ÷ [0.2] FULL STOP (ATerm) × [5.0] COMBINING DIAERESIS (Extend_FE) × [9.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_SB('÷ 002E × 000A ÷	#  ÷ [0.2] FULL STOP (ATerm) × [9.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_SB('÷ 002E × 0308 × 000A ÷	#  ÷ [0.2] FULL STOP (ATerm) × [5.0] COMBINING DIAERESIS (Extend_FE) × [9.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_SB('÷ 002E × 0085 ÷	#  ÷ [0.2] FULL STOP (ATerm) × [9.0] <NEXT LINE (NEL)> (Sep) ÷ [0.3]');
    Test_SB('÷ 002E × 0308 × 0085 ÷	#  ÷ [0.2] FULL STOP (ATerm) × [5.0] COMBINING DIAERESIS (Extend_FE) × [9.0] <NEXT LINE (NEL)> (Sep) ÷ [0.3]');
    Test_SB('÷ 002E × 0009 ÷	#  ÷ [0.2] FULL STOP (ATerm) × [9.0] <CHARACTER TABULATION> (Sp) ÷ [0.3]');
    Test_SB('÷ 002E × 0308 × 0009 ÷	#  ÷ [0.2] FULL STOP (ATerm) × [5.0] COMBINING DIAERESIS (Extend_FE) × [9.0] <CHARACTER TABULATION> (Sp) ÷ [0.3]');
    Test_SB('÷ 002E × 0061 ÷	#  ÷ [0.2] FULL STOP (ATerm) × [8.0] LATIN SMALL LETTER A (Lower) ÷ [0.3]');
    Test_SB('÷ 002E × 0308 × 0061 ÷	#  ÷ [0.2] FULL STOP (ATerm) × [5.0] COMBINING DIAERESIS (Extend_FE) × [8.0] LATIN SMALL LETTER A (Lower) ÷ [0.3]');
    Test_SB('÷ 002E ÷ 0041 ÷	#  ÷ [0.2] FULL STOP (ATerm) ÷ [11.0] LATIN CAPITAL LETTER A (Upper) ÷ [0.3]');
    Test_SB('÷ 002E × 0308 ÷ 0041 ÷	#  ÷ [0.2] FULL STOP (ATerm) × [5.0] COMBINING DIAERESIS (Extend_FE) ÷ [11.0] LATIN CAPITAL LETTER A (Upper) ÷ [0.3]');
    Test_SB('÷ 002E ÷ 01BB ÷	#  ÷ [0.2] FULL STOP (ATerm) ÷ [11.0] LATIN LETTER TWO WITH STROKE (OLetter) ÷ [0.3]');
    Test_SB('÷ 002E × 0308 ÷ 01BB ÷	#  ÷ [0.2] FULL STOP (ATerm) × [5.0] COMBINING DIAERESIS (Extend_FE) ÷ [11.0] LATIN LETTER TWO WITH STROKE (OLetter) ÷ [0.3]');
    Test_SB('÷ 002E × 0030 ÷	#  ÷ [0.2] FULL STOP (ATerm) × [6.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_SB('÷ 002E × 0308 × 0030 ÷	#  ÷ [0.2] FULL STOP (ATerm) × [5.0] COMBINING DIAERESIS (Extend_FE) × [6.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_SB('÷ 002E × 002E ÷	#  ÷ [0.2] FULL STOP (ATerm) × [8.1] FULL STOP (ATerm) ÷ [0.3]');
    Test_SB('÷ 002E × 0308 × 002E ÷	#  ÷ [0.2] FULL STOP (ATerm) × [5.0] COMBINING DIAERESIS (Extend_FE) × [8.1] FULL STOP (ATerm) ÷ [0.3]');
    Test_SB('÷ 002E × 0021 ÷	#  ÷ [0.2] FULL STOP (ATerm) × [8.1] EXCLAMATION MARK (STerm) ÷ [0.3]');
    Test_SB('÷ 002E × 0308 × 0021 ÷	#  ÷ [0.2] FULL STOP (ATerm) × [5.0] COMBINING DIAERESIS (Extend_FE) × [8.1] EXCLAMATION MARK (STerm) ÷ [0.3]');
    Test_SB('÷ 002E × 0022 ÷	#  ÷ [0.2] FULL STOP (ATerm) × [9.0] QUOTATION MARK (Close) ÷ [0.3]');
    Test_SB('÷ 002E × 0308 × 0022 ÷	#  ÷ [0.2] FULL STOP (ATerm) × [5.0] COMBINING DIAERESIS (Extend_FE) × [9.0] QUOTATION MARK (Close) ÷ [0.3]');
    Test_SB('÷ 002E × 002C ÷	#  ÷ [0.2] FULL STOP (ATerm) × [8.1] COMMA (SContinue) ÷ [0.3]');
    Test_SB('÷ 002E × 0308 × 002C ÷	#  ÷ [0.2] FULL STOP (ATerm) × [5.0] COMBINING DIAERESIS (Extend_FE) × [8.1] COMMA (SContinue) ÷ [0.3]');
    Test_SB('÷ 002E × 00AD ÷	#  ÷ [0.2] FULL STOP (ATerm) × [5.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_SB('÷ 002E × 0308 × 00AD ÷	#  ÷ [0.2] FULL STOP (ATerm) × [5.0] COMBINING DIAERESIS (Extend_FE) × [5.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_SB('÷ 002E × 0300 ÷	#  ÷ [0.2] FULL STOP (ATerm) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 002E × 0308 × 0300 ÷	#  ÷ [0.2] FULL STOP (ATerm) × [5.0] COMBINING DIAERESIS (Extend_FE) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 0021 ÷ 0001 ÷	#  ÷ [0.2] EXCLAMATION MARK (STerm) ÷ [11.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_SB('÷ 0021 × 0308 ÷ 0001 ÷	#  ÷ [0.2] EXCLAMATION MARK (STerm) × [5.0] COMBINING DIAERESIS (Extend_FE) ÷ [11.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_SB('÷ 0021 × 000D ÷	#  ÷ [0.2] EXCLAMATION MARK (STerm) × [9.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_SB('÷ 0021 × 0308 × 000D ÷	#  ÷ [0.2] EXCLAMATION MARK (STerm) × [5.0] COMBINING DIAERESIS (Extend_FE) × [9.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_SB('÷ 0021 × 000A ÷	#  ÷ [0.2] EXCLAMATION MARK (STerm) × [9.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_SB('÷ 0021 × 0308 × 000A ÷	#  ÷ [0.2] EXCLAMATION MARK (STerm) × [5.0] COMBINING DIAERESIS (Extend_FE) × [9.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_SB('÷ 0021 × 0085 ÷	#  ÷ [0.2] EXCLAMATION MARK (STerm) × [9.0] <NEXT LINE (NEL)> (Sep) ÷ [0.3]');
    Test_SB('÷ 0021 × 0308 × 0085 ÷	#  ÷ [0.2] EXCLAMATION MARK (STerm) × [5.0] COMBINING DIAERESIS (Extend_FE) × [9.0] <NEXT LINE (NEL)> (Sep) ÷ [0.3]');
    Test_SB('÷ 0021 × 0009 ÷	#  ÷ [0.2] EXCLAMATION MARK (STerm) × [9.0] <CHARACTER TABULATION> (Sp) ÷ [0.3]');
    Test_SB('÷ 0021 × 0308 × 0009 ÷	#  ÷ [0.2] EXCLAMATION MARK (STerm) × [5.0] COMBINING DIAERESIS (Extend_FE) × [9.0] <CHARACTER TABULATION> (Sp) ÷ [0.3]');
    Test_SB('÷ 0021 ÷ 0061 ÷	#  ÷ [0.2] EXCLAMATION MARK (STerm) ÷ [11.0] LATIN SMALL LETTER A (Lower) ÷ [0.3]');
    Test_SB('÷ 0021 × 0308 ÷ 0061 ÷	#  ÷ [0.2] EXCLAMATION MARK (STerm) × [5.0] COMBINING DIAERESIS (Extend_FE) ÷ [11.0] LATIN SMALL LETTER A (Lower) ÷ [0.3]');
    Test_SB('÷ 0021 ÷ 0041 ÷	#  ÷ [0.2] EXCLAMATION MARK (STerm) ÷ [11.0] LATIN CAPITAL LETTER A (Upper) ÷ [0.3]');
    Test_SB('÷ 0021 × 0308 ÷ 0041 ÷	#  ÷ [0.2] EXCLAMATION MARK (STerm) × [5.0] COMBINING DIAERESIS (Extend_FE) ÷ [11.0] LATIN CAPITAL LETTER A (Upper) ÷ [0.3]');
    Test_SB('÷ 0021 ÷ 01BB ÷	#  ÷ [0.2] EXCLAMATION MARK (STerm) ÷ [11.0] LATIN LETTER TWO WITH STROKE (OLetter) ÷ [0.3]');
    Test_SB('÷ 0021 × 0308 ÷ 01BB ÷	#  ÷ [0.2] EXCLAMATION MARK (STerm) × [5.0] COMBINING DIAERESIS (Extend_FE) ÷ [11.0] LATIN LETTER TWO WITH STROKE (OLetter) ÷ [0.3]');
    Test_SB('÷ 0021 ÷ 0030 ÷	#  ÷ [0.2] EXCLAMATION MARK (STerm) ÷ [11.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_SB('÷ 0021 × 0308 ÷ 0030 ÷	#  ÷ [0.2] EXCLAMATION MARK (STerm) × [5.0] COMBINING DIAERESIS (Extend_FE) ÷ [11.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_SB('÷ 0021 × 002E ÷	#  ÷ [0.2] EXCLAMATION MARK (STerm) × [8.1] FULL STOP (ATerm) ÷ [0.3]');
    Test_SB('÷ 0021 × 0308 × 002E ÷	#  ÷ [0.2] EXCLAMATION MARK (STerm) × [5.0] COMBINING DIAERESIS (Extend_FE) × [8.1] FULL STOP (ATerm) ÷ [0.3]');
    Test_SB('÷ 0021 × 0021 ÷	#  ÷ [0.2] EXCLAMATION MARK (STerm) × [8.1] EXCLAMATION MARK (STerm) ÷ [0.3]');
    Test_SB('÷ 0021 × 0308 × 0021 ÷	#  ÷ [0.2] EXCLAMATION MARK (STerm) × [5.0] COMBINING DIAERESIS (Extend_FE) × [8.1] EXCLAMATION MARK (STerm) ÷ [0.3]');
    Test_SB('÷ 0021 × 0022 ÷	#  ÷ [0.2] EXCLAMATION MARK (STerm) × [9.0] QUOTATION MARK (Close) ÷ [0.3]');
    Test_SB('÷ 0021 × 0308 × 0022 ÷	#  ÷ [0.2] EXCLAMATION MARK (STerm) × [5.0] COMBINING DIAERESIS (Extend_FE) × [9.0] QUOTATION MARK (Close) ÷ [0.3]');
    Test_SB('÷ 0021 × 002C ÷	#  ÷ [0.2] EXCLAMATION MARK (STerm) × [8.1] COMMA (SContinue) ÷ [0.3]');
    Test_SB('÷ 0021 × 0308 × 002C ÷	#  ÷ [0.2] EXCLAMATION MARK (STerm) × [5.0] COMBINING DIAERESIS (Extend_FE) × [8.1] COMMA (SContinue) ÷ [0.3]');
    Test_SB('÷ 0021 × 00AD ÷	#  ÷ [0.2] EXCLAMATION MARK (STerm) × [5.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_SB('÷ 0021 × 0308 × 00AD ÷	#  ÷ [0.2] EXCLAMATION MARK (STerm) × [5.0] COMBINING DIAERESIS (Extend_FE) × [5.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_SB('÷ 0021 × 0300 ÷	#  ÷ [0.2] EXCLAMATION MARK (STerm) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 0021 × 0308 × 0300 ÷	#  ÷ [0.2] EXCLAMATION MARK (STerm) × [5.0] COMBINING DIAERESIS (Extend_FE) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 0022 × 0001 ÷	#  ÷ [0.2] QUOTATION MARK (Close) × [998.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_SB('÷ 0022 × 0308 × 0001 ÷	#  ÷ [0.2] QUOTATION MARK (Close) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_SB('÷ 0022 × 000D ÷	#  ÷ [0.2] QUOTATION MARK (Close) × [998.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_SB('÷ 0022 × 0308 × 000D ÷	#  ÷ [0.2] QUOTATION MARK (Close) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_SB('÷ 0022 × 000A ÷	#  ÷ [0.2] QUOTATION MARK (Close) × [998.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_SB('÷ 0022 × 0308 × 000A ÷	#  ÷ [0.2] QUOTATION MARK (Close) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_SB('÷ 0022 × 0085 ÷	#  ÷ [0.2] QUOTATION MARK (Close) × [998.0] <NEXT LINE (NEL)> (Sep) ÷ [0.3]');
    Test_SB('÷ 0022 × 0308 × 0085 ÷	#  ÷ [0.2] QUOTATION MARK (Close) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <NEXT LINE (NEL)> (Sep) ÷ [0.3]');
    Test_SB('÷ 0022 × 0009 ÷	#  ÷ [0.2] QUOTATION MARK (Close) × [998.0] <CHARACTER TABULATION> (Sp) ÷ [0.3]');
    Test_SB('÷ 0022 × 0308 × 0009 ÷	#  ÷ [0.2] QUOTATION MARK (Close) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <CHARACTER TABULATION> (Sp) ÷ [0.3]');
    Test_SB('÷ 0022 × 0061 ÷	#  ÷ [0.2] QUOTATION MARK (Close) × [998.0] LATIN SMALL LETTER A (Lower) ÷ [0.3]');
    Test_SB('÷ 0022 × 0308 × 0061 ÷	#  ÷ [0.2] QUOTATION MARK (Close) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN SMALL LETTER A (Lower) ÷ [0.3]');
    Test_SB('÷ 0022 × 0041 ÷	#  ÷ [0.2] QUOTATION MARK (Close) × [998.0] LATIN CAPITAL LETTER A (Upper) ÷ [0.3]');
    Test_SB('÷ 0022 × 0308 × 0041 ÷	#  ÷ [0.2] QUOTATION MARK (Close) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN CAPITAL LETTER A (Upper) ÷ [0.3]');
    Test_SB('÷ 0022 × 01BB ÷	#  ÷ [0.2] QUOTATION MARK (Close) × [998.0] LATIN LETTER TWO WITH STROKE (OLetter) ÷ [0.3]');
    Test_SB('÷ 0022 × 0308 × 01BB ÷	#  ÷ [0.2] QUOTATION MARK (Close) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN LETTER TWO WITH STROKE (OLetter) ÷ [0.3]');
    Test_SB('÷ 0022 × 0030 ÷	#  ÷ [0.2] QUOTATION MARK (Close) × [998.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_SB('÷ 0022 × 0308 × 0030 ÷	#  ÷ [0.2] QUOTATION MARK (Close) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_SB('÷ 0022 × 002E ÷	#  ÷ [0.2] QUOTATION MARK (Close) × [998.0] FULL STOP (ATerm) ÷ [0.3]');
    Test_SB('÷ 0022 × 0308 × 002E ÷	#  ÷ [0.2] QUOTATION MARK (Close) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] FULL STOP (ATerm) ÷ [0.3]');
    Test_SB('÷ 0022 × 0021 ÷	#  ÷ [0.2] QUOTATION MARK (Close) × [998.0] EXCLAMATION MARK (STerm) ÷ [0.3]');
    Test_SB('÷ 0022 × 0308 × 0021 ÷	#  ÷ [0.2] QUOTATION MARK (Close) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] EXCLAMATION MARK (STerm) ÷ [0.3]');
    Test_SB('÷ 0022 × 0022 ÷	#  ÷ [0.2] QUOTATION MARK (Close) × [998.0] QUOTATION MARK (Close) ÷ [0.3]');
    Test_SB('÷ 0022 × 0308 × 0022 ÷	#  ÷ [0.2] QUOTATION MARK (Close) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] QUOTATION MARK (Close) ÷ [0.3]');
    Test_SB('÷ 0022 × 002C ÷	#  ÷ [0.2] QUOTATION MARK (Close) × [998.0] COMMA (SContinue) ÷ [0.3]');
    Test_SB('÷ 0022 × 0308 × 002C ÷	#  ÷ [0.2] QUOTATION MARK (Close) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] COMMA (SContinue) ÷ [0.3]');
    Test_SB('÷ 0022 × 00AD ÷	#  ÷ [0.2] QUOTATION MARK (Close) × [5.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_SB('÷ 0022 × 0308 × 00AD ÷	#  ÷ [0.2] QUOTATION MARK (Close) × [5.0] COMBINING DIAERESIS (Extend_FE) × [5.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_SB('÷ 0022 × 0300 ÷	#  ÷ [0.2] QUOTATION MARK (Close) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 0022 × 0308 × 0300 ÷	#  ÷ [0.2] QUOTATION MARK (Close) × [5.0] COMBINING DIAERESIS (Extend_FE) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 002C × 0001 ÷	#  ÷ [0.2] COMMA (SContinue) × [998.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_SB('÷ 002C × 0308 × 0001 ÷	#  ÷ [0.2] COMMA (SContinue) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_SB('÷ 002C × 000D ÷	#  ÷ [0.2] COMMA (SContinue) × [998.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_SB('÷ 002C × 0308 × 000D ÷	#  ÷ [0.2] COMMA (SContinue) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_SB('÷ 002C × 000A ÷	#  ÷ [0.2] COMMA (SContinue) × [998.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_SB('÷ 002C × 0308 × 000A ÷	#  ÷ [0.2] COMMA (SContinue) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_SB('÷ 002C × 0085 ÷	#  ÷ [0.2] COMMA (SContinue) × [998.0] <NEXT LINE (NEL)> (Sep) ÷ [0.3]');
    Test_SB('÷ 002C × 0308 × 0085 ÷	#  ÷ [0.2] COMMA (SContinue) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <NEXT LINE (NEL)> (Sep) ÷ [0.3]');
    Test_SB('÷ 002C × 0009 ÷	#  ÷ [0.2] COMMA (SContinue) × [998.0] <CHARACTER TABULATION> (Sp) ÷ [0.3]');
    Test_SB('÷ 002C × 0308 × 0009 ÷	#  ÷ [0.2] COMMA (SContinue) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <CHARACTER TABULATION> (Sp) ÷ [0.3]');
    Test_SB('÷ 002C × 0061 ÷	#  ÷ [0.2] COMMA (SContinue) × [998.0] LATIN SMALL LETTER A (Lower) ÷ [0.3]');
    Test_SB('÷ 002C × 0308 × 0061 ÷	#  ÷ [0.2] COMMA (SContinue) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN SMALL LETTER A (Lower) ÷ [0.3]');
    Test_SB('÷ 002C × 0041 ÷	#  ÷ [0.2] COMMA (SContinue) × [998.0] LATIN CAPITAL LETTER A (Upper) ÷ [0.3]');
    Test_SB('÷ 002C × 0308 × 0041 ÷	#  ÷ [0.2] COMMA (SContinue) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN CAPITAL LETTER A (Upper) ÷ [0.3]');
    Test_SB('÷ 002C × 01BB ÷	#  ÷ [0.2] COMMA (SContinue) × [998.0] LATIN LETTER TWO WITH STROKE (OLetter) ÷ [0.3]');
    Test_SB('÷ 002C × 0308 × 01BB ÷	#  ÷ [0.2] COMMA (SContinue) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN LETTER TWO WITH STROKE (OLetter) ÷ [0.3]');
    Test_SB('÷ 002C × 0030 ÷	#  ÷ [0.2] COMMA (SContinue) × [998.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_SB('÷ 002C × 0308 × 0030 ÷	#  ÷ [0.2] COMMA (SContinue) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_SB('÷ 002C × 002E ÷	#  ÷ [0.2] COMMA (SContinue) × [998.0] FULL STOP (ATerm) ÷ [0.3]');
    Test_SB('÷ 002C × 0308 × 002E ÷	#  ÷ [0.2] COMMA (SContinue) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] FULL STOP (ATerm) ÷ [0.3]');
    Test_SB('÷ 002C × 0021 ÷	#  ÷ [0.2] COMMA (SContinue) × [998.0] EXCLAMATION MARK (STerm) ÷ [0.3]');
    Test_SB('÷ 002C × 0308 × 0021 ÷	#  ÷ [0.2] COMMA (SContinue) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] EXCLAMATION MARK (STerm) ÷ [0.3]');
    Test_SB('÷ 002C × 0022 ÷	#  ÷ [0.2] COMMA (SContinue) × [998.0] QUOTATION MARK (Close) ÷ [0.3]');
    Test_SB('÷ 002C × 0308 × 0022 ÷	#  ÷ [0.2] COMMA (SContinue) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] QUOTATION MARK (Close) ÷ [0.3]');
    Test_SB('÷ 002C × 002C ÷	#  ÷ [0.2] COMMA (SContinue) × [998.0] COMMA (SContinue) ÷ [0.3]');
    Test_SB('÷ 002C × 0308 × 002C ÷	#  ÷ [0.2] COMMA (SContinue) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] COMMA (SContinue) ÷ [0.3]');
    Test_SB('÷ 002C × 00AD ÷	#  ÷ [0.2] COMMA (SContinue) × [5.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_SB('÷ 002C × 0308 × 00AD ÷	#  ÷ [0.2] COMMA (SContinue) × [5.0] COMBINING DIAERESIS (Extend_FE) × [5.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_SB('÷ 002C × 0300 ÷	#  ÷ [0.2] COMMA (SContinue) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 002C × 0308 × 0300 ÷	#  ÷ [0.2] COMMA (SContinue) × [5.0] COMBINING DIAERESIS (Extend_FE) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 00AD × 0001 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [998.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_SB('÷ 00AD × 0308 × 0001 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_SB('÷ 00AD × 000D ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [998.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_SB('÷ 00AD × 0308 × 000D ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_SB('÷ 00AD × 000A ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [998.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_SB('÷ 00AD × 0308 × 000A ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_SB('÷ 00AD × 0085 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [998.0] <NEXT LINE (NEL)> (Sep) ÷ [0.3]');
    Test_SB('÷ 00AD × 0308 × 0085 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <NEXT LINE (NEL)> (Sep) ÷ [0.3]');
    Test_SB('÷ 00AD × 0009 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [998.0] <CHARACTER TABULATION> (Sp) ÷ [0.3]');
    Test_SB('÷ 00AD × 0308 × 0009 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <CHARACTER TABULATION> (Sp) ÷ [0.3]');
    Test_SB('÷ 00AD × 0061 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [998.0] LATIN SMALL LETTER A (Lower) ÷ [0.3]');
    Test_SB('÷ 00AD × 0308 × 0061 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN SMALL LETTER A (Lower) ÷ [0.3]');
    Test_SB('÷ 00AD × 0041 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [998.0] LATIN CAPITAL LETTER A (Upper) ÷ [0.3]');
    Test_SB('÷ 00AD × 0308 × 0041 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN CAPITAL LETTER A (Upper) ÷ [0.3]');
    Test_SB('÷ 00AD × 01BB ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [998.0] LATIN LETTER TWO WITH STROKE (OLetter) ÷ [0.3]');
    Test_SB('÷ 00AD × 0308 × 01BB ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN LETTER TWO WITH STROKE (OLetter) ÷ [0.3]');
    Test_SB('÷ 00AD × 0030 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [998.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_SB('÷ 00AD × 0308 × 0030 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_SB('÷ 00AD × 002E ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [998.0] FULL STOP (ATerm) ÷ [0.3]');
    Test_SB('÷ 00AD × 0308 × 002E ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] FULL STOP (ATerm) ÷ [0.3]');
    Test_SB('÷ 00AD × 0021 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [998.0] EXCLAMATION MARK (STerm) ÷ [0.3]');
    Test_SB('÷ 00AD × 0308 × 0021 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] EXCLAMATION MARK (STerm) ÷ [0.3]');
    Test_SB('÷ 00AD × 0022 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [998.0] QUOTATION MARK (Close) ÷ [0.3]');
    Test_SB('÷ 00AD × 0308 × 0022 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] QUOTATION MARK (Close) ÷ [0.3]');
    Test_SB('÷ 00AD × 002C ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [998.0] COMMA (SContinue) ÷ [0.3]');
    Test_SB('÷ 00AD × 0308 × 002C ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] COMMA (SContinue) ÷ [0.3]');
    Test_SB('÷ 00AD × 00AD ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [5.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_SB('÷ 00AD × 0308 × 00AD ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [5.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_SB('÷ 00AD × 0300 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 00AD × 0308 × 0300 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 0300 × 0001 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [998.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_SB('÷ 0300 × 0308 × 0001 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_SB('÷ 0300 × 000D ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [998.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_SB('÷ 0300 × 0308 × 000D ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_SB('÷ 0300 × 000A ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [998.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_SB('÷ 0300 × 0308 × 000A ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_SB('÷ 0300 × 0085 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [998.0] <NEXT LINE (NEL)> (Sep) ÷ [0.3]');
    Test_SB('÷ 0300 × 0308 × 0085 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <NEXT LINE (NEL)> (Sep) ÷ [0.3]');
    Test_SB('÷ 0300 × 0009 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [998.0] <CHARACTER TABULATION> (Sp) ÷ [0.3]');
    Test_SB('÷ 0300 × 0308 × 0009 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <CHARACTER TABULATION> (Sp) ÷ [0.3]');
    Test_SB('÷ 0300 × 0061 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [998.0] LATIN SMALL LETTER A (Lower) ÷ [0.3]');
    Test_SB('÷ 0300 × 0308 × 0061 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN SMALL LETTER A (Lower) ÷ [0.3]');
    Test_SB('÷ 0300 × 0041 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [998.0] LATIN CAPITAL LETTER A (Upper) ÷ [0.3]');
    Test_SB('÷ 0300 × 0308 × 0041 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN CAPITAL LETTER A (Upper) ÷ [0.3]');
    Test_SB('÷ 0300 × 01BB ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [998.0] LATIN LETTER TWO WITH STROKE (OLetter) ÷ [0.3]');
    Test_SB('÷ 0300 × 0308 × 01BB ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN LETTER TWO WITH STROKE (OLetter) ÷ [0.3]');
    Test_SB('÷ 0300 × 0030 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [998.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_SB('÷ 0300 × 0308 × 0030 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_SB('÷ 0300 × 002E ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [998.0] FULL STOP (ATerm) ÷ [0.3]');
    Test_SB('÷ 0300 × 0308 × 002E ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] FULL STOP (ATerm) ÷ [0.3]');
    Test_SB('÷ 0300 × 0021 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [998.0] EXCLAMATION MARK (STerm) ÷ [0.3]');
    Test_SB('÷ 0300 × 0308 × 0021 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] EXCLAMATION MARK (STerm) ÷ [0.3]');
    Test_SB('÷ 0300 × 0022 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [998.0] QUOTATION MARK (Close) ÷ [0.3]');
    Test_SB('÷ 0300 × 0308 × 0022 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] QUOTATION MARK (Close) ÷ [0.3]');
    Test_SB('÷ 0300 × 002C ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [998.0] COMMA (SContinue) ÷ [0.3]');
    Test_SB('÷ 0300 × 0308 × 002C ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] COMMA (SContinue) ÷ [0.3]');
    Test_SB('÷ 0300 × 00AD ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [5.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_SB('÷ 0300 × 0308 × 00AD ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [5.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_SB('÷ 0300 × 0300 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 0300 × 0308 × 0300 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 000D × 000A ÷ 0061 × 000A ÷ 0308 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) × [3.0] <LINE FEED (LF)> (LF) ÷ [4.0] LATIN SMALL LETTER A (Lower) × [998.0] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 0061 × 0308 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Lower) × [5.0] COMBINING DIAERESIS (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 0020 × 200D × 0646 ÷	#  ÷ [0.2] SPACE (Sp) × [5.0] ZERO WIDTH JOINER (Extend_FE) × [998.0] ARABIC LETTER NOON (OLetter) ÷ [0.3]');
    Test_SB('÷ 0646 × 200D × 0020 ÷	#  ÷ [0.2] ARABIC LETTER NOON (OLetter) × [5.0] ZERO WIDTH JOINER (Extend_FE) × [998.0] SPACE (Sp) ÷ [0.3]');
    Test_SB('÷ 0028 × 0022 × 0047 × 006F × 002E × 0022 × 0029 × 0020 ÷ 0028 × 0048 × 0065 × 0020 × 0064 × 0069 × 0064 × 002E × 0029 ÷	#  ÷ [0.2] LEFT PARENTHESIS (Close) × [998.0] QUOTATION MARK (Close) × [998.0] LATIN CAPITAL LETTER G (Upper) × [998.0] LATIN SMALL LETTER O (Lower) × [998.0] FULL STOP (ATerm) × [9.0] QUOTATION MARK (Close) × [9.0] RIGHT PARENTHESIS (Close) × [9.0] SPACE (Sp) ÷ [11.0] LEFT PARENTHESIS (Close) × [998.0] LATIN CAPITAL LETTER H (Upper) × [998.0] LATIN SMALL LETTER E (Lower) × [998.0] SPACE (Sp) × [998.0] LATIN SMALL LETTER D (Lower) × [998.0] LATIN SMALL LETTER I (Lower) × [998.0] LATIN SMALL LETTER D (Lower) × [998.0] FULL STOP (ATerm) × [9.0] RIGHT PARENTHESIS (Close) ÷ [0.3]');
    Test_SB('÷ 0028 × 201C × 0047 × 006F × 003F × 201D × 0029 × 0020 ÷ 0028 × 0048 × 0065 × 0020 × 0064 × 0069 × 0064 × 002E × 0029 ÷	#  ÷ [0.2] LEFT PARENTHESIS (Close) × [998.0] LEFT DOUBLE QUOTATION MARK (Close) × [998.0] LATIN CAPITAL LETTER G (Upper) × [998.0] LATIN SMALL LETTER O (Lower) × [998.0] QUESTION MARK (STerm) × [9.0] RIGHT DOUBLE QUOTATION MARK (Close) × [9.0] RIGHT PARENTHESIS (Close) × [9.0] SPACE (Sp) ÷ [11.0] LEFT PARENTHESIS (Close) × [998.0] LATIN CAPITAL LETTER H (Upper) × [998.0] LATIN SMALL LETTER E (Lower) × [998.0] SPACE (Sp) × [998.0] LATIN SMALL LETTER D (Lower) × [998.0] LATIN SMALL LETTER I (Lower) × [998.0] LATIN SMALL LETTER D (Lower) × [998.0] FULL STOP (ATerm) × [9.0] RIGHT PARENTHESIS (Close) ÷ [0.3]');
    Test_SB('÷ 0055 × 002E × 0053 × 002E × 0041 × 0300 × 002E × 0020 × 0069 × 0073 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER U (Upper) × [998.0] FULL STOP (ATerm) × [7.0] LATIN CAPITAL LETTER S (Upper) × [998.0] FULL STOP (ATerm) × [7.0] LATIN CAPITAL LETTER A (Upper) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) × [998.0] FULL STOP (ATerm) × [8.0] SPACE (Sp) × [8.0] LATIN SMALL LETTER I (Lower) × [998.0] LATIN SMALL LETTER S (Lower) ÷ [0.3]');
    Test_SB('÷ 0055 × 002E × 0053 × 002E × 0041 × 0300 × 003F × 0020 ÷ 0048 × 0065 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER U (Upper) × [998.0] FULL STOP (ATerm) × [7.0] LATIN CAPITAL LETTER S (Upper) × [998.0] FULL STOP (ATerm) × [7.0] LATIN CAPITAL LETTER A (Upper) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) × [998.0] QUESTION MARK (STerm) × [9.0] SPACE (Sp) ÷ [11.0] LATIN CAPITAL LETTER H (Upper) × [998.0] LATIN SMALL LETTER E (Lower) ÷ [0.3]');
    Test_SB('÷ 0055 × 002E × 0053 × 002E × 0041 × 0300 × 002E ÷	#  ÷ [0.2] LATIN CAPITAL LETTER U (Upper) × [998.0] FULL STOP (ATerm) × [7.0] LATIN CAPITAL LETTER S (Upper) × [998.0] FULL STOP (ATerm) × [7.0] LATIN CAPITAL LETTER A (Upper) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) × [998.0] FULL STOP (ATerm) ÷ [0.3]');
    Test_SB('÷ 0033 × 002E × 0034 ÷	#  ÷ [0.2] DIGIT THREE (Numeric) × [998.0] FULL STOP (ATerm) × [6.0] DIGIT FOUR (Numeric) ÷ [0.3]');
    Test_SB('÷ 0063 × 002E × 0064 ÷	#  ÷ [0.2] LATIN SMALL LETTER C (Lower) × [998.0] FULL STOP (ATerm) × [8.0] LATIN SMALL LETTER D (Lower) ÷ [0.3]');
    Test_SB('÷ 0043 × 002E × 0064 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER C (Upper) × [998.0] FULL STOP (ATerm) × [8.0] LATIN SMALL LETTER D (Lower) ÷ [0.3]');
    Test_SB('÷ 0063 × 002E × 0044 ÷	#  ÷ [0.2] LATIN SMALL LETTER C (Lower) × [998.0] FULL STOP (ATerm) × [7.0] LATIN CAPITAL LETTER D (Upper) ÷ [0.3]');
    Test_SB('÷ 0043 × 002E × 0044 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER C (Upper) × [998.0] FULL STOP (ATerm) × [7.0] LATIN CAPITAL LETTER D (Upper) ÷ [0.3]');
    Test_SB('÷ 0065 × 0074 × 0063 × 002E × 0029 × 2019 × 00A0 × 0074 × 0068 × 0065 ÷	#  ÷ [0.2] LATIN SMALL LETTER E (Lower) × [998.0] LATIN SMALL LETTER T (Lower) × [998.0] LATIN SMALL LETTER C (Lower) × [998.0] FULL STOP (ATerm) × [8.0] RIGHT PARENTHESIS (Close) × [8.0] RIGHT SINGLE QUOTATION MARK (Close) × [8.0] NO-BREAK SPACE (Sp) × [8.0] LATIN SMALL LETTER T (Lower) × [998.0] LATIN SMALL LETTER H (Lower) × [998.0] LATIN SMALL LETTER E (Lower) ÷ [0.3]');
    Test_SB('÷ 0065 × 0074 × 0063 × 002E × 0029 × 2019 × 00A0 ÷ 0054 × 0068 × 0065 ÷	#  ÷ [0.2] LATIN SMALL LETTER E (Lower) × [998.0] LATIN SMALL LETTER T (Lower) × [998.0] LATIN SMALL LETTER C (Lower) × [998.0] FULL STOP (ATerm) × [9.0] RIGHT PARENTHESIS (Close) × [9.0] RIGHT SINGLE QUOTATION MARK (Close) × [9.0] NO-BREAK SPACE (Sp) ÷ [11.0] LATIN CAPITAL LETTER T (Upper) × [998.0] LATIN SMALL LETTER H (Lower) × [998.0] LATIN SMALL LETTER E (Lower) ÷ [0.3]');
    Test_SB('÷ 0065 × 0074 × 0063 × 002E × 0029 × 2019 × 00A0 × 2018 × 0028 × 0074 × 0068 × 0065 ÷	#  ÷ [0.2] LATIN SMALL LETTER E (Lower) × [998.0] LATIN SMALL LETTER T (Lower) × [998.0] LATIN SMALL LETTER C (Lower) × [998.0] FULL STOP (ATerm) × [8.0] RIGHT PARENTHESIS (Close) × [8.0] RIGHT SINGLE QUOTATION MARK (Close) × [8.0] NO-BREAK SPACE (Sp) × [8.0] LEFT SINGLE QUOTATION MARK (Close) × [998.0] LEFT PARENTHESIS (Close) × [998.0] LATIN SMALL LETTER T (Lower) × [998.0] LATIN SMALL LETTER H (Lower) × [998.0] LATIN SMALL LETTER E (Lower) ÷ [0.3]');
    Test_SB('÷ 0065 × 0074 × 0063 × 002E × 0029 × 2019 × 00A0 ÷ 2018 × 0028 × 0054 × 0068 × 0065 ÷	#  ÷ [0.2] LATIN SMALL LETTER E (Lower) × [998.0] LATIN SMALL LETTER T (Lower) × [998.0] LATIN SMALL LETTER C (Lower) × [998.0] FULL STOP (ATerm) × [9.0] RIGHT PARENTHESIS (Close) × [9.0] RIGHT SINGLE QUOTATION MARK (Close) × [9.0] NO-BREAK SPACE (Sp) ÷ [11.0] LEFT SINGLE QUOTATION MARK (Close) × [998.0] LEFT PARENTHESIS (Close) × [998.0] LATIN CAPITAL LETTER T (Upper) × [998.0] LATIN SMALL LETTER H (Lower) × [998.0] LATIN SMALL LETTER E (Lower) ÷ [0.3]');
    Test_SB('÷ 0065 × 0074 × 0063 × 002E × 0029 × 2019 × 00A0 × 0308 × 0074 × 0068 × 0065 ÷	#  ÷ [0.2] LATIN SMALL LETTER E (Lower) × [998.0] LATIN SMALL LETTER T (Lower) × [998.0] LATIN SMALL LETTER C (Lower) × [998.0] FULL STOP (ATerm) × [8.0] RIGHT PARENTHESIS (Close) × [8.0] RIGHT SINGLE QUOTATION MARK (Close) × [8.0] NO-BREAK SPACE (Sp) × [5.0] COMBINING DIAERESIS (Extend_FE) × [8.0] LATIN SMALL LETTER T (Lower) × [998.0] LATIN SMALL LETTER H (Lower) × [998.0] LATIN SMALL LETTER E (Lower) ÷ [0.3]');
    Test_SB('÷ 0065 × 0074 × 0063 × 002E × 0029 × 2019 × 00A0 × 0308 ÷ 0054 × 0068 × 0065 ÷	#  ÷ [0.2] LATIN SMALL LETTER E (Lower) × [998.0] LATIN SMALL LETTER T (Lower) × [998.0] LATIN SMALL LETTER C (Lower) × [998.0] FULL STOP (ATerm) × [9.0] RIGHT PARENTHESIS (Close) × [9.0] RIGHT SINGLE QUOTATION MARK (Close) × [9.0] NO-BREAK SPACE (Sp) × [5.0] COMBINING DIAERESIS (Extend_FE) ÷ [11.0] LATIN CAPITAL LETTER T (Upper) × [998.0] LATIN SMALL LETTER H (Lower) × [998.0] LATIN SMALL LETTER E (Lower) ÷ [0.3]');
    Test_SB('÷ 0065 × 0074 × 0063 × 002E × 0029 × 2019 × 0308 ÷ 0054 × 0068 × 0065 ÷	#  ÷ [0.2] LATIN SMALL LETTER E (Lower) × [998.0] LATIN SMALL LETTER T (Lower) × [998.0] LATIN SMALL LETTER C (Lower) × [998.0] FULL STOP (ATerm) × [9.0] RIGHT PARENTHESIS (Close) × [9.0] RIGHT SINGLE QUOTATION MARK (Close) × [5.0] COMBINING DIAERESIS (Extend_FE) ÷ [11.0] LATIN CAPITAL LETTER T (Upper) × [998.0] LATIN SMALL LETTER H (Lower) × [998.0] LATIN SMALL LETTER E (Lower) ÷ [0.3]');
    Test_SB('÷ 0065 × 0074 × 0063 × 002E × 0029 × 000A ÷ 0308 × 0054 × 0068 × 0065 ÷	#  ÷ [0.2] LATIN SMALL LETTER E (Lower) × [998.0] LATIN SMALL LETTER T (Lower) × [998.0] LATIN SMALL LETTER C (Lower) × [998.0] FULL STOP (ATerm) × [9.0] RIGHT PARENTHESIS (Close) × [9.0] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN CAPITAL LETTER T (Upper) × [998.0] LATIN SMALL LETTER H (Lower) × [998.0] LATIN SMALL LETTER E (Lower) ÷ [0.3]');
    Test_SB('÷ 0074 × 0068 × 0065 × 0020 × 0072 × 0065 × 0073 × 0070 × 002E × 0020 × 006C × 0065 × 0061 × 0064 × 0065 × 0072 × 0073 × 0020 × 0061 × 0072 × 0065 ÷	#  ÷ [0.2] LATIN SMALL LETTER T (Lower) × [998.0] LATIN SMALL LETTER H (Lower) × [998.0] LATIN SMALL LETTER E (Lower) × [998.0] SPACE (Sp) × [998.0] LATIN SMALL LETTER R (Lower) × [998.0] LATIN SMALL LETTER E (Lower) × [998.0] LATIN SMALL LETTER S (Lower) × [998.0] LATIN SMALL LETTER P (Lower) × [998.0] FULL STOP (ATerm) × [8.0] SPACE (Sp) × [8.0] LATIN SMALL LETTER L (Lower) × [998.0] LATIN SMALL LETTER E (Lower) × [998.0] LATIN SMALL LETTER A (Lower) × [998.0] LATIN SMALL LETTER D (Lower) × [998.0] LATIN SMALL LETTER E (Lower) × [998.0] LATIN SMALL LETTER R (Lower) × [998.0] LATIN SMALL LETTER S (Lower) × [998.0] SPACE (Sp) × [998.0] LATIN SMALL LETTER A (Lower) × [998.0] LATIN SMALL LETTER R (Lower) × [998.0] LATIN SMALL LETTER E (Lower) ÷ [0.3]');
    Test_SB('÷ 5B57 × 002E ÷ 5B57 ÷	#  ÷ [0.2] CJK UNIFIED IDEOGRAPH-5B57 (OLetter) × [998.0] FULL STOP (ATerm) ÷ [11.0] CJK UNIFIED IDEOGRAPH-5B57 (OLetter) ÷ [0.3]');
    Test_SB('÷ 0065 × 0074 × 0063 × 002E ÷ 5B83 ÷	#  ÷ [0.2] LATIN SMALL LETTER E (Lower) × [998.0] LATIN SMALL LETTER T (Lower) × [998.0] LATIN SMALL LETTER C (Lower) × [998.0] FULL STOP (ATerm) ÷ [11.0] CJK UNIFIED IDEOGRAPH-5B83 (OLetter) ÷ [0.3]');
    Test_SB('÷ 0065 × 0074 × 0063 × 002E × 3002 ÷	#  ÷ [0.2] LATIN SMALL LETTER E (Lower) × [998.0] LATIN SMALL LETTER T (Lower) × [998.0] LATIN SMALL LETTER C (Lower) × [998.0] FULL STOP (ATerm) × [8.1] IDEOGRAPHIC FULL STOP (STerm) ÷ [0.3]');
    Test_SB('÷ 5B57 × 3002 ÷ 5B83 ÷	#  ÷ [0.2] CJK UNIFIED IDEOGRAPH-5B57 (OLetter) × [998.0] IDEOGRAPHIC FULL STOP (STerm) ÷ [11.0] CJK UNIFIED IDEOGRAPH-5B83 (OLetter) ÷ [0.3]');
    Test_SB('÷ 0021 × 0020 × 0020 ÷	#  ÷ [0.2] EXCLAMATION MARK (STerm) × [9.0] SPACE (Sp) × [10.0] SPACE (Sp) ÷ [0.3]');
    Test_SB('÷ 2060 × 0028 × 2060 × 0022 × 2060 × 0047 × 2060 × 006F × 2060 × 002E × 2060 × 0022 × 2060 × 0029 × 2060 × 0020 × 2060 ÷ 0028 × 2060 × 0048 × 2060 × 0065 × 2060 × 0020 × 2060 × 0064 × 2060 × 0069 × 2060 × 0064 × 2060 × 002E × 2060 × 0029 × 2060 × 2060 ÷	#  ÷ [0.2] WORD JOINER (Format_FE) × [998.0] LEFT PARENTHESIS (Close) × [5.0] WORD JOINER (Format_FE) × [998.0] QUOTATION MARK (Close) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN CAPITAL LETTER G (Upper) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER O (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] FULL STOP (ATerm) × [5.0] WORD JOINER (Format_FE) × [9.0] QUOTATION MARK (Close) × [5.0] WORD JOINER (Format_FE) × [9.0] RIGHT PARENTHESIS (Close) × [5.0] WORD JOINER (Format_FE) × [9.0] SPACE (Sp) × [5.0] WORD JOINER (Format_FE) ÷ [11.0] LEFT PARENTHESIS (Close) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN CAPITAL LETTER H (Upper) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER E (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] SPACE (Sp) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER D (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER I (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER D (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] FULL STOP (ATerm) × [5.0] WORD JOINER (Format_FE) × [9.0] RIGHT PARENTHESIS (Close) × [5.0] WORD JOINER (Format_FE) × [5.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_SB('÷ 2060 × 0028 × 2060 × 201C × 2060 × 0047 × 2060 × 006F × 2060 × 003F × 2060 × 201D × 2060 × 0029 × 2060 × 0020 × 2060 ÷ 0028 × 2060 × 0048 × 2060 × 0065 × 2060 × 0020 × 2060 × 0064 × 2060 × 0069 × 2060 × 0064 × 2060 × 002E × 2060 × 0029 × 2060 × 2060 ÷	#  ÷ [0.2] WORD JOINER (Format_FE) × [998.0] LEFT PARENTHESIS (Close) × [5.0] WORD JOINER (Format_FE) × [998.0] LEFT DOUBLE QUOTATION MARK (Close) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN CAPITAL LETTER G (Upper) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER O (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] QUESTION MARK (STerm) × [5.0] WORD JOINER (Format_FE) × [9.0] RIGHT DOUBLE QUOTATION MARK (Close) × [5.0] WORD JOINER (Format_FE) × [9.0] RIGHT PARENTHESIS (Close) × [5.0] WORD JOINER (Format_FE) × [9.0] SPACE (Sp) × [5.0] WORD JOINER (Format_FE) ÷ [11.0] LEFT PARENTHESIS (Close) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN CAPITAL LETTER H (Upper) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER E (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] SPACE (Sp) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER D (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER I (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER D (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] FULL STOP (ATerm) × [5.0] WORD JOINER (Format_FE) × [9.0] RIGHT PARENTHESIS (Close) × [5.0] WORD JOINER (Format_FE) × [5.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_SB('÷ 2060 × 0055 × 2060 × 002E × 2060 × 0053 × 2060 × 002E × 2060 × 0041 × 2060 × 0300 × 002E × 2060 × 0020 × 2060 × 0069 × 2060 × 0073 × 2060 × 2060 ÷	#  ÷ [0.2] WORD JOINER (Format_FE) × [998.0] LATIN CAPITAL LETTER U (Upper) × [5.0] WORD JOINER (Format_FE) × [998.0] FULL STOP (ATerm) × [5.0] WORD JOINER (Format_FE) × [7.0] LATIN CAPITAL LETTER S (Upper) × [5.0] WORD JOINER (Format_FE) × [998.0] FULL STOP (ATerm) × [5.0] WORD JOINER (Format_FE) × [7.0] LATIN CAPITAL LETTER A (Upper) × [5.0] WORD JOINER (Format_FE) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) × [998.0] FULL STOP (ATerm) × [5.0] WORD JOINER (Format_FE) × [8.0] SPACE (Sp) × [5.0] WORD JOINER (Format_FE) × [8.0] LATIN SMALL LETTER I (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER S (Lower) × [5.0] WORD JOINER (Format_FE) × [5.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_SB('÷ 2060 × 0055 × 2060 × 002E × 2060 × 0053 × 2060 × 002E × 2060 × 0041 × 2060 × 0300 × 003F × 2060 × 0020 × 2060 ÷ 0048 × 2060 × 0065 × 2060 × 2060 ÷	#  ÷ [0.2] WORD JOINER (Format_FE) × [998.0] LATIN CAPITAL LETTER U (Upper) × [5.0] WORD JOINER (Format_FE) × [998.0] FULL STOP (ATerm) × [5.0] WORD JOINER (Format_FE) × [7.0] LATIN CAPITAL LETTER S (Upper) × [5.0] WORD JOINER (Format_FE) × [998.0] FULL STOP (ATerm) × [5.0] WORD JOINER (Format_FE) × [7.0] LATIN CAPITAL LETTER A (Upper) × [5.0] WORD JOINER (Format_FE) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) × [998.0] QUESTION MARK (STerm) × [5.0] WORD JOINER (Format_FE) × [9.0] SPACE (Sp) × [5.0] WORD JOINER (Format_FE) ÷ [11.0] LATIN CAPITAL LETTER H (Upper) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER E (Lower) × [5.0] WORD JOINER (Format_FE) × [5.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_SB('÷ 2060 × 0055 × 2060 × 002E × 2060 × 0053 × 2060 × 002E × 2060 × 0041 × 2060 × 0300 × 002E × 2060 × 2060 ÷	#  ÷ [0.2] WORD JOINER (Format_FE) × [998.0] LATIN CAPITAL LETTER U (Upper) × [5.0] WORD JOINER (Format_FE) × [998.0] FULL STOP (ATerm) × [5.0] WORD JOINER (Format_FE) × [7.0] LATIN CAPITAL LETTER S (Upper) × [5.0] WORD JOINER (Format_FE) × [998.0] FULL STOP (ATerm) × [5.0] WORD JOINER (Format_FE) × [7.0] LATIN CAPITAL LETTER A (Upper) × [5.0] WORD JOINER (Format_FE) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) × [998.0] FULL STOP (ATerm) × [5.0] WORD JOINER (Format_FE) × [5.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_SB('÷ 2060 × 0033 × 2060 × 002E × 2060 × 0034 × 2060 × 2060 ÷	#  ÷ [0.2] WORD JOINER (Format_FE) × [998.0] DIGIT THREE (Numeric) × [5.0] WORD JOINER (Format_FE) × [998.0] FULL STOP (ATerm) × [5.0] WORD JOINER (Format_FE) × [6.0] DIGIT FOUR (Numeric) × [5.0] WORD JOINER (Format_FE) × [5.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_SB('÷ 2060 × 0063 × 2060 × 002E × 2060 × 0064 × 2060 × 2060 ÷	#  ÷ [0.2] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER C (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] FULL STOP (ATerm) × [5.0] WORD JOINER (Format_FE) × [8.0] LATIN SMALL LETTER D (Lower) × [5.0] WORD JOINER (Format_FE) × [5.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_SB('÷ 2060 × 0043 × 2060 × 002E × 2060 × 0064 × 2060 × 2060 ÷	#  ÷ [0.2] WORD JOINER (Format_FE) × [998.0] LATIN CAPITAL LETTER C (Upper) × [5.0] WORD JOINER (Format_FE) × [998.0] FULL STOP (ATerm) × [5.0] WORD JOINER (Format_FE) × [8.0] LATIN SMALL LETTER D (Lower) × [5.0] WORD JOINER (Format_FE) × [5.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_SB('÷ 2060 × 0063 × 2060 × 002E × 2060 × 0044 × 2060 × 2060 ÷	#  ÷ [0.2] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER C (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] FULL STOP (ATerm) × [5.0] WORD JOINER (Format_FE) × [7.0] LATIN CAPITAL LETTER D (Upper) × [5.0] WORD JOINER (Format_FE) × [5.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_SB('÷ 2060 × 0043 × 2060 × 002E × 2060 × 0044 × 2060 × 2060 ÷	#  ÷ [0.2] WORD JOINER (Format_FE) × [998.0] LATIN CAPITAL LETTER C (Upper) × [5.0] WORD JOINER (Format_FE) × [998.0] FULL STOP (ATerm) × [5.0] WORD JOINER (Format_FE) × [7.0] LATIN CAPITAL LETTER D (Upper) × [5.0] WORD JOINER (Format_FE) × [5.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_SB('÷ 2060 × 0065 × 2060 × 0074 × 2060 × 0063 × 2060 × 002E × 2060 × 0029 × 2060 × 2019 × 2060 × 00A0 × 2060 × 0074 × 2060 × 0068 × 2060 × 0065 × 2060 × 2060 ÷	#  ÷ [0.2] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER E (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER T (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER C (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] FULL STOP (ATerm) × [5.0] WORD JOINER (Format_FE) × [8.0] RIGHT PARENTHESIS (Close) × [5.0] WORD JOINER (Format_FE) × [8.0] RIGHT SINGLE QUOTATION MARK (Close) × [5.0] WORD JOINER (Format_FE) × [8.0] NO-BREAK SPACE (Sp) × [5.0] WORD JOINER (Format_FE) × [8.0] LATIN SMALL LETTER T (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER H (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER E (Lower) × [5.0] WORD JOINER (Format_FE) × [5.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_SB('÷ 2060 × 0065 × 2060 × 0074 × 2060 × 0063 × 2060 × 002E × 2060 × 0029 × 2060 × 2019 × 2060 × 00A0 × 2060 ÷ 0054 × 2060 × 0068 × 2060 × 0065 × 2060 × 2060 ÷	#  ÷ [0.2] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER E (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER T (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER C (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] FULL STOP (ATerm) × [5.0] WORD JOINER (Format_FE) × [9.0] RIGHT PARENTHESIS (Close) × [5.0] WORD JOINER (Format_FE) × [9.0] RIGHT SINGLE QUOTATION MARK (Close) × [5.0] WORD JOINER (Format_FE) × [9.0] NO-BREAK SPACE (Sp) × [5.0] WORD JOINER (Format_FE) ÷ [11.0] LATIN CAPITAL LETTER T (Upper) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER H (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER E (Lower) × [5.0] WORD JOINER (Format_FE) × [5.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_SB('÷ 2060 × 0065 × 2060 × 0074 × 2060 × 0063 × 2060 × 002E × 2060 × 0029 × 2060 × 2019 × 2060 × 00A0 × 2060 × 2018 × 2060 × 0028 × 2060 × 0074 × 2060 × 0068 × 2060 × 0065 × 2060 × 2060 ÷	#  ÷ [0.2] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER E (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER T (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER C (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] FULL STOP (ATerm) × [5.0] WORD JOINER (Format_FE) × [8.0] RIGHT PARENTHESIS (Close) × [5.0] WORD JOINER (Format_FE) × [8.0] RIGHT SINGLE QUOTATION MARK (Close) × [5.0] WORD JOINER (Format_FE) × [8.0] NO-BREAK SPACE (Sp) × [5.0] WORD JOINER (Format_FE) × [8.0] LEFT SINGLE QUOTATION MARK (Close) × [5.0] WORD JOINER (Format_FE) × [998.0] LEFT PARENTHESIS (Close) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER T (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER H (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER E (Lower) × [5.0] WORD JOINER (Format_FE) × [5.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_SB('÷ 2060 × 0065 × 2060 × 0074 × 2060 × 0063 × 2060 × 002E × 2060 × 0029 × 2060 × 2019 × 2060 × 00A0 × 2060 ÷ 2018 × 2060 × 0028 × 2060 × 0054 × 2060 × 0068 × 2060 × 0065 × 2060 × 2060 ÷	#  ÷ [0.2] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER E (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER T (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER C (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] FULL STOP (ATerm) × [5.0] WORD JOINER (Format_FE) × [9.0] RIGHT PARENTHESIS (Close) × [5.0] WORD JOINER (Format_FE) × [9.0] RIGHT SINGLE QUOTATION MARK (Close) × [5.0] WORD JOINER (Format_FE) × [9.0] NO-BREAK SPACE (Sp) × [5.0] WORD JOINER (Format_FE) ÷ [11.0] LEFT SINGLE QUOTATION MARK (Close) × [5.0] WORD JOINER (Format_FE) × [998.0] LEFT PARENTHESIS (Close) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN CAPITAL LETTER T (Upper) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER H (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER E (Lower) × [5.0] WORD JOINER (Format_FE) × [5.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_SB('÷ 2060 × 0065 × 2060 × 0074 × 2060 × 0063 × 2060 × 002E × 2060 × 0029 × 2060 × 2019 × 2060 × 00A0 × 2060 × 0308 × 0074 × 2060 × 0068 × 2060 × 0065 × 2060 × 2060 ÷	#  ÷ [0.2] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER E (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER T (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER C (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] FULL STOP (ATerm) × [5.0] WORD JOINER (Format_FE) × [8.0] RIGHT PARENTHESIS (Close) × [5.0] WORD JOINER (Format_FE) × [8.0] RIGHT SINGLE QUOTATION MARK (Close) × [5.0] WORD JOINER (Format_FE) × [8.0] NO-BREAK SPACE (Sp) × [5.0] WORD JOINER (Format_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [8.0] LATIN SMALL LETTER T (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER H (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER E (Lower) × [5.0] WORD JOINER (Format_FE) × [5.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_SB('÷ 2060 × 0065 × 2060 × 0074 × 2060 × 0063 × 2060 × 002E × 2060 × 0029 × 2060 × 2019 × 2060 × 00A0 × 2060 × 0308 ÷ 0054 × 2060 × 0068 × 2060 × 0065 × 2060 × 2060 ÷	#  ÷ [0.2] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER E (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER T (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER C (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] FULL STOP (ATerm) × [5.0] WORD JOINER (Format_FE) × [9.0] RIGHT PARENTHESIS (Close) × [5.0] WORD JOINER (Format_FE) × [9.0] RIGHT SINGLE QUOTATION MARK (Close) × [5.0] WORD JOINER (Format_FE) × [9.0] NO-BREAK SPACE (Sp) × [5.0] WORD JOINER (Format_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) ÷ [11.0] LATIN CAPITAL LETTER T (Upper) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER H (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER E (Lower) × [5.0] WORD JOINER (Format_FE) × [5.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_SB('÷ 2060 × 0065 × 2060 × 0074 × 2060 × 0063 × 2060 × 002E × 2060 × 0029 × 2060 × 2019 × 2060 × 0308 ÷ 0054 × 2060 × 0068 × 2060 × 0065 × 2060 × 2060 ÷	#  ÷ [0.2] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER E (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER T (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER C (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] FULL STOP (ATerm) × [5.0] WORD JOINER (Format_FE) × [9.0] RIGHT PARENTHESIS (Close) × [5.0] WORD JOINER (Format_FE) × [9.0] RIGHT SINGLE QUOTATION MARK (Close) × [5.0] WORD JOINER (Format_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) ÷ [11.0] LATIN CAPITAL LETTER T (Upper) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER H (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER E (Lower) × [5.0] WORD JOINER (Format_FE) × [5.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_SB('÷ 2060 × 0065 × 2060 × 0074 × 2060 × 0063 × 2060 × 002E × 2060 × 0029 × 2060 × 000A ÷ 2060 × 0308 × 2060 × 0054 × 2060 × 0068 × 2060 × 0065 × 2060 × 2060 ÷	#  ÷ [0.2] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER E (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER T (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER C (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] FULL STOP (ATerm) × [5.0] WORD JOINER (Format_FE) × [9.0] RIGHT PARENTHESIS (Close) × [5.0] WORD JOINER (Format_FE) × [9.0] <LINE FEED (LF)> (LF) ÷ [4.0] WORD JOINER (Format_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN CAPITAL LETTER T (Upper) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER H (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER E (Lower) × [5.0] WORD JOINER (Format_FE) × [5.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_SB('÷ 2060 × 0074 × 2060 × 0068 × 2060 × 0065 × 2060 × 0020 × 2060 × 0072 × 2060 × 0065 × 2060 × 0073 × 2060 × 0070 × 2060 × 002E × 2060 × 0020 × 2060 × 006C × 2060 × 0065 × 2060 × 0061 × 2060 × 0064 × 2060 × 0065 × 2060 × 0072 × 2060 × 0073 × 2060 × 0020 × 2060 × 0061 × 2060 × 0072 × 2060 × 0065 × 2060 × 2060 ÷	#  ÷ [0.2] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER T (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER H (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER E (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] SPACE (Sp) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER R (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER E (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER S (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER P (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] FULL STOP (ATerm) × [5.0] WORD JOINER (Format_FE) × [8.0] SPACE (Sp) × [5.0] WORD JOINER (Format_FE) × [8.0] LATIN SMALL LETTER L (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER E (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER A (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER D (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER E (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER R (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER S (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] SPACE (Sp) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER A (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER R (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER E (Lower) × [5.0] WORD JOINER (Format_FE) × [5.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_SB('÷ 2060 × 5B57 × 2060 × 002E × 2060 ÷ 5B57 × 2060 × 2060 ÷	#  ÷ [0.2] WORD JOINER (Format_FE) × [998.0] CJK UNIFIED IDEOGRAPH-5B57 (OLetter) × [5.0] WORD JOINER (Format_FE) × [998.0] FULL STOP (ATerm) × [5.0] WORD JOINER (Format_FE) ÷ [11.0] CJK UNIFIED IDEOGRAPH-5B57 (OLetter) × [5.0] WORD JOINER (Format_FE) × [5.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_SB('÷ 2060 × 0065 × 2060 × 0074 × 2060 × 0063 × 2060 × 002E × 2060 ÷ 5B83 × 2060 × 2060 ÷	#  ÷ [0.2] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER E (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER T (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER C (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] FULL STOP (ATerm) × [5.0] WORD JOINER (Format_FE) ÷ [11.0] CJK UNIFIED IDEOGRAPH-5B83 (OLetter) × [5.0] WORD JOINER (Format_FE) × [5.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_SB('÷ 2060 × 0065 × 2060 × 0074 × 2060 × 0063 × 2060 × 002E × 2060 × 3002 × 2060 × 2060 ÷	#  ÷ [0.2] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER E (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER T (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER C (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] FULL STOP (ATerm) × [5.0] WORD JOINER (Format_FE) × [8.1] IDEOGRAPHIC FULL STOP (STerm) × [5.0] WORD JOINER (Format_FE) × [5.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_SB('÷ 2060 × 5B57 × 2060 × 3002 × 2060 ÷ 5B83 × 2060 × 2060 ÷	#  ÷ [0.2] WORD JOINER (Format_FE) × [998.0] CJK UNIFIED IDEOGRAPH-5B57 (OLetter) × [5.0] WORD JOINER (Format_FE) × [998.0] IDEOGRAPHIC FULL STOP (STerm) × [5.0] WORD JOINER (Format_FE) ÷ [11.0] CJK UNIFIED IDEOGRAPH-5B83 (OLetter) × [5.0] WORD JOINER (Format_FE) × [5.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_SB('÷ 2060 × 0021 × 2060 × 0020 × 2060 × 0020 × 2060 × 2060 ÷	#  ÷ [0.2] WORD JOINER (Format_FE) × [998.0] EXCLAMATION MARK (STerm) × [5.0] WORD JOINER (Format_FE) × [9.0] SPACE (Sp) × [5.0] WORD JOINER (Format_FE) × [10.0] SPACE (Sp) × [5.0] WORD JOINER (Format_FE) × [5.0] WORD JOINER (Format_FE) ÷ [0.3]');
}
if (!$::TESTCHUNK or $::TESTCHUNK == 6) {
    Test_LB('× 0023 × 0023 ÷	#  × [0.3] NUMBER SIGN (AL) × [28.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0023 × 0020 ÷ 0023 ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0023 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [28.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0023 ÷ 2014 ÷	#  × [0.3] NUMBER SIGN (AL) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0023 × 0020 ÷ 2014 ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0023 × 0308 ÷ 2014 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0023 × 0009 ÷	#  × [0.3] NUMBER SIGN (AL) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0023 × 0020 ÷ 0009 ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0009 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0023 ÷ 00B4 ÷	#  × [0.3] NUMBER SIGN (AL) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0023 × 0020 ÷ 00B4 ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0023 × 0308 ÷ 00B4 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0023 × 000B ÷	#  × [0.3] NUMBER SIGN (AL) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0023 × 0020 × 000B ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 000B ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 × 000B ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0023 ÷ FFFC ÷	#  × [0.3] NUMBER SIGN (AL) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0023 × 0020 ÷ FFFC ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0023 × 0308 ÷ FFFC ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0023 × 007D ÷	#  × [0.3] NUMBER SIGN (AL) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0023 × 0020 × 007D ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 007D ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 × 007D ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0023 × 000D ÷	#  × [0.3] NUMBER SIGN (AL) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0023 × 0020 × 000D ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 000D ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 × 000D ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0023 × 0021 ÷	#  × [0.3] NUMBER SIGN (AL) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0023 × 0020 × 0021 ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0021 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 × 0021 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0023 × 00A0 ÷	#  × [0.3] NUMBER SIGN (AL) × [12.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0023 × 0020 ÷ 00A0 ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 00A0 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0023 ÷ AC00 ÷	#  × [0.3] NUMBER SIGN (AL) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0023 × 0020 ÷ AC00 ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0023 × 0308 ÷ AC00 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0023 ÷ AC01 ÷	#  × [0.3] NUMBER SIGN (AL) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0023 × 0020 ÷ AC01 ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0023 × 0308 ÷ AC01 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0023 × 05D0 ÷	#  × [0.3] NUMBER SIGN (AL) × [28.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0023 × 0020 ÷ 05D0 ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 05D0 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [28.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0023 × 002D ÷	#  × [0.3] NUMBER SIGN (AL) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0023 × 0020 ÷ 002D ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 002D ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 ÷ 002D ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0023 ÷ 231A ÷	#  × [0.3] NUMBER SIGN (AL) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0023 × 0020 ÷ 231A ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0023 × 0308 ÷ 231A ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 ÷ 231A ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0023 × 2024 ÷	#  × [0.3] NUMBER SIGN (AL) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0023 × 0020 ÷ 2024 ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 2024 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0023 × 002C ÷	#  × [0.3] NUMBER SIGN (AL) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0023 × 0020 × 002C ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 002C ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 × 002C ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0023 ÷ 1100 ÷	#  × [0.3] NUMBER SIGN (AL) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0023 × 0020 ÷ 1100 ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0023 × 0308 ÷ 1100 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0023 ÷ 11A8 ÷	#  × [0.3] NUMBER SIGN (AL) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0023 × 0020 ÷ 11A8 ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0023 × 0308 ÷ 11A8 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0023 ÷ 1160 ÷	#  × [0.3] NUMBER SIGN (AL) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0023 × 0020 ÷ 1160 ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0023 × 0308 ÷ 1160 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0023 × 000A ÷	#  × [0.3] NUMBER SIGN (AL) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0023 × 0020 × 000A ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 000A ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 × 000A ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0023 × 0085 ÷	#  × [0.3] NUMBER SIGN (AL) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0023 × 0020 × 0085 ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0085 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 × 0085 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0023 × 17D6 ÷	#  × [0.3] NUMBER SIGN (AL) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0023 × 0020 ÷ 17D6 ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 17D6 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0023 × 0030 ÷	#  × [0.3] NUMBER SIGN (AL) × [23.02] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0023 × 0020 ÷ 0030 ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0030 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [23.02] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0023 ÷ 2329 ÷	#  × [0.3] NUMBER SIGN (AL) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 0023 × 0020 ÷ 2329 ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 0023 × 0308 ÷ 2329 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 ÷ 2329 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 0023 × 0025 ÷	#  × [0.3] NUMBER SIGN (AL) × [24.03] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0023 × 0020 ÷ 0025 ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0025 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [24.03] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0023 × 0024 ÷	#  × [0.3] NUMBER SIGN (AL) × [24.03] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0023 × 0020 ÷ 0024 ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0024 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [24.03] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0023 × 0022 ÷	#  × [0.3] NUMBER SIGN (AL) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0023 × 0020 ÷ 0022 ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0022 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0023 × 0020 ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0023 × 0020 × 0020 ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 × 0020 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0023 × 002F ÷	#  × [0.3] NUMBER SIGN (AL) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0023 × 0020 × 002F ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 002F ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 × 002F ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0023 × 2060 ÷	#  × [0.3] NUMBER SIGN (AL) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0023 × 0020 × 2060 ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 2060 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 × 2060 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0023 × 200B ÷	#  × [0.3] NUMBER SIGN (AL) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0023 × 0020 × 200B ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 200B ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 × 200B ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0023 ÷ 1F1E6 ÷	#  × [0.3] NUMBER SIGN (AL) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0023 × 0020 ÷ 1F1E6 ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0023 × 0308 ÷ 1F1E6 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0023 ÷ 261D ÷	#  × [0.3] NUMBER SIGN (AL) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0023 × 0020 ÷ 261D ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0023 × 0308 ÷ 261D ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 ÷ 261D ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0023 ÷ 1F3FB ÷	#  × [0.3] NUMBER SIGN (AL) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0023 × 0020 ÷ 1F3FB ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0023 × 0308 ÷ 1F3FB ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0023 × 0029 ÷	#  × [0.3] NUMBER SIGN (AL) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0023 × 0020 × 0029 ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0029 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 × 0029 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0023 × 0028 ÷	#  × [0.3] NUMBER SIGN (AL) × [30.01] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 0023 × 0020 ÷ 0028 ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0028 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [30.01] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 0023 × 0001 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0023 × 0020 ÷ 0001 ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0001 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0023 × 200D ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0023 × 0020 ÷ 200D ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 200D ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 ÷ 200D ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0023 × 00A7 ÷	#  × [0.3] NUMBER SIGN (AL) × [28.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0023 × 0020 ÷ 00A7 ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 00A7 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [28.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0023 × 50005 ÷	#  × [0.3] NUMBER SIGN (AL) × [28.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0023 × 0020 ÷ 50005 ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 50005 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [28.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0023 × 0E01 ÷	#  × [0.3] NUMBER SIGN (AL) × [28.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0023 × 0020 ÷ 0E01 ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0E01 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [28.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0023 × 3041 ÷	#  × [0.3] NUMBER SIGN (AL) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0023 × 0020 ÷ 3041 ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 3041 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 2014 ÷ 0023 ÷	#  × [0.3] EM DASH (B2) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 2014 × 0020 ÷ 0023 ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 2014 × 0308 ÷ 0023 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 2014 × 2014 ÷	#  × [0.3] EM DASH (B2) × [17.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 2014 × 0020 × 2014 ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) × [17.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 2014 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [17.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 × 2014 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [17.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 2014 × 0009 ÷	#  × [0.3] EM DASH (B2) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 2014 × 0020 ÷ 0009 ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0009 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 2014 ÷ 00B4 ÷	#  × [0.3] EM DASH (B2) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 2014 × 0020 ÷ 00B4 ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 2014 × 0308 ÷ 00B4 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 2014 × 000B ÷	#  × [0.3] EM DASH (B2) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 2014 × 0020 × 000B ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 000B ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 × 000B ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 2014 ÷ FFFC ÷	#  × [0.3] EM DASH (B2) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 2014 × 0020 ÷ FFFC ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 2014 × 0308 ÷ FFFC ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 2014 × 007D ÷	#  × [0.3] EM DASH (B2) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 2014 × 0020 × 007D ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 007D ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 × 007D ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 2014 × 000D ÷	#  × [0.3] EM DASH (B2) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 2014 × 0020 × 000D ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 000D ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 × 000D ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 2014 × 0021 ÷	#  × [0.3] EM DASH (B2) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 2014 × 0020 × 0021 ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0021 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 × 0021 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 2014 × 00A0 ÷	#  × [0.3] EM DASH (B2) × [12.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 2014 × 0020 ÷ 00A0 ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 00A0 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 2014 ÷ AC00 ÷	#  × [0.3] EM DASH (B2) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 2014 × 0020 ÷ AC00 ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 2014 × 0308 ÷ AC00 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 2014 ÷ AC01 ÷	#  × [0.3] EM DASH (B2) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 2014 × 0020 ÷ AC01 ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 2014 × 0308 ÷ AC01 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 2014 ÷ 05D0 ÷	#  × [0.3] EM DASH (B2) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 2014 × 0020 ÷ 05D0 ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 2014 × 0308 ÷ 05D0 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 2014 × 002D ÷	#  × [0.3] EM DASH (B2) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 2014 × 0020 ÷ 002D ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 002D ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 ÷ 002D ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 2014 ÷ 231A ÷	#  × [0.3] EM DASH (B2) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 2014 × 0020 ÷ 231A ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 2014 × 0308 ÷ 231A ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 ÷ 231A ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 2014 × 2024 ÷	#  × [0.3] EM DASH (B2) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 2014 × 0020 ÷ 2024 ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 2024 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 2014 × 002C ÷	#  × [0.3] EM DASH (B2) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 2014 × 0020 × 002C ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 002C ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 × 002C ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 2014 ÷ 1100 ÷	#  × [0.3] EM DASH (B2) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 2014 × 0020 ÷ 1100 ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 2014 × 0308 ÷ 1100 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 2014 ÷ 11A8 ÷	#  × [0.3] EM DASH (B2) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 2014 × 0020 ÷ 11A8 ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 2014 × 0308 ÷ 11A8 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 2014 ÷ 1160 ÷	#  × [0.3] EM DASH (B2) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 2014 × 0020 ÷ 1160 ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 2014 × 0308 ÷ 1160 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 2014 × 000A ÷	#  × [0.3] EM DASH (B2) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 2014 × 0020 × 000A ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 000A ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 × 000A ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 2014 × 0085 ÷	#  × [0.3] EM DASH (B2) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 2014 × 0020 × 0085 ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0085 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 × 0085 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 2014 × 17D6 ÷	#  × [0.3] EM DASH (B2) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 2014 × 0020 ÷ 17D6 ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 17D6 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 2014 ÷ 0030 ÷	#  × [0.3] EM DASH (B2) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 2014 × 0020 ÷ 0030 ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 2014 × 0308 ÷ 0030 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 2014 ÷ 2329 ÷	#  × [0.3] EM DASH (B2) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 2014 × 0020 ÷ 2329 ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 2014 × 0308 ÷ 2329 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 ÷ 2329 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 2014 ÷ 0025 ÷	#  × [0.3] EM DASH (B2) ÷ [999.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 2014 × 0020 ÷ 0025 ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 2014 × 0308 ÷ 0025 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 2014 ÷ 0024 ÷	#  × [0.3] EM DASH (B2) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 2014 × 0020 ÷ 0024 ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 2014 × 0308 ÷ 0024 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 2014 × 0022 ÷	#  × [0.3] EM DASH (B2) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 2014 × 0020 ÷ 0022 ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0022 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 2014 × 0020 ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 2014 × 0020 × 0020 ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 × 0020 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 2014 × 002F ÷	#  × [0.3] EM DASH (B2) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 2014 × 0020 × 002F ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 002F ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 × 002F ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 2014 × 2060 ÷	#  × [0.3] EM DASH (B2) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 2014 × 0020 × 2060 ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 2060 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 × 2060 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 2014 × 200B ÷	#  × [0.3] EM DASH (B2) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 2014 × 0020 × 200B ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 200B ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 × 200B ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 2014 ÷ 1F1E6 ÷	#  × [0.3] EM DASH (B2) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 2014 × 0020 ÷ 1F1E6 ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 2014 × 0308 ÷ 1F1E6 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 2014 ÷ 261D ÷	#  × [0.3] EM DASH (B2) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 2014 × 0020 ÷ 261D ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 2014 × 0308 ÷ 261D ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 ÷ 261D ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 2014 ÷ 1F3FB ÷	#  × [0.3] EM DASH (B2) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 2014 × 0020 ÷ 1F3FB ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 2014 × 0308 ÷ 1F3FB ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 2014 × 0029 ÷	#  × [0.3] EM DASH (B2) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 2014 × 0020 × 0029 ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0029 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 × 0029 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 2014 ÷ 0028 ÷	#  × [0.3] EM DASH (B2) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 2014 × 0020 ÷ 0028 ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 2014 × 0308 ÷ 0028 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 2014 × 0001 ÷	#  × [0.3] EM DASH (B2) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 2014 × 0020 ÷ 0001 ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0001 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 2014 × 200D ÷	#  × [0.3] EM DASH (B2) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 2014 × 0020 ÷ 200D ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 200D ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 ÷ 200D ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 2014 ÷ 00A7 ÷	#  × [0.3] EM DASH (B2) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 2014 × 0020 ÷ 00A7 ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 2014 × 0308 ÷ 00A7 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 2014 ÷ 50005 ÷	#  × [0.3] EM DASH (B2) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 2014 × 0020 ÷ 50005 ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 2014 × 0308 ÷ 50005 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 2014 ÷ 0E01 ÷	#  × [0.3] EM DASH (B2) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 2014 × 0020 ÷ 0E01 ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 2014 × 0308 ÷ 0E01 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 2014 × 3041 ÷	#  × [0.3] EM DASH (B2) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 2014 × 0020 ÷ 3041 ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 3041 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0009 ÷ 0023 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0009 × 0020 ÷ 0023 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0009 × 0308 ÷ 0023 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0009 ÷ 2014 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0009 × 0020 ÷ 2014 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0009 × 0308 ÷ 2014 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0009 × 0009 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0009 × 0020 ÷ 0009 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0009 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0009 ÷ 00B4 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0009 × 0020 ÷ 00B4 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0009 × 0308 ÷ 00B4 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0009 × 000B ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0009 × 0020 × 000B ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 000B ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 × 000B ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0009 ÷ FFFC ÷	#  × [0.3] <CHARACTER TABULATION> (BA) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0009 × 0020 ÷ FFFC ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0009 × 0308 ÷ FFFC ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0009 × 007D ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0009 × 0020 × 007D ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 007D ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 × 007D ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0009 × 000D ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0009 × 0020 × 000D ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 000D ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 × 000D ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0009 × 0021 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0009 × 0020 × 0021 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0021 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 × 0021 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0009 ÷ 00A0 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) ÷ [999.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0009 × 0020 ÷ 00A0 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0009 × 0308 ÷ 00A0 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0009 ÷ AC00 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0009 × 0020 ÷ AC00 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0009 × 0308 ÷ AC00 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0009 ÷ AC01 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0009 × 0020 ÷ AC01 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0009 × 0308 ÷ AC01 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0009 ÷ 05D0 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0009 × 0020 ÷ 05D0 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0009 × 0308 ÷ 05D0 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0009 × 002D ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0009 × 0020 ÷ 002D ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 002D ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 ÷ 002D ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0009 ÷ 231A ÷	#  × [0.3] <CHARACTER TABULATION> (BA) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0009 × 0020 ÷ 231A ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0009 × 0308 ÷ 231A ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 ÷ 231A ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0009 × 2024 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0009 × 0020 ÷ 2024 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 2024 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0009 × 002C ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0009 × 0020 × 002C ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 002C ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 × 002C ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0009 ÷ 1100 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0009 × 0020 ÷ 1100 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0009 × 0308 ÷ 1100 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0009 ÷ 11A8 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0009 × 0020 ÷ 11A8 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0009 × 0308 ÷ 11A8 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0009 ÷ 1160 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0009 × 0020 ÷ 1160 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0009 × 0308 ÷ 1160 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0009 × 000A ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0009 × 0020 × 000A ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 000A ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 × 000A ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0009 × 0085 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0009 × 0020 × 0085 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0085 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 × 0085 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0009 × 17D6 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0009 × 0020 ÷ 17D6 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 17D6 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0009 ÷ 0030 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0009 × 0020 ÷ 0030 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0009 × 0308 ÷ 0030 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0009 ÷ 2329 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 0009 × 0020 ÷ 2329 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 0009 × 0308 ÷ 2329 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 ÷ 2329 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 0009 ÷ 0025 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) ÷ [999.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0009 × 0020 ÷ 0025 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0009 × 0308 ÷ 0025 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0009 ÷ 0024 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0009 × 0020 ÷ 0024 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0009 × 0308 ÷ 0024 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0009 × 0022 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0009 × 0020 ÷ 0022 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0022 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0009 × 0020 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0009 × 0020 × 0020 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 × 0020 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0009 × 002F ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0009 × 0020 × 002F ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 002F ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 × 002F ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0009 × 2060 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0009 × 0020 × 2060 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 2060 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 × 2060 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0009 × 200B ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0009 × 0020 × 200B ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 200B ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 × 200B ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0009 ÷ 1F1E6 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0009 × 0020 ÷ 1F1E6 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0009 × 0308 ÷ 1F1E6 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0009 ÷ 261D ÷	#  × [0.3] <CHARACTER TABULATION> (BA) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0009 × 0020 ÷ 261D ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0009 × 0308 ÷ 261D ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 ÷ 261D ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0009 ÷ 1F3FB ÷	#  × [0.3] <CHARACTER TABULATION> (BA) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0009 × 0020 ÷ 1F3FB ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0009 × 0308 ÷ 1F3FB ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0009 × 0029 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0009 × 0020 × 0029 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0029 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 × 0029 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0009 ÷ 0028 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 0009 × 0020 ÷ 0028 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 0009 × 0308 ÷ 0028 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 0009 × 0001 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0009 × 0020 ÷ 0001 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0001 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0009 × 200D ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0009 × 0020 ÷ 200D ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 200D ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 ÷ 200D ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0009 ÷ 00A7 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0009 × 0020 ÷ 00A7 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0009 × 0308 ÷ 00A7 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0009 ÷ 50005 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0009 × 0020 ÷ 50005 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0009 × 0308 ÷ 50005 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0009 ÷ 0E01 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0009 × 0020 ÷ 0E01 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0009 × 0308 ÷ 0E01 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0009 × 3041 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0009 × 0020 ÷ 3041 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 3041 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 00B4 × 0023 ÷	#  × [0.3] ACUTE ACCENT (BB) × [21.04] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 ÷ 0023 ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0023 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.04] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 00B4 × 2014 ÷	#  × [0.3] ACUTE ACCENT (BB) × [21.04] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 ÷ 2014 ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 2014 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.04] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 00B4 × 0009 ÷	#  × [0.3] ACUTE ACCENT (BB) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 ÷ 0009 ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0009 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 00B4 × 00B4 ÷	#  × [0.3] ACUTE ACCENT (BB) × [21.04] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 ÷ 00B4 ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 00B4 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.04] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 00B4 × 000B ÷	#  × [0.3] ACUTE ACCENT (BB) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 × 000B ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 000B ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 × 000B ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 00B4 ÷ FFFC ÷	#  × [0.3] ACUTE ACCENT (BB) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 ÷ FFFC ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 ÷ FFFC ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 00B4 × 007D ÷	#  × [0.3] ACUTE ACCENT (BB) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 × 007D ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 007D ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 × 007D ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 00B4 × 000D ÷	#  × [0.3] ACUTE ACCENT (BB) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 × 000D ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 000D ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 × 000D ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 00B4 × 0021 ÷	#  × [0.3] ACUTE ACCENT (BB) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 × 0021 ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0021 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 × 0021 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 00B4 × 00A0 ÷	#  × [0.3] ACUTE ACCENT (BB) × [12.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 ÷ 00A0 ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 00A0 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 00B4 × AC00 ÷	#  × [0.3] ACUTE ACCENT (BB) × [21.04] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 ÷ AC00 ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × AC00 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.04] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 00B4 × AC01 ÷	#  × [0.3] ACUTE ACCENT (BB) × [21.04] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 ÷ AC01 ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × AC01 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.04] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 00B4 × 05D0 ÷	#  × [0.3] ACUTE ACCENT (BB) × [21.04] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 ÷ 05D0 ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 05D0 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.04] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 00B4 × 002D ÷	#  × [0.3] ACUTE ACCENT (BB) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 ÷ 002D ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 002D ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 ÷ 002D ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 00B4 × 231A ÷	#  × [0.3] ACUTE ACCENT (BB) × [21.04] WATCH (ID) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 ÷ 231A ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 231A ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.04] WATCH (ID) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 ÷ 231A ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 00B4 × 2024 ÷	#  × [0.3] ACUTE ACCENT (BB) × [21.04] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 ÷ 2024 ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 2024 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.04] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 00B4 × 002C ÷	#  × [0.3] ACUTE ACCENT (BB) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 × 002C ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 002C ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 × 002C ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 00B4 × 1100 ÷	#  × [0.3] ACUTE ACCENT (BB) × [21.04] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 ÷ 1100 ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 1100 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.04] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 00B4 × 11A8 ÷	#  × [0.3] ACUTE ACCENT (BB) × [21.04] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 ÷ 11A8 ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 11A8 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.04] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 00B4 × 1160 ÷	#  × [0.3] ACUTE ACCENT (BB) × [21.04] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 ÷ 1160 ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 1160 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.04] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 00B4 × 000A ÷	#  × [0.3] ACUTE ACCENT (BB) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 × 000A ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 000A ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 × 000A ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 00B4 × 0085 ÷	#  × [0.3] ACUTE ACCENT (BB) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 × 0085 ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0085 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 × 0085 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 00B4 × 17D6 ÷	#  × [0.3] ACUTE ACCENT (BB) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 ÷ 17D6 ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 17D6 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 00B4 × 0030 ÷	#  × [0.3] ACUTE ACCENT (BB) × [21.04] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 ÷ 0030 ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0030 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.04] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 00B4 × 2329 ÷	#  × [0.3] ACUTE ACCENT (BB) × [21.04] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 ÷ 2329 ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 2329 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.04] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 ÷ 2329 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 00B4 × 0025 ÷	#  × [0.3] ACUTE ACCENT (BB) × [21.04] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 ÷ 0025 ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0025 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.04] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 00B4 × 0024 ÷	#  × [0.3] ACUTE ACCENT (BB) × [21.04] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 ÷ 0024 ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0024 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.04] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 00B4 × 0022 ÷	#  × [0.3] ACUTE ACCENT (BB) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 ÷ 0022 ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0022 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 × 0020 ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 × 0020 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 00B4 × 002F ÷	#  × [0.3] ACUTE ACCENT (BB) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 × 002F ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 002F ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 × 002F ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 00B4 × 2060 ÷	#  × [0.3] ACUTE ACCENT (BB) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 × 2060 ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 2060 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 × 2060 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 00B4 × 200B ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 × 200B ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 200B ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 × 200B ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 00B4 × 1F1E6 ÷	#  × [0.3] ACUTE ACCENT (BB) × [21.04] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 ÷ 1F1E6 ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 1F1E6 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.04] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 00B4 × 261D ÷	#  × [0.3] ACUTE ACCENT (BB) × [21.04] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 ÷ 261D ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 261D ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.04] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 ÷ 261D ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 00B4 × 1F3FB ÷	#  × [0.3] ACUTE ACCENT (BB) × [21.04] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 ÷ 1F3FB ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 1F3FB ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.04] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 00B4 × 0029 ÷	#  × [0.3] ACUTE ACCENT (BB) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 × 0029 ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0029 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 × 0029 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 00B4 × 0028 ÷	#  × [0.3] ACUTE ACCENT (BB) × [21.04] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 ÷ 0028 ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0028 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.04] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 00B4 × 0001 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 ÷ 0001 ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0001 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 00B4 × 200D ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 ÷ 200D ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 200D ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 ÷ 200D ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 00B4 × 00A7 ÷	#  × [0.3] ACUTE ACCENT (BB) × [21.04] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 ÷ 00A7 ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 00A7 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.04] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 00B4 × 50005 ÷	#  × [0.3] ACUTE ACCENT (BB) × [21.04] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 ÷ 50005 ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 50005 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.04] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 00B4 × 0E01 ÷	#  × [0.3] ACUTE ACCENT (BB) × [21.04] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 ÷ 0E01 ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0E01 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.04] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 00B4 × 3041 ÷	#  × [0.3] ACUTE ACCENT (BB) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 ÷ 3041 ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 3041 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 000B ÷ 0023 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 ÷ 0023 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0023 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [28.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 ÷ 0023 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 000B ÷ 2014 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 ÷ 2014 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 ÷ 2014 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 ÷ 2014 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 000B ÷ 0009 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 ÷ 0009 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0009 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 ÷ 0009 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 000B ÷ 00B4 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 ÷ 00B4 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 ÷ 00B4 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 000B ÷ 000B ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 × 000B ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 000B ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 × 000B ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 000B ÷ FFFC ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 ÷ FFFC ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 ÷ FFFC ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 ÷ FFFC ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 000B ÷ 007D ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 × 007D ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 007D ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 × 007D ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 000B ÷ 000D ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 × 000D ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 000D ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 × 000D ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 000B ÷ 0021 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 × 0021 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0021 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 × 0021 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 000B ÷ 00A0 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 ÷ 00A0 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 00A0 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 000B ÷ AC00 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 ÷ AC00 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 ÷ AC00 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 ÷ AC00 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 000B ÷ AC01 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 ÷ AC01 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 ÷ AC01 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 ÷ AC01 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 000B ÷ 05D0 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 ÷ 05D0 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 05D0 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [28.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 000B ÷ 002D ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 ÷ 002D ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 002D ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 ÷ 002D ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 000B ÷ 231A ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 ÷ 231A ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 ÷ 231A ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 ÷ 231A ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 000B ÷ 2024 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 ÷ 2024 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 2024 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 ÷ 2024 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 000B ÷ 002C ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMMA (IS) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 × 002C ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 002C ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 × 002C ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 000B ÷ 1100 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 ÷ 1100 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 ÷ 1100 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 ÷ 1100 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 000B ÷ 11A8 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 ÷ 11A8 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 ÷ 11A8 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 000B ÷ 1160 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 ÷ 1160 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 ÷ 1160 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 ÷ 1160 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 000B ÷ 000A ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 × 000A ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 000A ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 × 000A ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 000B ÷ 0085 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 × 0085 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0085 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 × 0085 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 000B ÷ 17D6 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 ÷ 17D6 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 17D6 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 000B ÷ 0030 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 ÷ 0030 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0030 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [23.02] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 ÷ 0030 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 000B ÷ 2329 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 ÷ 2329 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 ÷ 2329 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 ÷ 2329 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 000B ÷ 0025 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 ÷ 0025 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0025 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [24.03] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 ÷ 0025 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 000B ÷ 0024 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 ÷ 0024 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0024 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [24.03] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 ÷ 0024 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 000B ÷ 0022 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 ÷ 0022 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0022 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 ÷ 0022 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 × 0020 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 × 0020 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 000B ÷ 002F ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 × 002F ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 002F ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 × 002F ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 000B ÷ 2060 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 × 2060 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 2060 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 × 2060 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 000B ÷ 200B ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 × 200B ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 200B ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 × 200B ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 000B ÷ 1F1E6 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 ÷ 1F1E6 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 ÷ 1F1E6 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 000B ÷ 261D ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 ÷ 261D ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 ÷ 261D ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 ÷ 261D ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 000B ÷ 1F3FB ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 ÷ 1F3FB ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 ÷ 1F3FB ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 000B ÷ 0029 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 × 0029 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0029 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 × 0029 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 000B ÷ 0028 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 ÷ 0028 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0028 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [30.01] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 ÷ 0028 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 000B ÷ 0001 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 ÷ 0001 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0001 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 ÷ 0001 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 000B ÷ 200D ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 ÷ 200D ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 200D ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 ÷ 200D ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 000B ÷ 00A7 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 ÷ 00A7 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 00A7 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [28.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 000B ÷ 50005 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 ÷ 50005 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 50005 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [28.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 ÷ 50005 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 000B ÷ 0E01 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 ÷ 0E01 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0E01 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [28.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 000B ÷ 3041 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 ÷ 3041 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 3041 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 ÷ 3041 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× FFFC ÷ 0023 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) ÷ [20.02] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× FFFC × 0020 ÷ 0023 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× FFFC × 0308 ÷ 0023 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.02] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× FFFC ÷ 2014 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) ÷ [20.02] EM DASH (B2) ÷ [0.3]');
    Test_LB('× FFFC × 0020 ÷ 2014 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× FFFC × 0308 ÷ 2014 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.02] EM DASH (B2) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× FFFC ÷ 0009 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) ÷ [20.02] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× FFFC × 0020 ÷ 0009 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× FFFC × 0308 ÷ 0009 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.02] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× FFFC ÷ 00B4 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) ÷ [20.02] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× FFFC × 0020 ÷ 00B4 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× FFFC × 0308 ÷ 00B4 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.02] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× FFFC × 000B ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× FFFC × 0020 × 000B ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 000B ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 × 000B ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× FFFC ÷ FFFC ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× FFFC × 0020 ÷ FFFC ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× FFFC × 0308 ÷ FFFC ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× FFFC × 007D ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× FFFC × 0020 × 007D ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 007D ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 × 007D ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× FFFC × 000D ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× FFFC × 0020 × 000D ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 000D ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 × 000D ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× FFFC × 0021 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× FFFC × 0020 × 0021 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0021 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 × 0021 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× FFFC × 00A0 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [12.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× FFFC × 0020 ÷ 00A0 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 00A0 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× FFFC ÷ AC00 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) ÷ [20.02] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× FFFC × 0020 ÷ AC00 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× FFFC × 0308 ÷ AC00 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.02] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× FFFC ÷ AC01 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) ÷ [20.02] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× FFFC × 0020 ÷ AC01 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× FFFC × 0308 ÷ AC01 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.02] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× FFFC ÷ 05D0 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) ÷ [20.02] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× FFFC × 0020 ÷ 05D0 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× FFFC × 0308 ÷ 05D0 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.02] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× FFFC ÷ 002D ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) ÷ [20.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× FFFC × 0020 ÷ 002D ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× FFFC × 0308 ÷ 002D ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 ÷ 002D ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× FFFC ÷ 231A ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) ÷ [20.02] WATCH (ID) ÷ [0.3]');
    Test_LB('× FFFC × 0020 ÷ 231A ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× FFFC × 0308 ÷ 231A ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.02] WATCH (ID) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 ÷ 231A ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× FFFC ÷ 2024 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) ÷ [20.02] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× FFFC × 0020 ÷ 2024 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× FFFC × 0308 ÷ 2024 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.02] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× FFFC × 002C ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× FFFC × 0020 × 002C ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 002C ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 × 002C ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× FFFC ÷ 1100 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) ÷ [20.02] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× FFFC × 0020 ÷ 1100 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× FFFC × 0308 ÷ 1100 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.02] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× FFFC ÷ 11A8 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) ÷ [20.02] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× FFFC × 0020 ÷ 11A8 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× FFFC × 0308 ÷ 11A8 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.02] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× FFFC ÷ 1160 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) ÷ [20.02] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× FFFC × 0020 ÷ 1160 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× FFFC × 0308 ÷ 1160 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.02] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× FFFC × 000A ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× FFFC × 0020 × 000A ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 000A ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 × 000A ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× FFFC × 0085 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× FFFC × 0020 × 0085 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0085 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 × 0085 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× FFFC ÷ 17D6 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) ÷ [20.02] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× FFFC × 0020 ÷ 17D6 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× FFFC × 0308 ÷ 17D6 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.02] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× FFFC ÷ 0030 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) ÷ [20.02] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× FFFC × 0020 ÷ 0030 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× FFFC × 0308 ÷ 0030 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.02] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× FFFC ÷ 2329 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) ÷ [20.02] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× FFFC × 0020 ÷ 2329 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× FFFC × 0308 ÷ 2329 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.02] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 ÷ 2329 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× FFFC ÷ 0025 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) ÷ [20.02] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× FFFC × 0020 ÷ 0025 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× FFFC × 0308 ÷ 0025 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.02] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× FFFC ÷ 0024 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) ÷ [20.02] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× FFFC × 0020 ÷ 0024 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× FFFC × 0308 ÷ 0024 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.02] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× FFFC × 0022 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× FFFC × 0020 ÷ 0022 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0022 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× FFFC × 0020 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× FFFC × 0020 × 0020 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 × 0020 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× FFFC × 002F ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× FFFC × 0020 × 002F ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 002F ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 × 002F ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× FFFC × 2060 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× FFFC × 0020 × 2060 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 2060 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 × 2060 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× FFFC × 200B ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× FFFC × 0020 × 200B ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 200B ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 × 200B ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× FFFC ÷ 1F1E6 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) ÷ [20.02] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× FFFC × 0020 ÷ 1F1E6 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× FFFC × 0308 ÷ 1F1E6 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.02] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× FFFC ÷ 261D ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) ÷ [20.02] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× FFFC × 0020 ÷ 261D ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× FFFC × 0308 ÷ 261D ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.02] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 ÷ 261D ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× FFFC ÷ 1F3FB ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) ÷ [20.02] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× FFFC × 0020 ÷ 1F3FB ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× FFFC × 0308 ÷ 1F3FB ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.02] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× FFFC × 0029 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× FFFC × 0020 × 0029 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0029 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 × 0029 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× FFFC ÷ 0028 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) ÷ [20.02] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× FFFC × 0020 ÷ 0028 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× FFFC × 0308 ÷ 0028 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.02] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× FFFC × 0001 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× FFFC × 0020 ÷ 0001 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0001 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× FFFC × 200D ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× FFFC × 0020 ÷ 200D ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 200D ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 ÷ 200D ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× FFFC ÷ 00A7 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) ÷ [20.02] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× FFFC × 0020 ÷ 00A7 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× FFFC × 0308 ÷ 00A7 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.02] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× FFFC ÷ 50005 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) ÷ [20.02] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× FFFC × 0020 ÷ 50005 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× FFFC × 0308 ÷ 50005 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.02] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× FFFC ÷ 0E01 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) ÷ [20.02] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× FFFC × 0020 ÷ 0E01 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× FFFC × 0308 ÷ 0E01 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.02] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× FFFC ÷ 3041 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) ÷ [20.02] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× FFFC × 0020 ÷ 3041 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× FFFC × 0308 ÷ 3041 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.02] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 007D ÷ 0023 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 007D × 0020 ÷ 0023 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 007D × 0308 ÷ 0023 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 007D ÷ 2014 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 007D × 0020 ÷ 2014 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 007D × 0308 ÷ 2014 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 007D × 0009 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 007D × 0020 ÷ 0009 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0009 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 007D ÷ 00B4 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 007D × 0020 ÷ 00B4 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 007D × 0308 ÷ 00B4 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 007D × 000B ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 007D × 0020 × 000B ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 000B ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 × 000B ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 007D ÷ FFFC ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 007D × 0020 ÷ FFFC ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 007D × 0308 ÷ FFFC ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 007D × 007D ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 007D × 0020 × 007D ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 007D ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 × 007D ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 007D × 000D ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 007D × 0020 × 000D ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 000D ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 × 000D ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 007D × 0021 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 007D × 0020 × 0021 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0021 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 × 0021 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 007D × 00A0 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [12.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 007D × 0020 ÷ 00A0 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 00A0 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 007D ÷ AC00 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 007D × 0020 ÷ AC00 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 007D × 0308 ÷ AC00 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 007D ÷ AC01 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 007D × 0020 ÷ AC01 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 007D × 0308 ÷ AC01 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 007D ÷ 05D0 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 007D × 0020 ÷ 05D0 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 007D × 0308 ÷ 05D0 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 007D × 002D ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 007D × 0020 ÷ 002D ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 002D ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 ÷ 002D ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 007D ÷ 231A ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 007D × 0020 ÷ 231A ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 007D × 0308 ÷ 231A ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 ÷ 231A ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 007D × 2024 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 007D × 0020 ÷ 2024 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 2024 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 007D × 002C ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 007D × 0020 × 002C ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 002C ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 × 002C ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 007D ÷ 1100 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 007D × 0020 ÷ 1100 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 007D × 0308 ÷ 1100 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 007D ÷ 11A8 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 007D × 0020 ÷ 11A8 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 007D × 0308 ÷ 11A8 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 007D ÷ 1160 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 007D × 0020 ÷ 1160 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 007D × 0308 ÷ 1160 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 007D × 000A ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 007D × 0020 × 000A ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 000A ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 × 000A ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 007D × 0085 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 007D × 0020 × 0085 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0085 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 × 0085 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 007D × 17D6 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [16.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 007D × 0020 × 17D6 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) × [16.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 17D6 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [16.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 × 17D6 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [16.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 007D ÷ 0030 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 007D × 0020 ÷ 0030 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 007D × 0308 ÷ 0030 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 007D ÷ 2329 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 007D × 0020 ÷ 2329 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 007D × 0308 ÷ 2329 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 ÷ 2329 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 007D ÷ 0025 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) ÷ [999.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 007D × 0020 ÷ 0025 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 007D × 0308 ÷ 0025 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 007D ÷ 0024 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 007D × 0020 ÷ 0024 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 007D × 0308 ÷ 0024 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 007D × 0022 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 007D × 0020 ÷ 0022 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0022 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 007D × 0020 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 007D × 0020 × 0020 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 × 0020 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 007D × 002F ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 007D × 0020 × 002F ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 002F ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 × 002F ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 007D × 2060 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 007D × 0020 × 2060 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 2060 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 × 2060 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 007D × 200B ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 007D × 0020 × 200B ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 200B ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 × 200B ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 007D ÷ 1F1E6 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 007D × 0020 ÷ 1F1E6 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 007D × 0308 ÷ 1F1E6 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 007D ÷ 261D ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 007D × 0020 ÷ 261D ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 007D × 0308 ÷ 261D ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 ÷ 261D ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 007D ÷ 1F3FB ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 007D × 0020 ÷ 1F3FB ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 007D × 0308 ÷ 1F3FB ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 007D × 0029 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 007D × 0020 × 0029 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0029 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 × 0029 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 007D ÷ 0028 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 007D × 0020 ÷ 0028 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 007D × 0308 ÷ 0028 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 007D × 0001 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 007D × 0020 ÷ 0001 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0001 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 007D × 200D ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 007D × 0020 ÷ 200D ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 200D ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 ÷ 200D ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 007D ÷ 00A7 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 007D × 0020 ÷ 00A7 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 007D × 0308 ÷ 00A7 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 007D ÷ 50005 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 007D × 0020 ÷ 50005 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 007D × 0308 ÷ 50005 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 007D ÷ 0E01 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 007D × 0020 ÷ 0E01 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 007D × 0308 ÷ 0E01 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 007D × 3041 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [16.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 007D × 0020 × 3041 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) × [16.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 3041 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [16.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 × 3041 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [16.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 000D ÷ 0023 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 ÷ 0023 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0023 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [28.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 ÷ 0023 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 000D ÷ 2014 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 ÷ 2014 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 ÷ 2014 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 ÷ 2014 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 000D ÷ 0009 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 ÷ 0009 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0009 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 ÷ 0009 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 000D ÷ 00B4 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 ÷ 00B4 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 ÷ 00B4 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 000D ÷ 000B ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 × 000B ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 000B ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 × 000B ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 000D ÷ FFFC ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 ÷ FFFC ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 ÷ FFFC ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 ÷ FFFC ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 000D ÷ 007D ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 × 007D ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 007D ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 × 007D ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 000D ÷ 000D ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 × 000D ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 000D ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 × 000D ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 000D ÷ 0021 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 × 0021 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0021 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 × 0021 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 000D ÷ 00A0 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 ÷ 00A0 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 00A0 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 000D ÷ AC00 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 ÷ AC00 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 ÷ AC00 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 ÷ AC00 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 000D ÷ AC01 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 ÷ AC01 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 ÷ AC01 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 ÷ AC01 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 000D ÷ 05D0 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 ÷ 05D0 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 05D0 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [28.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 000D ÷ 002D ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 ÷ 002D ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 002D ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 ÷ 002D ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 000D ÷ 231A ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] WATCH (ID) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 ÷ 231A ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 ÷ 231A ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 ÷ 231A ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 000D ÷ 2024 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 ÷ 2024 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 2024 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 ÷ 2024 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 000D ÷ 002C ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 × 002C ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 002C ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 × 002C ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 000D ÷ 1100 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 ÷ 1100 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 ÷ 1100 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 ÷ 1100 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 000D ÷ 11A8 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 ÷ 11A8 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 ÷ 11A8 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 000D ÷ 1160 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 ÷ 1160 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 ÷ 1160 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 ÷ 1160 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 000D × 000A ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) × [5.01] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 × 000A ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 000A ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 × 000A ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 000D ÷ 0085 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 × 0085 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0085 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 × 0085 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 000D ÷ 17D6 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 ÷ 17D6 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 17D6 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 000D ÷ 0030 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 ÷ 0030 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0030 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [23.02] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 ÷ 0030 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 000D ÷ 2329 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 ÷ 2329 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 ÷ 2329 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 ÷ 2329 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 000D ÷ 0025 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 ÷ 0025 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0025 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [24.03] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 ÷ 0025 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 000D ÷ 0024 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 ÷ 0024 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0024 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [24.03] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 ÷ 0024 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 000D ÷ 0022 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 ÷ 0022 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0022 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 ÷ 0022 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 × 0020 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 × 0020 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 000D ÷ 002F ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 × 002F ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 002F ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 × 002F ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 000D ÷ 2060 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 × 2060 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 2060 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 × 2060 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 000D ÷ 200B ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 × 200B ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 200B ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 × 200B ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 000D ÷ 1F1E6 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 ÷ 1F1E6 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 ÷ 1F1E6 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 000D ÷ 261D ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 ÷ 261D ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 ÷ 261D ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 ÷ 261D ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 000D ÷ 1F3FB ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 ÷ 1F3FB ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 ÷ 1F3FB ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 000D ÷ 0029 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 × 0029 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0029 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 × 0029 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 000D ÷ 0028 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 ÷ 0028 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0028 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [30.01] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 ÷ 0028 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 000D ÷ 0001 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 ÷ 0001 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0001 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 ÷ 0001 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 000D ÷ 200D ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 ÷ 200D ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 200D ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 ÷ 200D ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 000D ÷ 00A7 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 ÷ 00A7 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 00A7 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [28.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 000D ÷ 50005 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 ÷ 50005 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 50005 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [28.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 ÷ 50005 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 000D ÷ 0E01 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 ÷ 0E01 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0E01 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [28.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 000D ÷ 3041 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 ÷ 3041 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 3041 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 ÷ 3041 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0021 ÷ 0023 ÷	#  × [0.3] EXCLAMATION MARK (EX) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0021 × 0020 ÷ 0023 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0021 × 0308 ÷ 0023 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0021 ÷ 2014 ÷	#  × [0.3] EXCLAMATION MARK (EX) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0021 × 0020 ÷ 2014 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0021 × 0308 ÷ 2014 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0021 × 0009 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0021 × 0020 ÷ 0009 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0009 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0021 ÷ 00B4 ÷	#  × [0.3] EXCLAMATION MARK (EX) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0021 × 0020 ÷ 00B4 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0021 × 0308 ÷ 00B4 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0021 × 000B ÷	#  × [0.3] EXCLAMATION MARK (EX) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0021 × 0020 × 000B ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 000B ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 × 000B ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0021 ÷ FFFC ÷	#  × [0.3] EXCLAMATION MARK (EX) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0021 × 0020 ÷ FFFC ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0021 × 0308 ÷ FFFC ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0021 × 007D ÷	#  × [0.3] EXCLAMATION MARK (EX) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0021 × 0020 × 007D ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 007D ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 × 007D ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0021 × 000D ÷	#  × [0.3] EXCLAMATION MARK (EX) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0021 × 0020 × 000D ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 000D ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 × 000D ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0021 × 0021 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0021 × 0020 × 0021 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0021 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 × 0021 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0021 × 00A0 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [12.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0021 × 0020 ÷ 00A0 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 00A0 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0021 ÷ AC00 ÷	#  × [0.3] EXCLAMATION MARK (EX) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0021 × 0020 ÷ AC00 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0021 × 0308 ÷ AC00 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0021 ÷ AC01 ÷	#  × [0.3] EXCLAMATION MARK (EX) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0021 × 0020 ÷ AC01 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0021 × 0308 ÷ AC01 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0021 ÷ 05D0 ÷	#  × [0.3] EXCLAMATION MARK (EX) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0021 × 0020 ÷ 05D0 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0021 × 0308 ÷ 05D0 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0021 × 002D ÷	#  × [0.3] EXCLAMATION MARK (EX) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0021 × 0020 ÷ 002D ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 002D ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 ÷ 002D ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0021 ÷ 231A ÷	#  × [0.3] EXCLAMATION MARK (EX) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0021 × 0020 ÷ 231A ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0021 × 0308 ÷ 231A ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 ÷ 231A ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0021 × 2024 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0021 × 0020 ÷ 2024 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 2024 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0021 × 002C ÷	#  × [0.3] EXCLAMATION MARK (EX) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0021 × 0020 × 002C ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 002C ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 × 002C ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0021 ÷ 1100 ÷	#  × [0.3] EXCLAMATION MARK (EX) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0021 × 0020 ÷ 1100 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0021 × 0308 ÷ 1100 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0021 ÷ 11A8 ÷	#  × [0.3] EXCLAMATION MARK (EX) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0021 × 0020 ÷ 11A8 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0021 × 0308 ÷ 11A8 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0021 ÷ 1160 ÷	#  × [0.3] EXCLAMATION MARK (EX) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0021 × 0020 ÷ 1160 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0021 × 0308 ÷ 1160 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0021 × 000A ÷	#  × [0.3] EXCLAMATION MARK (EX) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0021 × 0020 × 000A ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 000A ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 × 000A ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0021 × 0085 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0021 × 0020 × 0085 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0085 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 × 0085 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0021 × 17D6 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0021 × 0020 ÷ 17D6 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 17D6 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0021 ÷ 0030 ÷	#  × [0.3] EXCLAMATION MARK (EX) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0021 × 0020 ÷ 0030 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0021 × 0308 ÷ 0030 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0021 ÷ 2329 ÷	#  × [0.3] EXCLAMATION MARK (EX) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 0021 × 0020 ÷ 2329 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 0021 × 0308 ÷ 2329 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 ÷ 2329 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 0021 ÷ 0025 ÷	#  × [0.3] EXCLAMATION MARK (EX) ÷ [999.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0021 × 0020 ÷ 0025 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0021 × 0308 ÷ 0025 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0021 ÷ 0024 ÷	#  × [0.3] EXCLAMATION MARK (EX) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0021 × 0020 ÷ 0024 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0021 × 0308 ÷ 0024 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0021 × 0022 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0021 × 0020 ÷ 0022 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0022 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0021 × 0020 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0021 × 0020 × 0020 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 × 0020 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0021 × 002F ÷	#  × [0.3] EXCLAMATION MARK (EX) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0021 × 0020 × 002F ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 002F ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 × 002F ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0021 × 2060 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0021 × 0020 × 2060 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 2060 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 × 2060 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0021 × 200B ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0021 × 0020 × 200B ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 200B ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 × 200B ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0021 ÷ 1F1E6 ÷	#  × [0.3] EXCLAMATION MARK (EX) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0021 × 0020 ÷ 1F1E6 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0021 × 0308 ÷ 1F1E6 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0021 ÷ 261D ÷	#  × [0.3] EXCLAMATION MARK (EX) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0021 × 0020 ÷ 261D ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0021 × 0308 ÷ 261D ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 ÷ 261D ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0021 ÷ 1F3FB ÷	#  × [0.3] EXCLAMATION MARK (EX) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0021 × 0020 ÷ 1F3FB ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0021 × 0308 ÷ 1F3FB ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0021 × 0029 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0021 × 0020 × 0029 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0029 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 × 0029 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0021 ÷ 0028 ÷	#  × [0.3] EXCLAMATION MARK (EX) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 0021 × 0020 ÷ 0028 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 0021 × 0308 ÷ 0028 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 0021 × 0001 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0021 × 0020 ÷ 0001 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0001 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0021 × 200D ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0021 × 0020 ÷ 200D ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 200D ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 ÷ 200D ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0021 ÷ 00A7 ÷	#  × [0.3] EXCLAMATION MARK (EX) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0021 × 0020 ÷ 00A7 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0021 × 0308 ÷ 00A7 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0021 ÷ 50005 ÷	#  × [0.3] EXCLAMATION MARK (EX) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0021 × 0020 ÷ 50005 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0021 × 0308 ÷ 50005 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0021 ÷ 0E01 ÷	#  × [0.3] EXCLAMATION MARK (EX) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0021 × 0020 ÷ 0E01 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0021 × 0308 ÷ 0E01 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0021 × 3041 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0021 × 0020 ÷ 3041 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 3041 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 00A0 × 0023 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 ÷ 0023 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0023 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 00A0 × 2014 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 ÷ 2014 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 2014 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 00A0 × 0009 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 ÷ 0009 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0009 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 00A0 × 00B4 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 ÷ 00B4 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 00B4 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 00A0 × 000B ÷	#  × [0.3] NO-BREAK SPACE (GL) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 × 000B ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 000B ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 × 000B ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 00A0 × FFFC ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 ÷ FFFC ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × FFFC ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 00A0 × 007D ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 × 007D ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 007D ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 × 007D ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 00A0 × 000D ÷	#  × [0.3] NO-BREAK SPACE (GL) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 × 000D ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 000D ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 × 000D ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 00A0 × 0021 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 × 0021 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0021 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 × 0021 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 00A0 × 00A0 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 ÷ 00A0 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 00A0 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 00A0 × AC00 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 ÷ AC00 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × AC00 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 00A0 × AC01 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 ÷ AC01 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × AC01 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 00A0 × 05D0 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 ÷ 05D0 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 05D0 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 00A0 × 002D ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 ÷ 002D ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 002D ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 ÷ 002D ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 00A0 × 231A ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 ÷ 231A ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 231A ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 ÷ 231A ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 00A0 × 2024 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 ÷ 2024 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 2024 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 00A0 × 002C ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] COMMA (IS) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 × 002C ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 002C ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] COMMA (IS) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 × 002C ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 00A0 × 1100 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 ÷ 1100 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 1100 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 00A0 × 11A8 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 ÷ 11A8 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 11A8 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 00A0 × 1160 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 ÷ 1160 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 1160 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 00A0 × 000A ÷	#  × [0.3] NO-BREAK SPACE (GL) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 × 000A ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 000A ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 × 000A ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 00A0 × 0085 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 × 0085 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0085 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 × 0085 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 00A0 × 17D6 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 ÷ 17D6 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 17D6 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 00A0 × 0030 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 ÷ 0030 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0030 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 00A0 × 2329 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 ÷ 2329 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 2329 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 ÷ 2329 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 00A0 × 0025 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 ÷ 0025 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0025 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 00A0 × 0024 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 ÷ 0024 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0024 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 00A0 × 0022 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 ÷ 0022 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0022 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 × 0020 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 × 0020 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 00A0 × 002F ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 × 002F ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 002F ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 × 002F ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 00A0 × 2060 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 × 2060 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 2060 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 × 2060 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 00A0 × 200B ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 × 200B ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 200B ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 × 200B ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 00A0 × 1F1E6 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 ÷ 1F1E6 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 1F1E6 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 00A0 × 261D ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 ÷ 261D ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 261D ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 ÷ 261D ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 00A0 × 1F3FB ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 ÷ 1F3FB ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 1F3FB ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 00A0 × 0029 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 × 0029 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0029 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 × 0029 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 00A0 × 0028 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 ÷ 0028 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0028 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 00A0 × 0001 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 ÷ 0001 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0001 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 00A0 × 200D ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 ÷ 200D ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 200D ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 ÷ 200D ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 00A0 × 00A7 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 ÷ 00A7 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 00A7 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 00A0 × 50005 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 ÷ 50005 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 50005 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 00A0 × 0E01 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 ÷ 0E01 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0E01 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 00A0 × 3041 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 ÷ 3041 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 3041 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× AC00 ÷ 0023 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× AC00 × 0020 ÷ 0023 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× AC00 × 0308 ÷ 0023 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× AC00 ÷ 2014 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× AC00 × 0020 ÷ 2014 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× AC00 × 0308 ÷ 2014 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× AC00 × 0009 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× AC00 × 0020 ÷ 0009 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0009 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× AC00 ÷ 00B4 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× AC00 × 0020 ÷ 00B4 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× AC00 × 0308 ÷ 00B4 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× AC00 × 000B ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× AC00 × 0020 × 000B ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 000B ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 × 000B ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× AC00 ÷ FFFC ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× AC00 × 0020 ÷ FFFC ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× AC00 × 0308 ÷ FFFC ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× AC00 × 007D ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× AC00 × 0020 × 007D ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 007D ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 × 007D ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× AC00 × 000D ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× AC00 × 0020 × 000D ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 000D ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 × 000D ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× AC00 × 0021 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× AC00 × 0020 × 0021 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0021 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 × 0021 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× AC00 × 00A0 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [12.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× AC00 × 0020 ÷ 00A0 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 00A0 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× AC00 ÷ AC00 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× AC00 × 0020 ÷ AC00 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× AC00 × 0308 ÷ AC00 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× AC00 ÷ AC01 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× AC00 × 0020 ÷ AC01 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× AC00 × 0308 ÷ AC01 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× AC00 ÷ 05D0 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× AC00 × 0020 ÷ 05D0 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× AC00 × 0308 ÷ 05D0 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× AC00 × 002D ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× AC00 × 0020 ÷ 002D ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 002D ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 ÷ 002D ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× AC00 ÷ 231A ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× AC00 × 0020 ÷ 231A ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× AC00 × 0308 ÷ 231A ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 ÷ 231A ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× AC00 × 2024 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× AC00 × 0020 ÷ 2024 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 2024 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× AC00 × 002C ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× AC00 × 0020 × 002C ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 002C ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 × 002C ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× AC00 ÷ 1100 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× AC00 × 0020 ÷ 1100 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× AC00 × 0308 ÷ 1100 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× AC00 × 11A8 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [26.02] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× AC00 × 0020 ÷ 11A8 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 11A8 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [26.02] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× AC00 × 1160 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [26.02] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× AC00 × 0020 ÷ 1160 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 1160 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [26.02] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× AC00 × 000A ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× AC00 × 0020 × 000A ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 000A ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 × 000A ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× AC00 × 0085 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× AC00 × 0020 × 0085 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0085 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 × 0085 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× AC00 × 17D6 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× AC00 × 0020 ÷ 17D6 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 17D6 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× AC00 ÷ 0030 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× AC00 × 0020 ÷ 0030 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× AC00 × 0308 ÷ 0030 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× AC00 ÷ 2329 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× AC00 × 0020 ÷ 2329 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× AC00 × 0308 ÷ 2329 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 ÷ 2329 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× AC00 × 0025 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [27.01] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× AC00 × 0020 ÷ 0025 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0025 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [27.01] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× AC00 ÷ 0024 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× AC00 × 0020 ÷ 0024 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× AC00 × 0308 ÷ 0024 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× AC00 × 0022 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× AC00 × 0020 ÷ 0022 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0022 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× AC00 × 0020 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× AC00 × 0020 × 0020 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 × 0020 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× AC00 × 002F ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× AC00 × 0020 × 002F ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 002F ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 × 002F ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× AC00 × 2060 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× AC00 × 0020 × 2060 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 2060 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 × 2060 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× AC00 × 200B ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× AC00 × 0020 × 200B ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 200B ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 × 200B ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× AC00 ÷ 1F1E6 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× AC00 × 0020 ÷ 1F1E6 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× AC00 × 0308 ÷ 1F1E6 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× AC00 ÷ 261D ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× AC00 × 0020 ÷ 261D ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× AC00 × 0308 ÷ 261D ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 ÷ 261D ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× AC00 ÷ 1F3FB ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× AC00 × 0020 ÷ 1F3FB ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× AC00 × 0308 ÷ 1F3FB ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× AC00 × 0029 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× AC00 × 0020 × 0029 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0029 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 × 0029 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× AC00 ÷ 0028 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× AC00 × 0020 ÷ 0028 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× AC00 × 0308 ÷ 0028 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× AC00 × 0001 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× AC00 × 0020 ÷ 0001 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0001 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× AC00 × 200D ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× AC00 × 0020 ÷ 200D ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 200D ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 ÷ 200D ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× AC00 ÷ 00A7 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× AC00 × 0020 ÷ 00A7 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× AC00 × 0308 ÷ 00A7 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× AC00 ÷ 50005 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× AC00 × 0020 ÷ 50005 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× AC00 × 0308 ÷ 50005 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× AC00 ÷ 0E01 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× AC00 × 0020 ÷ 0E01 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× AC00 × 0308 ÷ 0E01 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× AC00 × 3041 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× AC00 × 0020 ÷ 3041 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 3041 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× AC01 ÷ 0023 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× AC01 × 0020 ÷ 0023 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× AC01 × 0308 ÷ 0023 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× AC01 ÷ 2014 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× AC01 × 0020 ÷ 2014 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× AC01 × 0308 ÷ 2014 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× AC01 × 0009 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× AC01 × 0020 ÷ 0009 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0009 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× AC01 ÷ 00B4 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× AC01 × 0020 ÷ 00B4 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× AC01 × 0308 ÷ 00B4 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× AC01 × 000B ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× AC01 × 0020 × 000B ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 000B ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 × 000B ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× AC01 ÷ FFFC ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× AC01 × 0020 ÷ FFFC ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
}
if (!$::TESTCHUNK or $::TESTCHUNK == 7) {
    Test_LB('× AC01 × 0308 ÷ FFFC ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× AC01 × 007D ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× AC01 × 0020 × 007D ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 007D ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 × 007D ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× AC01 × 000D ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× AC01 × 0020 × 000D ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 000D ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 × 000D ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× AC01 × 0021 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× AC01 × 0020 × 0021 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0021 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 × 0021 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× AC01 × 00A0 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [12.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× AC01 × 0020 ÷ 00A0 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 00A0 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× AC01 ÷ AC00 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× AC01 × 0020 ÷ AC00 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× AC01 × 0308 ÷ AC00 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× AC01 ÷ AC01 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× AC01 × 0020 ÷ AC01 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× AC01 × 0308 ÷ AC01 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× AC01 ÷ 05D0 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× AC01 × 0020 ÷ 05D0 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× AC01 × 0308 ÷ 05D0 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× AC01 × 002D ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× AC01 × 0020 ÷ 002D ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 002D ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 ÷ 002D ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× AC01 ÷ 231A ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× AC01 × 0020 ÷ 231A ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× AC01 × 0308 ÷ 231A ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 ÷ 231A ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× AC01 × 2024 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× AC01 × 0020 ÷ 2024 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 2024 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× AC01 × 002C ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× AC01 × 0020 × 002C ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 002C ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 × 002C ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× AC01 ÷ 1100 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× AC01 × 0020 ÷ 1100 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× AC01 × 0308 ÷ 1100 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× AC01 × 11A8 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [26.03] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× AC01 × 0020 ÷ 11A8 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 11A8 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [26.03] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× AC01 ÷ 1160 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× AC01 × 0020 ÷ 1160 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× AC01 × 0308 ÷ 1160 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× AC01 × 000A ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× AC01 × 0020 × 000A ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 000A ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 × 000A ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× AC01 × 0085 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× AC01 × 0020 × 0085 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0085 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 × 0085 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× AC01 × 17D6 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× AC01 × 0020 ÷ 17D6 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 17D6 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× AC01 ÷ 0030 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× AC01 × 0020 ÷ 0030 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× AC01 × 0308 ÷ 0030 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× AC01 ÷ 2329 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× AC01 × 0020 ÷ 2329 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× AC01 × 0308 ÷ 2329 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 ÷ 2329 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× AC01 × 0025 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [27.01] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× AC01 × 0020 ÷ 0025 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0025 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [27.01] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× AC01 ÷ 0024 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× AC01 × 0020 ÷ 0024 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× AC01 × 0308 ÷ 0024 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× AC01 × 0022 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× AC01 × 0020 ÷ 0022 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0022 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× AC01 × 0020 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× AC01 × 0020 × 0020 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 × 0020 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× AC01 × 002F ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× AC01 × 0020 × 002F ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 002F ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 × 002F ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× AC01 × 2060 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× AC01 × 0020 × 2060 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 2060 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 × 2060 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× AC01 × 200B ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× AC01 × 0020 × 200B ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 200B ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 × 200B ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× AC01 ÷ 1F1E6 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× AC01 × 0020 ÷ 1F1E6 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× AC01 × 0308 ÷ 1F1E6 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× AC01 ÷ 261D ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× AC01 × 0020 ÷ 261D ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× AC01 × 0308 ÷ 261D ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 ÷ 261D ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× AC01 ÷ 1F3FB ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× AC01 × 0020 ÷ 1F3FB ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× AC01 × 0308 ÷ 1F3FB ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× AC01 × 0029 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× AC01 × 0020 × 0029 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0029 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 × 0029 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× AC01 ÷ 0028 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× AC01 × 0020 ÷ 0028 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× AC01 × 0308 ÷ 0028 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× AC01 × 0001 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× AC01 × 0020 ÷ 0001 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0001 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× AC01 × 200D ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× AC01 × 0020 ÷ 200D ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 200D ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 ÷ 200D ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× AC01 ÷ 00A7 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× AC01 × 0020 ÷ 00A7 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× AC01 × 0308 ÷ 00A7 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× AC01 ÷ 50005 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× AC01 × 0020 ÷ 50005 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× AC01 × 0308 ÷ 50005 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× AC01 ÷ 0E01 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× AC01 × 0020 ÷ 0E01 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× AC01 × 0308 ÷ 0E01 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× AC01 × 3041 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× AC01 × 0020 ÷ 3041 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 3041 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 05D0 × 0023 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [28.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 ÷ 0023 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0023 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [28.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 05D0 ÷ 2014 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 ÷ 2014 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 ÷ 2014 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 05D0 × 0009 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 ÷ 0009 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0009 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 05D0 ÷ 00B4 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 ÷ 00B4 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 ÷ 00B4 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 05D0 × 000B ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 × 000B ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 000B ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 × 000B ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 05D0 ÷ FFFC ÷	#  × [0.3] HEBREW LETTER ALEF (HL) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 ÷ FFFC ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 ÷ FFFC ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 05D0 × 007D ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 × 007D ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 007D ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 × 007D ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 05D0 × 000D ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 × 000D ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 000D ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 × 000D ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 05D0 × 0021 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 × 0021 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0021 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 × 0021 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 05D0 × 00A0 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [12.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 ÷ 00A0 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 00A0 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 05D0 ÷ AC00 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 ÷ AC00 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 ÷ AC00 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 05D0 ÷ AC01 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 ÷ AC01 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 ÷ AC01 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 05D0 × 05D0 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [28.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 ÷ 05D0 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 05D0 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [28.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 05D0 × 002D ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 ÷ 002D ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 002D ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 ÷ 002D ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 05D0 ÷ 231A ÷	#  × [0.3] HEBREW LETTER ALEF (HL) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 ÷ 231A ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 ÷ 231A ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 ÷ 231A ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 05D0 × 2024 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 ÷ 2024 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 2024 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 05D0 × 002C ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 × 002C ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 002C ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 × 002C ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 05D0 ÷ 1100 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 ÷ 1100 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 ÷ 1100 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 05D0 ÷ 11A8 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 ÷ 11A8 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 ÷ 11A8 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 05D0 ÷ 1160 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 ÷ 1160 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 ÷ 1160 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 05D0 × 000A ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 × 000A ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 000A ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 × 000A ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 05D0 × 0085 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 × 0085 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0085 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 × 0085 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 05D0 × 17D6 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 ÷ 17D6 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 17D6 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 05D0 × 0030 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [23.02] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 ÷ 0030 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0030 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [23.02] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 05D0 ÷ 2329 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 ÷ 2329 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 ÷ 2329 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 ÷ 2329 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 05D0 × 0025 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [24.03] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 ÷ 0025 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0025 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [24.03] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 05D0 × 0024 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [24.03] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 ÷ 0024 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0024 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [24.03] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 05D0 × 0022 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 ÷ 0022 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0022 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 × 0020 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 × 0020 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 05D0 × 002F ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 × 002F ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 002F ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 × 002F ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 05D0 × 2060 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 × 2060 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 2060 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 × 2060 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 05D0 × 200B ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 × 200B ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 200B ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 × 200B ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 05D0 ÷ 1F1E6 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 ÷ 1F1E6 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 ÷ 1F1E6 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 05D0 ÷ 261D ÷	#  × [0.3] HEBREW LETTER ALEF (HL) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 ÷ 261D ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 ÷ 261D ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 ÷ 261D ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 05D0 ÷ 1F3FB ÷	#  × [0.3] HEBREW LETTER ALEF (HL) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 ÷ 1F3FB ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 ÷ 1F3FB ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 05D0 × 0029 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 × 0029 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0029 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 × 0029 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 05D0 × 0028 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [30.01] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 ÷ 0028 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0028 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [30.01] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 05D0 × 0001 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 ÷ 0001 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0001 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 05D0 × 200D ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 ÷ 200D ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 200D ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 ÷ 200D ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 05D0 × 00A7 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [28.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 ÷ 00A7 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 00A7 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [28.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 05D0 × 50005 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [28.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 ÷ 50005 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 50005 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [28.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 05D0 × 0E01 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [28.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 ÷ 0E01 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0E01 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [28.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 05D0 × 3041 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 ÷ 3041 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 3041 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 002D ÷ 0023 ÷	#  × [0.3] HYPHEN-MINUS (HY) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 002D × 0020 ÷ 0023 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 002D × 0308 ÷ 0023 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 002D ÷ 2014 ÷	#  × [0.3] HYPHEN-MINUS (HY) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 002D × 0020 ÷ 2014 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 002D × 0308 ÷ 2014 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 002D × 0009 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 002D × 0020 ÷ 0009 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0009 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 002D ÷ 00B4 ÷	#  × [0.3] HYPHEN-MINUS (HY) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 002D × 0020 ÷ 00B4 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 002D × 0308 ÷ 00B4 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 002D × 000B ÷	#  × [0.3] HYPHEN-MINUS (HY) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 002D × 0020 × 000B ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 000B ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 × 000B ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 002D ÷ FFFC ÷	#  × [0.3] HYPHEN-MINUS (HY) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 002D × 0020 ÷ FFFC ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 002D × 0308 ÷ FFFC ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 002D × 007D ÷	#  × [0.3] HYPHEN-MINUS (HY) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 002D × 0020 × 007D ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 007D ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 × 007D ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 002D × 000D ÷	#  × [0.3] HYPHEN-MINUS (HY) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 002D × 0020 × 000D ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 000D ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 × 000D ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 002D × 0021 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 002D × 0020 × 0021 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0021 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 × 0021 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 002D ÷ 00A0 ÷	#  × [0.3] HYPHEN-MINUS (HY) ÷ [999.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 002D × 0020 ÷ 00A0 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 002D × 0308 ÷ 00A0 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 002D ÷ AC00 ÷	#  × [0.3] HYPHEN-MINUS (HY) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 002D × 0020 ÷ AC00 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 002D × 0308 ÷ AC00 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 002D ÷ AC01 ÷	#  × [0.3] HYPHEN-MINUS (HY) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 002D × 0020 ÷ AC01 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 002D × 0308 ÷ AC01 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 002D ÷ 05D0 ÷	#  × [0.3] HYPHEN-MINUS (HY) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 002D × 0020 ÷ 05D0 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 002D × 0308 ÷ 05D0 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 002D × 002D ÷	#  × [0.3] HYPHEN-MINUS (HY) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 002D × 0020 ÷ 002D ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 002D ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 ÷ 002D ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 002D ÷ 231A ÷	#  × [0.3] HYPHEN-MINUS (HY) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 002D × 0020 ÷ 231A ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 002D × 0308 ÷ 231A ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 ÷ 231A ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 002D × 2024 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 002D × 0020 ÷ 2024 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 2024 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 002D × 002C ÷	#  × [0.3] HYPHEN-MINUS (HY) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 002D × 0020 × 002C ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 002C ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 × 002C ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 002D ÷ 1100 ÷	#  × [0.3] HYPHEN-MINUS (HY) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 002D × 0020 ÷ 1100 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 002D × 0308 ÷ 1100 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 002D ÷ 11A8 ÷	#  × [0.3] HYPHEN-MINUS (HY) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 002D × 0020 ÷ 11A8 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 002D × 0308 ÷ 11A8 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 002D ÷ 1160 ÷	#  × [0.3] HYPHEN-MINUS (HY) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 002D × 0020 ÷ 1160 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 002D × 0308 ÷ 1160 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 002D × 000A ÷	#  × [0.3] HYPHEN-MINUS (HY) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 002D × 0020 × 000A ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 000A ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 × 000A ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 002D × 0085 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 002D × 0020 × 0085 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0085 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 × 0085 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 002D × 17D6 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 002D × 0020 ÷ 17D6 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 17D6 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 002D × 0030 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [25.02] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 002D × 0020 ÷ 0030 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0030 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [25.02] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 002D ÷ 2329 ÷	#  × [0.3] HYPHEN-MINUS (HY) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 002D × 0020 ÷ 2329 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 002D × 0308 ÷ 2329 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 ÷ 2329 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 002D ÷ 0025 ÷	#  × [0.3] HYPHEN-MINUS (HY) ÷ [999.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 002D × 0020 ÷ 0025 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 002D × 0308 ÷ 0025 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 002D ÷ 0024 ÷	#  × [0.3] HYPHEN-MINUS (HY) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 002D × 0020 ÷ 0024 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 002D × 0308 ÷ 0024 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 002D × 0022 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 002D × 0020 ÷ 0022 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0022 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 002D × 0020 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 002D × 0020 × 0020 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 × 0020 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 002D × 002F ÷	#  × [0.3] HYPHEN-MINUS (HY) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 002D × 0020 × 002F ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 002F ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 × 002F ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 002D × 2060 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 002D × 0020 × 2060 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 2060 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 × 2060 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 002D × 200B ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 002D × 0020 × 200B ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 200B ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 × 200B ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 002D ÷ 1F1E6 ÷	#  × [0.3] HYPHEN-MINUS (HY) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 002D × 0020 ÷ 1F1E6 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 002D × 0308 ÷ 1F1E6 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 002D ÷ 261D ÷	#  × [0.3] HYPHEN-MINUS (HY) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 002D × 0020 ÷ 261D ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 002D × 0308 ÷ 261D ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 ÷ 261D ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 002D ÷ 1F3FB ÷	#  × [0.3] HYPHEN-MINUS (HY) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 002D × 0020 ÷ 1F3FB ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 002D × 0308 ÷ 1F3FB ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 002D × 0029 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 002D × 0020 × 0029 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0029 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 × 0029 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 002D ÷ 0028 ÷	#  × [0.3] HYPHEN-MINUS (HY) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 002D × 0020 ÷ 0028 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 002D × 0308 ÷ 0028 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 002D × 0001 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 002D × 0020 ÷ 0001 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0001 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 002D × 200D ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 002D × 0020 ÷ 200D ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 200D ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 ÷ 200D ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 002D ÷ 00A7 ÷	#  × [0.3] HYPHEN-MINUS (HY) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 002D × 0020 ÷ 00A7 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 002D × 0308 ÷ 00A7 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 002D ÷ 50005 ÷	#  × [0.3] HYPHEN-MINUS (HY) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 002D × 0020 ÷ 50005 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 002D × 0308 ÷ 50005 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 002D ÷ 0E01 ÷	#  × [0.3] HYPHEN-MINUS (HY) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 002D × 0020 ÷ 0E01 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 002D × 0308 ÷ 0E01 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 002D × 3041 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 002D × 0020 ÷ 3041 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 3041 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 231A ÷ 0023 ÷	#  × [0.3] WATCH (ID) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 231A × 0020 ÷ 0023 ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 231A × 0308 ÷ 0023 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 231A ÷ 2014 ÷	#  × [0.3] WATCH (ID) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 231A × 0020 ÷ 2014 ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 231A × 0308 ÷ 2014 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 231A × 0009 ÷	#  × [0.3] WATCH (ID) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 231A × 0020 ÷ 0009 ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0009 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 231A ÷ 00B4 ÷	#  × [0.3] WATCH (ID) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 231A × 0020 ÷ 00B4 ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 231A × 0308 ÷ 00B4 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 231A × 000B ÷	#  × [0.3] WATCH (ID) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 231A × 0020 × 000B ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 000B ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 × 000B ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 231A ÷ FFFC ÷	#  × [0.3] WATCH (ID) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 231A × 0020 ÷ FFFC ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 231A × 0308 ÷ FFFC ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 231A × 007D ÷	#  × [0.3] WATCH (ID) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 231A × 0020 × 007D ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 007D ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 × 007D ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 231A × 000D ÷	#  × [0.3] WATCH (ID) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 231A × 0020 × 000D ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 000D ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 × 000D ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 231A × 0021 ÷	#  × [0.3] WATCH (ID) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 231A × 0020 × 0021 ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0021 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 × 0021 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 231A × 00A0 ÷	#  × [0.3] WATCH (ID) × [12.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 231A × 0020 ÷ 00A0 ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 00A0 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 231A ÷ AC00 ÷	#  × [0.3] WATCH (ID) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 231A × 0020 ÷ AC00 ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 231A × 0308 ÷ AC00 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 231A ÷ AC01 ÷	#  × [0.3] WATCH (ID) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 231A × 0020 ÷ AC01 ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 231A × 0308 ÷ AC01 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 231A ÷ 05D0 ÷	#  × [0.3] WATCH (ID) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 231A × 0020 ÷ 05D0 ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 231A × 0308 ÷ 05D0 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 231A × 002D ÷	#  × [0.3] WATCH (ID) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 231A × 0020 ÷ 002D ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 002D ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 ÷ 002D ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 231A ÷ 231A ÷	#  × [0.3] WATCH (ID) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 231A × 0020 ÷ 231A ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 231A × 0308 ÷ 231A ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 ÷ 231A ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 231A × 2024 ÷	#  × [0.3] WATCH (ID) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 231A × 0020 ÷ 2024 ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 2024 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 231A × 002C ÷	#  × [0.3] WATCH (ID) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 231A × 0020 × 002C ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 002C ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 × 002C ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 231A ÷ 1100 ÷	#  × [0.3] WATCH (ID) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 231A × 0020 ÷ 1100 ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 231A × 0308 ÷ 1100 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 231A ÷ 11A8 ÷	#  × [0.3] WATCH (ID) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 231A × 0020 ÷ 11A8 ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 231A × 0308 ÷ 11A8 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 231A ÷ 1160 ÷	#  × [0.3] WATCH (ID) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 231A × 0020 ÷ 1160 ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 231A × 0308 ÷ 1160 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 231A × 000A ÷	#  × [0.3] WATCH (ID) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 231A × 0020 × 000A ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 000A ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 × 000A ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 231A × 0085 ÷	#  × [0.3] WATCH (ID) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 231A × 0020 × 0085 ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0085 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 × 0085 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 231A × 17D6 ÷	#  × [0.3] WATCH (ID) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 231A × 0020 ÷ 17D6 ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 17D6 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 231A ÷ 0030 ÷	#  × [0.3] WATCH (ID) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 231A × 0020 ÷ 0030 ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 231A × 0308 ÷ 0030 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 231A ÷ 2329 ÷	#  × [0.3] WATCH (ID) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 231A × 0020 ÷ 2329 ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 231A × 0308 ÷ 2329 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 ÷ 2329 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 231A × 0025 ÷	#  × [0.3] WATCH (ID) × [23.13] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 231A × 0020 ÷ 0025 ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0025 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [23.13] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 231A ÷ 0024 ÷	#  × [0.3] WATCH (ID) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 231A × 0020 ÷ 0024 ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 231A × 0308 ÷ 0024 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 231A × 0022 ÷	#  × [0.3] WATCH (ID) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 231A × 0020 ÷ 0022 ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0022 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 231A × 0020 ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 231A × 0020 × 0020 ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 × 0020 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 231A × 002F ÷	#  × [0.3] WATCH (ID) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 231A × 0020 × 002F ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 002F ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 × 002F ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 231A × 2060 ÷	#  × [0.3] WATCH (ID) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 231A × 0020 × 2060 ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 2060 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 × 2060 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 231A × 200B ÷	#  × [0.3] WATCH (ID) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 231A × 0020 × 200B ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 200B ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 × 200B ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 231A ÷ 1F1E6 ÷	#  × [0.3] WATCH (ID) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 231A × 0020 ÷ 1F1E6 ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 231A × 0308 ÷ 1F1E6 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 231A ÷ 261D ÷	#  × [0.3] WATCH (ID) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 231A × 0020 ÷ 261D ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 231A × 0308 ÷ 261D ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 ÷ 261D ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 231A ÷ 1F3FB ÷	#  × [0.3] WATCH (ID) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 231A × 0020 ÷ 1F3FB ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 231A × 0308 ÷ 1F3FB ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 231A × 0029 ÷	#  × [0.3] WATCH (ID) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 231A × 0020 × 0029 ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0029 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 × 0029 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 231A ÷ 0028 ÷	#  × [0.3] WATCH (ID) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 231A × 0020 ÷ 0028 ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 231A × 0308 ÷ 0028 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 231A × 0001 ÷	#  × [0.3] WATCH (ID) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 231A × 0020 ÷ 0001 ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0001 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 231A × 200D ÷	#  × [0.3] WATCH (ID) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 231A × 0020 ÷ 200D ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 200D ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 ÷ 200D ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 231A ÷ 00A7 ÷	#  × [0.3] WATCH (ID) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 231A × 0020 ÷ 00A7 ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 231A × 0308 ÷ 00A7 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 231A ÷ 50005 ÷	#  × [0.3] WATCH (ID) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 231A × 0020 ÷ 50005 ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 231A × 0308 ÷ 50005 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 231A ÷ 0E01 ÷	#  × [0.3] WATCH (ID) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 231A × 0020 ÷ 0E01 ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 231A × 0308 ÷ 0E01 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 231A × 3041 ÷	#  × [0.3] WATCH (ID) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 231A × 0020 ÷ 3041 ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 3041 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 2024 ÷ 0023 ÷	#  × [0.3] ONE DOT LEADER (IN) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 2024 × 0020 ÷ 0023 ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 2024 × 0308 ÷ 0023 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 2024 ÷ 2014 ÷	#  × [0.3] ONE DOT LEADER (IN) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 2024 × 0020 ÷ 2014 ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 2024 × 0308 ÷ 2014 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 2024 × 0009 ÷	#  × [0.3] ONE DOT LEADER (IN) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 2024 × 0020 ÷ 0009 ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0009 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 2024 ÷ 00B4 ÷	#  × [0.3] ONE DOT LEADER (IN) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 2024 × 0020 ÷ 00B4 ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 2024 × 0308 ÷ 00B4 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 2024 × 000B ÷	#  × [0.3] ONE DOT LEADER (IN) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 2024 × 0020 × 000B ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 000B ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 × 000B ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 2024 ÷ FFFC ÷	#  × [0.3] ONE DOT LEADER (IN) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 2024 × 0020 ÷ FFFC ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 2024 × 0308 ÷ FFFC ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 2024 × 007D ÷	#  × [0.3] ONE DOT LEADER (IN) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 2024 × 0020 × 007D ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 007D ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 × 007D ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 2024 × 000D ÷	#  × [0.3] ONE DOT LEADER (IN) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 2024 × 0020 × 000D ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 000D ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 × 000D ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 2024 × 0021 ÷	#  × [0.3] ONE DOT LEADER (IN) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 2024 × 0020 × 0021 ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0021 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 × 0021 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 2024 × 00A0 ÷	#  × [0.3] ONE DOT LEADER (IN) × [12.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 2024 × 0020 ÷ 00A0 ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 00A0 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 2024 ÷ AC00 ÷	#  × [0.3] ONE DOT LEADER (IN) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 2024 × 0020 ÷ AC00 ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 2024 × 0308 ÷ AC00 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 2024 ÷ AC01 ÷	#  × [0.3] ONE DOT LEADER (IN) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 2024 × 0020 ÷ AC01 ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 2024 × 0308 ÷ AC01 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 2024 ÷ 05D0 ÷	#  × [0.3] ONE DOT LEADER (IN) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 2024 × 0020 ÷ 05D0 ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 2024 × 0308 ÷ 05D0 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 2024 × 002D ÷	#  × [0.3] ONE DOT LEADER (IN) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 2024 × 0020 ÷ 002D ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 002D ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 ÷ 002D ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 2024 ÷ 231A ÷	#  × [0.3] ONE DOT LEADER (IN) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 2024 × 0020 ÷ 231A ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 2024 × 0308 ÷ 231A ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 ÷ 231A ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 2024 × 2024 ÷	#  × [0.3] ONE DOT LEADER (IN) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 2024 × 0020 ÷ 2024 ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 2024 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 2024 × 002C ÷	#  × [0.3] ONE DOT LEADER (IN) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 2024 × 0020 × 002C ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 002C ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 × 002C ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 2024 ÷ 1100 ÷	#  × [0.3] ONE DOT LEADER (IN) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 2024 × 0020 ÷ 1100 ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 2024 × 0308 ÷ 1100 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 2024 ÷ 11A8 ÷	#  × [0.3] ONE DOT LEADER (IN) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 2024 × 0020 ÷ 11A8 ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 2024 × 0308 ÷ 11A8 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 2024 ÷ 1160 ÷	#  × [0.3] ONE DOT LEADER (IN) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 2024 × 0020 ÷ 1160 ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 2024 × 0308 ÷ 1160 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 2024 × 000A ÷	#  × [0.3] ONE DOT LEADER (IN) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 2024 × 0020 × 000A ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 000A ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 × 000A ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 2024 × 0085 ÷	#  × [0.3] ONE DOT LEADER (IN) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 2024 × 0020 × 0085 ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0085 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 × 0085 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 2024 × 17D6 ÷	#  × [0.3] ONE DOT LEADER (IN) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 2024 × 0020 ÷ 17D6 ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 17D6 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 2024 ÷ 0030 ÷	#  × [0.3] ONE DOT LEADER (IN) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 2024 × 0020 ÷ 0030 ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 2024 × 0308 ÷ 0030 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 2024 ÷ 2329 ÷	#  × [0.3] ONE DOT LEADER (IN) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 2024 × 0020 ÷ 2329 ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 2024 × 0308 ÷ 2329 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 ÷ 2329 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 2024 ÷ 0025 ÷	#  × [0.3] ONE DOT LEADER (IN) ÷ [999.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 2024 × 0020 ÷ 0025 ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 2024 × 0308 ÷ 0025 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 2024 ÷ 0024 ÷	#  × [0.3] ONE DOT LEADER (IN) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 2024 × 0020 ÷ 0024 ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 2024 × 0308 ÷ 0024 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 2024 × 0022 ÷	#  × [0.3] ONE DOT LEADER (IN) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 2024 × 0020 ÷ 0022 ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0022 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 2024 × 0020 ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 2024 × 0020 × 0020 ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 × 0020 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 2024 × 002F ÷	#  × [0.3] ONE DOT LEADER (IN) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 2024 × 0020 × 002F ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 002F ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 × 002F ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 2024 × 2060 ÷	#  × [0.3] ONE DOT LEADER (IN) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 2024 × 0020 × 2060 ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 2060 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 × 2060 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 2024 × 200B ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 2024 × 0020 × 200B ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 200B ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 × 200B ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 2024 ÷ 1F1E6 ÷	#  × [0.3] ONE DOT LEADER (IN) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 2024 × 0020 ÷ 1F1E6 ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 2024 × 0308 ÷ 1F1E6 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 2024 ÷ 261D ÷	#  × [0.3] ONE DOT LEADER (IN) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 2024 × 0020 ÷ 261D ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 2024 × 0308 ÷ 261D ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 ÷ 261D ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 2024 ÷ 1F3FB ÷	#  × [0.3] ONE DOT LEADER (IN) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 2024 × 0020 ÷ 1F3FB ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 2024 × 0308 ÷ 1F3FB ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 2024 × 0029 ÷	#  × [0.3] ONE DOT LEADER (IN) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 2024 × 0020 × 0029 ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0029 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 × 0029 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 2024 ÷ 0028 ÷	#  × [0.3] ONE DOT LEADER (IN) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 2024 × 0020 ÷ 0028 ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 2024 × 0308 ÷ 0028 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 2024 × 0001 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 2024 × 0020 ÷ 0001 ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0001 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 2024 × 200D ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 2024 × 0020 ÷ 200D ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 200D ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 ÷ 200D ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 2024 ÷ 00A7 ÷	#  × [0.3] ONE DOT LEADER (IN) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 2024 × 0020 ÷ 00A7 ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 2024 × 0308 ÷ 00A7 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 2024 ÷ 50005 ÷	#  × [0.3] ONE DOT LEADER (IN) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 2024 × 0020 ÷ 50005 ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 2024 × 0308 ÷ 50005 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 2024 ÷ 0E01 ÷	#  × [0.3] ONE DOT LEADER (IN) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 2024 × 0020 ÷ 0E01 ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 2024 × 0308 ÷ 0E01 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 2024 × 3041 ÷	#  × [0.3] ONE DOT LEADER (IN) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 2024 × 0020 ÷ 3041 ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 3041 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 002C × 0023 ÷	#  × [0.3] COMMA (IS) × [29.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 002C × 0020 ÷ 0023 ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0023 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [29.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 002C ÷ 2014 ÷	#  × [0.3] COMMA (IS) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 002C × 0020 ÷ 2014 ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 002C × 0308 ÷ 2014 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 002C × 0009 ÷	#  × [0.3] COMMA (IS) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 002C × 0020 ÷ 0009 ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0009 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 002C ÷ 00B4 ÷	#  × [0.3] COMMA (IS) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 002C × 0020 ÷ 00B4 ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 002C × 0308 ÷ 00B4 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 002C × 000B ÷	#  × [0.3] COMMA (IS) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 002C × 0020 × 000B ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 000B ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 × 000B ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 002C ÷ FFFC ÷	#  × [0.3] COMMA (IS) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 002C × 0020 ÷ FFFC ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 002C × 0308 ÷ FFFC ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 002C × 007D ÷	#  × [0.3] COMMA (IS) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 002C × 0020 × 007D ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 007D ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 × 007D ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 002C × 000D ÷	#  × [0.3] COMMA (IS) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 002C × 0020 × 000D ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 000D ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 × 000D ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 002C × 0021 ÷	#  × [0.3] COMMA (IS) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 002C × 0020 × 0021 ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0021 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 × 0021 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 002C × 00A0 ÷	#  × [0.3] COMMA (IS) × [12.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 002C × 0020 ÷ 00A0 ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 00A0 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 002C ÷ AC00 ÷	#  × [0.3] COMMA (IS) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 002C × 0020 ÷ AC00 ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 002C × 0308 ÷ AC00 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 002C ÷ AC01 ÷	#  × [0.3] COMMA (IS) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 002C × 0020 ÷ AC01 ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 002C × 0308 ÷ AC01 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 002C × 05D0 ÷	#  × [0.3] COMMA (IS) × [29.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 002C × 0020 ÷ 05D0 ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 05D0 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [29.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 002C × 002D ÷	#  × [0.3] COMMA (IS) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 002C × 0020 ÷ 002D ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 002D ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 ÷ 002D ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 002C ÷ 231A ÷	#  × [0.3] COMMA (IS) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 002C × 0020 ÷ 231A ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 002C × 0308 ÷ 231A ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 ÷ 231A ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 002C × 2024 ÷	#  × [0.3] COMMA (IS) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 002C × 0020 ÷ 2024 ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 2024 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 002C × 002C ÷	#  × [0.3] COMMA (IS) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 002C × 0020 × 002C ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 002C ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 × 002C ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 002C ÷ 1100 ÷	#  × [0.3] COMMA (IS) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 002C × 0020 ÷ 1100 ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 002C × 0308 ÷ 1100 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 002C ÷ 11A8 ÷	#  × [0.3] COMMA (IS) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 002C × 0020 ÷ 11A8 ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 002C × 0308 ÷ 11A8 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 002C ÷ 1160 ÷	#  × [0.3] COMMA (IS) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 002C × 0020 ÷ 1160 ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 002C × 0308 ÷ 1160 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 002C × 000A ÷	#  × [0.3] COMMA (IS) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 002C × 0020 × 000A ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 000A ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 × 000A ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 002C × 0085 ÷	#  × [0.3] COMMA (IS) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 002C × 0020 × 0085 ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0085 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 × 0085 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 002C × 17D6 ÷	#  × [0.3] COMMA (IS) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 002C × 0020 ÷ 17D6 ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 17D6 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 002C ÷ 0030 ÷	#  × [0.3] COMMA (IS) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 002C × 0020 ÷ 0030 ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 002C × 0308 ÷ 0030 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 002C ÷ 2329 ÷	#  × [0.3] COMMA (IS) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 002C × 0020 ÷ 2329 ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 002C × 0308 ÷ 2329 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 ÷ 2329 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 002C ÷ 0025 ÷	#  × [0.3] COMMA (IS) ÷ [999.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 002C × 0020 ÷ 0025 ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 002C × 0308 ÷ 0025 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 002C ÷ 0024 ÷	#  × [0.3] COMMA (IS) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 002C × 0020 ÷ 0024 ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 002C × 0308 ÷ 0024 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 002C × 0022 ÷	#  × [0.3] COMMA (IS) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 002C × 0020 ÷ 0022 ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0022 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 002C × 0020 ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 002C × 0020 × 0020 ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 × 0020 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 002C × 002F ÷	#  × [0.3] COMMA (IS) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 002C × 0020 × 002F ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 002F ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 × 002F ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 002C × 2060 ÷	#  × [0.3] COMMA (IS) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 002C × 0020 × 2060 ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 2060 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 × 2060 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 002C × 200B ÷	#  × [0.3] COMMA (IS) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 002C × 0020 × 200B ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 200B ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 × 200B ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 002C ÷ 1F1E6 ÷	#  × [0.3] COMMA (IS) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 002C × 0020 ÷ 1F1E6 ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 002C × 0308 ÷ 1F1E6 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 002C ÷ 261D ÷	#  × [0.3] COMMA (IS) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 002C × 0020 ÷ 261D ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 002C × 0308 ÷ 261D ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 ÷ 261D ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 002C ÷ 1F3FB ÷	#  × [0.3] COMMA (IS) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 002C × 0020 ÷ 1F3FB ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 002C × 0308 ÷ 1F3FB ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 002C × 0029 ÷	#  × [0.3] COMMA (IS) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 002C × 0020 × 0029 ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0029 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 × 0029 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 002C ÷ 0028 ÷	#  × [0.3] COMMA (IS) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 002C × 0020 ÷ 0028 ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 002C × 0308 ÷ 0028 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 002C × 0001 ÷	#  × [0.3] COMMA (IS) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 002C × 0020 ÷ 0001 ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0001 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 002C × 200D ÷	#  × [0.3] COMMA (IS) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 002C × 0020 ÷ 200D ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 200D ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 ÷ 200D ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 002C × 00A7 ÷	#  × [0.3] COMMA (IS) × [29.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 002C × 0020 ÷ 00A7 ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 00A7 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [29.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 002C × 50005 ÷	#  × [0.3] COMMA (IS) × [29.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 002C × 0020 ÷ 50005 ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 50005 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [29.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 002C × 0E01 ÷	#  × [0.3] COMMA (IS) × [29.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 002C × 0020 ÷ 0E01 ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0E01 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [29.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 002C × 3041 ÷	#  × [0.3] COMMA (IS) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 002C × 0020 ÷ 3041 ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 3041 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 1100 ÷ 0023 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 1100 × 0020 ÷ 0023 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 1100 × 0308 ÷ 0023 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 1100 ÷ 2014 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 1100 × 0020 ÷ 2014 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 1100 × 0308 ÷ 2014 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 1100 × 0009 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 1100 × 0020 ÷ 0009 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0009 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 1100 ÷ 00B4 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 1100 × 0020 ÷ 00B4 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 1100 × 0308 ÷ 00B4 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 1100 × 000B ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 1100 × 0020 × 000B ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 000B ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 × 000B ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 1100 ÷ FFFC ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 1100 × 0020 ÷ FFFC ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 1100 × 0308 ÷ FFFC ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 1100 × 007D ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 1100 × 0020 × 007D ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 007D ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 × 007D ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 1100 × 000D ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 1100 × 0020 × 000D ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 000D ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 × 000D ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 1100 × 0021 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 1100 × 0020 × 0021 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0021 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 × 0021 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 1100 × 00A0 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [12.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 1100 × 0020 ÷ 00A0 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 00A0 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 1100 × AC00 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [26.01] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 1100 × 0020 ÷ AC00 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × AC00 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [26.01] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 1100 × AC01 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [26.01] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 1100 × 0020 ÷ AC01 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × AC01 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [26.01] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 1100 ÷ 05D0 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 1100 × 0020 ÷ 05D0 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 1100 × 0308 ÷ 05D0 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 1100 × 002D ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 1100 × 0020 ÷ 002D ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 002D ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 ÷ 002D ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 1100 ÷ 231A ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 1100 × 0020 ÷ 231A ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 1100 × 0308 ÷ 231A ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 ÷ 231A ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 1100 × 2024 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 1100 × 0020 ÷ 2024 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 2024 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 1100 × 002C ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 1100 × 0020 × 002C ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 002C ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 × 002C ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 1100 × 1100 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [26.01] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 1100 × 0020 ÷ 1100 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 1100 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [26.01] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 1100 ÷ 11A8 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 1100 × 0020 ÷ 11A8 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 1100 × 0308 ÷ 11A8 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 1100 × 1160 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [26.01] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 1100 × 0020 ÷ 1160 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 1160 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [26.01] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 1100 × 000A ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 1100 × 0020 × 000A ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 000A ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 × 000A ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 1100 × 0085 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 1100 × 0020 × 0085 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0085 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 × 0085 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 1100 × 17D6 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 1100 × 0020 ÷ 17D6 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 17D6 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 1100 ÷ 0030 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 1100 × 0020 ÷ 0030 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 1100 × 0308 ÷ 0030 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 1100 ÷ 2329 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 1100 × 0020 ÷ 2329 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 1100 × 0308 ÷ 2329 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 ÷ 2329 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 1100 × 0025 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [27.01] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 1100 × 0020 ÷ 0025 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0025 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [27.01] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 1100 ÷ 0024 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 1100 × 0020 ÷ 0024 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 1100 × 0308 ÷ 0024 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 1100 × 0022 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 1100 × 0020 ÷ 0022 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0022 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 1100 × 0020 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 1100 × 0020 × 0020 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 × 0020 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 1100 × 002F ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 1100 × 0020 × 002F ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 002F ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 × 002F ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 1100 × 2060 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 1100 × 0020 × 2060 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 2060 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 × 2060 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 1100 × 200B ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 1100 × 0020 × 200B ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 200B ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 × 200B ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 1100 ÷ 1F1E6 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 1100 × 0020 ÷ 1F1E6 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 1100 × 0308 ÷ 1F1E6 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 1100 ÷ 261D ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 1100 × 0020 ÷ 261D ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 1100 × 0308 ÷ 261D ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 ÷ 261D ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 1100 ÷ 1F3FB ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 1100 × 0020 ÷ 1F3FB ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 1100 × 0308 ÷ 1F3FB ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 1100 × 0029 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 1100 × 0020 × 0029 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0029 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 × 0029 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 1100 ÷ 0028 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 1100 × 0020 ÷ 0028 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 1100 × 0308 ÷ 0028 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 1100 × 0001 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 1100 × 0020 ÷ 0001 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0001 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 1100 × 200D ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 1100 × 0020 ÷ 200D ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 200D ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 ÷ 200D ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 1100 ÷ 00A7 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 1100 × 0020 ÷ 00A7 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 1100 × 0308 ÷ 00A7 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 1100 ÷ 50005 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 1100 × 0020 ÷ 50005 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 1100 × 0308 ÷ 50005 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 1100 ÷ 0E01 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 1100 × 0020 ÷ 0E01 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 1100 × 0308 ÷ 0E01 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 1100 × 3041 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 1100 × 0020 ÷ 3041 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 3041 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 11A8 ÷ 0023 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 ÷ 0023 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 ÷ 0023 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 11A8 ÷ 2014 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 ÷ 2014 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 ÷ 2014 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 11A8 × 0009 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 ÷ 0009 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0009 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 11A8 ÷ 00B4 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 ÷ 00B4 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 ÷ 00B4 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 11A8 × 000B ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 × 000B ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 000B ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 × 000B ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 11A8 ÷ FFFC ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 ÷ FFFC ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 ÷ FFFC ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 11A8 × 007D ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 × 007D ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 007D ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 × 007D ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 11A8 × 000D ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 × 000D ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 000D ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 × 000D ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 11A8 × 0021 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 × 0021 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0021 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 × 0021 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 11A8 × 00A0 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [12.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 ÷ 00A0 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 00A0 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 11A8 ÷ AC00 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 ÷ AC00 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 ÷ AC00 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 11A8 ÷ AC01 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 ÷ AC01 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 ÷ AC01 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 11A8 ÷ 05D0 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 ÷ 05D0 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 ÷ 05D0 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 11A8 × 002D ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 ÷ 002D ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 002D ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 ÷ 002D ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 11A8 ÷ 231A ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 ÷ 231A ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 ÷ 231A ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 ÷ 231A ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 11A8 × 2024 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 ÷ 2024 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 2024 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 11A8 × 002C ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 × 002C ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 002C ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 × 002C ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 11A8 ÷ 1100 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 ÷ 1100 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 ÷ 1100 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 11A8 × 11A8 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [26.03] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 ÷ 11A8 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 11A8 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [26.03] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 11A8 ÷ 1160 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 ÷ 1160 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 ÷ 1160 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 11A8 × 000A ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 × 000A ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 000A ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 × 000A ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 11A8 × 0085 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 × 0085 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0085 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 × 0085 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 11A8 × 17D6 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 ÷ 17D6 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 17D6 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 11A8 ÷ 0030 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 ÷ 0030 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 ÷ 0030 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 11A8 ÷ 2329 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 ÷ 2329 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 ÷ 2329 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 ÷ 2329 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 11A8 × 0025 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [27.01] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 ÷ 0025 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0025 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [27.01] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 11A8 ÷ 0024 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 ÷ 0024 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 ÷ 0024 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 11A8 × 0022 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 ÷ 0022 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0022 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 × 0020 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 × 0020 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 11A8 × 002F ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 × 002F ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 002F ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 × 002F ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 11A8 × 2060 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 × 2060 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 2060 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 × 2060 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 11A8 × 200B ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 × 200B ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 200B ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 × 200B ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 11A8 ÷ 1F1E6 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 ÷ 1F1E6 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 ÷ 1F1E6 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 11A8 ÷ 261D ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 ÷ 261D ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 ÷ 261D ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 ÷ 261D ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 11A8 ÷ 1F3FB ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 ÷ 1F3FB ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 ÷ 1F3FB ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 11A8 × 0029 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 × 0029 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0029 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 × 0029 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 11A8 ÷ 0028 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 ÷ 0028 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 ÷ 0028 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 11A8 × 0001 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 ÷ 0001 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0001 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 11A8 × 200D ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 ÷ 200D ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 200D ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 ÷ 200D ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 11A8 ÷ 00A7 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 ÷ 00A7 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 ÷ 00A7 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 11A8 ÷ 50005 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 ÷ 50005 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 ÷ 50005 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 11A8 ÷ 0E01 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 ÷ 0E01 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 ÷ 0E01 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 11A8 × 3041 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 ÷ 3041 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 3041 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 1160 ÷ 0023 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 1160 × 0020 ÷ 0023 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 1160 × 0308 ÷ 0023 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 1160 ÷ 2014 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 1160 × 0020 ÷ 2014 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 1160 × 0308 ÷ 2014 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 1160 × 0009 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 1160 × 0020 ÷ 0009 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0009 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 1160 ÷ 00B4 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 1160 × 0020 ÷ 00B4 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 1160 × 0308 ÷ 00B4 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 1160 × 000B ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 1160 × 0020 × 000B ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 000B ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 × 000B ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 1160 ÷ FFFC ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 1160 × 0020 ÷ FFFC ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 1160 × 0308 ÷ FFFC ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 1160 × 007D ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 1160 × 0020 × 007D ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 007D ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 × 007D ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 1160 × 000D ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 1160 × 0020 × 000D ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 000D ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 × 000D ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 1160 × 0021 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 1160 × 0020 × 0021 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0021 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 × 0021 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 1160 × 00A0 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [12.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 1160 × 0020 ÷ 00A0 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 00A0 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 1160 ÷ AC00 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 1160 × 0020 ÷ AC00 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 1160 × 0308 ÷ AC00 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 1160 ÷ AC01 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 1160 × 0020 ÷ AC01 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 1160 × 0308 ÷ AC01 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 1160 ÷ 05D0 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 1160 × 0020 ÷ 05D0 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 1160 × 0308 ÷ 05D0 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 1160 × 002D ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 1160 × 0020 ÷ 002D ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 002D ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 ÷ 002D ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 1160 ÷ 231A ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 1160 × 0020 ÷ 231A ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 1160 × 0308 ÷ 231A ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 ÷ 231A ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 1160 × 2024 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 1160 × 0020 ÷ 2024 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 2024 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 1160 × 002C ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 1160 × 0020 × 002C ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 002C ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 × 002C ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 1160 ÷ 1100 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 1160 × 0020 ÷ 1100 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 1160 × 0308 ÷ 1100 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 1160 × 11A8 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [26.02] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 1160 × 0020 ÷ 11A8 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 11A8 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [26.02] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 1160 × 1160 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [26.02] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 1160 × 0020 ÷ 1160 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 1160 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [26.02] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 1160 × 000A ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 1160 × 0020 × 000A ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 000A ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 × 000A ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 1160 × 0085 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 1160 × 0020 × 0085 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0085 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 × 0085 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 1160 × 17D6 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 1160 × 0020 ÷ 17D6 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 17D6 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 1160 ÷ 0030 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 1160 × 0020 ÷ 0030 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 1160 × 0308 ÷ 0030 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 1160 ÷ 2329 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 1160 × 0020 ÷ 2329 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 1160 × 0308 ÷ 2329 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 ÷ 2329 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 1160 × 0025 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [27.01] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 1160 × 0020 ÷ 0025 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0025 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [27.01] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 1160 ÷ 0024 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 1160 × 0020 ÷ 0024 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 1160 × 0308 ÷ 0024 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 1160 × 0022 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 1160 × 0020 ÷ 0022 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0022 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 1160 × 0020 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 1160 × 0020 × 0020 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 × 0020 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 1160 × 002F ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 1160 × 0020 × 002F ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 002F ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 × 002F ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 1160 × 2060 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 1160 × 0020 × 2060 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 2060 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 × 2060 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 1160 × 200B ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 1160 × 0020 × 200B ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 200B ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 × 200B ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 1160 ÷ 1F1E6 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 1160 × 0020 ÷ 1F1E6 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 1160 × 0308 ÷ 1F1E6 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 1160 ÷ 261D ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 1160 × 0020 ÷ 261D ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 1160 × 0308 ÷ 261D ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 ÷ 261D ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 1160 ÷ 1F3FB ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 1160 × 0020 ÷ 1F3FB ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 1160 × 0308 ÷ 1F3FB ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 1160 × 0029 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 1160 × 0020 × 0029 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0029 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 × 0029 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 1160 ÷ 0028 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 1160 × 0020 ÷ 0028 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 1160 × 0308 ÷ 0028 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 1160 × 0001 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 1160 × 0020 ÷ 0001 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0001 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 1160 × 200D ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 1160 × 0020 ÷ 200D ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 200D ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 ÷ 200D ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 1160 ÷ 00A7 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 1160 × 0020 ÷ 00A7 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 1160 × 0308 ÷ 00A7 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 1160 ÷ 50005 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 1160 × 0020 ÷ 50005 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 1160 × 0308 ÷ 50005 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 1160 ÷ 0E01 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 1160 × 0020 ÷ 0E01 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 1160 × 0308 ÷ 0E01 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 1160 × 3041 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 1160 × 0020 ÷ 3041 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 3041 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 000A ÷ 0023 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 ÷ 0023 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0023 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [28.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 ÷ 0023 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 000A ÷ 2014 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 ÷ 2014 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 ÷ 2014 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 ÷ 2014 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 000A ÷ 0009 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 ÷ 0009 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0009 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 ÷ 0009 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 000A ÷ 00B4 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 ÷ 00B4 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 ÷ 00B4 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 000A ÷ 000B ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 × 000B ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 000B ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 × 000B ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 000A ÷ FFFC ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 ÷ FFFC ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 ÷ FFFC ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 ÷ FFFC ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 000A ÷ 007D ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 × 007D ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 007D ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 × 007D ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 000A ÷ 000D ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 × 000D ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 000D ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 × 000D ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 000A ÷ 0021 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 × 0021 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0021 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 × 0021 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 000A ÷ 00A0 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 ÷ 00A0 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 00A0 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 000A ÷ AC00 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 ÷ AC00 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 ÷ AC00 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 ÷ AC00 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 000A ÷ AC01 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 ÷ AC01 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 ÷ AC01 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 ÷ AC01 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 000A ÷ 05D0 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 ÷ 05D0 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 05D0 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [28.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 000A ÷ 002D ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 ÷ 002D ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 002D ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 ÷ 002D ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 000A ÷ 231A ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] WATCH (ID) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 ÷ 231A ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 ÷ 231A ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 ÷ 231A ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 000A ÷ 2024 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 ÷ 2024 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 2024 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 ÷ 2024 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 000A ÷ 002C ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 × 002C ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 002C ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 × 002C ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 000A ÷ 1100 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 ÷ 1100 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 ÷ 1100 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 ÷ 1100 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 000A ÷ 11A8 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 ÷ 11A8 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 ÷ 11A8 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 000A ÷ 1160 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 ÷ 1160 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 ÷ 1160 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 ÷ 1160 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 000A ÷ 000A ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 × 000A ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 000A ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 × 000A ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 000A ÷ 0085 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 × 0085 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0085 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 × 0085 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 000A ÷ 17D6 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 ÷ 17D6 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 17D6 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 000A ÷ 0030 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 ÷ 0030 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0030 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [23.02] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 ÷ 0030 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 000A ÷ 2329 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 ÷ 2329 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 ÷ 2329 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 ÷ 2329 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 000A ÷ 0025 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 ÷ 0025 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0025 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [24.03] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 ÷ 0025 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 000A ÷ 0024 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 ÷ 0024 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0024 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [24.03] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 ÷ 0024 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 000A ÷ 0022 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 ÷ 0022 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0022 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 ÷ 0022 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 × 0020 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 × 0020 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 000A ÷ 002F ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 × 002F ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 002F ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 × 002F ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 000A ÷ 2060 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 × 2060 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 2060 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 × 2060 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 000A ÷ 200B ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 × 200B ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 200B ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 × 200B ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 000A ÷ 1F1E6 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 ÷ 1F1E6 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 ÷ 1F1E6 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 000A ÷ 261D ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 ÷ 261D ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 ÷ 261D ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 ÷ 261D ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 000A ÷ 1F3FB ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 ÷ 1F3FB ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 ÷ 1F3FB ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 000A ÷ 0029 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 × 0029 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0029 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 × 0029 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 000A ÷ 0028 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 ÷ 0028 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0028 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [30.01] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 ÷ 0028 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 000A ÷ 0001 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 ÷ 0001 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0001 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 ÷ 0001 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 000A ÷ 200D ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 ÷ 200D ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 200D ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 ÷ 200D ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 000A ÷ 00A7 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 ÷ 00A7 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 00A7 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [28.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 000A ÷ 50005 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 ÷ 50005 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 50005 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [28.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 ÷ 50005 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 000A ÷ 0E01 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 ÷ 0E01 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0E01 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [28.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 000A ÷ 3041 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 ÷ 3041 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 3041 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 ÷ 3041 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0023 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 ÷ 0023 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0023 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [28.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 ÷ 0023 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 2014 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 ÷ 2014 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 ÷ 2014 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 ÷ 2014 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0009 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 ÷ 0009 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0009 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 ÷ 0009 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0085 ÷ 00B4 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 ÷ 00B4 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 ÷ 00B4 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0085 ÷ 000B ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 × 000B ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 000B ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 × 000B ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0085 ÷ FFFC ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 ÷ FFFC ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 ÷ FFFC ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 ÷ FFFC ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0085 ÷ 007D ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 × 007D ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 007D ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 × 007D ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 000D ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 × 000D ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 000D ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 × 000D ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0021 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 × 0021 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0021 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 × 0021 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0085 ÷ 00A0 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 ÷ 00A0 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 00A0 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0085 ÷ AC00 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 ÷ AC00 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 ÷ AC00 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 ÷ AC00 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0085 ÷ AC01 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 ÷ AC01 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 ÷ AC01 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 ÷ AC01 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0085 ÷ 05D0 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 ÷ 05D0 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 05D0 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [28.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 002D ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 ÷ 002D ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 002D ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 ÷ 002D ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0085 ÷ 231A ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 ÷ 231A ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 ÷ 231A ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 ÷ 231A ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0085 ÷ 2024 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 ÷ 2024 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 2024 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 ÷ 2024 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0085 ÷ 002C ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 × 002C ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 002C ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 × 002C ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0085 ÷ 1100 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 ÷ 1100 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 ÷ 1100 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 ÷ 1100 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 11A8 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 ÷ 11A8 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 ÷ 11A8 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0085 ÷ 1160 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 ÷ 1160 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 ÷ 1160 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 ÷ 1160 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0085 ÷ 000A ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 × 000A ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 000A ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 × 000A ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0085 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 × 0085 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0085 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 × 0085 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 17D6 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 ÷ 17D6 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 17D6 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0030 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 ÷ 0030 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0030 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [23.02] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 ÷ 0030 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0085 ÷ 2329 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 ÷ 2329 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 ÷ 2329 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 ÷ 2329 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0025 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 ÷ 0025 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0025 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [24.03] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 ÷ 0025 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0024 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 ÷ 0024 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0024 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [24.03] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 ÷ 0024 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0022 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 ÷ 0022 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0022 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 ÷ 0022 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 × 0020 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 × 0020 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0085 ÷ 002F ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 × 002F ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 002F ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 × 002F ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0085 ÷ 2060 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 × 2060 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 2060 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 × 2060 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0085 ÷ 200B ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 × 200B ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 200B ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 × 200B ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0085 ÷ 1F1E6 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 ÷ 1F1E6 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 ÷ 1F1E6 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0085 ÷ 261D ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 ÷ 261D ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 ÷ 261D ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 ÷ 261D ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0085 ÷ 1F3FB ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 ÷ 1F3FB ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 ÷ 1F3FB ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0029 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 × 0029 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0029 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 × 0029 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0028 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 ÷ 0028 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0028 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [30.01] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 ÷ 0028 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0001 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 ÷ 0001 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0001 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 ÷ 0001 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0085 ÷ 200D ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 ÷ 200D ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 200D ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 ÷ 200D ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0085 ÷ 00A7 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 ÷ 00A7 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 00A7 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [28.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 50005 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 ÷ 50005 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 50005 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [28.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 ÷ 50005 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0E01 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 ÷ 0E01 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0E01 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [28.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 3041 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 ÷ 3041 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 3041 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 ÷ 3041 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 17D6 ÷ 0023 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 ÷ 0023 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 ÷ 0023 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 17D6 ÷ 2014 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 ÷ 2014 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 ÷ 2014 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 17D6 × 0009 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 ÷ 0009 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0009 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 17D6 ÷ 00B4 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 ÷ 00B4 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 ÷ 00B4 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 17D6 × 000B ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 × 000B ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 000B ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 × 000B ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 17D6 ÷ FFFC ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 ÷ FFFC ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 ÷ FFFC ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 17D6 × 007D ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 × 007D ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 007D ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 × 007D ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 17D6 × 000D ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 × 000D ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 000D ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 × 000D ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 17D6 × 0021 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 × 0021 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0021 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 × 0021 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 17D6 × 00A0 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [12.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 ÷ 00A0 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 00A0 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 17D6 ÷ AC00 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 ÷ AC00 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 ÷ AC00 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
}
if (!$::TESTCHUNK or $::TESTCHUNK == 8) {
    Test_LB('× 17D6 ÷ AC01 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 ÷ AC01 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 ÷ AC01 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 17D6 ÷ 05D0 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 ÷ 05D0 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 ÷ 05D0 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 17D6 × 002D ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 ÷ 002D ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 002D ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 ÷ 002D ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 17D6 ÷ 231A ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 ÷ 231A ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 ÷ 231A ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 ÷ 231A ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 17D6 × 2024 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 ÷ 2024 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 2024 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 17D6 × 002C ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 × 002C ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 002C ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 × 002C ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 17D6 ÷ 1100 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 ÷ 1100 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 ÷ 1100 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 17D6 ÷ 11A8 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 ÷ 11A8 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 ÷ 11A8 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 17D6 ÷ 1160 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 ÷ 1160 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 ÷ 1160 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 17D6 × 000A ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 × 000A ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 000A ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 × 000A ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 17D6 × 0085 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 × 0085 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0085 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 × 0085 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 17D6 × 17D6 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 ÷ 17D6 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 17D6 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 17D6 ÷ 0030 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 ÷ 0030 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 ÷ 0030 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 17D6 ÷ 2329 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 ÷ 2329 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 ÷ 2329 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 ÷ 2329 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 17D6 ÷ 0025 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [999.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 ÷ 0025 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 ÷ 0025 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 17D6 ÷ 0024 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 ÷ 0024 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 ÷ 0024 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 17D6 × 0022 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 ÷ 0022 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0022 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 × 0020 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 × 0020 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 17D6 × 002F ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 × 002F ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 002F ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 × 002F ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 17D6 × 2060 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 × 2060 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 2060 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 × 2060 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 17D6 × 200B ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 × 200B ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 200B ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 × 200B ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 17D6 ÷ 1F1E6 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 ÷ 1F1E6 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 ÷ 1F1E6 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 17D6 ÷ 261D ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 ÷ 261D ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 ÷ 261D ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 ÷ 261D ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 17D6 ÷ 1F3FB ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 ÷ 1F3FB ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 ÷ 1F3FB ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 17D6 × 0029 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 × 0029 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0029 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 × 0029 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 17D6 ÷ 0028 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 ÷ 0028 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 ÷ 0028 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 17D6 × 0001 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 ÷ 0001 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0001 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 17D6 × 200D ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 ÷ 200D ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 200D ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 ÷ 200D ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 17D6 ÷ 00A7 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 ÷ 00A7 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 ÷ 00A7 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 17D6 ÷ 50005 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 ÷ 50005 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 ÷ 50005 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 17D6 ÷ 0E01 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 ÷ 0E01 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 ÷ 0E01 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 17D6 × 3041 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 ÷ 3041 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 3041 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0030 × 0023 ÷	#  × [0.3] DIGIT ZERO (NU) × [23.03] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0030 × 0020 ÷ 0023 ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0023 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [23.03] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0030 ÷ 2014 ÷	#  × [0.3] DIGIT ZERO (NU) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0030 × 0020 ÷ 2014 ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0030 × 0308 ÷ 2014 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0030 × 0009 ÷	#  × [0.3] DIGIT ZERO (NU) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0030 × 0020 ÷ 0009 ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0009 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0030 ÷ 00B4 ÷	#  × [0.3] DIGIT ZERO (NU) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0030 × 0020 ÷ 00B4 ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0030 × 0308 ÷ 00B4 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0030 × 000B ÷	#  × [0.3] DIGIT ZERO (NU) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0030 × 0020 × 000B ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 000B ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 × 000B ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0030 ÷ FFFC ÷	#  × [0.3] DIGIT ZERO (NU) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0030 × 0020 ÷ FFFC ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0030 × 0308 ÷ FFFC ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0030 × 007D ÷	#  × [0.3] DIGIT ZERO (NU) × [25.04] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0030 × 0020 × 007D ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 007D ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [25.04] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 × 007D ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0030 × 000D ÷	#  × [0.3] DIGIT ZERO (NU) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0030 × 0020 × 000D ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 000D ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 × 000D ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0030 × 0021 ÷	#  × [0.3] DIGIT ZERO (NU) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0030 × 0020 × 0021 ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0021 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 × 0021 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0030 × 00A0 ÷	#  × [0.3] DIGIT ZERO (NU) × [12.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0030 × 0020 ÷ 00A0 ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 00A0 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0030 ÷ AC00 ÷	#  × [0.3] DIGIT ZERO (NU) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0030 × 0020 ÷ AC00 ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0030 × 0308 ÷ AC00 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0030 ÷ AC01 ÷	#  × [0.3] DIGIT ZERO (NU) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0030 × 0020 ÷ AC01 ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0030 × 0308 ÷ AC01 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0030 × 05D0 ÷	#  × [0.3] DIGIT ZERO (NU) × [23.03] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0030 × 0020 ÷ 05D0 ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 05D0 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [23.03] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0030 × 002D ÷	#  × [0.3] DIGIT ZERO (NU) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0030 × 0020 ÷ 002D ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 002D ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 ÷ 002D ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0030 ÷ 231A ÷	#  × [0.3] DIGIT ZERO (NU) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0030 × 0020 ÷ 231A ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0030 × 0308 ÷ 231A ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 ÷ 231A ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0030 × 2024 ÷	#  × [0.3] DIGIT ZERO (NU) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0030 × 0020 ÷ 2024 ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 2024 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0030 × 002C ÷	#  × [0.3] DIGIT ZERO (NU) × [25.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0030 × 0020 × 002C ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 002C ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [25.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 × 002C ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0030 ÷ 1100 ÷	#  × [0.3] DIGIT ZERO (NU) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0030 × 0020 ÷ 1100 ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0030 × 0308 ÷ 1100 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0030 ÷ 11A8 ÷	#  × [0.3] DIGIT ZERO (NU) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0030 × 0020 ÷ 11A8 ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0030 × 0308 ÷ 11A8 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0030 ÷ 1160 ÷	#  × [0.3] DIGIT ZERO (NU) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0030 × 0020 ÷ 1160 ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0030 × 0308 ÷ 1160 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0030 × 000A ÷	#  × [0.3] DIGIT ZERO (NU) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0030 × 0020 × 000A ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 000A ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 × 000A ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0030 × 0085 ÷	#  × [0.3] DIGIT ZERO (NU) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0030 × 0020 × 0085 ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0085 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 × 0085 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0030 × 17D6 ÷	#  × [0.3] DIGIT ZERO (NU) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0030 × 0020 ÷ 17D6 ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 17D6 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0030 × 0030 ÷	#  × [0.3] DIGIT ZERO (NU) × [25.03] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0030 × 0020 ÷ 0030 ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0030 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [25.03] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0030 ÷ 2329 ÷	#  × [0.3] DIGIT ZERO (NU) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 0030 × 0020 ÷ 2329 ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 0030 × 0308 ÷ 2329 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 ÷ 2329 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 0030 × 0025 ÷	#  × [0.3] DIGIT ZERO (NU) × [25.05] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0030 × 0020 ÷ 0025 ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0025 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [25.05] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0030 × 0024 ÷	#  × [0.3] DIGIT ZERO (NU) × [25.05] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0030 × 0020 ÷ 0024 ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0024 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [25.05] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0030 × 0022 ÷	#  × [0.3] DIGIT ZERO (NU) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0030 × 0020 ÷ 0022 ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0022 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0030 × 0020 ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0030 × 0020 × 0020 ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 × 0020 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0030 × 002F ÷	#  × [0.3] DIGIT ZERO (NU) × [25.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0030 × 0020 × 002F ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 002F ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [25.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 × 002F ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0030 × 2060 ÷	#  × [0.3] DIGIT ZERO (NU) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0030 × 0020 × 2060 ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 2060 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 × 2060 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0030 × 200B ÷	#  × [0.3] DIGIT ZERO (NU) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0030 × 0020 × 200B ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 200B ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 × 200B ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0030 ÷ 1F1E6 ÷	#  × [0.3] DIGIT ZERO (NU) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0030 × 0020 ÷ 1F1E6 ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0030 × 0308 ÷ 1F1E6 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0030 ÷ 261D ÷	#  × [0.3] DIGIT ZERO (NU) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0030 × 0020 ÷ 261D ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0030 × 0308 ÷ 261D ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 ÷ 261D ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0030 ÷ 1F3FB ÷	#  × [0.3] DIGIT ZERO (NU) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0030 × 0020 ÷ 1F3FB ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0030 × 0308 ÷ 1F3FB ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0030 × 0029 ÷	#  × [0.3] DIGIT ZERO (NU) × [25.04] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0030 × 0020 × 0029 ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0029 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [25.04] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 × 0029 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0030 × 0028 ÷	#  × [0.3] DIGIT ZERO (NU) × [30.01] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 0030 × 0020 ÷ 0028 ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0028 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [30.01] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 0030 × 0001 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0030 × 0020 ÷ 0001 ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0001 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0030 × 200D ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0030 × 0020 ÷ 200D ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 200D ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 ÷ 200D ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0030 × 00A7 ÷	#  × [0.3] DIGIT ZERO (NU) × [23.03] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0030 × 0020 ÷ 00A7 ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 00A7 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [23.03] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0030 × 50005 ÷	#  × [0.3] DIGIT ZERO (NU) × [23.03] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0030 × 0020 ÷ 50005 ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 50005 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [23.03] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0030 × 0E01 ÷	#  × [0.3] DIGIT ZERO (NU) × [23.03] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0030 × 0020 ÷ 0E01 ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0E01 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [23.03] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0030 × 3041 ÷	#  × [0.3] DIGIT ZERO (NU) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0030 × 0020 ÷ 3041 ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 3041 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 2329 × 0023 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [14.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 2329 × 0020 × 0023 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [7.01] SPACE (SP) × [14.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 0023 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 0020 × 0023 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 2329 × 2014 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [14.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 2329 × 0020 × 2014 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [7.01] SPACE (SP) × [14.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 2014 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 0020 × 2014 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 2329 × 0009 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [14.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 2329 × 0020 × 0009 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [7.01] SPACE (SP) × [14.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 0009 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 0020 × 0009 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 2329 × 00B4 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [14.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 2329 × 0020 × 00B4 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [7.01] SPACE (SP) × [14.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 00B4 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 0020 × 00B4 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 2329 × 000B ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 2329 × 0020 × 000B ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 000B ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 0020 × 000B ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 2329 × FFFC ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [14.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 2329 × 0020 × FFFC ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [7.01] SPACE (SP) × [14.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × FFFC ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 0020 × FFFC ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 2329 × 007D ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 2329 × 0020 × 007D ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 007D ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 0020 × 007D ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 2329 × 000D ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 2329 × 0020 × 000D ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 000D ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 0020 × 000D ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 2329 × 0021 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 2329 × 0020 × 0021 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 0021 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 0020 × 0021 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 2329 × 00A0 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [12.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 2329 × 0020 × 00A0 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [7.01] SPACE (SP) × [14.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 00A0 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 0020 × 00A0 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 2329 × AC00 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [14.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 2329 × 0020 × AC00 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [7.01] SPACE (SP) × [14.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × AC00 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 0020 × AC00 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 2329 × AC01 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [14.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 2329 × 0020 × AC01 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [7.01] SPACE (SP) × [14.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × AC01 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 0020 × AC01 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 2329 × 05D0 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [14.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 2329 × 0020 × 05D0 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [7.01] SPACE (SP) × [14.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 05D0 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 0020 × 05D0 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 2329 × 002D ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [14.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 2329 × 0020 × 002D ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [7.01] SPACE (SP) × [14.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 002D ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 0020 × 002D ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 2329 × 231A ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [14.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 2329 × 0020 × 231A ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [7.01] SPACE (SP) × [14.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 231A ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 0020 × 231A ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 2329 × 2024 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [14.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 2329 × 0020 × 2024 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [7.01] SPACE (SP) × [14.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 2024 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 0020 × 2024 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 2329 × 002C ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 2329 × 0020 × 002C ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 002C ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 0020 × 002C ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 2329 × 1100 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [14.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 2329 × 0020 × 1100 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [7.01] SPACE (SP) × [14.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 1100 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 0020 × 1100 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 2329 × 11A8 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [14.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 2329 × 0020 × 11A8 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [7.01] SPACE (SP) × [14.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 11A8 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 0020 × 11A8 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 2329 × 1160 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [14.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 2329 × 0020 × 1160 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [7.01] SPACE (SP) × [14.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 1160 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 0020 × 1160 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 2329 × 000A ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 2329 × 0020 × 000A ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 000A ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 0020 × 000A ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 2329 × 0085 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 2329 × 0020 × 0085 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 0085 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 0020 × 0085 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 2329 × 17D6 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [14.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 2329 × 0020 × 17D6 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [7.01] SPACE (SP) × [14.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 17D6 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 0020 × 17D6 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 2329 × 0030 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [14.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 2329 × 0020 × 0030 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [7.01] SPACE (SP) × [14.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 0030 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 0020 × 0030 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 2329 × 2329 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [14.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 2329 × 0020 × 2329 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [7.01] SPACE (SP) × [14.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 2329 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 0020 × 2329 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 2329 × 0025 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [14.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 2329 × 0020 × 0025 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [7.01] SPACE (SP) × [14.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 0025 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 0020 × 0025 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 2329 × 0024 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [14.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 2329 × 0020 × 0024 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [7.01] SPACE (SP) × [14.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 0024 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 0020 × 0024 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 2329 × 0022 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [14.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 2329 × 0020 × 0022 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [7.01] SPACE (SP) × [14.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 0022 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 0020 × 0022 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 2329 × 0020 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 2329 × 0020 × 0020 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 0020 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 0020 × 0020 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 2329 × 002F ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 2329 × 0020 × 002F ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 002F ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 0020 × 002F ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 2329 × 2060 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 2329 × 0020 × 2060 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 2060 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 0020 × 2060 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 2329 × 200B ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 2329 × 0020 × 200B ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 200B ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 0020 × 200B ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 2329 × 1F1E6 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [14.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 2329 × 0020 × 1F1E6 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [7.01] SPACE (SP) × [14.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 1F1E6 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 0020 × 1F1E6 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 2329 × 261D ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [14.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 2329 × 0020 × 261D ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [7.01] SPACE (SP) × [14.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 261D ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 0020 × 261D ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 2329 × 1F3FB ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [14.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 2329 × 0020 × 1F3FB ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [7.01] SPACE (SP) × [14.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 1F3FB ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 0020 × 1F3FB ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 2329 × 0029 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 2329 × 0020 × 0029 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 0029 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 0020 × 0029 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 2329 × 0028 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [14.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 2329 × 0020 × 0028 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [7.01] SPACE (SP) × [14.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 0028 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 0020 × 0028 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 2329 × 0001 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 2329 × 0020 × 0001 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [7.01] SPACE (SP) × [14.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 0001 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 0020 × 0001 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 2329 × 200D ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 2329 × 0020 × 200D ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [7.01] SPACE (SP) × [14.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 200D ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 0020 × 200D ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 2329 × 00A7 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [14.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 2329 × 0020 × 00A7 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [7.01] SPACE (SP) × [14.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 00A7 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 0020 × 00A7 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 2329 × 50005 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [14.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 2329 × 0020 × 50005 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [7.01] SPACE (SP) × [14.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 50005 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 0020 × 50005 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 2329 × 0E01 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [14.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 2329 × 0020 × 0E01 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [7.01] SPACE (SP) × [14.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 0E01 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 0020 × 0E01 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 2329 × 3041 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [14.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 2329 × 0020 × 3041 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [7.01] SPACE (SP) × [14.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 3041 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 0020 × 3041 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0025 × 0023 ÷	#  × [0.3] PERCENT SIGN (PO) × [24.02] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0025 × 0020 ÷ 0023 ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0023 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [24.02] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0025 ÷ 2014 ÷	#  × [0.3] PERCENT SIGN (PO) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0025 × 0020 ÷ 2014 ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0025 × 0308 ÷ 2014 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0025 × 0009 ÷	#  × [0.3] PERCENT SIGN (PO) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0025 × 0020 ÷ 0009 ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0009 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0025 ÷ 00B4 ÷	#  × [0.3] PERCENT SIGN (PO) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0025 × 0020 ÷ 00B4 ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0025 × 0308 ÷ 00B4 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0025 × 000B ÷	#  × [0.3] PERCENT SIGN (PO) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0025 × 0020 × 000B ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 000B ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 × 000B ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0025 ÷ FFFC ÷	#  × [0.3] PERCENT SIGN (PO) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0025 × 0020 ÷ FFFC ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0025 × 0308 ÷ FFFC ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0025 × 007D ÷	#  × [0.3] PERCENT SIGN (PO) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0025 × 0020 × 007D ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 007D ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 × 007D ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0025 × 000D ÷	#  × [0.3] PERCENT SIGN (PO) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0025 × 0020 × 000D ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 000D ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 × 000D ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0025 × 0021 ÷	#  × [0.3] PERCENT SIGN (PO) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0025 × 0020 × 0021 ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0021 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 × 0021 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0025 × 00A0 ÷	#  × [0.3] PERCENT SIGN (PO) × [12.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0025 × 0020 ÷ 00A0 ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 00A0 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0025 ÷ AC00 ÷	#  × [0.3] PERCENT SIGN (PO) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0025 × 0020 ÷ AC00 ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0025 × 0308 ÷ AC00 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0025 ÷ AC01 ÷	#  × [0.3] PERCENT SIGN (PO) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0025 × 0020 ÷ AC01 ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0025 × 0308 ÷ AC01 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0025 × 05D0 ÷	#  × [0.3] PERCENT SIGN (PO) × [24.02] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0025 × 0020 ÷ 05D0 ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 05D0 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [24.02] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0025 × 002D ÷	#  × [0.3] PERCENT SIGN (PO) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0025 × 0020 ÷ 002D ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 002D ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 ÷ 002D ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0025 ÷ 231A ÷	#  × [0.3] PERCENT SIGN (PO) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0025 × 0020 ÷ 231A ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0025 × 0308 ÷ 231A ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 ÷ 231A ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0025 × 2024 ÷	#  × [0.3] PERCENT SIGN (PO) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0025 × 0020 ÷ 2024 ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 2024 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0025 × 002C ÷	#  × [0.3] PERCENT SIGN (PO) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0025 × 0020 × 002C ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 002C ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 × 002C ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0025 ÷ 1100 ÷	#  × [0.3] PERCENT SIGN (PO) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0025 × 0020 ÷ 1100 ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0025 × 0308 ÷ 1100 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0025 ÷ 11A8 ÷	#  × [0.3] PERCENT SIGN (PO) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0025 × 0020 ÷ 11A8 ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0025 × 0308 ÷ 11A8 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0025 ÷ 1160 ÷	#  × [0.3] PERCENT SIGN (PO) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0025 × 0020 ÷ 1160 ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0025 × 0308 ÷ 1160 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0025 × 000A ÷	#  × [0.3] PERCENT SIGN (PO) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0025 × 0020 × 000A ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 000A ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 × 000A ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0025 × 0085 ÷	#  × [0.3] PERCENT SIGN (PO) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0025 × 0020 × 0085 ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0085 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 × 0085 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0025 × 17D6 ÷	#  × [0.3] PERCENT SIGN (PO) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0025 × 0020 ÷ 17D6 ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 17D6 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0025 × 0030 ÷	#  × [0.3] PERCENT SIGN (PO) × [25.01] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0025 × 0020 ÷ 0030 ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0030 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [25.01] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0025 ÷ 2329 ÷	#  × [0.3] PERCENT SIGN (PO) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 0025 × 0020 ÷ 2329 ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 0025 × 0308 ÷ 2329 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 ÷ 2329 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 0025 ÷ 0025 ÷	#  × [0.3] PERCENT SIGN (PO) ÷ [999.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0025 × 0020 ÷ 0025 ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0025 × 0308 ÷ 0025 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0025 ÷ 0024 ÷	#  × [0.3] PERCENT SIGN (PO) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0025 × 0020 ÷ 0024 ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0025 × 0308 ÷ 0024 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0025 × 0022 ÷	#  × [0.3] PERCENT SIGN (PO) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0025 × 0020 ÷ 0022 ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0022 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0025 × 0020 ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0025 × 0020 × 0020 ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 × 0020 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0025 × 002F ÷	#  × [0.3] PERCENT SIGN (PO) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0025 × 0020 × 002F ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 002F ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 × 002F ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0025 × 2060 ÷	#  × [0.3] PERCENT SIGN (PO) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0025 × 0020 × 2060 ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 2060 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 × 2060 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0025 × 200B ÷	#  × [0.3] PERCENT SIGN (PO) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0025 × 0020 × 200B ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 200B ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 × 200B ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0025 ÷ 1F1E6 ÷	#  × [0.3] PERCENT SIGN (PO) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0025 × 0020 ÷ 1F1E6 ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0025 × 0308 ÷ 1F1E6 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0025 ÷ 261D ÷	#  × [0.3] PERCENT SIGN (PO) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0025 × 0020 ÷ 261D ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0025 × 0308 ÷ 261D ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 ÷ 261D ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0025 ÷ 1F3FB ÷	#  × [0.3] PERCENT SIGN (PO) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0025 × 0020 ÷ 1F3FB ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0025 × 0308 ÷ 1F3FB ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0025 × 0029 ÷	#  × [0.3] PERCENT SIGN (PO) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0025 × 0020 × 0029 ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0029 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 × 0029 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0025 ÷ 0028 ÷	#  × [0.3] PERCENT SIGN (PO) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 0025 × 0020 ÷ 0028 ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 0025 × 0308 ÷ 0028 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 0025 × 0001 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0025 × 0020 ÷ 0001 ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0001 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0025 × 200D ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0025 × 0020 ÷ 200D ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 200D ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 ÷ 200D ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0025 × 00A7 ÷	#  × [0.3] PERCENT SIGN (PO) × [24.02] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0025 × 0020 ÷ 00A7 ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 00A7 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [24.02] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0025 × 50005 ÷	#  × [0.3] PERCENT SIGN (PO) × [24.02] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0025 × 0020 ÷ 50005 ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 50005 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [24.02] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0025 × 0E01 ÷	#  × [0.3] PERCENT SIGN (PO) × [24.02] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0025 × 0020 ÷ 0E01 ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0E01 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [24.02] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0025 × 3041 ÷	#  × [0.3] PERCENT SIGN (PO) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0025 × 0020 ÷ 3041 ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 3041 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0024 × 0023 ÷	#  × [0.3] DOLLAR SIGN (PR) × [24.02] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0024 × 0020 ÷ 0023 ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0023 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [24.02] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0024 ÷ 2014 ÷	#  × [0.3] DOLLAR SIGN (PR) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0024 × 0020 ÷ 2014 ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0024 × 0308 ÷ 2014 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0024 × 0009 ÷	#  × [0.3] DOLLAR SIGN (PR) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0024 × 0020 ÷ 0009 ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0009 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0024 ÷ 00B4 ÷	#  × [0.3] DOLLAR SIGN (PR) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0024 × 0020 ÷ 00B4 ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0024 × 0308 ÷ 00B4 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0024 × 000B ÷	#  × [0.3] DOLLAR SIGN (PR) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0024 × 0020 × 000B ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 000B ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 × 000B ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0024 ÷ FFFC ÷	#  × [0.3] DOLLAR SIGN (PR) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0024 × 0020 ÷ FFFC ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0024 × 0308 ÷ FFFC ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0024 × 007D ÷	#  × [0.3] DOLLAR SIGN (PR) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0024 × 0020 × 007D ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 007D ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 × 007D ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0024 × 000D ÷	#  × [0.3] DOLLAR SIGN (PR) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0024 × 0020 × 000D ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 000D ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 × 000D ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0024 × 0021 ÷	#  × [0.3] DOLLAR SIGN (PR) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0024 × 0020 × 0021 ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0021 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 × 0021 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0024 × 00A0 ÷	#  × [0.3] DOLLAR SIGN (PR) × [12.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0024 × 0020 ÷ 00A0 ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 00A0 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0024 × AC00 ÷	#  × [0.3] DOLLAR SIGN (PR) × [27.02] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0024 × 0020 ÷ AC00 ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × AC00 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [27.02] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0024 × AC01 ÷	#  × [0.3] DOLLAR SIGN (PR) × [27.02] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0024 × 0020 ÷ AC01 ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × AC01 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [27.02] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0024 × 05D0 ÷	#  × [0.3] DOLLAR SIGN (PR) × [24.02] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0024 × 0020 ÷ 05D0 ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 05D0 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [24.02] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0024 × 002D ÷	#  × [0.3] DOLLAR SIGN (PR) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0024 × 0020 ÷ 002D ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 002D ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 ÷ 002D ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0024 × 231A ÷	#  × [0.3] DOLLAR SIGN (PR) × [23.12] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0024 × 0020 ÷ 231A ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 231A ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [23.12] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 ÷ 231A ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0024 × 2024 ÷	#  × [0.3] DOLLAR SIGN (PR) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0024 × 0020 ÷ 2024 ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 2024 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0024 × 002C ÷	#  × [0.3] DOLLAR SIGN (PR) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0024 × 0020 × 002C ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 002C ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 × 002C ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0024 × 1100 ÷	#  × [0.3] DOLLAR SIGN (PR) × [27.02] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0024 × 0020 ÷ 1100 ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 1100 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [27.02] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0024 × 11A8 ÷	#  × [0.3] DOLLAR SIGN (PR) × [27.02] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0024 × 0020 ÷ 11A8 ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 11A8 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [27.02] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0024 × 1160 ÷	#  × [0.3] DOLLAR SIGN (PR) × [27.02] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0024 × 0020 ÷ 1160 ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 1160 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [27.02] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0024 × 000A ÷	#  × [0.3] DOLLAR SIGN (PR) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0024 × 0020 × 000A ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 000A ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 × 000A ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0024 × 0085 ÷	#  × [0.3] DOLLAR SIGN (PR) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0024 × 0020 × 0085 ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0085 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 × 0085 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0024 × 17D6 ÷	#  × [0.3] DOLLAR SIGN (PR) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0024 × 0020 ÷ 17D6 ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 17D6 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0024 × 0030 ÷	#  × [0.3] DOLLAR SIGN (PR) × [25.01] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0024 × 0020 ÷ 0030 ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0030 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [25.01] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0024 ÷ 2329 ÷	#  × [0.3] DOLLAR SIGN (PR) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 0024 × 0020 ÷ 2329 ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 0024 × 0308 ÷ 2329 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 ÷ 2329 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 0024 ÷ 0025 ÷	#  × [0.3] DOLLAR SIGN (PR) ÷ [999.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0024 × 0020 ÷ 0025 ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0024 × 0308 ÷ 0025 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0024 ÷ 0024 ÷	#  × [0.3] DOLLAR SIGN (PR) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0024 × 0020 ÷ 0024 ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0024 × 0308 ÷ 0024 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0024 × 0022 ÷	#  × [0.3] DOLLAR SIGN (PR) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0024 × 0020 ÷ 0022 ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0022 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0024 × 0020 ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0024 × 0020 × 0020 ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 × 0020 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0024 × 002F ÷	#  × [0.3] DOLLAR SIGN (PR) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0024 × 0020 × 002F ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 002F ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 × 002F ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0024 × 2060 ÷	#  × [0.3] DOLLAR SIGN (PR) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0024 × 0020 × 2060 ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 2060 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 × 2060 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0024 × 200B ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0024 × 0020 × 200B ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 200B ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 × 200B ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0024 ÷ 1F1E6 ÷	#  × [0.3] DOLLAR SIGN (PR) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0024 × 0020 ÷ 1F1E6 ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0024 × 0308 ÷ 1F1E6 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0024 × 261D ÷	#  × [0.3] DOLLAR SIGN (PR) × [23.12] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0024 × 0020 ÷ 261D ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 261D ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [23.12] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 ÷ 261D ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0024 × 1F3FB ÷	#  × [0.3] DOLLAR SIGN (PR) × [23.12] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0024 × 0020 ÷ 1F3FB ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 1F3FB ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [23.12] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0024 × 0029 ÷	#  × [0.3] DOLLAR SIGN (PR) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0024 × 0020 × 0029 ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0029 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 × 0029 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0024 ÷ 0028 ÷	#  × [0.3] DOLLAR SIGN (PR) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 0024 × 0020 ÷ 0028 ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 0024 × 0308 ÷ 0028 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 0024 × 0001 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0024 × 0020 ÷ 0001 ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0001 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0024 × 200D ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0024 × 0020 ÷ 200D ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 200D ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 ÷ 200D ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0024 × 00A7 ÷	#  × [0.3] DOLLAR SIGN (PR) × [24.02] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0024 × 0020 ÷ 00A7 ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 00A7 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [24.02] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0024 × 50005 ÷	#  × [0.3] DOLLAR SIGN (PR) × [24.02] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0024 × 0020 ÷ 50005 ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 50005 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [24.02] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0024 × 0E01 ÷	#  × [0.3] DOLLAR SIGN (PR) × [24.02] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0024 × 0020 ÷ 0E01 ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0E01 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [24.02] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0024 × 3041 ÷	#  × [0.3] DOLLAR SIGN (PR) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0024 × 0020 ÷ 3041 ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 3041 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0022 × 0023 ÷	#  × [0.3] QUOTATION MARK (QU) × [19.02] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0022 × 0020 ÷ 0023 ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0023 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.02] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0022 × 2014 ÷	#  × [0.3] QUOTATION MARK (QU) × [19.02] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0022 × 0020 ÷ 2014 ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 2014 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.02] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0022 × 0009 ÷	#  × [0.3] QUOTATION MARK (QU) × [19.02] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0022 × 0020 ÷ 0009 ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0009 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.02] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0022 × 00B4 ÷	#  × [0.3] QUOTATION MARK (QU) × [19.02] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0022 × 0020 ÷ 00B4 ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 00B4 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.02] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0022 × 000B ÷	#  × [0.3] QUOTATION MARK (QU) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0022 × 0020 × 000B ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 000B ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 × 000B ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0022 × FFFC ÷	#  × [0.3] QUOTATION MARK (QU) × [19.02] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0022 × 0020 ÷ FFFC ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × FFFC ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.02] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0022 × 007D ÷	#  × [0.3] QUOTATION MARK (QU) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0022 × 0020 × 007D ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 007D ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 × 007D ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0022 × 000D ÷	#  × [0.3] QUOTATION MARK (QU) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0022 × 0020 × 000D ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 000D ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 × 000D ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0022 × 0021 ÷	#  × [0.3] QUOTATION MARK (QU) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0022 × 0020 × 0021 ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0021 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 × 0021 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0022 × 00A0 ÷	#  × [0.3] QUOTATION MARK (QU) × [12.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0022 × 0020 ÷ 00A0 ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 00A0 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0022 × AC00 ÷	#  × [0.3] QUOTATION MARK (QU) × [19.02] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0022 × 0020 ÷ AC00 ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × AC00 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.02] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0022 × AC01 ÷	#  × [0.3] QUOTATION MARK (QU) × [19.02] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0022 × 0020 ÷ AC01 ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × AC01 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.02] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0022 × 05D0 ÷	#  × [0.3] QUOTATION MARK (QU) × [19.02] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0022 × 0020 ÷ 05D0 ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 05D0 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.02] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0022 × 002D ÷	#  × [0.3] QUOTATION MARK (QU) × [19.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0022 × 0020 ÷ 002D ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 002D ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 ÷ 002D ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0022 × 231A ÷	#  × [0.3] QUOTATION MARK (QU) × [19.02] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0022 × 0020 ÷ 231A ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 231A ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.02] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 ÷ 231A ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0022 × 2024 ÷	#  × [0.3] QUOTATION MARK (QU) × [19.02] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0022 × 0020 ÷ 2024 ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 2024 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.02] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0022 × 002C ÷	#  × [0.3] QUOTATION MARK (QU) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0022 × 0020 × 002C ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 002C ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 × 002C ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0022 × 1100 ÷	#  × [0.3] QUOTATION MARK (QU) × [19.02] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0022 × 0020 ÷ 1100 ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 1100 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.02] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0022 × 11A8 ÷	#  × [0.3] QUOTATION MARK (QU) × [19.02] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0022 × 0020 ÷ 11A8 ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 11A8 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.02] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0022 × 1160 ÷	#  × [0.3] QUOTATION MARK (QU) × [19.02] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0022 × 0020 ÷ 1160 ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 1160 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.02] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0022 × 000A ÷	#  × [0.3] QUOTATION MARK (QU) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0022 × 0020 × 000A ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 000A ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 × 000A ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0022 × 0085 ÷	#  × [0.3] QUOTATION MARK (QU) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0022 × 0020 × 0085 ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0085 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 × 0085 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0022 × 17D6 ÷	#  × [0.3] QUOTATION MARK (QU) × [19.02] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0022 × 0020 ÷ 17D6 ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 17D6 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.02] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0022 × 0030 ÷	#  × [0.3] QUOTATION MARK (QU) × [19.02] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0022 × 0020 ÷ 0030 ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0030 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.02] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0022 × 2329 ÷	#  × [0.3] QUOTATION MARK (QU) × [15.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 0022 × 0020 × 2329 ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) × [15.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 2329 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [15.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 × 2329 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [15.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 0022 × 0025 ÷	#  × [0.3] QUOTATION MARK (QU) × [19.02] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0022 × 0020 ÷ 0025 ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0025 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.02] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0022 × 0024 ÷	#  × [0.3] QUOTATION MARK (QU) × [19.02] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0022 × 0020 ÷ 0024 ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0024 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.02] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0022 × 0022 ÷	#  × [0.3] QUOTATION MARK (QU) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0022 × 0020 ÷ 0022 ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0022 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0022 × 0020 ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0022 × 0020 × 0020 ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 × 0020 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0022 × 002F ÷	#  × [0.3] QUOTATION MARK (QU) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0022 × 0020 × 002F ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 002F ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 × 002F ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0022 × 2060 ÷	#  × [0.3] QUOTATION MARK (QU) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0022 × 0020 × 2060 ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 2060 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 × 2060 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0022 × 200B ÷	#  × [0.3] QUOTATION MARK (QU) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0022 × 0020 × 200B ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 200B ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 × 200B ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0022 × 1F1E6 ÷	#  × [0.3] QUOTATION MARK (QU) × [19.02] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0022 × 0020 ÷ 1F1E6 ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 1F1E6 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.02] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0022 × 261D ÷	#  × [0.3] QUOTATION MARK (QU) × [19.02] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0022 × 0020 ÷ 261D ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 261D ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.02] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 ÷ 261D ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0022 × 1F3FB ÷	#  × [0.3] QUOTATION MARK (QU) × [19.02] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0022 × 0020 ÷ 1F3FB ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 1F3FB ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.02] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0022 × 0029 ÷	#  × [0.3] QUOTATION MARK (QU) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0022 × 0020 × 0029 ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0029 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 × 0029 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0022 × 0028 ÷	#  × [0.3] QUOTATION MARK (QU) × [15.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 0022 × 0020 × 0028 ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) × [15.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0028 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [15.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 × 0028 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [15.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 0022 × 0001 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0022 × 0020 ÷ 0001 ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0001 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0022 × 200D ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0022 × 0020 ÷ 200D ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 200D ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 ÷ 200D ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0022 × 00A7 ÷	#  × [0.3] QUOTATION MARK (QU) × [19.02] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0022 × 0020 ÷ 00A7 ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 00A7 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.02] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0022 × 50005 ÷	#  × [0.3] QUOTATION MARK (QU) × [19.02] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0022 × 0020 ÷ 50005 ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 50005 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.02] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0022 × 0E01 ÷	#  × [0.3] QUOTATION MARK (QU) × [19.02] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0022 × 0020 ÷ 0E01 ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0E01 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.02] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0022 × 3041 ÷	#  × [0.3] QUOTATION MARK (QU) × [19.02] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0022 × 0020 ÷ 3041 ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 3041 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.02] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0023 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0020 × 0020 ÷ 0023 ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0023 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [28.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 ÷ 0023 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0020 ÷ 2014 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0020 × 0020 ÷ 2014 ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 ÷ 2014 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 ÷ 2014 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0009 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0020 × 0020 ÷ 0009 ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0009 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 ÷ 0009 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0020 ÷ 00B4 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0020 × 0020 ÷ 00B4 ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 ÷ 00B4 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0020 × 000B ÷	#  × [0.3] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0020 × 0020 × 000B ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 000B ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 × 000B ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0020 ÷ FFFC ÷	#  × [0.3] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0020 × 0020 ÷ FFFC ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 ÷ FFFC ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 ÷ FFFC ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0020 × 007D ÷	#  × [0.3] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0020 × 0020 × 007D ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 007D ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 × 007D ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0020 × 000D ÷	#  × [0.3] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0020 × 0020 × 000D ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 000D ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 × 000D ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0020 × 0021 ÷	#  × [0.3] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0020 × 0020 × 0021 ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0021 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 × 0021 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0020 ÷ 00A0 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0020 × 0020 ÷ 00A0 ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 00A0 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0020 ÷ AC00 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0020 × 0020 ÷ AC00 ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 ÷ AC00 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 ÷ AC00 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0020 ÷ AC01 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0020 × 0020 ÷ AC01 ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 ÷ AC01 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 ÷ AC01 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0020 ÷ 05D0 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0020 × 0020 ÷ 05D0 ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 05D0 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [28.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0020 ÷ 002D ÷	#  × [0.3] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0020 × 0020 ÷ 002D ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 002D ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 ÷ 002D ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0020 ÷ 231A ÷	#  × [0.3] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0020 × 0020 ÷ 231A ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 ÷ 231A ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 ÷ 231A ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0020 ÷ 2024 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0020 × 0020 ÷ 2024 ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 2024 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 ÷ 2024 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0020 × 002C ÷	#  × [0.3] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0020 × 0020 × 002C ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 002C ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 × 002C ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0020 ÷ 1100 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0020 × 0020 ÷ 1100 ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 ÷ 1100 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 ÷ 1100 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0020 ÷ 11A8 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0020 × 0020 ÷ 11A8 ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 ÷ 11A8 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0020 ÷ 1160 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0020 × 0020 ÷ 1160 ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 ÷ 1160 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 ÷ 1160 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0020 × 000A ÷	#  × [0.3] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0020 × 0020 × 000A ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 000A ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 × 000A ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0020 × 0085 ÷	#  × [0.3] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0020 × 0020 × 0085 ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0085 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 × 0085 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0020 ÷ 17D6 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0020 × 0020 ÷ 17D6 ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 17D6 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0030 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0020 × 0020 ÷ 0030 ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0030 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [23.02] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 ÷ 0030 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0020 ÷ 2329 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 0020 × 0020 ÷ 2329 ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 ÷ 2329 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 ÷ 2329 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0025 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0020 × 0020 ÷ 0025 ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0025 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [24.03] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 ÷ 0025 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0024 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0020 × 0020 ÷ 0024 ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0024 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [24.03] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 ÷ 0024 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0022 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0020 × 0020 ÷ 0022 ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0022 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 ÷ 0022 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0020 × 0020 ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0020 × 0020 × 0020 ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 × 0020 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0020 × 002F ÷	#  × [0.3] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0020 × 0020 × 002F ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 002F ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 × 002F ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0020 × 2060 ÷	#  × [0.3] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0020 × 0020 × 2060 ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 2060 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 × 2060 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0020 × 200B ÷	#  × [0.3] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0020 × 0020 × 200B ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 200B ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 × 200B ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0020 ÷ 1F1E6 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0020 × 0020 ÷ 1F1E6 ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 ÷ 1F1E6 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0020 ÷ 261D ÷	#  × [0.3] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0020 × 0020 ÷ 261D ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 ÷ 261D ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 ÷ 261D ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0020 ÷ 1F3FB ÷	#  × [0.3] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0020 × 0020 ÷ 1F3FB ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 ÷ 1F3FB ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0020 × 0029 ÷	#  × [0.3] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0020 × 0020 × 0029 ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0029 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 × 0029 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0028 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 0020 × 0020 ÷ 0028 ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0028 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [30.01] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 ÷ 0028 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0001 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0020 × 0020 ÷ 0001 ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0001 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 ÷ 0001 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0020 ÷ 200D ÷	#  × [0.3] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0020 × 0020 ÷ 200D ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 200D ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 ÷ 200D ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0020 ÷ 00A7 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0020 × 0020 ÷ 00A7 ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 00A7 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [28.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0020 ÷ 50005 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0020 × 0020 ÷ 50005 ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 50005 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [28.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 ÷ 50005 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0E01 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0020 × 0020 ÷ 0E01 ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0E01 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [28.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0020 ÷ 3041 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0020 × 0020 ÷ 3041 ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 3041 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 ÷ 3041 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 002F ÷ 0023 ÷	#  × [0.3] SOLIDUS (SY) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 002F × 0020 ÷ 0023 ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 002F × 0308 ÷ 0023 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 002F ÷ 2014 ÷	#  × [0.3] SOLIDUS (SY) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 002F × 0020 ÷ 2014 ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 002F × 0308 ÷ 2014 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 002F × 0009 ÷	#  × [0.3] SOLIDUS (SY) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 002F × 0020 ÷ 0009 ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0009 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 002F ÷ 00B4 ÷	#  × [0.3] SOLIDUS (SY) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 002F × 0020 ÷ 00B4 ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 002F × 0308 ÷ 00B4 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 002F × 000B ÷	#  × [0.3] SOLIDUS (SY) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 002F × 0020 × 000B ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 000B ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 × 000B ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 002F ÷ FFFC ÷	#  × [0.3] SOLIDUS (SY) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 002F × 0020 ÷ FFFC ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 002F × 0308 ÷ FFFC ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 002F × 007D ÷	#  × [0.3] SOLIDUS (SY) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 002F × 0020 × 007D ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 007D ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 × 007D ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 002F × 000D ÷	#  × [0.3] SOLIDUS (SY) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 002F × 0020 × 000D ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 000D ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 × 000D ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 002F × 0021 ÷	#  × [0.3] SOLIDUS (SY) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 002F × 0020 × 0021 ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0021 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 × 0021 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 002F × 00A0 ÷	#  × [0.3] SOLIDUS (SY) × [12.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 002F × 0020 ÷ 00A0 ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 00A0 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 002F ÷ AC00 ÷	#  × [0.3] SOLIDUS (SY) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 002F × 0020 ÷ AC00 ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 002F × 0308 ÷ AC00 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 002F ÷ AC01 ÷	#  × [0.3] SOLIDUS (SY) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 002F × 0020 ÷ AC01 ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 002F × 0308 ÷ AC01 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 002F × 05D0 ÷	#  × [0.3] SOLIDUS (SY) × [21.2] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 002F × 0020 ÷ 05D0 ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 05D0 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.2] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 002F × 002D ÷	#  × [0.3] SOLIDUS (SY) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 002F × 0020 ÷ 002D ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 002D ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 ÷ 002D ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 002F ÷ 231A ÷	#  × [0.3] SOLIDUS (SY) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 002F × 0020 ÷ 231A ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 002F × 0308 ÷ 231A ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 ÷ 231A ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 002F × 2024 ÷	#  × [0.3] SOLIDUS (SY) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 002F × 0020 ÷ 2024 ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 2024 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 002F × 002C ÷	#  × [0.3] SOLIDUS (SY) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 002F × 0020 × 002C ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 002C ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 × 002C ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 002F ÷ 1100 ÷	#  × [0.3] SOLIDUS (SY) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 002F × 0020 ÷ 1100 ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 002F × 0308 ÷ 1100 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 002F ÷ 11A8 ÷	#  × [0.3] SOLIDUS (SY) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 002F × 0020 ÷ 11A8 ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 002F × 0308 ÷ 11A8 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 002F ÷ 1160 ÷	#  × [0.3] SOLIDUS (SY) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 002F × 0020 ÷ 1160 ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 002F × 0308 ÷ 1160 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 002F × 000A ÷	#  × [0.3] SOLIDUS (SY) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 002F × 0020 × 000A ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 000A ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 × 000A ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 002F × 0085 ÷	#  × [0.3] SOLIDUS (SY) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 002F × 0020 × 0085 ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0085 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 × 0085 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 002F × 17D6 ÷	#  × [0.3] SOLIDUS (SY) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 002F × 0020 ÷ 17D6 ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 17D6 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 002F ÷ 0030 ÷	#  × [0.3] SOLIDUS (SY) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 002F × 0020 ÷ 0030 ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 002F × 0308 ÷ 0030 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 002F ÷ 2329 ÷	#  × [0.3] SOLIDUS (SY) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 002F × 0020 ÷ 2329 ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 002F × 0308 ÷ 2329 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 ÷ 2329 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 002F ÷ 0025 ÷	#  × [0.3] SOLIDUS (SY) ÷ [999.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 002F × 0020 ÷ 0025 ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 002F × 0308 ÷ 0025 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 002F ÷ 0024 ÷	#  × [0.3] SOLIDUS (SY) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 002F × 0020 ÷ 0024 ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 002F × 0308 ÷ 0024 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 002F × 0022 ÷	#  × [0.3] SOLIDUS (SY) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 002F × 0020 ÷ 0022 ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0022 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 002F × 0020 ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 002F × 0020 × 0020 ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 × 0020 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 002F × 002F ÷	#  × [0.3] SOLIDUS (SY) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 002F × 0020 × 002F ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 002F ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 × 002F ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 002F × 2060 ÷	#  × [0.3] SOLIDUS (SY) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 002F × 0020 × 2060 ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 2060 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 × 2060 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 002F × 200B ÷	#  × [0.3] SOLIDUS (SY) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 002F × 0020 × 200B ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 200B ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 × 200B ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 002F ÷ 1F1E6 ÷	#  × [0.3] SOLIDUS (SY) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 002F × 0020 ÷ 1F1E6 ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 002F × 0308 ÷ 1F1E6 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 002F ÷ 261D ÷	#  × [0.3] SOLIDUS (SY) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 002F × 0020 ÷ 261D ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 002F × 0308 ÷ 261D ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 ÷ 261D ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 002F ÷ 1F3FB ÷	#  × [0.3] SOLIDUS (SY) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 002F × 0020 ÷ 1F3FB ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 002F × 0308 ÷ 1F3FB ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 002F × 0029 ÷	#  × [0.3] SOLIDUS (SY) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 002F × 0020 × 0029 ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0029 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 × 0029 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 002F ÷ 0028 ÷	#  × [0.3] SOLIDUS (SY) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 002F × 0020 ÷ 0028 ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 002F × 0308 ÷ 0028 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 002F × 0001 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 002F × 0020 ÷ 0001 ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0001 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 002F × 200D ÷	#  × [0.3] SOLIDUS (SY) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 002F × 0020 ÷ 200D ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 200D ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 ÷ 200D ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 002F ÷ 00A7 ÷	#  × [0.3] SOLIDUS (SY) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 002F × 0020 ÷ 00A7 ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 002F × 0308 ÷ 00A7 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 002F ÷ 50005 ÷	#  × [0.3] SOLIDUS (SY) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 002F × 0020 ÷ 50005 ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 002F × 0308 ÷ 50005 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 002F ÷ 0E01 ÷	#  × [0.3] SOLIDUS (SY) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 002F × 0020 ÷ 0E01 ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 002F × 0308 ÷ 0E01 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 002F × 3041 ÷	#  × [0.3] SOLIDUS (SY) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 002F × 0020 ÷ 3041 ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 3041 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 2060 × 0023 ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 2060 × 0020 ÷ 0023 ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0023 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 2060 × 2014 ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 2060 × 0020 ÷ 2014 ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 2014 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 2060 × 0009 ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 2060 × 0020 ÷ 0009 ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0009 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 2060 × 00B4 ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 2060 × 0020 ÷ 00B4 ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 00B4 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 2060 × 000B ÷	#  × [0.3] WORD JOINER (WJ) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 2060 × 0020 × 000B ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 000B ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 × 000B ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 2060 × FFFC ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 2060 × 0020 ÷ FFFC ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × FFFC ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 2060 × 007D ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 2060 × 0020 × 007D ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 007D ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 × 007D ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 2060 × 000D ÷	#  × [0.3] WORD JOINER (WJ) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 2060 × 0020 × 000D ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 000D ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 × 000D ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 2060 × 0021 ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 2060 × 0020 × 0021 ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0021 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 × 0021 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 2060 × 00A0 ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 2060 × 0020 ÷ 00A0 ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 00A0 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 2060 × AC00 ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 2060 × 0020 ÷ AC00 ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × AC00 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 2060 × AC01 ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 2060 × 0020 ÷ AC01 ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × AC01 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 2060 × 05D0 ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 2060 × 0020 ÷ 05D0 ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 05D0 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 2060 × 002D ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 2060 × 0020 ÷ 002D ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 002D ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 ÷ 002D ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 2060 × 231A ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] WATCH (ID) ÷ [0.3]');
    Test_LB('× 2060 × 0020 ÷ 231A ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 231A ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] WATCH (ID) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 ÷ 231A ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 2060 × 2024 ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 2060 × 0020 ÷ 2024 ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 2024 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 2060 × 002C ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 2060 × 0020 × 002C ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 002C ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 × 002C ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 2060 × 1100 ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 2060 × 0020 ÷ 1100 ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 1100 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 2060 × 11A8 ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 2060 × 0020 ÷ 11A8 ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 11A8 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 2060 × 1160 ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 2060 × 0020 ÷ 1160 ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 1160 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 2060 × 000A ÷	#  × [0.3] WORD JOINER (WJ) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 2060 × 0020 × 000A ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 000A ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 × 000A ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 2060 × 0085 ÷	#  × [0.3] WORD JOINER (WJ) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 2060 × 0020 × 0085 ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0085 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 × 0085 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 2060 × 17D6 ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 2060 × 0020 ÷ 17D6 ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 17D6 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 2060 × 0030 ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 2060 × 0020 ÷ 0030 ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0030 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 2060 × 2329 ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 2060 × 0020 ÷ 2329 ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 2329 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 ÷ 2329 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 2060 × 0025 ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 2060 × 0020 ÷ 0025 ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0025 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 2060 × 0024 ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 2060 × 0020 ÷ 0024 ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0024 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 2060 × 0022 ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 2060 × 0020 ÷ 0022 ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0022 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 2060 × 0020 ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 2060 × 0020 × 0020 ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 × 0020 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 2060 × 002F ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 2060 × 0020 × 002F ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 002F ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 × 002F ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 2060 × 2060 ÷	#  × [0.3] WORD JOINER (WJ) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 2060 × 0020 × 2060 ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 2060 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 × 2060 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 2060 × 200B ÷	#  × [0.3] WORD JOINER (WJ) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 2060 × 0020 × 200B ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 200B ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 × 200B ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 2060 × 1F1E6 ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 2060 × 0020 ÷ 1F1E6 ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 1F1E6 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 2060 × 261D ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 2060 × 0020 ÷ 261D ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 261D ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 ÷ 261D ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 2060 × 1F3FB ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 2060 × 0020 ÷ 1F3FB ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 1F3FB ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 2060 × 0029 ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 2060 × 0020 × 0029 ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0029 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 × 0029 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 2060 × 0028 ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 2060 × 0020 ÷ 0028 ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0028 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 2060 × 0001 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 2060 × 0020 ÷ 0001 ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0001 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 2060 × 200D ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 2060 × 0020 ÷ 200D ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 200D ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 ÷ 200D ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 2060 × 00A7 ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 2060 × 0020 ÷ 00A7 ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 00A7 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 2060 × 50005 ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 2060 × 0020 ÷ 50005 ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 50005 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 2060 × 0E01 ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 2060 × 0020 ÷ 0E01 ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0E01 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 2060 × 3041 ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 2060 × 0020 ÷ 3041 ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 3041 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 200B ÷ 0023 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 0023 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0023 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [28.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 ÷ 0023 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 200B ÷ 2014 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 2014 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 ÷ 2014 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 ÷ 2014 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 200B ÷ 0009 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 0009 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0009 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 ÷ 0009 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 200B ÷ 00B4 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 00B4 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 ÷ 00B4 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 200B × 000B ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 200B × 0020 × 000B ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 000B ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 × 000B ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 200B ÷ FFFC ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ FFFC ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 ÷ FFFC ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 ÷ FFFC ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 200B ÷ 007D ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 007D ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 007D ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 × 007D ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 200B × 000D ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 200B × 0020 × 000D ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 000D ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 × 000D ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 200B ÷ 0021 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 0021 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0021 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 × 0021 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 200B ÷ 00A0 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 00A0 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 00A0 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 200B ÷ AC00 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ AC00 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 ÷ AC00 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 ÷ AC00 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 200B ÷ AC01 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ AC01 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 ÷ AC01 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 ÷ AC01 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 200B ÷ 05D0 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 05D0 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 05D0 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [28.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 200B ÷ 002D ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 002D ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 002D ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 ÷ 002D ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 200B ÷ 231A ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 231A ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 ÷ 231A ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 ÷ 231A ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 200B ÷ 2024 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 2024 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 2024 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 ÷ 2024 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 200B ÷ 002C ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMMA (IS) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 002C ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] COMMA (IS) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 002C ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 × 002C ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 200B ÷ 1100 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 1100 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 ÷ 1100 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 ÷ 1100 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 200B ÷ 11A8 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 11A8 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 ÷ 11A8 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 200B ÷ 1160 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 1160 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 ÷ 1160 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 ÷ 1160 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 200B × 000A ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 200B × 0020 × 000A ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 000A ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 × 000A ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 200B × 0085 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 200B × 0020 × 0085 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0085 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 × 0085 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 200B ÷ 17D6 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 17D6 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 17D6 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 200B ÷ 0030 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 0030 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0030 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [23.02] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 ÷ 0030 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 200B ÷ 2329 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 2329 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 ÷ 2329 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 ÷ 2329 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 200B ÷ 0025 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 0025 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0025 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [24.03] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 ÷ 0025 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 200B ÷ 0024 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 0024 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0024 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [24.03] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 ÷ 0024 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 200B ÷ 0022 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 0022 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0022 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 ÷ 0022 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 200B × 0020 × 0020 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 × 0020 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 200B ÷ 002F ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 002F ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 002F ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 × 002F ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 200B ÷ 2060 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 2060 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 2060 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 × 2060 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 200B × 200B ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 200B × 0020 × 200B ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 200B ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 × 200B ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 200B ÷ 1F1E6 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 1F1E6 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 ÷ 1F1E6 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 200B ÷ 261D ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 261D ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 ÷ 261D ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 ÷ 261D ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 200B ÷ 1F3FB ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 1F3FB ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 ÷ 1F3FB ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 200B ÷ 0029 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 0029 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0029 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 × 0029 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 200B ÷ 0028 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 0028 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0028 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [30.01] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 ÷ 0028 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 200B ÷ 0001 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 0001 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0001 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 ÷ 0001 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 200B ÷ 200D ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 200D ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 200D ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 ÷ 200D ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 200B ÷ 00A7 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 00A7 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 00A7 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [28.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 200B ÷ 50005 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 50005 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 50005 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [28.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 ÷ 50005 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 200B ÷ 0E01 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 0E01 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0E01 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [28.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 200B ÷ 3041 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 3041 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 3041 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 ÷ 3041 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 1F1E6 ÷ 0023 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 ÷ 0023 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 ÷ 0023 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 1F1E6 ÷ 2014 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 ÷ 2014 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 ÷ 2014 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0009 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 ÷ 0009 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0009 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 1F1E6 ÷ 00B4 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 ÷ 00B4 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 ÷ 00B4 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 1F1E6 × 000B ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 × 000B ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 000B ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 × 000B ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 1F1E6 ÷ FFFC ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 ÷ FFFC ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 ÷ FFFC ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 1F1E6 × 007D ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 × 007D ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 007D ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 × 007D ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 1F1E6 × 000D ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 × 000D ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 000D ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 × 000D ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0021 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 × 0021 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0021 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 × 0021 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 1F1E6 × 00A0 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [12.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 ÷ 00A0 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 00A0 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 1F1E6 ÷ AC00 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 ÷ AC00 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 ÷ AC00 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 1F1E6 ÷ AC01 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 ÷ AC01 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 ÷ AC01 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 1F1E6 ÷ 05D0 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 ÷ 05D0 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 ÷ 05D0 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 1F1E6 × 002D ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 ÷ 002D ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 002D ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 ÷ 002D ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 1F1E6 ÷ 231A ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 ÷ 231A ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 ÷ 231A ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 ÷ 231A ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 1F1E6 × 2024 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 ÷ 2024 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 2024 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 1F1E6 × 002C ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 × 002C ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 002C ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 × 002C ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 1F1E6 ÷ 1100 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 ÷ 1100 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 ÷ 1100 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 1F1E6 ÷ 11A8 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 ÷ 11A8 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 ÷ 11A8 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 1F1E6 ÷ 1160 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 ÷ 1160 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 ÷ 1160 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 1F1E6 × 000A ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 × 000A ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 000A ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 × 000A ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0085 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 × 0085 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0085 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 × 0085 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 1F1E6 × 17D6 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 ÷ 17D6 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 17D6 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 1F1E6 ÷ 0030 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 ÷ 0030 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 ÷ 0030 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 1F1E6 ÷ 2329 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 ÷ 2329 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 ÷ 2329 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 ÷ 2329 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 1F1E6 ÷ 0025 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 ÷ 0025 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 ÷ 0025 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 1F1E6 ÷ 0024 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 ÷ 0024 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 ÷ 0024 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0022 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 ÷ 0022 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0022 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 × 0020 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 × 0020 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 1F1E6 × 002F ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 × 002F ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 002F ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 × 002F ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 1F1E6 × 2060 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 × 2060 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 2060 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 × 2060 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 1F1E6 × 200B ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 × 200B ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 200B ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 × 200B ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 1F1E6 × 1F1E6 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [30.11] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 ÷ 1F1E6 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 1F1E6 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [30.11] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 1F1E6 ÷ 261D ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 ÷ 261D ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 ÷ 261D ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 ÷ 261D ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 1F1E6 ÷ 1F3FB ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 ÷ 1F3FB ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 ÷ 1F3FB ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0029 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 × 0029 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0029 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 × 0029 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 1F1E6 ÷ 0028 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 ÷ 0028 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 ÷ 0028 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0001 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 ÷ 0001 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0001 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 1F1E6 × 200D ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 ÷ 200D ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 200D ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 ÷ 200D ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 1F1E6 ÷ 00A7 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 ÷ 00A7 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 ÷ 00A7 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 1F1E6 ÷ 50005 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 ÷ 50005 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 ÷ 50005 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 1F1E6 ÷ 0E01 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 ÷ 0E01 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 ÷ 0E01 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 1F1E6 × 3041 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 ÷ 3041 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 3041 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 261D ÷ 0023 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 261D × 0020 ÷ 0023 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 261D × 0308 ÷ 0023 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 261D ÷ 2014 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 261D × 0020 ÷ 2014 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 261D × 0308 ÷ 2014 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 261D × 0009 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 261D × 0020 ÷ 0009 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0009 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 261D ÷ 00B4 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 261D × 0020 ÷ 00B4 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 261D × 0308 ÷ 00B4 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 261D × 000B ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 261D × 0020 × 000B ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 000B ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 × 000B ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 261D ÷ FFFC ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 261D × 0020 ÷ FFFC ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 261D × 0308 ÷ FFFC ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 261D × 007D ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 261D × 0020 × 007D ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 007D ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 × 007D ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 261D × 000D ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 261D × 0020 × 000D ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 000D ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 × 000D ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 261D × 0021 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 261D × 0020 × 0021 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0021 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 × 0021 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 261D × 00A0 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [12.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 261D × 0020 ÷ 00A0 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 00A0 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 261D ÷ AC00 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 261D × 0020 ÷ AC00 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 261D × 0308 ÷ AC00 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 261D ÷ AC01 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 261D × 0020 ÷ AC01 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 261D × 0308 ÷ AC01 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 261D ÷ 05D0 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 261D × 0020 ÷ 05D0 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 261D × 0308 ÷ 05D0 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 261D × 002D ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 261D × 0020 ÷ 002D ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 002D ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 ÷ 002D ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 261D ÷ 231A ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 261D × 0020 ÷ 231A ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 261D × 0308 ÷ 231A ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 ÷ 231A ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 261D × 2024 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 261D × 0020 ÷ 2024 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 2024 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 261D × 002C ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 261D × 0020 × 002C ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
}
if (!$::TESTCHUNK or $::TESTCHUNK == 9) {
    Test_LB('× 261D × 0308 × 002C ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 × 002C ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 261D ÷ 1100 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 261D × 0020 ÷ 1100 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 261D × 0308 ÷ 1100 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 261D ÷ 11A8 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 261D × 0020 ÷ 11A8 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 261D × 0308 ÷ 11A8 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 261D ÷ 1160 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 261D × 0020 ÷ 1160 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 261D × 0308 ÷ 1160 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 261D × 000A ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 261D × 0020 × 000A ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 000A ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 × 000A ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 261D × 0085 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 261D × 0020 × 0085 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0085 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 × 0085 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 261D × 17D6 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 261D × 0020 ÷ 17D6 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 17D6 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 261D ÷ 0030 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 261D × 0020 ÷ 0030 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 261D × 0308 ÷ 0030 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 261D ÷ 2329 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 261D × 0020 ÷ 2329 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 261D × 0308 ÷ 2329 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 ÷ 2329 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 261D × 0025 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [23.13] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 261D × 0020 ÷ 0025 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0025 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [23.13] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 261D ÷ 0024 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 261D × 0020 ÷ 0024 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 261D × 0308 ÷ 0024 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 261D × 0022 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 261D × 0020 ÷ 0022 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0022 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 261D × 0020 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 261D × 0020 × 0020 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 × 0020 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 261D × 002F ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 261D × 0020 × 002F ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 002F ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 × 002F ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 261D × 2060 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 261D × 0020 × 2060 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 2060 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 × 2060 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 261D × 200B ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 261D × 0020 × 200B ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 200B ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 × 200B ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 261D ÷ 1F1E6 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 261D × 0020 ÷ 1F1E6 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 261D × 0308 ÷ 1F1E6 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 261D ÷ 261D ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 261D × 0020 ÷ 261D ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 261D × 0308 ÷ 261D ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 ÷ 261D ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 261D × 1F3FB ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [30.21] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 261D × 0020 ÷ 1F3FB ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 1F3FB ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [30.21] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 261D × 0029 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 261D × 0020 × 0029 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0029 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 × 0029 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 261D ÷ 0028 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 261D × 0020 ÷ 0028 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 261D × 0308 ÷ 0028 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 261D × 0001 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 261D × 0020 ÷ 0001 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0001 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 261D × 200D ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 261D × 0020 ÷ 200D ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 200D ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 ÷ 200D ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 261D ÷ 00A7 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 261D × 0020 ÷ 00A7 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 261D × 0308 ÷ 00A7 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 261D ÷ 50005 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 261D × 0020 ÷ 50005 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 261D × 0308 ÷ 50005 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 261D ÷ 0E01 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 261D × 0020 ÷ 0E01 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 261D × 0308 ÷ 0E01 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 261D × 3041 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 261D × 0020 ÷ 3041 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 3041 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 1F3FB ÷ 0023 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 ÷ 0023 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 ÷ 0023 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 1F3FB ÷ 2014 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 ÷ 2014 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 ÷ 2014 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 1F3FB × 0009 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 ÷ 0009 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0009 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 1F3FB ÷ 00B4 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 ÷ 00B4 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 ÷ 00B4 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 1F3FB × 000B ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 × 000B ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 000B ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 × 000B ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 1F3FB ÷ FFFC ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 ÷ FFFC ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 ÷ FFFC ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 1F3FB × 007D ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 × 007D ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 007D ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 × 007D ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 1F3FB × 000D ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 × 000D ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 000D ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 × 000D ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 1F3FB × 0021 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 × 0021 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0021 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 × 0021 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 1F3FB × 00A0 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [12.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 ÷ 00A0 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 00A0 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 1F3FB ÷ AC00 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 ÷ AC00 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 ÷ AC00 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 1F3FB ÷ AC01 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 ÷ AC01 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 ÷ AC01 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 1F3FB ÷ 05D0 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 ÷ 05D0 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 ÷ 05D0 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 1F3FB × 002D ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 ÷ 002D ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 002D ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 ÷ 002D ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 1F3FB ÷ 231A ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 ÷ 231A ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 ÷ 231A ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 ÷ 231A ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 1F3FB × 2024 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 ÷ 2024 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 2024 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 1F3FB × 002C ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 × 002C ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 002C ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 × 002C ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 1F3FB ÷ 1100 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 ÷ 1100 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 ÷ 1100 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 1F3FB ÷ 11A8 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 ÷ 11A8 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 ÷ 11A8 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 1F3FB ÷ 1160 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 ÷ 1160 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 ÷ 1160 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 1F3FB × 000A ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 × 000A ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 000A ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 × 000A ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 1F3FB × 0085 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 × 0085 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0085 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 × 0085 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 1F3FB × 17D6 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 ÷ 17D6 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 17D6 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 1F3FB ÷ 0030 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 ÷ 0030 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 ÷ 0030 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 1F3FB ÷ 2329 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 ÷ 2329 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 ÷ 2329 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 ÷ 2329 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 1F3FB × 0025 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [23.13] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 ÷ 0025 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0025 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [23.13] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 1F3FB ÷ 0024 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 ÷ 0024 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 ÷ 0024 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 1F3FB × 0022 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 ÷ 0022 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0022 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 × 0020 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 × 0020 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 1F3FB × 002F ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 × 002F ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 002F ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 × 002F ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 1F3FB × 2060 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 × 2060 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 2060 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 × 2060 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 1F3FB × 200B ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 × 200B ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 200B ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 × 200B ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 1F3FB ÷ 1F1E6 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 ÷ 1F1E6 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 ÷ 1F1E6 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 1F3FB ÷ 261D ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 ÷ 261D ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 ÷ 261D ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 ÷ 261D ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 1F3FB ÷ 1F3FB ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 ÷ 1F3FB ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 ÷ 1F3FB ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 1F3FB × 0029 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 × 0029 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0029 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 × 0029 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 1F3FB ÷ 0028 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 ÷ 0028 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 ÷ 0028 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 1F3FB × 0001 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 ÷ 0001 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0001 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 1F3FB × 200D ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 ÷ 200D ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 200D ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 ÷ 200D ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 1F3FB ÷ 00A7 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 ÷ 00A7 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 ÷ 00A7 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 1F3FB ÷ 50005 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 ÷ 50005 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 ÷ 50005 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 1F3FB ÷ 0E01 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 ÷ 0E01 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 ÷ 0E01 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 1F3FB × 3041 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 ÷ 3041 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 3041 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0029 × 0023 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [30.02] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0029 × 0020 ÷ 0023 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0023 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [30.02] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0029 ÷ 2014 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0029 × 0020 ÷ 2014 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0029 × 0308 ÷ 2014 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0029 × 0009 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0029 × 0020 ÷ 0009 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0009 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0029 ÷ 00B4 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0029 × 0020 ÷ 00B4 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0029 × 0308 ÷ 00B4 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0029 × 000B ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0029 × 0020 × 000B ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 000B ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 × 000B ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0029 ÷ FFFC ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0029 × 0020 ÷ FFFC ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0029 × 0308 ÷ FFFC ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0029 × 007D ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0029 × 0020 × 007D ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 007D ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 × 007D ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0029 × 000D ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0029 × 0020 × 000D ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 000D ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 × 000D ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0029 × 0021 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0029 × 0020 × 0021 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0021 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 × 0021 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0029 × 00A0 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [12.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0029 × 0020 ÷ 00A0 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 00A0 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0029 ÷ AC00 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0029 × 0020 ÷ AC00 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0029 × 0308 ÷ AC00 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0029 ÷ AC01 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0029 × 0020 ÷ AC01 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0029 × 0308 ÷ AC01 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0029 × 05D0 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [30.02] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0029 × 0020 ÷ 05D0 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 05D0 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [30.02] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0029 × 002D ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0029 × 0020 ÷ 002D ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 002D ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 ÷ 002D ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0029 ÷ 231A ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0029 × 0020 ÷ 231A ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0029 × 0308 ÷ 231A ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 ÷ 231A ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0029 × 2024 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0029 × 0020 ÷ 2024 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 2024 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0029 × 002C ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0029 × 0020 × 002C ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 002C ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 × 002C ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0029 ÷ 1100 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0029 × 0020 ÷ 1100 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0029 × 0308 ÷ 1100 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0029 ÷ 11A8 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0029 × 0020 ÷ 11A8 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0029 × 0308 ÷ 11A8 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0029 ÷ 1160 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0029 × 0020 ÷ 1160 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0029 × 0308 ÷ 1160 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0029 × 000A ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0029 × 0020 × 000A ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 000A ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 × 000A ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0029 × 0085 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0029 × 0020 × 0085 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0085 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 × 0085 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0029 × 17D6 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [16.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0029 × 0020 × 17D6 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [7.01] SPACE (SP) × [16.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 17D6 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [16.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 × 17D6 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [16.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0029 × 0030 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [30.02] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0029 × 0020 ÷ 0030 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0030 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [30.02] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0029 ÷ 2329 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 0029 × 0020 ÷ 2329 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 0029 × 0308 ÷ 2329 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 ÷ 2329 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 0029 ÷ 0025 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) ÷ [999.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0029 × 0020 ÷ 0025 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0029 × 0308 ÷ 0025 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0029 ÷ 0024 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0029 × 0020 ÷ 0024 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0029 × 0308 ÷ 0024 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0029 × 0022 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0029 × 0020 ÷ 0022 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0022 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0029 × 0020 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0029 × 0020 × 0020 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 × 0020 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0029 × 002F ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0029 × 0020 × 002F ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 002F ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 × 002F ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0029 × 2060 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0029 × 0020 × 2060 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 2060 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 × 2060 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0029 × 200B ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0029 × 0020 × 200B ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 200B ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 × 200B ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0029 ÷ 1F1E6 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0029 × 0020 ÷ 1F1E6 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0029 × 0308 ÷ 1F1E6 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0029 ÷ 261D ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0029 × 0020 ÷ 261D ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0029 × 0308 ÷ 261D ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 ÷ 261D ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0029 ÷ 1F3FB ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0029 × 0020 ÷ 1F3FB ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0029 × 0308 ÷ 1F3FB ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0029 × 0029 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0029 × 0020 × 0029 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0029 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 × 0029 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0029 ÷ 0028 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 0029 × 0020 ÷ 0028 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 0029 × 0308 ÷ 0028 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 0029 × 0001 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0029 × 0020 ÷ 0001 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0001 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0029 × 200D ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0029 × 0020 ÷ 200D ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 200D ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 ÷ 200D ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0029 × 00A7 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [30.02] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0029 × 0020 ÷ 00A7 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 00A7 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [30.02] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0029 × 50005 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [30.02] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0029 × 0020 ÷ 50005 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 50005 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [30.02] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0029 × 0E01 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [30.02] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0029 × 0020 ÷ 0E01 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0E01 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [30.02] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0029 × 3041 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [16.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0029 × 0020 × 3041 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [7.01] SPACE (SP) × [16.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 3041 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [16.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 × 3041 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [16.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0028 × 0023 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [14.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 0023 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [7.01] SPACE (SP) × [14.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0023 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 0023 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0028 × 2014 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [14.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 2014 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [7.01] SPACE (SP) × [14.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 2014 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 2014 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0028 × 0009 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [14.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 0009 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [7.01] SPACE (SP) × [14.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0009 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 0009 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0028 × 00B4 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [14.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 00B4 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [7.01] SPACE (SP) × [14.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 00B4 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 00B4 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0028 × 000B ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 000B ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 000B ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 000B ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0028 × FFFC ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [14.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × FFFC ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [7.01] SPACE (SP) × [14.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × FFFC ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × FFFC ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0028 × 007D ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 007D ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 007D ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 007D ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0028 × 000D ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 000D ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 000D ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 000D ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0028 × 0021 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 0021 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0021 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 0021 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0028 × 00A0 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [12.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 00A0 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [7.01] SPACE (SP) × [14.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 00A0 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 00A0 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0028 × AC00 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [14.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × AC00 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [7.01] SPACE (SP) × [14.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × AC00 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × AC00 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0028 × AC01 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [14.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × AC01 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [7.01] SPACE (SP) × [14.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × AC01 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × AC01 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0028 × 05D0 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [14.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 05D0 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [7.01] SPACE (SP) × [14.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 05D0 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 05D0 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0028 × 002D ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [14.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 002D ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [7.01] SPACE (SP) × [14.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 002D ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 002D ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0028 × 231A ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [14.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 231A ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [7.01] SPACE (SP) × [14.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 231A ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 231A ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0028 × 2024 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [14.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 2024 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [7.01] SPACE (SP) × [14.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 2024 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 2024 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0028 × 002C ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 002C ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 002C ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 002C ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0028 × 1100 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [14.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 1100 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [7.01] SPACE (SP) × [14.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 1100 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 1100 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0028 × 11A8 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [14.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 11A8 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [7.01] SPACE (SP) × [14.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 11A8 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 11A8 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0028 × 1160 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [14.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 1160 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [7.01] SPACE (SP) × [14.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 1160 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 1160 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0028 × 000A ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 000A ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 000A ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 000A ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0028 × 0085 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 0085 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0085 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 0085 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0028 × 17D6 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [14.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 17D6 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [7.01] SPACE (SP) × [14.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 17D6 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 17D6 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0028 × 0030 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [14.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 0030 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [7.01] SPACE (SP) × [14.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0030 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 0030 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0028 × 2329 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [14.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 2329 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [7.01] SPACE (SP) × [14.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 2329 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 2329 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 0028 × 0025 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [14.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 0025 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [7.01] SPACE (SP) × [14.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0025 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 0025 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0028 × 0024 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [14.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 0024 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [7.01] SPACE (SP) × [14.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0024 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 0024 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0028 × 0022 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [14.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 0022 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [7.01] SPACE (SP) × [14.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0022 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 0022 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0028 × 0020 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 0020 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 0020 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0028 × 002F ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 002F ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 002F ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 002F ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0028 × 2060 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 2060 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 2060 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 2060 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0028 × 200B ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 200B ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 200B ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 200B ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0028 × 1F1E6 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [14.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 1F1E6 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [7.01] SPACE (SP) × [14.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 1F1E6 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 1F1E6 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0028 × 261D ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [14.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 261D ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [7.01] SPACE (SP) × [14.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 261D ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 261D ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0028 × 1F3FB ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [14.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 1F3FB ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [7.01] SPACE (SP) × [14.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 1F3FB ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 1F3FB ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0028 × 0029 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 0029 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0029 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 0029 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0028 × 0028 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [14.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 0028 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [7.01] SPACE (SP) × [14.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0028 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 0028 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 0028 × 0001 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 0001 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [7.01] SPACE (SP) × [14.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0001 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 0001 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0028 × 200D ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 200D ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [7.01] SPACE (SP) × [14.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 200D ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 200D ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0028 × 00A7 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [14.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 00A7 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [7.01] SPACE (SP) × [14.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 00A7 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 00A7 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0028 × 50005 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [14.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 50005 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [7.01] SPACE (SP) × [14.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 50005 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 50005 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0028 × 0E01 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [14.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 0E01 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [7.01] SPACE (SP) × [14.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0E01 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 0E01 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0028 × 3041 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [14.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 3041 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [7.01] SPACE (SP) × [14.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 3041 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 3041 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0001 × 0023 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [28.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0001 × 0020 ÷ 0023 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0023 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [28.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0001 ÷ 2014 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0001 × 0020 ÷ 2014 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0001 × 0308 ÷ 2014 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0001 × 0009 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0001 × 0020 ÷ 0009 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0009 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0001 ÷ 00B4 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0001 × 0020 ÷ 00B4 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0001 × 0308 ÷ 00B4 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0001 × 000B ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0001 × 0020 × 000B ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 000B ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 × 000B ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0001 ÷ FFFC ÷	#  × [0.3] <START OF HEADING> (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0001 × 0020 ÷ FFFC ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0001 × 0308 ÷ FFFC ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0001 × 007D ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [13.04] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0001 × 0020 × 007D ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 007D ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.04] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 × 007D ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0001 × 000D ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0001 × 0020 × 000D ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 000D ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 × 000D ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0001 × 0021 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0001 × 0020 × 0021 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0021 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 × 0021 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0001 × 00A0 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [12.3] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0001 × 0020 ÷ 00A0 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 00A0 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.3] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0001 ÷ AC00 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0001 × 0020 ÷ AC00 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0001 × 0308 ÷ AC00 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0001 ÷ AC01 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0001 × 0020 ÷ AC01 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0001 × 0308 ÷ AC01 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0001 × 05D0 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [28.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0001 × 0020 ÷ 05D0 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 05D0 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [28.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0001 × 002D ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0001 × 0020 ÷ 002D ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 002D ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 ÷ 002D ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0001 ÷ 231A ÷	#  × [0.3] <START OF HEADING> (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0001 × 0020 ÷ 231A ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0001 × 0308 ÷ 231A ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 ÷ 231A ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0001 × 2024 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0001 × 0020 ÷ 2024 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 2024 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0001 × 002C ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [13.04] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0001 × 0020 × 002C ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 002C ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.04] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 × 002C ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0001 ÷ 1100 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0001 × 0020 ÷ 1100 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0001 × 0308 ÷ 1100 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0001 ÷ 11A8 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0001 × 0020 ÷ 11A8 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0001 × 0308 ÷ 11A8 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0001 ÷ 1160 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0001 × 0020 ÷ 1160 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0001 × 0308 ÷ 1160 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0001 × 000A ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0001 × 0020 × 000A ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 000A ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 × 000A ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0001 × 0085 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0001 × 0020 × 0085 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0085 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 × 0085 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0001 × 17D6 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0001 × 0020 ÷ 17D6 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 17D6 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0001 × 0030 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [23.02] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0001 × 0020 ÷ 0030 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0030 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [23.02] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0001 ÷ 2329 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 0001 × 0020 ÷ 2329 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 0001 × 0308 ÷ 2329 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 ÷ 2329 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 0001 × 0025 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [24.03] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0001 × 0020 ÷ 0025 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0025 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [24.03] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0001 × 0024 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [24.03] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0001 × 0020 ÷ 0024 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0024 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [24.03] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0001 × 0022 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0001 × 0020 ÷ 0022 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0022 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0001 × 0020 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0001 × 0020 × 0020 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 × 0020 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0001 × 002F ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [13.04] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0001 × 0020 × 002F ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 002F ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.04] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 × 002F ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0001 × 2060 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0001 × 0020 × 2060 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 2060 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 × 2060 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0001 × 200B ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0001 × 0020 × 200B ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 200B ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 × 200B ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0001 ÷ 1F1E6 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0001 × 0020 ÷ 1F1E6 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0001 × 0308 ÷ 1F1E6 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0001 ÷ 261D ÷	#  × [0.3] <START OF HEADING> (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0001 × 0020 ÷ 261D ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0001 × 0308 ÷ 261D ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 ÷ 261D ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0001 ÷ 1F3FB ÷	#  × [0.3] <START OF HEADING> (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0001 × 0020 ÷ 1F3FB ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0001 × 0308 ÷ 1F3FB ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0001 × 0029 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [13.04] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0001 × 0020 × 0029 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0029 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.04] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 × 0029 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0001 × 0028 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [30.01] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 0001 × 0020 ÷ 0028 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0028 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [30.01] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 0001 × 0001 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0001 × 0020 ÷ 0001 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0001 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0001 × 200D ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0001 × 0020 ÷ 200D ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 200D ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 ÷ 200D ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0001 × 00A7 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [28.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0001 × 0020 ÷ 00A7 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 00A7 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [28.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0001 × 50005 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [28.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0001 × 0020 ÷ 50005 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 50005 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [28.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0001 × 0E01 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [28.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0001 × 0020 ÷ 0E01 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0E01 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [28.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0001 × 3041 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0001 × 0020 ÷ 3041 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 3041 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 200D × 0023 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 200D × 0020 ÷ 0023 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0023 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [28.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 200D × 2014 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 200D × 0020 ÷ 2014 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 200D × 0308 ÷ 2014 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 200D × 0009 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 200D × 0020 ÷ 0009 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0009 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 200D × 00B4 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 200D × 0020 ÷ 00B4 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 200D × 0308 ÷ 00B4 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 200D × 000B ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 200D × 0020 × 000B ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 000B ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 × 000B ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 200D × FFFC ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 200D × 0020 ÷ FFFC ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 200D × 0308 ÷ FFFC ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 200D × 007D ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 200D × 0020 × 007D ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 007D ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [13.04] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 × 007D ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 200D × 000D ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 200D × 0020 × 000D ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 000D ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 × 000D ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 200D × 0021 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 200D × 0020 × 0021 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0021 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 × 0021 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 200D × 00A0 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 200D × 0020 ÷ 00A0 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 00A0 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [12.3] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 200D × AC00 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 200D × 0020 ÷ AC00 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 200D × 0308 ÷ AC00 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 200D × AC01 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 200D × 0020 ÷ AC01 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 200D × 0308 ÷ AC01 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 200D × 05D0 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 200D × 0020 ÷ 05D0 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 05D0 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [28.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 200D × 002D ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 200D × 0020 ÷ 002D ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 002D ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 ÷ 002D ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 200D × 231A ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] WATCH (ID) ÷ [0.3]');
    Test_LB('× 200D × 0020 ÷ 231A ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 200D × 0308 ÷ 231A ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 ÷ 231A ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 200D × 2024 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 200D × 0020 ÷ 2024 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 2024 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 200D × 002C ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMMA (IS) ÷ [0.3]');
    Test_LB('× 200D × 0020 × 002C ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 002C ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [13.04] COMMA (IS) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 × 002C ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 200D × 1100 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 200D × 0020 ÷ 1100 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 200D × 0308 ÷ 1100 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 200D × 11A8 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 200D × 0020 ÷ 11A8 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 200D × 0308 ÷ 11A8 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 200D × 1160 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 200D × 0020 ÷ 1160 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 200D × 0308 ÷ 1160 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 200D × 000A ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 200D × 0020 × 000A ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 000A ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 × 000A ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 200D × 0085 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 200D × 0020 × 0085 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0085 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 × 0085 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 200D × 17D6 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 200D × 0020 ÷ 17D6 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 17D6 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 200D × 0030 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 200D × 0020 ÷ 0030 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0030 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [23.02] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 200D × 2329 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 200D × 0020 ÷ 2329 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 200D × 0308 ÷ 2329 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 ÷ 2329 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 200D × 0025 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 200D × 0020 ÷ 0025 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0025 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [24.03] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 200D × 0024 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 200D × 0020 ÷ 0024 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0024 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [24.03] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 200D × 0022 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 200D × 0020 ÷ 0022 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0022 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 200D × 0020 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 200D × 0020 × 0020 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 × 0020 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 200D × 002F ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 200D × 0020 × 002F ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 002F ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [13.04] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 × 002F ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 200D × 2060 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 200D × 0020 × 2060 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 2060 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 × 2060 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 200D × 200B ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 200D × 0020 × 200B ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 200B ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 × 200B ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 200D × 1F1E6 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 200D × 0020 ÷ 1F1E6 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 200D × 0308 ÷ 1F1E6 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 200D × 261D ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 200D × 0020 ÷ 261D ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 200D × 0308 ÷ 261D ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 ÷ 261D ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 200D × 1F3FB ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 200D × 0020 ÷ 1F3FB ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 200D × 0308 ÷ 1F3FB ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 200D × 0029 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 200D × 0020 × 0029 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0029 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [13.04] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 × 0029 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 200D × 0028 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 200D × 0020 ÷ 0028 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0028 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [30.01] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 200D × 0001 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 200D × 0020 ÷ 0001 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0001 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 200D × 200D ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 200D × 0020 ÷ 200D ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 200D ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 ÷ 200D ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 200D × 00A7 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 200D × 0020 ÷ 00A7 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 00A7 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [28.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 200D × 50005 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 200D × 0020 ÷ 50005 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 50005 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [28.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 200D × 0E01 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 200D × 0020 ÷ 0E01 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0E01 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [28.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 200D × 3041 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 200D × 0020 ÷ 3041 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 3041 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 00A7 × 0023 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [28.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 ÷ 0023 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0023 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [28.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 00A7 ÷ 2014 ÷	#  × [0.3] SECTION SIGN (AI_AL) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 ÷ 2014 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 ÷ 2014 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 00A7 × 0009 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 ÷ 0009 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0009 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 00A7 ÷ 00B4 ÷	#  × [0.3] SECTION SIGN (AI_AL) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 ÷ 00B4 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 ÷ 00B4 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 00A7 × 000B ÷	#  × [0.3] SECTION SIGN (AI_AL) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 × 000B ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 000B ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 × 000B ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 00A7 ÷ FFFC ÷	#  × [0.3] SECTION SIGN (AI_AL) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 ÷ FFFC ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 ÷ FFFC ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 00A7 × 007D ÷	#  × [0.3] SECTION SIGN (AI_AL) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 × 007D ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 007D ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 × 007D ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 00A7 × 000D ÷	#  × [0.3] SECTION SIGN (AI_AL) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 × 000D ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 000D ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 × 000D ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 00A7 × 0021 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 × 0021 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0021 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 × 0021 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 00A7 × 00A0 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [12.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 ÷ 00A0 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 00A0 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 00A7 ÷ AC00 ÷	#  × [0.3] SECTION SIGN (AI_AL) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 ÷ AC00 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 ÷ AC00 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 00A7 ÷ AC01 ÷	#  × [0.3] SECTION SIGN (AI_AL) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 ÷ AC01 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 ÷ AC01 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 00A7 × 05D0 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [28.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 ÷ 05D0 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 05D0 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [28.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 00A7 × 002D ÷	#  × [0.3] SECTION SIGN (AI_AL) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 ÷ 002D ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 002D ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 ÷ 002D ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 00A7 ÷ 231A ÷	#  × [0.3] SECTION SIGN (AI_AL) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 ÷ 231A ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 ÷ 231A ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 ÷ 231A ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 00A7 × 2024 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 ÷ 2024 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 2024 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 00A7 × 002C ÷	#  × [0.3] SECTION SIGN (AI_AL) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 × 002C ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 002C ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 × 002C ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 00A7 ÷ 1100 ÷	#  × [0.3] SECTION SIGN (AI_AL) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 ÷ 1100 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 ÷ 1100 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 00A7 ÷ 11A8 ÷	#  × [0.3] SECTION SIGN (AI_AL) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 ÷ 11A8 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 ÷ 11A8 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 00A7 ÷ 1160 ÷	#  × [0.3] SECTION SIGN (AI_AL) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 ÷ 1160 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 ÷ 1160 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 00A7 × 000A ÷	#  × [0.3] SECTION SIGN (AI_AL) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 × 000A ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 000A ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 × 000A ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 00A7 × 0085 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 × 0085 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0085 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 × 0085 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 00A7 × 17D6 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 ÷ 17D6 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 17D6 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 00A7 × 0030 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [23.02] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 ÷ 0030 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0030 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [23.02] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 00A7 ÷ 2329 ÷	#  × [0.3] SECTION SIGN (AI_AL) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 ÷ 2329 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 ÷ 2329 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 ÷ 2329 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 00A7 × 0025 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [24.03] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 ÷ 0025 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0025 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [24.03] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 00A7 × 0024 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [24.03] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 ÷ 0024 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0024 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [24.03] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 00A7 × 0022 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 ÷ 0022 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0022 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 × 0020 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 × 0020 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 00A7 × 002F ÷	#  × [0.3] SECTION SIGN (AI_AL) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 × 002F ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 002F ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 × 002F ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 00A7 × 2060 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 × 2060 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 2060 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 × 2060 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 00A7 × 200B ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 × 200B ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 200B ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 × 200B ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 00A7 ÷ 1F1E6 ÷	#  × [0.3] SECTION SIGN (AI_AL) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 ÷ 1F1E6 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 ÷ 1F1E6 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 00A7 ÷ 261D ÷	#  × [0.3] SECTION SIGN (AI_AL) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 ÷ 261D ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 ÷ 261D ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 ÷ 261D ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 00A7 ÷ 1F3FB ÷	#  × [0.3] SECTION SIGN (AI_AL) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 ÷ 1F3FB ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 ÷ 1F3FB ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 00A7 × 0029 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 × 0029 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0029 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 × 0029 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 00A7 × 0028 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [30.01] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 ÷ 0028 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0028 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [30.01] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 00A7 × 0001 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 ÷ 0001 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0001 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 00A7 × 200D ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 ÷ 200D ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 200D ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 ÷ 200D ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 00A7 × 00A7 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [28.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 ÷ 00A7 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 00A7 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [28.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 00A7 × 50005 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [28.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 ÷ 50005 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 50005 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [28.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 00A7 × 0E01 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [28.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 ÷ 0E01 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0E01 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [28.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 00A7 × 3041 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 ÷ 3041 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 3041 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 50005 × 0023 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [28.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 50005 × 0020 ÷ 0023 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0023 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [28.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 50005 ÷ 2014 ÷	#  × [0.3] <reserved-50005> (XX_AL) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 50005 × 0020 ÷ 2014 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 50005 × 0308 ÷ 2014 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 50005 × 0009 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 50005 × 0020 ÷ 0009 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0009 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 50005 ÷ 00B4 ÷	#  × [0.3] <reserved-50005> (XX_AL) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 50005 × 0020 ÷ 00B4 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 50005 × 0308 ÷ 00B4 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 50005 × 000B ÷	#  × [0.3] <reserved-50005> (XX_AL) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 50005 × 0020 × 000B ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 000B ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 × 000B ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 50005 ÷ FFFC ÷	#  × [0.3] <reserved-50005> (XX_AL) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 50005 × 0020 ÷ FFFC ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 50005 × 0308 ÷ FFFC ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 50005 × 007D ÷	#  × [0.3] <reserved-50005> (XX_AL) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 50005 × 0020 × 007D ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 007D ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 × 007D ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 50005 × 000D ÷	#  × [0.3] <reserved-50005> (XX_AL) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 50005 × 0020 × 000D ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 000D ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 × 000D ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 50005 × 0021 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 50005 × 0020 × 0021 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0021 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 × 0021 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 50005 × 00A0 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [12.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 50005 × 0020 ÷ 00A0 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 00A0 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 50005 ÷ AC00 ÷	#  × [0.3] <reserved-50005> (XX_AL) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 50005 × 0020 ÷ AC00 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 50005 × 0308 ÷ AC00 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 50005 ÷ AC01 ÷	#  × [0.3] <reserved-50005> (XX_AL) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 50005 × 0020 ÷ AC01 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 50005 × 0308 ÷ AC01 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 50005 × 05D0 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [28.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 50005 × 0020 ÷ 05D0 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 05D0 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [28.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 50005 × 002D ÷	#  × [0.3] <reserved-50005> (XX_AL) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 50005 × 0020 ÷ 002D ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 002D ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 ÷ 002D ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 50005 ÷ 231A ÷	#  × [0.3] <reserved-50005> (XX_AL) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 50005 × 0020 ÷ 231A ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 50005 × 0308 ÷ 231A ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 ÷ 231A ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 50005 × 2024 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 50005 × 0020 ÷ 2024 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 2024 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 50005 × 002C ÷	#  × [0.3] <reserved-50005> (XX_AL) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 50005 × 0020 × 002C ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 002C ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 × 002C ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 50005 ÷ 1100 ÷	#  × [0.3] <reserved-50005> (XX_AL) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 50005 × 0020 ÷ 1100 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 50005 × 0308 ÷ 1100 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 50005 ÷ 11A8 ÷	#  × [0.3] <reserved-50005> (XX_AL) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 50005 × 0020 ÷ 11A8 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 50005 × 0308 ÷ 11A8 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 50005 ÷ 1160 ÷	#  × [0.3] <reserved-50005> (XX_AL) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 50005 × 0020 ÷ 1160 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 50005 × 0308 ÷ 1160 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 50005 × 000A ÷	#  × [0.3] <reserved-50005> (XX_AL) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 50005 × 0020 × 000A ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 000A ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 × 000A ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 50005 × 0085 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 50005 × 0020 × 0085 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0085 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 × 0085 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 50005 × 17D6 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 50005 × 0020 ÷ 17D6 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 17D6 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 50005 × 0030 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [23.02] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 50005 × 0020 ÷ 0030 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0030 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [23.02] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 50005 ÷ 2329 ÷	#  × [0.3] <reserved-50005> (XX_AL) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 50005 × 0020 ÷ 2329 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 50005 × 0308 ÷ 2329 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 ÷ 2329 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 50005 × 0025 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [24.03] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 50005 × 0020 ÷ 0025 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0025 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [24.03] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 50005 × 0024 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [24.03] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 50005 × 0020 ÷ 0024 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0024 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [24.03] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 50005 × 0022 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 50005 × 0020 ÷ 0022 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0022 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 50005 × 0020 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 50005 × 0020 × 0020 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 × 0020 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 50005 × 002F ÷	#  × [0.3] <reserved-50005> (XX_AL) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 50005 × 0020 × 002F ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 002F ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 × 002F ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 50005 × 2060 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 50005 × 0020 × 2060 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 2060 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 × 2060 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 50005 × 200B ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 50005 × 0020 × 200B ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 200B ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 × 200B ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 50005 ÷ 1F1E6 ÷	#  × [0.3] <reserved-50005> (XX_AL) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 50005 × 0020 ÷ 1F1E6 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 50005 × 0308 ÷ 1F1E6 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 50005 ÷ 261D ÷	#  × [0.3] <reserved-50005> (XX_AL) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 50005 × 0020 ÷ 261D ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 50005 × 0308 ÷ 261D ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 ÷ 261D ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 50005 ÷ 1F3FB ÷	#  × [0.3] <reserved-50005> (XX_AL) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 50005 × 0020 ÷ 1F3FB ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 50005 × 0308 ÷ 1F3FB ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 50005 × 0029 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 50005 × 0020 × 0029 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0029 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 × 0029 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 50005 × 0028 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [30.01] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 50005 × 0020 ÷ 0028 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0028 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [30.01] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 50005 × 0001 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 50005 × 0020 ÷ 0001 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0001 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 50005 × 200D ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 50005 × 0020 ÷ 200D ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 200D ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 ÷ 200D ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 50005 × 00A7 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [28.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 50005 × 0020 ÷ 00A7 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 00A7 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [28.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 50005 × 50005 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [28.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 50005 × 0020 ÷ 50005 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 50005 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [28.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 50005 × 0E01 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [28.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 50005 × 0020 ÷ 0E01 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0E01 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [28.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 50005 × 3041 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 50005 × 0020 ÷ 3041 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 3041 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0E01 × 0023 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [28.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 ÷ 0023 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0023 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [28.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0E01 ÷ 2014 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 ÷ 2014 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 ÷ 2014 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0E01 × 0009 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 ÷ 0009 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0009 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0E01 ÷ 00B4 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 ÷ 00B4 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 ÷ 00B4 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0E01 × 000B ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 × 000B ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 000B ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 × 000B ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0E01 ÷ FFFC ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 ÷ FFFC ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 ÷ FFFC ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0E01 × 007D ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 × 007D ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 007D ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 × 007D ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0E01 × 000D ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 × 000D ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 000D ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 × 000D ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0E01 × 0021 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 × 0021 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0021 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 × 0021 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0E01 × 00A0 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [12.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 ÷ 00A0 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 00A0 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0E01 ÷ AC00 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 ÷ AC00 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 ÷ AC00 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0E01 ÷ AC01 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 ÷ AC01 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 ÷ AC01 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0E01 × 05D0 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [28.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 ÷ 05D0 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 05D0 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [28.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0E01 × 002D ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 ÷ 002D ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 002D ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 ÷ 002D ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0E01 ÷ 231A ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 ÷ 231A ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 ÷ 231A ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 ÷ 231A ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0E01 × 2024 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 ÷ 2024 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 2024 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0E01 × 002C ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 × 002C ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 002C ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 × 002C ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0E01 ÷ 1100 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 ÷ 1100 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 ÷ 1100 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0E01 ÷ 11A8 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 ÷ 11A8 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 ÷ 11A8 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0E01 ÷ 1160 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 ÷ 1160 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 ÷ 1160 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0E01 × 000A ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 × 000A ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 000A ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 × 000A ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0E01 × 0085 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 × 0085 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0085 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 × 0085 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0E01 × 17D6 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 ÷ 17D6 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 17D6 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0E01 × 0030 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [23.02] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 ÷ 0030 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0030 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [23.02] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0E01 ÷ 2329 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 ÷ 2329 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 ÷ 2329 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 ÷ 2329 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 0E01 × 0025 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [24.03] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 ÷ 0025 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0025 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [24.03] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0E01 × 0024 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [24.03] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 ÷ 0024 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0024 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [24.03] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0E01 × 0022 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 ÷ 0022 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0022 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 × 0020 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 × 0020 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0E01 × 002F ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 × 002F ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 002F ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 × 002F ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0E01 × 2060 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 × 2060 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 2060 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 × 2060 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0E01 × 200B ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 × 200B ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 200B ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 × 200B ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0E01 ÷ 1F1E6 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 ÷ 1F1E6 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 ÷ 1F1E6 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0E01 ÷ 261D ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 ÷ 261D ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 ÷ 261D ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 ÷ 261D ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0E01 ÷ 1F3FB ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 ÷ 1F3FB ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 ÷ 1F3FB ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0E01 × 0029 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 × 0029 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0029 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 × 0029 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0E01 × 0028 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [30.01] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 ÷ 0028 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0028 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [30.01] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 0E01 × 0001 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 ÷ 0001 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0001 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0E01 × 200D ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 ÷ 200D ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 200D ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 ÷ 200D ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0E01 × 00A7 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [28.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 ÷ 00A7 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 00A7 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [28.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0E01 × 50005 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [28.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 ÷ 50005 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 50005 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [28.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0E01 × 0E01 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [28.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 ÷ 0E01 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0E01 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [28.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0E01 × 3041 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 ÷ 3041 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 3041 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 3041 ÷ 0023 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 3041 × 0020 ÷ 0023 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 3041 × 0308 ÷ 0023 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 3041 ÷ 2014 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 3041 × 0020 ÷ 2014 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 3041 × 0308 ÷ 2014 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 3041 × 0009 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 3041 × 0020 ÷ 0009 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0009 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 3041 ÷ 00B4 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 3041 × 0020 ÷ 00B4 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 3041 × 0308 ÷ 00B4 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 3041 × 000B ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 3041 × 0020 × 000B ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 000B ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 × 000B ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 3041 ÷ FFFC ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 3041 × 0020 ÷ FFFC ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 3041 × 0308 ÷ FFFC ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 3041 × 007D ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 3041 × 0020 × 007D ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 007D ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 × 007D ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 3041 × 000D ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 3041 × 0020 × 000D ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 000D ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 × 000D ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 3041 × 0021 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 3041 × 0020 × 0021 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0021 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 × 0021 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 3041 × 00A0 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [12.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 3041 × 0020 ÷ 00A0 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 00A0 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 3041 ÷ AC00 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 3041 × 0020 ÷ AC00 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 3041 × 0308 ÷ AC00 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 3041 ÷ AC01 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 3041 × 0020 ÷ AC01 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 3041 × 0308 ÷ AC01 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 3041 ÷ 05D0 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 3041 × 0020 ÷ 05D0 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 3041 × 0308 ÷ 05D0 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 3041 × 002D ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 3041 × 0020 ÷ 002D ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 002D ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 ÷ 002D ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 3041 ÷ 231A ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 3041 × 0020 ÷ 231A ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 3041 × 0308 ÷ 231A ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 ÷ 231A ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 3041 × 2024 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 3041 × 0020 ÷ 2024 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 2024 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 3041 × 002C ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 3041 × 0020 × 002C ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 002C ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 × 002C ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 3041 ÷ 1100 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 3041 × 0020 ÷ 1100 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 3041 × 0308 ÷ 1100 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 3041 ÷ 11A8 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 3041 × 0020 ÷ 11A8 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 3041 × 0308 ÷ 11A8 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 3041 ÷ 1160 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 3041 × 0020 ÷ 1160 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 3041 × 0308 ÷ 1160 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 3041 × 000A ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 3041 × 0020 × 000A ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 000A ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 × 000A ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 3041 × 0085 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 3041 × 0020 × 0085 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0085 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 × 0085 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 3041 × 17D6 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 3041 × 0020 ÷ 17D6 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 17D6 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 3041 ÷ 0030 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 3041 × 0020 ÷ 0030 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 3041 × 0308 ÷ 0030 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 3041 ÷ 2329 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 3041 × 0020 ÷ 2329 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 3041 × 0308 ÷ 2329 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 ÷ 2329 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 3041 ÷ 0025 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [999.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 3041 × 0020 ÷ 0025 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 3041 × 0308 ÷ 0025 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 3041 ÷ 0024 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 3041 × 0020 ÷ 0024 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 3041 × 0308 ÷ 0024 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 3041 × 0022 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 3041 × 0020 ÷ 0022 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0022 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 3041 × 0020 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 3041 × 0020 × 0020 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 × 0020 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 3041 × 002F ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 3041 × 0020 × 002F ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 002F ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 × 002F ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 3041 × 2060 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 3041 × 0020 × 2060 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 2060 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 × 2060 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 3041 × 200B ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 3041 × 0020 × 200B ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 200B ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 × 200B ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 3041 ÷ 1F1E6 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 3041 × 0020 ÷ 1F1E6 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 3041 × 0308 ÷ 1F1E6 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 3041 ÷ 261D ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 3041 × 0020 ÷ 261D ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 3041 × 0308 ÷ 261D ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 ÷ 261D ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 3041 ÷ 1F3FB ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 3041 × 0020 ÷ 1F3FB ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 3041 × 0308 ÷ 1F3FB ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 3041 × 0029 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 3041 × 0020 × 0029 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0029 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 × 0029 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 3041 ÷ 0028 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 3041 × 0020 ÷ 0028 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 3041 × 0308 ÷ 0028 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 3041 × 0001 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 3041 × 0020 ÷ 0001 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0001 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 3041 × 200D ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 3041 × 0020 ÷ 200D ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 200D ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 ÷ 200D ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 3041 ÷ 00A7 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 3041 × 0020 ÷ 00A7 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 3041 × 0308 ÷ 00A7 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 3041 ÷ 50005 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 3041 × 0020 ÷ 50005 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 3041 × 0308 ÷ 50005 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 3041 ÷ 0E01 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 3041 × 0020 ÷ 0E01 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 3041 × 0308 ÷ 0E01 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 3041 × 3041 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 3041 × 0020 ÷ 3041 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 3041 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 000D × 000A ÷ 0061 × 000A ÷ 0308 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) × [5.01] <LINE FEED (LF)> (LF) ÷ [5.03] LATIN SMALL LETTER A (AL) × [6.0] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) ÷ [0.3]');
    Test_LB('× 0061 × 0308 ÷	#  × [0.3] LATIN SMALL LETTER A (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [0.3]');
    Test_LB('× 0020 ÷ 200D × 0646 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] ARABIC LETTER NOON (AL) ÷ [0.3]');
    Test_LB('× 0646 × 200D × 0020 ÷	#  × [0.3] ARABIC LETTER NOON (AL) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 000B ÷ 3041 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 000D ÷ 3041 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0085 ÷ 3041 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 200D × 261D ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 3041 × 2060 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 2060 × 3041 ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 00A0 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 200D × 00A0 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 200D × 002F ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 2014 × 2014 ÷	#  × [0.3] EM DASH (B2) × [17.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 3041 ÷ FFFC ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× FFFC ÷ 3041 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) ÷ [20.02] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 3041 × 002D ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0E01 × 2024 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0021 × 2024 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 2024 × 2024 ÷	#  × [0.3] ONE DOT LEADER (IN) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0030 × 2024 ÷	#  × [0.3] DIGIT ZERO (NU) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 261D × 0025 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [23.13] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0E01 × 0030 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [23.02] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0024 × 261D ÷	#  × [0.3] DOLLAR SIGN (PR) × [23.12] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0024 × 0E01 ÷	#  × [0.3] DOLLAR SIGN (PR) × [24.02] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0025 × 0E01 ÷	#  × [0.3] PERCENT SIGN (PO) × [24.02] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 1100 × 1160 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [26.01] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 1160 × 1160 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [26.02] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 11A8 × 11A8 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [26.03] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 1160 × 2024 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 1160 × 0025 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [27.01] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0024 × 1160 ÷	#  × [0.3] DOLLAR SIGN (PR) × [27.02] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 261D × 1F3FB ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [30.21] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0066 × 0069 × 006E × 0061 × 006C ÷	#  × [0.3] LATIN SMALL LETTER F (AL) × [28.0] LATIN SMALL LETTER I (AL) × [28.0] LATIN SMALL LETTER N (AL) × [28.0] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER L (AL) ÷ [0.3]');
    Test_LB('× 0063 × 0061 × 006E × 0027 × 0074 ÷	#  × [0.3] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER N (AL) × [19.01] APOSTROPHE (QU) × [19.02] LATIN SMALL LETTER T (AL) ÷ [0.3]');
    Test_LB('× 0063 × 0061 × 006E × 2019 × 0074 ÷	#  × [0.3] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER N (AL) × [19.01] RIGHT SINGLE QUOTATION MARK (QU) × [19.02] LATIN SMALL LETTER T (AL) ÷ [0.3]');
    Test_LB('× 0027 × 0063 × 0061 × 006E × 0027 × 0020 ÷ 006E × 006F × 0074 ÷	#  × [0.3] APOSTROPHE (QU) × [19.02] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER N (AL) × [19.01] APOSTROPHE (QU) × [7.01] SPACE (SP) ÷ [18.0] LATIN SMALL LETTER N (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER T (AL) ÷ [0.3]');
    Test_LB('× 0063 × 0061 × 006E × 0020 ÷ 0027 × 006E × 006F × 0074 × 0027 ÷	#  × [0.3] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER N (AL) × [7.01] SPACE (SP) ÷ [18.0] APOSTROPHE (QU) × [19.02] LATIN SMALL LETTER N (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER T (AL) × [19.01] APOSTROPHE (QU) ÷ [0.3]');
    Test_LB('× 0062 × 0075 × 0067 × 0028 × 0073 × 0029 × 0020 × 0020 × 0020 × 0020 × 0020 ÷	#  × [0.3] LATIN SMALL LETTER B (AL) × [28.0] LATIN SMALL LETTER U (AL) × [28.0] LATIN SMALL LETTER G (AL) × [30.01] LEFT PARENTHESIS (OP_OP30) × [14.0] LATIN SMALL LETTER S (AL) × [13.02] RIGHT PARENTHESIS (CP_CP30) × [7.01] SPACE (SP) × [7.01] SPACE (SP) × [7.01] SPACE (SP) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0062 × 0075 × 0067 × 0028 × 0073 × 0029 × 00A0 × 0020 × 0020 × 0020 × 0020 × 0020 ÷	#  × [0.3] LATIN SMALL LETTER B (AL) × [28.0] LATIN SMALL LETTER U (AL) × [28.0] LATIN SMALL LETTER G (AL) × [30.01] LEFT PARENTHESIS (OP_OP30) × [14.0] LATIN SMALL LETTER S (AL) × [13.02] RIGHT PARENTHESIS (CP_CP30) × [12.1] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) × [7.01] SPACE (SP) × [7.01] SPACE (SP) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 002E × 002E ÷ 307E ÷ 3059 × 3002 ÷ 0058 × 004D × 004C ÷ 306E × 002E × 002E ÷	#  × [0.3] FULL STOP (IS) × [13.02] FULL STOP (IS) ÷ [999.0] HIRAGANA LETTER MA (ID) ÷ [999.0] HIRAGANA LETTER SU (ID) × [13.02] IDEOGRAPHIC FULL STOP (CL) ÷ [999.0] LATIN CAPITAL LETTER X (AL) × [28.0] LATIN CAPITAL LETTER M (AL) × [28.0] LATIN CAPITAL LETTER L (AL) ÷ [999.0] HIRAGANA LETTER NO (ID) × [13.02] FULL STOP (IS) × [13.02] FULL STOP (IS) ÷ [0.3]');
    Test_LB('× 0061 × 0062 × 00AD ÷ 0062 × 0079 ÷	#  × [0.3] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER B (AL) × [21.01] SOFT HYPHEN (BA) ÷ [999.0] LATIN SMALL LETTER B (AL) × [28.0] LATIN SMALL LETTER Y (AL) ÷ [0.3]');
    Test_LB('× 002D × 0033 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [25.02] DIGIT THREE (NU) ÷ [0.3]');
    Test_LB('× 0065 × 002E × 0067 × 002E ÷	#  × [0.3] LATIN SMALL LETTER E (AL) × [13.02] FULL STOP (IS) × [29.0] LATIN SMALL LETTER G (AL) × [13.02] FULL STOP (IS) ÷ [0.3]');
    Test_LB('× 4E00 × 002E ÷ 4E00 × 002E ÷	#  × [0.3] CJK UNIFIED IDEOGRAPH-4E00 (ID) × [13.02] FULL STOP (IS) ÷ [999.0] CJK UNIFIED IDEOGRAPH-4E00 (ID) × [13.02] FULL STOP (IS) ÷ [0.3]');
    Test_LB('× 0061 × 0020 × 0020 ÷ 0062 ÷	#  × [0.3] LATIN SMALL LETTER A (AL) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [18.0] LATIN SMALL LETTER B (AL) ÷ [0.3]');
    Test_LB('× 0061 × 0020 × 0020 × 200B ÷ 0062 ÷	#  × [0.3] LATIN SMALL LETTER A (AL) × [7.01] SPACE (SP) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [8.0] LATIN SMALL LETTER B (AL) ÷ [0.3]');
    Test_LB('× 0061 × 0020 ÷ 0308 × 0062 ÷	#  × [0.3] LATIN SMALL LETTER A (AL) × [7.01] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [28.0] LATIN SMALL LETTER B (AL) ÷ [0.3]');
    Test_LB('× 0031 × 0308 × 0062 × 0028 × 0061 × 0029 × 002D ÷ 0028 × 0062 × 0029 ÷	#  × [0.3] DIGIT ONE (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [23.03] LATIN SMALL LETTER B (AL) × [30.01] LEFT PARENTHESIS (OP_OP30) × [14.0] LATIN SMALL LETTER A (AL) × [13.02] RIGHT PARENTHESIS (CP_CP30) × [21.02] HYPHEN-MINUS (HY) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) × [14.0] LATIN SMALL LETTER B (AL) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0067 × 0069 × 0076 × 0065 × 0020 ÷ 0062 × 006F × 006F × 006B × 0028 × 0073 × 0029 × 002E ÷	#  × [0.3] LATIN SMALL LETTER G (AL) × [28.0] LATIN SMALL LETTER I (AL) × [28.0] LATIN SMALL LETTER V (AL) × [28.0] LATIN SMALL LETTER E (AL) × [7.01] SPACE (SP) ÷ [18.0] LATIN SMALL LETTER B (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER K (AL) × [30.01] LEFT PARENTHESIS (OP_OP30) × [14.0] LATIN SMALL LETTER S (AL) × [13.02] RIGHT PARENTHESIS (CP_CP30) × [13.02] FULL STOP (IS) ÷ [0.3]');
    Test_LB('× 307E ÷ 0028 × 3059 × 0029 ÷	#  × [0.3] HIRAGANA LETTER MA (ID) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) × [14.0] HIRAGANA LETTER SU (ID) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0066 × 0069 × 006E × 0064 × 0020 × 002E × 0063 × 006F × 006D ÷	#  × [0.3] LATIN SMALL LETTER F (AL) × [28.0] LATIN SMALL LETTER I (AL) × [28.0] LATIN SMALL LETTER N (AL) × [28.0] LATIN SMALL LETTER D (AL) × [7.01] SPACE (SP) × [13.02] FULL STOP (IS) × [29.0] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER M (AL) ÷ [0.3]');
    Test_LB('× 0065 × 0071 × 0075 × 0061 × 006C × 0073 × 0020 × 002E ÷ 0033 × 0035 × 0020 ÷ 0063 × 0065 × 006E × 0074 × 0073 ÷	#  × [0.3] LATIN SMALL LETTER E (AL) × [28.0] LATIN SMALL LETTER Q (AL) × [28.0] LATIN SMALL LETTER U (AL) × [28.0] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER L (AL) × [28.0] LATIN SMALL LETTER S (AL) × [7.01] SPACE (SP) × [13.02] FULL STOP (IS) ÷ [999.0] DIGIT THREE (NU) × [25.03] DIGIT FIVE (NU) × [7.01] SPACE (SP) ÷ [18.0] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER E (AL) × [28.0] LATIN SMALL LETTER N (AL) × [28.0] LATIN SMALL LETTER T (AL) × [28.0] LATIN SMALL LETTER S (AL) ÷ [0.3]');
    Test_LB('× 0028 × 0073 × 0029 × 0068 × 0065 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [14.0] LATIN SMALL LETTER S (AL) × [13.02] RIGHT PARENTHESIS (CP_CP30) × [30.02] LATIN SMALL LETTER H (AL) × [28.0] LATIN SMALL LETTER E (AL) ÷ [0.3]');
    Test_LB('× 007B × 0073 × 007D ÷ 0068 × 0065 ÷	#  × [0.3] LEFT CURLY BRACKET (OP_OP30) × [14.0] LATIN SMALL LETTER S (AL) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [999.0] LATIN SMALL LETTER H (AL) × [28.0] LATIN SMALL LETTER E (AL) ÷ [0.3]');
    Test_LB('× 02C8 × 0073 × 0049 × 006C × 0259 × 0062 × 0028 × 0259 × 0029 × 006C ÷	#  × [0.3] MODIFIER LETTER VERTICAL LINE (BB) × [21.04] LATIN SMALL LETTER S (AL) × [28.0] LATIN CAPITAL LETTER I (AL) × [28.0] LATIN SMALL LETTER L (AL) × [28.0] LATIN SMALL LETTER SCHWA (AL) × [28.0] LATIN SMALL LETTER B (AL) × [30.01] LEFT PARENTHESIS (OP_OP30) × [14.0] LATIN SMALL LETTER SCHWA (AL) × [13.02] RIGHT PARENTHESIS (CP_CP30) × [30.02] LATIN SMALL LETTER L (AL) ÷ [0.3]');
    Test_LB('× 02C8 × 0073 × 0049 × 006C × 0259 × 0062 × 007B × 0259 × 007D ÷ 006C ÷	#  × [0.3] MODIFIER LETTER VERTICAL LINE (BB) × [21.04] LATIN SMALL LETTER S (AL) × [28.0] LATIN CAPITAL LETTER I (AL) × [28.0] LATIN SMALL LETTER L (AL) × [28.0] LATIN SMALL LETTER SCHWA (AL) × [28.0] LATIN SMALL LETTER B (AL) × [30.01] LEFT CURLY BRACKET (OP_OP30) × [14.0] LATIN SMALL LETTER SCHWA (AL) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [999.0] LATIN SMALL LETTER L (AL) ÷ [0.3]');
    Test_LB('× 0063 × 006F × 0064 × 0065 × 0028 × 0073 × 0029 × 002E ÷	#  × [0.3] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER D (AL) × [28.0] LATIN SMALL LETTER E (AL) × [30.01] LEFT PARENTHESIS (OP_OP30) × [14.0] LATIN SMALL LETTER S (AL) × [13.02] RIGHT PARENTHESIS (CP_CP30) × [13.02] FULL STOP (IS) ÷ [0.3]');
    Test_LB('× 0063 × 006F × 0064 × 0065 × 0028 × 0073 × 002E × 0029 ÷	#  × [0.3] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER D (AL) × [28.0] LATIN SMALL LETTER E (AL) × [30.01] LEFT PARENTHESIS (OP_OP30) × [14.0] LATIN SMALL LETTER S (AL) × [13.02] FULL STOP (IS) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0063 × 006F × 0064 × 0065 × 0028 × 0073 × 0029 × 0021 ÷	#  × [0.3] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER D (AL) × [28.0] LATIN SMALL LETTER E (AL) × [30.01] LEFT PARENTHESIS (OP_OP30) × [14.0] LATIN SMALL LETTER S (AL) × [13.02] RIGHT PARENTHESIS (CP_CP30) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0063 × 006F × 0064 × 0065 × 0028 × 0073 × 0021 × 0029 ÷	#  × [0.3] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER D (AL) × [28.0] LATIN SMALL LETTER E (AL) × [30.01] LEFT PARENTHESIS (OP_OP30) × [14.0] LATIN SMALL LETTER S (AL) × [13.01] EXCLAMATION MARK (EX) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0063 × 006F × 0064 × 0065 × 005C ÷ 0028 × 0073 × 005C × 0029 ÷	#  × [0.3] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER D (AL) × [28.0] LATIN SMALL LETTER E (AL) × [24.03] REVERSE SOLIDUS (PR) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) × [14.0] LATIN SMALL LETTER S (AL) × [24.03] REVERSE SOLIDUS (PR) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0063 × 006F × 0064 × 0065 × 0028 × 0020 × 0073 × 0020 × 0029 ÷	#  × [0.3] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER D (AL) × [28.0] LATIN SMALL LETTER E (AL) × [30.01] LEFT PARENTHESIS (OP_OP30) × [7.01] SPACE (SP) × [14.0] LATIN SMALL LETTER S (AL) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0063 × 006F × 0064 × 0065 × 007B × 0073 × 007D ÷	#  × [0.3] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER D (AL) × [28.0] LATIN SMALL LETTER E (AL) × [30.01] LEFT CURLY BRACKET (OP_OP30) × [14.0] LATIN SMALL LETTER S (AL) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0063 × 006F × 0064 × 0065 × 007B × 0073 × 007D × 002E ÷	#  × [0.3] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER D (AL) × [28.0] LATIN SMALL LETTER E (AL) × [30.01] LEFT CURLY BRACKET (OP_OP30) × [14.0] LATIN SMALL LETTER S (AL) × [13.02] RIGHT CURLY BRACKET (CL) × [13.02] FULL STOP (IS) ÷ [0.3]');
    Test_LB('× 0063 × 006F × 0064 × 0065 × 007B × 0073 × 007D × 0021 ÷	#  × [0.3] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER D (AL) × [28.0] LATIN SMALL LETTER E (AL) × [30.01] LEFT CURLY BRACKET (OP_OP30) × [14.0] LATIN SMALL LETTER S (AL) × [13.02] RIGHT CURLY BRACKET (CL) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0063 × 006F × 0064 × 0065 × 005C ÷ 007B × 0073 × 005C × 007D ÷	#  × [0.3] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER D (AL) × [28.0] LATIN SMALL LETTER E (AL) × [24.03] REVERSE SOLIDUS (PR) ÷ [999.0] LEFT CURLY BRACKET (OP_OP30) × [14.0] LATIN SMALL LETTER S (AL) × [24.03] REVERSE SOLIDUS (PR) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0063 × 006F × 0064 × 0065 × 007B × 0020 × 0073 × 0020 × 007D ÷	#  × [0.3] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER D (AL) × [28.0] LATIN SMALL LETTER E (AL) × [30.01] LEFT CURLY BRACKET (OP_OP30) × [7.01] SPACE (SP) × [14.0] LATIN SMALL LETTER S (AL) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0063 × 006F × 0064 × 0028 × 0065 × 0029 × 2026 ÷ 0028 × 0073 × 0029 ÷	#  × [0.3] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER D (AL) × [30.01] LEFT PARENTHESIS (OP_OP30) × [14.0] LATIN SMALL LETTER E (AL) × [13.02] RIGHT PARENTHESIS (CP_CP30) × [22.0] HORIZONTAL ELLIPSIS (IN) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) × [14.0] LATIN SMALL LETTER S (AL) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0028 × 0063 × 006F × 0064 × 0028 × 0065 × 0029 × 2026 × 0029 × 0073 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [14.0] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER D (AL) × [30.01] LEFT PARENTHESIS (OP_OP30) × [14.0] LATIN SMALL LETTER E (AL) × [13.02] RIGHT PARENTHESIS (CP_CP30) × [22.0] HORIZONTAL ELLIPSIS (IN) × [13.02] RIGHT PARENTHESIS (CP_CP30) × [30.02] LATIN SMALL LETTER S (AL) ÷ [0.3]');
    Test_LB('× 0063 × 006F × 0064 × 007B × 0065 × 007D × 2026 ÷ 007B × 0073 × 007D ÷	#  × [0.3] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER D (AL) × [30.01] LEFT CURLY BRACKET (OP_OP30) × [14.0] LATIN SMALL LETTER E (AL) × [13.02] RIGHT CURLY BRACKET (CL) × [22.0] HORIZONTAL ELLIPSIS (IN) ÷ [999.0] LEFT CURLY BRACKET (OP_OP30) × [14.0] LATIN SMALL LETTER S (AL) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 007B × 0063 × 006F × 0064 × 007B × 0065 × 007D × 2026 × 007D ÷ 0073 ÷	#  × [0.3] LEFT CURLY BRACKET (OP_OP30) × [14.0] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER D (AL) × [30.01] LEFT CURLY BRACKET (OP_OP30) × [14.0] LATIN SMALL LETTER E (AL) × [13.02] RIGHT CURLY BRACKET (CL) × [22.0] HORIZONTAL ELLIPSIS (IN) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [999.0] LATIN SMALL LETTER S (AL) ÷ [0.3]');
    Test_LB('× 0028 × 0063 × 006F × 006E × 002D × 0029 × 006C × 0061 × 006E × 0067 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [14.0] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER N (AL) × [21.02] HYPHEN-MINUS (HY) × [13.02] RIGHT PARENTHESIS (CP_CP30) × [30.02] LATIN SMALL LETTER L (AL) × [28.0] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER N (AL) × [28.0] LATIN SMALL LETTER G (AL) ÷ [0.3]');
    Test_LB('× 0028 × 0063 × 006F × 006E × 00AD × 0029 × 006C × 0061 × 006E × 0067 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [14.0] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER N (AL) × [21.01] SOFT HYPHEN (BA) × [13.02] RIGHT PARENTHESIS (CP_CP30) × [30.02] LATIN SMALL LETTER L (AL) × [28.0] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER N (AL) × [28.0] LATIN SMALL LETTER G (AL) ÷ [0.3]');
    Test_LB('× 0028 × 0063 × 006F × 006E × 2011 × 0029 × 006C × 0061 × 006E × 0067 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [14.0] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER N (AL) × [12.1] NON-BREAKING HYPHEN (GL) × [12.0] RIGHT PARENTHESIS (CP_CP30) × [30.02] LATIN SMALL LETTER L (AL) × [28.0] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER N (AL) × [28.0] LATIN SMALL LETTER G (AL) ÷ [0.3]');
    Test_LB('× 0028 × 0063 × 006F × 006E × 0029 × 002D ÷ 006C × 0061 × 006E × 0067 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [14.0] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER N (AL) × [13.02] RIGHT PARENTHESIS (CP_CP30) × [21.02] HYPHEN-MINUS (HY) ÷ [999.0] LATIN SMALL LETTER L (AL) × [28.0] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER N (AL) × [28.0] LATIN SMALL LETTER G (AL) ÷ [0.3]');
    Test_LB('× 0028 × 0063 × 006F × 006E × 0029 × 00AD ÷ 006C × 0061 × 006E × 0067 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [14.0] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER N (AL) × [13.02] RIGHT PARENTHESIS (CP_CP30) × [21.01] SOFT HYPHEN (BA) ÷ [999.0] LATIN SMALL LETTER L (AL) × [28.0] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER N (AL) × [28.0] LATIN SMALL LETTER G (AL) ÷ [0.3]');
    Test_LB('× 0028 × 0063 × 006F × 006E × 0029 × 2011 × 006C × 0061 × 006E × 0067 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [14.0] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER N (AL) × [13.02] RIGHT PARENTHESIS (CP_CP30) × [12.1] NON-BREAKING HYPHEN (GL) × [12.0] LATIN SMALL LETTER L (AL) × [28.0] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER N (AL) × [28.0] LATIN SMALL LETTER G (AL) ÷ [0.3]');
    Test_LB('× 007B × 0063 × 006F × 006E × 002D × 007D ÷ 006C × 0061 × 006E × 0067 ÷	#  × [0.3] LEFT CURLY BRACKET (OP_OP30) × [14.0] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER N (AL) × [21.02] HYPHEN-MINUS (HY) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [999.0] LATIN SMALL LETTER L (AL) × [28.0] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER N (AL) × [28.0] LATIN SMALL LETTER G (AL) ÷ [0.3]');
    Test_LB('× 007B × 0063 × 006F × 006E × 00AD × 007D ÷ 006C × 0061 × 006E × 0067 ÷	#  × [0.3] LEFT CURLY BRACKET (OP_OP30) × [14.0] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER N (AL) × [21.01] SOFT HYPHEN (BA) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [999.0] LATIN SMALL LETTER L (AL) × [28.0] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER N (AL) × [28.0] LATIN SMALL LETTER G (AL) ÷ [0.3]');
    Test_LB('× 007B × 0063 × 006F × 006E × 2011 × 007D ÷ 006C × 0061 × 006E × 0067 ÷	#  × [0.3] LEFT CURLY BRACKET (OP_OP30) × [14.0] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER N (AL) × [12.1] NON-BREAKING HYPHEN (GL) × [12.0] RIGHT CURLY BRACKET (CL) ÷ [999.0] LATIN SMALL LETTER L (AL) × [28.0] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER N (AL) × [28.0] LATIN SMALL LETTER G (AL) ÷ [0.3]');
    Test_LB('× 007B × 0063 × 006F × 006E × 007D × 002D ÷ 006C × 0061 × 006E × 0067 ÷	#  × [0.3] LEFT CURLY BRACKET (OP_OP30) × [14.0] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER N (AL) × [13.02] RIGHT CURLY BRACKET (CL) × [21.02] HYPHEN-MINUS (HY) ÷ [999.0] LATIN SMALL LETTER L (AL) × [28.0] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER N (AL) × [28.0] LATIN SMALL LETTER G (AL) ÷ [0.3]');
    Test_LB('× 007B × 0063 × 006F × 006E × 007D × 00AD ÷ 006C × 0061 × 006E × 0067 ÷	#  × [0.3] LEFT CURLY BRACKET (OP_OP30) × [14.0] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER N (AL) × [13.02] RIGHT CURLY BRACKET (CL) × [21.01] SOFT HYPHEN (BA) ÷ [999.0] LATIN SMALL LETTER L (AL) × [28.0] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER N (AL) × [28.0] LATIN SMALL LETTER G (AL) ÷ [0.3]');
    Test_LB('× 007B × 0063 × 006F × 006E × 007D × 2011 × 006C × 0061 × 006E × 0067 ÷	#  × [0.3] LEFT CURLY BRACKET (OP_OP30) × [14.0] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER N (AL) × [13.02] RIGHT CURLY BRACKET (CL) × [12.1] NON-BREAKING HYPHEN (GL) × [12.0] LATIN SMALL LETTER L (AL) × [28.0] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER N (AL) × [28.0] LATIN SMALL LETTER G (AL) ÷ [0.3]');
    Test_LB('× 0063 × 0072 × 0065 × 0301 × 0028 × 0065 × 0301 × 0029 ÷ 0028 × 0065 × 0029 ÷	#  × [0.3] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER R (AL) × [28.0] LATIN SMALL LETTER E (AL) × [9.0] COMBINING ACUTE ACCENT (CM1_CM) × [30.01] LEFT PARENTHESIS (OP_OP30) × [14.0] LATIN SMALL LETTER E (AL) × [9.0] COMBINING ACUTE ACCENT (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP_CP30) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) × [14.0] LATIN SMALL LETTER E (AL) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0063 × 0072 × 0065 × 0301 × 005B × 0065 × 0072 × 007C ÷ 0065 × 0301 × 0028 × 0065 × 0029 ÷ 0028 × 0073 × 0029 × 005D ÷	#  × [0.3] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER R (AL) × [28.0] LATIN SMALL LETTER E (AL) × [9.0] COMBINING ACUTE ACCENT (CM1_CM) × [30.01] LEFT SQUARE BRACKET (OP_OP30) × [14.0] LATIN SMALL LETTER E (AL) × [28.0] LATIN SMALL LETTER R (AL) × [21.01] VERTICAL LINE (BA) ÷ [999.0] LATIN SMALL LETTER E (AL) × [9.0] COMBINING ACUTE ACCENT (CM1_CM) × [30.01] LEFT PARENTHESIS (OP_OP30) × [14.0] LATIN SMALL LETTER E (AL) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) × [14.0] LATIN SMALL LETTER S (AL) × [13.02] RIGHT PARENTHESIS (CP_CP30) × [13.02] RIGHT SQUARE BRACKET (CP_CP30) ÷ [0.3]');
    Test_LB('× 0063 × 0072 × 0065 × 0301 × 007B × 0065 × 0072 × 007C ÷ 0065 × 0301 × 0028 × 0065 × 0029 ÷ 0028 × 0073 × 0029 × 007D ÷	#  × [0.3] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER R (AL) × [28.0] LATIN SMALL LETTER E (AL) × [9.0] COMBINING ACUTE ACCENT (CM1_CM) × [30.01] LEFT CURLY BRACKET (OP_OP30) × [14.0] LATIN SMALL LETTER E (AL) × [28.0] LATIN SMALL LETTER R (AL) × [21.01] VERTICAL LINE (BA) ÷ [999.0] LATIN SMALL LETTER E (AL) × [9.0] COMBINING ACUTE ACCENT (CM1_CM) × [30.01] LEFT PARENTHESIS (OP_OP30) × [14.0] LATIN SMALL LETTER E (AL) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) × [14.0] LATIN SMALL LETTER S (AL) × [13.02] RIGHT PARENTHESIS (CP_CP30) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0061 × 006D × 0062 × 0069 × 0067 × 0075 × 0028 × 0308 × 0029 ÷ 0028 × 0065 × 0308 × 0029 ÷	#  × [0.3] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER M (AL) × [28.0] LATIN SMALL LETTER B (AL) × [28.0] LATIN SMALL LETTER I (AL) × [28.0] LATIN SMALL LETTER G (AL) × [28.0] LATIN SMALL LETTER U (AL) × [30.01] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP_CP30) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) × [14.0] LATIN SMALL LETTER E (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0061 × 006D × 0062 × 0069 × 0067 × 0075 × 0028 × 00AB × 0308 × 00BB × 0029 ÷ 0028 × 0065 × 0308 × 0029 ÷	#  × [0.3] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER M (AL) × [28.0] LATIN SMALL LETTER B (AL) × [28.0] LATIN SMALL LETTER I (AL) × [28.0] LATIN SMALL LETTER G (AL) × [28.0] LATIN SMALL LETTER U (AL) × [30.01] LEFT PARENTHESIS (OP_OP30) × [14.0] LEFT-POINTING DOUBLE ANGLE QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] RIGHT-POINTING DOUBLE ANGLE QUOTATION MARK (QU) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) × [14.0] LATIN SMALL LETTER E (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0061 × 006D × 0062 × 0069 × 0067 × 0075 × 0028 × 00AB × 0020 ÷ 0308 × 0020 ÷ 00BB × 0029 ÷ 0028 × 0065 × 0308 × 0029 ÷	#  × [0.3] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER M (AL) × [28.0] LATIN SMALL LETTER B (AL) × [28.0] LATIN SMALL LETTER I (AL) × [28.0] LATIN SMALL LETTER G (AL) × [28.0] LATIN SMALL LETTER U (AL) × [30.01] LEFT PARENTHESIS (OP_OP30) × [14.0] LEFT-POINTING DOUBLE ANGLE QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] RIGHT-POINTING DOUBLE ANGLE QUOTATION MARK (QU) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) × [14.0] LATIN SMALL LETTER E (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0061 × 006D × 0062 × 0069 × 0067 × 0075 × 00AB × 0020 × 0028 × 0020 × 0308 × 0020 × 0029 × 0020 ÷ 00BB × 0028 × 0065 × 0308 × 0029 ÷	#  × [0.3] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER M (AL) × [28.0] LATIN SMALL LETTER B (AL) × [28.0] LATIN SMALL LETTER I (AL) × [28.0] LATIN SMALL LETTER G (AL) × [28.0] LATIN SMALL LETTER U (AL) × [19.01] LEFT-POINTING DOUBLE ANGLE QUOTATION MARK (QU) × [7.01] SPACE (SP) × [15.0] LEFT PARENTHESIS (OP_OP30) × [7.01] SPACE (SP) × [14.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) × [7.01] SPACE (SP) ÷ [18.0] RIGHT-POINTING DOUBLE ANGLE QUOTATION MARK (QU) × [15.0] LEFT PARENTHESIS (OP_OP30) × [14.0] LATIN SMALL LETTER E (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0061 × 006D × 0062 × 0069 × 0067 × 0075 × 00AB × 202F × 0028 × 0020 × 0308 × 0020 × 0029 × 202F × 00BB × 0028 × 0065 × 0308 × 0029 ÷	#  × [0.3] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER M (AL) × [28.0] LATIN SMALL LETTER B (AL) × [28.0] LATIN SMALL LETTER I (AL) × [28.0] LATIN SMALL LETTER G (AL) × [28.0] LATIN SMALL LETTER U (AL) × [19.01] LEFT-POINTING DOUBLE ANGLE QUOTATION MARK (QU) × [12.1] NARROW NO-BREAK SPACE (GL) × [12.0] LEFT PARENTHESIS (OP_OP30) × [7.01] SPACE (SP) × [14.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) × [12.1] NARROW NO-BREAK SPACE (GL) × [12.0] RIGHT-POINTING DOUBLE ANGLE QUOTATION MARK (QU) × [15.0] LEFT PARENTHESIS (OP_OP30) × [14.0] LATIN SMALL LETTER E (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0061 × 006D × 0062 × 0069 × 0067 × 0075 × 007B × 0308 × 007D ÷ 0028 × 0065 × 0308 × 0029 ÷	#  × [0.3] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER M (AL) × [28.0] LATIN SMALL LETTER B (AL) × [28.0] LATIN SMALL LETTER I (AL) × [28.0] LATIN SMALL LETTER G (AL) × [28.0] LATIN SMALL LETTER U (AL) × [30.01] LEFT CURLY BRACKET (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) × [14.0] LATIN SMALL LETTER E (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0061 × 006D × 0062 × 0069 × 0067 × 0075 × 007B × 00AB × 0308 × 00BB × 007D ÷ 0028 × 0065 × 0308 × 0029 ÷	#  × [0.3] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER M (AL) × [28.0] LATIN SMALL LETTER B (AL) × [28.0] LATIN SMALL LETTER I (AL) × [28.0] LATIN SMALL LETTER G (AL) × [28.0] LATIN SMALL LETTER U (AL) × [30.01] LEFT CURLY BRACKET (OP_OP30) × [14.0] LEFT-POINTING DOUBLE ANGLE QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] RIGHT-POINTING DOUBLE ANGLE QUOTATION MARK (QU) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) × [14.0] LATIN SMALL LETTER E (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0061 × 006D × 0062 × 0069 × 0067 × 0075 × 007B × 00AB × 0020 ÷ 0308 × 0020 ÷ 00BB × 007D ÷ 0028 × 0065 × 0308 × 0029 ÷	#  × [0.3] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER M (AL) × [28.0] LATIN SMALL LETTER B (AL) × [28.0] LATIN SMALL LETTER I (AL) × [28.0] LATIN SMALL LETTER G (AL) × [28.0] LATIN SMALL LETTER U (AL) × [30.01] LEFT CURLY BRACKET (OP_OP30) × [14.0] LEFT-POINTING DOUBLE ANGLE QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] RIGHT-POINTING DOUBLE ANGLE QUOTATION MARK (QU) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) × [14.0] LATIN SMALL LETTER E (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0061 × 006D × 0062 × 0069 × 0067 × 0075 × 00AB × 0020 × 007B × 0020 × 0308 × 0020 × 007D × 0020 ÷ 00BB × 0028 × 0065 × 0308 × 0029 ÷	#  × [0.3] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER M (AL) × [28.0] LATIN SMALL LETTER B (AL) × [28.0] LATIN SMALL LETTER I (AL) × [28.0] LATIN SMALL LETTER G (AL) × [28.0] LATIN SMALL LETTER U (AL) × [19.01] LEFT-POINTING DOUBLE ANGLE QUOTATION MARK (QU) × [7.01] SPACE (SP) × [15.0] LEFT CURLY BRACKET (OP_OP30) × [7.01] SPACE (SP) × [14.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) ÷ [18.0] RIGHT-POINTING DOUBLE ANGLE QUOTATION MARK (QU) × [15.0] LEFT PARENTHESIS (OP_OP30) × [14.0] LATIN SMALL LETTER E (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0061 × 006D × 0062 × 0069 × 0067 × 0075 × 00AB × 202F × 007B × 0020 × 0308 × 0020 × 007D × 202F × 00BB × 0028 × 0065 × 0308 × 0029 ÷	#  × [0.3] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER M (AL) × [28.0] LATIN SMALL LETTER B (AL) × [28.0] LATIN SMALL LETTER I (AL) × [28.0] LATIN SMALL LETTER G (AL) × [28.0] LATIN SMALL LETTER U (AL) × [19.01] LEFT-POINTING DOUBLE ANGLE QUOTATION MARK (QU) × [12.1] NARROW NO-BREAK SPACE (GL) × [12.0] LEFT CURLY BRACKET (OP_OP30) × [7.01] SPACE (SP) × [14.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) × [12.1] NARROW NO-BREAK SPACE (GL) × [12.0] RIGHT-POINTING DOUBLE ANGLE QUOTATION MARK (QU) × [15.0] LEFT PARENTHESIS (OP_OP30) × [14.0] LATIN SMALL LETTER E (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0028 × 0063 × 007A × 0065 × 0072 × 0077 × 006F × 006E × 006F × 00AD ÷ 2011 × 0029 × 006E × 0069 × 0065 × 0062 × 0069 × 0065 × 0073 × 006B × 0061 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [14.0] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER Z (AL) × [28.0] LATIN SMALL LETTER E (AL) × [28.0] LATIN SMALL LETTER R (AL) × [28.0] LATIN SMALL LETTER W (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER N (AL) × [28.0] LATIN SMALL LETTER O (AL) × [21.01] SOFT HYPHEN (BA) ÷ [999.0] NON-BREAKING HYPHEN (GL) × [12.0] RIGHT PARENTHESIS (CP_CP30) × [30.02] LATIN SMALL LETTER N (AL) × [28.0] LATIN SMALL LETTER I (AL) × [28.0] LATIN SMALL LETTER E (AL) × [28.0] LATIN SMALL LETTER B (AL) × [28.0] LATIN SMALL LETTER I (AL) × [28.0] LATIN SMALL LETTER E (AL) × [28.0] LATIN SMALL LETTER S (AL) × [28.0] LATIN SMALL LETTER K (AL) × [28.0] LATIN SMALL LETTER A (AL) ÷ [0.3]');
    Test_LB('× 0028 × 0063 × 007A × 0065 × 0072 × 0077 × 006F × 006E × 006F × 00AD × 0029 × 2011 × 006E × 0069 × 0065 × 0062 × 0069 × 0065 × 0073 × 006B × 0061 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [14.0] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER Z (AL) × [28.0] LATIN SMALL LETTER E (AL) × [28.0] LATIN SMALL LETTER R (AL) × [28.0] LATIN SMALL LETTER W (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER N (AL) × [28.0] LATIN SMALL LETTER O (AL) × [21.01] SOFT HYPHEN (BA) × [13.02] RIGHT PARENTHESIS (CP_CP30) × [12.1] NON-BREAKING HYPHEN (GL) × [12.0] LATIN SMALL LETTER N (AL) × [28.0] LATIN SMALL LETTER I (AL) × [28.0] LATIN SMALL LETTER E (AL) × [28.0] LATIN SMALL LETTER B (AL) × [28.0] LATIN SMALL LETTER I (AL) × [28.0] LATIN SMALL LETTER E (AL) × [28.0] LATIN SMALL LETTER S (AL) × [28.0] LATIN SMALL LETTER K (AL) × [28.0] LATIN SMALL LETTER A (AL) ÷ [0.3]');
    Test_LB('× 0028 × 0063 × 007A × 0065 × 0072 × 0077 × 006F × 006E × 006F × 0029 × 00AD ÷ 2011 × 006E × 0069 × 0065 × 0062 × 0069 × 0065 × 0073 × 006B × 0061 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [14.0] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER Z (AL) × [28.0] LATIN SMALL LETTER E (AL) × [28.0] LATIN SMALL LETTER R (AL) × [28.0] LATIN SMALL LETTER W (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER N (AL) × [28.0] LATIN SMALL LETTER O (AL) × [13.02] RIGHT PARENTHESIS (CP_CP30) × [21.01] SOFT HYPHEN (BA) ÷ [999.0] NON-BREAKING HYPHEN (GL) × [12.0] LATIN SMALL LETTER N (AL) × [28.0] LATIN SMALL LETTER I (AL) × [28.0] LATIN SMALL LETTER E (AL) × [28.0] LATIN SMALL LETTER B (AL) × [28.0] LATIN SMALL LETTER I (AL) × [28.0] LATIN SMALL LETTER E (AL) × [28.0] LATIN SMALL LETTER S (AL) × [28.0] LATIN SMALL LETTER K (AL) × [28.0] LATIN SMALL LETTER A (AL) ÷ [0.3]');
    Test_LB('× 007B × 0063 × 007A × 0065 × 0072 × 0077 × 006F × 006E × 006F × 00AD ÷ 2011 × 007D ÷ 006E × 0069 × 0065 × 0062 × 0069 × 0065 × 0073 × 006B × 0061 ÷	#  × [0.3] LEFT CURLY BRACKET (OP_OP30) × [14.0] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER Z (AL) × [28.0] LATIN SMALL LETTER E (AL) × [28.0] LATIN SMALL LETTER R (AL) × [28.0] LATIN SMALL LETTER W (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER N (AL) × [28.0] LATIN SMALL LETTER O (AL) × [21.01] SOFT HYPHEN (BA) ÷ [999.0] NON-BREAKING HYPHEN (GL) × [12.0] RIGHT CURLY BRACKET (CL) ÷ [999.0] LATIN SMALL LETTER N (AL) × [28.0] LATIN SMALL LETTER I (AL) × [28.0] LATIN SMALL LETTER E (AL) × [28.0] LATIN SMALL LETTER B (AL) × [28.0] LATIN SMALL LETTER I (AL) × [28.0] LATIN SMALL LETTER E (AL) × [28.0] LATIN SMALL LETTER S (AL) × [28.0] LATIN SMALL LETTER K (AL) × [28.0] LATIN SMALL LETTER A (AL) ÷ [0.3]');
    Test_LB('× 007B × 0063 × 007A × 0065 × 0072 × 0077 × 006F × 006E × 006F × 00AD × 007D × 2011 × 006E × 0069 × 0065 × 0062 × 0069 × 0065 × 0073 × 006B × 0061 ÷	#  × [0.3] LEFT CURLY BRACKET (OP_OP30) × [14.0] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER Z (AL) × [28.0] LATIN SMALL LETTER E (AL) × [28.0] LATIN SMALL LETTER R (AL) × [28.0] LATIN SMALL LETTER W (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER N (AL) × [28.0] LATIN SMALL LETTER O (AL) × [21.01] SOFT HYPHEN (BA) × [13.02] RIGHT CURLY BRACKET (CL) × [12.1] NON-BREAKING HYPHEN (GL) × [12.0] LATIN SMALL LETTER N (AL) × [28.0] LATIN SMALL LETTER I (AL) × [28.0] LATIN SMALL LETTER E (AL) × [28.0] LATIN SMALL LETTER B (AL) × [28.0] LATIN SMALL LETTER I (AL) × [28.0] LATIN SMALL LETTER E (AL) × [28.0] LATIN SMALL LETTER S (AL) × [28.0] LATIN SMALL LETTER K (AL) × [28.0] LATIN SMALL LETTER A (AL) ÷ [0.3]');
    Test_LB('× 007B × 0063 × 007A × 0065 × 0072 × 0077 × 006F × 006E × 006F × 007D × 00AD ÷ 2011 × 006E × 0069 × 0065 × 0062 × 0069 × 0065 × 0073 × 006B × 0061 ÷	#  × [0.3] LEFT CURLY BRACKET (OP_OP30) × [14.0] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER Z (AL) × [28.0] LATIN SMALL LETTER E (AL) × [28.0] LATIN SMALL LETTER R (AL) × [28.0] LATIN SMALL LETTER W (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER N (AL) × [28.0] LATIN SMALL LETTER O (AL) × [13.02] RIGHT CURLY BRACKET (CL) × [21.01] SOFT HYPHEN (BA) ÷ [999.0] NON-BREAKING HYPHEN (GL) × [12.0] LATIN SMALL LETTER N (AL) × [28.0] LATIN SMALL LETTER I (AL) × [28.0] LATIN SMALL LETTER E (AL) × [28.0] LATIN SMALL LETTER B (AL) × [28.0] LATIN SMALL LETTER I (AL) × [28.0] LATIN SMALL LETTER E (AL) × [28.0] LATIN SMALL LETTER S (AL) × [28.0] LATIN SMALL LETTER K (AL) × [28.0] LATIN SMALL LETTER A (AL) ÷ [0.3]');
    Test_LB('× 006F × 0070 × 0065 × 0072 × 0061 × 0074 × 006F × 0072 × 005B × 005D ÷ 0028 × 0030 × 0029 × 003B ÷	#  × [0.3] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER P (AL) × [28.0] LATIN SMALL LETTER E (AL) × [28.0] LATIN SMALL LETTER R (AL) × [28.0] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER T (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER R (AL) × [30.01] LEFT SQUARE BRACKET (OP_OP30) × [13.02] RIGHT SQUARE BRACKET (CP_CP30) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) × [14.0] DIGIT ZERO (NU) × [25.04] RIGHT PARENTHESIS (CP_CP30) × [13.02] SEMICOLON (IS) ÷ [0.3]');
    Test_LB('× 006F × 0070 × 0065 × 0072 × 0061 × 0074 × 006F × 0072 × 005B × 005D ÷ 0028 × 0029 ÷ 007B × 007D ÷	#  × [0.3] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER P (AL) × [28.0] LATIN SMALL LETTER E (AL) × [28.0] LATIN SMALL LETTER R (AL) × [28.0] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER T (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER R (AL) × [30.01] LEFT SQUARE BRACKET (OP_OP30) × [13.02] RIGHT SQUARE BRACKET (CP_CP30) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [999.0] LEFT CURLY BRACKET (OP_OP30) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 672C ÷ 0028 × 3092 × 0029 ÷ 8AAD ÷ 3080 ÷	#  × [0.3] CJK UNIFIED IDEOGRAPH-672C (ID) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) × [14.0] HIRAGANA LETTER WO (ID) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [999.0] CJK UNIFIED IDEOGRAPH-8AAD (ID) ÷ [999.0] HIRAGANA LETTER MU (ID) ÷ [0.3]');
    Test_LB('× 672C ÷ 0028 × 300C × 3092 × 300D × 0029 ÷ 8AAD ÷ 3080 ÷	#  × [0.3] CJK UNIFIED IDEOGRAPH-672C (ID) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) × [14.0] LEFT CORNER BRACKET (OP) × [14.0] HIRAGANA LETTER WO (ID) × [13.02] RIGHT CORNER BRACKET (CL) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [999.0] CJK UNIFIED IDEOGRAPH-8AAD (ID) ÷ [999.0] HIRAGANA LETTER MU (ID) ÷ [0.3]');
    Test_LB('× 672C ÷ 300C × 0028 × 3092 × 0029 × 300D ÷ 8AAD ÷ 3080 ÷	#  × [0.3] CJK UNIFIED IDEOGRAPH-672C (ID) ÷ [999.0] LEFT CORNER BRACKET (OP) × [14.0] LEFT PARENTHESIS (OP_OP30) × [14.0] HIRAGANA LETTER WO (ID) × [13.02] RIGHT PARENTHESIS (CP_CP30) × [13.02] RIGHT CORNER BRACKET (CL) ÷ [999.0] CJK UNIFIED IDEOGRAPH-8AAD (ID) ÷ [999.0] HIRAGANA LETTER MU (ID) ÷ [0.3]');
    Test_LB('× 672C ÷ 007B × 3092 × 007D ÷ 8AAD ÷ 3080 ÷	#  × [0.3] CJK UNIFIED IDEOGRAPH-672C (ID) ÷ [999.0] LEFT CURLY BRACKET (OP_OP30) × [14.0] HIRAGANA LETTER WO (ID) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [999.0] CJK UNIFIED IDEOGRAPH-8AAD (ID) ÷ [999.0] HIRAGANA LETTER MU (ID) ÷ [0.3]');
    Test_LB('× 672C ÷ 007B × 300C × 3092 × 300D × 007D ÷ 8AAD ÷ 3080 ÷	#  × [0.3] CJK UNIFIED IDEOGRAPH-672C (ID) ÷ [999.0] LEFT CURLY BRACKET (OP_OP30) × [14.0] LEFT CORNER BRACKET (OP) × [14.0] HIRAGANA LETTER WO (ID) × [13.02] RIGHT CORNER BRACKET (CL) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [999.0] CJK UNIFIED IDEOGRAPH-8AAD (ID) ÷ [999.0] HIRAGANA LETTER MU (ID) ÷ [0.3]');
    Test_LB('× 672C ÷ 005B × 0028 × 3092 × 0029 × 005D ÷ 8AAD ÷ 3080 ÷	#  × [0.3] CJK UNIFIED IDEOGRAPH-672C (ID) ÷ [999.0] LEFT SQUARE BRACKET (OP_OP30) × [14.0] LEFT PARENTHESIS (OP_OP30) × [14.0] HIRAGANA LETTER WO (ID) × [13.02] RIGHT PARENTHESIS (CP_CP30) × [13.02] RIGHT SQUARE BRACKET (CP_CP30) ÷ [999.0] CJK UNIFIED IDEOGRAPH-8AAD (ID) ÷ [999.0] HIRAGANA LETTER MU (ID) ÷ [0.3]');
    Test_LB('× 0028 × 30CB × 30E5 × 30FC × 30FB × 0029 ÷ 30E8 × 30FC ÷ 30AF ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [14.0] KATAKANA LETTER NI (ID) × [21.03] KATAKANA LETTER SMALL YU (CJ_NS) × [21.03] KATAKANA-HIRAGANA PROLONGED SOUND MARK (CJ_NS) × [21.03] KATAKANA MIDDLE DOT (NS) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [999.0] KATAKANA LETTER YO (ID) × [21.03] KATAKANA-HIRAGANA PROLONGED SOUND MARK (CJ_NS) ÷ [999.0] KATAKANA LETTER KU (ID) ÷ [0.3]');
    Test_LB('× 0028 × 30CB × 30E5 × 30FC × 0029 × 30FB ÷ 30E8 × 30FC ÷ 30AF ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [14.0] KATAKANA LETTER NI (ID) × [21.03] KATAKANA LETTER SMALL YU (CJ_NS) × [21.03] KATAKANA-HIRAGANA PROLONGED SOUND MARK (CJ_NS) × [13.02] RIGHT PARENTHESIS (CP_CP30) × [16.0] KATAKANA MIDDLE DOT (NS) ÷ [999.0] KATAKANA LETTER YO (ID) × [21.03] KATAKANA-HIRAGANA PROLONGED SOUND MARK (CJ_NS) ÷ [999.0] KATAKANA LETTER KU (ID) ÷ [0.3]');
    Test_LB('× 007B × 30CB × 30E5 × 30FC × 30FB × 007D ÷ 30E8 × 30FC ÷ 30AF ÷	#  × [0.3] LEFT CURLY BRACKET (OP_OP30) × [14.0] KATAKANA LETTER NI (ID) × [21.03] KATAKANA LETTER SMALL YU (CJ_NS) × [21.03] KATAKANA-HIRAGANA PROLONGED SOUND MARK (CJ_NS) × [21.03] KATAKANA MIDDLE DOT (NS) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [999.0] KATAKANA LETTER YO (ID) × [21.03] KATAKANA-HIRAGANA PROLONGED SOUND MARK (CJ_NS) ÷ [999.0] KATAKANA LETTER KU (ID) ÷ [0.3]');
    Test_LB('× 007B × 30CB × 30E5 × 30FC × 007D × 30FB ÷ 30E8 × 30FC ÷ 30AF ÷	#  × [0.3] LEFT CURLY BRACKET (OP_OP30) × [14.0] KATAKANA LETTER NI (ID) × [21.03] KATAKANA LETTER SMALL YU (CJ_NS) × [21.03] KATAKANA-HIRAGANA PROLONGED SOUND MARK (CJ_NS) × [13.02] RIGHT CURLY BRACKET (CL) × [16.0] KATAKANA MIDDLE DOT (NS) ÷ [999.0] KATAKANA LETTER YO (ID) × [21.03] KATAKANA-HIRAGANA PROLONGED SOUND MARK (CJ_NS) ÷ [999.0] KATAKANA LETTER KU (ID) ÷ [0.3]');
    Test_LB('× 0028 × 1850 × 1846 × 1851 × 1846 ÷ 1806 × 0029 × 182A × 1822 × 1834 × 1822 × 182D × 180C ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [14.0] MONGOLIAN LETTER TODO TA (AL) × [28.0] MONGOLIAN LETTER TODO O (AL) × [28.0] MONGOLIAN LETTER TODO DA (AL) × [28.0] MONGOLIAN LETTER TODO O (AL) ÷ [999.0] MONGOLIAN TODO SOFT HYPHEN (BB) × [13.02] RIGHT PARENTHESIS (CP_CP30) × [30.02] MONGOLIAN LETTER BA (AL) × [28.0] MONGOLIAN LETTER I (AL) × [28.0] MONGOLIAN LETTER CHA (AL) × [28.0] MONGOLIAN LETTER I (AL) × [28.0] MONGOLIAN LETTER GA (AL) × [9.0] MONGOLIAN FREE VARIATION SELECTOR TWO (CM1_CM) ÷ [0.3]');
    Test_LB('× 0028 × 1850 × 1846 × 1851 × 1846 × 0029 ÷ 1806 × 182A × 1822 × 1834 × 1822 × 182D × 180C ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [14.0] MONGOLIAN LETTER TODO TA (AL) × [28.0] MONGOLIAN LETTER TODO O (AL) × [28.0] MONGOLIAN LETTER TODO DA (AL) × [28.0] MONGOLIAN LETTER TODO O (AL) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [999.0] MONGOLIAN TODO SOFT HYPHEN (BB) × [21.04] MONGOLIAN LETTER BA (AL) × [28.0] MONGOLIAN LETTER I (AL) × [28.0] MONGOLIAN LETTER CHA (AL) × [28.0] MONGOLIAN LETTER I (AL) × [28.0] MONGOLIAN LETTER GA (AL) × [9.0] MONGOLIAN FREE VARIATION SELECTOR TWO (CM1_CM) ÷ [0.3]');
    Test_LB('× 007B × 1850 × 1846 × 1851 × 1846 ÷ 1806 × 007D ÷ 182A × 1822 × 1834 × 1822 × 182D × 180C ÷	#  × [0.3] LEFT CURLY BRACKET (OP_OP30) × [14.0] MONGOLIAN LETTER TODO TA (AL) × [28.0] MONGOLIAN LETTER TODO O (AL) × [28.0] MONGOLIAN LETTER TODO DA (AL) × [28.0] MONGOLIAN LETTER TODO O (AL) ÷ [999.0] MONGOLIAN TODO SOFT HYPHEN (BB) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [999.0] MONGOLIAN LETTER BA (AL) × [28.0] MONGOLIAN LETTER I (AL) × [28.0] MONGOLIAN LETTER CHA (AL) × [28.0] MONGOLIAN LETTER I (AL) × [28.0] MONGOLIAN LETTER GA (AL) × [9.0] MONGOLIAN FREE VARIATION SELECTOR TWO (CM1_CM) ÷ [0.3]');
    Test_LB('× 007B × 1850 × 1846 × 1851 × 1846 × 007D ÷ 1806 × 182A × 1822 × 1834 × 1822 × 182D × 180C ÷	#  × [0.3] LEFT CURLY BRACKET (OP_OP30) × [14.0] MONGOLIAN LETTER TODO TA (AL) × [28.0] MONGOLIAN LETTER TODO O (AL) × [28.0] MONGOLIAN LETTER TODO DA (AL) × [28.0] MONGOLIAN LETTER TODO O (AL) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [999.0] MONGOLIAN TODO SOFT HYPHEN (BB) × [21.04] MONGOLIAN LETTER BA (AL) × [28.0] MONGOLIAN LETTER I (AL) × [28.0] MONGOLIAN LETTER CHA (AL) × [28.0] MONGOLIAN LETTER I (AL) × [28.0] MONGOLIAN LETTER GA (AL) × [9.0] MONGOLIAN FREE VARIATION SELECTOR TWO (CM1_CM) ÷ [0.3]');
    Test_LB('× 0028 × 0068 × 0074 × 0074 × 0070 × 003A × 002F × 002F × 0029 × 0078 × 006E × 002D × 002D ÷ 0061 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [14.0] LATIN SMALL LETTER H (AL) × [28.0] LATIN SMALL LETTER T (AL) × [28.0] LATIN SMALL LETTER T (AL) × [28.0] LATIN SMALL LETTER P (AL) × [13.02] COLON (IS) × [13.02] SOLIDUS (SY) × [13.02] SOLIDUS (SY) × [13.02] RIGHT PARENTHESIS (CP_CP30) × [30.02] LATIN SMALL LETTER X (AL) × [28.0] LATIN SMALL LETTER N (AL) × [21.02] HYPHEN-MINUS (HY) × [21.02] HYPHEN-MINUS (HY) ÷ [999.0] LATIN SMALL LETTER A (AL) ÷ [0.3]');
    Test_LB('× 007B × 0068 × 0074 × 0074 × 0070 × 003A × 002F × 002F × 007D ÷ 0078 × 006E × 002D × 002D ÷ 0061 ÷	#  × [0.3] LEFT CURLY BRACKET (OP_OP30) × [14.0] LATIN SMALL LETTER H (AL) × [28.0] LATIN SMALL LETTER T (AL) × [28.0] LATIN SMALL LETTER T (AL) × [28.0] LATIN SMALL LETTER P (AL) × [13.02] COLON (IS) × [13.02] SOLIDUS (SY) × [13.02] SOLIDUS (SY) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [999.0] LATIN SMALL LETTER X (AL) × [28.0] LATIN SMALL LETTER N (AL) × [21.02] HYPHEN-MINUS (HY) × [21.02] HYPHEN-MINUS (HY) ÷ [999.0] LATIN SMALL LETTER A (AL) ÷ [0.3]');
    Test_LB('× 0028 × 0030 × 002C × 0031 × 0029 × 002B × 0028 × 0032 × 002C × 0033 × 0029 × 2295 × 0028 × 2212 × 0034 × 002C × 0035 × 0029 × 2296 × 0028 × 0036 × 002C × 0037 × 0029 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [14.0] DIGIT ZERO (NU) × [25.03] COMMA (IS) × [25.04] DIGIT ONE (NU) × [25.04] RIGHT PARENTHESIS (CP_CP30) × [25.05] PLUS SIGN (PR) × [25.01] LEFT PARENTHESIS (OP_OP30) × [14.0] DIGIT TWO (NU) × [25.03] COMMA (IS) × [25.04] DIGIT THREE (NU) × [25.04] RIGHT PARENTHESIS (CP_CP30) × [30.02] CIRCLED PLUS (AI_AL) × [30.01] LEFT PARENTHESIS (OP_OP30) × [14.0] MINUS SIGN (PR) × [25.01] DIGIT FOUR (NU) × [25.03] COMMA (IS) × [25.04] DIGIT FIVE (NU) × [25.04] RIGHT PARENTHESIS (CP_CP30) × [30.02] CIRCLED MINUS (AL) × [30.01] LEFT PARENTHESIS (OP_OP30) × [14.0] DIGIT SIX (NU) × [25.03] COMMA (IS) × [25.04] DIGIT SEVEN (NU) × [25.04] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 007B × 0030 × 002C × 0031 × 007D × 002B × 007B × 0032 × 002C × 0033 × 007D ÷ 2295 × 007B × 2212 × 0034 × 002C × 0035 × 007D ÷ 2296 × 007B × 0036 × 002C × 0037 × 007D ÷	#  × [0.3] LEFT CURLY BRACKET (OP_OP30) × [14.0] DIGIT ZERO (NU) × [25.03] COMMA (IS) × [25.04] DIGIT ONE (NU) × [25.04] RIGHT CURLY BRACKET (CL) × [25.05] PLUS SIGN (PR) × [25.01] LEFT CURLY BRACKET (OP_OP30) × [14.0] DIGIT TWO (NU) × [25.03] COMMA (IS) × [25.04] DIGIT THREE (NU) × [25.04] RIGHT CURLY BRACKET (CL) ÷ [999.0] CIRCLED PLUS (AI_AL) × [30.01] LEFT CURLY BRACKET (OP_OP30) × [14.0] MINUS SIGN (PR) × [25.01] DIGIT FOUR (NU) × [25.03] COMMA (IS) × [25.04] DIGIT FIVE (NU) × [25.04] RIGHT CURLY BRACKET (CL) ÷ [999.0] CIRCLED MINUS (AL) × [30.01] LEFT CURLY BRACKET (OP_OP30) × [14.0] DIGIT SIX (NU) × [25.03] COMMA (IS) × [25.04] DIGIT SEVEN (NU) × [25.04] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0061 × 0062 ÷	#  × [0.3] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER B (AL) ÷ [0.3]');
    Test_LB('× 0061 × 0062 × 0020 ÷	#  × [0.3] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER B (AL) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0061 × 0062 × 0020 ÷ 0063 ÷	#  × [0.3] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER B (AL) × [7.01] SPACE (SP) ÷ [18.0] LATIN SMALL LETTER C (AL) ÷ [0.3]');
    Test_LB('× 0061 ÷ 307E ÷	#  × [0.3] LATIN SMALL LETTER A (AL) ÷ [999.0] HIRAGANA LETTER MA (ID) ÷ [0.3]');
    Test_LB('× 0939 × 093F × 0928 × 094D × 0926 × 0940 × 0020 ÷	#  × [0.3] DEVANAGARI LETTER HA (AL) × [9.0] DEVANAGARI VOWEL SIGN I (CM1_CM) × [28.0] DEVANAGARI LETTER NA (AL) × [9.0] DEVANAGARI SIGN VIRAMA (CM1_CM) × [28.0] DEVANAGARI LETTER DA (AL) × [9.0] DEVANAGARI VOWEL SIGN II (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 092F × 0938 × 0917 × 0941 × 091A × 093F × 0924 × 0940 × 092F × 0938 × 093E × 0020 ÷	#  × [0.3] DEVANAGARI LETTER YA (AL) × [28.0] DEVANAGARI LETTER SA (AL) × [28.0] DEVANAGARI LETTER GA (AL) × [9.0] DEVANAGARI VOWEL SIGN U (CM1_CM) × [28.0] DEVANAGARI LETTER CA (AL) × [9.0] DEVANAGARI VOWEL SIGN I (CM1_CM) × [28.0] DEVANAGARI LETTER TA (AL) × [9.0] DEVANAGARI VOWEL SIGN II (CM1_CM) × [28.0] DEVANAGARI LETTER YA (AL) × [28.0] DEVANAGARI LETTER SA (AL) × [9.0] DEVANAGARI VOWEL SIGN AA (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 5370 ÷ 672C ÷	#  × [0.3] CJK UNIFIED IDEOGRAPH-5370 (ID) ÷ [999.0] CJK UNIFIED IDEOGRAPH-672C (ID) ÷ [0.3]');
    Test_LB('× 8AAD ÷ 3080 ÷	#  × [0.3] CJK UNIFIED IDEOGRAPH-8AAD (ID) ÷ [999.0] HIRAGANA LETTER MU (ID) ÷ [0.3]');
    Test_LB('× 5165 ÷ 529B ÷ 3057 ÷ 30A8 ÷	#  × [0.3] CJK UNIFIED IDEOGRAPH-5165 (ID) ÷ [999.0] CJK UNIFIED IDEOGRAPH-529B (ID) ÷ [999.0] HIRAGANA LETTER SI (ID) ÷ [999.0] KATAKANA LETTER E (ID) ÷ [0.3]');
    Test_LB('× 4F4D × 3002 ÷ 8A18 ÷	#  × [0.3] CJK UNIFIED IDEOGRAPH-4F4D (ID) × [13.02] IDEOGRAPHIC FULL STOP (CL) ÷ [999.0] CJK UNIFIED IDEOGRAPH-8A18 (ID) ÷ [0.3]');
    Test_LB('× 672C × 3002 ÷	#  × [0.3] CJK UNIFIED IDEOGRAPH-672C (ID) × [13.02] IDEOGRAPHIC FULL STOP (CL) ÷ [0.3]');
    Test_LB('× 967A × 300D ÷ 306E ÷	#  × [0.3] CJK UNIFIED IDEOGRAPH-967A (ID) × [13.02] RIGHT CORNER BRACKET (CL) ÷ [999.0] HIRAGANA LETTER NO (ID) ÷ [0.3]');
    Test_LB('× 3057 × 3087 ÷ 3046 ÷	#  × [0.3] HIRAGANA LETTER SI (ID) × [21.03] HIRAGANA LETTER SMALL YO (CJ_NS) ÷ [999.0] HIRAGANA LETTER U (ID) ÷ [0.3]');
    Test_LB('× 307E ÷ 0061 ÷ 672C ÷	#  × [0.3] HIRAGANA LETTER MA (ID) ÷ [999.0] LATIN SMALL LETTER A (AL) ÷ [999.0] CJK UNIFIED IDEOGRAPH-672C (ID) ÷ [0.3]');
    Test_LB('× C5C6 ÷ C5B4 ÷ C694 × 0020 ÷ 006F × 0072 × 0020 ÷ BABB ÷	#  × [0.3] HANGUL SYLLABLE EOBS (H3) ÷ [999.0] HANGUL SYLLABLE EO (H2) ÷ [999.0] HANGUL SYLLABLE YO (H2) × [7.01] SPACE (SP) ÷ [18.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER R (AL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE MOS (H3) ÷ [0.3]');
    Test_LB('× 307E ÷ 0061 × 0062 × 0020 ÷	#  × [0.3] HIRAGANA LETTER MA (ID) ÷ [999.0] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER B (AL) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 3067 ÷ 4F7F ÷	#  × [0.3] HIRAGANA LETTER DE (ID) ÷ [999.0] CJK UNIFIED IDEOGRAPH-4F7F (ID) ÷ [0.3]');
    Test_LB('× 3059 ÷ 308B ÷	#  × [0.3] HIRAGANA LETTER SU (ID) ÷ [999.0] HIRAGANA LETTER RU (ID) ÷ [0.3]');
    Test_LB('× 306E ÷ 30D1 ÷ 30F3 ÷	#  × [0.3] HIRAGANA LETTER NO (ID) ÷ [999.0] KATAKANA LETTER PA (ID) ÷ [999.0] KATAKANA LETTER N (ID) ÷ [0.3]');
    Test_LB('× 3046 × 3000 ÷ 3048 × 3000 ÷ 304A × 300D ÷	#  × [0.3] HIRAGANA LETTER U (ID) × [21.01] IDEOGRAPHIC SPACE (BA) ÷ [999.0] HIRAGANA LETTER E (ID) × [21.01] IDEOGRAPHIC SPACE (BA) ÷ [999.0] HIRAGANA LETTER O (ID) × [13.02] RIGHT CORNER BRACKET (CL) ÷ [0.3]');
    Test_LB('× 308B × 0020 ÷ C740 ÷ C601 × 0020 ÷ 306B ÷	#  × [0.3] HIRAGANA LETTER RU (ID) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE EUN (H3) ÷ [999.0] HANGUL SYLLABLE YEONG (H3) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER NI (ID) ÷ [0.3]');
    Test_LB('× 3057 × 3087 ÷ 3046 × 3002 ÷	#  × [0.3] HIRAGANA LETTER SI (ID) × [21.03] HIRAGANA LETTER SMALL YO (CJ_NS) ÷ [999.0] HIRAGANA LETTER U (ID) × [13.02] IDEOGRAPHIC FULL STOP (CL) ÷ [0.3]');
    Test_LB('× 30E0 ÷ 306E ÷ 4E00 ÷	#  × [0.3] KATAKANA LETTER MU (ID) ÷ [999.0] HIRAGANA LETTER NO (ID) ÷ [999.0] CJK UNIFIED IDEOGRAPH-4E00 (ID) ÷ [0.3]');
    Test_LB('× 30D5 ÷ 30EA ÷	#  × [0.3] KATAKANA LETTER HU (ID) ÷ [999.0] KATAKANA LETTER RI (ID) ÷ [0.3]');
    Test_LB('× 30D5 ÷ 30EA × 30FC ÷ 767E ÷	#  × [0.3] KATAKANA LETTER HU (ID) ÷ [999.0] KATAKANA LETTER RI (ID) × [21.03] KATAKANA-HIRAGANA PROLONGED SOUND MARK (CJ_NS) ÷ [999.0] CJK UNIFIED IDEOGRAPH-767E (ID) ÷ [0.3]');
    Test_LB('× 30D4 × 30E5 × 30FC ÷ 30BF ÷ 3067 ÷ 4F7F ÷ 7528 ÷ 3059 ÷ 308B ÷	#  × [0.3] KATAKANA LETTER PI (ID) × [21.03] KATAKANA LETTER SMALL YU (CJ_NS) × [21.03] KATAKANA-HIRAGANA PROLONGED SOUND MARK (CJ_NS) ÷ [999.0] KATAKANA LETTER TA (ID) ÷ [999.0] HIRAGANA LETTER DE (ID) ÷ [999.0] CJK UNIFIED IDEOGRAPH-4F7F (ID) ÷ [999.0] CJK UNIFIED IDEOGRAPH-7528 (ID) ÷ [999.0] HIRAGANA LETTER SU (ID) ÷ [999.0] HIRAGANA LETTER RU (ID) ÷ [0.3]');
    Test_LB('× 30BF × 30FC ÷ 30AD × 30FC ÷ 3092 ÷ 62BC ÷	#  × [0.3] KATAKANA LETTER TA (ID) × [21.03] KATAKANA-HIRAGANA PROLONGED SOUND MARK (CJ_NS) ÷ [999.0] KATAKANA LETTER KI (ID) × [21.03] KATAKANA-HIRAGANA PROLONGED SOUND MARK (CJ_NS) ÷ [999.0] HIRAGANA LETTER WO (ID) ÷ [999.0] CJK UNIFIED IDEOGRAPH-62BC (ID) ÷ [0.3]');
    Test_LB('× 30B7 × 30E7 ÷ 30F3 ÷	#  × [0.3] KATAKANA LETTER SI (ID) × [21.03] KATAKANA LETTER SMALL YO (CJ_NS) ÷ [999.0] KATAKANA LETTER N (ID) ÷ [0.3]');
    Test_LB('× 0061 × 002E ÷ 0032 × 0020 ÷	#  × [0.3] LATIN SMALL LETTER A (AL) × [13.02] FULL STOP (IS) ÷ [999.0] DIGIT TWO (NU) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0061 × 002E ÷ 0032 × 0020 ÷ 0915 ÷	#  × [0.3] LATIN SMALL LETTER A (AL) × [13.02] FULL STOP (IS) ÷ [999.0] DIGIT TWO (NU) × [7.01] SPACE (SP) ÷ [18.0] DEVANAGARI LETTER KA (AL) ÷ [0.3]');
    Test_LB('× 0061 × 002E ÷ 0032 × 0020 ÷ 672C ÷	#  × [0.3] LATIN SMALL LETTER A (AL) × [13.02] FULL STOP (IS) ÷ [999.0] DIGIT TWO (NU) × [7.01] SPACE (SP) ÷ [18.0] CJK UNIFIED IDEOGRAPH-672C (ID) ÷ [0.3]');
    Test_LB('× 0061 × 002E ÷ 0032 × 3000 ÷ 672C ÷	#  × [0.3] LATIN SMALL LETTER A (AL) × [13.02] FULL STOP (IS) ÷ [999.0] DIGIT TWO (NU) × [21.01] IDEOGRAPHIC SPACE (BA) ÷ [999.0] CJK UNIFIED IDEOGRAPH-672C (ID) ÷ [0.3]');
    Test_LB('× 0061 × 002E ÷ 0032 × 3000 ÷ 307E ÷	#  × [0.3] LATIN SMALL LETTER A (AL) × [13.02] FULL STOP (IS) ÷ [999.0] DIGIT TWO (NU) × [21.01] IDEOGRAPHIC SPACE (BA) ÷ [999.0] HIRAGANA LETTER MA (ID) ÷ [0.3]');
    Test_LB('× 0061 × 002E ÷ 0032 × 3000 ÷ 0033 ÷	#  × [0.3] LATIN SMALL LETTER A (AL) × [13.02] FULL STOP (IS) ÷ [999.0] DIGIT TWO (NU) × [21.01] IDEOGRAPHIC SPACE (BA) ÷ [999.0] DIGIT THREE (NU) ÷ [0.3]');
    Test_LB('× 0061 × 0062 × 002E × 0020 ÷ 0032 ÷	#  × [0.3] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER B (AL) × [13.02] FULL STOP (IS) × [7.01] SPACE (SP) ÷ [18.0] DIGIT TWO (NU) ÷ [0.3]');
    Test_LB('× 0041 × 002E ÷ 0031 × 0020 ÷ BABB ÷	#  × [0.3] LATIN CAPITAL LETTER A (AL) × [13.02] FULL STOP (IS) ÷ [999.0] DIGIT ONE (NU) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE MOS (H3) ÷ [0.3]');
    Test_LB('× BD24 ÷ C5B4 × 002E × 0020 ÷ 0041 × 002E ÷ 0032 × 0020 ÷ BCFC ÷	#  × [0.3] HANGUL SYLLABLE BWASS (H3) ÷ [999.0] HANGUL SYLLABLE EO (H2) × [13.02] FULL STOP (IS) × [7.01] SPACE (SP) ÷ [18.0] LATIN CAPITAL LETTER A (AL) × [13.02] FULL STOP (IS) ÷ [999.0] DIGIT TWO (NU) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE BOL (H3) ÷ [0.3]');
    Test_LB('× BD10 ÷ C694 × 002E × 0020 ÷ 0041 × 002E ÷ 0033 × 0020 ÷ BABB ÷	#  × [0.3] HANGUL SYLLABLE BWA (H2) ÷ [999.0] HANGUL SYLLABLE YO (H2) × [13.02] FULL STOP (IS) × [7.01] SPACE (SP) ÷ [18.0] LATIN CAPITAL LETTER A (AL) × [13.02] FULL STOP (IS) ÷ [999.0] DIGIT THREE (NU) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE MOS (H3) ÷ [0.3]');
    Test_LB('× C694 × 002E × 0020 ÷ 0041 × 002E ÷ 0034 × 0020 ÷ BABB ÷	#  × [0.3] HANGUL SYLLABLE YO (H2) × [13.02] FULL STOP (IS) × [7.01] SPACE (SP) ÷ [18.0] LATIN CAPITAL LETTER A (AL) × [13.02] FULL STOP (IS) ÷ [999.0] DIGIT FOUR (NU) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE MOS (H3) ÷ [0.3]');
    Test_LB('× 0061 × 002E ÷ 0032 × 3000 ÷ 300C ÷	#  × [0.3] LATIN SMALL LETTER A (AL) × [13.02] FULL STOP (IS) ÷ [999.0] DIGIT TWO (NU) × [21.01] IDEOGRAPHIC SPACE (BA) ÷ [999.0] LEFT CORNER BRACKET (OP) ÷ [0.3]');
    Test_LB('× 306B ÷ 300C × 30D0 ÷ 0028 × 0062 × 0061 × 0029 × 300D ÷ 3084 ÷ 300C × 30B9 ÷	#  × [0.3] HIRAGANA LETTER NI (ID) ÷ [999.0] LEFT CORNER BRACKET (OP) × [14.0] KATAKANA LETTER BA (ID) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) × [14.0] LATIN SMALL LETTER B (AL) × [28.0] LATIN SMALL LETTER A (AL) × [13.02] RIGHT PARENTHESIS (CP_CP30) × [13.02] RIGHT CORNER BRACKET (CL) ÷ [999.0] HIRAGANA LETTER YA (ID) ÷ [999.0] LEFT CORNER BRACKET (OP) × [14.0] KATAKANA LETTER SU (ID) ÷ [0.3]');
    Test_LB('× 308B ÷ 300C × 0055 × 004B ÷ 30DD ÷ 30F3 ÷ 30C9 × 300D × FF09 × 3001 ÷ 30A8 ÷	#  × [0.3] HIRAGANA LETTER RU (ID) ÷ [999.0] LEFT CORNER BRACKET (OP) × [14.0] LATIN CAPITAL LETTER U (AL) × [28.0] LATIN CAPITAL LETTER K (AL) ÷ [999.0] KATAKANA LETTER PO (ID) ÷ [999.0] KATAKANA LETTER N (ID) ÷ [999.0] KATAKANA LETTER DO (ID) × [13.02] RIGHT CORNER BRACKET (CL) × [13.02] FULLWIDTH RIGHT PARENTHESIS (CL) × [13.02] IDEOGRAPHIC COMMA (CL) ÷ [999.0] KATAKANA LETTER E (ID) ÷ [0.3]');
    Test_LB('× 306F × 3001 ÷ 300C × 003D × 0072 × 0061 × 006E × 0064 × 0028 × 0029 × 300D ÷ 3068 ÷	#  × [0.3] HIRAGANA LETTER HA (ID) × [13.02] IDEOGRAPHIC COMMA (CL) ÷ [999.0] LEFT CORNER BRACKET (OP) × [14.0] EQUALS SIGN (AL) × [28.0] LATIN SMALL LETTER R (AL) × [28.0] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER N (AL) × [28.0] LATIN SMALL LETTER D (AL) × [30.01] LEFT PARENTHESIS (OP_OP30) × [13.02] RIGHT PARENTHESIS (CP_CP30) × [13.02] RIGHT CORNER BRACKET (CL) ÷ [999.0] HIRAGANA LETTER TO (ID) ÷ [0.3]');
    Test_LB('× 3067 × 3001 ÷ 300C × 0021 × 300D ÷ 3068 ÷	#  × [0.3] HIRAGANA LETTER DE (ID) × [13.02] IDEOGRAPHIC COMMA (CL) ÷ [999.0] LEFT CORNER BRACKET (OP) × [13.01] EXCLAMATION MARK (EX) × [13.02] RIGHT CORNER BRACKET (CL) ÷ [999.0] HIRAGANA LETTER TO (ID) ÷ [0.3]');
    Test_LB('× 8A33 ÷ 300C × 3059 ÷	#  × [0.3] CJK UNIFIED IDEOGRAPH-8A33 (ID) ÷ [999.0] LEFT CORNER BRACKET (OP) × [14.0] HIRAGANA LETTER SU (ID) ÷ [0.3]');
    Test_LB('× 3066 ÷ 300C × BD24 ÷ C5B4 × 003F × 300D ÷ 3068 ÷	#  × [0.3] HIRAGANA LETTER TE (ID) ÷ [999.0] LEFT CORNER BRACKET (OP) × [14.0] HANGUL SYLLABLE BWASS (H3) ÷ [999.0] HANGUL SYLLABLE EO (H2) × [13.01] QUESTION MARK (EX) × [13.02] RIGHT CORNER BRACKET (CL) ÷ [999.0] HIRAGANA LETTER TO (ID) ÷ [0.3]');
    Test_LB('× 306E ÷ 300C × 305D ÷	#  × [0.3] HIRAGANA LETTER NO (ID) ÷ [999.0] LEFT CORNER BRACKET (OP) × [14.0] HIRAGANA LETTER SO (ID) ÷ [0.3]');
    Test_LB('× 306F ÷ 300C × 30A8 ÷	#  × [0.3] HIRAGANA LETTER HA (ID) ÷ [999.0] LEFT CORNER BRACKET (OP) × [14.0] KATAKANA LETTER E (ID) ÷ [0.3]');
    Test_LB('× 4F8B × FF1A ÷ 300C × 3042 × 3000 ÷ 3044 ÷	#  × [0.3] CJK UNIFIED IDEOGRAPH-4F8B (ID) × [21.03] FULLWIDTH COLON (NS) ÷ [999.0] LEFT CORNER BRACKET (OP) × [14.0] HIRAGANA LETTER A (ID) × [21.01] IDEOGRAPHIC SPACE (BA) ÷ [999.0] HIRAGANA LETTER I (ID) ÷ [0.3]');
    Test_LB('× 304F × 3001 ÷ 300C × D3C9 ÷ C591 ÷ C740 ÷	#  × [0.3] HIRAGANA LETTER KU (ID) × [13.02] IDEOGRAPHIC COMMA (CL) ÷ [999.0] LEFT CORNER BRACKET (OP) × [14.0] HANGUL SYLLABLE PYEONG (H3) ÷ [999.0] HANGUL SYLLABLE YANG (H3) ÷ [999.0] HANGUL SYLLABLE EUN (H3) ÷ [0.3]');
    Test_LB('× 306B ÷ 300C × C81C ÷ BAA9 ÷ 0028 × 984C ÷ 540D × 0029 ÷ C740 ÷	#  × [0.3] HIRAGANA LETTER NI (ID) ÷ [999.0] LEFT CORNER BRACKET (OP) × [14.0] HANGUL SYLLABLE JE (H2) ÷ [999.0] HANGUL SYLLABLE MOG (H3) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) × [14.0] CJK UNIFIED IDEOGRAPH-984C (ID) ÷ [999.0] CJK UNIFIED IDEOGRAPH-540D (ID) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [999.0] HANGUL SYLLABLE EUN (H3) ÷ [0.3]');
    Test_LB('× 5178 ÷ 300E × 30A6 × 30A3 ÷ 30AD ÷	#  × [0.3] CJK UNIFIED IDEOGRAPH-5178 (ID) ÷ [999.0] LEFT WHITE CORNER BRACKET (OP) × [14.0] KATAKANA LETTER U (ID) × [21.03] KATAKANA LETTER SMALL I (CJ_NS) ÷ [999.0] KATAKANA LETTER KI (ID) ÷ [0.3]');
    Test_LB('× 3067 ÷ 300E × 82F1 ÷ 8A9E ÷	#  × [0.3] HIRAGANA LETTER DE (ID) ÷ [999.0] LEFT WHITE CORNER BRACKET (OP) × [14.0] CJK UNIFIED IDEOGRAPH-82F1 (ID) ÷ [999.0] CJK UNIFIED IDEOGRAPH-8A9E (ID) ÷ [0.3]');
    Test_LB('× 0028 × 0073 × 0029 × 0020 ÷ 672C ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [14.0] LATIN SMALL LETTER S (AL) × [13.02] RIGHT PARENTHESIS (CP_CP30) × [7.01] SPACE (SP) ÷ [18.0] CJK UNIFIED IDEOGRAPH-672C (ID) ÷ [0.3]');
    Test_LB('× 0028 × 0073 × 0029 × 0020 ÷ 307E ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [14.0] LATIN SMALL LETTER S (AL) × [13.02] RIGHT PARENTHESIS (CP_CP30) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER MA (ID) ÷ [0.3]');
    Test_LB('× 0028 × 0073 × 0029 × 0020 ÷ 30AF ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [14.0] LATIN SMALL LETTER S (AL) × [13.02] RIGHT PARENTHESIS (CP_CP30) × [7.01] SPACE (SP) ÷ [18.0] KATAKANA LETTER KU (ID) ÷ [0.3]');
    Test_LB('× 308B × 3002 ÷ 0064 × 006F × 0067 ÷ FF08 × 72AC × FF09 ÷ 3092 ÷	#  × [0.3] HIRAGANA LETTER RU (ID) × [13.02] IDEOGRAPHIC FULL STOP (CL) ÷ [999.0] LATIN SMALL LETTER D (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER G (AL) ÷ [999.0] FULLWIDTH LEFT PARENTHESIS (OP) × [14.0] CJK UNIFIED IDEOGRAPH-72AC (ID) × [13.02] FULLWIDTH RIGHT PARENTHESIS (CL) ÷ [999.0] HIRAGANA LETTER WO (ID) ÷ [0.3]');
    Test_LB('× 672C ÷ FF08 × 307E ÷	#  × [0.3] CJK UNIFIED IDEOGRAPH-672C (ID) ÷ [999.0] FULLWIDTH LEFT PARENTHESIS (OP) × [14.0] HIRAGANA LETTER MA (ID) ÷ [0.3]');
    Test_LB('× 672C × 0020 ÷ 0028 × 0061 ÷	#  × [0.3] CJK UNIFIED IDEOGRAPH-672C (ID) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) × [14.0] LATIN SMALL LETTER A (AL) ÷ [0.3]');
    Test_LB('× 70B9 × 0020 ÷ 005B × 7DE8 ÷ 96C6 × 005D ÷	#  × [0.3] CJK UNIFIED IDEOGRAPH-70B9 (ID) × [7.01] SPACE (SP) ÷ [18.0] LEFT SQUARE BRACKET (OP_OP30) × [14.0] CJK UNIFIED IDEOGRAPH-7DE8 (ID) ÷ [999.0] CJK UNIFIED IDEOGRAPH-96C6 (ID) × [13.02] RIGHT SQUARE BRACKET (CP_CP30) ÷ [0.3]');
    Test_LB('× 0061 × 0028 × 0073 × 0029 × 0020 ÷	#  × [0.3] LATIN SMALL LETTER A (AL) × [30.01] LEFT PARENTHESIS (OP_OP30) × [14.0] LATIN SMALL LETTER S (AL) × [13.02] RIGHT PARENTHESIS (CP_CP30) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× FF08 × 30B6 × 30FB ÷ 30AF ÷ 30A4 × 30C3 ÷ 30AF × 30FB ÷ 30D6 ÷	#  × [0.3] FULLWIDTH LEFT PARENTHESIS (OP) × [14.0] KATAKANA LETTER ZA (ID) × [21.03] KATAKANA MIDDLE DOT (NS) ÷ [999.0] KATAKANA LETTER KU (ID) ÷ [999.0] KATAKANA LETTER I (ID) × [21.03] KATAKANA LETTER SMALL TU (CJ_NS) ÷ [999.0] KATAKANA LETTER KU (ID) × [21.03] KATAKANA MIDDLE DOT (NS) ÷ [999.0] KATAKANA LETTER BU (ID) ÷ [0.3]');
    Test_LB('× 0070 ÷ FF08 × 30AF ÷ 30A4 × 30C3 ÷ 30AF × 30FB ÷ 30D6 ÷	#  × [0.3] LATIN SMALL LETTER P (AL) ÷ [999.0] FULLWIDTH LEFT PARENTHESIS (OP) × [14.0] KATAKANA LETTER KU (ID) ÷ [999.0] KATAKANA LETTER I (ID) × [21.03] KATAKANA LETTER SMALL TU (CJ_NS) ÷ [999.0] KATAKANA LETTER KU (ID) × [21.03] KATAKANA MIDDLE DOT (NS) ÷ [999.0] KATAKANA LETTER BU (ID) ÷ [0.3]');
    Test_LB('× 0061 × 0062 ÷ FF08 × 30AF ÷	#  × [0.3] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER B (AL) ÷ [999.0] FULLWIDTH LEFT PARENTHESIS (OP) × [14.0] KATAKANA LETTER KU (ID) ÷ [0.3]');
    Test_LB('× 0028 × 5370 ÷ 672C × 0029 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [14.0] CJK UNIFIED IDEOGRAPH-5370 (ID) ÷ [999.0] CJK UNIFIED IDEOGRAPH-672C (ID) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 30B9 ÷ FF08 × 3044 ÷	#  × [0.3] KATAKANA LETTER SU (ID) ÷ [999.0] FULLWIDTH LEFT PARENTHESIS (OP) × [14.0] HIRAGANA LETTER I (ID) ÷ [0.3]');
    Test_LB('× 30C9 ÷ FF08 × 30DD ÷	#  × [0.3] KATAKANA LETTER DO (ID) ÷ [999.0] FULLWIDTH LEFT PARENTHESIS (OP) × [14.0] KATAKANA LETTER PO (ID) ÷ [0.3]');
    Test_LB('× 30C9 × 0020 ÷ 0028 × 8CEA ÷	#  × [0.3] KATAKANA LETTER DO (ID) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) × [14.0] CJK UNIFIED IDEOGRAPH-8CEA (ID) ÷ [0.3]');
    Test_LB('× 0073 × 0029 × 300D ÷ 307E ÷	#  × [0.3] LATIN SMALL LETTER S (AL) × [13.02] RIGHT PARENTHESIS (CP_CP30) × [13.02] RIGHT CORNER BRACKET (CL) ÷ [999.0] HIRAGANA LETTER MA (ID) ÷ [0.3]');
    Test_LB('× 0061 × FF09 × 300F ÷	#  × [0.3] LATIN SMALL LETTER A (AL) × [13.02] FULLWIDTH RIGHT PARENTHESIS (CL) × [13.02] RIGHT WHITE CORNER BRACKET (CL) ÷ [0.3]');
    Test_LB('× 308B × 300D × FF09 ÷ 306F ÷	#  × [0.3] HIRAGANA LETTER RU (ID) × [13.02] RIGHT CORNER BRACKET (CL) × [13.02] FULLWIDTH RIGHT PARENTHESIS (CL) ÷ [999.0] HIRAGANA LETTER HA (ID) ÷ [0.3]');
    Test_LB('× 30C9 × 300D × FF09 × 3001 ÷ 30A8 ÷	#  × [0.3] KATAKANA LETTER DO (ID) × [13.02] RIGHT CORNER BRACKET (CL) × [13.02] FULLWIDTH RIGHT PARENTHESIS (CL) × [13.02] IDEOGRAPHIC COMMA (CL) ÷ [999.0] KATAKANA LETTER E (ID) ÷ [0.3]');
    Test_LB('× 0072 × 006B × 0029 × 300D ÷ 3082 ÷	#  × [0.3] LATIN SMALL LETTER R (AL) × [28.0] LATIN SMALL LETTER K (AL) × [13.02] RIGHT PARENTHESIS (CP_CP30) × [13.02] RIGHT CORNER BRACKET (CL) ÷ [999.0] HIRAGANA LETTER MO (ID) ÷ [0.3]');
    Test_LB('× 30AF ÷ 0028 × 0061 × 0062 × 0020 ÷ 0063 × 0064 × 0029 × 300D ÷ 3082 ÷	#  × [0.3] KATAKANA LETTER KU (ID) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) × [14.0] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER B (AL) × [7.01] SPACE (SP) ÷ [18.0] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER D (AL) × [13.02] RIGHT PARENTHESIS (CP_CP30) × [13.02] RIGHT CORNER BRACKET (CL) ÷ [999.0] HIRAGANA LETTER MO (ID) ÷ [0.3]');
    Test_LB('× 30F3 × 30FB ÷ 30DE × 30FC ÷ 30AF ÷ 0028 × 0065 × 0078 ÷	#  × [0.3] KATAKANA LETTER N (ID) × [21.03] KATAKANA MIDDLE DOT (NS) ÷ [999.0] KATAKANA LETTER MA (ID) × [21.03] KATAKANA-HIRAGANA PROLONGED SOUND MARK (CJ_NS) ÷ [999.0] KATAKANA LETTER KU (ID) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) × [14.0] LATIN SMALL LETTER E (AL) × [28.0] LATIN SMALL LETTER X (AL) ÷ [0.3]');
    Test_LB('× 30DE × 30FC ÷ 0028 × 006D × 0061 × 0029 × 300D ÷ 306A ÷	#  × [0.3] KATAKANA LETTER MA (ID) × [21.03] KATAKANA-HIRAGANA PROLONGED SOUND MARK (CJ_NS) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) × [14.0] LATIN SMALL LETTER M (AL) × [28.0] LATIN SMALL LETTER A (AL) × [13.02] RIGHT PARENTHESIS (CP_CP30) × [13.02] RIGHT CORNER BRACKET (CL) ÷ [999.0] HIRAGANA LETTER NA (ID) ÷ [0.3]');
    Test_LB('× 30AC ÷ 30EF × 300D × 3002 ÷ 3053 ÷	#  × [0.3] KATAKANA LETTER GA (ID) ÷ [999.0] KATAKANA LETTER WA (ID) × [13.02] RIGHT CORNER BRACKET (CL) × [13.02] IDEOGRAPHIC FULL STOP (CL) ÷ [999.0] HIRAGANA LETTER KO (ID) ÷ [0.3]');
    Test_LB('× 30AF × 300D ÷ 307E ÷	#  × [0.3] KATAKANA LETTER KU (ID) × [13.02] RIGHT CORNER BRACKET (CL) ÷ [999.0] HIRAGANA LETTER MA (ID) ÷ [0.3]');
    Test_LB('× 30EF × 300D × 3002 ÷ 3053 ÷	#  × [0.3] KATAKANA LETTER WA (ID) × [13.02] RIGHT CORNER BRACKET (CL) × [13.02] IDEOGRAPHIC FULL STOP (CL) ÷ [999.0] HIRAGANA LETTER KO (ID) ÷ [0.3]');
    Test_LB('× 30AF × 300D ÷ 307E × 3001 ÷ 672C ÷	#  × [0.3] KATAKANA LETTER KU (ID) × [13.02] RIGHT CORNER BRACKET (CL) ÷ [999.0] HIRAGANA LETTER MA (ID) × [13.02] IDEOGRAPHIC COMMA (CL) ÷ [999.0] CJK UNIFIED IDEOGRAPH-672C (ID) ÷ [0.3]');
    Test_LB('× 30AF × 300D × 3001 ÷ 30AF ÷	#  × [0.3] KATAKANA LETTER KU (ID) × [13.02] RIGHT CORNER BRACKET (CL) × [13.02] IDEOGRAPHIC COMMA (CL) ÷ [999.0] KATAKANA LETTER KU (ID) ÷ [0.3]');
    Test_LB('× 30C7 × 30A3 ÷ 30A2 ÷ FF08 × 0061 × 0062 × FF09 × 300F ÷	#  × [0.3] KATAKANA LETTER DE (ID) × [21.03] KATAKANA LETTER SMALL I (CJ_NS) ÷ [999.0] KATAKANA LETTER A (ID) ÷ [999.0] FULLWIDTH LEFT PARENTHESIS (OP) × [14.0] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER B (AL) × [13.02] FULLWIDTH RIGHT PARENTHESIS (CL) × [13.02] RIGHT WHITE CORNER BRACKET (CL) ÷ [0.3]');
    Test_LB('× CABD ÷ C774 ÷ C5D0 ÷ C694 × 003F × 300D ÷ 3068 ÷ 805E ÷	#  × [0.3] HANGUL SYLLABLE JJOG (H3) ÷ [999.0] HANGUL SYLLABLE I (H2) ÷ [999.0] HANGUL SYLLABLE E (H2) ÷ [999.0] HANGUL SYLLABLE YO (H2) × [13.01] QUESTION MARK (EX) × [13.02] RIGHT CORNER BRACKET (CL) ÷ [999.0] HIRAGANA LETTER TO (ID) ÷ [999.0] CJK UNIFIED IDEOGRAPH-805E (ID) ÷ [0.3]');
    Test_LB('× 540D × 0029 ÷ C740 × 0020 ÷ C54C ÷ C544 ÷ C694 × 003F × 300D ÷ 3068 ÷	#  × [0.3] CJK UNIFIED IDEOGRAPH-540D (ID) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [999.0] HANGUL SYLLABLE EUN (H3) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE AL (H3) ÷ [999.0] HANGUL SYLLABLE A (H2) ÷ [999.0] HANGUL SYLLABLE YO (H2) × [13.01] QUESTION MARK (EX) × [13.02] RIGHT CORNER BRACKET (CL) ÷ [999.0] HIRAGANA LETTER TO (ID) ÷ [0.3]');
    Test_LB('× 8CA8 × 0029 × 0020 ÷ 002D × 0020 ÷ 0028 × 0070 × 006F ÷	#  × [0.3] CJK UNIFIED IDEOGRAPH-8CA8 (ID) × [13.02] RIGHT PARENTHESIS (CP_CP30) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) × [14.0] LATIN SMALL LETTER P (AL) × [28.0] LATIN SMALL LETTER O (AL) ÷ [0.3]');
    Test_LB('× 91CF × 0029 × 0020 × 301C × 0020 ÷ 0028 × 0070 × 006F ÷	#  × [0.3] CJK UNIFIED IDEOGRAPH-91CF (ID) × [13.02] RIGHT PARENTHESIS (CP_CP30) × [7.01] SPACE (SP) × [16.0] WAVE DASH (NS) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) × [14.0] LATIN SMALL LETTER P (AL) × [28.0] LATIN SMALL LETTER O (AL) ÷ [0.3]');
    Test_LB('× 30C9 ÷ 91CD × FF09 × 0020 × 301C × 0020 ÷ 529B × 30FB ÷ 91CD ÷	#  × [0.3] KATAKANA LETTER DO (ID) ÷ [999.0] CJK UNIFIED IDEOGRAPH-91CD (ID) × [13.02] FULLWIDTH RIGHT PARENTHESIS (CL) × [7.01] SPACE (SP) × [16.0] WAVE DASH (NS) × [7.01] SPACE (SP) ÷ [18.0] CJK UNIFIED IDEOGRAPH-529B (ID) × [21.03] KATAKANA MIDDLE DOT (NS) ÷ [999.0] CJK UNIFIED IDEOGRAPH-91CD (ID) ÷ [0.3]');
    Test_LB('× 0061 × 0062 × 0022 × FF08 × 307E ÷	#  × [0.3] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER B (AL) × [19.01] QUOTATION MARK (QU) × [15.0] FULLWIDTH LEFT PARENTHESIS (OP) × [14.0] HIRAGANA LETTER MA (ID) ÷ [0.3]');
    Test_LB('× 306F × 0020 ÷ 0022 × 0073 × 0022 × 0020 ÷	#  × [0.3] HIRAGANA LETTER HA (ID) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) × [19.02] LATIN SMALL LETTER S (AL) × [19.01] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 306F × 3001 × 0022 × 0054 × 0068 × 0065 × 0020 ÷	#  × [0.3] HIRAGANA LETTER HA (ID) × [13.02] IDEOGRAPHIC COMMA (CL) × [19.01] QUOTATION MARK (QU) × [19.02] LATIN CAPITAL LETTER T (AL) × [28.0] LATIN SMALL LETTER H (AL) × [28.0] LATIN SMALL LETTER E (AL) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0064 × 006F × 0067 × 0022 × 0020 ÷ 3092 ÷	#  × [0.3] LATIN SMALL LETTER D (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER G (AL) × [19.01] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER WO (ID) ÷ [0.3]');
    Test_LB('× 0039 × 0030 × 0022 × 0020 ÷ 3068 ÷	#  × [0.3] DIGIT NINE (NU) × [25.03] DIGIT ZERO (NU) × [19.01] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER TO (ID) ÷ [0.3]');
    Test_LB('× 30B9 × 30FB ÷ 30AA × 30FC ÷ 30D0 × 30FC × 30FB ÷ 30B6 × 30FB ÷ 30EC ÷	#  × [0.3] KATAKANA LETTER SU (ID) × [21.03] KATAKANA MIDDLE DOT (NS) ÷ [999.0] KATAKANA LETTER O (ID) × [21.03] KATAKANA-HIRAGANA PROLONGED SOUND MARK (CJ_NS) ÷ [999.0] KATAKANA LETTER BA (ID) × [21.03] KATAKANA-HIRAGANA PROLONGED SOUND MARK (CJ_NS) × [21.03] KATAKANA MIDDLE DOT (NS) ÷ [999.0] KATAKANA LETTER ZA (ID) × [21.03] KATAKANA MIDDLE DOT (NS) ÷ [999.0] KATAKANA LETTER RE (ID) ÷ [0.3]');
    Test_LB('× 30B9 × 30FB ÷ 30B8 × 30E3 ÷ 30F3 ÷	#  × [0.3] KATAKANA LETTER SU (ID) × [21.03] KATAKANA MIDDLE DOT (NS) ÷ [999.0] KATAKANA LETTER ZI (ID) × [21.03] KATAKANA LETTER SMALL YA (CJ_NS) ÷ [999.0] KATAKANA LETTER N (ID) ÷ [0.3]');
    Test_LB('× 30F3 × 30FB ÷ 30D5 × 30A9 × 30C3 ÷ 30AF ÷	#  × [0.3] KATAKANA LETTER N (ID) × [21.03] KATAKANA MIDDLE DOT (NS) ÷ [999.0] KATAKANA LETTER HU (ID) × [21.03] KATAKANA LETTER SMALL O (CJ_NS) × [21.03] KATAKANA LETTER SMALL TU (CJ_NS) ÷ [999.0] KATAKANA LETTER KU (ID) ÷ [0.3]');
    Test_LB('× 30A4 ÷ 30B8 × 30FC × 30FB ÷ 30C9 × 30C3 ÷ 30B0 × 3001 ÷ 548C ÷	#  × [0.3] KATAKANA LETTER I (ID) ÷ [999.0] KATAKANA LETTER ZI (ID) × [21.03] KATAKANA-HIRAGANA PROLONGED SOUND MARK (CJ_NS) × [21.03] KATAKANA MIDDLE DOT (NS) ÷ [999.0] KATAKANA LETTER DO (ID) × [21.03] KATAKANA LETTER SMALL TU (CJ_NS) ÷ [999.0] KATAKANA LETTER GU (ID) × [13.02] IDEOGRAPHIC COMMA (CL) ÷ [999.0] CJK UNIFIED IDEOGRAPH-548C (ID) ÷ [0.3]');
    Test_LB('× 30E1 × 30FC ÷ 30B7 × 30E7 ÷ 30F3 × 30FB ÷ 30DE × 30FC ÷ 30AF ÷	#  × [0.3] KATAKANA LETTER ME (ID) × [21.03] KATAKANA-HIRAGANA PROLONGED SOUND MARK (CJ_NS) ÷ [999.0] KATAKANA LETTER SI (ID) × [21.03] KATAKANA LETTER SMALL YO (CJ_NS) ÷ [999.0] KATAKANA LETTER N (ID) × [21.03] KATAKANA MIDDLE DOT (NS) ÷ [999.0] KATAKANA LETTER MA (ID) × [21.03] KATAKANA-HIRAGANA PROLONGED SOUND MARK (CJ_NS) ÷ [999.0] KATAKANA LETTER KU (ID) ÷ [0.3]');
    Test_LB('× 30F3 × 30FB ÷ 30AF ÷ 0028 × 0061 ÷	#  × [0.3] KATAKANA LETTER N (ID) × [21.03] KATAKANA MIDDLE DOT (NS) ÷ [999.0] KATAKANA LETTER KU (ID) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) × [14.0] LATIN SMALL LETTER A (AL) ÷ [0.3]');
    Test_LB('× 30B7 × 30E7 ÷ 30F3 × 30FB ÷ 30DE ÷	#  × [0.3] KATAKANA LETTER SI (ID) × [21.03] KATAKANA LETTER SMALL YO (CJ_NS) ÷ [999.0] KATAKANA LETTER N (ID) × [21.03] KATAKANA MIDDLE DOT (NS) ÷ [999.0] KATAKANA LETTER MA (ID) ÷ [0.3]');
    Test_LB('× 672C × 003A × 0020 ÷	#  × [0.3] CJK UNIFIED IDEOGRAPH-672C (ID) × [13.02] COLON (IS) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 672C × 003A × 0020 ÷ 30AF ÷	#  × [0.3] CJK UNIFIED IDEOGRAPH-672C (ID) × [13.02] COLON (IS) × [7.01] SPACE (SP) ÷ [18.0] KATAKANA LETTER KU (ID) ÷ [0.3]');
    Test_LB('× 51FA ÷ 5178 × 003A × 0020 ÷ 30D5 ÷ 30EA × 30FC ÷ 767E ÷	#  × [0.3] CJK UNIFIED IDEOGRAPH-51FA (ID) ÷ [999.0] CJK UNIFIED IDEOGRAPH-5178 (ID) × [13.02] COLON (IS) × [7.01] SPACE (SP) ÷ [18.0] KATAKANA LETTER HU (ID) ÷ [999.0] KATAKANA LETTER RI (ID) × [21.03] KATAKANA-HIRAGANA PROLONGED SOUND MARK (CJ_NS) ÷ [999.0] CJK UNIFIED IDEOGRAPH-767E (ID) ÷ [0.3]');
    Test_LB('× 5F8C × 2026 ÷ 306B ÷	#  × [0.3] CJK UNIFIED IDEOGRAPH-5F8C (ID) × [22.0] HORIZONTAL ELLIPSIS (IN) ÷ [999.0] HIRAGANA LETTER NI (ID) ÷ [0.3]');
    Test_LB('× 3057 × 3087 ÷ 3046 × 3002 × 3002 × 3002 ÷	#  × [0.3] HIRAGANA LETTER SI (ID) × [21.03] HIRAGANA LETTER SMALL YO (CJ_NS) ÷ [999.0] HIRAGANA LETTER U (ID) × [13.02] IDEOGRAPHIC FULL STOP (CL) × [13.02] IDEOGRAPHIC FULL STOP (CL) × [13.02] IDEOGRAPHIC FULL STOP (CL) ÷ [0.3]');
    Test_LB('× 304D × 3001 × 0021 × 0021 × 3001 × 0021 × 0021 × 0021 ÷ 3068 ÷	#  × [0.3] HIRAGANA LETTER KI (ID) × [13.02] IDEOGRAPHIC COMMA (CL) × [13.01] EXCLAMATION MARK (EX) × [13.01] EXCLAMATION MARK (EX) × [13.02] IDEOGRAPHIC COMMA (CL) × [13.01] EXCLAMATION MARK (EX) × [13.01] EXCLAMATION MARK (EX) × [13.01] EXCLAMATION MARK (EX) ÷ [999.0] HIRAGANA LETTER TO (ID) ÷ [0.3]');
    Test_LB('× 306F × 3001 × 003F ÷ 3068 × 0021 ÷ 3092 ÷	#  × [0.3] HIRAGANA LETTER HA (ID) × [13.02] IDEOGRAPHIC COMMA (CL) × [13.01] QUESTION MARK (EX) ÷ [999.0] HIRAGANA LETTER TO (ID) × [13.01] EXCLAMATION MARK (EX) ÷ [999.0] HIRAGANA LETTER WO (ID) ÷ [0.3]');
    Test_LB('× 305F × 3001 × 2049 ÷ 0028 × 0021 × 003F × 0029 ÷ 306E ÷	#  × [0.3] HIRAGANA LETTER TA (ID) × [13.02] IDEOGRAPHIC COMMA (CL) × [16.0] EXCLAMATION QUESTION MARK (NS) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) × [13.01] EXCLAMATION MARK (EX) × [13.01] QUESTION MARK (EX) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [999.0] HIRAGANA LETTER NO (ID) ÷ [0.3]');
    Test_LB('× 3084 × 3001 × 2048 ÷ 0028 × 003F × 0021 × 0029 ÷ 306E ÷	#  × [0.3] HIRAGANA LETTER YA (ID) × [13.02] IDEOGRAPHIC COMMA (CL) × [16.0] QUESTION EXCLAMATION MARK (NS) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) × [13.01] QUESTION MARK (EX) × [13.01] EXCLAMATION MARK (EX) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [999.0] HIRAGANA LETTER NO (ID) ÷ [0.3]');
    Test_LB('× 305F × 0020 ÷ 203D ÷ 3068 ÷	#  × [0.3] HIRAGANA LETTER TA (ID) × [7.01] SPACE (SP) ÷ [18.0] INTERROBANG (NS) ÷ [999.0] HIRAGANA LETTER TO (ID) ÷ [0.3]');
    Test_LB('× 305B × FF01 ÷ 0031 × 0030 × 0030 × 0025 ÷ 306E ÷ 5B8C ÷	#  × [0.3] HIRAGANA LETTER SE (ID) × [13.01] FULLWIDTH EXCLAMATION MARK (EX) ÷ [999.0] DIGIT ONE (NU) × [25.03] DIGIT ZERO (NU) × [25.03] DIGIT ZERO (NU) × [25.05] PERCENT SIGN (PO) ÷ [999.0] HIRAGANA LETTER NO (ID) ÷ [999.0] CJK UNIFIED IDEOGRAPH-5B8C (ID) ÷ [0.3]');
    Test_LB('× 0032 × 0033 ÷ 672C ÷	#  × [0.3] DIGIT TWO (NU) × [25.03] DIGIT THREE (NU) ÷ [999.0] CJK UNIFIED IDEOGRAPH-672C (ID) ÷ [0.3]');
    Test_LB('× 30A1 ÷ 30D9 × 30C3 ÷ 30C8 ÷ 0032 × 0036 ÷ 5B57 ÷ 3092 ÷	#  × [0.3] KATAKANA LETTER SMALL A (CJ_NS) ÷ [999.0] KATAKANA LETTER BE (ID) × [21.03] KATAKANA LETTER SMALL TU (CJ_NS) ÷ [999.0] KATAKANA LETTER TO (ID) ÷ [999.0] DIGIT TWO (NU) × [25.03] DIGIT SIX (NU) ÷ [999.0] CJK UNIFIED IDEOGRAPH-5B57 (ID) ÷ [999.0] HIRAGANA LETTER WO (ID) ÷ [0.3]');
    Test_LB('× 4F8B × FF1A ÷ 00A3 × 0032 × 0033 ÷	#  × [0.3] CJK UNIFIED IDEOGRAPH-4F8B (ID) × [21.03] FULLWIDTH COLON (NS) ÷ [999.0] POUND SIGN (PR) × [25.01] DIGIT TWO (NU) × [25.03] DIGIT THREE (NU) ÷ [0.3]');
    Test_LB('× 8A18 ÷ 53F7 × 0020 ÷ 00A3 × 3002 ÷	#  × [0.3] CJK UNIFIED IDEOGRAPH-8A18 (ID) ÷ [999.0] CJK UNIFIED IDEOGRAPH-53F7 (ID) × [7.01] SPACE (SP) ÷ [18.0] POUND SIGN (PR) × [13.02] IDEOGRAPHIC FULL STOP (CL) ÷ [0.3]');
    Test_LB('× 308C ÷ 308B × 3002 ÷ 0071 × 0075 ÷	#  × [0.3] HIRAGANA LETTER RE (ID) ÷ [999.0] HIRAGANA LETTER RU (ID) × [13.02] IDEOGRAPHIC FULL STOP (CL) ÷ [999.0] LATIN SMALL LETTER Q (AL) × [28.0] LATIN SMALL LETTER U (AL) ÷ [0.3]');
    Test_LB('× 307E × 3002 ÷	#  × [0.3] HIRAGANA LETTER MA (ID) × [13.02] IDEOGRAPHIC FULL STOP (CL) ÷ [0.3]');
    Test_LB('× 307E × 3002 ÷ 0061 × 0062 × 0020 ÷	#  × [0.3] HIRAGANA LETTER MA (ID) × [13.02] IDEOGRAPHIC FULL STOP (CL) ÷ [999.0] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER B (AL) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 308B × 3002 ÷ 6570 ÷	#  × [0.3] HIRAGANA LETTER RU (ID) × [13.02] IDEOGRAPHIC FULL STOP (CL) ÷ [999.0] CJK UNIFIED IDEOGRAPH-6570 (ID) ÷ [0.3]');
    Test_LB('× 308B × 3002 ÷ 3053 ÷	#  × [0.3] HIRAGANA LETTER RU (ID) × [13.02] IDEOGRAPHIC FULL STOP (CL) ÷ [999.0] HIRAGANA LETTER KO (ID) ÷ [0.3]');
    Test_LB('× 3044 × 3002 ÷ 30D1 ÷	#  × [0.3] HIRAGANA LETTER I (ID) × [13.02] IDEOGRAPHIC FULL STOP (CL) ÷ [999.0] KATAKANA LETTER PA (ID) ÷ [0.3]');
    Test_LB('× 30AC ÷ 30EF × 300D × 3002 ÷ 3053 ÷ 308C ÷	#  × [0.3] KATAKANA LETTER GA (ID) ÷ [999.0] KATAKANA LETTER WA (ID) × [13.02] RIGHT CORNER BRACKET (CL) × [13.02] IDEOGRAPHIC FULL STOP (CL) ÷ [999.0] HIRAGANA LETTER KO (ID) ÷ [999.0] HIRAGANA LETTER RE (ID) ÷ [0.3]');
    Test_LB('× 8A9E ÷ 306E ÷ 0069 × 006F ÷ 306E × 3001 ÷ 0032 ÷ 5B57 ÷ 3092 ÷	#  × [0.3] CJK UNIFIED IDEOGRAPH-8A9E (ID) ÷ [999.0] HIRAGANA LETTER NO (ID) ÷ [999.0] LATIN SMALL LETTER I (AL) × [28.0] LATIN SMALL LETTER O (AL) ÷ [999.0] HIRAGANA LETTER NO (ID) × [13.02] IDEOGRAPHIC COMMA (CL) ÷ [999.0] DIGIT TWO (NU) ÷ [999.0] CJK UNIFIED IDEOGRAPH-5B57 (ID) ÷ [999.0] HIRAGANA LETTER WO (ID) ÷ [0.3]');
    Test_LB('× 3001 ÷ 548C ÷	#  × [0.3] IDEOGRAPHIC COMMA (CL) ÷ [999.0] CJK UNIFIED IDEOGRAPH-548C (ID) ÷ [0.3]');
    Test_LB('× 3001 ÷ 30BF ÷	#  × [0.3] IDEOGRAPHIC COMMA (CL) ÷ [999.0] KATAKANA LETTER TA (ID) ÷ [0.3]');
    Test_LB('× 3001 ÷ 304B ÷	#  × [0.3] IDEOGRAPHIC COMMA (CL) ÷ [999.0] HIRAGANA LETTER KA (ID) ÷ [0.3]');
    Test_LB('× 3001 ÷ 3053 ÷ 308C ÷ 3067 ÷ 306F × 0020 ÷	#  × [0.3] IDEOGRAPHIC COMMA (CL) ÷ [999.0] HIRAGANA LETTER KO (ID) ÷ [999.0] HIRAGANA LETTER RE (ID) ÷ [999.0] HIRAGANA LETTER DE (ID) ÷ [999.0] HIRAGANA LETTER HA (ID) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 3057 × 3001 ÷ 0061 × 0062 ÷ 3068 ÷	#  × [0.3] HIRAGANA LETTER SI (ID) × [13.02] IDEOGRAPHIC COMMA (CL) ÷ [999.0] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER B (AL) ÷ [999.0] HIRAGANA LETTER TO (ID) ÷ [0.3]');
    Test_LB('× 0061 ÷ 1F1E6 ÷ 0062 ÷	#  × [0.3] LATIN SMALL LETTER A (AL) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] LATIN SMALL LETTER B (AL) ÷ [0.3]');
    Test_LB('× 1F1F7 × 1F1FA ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER R (RI) × [30.11] REGIONAL INDICATOR SYMBOL LETTER U (RI) ÷ [0.3]');
    Test_LB('× 1F1F7 × 1F1FA ÷ 1F1F8 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER R (RI) × [30.11] REGIONAL INDICATOR SYMBOL LETTER U (RI) ÷ [30.13] REGIONAL INDICATOR SYMBOL LETTER S (RI) ÷ [0.3]');
    Test_LB('× 1F1F7 × 1F1FA ÷ 1F1F8 × 1F1EA ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER R (RI) × [30.11] REGIONAL INDICATOR SYMBOL LETTER U (RI) ÷ [30.13] REGIONAL INDICATOR SYMBOL LETTER S (RI) × [30.11] REGIONAL INDICATOR SYMBOL LETTER E (RI) ÷ [0.3]');
    Test_LB('× 1F1F7 × 1F1FA × 200B ÷ 1F1F8 × 1F1EA ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER R (RI) × [30.11] REGIONAL INDICATOR SYMBOL LETTER U (RI) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [8.0] REGIONAL INDICATOR SYMBOL LETTER S (RI) × [30.12] REGIONAL INDICATOR SYMBOL LETTER E (RI) ÷ [0.3]');
    Test_LB('× 05D0 × 002D × 05D0 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [21.02] HYPHEN-MINUS (HY) × [21.1] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 1F02C × 1F3FF ÷	#  × [0.3] <reserved-1F02C> (Other) × [30.22] EMOJI MODIFIER FITZPATRICK TYPE-6 (EM) ÷ [0.3]');
    Test_LB('× 00A9 ÷ 1F3FF ÷	#  × [0.3] COPYRIGHT SIGN (AL) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-6 (EM) ÷ [0.3]');
}
if (!$::TESTCHUNK or $::TESTCHUNK == 10) {
    Test_WB('÷ 0001 ÷ 0001 ÷	#  ÷ [0.2] <START OF HEADING> (Other) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 0001 × 0308 ÷ 0001 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 0001 ÷ 000D ÷	#  ÷ [0.2] <START OF HEADING> (Other) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 0001 × 0308 ÷ 000D ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 0001 ÷ 000A ÷	#  ÷ [0.2] <START OF HEADING> (Other) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 0001 × 0308 ÷ 000A ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 0001 ÷ 000B ÷	#  ÷ [0.2] <START OF HEADING> (Other) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 0001 × 0308 ÷ 000B ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 0001 ÷ 3031 ÷	#  ÷ [0.2] <START OF HEADING> (Other) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0001 × 0308 ÷ 3031 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0001 ÷ 0041 ÷	#  ÷ [0.2] <START OF HEADING> (Other) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0001 × 0308 ÷ 0041 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0001 ÷ 003A ÷	#  ÷ [0.2] <START OF HEADING> (Other) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0001 × 0308 ÷ 003A ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0001 ÷ 002C ÷	#  ÷ [0.2] <START OF HEADING> (Other) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0001 × 0308 ÷ 002C ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0001 ÷ 002E ÷	#  ÷ [0.2] <START OF HEADING> (Other) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 0001 × 0308 ÷ 002E ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 0001 ÷ 0030 ÷	#  ÷ [0.2] <START OF HEADING> (Other) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0001 × 0308 ÷ 0030 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0001 ÷ 005F ÷	#  ÷ [0.2] <START OF HEADING> (Other) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0001 × 0308 ÷ 005F ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0001 ÷ 1F1E6 ÷	#  ÷ [0.2] <START OF HEADING> (Other) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 0001 × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 0001 ÷ 05D0 ÷	#  ÷ [0.2] <START OF HEADING> (Other) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0001 × 0308 ÷ 05D0 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0001 ÷ 0022 ÷	#  ÷ [0.2] <START OF HEADING> (Other) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 0001 × 0308 ÷ 0022 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 0001 ÷ 0027 ÷	#  ÷ [0.2] <START OF HEADING> (Other) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0001 × 0308 ÷ 0027 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0001 ÷ 231A ÷	#  ÷ [0.2] <START OF HEADING> (Other) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 0001 × 0308 ÷ 231A ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 0001 ÷ 0020 ÷	#  ÷ [0.2] <START OF HEADING> (Other) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 0001 × 0308 ÷ 0020 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 0001 × 00AD ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0001 × 0308 × 00AD ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0001 × 0300 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0001 × 0308 × 0300 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0001 × 200D ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 0001 × 0308 × 200D ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 0001 ÷ 0061 × 2060 ÷	#  ÷ [0.2] <START OF HEADING> (Other) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0001 × 0308 ÷ 0061 × 2060 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0001 ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] <START OF HEADING> (Other) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0001 × 0308 ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0001 ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] <START OF HEADING> (Other) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0001 × 0308 ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0001 ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] <START OF HEADING> (Other) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0001 × 0308 ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0001 ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] <START OF HEADING> (Other) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0001 × 0308 ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0001 ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] <START OF HEADING> (Other) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0001 × 0308 ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0001 ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] <START OF HEADING> (Other) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0001 × 0308 ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0001 ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] <START OF HEADING> (Other) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0001 × 0308 ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0001 ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] <START OF HEADING> (Other) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0001 × 0308 ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0001 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0308 ÷ 0001 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 000D ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0308 ÷ 000D ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 000D × 000A ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) × [3.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0308 ÷ 000A ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 000B ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0308 ÷ 000B ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 3031 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0308 ÷ 3031 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0041 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0308 ÷ 0041 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 003A ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0308 ÷ 003A ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 002C ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0308 ÷ 002C ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 002E ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0308 ÷ 002E ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0030 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0308 ÷ 0030 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 005F ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0308 ÷ 005F ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 1F1E6 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 05D0 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0308 ÷ 05D0 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0022 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0308 ÷ 0022 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0027 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0308 ÷ 0027 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 231A ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0308 ÷ 231A ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0020 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0308 ÷ 0020 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 00AD ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0308 × 00AD ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0300 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0308 × 0300 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 200D ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0308 × 200D ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0061 × 2060 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0308 ÷ 0061 × 2060 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0308 ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0308 ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0308 ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0308 ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0308 ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0308 ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0308 ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0308 ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0001 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0308 ÷ 0001 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 000D ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0308 ÷ 000D ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 000A ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0308 ÷ 000A ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 000B ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0308 ÷ 000B ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 3031 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0308 ÷ 3031 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0041 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0308 ÷ 0041 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 003A ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0308 ÷ 003A ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 002C ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0308 ÷ 002C ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 002E ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0308 ÷ 002E ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0030 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0308 ÷ 0030 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 005F ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0308 ÷ 005F ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 1F1E6 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 05D0 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0308 ÷ 05D0 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0022 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0308 ÷ 0022 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0027 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0308 ÷ 0027 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 231A ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0308 ÷ 231A ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0020 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0308 ÷ 0020 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 00AD ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0308 × 00AD ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0300 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0308 × 0300 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 200D ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0308 × 200D ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0061 × 2060 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0308 ÷ 0061 × 2060 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0308 ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0308 ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0308 ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0308 ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0308 ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0308 ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0308 ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0308 ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0001 ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0308 ÷ 0001 ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 000D ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0308 ÷ 000D ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 000A ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0308 ÷ 000A ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 000B ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0308 ÷ 000B ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 3031 ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0308 ÷ 3031 ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0041 ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0308 ÷ 0041 ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 003A ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0308 ÷ 003A ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 002C ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0308 ÷ 002C ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 002E ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0308 ÷ 002E ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0030 ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0308 ÷ 0030 ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 005F ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0308 ÷ 005F ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 1F1E6 ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 05D0 ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0308 ÷ 05D0 ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0022 ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0308 ÷ 0022 ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0027 ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0308 ÷ 0027 ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 231A ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0308 ÷ 231A ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0020 ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0308 ÷ 0020 ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 00AD ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0308 × 00AD ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0300 ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0308 × 0300 ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 200D ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0308 × 200D ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0061 × 2060 ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0308 ÷ 0061 × 2060 ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0308 ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0308 ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0308 ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0308 ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0308 ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0308 ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0308 ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0308 ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 3031 ÷ 0001 ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 3031 × 0308 ÷ 0001 ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 3031 ÷ 000D ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 3031 × 0308 ÷ 000D ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 3031 ÷ 000A ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 3031 × 0308 ÷ 000A ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 3031 ÷ 000B ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 3031 × 0308 ÷ 000B ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 3031 × 3031 ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [13.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 3031 × 0308 × 3031 ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] COMBINING DIAERESIS (Extend_FE) × [13.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 3031 ÷ 0041 ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 3031 × 0308 ÷ 0041 ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 3031 ÷ 003A ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 3031 × 0308 ÷ 003A ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 3031 ÷ 002C ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 3031 × 0308 ÷ 002C ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 3031 ÷ 002E ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 3031 × 0308 ÷ 002E ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 3031 ÷ 0030 ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 3031 × 0308 ÷ 0030 ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 3031 × 005F ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [13.1] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 3031 × 0308 × 005F ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] COMBINING DIAERESIS (Extend_FE) × [13.1] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 3031 ÷ 1F1E6 ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 3031 × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 3031 ÷ 05D0 ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 3031 × 0308 ÷ 05D0 ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 3031 ÷ 0022 ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 3031 × 0308 ÷ 0022 ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 3031 ÷ 0027 ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 3031 × 0308 ÷ 0027 ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 3031 ÷ 231A ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 3031 × 0308 ÷ 231A ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 3031 ÷ 0020 ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 3031 × 0308 ÷ 0020 ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 3031 × 00AD ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 3031 × 0308 × 00AD ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 3031 × 0300 ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 3031 × 0308 × 0300 ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 3031 × 200D ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 3031 × 0308 × 200D ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 3031 ÷ 0061 × 2060 ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 3031 × 0308 ÷ 0061 × 2060 ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 3031 ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 3031 × 0308 ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 3031 ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 3031 × 0308 ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 3031 ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 3031 × 0308 ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 3031 ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 3031 × 0308 ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 3031 ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 3031 × 0308 ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 3031 ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 3031 × 0308 ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 3031 ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 3031 × 0308 ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 3031 ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 3031 × 0308 ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0041 ÷ 0001 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 0041 × 0308 ÷ 0001 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 0041 ÷ 000D ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 0041 × 0308 ÷ 000D ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 0041 ÷ 000A ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 0041 × 0308 ÷ 000A ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 0041 ÷ 000B ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 0041 × 0308 ÷ 000B ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 0041 ÷ 3031 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0041 × 0308 ÷ 3031 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0041 × 0041 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [5.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0041 × 0308 × 0041 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [5.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0041 ÷ 003A ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0041 × 0308 ÷ 003A ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0041 ÷ 002C ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0041 × 0308 ÷ 002C ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0041 ÷ 002E ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 0041 × 0308 ÷ 002E ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 0041 × 0030 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [9.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0041 × 0308 × 0030 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [9.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0041 × 005F ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0041 × 0308 × 005F ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [13.1] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0041 ÷ 1F1E6 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 0041 × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 0041 × 05D0 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [5.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0041 × 0308 × 05D0 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [5.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0041 ÷ 0022 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 0041 × 0308 ÷ 0022 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 0041 ÷ 0027 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0041 × 0308 ÷ 0027 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0041 ÷ 231A ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 0041 × 0308 ÷ 231A ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 0041 ÷ 0020 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 0041 × 0308 ÷ 0020 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 0041 × 00AD ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0041 × 0308 × 00AD ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0041 × 0300 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0041 × 0308 × 0300 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0041 × 200D ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 0041 × 0308 × 200D ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 0041 × 0061 × 2060 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [5.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0041 × 0308 × 0061 × 2060 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [5.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0041 × 0061 ÷ 003A ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [5.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0041 × 0308 × 0061 ÷ 003A ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [5.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0041 × 0061 ÷ 0027 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [5.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0041 × 0308 × 0061 ÷ 0027 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [5.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0041 × 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [5.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0041 × 0308 × 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [5.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0041 × 0061 ÷ 002C ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [5.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0041 × 0308 × 0061 ÷ 002C ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [5.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0041 × 0031 ÷ 003A ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [9.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0041 × 0308 × 0031 ÷ 003A ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [9.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0041 × 0031 ÷ 0027 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [9.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0041 × 0308 × 0031 ÷ 0027 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [9.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0041 × 0031 ÷ 002C ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [9.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0041 × 0308 × 0031 ÷ 002C ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [9.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0041 × 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [9.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0041 × 0308 × 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [9.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 003A ÷ 0001 ÷	#  ÷ [0.2] COLON (MidLetter) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 003A × 0308 ÷ 0001 ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 003A ÷ 000D ÷	#  ÷ [0.2] COLON (MidLetter) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 003A × 0308 ÷ 000D ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 003A ÷ 000A ÷	#  ÷ [0.2] COLON (MidLetter) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 003A × 0308 ÷ 000A ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 003A ÷ 000B ÷	#  ÷ [0.2] COLON (MidLetter) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 003A × 0308 ÷ 000B ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 003A ÷ 3031 ÷	#  ÷ [0.2] COLON (MidLetter) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 003A × 0308 ÷ 3031 ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 003A ÷ 0041 ÷	#  ÷ [0.2] COLON (MidLetter) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 003A × 0308 ÷ 0041 ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 003A ÷ 003A ÷	#  ÷ [0.2] COLON (MidLetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 003A × 0308 ÷ 003A ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 003A ÷ 002C ÷	#  ÷ [0.2] COLON (MidLetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 003A × 0308 ÷ 002C ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 003A ÷ 002E ÷	#  ÷ [0.2] COLON (MidLetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 003A × 0308 ÷ 002E ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 003A ÷ 0030 ÷	#  ÷ [0.2] COLON (MidLetter) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 003A × 0308 ÷ 0030 ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 003A ÷ 005F ÷	#  ÷ [0.2] COLON (MidLetter) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 003A × 0308 ÷ 005F ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 003A ÷ 1F1E6 ÷	#  ÷ [0.2] COLON (MidLetter) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 003A × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 003A ÷ 05D0 ÷	#  ÷ [0.2] COLON (MidLetter) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 003A × 0308 ÷ 05D0 ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 003A ÷ 0022 ÷	#  ÷ [0.2] COLON (MidLetter) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 003A × 0308 ÷ 0022 ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 003A ÷ 0027 ÷	#  ÷ [0.2] COLON (MidLetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 003A × 0308 ÷ 0027 ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 003A ÷ 231A ÷	#  ÷ [0.2] COLON (MidLetter) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 003A × 0308 ÷ 231A ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 003A ÷ 0020 ÷	#  ÷ [0.2] COLON (MidLetter) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 003A × 0308 ÷ 0020 ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 003A × 00AD ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 003A × 0308 × 00AD ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 003A × 0300 ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 003A × 0308 × 0300 ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 003A × 200D ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 003A × 0308 × 200D ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 003A ÷ 0061 × 2060 ÷	#  ÷ [0.2] COLON (MidLetter) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 003A × 0308 ÷ 0061 × 2060 ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 003A ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] COLON (MidLetter) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 003A × 0308 ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 003A ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] COLON (MidLetter) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 003A × 0308 ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 003A ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] COLON (MidLetter) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 003A × 0308 ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 003A ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] COLON (MidLetter) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 003A × 0308 ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 003A ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] COLON (MidLetter) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 003A × 0308 ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 003A ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] COLON (MidLetter) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 003A × 0308 ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 003A ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] COLON (MidLetter) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 003A × 0308 ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 003A ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] COLON (MidLetter) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 003A × 0308 ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 002C ÷ 0001 ÷	#  ÷ [0.2] COMMA (MidNum) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 002C × 0308 ÷ 0001 ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 002C ÷ 000D ÷	#  ÷ [0.2] COMMA (MidNum) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 002C × 0308 ÷ 000D ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 002C ÷ 000A ÷	#  ÷ [0.2] COMMA (MidNum) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 002C × 0308 ÷ 000A ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 002C ÷ 000B ÷	#  ÷ [0.2] COMMA (MidNum) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 002C × 0308 ÷ 000B ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 002C ÷ 3031 ÷	#  ÷ [0.2] COMMA (MidNum) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 002C × 0308 ÷ 3031 ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 002C ÷ 0041 ÷	#  ÷ [0.2] COMMA (MidNum) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 002C × 0308 ÷ 0041 ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 002C ÷ 003A ÷	#  ÷ [0.2] COMMA (MidNum) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 002C × 0308 ÷ 003A ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 002C ÷ 002C ÷	#  ÷ [0.2] COMMA (MidNum) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 002C × 0308 ÷ 002C ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 002C ÷ 002E ÷	#  ÷ [0.2] COMMA (MidNum) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 002C × 0308 ÷ 002E ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 002C ÷ 0030 ÷	#  ÷ [0.2] COMMA (MidNum) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 002C × 0308 ÷ 0030 ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 002C ÷ 005F ÷	#  ÷ [0.2] COMMA (MidNum) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 002C × 0308 ÷ 005F ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 002C ÷ 1F1E6 ÷	#  ÷ [0.2] COMMA (MidNum) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 002C × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 002C ÷ 05D0 ÷	#  ÷ [0.2] COMMA (MidNum) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 002C × 0308 ÷ 05D0 ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 002C ÷ 0022 ÷	#  ÷ [0.2] COMMA (MidNum) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 002C × 0308 ÷ 0022 ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 002C ÷ 0027 ÷	#  ÷ [0.2] COMMA (MidNum) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 002C × 0308 ÷ 0027 ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 002C ÷ 231A ÷	#  ÷ [0.2] COMMA (MidNum) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 002C × 0308 ÷ 231A ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 002C ÷ 0020 ÷	#  ÷ [0.2] COMMA (MidNum) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 002C × 0308 ÷ 0020 ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 002C × 00AD ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 002C × 0308 × 00AD ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 002C × 0300 ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 002C × 0308 × 0300 ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 002C × 200D ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 002C × 0308 × 200D ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 002C ÷ 0061 × 2060 ÷	#  ÷ [0.2] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 002C × 0308 ÷ 0061 × 2060 ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 002C ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 002C × 0308 ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 002C ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 002C × 0308 ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 002C ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 002C × 0308 ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 002C ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 002C × 0308 ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 002C ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] COMMA (MidNum) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 002C × 0308 ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 002C ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] COMMA (MidNum) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 002C × 0308 ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 002C ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] COMMA (MidNum) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 002C × 0308 ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 002C ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] COMMA (MidNum) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 002C × 0308 ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 002E ÷ 0001 ÷	#  ÷ [0.2] FULL STOP (MidNumLet) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 002E × 0308 ÷ 0001 ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 002E ÷ 000D ÷	#  ÷ [0.2] FULL STOP (MidNumLet) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 002E × 0308 ÷ 000D ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 002E ÷ 000A ÷	#  ÷ [0.2] FULL STOP (MidNumLet) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 002E × 0308 ÷ 000A ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 002E ÷ 000B ÷	#  ÷ [0.2] FULL STOP (MidNumLet) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 002E × 0308 ÷ 000B ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 002E ÷ 3031 ÷	#  ÷ [0.2] FULL STOP (MidNumLet) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 002E × 0308 ÷ 3031 ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 002E ÷ 0041 ÷	#  ÷ [0.2] FULL STOP (MidNumLet) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 002E × 0308 ÷ 0041 ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 002E ÷ 003A ÷	#  ÷ [0.2] FULL STOP (MidNumLet) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 002E × 0308 ÷ 003A ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 002E ÷ 002C ÷	#  ÷ [0.2] FULL STOP (MidNumLet) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 002E × 0308 ÷ 002C ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 002E ÷ 002E ÷	#  ÷ [0.2] FULL STOP (MidNumLet) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 002E × 0308 ÷ 002E ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 002E ÷ 0030 ÷	#  ÷ [0.2] FULL STOP (MidNumLet) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 002E × 0308 ÷ 0030 ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 002E ÷ 005F ÷	#  ÷ [0.2] FULL STOP (MidNumLet) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 002E × 0308 ÷ 005F ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 002E ÷ 1F1E6 ÷	#  ÷ [0.2] FULL STOP (MidNumLet) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 002E × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 002E ÷ 05D0 ÷	#  ÷ [0.2] FULL STOP (MidNumLet) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 002E × 0308 ÷ 05D0 ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 002E ÷ 0022 ÷	#  ÷ [0.2] FULL STOP (MidNumLet) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 002E × 0308 ÷ 0022 ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 002E ÷ 0027 ÷	#  ÷ [0.2] FULL STOP (MidNumLet) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 002E × 0308 ÷ 0027 ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 002E ÷ 231A ÷	#  ÷ [0.2] FULL STOP (MidNumLet) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 002E × 0308 ÷ 231A ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 002E ÷ 0020 ÷	#  ÷ [0.2] FULL STOP (MidNumLet) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 002E × 0308 ÷ 0020 ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 002E × 00AD ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 002E × 0308 × 00AD ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 002E × 0300 ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 002E × 0308 × 0300 ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 002E × 200D ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 002E × 0308 × 200D ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 002E ÷ 0061 × 2060 ÷	#  ÷ [0.2] FULL STOP (MidNumLet) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 002E × 0308 ÷ 0061 × 2060 ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 002E ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] FULL STOP (MidNumLet) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 002E × 0308 ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 002E ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] FULL STOP (MidNumLet) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 002E × 0308 ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 002E ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] FULL STOP (MidNumLet) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 002E × 0308 ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 002E ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] FULL STOP (MidNumLet) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 002E × 0308 ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 002E ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] FULL STOP (MidNumLet) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 002E × 0308 ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 002E ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] FULL STOP (MidNumLet) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 002E × 0308 ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 002E ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] FULL STOP (MidNumLet) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 002E × 0308 ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 002E ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] FULL STOP (MidNumLet) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 002E × 0308 ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0030 ÷ 0001 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 0030 × 0308 ÷ 0001 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 0030 ÷ 000D ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 0030 × 0308 ÷ 000D ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 0030 ÷ 000A ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 0030 × 0308 ÷ 000A ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 0030 ÷ 000B ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 0030 × 0308 ÷ 000B ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 0030 ÷ 3031 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0030 × 0308 ÷ 3031 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0030 × 0041 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [10.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0030 × 0308 × 0041 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] COMBINING DIAERESIS (Extend_FE) × [10.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0030 ÷ 003A ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0030 × 0308 ÷ 003A ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0030 ÷ 002C ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0030 × 0308 ÷ 002C ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0030 ÷ 002E ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 0030 × 0308 ÷ 002E ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 0030 × 0030 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [8.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0030 × 0308 × 0030 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] COMBINING DIAERESIS (Extend_FE) × [8.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0030 × 005F ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [13.1] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0030 × 0308 × 005F ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] COMBINING DIAERESIS (Extend_FE) × [13.1] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0030 ÷ 1F1E6 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 0030 × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 0030 × 05D0 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [10.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0030 × 0308 × 05D0 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] COMBINING DIAERESIS (Extend_FE) × [10.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0030 ÷ 0022 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 0030 × 0308 ÷ 0022 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 0030 ÷ 0027 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0030 × 0308 ÷ 0027 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0030 ÷ 231A ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 0030 × 0308 ÷ 231A ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 0030 ÷ 0020 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 0030 × 0308 ÷ 0020 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 0030 × 00AD ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0030 × 0308 × 00AD ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0030 × 0300 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0030 × 0308 × 0300 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0030 × 200D ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 0030 × 0308 × 200D ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 0030 × 0061 × 2060 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [10.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0030 × 0308 × 0061 × 2060 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] COMBINING DIAERESIS (Extend_FE) × [10.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0030 × 0061 ÷ 003A ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [10.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0030 × 0308 × 0061 ÷ 003A ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] COMBINING DIAERESIS (Extend_FE) × [10.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0030 × 0061 ÷ 0027 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [10.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0030 × 0308 × 0061 ÷ 0027 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] COMBINING DIAERESIS (Extend_FE) × [10.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0030 × 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [10.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0030 × 0308 × 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] COMBINING DIAERESIS (Extend_FE) × [10.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0030 × 0061 ÷ 002C ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [10.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0030 × 0308 × 0061 ÷ 002C ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] COMBINING DIAERESIS (Extend_FE) × [10.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0030 × 0031 ÷ 003A ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [8.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0030 × 0308 × 0031 ÷ 003A ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] COMBINING DIAERESIS (Extend_FE) × [8.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0030 × 0031 ÷ 0027 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [8.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0030 × 0308 × 0031 ÷ 0027 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] COMBINING DIAERESIS (Extend_FE) × [8.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0030 × 0031 ÷ 002C ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [8.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0030 × 0308 × 0031 ÷ 002C ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] COMBINING DIAERESIS (Extend_FE) × [8.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0030 × 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [8.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0030 × 0308 × 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] COMBINING DIAERESIS (Extend_FE) × [8.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 005F ÷ 0001 ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 005F × 0308 ÷ 0001 ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 005F ÷ 000D ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 005F × 0308 ÷ 000D ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 005F ÷ 000A ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 005F × 0308 ÷ 000A ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 005F ÷ 000B ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 005F × 0308 ÷ 000B ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 005F × 3031 ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [13.2] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 005F × 0308 × 3031 ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) × [13.2] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 005F × 0041 ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [13.2] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 005F × 0308 × 0041 ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) × [13.2] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 005F ÷ 003A ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 005F × 0308 ÷ 003A ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 005F ÷ 002C ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 005F × 0308 ÷ 002C ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 005F ÷ 002E ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 005F × 0308 ÷ 002E ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 005F × 0030 ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [13.2] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 005F × 0308 × 0030 ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) × [13.2] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 005F × 005F ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [13.1] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 005F × 0308 × 005F ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) × [13.1] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 005F ÷ 1F1E6 ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 005F × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 005F × 05D0 ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [13.2] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 005F × 0308 × 05D0 ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) × [13.2] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 005F ÷ 0022 ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 005F × 0308 ÷ 0022 ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 005F ÷ 0027 ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 005F × 0308 ÷ 0027 ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 005F ÷ 231A ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 005F × 0308 ÷ 231A ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 005F ÷ 0020 ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 005F × 0308 ÷ 0020 ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 005F × 00AD ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 005F × 0308 × 00AD ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 005F × 0300 ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 005F × 0308 × 0300 ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 005F × 200D ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 005F × 0308 × 200D ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 005F × 0061 × 2060 ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 005F × 0308 × 0061 × 2060 ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) × [13.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 005F × 0061 ÷ 003A ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 005F × 0308 × 0061 ÷ 003A ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 005F × 0061 ÷ 0027 ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 005F × 0308 × 0061 ÷ 0027 ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 005F × 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 005F × 0308 × 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 005F × 0061 ÷ 002C ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 005F × 0308 × 0061 ÷ 002C ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 005F × 0031 ÷ 003A ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 005F × 0308 × 0031 ÷ 003A ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 005F × 0031 ÷ 0027 ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 005F × 0308 × 0031 ÷ 0027 ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 005F × 0031 ÷ 002C ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 005F × 0308 × 0031 ÷ 002C ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 005F × 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 005F × 0308 × 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 1F1E6 ÷ 0001 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 0308 ÷ 0001 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 1F1E6 ÷ 000D ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 0308 ÷ 000D ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 1F1E6 ÷ 000A ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 0308 ÷ 000A ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 1F1E6 ÷ 000B ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 0308 ÷ 000B ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 1F1E6 ÷ 3031 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 0308 ÷ 3031 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 1F1E6 ÷ 0041 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 0308 ÷ 0041 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 1F1E6 ÷ 003A ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 0308 ÷ 003A ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 1F1E6 ÷ 002C ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 0308 ÷ 002C ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 1F1E6 ÷ 002E ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 0308 ÷ 002E ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 1F1E6 ÷ 0030 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 0308 ÷ 0030 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 1F1E6 ÷ 005F ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 0308 ÷ 005F ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 1F1E6 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [15.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 0308 × 1F1E6 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] COMBINING DIAERESIS (Extend_FE) × [15.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 1F1E6 ÷ 05D0 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 0308 ÷ 05D0 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 1F1E6 ÷ 0022 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 0308 ÷ 0022 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 1F1E6 ÷ 0027 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 0308 ÷ 0027 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 1F1E6 ÷ 231A ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 0308 ÷ 231A ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 1F1E6 ÷ 0020 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 0308 ÷ 0020 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 00AD ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 0308 × 00AD ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 0300 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 0308 × 0300 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 200D ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 0308 × 200D ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 1F1E6 ÷ 0061 × 2060 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 0308 ÷ 0061 × 2060 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 1F1E6 ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 0308 ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 1F1E6 ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 0308 ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 1F1E6 ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 0308 ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 1F1E6 ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 0308 ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 1F1E6 ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 0308 ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 1F1E6 ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 0308 ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 1F1E6 ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 0308 ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 1F1E6 ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 0308 ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 05D0 ÷ 0001 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0308 ÷ 0001 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 05D0 ÷ 000D ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0308 ÷ 000D ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 05D0 ÷ 000A ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0308 ÷ 000A ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 05D0 ÷ 000B ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0308 ÷ 000B ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 05D0 ÷ 3031 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0308 ÷ 3031 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0041 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [5.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0308 × 0041 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [5.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 05D0 ÷ 003A ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0308 ÷ 003A ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 05D0 ÷ 002C ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0308 ÷ 002C ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 05D0 ÷ 002E ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0308 ÷ 002E ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0030 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [9.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0308 × 0030 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [9.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 05D0 × 005F ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [13.1] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0308 × 005F ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [13.1] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 05D0 ÷ 1F1E6 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 05D0 × 05D0 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [5.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0308 × 05D0 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [5.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 05D0 ÷ 0022 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0308 ÷ 0022 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0027 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [7.1] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0308 × 0027 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [7.1] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 05D0 ÷ 231A ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0308 ÷ 231A ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 05D0 ÷ 0020 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0308 ÷ 0020 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 05D0 × 00AD ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0308 × 00AD ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0300 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0308 × 0300 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 05D0 × 200D ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0308 × 200D ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0061 × 2060 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [5.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0308 × 0061 × 2060 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [5.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0061 ÷ 003A ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [5.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0308 × 0061 ÷ 003A ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [5.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0061 ÷ 0027 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [5.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0308 × 0061 ÷ 0027 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [5.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [5.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0308 × 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [5.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0061 ÷ 002C ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [5.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0308 × 0061 ÷ 002C ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [5.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0031 ÷ 003A ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [9.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0308 × 0031 ÷ 003A ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [9.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0031 ÷ 0027 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [9.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0308 × 0031 ÷ 0027 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [9.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0031 ÷ 002C ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [9.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0308 × 0031 ÷ 002C ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [9.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [9.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0308 × 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [9.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0022 ÷ 0001 ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 0022 × 0308 ÷ 0001 ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 0022 ÷ 000D ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 0022 × 0308 ÷ 000D ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 0022 ÷ 000A ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 0022 × 0308 ÷ 000A ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 0022 ÷ 000B ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 0022 × 0308 ÷ 000B ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 0022 ÷ 3031 ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0022 × 0308 ÷ 3031 ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0022 ÷ 0041 ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0022 × 0308 ÷ 0041 ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0022 ÷ 003A ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0022 × 0308 ÷ 003A ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0022 ÷ 002C ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0022 × 0308 ÷ 002C ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0022 ÷ 002E ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 0022 × 0308 ÷ 002E ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 0022 ÷ 0030 ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0022 × 0308 ÷ 0030 ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0022 ÷ 005F ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0022 × 0308 ÷ 005F ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0022 ÷ 1F1E6 ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 0022 × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 0022 ÷ 05D0 ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0022 × 0308 ÷ 05D0 ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0022 ÷ 0022 ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 0022 × 0308 ÷ 0022 ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 0022 ÷ 0027 ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0022 × 0308 ÷ 0027 ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0022 ÷ 231A ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 0022 × 0308 ÷ 231A ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 0022 ÷ 0020 ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 0022 × 0308 ÷ 0020 ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 0022 × 00AD ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0022 × 0308 × 00AD ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0022 × 0300 ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0022 × 0308 × 0300 ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0022 × 200D ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 0022 × 0308 × 200D ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 0022 ÷ 0061 × 2060 ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0022 × 0308 ÷ 0061 × 2060 ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0022 ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0022 × 0308 ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0022 ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0022 × 0308 ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0022 ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0022 × 0308 ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0022 ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0022 × 0308 ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0022 ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0022 × 0308 ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0022 ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0022 × 0308 ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0022 ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0022 × 0308 ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0022 ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0022 × 0308 ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0027 ÷ 0001 ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 0027 × 0308 ÷ 0001 ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 0027 ÷ 000D ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 0027 × 0308 ÷ 000D ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 0027 ÷ 000A ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 0027 × 0308 ÷ 000A ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 0027 ÷ 000B ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 0027 × 0308 ÷ 000B ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 0027 ÷ 3031 ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0027 × 0308 ÷ 3031 ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0027 ÷ 0041 ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0027 × 0308 ÷ 0041 ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0027 ÷ 003A ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0027 × 0308 ÷ 003A ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0027 ÷ 002C ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0027 × 0308 ÷ 002C ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0027 ÷ 002E ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 0027 × 0308 ÷ 002E ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 0027 ÷ 0030 ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0027 × 0308 ÷ 0030 ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0027 ÷ 005F ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0027 × 0308 ÷ 005F ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0027 ÷ 1F1E6 ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 0027 × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 0027 ÷ 05D0 ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0027 × 0308 ÷ 05D0 ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0027 ÷ 0022 ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 0027 × 0308 ÷ 0022 ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 0027 ÷ 0027 ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0027 × 0308 ÷ 0027 ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0027 ÷ 231A ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 0027 × 0308 ÷ 231A ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 0027 ÷ 0020 ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 0027 × 0308 ÷ 0020 ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 0027 × 00AD ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0027 × 0308 × 00AD ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0027 × 0300 ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0027 × 0308 × 0300 ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0027 × 200D ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 0027 × 0308 × 200D ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 0027 ÷ 0061 × 2060 ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0027 × 0308 ÷ 0061 × 2060 ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0027 ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0027 × 0308 ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0027 ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0027 × 0308 ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0027 ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0027 × 0308 ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0027 ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0027 × 0308 ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0027 ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0027 × 0308 ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0027 ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0027 × 0308 ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0027 ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0027 × 0308 ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0027 ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0027 × 0308 ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 231A ÷ 0001 ÷	#  ÷ [0.2] WATCH (ExtPict) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 231A × 0308 ÷ 0001 ÷	#  ÷ [0.2] WATCH (ExtPict) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 231A ÷ 000D ÷	#  ÷ [0.2] WATCH (ExtPict) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 231A × 0308 ÷ 000D ÷	#  ÷ [0.2] WATCH (ExtPict) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 231A ÷ 000A ÷	#  ÷ [0.2] WATCH (ExtPict) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 231A × 0308 ÷ 000A ÷	#  ÷ [0.2] WATCH (ExtPict) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 231A ÷ 000B ÷	#  ÷ [0.2] WATCH (ExtPict) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 231A × 0308 ÷ 000B ÷	#  ÷ [0.2] WATCH (ExtPict) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 231A ÷ 3031 ÷	#  ÷ [0.2] WATCH (ExtPict) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 231A × 0308 ÷ 3031 ÷	#  ÷ [0.2] WATCH (ExtPict) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 231A ÷ 0041 ÷	#  ÷ [0.2] WATCH (ExtPict) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 231A × 0308 ÷ 0041 ÷	#  ÷ [0.2] WATCH (ExtPict) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 231A ÷ 003A ÷	#  ÷ [0.2] WATCH (ExtPict) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 231A × 0308 ÷ 003A ÷	#  ÷ [0.2] WATCH (ExtPict) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 231A ÷ 002C ÷	#  ÷ [0.2] WATCH (ExtPict) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 231A × 0308 ÷ 002C ÷	#  ÷ [0.2] WATCH (ExtPict) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 231A ÷ 002E ÷	#  ÷ [0.2] WATCH (ExtPict) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 231A × 0308 ÷ 002E ÷	#  ÷ [0.2] WATCH (ExtPict) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 231A ÷ 0030 ÷	#  ÷ [0.2] WATCH (ExtPict) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 231A × 0308 ÷ 0030 ÷	#  ÷ [0.2] WATCH (ExtPict) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 231A ÷ 005F ÷	#  ÷ [0.2] WATCH (ExtPict) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 231A × 0308 ÷ 005F ÷	#  ÷ [0.2] WATCH (ExtPict) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 231A ÷ 1F1E6 ÷	#  ÷ [0.2] WATCH (ExtPict) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 231A × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] WATCH (ExtPict) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 231A ÷ 05D0 ÷	#  ÷ [0.2] WATCH (ExtPict) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 231A × 0308 ÷ 05D0 ÷	#  ÷ [0.2] WATCH (ExtPict) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 231A ÷ 0022 ÷	#  ÷ [0.2] WATCH (ExtPict) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 231A × 0308 ÷ 0022 ÷	#  ÷ [0.2] WATCH (ExtPict) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 231A ÷ 0027 ÷	#  ÷ [0.2] WATCH (ExtPict) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 231A × 0308 ÷ 0027 ÷	#  ÷ [0.2] WATCH (ExtPict) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 231A ÷ 231A ÷	#  ÷ [0.2] WATCH (ExtPict) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 231A × 0308 ÷ 231A ÷	#  ÷ [0.2] WATCH (ExtPict) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 231A ÷ 0020 ÷	#  ÷ [0.2] WATCH (ExtPict) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 231A × 0308 ÷ 0020 ÷	#  ÷ [0.2] WATCH (ExtPict) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 231A × 00AD ÷	#  ÷ [0.2] WATCH (ExtPict) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 231A × 0308 × 00AD ÷	#  ÷ [0.2] WATCH (ExtPict) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 231A × 0300 ÷	#  ÷ [0.2] WATCH (ExtPict) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 231A × 0308 × 0300 ÷	#  ÷ [0.2] WATCH (ExtPict) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 231A × 200D ÷	#  ÷ [0.2] WATCH (ExtPict) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 231A × 0308 × 200D ÷	#  ÷ [0.2] WATCH (ExtPict) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 231A ÷ 0061 × 2060 ÷	#  ÷ [0.2] WATCH (ExtPict) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 231A × 0308 ÷ 0061 × 2060 ÷	#  ÷ [0.2] WATCH (ExtPict) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 231A ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] WATCH (ExtPict) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 231A × 0308 ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] WATCH (ExtPict) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 231A ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] WATCH (ExtPict) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 231A × 0308 ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] WATCH (ExtPict) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 231A ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] WATCH (ExtPict) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 231A × 0308 ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] WATCH (ExtPict) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 231A ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] WATCH (ExtPict) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 231A × 0308 ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] WATCH (ExtPict) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 231A ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] WATCH (ExtPict) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 231A × 0308 ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] WATCH (ExtPict) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 231A ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] WATCH (ExtPict) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 231A × 0308 ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] WATCH (ExtPict) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 231A ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] WATCH (ExtPict) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 231A × 0308 ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] WATCH (ExtPict) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 231A ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] WATCH (ExtPict) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 231A × 0308 ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] WATCH (ExtPict) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0020 ÷ 0001 ÷	#  ÷ [0.2] SPACE (WSegSpace) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 0020 × 0308 ÷ 0001 ÷	#  ÷ [0.2] SPACE (WSegSpace) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 0020 ÷ 000D ÷	#  ÷ [0.2] SPACE (WSegSpace) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 0020 × 0308 ÷ 000D ÷	#  ÷ [0.2] SPACE (WSegSpace) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 0020 ÷ 000A ÷	#  ÷ [0.2] SPACE (WSegSpace) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 0020 × 0308 ÷ 000A ÷	#  ÷ [0.2] SPACE (WSegSpace) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 0020 ÷ 000B ÷	#  ÷ [0.2] SPACE (WSegSpace) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 0020 × 0308 ÷ 000B ÷	#  ÷ [0.2] SPACE (WSegSpace) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 0020 ÷ 3031 ÷	#  ÷ [0.2] SPACE (WSegSpace) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0020 × 0308 ÷ 3031 ÷	#  ÷ [0.2] SPACE (WSegSpace) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0020 ÷ 0041 ÷	#  ÷ [0.2] SPACE (WSegSpace) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0020 × 0308 ÷ 0041 ÷	#  ÷ [0.2] SPACE (WSegSpace) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0020 ÷ 003A ÷	#  ÷ [0.2] SPACE (WSegSpace) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0020 × 0308 ÷ 003A ÷	#  ÷ [0.2] SPACE (WSegSpace) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0020 ÷ 002C ÷	#  ÷ [0.2] SPACE (WSegSpace) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0020 × 0308 ÷ 002C ÷	#  ÷ [0.2] SPACE (WSegSpace) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0020 ÷ 002E ÷	#  ÷ [0.2] SPACE (WSegSpace) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 0020 × 0308 ÷ 002E ÷	#  ÷ [0.2] SPACE (WSegSpace) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 0020 ÷ 0030 ÷	#  ÷ [0.2] SPACE (WSegSpace) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0020 × 0308 ÷ 0030 ÷	#  ÷ [0.2] SPACE (WSegSpace) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0020 ÷ 005F ÷	#  ÷ [0.2] SPACE (WSegSpace) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0020 × 0308 ÷ 005F ÷	#  ÷ [0.2] SPACE (WSegSpace) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0020 ÷ 1F1E6 ÷	#  ÷ [0.2] SPACE (WSegSpace) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 0020 × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] SPACE (WSegSpace) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 0020 ÷ 05D0 ÷	#  ÷ [0.2] SPACE (WSegSpace) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0020 × 0308 ÷ 05D0 ÷	#  ÷ [0.2] SPACE (WSegSpace) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0020 ÷ 0022 ÷	#  ÷ [0.2] SPACE (WSegSpace) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 0020 × 0308 ÷ 0022 ÷	#  ÷ [0.2] SPACE (WSegSpace) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 0020 ÷ 0027 ÷	#  ÷ [0.2] SPACE (WSegSpace) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0020 × 0308 ÷ 0027 ÷	#  ÷ [0.2] SPACE (WSegSpace) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0020 ÷ 231A ÷	#  ÷ [0.2] SPACE (WSegSpace) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 0020 × 0308 ÷ 231A ÷	#  ÷ [0.2] SPACE (WSegSpace) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 0020 × 0020 ÷	#  ÷ [0.2] SPACE (WSegSpace) × [3.4] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 0020 × 0308 ÷ 0020 ÷	#  ÷ [0.2] SPACE (WSegSpace) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 0020 × 00AD ÷	#  ÷ [0.2] SPACE (WSegSpace) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0020 × 0308 × 00AD ÷	#  ÷ [0.2] SPACE (WSegSpace) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0020 × 0300 ÷	#  ÷ [0.2] SPACE (WSegSpace) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0020 × 0308 × 0300 ÷	#  ÷ [0.2] SPACE (WSegSpace) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0020 × 200D ÷	#  ÷ [0.2] SPACE (WSegSpace) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 0020 × 0308 × 200D ÷	#  ÷ [0.2] SPACE (WSegSpace) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 0020 ÷ 0061 × 2060 ÷	#  ÷ [0.2] SPACE (WSegSpace) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0020 × 0308 ÷ 0061 × 2060 ÷	#  ÷ [0.2] SPACE (WSegSpace) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0020 ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] SPACE (WSegSpace) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0020 × 0308 ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] SPACE (WSegSpace) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0020 ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] SPACE (WSegSpace) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0020 × 0308 ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] SPACE (WSegSpace) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0020 ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] SPACE (WSegSpace) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0020 × 0308 ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] SPACE (WSegSpace) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0020 ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] SPACE (WSegSpace) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0020 × 0308 ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] SPACE (WSegSpace) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0020 ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] SPACE (WSegSpace) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0020 × 0308 ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] SPACE (WSegSpace) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0020 ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] SPACE (WSegSpace) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0020 × 0308 ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] SPACE (WSegSpace) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0020 ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] SPACE (WSegSpace) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0020 × 0308 ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] SPACE (WSegSpace) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0020 ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] SPACE (WSegSpace) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0020 × 0308 ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] SPACE (WSegSpace) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 00AD ÷ 0001 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 00AD × 0308 ÷ 0001 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 00AD ÷ 000D ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 00AD × 0308 ÷ 000D ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 00AD ÷ 000A ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 00AD × 0308 ÷ 000A ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 00AD ÷ 000B ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 00AD × 0308 ÷ 000B ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 00AD ÷ 3031 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 00AD × 0308 ÷ 3031 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 00AD ÷ 0041 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 00AD × 0308 ÷ 0041 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 00AD ÷ 003A ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 00AD × 0308 ÷ 003A ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 00AD ÷ 002C ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 00AD × 0308 ÷ 002C ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 00AD ÷ 002E ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 00AD × 0308 ÷ 002E ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 00AD ÷ 0030 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 00AD × 0308 ÷ 0030 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 00AD ÷ 005F ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 00AD × 0308 ÷ 005F ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 00AD ÷ 1F1E6 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 00AD × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 00AD ÷ 05D0 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 00AD × 0308 ÷ 05D0 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 00AD ÷ 0022 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 00AD × 0308 ÷ 0022 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 00AD ÷ 0027 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 00AD × 0308 ÷ 0027 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 00AD ÷ 231A ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 00AD × 0308 ÷ 231A ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 00AD ÷ 0020 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 00AD × 0308 ÷ 0020 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 00AD × 00AD ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 00AD × 0308 × 00AD ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 00AD × 0300 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 00AD × 0308 × 0300 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 00AD × 200D ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 00AD × 0308 × 200D ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 00AD ÷ 0061 × 2060 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 00AD × 0308 ÷ 0061 × 2060 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 00AD ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 00AD × 0308 ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 00AD ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 00AD × 0308 ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 00AD ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 00AD × 0308 ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 00AD ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 00AD × 0308 ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 00AD ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 00AD × 0308 ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 00AD ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 00AD × 0308 ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 00AD ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 00AD × 0308 ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 00AD ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 00AD × 0308 ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0300 ÷ 0001 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 0300 × 0308 ÷ 0001 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 0300 ÷ 000D ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 0300 × 0308 ÷ 000D ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 0300 ÷ 000A ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 0300 × 0308 ÷ 000A ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 0300 ÷ 000B ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 0300 × 0308 ÷ 000B ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 0300 ÷ 3031 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0300 × 0308 ÷ 3031 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0300 ÷ 0041 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0300 × 0308 ÷ 0041 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0300 ÷ 003A ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0300 × 0308 ÷ 003A ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0300 ÷ 002C ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0300 × 0308 ÷ 002C ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0300 ÷ 002E ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 0300 × 0308 ÷ 002E ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 0300 ÷ 0030 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0300 × 0308 ÷ 0030 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0300 ÷ 005F ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0300 × 0308 ÷ 005F ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0300 ÷ 1F1E6 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 0300 × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 0300 ÷ 05D0 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0300 × 0308 ÷ 05D0 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0300 ÷ 0022 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 0300 × 0308 ÷ 0022 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 0300 ÷ 0027 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0300 × 0308 ÷ 0027 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0300 ÷ 231A ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 0300 × 0308 ÷ 231A ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 0300 ÷ 0020 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 0300 × 0308 ÷ 0020 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 0300 × 00AD ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0300 × 0308 × 00AD ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0300 × 0300 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0300 × 0308 × 0300 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0300 × 200D ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 0300 × 0308 × 200D ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 0300 ÷ 0061 × 2060 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0300 × 0308 ÷ 0061 × 2060 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0300 ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0300 × 0308 ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0300 ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0300 × 0308 ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0300 ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0300 × 0308 ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0300 ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0300 × 0308 ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0300 ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0300 × 0308 ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0300 ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0300 × 0308 ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0300 ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0300 × 0308 ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0300 ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0300 × 0308 ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 200D ÷ 0001 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 200D × 0308 ÷ 0001 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 200D ÷ 000D ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 200D × 0308 ÷ 000D ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 200D ÷ 000A ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 200D × 0308 ÷ 000A ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 200D ÷ 000B ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 200D × 0308 ÷ 000B ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 200D ÷ 3031 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 200D × 0308 ÷ 3031 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 200D ÷ 0041 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 200D × 0308 ÷ 0041 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 200D ÷ 003A ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 200D × 0308 ÷ 003A ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 200D ÷ 002C ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 200D × 0308 ÷ 002C ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 200D ÷ 002E ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 200D × 0308 ÷ 002E ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 200D ÷ 0030 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 200D × 0308 ÷ 0030 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 200D ÷ 005F ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 200D × 0308 ÷ 005F ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 200D ÷ 1F1E6 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 200D × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 200D ÷ 05D0 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 200D × 0308 ÷ 05D0 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 200D ÷ 0022 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 200D × 0308 ÷ 0022 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 200D ÷ 0027 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 200D × 0308 ÷ 0027 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 200D × 231A ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [3.3] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 200D × 0308 ÷ 231A ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 200D ÷ 0020 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 200D × 0308 ÷ 0020 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 200D × 00AD ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 200D × 0308 × 00AD ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 200D × 0300 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 200D × 0308 × 0300 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 200D × 200D ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 200D × 0308 × 200D ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 200D ÷ 0061 × 2060 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 200D × 0308 ÷ 0061 × 2060 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 200D ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 200D × 0308 ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 200D ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 200D × 0308 ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 200D ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 200D × 0308 ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 200D ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 200D × 0308 ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 200D ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 200D × 0308 ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 200D ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 200D × 0308 ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 200D ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 200D × 0308 ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 200D ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 200D × 0308 ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 ÷ 0001 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0308 ÷ 0001 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 ÷ 000D ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0308 ÷ 000D ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 ÷ 000A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0308 ÷ 000A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 ÷ 000B ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0308 ÷ 000B ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 ÷ 3031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0308 ÷ 3031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0041 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [5.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0308 × 0041 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [5.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 ÷ 003A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0308 ÷ 003A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 ÷ 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0308 ÷ 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 ÷ 002E ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0308 ÷ 002E ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0030 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [9.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0308 × 0030 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [9.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 005F ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [13.1] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0308 × 005F ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [13.1] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 ÷ 1F1E6 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 05D0 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [5.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0308 × 05D0 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [5.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 ÷ 0022 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0308 ÷ 0022 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 ÷ 0027 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0308 ÷ 0027 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 ÷ 231A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0308 ÷ 231A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 ÷ 0020 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0308 ÷ 0020 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 00AD ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0308 × 00AD ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0300 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0308 × 0300 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 200D ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0308 × 200D ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0061 × 2060 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [5.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0308 × 0061 × 2060 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [5.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0061 ÷ 003A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [5.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0308 × 0061 ÷ 003A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [5.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0061 ÷ 0027 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [5.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0308 × 0061 ÷ 0027 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [5.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [5.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0308 × 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [5.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0061 ÷ 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [5.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0308 × 0061 ÷ 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [5.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0031 ÷ 003A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [9.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0308 × 0031 ÷ 003A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [9.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0031 ÷ 0027 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [9.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0308 × 0031 ÷ 0027 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [9.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0031 ÷ 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [9.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0308 × 0031 ÷ 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [9.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [9.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0308 × 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [9.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A ÷ 0001 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A × 0308 ÷ 0001 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A ÷ 000D ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A × 0308 ÷ 000D ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A ÷ 000A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A × 0308 ÷ 000A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A ÷ 000B ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A × 0308 ÷ 000B ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A ÷ 3031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A × 0308 ÷ 3031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0061 × 003A × 0041 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] COLON (MidLetter) × [7.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 003A × 0308 × 0041 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [7.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A ÷ 003A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A × 0308 ÷ 003A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A ÷ 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A × 0308 ÷ 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A ÷ 002E ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A × 0308 ÷ 002E ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A ÷ 0030 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A × 0308 ÷ 0030 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A ÷ 005F ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A × 0308 ÷ 005F ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A ÷ 1F1E6 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 0061 × 003A × 05D0 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] COLON (MidLetter) × [7.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0061 × 003A × 0308 × 05D0 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [7.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A ÷ 0022 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A × 0308 ÷ 0022 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A ÷ 0027 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A × 0308 ÷ 0027 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A ÷ 231A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A × 0308 ÷ 231A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A ÷ 0020 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A × 0308 ÷ 0020 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A × 00AD ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A × 0308 × 00AD ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A × 0300 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A × 0308 × 0300 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A × 200D ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A × 0308 × 200D ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 0061 × 003A × 0061 × 2060 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] COLON (MidLetter) × [7.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 × 003A × 0308 × 0061 × 2060 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [7.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 × 003A × 0061 ÷ 003A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] COLON (MidLetter) × [7.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 003A × 0308 × 0061 ÷ 003A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [7.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 003A × 0061 ÷ 0027 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] COLON (MidLetter) × [7.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 × 003A × 0308 × 0061 ÷ 0027 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [7.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 × 003A × 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] COLON (MidLetter) × [7.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 × 003A × 0308 × 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [7.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 × 003A × 0061 ÷ 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] COLON (MidLetter) × [7.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0061 × 003A × 0308 × 0061 ÷ 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [7.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A × 0308 ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A × 0308 ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A × 0308 ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A × 0308 ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 ÷ 0001 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 0308 ÷ 0001 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 ÷ 000D ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 0308 ÷ 000D ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 ÷ 000A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 0308 ÷ 000A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 ÷ 000B ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 0308 ÷ 000B ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 ÷ 3031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 0308 ÷ 3031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0061 × 0027 × 0041 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] APOSTROPHE (Single_Quote) × [7.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 0027 × 0308 × 0041 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) × [7.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 ÷ 003A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 0308 ÷ 003A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 ÷ 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 0308 ÷ 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 ÷ 002E ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 0308 ÷ 002E ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 ÷ 0030 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 0308 ÷ 0030 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 ÷ 005F ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 0308 ÷ 005F ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 ÷ 1F1E6 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 0061 × 0027 × 05D0 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] APOSTROPHE (Single_Quote) × [7.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0061 × 0027 × 0308 × 05D0 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) × [7.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 ÷ 0022 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 0308 ÷ 0022 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 ÷ 0027 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 0308 ÷ 0027 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 ÷ 231A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 0308 ÷ 231A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 ÷ 0020 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 0308 ÷ 0020 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 00AD ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 0308 × 00AD ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 0300 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 0308 × 0300 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 200D ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 0308 × 200D ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 0061 × 0027 × 0061 × 2060 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] APOSTROPHE (Single_Quote) × [7.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 × 0027 × 0308 × 0061 × 2060 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) × [7.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 × 0027 × 0061 ÷ 003A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] APOSTROPHE (Single_Quote) × [7.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 0027 × 0308 × 0061 ÷ 003A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) × [7.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 0027 × 0061 ÷ 0027 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] APOSTROPHE (Single_Quote) × [7.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 × 0027 × 0308 × 0061 ÷ 0027 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) × [7.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 × 0027 × 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] APOSTROPHE (Single_Quote) × [7.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 × 0027 × 0308 × 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) × [7.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 × 0027 × 0061 ÷ 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] APOSTROPHE (Single_Quote) × [7.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0061 × 0027 × 0308 × 0061 ÷ 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) × [7.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 0308 ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 0308 ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 0308 ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 0308 ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 ÷ 0001 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 × 0308 ÷ 0001 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 ÷ 000D ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 × 0308 ÷ 000D ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 ÷ 000A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 × 0308 ÷ 000A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 ÷ 000B ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 × 0308 ÷ 000B ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 ÷ 3031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 × 0308 ÷ 3031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0061 × 0027 × 2060 × 0041 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [7.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 0027 × 2060 × 0308 × 0041 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [7.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 ÷ 003A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 × 0308 ÷ 003A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 ÷ 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 × 0308 ÷ 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 ÷ 002E ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 × 0308 ÷ 002E ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 ÷ 0030 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 × 0308 ÷ 0030 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 ÷ 005F ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 × 0308 ÷ 005F ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 ÷ 1F1E6 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 0061 × 0027 × 2060 × 05D0 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [7.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0061 × 0027 × 2060 × 0308 × 05D0 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [7.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 ÷ 0022 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 × 0308 ÷ 0022 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 ÷ 0027 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 × 0308 ÷ 0027 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 ÷ 231A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 × 0308 ÷ 231A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 ÷ 0020 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 × 0308 ÷ 0020 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 × 00AD ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 × 0308 × 00AD ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 × 0300 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 × 0308 × 0300 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 × 200D ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 × 0308 × 200D ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 0061 × 0027 × 2060 × 0061 × 2060 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [7.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 × 0027 × 2060 × 0308 × 0061 × 2060 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [7.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 × 0027 × 2060 × 0061 ÷ 003A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [7.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 0027 × 2060 × 0308 × 0061 ÷ 003A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [7.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 0027 × 2060 × 0061 ÷ 0027 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [7.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 × 0027 × 2060 × 0308 × 0061 ÷ 0027 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [7.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 × 0027 × 2060 × 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [7.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 × 0027 × 2060 × 0308 × 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [7.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 × 0027 × 2060 × 0061 ÷ 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [7.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0061 × 0027 × 2060 × 0308 × 0061 ÷ 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [7.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 × 0308 ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 × 0308 ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 × 0308 ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 × 0308 ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 0001 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 0308 ÷ 0001 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 000D ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 0308 ÷ 000D ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 000A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 0308 ÷ 000A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 000B ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 0308 ÷ 000B ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 3031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 0308 ÷ 3031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 0041 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 0308 ÷ 0041 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 003A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 0308 ÷ 003A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 0308 ÷ 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 002E ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 0308 ÷ 002E ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 0030 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 0308 ÷ 0030 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 005F ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 0308 ÷ 005F ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 1F1E6 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 05D0 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 0308 ÷ 05D0 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 0022 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 0308 ÷ 0022 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 0027 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 0308 ÷ 0027 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 231A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 0308 ÷ 231A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 0020 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 0308 ÷ 0020 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 00AD ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 0308 × 00AD ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 0300 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 0308 × 0300 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 200D ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 0308 × 200D ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 0061 × 2060 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 0308 ÷ 0061 × 2060 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 0308 ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 0308 ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 0308 ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 0308 ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 0308 ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 0308 ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 0308 ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 0308 ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 0001 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 0308 ÷ 0001 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 000D ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 0308 ÷ 000D ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 000A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 0308 ÷ 000A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 000B ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 0308 ÷ 000B ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 3031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 0308 ÷ 3031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 0041 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 0308 ÷ 0041 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 003A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 0308 ÷ 003A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 002C ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 0308 ÷ 002C ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 002E ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 0308 ÷ 002E ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 0030 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 0308 ÷ 0030 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 005F ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 0308 ÷ 005F ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 1F1E6 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 05D0 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 0308 ÷ 05D0 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 0022 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 0308 ÷ 0022 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 0027 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 0308 ÷ 0027 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 231A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 0308 ÷ 231A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 0020 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 0308 ÷ 0020 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 00AD ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 0308 × 00AD ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 0300 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 0308 × 0300 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 200D ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 0308 × 200D ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 0061 × 2060 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 0308 ÷ 0061 × 2060 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 0308 ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 0308 ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 0308 ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 0308 ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 0308 ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 0308 ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 0308 ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 0308 ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 ÷ 0001 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 × 0308 ÷ 0001 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 ÷ 000D ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 × 0308 ÷ 000D ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 ÷ 000A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 × 0308 ÷ 000A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 ÷ 000B ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 × 0308 ÷ 000B ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 ÷ 3031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 × 0308 ÷ 3031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 ÷ 0041 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 × 0308 ÷ 0041 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 ÷ 003A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 × 0308 ÷ 003A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 ÷ 002C ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 × 0308 ÷ 002C ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 ÷ 002E ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 × 0308 ÷ 002E ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 0031 × 0027 × 0030 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [12.0] APOSTROPHE (Single_Quote) × [11.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 × 0027 × 0308 × 0030 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [12.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) × [11.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 ÷ 005F ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 × 0308 ÷ 005F ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 ÷ 1F1E6 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 ÷ 05D0 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 × 0308 ÷ 05D0 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 ÷ 0022 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 × 0308 ÷ 0022 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 ÷ 0027 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 × 0308 ÷ 0027 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 ÷ 231A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 × 0308 ÷ 231A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 ÷ 0020 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 × 0308 ÷ 0020 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 × 00AD ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 × 0308 × 00AD ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 × 0300 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 × 0308 × 0300 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 × 200D ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 × 0308 × 200D ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 ÷ 0061 × 2060 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 × 0308 ÷ 0061 × 2060 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 × 0308 ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 × 0308 ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 × 0308 ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 × 0308 ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0031 × 0027 × 0031 ÷ 003A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [12.0] APOSTROPHE (Single_Quote) × [11.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0031 × 0027 × 0308 × 0031 ÷ 003A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [12.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) × [11.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0031 × 0027 × 0031 ÷ 0027 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [12.0] APOSTROPHE (Single_Quote) × [11.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 × 0027 × 0308 × 0031 ÷ 0027 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [12.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) × [11.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 × 0027 × 0031 ÷ 002C ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [12.0] APOSTROPHE (Single_Quote) × [11.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0031 × 0027 × 0308 × 0031 ÷ 002C ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [12.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) × [11.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0031 × 0027 × 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [12.0] APOSTROPHE (Single_Quote) × [11.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 × 0027 × 0308 × 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [12.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) × [11.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C ÷ 0001 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C × 0308 ÷ 0001 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C ÷ 000D ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C × 0308 ÷ 000D ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C ÷ 000A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C × 0308 ÷ 000A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C ÷ 000B ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C × 0308 ÷ 000B ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C ÷ 3031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C × 0308 ÷ 3031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C ÷ 0041 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C × 0308 ÷ 0041 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C ÷ 003A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C × 0308 ÷ 003A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C ÷ 002C ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C × 0308 ÷ 002C ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C ÷ 002E ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C × 0308 ÷ 002E ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 0031 × 002C × 0030 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [12.0] COMMA (MidNum) × [11.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 × 002C × 0308 × 0030 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [12.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) × [11.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C ÷ 005F ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C × 0308 ÷ 005F ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C ÷ 1F1E6 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C ÷ 05D0 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C × 0308 ÷ 05D0 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C ÷ 0022 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C × 0308 ÷ 0022 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C ÷ 0027 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C × 0308 ÷ 0027 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C ÷ 231A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C × 0308 ÷ 231A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C ÷ 0020 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C × 0308 ÷ 0020 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C × 00AD ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C × 0308 × 00AD ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C × 0300 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C × 0308 × 0300 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C × 200D ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C × 0308 × 200D ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C ÷ 0061 × 2060 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C × 0308 ÷ 0061 × 2060 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C × 0308 ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C × 0308 ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C × 0308 ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C × 0308 ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0031 × 002C × 0031 ÷ 003A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [12.0] COMMA (MidNum) × [11.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0031 × 002C × 0308 × 0031 ÷ 003A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [12.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) × [11.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0031 × 002C × 0031 ÷ 0027 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [12.0] COMMA (MidNum) × [11.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 × 002C × 0308 × 0031 ÷ 0027 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [12.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) × [11.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 × 002C × 0031 ÷ 002C ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [12.0] COMMA (MidNum) × [11.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0031 × 002C × 0308 × 0031 ÷ 002C ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [12.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) × [11.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0031 × 002C × 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [12.0] COMMA (MidNum) × [11.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 × 002C × 0308 × 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [12.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) × [11.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 ÷ 0001 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 × 0308 ÷ 0001 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 ÷ 000D ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 × 0308 ÷ 000D ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 ÷ 000A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 × 0308 ÷ 000A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 ÷ 000B ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 × 0308 ÷ 000B ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 ÷ 3031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 × 0308 ÷ 3031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 ÷ 0041 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 × 0308 ÷ 0041 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 ÷ 003A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 × 0308 ÷ 003A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 ÷ 002C ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 × 0308 ÷ 002C ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 ÷ 002E ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 × 0308 ÷ 002E ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 0031 × 002E × 2060 × 0030 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [12.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [11.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 × 002E × 2060 × 0308 × 0030 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [12.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [11.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 ÷ 005F ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 × 0308 ÷ 005F ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 ÷ 1F1E6 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 ÷ 05D0 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 × 0308 ÷ 05D0 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 ÷ 0022 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 × 0308 ÷ 0022 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 ÷ 0027 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 × 0308 ÷ 0027 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 ÷ 231A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 × 0308 ÷ 231A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 ÷ 0020 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 × 0308 ÷ 0020 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 × 00AD ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 × 0308 × 00AD ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 × 0300 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 × 0308 × 0300 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 × 200D ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 × 0308 × 200D ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 ÷ 0061 × 2060 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 × 0308 ÷ 0061 × 2060 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 × 0308 ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 × 0308 ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 × 0308 ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 × 0308 ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0031 × 002E × 2060 × 0031 ÷ 003A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [12.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [11.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0031 × 002E × 2060 × 0308 × 0031 ÷ 003A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [12.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [11.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0031 × 002E × 2060 × 0031 ÷ 0027 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [12.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [11.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 × 002E × 2060 × 0308 × 0031 ÷ 0027 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [12.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [11.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 × 002E × 2060 × 0031 ÷ 002C ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [12.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [11.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0031 × 002E × 2060 × 0308 × 0031 ÷ 002C ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [12.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [11.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0031 × 002E × 2060 × 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [12.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [11.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 × 002E × 2060 × 0308 × 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [12.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [11.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 000D × 000A ÷ 0061 ÷ 000A ÷ 0308 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) × [3.0] <LINE FEED (LF)> (LF) ÷ [3.1] LATIN SMALL LETTER A (ALetter) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0061 × 0308 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0020 × 200D ÷ 0646 ÷	#  ÷ [0.2] SPACE (WSegSpace) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [999.0] ARABIC LETTER NOON (ALetter) ÷ [0.3]');
    Test_WB('÷ 0646 × 200D ÷ 0020 ÷	#  ÷ [0.2] ARABIC LETTER NOON (ALetter) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 0041 × 0041 × 0041 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [5.0] LATIN CAPITAL LETTER A (ALetter) × [5.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0041 × 003A × 0041 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [6.0] COLON (MidLetter) × [7.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0041 ÷ 003A ÷ 003A ÷ 0041 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0027 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [7.1] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0022 × 05D0 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [7.2] QUOTATION MARK (Double_Quote) × [7.3] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0041 × 0030 × 0030 × 0041 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [9.0] DIGIT ZERO (Numeric) × [8.0] DIGIT ZERO (Numeric) × [10.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0030 × 002C × 0030 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [12.0] COMMA (MidNum) × [11.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0030 ÷ 002C ÷ 002C ÷ 0030 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] COMMA (MidNum) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 3031 × 3031 ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [13.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0041 × 005F × 0030 × 005F × 3031 × 005F ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ZERO (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] VERTICAL KANA REPEAT MARK (Katakana) × [13.1] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0041 × 005F × 005F × 0041 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 1F1E7 ÷ 1F1E8 ÷ 0062 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [15.0] REGIONAL INDICATOR SYMBOL LETTER B (RI) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER C (RI) ÷ [999.0] LATIN SMALL LETTER B (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 1F1E6 × 1F1E7 ÷ 1F1E8 ÷ 0062 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [16.0] REGIONAL INDICATOR SYMBOL LETTER B (RI) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER C (RI) ÷ [999.0] LATIN SMALL LETTER B (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 1F1E6 × 1F1E7 × 200D ÷ 1F1E8 ÷ 0062 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [16.0] REGIONAL INDICATOR SYMBOL LETTER B (RI) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER C (RI) ÷ [999.0] LATIN SMALL LETTER B (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 1F1E6 × 200D × 1F1E7 ÷ 1F1E8 ÷ 0062 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) × [16.0] REGIONAL INDICATOR SYMBOL LETTER B (RI) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER C (RI) ÷ [999.0] LATIN SMALL LETTER B (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 1F1E6 × 1F1E7 ÷ 1F1E8 × 1F1E9 ÷ 0062 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [16.0] REGIONAL INDICATOR SYMBOL LETTER B (RI) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER C (RI) × [16.0] REGIONAL INDICATOR SYMBOL LETTER D (RI) ÷ [999.0] LATIN SMALL LETTER B (ALetter) ÷ [0.3]');
    Test_WB('÷ 1F476 × 1F3FF ÷ 1F476 ÷	#  ÷ [0.2] BABY (ExtPict) × [4.0] EMOJI MODIFIER FITZPATRICK TYPE-6 (Extend_FE) ÷ [999.0] BABY (ExtPict) ÷ [0.3]');
    Test_WB('÷ 1F6D1 × 200D × 1F6D1 ÷	#  ÷ [0.2] OCTAGONAL SIGN (ExtPict) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) × [3.3] OCTAGONAL SIGN (ExtPict) ÷ [0.3]');
    Test_WB('÷ 0061 × 200D × 1F6D1 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) × [3.3] OCTAGONAL SIGN (ExtPict) ÷ [0.3]');
    Test_WB('÷ 2701 × 200D × 2701 ÷	#  ÷ [0.2] UPPER BLADE SCISSORS (Other) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) × [3.3] UPPER BLADE SCISSORS (Other) ÷ [0.3]');
    Test_WB('÷ 0061 × 200D × 2701 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) × [3.3] UPPER BLADE SCISSORS (Other) ÷ [0.3]');
    Test_WB('÷ 1F476 × 1F3FF × 0308 × 200D × 1F476 × 1F3FF ÷	#  ÷ [0.2] BABY (ExtPict) × [4.0] EMOJI MODIFIER FITZPATRICK TYPE-6 (Extend_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) × [3.3] BABY (ExtPict) × [4.0] EMOJI MODIFIER FITZPATRICK TYPE-6 (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 1F6D1 × 1F3FF ÷	#  ÷ [0.2] OCTAGONAL SIGN (ExtPict) × [4.0] EMOJI MODIFIER FITZPATRICK TYPE-6 (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 200D × 1F6D1 × 1F3FF ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [3.3] OCTAGONAL SIGN (ExtPict) × [4.0] EMOJI MODIFIER FITZPATRICK TYPE-6 (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 200D × 1F6D1 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [3.3] OCTAGONAL SIGN (ExtPict) ÷ [0.3]');
    Test_WB('÷ 200D × 1F6D1 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [3.3] OCTAGONAL SIGN (ExtPict) ÷ [0.3]');
    Test_WB('÷ 1F6D1 ÷ 1F6D1 ÷	#  ÷ [0.2] OCTAGONAL SIGN (ExtPict) ÷ [999.0] OCTAGONAL SIGN (ExtPict) ÷ [0.3]');
    Test_WB('÷ 0061 × 0308 × 200D × 0308 × 0062 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [5.0] LATIN SMALL LETTER B (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0020 × 0020 ÷ 0062 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] SPACE (WSegSpace) × [3.4] SPACE (WSegSpace) ÷ [999.0] LATIN SMALL LETTER B (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 003A ÷ 0031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0031 ÷ 003A ÷ 003A ÷ 0031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0061 ÷ 003A ÷ 003A ÷ 0031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 003A ÷ 0061 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0031 ÷ 003A ÷ 003A ÷ 0061 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0061 ÷ 003A ÷ 003A ÷ 0061 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 002E ÷ 0031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0031 ÷ 003A ÷ 002E ÷ 0031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0061 ÷ 003A ÷ 002E ÷ 0031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 002E ÷ 0061 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0031 ÷ 003A ÷ 002E ÷ 0061 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0061 ÷ 003A ÷ 002E ÷ 0061 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 002C ÷ 0031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0031 ÷ 003A ÷ 002C ÷ 0031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0061 ÷ 003A ÷ 002C ÷ 0031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 002C ÷ 0061 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0031 ÷ 003A ÷ 002C ÷ 0061 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0061 ÷ 003A ÷ 002C ÷ 0061 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E ÷ 003A ÷ 0031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] COLON (MidLetter) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0031 ÷ 002E ÷ 003A ÷ 0031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] COLON (MidLetter) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0061 ÷ 002E ÷ 003A ÷ 0031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] COLON (MidLetter) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E ÷ 003A ÷ 0061 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] COLON (MidLetter) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0031 ÷ 002E ÷ 003A ÷ 0061 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] COLON (MidLetter) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0061 ÷ 002E ÷ 003A ÷ 0061 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] COLON (MidLetter) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E ÷ 002E ÷ 0031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0031 ÷ 002E ÷ 002E ÷ 0031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0061 ÷ 002E ÷ 002E ÷ 0031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E ÷ 002E ÷ 0061 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0031 ÷ 002E ÷ 002E ÷ 0061 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0061 ÷ 002E ÷ 002E ÷ 0061 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E ÷ 002C ÷ 0031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] COMMA (MidNum) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0031 ÷ 002E ÷ 002C ÷ 0031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] COMMA (MidNum) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0061 ÷ 002E ÷ 002C ÷ 0031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] COMMA (MidNum) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E ÷ 002C ÷ 0061 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0031 ÷ 002E ÷ 002C ÷ 0061 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0061 ÷ 002E ÷ 002C ÷ 0061 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C ÷ 003A ÷ 0031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] COLON (MidLetter) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0031 ÷ 002C ÷ 003A ÷ 0031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] COLON (MidLetter) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0061 ÷ 002C ÷ 003A ÷ 0031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] COLON (MidLetter) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C ÷ 003A ÷ 0061 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] COLON (MidLetter) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0031 ÷ 002C ÷ 003A ÷ 0061 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] COLON (MidLetter) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0061 ÷ 002C ÷ 003A ÷ 0061 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] COLON (MidLetter) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C ÷ 002E ÷ 0031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0031 ÷ 002C ÷ 002E ÷ 0031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0061 ÷ 002C ÷ 002E ÷ 0031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C ÷ 002E ÷ 0061 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0031 ÷ 002C ÷ 002E ÷ 0061 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0061 ÷ 002C ÷ 002E ÷ 0061 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C ÷ 002C ÷ 0031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] COMMA (MidNum) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0031 ÷ 002C ÷ 002C ÷ 0031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] COMMA (MidNum) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0061 ÷ 002C ÷ 002C ÷ 0031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] COMMA (MidNum) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C ÷ 002C ÷ 0061 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0031 ÷ 002C ÷ 002C ÷ 0061 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0061 ÷ 002C ÷ 002C ÷ 0061 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A ÷ 003A ÷ 0031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0031 ÷ 003A ÷ 003A ÷ 0031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0061 ÷ 003A ÷ 003A ÷ 0031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A ÷ 003A ÷ 0061 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0031 ÷ 003A ÷ 003A ÷ 0061 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0061 ÷ 003A ÷ 003A ÷ 0061 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A ÷ 002E ÷ 0031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0031 ÷ 003A ÷ 002E ÷ 0031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0061 ÷ 003A ÷ 002E ÷ 0031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A ÷ 002E ÷ 0061 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0031 ÷ 003A ÷ 002E ÷ 0061 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0061 ÷ 003A ÷ 002E ÷ 0061 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A ÷ 002C ÷ 0031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0031 ÷ 003A ÷ 002C ÷ 0031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0061 ÷ 003A ÷ 002C ÷ 0031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A ÷ 002C ÷ 0061 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0031 ÷ 003A ÷ 002C ÷ 0061 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0061 ÷ 003A ÷ 002C ÷ 0061 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002E ÷ 003A ÷ 0031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] COLON (MidLetter) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0031 ÷ 002E ÷ 003A ÷ 0031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] COLON (MidLetter) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0061 ÷ 002E ÷ 003A ÷ 0031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] COLON (MidLetter) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002E ÷ 003A ÷ 0061 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] COLON (MidLetter) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0031 ÷ 002E ÷ 003A ÷ 0061 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] COLON (MidLetter) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0061 ÷ 002E ÷ 003A ÷ 0061 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] COLON (MidLetter) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002E ÷ 002E ÷ 0031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0031 ÷ 002E ÷ 002E ÷ 0031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0061 ÷ 002E ÷ 002E ÷ 0031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002E ÷ 002E ÷ 0061 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0031 ÷ 002E ÷ 002E ÷ 0061 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0061 ÷ 002E ÷ 002E ÷ 0061 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002E ÷ 002C ÷ 0031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] COMMA (MidNum) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0031 ÷ 002E ÷ 002C ÷ 0031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] COMMA (MidNum) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0061 ÷ 002E ÷ 002C ÷ 0031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] COMMA (MidNum) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002E ÷ 002C ÷ 0061 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0031 ÷ 002E ÷ 002C ÷ 0061 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0061 ÷ 002E ÷ 002C ÷ 0061 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 003A ÷ 0031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] COLON (MidLetter) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0031 ÷ 002C ÷ 003A ÷ 0031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] COLON (MidLetter) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0061 ÷ 002C ÷ 003A ÷ 0031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] COLON (MidLetter) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 003A ÷ 0061 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] COLON (MidLetter) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0031 ÷ 002C ÷ 003A ÷ 0061 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] COLON (MidLetter) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0061 ÷ 002C ÷ 003A ÷ 0061 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] COLON (MidLetter) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 002E ÷ 0031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0031 ÷ 002C ÷ 002E ÷ 0031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0061 ÷ 002C ÷ 002E ÷ 0031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 002E ÷ 0061 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0031 ÷ 002C ÷ 002E ÷ 0061 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0061 ÷ 002C ÷ 002E ÷ 0061 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 002C ÷ 0031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] COMMA (MidNum) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0031 ÷ 002C ÷ 002C ÷ 0031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] COMMA (MidNum) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0061 ÷ 002C ÷ 002C ÷ 0031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] COMMA (MidNum) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 002C ÷ 0061 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0031 ÷ 002C ÷ 002C ÷ 0061 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0061 ÷ 002C ÷ 002C ÷ 0061 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
}
Finished();
